"use strict";
(self["webpackChunkcactbot"] = self["webpackChunkcactbot"] || []).push([[890],{

/***/ 408:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "Z": () => (/* binding */ raidboss_manifest)
});

// EXTERNAL MODULE: ./resources/zone_id.ts
var zone_id = __webpack_require__(588);
;// CONCATENATED MODULE: ./ui/raidboss/data/00-misc/general.ts

const caresAboutTankStuff = data => {
  return data.role === 'tank' || data.role === 'healer' || data.job === 'BLU';
};

// Triggers for all occasions and zones.
const triggerSet = {
  id: 'CactbotGeneral',
  zoneId: zone_id/* default.MatchAll */.Z.MatchAll,
  triggers: [{
    id: 'General Provoke',
    comment: {
      cn: '仅在非自身小队成员释放“挑衅”且自身为坦克/治疗/青魔法师时触发。'
    },
    type: 'Ability',
    netRegex: {
      id: '1D6D'
    },
    condition: (data, matches) => {
      if (matches.source !== data.me && !data.party.inAlliance(matches.source)) return false;
      return caresAboutTankStuff(data);
    },
    infoText: (data, matches, output) => {
      return output.text({
        player: data.party.member(matches.source)
      });
    },
    outputStrings: {
      text: {
        en: 'Provoke: ${player}',
        de: 'Herausforderung: ${player}',
        fr: 'Provocation: ${player}',
        ja: '挑発: ${player}',
        cn: '挑衅: ${player}',
        ko: '도발: ${player}'
      }
    }
  }, {
    id: 'General Frog Legs',
    comment: {
      cn: '仅在非自身小队成员释放“蛙腿”且自身为坦克/治疗/青魔法师时触发。'
    },
    type: 'Ability',
    netRegex: {
      id: '4783'
    },
    condition: (data, matches) => {
      if (matches.source !== data.me && !data.party.inAlliance(matches.source)) return false;
      return caresAboutTankStuff(data);
    },
    suppressSeconds: 0.5,
    infoText: (data, matches, output) => {
      if (matches.targetId === 'E0000000') return output.noTarget({
        player: data.party.member(matches.source)
      });
      return output.text({
        player: data.party.member(matches.source)
      });
    },
    outputStrings: {
      text: {
        en: 'Provoke: ${player}',
        de: 'Herausforderung: ${player}',
        fr: 'Provocation: ${player}',
        ja: '挑発: ${player}',
        cn: '挑衅: ${player}',
        ko: '도발: ${player}'
      },
      noTarget: {
        en: 'Provoke: ${player} (missed)',
        de: 'Herausforderung: ${player} (verfehlt)',
        fr: 'Provocation: ${player} (manquée)',
        ja: '挑発: ${player} (タゲなし)',
        cn: '挑衅: ${player} (无目标)',
        ko: '도발: ${player} (빗나감)'
      }
    }
  }, {
    id: 'General Shirk',
    comment: {
      cn: '仅在非自身小队成员释放“退避”且自身为坦克/治疗/青魔法师时触发。'
    },
    type: 'Ability',
    netRegex: {
      id: '1D71'
    },
    condition: (data, matches) => {
      if (matches.source !== data.me && !data.party.inAlliance(matches.source)) return false;
      return caresAboutTankStuff(data);
    },
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.source)
    }),
    outputStrings: {
      text: {
        en: 'Shirk: ${player}',
        de: 'Geteiltes Leid: ${player}',
        fr: 'Dérobade: ${player}',
        ja: 'シャーク: ${player}',
        cn: '退避: ${player}',
        ko: '기피: ${player}'
      }
    }
  }, {
    id: 'General Holmgang',
    comment: {
      cn: '仅在非自身小队成员释放“死斗”且自身为坦克/治疗/青魔法师时触发。'
    },
    type: 'Ability',
    netRegex: {
      id: '2B'
    },
    condition: (data, matches) => {
      if (matches.source !== data.me && !data.party.inAlliance(matches.source)) return false;
      return caresAboutTankStuff(data);
    },
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.source)
    }),
    outputStrings: {
      text: {
        en: 'Holmgang: ${player}',
        de: 'Holmgang: ${player}',
        fr: 'Holmgang: ${player}',
        ja: 'ホルムギャング: ${player}',
        cn: '死斗: ${player}',
        ko: '일대일 결투: ${player}'
      }
    }
  }, {
    id: 'General Hallowed',
    comment: {
      cn: '仅在非自身小队成员释放“神圣领域”且自身为坦克/治疗/青魔法师时触发。'
    },
    type: 'Ability',
    netRegex: {
      id: '1E'
    },
    condition: (data, matches) => {
      if (matches.source !== data.me && !data.party.inAlliance(matches.source)) return false;
      return caresAboutTankStuff(data);
    },
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.source)
    }),
    outputStrings: {
      text: {
        en: 'Hallowed: ${player}',
        de: 'Heiliger Boden: ${player}',
        fr: 'Invincible: ${player}',
        ja: 'インビンシブル: ${player}',
        cn: '神圣领域: ${player}',
        ko: '천하무적: ${player}'
      }
    }
  }, {
    id: 'General Superbolide',
    comment: {
      cn: '仅在非自身小队成员释放“超火流星”且自身为坦克/治疗/青魔法师时触发。'
    },
    type: 'Ability',
    netRegex: {
      id: '3F18'
    },
    condition: (data, matches) => {
      if (matches.source !== data.me && !data.party.inAlliance(matches.source)) return false;
      return caresAboutTankStuff(data);
    },
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.source)
    }),
    outputStrings: {
      text: {
        en: 'Bolide: ${player}',
        de: 'Meteoritenfall: ${player}',
        fr: 'Bolide: ${player}',
        ja: 'ボーライド: ${player}',
        cn: '超火流星: ${player}',
        ko: '폭발 유성: ${player}'
      }
    }
  }, {
    id: 'General Living',
    comment: {
      cn: '仅在非自身小队成员释放“行尸走肉”且自身为坦克/治疗/青魔法师时触发。'
    },
    type: 'Ability',
    netRegex: {
      id: 'E36'
    },
    condition: (data, matches) => {
      if (matches.source !== data.me && !data.party.inAlliance(matches.source)) return false;
      return caresAboutTankStuff(data);
    },
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.source)
    }),
    outputStrings: {
      text: {
        en: 'Living: ${player}',
        de: 'Totenerweckung: ${player}',
        fr: 'Mort-vivant: ${player}',
        ja: 'リビングデッド: ${player}',
        cn: '行尸走肉: ${player}',
        ko: '산송장: ${player}'
      }
    }
  }, {
    id: 'General Walking',
    comment: {
      cn: '仅在非自身小队成员获得“死而不僵”且自身为坦克/治疗/青魔法师时触发。'
    },
    type: 'GainsEffect',
    netRegex: {
      effectId: '32B'
    },
    condition: (data, matches) => {
      if (matches.source !== data.me && !data.party.inAlliance(matches.source)) return false;
      return caresAboutTankStuff(data);
    },
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.source)
    }),
    outputStrings: {
      text: {
        en: 'Walking: ${player}',
        de: 'Erweckter: ${player}',
        fr: 'Marcheur des limbes: ${player}',
        ja: 'ウォーキングデッド: ${player}',
        cn: '死而不僵: ${player}',
        ko: '움직이는 시체: ${player}'
      }
    }
  }, {
    // 0039 is the system message channel, when the current player commences a ready check,
    // the message is sent to this channel; when a ready check is invoked by others, then it
    // would be sent to the 0239 channel.  (Sometimes this is also sent to 0139, unknown why?)
    id: 'General Ready Check',
    comment: {
      cn: '在队友发起准备确认时，播放D.Va的“Game on”音效(^-^)V'
    },
    type: 'GameLog',
    netRegex: {
      line: '(?:You have commenced a ready check|\\y{Name} has initiated a ready check).*?',
      code: ['0039', '0139', '0239'],
      capture: false
    },
    sound: '../../resources/sounds/Overwatch/D.Va_-_Game_on.webm',
    soundVolume: 0.6
  }],
  timelineReplace: [{
    locale: 'de',
    replaceSync: {
      'has initiated a ready check': 'eine Bereitschaftsanfrage gestellt',
      'You have commenced a ready check': 'Du hast eine Bereitschaftsanfrage gestellt',
      'You poke the striking dummy': 'Du stupst die Trainingspuppe an',
      'You psych yourself up alongside the striking dummy': 'Du willst wahren Kampfgeist in der Trainingspuppe entfachen',
      'You burst out laughing at the striking dummy': 'Du lachst herzlich mit der Trainingspuppe',
      'You clap for the striking dummy': 'Du klatschst begeistert Beifall für die Trainingspuppe'
    }
  }, {
    locale: 'fr',
    replaceSync: {
      ' has initiated a ready check': '',
      'You have commenced a ready check\\|': 'Un appel de préparation a été lancé par ',
      'You poke the striking dummy': 'Vous touchez légèrement le mannequin d\'entraînement du doigt',
      'You psych yourself up alongside the striking dummy': 'Vous vous motivez devant le mannequin d\'entraînement',
      'You burst out laughing at the striking dummy': 'Vous vous esclaffez devant le mannequin d\'entraînement',
      'You clap for the striking dummy': 'Vous applaudissez le mannequin d\'entraînement'
    }
  }, {
    locale: 'ja',
    replaceSync: {
      ' has initiated a ready check': 'がレディチェックを開始しました',
      'You have commenced a ready check': 'レディチェックを開始しました',
      'You poke the striking dummy': '.*は木人をつついた',
      'You psych yourself up alongside the striking dummy': '.*は木人に活を入れた',
      'You burst out laughing at the striking dummy': '.*は木人のことを大笑いした',
      'You clap for the striking dummy': '.*は木人に拍手した'
    }
  }, {
    locale: 'cn',
    replaceSync: {
      ' has initiated a ready check': '发起了准备确认',
      'You have commenced a ready check': '发起了准备确认',
      'You poke the striking dummy': '.*用手指戳向木',
      'You psych yourself up alongside the striking dummy': '.*激励木人',
      'You burst out laughing at the striking dummy': '.*看着木人高声大笑',
      'You clap for the striking dummy': '.*向木人送上掌声'
    }
  }, {
    locale: 'ko',
    replaceSync: {
      'has initiated a ready check': '님이 준비 확인을 시작했습니다',
      'You have commenced a ready check': '준비 확인을 시작합니다',
      'You poke the striking dummy': '.*나무인형을 쿡쿡 찌릅니다',
      'You psych yourself up alongside the striking dummy': '.*나무인형에게 힘을 불어넣습니다',
      'You burst out laughing at the striking dummy': '.*나무인형을 보고 폭소를 터뜨립니다',
      'You clap for the striking dummy': '.*나무인형에게 박수를 보냅니다'
    }
  }]
};
/* harmony default export */ const general = (triggerSet);
// EXTERNAL MODULE: ./resources/outputs.ts
var outputs = __webpack_require__(81);
// EXTERNAL MODULE: ./resources/util.ts
var util = __webpack_require__(509);
;// CONCATENATED MODULE: ./ui/raidboss/data/00-misc/test.ts



const strikingDummyNames = {
  en: 'Striking Dummy',
  de: 'Trainingspuppe',
  fr: 'Mannequin d\'entraînement',
  ja: '木人',
  cn: '木人',
  ko: '나무인형'
};
const test_triggerSet = {
  id: 'CactbotTest',
  zoneId: zone_id/* default.MiddleLaNoscea */.Z.MiddleLaNoscea,
  config: [{
    id: 'testTriggerOutput',
    name: {
      en: 'Output for "/echo cactbot test config"',
      de: 'Ausgabe für "/echo cactbot test config"',
      fr: 'Sortie pour "/echo cactbot test config"',
      ja: '"/echo cactbot test config"のアウトプット',
      cn: '输出 "/echo cactbot测试配置"',
      ko: '"/echo cactbot 설정 테스트" 출력값'
    },
    type: 'string',
    default: () => {
      // Test default function.
      return 'Unset Option';
    }
  }],
  timelineFile: 'test.txt',
  // timeline here is additions to the timeline.  They can
  // be strings, or arrays of strings, or functions that
  // take the same data object (including role and lang)
  // that triggers do.
  timeline: ['alerttext "Final Sting" before 4 "oh no final sting in 4"', 'alarmtext "Death" before 3', 'alertall "Long Castbar" before 1 speak "voice" "long"', data => {
    if (data.role !== 'tank' && data.role !== 'healer') return 'hideall "Super Tankbuster"';
    return 'alarmtext "Super Tankbuster" before 2';
  }, data => {
    if (data.role !== 'dps') return 'hideall "Pentacle Sac (DPS)"';
  }, data => {
    if (data.role !== 'healer') return 'hideall "Almagest"';
    return 'alarmtext "Almagest" before 0';
  }, data => {
    return [`40 "Death To ${data.me}!!"`, 'hideall "Death"'];
  }],
  initData: () => {
    return {
      delayedDummyTimestampBefore: 0,
      delayedDummyTimestampAfter: 0,
      pokes: 0,
      watchingForCast: false
    };
  },
  timelineStyles: [{
    regex: /^Death To/,
    style: {
      'color': 'red',
      'font-family': 'Impact'
    }
  }],
  timelineTriggers: [{
    id: 'Test Angry Dummy',
    regex: /Angry Dummy/,
    beforeSeconds: 2,
    infoText: (_data, _matches, output) => output.stack(),
    tts: (_data, _matches, output) => output.stackTTS(),
    outputStrings: {
      stack: {
        en: 'Stack for Angry Dummy',
        de: 'Sammeln für Wütender Dummy',
        fr: 'Packez-vous pour le Mannequin en colère',
        ja: '怒る木人に集合',
        cn: '木人处集合',
        ko: '화난 나무인형에 집합'
      },
      stackTTS: {
        en: 'Stack',
        de: 'Sammeln',
        fr: 'Packez-vous',
        ja: '集合',
        cn: '集合',
        ko: '집합'
      }
    }
  }, {
    id: 'Test Delayed Dummy',
    regex: /Angry Dummy/,
    beforeSeconds: 0,
    // Add in a huge delay to make it obvious the delay runs before promise.
    delaySeconds: 10,
    promise: data => {
      data.delayedDummyTimestampBefore = Date.now();
      return new Promise(res => {
        window.setTimeout(() => {
          data.delayedDummyTimestampAfter = Date.now();
          res();
        }, 3000);
      });
    },
    infoText: (data, _matches, output) => {
      const elapsed = data.delayedDummyTimestampAfter - data.delayedDummyTimestampBefore;
      return output.elapsed({
        elapsed: elapsed
      });
    },
    outputStrings: {
      elapsed: {
        en: 'Elapsed ms: ${elapsed}',
        de: 'Abgelaufene ms: ${elapsed}',
        fr: 'Expiré ms: ${elapsed}',
        ja: '経過時間：${elapsed}',
        cn: '经过时间：${elapsed}',
        ko: '경과 시간: ${elapsed}'
      }
    }
  }],
  triggers: [{
    id: 'Test Poke',
    type: 'GameLog',
    netRegex: {
      line: 'You poke the striking dummy.*?',
      capture: false
    },
    preRun: data => ++data.pokes,
    infoText: (data, _matches, output) => output.poke({
      numPokes: data.pokes
    }),
    outputStrings: {
      poke: {
        en: 'poke #${numPokes}',
        de: 'stups #${numPokes}',
        fr: 'poussée #${numPokes}',
        ja: 'つつく #${numPokes}',
        cn: '戳 #${numPokes}',
        ko: '${numPokes}번 찌름'
      }
    }
  }, {
    id: 'Test Psych',
    type: 'GameLog',
    netRegex: {
      line: 'You psych yourself up alongside the striking dummy.*?',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    tts: {
      en: 'psych',
      de: 'auf gehts',
      fr: 'motivation',
      ja: '活を入れる',
      cn: '激励',
      ko: '힘내라!'
    },
    outputStrings: {
      text: {
        en: 'PSYCH!!!',
        de: 'AUF GEHTS!!!',
        fr: 'MOTIVATION !!!',
        ja: '活を入れる！！',
        cn: '激励！！',
        ko: '힘내라!!'
      }
    }
  }, {
    id: 'Test Laugh',
    type: 'GameLog',
    netRegex: {
      line: 'You burst out laughing at the striking dummy.*?',
      capture: false
    },
    suppressSeconds: 5,
    alarmText: (_data, _matches, output) => output.text(),
    tts: {
      en: 'hahahahaha',
      de: 'hahahahaha',
      fr: 'hahahahaha',
      ja: 'ハハハハハ',
      cn: '哈哈哈哈哈哈',
      ko: '푸하하하하핳'
    },
    outputStrings: {
      text: {
        en: 'hahahahaha',
        de: 'hahahahaha',
        fr: 'hahahahaha',
        ja: 'ハハハハハ',
        cn: '2333333333',
        ko: '푸하하하하핳'
      }
    }
  }, {
    id: 'Test Clap',
    type: 'GameLog',
    netRegex: {
      line: 'You clap for the striking dummy.*?',
      capture: false
    },
    sound: '../../resources/sounds/freesound/power_up.webm',
    soundVolume: 0.3,
    tts: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'clapity clap',
        de: 'klatschen',
        fr: 'applaudissement',
        ja: '拍手',
        cn: '鼓掌',
        ko: '박수 짝짝짝'
      }
    }
  }, {
    id: 'Test Lang',
    type: 'GameLog',
    // In game: /echo cactbot lang
    netRegex: {
      line: 'cactbot lang.*?',
      code: util/* default.gameLogCodes.echo */.Z.gameLogCodes.echo,
      capture: false
    },
    infoText: (data, _matches, output) => output.text({
      lang: data.parserLang
    }),
    outputStrings: {
      text: {
        en: 'Language: ${lang}',
        de: 'Sprache: ${lang}',
        fr: 'Langage: ${lang}',
        ja: '言語：${lang}',
        cn: '语言: ${lang}',
        ko: '언어: ${lang}'
      }
    }
  }, {
    id: 'Test Response',
    type: 'GameLog',
    netRegex: {
      line: 'cactbot test response.*?',
      code: util/* default.gameLogCodes.echo */.Z.gameLogCodes.echo,
      capture: false
    },
    response: (_data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        alarmOne: outputs/* default.num1 */.Z.num1,
        alertTwo: outputs/* default.num2 */.Z.num2,
        infoThree: outputs/* default.num3 */.Z.num3,
        ttsFour: outputs/* default.num4 */.Z.num4
      };
      return {
        alarmText: output.alarmOne(),
        alertText: output.alertTwo(),
        infoText: output.infoThree(),
        tts: output.ttsFour()
      };
    }
  }, {
    id: 'Test Watch',
    type: 'GameLog',
    netRegex: {
      line: 'cactbot test watch.*?',
      code: util/* default.gameLogCodes.echo */.Z.gameLogCodes.echo,
      capture: false
    },
    promise: data => util/* default.watchCombatant */.Z.watchCombatant({
      names: [data.me, strikingDummyNames[data.lang] ?? strikingDummyNames['en']],
      // 50 seconds
      maxDuration: 50000
    }, ret => {
      const me = ret.combatants.find(c => c.Name === data.me);
      const dummyName = strikingDummyNames[data.lang] ?? strikingDummyNames['en'];
      const dummies = ret.combatants.filter(c => c.Name === dummyName);
      console.log(`test watch: me = ${me?.Name ?? 'undefined'}; ${dummies.length} dummies`);
      if (me) {
        for (const dummy of dummies) {
          const distX = Math.abs(me.PosX - dummy.PosX);
          const distY = Math.abs(me.PosY - dummy.PosY);
          const dist = Math.hypot(distX, distY);
          console.log(`test watch: distX = ${distX}; distY = ${distY}; dist = ${dist}`);
          if (dist < 5) return true;
        }
        return false;
      }
      return false;
    }),
    infoText: (_data, _matches, output) => output.close(),
    outputStrings: {
      close: {
        en: 'Dummy close!',
        de: 'Puppe beendet!',
        fr: 'Mannequin proche !',
        ja: '木人に近すぎ！',
        cn: '靠近木人！',
        ko: '나무인형과 가까움!'
      }
    }
  }, {
    id: 'Test Config',
    type: 'GameLog',
    netRegex: {
      line: 'cactbot test config.*?',
      code: util/* default.gameLogCodes.echo */.Z.gameLogCodes.echo,
      capture: false
    },
    alertText: (data, _matches, output) => {
      return output.text({
        value: data.triggerSetConfig.testTriggerOutput.toString()
      });
    },
    outputStrings: {
      text: {
        en: 'Config Value: ${value}',
        de: 'Einstellungswert: ${value}',
        fr: 'Valeur de configuration : ${value}',
        ja: '設定: ${value}',
        cn: '配置值: ${value}',
        ko: '설정값: ${value}'
      }
    }
  }, {
    id: 'Test Combatant Cast Enable',
    type: 'GameLog',
    netRegex: {
      line: 'cactbot test combatant cast.*?',
      code: util/* default.gameLogCodes.echo */.Z.gameLogCodes.echo,
      capture: false
    },
    run: data => {
      data.watchingForCast = true;
    }
  }, {
    id: 'Test Combatant Cast',
    type: 'CombatantMemory',
    netRegex: {
      pair: [{
        key: 'IsCasting1',
        value: '1'
      }, {
        key: 'CastBuffID',
        value: '.*?'
      }]
    },
    condition: data => data.watchingForCast,
    infoText: (data, matches, output) => {
      data.watchingForCast = false;
      return output.casting({
        id: matches.id,
        spellId: matches.pairCastBuffID
      });
    },
    outputStrings: {
      casting: {
        en: 'ID ${id} is casting spell ID ${spellId}',
        de: 'ID ${id} wirkt Zauber ID ${spellId}',
        fr: 'ID ${id} incante le sort ID ${spellId}',
        ja: 'ID ${id} スペルID ${spellId}を詠唱中',
        cn: 'ID ${id} 正在施法 ID ${spellId}',
        ko: 'ID ${id}: 스킬 ID ${spellId}를 시전하는 중'
      }
    }
  }, {
    id: 'Test Countdown',
    type: 'Countdown',
    netRegex: {
      result: '00'
    },
    infoText: (_data, matches, output) => output.countdown({
      player: matches.name,
      seconds: matches.countdownTime
    }),
    outputStrings: {
      countdown: {
        en: '${player} started ${seconds}s countdown',
        fr: '${player} a démarré un compte à rebours de ${seconds}s',
        ko: '${player} ${seconds}초 초읽기를 시작했습니다'
      }
    }
  }, {
    id: 'Test Countdown Failed',
    type: 'Countdown',
    netRegex: {
      result: '(?!00).{2}'
    },
    infoText: (_data, matches, output) => output.countdownFail({
      player: matches.name,
      code: matches.result
    }),
    outputStrings: {
      countdownFail: {
        en: '${player} failed to start countdown (result code: ${code})',
        fr: '${player} a échoué à démarrer un compte à rebours (result code: ${code})',
        ko: '${player} 초읽기를 시작하지 못했습니다 (반환 코드: ${code})'
      }
    }
  }, {
    id: 'Test Countdown Cancel',
    type: 'CountdownCancel',
    netRegex: {},
    infoText: (_data, matches, output) => output.countdownCancel({
      player: matches.name
    }),
    outputStrings: {
      countdownCancel: {
        en: '${player} cancelled countdown',
        fr: '${player} a annulé le compte à rebours',
        ko: '${player} 초읽기를 취소했습니다'
      }
    }
  }, {
    id: 'Test OutputStrings',
    type: 'GameLog',
    netRegex: {
      line: 'cactbot test outputStrings',
      code: util/* default.gameLogCodes.echo */.Z.gameLogCodes.echo,
      capture: false
    },
    infoText: (data, _matches, output) => {
      // TODO: This doesn't work unless you're in a party, because party tracker is empty.
      // OverlayPlugin should probably always return the current player as being in the party
      // regardless of the rest of the party composition.
      return output.text({
        player: data.party.member(data.me)
      });
    },
    outputStrings: {
      text: {
        en: 'player = ${player}, player.job = ${player.job}, player.bogus = ${player.bogus}',
        de: 'player = ${player}, player.job = ${player.job}, player.bogus = ${player.bogus}',
        fr: 'player = ${player}, player.job = ${player.job}, player.bogus = ${player.bogus}',
        ja: 'player = ${player}, player.job = ${player.job}, player.bogus = ${player.bogus}',
        cn: 'player = ${player}, player.job = ${player.job}, player.bogus = ${player.bogus}',
        ko: 'player = ${player}, player.job = ${player.job}, player.bogus = ${player.bogus}'
      }
    }
  }],
  timelineReplace: [{
    locale: 'de',
    replaceSync: {
      'You bid farewell to the striking dummy': 'Du winkst der Trainingspuppe zum Abschied zu',
      'You bow courteously to the striking dummy': 'Du verbeugst dich hochachtungsvoll vor der Trainingspuppe',
      'test sync': 'test sync',
      'You burst out laughing at the striking dummy': 'Du lachst herzlich mit der Trainingspuppe',
      'cactbot lang': 'cactbot sprache',
      'cactbot test response': 'cactbot test antwort',
      'cactbot test watch': 'cactbot test beobachten',
      'cactbot test config': 'cactbot test konfig',
      'cactbot test outputStrings': 'cactbot test outputStrings',
      'cactbot test combatant cast': 'cactbot test gegner wirken',
      'testNetRegexTimeline': 'testNetRegexTimeline',
      'You clap for the striking dummy': 'Du klatschst begeistert Beifall für die Trainingspuppe',
      'You psych yourself up alongside the striking dummy': 'Du willst wahren Kampfgeist in der Trainingspuppe entfachen',
      'You poke the striking dummy': 'Du stupst die Trainingspuppe an'
    },
    replaceText: {
      'Final Sting': 'Schlussstich',
      'Almagest': 'Almagest',
      'Angry Dummy': 'Wütender Dummy',
      'Long Castbar': 'Langer Zauberbalken',
      'Dummy Stands Still': 'Dummy still stehen',
      'Death': 'Tot',
      'Super Tankbuster': 'Super Tankbuster',
      'Pentacle Sac': 'Pentacle Sac',
      'Engage': 'Start!',
      'Two': 'Zwei',
      '(?<! )Three': 'Drei',
      'Four': 'Vier',
      'Six': 'Sechs',
      'Ten(?!d)': 'Zehn',
      'Fifteen': 'Fünfzehn',
      'Force Jump Three': 'Gewaltsam auf Drei Springen',
      'Invisible': 'Unsichtbar'
    }
  }, {
    locale: 'fr',
    replaceSync: {
      'cactbot lang': 'cactbot langue',
      'cactbot test response': 'cactbot test de réponse',
      'cactbot test watch': 'cactbot test d\'observation',
      'cactbot test config': 'test de configuration de cactbot',
      'cactbot test combatant cast': 'test d\'incantation d\'un combatant',
      'cactbot test outputStrings': 'cactbot test outputStrings',
      'testNetRegexTimeline': 'testNetRegexTimeline',
      'You bid farewell to the striking dummy': 'Vous faites vos adieux au mannequin d\'entraînement',
      'You bow courteously to the striking dummy': 'Vous vous inclinez devant le mannequin d\'entraînement',
      'You burst out laughing at the striking dummy': 'Vous vous esclaffez devant le mannequin d\'entraînement',
      'You clap for the striking dummy': 'Vous applaudissez le mannequin d\'entraînement',
      'You poke the striking dummy': 'Vous touchez légèrement le mannequin d\'entraînement du doigt',
      'You psych yourself up alongside the striking dummy': 'Vous vous motivez devant le mannequin d\'entraînement',
      'test sync': 'test sync'
    },
    replaceText: {
      'Almagest': 'Almageste',
      'Angry Dummy': 'Mannequin en colère',
      'Death': 'Mort',
      'Death To': 'Mort sur',
      'Dummy Stands Still': 'Mannequin immobile',
      'Engage': 'À l\'attaque',
      'Final Sting': 'Dard final',
      'Long Castbar': 'Longue barre de lancement',
      'Pentacle Sac': 'Pentacle Sac',
      'Super Tankbuster': 'Super Tank buster',
      'Two': 'Deux',
      '(?<! )Three': 'Trois',
      'Four': 'Quatre',
      'Six': 'Six',
      'Ten': 'Dix',
      'Fifteen': 'Quinze',
      'Force Jump Three': 'Saut forcé à trois',
      'Invisible': 'Invisible'
    }
  }, {
    locale: 'ja',
    missingTranslations: true,
    replaceSync: {
      'You bid farewell to the striking dummy': '.*は木人に別れの挨拶をした',
      'You bow courteously to the striking dummy': '.*は木人にお辞儀した',
      'test sync': 'test sync',
      'You burst out laughing at the striking dummy': '.*は木人のことを大笑いした',
      'cactbot lang': 'cactbot言語',
      'cactbot test response': 'cactbotレスポンステスト',
      'cactbot test watch': 'cactbot探知テスト',
      'cactbot test config': 'cactbot設定テスト',
      'cactbot test combatant cast': 'cactbotターゲットキャストテスト',
      'cactbot test outputStrings': 'cactbot outputStrings テスト',
      'You clap for the striking dummy': '.*は木人に拍手した',
      'You psych yourself up alongside the striking dummy': '.*は木人に活を入れた',
      'You poke the striking dummy': '.*は木人をつついた'
    },
    replaceText: {
      'Almagest': 'アルマゲスト',
      'Angry Dummy': '怒る木人',
      'Death': '死',
      'Death To': '死の宣告',
      'Dummy Stands Still': '木人はじっとしている',
      'Engage': '戦闘開始',
      'Final Sting': 'ファイナルスピア',
      'Long Castbar': '長い長い詠唱バー',
      'Pentacle Sac': 'ナイサイ',
      'Super Tankbuster': 'スーパータンクバスター',
      'Two': '二',
      '(?<! )Three': '三',
      'Four': '四',
      'Six': '六',
      'Ten': '十',
      'Fifteen': '十五',
      'Force Jump Three': '三に強制ジャンプ',
      'Invisible': '見えないはず'
    }
  }, {
    locale: 'cn',
    replaceSync: {
      'You bid farewell to the striking dummy': '.*向木人告别',
      'You bow courteously to the striking dummy': '.*恭敬地对木人行礼',
      'test sync': 'test sync',
      'testNetRegexTimeline': 'testNetRegexTimeline',
      'You burst out laughing at the striking dummy': '.*看着木人高声大笑',
      'cactbot lang': 'cactbot语言',
      'cactbot test combatant cast': 'cactbot测试战斗员施法',
      'cactbot test config': 'cactbot测试配置',
      'cactbot test outputStrings': 'cactbot测试输出字符串',
      'cactbot test response': 'cactbot响应测试',
      'cactbot test watch': 'cactbot探测测试',
      'You clap for the striking dummy': '.*向木人送上掌声',
      'You psych yourself up alongside the striking dummy': '.*激励木人',
      'You poke the striking dummy': '.*用手指戳向木人'
    },
    replaceText: {
      'Final Sting': '终极针',
      'Almagest': '至高无上',
      'Angry Dummy': '愤怒的木人',
      'Long Castbar': '长时间咏唱',
      'Dummy Stands Still': '木人8动了',
      'Super Tankbuster': '超级无敌转圈死刑',
      'Death To': '嗝屁攻击：',
      'Death': '嗝屁',
      'Engage': '战斗开始',
      'Pentacle Sac': '传毒',
      'Two': '贰',
      '(?<! )Three': '叁',
      'Four': '肆',
      'Six': '陆',
      'Ten': '拾',
      'Fifteen': '拾伍',
      'Force Jump Three': '强制跳转叁',
      'Invisible': '不可见'
    }
  }, {
    locale: 'ko',
    replaceSync: {
      'You bid farewell to the striking dummy': '.*나무인형에게 작별 인사를 합니다',
      'You bow courteously to the striking dummy': '.*나무인형에게 공손하게 인사합니다',
      'test sync': '테스트 싱크',
      'testNetRegexTimeline': 'testNetRegexTimeline',
      'You burst out laughing at the striking dummy': '.*나무인형을 보고 폭소를 터뜨립니다',
      'cactbot test config': 'cactbot 설정 테스트',
      'cactbot lang': 'cactbot 언어',
      'cactbot test response': 'cactbot 응답 테스트',
      'cactbot test watch': 'cactbot 탐지 테스트',
      'cactbot test combatant cast': 'cactbot 스킬 시전 테스트',
      'cactbot test outputStrings': 'cactbot outputStrings 테스트',
      'You clap for the striking dummy': '.*나무인형에게 박수를 보냅니다',
      'You psych yourself up alongside the striking dummy': '.*나무인형에게 힘을 불어넣습니다',
      'You poke the striking dummy': '.*나무인형을 쿡쿡 찌릅니다'
    },
    replaceText: {
      'Final Sting': '마지막 벌침',
      'Almagest': '알마게스트',
      'Angry Dummy': '화난 나무인형',
      'Long Castbar': '긴 시전바',
      'Dummy Stands Still': '나무인형이 아직 살아있다',
      'Death': '데스',
      'Super Tankbuster': '초강력 탱크버스터',
      'Pentacle Sac': 'Pentacle Sac',
      'Engage': '시작',
      'Two': '2',
      '(?<! )Three': '3',
      'Four': '4',
      'Six': '6',
      'Ten': '10',
      'Fifteen': '15',
      'Force Jump Three': '3으로 돌아가기',
      'Invisible': '타임라인 숨기기'
    }
  }]
};
/* harmony default export */ const test = (test_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/00-misc/test.txt
const _00_misc_test_namespaceObject = "# I am but a wee little test timeline\r\n#\r\n# Teleport your way to Summerford Farms, ancestral home of striking dummies.\r\n#\r\n# Make sure emotes show up in your log, such that /bow generates a line such\r\n# as \"You bow courteously to the striking dummy.\" Once that is turned on,\r\n# /bow to the striking dummy to start the timeline.\r\n#\r\n# Alternatively, do a countdown, such as \"/countdown 5\" which will also\r\n# start it.\r\n#\r\n# /poke, /pysch, or /laugh at the striking dummy for trigger examples.\r\n#\r\n# /goodbye to the striking dummy to stop the timeline.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0 \"--Reset--\" GameLog { code: \"001D\", line: \"You bid farewell to the striking dummy.*?\" } window 0,10000 jump 0\r\n\r\n# two examples with different quoting which should both be supported\r\n0 \"--sync--\" GameLog { line: 'testNetRegexTimeline' } window 100000,100000\r\n0 \"--sync--\" GameLog { \"line\": \"testNetRegexTimeline\" } window 100000,100000\r\n\r\n0 \"--sync--\" GameLog { code: \"0039\", line: \"Engage!.*?\" } window 100000,100000\r\n0 \"--sync--\" GameLog { code: \"001D\", line: \"You bow courteously to the striking dummy.*?\" } window 0,1\r\n3 \"Almagest\"\r\n6 \"Angry Dummy\"\r\n10 \"Long Castbar\" duration 10\r\n15 \"Final Sting\"\r\n18 \"Pentacle Sac (DPS)\"\r\n25 \"Super Tankbuster\" GameLog { code: \"0038\", line: \"test sync1.*?\" } window 30,30\r\n30 \"Dummy Stands Still\"\r\n40 \"Death\"\r\n\r\n50 \"--sync--\" GameLog { code: \"0038\", line: \"test sync2.*?\" } window 100,1 forcejump \"loop\"\r\n\r\n# Loop test!\r\n100 label \"loop\"\r\n102 \"Two\"\r\n103 label \"three\"\r\n103 \"Three\"\r\n104 \"Four\"\r\n106 \"Six\"\r\n110 \"Ten\" #duration 100\r\n115 \"Fifteen\"\r\n118 \"Force Jump Three\" GameLog { code: \"0038\", line: \"test sync3.*?\" } window 10,10 forcejump \"three\"\r\n120 \"Invisible\" GameLog { code: \"0038\", line: \"test sync4.*?\" } forcejump 1000\r\n";
// EXTERNAL MODULE: ./resources/conditions.ts
var conditions = __webpack_require__(446);
// EXTERNAL MODULE: ./resources/responses.ts
var responses = __webpack_require__(469);
;// CONCATENATED MODULE: ./ui/raidboss/data/00-misc/the_masked_carnivale.ts





// all Masked Carnivale Stages/Acts take place in the same zone
// there are unique Instance Content IDs for each Masked Carnivale Stage
// TODO: improve S11 A1-2 Fulmination trigger
// TODO: verify if S29 A1 Pillar of Flame 1 is always out-then-in, or can it be in-then-out
// TODO: verify if S30 A1 Rubber Bullet safe-spot is always the same
const the_masked_carnivale_triggerSet = {
  id: 'TheMaskedCarnivale',
  zoneId: zone_id/* default.TheMaskedCarnivale */.Z.TheMaskedCarnivale,
  zoneLabel: {
    en: 'The Masked Carnivale',
    de: 'Die Große Maskerade',
    fr: 'Le carnaval masqué',
    cn: '假面狂欢',
    ko: '가면 무투회'
  },
  triggers: [
  // ================ Stage 01 Act 1 ================
  // intentionally blank
  // ================ Stage 02 Act 1 ================
  // intentionally blank
  // ---------------- Stage 02 Act 2 ----------------
  // intentionally blank
  // ================ Stage 03 Act 1 ================
  {
    id: 'Carnivale S03 A1 Zipacna Obliterate',
    type: 'StartsUsing',
    netRegex: {
      id: '381D',
      source: 'Zipacna'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  },
  // ================ Stage 04 Act 1 ================
  // intentionally blank
  // ---------------- Stage 04 Act 2 ----------------
  {
    id: 'Carnivale S04 A2 Kreios Magitek Field',
    type: 'StartsUsing',
    netRegex: {
      id: '3821',
      source: 'Kreios'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  },
  // ================ Stage 05 Act 1 ================
  // intentionally blank
  // ================ Stage 06 Act 1 ================
  {
    id: 'Carnivale S06 A1-2 Blind Gain',
    // 23B = Blind (can't be hit by gaze attacks)
    type: 'GainsEffect',
    netRegex: {
      effectId: '23B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: data => data.blind = true
  }, {
    id: 'Carnivale S06 A1-2 Blind Lose',
    // 23B = Blind (can't be hit by gaze attacks)
    type: 'LosesEffect',
    netRegex: {
      effectId: '23B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => delete data.blind
  }, {
    id: 'Carnivale S06 A1-2 Arena Catoblepas Demon Eye',
    // if Blind then can't be hit by gaze attacks
    type: 'StartsUsing',
    netRegex: {
      id: '3963',
      source: 'Arena Catoblepas',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      if (!data.blind) return output.lookAway();
    },
    outputStrings: {
      lookAway: outputs/* default.lookAway */.Z.lookAway
    }
  },
  // ---------------- Stage 06 Act 2 ----------------
  {
    id: 'Carnivale S06 A2 Arena Eye Dread Gaze',
    // if Blind then can't be hit by gaze attacks
    type: 'StartsUsing',
    netRegex: {
      id: '3966',
      source: 'Arena Eye',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      if (!data.blind) return output.lookAway();
    },
    outputStrings: {
      lookAway: outputs/* default.lookAway */.Z.lookAway
    }
  },
  // ================ Stage 07 Act 1 ================
  // intentionally blank
  // ---------------- Stage 07 Act 2 ----------------
  // intentionally blank
  // ---------------- Stage 07 Act 3 ----------------
  {
    id: 'Carnivale S07 A3 Gladiatorial Node Low Voltage',
    type: 'StartsUsing',
    netRegex: {
      id: '3976',
      source: 'Gladiatorial Node'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 3,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Barricade',
        de: 'Hinter den Barrikaden verstecken',
        fr: 'Cachez-vous derrière la barricade',
        ja: '柵の後ろに',
        cn: '躲在栅栏后',
        ko: '울타리 뒤에 숨기'
      }
    }
  },
  // ================ Stage 08 Act 1 ================
  // intentionally blank
  // ---------------- Stage 08 Act 2 ----------------
  {
    id: 'Carnivale S08 A2 Arena Progenitrix Burst',
    type: 'StartsUsing',
    netRegex: {
      id: '3958',
      source: 'Arena Progenitrix'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  },
  // ================ Stage 09 Act 1 ================
  {
    id: 'Carnivale S09 A1 Guimauve Golden Tongue',
    type: 'StartsUsing',
    netRegex: {
      id: '37B9',
      source: 'Guimauve'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  },
  // ================ Stage 10 Act 1 ================
  {
    id: 'Carnivale S10 A1 Crom Dubh King\'s Will',
    // if attempting The Harder They Fall achievement, do not interrupt this cast
    type: 'StartsUsing',
    netRegex: {
      id: '397F',
      source: 'Crom Dubh'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Carnivale S10 A1 Crom Dubh Black Nebula',
    type: 'StartsUsing',
    netRegex: {
      id: '3984',
      source: 'Crom Dubh'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  },
  // ================ Stage 11 Act 1 ================
  {
    id: 'Carnivale S11 A1-2 Arena Gas Bomb Fulmination',
    // Arena Gas Bombs (x2 Act 1, x4 Act 2) channel a long cast (22.7s) which is lethal if completed
    // this cast can be interrupted (immediate re-cast) by doing any damage to them; warn when this cast is about to finish
    // TODO: this trigger is janky; trigger can overlap from multiple targets in unintended ways,
    //   and trigger still fires if target dies
    type: 'StartsUsing',
    netRegex: {
      id: '38F7',
      source: 'Arena Gas Bomb'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    suppressSeconds: 5,
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  },
  // ---------------- Stage 11 Act 2 ----------------
  // intentionally blank
  // ================ Stage 12 Act 1 ================
  // intentionally blank
  // ---------------- Stage 12 Act 2 ----------------
  {
    id: 'Carnivale S12 A2 Hydnora Inflammable Fumes',
    type: 'StartsUsing',
    netRegex: {
      id: '39A1',
      source: 'Hydnora'
    },
    response: responses/* Responses.stun */.n3.stun()
  }, {
    id: 'Carnivale S12 A2 Hydnora Spore Sac',
    // spawns several Arena Roselets which can be killed individually
    // or can use Ice Spikes to reflect their attacks and kill them all at once
    type: 'StartsUsing',
    netRegex: {
      id: '39A0',
      source: 'Hydnora',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Arena Roselets spawning!',
        de: 'Arena-Röslinge erscheinen!',
        fr: 'Roses d\'arène vient d\'apparaitre !',
        cn: '正在生成 斗场小红花!',
        ko: '넝쿨장미 소환됨!'
      }
    }
  },
  // ================ Stage 13 Act 1 ================
  // intentionally blank
  // ---------------- Stage 13 Act 2 ----------------
  {
    id: 'Carnivale S13 A2 Carmilla Dark Sabbath',
    type: 'StartsUsing',
    netRegex: {
      id: '3A67',
      source: 'Carmilla',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Carnivale S13 A2 Carmilla Summon Darkness',
    // add needs to be killed before Carmilla consumes it
    // if not killed in time, Carmilla gains a Damage Up buff and kills the player
    type: 'AddedCombatant',
    netRegex: {
      name: 'Arena Succubus'
    },
    infoText: (_data, matches, output) => output.kill({
      name: matches.name
    }),
    outputStrings: {
      kill: {
        en: 'Kill ${name}',
        de: 'Besiege ${name}',
        fr: 'Tuez ${name}',
        ja: '${name}を倒す',
        cn: '击杀 ${name}',
        ko: '${name} 처치'
      }
    }
  }, {
    id: 'Carnivale S13 A2 Arena Succubus Beguiling Mist',
    type: 'StartsUsing',
    netRegex: {
      id: '3AC5',
      source: 'Arena Succubus'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  },
  // ================ Stage 14 Act 1 ================
  {
    id: 'Carnivale S14 A1-2 Arena Jam The Last Song',
    type: 'StartsUsing',
    netRegex: {
      id: '39A4',
      source: 'Arena Jam'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 3,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Barricade',
        de: 'Hinter den Barrikaden verstecken',
        fr: 'Cachez-vous derrière la barricade',
        ja: '柵の後ろに',
        cn: '躲在栅栏后',
        ko: '울타리 뒤에 숨기'
      }
    }
  },
  // ---------------- Stage 14 Act 2 ----------------
  // intentionally blank
  // ================ Stage 15 Act 1 ================
  {
    id: 'Carnivale S15 A1 Bestial Node High Voltage',
    type: 'StartsUsing',
    netRegex: {
      id: '3A2A',
      source: 'Bestial Node'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Carnivale S15 A1 Arena Shabti Spawn',
    // Arena Shabti spawns with a Damage Up buff that makes its attacks very dangerous
    // can Sleep the Arena Shabti until the buff expires
    type: 'AddedCombatant',
    netRegex: {
      name: 'Arena Shabti'
    },
    alertText: (_data, matches, output) => output.sleep({
      name: matches.name
    }),
    outputStrings: {
      sleep: outputs/* default.sleepTarget */.Z.sleepTarget
    }
  }, {
    id: 'Carnivale S15 A1 Bestial Node Superstorm',
    type: 'StartsUsing',
    netRegex: {
      id: '3A7B',
      source: 'Bestial Node',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Carnivale S15 A1 Bestial Node Repelling Cannons',
    type: 'StartsUsing',
    netRegex: {
      id: '3A2C',
      source: 'Bestial Node',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Carnivale S15 A1 Bestial Node Ballast',
    type: 'StartsUsing',
    netRegex: {
      id: '3A2D',
      source: 'Bestial Node',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  },
  // ================ Stage 16 Act 1 ================
  // intentionally blank
  // ---------------- Stage 16 Act 2 ----------------
  {
    id: 'Carnivale S16 A2 Tikbalang 10-tonze Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '3A17',
      source: 'Tikbalang',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Carnivale S16 A2 Tikbalang 111-tonze Swing',
    type: 'StartsUsing',
    netRegex: {
      id: '3A18',
      source: 'Tikbalang',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Carnivale S16 A2 Tikbalang Cry of Rage',
    type: 'StartsUsing',
    netRegex: {
      id: '3A1B',
      source: 'Tikbalang',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Carnivale S16 A2 Tikbalang 1111-tonze Swing',
    // Tikbalang casts The Bull's Voice (39BB) to give himself a Damage Up (122) buff,
    // then uses Predatorial Instinct (395D) to give the player an uncleansable Heavy (F0) and draw them in,
    // then begins casting 1111-tonze Swing (395E) which is lethal if not mitigated
    type: 'StartsUsing',
    netRegex: {
      id: '395E',
      source: 'Tikbalang',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Diamondback',
        de: 'Diamantrücken',
        fr: 'Dos de diamant',
        cn: '超硬化',
        ko: '초경화'
      }
    }
  }, {
    id: 'Carnivale S16 A2 Tikbalang Zoom In',
    type: 'StartsUsing',
    netRegex: {
      id: '3A19',
      source: 'Tikbalang',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Charge + knockback',
        de: 'Ansturm + Rückstoß',
        fr: 'Charge + Poussée',
        cn: '冲锋 + 击退',
        ko: '돌진 + 넉백'
      }
    }
  }, {
    id: 'Carnivale S16 A2 Tikbalang 10-tonze Wave',
    // front cleave with donut aoe
    type: 'StartsUsing',
    netRegex: {
      id: '3A1C',
      source: 'Tikbalang',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from front + in',
        de: 'Weg von Vorne + Rein',
        fr: 'Loin de l\'avant + intérieur',
        cn: '避开正面 + 去下方',
        ko: '보스 전방 피하기 + 안으로'
      }
    }
  },
  // ================ Stage 17 Act 1 ================
  // intentionally blank
  // ---------------- Stage 17 Act 2 ----------------
  {
    id: 'Carnivale S17 A2 Kreios Magitek Field',
    // same name, different id from S04 A2
    type: 'StartsUsing',
    netRegex: {
      id: '3AC9',
      source: 'Kreios'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  },
  // ================ Stage 18 Act 1 ================
  {
    id: 'Carnivale S18 A1-2 Arena Manticore Wild Charge',
    // non-telegraphed charge + knockback
    type: 'StartsUsing',
    netRegex: {
      id: '3ACF',
      source: 'Arena Manticore',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Charge + knockback',
        de: 'Ansturm + Rückstoß',
        fr: 'Ruée + Poussée',
        cn: '冲锋 + 击退',
        ko: '돌진 + 넉백'
      }
    }
  }, {
    id: 'Carnivale S18 A1-2 Arena Manticore Ripper Claw',
    // non-telegraphed front cleave
    type: 'StartsUsing',
    netRegex: {
      id: '3ACA',
      source: 'Arena Manticore',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Carnivale S18 A1-2 Arena Manticore Fireball',
    // non-telegraphed ranged aoe
    type: 'StartsUsing',
    netRegex: {
      id: '3ACB',
      source: 'Arena Manticore',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fireball',
        de: 'Feuerball',
        fr: 'Boule de feu',
        cn: '火球',
        ko: '화염구'
      }
    }
  },
  // ---------------- Stage 18 Act 2 ----------------
  // intentionally blank
  // ================ Stage 19 Act 1 ================
  {
    id: 'Carnivale S19 A1-2 Reflective Rebekkah Reflect',
    // reflects all magic attacks
    type: 'StartsUsing',
    netRegex: {
      id: '3AE1',
      source: 'Reflective Rebekkah',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Magic reflect',
        de: 'Magische Reflektion',
        fr: 'Réflexion magique',
        cn: '反弹魔法伤害',
        ko: '마법공격 반사됨'
      }
    }
  }, {
    id: 'Carnivale S19 A1-2 Reflective Rebekkah Offal Breath',
    type: 'StartsUsing',
    netRegex: {
      id: '3AE4',
      source: 'Reflective Rebekkah'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  },
  // ---------------- Stage 19 Act 2 ----------------
  {
    id: 'Carnivale S19 A2 Reflective Rebekkah Schizocarps',
    // spawns 8x Hot Hips around the arena that do a simultaneous gaze attack
    // can either look away from all Hot Hips or Blind yourself to dodge the gazes
    type: 'StartsUsing',
    netRegex: {
      id: '3AE5',
      source: 'Reflective Rebekkah',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Blind yourself or Look Away',
        de: 'Erblinden oder schau weg',
        fr: 'Aveuglez-vous ou regardez ailleurs',
        cn: '致盲自己或看向其他方向',
        ko: '나한테 실명걸기 또는 뒤돌기'
      }
    }
  },
  // ================ Stage 20 Act 1 ================
  {
    id: 'Carnivale S20 A1,3 Typhon Snort',
    // Typhon casts Snort to knock the player back,
    // then uses 3x un-telegraphed Fireballs that do very high damage if not mitigated
    type: 'StartsUsing',
    netRegex: {
      id: '3970',
      source: 'Typhon',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Diamondback',
        de: 'Diamantrücken',
        fr: 'Dos de diamant',
        cn: '超硬化',
        ko: '초경화'
      }
    }
  },
  // ---------------- Stage 20 Act 2 ----------------
  {
    id: 'Carnivale S20 A2 Ultros Imp Song',
    type: 'StartsUsing',
    netRegex: {
      id: '3978',
      source: 'Ultros'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  },
  // ---------------- Stage 20 Act 3 ----------------
  {
    id: 'Carnivale S20 A3 Ultros Imp Song',
    // same name, different id from S20 A2
    type: 'StartsUsing',
    netRegex: {
      id: '3998',
      source: 'Ultros'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Carnivale S20 A3 Stylish Tentacle Clearout',
    type: 'Ability',
    netRegex: {
      id: '399D',
      source: 'Stylish Tentacle',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  },
  // ================ Stage 21 Act 1 ================
  {
    id: 'Carnivale S21 A1-2 Arena Imp Void Blizzard',
    type: 'StartsUsing',
    netRegex: {
      id: '3AD7',
      source: 'Arena Imp'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  },
  // ---------------- Stage 21 Act 2 ----------------
  {
    id: 'Carnivale S21 A2 Act Start',
    // triggers off of the first autoattack in S21 A2
    type: 'Ability',
    netRegex: {
      id: '1961',
      source: 'Apademak',
      capture: false
    },
    preRun: data => data.act2 = true,
    suppressSeconds: 999999
  }, {
    id: 'Carnivale S21 A2 Apademak The Ram\'s Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '3AE7',
      source: 'Apademak',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Carnivale S21 A2 Apademak The Dragon\'s Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '3AE8',
      source: 'Apademak',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Carnivale S21 A2 Apademak The Ram\'s Keeper',
    type: 'StartsUsing',
    netRegex: {
      id: '3AE9',
      source: 'Apademak'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Carnivale S21 A2 Arena Imp Spawn',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Arena Imp',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.act2) return output.killAdds();
    },
    outputStrings: {
      killAdds: outputs/* default.killAdds */.Z.killAdds
    }
  },
  // ================ Stage 22 Act 1 ================
  // intentionally blank
  // ---------------- Stage 22 Act 2 ----------------
  {
    id: 'Carnivale S22 A2 Act Start',
    // triggers off of the first autoattack in S22 A2
    type: 'Ability',
    netRegex: {
      id: '1963',
      source: 'The Forefather',
      capture: false
    },
    preRun: data => data.act2 = true,
    suppressSeconds: 999999
  }, {
    id: 'Carnivale S22 A2 The Forefather Sap',
    // aoe under the player, followed by several aoes around the room with one safe spot
    type: 'Ability',
    netRegex: {
      id: '3A3A',
      source: 'The Forefather',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get to Safe Spot',
        de: 'Geh zur sicheren Stelle',
        fr: 'Allez dans la zone sûre',
        cn: '去安全区',
        ko: '안전지대 찾기'
      }
    }
  }, {
    id: 'Carnivale S22 A2 Arena Grenade Spawn',
    // Arena Grenades spawn with Sleep; if they wake up they will do lethal damage
    // Arena Grenades can be killed with a single standard (220p) attack spell
    // Arena Grenades need to be killed before the boss casts Ignition (3AC0, light roomwide attack, wakes Grenades)
    type: 'AddedCombatant',
    netRegex: {
      name: 'Arena Grenade'
    },
    alertText: (data, matches, output) => {
      if (data.act2) return output.kill({
        name: matches.name
      });
    },
    outputStrings: {
      kill: {
        en: 'Kill ${name}',
        de: 'Besiege ${name}',
        fr: 'Tuez ${name}',
        ja: '${name}を倒す',
        cn: '击杀 ${name}',
        ko: '${name} 처치'
      }
    }
  }, {
    id: 'Carnivale S22 A2 Arena Gas Bomb Spawn',
    // The Forefather will cast Burst (3A38), a non-interruptable, lethal roomwide attack
    // Arena Gas Bombs cast Flashthoom (3A36), a small aoe which will interrupt Burst
    // Arena Gas Bombs spawn on the edge of the arena and need to be pulled in range of the boss
    type: 'AddedCombatant',
    netRegex: {
      name: 'Arena Gas Bomb'
    },
    alertText: (data, matches, output) => {
      if (data.act2) return output.pullToBoss({
        name: matches.name
      });
    },
    outputStrings: {
      pullToBoss: {
        en: 'Pull ${name} to boss',
        de: 'Ziehe ${name} zum Boss',
        fr: 'Attirez ${name} vers le boss',
        cn: '将 ${name} 拉到BOSS处',
        ko: '보스쪽으로 ${name} 끌고오기'
      }
    }
  },
  // ================ Stage 23 Act 1 ================
  {
    id: 'Carnivale S23 A1 Kronprinz Behemoth Ecliptic Meteor',
    // Ecliptic Meteor (9.7s cast) is lethal if not mitigated
    // delay slightly so Diamondback doesn't run out too fast
    type: 'StartsUsing',
    netRegex: {
      id: '3B99',
      source: 'Kronprinz Behemoth',
      capture: false
    },
    delaySeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Diamondback',
        de: 'Diamantrücken',
        fr: 'Dos de diamant',
        cn: '超硬化',
        ko: '초경화'
      }
    }
  },
  // ================ Stage 24 Act 1 ================
  // intentionally blank
  // ---------------- Stage 24 Act 2 ----------------
  {
    id: 'Carnivale S24 A2 Arena Scribe Silence',
    type: 'StartsUsing',
    netRegex: {
      id: '3BD9',
      source: 'Arena Scribe'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Carnivale S24 A2 Arena Scribe Condensed Libra',
    // 38 = Physical Vulnerability Up
    // will make next attack (Triple Hit, 3BD8) lethal
    // can cleanse the debuff or mitigate the attack
    type: 'GainsEffect',
    netRegex: {
      effectId: '38',
      source: 'Arena Scribe'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse debuff or mitigate',
        de: 'Debuff entfernen oder mitigieren',
        fr: 'Guérissez les débuffs ou mitigez',
        cn: '驱散DEBUFF或减伤',
        ko: '디버프 해제 또는 생존기'
      }
    }
  },
  // ---------------- Stage 24 Act 3 ----------------
  {
    id: 'Carnivale S24 A3 Epilogi Page Tear',
    type: 'StartsUsing',
    netRegex: {
      id: '3BDC',
      source: 'Epilogi',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Carnivale S24 A3 Epilogi Head Down',
    type: 'StartsUsing',
    netRegex: {
      id: '3BDD',
      source: 'Epilogi',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback into Safe Spot',
        de: 'Rückstoß zur sicheren Stelle',
        fr: 'Poussée vers la zone sûre',
        cn: '击退到安全区',
        ko: '안전지대로 넉백되기'
      }
    }
  }, {
    id: 'Carnivale S24 A3 Epilogi Bone Shaker',
    // aoe + spawns adds
    type: 'Ability',
    netRegex: {
      id: '3BDE',
      source: 'Epilogi',
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds()
  },
  // ================ Stage 25 Act 1 ================
  {
    id: 'Carnivale S25 A1,3 Azulmagia Ice Spikes',
    // reflects physical damage
    type: 'StartsUsing',
    netRegex: {
      id: '39AA',
      source: 'Azulmagia',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Physical reflect',
        de: 'Physische Reflektion',
        fr: 'Réflexion physique',
        cn: '反弹物理伤害',
        ko: '물리공격 반사됨'
      }
    }
  }, {
    id: 'Carnivale S25 A1-3 Azulmagia The Ram\'s Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '39AB',
      source: 'Azulmagia',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Carnivale S25 A1-3 Azulmagia The Dragon\'s Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '39AC',
      source: 'Azulmagia',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  },
  // ---------------- Stage 25 Act 2 ----------------
  {
    id: 'Carnivale S25 A2-3 Azulmagia Repelling Spray',
    // reflects magic damage
    type: 'StartsUsing',
    netRegex: {
      id: '39B0',
      source: 'Azulmagia',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Magic reflect',
        de: 'Magische Reflektion',
        fr: 'Réflexion magique',
        cn: '反弹魔法伤害',
        ko: '마법공격 반사됨'
      }
    }
  }, {
    id: 'Carnivale S25 A2 Azulmagia Blazing Angon',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Blazing Angon',
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds()
  },
  // ---------------- Stage 25 Act 3 ----------------
  // intentionally blank
  // ================ Stage 26 Act 1 ================
  {
    id: 'Carnivale S26 A1 Arena Mirrorknight Alternate Plumage',
    // 3F = Vulnerability Down, can be dispelled
    type: 'GainsEffect',
    netRegex: {
      effectId: '3F',
      target: 'Arena Mirrorknight'
    },
    infoText: (_data, matches, output) => output.dispel({
      name: matches.target
    }),
    outputStrings: {
      dispel: {
        en: 'Dispel ${name}',
        de: 'Entferne ${name}',
        fr: 'Dissipez ${name}',
        cn: '清除 ${name}',
        ko: '${name} 버프 해제'
      }
    }
  }, {
    id: 'Carnivale S26 A1 Arena Mirrorknight Caber Toss',
    type: 'StartsUsing',
    netRegex: {
      id: '4900',
      source: 'Arena Mirrorknight'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  },
  // ---------------- Stage 26 Act 2 ----------------
  {
    id: 'Carnivale S26 A2 Papa Humbaba Raw Instinct',
    // 705 = Critical Strikes, can be dispelled
    type: 'GainsEffect',
    netRegex: {
      effectId: '705',
      target: 'Papa Humbaba'
    },
    infoText: (_data, matches, output) => output.dispel({
      name: matches.target
    }),
    outputStrings: {
      dispel: {
        en: 'Dispel ${name}',
        de: 'Entferne ${name}',
        fr: 'Dissipez ${name}',
        cn: '清除 ${name}',
        ko: '${name} 버프 해제'
      }
    }
  }, {
    id: 'Carnivale S26 A2 Papa Humbaba Dad Joke',
    // attack has a headmarker warning but no castbar
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Carnivale S26 A2 Papa Humbaba Void Thunder III',
    // 10F = Electrocution, can be cleansed
    type: 'GainsEffect',
    netRegex: {
      effectId: '10F',
      source: 'Papa Humbaba'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse debuff',
        de: 'Debuff entfernen',
        fr: 'Guérissez le débuff',
        cn: '驱散DEBUFF',
        ko: '디버프 해제'
      }
    }
  },
  // ================ Stage 27 Act 1 ================
  // intentionally blank
  // ================ Stage 28 Act 1 ================
  {
    id: 'Carnivale S28 A1 Durinn Doom Impending',
    // gives Doom (6E9) and Incurable (5D0)
    // if not healed to full before debuffs applied, player will die
    type: 'StartsUsing',
    netRegex: {
      id: '4A6B',
      source: 'Durinn',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Heal To Full',
        de: 'Vollheilen',
        fr: 'Soignez complètement',
        ja: '全員のHPを全回復',
        cn: '奶满自己',
        ko: '체력 풀피로'
      }
    }
  }, {
    id: 'Carnivale S28 A1 Durinn March of the Draugar',
    // summons different adds each wave
    type: 'Ability',
    netRegex: {
      id: '4A71',
      source: 'Durinn',
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'Carnivale S28 A1 Durinn Cackle',
    type: 'StartsUsing',
    netRegex: {
      id: '4A6D',
      source: 'Durinn'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Carnivale S28 A1 Durinn Mega Death',
    // if player does not have the Death Becomes You (895) debuff when cast finishes, they will die
    type: 'StartsUsing',
    netRegex: {
      id: '4A6F',
      source: 'Durinn',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in one puddle',
        de: 'In einer Fläche stehen',
        fr: 'Placez-vous dans une zone au sol',
        ja: '範囲に入る',
        cn: '站在圈里',
        ko: '장판 하나만 밟기'
      }
    }
  }, {
    id: 'Carnivale S28 A1 Durinn Funeral Pyre',
    // all undead in this stage take increased damage from fire attacks
    // player counts as undead if they have the Death Becomes You (895) debuff
    type: 'StartsUsing',
    netRegex: {
      id: '4A70',
      source: 'Durinn',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid puddles',
        de: 'Vermeide Flächen',
        fr: 'Évitez les flaques',
        cn: '躲避圈圈',
        ko: '장판 피하기'
      }
    }
  }, {
    id: 'Carnivale S28 A1 Durinn Brainstorm',
    // Mindhack with ground aoes, single safe spot
    type: 'GainsEffect',
    // 7A6 = Forward March
    // 7A7 = About Face
    // 7A8 = Left Face
    // 7A9 = Right Face
    netRegex: {
      effectId: '7A[6-9]',
      source: 'Durinn'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, matches, output) => {
      const effectId = matches.effectId.toUpperCase();
      if (effectId === '7A6') return output.forward();
      if (effectId === '7A7') return output.backward();
      if (effectId === '7A8') return output.left();
      if (effectId === '7A9') return output.right();
    },
    outputStrings: {
      forward: {
        en: 'March Forward into Safe Spot',
        de: 'marschiere Vorwärts in die sichere Stelle',
        fr: 'Marche avant forcée en zone sûre',
        ja: '強制移動: 前',
        cn: '向前强制移动到安全区',
        ko: '강제 이동 앞'
      },
      backward: {
        en: 'March Backward into Safe Spot',
        de: 'marschiere Rückwärts in die sichere Stelle',
        fr: 'Marche arrière forcée en zone sûre',
        ja: '強制移動: 後ろ',
        cn: '向后强制移动到安全区',
        ko: '강제 이동 뒤'
      },
      left: {
        en: 'March Left into Safe Spot',
        de: 'marschiere Links in die sichere Stelle',
        fr: 'Marche à gauche forcée en zone sûre',
        ja: '強制移動: 左',
        cn: '向左强制移动到安全区',
        ko: '강제 이동 왼쪽'
      },
      right: {
        en: 'March Right into Safe Spot',
        de: 'marschiere Rechts in die sichere Stelle',
        fr: 'Marche à droite forcée en zone sûre',
        ja: '強制移動: 右',
        cn: '向右强制移动到安全区',
        ko: '강제 이동 오른쪽'
      }
    }
  },
  // ================ Stage 29 Act 1 ================
  {
    id: 'Carnivale S29 A1 Shikigami of the Pyre Fluid Swing',
    // cleave + knockback if not interrupted
    type: 'StartsUsing',
    netRegex: {
      id: '4901',
      source: 'Shikigami of the Pyre'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Carnivale S29 A1 Shikigami of the Pyre Sea of Flames',
    type: 'StartsUsing',
    netRegex: {
      id: '4905',
      source: 'Shikigami of the Pyre',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait two Eruptions',
        de: 'Köder 2 Eruptionen',
        fr: 'Attirez 2 éruptions',
        cn: '诱导2个地火',
        ko: '장판 2개 유도'
      }
    }
  }, {
    id: 'Carnivale S29 A1 Shikigami of the Pyre Pyretic',
    // the Pyretic cast (4903) gives the Pyretic debuff (3C0)
    type: 'StartsUsing',
    netRegex: {
      id: '4903',
      source: 'Shikigami of the Pyre',
      capture: false
    },
    response: responses/* Responses.stopEverything */.n3.stopEverything()
  }, {
    id: 'Carnivale S29 A1 Pyretic Lose',
    // 3C0 = Pyretic
    // Shikigami of the Pyre casts Fire II (4904) to bait the player into moving early
    type: 'LosesEffect',
    netRegex: {
      effectId: '3C0',
      source: 'Shikigami of the Pyre'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'Carnivale S29 A1 Shikigami of the Pyre Pillar of Flame 1',
    // out-then-in pattern
    // TODO: is this always out-then-in, can it ever be in-then-out?
    type: 'StartsUsing',
    netRegex: {
      id: '4907',
      source: 'Shikigami of the Pyre',
      capture: false
    },
    response: responses/* Responses.getOutThenIn */.n3.getOutThenIn()
  }, {
    id: 'Carnivale S29 A1 Shikigami of the Pyre Pillar of Flame 2',
    // single safe spot pattern
    type: 'StartsUsing',
    netRegex: {
      id: '49CE',
      source: 'Shikigami of the Pyre',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get to Safe Spot',
        de: 'Geh zur sicheren Stelle',
        fr: 'Allez en zone sûre',
        cn: '去安全区',
        ko: '안전지대 찾기'
      }
    }
  }, {
    id: 'Carnivale S29 A1 Shikigami of the Pyre Flare Star',
    // proximity damage from center of the arena
    type: 'StartsUsing',
    netRegex: {
      id: '4909',
      source: 'Shikigami of the Pyre',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get to edge',
        de: 'Geh zu einem Rand',
        fr: 'Allez sur le bord',
        cn: '去场边',
        ko: '외곽으로'
      }
    }
  }, {
    id: 'Carnivale S29 A1 Shikigami of the Pyre Rush',
    // charge from boss that deals proximity-based damage
    type: 'StartsUsing',
    netRegex: {
      id: '4902',
      source: 'Shikigami of the Pyre',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Run Away From Boss',
        de: 'Renn weg vom Boss',
        fr: 'Éloignez-vous du boss',
        ja: 'ボスから離れる',
        cn: '远离Boss',
        ko: '보스와 거리 벌리기'
      }
    }
  },
  // ---------------- Stage 29 Act 2 ----------------
  {
    id: 'Carnivale S29 A2 Shikigami of the Undertow Fluid Swing',
    // cleave + knockback if not interrupted
    type: 'StartsUsing',
    netRegex: {
      id: '4A11',
      source: 'Shikigami of the Undertow'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Carnivale S29 A2 Shikigami of the Undertow Protean Wave',
    // cone from front of boss then cone baited on player
    type: 'StartsUsing',
    netRegex: {
      id: '4A1B',
      source: 'Shikigami of the Undertow',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Carnivale S29 A2 Shikigami of the Undertow Throttle',
    // 2BC = Throttle, lethal if not cleansed
    type: 'GainsEffect',
    netRegex: {
      effectId: '2BC',
      source: 'Shikigami of the Undertow'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse debuff',
        de: 'Debuff entfernen',
        fr: 'Guérissez le débuff',
        cn: '驱散DEBUFF',
        ko: '디버프 해제'
      }
    }
  }, {
    id: 'Carnivale S29 A2 Shikigami of the Undertow Ferrofluid',
    // 4A12 magnets with different polarity (will get pulled into boss + point-blank aoe under boss)
    // 4A13 magnets with same polarity (will get pushed away from boss + donut aoe around boss)
    type: 'StartsUsing',
    netRegex: {
      id: '4A1[23]',
      source: 'Shikigami of the Undertow'
    },
    infoText: (_data, matches, output) => {
      if (matches.id === '4A12') return output.far();
      return output.close();
    },
    outputStrings: {
      close: {
        en: 'Close to boss',
        de: 'Nahe am Boss',
        fr: 'Allez près du boss',
        ja: 'ボスに近づく',
        cn: '靠近boss',
        ko: '보스 가까이 붙기'
      },
      far: {
        en: 'Away from boss',
        de: 'Weg am Boss',
        fr: 'Éloignez-vous du boss',
        ja: 'ボスから離れる',
        cn: '远离boss',
        ko: '보스에게서 멀어지기'
      }
    }
  }, {
    id: 'Carnivale S29 A2 Shikigami of the Undertow Fluid Ball',
    type: 'StartsUsing',
    netRegex: {
      id: '4A18',
      source: 'Shikigami of the Undertow',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait two aoes',
        de: 'Köder 2 AoEs',
        fr: 'Attirez 2 AoEs',
        cn: '诱导2个AOE',
        ko: '장판 2개 유도'
      }
    }
  }, {
    id: 'Carnivale S29 A2 Shikigami of the Undertow Watery Grasp Warning',
    type: 'StartsUsing',
    netRegex: {
      id: '4A54',
      source: 'Shikigami of the Undertow',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Adds soon',
        de: 'Bald Adds',
        fr: 'Adds bientôt',
        cn: '小怪即将出现',
        ko: '곧 쫄 나옴'
      }
    }
  }, {
    id: 'Carnivale S29 A2 Shikigami of the Undertow Watery Grasp Adds',
    type: 'Ability',
    netRegex: {
      id: '4A54',
      source: 'Shikigami of the Undertow',
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'Carnivale S29 A2 Shikigami of the Undertow Big Splash',
    // Big Splash (7.7s cast) is lethal if not mitigated
    type: 'StartsUsing',
    netRegex: {
      id: '4A15',
      source: 'Shikigami of the Undertow',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Diamondback',
        de: 'Diamantrücken',
        fr: 'Dos de diamant',
        cn: '超硬化',
        ko: '초경화'
      }
    }
  }, {
    id: 'Carnivale S29 A2 Shikigami of the Undertow Unwind',
    // proximity damage from 3x water tornadoes
    type: 'StartsUsing',
    netRegex: {
      id: '4A29',
      source: 'Shikigami of the Undertow',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from water tornadoes',
        de: 'Weg von den Wassertornados',
        fr: 'Éloignez-vous des tornades d\'eau',
        cn: '远离水龙卷',
        ko: '물기둥에서 멀리 떨어지기'
      }
    }
  },
  // ================ Stage 30 Act 1 ================
  {
    id: 'Carnivale S30 A1,3 Siegfried Magic Drain',
    // reflects all magic attacks
    type: 'StartsUsing',
    netRegex: {
      id: '49CA',
      source: 'Siegfried',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Magic reflect',
        de: 'Magische Reflektion',
        fr: 'Réflexion magique',
        cn: '反弹魔法伤害',
        ko: '마법공격 반사됨'
      }
    }
  }, {
    id: 'Carnivale S30 A1,3 Siegfried Ankle Graze',
    // 234 = Bind
    type: 'GainsEffect',
    netRegex: {
      effectId: '234',
      source: 'Siegfried'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse debuff',
        de: 'Debuff entfernen',
        fr: 'Guérissez le débuff',
        cn: '驱散DEBUFF',
        ko: '디버프 해제'
      }
    }
  }, {
    id: 'Carnivale S30 A1,3 Siegfried Hyperdrive',
    type: 'Ability',
    netRegex: {
      id: '4994',
      source: 'Siegfried',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait three aoes',
        de: 'Köder 3 AoEs',
        fr: 'Attirez 3 AoEs',
        cn: '诱导3个AOE',
        ko: '장판 3개 유도'
      }
    }
  }, {
    id: 'Carnivale S30 A1 Siegfried Rubber Bullet',
    // TODO: is back-right from boss always safe?
    type: 'StartsUsing',
    netRegex: {
      id: '499F',
      source: 'Siegfried',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback into Safe Spot',
        de: 'Rückstoß zur sicheren Stelle',
        fr: 'Poussée vers la zone sûre',
        cn: '击退到安全区',
        ko: '안전지대로 넉백되기'
      }
    }
  },
  // ---------------- Stage 30 Act 2 ----------------
  {
    id: 'Carnivale S30 A2-3 Siegfried Swiftsteel',
    // donut aoe with knockback
    type: 'StartsUsing',
    netRegex: {
      id: '499A',
      source: 'Siegfried',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get in + Knockback',
        de: 'Geh rein + Rückstoß',
        fr: 'Intérieur + Poussée',
        cn: '去脚下 + 击退',
        ko: '안으로 + 넉백'
      }
    }
  }, {
    id: 'Carnivale S30 A2-3 Siegfried Shattersteel',
    // single safe spot in gap between two ice blocks
    type: 'StartsUsing',
    netRegex: {
      id: '4A53',
      source: 'Siegfried',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get to Safe Spot (between two ice)',
        de: 'Geh zur sicheren Stelle (zwischen 2 Eis)',
        fr: 'Allez en zone sûre (entre deux glaces)',
        cn: '去安全区 (两个冰之间)',
        ko: '안전지대 찾기 (얼음 없는쪽)'
      }
    }
  },
  // ---------------- Stage 30 Act 3 ----------------
  // intentionally blank
  // ================ Stage 31 Act 1 ================
  {
    id: 'Carnivale S31 A1 Gogo, Master of Mimicry Mimic',
    // Gogo counterattacks all attacks while Mimicry (992) is active
    type: 'StartsUsing',
    netRegex: {
      id: '5A39',
      source: 'Gogo, Master of Mimicry'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stop attacking',
        de: 'Angriffe stoppen',
        fr: 'Arrêtez d\'attaquer',
        ja: '攻撃禁止',
        cn: '停止攻击',
        ko: '공격 중지'
      }
    }
  }, {
    id: 'Carnivale S31 A1 Gogo, Master of Mimicry Mimicked Sap',
    // casts 3x, second and third casts are faster
    // 5A40 = 3.2s, 5A41 = 1.2s
    type: 'Ability',
    netRegex: {
      id: '5A40',
      source: 'Gogo, Master of Mimicry',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait two aoes',
        de: 'Köder 2 AoEs',
        fr: 'Attirez 2 AoEs',
        cn: '诱导2个AOE',
        ko: '장판 2개 유도'
      }
    }
  }, {
    id: 'Carnivale S31 A1 Gogo, Master of Mimicry Mimicked Imp Song',
    type: 'StartsUsing',
    netRegex: {
      id: '5A4A',
      source: 'Gogo, Master of Mimicry'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Carnivale S31 A1 Gogo, Master of Mimicry Mimicked Doom Impending',
    // gives Doom (6E9) and Incurable (5D0)
    // if not healed to full before debuffs applied, player will die
    type: 'StartsUsing',
    netRegex: {
      id: '5A49',
      source: 'Gogo, Master of Mimicry',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Heal To Full',
        de: 'Vollheilen',
        fr: 'Soignez complètement',
        ja: '全員のHPを全回復',
        cn: '奶满自己',
        ko: '체력 풀피로'
      }
    }
  }, {
    id: 'Carnivale S31 A1 Gogo, Master of Mimicry Mimicked Bunshin',
    // spawns a clone that does a double cone while Gogo does a line aoe
    type: 'StartsUsing',
    netRegex: {
      id: '5A43',
      source: 'Gogo, Master of Mimicry',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Add soon',
        de: 'Bald Add',
        fr: 'Add bientôt',
        cn: '小怪即将出现',
        ko: '분신 등장'
      }
    }
  }, {
    id: 'Carnivale S31 A1 Gogo, Master of Mimicry Mimicked Raw Instinct',
    // 705 = Critical Strikes, can be dispelled
    type: 'GainsEffect',
    netRegex: {
      effectId: '705',
      target: 'Gogo, Master of Mimicry'
    },
    infoText: (_data, matches, output) => output.dispel({
      name: matches.target
    }),
    outputStrings: {
      dispel: {
        en: 'Dispel ${name}',
        de: 'Entferne ${name}',
        fr: 'Dissipez ${name}',
        cn: '清除 ${name}',
        ko: '${name} 버프 해제'
      }
    }
  },
  // ---------------- Stage 31 Act 2 ----------------
  {
    id: 'Carnivale S31 A2 Gogo, Master of Mimicry Gogo Fire III',
    // gives the Pyretic debuff (3C0)
    // followed by Gogo Blizzard III (5A4E), a point-blank aoe around the boss
    type: 'StartsUsing',
    netRegex: {
      id: '5A4D',
      source: 'Gogo, Master of Mimicry',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from boss => Stop Everything',
        de: 'Weg vom Boss => Stoppe alles',
        fr: 'Éloignez-vous du boss => Arrêtez tout',
        cn: '远离BOSS => 停停停',
        ko: '보스와 멀리 떨어지기 => 행동 멈추기'
      }
    }
  }, {
    id: 'Carnivale S31 A2 Gogo, Master of Mimicry Gogo Meteor',
    // Gogo Meteor is a clusterfuck of random, baited, and proximity-damage aoes
    // followed by one giant, roomwide meteor that is lethal if not mitigated
    // multiple ids: 5A50, 5A51, 5A52, 5A53, 5A54, 5A59, 5A5B
    // 5A54 is the giant, roomwide, lethal meteor at the end
    type: 'StartsUsing',
    netRegex: {
      id: '5A54',
      source: 'Gogo, Master of Mimicry'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) / 2,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Diamondback',
        de: 'Diamantrücken',
        fr: 'Dos de diamant',
        cn: '超硬化',
        ko: '초경화'
      }
    }
  }, {
    id: 'Carnivale S31 A2 Gogo, Master of Mimicry Icestorm',
    // Icestorm gives two debuffs: Frostbite (10C) and Heavy (453)
    // both need to be cleansed so the following mechanics can be dodged
    type: 'GainsEffect',
    netRegex: {
      effectId: ['10C', '453'],
      source: 'Gogo, Master of Mimicry'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse both debuffs',
        de: 'Entferne beide Debuffs',
        fr: 'Guérissez les deux débuffs',
        cn: '驱散两个DEBUFF',
        ko: '디버프 둘다 해제'
      }
    }
  },
  // ================ Stage 32 Act 1 ================
  {
    id: 'Carnivale S32 A1-2 Goldor Goldor Blizzard III',
    type: 'StartsUsing',
    netRegex: {
      id: '871D',
      source: 'Goldor'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Carnivale S32 A1-2 Goldor Goldor Aero III',
    type: 'StartsUsing',
    netRegex: {
      id: '869C',
      source: 'Goldor',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Carnivale S32 A1-2 Goldor Goldor Thunder III',
    // 10F = Electrocution, can be cleansed
    type: 'GainsEffect',
    netRegex: {
      effectId: '10F',
      source: 'Goldor'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse debuff',
        de: 'Debuff entfernen',
        fr: 'Guérissez le débuff',
        cn: '驱散DEBUFF',
        ko: '디버프 해제'
      }
    }
  },
  // ---------------- Stage 32 Act 2 ----------------
  {
    id: 'Carnivale S32 A2 Gilded Cyclops 24-carat Swing',
    type: 'StartsUsing',
    netRegex: {
      id: '86A3',
      source: 'Gilded Cyclops',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Carnivale S32 A2 Goldor Goldor Rush',
    type: 'StartsUsing',
    netRegex: {
      id: '86A4',
      source: 'Goldor',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Apademak': 'Apademak',
      'Arena Catoblepas': 'Arena-Catblepus',
      'Arena Eye': 'Arena-Auge',
      'Arena Gas Bomb': 'Arena-Gasbomber',
      'Arena Grenade': 'Arena-Granate',
      'Arena Imp': 'Arena-Imp',
      'Arena Jam': 'Arena-Marmelade',
      'Arena Manticore': 'Arena-Manticore',
      'Arena Mirrorknight': 'Arena-Speglidae',
      'Arena Progenitrix': 'Arena-Progenitrix',
      'Arena Scribe': 'Arena-Scholar',
      'Arena Shabti': 'Arena-Shabti',
      'Arena Succubus': 'Arena-Sukkubus',
      'Azulmagia': 'Azulmagia',
      'Bestial Node': 'bestialisch(?:e|er|es|en) System',
      'Blazing Angon': 'Glühender Ango',
      'Carmilla': 'Carmilla',
      'Crom Dubh': 'Crom Dubh',
      'Durinn': 'Durinn',
      'Epilogi': 'Epilogi',
      'Gilded Cyclops': 'gülden(?:e|er|es|en) Zyklop',
      'Gladiatorial Node': 'kämpferisch(?:e|er|es|en) System',
      'Gogo, Master of Mimicry': 'Gogo (?:der|die|das) Mime',
      'Goldor': 'Goldor',
      'Guimauve': 'Guimauve',
      'Hydnora': 'Hydnora',
      'Kreios': 'Kreios',
      'Kronprinz Behemoth': 'Kronprinz-Behemoth',
      'Papa Humbaba': 'Hunbabas Papa',
      'Reflective Rebekkah': 'Rebekkah Rotzeranke',
      'Shikigami of the Pyre': 'Shikigami des Feuers',
      'Shikigami of the Undertow': 'Shikigami des Wassers',
      'Siegfried': 'Siegfried',
      'Stylish Tentacle': 'elegant(?:e|er|es|en) Tentakel',
      'The Forefather': 'Urgroßbomber',
      'Tikbalang': 'Tikbalang',
      'Typhon': 'Typhon',
      'Ultros': 'Ultros',
      'Zipacna': 'Zipacna'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Apademak': 'Apademak',
      'Arena Catoblepas': 'catoblépas de l\'arène',
      'Arena Eye': 'œil de l\'arène',
      'Arena Gas Bomb': 'bombo à gaz de l\'arène',
      'Arena Grenade': 'grenado de l\'arène',
      'Arena Imp': 'imp de l\'arène',
      'Arena Jam': 'confiture aigre',
      'Arena Manticore': 'manticore de l\'arène',
      'Arena Mirrorknight': 'chevalier miroir de l\'arène',
      'Arena Progenitrix': 'maman bombo de l\'arène',
      'Arena Scribe': 'scribe de l\'arène',
      'Arena Shabti': 'chaouabti de l\'arène',
      'Arena Succubus': 'succube de l\'arène',
      'Azulmagia': 'Azulmagia',
      'Bestial Node': 'sphère bestiale',
      'Blazing Angon': 'Angon flamboyant',
      'Carmilla': 'Carmilla',
      'Crom Dubh': 'Crom Dubh',
      'Durinn': 'Durinn',
      'Epilogi': 'Epilogi',
      'Gilded Cyclops': 'cyclope de Goldor',
      'Gladiatorial Node': 'sphère gladiatrice',
      'Gogo, Master of Mimicry': 'Gogo le mime',
      'Goldor': 'Goldor',
      'Guimauve': 'Guimauve',
      'Hydnora': 'Hydnora',
      'Kreios': 'Kreios',
      'Kronprinz Behemoth': 'Kronprinz béhémoth',
      'Papa Humbaba': 'Papa Humbaba',
      'Reflective Rebekkah': 'Rebekkah l\'égocentrique',
      'Shikigami of the Pyre': 'shikigami de feu',
      'Shikigami of the Undertow': 'shikigami d\'eau',
      'Siegfried': 'Siegfried',
      'Stylish Tentacle': 'tentacule',
      'The Forefather': 'Papi bombo',
      'Tikbalang': 'Tikbalang',
      'Typhon': 'Typhon',
      'Ultros': 'Orthros',
      'Zipacna': 'Zipacna'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Apademak': 'アペデマク',
      'Arena Catoblepas': 'アリーナ・カトブレパス',
      'Arena Eye': 'アリーナ・アイ',
      'Arena Gas Bomb': 'アリーナ・ガスボム',
      'Arena Grenade': 'アリーナ・グレネード',
      'Arena Imp': 'アリーナ・インプ',
      'Arena Jam': 'アリーナ・ポイズンジャム',
      'Arena Manticore': 'アリーナ・マンティコア',
      'Arena Mirrorknight': 'アリーナ・ミラーナイト',
      'Arena Progenitrix': 'アリーナ・マザーボム',
      'Arena Scribe': 'アリーナ・スクライブ',
      'Arena Shabti': 'アリーナ・シュワブチ',
      'Arena Succubus': 'アリーナ・サキュバス',
      'Azulmagia': 'アポカリョープス',
      'Bestial Node': '闘獣システム',
      'Blazing Angon': 'ブレージングアンゴン',
      'Carmilla': 'カーミラ',
      'Crom Dubh': 'クロムドゥーブ',
      'Durinn': 'ドゥリン',
      'Epilogi': 'エペロギ',
      'Gilded Cyclops': 'ゴールドル・サイクロプス',
      'Gladiatorial Node': '闘技システム',
      'Gogo, Master of Mimicry': 'ものまね士ゴゴ',
      'Goldor': 'ゴールドル',
      'Guimauve': 'ギモーヴ',
      'Hydnora': 'ヒドノラ',
      'Kreios': 'クレイオス',
      'Kronprinz Behemoth': 'クロンプリンツ・ベヒーモス',
      'Papa Humbaba': 'フンババ・パパ',
      'Reflective Rebekkah': 'リフレクティブ・レベッカ',
      'Shikigami of the Pyre': '火のシキガミ',
      'Shikigami of the Undertow': '水のシキガミ',
      'Siegfried': 'ジークフリード',
      'Stylish Tentacle': 'タコ足',
      'The Forefather': 'グランパボム',
      'Tikbalang': 'ティクバラン',
      'Typhon': 'テュポーン',
      'Ultros': 'オルトロス',
      'Zipacna': 'シパクナー'
    }
  }, {
    'locale': 'cn',
    'missingTranslations': true,
    'replaceSync': {
      'Apademak': '阿帕德马克',
      'Arena Catoblepas': '斗场卡托布莱帕斯',
      'Arena Eye': '斗场之眼',
      'Arena Gas Bomb': '斗场瓦斯弹怪',
      'Arena Grenade': '斗场榴弹怪',
      'Arena Imp': '斗场小魔精',
      'Arena Jam': '斗场剧毒果酱怪',
      'Arena Manticore': '斗场曼提克',
      'Arena Mirrorknight': '斗场镜骑士',
      'Arena Progenitrix': '斗场爆弹之母',
      'Arena Scribe': '斗场抄写员',
      'Arena Shabti': '斗场沙布提',
      'Arena Succubus': '斗场梦魔',
      'Azulmagia': '启示者',
      'Bestial Node': '斗兽系统',
      'Blazing Angon': '烈火投枪',
      'Carmilla': '卡蜜拉',
      'Crom Dubh': '幽黑曲偶',
      'Durinn': '都灵',
      'Epilogi': '艾匹罗基',
      'Gladiatorial Node': '斗技系统',
      'Gogo, Master of Mimicry': '模仿师 格格',
      'Guimauve': '棉花软糖',
      'Hydnora': '火花草',
      'Kreios': '克利俄斯',
      'Kronprinz Behemoth': '贝希摩斯太子',
      'Papa Humbaba': '洪巴巴之父',
      'Reflective Rebekkah': '反射魔花瑞贝卡',
      'Shikigami of the Pyre': '火之式神',
      'Shikigami of the Undertow': '水之式神',
      'Siegfried': '齐格弗里德',
      'Stylish Tentacle': '章鱼触手',
      'The Forefather': '爆弹之祖',
      'Tikbalang': '迪克巴朗',
      'Typhon': '提丰',
      'Ultros': '奥尔特罗斯',
      'Zipacna': '希帕克纳'
    }
  }, {
    'locale': 'ko',
    'missingTranslations': true,
    'replaceSync': {
      'Apademak': '아페데마크',
      'Arena Catoblepas': '투기장 카토블레파스',
      'Arena Eye': '투기장 눈알',
      'Arena Gas Bomb': '투기장 가스봄',
      'Arena Grenade': '투기장 그레네이드',
      'Arena Imp': '투기장 임프',
      'Arena Jam': '투기장 독잼',
      'Arena Manticore': '투기장 만티코어',
      'Arena Mirrorknight': '투기장 거울기사',
      'Arena Progenitrix': '투기장 엄마 봄',
      'Arena Scribe': '투기장 서기',
      'Arena Shabti': '투기장 샤브티',
      'Arena Succubus': '투기장 서큐버스',
      'Azulmagia': '아포칼리옵스',
      'Bestial Node': '투기야수 시스템',
      'Blazing Angon': '폭염 투창',
      'Carmilla': '카밀라',
      'Crom Dubh': '크롬 두브',
      'Durinn': '두린',
      'Epilogi': '에필로기',
      'Gladiatorial Node': '투기 시스템',
      'Gogo, Master of Mimicry': '흉내쟁이 고고',
      'Guimauve': '기모브',
      'Hydnora': '히드노라',
      'Kreios': '크레이오스',
      'Kronprinz Behemoth': '황태자 베히모스',
      'Papa Humbaba': '아빠 훔바바',
      'Reflective Rebekkah': '사색하는 레베카',
      'Shikigami of the Pyre': '불의 사역귀',
      'Shikigami of the Undertow': '물의 사역귀',
      'Siegfried': '지크프리드',
      'Stylish Tentacle': '문어발',
      'The Forefather': '할아봄',
      'Tikbalang': '틱발랑',
      'Typhon': '티폰',
      'Ultros': '오르트로스',
      'Zipacna': '시파크나'
    }
  }]
};
/* harmony default export */ const the_masked_carnivale = (the_masked_carnivale_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/alliance/the_world_of_darkness.ts



// TODO:
//  Angra Mainyu
//    Add Level 100 Flare
//    Add Level 150 Doom
//    Add Roulette?
//    Add info text for add spawns?
//  Five-Headed Dragon
//  Howling Atomos
//  Cerberus
//  Cloud of Darkness
const the_world_of_darkness_triggerSet = {
  id: 'TheWorldOfDarkness',
  zoneId: zone_id/* default.TheWorldOfDarkness */.Z.TheWorldOfDarkness,
  triggers: [{
    id: 'Angra Mainyu Gain Sullen',
    type: 'GainsEffect',
    netRegex: {
      effectId: '27c'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.sullenDebuff = true
  }, {
    id: 'Angra Mainyu Lose Sullen',
    type: 'LosesEffect',
    netRegex: {
      effectId: '27c'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.sullenDebuff = false
  }, {
    id: 'Angra Mainyu Gain Ireful',
    type: 'GainsEffect',
    netRegex: {
      effectId: '27d'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.irefulDebuff = true
  }, {
    id: 'Angra Mainyu Lose Ireful',
    type: 'LosesEffect',
    netRegex: {
      effectId: '27d'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.irefulDebuff = false
  }, {
    id: 'Angra Mainyu Double Vision',
    type: 'StartsUsing',
    netRegex: {
      id: 'CC8',
      source: 'Angra Mainyu',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.sullenDebuff) {
        // Stand behind boss in the red half to switch to Ireful
        return output.red();
      } else if (data.irefulDebuff) {
        // Stand in front of boss in the white half to switch to Sullen
        return output.white();
      }
    },
    outputStrings: {
      red: {
        en: 'Get Behind (Red)',
        de: 'Geh nach Hinten (Rot)',
        fr: 'Passez derrière (Rouge)',
        ja: 'ボスの後ろに (赤)',
        cn: '去背后 (红色)',
        ko: '뒤쪽으로 (빨강)'
      },
      white: {
        en: 'Get in Front (White)',
        de: 'Geh nach Vorne (Weiß)',
        fr: 'Allez devant (Blanc)',
        ja: 'ボスの前に (白)',
        cn: '去正面 (白色)',
        ko: '앞쪽으로 (흰색)'
      }
    }
  }, {
    id: 'Angra Mainyu Mortal Gaze',
    type: 'StartsUsing',
    netRegex: {
      id: ['CD1', 'DAB'],
      source: 'Angra Mainyu',
      capture: false
    },
    suppressSeconds: 0.1,
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'Angra Mainyu Gain Doom',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'd2'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.cleanse(),
    outputStrings: {
      cleanse: {
        en: 'Run to Cleanse Circle',
        de: 'Geh in die Kreise zum reinigen',
        fr: 'Allez dans un cercle de purification',
        ja: '床の光っている円範囲へ',
        cn: '快踩净化圈',
        ko: '흰색 원 밟아서 선고 해제하기'
      }
    }
  }, {
    id: 'Angra Mainyu Level 100 Flare Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '002C'
    },
    condition: conditions/* default.targetIsNotYou */.Z.targetIsNotYou(),
    response: responses/* Responses.awayFrom */.n3.awayFrom()
  }, {
    id: 'Angra Mainyu Level 150 Death Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '002D'
    },
    condition: conditions/* default.targetIsNotYou */.Z.targetIsNotYou(),
    response: responses/* Responses.awayFrom */.n3.awayFrom()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Angra Mainyu': 'Angra Mainyu'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Angra Mainyu': 'Angra Mainyu'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Angra Mainyu': 'アンラ・マンユ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Angra Mainyu': '安哥拉·曼纽'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Angra Mainyu': '앙그라 마이뉴'
    }
  }]
};
/* harmony default export */ const the_world_of_darkness = (the_world_of_darkness_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/amdapor_keep.ts


const amdapor_keep_triggerSet = {
  id: 'AmdaporKeep',
  zoneId: zone_id/* default.AmdaporKeep */.Z.AmdaporKeep,
  triggers: [{
    id: 'Amdapor Keep Liquefy Middle',
    type: 'StartsUsing',
    netRegex: {
      id: '415',
      source: 'Demon Wall',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'Amdapor Keep Liquefy Sides',
    type: 'StartsUsing',
    netRegex: {
      id: '416',
      source: 'Demon Wall',
      capture: false
    },
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'Amdapor Keep Repel',
    type: 'StartsUsing',
    netRegex: {
      id: '417',
      source: 'Demon Wall',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Demon Wall': 'Dämonenwand'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Demon Wall': 'mur démonique'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Demon Wall': 'デモンズウォール'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Demon Wall': '恶魔墙'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Demon Wall': '악마의 벽'
    }
  }]
};
/* harmony default export */ const amdapor_keep = (amdapor_keep_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/amdapor_keep_hard.ts



const amdapor_keep_hard_triggerSet = {
  id: 'AmdaporKeepHard',
  zoneId: zone_id/* default.AmdaporKeepHard */.Z.AmdaporKeepHard,
  triggers: [{
    id: 'Amdapor Keep Hard Entrance',
    type: 'StartsUsing',
    netRegex: {
      id: 'C65',
      source: 'Boogyman',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Amdapor Keep Hard Boss2 Headmarker on YOU',
    type: 'HeadMarker',
    netRegex: {
      id: '000F'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Behind Statue',
        de: 'Geh hinter die Statue',
        fr: 'Cachez vous derriere une statue',
        cn: '躲在雕像后',
        ko: '조각상 뒤에 숨기'
      }
    }
  }, {
    id: 'Amdapor Keep Hard Invisible',
    type: 'StartsUsing',
    netRegex: {
      id: 'C63',
      source: 'Boogyman',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill luminescence and stay close to boss',
        de: 'Besiege die Photosphäre und steh nahe am Boss',
        fr: 'Tuez la Luminescence et restez près du boss',
        cn: '击杀幻光球, 靠近BOSS',
        ko: '빛구슬을 잡고 보스와 가까이 붙기'
      }
    }
  }, {
    id: 'Amdapor Keep Hard Imobilize',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['29B', '260'],
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Boogyman': 'Butzemann'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Boogyman': 'croque-mitaine'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Boogyman': 'ボギーマン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Boogyman': '夜魔人'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Boogyman': '부기맨'
    }
  }]
};
/* harmony default export */ const amdapor_keep_hard = (amdapor_keep_hard_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/aurum_vale.ts


const aurum_vale_triggerSet = {
  id: 'TheAurumVale',
  zoneId: zone_id/* default.TheAurumVale */.Z.TheAurumVale,
  triggers: [{
    id: 'Aurum Vale GoldLungs/Burrs',
    type: 'GainsEffect',
    // Count `0[2-9]` here is to filter out the first stack
    netRegex: {
      effectId: ['12E', '12F'],
      count: '0[2-9]'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Eat Fruit',
        de: 'Frucht essen',
        fr: 'Mangez un fruit',
        cn: '吃果实',
        ko: '열매 먹기'
      }
    }
  }]
};
/* harmony default export */ const aurum_vale = (aurum_vale_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/brayfloxs_longstop.ts


const brayfloxs_longstop_triggerSet = {
  id: 'BrayfloxsLongstop',
  zoneId: zone_id/* default.BrayfloxsLongstop */.Z.BrayfloxsLongstop,
  initData: () => {
    return {
      pelicanPoisons: []
    };
  },
  triggers: [{
    id: 'Brayflox Normal Numbing Breath',
    type: 'StartsUsing',
    netRegex: {
      id: '1FA',
      source: 'Great Yellow Pelican'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun('info')
  }, {
    id: 'Brayflox Normal Pelican Poison Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: '12'
    },
    condition: data => data.CanCleanse(),
    run: (data, matches) => data.pelicanPoisons.push(matches.target)
  }, {
    id: 'Brayflox Normal Pelican Poison Healer',
    type: 'GainsEffect',
    netRegex: {
      effectId: '12',
      capture: false
    },
    condition: data => data.CanCleanse(),
    delaySeconds: 1,
    suppressSeconds: 2,
    alertText: (data, _matches, output) => {
      const names = data.pelicanPoisons.sort();
      if (names.length === 1 && names[0] === data.me) return output.esunaYourPoison();
      return output.esunaPoisonOn({
        players: names.map(x => data.party.member(x))
      });
    },
    run: data => data.pelicanPoisons = [],
    outputStrings: {
      esunaYourPoison: {
        en: 'Esuna Your Poison',
        de: 'Entferne dein Gift',
        fr: 'Purifiez-vous du poison',
        ja: '自分の毒をエスナ',
        cn: '康复自己的毒',
        ko: '독 에스나 하기'
      },
      esunaPoisonOn: {
        en: 'Esuna Poison on ${players}',
        de: 'Entferne Gift von ${players}',
        fr: 'Purifiez le poison sur ${players}',
        ja: '${players}の毒をエスナ',
        cn: '康复${players}',
        ko: '"${players}" 독 에스나'
      }
    }
  }, {
    // Pelican Adds
    // Only parsing for Sable Back since there is at least 1 Sable Back in each spawn pack.
    // The pack with the boss is 3 Violet Backs, not parsing for them prevents the trigger
    // from activating early when you pick up the Headgate Key and the boss and adds spawn.
    id: 'Brayflox Normal Pelican Adds',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '1283',
      capture: false
    },
    suppressSeconds: 2,
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'Brayflox Normal Ashdrake Burning Cyclone',
    type: 'StartsUsing',
    netRegex: {
      id: '205',
      source: 'Ashdrake'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun('info')
  }, {
    // Tempest Biast Spawn
    id: 'Brayflox Normal Tempest Biast',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '1285',
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'Brayflox Normal Inferno Drake Burning Cyclone',
    type: 'StartsUsing',
    netRegex: {
      id: '3D8',
      source: 'Inferno Drake'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun('info')
  }, {
    // Hellbender Bubble
    id: 'Brayflox Normal Hellbender Effluvium',
    type: 'Ability',
    netRegex: {
      id: '3D3',
      source: 'Hellbender'
    },
    infoText: (data, matches, output) => {
      if (matches.target !== data.me) return output.breakBubbleOn({
        player: data.party.member(matches.target)
      });
      if (matches.target === data.me) return output.breakYourBubble();
    },
    outputStrings: {
      breakBubbleOn: {
        en: 'Break Bubble on ${player}',
        de: 'Besiege die Blase von ${player}',
        fr: 'Brisez la bulle de ${player}',
        ja: '${player}の泡を破れ',
        cn: '打${player}的泡泡',
        ko: '"${player}" 물구슬 깨기'
      },
      breakYourBubble: {
        en: 'Break Your Bubble',
        de: 'Besiege deine Blase',
        fr: 'Brisez votre bulle',
        ja: '自分の泡を破れ',
        cn: '打自己的泡泡',
        ko: '물구슬 깨기'
      }
    }
  }, {
    // Stunnable Line Attack
    id: 'Brayflox Normal Aiatar Dragon Breath',
    type: 'StartsUsing',
    netRegex: {
      id: '22F',
      source: 'Aiatar'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun('info')
  }, {
    // Move Aiatar out of Puddles
    id: 'Brayflox Normal Aiatar Toxic Vomit Tank',
    type: 'GainsEffect',
    netRegex: {
      effectId: '117',
      capture: false
    },
    condition: data => data.role === 'tank',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move Boss Out of Puddles',
        de: 'Bewege den Boss aus der Fläche',
        fr: 'Déplacez le boss hors des zones au sol',
        ja: 'ボスを円範囲の外に',
        cn: '把BOSS拉出圈圈',
        ko: '장판에 보스가 닿지 않게 하기'
      }
    }
  }, {
    // Healer Esuna Poison.
    // This triggers on both Salivous Snap and Puddle Poison Application
    id: 'Brayflox Normal Aiatar Poison Healer',
    type: 'GainsEffect',
    netRegex: {
      effectId: '113'
    },
    condition: data => data.CanCleanse(),
    alertText: (data, matches, output) => {
      if (matches.target !== data.me) return output.esunaPoisonOn({
        player: data.party.member(matches.target)
      });
      return output.esunaYourPoison();
    },
    outputStrings: {
      esunaPoisonOn: {
        en: 'Esuna Poison on ${player}',
        de: 'Entferne Gift von ${player}',
        fr: 'Purifiez le poison sur ${player}',
        ja: '${player}の毒をエスナ',
        cn: '康复${player}的毒',
        ko: '"${player}" 독 에스나'
      },
      esunaYourPoison: {
        en: 'Esuna Your Poison',
        de: 'Entferne dein Gift',
        fr: 'Purifiez-vous du poison',
        ja: '自分の毒をエスナ',
        cn: '康复自己的毒',
        ko: '독 에스나 하기'
      }
    }
  }, {
    id: 'Brayflox Normal Aiatar Salivous Snap',
    type: 'StartsUsing',
    netRegex: {
      id: '6FF3',
      source: 'Aiatar'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aiatar': 'Aiatar',
      'Ashdrake': 'Asch-Drakon',
      'Great Yellow Pelican': 'Großer Gelbpelikan',
      'Hellbender': 'Höllenkrümmer',
      'Inferno Drake': 'Sonnen-Drakon'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aiatar': 'Aiatar',
      'Ashdrake': 'draconide des cendres',
      'Great Yellow Pelican': 'grand pélican jaune',
      'Hellbender': 'ménopome',
      'Inferno Drake': 'draconide des brasiers'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aiatar': 'アイアタル',
      'Ashdrake': 'アッシュドレイク',
      'Great Yellow Pelican': 'グレート・イエローペリカン',
      'Hellbender': 'ヘルベンダー',
      'Inferno Drake': 'インフェルノドレイク'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aiatar': '阿杰特',
      'Ashdrake': '白烬火蛟',
      'Great Yellow Pelican': '大黄鹈鹕',
      'Hellbender': '水栖蝾螈',
      'Inferno Drake': '狱炎火蛟'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aiatar': '아이아타르',
      'Ashdrake': '잿빛도마뱀',
      'Great Yellow Pelican': '노란 왕사다새',
      'Hellbender': '장수도롱뇽',
      'Inferno Drake': '지옥불 도마뱀'
    }
  }]
};
/* harmony default export */ const brayfloxs_longstop = (brayfloxs_longstop_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/cutters_cry.ts


const cutters_cry_triggerSet = {
  id: 'CuttersCry',
  zoneId: zone_id/* default.CuttersCry */.Z.CuttersCry,
  triggers: [{
    id: 'Chimera Ram Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '450',
      source: 'Chimera',
      capture: false
    },
    response: responses/* Responses.outOfMelee */.n3.outOfMelee()
  }, {
    id: 'Chimera Dragon Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '5A2',
      source: 'Chimera',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Chimera': 'Chimära'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Chimera': 'Chimère'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Chimera': 'キマイラ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Chimera': '奇美拉'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Chimera': '키마이라'
    }
  }]
};
/* harmony default export */ const cutters_cry = (cutters_cry_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/halatali_hard.ts

const halatali_hard_triggerSet = {
  id: 'HalataliHard',
  zoneId: zone_id/* default.HalataliHard */.Z.HalataliHard,
  triggers: [{
    id: 'Hataliti Hard Demon Eye',
    type: 'StartsUsing',
    netRegex: {
      id: '833',
      source: 'Catoblepas',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Use the Orb',
        de: 'Orb benutzen',
        fr: 'Utilisez l\'Orbe',
        cn: '使用幽暗珠',
        ko: '구슬 사용하기'
      }
    }
  }, {
    id: 'Hataliti Hard Standstill',
    type: 'StartsUsing',
    netRegex: {
      id: '84F',
      source: 'Mumuepo the Beholden',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Use the Nail',
        de: 'Nagel benutzen',
        fr: 'Utilisez L\'Épine',
        cn: '使用咒具',
        ko: '주술도구 사용하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Catoblepas': 'Catblepus',
      'Mumuepo the Beholden': 'Ex-Bischof Mumuepo '
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Catoblepas': 'catoblépas',
      'Mumuepo the Beholden': 'Mumuepo le prêtre déchu'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Catoblepas': 'カトブレパス',
      'Mumuepo the Beholden': '廃司教 ムムエポ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Catoblepas': '卡托布莱帕斯',
      'Mumuepo the Beholden': '退位主教 穆穆埃珀'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Catoblepas': '카토블레파스',
      'Mumuepo the Beholden': '폐주교 무무에포'
    }
  }]
};
/* harmony default export */ const halatali_hard = (halatali_hard_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/haukke_manor.ts



const haukke_manor_triggerSet = {
  id: 'HaukkeManor',
  zoneId: zone_id/* default.HaukkeManor */.Z.HaukkeManor,
  triggers: [{
    id: 'Haukke Normal Dark Mist Stun',
    type: 'StartsUsing',
    netRegex: {
      id: '2C1',
      source: ['Manor Maidservant', 'Manor Claviger', 'Lady Amandine']
    },
    condition: data => data.CanStun(),
    suppressSeconds: 2,
    response: responses/* Responses.stun */.n3.stun('info')
  }, {
    id: 'Haukke Normal Steward Soul Drain Stun',
    type: 'StartsUsing',
    netRegex: {
      id: '35C',
      source: 'Manor Steward'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun('info')
  }, {
    // Particle and spell effects make this particular Dark Mist hard to see.
    id: 'Haukke Normal Amandine Dark Mist Dodge',
    type: 'StartsUsing',
    netRegex: {
      id: '2C1',
      source: 'Lady Amandine',
      capture: false
    },
    condition: data => !data.CanStun(),
    response: responses/* Responses.outOfMelee */.n3.outOfMelee('alert')
  }, {
    id: 'Haukke Normal Amandine Void Fire III',
    type: 'StartsUsing',
    netRegex: {
      id: '356',
      source: 'Lady Amandine'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt('info')
  }, {
    id: 'Haukke Normal Amandine Void Thunder III',
    type: 'StartsUsing',
    netRegex: {
      id: '358',
      source: 'Lady Amandine'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.getBehind */.n3.getBehind('info')
  }, {
    // 2 Lady's Handmaiden and 1 Manor Sentry Spawn
    // The sentry outside the bosses room loads when you enter the zone.
    // This causes the trigger to go off early, parsing for the Handmaiden fixes the problem.
    // Suppression included since 2 Handmaiden's spawn at the same time
    id: 'Haukke Normal Ladys Handmaiden',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '424',
      capture: false
    },
    suppressSeconds: 2,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Sentry',
        de: 'Wachposten besiegen',
        fr: 'Tuez la sentinelle',
        ja: '守衛を倒す',
        cn: '击杀守卫',
        ko: '경비원 죽이기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Manor Maidservant': 'Hausmädchen',
      'Manor Claviger': 'Herrenhaus-Schlüsselträgerin',
      'Lady Amandine': 'Lady Amandine',
      'Manor Steward': 'Seneschall'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Manor Maidservant': 'soubrette du manoir',
      'Manor Claviger': 'clavière du manoir',
      'Lady Amandine': 'dame Amandine',
      'Manor Steward': 'intendant du manoir',
      'The void lamps have begun emitting an eerie glow': 'La lanterne sinistre luit d\'un éclat lugubre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Manor Maidservant': '御用邸のメイド',
      'Manor Claviger': '夫人付きクラヴィジャー',
      'Lady Amandine': 'レディ・アマンディヌ',
      'Manor Steward': '御用邸の執事長'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Manor Maidservant': '庄园的女仆',
      'Manor Claviger': '随从女工',
      'Lady Amandine': '阿芒迪娜女士',
      'Manor Steward': '庄园的总管'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Manor Maidservant': '별궁의 하녀',
      'Manor Claviger': '부인의 청지기',
      'Lady Amandine': '레이디 아망딘',
      'Manor Steward': '별궁의 집사장'
    }
  }]
};
/* harmony default export */ const haukke_manor = (haukke_manor_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/haukke_manor_hard.ts


const haukke_manor_hard_triggerSet = {
  id: 'HaukkeManorHard',
  zoneId: zone_id/* default.HaukkeManorHard */.Z.HaukkeManorHard,
  triggers: [{
    id: 'Haukke Manor Hard Stoneskin',
    type: 'StartsUsing',
    netRegex: {
      id: '3F0',
      source: 'Manor Sentry'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Haukke Manor Hard Beguiling Mist',
    type: 'StartsUsing',
    netRegex: {
      id: '6B7',
      source: 'Halicarnassus'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Halicarnassus': 'Halikarnassos',
      'Manor Sentry': 'Wächter'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Halicarnassus': 'Halicarnasse',
      'Manor Sentry': 'vigile du manoir'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Halicarnassus': 'ハリカルナッソス',
      'Manor Sentry': '御用邸の石像'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Halicarnassus': '哈利卡纳苏斯',
      'Manor Sentry': '庄园的石像'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Halicarnassus': '할리카르나소스',
      'Manor Sentry': '별궁 석상'
    }
  }]
};
/* harmony default export */ const haukke_manor_hard = (haukke_manor_hard_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/hullbreaker_isle.ts


const hullbreaker_isle_triggerSet = {
  id: 'HullbreakerIsle',
  zoneId: zone_id/* default.HullbreakerIsle */.Z.HullbreakerIsle,
  triggers: [{
    id: 'Hullbreaker Isle Stool Pelt',
    type: 'StartsUsing',
    netRegex: {
      id: '89E',
      source: 'Sasquatch',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hullbreaker Isle Chest Thump',
    type: 'Ability',
    netRegex: {
      id: '89F',
      source: 'Sasquatch',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Shake Banana tree',
        de: 'Bananenbaum schütteln',
        fr: 'Secouez le bananier',
        cn: '摇晃香蕉树',
        ko: '바나나 나무 사용하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Sasquatch': 'Sasquatch'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Sasquatch': 'Sasquatch'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Sasquatch': 'サスカッチ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Sasquatch': '大脚巨猿'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Sasquatch': '사스콰치'
    }
  }]
};
/* harmony default export */ const hullbreaker_isle = (hullbreaker_isle_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/pharos_sirius.ts



const pharos_sirius_triggerSet = {
  id: 'PharosSirius',
  zoneId: zone_id/* default.PharosSirius */.Z.PharosSirius,
  triggers: [{
    id: 'Pharos Sirius Deathly Cadenza',
    type: 'StartsUsing',
    netRegex: {
      id: '5CF',
      source: 'Siren',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Pharos Sirius Feral Lunge',
    type: 'StartsUsing',
    netRegex: {
      id: '5CC',
      source: 'Siren',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Pharos Sirius Corrupted Crystal',
    type: 'GainsEffect',
    netRegex: {
      effectId: '176',
      count: '03'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread: Stacks Explode Soon',
        de: 'Verteilen: Kristallstacks explodieren bald',
        fr: 'Écartez-vous : les cristaux vont exploser',
        cn: '散开: 即将爆炸',
        ko: '산개: 곧 크리스탈 폭발'
      }
    }
  }, {
    // Not 100% sure if there's a better way to handle the callout
    id: 'Pharos Sirius Doom',
    type: 'GainsEffect',
    netRegex: {
      effectId: '172'
    },
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.target)
    }),
    outputStrings: {
      text: {
        en: 'Heal ${player} to full',
        de: 'Heile ${player} voll',
        fr: 'Soin complet sur ${player}',
        cn: '奶满${player}',
        ko: '완전 회복: ${player}'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Siren': 'Sirene'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Siren': 'sirène'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Siren': 'セイレーン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Siren': '塞壬'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Siren': '세이렌'
    }
  }]
};
/* harmony default export */ const pharos_sirius = (pharos_sirius_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/sastasha_hard.ts


const sastasha_hard_triggerSet = {
  id: 'SastashaHard',
  zoneId: zone_id/* default.SastashaHard */.Z.SastashaHard,
  triggers: [{
    id: 'Sastasha Hard Slime',
    type: 'GainsEffect',
    netRegex: {
      effectId: '239'
    },
    condition: data => data.CanCleanse(),
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.target)
    }),
    outputStrings: {
      text: {
        en: 'Esuna ${player}',
        de: 'Medica ${player}',
        fr: 'Guérison sur ${player}',
        ja: '${player} にエスナ',
        cn: '驱散: ${player}',
        ko: '${player} 에스나'
      }
    }
  }, {
    id: 'Sastasha Hard Tail Screw',
    type: 'StartsUsing',
    netRegex: {
      id: 'BF4',
      source: 'Karlabos'
    },
    alertText: (data, matches, output) => {
      if (data.CanStun()) return output.stun({
        name: matches.source
      });
    },
    infoText: (data, matches, output) => {
      return output.tailScrewOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      stun: outputs/* default.stunTarget */.Z.stunTarget,
      tailScrewOn: {
        en: 'Tail Screw on ${player}',
        de: 'Schweifschraube auf ${player}',
        fr: 'Coup de queue sur ${player}',
        cn: '螺旋尾点${player}',
        ko: '${player} 꼬리 후려치기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Karlabos': 'Karlabos'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Karlabos': 'Karlabos'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Karlabos': 'カーラボス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Karlabos': '真红龙虾'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Karlabos': '칼라보스'
    }
  }]
};
/* harmony default export */ const sastasha_hard = (sastasha_hard_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/snowcloak.ts

const snowcloak_triggerSet = {
  id: 'Snowcloak',
  zoneId: zone_id/* default.Snowcloak */.Z.Snowcloak,
  triggers: [{
    id: 'Snowcloak Lunar Cry',
    type: 'StartsUsing',
    netRegex: {
      id: 'C1F',
      source: 'Fenrir',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide behind Ice',
        de: 'Hinter dem Eis verstecken',
        fr: 'Cachez vous derrière un pilier de glace',
        cn: '躲在冰柱后',
        ko: '얼음 뒤에 숨기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Fenrir': 'Fenrir'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Fenrir': 'Fenrir'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Fenrir': 'フェンリル'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Fenrir': '芬里尔'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Fenrir': '펜리르'
    }
  }]
};
/* harmony default export */ const snowcloak = (snowcloak_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/the_lost_city_of_amdapor.ts



const the_lost_city_of_amdapor_triggerSet = {
  id: 'TheLostCityOfAmdapor',
  zoneId: zone_id/* default.TheLostCityOfAmdapor */.Z.TheLostCityOfAmdapor,
  triggers: [{
    id: 'Lost City Amdapor Devour',
    type: 'Ability',
    netRegex: {
      id: '736',
      source: 'Chudo-Yudo',
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'Lost City Amdapor Graviball',
    type: 'StartsUsing',
    netRegex: {
      id: '762',
      source: 'Diabolos'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Puddle Outside',
        de: 'Fläche draußen ablegen',
        fr: 'Déposez les flaques à l\'extérieur',
        cn: '远离放置圈圈',
        ko: '바깥쪽으로 장판 유도하기'
      }
    }
  }, {
    id: 'Lost City Amdapor Ultimate Terror',
    type: 'StartsUsing',
    netRegex: {
      id: '766',
      source: 'Diabolos',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Chudo-Yudo': 'Chudo-Yudo',
      'Diabolos': 'Diabolos'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Chudo-Yudo': 'Chudo-Yudo',
      'Diabolos': 'Diabolos'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Chudo-Yudo': 'チョドーユドー',
      'Diabolos': 'ディアボロス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Chudo-Yudo': '丘都尤都',
      'Diabolos': '迪亚波罗斯'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Chudo-Yudo': '추도유도',
      'Diabolos': '디아볼로스'
    }
  }]
};
/* harmony default export */ const the_lost_city_of_amdapor = (the_lost_city_of_amdapor_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/the_stone_vigil.ts


const the_stone_vigil_triggerSet = {
  id: 'TheStoneVigil',
  zoneId: zone_id/* default.TheStoneVigil */.Z.TheStoneVigil,
  triggers: [{
    id: 'Stone Vigil Swinge',
    type: 'StartsUsing',
    netRegex: {
      id: '387',
      source: 'Chudo-Yudo',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Chudo-Yudo': 'Chudo-Yudo'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Chudo-Yudo': 'Chudo-Yudo'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Chudo-Yudo': 'チョドーユドー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Chudo-Yudo': '丘都尤都'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Chudo-Yudo': '추도유도'
    }
  }]
};
/* harmony default export */ const the_stone_vigil = (the_stone_vigil_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/the_stone_vigil_hard.ts


const the_stone_vigil_hard_triggerSet = {
  id: 'TheStoneVigilHard',
  zoneId: zone_id/* default.TheStoneVigilHard */.Z.TheStoneVigilHard,
  triggers: [{
    id: 'Stone Vigil Hard Swinge',
    type: 'StartsUsing',
    netRegex: {
      id: '8F7',
      source: 'Gorynich',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Stone Vigil Hard Lion\'s Breath',
    type: 'StartsUsing',
    netRegex: {
      id: '8F6',
      source: 'Gorynich',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Stone Vigil Hard Rake',
    type: 'StartsUsing',
    netRegex: {
      id: '8F5',
      source: 'Gorynich'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Gorynich': 'Gorynich'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Gorynich': 'Gorynich'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Gorynich': 'ゴリニチ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Gorynich': '格里尼奇恶龙'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Gorynich': '고리니치'
    }
  }]
};
/* harmony default export */ const the_stone_vigil_hard = (the_stone_vigil_hard_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/the_sunken_temple_of_quarn.ts


const the_sunken_temple_of_quarn_triggerSet = {
  id: 'TheSunkenTempleOfQarn',
  zoneId: zone_id/* default.TheSunkenTempleOfQarn */.Z.TheSunkenTempleOfQarn,
  triggers: [{
    id: 'Sunken Quarn Doom',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D2'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Step on Glowing Plate',
        de: 'Auf der leuchtende Platte stehen',
        fr: 'Marchez sur la plaque qui brille',
        cn: '踩发光地板',
        ko: '빛나는 발판 밟기'
      }
    }
  }]
};
/* harmony default export */ const the_sunken_temple_of_quarn = (the_sunken_temple_of_quarn_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/the_sunken_temple_of_quarn_hard.ts


const the_sunken_temple_of_quarn_hard_triggerSet = {
  id: 'TheSunkenTempleOfQarnHard',
  zoneId: zone_id/* default.TheSunkenTempleOfQarnHard */.Z.TheSunkenTempleOfQarnHard,
  triggers: [{
    id: 'Sunken Quarn Hard Light of Anathema',
    type: 'StartsUsing',
    netRegex: {
      id: 'C26',
      source: 'Vicegerent to the Warden',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Vicegerent to the Warden': 'Statthalter der Aufseherin'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Vicegerent to the Warden': 'adjoint de la Gardienne'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Vicegerent to the Warden': 'アーゼマヴァイスジェレント'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Vicegerent to the Warden': '审理神代言者'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Vicegerent to the Warden': '아제마 교황'
    }
  }]
};
/* harmony default export */ const the_sunken_temple_of_quarn_hard = (the_sunken_temple_of_quarn_hard_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/the_tam_tara_depocraft_hard.ts

const the_tam_tara_depocraft_hard_triggerSet = {
  id: 'TheTamTaraDeepcroftHard',
  zoneId: zone_id/* default.TheTamTaraDeepcroftHard */.Z.TheTamTaraDeepcroftHard,
  triggers: [{
    id: 'Tam-Tara Hard Inhumanity',
    type: 'Ability',
    netRegex: {
      id: '956',
      source: 'Liavinne',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack (ignore adds)',
        de: 'Sammeln (Adds ignorieren)',
        fr: 'Packez-vous: ne tuez pas les Adds',
        cn: '集合 (忽略小怪)',
        ko: '모이기 (쫄은 무시)'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Liavinne': 'Liavinne'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Liavinne': 'Liavinne la dame d\'honneur'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Liavinne': '立会人リアヴィヌ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Liavinne': '证婚人 莉亚维娜'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Liavinne': '입회인 리아빈'
    }
  }]
};
/* harmony default export */ const the_tam_tara_depocraft_hard = (the_tam_tara_depocraft_hard_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/dungeon/the_wanderers_palace_hard.ts


const the_wanderers_palace_hard_triggerSet = {
  id: 'TheWanderersPalaceHard',
  zoneId: zone_id/* default.TheWanderersPalaceHard */.Z.TheWanderersPalaceHard,
  triggers: [{
    id: 'Wanderer\'s Palace Hard Firespit',
    type: 'StartsUsing',
    netRegex: {
      id: 'C91',
      source: 'Slithy Zolool Ja'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    // Not 100% sure if there's a better way to handle the callout
    id: 'Wanderer\'s Palace Hard Doom',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D2'
    },
    alertText: (data, matches, output) => output.text({
      player: data.party.member(matches.target)
    }),
    outputStrings: {
      text: {
        en: 'Heal ${player} to full',
        de: 'Heile ${player} voll',
        fr: 'Soin complet sur ${player}',
        cn: '奶满${player}',
        ko: '완전 회복: ${player}'
      }
    }
  }, {
    id: 'Wanderer\'s Palace Hard Soul Douse',
    type: 'StartsUsing',
    netRegex: {
      id: 'C9E',
      source: 'Slithy Zolool Ja',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Slithy Zolool Ja': 'Zolool Ja'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Slithy Zolool Ja': 'Zolool Ja'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Slithy Zolool Ja': '濡肌のゾルージャ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Slithy Zolool Ja': '湿皮妖师 佐尔加'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Slithy Zolool Ja': '축축한 졸루쟈'
    }
  }]
};
/* harmony default export */ const the_wanderers_palace_hard = (the_wanderers_palace_hard_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t1.ts



const t1_triggerSet = {
  id: 'TheBindingCoilOfBahamutTurn1',
  zoneId: zone_id/* default.TheBindingCoilOfBahamutTurn1 */.Z.TheBindingCoilOfBahamutTurn1,
  initData: () => {
    return {
      started: false
    };
  },
  triggers: [{
    id: 'T1 High Voltage',
    type: 'StartsUsing',
    netRegex: {
      source: 'Ads',
      id: '5A7'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    // Indiscriminate Hood Swing
    id: 'T1 Initiated',
    type: 'Ability',
    netRegex: {
      source: 'Caduceus',
      id: '4B8.*?',
      capture: false
    },
    run: data => data.started = true
  }, {
    id: 'T1 Regorge',
    type: 'Ability',
    netRegex: {
      source: 'Caduceus',
      id: '4BA'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spit on YOU',
        de: 'Spucke auf DIR',
        fr: 'Crachat sur VOUS',
        ja: '自分にリゴージ',
        cn: '吐痰点名',
        ko: '나에게 침뱉기'
      }
    }
  }, {
    id: 'T1 Split',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Caduceus',
      capture: false
    },
    condition: data => data.started,
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Split',
        de: 'Teilen',
        fr: 'Division',
        ja: '分裂',
        cn: '分裂',
        ko: '분열'
      }
    }
  }, {
    id: 'T1 Hood Swing',
    type: 'Ability',
    netRegex: {
      source: 'Caduceus',
      id: '4B8'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 8,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hood Swing in 10',
        de: 'Kapuzenschwung in 10',
        fr: 'Coup de capot dans 10s',
        ja: '十秒以内タンクバスター',
        cn: '10秒内死刑',
        ko: '10초 이내에 머리 휘두르기'
      }
    }
  }, {
    id: 'T1 Slime Timer First',
    type: 'SystemLogMessage',
    // The Allagan megastructure will be sealed off
    netRegex: {
      id: '7DC',
      param1: '379',
      capture: false
    },
    delaySeconds: 35,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Slime Soon',
        de: 'Schleim bald',
        fr: 'Gluant bientôt',
        ja: 'まもなくスライム',
        cn: '软泥即将出现',
        ko: '곧 슬라임'
      }
    }
  }, {
    id: 'T1 Slime Timer',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Dark Matter Slime',
      capture: false
    },
    delaySeconds: 35,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Slime Soon',
        de: 'Schleim bald',
        fr: 'Gluant bientôt',
        ja: 'まもなくスライム',
        cn: '软泥即将出现',
        ko: '곧 슬라임'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Ads': 'Abwehrsystem',
      'Caduceus': 'Caduceus',
      'Dark Matter Slime': 'Dunkelmaterien-Schleim',
      'The Allagan megastructure': 'Allagische Superstruktur'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ads': 'Sphère De Contrôle',
      'Caduceus': 'Caducée',
      'Dark Matter Slime': 'Gluant De Matière Sombre',
      'The Allagan megastructure': 'Mégastructure allagoise'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ads': '制御システム',
      'Caduceus': 'カドゥケウス',
      'Dark Matter Slime': 'ダークマター・スライム',
      'The Allagan megastructure': 'アラグの遺構'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ads': '自卫系统',
      'Caduceus': '神杖巨蛇',
      'Dark Matter Slime': '暗物质粘液怪',
      'The Allagan megastructure': '亚拉戈遗构'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ads': '제어 시스템',
      'Caduceus': '카두케우스',
      'Dark Matter Slime': '암흑물질 슬라임',
      'The Allagan megastructure': '알라그 유적'
    }
  }]
};
/* harmony default export */ const t1 = (t1_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t10.ts


const t10_triggerSet = {
  id: 'TheFinalCoilOfBahamutTurn1',
  zoneId: zone_id/* default.TheFinalCoilOfBahamutTurn1 */.Z.TheFinalCoilOfBahamutTurn1,
  timelineFile: 't10.txt',
  triggers: [{
    id: 'T10 Phase Change',
    type: 'StartsUsing',
    netRegex: {
      id: 'B5D',
      source: 'Imdugud',
      capture: false
    },
    sound: 'Long'
  }, {
    id: 'T10 Heat Lightning',
    type: 'StartsUsing',
    netRegex: {
      id: 'B5F',
      source: 'Imdugud',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'T10 Wild Charge',
    type: 'HeadMarker',
    netRegex: {
      id: '001F'
    },
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) return output.chargeOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return output.chargeOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      chargeOn: {
        en: 'Charge on ${player}',
        de: 'Ansturm auf ${player}',
        fr: 'Charge sur ${player}',
        ja: '${player}にワイルドチャージ',
        cn: '蓝球点${player}',
        ko: '"${player}" 돌진 대상'
      },
      chargeOnYou: {
        en: 'Charge on YOU',
        de: 'Ansturm auf DIR',
        fr: 'Charge sur VOUS',
        ja: '自分にワイルドチャージ',
        cn: '蓝球点名',
        ko: '돌진 대상자'
      }
    }
  }, {
    id: 'T10 Prey',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    response: responses/* Responses.preyOn */.n3.preyOn()
  }, {
    id: 'T10 Cyclonic Tether',
    type: 'Tether',
    netRegex: {
      id: '0015',
      source: 'Imdugud'
    },
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) return output.cyclonicOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return output.cyclonicOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      cyclonicOn: {
        en: 'Cyclonic on ${player}',
        de: 'Zyklon-Chaos auf ${player}',
        fr: 'Chaos cyclonique sur ${player}',
        ja: '${player}にサイクロニックカオス',
        cn: '连线点${player}',
        ko: '${player} 휘몰아치는 혼돈'
      },
      cyclonicOnYou: {
        en: 'Cyclonic on YOU',
        de: 'Zyklon-Chaos auf DIR',
        fr: 'Chaos cyclonique sur VOUS',
        ja: '自分にサイクロニックカオス',
        cn: '连线点名',
        ko: '휘몰아치는 혼돈 대상자'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Imdugud': 'Imdugud',
      'The Alpha Concourse': 'Alpha-Emergenzzone'
    },
    'replaceText': {
      'Crackle Hiss': 'Knisterndes Fauchen',
      'Critical Rip': 'Kritischer Riss',
      'Cyclonic Chaos': 'Zyklon-Chaos',
      'Daughter': 'Tochter',
      'Electric Burst': 'Stromstoß',
      'Electrocharge': 'Elektro-Ladung',
      'Heat Lightning': 'Hitzeblitz',
      'Random \\+ Charge': 'Zufall + Wilde Rage',
      'Son': 'Sohn',
      'Spike Flail': 'Dornendresche',
      'Wild Charge': 'Wilde Rage'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Imdugud': 'Imdugud',
      'The Alpha Concourse': 'secteur des croyants'
    },
    'replaceText': {
      'Crackle Hiss': 'Crachat crépitant',
      'Critical Rip': 'Griffure critique',
      'Cyclonic Chaos': 'Chaos cyclonique',
      'Electric Burst': 'Salve électrique',
      'Electrocharge': 'Charge électrique',
      'Heat Lightning': 'Éclair de chaleur',
      'Random \\+ Charge': 'Aléatoire + Charge',
      '1x Son / 1x Daughter Adds': 'Adds 1x Fils / 1x Fille',
      '2x Son / 2x Daughter Adds': 'Adds 2x Fils / 2x Fille',
      'Spike Flail': 'Fléau à pointes',
      'Wild Charge': 'Charge sauvage'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Imdugud': 'イムドゥグド',
      'The Alpha Concourse': '第I信徒区画'
    },
    'replaceText': {
      'Crackle Hiss': 'クラックルヒス',
      'Critical Rip': 'クリティカルリップ',
      'Cyclonic Chaos': 'サイクロニックカオス',
      'Electric Burst': 'エレクトリックバースト',
      'Electrocharge': 'エレクトロチャージ',
      'Heat Lightning': 'ヒートライトニング',
      'Random \\+ Charge': 'ランダム + チャージ',
      '1x Son / 1x Daughter Adds': '雑魚: 1サン/1ドーター',
      '2x Son / 2x Daughter Adds': '雑魚: 2サン/2ドーター',
      'Spike Flail': 'スパイクフレイル',
      'Wild Charge': 'ワイルドチャージ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Imdugud': '伊姆都古德',
      'The Alpha Concourse': '第1信徒区间'
    },
    'replaceText': {
      'Crackle Hiss': '雷光电闪',
      'Critical Rip': '暴击撕裂',
      'Cyclonic Chaos': '龙卷雷暴',
      'Daughter': '伊姆都古德之女',
      'Electric Burst': '电光爆发',
      'Electrocharge': '蓄电',
      'Heat Lightning': '惊电',
      'Random \\+ Charge': '随机+冲锋',
      'Son': '伊姆都古德之子',
      'Spike Flail': '刃尾横扫',
      'Wild Charge': '狂野冲锋'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Imdugud': '임두구드',
      'The Alpha Concourse': '제I신도 구역'
    },
    'replaceText': {
      'Crackle Hiss': '파직파직 번개',
      'Critical Rip': '찢어가르기',
      'Cyclonic Chaos': '휘몰아치는 혼돈',
      'Electric Burst': '전하 폭발',
      'Electrocharge': '전하 충전',
      'Heat Lightning': '뜨거운 번개',
      'Spike Flail': '가시 매타작',
      'Wild Charge': '야성의 돌진',
      'Daughter': '딸',
      'Son': '아들',
      'Adds': '쫄',
      'Random \\+ Charge': '번개/혼돈 + 전하 충전'
    }
  }]
};
/* harmony default export */ const t10 = (t10_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t10.txt
const raid_t10_namespaceObject = "# Turn 10\r\n# -ii B5A B5C B60 B66 B68 B64 B59 B58 B65 B61 B57 -p B5D:200 B5E:500\r\n\r\n# Note: Use zone seal message instead of 0x104 line to start timeline\r\n# as there are pre-boss adds to start the encounter.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Initial Phase: Tankbuster, Charge, Repeat\r\n0.0 \"Start\"\r\n# Alpha Concourse will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"588\" } window 5,5\r\n8.0 \"Crackle Hiss\" Ability { id: \"B55\", source: \"Imdugud\" }\r\n16.0 \"Critical Rip\" Ability { id: \"B56\", source: \"Imdugud\" }\r\n20.0 \"Crackle Hiss\" Ability { id: \"B55\", source: \"Imdugud\" }\r\n32.0 \"Wild Charge\" Ability { id: \"B5B\", source: \"Imdugud\" } window 8,8\r\n36.0 \"Crackle Hiss\" Ability { id: \"B55\", source: \"Imdugud\" }\r\n51.0 \"Spike Flail\" #Ability { id: \"B57\", source: \"Imdugud\" }\r\n56.0 \"Crackle Hiss\" Ability { id: \"B55\", source: \"Imdugud\" }\r\n64.0 \"Critical Rip\" Ability { id: \"B56\", source: \"Imdugud\" } window 20,20 jump 20\r\n# fake lookahead loop\r\n68.0 \"Crackle Hiss\"\r\n80.0 \"Wild Charge\"\r\n84.0 \"Crackle Hiss\"\r\n89.0 \"Spike Flail\"\r\n\r\n# 85% push into Adds Phase #1\r\n196.0 \"--sync--\" StartsUsing { id: \"B5D\", source: \"Imdugud\" } window 200,0\r\n200.0 \"Electrocharge\" Ability { id: \"B5D\", source: \"Imdugud\" } window 200,0\r\n201.0 \"2x Son / 2x Daughter Adds\"\r\n\r\n# Mid Phase: Alternates Heat Lightning, Heat Lightning+Charge, Tankbuster, Repeat\r\n497.0 \"--sync--\" StartsUsing { id: \"B5E\", source: \"Imdugud\" } window 500,0\r\n500.0 \"Electric Burst\" Ability { id: \"B5E\", source: \"Imdugud\" } window 500,0\r\n509.2 \"Heat Lightning\" Ability { id: \"B5F\", source: \"Imdugud\" }\r\n528.1 \"Crackle Hiss\" Ability { id: \"B55\", source: \"Imdugud\" }\r\n535.2 \"Heat Lightning\" Ability { id: \"B5F\", source: \"Imdugud\" }\r\n541.9 \"Wild Charge\" Ability { id: \"B5B\", source: \"Imdugud\" } window 8,8\r\n545.3 \"Crackle Hiss\" Ability { id: \"B55\", source: \"Imdugud\" }\r\n558.3 \"Critical Rip\" Ability { id: \"B56\", source: \"Imdugud\" }\r\n561.5 \"Crackle Hiss\" Ability { id: \"B55\", source: \"Imdugud\" }\r\n# fake lookahead loop\r\n569.8 \"Heat Lightning\" Ability { id: \"B5F\", source: \"Imdugud\" } window 20,20 jump 509.2\r\n588.7 \"Crackle Hiss\"\r\n595.8 \"Heat Lightning\"\r\n602.5 \"Wild Charge\"\r\n\r\n# 53% push into Adds Phase #2\r\n696.0 \"--sync--\" StartsUsing { id: \"B5D\", source: \"Imdugud\" } window 200,0\r\n700.0 \"Electrocharge\" Ability { id: \"B5D\", source: \"Imdugud\" } window 400,0\r\n701.0 \"2x Son / 2x Daughter Adds\"\r\n736.0 \"1x Son / 1x Daughter Adds\"\r\n\r\n# Final Phase: Heat+Tether, Buster, Random Mechanic, Repeat\r\n997.0 \"--sync--\" StartsUsing { id: \"B5E\", source: \"Imdugud\" } window 400,0\r\n1000.0 \"Electric Burst\" Ability { id: \"B5E\", source: \"Imdugud\" } window 400,0\r\n\r\n1009.3 \"Heat Lightning\" Ability { id: \"B5F\", source: \"Imdugud\" }\r\n1013.5 \"Cyclonic Chaos\" Ability { id: \"B61\", source: \"Imdugud\" }\r\n1028.5 \"Crackle Hiss\" Ability { id: \"B55\", source: \"Imdugud\" }\r\n\r\n1035.8 \"Critical Rip\" Ability { id: \"B56\", source: \"Imdugud\" } window 20,20\r\n1042.0 \"Crackle Hiss\" Ability { id: \"B55\", source: \"Imdugud\" }\r\n\r\n# Heat + Charge, OR Tether + Charge\r\n1058.0 \"Random + Charge\"\r\n\r\n1061.2 \"Crackle Hiss\" Ability { id: \"B55\", source: \"Imdugud\" }\r\n1089.2 \"Heat Lightning\" Ability { id: \"B5F\", source: \"Imdugud\" } window 20,20 jump 1009.3\r\n1093.4 \"Cyclonic Chaos\"\r\n1108.4 \"Crackle Hiss\"\r\n1115.7 \"Critical Rip\"\r\n1121.9 \"Crackle Hiss\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t11.ts




const t11_triggerSet = {
  id: 'TheFinalCoilOfBahamutTurn2',
  zoneId: zone_id/* default.TheFinalCoilOfBahamutTurn2 */.Z.TheFinalCoilOfBahamutTurn2,
  timelineFile: 't11.txt',
  triggers: [{
    id: 'T11 Secondary Head',
    type: 'Ability',
    netRegex: {
      source: 'Kaliya',
      id: 'B73'
    },
    alertText: (data, matches, output) => {
      return output.text({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Stun on ${player}',
        de: 'Stun auf ${player}',
        fr: 'Stun sur ${player}',
        ja: '${player}にスタン',
        cn: '击昏${player}',
        ko: '"${player}" 기절'
      }
    }
  }, {
    id: 'T11 Seed River First',
    type: 'Ability',
    netRegex: {
      source: 'Kaliya',
      id: 'B74',
      capture: false
    },
    condition: data => data.firstSeed === undefined,
    response: responses/* Responses.spreadThenStack */.n3.spreadThenStack(),
    run: data => data.firstSeed = 'river'
  }, {
    id: 'T11 Seed Sea First',
    type: 'Ability',
    netRegex: {
      id: 'B75',
      source: 'Kaliya',
      capture: false
    },
    condition: data => data.firstSeed === undefined,
    response: responses/* Responses.stackThenSpread */.n3.stackThenSpread(),
    run: data => data.firstSeed = 'sea'
  }, {
    id: 'T11 Seed River Second',
    type: 'Ability',
    netRegex: {
      id: 'B76',
      source: 'Kaliya',
      capture: false
    },
    // FIXME: is this condition reversed?
    condition: data => data.firstSeed === undefined,
    response: responses/* Responses.stackMarker */.n3.stackMarker(),
    run: data => delete data.firstSeed
  }, {
    id: 'T11 Seed Sea Second',
    type: 'Ability',
    netRegex: {
      id: 'B77',
      source: 'Kaliya',
      capture: false
    },
    // FIXME: is this condition reversed?
    condition: data => data.firstSeed === undefined,
    response: responses/* Responses.spread */.n3.spread(),
    run: data => delete data.firstSeed
  }, {
    id: 'T11 Phase 2',
    type: 'Ability',
    // Barofield
    netRegex: {
      source: 'Kaliya',
      id: 'B6F'
    },
    condition: data => !data.beganMonitoringHp,
    preRun: data => data.beganMonitoringHp = true,
    promise: (_data, matches) => util/* default.watchCombatant */.Z.watchCombatant({
      ids: [parseInt(matches.sourceId, 16)]
    }, ret => {
      return ret.combatants.some(c => {
        return c.CurrentHP / c.MaxHP <= 0.60;
      });
    }),
    sound: 'Long',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out of Middle',
        de: 'Raus aus der Mitte',
        fr: 'Sortez du milieu',
        ja: '中央から離れる',
        cn: '离开中间',
        ko: '중앙에서 벗어나기'
      }
    }
  }, {
    id: 'T11 Forked Lightning',
    type: 'Ability',
    netRegex: {
      id: 'B85',
      source: 'Electric Node'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Lightning on YOU',
        de: 'Blitz auf DIR',
        fr: 'Éclair sur VOUS',
        ja: '自分にフォークライトニング',
        cn: '雷点名',
        ko: '갈래 번개 대상자'
      }
    }
  }, {
    id: 'T11 Phase 3',
    type: 'Ability',
    netRegex: {
      id: 'B78',
      source: 'Kaliya',
      capture: false
    },
    sound: 'Long',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Final Phase',
        de: 'Finale Phase',
        fr: 'Phase finale',
        ja: 'フェイス３',
        cn: 'P3',
        ko: '마지막 페이즈'
      }
    }
  }, {
    id: 'T11 Tether Accumulate A',
    type: 'Tether',
    netRegex: {
      id: '001C',
      target: 'Kaliya'
    },
    run: (data, matches) => {
      (data.tetherA ??= []).push(matches.source);
    }
  }, {
    id: 'T11 Tether Accumulate B',
    type: 'Tether',
    netRegex: {
      id: '001D',
      target: 'Kaliya'
    },
    run: (data, matches) => {
      (data.tetherB ??= []).push(matches.source);
    }
  }, {
    id: 'T11 Tether A',
    type: 'Tether',
    netRegex: {
      id: '001C',
      target: 'Kaliya',
      capture: false
    },
    condition: data => data.tetherA?.length === 2,
    alarmText: (data, _matches, output) => {
      let partner;
      const [player0, player1] = data.tetherA ?? [];
      if (player0 === undefined || player1 === undefined) return;
      if (player0 === data.me) partner = player1;
      if (player1 === data.me) partner = player0;
      if (partner === undefined) return;
      return output.text({
        player: data.party.member(partner)
      });
    },
    outputStrings: {
      text: {
        en: 'Red Tethers With ${player}',
        de: 'Rote Verbindung mit ${player}',
        fr: 'Liens rouges avec ${player}',
        ja: '${player}に赤い線',
        cn: '红线连${player}',
        ko: '"${player}"와 빨간 선'
      }
    }
  }, {
    id: 'T11 Tether B',
    type: 'Tether',
    netRegex: {
      id: '001D',
      target: 'Kaliya',
      capture: false
    },
    condition: data => data.tetherB?.length === 2,
    alarmText: (data, _matches, output) => {
      let partner;
      const [player0, player1] = data.tetherB ?? [];
      if (player0 === undefined || player1 === undefined) return;
      if (player0 === data.me) partner = player1;
      if (player1 === data.me) partner = player0;
      if (partner === undefined) return;
      return output.text({
        player: data.party.member(partner)
      });
    },
    outputStrings: {
      text: {
        en: 'Blue Tethers With ${player}',
        de: 'Blaue Verbindung mit ${player}',
        fr: 'Liens bleus avec ${player}',
        ja: '${player}に青い線',
        cn: '蓝线连${player}',
        ko: '"${player}"와 파랑 선'
      }
    }
  }, {
    id: 'T11 Tether Cleanup',
    type: 'Ability',
    netRegex: {
      id: 'B7B',
      source: 'Kaliya',
      capture: false
    },
    run: data => {
      delete data.tetherA;
      delete data.tetherB;
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Electric Node': 'Elektrisches Modul',
      'Kaliya': 'Kaliya',
      'The Core Override': 'Kern-Steuereinheit'
    },
    'replaceText': {
      'Barofield': 'Baro-Feld',
      'Emergency Mode': 'Notprogramm',
      'Main Head': 'Hauptkopf',
      'Nanospore Jet': 'Nanosporen-Strahl',
      'Nerve Cloud': 'Nervenwolke',
      'Nerve Gas': 'Nervengas',
      'Resonance': 'Resonanz',
      'Secondary Head': 'Nebenkopf',
      'Seed Of The Rivers/Sea': 'Samen der Flüsse/See',
      'Seed Of The Sea/Rivers': 'Samen der See/Flüsse',
      'Stun': 'Betäubung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Electric Node': 'Module d\'électrochoc',
      'Kaliya': 'Kaliya',
      'The Core Override': 'l\'unité de contrôle du Cœur'
    },
    'replaceText': {
      'Barofield': 'Barotraumatisme',
      'Emergency Mode': 'Mode d\'urgence',
      'Main Head': 'Tête principale',
      'Nanospore Jet': 'Jet de magismoparticules',
      'Nerve Cloud': 'Nuage neurotoxique',
      'Nerve Gas': 'Gaz neurotoxique',
      'Resonance': 'Résonance',
      'Secondary Head': 'Tête secondaire',
      'Seed Of The Rivers/Sea': 'Germe de la rivière/mer',
      'Seed Of The Sea/Rivers': 'Germe de la mer/rivière',
      'Stun': 'Étourdissement'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Electric Node': '雷撃システム',
      'Kaliya': 'カーリア',
      'The Core Override': 'コア制御区画'
    },
    'replaceText': {
      'Barofield': 'バロフィールド',
      'Emergency Mode': 'イマージャンシーモード',
      'Main Head': 'メインヘッド',
      'Nanospore Jet': '魔科学粒子散布',
      'Nerve Cloud': 'ナーブクラウド',
      'Nerve Gas': 'ナーブガス',
      'Resonance': 'レゾナンス',
      'Secondary Head': 'サブヘッド',
      'Seed Of The Rivers/Sea': 'シード・オブ・リバー / シード・オブ・シー',
      'Seed Of The Sea/Rivers': 'シード・オブ・シー / シード・オブ・リバー',
      'Stun': 'スタン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Electric Node': '雷击系统',
      'Kaliya': '卡利亚',
      'The Core Override': '核心控制区间'
    },
    'replaceText': {
      'Barofield': '气压领域',
      'Emergency Mode': '紧急模式',
      'Main Head': '主首',
      'Nanospore Jet': '魔科学粒子散布',
      'Nerve Cloud': '神经云',
      'Nerve Gas': '神经毒气',
      'Resonance': '共鸣',
      'Secondary Head': '侧首',
      'Seed Of The Rivers/Sea': '江河/海洋之种',
      'Seed Of The Sea/Rivers': '海洋/江河之种',
      'Stun': '眩晕'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Electric Node': '뇌격 시스템',
      'Kaliya': '칼리야',
      'The Core Override': '핵심 제어 구역'
    },
    'replaceText': {
      'Barofield': '압력 필드',
      'Emergency Mode': '비상 모드',
      'Main Head': '가운뎃머리',
      'Nanospore Jet': '마과학 입자 살포',
      'Nerve Cloud': '신경 구름',
      'Nerve Gas': '신경 가스',
      'Resonance': '공명',
      'Secondary Head': '옆 머리',
      'Seed Of The Rivers/Sea': '강/바다의 원천',
      'Seed Of The Sea/Rivers': '바다/강의 원천',
      'Stun': '기절'
    }
  }]
};
/* harmony default export */ const t11 = (t11_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t11.txt
const raid_t11_namespaceObject = "### Turn 11\r\n# -ii B70 B6A B75 B74 B80 B7C -p B6F:200 B78:600 B7A:1208\r\n\r\n# Note: Use zone seal message instead of 0x104 line to start timeline\r\n# as there are pre-boss adds to start the encounter.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1\r\n0.0 \"Start\"\r\n# Core Override will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"592\" } window 10,10\r\n9.4 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" } window 10,10\r\n\r\n19.7 \"Nerve Gas\"\r\n24.9 \"Nerve Gas\"\r\n30.1 \"Nerve Gas\"\r\n33.4 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n38.6 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n\r\n48.9 \"Nerve Gas\"\r\n54.1 \"Nerve Gas\"\r\n59.3 \"Nerve Gas\"\r\n62.6 \"Resonance\"\r\n67.8 \"Resonance\"\r\n\r\n### Phase 2 (90%)\r\n200.0 \"Barofield\" Ability { id: \"B6F\", source: \"Kaliya\" } window 200,0\r\n\r\n208.0 \"Seed Of The Sea/Rivers\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n213.3 \"Seed Of The Rivers/Sea\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n217.5 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n220.7 \"Secondary Head Stun\" Ability { id: \"B73\", source: \"Kaliya\" }\r\n225.8 \"Secondary Head\" Ability { id: \"B72\", source: \"Kaliya\" }\r\n226.9 \"Main Head\" Ability { id: \"B71\", source: \"Kaliya\" }\r\n231.1 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n237.4 \"Nerve Gas\"\r\n242.5 \"Nerve Gas\"\r\n247.5 \"Nerve Gas\"\r\n250.8 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n\r\n258.0 \"Seed Of The Sea/Rivers\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n263.3 \"Seed Of The Rivers/Sea\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n267.5 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" } window 10,10 jump 217.5\r\n270.7 \"Secondary Head Stun\"\r\n275.8 \"Secondary Head\"\r\n276.9 \"Main Head\"\r\n281.1 \"Resonance\"\r\n287.4 \"Nerve Gas\"\r\n292.5 \"Nerve Gas\"\r\n297.5 \"Nerve Gas\"\r\n300.8 \"Resonance\"\r\n\r\n### Phase 3 (60%)\r\n# TODO: does this enrage?\r\n\r\n\r\n### Phase 4 (nodes defeated)\r\n# this phase has different timings if you are soloing, sorry.\r\n# it's possible resonance timings are not reliable either.\r\n595.0 \"--sync--\" StartsUsing { id: \"B78\", source: \"Kaliya\" } window 600,600\r\n600.0 \"Emergency Mode\" Ability { id: \"B78\", source: \"Kaliya\" }\r\n\r\n606.1 \"Nerve Cloud\" Ability { id: \"B79\", source: \"Kaliya\" } window 100,100\r\n617.3 \"Nanospore Jet\" Ability { id: \"B7B\", source: \"Kaliya\" } window 50,50\r\n625.4 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n634.9 \"Seed Of The Sea/Rivers\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n639.7 \"Seed Of The Rivers/Sea\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n644.1 \"Nerve Gas\"\r\n649.2 \"Nerve Gas\"\r\n654.3 \"Nerve Gas\"\r\n658.6 \"Secondary Head Stun\" Ability { id: \"B73\", source: \"Kaliya\" }\r\n663.7 \"Secondary Head\" Ability { id: \"B72\", source: \"Kaliya\" }\r\n664.8 \"Main Head\" Ability { id: \"B71\", source: \"Kaliya\" }\r\n668.1 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n\r\n677.2 \"Nanospore Jet\" Ability { id: \"B7B\", source: \"Kaliya\" } window 50,50\r\n685.3 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n694.6 \"Seed Of The Sea/Rivers\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n699.6 \"Seed Of The Rivers/Sea\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n704.0 \"Nerve Gas\"\r\n709.0 \"Nerve Gas\"\r\n714.1 \"Nerve Gas\"\r\n718.4 \"Secondary Head Stun\" Ability { id: \"B73\", source: \"Kaliya\" }\r\n723.6 \"Secondary Head\" Ability { id: \"B72\", source: \"Kaliya\" }\r\n724.7 \"Main Head\" Ability { id: \"B71\", source: \"Kaliya\" }\r\n727.9 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n\r\n733.9 \"Nerve Cloud\" Ability { id: \"B79\", source: \"Kaliya\" } window 100,100\r\n745.1 \"Nanospore Jet\" Ability { id: \"B7B\", source: \"Kaliya\" } window 50,50\r\n756.2 \"Nerve Gas\"\r\n761.3 \"Nerve Gas\"\r\n766.4 \"Nerve Gas\"\r\n768.6 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n779.7 \"Seed Of The Sea/Rivers\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n784.8 \"Seed Of The Rivers/Sea\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n785.0 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n787.1 \"Secondary Head Stun\" Ability { id: \"B73\", source: \"Kaliya\" }\r\n792.2 \"Secondary Head\" Ability { id: \"B72\", source: \"Kaliya\" }\r\n793.3 \"Main Head\" Ability { id: \"B71\", source: \"Kaliya\" }\r\n\r\n804.7 \"Nanospore Jet\" Ability { id: \"B7B\", source: \"Kaliya\" } window 50,50\r\n815.9 \"Nerve Gas\"\r\n821.0 \"Nerve Gas\"\r\n826.1 \"Nerve Gas\"\r\n828.2 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n839.4 \"Seed Of The Sea/Rivers\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n844.5 \"Seed Of The Rivers/Sea\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n844.7 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n846.8 \"Secondary Head Stun\" Ability { id: \"B73\", source: \"Kaliya\" }\r\n851.9 \"Secondary Head\" Ability { id: \"B72\", source: \"Kaliya\" }\r\n853.0 \"Main Head\" Ability { id: \"B71\", source: \"Kaliya\" }\r\n\r\n861.3 \"Nerve Cloud\" Ability { id: \"B79\", source: \"Kaliya\" } window 100,100\r\n872.5 \"Nanospore Jet\" Ability { id: \"B7B\", source: \"Kaliya\" } window 50,50\r\n880.6 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n889.8 \"Seed Of The Sea/Rivers\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n894.7 \"Seed Of The Rivers/Sea\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n899.2 \"Nerve Gas\"\r\n904.4 \"Nerve Gas\"\r\n909.5 \"Nerve Gas\"\r\n913.7 \"Secondary Head Stun\" Ability { id: \"B73\", source: \"Kaliya\" }\r\n918.8 \"Secondary Head\" Ability { id: \"B72\", source: \"Kaliya\" }\r\n920.0 \"Main Head\" Ability { id: \"B71\", source: \"Kaliya\" }\r\n923.2 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n\r\n932.4 \"Nanospore Jet\" Ability { id: \"B7B\", source: \"Kaliya\" } window 50,50\r\n943.6 \"Nerve Gas\"\r\n948.7 \"Nerve Gas\"\r\n953.7 \"Nerve Gas\"\r\n955.8 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n967.0 \"Seed Of The Sea/Rivers\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n972.0 \"Seed Of The Rivers/Sea\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n972.2 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n974.3 \"Secondary Head\" Ability { id: \"B73\", source: \"Kaliya\" }\r\n979.4 \"Secondary Head\" Ability { id: \"B72\", source: \"Kaliya\" }\r\n980.5 \"Main Head\" Ability { id: \"B71\", source: \"Kaliya\" }\r\n\r\n988.8 \"Nerve Cloud\" Ability { id: \"B79\", source: \"Kaliya\" } window 100,100\r\n1000.0 \"Nanospore Jet\" Ability { id: \"B7B\", source: \"Kaliya\" } window 50,50\r\n1011.2 \"Nerve Gas\"\r\n1016.2 \"Nerve Gas\"\r\n1021.3 \"Nerve Gas\"\r\n1023.5 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n1034.7 \"Seed Of The Sea/Rivers\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n1039.7 \"Seed Of The Rivers/Sea\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n1039.9 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n1042.0 \"Secondary Head\" Ability { id: \"B73\", source: \"Kaliya\" }\r\n1047.1 \"Secondary Head\" Ability { id: \"B72\", source: \"Kaliya\" }\r\n1048.2 \"Main Head\" Ability { id: \"B71\", source: \"Kaliya\" }\r\n\r\n1059.6 \"Nanospore Jet\" Ability { id: \"B7B\", source: \"Kaliya\" } window 50,50\r\n1067.8 \"Resonance\" Ability { id: \"B6B\", source: \"Kaliya\" }\r\n1077.2 \"Seed Of The Sea/Rivers\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n1082.2 \"Seed Of The Rivers/Sea\" Ability { id: \"B7[67]\", source: \"Kaliya\" }\r\n1086.5 \"Nerve Gas\"\r\n1091.7 \"Nerve Gas\"\r\n1096.9 \"Nerve Gas\"\r\n\r\n\r\n### Phase 5 (enrage)\r\n1200.0 \"--sync--\" Ability { id: \"B7A\", source: \"Kaliya\" } window 1200,1200\r\n1208.0 \"Nerve Cloud Enrage\"\r\n1220.2 \"Nerve Cloud Enrage\"\r\n1232.4 \"Nerve Cloud Enrage\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t12.ts


const t12_triggerSet = {
  id: 'TheFinalCoilOfBahamutTurn3',
  zoneId: zone_id/* default.TheFinalCoilOfBahamutTurn3 */.Z.TheFinalCoilOfBahamutTurn3,
  timelineFile: 't12.txt',
  initData: () => {
    return {
      phase: 0
    };
  },
  triggers: [{
    id: 'T12 Phase 3',
    type: 'Ability',
    netRegex: {
      id: 'B96',
      source: 'Phoenix',
      capture: false
    },
    sound: 'Long',
    run: data => data.phase = 3
  }, {
    id: 'T12 Bennu',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Bennu',
      capture: false
    },
    condition: data => data.phase <= 2,
    delaySeconds: 55,
    durationSeconds: 4.5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bennu Soon',
        de: 'Bennu Add bald',
        fr: 'Bénou bientôt',
        ja: 'まもなくベンヌ',
        cn: '小鸟即将出现',
        ko: '곧 벤누 쫄'
      }
    }
  }, {
    id: 'T12 Revelation',
    type: 'StartsUsing',
    netRegex: {
      id: 'B87',
      source: 'Phoenix'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.revelationOnYou();
    },
    infoText: (data, matches, output) => {
      if (matches.target !== data.me) return output.awayFromPlayer({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      awayFromPlayer: {
        en: 'Away from ${player}',
        de: 'Weg von ${player}',
        fr: 'Éloignez-vous de ${player}',
        ja: '${player}から離れる',
        cn: '远离${player}',
        ko: '"${player}"에게서 멀어지기'
      },
      revelationOnYou: {
        en: 'Revelation on YOU',
        de: 'Offenbarung auf DIR',
        fr: 'Révélation sur VOUS',
        ja: '自分にリヴァレーション',
        cn: '天启点名',
        ko: '계시 대상자'
      }
    }
  }, {
    id: 'T12 Blackfire',
    type: 'StartsUsing',
    netRegex: {
      id: 'B8C',
      source: 'Phoenix',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Blackfire Spread',
        de: 'Schwarzfeuer verteilen',
        fr: 'Flamme noire, dispersez-vous',
        ja: '漆黒の炎、散開',
        cn: '黑火分散',
        ko: '칠흑의 불꽃 산개'
      }
    }
  }, {
    id: 'T12 Whitefire',
    type: 'HeadMarker',
    netRegex: {
      id: '0020'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Whitefire on YOU',
        de: 'Weißfeuer auf DIR',
        fr: 'Flamme blanche sur VOUS',
        ja: '自分に白熱の炎',
        cn: '白火点名',
        ko: '백열의 불꽃 대상자'
      }
    }
  }, {
    id: 'T12 Bluefire',
    type: 'HeadMarker',
    netRegex: {
      id: '0021'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bluefire Away',
        de: 'Blaufeuer wegbringen',
        fr: 'Flamme bleue, éloignez-vous',
        ja: '青碧の炎、離れる',
        cn: '蓝火远离',
        ko: '청벽의 불꽃 대상자'
      }
    }
  }, {
    // Chain Of Purgatory
    id: 'T12 Chain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '24D'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.chainOnYou();
    },
    infoText: (data, matches, output) => {
      if (matches.target !== data.me) return output.chainOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      chainOn: {
        en: 'Chain on ${player}',
        de: 'Kette auf ${player}',
        fr: 'Chaine sur ${player}',
        ja: '${player}に誘爆',
        cn: '毒点名${player}',
        ko: '"${player}" 사슬 대상'
      },
      chainOnYou: {
        en: 'Chain on YOU',
        de: 'Kette auf DIR',
        fr: 'Chaine sur VOUS',
        ja: '自分に誘爆',
        cn: '毒点名',
        ko: '사슬 대상자'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bennu': 'Bennu',
      'Phoenix(?!-)': 'Phönix',
      'Phoenix-Egi': 'Phönix-Egi'
    },
    'replaceText': {
      '(?<! )Rebirth': 'Wiedergeburt',
      'Bennu Add': 'Bennu Add',
      'Blackfire': 'Schwarzfeuer',
      'Bluefire': 'Blaufeuer',
      'Brand Of Purgatory': 'Zeichen der Läuterung',
      'Flames Of Rebirth': 'Flammen der Wiedergeburt',
      'Flames Of Unforgiveness': 'Zeichen der Läuterung',
      'Fountain Of Fire': 'Quell des Feuers',
      'Fountain(?! Of Fire)': 'Quell',
      'Redfire Plume': 'Rotfeuer-Feder',
      'Redfire(?! )': 'Rotfeuer',
      'Revelation': 'Offenbarung',
      'Scorched Pinion': 'Versengte Schwinge',
      'Summon': 'Beschwörung',
      'Whitefire': 'Weißfeuer'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bennu': 'Bénou',
      'Phoenix(?!-)': 'Phénix',
      'Phoenix-Egi': 'Phénix-Egi'
    },
    'replaceText': {
      '(?<! )Rebirth': 'Résurrection',
      'Bennu Add': 'Add Bénou',
      'Blackfire': 'Flamme noire',
      'Bluefire': 'Flamme bleue',
      'Brand Of Purgatory': 'Tison du purgatoire',
      'Flames Of Rebirth': 'Feu résurrecteur',
      'Flames Of Unforgiveness': 'Flammes du purgatoire',
      'Fountain Of Fire': 'Flamme de la vie',
      'Fountain Tick': 'Fontaine tick',
      'Redfire Plume': 'Panache rouge',
      'Redfire(?! )': 'Flambée rouge',
      'Revelation': 'Révélation',
      'Scorched Pinion': 'Aile embrasante',
      'Summon': 'Incidence',
      'Whitefire': 'Flamme blanche'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bennu': 'ベンヌ',
      'Phoenix(?!-)': 'フェニックス',
      'Phoenix-Egi': 'フェニックス・エギ'
    },
    'replaceText': {
      '(?<! )Rebirth': '新生',
      'Bennu Add': '雑魚: ベンヌ',
      'Blackfire': '漆黒の炎',
      'Bluefire': '青碧の炎',
      'Brand Of Purgatory': '煉獄の炎',
      'Flames Of Rebirth': '転生の炎',
      'Flames Of Unforgiveness': '煉獄の爆炎',
      'Fountain Of Fire': '霊泉の炎',
      'Fountain Tick ': '霊泉の炎: ',
      'Redfire Plume': '赤熱の炎柱',
      'Redfire(?! )': '紅蓮の炎',
      'Revelation': 'リヴァレーション',
      'Scorched Pinion': '炎の翼',
      'Summon': '招来',
      'Whitefire': '白熱の炎'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bennu': '贝努鸟',
      'Phoenix(?!-)': '不死鸟',
      'Phoenix-Egi': '不死鸟之灵'
    },
    'replaceText': {
      '(?<! )Rebirth': '重生',
      'Bennu Add': '贝努鸟出现',
      'Blackfire': '漆黑之炎',
      'Bluefire': '青蓝之炎',
      'Brand Of Purgatory': '炼狱之炎',
      'Flames Of Rebirth': '转生之炎',
      'Flames Of Unforgiveness': '炼狱之燎火',
      'Fountain Of Fire': '灵泉之炎',
      'Fountain(?! Of Fire)': '灵泉',
      'Redfire Plume': '赤红之炎柱',
      'Redfire(?! )': '红莲之炎',
      'Revelation': '天启',
      'Scorched Pinion': '炎之翼',
      'Summon': '召唤',
      'Whitefire': '白热之炎'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bennu': '벤누',
      'Phoenix(?!-)': '피닉스',
      'Phoenix-Egi': '피닉스 에기'
    },
    'replaceText': {
      '(?<! )Rebirth': '소생',
      'Bennu Add': '벤누 쫄',
      'Blackfire': '칠흑의 불꽃',
      'Bluefire': '청벽의 불꽃',
      'Brand Of Purgatory': '연옥의 불꽃',
      'Flames Of Rebirth': '윤회의 불꽃',
      'Flames Of Unforgiveness': '연옥의 폭염',
      'Fountain Of Fire': '영검의 불꽃',
      'Fountain Tick': '영겁 틱',
      'Redfire Plume': '작열 불기둥',
      'Redfire(?! )': '홍련의 불꽃',
      'Revelation': '계시',
      'Scorched Pinion': '타오르는 날개',
      'Summon': '소환',
      'Whitefire': '백열의 불꽃'
    }
  }]
};
/* harmony default export */ const t12 = (t12_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t12.txt
const raid_t12_namespaceObject = "# Turn 12\r\n# -ii B5A B5C B60 B66 B68 B64 B59 B58 B65 B61 B57 B92 -p B5D:200 B5E:500\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Summon\"\r\nhideall \"Scorched Pinion\"\r\n\r\n### Phase 1: Blackfire/Whitefire\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n9.0 \"Bennu Add\"\r\n18.0 \"Revelation\" Ability { id: \"B87\", source: \"Phoenix\" } window 18,10\r\n32.1 \"Blackfire\" Ability { id: \"B8C\", source: \"Phoenix\" }\r\n42.1 \"--sync--\" Ability { id: \"B8F\", source: \"Phoenix\" }\r\n43.6 \"Whitefire\" Ability { id: \"B90\", source: \"Phoenix\" }\r\n\r\n77.0 \"Revelation\" Ability { id: \"B87\", source: \"Phoenix\" } window 20,20 jump 18\r\n91.1 \"Blackfire\"\r\n101.1 \"--sync--\"\r\n102.6 \"Whitefire\"\r\n\r\n\r\n### Phase 2: Bluefire/Redfire\r\n200.0 \"Brand Of Purgatory\" Ability { id: \"B88\", source: \"Phoenix\" } window 200,0\r\n\r\n210.6 \"Bluefire\" Ability { id: \"B91\", source: \"Phoenix\" } duration 4.1\r\n223.6 \"Flames Of Unforgiveness\" Ability { id: \"B8B\", source: \"Phoenix\" }\r\n231.0 \"Redfire\" Ability { id: \"B93\", source: \"Phoenix\" }\r\n237.1 \"Revelation\" Ability { id: \"B87\", source: \"Phoenix\" }\r\n\r\n248.2 \"Bluefire\" Ability { id: \"B91\", source: \"Phoenix\" } duration 4.1\r\n261.3 \"Flames Of Unforgiveness\" Ability { id: \"B8B\", source: \"Phoenix\" }\r\n268.3 \"Redfire\" Ability { id: \"B93\", source: \"Phoenix\" }\r\n\r\n280.6 \"Bluefire\" Ability { id: \"B91\", source: \"Phoenix\" } duration 4.1\r\n293.6 \"Flames Of Unforgiveness\" Ability { id: \"B8B\", source: \"Phoenix\" } window 20,20 jump 223.6\r\n301.0 \"Redfire\"\r\n307.1 \"Revelation\"\r\n\r\n318.2 \"Bluefire\"\r\n331.3 \"Flames Of Unforgiveness\"\r\n338.3 \"Redfire\"\r\n\r\n\r\n### Phase 3: So Many Bennies\r\n400.0 \"--sync--\" Ability { id: \"B96\", source: \"Phoenix\" } window 400,0\r\n404.1 \"--sync--\" Ability { id: \"B97\", source: \"Phoenix\" } window 404,5\r\n407.1 \"Flames Of Rebirth\" Ability { id: \"B98\", source: \"Phoenix\" }\r\n421.3 \"Flames Of Rebirth\" Ability { id: \"B99\", source: \"Phoenix\" }\r\n435.5 \"Flames Of Rebirth\" Ability { id: \"B99\", source: \"Phoenix\" } window 8,8 jump 421.3\r\n449.7 \"Flames Of Rebirth\"\r\n463.9 \"Flames Of Rebirth\"\r\n478.1 \"Flames Of Rebirth\"\r\n\r\n\r\n### Phase 4: Fountains of Life and Death\r\n996.0 \"--sync--\" StartsUsing { id: \"C88\", source: \"Phoenix\" } window 1000,0\r\n1000.0 \"Rebirth\" Ability { id: \"C88\", source: \"Phoenix\" }\r\n1005.8 \"Brand Of Purgatory\" Ability { id: \"B88\", source: \"Phoenix\" }\r\n\r\n# Fountain 1\r\n1011.0 \"Fountain Of Fire\" Ability { id: \"B9C\", source: \"Phoenix\" }\r\n1014.1 \"Summon\" Ability { id: \"B9F\", source: \"Phoenix\" }\r\n1019.1 \"Fountain Tick 1\"\r\n1020.3 \"Scorched Pinion\" Ability { id: \"BA0\", source: \"Phoenix-Egi\" }\r\n1022.1 \"Revelation\" Ability { id: \"B87\", source: \"Phoenix\" } window 10,10\r\n1024.3 \"Fountain Tick 2\"\r\n1026.4 \"Scorched Pinion\" #Ability { id: \"BA0\", source: \"Phoenix-Egi\" }\r\n1029.3 \"Fountain Tick 3\"\r\n1032.8 \"Scorched Pinion\" #Ability { id: \"BA1\", source: \"Phoenix-Egi\" }\r\n1034.3 \"Fountain Tick 4\"\r\n1038.2 \"Scorched Pinion\" #Ability { id: \"BA0\", source: \"Phoenix-Egi\" }\r\n1039.3 \"Fountain Tick 5\"\r\n1044.2 \"Scorched Pinion\" #Ability { id: \"BA0\", source: \"Phoenix-Egi\" }\r\n1044.2 \"Flames Of Unforgiveness\" Ability { id: \"B8B\", source: \"Phoenix\" } window 10,10\r\n1044.4 \"Fountain Tick 6\"\r\n1049.5 \"Fountain Tick 7\"\r\n1050.8 \"Scorched Pinion\" #Ability { id: \"BA1\", source: \"Phoenix-Egi\" }\r\n1054.6 \"Fountain Tick 8\"\r\n1059.4 \"Flames Of Rebirth\" Ability { id: \"B9A\", source: \"Phoenix\" } window 10,10\r\n\r\n# Fountain 2\r\n1066.6 \"Fountain Of Fire\" Ability { id: \"B9C\", source: \"Phoenix\" }\r\n1069.6 \"Summon\" Ability { id: \"B9F\", source: \"Phoenix\" }\r\n1074.8 \"Fountain Tick 1\"\r\n1075.8 \"Scorched Pinion\" #Ability { id: \"BA0\", source: \"Phoenix-Egi\" }\r\n1077.7 \"Revelation\" Ability { id: \"B87\", source: \"Phoenix\" } window 10,10\r\n1079.9 \"Fountain Tick 2\"\r\n1081.8 \"Scorched Pinion\" #Ability { id: \"BA0\", source: \"Phoenix-Egi\" }\r\n1085.1 \"Fountain Tick 3\"\r\n1088.4 \"Scorched Pinion\" #Ability { id: \"BA1\", source: \"Phoenix-Egi\" }\r\n1090.2 \"Fountain Tick 4\"\r\n1093.8 \"Scorched Pinion\" #Ability { id: \"BA0\", source: \"Phoenix-Egi\" }\r\n1095.2 \"Fountain Tick 5\"\r\n1099.8 \"Scorched Pinion\" #Ability { id: \"BA0\", source: \"Phoenix-Egi\" }\r\n1099.8 \"Flames Of Unforgiveness\" Ability { id: \"B8B\", source: \"Phoenix\" }\r\n1100.3 \"Fountain Tick 6\"\r\n1105.4 \"Fountain Tick 7\"\r\n1106.3 \"Scorched Pinion\" #Ability { id: \"BA1\", source: \"Phoenix-Egi\" }\r\n1110.4 \"Fountain Tick 8\"\r\n1115.0 \"Flames Of Rebirth\" Ability { id: \"B9A\", source: \"Phoenix\" }\r\n\r\n# Dance Minigame\r\n1117.2 \"--sync--\" Ability { id: \"BA2\", source: \"Phoenix\" }\r\n1118.3 \"--sync--\" Ability { id: \"B96\", source: \"Phoenix\" }\r\n1119.0 \"Scorched Pinion\" #Ability { id: \"BA0\", source: \"Phoenix-Egi\" }\r\n1121.1 \"Scorched Pinion\" #Ability { id: \"BA0\", source: \"Phoenix-Egi\" }\r\n1121.2 \"Redfire Plume\" #Ability { id: \"BA3\", source: \"Phoenix\" }\r\n1123.0 \"Scorched Pinion\" #Ability { id: \"BA0\", source: \"Phoenix-Egi\" }\r\n1125.1 \"Scorched Pinion\" #Ability { id: \"BA0\", source: \"Phoenix-Egi\" }\r\n1125.7 \"Scorched Pinion\" #Ability { id: \"BA1\", source: \"Phoenix-Egi\" }\r\n1127.2 \"Scorched Pinion\" #Ability { id: \"BA0\", source: \"Phoenix-Egi\" }\r\n1127.8 \"Scorched Pinion\" #Ability { id: \"BA1\", source: \"Phoenix-Egi\" }\r\n1129.7 \"Scorched Pinion\" #Ability { id: \"BA1\", source: \"Phoenix-Egi\" }\r\n1131.8 \"Scorched Pinion\" #Ability { id: \"BA1\", source: \"Phoenix-Egi\" }\r\n1133.9 \"Scorched Pinion\" #Ability { id: \"BA1\", source: \"Phoenix-Egi\" }\r\n1137.9 \"--sync--\" Ability { id: \"B97\", source: \"Phoenix\" } window 20,20\r\n\r\n# Loop\r\n1143.1 \"Fountain Of Fire\" Ability { id: \"B9C\", source: \"Phoenix\" } window 50,50 jump 1011.1\r\n1146.2 \"Summon\"\r\n1151.2 \"Fountain Tick 1\"\r\n1152.4 \"Scorched Pinion\"\r\n1154.2 \"Revelation\"\r\n1156.4 \"Fountain Tick 2\"\r\n1158.5 \"Scorched Pinion\"\r\n1161.4 \"Fountain Tick 3\"\r\n1164.9 \"Scorched Pinion\"\r\n1166.4 \"Fountain Tick 4\"\r\n1170.3 \"Scorched Pinion\"\r\n1171.4 \"Fountain Tick 5\"\r\n1176.3 \"Scorched Pinion\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t13.ts



const t13_triggerSet = {
  id: 'TheFinalCoilOfBahamutTurn4',
  zoneId: zone_id/* default.TheFinalCoilOfBahamutTurn4 */.Z.TheFinalCoilOfBahamutTurn4,
  timelineFile: 't13.txt',
  initData: () => {
    return {
      gigaflare: 0
    };
  },
  timelineTriggers: [{
    id: 'T13 Dive Warning',
    regex: /Megaflare Dive/,
    beforeSeconds: 5,
    response: responses/* Responses.stackMiddle */.n3.stackMiddle()
  }],
  triggers: [{
    id: 'T13 Gigaflare Phase Change',
    type: 'StartsUsing',
    netRegex: {
      id: 'BB9',
      source: 'Bahamut Prime',
      capture: false
    },
    // Only the first two gigas are phase changes, the rest are in final phase.
    condition: data => data.gigaflare <= 2,
    sound: 'Long',
    infoText: (data, _matches, output) => {
      if (data.gigaflare !== 0) return output.text();
    },
    run: data => data.gigaflare++,
    outputStrings: {
      text: {
        en: 'Stack Center for Dives',
        de: 'In der Mitte sammeln für Sturzbombe',
        fr: 'Packez-vous au centre pour les plongeons',
        ja: '中央待機、メガフレアダイブを待つ',
        cn: '中间集合等待俯冲',
        ko: '기가플레어 집합'
      }
    }
  }, {
    id: 'T13 Flatten',
    type: 'StartsUsing',
    netRegex: {
      id: 'BAE',
      source: 'Bahamut Prime'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.flattenOnYou();
    },
    infoText: (data, matches, output) => {
      if (matches.target === data.me) return;
      return output.flattenOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      flattenOn: {
        en: 'Flatten on ${player}',
        de: 'Einebnen auf ${player}',
        fr: 'Compression sur ${player}',
        ja: '${player}にフラッテン',
        cn: '死刑点${player}',
        ko: '짓뭉개기 ${player}'
      },
      flattenOnYou: {
        en: 'Flatten on YOU',
        de: 'Einebnen auf DIR',
        fr: 'Compression sur VOUS',
        ja: '自分にフラッテン',
        cn: '死刑',
        ko: '짓뭉개기'
      }
    }
  }, {
    id: 'T13 Megaflare Share',
    type: 'HeadMarker',
    netRegex: {
      id: '0027'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Megaflare Stack',
        de: 'Megaflare Sammeln',
        fr: 'MégaBrasier, Packez-vous',
        ja: 'メガフレア、集合',
        cn: '百万核爆集合',
        ko: '메가플레어 쉐어'
      }
    }
  }, {
    id: 'T13 Earthshaker',
    type: 'HeadMarker',
    netRegex: {
      id: '0028'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.earthshaker */.n3.earthshaker()
  }, {
    id: 'T13 Tempest Wing',
    type: 'Tether',
    netRegex: {
      id: '0004',
      target: 'Bahamut Prime'
    },
    condition: (data, matches) => data.me === matches.source,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tempest Tether on YOU',
        de: 'Sturm Verbindung auf DIR',
        fr: 'Liens de tempête sur VOUS',
        ja: '自分にテンペストウィング',
        cn: '风圈点名',
        ko: '폭풍 줄 대상자'
      }
    }
  }, {
    id: 'T13 Akh Morn',
    type: 'StartsUsing',
    netRegex: {
      id: 'BC2',
      source: 'Bahamut Prime'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.akhMornOnYou();
    },
    infoText: (data, matches, output) => {
      if (matches.target !== data.me) return output.akhMornOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      akhMornOn: {
        en: 'Akh Morn on ${player}',
        de: 'Akh Morn auf ${player}',
        fr: 'Akh Morn sur ${player}',
        ja: '${player}にアク・モーン',
        cn: '死亡轮回点${player}',
        ko: '"${player}" 아크몬'
      },
      akhMornOnYou: {
        en: 'Akh Morn on YOU',
        de: 'Akh Morn auf DIR',
        fr: 'Akh Morn sur VOUS',
        ja: '自分にアク・モーン',
        cn: '死亡轮回点名',
        ko: '아크몬 대상자'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bahamut Prime': 'Prim-Bahamut',
      'The Storm of Meracydia': 'Sturm von Meracydia'
    },
    'replaceText': {
      'Akh Morn': 'Akh Morn',
      'Blood': 'Blut',
      'Dark Aether': 'Dunkeläther',
      'Double Dive': 'Doppelschwinge',
      'Earth Shaker': 'Erdstoß',
      'Flare Breath': 'Flare-Atem',
      'Flare Star': 'Flare-Stern',
      'Flatten': 'Einebnen',
      'Gigaflare': 'Gigaflare',
      'Gust Add': 'Wind Add',
      'MF Pepperoni': 'MF Fläche',
      'MF Share': 'MF Sammeln',
      'MF Spread': 'MF Verteilen',
      'MF Tower\\(s\\)': 'MF Türme',
      'MF Tower(?!\\(s)': 'MF Turm',
      'Megaflare': 'Megaflare',
      'Pain Add': 'Schmerz Add',
      'Rage Of Bahamut': 'Bahamuts Zorn',
      'Shadow Add': 'Schatten Add',
      'Sin Add': 'Sünde Add',
      'Storm Add': 'Sturm Add',
      'Tempest Wing': 'Sturm-Schwinge',
      'Teraflare': 'Teraflare'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bahamut Prime': 'Primo-Bahamut',
      'The Storm of Meracydia': 'Tempête De Méracydia'
    },
    'replaceText': {
      'Akh Morn': 'Akh Morn',
      '(?<! )Blood Add': 'Add Sang',
      'Blood, Pain Adds': 'Adds Sang, Douleur',
      '1x Dark Aether Orb': '1x Orbe d\'éther sombre',
      'Dark Aether Orbs': 'Orbes d\'éther sombre',
      'Double Dive': 'Plongeon double',
      'Earth Shaker Marker': 'Marquage Secousse',
      'Earth Shaker(?! Marker)': 'Secousse',
      'Flare Breath': 'Souffle brasier',
      'Flare Star': 'Astre flamboyant',
      'Flatten': 'Compression',
      'Gigaflare': 'GigaBrasier',
      '2x Gust Adds': 'Adds 2x Bourrasque',
      '3x Gust Adds': 'Adds 3x Bourrasque',
      'MF Pepperoni': 'MB Zones au sol',
      'MF Share': 'MB Partagez',
      'MF Spread': 'MB Dispersez-vous',
      'MF Tower': 'MB Tour',
      'Megaflare Dive': 'Plongeon Mégabrasier',
      'Megaflare(?! Dive)': 'MégaBrasier',
      '(?<! )Pain Add': 'Add Douleur',
      'Rage Of Bahamut': 'Courroux de Bahamut',
      'Shadow Add': 'Add Ombre',
      '(?<! )Sin Add': 'Add Péché',
      '2x Sin Adds': 'Adds 2x Péché',
      'Storm Add': 'Add Tempête',
      'Tempest Wing Tethers': 'Liens Aile de tempête',
      'Tempest Wing(?! Tethers)': 'Aile de tempête',
      'Teraflare': 'TéraBrasier'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bahamut Prime': 'バハムート・プライム',
      'The Storm of Meracydia': 'メラシディアン・ストーム'
    },
    'replaceText': {
      'Akh Morn': 'アク・モーン',
      '(?<! )Blood Add': '雑魚: ブラッド',
      'Blood, Pain Adds': '雑魚: ブラッド + ペイン',
      '1x Dark Aether Orb': '1x ダークエーテル',
      'Dark Aether Orbs': 'ダークエーテル',
      'Double Dive': 'ダブルダイブ',
      'Earth Shaker': 'アースシェイカー',
      'Flare Breath': 'フレアブレス',
      'Flare Star': 'フレアスター',
      'Flatten': 'フラッテン',
      'Gigaflare': 'ギガフレア',
      '2x Gust Adds': '雑魚: 2x ガスト',
      '3x Gust Adds': '雑魚: 3x ガスト',
      '(?<= )Marker': 'マーカー',
      'MF Pepperoni': 'メガ: AoE',
      'MF Share': 'メガ: 頭割り',
      'MF Spread': 'メガ: 散開',
      'MF Tower(\\(s\\))?': 'メガ: 塔',
      'Megaflare': 'メガフレア',
      '(?<! )Pain Add': '雑魚: ペイン',
      'Rage Of Bahamut': '龍神の咆吼',
      'Shadow Add': '雑魚: シャドウ',
      '(?<! )Sin Add': '雑魚: シン',
      '2x Sin Adds': '雑魚: 2x シン',
      'Storm Add': '雑魚: ストーム',
      'Tempest Wing Tethers': 'テンペストウィング・線',
      'Tempest Wing(?! Tethers)': 'テンペストウィング',
      'Teraflare': 'テラフレア'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bahamut Prime': '至尊巴哈姆特',
      'The Storm of Meracydia': '美拉西迪亚的怒雨'
    },
    'replaceText': {
      'Akh Morn': '死亡轮回',
      '(?<! )Blood Add': '血仇出现',
      'Blood, Pain Adds': '血仇, 苦痛出现',
      '1x Dark Aether Orb': '1x暗以太',
      'Dark Aether Orbs': '暗以太',
      'Double Dive': '双重俯冲',
      'Earth Shaker Marker': '大地摇动点名',
      'Earth Shaker(?! Marker)': '大地摇动',
      'Flare Breath': '核爆吐息',
      'Flare Star': '耀星',
      'Flatten': '夷为平地',
      'Gigaflare': '十亿核爆',
      '2x Gust Adds': '2x悲风出现',
      '3x Gust Adds': '3x悲风出现',
      'MF Pepperoni': '百万核爆放粑粑',
      'MF Share': '百万核爆分摊',
      'MF Spread': '百万核爆分散',
      'MF Tower': '百万核爆踩塔',
      'Megaflare Dive': '百万核爆冲',
      'Megaflare(?! Dive)': '百万核爆',
      '(?<! )Pain Add': '苦痛出现',
      'Rage Of Bahamut': '龙神咆哮',
      'Shadow Add': '怨影出现',
      '(?<! )Sin Add': '罪恶出现',
      '2x Sin Adds': '2x罪恶出现',
      'Storm Add': '怒雨出现',
      'Tempest Wing Tethers': '风暴之翼连线',
      'Tempest Wing(?! Tethers)': '风暴之翼',
      'Teraflare': '万亿核爆'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bahamut Prime': '바하무트 프라임',
      'The Storm of Meracydia': '메라시디아의 폭풍'
    },
    'replaceText': {
      'Akh Morn': '아크 몬',
      'Blood, Pain Adds': '선혈, 고통 쫄',
      'Blood Add': '선혈 쫄',
      'Sin Add(s)?': '원죄 쫄',
      '(?<! )Pain Add': '고통 쫄',
      'Storm Add': '폭풍 쫄',
      'Shadow Add': '그림자 쫄',
      'Gust Add(s)?': '돌풍 쫄',
      'Dark Aether Orb(s)?': '어둠의 에테르 구슬',
      'Double Dive': '이중 강하',
      'Earth Shaker': '요동치는 대지',
      'Flare Breath': '타오르는 숨결',
      'Flare Star': '타오르는 별',
      'Flatten': '짓뭉개기',
      'Gigaflare': '기가플레어',
      'Megaflare(?! Dive)': '메가플레어',
      'Megaflare Dive': '메가플레어 다이브',
      'MF Pepperoni': '메가플레어 원형 장판',
      'MF Share': '메가플레어 쉐어',
      'MF Spread': '메가플레어 산개',
      'MF Tower(\\(s\\))?': '메가플레어 기둥',
      'Marker': '징',
      'Tethers': '선',
      'Rage Of Bahamut': '용신의 포효',
      'Tempest Wing': '폭풍우 날개',
      'Teraflare': '테라플레어'
    }
  }]
};
/* harmony default export */ const t13 = (t13_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t13.txt
const raid_t13_namespaceObject = "### Turn 13\r\n# -ii BB0 BB1 BAC BBC BC5 BD0 BCC BCF -p BAD:7 BB9:200\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1: Megaflare Warmup\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.0 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" } window 7,10\r\n15.1 \"Megaflare\" Ability { id: \"BAF\", source: \"Bahamut Prime\" } window 80,80\r\n18.8 \"MF Spread\" #Ability { id: \"BB0\", source: \"Bahamut Prime\" }\r\n20.5 \"MF Pepperoni\" #Ability { id: \"BB1\", source: \"Bahamut Prime\" }\r\n22.6 \"MF Share\" Ability { id: \"BB2\", source: \"Bahamut Prime\" }\r\n25.1 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" } window 10,5\r\n33.1 \"Flatten\" Ability { id: \"BAE\", source: \"Bahamut Prime\" } window 30,30\r\n35.2 \"Flare Breath x3\" duration 4\r\n45.4 \"Earth Shaker Marker\"\r\n50.4 \"Earth Shaker x3\" duration 4\r\n\r\n56.6 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n64.7 \"Megaflare\" Ability { id: \"BAF\", source: \"Bahamut Prime\" } window 80,80\r\n68.4 \"MF Spread\"\r\n70.1 \"MF Pepperoni\"\r\n72.2 \"MF Share\"\r\n74.7 \"Flare Breath\"\r\n82.7 \"Flatten\"\r\n84.8 \"Flare Breath x3\"\r\n95.0 \"Earth Shaker Marker\"\r\n100.0 \"Earth Shaker x3\"\r\n\r\n\r\n### Phase 2 (75%): Flare Star, Rage of Bahamut, Dragons\r\n195.0 \"--sync--\" StartsUsing { id: \"BB9\", source: \"Bahamut Prime\" } window 200,0\r\n200.0 \"Gigaflare\" Ability { id: \"BB9\", source: \"Bahamut Prime\" } window 200,5\r\n\r\n203.0 \"Shadow Add (N)\"\r\n212.3 \"Flare Star\" Ability { id: \"BBB\", source: \"Bahamut Prime\" }\r\n214.1 \"(1x Dark Aether Orb)\"\r\n220.5 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n226.6 \"(3x Dark Aether Orbs)\"\r\n234.5 \"Flatten\" Ability { id: \"BAE\", source: \"Bahamut Prime\" }\r\n237.8 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n238.4 \"(3x Dark Aether Orbs)\"\r\n252.8 \"Megaflare\" Ability { id: \"BAF\", source: \"Bahamut Prime\" }\r\n256.0 \"MF Spread\"\r\n258.0 \"MF Pepperoni\"\r\n260.3 \"MF Share\"\r\n261.9 \"MF Tower\" Ability { id: \"BB3\", source: \"Bahamut Prime\" }\r\n263.0 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n269.1 \"Rage Of Bahamut\" Ability { id: \"BBD\", source: \"Bahamut Prime\" }\r\n\r\n270.1 \"Shadow Add (SW)\"\r\n278.3 \"Flare Star\" Ability { id: \"BBB\", source: \"Bahamut Prime\" }\r\n280.1 \"(3x Dark Aether Orbs)\"\r\n286.5 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n292.1 \"(3x Dark Aether Orbs)\"\r\n300.5 \"Flatten\" Ability { id: \"BAE\", source: \"Bahamut Prime\" }\r\n303.8 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n304.6 \"(2x Dark Aether Orbs)\"\r\n318.8 \"Megaflare\" Ability { id: \"BAF\", source: \"Bahamut Prime\" }\r\n322.0 \"MF Spread\"\r\n324.0 \"MF Pepperoni\"\r\n326.3 \"MF Share\"\r\n327.9 \"MF Tower\" Ability { id: \"BB3\", source: \"Bahamut Prime\" }\r\n329.0 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n335.1 \"Rage Of Bahamut\" Ability { id: \"BBD\", source: \"Bahamut Prime\" }\r\n\r\n336.1 \"Shadow Add (SE)\"\r\n344.3 \"Flare Star\" Ability { id: \"BBB\", source: \"Bahamut Prime\" }\r\n346.1 \"(3x Dark Aether Orbs)\"\r\n352.5 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n358.1 \"(3x Dark Aether Orbs)\"\r\n366.5 \"Flatten\" Ability { id: \"BAE\", source: \"Bahamut Prime\" }\r\n369.8 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n370.6 \"(2x Dark Aether Orbs)\"\r\n384.8 \"Megaflare\" Ability { id: \"BAF\", source: \"Bahamut Prime\" }\r\n388.0 \"MF Spread\"\r\n390.0 \"MF Pepperoni\"\r\n392.3 \"MF Share\"\r\n393.9 \"MF Tower\" Ability { id: \"BB3\", source: \"Bahamut Prime\" }\r\n395.0 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n401.1 \"Rage Of Bahamut\" Ability { id: \"BBD\", source: \"Bahamut Prime\" }\r\n\r\n402.1 \"Shadow Add\"\r\n410.3 \"Flare Star\" Ability { id: \"BBB\", source: \"Bahamut Prime\" } window 50,50 jump 344.3\r\n412.1 \"(3x Dark Aether Orbs)\"\r\n418.5 \"Flare Breath\"\r\n424.1 \"(3x Dark Aether Orbs)\"\r\n432.5 \"Flatten\"\r\n435.8 \"Flare Breath\"\r\n436.6 \"(2x Dark Aether Orbs)\"\r\n450.8 \"Megaflare\"\r\n454.0 \"MF Spread\"\r\n456.0 \"MF Pepperoni\"\r\n458.3 \"MF Share\"\r\n459.9 \"MF Tower\"\r\n461.0 \"Flare Breath\"\r\n467.1 \"Rage Of Bahamut\"\r\n\r\n\r\n### Phase 3 (52%): adds, adds, adds\r\n495.0 \"--sync--\" StartsUsing { id: \"BB9\", source: \"Bahamut Prime\" } window 290,0\r\n500.0 \"Gigaflare\" Ability { id: \"BB9\", source: \"Bahamut Prime\" }\r\n505.4 \"--sync--\" Ability { id: \"BBE\", source: \"Bahamut Prime\" }\r\n508.5 \"--sync--\" Ability { id: \"BBF\", source: \"Bahamut Prime\" }\r\n514.7 \"Megaflare Dive\" Ability { id: \"BC0\", source: \"Bahamut Prime\" }\r\n516.6 \"Double Dive\" Ability { id: \"BC8\", source: \"The Storm of Meracydia\" }\r\n517.8 \"--sync--\" Ability { id: \"BBE\", source: \"Bahamut Prime\" }\r\n518.7 \"MF Spread\"\r\n520.9 \"MF Pepperoni\"\r\n523.0 \"MF Share\"\r\n525.1 \"Blood, Pain Adds (E/W)\"\r\n545.5 \"3x Gust Adds\"\r\n571.2 \"2x Sin Adds (N/S)\"\r\n599.7 \"--sync--\" Ability { id: \"BBF\", source: \"Bahamut Prime\" }\r\n605.8 \"Megaflare Dive\" Ability { id: \"BC0\", source: \"Bahamut Prime\" }\r\n607.7 \"Double Dive\" Ability { id: \"BC8\", source: \"The Storm of Meracydia\" }\r\n608.9 \"--sync--\" Ability { id: \"BBE\", source: \"Bahamut Prime\" }\r\n609.8 \"MF Spread\"\r\n612.0 \"MF Pepperoni\"\r\n614.1 \"MF Share\"\r\n620.3 \"Storm Add (Center)\"\r\n631.1 \"Blood Add (N)\"\r\n641.1 \"2x Gust Adds (S)\"\r\n651.6 \"Sin Add (E)\"\r\n672.2 \"Pain Add (W)\"\r\n692.8 \"--sync--\" Ability { id: \"BBF\", source: \"Bahamut Prime\" }\r\n698.9 \"Megaflare Dive\" Ability { id: \"BC0\", source: \"Bahamut Prime\" }\r\n702.1 \"--sync--\" Ability { id: \"BBE\", source: \"Bahamut Prime\" }\r\n702.9 \"MF Spread\"\r\n705.1 \"MF Pepperoni\"\r\n707.2 \"MF Share\"\r\n725.4 \"Teraflare\" Ability { id: \"BC1\", source: \"Bahamut Prime\" } window 700,700\r\n\r\n\r\n### Phase 4: Akh Morns, Tempest Wings\r\n735.6 \"--sync--\" Ability { id: \"BBE\", source: \"Bahamut Prime\" }\r\n737.8 \"--sync--\" Ability { id: \"BBF\", source: \"Bahamut Prime\" }\r\n\r\n745.1 \"Akh Morn x2\" Ability { id: \"BC2\", source: \"Bahamut Prime\" } duration 2.1 window 40,40\r\n759.5 \"Megaflare\" Ability { id: \"BAF\", source: \"Bahamut Prime\" }\r\n764.6 \"MF Pepperoni\"\r\n766.6 \"Tempest Wing\" Ability { id: \"BC4\", source: \"Bahamut Prime\" }\r\n767.3 \"MF Share\" Ability { id: \"BB2\", source: \"Bahamut Prime\" }\r\n767.9 \"--sync--\" Ability { id: \"C89\", source: \"Bahamut Prime\" } # Tempest Wing Gust?\r\n768.6 \"MF Tower(s)\" Ability { id: \"BB3\", source: \"Bahamut Prime\" }\r\n781.7 \"Earth Shaker Marker\"\r\n786.7 \"Earth Shaker x3\" duration 4\r\n787.7 \"Tempest Wing Tethers\"\r\n793.7 \"Tempest Wing\" Ability { id: \"BC4\", source: \"Bahamut Prime\" }\r\n794.9 \"--sync--\" Ability { id: \"C89\", source: \"Bahamut Prime\" }\r\n795.9 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n\r\n807.1 \"Akh Morn x3\" Ability { id: \"BC2\", source: \"Bahamut Prime\" } duration 3.1 window 40,40\r\n822.3 \"Megaflare\" Ability { id: \"BAF\", source: \"Bahamut Prime\" }\r\n827.4 \"MF Pepperoni\"\r\n829.4 \"Tempest Wing\" Ability { id: \"BC4\", source: \"Bahamut Prime\" }\r\n830.1 \"MF Share\" Ability { id: \"BB2\", source: \"Bahamut Prime\" }\r\n830.7 \"--sync--\" Ability { id: \"C89\", source: \"Bahamut Prime\" }\r\n831.4 \"MF Tower(s)\" Ability { id: \"BB3\", source: \"Bahamut Prime\" }\r\n844.5 \"Earth Shaker Marker\"\r\n849.5 \"Earth Shaker x3\" duration 4\r\n850.5 \"Tempest Wing Tethers\"\r\n856.5 \"Tempest Wing\" Ability { id: \"BC4\", source: \"Bahamut Prime\" }\r\n857.7 \"--sync--\" Ability { id: \"C89\", source: \"Bahamut Prime\" }\r\n858.7 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n\r\n871.4 \"Gigaflare\" Ability { id: \"BB9\", source: \"Bahamut Prime\" } window 100,100\r\n\r\n880.8 \"Akh Morn x4\" Ability { id: \"BC2\", source: \"Bahamut Prime\" } duration 4.1 window 40,40\r\n897.2 \"Megaflare\" Ability { id: \"BAF\", source: \"Bahamut Prime\" }\r\n902.3 \"MF Pepperoni\"\r\n904.3 \"Tempest Wing\" Ability { id: \"BC4\", source: \"Bahamut Prime\" }\r\n905.0 \"MF Share\" Ability { id: \"BB2\", source: \"Bahamut Prime\" }\r\n905.6 \"--sync--\" Ability { id: \"C89\", source: \"Bahamut Prime\" }\r\n906.3 \"MF Tower(s)\" Ability { id: \"BB3\", source: \"Bahamut Prime\" }\r\n919.4 \"Earth Shaker Marker\"\r\n924.4 \"Earth Shaker x3\" duration 4\r\n925.4 \"Tempest Wing Tethers\"\r\n931.4 \"Tempest Wing\" Ability { id: \"BC4\", source: \"Bahamut Prime\" }\r\n932.6 \"--sync--\" Ability { id: \"C89\", source: \"Bahamut Prime\" }\r\n933.6 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n\r\n944.8 \"Akh Morn x5\" Ability { id: \"BC2\", source: \"Bahamut Prime\" } duration 5.1 window 40,40\r\n962.2 \"Megaflare\" Ability { id: \"BAF\", source: \"Bahamut Prime\" }\r\n967.3 \"MF Pepperoni\"\r\n969.3 \"Tempest Wing\" Ability { id: \"BC4\", source: \"Bahamut Prime\" }\r\n970.0 \"MF Share\" Ability { id: \"BB2\", source: \"Bahamut Prime\" }\r\n970.6 \"--sync--\" Ability { id: \"C89\", source: \"Bahamut Prime\" }\r\n971.3 \"MF Tower(s)\" Ability { id: \"BB3\", source: \"Bahamut Prime\" }\r\n984.4 \"Earth Shaker Marker\"\r\n989.4 \"Earth Shaker x3\" duration 4\r\n990.4 \"Tempest Wing Tethers\"\r\n996.4 \"Tempest Wing\" Ability { id: \"BC4\", source: \"Bahamut Prime\" }\r\n997.6 \"--sync--\" Ability { id: \"C89\", source: \"Bahamut Prime\" }\r\n998.6 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n\r\n1011.3 \"Gigaflare\" Ability { id: \"BB9\", source: \"Bahamut Prime\" } window 100,100\r\n\r\n1020.7 \"Akh Morn x6\" Ability { id: \"BC2\", source: \"Bahamut Prime\" } duration 6.1 window 40,40\r\n1039.1 \"Megaflare\" Ability { id: \"BAF\", source: \"Bahamut Prime\" }\r\n1044.2 \"MF Pepperoni\"\r\n1046.2 \"Tempest Wing\" Ability { id: \"BC4\", source: \"Bahamut Prime\" }\r\n1046.9 \"MF Share\" Ability { id: \"BB2\", source: \"Bahamut Prime\" }\r\n1047.5 \"--sync--\" Ability { id: \"C89\", source: \"Bahamut Prime\" }\r\n1048.2 \"MF Tower(s)\" Ability { id: \"BB3\", source: \"Bahamut Prime\" }\r\n1061.3 \"Earth Shaker Marker\"\r\n1066.3 \"Earth Shaker x3\" duration 4\r\n1067.3 \"Tempest Wing Tethers\"\r\n1073.3 \"Tempest Wing\" Ability { id: \"BC4\", source: \"Bahamut Prime\" }\r\n1074.5 \"--sync--\" Ability { id: \"C89\", source: \"Bahamut Prime\" }\r\n1075.5 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n\r\n1086.7 \"Akh Morn x7\" Ability { id: \"BC2\", source: \"Bahamut Prime\" } duration 7.1 window 40,40\r\n1106.1 \"Megaflare\" Ability { id: \"BAF\", source: \"Bahamut Prime\" }\r\n1111.2 \"MF Pepperoni\"\r\n1113.2 \"Tempest Wing\" Ability { id: \"BC4\", source: \"Bahamut Prime\" }\r\n1113.9 \"MF Share\" Ability { id: \"BB2\", source: \"Bahamut Prime\" }\r\n1114.5 \"--sync--\" Ability { id: \"C89\", source: \"Bahamut Prime\" }\r\n1115.2 \"MF Tower(s)\" Ability { id: \"BB3\", source: \"Bahamut Prime\" }\r\n1128.3 \"Earth Shaker Marker\"\r\n1133.3 \"Earth Shaker x3\" duration 4\r\n1134.3 \"Tempest Wing Tethers\"\r\n1140.3 \"Tempest Wing\" Ability { id: \"BC4\", source: \"Bahamut Prime\" }\r\n1141.5 \"--sync--\" Ability { id: \"C89\", source: \"Bahamut Prime\" }\r\n1142.5 \"Flare Breath\" Ability { id: \"BAD\", source: \"Bahamut Prime\" }\r\n\r\n1155.2 \"Gigaflare\" Ability { id: \"BB9\", source: \"Bahamut Prime\" } window 100,100\r\n\r\n\r\n### Enrage\r\n2000.0 \"--sync--\" StartsUsing { id: \"BBA\", source: \"Bahamut Prime\" } window 2000,2000\r\n2010.0 \"Gigaflare Enrage\"\r\n2025.2 \"Gigaflare Enrage\"\r\n2037.4 \"Gigaflare Enrage\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t2.ts



const t2_triggerSet = {
  id: 'TheBindingCoilOfBahamutTurn2',
  zoneId: zone_id/* default.TheBindingCoilOfBahamutTurn2 */.Z.TheBindingCoilOfBahamutTurn2,
  triggers: [{
    id: 'T2 High Voltage',
    type: 'StartsUsing',
    netRegex: {
      id: '4C0'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'T2 Ballast',
    type: 'StartsUsing',
    netRegex: {
      id: '4C5',
      capture: false
    },
    suppressSeconds: 3,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    // Allagan Rot
    id: 'T2 Rot',
    type: 'GainsEffect',
    netRegex: {
      effectId: '14D'
    },
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) return output.rotOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return output.rotOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      rotOn: {
        en: 'Rot on ${player}',
        de: 'Fäulnis auf ${player}',
        fr: 'Pourriture sur ${player}',
        ja: '${player}にアラガンロット',
        cn: '毒点 ${player}',
        ko: '${player} 알라그 부패'
      },
      rotOnYou: {
        en: 'Rot on YOU',
        de: 'Fäulnis auf DIR',
        fr: 'Pourriture sur VOUS',
        ja: '自分にアラガンロット',
        cn: '毒点名',
        ko: '알라그 부패 대상자'
      }
    }
  }, {
    id: 'T2 Pass Rot',
    type: 'GainsEffect',
    netRegex: {
      effectId: '14D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: data => data.rot = true,
    delaySeconds: 11,
    alertText: (data, _matches, output) => {
      if (!data.rot) return;
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'Pass Rot',
        de: 'Fäulnis abgeben',
        fr: 'Passez la pourriture',
        ja: 'ロットを移す',
        cn: '传毒',
        ko: '부패 전달하기'
      }
    }
  }, {
    id: 'T2 Lost Rot',
    type: 'LosesEffect',
    netRegex: {
      effectId: '14D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => delete data.rot
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Allagan Rot': 'Allagische Fäulnis'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Allagan Rot': 'Pourriture Allagoise'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Allagan Rot': 'アラガンロット'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Allagan Rot': '亚拉戈古病毒'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Allagan Rot': '알라그 부패'
    }
  }]
};
/* harmony default export */ const t2 = (t2_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t4.ts


const t4_triggerSet = {
  id: 'TheBindingCoilOfBahamutTurn4',
  zoneId: zone_id/* default.TheBindingCoilOfBahamutTurn4 */.Z.TheBindingCoilOfBahamutTurn4,
  timelineFile: 't4.txt',
  triggers: [{
    id: 'T4 Gravity Thrust',
    type: 'StartsUsing',
    netRegex: {
      source: 'Spinner-Rook',
      id: '4D4'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'LOS Thrust',
        de: 'LOS Gravitationsschlag',
        fr: 'LOS Percée gravitationelle',
        ja: 'グラビデカノン',
        cn: '死刑',
        ko: '중력포'
      }
    }
  }, {
    id: 'T4 Pox',
    type: 'StartsUsing',
    netRegex: {
      source: 'Spinner-Rook',
      id: '4D5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'LOS Pox',
        de: 'LOS Pocken',
        fr: 'LOS Vérole',
        ja: 'ポックス',
        cn: '血量上限降低',
        ko: '두창'
      }
    }
  }, {
    id: 'T4 Reminder',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Clockwork Knight',
      capture: false
    },
    suppressSeconds: 100000,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Magic on Soldier, Physical on Knights',
        de: 'Magier auf Soldat, Physische auf Ritter',
        fr: 'Magique sur Soldat, Physique sur Chevalier',
        ja: '魔法はソルジャー、物理はナイト',
        cn: '法系打士兵，物理打骑士',
        ko: '병사 마법공격, 기사 물리공격'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Clockwork Bug': 'Uhrwerk-Wanze',
      'Clockwork Dreadnaught': 'Brummonaut',
      'Clockwork Knight': 'Uhrwerk-Ritter',
      'Drive Cylinder': 'Antriebszylinder',
      'Spinner-rook': 'Drehturm'
    },
    'replaceText': {
      'Bug': 'Wanze',
      'Dreadnaught': 'Brummonaut',
      'Emergency Override': 'Not-Übersteuerung',
      'Knight': 'Ritter',
      'Rook': 'Drehturm',
      'Soldier': 'Soldat'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Clockwork Bug': 'Insecte Mécanique',
      'Clockwork Dreadnaught': 'Cuirassé Dreadnaught',
      'Clockwork Knight': 'Chevalier Mécanique',
      'Drive Cylinder': 'Cylindre Propulseur',
      'Spinner-rook': 'Drone-Drille'
    },
    'replaceText': {
      'Bug': 'Insecte',
      'Dreadnaught': 'Cuirassé',
      'Emergency Override': 'Annulation d\'urgence',
      'Knight': 'Chevalier',
      'Rook': 'Drone',
      'Soldier': 'Soldat'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Clockwork Bug': 'アラガンワーク・バグ',
      'Clockwork Dreadnaught': 'ドレッドノート',
      'Clockwork Knight': 'アラガンワーク・ナイト',
      'Drive Cylinder': '稼働隔壁',
      'Spinner-rook': 'ルークスピナー'
    },
    'replaceText': {
      'Bug': 'アラガンワーク・バグ',
      'Dreadnaught': 'ドレッドノート',
      'Emergency Override': 'エマージェンシー・オーバーライド',
      'Knight': 'ナイト',
      'Rook': 'ルーク',
      'Soldier': 'ソルジャー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Clockwork Bug': '亚拉戈发条虫',
      'Clockwork Dreadnaught': '恐慌装甲',
      'Clockwork Knight': '亚拉戈发条骑士',
      'Drive Cylinder': '隔离壁',
      'Spinner-rook': '转盘堡'
    },
    'replaceText': {
      'Bug': '故障虫',
      'Dreadnaught': '恐慌装甲',
      'Emergency Override': '紧急超驰控制',
      'Knight': '亚拉戈发条骑士',
      'Rook': '转盘堡',
      'Soldier': '亚拉戈发条士兵'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Clockwork Bug': '알라그 태엽벌레',
      'Clockwork Dreadnaught': '드레드노트',
      'Clockwork Knight': '알라그 태엽기사',
      'Drive Cylinder': '가동격벽',
      'Spinner-rook': '보루형 회전전차'
    },
    'replaceText': {
      'Bug': '버그',
      'Dreadnaught': '드레드노트',
      'Emergency Override': '긴급 체제 변환',
      'Knight': '기사',
      'Soldier': '병사',
      'Rook': '회전전차'
    }
  }]
};
/* harmony default export */ const t4 = (t4_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t4.txt
const raid_t4_namespaceObject = "### T4\r\n# http://forum.square-enix.com/ffxiv/threads/103985-EXTREME-BINDING-COIL-OF-BAHAMUT-TURN-4-GUIDE\r\n\r\n0.0 \"6x Bug\" AddedCombatant { name: \"Clockwork Bug\" } window 0,1\r\n\r\n63.0 \"Knight + Soldier (NW)\" AddedCombatant { name: \"Clockwork Knight\" } window 70,0\r\n63.0 \"Knight + Soldier (NE)\"\r\n\r\n123.0 \"Dreadnaught (NW)\" AddedCombatant { name: \"Clockwork Dreadnaught\" } window 130,0\r\n123.0 \"4x Bug (S)\"\r\n\r\n183.0 \"2x Rook (E/W)\" AddedCombatant { name: \"Spinner-rook\" } window 190,0\r\n183.0 \"4x Bug (outside)\"\r\n\r\n243.0 \"Dreadnaught (NE)\" AddedCombatant { name: \"Clockwork Dreadnaught\" } window 115,0\r\n243.0 \"Soldier (center)\"\r\n243.0 \"Knight (SE)\"\r\n\r\n303.0 \"Dreadnaught (NE)\" AddedCombatant { name: \"Clockwork Dreadnaught\" } window 55,0\r\n303.0 \"Knight (center)\"\r\n303.0 \"Soldier (SW)\"\r\n303.0 \"Rook (NE)\"\r\n303.0 \"2x Bug (SE/NW)\"\r\n\r\n423.0 \"Emergency Override\" Ability { id: \"4EA\", source: \"Drive Cylinder\" } window 500,500\r\n427.0 \"Emergency Override\"\r\n431.0 \"Emergency Override\"\r\n435.0 \"Emergency Override\"\r\n439.0 \"Emergency Override\"\r\n443.0 \"Emergency Override\"\r\n447.0 \"Emergency Override\"\r\n451.0 \"Emergency Override\"\r\n454.0 \"Emergency Override\"\r\n458.0 \"Emergency Override\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t5.ts



const t5_triggerSet = {
  id: 'TheBindingCoilOfBahamutTurn5',
  zoneId: zone_id/* default.TheBindingCoilOfBahamutTurn5 */.Z.TheBindingCoilOfBahamutTurn5,
  timelineFile: 't5.txt',
  initData: () => {
    return {
      monitoringHP: false,
      hpThresholds: [0.85, 0.55, 0.29],
      currentPhase: 0
    };
  },
  triggers: [{
    id: 'T5 Twintania Phase Change Watcher',
    type: 'Ability',
    netRegex: {
      source: 'Twintania'
    },
    condition: data => !data.monitoringHP && data.hpThresholds[data.currentPhase] !== undefined,
    preRun: data => data.monitoringHP = true,
    promise: (data, matches) => util/* default.watchCombatant */.Z.watchCombatant({
      ids: [parseInt(matches.sourceId, 16)]
    }, ret => {
      const twintaniaBelowGivenHP = ret.combatants.some(c => {
        const currentHPCheck = data.hpThresholds[data.currentPhase] ?? -1;
        return c.CurrentHP / c.MaxHP <= currentHPCheck;
      });
      return twintaniaBelowGivenHP;
    }),
    sound: 'Long',
    run: data => {
      data.currentPhase++;
      data.monitoringHP = false;
    }
  }, {
    id: 'T5 Death Sentence',
    type: 'StartsUsing',
    netRegex: {
      source: 'Twintania',
      id: '5B2'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'T5 Death Sentence Warning',
    type: 'StartsUsing',
    netRegex: {
      source: 'Twintania',
      id: '5B2',
      capture: false
    },
    delaySeconds: 30,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Death Sentence Soon',
        de: 'Todesurteil bald',
        fr: 'Peine de mort bientôt',
        ja: 'まもなくデスセンテンス',
        cn: '死刑',
        ko: '사형선고'
      }
    }
  }, {
    id: 'T5 Liquid Hell',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Scourge Of Meracydia',
      id: '4DB',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Liquid Hell',
        de: 'Höllenschmelze',
        fr: 'Enfer liquide',
        ja: 'ヘルリキッド',
        cn: '液体地狱',
        ko: '지옥의 늪'
      }
    }
  }, {
    id: 'T5 Fireball',
    type: 'Ability',
    netRegex: {
      source: 'Twintania',
      id: '5AC'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.fireballOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return output.fireballOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      fireballOn: {
        en: 'Fireball on ${player}',
        de: 'Feuerball auf ${player}',
        fr: 'Boule de feu sur ${player}',
        ja: '${player}にファイアボール',
        cn: '火球点${player}',
        ko: '"${player}" 쉐어징'
      },
      fireballOnYou: {
        en: 'Fireball on YOU',
        de: 'Feuerball auf DIR',
        fr: 'Boule de feu sur VOUS',
        ja: '自分にファイアボール',
        cn: '火球点名',
        ko: '나에게 화염구'
      }
    }
  }, {
    id: 'T5 Conflagration',
    type: 'Ability',
    netRegex: {
      source: 'Twintania',
      id: '5AB'
    },
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) return output.conflagOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return output.conflagOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      conflagOn: {
        en: 'Conflag on ${player}',
        de: 'Feuersturm auf ${player}',
        fr: 'Tempête de feu sur ${player}',
        ja: '${player}にファイアストーム',
        cn: '火焰流点${player}',
        ko: '불보라${player}'
      },
      conflagOnYou: {
        en: 'Conflag on YOU',
        de: 'Feuersturm auf DIR',
        fr: 'Tempête de feu sur VOUS',
        ja: '自分にファイアストーム',
        cn: '火焰流点名',
        ko: '불보라 보스밑으로'
      }
    }
  }, {
    id: 'T5 Divebomb',
    type: 'Ability',
    netRegex: {
      source: 'Twintania',
      id: '5B0',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'DIVEBOMB',
        de: 'STURZBOMBE',
        fr: 'BOMBE PLONGEANTE',
        ja: 'ダイブボム',
        cn: '俯冲',
        ko: '급강하'
      }
    }
  }, {
    id: 'T5 Divebomb Set Two',
    type: 'Ability',
    netRegex: {
      source: 'Twintania',
      id: '5B0',
      capture: false
    },
    delaySeconds: 60,
    suppressSeconds: 5000,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Divebombs Soon',
        de: 'Sturzbombe bald',
        fr: 'Bombe plongeante bientôt',
        ja: 'まもなくダイブボム',
        cn: '即将俯冲',
        ko: '급강하 준비'
      }
    }
  }, {
    // Unwoven Will
    id: 'T5 Dreadknight',
    type: 'Ability',
    netRegex: {
      source: 'Twintania',
      id: '4E3'
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.knightOnYou();
      return output.knightOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      knightOnYou: {
        en: 'Knight on YOU',
        de: 'Furchtritter auf DIR',
        fr: 'Chevalier sur VOUS',
        ja: '自分にナイト',
        cn: '骑士点名',
        ko: '드레드 대상자'
      },
      knightOn: {
        en: 'Knight on ${player}',
        de: 'Furchtritter auf ${player}',
        fr: 'Chevalier sur ${player}',
        ja: '${player}にナイト',
        cn: '骑士点${player}',
        ko: '"${player}" 드래드 대상'
      }
    }
  }, {
    id: 'T5 Twister',
    type: 'StartsUsing',
    netRegex: {
      source: 'Twintania',
      id: '4E1',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Twister!',
        de: 'Wirbelsturm!',
        fr: 'Tornade !',
        ja: 'ツイスター!',
        cn: '风风风！',
        ko: '회오리'
      }
    }
  }, {
    id: 'T5 Hatch',
    type: 'Ability',
    netRegex: {
      source: 'Twintania',
      id: '5AD'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.hatchOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return output.hatchOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      hatchOn: {
        en: 'Hatch on ${player}',
        de: 'Austritt auf ${player}',
        fr: 'Éclosion sur ${player}',
        ja: '${player}に魔力爆散',
        cn: '黑球点${player}',
        ko: '"${player}" 마력방출'
      },
      hatchOnYou: {
        en: 'Hatch on YOU',
        de: 'Austritt auf DIR',
        fr: 'Éclosion sur VOUS',
        ja: '自分に魔力爆散',
        cn: '黑球点名',
        ko: '나에게 마력방출'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'The Right Hand of Bahamut': 'Rechten Hand von Bahamut',
      'The Scourge Of Meracydia': 'Fackel von Meracydia',
      'Twintania': 'Twintania'
    },
    'replaceText': {
      'Aetheric Profusion': 'Ätherische Profusion',
      'Asclepius': 'Asclepius',
      'Death Sentence': 'Todesurteil',
      'Divebomb': 'Sturzbombe',
      'Fireball': 'Feuerball',
      'Firestorm': 'Feuersturm',
      'Hatch': 'Austritt',
      'Hygieia': 'Hygieia',
      'Liquid Hell': 'Höllenschmelze',
      'Plummet': 'Ausloten',
      'Twister': 'Wirbelsturm',
      'Unwoven Will': 'Entwobener Wille'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'The Right Hand of Bahamut': 'la Serre droite de Bahamut',
      'The Scourge Of Meracydia': 'Fléau De Méracydia',
      'Twintania': 'Gémellia'
    },
    'replaceText': {
      '1x Asclepius Add': 'Add 1x Asclépios',
      '2x Hygieia Adds': 'Adds 2x Hygie',
      'Aetheric Profusion': 'Excès d\'éther',
      'Death Sentence': 'Peine de mort',
      'Divebomb': 'Bombe plongeante',
      'Fireball': 'Boule de feu',
      'Firestorm': 'Tempête de feu',
      'Hatch': 'Éclosion',
      'Liquid Hell': 'Enfer liquide',
      'Plummet': 'Piqué',
      'Twister': 'Tornade',
      'Unwoven Will': 'Volonté dispersée'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'The Right Hand of Bahamut': 'バハムートの右手',
      'The Scourge Of Meracydia': 'メラシディアン・ワイバーン',
      'Twintania': 'ツインタニア'
    },
    'replaceText': {
      'Aetheric Profusion': 'エーテリックプロフュージョン',
      'Asclepius': 'アスクレピオス',
      'Death Sentence': 'デスセンテンス',
      'Divebomb': 'ダイブボム',
      'Fireball': 'ファイアボール',
      'Firestorm': 'ファイアストーム',
      'Hatch': '魔力爆散',
      'Hygieia': 'ヒュギエイア',
      'Liquid Hell': 'ヘルリキッド',
      'Plummet': 'プラメット',
      'Twister': 'ツイスター',
      'Unwoven Will': 'アンウォーヴェンウィル'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'The Right Hand of Bahamut': '巴哈姆特的右手',
      'The Scourge Of Meracydia': '美拉西迪亚祸龙',
      'Twintania': '双塔尼亚'
    },
    'replaceText': {
      'Aetheric Profusion': '以太失控',
      'Asclepius': '阿斯克勒庇俄斯',
      'Death Sentence': '死刑',
      'Divebomb': '爆破俯冲',
      'Fireball': '火球',
      'Firestorm': '火焰风暴',
      'Hatch': '魔力爆散',
      'Hygieia': '许癸厄亚',
      'Liquid Hell': '液体地狱',
      'Plummet': '垂直下落',
      'Twister': '旋风',
      'Unwoven Will': '破愿'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'The Right Hand of Bahamut': '바하무트의 오른손',
      'The Scourge Of Meracydia': '메라시디아 와이번',
      'Twintania': '트윈타니아'
    },
    'replaceText': {
      'Aetheric Profusion': '에테르 홍수',
      'Asclepius': '아스클레피오스',
      'Death Sentence': '사형 선고',
      'Divebomb': '급강하 폭격',
      'Fireball': '화염구',
      'Firestorm': '불보라',
      'Hatch': '마력 방출',
      'Hygieia': '히기에이아',
      'Liquid Hell': '지옥의 늪',
      'Plummet': '곤두박질',
      'Twister': '회오리',
      'Unwoven Will': '짓밟힌 의지'
    }
  }]
};
/* harmony default export */ const t5 = (t5_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t5.txt
const raid_t5_namespaceObject = "### Turn 5\r\n# -p 4D8:7.5 4DE:205 5B0:400 4E0:600 5AD:800 -ii 4DB 4D9 4E8 4DA 29E 4E2 29F 29D 4BC 5AC 4DF 4E9\r\n\r\n# plummet and death sentence are on their own unique timers and appear to be\r\n# lower priority than everything else.  This means that their timings are\r\n# interspersed with everything else and can't be used.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.5 \"Plummet\" Ability { id: \"4D8\", source: \"Twintania\" } window 10,5\r\n21.6 \"Death Sentence\" Ability { id: \"5B2\", source: \"Twintania\" } window 22,10\r\n25.7 \"Plummet\" Ability { id: \"4D8\", source: \"Twintania\" }\r\n38.4 \"Plummet\" Ability { id: \"4D8\", source: \"Twintania\" }\r\n51.8 \"Plummet\" Ability { id: \"4D8\", source: \"Twintania\" }\r\n57.9 \"Death Sentence\" Ability { id: \"5B2\", source: \"Twintania\" } window 22,10\r\n65.3 \"Plummet\" Ability { id: \"4D8\", source: \"Twintania\" }\r\n# ???\r\n\r\n\r\n### Phase 2\r\n200.0 \"--sync--\" Ability { id: \"5AC\", source: \"Twintania\" } window 200,0\r\n205.0 \"Fireball\" Ability { id: \"4DE\", source: \"Twintania\" }\r\n219.0 \"Firestorm\" Ability { id: \"5AB\", source: \"Twintania\" }\r\n229.3 \"Fireball\" Ability { id: \"4DE\", source: \"Twintania\" }\r\n254.9 \"Fireball\" Ability { id: \"4DE\", source: \"Twintania\" }\r\n257.4 \"Firestorm\" Ability { id: \"5AB\", source: \"Twintania\" }\r\n280.0 \"Fireball\" Ability { id: \"4DE\", source: \"Twintania\" }\r\n# ???\r\n\r\n### Phase 3\r\n400.0 \"Divebomb\" Ability { id: \"5B0\", source: \"Twintania\" } window 400,0\r\n407.9 \"Divebomb\" Ability { id: \"5B0\", source: \"Twintania\" }\r\n415.6 \"Divebomb\" Ability { id: \"5B0\", source: \"Twintania\" }\r\n419.6 \"1x Asclepius add\"\r\n419.6 \"2x Hygieia adds\"\r\n465.3 \"Divebomb\" Ability { id: \"5B0\", source: \"Twintania\" } window 30,5\r\n473.0 \"Divebomb\" Ability { id: \"5B0\", source: \"Twintania\" }\r\n480.9 \"Divebomb\" Ability { id: \"5B0\", source: \"Twintania\" }\r\n484.9 \"2x Hygieia adds\"\r\n\r\n\r\n### Phase 4\r\n# Note: this is not perfect.  Unwoven will appears to be exactly 40s apart\r\n# and takes priority over everything else.  Rarely you can get three\r\n# twisters between unwoven wills if the plummet/death sentences timers are\r\n# weird.  Having twister timers seems nice though, even if it's not perfect.\r\n\r\n546.0 \"--targetable--\"\r\n600.0 \"Aetheric Profusion\" Ability { id: \"4E0\", source: \"Twintania\" } window 600,0\r\n616.0 \"Unwoven Will\" Ability { id: \"4E3\", source: \"Twintania\" } window 50,20\r\n637.8 \"Twister\" Ability { id: \"4E1\", source: \"Twintania\" }\r\n656.2 \"Unwoven Will\" Ability { id: \"4E3\", source: \"Twintania\" } window 30,30\r\n664.6 \"Twister\" Ability { id: \"4E1\", source: \"Twintania\" }\r\n685.8 \"Twister\" Ability { id: \"4E1\", source: \"Twintania\" }\r\n\r\n696.0 \"Unwoven Will\" Ability { id: \"4E3\", source: \"Twintania\" } window 30,30\r\n711.0 \"Twister\" Ability { id: \"4E1\", source: \"Twintania\" }\r\n736.2 \"Unwoven Will\" Ability { id: \"4E3\", source: \"Twintania\" } window 30,30\r\n744.6 \"Twister\" Ability { id: \"4E1\", source: \"Twintania\" }\r\n765.8 \"Twister\" Ability { id: \"4E1\", source: \"Twintania\" }\r\n\r\n776.0 \"Unwoven Will\" Ability { id: \"4E3\", source: \"Twintania\" } window 30,30 jump 696\r\n791.0 \"Twister\"\r\n816.2 \"Unwoven Will\"\r\n824.6 \"Twister\"\r\n845.8 \"Twister\"\r\n\r\n\r\n### Phase 5\r\n900.0 \"Hatch\" Ability { id: \"5AD\", source: \"Twintania\" } window 900,0\r\n904.0 \"Liquid Hell\" Ability { id: \"5B1\", source: \"Twintania\" } duration 8 window 200,200\r\n912.5 \"Hatch\" Ability { id: \"5AD\", source: \"Twintania\" }\r\n921.0 \"Hatch\" Ability { id: \"5AD\", source: \"Twintania\" }\r\n922.0 \"Liquid Hell\"\r\n930.5 \"Hatch\"\r\n939.0 \"Hatch\"\r\n940.0 \"Liquid Hell\"\r\n948.5 \"Hatch\"\r\n957.0 \"Hatch\"\r\n\r\n\r\n### Enrage\r\n# There's also plummets in here on a different timer.\r\n1000 \"Aetheric Profusion\" Ability { id: \"4E0\", source: \"Twintania\" } window 399,100\r\n1006 \"Aetheric Profusion\"\r\n1012 \"Aetheric Profusion\"\r\n1018 \"Aetheric Profusion\"\r\n1024 \"Aetheric Profusion\"\r\n1030 \"Aetheric Profusion\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t6.ts




const t6_triggerSet = {
  id: 'TheSecondCoilOfBahamutTurn1',
  zoneId: zone_id/* default.TheSecondCoilOfBahamutTurn1 */.Z.TheSecondCoilOfBahamutTurn1,
  timelineFile: 't6.txt',
  triggers: [{
    id: 'T6 Phase 2',
    type: 'Ability',
    // Bloody Caress.
    netRegex: {
      id: '797',
      source: 'Rafflesia'
    },
    condition: data => !data.beganMonitoringHp,
    preRun: data => data.beganMonitoringHp = true,
    promise: (_data, matches) => util/* default.watchCombatant */.Z.watchCombatant({
      ids: [parseInt(matches.sourceId, 16)]
    }, ret => {
      return ret.combatants.some(c => {
        return c.CurrentHP / c.MaxHP <= 0.7;
      });
    }),
    sound: 'Long'
  }, {
    id: 'T6 Thorn Whip Collect',
    type: 'Tether',
    netRegex: {
      id: '0012'
    },
    run: (data, matches) => {
      data.thornMap ??= {};
      (data.thornMap[matches.source] ??= []).push(matches.target);
      (data.thornMap[matches.target] ??= []).push(matches.source);
    }
  }, {
    id: 'T6 Thorn Whip',
    type: 'Ability',
    netRegex: {
      id: '879',
      source: 'Rafflesia'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (data, _matches, output) => {
      const partners = data.thornMap?.[data.me] ?? [];
      const [partner1, partner2] = partners;
      if (partners.length === 0) return output.thornsOnYou();
      if (partners.length === 1 && partner1 !== undefined) return output.oneTether({
        player: data.party.member(partner1)
      });
      if (partners.length === 2 && partner1 !== undefined && partner2 !== undefined) {
        return output.twoTethers({
          player1: data.party.member(partner1),
          player2: data.party.member(partner2)
        });
      }
      return output.threeOrMoreTethers({
        num: partners.length
      });
    },
    run: data => delete data.thornMap,
    outputStrings: {
      thornsOnYou: {
        en: 'Thorns on YOU',
        de: 'Dornenpeitsche auf DIR',
        fr: 'Ronces sur VOUS',
        ja: '自分にソーンウィップ',
        cn: '荆棘点名',
        ko: '가시 대상자'
      },
      oneTether: {
        en: 'Thorns w/ (${player})',
        de: 'Dornenpeitsche mit (${player})',
        fr: 'Ronces avec (${player})',
        ja: '自分と (${player}) にソーンウィップ',
        cn: '荆棘与(${player})',
        ko: '가시 대상자 (${player})'
      },
      twoTethers: {
        en: 'Thorns w/ (${player1}, ${player2})',
        de: 'Dornenpeitsche mit (${player1}, ${player2})',
        fr: 'Ronces avec (${player1}, ${player2})',
        ja: '自分と (${player1}, ${player2}) にソーンウィップ',
        cn: '荆棘与(${player1}, ${player2})',
        ko: '가시 대상자 (${player1}, ${player2})'
      },
      threeOrMoreTethers: {
        en: 'Thorns (${num} people)',
        de: 'Dornenpeitsche mit (${num} Personen)',
        fr: 'Ronces (${num} personne)',
        ja: 'ソーンウィップ (${num}人)',
        cn: '荆棘(${num} people)',
        ko: '가시 (${num}명)'
      }
    }
  }, {
    // Honey-Glazed
    id: 'T6 Honey On',
    type: 'GainsEffect',
    netRegex: {
      effectId: '1BE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.honey = true
  }, {
    id: 'T6 Honey Off',
    type: 'LosesEffect',
    netRegex: {
      effectId: '1BE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => delete data.honey
  }, {
    id: 'T6 Flower',
    type: 'HeadMarker',
    netRegex: {
      id: '000D'
    },
    alarmText: (data, _matches, output) => {
      if (data.honey) return output.getEaten();
    },
    alertText: (data, matches, output) => {
      if (data.honey) return;
      if (data.me === matches.target) return output.jumpInNewThorns();
    },
    infoText: (data, matches, output) => {
      if (data.honey || data.me === matches.target) return;
      return output.avoidDevour();
    },
    outputStrings: {
      avoidDevour: {
        en: 'Avoid Devour',
        de: 'Weiche Verschlingen aus',
        fr: 'Évitez Dévoration',
        ja: '捕食を避ける',
        cn: '躲开吞食',
        ko: '포식 피하기'
      },
      jumpInNewThorns: {
        en: 'Devour: Jump In New Thorns',
        de: 'Verschlingen: Spring in die neuen Dornen',
        fr: 'Dévoration : Sautez dans les ronces',
        ja: '捕食: 新芽に乗る',
        cn: '去新荆棘',
        ko: '포식: 가시장판 밟기'
      },
      getEaten: {
        en: 'Devour: Get Eaten',
        de: 'Verschlingen: Gefressen werden',
        fr: 'Dévoration : Faites-vous manger',
        ja: '捕食: 捕食される',
        cn: '捕食点名',
        ko: '포식: 잡아먹히기'
      }
    }
  }, {
    id: 'T6 Blighted',
    type: 'StartsUsing',
    netRegex: {
      id: '79D',
      source: 'Rafflesia',
      capture: false
    },
    response: responses/* Responses.stopEverything */.n3.stopEverything()
  }, {
    id: 'T6 Phase 3',
    type: 'StartsUsing',
    netRegex: {
      id: '79E',
      source: 'Rafflesia',
      capture: false
    },
    condition: data => !data.seenLeafstorm,
    sound: 'Long',
    run: data => data.seenLeafstorm = true
  }, {
    id: 'T6 Swarm Stack',
    type: 'StartsUsing',
    netRegex: {
      id: '86C',
      source: 'Rafflesia',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack for Acid',
        de: 'Sammeln für Säure-Blubberblase',
        fr: 'Packez-vous pour Pluie acide',
        ja: '集合、アシッドレインを誘導',
        cn: '集合引导酸雨',
        ko: '모여서 산성비 장판 유도'
      }
    }
  }, {
    id: 'T6 Swarm',
    type: 'Ability',
    netRegex: {
      id: '7A0',
      source: 'Rafflesia'
    },
    condition: (data, matches) => data.me === matches.target || data.role === 'healer' || data.job === 'BLU',
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.swarmOnYou();
    },
    infoText: (data, matches, output) => {
      if (matches.target !== data.me) return output.swarmOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      swarmOn: {
        en: 'Swarm on ${player}',
        de: 'Fähenfurz auf ${player}',
        fr: 'Nuée sur ${player}',
        ja: '${player}にスウォーム',
        cn: '蜂群点${player}',
        ko: '${player} 벌레'
      },
      swarmOnYou: {
        en: 'Swarm on YOU',
        de: 'Fähenfurz auf DIR',
        fr: 'Nuée sur VOUS',
        ja: '自分にスウォーム',
        cn: '蜂群点名',
        ko: '벌레 대상자'
      }
    }
  }, {
    id: 'T6 Rotten Stench',
    type: 'HeadMarker',
    netRegex: {
      id: '000E'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.shareLaserOnYou();
      return output.shareLaserOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      shareLaserOnYou: {
        en: 'Share Laser (on YOU)',
        de: 'Geteilter Laser (auf DIR)',
        fr: 'Partagez le laser (sur VOUS)',
        ja: '(自分に)頭割りレーザー',
        cn: '分摊激光点名',
        ko: '직선 쉐어 대상자'
      },
      shareLaserOn: {
        en: 'Share Laser (on ${player})',
        de: 'Geteilter Laser (auf ${player})',
        fr: 'Partage de laser (sur ${player})',
        ja: '(${player})に頭割りレーザー',
        cn: '分摊激光点(on ${player})',
        ko: '${player} 직선 쉐어'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Rafflesia': 'Rafflesia',
      'Scar\'s Edge': 'Narbenrand'
    },
    'replaceText': {
      'Acid Rain': 'Säureregen',
      'Blighted Bouquet': 'Mehltau-Bouquet',
      'Bloody Caress': 'Vampirranke',
      'Briary Growth': 'Wuchernde Dornen',
      'Devour': 'Verschlingen',
      'Floral Trap': 'Saugfalle',
      'Leafstorm': 'Blättersturm',
      'Rotten Stench': 'Fauler Gestank',
      'Spit': 'Hypersekretion',
      'Swarm': 'Fähenfurz',
      'Thorn Whip': 'Dornenpeitsche',
      'Viscid Emission': 'Klebsporen'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Rafflesia': 'Rafflesia',
      'Scar\'s Edge': 'l\'Huis de la Marque'
    },
    'replaceText': {
      'Acid Rain': 'Pluie acide',
      'Blighted Bouquet': 'Bouquet mildiousé',
      'Bloody Caress': 'Caresse sanglante',
      'Briary Growth': 'Poussée de tige',
      'Devour': 'Dévoration',
      'Floral Trap': 'Piège floral',
      'Leafstorm': 'Tempête de feuilles',
      'Rotten Stench': 'Pestilence nauséabonde',
      'Spit': 'Crachat',
      'Swarm': 'Nuée',
      'Thorn Whip': 'Fouet de ronces',
      'Viscid Emission': 'Émission visqueuse'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Rafflesia': 'ラフレシア',
      'Scar\'s Edge': '傷跡の門戸'
    },
    'replaceText': {
      'Acid Rain': '酸性雨',
      'Blighted Bouquet': 'ブライテッドブーケ',
      'Bloody Caress': 'ブラッディカレス',
      'Briary Growth': 'ブライアリーグロウス',
      'Devour': '捕食',
      'Floral Trap': 'フローラルトラップ',
      'Leafstorm': 'リーフストーム',
      'Rotten Stench': 'ロトンステンチ',
      'Spit': '吐出す',
      'Swarm': 'スウォーム',
      'Thorn Whip': 'ソーンウィップ',
      'Viscid Emission': 'ヴィシドエミッション'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Rafflesia': '大王花',
      'Scar\'s Edge': '破损的门前'
    },
    'replaceText': {
      'Acid Rain': '酸雨',
      'Blighted Bouquet': '凋零的花香',
      'Bloody Caress': '血腥的爱抚',
      'Briary Growth': '荆棘丛生',
      'Devour': '捕食',
      'Floral Trap': '鲜花陷阱',
      'Leafstorm': '绿叶风暴',
      'Rotten Stench': '腐烂恶臭',
      'Spit': '呕吐',
      'Swarm': '招蜂香气',
      'Thorn Whip': '荆棘鞭',
      'Viscid Emission': '胶质排放物'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Rafflesia': '라플레시아',
      'Scar\'s Edge': '상흔의 입구'
    },
    'replaceText': {
      'Acid Rain': '산성비',
      'Blighted Bouquet': '시든 꽃다발',
      'Bloody Caress': '피의 애무',
      'Briary Growth': '자라는 가시나무',
      'Devour': '포식',
      'Floral Trap': '향기의 덫',
      'Leafstorm': '잎사귀 폭풍',
      'Rotten Stench': '썩은 냄새',
      'Spit': '뱉기',
      'Swarm': '벌레 떼',
      'Thorn Whip': '가시채찍',
      'Viscid Emission': '점액 배출'
    }
  }]
};
/* harmony default export */ const t6 = (t6_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t6.txt
const raid_t6_namespaceObject = "# Turn 6\r\n# -ii 798 7A5 7A4 79F 870 7A7 7A1 7A6 83A -p 797:7.5 79D:204 79E:403 87A:1003\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Note: Use zone seal message instead of 0x104 line to start timeline\r\n# as there are pre-boss adds to start the encounter.\r\n\r\n### Phase 1\r\n0.0 \"Start\"\r\n# Scar's Edge will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"51C\" } window 10,10\r\n7.5 \"Bloody Caress\" Ability { id: \"797\", source: \"Rafflesia\" } window 8,8\r\n11.5 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n18.5 \"Briary Growth\" Ability { id: \"884\", source: \"Rafflesia\" } window 20,20\r\n20.6 \"Bloody Caress\" Ability { id: \"797\", source: \"Rafflesia\" }\r\n28.6 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n35.3 \"Floral Trap\" Ability { id: \"799\", source: \"Rafflesia\" }\r\n37.4 \"Devour\" Ability { id: \"79A\", source: \"Rafflesia\" }\r\n42.5 \"Spit\" Ability { id: \"79B\", source: \"Rafflesia\" }\r\n46.6 \"Bloody Caress\" Ability { id: \"797\", source: \"Rafflesia\" }\r\n55.6 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n58.7 \"Bloody Caress\" Ability { id: \"797\", source: \"Rafflesia\" }\r\n63.6 \"Briary Growth\" Ability { id: \"884\", source: \"Rafflesia\" } window 20,20\r\n70.8 \"Bloody Caress\" Ability { id: \"797\", source: \"Rafflesia\" }\r\n73.7 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n80.5 \"Floral Trap\" Ability { id: \"799\", source: \"Rafflesia\" }\r\n82.5 \"Devour\" Ability { id: \"79A\", source: \"Rafflesia\" }\r\n87.6 \"Spit\" Ability { id: \"79B\", source: \"Rafflesia\" }\r\n\r\n96.9 \"Bloody Caress\" Ability { id: \"797\", source: \"Rafflesia\" }\r\n100.9 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n107.9 \"Briary Growth\" Ability { id: \"884\", source: \"Rafflesia\" } window 20,20 jump 18.5\r\n110.0 \"Bloody Caress\"\r\n118.0 \"Thorn Whip\"\r\n124.7 \"Floral Trap\"\r\n126.8 \"Devour\"\r\n131.9 \"Spit\"\r\n136.0 \"Bloody Caress\"\r\n\r\n### Phase 2\r\n# There is a Bloody Caress (often?) right at the start of this phase before blighted.\r\n# But it's hard to sync to it properly, sorry.\r\n200.0 \"--sync--\" StartsUsing { id: \"79D\", source: \"Rafflesia\" } window 200,0\r\n204.0 \"Blighted Bouquet\" Ability { id: \"79D\", source: \"Rafflesia\" }\r\n209.0 \"Briary Growth\" Ability { id: \"884\", source: \"Rafflesia\" } window 20,20\r\n214.1 \"Bloody Caress\" Ability { id: \"797\", source: \"Rafflesia\" }\r\n219.0 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n225.8 \"Floral Trap\" Ability { id: \"799\", source: \"Rafflesia\" }\r\n227.8 \"Devour\" Ability { id: \"79A\", source: \"Rafflesia\" }\r\n232.8 \"Spit\" Ability { id: \"79B\", source: \"Rafflesia\" }\r\n235.8 \"Viscid Emission\" Ability { id: \"79C\", source: \"Rafflesia\" }\r\n240.9 \"Bloody Caress\" Ability { id: \"797\", source: \"Rafflesia\" }\r\n244.9 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n254.0 \"Blighted Bouquet\" Ability { id: \"79D\", source: \"Rafflesia\" }\r\n258.2 \"Bloody Caress\" Ability { id: \"797\", source: \"Rafflesia\" }\r\n260.1 \"Briary Growth\" Ability { id: \"884\", source: \"Rafflesia\" } window 20,20\r\n269.2 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n275.5 \"Floral Trap\" Ability { id: \"799\", source: \"Rafflesia\" }\r\n277.5 \"Devour\" Ability { id: \"79A\", source: \"Rafflesia\" }\r\n282.5 \"Spit\" Ability { id: \"79B\", source: \"Rafflesia\" }\r\n285.3 \"Bloody Caress\" Ability { id: \"797\", source: \"Rafflesia\" }\r\n294.2 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n297.5 \"Bloody Caress\" Ability { id: \"797\", source: \"Rafflesia\" }\r\n\r\n304.4 \"Blighted Bouquet\" Ability { id: \"79D\", source: \"Rafflesia\" } window 30,30 jump 204\r\n309.4 \"Briary Growth\"\r\n314.5 \"Bloody Caress\"\r\n319.4 \"Thorn Whip\"\r\n326.2 \"Floral Trap\"\r\n328.2 \"Devour\"\r\n333.2 \"Spit\"\r\n336.2 \"Viscid Emission\"\r\n\r\n### Phase 3\r\n# This ignores dinky leafstorms that do like 200 damage.\r\n\r\n400.0 \"--sync--\" StartsUsing { id: \"79E\", source: \"Rafflesia\" } window 400,0\r\n403.0 \"Leafstorm\" Ability { id: \"79E\", source: \"Rafflesia\" }\r\n413.1 \"Acid Rain\" Ability { id: \"86C\", source: \"Rafflesia\" }\r\n420.3 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n432.4 \"Swarm\" Ability { id: \"7A0\", source: \"Rafflesia\" }\r\n445.5 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n450.3 \"Rotten Stench\" Ability { id: \"7A2\", source: \"Rafflesia\" }\r\n465.5 \"Swarm\" Ability { id: \"7A0\", source: \"Rafflesia\" }\r\n478.5 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n490.7 \"Swarm\" Ability { id: \"7A0\", source: \"Rafflesia\" }\r\n495.6 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n500.1 \"Rotten Stench\" Ability { id: \"7A2\", source: \"Rafflesia\" }\r\n\r\n# looping leafstorm (the first one has swarm later)\r\n523.2 \"Leafstorm\" Ability { id: \"79E\", source: \"Rafflesia\" } window 100,300\r\n528.4 \"Swarm\" Ability { id: \"7A0\", source: \"Rafflesia\" }\r\n537.3 \"Acid Rain\" Ability { id: \"86C\", source: \"Rafflesia\" }\r\n544.4 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n556.7 \"Swarm\" Ability { id: \"7A0\", source: \"Rafflesia\" }\r\n569.6 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n574.4 \"Rotten Stench\" Ability { id: \"7A2\", source: \"Rafflesia\" }\r\n589.7 \"Swarm\" Ability { id: \"7A0\", source: \"Rafflesia\" }\r\n602.7 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n614.8 \"Swarm\" Ability { id: \"7A0\", source: \"Rafflesia\" }\r\n619.7 \"Thorn Whip\" Ability { id: \"879\", source: \"Rafflesia\" }\r\n624.5 \"Rotten Stench\" Ability { id: \"7A2\", source: \"Rafflesia\" }\r\n\r\n647.6 \"Leafstorm\"\r\n652.8 \"Swarm\"\r\n661.7 \"Acid Rain\"\r\n668.8 \"Thorn Whip\"\r\n681.1 \"Swarm\"\r\n694.0 \"Thorn Whip\"\r\n698.8 \"Rotten Stench\"\r\n714.1 \"Swarm\"\r\n727.1 \"Thorn Whip\"\r\n739.2 \"Swarm\"\r\n744.1 \"Thorn Whip\"\r\n748.9 \"Rotten Stench\"\r\n\r\n### Enrage\r\n# This does like 60k damage so probably will kill you\r\n# if you are so slow to see it, but just for completeness\r\n# it repeats every five seconds.\r\n1000.0 \"--sync--\" StartsUsing { id: \"87A\", source: \"Rafflesia\" } window 1000,1000\r\n1003.0 \"Leafstorm\" Ability { id: \"87A\", source: \"Rafflesia\" }\r\n1008.0 \"Leafstorm\"\r\n1013.0 \"Leafstorm\"\r\n1018.0 \"Leafstorm\"\r\n1023.0 \"Leafstorm\"\r\n1028.0 \"Leafstorm\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t7.ts




const t7_triggerSet = {
  id: 'TheSecondCoilOfBahamutTurn2',
  zoneId: zone_id/* default.TheSecondCoilOfBahamutTurn2 */.Z.TheSecondCoilOfBahamutTurn2,
  timelineFile: 't7.txt',
  initData: () => {
    return {
      monitoringHP: false,
      hpThresholds: [0.79, 0.59, 0.34],
      currentPhase: 0
    };
  },
  triggers: [{
    id: 'T7 Meluseine Phase Change Watcher',
    type: 'Ability',
    // On Tail Slap.
    netRegex: {
      id: '7A8',
      source: 'Melusine'
    },
    condition: data => !data.monitoringHP && data.hpThresholds[data.currentPhase] !== undefined,
    preRun: data => data.monitoringHP = true,
    promise: (data, matches) => util/* default.watchCombatant */.Z.watchCombatant({
      ids: [parseInt(matches.sourceId, 16)]
    }, ret => {
      return ret.combatants.some(c => {
        const currentHPCheck = data.hpThresholds[data.currentPhase] ?? -1;
        return c.CurrentHP / c.MaxHP <= currentHPCheck;
      });
    }),
    sound: 'Long',
    run: data => {
      data.currentPhase++;
      data.monitoringHP = false;
    }
  }, {
    id: 'T7 Ram',
    type: 'StartsUsing',
    netRegex: {
      id: '860',
      source: 'Proto-Chimera',
      capture: false
    },
    // TODO: is this silenceable in 5.0?
    condition: data => data.CanStun() || data.CanSilence(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Silence Ram\'s Voice',
        de: 'Verstumme Stimme des Widders',
        fr: 'Interrompez Voix du bélier',
        ja: '沈黙: 氷結の咆哮',
        cn: '沉默寒冰咆哮',
        ko: '빙결의 포효 침묵시키기'
      }
    }
  }, {
    id: 'T7 Dragon',
    type: 'StartsUsing',
    netRegex: {
      id: '861',
      source: 'Proto-Chimera',
      capture: false
    },
    // TODO: is this silenceable in 5.0?
    condition: data => data.CanStun() || data.CanSilence(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Silence Dragon\'s Voice',
        de: 'Verstumme Stimme des Drachens',
        fr: 'Interrompez Voix du dragon',
        ja: '沈黙: 雷電の咆哮',
        cn: '沉默雷电咆哮',
        ko: '뇌전의 포효 침묵시키기'
      }
    }
  }, {
    id: 'T7 Tail Slap',
    type: 'Ability',
    netRegex: {
      id: '7A8',
      source: 'Melusine'
    },
    condition: (data, matches) => data.me === matches.target && data.job === 'BLU',
    delaySeconds: 6,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tail Slap in 10',
        de: 'Schweifklapser in 10',
        fr: 'Gifle caudale dans 10s',
        ja: 'まもなくテールスラップ',
        cn: '10秒内死刑',
        ko: '10초 안에 꼬리치기'
      }
    }
  }, {
    id: 'T7 Renaud',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Renaud',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Renaud Add',
        de: 'Renaud Add',
        fr: 'Add Renaud',
        ja: '雑魚：ルノー',
        cn: '雷诺出现',
        ko: '르노 쫄'
      }
    }
  }, {
    id: 'T7 Cursed Voice',
    type: 'GainsEffect',
    netRegex: {
      effectId: '1C3'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 3,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Voice Soon',
        de: 'Stimme Der Verwünschung bald',
        fr: 'Voix du maléfice bientôt',
        ja: 'まもなく呪詛の声',
        cn: '诅咒之声即将判定',
        ko: '곧 저주의 목소리'
      }
    }
  }, {
    id: 'T7 Cursed Shriek',
    type: 'GainsEffect',
    netRegex: {
      effectId: '1C4'
    },
    durationSeconds: 3,
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) return output.shriekOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return output.shriekOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      shriekOn: {
        en: 'Shriek on ${player}',
        de: 'Schrei Der Verwünschung auf ${player}',
        fr: 'Cri du maléfice sur ${player}',
        ja: '${player}に呪詛の叫声',
        cn: '诅咒之嚎点${player}',
        ko: '"${player}" 저주의 외침 대상'
      },
      shriekOnYou: {
        en: 'Shriek on YOU',
        de: 'Schrei Der Verwünschung auf DIR',
        fr: 'Cri du maléfice sur VOUS',
        ja: '自分に呪詛の叫声',
        cn: '诅咒之嚎点名',
        ko: '저주의 외침 대상자'
      }
    }
  }, {
    id: 'T7 Cursed Shriek Reminder',
    type: 'GainsEffect',
    netRegex: {
      effectId: '1C4'
    },
    delaySeconds: 7,
    durationSeconds: 3,
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.shriekSoon();
      return output.dodgeShriek();
    },
    outputStrings: {
      shriekSoon: {
        en: 'Shriek Soon',
        de: 'Schrei Der Verwünschung bald',
        fr: 'Cri du maléfice bientôt',
        ja: 'まもなく呪詛の叫声',
        cn: '诅咒之嚎即将判定',
        ko: '곧 저주의 외침 발동'
      },
      dodgeShriek: {
        en: 'Dodge Shriek',
        de: 'Schrei Der Verwünschung ausweichen',
        fr: 'Esquivez le cri maudit',
        ja: '呪詛の叫声を避ける',
        cn: '躲避诅咒之嚎',
        ko: '저주의 외침 피하기'
      }
    }
  }, {
    id: 'T7 Petrifaction 1',
    type: 'StartsUsing',
    netRegex: {
      id: '7BB',
      source: 'Lamia Prosector',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'T7 Petrifaction 2',
    type: 'StartsUsing',
    netRegex: {
      id: '7B1',
      source: 'Melusine',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'T7 Tail',
    type: 'StartsUsing',
    netRegex: {
      id: '7B2',
      source: 'Melusine',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Venomous Tail',
        de: 'Venomschweif',
        fr: 'Queue venimeuse',
        ja: 'ベノモステール',
        cn: '猛毒之尾',
        ko: '맹독 꼬리'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bioweapon Storage': 'Biowaffen-Magazin',
      'Lamia Prosector': 'Lamia-Prosektorin',
      'Melusine': 'Melusine',
      'Proto-Chimera': 'Proto-Chimära',
      'Renaud': 'Renaud'
    },
    'replaceText': {
      'Circle Blade': 'Kreisklinge',
      'Circle Of Flames': 'Feuerkreis',
      'Cursed Shriek': 'Schrei der Verwünschung',
      'Cursed Voice': 'Stimme der Verwünschung',
      'Deathdancer': 'Todestänzerin',
      'Frenzy': 'Verve',
      'Petrifaction': 'Versteinerung',
      'Red Lotus Blade': 'Rote Lotosklinge',
      'Sacrifice': 'Aufopferung',
      'Tail Slap': 'Schweifklapser',
      'Venomous Tail': 'Venomschweif'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bioweapon Storage': 'l\'entrepôt d\'armes biologiques',
      'Lamia Prosector': 'Lamia Dissectrice',
      'Melusine': 'Mélusine',
      'Proto-Chimera': 'Protochimère',
      'Renaud': 'Renaud'
    },
    'replaceText': {
      'Circle Blade': 'Lame circulaire',
      'Circle Of Flames': 'Cercle de flammes',
      'Cursed Shriek': 'Cri maudit',
      'Cursed Voice': 'Voix maudite',
      'Deathdancer Add': 'Add Danseuse de mort',
      'Frenzy': 'Frénésie',
      'Petrifaction': 'Pétrification',
      'Red Lotus Blade': 'Lame lotus rouge',
      'Sacrifice': 'Sacrifice',
      'Tail Slap': 'Gifle caudale',
      'Venomous Tail': 'Queue venimeuse'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bioweapon Storage': '生体管理区',
      'Lamia Prosector': 'ラミア・プロセクター',
      'Melusine': 'メリュジーヌ',
      'Proto-Chimera': 'プロトキマイラ',
      'Renaud': 'ルノー'
    },
    'replaceText': {
      '(.*) Adds?': '雑魚: $1',
      'Circle Blade': 'サークルブレード',
      'Circle Of Flames': 'サークル・オブ・フレイム',
      'Cursed Shriek': '呪詛の叫声',
      'Cursed Voice': '呪詛の声',
      'Deathdancer': 'デスダンサー',
      'Frenzy': '熱狂',
      'Petrifaction': 'ペトリファクション',
      'Red Lotus Blade': 'レッドロータス',
      'Sacrifice': 'サクリファイス',
      'Tail Slap': 'テールスラップ',
      'Venomous Tail': 'ベノモステール'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bioweapon Storage': '生体管理区',
      'Lamia Prosector': '拉米亚解剖女王',
      'Melusine': '美瑠姬奴',
      'Proto-Chimera': '原型奇美拉',
      'Renaud': '雷诺'
    },
    'replaceText': {
      'Circle Blade': '回旋斩',
      'Circle Of Flames': '地层断裂',
      'Cursed Shriek': '诅咒之嚎',
      'Cursed Voice': '诅咒之声',
      'Deathdancer': '死亡舞师',
      'Frenzy': '狂热',
      'Petrifaction': '石化',
      'Red Lotus Blade': '红莲',
      'Sacrifice': '献祭',
      'Tail Slap': '尾部猛击',
      'Venomous Tail': '猛毒之尾'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bioweapon Storage': '생체 관리 구역',
      'Lamia Prosector': '라미아 시체해부자',
      'Melusine': '멜뤼진',
      'Proto-Chimera': '프로토 키마이라',
      'Renaud': '르노'
    },
    'replaceText': {
      'Circle Blade': '회전 베기',
      'Circle Of Flames': '화염의 원',
      'Cursed Shriek': '저주의 외침',
      'Cursed Voice': '저주의 목소리',
      'Deathdancer': '죽음무용수',
      'Frenzy': '열광',
      'Petrifaction': '석화',
      'Red Lotus Blade': '홍련의 칼날',
      'Sacrifice': '희생',
      'Tail Slap': '꼬리치기',
      'Venomous Tail': '맹독 꼬리'
    }
  }]
};
/* harmony default export */ const t7 = (t7_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t7.txt
const raid_t7_namespaceObject = "### Turn 7\r\n# -ii 7B6 7B4 7B5 7B9 7BA 7BE 7B7 7B8 7BD 7B3 7BF 7BB 7BC\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Note: Use zone seal message instead of 0x104 line to start timeline\r\n# as there are pre-boss adds to start the encounter.\r\n\r\n### Phase 1 (100%)\r\n\r\n# Bioweapon Storage will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"51E\" } window 10,10\r\n6.4 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" } window 7,0\r\n12.3 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n14.3 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n24.8 \"Circle Blade\" Ability { id: \"7AB\", source: \"Melusine\" }\r\n26.5 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n30.3 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n36.4 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n42.5 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n48.8 \"Circle Blade\" Ability { id: \"7AB\", source: \"Melusine\" }\r\n50.5 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n60.4 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n61.5 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n66.3 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n72.7 \"Circle Blade\" Ability { id: \"7AB\", source: \"Melusine\" }\r\n77.5 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n82.3 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n86.6 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n93.6 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n97.1 \"Circle Blade\" Ability { id: \"7AB\", source: \"Melusine\" }\r\n99.1 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n110.7 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n111.8 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n114.8 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n121.2 \"Circle Blade\" Ability { id: \"7AB\", source: \"Melusine\" }\r\n127.8 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n130.8 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n135.1 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n145.3 \"Circle Blade\" Ability { id: \"7AB\", source: \"Melusine\" }\r\n147.3 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n148.4 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n159.2 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n163.1 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n164.2 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n169.1 \"Circle Blade\" Ability { id: \"7AB\", source: \"Melusine\" }\r\n179.1 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n180.2 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n184.5 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n193.3 \"Circle Blade\" Ability { id: \"7AB\", source: \"Melusine\" }\r\n195.2 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n196.6 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n### Phase 2 (80%): shriek, 3 adds 30 seconds apart\r\n# Note: This used to be synced from a HP% log line that is no longer present.\r\n306.6 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" } window 10,10\r\n314.6 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n319.0 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" } duration 11 window 319,30\r\n322.6 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n328.2 \"Circle Blade\" Ability { id: \"7AB\", source: \"Melusine\" }\r\n330.0 \"Deathdancer Add (NE)\"\r\n330.7 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n336.6 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n338.8 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n345.6 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" } window 155,10\r\n346.7 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n354.6 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n360.0 \"Deathdancer Add (NW)\"\r\n360.8 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n362.6 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n366.8 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" } duration 11\r\n370.7 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n374.5 \"Circle Blade\" Ability { id: \"7AB\", source: \"Melusine\" }\r\n378.8 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n384.8 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n386.8 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n394.7 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n402.8 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n408.8 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n410.8 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n415.0 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" } duration 11\r\n420.3 \"Circle Blade\" Ability { id: \"7AB\", source: \"Melusine\" }\r\n422.1 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n426.8 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n432.8 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n438.0 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n442.8 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n454.2 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n457.3 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n459.0 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n463.2 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" } duration 11\r\n466.9 \"Circle Blade\" Ability { id: \"7AB\", source: \"Melusine\" }\r\n470.2 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n475.0 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n481.4 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n486.2 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n491.1 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n502.2 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n505.5 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n507.2 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n511.4 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" } duration 11\r\n515.1 \"Circle Blade\" Ability { id: \"7AB\", source: \"Melusine\" }\r\n518.3 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n523.2 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n529.5 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n534.4 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n539.2 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n\r\n### Phase 3 (59%): 4 archer adds, exploding floor\r\n# Note: This used to be synced from a HP% log line that is no longer present.\r\n812.0 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" } window 12,10\r\n814.0 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n820.1 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" } window 820,20\r\n822.1 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n830.2 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n836.1 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n840.2 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n843.3 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" }\r\n846.3 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n852.2 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n854.3 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n860.2 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n862.2 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n870.3 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n878.4 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n884.3 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n\r\n885.4 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n886.5 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n890.5 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" }\r\n894.4 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n902.8 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n908.3 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n910.5 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n917.5 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n918.7 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n926.6 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n932.5 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n934.8 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n937.8 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" }\r\n942.7 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n949.4 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n950.6 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n956.2 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n958.4 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n966.4 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n974.4 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n980.2 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n\r\n981.5 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n982.6 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n985.7 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" }\r\n990.4 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n998.6 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1004.2 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1006.4 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n1013.3 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n1014.6 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1022.5 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n1028.3 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1030.7 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1033.8 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" }\r\n1038.5 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n1045.4 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n1046.7 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1052.3 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1054.5 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n1062.7 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1070.5 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n1076.3 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n\r\n1077.4 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n1078.7 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1081.8 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" }\r\n1086.7 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n1094.8 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1100.4 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1102.6 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n1109.5 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n1110.9 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1118.6 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n1124.3 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1126.7 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1129.8 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" }\r\n1134.6 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n1141.4 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n1142.7 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1148.4 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1150.6 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n1158.7 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1166.6 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n1172.3 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n\r\n1173.4 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n1174.7 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1177.8 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" }\r\n1182.6 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n1190.9 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1196.2 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1198.6 \"Circle Of Flames x2\" #sync Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n\r\n### Phase 5 (post-prosecutor): venomous tail\r\n1600.0 \"Sacrifice\" Ability { id: \"86E\", source: \"Lamia Prosector\" } window 1600,0\r\n1601.0 \"Frenzy\" Ability { id: \"86D\", source: \"Melusine\" }\r\n\r\n1608.1 \"Petrifaction\" Ability { id: \"7B1\", source: \"Melusine\" } window 1610,5\r\n1611.3 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1617.9 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n1624.0 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1627.1 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1630.1 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" }\r\n1634.1 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n1638.9 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n1643.0 \"Venomous Tail\" Ability { id: \"7B2\", source: \"Melusine\" }\r\n1644.1 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1647.9 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1650.1 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n1655.3 \"Petrifaction\" Ability { id: \"7B1\", source: \"Melusine\" }\r\n1660.2 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1666.2 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n1672.1 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1673.3 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n1677.2 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" }\r\n1678.5 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1682.2 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n1690.2 \"Venomous Tail\" Ability { id: \"7B2\", source: \"Melusine\" }\r\n1696.1 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1697.4 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1698.4 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n1703.5 \"Petrifaction\" Ability { id: \"7B1\", source: \"Melusine\" }\r\n1705.3 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n1713.3 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1714.4 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n1720.2 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1724.1 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" }\r\n1729.2 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1730.5 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n1737.2 \"Venomous Tail\" Ability { id: \"7B2\", source: \"Melusine\" }\r\n1740.4 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n1744.2 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1746.8 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1747.9 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n1752.9 \"Petrifaction\" Ability { id: \"7B1\", source: \"Melusine\" }\r\n1761.4 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1763.8 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n1768.4 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1771.5 \"Cursed Shriek\" Ability { id: \"7AF\", source: \"Melusine\" }\r\n1772.8 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n1777.6 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1780.0 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n1785.2 \"Venomous Tail\" Ability { id: \"7B2\", source: \"Melusine\" }\r\n1792.4 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n1795.9 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1796.9 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n\r\n1802.1 \"Petrifaction\" Ability { id: \"7B1\", source: \"Melusine\" }\r\n1804.9 \"Red Lotus Blade\" Ability { id: \"7A9\", source: \"Melusine\" }\r\n1809.7 \"Tail Slap\" Ability { id: \"7A8\", source: \"Melusine\" }\r\n1813.0 \"Circle Of Flames x2\" #Ability { id: \"7AA\", source: \"Melusine\" }\r\n1817.2 \"Cursed Voice\" Ability { id: \"7AC\", source: \"Melusine\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t8.ts


const t8_triggerSet = {
  id: 'TheSecondCoilOfBahamutTurn3',
  zoneId: zone_id/* default.TheSecondCoilOfBahamutTurn3 */.Z.TheSecondCoilOfBahamutTurn3,
  timelineFile: 't8.txt',
  initData: () => {
    return {
      landmines: {}
    };
  },
  triggers: [{
    id: 'T8 Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '0011'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn('info')
  }, {
    // https://xivapi.com/LogMessage/2278
    // en: Landmines have been scattered...
    id: 'T8 Landmine Start',
    type: 'SystemLogMessage',
    netRegex: {
      id: '8E6',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.landmines = {},
    outputStrings: {
      text: {
        en: 'Explode Landmines',
        de: 'Landminen explodieren',
        fr: 'Explosez les mines',
        ja: '地雷を踏む',
        cn: '引爆地雷',
        ko: '지뢰 폭발시키기'
      }
    }
  }, {
    id: 'T8 Landmine Explosion',
    type: 'Ability',
    netRegex: {
      id: '7D1',
      source: 'Allagan Mine'
    },
    infoText: (data, matches, output) => {
      if (matches.target in data.landmines) return;
      const num = Object.keys(data.landmines).length + 1;
      return output.landmine({
        num: num
      });
    },
    tts: (data, matches, output) => {
      if (matches.target in data.landmines) return;
      const num = Object.keys(data.landmines).length + 1;
      return output.landmineTTS({
        num: num
      });
    },
    run: (data, matches) => {
      if (matches.target) data.landmines[matches.target] = true;
    },
    outputStrings: {
      landmine: {
        en: '${num} / 3',
        de: '${num} / 3',
        fr: '${num} / 3',
        ja: '${num} / 3',
        cn: '${num} / 3',
        ko: '${num} / 3'
      },
      landmineTTS: {
        en: '${num}',
        de: '${num}',
        fr: '${num}',
        ja: '${num}',
        cn: '${num}',
        ko: '${num}'
      }
    }
  }, {
    id: 'T8 Homing Missile Warning',
    type: 'Tether',
    netRegex: {
      id: '0005',
      target: 'The Avatar'
    },
    suppressSeconds: 6,
    infoText: (data, matches, output) => {
      return output.text({
        player: data.party.member(matches.source)
      });
    },
    outputStrings: {
      text: {
        en: 'Missile Tether (on ${player})',
        de: 'Raketen Tether (auf ${player})',
        fr: 'Lien missile sur ${player}',
        ja: '${player}にミサイル',
        cn: '导弹连线(on ${player})',
        ko: '"${player}" 유도 미사일 대상'
      }
    }
  }, {
    id: 'T8 Brainjack',
    type: 'StartsUsing',
    netRegex: {
      id: '7C3',
      source: 'The Avatar'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.brainjackOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return output.brainjackOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      brainjackOn: {
        en: 'Brainjack on ${player}',
        de: 'Gehirnwäsche auf ${player}',
        fr: 'Détournement cérébral sur ${player}',
        ja: '${player}に混乱',
        cn: '洗脑点${player}',
        ko: '"${player}" 두뇌 장악 대상'
      },
      brainjackOnYou: {
        en: 'Brainjack on YOU',
        de: 'Gehirnwäsche auf DIR',
        fr: 'Détournement cérébral sur VOUS',
        ja: '自分に混乱',
        cn: '洗脑点名',
        ko: '두뇌 장악 대상자'
      }
    }
  }, {
    id: 'T8 Allagan Field',
    type: 'StartsUsing',
    netRegex: {
      id: '7C4',
      source: 'The Avatar'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.allaganFieldOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return output.allaganFieldOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      allaganFieldOn: {
        en: 'Allagan Field on ${player}',
        de: 'Allagisches Feld auf ${player}',
        fr: 'Champ allagois sur ${player}',
        ja: '${player}にアラガンフィールド',
        cn: '亚拉戈领域点${player}',
        ko: '"${player}" 알라그 필드 대상'
      },
      allaganFieldOnYou: {
        en: 'Allagan Field on YOU',
        de: 'Allagisches Feld auf DIR',
        fr: 'Champ allagois sur VOUS',
        ja: '自分にアラガンフィールド',
        cn: '亚拉戈领域点名',
        ko: '알라그 필드 대상자'
      }
    }
  }, {
    id: 'T8 Dreadnaught',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Clockwork Dreadnaught',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dreadnaught Add',
        de: 'Brummonaut Add',
        fr: 'Add Cuirassé',
        ja: '雑魚：ドレッドノート',
        cn: '恐慌装甲出现',
        ko: '드레드노트 쫄'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Allagan Field': 'Allagisches Feld',
      'Allagan Mine': 'Allagische Mine',
      'Clockwork Dreadnaught': 'Brummonaut',
      'The Avatar': 'Avatar',
      'The central bow': 'Rumpf-Zentralsektor'
    },
    'replaceText': {
      'Allagan Field': 'Allagisches Feld',
      'Atomic Ray': 'Atomstrahlung',
      'Ballistic Missile': 'Ballistische Rakete',
      'Brainjack': 'Gehirnwäsche',
      'Critical Surge': 'Kritischer Schub',
      'Diffusion Ray': 'Diffusionsstrahl',
      'Gaseous Bomb': 'Explosives Gasgemisch',
      'Homing Missile': 'Lenkgeschoss',
      'Inertia Stream': 'Trägheitsstrom'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Allagan Field': 'Champ Allagois',
      'Allagan Mine': 'Mine Allagoise',
      'Clockwork Dreadnaught': 'Cuirassé Dreadnaught',
      'The Avatar': 'Bio-Tréant',
      'The central bow': 'l\'axe central - proue'
    },
    'replaceText': {
      'Allagan Field': 'Champ allagois',
      'Atomic Ray': 'Rayon atomique',
      'Ballistic Missile': 'Missiles balistiques',
      'Brainjack': 'Détournement cérébral',
      'Critical Surge': 'Trouée critique',
      'Diffusion Ray': 'Rayon diffuseur',
      'Gaseous Bomb': 'Bombe gazeuse',
      'Homing Missile': 'Tête chercheuse',
      'Inertia Stream': 'Courant apathique'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Allagan Field': 'アラガンフィールド',
      'Allagan Mine': 'アラガンマイン',
      'Clockwork Dreadnaught': 'ドレッドノート',
      'The Avatar': 'アバター',
      'The central bow': '中枢艦首区'
    },
    'replaceText': {
      'Allagan Field': 'アラガンフィールド',
      'Atomic Ray': 'アトミックレイ',
      'Ballistic Missile': 'バリスティックミサイル',
      'Brainjack': 'ブレインジャック',
      'Critical Surge': '臨界突破',
      'Diffusion Ray': 'ディフュージョンレイ',
      'Gaseous Bomb': '気化爆弾',
      'Homing Missile': 'ホーミングミサイル',
      'Inertia Stream': 'イナーシャストリーム'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Allagan Field': '亚拉戈领域',
      'Allagan Mine': '亚拉戈机雷',
      'Clockwork Dreadnaught': '恐慌装甲',
      'The Avatar': '降世化身',
      'The central bow': '中枢舰首区'
    },
    'replaceText': {
      'Allagan Field': '亚拉戈领域',
      'Atomic Ray': '原子射线',
      'Ballistic Missile': '弹道导弹',
      'Brainjack': '洗脑',
      'Critical Surge': '临界突破',
      'Diffusion Ray': '扩散射线',
      'Gaseous Bomb': '气化炸弹',
      'Homing Missile': '自控导弹',
      'Inertia Stream': '惰性流'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Allagan Field': '알라그 필드',
      'Allagan Mine': '알라그 지뢰',
      'Clockwork Dreadnaught': '드레드노트',
      'The Avatar': '아바타',
      'The central bow': '중추 함수 구역'
    },
    'replaceText': {
      'Allagan Field': '알라그 필드',
      'Atomic Ray': '원자 파동',
      'Ballistic Missile': '탄도 미사일',
      'Brainjack': '두뇌 장악',
      'Critical Surge': '임계 돌파',
      'Diffusion Ray': '확산 광선',
      'Gaseous Bomb': '기화 폭탄',
      'Homing Missile': '유도 미사일',
      'Inertia Stream': '관성 기류'
    }
  }]
};
/* harmony default export */ const t8 = (t8_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t8.txt
const raid_t8_namespaceObject = "### Turn 8\r\n# -ii 7D1 87C 87D 7CC 7CD 7CF 7CE -p 7C9:162.6 7C8:800\r\n\r\n# Note: sadly there's nothing in the logs about towers and so\r\n# there's no way to really include them here.\r\n\r\n# Note: Use zone seal message instead of 0x104 line to start timeline\r\n# as there are pre-boss adds to start the encounter.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1: introduction to towers\r\n0.0 \"Start\"\r\n# Central Bow will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"532\" } window 10,10\r\n6.1 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" } window 7,10\r\n26.0 \"Homing Missile\" Ability { id: \"7C7\", source: \"The Avatar\" }\r\n27.2 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n34.9 \"Gaseous Bomb\" Ability { id: \"7C6\", source: \"The Avatar\" }\r\n42.2 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n57.3 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n65.9 \"Homing Missile\" Ability { id: \"7C7\", source: \"The Avatar\" }\r\n75.0 \"Gaseous Bomb\" Ability { id: \"7C6\", source: \"The Avatar\" }\r\n76.2 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n91.2 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n106.0 \"Homing Missile\" Ability { id: \"7C7\", source: \"The Avatar\" }\r\n107.2 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n115.0 \"Gaseous Bomb\" Ability { id: \"7C6\", source: \"The Avatar\" }\r\n122.2 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n137.2 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n146.0 \"Homing Missile\" Ability { id: \"7C7\", source: \"The Avatar\" }\r\n155.0 \"Gaseous Bomb\" Ability { id: \"7C6\", source: \"The Avatar\" }\r\n156.2 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n\r\n### Phase 2 (75%): brainjack + ballistic missile\r\n# Inertia Stream hits twice 1 second apart.\r\n# Only sync backwards for this first of three.\r\n162.6 \"Inertia Stream\" Ability { id: \"7C9\", source: \"The Avatar\" } window 170,0\r\n168.9 \"Ballistic Missile\" Ability { id: \"7CA\", source: \"The Avatar\" }\r\n176.6 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n184.5 \"Brainjack\" Ability { id: \"7C3\", source: \"The Avatar\" } duration 11\r\n191.6 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n199.5 \"Homing Missile\" Ability { id: \"7C7\", source: \"The Avatar\" }\r\n206.6 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n215.5 \"Gaseous Bomb\" Ability { id: \"7C6\", source: \"The Avatar\" }\r\n224.6 \"Brainjack\" Ability { id: \"7C3\", source: \"The Avatar\" } duration 11\r\n225.8 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n239.6 \"Homing Missile\" Ability { id: \"7C7\", source: \"The Avatar\" }\r\n240.9 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n242.0 \"Inertia Stream\"\r\n248.3 \"Ballistic Missile\" Ability { id: \"7CA\", source: \"The Avatar\" }\r\n255.6 \"Gaseous Bomb\" Ability { id: \"7C6\", source: \"The Avatar\" }\r\n256.8 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n264.7 \"Brainjack\" Ability { id: \"7C3\", source: \"The Avatar\" } duration 11\r\n271.7 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n279.6 \"Homing Missile\" Ability { id: \"7C7\", source: \"The Avatar\" }\r\n286.8 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n295.7 \"Gaseous Bomb\" Ability { id: \"7C6\", source: \"The Avatar\" }\r\n304.8 \"Brainjack\" Ability { id: \"7C3\", source: \"The Avatar\" } duration 11\r\n306.0 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n319.7 \"Homing Missile\" Ability { id: \"7C7\", source: \"The Avatar\" }\r\n321.0 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n322.2 \"Inertia Stream\"\r\n328.4 \"Ballistic Missile\" Ability { id: \"7CA\", source: \"The Avatar\" }\r\n335.8 \"Gaseous Bomb\" Ability { id: \"7C6\", source: \"The Avatar\" }\r\n337.0 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n344.9 \"Brainjack\" Ability { id: \"7C3\", source: \"The Avatar\" } duration 11\r\n352.0 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n359.8 \"Homing Missile\" Ability { id: \"7C7\", source: \"The Avatar\" }\r\n367.1 \"Diffusion Ray\" Ability { id: \"7C2\", source: \"The Avatar\" }\r\n375.9 \"Gaseous Bomb\" Ability { id: \"7C6\", source: \"The Avatar\" }\r\n\r\n### Phase 3 (45%): allagan field\r\n# NOTE: there seems to be two different last phase timings\r\n# for diffusion ray, depending on when you push.\r\n# There's the allagan field + 2 ray pattern (e.g. 380), where ray comes with missile/late\r\n# There's the allagan field + 3 ray pattern (e.g. 420), where ray comes with field/bomb/surge\r\n# The first 380 pattern seems always correct, however sometimes the 420 pattern\r\n# can instead be the 380/460 pattern, with a different diffusion ray.\r\n# The field/missile/bomb/surge timings are all roughly the same, so this\r\n# just removes the ray syncs and hopes for the best.\r\n377.0 \"--sync--\" StartsUsing { id: \"7C4\", source: \"The Avatar\" } window 400,0\r\n380.0 \"Allagan Field\" Ability { id: \"7C4\", source: \"The Avatar\" } duration 31 window 400,10\r\n386.3 \"Homing Missile\" Ability { id: \"7C7\", source: \"The Avatar\" }\r\n387.6 \"Diffusion Ray\" #Ability { id: \"7C2\", source: \"The Avatar\" }\r\n394.2 \"Gaseous Bomb\" Ability { id: \"7C6\", source: \"The Avatar\" }\r\n402.5 \"Diffusion Ray\" #Ability { id: \"7C2\", source: \"The Avatar\" }\r\n410.9 \"Critical Surge\" Ability { id: \"7C5\", source: \"Allagan Field\" }\r\n\r\n420.0 \"Allagan Field\" Ability { id: \"7C4\", source: \"The Avatar\" } duration 31\r\n421.2 \"Diffusion Ray\" #Ability { id: \"7C2\", source: \"The Avatar\" }\r\n427.2 \"Homing Missile\" Ability { id: \"7C7\", source: \"The Avatar\" }\r\n434.2 \"Gaseous Bomb\" Ability { id: \"7C6\", source: \"The Avatar\" }\r\n436.2 \"Diffusion Ray\" #Ability { id: \"7C2\", source: \"The Avatar\" }\r\n450.8 \"Critical Surge\" Ability { id: \"7C5\", source: \"Allagan Field\" }\r\n451.2 \"Diffusion Ray\" #Ability { id: \"7C2\", source: \"The Avatar\" }\r\n\r\n460.1 \"Allagan Field\" Ability { id: \"7C4\", source: \"The Avatar\" } duration 31\r\n467.3 \"Homing Missile\" Ability { id: \"7C7\", source: \"The Avatar\" }\r\n468.5 \"Diffusion Ray\" #Ability { id: \"7C2\", source: \"The Avatar\" }\r\n474.3 \"Gaseous Bomb\" Ability { id: \"7C6\", source: \"The Avatar\" }\r\n483.6 \"Diffusion Ray\" #Ability { id: \"7C2\", source: \"The Avatar\" }\r\n490.9 \"Critical Surge\" Ability { id: \"7C5\", source: \"Allagan Field\" }\r\n\r\n500.0 \"Allagan Field\" Ability { id: \"7C4\", source: \"The Avatar\" } duration 31\r\n501.2 \"Diffusion Ray\" #Ability { id: \"7C2\", source: \"The Avatar\" }\r\n507.3 \"Homing Missile\" Ability { id: \"7C7\", source: \"The Avatar\" }\r\n514.3 \"Gaseous Bomb\" Ability { id: \"7C6\", source: \"The Avatar\" }\r\n516.2 \"Diffusion Ray\" #Ability { id: \"7C2\", source: \"The Avatar\" }\r\n530.9 \"Critical Surge\" Ability { id: \"7C5\", source: \"Allagan Field\" }\r\n531.2 \"Diffusion Ray\" #Ability { id: \"7C2\", source: \"The Avatar\" }\r\n\r\n540.1 \"Allagan Field\" Ability { id: \"7C4\", source: \"The Avatar\" } duration 31 jump 460.1\r\n547.3 \"Homing Missile\"\r\n548.5 \"Diffusion Ray\"\r\n554.3 \"Gaseous Bomb\"\r\n563.5 \"Diffusion Ray\"\r\n570.9 \"Critical Surge\"\r\n\r\n\r\n### Phase 4: Enrage\r\n800.0 \"Atomic Ray\" Ability { id: \"7C8\", source: \"The Avatar\" } window 800,800\r\n805.1 \"Atomic Ray\"\r\n810.2 \"Atomic Ray\"\r\n815.3 \"Atomic Ray\"\r\n820.4 \"Atomic Ray\"\r\n825.5 \"Atomic Ray\"\r\n830.6 \"Atomic Ray\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t9.ts





const diveDirections = {
  unknown: outputs/* default.unknown */.Z.unknown,
  north: outputs/* default.dirN */.Z.dirN,
  northeast: outputs/* default.dirNE */.Z.dirNE,
  east: outputs/* default.dirE */.Z.dirE,
  southeast: outputs/* default.dirSE */.Z.dirSE,
  south: outputs/* default.dirS */.Z.dirS,
  southwest: outputs/* default.dirSW */.Z.dirSW,
  west: outputs/* default.dirW */.Z.dirW,
  northwest: outputs/* default.dirNW */.Z.dirNW
};
const t9_triggerSet = {
  id: 'TheSecondCoilOfBahamutTurn4',
  zoneId: zone_id/* default.TheSecondCoilOfBahamutTurn4 */.Z.TheSecondCoilOfBahamutTurn4,
  timelineFile: 't9.txt',
  initData: () => {
    return {
      monitoringHP: false,
      seenFinalPhase: false,
      tetherCount: 0,
      naelDiveMarkerCount: 0
    };
  },
  timelineTriggers: [{
    id: 'T9 Claw',
    regex: /Bahamut's Claw x5/,
    beforeSeconds: 5,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'T9 Dalamud Dive',
    regex: /Dalamud Dive/,
    beforeSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dive on Main Tank',
        de: 'Sturz auf den Main Tank',
        fr: 'Plongeon sur le Main Tank',
        ja: 'MTに飛んでくる',
        cn: '凶鸟跳点MT',
        ko: '광역 탱버'
      }
    }
  }, {
    id: 'T9 Super Nova',
    regex: /Super Nova x3/,
    beforeSeconds: 4,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Super Novas Outside',
        de: 'Köder Supernova draußen',
        fr: 'Attirez les Supernovas à l\'extérieur',
        ja: 'スーパーノヴァを外に設置',
        cn: '人群外放黑洞',
        ko: '초신성 외곽으로 유도'
      }
    }
  }],
  triggers: [{
    id: 'T9 Raven Blight You',
    type: 'GainsEffect',
    netRegex: {
      effectId: '1CA'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 5,
    durationSeconds: 5,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Blight on YOU',
        de: 'Pestschwinge auf DIR',
        fr: 'Bile de rapace sur VOUS',
        ja: '自分に凶鳥毒気',
        cn: '毒气点名',
        ko: '흉조의 독 대상자'
      }
    }
  }, {
    id: 'T9 Raven Blight Not You',
    type: 'GainsEffect',
    netRegex: {
      effectId: '1CA'
    },
    condition: conditions/* default.targetIsNotYou */.Z.targetIsNotYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 5,
    durationSeconds: 5,
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.target)
    }),
    outputStrings: {
      text: {
        en: 'Blight on ${player}',
        de: 'Pestschwinge auf ${player}',
        fr: 'Bile de rapace sur ${player}',
        ja: '${player}に凶鳥毒気',
        cn: '毒气点${player}',
        ko: '${player} 흉조의 독'
      }
    }
  }, {
    id: 'T9 Meteor',
    type: 'HeadMarker',
    netRegex: {
      id: '000[7A9]'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.meteorOnYou */.n3.meteorOnYou()
  }, {
    id: 'T9 Meteor Stream',
    type: 'HeadMarker',
    netRegex: {
      id: '0008'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'T9 Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '000F'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.thermoOnYou();
      return output.stackOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      thermoOnYou: {
        en: 'Thermo on YOU',
        de: 'Thermo auf DIR',
        fr: 'Thermo sur VOUS',
        ja: '自分に頭割り',
        cn: '分摊点名',
        ko: '쉐어징 대상자'
      },
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'T9 Phase 2',
    type: 'Ability',
    // Ravensclaw
    netRegex: {
      id: '7D5',
      source: 'Nael Deus Darnus'
    },
    condition: data => !data.beganMonitoringHp,
    preRun: data => data.beganMonitoringHp = true,
    promise: (_data, matches) => util/* default.watchCombatant */.Z.watchCombatant({
      ids: [parseInt(matches.sourceId, 16)]
    }, ret => {
      return ret.combatants.some(c => {
        return c.CurrentHP / c.MaxHP <= 0.64;
      });
    }),
    sound: 'Long'
  }, {
    id: 'T9 Earthshock',
    type: 'StartsUsing',
    netRegex: {
      id: '7F5',
      source: 'Dalamud Spawn',
      capture: false
    },
    condition: data => data.CanSilence(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Silence Blue Golem',
        de: 'Blauen Golem verstummen',
        fr: 'Interrompez le Golem bleu',
        ja: '沈黙：青ゴーレム',
        cn: '沉默蓝色小怪',
        ko: '파란골렘 기술끊기'
      }
    }
  }, {
    id: 'T9 Heavensfall',
    type: 'StartsUsing',
    netRegex: {
      id: '83B',
      source: 'Nael Deus Darnus',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Heavensfall',
        de: 'Himmelssturz',
        fr: 'Destruction universelle',
        ja: '天地崩壊',
        cn: '击退AOE',
        ko: '천지붕괴'
      }
    }
  }, {
    id: 'T9 Garotte Twist Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '1CE'
    },
    condition: (data, matches) => data.me === matches.target && !data.garotte,
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.garotte = true,
    outputStrings: {
      text: {
        en: 'Garotte on YOU',
        de: 'Leicht fixierbar auf DIR',
        fr: 'Sangle accélérée sur VOUS',
        ja: '自分に拘束加速',
        cn: '连坐点名',
        ko: '구속 가속'
      }
    }
  }, {
    id: 'T9 Ghost Death',
    type: 'Ability',
    netRegex: {
      id: '7FA',
      source: 'The Ghost Of Meracydia',
      capture: false
    },
    condition: data => data.garotte,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse Garotte',
        de: 'reinige Leicht fixierbar',
        fr: 'Dissipez Sangle accélérée',
        ja: '白い床に乗る',
        cn: '踩白圈',
        ko: '흰색 장판 밟기'
      }
    }
  }, {
    id: 'T9 Garotte Twist Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '1CE'
    },
    condition: (data, matches) => data.me === matches.target && data.garotte,
    run: data => delete data.garotte
  }, {
    id: 'T9 Final Phase',
    type: 'StartsUsing',
    netRegex: {
      id: '7E6',
      source: 'Nael Deus Darnus',
      capture: false
    },
    condition: data => !data.seenFinalPhase,
    sound: 'Long',
    run: data => data.seenFinalPhase = true
  }, {
    id: 'T9 Dragon Locations',
    type: 'AddedCombatant',
    netRegex: {
      name: ['Firehorn', 'Iceclaw', 'Thunderwing']
    },
    run: (data, matches) => {
      // Lowercase all of the names here for case insensitive matching.
      const allNames = {
        en: ['firehorn', 'iceclaw', 'thunderwing'],
        de: ['feuerhorn', 'eisklaue', 'donnerschwinge'],
        fr: ['corne-de-feu', 'griffe-de-glace ', 'aile-de-foudre'],
        ja: ['ファイアホーン', 'アイスクロウ', 'サンダーウィング'],
        cn: ['火角', '冰爪', '雷翼'],
        ko: ['화염뿔', '얼음발톱', '번개날개']
      };
      const names = allNames[data.parserLang];
      const idx = names.indexOf(matches.name.toLowerCase());
      if (idx === -1) return;
      const x = parseFloat(matches.x);
      const y = parseFloat(matches.y);

      // Most dragons are out on a circle of radius=~28.
      // Ignore spurious dragons like "Pos: (0.000919255,0.006120025,2.384186E-07)"
      if (x * x + y * y < 20 * 20) return;

      // Positions are the 8 cardinals + numerical slop on a radius=28 circle.
      // N = (0, -28), E = (28, 0), S = (0, 28), W = (-28, 0)
      // Map N = 0, NE = 1, ..., NW = 7
      const dir = Math.round(4 - 4 * Math.atan2(x, y) / Math.PI) % 8;
      data.dragons ??= [0, 0, 0];
      data.dragons[idx] = dir;
    }
  }, {
    id: 'T9 Final Phase Reset',
    type: 'StartsUsing',
    netRegex: {
      id: '7E6',
      source: 'Nael Deus Darnus',
      capture: false
    },
    run: data => {
      data.tetherCount = 0;
      data.naelDiveMarkerCount = 0;
      data.naelMarks = ['unknown', 'unknown'];
      data.safeZone = 'unknown';

      // Missing dragons??
      if (!data.dragons || data.dragons.length !== 3) return;

      // T9 normal dragons are easy.
      // The first two are always split, so A is the first dragon + 1.
      // The last one is single, so B is the last dragon + 1.

      const dragons = data.dragons.sort();
      const [d0, d1, d2] = dragons;
      if (d0 === undefined || d1 === undefined || d2 === undefined) return;
      const dirNames = ['north', 'northeast', 'east', 'southeast', 'south', 'southwest', 'west', 'northwest'];
      data.naelMarks = [d0, d2].map(i => dirNames[(i + 1) % 8] ?? 'unknown');

      // Safe zone is one to the left of the first dragon, unless
      // the last dragon is diving there.  If that's true, use
      // one to the right of the second dragon.
      let possibleSafe = (d0 - 1 + 8) % 8;
      if ((d2 + 2) % 8 === possibleSafe) possibleSafe = (d1 + 1) % 8;
      data.safeZone = dirNames[possibleSafe];
    }
  }, {
    id: 'T9 Dragon Marks',
    type: 'StartsUsing',
    netRegex: {
      id: '7E6',
      source: 'Nael Deus Darnus',
      capture: false
    },
    durationSeconds: 12,
    infoText: (data, _matches, output) => output.marks({
      dir1: output[data.naelMarks?.[0] ?? 'unknown'](),
      dir2: output[data.naelMarks?.[1] ?? 'unknown']()
    }),
    outputStrings: {
      ...diveDirections,
      marks: {
        en: 'Marks: ${dir1}, ${dir2}',
        de: 'Markierungen : ${dir1}, ${dir2}',
        fr: 'Marques : ${dir1}, ${dir2}',
        ja: 'マーカー: ${dir1}, ${dir2}',
        cn: '标记： ${dir1}, ${dir2}',
        ko: '카탈징: ${dir1}, ${dir2}'
      }
    }
  }, {
    id: 'T9 Tether',
    type: 'Tether',
    netRegex: {
      id: '0005',
      source: 'Firehorn'
    },
    preRun: data => {
      data.tetherCount++;
    },
    alertText: (data, matches, output) => {
      if (data.me !== matches.target) return;

      // Out, In, Out, In
      if (data.tetherCount % 2) return output.fireOutOnYou();
      return output.fireInOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return;
      // Out, In, Out, In
      if (data.tetherCount % 2) return output.fireOutOn({
        player: data.party.member(matches.target)
      });
      return output.fireInOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      fireOutOnYou: {
        en: 'Fire Out (on YOU)',
        de: 'Feuer raus (auf DIR)',
        fr: 'Feu extérieur (sur VOUS)',
        ja: 'ファイヤ、外に (自分)',
        cn: '火球单吃点名',
        ko: '불 대상자 밖으로'
      },
      fireInOnYou: {
        en: 'Fire In (on YOU)',
        de: 'Feuer rein (auf DIR)',
        fr: 'Feu intérieur (sur VOUS)',
        ja: 'ファイヤ、頭割り (自分)',
        cn: '火球集合点名',
        ko: '불 대상자 같이맞기'
      },
      fireOutOn: {
        en: 'Fire Out (on ${player})',
        de: 'Feuer raus (auf ${player})',
        fr: 'Feu extérieur (sur ${player})',
        ja: 'ファイヤ、外に (${player})',
        cn: '火球单吃点${player}',
        ko: '${player} 불 밖으로'
      },
      fireInOn: {
        en: 'Fire In (on ${player})',
        de: 'Feuer rein (auf ${player})',
        fr: 'Feu intérieur (sur ${player})',
        ja: 'ファイヤ、頭割り (${player})',
        cn: '火球集合点${player}',
        ko: '${player} 불 같이맞기'
      }
    }
  }, {
    id: 'T9 Thunder',
    type: 'Ability',
    netRegex: {
      source: 'Thunderwing',
      id: '7FD'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Thunder on YOU',
        de: 'Blitz auf DIR',
        fr: 'Foudre sur VOUS',
        ja: '自分にサンダー',
        cn: '雷点名',
        ko: '번개 대상자'
      }
    }
  }, {
    id: 'T9 Dragon Safe Zone',
    type: 'HeadMarker',
    netRegex: {
      id: '0014',
      capture: false
    },
    delaySeconds: 3,
    durationSeconds: 6,
    suppressSeconds: 20,
    infoText: (data, _matches, output) => output.safeZone({
      dir: output[data.safeZone ?? 'unknown']()
    }),
    outputStrings: {
      ...diveDirections,
      safeZone: {
        en: 'Safe zone: ${dir}',
        de: 'Sichere Zone: ${dir}',
        fr: 'Zone safe : ${dir}',
        ja: '安置: ${dir}',
        cn: '安全点在：${dir}',
        ko: '안전 지대: ${dir}'
      }
    }
  }, {
    id: 'T9 Dragon Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0014'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (data, matches, output) => {
      data.naelDiveMarkerCount ??= 0;
      if (matches.target !== data.me) return;
      const marker = ['A', 'B', 'C'][data.naelDiveMarkerCount];
      const dir = data.naelMarks?.[data.naelDiveMarkerCount];
      return output.goToMarkerInDir({
        marker: marker,
        dir: dir
      });
    },
    tts: (data, matches, output) => {
      data.naelDiveMarkerCount ??= 0;
      if (matches.target !== data.me) return;
      return output.goToMarker({
        marker: ['A', 'B', 'C'][data.naelDiveMarkerCount]
      });
    },
    outputStrings: {
      goToMarkerInDir: {
        en: 'Go To ${marker} (in ${dir})',
        de: 'Gehe zu ${marker} (im ${dir})',
        fr: 'Allez en ${marker} (direction ${dir})',
        ja: '${marker}に行く' + ' (あと ${dir}秒)',
        cn: '去${marker} (在 ${dir}秒)',
        ko: '${marker}로 이동' + ' (${dir}쪽)'
      },
      goToMarker: {
        en: 'Go To ${marker}',
        de: 'Gehe zu ${marker}',
        fr: 'Allez en ${marker}',
        ja: '${marker}行くよ',
        cn: '去${marker}',
        ko: '${marker}로 이동'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Astral Debris': 'Lichtgestein',
      'Dalamud Fragment': 'Dalamud-Bruchstück',
      'Dalamud Spawn': 'Dalamud-Golem',
      'Firehorn': 'Feuerhorn',
      'Iceclaw': 'Eisklaue',
      'Nael Geminus': 'Nael Geminus',
      'Nael deus Darnus': 'Nael deus Darnus',
      'Ragnarok': 'Ragnarök',
      'The Ghost Of Meracydia': 'Geist von Meracydia',
      'Thunderwing': 'Donnerschwinge',
      'Umbral Debris': 'Schattengestein'
    },
    'replaceText': {
      '(?<! )Meteor(?! Stream)': 'Meteor',
      'Bahamut\'s Claw': 'Klauen Bahamuts',
      'Bahamut\'s Favor': 'Bahamuts Segen',
      'Binding Coil': 'Verschlungene Schatten',
      'Cauterize': 'Kauterisieren',
      'Chain Lightning': 'Kettenblitz',
      'Dalamud Dive': 'Dalamud-Sturzflug',
      'Divebomb': 'Sturzbombe',
      'Fireball': 'Feuerball',
      'Ghost': 'Geist',
      'Golem Meteors': 'Golem Meteore',
      'Heavensfall': 'Himmelssturz',
      'Iron Chariot': 'Eiserner Streitwagen',
      'Lunar Dynamo': 'Lunarer Dynamo',
      'Megaflare': 'Megaflare',
      'Meteor Stream': 'Meteorflug',
      'Raven Dive': 'Bahamuts Schwinge',
      'Ravensbeak': 'Bradamante',
      'Ravensclaw': 'Silberklauen',
      'Stardust': 'Sternenstaub',
      'Super Nova': 'Supernova',
      'Thermionic Beam': 'Thermionischer Strahl'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Astral Debris': 'Débris Astral',
      'Dalamud Fragment': 'Débris De Dalamud',
      'Dalamud Spawn': 'Golem De Dalamud',
      'Firehorn': 'Corne-De-Feu',
      'Iceclaw': 'Griffe-De-Glace',
      'Nael Geminus': 'Nael Geminus',
      'Nael deus Darnus': 'Nael Deus Darnus',
      'Ragnarok': 'Ragnarok',
      'The Ghost Of Meracydia': 'Fantôme Méracydien',
      'Thunderwing': 'Aile-De-Foudre',
      'Umbral Debris': 'Débris Ombral'
    },
    'replaceText': {
      '(?<! )Meteor(?! Stream)': 'Météore',
      'Bahamut\'s Claw': 'Griffe de Bahamut',
      'Bahamut\'s Favor': 'Auspice du dragon',
      'Binding Coil': 'Écheveau entravant',
      'Cauterize': 'Cautérisation',
      'Chain Lightning': 'Chaîne d\'éclairs',
      'Dalamud Dive': 'Chute de Dalamud',
      'Divebomb Mark': 'Bombe plongeante, marque',
      'Fireball': 'Boule de feu',
      'Ghost Add': 'Add Fantôme',
      'Golem Meteors': 'Golem de Dalamud',
      'Heavensfall': 'Destruction universelle',
      'Iron Chariot': 'Char de fer',
      'Lunar Dynamo': 'Dynamo lunaire',
      'Megaflare': 'MégaBrasier',
      'Meteor Stream': 'Rayon météore',
      'Raven Dive': 'Fonte du rapace',
      'Ravensbeak': 'Bec du rapace',
      'Ravensclaw': 'Serre du rapace',
      'Stardust': 'Poussière d\'étoile',
      'Super Nova': 'Supernova',
      'Thermionic Beam': 'Rayon thermoïonique'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Astral Debris': 'アストラルデブリ',
      'Dalamud Fragment': 'ダラガブデブリ',
      'Dalamud Spawn': 'ダラガブゴーレム',
      'Firehorn': 'ファイアホーン',
      'Iceclaw': 'アイスクロウ',
      'Nael Geminus': 'ネール・ジェミナス',
      'Nael deus Darnus': 'ネール・デウス・ダーナス',
      'Ragnarok': 'ラグナロク',
      'The Ghost Of Meracydia': 'メラシディアン・ゴースト',
      'Thunderwing': 'サンダーウィング',
      'Umbral Debris': 'アンブラルデブリ'
    },
    'replaceText': {
      '(?<! )Meteor(?! Stream)': 'メテオ',
      'Bahamut\'s Claw': 'バハムートクロウ',
      'Bahamut\'s Favor': '龍神の加護',
      'Binding Coil': 'バインディングコイル',
      'Cauterize': 'カータライズ',
      'Chain Lightning': 'チェインライトニング',
      'Dalamud Dive': 'ダラガブダイブ',
      'Divebomb': 'ダイブボム',
      'Fireball': 'ファイアボール',
      'Ghost Add': '雑魚: ゴースト',
      'Golem Meteors': 'ゴーレムメテオ',
      'Heavensfall': '天地崩壊',
      'Iron Chariot': 'アイアンチャリオット',
      'Lunar Dynamo': 'ルナダイナモ',
      '(?<= )Mark(?= \\w)': 'マーク',
      'Megaflare': 'メガフレア',
      'Meteor Stream': 'メテオストリーム',
      'Raven Dive': 'レイヴンダイブ',
      'Ravensbeak': 'レイヴェンズビーク',
      'Ravensclaw': 'レイヴェンズクロウ',
      'Stardust': 'スターダスト',
      'Super Nova': 'スーパーノヴァ',
      'Thermionic Beam': 'サーミオニックビーム'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Astral Debris': '星极岩屑',
      'Dalamud Fragment': '卫月岩屑',
      'Dalamud Spawn': '卫月巨像',
      'Firehorn': '火角',
      'Iceclaw': '冰爪',
      'Nael Geminus': '奈尔双生子',
      'Nael deus Darnus': '奈尔·神·达纳斯',
      'Ragnarok': '诸神黄昏',
      'The Ghost Of Meracydia': '美拉西迪亚幽龙',
      'Thunderwing': '雷翼',
      'Umbral Debris': '灵极岩屑'
    },
    'replaceText': {
      '(?<! )Meteor(?! Stream)': '陨石',
      'Bahamut\'s Claw': '巴哈姆特之爪',
      'Bahamut\'s Favor': '龙神的加护',
      'Binding Coil': '拘束圈',
      'Cauterize': '低温俯冲',
      'Chain Lightning': '雷光链',
      'Dalamud Dive': '月华冲',
      'Divebomb': '爆破俯冲',
      'Fireball': '烈火球',
      'Ghost': '幽灵',
      'Golem Meteors': '石头人陨石',
      'Heavensfall': '天崩地裂',
      'Iron Chariot': '钢铁战车',
      'Lunar Dynamo': '月流电圈',
      'Megaflare': '百万核爆',
      'Meteor Stream': '陨石流',
      'Raven Dive': '凶鸟冲',
      'Ravensbeak': '凶鸟尖喙',
      'Ravensclaw': '凶鸟利爪',
      'Stardust': '星尘',
      'Super Nova': '超新星',
      'Thermionic Beam': '热离子光束'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Astral Debris': '천상의 잔해',
      'Dalamud Fragment': '달라가브의 잔해',
      'Dalamud Spawn': '달라가브 골렘',
      'Firehorn': '화염뿔',
      'Iceclaw': '얼음발톱',
      'Nael Geminus': '넬 게미누스',
      'Nael deus Darnus': '넬 데우스 다르누스',
      'Ragnarok': '라그나로크',
      'The Ghost Of Meracydia': '메라시디아의 유령',
      'Thunderwing': '번개날개',
      'Umbral Debris': '저승의 잔해'
    },
    'replaceText': {
      '(?<! )Meteor(?! Stream)': '메테오',
      'Bahamut\'s Claw': '바하무트의 발톱',
      'Bahamut\'s Favor': '용신의 가호',
      'Binding Coil': '구속의 고리',
      'Cauterize': '인두질',
      'Chain Lightning': '번개 사슬',
      'Dalamud Dive': '달라가브 강하',
      'Divebomb': '급강하 폭격',
      'Fireball': '화염구',
      'Ghost Add': '유령 쫄',
      'Golem Meteors': '골렘 메테오',
      'Heavensfall': '천지붕괴',
      'Iron Chariot': '강철 전차',
      'Lunar Dynamo': '달의 원동력',
      'Megaflare': '메가플레어',
      'Meteor Stream': '유성 폭풍',
      'Raven Dive': '흉조의 강하',
      'Ravensbeak': '흉조의 부리',
      'Ravensclaw': '흉조의 발톱',
      'Stardust': '별조각',
      'Super Nova': '초신성',
      'Thermionic Beam': '열전자 광선',
      'Mark A': 'A징',
      'Mark B': 'B징'
    }
  }]
};
/* harmony default export */ const t9 = (t9_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/raid/t9.txt
const raid_t9_namespaceObject = "# Turn 9\r\n# -ii 7EC 7F6 7E5 7FA 7E1 7E3 -p 7E7:683.5\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1\r\n# This phase really doesn't seem to loop anywhere.\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n5.5 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" } window 6,5\r\n16.6 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n\r\n21.8 \"Stardust\" Ability { id: \"877\", source: \"Nael deus Darnus\" } duration 9\r\n30.8 \"--sync--\" Ability { id: \"7E9\", source: [\"Astral Debris\", \"Umbral Debris\"] }\r\n30.9 \"Ravensbeak\" Ability { id: \"7D6\", source: \"Nael deus Darnus\" } duration 13\r\n36.2 \"Raven Dive\" Ability { id: \"7DD\", source: \"Nael deus Darnus\" }\r\n40.8 \"Iron Chariot\" Ability { id: \"7D8\", source: \"Nael deus Darnus\" }\r\n42.6 \"Thermionic Beam\" Ability { id: \"7DF\", source: \"Nael deus Darnus\" }\r\n43.6 \"Raven Dive\" Ability { id: \"7DD\", source: \"Nael deus Darnus\" }\r\n44.0 \"--sync--\" Ability { id: \"7D7\", source: \"Nael deus Darnus\" }\r\n48.3 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n\r\n58.6 \"Stardust\" Ability { id: \"877\", source: \"Nael deus Darnus\" } duration 9\r\n63.4 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n67.6 \"--sync--\" Ability { id: \"7E9\", source: [\"Astral Debris\", \"Umbral Debris\"] }\r\n69.4 \"Lunar Dynamo\" Ability { id: \"7DA\", source: \"Nael deus Darnus\" }\r\n71.8 \"Meteor Stream\" Ability { id: \"7DE\", source: \"Nael Geminus\" }\r\n74.9 \"Dalamud Dive\" Ability { id: \"7DC\", source: \"Nael deus Darnus\" }\r\n83.7 \"Ravensbeak\" Ability { id: \"7D6\", source: \"Nael deus Darnus\" } duration 13\r\n89.5 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n\r\n95.0 \"Stardust\" Ability { id: \"877\", source: \"Nael deus Darnus\" } duration 9\r\n96.6 \"--sync--\" Ability { id: \"7D7\", source: \"Nael deus Darnus\" }\r\n104.0 \"--sync--\" Ability { id: \"7E9\", source: [\"Astral Debris\", \"Umbral Debris\"] }\r\n107.2 \"Meteor Stream\" #Ability { id: \"7DE\", source: \"Nael Geminus\" }\r\n112.3 \"Meteor Stream\" #Ability { id: \"7DE\", source: \"Nael Geminus\" }\r\n115.4 \"Dalamud Dive\" Ability { id: \"7DC\", source: \"Nael deus Darnus\" }\r\n119.7 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n130.2 \"Ravensbeak\" Ability { id: \"7D6\", source: \"Nael deus Darnus\" } duration 13\r\n\r\n135.5 \"Stardust\" Ability { id: \"877\", source: \"Nael deus Darnus\" } duration 9\r\n140.0 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n143.2 \"--sync--\" Ability { id: \"7D7\", source: \"Nael deus Darnus\" }\r\n144.6 \"--sync--\" Ability { id: \"7E9\", source: [\"Astral Debris\", \"Umbral Debris\"] }\r\n146.1 \"Raven Dive\" Ability { id: \"7DD\", source: \"Nael deus Darnus\" }\r\n150.7 \"Iron Chariot\" Ability { id: \"7D8\", source: \"Nael deus Darnus\" }\r\n152.6 \"Thermionic Beam\" Ability { id: \"7DF\", source: \"Nael deus Darnus\" }\r\n153.6 \"Raven Dive\" Ability { id: \"7DD\", source: \"Nael deus Darnus\" }\r\n162.6 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n\r\n168.6 \"Stardust\" Ability { id: \"877\", source: \"Nael deus Darnus\" } duration 9\r\n177.4 \"Ravensbeak\" Ability { id: \"7D6\", source: \"Nael deus Darnus\" } duration 13\r\n177.7 \"--sync--\" Ability { id: \"7E9\", source: [\"Astral Debris\", \"Umbral Debris\"] }\r\n183.9 \"Lunar Dynamo\" Ability { id: \"7DA\", source: \"Nael deus Darnus\" }\r\n186.2 \"Meteor Stream\" Ability { id: \"7DE\", source: \"Nael Geminus\" }\r\n189.3 \"Dalamud Dive\" Ability { id: \"7DC\", source: \"Nael deus Darnus\" }\r\n190.4 \"--sync--\" Ability { id: \"7D7\", source: \"Nael deus Darnus\" }\r\n192.9 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n\r\n203.9 \"Stardust\" Ability { id: \"877\", source: \"Nael deus Darnus\" } duration 9\r\n208.0 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n213.0 \"--sync--\" Ability { id: \"7E9\", source: [\"Astral Debris\", \"Umbral Debris\"] }\r\n217.5 \"Meteor Stream\" #Ability { id: \"7DE\", source: \"Nael Geminus\" }\r\n222.6 \"Meteor Stream\" #Ability { id: \"7DE\", source: \"Nael Geminus\" }\r\n225.8 \"Dalamud Dive\" Ability { id: \"7DC\", source: \"Nael deus Darnus\" }\r\n234.2 \"Ravensbeak\" Ability { id: \"7D6\", source: \"Nael deus Darnus\" } duration 13\r\n239.6 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n\r\n245.8 \"Stardust\" Ability { id: \"877\", source: \"Nael deus Darnus\" } duration 9\r\n254.8 \"--sync--\" Ability { id: \"7E9\", source: [\"Astral Debris\", \"Umbral Debris\"] }\r\n255.5 \"Raven Dive\" Ability { id: \"7DD\", source: \"Nael deus Darnus\" }\r\n260.1 \"Iron Chariot\" Ability { id: \"7D8\", source: \"Nael deus Darnus\" }\r\n262.1 \"Thermionic Beam\" Ability { id: \"7DF\", source: \"Nael deus Darnus\" }\r\n263.1 \"Raven Dive\" Ability { id: \"7DD\", source: \"Nael deus Darnus\" }\r\n266.4 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n277.3 \"Ravensbeak\" Ability { id: \"7D6\", source: \"Nael deus Darnus\" } duration 13\r\n\r\n283.0 \"Stardust\" Ability { id: \"877\", source: \"Nael deus Darnus\" } duration 9\r\n286.8 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n292.0 \"--sync--\" Ability { id: \"7E9\", source: [\"Astral Debris\", \"Umbral Debris\"] }\r\n294.3 \"Lunar Dynamo\" Ability { id: \"7DA\", source: \"Nael deus Darnus\" }\r\n296.7 \"Meteor Stream\" Ability { id: \"7DE\", source: \"Nael Geminus\" }\r\n299.9 \"Dalamud Dive\" Ability { id: \"7DC\", source: \"Nael deus Darnus\" }\r\n307.9 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n\r\n314.3 \"Stardust\" Ability { id: \"877\", source: \"Nael deus Darnus\" } duration 9\r\n322.8 \"Ravensbeak\" Ability { id: \"7D6\", source: \"Nael deus Darnus\" }\r\n323.3 \"--sync--\" Ability { id: \"7E9\", source: [\"Astral Debris\", \"Umbral Debris\"] }\r\n332.0 \"Meteor Stream\" Ability { id: \"7DE\", source: \"Nael Geminus\" }\r\n335.9 \"--sync--\" Ability { id: \"7D7\", source: \"Nael deus Darnus\" }\r\n337.0 \"Meteor Stream\" Ability { id: \"7DE\", source: \"Nael Geminus\" }\r\n340.2 \"Dalamud Dive\" Ability { id: \"7DC\", source: \"Nael deus Darnus\" }\r\n343.2 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n\r\n355.0 \"Stardust\" Ability { id: \"877\", source: \"Nael deus Darnus\" } duration 9\r\n358.5 \"Ravensclaw\" Ability { id: \"7D5\", source: \"Nael deus Darnus\" }\r\n364.0 \"--sync--\" Ability { id: \"7E9\", source: [\"Astral Debris\", \"Umbral Debris\"] }\r\n366.0 \"Raven Dive\" Ability { id: \"7DD\", source: \"Nael deus Darnus\" }\r\n370.5 \"Iron Chariot\" Ability { id: \"7D8\", source: \"Nael deus Darnus\" }\r\n372.7 \"Thermionic Beam\" Ability { id: \"7DF\", source: \"Nael deus Darnus\" }\r\n373.7 \"Raven Dive\" Ability { id: \"7DD\", source: \"Nael deus Darnus\" }\r\n\r\n# Meteors just start exploding here no matter how far away you put them.\r\n\r\n\r\n### Phase 2: Golem Adds\r\n500.0 \"--untargetable--\"\r\n503.3 \"Golem Meteors\" HeadMarker { id: \"0007\" } duration 11 window 505,0\r\n514.3 \"--sync--\" Ability { id: \"7EB\", source: \"Dalamud Fragment\" }\r\n582.3 \"Meteor 1/6\" HeadMarker { id: \"000[9A]\" } duration 7 window 83,0\r\n584.3 \"Meteor 2/6\" duration 7\r\n586.3 \"Meteor 3/6\" duration 7\r\n588.3 \"Meteor 4/6\" duration 7\r\n590.5 \"Meteor 5/6\" duration 7\r\n592.5 \"Meteor 6/6\" duration 7\r\n598.3 \"Golem Meteors\" HeadMarker { id: \"0007\" } duration 11 window 80,80\r\n609.3 \"--sync--\" Ability { id: \"7EB\", source: \"Dalamud Fragment\" }\r\n683.5 \"Megaflare\" Ability { id: \"7E7\", source: \"Nael deus Darnus\" } window 700,700\r\n\r\n\r\n### Phase 3: Heavensfall\r\n# Phase 3 is on a 54 second nael rotation and a 60 second dragon rotation.\r\n# This unrolls the loop for the first few dragons.\r\n693.6 \"Dalamud Dive\" Ability { id: \"7DC\", source: \"Nael deus Darnus\" } window 300,300\r\n695.6 \"--targetable--\"\r\n\r\n699.2 \"--sync--\" Ability { id: \"83B\", source: \"Nael deus Darnus\" }\r\n701.9 \"Heavensfall\" Ability { id: \"7E4\", source: \"Ragnarok\" } window 702,10\r\n714.3 \"Bahamut's Claw x2\" #Ability { id: \"871\", source: \"Nael deus Darnus\" }\r\n716.0 \"Ghost Add 1 (North)\"\r\n721.8 \"Binding Coil\" Ability { id: \"7E2\", source: \"Nael deus Darnus\" }\r\n737.0 \"Bahamut's Claw x2\" #Ability { id: \"871\", source: \"Nael deus Darnus\" }\r\n744.4 \"Binding Coil\" Ability { id: \"7E2\", source: \"Nael deus Darnus\" }\r\n\r\n749.5 \"--sync--\" Ability { id: \"83B\", source: \"Nael deus Darnus\" }\r\n752.2 \"Heavensfall\" Ability { id: \"7E4\", source: \"Ragnarok\" } window 40,40\r\n755.9 \"Super Nova x2\" duration 2.3 #Ability { id: \"7E0\", source: \"Nael deus Darnus\" }\r\n768.7 \"Bahamut's Claw x2\" #Ability { id: \"871\", source: \"Nael deus Darnus\" }\r\n775.9 \"Binding Coil\" Ability { id: \"7E2\", source: \"Nael deus Darnus\" }\r\n776.0 \"Ghost Add 2 (East)\"\r\n791.3 \"Bahamut's Claw x2\" #Ability { id: \"871\", source: \"Nael deus Darnus\" }\r\n798.5 \"Binding Coil\" Ability { id: \"7E2\", source: \"Nael deus Darnus\" }\r\n\r\n803.5 \"--sync--\" Ability { id: \"83B\", source: \"Nael deus Darnus\" }\r\n806.2 \"Heavensfall\" Ability { id: \"7E4\", source: \"Ragnarok\" } window 40,40\r\n809.9 \"Super Nova x2\" duration 2.3 #Ability { id: \"7E0\", source: \"Nael deus Darnus\" }\r\n822.7 \"Bahamut's Claw x2\" #Ability { id: \"871\", source: \"Nael deus Darnus\" }\r\n829.9 \"Binding Coil\" Ability { id: \"7E2\", source: \"Nael deus Darnus\" }\r\n836.0 \"Ghost Add 3 (South)\"\r\n845.3 \"Bahamut's Claw x2\" #Ability { id: \"871\", source: \"Nael deus Darnus\" }\r\n852.5 \"Binding Coil\" Ability { id: \"7E2\", source: \"Nael deus Darnus\" }\r\n\r\n857.5 \"--sync--\" Ability { id: \"83B\", source: \"Nael deus Darnus\" }\r\n860.2 \"Heavensfall\" Ability { id: \"7E4\", source: \"Ragnarok\" } window 40,40\r\n863.9 \"Super Nova x2\" duration 2.3 #Ability { id: \"7E0\", source: \"Nael deus Darnus\" }\r\n876.7 \"Bahamut's Claw x2\" #Ability { id: \"871\", source: \"Nael deus Darnus\" }\r\n883.9 \"Binding Coil\" Ability { id: \"7E2\", source: \"Nael deus Darnus\" }\r\n899.3 \"Bahamut's Claw x2\" #Ability { id: \"871\", source: \"Nael deus Darnus\" }\r\n906.5 \"Binding Coil\" Ability { id: \"7E2\", source: \"Nael deus Darnus\" }\r\n\r\n911.5 \"--sync--\" Ability { id: \"83B\", source: \"Nael deus Darnus\" } window 40,40 jump 857.5\r\n914.2 \"Heavensfall\"\r\n917.9 \"Super Nova x2\"\r\n930.7 \"Bahamut's Claw x2\"\r\n937.9 \"Binding Coil\"\r\n953.3 \"Bahamut's Claw x2\"\r\n960.5 \"Binding Coil\"\r\n\r\n\r\n### Phase 4: Divebombs and Dances\r\n1000.0 \"Bahamut's Favor\" Ability { id: \"7E6\", source: \"Nael deus Darnus\" } window 1000,80\r\n1003.1 \"Bahamut's Claw x5\" duration 2.9 #Ability { id: \"871\", source: \"Nael deus Darnus\" }\r\n1013.9 \"Chain Lightning\" Ability { id: \"7FD\", source: \"Thunderwing\" } duration 6\r\n1014.4 \"Raven Dive\" Ability { id: \"7DD\", source: \"Nael deus Darnus\" }\r\n1014.9 \"Fireball (Out)\" Ability { id: \"7FB\", source: \"Firehorn\" }\r\n1019.0 \"Lunar Dynamo\" Ability { id: \"7DA\", source: \"Nael deus Darnus\" }\r\n1025.9 \"Chain Lightning\" Ability { id: \"7FD\", source: \"Thunderwing\" } duration 6\r\n1026.9 \"Fireball (In)\" Ability { id: \"7FB\", source: \"Firehorn\" }\r\n1038.0 \"Chain Lightning\" Ability { id: \"7FD\", source: \"Thunderwing\" } duration 6\r\n1039.0 \"Fireball (Out)\" Ability { id: \"7FB\", source: \"Firehorn\" }\r\n1040.2 \"Iron Chariot\" Ability { id: \"7D8\", source: \"Nael deus Darnus\" }\r\n1041.9 \"Super Nova x3\" duration 3 #Ability { id: \"7E0\", source: \"Nael deus Darnus\" }\r\n1047.4 \"Thermionic Beam\" Ability { id: \"7DF\", source: \"Nael deus Darnus\" }\r\n1050.0 \"Chain Lightning\" Ability { id: \"7FD\", source: \"Thunderwing\" } duration 6\r\n1051.2 \"Fireball (In)\" Ability { id: \"7FB\", source: \"Firehorn\" }\r\n1054.2 \"Bahamut's Claw x5\" duration 2.9 #Ability { id: \"871\", source: \"Nael deus Darnus\" }\r\n1061.2 \"Divebomb Mark A\" duration 5\r\n1067.3 \"Divebomb Mark B\" duration 5\r\n1070.5 \"Cauterize x2\" Ability { id: \"801\", source: \"Thunderwing\" }\r\n1070.6 \"Meteor Stream\" Ability { id: \"7DE\", source: \"Nael Geminus\" }\r\n1076.6 \"Cauterize x1\" Ability { id: \"7FF\", source: \"Firehorn\" }\r\n1076.7 \"Meteor Stream\" Ability { id: \"7DE\", source: \"Nael Geminus\" }\r\n1080.8 \"Dalamud Dive\" Ability { id: \"7DC\", source: \"Nael deus Darnus\" }\r\n\r\n1096.6 \"Bahamut's Favor\" Ability { id: \"7E6\", source: \"Nael deus Darnus\" } window 80,80\r\n1099.7 \"Bahamut's Claw x5\" duration 2.9 #Ability { id: \"871\", source: \"Nael deus Darnus\" }\r\n1110.4 \"Raven Dive\" Ability { id: \"7DD\", source: \"Nael deus Darnus\" }\r\n1110.4 \"Chain Lightning\" Ability { id: \"7FD\", source: \"Thunderwing\" } duration 6\r\n1111.3 \"Fireball (Out)\" Ability { id: \"7FB\", source: \"Firehorn\" }\r\n1114.9 \"Lunar Dynamo\" Ability { id: \"7DA\", source: \"Nael deus Darnus\" }\r\n1122.5 \"Chain Lightning\" Ability { id: \"7FD\", source: \"Thunderwing\" } duration 6\r\n1123.4 \"Fireball (In)\" Ability { id: \"7FB\", source: \"Firehorn\" }\r\n1134.4 \"Chain Lightning\" Ability { id: \"7FD\", source: \"Thunderwing\" } duration 6\r\n1135.5 \"Fireball (Out)\" Ability { id: \"7FB\", source: \"Firehorn\" }\r\n1136.0 \"Iron Chariot\" Ability { id: \"7D8\", source: \"Nael deus Darnus\" }\r\n1137.8 \"Super Nova x3\" duration 3 #Ability { id: \"7E0\", source: \"Nael deus Darnus\" }\r\n1143.8 \"Thermionic Beam\" Ability { id: \"7DF\", source: \"Nael deus Darnus\" }\r\n1146.6 \"Chain Lightning\" Ability { id: \"7FD\", source: \"Thunderwing\" } duration 6\r\n1147.7 \"Fireball (In)\" Ability { id: \"7FB\", source: \"Firehorn\" }\r\n1150.6 \"Bahamut's Claw x5\" duration 2.9 #Ability { id: \"871\", source: \"Nael deus Darnus\" }\r\n1157.8 \"Divebomb Mark A\" duration 5\r\n1163.9 \"Divebomb Mark B\" duration 5\r\n1164.3 \"Iron Chariot\" Ability { id: \"7D8\", source: \"Nael deus Darnus\" }\r\n1167.1 \"Cauterize x2\" Ability { id: \"7FF\", source: \"Firehorn\" }\r\n1168.1 \"Raven Dive\" Ability { id: \"7DD\", source: \"Nael deus Darnus\" }\r\n1172.7 \"Lunar Dynamo\" Ability { id: \"7DA\", source: \"Nael deus Darnus\" }\r\n1173.2 \"Cauterize x1\" Ability { id: \"800\", source: \"Iceclaw\" }\r\n\r\n1193.1 \"Bahamut's Favor\" Ability { id: \"7E6\", source: \"Nael deus Darnus\" } window 80,80\r\n1196.1 \"Bahamut's Claw x5\" duration 2.9 #Ability { id: \"871\", source: \"Nael deus Darnus\" }\r\n1206.9 \"Raven Dive\" Ability { id: \"7DD\", source: \"Nael deus Darnus\" }\r\n1207.0 \"Chain Lightning\" Ability { id: \"7FD\", source: \"Thunderwing\" } duration 6\r\n1207.9 \"Fireball (Out)\" Ability { id: \"7FB\", source: \"Firehorn\" }\r\n1211.4 \"Lunar Dynamo\" Ability { id: \"7DA\", source: \"Nael deus Darnus\" }\r\n1219.0 \"Chain Lightning\" Ability { id: \"7FD\", source: \"Thunderwing\" } duration 6\r\n1219.9 \"Fireball (In)\" Ability { id: \"7FB\", source: \"Firehorn\" }\r\n1231.0 \"Chain Lightning\" Ability { id: \"7FD\", source: \"Thunderwing\" } duration 6\r\n1232.1 \"Fireball (Out)\" Ability { id: \"7FB\", source: \"Firehorn\" }\r\n1232.6 \"Iron Chariot\" Ability { id: \"7D8\", source: \"Nael deus Darnus\" }\r\n1234.4 \"Super Nova x3\" duration 3 #Ability { id: \"7E0\", source: \"Nael deus Darnus\" }\r\n1240.5 \"Thermionic Beam\" Ability { id: \"7DF\", source: \"Nael deus Darnus\" }\r\n1243.1 \"Chain Lightning\" Ability { id: \"7FD\", source: \"Thunderwing\" } duration 6\r\n1244.4 \"Fireball (In)\" Ability { id: \"7FB\", source: \"Firehorn\" }\r\n1247.4 \"Bahamut's Claw x5\" duration 2.9 #Ability { id: \"871\", source: \"Nael deus Darnus\" }\r\n1254.4 \"Divebomb Mark A\" duration 5\r\n1260.3 \"Divebomb Mark B\" duration 5\r\n1263.7 \"Cauterize x2\" Ability { id: \"801\", source: \"Thunderwing\" }\r\n1263.8 \"Meteor Stream\" Ability { id: \"7DE\", source: \"Nael Geminus\" }\r\n1269.6 \"Cauterize x1\" Ability { id: \"7FF\", source: \"Firehorn\" }\r\n1269.9 \"Meteor Stream\" Ability { id: \"7DE\", source: \"Nael Geminus\" }\r\n1274.5 \"Dalamud Dive\" Ability { id: \"7DC\", source: \"Nael deus Darnus\" }\r\n\r\n1289.7 \"Bahamut's Favor\" Ability { id: \"7E6\", source: \"Nael deus Darnus\" } window 80,800 jump 1096.6\r\n1292.8 \"Bahamut's Claw x5\"\r\n1303.5 \"Raven Dive\"\r\n1303.5 \"Chain Lightning\"\r\n1304.4 \"Fireball (Out)\"\r\n1308.0 \"Lunar Dynamo\"\r\n1315.6 \"Chain Lightning\"\r\n1316.5 \"Fireball (In)\"\r\n1327.5 \"Chain Lightning\"\r\n1328.6 \"Fireball (Out)\"\r\n1329.1 \"Iron Chariot\"\r\n1330.9 \"Super Nova x3\"\r\n1336.9 \"Thermionic Beam\"\r\n1339.7 \"Chain Lightning\"\r\n1340.8 \"Fireball (In)\"\r\n1343.7 \"Bahamut's Claw x5\"\r\n1350.9 \"Divebomb Mark A\"\r\n1357.0 \"Divebomb Mark B\"\r\n1357.4 \"Iron Chariot\"\r\n1360.2 \"Cauterize x2\"\r\n1361.2 \"Raven Dive\"\r\n1365.8 \"Lunar Dynamo\"\r\n1366.3 \"Cauterize x1\"\r\n\r\n\r\n### Phase 5: What Took You So Long\r\n2000.0 \"Megaflare Enrage\" Ability { id: \"7E8\", source: \"Nael deus Darnus\" } window 2000,2000\r\n2008.5 \"Megaflare Enrage\"\r\n2017.0 \"Megaflare Enrage\"\r\n2025.5 \"Megaflare Enrage\"\r\n2034.0 \"Megaflare Enrage\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/ifrit-nm.ts


const ifrit_nm_triggerSet = {
  id: 'TheBowlOfEmbers',
  zoneId: zone_id/* default.TheBowlOfEmbers */.Z.TheBowlOfEmbers,
  timelineFile: 'ifrit-nm.txt',
  timelineTriggers: [{
    id: 'IfritNM Inner',
    regex: /Radiant Plume \(inner\)/,
    beforeSeconds: 3.5,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'IfritNM Outer',
    regex: /Radiant Plume \(outer\)/,
    beforeSeconds: 3.5,
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'IfritNM Nail Add',
    regex: /Nail Add/,
    beforeSeconds: 0.5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Nail',
        de: 'infernalische Fessel zerstören',
        fr: 'Détruisez le clou',
        ja: '炎獄の楔を討つ',
        cn: '击杀火狱之楔',
        ko: '말뚝 파괴하기'
      }
    }
  }],
  triggers: [],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Ifrit': 'Ifrit'
    },
    'replaceText': {
      'Eruption': 'Eruption',
      'Hellfire': 'Höllenfeuer',
      'Incinerate': 'Einäschern',
      'Nail Add': 'Fessel Add',
      'Radiant Plume': 'Scheiterhaufen',
      'Vulcan Burst': 'Feuerstoß'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ifrit': 'Ifrit'
    },
    'replaceText': {
      'Eruption': 'Éruption',
      'Hellfire': 'Flammes de l\'enfer',
      'Incinerate': 'Incinération',
      'Nail Add': 'Add Clou',
      'Radiant Plume': 'Panache radiant',
      'Vulcan Burst': 'Explosion volcanique'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ifrit': 'イフリート'
    },
    'replaceText': {
      'Eruption': 'エラプション',
      'Hellfire': '地獄の火炎',
      'Incinerate': 'インシネレート',
      'Nail Add': '雑魚: 炎獄の楔',
      'Radiant Plume': '光輝の炎柱',
      'Vulcan Burst': 'バルカンバースト'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ifrit': '伊弗利特'
    },
    'replaceText': {
      'Eruption': '地火喷发',
      'Hellfire': '地狱之火炎',
      'Incinerate': '烈焰焚烧',
      'Nail Add': '火狱之楔出现',
      'Radiant Plume': '光辉炎柱',
      'Vulcan Burst': '火神爆裂'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ifrit': '이프리트'
    },
    'replaceText': {
      'Eruption': '용암 분출',
      'Hellfire': '지옥의 화염',
      'Incinerate': '소각',
      'Nail Add': '말뚝 소환',
      'Radiant Plume': '광휘의 불기둥',
      'Vulcan Burst': '폭렬 난사'
    }
  }]
};
/* harmony default export */ const ifrit_nm = (ifrit_nm_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/ifrit-nm.txt
const trial_ifrit_nm_namespaceObject = "# Ifrit Story Mode / Normal Mode\r\n# -ii 2DD 2DE\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# 0%\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n1.2 \"Incinerate\" Ability { id: \"1C5\", source: \"Ifrit\" } window 10,10\r\n9.1 \"Vulcan Burst\" Ability { id: \"1C6\", source: \"Ifrit\" }\r\n17.1 \"Incinerate\" Ability { id: \"1C5\", source: \"Ifrit\" }\r\n30.0 \"Incinerate\" Ability { id: \"1C5\", source: \"Ifrit\" }\r\n42.9 \"Incinerate\" Ability { id: \"1C5\", source: \"Ifrit\" }\r\n\r\n50.7 \"Vulcan Burst\" Ability { id: \"1C6\", source: \"Ifrit\" } window 30,30 jump 9.1\r\n58.7 \"Incinerate\"\r\n71.6 \"Incinerate\"\r\n84.5 \"Incinerate\"\r\n\r\n92.3 \"Vulcan Burst\"\r\n100.3 \"Incinerate\"\r\n113.2 \"Incinerate\"\r\n126.1 \"Incinerate\"\r\n\r\n# 70%\r\n# https://xivapi.com/InstanceContentTextData/2601\r\n# en: Succumb to the Inferno!\r\n200.0 \"--sync--\" BattleTalk2 { npcNameId: \"04A1\", instanceContentTextId: \"0A29\" } window 200,0\r\n201.0 \"Incinerate\" Ability { id: \"1C5\", source: \"Ifrit\" }\r\n209.0 \"Eruption\" Ability { id: \"1C7\", source: \"Ifrit\" } window 210,5\r\n213.5 \"Vulcan Burst\" Ability { id: \"1C6\", source: \"Ifrit\" }\r\n\r\n220.4 \"Incinerate\" Ability { id: \"1C5\", source: \"Ifrit\" }\r\n228.5 \"Eruption\" Ability { id: \"1C7\", source: \"Ifrit\" }\r\n237.1 \"Incinerate\" Ability { id: \"1C5\", source: \"Ifrit\" } window 10,10 jump 220.4\r\n245.2 \"Eruption\"\r\n253.8 \"Incinerate\"\r\n261.9 \"Eruption\"\r\n270.5 \"Incinerate\"\r\n278.6 \"Eruption\"\r\n\r\n# 50%\r\n# https://xivapi.com/InstanceContentTextData/2602\r\n# en: Surrender thyself to the fires of judgment!\r\n300.0 \"--sync--\" BattleTalk2 { npcNameId: \"04A1\", instanceContentTextId: \"0A2A\" } window 300,0\r\n305.0 \"Nail Add\"\r\n306.7 \"Incinerate\" Ability { id: \"1C5\", source: \"Ifrit\" }\r\n314.4 \"Vulcan Burst\" Ability { id: \"1C6\", source: \"Ifrit\" }\r\n322.3 \"Incinerate\" Ability { id: \"1C5\", source: \"Ifrit\" }\r\n335.1 \"Incinerate\" Ability { id: \"1C5\", source: \"Ifrit\" }\r\n\r\n341.7 \"--untargetable--\"\r\n344.3 \"--sync--\" StartsUsing { id: \"1CA\", source: \"Ifrit\" } window 500,0\r\n346.3 \"Hellfire\" Ability { id: \"1CA\", source: \"Ifrit\" }\r\n350.7 \"--targetable--\"\r\n\r\n352.6 \"Incinerate\" Ability { id: \"1C5\", source: \"Ifrit\" }\r\n361.7 \"Eruption\" Ability { id: \"1C7\", source: \"Ifrit\" }\r\n370.4 \"Radiant Plume (inner)\" Ability { id: \"1C8\", source: \"Ifrit\" }\r\n378.8 \"Radiant Plume (outer)\" Ability { id: \"1C8\", source: \"Ifrit\" }\r\n\r\n385.0 \"Incinerate\" Ability { id: \"1C5\", source: \"Ifrit\" } window 20,20 jump 352.6\r\n394.1 \"Eruption\"\r\n402.8 \"Radiant Plume (inner)\"\r\n411.2 \"Radiant Plume (outer)\"\r\n\r\n417.4 \"Incinerate\"\r\n426.5 \"Eruption\"\r\n435.2 \"Radiant Plume (inner)\"\r\n443.6 \"Radiant Plume (outer)\"\r\n";
// EXTERNAL MODULE: ./resources/overlay_plugin_api.ts
var overlay_plugin_api = __webpack_require__(959);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/levi-ex.ts




// TODO: we could consider a timeline trigger for the Tidal Roar raidwide,
// but it barely does 25% health, has no startsUsing, and the timeline for
// this fight is not reliable enough to use.

// TODO: it'd be nice to call out the dives too, but there is no log line
// or combatant in the right place until ~4.5s after the nameplate toggles.
// This is about 1-2s after the splash appears, and so feels really late.
// Unfortunately the dives also have multiple combatants in plausible
// positions (+/-7, +/-20) and so more work would need to be done to tell
// them apart.
const levi_ex_triggerSet = {
  id: 'TheWhorleaterExtreme',
  zoneId: zone_id/* default.TheWhorleaterExtreme */.Z.TheWhorleaterExtreme,
  timelineFile: 'levi-ex.txt',
  initData: () => {
    return {
      converter: false,
      diveCounter: 0,
      slamLevis: []
    };
  },
  triggers: [{
    id: 'LeviEx Dive Counter Tidal Wave Reset',
    type: 'Ability',
    netRegex: {
      source: 'Leviathan',
      id: '82E',
      capture: false
    },
    run: data => {
      // There's always a slam after Tidal Wave.
      data.diveCounter = 1;
      // If you are running this unsynced and don't hit the button,
      // then prevent "Hit the Button" calls on future dives.
      data.converter = false;
    }
  }, {
    id: 'LeviEx Dive Counter Body Slam Reset',
    type: 'Ability',
    netRegex: {
      source: 'Leviathan',
      id: '82A',
      capture: false
    },
    // Redundant, but this will keep things on track if anything goes awry.
    run: data => data.diveCounter = 1
  }, {
    id: 'LeviEx Dive Counter Wave Spume Adjust',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Wave Spume',
      capture: false
    },
    suppressSeconds: 5,
    // Usually the pattern is slam / dive / dive / slam, but after wave spumes appear,
    // there is a single dive then a slam.  Adjust for this one-off case here.
    run: data => data.diveCounter = 2
  }, {
    id: 'LeviEx Slam Location',
    type: 'NameToggle',
    netRegex: {
      name: 'Leviathan',
      toggle: '00',
      capture: false
    },
    condition: data => {
      return ++data.diveCounter % 3 === 1;
    },
    // Actor moves between 4.6s and 4.7s; add a tiny bit of time for certainty.
    delaySeconds: 5,
    promise: async data => {
      const callData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants'
      });
      if (callData.combatants.length === 0) {
        console.error('Dive: failed to get combatants: ${JSON.stringify(callData)}');
        return;
      }
      // This is the real levi, according to hp.
      data.slamLevis = callData.combatants.filter(c => c.BNpcID === 2802);
    },
    alertText: (data, _matches, output) => {
      // Slams happen at +/-~14.6 +/-~13.
      const filtered = data.slamLevis.filter(c => {
        const offsetX = Math.abs(Math.abs(c.PosX) - 14.6);
        const offsetY = Math.abs(Math.abs(c.PosY) - 13);
        return offsetX < 1 && offsetY < 1;
      });
      if (filtered.length !== 1) return;
      const levi = filtered[0];
      if (levi && levi.PosY > 0) return output.north();
      return output.south();
    },
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      south: outputs/* default.south */.Z.south
    }
  }, {
    id: 'LeviEx Veil of the Whorl',
    type: 'Ability',
    netRegex: {
      source: 'Leviathan',
      id: '875',
      capture: false
    },
    condition: data => util/* default.isCasterDpsJob */.Z.isCasterDpsJob(data.job) || util/* default.isHealerJob */.Z.isHealerJob(data.job),
    suppressSeconds: 9999,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Attack Head Only',
        de: 'Nur den Kopf angreifen',
        fr: 'Attaquez seulement la tête',
        ja: '頭だけに攻撃',
        cn: '攻击头部',
        ko: '머리만 공격하기'
      }
    }
  }, {
    id: 'LeviEx Mantle of the Whorl',
    type: 'Ability',
    netRegex: {
      source: 'Leviathan\'s Tail',
      id: '874',
      capture: false
    },
    condition: data => util/* default.isRangedDpsJob */.Z.isRangedDpsJob(data.job),
    suppressSeconds: 9999,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Attack Tail Only',
        de: 'Nur den Schwanz angreifen',
        fr: 'Attaquez seulement la queue',
        ja: 'テールだけに攻撃',
        cn: '攻击尾巴',
        ko: '꼬리만 공격하기'
      }
    }
  }, {
    id: 'LeviEx Wavespine Sahagin Add',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Wavespine Sahagin',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.killAdds */.Z.killAdds
    }
  }, {
    id: 'LeviEx Wavetooth Sahagin Add',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Wavetooth Sahagin',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Wavetooth Add',
        de: 'Besiege Wellenzahn Add',
        fr: 'Tuez l\'add Dent-du-ressac',
        ja: 'ウェイブトゥース・サハギンに攻撃',
        cn: '优先击杀波齿鱼人',
        ko: '물결이빨 사하긴 처치'
      }
    }
  }, {
    id: 'LeviEx Wavetooth Sahagin Stun',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Wavetooth Sahagin'
    },
    condition: data => data.CanStun(),
    delaySeconds: 5,
    alertText: (_data, matches, output) => output.text({
      name: matches.name
    }),
    outputStrings: {
      text: outputs/* default.stunTarget */.Z.stunTarget
    }
  }, {
    id: 'LeviEx Gyre Spume',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Gyre Spume',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Gyre Spumes',
        de: 'Besiege Gischtblase',
        fr: 'Tuez les écumes concentriques',
        ja: 'ジャイヤ・スピュームに攻撃',
        cn: '打黄泡泡',
        ko: '노랑 물거품 처치'
      }
    }
  }, {
    id: 'LeviEx Wave Spume',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Wave Spume',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Wave Spume Adds',
        de: 'Gischtwelle Adds',
        fr: 'Adds Écumes ondulantes',
        ja: 'ウェイブ・スピューム出現',
        cn: '蓝泡泡出现',
        ko: '파랑 물거품 출현'
      }
    }
  }, {
    id: 'LeviEx Wave Spume Explosion',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Wave Spume',
      capture: false
    },
    // ~35.2 seconds from added combatant until :Aqua Burst:888: explosion.
    // Tell everybody because not much else going on in this fight,
    // and other people need to get away.
    delaySeconds: 30,
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Burst Soon',
        de: 'Gischtwelle platzen gleich',
        fr: 'Burst bientôt',
        ja: 'まもなく爆発',
        cn: '黄泡泡即将爆炸',
        ko: '물거품 폭발'
      }
    }
  }, {
    id: 'LeviEx Elemental Converter',
    type: 'NameToggle',
    netRegex: {
      name: 'Elemental Converter'
    },
    run: (data, matches) => data.converter = !!parseInt(matches.toggle)
  }, {
    id: 'LeviEx Hit The Button',
    type: 'NameToggle',
    netRegex: {
      name: 'Leviathan',
      toggle: '00',
      capture: false
    },
    // The best way to know if it's time to hit the button is if the converter is ready.
    // I think this is not true for hard mode, but is true (fingers crossed) for extreme.
    condition: data => data.converter,
    // Some delay for safety, as the button can be hit too early.
    delaySeconds: 3.5,
    suppressSeconds: 30,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hit The Button!',
        de: 'Mit Elementarumwandler interagieren!',
        fr: 'Activez la barrière !',
        ja: '魔法障壁を発動',
        cn: '打开开关！',
        ko: '장벽 발동!'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Elemental Converter': 'Elementarumwandler',
      'Leviathan(?!\'s)': 'Leviathan',
      'Leviathan\'s Tail': 'Leviathans Schwanz',
      'Gyre Spume': 'Gischtblase',
      'Wave Spume': 'Gischtwelle',
      'Wavetooth Sahagin': 'Wellenzahn-Sahagin',
      'Wavespine Sahagin': 'Wellendorn-Sahagin'
    },
    'replaceText': {
      'Aqua Breath': 'Aqua-Atem',
      'Aqua Burst': 'Aquatischer Knall',
      'Body Slam': 'Bugwelle',
      'Briny Veil': 'Wasserspiegelung',
      'Dread Tide': 'Hydrophobie',
      'Grand Fall': 'Wasserfall',
      'Gyre Spume': 'Gischtblase',
      'Mantle Of The Whorl': 'Wogenmantel',
      'Spinning Dive': 'Drehsprung',
      'Tail Whip': 'Schwanzpeitsche',
      'Tidal Roar': 'Schrei der Gezeiten',
      'Tidal Wave': 'Flutwelle',
      'Veil Of The Whorl': 'Wogenschleier',
      'Waterspout': 'Wasserhose',
      'Wave Spume': 'Gischtwelle',
      'Wavespine Sahagin': 'Wellendorn-Sahagin',
      'Wavetooth Sahagin': 'Wellenzahn-Sahagin'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Elemental Converter': 'activateur de la barrière',
      'Leviathan(?!\'s)': 'Léviathan',
      'Leviathan\'s Tail': 'queue de Léviathan',
      'Gyre Spume': 'écume concentrique',
      'Wave Spume': 'écume ondulante',
      'Wavetooth Sahagin': 'Sahuagin dent-du-ressac',
      'Wavespine Sahagin': 'Sahuagin épine-du-ressac'
    },
    'replaceText': {
      '\\(NW\\)': '(NO)',
      'Aqua Breath': 'Aquasouffle',
      'Aqua Burst': 'Explosion aquatique',
      'Body Slam': 'Charge physique',
      'Briny Veil': 'Miroir d\'eau',
      'Dread Tide': 'Onde terrifiante',
      'Grand Fall': 'Chute grandiose',
      'Gyre Spume': 'écume concentrique',
      'Mantle Of The Whorl': 'Manteau du Déchaîneur',
      'Spinning Dive': 'Piqué tournant',
      'Tail Whip': 'Coup caudal',
      'Tidal Roar': 'Vague rugissante',
      'Tidal Wave': 'Raz-de-marée',
      'Veil Of The Whorl': 'Voile du Déchaîneur',
      'Waterspout': 'Inondation',
      'Wave Spume': 'écume ondulante',
      'Wavespine Sahagin': 'Sahuagin épine-du-ressac',
      'Wavetooth Sahagin': 'Sahuagin dent-du-ressac'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Elemental Converter': '魔法障壁発動器',
      'Leviathan(?!\'s)': 'リヴァイアサン',
      'Leviathan\'s Tail': 'リヴァイアサン・テール',
      'Gyre Spume': 'ジャイヤ・スピューム',
      'Wave Spume': 'ウェイブ・スピューム',
      'Wavetooth Sahagin': 'ウェイブトゥース・サハギン',
      'Wavespine Sahagin': 'ウェイブスパイン・サハギン'
    },
    'replaceText': {
      'Aqua Breath': 'アクアブレス',
      'Aqua Burst': 'アクアバースト',
      'Body Slam': 'ボディスラム',
      'Briny Veil': 'ウォーターミラー',
      'Dread Tide': 'ドレッドウォーター',
      'Grand Fall': 'グランドフォール',
      'Gyre Spume': 'ジャイヤ・スピューム',
      'Mantle Of The Whorl': '水神のマント',
      'Spinning Dive': 'スピニングダイブ',
      'Tail Whip': 'テールウィップ',
      'Tidal Roar': 'タイダルロア',
      'Tidal Wave': 'タイダルウェイブ',
      'Veil Of The Whorl': '水神のヴェール',
      'Waterspout': 'オーバーフラッド',
      'Wave Spume': 'ウェイブ・スピューム',
      'Wavespine Sahagin': 'ウェイブスパイン・サハギン',
      'Wavetooth Sahagin': 'ウェイブトゥース・サハギン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Elemental Converter': '魔法障壁发动器',
      'Leviathan(?!\'s)': '利维亚桑',
      'Leviathan\'s Tail': '利维亚桑的尾巴',
      'Gyre Spume': '游涡泡沫',
      'Wave Spume': '巨浪泡沫',
      'Wavetooth Sahagin': '波齿鱼人',
      'Wavespine Sahagin': '波棘鱼人'
    },
    'replaceText': {
      'Aqua Breath': '水流吐息',
      'Aqua Burst': '流水爆发',
      'Body Slam': '猛撞',
      'Briny Veil': '海水镜面',
      'Dread Tide': '恐慌潮水',
      'Grand Fall': '九天落水',
      'Gyre Spume': '游涡泡沫',
      'Mantle Of The Whorl': '水神的披风',
      'Spinning Dive': '旋转下潜',
      'Tail Whip': '扫尾',
      'Tidal Roar': '怒潮咆哮',
      'Tidal Wave': '巨浪',
      'Veil Of The Whorl': '水神的面纱',
      'Waterspout': '海龙卷',
      'Wave Spume': '巨浪泡沫',
      'Wavespine Sahagin': '波棘鱼人',
      'Wavetooth Sahagin': '波齿鱼人'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Elemental Converter': '마법 장벽 발동기',
      'Leviathan(?!\'s)': '리바이어선',
      'Leviathan\'s Tail': '리바이어선 꼬리',
      'Gyre Spume': '소용돌이치는 물거품',
      'Wave Spume': '파도치는 물거품',
      'Wavetooth Sahagin': '물결이빨 사하긴',
      'Wavespine Sahagin': '물결등뼈 사하긴'
    },
    'replaceText': {
      'Aqua Breath': '물의 숨결',
      'Aqua Burst': '물방울 폭발',
      'Body Slam': '몸통 박기',
      'Briny Veil': '물의 거울',
      'Dread Tide': '공포의 물결',
      'Grand Fall': '강우',
      'Gyre Spume': '소용돌이치는 물거품',
      'Mantle Of The Whorl': '수신의 망토',
      'Spinning Dive': '고속 돌진',
      'Tail Whip': '꼬리 채찍',
      'Tidal Roar': '바다의 포효',
      'Tidal Wave': '해일',
      'Veil Of The Whorl': '수신의 장막',
      'Waterspout': '물폭풍',
      'Wave Spume': '파도치는 물거품',
      'Wavespine Sahagin': '물결등뼈 사하긴',
      'Wavetooth Sahagin': '물결이빨 사하긴'
    }
  }]
};
/* harmony default export */ const levi_ex = (levi_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/levi-ex.txt
const trial_levi_ex_namespaceObject = "### Leviathan Extreme\r\n# -p 82A:33.1 82E:286.5\r\n# -ii 828 823 824 825 829 82B 752 74E 88A 74A 749 82D 88B 831 792 791 747 748\r\n# -it \"Leviathan\"\r\n\r\n# Note: Briny Veil (831) is applied initially after the first jumps and then\r\n# whenever it falls off the person tanking the tail.  It is ignored after the\r\n# first time in the rest of the timeline because any jump will desync it.\r\n\r\n# Note: Some pushes in this fight are relative to boss hp and others are\r\n# related to Gyre Spume hp.  For instance, if Levi is pushed to 50% very\r\n# quickly the Spumes will spawn (but the Sahagin will keep spawning).\r\n# However, the fight is also relative to spume hp.  Even if Levi is at\r\n# 100%, if the spumes are killed very very quickly then Levi will skip\r\n# the 2x Spinning Dive + Body Slam section and go immediately into\r\n# 1x Spinning Dive + Tidal Wave.\r\n\r\n# Worse, the spumes appear both on a timer and on an hp push (so you can't sync)\r\n# and behavior seems different once the spumes appear.\r\n\r\n# Levi *ALSO* has multiple pushes, possibly every 10%.  For instance,\r\n# if you push to 80% in the initial phase with a strong hit, he will\r\n# go directly into the Briny Veil.\r\n\r\n# This timeline mostly just throws up its hands and tries to do its best\r\n# for the \"slow\" case where you're not doing any pushes whatsoever.\r\n# It's tough to sync and know the difference between 228.9 untargetable\r\n# and 275.2 untargetable (a tidal roar before? extra grand falls?),\r\n# but that's not something that can be done with timeline syncs.\r\n\r\n# All of this wordiness is to say that it's tough to sync this timeline properly,\r\n# sorry.\r\n\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1: Literally Just Autos (100% -> 90%)\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n25.8 \"--untargetable--\" NameToggle { name: \"Leviathan\", toggle: \"00\" } window 30,10\r\n\r\n### Phase 2: One Set of Orbs (90% -> 50%?)\r\n33.0 \"--targetable--\"\r\n33.1 \"Body Slam\" Ability { id: \"82A\", source: \"Leviathan\" } window 40,10\r\n38.3 \"Veil Of The Whorl\" Ability { id: \"875\", source: \"Leviathan\" } window 40,10\r\n43.3 \"Mantle Of The Whorl\" Ability { id: \"874\", source: \"Leviathan's Tail\" }\r\n45.6 \"--2x Wavespine Sahagin (N)--\"\r\n53.2 \"Aqua Breath\" Ability { id: \"826\", source: \"Leviathan\" }\r\n59.3 \"Tail Whip\" Ability { id: \"827\", source: \"Leviathan's Tail\" }\r\n60.4 \"Waterspout\" Ability { id: \"742\", source: \"Leviathan\" }\r\n73.8 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n77.9 \"Tidal Roar\" Ability { id: \"74B\", source: \"Leviathan\" } window 30,30\r\n\r\n85.2 \"--untargetable--\"\r\n88.3 \"Grand Fall\" Ability { id: \"82F\", source: \"Leviathan\" }\r\n90.8 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n94.3 \"Grand Fall\" Ability { id: \"82F\", source: \"Leviathan\" }\r\n95.8 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n101.5 \"--targetable--\"\r\n\r\n101.6 \"Body Slam\" Ability { id: \"82A\", source: \"Leviathan\" } window 30,30\r\n106.0 \"Briny Veil\" Ability { id: \"831\", source: \"Leviathan\" }\r\n110.7 \"--Wavetooth Sahagin (E)--\"\r\n121.0 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n125.1 \"Aqua Breath\" Ability { id: \"826\", source: \"Leviathan\" }\r\n126.0 \"Tail Whip\" Ability { id: \"827\", source: \"Leviathan's Tail\" }\r\n132.3 \"Waterspout\" Ability { id: \"742\", source: \"Leviathan\" }\r\n145.7 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n149.8 \"Tidal Roar\" Ability { id: \"74B\", source: \"Leviathan\" } window 30,30\r\n\r\n154.9 \"--untargetable--\"\r\n158.0 \"Grand Fall x3\" #Ability { id: \"82F\", source: \"Leviathan\" }\r\n160.5 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n165.4 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n171.1 \"--targetable--\"\r\n\r\n171.2 \"Body Slam\" Ability { id: \"82A\", source: \"Leviathan\" } window 30,30\r\n180.8 \"--4x Gyre Spume--\"\r\n192.7 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n196.3 \"Tail Whip\" #Ability { id: \"827\", source: \"Leviathan's Tail\" }\r\n196.8 \"Aqua Breath\" Ability { id: \"826\", source: \"Leviathan\" }\r\n204.0 \"Waterspout\" Ability { id: \"742\", source: \"Leviathan\" }\r\n217.3 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n221.4 \"Tidal Roar\" Ability { id: \"74B\", source: \"Leviathan\" } window 30,30\r\n\r\n228.9 \"--untargetable--\"\r\n232.0 \"Grand Fall x3\" #Ability { id: \"82F\", source: \"Leviathan\" }\r\n234.5 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n239.4 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n245.1 \"--targetable--\"\r\n\r\n245.2 \"Body Slam\" Ability { id: \"82A\", source: \"Leviathan\" } window 30,30\r\n267.5 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n\r\n275.2 \"--untargetable--\"\r\n278.3 \"Grand Fall\" Ability { id: \"82F\", source: \"Leviathan\" }\r\n280.8 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n280.8 \"--untargetable--\"\r\n286.5 \"Tidal Wave\" Ability { id: \"82E\", source: \"Leviathan\" } window 300,100\r\n\r\n\r\n### Phase 3: Two Sets of Orbs (50% -> 20%?)\r\n299.2 \"--targetable--\"\r\n299.3 \"Body Slam\" Ability { id: \"82A\", source: \"Leviathan\" } window 30,30\r\n301.3 \"--2x Wavespine Sahagin (S)--\"\r\n318.6 \"Aqua Breath\" Ability { id: \"826\", source: \"Leviathan\" }\r\n318.6 \"Tail Whip\" #Ability { id: \"827\", source: \"Leviathan's Tail\" }\r\n322.7 \"Waterspout\" Ability { id: \"742\", source: \"Leviathan\" }\r\n329.9 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n338.1 \"Tidal Roar\" Ability { id: \"74B\", source: \"Leviathan\" }\r\n\r\n347.3 \"--untargetable--\"\r\n350.4 \"Grand Fall\" Ability { id: \"82F\", source: \"Leviathan\" }\r\n352.9 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n357.8 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n\r\n363.5 \"--targetable--\"\r\n363.6 \"Body Slam\" Ability { id: \"82A\", source: \"Leviathan\" } window 30,30\r\n364.9 \"--4x Gyre Spume--\"\r\n382.9 \"Aqua Breath\" Ability { id: \"826\", source: \"Leviathan\" }\r\n385.0 \"Tail Whip\" #Ability { id: \"827\", source: \"Leviathan's Tail\" }\r\n387.1 \"Waterspout\" Ability { id: \"742\", source: \"Leviathan\" }\r\n394.3 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n402.4 \"--4x Wave Spume--\"\r\n402.5 \"Tidal Roar\" Ability { id: \"74B\", source: \"Leviathan\" }\r\n\r\n413.8 \"--untargetable--\"\r\n416.9 \"Grand Fall x3\" #Ability { id: \"82F\", source: \"Leviathan\" }\r\n419.4 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n\r\n\r\n425.1 \"--targetable--\"\r\n425.2 \"Body Slam\" Ability { id: \"82A\", source: \"Leviathan\" }\r\n435.3 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n439.6 \"Aqua Burst\" Ability { id: \"888\", source: \"Wave Spume\" }\r\n442.5 \"Aqua Breath\" Ability { id: \"826\", source: \"Leviathan\" }\r\n446.6 \"Waterspout\" Ability { id: \"742\", source: \"Leviathan\" }\r\n455.8 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n462.5 \"--untargetable--\"\r\n465.6 \"Grand Fall x3\" #Ability { id: \"82F\", source: \"Leviathan\" }\r\n468.1 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n468.1 \"--untargetable--\"\r\n473.9 \"Tidal Wave\" Ability { id: \"82E\", source: \"Leviathan\" } window 150,100\r\n\r\n\r\n### Phase 4: more adds, enrage\r\n486.6 \"--targetable--\"\r\n486.7 \"Body Slam\" Ability { id: \"82A\", source: \"Leviathan\" } window 30,30\r\n488.2 \"--Wavetooth Sahagin (NW)--\"\r\n500.3 \"Tidal Roar\" Ability { id: \"74B\", source: \"Leviathan\" }\r\n508.5 \"Aqua Breath\" Ability { id: \"826\", source: \"Leviathan\" }\r\n512.6 \"Waterspout\" Ability { id: \"742\", source: \"Leviathan\" }\r\n512.6 \"Tail Whip\" #Ability { id: \"827\", source: \"Leviathan's Tail\" }\r\n519.8 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n523.9 \"Tidal Roar\" Ability { id: \"74B\", source: \"Leviathan\" }\r\n\r\n532.1 \"--untargetable--\"\r\n535.2 \"Grand Fall x3\" #Ability { id: \"82F\", source: \"Leviathan\" }\r\n537.7 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n542.6 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n\r\n548.3 \"--targetable--\"\r\n548.4 \"Body Slam\" Ability { id: \"82A\", source: \"Leviathan\" } window 30,30\r\n563.6 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n567.7 \"Tidal Roar\" Ability { id: \"74B\", source: \"Leviathan\" }\r\n581.1 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n587.3 \"Tidal Roar\" Ability { id: \"74B\", source: \"Leviathan\" }\r\n600.9 \"--2x Wavespine Sahagin--\" # ? not sure where\r\n601.6 \"Tidal Roar\" Ability { id: \"74B\", source: \"Leviathan\" }\r\n609.8 \"Aqua Breath\" Ability { id: \"826\", source: \"Leviathan\" }\r\n613.9 \"Waterspout\" Ability { id: \"742\", source: \"Leviathan\" }\r\n614.8 \"Tail Whip\" #Ability { id: \"827\", source: \"Leviathan's Tail\" }\r\n621.1 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n625.2 \"Tidal Roar\" Ability { id: \"74B\", source: \"Leviathan\" }\r\n\r\n634.1 \"--untargetable--\"\r\n637.2 \"Grand Fall x3\" Ability { id: \"82F\", source: \"Leviathan\" }\r\n639.7 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n644.6 \"Spinning Dive\" Ability { id: \"82C\", source: \"Leviathan\" }\r\n\r\n650.3 \"--targetable--\"\r\n650.4 \"Body Slam\" Ability { id: \"82A\", source: \"Leviathan\" } window 30,30\r\n665.6 \"Dread Tide\" Ability { id: \"754\", source: \"Leviathan\" }\r\n\r\n669.6 \"--untargetable--\"\r\n676.9 \"Tidal Wave Enrage\" Ability { id: \"82E\", source: \"Leviathan\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/shiva-ex.ts



// TODO: some sort of warning about extra tank damage during bow phase?
// TODO: should the post-staff "spread" happen unconditionally prior to marker?
const shiva_ex_triggerSet = {
  id: 'TheAkhAfahAmphitheatreExtreme',
  zoneId: zone_id/* default.TheAkhAfahAmphitheatreExtreme */.Z.TheAkhAfahAmphitheatreExtreme,
  timelineFile: 'shiva-ex.txt',
  initData: () => {
    return {
      blunt: {},
      slashing: {},
      soonAfterWeaponChange: false,
      seenDiamondDust: false
    };
  },
  timelineTriggers: [{
    id: 'ShivaEx Absolute Zero',
    regex: /Absolute Zero/,
    beforeSeconds: 5,
    // These are usually doubled, so avoid spamming.
    suppressSeconds: 10,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'ShivaEx Icebrand',
    regex: /Icebrand/,
    beforeSeconds: 5,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Party Share Tankbuster',
        de: 'Tankbuster mit der Gruppe Teilen',
        fr: 'Partagez le Tank buster avec le groupe',
        ja: '頭割りタンクバスター',
        cn: '团队分摊死刑',
        ko: '파티 쉐어 탱버'
      }
    }
  }, {
    // Heavenly Strike is knockback only when unshielded, so use "info" here.
    id: 'ShivaEx Heavenly Strike',
    regex: /Heavenly Strike/,
    beforeSeconds: 5,
    suppressSeconds: 1,
    response: responses/* Responses.knockback */.n3.knockback('info')
  }],
  triggers: [{
    id: 'ShivaEx Staff Phase',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: '995',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        staffTankSwap: {
          en: 'Staff (Tank Swap)',
          de: 'Stab (Tankwechsel)',
          fr: 'Bâton (Tank Swap)',
          ja: '杖 (スイッチ)',
          cn: '权杖（换T）',
          ko: '지팡이 (탱커 교대)'
        },
        staff: {
          en: 'Staff',
          de: 'Stab',
          fr: 'Bâton',
          ja: '杖',
          cn: '权杖',
          ko: '지팡이'
        }
      };
      if (data.role === 'tank') {
        if (data.currentTank !== undefined && data.blunt[data.currentTank]) return {
          alertText: output.staffTankSwap()
        };
      }
      return {
        infoText: output.staff()
      };
    },
    run: data => data.soonAfterWeaponChange = true
  }, {
    id: 'ShivaEx Sword Phase',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: '993',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        swordTankSwap: {
          en: 'Sword (Tank Swap)',
          de: 'Schwert (Tankwechsel)',
          fr: 'Épée (Tank Swap)',
          ja: '剣 (スイッチ)',
          cn: '剑（换T）',
          ko: '검 (탱커 교대)'
        },
        sword: {
          en: 'Sword',
          de: 'Schwert',
          fr: 'Épée',
          ja: '剣',
          cn: '剑',
          ko: '검'
        }
      };
      if (data.role === 'tank') {
        if (data.currentTank !== undefined && data.slashing[data.currentTank]) return {
          alertText: output.swordTankSwap()
        };
      }
      return {
        infoText: output.sword()
      };
    },
    run: data => data.soonAfterWeaponChange = true
  }, {
    id: 'ShivaEx Weapon Change Delayed',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: ['993', '995'],
      capture: false
    },
    delaySeconds: 30,
    run: data => data.soonAfterWeaponChange = false
  }, {
    id: 'ShivaEx Slashing Resistance Down Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '23C'
    },
    run: (data, matches) => data.slashing[matches.target] = true
  }, {
    id: 'ShivaEx Slashing Resistance Down Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '23C'
    },
    run: (data, matches) => data.slashing[matches.target] = false
  }, {
    id: 'ShivaEx Blunt Resistance Down Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '23D'
    },
    run: (data, matches) => data.blunt[matches.target] = true
  }, {
    id: 'ShivaEx Blunt Resistance Down Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '23D'
    },
    run: (data, matches) => data.blunt[matches.target] = false
  }, {
    id: 'ShivaEx Current Tank',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: 'BE5'
    },
    run: (data, matches) => data.currentTank = matches.target
  }, {
    id: 'ShivaEx Hailstorm Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '001D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'ShivaEx Glacier Bash',
    type: 'StartsUsing',
    netRegex: {
      id: 'BE9',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind('info')
  }, {
    id: 'ShivaEx Whiteout',
    type: 'StartsUsing',
    netRegex: {
      id: 'BEC',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'ShivaEx Diamond Dust',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: '98A',
      capture: false
    },
    run: data => data.seenDiamondDust = true
  }, {
    id: 'ShivaEx Frost Bow',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: 'BDD',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind('alarm'),
    run: data => {
      // Just in case ACT has crashed or something, make sure this state is correct.
      data.seenDiamondDust = true;
    }
  }, {
    id: 'ShivaEx Avalanche Marker Me',
    type: 'HeadMarker',
    netRegex: {
      id: '001A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // Responses.knockback does not quite give the 'laser cleave' aspect here.
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback Laser on YOU',
        de: 'Rückstoß-Laser auf DIR',
        fr: 'Poussée-Laser sur VOUS',
        ja: '自分にアバランチ',
        cn: '击退激光点名',
        ko: '넉백 레이저 대상자'
      }
    }
  }, {
    id: 'ShivaEx Avalanche Marker Other',
    type: 'HeadMarker',
    netRegex: {
      id: '001A'
    },
    condition: conditions/* default.targetIsNotYou */.Z.targetIsNotYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Laser',
        de: 'Laser ausweichen',
        fr: 'Évitez le laser',
        ja: 'アバランチを避ける',
        cn: '躲避击退激光',
        ko: '레이저 피하기'
      }
    }
  }, {
    id: 'ShivaEx Shiva Circles',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: 'BEB'
    },
    condition: (data, matches) => {
      // Ignore other middle circles and try to only target the Icicle Impact x9.
      if (!data.seenDiamondDust || data.soonAfterWeaponChange) return false;
      const x = parseFloat(matches.x);
      const y = parseFloat(matches.y);
      return Math.abs(x) < 0.1 && Math.abs(y) < 0.1;
    },
    // This can hit multiple people.
    suppressSeconds: 10,
    response: responses/* Responses.goMiddle */.n3.goMiddle('info')
  }, {
    id: 'ShivaEx Permafrost',
    type: 'StartsUsing',
    netRegex: {
      id: 'BE3',
      capture: false
    },
    response: responses/* Responses.stopMoving */.n3.stopMoving('alert')
  }, {
    id: 'ShivaEx Ice Boulder',
    type: 'Ability',
    netRegex: {
      id: 'C8A'
    },
    condition: conditions/* default.targetIsNotYou */.Z.targetIsNotYou(),
    infoText: (data, matches, output) => {
      return output.text({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Free ${player}',
        de: 'Befreie ${player}',
        fr: 'Libérez ${player}',
        ja: '${player}を救って',
        cn: '解救${player}',
        ko: '${player}감옥 해제'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Ice Soldier': 'Eissoldat',
      'Shiva': 'Shiva'
    },
    'replaceText': {
      '\\(circle\\)': '(Kreis)',
      '\\(cross\\)': '(Kreuz)',
      'Absolute Zero': 'Absoluter Nullpunkt',
      'Avalanche': 'Lawine',
      'Diamond Dust': 'Diamantenstaub',
      'Dreams Of Ice': 'Eisige Träume',
      'Frost Blade': 'Frostklinge',
      'Frost Bow': 'Frostbogen',
      'Frost Staff': 'Froststab',
      'Glacier Bash': 'Gletscherlauf',
      'Glass Dance': 'Gläserner Tanz',
      'Hailstorm': 'Hagelsturm',
      'Heavenly Strike': 'Himmelszorn',
      'Icebrand': 'Eisbrand',
      'Icicle Impact': 'Eiszapfen-Schlag',
      'Melt': 'Schmelzen',
      'Permafrost': 'Permafrost',
      'Whiteout': 'Schneeblindheit'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ice Soldier': 'soldat de glace',
      'Shiva': 'Shiva'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(circle\\)': '(cercle)',
      '\\(cross\\)': '(croix)',
      'Absolute Zero': 'Zéro absolu',
      'Avalanche': 'Avalanche',
      'Diamond Dust': 'Poussière de diamant',
      'Dreams Of Ice': 'Illusions glacées',
      'Frost Blade': 'Lame glaciale',
      'Frost Bow': 'Arc glacial',
      'Frost Staff': 'Bâton glacial',
      'Glacier Bash': 'Effondrement de glacier',
      'Glass Dance': 'Danse de glace',
      'Hailstorm': 'Averse de grêle',
      'Heavenly Strike': 'Frappe céleste',
      'Icebrand': 'Épée de glace',
      'Icicle Impact': 'Impact de stalactite',
      'Melt': 'Fonte',
      'Permafrost': 'Permafrost',
      'Whiteout': 'Fusion Glaciation'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ice Soldier': 'アイスソルジャー',
      'Shiva': 'シヴァ'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(circle\\)': '(輪)',
      '\\(cross\\)': '(十字)',
      'Absolute Zero': '絶対零度',
      'Avalanche': 'アバランチ',
      'Diamond Dust': 'ダイアモンドダスト',
      'Dreams Of Ice': '氷結の幻想',
      'Frost Blade': '凍てつく剣',
      'Frost Bow': '凍てつく弓',
      'Frost Staff': '凍てつく杖',
      'Glacier Bash': 'グレイシャーバッシュ',
      'Glass Dance': '氷雪乱舞',
      'Hailstorm': 'ヘイルストーム',
      'Heavenly Strike': 'ヘヴンリーストライク',
      'Icebrand': 'アイスブランド',
      'Icicle Impact': 'アイシクルインパクト',
      'Melt': 'ウェポンメルト',
      'Permafrost': 'パーマフロスト',
      'Whiteout': 'ホワイトアウト'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ice Soldier': '寒冰士兵',
      'Shiva': '希瓦'
    },
    'replaceText': {
      '\\(circle\\)': '(圆)',
      '\\(cross\\)': '(十字)',
      'Absolute Zero': '绝对零度',
      'Avalanche': '雪崩',
      'Diamond Dust': '钻石星尘',
      'Dreams Of Ice': '寒冰的幻想',
      'Frost Blade': '冰霜之剑',
      'Frost Bow': '冰霜之弓',
      'Frost Staff': '冰霜之杖',
      'Glacier Bash': '冰河怒击',
      'Glass Dance': '冰雪乱舞',
      'Hailstorm': '冰雹',
      'Heavenly Strike': '天降一击',
      'Icebrand': '冰印剑',
      'Icicle Impact': '冰柱冲击',
      'Melt': '武器融化',
      'Permafrost': '永久冻土',
      'Whiteout': '白化视界'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ice Soldier': '얼음 병사',
      'Shiva': '시바'
    },
    'replaceText': {
      '\\(circle\\)': '(원형)',
      '\\(cross\\)': '(십자)',
      'Absolute Zero': '절대영도',
      'Avalanche': '눈사태',
      'Diamond Dust': '다이아몬드 더스트',
      'Dreams Of Ice': '빙결의 환상',
      'Frost Blade': '얼어붙은 검',
      'Frost Bow': '얼어붙은 활',
      'Frost Staff': '얼어붙은 지팡이',
      'Glacier Bash': '빙하 강타',
      'Glass Dance': '빙설난무',
      'Hailstorm': '우박 폭풍',
      'Heavenly Strike': '천상의 일격',
      'Icebrand': '얼음의 낙인',
      'Icicle Impact': '고드름 낙하',
      'Melt': '무기 용해',
      'Permafrost': '영구동토',
      'Whiteout': '폭설'
    }
  }]
};
/* harmony default export */ const shiva_ex = (shiva_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/shiva-ex.txt
const trial_shiva_ex_namespaceObject = "### Shiva Extreme\r\n# https://ffxiv.consolegameswiki.com/wiki/Akh_Afah_Amphitheatre_(Extreme)\r\n#\r\n# -ii BE2 C8A 9A2 -it Shiva\r\n# staff first: -p 995:100 C7F:200 994:800\r\n# blade first: -p 993:400 994:600 C7F:800\r\n# post-cutscene: -p C16:866.7\r\n#\r\n# Phase Flowchart:\r\n# HP:100%       95%          90%            80%        50% (if adds dead)\r\n#\r\n#           +-> 2a(staff) -> 3a(sword) -+\r\n# 1(autos) -+                           +-> 4(adds) -> cutscene ->\r\n#           +-> 2b(sword) -> 3b(staff) -+\r\n#\r\n#\r\n#\r\n#                        +-> 7a(staff) -+\r\n# -> 5(staff) -> 6(bow) -+              + -> 6(bow) -> etc\r\n#                        +-> 7b(sword) -+\r\n#\r\n#\r\n# Notes:\r\n# * in the 2b/3a sword phases, Whiteout / Glacier Bash can be +0.5s delayed randomly??\r\n# * Shiva will push at 50% to cutscene if adds are dead, invincible when <50% otherwise.\r\n# * permafrost is weirdly optional and makes timing the latter half a mess.\r\n# * 7a/7b have 1-2 permafrosts (1 of 2 options while weapon is out, 1 maybe during icicle impact)\r\n# * 5 only has the optional icicle impact permafrosts\r\n# * 6 has an optional permafrost after the avalanche laser\r\n# * permafrost appears to push back other abilities by ~4s, so lots of large syncs after them\r\n# * it doesn't seem like there's any connection between permafrost in one phase vs others\r\n# * overall, timings are very sloppy compared to other fights, maybe due to Shiva ~~animations~~\r\n\r\nhideall \"--sync--\"\r\nhideall \"--Reset--\"\r\n\r\n# Phase 1: Literally Just Autos (100% -> 95%)\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n2.0 \"--sync--\" Ability { id: \"BE4\", source: \"Shiva\" } window 10,10\r\n\r\n# jump to staff\r\n10.0 \"--sync--\" Ability { id: \"995\", source: \"Shiva\" } window 10,100 jump 100\r\n# jump to sword\r\n10.0 \"--sync--\" Ability { id: \"993\", source: \"Shiva\" } window 10,100 jump 400\r\n\r\n# Phase 2a: Staff (95% -> 90%)\r\n100.0 \"Frost Staff\" Ability { id: \"995\", source: \"Shiva\" }\r\n108.1 \"Hailstorm\" Ability { id: \"997\", source: \"Shiva\" }\r\n\r\n117.6 \"Absolute Zero\" Ability { id: \"BE6\", source: \"Shiva\" }\r\n127.0 \"Absolute Zero\" Ability { id: \"BE6\", source: \"Shiva\" }\r\n\r\n140.5 \"Absolute Zero\" Ability { id: \"BE6\", source: \"Shiva\" } window 8,8 jump 117.6\r\n149.9 \"Absolute Zero\" #Ability { id: \"BE6\", source: \"Shiva\" }\r\n\r\n163.4 \"Absolute Zero\" #Ability { id: \"BE6\", source: \"Shiva\" }\r\n173.8 \"Absolute Zero\" #Ability { id: \"BE6\", source: \"Shiva\" }\r\n\r\n\r\n# Phase 3a: Sword (90% -> 80%)\r\n200.0 \"Melt\" Ability { id: \"C7F\", source: \"Shiva\" } window 100,0\r\n# This rolls out x4 over 1.5 seconds, so don't sync\r\n207.2 \"Icicle Impact\" #Ability { id: \"BEB\", source: \"Shiva\" }\r\n212.3 \"Dreams Of Ice\" Ability { id: \"BEA\", source: \"Shiva\" }\r\n\r\n225.0 \"Frost Blade\" Ability { id: \"993\", source: \"Shiva\" }\r\n230.1 \"Icebrand\" Ability { id: \"BE1\", source: \"Shiva\" }\r\n\r\n235.4 \"Heavenly Strike\" Ability { id: \"BE8\", source: \"Shiva\" }\r\n245.0 \"Glacier Bash\" Ability { id: \"BE9\", source: \"Shiva\" }\r\n255.4 \"Whiteout\" Ability { id: \"BEC\", source: \"Shiva\" }\r\n\r\n263.9 \"Heavenly Strike\" Ability { id: \"BE8\", source: \"Shiva\" }\r\n273.5 \"Glacier Bash\" Ability { id: \"BE9\", source: \"Shiva\" }\r\n284.5 \"Whiteout\" Ability { id: \"BEC\", source: \"Shiva\" }\r\n\r\n292.8 \"Heavenly Strike\" Ability { id: \"BE8\", source: \"Shiva\" } window 20,20 jump 235.4\r\n302.4 \"Glacier Bash\" #Ability { id: \"BE9\", source: \"Shiva\" }\r\n312.8 \"Whiteout\" #Ability { id: \"BEC\", source: \"Shiva\" }\r\n\r\n321.3 \"Heavenly Strike\" #Ability { id: \"BE8\", source: \"Shiva\" }\r\n330.9 \"Glacier Bash\" #Ability { id: \"BE9\", source: \"Shiva\" }\r\n341.9 \"Whiteout\" #Ability { id: \"BEC\", source: \"Shiva\" }\r\n\r\n\r\n# Jump to adds phase from 1a/2a\r\n350.0 \"--sync--\" Ability { id: \"994\", source: \"Shiva\" } window 350,0 jump 800\r\n\r\n\r\n# Phase 2b: Sword (95% -> 90%)\r\n400.0 \"Frost Blade\" Ability { id: \"993\", source: \"Shiva\" }\r\n405.1 \"Icebrand\" Ability { id: \"BE1\", source: \"Shiva\" }\r\n\r\n410.3 \"Heavenly Strike\" Ability { id: \"BE8\", source: \"Shiva\" }\r\n419.9 \"Glacier Bash\" Ability { id: \"BE9\", source: \"Shiva\" }\r\n430.3 \"Whiteout\" Ability { id: \"BEC\", source: \"Shiva\" }\r\n\r\n438.8 \"Heavenly Strike\" Ability { id: \"BE8\", source: \"Shiva\" }\r\n448.4 \"Glacier Bash\" Ability { id: \"BE9\", source: \"Shiva\" }\r\n458.8 \"Whiteout\" Ability { id: \"BEC\", source: \"Shiva\" }\r\n\r\n467.2 \"Heavenly Strike\" Ability { id: \"BE8\", source: \"Shiva\" } window 20,20 jump 410.3\r\n477.3 \"Glacier Bash\" #Ability { id: \"BE9\", source: \"Shiva\" }\r\n487.7 \"Whiteout\" #Ability { id: \"BEC\", source: \"Shiva\" }\r\n\r\n496.2 \"Heavenly Strike\" #Ability { id: \"BE8\", source: \"Shiva\" }\r\n505.8 \"Glacier Bash\" #Ability { id: \"BE9\", source: \"Shiva\" }\r\n516.8 \"Whiteout\" #Ability { id: \"BEC\", source: \"Shiva\" }\r\n\r\n\r\n# Phase 3b: Staff (90% -> 80%)\r\n600.0 \"Melt\" Ability { id: \"994\", source: \"Shiva\" } window 200,0\r\n# This rolls out x4 over 1.5 seconds, so don't sync\r\n607.2 \"Icicle Impact\" #Ability { id: \"BEB\", source: \"Shiva\" }\r\n612.3 \"Dreams Of Ice\" Ability { id: \"BEA\", source: \"Shiva\" }\r\n\r\n625.0 \"Frost Staff\" Ability { id: \"995\", source: \"Shiva\" }\r\n633.1 \"Hailstorm\" Ability { id: \"997\", source: \"Shiva\" }\r\n\r\n642.6 \"Absolute Zero\" Ability { id: \"BE6\", source: \"Shiva\" }\r\n652.0 \"Absolute Zero\" Ability { id: \"BE6\", source: \"Shiva\" }\r\n\r\n665.5 \"Absolute Zero\" Ability { id: \"BE6\", source: \"Shiva\" } window 8,8 jump 642.6\r\n674.9 \"Absolute Zero\" #Ability { id: \"BE6\", source: \"Shiva\" }\r\n\r\n688.4 \"Absolute Zero\" #Ability { id: \"BE6\", source: \"Shiva\" }\r\n698.8 \"Absolute Zero\" #Ability { id: \"BE6\", source: \"Shiva\" }\r\n\r\n\r\n# Jump to adds phase from 1b/2b\r\n750.0 \"--sync--\" Ability { id: \"C7F\", source: \"Shiva\" } window 350,0 jump 801\r\n\r\n\r\n# Phase 4: Adds\r\n800.0 \"--sync--\" #Ability { id: \"994\", source: \"Shiva\" }\r\n801.0 \"--sync--\" #Ability { id: \"C7F\", source: \"Shiva\" }\r\n# If you push *really* fast and skip a 3a/3b weapon phase, you'll miss the melt jump.\r\n# So, fix that up with a combatant sync here.\r\n806.6 \"--adds targetable--\" AddedCombatant { name: \"Ice Soldier\" } window 807,10\r\n807.6 \"Dreams Of Ice\" Ability { id: \"BEA\", source: \"Shiva\" }\r\n813.2 \"Frost Blade\" Ability { id: \"993\", source: \"Shiva\" }\r\n818.5 \"Icebrand\" Ability { id: \"BE1\", source: \"Shiva\" }\r\n828.0 \"Glacier Bash\" Ability { id: \"BE9\", source: \"Shiva\" }\r\n837.5 \"Heavenly Strike\" Ability { id: \"BE8\", source: \"Shiva\" }\r\n\r\n\r\n# Diamond Dust Cutscene\r\n854.4 \"Melt\" Ability { id: \"994\", source: \"Shiva\" } window 60,10\r\n855.5 \"--untargetable--\"\r\n866.7 \"--frozen--\" Ability { id: \"C16\", source: \"Shiva\" } window 900,50\r\n871.6 \"Diamond Dust\" Ability { id: \"98A\", source: \"Shiva\" }\r\n878.7 \"--targetable--\"\r\n878.9 \"Dreams Of Ice\" Ability { id: \"BEA\", source: \"Shiva\" }\r\n\r\n\r\n# Phase 5: Post-Cutscene Staff\r\n# Unlike phase 7a staff, this one can only have a single optional Permafrost.\r\n885.8 \"Frost Staff\" Ability { id: \"995\", source: \"Shiva\" }\r\n888.1 \"Icicle Impact (cross)\" #Ability { id: \"BEB\", source: \"Shiva\" }\r\n893.9 \"Hailstorm\" Ability { id: \"997\", source: \"Shiva\" }\r\n896.0 \"Icicle Impact (cross)\" #Ability { id: \"BEB\", source: \"Shiva\" }\r\n908.6 \"Absolute Zero\" Ability { id: \"BE6\", source: \"Shiva\" }\r\n920.2 \"Absolute Zero\" Ability { id: \"BE6\", source: \"Shiva\" }\r\n925.4 \"Melt\" Ability { id: \"C7F\", source: \"Shiva\" }\r\n932.6 \"Icicle Impact (circle)\" duration 4 #Ability { id: \"BEB\", source: \"Shiva\" }\r\n935.5 \"Permafrost?\" Ability { id: \"BE3\", source: \"Shiva\" }\r\n939.7 \"Dreams Of Ice\" Ability { id: \"BEA\", source: \"Shiva\" } window 20,10\r\n\r\n\r\n# Phase 6: Bow\r\n942.8 \"Frost Bow\" Ability { id: \"BDD\", source: \"Shiva\" }\r\n947.9 \"Glass Dance\" Ability { id: \"BDF\", source: \"Shiva\" }\r\n970.5 \"Avalanche\" Ability { id: \"BE0\", source: \"Shiva\" }\r\n974.6 \"Permafrost?\" Ability { id: \"BE3\", source: \"Shiva\" }\r\n986.1 \"Melt\" Ability { id: \"C7E\", source: \"Shiva\" } window 20,20\r\n988.3 \"Dreams Of Ice\" Ability { id: \"BEA\", source: \"Shiva\" }\r\n\r\n996.2 \"Frost Staff?\" Ability { id: \"995\", source: \"Shiva\" } window 100,50 jump 1096.2\r\n996.2 \"Frost Blade?\" Ability { id: \"993\", source: \"Shiva\" } window 100,50 jump 1296.2\r\n\r\n\r\n# Phase 7a: Staff\r\n1096.2 \"Frost Staff\" Ability { id: \"995\", source: \"Shiva\" }\r\n1098.1 \"Icicle Impact (cross)\" #Ability { id: \"BEB\", source: \"Shiva\" }\r\n1104.3 \"Hailstorm\" Ability { id: \"997\", source: \"Shiva\" }\r\n1106.1 \"Icicle Impact (cross)\" #Ability { id: \"BEB\", source: \"Shiva\" }\r\n1109.0 \"Permafrost?\" Ability { id: \"BE3\", source: \"Shiva\" }\r\n1117.8 \"Absolute Zero\" Ability { id: \"BE6\", source: \"Shiva\" } window 20,2.5\r\n1125.6 \"Absolute Zero\" Ability { id: \"BE6\", source: \"Shiva\" }\r\n1133.0 \"Absolute Zero\" Ability { id: \"BE6\", source: \"Shiva\" }\r\n# Note: this last absolute zero can either happen at 1135.8 or 1140.4 depending on\r\n# where the permafrost shows up.  So, don't sync it.\r\n1138.0 \"Absolute Zero\" #Ability { id: \"BE6\", source: \"Shiva\" }\r\n1140.0 \"Permafrost?\" Ability { id: \"BE3\", source: \"Shiva\" }\r\n1149.4 \"Melt\" Ability { id: \"C7F\", source: \"Shiva\" } window 20,20\r\n1156.6 \"Icicle Impact (circle)\" duration 4 #Ability { id: \"BEB\", source: \"Shiva\" }\r\n1159.5 \"Permafrost?\" Ability { id: \"BE3\", source: \"Shiva\" }\r\n1163.7 \"Dreams Of Ice\" Ability { id: \"BEA\", source: \"Shiva\" } window 20,20\r\n\r\n1166.9 \"Frost Bow\" Ability { id: \"BDD\", source: \"Shiva\" } window 100,20 jump 942.8\r\n1172.0 \"Glass Dance\" #Ability { id: \"BDF\", source: \"Shiva\" }\r\n1194.6 \"Avalanche\" #Ability { id: \"BE0\", source: \"Shiva\" }\r\n1198.7 \"Permafrost?\" #Ability { id: \"BE3\", source: \"Shiva\" }\r\n1210.2 \"Melt\" #Ability { id: \"C7E\", source: \"Shiva\" } window 20,20\r\n1212.4 \"Dreams Of Ice\" #Ability { id: \"BEA\", source: \"Shiva\" }\r\n\r\n\r\n\r\n\r\n# Phase 7b: Sword\r\n1296.2 \"Frost Blade\" Ability { id: \"993\", source: \"Shiva\" }\r\n1298.5 \"Icicle Impact (cross)\" #Ability { id: \"BEB\", source: \"Shiva\" }\r\n1302.3 \"Icebrand\" Ability { id: \"BE1\", source: \"Shiva\" }\r\n1306.4 \"Icicle Impact (cross)\" #Ability { id: \"BEB\", source: \"Shiva\" }\r\n1306.4 \"Permafrost?\" Ability { id: \"BE3\", source: \"Shiva\" }\r\n1316.8 \"--sync--\" StartsUsing { id: \"BE9\", source: \"Shiva\" } window 10,10\r\n1319.0 \"Glacier Bash\" Ability { id: \"BE9\", source: \"Shiva\" }\r\n1329.4 \"Whiteout\" Ability { id: \"BEC\", source: \"Shiva\" }\r\n1334.7 \"Heavenly Strike\" Ability { id: \"BE8\", source: \"Shiva\" }\r\n1338.8 \"Permafrost?\" Ability { id: \"BE3\", source: \"Shiva\" }\r\n1350.7 \"Melt\" Ability { id: \"994\", source: \"Shiva\" } window 20,10\r\n1357.9 \"Icicle Impact (circle)\" duration 4 #Ability { id: \"BEB\", source: \"Shiva\" }\r\n1360.8 \"Permafrost?\" Ability { id: \"BE3\", source: \"Shiva\" }\r\n1365.0 \"Dreams Of Ice\" Ability { id: \"BEA\", source: \"Shiva\" } window 20,20\r\n\r\n1368.2 \"Frost Bow\" Ability { id: \"BDD\", source: \"Shiva\" } window 100,20 jump 942.8\r\n1373.3 \"Glass Dance\" #Ability { id: \"BDF\", source: \"Shiva\" }\r\n1395.9 \"Avalanche\" #Ability { id: \"BE0\", source: \"Shiva\" }\r\n1400.0 \"Permafrost?\" #Ability { id: \"BE3\", source: \"Shiva\" }\r\n1411.5 \"Melt\" #Ability { id: \"C7E\", source: \"Shiva\" } window 20,20\r\n1413.7 \"Dreams Of Ice\" #Ability { id: \"BEA\", source: \"Shiva\" }\r\n\r\n\r\n\r\n# Enrage\r\n#1165.6 \"--untargetable--\"\r\n#1176.7 \"--sync--\" Ability { id: \"C16\", source: \"Shiva\" }\r\n#1176.7 \"Diamond Dust\" Ability { id: \"9A2\", source: \"Shiva\" }\r\n#1181.6 \"Diamond Dust\" Ability { id: \"98A\", source: \"Shiva\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/shiva-hm.ts



// TODO: should the post-staff "spread" happen unconditionally prior to marker?

const shiva_hm_triggerSet = {
  id: 'TheAkhAfahAmphitheatreHard',
  zoneId: zone_id/* default.TheAkhAfahAmphitheatreHard */.Z.TheAkhAfahAmphitheatreHard,
  timelineFile: 'shiva-hm.txt',
  timelineTriggers: [{
    id: 'ShivaHm Absolute Zero',
    regex: /Absolute Zero/,
    beforeSeconds: 5,
    // These are usually doubled, so avoid spamming.
    suppressSeconds: 10,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'ShivaHm Icebrand',
    regex: /Icebrand/,
    beforeSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'ShivaHm Hailstorm Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '001D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'ShivaHm Glacier Bash',
    type: 'StartsUsing',
    netRegex: {
      id: '9A1',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind('info')
  }, {
    id: 'ShivaHm Permafrost',
    type: 'StartsUsing',
    netRegex: {
      id: '999',
      capture: false
    },
    response: responses/* Responses.stopMoving */.n3.stopMoving('alert')
  }, {
    id: 'ShivaHm Ice Boulder',
    type: 'Ability',
    netRegex: {
      id: '9A3'
    },
    condition: conditions/* default.targetIsNotYou */.Z.targetIsNotYou(),
    infoText: (data, matches, output) => {
      return output.text({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Free ${player}',
        de: 'Befreie ${player}',
        fr: 'Libérez ${player}',
        ja: '${player}を救う',
        cn: '解救${player}',
        ko: '${player}감옥 해제'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Ice Soldier': 'Eissoldat',
      'Shiva': 'Shiva'
    },
    'replaceText': {
      '\\(circle\\)': '(Kreis)',
      '\\(cross\\)': '(Kreuz)',
      'Absolute Zero': 'Absoluter Nullpunkt',
      'Diamond Dust': 'Diamantenstaub',
      'Dreams Of Ice': 'Eisige Träume',
      'Frost Blade': 'Frostklinge',
      'Frost Staff': 'Froststab',
      'Glacier Bash': 'Gletscherlauf',
      'Hailstorm': 'Hagelsturm',
      'Heavenly Strike': 'Himmelszorn',
      'Icebrand': 'Eisbrand',
      'Icicle Impact': 'Eiszapfen-Schlag',
      'Melt': 'Schmelzen',
      'Permafrost': 'Permafrost'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ice Soldier': 'soldat de glace',
      'Shiva': 'Shiva'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(circle\\)': '(cercle)',
      '\\(cross\\)': '(croix)',
      'Absolute Zero': 'Zéro absolu',
      'Diamond Dust': 'Poussière de diamant',
      'Dreams Of Ice': 'Illusions glacées',
      'Frost Blade': 'Lame glaciale',
      'Frost Staff': 'Bâton glacial',
      'Glacier Bash': 'Effondrement de glacier',
      'Hailstorm': 'Averse de grêle',
      'Heavenly Strike': 'Frappe céleste',
      'Icebrand': 'Épée de glace',
      'Icicle Impact': 'Impact de stalactite',
      'Melt': 'Fonte',
      'Permafrost': 'Permafrost'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ice Soldier': 'アイスソルジャー',
      'Shiva': 'シヴァ'
    },
    'replaceText': {
      '\\(circle\\)': '(輪)',
      '\\(cross\\)': '(十字)',
      'Absolute Zero': '絶対零度',
      'Diamond Dust': 'ダイアモンドダスト',
      'Dreams Of Ice': '氷結の幻想',
      'Frost Blade': '凍てつく剣',
      'Frost Staff': '凍てつく杖',
      'Glacier Bash': 'グレイシャーバッシュ',
      'Hailstorm': 'ヘイルストーム',
      'Heavenly Strike': 'ヘヴンリーストライク',
      'Icebrand': 'アイスブランド',
      'Icicle Impact': 'アイシクルインパクト',
      'Melt': 'ウェポンメルト',
      'Permafrost': 'パーマフロスト'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ice Soldier': '寒冰士兵',
      'Shiva': '希瓦'
    },
    'replaceText': {
      '\\(circle\\)': '(圆)',
      '\\(cross\\)': '(十字)',
      'Absolute Zero': '绝对零度',
      'Diamond Dust': '钻石星尘',
      'Dreams Of Ice': '寒冰的幻想',
      'Frost Blade': '冰霜之剑',
      'Frost Staff': '冰霜之杖',
      'Glacier Bash': '冰河怒击',
      'Hailstorm': '冰雹',
      'Heavenly Strike': '天降一击',
      'Icebrand': '冰印剑',
      'Icicle Impact': '冰柱冲击',
      'Melt': '武器融化',
      'Permafrost': '永久冻土'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ice Soldier': '얼음 병사',
      'Shiva': '시바'
    },
    'replaceText': {
      '\\(circle\\)': '(원형)',
      '\\(cross\\)': '(십자)',
      'Absolute Zero': '절대영도',
      'Diamond Dust': '다이아몬드 더스트',
      'Dreams Of Ice': '빙결의 환상',
      'Frost Blade': '얼어붙은 검',
      'Frost Staff': '얼어붙은 지팡이',
      'Glacier Bash': '빙하 강타',
      'Hailstorm': '우박 폭풍',
      'Heavenly Strike': '천상의 일격',
      'Icebrand': '얼음의 낙인',
      'Icicle Impact': '고드름 낙하',
      'Melt': '무기 용해',
      'Permafrost': '영구동토'
    }
  }]
};
/* harmony default export */ const shiva_hm = (shiva_hm_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/shiva-hm.txt
const trial_shiva_hm_namespaceObject = "### Shiva Hard\r\n# https://finalfantasy.fandom.com/wiki/Akh_Afah_Ampitheatre\r\n#\r\n# -it Shiva -ii 998 9A2 9A3\r\n# -p 995:100 C7F:200 994:800\r\n#\r\n# Phase Flowchart:\r\n# HP:100%     95%         85%           65%               40% (if adds dead)\r\n#                                   +-> 4a(adds+staff) -> cutscene -+\r\n# 1(autos) -> 2(staff) -> 3(sword) -+                               +->\r\n#                                   +-> 4b(adds+sword) -> cutscene -+\r\n#\r\n#  +-> 5a(staff) -+       +-> 6a(staff) -+\r\n# -+              + -+-> -+              + --- repeat --+\r\n#  +-> 5b(sword) -+  ^    +-> 6b(sword) -+              |\r\n#                    |                                  |\r\n#                    +----------------------------------+\r\n#\r\n# Notes:\r\n# * no enrage (at least in twenty minutes)\r\n# * like extreme, will go invincible if pushed below 40% until adds are dead\r\n# * always starts out staff phase sword phase, then a random one during adds\r\n# * the first phase after the cutscene has slightly different timings/abilities\r\n# * during phase 1, the icicle impact between phase 2 and 3 is always cross\r\n# * after the cutscene, the icicle impact is always the circle\r\n# * the remaining icicle impacts are random, but it doesn't affect the timeline\r\n# * unlike extreme, the permafrosts are guaranteed (thank goodness)\r\n\r\nhideall \"--sync--\"\r\nhideall \"--Reset--\"\r\n\r\n# Phase 1: Literally Just Autos (100% -> 95%)\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n2.0 \"--sync--\" Ability { id: \"99A\", source: \"Shiva\" } window 10,10\r\n\r\n# jump to staff\r\n10.0 \"--sync--\" Ability { id: \"995\", source: \"Shiva\" } window 10,100 jump 200\r\n\r\n\r\n# Phase 2: Staff (95% -> 85%)\r\n200.0 \"Frost Staff\" Ability { id: \"995\", source: \"Shiva\" }\r\n208.1 \"Hailstorm\" Ability { id: \"997\", source: \"Shiva\" }\r\n\r\n221.7 \"Absolute Zero\" Ability { id: \"99C\", source: \"Shiva\" } window 30,30 jump 221.7\r\n244.7 \"Absolute Zero\" #Ability { id: \"99C\", source: \"Shiva\" }\r\n267.7 \"Absolute Zero\" #Ability { id: \"99C\", source: \"Shiva\" }\r\n\r\n\r\n# Phase 3: Sword (85% -> 65%)\r\n400.0 \"Melt\" Ability { id: \"C7F\", source: \"Shiva\" } window 200,0\r\n409.2 \"Icicle Impact (cross)\" Ability { id: \"99E\", source: \"Shiva\" }\r\n417.3 \"Dreams Of Ice\" Ability { id: \"99D\", source: \"Shiva\" }\r\n\r\n427.9 \"Frost Blade\" Ability { id: \"993\", source: \"Shiva\" }\r\n433.0 \"Icebrand\" Ability { id: \"996\", source: \"Shiva\" }\r\n439.3 \"Heavenly Strike\" Ability { id: \"9A0\", source: \"Shiva\" }\r\n\r\n451.9 \"Glacier Bash\" Ability { id: \"9A1\", source: \"Shiva\" }\r\n468.7 \"Heavenly Strike\" Ability { id: \"9A0\", source: \"Shiva\" }\r\n\r\n481.1 \"Glacier Bash\" Ability { id: \"9A1\", source: \"Shiva\" } window 20,20 jump 451.9\r\n497.9 \"Heavenly Strike\" #Ability { id: \"9A0\", source: \"Shiva\" }\r\n\r\n\r\n# Phase 4: Adds\r\n800.0 \"Melt\" Ability { id: \"994\", source: \"Shiva\" } window 800,0\r\n# If you push *really* fast and skip a weapon phase, you'll miss the melt jump.\r\n# So, fix that up with a combatant sync here.\r\n806.2 \"--adds targetable--\" AddedCombatant { name: \"Ice Soldier\" } window 807,2.5\r\n809.9 \"Dreams Of Ice\" Ability { id: \"99D\", source: \"Shiva\" }\r\n\r\n# Note: Yes, really.  These times are different.\r\n823.6 \"Frost Staff?\" Ability { id: \"995\", source: \"Shiva\" } window 100,100 jump 1023.6\r\n825.4 \"Frost Blade?\" Ability { id: \"993\", source: \"Shiva\" } window 100,100 jump 1225.4\r\n\r\n\r\n# Phase 4a: Adds (Staff)\r\n1023.6 \"Frost Staff\" Ability { id: \"995\", source: \"Shiva\" }\r\n1031.7 \"Hailstorm\" Ability { id: \"997\", source: \"Shiva\" }\r\n1044.3 \"Absolute Zero\" Ability { id: \"99C\", source: \"Shiva\" }\r\n\r\n1051.6 \"Melt\" Ability { id: \"C7F\", source: \"Shiva\" } window 100,10\r\n1052.7 \"--untargetable--\"\r\n1063.9 \"--frozen--\" Ability { id: \"C16\", source: \"Shiva\" } window 1100,10\r\n1068.8 \"Diamond Dust\" Ability { id: \"98A\", source: \"Shiva\" }\r\n1076.0 \"--targetable--\"\r\n1079.1 \"Dreams Of Ice\" Ability { id: \"99D\", source: \"Shiva\" }\r\n1088.3 \"Icicle Impact (circle)\" duration 4 #Ability { id: \"99E\", source: \"Shiva\" }\r\n\r\n1095.3 \"Frost Staff?\" Ability { id: \"995\", source: \"Shiva\" } window 50,90 jump 1400\r\n1095.3 \"Frost Blade?\" Ability { id: \"993\", source: \"Shiva\" } window 50,90 jump 1600\r\n\r\n\r\n# Phase 4b: Adds (Blade)\r\n1225.4 \"Frost Blade\" Ability { id: \"993\", source: \"Shiva\" }\r\n1230.5 \"Icebrand\" Ability { id: \"996\", source: \"Shiva\" }\r\n1236.8 \"Heavenly Strike\" Ability { id: \"9A0\", source: \"Shiva\" }\r\n1249.2 \"Glacier Bash\" Ability { id: \"9A1\", source: \"Shiva\" }\r\n\r\n# You get 5 extra seconds to kill the adds if it's Blade.\r\n1256.6 \"Melt\" Ability { id: \"994\", source: \"Shiva\" } window 100,10\r\n1257.7 \"--untargetable--\"\r\n1268.9 \"--frozen--\" Ability { id: \"C16\", source: \"Shiva\" }\r\n1273.8 \"Diamond Dust\" Ability { id: \"98A\", source: \"Shiva\" }\r\n1281.0 \"--targetable--\"\r\n1284.2 \"Dreams Of Ice\" Ability { id: \"99D\", source: \"Shiva\" }\r\n1293.4 \"Icicle Impact (circle)\" duration 4 #Ability { id: \"99E\", source: \"Shiva\" }\r\n\r\n1300.6 \"Frost Staff?\" Ability { id: \"995\", source: \"Shiva\" } window 50,90 jump 1400\r\n1300.6 \"Frost Blade?\" Ability { id: \"993\", source: \"Shiva\" } window 50,90 jump 1600\r\n\r\n\r\n# Phase 5a: Staff\r\n# Note: only one absolute zero here.\r\n1400.0 \"Frost Staff\" Ability { id: \"995\", source: \"Shiva\" }\r\n1408.1 \"Hailstorm\" Ability { id: \"997\", source: \"Shiva\" }\r\n1421.7 \"Absolute Zero\" Ability { id: \"99C\", source: \"Shiva\" }\r\n1432.2 \"Melt\" Ability { id: \"C7F\", source: \"Shiva\" }\r\n1434.3 \"Permafrost\" Ability { id: \"999\", source: \"Shiva\" }\r\n1440.5 \"Dreams Of Ice\" Ability { id: \"99D\", source: \"Shiva\" }\r\n1450.7 \"Icicle Impact\" Ability { id: \"99E\", source: \"Shiva\" }\r\n\r\n1454.7 \"Frost Staff?\" Ability { id: \"995\", source: \"Shiva\" } window 50,90 jump 1800\r\n1454.7 \"Frost Blade?\" Ability { id: \"993\", source: \"Shiva\" } window 50,90 jump 2000\r\n\r\n\r\n# Phase 5b: Blade\r\n# Note: this has the same abilities as 6b, but slightly different timings,\r\n# e.g. Heavenly Strike is ~1611 instead of ~1614.\r\n1600.0 \"Frost Blade\" Ability { id: \"993\", source: \"Shiva\" }\r\n1605.3 \"Icebrand\" Ability { id: \"996\", source: \"Shiva\" }\r\n1611.7 \"Heavenly Strike\" Ability { id: \"9A0\", source: \"Shiva\" } window 10,10\r\n1624.2 \"Glacier Bash\" Ability { id: \"9A1\", source: \"Shiva\" }\r\n1634.8 \"Melt\" Ability { id: \"994\", source: \"Shiva\" }\r\n1636.9 \"Permafrost\" Ability { id: \"999\", source: \"Shiva\" }\r\n1643.1 \"Dreams Of Ice\" Ability { id: \"99D\", source: \"Shiva\" }\r\n1653.3 \"Icicle Impact\" #Ability { id: \"99E\", source: \"Shiva\" }\r\n\r\n1657.6 \"Frost Staff?\" Ability { id: \"995\", source: \"Shiva\" } window 90,90 jump 1800\r\n1657.6 \"Frost Blade?\" Ability { id: \"993\", source: \"Shiva\" } window 90,90 jump 2000\r\n\r\n\r\n# Phase 6a: Staff\r\n1800.0 \"Frost Staff\" Ability { id: \"995\", source: \"Shiva\" }\r\n1808.1 \"Hailstorm\" Ability { id: \"997\", source: \"Shiva\" }\r\n1818.6 \"Absolute Zero\" Ability { id: \"99C\", source: \"Shiva\" }\r\n1823.9 \"Absolute Zero\" Ability { id: \"99C\", source: \"Shiva\" }\r\n1829.2 \"Melt\" Ability { id: \"C7F\", source: \"Shiva\" }\r\n1831.3 \"Permafrost\" Ability { id: \"999\", source: \"Shiva\" }\r\n1837.5 \"Dreams Of Ice\" Ability { id: \"99D\", source: \"Shiva\" }\r\n1847.8 \"Icicle Impact\" Ability { id: \"99E\", source: \"Shiva\" }\r\n\r\n1851.8 \"Frost Staff?\" Ability { id: \"995\", source: \"Shiva\" } window 90,90 jump 1800\r\n1851.8 \"Frost Blade?\" Ability { id: \"993\", source: \"Shiva\" } window 90,90 jump 2000\r\n\r\n\r\n# Phase 6b: Blade\r\n2000.0 \"Frost Blade\" Ability { id: \"993\", source: \"Shiva\" }\r\n2005.1 \"Icebrand\" Ability { id: \"996\", source: \"Shiva\" } window 5,5\r\n2014.5 \"Heavenly Strike\" Ability { id: \"9A0\", source: \"Shiva\" } window 5,5\r\n2024.9 \"Glacier Bash\" Ability { id: \"9A1\", source: \"Shiva\" }\r\n2030.2 \"Melt\" Ability { id: \"994\", source: \"Shiva\" }\r\n2032.3 \"Permafrost\" Ability { id: \"999\", source: \"Shiva\" }\r\n2038.5 \"Dreams Of Ice\" Ability { id: \"99D\", source: \"Shiva\" }\r\n2048.7 \"Icicle Impact\" #Ability { id: \"99E\", source: \"Shiva\" }\r\n\r\n2053.5 \"Frost Staff?\" Ability { id: \"995\", source: \"Shiva\" } window 90,90 jump 1800\r\n2053.5 \"Frost Blade?\" Ability { id: \"993\", source: \"Shiva\" } window 90,90 jump 2000\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/titan-ex.ts


const titan_ex_triggerSet = {
  id: 'TheNavelExtreme',
  zoneId: zone_id/* default.TheNavelExtreme */.Z.TheNavelExtreme,
  timelineFile: 'titan-ex.txt',
  timelineTriggers: [{
    id: 'TitanEx Mountain Buster',
    regex: /Mountain Buster/,
    beforeSeconds: 7,
    condition: data => data.role === 'healer' || data.role === 'tank',
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'TitanEx Mountain Buster Avoid',
    regex: /Mountain Buster/,
    beforeSeconds: 7,
    condition: data => data.role !== 'healer' && data.role !== 'tank',
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'TitanEx Tumult',
    regex: /Tumult/,
    beforeSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'TitanEx Gaoler Adds',
    regex: /Gaoler Adds/,
    beforeSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Gaoler Adds',
        de: 'graniten Kerkermeister Adds',
        fr: 'Adds Geôlier',
        ja: '雑魚: 子タイタン',
        cn: '小土豆出现',
        ko: '화강암 감옥 쫄'
      }
    }
  }, {
    id: 'TitanEx Double Weight',
    regex: /Weight Of The Land 1/,
    beforeSeconds: 4,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Double Weight',
        de: 'Doppeltes Gaias Gewicht',
        fr: 'Double poids',
        ja: '大地の重み2連',
        cn: '二连流沙',
        ko: '2연속 대지의 무게'
      }
    }
  }],
  triggers: [{
    // Doesn't seem like this happens twice, but let's be safe.
    id: 'TitanEx Rock Throw',
    type: 'Tether',
    netRegex: {
      id: '0007'
    },
    suppressSeconds: 1,
    alertText: (data, matches, output) => {
      if (matches.source === data.me || matches.target === data.me) return output.jailOnYou();
    },
    infoText: (data, matches, output) => {
      if (matches.source !== data.me && matches.target !== data.me) return output.jails();
    },
    outputStrings: {
      jailOnYou: {
        en: 'Jail on YOU',
        de: 'Gefängnis auf DIR',
        fr: 'Geôle sur VOUS',
        ja: '自分にジェイル',
        cn: '石牢点名',
        ko: '돌감옥 대상자'
      },
      jails: {
        en: 'Jails',
        de: 'Gefängnis',
        fr: 'Geôles',
        ja: 'ジェイル',
        cn: '石牢',
        ko: '돌감옥'
      }
    }
  }, {
    id: 'TitanEx Upheaval',
    type: 'StartsUsing',
    // Five second cast time.
    netRegex: {
      source: 'Titan',
      id: '5BA',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback('info')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bomb Boulder': 'Bomber-Brocken',
      'Granite Gaoler': 'graniten(?:e|er|es|en) Kerkermeister',
      'Titan': 'Titan'
    },
    'replaceText': {
      '\\(all\\)': '(alle)',
      '\\(clock\\)': '(Uhrzeiger)',
      '\\(one side\\)': '(eine Seite)',
      '\\(row (\\\d)\\)': '(Reihe $1)',
      'Burst': 'Einschlag',
      'Bury': 'Begraben',
      'Earthen Fury': 'Gaias Zorn',
      'Gaoler Adds': 'Kerkermeister Adds',
      'Gaoler Landslide': 'Kerkermeister Bergsturz',
      'Gaoler Tumult': 'Kerkermeister Urerschütterung ',
      'Geocrush': 'Geo-Stoß',
      '(?<! )Landslide': 'Bergsturz',
      'Mountain Buster': 'Bergsprenger',
      'Rock Buster': 'Steinsprenger',
      'Rock Throw': 'Granitgefängnis',
      '(?<! )Tumult': 'Urerschütterung',
      'Upheaval': 'Urtrauma',
      'Weight Of The Land': 'Gaias Gewicht'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bomb Boulder': 'Bombo Rocher',
      'Granite Gaoler': 'Geôlier De Granite',
      'Titan': 'Titan'
    },
    'replaceText': {
      '\\(all\\)': '(tous)',
      '\\(clock\\)': '(sens horaire)',
      '\\(one side\\)': '(un côté)',
      '\\(row (\\\d)\\)': '(rangée $1)',
      'Burst': 'Explosion',
      'Bury': 'Ensevelissement',
      'Earthen Fury': 'Fureur tellurique',
      'Gaoler Adds': 'Adds geôlier',
      'Gaoler Landslide\\?': 'Geôlier glissement ?',
      'Gaoler Tumult': 'Geôlier tumulte',
      'Geocrush': 'Broie-terre',
      '(?<! )Landslide': 'Glissement de terrain',
      'Mountain Buster': 'Casse-montagnes',
      'Rock Buster': 'Casse-roc',
      'Rock Throw': 'Jeté de rocs',
      '(?<! )Tumult': 'Tumulte',
      'Upheaval': 'Bouleversement',
      'Weight Of The Land': 'Poids de la terre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bomb Boulder': 'ボムボルダー',
      'Granite Gaoler': 'グラナイト・ジェイラー',
      'Titan': 'タイタン'
    },
    'replaceText': {
      '\\(all\\)': '(全て)',
      '\\(clock\\)': '(時針回り)',
      '\\(one side\\)': '(一側)',
      '\\(row 1\\)': '(1列)',
      '\\(row 2\\)': '(2列)',
      '\\(row 3\\)': '(3列)',
      'Burst': '大爆発',
      'Bury': '衝撃',
      'Earthen Fury': '大地の怒り',
      'Gaoler Adds': '雑魚: 子タイタン',
      'Gaoler Landslide\\?': '子タイタン: ランドスライド?',
      'Gaoler Tumult': '子タイタン: 激震',
      'Geocrush': 'ジオクラッシュ',
      '(?<! )Landslide': 'ランドスライド',
      'Mountain Buster': 'マウンテンバスター',
      'Rock Buster': 'ロックバスター',
      'Rock Throw': 'グラナイト・ジェイル',
      '(?<! )Tumult': '激震',
      'Upheaval': '大激震',
      'Weight Of The Land': '大地の重み'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bomb Boulder': '爆破岩石',
      'Granite Gaoler': '花岗石卫',
      'Titan': '泰坦'
    },
    'replaceText': {
      '\\(all\\)': '(全部)',
      '\\(clock\\)': '(顺时针)',
      '\\(one side\\)': '(一侧)',
      '\\(row 1\\)': '(第1列)',
      '\\(row 2\\)': '(第2列)',
      '\\(row 3\\)': '(第3列)',
      'Burst': '爆炸',
      'Bury': '塌方',
      'Earthen Fury': '大地之怒',
      'Gaoler Adds': '花岗石卫出现',
      'Gaoler Landslide': '花岗石卫地裂',
      'Gaoler Tumult': '花岗石卫怒震',
      'Geocrush': '大地粉碎',
      '(?<! )Landslide': '地裂',
      'Mountain Buster': '山崩',
      'Rock Buster': '碎岩',
      'Rock Throw': '花岗岩牢狱',
      '(?<! )Tumult': '怒震',
      'Upheaval': '大怒震',
      'Weight Of The Land': '大地之重'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bomb Boulder': '바위폭탄',
      'Granite Gaoler': '화강암 감옥',
      'Titan': '타이탄'
    },
    'replaceText': {
      '\\(all\\)': '(모두)',
      '\\(clock\\)': '(시계 방향)',
      '\\(one side\\)': '(한 방향)',
      '\\(row 1\\)': '(1열)',
      '\\(row 2\\)': '(2열)',
      '\\(row 3\\)': '(3열)',
      'Burst': '대폭발',
      'Bury': '충격',
      'Earthen Fury': '대지의 분노',
      'Gaoler Adds': '화강암 감옥 등장',
      'Gaoler Landslide': '화강암 감옥 산사태',
      'Gaoler Tumult': '화강암 감옥 격진',
      'Geocrush': '대지 붕괴',
      '(?<! )Landslide': '산사태',
      'Mountain Buster': '산 쪼개기',
      'Rock Buster': '바위 쪼개기',
      'Rock Throw': '화강암 감옥',
      '(?<! )Tumult': '격진',
      'Upheaval': '대격진',
      'Weight Of The Land': '대지의 무게'
    }
  }]
};
/* harmony default export */ const titan_ex = (titan_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/titan-ex.txt
const trial_titan_ex_namespaceObject = "# Titan Extreme\r\n# -p 5C0:203 5C1:700 -ii 368 5BD 5BC 673\r\n\r\n# Note: Landslides during upheavals only happen if there is a targetable\r\n# player outside the two jails.  If solo/duo-ing, then everything moves\r\n# up ~6 seconds or so, which is why there's large windows after Upheaval.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1: 100->85%\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n\r\n10.0 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" } window 10,10\r\n18.7 \"Weight Of The Land\" Ability { id: \"5BE\", source: \"Titan\" } window 20,5\r\n22.3 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" }\r\n27.5 \"Tumult x4\" duration 3.5 #Ability { id: \"5B9\", source: \"Titan\" }\r\n37.3 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" }\r\n41.4 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" }\r\n48.0 \"Weight Of The Land\" Ability { id: \"5BE\", source: \"Titan\" }\r\n55.7 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" }\r\n\r\n62.0 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" } window 15,15 jump 10\r\n70.2 \"Weight Of The Land\"\r\n74.3 \"Mountain Buster\"\r\n79.5 \"Tumult x4\" duration 3.5 #Ability { id: \"5B9\", source: \"Titan\" }\r\n89.3 \"Landslide\"\r\n93.4 \"Mountain Buster\"\r\n99.5 \"Weight Of The Land\"\r\n107.7 \"Mountain Buster\"\r\n\r\n\r\n# Phase 2: 85%->55%\r\n200.0 \"--sync--\" StartsUsing { id: \"5C0\", source: \"Titan\" } window 200,0\r\n203.0 \"Geocrush\" Ability { id: \"5C0\", source: \"Titan\" }\r\n\r\n212.6 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" }\r\n216.7 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" } duration 21.5\r\n220.8 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" }\r\n229.8 \"Upheaval\" Ability { id: \"5BA\", source: \"Titan\" }\r\n234.8 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" }\r\n242.0 \"Tumult x4\" duration 3.5 # Ability { id: \"5B9\", source: \"Titan\" }\r\n251.0 \"Weight Of The Land\" Ability { id: \"5BE\", source: \"Titan\" } window 15,15\r\n254.6 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" }\r\n262.0 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" }\r\n271.7 \"Weight Of The Land\" Ability { id: \"5BE\", source: \"Titan\" }\r\n276.8 \"Bury (one side)\" Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n278.0 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" }\r\n287.4 \"Burst\" Ability { id: \"5BF\", source: \"Bomb Boulder\" }\r\n\r\n288.1 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" }\r\n292.2 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" } duration 21.5\r\n296.3 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" }\r\n305.4 \"Upheaval\" Ability { id: \"5BA\", source: \"Titan\" }\r\n310.4 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" }\r\n317.5 \"Tumult x4\" duration 3.5 #Ability { id: \"5B9\", source: \"Titan\" }\r\n326.5 \"Weight Of The Land\" Ability { id: \"5BE\", source: \"Titan\" } window 15,15\r\n330.1 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" }\r\n337.3 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" }\r\n347.0 \"Weight Of The Land\" Ability { id: \"5BE\", source: \"Titan\" }\r\n351.7 \"Bury (clock)\" duration 4.2 #Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n353.6 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" }\r\n360.9 \"Burst\" duration 4.2 #Ability { id: \"5BF\", source: \"Bomb Boulder\" }\r\n\r\n363.9 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" } window 20,20 jump 212.6\r\n368.0 \"Rock Throw\"\r\n372.1 \"Mountain Buster\"\r\n381.1 \"Upheaval\"\r\n387.3 \"Tumult x4\"\r\n395.8 \"Weight Of The Land\"\r\n399.9 \"Mountain Buster\"\r\n407.3 \"Landslide\"\r\n416.5 \"Weight Of The Land\"\r\n422.1 \"Bury (one side)\"\r\n423.3 \"Mountain Buster\"\r\n432.7 \"Burst\"\r\n\r\n\r\n### Phase 3: Heart Phase (at 55%)\r\n500.0 \"--sync--\" StartsUsing { id: \"5C0\", source: \"Titan\" } window 299,0\r\n503.0 \"Geocrush\" Ability { id: \"5C0\", source: \"Titan\" }\r\n515.6 \"Weight Of The Land\" Ability { id: \"5BE\", source: \"Titan\" }\r\n521.2 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" } duration 21.5\r\n526.0 \"Rock Buster\" Ability { id: \"5B7\", source: \"Titan\" }\r\n533.0 \"Upheaval\" Ability { id: \"5BA\", source: \"Titan\" }\r\n538.0 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" }\r\n544.0 \"Tumult x4\" duration 3.5 #Ability { id: \"5B9\", source: \"Titan\" }\r\n553.1 \"Weight Of The Land\" Ability { id: \"5BE\", source: \"Titan\" } window 15,15\r\n561.8 \"Rock Buster\" Ability { id: \"5B7\", source: \"Titan\" }\r\n563.8 \"Bury (clock)\" duration 3 # Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n570.8 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" }\r\n572.9 \"Burst\" duration 3 # Ability { id: \"5BF\", source: \"Bomb Boulder\" }\r\n574.9 \"Tumult x4\" duration 3.5 #Ability { id: \"5B9\", source: \"Titan\" }\r\n583.0 \"Weight Of The Land\" Ability { id: \"5BE\", source: \"Titan\" }\r\n593.0 \"--untargetable--\"\r\n\r\n\r\n### Phase 4\r\n700.0 \"Earthen Fury\" Ability { id: \"5C1\", source: \"Titan\" } window 700,0\r\n713.1 \"Gaoler Adds (E/W)\"\r\n715.8 \"Gaoler Tumult\" #Ability { id: \"5C4\", source: \"Granite Gaoler\" }\r\n716.3 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" }\r\n\r\n723.3 \"Bury x4\" #Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n725.8 \"Bury x4\" #Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n730.2 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" }\r\n732.5 \"Burst x4\" #Ability { id: \"5BF\", source: \"Bomb Boulder\" }\r\n734.9 \"Burst x4\" #Ability { id: \"5BF\", source: \"Bomb Boulder\" }\r\n735.4 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" }\r\n739.8 \"Gaoler Landslide?\" #Ability { id: \"5C3\", source: \"Granite Gaoler\" }\r\n744.0 \"Weight Of The Land\" Ability { id: \"5BE\", source: \"Titan\" }\r\n\r\n749.7 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" } duration 21.5\r\n753.9 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" }\r\n762.9 \"Upheaval\" Ability { id: \"5BA\", source: \"Titan\" }\r\n767.9 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" }\r\n779.0 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" } window 15,15\r\n783.2 \"Tumult x4\" duration 3.5 #Ability { id: \"5B9\", source: \"Titan\" }\r\n792.2 \"Weight Of The Land 1\" #Ability { id: \"5BE\", source: \"Titan\" }\r\n794.7 \"Weight Of The Land 2\" #Ability { id: \"5BE\", source: \"Titan\" }\r\n799.9 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" }\r\n\r\n804.1 \"Bury (row 1)\" #Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n805.0 \"Bury (row 2)\" #Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n806.1 \"Bury (row 3)\" #Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n811.0 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" }\r\n813.1 \"Burst 1\" #Ability { id: \"5BF\", source: \"Bomb Boulder\" }\r\n814.6 \"Burst 2\" #Ability { id: \"5BF\", source: \"Bomb Boulder\" }\r\n816.1 \"Burst 3\" #Ability { id: \"5BF\", source: \"Bomb Boulder\" }\r\n819.2 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" }\r\n\r\n832.7 \"Bury (all)\" Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n837.0 \"Tumult x4\" duration 3.5 #Ability { id: \"5B9\", source: \"Titan\" }\r\n845.9 \"Weight Of The Land\" Ability { id: \"5BE\", source: \"Titan\" }\r\n852.5 \"--untargetable--\"\r\n855.1 \"Burst\" Ability { id: \"5BF\", source: \"Bomb Boulder\" }\r\n856.7 \"Geocrush\" Ability { id: \"5C0\", source: \"Titan\" }\r\n857.1 \"--targetable--\"\r\n862.4 \"Landslide\" Ability { id: \"5BB\", source: \"Titan\" }\r\n\r\n# loop\r\n874.0 \"Gaoler Adds (E/W)\"\r\n876.7 \"Gaoler Tumult\" #Ability { id: \"5C4\", source: \"Granite Gaoler\" }\r\n877.2 \"Mountain Buster\" Ability { id: \"5B8\", source: \"Titan\" } window 40,40 jump 716.3\r\n\r\n884.2 \"Bury x4\"\r\n886.7 \"Bury x4\"\r\n891.1 \"Landslide\"\r\n893.4 \"Burst x4\"\r\n895.8 \"Burst x4\"\r\n896.3 \"Mountain Buster\"\r\n900.7 \"Gaoler Landslide?\"\r\n904.4 \"Weight Of The Land\"\r\n\r\n\r\n### Enrage\r\n1000.0 \"--sync--\" StartsUsing { id: \"5C2\", source: \"Titan\" } window 1000,1000\r\n1010.0 \"Upheaval Enrage\" #Ability { id: \"5C2\", source: \"Titan\" }\r\n1022.0 \"Upheaval Enrage\" #Ability { id: \"5C2\", source: \"Titan\" }\r\n1034.0 \"Upheaval Enrage\" #Ability { id: \"5C2\", source: \"Titan\" }\r\n1046.0 \"Upheaval Enrage\" #Ability { id: \"5C2\", source: \"Titan\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/titan-hm.ts


const titan_hm_triggerSet = {
  id: 'TheNavelHard',
  zoneId: zone_id/* default.TheNavelHard */.Z.TheNavelHard,
  timelineFile: 'titan-hm.txt',
  timelineTriggers: [{
    id: 'TitanHm Mountain Buster',
    regex: /Mountain Buster/,
    beforeSeconds: 7,
    condition: data => data.role === 'healer' || data.role === 'tank',
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'TitanHm Mountain Buster Avoid',
    regex: /Mountain Buster/,
    beforeSeconds: 7,
    condition: data => data.role !== 'healer' && data.role !== 'tank',
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'TitanHm Rock Buster',
    regex: /Rock Buster/,
    beforeSeconds: 6,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'TitanHm Tumult',
    regex: /Tumult/,
    beforeSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  triggers: [{
    id: 'TitanHm Damage Down',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3E'
    },
    condition: data => data.CanCleanse(),
    infoText: (data, matches, output) => {
      return output.text({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Cleanse ${player}',
        de: 'Reinige ${player}',
        fr: 'Guérison sur ${player}',
        ja: '${player}にエスナ',
        cn: '康复${player}',
        ko: '${player}에스나'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bomb Boulder': 'Bomber-Brocken',
      'Titan': 'Titan'
    },
    'replaceText': {
      '\\(clock\\)': '(Uhrzeiger)',
      'Burst': 'Einschlag',
      'Bury': 'Begraben',
      'Earthen Fury': 'Gaias Zorn',
      'Geocrush': 'Geo-Stoß',
      'Landslide': 'Bergsturz',
      'Mountain Buster': 'Bergsprenger',
      'Rock Buster': 'Steinsprenger',
      'Rock Throw': 'Granitgefängnis',
      'Tumult': 'Urerschütterung',
      'Weight Of The Land': 'Gaias Gewicht'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bomb Boulder': 'Bombo Rocher',
      'Titan': 'Titan'
    },
    'replaceText': {
      '\\(clock\\)': '(sens horaire)',
      '\\(diamond\\)': '(diamant)',
      '\\(line\\)': '(ligne)',
      'Burst': 'Explosion',
      'Bury': 'Ensevelissement',
      'Earthen Fury': 'Fureur tellurique',
      'Geocrush': 'Broie-terre',
      'Landslide': 'Glissement de terrain',
      'Mountain Buster': 'Casse-montagnes',
      'Rock Buster': 'Casse-roc',
      'Rock Throw': 'Jeté de rocs',
      'Tumult': 'Tumulte',
      'Weight Of The Land': 'Poids de la terre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bomb Boulder': 'ボムボルダー',
      'Titan': 'タイタン'
    },
    'replaceText': {
      '\\(clock\\)': '(時針回り)',
      '\\(diamond\\)': '(ダイヤモンド)',
      '\\(line\\)': '(一直線)',
      'Burst': '大爆発',
      'Bury': '衝撃',
      'Earthen Fury': '大地の怒り',
      'Geocrush': 'ジオクラッシュ',
      'Landslide': 'ランドスライド',
      'Mountain Buster': 'マウンテンバスター',
      'Rock Buster': 'ロックバスター',
      'Rock Throw': 'グラナイト・ジェイル',
      'Tumult': '激震',
      'Weight Of The Land': '大地の重み'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bomb Boulder': '爆破岩石',
      'Titan': '泰坦'
    },
    'replaceText': {
      '\\(clock\\)': '(顺时针)',
      '\\(diamond\\)': '(钻石)',
      '\\(line\\)': '(直线)',
      'Burst': '爆炸',
      'Bury': '塌方',
      'Earthen Fury': '大地之怒',
      'Geocrush': '大地粉碎',
      'Landslide': '地裂',
      'Mountain Buster': '山崩',
      'Rock Buster': '碎岩',
      'Rock Throw': '花岗岩牢狱',
      'Tumult': '怒震',
      'Weight Of The Land': '大地之重'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bomb Boulder': '바위폭탄',
      'Titan': '타이탄'
    },
    'replaceText': {
      '\\(clock\\)': '(시계 방향)',
      '\\(diamond\\)': '(3방향)',
      '\\(line\\)': '(직선)',
      'Burst': '대폭발',
      'Bury': '충격',
      'Earthen Fury': '대지의 분노',
      'Geocrush': '대지 붕괴',
      'Landslide': '산사태',
      'Mountain Buster': '산 쪼개기',
      'Rock Buster': '바위 쪼개기',
      'Rock Throw': '화강암 감옥',
      'Tumult': '격진',
      'Weight Of The Land': '대지의 무게'
    }
  }]
};
/* harmony default export */ const titan_hm = (titan_hm_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/titan-hm.txt
const trial_titan_hm_namespaceObject = "# Titan Hard Mode\r\n# -p 555:203 41B:425.1 556:873.7\r\n# -ii 553\r\n\r\n# Note: You can solo this, but all the jails hit you with Granite Sepulchre\r\n# after some time.  This doesn't happen if you're not solo.  However,\r\n# Titan changes his rotation (skips landslides, last phase gets weird)\r\n# and so this timeline doesn't attempt to handle that.\r\n\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1: 100->90%\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n\r\n5.0 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" } window 5,50\r\n11.2 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n17.4 \"Tumult x2\" duration 1.2 #Ability { id: \"551\", source: \"Titan\" }\r\n\r\n23.7 \"Rock Buster\" #Ability { id: \"550\", source: \"Titan\" }\r\n29.9 \"Landslide\" #Ability { id: \"554\", source: \"Titan\" }\r\n36.1 \"Tumult x2\" duration 1.2 #Ability { id: \"551\", source: \"Titan\" }\r\n\r\n42.4 \"Rock Buster\" #Ability { id: \"550\", source: \"Titan\" }\r\n48.6 \"Landslide\" #Ability { id: \"554\", source: \"Titan\" }\r\n54.8 \"Tumult x2\" duration 1.2 #Ability { id: \"551\", source: \"Titan\" }\r\n\r\n\r\n# Phase 2: 90%->80%\r\n200.0 \"--sync--\" StartsUsing { id: \"555\", source: \"Titan\" } window 200,0\r\n203.0 \"Geocrush\" Ability { id: \"555\", source: \"Titan\" }\r\n\r\n211.4 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n217.6 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n221.8 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n229.9 \"Tumult x3\" duration 2.4 #Ability { id: \"551\", source: \"Titan\" }\r\n\r\n239.4 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" } window 40,40 jump 211.4\r\n245.6 \"Rock Buster\" #Ability { id: \"550\", source: \"Titan\" }\r\n249.8 \"Landslide\" #Ability { id: \"554\", source: \"Titan\" }\r\n257.9 \"Tumult x3\" duration 2.4 #Ability { id: \"551\", source: \"Titan\" }\r\n\r\n267.4 \"Weight Of The Land\" #Ability { id: \"552\", source: \"Titan\" }\r\n273.6 \"Rock Buster\" #Ability { id: \"550\", source: \"Titan\" }\r\n277.8 \"Landslide\" #Ability { id: \"554\", source: \"Titan\" }\r\n285.9 \"Tumult x3\" duration 2.4 #Ability { id: \"551\", source: \"Titan\" }\r\n\r\n\r\n# Phase 3: 80%->60%\r\n400.0 \"--sync--\" StartsUsing { id: \"555\", source: \"Titan\" } window 199,0\r\n403.0 \"Geocrush\" Ability { id: \"555\", source: \"Titan\" }\r\n411.9 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n420.0 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n\r\n425.1 \"Bury (clock)\" duration 4 #Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n429.9 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n434.3 \"Burst\" duration 4 #Ability { id: \"41C\", source: \"Bomb Boulder\" }\r\n\r\n439.5 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n445.6 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n449.7 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" }\r\n456.8 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n459.8 \"Tumult x3\" duration 2.4 #Ability { id: \"551\", source: \"Titan\" }\r\n469.5 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n477.6 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n\r\n482.7 \"Bury (diamond)\" duration 2 #Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n487.5 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n491.9 \"Burst\" duration 3 #Ability { id: \"41C\", source: \"Bomb Boulder\" }\r\n\r\n497.2 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n503.3 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n507.6 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" }\r\n514.8 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n517.8 \"Tumult x3\" duration 2.4 #Ability { id: \"551\", source: \"Titan\" }\r\n528.1 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n536.2 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" } window 30,30 jump 420\r\n\r\n541.3 \"Bury (clock)\" duration 4 #Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n546.1 \"Rock Buster\" #Ability { id: \"550\", source: \"Titan\" }\r\n550.5 \"Burst\" duration 4 #Ability { id: \"41C\", source: \"Bomb Boulder\" }\r\n\r\n555.7 \"Landslide\" #Ability { id: \"554\", source: \"Titan\" }\r\n561.8 \"Weight Of The Land\" #Ability { id: \"552\", source: \"Titan\" }\r\n565.9 \"Rock Throw\" #Ability { id: \"285\", source: \"Titan\" }\r\n573.0 \"Rock Buster\" #Ability { id: \"550\", source: \"Titan\" }\r\n576.0 \"Tumult x3\" duration 2.4 #Ability { id: \"551\", source: \"Titan\" }\r\n585.7 \"Landslide\" #Ability { id: \"554\", source: \"Titan\" }\r\n593.8 \"Weight Of The Land\" #Ability { id: \"552\", source: \"Titan\" }\r\n\r\n\r\n# Phase 4: Heart\r\n800.0 \"--sync--\" StartsUsing { id: \"555\", source: \"Titan\" } window 399,0\r\n803.0 \"Geocrush\" Ability { id: \"555\", source: \"Titan\" }\r\n805.3 \"--targetable--\"\r\n\r\n812.3 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" }\r\n816.4 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n820.6 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n828.7 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n\r\n834.8 \"Tumult x3\" duration 2.4 #Ability { id: \"551\", source: \"Titan\" }\r\n\r\n842.5 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" }\r\n846.6 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n850.8 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n858.9 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n\r\n868.2 \"--untargetable--\"\r\n\r\n\r\n# Phase 5: 60%->0%\r\n873.7 \"Earthen Fury\" Ability { id: \"556\", source: \"Titan\" } window 1000,30\r\n878.4 \"--targetable--\"\r\n882.5 \"Mountain Buster\" Ability { id: \"283\", source: \"Titan\" }\r\n886.6 \"Tumult x4\" duration 3.6 #Ability { id: \"551\", source: \"Titan\" }\r\n895.3 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n\r\n900.4 \"Bury (line)\" duration 2 #Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n908.4 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n909.4 \"Burst\" duration 3 #Ability { id: \"41C\", source: \"Bomb Boulder\" }\r\n\r\n912.6 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n916.6 \"Mountain Buster\" Ability { id: \"283\", source: \"Titan\" }\r\n922.7 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n927.2 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" }\r\n937.5 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n941.6 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n945.6 \"Mountain Buster\" Ability { id: \"283\", source: \"Titan\" }\r\n949.7 \"Tumult x4\" duration 3.6 #Ability { id: \"551\", source: \"Titan\" }\r\n958.4 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n\r\n963.5 \"Bury (clock)\" duration 4 #Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n972.0 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n972.7 \"Burst\" duration 4 #Ability { id: \"41C\", source: \"Bomb Boulder\" }\r\n\r\n976.2 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n980.2 \"Mountain Buster\" Ability { id: \"283\", source: \"Titan\" }\r\n986.3 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n990.9 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" }\r\n1001.1 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n1005.2 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n1009.2 \"Mountain Buster\" Ability { id: \"283\", source: \"Titan\" }\r\n1013.3 \"Tumult x4\" duration 3.6 #Ability { id: \"551\", source: \"Titan\" }\r\n1022.0 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n\r\n1027.1 \"Bury (line)\" duration 2 #Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n1035.4 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n1036.2 \"Burst\" duration 3 #Ability { id: \"41C\", source: \"Bomb Boulder\" }\r\n\r\n1039.6 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n1043.6 \"Mountain Buster\" Ability { id: \"283\", source: \"Titan\" }\r\n1049.7 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n1054.5 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" }\r\n1064.8 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n1068.9 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n1072.9 \"Mountain Buster\" Ability { id: \"283\", source: \"Titan\" }\r\n1077.0 \"Tumult x4\" duration 3.6 #Ability { id: \"551\", source: \"Titan\" }\r\n1085.7 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n\r\n1090.8 \"Bury (diamond)\" duration 2 #Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n1099.3 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n1100.0 \"Burst\" duration 3 #Ability { id: \"41C\", source: \"Bomb Boulder\" }\r\n\r\n1103.5 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n1107.5 \"Mountain Buster\" Ability { id: \"283\", source: \"Titan\" }\r\n1113.6 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" }\r\n1118.2 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" }\r\n1128.5 \"Landslide\" Ability { id: \"554\", source: \"Titan\" }\r\n1132.6 \"Rock Buster\" Ability { id: \"550\", source: \"Titan\" }\r\n1136.6 \"Mountain Buster\" Ability { id: \"283\", source: \"Titan\" }\r\n\r\n1140.7 \"Tumult x5\" duration 4.8 #Ability { id: \"551\", source: \"Titan\" }\r\n\r\n1150.6 \"Weight Of The Land\" Ability { id: \"552\", source: \"Titan\" } window 20,20 jump 895.3\r\n\r\n1155.7 \"Bury (line)\" #duration 2 #Ability { id: \"41B\", source: \"Bomb Boulder\" }\r\n1163.7 \"Landslide\" #Ability { id: \"554\", source: \"Titan\" }\r\n1164.7 \"Burst\" duration 3 #Ability { id: \"41C\", source: \"Bomb Boulder\" }\r\n\r\n1167.9 \"Rock Buster\" #Ability { id: \"550\", source: \"Titan\" }\r\n1171.9 \"Mountain Buster\" #Ability { id: \"283\", source: \"Titan\" }\r\n1178.0 \"Weight Of The Land\" #Ability { id: \"552\", source: \"Titan\" }\r\n1182.5 \"Rock Throw\" #Ability { id: \"285\", source: \"Titan\" }\r\n1192.8 \"Landslide\" #Ability { id: \"554\", source: \"Titan\" }\r\n1196.9 \"Rock Buster\" #Ability { id: \"550\", source: \"Titan\" }\r\n1200.9 \"Mountain Buster\" #Ability { id: \"283\", source: \"Titan\" }\r\n1205.0 \"Tumult x4\" duration 3.6 #Ability { id: \"551\", source: \"Titan\" }\r\n1213.7 \"Weight Of The Land\" #Ability { id: \"552\", source: \"Titan\" }\r\n\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/titan-nm.ts


const titan_nm_triggerSet = {
  id: 'TheNavel',
  zoneId: zone_id/* default.TheNavel */.Z.TheNavel,
  timelineFile: 'titan-nm.txt',
  timelineTriggers: [{
    // Early Callout for Tank Cleave
    id: 'TitanNm Rock Buster',
    regex: /Rock Buster/,
    beforeSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'TitanNm Tumult',
    type: 'Ability',
    netRegex: {
      id: '282',
      source: 'Titan',
      capture: false
    },
    suppressSeconds: 2,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Gaol callout for both yourself and others
    id: 'TitanNm Gaols',
    type: 'GainsEffect',
    netRegex: {
      effectId: '124'
    },
    alertText: (data, matches, output) => {
      if (matches.target !== data.me) return output.breakGaolOn({
        player: data.party.member(matches.target)
      });
      return output.gaolOnYou();
    },
    outputStrings: {
      breakGaolOn: {
        en: 'Break Gaol on ${player}',
        de: 'Zerstöre das Gefängnis von ${player}',
        fr: 'Brisez la geôle sur ${player}',
        ja: '${player}にジェイル',
        cn: '石牢点${player}',
        ko: '${player} 돌감옥 해제'
      },
      gaolOnYou: {
        en: 'Gaol on YOU',
        de: 'Gefängnis auf DIR',
        fr: 'Geôle sur VOUS',
        ja: '自分にジェイル',
        cn: '石牢点名',
        ko: '돌감옥 대상자'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Earthen Fury': 'Gaias Zorn',
      'Titan': 'Titan'
    },
    'replaceText': {
      'Earthen Fury': 'Gaias Zorn',
      'Geocrush': 'Geo-Stoß',
      'Landslide': 'Bergsturz',
      'Rock Buster': 'Steinsprenger',
      'Rock Throw': 'Granitgefängnis',
      'Tumult': 'Urerschütterung',
      'Weight Of The Land': 'Gaias Gewicht'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Earthen Fury': 'Fureur tellurique',
      'Titan': 'Titan'
    },
    'replaceText': {
      'Earthen Fury': 'Fureur tellurique',
      'Geocrush': 'Broie-terre',
      'Landslide': 'Glissement de terrain',
      'Rock Buster': 'Casse-roc',
      'Rock Throw': 'Jeté de rocs',
      'Tumult': 'Tumulte',
      'Weight Of The Land': 'Poids de la terre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Earthen Fury': '大地の怒り',
      'Titan': 'タイタン'
    },
    'replaceText': {
      'Earthen Fury': '大地の怒り',
      'Geocrush': 'ジオクラッシュ',
      'Landslide': 'ランドスライド',
      'Rock Buster': 'ロックバスター',
      'Rock Throw': 'グラナイト・ジェイル',
      'Tumult': '激震',
      'Weight Of The Land': '大地の重み'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Earthen Fury': '大地之怒',
      'Titan': '泰坦'
    },
    'replaceText': {
      'Earthen Fury': '大地之怒',
      'Geocrush': '大地粉碎',
      'Landslide': '地裂',
      'Rock Buster': '碎岩',
      'Rock Throw': '花岗岩牢狱',
      'Tumult': '怒震',
      'Weight Of The Land': '大地之重'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Earthen Fury': '대지의 분노',
      'Titan': '타이탄'
    },
    'replaceText': {
      'Earthen Fury': '대지의 분노',
      'Geocrush': '대지 붕괴',
      'Landslide': '산사태',
      'Rock Buster': '바위 쪼개기',
      'Rock Throw': '화강암 감옥',
      'Tumult': '격진',
      'Weight Of The Land': '대지의 무게'
    }
  }]
};
/* harmony default export */ const titan_nm = (titan_nm_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/titan-nm.txt
const trial_titan_nm_namespaceObject = "### Titan Story / Normal\r\n# -ii 5C5 3CD -p 28B:203.0  28C:601.1\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1 100 -> 85%\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n5.0 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" } window 5,5\r\n7.0 \"Tumult\" Ability { id: \"282\", source: \"Titan\" }\r\n16.1 \"Tumult\" Ability { id: \"282\", source: \"Titan\" }\r\n19.2 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" }\r\n25.2 \"Tumult\" Ability { id: \"282\", source: \"Titan\" } window 8,8\r\n\r\n32.3 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" }\r\n34.3 \"Tumult\" Ability { id: \"282\", source: \"Titan\" }\r\n43.4 \"Tumult\" Ability { id: \"282\", source: \"Titan\" }\r\n46.5 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" }\r\n52.5 \"Tumult\" Ability { id: \"282\", source: \"Titan\" } window 8,8 jump 25.2\r\n\r\n59.6 \"Rock Buster\"\r\n61.6 \"Tumult\"\r\n70.7 \"Tumult\"\r\n73.8 \"Rock Buster\"\r\n79.8 \"Tumult\"\r\n\r\n### Phase 2 85 -> 55%\r\n200.0 \"--sync--\" StartsUsing { id: \"28B\", source: \"Titan\" } window 200,0\r\n203.0 \"Geocrush\" Ability { id: \"28B\", source: \"Titan\" }\r\n\r\n211.6 \"Landslide\" Ability { id: \"28A\", source: \"Titan\" } window 211,17\r\n217.8 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" }\r\n221.8 \"Tumult\" Ability { id: \"282\", source: \"Titan\" }\r\n229.1 \"Landslide\" Ability { id: \"28A\", source: \"Titan\" }\r\n235.3 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" }\r\n239.3 \"Tumult\" Ability { id: \"282\", source: \"Titan\" } window 17,16\r\n\r\n246.6 \"Landslide\" Ability { id: \"28A\", source: \"Titan\" }\r\n252.8 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" }\r\n256.8 \"Tumult\" Ability { id: \"282\", source: \"Titan\" } window 15,17\r\n264.1 \"Landslide\" Ability { id: \"28A\", source: \"Titan\" }\r\n270.2 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" }\r\n274.2 \"Tumult\" Ability { id: \"282\", source: \"Titan\" } window 17,16 jump 239.3\r\n\r\n### including syncs until a decision is made to keep or remove them. Potential FIX ME!\r\n281.6 \"Landslide\" Ability { id: \"28A\", source: \"Titan\" }\r\n287.8 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" }\r\n291.8 \"Tumult\" Ability { id: \"282\", source: \"Titan\" } window 15,17\r\n299.1 \"Landslide\" Ability { id: \"28A\", source: \"Titan\" }\r\n305.2 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" }\r\n309.2 \"Tumult\" Ability { id: \"282\", source: \"Titan\" }\r\n\r\n### Phase 3 Heart Phase (55%)\r\n400.0 \"--sync--\" StartsUsing { id: \"28B\", source: \"Titan\" } window 196,0\r\n403.0 \"Geocrush\" Ability { id: \"28B\", source: \"Titan\" }\r\n413.6 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" }\r\n421.5 \"Landslide\" Ability { id: \"28A\", source: \"Titan\" }\r\n427.6 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" } window 20,15\r\n431.6 \"Tumult\" Ability { id: \"282\", source: \"Titan\" }\r\n435.1 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" }\r\n442.9 \"Landslide\" Ability { id: \"28A\", source: \"Titan\" }\r\n449.1 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" }\r\n453.1 \"Tumult\" Ability { id: \"282\", source: \"Titan\" } window 16,25\r\n464.6 \"Landslide\" Ability { id: \"28A\", source: \"Titan\" }\r\n473.6 \"Enrage\"\r\n\r\n### Phase 4 55 -> 0%\r\n600.0 \"--sync--\" StartsUsing { id: \"28C\", source: \"Earthen Fury\" } window 600,0\r\n601.1 \"Earthen Fury\" Ability { id: \"28C\", source: \"Titan\" }\r\n\r\n614.1 \"Landslide\" Ability { id: \"28A\", source: \"Titan\" }\r\n620.2 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" }\r\n624.2 \"Weight Of The Land\" Ability { id: \"284\", source: \"Titan\" } window 626,23\r\n630.3 \"Tumult x2\" duration 2.5 #Ability { id: \"282\", source: \"Titan\" }\r\n636.5 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" }\r\n643.6 \"Landslide\" Ability { id: \"28A\", source: \"Titan\" }\r\n649.7 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" }\r\n653.7 \"Weight Of The Land\" Ability { id: \"284\", source: \"Titan\" } window 23,26\r\n659.8 \"Tumult x2\" duration 2.5 #Ability { id: \"282\", source: \"Titan\" }\r\n667.0 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" }\r\n\r\n674.1 \"Landslide\" Ability { id: \"28A\", source: \"Titan\" }\r\n680.2 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" }\r\n684.2 \"Weight Of The Land\" Ability { id: \"284\", source: \"Titan\" } window 26,24\r\n690.3 \"Tumult x2\" duration 2.5 #Ability { id: \"282\", source: \"Titan\" }\r\n696.5 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" }\r\n703.6 \"Landslide\" Ability { id: \"28A\", source: \"Titan\" }\r\n709.7 \"Rock Buster\" Ability { id: \"281\", source: \"Titan\" }\r\n713.7 \"Weight Of The Land\" Ability { id: \"284\", source: \"Titan\" }\r\n719.8 \"Tumult x2\" duration 2.5 #Ability { id: \"282\", source: \"Titan\" } window 28,23\r\n727.0 \"Rock Throw\" Ability { id: \"285\", source: \"Titan\" } window 29,28 jump 667\r\n\r\n734.1 \"Landslide\"\r\n740.2 \"Rock Buster\"\r\n744.2 \"Weight Of The Land\"\r\n750.3 \"Tumult x2\"\r\n756.5 \"Rock Throw\"\r\n763.6 \"Landslide\"\r\n769.7 \"Rock Buster\"\r\n773.7 \"Weight Of The Land\"\r\n779.8 \"Tumult x2\"\r\n787.0 \"Rock Throw\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/ultima-ex.ts



const ultima_ex_triggerSet = {
  id: 'TheMinstrelsBalladUltimasBane',
  zoneId: zone_id/* default.TheMinstrelsBalladUltimasBane */.Z.TheMinstrelsBalladUltimasBane,
  timelineFile: 'ultima-ex.txt',
  initData: () => {
    return {
      plasmTargets: [],
      boomCounter: 1
    };
  },
  timelineTriggers: [{
    id: 'Ultima EX Homing Lasers',
    regex: /Homing Lasers/,
    beforeSeconds: 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread--Homing Lasers',
        de: 'Verteilen--Leitlaser',
        fr: 'Écartez-vous - Lasers guidés',
        cn: '分散--追踪激光',
        ko: '산개--유도 레이저'
      }
    }
  }, {
    id: 'Ultima EX Diffractive Laser',
    regex: /Diffractive Laser/,
    beforeSeconds: 4,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Ultima EX Vulcan Burst',
    regex: /Vulcan Burst/,
    beforeSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Melee knockback',
        de: 'Melee Rückstoß',
        fr: 'Poussée',
        cn: '近战击退',
        ko: '근접 넉백'
      }
    }
  }],
  triggers: [{
    id: 'Ultima EX Tank Purge',
    type: 'StartsUsing',
    netRegex: {
      id: '5EA',
      source: 'The Ultima Weapon',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    // At 5 stacks of Viscous Aetheroplasm, the target begins taking massive damage.
    id: 'Ultima EX Viscous Aetheroplasm',
    type: 'GainsEffect',
    netRegex: {
      effectId: '171',
      count: '04',
      capture: false
    },
    condition: data => data.role === 'tank' || data.job === 'BLU',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.tankSwap */.Z.tankSwap
    }
  }, {
    id: 'Ultima EX Homing Aetheroplasm Collect',
    type: 'Ability',
    netRegex: {
      id: '672'
    },
    run: (data, matches) => {
      data.plasmTargets = data.plasmTargets ??= [];
      data.plasmTargets.push(matches.target);
    }
  }, {
    // This ability is ARR 2.0's version of headmarkers. No associated 27 lines are present.
    // These lines are sent by entities with no name and no 03/04 lines.
    id: 'Ultima EX Homing Aetheroplasm Call',
    type: 'Ability',
    netRegex: {
      id: '672',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (data.plasmTargets?.includes(data.me)) return output.target();
      return output.avoid();
    },
    outputStrings: {
      target: {
        en: 'Homing Aetheroplasm on YOU',
        de: 'Verfolgendes Ätheroplasma auf DIR',
        fr: 'Laser + Éthéroplasma sur VOUS',
        cn: '追踪激光点名',
        ko: '에테르 폭뢰 대상자'
      },
      avoid: {
        en: 'Avoid Homing Aetheroplasm',
        de: 'Weiche dem verfolgendem Ätheroplasma aus',
        fr: 'Évitez le laser + l\'Éthéroplasma',
        cn: '躲避追踪激光',
        ko: '에테르 폭뢰 피하기'
      }
    }
  }, {
    id: 'Ultima EX Homing Aetheroplasm Cleanup',
    type: 'Ability',
    netRegex: {
      id: '672',
      capture: false
    },
    delaySeconds: 5,
    suppressSeconds: 5,
    run: data => delete data.plasmTargets
  }, {
    // We use a StartsUsing line here because we can't use timeline triggers for this,
    // and we want to warn players as early as possible.
    id: 'Ultima EX Aetheric Boom Orbs',
    type: 'StartsUsing',
    netRegex: {
      id: '5E7',
      source: 'The Ultima Weapon',
      capture: false
    },
    alarmText: (data, _matches, output) => output[`boom${data.boomCounter}`](),
    run: data => data.boomCounter += 1,
    outputStrings: {
      boom1: {
        en: 'Orbs: Cardinals',
        de: 'Orbs: Kardinal',
        fr: 'Orbes : Cardinaux',
        cn: '球: 十字',
        ko: '구슬: 십자'
      },
      boom2: {
        en: 'Orbs: Cardinals (N/S first)',
        de: 'Orbs: Kardinal (N/S zuerst)',
        fr: 'Orbes : Cardinaux (N/S en premier)',
        cn: '球: 十字（先南/北）',
        ko: '구슬: 십자(남/북 먼저)'
      },
      boom3: {
        en: 'Orbs: Intercardinals',
        de: 'Orbs: Interkardinal',
        fr: 'Orbes : Intercardinaux',
        cn: '球: 方形',
        ko: '구슬: 사각형'
      }
    }
  }, {
    id: 'Ultima EX Aetheric Boom Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '5E7',
      source: 'The Ultima Weapon',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'The Ultima Weapon': 'Ultima-Waffe',
      'Ultima Garuda': 'Ultima-Garuda',
      'Ultima Ifrit': 'Ultima-Ifrit',
      'Ultima Titan': 'Ultima-Titan'
    },
    'replaceText': {
      'Aetheric Boom': 'Ätherknall',
      'Ceruleum Vent': 'Erdseim-Entlüfter',
      'Crimson Cyclone': 'Zinnober-Zyklon',
      'Diffractive Laser': 'Diffraktiver Laser',
      'Eruption': 'Eruption',
      'Eye of the Storm': 'Auge des Sturms',
      'Geocrush': 'Geo-Stoß',
      'Homing Lasers': 'Leitlaser',
      'Magitek Ray': 'Magitek-Laser',
      'Mistral Song': 'Mistral-Song',
      'Radiant Plume': 'Scheiterhaufen',
      'Tank Purge': 'Tankreinigung',
      'Ultima': 'Ultima',
      'Viscous Aetheroplasm': 'Viskoses Ätheroplasma',
      'Vulcan Burst': 'Feuerstoß',
      'Weight of the Land': 'Gaias Gewicht'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'The Ultima Weapon': 'Ultima Arma',
      'Ultima Garuda': 'Ultima-Garuda',
      'Ultima Ifrit': 'Ultima-Ifrit',
      'Ultima Titan': 'Ultima-Titan'
    },
    'replaceText': {
      'Aetheric Boom': 'Onde d\'éther',
      'Ceruleum Vent': 'Exutoire à céruleum',
      'Crimson Cyclone': 'Cyclone écarlate',
      'Diffractive Laser': 'Laser diffractif',
      'Eruption': 'Éruption',
      'Eye of the Storm': 'Œil du cyclone',
      'Geocrush': 'Broie-terre',
      'Homing Lasers': 'Lasers autoguidés',
      'Magitek Ray': 'Rayon magitek',
      'Mistral Song': 'Chant du mistral',
      'Radiant Plume': 'Panache radiant',
      'Tank Purge': 'Vidange de réservoir',
      'Ultima': 'Ultima',
      'Viscous Aetheroplasm': 'Éthéroplasma poisseux',
      'Vulcan Burst': 'Explosion volcanique',
      'Weight of the Land': 'Poids de la terre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'The Ultima Weapon': 'アルテマウェポン',
      'Ultima Garuda': 'アルテマ・ガルーダ',
      'Ultima Ifrit': 'アルテマ・イフリート',
      'Ultima Titan': 'アルテマ・タイタン'
    },
    'replaceText': {
      'Aetheric Boom': 'エーテル波動',
      'Ceruleum Vent': 'セルレアムベント',
      'Crimson Cyclone': 'クリムゾンサイクロン',
      'Diffractive Laser': '拡散レーザー',
      'Eruption': 'エラプション',
      'Eye of the Storm': 'アイ・オブ・ストーム',
      'Geocrush': 'ジオクラッシュ',
      'Homing Lasers': '誘導レーザー',
      'Magitek Ray': '魔導レーザー',
      'Mistral Song': 'ミストラルソング',
      'Radiant Plume': '光輝の炎柱',
      'Tank Purge': '魔導フレア',
      'Ultima': 'アルテマ',
      'Viscous Aetheroplasm': '吸着式エーテル爆雷',
      'Vulcan Burst': 'バルカンバースト',
      'Weight of the Land': '大地の重み'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'The Ultima Weapon': '究极神兵',
      'Ultima Garuda': '究极迦楼罗',
      'Ultima Ifrit': '究极伊弗利特',
      'Ultima Titan': '究极泰坦'
    },
    'replaceText': {
      'Aetheric Boom': '以太波动',
      'Ceruleum Vent': '青磷放射',
      'Crimson Cyclone': '深红旋风',
      'Diffractive Laser': '扩散射线',
      'Eruption': '地火喷发',
      'Eye of the Storm': '台风眼',
      'Geocrush': '大地粉碎',
      'Homing Lasers': '诱导射线',
      'Magitek Ray': '魔导激光',
      'Mistral Song': '寒风之歌',
      'Radiant Plume': '光辉炎柱',
      'Tank Purge': '魔导核爆',
      'Ultima': '究极',
      'Viscous Aetheroplasm': '吸附式以太炸弹',
      'Vulcan Burst': '火神爆裂',
      'Weight of the Land': '大地之重'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'The Ultima Weapon': '알테마 웨폰',
      'Ultima Garuda': '알테마 가루다',
      'Ultima Ifrit': '알테마 이프리트',
      'Ultima Titan': '알테마 타이탄'
    },
    'replaceText': {
      'Aetheric Boom': '에테르 파동',
      'Ceruleum Vent': '청린 방출',
      'Crimson Cyclone': '진홍 회오리',
      'Diffractive Laser': '확산 레이저',
      'Eruption': '용암 분출',
      'Eye of the Storm': '태풍의 눈',
      'Geocrush': '대지 붕괴',
      'Homing Lasers': '유도 레이저',
      'Magitek Ray': '마도 레이저',
      'Mistral Song': '삭풍의 노래',
      'Radiant Plume': '광휘의 불기둥',
      'Tank Purge': '마도 플레어',
      'Ultima': '알테마',
      'Viscous Aetheroplasm': '흡착식 에테르 폭뢰',
      'Vulcan Burst': '폭렬 난사',
      'Weight of the Land': '대지의 무게'
    }
  }]
};
/* harmony default export */ const ultima_ex = (ultima_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/02-arr/trial/ultima-ex.txt
const trial_ultima_ex_namespaceObject = "### The Minstrel's Ballad: Ultima's Bane\r\n# -ii 5E8 5E9 5F6 60A\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n\r\n# Phase 1: 100% - 85%\r\n3.2 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" } window 3.2,10\r\n15.1 \"Vulcan Burst\" Ability { id: \"5EE\", source: \"The Ultima Weapon\" }\r\n16.6 \"Mistral Song\" Ability { id: \"5ED\", source: \"Ultima Garuda\" }\r\n26.4 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n29.7 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n33.0 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" } window 10,10\r\n41.3 \"Eye of the Storm\" Ability { id: \"5EF\", source: \"The Ultima Weapon\" }\r\n43.9 \"Geocrush\" Ability { id: \"5F0\", source: \"Ultima Titan\" }\r\n48.4 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n51.7 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n\r\n55.0 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" } window 10,10 jump 3.2\r\n66.9 \"Vulcan Burst\"\r\n68.4 \"Mistral Song\"\r\n78.2 \"Homing Lasers\"\r\n81.5 \"Ceruleum Vent\"\r\n84.8 \"Viscous Aetheroplasm\"\r\n\r\n\r\n# Phase 2: 84.9% - 65%\r\n# The animation for Garuda dying precedes this,\r\n# but there are no log lines that show for her death.\r\n98.3 \"--sync--\" StartsUsing { id: \"5F1\", source: \"The Ultima Weapon\" } window 98.3,5\r\n100.0 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n103.0 \"Weight of the Land\" Ability { id: \"5F2\", source: \"The Ultima Weapon\" }\r\n107.1 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n\r\n115.9 \"Tank Purge\" Ability { id: \"5EA\", source: \"The Ultima Weapon\" } window 30,30\r\n119.3 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n125.6 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n129.6 \"Weight of the Land\" Ability { id: \"5F2\", source: \"The Ultima Weapon\" }\r\n130.7 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n134.0 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n141.3 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n148.6 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n151.6 \"Weight of the Land\" Ability { id: \"5F2\", source: \"The Ultima Weapon\" }\r\n152.7 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n156.0 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n\r\n164.8 \"Tank Purge\" Ability { id: \"5EA\", source: \"The Ultima Weapon\" } window 30,30\r\n168.2 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n175.5 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n179.5 \"Weight of the Land\" Ability { id: \"5F2\", source: \"The Ultima Weapon\" }\r\n179.6 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n182.9 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n190.3 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n195.7 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n198.6 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n201.6 \"Weight of the Land\" Ability { id: \"5F2\", source: \"The Ultima Weapon\" }\r\n203.7 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n\r\n212.5 \"Tank Purge\" Ability { id: \"5EA\", source: \"The Ultima Weapon\" } window 30,30 jump 164.8\r\n215.9 \"Homing Lasers\"\r\n223.2 \"Radiant Plume\"\r\n227.2 \"Weight of the Land\"\r\n227.3 \"Ceruleum Vent\"\r\n230.6 \"Viscous Aetheroplasm\"\r\n\r\n\r\n# Phase 3: 64.9% -50%\r\n# As in phase 2, Titan's death animation comes first with no indicator.\r\n# The phase opens with what seems to be a *long* set of fixed blocks.\r\n# A Viscous Aetheroplasm may or may not be skipped.\r\n\r\n297.3 \"--sync--\" StartsUsing { id: \"5F4\", source: \"The Ultima Weapon\" } window 297.3,0\r\n300.0 \"Eruption x5\" duration 8 #Ability { id: \"5F4\", source: \"The Ultima Weapon\" }\r\n306.6 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n315.3 \"Tank Purge\" Ability { id: \"5EA\", source: \"The Ultima Weapon\" } window 15,15\r\n318.6 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n323.9 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n327.2 \"Viscous Aetheroplasm?\" #Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n332.4 \"--sync--\" StartsUsing { id: \"5F1\", source: \"The Ultima Weapon\" } window 10,2.5\r\n335.1 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n337.9 \"Crimson Cyclone\" Ability { id: \"5F5\", source: \"Ultima Ifrit\" }\r\n339.2 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n343.2 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n345.4 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" } window 15,15\r\n345.9 \"Crimson Cyclone\" Ability { id: \"5F5\", source: \"Ultima Ifrit\" }\r\n347.1 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n352.7 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n\r\n360.6 \"Eruption x5\" duration 8 #Ability { id: \"5F4\", source: \"The Ultima Weapon\" }\r\n365.1 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n368.5 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n377.2 \"Tank Purge\" Ability { id: \"5EA\", source: \"The Ultima Weapon\" } window 15,15\r\n380.6 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n\r\n# A possible extra block is here, but it doesn't seem to change the rotation.\r\n# Ceruleum Vent jumps to a small sidetrack before continuing.\r\n385.2 \"--sync--\" StartsUsing { id: \"5F1\", source: \"The Ultima Weapon\" } window 15,15 jump 547.3 # Radiant Plume\r\n385.9 \"Ceruleum Vent?\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" } window 15,15 jump 450\r\n387.9 \"Radiant Plume?\"\r\n389.2 \"Viscous Aetheroplasm?\"\r\n390.7 \"Crimson Cyclone?\"\r\n392.0 \"Radiant Plume?\"\r\n396.0 \"Radiant Plume?\"\r\n396.5 \"Homing Lasers?\"\r\n\r\n# Vent sidetrack into normal early Eruption block\r\n450.0 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n453.3 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n460.6 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n466.0 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n\r\n# Normal early Eruption block\r\n466.5 \"--sync--\" StartsUsing { id: \"5F4\", source: \"The Ultima Weapon\" } window 30,1\r\n469.2 \"Eruption x5\" duration 8 #Ability { id: \"5F4\", source: \"The Ultima Weapon\" }\r\n475.0 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n483.8 \"Tank Purge\" Ability { id: \"5EA\", source: \"The Ultima Weapon\" } window 15,15\r\n487.1 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n492.5 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n\r\n# Eruption and Cyclone blocks will alternate from here.\r\n# *However*, at any time, a Viscous Aetheroplasm bridge may follow.\r\n# Subesquent blocks are different, ending with an Aetheroplasm rather than a Vent.\r\n\r\n492.7 \"--sync--\" StartsUsing { id: \"5F1\", source: \"The Ultima Weapon\" } window 20,20 jump 547.3 # Radiant Plume\r\n495.4 \"Radiant Plume?\"\r\n495.8 \"Viscous Aetheroplasm?\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" } window 15,15 jump 650\r\n498.2 \"Crimson Cyclone?\"\r\n499.5 \"Radiant Plume\"\r\n503.1 \"Homing Lasers?\"\r\n503.5 \"Radiant Plume?\"\r\n506.3 \"Crimson Cyclone?\"\r\n\r\n# Normal early Cyclone block\r\n# Ceruleum Vent doesn't always happen during these Cyclone blocks.\r\n# However, timings don't seem dependent on its use,\r\n# so we can safely just not sync it and leave the block alone.\r\n547.3 \"--sync--\" StartsUsing { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n550.0 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n552.8 \"Crimson Cyclone\" Ability { id: \"5F5\", source: \"Ultima Ifrit\" }\r\n554.1 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n558.1 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n560.9 \"Crimson Cyclone\" Ability { id: \"5F5\", source: \"Ultima Ifrit\" }\r\n561.1 \"Ceruleum Vent?\" #Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n562.1 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n564.4 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n571.7 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n577.1 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n\r\n# Jump to the Aetheroplasm bridge or the early Eruption block\r\n577.4 \"--sync--\" StartsUsing { id: \"5F4\", source: \"The Ultima Weapon\" } window 20,20 jump 466.5\r\n580.1 \"Eruption x5?\"\r\n580.4 \"Viscous Aetheroplasm?\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" } window 5,5 jump 650\r\n585.9 \"Viscous Aetheroplasm?\"\r\n587.7 \"Homing Lasers?\"\r\n593.0 \"Ceruleum Vent?\"\r\n594.7 \"Tank Purge\"\r\n\r\n# An Aetheroplasm immediately following a Vent seems to indicate the start of the late rotation.\r\n# If this block follows an Eruption block, Tank Purge is skipped.\r\n# If this block follows a Cyclone block, Aetheroplasm is skipped\r\n650.0 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n658.7 \"Tank Purge?\" #Ability { id: \"5EA\", source: \"The Ultima Weapon\" }\r\n662.0 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" } window 12,5\r\n667.3 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n\r\n# From here, the late Cyclone/EruptionHoming Lasers blocks are added.\r\n669.9 \"--sync--\" StartsUsing { id: \"5F1\", source: \"The Ultima Weapon\" } window 15,15 jump 697.3 # Radiant Plume\r\n670.7 \"Viscous Aetheroplasm?\" #Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n671.0 \"--sync--\" StartsUsing { id: \"5F4\", source: \"The Ultima Weapon\" } window 15,15 jump 797.3 # Eruption\r\n672.6 \"Radiant Plume?\"\r\n673.7 \"Eruption x5?\"\r\n675.4 \"Crimson Cyclone?\"\r\n676.7 \"Radiant Plume?\"\r\n678.0 \"Homing Lasers?\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" } window 10,10 jump 900\r\n680.7 \"Radiant Plume?\"\r\n684.3 \"Tank Purge?\"\r\n\r\n# Late Cyclone block\r\n697.3 \"--sync--\" StartsUsing { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n700.0 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n702.8 \"Crimson Cyclone\" Ability { id: \"5F5\", source: \"Ultima Ifrit\" }\r\n704.1 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n708.1 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n710.9 \"Crimson Cyclone\" Ability { id: \"5F5\", source: \"Ultima Ifrit\" }\r\n712.1 \"Radiant Plume\" Ability { id: \"5F1\", source: \"The Ultima Weapon\" }\r\n716.1 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" } window 12,5\r\n721.4 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n724.7 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n\r\n727.3 \"--sync--\" StartsUsing { id: \"5F4\", source: \"The Ultima Weapon\" } window 15,15 jump 797.3 # Eruption\r\n730.0 \"Eruption x5?\"\r\n732.0 \"Homing Lasers?\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" } window 10,10 jump 900\r\n737.3 \"Ceruleum Vent?\"\r\n740.6 \"Viscous Aetheroplasm?\"\r\n740.6 \"Tank Purge?\"\r\n743.9 \"Homing Lasers?\"\r\n\r\n# Late Eruption block\r\n797.3 \"--sync--\" StartsUsing { id: \"5F4\", source: \"The Ultima Weapon\" } window 2.5,0\r\n800.0 \"Eruption x5\" duration 8 #Ability { id: \"5F4\", source: \"The Ultima Weapon\" }\r\n810.6 \"Tank Purge\" Ability { id: \"5EA\", source: \"The Ultima Weapon\" } window 15,15\r\n813.9 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n819.2 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n822.5 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n\r\n825.1 \"--sync--\" StartsUsing { id: \"5F1\", source: \"The Ultima Weapon\" } window 15,15 jump 697.3 # Radiant Plume\r\n827.8 \"Radiant Plume?\"\r\n829.8 \"Homing Lasers?\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" } window 10,10 jump 900\r\n830.6 \"Crimson Cyclone?\"\r\n831.9 \"Radiant Plume?\"\r\n835.1 \"Ceruleum Vent?\"\r\n835.9 \"Radiant Plume?\"\r\n838.4 \"Viscous Aetheroplasm?\"\r\n\r\n# Late Homing Lasers sidetrack\r\n900.0 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n905.3 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n908.6 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n\r\n912.3 \"--sync--\" StartsUsing { id: \"5F4\", source: \"The Ultima Weapon\" } window 15,15 jump 797.3 # Eruption\r\n913.2 \"--sync--\" StartsUsing { id: \"5F1\", source: \"The Ultima Weapon\" } window 15,15 jump 697.3 # Radiant Plume\r\n915.0 \"Eruption x5?\"\r\n915.9 \"Radiant Plume?\"\r\n918.7 \"Crimson Cyclone?\"\r\n920.0 \"Radiant Plume?\"\r\n924.0 \"Radiant Plume?\"\r\n924.1 \"Tank Purge?\"\r\n927.4 \"Homing Lasers?\"\r\n\r\n\r\n# Phase 4 -- 49.9% - 0%\r\n# Phase 4 seems to have a single rotation block.\r\n# Aetheric Boom and Freefire events happen at HP thresholds,\r\n# but they do not appear to change ability usage,\r\n# they just delay whatever ability was queued up next.\r\n# Because of this, we add many more sync windows than we normally would.\r\n\r\n# The opening block is short.\r\n1000.0 \"Aetheric Boom\" Ability { id: \"5E7\", source: \"The Ultima Weapon\" } window 1000,5\r\n1011.3 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n1015.6 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n1019.9 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n1023.1 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n1034.1 \"Magitek Ray 1\" Ability { id: [\"5E3\", \"5E4\", \"5E5\"], source: \"The Ultima Weapon\" }\r\n1037.1 \"Magitek Ray 2\" Ability { id: [\"5E3\", \"5E4\", \"5E5\"], source: \"The Ultima Weapon\" }\r\n1040.1 \"Magitek Ray 3\" Ability { id: [\"5E3\", \"5E4\", \"5E5\"], source: \"The Ultima Weapon\" }\r\n\r\n1042.7 \"--sync--\" StartsUsing { id: \"5EA\", source: \"The Ultima Weapon\" } window 45,45\r\n1045.9 \"Tank Purge\" Ability { id: \"5EA\", source: \"The Ultima Weapon\" }\r\n1049.2 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n1052.5 \"Diffractive Laser\" Ability { id: \"5E2\", source: \"The Ultima Weapon\" } window 20,20\r\n1054.8 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" } window 20,20\r\n1059.1 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n1062.4 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n1070.5 \"Magitek Ray 1\" Ability { id: [\"5E3\", \"5E4\", \"5E5\"], source: \"The Ultima Weapon\" } window 15,1\r\n1073.5 \"Magitek Ray 2\" Ability { id: [\"5E3\", \"5E4\", \"5E5\"], source: \"The Ultima Weapon\" }\r\n1076.5 \"Magitek Ray 3\" Ability { id: [\"5E3\", \"5E4\", \"5E5\"], source: \"The Ultima Weapon\" }\r\n1080.8 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n1084.1 \"Diffractive Laser\" Ability { id: \"5E2\", source: \"The Ultima Weapon\" } window 10,20\r\n1086.4 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" } window 10,20\r\n1090.7 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n1094.0 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n1105.1 \"Magitek Ray 1\" Ability { id: [\"5E3\", \"5E4\", \"5E5\"], source: \"The Ultima Weapon\" } window 15,1\r\n1108.1 \"Magitek Ray 2\" Ability { id: [\"5E3\", \"5E4\", \"5E5\"], source: \"The Ultima Weapon\" }\r\n1111.0 \"Magitek Ray 3\" Ability { id: [\"5E3\", \"5E4\", \"5E5\"], source: \"The Ultima Weapon\" }\r\n\r\n1113.6 \"--sync--\" StartsUsing { id: \"5EA\", source: \"The Ultima Weapon\" } window 45,45 jump 1042.7\r\n1116.8 \"Tank Purge\" Ability { id: \"5EA\", source: \"The Ultima Weapon\" }\r\n1120.2 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n1123.5 \"Diffractive Laser\" Ability { id: \"5E2\", source: \"The Ultima Weapon\" }\r\n1125.8 \"Homing Lasers\" Ability { id: \"5E1\", source: \"The Ultima Weapon\" }\r\n1130.1 \"Ceruleum Vent\" Ability { id: \"5E0\", source: \"The Ultima Weapon\" }\r\n1133.4 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n1141.5 \"Magitek Ray 1\" Ability { id: [\"5E3\", \"5E4\", \"5E5\"], source: \"The Ultima Weapon\" }\r\n1144.5 \"Magitek Ray 2\" Ability { id: [\"5E3\", \"5E4\", \"5E5\"], source: \"The Ultima Weapon\" }\r\n1147.5 \"Magitek Ray 3\" Ability { id: [\"5E3\", \"5E4\", \"5E5\"], source: \"The Ultima Weapon\" }\r\n1151.8 \"Viscous Aetheroplasm\" Ability { id: \"5DF\", source: \"The Ultima Weapon\" }\r\n\r\n\r\n\r\n# Enrage appears to be at 10:30.\r\n# Ultima Weapon teleports to the center and casts Ultima.\r\n9989.3 \"--sync--\" StartsUsing { id: \"5EC\", source: \"The Ultima Weapon\" } window 10000,0\r\n10000.0 \"Ultima Enrage\" Ability { id: \"5EC\", source: \"The Ultima Weapon\" }\r\n\r\n\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/alliance/dun_scaith.ts



const dun_scaith_triggerSet = {
  id: 'DunScaith',
  zoneId: zone_id/* default.DunScaith */.Z.DunScaith,
  timelineFile: 'dun_scaith.txt',
  timelineTriggers: [{
    id: 'Dun Scaith Spike Of Darkness',
    regex: /Spike Of Darkness/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }],
  triggers: [
  // Basic stack occurs across all encounters except Deathgaze.
  {
    id: 'Dun Scaith Generic Stack-up',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  },
  // DEATHGAZE
  {
    id: 'Dun Scaith Void Death Circle',
    type: 'StartsUsing',
    netRegex: {
      id: ['1C7F', '1C90'],
      source: 'Deathgaze Hollow',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out of death circle',
        de: 'Raus aus den Todeskreisen',
        fr: 'Sortez du cercle de mort',
        ja: 'ヴォイド・デス、外へ',
        cn: '离开圈内并扯断连线',
        ko: '데스 장판 빠져나오기'
      }
    }
  }, {
    // Currently set up to just notify the healers/Bard to cleanse.
    // Or use / 16:\y{ObjectId}:Deathgaze Hollow:1C85:Doomsay:\y{ObjectId}:(\y{Name})
    // This would allow for notifying who needs cleansing directly, but might be spammy
    id: 'Dun Scaith Doom',
    type: 'StartsUsing',
    netRegex: {
      id: ['1C84', '1C85'],
      source: 'Deathgaze Hollow',
      capture: false
    },
    condition: data => data.CanCleanse(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse Doom soon!',
        de: 'Verhängnis bald reinigen!',
        fr: 'Dissipez le Glas bientôt !',
        ja: '死の宣告、エスナ！',
        cn: '尽快驱散死亡宣告！',
        ko: '죽음의 선고 해제'
      }
    }
  }, {
    // There's another Void Blizzard IV with ID 1C77, but it's not the timing we want
    // The actual knockback cast is Void Aero IV, but it gives only 2-3s warning.
    id: 'Dun Scaith Blizzard Pillars',
    type: 'StartsUsing',
    netRegex: {
      id: '1C8B',
      source: 'Deathgaze Hollow',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Dun Scaith Void Sprite',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '5508',
      capture: false
    },
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill sprites',
        de: 'Exergone töten',
        fr: 'Tuez les élémentaires',
        ja: 'スプライトを倒す',
        cn: '击杀虚无元精',
        ko: '정령 잡기'
      }
    }
  }, {
    id: 'Dun Scaith Aero 2',
    type: 'HeadMarker',
    netRegex: {
      id: '0046'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Tornado outside',
        de: 'Wirbel draußen ablegen',
        fr: 'Déposez les tornades à l\'extérieur',
        ja: 'エアロガ、外に置く',
        cn: '场地边缘放风圈',
        ko: '회오리 외곽으로 유도'
      }
    }
  }, {
    // Deathgaze has two separate casts for this
    // Which one appears to depend on whether it's used alongside Bolt of Darkness
    // Mechanically the handling is the same
    id: 'Dun Scaith Aero 3',
    type: 'StartsUsing',
    netRegex: {
      id: ['1C7B', '1C8D'],
      source: 'Deathgaze Hollow',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    // It's not certain what causes Deathgaze to choose which ability.
    // Both are present with cast times of 2.7 seconds,
    // and neither seems to target players directly.
    id: 'Dun Scaith Void Death Squares',
    type: 'StartsUsing',
    netRegex: {
      id: ['1C82', '1C83'],
      source: 'Deathgaze Hollow',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid death squares',
        de: 'Weiche den Todes-Feldern aus',
        fr: 'Évitez les carrés de mort',
        ja: 'ヴォイド・デスジャ、エリアの外に',
        cn: '离开即死区域',
        ko: '검은 장판 피하기'
      }
    }
  },
  // FERDIAD
  {
    id: 'Dun Scaith Scythe Drop',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop scythe outside',
        de: 'Sense draußen ablegen',
        fr: 'Déposez la faux à l\'extérieur',
        ja: 'ブラックウインド、外に置く',
        cn: '场地边缘放镰刀',
        ko: '낫 외곽으로 유도'
      }
    }
  }, {
    id: 'Dun Scaith Jongleur\'s X',
    type: 'StartsUsing',
    netRegex: {
      id: '1C98',
      source: 'Ferdiad Hollow'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    // 5510 is Wailing Atomos (blue), 5511 is Cursing Atomos(yellow).
    // Sometimes it will happen that Aether/Chakrams will start casting before
    // the addedCombatant line that contains the Atomos.
    // When this happens, a simple startsCasting trigger will silently fail.
    // To avoid this, we store the IDs of Atomos for later comparison.
    id: 'Dun Scaith Atomos Setup',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: ['5510', '5511']
    },
    run: (data, matches) => {
      data.cursing ??= [];
      data.wailing ??= [];
      const id = matches.id.toUpperCase();
      matches.npcNameId === '5510' ? data.wailing.push(id) : data.cursing.push(id);
    }
  }, {
    // Wailing Atomos is blue, Cursing Atomos is yellow.
    // 1C9F:Aether is the circle AoE, 1CA0:Aetherial Chakram is the donut AoE
    id: 'Dun Scaith Atomos Compile',
    type: 'StartsUsing',
    netRegex: {
      id: ['1C9F', '1CA0']
    },
    delaySeconds: .5,
    run: (data, matches) => {
      data.sphere ??= [];
      data.donut ??= [];
      const target = data.wailing?.includes(matches.targetId) ? 'wailing' : 'cursing';
      if (matches.id === '1C9F') data.sphere.push(target);else data.donut.push(target);
    }
  }, {
    id: 'Dun Scaith Atomos Response',
    type: 'StartsUsing',
    netRegex: {
      id: ['1C9F', '1CA0'],
      capture: false
    },
    delaySeconds: 1,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      if (data.donut?.length === 2) {
        return output.goToAnyUntethered();
      } else if (data.sphere?.length === 2) {
        return output.avoidAllUntethered();
      } else if (data.donut?.length === 1) {
        // Wailing Atomos is blue, Cursing Atomos is yellow.
        // If there's exactly 1 Chakram, the other Atomos is irrelevant.
        // (Any Chakram Atomos is guaranteed to be safe.)
        if (data.donut?.[0] === 'wailing') return output.goToUntetheredBlue();
        return output.goToUntetheredYellow();
      }
      // If there's only a Sphere on the field, the other Atomos color isn't guaranteed safe.
      // Therefore we need to specify staying away from the Sphere-tethered Atomos.
      if (data.sphere?.[0] === 'wailing') return output.avoidUntetheredBlue();
      return output.avoidUntetheredYellow();
    },
    outputStrings: {
      goToAnyUntethered: {
        en: 'Go To Any Untethered',
        de: 'Gehe zu einem Unverbundenen',
        fr: 'Allez sous une Gueule non liée',
        ja: '線のないアトモスに近づく',
        cn: '靠近无线小怪',
        ko: '아무 아트모스 근처로'
      },
      avoidAllUntethered: {
        en: 'Avoid All Untethered',
        de: 'Vermeide alle Unverbundenen',
        fr: 'Évitez toutes les Gueules non liées',
        ja: '線のないアトモスから離れる',
        cn: '远离无线小怪',
        ko: '모든 아트모스 피하기'
      },
      goToUntetheredBlue: {
        en: 'Go to Untethered Blue',
        de: 'Gehe zu dem nicht verbundenen blauem Atomos',
        fr: 'Allez sous une Gueule bleue non liée',
        ja: '線のない青色アトモスに近づく',
        cn: '靠近蓝色小怪',
        ko: '파란 아트모스로 이동'
      },
      goToUntetheredYellow: {
        en: 'Go to Untethered Yellow',
        de: 'Gehe zu dem nicht verbundenen gelben Atomos',
        fr: 'Allez sous une Gueule jaune non liée',
        ja: '線のない黄色アトモスに近づく',
        cn: '靠近黄色小怪',
        ko: '노란 아트모스로 이동'
      },
      avoidUntetheredBlue: {
        en: 'Avoid Untethered Blue',
        de: 'Weiche dem nicht verbundenen blauem Atomos aus',
        fr: 'Évitez une Gueule bleue non liée',
        ja: '線のない青色アトモスから離れる',
        cn: '远离蓝色小怪',
        ko: '파란 아트모스 피하기'
      },
      avoidUntetheredYellow: {
        en: 'Avoid Untethered Yellow',
        de: 'Weiche dem nicht verbundenen gelben Atomos aus',
        fr: 'Évitez une Gueule jaune non liée',
        ja: '線のない黄色アトモスから離れる',
        cn: '远离黄色小怪',
        ko: '노란 아트모스 피하기'
      }
    }
  }, {
    id: 'Dun Scaith Atomos Cleanup',
    type: 'Ability',
    netRegex: {
      id: ['1CA1', '1CA2'],
      capture: false
    },
    run: data => {
      delete data.cursing;
      delete data.wailing;
      delete data.sphere;
      delete data.donut;
    }
  }, {
    id: 'Dun Scaith Blackfire',
    type: 'StartsUsing',
    netRegex: {
      id: '1CAA',
      source: 'Ferdiad Hollow',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid puddles',
        de: 'Flächen ausweichen',
        fr: 'Évitez les zones au sol',
        ja: '円範囲攻撃、避ける',
        cn: '离开圈圈',
        ko: '장판 피하기'
      }
    }
  }, {
    // https://xivapi.com/Status/1137
    id: 'Dun Scaith Debilitator Fire',
    type: 'GainsEffect',
    netRegex: {
      effectId: '471',
      capture: false
    },
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Change puddles to water',
        de: 'Ändere Flächen zu Wasser',
        fr: 'Changez les zones au sol en eau',
        ja: '青い水に入れ替える',
        cn: '将地上的圈踩成蓝色',
        ko: '파란 장판으로 바꾸기'
      }
    }
  }, {
    // https://xivapi.com/Status/1157
    id: 'Dun Scaith Debilitator Water',
    type: 'GainsEffect',
    netRegex: {
      effectId: '485',
      capture: false
    },
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Change puddles to fire',
        de: 'Ändere Flächen zu Feuer',
        fr: 'Changez les zones au sol en feu',
        ja: '赤い火に入れ替える',
        cn: '将地上的圈踩成红色',
        ko: '빨간 장판으로 바꾸기'
      }
    }
  },
  // PROTO-ULTIMA
  {
    // Covers both 1E52 Aetherochemical Flare and 1D9D Supernova. Response to both is the same.
    id: 'Dun Scaith Proto-Ultima Raid Damage',
    type: 'StartsUsing',
    netRegex: {
      id: ['1E52', '1D9D'],
      source: 'Proto Ultima',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Dun Scaith Prey Markers',
    type: 'GainsEffect',
    netRegex: {
      effectId: '232'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Prey--Avoid party and keep moving',
        de: 'Markiert - Weg von der Gruppe und bleib in Bewegung',
        fr: 'Marquage - Évitez les autres et bougez',
        ja: 'マーキング - 外に移動し続ける',
        cn: '离开人群并保持移动',
        ko: '파티에서 떨어지고 계속 움직이기'
      }
    }
  }, {
    // Triggering off the Bit appearance
    // The cast time on Aetheromodulator is under 3 seconds
    id: 'Dun Scaith Bit Circles',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '3782',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Bit AoEs',
        de: 'Weiche den Bit AoEs aus',
        fr: 'Évitez les AoE des forets',
        ja: 'AoEを避ける',
        cn: '躲避小型AOE',
        ko: '비트 장판 피하기'
      }
    }
  }, {
    id: 'Dun Scaith Aether Collectors',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '3781',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill collectors',
        de: 'Ätherakkumulator besiegen',
        fr: 'Détruisez les accumulateurs',
        ja: 'エーテル集積器を倒す',
        cn: '击杀以太收集器',
        ko: '에테르 집적기 파괴'
      }
    }
  },
  // SCATHACH
  {
    // The actual attack is 1D20, but the castbar windup is 1D1F
    id: 'Dun Scaith Shadespin',
    type: 'StartsUsing',
    netRegex: {
      id: '1D1[EF]',
      source: 'Scathach',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid arm slaps',
        de: 'Weiche den Armschlägen aus',
        fr: 'Évitez les claques de bras',
        ja: '影の手を避ける',
        cn: '站在boss背后方向',
        ko: '날개 피하기'
      }
    }
  }, {
    id: 'Dun Scaith Thirty Thorns',
    type: 'Ability',
    netRegex: {
      id: ['1D1B', '1D2B'],
      source: 'Scathach',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.outOfMelee */.n3.outOfMelee()
  }, {
    id: 'Dun Scaith Thirty Arrows',
    type: 'StartsUsing',
    netRegex: {
      id: '1D2F',
      source: 'Scathach',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid line AoEs',
        de: 'Weiche den Linien AoEs aus',
        fr: 'Évitez les AoEs en ligne',
        ja: 'スカアハの正面に立たない',
        cn: '躲开boss正面路线',
        ko: '직선 장판 피하기'
      }
    }
  }, {
    id: 'Dun Scaith Thirty Souls',
    type: 'StartsUsing',
    netRegex: {
      id: '1D32',
      source: 'Scathach',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Ordinarily we wouldn't use a log message for this.
    // However, the RP text seems to be the only indicator.
    // (Not a MapEffect packet either.)
    // https://xivapi.com/LogMessage/2747
    // en: Shadows gather on the floor.
    id: 'Dun Scaith Shadow Links',
    type: 'SystemLogMessage',
    netRegex: {
      id: 'ABB',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.stopMoving */.n3.stopMoving()
  }, {
    id: 'Dun Scaith Shadow Limb Spawn',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '5516',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill the hands',
        de: 'Besiege die Hand',
        fr: 'Tuez les mains',
        ja: '影の手を倒す',
        cn: '击杀影之手',
        ko: '손 처치하기'
      }
    }
  }, {
    id: 'Dun Scaith Connla Spawn',
    type: 'StartsUsing',
    netRegex: {
      id: '1CD1',
      source: 'Connla',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid AoE, Kill Connla',
        de: 'Weiche AoE aus, besiege Connla',
        fr: 'Évitez les AoE, tuez Connla',
        ja: 'AoEを避け、コンラを倒す',
        cn: '躲避AOE后击杀康拉',
        ko: '장판 피하고 콘라 처치'
      }
    }
  }, {
    // This trigger is common to both Scathach and Diabolos, since handling is 100% identical.
    id: 'Dun Scaith Nox Orbs',
    type: 'HeadMarker',
    netRegex: {
      id: '005C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Take orb outside',
        de: 'Orb nach außen bringen',
        fr: 'Prenez l\'orbe à l\'extérieur',
        ja: '黒い球体を外に引く',
        cn: '把球带出人群，移动到球不再出现为止',
        ko: '구슬 외곽으로 유도'
      }
    }
  }, {
    // This trigger is common to both Scathach and Diabolos, since handling is 100% identical.
    id: 'Dun Scaith Shadethrust',
    type: 'StartsUsing',
    netRegex: {
      id: ['1D23', '1C1A'],
      source: ['Scathach', 'Diabolos Hollow'],
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  },
  // DIABOLOS
  {
    id: 'Dun Scaith Ultimate Terror',
    type: 'StartsUsing',
    netRegex: {
      id: '1C12',
      source: 'Diabolos',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Dun Scaith Nightmare',
    type: 'StartsUsing',
    netRegex: {
      id: ['1C0E', '1C20'],
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Dun Scaith Noctoshield',
    type: 'GainsEffect',
    netRegex: {
      target: 'Diabolos',
      effectId: '1AA',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Boss hitting hard--Shield/Mitigate',
        de: 'Harter Hit vom Boss - Schild/Milderung',
        fr: 'Le boss frappe fort - Bouclier/Mitigation',
        ja: '大ダメージ物理タンクバスター - ダメージ軽減/バリア',
        cn: 'MT大伤害物理死刑—注意减伤/治疗盾',
        ko: '탱커버스터 - 뎀감/보호막'
      }
    }
  }, {
    id: 'Dun Scaith Ruinous Omen',
    type: 'StartsUsing',
    netRegex: {
      id: ['1C10', '1C11'],
      source: 'Diabolos',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Dun Scaith Deathgates',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '5523',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill the deathgates',
        de: 'Besiege die Tore des Todes',
        fr: 'Détruisez les portes de mort',
        ja: '召喚の扉を倒す',
        cn: '击杀召唤之门',
        ko: '소환의 문 파괴'
      }
    }
  }, {
    id: 'Dun Scaith Camisado',
    type: 'StartsUsing',
    netRegex: {
      id: '1C19',
      source: 'Diabolos Hollow'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Dun Scaith Hollow Night',
    type: 'HeadMarker',
    netRegex: {
      id: '005B'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.gazeStackOnYou();
      return output.stackOnAndLookAway({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      gazeStackOnYou: {
        en: 'Gaze stack on YOU',
        de: 'Blick-Sammeln auf DIR',
        fr: 'Package sur VOUS',
        ja: '自分に頭割り',
        cn: '点名分摊',
        ko: '시선 쉐어 대상자'
      },
      stackOnAndLookAway: {
        en: 'Stack on ${player} and look away',
        de: 'Sammeln bei ${player} und wewg schauen',
        fr: 'Packez-vous sur ${player} et regardez ailleurs',
        ja: '${player}に頭割り、見ない',
        cn: '靠近并背对${player}分摊',
        ko: '${player} 쉐어, 바라보지않기'
      }
    }
  }, {
    id: 'Dun Scaith Hollow Omen',
    type: 'StartsUsing',
    netRegex: {
      id: ['1C22', '1C23'],
      source: 'Diabolos Hollow',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    // This is the tank version of the stack marker. It has minimal circular bordering
    id: 'Dun Scaith Blindside',
    type: 'HeadMarker',
    netRegex: {
      id: '005D'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Dun Scaith Earth Shaker',
    type: 'HeadMarker',
    netRegex: {
      id: '0028'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.earthshaker */.n3.earthshaker()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aether(?!i)': 'Äthersphäre',
      'Aether Collector': 'Ätherakkumulator',
      'Aetherial Chakram': 'ätherisch(?:e|er|es|en) Chakram',
      'Connla': 'Connla',
      'Cursing Atomos': 'Fluch-Atomos',
      'Deathgate': 'Tor des Todes',
      'Deathgaze Hollow': 'Nihil-Thanatos',
      'Diabolos Hollow': 'Nihil-Diabolos',
      'Diabolos(?! )': 'Diabolos',
      'Ferdiad Hollow': 'Nihil-Ferdiad',
      'Lifegate': 'Tor des Lebens',
      'Proto Bit': 'Proto-Drohne',
      'Proto Ultima': 'Proto-Ultima',
      'Scathach': 'Scathach',
      'Shadow Limb': 'Schattenhand',
      'Shadowcourt Jester': 'Schattenhof-Narr',
      'The Queen\'s Graces': 'Anmut der Königin',
      'The Queen\'s Pride': 'Stolz der Königin',
      'The Rostrum': 'Podium',
      'The main deck': 'Hauptdeck',
      'Void Sprite': 'Nichts-Exergon',
      'Wailing Atomos': 'Heul-Atomos'
    },
    'replaceText': {
      '--deathgate spawn--': '--Tor des Todes erscheint--',
      '--lifegate spawn--': '--Tor des Lebens erscheint--',
      '--shadows gather--': '--Schatten sammeln sich--',
      '--towers appear--': '--Türme erscheinen--',
      'Aether Bend': 'Ätherbeugung',
      'Aetherial Pool': 'Ätherstau',
      'Aetherochemical Flare': 'Ätherochemisches Flare',
      'Aetherochemical Laser': 'Ätherochemischer Laser',
      'Black Wind': 'Schwarzer Wind',
      'Blackbolt': 'Schwarzer Schuss',
      'Blackfire': 'Schwarzfeuer',
      'Blinding Shadow': 'Blendender Schatten',
      'Blindside': 'Schwache Seite',
      'Bolt Of Darkness': 'Dunkles Geschoss',
      '(?<! )Camisado': 'Camisado',
      'Citadel Buster': 'Zitadellensprenger',
      'Debilitator': 'Schwachmacher',
      'Diffractive Laser': 'Diffraktiver Laser',
      'Doomsay': 'Todesfluch',
      'Double Edge': 'Doppelschliff',
      'Dream Shroud': 'Traumgewand',
      'Earth Shaker': 'Erdstoß',
      'Eikonizer': 'Ikonisator',
      'Explosion': 'Explosion',
      'Flameflow': 'Flammenstrom',
      'Flare Star': 'Flare-Stern',
      'Hollow Camisado': 'Hohles Camisado',
      'Hollow Night(?!mare)': 'Hohlnacht',
      'Hollow Nightmare': 'Hohler Albtraum',
      'Hollow Omen': 'Hohles Omen',
      'Hollow Terror': 'Hohler Terror',
      'Hollowshield': 'Hohlschild',
      'Jester\'s Jig': 'Narretei',
      'Jester\'s Reap': 'Narrensense',
      'Jester\'s Reward': 'Lohn des Possenreißers',
      'Jongleur\'s X': 'Jonglage',
      'Juggling Sphere': 'Jonglierball',
      'Light Pillar': 'Lichtsäule',
      'Manos': 'Manos',
      '(?<!Hollow )Nightmare': 'Albtraum',
      'Night Terror': 'Nachtterror',
      'Noctoshield': 'Nachtschild',
      'Nox': 'Nox',
      'Particle Beam': 'Partikelstrahl',
      'Pavor Inanis': 'Pavor Inanis',
      'Pitfall': 'Berstender Boden',
      'Ruinous Omen': 'Ruinöses Omen',
      'Shadesmite': 'Schattenhieb',
      'Shadespin': 'Dunkeldrehung',
      'Shadethrust': 'Schattenschub',
      'Shadow Release': 'Entschattung',
      'Sleight': 'Trick',
      'Soar': 'Auffliegen',
      'Spike Of Darkness': 'Spitze der Dunkelheit',
      'Supernova': 'Wahnstrahl',
      '(?<!( |t))Terror': 'Terror',
      'Thirty Arrows': 'Dreißig Pfeile',
      'Thirty Cries': 'Dreißig Schreie',
      'Thirty Sickles': 'Dreißig Sicheln',
      'Thirty Souls': 'Dreißig Seelen',
      'Thirty Thorns': 'Dreißig Dornen',
      'Touchdown': 'Himmelsturz',
      'Ultimate Terror': 'Ultimativer Terror',
      'Void Aero II(?!I)': 'Nichts-Windra',
      'Void Aero III': 'Nichts-Windga',
      'Void Aero IV': 'Nichts-Windka',
      'Void Blizzard III': 'Nichts-Eisga',
      'Void Blizzard IV': 'Nichts-Eiska',
      'Void Death(?! IV)': 'Nichts-Tod',
      'Void Death IV': 'Nichts-Todka',
      'Wormhole': 'Wurmloch'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aether(?!i)': 'sphère éthérée',
      'Aether Collector': 'accumulateur d\'éther',
      'Aetherial Chakram': 'chakram éthéré',
      'Connla': 'Connla',
      'Cursing Atomos': 'gueule maudissante',
      'Deathgate': 'porte de mort',
      'Deathgaze Hollow': 'mortalis nihil',
      'Diabolos Hollow': 'Diabolos nihil',
      'Diabolos(?! )': 'Diabolos',
      'Ferdiad Hollow': 'Ferdiad nihil',
      'Lifegate': 'porte de vie',
      'Proto Bit': 'proto-foret',
      'Proto Ultima': 'Proto-Ultima',
      'Scathach': 'Scáthach',
      'Shadow Limb': 'Mains d\'ombre',
      'Shadowcourt Jester': 'bouffon de la Cour des ombres',
      'The Queen\'s Graces': 'Grâces de la Reine',
      'The Queen\'s Pride': 'Fierté de la Reine',
      'The Rostrum': 'Scène',
      'The main deck': 'Pont principal',
      'Void Sprite': 'élémentaire du vide',
      'Wailing Atomos': 'gueule gémissante'
    },
    'replaceText': {
      '--deathgate spawn--': '--apparition des portes de mort--',
      '--lifegate spawn--': '--apparition des portes de vie--',
      '--shadows gather--': '--pouvoir des ombres--',
      '--towers appear--': '--apparition des tours--',
      'Aether Bend': 'Diffraction éthérée',
      'Aetherial Pool': 'Attraction éthéréenne',
      'Aetherochemical Flare': 'Brasier magismologique',
      'Aetherochemical Laser': 'Laser magismologique',
      'Black Wind': 'Vent noir',
      'Blackbolt': 'Éclair noir',
      'Blackfire': 'Flamme noire',
      'Blinding Shadow': 'Ombre aveuglante',
      'Blindside': 'Mystification',
      'Bolt Of Darkness': 'Éclair des ténèbres',
      '(?<!Hollow )Camisado(?! nihil)': 'Camisado',
      'Citadel Buster': 'Casse-citadelle',
      'Debilitator': 'Débilitant',
      'Diffractive Laser': 'Rayon accélérateur',
      'Doomsay': 'Malédiction funeste',
      'Double Edge': 'Double tranchant',
      'Dream Shroud': 'Voile onirique',
      'Earth Shaker': 'Secousse',
      'Eikonizer': 'Casse-Primordial',
      'Explosion': 'Explosion',
      'Flameflow': 'Flot de flammes',
      'Flare Star': 'Astre flamboyant',
      'Hollow Camisado': 'Camisado nihil',
      'Hollow Night(?!mare)': 'Nuit nihil',
      'Hollow Nightmare': 'Cauchemar nihil',
      'Hollow Omen': 'Présage nihil',
      'Hollow Terror': 'Terreur nihil',
      'Hollowshield': 'Bouclier nihil',
      'Jester\'s Jig': 'Gigue du bouffon',
      'Jester\'s Reap': 'Bouffon du roi',
      'Jester\'s Reward': 'Récompense du bouffon',
      'Jongleur\'s X': 'Jongleur fou',
      'Juggling Sphere': 'Sphère jongleuse',
      'Light Pillar': 'Colonne lumineuse',
      'Manos': 'Concentration ombrale',
      'Night Terror': 'Terreur nocturne',
      '(?<!Hollow )Nightmare': 'Cauchemar',
      'Noctoshield': 'Nocto-bouclier',
      'Nox': 'Nox',
      'Particle Beam': 'Rayon explosif',
      'Pavor Inanis': 'Pavor inanis',
      'Pitfall': 'Embûche',
      'Ruinous Omen': 'Mauvais présage',
      'Shadesmite': 'Frappe ombrale',
      'Shadespin': 'Tourbillon ombral',
      'Shadethrust': 'Transpercement ténèbreux',
      'Shadow Release': 'Libération ombrale',
      'Sleight': 'Maestria',
      'Soar': 'Ascension',
      'Spike Of Darkness': 'Pointes des ténèbres',
      'Supernova': 'Démence spatiale',
      '(?<! )Terror': 'Terreur',
      'Thirty Arrows': 'Trente flèches',
      'Thirty Cries': 'Trente cris',
      'Thirty Sickles': 'Trente faucilles',
      'Thirty Souls': 'Trente âmes',
      'Thirty Thorns': 'Trente épines',
      'Touchdown': 'Atterrissage',
      'Ultimate Terror': 'Terreur ultime',
      'Void Aero II(?!I)': 'Extra Vent du néant',
      'Void Aero III': 'Méga Vent du néant',
      'Void Aero IV': 'Giga Vent du néant',
      'Void Blizzard III': 'Méga Glace du néant',
      'Void Blizzard IV': 'Giga Glace du néant',
      'Void Death': 'Mort du néant',
      'Wormhole': 'Vortex'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aether(?! |ial)': 'エーテルスフィア',
      'Aether Collector': 'エーテル集積器',
      'Aetherial Chakram': 'エーテルチャクラム',
      'Connla': 'コンラ',
      'Cursing Atomos': '怨声のアトモス',
      'Deathgate': '召喚の扉',
      'Deathgaze Hollow': 'デスゲイズ・ホロー',
      'Diabolos Hollow': 'ディアボロス・ホロー',
      'Diabolos(?! )': 'ディアボロス',
      'Ferdiad Hollow': 'フェルディア・ホロー',
      'Lifegate': '魔力の扉',
      'Proto Bit': 'プロトビット',
      'Proto Ultima': 'プロトアルテマ',
      'Scathach': 'スカアハ',
      'Shadow Limb': '影の手',
      'Shadowcourt Jester': 'クィーンズ・ジェスター',
      'The Queen\'s Graces': '女王の間',
      'The Queen\'s Pride': '女王の観閲広場',
      'The Rostrum': '道化の舞台',
      'The main deck': 'レディ・ラドリア号主甲板',
      'Void Sprite': 'ヴォイド・スプライト',
      'Wailing Atomos': '虚声のアトモス'
    },
    'replaceText': {
      '--deathgate spawn--': '--召喚の扉出現--',
      '--lifegate spawn--': '--魔力の扉出現--',
      '--shadows gather--': '--影の力を集めてる--',
      '--towers appear--': '--塔出現--',
      'Aether Bend': 'エーテルベント',
      'Aetherial Pool': 'エーテリアルプール',
      'Aetherochemical Flare': '魔科学フレア',
      'Aetherochemical Laser': '魔科学レーザー',
      'Black Wind': 'ブラックウインド',
      'Blackbolt': 'ブラックボルト',
      'Blackfire': '漆黒の炎',
      'Blinding Shadow': 'ブライテストシャドウ',
      'Blindside': 'ブラインドサイド',
      'Bolt Of Darkness': 'ダークネスボルト',
      '(?<!Hollow )Camisado': 'カミサドー',
      'Citadel Buster': 'シタデルバスター',
      'Debilitator': 'ウィークメーカー',
      'Diffractive Laser': '拡散レーザー',
      'Doomsay': '死の呪い',
      'Double Edge': '諸刃の剣',
      'Dream Shroud': 'ドリームシュラウド',
      'Earth Shaker': 'アースシェイカー',
      'Eikonizer': 'プライマルバスター',
      'Explosion': '爆発',
      'Flameflow': 'フレイムフロウ',
      'Flare Star': 'フレアスター',
      'Hollow Camisado': 'ホローカミサドー',
      'Hollow Night(?!mare)': 'ホローナイト',
      'Hollow Nightmare': 'ホローナイトメア',
      'Hollow Omen': 'ホローオーメン',
      'Hollow Terror': 'ホローテラー',
      'Hollowshield': 'ホローシールド',
      'Jester\'s Jig': 'ジェスターズジグ',
      'Jester\'s Reap': 'ジェスターズリープ',
      'Jester\'s Reward': 'ジェスターズリワード',
      'Jongleur\'s X': 'ダークジャグリング',
      'Juggling Sphere': 'ジャグリング・スフィア',
      'Light Pillar': 'リヒト・ゾイレ',
      'Manos': '影の凝縮',
      'Night Terror': 'ナイトテラー',
      '(?<!Hollow )Nightmare': 'ナイトメア',
      'Noctoshield': 'ノクトシールド',
      'Nox': 'ノックス',
      'Particle Beam': '波動爆発',
      'Pavor Inanis': 'パボルイナニス',
      'Pitfall': '強襲',
      'Ruinous Omen': 'ルイナスオーメン',
      'Shadesmite': 'シェードスマイト',
      'Shadespin': 'シェードスピン',
      'Shadethrust': 'シャドウスラスト',
      'Shadow Release': '影の解放',
      'Sleight': 'スレイト',
      'Soar': '飛翔',
      'Spike Of Darkness': 'ダークネススパイク',
      'Supernova': 'インサニティサン',
      '(?<! )Terror': '恐怖',
      'Thirty Arrows': 'サーティー・アローズ',
      'Thirty Cries': 'サーティー・クライス',
      'Thirty Sickles': 'サーティー・シックルズ',
      'Thirty Souls': 'サーティー・ソウルズ',
      'Thirty Thorns': 'サーティー・ソーンズ',
      'Touchdown': 'タッチダウン',
      'Ultimate Terror': 'アルティメットテラー',
      'Void Aero II(?!I)': 'ヴォイド・エアロラ',
      'Void Aero III': 'ヴォイド・エアロガ',
      'Void Aero IV': 'ヴォイド・エアロジャ',
      'Void Blizzard III': 'ヴォイド・ブリザガ',
      'Void Blizzard IV': 'ヴォイド・ブリザジャ',
      'Void Death(?! )': 'ヴォイド・デス',
      'Void Death IV': 'ヴォイド・デスジャ',
      'Wormhole': 'ワームホール'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aether(?! |ial)': '以太晶球',
      'Aether Collector': '以太收集器',
      'Aetherial Chakram': '以太轮',
      'Connla': '康拉',
      'Cursing Atomos': '怨声的阿托莫斯',
      'Deathgate': '召唤之门',
      'Deathgaze Hollow': '虚空死亡凝视',
      'Diabolos Hollow': '虚空迪亚波罗斯',
      'Diabolos(?! )': '迪亚波罗斯',
      'Ferdiad Hollow': '虚空弗迪亚',
      'Lifegate': '魔力之门',
      'Proto Bit': '原型浮游炮',
      'Proto Ultima': '究极神兵原型',
      'Scathach': '斯卡哈',
      'Shadow Limb': '影之手',
      'Shadowcourt Jester': '女王小丑',
      'The Queen\'s Graces': '女王之间',
      'The Queen\'s Pride': '女王的阅兵广场',
      'The Rostrum': '小丑舞台',
      'The main deck': '主甲板',
      'Void Sprite': '虚无元精',
      'Wailing Atomos': '虚声的阿托莫斯'
    },
    'replaceText': {
      '--deathgate spawn--': '--召唤之门出现--',
      '--lifegate spawn--': '--魔力之门出现--',
      '--shadows gather--': '--影之力--',
      '--towers appear--': '--塔出现--',
      'Aether Bend': '以太曲折',
      'Aetherial Pool': '以太池',
      'Aetherochemical Flare': '魔科学核爆',
      'Aetherochemical Laser': '魔科学激光',
      'Black Wind': '黑风',
      'Blackbolt': '黑雷',
      'Blackfire': '漆黑之炎',
      'Blinding Shadow': '蔽目之影',
      'Blindside': '盲点袭击',
      'Bolt Of Darkness': '黑暗电光',
      '(?<! )Camisado': '夜袭',
      'Citadel Buster': '攻城炮',
      'Debilitator': '弱点生成',
      'Diffractive Laser': '扩散射线',
      'Doomsay': '死亡诅咒',
      'Double Edge': '双刃剑',
      'Dream Shroud': '梦境之障',
      'Earth Shaker': '大地摇动',
      'Eikonizer': '荒蛮破坏者',
      'Explosion': '爆炸',
      'Flameflow': '烈炎流',
      'Flare Star': '耀星',
      'Hollow Camisado': '虚空夜袭',
      'Hollow Night(?!mare)': '虚空暗夜',
      'Hollow Nightmare': '虚空噩梦',
      'Hollow Omen': '虚空预兆',
      'Hollow Terror': '虚空恐惧',
      'Hollowshield': '虚空之障',
      'Jester\'s Jig': '小丑的吉格舞',
      'Jester\'s Reap': '小丑收割',
      'Jester\'s Reward': '小丑的奖励',
      'Jongleur\'s X': '黑暗杂耍',
      'Juggling Sphere': '杂耍球',
      'Light Pillar': '光柱',
      'Manos': '影子凝缩',
      'Night Terror': '暗夜恐惧',
      '(?<!Hollow )Nightmare': '噩梦',
      'Noctoshield': '夜障',
      'Nox': '夜',
      'Particle Beam': '波动爆炸',
      'Pavor Inanis': '虚空之惊',
      'Pitfall': '强袭',
      'Ruinous Omen': '破灭预兆',
      'Shadesmite': '阴影重击',
      'Shadespin': '阴影回旋',
      'Shadethrust': '暗影直刺',
      'Shadow Release': '影子释放',
      'Sleight': '诡计',
      'Soar': '飞翔',
      'Spike Of Darkness': '黑暗钉刺',
      'Supernova': '空间错乱',
      '(?<! )Terror': '恐怖',
      'Thirty Arrows': '三十矢',
      'Thirty Cries': '三十泣',
      'Thirty Sickles': '三十镰',
      'Thirty Souls': '三十魂',
      'Thirty Thorns': '三十棘',
      'Touchdown': '空降',
      'Ultimate Terror': '究极恐惧',
      'Void Aero II(?!I)': '虚空烈风',
      'Void Aero III': '虚空暴风',
      'Void Aero IV': '虚空飙风',
      'Void Blizzard III': '虚空冰封',
      'Void Blizzard IV': '虚空冰澈',
      'Void Death(?! )': '虚空即死',
      'Void Death IV': '虚空极死',
      'Wormhole': '虫洞'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aether(?!i)': '에테르 구체',
      'Aether Collector': '에테르 집적기',
      'Aetherial Chakram': '에테르 차크람',
      'Connla': '콘라',
      'Cursing Atomos': '원성의 아토모스',
      'Deathgate': '소환의 문',
      'Deathgaze Hollow': '공허의 저승파수꾼',
      'Diabolos Hollow': '공허의 디아볼로스',
      'Diabolos(?! )': '디아볼로스',
      'Ferdiad Hollow': '공허의 페르디아',
      'Lifegate': '마력의 문',
      'Proto Bit': '프로토 비트',
      'Proto Ultima': '프로토 알테마',
      'Scathach': '스카하크',
      'Shadow Limb': '그림자 손',
      'Shadowcourt Jester': '여왕의 어릿광대',
      'The Queen\'s Graces': '여왕의 방',
      'The Queen\'s Pride': '여왕의 사열 광장',
      'The Rostrum': '광대의 무대',
      'The main deck': '레이디 래들리아호 주 갑판',
      'Void Sprite': '보이드 정령',
      'Wailing Atomos': '허성의 아토모스'
    },
    'replaceText': {
      '--deathgate spawn--': '--소환의 문 생성--',
      '--lifegate spawn--': '--마력의 문 생성--',
      '--shadows gather--': '--그림자 모임--',
      '--towers appear--': '--기둥 생성--',
      'Aether Bend': '에테르 굴절',
      'Aetherial Pool': '에테르 웅덩이',
      'Aetherochemical Flare': '마과학 플레어',
      'Aetherochemical Laser': '마과학 레이저',
      'Black Wind': '검은 바람',
      'Blackbolt': '검은 전광',
      'Blackfire': '칠흑의 불꽃',
      'Blinding Shadow': '눈부신 그림자',
      'Blindside': '맹점 기습',
      'Bolt Of Darkness': '암흑포',
      '(?<!Hollow )Camisado': '야습',
      'Citadel Buster': '공성포',
      'Debilitator': '약점 부여',
      'Diffractive Laser': '확산 레이저',
      'Doomsay': '죽음의 저주',
      'Double Edge': '양날의 검',
      'Dream Shroud': '꿈의 장막',
      'Earth Shaker': '요동치는 대지',
      'Eikonizer': '대 야만신포',
      'Explosion': '폭발',
      'Flameflow': '화염 순환',
      'Flare Star': '타오르는 별',
      'Hollow Camisado': '공허의 야습',
      'Hollow Night(?!mare)': '공허의 밤',
      'Hollow Nightmare': '공허의 악몽',
      'Hollow Omen': '공허의 전조',
      'Hollowshield': '공허의 방패',
      'Jester\'s Jig': '광대의 춤',
      'Jester\'s Reap': '광대의 낫질',
      'Jester\'s Reward': '광대의 답례',
      'Jongleur\'s X': '어둠의 곡예',
      'Juggling Sphere': '마술 구체',
      'Light Pillar': '빛 기둥',
      'Manos': '그림자 응축',
      '(?<!Hollow )Nightmare': '악몽',
      'Noctoshield': '밤의 방패',
      'Nox': '암야',
      'Particle Beam': '파동 폭발',
      'Pavor Inanis': '공허의 경외',
      'Pitfall': '강습',
      'Ruinous Omen': '재앙의 전조',
      'Shadesmite': '그림자 강타',
      'Shadespin': '그림자 회전',
      'Shadethrust': '그림자 관통',
      'Shadow Release': '그림자 해방',
      'Sleight': '교묘한 술책',
      'Soar': '비상',
      'Spike Of Darkness': '어둠의 강타',
      'Supernova': '광란의 태양',
      'Ultimate Terror': '궁극의 공포',
      '(?<!Ultimate )Terror': '공포',
      'Thirty Arrows': '서른 화살',
      'Thirty Cries': '서른 울음',
      'Thirty Sickles': '서른 낫',
      'Thirty Souls': '서른 혼',
      'Thirty Thorns': '서른 가시',
      'Touchdown': '착지',
      'Void Aero II(?!I)': '보이드 에어로라',
      'Void Aero III': '보이드 에어로가',
      'Void Aero IV': '보이드 에어로쟈',
      'Void Blizzard III': '보이드 블리자가',
      'Void Blizzard IV': '보이드 블리자쟈',
      'Void Death': '보이드 데스',
      'Wormhole': '웜홀'
    }
  }]
};
/* harmony default export */ const dun_scaith = (dun_scaith_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/alliance/dun_scaith.txt
const alliance_dun_scaith_namespaceObject = "### DUN SCAITH\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~~~~~~~~~~#\r\n# DEATHGAZE HOLLOW #\r\n#~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 1C90 1ABC -ic \"Fierce Wind\" \"Void Sprite\"\r\n\r\n# Main Deck will be sealed off\r\n0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"755\" } window 0,5\r\n6.7 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n11.8 \"--sync--\" Ability { id: \"1C91\", source: \"Deathgaze Hollow\" }\r\n16.6 \"--sync--\" Ability { id: \"1C92\", source: \"Deathgaze Hollow\" }\r\n19.0 \"Void Death\" Ability { id: \"1C7F\", source: \"Deathgaze Hollow\" }\r\n23.6 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n31.6 \"Void Aero II\" Ability { id: \"1C79\", source: \"Deathgaze Hollow\" }\r\n32.4 \"--sync--\" Ability { id: \"1C8C\", source: \"Deathgaze Hollow\" }\r\n34.6 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n39.1 \"Void Blizzard III\" Ability { id: \"1C75\", source: \"Deathgaze Hollow\" }\r\n39.6 \"--sync--\" Ability { id: \"1C8A\", source: \"Deathgaze Hollow\" }\r\n48.1 \"Void Aero III\" Ability { id: \"1C7B\", source: \"Deathgaze Hollow\" }\r\n54.1 \"--sync--\" Ability { id: \"1C8E\", source: \"Deathgaze Hollow\" }\r\n54.1 \"Void Aero III\" Ability { id: \"1C8D\", source: \"Deathgaze Hollow\" }\r\n56.1 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n62.1 \"Doomsay\" Ability { id: \"1C8[45]\", source: \"Deathgaze Hollow\" }\r\n\r\n# Logs exist where this section is skipped? HP push?\r\n74.3 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n77.6 \"--sync--\" Ability { id: \"1C91\", source: \"Deathgaze Hollow\" }\r\n82.4 \"--sync--\" Ability { id: \"1C92\", source: \"Deathgaze Hollow\" }\r\n84.9 \"Void Death\" Ability { id: \"1C7F\", source: \"Deathgaze Hollow\" }\r\n\r\n87.8 \"--sync--\" Ability { id: \"1C81\", source: \"Deathgaze Hollow\" } window 30,5\r\n94.8 \"Void Blizzard IV\" Ability { id: \"1C77\", source: \"Deathgaze Hollow\" }\r\n99.8 \"Void Blizzard IV\" Ability { id: \"1C8B\", source: \"Deathgaze Hollow\" }\r\n103.8 \"Void Aero IV\" Ability { id: \"1C7C\", source: \"Deathgaze Hollow\" }\r\n104.3 \"--sync--\" Ability { id: \"1C8F\", source: \"Deathgaze Hollow\" }\r\n113.8 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n123.8 \"Void Aero II\" Ability { id: \"1C78\", source: \"Deathgaze Hollow\" }\r\n124.6 \"--sync--\" Ability { id: \"1C8C\", source: \"Deathgaze Hollow\" }\r\n129.8 \"Void Aero III\" Ability { id: \"1C7A\", source: \"Deathgaze Hollow\" }\r\n139.8 \"--sync--\" Ability { id: \"1C8E\", source: \"Deathgaze Hollow\" }\r\n139.8 \"Void Aero III\" Ability { id: \"1C8D\", source: \"Deathgaze Hollow\" }\r\n139.8 \"Bolt Of Darkness\" Ability { id: \"1C8[67]\", source: \"Deathgaze Hollow\" }\r\n140.6 \"--sync--\" Ability { id: \"1C93\", source: \"Deathgaze Hollow\" }\r\n145.8 \"Void Death IV\" Ability { id: \"1C8[23]\", source: \"Deathgaze Hollow\" }\r\n149.8 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n154.8 \"Doomsay\" Ability { id: \"1C8[45]\", source: \"Deathgaze Hollow\" }\r\n159.8 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n168.8 \"Void Aero II\" Ability { id: \"1C78\", source: \"Deathgaze Hollow\" }\r\n169.6 \"--sync--\" Ability { id: \"1C8C\", source: \"Deathgaze Hollow\" }\r\n172.8 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n178.3 \"Void Blizzard III\" Ability { id: \"1C74\", source: \"Deathgaze Hollow\" }\r\n178.8 \"--sync--\" Ability { id: \"1C8A\", source: \"Deathgaze Hollow\" }\r\n184.3 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n189.3 \"Void Death IV\" Ability { id: \"1C8[23]\", source: \"Deathgaze Hollow\" }\r\n194.3 \"--sync--\" Ability { id: \"1C91\", source: \"Deathgaze Hollow\" }\r\n199.3 \"--sync--\" Ability { id: \"1C92\", source: \"Deathgaze Hollow\" }\r\n201.7 \"Void Death\" Ability { id: \"1C7E\", source: \"Deathgaze Hollow\" }\r\n204.3 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n209.3 \"Doomsay\" Ability { id: \"1C8[45]\", source: \"Deathgaze Hollow\" }\r\n218.3 \"Void Aero II\" Ability { id: \"1C78\", source: \"Deathgaze Hollow\" }\r\n219.1 \"--sync--\" Ability { id: \"1C8C\", source: \"Deathgaze Hollow\" }\r\n228.3 \"Void Blizzard IV\" Ability { id: \"1C76\", source: \"Deathgaze Hollow\" }\r\n233.3 \"Void Blizzard IV\" Ability { id: \"1C8B\", source: \"Deathgaze Hollow\" }\r\n237.3 \"Void Aero IV\" Ability { id: \"1C7D\", source: \"Deathgaze Hollow\" }\r\n237.8 \"--sync--\" Ability { id: \"1C8F\", source: \"Deathgaze Hollow\" }\r\n247.3 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n257.3 \"Void Aero II\" Ability { id: \"1C79\", source: \"Deathgaze Hollow\" }\r\n258.1 \"--sync--\" Ability { id: \"1C8C\", source: \"Deathgaze Hollow\" }\r\n263.3 \"Void Aero III\" Ability { id: \"1C7B\", source: \"Deathgaze Hollow\" }\r\n273.3 \"--sync--\" Ability { id: \"1C8E\", source: \"Deathgaze Hollow\" }\r\n273.3 \"Void Aero III\" Ability { id: \"1C8D\", source: \"Deathgaze Hollow\" }\r\n273.3 \"Bolt Of Darkness\" Ability { id: \"1C8[67]\", source: \"Deathgaze Hollow\" }\r\n274.1 \"--sync--\" Ability { id: \"1C93\", source: \"Deathgaze Hollow\" }\r\n279.3 \"Void Death IV\" Ability { id: \"1C8[23]\", source: \"Deathgaze Hollow\" }\r\n283.3 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n288.3 \"Doomsay\" Ability { id: \"1C8[45]\", source: \"Deathgaze Hollow\" }\r\n293.3 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n302.3 \"Void Aero II\" Ability { id: \"1C79\", source: \"Deathgaze Hollow\" }\r\n303.1 \"--sync--\" Ability { id: \"1C8C\", source: \"Deathgaze Hollow\" }\r\n306.3 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n311.8 \"Void Blizzard III\" Ability { id: \"1C75\", source: \"Deathgaze Hollow\" }\r\n312.3 \"--sync--\" Ability { id: \"1C8A\", source: \"Deathgaze Hollow\" }\r\n317.8 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n322.8 \"Void Death IV\" Ability { id: \"1C8[23]\", source: \"Deathgaze Hollow\" }\r\n327.8 \"--sync--\" Ability { id: \"1C91\", source: \"Deathgaze Hollow\" }\r\n332.8 \"--sync--\" Ability { id: \"1C92\", source: \"Deathgaze Hollow\" }\r\n335.2 \"Void Death\" Ability { id: \"1C7F\", source: \"Deathgaze Hollow\" }\r\n337.8 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n342.8 \"Doomsay\" Ability { id: \"1C8[45]\", source: \"Deathgaze Hollow\" }\r\n351.8 \"Void Aero II\" Ability { id: \"1C79\", source: \"Deathgaze Hollow\" }\r\n352.6 \"--sync--\" Ability { id: \"1C8C\", source: \"Deathgaze Hollow\" }\r\n361.8 \"Void Blizzard IV\" Ability { id: \"1C77\", source: \"Deathgaze Hollow\" }\r\n366.8 \"Void Blizzard IV\" Ability { id: \"1C8B\", source: \"Deathgaze Hollow\" }\r\n370.8 \"Void Aero IV\" Ability { id: \"1C7C\", source: \"Deathgaze Hollow\" }\r\n371.3 \"--sync--\" Ability { id: \"1C8F\", source: \"Deathgaze Hollow\" }\r\n380.8 \"Spike Of Darkness\" Ability { id: \"1E51\", source: \"Deathgaze Hollow\" }\r\n390.8 \"Void Aero II\" Ability { id: \"1C78\", source: \"Deathgaze Hollow\" }\r\n391.6 \"--sync--\" Ability { id: \"1C8C\", source: \"Deathgaze Hollow\" }\r\n396.8 \"Void Aero III\" Ability { id: \"1C7A\", source: \"Deathgaze Hollow\" }\r\n406.8 \"--sync--\" Ability { id: \"1C8E\", source: \"Deathgaze Hollow\" }\r\n406.8 \"Void Aero III\" Ability { id: \"1C8D\", source: \"Deathgaze Hollow\" }\r\n406.8 \"Bolt Of Darkness\" Ability { id: \"1C8[67]\", source: \"Deathgaze Hollow\" }\r\n407.6 \"--sync--\" Ability { id: \"1C93\", source: \"Deathgaze Hollow\" }\r\n412.8 \"Void Death IV\" Ability { id: \"1C8[23]\", source: \"Deathgaze Hollow\" }\r\n\r\n\r\n#~~~~~~~~~~~~~~~~#\r\n# FERDIAD HOLLOW #\r\n#~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 1C97 1CA8 1CA9 1CAB -ic \"Abyssal Scythe\"\r\n# -ic \"Ferdiad's Fool\"\r\n\r\n# The Rostrum will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"758\" } window 1000,5\r\n1014.2 \"Black Wind x3\" # Ability { id: \"1CAC\", source: \"Ferdiad Hollow\" }\r\n1020.3 \"Sleight\" Ability { id: \"1C99\", source: \"Ferdiad Hollow\" }\r\n1028.0 \"Wormhole\" Ability { id: \"1C9A\", source: \"Ferdiad Hollow\" }\r\n1028.3 \"--sync--\" Ability { id: \"1C49\", source: [\"Cursing Atomos\", \"Wailing Atomos\"] }\r\n1028.5 \"Juggling Sphere\" Ability { id: \"1C(9F|A0)\", source: [\"Aether\", \"Aetherial Chakram\"] }\r\n1030.0 \"--sync--\" Ability { id: \"1C9[CD]\", source: [\"Cursing Atomos\", \"Wailing Atomos\"] }\r\n1033.2 \"Explosion\" Ability { id: \"1CA[12]\", source: [\"Aether\", \"Aetherial Chakram\"] }\r\n1039.2 \"Jester's Reap\" Ability { id: \"1E41\", source: \"Ferdiad Hollow\" }\r\n1047.2 \"Jongleur's X\" Ability { id: \"1C98\", source: \"Ferdiad Hollow\" }\r\n1052.2 \"Sleight\" Ability { id: \"1C99\", source: \"Ferdiad Hollow\" }\r\n1060.5 \"Wormhole\" Ability { id: \"1C9A\", source: \"Ferdiad Hollow\" }\r\n1060.8 \"--sync--\" Ability { id: \"1C49\", source: [\"Cursing Atomos\", \"Wailing Atomos\"] }\r\n1061.0 \"Juggling Sphere\" Ability { id: \"1C(9F|A0)\", source: [\"Aether\", \"Aetherial Chakram\"] }\r\n1062.5 \"--sync--\" Ability { id: \"1C9[CD]\", source: [\"Cursing Atomos\", \"Wailing Atomos\"] }\r\n1065.7 \"Explosion\" Ability { id: \"1CA[12]\", source: [\"Aether\", \"Aetherial Chakram\"] }\r\n1069.7 \"Debilitator\" Ability { id: \"1CA6\", source: \"Ferdiad Hollow\" }\r\n1079.9 \"Jongleur's X\" Ability { id: \"1C98\", source: \"Ferdiad Hollow\" }\r\n1087.4 \"Flameflow\" Ability { id: \"1CA7\", source: \"Ferdiad Hollow\" }\r\n1089.9 \"Sleight\" Ability { id: \"1C99\", source: \"Ferdiad Hollow\" }\r\n\r\n\r\n# The intermission is extremely complex to figure out.\r\n# There are Atomos teleports, but only if Fools aren't alive.\r\n# The Fool actions don't seem to have strict timers.\r\n# It's all a mess, but Ferdiad is guaranteed to do his half-circle on time.\r\n1089.9 \"--untargetable--\"\r\n1095.9 \"--sync--\" Ability { id: \"1C9E\", source: \"Wailing Atomos\" } window 95.9,5\r\n1131.1 \"Jester's Reward\" Ability { id: \"1CA3\", source: \"Ferdiad Hollow\" }\r\n\r\n\r\n\r\n1300.0 \"--sync--\" StartsUsing { id: \"1CA4\", source: \"Ferdiad Hollow\" } window 300,5\r\n1304.7 \"Jester's Jig\" Ability { id: \"1CA4\", source: \"Ferdiad Hollow\" }\r\n1306.7 \"--sync--\" Ability { id: \"1CA5\", source: \"Ferdiad Hollow\" }\r\n\r\n1319.0 \"Sleight\" Ability { id: \"1C99\", source: \"Ferdiad Hollow\" }\r\n1327.5 \"Wormhole\" Ability { id: \"1C9A\", source: \"Ferdiad Hollow\" }\r\n1327.8 \"--sync--\" Ability { id: \"1C49\", source: [\"Cursing Atomos\", \"Wailing Atomos\"] }\r\n1328.0 \"Juggling Sphere\" Ability { id: \"1C(9F|A0)\", source: [\"Aether\", \"Aetherial Chakram\"] }\r\n1329.6 \"--sync--\" Ability { id: \"1C9[CD]\", source: [\"Cursing Atomos\", \"Wailing Atomos\"] }\r\n1333.0 \"Explosion\" Ability { id: \"1CA[12]\", source: [\"Aether\", \"Aetherial Chakram\"] } window 15,15\r\n1338.1 \"Jester's Reap\" Ability { id: \"1E41\", source: \"Ferdiad Hollow\" }\r\n1348.8 \"Black Wind\" # Ability { id: \"1CAC\", source: \"Ferdiad Hollow\" }\r\n1362.4 \"Blackfire\" Ability { id: \"1CAA\", source: \"Ferdiad Hollow\" }\r\n1372.7 \"Jester's Reap\" Ability { id: \"1E41\", source: \"Ferdiad Hollow\" }\r\n1380.9 \"Jongleur's X\" Ability { id: \"1C98\", source: \"Ferdiad Hollow\" } window 15,15\r\n1387.2 \"Debilitator\" Ability { id: \"1CA6\", source: \"Ferdiad Hollow\" }\r\n1394.7 \"Blackbolt\" Ability { id: \"1CAD\", source: \"Ferdiad Hollow\" }\r\n1405.2 \"Flameflow\" Ability { id: \"1CA7\", source: \"Ferdiad Hollow\" }\r\n1411.4 \"Jester's Reap\" Ability { id: \"1E41\", source: \"Ferdiad Hollow\" }\r\n\r\n1420.4 \"Sleight\" Ability { id: \"1C99\", source: \"Ferdiad Hollow\" } window 15,15 jump 1319\r\n1428.9 \"Wormhole\"\r\n1429.4 \"Juggling Sphere\"\r\n1434.4 \"Explosion\"\r\n1439.5 \"Jester's Reap\"\r\n1450.2 \"Black Wind\"\r\n\r\n#~~~~~~~~~~~~~~#\r\n# PROTO ULTIMA #\r\n#~~~~~~~~~~~~~~#\r\n\r\n# It's all bad. It never lasts long enough to get a good sample of its abilities.\r\n# A couple logs exist that seem to indicate that Light Pillar can come first.\r\n# However, no logs since 2019 show this behavior.\r\n# Maybe HP%-based? We window Light Pillar just to be safe.\r\n\r\n# -ii 1D9B\r\n# -ic \"Allagan Dreadnaught\" \"Proto Bit\"\r\n\r\n# The Queen's Pride will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"759\" } window 2000,5\r\n\r\n2007.8 \"Aether Bend\" Ability { id: \"1D99\", source: \"Proto Ultima\" }\r\n2018.4 \"Aetherochemical Laser 1\" Ability { id: \"1D96\", source: \"Proto Ultima\" }\r\n2022.4 \"Aetherochemical Laser 2\" Ability { id: \"1D98\", source: \"Proto Ultima\" }\r\n2026.4 \"Aetherochemical Laser 3\" Ability { id: \"1D97\", source: \"Proto Ultima\" }\r\n2033.4 \"Aetherochemical Flare\" Ability { id: \"1E52\", source: \"Proto Ultima\" }\r\n2034.6 \"Diffractive Laser\" # Ability { id: \"1DAA\", source: \"Proto Ultima\" }\r\n2036.6 \"--sync--\" Ability { id: \"1D9A\", source: \"Proto Ultima\" } window 36,5 # Logs exist where this is first.\r\n2042.6 \"Light Pillar x8\" duration 10 # Ability { id: \"1DA8\", source: \"Proto Ultima\" }\r\n2053.4 \"Aetherochemical Flare\" Ability { id: \"1E52\", source: \"Proto Ultima\" }\r\n\r\n# We don't know about this part. Maybe it does this?\r\n# Timing might be a little different?\r\n2060.0 \"Aether Bend\" Ability { id: \"1D99\", source: \"Proto Ultima\" } window 30,15 jump 2007.8\r\n2070.6 \"Aetherochemical Laser 1\"\r\n2074.6 \"Aetherochemical Laser 2\"\r\n2078.6 \"Aetherochemical Laser 3\"\r\n2079.8 \"Diffractive Laser\"\r\n2085.8 \"Light Pillar x8\"\r\n\r\n2100.0 \"--untargetable--\" Ability { id: \"1DA0\", source: \"Proto Ultima\" } window 100,5\r\n2110.6 \"--sync--\" Ability { id: \"1DAC\", source: \"Proto Ultima\" }\r\n2110.6 \"Eikonizer\" Ability { id: \"1DAD\", source: \"Proto Ultima\" }\r\n2117.5 \"Aetherial Pool\" Ability { id: \"1DA3\", source: \"Proto Ultima\" }\r\n2119.1 \"Flare Star\" Ability { id: \"1DA4\", source: \"Proto Ultima\" }\r\n2125.5 \"Aetherial Pool\" Ability { id: \"1DA3\", source: \"Proto Ultima\" }\r\n2126.2 \"--sync--\" Ability { id: \"1DA2\", source: \"Proto Ultima\" }\r\n2127.1 \"Flare Star\" Ability { id: \"1DA4\", source: \"Proto Ultima\" }\r\n2131.2 \"Citadel Buster\" Ability { id: \"1DAB\", source: \"Proto Ultima\" }\r\n2139.3 \"Touchdown\" Ability { id: \"1D9C\", source: \"Proto Ultima\" }\r\n2139.3 \"--targetable--\"\r\n\r\n2147.4 \"Supernova\" Ability { id: \"1D9D\", source: \"Proto Ultima\" }\r\n2156.6 \"--sync--\" Ability { id: \"1D9A\", source: \"Proto Ultima\" }\r\n2160.7 \"Light Pillar x10\" # Ability { id: \"1DA5\", source: \"Proto Ultima\" }\r\n2194.7 \"Aether Bend\" Ability { id: \"1D99\", source: \"Proto Ultima\" } window 30,5\r\n2200.7 \"Aetherochemical Flare\" Ability { id: \"1E52\", source: \"Proto Ultima\" }\r\n2204.4 \"Aetherochemical Laser 1\" Ability { id: \"1D96\", source: \"Proto Ultima\" } window 45,5\r\n2208.4 \"Aetherochemical Laser 2\" Ability { id: \"1D97\", source: \"Proto Ultima\" }\r\n2213.4 \"Aetherochemical Laser 3\" Ability { id: \"1D98\", source: \"Proto Ultima\" }\r\n2214.4 \"Diffractive Laser\" # Ability { id: \"1DAA\", source: \"Proto Ultima\" }\r\n\r\n# We don't know, but it seems likely.\r\n2216.4 \"--sync--\" Ability { id: \"1D9A\", source: \"Proto Ultima\" } window 30,30 jump 2156.6\r\n2220.5 \"Light Pillar x10\"\r\n\r\n# Enrage is a LOOOONG cast alongside Aether Collectors.\r\n2500.0 \"--sync--\" StartsUsing { id: \"1DA9\", source: \"Proto Ultima\" } window 2500,5\r\n2559.7 \"Supernova Enrage\" Ability { id: \"1DA9\", source: \"Proto Ultima\" }\r\n\r\n\r\n#~~~~~~~~~~#\r\n# SCATHACH #\r\n#~~~~~~~~~~#\r\n\r\n# -ii 1D2C 1D2D 1D2E 1D30 1DD4 1DD5 1E50\r\n# -ic Shadowcourt Jester\" \"Chimera Poppet\"\r\n\r\n# The Queen's Graces will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"75A\" } window 3000,5\r\n3013.1 \"Thirty Thorns\" Ability { id: \"1D2B\", source: \"Scathach\" }\r\n3030.2 \"Thirty Arrows\" Ability { id: \"1D2F\", source: \"Scathach\" } window 30,5\r\n3037.4 \"Manos\" Ability { id: \"1CD3\", source: \"Scathach\" } window 30,5\r\n3047.7 \"--sync--\" Ability { id: [\"1D1[EF]\"], source: \"Scathach\" }\r\n3049.0 \"Shadespin\" Ability { id: \"1D20\", source: \"Scathach\" }\r\n3052.8 \"Thirty Sickles\" Ability { id: \"1D31\", source: \"Scathach\" }\r\n3056.0 \"Soar\" Ability { id: \"1D1B\", source: \"Scathach\" }\r\n3060.0 \"--sync--\" Ability { id: \"1D1C\", source: \"Scathach\" }\r\n3061.0 \"Shadesmite\" Ability { id: \"1D1D\", source: \"Scathach\" }\r\n\r\n3070.8 \"--shadows gather--\"\r\n3084.8 \"Thirty Souls\" Ability { id: \"1D32\", source: \"Scathach\" } window 30,5\r\n3088.0 \"Shadow Release\" Ability { id: \"1CD4\", source: \"Scathach\" } window 90,5\r\n3095.1 \"--sync--\" Ability { id: \"1CD0\", source: \"Connla\" }\r\n3095.1 \"Pitfall\" Ability { id: \"1CD1\", source: \"Connla\" }\r\n3101.1 \"Thirty Thorns\" Ability { id: \"1D2B\", source: \"Scathach\" }\r\n3117.3 \"Thirty Arrows\" Ability { id: \"1D2F\", source: \"Scathach\" }\r\n3130.4 \"Thirty Souls\" Ability { id: \"1D32\", source: \"Scathach\" } window 30,5\r\n3133.6 \"Manos\" Ability { id: \"1CD3\", source: \"Scathach\" } window 30,5\r\n3143.7 \"--sync--\" Ability { id: \"1D1[EF]\", source: \"Scathach\" }\r\n3144.9 \"Shadespin\" Ability { id: \"1D20\", source: \"Scathach\" }\r\n3151.9 \"Nox x5\" Ability { id: \"1D22\", source: \"Scathach\" }\r\n3164.1 \"Shadethrust\" Ability { id: \"1D23\", source: \"Scathach\" }\r\n3182.2 \"Thirty Souls\" Ability { id: \"1D32\", source: \"Scathach\" }\r\n3197.4 \"Thirty Sickles\" Ability { id: \"1D31\", source: \"Scathach\" } window 45,5\r\n3199.4 \"--shadows gather--\"\r\n3203.6 \"Soar\" Ability { id: \"1D1B\", source: \"Scathach\" }\r\n3207.8 \"--sync--\" Ability { id: \"1D1C\", source: \"Scathach\" }\r\n3208.7 \"Shadesmite\" Ability { id: \"1D1D\", source: \"Scathach\" } window 30,30 jump 3061\r\n\r\n# We don't know 100% that this is the correct rotation,\r\n# but based on the available logs and video, it seems likely.\r\n3218.5 \"--shadows gather--\"\r\n3232.5 \"Thirty Souls\"\r\n3235.7 \"Shadow Release\"\r\n3242.8 \"Pitfall\"\r\n3248.8 \"Thirty Thorns\"\r\n\r\n\r\n# Intermission at 45% HP. Might be a time push too? but it's uncertain.\r\n3300.0 \"--untargetable--\" NameToggle { name: \"Scathach\", toggle: \"00\" } window 300,5\r\n3302.2 \"--sync--\" AddedCombatant { name: \"Shadowcourt Jester\" } window 300,5\r\n3323.6 \"--towers appear--\"\r\n3333.6 \"Particle Beam\" Ability { id: \"1D2[78]\", source: \"Scathach\" }\r\n\r\n\r\n3400.5 \"--sync--\" StartsUsing { id: \"1D34\", source: \"Scathach\" } window 100,5\r\n# 3405.2 \"Blinding Shadow\" Ability { id: \"1D34\", source: \"Scathach\" }\r\n3409.2 \"Blinding Shadow\" Ability { id: \"1DAE\", source: \"Scathach\" }\r\n\r\n# A very long rotation, approximately 192 seconds.\r\n# Add spawns and shadows gathering are approximate,\r\n# as nothing shows up for them in the log.\r\n3411.4 \"Shadow Release\" Ability { id: \"1CD4\", source: \"Scathach\" }\r\n3421.5 \"Thirty Souls\" Ability { id: \"1D32\", source: \"Scathach\" }\r\n3428.6 \"Thirty Arrows\" Ability { id: \"1D2F\", source: \"Scathach\" }\r\n3435.6 \"Particle Beam\" Ability { id: \"1D2[78]\", source: \"Scathach\" }\r\n3444.8 \"Thirty Souls\" Ability { id: \"1D32\", source: \"Scathach\" }\r\n3453.1 \"Thirty Souls\" Ability { id: \"1D32\", source: \"Scathach\" }\r\n3459.1 \"Thirty Arrows\" Ability { id: \"1D2F\", source: \"Scathach\" }\r\n3469.4 \"Thirty Cries\" Ability { id: \"1D33\", source: \"Scathach\" }\r\n3471.5 \"Particle Beam\" Ability { id: \"1D2[78]\", source: \"Scathach\" }\r\n3480.7 \"--sync--\" Ability { id: \"1CD0\", source: \"Connla\" }\r\n3480.7 \"Pitfall\" Ability { id: \"1CD1\", source: \"Connla\" }\r\n3491.8 \"Thirty Cries\" Ability { id: \"1D33\", source: \"Scathach\" }\r\n3494.9 \"Thirty Thorns\" Ability { id: \"1D2B\", source: \"Scathach\" }\r\n3506.1 \"Thirty Souls\" Ability { id: \"1D32\", source: \"Scathach\" }\r\n3510.4 \"Manos\" Ability { id: \"1CD3\", source: \"Scathach\" }\r\n3520.5 \"--sync--\" Ability { id: \"1D1[EF]\", source: \"Scathach\" }\r\n3521.6 \"Shadespin\" Ability { id: \"1D20\", source: \"Scathach\" }\r\n3523.6 \"--shadows gather--\"\r\n3526.7 \"Thirty Sickles\" Ability { id: \"1D31\", source: \"Scathach\" }\r\n3528.7 \"--adds spawn--\"\r\n3535.9 \"Nox x5\" Ability { id: \"1D22\", source: \"Scathach\" }\r\n3544.1 \"Shadethrust\" Ability { id: \"1D23\", source: \"Scathach\" }\r\n3552.2 \"Thirty Souls\" Ability { id: \"1D32\", source: \"Scathach\" }\r\n3553.2 \"--shadows gather--\"\r\n3557.4 \"Soar\" Ability { id: \"1D1B\", source: \"Scathach\" }\r\n3561.4 \"--sync--\" Ability { id: \"1D1C\", source: \"Scathach\" }\r\n3562.4 \"Shadesmite\" Ability { id: \"1D1D\", source: \"Scathach\" }\r\n3571.5 \"Shadethrust\" Ability { id: \"1D23\", source: \"Scathach\" }\r\n3575.5 \"--shadows gather--\"\r\n3580.6 \"--sync--\" Ability { id: \"1D1[EF]\", source: \"Scathach\" }\r\n3581.7 \"Shadespin\" Ability { id: \"1D20\", source: \"Scathach\" }\r\n3588.8 \"Thirty Souls\" Ability { id: \"1D32\", source: \"Scathach\" }\r\n3599.0 \"Thirty Souls\" Ability { id: \"1D32\", source: \"Scathach\" }\r\n\r\n# Again, this is presumed based on what we have.\r\n# There might be extra adds/shadows.\r\n3603.3 \"Shadow Release\" Ability { id: \"1CD4\", source: \"Scathach\" } window 30,30 jump 3409.2\r\n3613.4 \"Thirty Souls\"\r\n3620.5 \"Thirty Arrows\"\r\n3627.5 \"Particle Beam\"\r\n3636.7 \"Thirty Souls\"\r\n\r\n\r\n#~~~~~~~~~~#\r\n# DIABOLOS #\r\n#~~~~~~~~~~#\r\n\r\n# -ii 1C1B\r\n\r\n# Timing can vary depending on whether or not stuns are used.\r\n# Abilities can be skipped or delayed, there doesn't seem to be a clear pattern.\r\n# Also, tons of possible micro-skips before and after Ruinous Omen.\r\n\r\n# We sync off an attack from Diabolos because there are two encounters in The Lunar.\r\n4000.0 \"--sync--\" Ability { id: \"1C0C\", source: \"Diabolos\" } window 4000,1\r\n4009.9 \"Camisado\" Ability { id: \"1C0D\", source: \"Diabolos\" }\r\n4022.1 \"Nightmare\" Ability { id: \"1C0E\", source: \"Diabolos\" }\r\n4032.3 \"Ultimate Terror\" Ability { id: \"1C12\", source: \"Diabolos\" } window 15,5\r\n4050.5 \"Camisado\" Ability { id: \"1C0D\", source: \"Diabolos\" }\r\n4053.5 \"Noctoshield\" Ability { id: \"1C0F\", source: \"Diabolos\" } window 10,5\r\n4058.7 \"Nightmare\" Ability { id: \"1C0E\", source: \"Diabolos\" } window 10,5\r\n\r\n# This seems like a possible rotation? Maybe?\r\n4064.9 \"Camisado\" Ability { id: \"1C0D\", source: \"Diabolos\" }\r\n4075.2 \"Camisado\" Ability { id: \"1C0D\", source: \"Diabolos\" }\r\n4078.4 \"Noctoshield\" Ability { id: \"1C0F\", source: \"Diabolos\" }\r\n4083.4 \"Nightmare\" Ability { id: \"1C0E\", source: \"Diabolos\" } window 10,5 jump 4058.7\r\n\r\n4089.6 \"Camisado\"\r\n4099.9 \"Camisado\"\r\n4103.1 \"Noctoshield\"\r\n4108.1 \"Nightmare\"\r\n\r\n4149.0 \"--sync--\" StartsUsing { id: \"1C10\", source: \"Diabolos\" } window 150,5\r\n4163.7 \"Ruinous Omen\" Ability { id: \"1C10\", source: \"Diabolos\" }\r\n4164.7 \"Ruinous Omen\" Ability { id: \"1C11\", source: \"Diabolos\" }\r\n\r\n4170.3 \"Camisado\" Ability { id: \"1C0D\", source: \"Diabolos\" }\r\n4178.7 \"Night Terror\" Ability { id: \"1C13\", source: \"Diabolos\" }\r\n4185.8 \"Ultimate Terror\" Ability { id: \"1C12\", source: \"Diabolos\" }\r\n4190.0 \"Camisado\" Ability { id: \"1C0D\", source: \"Diabolos\" }\r\n4195.1 \"Camisado\" Ability { id: \"1C0D\", source: \"Diabolos\" }\r\n4203.5 \"Nightmare\" Ability { id: \"1C0E\", source: \"Diabolos\" }\r\n4206.6 \"Camisado\" Ability { id: \"1C0D\", source: \"Diabolos\" }\r\n4213.1 \"Camisado\" Ability { id: \"1C0D\", source: \"Diabolos\" }\r\n4216.2 \"Noctoshield\" Ability { id: \"1C0F\", source: \"Diabolos\" }\r\n4219.3 \"Camisado\" Ability { id: \"1C0D\", source: \"Diabolos\" }\r\n4225.8 \"Camisado\" Ability { id: \"1C0D\", source: \"Diabolos\" }\r\n\r\n4233.8 \"Ultimate Terror\" Ability { id: \"1C12\", source: \"Diabolos\" } window 15,15 jump 4185.8\r\n4238.9 \"Camisado\"\r\n4244.0 \"Camisado\"\r\n4252.4 \"Nightmare\"\r\n4255.5 \"Camisado\"\r\n4262.0 \"Camisado\"\r\n\r\n# This section leads directly into Diabolos Hollow the first time after Diabolos is defeated.\r\n# This is the dueling-lasers part where the party kills the big deathgate and two small ones.\r\n\r\n4274.0 \"--sync--\" NameToggle { name: \"Diabolos\", toggle: \"00\" } window 100,5\r\n4286.2 \"--lifegate spawn--\" AddedCombatant { name: \"Lifegate\" } window 300,5\r\n4300.0 \"--sync--\" Ability { id: \"1C16\", source: \"Diabolos\" } window 300,5\r\n4320.0 \"--deathgate spawn--\" AddedCombatant { name: \"Deathgate\" } window 50,5\r\n4477.1 \"--sync--\" Ability { id: \"1AFB\", source: \"Diabolos\" } window 177,5\r\n4488.5 \"--sync--\" Ability { id: \"1AFD\", source: \"Diabolos\" }\r\n4494.6 \"Dream Shroud\" Ability { id: \"1DB1\", source: \"Diabolos Hollow\" } window 194,5\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~#\r\n# DIABOLOS HOLLOW #\r\n#~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 1C1B 1C2A\r\n# ic 'Voidgate\" \"Shadowsphere\" \"Diabolic Gate\" \"Deathgate\" \"Shadow Dahak\" \"Shadow Hound\"\r\n\r\n# This fight will normally begin immediately after Diabolos.\r\n# However, if an encounter with Diabolos Hollow fails,\r\n# the fight will resume here, rather than back at Diabolos.\r\n\r\n\r\n# As with Diabolos, we sync to an attack to start the timeline.\r\n# The attacks aren't always so cleanly distributed,\r\n# so we sync with wider windows than normal.\r\n\r\n# This first rotation block last until the initial zero-damage shield breaks.\r\n4500.9 \"--sync--\" Ability { id: \"1E3E\", source: \"Diabolos Hollow\" } window 4501,1\r\n4507.9 \"Hollow Camisado\" Ability { id: \"1C19\", source: \"Diabolos Hollow\" } window 5,5\r\n4516.2 \"Shadethrust\" Ability { id: \"1C1A\", source: \"Diabolos Hollow\" } window 5,5\r\n4523.6 \"Hollow Camisado\" Ability { id: \"1C19\", source: \"Diabolos Hollow\" } window 5,5\r\n4530.8 \"Shadethrust\" Ability { id: \"1C1A\", source: \"Diabolos Hollow\" } window 5,5\r\n\r\n4540.1 \"Hollow Camisado\" Ability { id: \"1C19\", source: \"Diabolos Hollow\" } window 5,5 jump 4507.9\r\n4547.2 \"Shadethrust\"\r\n4554.6 \"Hollow Camisado\"\r\n4561.8 \"Shadethrust\"\r\n4571.1 \"Hollow Camisado\"\r\n4578.2 \"Shadethrust\"\r\n\r\n# Presumably Nox is the first indication of Diabolos' shield breaking.\r\n# At 75%, Diabolos Hollow pushes Hollowshield,\r\n# replacing/delaying? whichever mechanic happens to be next.\r\n\r\n# Lots of possible pushes here, unknown what triggers them.\r\n# If not pushed, it *appears* this section flows naturally.\r\n4600.0 \"Nox x5\" Ability { id: \"1C1C\", source: \"Diabolos Hollow\" } window 100,5\r\n4604.2 \"Hollow Night\" Ability { id: \"1C1D\", source: \"Diabolos Hollow\" }\r\n4613.6 \"Shadethrust\" Ability { id: \"1C1A\", source: \"Diabolos Hollow\" }\r\n4620.4 \"Particle Beam\" Ability { id: \"1C2[456]\", source: \"Diabolos Hollow\" }\r\n4620.8 \"Hollow Camisado\" Ability { id: \"1C19\", source: \"Diabolos Hollow\" }\r\n4624.1 \"--deathgate spawn--\" AddedCombatant { name: \"Deathgate\" } window 25,5\r\n4627.1 \"Hollowshield\" Ability { id: \"1C1E\", source: \"Diabolos Hollow\" } window 27.1,5\r\n4637.5 \"Hollow Camisado\" Ability { id: \"1C19\", source: \"Diabolos Hollow\" }\r\n4646.8 \"Shadethrust\" Ability { id: \"1C1A\", source: \"Diabolos Hollow\" } window 20,10\r\n\r\n4654.9 \"Pavor Inanis\" Ability { id: \"1C1F\", source: \"Diabolos Hollow\" } window 55,5\r\n4665.3 \"Hollow Night\" Ability { id: \"1C1D\", source: \"Diabolos Hollow\" }\r\n4677.4 \"Hollow Nightmare\" Ability { id: \"1C20\", source: \"Diabolos Hollow\" }\r\n4690.9 \"Hollow Camisado\" Ability { id: \"1C19\", source: \"Diabolos Hollow\" } window 30,5\r\n4700.2 \"Nox x5\" Ability { id: \"1C1C\", source: \"Diabolos Hollow\" } window 30,5\r\n4705.2 \"Hollow Nightmare\" Ability { id: \"1C20\", source: \"Diabolos Hollow\" }\r\n4718.4 \"Hollow Camisado\" Ability { id: \"1C19\", source: \"Diabolos Hollow\" }\r\n4727.6 \"Hollow Terror\" Ability { id: \"1C21\", source: \"Diabolos Hollow\" }\r\n4737.2 \"Shadethrust\" Ability { id: \"1C1A\", source: \"Diabolos Hollow\" } window 20,5\r\n4751.0 \"Shadethrust\" Ability { id: \"1C1A\", source: \"Diabolos Hollow\" }\r\n4753.5 \"Particle Beam\" Ability { id: \"1C2[456]\", source: \"Diabolos Hollow\" }\r\n4760.3 \"Pavor Inanis\" Ability { id: \"1C1F\", source: \"Diabolos Hollow\" } window 30,30\r\n4766.6 \"Hollow Camisado\" Ability { id: \"1C19\", source: \"Diabolos Hollow\" }\r\n4774.9 \"Nightmare/Terror\" Ability { id: \"1C2[01]\", source: \"Diabolos Hollow\" }\r\n\r\n\r\n# Can push early at 50% HP\r\n4785.3 \"--sync--\" Ability { id: \"1C18\", source: \"Diabolos Hollow\" } window 785,5\r\n4804.1 \"--sync--\" Ability { id: \"1C22\", source: \"Diabolos Hollow\" }\r\n4809.2 \"Hollow Omen\" Ability { id: \"1C23\", source: \"Diabolos Hollow\" }\r\n4818.3 \"Double Edge\" Ability { id: \"1C2B\", source: \"Diabolos Hollow\" }\r\n\r\n4825.6 \"Blindside\" Ability { id: \"1C28\", source: \"Diabolos Hollow\" }\r\n4828.7 \"--sync--\" Ability { id: \"1C18\", source: \"Diabolos Hollow\" }\r\n4836.0 \"Earth Shaker\" Ability { id: \"1C29\", source: \"Diabolos Hollow\" } window 15,15\r\n4844.0 \"Blindside\" Ability { id: \"1C28\", source: \"Diabolos Hollow\" }\r\n4852.2 \"Blindside\" Ability { id: \"1C28\", source: \"Diabolos Hollow\" }\r\n4855.4 \"--sync--\" Ability { id: \"1C18\", source: \"Diabolos Hollow\" }\r\n4862.7 \"Earth Shaker\" Ability { id: \"1C29\", source: \"Diabolos Hollow\" }\r\n\r\n4870.8 \"Blindside\" Ability { id: \"1C28\", source: \"Diabolos Hollow\" } window 10,5 jump 4825.6\r\n4881.2 \"Earth Shaker\"\r\n4889.2 \"Blindside\"\r\n4897.4 \"Blindside\"\r\n4907.9 \"Earth Shaker\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/alliance/weeping_city.ts



const weeping_city_triggerSet = {
  id: 'TheWeepingCityOfMhach',
  zoneId: zone_id/* default.TheWeepingCityOfMhach */.Z.TheWeepingCityOfMhach,
  timelineFile: 'weeping_city.txt',
  timelineTriggers: [{
    id: 'Weeping City Dark Spike',
    regex: /Dark Spike/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Weeping City Widow\'s Kiss',
    regex: /The Widow's Kiss/,
    beforeSeconds: 5,
    // Probably kills the player if failed, so it gets an alert.
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand on webs',
        de: 'Auf den Spinnennetzen stehen',
        fr: 'Placez-vous dans les toiles',
        ja: 'アンキレーウェブに入る',
        cn: '站在网上',
        ko: '거미줄 위에 서기'
      }
    }
  }, {
    id: 'Weeping City Punishing Ray',
    regex: /Punishing Ray/,
    beforeSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Puddles',
        de: 'Flächen nehmen',
        fr: 'Allez dans les zones au sol',
        ja: '踏む',
        cn: '踩圈',
        ko: '바닥 장판 밟기'
      }
    }
  }, {
    id: 'Weeping City Bloodied Nail',
    regex: /Bloodied Nail/,
    beforeSeconds: 4,
    suppressSeconds: 10,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Weeping City Split End',
    regex: /Split End/,
    beforeSeconds: 4,
    suppressSeconds: 10,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Weeping City Aura Burst',
    regex: /Aura Burst/,
    beforeSeconds: 4,
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  triggers: [{
    // 2 of the 4 encounters in Weeping City use the 0017 head marker.
    // 2 of the 4 use the 003E head marker.
    // Because of this, we restrict those triggers for each boss to activate
    // only when that boss is in progress.
    id: 'Weeping City HeadMarker Arachne',
    type: 'SystemLogMessage',
    // The Queen's Room will be sealed off
    netRegex: {
      id: '7DC',
      param1: '6E0',
      capture: false
    },
    run: data => data.arachneStarted = true
  }, {
    id: 'Weeping City HeadMarker Ozma',
    type: 'SystemLogMessage',
    // The Gloriole will be sealed off
    netRegex: {
      id: '7DC',
      param1: '6E5',
      capture: false
    },
    run: data => {
      data.arachneStarted = false;
      data.ozmaStarted = true;
    }
  }, {
    id: 'Weeping City HeadMarker Calofisteri',
    type: 'SystemLogMessage',
    // The Tomb Of The Nullstone will be sealed off
    netRegex: {
      id: '7DC',
      param1: '6E6',
      capture: false
    },
    run: data => {
      data.ozmaStarted = false;
      data.calStarted = true;
    }
  }, {
    id: 'Weeping City Sticky Wicket',
    type: 'HeadMarker',
    netRegex: {
      id: '003C',
      capture: false
    },
    suppressSeconds: 10,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Weeping City Shadow Burst',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    condition: data => data.arachneStarted,
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Weeping City Frond Affeared',
    type: 'StartsUsing',
    netRegex: {
      id: '183A',
      source: 'Arachne Eve',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Weeping City Arachne Web',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: (data, matches) => data.arachneStarted && data.me === matches.target,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Web Outside',
        de: 'Spinnennetz draußen ablegen',
        fr: 'Déposez les toiles à l\'extérieur',
        ja: 'ウェブを外周に捨てる',
        cn: '蛛网点名，放在场边',
        ko: '거미줄 바깥쪽으로 빼기'
      }
    }
  }, {
    id: 'Weeping City Brand Of The Fallen',
    type: 'HeadMarker',
    netRegex: {
      id: '0037'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.doritoStack */.n3.doritoStack()
  }, {
    id: 'Weeping City Dark Eruption',
    type: 'HeadMarker',
    netRegex: {
      id: '0019'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Puddles on YOU',
        de: 'Pfützen auf DIR',
        fr: 'Zones au sol sur VOUS',
        ja: '自分に床範囲',
        cn: '圈圈点名',
        ko: '장판 바깥에 깔기'
      }
    }
  }, {
    id: 'Weeping City Beguiling Mist',
    type: 'StartsUsing',
    netRegex: {
      id: '17CE',
      source: 'Summoned Succubus'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Weeping City Mortal Ray',
    type: 'StartsUsing',
    netRegex: {
      id: '17D4',
      source: 'Summoned Haagenti'
    },
    response: responses/* Responses.lookAwayFromSource */.n3.lookAwayFromSource()
  }, {
    id: 'Weeping City Hell Wind',
    type: 'StartsUsing',
    netRegex: {
      id: '17CB',
      source: 'Forgall',
      capture: false
    },
    // Hell Wind sets HP to single digits, so mitigations don't work. Don't notify non-healers.
    condition: data => data.role === 'healer' || data.job === 'BLU',
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Weeping City Mega Death',
    type: 'StartsUsing',
    netRegex: {
      id: '17CA',
      source: 'Forgall',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in one puddle',
        de: 'In einer Fläche stehen',
        fr: 'Placez-vous dans une zone au sol',
        ja: '範囲に入る',
        cn: '站在圈里',
        ko: '장판 하나만 밟기'
      }
    }
  }, {
    id: 'Weeping City Meteor Impact',
    type: 'HeadMarker',
    netRegex: {
      id: '0039'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop meteor back or left',
        de: 'Meteor hinten oder links ablegen',
        fr: 'Déposez le météore derrière ou à gauche',
        ja: 'メテオ、後ろや左に置く',
        cn: '流星点名，放在背后或左边',
        ko: '메테오 뒤/왼쪽으로 빼기'
      }
    }
  }, {
    // The ability used here is Ozma entering Pyramid form.
    // Execration follows this up almost immediately.
    id: 'Weeping City Execration',
    type: 'Ability',
    netRegex: {
      id: '1826',
      source: 'Ozma',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get off rectangle platform',
        de: 'Von der plattform runter gehen',
        fr: 'Descendez de la plateforme rectangle',
        ja: '通路で回避',
        cn: '离开平台',
        ko: '통로로 이동'
      }
    }
  }, {
    // The ability used here is Ozma entering Cube form.
    // Flare Star and tank lasers follow shortly.
    id: 'Weeping City Flare Star Ring',
    type: 'Ability',
    netRegex: {
      id: '1803',
      source: 'Ozma',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    // The ability used here is Ozma entering Cube form. The actual laser ability, 1831,
    // is literally named "attack". Ozma zaps the 3 highest-threat targets. (Not always tanks!)
    // This continues until the next Sphere form, whether by time or by HP push.
    id: 'Weeping City Tank Lasers',
    type: 'Ability',
    netRegex: {
      id: '1803',
      source: 'Ozma',
      capture: false
    },
    // Delaying here to avoid colliding with other Flare Star triggers.
    delaySeconds: 4,
    alertText: (data, _matches, output) => {
      if (data.role === 'tank') return output.tankLasers();
      return output.avoidTanks();
    },
    outputStrings: {
      tankLasers: {
        en: 'Tank lasers--Avoid party',
        de: 'Tank lasers--Weg von der Party',
        fr: 'Tank lasers - Évitez le groupe',
        ja: 'タンクレーザー - 外に',
        cn: '坦克激光--远离人群',
        ko: '탱커 레이저-- 파티원 피하기'
      },
      avoidTanks: {
        en: 'Avoid tanks',
        de: 'Weg von den Tanks',
        fr: 'Évitez les tanks',
        ja: 'タンクから離れる',
        cn: '远离坦克',
        ko: '탱커 피하기'
      }
    }
  }, {
    // The NPC name is Ozmasphere. These need to be popped just like any other Flare Star.
    // Failing to pop an orb means it will explode, dealing damage with 1808 Aethernova.
    id: 'Weeping City Flare Star Orbs',
    type: 'AddedCombatant',
    netRegex: {
      npcBaseId: '4889',
      capture: false
    },
    condition: data => data.role === 'tank' || data.role === 'healer' || data.job === 'BLU',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get orbs',
        de: 'Kugeln nehmen',
        fr: 'Prenez les orbes',
        ja: '玉を取る',
        cn: '撞球',
        ko: '구슬 부딪히기'
      }
    }
  }, {
    id: 'Weeping City Acceleration Bomb',
    type: 'GainsEffect',
    netRegex: {
      effectId: '430'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 3,
    response: responses/* Responses.stopEverything */.n3.stopEverything()
  }, {
    id: 'Weeping City Assimilation',
    type: 'StartsUsing',
    netRegex: {
      id: '1802',
      source: 'Ozmashade',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    // Each party gets a stack marker, so this is the best we can do.
    id: 'Weeping City Meteor Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E',
      capture: false
    },
    condition: data => data.ozmaStarted,
    suppressSeconds: 5,
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }, {
    // Coif Change is always followed up shortly by Haircut.
    // There's no castbar or indicator except that she grows a scythe on one side.
    // It's not a very obvious visual cue unless the player knows to look for it.
    id: 'Weeping City Coif Change Left',
    type: 'Ability',
    netRegex: {
      id: '180A',
      source: 'Calofisteri',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Weeping City Coif Change Right',
    type: 'Ability',
    netRegex: {
      id: '180E',
      source: 'Calofisteri',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    // 4899 is the base ID for bulb hair. 4900 is axe hair.
    // Bulbs do a circle AoE surrounding them, while axes are a donut.
    id: 'Weeping City Living Lock Axes',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: ['4899', '4900'],
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Close to axes, avoid bulbs',
        de: 'Nahe den Äxten, vermeide Knospen',
        fr: 'Restez proche des haches, évitez les bulbes',
        ja: '刃物の髪に近づき、丸い髪から離れる',
        cn: '靠近斧状发，远离球状发',
        ko: '도끼모양에 붙고, 둥근모양은 피하기'
      }
    }
  }, {
    id: 'Weeping City Living Lock Scythes',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '4898',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid scythe line AoEs',
        de: 'Weiche den Sensen AOEs aus',
        fr: 'Évitez les AoEs en lignes des faux',
        ja: '十字AoE',
        cn: '躲避镰刀直线AOE',
        ko: '직선 장판 피하기'
      }
    }
  }, {
    // These adds are the purple circles waiting to grab people and Garrotte them.
    id: 'Weeping City Entanglement',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '4904',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid purple circles',
        de: 'Vermeide die lilanen Flächen',
        fr: 'Évitez les cercles violets',
        ja: '紫の円範囲を避ける',
        cn: '远离紫圈',
        ko: '보라색 원 피하기'
      }
    }
  }, {
    // If by some chance someone actually did stand in the purple circles, break them out.
    // The actual ability here is an Unknown ability, but it begins slightly before Garrotte.
    id: 'Weeping City Garrotte',
    type: 'Ability',
    netRegex: {
      id: '181D',
      source: 'Entanglement',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.killExtraAdd */.n3.killExtraAdd()
  }, {
    id: 'Weeping City Particle Beam',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: data => data.calStarted,
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.skyLaserOnYou();
      return output.avoidSkyLasers();
    },
    outputStrings: {
      skyLaserOnYou: {
        en: '16x Sky Laser on YOU!',
        de: '16x Himmelslaser auf DIR!',
        fr: '16x Lasers du ciel sur VOUS',
        ja: '自分に16連撃潜地式波動砲！',
        cn: '16连追踪AOE点名',
        ko: '16 추적 레이저 대상자'
      },
      avoidSkyLasers: {
        en: 'Avoid Sky Lasers',
        de: 'Himmelslaser ausweichen',
        fr: 'Évitez les lasers du ciel',
        ja: '潜地式波動砲を避ける',
        cn: '躲避追踪AOE',
        ko: '추적 레이저 피하기'
      }
    }
  }, {
    // The actual ability here is Mana Drain, which ends the intermission.
    // Dancing Mad follows this up closely enough to make this the best time to notify.
    id: 'Weeping City Dancing Mad',
    type: 'Ability',
    netRegex: {
      id: '1819',
      source: 'Calofisteri',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Weeping City Penetration',
    type: 'StartsUsing',
    netRegex: {
      id: '1822',
      source: 'Calofisteri',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Weeping City Depth Charge',
    type: 'StartsUsing',
    netRegex: {
      id: '1820',
      source: 'Calofisteri',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Arachne Eve': 'Arachne (?:der|die|das) Ahnin',
      'Calofisteri': 'Calofisteri',
      'Entanglement': 'Verfilzung',
      'Forgall': 'Forgall',
      'Living Lock': 'lebend(?:e|er|es|en) Locke',
      'Ozma(?!shade)': 'Yadis',
      'Ozmashade': 'Yadis-Schatten',
      'Poison Mist': 'Giftnebel',
      'Shriveled Talon': 'verschrumpelt(?:e|er|es|en) Harpyie',
      'Singularity Fragment': 'Singularitätsfragment',
      'Summoned Haagenti': 'beschworen(?:e|er|es|en) Haagenti',
      'Summoned Succubus': 'beschworen(?:e|er|es|en) Sukkubus',
      'The Gloriole': 'Aureole',
      'The Queen\'s Room': 'Spinnenfalle',
      'The Shrine Of The Goetic': 'Altar der Goëtie',
      'The Tomb Of The Nullstone': 'Kammer des Nullsteins'
    },
    'replaceText': {
      'Acceleration Bomb': 'Beschleunigungsbombe',
      'Arachne Web': 'Arachne-Netz',
      'Aura Burst': 'Auraknall',
      'Black Hole': 'Schwarzes Loch',
      'Bloodied Nail': 'Blutiger Nagel',
      'Brand of the Fallen': 'Brandzeichen der Opferung',
      'Coif Change': 'Typveränderung',
      'Cube': 'Kubus',
      'Dancing Mad': 'Wilder Tanz',
      'Dark Eruption': 'Dunkle Eruption',
      'Dark Spike': 'Dunkler Stachel',
      'Depth Charge': 'Tiefenangriff',
      'Evil Curl': 'Böse Locke',
      'Evil Mist': 'Bösartiger Nebel',
      'Evil Switch': 'Böse Strähne',
      'Evil Tress': 'Böse Mähne',
      'Execration': 'Exsekration',
      '(?<! )Explosion': 'Explosion',
      'Extension': 'Strähnchen',
      'Feint Particle Beam': 'Schein-Partikelstrahl',
      'Flare Star': 'Flare-Stern',
      'Frond Affeared': 'Antlitz der Angst',
      'Haircut': 'Haarschnitt',
      'Hell Wind': 'Höllenwind',
      'Holy': 'Sanctus',
      'Implosion': 'Implosion',
      'Mana Drain': 'Magische Anziehung',
      'Mana Explosion': 'Mana-Explosion',
      'Mega Death': 'Megatod',
      'Megiddo Flame': 'Megiddoflamme',
      'Meteor(?![\\w\\s])': 'Meteor',
      'Meteor Headmarkers': 'Meteor Markierungen',
      'Meteor Impact': 'Meteoreinschlag',
      'Necropurge': 'Nekrobuße',
      'Penetration': 'Durchdringen',
      'Pitfall': 'Berstender Boden',
      'Punishing Ray': 'Strafender Strahl',
      'Pyramid': 'Pyramide',
      'Shadow Burst': 'Schattenstoß',
      'Silken Spray': 'Seidengespinst',
      'Sphere': 'Kugel',
      'Split End': 'Gespaltene Spitzen',
      'Sticky Wicket': 'Klebfadenfetzen',
      'Tank Lasers': 'Tank Laser',
      'The Widow\'s Embrace': 'Eiserne Umgarnung',
      'The Widow\'s Kiss': 'Seidige Umgarnung',
      'Transfiguration': 'Transfiguration',
      'Tremblor': 'Erdbeben'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Arachne Eve': 'Arachné mère',
      'Calofisteri': 'Calofisteri',
      'Entanglement': 'emmêlement',
      'Forgall': 'Forgall',
      'Living Lock': 'mèche animée',
      'Ozma(?!shade)': 'Ozma',
      'Ozmashade': 'ombre d\'Ozma',
      'Poison Mist': 'Brume empoisonnée',
      'Shriveled Talon': 'dépouille de Harpie féroce',
      'Singularity Fragment': 'fragment de singularité',
      'Summoned Haagenti': 'haagenti adjuré',
      'Summoned Succubus': 'succube adjuré',
      'The Gloriole': 'Hauteurs de la pyramide',
      'The Queen\'s Room': 'Domaine de la Tisseuse',
      'The Shrine Of The Goetic': 'Sanctuaire du Goétique',
      'The Tomb Of The Nullstone': 'Tombeau de la Clef de voûte'
    },
    'replaceText': {
      '\\?': ' ?',
      'Acceleration Bomb': 'Bombe accélératrice',
      'Arachne Web': 'Toile d\'Arachné',
      'Aura Burst': 'Déflagration d\'aura',
      'Black Hole': 'Trou noir',
      'Bloodied Nail': 'Ongles sanglants',
      'Brand of the Fallen': 'Marque des déchus',
      'Coif Change': 'Recoiffage',
      'Cube': 'Cube',
      'Dancing Mad': 'Danse effrénée',
      'Dark Eruption': 'Éruption ténébreuse',
      'Dark Spike': 'Pointe ténébreuse',
      'Depth Charge': 'Charge des profondeurs',
      'Evil Curl': 'Boucle maléfique',
      'Evil Mist': 'Brume maléfique',
      'Evil Switch': 'Fouetté maléfique',
      'Evil Tress': 'Tresse maléfique',
      'Execration': 'Exécration',
      '(?<! )Explosion': 'Explosion',
      'Extension': 'Extension',
      'Feint Particle Beam': 'Rayon pénétrant',
      'Flare Star': 'Astre flamboyant',
      'Frond Affeared': 'Fronde effrayante',
      'Haircut': 'Coupe de cheveux',
      'Hell Wind': 'Vent infernal',
      'Holy': 'Miracle',
      'Implosion': 'Implosion',
      'Mana Drain': 'Inspiration de magie',
      'Mana Explosion': 'Explosion de mana',
      'Mega Death': 'Mégamort',
      'Megiddo Flame': 'Flamme de Megiddo',
      'Meteor(?![\\w\\s])': 'Météore',
      'Meteor Headmarkers': 'Marqueurs de météores',
      'Meteor Impact': 'Impact de météore',
      'Necropurge': 'Nécropurge',
      'Penetration': 'Pénétration',
      'Pitfall': 'Embûche',
      'Punishing Ray': 'Rayon punitif',
      'Pyramid': 'Pyramide',
      'Shadow Burst': 'Salve ténébreuse',
      'Silken Spray': 'Aspersion de soie',
      'Sphere': 'Sphère',
      'Split End': 'Pointes fourchues',
      'Sticky Wicket': 'Projectile collant',
      'Tank Lasers': 'Tank lasers',
      'The Widow\'s Embrace': 'Gravité arachnéenne',
      'The Widow\'s Kiss': 'Attraction arachnéenne',
      'Transfiguration': 'Transmutation',
      'Tremblor': 'Tremblement de terre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Arachne Eve': 'アルケニー',
      'Calofisteri': 'カロフィステリ',
      'Forgall': 'フォルガル',
      'Entanglement': '魔髪の縛め',
      'Living Lock': 'カロフィステリの魔髪',
      'Ozma(?!shade)': 'オズマ',
      'Ozmashade': 'オズマの影',
      'Poison Mist': '毒霧',
      'Shriveled Talon': '大鷲連合の遺骸',
      'Singularity Fragment': '圧縮世界の断片',
      'Summoned Haagenti': 'サモン・ハーゲンティ',
      'Summoned Succubus': 'サモン・サキュバス',
      'The Gloriole': 'ピラミッド上部層',
      'The Queen\'s Room': '蜘蛛女の狩場',
      'The Shrine Of The Goetic': '神託の祭壇',
      'The Tomb Of The Nullstone': '要の玄室'
    },
    'replaceText': {
      'Acceleration Bomb': '加速度爆弾',
      'Arachne Web': 'アンキレーウェブ',
      'Aura Burst': 'オーラバースト',
      'Black Hole': 'ブラックホール',
      'Bloodied Nail': 'ブラッディネイル',
      'Brand of the Fallen': '生贄の烙印',
      'Coif Change': '魔髪変化',
      'Cube': '立方体状態',
      'Dancing Mad': 'ダンシングマッド',
      'Dark Eruption': 'ダークエラプション',
      'Dark Spike': 'ダークスパイク',
      'Depth Charge': 'デプスチャージ',
      'Evil Curl': 'イビルカール',
      'Evil Mist': 'イビルミスト',
      'Evil Switch': 'イビルスウィッチ',
      'Evil Tress': 'イビルトレス',
      'Execration': 'エクセクレイション',
      '(?<! )Explosion': '爆発',
      'Extension': 'エクステンション',
      'Feint Particle Beam': '潜地式波動砲',
      'Flare Star': 'フレアスター',
      'Frond Affeared': '恐怖のまなざし',
      'Haircut': 'ヘアカット',
      'Hell Wind': 'ヘルウィンド',
      'Holy': 'ホーリー',
      'Implosion': 'インプロージョン',
      'Mana Drain': '魔力吸引',
      'Mana Explosion': '魔力爆発',
      'Mega Death': 'オーバーデス',
      'Megiddo Flame': 'メギドフレイム',
      'Meteor(?![\\w\\s])': 'メテオ',
      'Meteor Headmarkers': 'メテオ マーキング',
      'Meteor Impact': 'メテオインパクト',
      'Necropurge': 'ネクロパージ',
      'Penetration': 'ペネトレーション',
      'Pitfall': '強襲',
      'Punishing Ray': 'パニッシュレイ',
      'Pyramid': '三角錐状態',
      'Shadow Burst': 'シャドウバースト',
      'Silken Spray': 'シルクスプレー',
      'Sphere': '球体状態',
      'Split End': 'スプリットエンド',
      'Sticky Wicket': 'スティッキーウィケット',
      'Tank Lasers': 'タンクレザー',
      'The Widow\'s Embrace': '蜘蛛の大罠',
      'The Widow\'s Kiss': '蜘蛛の罠',
      'Transfiguration': '形態変化',
      'Tremblor': '地震'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Arachne Eve': '阿剌克涅',
      'Calofisteri': '卡洛菲斯提莉',
      'Forgall': '弗加尔',
      'Entanglement': '魔发束缚',
      'Living Lock': '卡洛菲斯提莉的魔发',
      'Ozma(?!shade)': '奥兹玛',
      'Ozmashade': '奥兹玛之影',
      'Poison Mist': '毒雾',
      'Shriveled Talon': '猛禽联盟遗骸',
      'Singularity Fragment': '压缩世界的断片',
      'Summoned Haagenti': '被召唤出的哈加提',
      'Summoned Succubus': '被召唤出的梦魔',
      'The Gloriole': '金字塔上层',
      'The Queen\'s Room': '女王蛛猎场',
      'The Shrine Of The Goetic': '神谕祭坛',
      'The Tomb Of The Nullstone': '契约石玄室'
    },
    'replaceText': {
      'Acceleration Bomb': '加速度炸弹',
      'Arachne Web': '阿剌克涅之网',
      'Aura Burst': '灵气爆',
      'Black Hole': '黑洞',
      'Bloodied Nail': '血爪',
      'Brand of the Fallen': '祭品烙印',
      'Coif Change': '魔发变化',
      'Cube': '立方体形态',
      'Dancing Mad': '魔发狂舞',
      'Dark Eruption': '暗炎喷发',
      'Dark Spike': '暗之刺爪',
      'Depth Charge': '蓄力冲击',
      'Evil Curl': '罪恶发旋',
      'Evil Mist': '恶魔毒雾',
      'Evil Switch': '罪恶发钩',
      'Evil Tress': '罪恶发团',
      'Execration': '缩小射线',
      '(?<! )Explosion': '爆炸',
      'Extension': '接发',
      'Feint Particle Beam': '潜地式波动炮',
      'Flare Star': '耀星',
      'Frond Affeared': '恐惧视线',
      'Haircut': '魔发斩',
      'Hell Wind': '地狱之风',
      'Holy': '神圣',
      'Implosion': '向心聚爆',
      'Mana Drain': '魔力吸收',
      'Mana Explosion': '魔力爆炸',
      'Mega Death': '超即死',
      'Megiddo Flame': '米吉多烈焰',
      'Meteor(?![\\w\\s])': '陨石',
      'Meteor Headmarkers': '陨石点名',
      'Meteor Impact': '陨石冲击',
      'Necropurge': '死灵潜质',
      'Penetration': '透耳尖啸',
      'Pitfall': '强袭',
      'Punishing Ray': '惩戒之光',
      'Pyramid': '三角锥形态',
      'Shadow Burst': '暗影爆',
      'Silken Spray': '喷吐蛛丝',
      'Sphere': '球形态',
      'Split End': '发梢分裂',
      'Sticky Wicket': '粘液弹',
      'Tank Lasers': '坦克激光',
      'The Widow\'s Embrace': '大蜘蛛陷阱',
      'The Widow\'s Kiss': '蜘蛛陷阱',
      'Transfiguration': '形态变化',
      'Tremblor': '地震'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Arachne Eve': '아라크네',
      'Calofisteri': '칼로피스테리',
      'Forgall': '포르갈',
      'Entanglement': '머리카락 포박',
      'Living Lock': '칼로피스테리의 머리카락',
      'Ozma(?!shade)': '오즈마',
      'Ozmashade': '오즈마의 그림자',
      'Poison Mist': '독안개',
      'Shriveled Talon': '참수리연합 주검',
      'Singularity Fragment': '압축세계의 단편',
      'Summoned Haagenti': '소환된 하겐티',
      'Summoned Succubus': '소환된 서큐버스',
      'The Gloriole': '피라미드 상층부',
      'The Queen\'s Room': '거미 여왕의 사냥터',
      'The Shrine Of The Goetic': '신탁의 제단',
      'The Tomb Of The Nullstone': '쐐기 안치소'
    },
    'replaceText': {
      'Acceleration Bomb': '가속도 폭탄',
      'Arachne Web': '아라크네의 거미줄',
      'Aura Burst': '오라 폭발',
      'Black Hole': '블랙홀',
      'Bloodied Nail': '핏빛 손톱',
      'Brand of the Fallen': '산제물 낙인',
      'Coif Change': '머리카락 변화',
      'Cube': '사각형',
      'Dancing Mad': '춤추는 광기',
      'Dark Eruption': '황천의 불기둥',
      'Dark Spike': '어둠의 내리치기',
      'Depth Charge': '심연 돌격',
      'Evil Curl': '악마의 곱슬머리',
      'Evil Mist': '악마의 안개',
      'Evil Switch': '악마의 머리채',
      'Evil Tress': '악마의 땋은머리',
      'Execration': '혐오의 저주',
      '(?<! )Explosion': '폭발',
      'Extension': '머리카락 연장',
      'Feint Particle Beam': '위장형 파동포',
      'Flare Star': '타오르는 별',
      'Frond Affeared': '섬뜩한 시선',
      'Haircut': '머리카락 참격',
      'Hell Wind': '황천의 바람',
      'Holy': '홀리',
      'Implosion': '내파',
      'Mana Drain': '마력 흡입',
      'Mana Explosion': '마력 폭발',
      'Mega Death': '범람하는 죽음',
      'Megiddo Flame': '메기도 플레임',
      'Meteor(?![\\w\\s])': '메테오',
      'Meteor Headmarkers': '메테오 머리징',
      'Meteor Impact': '운석 낙하',
      'Necropurge': '사령 침잠',
      'Penetration': '침투',
      'Pitfall': '강습',
      'Punishing Ray': '응징의 빛줄기',
      'Pyramid': '삼각형',
      'Shadow Burst': '그림자 폭발',
      'Silken Spray': '거미줄 분사',
      'Sphere': '원',
      'Split End': '쪼개기',
      'Sticky Wicket': '끈끈이 구멍',
      'Tank Lasers': '탱 레이저',
      'The Widow\'s Embrace': '큰거미의 포옹',
      'The Widow\'s Kiss': '거미 덫',
      'Transfiguration': '형태 변화',
      'Tremblor': '지진'
    }
  }]
};
/* harmony default export */ const weeping_city = (weeping_city_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/alliance/weeping_city.txt
const alliance_weeping_city_namespaceObject = "### THE WEEPING CITY OF MHACH\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~~~~~#\r\n# ARACHNE EVE #\r\n#~~~~~~~~~~~~~#\r\n\r\n# -ii 368 1835 1836\r\n# -ic \"Webmaiden\" \"Spitting Spider\" \"Skittering Spider\" \"Earth Aether\"\r\n\r\n# The Queen's Room will be sealed off\r\n0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"6E0\" }\r\n9.8 \"Dark Spike\" Ability { id: \"1823\", source: \"Arachne Eve\" }\r\n21.6 \"Silken Spray\" Ability { id: \"1824\", source: \"Arachne Eve\" }\r\n30.4 \"Arachne Web x3\" duration 5 # Ability { id: \"185E\", source: \"Arachne Eve\" }\r\n36.8 \"--untargetable--\"\r\n41.9 \"Tremblor x3\" Ability { id: \"1837\", source: \"Arachne Eve\" } # 3 separate abilities, 1837/1836/1835\r\n48.4 \"--sync--\" Ability { id: \"1889\", source: \"Arachne Eve\" }\r\n49.9 \"Pitfall\" Ability { id: \"1825\", source: \"Arachne Eve\" }\r\n51.9 \"--targetable--\"\r\n52.1 \"--sync--\" Ability { id: \"1847\", source: \"Arachne Eve\" } # Sticky Wicket head markers\r\n55.7 \"Sticky Wicket x3\" # Ability { id: \"183F\", source: \"Arachne Eve\" }\r\n64.1 \"Silken Spray\" Ability { id: \"1824\", source: \"Arachne Eve\" }\r\n\r\n# Intermission up in her web. There's a LOT of stuff going on here,\r\n# but the add spawns and abilities are dependent on what the team kills.\r\n# Implosion is the only real consistency we have through the intermission.\r\n95.7 \"Implosion\" Ability { id: \"1833\", source: \"Arachne Eve\" } window 95.7,2.5\r\n113.9 \"Implosion\" Ability { id: \"1833\", source: \"Arachne Eve\" }\r\n132.1 \"Implosion\" Ability { id: \"1833\", source: \"Arachne Eve\" }\r\n150.3 \"Implosion\" Ability { id: \"1833\", source: \"Arachne Eve\" } jump 95.7\r\n168.5 \"Implosion\"\r\n186.7 \"Implosion\"\r\n\r\n# Back on the ground for a relatively short bridge block\r\n# We sync to a 14/20 startsUsing log line instead of a 15/21 ability line.\r\n# This lets us jump out of the intermission slightly earlier.\r\n197.3 \"Dark Spike\" StartsUsing { id: \"1823\", source: \"Arachne Eve\" } window 100,5\r\n206.3 \"--sync--\" Ability { id: \"1847\", source: \"Arachne Eve\" }\r\n210.5 \"Sticky Wicket x3\" # Ability { id: \"183F\", source: \"Arachne Eve\" }\r\n212.1 \"--untargetable--\"\r\n216.7 \"Tremblor x3\" Ability { id: \"1837\", source: \"Arachne Eve\" }\r\n223.9 \"--sync--\" Ability { id: \"1889\", source: \"Arachne Eve\" }\r\n225.5 \"Pitfall\" Ability { id: \"1825\", source: \"Arachne Eve\" }\r\n227.5 \"--targetable--\"\r\n233.2 \"Arachne Web x3\" duration 5 # Ability { id: \"185E\", source: \"Arachne Eve\" }\r\n246.3 \"Shadow Burst\" Ability { id: \"1838\", source: \"Arachne Eve\" }\r\n253.0 \"Dark Spike\" Ability { id: \"1823\", source: \"Arachne Eve\" }\r\n264.4 \"Frond Affeared\" Ability { id: \"183A\", source: \"Arachne Eve\" } window 30,30\r\n271.1 \"Silken Spray\" Ability { id: \"1824\", source: \"Arachne Eve\" }\r\n277.9 \"Dark Spike\" Ability { id: \"1823\", source: \"Arachne Eve\" }\r\n287.7 \"Arachne Web x3\" duration 5 # Ability { id: \"185E\", source: \"Arachne Eve\" }\r\n294.2 \"--untargetable--\"\r\n297.9 \"The Widow's Kiss\" duration 5 # Ability { id: \"1842\", source: \"Arachne Eve\" }\r\n305.9 \"The Widow's Embrace\" Ability { id: \"1888\", source: \"Arachne Eve\" }\r\n308.5 \"Pitfall\" Ability { id: \"1845\", source: \"Arachne Eve\" }\r\n310.5 \"--targetable--\"\r\n317.2 \"Dark Spike\" Ability { id: \"1823\", source: \"Arachne Eve\" }\r\n\r\n# And up we go again.\r\n347.2 \"Implosion\" Ability { id: \"1833\", source: \"Arachne Eve\" } window 147,5\r\n365.4 \"Implosion\" Ability { id: \"1833\", source: \"Arachne Eve\" }\r\n383.6 \"Implosion\" Ability { id: \"1833\", source: \"Arachne Eve\" } jump 347.2\r\n401.8 \"Implosion\"\r\n420.0 \"Implosion\"\r\n\r\n# Back down again for another bridge block\r\n464.9 \"Dark Spike\" Ability { id: \"1823\", source: \"Arachne Eve\" } window 120,5\r\n476.4 \"Arachne Web x3\" duration 5 # Ability { id: \"185E\", source: \"Arachne Eve\" }\r\n483.8 \"--sync--\" Ability { id: \"1847\", source: \"Arachne Eve\" }\r\n487.4 \"Sticky Wicket x3\" # Ability { id: \"183F\", source: \"Arachne Eve\" }\r\n489.8 \"--untargetable--\"\r\n494.4 \"Tremblor x3\" Ability { id: \"1837\", source: \"Arachne Eve\" }\r\n501.3 \"The Widow's Kiss x3\" duration 5 # Ability { id: \"1842\", source: \"Arachne Eve\" }\r\n509.3 \"The Widow's Embrace\" Ability { id: \"1888\", source: \"Arachne Eve\" }\r\n511.9 \"Pitfall\" Ability { id: \"1845\", source: \"Arachne Eve\" }\r\n513.9 \"--targetable--\"\r\n520.6 \"Dark Spike\" Ability { id: \"1823\", source: \"Arachne Eve\" }\r\n526.4 \"Silken Spray\" Ability { id: \"1824\", source: \"Arachne Eve\" }\r\n535.0 \"Dark Spike\" Ability { id: \"1823\", source: \"Arachne Eve\" }\r\n546.3 \"Frond Affeared\" Ability { id: \"183A\", source: \"Arachne Eve\" } window 30,30\r\n559.7 \"Shadow Burst\" Ability { id: \"1838\", source: \"Arachne Eve\" }\r\n565.2 \"Dark Spike\" Ability { id: \"1823\", source: \"Arachne Eve\" }\r\n572.2 \"--sync--\" Ability { id: \"1847\", source: \"Arachne Eve\" }\r\n575.9 \"Sticky Wicket x3\" # Ability { id: \"183F\", source: \"Arachne Eve\" }\r\n578.3 \"--untargetable--\"\r\n582.9 \"Tremblor x3\" Ability { id: \"1837\", source: \"Arachne Eve\" }\r\n\r\n# And *finally* we get to rotation blocks!\r\n# It may not be necessary to sync so widely, but it's probably a safe bet,\r\n# since we don't have any network logs that get this far to verify.\r\n589.4 \"--sync--\" Ability { id: \"1889\", source: \"Arachne Eve\" } window 100,5\r\n590.9 \"Pitfall\" Ability { id: \"1825\", source: \"Arachne Eve\" }\r\n592.9 \"--targetable--\"\r\n604.6 \"Arachne Web x3\" duration 5 # Ability { id: \"185E\", source: \"Arachne Eve\" }\r\n617.8 \"Dark Spike\" Ability { id: \"1823\", source: \"Arachne Eve\" }\r\n623.3 \"Silken Spray\" Ability { id: \"1824\", source: \"Arachne Eve\" }\r\n631.8 \"Dark Spike\" Ability { id: \"1823\", source: \"Arachne Eve\" }\r\n642.8 \"Frond Affeared\" Ability { id: \"183A\", source: \"Arachne Eve\" } window 30,30\r\n656.5 \"Shadow Burst\" Ability { id: \"1838\", source: \"Arachne Eve\" }\r\n662.0 \"Dark Spike\" Ability { id: \"1823\", source: \"Arachne Eve\" }\r\n677.0 \"Arachne Web x3\" duration 5 # Ability { id: \"185E\", source: \"Arachne Eve\" }\r\n681.2 \"--untargetable--\"\r\n684.9 \"The Widow's Kiss x3\" duration 5 # Ability { id: \"1842\", source: \"Arachne Eve\" }\r\n692.9 \"The Widow's Embrace\" Ability { id: \"1888\", source: \"Arachne Eve\" }\r\n695.4 \"Pitfall\" Ability { id: \"1845\", source: \"Arachne Eve\" }\r\n697.4 \"--targetable--\"\r\n703.4 \"--sync--\" Ability { id: \"1847\", source: \"Arachne Eve\" }\r\n707.1 \"Sticky Wicket x3\" # Ability { id: \"183F\", source: \"Arachne Eve\" }\r\n716.1 \"Dark Spike\" Ability { id: \"1823\", source: \"Arachne Eve\" }\r\n721.6 \"Silken Spray\" Ability { id: \"1824\", source: \"Arachne Eve\" }\r\n730.1 \"Dark Spike\" Ability { id: \"1823\", source: \"Arachne Eve\" }\r\n741.1 \"Frond Affeared\" Ability { id: \"183A\", source: \"Arachne Eve\" } window 30,30\r\n754.7 \"Shadow Burst\" Ability { id: \"1838\", source: \"Arachne Eve\" }\r\n760.2 \"Dark Spike\" Ability { id: \"1823\", source: \"Arachne Eve\" }\r\n767.2 \"--sync--\" Ability { id: \"1847\", source: \"Arachne Eve\" }\r\n770.8 \"Sticky Wicket x3\" # Ability { id: \"183F\", source: \"Arachne Eve\" }\r\n773.0 \"--untargetable--\"\r\n777.6 \"Tremblor x3\" # Ability { id: \"1837\", source: \"Arachne Eve\" }\r\n\r\n784.1 \"--sync--\" Ability { id: \"1889\", source: \"Arachne Eve\" } jump 589.4\r\n785.6 \"Pitfall\"\r\n787.6 \"--targetable--\"\r\n799.3 \"Arachne Web\"\r\n812.5 \"Dark Spike\"\r\n818.0 \"Silken Spray\"\r\n\r\n#~~~~~~~~~#\r\n# FORGALL #\r\n#~~~~~~~~~#\r\n\r\n# -ii 366 17D5 17C1 17D6\r\n\r\n# The Shrine of the Goetic will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"6E3\" } window 1000,5\r\n1014.2 \"Necropurge\" Ability { id: \"17D7\", source: \"Shriveled Talon\" }\r\n1024.4 \"Megiddo Flame\" Ability { id: \"17C0\", source: \"Forgall\" }\r\n1032.4 \"Necropurge\" Ability { id: \"17BE\", source: \"Forgall\" }\r\n1060.7 \"Megiddo Flame\" Ability { id: \"17C0\", source: \"Forgall\" }\r\n1066.7 \"Punishing Ray\" Ability { id: \"17C4\", source: \"Forgall\" }\r\n1081.0 \"Brand of the Fallen\" Ability { id: \"17CC\", source: \"Forgall\" } window 20,20\r\n1090.3 \"Evil Mist\" Ability { id: \"17C5\", source: \"Forgall\" }\r\n1101.3 \"Necropurge\" Ability { id: \"17D7\", source: \"Shriveled Talon\" }\r\n1118.3 \"Necropurge\" Ability { id: \"17BE\", source: \"Forgall\" }\r\n1131.6 \"Necropurge\" Ability { id: \"17BF\", source: \"Forgall\" }\r\n1132.8 \"Brand of the Fallen\" Ability { id: \"17CC\", source: \"Forgall\" } window 20,20\r\n1141.1 \"--sync--\" Ability { id: \"17C2\", source: \"Forgall\" } # Dark Eruption markers go out.\r\n1146.3 \"Dark Eruption x3\" # Ability { id: \"17C3\", source: \"Forgall\" }\r\n1163.2 \"--sync--\" Ability { id: \"17C7\", source: \"Forgall\" } window 163.2,0 # Pushes at 50% HP.\r\n\r\n# We don't know how long the intermission goes.\r\n# There's no data available to tell us what, if anything,\r\n# happens if the three adds aren't killed in time.\r\n# It could even be nothing.\r\n# If the intermission goes longer than 3 minutes, something is WRONG.\r\n\r\n1350.0 \"Mana Explosion\" Ability { id: \"17C8\", source: \"Forgall\" } window 350,5\r\n\r\n1360.2 \"Necropurge\" Ability { id: \"17BE\", source: \"Forgall\" } window 200,5\r\n1373.4 \"Necropurge\" Ability { id: \"17BF\", source: \"Forgall\" }\r\n1373.4 \"--sync--\" Ability { id: \"17D8\", source: \"Poison Mist\" }\r\n1377.5 \"Mega Death\" Ability { id: \"17CA\", source: \"Forgall\" } window 20,20\r\n1388.5 \"--sync--\" Ability { id: \"17C2\", source: \"Forgall\" }\r\n1393.7 \"Dark Eruption x3\" # Ability { id: \"17C3\", source: \"Forgall\" }\r\n1395.7 \"Megiddo Flame\" Ability { id: \"17C0\", source: \"Forgall\" }\r\n1400.9 \"Evil Mist\" Ability { id: \"17C5\", source: \"Forgall\" }\r\n1414.9 \"Necropurge\" Ability { id: \"17BF\", source: \"Forgall\" }\r\n1414.9 \"--sync--\" Ability { id: \"17D8\", source: \"Poison Mist\" }\r\n1419.1 \"Mega Death\" Ability { id: \"17CA\", source: \"Forgall\" } window 20,20\r\n1439.2 \"Hell Wind\" Ability { id: \"17CB\", source: \"Forgall\" }\r\n1453.3 \"Brand of the Fallen\" Ability { id: \"17CC\", source: \"Forgall\" }\r\n1459.5 \"Punishing Ray\" Ability { id: \"17C4\", source: \"Forgall\" }\r\n1465.6 \"Brand of the Fallen\" Ability { id: \"17CC\", source: \"Forgall\" }\r\n\r\n1481.9 \"Necropurge\" Ability { id: \"17BE\", source: \"Forgall\" } jump 1360.2\r\n1495.1 \"Necropurge\"\r\n1499.1 \"Mega Death\"\r\n1515.4 \"Dark Eruption x3\"\r\n\r\n#~~~~~~#\r\n# OZMA #\r\n#~~~~~~#\r\n\r\n# -ii 366 367 368 1802 1806 1807 1829 1830 1832\r\n# -ic \"Singularity Ripple\" \"Singularity Trace\"\r\n\r\n# Ozma is based on an A/B timeline pattern.\r\n# She begins in Sphere form and can morph into Cube or Pyramid stance.\r\n# The complete flow looks like:\r\n\r\n# Sphere opening block -->              --> Cube bridge block ---->       . - - - - - - - - - - ---\r\n#                                                                         V                       |\r\n# Cube opening block ----> Intermission --> Sphere bridge block --> (Cube|Sphere) rotation blocks |\r\n\r\n# The Gloriole will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"6E5\" } window 2000,5\r\n2015.0 \"Meteor Headmarkers\"\r\n2024.0 \"Meteor Impact\" Ability { id: \"1935\", source: \"Singularity Fragment\" }\r\n\r\n2045.5 \"Transfiguration (Pyramid/Cube?)\" Ability { id: \"1826\", source: \"Ozma\" } jump 2150\r\n2045.5 \"--sync--\" Ability { id: \"1803\", source: \"Ozma\" } jump 2250\r\n2052.6 \"Execration?\"\r\n2052.6 \"Flare Star?\"\r\n2059.0 \"Explosion x5?\"\r\n2073.9 \"Acceleration Bomb?\"\r\n\r\n# Pyramid-first path\r\n\r\n2150.0 \"Transfiguration (Pyramid)\" Ability { id: \"1826\", source: \"Ozma\" }\r\n2157.1 \"Execration\" Ability { id: \"1828\", source: \"Ozma\" }\r\n2178.4 \"Acceleration Bomb\" Ability { id: \"182F\", source: \"Ozma\" }\r\n2195.7 \"Transfiguration (Sphere)\" Ability { id: \"1827\", source: \"Ozma\" }\r\n2199.1 \"--sync--\" StartsUsing { id: \"1800\", source: \"Ozma\" } window 48.8,5\r\n2203.8 \"Black Hole\" Ability { id: \"1800\", source: \"Ozma\" } window 53,5 jump 2400\r\n\r\n# Cube-first path\r\n\r\n2250.0 \"Transfiguration (Cube)\" Ability { id: \"1803\", source: \"Ozma\" }\r\n2257.0 \"Flare Star\" Ability { id: \"1805\", source: \"Ozma\" }\r\n2288.0 \"Holy\" Ability { id: \"182E\", source: \"Ozma\" }\r\n2300.0 \"Transfiguration (Sphere)\" Ability { id: \"1804\", source: \"Ozma\" }\r\n2303.3 \"--sync--\" StartsUsing { id: \"1800\", source: \"Ozma\" } window 53.3,5\r\n2308.0 \"Black Hole\" Ability { id: \"1800\", source: \"Ozma\" } window 58,5 jump 2400\r\n\r\n# Intermission\r\n\r\n2400.0 \"Black Hole\" # seems to be a 55% HP push.\r\n# We can't really do anything with this intermission.\r\n# The only real repetition is the Singularity Echoes casting stuff.\r\n# But they die well before the intermission ends, so no point.\r\n# Instead, we just let the timeline play on dead space.\r\n# The intermission's enrage is probably under 3 minutes, but we have no way to know.\r\n\r\n2594.4 \"--sync--\" Ability { id: \"182D\", source: \"Ozma\" } window 194.4,0\r\n2600.0 \"--sync--\" Ability { id: \"1826\", source: \"Ozma\" } window 200,5 jump 2700\r\n2600.0 \"--sync--\" Ability { id: \"1803\", source: \"Ozma\" } window 200,5 jump 3000\r\n\r\n# The continuation from the intermission is dependent on whichever was first.\r\n# Each has its own bridge block, each one leading into a pair of rotation blocks.\r\n# Because of this, it's necessary to jump around way more than we should have to.\r\n# Each block seems? to be full of tiny HP pushes back into Sphere form.\r\n\r\n\r\n# Cube-first continued\r\n2700.0 \"Transfiguration (Pyramid)\" Ability { id: \"1826\", source: \"Ozma\" }\r\n2707.0 \"Execration\" Ability { id: \"1828\", source: \"Ozma\" }\r\n2728.0 \"Acceleration Bomb\" Ability { id: \"182F\", source: \"Ozma\" }\r\n2745.0 \"Transfiguration (Sphere)\" Ability { id: \"1827\", source: \"Ozma\" } window 45,5\r\n2763.0 \"Meteor Impact\" Ability { id: \"1935\", source: \"Singularity Fragment\" }\r\n\r\n2790.8 \"Transfiguration (Cube/Pyramid?)\" Ability { id: \"1826\", source: \"Ozma\" } window 50,5 jump 3200\r\n2790.8 \"--sync--\" Ability { id: \"1803\", source: \"Ozma\" } window 50,5 jump 3400\r\n2797.8 \"Execration?\"\r\n2797.8 \"Flare Star?\"\r\n2809.8 \"Holy?\"\r\n2813.8 \"Acceleration Bomb?\"\r\n2816.8 \"Meteor Impact?\"\r\n\r\n\r\n# Pyramid-first continued\r\n\r\n3000.0 \"Transfiguration (Cube)\" Ability { id: \"1803\", source: \"Ozma\" }\r\n3007.0 \"Flare Star\" Ability { id: \"1805\", source: \"Ozma\" }\r\n3011.0 \"Tank Lasers\" # Ability { id: \"1831\", source: \"Ozma\" }\r\n3029.7 \"Transfiguration (Sphere)\" Ability { id: \"1804\", source: \"Ozma\" }\r\n3047.9 \"Meteor Impact\" Ability { id: \"1935\", source: \"Singularity Fragment\" }\r\n\r\n3080.8 \"Transfiguration (Cube/Pyramid?)\" Ability { id: \"1826\", source: \"Ozma\" } window 50,5 jump 3200\r\n3080.8 \"--sync--\" Ability { id: \"1803\", source: \"Ozma\" } window 50,5 jump 3400\r\n3087.8 \"Execration?\"\r\n3087.8 \"Flare Star?\"\r\n3091.8 \"Tank Lasers?\"\r\n3099.8 \"Holy?\"\r\n3103.8 \"Acceleration Bomb?\"\r\n\r\n\r\n# Pyramid standard rotation\r\n\r\n3200.0 \"Transfiguration (Pyramid)\" Ability { id: \"1826\", source: \"Ozma\" }\r\n3207.0 \"Execration\" Ability { id: \"1828\", source: \"Ozma\" }\r\n3223.0 \"Acceleration Bomb\" Ability { id: \"182F\", source: \"Ozma\" }\r\n3226.0 \"Meteor Impact\" Ability { id: \"1935\", source: \"Singularity Fragment\" }\r\n3246.5 \"Meteor\" # Ability { id: \"182D\", source: \"Ozma\" }\r\n3261.0 \"Acceleration Bomb\" Ability { id: \"182F\", source: \"Ozma\" }\r\n3263.0 \"Transfiguration (Sphere)\" Ability { id: \"1827\", source: \"Ozma\" } window 50,5\r\n\r\n3275.0 \"Transfiguration (Cube/Pyramid?)\" Ability { id: \"1826\", source: \"Ozma\" } window 50,5 jump 3200\r\n3275.0 \"--sync--\" Ability { id: \"1803\", source: \"Ozma\" } jump 3400\r\n3282.0 \"Execration?\"\r\n3282.0 \"Flare Star?\"\r\n3286.0 \"Tank Lasers?\"\r\n3294.0 \"Holy?\"\r\n3298.0 \"Acceleration Bomb?\"\r\n\r\n\r\n# Cube standard rotation\r\n\r\n3400.0 \"Transfiguration (Cube)\" Ability { id: \"1803\", source: \"Ozma\" }\r\n3407.0 \"Flare Star\" Ability { id: \"1805\", source: \"Ozma\" }\r\n3411.0 \"Tank Lasers\" # Ability { id: \"1831\", source: \"Ozma\" }\r\n3419.2 \"Holy\" Ability { id: \"182E\", source: \"Ozma\" }\r\n3435.1 \"Meteor Impact\" Ability { id: \"1935\", source: \"Singularity Fragment\" }\r\n3441.3 \"Holy\" Ability { id: \"182E\", source: \"Ozma\" }\r\n3456.6 \"Meteor\" # Ability { id: \"182D\", source: \"Ozma\" }\r\n3463.2 \"Transfiguration (Sphere)\" Ability { id: \"1804\", source: \"Ozma\" } window 50,5\r\n\r\n3475.2 \"Transfiguration (Cube/Pyramid?)\" Ability { id: \"1826\", source: \"Ozma\" } window 50,5 jump 3200\r\n3475.2 \"--sync--\" Ability { id: \"1803\", source: \"Ozma\" } window 50,5 jump 3400\r\n3482.2 \"Execration?\"\r\n3482.2 \"Flare Star?\"\r\n3486.2 \"Tank Lasers?\"\r\n3494.2 \"Holy?\"\r\n3498.2 \"Acceleration Bomb?\"\r\n\r\n\r\n\r\n\r\n#~~~~~~~~~~~~~#\r\n# CALOFISTERI #\r\n#~~~~~~~~~~~~~#\r\n\r\n# -ii 181B 181C 181D 181E 1928\r\n\r\n# 1811 and 180D are releasing hair after Haircut and Split End cleaves\r\n\r\n# Tomb of the Nullstone will be sealed off\r\n4000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"6E6\" } window 4000,5\r\n4004.1 \"Bloodied Nail x4\" # Ability { id: \"181F\", source: \"Calofisteri\" }\r\n4018.8 \"Coif Change\" Ability { id: \"180[AE]\", source: \"Calofisteri\" } window 18.8,5\r\n4027.8 \"Haircut\" Ability { id: \"180[BF]\", source: \"Calofisteri\" }\r\n4030.8 \"Split End\" Ability { id: \"18(0C|10)\", source: \"Calofisteri\" }\r\n4035.8 \"Split End\" Ability { id: \"18(0C|10)\", source: \"Calofisteri\" }\r\n4040.8 \"Extension\" Ability { id: \"1812\", source: \"Calofisteri\" }\r\n4043.8 \"Split End\" Ability { id: \"18(0C|10)\", source: \"Calofisteri\" }\r\n4047.8 \"Split End\" Ability { id: \"18(0C|10)\", source: \"Calofisteri\" }\r\n4051.9 \"--sync--\" Ability { id: \"18(0D|11)\", source: \"Calofisteri\" } window 51,5\r\n4054.9 \"Coif Change\" Ability { id: \"180[AE]\", source: \"Calofisteri\" }\r\n4063.9 \"Haircut\" Ability { id: \"180[BF]\", source: \"Calofisteri\" }\r\n4066.9 \"Split End\" Ability { id: \"18(0C|10)\", source: \"Calofisteri\" }\r\n4071.9 \"Split End\" Ability { id: \"18(0C|10)\", source: \"Calofisteri\" }\r\n4076.9 \"Extension\" Ability { id: \"1812\", source: \"Calofisteri\" }\r\n4079.9 \"Split End\" Ability { id: \"18(0C|10)\", source: \"Calofisteri\" }\r\n4083.9 \"Split End\" Ability { id: \"18(0C|10)\", source: \"Calofisteri\" }\r\n4090.9 \"Haircut\" Ability { id: \"180[BF]\", source: \"Calofisteri\" }\r\n4093.9 \"Split End\" Ability { id: \"18(0C|10)\", source: \"Calofisteri\" }\r\n4096.9 \"Aura Burst\" Ability { id: \"1821\", source: \"Calofisteri\" }\r\n4099.8 \"--sync--\" Ability { id: \"18(0D|11)\", source: \"Calofisteri\" } window 40,5\r\n4101.4 \"--untargetable--\"\r\n4103.8 \"Dancing Mad\" Ability { id: \"1818\", source: \"Calofisteri\" } window 103.8,5\r\n\r\n# An intermission full of SKY LASERS\r\n4112.3 \"Feint Particle Beam x16\" Ability { id: \"1927\", source: \"Calofisteri\" } duration 10\r\n4131.6 \"Feint Particle Beam x16\" Ability { id: \"1927\", source: \"Calofisteri\" } duration 10\r\n4140.9 \"Feint Particle Beam x16\" Ability { id: \"1927\", source: \"Calofisteri\" } jump 4112.3\r\n4160.8 \"Feint Particle Beam x16\"\r\n\r\n\r\n# Returning to a broken bridge block.\r\n# It doesn't look like time taken on the intermission affects how many times\r\n# Dancing Mad strikes.\r\n\r\n4200.0 \"Mana Drain\" Ability { id: \"1819\", source: \"Calofisteri\" } window 80,5\r\n4204.0 \"Dancing Mad\" Ability { id: \"181A\", source: \"Calofisteri\" }\r\n4212.9 \"--targetable--\"\r\n4215.0 \"Coif Change\" Ability { id: \"180[AE]\", source: \"Calofisteri\" }\r\n4224.0 \"Haircut\" Ability { id: \"180[BF]\", source: \"Calofisteri\" }\r\n4227.0 \"--sync--\" Ability { id: \"18(0D|11)\", source: \"Calofisteri\" }\r\n4232.0 \"Extension\" Ability { id: \"1812\", source: \"Calofisteri\" }\r\n4237.0 \"--sync--\" Ability { id: \"1813\", source: \"Calofisteri\" }\r\n4238.0 \"Bloodied Nail x3\" # Ability { id: \"181F\", source: \"Calofisteri\" }\r\n4249.0 \"Evil Curl/Evil Tress\" Ability { id: \"181[67]\", source: \"Living Lock\" }\r\n4251.5 \"Extension\" Ability { id: \"1812\", source: \"Calofisteri\" }\r\n4253.5 \"Coif Change\" Ability { id: \"180[AE]\", source: \"Calofisteri\" } window 15,15\r\n\r\n# This section of the bridge may be skipped depending on DPS. HP% for push is unknown.\r\n4262.5 \"Haircut\" Ability { id: \"180[BF]\", source: \"Calofisteri\" }\r\n4268.5 \"Aura Burst\" Ability { id: \"1821\", source: \"Calofisteri\" }\r\n4273.5 \"Split End\" Ability { id: \"18(0C|10)\", source: \"Calofisteri\" }\r\n4278.5 \"Split End\" Ability { id: \"18(0C|10)\", source: \"Calofisteri\" }\r\n\r\n4280.5 \"--sync--\" Ability { id: \"18(0D|11)\", source: \"Calofisteri\" } window 27,15\r\n4285.5 \"Extension\" Ability { id: \"1812\", source: \"Calofisteri\" }\r\n4290.5 \"--sync--\" Ability { id: \"1813\", source: \"Calofisteri\" }\r\n4293.4 \"Penetration\" Ability { id: \"1822\", source: \"Calofisteri\" }\r\n\r\n# Rotation block to 0%\r\n4296.9 \"Coif Change\" Ability { id: \"180[AE]\", source: \"Calofisteri\" } window 15,15\r\n4307.2 \"Depth Charge\" Ability { id: \"1820\", source: \"Calofisteri\" }\r\n4311.2 \"Haircut\" Ability { id: \"180[BF]\", source: \"Calofisteri\" }\r\n4317.2 \"--sync--\" Ability { id: \"18(0D|11)\", source: \"Calofisteri\" }\r\n4322.2 \"Extension\" Ability { id: \"1812\", source: \"Calofisteri\" }\r\n4325.2 \"Bloodied Nail x3\" # Ability { id: \"181F\", source: \"Calofisteri\" }\r\n4332.2 \"Aura Burst\" Ability { id: \"1821\", source: \"Calofisteri\" }\r\n4338.7 \"Coif Change\" Ability { id: \"180[AE]\", source: \"Calofisteri\" } window 15,15\r\n4339.2 \"Evil Switch\" Ability { id: \"1815\", source: \"Living Lock\" }\r\n4345.7 \"Haircut\" Ability { id: \"180[BF]\", source: \"Calofisteri\" }\r\n4351.7 \"Extension\" Ability { id: \"1812\", source: \"Calofisteri\" }\r\n4356.7 \"Split End\" Ability { id: \"18(0C|10)\", source: \"Calofisteri\" }\r\n4358.7 \"--sync--\" Ability { id: \"18(0D|11)\", source: \"Calofisteri\" }\r\n4363.7 \"Extension\" Ability { id: \"1812\", source: \"Calofisteri\" }\r\n4367.7 \"Bloodied Nail x3\" # Ability { id: \"181F\", source: \"Calofisteri\" }\r\n4377.2 \"Aura Burst\" Ability { id: \"1821\", source: \"Calofisteri\" }\r\n4379.2 \"Coif Change\" Ability { id: \"180[AE]\", source: \"Calofisteri\" } window 15,15\r\n4380.7 \"Evil Curl/Evil Tress\" Ability { id: \"181[67]\", source: \"Living Lock\" }\r\n4386.3 \"Haircut\" Ability { id: \"180[BF]\", source: \"Calofisteri\" }\r\n4392.3 \"Split End\" Ability { id: \"18(0C|10)\", source: \"Calofisteri\" }\r\n4397.3 \"Split End\" Ability { id: \"18(0C|10)\", source: \"Calofisteri\" }\r\n4402.3 \"Aura Burst\" Ability { id: \"1821\", source: \"Calofisteri\" }\r\n4404.3 \"--sync--\" Ability { id: \"18(0D|11)\", source: \"Calofisteri\" }\r\n4409.3 \"Extension\" Ability { id: \"1812\", source: \"Calofisteri\" }\r\n4414.3 \"--sync--\" Ability { id: \"1813\", source: \"Calofisteri\" }\r\n4417.7 \"Penetration\" Ability { id: \"1822\", source: \"Calofisteri\" }\r\n4421.2 \"Evil Curl/Evil Tress\" Ability { id: \"181[67]\", source: \"Living Lock\" }\r\n\r\n4421.2 \"Coif Change\" Ability { id: \"180[AE]\", source: \"Calofisteri\" } window 15,15 jump 4296.9\r\n4431.5 \"Depth Charge\"\r\n4435.5 \"Haircut\"\r\n4446.5 \"Extension\"\r\n4449.5 \"Bloodied Nail x3\"\r\n4456.5 \"Aura Burst\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_001-010.ts



// Palace of the Dead Floors 001-010
// TODO: Palace Hornet Final Sting, 70% max HP enrage attack
const the_palace_of_the_dead_floors_001_010_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors1_10',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors1_10 */.Z.ThePalaceOfTheDeadFloors1_10,
  triggers: [
  // ---------------- Floor 001-009 Mobs ----------------
  // intentionally blank
  // ---------------- Floor 010 Boss: Palace Deathgaze ----------------
  {
    id: 'PotD 001-010 Palace Deathgaze Aero Blast',
    type: 'StartsUsing',
    netRegex: {
      id: '1914',
      source: 'Palace Deathgaze',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Palace Deathgaze': 'Palast-Thanatos'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Palace Deathgaze': 'mortalis du palais'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Palace Deathgaze': 'パレス・デスゲイズ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Palace Deathgaze': '地宫死亡凝视'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Palace Deathgaze': '궁전 저승파수꾼'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_001_010 = (the_palace_of_the_dead_floors_001_010_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_011-020.ts



// Palace of the Dead Floors 011-020
// TODO: Palace Slime Rupture, high damage AoE enrage
const the_palace_of_the_dead_floors_011_020_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors11_20',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors11_20 */.Z.ThePalaceOfTheDeadFloors11_20,
  triggers: [
  // ---------------- Floor 011-019 Mobs ----------------
  {
    id: 'PotD 011-020 Palace Cobra Stone Gaze',
    // inflicts Petrify
    type: 'StartsUsing',
    netRegex: {
      id: '18CF',
      source: 'Palace Cobra',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  },
  // ---------------- Floor 020 Boss: Spurge ----------------
  {
    id: 'PotD 011-020 Spurge Leafstorm',
    type: 'StartsUsing',
    netRegex: {
      id: '1918',
      source: 'Spurge',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'PotD 011-020 Spurge Adds Spawn',
    // 4981 = Palace Hornet, use Final Sting 70% max HP enrage attack if not killed fast enough
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '4981',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.killAdds */.n3.killAdds('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Palace Cobra': 'Palast-Kobra',
      'Spurge': 'Euphorbia'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Palace Cobra': 'cobra du palais',
      'Spurge': 'Euphorbe'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Palace Cobra': 'パレス・コブラ',
      'Spurge': 'スパージ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Palace Cobra': '地宫眼镜蛇',
      'Spurge': '大戟花'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Palace Cobra': '궁전 코브라',
      'Spurge': '등대풀'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_011_020 = (the_palace_of_the_dead_floors_011_020_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_021-030.ts




// Palace of the Dead Floors 021-030
// TODO: Palace Peiste Stone Gaze front cone AoE gaze attack
const the_palace_of_the_dead_floors_021_030_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors21_30',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors21_30 */.Z.ThePalaceOfTheDeadFloors21_30,
  triggers: [
  // ---------------- Floor 021-029 Mobs ----------------
  {
    id: 'PotD 021-030 Palace Minotaur 111-tonze Swing',
    // untelegraphed PBAoE with knockback
    type: 'StartsUsing',
    netRegex: {
      id: '18DC',
      source: 'Palace Minotaur',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'PotD 021-030 Palace Skatene Chirp',
    // untelegraphed PBAoE Sleep
    type: 'StartsUsing',
    netRegex: {
      id: '18DD',
      source: 'Palace Skatene',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  },
  // ---------------- Floor 030 Boss: Ningishzida ----------------
  {
    id: 'PotD 021-030 Ningishzida Ball of Fire',
    // persistent AoE that inflicts Burns (11C)
    type: 'NetworkAOEAbility',
    netRegex: {
      id: '191B',
      source: 'Ningishzida'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'PotD 021-030 Ningishzida Ball of Ice',
    // persistent AoE that inflicts Frostbite
    type: 'NetworkAOEAbility',
    netRegex: {
      id: '191C',
      source: 'Ningishzida'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'PotD 021-030 Ningishzida Fear Itself',
    // roomwide donut AoE that inflicts Terror (42), need to be inside boss hitbox to avoid
    // Ningishzida always moves to the center of the room first before casting this
    type: 'StartsUsing',
    netRegex: {
      id: '191D',
      source: 'Ningishzida',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Ningishzida': 'Ningishzida',
      'Palace Minotaur': 'Palast-Minotaurus',
      'Palace Skatene': 'Palast-Skatene'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ningishzida': 'Ningishzida',
      'Palace Minotaur': 'minotaure du palais',
      'Palace Skatene': 'skate\'ne du palais'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ningishzida': 'ニンギジッダ',
      'Palace Minotaur': 'パレス・ミノタウロス',
      'Palace Skatene': 'パレス・スカネテ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ningishzida': '宁吉兹济达',
      'Palace Minotaur': '地宫弥诺陶洛斯',
      'Palace Skatene': '地宫斯卡尼特'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ningishzida': '닝기시지다',
      'Palace Minotaur': '궁전 미노타우로스',
      'Palace Skatene': '궁전 스카네테'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_021_030 = (the_palace_of_the_dead_floors_021_030_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_031-040.ts



// Palace of the Dead Floors 031-040

const the_palace_of_the_dead_floors_031_040_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors31_40',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors31_40 */.Z.ThePalaceOfTheDeadFloors31_40,
  triggers: [
  // ---------------- Floor 031-039 Mobs ----------------
  {
    id: 'PotD 031-040 Nightmare Eye Eyes on Me',
    // untelegraphed roomwide AoE
    type: 'StartsUsing',
    netRegex: {
      id: '18E2',
      source: 'Nightmare Eye',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  },
  // ---------------- Floor 40 Boss: Ixtab ----------------
  {
    id: 'PotD 031-040 Ixtab Adds Spawn',
    // 5030 = Nightmare Bhoot
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '5030',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.killAdds */.n3.killAdds('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Nightmare Eye': 'Albtraum-Auge'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Nightmare Eye': 'œil du cauchemar'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Nightmare Eye': 'ナイトメア・アイ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Nightmare Eye': '噩梦之眼'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Nightmare Eye': '악몽 눈알'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_031_040 = (the_palace_of_the_dead_floors_031_040_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_041-050.ts



// Palace of the Dead Floors 041-050

const the_palace_of_the_dead_floors_041_050_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors41_50',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors41_50 */.Z.ThePalaceOfTheDeadFloors41_50,
  triggers: [
  // ---------------- Floor 041-049 Mobs ----------------
  {
    id: 'PotD 041-050 Nightmare Bhoot Paralyze III',
    // inflicts Paralyze
    type: 'StartsUsing',
    netRegex: {
      id: '18F2',
      source: 'Nightmare Bhoot'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'PotD 041-050 Nightmare Persona Paralyze III',
    // same ability name, different mob
    // inflicts Paralyze
    type: 'StartsUsing',
    netRegex: {
      id: '18F4',
      source: 'Nightmare Persona'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'PotD 041-050 Nightmare Wraith Scream',
    // inflicts Terror (42)
    type: 'StartsUsing',
    netRegex: {
      id: '190A',
      source: 'Nightmare Wraith'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'PotD 041-050 Nightmare Manticore Ripper Claw',
    // untelegraphed front cone AoE
    type: 'StartsUsing',
    netRegex: {
      id: '18FA',
      source: 'Nightmare Manticore',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  },
  // ---------------- Floor 050 Boss: Edda Blackbosom ----------------
  {
    id: 'PotD 041-050 Edda Blackbosom In Health (PBAoE)',
    // large PBAoE, increases damage of Black Honeymoon if hit
    type: 'StartsUsing',
    netRegex: {
      id: '18FE',
      source: 'Edda Blackbosom',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'PotD 041-050 Edda Blackbosom In Health (Donut)',
    // Donut AoE, increases damage of Black Honeymoon if hit
    type: 'StartsUsing',
    netRegex: {
      id: '18FF',
      source: 'Edda Blackbosom',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'PotD 041-050 Edda Blackbosom Black Honeymoon',
    // roomwide AoE, does more damage increased based on how many players hit by In Health
    type: 'StartsUsing',
    netRegex: {
      id: '1902',
      source: 'Edda Blackbosom',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'PotD 041-050 Edda Blackbosom Cold Feet',
    // gaze, inflicts Confusion
    type: 'StartsUsing',
    netRegex: {
      id: '1903',
      source: 'Edda Blackbosom',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Edda Blackbosom': 'Edda Schwarzherz',
      'Nightmare Bhoot': 'Albtraum-Bhut',
      'Nightmare Manticore': 'Albtraum-Manticore',
      'Nightmare Persona': 'Albtraum-Persona',
      'Nightmare Wraith': 'Albtraum-Geist'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Edda Blackbosom': 'Edda Cœur-noir',
      'Nightmare Bhoot': 'bhut du cauchemar',
      'Nightmare Manticore': 'manticore du cauchemar',
      'Nightmare Persona': 'persona du cauchemar',
      'Nightmare Wraith': 'spectre du cauchemar'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Edda Blackbosom': '漆黒のエッダ',
      'Nightmare Bhoot': 'ナイトメア・ブフート',
      'Nightmare Manticore': 'ナイトメア・マンティコア',
      'Nightmare Persona': 'ナイトメア・ペルソナ',
      'Nightmare Wraith': 'ナイトメア・レイス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Edda Blackbosom': '漆黑的艾达',
      'Nightmare Bhoot': '噩梦浮灵',
      'Nightmare Manticore': '噩梦曼提克',
      'Nightmare Persona': '噩梦假面',
      'Nightmare Wraith': '噩梦幽灵'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Edda Blackbosom': '칠흑의 에다',
      'Nightmare Bhoot': '악몽 브후트',
      'Nightmare Manticore': '악몽 만티코어',
      'Nightmare Persona': '악몽 페르소나',
      'Nightmare Wraith': '악몽 망령'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_041_050 = (the_palace_of_the_dead_floors_041_050_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_051-060.ts




// Palace of the Dead Floors 051-060

const the_palace_of_the_dead_floors_051_060_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors51_60',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors51_60 */.Z.ThePalaceOfTheDeadFloors51_60,
  triggers: [
  // ---------------- Floor 051-059 Mobs ----------------
  {
    id: 'PotD 051-060 Palace Deepeye Hypnotize',
    // gaze, inflicts Sleep
    type: 'StartsUsing',
    netRegex: {
      id: '1B1B',
      source: 'Palace Deepeye',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'PotD 051-060 Palace Pot Mysterious Light',
    // gaze, inflicts Blind
    type: 'StartsUsing',
    netRegex: {
      id: '1B29',
      source: 'Palace Pot',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'PotD 051-060 Palace Imp Ice Spikes Cast',
    // gains Ice Spikes (C6), high counterattack damage when hit
    type: 'StartsUsing',
    netRegex: {
      id: '1B1F',
      source: 'Palace Imp'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'PotD 051-060 Palace Imp Ice Spikes Gain',
    // C6 = Ice Spikes, high counterattack damage when hit
    type: 'GainsEffect',
    netRegex: {
      effectId: 'C6',
      target: 'Palace Imp'
    },
    alertText: (_data, matches, output) => output.text({
      target: matches.target
    }),
    outputStrings: {
      text: {
        en: 'Stop attacking ${target}',
        de: 'Stoppe Angriffe auf ${target}',
        fr: 'N\'attaquez plus ${target}',
        cn: '停止攻击 ${target}',
        ko: '${target} 공격 중지'
      }
    }
  },
  // ---------------- Floor 060 Boss: The Black Rider ----------------
  {
    id: 'PotD 051-060 The Black Rider Valfodr',
    // charge with knockback
    type: 'StartsUsing',
    netRegex: {
      id: '1BB1',
      source: 'The Black Rider'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback into Safe Spot',
        de: 'Rückstoß zur sicheren Stelle',
        fr: 'Faites-vous pousser dans une zone sûre',
        cn: '击退到安全区',
        ko: '안전지대로 넉백되기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Palace Deepeye': 'Palast-Glotzauge',
      'Palace Imp': 'Palast-Imp',
      'Palace Pot': 'Palast-Manatopf',
      'The Black Rider': '(?:der|die|das) Schwarz(?:e|er|es|en) Reiter'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Palace Deepeye': 'oculus du palais',
      'Palace Imp': 'imp du palais',
      'Palace Pot': 'pot de mana du palais',
      'The Black Rider': 'cavalier noir'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Palace Deepeye': 'パレス・ディープアイ',
      'Palace Imp': 'パレス・インプ',
      'Palace Pot': 'パレス・マナポット',
      'The Black Rider': 'ブラックライダー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Palace Deepeye': '地宫深瞳',
      'Palace Imp': '地宫小魔精',
      'Palace Pot': '地宫魔力罐',
      'The Black Rider': '深黑骑士'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Palace Deepeye': '궁전 볼록눈',
      'Palace Imp': '궁전 임프',
      'Palace Pot': '궁전 마나 항아리',
      'The Black Rider': '검은 기수'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_051_060 = (the_palace_of_the_dead_floors_051_060_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_061-070.ts



// Palace of the Dead Floors 061-070

const the_palace_of_the_dead_floors_061_070_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors61_70',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors61_70 */.Z.ThePalaceOfTheDeadFloors61_70,
  triggers: [
  // ---------------- Floor 061-069 Mobs ----------------
  {
    id: 'PotD 061-070 Palace Diplocaulus Foregone Gleam',
    // front cone gaze
    type: 'StartsUsing',
    netRegex: {
      id: '1B2D',
      source: 'Palace Diplocaulus',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }
  // ---------------- Floor 070 Boss: Yaquaru ----------------
  // intentionally blank
  ],

  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Palace Diplocaulus': 'Palast-Diplocaulus'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Palace Diplocaulus': 'diplocaulus du palais'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Palace Diplocaulus': 'パレス・ディプロカウルス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Palace Diplocaulus': '地宫笠头螈'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Palace Diplocaulus': '궁전 디플로카울루스'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_061_070 = (the_palace_of_the_dead_floors_061_070_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_071-080.ts



// Palace of the Dead Floors 071-080

const the_palace_of_the_dead_floors_071_080_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors71_80',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors71_80 */.Z.ThePalaceOfTheDeadFloors71_80,
  triggers: [
  // ---------------- Floor 071-079 Mobs ----------------
  {
    id: 'PotD 071-080 Palace Cyclops Eye of the Beholder',
    // untelegraphed front cone AoE
    type: 'StartsUsing',
    netRegex: {
      id: '1B3C',
      source: 'Palace Cyclops',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  },
  // ---------------- Floor 080 Boss: Gudanna ----------------
  {
    id: 'PotD 071-080 Gudanna Ecliptic Meteor',
    // 80% max HP damage
    type: 'StartsUsing',
    netRegex: {
      id: '1BBB',
      source: 'Gudanna'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 4,
    response: responses/* Responses.bigAoe */.n3.bigAoe('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Gudanna': 'Gudanna',
      'Palace Cyclops': 'Palast-Zyklop'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Gudanna': 'Gudanna',
      'Palace Cyclops': 'cyclope du palais'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Gudanna': 'グアンナ',
      'Palace Cyclops': 'パレス・サイクロプス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Gudanna': '古丹纳',
      'Palace Cyclops': '地宫独眼巨人'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Gudanna': '구단나',
      'Palace Cyclops': '궁전 사이클롭스'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_071_080 = (the_palace_of_the_dead_floors_071_080_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_081-090.ts


// Palace of the Dead Floors 081-090
// TODO: Palace Bomb Self-Destruct, high damage AoE enrage
// TODO: Palace Worm unknown high damage draw-in + PBAoE enrage
const the_palace_of_the_dead_floors_081_090_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors81_90',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors81_90 */.Z.ThePalaceOfTheDeadFloors81_90,
  triggers: [
  // ---------------- Floor 081-089 Mobs ----------------
  // intentionally blank
  // ---------------- Floor 090 Boss: The Godmother ----------------
  {
    id: 'PotD 081-090 Grey Bomb Spawn',
    // 4578 = Grey Bomb
    // kill before Burst (1BC1) finishes casting
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '4578'
    },
    alertText: (_data, matches, output) => output.kill({
      name: matches.name
    }),
    outputStrings: {
      kill: {
        en: 'Kill ${name}',
        de: 'Besiege ${name}',
        fr: 'Tuez ${name}',
        ja: '${name}を倒す',
        cn: '击杀 ${name}',
        ko: '${name} 처치'
      }
    }
  }, {
    id: 'PotD 081-090 Giddy Bomb Spawn',
    // 5477 = Giddy Bomb
    // The Godmother casts Massive Burst (1BBE), a non-interruptable, 99% HP roomwide attack
    // Lava Bomb casts Hypothermal Combustion (1BC0), a small PBAoE which will interrupt Massive Burst
    // attack Giddy Bomb to push it into The Godmother
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '5477'
    },
    alertText: (_data, matches, output) => output.pushToBoss({
      name: matches.name
    }),
    outputStrings: {
      pushToBoss: {
        en: 'Push ${name} into boss',
        de: 'Stoß ${name} in den Boss',
        fr: 'Poussez ${name} sur le boss',
        cn: '将 ${name} 推至BOSS',
        ko: '보스쪽으로 ${name} 밀기'
      }
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_081_090 = (the_palace_of_the_dead_floors_081_090_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_091-100.ts



// Palace of the Dead Floors 091-100

const the_palace_of_the_dead_floors_091_100_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors91_100',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors91_100 */.Z.ThePalaceOfTheDeadFloors91_100,
  triggers: [
  // ---------------- Floor 091-099 Mobs ----------------
  {
    id: 'PotD 091-100 Palace Wraith Scream',
    // inflicts Terror (42)
    type: 'StartsUsing',
    netRegex: {
      id: '190A',
      source: 'Palace Wraith'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  },
  // ---------------- Floor 100 Boss: Nybeth Obdilord ----------------
  {
    id: 'PotD 091-100 Nybeth Obdilord Summon Darkness',
    // 5357 = Giant Corse
    // 5358 = Bicephalic Corse
    // 5359 = Iron Corse
    type: 'Ability',
    netRegex: {
      id: '1ADC',
      source: 'Nybeth Obdilord',
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Nybeth Obdilord': 'Nybeth Obdilord',
      'Palace Wraith': 'Palast-Geist'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Nybeth Obdilord': 'Nybeth Obdilord',
      'Palace Wraith': 'spectre du palais'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Nybeth Obdilord': '屍術師ニバス',
      'Palace Wraith': 'パレス・レイス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Nybeth Obdilord': '死灵术士尼博斯',
      'Palace Wraith': '地宫幽灵'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Nybeth Obdilord': '시체술사 니버스',
      'Palace Wraith': '궁전 망령'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_091_100 = (the_palace_of_the_dead_floors_091_100_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_101-110.ts



// Palace of the Dead Floors 101-110
// TODO: Deep Palace Hornet Final Sting, 99% of max HP enrage
const the_palace_of_the_dead_floors_101_110_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors101_110',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors101_110 */.Z.ThePalaceOfTheDeadFloors101_110,
  triggers: [
  // ---------------- Floor 101-109 Mobs ----------------
  // intentionally blank
  // ---------------- Floor 110 Boss: Alicanto ----------------
  {
    id: 'PotD 101-110 Alicanto Aero Blast',
    // roomwide AoE plus DoT
    type: 'StartsUsing',
    netRegex: {
      id: '1BDC',
      source: 'Alicanto',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Alicanto': 'Alicanto'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Alicanto': 'Alicanto'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Alicanto': 'アリカント'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Alicanto': '阿利坎托'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Alicanto': '알리칸토'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_101_110 = (the_palace_of_the_dead_floors_101_110_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_111-120.ts



// Palace of the Dead Floors 111-120
// TODO: Deep Palace Slime Rupture, high damage AoE enrage
const the_palace_of_the_dead_floors_111_120_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors111_120',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors111_120 */.Z.ThePalaceOfTheDeadFloors111_120,
  triggers: [
  // ---------------- Floor 111-119 Mobs ----------------
  {
    id: 'PotD 111-120 Deep Palace Salamander Mucin',
    // gains Stoneskin (97)
    type: 'StartsUsing',
    netRegex: {
      id: '1B66',
      source: 'Deep Palace Salamander'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  },
  // ---------------- Floor 120 Boss: Kirtimukha ----------------
  {
    id: 'PotD 111-120 Kirtimukha Leafstorm',
    type: 'StartsUsing',
    netRegex: {
      id: '1BE0',
      source: 'Kirtimukha',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'PotD 111-120 Kirtimukha Adds Spawn',
    // 5366 = Deep Palace Hornet, use Final Sting 70% max HP enrage attack if not killed fast enough
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '5366',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.killAdds */.n3.killAdds('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Deep Palace Salamander': 'Katakomben-Salamander',
      'Kirtimukha': 'Kirtimukha'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Deep Palace Salamander': 'salamandre des profondeurs',
      'Kirtimukha': 'Kirtimukha'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Deep Palace Salamander': 'ディープパレス・サラマンダー',
      'Kirtimukha': 'キールティムカ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Deep Palace Salamander': '深宫蝾螈',
      'Kirtimukha': '荣光魔花'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Deep Palace Salamander': '깊은 궁전 불도롱뇽',
      'Kirtimukha': '키르티무카'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_111_120 = (the_palace_of_the_dead_floors_111_120_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_121-130.ts




// Palace of the Dead Floors 121-130
// TODO: missing Deep Palace Dullahan Blade of Suffering (interruptable cast)
const the_palace_of_the_dead_floors_121_130_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors121_130',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors121_130 */.Z.ThePalaceOfTheDeadFloors121_130,
  triggers: [
  // ---------------- Floor 121-129 Mobs ----------------
  {
    id: 'PotD 121-130 Deep Palace Minotaur 111-tonze Swing',
    // untelegraphed PBAoE with knockback
    type: 'StartsUsing',
    netRegex: {
      id: '18DC',
      source: 'Deep Palace Minotaur',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'PotD 121-130 Deep Palace Skatene Chirp',
    // untelegraphed PBAoE Sleep
    type: 'StartsUsing',
    netRegex: {
      id: '18DD',
      source: 'Deep Palace Skatene',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  },
  // ---------------- Floor 130 Boss: Alfard ----------------
  {
    id: 'PotD 121-130 Alfard Ball of Fire',
    // persistent AoE that inflicts Burns (11C)
    type: 'NetworkAOEAbility',
    netRegex: {
      id: '1BE3',
      source: 'Alfard'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'PotD 121-130 Alfard Ball of Ice',
    // persistent AoE that inflicts Frostbite
    type: 'NetworkAOEAbility',
    netRegex: {
      id: '1BE4',
      source: 'Alfard'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'PotD 121-130 Alfard Fear Itself',
    // roomwide donut AoE that inflicts Terror (42), need to be inside boss hitbox to avoid
    // Alfard always moves to the center of the room first before casting this
    type: 'StartsUsing',
    netRegex: {
      id: '1BE5',
      source: 'Alfard',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Alfard': 'Alfard',
      'Deep Palace Minotaur': 'Katakomben-Minotaurus',
      'Deep Palace Skatene': 'Katakomben-Skatene'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Alfard': 'Alfard',
      'Deep Palace Minotaur': 'minotaure des profondeurs',
      'Deep Palace Skatene': 'skate\'ne des profondeurs'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Alfard': 'アルファルド',
      'Deep Palace Minotaur': 'ディープパレス・ミノタウルス',
      'Deep Palace Skatene': 'ディープパレス・スカネテ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Alfard': '埃尔法德',
      'Deep Palace Minotaur': '深宫弥诺陶洛斯',
      'Deep Palace Skatene': '深宫斯卡尼特'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Alfard': '알파르드',
      'Deep Palace Minotaur': '깊은 궁전 미노타우로스',
      'Deep Palace Skatene': '깊은 궁전 스카네테'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_121_130 = (the_palace_of_the_dead_floors_121_130_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_131-140.ts



// Palace of the Dead Floors 131-140

const the_palace_of_the_dead_floors_131_140_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors131_140',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors131_140 */.Z.ThePalaceOfTheDeadFloors131_140,
  triggers: [
  // ---------------- Floor 131-139 Mobs ----------------
  {
    id: 'PotD 131-140 Deep Palace Ahriman Level 5 Petrify',
    // untelegraphed cone AoE that inflicts Petrify
    type: 'StartsUsing',
    netRegex: {
      id: '1B77',
      source: 'Deep Palace Ahriman',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'PotD 131-140 Deep Palace Catoblepas Eye of the Stunted',
    // gaze attack that inflicts Minimum (1B6)
    type: 'StartsUsing',
    netRegex: {
      id: '1B7A',
      source: 'Deep Palace Catoblepas',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  },
  // ---------------- Floor 140 Boss: Ah Puch ----------------
  {
    id: 'PotD 131-140 Ah Puch Adds Spawn',
    // 5411 = Deep Palace Follower
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '5411',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.killAdds */.n3.killAdds('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Deep Palace Ahriman': 'Katakomben-Ahriman',
      'Deep Palace Catoblepas': 'Katakomben-Catblepus'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Deep Palace Ahriman': 'ahriman des profondeurs',
      'Deep Palace Catoblepas': 'catoblépas des profondeurs'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Deep Palace Ahriman': 'ディープパレス・アーリマン',
      'Deep Palace Catoblepas': 'ディープパレス・カトブレパス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Deep Palace Ahriman': '深宫冥鬼之眼',
      'Deep Palace Catoblepas': '深宫卡托布莱帕斯'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Deep Palace Ahriman': '깊은 궁전 아리만',
      'Deep Palace Catoblepas': '깊은 궁전 카토블레파스'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_131_140 = (the_palace_of_the_dead_floors_131_140_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_141-150.ts



// Palace of the Dead Floors 141-150

const the_palace_of_the_dead_floors_141_150_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors141_150',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors141_150 */.Z.ThePalaceOfTheDeadFloors141_150,
  triggers: [
  // ---------------- Floor 141-149 Mobs ----------------
  {
    id: 'PotD 141-150 Deep Palace Bhoot Paralyze III',
    // inflicts Paralyze
    type: 'StartsUsing',
    netRegex: {
      id: '18F2',
      source: 'Deep Palace Bhoot'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'PotD 141-150 Deep Palace Persona Paralyze III',
    // same ability name, different mob
    // inflicts Paralyze
    type: 'StartsUsing',
    netRegex: {
      id: '18F4',
      source: 'Deep Palace Persona'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'PotD 141-150 Deep Palace Wraith Scream',
    // inflicts Terror (42)
    type: 'StartsUsing',
    netRegex: {
      id: '190A',
      source: 'Deep Palace Wraith'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'PotD 141-150 Deep Palace Succubus Void Fire IV',
    // very large AoE
    type: 'StartsUsing',
    netRegex: {
      id: '1B81',
      source: 'Deep Palace Succubus'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'PotD 141-150 Deep Palace Manticore Ripper Claw',
    // untelegraphed front cone AoE
    type: 'StartsUsing',
    netRegex: {
      id: '18FA',
      source: 'Deep Palace Manticore',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'PotD 141-150 Onyx Dragon Evil Eye',
    // gaze, inflicts Terror (42), combos with Miasma Breath (1B82)
    type: 'StartsUsing',
    netRegex: {
      id: '1B83',
      source: 'Onyx Dragon',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  },
  // ---------------- Floor 150 Boss: Tisiphone ----------------
  {
    id: 'PotD 141-150 Tisiphone Blood Rain',
    // big roomwide AoE
    type: 'StartsUsing',
    netRegex: {
      id: '1BF1',
      source: 'Tisiphone',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Deep Palace Bhoot': 'Katakomben-Bhut',
      'Deep Palace Manticore': 'Katakomben-Manticore',
      'Deep Palace Persona': 'Katakomben-Persona',
      'Deep Palace Succubus': 'Katakomben-Sukkubus',
      'Deep Palace Wraith': 'Katakomben-Geist',
      'Onyx Dragon': 'Onyxdrache',
      'Tisiphone': 'Tisiphone'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Deep Palace Bhoot': 'bhut des profondeurs',
      'Deep Palace Manticore': 'manticore des profondeurs',
      'Deep Palace Persona': 'persona des profondeurs',
      'Deep Palace Succubus': 'succube des profondeurs',
      'Deep Palace Wraith': 'spectre des profondeurs',
      'Onyx Dragon': 'dragon d\'onyx',
      'Tisiphone': 'Tisiphone'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Deep Palace Bhoot': 'ディープパレス・ブフート',
      'Deep Palace Manticore': 'ディープパレス・マンティコア',
      'Deep Palace Persona': 'ディープパレス・ペルソナ',
      'Deep Palace Succubus': 'ディープパレス・サキュバス',
      'Deep Palace Wraith': 'ディープパレス・レイス',
      'Onyx Dragon': 'オニキスドラゴン',
      'Tisiphone': 'ティーシポネー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Deep Palace Bhoot': '深宫浮灵',
      'Deep Palace Manticore': '深宫曼提克',
      'Deep Palace Persona': '深宫假面',
      'Deep Palace Succubus': '深宫梦魔',
      'Deep Palace Wraith': '深宫幽灵',
      'Onyx Dragon': '奥尼克斯龙',
      'Tisiphone': '提西福涅'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Deep Palace Bhoot': '깊은 궁전 브후트',
      'Deep Palace Manticore': '깊은 궁전 만티코어',
      'Deep Palace Persona': '깊은 궁전 페르소나',
      'Deep Palace Succubus': '깊은 궁전 서큐버스',
      'Deep Palace Wraith': '깊은 궁전 망령',
      'Onyx Dragon': '줄마노 드래곤',
      'Tisiphone': '티시포네'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_141_150 = (the_palace_of_the_dead_floors_141_150_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_151-160.ts




// Palace of the Dead Floors 151-160

const the_palace_of_the_dead_floors_151_160_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors151_160',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors151_160 */.Z.ThePalaceOfTheDeadFloors151_160,
  triggers: [
  // ---------------- Floor 151-159 Mobs ----------------
  {
    id: 'PotD 151-160 Deep Palace Deepeye Hypnotize',
    // gaze, inflicts Sleep
    type: 'StartsUsing',
    netRegex: {
      id: '1B1B',
      source: 'Deep Palace Deepeye',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'PotD 151-160 Deep Palace Pot Mysterious Light',
    // gaze, inflicts Blind
    type: 'StartsUsing',
    netRegex: {
      id: '1B29',
      source: 'Deep Palace Pot',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'PotD 151-160 Deep Palace Devilet Ice Spikes Cast',
    // gains Ice Spikes (C6), high counterattack damage when hit
    type: 'StartsUsing',
    netRegex: {
      id: '1B1F',
      source: 'Deep Palace Devilet'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'PotD 151-160 Deep Palace Devilet Ice Spikes Gain',
    // C6 = Ice Spikes, high counterattack damage when hit
    type: 'GainsEffect',
    netRegex: {
      effectId: 'C6',
      target: 'Deep Palace Devilet'
    },
    alertText: (_data, matches, output) => output.text({
      target: matches.target
    }),
    outputStrings: {
      text: {
        en: 'Stop attacking ${target}',
        de: 'Stoppe Angriffe auf ${target}',
        fr: 'N\'attaquez plus ${target}',
        cn: '停止攻击 ${target}',
        ko: '${target} 공격 중지'
      }
    }
  },
  // ---------------- Floor 160 Boss: Todesritter ----------------
  {
    id: 'PotD 151-160 Todesritter Valfodr',
    // charge with knockback
    type: 'StartsUsing',
    netRegex: {
      id: '1BF4',
      source: 'Todesritter'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback into Safe Spot',
        de: 'Rückstoß zur sicheren Stelle',
        fr: 'Faites-vous pousser dans une zone sûre',
        cn: '击退到安全区',
        ko: '안전지대로 넉백되기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Deep Palace Deepeye': 'Katakomben-Glotzauge',
      'Deep Palace Devilet': 'Katakomben-Eufel',
      'Deep Palace Pot': 'Katakomben-Manatopf',
      'Todesritter': 'Todesritter'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Deep Palace Deepeye': 'oculus des profondeurs',
      'Deep Palace Devilet': 'diablotin des profondeurs',
      'Deep Palace Pot': 'pot de mana des profondeurs',
      'Todesritter': 'Todesritter'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Deep Palace Deepeye': 'ディープパレス・ディープアイ',
      'Deep Palace Devilet': 'ディープパレス・デビレット',
      'Deep Palace Pot': 'ディープパレス・マナポット',
      'Todesritter': 'トーリスリッター'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Deep Palace Deepeye': '深宫深瞳',
      'Deep Palace Devilet': '深宫小恶魔',
      'Deep Palace Pot': '深宫魔力罐',
      'Todesritter': '非生骑士'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Deep Palace Deepeye': '깊은 궁전 볼록눈',
      'Deep Palace Devilet': '깊은 궁전 꼬마악마',
      'Deep Palace Pot': '깊은 궁전 마나 항아리',
      'Todesritter': '죽음의 기사'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_151_160 = (the_palace_of_the_dead_floors_151_160_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_161-170.ts



// Palace of the Dead Floors 161-170

const the_palace_of_the_dead_floors_161_170_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors161_170',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors161_170 */.Z.ThePalaceOfTheDeadFloors161_170,
  triggers: [
  // ---------------- Floor 161-169 Mobs ----------------
  {
    id: 'PotD 161-170 Deep Palace Diplocaulus Mucin',
    // gains Stoneskin (practically immune to damage for 8s)
    type: 'StartsUsing',
    netRegex: {
      id: '1B66',
      source: 'Deep Palace Diplocaulus'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'PotD 161-170 Deep Palace Diplocaulus Foregone Gleam',
    // front cone gaze
    type: 'StartsUsing',
    netRegex: {
      id: '1B2D',
      source: 'Deep Palace Diplocaulus',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }
  // ---------------- Floor 170 Boss: Yulunggu ----------------
  // intentionally blank
  ],

  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Deep Palace Diplocaulus': 'Katakomben-Diplocaulus'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Deep Palace Diplocaulus': 'diplocaulus des profondeurs'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Deep Palace Diplocaulus': 'ディープパレス・ディプロカウルス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Deep Palace Diplocaulus': '深宫笠头螈'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Deep Palace Diplocaulus': '깊은 궁전 디플로카울루스'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_161_170 = (the_palace_of_the_dead_floors_161_170_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_171-180.ts



// Palace of the Dead Floors 171-180
// TODO: Deep Palace Snowclops 100-tonze Swing (untelegraphed PBAoE)
// TODO: Deep Palace Wisent Khoomii (draw-in + heavy, combos with Horroisonous Blast, can avoid with knockback-prevent)
// TODO: Deep Palace Wisent Horroisonous Blast (large, high damage PBAoE, can be interrupted)
const the_palace_of_the_dead_floors_171_180_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors171_180',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors171_180 */.Z.ThePalaceOfTheDeadFloors171_180,
  triggers: [
  // ---------------- Floor 171-179 Mobs ----------------
  {
    id: 'PotD 171-180 Deep Palace Snowclops Glower',
    // untelegraphed front line AoE
    type: 'StartsUsing',
    netRegex: {
      id: '1B95',
      source: 'Deep Palace Snowclops',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'PotD 171-180 Bird of the Deep Palace Tropical Wind',
    // gains Haste and Attack Boost
    type: 'StartsUsing',
    netRegex: {
      id: '1B94',
      source: 'Bird of the Deep Palace'
    },
    response: responses/* Responses.interruptIfPossible */.n3.interruptIfPossible()
  },
  // ---------------- Floor 180 Boss: Dendainsonne ----------------
  {
    id: 'PotD 171-180 Dendainsonne Ecliptic Meteor',
    // 80% max HP damage
    type: 'StartsUsing',
    netRegex: {
      id: '1BFE',
      source: 'Dendainsonne'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 4,
    response: responses/* Responses.bigAoe */.n3.bigAoe('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bird of the Deep Palace': 'Katakombenvogel',
      'Deep Palace Snowclops': 'Katakomben-Schneezyklop',
      'Dendainsonne': 'Dendainsonne'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bird of the Deep Palace': 'oiseau des profondeurs',
      'Deep Palace Snowclops': 'chionope des profondeurs',
      'Dendainsonne': 'Dendainsonne'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bird of the Deep Palace': 'バード・オブ・ディープパレス',
      'Deep Palace Snowclops': 'ディープパレス・スノウクロプス',
      'Dendainsonne': 'デンダインゾネ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bird of the Deep Palace': '深宫妖鸟',
      'Deep Palace Snowclops': '深宫独眼雪巨人',
      'Dendainsonne': '丹代恩索涅'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bird of the Deep Palace': '깊은 궁전 새',
      'Deep Palace Snowclops': '깊은 궁전 눈보라 사이클롭스',
      'Dendainsonne': '덴다인존네'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_171_180 = (the_palace_of_the_dead_floors_171_180_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_181-190.ts



// Palace of the Dead Floors 181-190

const the_palace_of_the_dead_floors_181_190_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors181_190',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors181_190 */.Z.ThePalaceOfTheDeadFloors181_190,
  triggers: [
  // ---------------- Floor 181-189 Mobs ----------------
  {
    id: 'PotD 181-190 Deep Palace Garm Ram\'s Voice',
    // untelegraphed PBAoE
    type: 'StartsUsing',
    netRegex: {
      id: '1BA6',
      source: 'Deep Palace Garm'
    },
    alertText: (data, matches, output) => {
      if (data.CanSilence()) return output.interruptOrOut({
        name: matches.source
      });
      return output.out();
    },
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      interruptOrOut: {
        en: 'Out or interrupt ${name}',
        de: 'Raus oder unterbreche ${name}',
        fr: 'Éloignez-vous de ou interrompez ${name}',
        cn: '出去或打断 ${name}',
        ko: '밖으로 또는 ${name} 시전 끊기'
      }
    }
  }, {
    id: 'PotD 181-190 Deep Palace Garm Dragon\'s Voice',
    // untelegraphed donut AoE
    type: 'StartsUsing',
    netRegex: {
      id: '1BA7',
      source: 'Deep Palace Garm'
    },
    alertText: (data, matches, output) => {
      if (data.CanSilence()) return output.interruptOrUnder({
        name: matches.source
      });
      return output.getUnder();
    },
    outputStrings: {
      getUnder: outputs/* default.getUnder */.Z.getUnder,
      interruptOrUnder: {
        en: 'Get Under or interrupt ${name}',
        de: 'Unter oder unterbreche ${name}',
        fr: 'Allez dessous ou interrompez ${name}',
        cn: '去脚下或打断 ${name}',
        ko: '밑으로 또는 ${name} 시전 끊기'
      }
    }
  },
  // ---------------- Floor 190 Boss: The Godfather ----------------
  {
    id: 'PotD 181-190 Remedy Bomb Spawn',
    // 4579 = Remedy Bomb
    // kill before Hypothermal Combustion (1C03) finishes casting
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '4579'
    },
    alertText: (_data, matches, output) => output.kill({
      name: matches.name
    }),
    outputStrings: {
      kill: {
        en: 'Kill ${name}',
        de: 'Besiege ${name}',
        fr: 'Tuez ${name}',
        ja: '${name}を倒す',
        cn: '击杀 ${name}',
        ko: '${name} 처치'
      }
    }
  }, {
    id: 'PotD 181-190 Lava Bomb Spawn',
    // 4580 = Lava Bomb
    // The Godfather casts Massive Burst (1BBF), a non-interruptable, 99% HP roomwide attack
    // Lava Bomb casts Flashthoom (1C02), a small PBAoE which will interrupt Massive Burst
    // attack Lava Bomb to push it into The Godfather
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '4580'
    },
    alertText: (_data, matches, output) => output.pushToBoss({
      name: matches.name
    }),
    outputStrings: {
      pushToBoss: {
        en: 'Push ${name} into boss',
        de: 'Stoß ${name} in den Boss',
        fr: 'Poussez ${name} sur le boss',
        cn: '将 ${name} 推至BOSS',
        ko: '보스쪽으로 ${name} 밀기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Deep Palace Garm': 'Katakomben-Garm'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Deep Palace Garm': 'garm des profondeurs'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Deep Palace Garm': 'ディープパレス・ガルム'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Deep Palace Garm': '深宫加姆'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Deep Palace Garm': '깊은 궁전 가름'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_181_190 = (the_palace_of_the_dead_floors_181_190_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_floors_191-200.ts



// Palace of the Dead Floors 191-200

const the_palace_of_the_dead_floors_191_200_triggerSet = {
  id: 'ThePalaceOfTheDeadFloors191_200',
  zoneId: zone_id/* default.ThePalaceOfTheDeadFloors191_200 */.Z.ThePalaceOfTheDeadFloors191_200,
  triggers: [
  // ---------------- Floor 191-199 Mobs ----------------
  {
    id: 'PotD 191-200 Deep Palace Wraith Scream',
    // inflicts Terror (42)
    // same as Floors 141-150
    type: 'StartsUsing',
    netRegex: {
      id: '190A',
      source: 'Deep Palace Wraith'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'PotD 191-200 Onyx Dragon Evil Eye',
    // gaze, inflicts Terror (42), combos with Miasma Breath (1B82)
    // same as Floors 141-150
    type: 'StartsUsing',
    netRegex: {
      id: '1B83',
      source: 'Onyx Dragon',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'PotD 191-200 Deep Palace Fachan Level 5 Death',
    // untelegraphed cone AoE that causes instant death
    type: 'StartsUsing',
    netRegex: {
      id: '1BAC',
      source: 'Deep Palace Fachan',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'PotD 191-200 Deep Palace Knight Death Spiral',
    // donut AoE
    type: 'StartsUsing',
    netRegex: {
      id: '1BAA',
      source: 'Deep Palace Knight',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Deep Palace Fachan': 'Katakomben-Fachan',
      'Deep Palace Knight': 'Katakomben-Ritter',
      'Deep Palace Wraith': 'Katakomben-Geist',
      'Onyx Dragon': 'Onyxdrache'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Deep Palace Fachan': 'fachan des profondeurs',
      'Deep Palace Knight': 'chevalier des profondeurs',
      'Deep Palace Wraith': 'spectre des profondeurs',
      'Onyx Dragon': 'dragon d\'onyx'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Deep Palace Fachan': 'ディープパレス・ファハン',
      'Deep Palace Knight': 'ディープパレス・ナイト',
      'Deep Palace Wraith': 'ディープパレス・レイス',
      'Onyx Dragon': 'オニキスドラゴン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Deep Palace Fachan': '深宫幽鬼之眼',
      'Deep Palace Knight': '深宫骑士',
      'Deep Palace Wraith': '深宫幽灵',
      'Onyx Dragon': '奥尼克斯龙'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Deep Palace Fachan': '깊은 궁전 파한',
      'Deep Palace Knight': '깊은 궁전 기사',
      'Deep Palace Wraith': '깊은 궁전 망령',
      'Onyx Dragon': '줄마노 드래곤'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_floors_191_200 = (the_palace_of_the_dead_floors_191_200_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/deepdungeon/the_palace_of_the_dead_general.ts



// Triggers applicable to all Palace of the Dead floors.

const the_palace_of_the_dead_general_triggerSet = {
  id: 'ThePalaceOfTheDeadGeneral',
  zoneId: [zone_id/* default.ThePalaceOfTheDeadFloors1_10 */.Z.ThePalaceOfTheDeadFloors1_10, zone_id/* default.ThePalaceOfTheDeadFloors11_20 */.Z.ThePalaceOfTheDeadFloors11_20, zone_id/* default.ThePalaceOfTheDeadFloors21_30 */.Z.ThePalaceOfTheDeadFloors21_30, zone_id/* default.ThePalaceOfTheDeadFloors31_40 */.Z.ThePalaceOfTheDeadFloors31_40, zone_id/* default.ThePalaceOfTheDeadFloors41_50 */.Z.ThePalaceOfTheDeadFloors41_50, zone_id/* default.ThePalaceOfTheDeadFloors51_60 */.Z.ThePalaceOfTheDeadFloors51_60, zone_id/* default.ThePalaceOfTheDeadFloors61_70 */.Z.ThePalaceOfTheDeadFloors61_70, zone_id/* default.ThePalaceOfTheDeadFloors71_80 */.Z.ThePalaceOfTheDeadFloors71_80, zone_id/* default.ThePalaceOfTheDeadFloors81_90 */.Z.ThePalaceOfTheDeadFloors81_90, zone_id/* default.ThePalaceOfTheDeadFloors91_100 */.Z.ThePalaceOfTheDeadFloors91_100, zone_id/* default.ThePalaceOfTheDeadFloors101_110 */.Z.ThePalaceOfTheDeadFloors101_110, zone_id/* default.ThePalaceOfTheDeadFloors111_120 */.Z.ThePalaceOfTheDeadFloors111_120, zone_id/* default.ThePalaceOfTheDeadFloors121_130 */.Z.ThePalaceOfTheDeadFloors121_130, zone_id/* default.ThePalaceOfTheDeadFloors131_140 */.Z.ThePalaceOfTheDeadFloors131_140, zone_id/* default.ThePalaceOfTheDeadFloors141_150 */.Z.ThePalaceOfTheDeadFloors141_150, zone_id/* default.ThePalaceOfTheDeadFloors151_160 */.Z.ThePalaceOfTheDeadFloors151_160, zone_id/* default.ThePalaceOfTheDeadFloors161_170 */.Z.ThePalaceOfTheDeadFloors161_170, zone_id/* default.ThePalaceOfTheDeadFloors171_180 */.Z.ThePalaceOfTheDeadFloors171_180, zone_id/* default.ThePalaceOfTheDeadFloors181_190 */.Z.ThePalaceOfTheDeadFloors181_190, zone_id/* default.ThePalaceOfTheDeadFloors191_200 */.Z.ThePalaceOfTheDeadFloors191_200],
  zoneLabel: {
    en: 'The Palace of the Dead (All Floors)',
    de: 'Palast der Toten (Alle Ebenen)',
    fr: 'Le palais des morts (Tous les étages)',
    cn: '死者宫殿 (全楼层)',
    ko: '망자의 궁전 (전체 층)'
  },
  triggers: [
  // ---------------- Mimics ----------------
  {
    id: 'PotD General Mimic Spawn',
    // 2566 = Mimic (appears to be same npcNameId all floors)
    // floor 1-30 bronze chests, can stun or interrupt
    // floor 31-40 silver chests, can stun or interrupt
    // floor 41+ gold chests, can interrupt, immune to stun
    // TODO: some Mimics may spawn after transference between floors and get called early before being found
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '2566',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mimic spawned!',
        de: 'Mimik ist erschienen!',
        fr: 'Un mime est apparu !',
        cn: '已生成 拟态怪!',
        ko: '미믹 등장!'
      }
    }
  }, {
    id: 'PotD General Mimic Infatuation',
    // inflicts Accursed Pox (43F) if not interrupted
    type: 'StartsUsing',
    netRegex: {
      id: '18FD',
      source: 'Mimic'
    },
    response: responses/* Responses.interruptIfPossible */.n3.interruptIfPossible()
  },
  // ---------------- Pomanders ----------------
  {
    id: 'PotD General Pomander Duplicate',
    // duplicate item message: https://xivapi.com/LogMessage/7222?pretty=true
    // en: You return the pomander of ${pomander} to the coffer. You cannot carry any more of that item.
    type: 'SystemLogMessage',
    netRegex: {
      id: '1C36'
    },
    infoText: (_data, matches, output) => {
      switch (parseInt(matches.param1, 16)) {
        case 1:
          return output.duplicate({
            pomander: output.safety()
          });
        case 2:
          return output.duplicate({
            pomander: output.sight()
          });
        case 3:
          return output.duplicate({
            pomander: output.strength()
          });
        case 4:
          return output.duplicate({
            pomander: output.steel()
          });
        case 5:
          return output.duplicate({
            pomander: output.affluence()
          });
        case 6:
          return output.duplicate({
            pomander: output.flight()
          });
        case 7:
          return output.duplicate({
            pomander: output.alteration()
          });
        case 8:
          return output.duplicate({
            pomander: output.purity()
          });
        case 9:
          return output.duplicate({
            pomander: output.fortune()
          });
        case 10:
          return output.duplicate({
            pomander: output.witching()
          });
        case 11:
          return output.duplicate({
            pomander: output.serenity()
          });
        case 12:
          return output.duplicate({
            pomander: output.rage()
          });
        case 13:
          return output.duplicate({
            pomander: output.lust()
          });
        case 14:
          return output.duplicate({
            pomander: output.intuition()
          });
        case 15:
          return output.duplicate({
            pomander: output.raising()
          });
        case 16:
          return output.duplicate({
            pomander: output.resolution()
          });
        case 17:
          return output.duplicate({
            pomander: output.frailty()
          });
        case 18:
          return output.duplicate({
            pomander: output.concealment()
          });
        case 19:
          return output.duplicate({
            pomander: output.petrification()
          });
      }
    },
    outputStrings: {
      duplicate: {
        en: '${pomander} duplicate',
        de: 'Doppelter ${pomander}',
        fr: '${pomander} dupliqué',
        cn: '${pomander} 重复',
        ko: '${pomander} 중복'
      },
      // pomanders: https://xivapi.com/deepdungeonItem?pretty=true
      safety: {
        en: 'Safety',
        de: 'Siegelbruchs',
        fr: 'Désamorçage',
        ja: '呪印解除',
        cn: '咒印解除',
        ko: '함정 해제'
      },
      sight: {
        en: 'Sight',
        de: 'Sicht',
        fr: 'Localisation',
        ja: 'サイトロ',
        cn: '全景',
        ko: '사이트로'
      },
      strength: {
        en: 'Strength',
        de: 'Stärkung',
        fr: 'Puissance',
        ja: '自己強化',
        cn: '强化自身',
        ko: '자기 강화'
      },
      steel: {
        en: 'Steel',
        de: 'Abwehr',
        fr: 'Protection',
        ja: '防御強化',
        cn: '强化防御',
        ko: '방어 강화'
      },
      affluence: {
        en: 'Affluence',
        de: 'Schätze',
        fr: 'Décèlement',
        ja: '宝箱増加',
        cn: '宝箱增加',
        ko: '보물상자 증가'
      },
      flight: {
        en: 'Flight',
        de: 'Feindtods',
        fr: 'Sécurisation',
        ja: '敵排除',
        cn: '减少敌人',
        ko: '적 감소'
      },
      alteration: {
        en: 'Alteration',
        de: 'Feindwandlung',
        fr: 'Affaiblissement',
        ja: '敵変化',
        cn: '改变敌人',
        ko: '적 대체'
      },
      purity: {
        en: 'Purity',
        de: 'Entzauberung',
        fr: 'Anti-maléfice',
        ja: '解呪',
        cn: '解咒',
        ko: '저주 해제'
      },
      fortune: {
        en: 'Fortune',
        de: 'Glücks',
        fr: 'Chance',
        ja: '運気上昇',
        cn: '运气上升',
        ko: '운 상승'
      },
      witching: {
        en: 'Witching',
        de: 'Wandlung',
        fr: 'Mutation',
        ja: '形態変化',
        cn: '形态变化',
        ko: '적 변형'
      },
      serenity: {
        en: 'Serenity',
        de: 'Enthexung',
        fr: 'Dissipation',
        ja: '魔法効果解除',
        cn: '魔法效果解除',
        ko: '마법 효과 해제'
      },
      rage: {
        en: 'Rage',
        de: 'Manticoren',
        fr: 'Manticore',
        ja: 'マンティコア化',
        cn: '曼提克化',
        ko: '만티코어 변신'
      },
      lust: {
        en: 'Lust',
        de: 'Sukkuben',
        fr: 'Succube',
        ja: 'サキュバス化',
        cn: '梦魔化',
        ko: '서큐버스 변신'
      },
      intuition: {
        en: 'Intuition',
        de: 'Finders',
        fr: 'Intuition',
        ja: '財宝感知',
        cn: '感知宝藏',
        ko: '보물 탐지'
      },
      raising: {
        en: 'Raising',
        de: 'Lebens',
        fr: 'Résurrection',
        ja: 'リレイズ',
        cn: '重生',
        ko: '리레이즈'
      },
      resolution: {
        en: 'Resolution',
        de: 'Kuribu',
        fr: 'Kuribu',
        ja: 'クリブ化',
        cn: '基路伯化',
        ko: '쿠리부 변신'
      },
      frailty: {
        en: 'Frailty',
        de: 'Feindschwächung',
        fr: 'Incapacité',
        ja: '敵弱体',
        cn: '弱化敌人',
        ko: '적 약화'
      },
      concealment: {
        en: 'Concealment',
        de: 'Verschwindens',
        fr: 'Invisibilité',
        ja: 'バニシュ',
        cn: '隐形',
        ko: '배니시'
      },
      petrification: {
        en: 'Petrification',
        de: 'Feindversteinerung',
        fr: 'Pétrification',
        ja: '敵石化',
        cn: '石化敌人',
        ko: '적 석화'
      }
    }
  },
  // ---------------- Floor Notifications ----------------
  {
    id: 'PotD General Cairn of Passage',
    // portal to transfer between floors
    // Cairn of Passage activation message: https://xivapi.com/LogMessage/7245?pretty=true
    // en: The Cairn of Passage is activated!
    type: 'SystemLogMessage',
    netRegex: {
      id: '1C4D',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cairn of Passage activated',
        de: 'Wegleuchte aktiviert',
        fr: 'La pierre de téléportation s\'est activée',
        cn: '转移石冢已启动',
        ko: '전송 석탑 활성화'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Mimic': 'Nachahmung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Mimic': 'Mime'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Mimic': 'ものまね'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Mimic': '模仿'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Mimic': '흉내'
    }
  }]
};
/* harmony default export */ const the_palace_of_the_dead_general = (the_palace_of_the_dead_general_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/aetherochemical_research_facility.ts


// Aetherochemical Research Facility
const aetherochemical_research_facility_triggerSet = {
  id: 'TheAetherochemicalResearchFacility',
  zoneId: zone_id/* default.TheAetherochemicalResearchFacility */.Z.TheAetherochemicalResearchFacility,
  timelineFile: 'aetherochemical_research_facility.txt',
  timelineTriggers: [{
    id: 'Facility Bastardbluss',
    regex: /Bastardbluss/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Facility Hood Swing',
    regex: /Hood Swing/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Facility Chthonic Hush',
    regex: /Chthonic Hush/,
    beforeSeconds: 4,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Facility Height Of Chaos',
    regex: /Height Of Chaos/,
    beforeSeconds: 4,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'Facility Petrifaction',
    type: 'StartsUsing',
    netRegex: {
      id: '10EB',
      source: 'Harmachis',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Facility Inertia Stream',
    type: 'Ability',
    netRegex: {
      id: '10ED',
      source: 'Harmachis'
    },
    condition: data => {
      // Tanks technically shouldn't assist with this mechanic
      return data.role !== 'tank';
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Facility Dark Orb',
    type: 'StartsUsing',
    netRegex: {
      id: '10FC',
      source: ['Igeyorhm', 'Lahabrea']
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Facility Shadow Flare',
    type: 'StartsUsing',
    netRegex: {
      id: '1109',
      source: 'Ascian Prime',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Facility Annihilation',
    type: 'StartsUsing',
    netRegex: {
      id: '110A',
      source: 'Ascian Prime',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Facility Universal Manipulation',
    type: 'StartsUsing',
    netRegex: {
      id: '1105',
      source: 'Ascian Prime'
    },
    // The cast is ~10s, but it takes about 2s for correct execution to register
    // 6s to execute is *usually* enough time
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in dark portal',
        de: 'Im dunklen Portal stehen',
        fr: 'Placez-vous dans un portail noir',
        ja: '黒い玉に入る',
        cn: '进入黑洞',
        ko: '검은 포탈에 들어가기'
      }
    }
  }, {
    id: 'Facility Chaosphere',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Chaosphere',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid your orb--pop others\'',
        de: 'Weiche deinem Orb aus - löse die Orbs der anderen aus',
        fr: 'Évitez votre orbe, éclatez les autres',
        ja: '自分の玉を避け、他人の玉を砕く',
        cn: '躲开自己的球，去撞别人的球',
        ko: '내 구체는 피하고, 다른 구체 터트리기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Analysis and Proving': 'Prototypentest',
      'Ascian Prime': 'Prim-Ascian',
      'Blizzardsphere': 'Eissphäre',
      'Chaosphere': 'Chaossphäre',
      'Evaluation and Authentication': 'Evaluation und Zertifikation',
      'Firesphere': 'Feuersphäre',
      'Harmachis': 'Harmachis',
      'Igeyorhm': 'Igeyorhm',
      'Lahabrea': 'Lahabrea',
      'Magitek Turret I(?!I)': 'Magitek-Geschütz I',
      'Magitek Turret II': 'Magitek-Geschütz II',
      'Regula van Hydrus': 'Regula van Hydrus'
    },
    'replaceText': {
      'Aetherochemical Grenado': 'Magitek-Granate',
      'Ancient Circle': 'Orbis Antiquus',
      'Ancient Eruption': 'Antike Eruption',
      'Annihilation': 'Annihilation',
      'Ballistic Missile': 'Ballistische Rakete',
      'Bastardbluss': 'Bastardschuss',
      'Blizzard Burst': 'Eissplitter',
      'Blizzard Sphere': 'Eissphäre',
      'Chthonic Hush': 'Chthonisches Schweigen',
      'Circle of Flames': 'Feuerkreis',
      'Dark Blizzard II': 'Dunkel-Eisra',
      'Dark Fire II': 'Dunkel-Feura',
      'Dark Orb': 'Dunkler Orbis',
      'End of Days': 'Megiddoflamme',
      'Entropic Flame': 'Entropische Flamme',
      'Fire Burst': 'Feuerknall',
      'Gaseous Bomb': 'Ballistische Rakete',
      'Height of Chaos': 'Klimax des Chaos',
      'Hood Swing': 'Kapuzenschwung',
      'Inertia Stream': 'Trägheitsstrom',
      'Judgment': 'Aburteilung',
      'Ka': 'Ka',
      'Magitek Slug': 'Magitek-Projektil',
      'Magitek Spread': 'Magitek-Streuschuss',
      'Magitek Turret': 'Magitek-Gefechtsturm',
      'Permafrost': 'Pergelisol',
      'Petrifaction': 'Versteinerung',
      'Riddle of the Sphinx': 'Rätsel der Sphinx',
      'Sea of Pitch': 'Pech-See',
      'Self-detonate': 'Zerbersten',
      'Shadow Flare': 'Schattenflamme',
      'Steel Scales': 'Stahlschuppen',
      'Universal Manipulation': 'Umwertung aller Werte',
      'Weighing of the Heart': 'Gewissensprüfung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Analysis and Proving': 'Analyse et Essai',
      'Ascian Prime': 'Primo-Ascien',
      'Blizzardsphere': 'Sphère de glace',
      'Chaosphere': 'Sphère de chaos',
      'Evaluation and Authentication': 'Évaluation et Authentification',
      'Firesphere': 'Sphère de feu',
      'Harmachis': 'Horemakhet',
      'Igeyorhm': 'Igeyorhm',
      'Lahabrea': 'Lahabrea',
      'Magitek Turret I(?!I)': 'Tourelle magitek TM-I',
      'Magitek Turret II': 'Tourelle magitek TM-II',
      'Regula van Hydrus': 'Regula van Hydrus'
    },
    'replaceText': {
      '\\?': ' ?',
      'Aetherochemical Grenado': 'Grenade magitek',
      'Ancient Circle': 'Cercle ancien',
      'Ancient Eruption': 'Éruption ancienne',
      'Annihilation': 'Annihilation',
      'Ballistic Missile': 'Missiles balistiques',
      'Bastardbluss': 'Lacération vicieuse',
      'Blizzard Burst': 'Explosion glaciale',
      'Blizzard Sphere': 'Sphère de glace',
      'Chthonic Hush': 'Silence chthonien',
      'Circle of Flames': 'Cercle de flammes',
      'Dark Blizzard II': 'Extra Glace ténébreuse',
      'Dark Fire II': 'Extra Feu ténébreux',
      'Dark Orb': 'Orbe ténébreux',
      'End of Days': 'Jugement dernier',
      'Entropic Flame': 'Flamme entropique',
      'Fire Burst': 'Explosion ardente',
      'Gaseous Bomb': 'Bombe gazeuse',
      'Height of Chaos': 'Apogée du chaos',
      'Hood Swing': 'Coup de capot',
      'Inertia Stream': 'Courant apathique',
      'Judgment': 'Jugement',
      'Ka': 'Ka',
      'Magitek Slug': 'Projectile magitek',
      'Magitek Spread': 'Ensemencement magitek',
      'Magitek Turret': 'Tourelle magitek',
      'Permafrost': 'Pergélisol',
      'Petrifaction': 'Pétrification',
      'Riddle of the Sphinx': 'Énigme du Sphinx',
      'Sea of Pitch': 'Océan de goudron',
      'Self-detonate': 'Auto-atomisation',
      'Shadow Flare': 'Éruption ténébreuse',
      'Steel Scales': 'Écailles d\'acier',
      'Universal Manipulation': 'Manipulation universelle',
      'Weighing of the Heart': 'Pesée du cœur'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Analysis and Proving': '試作機実験庫',
      'Ascian Prime': 'アシエン・プライム',
      'Blizzardsphere': 'ブリザードスフィア',
      'Chaosphere': 'カオススフィア',
      'Evaluation and Authentication': '評価試験場',
      'Firesphere': 'ファイアスフィア',
      'Harmachis': 'ハルマキス',
      'Igeyorhm': 'アシエン・イゲオルム',
      'Lahabrea': 'アシエン・ラハブレア',
      'Magitek Turret I(?!I)': '魔導タレットI',
      'Magitek Turret II': '魔導タレットII',
      'Regula van Hydrus': 'レグラ・ヴァン・ヒュドルス'
    },
    'replaceText': {
      '(?<= )Appears': '出現',
      'Aetherochemical Grenado': '魔導榴弾',
      'Ancient Circle': 'エンシェントリング',
      'Ancient Eruption': 'エンシェントエラプション',
      'Annihilation': 'アナイアレイション',
      'Ballistic Missile': 'バリスティックミサイル',
      'Bastardbluss': 'ガンバスタード',
      'Blizzard Burst': 'ブリザードバースト',
      'Blizzard Sphere': 'ブリザードスフィア',
      'Chthonic Hush': 'クトニオスハッシュ',
      'Circle of Flames': 'サークル・オブ・フレイム',
      'Dark Blizzard II': 'ダークブリザラ',
      'Dark Fire II': 'ダークファイラ',
      'Dark Orb': 'ダークオーブ',
      'End of Days': 'メギドフレイム',
      'Entropic Flame': 'エントロピックフレイム',
      'Fire Burst': 'ファイアバースト',
      'Gaseous Bomb': '気化爆弾',
      'Height of Chaos': 'ハイト・オブ・カオス',
      'Hood Swing': 'フードスイング',
      'Inertia Stream': 'イナーシャストリーム',
      'Judgment': 'ジャッジメント',
      'Ka': 'カー',
      'Magitek Slug': '魔導スラッグショット',
      'Magitek Spread': '魔導バックショット',
      'Magitek Turret': '魔導タレット',
      'Permafrost': '永久凍土',
      'Petrifaction': 'ペトリファクション',
      'Riddle of the Sphinx': '謎かけ',
      'Sea of Pitch': 'シー・オブ・ピッチ',
      'Self-detonate': '爆発霧散',
      'Shadow Flare': 'シャドウフレア',
      'Steel Scales': 'スチールスケール',
      'Universal Manipulation': '法則改変',
      'Weighing of the Heart': '転生の儀'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Analysis and Proving': '试验机评测库',
      'Ascian Prime': '至尊无影',
      'Blizzardsphere': '寒冰晶球',
      'Chaosphere': '混沌晶球',
      'Evaluation and Authentication': '评测场',
      'Firesphere': '烈火晶球',
      'Harmachis': '赫鲁玛奇斯',
      'Igeyorhm': '以格约姆',
      'Lahabrea': '拉哈布雷亚',
      'Magitek Turret I(?!I)': '魔导炮塔I',
      'Magitek Turret II': '魔导炮塔II',
      'Regula van Hydrus': '雷古拉·范·休著斯'
    },
    'replaceText': {
      'Aetherochemical Grenado': '魔导榴弹',
      'Ancient Circle': '古代圆环',
      'Ancient Eruption': '古火喷发',
      'Annihilation': '湮灭',
      'Ballistic Missile': '弹道导弹',
      'Bastardbluss': '重枪剑',
      'Blizzard Burst': '冰结球炸裂',
      'Blizzard Sphere': '冰结球',
      'Chthonic Hush': '地府安宁',
      'Circle of Flames': '地层断裂',
      'Dark Blizzard II': '暗冰冻',
      'Dark Fire II': '暗烈炎',
      'Dark Orb': '暗天球',
      'End of Days': '末日之火',
      'Entropic Flame': '熵火',
      'Fire Burst': '火炎球炸裂',
      'Gaseous Bomb': '气化炸弹',
      'Height of Chaos': '混沌之巅',
      'Hood Swing': '甩头攻击',
      'Inertia Stream': '惰性流',
      'Judgment': '制裁',
      'Ka': '灵',
      'Magitek Slug': '魔导独头弹',
      'Magitek Spread': '魔导扩散弹',
      'Magitek Turret': '魔导炮塔',
      'Permafrost': '永久冻土',
      'Petrifaction': '石化',
      'Riddle of the Sphinx': '斯芬克斯之谜',
      'Sea of Pitch': '沥青海',
      'Self-detonate': '雾散爆发',
      'Shadow Flare': '暗影核爆',
      'Steel Scales': '钢鳞',
      'Universal Manipulation': '法则变更',
      'Weighing of the Heart': '转生之仪'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Analysis and Proving': '견본 기체 실험고',
      'Ascian Prime': '아씨엔 프라임',
      'Blizzardsphere': '눈보라 구체',
      'Chaosphere': '혼돈의 구체',
      'Evaluation and Authentication': '평가시험장',
      'Firesphere': '불의 구체',
      'Harmachis': '하르마키스',
      'Igeyorhm': '아씨엔 이게요름',
      'Lahabrea': '아씨엔 라하브레아',
      'Magitek Turret I(?!I)': '마도 포탑 I',
      'Magitek Turret II': '마도 포탑 II',
      'Regula van Hydrus': '레굴라 반 히드루스'
    },
    'replaceText': {
      'Aetherochemical Grenado': '마도 유탄',
      'Ancient Circle': '고대의 고리',
      'Ancient Eruption': '고대의 불기둥',
      'Annihilation': '멸절',
      'Ballistic Missile': '탄도 미사일',
      'Bastardbluss': '건바스타드',
      'Blizzard Burst': '블리자드 버스트',
      'Blizzard Sphere': '눈보라 구체',
      'Chthonic Hush': '지하신의 침묵',
      'Circle of Flames': '화염의 원',
      'Dark Blizzard II': '다크 블리자라',
      'Dark Fire II': '다크 파이라',
      'Dark Orb': '암흑 구체',
      'End of Days': '메기도 플레임',
      'Entropic Flame': '불확실한 불꽃',
      'Fire Burst': '파이어 버스트',
      'Gaseous Bomb': '기화 폭탄',
      'Height of Chaos': '혼돈의 정점',
      'Hood Swing': '머리 휘두르기',
      'Inertia Stream': '관성 기류',
      'Judgment': '심판의 날',
      'Ka': '카',
      'Magitek Slug': '마도 슬러그탄',
      'Magitek Spread': '마도 난사',
      'Magitek Turret': '마도 포탑',
      'Permafrost': '영원의 동토',
      'Petrifaction': '석화',
      'Riddle of the Sphinx': '수수께끼',
      'Sea of Pitch': '역청의 바다',
      'Self-detonate': '자가폭발',
      'Shadow Flare': '섀도우 플레어',
      'Steel Scales': '강철 비늘',
      'Universal Manipulation': '법칙 변조',
      'Weighing of the Heart': '윤회 의식'
    }
  }]
};
/* harmony default export */ const aetherochemical_research_facility = (aetherochemical_research_facility_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/aetherochemical_research_facility.txt
const dungeon_aetherochemical_research_facility_namespaceObject = "hideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~~~~~~~~~~~#\r\n# Regula van Hydrus #\r\n#~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 10E1\r\n# Analysis and Proving will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"63E\" }\r\n6.3 \"Bastardbluss\" Ability { id: \"10DA\", source: \"Regula van Hydrus\" } window 6.3,5\r\n\r\n13.4 \"Judgment\" Ability { id: \"10DD\", source: \"Regula van Hydrus\" } window 13.4,2.5\r\n18.6 \"Judgment\" Ability { id: \"10DE\", source: \"Regula van Hydrus\" }\r\n25.5 \"Bastardbluss\" Ability { id: \"10DA\", source: \"Regula van Hydrus\" }\r\n37.8 \"Bastardbluss\" Ability { id: \"10DA\", source: \"Regula van Hydrus\" }\r\n\r\n44.9 \"Judgment\" Ability { id: \"10DD\", source: \"Regula van Hydrus\" } window 15,3\r\n50.1 \"Judgment\" Ability { id: \"10DE\", source: \"Regula van Hydrus\" }\r\n57.0 \"Bastardbluss\" Ability { id: \"10DA\", source: \"Regula van Hydrus\" }\r\n69.3 \"Bastardbluss\" Ability { id: \"10DA\", source: \"Regula van Hydrus\" } jump 37.8\r\n\r\n76.4 \"Judgment\"\r\n81.6 \"Judgment\"\r\n88.5 \"Bastardbluss\"\r\n100.8 \"Bastardbluss\"\r\n\r\n# First turrets at HP < 80%\r\n150.0 \"Magitek Turret\" Ability { id: \"10E0\", source: \"Regula van Hydrus\" } window 150,5\r\n152.4 \"--sync--\" Ability { id: \"10DF\", source: \"Regula van Hydrus\" }\r\n157.8 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n161.4 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n165.1 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n166.4 \"--sync--\" Ability { id: \"10DF\", source: \"Regula van Hydrus\" }\r\n171.6 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n175.5 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n179.2 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n180.5 \"--sync--\" Ability { id: \"10DF\", source: \"Regula van Hydrus\" }\r\n185.4 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n188.8 \"Self-detonate?\" Ability { id: \"10E3\", source: \"Magitek Turret I\" }\r\n189.2 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n193.0 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n\r\n# Rotation resumes here whether or not turrets are successful\r\n199.3 \"Bastardbluss\" Ability { id: \"10DA\", source: \"Regula van Hydrus\" } window 50,1\r\n202.4 \"Bastardbluss\" Ability { id: \"10DA\", source: \"Regula van Hydrus\" }\r\n209.7 \"Judgment\" Ability { id: \"10DD\", source: \"Regula van Hydrus\" } window 15,2.5\r\n215.0 \"Judgment\" Ability { id: \"10DE\", source: \"Regula van Hydrus\" }\r\n\r\n221.9 \"Bastardbluss\" Ability { id: \"10DA\", source: \"Regula van Hydrus\" } window 10,10\r\n234.2 \"Bastardbluss\" Ability { id: \"10DA\", source: \"Regula van Hydrus\" }\r\n237.5 \"Bastardbluss\" Ability { id: \"10DA\", source: \"Regula van Hydrus\" }\r\n244.7 \"Judgment\" Ability { id: \"10DD\", source: \"Regula van Hydrus\" }\r\n249.9 \"Judgment\" Ability { id: \"10DE\", source: \"Regula van Hydrus\" } jump 215\r\n\r\n256.8 \"Bastardbluss\"\r\n269.1 \"Bastardbluss\"\r\n272.4 \"Bastardbluss\"\r\n279.6 \"Judgment\"\r\n284.8 \"Judgment\"\r\n\r\n# Second turrets at HP < 50%\r\n330.1 \"Magitek Turret\" Ability { id: \"10E0\", source: \"Regula van Hydrus\" } window 130,5\r\n332.5 \"--sync--\" Ability { id: \"10DF\", source: \"Regula van Hydrus\" }\r\n337.8 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n340.7 \"Aetherochemical Grenado\" Ability { id: \"10E2\", source: \"Magitek Turret II\" }\r\n341.4 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n345.0 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n345.7 \"Aetherochemical Grenado\" Ability { id: \"10E2\", source: \"Magitek Turret II\" }\r\n346.2 \"--sync--\" Ability { id: \"10DF\", source: \"Regula van Hydrus\" }\r\n350.9 \"Aetherochemical Grenado\" Ability { id: \"10E2\", source: \"Magitek Turret II\" }\r\n351.4 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n355.1 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n356.1 \"Aetherochemical Grenado\" Ability { id: \"10E2\", source: \"Magitek Turret II\" }\r\n358.8 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n360.0 \"--sync--\" Ability { id: \"10DF\", source: \"Regula van Hydrus\" }\r\n361.3 \"Aetherochemical Grenado\" Ability { id: \"10E2\", source: \"Magitek Turret II\" }\r\n365.0 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n368.0 \"Self-detonate?\" Ability { id: \"10E3\", source: [\"Magitek Turret I\", \"Magitek Turret II\"] }\r\n368.7 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n372.5 \"Magitek Slug\" Ability { id: \"10DB\", source: \"Regula van Hydrus\" }\r\n373.7 \"--sync--\" Ability { id: \"10DF\", source: \"Regula van Hydrus\" }\r\n\r\n# Brief rotation block\r\n379.3 \"Magitek Spread\" Ability { id: \"10DC\", source: \"Regula van Hydrus\" } window 150,5\r\n386.5 \"Bastardbluss\" Ability { id: \"10DA\", source: \"Regula van Hydrus\" }\r\n389.6 \"Bastardbluss\" Ability { id: \"10DA\", source: \"Regula van Hydrus\" }\r\n392.7 \"Bastardbluss\" Ability { id: \"10DA\", source: \"Regula van Hydrus\" }\r\n399.8 \"Judgment\" Ability { id: \"10DD\", source: \"Regula van Hydrus\" }\r\n405.0 \"Judgment\" Ability { id: \"10DE\", source: \"Regula van Hydrus\" }\r\n414.9 \"Magitek Spread\" Ability { id: \"10DC\", source: \"Regula van Hydrus\" } window 15,15\r\n422.0 \"Bastardbluss\" Ability { id: \"10DA\", source: \"Regula van Hydrus\" }\r\n\r\n# More turrets, same as the second set\r\n# Clean loop to HP = 0\r\n429.1 \"Magitek Turret\" Ability { id: \"10E0\", source: \"Regula van Hydrus\" } window 50,5 jump 330.1\r\n436.8 \"Magitek Slug\"\r\n439.7 \"Aetherochemical Grenado\"\r\n440.4 \"Magitek Slug\"\r\n444.0 \"Magitek Slug\"\r\n444.7 \"Aetherochemical Grenado\"\r\n449.9 \"Aetherochemical Grenado\"\r\n450.4 \"Magitek Slug\"\r\n454.1 \"Magitek Slug\"\r\n455.1 \"Aetherochemical Grenado\"\r\n457.8 \"Magitek Slug\"\r\n\r\n#~~~~~~~~~~~#\r\n# Harmachis #\r\n#~~~~~~~~~~~#\r\n\r\n# -ii 10ES\r\n# 10E8 is used at the beginning and end of all transformation sequences\r\n# It's not included at phase starts because each start is accompanied\r\n# by a unique version of the skill as well.\r\n\r\n# Evaluation and Authentication will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"63F\" } window 1000,5\r\n\r\n# Cobra is immediate\r\n1008.6 \"Weighing of the Heart\" Ability { id: \"10E8\", source: \"Harmachis\" } window 9,9\r\n1011.7 \"Steel Scales\" Ability { id: \"10EA\", source: \"Harmachis\" }\r\n1014.8 \"Hood Swing\" Ability { id: \"10E9\", source: \"Harmachis\" }\r\n1019.0 \"Weighing of the Heart\" Ability { id: \"138F\", source: \"Harmachis\" }\r\n\r\n# Base rotation after Cobra\r\n1024.6 \"Chthonic Hush\" Ability { id: \"10E7\", source: \"Harmachis\" }\r\n1033.3 \"Riddle of The Sphinx\" Ability { id: \"10E4\", source: \"Harmachis\" }\r\n1040.3 \"Chthonic Hush\" Ability { id: \"10E7\", source: \"Harmachis\" }\r\n1049.0 \"Riddle of The Sphinx\" Ability { id: \"10E4\", source: \"Harmachis\" }\r\n\r\n1056.0 \"Chthonic Hush\" Ability { id: \"10E7\", source: \"Harmachis\" }\r\n1064.7 \"Riddle of The Sphinx\" Ability { id: \"10E4\", source: \"Harmachis\" }\r\n1071.7 \"Chthonic Hush\" Ability { id: \"10E7\", source: \"Harmachis\" }\r\n1080.4 \"Riddle of The Sphinx\" Ability { id: \"10E4\", source: \"Harmachis\" } jump 1049\r\n\r\n1087.4 \"Chthonic Hush\"\r\n1096.1 \"Riddle of The Sphinx\"\r\n1103.1 \"Chthonic Hush\"\r\n\r\n# Naga form at HP < 80%\r\n1133.5 \"Weighing of the Heart\" Ability { id: \"ECE\", source: \"Harmachis\" } window 130,5\r\n1139.6 \"Petrifaction\" Ability { id: \"10EB\", source: \"Harmachis\" }\r\n1142.8 \"Circle of Flames x2\" # Same ID for both, syncing breaks things\r\n1145.9 \"Weighing of the Heart\" Ability { id: \"138F\", source: \"Harmachis\" }\r\n\r\n# Modified rotation after Naga\r\n1151.5 \"Chthonic Hush\" Ability { id: \"10E7\", source: \"Harmachis\" } window 10,10\r\n1160.1 \"Riddle of The Sphinx\" Ability { id: \"10E4\", source: \"Harmachis\" }\r\n1169.4 \"Ka\" Ability { id: \"10E6\", source: \"Harmachis\" }\r\n\r\n1177.0 \"Chthonic Hush\" Ability { id: \"10E7\", source: \"Harmachis\" } window 10,10\r\n1185.6 \"Riddle of The Sphinx\" Ability { id: \"10E4\", source: \"Harmachis\" }\r\n1194.9 \"Ka\" Ability { id: \"10E6\", source: \"Harmachis\" } jump 1169.4\r\n\r\n1202.5 \"Chthonic Hush\"\r\n1211.1 \"Riddle of The Sphinx\"\r\n1220.4 \"Ka\"\r\n1228.0 \"Chthonic Hush\"\r\n\r\n# Machina at HP < 50%\r\n1250.0 \"Weighing of the Heart\" Ability { id: \"ED0\", source: \"Harmachis\" } window 250,5\r\n1253.2 \"Inertia Stream\" Ability { id: \"10ED\", source: \"Harmachis\" }\r\n1258.3 \"Ballistic Missile 1\" Ability { id: \"10EE\", source: \"Harmachis\" }\r\n1259.3 \"Ballistic Missile 2\" Ability { id: \"12A3\", source: \"Harmachis\" }\r\n1260.4 \"Ballistic Missile 3\" Ability { id: \"10EF\", source: \"Harmachis\" }\r\n1265.6 \"Gaseous Bomb\" Ability { id: \"10F0\", source: \"Harmachis\" } window 10,10\r\n1269.7 \"Weighing of the Heart\" Ability { id: \"138F\", source: \"Harmachis\" }\r\n\r\n# Rotation resumes to HP = 0\r\n# Single rotation block is alternated with random form shift blocks\r\n1275.2 \"Chthonic Hush\" Ability { id: \"10E7\", source: \"Harmachis\" }\r\n1283.8 \"Riddle of The Sphinx\" Ability { id: \"10E4\", source: \"Harmachis\" }\r\n1293.1 \"Ka\" Ability { id: \"10E6\", source: \"Harmachis\" }\r\n1300.4 \"Weighing of the Heart\"\r\n1300.4 \"--sync--\" Ability { id: \"ED0\", source: \"Harmachis\" } jump 1250 # Machina\r\n1300.4 \"--sync--\" Ability { id: \"10E8\", source: \"Harmachis\" } jump 1350 # Cobra\r\n1300.4 \"--sync--\" Ability { id: \"ECE\", source: \"Harmachis\" } jump 1400 # Naga\r\n1303.5 \"Steel Scales?\"\r\n1303.6 \"Inertia Stream?\"\r\n1306.5 \"Petrifaction?\"\r\n\r\n# Random shift Cobra\r\n1350.0 \"Weighing of the Heart\" Ability { id: \"10E8\", source: \"Harmachis\" }\r\n1353.3 \"Steel Scales\" Ability { id: \"10EA\", source: \"Harmachis\" } window 10,10\r\n1356.5 \"Hood Swing\" Ability { id: \"10E9\", source: \"Harmachis\" }\r\n1360.5 \"Weighing of the Heart\" Ability { id: \"138F\", source: \"Harmachis\" }\r\n1366.2 \"Chthonic Hush\" Ability { id: \"10E7\", source: \"Harmachis\" } window 10,10 jump 1275.2\r\n1374.8 \"Riddle of The Sphinx\"\r\n1384.1 \"Ka\"\r\n1391.4 \"Weighing of the Heart\"\r\n1394.5 \"Steel Scales?\"\r\n1394.6 \"Inertia Stream?\"\r\n1397.5 \"Petrifaction?\"\r\n\r\n# Random shift Naga\r\n1400.0 \"Weighing of the Heart\" Ability { id: \"ECE\", source: \"Harmachis\" }\r\n1406.1 \"Petrifaction\" Ability { id: \"10EB\", source: \"Harmachis\" }\r\n1409.3 \"Circle of Flames x2\" # Same ID for both, syncing breaks things\r\n1412.4 \"Weighing of the Heart\" Ability { id: \"138F\", source: \"Harmachis\" }\r\n1418.0 \"Chthonic Hush\" Ability { id: \"10E8\", source: \"Harmachis\" } window 10,10 jump 1275.2\r\n1426.6 \"Riddle of The Sphinx\"\r\n1435.9 \"Ka\"\r\n1443.2 \"Weighing of the Heart\"\r\n1446.3 \"Steel Scales?\"\r\n1446.4 \"Inertia Stream?\"\r\n1449.3 \"Petrifaction?\"\r\n\r\n#~~~~~~~~~~~~~~~~~~~~~~~~#\r\n# Igeyorhm and LahabreaD #\r\n#~~~~~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 10F1 10F3 10F6 10F8 10F9 12DE\r\n# We can't sync to the zone seal message because it's a two-part battle\r\n\r\n2000.5 \"--sync--\" Ability { id: \"10F1\", source: \"Igeyorhm\" } window 2000.5,0\r\n2008.6 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" } window 9,5\r\n\r\n2009.0 \"End Of Days\" Ability { id: \"10FD\", source: \"Lahabrea\" }\r\n2015.8 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n2020.9 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Igeyorhm\" } window 15,15\r\n2023.4 \"End Of Days\" Ability { id: \"10FD\", source: \"Lahabrea\" }\r\n2024.5 \"Sea Of Pitch\" Ability { id: \"12DE\", source: \"Igeyorhm\" }\r\n2029.0 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n2037.2 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n\r\n2037.7 \"End Of Days\" Ability { id: \"10FD\", source: \"Lahabrea\" }\r\n2044.3 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n2049.5 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Igeyorhm\" } window 15,15\r\n2052.2 \"End Of Days\" Ability { id: \"10FD\", source: \"Lahabrea\" }\r\n2057.7 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n2066.0 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" } jump 2037.2\r\n\r\n2066.5 \"End Of Days\"\r\n2073.1 \"Dark Orb\"\r\n2078.3 \"Sea Of Pitch\"\r\n2081.0 \"End Of Days\"\r\n2086.5 \"Dark Orb\"\r\n2094.8 \"Dark Orb\"\r\n\r\n# Special attack at HP < 75%\r\n2100.0 \"Blizzard Sphere\" Ability { id: \"10F5\", source: \"Igeyorhm\" } window 100,5\r\n2105.2 \"Blizzard Burst\" Ability { id: \"10FE\", source: \"Blizzardsphere\" }\r\n2108.3 \"Fire Burst\" Ability { id: \"10FF\", source: \"Firesphere\" }\r\n2115.4 \"Blizzard Burst\" Ability { id: \"10FE\", source: \"Blizzardsphere\" }\r\n2118.5 \"Fire Burst\" Ability { id: \"10FF\", source: \"Firesphere\" }\r\n\r\n# Modified rotation to HP < 50%\r\n# The two Ascians de-sync here. This section\r\n# is super-long to avoid any possibility of choppiness.\r\n\r\n2122.6 \"Dark Blizzard II\" Ability { id: \"10F2\", source: \"Igeyorhm\" } window 20,20\r\n2123.8 \"End Of Days\" Ability { id: \"10FD\", source: \"Lahabrea\" }\r\n2131.7 \"Shadow Flare\" Ability { id: \"10FA\", source: \"Igeyorhm\" }\r\n2137.4 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" }\r\n2142.9 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n2148.1 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Igeyorhm\" } window 20,20\r\n2151.9 \"End Of Days\" Ability { id: \"10FD\", source: \"Lahabrea\" }\r\n2156.3 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n2163.5 \"Dark Blizzard II\" Ability { id: \"10F2\", source: \"Igeyorhm\" } window 20,20\r\n2165.3 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" }\r\n2172.5 \"Shadow Flare\" Ability { id: \"10FA\", source: \"Igeyorhm\" }\r\n2179.7 \"End Of Days\" Ability { id: \"10FD\", source: \"Lahabrea\" }\r\n2183.6 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n2188.8 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Igeyorhm\" } window 20,20\r\n2193.0 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" }\r\n2197.0 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n\r\n2204.2 \"Dark Blizzard II\" Ability { id: \"10F2\", source: \"Igeyorhm\" } window 20,20\r\n2207.4 \"End Of Days\" Ability { id: \"10FD\", source: \"Lahabrea\" }\r\n2213.2 \"Shadow Flare\" Ability { id: \"10FA\", source: \"Igeyorhm\" }\r\n2220.8 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" }\r\n2224.4 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n2229.6 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Igeyorhm\" } window 20,20\r\n2235.3 \"End Of Days\" Ability { id: \"10FD\", source: \"Lahabrea\" }\r\n2237.9 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n2245.0 \"Dark Blizzard II\" Ability { id: \"10F2\", source: \"Igeyorhm\" } window 20,20\r\n2248.7 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" }\r\n2254.1 \"Shadow Flare\" Ability { id: \"10FA\", source: \"Igeyorhm\" }\r\n2263.0 \"End Of Days\" Ability { id: \"10FD\", source: \"Lahabrea\" }\r\n2265.5 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n2270.6 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Igeyorhm\" } window 20,20\r\n2276.4 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" }\r\n2278.8 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n\r\n#Lahabrea de-syncs from here, so we just sync to Igeyorhm now\r\n2285.9 \"Dark Blizzard II\" Ability { id: \"10F2\", source: \"Igeyorhm\" } window 15,15\r\n2295.0 \"Shadow Flare\" Ability { id: \"10FA\", source: \"Igeyorhm\" }\r\n2306.2 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n2311.3 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Igeyorhm\" }\r\n2319.6 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n2326.7 \"Dark Blizzard II\" Ability { id: \"10F2\", source: \"Igeyorhm\" } window 15,15\r\n2335.8 \"Shadow Flare\" Ability { id: \"10FA\", source: \"Igeyorhm\" }\r\n2346.9 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n2352.1 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Igeyorhm\" }\r\n2360.3 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n\r\n2367.4 \"Dark Blizzard II\" Ability { id: \"10F2\", source: \"Igeyorhm\" } window 15,15\r\n2376.6 \"Shadow Flare\" Ability { id: \"10FA\", source: \"Igeyorhm\" }\r\n2387.8 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" }\r\n2392.9 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Igeyorhm\" }\r\n2401.2 \"Dark Orb\" Ability { id: \"10FC\", source: \"Igeyorhm\" } jump 2360.3\r\n# Jump here and hope for the best. This should never happen\r\n2408.4 \"Dark Blizzard II\"\r\n2417.5 \"Shadow Flare\"\r\n2428.7 \"Dark Orb\"\r\n2433.8 \"Sea Of Pitch\"\r\n2442.1 \"Dark Orb\"\r\n\r\n# Ascians swap roles at Igeyorhm HP <= 50%\r\n\r\n2500.0 \"End Of Days\" Ability { id: \"10FD\", source: \"Igeyorhm\" } window 400,5\r\n2505.1 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n2510.2 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Lahabrea\" }\r\n2514.5 \"End Of Days\" Ability { id: \"10FD\", source: \"Igeyorhm\" }\r\n2517.3 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" } window 20,20\r\n2524.4 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n\r\n2528.9 \"End Of Days\" Ability { id: \"10FD\", source: \"Igeyorhm\" }\r\n2534.0 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n2539.1 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Lahabrea\" }\r\n2543.4 \"End Of Days\" Ability { id: \"10FD\", source: \"Igeyorhm\" }\r\n2546.2 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" } window 20,20\r\n2553.3 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" } jump 2274.4\r\n\r\n2557.8 \"End Of Days\"\r\n2562.9 \"Dark Orb\"\r\n2568.0 \"Sea Of Pitch\"\r\n2572.3 \"End Of Days\"\r\n2575.1 \"Dark Fire II\"\r\n2582.2 \"Dark Orb\"\r\n\r\n# Special attack at HP < 75%\r\n2600.0 \"Permafrost\" Ability { id: \"10F4\", source: \"Igeyorhm\" } window 500,5\r\n2604.0 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" }\r\n2609.1 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" }\r\n2614.2 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" }\r\n2623.4 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" }\r\n\r\n# Modified rotation to HP < 50%\r\n2624.6 \"End Of Days\" Ability { id: \"10FD\", source: \"Igeyorhm\" }\r\n2632.4 \"Shadow Flare\" Ability { id: \"1381\", source: \"Lahabrea\" } window 20,20\r\n2638.0 \"Dark Blizzard II\" Ability { id: \"10F2\", source: \"Igeyorhm\" }\r\n2643.5 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n2648.7 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Lahabrea\" } window 20,20\r\n2652.8 \"End Of Days\" Ability { id: \"10FD\", source: \"Igeyorhm\" }\r\n2657.0 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n2664.1 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" } window 20,20\r\n2666.3 \"Dark Blizzard II\" Ability { id: \"10F2\", source: \"Igeyorhm\" }\r\n2673.4 \"Shadow Flare\" Ability { id: \"1381\", source: \"Lahabrea\" }\r\n2680.9 \"End Of Days\" Ability { id: \"10FD\", source: \"Igeyorhm\" }\r\n2684.5 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n2689.8 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Lahabrea\" } window 20,20\r\n2694.3 \"Dark Blizzard II\" Ability { id: \"10F2\", source: \"Igeyorhm\" }\r\n2697.9 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n2705.1 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" }\r\n\r\n2708.8 \"End Of Days\" Ability { id: \"10FD\", source: \"Igeyorhm\" }\r\n2714.3 \"Shadow Flare\" Ability { id: \"1381\", source: \"Lahabrea\" } window 20,20\r\n2722.3 \"Dark Blizzard II\" Ability { id: \"10F2\", source: \"Igeyorhm\" }\r\n2725.4 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n2730.5 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Lahabrea\" } window 20,20\r\n2736.9 \"End Of Days\" Ability { id: \"10FD\", source: \"Igeyorhm\" }\r\n2738.7 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n2745.9 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" } window 20,20\r\n2750.4 \"Dark Blizzard II\" Ability { id: \"10F2\", source: \"Igeyorhm\" }\r\n2755.1 \"Shadow Flare\" Ability { id: \"1381\", source: \"Lahabrea\" }\r\n2765.1 \"End Of Days\" Ability { id: \"10FD\", source: \"Igeyorhm\" }\r\n2766.4 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n2771.5 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Lahabrea\" } window 20,20\r\n2778.6 \"Dark Blizzard II\" Ability { id: \"10F2\", source: \"Igeyorhm\" }\r\n2779.6 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n2786.8 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" }\r\n\r\n# Same as before, just sync to Lahabrea now\r\n2795.9 \"Shadow Flare\" Ability { id: \"1381\", source: \"Lahabrea\" }\r\n2807.2 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n2812.3 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Lahabrea\" } window 20,20\r\n2820.7 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n2827.8 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" }\r\n\r\n2837.0 \"Shadow Flare\" Ability { id: \"1381\", source: \"Lahabrea\" }\r\n2848.3 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n2853.4 \"Sea Of Pitch\" Ability { id: \"10FB\", source: \"Lahabrea\" } window 20,20\r\n2861.8 \"Dark Orb\" Ability { id: \"10FC\", source: \"Lahabrea\" }\r\n2868.9 \"Dark Fire II\" Ability { id: \"10F7\", source: \"Lahabrea\" } jump 2827.8\r\n\r\n2878.1 \"Shadow Flare\"\r\n2889.4 \"Dark Orb\"\r\n2894.5 \"Sea Of Pitch\"\r\n2902.9 \"Dark Orb\"\r\n2910.0 \"Dark Fire II\"\r\n\r\n#~~~~~~~~~~~~~~#\r\n# Ascian Prime #\r\n#~~~~~~~~~~~~~~#\r\n\r\n# -ii 1104 1108 -ic \"Aetherial Tear\" \"Chaosphere\"\r\n# We can't sync to the zone seal message because it's a two-part battle\r\n\r\n3002.3 \"--sync--\" Ability { id: \"1100\", source: \"Ascian Prime\" } window 3003,2\r\n3005.8 \"Height Of Chaos\" Ability { id: \"1101\", source: \"Ascian Prime\" } window 5.8,5\r\n3013.0 \"Ancient Eruption\" Ability { id: \"1103\", source: \"Ascian Prime\" }\r\n3022.1 \"Shadow Flare\" Ability { id: \"1109\", source: \"Ascian Prime\" } window 15,15\r\n3028.2 \"Height Of Chaos\" Ability { id: \"1101\", source: \"Ascian Prime\" }\r\n\r\n3038.0 \"Height Of Chaos\" Ability { id: \"1101\", source: \"Ascian Prime\" }\r\n3045.2 \"Ancient Eruption\" Ability { id: \"1103\", source: \"Ascian Prime\" }\r\n3054.3 \"Shadow Flare\" Ability { id: \"1109\", source: \"Ascian Prime\" } window 15,15\r\n3060.4 \"Height Of Chaos\" Ability { id: \"1101\", source: \"Ascian Prime\" } jump 3028.2\r\n\r\n3070.2 \"Height Of Chaos\"\r\n3077.4 \"Ancient Eruption\"\r\n3086.5 \"Shadow Flare\"\r\n3092.6 \"Height Of Chaos\"\r\n\r\n# Intermission 1 at HP < 80%\r\n3100.0 \"--sync--\" AddedCombatant { name: \"Firesphere\" } window 100,5\r\n\r\n3110.0 \"Ancient Circle Appears\"\r\n3115.1 \"Ancient Circle\" Ability { id: \"1102\", source: \"Ascian Prime\" }\r\n3123.1 \"Annihilation\" Ability { id: \"110A\", source: \"Ascian Prime\" } window 25,5\r\n3132.1 \"Ancient Eruption\" Ability { id: \"1103\", source: \"Ascian Prime\" }\r\n3147.3 \"Universal Manipulation\" Ability { id: \"1105\", source: \"Ascian Prime\" }\r\n\r\n3156.4 \"Height Of Chaos\" Ability { id: \"1101\", source: \"Ascian Prime\" } window 50,5\r\n3163.5 \"Entropic Flame\" Ability { id: \"1107\", source: \"Ascian Prime\" }\r\n3168.6 \"Height Of Chaos\" Ability { id: \"1101\", source: \"Ascian Prime\" }\r\n3175.7 \"Ancient Eruption\" Ability { id: \"1103\", source: \"Ascian Prime\" } window 15,15\r\n3184.8 \"Shadow Flare\" Ability { id: \"1109\", source: \"Ascian Prime\" }\r\n\r\n3194.0 \"Height Of Chaos\" Ability { id: \"1101\", source: \"Ascian Prime\" }\r\n3201.1 \"Entropic Flame\" Ability { id: \"1107\", source: \"Ascian Prime\" } window 30,30\r\n3206.2 \"Height Of Chaos\" Ability { id: \"1101\", source: \"Ascian Prime\" }\r\n3213.3 \"Ancient Eruption\" Ability { id: \"1103\", source: \"Ascian Prime\" }\r\n3222.4 \"Shadow Flare\" Ability { id: \"1109\", source: \"Ascian Prime\" } window 15,15 jump 3184.8\r\n\r\n3231.6 \"Height Of Chaos\"\r\n3238.7 \"Entropic Flame\"\r\n3243.8 \"Height Of Chaos\"\r\n3250.9 \"Ancient Eruption\"\r\n3260.0 \"Shadow Flare\"\r\n\r\n# Intermission 2 at HP < 40%\r\n3300.0 \"--sync--\" AddedCombatant { name: \"Firesphere\" } window 200,5\r\n\r\n3304.6 \"Ancient Circle Appears\"\r\n3309.7 \"Ancient Circle\" Ability { id: \"1102\", source: \"Ascian Prime\" }\r\n3314.7 \"Ancient Circle Appears\"\r\n3319.8 \"Ancient Circle\" Ability { id: \"1102\", source: \"Ascian Prime\" }\r\n3322.8 \"Annihilation\" Ability { id: \"110A\", source: \"Ascian Prime\" } window 30,30\r\n3331.8 \"Ancient Eruption\" Ability { id: \"1103\", source: \"Ascian Prime\" }\r\n3347.0 \"Universal Manipulation\" Ability { id: \"1105\", source: \"Ascian Prime\" }\r\n\r\n3356.2 \"Height Of Chaos\" Ability { id: \"1101\", source: \"Ascian Prime\" } window 50,5\r\n3363.3 \"Entropic Flame\" Ability { id: \"1107\", source: \"Ascian Prime\" }\r\n3368.5 \"Height Of Chaos\" Ability { id: \"1101\", source: \"Ascian Prime\" }\r\n3375.6 \"Ancient Eruption\" Ability { id: \"1103\", source: \"Ascian Prime\" } window 15,15\r\n3384.8 \"Shadow Flare\" Ability { id: \"1109\", source: \"Ascian Prime\" }\r\n3390.9 \"Height Of Chaos x3\" duration 5.0\r\n\r\n3402.7 \"Height Of Chaos\" Ability { id: \"1101\", source: \"Ascian Prime\" }\r\n3409.8 \"Entropic Flame\" Ability { id: \"1107\", source: \"Ascian Prime\" }\r\n3415.0 \"Height Of Chaos\" Ability { id: \"1101\", source: \"Ascian Prime\" }\r\n3422.1 \"Ancient Eruption\" Ability { id: \"1103\", source: \"Ascian Prime\" } window 15,15\r\n3431.3 \"Shadow Flare\" Ability { id: \"1109\", source: \"Ascian Prime\" }\r\n3437.4 \"Height Of Chaos x3\" duration 5.0\r\n\r\n# Jumping from a following block to avoid sync issues with Height Of Chaos x3\r\n3449.2 \"Height Of Chaos\" Ability { id: \"1101\", source: \"Ascian Prime\" } jump 3402.7\r\n3456.3 \"Entropic Flame\"\r\n3461.5 \"Height Of Chaos\"\r\n3468.6 \"Ancient Eruption\"\r\n3477.8 \"Shadow Flare\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/baelsars_wall.ts



const baelsars_wall_triggerSet = {
  id: 'BaelsarsWall',
  zoneId: zone_id/* default.BaelsarsWall */.Z.BaelsarsWall,
  timelineFile: 'baelsars_wall.txt',
  timelineTriggers: [{
    id: 'Baelsar Magitek Cannon',
    regex: /Magitek Cannon/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Baelsar Dull Blade',
    regex: /Dull Blade/,
    beforeSeconds: 4,
    response: responses/* Responses.miniBuster */.n3.miniBuster()
  }],
  triggers: [{
    id: 'Baelsar Magitek Claw',
    type: 'StartsUsing',
    netRegex: {
      id: '1CB2',
      source: 'Magitek Predator'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Baelsar Magitek Ray',
    type: 'StartsUsing',
    netRegex: {
      id: '1CB3',
      source: 'Magitek Predator',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Baelsar Needle Burst',
    type: 'StartsUsing',
    netRegex: {
      id: '1DC8',
      source: 'Magitek Vanguard D-1'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun()
  }, {
    id: 'Baelsar Launcher',
    type: 'StartsUsing',
    netRegex: {
      id: '1CBC',
      source: 'Magitek Predator',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Baelsar Dynamic Sensory Jammer',
    type: 'GainsEffect',
    netRegex: {
      effectId: '46C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.stopEverything */.n3.stopEverything()
  }, {
    id: 'Baelsar Griffin Beak',
    type: 'StartsUsing',
    netRegex: {
      id: '1CC3',
      source: 'The Griffin',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Baelsar Flash Powder',
    type: 'StartsUsing',
    netRegex: {
      id: '1CC4',
      source: 'The Griffin'
    },
    response: responses/* Responses.lookAwayFromSource */.n3.lookAwayFromSource()
  }, {
    id: 'Baelsar Griffin Claw',
    type: 'StartsUsing',
    netRegex: {
      id: '1CC2',
      source: 'The Griffin'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Baelsar Big Boot',
    type: 'HeadMarker',
    netRegex: {
      id: '1CC4'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.knockbackOn */.n3.knockbackOn()
  }, {
    id: 'Baelsar Restraint Collar',
    type: 'StartsUsing',
    netRegex: {
      id: '1CC8',
      source: 'The Griffin'
    },
    condition: conditions/* default.targetIsNotYou */.Z.targetIsNotYou(),
    alertText: (data, matches, output) => output.text({
      player: data.party.member(matches.target)
    }),
    outputStrings: {
      text: {
        en: 'Break chain on ${player}',
        de: 'Kette von ${player} brechen',
        fr: 'Cassez la chaînes sur ${player}',
        ja: '${player}の線を取る',
        cn: '截断${player}的线',
        ko: '${player}의 사슬 부수기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Armored Weapon': 'Panzerwaffe',
      'Blade Of The Griffin': 'Greifenklinge',
      'Magitek Bit': 'Éjection de drones',
      'Magitek Predator': 'Magitek-Prädator',
      'Magitek Vanguard D-1': 'Magitek-Frontbrecher D-1',
      'The Airship Landing': 'Luftschiff-Landeplatz',
      '(?<! )The Griffin': 'Ilberd',
      'The Magitek Installation': 'Magitek-Lager',
      'Via Praetoria': 'Via Praetoria'
    },
    'replaceText': {
      '--teleport(?!ation)': '--Teleport',
      'Assault Cannon': 'Canon d\'assaut',
      'Beak Of The Griffin': 'Greifenschnabel',
      'Big Boot': 'Beherzter Tritt',
      'Claw Of The Griffin': 'Greifenklaue',
      'Corrosion': 'Korrosion',
      'Diffractive Laser': 'Laser diffractif',
      'Distress Beacon': 'Appel de renforts',
      'Dull Blade': 'Stumpfklinge',
      'Dynamic Sensory Jammer': 'Brouilleur sensoriel',
      'Flash Powder': 'Blendpulver',
      'Gull Dive': 'Tauchflug',
      'Launcher': 'Raketenwerfer',
      'Lionshead': 'Löwenkopf',
      'Magitek Bit': 'Éjection de drones',
      'Magitek Cannon': 'Canon magitek',
      'Magitek Claw': 'Griffes magitek',
      'Magitek Missile': 'Missiles magitek',
      'Magitek Ray': 'Rayon magitek',
      'Restraint Collar': 'Chaîne de fer',
      'Sanguine Blade': 'Sanguis-Klinge'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Armored Weapon': 'Arme blindée',
      'Blade Of The Griffin': 'Lame du Griffon',
      'Magitek Bit': 'Drone magitek',
      'Magitek Predator': 'Prédateur magitek',
      'Magitek Vanguard D-1': 'Avant-garde magitek de défense',
      'The Airship Landing': 'terrain d\'atterrissage',
      '(?<! )The Griffin': 'Ilberd le Griffon',
      'The Magitek Installation': 'hangar magitek',
      'Via Praetoria': 'Via Praetoria'
    },
    'replaceText': {
      '\\?': ' ?',
      '--teleport': '--téléportation',
      'Assault Cannon': 'Cannon d\'assaut',
      'Beak Of The Griffin': 'Bec du Griffon',
      'Big Boot': 'Chassé destructeur',
      'Claw Of The Griffin': 'Serre du Griffon',
      'Corrosion': 'Désagrégation',
      'Diffractive Laser': 'Laser diffractif',
      'Distress Beacon': 'Appel de renforts',
      'Dull Blade': 'Lame émoussée',
      'Dynamic Sensory Jammer': 'Brouilleur sensoriel',
      'Flash Powder': 'Poudre aveuglante',
      'Gull Dive': 'Piqué de l\'aigle',
      'Launcher': 'Lance-roquettes',
      'Lionshead': 'Tête de lion',
      'Magitek Bit': 'Éjection de drones',
      'Magitek Cannon': 'Canon magitek',
      'Magitek Claw': 'Griffes magitek',
      'Magitek Missile': 'Missiles magitek',
      'Magitek Ray': 'Rayon magitek',
      'Restraint Collar': 'Chaîne de fer',
      'Sanguine Blade': 'Lame sanguine'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Armored Weapon': 'アームドウェポン',
      'Blade Of The Griffin': 'グリフィンブレード',
      'Magitek Bit': '魔導ビット',
      'Magitek Predator': '魔導プレデター',
      'Magitek Vanguard D-1': '魔導ヴァンガード防衛型',
      'The Airship Landing': '飛空戦艦発着場',
      '(?<! )The Griffin': '鉄面のイルベルド',
      'The Magitek Installation': '魔導兵器格納庫',
      'Via Praetoria': 'ヴィア・プラエトリア'
    },
    'replaceText': {
      'Assault Cannon': 'アサルトカノン',
      'Beak Of The Griffin': 'ビーク・オブ・グリフィン',
      'Big Boot': 'ビックブート',
      'Claw Of The Griffin': 'クロウ・オブ・グリフィン',
      'Corrosion': '溶解',
      'Diffractive Laser': '拡散レーザー',
      'Distress Beacon': '援軍要請',
      'Dull Blade': 'ダルブレード',
      'Dynamic Sensory Jammer': '動体感知ジャマー',
      'Flash Powder': 'フラッシュパウダー',
      'Gull Dive': 'ガルダイブ',
      'Launcher': 'ランチャー',
      'Lionshead': 'ライオンヘッド',
      'Magitek Bit': 'ビット射出',
      'Magitek Cannon': '魔導カノン',
      'Magitek Claw': '魔導クロー',
      'Magitek Missile': '魔導ミサイル',
      'Magitek Ray': '魔導レーザー',
      'Restraint Collar': '鉄鎖',
      'Sanguine Blade': 'サングインブレード'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Armored Weapon': '武装重甲',
      'Blade Of The Griffin': '狮鹫之刃',
      'Magitek Bit': '魔导浮游炮',
      'Magitek Predator': '魔导猎手',
      'Magitek Vanguard D-1': '魔导先锋防卫型',
      'The Airship Landing': '飞空战舰着陆场',
      '(?<! )The Griffin': '铁面公卿 伊尔伯德',
      'The Magitek Installation': '魔导兵器仓库',
      'Via Praetoria': '天营路'
    },
    'replaceText': {
      '--teleport': '--传送',
      'Assault Cannon': '突击加农炮',
      'Beak Of The Griffin': '狮鹫之喙',
      'Big Boot': '大靴重踹',
      'Claw Of The Griffin': '狮鹫之爪',
      'Corrosion': '溶解',
      'Diffractive Laser': '扩散射线',
      'Distress Beacon': '请求支援',
      'Dull Blade': '钝剑',
      'Dynamic Sensory Jammer': '运动体探知干扰器',
      'Flash Powder': '闪光粉',
      'Gull Dive': '海鸟冲',
      'Launcher': '火箭炮',
      'Lionshead': '狮子首',
      'Magitek Bit': '浮游炮射出',
      'Magitek Cannon': '魔导加农炮',
      'Magitek Claw': '魔导爪',
      'Magitek Missile': '魔导飞弹',
      'Magitek Ray': '魔导激光',
      'Restraint Collar': '锁链',
      'Sanguine Blade': '嗜血刃'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Armored Weapon': '무장 병기',
      'Blade Of The Griffin': '그리핀의 검',
      'Magitek Bit': '비트 사출',
      'Magitek Predator': '마도 프레데터',
      'Magitek Vanguard D-1': '마도 뱅가드 방어형',
      'The Airship Landing': '골드 소서 비공정 승강장',
      '(?<! )The Griffin': '철가면 일베르드',
      'The Magitek Installation': '마도 병기 격납고',
      'Via Praetoria': '근위대의 길'
    },
    'replaceText': {
      '--teleport': '--순간 이동',
      'Assault Cannon': '맹공포',
      'Beak Of The Griffin': '그리핀의 부리',
      'Big Boot': '걷어차기',
      'Claw Of The Griffin': '그리핀의 발톱',
      'Corrosion': '용해',
      'Diffractive Laser': '확산 레이저',
      'Distress Beacon': '지원 요청',
      'Dull Blade': '무딘 칼날',
      'Dynamic Sensory Jammer': '동작 감지 교란',
      'Flash Powder': '플래시 파우더',
      'Gull Dive': '갈매기 강하',
      'Launcher': '척탄',
      'Lionshead': '사자 머리',
      'Magitek Bit': '비트 사출',
      'Magitek Cannon': '마도포',
      'Magitek Claw': '마도 서슬발톱',
      'Magitek Missile': '마도 미사일',
      'Magitek Ray': '마도 레이저',
      'Restraint Collar': '쇠사슬',
      'Sanguine Blade': '핏빛 칼날'
    }
  }]
};
/* harmony default export */ const baelsars_wall = (baelsars_wall_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/baelsars_wall.txt
const dungeon_baelsars_wall_namespaceObject = "### BAELSAR'S WALL\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~~~~~~~~~~#\r\n# MAGITEK PREDATOR #\r\n#~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ic Sky Armor Reinforcement\r\n\r\n# Timings on this encounter drift up to 2-3 seconds.\r\n# We're not sure precisely what causes this,\r\n# but it could be related to how quickly the adds die.\r\n# When solo, the second Missile is skipped and the timeline just keeps on.\r\n# We sync on Magitek Ray and hope for the best. It's all bad.\r\n\r\n# Via Praetoria will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"746\" } window 0,1\r\n10.5 \"Magitek Claw\" Ability { id: \"1CB2\", source: \"Magitek Predator\" }\r\n26.8 \"Magitek Ray\" Ability { id: \"1CB3\", source: \"Magitek Predator\" }\r\n34.1 \"Magitek Missile\" Ability { id: \"1CB4\", source: \"Magitek Predator\" }\r\n\r\n44.4 \"Magitek Ray\" Ability { id: \"1CB3\", source: \"Magitek Predator\" }\r\n54.5 \"Magitek Claw\" Ability { id: \"1CB2\", source: \"Magitek Predator\" } window 5,5\r\n68.7 \"Magitek Missile\" Ability { id: \"1CB4\", source: \"Magitek Predator\" }\r\n70.8 \"Magitek Missile\" Ability { id: \"1CB4\", source: \"Magitek Predator\" }\r\n\r\n73.2 \"--sync--\" StartsUsing { id: \"1CB3\", source: \"Magitek Predator\" } window 10,10\r\n75.9 \"Magitek Ray\" Ability { id: \"1CB3\", source: \"Magitek Predator\" } jump 44.4\r\n89.0 \"Magitek Claw\"\r\n98.4 \"Magitek Missile\"\r\n100.6 \"Magitek Missile\"\r\n\r\n#~~~~~~~~~~~~~~~~#\r\n# ARMORED WEAPON #\r\n#~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 1CB7 1CBA\r\n\r\n# The Magitek Installation will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"747\" } window 1000,5\r\n1007.1 \"Magitek Cannon\" Ability { id: \"1CB8\", source: \"Armored Weapon\" } window 7.1,5\r\n1013.2 \"Launcher\" Ability { id: \"1CBC\", source: \"Armored Weapon\" }\r\n1019.4 \"Dynamic Sensory Jammer\" Ability { id: \"1CB9\", source: \"Armored Weapon\" } duration 6\r\n1033.7 \"Diffractive Laser\" Ability { id: \"1CBB\", source: \"Armored Weapon\" }\r\n\r\n1039.9 \"Distress Beacon?\" Ability { id: \"1CBE\", source: \"Armored Weapon\" } window 39.9,5 jump 1100\r\n1039.9 \"Magitek Bit?\" Ability { id: \"1CBD\", source: \"Armored Weapon\" } window 39.9,5 jump 1155.6\r\n1049.1 \"Launcher?\"\r\n1051.8 \"Assault Cannon?\"\r\n1053.2 \"Magitek Cannon?\"\r\n1054.1 \"Diffractive Laser?\"\r\n\r\n\r\n1100.0 \"Distress Beacon\" Ability { id: \"1CBE\", source: \"Armored Weapon\" }\r\n1109.2 \"Launcher\" Ability { id: \"1CBC\", source: \"Armored Weapon\" }\r\n1113.3 \"Magitek Cannon\" Ability { id: \"1CB8\", source: \"Armored Weapon\" }\r\n1120.4 \"Launcher\" Ability { id: \"1CBC\", source: \"Armored Weapon\" }\r\n1125.5 \"Dynamic Sensory Jammer\" Ability { id: \"1CB9\", source: \"Armored Weapon\" } duration 6\r\n1133.3 \"Diffractive Laser\" Ability { id: \"1CBB\", source: \"Armored Weapon\" } window 10,10\r\n1137.4 \"Magitek Cannon\" Ability { id: \"1CB8\", source: \"Armored Weapon\" }\r\n1144.4 \"Launcher\" Ability { id: \"1CBC\", source: \"Armored Weapon\" }\r\n\r\n1155.6 \"Magitek Bit\" Ability { id: \"1CBD\", source: \"Armored Weapon\" } window 30,30\r\n1161.5 \"--sync--\" Ability { id: \"1CBF\", source: \"Magitek Bit\" }\r\n1167.5 \"Assault Cannon\" Ability { id: \"1CC0\", source: \"Magitek Bit\" }\r\n1169.8 \"Diffractive Laser\" Ability { id: \"1CBB\", source: \"Armored Weapon\" } window 10,10\r\n1175.9 \"Launcher\" Ability { id: \"1CBC\", source: \"Armored Weapon\" }\r\n1181.0 \"Dynamic Sensory Jammer\" Ability { id: \"1CB9\", source: \"Armored Weapon\" } duration 6\r\n1188.9 \"Diffractive Laser\" Ability { id: \"1CBB\", source: \"Armored Weapon\" }\r\n1193.0 \"Magitek Cannon\" Ability { id: \"1CB8\", source: \"Armored Weapon\" }\r\n1200.0 \"Launcher\" Ability { id: \"1CBC\", source: \"Armored Weapon\" }\r\n\r\n1211.2 \"Distress Beacon\" Ability { id: \"1CBE\", source: \"Armored Weapon\" } window 30,30 jump 1100\r\n1220.4 \"Launcher\"\r\n1224.5 \"Magitek Cannon\"\r\n1231.6 \"Launcher\"\r\n1236.7 \"Dynamic Sensory Jammer\"\r\n1244.5 \"Diffractive Laser\"\r\n\r\n#~~~~~~~~~~~~~#\r\n# THE GRIFFIN #\r\n#~~~~~~~~~~~~~#\r\n\r\n# The Airship Landing will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"748\" } window 2000,5\r\n2006.1 \"Dull Blade\" Ability { id: \"1CC1\", source: \"The Griffin\" } window 6.1,5\r\n2012.2 \"Beak Of The Griffin\" Ability { id: \"1CC3\", source: \"The Griffin\" }\r\n2019.3 \"Flash Powder\" Ability { id: \"1CC4\", source: \"The Griffin\" }\r\n2021.4 \"--teleport--\" Ability { id: \"1CC6\", source: \"The Griffin\" }\r\n2026.9 \"Sanguine Blade\" Ability { id: \"1CC5\", source: \"The Griffin\" }\r\n\r\n2036.0 \"Claw Of The Griffin\" Ability { id: \"1CC2\", source: \"The Griffin\" } window 36,6\r\n2046.2 \"Gull Dive x7\" duration 5.6 # Ability { id: \"1CCB\", source: \"Blade Of The Griffin\" }\r\n2053.1 \"Lionshead\" Ability { id: \"1CCA\", source: \"The Griffin\" }\r\n2060.3 \"Dull Blade\" Ability { id: \"1CC1\", source: \"The Griffin\" }\r\n2066.4 \"Flash Powder\" Ability { id: \"1CC4\", source: \"The Griffin\" } window 30,30\r\n2071.6 \"Big Boot\" Ability { id: \"1CC7\", source: \"The Griffin\" }\r\n2077.7 \"Corrosion\" Ability { id: \"1CCC\", source: \"Blade Of The Griffin\" } window 30,30\r\n2077.8 \"--teleport--\" Ability { id: \"1CC6\", source: \"The Griffin\" }\r\n2083.3 \"Sanguine Blade\" Ability { id: \"1CC5\", source: \"The Griffin\" }\r\n2088.5 \"Dull Blade\" Ability { id: \"1CC1\", source: \"The Griffin\" }\r\n2095.6 \"Restraint Collar\" Ability { id: \"1CC8\", source: \"The Griffin\" } window 30,30\r\n2104.7 \"Beak Of The Griffin\" Ability { id: \"1CC3\", source: \"The Griffin\" }\r\n2108.8 \"Dull Blade\" Ability { id: \"1CC1\", source: \"The Griffin\" }\r\n2111.9 \"--teleport 1--\" # Ability { id: \"1CC6\", source: \"The Griffin\" }\r\n2112.7 \"--teleport 2--\" # Ability { id: \"1CC6\", source: \"The Griffin\" }\r\n2118.2 \"Sanguine Blade\" Ability { id: \"1CC5\", source: \"The Griffin\" }\r\n2125.3 \"Beak Of The Griffin\" Ability { id: \"1CC3\", source: \"The Griffin\" }\r\n\r\n2133.4 \"Claw Of The Griffin\" Ability { id: \"1CC2\", source: \"The Griffin\" } window 30,30 jump 2036\r\n2139.6 \"Gull Dive\"\r\n2146.5 \"Lionshead\"\r\n2153.7 \"Dull Blade\"\r\n2159.8 \"Flash Powder\"\r\n2164.9 \"Big Boot\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/fractal_continuum.ts


// Fractal Continuum
const fractal_continuum_triggerSet = {
  id: 'TheFractalContinuum',
  zoneId: zone_id/* default.TheFractalContinuum */.Z.TheFractalContinuum,
  timelineFile: 'fractal_continuum.txt',
  timelineTriggers: [{
    id: 'Fractal Atmospheric Displacement',
    regex: /Atmospheric Displacement/,
    beforeSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Fractal Sanctification',
    regex: /Sanctification/,
    beforeSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Fractal Unholy',
    regex: /Unholy/,
    beforeSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  triggers: [{
    id: 'Fractal Rapid Sever',
    type: 'StartsUsing',
    netRegex: {
      id: 'F7A',
      source: 'Phantom Ray'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Fractal Slash',
    type: 'StartsUsing',
    netRegex: {
      id: 'F83',
      source: 'Minotaur',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Fractal Swipe',
    type: 'StartsUsing',
    netRegex: {
      id: 'F81',
      source: 'Minotaur',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Fractal Small Swing',
    type: 'StartsUsing',
    netRegex: {
      id: 'F82',
      source: 'Minotaur',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Fractal Big Swing',
    type: 'StartsUsing',
    netRegex: {
      id: 'F87',
      source: 'Minotaur',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Use a cage',
        de: 'Benutze einen Käfig',
        fr: 'Utilisez un incubateur',
        ja: 'キメラ培養器を使う',
        cn: '打开笼子',
        ko: '키메라 배양기 사용하기'
      }
    }
  }, {
    id: 'Fractal Aetherochemical Bomb',
    type: 'GainsEffect',
    netRegex: {
      effectId: '2D3',
      capture: false
    },
    condition: data => data.CanCleanse(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse bomb',
        de: 'Reinige Bomben-Debuff',
        fr: 'Guérison => Debuff bombe',
        ja: 'エスナ：魔科学爆弾',
        cn: '康复魔炸弹',
        ko: '폭탄 디버프 해제'
      }
    }
  }, {
    id: 'Fractal Alarums',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Clockwork Alarum',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.killAdds */.n3.killAdds()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Clockwork Alarum': 'Uhrwerk-Alarm',
      'Exhibit level III': 'Ausstellungssektor III',
      'Minotaur': 'Minotaurus',
      'Phantom Ray': 'Phantomschimmer',
      'Repository Node': 'Verwahrungsknoten',
      'The Curator': 'Kurator',
      'The high-level incubation bay': 'Inkubationskammer',
      'The reality augmentation bay': 'Dilatationskammer'
    },
    'replaceText': {
      '(?<!1)111-Tonze Swing': '111-Tonzen-Schwung',
      '10-Tonze Slash': '11-Tonzen-Schlag',
      '11-Tonze Swipe': '11-Tonzen-Hieb',
      '1111-Tonze Swing': '1111-Tonzen-Schwung',
      'Aetherochemical Explosive': 'Ätherochemisches Explosivum',
      'Aetherochemical Mine': 'Ätherochemische Mine',
      'Atmospheric Compression': 'Schnittdruck',
      'Atmospheric Displacement': 'Schnitttest',
      'Damage Up': 'Schaden +',
      'Disorienting Groan': 'Kampfgebrüll',
      'Double Sever': 'Zweifachabtrennung',
      'Feast': 'Festmahl',
      'Rapid Sever': 'Radikale Abtrennung',
      'Sanctification': 'Sanktifikation',
      'The Educator': 'Zuchtmeister',
      'Unholy': 'Unheilig',
      'Zoom In': 'Heranholen'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Clockwork Alarum': 'Alarum mécanique',
      'Exhibit level III': 'secteur d\'exposition III',
      'Minotaur': 'Minotaure',
      'Phantom Ray': 'Rayon fantomatique',
      'Repository Node': 'Sphère de dépôt',
      'The Curator': 'Conservateur',
      'The high-level incubation bay': 'la Chambre d\'incubation chimérique',
      'The reality augmentation bay': 'la Salle de distorsion de la réalité'
    },
    'replaceText': {
      '\\?': ' ?',
      '(?<!1)111-Tonze Swing': 'Swing de 111 tonz',
      '10-Tonze Slash': 'Taillade de 10 tonz',
      '11-Tonze Swipe': 'Fauche de 11 tonz',
      '1111-Tonze Swing': 'Swing de 1111 tonz',
      'Aetherochemical Explosive': 'Bombe magismologique',
      'Aetherochemical Mine': 'Mine magismologique',
      'Atmospheric Compression': 'Écrasement',
      'Atmospheric Displacement': 'Moulinet infernal',
      'Damage Up': 'Bonus de dégats',
      'Disorienting Groan': 'Cri désorientant',
      'Double Sever': 'Double tranchage',
      'Feast': 'Festin',
      'Rapid Sever': 'Tranchage rapide',
      'Sanctification': 'Sanctification',
      'The Educator': 'Disciplinaire',
      'Unholy': 'Sombre miracle',
      'Zoom In': 'Charge'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Clockwork Alarum': 'アラガンワーク・アラーム',
      'Exhibit level III': '第III展示区',
      'Minotaur': 'ミノタウロス',
      'Phantom Ray': 'ファントムレイ',
      'Repository Node': '収蔵システム',
      'The Curator': 'キュレーター',
      'The high-level incubation bay': '特級キメラ培養室',
      'The reality augmentation bay': '現実拡張室'
    },
    'replaceText': {
      '(?<!1)111-Tonze Swing': '111トンズ・スイング',
      '10-Tonze Slash': '10トンズ・スラッシュ',
      '11-Tonze Swipe': '11トンズ・スワイプ',
      '1111-Tonze Swing': '1111トンズ・スイング',
      'Aetherochemical Explosive': '魔科学爆弾',
      'Aetherochemical Mine': '魔科学地雷',
      'Atmospheric Compression': '剣圧',
      'Atmospheric Displacement': '剣風',
      'Damage Up': 'ダメージ上昇',
      'Disorienting Groan': '雄叫び',
      'Double Sever': '多重斬り',
      'Feast': 'フィースト',
      'Rapid Sever': '滅多斬り',
      'Sanctification': '聖別の光',
      'The Educator': 'エデュケーター',
      'Unholy': 'アンホーリー',
      'Zoom In': 'ズームイン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Clockwork Alarum': '发条报警虫',
      'Exhibit level III': '第三展示区',
      'Minotaur': '弥诺陶洛斯',
      'Phantom Ray': '幻影光',
      'Repository Node': '收藏系统',
      'The Curator': '博物总管',
      'The high-level incubation bay': '特级合成兽培养室',
      'The reality augmentation bay': '现实增强室'
    },
    'replaceText': {
      '(?<!1)111-Tonze Swing': '百十一吨回转',
      '10-Tonze Slash': '十吨挥打',
      '11-Tonze Swipe': '十一吨横扫',
      '1111-Tonze Swing': '千百十一吨回转',
      'Aetherochemical Explosive': '魔科学炸弹',
      'Aetherochemical Mine': '魔科学地雷',
      'Atmospheric Compression': '剑压',
      'Atmospheric Displacement': '剑风',
      'Damage Up': '伤害提高',
      'Disorienting Groan': '吼叫',
      'Double Sever': '多重斩击',
      'Feast': '飨宴',
      'Rapid Sever': '急促斩击',
      'Sanctification': '祝圣之光',
      'The Educator': '管教',
      'Unholy': '邪圣',
      'Zoom In': '放大'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Clockwork Alarum': '알라그 태엽경보장치',
      'Exhibit level III': '제III전시구역',
      'Minotaur': '미노타우로스',
      'Phantom Ray': '환영 광선',
      'Repository Node': '소장 시스템',
      'The Curator': '전시 책임자',
      'The high-level incubation bay': '특급 키메라 배양실',
      'The reality augmentation bay': '현실확장실'
    },
    'replaceText': {
      '(?<!1)111-Tonze Swing': '111톤즈 휘두르기',
      '10-Tonze Slash': '10톤즈 베기',
      '11-Tonze Swipe': '11톤즈 후려치기',
      '1111-Tonze Swing': '1111톤즈 휘두르기',
      'Aetherochemical Explosive': '마과학 폭탄',
      'Aetherochemical Mine': '마과학 지뢰',
      'Atmospheric Compression': '검압',
      'Atmospheric Displacement': '칼바람',
      'Damage Up': '주는 피해량 증가',
      'Disorienting Groan': '우렁찬 외침',
      'Double Sever': '다중 베기',
      'Feast': '사육제',
      'Rapid Sever': '마구 베기',
      'Sanctification': '축성의 빛',
      'The Educator': '교육자',
      'Unholy': '부정함',
      'Zoom In': '확대'
    }
  }]
};
/* harmony default export */ const fractal_continuum = (fractal_continuum_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/fractal_continuum.txt
const dungeon_fractal_continuum_namespaceObject = "hideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n###Phantom Ray\r\n#-ii F7D -p F7F:100\r\n\r\n# Exhibit Level III will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"60D\" } window 0,1\r\n10.3 \"Rapid Sever\" Ability { id: \"F7A\", source: \"Phantom Ray\" } window 15,15\r\n16.6 \"Atmospheric Displacement\" Ability { id: \"F7E\", source: \"Phantom Ray\" }\r\n21.4 \"Double Sever 1\" Ability { id: \"F7[BC]\", source: \"Phantom Ray\" }\r\n25.6 \"Double Sever 2\" Ability { id: \"F7[BC]\", source: \"Phantom Ray\" }\r\n27.4 \"Atmospheric Displacement\" Ability { id: \"F7E\", source: \"Phantom Ray\" }\r\n\r\n41.5 \"Rapid Sever\" Ability { id: \"F7A\", source: \"Phantom Ray\" } window 15,15\r\n47.7 \"Atmospheric Displacement\" Ability { id: \"F7E\", source: \"Phantom Ray\" }\r\n52.5 \"Double Sever 1\" Ability { id: \"F7[BC]\", source: \"Phantom Ray\" }\r\n56.5 \"Double Sever 2\" Ability { id: \"F7[BC]\", source: \"Phantom Ray\" }\r\n58.3 \"Atmospheric Displacement\" Ability { id: \"F7E\", source: \"Phantom Ray\" }\r\n\r\n72.4 \"Rapid Sever\" Ability { id: \"F7A\", source: \"Phantom Ray\" } window 15,15 jump 41.5\r\n78.6 \"Atmospheric Displacement\"\r\n83.3 \"Double Sever 1\"\r\n87.4 \"Double Sever 2\"\r\n89.2 \"Atmospheric Displacement\"\r\n# Phase 2 at < 75% HP\r\n\r\n100.0 \"Damage Up\" Ability { id: \"F7F\", source: \"Phantom Ray\" } window 100,30 #Overclock\r\n104.8 \"Double Sever 1\" Ability { id: \"F7[BC]\", source: \"Phantom Ray\" }\r\n107.6 \"Atmospheric Compression\" Ability { id: \"F80\", source: \"Phantom Ray\" }\r\n109.0 \"Double Sever 2\" Ability { id: \"F7[BC]\", source: \"Phantom Ray\" }\r\n111.8 \"Atmospheric Displacement\" Ability { id: \"F7E\", source: \"Phantom Ray\" }\r\n118.9 \"Rapid Sever\" Ability { id: \"F7A\", source: \"Phantom Ray\" }\r\n124.0 \"Rapid Sever\" Ability { id: \"F7A\", source: \"Phantom Ray\" }\r\n128.2 \"Atmospheric Displacement\" Ability { id: \"F7E\", source: \"Phantom Ray\" }\r\n133.1 \"Double Sever 1\" Ability { id: \"F7[BC]\", source: \"Phantom Ray\" }\r\n137.3 \"Double Sever 2\" Ability { id: \"F7[BC]\", source: \"Phantom Ray\" }\r\n139.0 \"Atmospheric Displacement\" Ability { id: \"F7E\", source: \"Phantom Ray\" }\r\n146.1 \"Atmospheric Displacement\" Ability { id: \"F7E\", source: \"Phantom Ray\" }\r\n\r\n148.4 \"Damage Up\" Ability { id: \"F7F\", source: \"Phantom Ray\" } window 15,15 jump 100\r\n153.2 \"Double Sever 1\"\r\n156.0 \"Atmospheric Compression\"\r\n157.4 \"Double Sever 2\"\r\n160.2 \"Atmospheric Displacement\"\r\n167.3 \"Rapid Sever\"\r\n172.4 \"Rapid Sever\"\r\n176.6 \"Atmospheric Displacement\"\r\n\r\n###Minotaur\r\n# High-level Incubation Bay will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"60E\" } window 1999,5\r\n1008.8 \"11-Tonze Swipe\" Ability { id: \"F81\", source: \"Minotaur\" } window 9,9\r\n1019.0 \"111-Tonze Swing\" Ability { id: \"F82\", source: \"Minotaur\" } window 20,20\r\n1028.2 \"Disorienting Groan\" Ability { id: \"F84\", source: \"Minotaur\" }\r\n1029.4 \"Zoom In x3\" Ability { id: \"F86\", source: \"Minotaur\" } duration 3.7\r\n1034.3 \"10-Tonze Slash\" Ability { id: \"F83\", source: \"Minotaur\" } window 20,20\r\n1043.5 \"11-Tonze Swipe\" Ability { id: \"F81\", source: \"Minotaur\" }\r\n\r\n# Rotation desyncs here due to timing on cage use\r\n1048.0 \"--sync--\" HeadMarker { id: \"0036\", target: \"Minotaur\" } window 45,15 jump 1151\r\n1064.2 \"Feast?\"\r\n1064.3 \"1111-Tonze Swing?\" Ability { id: \"F87\", source: \"Minotaur\" } window 1,10 jump 1167.3\r\n\r\n1076.4 \"11-Tonze Swipe\"\r\n1086.7 \"111-Tonze Swing\"\r\n\r\n# Second rotation landing spots\r\n1151.0 \"--sync--\" #landing for correct cage use\r\n1167.2 \"Feast\" Ability { id: \"F88\", source: \"Minotaur\" } window 15,15\r\n1167.3 \"--sync--\" #landing for missed cage\r\n\r\n# Second rotation, same as the first\r\n# Necessary for a clean landing after cages\r\n1179.4 \"11-Tonze Swipe\" Ability { id: \"F81\", source: \"Minotaur\" } window 15,15\r\n1189.7 \"111-Tonze Swing\" Ability { id: \"F82\", source: \"Minotaur\" } window 20,20\r\n1199.0 \"Disorienting Groan\" Ability { id: \"F84\", source: \"Minotaur\" }\r\n1200.1 \"Zoom In x3\" Ability { id: \"F86\", source: \"Minotaur\" } duration 3.7\r\n1204.7 \"10-Tonze Slash\" Ability { id: \"F83\", source: \"Minotaur\" } window 20,20\r\n1214.0 \"11-Tonze Swipe\" Ability { id: \"F81\", source: \"Minotaur\" }\r\n1219.0 \"--sync--\" HeadMarker { id: \"0036\", target: \"Minotaur\" } window 45,15 jump 1151\r\n1235.2 \"Feast?\"\r\n1235.3 \"1111-Tonze Swing?\" Ability { id: \"F87\", source: \"Minotaur\" } window 1,10 jump 1167.3\r\n\r\n1247.4 \"11-Tonze Swipe\"\r\n1263.6 \"111-Tonze Swing\"\r\n\r\n###The Curator\r\n# -ii F8C F8E F8F F90 F91 F92\r\n# Ability F91 is a ground effect, Seed of the Rivers.\r\n# It's excluded because it's the only difference between phase 2 > 3,\r\n# phase 3 can enter at any one of those three points,\r\n# and there's no way to disambiguate where.\r\n# Phase length is the same regardless of added abilities.\r\n\r\n# Reality Augmentation Bay will be sealed off\r\n2000 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"612\" } window 2000,0\r\n2006.2 \"Sanctification\" Ability { id: \"F89\", source: \"The Curator\" } window 7,7\r\n2011.4 \"Unholy\" Ability { id: \"F8A\", source: \"The Curator\" }\r\n2020.6 \"Sanctification\" Ability { id: \"F89\", source: \"The Curator\" }\r\n2028.8 \"Aetherochemical Explosive\" Ability { id: \"F8B\", source: \"The Curator\" } window 15,15\r\n2033.0 \"Unholy\" Ability { id: \"F8A\", source: \"The Curator\" }\r\n2035.8 \"Sanctification\" Ability { id: \"F89\", source: \"The Curator\" }\r\n2042.0 \"Unholy\" Ability { id: \"F8A\", source: \"The Curator\" }\r\n2044.1 \"Sanctification\" Ability { id: \"F89\", source: \"The Curator\" }\r\n2053.2 \"Aetherochemical Explosive\" Ability { id: \"F8B\", source: \"The Curator\" }\r\n2066.4 \"The Educator\" Ability { id: \"F8D\", source: \"The Curator\" } window 30,30\r\n\r\n2073.2 \"Sanctification\" Ability { id: \"F89\", source: \"The Curator\" }\r\n2078.4 \"Unholy\" Ability { id: \"F8A\", source: \"The Curator\" }\r\n2087.6 \"Sanctification\" Ability { id: \"F89\", source: \"The Curator\" }\r\n2095.8 \"Aetherochemical Explosive\" Ability { id: \"F8B\", source: \"The Curator\" }\r\n2100.0 \"Unholy\" Ability { id: \"F8A\", source: \"The Curator\" }\r\n2102.8 \"Sanctification\" Ability { id: \"F89\", source: \"The Curator\" }\r\n2109.0 \"Unholy\" Ability { id: \"F8A\", source: \"The Curator\" }\r\n2111.1 \"Sanctification\" Ability { id: \"F89\", source: \"The Curator\" }\r\n2120.2 \"Aetherochemical Explosive\" Ability { id: \"F8B\", source: \"The Curator\" }\r\n2133.4 \"The Educator\" Ability { id: \"F8D\", source: \"The Curator\" } window 30,30\r\n\r\n2140.2 \"Sanctification\" Ability { id: \"F89\", source: \"The Curator\" } window 15,15 jump 2073.2\r\n2145.4 \"Unholy\"\r\n2154.6 \"Sanctification\"\r\n2162.8 \"Aetherochemical Explosive\"\r\n2167.0 \"Unholy\"\r\n2169.8 \"Sanctification\"\r\n\r\n# Phase 2 after first Educator. Maybe HP threshold?\r\n\r\n2200.0 \"Sanctification\" Ability { id: \"F89\", source: \"The Curator\" }\r\n2203.9 \"Aetherochemical Mine\" Ability { id: \"F8F\", source: \"Repository Node\" } window 2200,10\r\n2205.2 \"Unholy\" Ability { id: \"F8A\", source: \"The Curator\" }\r\n2214.6 \"Sanctification\" Ability { id: \"F89\", source: \"The Curator\" }\r\n2222.7 \"Aetherochemical Explosive\" Ability { id: \"F8B\", source: \"The Curator\" }\r\n2225.0 \"Aetherochemical Mine\" Ability { id: \"F8F\", source: \"Repository Node\" } window 10,10\r\n2226.8 \"Unholy\" Ability { id: \"F8A\", source: \"The Curator\" }\r\n2229.0 \"Sanctification\" Ability { id: \"F89\", source: \"The Curator\" }\r\n2235.0 \"Unholy\" Ability { id: \"F8A\", source: \"The Curator\" }\r\n2237.4 \"Sanctification\" Ability { id: \"F89\", source: \"The Curator\" }\r\n2242.0 \"Aetherochemical Mine\" Ability { id: \"F8F\", source: \"Repository Node\" }\r\n2246.5 \"Aetherochemical Explosive\" Ability { id: \"F8B\", source: \"The Curator\" } window 10,10\r\n2259.7 \"The Educator\" Ability { id: \"F8D\", source: \"The Curator\" }\r\n\r\n2267.0 \"Sanctification\" Ability { id: \"F89\", source: \"The Curator\" } window 15,15 jump 2196.1\r\n2270.9 \"Aetherochemical Mine\"\r\n2272.2 \"Unholy\"\r\n2281.6 \"Sanctification\"\r\n2289.7 \"Aetherochemical Explosive\"\r\n2292.0 \"Aetherochemical Mine\"\r\n2293.8 \"Unholy\"\r\n2296.0 \"Sanctification\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/gubal_library_hard.ts



// The Great Gubal Library--Hard
const gubal_library_hard_triggerSet = {
  id: 'TheGreatGubalLibraryHard',
  zoneId: zone_id/* default.TheGreatGubalLibraryHard */.Z.TheGreatGubalLibraryHard,
  timelineFile: 'gubal_library_hard.txt',
  timelineTriggers: [{
    id: 'Gubal Hard Triclip',
    regex: /Triclip/,
    beforeSeconds: 5,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Gubal Hard Searing Wind',
    regex: /Searing Wind/,
    beforeSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Gubal Hard Properties of Darkness',
    regex: /Darkness \(buster\)/,
    beforeSeconds: 5,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }],
  triggers: [{
    id: 'Gubal Hard Bibliocide',
    type: 'StartsUsing',
    netRegex: {
      id: '1945',
      source: 'Liquid Flame',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Gubal Hard Ferrofluid',
    type: 'HeadMarker',
    netRegex: {
      id: ['0030', '0031']
    },
    condition: (data, matches) => data.me === matches.target || matches.targetId.startsWith('4'),
    preRun: (data, matches) => {
      data.markers ??= [];
      data.markers.push(matches.id);
    },
    infoText: (data, _matches, output) => {
      if (data.markers?.length === 2) {
        const sameMarkers = data.markers[0] === data.markers[1];
        delete data.markers;
        if (sameMarkers) return output.closeToBoss();
        return output.awayFromBoss();
      }
    },
    outputStrings: {
      closeToBoss: {
        en: 'Close to boss',
        de: 'Nahe zum Boss',
        fr: 'Rapprochez-vous du boss',
        ja: 'ボスに近づく',
        cn: '靠近boss',
        ko: '보스와 가까이 서기'
      },
      awayFromBoss: {
        en: 'Away from boss',
        de: 'Weg vom Boss',
        fr: 'Éloignez-vous du boss',
        ja: 'ボスから離れる',
        cn: '远离boss',
        ko: '보스와 떨어지기'
      }
    }
  }, {
    id: 'Gubal Hard Slosh',
    type: 'Tether',
    netRegex: {
      id: '0039',
      source: 'Liquid Flame'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from boss',
        de: 'Weg vom Boss',
        fr: 'Éloignez-vous du boss',
        ja: 'ボスから離れる',
        cn: '远离boss',
        ko: '멀어지기'
      }
    }
  }, {
    id: 'Gubal Hard Sunseal',
    type: 'GainsEffect',
    netRegex: {
      effectId: '46F'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in red',
        de: 'Im Roten stehen',
        fr: 'Placez-vous dans le rouge',
        ja: '赤色に入る',
        cn: '站在红色',
        ko: '빨강장판에 서기'
      }
    }
  }, {
    id: 'Gubal Hard Moonseal',
    type: 'GainsEffect',
    netRegex: {
      effectId: '470'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in blue',
        de: 'Im Blauen stehen',
        fr: 'Placez-vous dans le bleu',
        ja: '青色に入る',
        cn: '站在蓝色',
        ko: '파랑장판에 서기'
      }
    }
  }, {
    // This inflicts a vulnerability stack on the tank if not interrupted
    id: 'Gubal Hard Condensed Libra',
    type: 'StartsUsing',
    netRegex: {
      id: '198D',
      source: 'Mechanoscribe',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.CanSilence()) return output.interruptMechanoscribe();
      if (data.CanStun()) return output.stunMechanoscribe();
    },
    outputStrings: {
      interruptMechanoscribe: {
        en: 'Interrupt Mechanoscribe',
        de: 'unterbreche Mechanoscholar',
        fr: 'Interrompez le Mécano-scribe',
        ja: '沈黙：メカノスクライブ',
        cn: '打断人偶',
        ko: '기계 서기 차단'
      },
      stunMechanoscribe: {
        en: 'Stun Mechanoscribe',
        de: 'betäube Mechanoscholar',
        fr: 'Étourdissez le Mécano-scribe',
        ja: 'スタン：メカノスクライブ',
        cn: '眩晕人偶',
        ko: '기계 서기 기절'
      }
    }
  }, {
    id: 'Gubal Hard Properties of Quakes',
    type: 'StartsUsing',
    netRegex: {
      id: '1956',
      source: 'Strix',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in light circle',
        de: 'Im hellen Kreis stehen',
        fr: 'Placez-vous dans le cercle blanc',
        ja: '白い輪に入る',
        cn: '去白色区域',
        ko: '빛 장판으로'
      }
    }
  }, {
    id: 'Gubal Hard Properties of Tornadoes',
    type: 'StartsUsing',
    netRegex: {
      id: '1957',
      source: 'Strix',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in dark circle',
        de: 'Im dunklen Kreis stehen',
        fr: 'Placez-vous dans le cercle noir',
        ja: '黒い輪に入る',
        cn: '去黑色区域',
        ko: '어둠 장판으로'
      }
    }
  }, {
    id: 'Gubal Hard Properties of Imps',
    type: 'StartsUsing',
    netRegex: {
      id: '1959',
      source: 'Strix',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse in green circle',
        de: 'Im grünen Kreis reinigen',
        fr: 'Purifiez-vous dans le cercle vert',
        ja: '緑の輪に入る',
        cn: '去绿色区域',
        ko: '초록 장판으로'
      }
    }
  }, {
    id: 'Gubal Hard Properties of Thunder',
    type: 'StartsUsing',
    netRegex: {
      id: '195A',
      source: 'Strix',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Gubal Hard Properties of Darkness II',
    type: 'StartsUsing',
    netRegex: {
      id: '1955',
      source: 'Strix',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Gubal Hard Ecliptic Meteor',
    type: 'StartsUsing',
    netRegex: {
      id: '195D',
      source: 'Behemoth Ward',
      capture: false
    },
    delaySeconds: 14,
    // Leaving about 10s warning to complete the LoS
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide behind boulder',
        de: 'Hinter dem Brocken verstecken',
        fr: 'Cachez-vous derrière le rocher',
        ja: 'メテオの後ろに',
        cn: '站在陨石后',
        ko: '운석 뒤에 숨기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Behemoth Ward': 'Buch-Behemoth',
      'Demon of the Tome': 'Bücherdämon',
      'Liquid Flame': 'flüssig(?:e|er|es|en) Flamme',
      'Mechanoscribe': 'Mechanoscholar',
      'Meteor': 'Meteor',
      'Middle Shelf Tome': 'Pappband',
      'Strix': 'Strix',
      'The Astrology and Astromancy Camera': 'Astrologische und Astronomische Gewölbe',
      'The Hall of Magicks': 'Halle der Magie',
      'The Rare Tomes Room': 'Abteilung für seltene Schriften',
      'Top Shelf Tome': 'Prachtband'
    },
    'replaceText': {
      '\\(buster\\)': '(Tankbuster)',
      'Bibliocide': 'Bibliozid',
      'Book Drop': 'Buch fällt',
      'Check Out': 'Anthologie',
      'Discontinue': 'Druck einstellen',
      'Ecliptic Meteor': 'Ekliptik-Meteor',
      'Folio': 'Foliant',
      'Form Shift': 'Formwechsel',
      'Frightful Roar': 'Furchtbares Brüllen',
      'Hand/Tornado': 'Hand/Tornado',
      'Issue': 'Publizieren',
      'Magnetism': 'Magnetismus',
      'Meteor Impact': 'Meteoreinschlag',
      'Properties Of Darkness': 'Theorie der Dunkelung',
      'Properties Of Imps': 'Über Flusskobolde',
      'Properties Of Quakes': 'Theorie des Seisga',
      'Properties Of Thunder III': 'Theorie des Blitzga',
      'Properties Of Tornados': 'Theorie des Tornado',
      'Quakes/Tornados': 'Seisga/Tornados',
      'Repel': 'Abstoßung',
      'Sea Of Flames': 'Flammenmeer',
      'Seal Of Night And Day': 'Siegel',
      'Searing Wind': 'Versengen',
      'Slosh': 'Durchbläuen',
      'Triclip': 'Dreischnitt'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Behemoth Ward': 'Béhémoth conjuré',
      'Demon of the Tome': 'Démon du Tome',
      'Liquid Flame': 'Flamme liquide',
      'Mechanoscribe': 'Mécano-scribe',
      'Meteor': 'Météore',
      'Middle Shelf Tome': 'Livre broché',
      'Strix': 'Strix',
      'The Astrology and Astromancy Camera': 'dôme d\'astrologie et d\'astromancie',
      'The Hall of Magicks': 'puits des magies',
      'The Rare Tomes Room': 'dôme des manuscrits rares',
      'Top Shelf Tome': 'Livre relié'
    },
    'replaceText': {
      '\\?': ' ?',
      'Bibliocide': 'Bibliocide',
      'Book Drop': 'Laché de livre',
      'Check Out': 'Anthologie',
      'Discontinue': 'Arrêt de publication',
      'Ecliptic Meteor': 'Météore écliptique',
      'Folio': 'Réimpression',
      'Form Shift': 'Glissement de posture',
      'Frightful Roar': 'Rugissement effroyable',
      'Hand/Tornado': 'Main/Tornade',
      'Issue': 'Publication',
      'Magnetism/Repel': 'Attraction/Répulsion',
      'Meteor Impact': 'Impact de météore',
      'Properties Of Darkness II': 'Propriétés d\'Extra Obscurité',
      'Properties Of Darkness(?! II)': 'Propriétés d\'Obscurité',
      'Properties Of Imps': 'Propriétés de Coup du kappa',
      'Properties Of Quakes': 'Propriétés de Méga Séisme',
      'Properties Of Thunder III': 'Propriétés de Méga Foudre',
      'Properties Of Tornados': 'Propriétés de Tornade',
      'Quakes/Tornados': 'Séismes/Tornades',
      'Sea Of Flames': 'Mer de flammes',
      'Seal Of Night And Day': 'Gravure',
      'Searing Wind': 'Carbonisation',
      'Slosh': 'Ruée',
      'Triclip': 'Triclip'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Behemoth Ward': 'ベヒーモス・ワード',
      'Demon of the Tome': 'デモン・オブ・トーム',
      'Liquid Flame': 'リクイドフレイム',
      'Mechanoscribe': 'メカノスクライブ',
      'Meteor': 'メテオ',
      'Middle Shelf Tome': '並製本',
      'Strix': 'ストリックス',
      'The Astrology and Astromancy Camera': '占星学研究室',
      'The Hall of Magicks': '魔書の翼廊',
      'The Rare Tomes Room': '思想稀覯書庫',
      'Top Shelf Tome': '上製本'
    },
    'replaceText': {
      '\\(buster\\)': '(バスター)',
      'Bibliocide': '火炎',
      'Book Drop': '本落下',
      'Check Out': '選書',
      'Discontinue': '廃刊',
      'Ecliptic Meteor': 'エクリプスメテオ',
      'Folio': '重版',
      'Form Shift': '演武',
      'Frightful Roar': 'フライトフルロア',
      'Hand/Tornado': '手/竜卷',
      'Issue': '刊行',
      'Magnetism': '磁力',
      'Meteor Impact': 'メテオインパクト',
      'Properties Of Darkness II': 'ダークラの章',
      'Properties Of Darkness(?! II)': 'ダークの章',
      'Properties Of Imps': 'カッパの章',
      'Properties Of Quakes': 'クエイガの章',
      'Properties Of Thunder III': 'サンダガの章',
      'Properties Of Tornados': 'トルネドの章',
      'Quakes/Tornados': 'クエイガの章/トルネドの章',
      'Repel': '反発',
      'Sea Of Flames': 'シー・オブ・フレイム',
      'Seal Of Night And Day': '刻印',
      'Searing Wind': '熱風',
      'Slosh': '突進',
      'Triclip': 'トライクリップ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Behemoth Ward': '贝希摩斯护卫',
      'Demon of the Tome': '书中恶魔',
      'Liquid Flame': '液态火焰',
      'Mechanoscribe': '自走人偶抄写员',
      'Meteor': '陨石',
      'Middle Shelf Tome': '平装本',
      'Strix': '博学林鸮',
      'The Astrology and Astromancy Camera': '占星学研究室',
      'The Hall of Magicks': '魔书翼廊',
      'The Rare Tomes Room': '思想珍秘书库',
      'Top Shelf Tome': '精装本'
    },
    'replaceText': {
      '\\?': ' ?',
      'Bibliocide': '焚书',
      'Book Drop': '书落下',
      'Check Out': '选集',
      'Discontinue': '停刊',
      'Ecliptic Meteor': '黄道陨石',
      'Folio': '再版',
      'Form Shift': '演武',
      'Frightful Roar': '骇人嚎叫',
      'Hand/Tornado': '手/龙卷',
      'Issue': '发行',
      'Magnetism/Repel': '磁力/相斥',
      'Meteor Impact': '陨石冲击',
      'Properties Of Darkness II': '昏暗之章',
      'Properties Of Darkness(?! II)': '黑暗之章',
      'Properties Of Imps': '河童之章',
      'Properties Of Quakes': '爆震之章',
      'Properties Of Thunder III': '暴雷之章',
      'Properties Of Tornados': '龙卷之章',
      'Quakes/Tornados': '爆震/龙卷',
      'Sea Of Flames': '火海',
      'Seal Of Night And Day': '刻印',
      'Searing Wind': '热风',
      'Slosh': '突进',
      'Triclip': '三连爪'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Behemoth Ward': '고서의 베히모스',
      'Demon of the Tome': '고서의 악마',
      'Liquid Flame': '액체 불꽃',
      'Mechanoscribe': '기계 서기',
      'Meteor': '메테오',
      'Middle Shelf Tome': '문고본',
      'Strix': '스트릭스',
      'The Astrology and Astromancy Camera': '점성학 연구실',
      'The Hall of Magicks': '악마서 복도',
      'The Rare Tomes Room': '사상희귀서고',
      'Top Shelf Tome': '양장본'
    },
    'replaceText': {
      'Bibliocide': '화염',
      'Book Drop': '책 떨어짐',
      'Check Out': '도서 선정',
      'Discontinue': '폐간',
      'Ecliptic Meteor': '황도 메테오',
      'Folio': '증쇄',
      'Form Shift': '연무',
      'Frightful Roar': '끔찍한 포효',
      'Hand/Tornado': '손/토네이도',
      'Issue': '간행',
      'Magnetism': '자력',
      'Meteor Impact': '운석 낙하',
      'Properties Of Darkness': '다크의 장',
      'Properties Of Imps': '물요정의 장',
      'Properties Of Quakes': '퀘이가의 장',
      'Properties Of Thunder III': '선더가의 장',
      'Properties Of Tornados': '토네이도의 장',
      'Repel': '반발',
      'Sea Of Flames': '화염의 바다',
      'Seal Of Night And Day': '각인',
      'Searing Wind': '열풍',
      'Slosh': '돌진',
      'Triclip': '삼단베기',
      'Quakes/Tornados': '퀘이가/토네이도'
    }
  }]
};
/* harmony default export */ const gubal_library_hard = (gubal_library_hard_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/gubal_library_hard.txt
const dungeon_gubal_library_hard_namespaceObject = "hideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Demon of the Tome\r\n# -ii 1951 1952\r\n\r\n# Hall of Magicks will be sealed off\r\n0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"657\" }\r\n6.1 \"Triclip\" Ability { id: \"193A\", source: \"Demon of the Tome\" } window 6.1,5\r\n17.3 \"Folio\" Ability { id: \"193C\", source: \"Demon of the Tome\" }\r\n23.4 \"--sync--\" Ability { id: \"193D\", source: \"Top Shelf Tome\" }\r\n24.0 \"Book Drop\" Ability { id: \"193E\", source: \"Top Shelf Tome\" }\r\n\r\n29.5 \"Triclip\" Ability { id: \"193A\", source: \"Demon of the Tome\" } window 15,15\r\n38.7 \"Folio\" Ability { id: \"193C\", source: \"Demon of the Tome\" }\r\n44.8 \"--sync--\" Ability { id: \"193D\", source: \"Top Shelf Tome\" }\r\n45.4 \"Book Drop\" Ability { id: \"193E\", source: \"Top Shelf Tome\" }\r\n47.0 \"Issue\" Ability { id: \"193F\", source: \"Middle Shelf Tome\" } window 15,15\r\n52.6 \"Discontinue\" Ability { id: \"1940\", source: \"Middle Shelf Tome\" }\r\n58.3 \"Frightful Roar\" Ability { id: \"193B\", source: \"Demon of the Tome\" }\r\n63.5 \"Triclip\" Ability { id: \"193A\", source: \"Demon of the Tome\" } window 15,15\r\n71.5 \"Folio\" Ability { id: \"193C\", source: \"Demon of the Tome\" }\r\n77.6 \"Issue\"\r\n82.2 \"Discontinue\"\r\n83.6 \"Issue\"\r\n84.2 \"Discontinue x3\"\r\n\r\n102.7 \"Triclip\" Ability { id: \"193A\", source: \"Demon of the Tome\" } window 15,15\r\n111.9 \"Folio\" Ability { id: \"193C\", source: \"Demon of the Tome\" }\r\n118.0 \"--sync--\" Ability { id: \"193D\", source: \"Top Shelf Tome\" }\r\n118.6 \"Book Drop\" Ability { id: \"193E\", source: \"Top Shelf Tome\" }\r\n120.2 \"Issue\" Ability { id: \"193F\", source: \"Middle Shelf Tome\" } window 15,15\r\n125.8 \"Discontinue\" Ability { id: \"1940\", source: \"Middle Shelf Tome\" }\r\n131.5 \"Frightful Roar\" Ability { id: \"193B\", source: \"Demon of the Tome\" }\r\n136.7 \"Triclip\" Ability { id: \"193A\", source: \"Demon of the Tome\" }\r\n144.7 \"Folio\" Ability { id: \"193C\", source: \"Demon of the Tome\" }\r\n150.8 \"Issue\"\r\n155.4 \"Discontinue\"\r\n156.8 \"Issue\"\r\n157.4 \"Discontinue x3\"\r\n\r\n# Ordinarily we would sync from the end of the last block\r\n# However, this tends to break due to multiple identical mechanics close together\r\n175.9 \"Triclip\" Ability { id: \"193A\", source: \"Demon of the Tome\" } window 15,15 jump 102.7\r\n185.1 \"Folio\"\r\n191.8 \"Book Drop\"\r\n193.4 \"Issue\"\r\n199.0 \"Discontinue\"\r\n204.7 \"Frightful Roar\"\r\n\r\n# Liquid Flame\r\n# -ii 1946 1953 194B\r\n# Whichever form (Hand/Tornado) comes second creates multiple phantom 0x1A \"GainsEffect\" lines\r\n# This will cause the timeline to desync if the syncs happen at the phase start,\r\n# so instead, put the syncs with jumps after each phase.\r\n\r\n# Astrology and Astromancy Camera will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"658\" } window 1000,0\r\n1007.3 \"Searing Wind\" Ability { id: \"1944\", source: \"Liquid Flame\" } window 7.3,5\r\n1014.3 \"Bibliocide\" Ability { id: \"1945\", source: \"Liquid Flame\" }\r\n1025.7 \"Sea Of Flames x3\"\r\n1030.5 \"Slosh\" Ability { id: \"1947\", source: \"Liquid Flame\" } window 10,10\r\n1034.6 \"Searing Wind\" Ability { id: \"1944\", source: \"Liquid Flame\" }\r\n1042.7 \"Bibliocide\" Ability { id: \"1945\", source: \"Liquid Flame\" }\r\n1054.3 \"--sync--\" GainsEffect { effectId: '2FF' } window 54,20 jump 1100 # Chiromorph\r\n1054.3 \"--sync--\" GainsEffect { effectId: '300' } window 54,20 jump 1200 # Anemomorph\r\n1054.3 \"Hand/Tornado?\"\r\n\r\n# Hand Form (Chiromorph)\r\n1100.0 \"--sync--\" # No actual sync; this is a jump destination\r\n1108.4 \"Seal Of Night And Day\" Ability { id: \"1949\", source: \"Liquid Flame\" } window 10,10\r\n1112.5 \"Searing Wind\" Ability { id: \"1948\", source: \"Liquid Flame\" }\r\n1116.4 \"Searing Wind\" Ability { id: \"1948\", source: \"Liquid Flame\" }\r\n1126.5 \"Seal Of Night And Day\" Ability { id: \"1949\", source: \"Liquid Flame\" } window 10,10\r\n1130.6 \"Searing Wind\" Ability { id: \"1948\", source: \"Liquid Flame\" }\r\n1134.7 \"Searing Wind\" Ability { id: \"1948\", source: \"Liquid Flame\" }\r\n1138.9 \"Searing Wind\" Ability { id: \"1948\", source: \"Liquid Flame\" }\r\n1149.1 \"--sync--\" GainsEffect { effectId: '300' } window 49,20 jump 1200 # jump to ignore phantom line\r\n1149.1 \"Form Shift\"\r\n\r\n# Tornado Form (Anemomorph)\r\n1200.0 \"--sync--\" # No actual sync; this is a jump destination\r\n1204.5 \"Bibliocide\" Ability { id: \"1945\", source: \"Liquid Flame\" } window 10,10\r\n1215.4 \"Magnetism/Repel?\" Ability { id: \"194[CD]\", source: \"Liquid Flame\" }\r\n1226.9 \"Bibliocide\" Ability { id: \"1945\", source: \"Liquid Flame\" }\r\n1237.8 \"Magnetism/Repel\" Ability { id: \"194[CD]\", source: \"Liquid Flame\" }\r\n1246.1 \"--sync--\" GainsEffect { effectId: '2FF' } window 46,20 jump 1100 # jump to ignore phantom line\r\n1246.1 \"Form Shift\"\r\n\r\n# Human Form (Anthropomorph)\r\n1300.0 \"--sync--\" GainsEffect { effectId: '2FE' } window 200,10 # no phantom line problem here\r\n1307.5 \"Searing Wind\" Ability { id: \"1944\", source: \"Liquid Flame\" } window 10,20\r\n1314.7 \"Bibliocide\" Ability { id: \"1945\", source: \"Liquid Flame\" }\r\n1326.0 \"Sea Of Flames x3\"\r\n1331.3 \"Slosh\" Ability { id: \"1947\", source: \"Liquid Flame\" } window 10,10\r\n1335.5 \"Searing Wind\" Ability { id: \"1944\", source: \"Liquid Flame\" }\r\n1343.8 \"Bibliocide\" Ability { id: \"1945\", source: \"Liquid Flame\" }\r\n\r\n1355.2 \"Searing Wind\" Ability { id: \"1944\", source: \"Liquid Flame\" } window 10,20\r\n1362.4 \"Bibliocide\" Ability { id: \"1945\", source: \"Liquid Flame\" }\r\n1373.8 \"Sea Of Flames x3\"\r\n1379.0 \"Slosh\" Ability { id: \"1947\", source: \"Liquid Flame\" } window 10,10\r\n1383.2 \"Searing Wind\" Ability { id: \"1944\", source: \"Liquid Flame\" }\r\n1391.5 \"Bibliocide\" Ability { id: \"1945\", source: \"Liquid Flame\" } jump 1343.8\r\n\r\n1402.9 \"Searing Wind\"\r\n1410.1 \"Bibliocide\"\r\n1421.4 \"Sea Of Flames x3\"\r\n1426.7 \"Slosh\"\r\n\r\n\r\n# Strix\r\n# -ii 194F 1950 1958 195B 1969\r\n\r\n# Rare Tomes Room will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"706\" } window 2000,5\r\n2009.2 \"Check Out\" Ability { id: \"194E\", source: \"Strix\" } window 9.2,10\r\n2017.5 \"Properties Of Darkness (buster)\" Ability { id: \"1954\", source: \"Strix\" }\r\n2029.6 \"Properties Of Quakes\" Ability { id: \"1956\", source: \"Strix\" }\r\n2033.8 \"Properties Of Darkness (buster)\" Ability { id: \"1954\", source: \"Strix\" }\r\n2040.1 \"Check Out\" Ability { id: \"194E\", source: \"Strix\" } window 10,10\r\n2048.4 \"Properties Of Darkness (buster)\" Ability { id: \"1954\", source: \"Strix\" }\r\n2056.7 \"Properties Of Darkness II\" Ability { id: \"1955\", source: \"Strix\" }\r\n2069.9 \"Properties Of Tornados\" Ability { id: \"1957\", source: \"Strix\" }\r\n2074.2 \"Properties Of Darkness (buster)\" Ability { id: \"1954\", source: \"Strix\" }\r\n2082.4 \"Properties Of Imps\" Ability { id: \"1959\", source: \"Strix\" } window 30,30\r\n2085.5 \"Properties Of Darkness\" Ability { id: \"1954\", source: \"Strix\" }\r\n2094.7 \"Properties Of Thunder III\" Ability { id: \"195A\", source: \"Strix\" }\r\n\r\n# Intermission\r\n2109.2 \"Check Out\" Ability { id: \"194E\", source: \"Strix\" }\r\n2125.6 \"Properties Of Darkness (buster)\" Ability { id: \"1954\", source: \"Strix\" }\r\n2126.1 \"--sync--\" Ability { id: \"1A6A\", source: \"Meteor\" }\r\n2126.7 \"Meteor Impact\" Ability { id: \"195E\", source: \"Behemoth Ward\" }\r\n2133.8 \"Properties Of Darkness (buster)\" Ability { id: \"1954\", source: \"Strix\" }\r\n2135.1 \"--sync--\" Ability { id: \"1A6A\", source: \"Meteor\" }\r\n2135.6 \"Meteor Impact\" Ability { id: \"195E\", source: \"Behemoth Ward\" }\r\n2143.7 \"Ecliptic Meteor\" Ability { id: \"195D\", source: \"Behemoth Ward\" }\r\n2144.7 \"--sync--\" Ability { id: \"195C\", source: \"Behemoth Ward\" }\r\n\r\n2155.0 \"Check Out\" Ability { id: \"194E\", source: \"Strix\" } window 20,20\r\n2172.3 \"Quakes/Tornados\" Ability { id: \"195[67]\", source: \"Strix\" }\r\n2178.6 \"Properties Of Darkness II\" Ability { id: \"1955\", source: \"Strix\" }\r\n2181.8 \"Properties Of Darkness (buster)\" Ability { id: \"1954\", source: \"Strix\" }\r\n2188.1 \"Properties Of Imps\" Ability { id: \"1959\", source: \"Strix\" } window 30,25\r\n2196.3 \"Properties Of Thunder III\" Ability { id: \"195A\", source: \"Strix\" }\r\n2203.5 \"Properties Of Darkness II\" Ability { id: \"1955\", source: \"Strix\" }\r\n2207.7 \"Properties Of Darkness (buster)\" Ability { id: \"1954\", source: \"Strix\" }\r\n\r\n2214.9 \"Check Out\" Ability { id: \"194E\", source: \"Strix\" } window 20,20\r\n2232.3 \"Quakes/Tornados\" Ability { id: \"195[67]\", source: \"Strix\" }\r\n2238.6 \"Properties Of Darkness II\" Ability { id: \"1955\", source: \"Strix\" }\r\n2241.8 \"Properties Of Darkness (buster)\" Ability { id: \"1954\", source: \"Strix\" }\r\n2248.1 \"Properties Of Imps\" Ability { id: \"1959\", source: \"Strix\" } window 30,25\r\n2256.3 \"Properties Of Thunder III\" Ability { id: \"195A\", source: \"Strix\" }\r\n2263.5 \"Properties Of Darkness II\" Ability { id: \"1955\", source: \"Strix\" }\r\n2267.7 \"Properties Of Darkness (buster)\" Ability { id: \"1954\", source: \"Strix\" } jump 2207.7\r\n\r\n2274.9 \"Check Out\"\r\n2292.2 \"Quakes/Tornados\"\r\n2298.5 \"Properties Of Darkness II\"\r\n2301.7 \"Properties Of Darkness (buster)\"\r\n2308.0 \"Properties Of Imps\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/sohm_al.ts



// Sohm Al (normal)
const sohm_al_triggerSet = {
  id: 'SohmAl',
  zoneId: zone_id/* default.SohmAl */.Z.SohmAl,
  timelineFile: 'sohm_al.txt',
  timelineTriggers: [{
    id: 'Sohm Al Raskovnik Bloody Caress',
    regex: /Bloody Caress/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'Sohm Al Myath Third Leg Forward',
    regex: /Third Leg Forward/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'Sohm Al Tioman Abyssic Buster',
    regex: /Abyssic Buster/,
    beforeSeconds: 4,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'Sohm Al Myath Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Sohm Al Myath Spread',
    type: 'HeadMarker',
    netRegex: {
      id: '008C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Sohm Al Myath Chyme',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Chyme Of The Mountain',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Chyme Add',
        de: 'Brei Add töten',
        fr: 'Tuez l\'add Chyme',
        ja: 'キームス・マウンテンを倒す',
        cn: '击杀圣山之糜',
        ko: '산의 유미즙 처치'
      }
    }
  }, {
    id: 'Sohm Al Tioman Meteor',
    type: 'HeadMarker',
    netRegex: {
      id: '0007'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.meteorOnYou */.n3.meteorOnYou()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Chyme Of The Mountain': 'Gebirgsbrei',
      'Greenlinn': 'Grünklippe',
      'Hess Afah': 'Hess Afah',
      'Myath': 'Myath',
      'Raskovnik': 'Raskovnik',
      'The Wound': 'Wunde',
      'Tioman': 'Tioman'
    },
    'replaceText': {
      'Abyssic Buster': 'Abyss-Sprenger',
      'Acid Rain': 'Säureregen',
      'Bloody Caress': 'Vampirranke',
      'Chaos Blast': 'Chaos-Knall',
      'Comet': 'Komet',
      'Dark Star': 'Dunkler Stern',
      'Ensnare': 'Anspringen',
      'Floral Trap': 'Saugfalle',
      'Flower Devour': 'Riesenappetit',
      'Heavensfall': 'Himmelsfall',
      'Leafstorm': 'Blättersturm',
      'Mad Dash': 'Tollwütiger Sprint',
      'Meteor Impact': 'Meteoreinschlag',
      'Overbite': 'Überbiss',
      'Phytobeam': 'Phytostrahl',
      'Primordial Roar': 'Urgebrüll',
      'Razor Scales': 'Messerscharfe Schuppen',
      'Spit': 'Hypersekretion',
      'Sweet Scent': 'Süßlicher Geruch',
      'Third Leg Forward': 'Drittes Bein'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Chyme Of The Mountain': 'Chyme des montagnes',
      'Greenlinn': 'Vertaven',
      'Hess Afah': 'Hess Afah',
      'Myath': 'Myath',
      'Raskovnik': 'Raskovnik',
      'The Wound': 'La Plaie',
      'Tioman': 'Tioman'
    },
    'replaceText': {
      'Abyssic Buster': 'Brisement abyssal',
      'Acid Rain': 'Pluie acide',
      'Bloody Caress': 'Caresse sanglante',
      'Chaos Blast': 'Explosion de chaos',
      'Comet': 'Comète',
      'Dark Star': 'Étoile noire',
      'Ensnare': 'Piégeage',
      'Floral Trap': 'Piège floral',
      'Flower Devour': 'Bâfrée',
      'Heavensfall': 'Chute céleste',
      'Leafstorm': 'Tempête de feuilles',
      'Mad Dash': 'Ruée démente',
      'Meteor Impact': 'Impact de météore',
      'Overbite': 'Morsure violente',
      'Phytobeam': 'Rayon solaire',
      'Primordial Roar': 'Rugissement primitif',
      'Razor Scales': 'Écailles rasantes',
      'Spit': 'Crachat',
      'Sweet Scent': 'Doux parfum',
      'Third Leg Forward': 'Fauchage'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Chyme Of The Mountain': 'キームス・マウンテン',
      'Greenlinn': '碧の崖',
      'Hess Afah': 'ヘス・アファー',
      'Myath': 'マイス',
      'Raskovnik': 'ラスコヴニク',
      'The Wound': '霊峰の傷',
      'Tioman': 'ティオマン'
    },
    'replaceText': {
      'Abyssic Buster': 'アビスバスター',
      'Acid Rain': 'アシッドレイン',
      'Bloody Caress': 'ブラッディカレス',
      'Chaos Blast': 'カオスブラスト',
      'Comet': 'コメット',
      'Dark Star': 'ダークスター',
      'Ensnare': 'エンスネア',
      'Floral Trap': 'フローラルトラップ',
      'Flower Devour': '大食い',
      'Heavensfall': 'ヘヴンスフォール',
      'Leafstorm': 'リーフストーム',
      'Mad Dash': 'マッドダッシュ',
      'Meteor Impact': 'メテオインパクト',
      'Overbite': 'オーバーバイト',
      'Phytobeam': 'ソーラービーム',
      'Primordial Roar': 'プライモーディアルロア',
      'Razor Scales': 'レーザースケイル',
      'Spit': '放出',
      'Sweet Scent': 'スイートセント',
      'Third Leg Forward': 'サードレッグ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Chyme Of The Mountain': '圣山之糜',
      'Greenlinn': '碧崖',
      'Hess Afah': '永望顶',
      'Myath': '迈斯龙',
      'Raskovnik': '破锁花王',
      'The Wound': '灵伤',
      'Tioman': '刁曼'
    },
    'replaceText': {
      'Abyssic Buster': '深渊破坏',
      'Acid Rain': '酸雨',
      'Bloody Caress': '血腥的爱抚',
      'Chaos Blast': '混沌爆破',
      'Comet': '彗星',
      'Dark Star': '暗星',
      'Ensnare': '诱捕',
      'Floral Trap': '鲜花陷阱',
      'Flower Devour': '狼吞虎咽',
      'Heavensfall': '惊天动地',
      'Leafstorm': '绿叶风暴',
      'Mad Dash': '疯狂泼溅',
      'Meteor Impact': '陨石冲击',
      'Overbite': '咬合',
      'Phytobeam': '植物射线',
      'Primordial Roar': '原始嚎叫',
      'Razor Scales': '鳞刀',
      'Spit': '吐出',
      'Sweet Scent': '香气',
      'Third Leg Forward': '第三腿前扫'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Chyme Of The Mountain': '산의 유미즙',
      'Greenlinn': '청록 절벽',
      'Hess Afah': '헤스 아파',
      'Myath': '마이스',
      'Raskovnik': '라스코브니크',
      'The Wound': '영봉의 상처',
      'Tioman': '티오만'
    },
    'replaceText': {
      'Abyssic Buster': '심연의 파괴자',
      'Acid Rain': '산성비',
      'Bloody Caress': '피의 애무',
      'Chaos Blast': '혼돈 폭풍',
      'Comet': '혜성',
      'Dark Star': '어둠의 별',
      'Ensnare': '올가미',
      'Floral Trap': '향기의 덫',
      'Flower Devour': '폭식',
      'Heavensfall': '천지 붕괴',
      'Leafstorm': '잎사귀 폭풍',
      'Mad Dash': '광분 질주',
      'Meteor Impact': '운석 낙하',
      'Overbite': '피개 교합',
      'Phytobeam': '태양 광선',
      'Primordial Roar': '태고의 포효',
      'Razor Scales': '날카로운 비늘',
      'Spit': '방출',
      'Sweet Scent': '달콤한 향기',
      'Third Leg Forward': '제3의 다리 전진'
    }
  }]
};
/* harmony default export */ const sohm_al = (sohm_al_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/sohm_al.txt
const dungeon_sohm_al_namespaceObject = "\r\n# SOHM AL\r\n\r\nhideall \"--sync--\"\r\nhideall \"--Reset--\"\r\n\r\n### Raskovnik\r\n# -p ED1:6.2\r\n\r\n# Greenlinn will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"649\" } window 0,1\r\n6.2 \"Bloody Caress\" Ability { id: \"ED1\", source: \"Raskovnik\" } window 6.2,0\r\n12.3 \"--sync--\" Ability { id: \"ED2\", source: \"Raskovnik\" }\r\n17.9 \"Acid Rain\" Ability { id: \"ED7\", source: \"Raskovnik\" }\r\n26.4 \"Phytobeam\" Ability { id: \"ED5\", source: \"Raskovnik\" }\r\n33.6 \"Bloody Caress\" Ability { id: \"ED1\", source: \"Raskovnik\" } jump 6.2\r\n39.7 \"--sync--\" # Ability { id: \"ED2\", source: \"Raskovnik\" }\r\n45.3 \"Acid Rain\" # Ability { id: \"ED7\", source: \"Raskovnik\" }\r\n53.9 \"Phytobeam\" # Ability { id: \"ED5\", source: \"Raskovnik\" }\r\n61.1 \"Bloody Caress\" # Ability { id: \"ED1\", source: \"Raskovnik\" }\r\n\r\n# HP push?\r\n# Looks like there are two loop groups of skills used repeatly?\r\n\r\n# Group 1\r\n100.0 \"--sync--\" StartsUsing { id: \"1395\", source: \"Raskovnik\" } window 100,0\r\n103.0 \"Sweet Scent\" Ability { id: \"1395\", source: \"Raskovnik\" } window 103,0\r\n114.6 \"Floral Trap\" Ability { id: \"1391\", source: \"Raskovnik\" }\r\n119.6 \"Flower Devour\" Ability { id: \"1392\", source: \"Raskovnik\" }\r\n125.4 \"Spit\" Ability { id: \"1393\", source: \"Raskovnik\" }\r\n126.5 \"--sync--\" Ability { id: \"1394\", source: \"Raskovnik\" }\r\n# Inside Loop\r\n# Raskovnik would use this loop 4 times?\r\n136.0 \"Floral Trap\" Ability { id: \"1391\", source: \"Raskovnik\" } jump 114.6\r\n141.0 \"Flower Devour\" # Ability { id: \"1392\", source: \"Raskovnik\" }\r\n146.8 \"Spit\" # Ability { id: \"1393\", source: \"Raskovnik\" }\r\n147.9 \"--sync--\" # Ability { id: \"1394\", source: \"Raskovnik\" }\r\n157.1 \"Floral Trap\" # Ability { id: \"1391\", source: \"Raskovnik\" }\r\n162.1 \"Flower Devour\" # Ability { id: \"1392\", source: \"Raskovnik\" }\r\n167.9 \"Spit\" # Ability { id: \"1393\", source: \"Raskovnik\" }\r\n# Inside Loop\r\n\r\n# Loop\r\n200.0 \"--sync--\" StartsUsing { id: \"1395\", source: \"Raskovnik\" } window 97,0 jump 100\r\n203.0 \"Sweet Scent\" Ability { id: \"1395\", source: \"Raskovnik\" } window 97,0 jump 103\r\n214.8 \"Floral Trap\" # Ability { id: \"1391\", source: \"Raskovnik\" }\r\n219.8 \"Flower Devour\" # Ability { id: \"1392\", source: \"Raskovnik\" }\r\n225.6 \"Spit\" # Ability { id: \"1393\", source: \"Raskovnik\" }\r\n226.7 \"--sync--\" # Ability { id: \"1394\", source: \"Raskovnik\" }\r\n\r\n# Group 2\r\n300.0 \"--sync--\" StartsUsing { id: \"ED6\", source: \"Raskovnik\" } window 300,0\r\n303.0 \"Leafstorm\" Ability { id: \"ED6\", source: \"Raskovnik\" }\r\n308.2 \"Bloody Caress\" Ability { id: \"ED1\", source: \"Raskovnik\" }\r\n314.3 \"--sync--\" Ability { id: \"ED2\", source: \"Raskovnik\" }\r\n319.9 \"Acid Rain\" Ability { id: \"ED7\", source: \"Raskovnik\" }\r\n328.5 \"Phytobeam\" Ability { id: \"ED5\", source: \"Raskovnik\" }\r\n333.7 \"Bloody Caress\" Ability { id: \"ED1\", source: \"Raskovnik\" }\r\n# Loop\r\n342.8 \"Leafstorm\" Ability { id: \"ED6\", source: \"Raskovnik\" } jump 303\r\n348.0 \"Bloody Caress\" # Ability { id: \"ED1\", source: \"Raskovnik\" }\r\n354.1 \"--sync--\" # Ability { id: \"ED2\", source: \"Raskovnik\" }\r\n359.7 \"Acid Rain\" # Ability { id: \"ED7\", source: \"Raskovnik\" }\r\n368.2 \"Phytobeam\" # Ability { id: \"ED5\", source: \"Raskovnik\" }\r\n373.4 \"Bloody Caress\" # Ability { id: \"ED1\", source: \"Raskovnik\" }\r\n\r\n# jump back to group 1\r\n500.0 \"--sync--\" StartsUsing { id: \"1395\", source: \"Raskovnik\" } window 500,0 jump 100\r\n\r\n\r\n### Myath\r\n# -p 1382:1006.1\r\n# -ic \"Chyme Of The Mountain\"\r\n\r\n# The Wound will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"64C\" } window 1000,1\r\n\r\n1006.1 \"Third Leg Forward\" Ability { id: \"1382\", source: \"Myath\" } window 6.1,5\r\n1011.2 \"Overbite\" Ability { id: \"EDB\", source: \"Myath\" }\r\n1019.3 \"Razor Scales\" Ability { id: \"EDC\", source: \"Myath\" }\r\n1024.5 \"Third Leg Forward\" Ability { id: \"1382\", source: \"Myath\" }\r\n1031.6 \"Third Leg Forward\" Ability { id: \"1382\", source: \"Myath\" }\r\n1036.7 \"Overbite\" Ability { id: \"EDB\", source: \"Myath\" }\r\n# Loop\r\n1044.8 \"Razor Scales\" Ability { id: \"EDC\", source: \"Myath\" } jump 1019.3\r\n1050.0 \"Third Leg Forward\" # Ability { id: \"1382\", source: \"Myath\" }\r\n1057.1 \"Third Leg Forward\" # Ability { id: \"1382\", source: \"Myath\" }\r\n1062.2 \"Overbite\" # Ability { id: \"EDB\", source: \"Myath\" }\r\n1070.3 \"Razor Scales\" # Ability { id: \"EDC\", source: \"Myath\" }\r\n1075.5 \"Third Leg Forward\" # Ability { id: \"1382\", source: \"Myath\" }\r\n\r\n# Myath would use Primordial Roar twice:\r\n# 1. HP < 90%?\r\n# 2. HP < 50%? also summon Chyme Of The Mountain\r\n1200.0 \"Primordial Roar\" Ability { id: \"EE2\", source: \"Myath\" } window 200,0\r\n1207.1 \"Third Leg Forward\" Ability { id: \"1382\", source: \"Myath\" }\r\n1214.2 \"Ensnare\" Ability { id: \"EDD\", source: \"Myath\" }\r\n1219.2 \"Mad Dash\" Ability { id: \"EE[01]\", source: \"Myath\" }\r\n1221.5 \"Ensnare\" Ability { id: \"EDD\", source: \"Myath\" }\r\n1226.5 \"Mad Dash\" Ability { id: \"EE[01]\", source: \"Myath\" }\r\n1229.0 \"Ensnare\" Ability { id: \"EDD\", source: \"Myath\" }\r\n1236.1 \"Mad Dash\" Ability { id: \"EE[01]\", source: \"Myath\" }\r\n1238.4 \"Ensnare\" Ability { id: \"EDD\", source: \"Myath\" }\r\n1245.4 \"Mad Dash\" Ability { id: \"EE[01]\", source: \"Myath\" }\r\n\r\n# Jump back to loop\r\n1249.8 \"Third Leg Forward\" Ability { id: \"1382\", source: \"Myath\" } window 30,5 jump 1006.1\r\n1254.9 \"Overbite\" # Ability { id: \"EDB\", source: \"Myath\" }\r\n1263.0 \"Razor Scales\" # Ability { id: \"EDC\", source: \"Myath\" }\r\n1268.2 \"Third Leg Forward\" # Ability { id: \"1382\", source: \"Myath\" }\r\n1275.3 \"Third Leg Forward\" # Ability { id: \"1382\", source: \"Myath\" }\r\n1280.4 \"Overbite\" # Ability { id: \"EDB\", source: \"Myath\" }\r\n\r\n\r\n### Tioman\r\n# -p EE3:2006\r\n# -ic \"Comet\"\r\n\r\n# Hess Afah will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"64D\" } window 2000,1\r\n\r\n2006.0 \"Abyssic Buster\" Ability { id: \"EE3\", source: \"Tioman\" } window 6,6\r\n2013.2 \"Chaos Blast\" Ability { id: \"EE5\", source: \"Tioman\" }\r\n2016.5 \"--sync--\" Ability { id: \"EEB\", source: \"Tioman\" }\r\n2020.4 \"Abyssic Buster\" Ability { id: \"EE3\", source: \"Tioman\" }\r\n2030.0 \"Comet\" Ability { id: \"EE6\", source: \"Tioman\" }\r\n2043.7 \"Meteor Impact\" Ability { id: \"1387\", source: \"Tioman\" }\r\n# Loop\r\n2047.3 \"Abyssic Buster\" Ability { id: \"EE3\", source: \"Tioman\" } jump 2006\r\n2054.5 \"Chaos Blast\" # Ability { id: \"EE5\", source: \"Tioman\" }\r\n2057.8 \"--sync--\" # Ability { id: \"EEB\", source: \"Tioman\" }\r\n2061.7 \"Abyssic Buster\" # Ability { id: \"EE3\", source: \"Tioman\" }\r\n2071.3 \"Comet\" # Ability { id: \"EE6\", source: \"Tioman\" }\r\n2084.9 \"Meteor Impact\" # Ability { id: \"1387\", source: \"Tioman\" }\r\n\r\n# 00:0044:Tioman:Arrogant insects! Be crushed beneath the weight of my fury!\r\n2200.0 \"Heavensfall\" Ability { id: \"EE7\", source: \"Tioman\" } window 200,0\r\n2223.5 \"Dark Star\" Ability { id: \"EE4\", source: \"Tioman\" } window 5,5\r\n2246.9 \"Dark Star\" Ability { id: \"EE4\", source: \"Tioman\" } window 5,5\r\n2270.4 \"Dark Star\" Ability { id: \"EE4\", source: \"Tioman\" } window 5,5 jump 2223.5\r\n2293.8 \"Dark Star\" Ability { id: \"EE4\", source: \"Tioman\" } window 5,5\r\n2317.3 \"Dark Star\" Ability { id: \"EE4\", source: \"Tioman\" } window 5,5\r\n# Tioman keeps using Dark Star every 23.5 seconds,\r\n# increasing Damage Up stacks, maximum is 16.\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# Jump back to normal loop\r\n# TODO: update to use forcejump\r\n2300.0 \"--sync--\" Ability { id: \"366\", source: \"Tioman\" } window 100,0\r\n2305.6 \"Abyssic Buster\" Ability { id: \"EE3\", source: \"Tioman\" } window 101,5 jump 2006\r\n2312.8 \"Chaos Blast\" # Ability { id: \"EE5\", source: \"Tioman\" }\r\n2316.1 \"--sync--\" # Ability { id: \"EEB\", source: \"Tioman\" }\r\n2320.0 \"Abyssic Buster\" # Ability { id: \"EE3\", source: \"Tioman\" }\r\n2329.6 \"Comet\" # Ability { id: \"EE6\", source: \"Tioman\" }\r\n2343.2 \"Meteor Impact\" # Ability { id: \"1387\", source: \"Tioman\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/sohm_al_hard.ts



const sohm_al_hard_triggerSet = {
  id: 'SohmAlHard',
  zoneId: zone_id/* default.SohmAlHard */.Z.SohmAlHard,
  timelineFile: 'sohm_al_hard.txt',
  timelineTriggers: [{
    id: 'Sohm Al Hard Wild Horn',
    regex: /Wild Horn/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }],
  triggers: [{
    // The actual damage is 1C31, but the windup for the damage
    // occurs between 1C30 and 1C31.
    id: 'Sohm Al Hard Inflammable Fumes',
    type: 'Ability',
    netRegex: {
      id: '1C30',
      source: 'The Leightonward',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Both the small and large Spore Sacs use Glorious Blaze.
    // However, it's not the same ability.
    id: 'Sohm Al Hard Glorious Blaze',
    type: 'StartsUsing',
    netRegex: {
      id: '1C32',
      source: 'Spore Sac',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from large pod',
        de: 'Weg vom großen Pod',
        fr: 'Éloignez-vous des spores',
        ja: 'スポアサックから離れる',
        cn: '远离大孢囊',
        ko: '큰 포자 주머니에게서 떨어지기'
      }
    }
  }, {
    // The actual effect being checked here is Heavy.
    id: 'Sohm Al Hard Excretion',
    type: 'GainsEffect',
    netRegex: {
      effectId: '0E'
    },
    condition: data => data.CanCleanse(),
    infoText: (data, matches, output) => {
      return output.text({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Cleanse ${player}',
        de: 'Reinige ${player}',
        fr: 'Guérison sur ${player}',
        ja: 'エスナ：${player}',
        cn: '康复${player}',
        ko: '${player} 에스나'
      }
    }
  }, {
    // Inflicts Incoming Healing Down.
    // If used while Gowrow is empowered,
    // leaves a tornado at the target location on completion.
    id: 'Sohm Al Hard Ripper Claw',
    type: 'StartsUsing',
    netRegex: {
      id: '1C37',
      source: 'Gowrow',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    // Inflicts Incoming Healing Down.
    // This ability is used only if there is a party member in range behind Gowrow
    // AND if Gowrow is not empowered.
    id: 'Sohm Al Hard Tail Smash',
    type: 'StartsUsing',
    netRegex: {
      id: '1C35',
      source: 'Gowrow',
      capture: false
    },
    response: responses/* Responses.goFrontOrSides */.n3.goFrontOrSides()
  }, {
    // Inflicts Incoming Healing Down.
    // Used only if Gowrow is empowered.
    id: 'Sohm Al Hard Tail Swing',
    type: 'StartsUsing',
    netRegex: {
      id: '1C36',
      source: 'Gowrow',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    // Used only if Gowrow is not empowered.
    id: 'Sohm Al Hard Wild Charge',
    type: 'StartsUsing',
    netRegex: {
      id: '1C39',
      source: 'Gowrow',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    // Used only if Gowrow is empowered.
    id: 'Sohm Al Hard Hot Charge',
    type: 'StartsUsing',
    netRegex: {
      id: '1C3A',
      source: 'Gowrow',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    // Used only if Gowrow is not empowered.
    id: 'Sohm Al Hard Fireball',
    type: 'StartsUsing',
    netRegex: {
      id: '1C3B',
      source: 'Gowrow',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    // Used only if Gowrow is empowered.
    id: 'Sohm Al Hard Lava Flow',
    type: 'StartsUsing',
    netRegex: {
      id: '1C3C',
      source: 'Gowrow',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    // This cast is accompanied by a 0017 head marker on the target.
    // We use the cast line for this trigger because the timing is the same.
    id: 'Sohm Al Hard Flying Press',
    type: 'StartsUsing',
    netRegex: {
      id: '1C3E',
      source: 'Lava Scorpion'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop puddle outside',
        de: 'Fläche draußen ablegen',
        fr: 'Déposez la zone au sol à l\'extérieur',
        ja: '外周に置く',
        cn: '人群外放圈圈',
        ko: '바깥쪽으로 장판 유도하기'
      }
    }
  }, {
    id: 'Sohm Al Hard Deadly Thrust',
    type: 'StartsUsing',
    netRegex: {
      id: ['1C40', '1C48'],
      source: ['Lava Scorpion', 'The Scorpion\'s Tail']
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Sohm Al Hard Hiss',
    type: 'StartsUsing',
    netRegex: {
      id: '1C45',
      source: 'Lava Scorpion',
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'The Wound': 'Wunde',
      'The Scorpion\'s Tail': 'Schwanzskorpion',
      'The Lava Tube': 'Lavagrotte',
      'The Leightonward': 'Hortigolem',
      'Small Spore Sac': 'klein(?:e|er|es|en) Sporensack',
      '(?<!Small )Spore Sac': 'Sporensack',
      'Lava Scorpion': 'Lavaskorpion',
      'Gowrow': 'Gowrow'
    },
    'replaceText': {
      '\\(Back\\)': '(Hinten)',
      '\\(Front\\)': '(Vorne)',
      '\\(Readies\\)': '(Vorbereitung)',
      '\\(Ring\\)': '(Ring)',
      'Wild Horn': 'Wildes Horn',
      'Spore Sac': 'Sporensack',
      'Realm Shaker': 'Erderschütterer',
      'Molten Silk': 'Geschmolzene Seide',
      'Inflammable Fumes': 'Entzündliches Gas',
      'Hiss': 'Zischen',
      'Glorious Blaze': 'Zündung',
      'Flying Press': 'Flugdruck',
      'Excretion': 'Schleim',
      'Deadly Thrust': 'Tödliche Durchbohrung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'The Wound': 'La Plaie',
      'The Lava Tube': 'Tunnel de lave',
      'The Leightonward': 'Chortocyon',
      'Small Spore Sac': 'petit sac de spores',
      'Lava Scorpion': 'scorpion de lave',
      'The Scorpion\'s Tail': 'queue du scorpion',
      '(?<!Small )Spore Sac': 'Sac de spores',
      'Gowrow': 'Gowrow'
    },
    'replaceText': {
      '\\(Back\\)': '(Derrière)',
      '\\(Front\\)': '(Devant)',
      '\\(Readies\\)': '(Préparation)',
      '\\(Ring\\)': '(Anneau)',
      'Wild Horn': 'Corne sauvage',
      '(?<!Small )Spore Sac': 'Sac de spores',
      'Realm Shaker': 'Secousse tellurique',
      'Molten Silk': 'Soie en fusion',
      'Inflammable Fumes': 'Gaz inflammable',
      'Hiss': 'Sifflet',
      'Glorious Blaze': 'Embrasement',
      'Flying Press': 'Aplatissement',
      'Excretion': 'Mucus',
      'Deadly Thrust': 'Transpercement mortel'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'The Wound': '霊峰の傷',
      'The Lava Tube': '大溶岩窟',
      'The Leightonward': 'レイトンワード',
      'Small Spore Sac': 'スモール・スポアサック',
      'Lava Scorpion': 'ラーヴァ・スコーピオン',
      'The Scorpion\'s Tail': 'テイル・スコーピオン',
      '(?<!Small )Spore Sac': 'スポアサック',
      'Gowrow': 'ガウロウ'
    },
    'replaceText': {
      '\\(Adds x2\\)': '(2つ 雑魚)',
      '\\(Adds x4\\)': '(4つ 雑魚)',
      '\\(Back\\)': '(後ろ)',
      '\\(Front\\)': '(前)',
      '\\(Readies\\)': '(構え)',
      '\\(Ring\\)': '(輪)',
      'Wild Horn': 'ワイルドホーン',
      'Spore Sac': 'スポアサック',
      'Realm Shaker': 'レルムシェーカー',
      'Molten Silk': 'モルテンシルク',
      'Inflammable Fumes': '可燃性ガス',
      'Hiss': '呼び寄せ',
      'Glorious Blaze': '引火',
      'Flying Press': 'フライングプレス',
      'Excretion': '粘液',
      'Deadly Thrust': 'デッドリースラスト'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Gowrow': '高牢怪龙',
      'The Wound': '灵伤',
      'The Scorpion\'s Tail': '尖尾蝎',
      'The Lava Tube': '大熔岩窟',
      'The Leightonward': '莱顿瓦德',
      'Small Spore Sac': '小型孢囊',
      '(?<!Small )Spore Sac': '孢囊',
      'Lava Scorpion': '熔岩蝎'
    },
    'replaceText': {
      '\\(Adds x2\\)': '(小怪x2)',
      '\\(Adds x4\\)': '(小怪x4)',
      '\\(Back\\)': '(后)',
      '\\(Front\\)': '(前)',
      '\\(Readies\\)': '(准备)',
      '\\(Ring\\)': '(月环)',
      'Wild Horn': '野性利角',
      'Spore Sac': '孢囊',
      'Realm Shaker': '震撼领域',
      'Molten Silk': '炎丝喷射',
      'Inflammable Fumes': '可燃性气体',
      'Hiss': '呼唤',
      'Glorious Blaze': '引火',
      'Flying Press': '飞跃重压',
      'Excretion': '粘液',
      'Deadly Thrust': '致命尾刺'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Gowrow': '가우로우',
      'The Wound': '영봉의 상처',
      'The Lava Tube': '대용암굴',
      'The Leightonward': '레이튼워드',
      'Small Spore Sac': '작은 포자 주머니',
      'Lava Scorpion': '용암 전갈',
      'The Scorpion\'s Tail': '꼬리 전갈',
      '(?<!Small )Spore Sac': '포자 주머니'
    },
    'replaceText': {
      'Wild Horn': '사나운 뿔',
      'Spore Sac': '포자 주머니',
      'Realm Shaker': '파멸 영역',
      'Molten Silk': '용암 분사',
      'Inflammable Fumes': '가연성 가스',
      'Hiss': '불러내기',
      'Glorious Blaze': '불붙이기',
      'Flying Press': '도약 내리찍기',
      'Excretion': '점액',
      'Deadly Thrust': '죽음의 꼬리'
    }
  }]
};
/* harmony default export */ const sohm_al_hard = (sohm_al_hard_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/sohm_al_hard.txt
const dungeon_sohm_al_hard_namespaceObject = "\r\n# SOHM AL HARD\r\n\r\nhideall \"--sync--\"\r\nhideall \"--Reset--\"\r\n\r\n#~~~~~~~~~~~~~~~~~~#\r\n# THE LEIGHTONWARD #\r\n#~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ic \"Spore Sac\"\r\n\r\n# The Wound will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"64C\" } window 0,1\r\n2.4 \"--sync--\" Ability { id: \"5B5\", source: \"The Leightonward\" } window 2.4,1\r\n6.1 \"Wild Horn\" Ability { id: \"1C2D\", source: \"The Leightonward\" } window 6.1,5\r\n13.2 \"Inflammable Fumes (Readies)\" Ability { id: \"1C30\", source: \"The Leightonward\" }\r\n17.2 \"Inflammable Fumes\" Ability { id: \"1C31\", source: \"The Leightonward\" } window 15,15\r\n22.4 \"Wild Horn\" Ability { id: \"1C2D\", source: \"The Leightonward\" }\r\n27.5 \"Spore Sac\" Ability { id: \"1C2F\", source: \"The Leightonward\" }\r\n33.6 \"Inflammable Fumes (Readies)\" Ability { id: \"1C30\", source: \"The Leightonward\" }\r\n37.6 \"Inflammable Fumes\" Ability { id: \"1C31\", source: \"The Leightonward\" } window 15,15\r\n40.7 \"Glorious Blaze\" Ability { id: \"1C33\", source: \"Small Spore Sac\" }\r\n44.9 \"Excretion\" Ability { id: \"1C2E\", source: \"The Leightonward\" }\r\n49.0 \"Wild Horn\" Ability { id: \"1C2D\", source: \"The Leightonward\" }\r\n55.1 \"Wild Horn\" Ability { id: \"1C2D\", source: \"The Leightonward\" }\r\n60.2 \"Spore Sac\" Ability { id: \"1C2F\", source: \"The Leightonward\" }\r\n66.3 \"Inflammable Fumes (Readies)\" Ability { id: \"1C30\", source: \"The Leightonward\" }\r\n70.3 \"Inflammable Fumes\" Ability { id: \"1C31\", source: \"The Leightonward\" } window 15,15\r\n73.3 \"Glorious Blaze\" Ability { id: \"1C33\", source: \"Small Spore Sac\" }\r\n84.6 \"Wild Horn\" Ability { id: \"1C2D\", source: \"The Leightonward\" }\r\n\r\n92.9 \"Excretion\" Ability { id: \"1C2E\", source: \"The Leightonward\" }\r\n98.0 \"Spore Sac\" Ability { id: \"1C2F\", source: \"The Leightonward\" }\r\n104.2 \"Inflammable Fumes (Readies)\" Ability { id: \"1C30\", source: \"The Leightonward\" }\r\n108.2 \"Inflammable Fumes\" Ability { id: \"1C31\", source: \"The Leightonward\" } window 15,15\r\n111.2 \"Glorious Blaze\" Ability { id: \"1C33\", source: \"Small Spore Sac\" }\r\n124.4 \"Wild Horn\" Ability { id: \"1C2D\", source: \"The Leightonward\" }\r\n130.5 \"Wild Horn\" Ability { id: \"1C2D\", source: \"The Leightonward\" }\r\n137.6 \"Inflammable Fumes (Readies)\" Ability { id: \"1C30\", source: \"The Leightonward\" }\r\n141.6 \"Inflammable Fumes\" Ability { id: \"1C31\", source: \"The Leightonward\" } window 15,15\r\n143.8 \"Wild Horn\" Ability { id: \"1C2D\", source: \"The Leightonward\" }\r\n150.0 \"Wild Horn\" Ability { id: \"1C2D\", source: \"The Leightonward\" } jump 84.6\r\n\r\n# The timing from Wild Horn to Excretion is the same no matter\r\n# whether the lead block is the opener or the rotation block.\r\n# Because of this, we have just the one iteration of the rotation block.\r\n\r\n158.2 \"Excretion\"\r\n163.3 \"Spore Sac\"\r\n169.5 \"Inflammable Fumes (Readies)\"\r\n173.5 \"Inflammable Fumes\"\r\n176.5 \"Glorious Blaze\"\r\n189.7 \"Wild Horn\"\r\n\r\n\r\n\r\n# Unfortunately, Gowrow's abilities do not fit neatly into a timeline.\r\n\r\n#~~~~~~~~~~~~~~~#\r\n# LAVA SCORPION #\r\n#~~~~~~~~~~~~~~~#\r\n\r\n# -ii 1C3F\r\n\r\n# The Lava Tube will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"763\" } window 2000,1\r\n2012.0 \"Molten Silk (Front)\" Ability { id: \"1C43\", source: \"Lava Scorpion\" } window 12,5\r\n2022.2 \"Flying Press\" Ability { id: \"1C3E\", source: \"Lava Scorpion\" }\r\n2038.4 \"Deadly Thrust\" Ability { id: \"1C40\", source: \"Lava Scorpion\" }\r\n2045.6 \"Hiss (Adds x2)\" Ability { id: \"1C45\", source: \"Lava Scorpion\" } window 15,15\r\n2068.8 \"Realm Shaker\" Ability { id: \"1C41\", source: \"Lava Scorpion\" }\r\n2079.4 \"Flying Press\" Ability { id: \"1C3E\", source: \"Lava Scorpion\" }\r\n2091.6 \"Deadly Thrust\" Ability { id: \"1C40\", source: \"Lava Scorpion\" }\r\n2101.8 \"Molten Silk (Front)\" Ability { id: \"1C43\", source: \"Lava Scorpion\" }\r\n2106.9 \"Molten Silk (Back)\" Ability { id: \"1C44\", source: \"Lava Scorpion\" }\r\n2118.6 \"Hiss (Adds x4)\" Ability { id: \"1C45\", source: \"Lava Scorpion\" } window 15,15\r\n2123.7 \"Molten Silk (Ring)\" Ability { id: \"1C42\", source: \"Lava Scorpion\" }\r\n2129.8 \"Deadly Thrust\" Ability { id: \"1C40\", source: \"Lava Scorpion\" }\r\n2150.0 \"Flying Press\" Ability { id: \"1C3E\", source: \"Lava Scorpion\" }\r\n2156.1 \"Flying Press\" Ability { id: \"1C3E\", source: \"Lava Scorpion\" }\r\n2167.3 \"Molten Silk (Front)\" Ability { id: \"1C43\", source: \"Lava Scorpion\" }\r\n2172.4 \"Molten Silk (Back)\" Ability { id: \"1C44\", source: \"Lava Scorpion\" }\r\n2182.0 \"Deadly Thrust\" Ability { id: \"1C40\", source: \"Lava Scorpion\" }\r\n2187.1 \"Flying Press\" Ability { id: \"1C3E\", source: \"Lava Scorpion\" }\r\n\r\n2196.3 \"Realm Shaker\" Ability { id: \"1C41\", source: \"Lava Scorpion\" } window 15,15\r\n2202.0 \"Molten Silk (Ring)\" Ability { id: \"1C42\", source: \"Lava Scorpion\" }\r\n2211.2 \"Hiss (Adds x2)\" Ability { id: \"1C45\", source: \"Lava Scorpion\" }\r\n2221.3 \"Deadly Thrust\" Ability { id: \"1C40\", source: \"Lava Scorpion\" }\r\n2231.5 \"Molten Silk (Back)\" Ability { id: \"1C44\", source: \"Lava Scorpion\" }\r\n2237.1 \"Molten Silk (Front)\" Ability { id: \"1C43\", source: \"Lava Scorpion\" }\r\n2246.3 \"Deadly Thrust\" Ability { id: \"1C40\", source: \"Lava Scorpion\" }\r\n\r\n2254.5 \"Realm Shaker\" Ability { id: \"1C41\", source: \"Lava Scorpion\" } window 15,15\r\n2260.2 \"Molten Silk (Ring)\" Ability { id: \"1C42\", source: \"Lava Scorpion\" }\r\n2269.4 \"Hiss (Adds x2)\" Ability { id: \"1C45\", source: \"Lava Scorpion\" }\r\n2279.5 \"Deadly Thrust\" Ability { id: \"1C40\", source: \"Lava Scorpion\" }\r\n2289.7 \"Molten Silk (Back)\" Ability { id: \"1C44\", source: \"Lava Scorpion\" }\r\n2295.3 \"Molten Silk (Front)\" Ability { id: \"1C43\", source: \"Lava Scorpion\" }\r\n2304.5 \"Deadly Thrust\" Ability { id: \"1C40\", source: \"Lava Scorpion\" } jump 2246.3\r\n\r\n2312.7 \"Realm Shaker\"\r\n2318.4 \"Molten Silk (Ring)\"\r\n2327.6 \"Hiss (Adds x2)\"\r\n2337.7 \"Deadly Thrust\"\r\n2347.9 \"Molten Silk (Back)\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/the_lost_city_of_amdapor_hard.ts



const the_lost_city_of_amdapor_hard_triggerSet = {
  id: 'TheLostCityOfAmdaporHard',
  zoneId: zone_id/* default.TheLostCityOfAmdaporHard */.Z.TheLostCityOfAmdaporHard,
  timelineFile: 'the_lost_city_of_amdapor_hard.txt',
  // Temporarily out of combat during Kuribu phases.  @_@;;
  resetWhenOutOfCombat: false,
  initData: () => {
    return {
      earthResistDown: {},
      windResistDown: {}
    };
  },
  triggers: [{
    id: 'LostCityHard Gremlin Bad-Mouth',
    type: 'StartsUsing',
    netRegex: {
      id: '775',
      source: 'Ranting Ranks Gremlin'
    },
    condition: conditions/* default.targetIsNotYou */.Z.targetIsNotYou(),
    infoText: (data, matches, output) => {
      return output.comfort({
        name: data.party.member(matches.target)
      });
    },
    outputStrings: {
      comfort: {
        en: '/comfort ${name}',
        de: '/trösten ${name}',
        fr: '/consoler ${name}',
        cn: '/安慰 ${name}',
        ko: '/위로 ${name}'
      }
    }
  }, {
    id: 'LostCityHard Achamoth Neuro Squama',
    type: 'StartsUsing',
    netRegex: {
      id: '15C5',
      source: 'Achamoth',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to edge; look outside',
        de: 'Geh zum Rand und schau nach draußen',
        fr: 'Allez sur les bords et regardez à l\'extérieur',
        cn: '去场边; 看场外',
        ko: '구석에서 바깥 보기'
      }
    }
  }, {
    id: 'LostCityHard Achamoth Toxic Squama',
    type: 'HeadMarker',
    netRegex: {
      id: '0001',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid chasing orb',
        de: 'Weiche dem verfolgenden Orb aus',
        fr: 'Évitez l\'orbe',
        cn: '躲避追踪球',
        ko: '유도 구슬 피하기'
      }
    }
  }, {
    id: 'LostCityHard Void Monk Water III',
    type: 'StartsUsing',
    netRegex: {
      id: '16C7',
      source: 'Void Monk'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'LostCityHard Void Monk Sucker',
    type: 'StartsUsing',
    netRegex: {
      id: '16C5',
      source: 'Void Monk',
      capture: false
    },
    response: responses/* Responses.drawIn */.n3.drawIn()
  }, {
    id: 'LostCityHard Void Monk Flood',
    type: 'Ability',
    // This is an instant cast followup to Sucker.
    netRegex: {
      id: '16C5',
      source: 'Void Monk',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut('info')
  }, {
    id: 'LostCityHard Winged Lion Wind Resist Down II Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '41C'
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    run: (data, matches) => data.windResistDown[matches.target] = true,
    outputStrings: {
      text: {
        en: 'Avoid Aero',
        de: 'Vermeide Wind',
        fr: 'Évitez le Vent',
        cn: '躲避风',
        ko: '에어로 피하기'
      }
    }
  }, {
    id: 'LostCityHard Winged Lion Wind Resist Down II Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '41C'
    },
    run: (data, matches) => data.windResistDown[matches.target] = false
  }, {
    id: 'LostCityHard Winged Lion Earth Resist Down II Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '41D'
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    run: (data, matches) => data.earthResistDown[matches.target] = true,
    outputStrings: {
      text: {
        en: 'Avoid Stone',
        de: 'Vermeide Stein',
        fr: 'Évitez le rocher',
        cn: '躲避石',
        ko: '스톤 피하기'
      }
    }
  }, {
    id: 'LostCityHard Winged Lion Earth Resist Down II Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '41D'
    },
    run: (data, matches) => data.earthResistDown[matches.target] = false
  }, {
    id: 'LostCityHard Winged Lion Ancient Stone',
    type: 'Ability',
    netRegex: {
      id: '15D2',
      source: 'Winged Lion',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        pop: {
          en: 'Pop stone orb',
          de: 'Nimm Stein Orb',
          fr: 'Prenez l\'orbe en pierre',
          cn: '踩石圈',
          ko: '스톤 구슬 부딪히기'
        },
        avoid: {
          en: 'Avoid stone orb',
          de: 'Vermeide Stein Orb',
          fr: 'Évitez l\'orbe de pierre',
          cn: '躲避石圈',
          ko: '스톤 구슬 피하기'
        }
      };
      if (data.earthResistDown[data.me]) return {
        infoText: output.avoid()
      };
      return {
        alertText: output.pop()
      };
    }
  }, {
    id: 'LostCityHard Winged Lion Ancient Aero',
    type: 'Ability',
    netRegex: {
      id: '15CE',
      source: 'Winged Lion',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        pop: {
          en: 'Pop aero orb',
          de: 'Nimm Wind Orb',
          fr: 'Prenez l\'orbe de vent',
          cn: '踩风圈',
          ko: '에어로 구슬 부딪히기'
        },
        avoid: {
          en: 'Avoid aero orb',
          de: 'Vermeide Wind Orb',
          fr: 'Évitez l\'orbe de vent',
          cn: '躲避风圈',
          ko: '에어로 구슬 피하기'
        }
      };
      if (data.windResistDown[data.me]) return {
        infoText: output.avoid()
      };
      return {
        alertText: output.pop()
      };
    }
  }, {
    id: 'LostCityHard Winged Lion Ancient Holy',
    type: 'Ability',
    netRegex: {
      id: '15CA',
      source: 'Winged Lion',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pop holy orb',
        de: 'Nimm Sanctus Orb',
        fr: 'Prenez l\'orbe de lumière',
        cn: '踩神圣圈',
        ko: '홀리 구슬 잡기'
      }
    }
  }, {
    id: 'LostCityHard Light Sprite Banish 3',
    type: 'StartsUsing',
    netRegex: {
      id: '680',
      source: 'Light Sprite'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'LostCityHard Mana Pot Mysterious Light',
    type: 'StartsUsing',
    netRegex: {
      id: '16C8',
      source: 'Mana Pot',
      capture: false
    },
    // These adds tend to do this all at once (or close) so be less noisy.
    suppressSeconds: 5,
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'LostCityHard Kuribu Regen',
    type: 'StartsUsing',
    netRegex: {
      id: '15DC',
      source: 'Kuribu',
      capture: false
    },
    condition: data => data.role === 'tank' || data.job === 'BLU',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move boss out of puddle',
        de: 'Bewege Boss aus der Fläche',
        fr: 'Déplacez le boss hors de la zone au sol',
        cn: '把BOSS拉出罩子',
        ko: '보스 장판에서 나오도록 유도하기'
      }
    }
  }, {
    id: 'LostCityHard Kuribu Cure IV',
    type: 'StartsUsing',
    netRegex: {
      id: '15DF',
      source: 'Kuribu',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in Circle',
        de: 'In einem Kreis stehen',
        fr: 'Restez dans le cercle',
        cn: '站进圈圈',
        ko: '보스 장판 안으로'
      }
    }
  }, {
    id: 'LostCityHard Kuribu Cure IV Reverse',
    type: 'StartsUsing',
    netRegex: {
      id: '15E0',
      source: 'Kuribu',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'LostCityHard Kuribu Cure III',
    type: 'HeadMarker',
    netRegex: {
      id: '004A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Achamoth': 'Achamoth',
      'Dark Wings': 'Dunkle Schwingen',
      'Kuribu': 'Kuribu',
      'Mana Pot': 'Manatopf',
      'Ranting Ranks Gremlin': 'tobend(?:e|er|es|en) Gremlin',
      'The Protectorate': 'Weihestätte',
      'The Tower Of White': 'Weißmagischer Turm',
      'Void Monk': 'Nichtsmönch',
      'Whisper of Existence': 'Trugbild',
      'Winged Lion': 'Schwingenlöwe',
      'light sprite': 'Licht-Exergon'
    },
    'replaceText': {
      '--adds--': '--Adds--',
      'Ancient Aero': 'Antiker Wind',
      'Ancient Holy': 'Sanctus Antiquus',
      'Ancient Libra': 'Antike Analyse',
      'Ancient Stone': 'Antiker Stein',
      'Cure III': 'Vitaga',
      'Cure IV': 'Vitaka',
      'Decoy': 'Lockvogel',
      'Enthrallment': 'Bezauberung',
      'Glory': 'Ruhm',
      'Neuro Squama': 'Neuroschuppen',
      'Psycho Squama': 'Psychoschuppen',
      'Regen': 'Regena',
      'Reverse': 'Umkehrung',
      'Scratch': 'Schramme',
      'Toxic Squama': 'Giftschuppen',
      'Transference': 'Transfer'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Achamoth': 'Achamoth',
      'Dark Wings': 'Ailes sombres',
      'Kuribu': 'Kuribu',
      'Mana Pot': 'pot de mana',
      'Ranting Ranks Gremlin': 'gremlin chahuteur',
      'The Protectorate': 'Protectorat',
      'The Tower Of White': 'Tour des Guérisseurs',
      'Void Monk': 'moine du néant',
      'Whisper of Existence': 'mirage',
      'Winged Lion': 'lion ailé',
      'light sprite': 'élémentaire de lumière'
    },
    'replaceText': {
      '--adds--': '--Adds--',
      'Ancient Aero': 'Vent ancien',
      'Ancient Holy': 'Miracle ancien',
      'Ancient Libra': 'Acuité ancienne',
      'Ancient Stone': 'Terre ancienne',
      'Cure III': 'Méga Soin',
      'Cure IV': 'Giga Soin',
      'Decoy': 'Leurre',
      'Enthrallment': 'Fascination',
      'Glory': 'Gloire',
      'Neuro Squama': 'Photo-écailles',
      'Psycho Squama': 'Psycho-écailles',
      'Regen': 'Récup',
      'Reverse': 'Inversion',
      'Scratch': 'Griffade',
      'Toxic Squama': 'Toxico-écailles',
      'Transference': 'Transfert'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Achamoth': 'アカモート',
      'Dark Wings': '黒風',
      'Kuribu': 'クリブ',
      'Mana Pot': 'マナポット',
      'Ranting Ranks Gremlin': 'グレムリン・ランター',
      'The Protectorate': '守護の聖域',
      'The Tower Of White': '白魔道士の塔',
      'Void Monk': 'ヴォイドモンク',
      'Whisper of Existence': '冒険者の幻影',
      'Winged Lion': 'ウィングドライオン',
      'light sprite': 'ライトスプライト'
    },
    'replaceText': {
      'Ancient Aero': 'エンシェントエアロ',
      'Ancient Holy': 'エンシェントホーリー',
      'Ancient Libra': 'エンシェントライブラ',
      'Ancient Stone': 'エンシェントストーン',
      'Cure III': 'ケアルガ',
      'Cure IV': 'ケアルジャ',
      'Decoy': 'デコイ',
      'Enthrallment': '無我夢中',
      'Glory': 'グローリーブレード',
      'Neuro Squama': '幻惑の鱗粉',
      'Psycho Squama': '魅了の鱗粉',
      'Regen': 'リジェネ',
      'Reverse': 'リバース',
      'Scratch': 'スクラッチ',
      'Toxic Squama': '毒素の鱗粉',
      'Transference': '転移'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Achamoth': '阿卡莫特',
      'Dark Wings': '黑旋风',
      'Kuribu': '基路伯',
      'Mana Pot': '魔力罐',
      'Ranting Ranks Gremlin': '咆哮格雷姆林',
      'The Protectorate': '守护圣域',
      'The Tower Of White': '白魔法师塔',
      'Void Monk': '虚无鬼鱼',
      'Whisper of Existence': '冒险者的幻影',
      'Winged Lion': '双翼飞狮',
      'light sprite': '光元精'
    },
    'replaceText': {
      '--adds--': '--小怪--',
      'Ancient Aero': '古代疾风',
      'Ancient Holy': '古代神圣',
      'Ancient Libra': '古代侦测',
      'Ancient Stone': '古代飞石',
      'Cure III': '愈疗',
      'Cure IV': '圣疗',
      'Decoy': '引诱',
      'Enthrallment': '醉生梦死',
      'Glory': '荣耀之剑',
      'Neuro Squama': '幻惑鳞粉',
      'Psycho Squama': '魅惑鳞粉',
      'Regen': '再生',
      'Reverse': '逆转',
      'Scratch': '抓击',
      'Toxic Squama': '毒素鳞粉',
      'Transference': '转移'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Achamoth': '아카모트',
      'Dark Wings': '흑풍',
      'Kuribu': '쿠리부',
      'Mana Pot': '마나 항아리',
      'Ranting Ranks Gremlin': '떠벌이 그렘린',
      'The Protectorate': '수호의 성역',
      'The Tower Of White': '백마도사의 탑',
      'Void Monk': '보이드 문어',
      'Whisper of Existence': '모험가의 환영',
      'Winged Lion': '날개사자',
      'light sprite': '빛 정령'
    },
    'replaceText': {
      '--adds--': '--쫄--',
      'Ancient Aero': '에인션트 에어로',
      'Ancient Holy': '에인션트 홀리',
      'Ancient Libra': '에인션트 라이브라',
      'Ancient Stone': '에인션트 스톤',
      'Cure III': '케알가',
      'Cure IV': '케알쟈',
      'Decoy': '유인',
      'Enthrallment': '호접몽',
      'Glory': '영광의 검',
      'Neuro Squama': '현혹의 비늘가루',
      'Psycho Squama': '매혹의 비늘가루',
      'Regen': '리제네',
      'Reverse': '역전',
      'Scratch': '생채기',
      'Toxic Squama': '독소 비늘가루',
      'Transference': '전이'
    }
  }]
};
/* harmony default export */ const the_lost_city_of_amdapor_hard = (the_lost_city_of_amdapor_hard_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/the_lost_city_of_amdapor_hard.txt
const dungeon_the_lost_city_of_amdapor_hard_namespaceObject = "### THE LOST CITY OF AMDAPOR (HARD)\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Use zone-unseal Reset line\r\n# Trigger set contains 'resetWhenOutOfCombat: false'\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~~#\r\n# ACHAMOTH #\r\n#~~~~~~~~~~#\r\n\r\n# -p 15C6:1022.7 -ii 15C8 15C4\r\n# 15C4 Proboscis does little damage and makes this encounter hard to time, so ignored.\r\n# Timings seem to get off if the boss moves around, so extra syncs are added.\r\n\r\n# Tower of White will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"541\" } window 10000,0\r\n1022.7 \"Psycho Squama\" Ability { id: \"15C6\", source: \"Achamoth\" }\r\n1044.0 \"Psycho Squama\" Ability { id: \"15C6\", source: \"Achamoth\" }\r\n1055.1 \"Neuro Squama\" Ability { id: \"15C5\", source: \"Achamoth\" }\r\n1063.2 \"Toxic Squama\" Ability { id: \"15C7\", source: \"Achamoth\" }\r\n1068.2 \"Enthrallment\" Ability { id: \"15C3\", source: \"Whisper of Existence\" }\r\n1078.3 \"Enthrallment\" Ability { id: \"15C3\", source: \"Whisper of Existence\" }\r\n1089.4 \"Psycho Squama\" Ability { id: \"15C6\", source: \"Achamoth\" }\r\n1109.8 \"Toxic Squama\" Ability { id: \"15C7\", source: \"Achamoth\" }\r\n\r\n1130.0 \"Neuro Squama\" Ability { id: \"15C5\", source: \"Achamoth\" }\r\n1140.0 \"Enthrallment\" Ability { id: \"15C3\", source: \"Whisper of Existence\" }\r\n1145.1 \"Toxic Squama\" Ability { id: \"15C7\", source: \"Achamoth\" } window 8,8\r\n1154.1 \"Psycho Squama\" Ability { id: \"15C6\", source: \"Achamoth\" }\r\n1161.1 \"Enthrallment\" Ability { id: \"15C3\", source: \"Whisper of Existence\" }\r\n1183.7 \"Toxic Squama\" Ability { id: \"15C7\", source: \"Achamoth\" } window 8,8\r\n1194.8 \"Psycho Squama\" Ability { id: \"15C6\", source: \"Achamoth\" }\r\n\r\n1212.0 \"Neuro Squama\" Ability { id: \"15C5\", source: \"Achamoth\" } window 20,20 jump 1130\r\n1222.0 \"Enthrallment\" #Ability { id: \"15C3\", source: \"Whisper of Existence\" }\r\n1227.1 \"Toxic Squama\" #Ability { id: \"15C7\", source: \"Achamoth\" }\r\n1236.1 \"Psycho Squama\" #Ability { id: \"15C6\", source: \"Achamoth\" }\r\n1243.1 \"Enthrallment\" #Ability { id: \"15C3\", source: \"Whisper of Existence\" }\r\n1265.7 \"Toxic Squama\" #Ability { id: \"15C7\", source: \"Achamoth\" }\r\n1276.8 \"Psycho Squama\" #Ability { id: \"15C6\", source: \"Achamoth\" }\r\n\r\n\r\n#~~~~~~~~~~~~~#\r\n# WINGED LION #\r\n#~~~~~~~~~~~~~#\r\n\r\n# -p 15CE:2012\r\n# -it \"Winged Lion\"\r\n# -ii 15D1 15D3 15D4 15CF 15CC 15D6 1706 15CD 167B\r\n\r\n# Dark Wings will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"698\" } window 10000,0\r\n2012.0 \"Ancient Aero\" Ability { id: \"15CE\", source: \"Winged Lion\" }\r\n2025.1 \"Scratch\" Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n2033.2 \"Ancient Stone\" Ability { id: \"15D2\", source: \"Winged Lion\" }\r\n2043.3 \"Scratch\" Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n\r\n# can hp% push here\r\n2049.5 \"--sync--\" StartsUsing { id: \"15C9\", source: \"Winged Lion\" } window 50,5\r\n2052.5 \"--sync--\" Ability { id: \"15C9\", source: \"Winged Lion\" }\r\n2054.5 \"--untargetable--\"\r\n2072.6 \"Ancient Holy\" Ability { id: \"15CA\", source: \"Winged Lion\" } window 20,20\r\n2074.6 \"--targetable--\"\r\n\r\n2088.7 \"Ancient Stone\" Ability { id: \"15D2\", source: \"Winged Lion\" }\r\n2097.8 \"Scratch\" Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n2105.9 \"Scratch\" Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n2120.0 \"Ancient Libra\" Ability { id: \"167D\", source: \"Winged Lion\" }\r\n2125.1 \"Scratch\" Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n2133.2 \"Ancient Stone\" Ability { id: \"15D2\", source: \"Winged Lion\" }\r\n2138.3 \"Scratch\" Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n\r\n2143.3 \"--sync--\" StartsUsing { id: \"15C9\", source: \"Winged Lion\" } window 80,5\r\n2145.6 \"--adds--\"\r\n2146.3 \"--sync--\" Ability { id: \"15C9\", source: \"Winged Lion\" }\r\n2148.3 \"--untargetable--\"\r\n2166.4 \"Ancient Holy\" Ability { id: \"15CA\", source: \"Winged Lion\" } window 20,20\r\n2168.4 \"--targetable--\"\r\n\r\n2176.5 \"Ancient Libra\" Ability { id: \"167D\", source: \"Winged Lion\" }\r\n2188.6 \"Ancient Aero\" Ability { id: \"15CE\", source: \"Winged Lion\" }\r\n2196.7 \"Scratch\" Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n2203.7 \"Scratch\" Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n2211.8 \"Ancient Stone\" Ability { id: \"15D2\", source: \"Winged Lion\" }\r\n2218.9 \"Scratch\" Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n2228.0 \"Ancient Aero\" Ability { id: \"15CE\", source: \"Winged Lion\" }\r\n2241.1 \"Ancient Libra\" Ability { id: \"167D\", source: \"Winged Lion\" }\r\n2246.1 \"Scratch\" Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n2254.2 \"Ancient Stone\" Ability { id: \"15D2\", source: \"Winged Lion\" }\r\n2259.3 \"Scratch\" Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n\r\n2264.4 \"--sync--\" StartsUsing { id: \"15C9\", source: \"Winged Lion\" } window 80,5\r\n2266.7 \"--adds--\"\r\n2267.4 \"--sync--\" Ability { id: \"15C9\", source: \"Winged Lion\" }\r\n2269.4 \"--untargetable--\"\r\n2287.5 \"Ancient Holy\" Ability { id: \"15CA\", source: \"Winged Lion\" } window 50,50 jump 2166.4\r\n2289.5 \"--targetable--\"\r\n\r\n2297.6 \"Ancient Libra\" #Ability { id: \"167D\", source: \"Winged Lion\" }\r\n2309.7 \"Ancient Aero\" #Ability { id: \"15CE\", source: \"Winged Lion\" }\r\n2317.8 \"Scratch\" #Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n2324.8 \"Scratch\" #Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n2332.9 \"Ancient Stone\" #Ability { id: \"15D2\", source: \"Winged Lion\" }\r\n2340.0 \"Scratch\" #Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n2349.1 \"Ancient Aero\" #Ability { id: \"15CE\", source: \"Winged Lion\" }\r\n2362.2 \"Ancient Libra\" #Ability { id: \"167D\", source: \"Winged Lion\" }\r\n2367.2 \"Scratch\" #Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n2375.3 \"Ancient Stone\" #Ability { id: \"15D2\", source: \"Winged Lion\" }\r\n2380.4 \"Scratch\" #Ability { id: \"15D5\", source: \"Winged Lion\" }\r\n\r\n\r\n#~~~~~~~~#\r\n# KURIBU #\r\n#~~~~~~~~#\r\n\r\n# Phase 1\r\n# The Protectorate will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"69A\" } window 10000,0\r\n3007.0 \"Glory\" Ability { id: \"15E4\", source: \"Kuribu\" }\r\n3015.1 \"Regen\" Ability { id: \"15DC\", source: \"Kuribu\" }\r\n3022.2 \"Transference\" Ability { id: \"15DE\", source: \"Kuribu\" }\r\n3032.2 \"Cure IV\" Ability { id: \"15DF\", source: \"Kuribu\" }\r\n3042.4 \"Cure III\" Ability { id: \"15D9\", source: \"Kuribu\" }\r\n3050.5 \"Glory\" Ability { id: \"15E4\", source: \"Kuribu\" }\r\n3058.6 \"Glory\" Ability { id: \"15E4\", source: \"Kuribu\" }\r\n\r\n3067.7 \"Glory\" Ability { id: \"15E4\", source: \"Kuribu\" }\r\n3075.8 \"Regen\" Ability { id: \"15DC\", source: \"Kuribu\" }\r\n3082.9 \"Transference\" Ability { id: \"15DE\", source: \"Kuribu\" } window 30,30 jump 3022.2\r\n3092.9 \"Cure IV\" #Ability { id: \"15DF\", source: \"Kuribu\" }\r\n3103.1 \"Cure III\" #Ability { id: \"15D9\", source: \"Kuribu\" }\r\n3111.2 \"Glory\" #Ability { id: \"15E4\", source: \"Kuribu\" }\r\n3119.3 \"Glory\" #Ability { id: \"15E4\", source: \"Kuribu\" }\r\n\r\n# Phase 2\r\n3300.0 \"--untargetable--\" NameToggle { name: \"Kuribu\", toggle: \"00\" } window 300,0\r\n3306.0 \"--targetable--\"\r\n3306.0 \"Reverse\" Ability { id: \"15D8\", source: \"Kuribu\" } window 306,5\r\n\r\n3313.0 \"Regen\" Ability { id: \"15DD\", source: \"Kuribu\" }\r\n3326.1 \"Cure IV\" Ability { id: \"15E0\", source: \"Kuribu\" }\r\n3334.2 \"Glory\" Ability { id: \"15E4\", source: \"Kuribu\" }\r\n3344.3 \"Cure III\" Ability { id: \"15DA\", source: \"Kuribu\" }\r\n3355.5 \"Glory\" Ability { id: \"15E4\", source: \"Kuribu\" }\r\n\r\n3365.6 \"Regen\" Ability { id: \"15DD\", source: \"Kuribu\" } window 30,30 jump 3313\r\n3378.7 \"Cure IV\" #Ability { id: \"15E0\", source: \"Kuribu\" }\r\n3386.8 \"Glory\" #Ability { id: \"15E4\", source: \"Kuribu\" }\r\n3396.9 \"Cure III\" #Ability { id: \"15DA\", source: \"Kuribu\" }\r\n3408.2 \"Glory\" #Ability { id: \"15E4\", source: \"Kuribu\" }\r\n\r\n# Phase 3\r\n3500.0 \"--untargetable--\" NameToggle { name: \"Kuribu\", toggle: \"00\" } window 200,0\r\n3506.0 \"--targetable--\"\r\n3506.0 \"Reverse\" Ability { id: \"15D8\", source: \"Kuribu\" }\r\n3511.0 \"Decoy\" Ability { id: \"15E1\", source: \"Kuribu\" } window 511,10\r\n3511.5 \"--targetable--\"\r\n3516.1 \"Glory\" Ability { id: \"15E4\", source: \"Kuribu\" }\r\n3518.2 \"Transference\" Ability { id: \"15DE\", source: \"Kuribu\" }\r\n3528.2 \"Cure IV\" Ability { id: \"15DF\", source: \"Kuribu\" }\r\n3536.3 \"Glory\" Ability { id: \"15E4\", source: \"Kuribu\" }\r\n\r\n3541.5 \"Reverse\" Ability { id: \"15D8\", source: \"Kuribu\" }\r\n3546.5 \"Decoy\" Ability { id: \"15E2\", source: \"Kuribu\" }\r\n3547.0 \"--targetable--\"\r\n3551.6 \"Regen\" Ability { id: \"15DD\", source: \"Kuribu\" }\r\n3579.7 \"Cure IV\" Ability { id: \"15E0\", source: \"Kuribu\" }\r\n3595.8 \"Cure III\" Ability { id: \"15DA\", source: \"Kuribu\" }\r\n3608.0 \"Glory\" Ability { id: \"15E4\", source: \"Kuribu\" }\r\n\r\n3617.2 \"Reverse\" Ability { id: \"15D8\", source: \"Kuribu\" } window 30,30 jump 3506\r\n3622.2 \"Decoy\" #Ability { id: \"15E1\", source: \"Kuribu\" }\r\n3622.7 \"--targetable--\"\r\n3627.3 \"Glory\" #Ability { id: \"15E4\", source: \"Kuribu\" }\r\n3629.4 \"Transference\" #Ability { id: \"15DE\", source: \"Kuribu\" }\r\n3639.4 \"Cure IV\" #Ability { id: \"15DF\", source: \"Kuribu\" }\r\n3647.5 \"Glory\" #Ability { id: \"15E4\", source: \"Kuribu\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/the_vault.ts



// The Vault
const the_vault_triggerSet = {
  id: 'TheVault',
  zoneId: zone_id/* default.TheVault */.Z.TheVault,
  timelineFile: 'the_vault.txt',
  timelineTriggers: [{
    id: 'The Vault Heavenly Slash',
    regex: /Heavenly Slash/,
    beforeSeconds: 3.5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'The Vault Shining Blade',
    regex: /Shining Blade/,
    beforeSeconds: 3,
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid dashes',
        de: 'Sprint ausweichen',
        fr: 'Évitez les charges',
        ja: 'ブレードを避ける',
        cn: '躲开冲锋',
        ko: '돌진 피하기'
      }
    }
  }, {
    id: 'The Vault Heavy Swing',
    regex: /Heavy Swing/,
    beforeSeconds: 4,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'The Vault Altar Candle',
    regex: /Altar Candle/,
    beforeSeconds: 5,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }],
  triggers: [{
    id: 'The Vault Holiest of Holy',
    type: 'StartsUsing',
    netRegex: {
      id: '101E',
      source: 'Ser Adelphel',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'The Vault Holy Shield Bash',
    type: 'StartsUsing',
    netRegex: {
      id: '101F',
      source: 'Ser Adelphel'
    },
    condition: data => data.role === 'healer',
    alertText: (data, matches, output) => {
      return output.text({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Heal + shield ${player}',
        de: 'Heilung + Schild ${player}',
        fr: 'Soin + bouclier ${player}',
        ja: 'すぐに${player}をヒールする',
        cn: '马上治疗${player}',
        ko: '${player} 강타 대상자'
      }
    }
  }, {
    id: 'The Vault Execution',
    type: 'HeadMarker',
    netRegex: {
      id: '0020'
    },
    response: responses/* Responses.awayFrom */.n3.awayFrom()
  }, {
    id: 'The Vault Black Nebula',
    type: 'StartsUsing',
    netRegex: {
      id: '1042',
      source: 'Face Of The Hero'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun()
  }, {
    id: 'The Vault Faith Unmoving',
    type: 'StartsUsing',
    netRegex: {
      id: '1027',
      source: 'Ser Grinnaux',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'The Vault Dimensional Torsion',
    type: 'Tether',
    netRegex: {
      id: '0001',
      source: 'Aetherial Tear'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 5,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from rifts',
        de: 'Weg von de Ätherspalten',
        fr: 'Éloignez-vous des déchirures',
        ja: '裂け目から離れる',
        cn: '远离黑圈',
        ko: '균열에서 멀리 떨어지기'
      }
    }
  }, {
    id: 'The Vault Altar Pyre',
    type: 'StartsUsing',
    netRegex: {
      id: '1035',
      source: 'Ser Charibert',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'The Vault Holy Chains',
    type: 'HeadMarker',
    netRegex: {
      id: '0061'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.breakChains */.n3.breakChains()
  }, {
    // This prevents out-of-combat activation for the March trigger during Charibert's spawn-in.
    id: 'The Vault Knights Activation',
    type: 'HeadMarker',
    netRegex: {
      id: '0061',
      capture: false
    },
    condition: data => !data.knightsActive,
    run: data => data.knightsActive = true
  }, {
    id: 'The Vault Knights March',
    type: 'AddedCombatant',
    netRegex: {
      name: ['Dawn Knight', 'Dusk Knight'],
      capture: false
    },
    condition: data => data.knightsActive,
    suppressSeconds: 4,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Evade marching knights',
        de: 'Marschierenden Rittern ausweichen',
        fr: 'Esquivez les chevaliers',
        ja: 'ナイトを避ける',
        cn: '躲开人马',
        ko: '자동기사 피하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aetherial Tear': 'Ätherspalt',
      'Dawn Knight': 'Dämmerross',
      'Dusk Knight': 'Morgenross',
      'Face Of The Hero': 'Gesicht des Helden',
      'Ser Adelphel Brightblade': 'Adelphel',
      'Ser Adelphel(?! )': 'Adelphel',
      'Ser Charibert': 'Charibert',
      'Ser Grinnaux the Bull': 'Grinnaux',
      'Ser Grinnaux(?! )': 'Grinnaux',
      'The Chancel': 'Bekenntnis des Glaubens',
      'The Quire': 'Chorempore',
      'The chapter house': 'Himmelsgewölbe'
    },
    'replaceText': {
      'Advent': 'Wiederkunft',
      'Altar Candle': 'Altarkerze',
      'Altar Pyre': 'Scheiterhaufen',
      'Black Knight\'s Tour': 'Schwarzer Rösselsprung',
      'Bloodstain': 'Befleckung',
      'Dimensional Collapse': 'Dimensionskollaps',
      'Dimensional Rip': 'Dimensionsriss',
      'Execution': 'Exekution',
      'Faith Unmoving': 'Fester Glaube',
      'Fast Blade': 'Vortexschnitt',
      'Heavenly Slash': 'Himmelsschlag',
      'Heavensflame': 'Himmlische Flamme',
      'Heavy Swing': 'Schwerer Schwinger',
      'Holiest Of Holy': 'Quell der Heiligkeit',
      'Holy Chain': 'Heilige Kette',
      'Holy Shield Bash': 'Heiliger Schildschlag',
      'Hyperdimensional Slash': 'Hyperdimensionsschlag',
      'Knights Appear': 'Rosse erscheinen',
      'Overpower': 'Kahlrodung',
      'Retreat(?!ing)': 'Rückzug',
      'Retreating': 'zurückziehen',
      'Rive': 'Spalten',
      'Sacred Flame': 'Heilige Flamme',
      'Shining Blade': 'Glänzende Klinge',
      'Solid Ascension': 'Gipfelstürmer',
      'White Knight\'s Tour': 'Weißer Rösselsprung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aetherial Tear': 'Déchirure dimensionnelle',
      'Dawn Knight': 'Cavalier de l\'aube',
      'Dusk Knight': 'Cavalier du crépuscule',
      'Face Of The Hero': 'Visage du héros',
      'Ser Adelphel Brightblade': 'Sire Adelphel',
      'Ser Adelphel(?! )': 'Sire Adelphel',
      'Ser Charibert': 'Sire Charibert',
      'Ser Grinnaux the Bull': 'Sire Grinnaux',
      'Ser Grinnaux(?! )': 'Sire Grinnaux',
      'The Chancel': 'salle de prière du sanctuaire de l\'Azur',
      'The Quire': 'chœur',
      'The chapter house': 'kiosque du patio'
    },
    'replaceText': {
      'Advent': 'Avènement',
      'Altar Candle': 'Cierge funéraire',
      'Altar Pyre': 'Bûcher funéraire',
      'Black Knight\'s Tour': 'Tour de cavalier noir',
      'Bloodstain': 'Tache de sang',
      'Dimensional Collapse': 'Effondrement dimensionnel',
      'Dimensional Rip': 'Déchirure dimensionnelle',
      'Execution': 'Exécution',
      'Faith Unmoving': 'Foi immuable',
      'Fast Blade': 'Lame rapide',
      'Heavenly Slash': 'Lacération céleste',
      'Heavensflame': 'Flamme céleste',
      'Heavy Swing': 'Swing céleste',
      'Holiest Of Holy': 'Saint des saints',
      'Holy Chain': 'Chaîne sacrée',
      'Holy Shield Bash': 'Coup de bouclier saint',
      'Hyperdimensional Slash': 'Lacération hyperdimensionnelle',
      'Knights Appear': 'Apparition des chevaliers',
      'Overpower': 'Domination',
      'Retreat(?!ing)': 'Retraite',
      'Retreating': 'Préparation de la retraite',
      'Rive': 'Coupure',
      'Sacred Flame Enrage?': 'Flamme sacrée Enrage ?',
      'Shining Blade': 'Lame brillante',
      'Solid Ascension': 'Ascension solide',
      'White Knight\'s Tour': 'Tour de cavalier blanc'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aetherial Tear': '次元の裂け目',
      'Dawn Knight': 'ドーン・オートナイト',
      'Dusk Knight': 'ダスク・オートナイト',
      'Face Of The Hero': 'フェイス・オブ・ヒーロー',
      'Ser Adelphel Brightblade': '美剣のアデルフェル',
      'Ser Adelphel(?! )': '聖騎士アデルフェル',
      'Ser Charibert': '聖騎士シャリベル',
      'Ser Grinnaux the Bull': '戦狂のグリノー',
      'Ser Grinnaux(?! )': '聖騎士グリノー',
      'The Chancel': '氷天宮礼拝堂',
      'The Quire': '聖歌隊席',
      'The chapter house': '庭園の小ホール'
    },
    'replaceText': {
      'Advent': '降臨',
      'Altar Candle': 'アルターキャンドル',
      'Altar Pyre': 'アルターパイヤ',
      'Black Knight\'s Tour': 'ブラックナイトツアー',
      'Bloodstain': 'ブラッドステイン',
      'Dimensional Collapse': 'ディメンションクラッシュ',
      'Dimensional Rip': 'ディメンションリップ',
      'Execution': 'エクスキューション',
      'Faith Unmoving': 'フェイスアンムーブ',
      'Fast Blade': 'ファストブレード',
      'Heavenly Slash': 'ヘヴンリースラッシュ',
      'Heavensflame': 'へヴンフレイム',
      'Heavy Swing': 'ヘヴンリースイング',
      'Holiest Of Holy': 'ホリエストホーリー',
      'Holy Chain': 'ホーリーチェーン',
      'Holy Shield Bash': 'ホーリーシールドバッシュ',
      'Hyperdimensional Slash': 'ハイパーディメンション',
      'Knights Appear': 'ナイト出現',
      'Overpower': 'オーバーパワー',
      'Retreat(?!ing)': '撤退',
      'Retreating': '撤退中',
      'Rive': 'ライブ',
      'Sacred Flame': '聖火燃焼',
      'Shining Blade': 'シャイニングブレード',
      'Solid Ascension': 'ソリッドライズ',
      'White Knight\'s Tour': 'ホワイトナイトツアー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aetherial Tear': '次元裂缝',
      'Dawn Knight': '拂晓骑士',
      'Dusk Knight': '黄昏骑士',
      'Face Of The Hero': '英雄之相',
      'Ser Adelphel Brightblade': '光辉剑 阿代尔斐尔',
      'Ser Adelphel(?! )': '圣骑士阿代尔斐尔',
      'Ser Charibert': '圣骑士沙里贝尔',
      'Ser Grinnaux the Bull': '战争狂 格里诺',
      'Ser Grinnaux(?! )': '圣骑士格里诺',
      'The Chancel': '冰天宫礼拜堂',
      'The Quire': '圣歌队席',
      'The chapter house': '庭园小厅'
    },
    'replaceText': {
      'Advent': '降临',
      'Altar Candle': '圣坛蜡烛',
      'Altar Pyre': '圣坛火葬',
      'Black Knight\'s Tour': '黑骑士之旅',
      'Bloodstain': '染血剑',
      'Dimensional Collapse': '空间破碎',
      'Dimensional Rip': '空间裂痕',
      'Execution': '处刑',
      'Faith Unmoving': '坚定信仰',
      'Fast Blade': '先锋剑',
      'Heavenly Slash': '天斩',
      'Heavensflame': '天火',
      'Heavy Swing': '重挥',
      'Holiest Of Holy': '至圣',
      'Holy Chain': '圣锁',
      'Holy Shield Bash': '圣盾猛击',
      'Hyperdimensional Slash': '多维空间斩',
      'Knights Appear': '骑士出现',
      'Overpower': '超压斧',
      'Retreat': '撤退',
      'Rive': '撕裂斧',
      'Sacred Flame': '圣火燃烧',
      'Shining Blade': '光芒剑',
      'Solid Ascension': '实体升天',
      'White Knight\'s Tour': '白骑士之旅'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aetherial Tear': '차원의 틈새',
      'Dawn Knight': '여명의 자동기사',
      'Dusk Knight': '황혼의 자동기사',
      'Face Of The Hero': '영웅의 형상',
      'Ser Adelphel Brightblade': '미검의 아델펠',
      'Ser Adelphel(?! )': '성기사 아델펠',
      'Ser Charibert': '성기사 샤리베르',
      'Ser Grinnaux the Bull': '전쟁광 그리노',
      'Ser Grinnaux(?! )': '성기사 그리노',
      'The Chancel': '빙천궁 예배당',
      'The Quire': '성가대석',
      'The chapter house': '기사단 강당'
    },
    'replaceText': {
      'Advent': '강림',
      'Altar Candle': '제단의 초',
      'Altar Pyre': '제단의 장작',
      'Black Knight\'s Tour': '흑기사 행진',
      'Bloodstain': '핏자국',
      'Dimensional Collapse': '차원 파괴',
      'Dimensional Rip': '차원 찢기',
      'Execution': '집행',
      'Faith Unmoving': '굳건한 신앙',
      'Fast Blade': '재빠른 검격',
      'Heavenly Slash': '천상의 참격',
      'Heavensflame': '천상의 불꽃',
      'Heavy Swing': '천상의 징벌',
      'Holiest Of Holy': '지고한 신성',
      'Holy Chain': '거룩한 사슬',
      'Holy Shield Bash': '성스러운 방패 강타',
      'Hyperdimensional Slash': '고차원',
      'Knights Appear': '자동 기사 생성',
      'Overpower': '압도',
      'Retreat(?!ing)': '철수',
      'Retreating': '철수 중',
      'Rive': '두 동강 내기',
      'Sacred Flame': '성화 연소',
      'Shining Blade': '찬란한 칼날',
      'Solid Ascension': '불변의 승천',
      'White Knight\'s Tour': '백기사 행진'
    }
  }]
};
/* harmony default export */ const the_vault = (the_vault_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/the_vault.txt
const dungeon_the_vault_namespaceObject = "hideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n###Ser Adelphel Brightblade\r\n# -ii 101B 1374 1019 101C\r\n\r\n# Pre-phase\r\n# Barely worth including, but oh well.\r\n\r\n# The Quire will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"622\" } window 0,1\r\n5.4 \"Fast Blade\" Ability { id: \"2CD\", source: \"Ser Adelphel Brightblade\" } window 5.4,5\r\n12.5 \"Bloodstain\" Ability { id: \"44B\", source: \"Ser Adelphel Brightblade\" }\r\n15.8 \"Fast Blade\" Ability { id: \"2CD\", source: \"Ser Adelphel Brightblade\" }\r\n26.5 \"Fast Blade\" Ability { id: \"2CD\", source: \"Ser Adelphel Brightblade\" }\r\n\r\n33.6 \"Bloodstain\" Ability { id: \"44B\", source: \"Ser Adelphel Brightblade\" } window 10,10\r\n36.8 \"Fast Blade\" Ability { id: \"2CD\", source: \"Ser Adelphel Brightblade\" }\r\n47.5 \"Fast Blade\" Ability { id: \"2CD\", source: \"Ser Adelphel Brightblade\" } jump 26.5\r\n\r\n54.7 \"Bloodstain\"\r\n57.8 \"Fast Blade\"\r\n68.7 \"Fast Blade\"\r\n\r\n# Phase 1\r\n\r\n100.0 \"Advent\" Ability { id: \"1373\", source: \"Ser Adelphel Brightblade\" } window 100,30\r\n102.1 \"Advent\" Ability { id: \"101A\", source: \"Ser Adelphel Brightblade\" }\r\n\r\n110.3 \"Holiest Of Holy\" Ability { id: \"101E\", source: \"Ser Adelphel\" }\r\n114.5 \"Heavenly Slash\" Ability { id: \"101D\", source: \"Ser Adelphel\" }\r\n122.8 \"Holy Shield Bash\" Ability { id: \"101F\", source: \"Ser Adelphel\" } window 10,10\r\n123.9 \"Solid Ascension x2\" Ability { id: \"1020\", source: \"Ser Adelphel\" }\r\n131.8 \"Heavenly Slash\" Ability { id: \"101D\", source: \"Ser Adelphel\" }\r\n\r\n140.0 \"Holiest Of Holy\" Ability { id: \"101E\", source: \"Ser Adelphel\" }\r\n144.2 \"Heavenly Slash\" Ability { id: \"101D\", source: \"Ser Adelphel\" }\r\n152.5 \"Holy Shield Bash\" Ability { id: \"101F\", source: \"Ser Adelphel\" } window 10,10\r\n153.6 \"Solid Ascension x2\" Ability { id: \"1020\", source: \"Ser Adelphel\" }\r\n161.5 \"Heavenly Slash\" Ability { id: \"101D\", source: \"Ser Adelphel\" } window 10,5 jump 131.8\r\n\r\n169.7 \"Holiest Of Holy\"\r\n173.9 \"Heavenly Slash\"\r\n182.2 \"Holy Shield Bash\"\r\n183.3 \"Solid Ascension x2\"\r\n191.2 \"Heavenly Slash\"\r\n\r\n# Phase 2 at < 70% HP\r\n\r\n300.0 \"Shining Blade 1\" Ability { id: \"1022\", source: \"Ser Adelphel\" } window 300,0\r\n302.4 \"Shining Blade 2\" Ability { id: \"1022\", source: \"Ser Adelphel\" } window 2,2\r\n304.6 \"Shining Blade 3\" Ability { id: \"1022\", source: \"Ser Adelphel\" } window 2,2\r\n307.0 \"Shining Blade 4\" Ability { id: \"1022\", source: \"Ser Adelphel\" } window 2,2\r\n309.0 \"--Untargetable--\"\r\n311.7 \"--Targetable--\"\r\n311.7 \"Execution\" Ability { id: \"1023\", source: \"Ser Adelphel\" }\r\n322.8 \"Holiest Of Holy\" Ability { id: \"101E\", source: \"Ser Adelphel\" }\r\n328.0 \"Heavenly Slash\" Ability { id: \"101D\", source: \"Ser Adelphel\" }\r\n337.2 \"Holy Shield Bash\" Ability { id: \"101F\", source: \"Ser Adelphel\" } window 15,15\r\n338.3 \"Solid Ascension x2\" Ability { id: \"1020\", source: \"Ser Adelphel\" }\r\n349.1 \"Holiest Of Holy\" Ability { id: \"101E\", source: \"Ser Adelphel\" }\r\n353.3 \"Heavenly Slash\" Ability { id: \"101D\", source: \"Ser Adelphel\" }\r\n\r\n357.4 \"Shining Blade 1\" Ability { id: \"1022\", source: \"Ser Adelphel\" } window 2,2\r\n359.8 \"Shining Blade 2\" Ability { id: \"1022\", source: \"Ser Adelphel\" } window 2,2\r\n362.0 \"Shining Blade 3\" Ability { id: \"1022\", source: \"Ser Adelphel\" } window 2,2\r\n364.4 \"Shining Blade 4\" Ability { id: \"1022\", source: \"Ser Adelphel\" } window 2,2\r\n366.4 \"--Untargetable--\"\r\n369.0 \"--Targetable--\"\r\n369.1 \"Execution\" Ability { id: \"1023\", source: \"Ser Adelphel\" }\r\n380.2 \"Holiest Of Holy\" Ability { id: \"101E\", source: \"Ser Adelphel\" }\r\n385.4 \"Heavenly Slash\" Ability { id: \"101D\", source: \"Ser Adelphel\" }\r\n394.6 \"Holy Shield Bash\" Ability { id: \"101F\", source: \"Ser Adelphel\" } window 15,15\r\n395.7 \"Solid Ascension x2\" Ability { id: \"1020\", source: \"Ser Adelphel\" }\r\n406.5 \"Holiest Of Holy\" Ability { id: \"101E\", source: \"Ser Adelphel\" }\r\n410.7 \"Heavenly Slash\" Ability { id: \"101D\", source: \"Ser Adelphel\" } window 15,15 jump 353.3\r\n\r\n414.8 \"Shining Blade 1\"\r\n417.2 \"Shining Blade 2\"\r\n419.4 \"Shining Blade 3\"\r\n421.8 \"Shining Blade 4\"\r\n426.5 \"Execution\"\r\n437.6 \"Holiest Of Holy\"\r\n\r\n# Closing sequence\r\n441.9 \"--sync--\" Ability { id: \"10A0\", source: \"Ser Adelphel Brightblade\" } window 450,0\r\n442.0 \"Retreating\" duration 8.0\r\n450 \"Retreat\" Ability { id: \"10A1\", source: \"Ser Adelphel Brightblade\" }\r\n\r\n###Ser Grinneaux the Bull\r\n# -ii 101A\r\n\r\n# Pre-phase\r\n# Chapter House will be sealed off\r\n1000 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"623\" } window 1000,1\r\n1006.7 \"Overpower\" Ability { id: \"88C\", source: \"Ser Grinnaux the Bull\" } window 6.7,5\r\n1015.6 \"Rive\" Ability { id: \"46F\", source: \"Ser Grinnaux the Bull\" }\r\n1018.9 \"Overpower\" Ability { id: \"88C\", source: \"Ser Grinnaux the Bull\" }\r\n1031.2 \"Overpower\" Ability { id: \"88C\", source: \"Ser Grinnaux the Bull\" }\r\n1039.9 \"Rive\" Ability { id: \"46F\", source: \"Ser Grinnaux the Bull\" }\r\n\r\n1043.2 \"Overpower\" Ability { id: \"88C\", source: \"Ser Grinnaux the Bull\" }\r\n1055.5 \"Overpower\" Ability { id: \"88C\", source: \"Ser Grinnaux the Bull\" }\r\n1064.2 \"Rive\" Ability { id: \"46F\", source: \"Ser Grinnaux the Bull\" } window 15,15 jump 1039.9\r\n\r\n1067.5 \"Overpower\"\r\n1079.8 \"Overpower\"\r\n1088.5 \"Rive\"\r\n\r\n# Phase transition\r\n1100.0 \"Advent\" Ability { id: \"1373\", source: \"Ser Grinnaux the Bull\" } window 100,5\r\n1101.0 \"Advent\" Ability { id: \"1374\", source: \"Ser Grinnaux\" }\r\n1101.9 \"--sync--\" Ability { id: \"101B\", source: \"Ser Grinnaux\" }\r\n\r\n# Main Phase\r\n1109.6 \"Dimensional Collapse\" Ability { id: \"1028\", source: \"Ser Grinnaux\" }\r\n1113.7 \"Heavy Swing\" Ability { id: \"1025\", source: \"Ser Grinnaux\" }\r\n1118.0 \"Heavy Swing\" Ability { id: \"1025\", source: \"Ser Grinnaux\" }\r\n1125.1 \"Hyperdimensional Slash\" Ability { id: \"1026\", source: \"Ser Grinnaux\" }\r\n1130.3 \"Hyperdimensional Slash\" Ability { id: \"1026\", source: \"Ser Grinnaux\" }\r\n1134.4 \"Heavy Swing\" Ability { id: \"1025\", source: \"Ser Grinnaux\" }\r\n1139.4 \"Faith Unmoving\" Ability { id: \"1027\", source: \"Ser Grinnaux\" } window 15,15\r\n\r\n1144.1 \"Dimensional Collapse\" Ability { id: \"1028\", source: \"Ser Grinnaux\" }\r\n1152.3 \"Dimensional Rip\" Ability { id: \"102C\", source: \"Ser Grinnaux\" }\r\n1155.5 \"Heavy Swing\" Ability { id: \"1025\", source: \"Ser Grinnaux\" }\r\n1161.6 \"Hyperdimensional Slash\" Ability { id: \"1026\", source: \"Ser Grinnaux\" }\r\n1166.8 \"Hyperdimensional Slash\" Ability { id: \"1026\", source: \"Ser Grinnaux\" }\r\n1170.8 \"Heavy Swing\" Ability { id: \"1025\", source: \"Ser Grinnaux\" }\r\n1177.4 \"Dimensional Collapse\" Ability { id: \"1028\", source: \"Ser Grinnaux\" } window 15,15\r\n1182.5 \"Faith Unmoving\" Ability { id: \"1027\", source: \"Ser Grinnaux\" }\r\n\r\n1192.7 \"Dimensional Rip\" Ability { id: \"102C\", source: \"Ser Grinnaux\" } window 15,15\r\n1195.9 \"Heavy Swing\" Ability { id: \"1025\", source: \"Ser Grinnaux\" }\r\n1202.1 \"Hyperdimensional Slash\" Ability { id: \"1026\", source: \"Ser Grinnaux\" }\r\n1207.9 \"Hyperdimensional Slash\" Ability { id: \"1026\", source: \"Ser Grinnaux\" }\r\n1212.1 \"Heavy Swing\" Ability { id: \"1025\", source: \"Ser Grinnaux\" }\r\n1218.7 \"Dimensional Collapse\" Ability { id: \"1028\", source: \"Ser Grinnaux\" } window 15,15\r\n1223.8 \"Faith Unmoving\" Ability { id: \"1027\", source: \"Ser Grinnaux\" }\r\n\r\n1234.0 \"Dimensional Rip\" Ability { id: \"102C\", source: \"Ser Grinnaux\" } window 15,15\r\n1237.1 \"Heavy Swing\" Ability { id: \"1025\", source: \"Ser Grinnaux\" }\r\n1243.3 \"Hyperdimensional Slash\" Ability { id: \"1026\", source: \"Ser Grinnaux\" }\r\n1248.8 \"Hyperdimensional Slash\" Ability { id: \"1026\", source: \"Ser Grinnaux\" }\r\n1253.0 \"Heavy Swing\" Ability { id: \"1025\", source: \"Ser Grinnaux\" }\r\n1259.6 \"Dimensional Collapse\" Ability { id: \"1028\", source: \"Ser Grinnaux\" } window 15,15\r\n1264.7 \"Faith Unmoving\" Ability { id: \"1027\", source: \"Ser Grinnaux\" } jump 1182.5\r\n\r\n# Closing sequence\r\n1441.9 \"--sync--\" Ability { id: \"10A0\", source: \"Ser Grinnaux the Bull\" } window 500,10\r\n1442.0 \"Retreating\" duration 8\r\n1450.0 \"Retreat\" Ability { id: \"10A1\", source: \"Ser Grinnaux the Bull\" }\r\n\r\n\r\n###Ser Charibert\r\n\r\n# The Chancel will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"624\" } window 2000,0\r\n2006.3 \"Altar Candle\" Ability { id: \"1030\", source: \"Ser Charibert\" } window 6.3,5\r\n2015.0 \"Heavensflame\" Ability { id: \"1031\", source: \"Ser Charibert\" }\r\n2019.2 \"Holy Chain\" Ability { id: \"1033\", source: \"Ser Charibert\" } window 15,15\r\n2024.4 \"Altar Candle\" Ability { id: \"1030\", source: \"Ser Charibert\" }\r\n2028.7 \"Knights Appear\"\r\n2037.6 \"Altar Pyre\" Ability { id: \"1035\", source: \"Ser Charibert\" } window 15,15\r\n\r\n2046.6 \"Altar Candle\" Ability { id: \"1030\", source: \"Ser Charibert\" }\r\n2055.3 \"Heavensflame\" Ability { id: \"1031\", source: \"Ser Charibert\" }\r\n2059.5 \"Holy Chain\" Ability { id: \"1033\", source: \"Ser Charibert\" } window 15,15\r\n2064.7 \"Altar Candle\" Ability { id: \"1030\", source: \"Ser Charibert\" }\r\n2068.8 \"Knights Appear\"\r\n2077.9 \"Altar Pyre\" Ability { id: \"1035\", source: \"Ser Charibert\" } window 15,15 jump 2037.6\r\n\r\n2086.9 \"Altar Candle\"\r\n2095.6 \"Heavensflame\"\r\n2099.8 \"Holy Chain\"\r\n2105.0 \"Altar Candle\"\r\n\r\n# Intermission at < 60% HP\r\n\r\n2200.0 \"--sync--\" Ability { id: \"1019\", source: \"Ser Charibert\" } window 200,5\r\n2205.1 \"--sync--\" Ability { id: \"1018\", source: \"Ser Charibert\" }\r\n2207.2 \"--sync--\" Ability { id: \"1036\", source: \"Ser Charibert\" }\r\n2218.4 \"Black Knight's Tour\" Ability { id: \"1039\", source: \"Dusk Knight\" }\r\n2218.5 \"White Knight's Tour\" Ability { id: \"1038\", source: \"Dawn Knight\" }\r\n2231.7 \"Black Knight's Tour\" Ability { id: \"1039\", source: \"Dusk Knight\" }\r\n2231.9 \"White Knight's Tour\" Ability { id: \"1038\", source: \"Dawn Knight\" }\r\n2245.0 \"Black Knight's Tour\" Ability { id: \"1039\", source: \"Dusk Knight\" }\r\n2245.2 \"White Knight's Tour\" Ability { id: \"1038\", source: \"Dawn Knight\" }\r\n2254.5 \"Sacred Flame Enrage?\"\r\n\r\n2294.0 \"--sync--\" Ability { id: \"1037\", source: \"Ser Charibert\" } window 2294,0\r\n\r\n# The party might survive an intermission enrage.\r\n# This wide window on Candle allows for that.\r\n2300.0 \"Altar Candle\" Ability { id: \"1030\", source: \"Ser Charibert\" } window 100,20\r\n2309.0 \"Altar Pyre\" Ability { id: \"1035\", source: \"Ser Charibert\" }\r\n2316.3 \"Knights Appear\"\r\n2318.6 \"Heavensflame\" Ability { id: \"1031\", source: \"Ser Charibert\" } window 15,15\r\n2322.8 \"Holy Chain\" Ability { id: \"1033\", source: \"Ser Charibert\" }\r\n2332.0 \"Altar Pyre\" Ability { id: \"1035\", source: \"Ser Charibert\" }\r\n2336.1 \"Altar Candle\" Ability { id: \"1030\", source: \"Ser Charibert\" }\r\n\r\n2345.3 \"Altar Candle\" Ability { id: \"1030\", source: \"Ser Charibert\" }\r\n2354.3 \"Altar Pyre\" Ability { id: \"1035\", source: \"Ser Charibert\" }\r\n2356.6 \"Knights Appear\"\r\n2363.9 \"Heavensflame\" Ability { id: \"1031\", source: \"Ser Charibert\" } window 15,15\r\n2368.1 \"Holy Chain\" Ability { id: \"1033\", source: \"Ser Charibert\" }\r\n2377.3 \"Altar Pyre\" Ability { id: \"1035\", source: \"Ser Charibert\" }\r\n2381.4 \"Altar Candle\" Ability { id: \"1030\", source: \"Ser Charibert\" } window 15,5 jump 2336.1\r\n\r\n2390.6 \"Altar Candle\"\r\n2399.6 \"Altar Pyre\"\r\n2409.2 \"Heavensflame\"\r\n2413.4 \"Holy Chain\"\r\n2422.6 \"Altar Pyre\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/xelphatol.ts



// Xelphatol
const xelphatol_triggerSet = {
  id: 'Xelphatol',
  zoneId: zone_id/* default.Xelphatol */.Z.Xelphatol,
  timelineFile: 'xelphatol.txt',
  timelineTriggers: [{
    id: 'Xelphatol Short Burst',
    regex: /Short Burst/,
    beforeSeconds: 4,
    suppressSeconds: 5,
    // Timelines jump sometimes, so let's not be noisy.
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    // This might be better handled by collecting Swiftfeather,
    // but a timeline trigger is easy and consistent.
    // This is *technically* avoidable, but if mishandled can kill melee or unwary healers.
    // (The timing from "cone locked in" to "cone damage snapshots" is 0.70 seconds.)
    id: 'Xelphatol On Low',
    regex: /On Low/,
    beforeSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Xelphatol Ixali Aero Buster',
    regex: /Ixali Aero \(buster\)/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }],
  triggers: [{
    id: 'Xelphatol Long Burst',
    type: 'StartsUsing',
    netRegex: {
      id: '19C8',
      source: 'Nuzal Hueloc',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Xelphatol Hot Blast',
    type: 'StartsUsing',
    netRegex: {
      id: '19CC',
      source: 'Floating Turret',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Xelphatol On High',
    type: 'StartsUsing',
    netRegex: {
      id: '19CF',
      source: 'Dotoli Ciloc',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Xelphatol Dark Wings',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Puddle on YOU',
        de: 'Fläche auf DIR',
        fr: 'Zone au sol sur VOUS',
        ja: '自分に風',
        cn: '风圈点名',
        ko: '장판 대상자'
      }
    }
  }, {
    id: 'Xelphatol Ixali Aero AOE',
    type: 'StartsUsing',
    netRegex: {
      id: '19D5',
      source: 'Tozol Huatotl',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Xelphatol Bill',
    type: 'HeadMarker',
    netRegex: {
      id: '0046'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Xelphatol Hawk',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Abalathian Hornbill': 'abalathisch(?:e|er|es|en) Hornrabe',
      'Dotoli Ciloc': 'Dotoli Ciloc',
      'Garuda': 'Garuda',
      'Nuzal Hueloc': 'Nuzal Hueloc',
      'The Cage': 'Halbhöhle',
      'The Tlachtli': 'Tlachtli',
      'The Vortex': 'Ursprung des Windes',
      'Tozol Huatotl': 'Tozol Huatotl',
      'Floating Turret': 'Schwebend(?:e|er|es|en) Geschütz'
    },
    'replaceText': {
      '\\(buster\\)': '(Tankbuster)',
      '\\(line\\)': '(Line)',
      '\\(aoe\\)': '(AoE)',
      'Aerial Blast': 'Windschlag',
      'Air Raid': 'Luftangriff',
      'Bill': 'Schnabel',
      'Dark Wings': 'Dunkle Schwingen',
      'Eye Of The Storm': 'Auge des Sturms',
      'Ingurgitate': 'Fütterung',
      'Ixali Aero(?! I)': 'Ixal-Wind',
      'Ixali Aero II(?!I)': 'Ixal-Windra',
      'Ixali Aero III': 'Ixal-Windga',
      'Lift': 'Aufsteigen',
      'Long Burst': 'Aero-Schuss',
      'Mistral Song': 'Mistral-Song',
      'On High': 'Brausender Fächersturm',
      'On Low': 'Fächersturm',
      'Short Burst': 'Kurzer Knall',
      'Summon Garuda': 'Beschwörung Garudas',
      'Swiftfeather': 'Leichte Feder',
      'Wicked Wheel': 'Rad der Bosheit',
      'Wind Blast': 'Windknall'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Abalathian Hornbill': 'bucorve d\'Abalathia',
      'Dotoli Ciloc': 'Dotoli Ciloc',
      'Floating Turret': 'tourelle volante',
      'Garuda': 'Garuda',
      'Nuzal Hueloc': 'Nuzal Hueloc',
      'The Cage': 'Le Nichoir',
      'The Tlachtli': 'Tlachtli',
      'The Vortex': 'Source des rafales',
      'Tozol Huatotl': 'Tozol Huatotl'
    },
    'replaceText': {
      '\\(buster\\)': '(Tank buster)',
      '\\(line\\)': '(Ligne)',
      '\\(aoe\\)': '(AoE)',
      'Aerial Blast': 'Rafale aérienne',
      'Air Raid': 'Raid aérien',
      'Bill': 'Bec solide',
      'Dark Wings': 'Ailes sombres',
      'Eye Of The Storm': 'Œil du cyclone',
      'Ingurgitate': 'Nourrissage',
      'Ixali Aero(?! I)': 'Vent ixal',
      'Ixali Aero II(?!I)': 'Extra Vent ixal',
      'Ixali Aero III': 'Méga Vent ixal',
      'Lift': 'Montée',
      'Long Burst': 'Gros éclatement',
      'Mistral Song': 'Chant du mistral',
      'On High': 'Grand éventement',
      'On Low': 'Éventement',
      'Short Burst': 'Petit éclatement',
      'Summon Garuda': 'Invocation de Garuda',
      'Swiftfeather': 'Plume vive',
      'Wicked Wheel': 'Roue mauvaise',
      'Wind Blast': 'Coup de vent'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Abalathian Hornbill': 'アバラシア・ホーンビル',
      'Dotoli Ciloc': '旋風のドトリ・シロック',
      'Garuda': 'ガルーダ',
      'Nuzal Hueloc': '飛天のヌザル・フェロック',
      'The Cage': '営巣地門前',
      'The Tlachtli': 'タパソリ闘技場',
      'The Vortex': '神前祭壇',
      'Tozol Huatotl': '晴嵐のトゾル・ファトトル',
      'Floating Turret': 'バルーンタレット'
    },
    'replaceText': {
      '\\(buster\\)': '(タンクバスター)',
      '\\(line\\)': '(直線範囲)',
      '\\(aoe\\)': '(AoE)',
      'Aerial Blast': 'エリアルブラスト',
      'Air Raid': 'エアレイド',
      'Bill': 'ソリッドビル',
      'Dark Wings': '黒風',
      'Eye Of The Storm': 'アイ・オブ・ストーム',
      'Ingurgitate': '給餌',
      'Ixali Aero(?! I)': 'イクサリエアロ',
      'Ixali Aero II(?!I)': 'イクサリエアロラ',
      'Ixali Aero III': 'イクサリエアロガ',
      'Lift': '上昇',
      'Long Burst': 'エアロショット',
      'Mistral Song': 'ミストラルソング',
      'On High': '大扇風',
      'On Low': '扇風',
      'Short Burst': 'ショットバースト',
      'Summon Garuda': 'ガルーダ召喚',
      'Swiftfeather': 'スウィフトフェザー',
      'Wicked Wheel': 'ウィケッドホイール',
      'Wind Blast': 'ウィンドブラスト'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Abalathian Hornbill': '阿巴拉提亚犀鸟',
      'Dotoli Ciloc': '旋风扇 德托里·西罗克',
      'Garuda': '迦楼罗',
      'Nuzal Hueloc': '飞天枪 奴扎尔·怀罗克',
      'The Cage': '巢营门前',
      'The Tlachtli': '塔帕索利斗技场',
      'The Vortex': '风神祭坛',
      'Tozol Huatotl': '晴天霹雳 托佐尔·法托特尔',
      'Floating Turret': '气球炮塔'
    },
    'replaceText': {
      '\\(buster\\)': '(死刑)',
      '\\(line\\)': '(直线)',
      '\\(aoe\\)': '(AOE)',
      'Aerial Blast': '大气爆发',
      'Air Raid': '空袭',
      'Bill': '坚喙',
      'Dark Wings': '黑旋风',
      'Eye Of The Storm': '台风眼',
      'Ingurgitate': '掠食',
      'Ixali Aero(?! I)': '鸟人疾风',
      'Ixali Aero II(?!I)': '鸟人烈风',
      'Ixali Aero III': '鸟人暴风',
      'Lift': '上升',
      'Long Burst': '疾风射击',
      'Mistral Song': '寒风之歌',
      'On High': '大扇风',
      'On Low': '扇风',
      'Short Burst': '爆裂射击',
      'Summon Garuda': '召唤迦楼罗',
      'Swiftfeather': '身轻如燕',
      'Wicked Wheel': '邪轮旋风',
      'Wind Blast': '烈风爆射'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Abalathian Hornbill': '아발라시아 뿔부리',
      'Dotoli Ciloc': '선풍의 도톨리 실록',
      'Garuda': '가루다',
      'Nuzal Hueloc': '비천의 누잘 후엘록',
      'The Cage': '거주지 입구',
      'The Tlachtli': '타팍솔리 투기장',
      'The Vortex': '접신 제단',
      'Tozol Huatotl': '청풍의 토졸 후아토틀',
      'Floating Turret': '기구 포탑'
    },
    'replaceText': {
      'Aerial Blast': '대기 폭발',
      'Air Raid': '공습',
      'Bill': '단단한 부리',
      'Dark Wings': '흑풍',
      'Eye Of The Storm': '태풍의 눈',
      'Ingurgitate': '먹이 주기',
      'Ixali Aero(?! I)': '이크살 에어로',
      'Ixali Aero II(?!I)': '이크살 에어로라',
      'Ixali Aero III': '이크살 에어로가',
      'Lift': '상승',
      'Long Burst': '바람 사격',
      'Mistral Song': '삭풍의 노래',
      'On High': '대선풍',
      'On Low': '선풍',
      'Short Burst': '폭렬 사격',
      'Summon Garuda': '가루다 소환',
      'Swiftfeather': '깃털 바람',
      'Wicked Wheel': '마녀의 수레바퀴',
      'Wind Blast': '바람 분출'
    }
  }]
};
/* harmony default export */ const xelphatol = (xelphatol_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/dungeon/xelphatol.txt
const dungeon_xelphatol_namespaceObject = "### XELPHATOL\r\n# TODO: update to use forcejump\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~~~~~~#\r\n# NUZAL HUELOC #\r\n#~~~~~~~~~~~~~~#\r\n\r\n# -ii 19CB 19CC\r\n# -ic \"Ixali Stitcher\" \"Airstone\"\r\n\r\n# The Cage will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"6FD\" } window 0,1\r\n7.0 \"Short Burst\" Ability { id: \"19C6\", source: \"Nuzal Hueloc\" } window 7,5\r\n15.1 \"Wind Blast\" Ability { id: \"19C7\", source: \"Nuzal Hueloc\" }\r\n19.2 \"Short Burst\" Ability { id: \"19C6\", source: \"Nuzal Hueloc\" }\r\n24.3 \"Lift\" Ability { id: \"19C9\", source: \"Nuzal Hueloc\" } window 24.3,5\r\n24.8 \"--untargetable--\"\r\n\r\n28.5 \"Air Raid\" Ability { id: \"19CA\", source: \"Nuzal Hueloc\" } window 5,6\r\n36.6 \"Air Raid\" Ability { id: \"19CA\", source: \"Nuzal Hueloc\" }\r\n48.1 \"Air Raid\" Ability { id: \"19CA\", source: \"Nuzal Hueloc\" }\r\n59.6 \"Air Raid\" Ability { id: \"19CA\", source: \"Nuzal Hueloc\" } jump 36.6\r\n71.1 \"Air Raid\"\r\n82.6 \"Air Raid\"\r\n94.1 \"Air Raid\"\r\n\r\n100.0 \"--sync--\" NameToggle { name: \"Nuzal Hueloc\", toggle: \"01\" } window 100,5\r\n121.3 \"Wind Blast\" Ability { id: \"19C7\", source: \"Nuzal Hueloc\" } window 21.3,5\r\n129.5 \"Long Burst\" Ability { id: \"19C8\", source: \"Nuzal Hueloc\" }\r\n132.7 \"Short Burst\" Ability { id: \"19C6\", source: \"Nuzal Hueloc\" }\r\n\r\n139.8 \"Wind Blast\" Ability { id: \"19C7\", source: \"Nuzal Hueloc\" } jump 121.3\r\n148.0 \"Long Burst\"\r\n151.2 \"Short Burst\"\r\n158.3 \"Wind Blast\"\r\n166.5 \"Long Burst\"\r\n169.7 \"Short Burst\"\r\n\r\n# syncing to a 14/20 line to give the user a little extra warning.\r\n200.0 \"--sync--\" StartsUsing { id: \"19C9\", source: \"Nuzal Hueloc\" } window 100,5\r\n202.7 \"Lift\" Ability { id: \"19C9\", source: \"Nuzal Hueloc\" }\r\n203.2 \"--untargetable--\"\r\n206.9 \"Air Raid\" Ability { id: \"19CA\", source: \"Nuzal Hueloc\" }\r\n214.6 \"Air Raid\" Ability { id: \"19CA\", source: \"Nuzal Hueloc\" }\r\n226.1 \"Air Raid\" Ability { id: \"19CA\", source: \"Nuzal Hueloc\" }\r\n237.6 \"Air Raid\" Ability { id: \"19CA\", source: \"Nuzal Hueloc\" } jump 206.9\r\n249.1 \"Air Raid\"\r\n260.6 \"Air Raid\"\r\n272.1 \"Air Raid\"\r\n\r\n\r\n300.0 \"--sync--\" NameToggle { name: \"Nuzal Hueloc\", toggle: \"01\" } window 100,5\r\n305.3 \"Short Burst\" Ability { id: \"19C6\", source: \"Nuzal Hueloc\" } window 5,10\r\n314.4 \"Wind Blast\" Ability { id: \"19C7\", source: \"Nuzal Hueloc\" }\r\n323.5 \"Long Burst\" Ability { id: \"19C8\", source: \"Nuzal Hueloc\" }\r\n\r\n330.7 \"Short Burst\" Ability { id: \"19C6\", source: \"Nuzal Hueloc\" } jump 305.3\r\n339.8 \"Wind Blast\"\r\n348.9 \"Long Burst\"\r\n356.1 \"Short Burst\"\r\n365.2 \"Wind Blast\"\r\n374.3 \"Long Burst\"\r\n\r\n\r\n#~~~~~~~~~~~~~~#\r\n# DOTOLI CILOC #\r\n#~~~~~~~~~~~~~~#\r\n\r\n# -ii 19D2\r\n\r\n# The Tlachtli will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"6FE\" } window 1000,5\r\n1012.4 \"On Low\" Ability { id: \"19CE\", source: \"Dotoli Ciloc\" }\r\n1024.5 \"On High\" Ability { id: \"19CF\", source: \"Dotoli Ciloc\" } window 24.5,10\r\n\r\n1036.7 \"On Low\" Ability { id: \"19CE\", source: \"Dotoli Ciloc\" }\r\n1045.2 \"Dark Wings\" Ability { id: \"19D0\", source: \"Dotoli Ciloc\" }\r\n1055.2 \"Swiftfeather\" Ability { id: \"19D1\", source: \"Dotoli Ciloc\" }\r\n1057.6 \"On Low\" Ability { id: \"19CE\", source: \"Dotoli Ciloc\" }\r\n1068.0 \"Dark Wings\" Ability { id: \"19D0\", source: \"Dotoli Ciloc\" }\r\n1074.6 \"On High\" Ability { id: \"19CF\", source: \"Dotoli Ciloc\" } window 20,20\r\n1076.8 \"Dark Wings\" Ability { id: \"19D0\", source: \"Dotoli Ciloc\" }\r\n\r\n1091.8 \"On Low\" Ability { id: \"19CE\", source: \"Dotoli Ciloc\" } jump 1036.7\r\n1100.3 \"Dark Wings\"\r\n1110.3 \"Swiftfeather\"\r\n1112.7 \"On Low\"\r\n1123.1 \"Dark Wings\"\r\n\r\n\r\n#~~~~~~~~~~~~~~~#\r\n# Tozol Huatotl #\r\n#~~~~~~~~~~~~~~~#\r\n\r\n# -ii 19D8\r\n\r\n# The Vortex will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"6FF\" } window 2000,5\r\n2007.1 \"Ixali Aero (buster)\" Ability { id: \"19D3\", source: \"Tozol Huatotl\" } window 7.1,5\r\n2014.2 \"Ixali Aero III (aoe)\" Ability { id: \"19D5\", source: \"Tozol Huatotl\" }\r\n2023.7 \"Bill\" Ability { id: \"19DA\", source: \"Abalathian Hornbill\" }\r\n2028.5 \"Ixali Aero (buster)\" Ability { id: \"19D3\", source: \"Tozol Huatotl\" }\r\n2035.6 \"Ixali Aero II (line)\" Ability { id: \"19D4\", source: \"Tozol Huatotl\" }\r\n2045.3 \"Ingurgitate\" Ability { id: \"19D9\", source: \"Abalathian Hornbill\" } window 10,10\r\n2050.9 \"Ixali Aero III (aoe)\" Ability { id: \"19D5\", source: \"Tozol Huatotl\" }\r\n2055.0 \"Ixali Aero (buster)\" Ability { id: \"19D3\", source: \"Tozol Huatotl\" }\r\n\r\n2063.1 \"Summon Garuda\" Ability { id: \"19D7\", source: \"Tozol Huatotl\" } window 63.1,10\r\n2072.7 \"Bill\" Ability { id: \"19DA\", source: \"Abalathian Hornbill\" }\r\n2072.9 \"Eye Of The Storm\" Ability { id: \"19DB\", source: \"Garuda\" }\r\n2074.8 \"Mistral Song\" Ability { id: \"19DC\", source: \"Garuda\" } window 20,20\r\n2078.5 \"Ixali Aero II (line)\" Ability { id: \"19D4\", source: \"Tozol Huatotl\" }\r\n2084.7 \"Ixali Aero (buster)\" Ability { id: \"19D3\", source: \"Tozol Huatotl\" }\r\n2091.8 \"Ixali Aero III (aoe)\" Ability { id: \"19D5\", source: \"Tozol Huatotl\" }\r\n2102.5 \"Ingurgitate\" Ability { id: \"19D9\", source: \"Abalathian Hornbill\" }\r\n2107.1 \"Ixali Aero II (line)\" Ability { id: \"19D4\", source: \"Tozol Huatotl\" }\r\n2112.2 \"Ixali Aero III (aoe)\" Ability { id: \"19D5\", source: \"Tozol Huatotl\" }\r\n2115.4 \"Ixali Aero (buster)\" Ability { id: \"19D3\", source: \"Tozol Huatotl\" }\r\n2127.3 \"Summon Garuda\" Ability { id: \"19D7\", source: \"Tozol Huatotl\" } window 30,30\r\n2136.7 \"Bill\" Ability { id: \"19DA\", source: \"Abalathian Hornbill\" }\r\n2139.0 \"Eye Of The Storm\" Ability { id: \"19DB\", source: \"Garuda\" }\r\n2139.0 \"Wicked Wheel\" Ability { id: \"19DD\", source: \"Garuda\" }\r\n2145.2 \"Aerial Blast\" Ability { id: \"19DE\", source: \"Garuda\" }\r\n2150.7 \"Ixali Aero III (aoe)\" Ability { id: \"19D5\", source: \"Tozol Huatotl\" }\r\n2161.0 \"Ixali Aero (buster)\" Ability { id: \"19D3\", source: \"Tozol Huatotl\" }\r\n2168.1 \"Ixali Aero III (aoe)\" Ability { id: \"19D5\", source: \"Tozol Huatotl\" }\r\n2178.8 \"Ingurgitate\" Ability { id: \"19D9\", source: \"Abalathian Hornbill\" } window 30,30\r\n2183.4 \"Ixali Aero II (line)\" Ability { id: \"19D4\", source: \"Tozol Huatotl\" }\r\n2188.5 \"Ixali Aero III (aoe)\" Ability { id: \"19D5\", source: \"Tozol Huatotl\" }\r\n2191.7 \"Ixali Aero (buster)\" Ability { id: \"19D3\", source: \"Tozol Huatotl\" }\r\n\r\n2202.5 \"Summon Garuda\" Ability { id: \"19D7\", source: \"Tozol Huatotl\" } jump 2063.1\r\n2212.1 \"Bill\"\r\n2212.3 \"Eye Of The Storm\"\r\n2214.2 \"Mistral Song\"\r\n2217.9 \"Ixali Aero II (line)\"\r\n2224.1 \"Ixali Aero (buster)\"\r\n2231.2 \"Ixali Aero III (aoe)\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/map/the_aquapolis.ts


const aquapolisOutputStrings = {
  spawn: {
    en: '${name} spawned!',
    de: '${name} erscheint!',
    fr: '${name} vient d\'apparaitre !',
    cn: '已生成 ${name}!',
    ko: '${name} 등장!'
  }
};
const the_aquapolis_triggerSet = {
  id: 'TheAquapolis',
  zoneId: zone_id/* default.TheAquapolis */.Z.TheAquapolis,
  triggers: [
  // ---------------- random treasure mobs ----------------
  {
    id: 'Aquapolis Goblin Treasure Hunter Spawn',
    // 5058 = Goblin Treasure Hunter
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '5058'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: aquapolisOutputStrings.spawn
    }
  }, {
    id: 'Aquapolis Arges Spawn',
    // 5059 = Arges
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '5059'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: aquapolisOutputStrings.spawn
    }
  }, {
    id: 'Aquapolis Arges 100-tonze Swipe',
    type: 'StartsUsing',
    netRegex: {
      id: '1966',
      source: 'Arges',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Aquapolis Arges 100-tonze Swing',
    type: 'StartsUsing',
    netRegex: {
      id: '1967',
      source: 'Arges',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  },
  // ---------------- cage mobs ----------------
  {
    id: 'Aquapolis Polis Pot Mysterious Light',
    type: 'StartsUsing',
    netRegex: {
      id: '16C8',
      source: 'Polis Pot',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'Aquapolis Polis Hornet Final Sting',
    type: 'StartsUsing',
    netRegex: {
      id: '9B2',
      source: 'Polis Hornet'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }]
};
/* harmony default export */ const the_aquapolis = (the_aquapolis_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/pvp/shatter.ts

const bNpcNameIdToLocation = {
  '12D6': 'center',
  // Icebound Tomelith A1
  '12D7': 'southwest',
  // Icebound Tomelith A2
  '12D8': 'southeast',
  // Icebound Tomelith A3
  '12D9': 'north' // Icebound Tomelith A4
};

const bNpcNameIds = Object.keys(bNpcNameIdToLocation);

// Frontlines: Shatter
const shatter_triggerSet = {
  id: 'TheFieldsOfGloryShatter',
  zoneId: zone_id/* default.TheFieldsOfGloryShatter */.Z.TheFieldsOfGloryShatter,
  triggers: [
  // https://xivapi.com/LogMessage/2652
  // en: <Clickable(<SheetEn(BNpcName,2,IntegerParameter(1),1,1)/>)/> activates and begins to emit heat.
  {
    id: 'Shatter Big Ice',
    type: 'SystemLogMessage',
    netRegex: {
      id: 'A5C',
      param1: bNpcNameIds
    },
    alertText: (_data, matches, output) => {
      const location = bNpcNameIdToLocation[matches.param1];
      if (location !== undefined) return output[location]();
    },
    outputStrings: {
      center: {
        en: 'Big Ice: Center',
        de: 'Grosses Eis: Mitte',
        fr: 'Grosse Glace : Centre',
        ja: '氷: 中央',
        cn: '大冰: 中央',
        ko: '큰 얼음: 중앙'
      },
      north: {
        en: 'Big Ice: North',
        de: 'Grosses Eis: Norden',
        fr: 'Grosse Glace : Nord',
        ja: '氷: 北',
        cn: '大冰: 北方',
        ko: '큰 얼음: 북쪽'
      },
      southeast: {
        en: 'Big Ice: Southeast',
        de: 'Grosses Eis: Süden',
        fr: 'Grosse Glace : Sud-Est',
        ja: '氷: 南東',
        cn: '大冰: 东南',
        ko: '큰 얼음: 남동쪽'
      },
      southwest: {
        en: 'Big Ice: Southwest',
        de: 'Grosses Eis: Südwesten',
        fr: 'Grosse Glace : Sud-Ouest',
        ja: '氷: 西南',
        cn: '大冰: 西南',
        ko: '큰 얼음: 남서쪽'
      }
    }
  }]
};
/* harmony default export */ const shatter = (shatter_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a10n.ts



const a10n_triggerSet = {
  id: 'AlexanderTheBreathOfTheCreator',
  zoneId: zone_id/* default.AlexanderTheBreathOfTheCreator */.Z.AlexanderTheBreathOfTheCreator,
  timelineFile: 'a10n.txt',
  timelineTriggers: [{
    id: 'A10N Goblin Rush',
    regex: /Goblin Rush/,
    beforeSeconds: 5,
    suppressSeconds: 5,
    // Ensure syncs don't multi-call
    response: responses/* Responses.miniBuster */.n3.miniBuster()
  }, {
    id: 'A10N Gobsway Rumblerocks',
    regex: /Gobsway Rumblerocks/,
    beforeSeconds: 4,
    suppressSeconds: 4,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'A10N Laceration',
    regex: /Laceration/,
    beforeSeconds: 5,
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid side saws',
        de: 'Weiche den Sägen an der Seite aus',
        fr: 'Évitez les scies sur le côté',
        cn: '躲避场边电锯',
        ko: '옆쪽의 톱 피하기'
      }
    }
  }],
  triggers: [
  // There doesn't seem to be any indication in the logs if a player activates a trap.
  {
    id: 'A10N Frost Laser Trap',
    type: 'Ability',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1AB1',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Frost Lasers',
        de: 'Eislaser',
        fr: 'Lasers de glace',
        ja: '罠: 氷',
        cn: '冰晶陷阱',
        ko: '얼음화살 함정'
      }
    }
  }, {
    id: 'A10N Ceiling Weight Trap',
    type: 'Ability',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1AB0',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Ceiling Weight',
        de: 'Gewichte von der Decke',
        fr: 'Poids du plafond',
        ja: '罠: 鉄球',
        cn: '铁球陷阱',
        ko: '철퇴 함정'
      }
    }
  }, {
    id: 'A10N Single Charge In',
    type: 'Ability',
    netRegex: {
      id: '1AB8',
      source: 'Lamebrix Strikebocks',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'A10N Single Charge Out',
    type: 'Ability',
    netRegex: {
      id: '1AB9',
      source: 'Lamebrix Strikebocks',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'A10N Gobrush Rushgob',
    type: 'StartsUsing',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1ACF'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'A10N Critical Wrath',
    type: 'HeadMarker',
    netRegex: {
      id: '0019'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'A10N Bomb Toss',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'A10N Gobslash Slicetops',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.target();
      return output.avoid();
    },
    outputStrings: {
      target: {
        en: 'Get away--Laser on YOU',
        de: 'Geh weg--Laser auf DIR',
        fr: 'Éloignez-vous - Laser sur VOUS',
        cn: '出去--激光点名',
        ko: '멀리 - 선 대상자'
      },
      avoid: {
        en: 'Avoid Prey Laser',
        de: 'Weiche dem Markierungs-Laser aus',
        fr: 'Évitez le laser',
        cn: '躲避追踪激光',
        ko: '선 피하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Gobspin Whooshdrops/Gobswipe Conklops': 'Single Charge #1',
      'Gobswipe Conklops/Gobspin Whooshdrops': 'Single Charge #2'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Blizzard Arrow': 'Eisregner',
      'Buzzsaw': 'Rotorsäge',
      'Goblin of Fortune': 'Helfenhand',
      'Gobpress R-VI': 'Gob-Roller VI',
      'Lamebrix Strikebocks': 'Wüterix (?:der|die|das) Söldner',
      'The Excruciationator': 'Multi-Martyrium',
      'Weight of the World': 'Schwere der Erde'
    },
    'replaceText': {
      'Bomb Toss': 'Bombenwurf',
      'Critical Wrath': 'Todsicherer Treffer',
      'Frostbite': 'Abfrieren',
      'Gobbieboom': 'Gobbombe',
      'Goblin Rush': 'Goblin-Rausch',
      'Gobrush Rushgob': 'Indigoblin-Rausch',
      'Gobslash Slicetops': 'Indigo-Vakuumhieb',
      'Gobspin Whooshdrops': 'Nichtgroße Gobwirbel',
      'Gobsway Rumblerocks': 'Riesengroße Schüttern',
      'Gobswipe Conklops': 'Unbremste Wirrschlagen',
      'Illuminati Hand Cannon': 'Indigohandkanone',
      'Impact': 'Impakt',
      'Laceration': 'Zerreißen',
      'Single Charge': 'Einzelaufladung',
      'Steam Roller': 'Dampfwalze',
      'Trap': 'Falle'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Blizzard Arrow': 'flèche de glace',
      'Buzzsaw': 'scie mécanique',
      'Goblin of Fortune': 'gobsoldat de fortune',
      'Gobpress R-VI': 'gobrouleau compresseur G-VI',
      'Lamebrix Strikebocks': 'Lamebrix le Mercenaire',
      'The Excruciationator': 'Plate-forme de torture polyvalente',
      'Weight of the World': 'Poids du monde'
    },
    'replaceText': {
      'Bomb Toss': 'Lancer de bombe',
      'Critical Wrath': 'Décision fatale',
      'Frostbite': 'Gelure',
      'Gobbieboom': 'Bombe gobeline',
      'Goblin Rush': 'Charge gobeline',
      'Gobrush Rushgob': 'Gobcharge gobeline',
      'Gobslash Slicetops': 'Gobtranchant du vide',
      'Gobspin Whooshdrops': 'Gobtoupie coupante',
      'Gobsway Rumblerocks': 'Gobbouleversement',
      'Gobswipe Conklops': 'Gobhachage sauvage',
      'Illuminati Hand Cannon': 'Main-canon indigo',
      'Impact': 'Impact',
      'Laceration': 'Lacération',
      'Single Charge': 'Rechargement simple',
      'Steam Roller': 'Compression',
      'Trap': 'Gobactivation de piège'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Blizzard Arrow': 'ブリザードアロー',
      'Buzzsaw': '回転ノコギリ',
      'Goblin of Fortune': 'マーシナリー・ソルジャー',
      'Gobpress R-VI': 'VI号ゴブリローラー',
      'Lamebrix Strikebocks': '傭兵のレイムプリクス',
      'The Excruciationator': '科学的万能処刑場',
      'Weight of the World': '大陸の重み'
    },
    'replaceText': {
      'Bomb Toss': '爆弾投げ',
      'Critical Wrath': '必中の決意',
      'Frostbite': 'フロストバイト',
      'Gobbieboom': 'ゴブ爆発',
      'Goblin Rush': 'ゴブリンラッシュ',
      'Gobrush Rushgob': 'ゴブ流ゴブリンラッシュ',
      'Gobslash Slicetops': 'ゴブ流真空斬り',
      'Gobspin Whooshdrops': 'ゴブ流回転斬り',
      'Gobsway Rumblerocks': 'ゴブ流大激震',
      'Gobswipe Conklops': 'ゴブ流乱れ斬り',
      'Illuminati Hand Cannon': 'イルミナティ・ハンドカノン',
      'Impact': 'インパクト',
      'Laceration': '斬撃',
      'Single Charge': '単発充填',
      'Steam Roller': 'ローラープレス',
      'Trap': '罠起動'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Blizzard Arrow': '冰箭发射器',
      'Buzzsaw': '旋转链锯',
      'Goblin of Fortune': '佣兵战士',
      'Gobpress R-VI': '6号哥布林压路机',
      'Lamebrix Strikebocks': '佣兵雷姆普里克斯',
      'The Excruciationator': '科学万能处刑场',
      'Weight of the World': '大陆之重'
    },
    'replaceText': {
      'Bomb Toss': '投弹',
      'Critical Wrath': '必中决心',
      'Frostbite': '寒冰箭',
      'Gobbieboom': '哥布爆炸',
      'Goblin Rush': '哥布林冲锋',
      'Gobrush Rushgob': '哥布流哥布林冲锋',
      'Gobslash Slicetops': '哥布流真空斩',
      'Gobspin Whooshdrops': '哥布流回旋斩',
      'Gobsway Rumblerocks': '哥布流大怒震',
      'Gobswipe Conklops': '哥布流乱斩',
      'Illuminati Hand Cannon': '青蓝手炮',
      'Impact': '冲击',
      'Laceration': '斩击',
      'Single Charge': '单发填充',
      'Steam Roller': '蒸汽滚轮',
      'Trap': '启动陷阱'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Blizzard Arrow': '얼음 화살',
      'Buzzsaw': '회전톱',
      'Goblin of Fortune': '용병 전사',
      'Gobpress R-VI': 'VI호 고블린롤러',
      'Lamebrix Strikebocks': '용병 레임브릭스',
      'The Excruciationator': '과학적 만능처형장',
      'Weight of the World': '대륙의 무게'
    },
    'replaceText': {
      'Bomb Toss': '폭탄 던지기',
      'Critical Wrath': '일격필중',
      'Frostbite': '동상',
      'Gobbieboom': '고블린 폭발',
      'Goblin Rush': '고블린 돌진',
      'Gobrush Rushgob': '고브류 고블린 돌진',
      'Gobslash Slicetops': '고브류 진공베기',
      'Gobspin Whooshdrops': '고브류 회전베기',
      'Gobsway Rumblerocks': '고브류 대격진',
      'Gobswipe Conklops': '고브류 연속베기',
      'Illuminati Hand Cannon': '푸른손 화포',
      'Impact': '임팩트',
      'Laceration': '참격',
      'Single Charge': '단발 충전',
      'Steam Roller': '롤러 프레스',
      'Trap': '함정 기동'
    }
  }]
};
/* harmony default export */ const a10n = (a10n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a10n.txt
const raid_a10n_namespaceObject = "### A10N\r\n# Alexander - The Breath of the Creator\r\n\r\n# -ii 1DCD 1AC9 1AB4\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# The Excruciationator will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"736\" } window 0,1\r\n7.0 \"Goblin Rush\" Ability { id: \"1A17\", source: \"Lamebrix Strikebocks\" } window 7,3\r\n10.1 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n15.2 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n22.2 \"Illuminati Hand Cannon\" Ability { id: \"1AD2\", source: \"Lamebrix Strikebocks\" }\r\n34.4 \"Gobslash Slicetops\" Ability { id: \"1AD1\", source: \"Lamebrix Strikebocks\" }\r\n37.5 \"Goblin Rush\" Ability { id: \"1A17\", source: \"Lamebrix Strikebocks\" }\r\n45.6 \"Gobrush Rushgob\" Ability { id: \"1ACF\", source: \"Lamebrix Strikebocks\" }\r\n49.7 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n56.7 \"Trap\" Ability { id: [\"1AB0\", \"1AB1\"], source: \"Lamebrix Strikebocks\" } window 56.7,5\r\n58.0 \"--sync--\" Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" }\r\n61.1 \"Goblin Rush\" Ability { id: \"1A17\", source: \"Lamebrix Strikebocks\" }\r\n61.7 \"Frostbite/Impact\" Ability { id: [\"1AC7\", \"1AC6\"], source: [\"Blizzard Arrow\", \"Weight of the World\"] }\r\n69.0 \"Trap\" Ability { id: [\"1AB0\", \"1AB1\"], source: \"Lamebrix Strikebocks\" }\r\n70.3 \"--sync--\" Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" }\r\n74.0 \"Impact/Frostbite\" Ability { id: [\"1AC7\", \"1AC6\"], source: [\"Blizzard Arrow\", \"Weight of the World\"] }\r\n74.9 \"Illuminati Hand Cannon\" Ability { id: \"1AD2\", source: \"Lamebrix Strikebocks\" }\r\n78.0 \"Goblin Rush\" Ability { id: \"1A17\", source: \"Lamebrix Strikebocks\" }\r\n87.1 \"Gobslash Slicetops\" Ability { id: \"1AD1\", source: \"Lamebrix Strikebocks\" }\r\n90.2 \"Goblin Rush\" Ability { id: \"1A17\", source: \"Lamebrix Strikebocks\" }\r\n98.3 \"Gobrush Rushgob\" Ability { id: \"1ACF\", source: \"Lamebrix Strikebocks\" }\r\n102.4 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n\r\n105.4 \"--untargetable--\"\r\n105.4 \"--sync--\" Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" } window 20,20\r\n110.7 \"--targetable--\"\r\n\r\n111.1 \"--sync--\" StartsUsing { id: \"1AC9\", source: \"Gobpress R-VI\" } window 112,10\r\n112.8 \"--sync--\" Ability { id: \"1A9C\", source: \"Lamebrix Strikebocks\" }\r\n117.8 \"Critical Wrath\" Ability { id: \"1ACD\", source: \"Lamebrix Strikebocks\" }\r\n122.9 \"Illuminati Hand Cannon\" Ability { id: \"1AD2\", source: \"Lamebrix Strikebocks\" }\r\n126.2 \"Steam Roller\" Ability { id: \"1ACA\", source: \"Gobpress R-VI\" }\r\n132.2 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n136.2 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n142.3 \"Illuminati Hand Cannon\" Ability { id: \"1AD2\", source: \"Lamebrix Strikebocks\" }\r\n145.5 \"Steam Roller\" Ability { id: \"1ACA\", source: \"Gobpress R-VI\" }\r\n156.2 \"Bomb Toss\" Ability { id: \"1ACE\", source: \"Lamebrix Strikebocks\" }\r\n161.4 \"Illuminati Hand Cannon\" Ability { id: \"1AD2\", source: \"Lamebrix Strikebocks\" }\r\n165.0 \"Steam Roller\" Ability { id: \"1ACA\", source: \"Gobpress R-VI\" }\r\n170.2 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n174.3 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n180.4 \"Illuminati Hand Cannon\" Ability { id: \"1AD2\", source: \"Lamebrix Strikebocks\" }\r\n184.3 \"Steam Roller\" Ability { id: \"1ACA\", source: \"Gobpress R-VI\" }\r\n\r\n# The Gobpress gains a damage up buff here. The intermission continues and loops if unsynced.\r\n189.7 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n194.8 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n199.9 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n203.6 \"Steam Roller Enrage?\" Ability { id: \"1ACA\", source: \"Gobpress R-VI\" }\r\n\r\n# This targetable entry is the earliest we can re-sync the timeline.\r\n300.0 \"--targetable--\" NameToggle { name: \"Lamebrix Strikebocks\", toggle: \"01\" } window 190,10\r\n309.2 \"Goblin Rush\" Ability { id: \"1A17\", source: \"Lamebrix Strikebocks\" } window 200,10\r\n317.3 \"Gobrush Rushgob\" Ability { id: \"1ACF\", source: \"Lamebrix Strikebocks\" }\r\n\r\n321.4 \"--sync--\" Ability { id: [\"1AB8\", \"1AB9\"], source: \"Lamebrix Strikebocks\" }\r\n324.6 \"--sync--\" Ability { id: \"1A97\", source: \"Lamebrix Strikebocks\" }\r\n325.5 \"Gobspin Whooshdrops/Gobswipe Conklops\" Ability { id: [\"1ACB\", \"1ACC\"], source: \"Lamebrix Strikebocks\" } window 25,10\r\n331.6 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n335.6 \"Goblin Rush\" Ability { id: \"1A17\", source: \"Lamebrix Strikebocks\" }\r\n339.7 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n344.7 \"--sync--\" Ability { id: [\"1AB8\", \"1AB9\"], source: \"Lamebrix Strikebocks\" }\r\n347.9 \"--sync--\" Ability { id: \"1A97\", source: \"Lamebrix Strikebocks\" }\r\n348.8 \"Gobswipe Conklops/Gobspin Whooshdrops\" Ability { id: [\"1ACB\", \"1ACC\"], source: \"Lamebrix Strikebocks\" } window 10,10\r\n355.9 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n360.0 \"Goblin Rush\" Ability { id: \"1A17\", source: \"Lamebrix Strikebocks\" }\r\n368.1 \"Gobrush Rushgob\" Ability { id: \"1ACF\", source: \"Lamebrix Strikebocks\" }\r\n372.3 \"Goblin Rush\" Ability { id: \"1A17\", source: \"Lamebrix Strikebocks\" }\r\n377.3 \"Laceration #1\" Ability { id: \"1AC8\", source: \"Buzzsaw\" } window 30,2.5\r\n380.3 \"Laceration #2\" Ability { id: \"1AC8\", source: \"Buzzsaw\" }\r\n383.3 \"Laceration #3\" Ability { id: \"1AC8\", source: \"Buzzsaw\" }\r\n385.3 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n389.3 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n393.3 \"Goblin Rush\" Ability { id: \"1A17\", source: \"Lamebrix Strikebocks\" }\r\n398.2 \"Trap #1\" Ability { id: [\"1AB0\", \"1AB1\"], source: \"Lamebrix Strikebocks\" } window 100,2.5\r\n402.3 \"Trap #2\" Ability { id: [\"1AB0\", \"1AB1\"], source: \"Lamebrix Strikebocks\" }\r\n403.2 \"Frostbite/Impact\" Ability { id: [\"1AC7\", \"1AC6\"], source: [\"Blizzard Arrow\", \"Weight of the World\"] }\r\n403.6 \"--sync--\" Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" }\r\n407.3 \"Impact/Frostbite\" Ability { id: [\"1AC7\", \"1AC6\"], source: [\"Blizzard Arrow\", \"Weight of the World\"] }\r\n408.9 \"Illuminati Hand Cannon\" Ability { id: \"1AD2\", source: \"Lamebrix Strikebocks\" }\r\n418.1 \"Gobslash Slicetops\" Ability { id: \"1AD1\", source: \"Lamebrix Strikebocks\" }\r\n422.1 \"Goblin Rush\" Ability { id: \"1A17\", source: \"Lamebrix Strikebocks\" }\r\n430.2 \"Gobrush Rushgob\" Ability { id: \"1ACF\", source: \"Lamebrix Strikebocks\" }\r\n434.3 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n440.4 \"--sync--\" Ability { id: \"1A9C\", source: \"Lamebrix Strikebocks\" } window 30,30\r\n444.4 \"Laceration #1\" Ability { id: \"1AC8\", source: \"Buzzsaw\" }\r\n445.4 \"Critical Wrath\" Ability { id: \"1ACD\", source: \"Lamebrix Strikebocks\" }\r\n447.4 \"Laceration #2\" Ability { id: \"1AC8\", source: \"Buzzsaw\" }\r\n450.4 \"Laceration #3\" Ability { id: \"1AC8\", source: \"Buzzsaw\" }\r\n453.1 \"Bomb Toss\" Ability { id: \"1ACE\", source: \"Lamebrix Strikebocks\" }\r\n465.1 \"Gobbieboom?\" Ability { id: \"1AD3\", source: \"Goblin of Fortune\" }\r\n467.2 \"Gobrush Rushgob\" Ability { id: \"1ACF\", source: \"Lamebrix Strikebocks\" }\r\n470.3 \"Gobsway Rumblerocks\" Ability { id: \"1AD0\", source: \"Lamebrix Strikebocks\" }\r\n\r\n474.4 \"--sync--\" Ability { id: [\"1AB8\", \"1AB9\"], source: \"Lamebrix Strikebocks\" } window 30,10 jump 321.4\r\n477.6 \"Single Charge\"\r\n478.5 \"Gobspin Whooshdrops/Gobswipe Conklops\"\r\n484.6 \"Gobsway Rumblerocks\"\r\n488.6 \"Goblin Rush\"\r\n492.7 \"Gobsway Rumblerocks\"\r\n500.9 \"Single Charge\"\r\n501.8 \"Gobswipe Conklops/Gobspin Whooshdrops\"\r\n508.9 \"Gobsway Rumblerocks\"\r\n513.0 \"Goblin Rush\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a10s.ts




// Notes:
// Ignoring Gobsway Rumblerocks (1AA0) aoe trigger, as it is small and frequent.
const chargeOutputStrings = {
  getIn: outputs/* default.in */.Z["in"],
  getOut: {
    en: 'Out',
    de: 'Raus',
    fr: 'Exterieur',
    ja: '外へ',
    cn: '远离',
    ko: '밖으로'
  },
  spread: outputs/* default.spread */.Z.spread,
  stackMarker: outputs/* default.stackMarker */.Z.stackMarker,
  unknown: outputs/* default.unknown */.Z.unknown
};
const a10s_triggerSet = {
  id: 'AlexanderTheBreathOfTheCreatorSavage',
  zoneId: zone_id/* default.AlexanderTheBreathOfTheCreatorSavage */.Z.AlexanderTheBreathOfTheCreatorSavage,
  timelineFile: 'a10s.txt',
  initData: () => {
    return {
      charges: []
    };
  },
  timelineTriggers: [{
    id: 'A10S Goblin Rush',
    regex: /Goblin Rush/,
    beforeSeconds: 5,
    suppressSeconds: 1,
    response: responses/* Responses.miniBuster */.n3.miniBuster()
  }, {
    id: 'A10S Gobbie Adds',
    regex: /Gobbie Adds/,
    beforeSeconds: 0,
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hit Adds With Weight Trap',
        de: 'Adds mit Gewichtsfalle treffen',
        fr: 'Frappez les Adds avec le Piège à poids',
        ja: '鉄球ギミックを使って雑魚を倒す',
        cn: '使用铁锤陷阱击中小怪',
        ko: '철퇴 함정으로 쫄 맞추기'
      }
    }
  }],
  triggers: [{
    id: 'A10S Floor Spike Trap',
    type: 'Ability',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1AB2',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Floor Spikes',
        de: 'Boden-Stachel',
        fr: 'Pics au sol',
        ja: '罠: 棘',
        cn: '地刺陷阱',
        ko: '가시 함정'
      }
    }
  }, {
    id: 'A10S Frost Laser Trap',
    type: 'Ability',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1AB1',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Frost Lasers',
        de: 'Eislaser',
        fr: 'Lasers de glace',
        ja: '罠: 氷',
        cn: '冰晶陷阱',
        ko: '얼음화살 함정'
      }
    }
  }, {
    id: 'A10S Ceiling Weight Trap',
    type: 'Ability',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1AB0',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Ceiling Weight',
        de: 'Gewichte von der Decke',
        fr: 'Poids du plafond',
        ja: '罠: 鉄球',
        cn: '铁球陷阱',
        ko: '철퇴 함정'
      }
    }
  }, {
    id: 'A10S Charge Marker',
    type: 'Ability',
    // This also handles the "single charge" call.
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1AB[89AB]'
    },
    preRun: (data, matches) => {
      const chargeMap = {
        '1AB8': 'getIn',
        '1AB9': 'getOut',
        '1ABA': 'spread',
        '1ABB': 'stackMarker'
      };
      data.charges.push(chargeMap[matches.id] ?? 'unknown');
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = chargeOutputStrings;

      // Call the first one out with alert, the other two with info.
      const severity = data.charges.length > 1 ? 'infoText' : 'alertText';
      const charge = data.charges[data.charges.length - 1] ?? 'unknown';
      return {
        [severity]: output[charge]()
      };
    }
  }, {
    id: 'A10S Charge 1',
    type: 'Ability',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1A9[789]',
      capture: false
    },
    run: data => data.charges.shift()
  }, {
    id: 'A10S Charge Double Triple',
    type: 'Ability',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1A9[ABCE]',
      capture: false
    },
    suppressSeconds: 0.5,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = chargeOutputStrings;
      if (data.charges.length === 0) return;
      const charge = data.charges.shift();
      if (charge !== undefined) return {
        alertText: output[charge]()
      };
    }
  }, {
    id: 'A10S Charge Clear',
    type: 'Ability',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1A9[789]',
      capture: false
    },
    delaySeconds: 10,
    run: data => {
      // Cleanup just in case.
      data.charges = [];
    }
  }, {
    id: 'A10S Gobrush Rushgob',
    type: 'StartsUsing',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1A9F'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'A10S Slicetops Tether',
    type: 'Tether',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '0039'
    },
    alarmText: (data, matches, output) => {
      if (data.me !== matches.target) return;
      return output.tankSwapGetAway();
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return;
      if (data.role === 'tank') return output.tankSwap();
      if (data.role === 'healer' || data.job === 'BLU') return output.shieldPlayer({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      tankSwap: outputs/* default.tankSwap */.Z.tankSwap,
      shieldPlayer: {
        en: 'Shield ${player}',
        de: 'Schild ${player}',
        fr: 'Bouclier ${player}',
        ja: '${player}にバリア',
        cn: '单盾${player}',
        ko: '"${player}" 보호막'
      },
      tankSwapGetAway: {
        en: 'Tank Swap, Get Away',
        de: 'Tankwechsel, geh weg',
        fr: 'Tank swap, éloignez-vous',
        ja: 'タンクスイッチ、離れる',
        cn: '换T并且远离',
        ko: '탱 교대, 멀리가기'
      }
    }
  }, {
    id: 'A10S Gobsnick Leghops',
    type: 'StartsUsing',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1AA4',
      capture: false
    },
    response: responses/* Responses.stopEverything */.n3.stopEverything()
  }, {
    id: 'A10S Brighteyes Tracker',
    type: 'Ability',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1AA9',
      capture: false
    },
    run: data => {
      // This comes out 0.1s before every '0029' prey marker.
      data.seenBrighteyes = true;
    }
  }, {
    id: 'A10S Brighteyes Cleanup',
    type: 'Ability',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1AA9',
      capture: false
    },
    delaySeconds: 20,
    suppressSeconds: 20,
    run: data => delete data.seenBrighteyes
  }, {
    id: 'A10S Brighteyes Prey Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0029'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Prey on YOU',
        de: 'Makierung auf DIR',
        fr: 'Marquage sur VOUS',
        ja: '自分に狙い目',
        cn: '火圈点名',
        ko: '징 대상자'
      }
    }
  }, {
    id: 'A10S Brighteyes Prey Marker Pass',
    type: 'HeadMarker',
    netRegex: {
      id: '0029'
    },
    condition: (data, matches) => {
      // Only need to pass on the first one.
      return data.me === matches.target && !data.seenBrighteyes;
    },
    delaySeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pass Prey',
        de: 'Makierung weitergeben',
        fr: 'Passez la marque',
        ja: '狙い目を渡す',
        cn: '传递点名',
        ko: '징 넘김'
      }
    }
  }, {
    id: 'A10S Gobslice Mooncrops',
    type: 'StartsUsing',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1A92',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hit Floor Trap',
        de: 'Aktiviere Bodenfalle',
        fr: 'Activez le Piège au sol',
        ja: '棘を踏む',
        cn: '踩地刺陷阱',
        ko: '가시함정 밟기'
      }
    }
  }, {
    id: 'A10S Gobslice Mooncrops Cast',
    type: 'StartsUsing',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1A8F',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut('info')
  }, {
    id: 'A10S Gobspin Zoomdrops',
    type: 'Ability',
    netRegex: {
      source: 'Lamebrix Strikebocks',
      id: '1A8F',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hit Boss With Ice',
        de: 'Boss mit Eis treffen',
        fr: 'Frappez le boss avec la Glace',
        ja: '氷を踏む',
        cn: '踩冰晶陷阱',
        ko: '보스에게 얼음함정 맞히기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Buzzsaw': 'Rotorsäge',
      'Gobpress R-VI': 'Gob-Roller VI',
      'Lamebrix Strikebocks': 'Wüterix (?:der|die|das) Söldner',
      'Lameprix Strikedocks': 'Wüterix (?:der|die|das) Trickser',
      'The Excruciationator': 'Multi-Martyrium',
      'Weight Of The World': 'Schwere der Erde'
    },
    'replaceText': {
      '(?!--)mechanic': 'Mechanik',
      '--in/out--': '--Rein/Raus--',
      '--out/in--': '--Raus/Rein--',
      '--spread/stack--': '--Verteilen/Sammeln--',
      '--stack/spread--': '--Sammeln/Verteilen--',
      '\\(Stack/Spread\\)': '(Sammeln/Verteilen)',
      'Brighteyes(?! Markers)': 'Zielheften Auge',
      'Brighteyes Markers': 'Zielheften Auge Markierungen',
      'Clone Add': 'Klon Add',
      'Discharge': 'Abfeuern',
      'Double Charge': 'Doppelaufladung',
      'Floor Trap': 'Boden-Falle',
      'Frost Trap': 'Eisstrahl-Falle',
      'Frostbite': 'Abfrieren',
      'Gobbie Adds': 'Gobbie Adds',
      'Goblin Rush': 'Goblin-Rausch',
      'Gobrush Rushgob': 'Indigoblin-Rausch ',
      'Gobslash Slicetops': 'Indigo-Vakuumhieb',
      'Gobslice Mooncrops': 'Schlitzensichel',
      'Gobsnick Leghops': 'Gob am Berg',
      'Gobspin Zoomdrops': 'Große Gobwirbel',
      'Gobsway Rumblerocks': 'Riesengroße Schüttern',
      'Gobswish Spraymops': 'Fährliche Fächer',
      'Illuminati Hand Cannon': 'Indigohandkanone',
      'Impact': 'Impakt',
      'Laceration': 'Zerreißen',
      'Single Charge': 'Einzelaufladung',
      'Steam Roller': 'Dampfwalze',
      'Stoneskin': 'Steinhaut',
      'Triple Charge': 'Dreifachaufladung',
      'Weight Trap': 'Gewichts-Falle',
      'Leghops\\?/Charge': 'Gob am Berg?/Aufladung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Buzzsaw': 'Scie mécanique',
      'Gobpress R-VI': 'Gobrouleau compresseur G-VI',
      'Lamebrix Strikebocks': 'Lamebrix le Mercenaire',
      'Lameprix Strikedocks': 'Lamebrix le Diversif',
      'The Excruciationator': 'la plate-forme de torture polyvalente',
      'Weight Of The World': 'Poids du monde'
    },
    'replaceText': {
      '(?!--)mechanic': 'Mécanique',
      '--in/out--': '--intérieur/extérieur--',
      '--out/in--': '--extérieur/intérieur--',
      '--spread/stack--': '--dispersion/package--',
      '--stack/spread--': '--package/dispersion--',
      '\\(Stack/Spread\\)': '(Package/Dispersion)',
      'Brighteyes Markers': 'Marquage Œil vif',
      'Brighteyes(?! Markers)': 'Œil vif',
      'Clone Add': 'Add Clone',
      'Discharge': 'Mitraillage',
      'Double Charge': 'Rechargement double',
      'Floor Trap': 'Piège au sol',
      'Frost Trap': 'Piège de glace',
      'Frostbite': 'Gelure',
      'Gobbie Adds x3': 'Adds x3 Gob',
      'Goblin Rush': 'Charge gobeline',
      'Gobrush Rushgob': 'Gobcharge gobeline',
      'Gobslash Slicetops': 'Gobtranchant du vide',
      'Gobslice Mooncrops': 'Gobcroissant lacérant',
      'Gobsnick Leghops': 'Gobfeinte mortelle',
      'Gobspin Zoomdrops': 'Gobtoupie mégatranchante',
      'Gobsway Rumblerocks': 'Gobbouleversement',
      'Gobswish Spraymops': 'Gobdécoupage brutal',
      'Illuminati Hand Cannon': 'Main-canon indigo',
      'Impact': 'Impact',
      'Laceration': 'Lacération',
      'Leghops\\?/Charge': 'Mortelle ?/Charge',
      'Single Charge': 'Rechargement simple',
      'Steam Roller': 'Compression',
      'Stoneskin': 'Cuirasse',
      'Triple Charge': 'Rechargement triple',
      'Weight Trap': 'Piège à poids'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Buzzsaw': '回転ノコギリ',
      'Gobpress R-VI': 'VI号ゴブリローラー',
      'Lamebrix Strikebocks': '傭兵のレイムプリクス',
      'Lameprix Strikedocks': '偽兵のレイムプリクス',
      'The Excruciationator': '科学的万能処刑場',
      'Weight Of The World': '大陸の重み'
    },
    'replaceText': {
      '(?!--)mechanic': 'ギミック',
      '--in/out--': '--中/外--',
      '--out/in--': '--外/中--',
      '--spread/stack--': '--散開/集合--',
      '--stack/spread--': '--集合/散開--',
      '\\(Stack/Spread\\)': '(集合/散開)',
      '\\)\\?': ') ?',
      'Brighteyes Markers': '狙い目マーキング',
      'Brighteyes(?! Markers)': '狙い目',
      'Clone Add': '雑魚: ミラージュ',
      'Discharge': '銃撃',
      'Double Charge': '二連充填',
      'Floor Trap': '罠ギミック',
      'Frost Trap': '罠: 氷',
      'Frostbite': 'フロストバイト',
      'Gobbie Adds x3': '雑魚: 3 ゴブ',
      'Goblin Rush': 'ゴブリンラッシュ',
      'Gobrush Rushgob': 'ゴブ流ゴブリンラッシュ',
      'Gobslash Slicetops': 'ゴブ流真空斬り',
      'Gobslice Mooncrops': 'ゴブ流三日月斬り',
      'Gobsnick Leghops': 'ゴブ流後の先',
      'Gobspin Zoomdrops': 'ゴブ流大回転斬り',
      'Gobsway Rumblerocks': 'ゴブ流大激震',
      'Gobswish Spraymops': 'ゴブ流飛水断ち',
      'Illuminati Hand Cannon': 'イルミナティ・ハンドカノン',
      'Impact': '衝撃',
      'Laceration': '斬撃',
      'Leghops\\?/Charge': 'ゴブ流後の先?/充填',
      'Single Charge': '単発充填',
      'Steam Roller': 'ローラープレス',
      'Stoneskin': 'ストンスキン',
      'Triple Charge': '三連充填',
      'Weight Trap': '罠: 鉄球'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Buzzsaw': '旋转链锯',
      'Gobpress R-VI': '6号哥布林压路机',
      'Lamebrix Strikebocks': '佣兵雷姆普里克斯',
      'Lameprix Strikedocks': '虚兵雷姆普里克斯',
      'The Excruciationator': '科学万能处刑场',
      'Weight Of The World': '大陆之重'
    },
    'replaceText': {
      '(?!--)mechanic': '机制',
      '--in/out--': '--内/外--',
      '--out/in--': '--外/内--',
      '--spread/stack--': '--分散/集合--',
      '--stack/spread--': '--集合/分散--',
      '\\)\\?': ') ?',
      'Brighteyes': '目标',
      'Clone Add': '分身出现',
      'Discharge': '枪击',
      'Double Charge': '二连填充',
      'Floor Trap': '地刺陷阱',
      'Frost Trap': '冰晶陷阱',
      'Frostbite': '寒冰箭',
      'Gobbie Adds': '哥布林出现',
      'Goblin Rush': '哥布林冲锋',
      'Gobrush Rushgob': '哥布流哥布林冲锋',
      'Gobslash Slicetops': '哥布流真空斩',
      'Gobslice Mooncrops': '哥布流月牙斩',
      'Gobsnick Leghops': '哥布流后之先',
      'Gobspin Zoomdrops': '哥布流大回旋斩',
      'Gobsway Rumblerocks': '哥布流大怒震',
      'Gobswish Spraymops': '哥布流断瀑斩',
      'Illuminati Hand Cannon': '青蓝手炮',
      'Impact': '锤击',
      'Laceration': '斩击',
      'Single Charge': '单发填充',
      'Steam Roller': '蒸汽滚轮',
      'Stoneskin': '石肤',
      'Triple Charge': '三连填充',
      'Weight Trap': '铁球陷阱',
      'Leghops\\?/Charge': '哥布流后之先?/冲锋'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Buzzsaw': '회전톱',
      'Gobpress R-VI': 'VI호 고블린롤러',
      'Lamebrix Strikebocks': '용병 레임브릭스',
      'Lameprix Strikedocks': '가짜 용병 레임프릭스',
      'The Excruciationator': '과학적 만능처형장',
      'Weight Of The World': '쇠구슬'
    },
    'replaceText': {
      '(?!--)mechanic': '기믹',
      '--in/out--': '--안/밖--',
      '--out/in--': '--밖/안--',
      '--spread/stack--': '--산개/쉐어--',
      '--stack/spread--': '--쉐어/산개--',
      'Brighteyes': '표적',
      'Clone Add': '분신 등장',
      'Discharge': '총격',
      'Double Charge': '2연속 충전',
      'Floor Trap': '가시 함정',
      'Frost Trap': '얼음화살 함정',
      'Frostbite': '동상',
      'Gobbie Adds': '고블린 등장',
      'Goblin Rush': '고블린 돌진',
      'Gobrush Rushgob': '고브류 고블린 돌진',
      'Gobslash Slicetops': '고브류 진공베기',
      'Gobslice Mooncrops': '고브류 초승달베기',
      'Gobsnick Leghops': '고브류 되받아치기',
      'Gobspin Zoomdrops': '고브류 대회전베기',
      'Gobsway Rumblerocks': '고브류 대격진',
      'Gobswish Spraymops': '고브류 물보라베기',
      'Illuminati Hand Cannon': '푸른손 화포',
      'Impact': '충격',
      'Laceration': '참격',
      'Single Charge': '단발 충전',
      'Steam Roller': '롤러 프레스',
      'Stoneskin': '스톤스킨',
      'Triple Charge': '3연속 충전',
      'Weight Trap': '철퇴 함정',
      'Leghops\\?/Charge': '되받아치기?/충전'
    }
  }]
};
/* harmony default export */ const a10s = (a10s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a10s.txt
const raid_a10s_namespaceObject = "### A10S\r\n# Alexander - The Breath of the Creator (Savage)\r\n# https://dtguilds.enjin.com/a10sguide\r\n# -p 1A16:6.5 1AB2:30.3 1AB1:73.6 1AB0:126.6 1AA9:207 1A99:528.5 1A92:735.3\r\n# -ii 1A9D 1A8D 1AA5 1DCC 1A8C 1AB3 1A96 1A93 1A90\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n6.5 \"Goblin Rush\" Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" } window 7,2.5\r\n9.6 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n14.7 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n18.8 \"--sync--\" Ability { id: \"1AB[AB]\", source: \"Lamebrix Strikebocks\" }\r\n22.1 \"Single Charge\" Ability { id: \"1A97\", source: \"Lamebrix Strikebocks\" }\r\n22.9 \"--spread/stack--\" Ability { id: \"1A9[CE]\", source: \"Lamebrix Strikebocks\" }\r\n\r\n# trap 1: hp ??%\r\n30.3 \"Floor Trap\" Ability { id: \"1AB2\", source: \"Lamebrix Strikebocks\" } window 31,5\r\n31.6 \"--jump--\" Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" }\r\n35.7 \"--sync--\" Ability { id: \"1AB[AB]\", source: \"Lamebrix Strikebocks\" }\r\n39.0 \"Single Charge (Stack/Spread)\" Ability { id: \"1A97\", source: \"Lamebrix Strikebocks\" }\r\n39.8 \"--stack/spread--\" Ability { id: \"1A9[CE]\", source: \"Lamebrix Strikebocks\" }\r\n50.0 \"Gobslash Slicetops\" Ability { id: \"1AA1\", source: \"Lamebrix Strikebocks\" }\r\n53.1 \"Goblin Rush\" Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" }\r\n61.2 \"Gobrush Rushgob\" Ability { id: \"1A9F\", source: \"Lamebrix Strikebocks\" }\r\n64.4 \"--sync--\" Ability { id: \"1AA6\", source: \"Lamebrix Strikebocks\" } # discharge puddles appear\r\n67.6 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n\r\n# trap 2: hp 85%\r\n73.6 \"Frost Trap\" Ability { id: \"1AB1\", source: \"Lamebrix Strikebocks\" } window 75,5\r\n74.9 \"--jump--\" Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" }\r\n76.5 \"Discharge\" Ability { id: \"1AA7\", source: \"Lamebrix Strikebocks\" }\r\n78.5 \"Frostbite\" Ability { id: \"1A8E\", source: \"Lamebrix Strikebocks\" }\r\n88.0 \"Gobsnick Leghops\" Ability { id: \"1AA4\", source: \"Lamebrix Strikebocks\" }\r\n90.2 \"Clone Add\"\r\n90.2 \"--jump--\" Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" }\r\n92.5 \"--sync--\" Ability { id: \"1AB8\", source: \"Lamebrix Strikebocks\" }\r\n95.8 \"Single Charge\" Ability { id: \"1A97\", source: \"Lamebrix Strikebocks\" }\r\n96.6 \"--in--\" Ability { id: \"1A9A\", source: \"Lamebrix Strikebocks\" }\r\n103.7 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n105.3 \"Gobswish Spraymops\" Ability { id: \"1AA3\", source: \"Lameprix Strikedocks\" }\r\n113.9 \"Gobrush Rushgob\" Ability { id: \"1A9F\", source: \"Lamebrix Strikebocks\" }\r\n118.5 \"Goblin Rush\" Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" }\r\n119.5 \"Gobswish Spraymops\" Ability { id: \"1AA3\", source: \"Lameprix Strikedocks\" }\r\n120.7 \"--sync--\" Ability { id: \"1AA6\", source: \"Lamebrix Strikebocks\" } # discharge puddles appear\r\n\r\n# trap 3: hp ??%\r\n126.6 \"Weight Trap\" Ability { id: \"1AB0\", source: \"Lamebrix Strikebocks\" } window 127,5\r\n128.0 \"--jump--\" Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" }\r\n131.6 \"Impact\" Ability { id: \"1A8B\", source: \"Weight Of The World\" }\r\n135.7 \"Discharge\" Ability { id: \"1AA7\", source: \"Lamebrix Strikebocks\" }\r\n144.3 \"Gobslash Slicetops\" Ability { id: \"1AA1\", source: \"Lamebrix Strikebocks\" }\r\n147.4 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n151.6 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n159.7 \"--sync--\" #Ability { id: \"1AB[89]\", source: \"Lamebrix Strikebocks\" }\r\n161.7 \"--sync--\" #Ability { id: \"1AB[89]\", source: \"Lamebrix Strikebocks\" }\r\n165.0 \"Double Charge\" Ability { id: \"1A98\", source: \"Lamebrix Strikebocks\" }\r\n165.8 \"--in/out--\" Ability { id: \"1A9[AB]\", source: \"Lamebrix Strikebocks\" }\r\n168.8 \"--out/in--\" Ability { id: \"1A9[AB]\", source: \"Lamebrix Strikebocks\" }\r\n171.9 \"--jump--\" Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" }\r\n178.2 \"Leghops?/Charge (In)?\"\r\n184.0 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n187.2 \"Goblin Rush\" Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" }\r\n195.3 \"Gobrush Rushgob\" Ability { id: \"1A9F\", source: \"Lamebrix Strikebocks\" }\r\n199.5 \"Goblin Rush\" Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" }\r\n\r\n\r\n### Phase 2: Steam Roller (60%)\r\n200.5 \"--untargetable--\" NameToggle { name: \"Lamebrix Strikebocks\", toggle: \"00\" } window 201,5\r\n201.6 \"--jump--\" Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" } window 20,5\r\n207.0 \"Brighteyes Markers\" Ability { id: \"1AA9\", source: \"Lamebrix Strikebocks\" } window 210,5\r\n212.0 \"Brighteyes\" Ability { id: \"1AAA\", source: \"Lamebrix Strikebocks\" }\r\n212.1 \"Illuminati Hand Cannon\" Ability { id: \"1AA8\", source: \"Lamebrix Strikebocks\" }\r\n216.3 \"Brighteyes Markers\" Ability { id: \"1AA9\", source: \"Lamebrix Strikebocks\" }\r\n221.2 \"Steam Roller\" Ability { id: \"1A95\", source: \"Gobpress R-VI\" }\r\n221.2 \"Brighteyes\" Ability { id: \"1AAA\", source: \"Lamebrix Strikebocks\" }\r\n231.5 \"Illuminati Hand Cannon\" Ability { id: \"1AA8\", source: \"Lamebrix Strikebocks\" }\r\n234.7 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n238.9 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n240.5 \"Steam Roller\" Ability { id: \"1A95\", source: \"Gobpress R-VI\" }\r\n241.6 \"Brighteyes Markers\" Ability { id: \"1AA9\", source: \"Lamebrix Strikebocks\" }\r\n246.6 \"Brighteyes\" Ability { id: \"1AAA\", source: \"Lamebrix Strikebocks\" }\r\n246.7 \"Illuminati Hand Cannon\" Ability { id: \"1AA8\", source: \"Lamebrix Strikebocks\" }\r\n250.9 \"Brighteyes Markers\" Ability { id: \"1AA9\", source: \"Lamebrix Strikebocks\" }\r\n255.9 \"Brighteyes\" Ability { id: \"1AAA\", source: \"Lamebrix Strikebocks\" }\r\n259.8 \"Steam Roller\" Ability { id: \"1A95\", source: \"Gobpress R-VI\" }\r\n268.1 \"Illuminati Hand Cannon\" Ability { id: \"1AA8\", source: \"Lamebrix Strikebocks\" }\r\n271.3 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n275.5 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n279.1 \"Steam Roller\" Ability { id: \"1A95\", source: \"Gobpress R-VI\" }\r\n285.8 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n289.9 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n294.1 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n298.2 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n298.4 \"Steam Roller Enrage\" Ability { id: \"1A95\", source: \"Gobpress R-VI\" }\r\n302.4 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n\r\n### Phase 3\r\n500.0 \"--targetable--\" NameToggle { name: \"Lamebrix Strikebocks\", toggle: \"01\" } window 500,0\r\n509.0 \"Goblin Rush\" Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" } window 305,5\r\n517.1 \"Gobrush Rushgob\" Ability { id: \"1A9F\", source: \"Lamebrix Strikebocks\" }\r\n521.3 \"--sync--\" #Ability { id: \"1AB[89AB]\", source: \"Lamebrix Strikebocks\" }\r\n523.3 \"--sync--\" #Ability { id: \"1AB[89AB]\", source: \"Lamebrix Strikebocks\" }\r\n525.3 \"--sync--\" #Ability { id: \"1AB[89AB]\", source: \"Lamebrix Strikebocks\" }\r\n\r\n528.5 \"Triple Charge\" Ability { id: \"1A99\", source: \"Lamebrix Strikebocks\" } window 530,10\r\n529.3 \"--mechanic 1--\" Ability { id: \"1A9[ABCE]\", source: \"Lamebrix Strikebocks\" }\r\n532.4 \"--mechanic 2--\" Ability { id: \"1A9[ABCE]\", source: \"Lamebrix Strikebocks\" }\r\n536.9 \"--mechanic 3--\" Ability { id: \"1A9[ABCE]\", source: \"Lamebrix Strikebocks\" }\r\n542.0 \"Goblin Rush\" Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" }\r\n546.1 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n550.2 \"Goblin Rush\" Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" }\r\n554.3 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n559.4 \"--jump--\" Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" }\r\n561.7 \"--sync--\" Ability { id: \"1AB8\", source: \"Lamebrix Strikebocks\" }\r\n565.0 \"Single Charge\" Ability { id: \"1A97\", source: \"Lamebrix Strikebocks\" }\r\n565.8 \"--in--\" Ability { id: \"1A9A\", source: \"Lamebrix Strikebocks\" }\r\n\r\n575.0 \"Gobspin Zoomdrops\" Ability { id: \"1A8F\", source: \"Lamebrix Strikebocks\" }\r\n576.9 \"Stoneskin\"\r\n580.2 \"Gobspin Zoomdrops\" Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n586.2 \"Gobspin Zoomdrops\" Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n592.2 \"Gobspin Zoomdrops\" Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" } window 3,100\r\n594.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n596.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n598.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n600.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n602.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n604.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n606.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n608.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n610.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n612.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n614.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n616.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n618.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n620.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n622.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n624.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n626.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n628.2 \"Gobspin Zoomdrops\" #Ability { id: \"1A91\", source: \"Lamebrix Strikebocks\" }\r\n\r\n700.0 \"Frostbite\" Ability { id: \"1A8E\", source: \"Lamebrix Strikebocks\" } window 125,0\r\n712.8 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n720.9 \"Gobrush Rushgob\" Ability { id: \"1A9F\", source: \"Lamebrix Strikebocks\" }\r\n724.1 \"--jump--\" Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" }\r\n735.3 \"Gobslice Mooncrops\" Ability { id: \"1A92\", source: \"Lamebrix Strikebocks\" }\r\n739.4 \"--jump--\" Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" }\r\n745.7 \"Leghops?/Charge (In)?\"\r\n749.9 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n754.0 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n758.1 \"Goblin Rush\" Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" }\r\n762.2 \"Goblin Rush\" Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" }\r\n\r\n# Sawblade phase\r\n765.3 \"Brighteyes Markers\" Ability { id: \"1AA9\", source: \"Lamebrix Strikebocks\" }\r\n769.2 \"Laceration\" #Ability { id: \"1A94\", source: \"Buzzsaw\" }\r\n770.3 \"Brighteyes\" Ability { id: \"1AAA\", source: \"Lamebrix Strikebocks\" }\r\n770.9 \"Illuminati Hand Cannon\" Ability { id: \"1AA8\", source: \"Lamebrix Strikebocks\" }\r\n772.3 \"Laceration\" #Ability { id: \"1A94\", source: \"Buzzsaw\" }\r\n775.1 \"Brighteyes Markers\" Ability { id: \"1AA9\", source: \"Lamebrix Strikebocks\" }\r\n775.4 \"Laceration\" #Ability { id: \"1A94\", source: \"Buzzsaw\" }\r\n778.2 \"--sync--\" Ability { id: \"1AB9\", source: \"Lamebrix Strikebocks\" }\r\n778.4 \"Laceration\" #Ability { id: \"1A94\", source: \"Buzzsaw\" }\r\n780.1 \"Brighteyes\" Ability { id: \"1AAA\", source: \"Lamebrix Strikebocks\" }\r\n781.5 \"Single Charge\" Ability { id: \"1A97\", source: \"Lamebrix Strikebocks\" }\r\n782.3 \"--out--\" Ability { id: \"1A9B\", source: \"Lamebrix Strikebocks\" }\r\n786.4 \"Goblin Rush\" Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" }\r\n795.6 \"Gobslash Slicetops\" Ability { id: \"1AA1\", source: \"Lamebrix Strikebocks\" }\r\n803.7 \"Gobrush Rushgob\" Ability { id: \"1A9F\", source: \"Lamebrix Strikebocks\" }\r\n\r\n# Adds phase\r\n806.9 \"--sync--\" Ability { id: \"1AA6\", source: \"Lamebrix Strikebocks\" } # discharge puddles appear\r\n811.8 \"Frost Trap\" Ability { id: \"1AB1\", source: \"Lamebrix Strikebocks\" }\r\n814.9 \"Discharge\" Ability { id: \"1AA7\", source: \"Lamebrix Strikebocks\" }\r\n815.9 \"Weight Trap\" Ability { id: \"1AB0\", source: \"Lamebrix Strikebocks\" }\r\n816.8 \"Frostbite\" Ability { id: \"1A8E\", source: \"Lamebrix Strikebocks\" }\r\n817.2 \"--jump--\" Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" }\r\n820.8 \"Impact\" Ability { id: \"1A8B\", source: \"Weight Of The World\" }\r\n824.9 \"Discharge\" Ability { id: \"1AA7\", source: \"Lamebrix Strikebocks\" }\r\n827.1 \"Gobbie Adds x3 (NE)\"\r\n828.4 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n832.5 \"Gobsway Rumblerocks\" Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n840.7 \"Gobsnick Leghops\" Ability { id: \"1AA4\", source: \"Lamebrix Strikebocks\" }\r\n845.6 \"Laceration\" #Ability { id: \"1A94\", source: \"Buzzsaw\" }\r\n847.8 \"Goblin Rush\" Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" }\r\n848.6 \"Laceration\" #Ability { id: \"1A94\", source: \"Buzzsaw\" }\r\n851.6 \"Laceration\" #Ability { id: \"1A94\", source: \"Buzzsaw\" }\r\n855.9 \"Gobrush Rushgob\" Ability { id: \"1A9F\", source: \"Lamebrix Strikebocks\" }\r\n860.0 \"Goblin Rush\" Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" }\r\n\r\n# Loop\r\n868.1 \"--sync--\" #Ability { id: \"1AB[89AB]\", source: \"Lamebrix Strikebocks\" }\r\n870.1 \"--sync--\" #Ability { id: \"1AB[89AB]\", source: \"Lamebrix Strikebocks\" }\r\n872.1 \"--sync--\" #Ability { id: \"1AB[89AB]\", source: \"Lamebrix Strikebocks\" }\r\n875.3 \"Triple Charge\" Ability { id: \"1A99\", source: \"Lamebrix Strikebocks\" } window 300,300 jump 528.5\r\n876.1 \"--mechanic 1--\" #Ability { id: \"1A9[ABCE]\", source: \"Lamebrix Strikebocks\" }\r\n879.2 \"--mechanic 2--\" #Ability { id: \"1A9[ABCE]\", source: \"Lamebrix Strikebocks\" }\r\n883.7 \"--mechanic 3--\" #Ability { id: \"1A9[ABCE]\", source: \"Lamebrix Strikebocks\" }\r\n888.8 \"Goblin Rush\" #Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" }\r\n892.9 \"Gobsway Rumblerocks\" #Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n897.0 \"Goblin Rush\" #Ability { id: \"1A16\", source: \"Lamebrix Strikebocks\" }\r\n901.1 \"Gobsway Rumblerocks\" #Ability { id: \"1AA0\", source: \"Lamebrix Strikebocks\" }\r\n906.2 \"--jump--\" #Ability { id: \"1AA2\", source: \"Lamebrix Strikebocks\" }\r\n908.5 \"--sync--\" #Ability { id: \"1AB8\", source: \"Lamebrix Strikebocks\" }\r\n911.8 \"Single Charge\" #Ability { id: \"1A97\", source: \"Lamebrix Strikebocks\" }\r\n912.6 \"--in--\" #Ability { id: \"1A9A\", source: \"Lamebrix Strikebocks\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a11s.ts



const a11s_triggerSet = {
  id: 'AlexanderTheHeartOfTheCreatorSavage',
  zoneId: zone_id/* default.AlexanderTheHeartOfTheCreatorSavage */.Z.AlexanderTheHeartOfTheCreatorSavage,
  timelineFile: 'a11s.txt',
  timelineTriggers: [{
    id: 'A11S Blastoff',
    regex: /Blastoff/,
    beforeSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  triggers: [{
    id: 'A11S Left Laser Sword',
    type: 'StartsUsing',
    netRegex: {
      source: 'Cruise Chaser',
      id: '1A7A',
      capture: false
    },
    // Sorry tanks.
    // We could figure out who is tanking and then do the opposite,
    // but probably that could get confusing too?
    // It seems better to just be consistent here and have tanks be smarter.
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'A11S Right Laser Sword',
    type: 'StartsUsing',
    netRegex: {
      source: 'Cruise Chaser',
      id: '1A79',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'A11S Optical Sight Clock',
    type: 'StartsUsing',
    netRegex: {
      source: 'Cruise Chaser',
      id: '1A6C',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Clock',
        de: 'Uhr',
        fr: 'Sens horaire',
        ja: '照準 (時針回り)',
        cn: '九连环',
        ko: '시계방향'
      }
    }
  }, {
    id: 'A11S Optical Sight Out',
    type: 'StartsUsing',
    netRegex: {
      source: 'Cruise Chaser',
      id: '1A6D',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut('info')
  }, {
    id: 'A11S Optical Sight Bait',
    type: 'StartsUsing',
    netRegex: {
      source: 'Cruise Chaser',
      id: '1A6E',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Optical Sight',
        de: 'Köder Visier',
        fr: 'Attirez la Visée optique',
        ja: '照準AoEを誘導',
        cn: '诱导AOE',
        ko: '유도 장판'
      }
    }
  }, {
    id: 'A11S Super Hawk Blaster',
    type: 'HeadMarker',
    netRegex: {
      id: '005A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'A11S Whirlwind',
    type: 'StartsUsing',
    netRegex: {
      source: 'Cruise Chaser',
      id: '1A84',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'A11S Spin Crusher',
    type: 'StartsUsing',
    netRegex: {
      source: 'Cruise Chaser',
      id: '1A85',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront('info')
  }, {
    id: 'A11S EDD Add',
    type: 'AddedCombatant',
    netRegex: {
      name: 'E\\.D\\.D\\.',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Add',
        de: 'Add besiegen',
        fr: 'Tuez l\'Add',
        ja: 'イーディーディーを倒す',
        cn: '击杀小怪',
        ko: '쫄 없애기'
      }
    }
  }, {
    id: 'A11S Armored Pauldron Add',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Armored Pauldron',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Break Pauldron',
        de: 'Schulterplatte zerstören',
        fr: 'Brisez la Protection',
        ja: 'アーマーを破壊する',
        cn: '击破护盾',
        ko: '견갑부 부수기'
      }
    }
  }, {
    id: 'A11S GA-100',
    type: 'StartsUsing',
    // Note: 0057 headmarker, but starts using occurs 3 seconds earlier.
    netRegex: {
      source: 'Cruise Chaser',
      id: '1A77'
    },
    // TODO: maybe we need a Responses.abilityOn()
    alarmText: (data, matches, output) => {
      if (data.me !== matches.target) return;
      return output.gaOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return;
      return output.gaOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      gaOn: {
        en: 'GA-100 on ${player}',
        de: 'GA-100 on ${player}',
        fr: 'GA-100 sur ${player}',
        ja: '${player}にGA-100',
        cn: 'GA-100点${player}',
        ko: '"${player}" GA-100'
      },
      gaOnYou: {
        en: 'GA-100 on YOU',
        de: 'GA-100 auf DIR',
        fr: 'GA-100 sur VOUS',
        ja: '自分にGA-100',
        cn: 'GA-100点名',
        ko: 'GA-100 대상자'
      }
    }
  }, {
    id: 'A11S Limit Cut Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '00(?:4F|5[0-6])'
    },
    run: (data, matches) => {
      const limitCutNumberMap = {
        '004F': 1,
        '0050': 2,
        '0051': 3,
        '0052': 4,
        '0053': 5,
        '0054': 6,
        '0055': 7,
        '0056': 8
      };
      const limitCutNumber = limitCutNumberMap[matches.id];
      if (!limitCutNumber) return;
      data.limitCutMap ??= {};
      data.limitCutMap[limitCutNumber] = matches.target;
      if (matches.target === data.me) {
        data.limitCutNumber = limitCutNumber;

        // Time between headmarker and mechanic.
        const limitCutDelayMap = {
          '004F': 8.8,
          '0050': 9.3,
          '0051': 11.0,
          '0052': 11.5,
          '0053': 13.2,
          '0054': 13.7,
          '0055': 15.5,
          '0056': 16.0
        };
        data.limitCutDelay = limitCutDelayMap[matches.id];
      }
    }
  }, {
    id: 'A11S Limit Cut Number',
    type: 'HeadMarker',
    netRegex: {
      id: '00(?:4F|5[0-6])'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: data => data.limitCutDelay ?? 0,
    infoText: (data, _matches, output) => output.text({
      num: data.limitCutNumber
    }),
    outputStrings: {
      text: {
        en: '${num}',
        de: '${num}',
        fr: '${num}',
        ja: '${num}',
        cn: '${num}',
        ko: '${num}'
      }
    }
  }, {
    id: 'A11S Limit Cut Mechanic',
    type: 'HeadMarker',
    netRegex: {
      id: '00(?:4F|5[0-6])'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: data => (data.limitCutDelay ?? 0) - 5,
    alertText: (data, _matches, output) => {
      if (!data.limitCutNumber || !data.limitCutMap) return;
      if (data.limitCutNumber % 2 === 1) {
        // Odds
        return output.knockbackCleave();
      }

      // Evens
      const partner = data.limitCutMap[data.limitCutNumber - 1];
      if (partner === undefined) {
        // In case something goes awry?
        return output.knockbackCharge();
      }
      return output.facePlayer({
        player: data.party.member(partner)
      });
    },
    outputStrings: {
      knockbackCleave: {
        en: 'Knockback Cleave; Face Outside',
        de: 'Rückstoß Cleave; nach Außen schauen',
        fr: 'Poussée Cleave; Regardez vers l\'extérieur',
        ja: 'ノックバック ソード; 外を向く',
        cn: '击退顺劈; 面向外侧',
        ko: '넉백 소드; 바깥쪽 바라보기'
      },
      knockbackCharge: {
        en: 'Knockback Charge',
        de: 'Rückstoß Charge',
        fr: 'Poussée Charge',
        ja: 'ノックバック チャージ',
        cn: '击退冲锋',
        ko: '넉백 차지'
      },
      facePlayer: {
        en: 'Face ${player}',
        de: 'Schaue zu ${player}',
        fr: 'Regardez ${player}',
        ja: '${player} に向かう',
        cn: '面向${player}',
        ko: '"${player}" 바라보기'
      }
    }
  }, {
    id: 'A11S Limit Cut Cleanup',
    type: 'Ability',
    netRegex: {
      source: 'Cruise Chaser',
      id: '1A80',
      capture: false
    },
    delaySeconds: 30,
    run: data => {
      delete data.limitCutDelay;
      delete data.limitCutNumber;
      delete data.limitCutMap;
    }
  }, {
    id: 'A11S Laser X Sword',
    type: 'StartsUsing',
    netRegex: {
      source: 'Cruise Chaser',
      id: '1A7F'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.sharedTankbusterOnYou();
      if (data.role === 'tank' || data.role === 'healer' || data.job === 'BLU') return output.sharedTankbusterOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      sharedTankbusterOnYou: {
        en: 'Shared Tankbuster on YOU',
        de: 'Geteilter Tankbuster auf DIR',
        fr: 'Tank buster à partager sur VOUS',
        ja: '自分に頭割りタンクバスター',
        cn: '分摊死刑点名',
        ko: '쉐어 탱버 대상자'
      },
      sharedTankbusterOn: {
        en: 'Shared Tankbuster on ${player}',
        de: 'Geteilter Tankbuster auf ${player}',
        fr: 'Tank buster à partager sur ${player}',
        ja: '${player}に頭割りタンクバスター',
        cn: '分摊死刑点${player}',
        ko: '"${player}" 쉐어 탱버'
      }
    }
  }, {
    id: 'A11S Propeller Wind',
    type: 'StartsUsing',
    netRegex: {
      source: 'Cruise Chaser',
      id: '1A7F',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Tower',
        de: 'Hinter dem Tower verstecken',
        fr: 'Cachez-vous derrière la tour',
        ja: '塔の後ろに',
        cn: '躲在塔后',
        ko: '기둥 뒤에 숨기'
      }
    }
  }, {
    id: 'A11S Plasma Shield',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Plasma Shield',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Break Shield From Front',
        de: 'Schild von vorne zerstören',
        fr: 'Brisez le Bouclier par l\'avant',
        ja: 'シールドを正面から破壊する',
        cn: '正面击破护盾',
        ko: '정면에서 방어막 부수기'
      }
    }
  },
  // There is a GameLog message (en: The plasma shield is shattered!), but no corresponding
  // SystemLogMessage. The 0x19 (NetworkDeath) line shows up >2 seconds later (too late).
  {
    id: 'A11S Plasma Shield Shattered',
    type: 'NetworkEffectResult',
    netRegex: {
      name: 'Plasma Shield',
      currentHp: '0',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'A11S Blassty Charge',
    type: 'StartsUsing',
    // The single post-shield charge.  Not "super" blassty charge during limit cut.
    netRegex: {
      source: 'Cruise Chaser',
      id: '1A83'
    },
    alarmText: (data, matches, output) => {
      if (data.me !== matches.target) return;
      return output.chargeOnYou();
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return;
      return output.chargeOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      chargeOn: {
        en: 'Charge on ${player}',
        de: 'Ansturm auf ${player}',
        fr: 'Charge sur ${player}',
        ja: '${player}にチャージ',
        cn: '冲锋点${player}',
        ko: '"${player}" 돌진'
      },
      chargeOnYou: {
        en: 'Charge on YOU',
        de: 'Ansturm auf DIR',
        fr: 'Charge sur VOUS',
        ja: '自分にチャージ',
        cn: '冲锋点名',
        ko: '돌진 대상자'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Armored Pauldron': 'Schulterplatte',
      'Claster': 'Claster-Mecha',
      'Cruise Chaser': 'Chaser-Mecha',
      'E\\\\.D\\\\.D\\\\.': 'E\\.D\\.D\\.-Mecha',
      'Multifield': 'Schichtfeld',
      'Plasma Shield': 'Plasmaschild',
      'The Main Generators': 'Hauptantriebsraum',
      'The plasma shield is shattered': 'Die Schulterplatte ist zerstört'
    },
    'replaceText': {
      '(?<! )Sword': 'Schwert',
      '(?<!Super )Hawk Blaster': 'Jagdfalke',
      '--invincible--': '--unverwundbar--',
      '\\(bait\\)': '(ködern)',
      '\\(clock/out\\)': '(im Uhrzeigersinn/Raus)',
      '\\(everyone\\)': '(jeder)',
      '\\(numbers\\)': '(Nummern)',
      '\\(orbs\\)': '(Orbs)',
      '\\(out/clock\\)': '(Raus/im Uhrzeigersinn)',
      '\\(shield\\)': '(Schild)',
      '\\?': ' ?',
      'Assault Cannon': 'Sturmkanone',
      'Blassty Blaster': 'Blassty-Blaster',
      'Blassty Charge': 'Blassty-Ladung',
      'Blastoff': 'Absprengen',
      '(?<!Blassty )Charge': 'Sturm',
      'E\\.D\\.D\\. Add': 'E.D.D.-Mecha Add',
      'E\\.D\\.D\\. Armored Pauldron': 'E.D.D.-Mecha Schulterplatte',
      'Eternal Darkness': 'Ewiges Dunkel',
      'GA-100': 'GA-100',
      'Lapis Lazuli': 'Lapislazuli',
      'Laser X Sword': 'Laserschwert X',
      'Left/Right Laser Sword': 'Linkes/Rechtes Laserschwert',
      'Limit Cut': 'Grenzwertüberschreitung',
      'Markers': 'Markierungen',
      'Multifield': 'Schichtfeld',
      'Optical Sight': 'Visier',
      'Perfect Landing': 'Perfekte Landung',
      'Photon': 'Photon',
      'Plasma Shield': 'Plasmaschild',
      'Plasmasphere': 'Plasmasphäre',
      'Propeller Wind': 'Luftschraube',
      'Spin Crusher': 'Rotorbrecher',
      'Super Hawk Blaster': 'Super-Jagdfalke',
      'Transform': 'Diamorphose',
      'Whirlwind': 'Wirbelwind'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Armored Pauldron': 'Protection d\'épaule',
      'Claster': 'Éclateur',
      'Cruise Chaser': 'Croiseur-chasseur',
      'E\\\\.D\\\\.D\\\\.': 'E\\.D\\.D\\.',
      'Multifield': 'Champ multistrate',
      'Plasma Shield': 'Bouclier plasma',
      'The Main Generators': 'la chambre du générateur principal',
      'The plasma shield is shattered.*?': 'Le bouclier plasma se brise.*?'
    },
    'replaceText': {
      '(?<! )Sword': 'Épée',
      '(?<!Super )Hawk Blaster': 'Canon faucon',
      '--invincible--': '--invulnérable--',
      '\\(bait\\)': '(attirez)',
      '\\(clock/out\\)': '(sens horaire/extérieur)',
      '\\(everyone\\)': '(tout les joueurs)',
      '\\(numbers\\)': '(nombres)',
      '\\(orbs\\)': '(orbes)',
      '\\(out/clock\\)': '(extérieur/sens horaire)',
      '\\(shield\\)': '(bouclier)',
      '\\?': ' ?',
      'Assault Cannon': 'Canon d\'assaut',
      'Blassty Blaster': 'Canon Blassty',
      'Blassty Charge': 'Charge Blassty',
      'Blastoff': 'Lancement',
      '(?<!Blassty )Charge': 'Charge',
      'E\\.D\\.D\\. Add': 'Add E.D.D.',
      'E\\.D\\.D\\. Armored Pauldron': 'E.D.D. Protection d\'épaule',
      'Eternal Darkness': 'Ténèbres éternelles',
      'GA-100': 'GA-100',
      'Lapis Lazuli': 'Lapis-lazuli',
      'Laser X Sword': 'Épée laser X',
      'Left/Right Laser Sword': 'Épée laser gauche/droite',
      'Limit Cut': 'Dépassement de limites',
      'Markers': 'Marqueurs',
      'Multifield': 'Champ multistrate',
      'Optical Sight': 'Visée optique',
      'Perfect Landing': 'Atterissage parfait',
      'Photon': 'Photon',
      'Plasma Shield': 'Bouclier plasma',
      'Plasmasphere': 'Sphère de plasma',
      'Propeller Wind': 'Vent turbine',
      'Spin Crusher': 'Écrasement tournoyant',
      'Super Hawk Blaster': 'Super canon faucon',
      'Transform': 'Transformation',
      'Whirlwind': 'Tornade'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Armored Pauldron': 'ショルダーアーマー',
      'Claster': 'クラスター',
      'Cruise Chaser': 'クルーズチェイサー',
      'E\\\\.D\\\\.D\\\\.': 'イーディーディー',
      'Multifield': '積層科学フィールド',
      'Plasma Shield': 'プラズマシールド',
      'The Main Generators': '中枢大動力室',
      'The plasma shield is shattered': 'プラズマシールドが壊れた！'
    },
    'replaceText': {
      '(?<! )Sword': 'ソード',
      '(?<!Super )Hawk Blaster': 'ホークブラスター',
      '--invincible--': '--インビンシブル--',
      '\\(bait\\)': '(誘導)',
      '\\(clock/out\\)': '(時針回り/外へ)',
      '\\(everyone\\)': '(全員)',
      '\\(numbers\\)': '(数字)',
      '\\(offtank\\)': '(ST)',
      '\\(orbs\\)': '(玉)',
      '\\(out/clock\\)': '(外へ/時針回り)',
      '\\(shield\\)': '(シールド)',
      '\\?': ' ?',
      'Assault Cannon': 'アサルトカノン',
      'Blassty Blaster': 'ブラスティ・ブラスター',
      'Blassty Charge': 'ブラスティ・チャージ',
      'Blastoff': 'ブラストオフ',
      '(?<!Blassty )Charge': 'チャージ',
      'E\\.D\\.D\\. Add': '雑魚: イーディーディー',
      'E\\.D\\.D\\. Armored Pauldron': 'イーディーディー ショルダーアーマー',
      'Eternal Darkness': '暗黒の運命',
      'GA-100': 'GA-100',
      'Lapis Lazuli': 'ラピスラズリ',
      'Laser X Sword': 'レーザーエックススウォード',
      'Left/Right Laser Sword': '左/右 ソード',
      'Limit Cut': 'リミッターカット',
      'Markers': 'マーク',
      'Multifield': '積層科学フィールド',
      'Optical Sight': '照準',
      'Perfect Landing': '着陸',
      'Photon': 'フォトン',
      'Plasma Shield': 'プラズマシールド',
      'Plasmasphere': 'プラズマスフィア',
      'Propeller Wind': 'プロペラウィンド',
      'Spin Crusher': 'スピンクラッシャー',
      'Super Hawk Blaster': 'スーパーホークブラスター',
      'Transform': 'トランスフォーム・シューター',
      'Whirlwind': '竜巻'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Armored Pauldron': '肩部装甲',
      'Claster': '舰载浮游炮',
      'Cruise Chaser': '巡航驱逐者',
      'E\\\\.D\\\\.D\\\\.': '护航机甲',
      'Multifield': '层积科学结界',
      'Plasma Shield': '等离子护盾',
      'The Main Generators': '中枢大动力室'
    },
    'replaceText': {
      '(?<! )Sword': '剑 ',
      '(?<!Super )Hawk Blaster': '鹰式破坏炮',
      '--invincible--': '--无敌--',
      '\\(bait\\)': '(诱导)',
      '\\(clock/out\\)': '(顺时针/外)',
      '\\(everyone\\)': '(全员)',
      '\\(numbers\\)': '(麻将)',
      '\\(orbs\\)': '(球)',
      '\\(out/clock\\)': '(外/顺时针)',
      '\\(shield\\)': '(护盾)',
      '\\?': ' ?',
      'Assault Cannon': '突击加农炮',
      'Blassty Blaster': '摧毁者破坏炮',
      'Blassty Charge': '摧毁者冲击',
      'Blastoff': '准备升空',
      '(?<!Blassty )Charge': '刺冲',
      'E\\.D\\.D\\. Add': '护航机甲出现',
      'E\\.D\\.D\\. Armored Pauldron': '护航机甲肩部装甲',
      'Eternal Darkness': '黑暗命运',
      'GA-100': '百式聚能炮',
      'Lapis Lazuli': '天青石',
      'Laser X Sword': '交叉光剑',
      'Left/Right Laser Sword': '左/右光剑',
      'Limit Cut': '限制器减档',
      'Markers': '标记',
      'Multifield': '层积科学结界',
      'Optical Sight': '制导',
      'Perfect Landing': '着陆',
      'Photon': '光子炮',
      'Plasma Shield': '等离子护盾',
      'Plasmasphere': '等离子球',
      'Propeller Wind': '螺旋桨强风',
      'Spin Crusher': '回旋碎踢',
      'Super Hawk Blaster': '超级鹰式破坏炮',
      'Transform': '变形',
      'Whirlwind': '龙卷风'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Armored Pauldron': '견갑부',
      'Claster': '클래스터',
      'Cruise Chaser': '순항추격기',
      'E\\\\.D\\\\.D\\\\.': 'E\\.D\\.D\\.',
      'Multifield': '적층과학 필드',
      'Plasma Shield': '플라스마 방어막',
      'The Main Generators': '중추 대동력실'
    },
    'replaceText': {
      '(?<! )Sword': '알파검',
      '(?<!Super )Hawk Blaster': '호크 블래스터',
      '--invincible--': '--무적--',
      '\\(bait\\)': '(유도)',
      '\\(clock/out\\)': '(시계방향/밖)',
      '\\(everyone\\)': '(모두)',
      '\\(numbers\\)': '(주사위)',
      '\\(orbs\\)': '(구슬)',
      '\\(out/clock\\)': '(밖/시계방향)',
      '\\(shield\\)': '(방어막)',
      'Assault Cannon': '맹공포',
      'Blassty Blaster': '블래스티 블래스터',
      'Blassty Charge': '블래스티 돌진',
      'Blastoff': '발진',
      '(?<!Blassty )Charge': '돌격',
      'E\\.D\\.D\\. Add': 'E.D.D. 등장',
      'E\\.D\\.D\\. Armored Pauldron': 'E.D.D. 견갑부',
      'Eternal Darkness': '암흑의 운명',
      'GA-100': 'GA-100',
      'Lapis Lazuli': '청금석',
      'Laser X Sword': '레이저 교차베기',
      'Left/Right Laser Sword': '왼쪽/오른쪽 레이저 베기',
      'Limit Cut': '리미터 해제',
      'Markers': '징',
      'Multifield': '적층과학 필드',
      'Optical Sight': '조준',
      'Perfect Landing': '착륙',
      'Photon': '광자',
      'Plasma Shield': '플라스마 방어막',
      'Plasmasphere': '플라스마 구체',
      'Propeller Wind': '추진 돌풍',
      'Spin Crusher': '회전 분쇄',
      'Super Hawk Blaster': '슈퍼 호크 블래스터',
      'Transform': '비행형 변신',
      'Whirlwind': '회오리바람'
    }
  }]
};
/* harmony default export */ const a11s = (a11s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a11s.txt
const raid_a11s_namespaceObject = "### A11S\r\n# Alexander - The Heart of the Creator (Savage)\r\n# https://docs.google.com/document/d/1z7VC-k2UzkLMsfWhWR9C5Z4dUlTZPPR0w2mNswTCnU4/edit\r\n# https://www.reddit.com/r/ffxiv/comments/5743rk/question_pillars_and_final_phase_of_a11s/d8p39zj/\r\n# -ii 1A64 1A65 1A77 1A74 1A7C 1AAF 1A61 1A62 1A63 1A70 1A72 1A7E\r\n# -p 1A80:179.3 1A19:352.5 1A75:651.8\r\n# Optionally for first phase: -p 1A6C:17.3 1A6D:17.3\r\n# Optionally for last phase: -p 1A76:551.3\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n6.2 \"--sync--\" StartsUsing { id: \"1A7[A9]\", source: \"Cruise Chaser\" } window 7,5\r\n9.2 \"Left/Right Laser Sword\" Ability { id: \"1A7[A9]\", source: \"Cruise Chaser\" }\r\n\r\n# skippable\r\n17.3 \"Optical Sight (clock/out)\" Ability { id: \"1A6[CD]\", source: \"Cruise Chaser\" }\r\n\r\n# skippable\r\n33.4 \"Whirlwind\" Ability { id: \"1A84\", source: \"Cruise Chaser\" }\r\n40.6 \"Spin Crusher\" Ability { id: \"1A85\", source: \"Cruise Chaser\" }\r\n\r\n# skippable\r\n45.8 \"E.D.D. Add\" AddedCombatant { name: \"E\\\\.D\\\\.D\\\\.\" } window 50,5\r\n\r\n# If we jump to this laser sword immediately after first, the timing is:\r\n# 9.2 (first sword) 21.7 (second sword)\r\n# Sync to somewhere that will catch t=18.7 - 2.5 seconds = ~36 window (at least)\r\n51.8 \"--sync--\" StartsUsing { id: \"1A7[A9]\", source: \"Cruise Chaser\" } window 40,5\r\n54.8 \"Left/Right Laser Sword\" Ability { id: \"1A7[A9]\", source: \"Cruise Chaser\" }\r\n55.8 \"E.D.D. Armored Pauldron\"\r\n64.0 \"Spin Crusher\" Ability { id: \"1A85\", source: \"Cruise Chaser\" }\r\n81.2 \"Whirlwind\" Ability { id: \"1A84\", source: \"Cruise Chaser\" }\r\n\r\n85.3 \"--sync--\" StartsUsing { id: \"1A7[A9]\", source: \"Cruise Chaser\" } window 30,5\r\n88.3 \"Left/Right Laser Sword\" Ability { id: \"1A7[A9]\", source: \"Cruise Chaser\" }\r\n\r\n# GA-100 in the first phase.  WHO KNEW?\r\n# There's a question mark because nobody should ever see this.\r\n101.6 \"GA-100?\" Ability { id: \"1A76\", source: \"Cruise Chaser\" }\r\n\r\n# can skip add and jump here\r\n112.7 \"--sync--\" StartsUsing { id: \"1A6E\", source: \"Cruise Chaser\" } window 113,5\r\n114.7 \"Optical Sight (bait)\" Ability { id: \"1A6E\", source: \"Cruise Chaser\" }\r\n119.9 \"Hawk Blaster\" Ability { id: \"1A6F\", source: \"Cruise Chaser\" }\r\n\r\n129.8 \"Optical Sight (clock/out)\" Ability { id: \"1A6[CD]\", source: \"Cruise Chaser\" }\r\n137.9 \"Super Hawk Blaster\" Ability { id: \"1A71\", source: \"Cruise Chaser\" }\r\n\r\n143.9 \"Optical Sight (out/clock)\" Ability { id: \"1A6[CD]\", source: \"Cruise Chaser\" }\r\n150.9 \"Super Hawk Blaster\" Ability { id: \"1A71\", source: \"Cruise Chaser\" }\r\n\r\n159.9 \"Whirlwind\" Ability { id: \"1A84\", source: \"Cruise Chaser\" }\r\n168.1 \"Left/Right Laser Sword\" Ability { id: \"1A7[A9]\", source: \"Cruise Chaser\" }\r\n\r\n### Limit Cut Numbers\r\n177.3 \"--sync--\" StartsUsing { id: \"1A80\", source: \"Cruise Chaser\" } window 180,5\r\n179.3 \"Limit Cut (numbers)\" Ability { id: \"1A80\", source: \"Cruise Chaser\" }\r\n179.9 \"--invincible--\"\r\n183.5 \"Markers\"\r\n192.1 \"Sword 1\" Ability { id: \"1A81\", source: \"Cruise Chaser\" }\r\n193.2 \"Charge 2\" Ability { id: \"1A82\", source: \"Cruise Chaser\" }\r\n195.4 \"Sword 3\" Ability { id: \"1A81\", source: \"Cruise Chaser\" }\r\n196.5 \"Charge 4\" Ability { id: \"1A82\", source: \"Cruise Chaser\" }\r\n198.7 \"Sword 5\" Ability { id: \"1A81\", source: \"Cruise Chaser\" }\r\n199.8 \"Charge 6\" Ability { id: \"1A82\", source: \"Cruise Chaser\" }\r\n202.0 \"Sword 7\" Ability { id: \"1A81\", source: \"Cruise Chaser\" }\r\n203.1 \"Charge 8\" Ability { id: \"1A82\", source: \"Cruise Chaser\" }\r\n205.2 \"--targetable--\"\r\n\r\n215.3 \"Photon\" Ability { id: \"1A73\", source: \"Cruise Chaser\" }\r\n222.4 \"Whirlwind\" Ability { id: \"1A84\", source: \"Cruise Chaser\" }\r\n229.6 \"Left/Right Laser Sword\" Ability { id: \"1A7[A9]\", source: \"Cruise Chaser\" }\r\n237.1 \"Blastoff\" Ability { id: \"1A66\", source: \"Cruise Chaser\" } window 240,10\r\n237.9 \"--untargetable--\"\r\n\r\n\r\n### Cutscene\r\n240.2 \"Transform\" Ability { id: \"1A49\", source: \"Cruise Chaser\" }\r\n247.9 \"--sync--\" Ability { id: \"1A4A\", source: \"Cruise Chaser\" }\r\n252.8 \"Blassty Blaster\" Ability { id: \"1A69\", source: \"Cruise Chaser\" }\r\n258.8 \"Transform\" Ability { id: \"1A4E\", source: \"Cruise Chaser\" }\r\n264.8 \"Perfect Landing\" Ability { id: \"1A6B\", source: \"Cruise Chaser\" }\r\n\r\n\r\n### ORBS\r\n268.0 \"--targetable--\"\r\n270.1 \"Limit Cut (orbs)\" Ability { id: \"1A80\", source: \"Cruise Chaser\" }\r\n270.7 \"--invincible--\"\r\n273.2 \"Lapis Lazuli x4\"\r\n276.3 \"--sync--\" Ability { id: \"1A7B\", source: \"Cruise Chaser\" }\r\n276.8 \"Plasmasphere x1\"\r\n283.4 \"Whirlwind\" Ability { id: \"1A84\", source: \"Cruise Chaser\" }\r\n287.6 \"--sync--\" Ability { id: \"1A5A\", source: \"Cruise Chaser\" }\r\n292.7 \"--sync--\" Ability { id: \"1A5B\", source: \"Claster\" }\r\n295.7 \"--sync--\" Ability { id: \"1A7B\", source: \"Cruise Chaser\" }\r\n296.4 \"Plasmasphere x2\"\r\n297.4 \"Assault Cannon\" #Ability { id: \"1A78\", source: \"Claster\" }\r\n308.0 \"Laser X Sword\" Ability { id: \"1A7F\", source: \"Cruise Chaser\" }\r\n308.9 \"--sync--\" Ability { id: \"1A5B\", source: \"Claster\" }\r\n313.7 \"Assault Cannon\" #Ability { id: \"1A78\", source: \"Claster\" }\r\n315.1 \"--sync--\" Ability { id: \"1A7B\", source: \"Cruise Chaser\" }\r\n315.7 \"Plasmasphere x2\"\r\n321.7 \"Assault Cannon\" #Ability { id: \"1A78\", source: \"Claster\" }\r\n326.2 \"Left/Right Laser Sword\" Ability { id: \"1A7[A9]\", source: \"Cruise Chaser\" }\r\n338.3 \"Whirlwind\" Ability { id: \"1A84\", source: \"Cruise Chaser\" }\r\n\r\n\r\n### Eternal Darkness\r\n344.4 \"--targetable--\"\r\n344.5 \"--sync--\" StartsUsing { id: \"1A19\", source: \"Cruise Chaser\" } window 350,10\r\n352.5 \"Eternal Darkness\" Ability { id: \"1A19\", source: \"Cruise Chaser\" }\r\n361.7 \"Left/Right Laser Sword\" Ability { id: \"1A7[A9]\", source: \"Cruise Chaser\" }\r\n370.8 \"Whirlwind\" Ability { id: \"1A84\", source: \"Cruise Chaser\" }\r\n378.9 \"Spin Crusher\" Ability { id: \"1A85\", source: \"Cruise Chaser\" }\r\n\r\n# skippable\r\n386.0 \"Optical Sight (bait)\" Ability { id: \"1A6E\", source: \"Cruise Chaser\" }\r\n391.2 \"Hawk Blaster\" Ability { id: \"1A6F\", source: \"Cruise Chaser\" }\r\n396.1 \"Super Hawk Blaster\" Ability { id: \"1A71\", source: \"Cruise Chaser\" }\r\n\r\n# also skippable\r\n399.2 \"--sync--\" StartsUsing { id: \"1A80\", source: \"Cruise Chaser\" } window 50,10\r\n401.2 \"Limit Cut (shield)\" Ability { id: \"1A80\", source: \"Cruise Chaser\" }\r\n401.8 \"--invincible--\"\r\n406.6 \"Plasma Shield\"\r\n431.2 \"Plasma Shield Enrage\"\r\n431.2 \"--sync--\" StartsUsing { id: \"1A83\", source: \"Cruise Chaser\" } window 40,30\r\n435.2 \"Blassty Charge\" Ability { id: \"1A83\", source: \"Cruise Chaser\" }\r\n437.3 \"--targetable--\"\r\n\r\n439.5 \"--sync--\" StartsUsing { id: \"1A73\", source: \"Cruise Chaser\" } window 40,10\r\n442.5 \"Photon (offtank)\" Ability { id: \"1A73\", source: \"Cruise Chaser\" }\r\n450.9 \"Laser X Sword\" Ability { id: \"1A7F\", source: \"Cruise Chaser\" }\r\n\r\n# maybe skippable\r\n458.7 \"E.D.D. Add\" AddedCombatant { name: \"E\\\\.D\\\\.D\\\\.\" }\r\n462.0 \"Photon (dps)\" Ability { id: \"1A73\", source: \"Cruise Chaser\" }\r\n470.2 \"Whirlwind\" Ability { id: \"1A84\", source: \"Cruise Chaser\" }\r\n\r\n478.4 \"--sync--\" StartsUsing { id: \"1A7[A9]\", source: \"Cruise Chaser\" } window 80,5\r\n481.4 \"Left/Right Laser Sword\" Ability { id: \"1A7[A9]\", source: \"Cruise Chaser\" }\r\n487.5 \"Photon (healer)\" Ability { id: \"1A73\", source: \"Cruise Chaser\" }\r\n495.6 \"Whirlwind\" Ability { id: \"1A84\", source: \"Cruise Chaser\" }\r\n502.1 \"Blastoff\" Ability { id: \"1A66\", source: \"Cruise Chaser\" } window 260,10\r\n502.9 \"--untargetable--\"\r\n\r\n\r\n### Cutscene 2\r\n505.2 \"Transform\" Ability { id: \"1A49\", source: \"Cruise Chaser\" }\r\n513.0 \"--sync--\" Ability { id: \"1A4A\", source: \"Cruise Chaser\" }\r\n517.8 \"Blassty Blaster\" Ability { id: \"1A69\", source: \"Cruise Chaser\" }\r\n520.8 \"Multifield x3\" AddedCombatant { name: \"Multifield\" }\r\n523.9 \"Transform\" Ability { id: \"1A4E\", source: \"Cruise Chaser\" }\r\n529.9 \"Perfect Landing\" Ability { id: \"1A6B\", source: \"Cruise Chaser\" }\r\n\r\n\r\n### Final phase\r\n532.7 \"--targetable--\"\r\n551.3 \"GA-100\" Ability { id: \"1A76\", source: \"Cruise Chaser\" }\r\n558.4 \"Optical Sight (clock/out)\" Ability { id: \"1A6[CD]\", source: \"Cruise Chaser\" }\r\n565.5 \"Super Hawk Blaster\" Ability { id: \"1A71\", source: \"Cruise Chaser\" }\r\n573.6 \"Optical Sight (out/clock)\" Ability { id: \"1A6[CD]\", source: \"Cruise Chaser\" }\r\n581.7 \"Super Hawk Blaster\" Ability { id: \"1A71\", source: \"Cruise Chaser\" }\r\n586.7 \"Whirlwind\" Ability { id: \"1A84\", source: \"Cruise Chaser\" }\r\n595.9 \"Whirlwind\" Ability { id: \"1A84\", source: \"Cruise Chaser\" }\r\n605.1 \"Laser X Sword\" Ability { id: \"1A7F\", source: \"Cruise Chaser\" }\r\n612.2 \"Optical Sight (bait)\" Ability { id: \"1A6E\", source: \"Cruise Chaser\" }\r\n617.4 \"Hawk Blaster\" Ability { id: \"1A6F\", source: \"Cruise Chaser\" }\r\n622.3 \"Super Hawk Blaster\" Ability { id: \"1A71\", source: \"Cruise Chaser\" }\r\n622.4 \"--sync--\" Ability { id: \"1A5A\", source: \"Cruise Chaser\" }\r\n626.6 \"--sync--\" Ability { id: \"1A5B\", source: \"Claster\" }\r\n# Well, really everyone but the main tank.  But that's too long to write out.\r\n628.6 \"Photon (everyone)\" Ability { id: \"1A73\", source: \"Cruise Chaser\" }\r\n633.1 \"Assault Cannon\" #Ability { id: \"1A78\", source: \"Claster\" }\r\n635.8 \"Whirlwind\" Ability { id: \"1A84\", source: \"Cruise Chaser\" }\r\n640.3 \"Assault Cannon\" #Ability { id: \"1A78\", source: \"Claster\" }\r\n647.4 \"Assault Cannon\" #Ability { id: \"1A78\", source: \"Claster\" }\r\n651.8 \"Propeller Wind\" Ability { id: \"1A75\", source: \"Cruise Chaser\" }\r\n\r\n655.0 \"--sync--\" StartsUsing { id: \"1A80\", source: \"Cruise Chaser\" } window 100,20\r\n657.0 \"Limit Cut (numbers)\" Ability { id: \"1A80\", source: \"Cruise Chaser\" }\r\n657.6 \"--invincible--\"\r\n661.2 \"Markers\"\r\n669.9 \"Sword 1\" Ability { id: \"1A81\", source: \"Cruise Chaser\" }\r\n671.0 \"Charge 2\" Ability { id: \"1A82\", source: \"Cruise Chaser\" }\r\n673.2 \"Sword 3\" Ability { id: \"1A81\", source: \"Cruise Chaser\" }\r\n674.3 \"Charge 4\" Ability { id: \"1A82\", source: \"Cruise Chaser\" }\r\n676.5 \"Sword 5\" Ability { id: \"1A81\", source: \"Cruise Chaser\" }\r\n677.6 \"Charge 6\" Ability { id: \"1A82\", source: \"Cruise Chaser\" }\r\n679.8 \"Sword 7\" Ability { id: \"1A81\", source: \"Cruise Chaser\" }\r\n680.9 \"Charge 8\" Ability { id: \"1A82\", source: \"Cruise Chaser\" }\r\n683.0 \"--targetable--\"\r\n\r\n693.2 \"Laser X Sword\" Ability { id: \"1A7F\", source: \"Cruise Chaser\" }\r\n697.2 \"E.D.D. Add\" AddedCombatant { name: \"E\\\\.D\\\\.D\\\\.\" }\r\n705.4 \"Photon (dps)\" Ability { id: \"1A73\", source: \"Cruise Chaser\" }\r\n714.6 \"Left/Right Laser Sword\" Ability { id: \"1A7[A9]\", source: \"Cruise Chaser\" }\r\n722.7 \"Photon (healer)\" Ability { id: \"1A73\", source: \"Cruise Chaser\" }\r\n730.8 \"Whirlwind\" Ability { id: \"1A84\", source: \"Cruise Chaser\" }\r\n\r\n733.7 \"--sync--\" StartsUsing { id: \"1A80\", source: \"Cruise Chaser\" } window 70,20\r\n735.7 \"Limit Cut (shield)\" Ability { id: \"1A80\", source: \"Cruise Chaser\" }\r\n736.3 \"--invincible--\"\r\n741.1 \"Plasma Shield\"\r\n765.7 \"Plasma Shield Enrage\"\r\n765.7 \"--sync--\" StartsUsing { id: \"1A83\", source: \"Cruise Chaser\" } window 40,30\r\n769.7 \"Blassty Charge\" Ability { id: \"1A83\", source: \"Cruise Chaser\" }\r\n771.8 \"--targetable--\"\r\n\r\n779.7 \"Spin Crusher\" Ability { id: \"1A85\", source: \"Cruise Chaser\" }\r\n789.7 \"Whirlwind\" Ability { id: \"1A84\", source: \"Cruise Chaser\" }\r\n806.4 \"Laser X Sword\" Ability { id: \"1A7F\", source: \"Cruise Chaser\" }\r\n\r\n# If you destroy a tower with the first GA-100, this is enrage.\r\n# FIXME: Guessing that this loops, but unclear.\r\n829.4 \"GA-100\" Ability { id: \"1A76\", source: \"Cruise Chaser\" } window 100,100 jump 551.3\r\n836.5 \"Optical Sight (clock/out)\"\r\n843.6 \"Super Hawk Blaster\"\r\n851.7 \"Optical Sight (out/clock)\"\r\n859.8 \"Super Hawk Blaster\"\r\n864.8 \"Whirlwind\"\r\n874.0 \"Whirlwind\"\r\n883.2 \"Laser X Sword\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a12n.ts




const a12n_triggerSet = {
  id: 'AlexanderTheSoulOfTheCreator',
  zoneId: zone_id/* default.AlexanderTheSoulOfTheCreator */.Z.AlexanderTheSoulOfTheCreator,
  timelineFile: 'a12n.txt',
  timelineTriggers: [{
    id: 'A12N Tank Limit Break',
    regex: /Divine Judgment/,
    beforeSeconds: 5,
    suppressSeconds: 9999,
    // Let's not spam tanks if they are unlucky enough to see enrage.
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Limit break now!',
        de: 'Limit break jetzt!',
        fr: 'Transcendance maintenant !',
        ja: 'タンクLBを！',
        cn: '坦克LB！',
        ko: '지금 탱리밋 사용!'
      }
    }
  }, {
    id: 'A12N Divine Spear',
    regex: /Divine Spear/,
    beforeSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'A12N Punishing Heat',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alexander Prime',
      id: '1AE4'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'A12N Blazing Scourge',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'A12N Mega Holy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alexander Prime',
      id: '1AE7',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'A12N Aggravated Assault',
    type: 'HeadMarker',
    netRegex: {
      id: '0010'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    // If the user is targeted for Assault, we need to ensure the stack trigger knows.
    run: data => data.assault = true,
    outputStrings: {
      text: {
        en: 'Spread (Don\'t Stack!)',
        de: 'Verteilen (Ohne stacken)',
        fr: 'Dispersez-vous (Pas de package !)',
        ja: '散開（重ならないように）',
        cn: '分散（不要重合!）',
        ko: '산개（모이지마세요!）'
      }
    }
  }, {
    // Both Incinerating Heat and Shared Sentence use the same stack marker.
    id: 'A12N Heat And Solidarity',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    delaySeconds: 0.5,
    alertText: (data, matches, output) => {
      // If the user was targeted for Assault, they shouldn't stack.
      // Unfortunately, Assault comes after the Shared Sentence marker in the log,
      // so we have to use the collect + delay construction to make calls.
      if (data.assault) return;
      if (data.me === matches.target) return output.stackOnYou();
      return output.stackOn({
        player: data.party.member(matches.target)
      });
    },
    run: data => delete data.assault,
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'A12N Laser Sacrament',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alexander Prime',
      id: '1AE5',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Lasers',
        de: 'Laser',
        fr: 'Lasers',
        ja: 'レーザー',
        cn: '十字圣礼',
        ko: '십자 성례'
      }
    }
  }, {
    id: 'A12N Communion Tether',
    type: 'Tether',
    netRegex: {
      source: 'Alexander',
      id: '0036'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Puddle Tether on YOU',
        de: 'Flächen-Verbindung auf dir',
        fr: 'Lien Zone au sol sur VOUS',
        ja: '自分に線',
        cn: '放圈连线点名',
        ko: '장판 남기는 선 대상자'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      '(?<! )Alexander(?! )': 'Alexander',
      'Alexander Prime': 'Prim-Alexander',
      'Judgment Crystal': 'Urteilskristall',
      'The General\'s Might': 'Arrhidaios (?:der|die|das) Stark(?:e|er|es|en)',
      'The General\'s Time': 'Arrhidaios (?:der|die|das) Kolossal(?:e|er|es|en)',
      'The General\'s Wing': 'Arrhidaios (?:der|die|das) Überwältigend(?:e|er|es|en)'
    },
    'replaceText': {
      '(?<!Radiant )Sacrament': 'Sakrament',
      'Almost Holy': 'Semi-Sanctus',
      'Arrhidaeus\'s Lanner': 'Arrhidaios der Bote',
      'Blazing Scourge': 'Peitschendes Licht',
      'Chastening Heat': 'Brennende Verdammung',
      'Chronofoil': 'Zeitschwingen',
      'Communion': 'Kommunion',
      'Confession': 'Bekenntnis',
      'Divine Judgment': 'Göttliches Urteil',
      'Divine Spear': 'Heiliger Speer',
      'Gravitational Anomaly': 'Gravitationsanomalie',
      'Half Gravity': 'Semi-Gravitas',
      'Holy Bleed': 'Sanctus-Einschlag',
      'Holy Scourge': 'Peitschende Gloriole',
      'Inception': 'Raumzeit-Eingriff',
      'Incinerating Heat': 'Sengende Hitze',
      'Judgment Crystal': 'Urteilskristall',
      'Mega Holy': 'Super-Sanctus',
      'Plaint Of Solidarity': 'Kollektivurteil',
      'Punishing Heat': 'Brennendes Urteil',
      'Radiant Sacrament': 'Brennendes Sakrament',
      'Smash': 'Schmettern',
      'Summon Alexander': 'Alexanders Beschwörung',
      'Temporal Stasis': 'Zeitstillstand',
      'Tetrashatter': 'Kristallbruch',
      'The General\'s Might': 'Arrhidaios der Starke',
      'The General\'s Time': 'Arrhidaios der Kolossale',
      'The General\'s Wing': 'Arrhidaios der Überwältigende',
      'Void Of Repentance': 'Kammer der Buße',
      'timegate(?!s)': 'Zeittor',
      'timegates active': 'Zeittore Aktiv',
      'timestop': 'Zeitstopp'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '(?<! )Alexander(?! )': 'Alexander',
      'Alexander Prime': 'Primo-Alexander',
      'Judgment Crystal': 'Cristal du jugement',
      'The General\'s Might': 'Pouvoir d\'Arrhabée',
      'The General\'s Time': 'Temps d\'Arrhabée',
      'The General\'s Wing': 'Aile d\'Arrhabée'
    },
    'replaceText': {
      '(?<! )Sacrament': 'Sacrement',
      '--timestop--': '--arrêt du temps--',
      '\\(Radiant\\?\\) Sacrament': 'Sacrement (rayonnant ?)',
      'Almost Holy(?!\\?)': 'Quasi-Miracle',
      'Almost Holy\\?': 'Quasi-Miracle ?',
      'Arrhidaeus\'s Lanner': 'Messager d\'Arrhabée',
      'Blazing Scourge': 'Lumière fustigeante',
      'Chastening Heat': 'Chaleur de l\'ordalie',
      'Chronofoil': 'Ailes du temps',
      'Communion': 'Communion',
      'Confession': 'Confession',
      'Divine Judgment': 'Jugement divin',
      'Divine Spear': 'Épieu divin',
      'Gravitational Anomaly': 'Anomalie gravitationnelle',
      'Half Gravity': 'Demi-Pesanteur',
      'Holy Bleed': 'Impact miraculeux',
      'Holy Scourge': 'Lumière fustigeante',
      'Inception': 'Commencement',
      'Incinerating Heat': 'Chaleur purifiante',
      'Judgment Crystal': 'Cristal du jugement',
      'Mega Holy': 'Méga Miracle',
      'Plaint Of Solidarity': 'Ordalie de la solidarité',
      'Punishing Heat': 'Chaleur punitive',
      'Radiant Sacrament': 'Sacrement rayonnant',
      'Smash': 'Fracassement',
      'Summon Alexander': 'Invocation d\'Alexander',
      'Temporal Stasis': 'Stase temporelle',
      'Tetrashatter': 'Rupture',
      'The General\'s Might': 'Pouvoir d\'Arrhabée',
      'The General\'s Time': 'Temps d\'Arrhabée',
      'The General\'s Wing': 'Aile d\'Arrhabée',
      'timegate(?!s)': 'Porte temporelle',
      'timegates active': 'Porte temporelle active',
      'Void Of Repentance': 'Vide du repentir'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '(?<! )Alexander(?! )': 'アレキサンダー',
      'Alexander Prime': 'アレキサンダー・プライム',
      'Judgment Crystal': '審判の結晶',
      'The General\'s Might': 'アリダイオス・マイト',
      'The General\'s Time': 'アリダイオス・タイム',
      'The General\'s Wing': 'アリダイオス・ウィング'
    },
    'replaceText': {
      '--timestop--': '--時間停止--',
      '(?<! )Sacrament': '十字の秘蹟',
      '\\(Radiant\\?\\) Sacrament': '十字の秘蹟/拝火の秘蹟',
      'Almost Holy': 'プチホーリー',
      'Arrhidaeus\'s Lanner': 'アリダイオス・ランナー',
      'Blazing Scourge': '白光の鞭',
      'Chastening Heat': '神罰の熱線',
      'Chronofoil': '時の翼',
      'Communion': 'コミュニオン',
      'Confession': '強制告解',
      'Divine Judgment': '聖なる審判',
      'Divine Spear': '聖なる炎',
      'Gravitational Anomaly': '重力異常',
      'Half Gravity': 'プチグラビデ',
      'Holy Bleed': 'ホーリーバースト',
      'Holy Scourge': '聖光の鞭',
      'Inception': '時空潜行',
      'Incinerating Heat': '浄化の熱線',
      'Judgment Crystal': '審判の結晶',
      'Mega Holy': 'メガホーリー',
      'Plaint Of Solidarity': '連帯の神判',
      'Punishing Heat': '懲罰の熱線',
      'Radiant Sacrament': '拝火の秘蹟',
      'Smash': 'スマッシュ',
      'Summon Alexander': 'アレキサンダー召喚',
      'Temporal Stasis': '時間停止',
      'Tetrashatter': '結晶破裂',
      'The General\'s Might': 'アリダイオス・マイト',
      'The General\'s Time': 'アリダイオス・タイム',
      'The General\'s Wing': 'アリダイオス・ウィング',
      'timegate(?!s)': 'タイムゲート',
      'timegates active': 'タイムゲート起動',
      'Void Of Repentance': '懺悔の間'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '(?<! )Alexander(?! )': '亚历山大',
      'Alexander Prime': '至尊亚历山大',
      'Judgment Crystal': '审判结晶',
      'The General\'s Might': '阿里达乌斯之力',
      'The General\'s Time': '阿里达乌斯之时',
      'The General\'s Wing': '阿里达乌斯之翼'
    },
    'replaceText': {
      '(?<!Radiant )Sacrament': '十字圣礼',
      'Almost Holy': '小神圣',
      'Arrhidaeus\'s Lanner': '阿里达乌斯之速',
      'Blazing Scourge': '白光之鞭',
      'Chastening Heat': '神罚射线',
      'Chronofoil': '光阴之翼',
      'Communion': '圣餐',
      'Confession': '强制告解',
      'Divine Judgment': '神圣审判',
      'Divine Spear': '圣炎',
      'Gravitational Anomaly': '重力异常',
      'Half Gravity': '小重力',
      'Holy Bleed': '神圣爆发',
      'Holy Scourge': '圣光之鞭',
      'Inception': '时空潜行',
      'Incinerating Heat': '净化射线',
      'Judgment Crystal': '审判结晶',
      'Mega Holy': '百万神圣',
      'Plaint Of Solidarity': '连带神判',
      'Punishing Heat': '惩戒射线',
      'Radiant Sacrament': '拜火圣礼',
      'Smash': '碎击斩',
      'Summon Alexander': '召唤亚历山大',
      'Temporal Stasis': '时间停止',
      'Tetrashatter': '结晶破碎',
      'The General\'s Might': '阿里达乌斯之力',
      'The General\'s Time': '阿里达乌斯之时',
      'The General\'s Wing': '阿里达乌斯之翼',
      'Void Of Repentance': '忏悔区',
      'timegate(?!s)': '时空门',
      'timegates active': '时空门激活',
      'timestop': '时停'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '(?<! )Alexander(?! )': '알렉산더',
      'Alexander Prime': '알렉산더 프라임',
      'Judgment Crystal': '심판의 결정체',
      'The General\'s Might': '아리다이오스의 권력',
      'The General\'s Time': '아리다이오스의 시간',
      'The General\'s Wing': '아리다이오스의 날개'
    },
    'replaceText': {
      '(?<!Radiant )Sacrament': '십자 성례',
      'Almost Holy': '프티 홀리',
      'Arrhidaeus\'s Lanner': '아리다이오스의 전령',
      'Blazing Scourge': '백광의 채찍',
      'Chastening Heat': '신벌의 열선',
      'Chronofoil': '시간의 날개',
      'Communion': '성체 배령',
      'Confession': '강제 고해',
      'Divine Judgment': '신성한 심판',
      'Divine Spear': '신성한 불꽃',
      'Gravitational Anomaly': '중력 이상',
      'Half Gravity': '프티 그라비데',
      'Holy Bleed': '성스러운 폭발',
      'Holy Scourge': '성광의 채찍',
      'Inception': '시공 잠행',
      'Incinerating Heat': '정화의 열선',
      'Judgment Crystal': '심판의 결정체',
      'Mega Holy': '메가 홀리',
      'Plaint Of Solidarity': '연대의 심판',
      'Punishing Heat': '징벌의 열선',
      'Radiant Sacrament': '원형 성례',
      'Smash': '박살',
      'Summon Alexander': '알렉산더 소환',
      'Temporal Stasis': '시간 정지',
      'Tetrashatter': '결정체 파열',
      'The General\'s Might': '아리다이오스의 권력',
      'The General\'s Time': '아리다이오스의 시간',
      'The General\'s Wing': '아리다이오스의 날개',
      'Void Of Repentance': '참회의 방',
      'timegate(?!s)': '시간 차원문',
      'timegates active': '시간 차원문 활성화',
      'timestop': '시간 정지'
    }
  }]
};
/* harmony default export */ const a12n = (a12n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a12n.txt
const raid_a12n_namespaceObject = "### ALEXANDER - THE SOUL OF THE CREATOR\r\n### ALEXANDER PRIME\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# -ii 1AE2 1AE6 1AF1\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n6.4 \"Divine Spear\" Ability { id: \"1AE3\", source: \"Alexander Prime\" } window 6.4,5\r\n14.5 \"Mega Holy\" Ability { id: \"1AE7\", source: \"Alexander Prime\" }\r\n22.6 \"Punishing Heat\" Ability { id: \"1AE4\", source: \"Alexander Prime\" }\r\n31.8 \"Sacrament\" Ability { id: \"1AE5\", source: \"Alexander Prime\" } window 30,30\r\n36.0 \"Divine Spear\" Ability { id: \"1AE3\", source: \"Alexander Prime\" }\r\n44.1 \"Mega Holy\" Ability { id: \"1AE7\", source: \"Alexander Prime\" }\r\n51.2 \"--sync--\" Ability { id: \"1AE8\", source: \"Alexander Prime\" }\r\n53.3 \"Blazing Scourge\" Ability { id: \"1AE9\", source: \"Alexander Prime\" }\r\n56.4 \"Divine Spear\" Ability { id: \"1AE3\", source: \"Alexander Prime\" }\r\n\r\n# The intermission can be pushed early at ~75% HP.\r\n61.4 \"--untargetable--\" NameToggle { name: \"Alexander Prime\", toggle: \"00\" } window 61.4,5\r\n161.9 \"--sync--\" Ability { id: \"1A18\", source: \"Alexander\" } window 161.9,5\r\n171.6 \"Divine Judgment\" Ability { id: \"1AEF\", source: \"Alexander\" }\r\n\r\n# Bridge block to Timegate.\r\n182.4 \"--targetable--\"\r\n185.4 \"Chronofoil\" Ability { id: \"19FA\", source: \"Alexander Prime\" } window 185.4,5\r\n199.6 \"Temporal Stasis\" Ability { id: \"1AF0\", source: \"Alexander Prime\" }\r\n203.7 \"--untargetable--\"\r\n203.7 \"Plaint Of Solidarity\" Ability { id: \"1AF2\", source: \"Alexander Prime\" }\r\n206.9 \"--targetable--\"\r\n212.0 \"Sacrament\" Ability { id: \"1AE5\", source: \"Alexander Prime\" }\r\n217.2 \"Divine Spear\" Ability { id: \"1AE3\", source: \"Alexander Prime\" }\r\n223.3 \"Mega Holy\" Ability { id: \"1AE7\", source: \"Alexander Prime\" }\r\n229.6 \"Punishing Heat\" Ability { id: \"1AE4\", source: \"Alexander Prime\" }\r\n234.8 \"Divine Spear\" Ability { id: \"1AE3\", source: \"Alexander Prime\" }\r\n244.9 \"Temporal Stasis\" Ability { id: \"1AF0\", source: \"Alexander Prime\" } window 30,30\r\n249.0 \"--untargetable--\"\r\n249.0 \"Plaint Of Solidarity\" Ability { id: \"1AF2\", source: \"Alexander Prime\" }\r\n252.2 \"--targetable--\"\r\n257.3 \"Sacrament\" Ability { id: \"1AE5\", source: \"Alexander Prime\" }\r\n266.5 \"--sync--\" Ability { id: \"1AE8\", source: \"Alexander Prime\" }\r\n268.7 \"Blazing Scourge\" Ability { id: \"1AE9\", source: \"Alexander Prime\" }\r\n274.6 \"Mega Holy\" Ability { id: \"1AE7\", source: \"Alexander Prime\" }\r\n278.8 \"Divine Spear\" Ability { id: \"1AE3\", source: \"Alexander Prime\" }\r\n\r\n# Timegates seem to push at 50% HP.\r\n# Push timings during Timegate seem inconsistent, so we include plenty of windows.\r\n# We don't sync to the 22 log line here because Alexander uses it twice in the bridge block.\r\n282.8 \"--untargetable--\"\r\n286.1 \"--targetable--\"\r\n290.1 \"Timegate\" Ability { id: \"1A03\", source: \"Alexander Prime\" } window 290,5\r\n309.7 \"Divine Spear\" Ability { id: \"1AE3\", source: \"Alexander Prime\" }\r\n318.8 \"Punishing Heat\" Ability { id: \"1AE4\", source: \"Alexander Prime\" }\r\n325.9 \"--sync--\" Ability { id: \"1AE8\", source: \"Alexander Prime\" }\r\n328.0 \"Blazing Scourge\" Ability { id: \"1AE9\", source: \"Alexander Prime\" } window 30,5\r\n332.9 \"Sacrament\" Ability { id: \"1AE5\", source: \"Alexander Prime\" }\r\n342.1 \"Mega Holy\" Ability { id: \"1AE7\", source: \"Alexander Prime\" } window 50,5\r\n346.2 \"Divine Spear\" Ability { id: \"1AE3\", source: \"Alexander Prime\" }\r\n354.3 \"Punishing Heat\" Ability { id: \"1AE4\", source: \"Alexander Prime\" }\r\n369.5 \"--sync--\" Ability { id: \"1AEA\", source: \"Alexander Prime\" }\r\n374.6 \"--sync--\" Ability { id: \"1AE8\", source: \"Alexander Prime\" }\r\n375.5 \"Gravitational Anomaly\" Ability { id: \"1AEB\", source: \"Alexander Prime\" } window 100,10\r\n376.8 \"Blazing Scourge\" Ability { id: \"1AE9\", source: \"Alexander Prime\" }\r\n378.8 \"Divine Spear\" Ability { id: \"1AE3\", source: \"Alexander Prime\" }\r\n386.9 \"Mega Holy\" Ability { id: \"1AE7\", source: \"Alexander Prime\" }\r\n395.0 \"Punishing Heat\" Ability { id: \"1AE4\", source: \"Alexander Prime\" }\r\n399.2 \"Divine Spear\" Ability { id: \"1AE3\", source: \"Alexander Prime\" }\r\n408.3 \"Temporal Stasis\" Ability { id: \"1AF0\", source: \"Alexander Prime\" }\r\n412.4 \"Plaint Of Solidarity\" Ability { id: \"1AF2\", source: \"Alexander Prime\" }\r\n415.4 \"--sync--\" Ability { id: \"1AEA\", source: \"Alexander Prime\" }\r\n421.4 \"Gravitational Anomaly\" Ability { id: \"1AEB\", source: \"Alexander Prime\" }\r\n422.6 \"Sacrament\" Ability { id: \"1AE5\", source: \"Alexander Prime\" }\r\n429.8 \"Incinerating Heat\" Ability { id: \"1AF3\", source: \"Alexander Prime\" }\r\n\r\n# Summon Alexander seems to push at 30% HP.\r\n# It appears that Alexander has to complete at least a part of the Timegate section first?\r\n# (Pushes of anywhere from 5% to 30% have been seen.)\r\n# Enrage happens after loop 4 if there have been no phase pushes.\r\n# Whether this is the case with pushes is unknown.\r\n\r\n436.0 \"Summon Alexander\" Ability { id: \"1A0A\", source: \"Alexander Prime\" } window 412.8,5\r\n446.2 \"Divine Spear\" Ability { id: \"1AE3\", source: \"Alexander Prime\" }\r\n454.3 \"Mega Holy\" Ability { id: \"1AE7\", source: \"Alexander Prime\" }\r\n461.2 \"Communion x4\" # Ability { id: \"1AFC\", source: \"Alexander\" }\r\n470.6 \"Temporal Stasis\" Ability { id: \"1AF0\", source: \"Alexander Prime\" } window 30,30\r\n474.7 \"--untargetable--\"\r\n474.7 \"Plaint Of Solidarity\" Ability { id: \"1AF2\", source: \"Alexander Prime\" }\r\n477.9 \"--targetable--\"\r\n481.4 \"Communion x4\" # Ability { id: \"1AFC\", source: \"Alexander\" }\r\n483.0 \"Sacrament\" Ability { id: \"1AE5\", source: \"Alexander Prime\" }\r\n499.2 \"Punishing Heat\" Ability { id: \"1AE4\", source: \"Alexander Prime\" } window 30,30\r\n503.4 \"Divine Spear\" Ability { id: \"1AE3\", source: \"Alexander Prime\" }\r\n511.5 \"Mega Holy\" Ability { id: \"1AE7\", source: \"Alexander Prime\" }\r\n\r\n521.7 \"Divine Spear\" Ability { id: \"1AE3\", source: \"Alexander Prime\" } jump 446.2\r\n529.8 \"Mega Holy\"\r\n536.7 \"Communion x4\"\r\n546.1 \"Temporal Stasis\"\r\n550.2 \"--untargetable--\"\r\n550.2 \"Plaint Of Solidarity\"\r\n553.4 \"--targetable--\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a12s.ts



const a12s_triggerSet = {
  id: 'AlexanderTheSoulOfTheCreatorSavage',
  zoneId: zone_id/* default.AlexanderTheSoulOfTheCreatorSavage */.Z.AlexanderTheSoulOfTheCreatorSavage,
  timelineFile: 'a12s.txt',
  initData: () => {
    return {
      scourge: []
    };
  },
  timelineTriggers: [{
    id: 'A12S Divine Spear',
    regex: /Divine Spear/,
    beforeSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'A12S Holy Bleed',
    regex: /Holy Bleed/,
    beforeSeconds: 5,
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }],
  triggers: [{
    id: 'A12S Punishing Heat',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alexander Prime',
      id: '19E9'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    // Applies to both holy and blazing scourge.
    id: 'A12S Holy Blazing Scourge You',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    condition: (data, matches) => {
      // Ignore Holy Scourge later in the fight.
      if (data.scourge.length > 2) return false;
      return data.me === matches.target;
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Scourge on YOU',
        de: 'Licht auf DIR',
        fr: 'Lumière sur VOUS',
        ja: '自分に白光の鞭',
        cn: '白光之鞭点名',
        ko: '성광의 채찍 대상자'
      }
    }
  }, {
    id: 'A12S Blazing Scourge Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    run: (data, matches) => data.scourge.push(matches.target)
  }, {
    id: 'A12S Blazing Scourge Report',
    type: 'HeadMarker',
    netRegex: {
      id: '001E',
      capture: false
    },
    condition: data => {
      // Ignore Holy Scourge later in the fight.
      if (data.scourge.length > 2) return false;
      return data.role === 'healer' || data.job === 'BLU';
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      // Ignore Holy Scourge later in the fight.
      if (data.scourge.length > 2) return false;
      const names = data.scourge.map(x => data.party.member(x)).sort();
      if (names.length === 0) return;
      return output.text({
        players: names
      });
    },
    outputStrings: {
      text: {
        en: 'Scourge: ${players}',
        de: 'Licht: ${players}',
        fr: 'Lumière : ${players}',
        ja: '${players}に白光の鞭',
        cn: '白光之鞭点:${players}',
        ko: '성광의 채찍:${players}'
      }
    }
  }, {
    id: 'A12S Mega Holy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alexander Prime',
      id: '19EE',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'A12S Incinerating Heat',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'A12S Laser Sacrament',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alexander Prime',
      id: '19EB',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Lasers',
        de: 'Laser',
        fr: 'Lasers',
        ja: '十字の秘蹟',
        cn: '十字圣礼',
        ko: '십자 성례'
      }
    }
  }, {
    id: 'A12S Radiant Sacrament',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alexander Prime',
      id: '19ED',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'A12S House Arrest',
    type: 'Tether',
    netRegex: {
      id: '001C'
    },
    condition: (data, matches) => matches.source === data.me || matches.target === data.me,
    infoText: (data, matches, output) => {
      const partner = matches.source === data.me ? matches.target : matches.source;
      return output.text({
        player: data.party.member(partner)
      });
    },
    outputStrings: {
      text: {
        en: 'Close Tethers (${player})',
        de: 'Nahe Verbindungen (${player})',
        fr: 'Liens proches (${player})',
        ja: '(${player})に近づく',
        cn: '靠近连线 (${player})',
        ko: '강제접근: 상대와 가까이 붙기 (${player})'
      }
    }
  }, {
    id: 'A12S Restraining Order',
    type: 'Tether',
    netRegex: {
      id: '001D'
    },
    condition: (data, matches) => matches.source === data.me || matches.target === data.me,
    alertText: (data, matches, output) => {
      const partner = matches.source === data.me ? matches.target : matches.source;
      return output.text({
        player: data.party.member(partner)
      });
    },
    outputStrings: {
      text: {
        en: 'Far Tethers (${player})',
        de: 'Entfernte Verbindungen (${player})',
        fr: 'Liens éloignés (${player})',
        ja: ' (${player})から離れる',
        cn: '远离连线 (${player})',
        ko: '접근금지: 상대와 떨어지기 (${player})'
      }
    }
  }, {
    id: 'A12S Shared Sentence',
    type: 'GainsEffect',
    netRegex: {
      effectId: '462'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Shared Sentence',
        de: 'Urteil Kollektivstrafe',
        fr: 'Partagez peine collective',
        ja: '集団罰',
        cn: '集团罪',
        ko: '집단형: 쉐어'
      }
    }
  }, {
    id: 'A12S Defamation',
    type: 'GainsEffect',
    netRegex: {
      effectId: '460'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Defamation',
        de: 'Ehrenstrafe',
        fr: 'Diffamation',
        ja: '名誉罰',
        cn: '名誉罪',
        ko: '명예형: 멀리가기'
      }
    }
  }, {
    id: 'A12S Judgment Crystal',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Crystal on YOU',
        de: 'Kristall auf DIR',
        fr: 'Cristal sur VOUS',
        ja: '自分に結晶',
        cn: '结晶点名',
        ko: '나에게 수정'
      }
    }
  }, {
    id: 'A12S Holy Scourge',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alexander Prime',
      id: '1A0B',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Shared Tankbuster',
        de: 'geteilter Tankbuster',
        fr: 'Partagez le Tank buster',
        ja: '頭割りタンクバスター',
        cn: '分摊死刑',
        ko: '쉐어 탱크버스터'
      }
    }
  }, {
    id: 'A12S Chastening Heat',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alexander Prime',
      id: '1A0D'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'A12S Communion Tether',
    type: 'Tether',
    netRegex: {
      source: 'Alexander',
      id: '0036'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Puddle Tether on YOU',
        de: 'Flächen-Verbindung auf dir',
        fr: 'Lien Zone au sol sur VOUS',
        ja: '自分に線',
        cn: '放圈连线点名',
        ko: '장판 남기는 선 대상자'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      '(?<! )Alexander(?! )': 'Alexander',
      'Alexander Prime': 'Prim-Alexander',
      'Judgment Crystal': 'Urteilskristall',
      'The General\'s Might': 'Arrhidaios (?:der|die|das) Stark(?:e|er|es|en)',
      'The General\'s Time': 'Arrhidaios (?:der|die|das) Kolossal(?:e|er|es|en)',
      'The General\'s Wing': 'Arrhidaios (?:der|die|das) Überwältigend(?:e|er|es|en)'
    },
    'replaceText': {
      '(?<! )Sacrament': 'Sakrament',
      '\\(Radiant\\?\\) Sacrament': '(Brennendes?) Sakrament',
      'Almost Holy': 'Semi-Sanctus',
      'Arrhidaeus\'s Lanner': 'Arrhidaios der Bote',
      'Blazing Scourge': 'Peitschendes Licht',
      'Chastening Heat': 'Brennende Verdammung',
      'Chronofoil': 'Zeitschwingen',
      'Communion': 'Kommunion',
      'Confession': 'Bekenntnis',
      'Divine Judgment': 'Göttliches Urteil',
      'Divine Spear': 'Heiliger Speer',
      'Gravitational Anomaly': 'Gravitationsanomalie',
      'Half Gravity': 'Semi-Gravitas',
      'Holy Bleed': 'Sanctus-Einschlag',
      'Holy Scourge': 'Peitschende Gloriole',
      'Inception': 'Raumzeit-Eingriff',
      'Incinerating Heat': 'Sengende Hitze',
      'Judgment Crystal': 'Urteilskristall',
      'Mega Holy': 'Super-Sanctus',
      'Punishing Heat': 'Brennendes Urteil',
      'Radiant Sacrament': 'Brennendes Sakrament',
      'Smash': 'Schmettern',
      'Summon Alexander': 'Alexanders Beschwörung',
      'Temporal Stasis': 'Zeitstillstand',
      'Tetrashatter': 'Kristallbruch',
      'The General\'s Might': 'Arrhidaios der Starke',
      'The General\'s Time': 'Arrhidaios der Kolossale',
      'The General\'s Wing': 'Arrhidaios der Überwältigende',
      'Void Of Repentance': 'Kammer der Buße',
      'timegate(?!s)': 'Zeittor',
      'timegates active': 'Zeittore Aktiv',
      'timestop': 'Zeitstopp'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '(?<! )Alexander(?! )': 'Alexander',
      'Alexander Prime': 'Primo-Alexander',
      'Judgment Crystal': 'Cristal du jugement',
      'The General\'s Might': 'Pouvoir d\'Arrhabée',
      'The General\'s Time': 'Temps d\'Arrhabée',
      'The General\'s Wing': 'Aile d\'Arrhabée'
    },
    'replaceText': {
      '\\(W\\)': '(O)',
      '(?<! )Sacrament': 'Sacrement',
      '--timestop--': '--arrêt du temps--',
      '\\(Radiant\\?\\) Sacrament': 'Sacrement (rayonnant ?)',
      'Almost Holy(?!\\?)': 'Quasi-Miracle',
      'Almost Holy\\?': 'Quasi-Miracle ?',
      'Arrhidaeus\'s Lanner': 'Messager d\'Arrhabée',
      'Blazing Scourge': 'Lumière fustigeante',
      'Chastening Heat': 'Chaleur de l\'ordalie',
      'Chronofoil': 'Ailes du temps',
      'Communion': 'Communion',
      'Confession': 'Confession',
      'Divine Judgment': 'Jugement divin',
      'Divine Spear': 'Épieu divin',
      'Gravitational Anomaly': 'Anomalie gravitationnelle',
      'Half Gravity': 'Demi-Pesanteur',
      'Holy Bleed': 'Impact miraculeux',
      'Holy Scourge': 'Lumière fustigeante',
      'Inception': 'Commencement',
      'Incinerating Heat': 'Chaleur purifiante',
      'Judgment Crystal': 'Cristal du jugement',
      'Mega Holy': 'Méga Miracle',
      'Punishing Heat': 'Chaleur punitive',
      'Radiant Sacrament': 'Sacrement rayonnant',
      'Smash': 'Fracassement',
      'Summon Alexander': 'Invocation d\'Alexander',
      'Temporal Stasis': 'Stase temporelle',
      'Tetrashatter': 'Rupture',
      'The General\'s Might': 'Pouvoir d\'Arrhabée',
      'The General\'s Time': 'Temps d\'Arrhabée',
      'The General\'s Wing': 'Aile d\'Arrhabée',
      'timegate': 'Porte temporelle',
      'Void Of Repentance': 'Vide du repentir'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '(?<! )Alexander(?! )': 'アレキサンダー',
      'Alexander Prime': 'アレキサンダー・プライム',
      'Judgment Crystal': '審判の結晶',
      'The General\'s Might': 'アリダイオス・マイト',
      'The General\'s Time': 'アリダイオス・タイム',
      'The General\'s Wing': 'アリダイオス・ウィング'
    },
    'replaceText': {
      '--timestop--': '--時間停止--',
      '(?<! )Sacrament': '十字の秘蹟',
      'Almost Holy': 'プチホーリー',
      'Arrhidaeus\'s Lanner': 'アリダイオス・ランナー',
      'Blazing Scourge': '白光の鞭',
      'Chastening Heat': '神罰の熱線',
      'Chronofoil': '時の翼',
      'Communion': 'コミュニオン',
      'Confession': '強制告解',
      'Divine Judgment': '聖なる審判',
      'Divine Spear': '聖なる炎',
      'Gravitational Anomaly': '重力異常',
      'Half Gravity': 'プチグラビデ',
      'Holy Bleed': 'ホーリーバースト',
      'Holy Scourge': '聖光の鞭',
      'Inception': '時空潜行',
      'Incinerating Heat': '浄化の熱線',
      'Judgment Crystal': '審判の結晶',
      'Mega Holy': 'メガホーリー',
      'Punishing Heat': '懲罰の熱線',
      'Radiant Sacrament': '拝火の秘蹟',
      '\\(Radiant\\?\\) Sacrament': '十字/拝火の秘蹟',
      'Smash': 'スマッシュ',
      'Summon Alexander': 'アレキサンダー召喚',
      'Temporal Stasis': '時間停止',
      'Tetrashatter': '結晶破裂',
      'The General\'s Might': 'アリダイオス・マイト',
      'The General\'s Time': 'アリダイオス・タイム',
      'The General\'s Wing': 'アリダイオス・ウィング',
      'timegate(?!s)': 'タイムゲート',
      'timegates active': 'タイムゲート起動',
      'Void Of Repentance': '懺悔の間'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '(?<! )Alexander(?! )': '亚历山大',
      'Alexander Prime': '至尊亚历山大',
      'Judgment Crystal': '审判结晶',
      'The General\'s Might': '阿里达乌斯之力',
      'The General\'s Time': '阿里达乌斯之时',
      'The General\'s Wing': '阿里达乌斯之翼'
    },
    'replaceText': {
      '(?<!Radiant )Sacrament': '十字圣礼',
      'Almost Holy': '小神圣',
      'Arrhidaeus\'s Lanner': '阿里达乌斯之速',
      'Blazing Scourge': '白光之鞭',
      'Chastening Heat': '神罚射线',
      'Chronofoil': '光阴之翼',
      'Communion': '圣餐',
      'Confession': '强制告解',
      'Divine Judgment': '神圣审判',
      'Divine Spear': '圣炎',
      'Gravitational Anomaly': '重力异常',
      'Half Gravity': '小重力',
      'Holy Bleed': '神圣爆发',
      'Holy Scourge': '圣光之鞭',
      'Inception': '时空潜行',
      'Incinerating Heat': '净化射线',
      'Judgment Crystal': '审判结晶',
      'Mega Holy': '百万神圣',
      'Punishing Heat': '惩戒射线',
      'Radiant Sacrament': '拜火圣礼',
      'Smash': '碎击斩',
      'Summon Alexander': '召唤亚历山大',
      'Temporal Stasis': '时间停止',
      'Tetrashatter': '结晶破碎',
      'The General\'s Might': '阿里达乌斯之力',
      'The General\'s Time': '阿里达乌斯之时',
      'The General\'s Wing': '阿里达乌斯之翼',
      'Void Of Repentance': '忏悔区',
      'timegate(?!s)': '时空门',
      'timegates active': '时空门激活',
      'timestop': '时停'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '(?<! )Alexander(?! )': '알렉산더',
      'Alexander Prime': '알렉산더 프라임',
      'Judgment Crystal': '심판의 결정체',
      'The General\'s Might': '아리다이오스의 권력',
      'The General\'s Time': '아리다이오스의 시간',
      'The General\'s Wing': '아리다이오스의 날개'
    },
    'replaceText': {
      '\\(Radiant\\?\\) Sacrament': '원형/십자 성례',
      '(?<! )Sacrament': '십자 성례',
      'Almost Holy': '프티 홀리',
      'Arrhidaeus\'s Lanner': '아리다이오스의 전령',
      'Blazing Scourge': '백광의 채찍',
      'Chastening Heat': '신벌의 열선',
      'Chronofoil': '시간의 날개',
      'Communion': '성체 배령',
      'Confession': '강제 고해',
      'Divine Judgment': '신성한 심판',
      'Divine Spear': '신성한 불꽃',
      'Gravitational Anomaly': '중력 이상',
      'Half Gravity': '프티 그라비데',
      'Holy Bleed': '성스러운 폭발',
      'Holy Scourge': '성광의 채찍',
      'Inception': '시공 잠행',
      'Incinerating Heat': '정화의 열선',
      'Judgment Crystal': '심판의 결정체',
      'Mega Holy': '메가 홀리',
      'Punishing Heat': '징벌의 열선',
      'Radiant Sacrament': '원형 성례',
      'Smash': '박살',
      'Summon Alexander': '알렉산더 소환',
      'Temporal Stasis': '시간 정지',
      'Tetrashatter': '결정체 파열',
      'The General\'s Might': '아리다이오스의 권력',
      'The General\'s Time': '아리다이오스의 시간',
      'The General\'s Wing': '아리다이오스의 날개',
      'Void Of Repentance': '참회의 방',
      'timegate(?!s)': '시간 차원문',
      'timegates active': '시간 차원문 활성화',
      'timestop': '시간 정지'
    }
  }]
};
/* harmony default export */ const a12s = (a12s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a12s.txt
const raid_a12s_namespaceObject = "### A12S\r\n# Alexander - The Soul of the Creator (Savage)\r\n# http://clees.me/guides/a12s/\r\n# -p 19E8:7 19F7:116.7 19F3:150.4 1A18:265.5\r\n# -ii 19E7 19F0 19F8 19F4 19F6 1A05 1A02 19EC 19FE 19FF 19FC 1A14 1A0F 1A0C\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.0 \"Divine Spear\" Ability { id: \"19E8\", source: \"Alexander Prime\" } window 7,10\r\n14.1 \"Punishing Heat\" Ability { id: \"19E9\", source: \"Alexander Prime\" }\r\n17.3 \"Divine Spear\" Ability { id: \"19E8\", source: \"Alexander Prime\" }\r\n23.4 \"Blazing Scourge\" Ability { id: \"19EF\", source: \"Alexander Prime\" } duration 6.3\r\n30.5 \"Incinerating Heat\" Ability { id: \"19EA\", source: \"Alexander Prime\" }\r\n35.7 \"Mega Holy\" Ability { id: \"19EE\", source: \"Alexander Prime\" }\r\n40.8 \"Mega Holy\" Ability { id: \"19EE\", source: \"Alexander Prime\" }\r\n45.9 \"--sync--\" Ability { id: \"19F1\", source: \"Alexander Prime\" }\r\n51.9 \"Gravitational Anomaly\" Ability { id: \"19F2\", source: \"Alexander Prime\" }\r\n54.0 \"(Radiant?) Sacrament\" Ability { id: \"19E[BD]\", source: \"Alexander Prime\" }\r\n58.1 \"Divine Spear\" Ability { id: \"19E8\", source: \"Alexander Prime\" }\r\n65.2 \"Punishing Heat\" Ability { id: \"19E9\", source: \"Alexander Prime\" }\r\n67.2 \"--untargetable--\" NameToggle { name: \"Alexander Prime\", toggle: \"00\" } window 70,5\r\n\r\n\r\n### Phase 2: Adds Phase (79% push)\r\n70.4 \"--targetable--\"\r\n70.4 \"Arrhidaeus's Lanner x8\"\r\n\r\n105.5 \"The General's Wing x4\"\r\n113.7 \"--sync--\" StartsUsing { id: \"19F7\", source: \"The General's Wing\" } window 114,3\r\n116.7 \"Almost Holy\" Ability { id: \"19F7\", source: \"The General's Wing\" }\r\n124.9 \"Almost Holy\" Ability { id: \"19F7\", source: \"The General's Wing\" }\r\n133.2 \"Almost Holy\" Ability { id: \"19F7\", source: \"The General's Wing\" }\r\n\r\n139.2 \"The General's Might (W)\" AddedCombatant { name: \"The General's Might\" } window 150,5\r\n139.2 \"The General's Time (E)\"\r\n141.6 \"Almost Holy?\" Ability { id: \"19F7\", source: \"The General's Wing\" }\r\n150.4 \"Smash\" Ability { id: \"19F3\", source: \"The General's Might\" } window 151,3\r\n154.4 \"Half Gravity\" Ability { id: \"19F5\", source: \"The General's Time\" }\r\n158.7 \"Smash\" Ability { id: \"19F3\", source: \"The General's Might\" }\r\n163.7 \"Half Gravity\" Ability { id: \"19F5\", source: \"The General's Time\" }\r\n167.0 \"Smash\" Ability { id: \"19F3\", source: \"The General's Might\" }\r\n172.9 \"Half Gravity\" Ability { id: \"19F5\", source: \"The General's Time\" }\r\n175.3 \"Smash\" Ability { id: \"19F3\", source: \"The General's Might\" }\r\n182.2 \"Half Gravity\" Ability { id: \"19F5\", source: \"The General's Time\" }\r\n183.6 \"Smash\" Ability { id: \"19F3\", source: \"The General's Might\" }\r\n191.5 \"Half Gravity\" Ability { id: \"19F5\", source: \"The General's Time\" }\r\n191.9 \"Smash\" Ability { id: \"19F3\", source: \"The General's Might\" }\r\n200.2 \"Smash\" Ability { id: \"19F3\", source: \"The General's Might\" }\r\n200.8 \"Half Gravity\" Ability { id: \"19F5\", source: \"The General's Time\" }\r\n208.5 \"Smash\" Ability { id: \"19F3\", source: \"The General's Might\" }\r\n210.1 \"Half Gravity\" Ability { id: \"19F5\", source: \"The General's Time\" }\r\n216.8 \"Smash\" Ability { id: \"19F3\", source: \"The General's Might\" }\r\n219.4 \"Half Gravity\" Ability { id: \"19F5\", source: \"The General's Time\" }\r\n225.1 \"Smash\" Ability { id: \"19F3\", source: \"The General's Might\" }\r\n228.8 \"Half Gravity\" Ability { id: \"19F5\", source: \"The General's Time\" }\r\n233.4 \"Smash\" Ability { id: \"19F3\", source: \"The General's Might\" }\r\n238.1 \"Half Gravity\" Ability { id: \"19F5\", source: \"The General's Time\" }\r\n241.7 \"Smash\" Ability { id: \"19F3\", source: \"The General's Might\" }\r\n247.4 \"Half Gravity\" Ability { id: \"19F5\", source: \"The General's Time\" }\r\n250.0 \"Smash\" Ability { id: \"19F3\", source: \"The General's Might\" }\r\n256.7 \"Half Gravity\" Ability { id: \"19F5\", source: \"The General's Time\" }\r\n258.3 \"Smash\" Ability { id: \"19F3\", source: \"The General's Might\" }\r\n\r\n### Phase 3: Temporal Stasis\r\n265.5 \"--sync--\" Ability { id: \"1A18\", source: \"Alexander\" } window 300,300\r\n275.2 \"Divine Judgment\" Ability { id: \"19F9\", source: \"Alexander\" }\r\n286.0 \"--targetable--\"\r\n289.0 \"Chronofoil\" Ability { id: \"19FA\", source: \"Alexander Prime\" }\r\n\r\n308.1 \"Temporal Stasis\" Ability { id: \"19FB\", source: \"Alexander Prime\" } window 350,10\r\n309.1 \"--timestop--\" duration 9\r\n316.2 \"--sync--\" Ability { id: \"19F1\", source: \"Alexander Prime\" }\r\n322.2 \"Gravitational Anomaly\" Ability { id: \"19F2\", source: \"Alexander Prime\" }\r\n324.3 \"(Radiant?) Sacrament\" Ability { id: \"19E[BD]\", source: \"Alexander Prime\" }\r\n329.4 \"Mega Holy\" Ability { id: \"19EE\", source: \"Alexander Prime\" }\r\n335.6 \"Divine Spear\" Ability { id: \"19E8\", source: \"Alexander Prime\" }\r\n342.7 \"Punishing Heat\" Ability { id: \"19E9\", source: \"Alexander Prime\" }\r\n345.9 \"Divine Spear\" Ability { id: \"19E8\", source: \"Alexander Prime\" }\r\n\r\n361.1 \"Temporal Stasis\" Ability { id: \"19FB\", source: \"Alexander Prime\" } window 30,30\r\n362.1 \"--timestop--\" duration 9\r\n369.2 \"--sync--\" Ability { id: \"19F1\", source: \"Alexander Prime\" }\r\n375.2 \"Gravitational Anomaly\" Ability { id: \"19F2\", source: \"Alexander Prime\" }\r\n377.3 \"(Radiant?) Sacrament\" Ability { id: \"19E[BD]\", source: \"Alexander Prime\" }\r\n382.4 \"Mega Holy\" Ability { id: \"19EE\", source: \"Alexander Prime\" }\r\n388.5 \"Divine Spear\" Ability { id: \"19E8\", source: \"Alexander Prime\" }\r\n395.6 \"Punishing Heat\" Ability { id: \"19E9\", source: \"Alexander Prime\" }\r\n398.8 \"Divine Spear\" Ability { id: \"19E8\", source: \"Alexander Prime\" }\r\n\r\n\r\n### Phase 4: Timegates, Judgment Crystals\r\n# FIXME: Add targetable/untargetable precise times here\r\n409.1 \"Timegate\" Ability { id: \"1A03\", source: \"Alexander Prime\" } window 450,30\r\n# FIXME: make this precise\r\n415.1 \"--timegates active--\"\r\n430.2 \"Judgment Crystal 1\" Ability { id: \"1A04\", source: \"Alexander Prime\" }\r\n443.8 \"Judgment Crystal 2\" Ability { id: \"1A04\", source: \"Alexander Prime\" }\r\n451.9 \"(Radiant?) Sacrament\" Ability { id: \"19E[BD]\", source: \"Alexander Prime\" }\r\n464.6 \"Judgment Crystal 3\" Ability { id: \"1A04\", source: \"Alexander Prime\" }\r\n470.7 \"Punishing Heat\" Ability { id: \"19E9\", source: \"Alexander Prime\" }\r\n484.3 \"Judgment Crystal 4\" Ability { id: \"1A04\", source: \"Alexander Prime\" }\r\n\r\n\r\n### Phase 5: Inception\r\n501.4 \"--untargetable--\"\r\n501.4 \"Inception\" Ability { id: \"1A08\", source: \"Alexander Prime\" } window 540,30\r\n507.6 \"Tetrashatter\" Ability { id: \"1A06\", source: \"Judgment Crystal\" }\r\n508.7 \"--targetable--\"\r\n508.7 \"Sacrament\" Ability { id: \"1A09\", source: \"Alexander Prime\" }\r\n516.8 \"Radiant Sacrament\" Ability { id: \"19ED\", source: \"Alexander Prime\" }\r\n527.9 \"Punishing Heat\" Ability { id: \"19E9\", source: \"Alexander Prime\" }\r\n532.1 \"Divine Spear\" Ability { id: \"19E8\", source: \"Alexander Prime\" }\r\n539.2 \"--sync--\" Ability { id: \"19F1\", source: \"Alexander Prime\" }\r\n545.2 \"Gravitational Anomaly\" Ability { id: \"19F2\", source: \"Alexander Prime\" }\r\n546.4 \"Incinerating Heat\" Ability { id: \"19EA\", source: \"Alexander Prime\" }\r\n\r\n557.6 \"--untargetable--\"\r\n557.6 \"Inception\" Ability { id: \"1A08\", source: \"Alexander Prime\" } window 30,30\r\n563.7 \"Tetrashatter\" Ability { id: \"1A06\", source: \"Judgment Crystal\" }\r\n564.9 \"--targetable--\"\r\n564.9 \"Sacrament\" Ability { id: \"1A09\", source: \"Alexander Prime\" }\r\n573.0 \"Radiant Sacrament\" Ability { id: \"19ED\", source: \"Alexander Prime\" }\r\n584.1 \"Punishing Heat\" Ability { id: \"19E9\", source: \"Alexander Prime\" }\r\n588.3 \"Divine Spear\" Ability { id: \"19E8\", source: \"Alexander Prime\" }\r\n595.4 \"--sync--\" Ability { id: \"19F1\", source: \"Alexander Prime\" }\r\n601.4 \"Gravitational Anomaly\" Ability { id: \"19F2\", source: \"Alexander Prime\" }\r\n602.6 \"Incinerating Heat\" Ability { id: \"19EA\", source: \"Alexander Prime\" }\r\n\r\n\r\n### Phase 6: Voids of Repentence\r\n611.8 \"Summon Alexander\" Ability { id: \"1A0A\", source: \"Alexander Prime\" } window 650,10\r\n620.9 \"Void Of Repentance\" Ability { id: \"1A0E\", source: \"Alexander Prime\" }\r\n632.0 \"Confession 1\" Ability { id: \"1A12\", source: \"Alexander Prime\" } window 2,2\r\n636.0 \"Confession 2\" Ability { id: \"1A12\", source: \"Alexander Prime\" } window 2,2\r\n640.0 \"Confession 3\" Ability { id: \"1A12\", source: \"Alexander Prime\" } window 2,2\r\n643.1 \"Incinerating Heat\" Ability { id: \"19EA\", source: \"Alexander Prime\" } window 30,30\r\n648.9 \"Holy Bleed\" Ability { id: \"1A13\", source: \"Alexander\" }\r\n659.3 \"Holy Scourge x4\" Ability { id: \"1A0B\", source: \"Alexander Prime\" } duration 5.9\r\n667.5 \"Chastening Heat\" Ability { id: \"1A0D\", source: \"Alexander Prime\" }\r\n\r\n# loop until enrage\r\n673.7 \"Void Of Repentance\" Ability { id: \"1A0E\", source: \"Alexander Prime\" }\r\n679.4 \"Communion x6\" Ability { id: \"1A15\", source: \"Alexander\" } duration 13 window 2,2\r\n684.8 \"Confession 1\" Ability { id: \"1A12\", source: \"Alexander Prime\" } window 2,2\r\n686.0 \"Sacrament\" Ability { id: \"19EB\", source: \"Alexander Prime\" }\r\n688.8 \"Confession 2\" Ability { id: \"1A12\", source: \"Alexander Prime\" } window 2,2\r\n692.8 \"Confession 3\" Ability { id: \"1A12\", source: \"Alexander Prime\" } window 2,2\r\n695.9 \"Incinerating Heat\" Ability { id: \"19EA\", source: \"Alexander Prime\" } window 30,30\r\n701.7 \"Holy Bleed\" Ability { id: \"1A13\", source: \"Alexander\" }\r\n712.1 \"Holy Scourge x4\" Ability { id: \"1A0B\", source: \"Alexander Prime\" } duration 5.9\r\n720.3 \"Chastening Heat\" Ability { id: \"1A0D\", source: \"Alexander Prime\" }\r\n\r\n726.5 \"Void Of Repentance\" Ability { id: \"1A0E\", source: \"Alexander Prime\" } window 40,40 jump 673.7\r\n732.2 \"Communion x6\"\r\n737.6 \"Confession 1\"\r\n738.8 \"Sacrament\"\r\n741.6 \"Confession 2\"\r\n745.6 \"Confession 3\"\r\n748.7 \"Incinerating Heat\"\r\n754.5 \"Holy Bleed\"\r\n764.9 \"Holy Scourge x4\"\r\n773.1 \"Chastening Heat\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a1s.ts




const a1s_triggerSet = {
  id: 'AlexanderTheFistOfTheFatherSavage',
  zoneId: zone_id/* default.AlexanderTheFistOfTheFatherSavage */.Z.AlexanderTheFistOfTheFatherSavage,
  timelineFile: 'a1s.txt',
  initData: () => {
    return {
      hydro: [],
      hyper: []
    };
  },
  timelineTriggers: [{
    id: 'A1S Emergency Liftoff',
    regex: /Emergency Liftoff/,
    beforeSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Liftoff Soon',
        de: 'Bald abheben',
        fr: 'Décollage bientôt',
        ja: '緊急上昇',
        cn: '上升',
        ko: '긴급 상승'
      }
    }
  }, {
    id: 'A1S Gunnery Pod',
    regex: /Gunnery Pod/,
    beforeSeconds: 4,
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  triggers: [{
    id: 'A1S Hydrothermal Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    run: (data, matches) => data.hydro.push(matches.target)
  }, {
    id: 'A1S Hydrothermal You',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hydrothermal on You',
        de: 'Hydrothermales auf DIR',
        fr: 'Missile hydrothermique sur Vous',
        ja: '自分に蒸気ミサイル',
        cn: '导弹点名',
        ko: '증기 미사일 대상자'
      }
    }
  }, {
    id: 'A1S Hydrothermal Healer',
    type: 'HeadMarker',
    netRegex: {
      id: '001E',
      capture: false
    },
    suppressSeconds: 2,
    infoText: (data, _matches, output) => {
      if (data.hydro.length === 0) return;
      return output.text({
        players: data.hydro.map(x => data.party.member(x))
      });
    },
    outputStrings: {
      text: {
        en: 'Hydrothermal on ${players}',
        de: 'Hydrothermales auf ${players}',
        fr: 'Missile hydrothermique sur ${players}',
        ja: '${players}に蒸気ミサイル',
        cn: '导弹点${players}',
        ko: '"${players}" 증기 미사일'
      }
    }
  }, {
    id: 'A1S Hydrothermal Cleanup',
    type: 'HeadMarker',
    netRegex: {
      id: '001E',
      capture: false
    },
    delaySeconds: 10,
    run: data => data.hydro = []
  }, {
    id: 'A1S Resin Bomb',
    type: 'StartsUsing',
    netRegex: {
      id: 'E46',
      source: 'Oppressor',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Resin Bomb',
        de: 'Köder Pechbombe',
        fr: 'Attirez Bombe de résine',
        ja: '粘着弾',
        cn: '粘着弹',
        ko: '점착탄'
      }
    }
  }, {
    id: 'A1S Hypercompressed Collect',
    type: 'StartsUsing',
    netRegex: {
      id: 'E4A',
      source: ['Oppressor', 'Oppressor 0\\.5']
    },
    run: (data, matches) => data.hyper.push(matches.target)
  }, {
    id: 'A1S Hypercompressed You',
    type: 'StartsUsing',
    netRegex: {
      id: 'E4A',
      source: ['Oppressor', 'Oppressor 0\\.5']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 2,
    response: responses/* Responses.tankBuster */.n3.tankBuster('alarm')
  }, {
    id: 'A1S Hypercompressed Other',
    type: 'StartsUsing',
    netRegex: {
      id: 'E4A',
      source: ['Oppressor', 'Oppressor 0\\.5'],
      capture: false
    },
    delaySeconds: 0.3,
    suppressSeconds: 2,
    alertText: (data, _matches, output) => {
      if (data.hyper.includes(data.me)) return;
      return output.text();
    },
    outputStrings: {
      text: outputs/* default.tankBusters */.Z.tankBusters
    }
  }, {
    id: 'A1S Hypercompressed Delete',
    type: 'StartsUsing',
    netRegex: {
      id: 'E4A',
      source: ['Oppressor', 'Oppressor 0\\.5'],
      capture: false
    },
    delaySeconds: 10,
    run: data => data.hyper = []
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      '3000-Tonze Missile': '3000-Tonzen-Geschoss',
      'Faust': 'Faust',
      'Hangar 8': 'Lagerhalle 8',
      'Machinery Bay 44': 'Kampfmaschinen-Baracke 44',
      'Oppressor(?! 0)': 'Unterdrücker',
      'Oppressor 0\\\\.5': 'Unterdrücker 0,5'
    },
    'replaceText': {
      '3000-Tonze Missile': '3000-Tonzen-Geschoss',
      'Distress Beacon': 'Notsignal',
      'Emergency Deployment': 'Noteinsatz',
      'Emergency Liftoff': 'Notstart',
      'Gunnery Pod': 'Waffenbehälter',
      'Hydrothermal Missile': 'Hydrothermales Geschoss',
      'Hypercompressed Plasma': 'Hyperkomprimiertes Plasma',
      'Kaltstrahl': 'Kaltstrahl',
      'Missile Impact': 'Raketenangriff',
      'Photon Spaser': 'Plasmonen-Spaser',
      'Pressure Increase': 'Druckanstieg',
      'Quick Landing': 'Schnelle Landung',
      'Resin Bomb': 'Pechbombe',
      'Royal Fount': 'Königsquelle',
      'Self-Destruct': 'Selbstzerstörung',
      'Sturm Doll': 'Sturmpuppe'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '3000-Tonze Missile': 'Missile de 3000 tonz',
      'Faust': 'Faust',
      'Hangar 8': 'grand hangar GH-8',
      'Machinery Bay 44': 'hangar d\'armement HA-44',
      'Oppressor(?! 0)': 'Oppresseur',
      'Oppressor 0\\\\.5': 'Oppresseur 0\\.5'
    },
    'replaceText': {
      '3000-Tonze Missile': 'Missile de 3000 tonz',
      'Distress Beacon': 'Fanal de détresse',
      'Emergency Deployment': 'Déploiement d\'urgence',
      'Emergency Liftoff': 'Décollage d\'urgence',
      'Gunnery Pod': 'Feu d\'artillerie',
      'Hydrothermal Missile': 'Missile hydrothermique',
      'Hypercompressed Plasma': 'Plasma hypercomprimé',
      'Kaltstrahl': 'Kaltstrahl',
      'Missile Impact': 'Frappe de missile',
      'Photon Spaser': 'Spaser à photons',
      'Pressure Increase': 'Hausse de pression',
      'Quick Landing': 'Atterrissage rapide',
      'Resin Bomb': 'Bombe de résine',
      'Royal Fount': 'Source royale',
      'Self-Destruct': 'Auto-destruction',
      'Sturm Doll Add': 'Add Poupée sturm'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '3000-Tonze Missile': '超大型ミサイル',
      'Faust': 'ファウスト',
      'Hangar 8': '第8大型格納庫',
      'Machinery Bay 44': '第44機工兵格納庫',
      'Oppressor(?! 0)': 'オプレッサー',
      'Oppressor 0\\\\.5': 'オプレッサー・ゼロ'
    },
    'replaceText': {
      '3000-Tonze Missile': '超大型ミサイル',
      'Distress Beacon': '救援要請',
      'Emergency Deployment': '緊急出撃',
      'Emergency Liftoff': '緊急上昇',
      'Gunnery Pod': 'ガンポッドファイア',
      'Hydrothermal Missile': '蒸気ミサイル',
      'Hypercompressed Plasma': 'ハイパープラズマ',
      'Kaltstrahl': 'カルトシュトラール',
      'Missile Impact': 'ミサイル攻撃',
      'Photon Spaser': 'フォトンスペーサー',
      'Pressure Increase': '蒸気圧上昇',
      'Quick Landing': '落着',
      'Resin Bomb': '粘着弾',
      'Royal Fount': 'ロイヤルファウント',
      'Self-Destruct': '自爆',
      'Sturm Doll Add': '雑魚: シュツルムドール'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '3000-Tonze Missile': '超大型导弹',
      'Faust': '浮士德',
      'Hangar 8': '第8大型机库',
      'Machinery Bay 44': '第44机工兵仓库',
      'Oppressor(?! 0)': '压迫者',
      'Oppressor 0\\\\.5': '压迫者零号'
    },
    'replaceText': {
      '3000-Tonze Missile': '超大型导弹',
      'Distress Beacon': '请求救援',
      'Emergency Deployment': '紧急出击',
      'Emergency Liftoff': '紧急上升',
      'Gunnery Pod': '炮台散射',
      'Hydrothermal Missile': '蒸汽导弹',
      'Hypercompressed Plasma': '超压缩等离子',
      'Kaltstrahl': '寒光',
      'Missile Impact': '导弹攻击',
      'Photon Spaser': '光子照射',
      'Pressure Increase': '蒸汽压上升',
      'Quick Landing': '落地',
      'Resin Bomb': '粘着弹',
      'Royal Fount': '皇泉射线',
      'Self-Destruct': '自爆',
      'Sturm Doll': '风暴人偶'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '3000-Tonze Missile': '초대형 미사일',
      'Faust': '파우스트',
      'Hangar 8': '제8 대형 격납고',
      'Machinery Bay 44': '제44 기공병 격납고',
      'Oppressor(?! 0)': '억압자',
      'Oppressor 0\\\\.5': '미완성 억압자'
    },
    'replaceText': {
      '3000-Tonze Missile': '초대형 미사일',
      'Distress Beacon': '구원 요청',
      'Emergency Deployment': '긴급 출격',
      'Emergency Liftoff': '긴급 상승',
      'Gunnery Pod': '기관총 발사',
      'Hydrothermal Missile': '증기 미사일',
      'Hypercompressed Plasma': '초플라스마',
      'Kaltstrahl': '냉병기 공격',
      'Missile Impact': '미사일 공격',
      'Photon Spaser': '광자포',
      'Pressure Increase': '증기압 상승',
      'Quick Landing': '경착륙',
      'Resin Bomb': '점착탄',
      'Royal Fount': '과열 분사',
      'Self-Destruct': '자폭',
      'Sturm Doll': '인형 폭기병'
    }
  }]
};
/* harmony default export */ const a1s = (a1s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a1s.txt
const raid_a1s_namespaceObject = "### A1S\r\n# Alexander - The Fist of the Father (Savage)\r\n\r\n# Note: Use zone seal message instead of 0x104 line to start timeline\r\n# as there are pre-boss adds to start the encounter.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Faust\r\n# -p E3C:1006 -ii E3E\r\n# Machinery Bay 44 will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"65F\" } window 1000,0\r\n1006.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" } window 1006,5\r\n1009.7 \"Sturm Doll Add\"\r\n1016.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" }\r\n1019.0 \"Pressure Increase 1\" Ability { id: \"E3D\", source: \"Faust\" }\r\n1026.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" }\r\n1029.7 \"Sturm Doll Add\"\r\n1036.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" }\r\n1039.0 \"Pressure Increase 2\" Ability { id: \"E3D\", source: \"Faust\" }\r\n1046.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" }\r\n1049.7 \"Sturm Doll Add\"\r\n1056.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" }\r\n1059.0 \"Pressure Increase 3\" Ability { id: \"E3D\", source: \"Faust\" }\r\n1066.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" }\r\n1069.7 \"Sturm Doll Add\"\r\n1076.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" }\r\n1079.0 \"Pressure Increase 4\" Ability { id: \"E3D\", source: \"Faust\" }\r\n1086.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" }\r\n1089.7 \"Sturm Doll Add\"\r\n1096.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" }\r\n1099.0 \"Pressure Increase 5\" Ability { id: \"E3D\", source: \"Faust\" }\r\n1106.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" }\r\n1109.7 \"Sturm Doll Add\"\r\n1116.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" }\r\n1119.0 \"Pressure Increase 6\" Ability { id: \"E3D\", source: \"Faust\" }\r\n1126.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" }\r\n1129.7 \"Sturm Doll Add\"\r\n1136.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" }\r\n1139.0 \"Pressure Increase 7\" Ability { id: \"E3D\", source: \"Faust\" }\r\n1146.0 \"Kaltstrahl\" Ability { id: \"E3C\", source: \"Faust\" }\r\n1149.7 \"Sturm Doll Add\"\r\n1152.0 \"Pressure Increase 16\" Ability { id: \"E7E\", source: \"Faust\" }\r\n1159.0 \"Kaltstrahl Enrage\" Ability { id: \"E7D\", source: \"Faust\" }\r\n1164.0 \"Kaltstrahl Enrage\" Ability { id: \"E7D\", source: \"Faust\" }\r\n# etc\r\n\r\n\r\n### Oppressor and a half\r\n# -p E40:2007\r\n# -ii E44 E53 E50 E4C E54 E47\r\n# -ic \"Oppressor 0.5\"\r\n\r\n# Hangar 8 will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"660\" } window 2000,0\r\n2007.0 \"Royal Fount\" Ability { id: \"E40\", source: \"Oppressor\" } window 2010,5\r\n2011.1 \"Gunnery Pod\" Ability { id: \"E41\", source: \"Oppressor\" }\r\n2016.2 \"Hydrothermal Missile\" Ability { id: \"E43\", source: \"Oppressor\" } duration 8\r\n2018.3 \"Gunnery Pod\" Ability { id: \"E41\", source: \"Oppressor\" }\r\n2024.1 \"Photon Spaser\" Ability { id: \"E42\", source: \"Oppressor\" }\r\n2028.2 \"Royal Fount\" Ability { id: \"E40\", source: \"Oppressor\" }\r\n2036.3 \"Resin Bomb\" Ability { id: \"E46\", source: \"Oppressor\" }\r\n2038.4 \"Royal Fount\" Ability { id: \"E40\", source: \"Oppressor\" }\r\n2044.2 \"Photon Spaser\" Ability { id: \"E42\", source: \"Oppressor\" }\r\n2046.3 \"Gunnery Pod\" Ability { id: \"E41\", source: \"Oppressor\" }\r\n2049.1 \"Royal Fount\" Ability { id: \"E40\", source: \"Oppressor\" }\r\n2054.2 \"Emergency Deployment\" Ability { id: \"E45\", source: \"Oppressor\" }\r\n2054.5 \"--targetable--\"\r\n2061.3 \"Hydrothermal Missile\" Ability { id: \"E43\", source: \"Oppressor\" } duration 8\r\n2063.4 \"Gunnery Pod\" Ability { id: \"E41\", source: \"Oppressor\" }\r\n2066.5 \"Royal Fount\" Ability { id: \"E40\", source: \"Oppressor\" }\r\n2069.6 \"Gunnery Pod\" Ability { id: \"E41\", source: \"Oppressor\" }\r\n2075.2 \"Photon Spaser\" Ability { id: \"E42\", source: \"Oppressor\" }\r\n2077.3 \"Gunnery Pod\" #Ability { id: \"E41\", source: \"Oppressor\" }\r\n2079.4 \"Gunnery Pod\" #Ability { id: \"E41\", source: \"Oppressor\" }\r\n2083.5 \"Royal Fount\" Ability { id: \"E40\", source: \"Oppressor\" }\r\n2085.6 \"Distress Beacon\" Ability { id: \"E48\", source: \"Oppressor\" }\r\n2096.3 \"--targetable--\"\r\n\r\n2106.4 \"3000-Tonze Missile\" Ability { id: \"E4B\", source: \"Oppressor\" }\r\n2112.6 \"Gunnery Pod\" Ability { id: \"E41\", source: \"Oppressor\" }\r\n2117.7 \"Emergency Deployment\" Ability { id: \"E45\", source: \"Oppressor\" }\r\n2118.0 \"--targetable--\"\r\n2125.8 \"Resin Bomb\" Ability { id: \"E46\", source: \"Oppressor\" }\r\n2128.0 \"Royal Fount\" Ability { id: \"E40\", source: \"Oppressor\" }\r\n2133.7 \"Photon Spaser\" Ability { id: \"E42\", source: \"Oppressor\" }\r\n2136.9 \"Gunnery Pod\" Ability { id: \"E41\", source: \"Oppressor\" }\r\n2143.0 \"Hydrothermal Missile\" Ability { id: \"E43\", source: \"Oppressor\" }\r\n2148.2 \"Royal Fount\" Ability { id: \"E40\", source: \"Oppressor\" }\r\n2156.3 \"Hypercompressed Plasma\" Ability { id: \"E4A\", source: \"Oppressor\" }\r\n2159.9 \"Missile Impact\" #Ability { id: \"E4[DE]\", source: \"3000-Tonze Missile\" }\r\n\r\n2166.5 \"Photon Spaser\" Ability { id: \"E42\", source: \"Oppressor\" }\r\n2173.7 \"Gunnery Pod\" Ability { id: \"E41\", source: \"Oppressor\" }\r\n2182.8 \"Royal Fount\" Ability { id: \"E40\", source: \"Oppressor\" }\r\n2188.9 \"--untargetable--\"\r\n2189.0 \"Emergency Liftoff\" Ability { id: \"E4F\", source: \"Oppressor\" }\r\n2203.7 \"Resin Bomb 1\" #Ability { id: \"E52\", source: \"Oppressor 0.5\" }\r\n2204.7 \"Resin Bomb 2\" #Ability { id: \"E52\", source: \"Oppressor\" }\r\n2205.7 \"Resin Bomb 3\" #Ability { id: \"E52\", source: \"Oppressor\" }\r\n2206.7 \"Resin Bomb 4\" #Ability { id: \"E52\", source: \"Oppressor 0.5\" }\r\n2207.7 \"Resin Bomb 5\" #Ability { id: \"E52\", source: \"Oppressor\" }\r\n2208.7 \"Resin Bomb 6\" #Ability { id: \"E52\", source: \"Oppressor\" }\r\n2209.7 \"Resin Bomb 7\" #Ability { id: \"E52\", source: \"Oppressor 0.5\" }\r\n2210.7 \"Resin Bomb 8\" #Ability { id: \"E52\", source: \"Oppressor 0.5\" }\r\n2210.7 \"Quick Landing\" Ability { id: \"E51\", source: \"Oppressor\" }\r\n\r\n2215.8 \"--targetable--\"\r\n2226.7 \"3000-Tonze Missile\" Ability { id: \"E4B\", source: \"Oppressor\" } window 100,100 jump 2106.4\r\n2232.9 \"Gunnery Pod\"\r\n2238.0 \"Emergency Deployment\"\r\n2238.3 \"--targetable--\"\r\n2246.1 \"Resin Bomb\"\r\n2248.3 \"Royal Fount\"\r\n2254.0 \"Photon Spaser\"\r\n2257.2 \"Gunnery Pod\"\r\n2263.3 \"Hydrothermal Missile\"\r\n2268.5 \"Royal Fount\"\r\n2276.6 \"Hypercompressed Plasma\"\r\n2280.2 \"Missile Impact\"\r\n\r\n\r\n\r\n## Enrage\r\n3000.0 \"--sync--\" StartsUsing { id: \"E49\", source: \"Oppressor\" } window 3000,0\r\n3000.0 \"--sync--\" StartsUsing { id: \"E49\", source: \"Oppressor 0\\\\.5\" } window 3000,0\r\n3010.0 \"Self-Destruct Enrage\" Ability { id: \"E49\", source: \"Oppressor\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a2s.ts


// TODO: could consider keeping track of the gobbie driver?
// Nothing in the logs for when you get in, other than removing combatanat.
// FDE, FDF, FE0, FE1 are all skills you use when inside.
// 12C0, FE2 are exploding it and getting out.
// There aren't many triggers, so maybe worth just keeping the global callouts
// for bombs and stuns.
const a2s_triggerSet = {
  id: 'AlexanderTheCuffOfTheFatherSavage',
  zoneId: zone_id/* default.AlexanderTheCuffOfTheFatherSavage */.Z.AlexanderTheCuffOfTheFatherSavage,
  timelineFile: 'a2s.txt',
  timelineTriggers: [{
    id: 'A2S Breakblock',
    regex: /(?:Brainhurt|Bodyhurt) Breakblock/,
    beforeSeconds: 10,
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stun Soon',
        de: 'Bald unterbrechen',
        fr: 'Étourdissez bientôt',
        ja: 'まもなくスタン',
        cn: '马上眩晕',
        ko: '곧 기절'
      }
    }
  }],
  triggers: [{
    id: 'A2S Bomb',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Bomb',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bomb',
        de: 'Bombe',
        fr: 'Bombe',
        ja: '爆弾',
        cn: '炸弹出现',
        ko: '폭탄'
      }
    }
  }, {
    id: 'A2S Prey',
    type: 'Ability',
    netRegex: {
      source: 'Magitek Gobwidow G-IX',
      id: '1413'
    },
    condition: data => data.role === 'healer' || data.job === 'BLU',
    suppressSeconds: 10,
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.target)
    }),
    outputStrings: {
      text: {
        en: 'Keep ${player} topped',
        de: 'Halte HP von ${player} oben',
        fr: 'Maintenez ${player} Max PV',
        ja: '${player}のHPを満タンに保つ',
        cn: '保持${player}满血',
        ko: '"${player}" 풀피 유지'
      }
    }
  }, {
    id: 'A2S Prey You',
    type: 'Ability',
    netRegex: {
      source: 'Magitek Gobwidow G-IX',
      id: '1413'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Boomcannon on YOU',
        de: 'Großeknall auf DIR',
        fr: 'Double cannon sur VOUS',
        ja: '自分にブームカノン',
        cn: '死刑点名',
        ko: '우레 포격 대상자'
      }
    }
  }, {
    id: 'A2S Soldier Spawn',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Gordian Soldier',
      capture: false
    },
    run: data => delete data.bangyzoom
  }, {
    id: 'A2S Bangyzoom',
    type: 'Ability',
    netRegex: {
      id: 'FD9',
      target: 'Gordian Soldier',
      capture: false
    },
    condition: data => !data.bangyzoom,
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.bangyzoom = true,
    outputStrings: {
      text: {
        en: 'Stun Soldier',
        de: 'unterbreche Soldat',
        fr: 'Étourdissez le soldat',
        ja: 'スタン：ソルジャー',
        cn: '眩晕士兵',
        ko: '병사 기절시키기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Boomtype Magitek Gobwalker G-VII': 'Gobumm-Stampfer VII',
      'Giant Bomb': 'Trumpfbombe',
      'Gordian Hardhelm': 'Gordios-Harthelm',
      'Gordian Hardmind': 'Gordios-Sturschale',
      'Gordian Sniper': 'Indigohand-Scharfschütze',
      'Gordian Soldier': 'Gordios-Soldat',
      'Hangar 12': 'Lagerhalle 12',
      'Jagd Doll': 'Jagdpuppe',
      'King Gobtank G-IV': 'Königs-Gobmaschine IV',
      'Magitek Gobwidow G-IX': 'Gob-Witwe IX',
      '(?<!Giant )Bomb(?!e)': 'Bombe'
    },
    'replaceText': {
      'Blitzstrahl': 'Blitzstrahl',
      'Bodyhurt Breakblock': 'Dickewand für Großeschmerz',
      'Boomcannon': 'Großeknall',
      'Brainhurt Breakblock': 'Dickewand für Zaubernschmerz',
      'Carpet Bomb': 'Flächenbombardement',
      'Explosion': 'Explosion',
      'Gobwalker': 'Gob-Stampfer',
      'Gobwidow': 'Gob-Witwe',
      'Hardhelm': 'Harthelm',
      'Hardmind': 'Sturschale',
      'Jagd Doll': 'Jagdpuppe',
      'Kaltstrahl': 'Kaltstrahl',
      'Massive Explosion': 'Detonation',
      'Sniper': 'Scharfschütze',
      'Soldier': 'Soldat',
      'Wave': 'Welle',
      'mid': 'Mitte'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '(?<!Giant )Bomb(?!e)': 'Bombe',
      'Boomtype Magitek Gobwalker G-VII': 'gobblindé magitek G-VII Boumbardier',
      'Giant Bomb': 'Bombe géante',
      'Gordian Hardhelm': 'Casque-dur gordien',
      'Gordian Hardmind': 'Cerveau-dur gordien',
      'Gordian Sniper': 'Sniper gordien',
      'Gordian Soldier': 'Soldat gordien',
      'Hangar 12': 'grand hangar GH-12',
      'Jagd Doll': 'Poupée jagd',
      'King Gobtank G-IV': 'Gobtank G-IV Roi',
      'Magitek Gobwidow G-IX': 'Gobmygale magitek G-IX'
    },
    'replaceText': {
      '\\(NW\\)': '(NO)',
      '\\(mid\\)': '(milieu)',
      '\\(SW\\)': '(SO)',
      'Blitzstrahl': 'Blitzstrahl',
      'Bodyhurt Breakblock': 'Blindage corporel',
      'Boomcannon': 'Double canon',
      'Brainhurt Breakblock': 'Blindage spirituel',
      'Carpet Bomb': 'Tapis de bombes',
      'Explosion': 'Explosion',
      'Gobwalker': 'Gobblindé',
      'Gobwidow': 'Gobmygale',
      'Hardhelm': 'Casque-dur',
      'Hardmind': 'Cerveau-dur',
      'Jagd Doll': 'Poupée jagd',
      'Kaltstrahl': 'Kaltstrahl',
      'Massive Explosion': 'Explosion massive',
      'Sniper': 'Sniper',
      'Soldier': 'Soldat',
      'Wave': 'Vague'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Boomtype Magitek Gobwalker G-VII': 'VII号ゴブリウォーカーB型',
      'Giant Bomb': '切り札',
      'Gordian Hardhelm': 'ゴルディオス・ハードヘルム',
      'Gordian Hardmind': 'ゴルディオス・ハードマインド',
      'Gordian Sniper': 'ゴルディオス・スナイパー',
      'Gordian Soldier': 'ゴルディオス・ソルジャー',
      'Hangar 12': '第12大型格納庫',
      'Jagd Doll': 'ヤークトドール',
      'King Gobtank G-IV': 'IV号キング・ゴブリタンク',
      'Magitek Gobwidow G-IX': 'IX号ゴブリウィドー',
      '(?<!Giant )Bomb(?!e)': '爆弾'
    },
    'replaceText': {
      'Blitzstrahl': 'ブリッツシュトラール',
      'Bodyhurt Breakblock': 'ボディブレイクブロック',
      'Boomcannon': 'ブームカノン',
      'Brainhurt Breakblock': 'ブレインブレイクブロック',
      'Carpet Bomb': '絨毯爆撃',
      '(?<!Massive )Explosion': '爆発',
      'Gobwalker': 'ゴブリウォーカー',
      'Gobwidow': 'ゴブリウィドー',
      'Hardhelm': 'ハードヘルム',
      'Hardmind': 'ハードマインド',
      'Jagd Doll': 'ヤークトドール',
      'Kaltstrahl': 'カルトシュトラール',
      'Massive Explosion': '大爆発',
      'Sniper': 'スナイパー',
      'Soldier': 'ソルジャー',
      'Wave': 'ウェイヴ',
      '\\(mid\\)': '(中央)'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Boomtype Magitek Gobwalker G-VII': '爆破型7号哥布林战车',
      'Giant Bomb': '最终炸弹',
      'Gordian Hardhelm': '戈耳狄硬盔兵',
      'Gordian Hardmind': '戈耳狄铁心兵',
      'Gordian Sniper': '戈耳狄狙击手',
      'Gordian Soldier': '戈耳狄士兵',
      'Hangar 12': '第12大型机库',
      'Jagd Doll': '狩猎人偶',
      'King Gobtank G-IV': '4号哥布林坦克王',
      'Magitek Gobwidow G-IX': '9号哥布林黑寡妇',
      '(?<!Giant )Bomb(?!e)': '炸弹'
    },
    'replaceText': {
      'Blitzstrahl': '迅光',
      'Bodyhurt Breakblock': '躯体防护',
      'Boomcannon': '爆炸加农炮',
      'Brainhurt Breakblock': '精神防护',
      'Carpet Bomb': '地毯式轰炸',
      '(?<!Massive )Explosion': '爆炸',
      'Gobwalker': '哥布林战车',
      'Gobwidow': '哥布林黑寡妇',
      'Hardhelm': '戈耳狄硬盔兵',
      'Hardmind': '戈耳狄铁心兵',
      'Jagd Doll': '狩猎人偶',
      'Kaltstrahl': '寒光',
      'Massive Explosion': '大爆炸',
      'Sniper': '戈耳狄狙击手',
      'Soldier': '戈耳狄士兵',
      'Wave': '波',
      '\\(mid\\)': '(中央)'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '(?<!Giant )Bomb(?!e)': '폭탄',
      'Boomtype Magitek Gobwalker G-VII': 'VII호 고블린워커 B형',
      'Giant Bomb': '대형 폭탄',
      'Gordian Hardhelm': '고르디우스 강화투구',
      'Gordian Hardmind': '고르디우스 강화두뇌',
      'Gordian Sniper': '고르디우스 저격수',
      'Gordian Soldier': '고르디우스 병사',
      'Hangar 12': '제12 대형 격납고',
      'Jagd Doll': '인형 수렵병',
      'King Gobtank G-IV': 'IV호 대왕 고블린탱크',
      'Magitek Gobwidow G-IX': 'IX호 고블린거미'
    },
    'replaceText': {
      'Blitzstrahl': '벼락',
      'Bodyhurt Breakblock': '육체 타격',
      'Boomcannon': '우레 포격',
      'Brainhurt Breakblock': '정신 타격',
      'Carpet Bomb': '융단폭격',
      '(?<!Massive )Explosion': '폭발',
      'Gobwalker': '고블린워커',
      'Gobwidow': '고블린거미',
      'Hardhelm': '강화투구',
      'Hardmind': '강화두뇌',
      'Jagd Doll': '인형 수렵병',
      'Kaltstrahl': '냉병기 공격',
      'Massive Explosion': '대폭발',
      'Sniper': '저격수',
      'Soldier': '병사',
      'Wave': '웨이브',
      '\\(mid\\)': '(중앙)'
    }
  }]
};
/* harmony default export */ const a2s = (a2s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a2s.txt
const raid_a2s_namespaceObject = "### A2S\r\n# Alexander - The Cuff of the Father (Savage)\r\n# https://dtguilds.enjin.com/a2sguide\r\n# -ii 13CE FCE FD7 FCF FD1 FD3 FD0 FD9 FCD\r\n\r\n\r\n# Note: because these are many mobs and this is FFXIV and also this is Heavensward,\r\n# this is all a bit imprecise.  Explosions seem to be +/- 1 second but roughly 15\r\n# from when the bomb appears.  Mobs of the same type are not always synced up.\r\n# So, many syncs are commented out.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Wave 1 (pull)\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n0.0 \"Soldier x2 (NW)\"\r\n\r\n\r\n# Wave 2 (timed push)\r\n20.3 \"--Wave 2--\" AddedCombatant { name: \"Gordian Hardmind\" } window 21,5\r\n20.3 \"Sniper, Soldier x2 (NW)\"\r\n20.3 \"Hardmind (SW)\"\r\n\r\n42.0 \"Brainhurt Breakblock\" Ability { id: \"FCC\", source: \"Gordian Hardmind\" }\r\n\r\n\r\n# Wave 3 (timed push)\r\n80.2 \"--Wave 3--\" AddedCombatant { name: \"Gordian Hardhelm\" } window 70,70\r\n80.2 \"Hardhelm, Soldier (SW)\"\r\n80.2 \"Hardmind, Sniper, Soldier 2x (N)\"\r\n\r\n101.9 \"Brainhurt Breakblock\" Ability { id: \"FCC\", source: \"Gordian Hardmind\" }\r\n101.9 \"Bodyhurt Breakblock\" Ability { id: \"FCB\", source: \"Gordian Hardhelm\" }\r\n\r\n\r\n# Wave 4 (triggered push)\r\n2000.0 \"--Wave 4--\" AddedCombatant { name: \"Boomtype Magitek Gobwalker G-VII\" } window 2000,0\r\n2000.0 \"Gobwalker (NE)\"\r\n2000.0 \"Sniper x2, Soldier x2 (mid)\"\r\n\r\n2012.3 \"Carpet Bomb 1\" Ability { id: \"FDA\", source: \"King Gobtank G-IV\" }\r\n2032.5 \"Explosion\" #Ability { id: \"FDC\", source: \"Bomb\" }\r\n2040.8 \"Carpet Bomb 2\" Ability { id: \"FDA\", source: \"King Gobtank G-IV\" }\r\n2061.0 \"Explosion\" #Ability { id: \"FDC\", source: \"Bomb\" }\r\n\r\n\r\n# Wave 5 (timed push)\r\n2095.5 \"--Wave 5--\" AddedCombatant { name: \"Magitek Gobwidow G-IX\" } window 2070,100\r\n2095.5 \"Gobwidow (N)\"\r\n2095.5 \"Gobwidow (S)\"\r\n2095.5 \"Soldier x2 (SW)\"\r\n\r\n2105.1 \"Carpet Bomb 1\" Ability { id: \"FDA\", source: \"King Gobtank G-IV\" }\r\n2107.0 \"--sync--\" Ability { id: \"1413\", source: \"Magitek Gobwidow G-IX\" }\r\n2114.6 \"Boomcannon\" Ability { id: \"FD8\", source: \"Magitek Gobwidow G-IX\" }\r\n2125.3 \"Explosion\" #Ability { id: \"FDC\", source: \"Bomb\" }\r\n2126.2 \"Carpet Bomb 2\" Ability { id: \"FDA\", source: \"King Gobtank G-IV\" }\r\n2138.3 \"--sync--\" Ability { id: \"1413\", source: \"Magitek Gobwidow G-IX\" }\r\n2146.0 \"Boomcannon\" Ability { id: \"FD8\", source: \"Magitek Gobwidow G-IX\" }\r\n2146.5 \"Explosion\" #Ability { id: \"FDC\", source: \"Bomb\" }\r\n\r\n\r\n# Wave 6 (timed push)\r\n2168.0 \"--Wave 6--\" AddedCombatant { name: \"Jagd Doll\" } window 2170,100\r\n2168.0 \"Jagd Doll (NE)\"\r\n2168.0 \"Gobwalker (N)\"\r\n2168.0 \"Hardhelm (SW)\"\r\n\r\n2176.3 \"Kaltstrahl\" Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n2177.3 \"Carpet Bomb\" Ability { id: \"FDA\", source: \"King Gobtank G-IV\" }\r\n2187.4 \"Blitzstrahl\" Ability { id: \"FD6\", source: \"Jagd Doll\" }\r\n2190.0 \"Bodyhurt Breakblock\" Ability { id: \"FCB\", source: \"Gordian Hardhelm\" }\r\n2195.7 \"Explosion\" #Ability { id: \"FDC\", source: \"Bomb\" }\r\n2196.5 \"Kaltstrahl\" Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n2198.3 \"Carpet Bomb\" Ability { id: \"FDA\", source: \"King Gobtank G-IV\" }\r\n2218.3 \"Explosion\" #Ability { id: \"FDC\", source: \"Bomb\" }\r\n\r\n2227.7 \"Blitzstrahl\" Ability { id: \"FD6\", source: \"Jagd Doll\" }\r\n2230.9 \"Kaltstrahl\" Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n2239.1 \"Kaltstrahl\" Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n\r\n2250.2 \"Blitzstrahl\" Ability { id: \"FD6\", source: \"Jagd Doll\" } window 10,10 jump 2227.7\r\n2253.4 \"Kaltstrahl\"\r\n2261.6 \"Kaltstrahl\"\r\n\r\n2272.7 \"Blitzstrahl\"\r\n2275.9 \"Kaltstrahl\"\r\n2284.1 \"Kaltstrahl\"\r\n\r\n2295.2 \"Blitzstrahl\"\r\n2298.4 \"Kaltstrahl\"\r\n2306.6 \"Kaltstrahl\"\r\n\r\n\r\n# Wave 7 (triggered push)\r\n3000.0 \"--Wave 7--\" AddedCombatant { name: \"Jagd Doll\" } window 825,0\r\n3000.0 \"Jagd Doll x4 (mid)\"\r\n\r\n3006.2 \"Kaltstrahl\" #Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n3010.8 \"Carpet Bomb 1\" Ability { id: \"FDA\", source: \"King Gobtank G-IV\" }\r\n3017.4 \"Blitzstrahl\" #Ability { id: \"FD6\", source: \"Jagd Doll\" }\r\n3029.1 \"Kaltstrahl\" #Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n3029.5 \"Explosion\" #Ability { id: \"FDC\", source: \"Bomb\" }\r\n3033.8 \"Carpet Bomb 2\" Ability { id: \"FDA\", source: \"King Gobtank G-IV\" }\r\n3040.1 \"Blitzstrahl\" #Ability { id: \"FD6\", source: \"Jagd Doll\" }\r\n3043.3 \"Kaltstrahl\" #Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n3051.5 \"Explosion\" #Ability { id: \"FDC\", source: \"Bomb\" }\r\n3062.6 \"Blitzstrahl\" #Ability { id: \"FD6\", source: \"Jagd Doll\" }\r\n3065.8 \"Kaltstrahl\" #Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n\r\n\r\n# Wave 8 (timed push)\r\n# TODO: include additional jagd doll stuff into here?\r\n3080.7 \"--Wave 8--\" AddedCombatant { name: \"Gordian Sniper\" } window 1075,100\r\n3080.7 \"Sniper x3, Soldier (SW)\"\r\n3080.7 \"Hardmind (N)\"\r\n3080.7 \"Hardhelm (SE)\"\r\n\r\n3090.8 \"Carpet Bomb 1\" Ability { id: \"FDA\", source: \"King Gobtank G-IV\" }\r\n3104.0 \"Bodyhurt Breakblock\" Ability { id: \"FCB\", source: \"Gordian Hardhelm\" }\r\n3104.0 \"Brainhurt Breakblock\" Ability { id: \"FCC\", source: \"Gordian Hardmind\" }\r\n3111.0 \"Explosion\" #Ability { id: \"FDC\", source: \"Bomb\" }\r\n3113.9 \"Carpet Bomb 2\" Ability { id: \"FDA\", source: \"King Gobtank G-IV\" }\r\n3134.2 \"Explosion\" #Ability { id: \"FDC\", source: \"Bomb\" }\r\n\r\n\r\n# Wave 9 (triggered push)\r\n4000.0 \"--Wave 9--\" AddedCombatant { name: \"Magitek Gobwidow G-IX\" } window 1900,0\r\n4000.0 \"Gobwidow (NW)\"\r\n4000.0 \"Gobwidow, Jagd Doll (SW)\"\r\n4000.0 \"Gobwalker (NE)\"\r\n4000.0 \"Sniper x2, Soldier x2 (SE)\"\r\n\r\n4014.4 \"--sync--\" #Ability { id: \"1413\", source: \"Magitek Gobwidow G-IX\" }\r\n4016.3 \"Blitzstrahl\" Ability { id: \"FD6\", source: \"Jagd Doll\" }\r\n4019.4 \"Kaltstrahl\" Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n4022.1 \"Boomcannon\" #Ability { id: \"FD8\", source: \"Magitek Gobwidow G-IX\" }\r\n4027.6 \"Kaltstrahl\" Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n4038.8 \"Blitzstrahl\" Ability { id: \"FD6\", source: \"Jagd Doll\" }\r\n4041.9 \"Kaltstrahl\" Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n\r\n4042.6 \"--sync--\" #Ability { id: \"1413\", source: \"Magitek Gobwidow G-IX\" }\r\n4050.1 \"Kaltstrahl\" Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n4050.3 \"Boomcannon\" #Ability { id: \"FD8\", source: \"Magitek Gobwidow G-IX\" }\r\n\r\n4061.3 \"Blitzstrahl\" Ability { id: \"FD6\", source: \"Jagd Doll\" }\r\n4064.4 \"Kaltstrahl\" Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n4070.8 \"--sync--\" #Ability { id: \"1413\", source: \"Magitek Gobwidow G-IX\" }\r\n4072.6 \"Kaltstrahl\" Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n4078.5 \"Boomcannon\" #Ability { id: \"FD8\", source: \"Magitek Gobwidow G-IX\" }\r\n\r\n4083.8 \"Blitzstrahl\" Ability { id: \"FD6\", source: \"Jagd Doll\" }\r\n4086.9 \"Kaltstrahl\" Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n4095.1 \"Kaltstrahl\" Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n4099.0 \"--sync--\" #Ability { id: \"1413\", source: \"Magitek Gobwidow G-IX\" }\r\n4106.3 \"Blitzstrahl\" Ability { id: \"FD6\", source: \"Jagd Doll\" }\r\n4106.7 \"Boomcannon\" #Ability { id: \"FD8\", source: \"Magitek Gobwidow G-IX\" }\r\n\r\n4109.4 \"Kaltstrahl\" Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n4117.6 \"Kaltstrahl\" Ability { id: \"FD4\", source: \"Jagd Doll\" }\r\n4127.2 \"--sync--\" #Ability { id: \"1413\", source: \"Magitek Gobwidow G-IX\" }\r\n4134.9 \"Boomcannon\" #Ability { id: \"FD8\", source: \"Magitek Gobwidow G-IX\" }\r\n\r\n\r\n\r\n# Enrage\r\n5000.0 \"--sync--\" AddedCombatant { name: \"Giant Bomb\" } window 5000,0\r\n5010.0 \"Massive Explosion Enrage\" Ability { id: \"FDD\", source: \"Giant Bomb\" }\r\n\r\n# Technically this loops, and has a special dialog where Quickthinx says:\r\n# \"Uplanders are stubborn, need lesson teachings! Illuminati─reload and fire!\"\r\n# and then starts throwing 2 bombs at once, but this is probably enough.\r\n\r\n# TODO: also, this technically happens while other mechanics are going on.\r\n# It'd be nice to be able to sort of \"splice\" the enrage cast in.\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a3n.ts



// ALEXANDER - THE ARM OF THE FATHER NORMAL
// A3N
const a3n_triggerSet = {
  id: 'AlexanderTheArmOfTheFather',
  zoneId: zone_id/* default.AlexanderTheArmOfTheFather */.Z.AlexanderTheArmOfTheFather,
  timelineFile: 'a3n.txt',
  timelineTriggers: [{
    id: 'A3N Splash',
    regex: /Splash/,
    beforeSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'A3N Fluid Swing',
    regex: /Fluid Swing/,
    beforeSeconds: 4,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  },
  // The Liquid Limb section includes rapid repeated Fluid Strike cleaves during the second half.
  // It's very complex to handle this without being spammy,
  // so we cue some of the callouts off of Wash Away instead.
  {
    id: 'A3N Fluid Strike 1',
    regex: /Wash Away/,
    beforeSeconds: 12,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'A3N Wash Away',
    type: 'StartsUsing',
    netRegex: {
      id: '12FF',
      source: 'Living Liquid',
      capture: false
    },
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'A3N Cascade',
    type: 'StartsUsing',
    netRegex: {
      id: '12F7',
      source: 'Living Liquid',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'A3N Sluice',
    type: 'HeadMarker',
    netRegex: {
      id: '001A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sluice on YOU',
        de: 'Schleusenöffnung auf DIR',
        fr: 'Éclusage sur Vous',
        ja: '自分にスルース',
        cn: '蓝点名',
        ko: '봇물 대상자'
      }
    }
  }, {
    // To avoid spam, we cue this off Wash Away instead.
    id: 'A3N Fluid Strike 2',
    type: 'Ability',
    netRegex: {
      id: '12FF',
      source: 'Living Liquid',
      capture: false
    },
    delaySeconds: 5,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '3x Tank Cleave',
        de: '3x Tank Cleave',
        fr: 'Tank Cleave x3',
        cn: '3x 顺劈',
        ko: '광역 탱버 3번'
      }
    }
  }, {
    id: 'A3N Fluid Strike 3',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Liquid Limb',
      capture: false
    },
    suppressSeconds: 60,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Repeated tank cleaves',
        de: 'Wiederholte Tank Cleaves',
        fr: 'Répétition de Tank cleaves',
        cn: '多重顺劈',
        ko: '광역 탱버 반복'
      }
    }
  }, {
    id: 'A3N Drainage You',
    type: 'Tether',
    netRegex: {
      id: '0005',
      target: 'Living Liquid'
    },
    condition: (data, matches) => matches.source === data.me,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drainage on YOU',
        de: 'Entwässerung auf DIR',
        fr: 'Drainage sur VOUS',
        ja: '自分にドレナージ',
        cn: '连线点名',
        ko: '하수로 대상자'
      }
    }
  }, {
    id: 'A3N Drainage Tank',
    type: 'Tether',
    netRegex: {
      id: '0005',
      target: 'Living Liquid',
      capture: false
    },
    condition: data => data.role === 'tank',
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get drainage tether',
        de: 'Hole die Entwässerungs-Verbindung',
        fr: 'Prenez un lien de drainage',
        ja: '線を取る',
        cn: '接线',
        ko: '하수로 선 가져오기'
      }
    }
  }, {
    id: 'A3N Ferrofluid Tether',
    type: 'Tether',
    netRegex: {
      id: '0026'
    },
    run: (data, matches) => {
      data.ferroTether ??= {};
      data.ferroTether[matches.source] = matches.target;
      data.ferroTether[matches.target] = matches.source;
    }
  }, {
    id: 'A3N Ferrofluid Signs',
    type: 'HeadMarker',
    netRegex: {
      id: ['0030', '0031']
    },
    run: (data, matches) => {
      data.ferroMarker ??= {};
      data.ferroMarker[matches.target] = matches.id;
    }
  }, {
    id: 'A3N Ferrofluid Call',
    type: 'StartsUsing',
    netRegex: {
      id: '1306',
      source: 'Living Liquid'
    },
    alertText: (data, matches, output) => {
      data.ferroTether ??= {};
      data.ferroMarker ??= {};
      const partner = data.ferroTether[data.me];
      const marker1 = data.ferroMarker[data.me];
      const marker2 = data.ferroMarker[partner ?? ''];
      if (partner === undefined || marker1 === undefined || marker2 === undefined) return `${matches.ability} (???)`;
      if (marker1 === marker2) return output.repel({
        player: data.party.member(partner)
      });
      return output.attract({
        player: data.party.member(partner)
      });
    },
    outputStrings: {
      repel: {
        en: 'Repel: close to ${player}',
        de: 'Abstoß: nahe bei ${player}',
        fr: 'Répulsion : Rapprochez-vous de ${player}',
        ja: '同じ極: ${player}に近づく',
        cn: '同极：靠近${player}',
        ko: '반발: ${player}와 가까이 붙기'
      },
      attract: {
        en: 'Attract: away from ${player}',
        de: 'Anziehung: weg von ${player}',
        fr: 'Attraction : Éloignez-vous de ${player}',
        ja: '異なる極: ${player}から離れる',
        cn: '异极：远离${player}',
        ko: '자력: ${player}와 떨어지기'
      }
    }
  }, {
    id: 'A3N FerrofluidCleanup',
    type: 'Ability',
    netRegex: {
      id: '1306',
      source: 'Living Liquid',
      capture: false
    },
    delaySeconds: 5,
    run: data => {
      delete data.ferroMarker;
      delete data.ferroTether;
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Condensate Demineralizer .9': 'Kondensatoranlage 9',
      'Hydrate Core': 'Hydratkern',
      'Liquid Limb': 'belebt(?:e|er|es|en) Hand',
      'Living Liquid': 'belebt(?:e|er|es|en) Wasser'
    },
    'replaceText': {
      '--Liquid Limb spawns--': '--Belebte Hand erscheint--',
      'Cascade': 'Cascade',
      'Drainage': 'Entwässerung',
      'Fluid Strike': 'Flüssiger Schlag',
      'Fluid Swing': 'Flüssiger Schwung',
      'Hydromorph': 'Hydromorphose',
      'Magnetism': 'Magnetismus',
      'Protean Wave': 'Proteische Welle',
      'Repel': 'Abstoßung',
      'Sluice': 'Schleusenöffnung',
      'Splash': 'Schwall',
      'Valve': 'Ventil',
      'Wash Away': 'Wegspülen'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Condensate Demineralizer .9': 'Grand condensateur GC-9',
      'Hydrate Core': 'noyau d\'hydrate',
      'Liquid Limb': 'membre liquide',
      'Living Liquid': 'liquide vivant'
    },
    'replaceText': {
      '--Liquid Limb spawns--': '--Apparition du membre liquide--',
      'Cascade': 'Cascade',
      'Drainage': 'Drainage',
      'Fluid Strike': 'Frappe fluide',
      'Fluid Swing': 'Coup fluide',
      'Hydromorph': 'Hydromorphe',
      'Magnetism': 'Magnétisme',
      'Protean Wave': 'Vague inconstante',
      'Repel': 'Répulsion',
      'Sluice': 'Éclusage',
      'Splash': 'Éclaboussement',
      'Valve': 'Ouverture de valve',
      'Wash Away': 'Lessivage'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Condensate Demineralizer .9': '第9大型復水器',
      'Hydrate Core': 'ハイドレードコア',
      'Liquid Limb': 'リキッドハンド',
      'Living Liquid': 'リビングリキッド'
    },
    'replaceText': {
      'Cascade': 'カスケード',
      'Drainage': 'ドレナージ',
      'Fluid Strike': 'フルイドストライク',
      'Fluid Swing': 'フルイドスイング',
      'Hydromorph': 'ハイドロモーフ',
      'Magnetism': '磁力',
      'Protean Wave': 'プロティアンウェイブ',
      'Repel': '反発',
      'Sluice': 'スルース',
      'Splash': 'スプラッシュ',
      'Valve': 'バルブオープン',
      'Wash Away': 'ウォッシュアウェイ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Condensate Demineralizer .9': '第9大型冷凝器',
      'Hydrate Core': '水合核心',
      'Liquid Limb': '活水之手',
      'Living Liquid': '有生命活水'
    },
    'replaceText': {
      '--Liquid Limb spawns--': '--活水之手出现--',
      'Cascade': '瀑泻',
      'Drainage': '排水',
      'Fluid Strike': '流体强袭',
      'Fluid Swing': '流体摆动',
      'Hydromorph': '水态转换',
      'Magnetism': '磁力',
      'Protean Wave': '万变水波',
      'Repel': '相斥',
      'Sluice': '冲洗',
      'Splash': '溅开',
      'Valve': '水阀',
      'Wash Away': '冲净'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Condensate Demineralizer .9': '제9대형복수기',
      'Hydrate Core': '액화 핵',
      'Liquid Limb': '액체 손',
      'Living Liquid': '살아있는 액체'
    },
    'replaceText': {
      '--Liquid Limb spawns--': '--액체 손 등장--',
      'Cascade': '캐스케이드',
      'Drainage': '하수로',
      'Fluid Strike': '유체 강타',
      'Fluid Swing': '유체 타격',
      'Hydromorph': '액상 변이',
      'Magnetism': '자력',
      'Protean Wave': '변화의 물결',
      'Repel': '반발',
      'Sluice': '봇물',
      'Splash': '물장구',
      'Valve': '밸브 개방',
      'Wash Away': '싹쓸이'
    }
  }]
};
/* harmony default export */ const a3n = (a3n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a3n.txt
const raid_a3n_namespaceObject = "### A3N\r\n# ALEXANDER: THE ARM OF THE FATHER\r\n# LIVING LIQUID\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# -ii 1305 12FA\r\n\r\n# Condensate Demineralizer #9 will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"66C\" } window 10000,10000\r\n7.5 \"Fluid Swing\" Ability { id: \"12EE\", source: \"Living Liquid\" }\r\n11.6 \"Splash x3\" duration 3 #Ability { id: \"12EF\", source: \"Living Liquid\" }\r\n19.9 \"Protean Wave\" Ability { id: \"12F0\", source: \"Living Liquid\" }\r\n23.5 \"Fluid Swing\" Ability { id: \"12EE\", source: \"Living Liquid\" }\r\n27.6 \"Splash x3\" duration 3 #Ability { id: \"12EF\", source: \"Living Liquid\" }\r\n32.9 \"Fluid Swing\" Ability { id: \"12EE\", source: \"Living Liquid\" }\r\n39.0 \"Sluice\" Ability { id: \"12F2\", source: \"Living Liquid\" }\r\n42.0 \"--sync--\" Ability { id: \"12F3\", source: \"Living Liquid\" }\r\n44.0 \"--sync--\" Ability { id: \"12F4\", source: \"Living Liquid\" }\r\n47.2 \"Fluid Swing\" Ability { id: \"12EE\", source: \"Living Liquid\" }\r\n53.3 \"Splash x3\" duration 3 #Ability { id: \"12EF\", source: \"Living Liquid\" }\r\n\r\n# Hand phase\r\n57.5 \"--untargetable--\"\r\n59.5 \"--sync--\" Ability { id: \"F28\", source: \"Hydrate Core\" }\r\n60.6 \"--sync--\" Ability { id: \"F22\", source: \"Living Liquid\" } window 60.6,10\r\n61.0 \"Hydromorph\" Ability { id: \"F29\", source: \"Hydrate Core\" }\r\n63.0 \"--sync--\" Ability { id: \"1040\", source: \"Hydrate Core\" }\r\n64.5 \"--targetable--\"\r\n70.6 \"Fluid Strike\" Ability { id: \"12FD\", source: \"Living Liquid\" }\r\n77.7 \"Wash Away\" Ability { id: \"12FF\", source: \"Living Liquid\" }\r\n87.9 \"Fluid Strike\" #Ability { id: \"12FD\", source: \"Living Liquid\" }\r\n91.0 \"Fluid Strike\" #Ability { id: \"12FD\", source: \"Living Liquid\" }\r\n94.1 \"Fluid Strike\" #Ability { id: \"12FD\", source: \"Living Liquid\" }\r\n98.1 \"--Liquid Limb spawns--\"\r\n104.2 \"Fluid Strike\" #Ability { id: \"12FE\", source: \"Living Liquid\" }\r\n109.3 \"Fluid Strike\" #Ability { id: \"12FE\", source: \"Living Liquid\" }\r\n111.4 \"Fluid Strike\" #Ability { id: \"12FE\", source: \"Living Liquid\" }\r\n116.5 \"Fluid Strike\" #Ability { id: \"12FE\", source: \"Living Liquid\" }\r\n118.6 \"Fluid Strike\" #Ability { id: \"12FE\", source: \"Living Liquid\" }\r\n123.7 \"Fluid Strike\" #Ability { id: \"12FE\", source: \"Living Liquid\" }\r\n125.8 \"Fluid Strike\" #Ability { id: \"12FE\", source: \"Living Liquid\" }\r\n\r\n# Tornado phase\r\n# There are several add waves here, but the timing is dependent on kill times,\r\n# and it's largely pointless to try to sync to them.\r\n# Drainage is the only consistent thing through the phase.\r\n\r\n128.8 \"--untargetable--\"\r\n132.1 \"--sync--\" Ability { id: \"F28\", source: \"Hydrate Core\" } window 68,5\r\n133.2 \"--sync--\" Ability { id: \"F24\", source: \"Living Liquid\" }\r\n133.6 \"Hydromorph\" Ability { id: \"F29\", source: \"Hydrate Core\" }\r\n135.7 \"--sync--\" Ability { id: \"1040\", source: \"Hydrate Core\" }\r\n157.9 \"Drainage\" Ability { id: \"1304\", source: \"Living Liquid\" }\r\n178.6 \"Drainage\" Ability { id: \"1304\", source: \"Living Liquid\" }\r\n\r\n# And back we go to the first phase, which repeats *identically from the beginning*(!!)\r\n\r\n200.2 \"--sync--\" Ability { id: \"F28\", source: \"Hydrate Core\" } window 71.4,5\r\n201.3 \"--sync--\" Ability { id: \"F26\", source: \"Living Liquid\" }\r\n201.7 \"Hydromorph\" Ability { id: \"F29\", source: \"Hydrate Core\" }\r\n205.2 \"--targetable--\"\r\n211.3 \"Fluid Swing\" Ability { id: \"12EE\", source: \"Living Liquid\" } jump 7.5\r\n215.4 \"Splash x3\"\r\n223.7 \"Protean Wave\"\r\n227.3 \"Fluid Swing\"\r\n231.4 \"Splash x3\"\r\n236.7 \"Fluid Swing\"\r\n\r\n\r\n\r\n# Final phase\r\n# There's no indication for this besides the 12F6 Valve ability.\r\n# Seems like maybe a 35% HP push?\r\n# Under certain circumstances, Ferrofluid/Magnetism can be skipped.\r\n# Fluid Swing after is synced to account for that.\r\n\r\n300.0 \"Valve\" Ability { id: \"12F6\", source: \"Living Liquid\" } window 300,5\r\n310.1 \"Cascade\" Ability { id: \"12F7\", source: \"Living Liquid\" }\r\n316.3 \"Fluid Swing\" Ability { id: \"12F5\", source: \"Living Liquid\" }\r\n319.5 \"Fluid Swing\" Ability { id: \"12F5\", source: \"Living Liquid\" }\r\n326.6 \"Sluice\" Ability { id: \"12F2\", source: \"Living Liquid\" }\r\n329.6 \"--sync--\" Ability { id: \"12F3\", source: \"Living Liquid\" }\r\n331.6 \"--sync--\" Ability { id: \"12F4\", source: \"Living Liquid\" }\r\n335.9 \"Magnetism/Repel\" Ability { id: [\"1307\", \"1309\"], source: \"Living Liquid\" }\r\n344.0 \"Fluid Swing\" Ability { id: \"12F5\", source: \"Living Liquid\" } window 17.4,2.5\r\n346.1 \"Splash x4\" # Ability { id: \"12EF\", source: \"Living Liquid\" }\r\n350.5 \"Fluid Swing\" Ability { id: \"12F5\", source: \"Living Liquid\" }\r\n359.8 \"Magnetism/Repel\" Ability { id: [\"1307\", \"1309\"], source: \"Living Liquid\" }\r\n365.9 \"Fluid Swing\" Ability { id: \"12F5\", source: \"Living Liquid\" } window 10,2.5\r\n372.0 \"Sluice\" Ability { id: \"12F2\", source: \"Living Liquid\" }\r\n375.0 \"--sync--\" Ability { id: \"12F3\", source: \"Living Liquid\" }\r\n377.0 \"--sync--\" Ability { id: \"12F4\", source: \"Living Liquid\" }\r\n378.7 \"Protean Wave\" Ability { id: \"12F0\", source: \"Living Liquid\" }\r\n381.4 \"Fluid Swing\" Ability { id: \"12F5\", source: \"Living Liquid\" }\r\n\r\n387.5 \"Cascade\" Ability { id: \"12F7\", source: \"Living Liquid\" } window 60,30 jump 310.1\r\n393.7 \"Fluid Swing\"\r\n396.9 \"Fluid Swing\"\r\n404.0 \"Sluice\"\r\n413.3 \"Magnetism/Repel\"\r\n421.4 \"Fluid Swing\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a3s.ts



const a3s_triggerSet = {
  id: 'AlexanderTheArmOfTheFatherSavage',
  zoneId: zone_id/* default.AlexanderTheArmOfTheFatherSavage */.Z.AlexanderTheArmOfTheFatherSavage,
  timelineFile: 'a3s.txt',
  timelineTriggers: [{
    id: 'A3S Wash Away',
    regex: /Wash Away/,
    beforeSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'A3S Splash',
    regex: /Splash/,
    beforeSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Note: there's nothing in the log for when the hand turns into an
    // open palm or a fist, so this just warns when to move and not
    // where to go based on time.
    id: 'A3S Hand of Stuff',
    regex: /Hand of Prayer\/Parting/,
    beforeSeconds: 5,
    condition: data => data.role === 'tank' || data.job === 'BLU',
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move Bosses',
        de: 'Bosse bewegen',
        fr: 'Déplacez les boss',
        ja: 'ボス動かして',
        cn: '移动Boss',
        ko: '보스 이동 주차'
      }
    }
  }],
  triggers: [{
    id: 'A3S Sluice',
    type: 'HeadMarker',
    netRegex: {
      id: '001A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sluice on YOU',
        de: 'Schleusenöffnung auf DIR',
        fr: 'Éclusage sur Vous',
        ja: '自分にスルース',
        cn: '蓝点名',
        ko: '봇물 대상자'
      }
    }
  }, {
    id: 'A3S Digititis Tank',
    type: 'HeadMarker',
    netRegex: {
      id: '0025'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank Debuff',
        de: 'Tank Debuff',
        fr: 'Debuff vulnérabilité',
        ja: 'タンクデバフ',
        cn: '坦克 Debuff',
        ko: '탱커 디버프'
      }
    }
  }, {
    id: 'A3S Digititis Healer',
    type: 'HeadMarker',
    netRegex: {
      id: '0022'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Healer Debuff',
        de: 'Heiler Debuff',
        fr: 'Debuff soins',
        ja: 'ヒーラーデバフ',
        cn: '奶妈 Debuff',
        ko: '힐러 디버프'
      }
    }
  }, {
    id: 'A3S Digititis Damage',
    type: 'HeadMarker',
    netRegex: {
      id: '0024'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Damage Debuff',
        de: 'DD Debuff',
        fr: 'Debuff dégats',
        ja: 'DPSデバフ',
        cn: 'DPS Debuff',
        ko: '딜러 디버프'
      }
    }
  }, {
    id: 'A3S Equal Concentration',
    type: 'Ability',
    netRegex: {
      source: ['Liquid Limb', 'Living Liquid'],
      id: 'F09',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Burn Higher HP Hand',
        de: 'Fokusiere Hand mit mehr HP',
        fr: 'Focus sur la main aux PV les plus élevés',
        ja: 'HPが高い手を討つ',
        cn: '转火血多手',
        ko: 'HP 더 많은 손에 집중'
      }
    }
  }, {
    id: 'A3S Drainage You',
    type: 'Tether',
    netRegex: {
      id: '0005',
      target: 'Living Liquid'
    },
    condition: (data, matches) => matches.source === data.me,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drainage on YOU',
        de: 'Entwässerung auf DIR',
        fr: 'Drainage sur VOUS',
        ja: '自分にドレナージ',
        cn: '连线点名',
        ko: '하수로 대상자'
      }
    }
  }, {
    id: 'A3S Drainage Tank',
    type: 'Tether',
    netRegex: {
      id: '0005',
      target: 'Living Liquid',
      capture: false
    },
    condition: data => data.role === 'tank',
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get drainage tether',
        de: 'Hole die Entwässerungs-Verbindung',
        fr: 'Prenez un lien de drainage',
        ja: '線を取る',
        cn: '接线',
        ko: '하수로 선 가져오기'
      }
    }
  }, {
    id: 'A3S Ferrofluid Tether',
    type: 'Tether',
    netRegex: {
      id: '0026'
    },
    run: (data, matches) => {
      data.ferroTether ??= {};
      data.ferroTether[matches.source] = matches.target;
      data.ferroTether[matches.target] = matches.source;
    }
  }, {
    id: 'A3S Ferrofluid Signs',
    type: 'HeadMarker',
    netRegex: {
      id: ['0030', '0031']
    },
    run: (data, matches) => {
      data.ferroMarker ??= {};
      data.ferroMarker[matches.target] = matches.id;
    }
  }, {
    // From logs, it appears that tethers, then headmarkers, then starts casting occurs.
    id: 'A3S Ferrofluid',
    type: 'StartsUsing',
    netRegex: {
      source: 'Living Liquid',
      id: 'F01'
    },
    alertText: (data, matches, output) => {
      data.ferroTether ??= {};
      data.ferroMarker ??= {};
      const partner = data.ferroTether[data.me];
      const marker1 = data.ferroMarker[data.me];
      const marker2 = data.ferroMarker[partner ?? ''];
      if (partner === undefined || marker1 === undefined || marker2 === undefined) return `${matches.ability} (???)`;
      if (marker1 === marker2) return output.repel({
        player: data.party.member(partner)
      });
      return output.attract({
        player: data.party.member(partner)
      });
    },
    outputStrings: {
      repel: {
        en: 'Repel: close to ${player}',
        de: 'Abstoß: nahe bei ${player}',
        fr: 'Répulsion : Rapprochez-vous de ${player}',
        ja: '同じ極: ${player}に近づく',
        cn: '同极：靠近${player}',
        ko: '반발: ${player}와 가까이 붙기'
      },
      attract: {
        en: 'Attract: away from ${player}',
        de: 'Anziehung: weg von ${player}',
        fr: 'Attraction : Éloignez-vous de ${player}',
        ja: '異なる極: ${player}から離れる',
        cn: '异极：远离${player}',
        ko: '자력: ${player}와 떨어지기'
      }
    }
  }, {
    id: 'A3S Cascade',
    type: 'StartsUsing',
    netRegex: {
      source: 'Living Liquid',
      id: 'EFE',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // aka Liquid Gaol
    id: 'A3S Throttle',
    type: 'Ability',
    netRegex: {
      source: 'Liquid Rage',
      id: 'F1A'
    },
    condition: data => data.CanCleanse(),
    alertText: (data, matches, output) => {
      return output.text({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Throttle on ${player}',
        de: 'Vollgas auf ${player}',
        fr: 'Geôle liquide sur ${player}',
        ja: '${player}に窒息',
        cn: '窒息点${player}',
        ko: '"${player}" 액체 감옥'
      }
    }
  }, {
    id: 'A3S Fluid Claw',
    type: 'HeadMarker',
    netRegex: {
      id: '0010'
    },
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) return output.clawOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return output.clawOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      clawOn: {
        en: 'Claw on ${player}',
        de: 'Klaue auf ${player}',
        fr: 'Griffe sur ${player}',
        ja: '${player}にフルイドクロー',
        cn: '抓奶手点${player}',
        ko: '"${player}" 액체 발톱'
      },
      clawOnYou: {
        en: 'Claw on YOU',
        de: 'Klaue auf DIR',
        fr: 'Griffe sur VOUS',
        ja: '自分にフルイドクロー',
        cn: '抓奶手点名',
        ko: '액체 발톱 대상자'
      }
    }
  }, {
    // aka Pressurize
    id: 'A3S Embolus',
    type: 'Ability',
    netRegex: {
      source: 'Living Liquid',
      id: 'F1B',
      capture: false
    },
    condition: data => data.role === 'tank' || data.job === 'BLU',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Embolus: Move Boss',
        de: 'Pfropfen: Boss bewegen',
        fr: 'Caillot : Déplacez le boss',
        ja: 'エンボラス: ボスを引いて離れる',
        cn: '水球出现：拉走BOSS',
        ko: '물구슬: 보스 주차 옮기기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Condensate Demineralizer \\.9': 'Kondensatoranlage 9',
      'Hydrate Core': 'Hydratkern',
      'Liquid Limb': 'belebt(?:e|er|es|en) Hand',
      'Liquid Rage': 'levitiert(?:e|er|es|en) Rage',
      'Living Liquid': 'belebt(?:e|er|es|en) Wasser'
    },
    'replaceText': {
      'Cascade': 'Kaskade',
      'Digititis': 'Digititis',
      'Drainage': 'Entwässerung',
      'Embolus': 'Pfropfen',
      'Equal Concentration': 'Isotonie',
      'Ferrofluid': 'Ferrofluid',
      'Fluid Claw': 'Amorphe Klaue',
      'Fluid Strike': 'Flüssiger Schlag',
      'Fluid Swing': 'Flüssiger Schwung',
      'Gear Lubricant': 'Getriebeschmiermittel',
      'Hand Of Pain': 'Qualhand',
      'Hand Of Prayer/Parting': 'Betende/Scheidende Hand',
      'Hydromorph': 'Hydromorphose',
      'Magnetism': 'Magnetismus',
      'Piston Lubricant': 'Kolbenschmiermittel',
      'Protean Wave': 'Proteische Welle',
      'Repel': 'Repulsion',
      'Sluice': 'Schleusenöffnung',
      'Splash': 'Schwall',
      'Throttle': 'Erstickung',
      'Wash Away': 'Wegspülen'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Condensate Demineralizer \\.9': 'grand condensateur GC-9',
      'Hydrate Core': 'Noyau d\'hydrate',
      'Liquid Limb': 'Membre liquide',
      'Liquid Rage': 'Furie liquide',
      'Living Liquid': 'Liquide vivant'
    },
    'replaceText': {
      'Cascade': 'Cascade',
      'Digititis': 'Phalangette',
      'Drainage': 'Drainage',
      'Embolus': 'Caillot',
      'Equal Concentration': 'Nivellement aqueux',
      'Ferrofluid': 'Ferrofluide',
      'Fluid Claw': 'Griffe fluide',
      'Fluid Strike': 'Frappe fluide',
      'Fluid Swing': 'Coup fluide',
      'Gear Lubricant': 'Lubrifiant d\'engrenage',
      'Hand Of Pain': 'Main de douleur',
      'Hand Of Prayer/Parting': 'Main de prière/séparation',
      'Hydromorph': 'Hydromorphe',
      'Magnetism/Repel': 'Magnétisme/Répulsion',
      'Piston Lubricant': 'Lubrifiant de piston',
      'Protean Wave': 'Vague inconstante',
      'Sluice': 'Éclusage',
      'Splash': 'Éclaboussement',
      'Throttle': 'Geôle liquide',
      'Wash Away': 'Lessivage'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Condensate Demineralizer \\.9': '第9大型復水器',
      'Hydrate Core': 'ハイドレードコア',
      'Liquid Limb': 'リキッドハンド',
      'Liquid Rage': 'リキッドレイジ',
      'Living Liquid': 'リビングリキッド'
    },
    'replaceText': {
      'Cascade': 'カスケード',
      'Digititis': 'ゆびさき',
      'Drainage': 'ドレナージ',
      'Embolus': 'エンボラス',
      'Equal Concentration': '水量均等化',
      'Ferrofluid': 'マグネット',
      'Fluid Claw': 'フルイドクロー',
      'Fluid Strike': 'フルイドストライク',
      'Fluid Swing': 'フルイドスイング',
      'Gear Lubricant': 'ギアオイル',
      'Hand Of Pain': 'ハンド・オブ・ペイン',
      'Hand Of Prayer': 'ハンド・オブ・プレイヤー',
      'Hydromorph': 'ハイドロモーフ',
      'Magnetism': '磁力',
      'Piston Lubricant': 'ピストンオイル',
      'Protean Wave': 'プロティアンウェイブ',
      'Repel': '反発',
      'Sluice': 'スルース',
      'Splash': 'スプラッシュ',
      'Throttle': '窒息',
      'Wash Away': 'ウォッシュアウェイ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Condensate Demineralizer \\.9': '第9大型冷凝器',
      'Hydrate Core': '水合核心',
      'Liquid Limb': '活水之手',
      'Liquid Rage': '活水之怒',
      'Living Liquid': '有生命活水'
    },
    'replaceText': {
      'Cascade': '倾泻',
      'Digititis': '指尖',
      'Drainage': '排水',
      'Embolus': '栓塞',
      'Equal Concentration': '水量均等化',
      'Ferrofluid': '磁石',
      'Fluid Claw': '流体之爪',
      'Fluid Strike': '流体强袭',
      'Fluid Swing': '流体摆动',
      'Gear Lubricant': '齿轮润滑剂',
      'Hand Of Pain': '苦痛之手',
      'Hand Of Prayer': '祈祷之手',
      'Hydromorph': '水态转换',
      'Magnetism': '磁力',
      'Piston Lubricant': '活塞润滑剂',
      'Protean Wave': '万变水波',
      'Repel': '相斥',
      'Sluice': '冲洗',
      'Splash': '溅开',
      'Throttle': '窒息',
      'Wash Away': '冲净'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Condensate Demineralizer \\.9': '제9대형복수기',
      'Hydrate Core': '액화 핵',
      'Liquid Limb': '액체 손',
      'Liquid Rage': '분노한 액체',
      'Living Liquid': '살아있는 액체'
    },
    'replaceText': {
      'Cascade': '폭포수',
      'Digititis': '지목',
      'Drainage': '하수로',
      'Embolus': '응고체',
      'Equal Concentration': '수량 균등화',
      'Ferrofluid': '자석',
      'Fluid Claw': '액체 발톱',
      'Fluid Strike': '유체 강타',
      'Fluid Swing': '유체 타격',
      'Gear Lubricant': '기어 윤활유',
      'Hand Of Pain': '고통의 손길',
      'Hand Of Prayer/Parting': '기도/작별의 손길',
      'Hydromorph': '액상 변이',
      'Magnetism': '자력',
      'Piston Lubricant': '피스톤 윤활유',
      'Protean Wave': '변화의 물결',
      'Repel': '반발',
      'Sluice': '봇물',
      'Splash': '물장구',
      'Throttle': '질식',
      'Wash Away': '싹쓸이'
    }
  }]
};
/* harmony default export */ const a3s = (a3s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a3s.txt
const raid_a3s_namespaceObject = "### A3S\r\n# Alexander - The Arm of the Father (Savage)\r\n# Staticbreaker (Ultimate)\r\n# https://dtguilds.enjin.com/a3sguide\r\n# -p EF3:7 -ii EF7 EF8 F1E EF9 EFB F0F F1D F11 F1C F17 F14\r\n\r\n# Note: \"Liquid Gaol\" renamed to \"Throttle\" to disambiguate from \"Liquid Claw\",\r\n# aka the healer gaol.  \"Pressurize\" also changed to \"Embolus\".\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1: Jiggly\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.0 \"Fluid Swing\" Ability { id: \"EF3\", source: \"Living Liquid\" }\r\n17.2 \"Protean Wave\" Ability { id: \"EF5\", source: \"Living Liquid\" }\r\n18.8 \"Protean Wave\" Ability { id: \"EF6\", source: \"Living Liquid\" }\r\n21.9 \"Fluid Swing\" Ability { id: \"EF3\", source: \"Living Liquid\" }\r\n25.0 \"Splash x3\" #Ability { id: \"EF4\", source: \"Living Liquid\" } duration 2.2\r\n32.3 \"Fluid Swing\" Ability { id: \"EF3\", source: \"Living Liquid\" }\r\n44.4 \"Sluice\" Ability { id: \"EFA\", source: \"Living Liquid\" }\r\n49.6 \"Splash x3\" #Ability { id: \"EF4\", source: \"Living Liquid\" } duration 2.2\r\n54.9 \"Fluid Swing\" Ability { id: \"EF3\", source: \"Living Liquid\" }\r\n56.8 \"--untargetable--\"\r\n58.9 \"--sync--\" Ability { id: \"F28\", source: \"Hydrate Core\" }\r\n60.0 \"--sync--\" Ability { id: \"F22\", source: \"Living Liquid\" }\r\n\r\n\r\n### Phase 2: Sound of Two Hands Cleaving\r\n60.4 \"Hydromorph\" Ability { id: \"F29\", source: \"Hydrate Core\" }\r\n62.4 \"--sync--\" Ability { id: \"1040\", source: \"Hydrate Core\" }\r\n63.9 \"--targetable--\"\r\n70.0 \"Fluid Strike\" Ability { id: \"F05\", source: \"Living Liquid\" }\r\n77.1 \"Wash Away\" Ability { id: \"F07\", source: \"Living Liquid\" }\r\n85.2 \"Digititis\" Ability { id: \"F08\", source: \"Living Liquid\" }\r\n90.4 \"Fluid Strike\" Ability { id: \"F05\", source: \"Living Liquid\" }\r\n100.5 \"Fluid Strike\" Ability { id: \"F05\", source: \"Living Liquid\" }\r\n107.6 \"Wash Away\" Ability { id: \"F07\", source: \"Living Liquid\" }\r\n109.6 \"--split--\"\r\n115.8 \"Fluid Strike\" Ability { id: \"F06\", source: \"Living Liquid\" }\r\n125.0 \"Hand Of Prayer/Parting\" Ability { id: \"F0[BC]\", source: [\"Living Liquid\", \"Liquid Limb\"] }\r\n136.9 \"Digititis\" Ability { id: \"F08\", source: \"Living Liquid\" }\r\n137.1 \"Equal Concentration\" Ability { id: \"F09\", source: \"Liquid Limb\" }\r\n137.1 \"--dps burn--\" duration 27.4\r\n# Limb's cleaves are slightly desynced here, so only include the main one.\r\n141.1 \"Fluid Strike x2\" Ability { id: \"F06\", source: \"Living Liquid\" }\r\n149.2 \"Fluid Strike x2\" Ability { id: \"F06\", source: \"Living Liquid\" }\r\n157.4 \"Fluid Strike x2\" Ability { id: \"F06\", source: \"Living Liquid\" }\r\n164.5 \"Hand Of Pain\" Ability { id: \"F0A\", source: \"Living Liquid\" }\r\n174.7 \"Hand Of Prayer/Parting\" Ability { id: \"F0[BC]\", source: [\"Living Liquid\", \"Liquid Limb\"] }\r\n178.8 \"Fluid Strike x2\" Ability { id: \"F06\", source: \"Living Liquid\" }\r\n183.8 \"--sync--\" Ability { id: \"F28\", source: \"Hydrate Core\" }\r\n184.9 \"--sync--\" Ability { id: \"F24\", source: \"Living Liquid\" }\r\n\r\n\r\n### Phase 3: Tornado\r\n185.3 \"Hydromorph\" Ability { id: \"F29\", source: \"Hydrate Core\" }\r\n187.3 \"--sync--\" Ability { id: \"1040\", source: \"Hydrate Core\" }\r\n192.0 \"Piston Lubricant x2\"\r\n201.1 \"Gear Lubricant x3\"\r\n# These happen about 1s apart, so don't sync.\r\n208.4 \"Drainage x2\" #Ability { id: \"F10\", source: \"Living Liquid\" }\r\n214.8 \"Gear Lubricant x2\"\r\n214.8 \"Piston Lubricant x1\"\r\n227.2 \"Ferrofluid\" Ability { id: \"F12\", source: \"Living Liquid\" }\r\n227.7 \"Magnetism/Repel\" Ability { id: \"F1[35]\", source: \"Living Liquid\" }\r\n230.3 \"Gear Lubricant x4\"\r\n237.5 \"Drainage x2\" #Ability { id: \"F10\", source: \"Living Liquid\" }\r\n243.6 \"Gear Lubricant x3\"\r\n252.0 \"Ferrofluid\" Ability { id: \"F12\", source: \"Living Liquid\" }\r\n252.5 \"Magnetism/Repel\" Ability { id: \"F1[35]\", source: \"Living Liquid\" }\r\n254.8 \"Piston Lubricant x4\"\r\n279.4 \"--sync--\" Ability { id: \"F28\", source: \"Hydrate Core\" }\r\n280.5 \"--sync--\" Ability { id: \"F26\", source: \"Living Liquid\" }\r\n280.9 \"Hydromorph\" Ability { id: \"F29\", source: \"Hydrate Core\" }\r\n282.9 \"--sync--\" Ability { id: \"1040\", source: \"Hydrate Core\" }\r\n\r\n### Phase 4: Jiggly Again\r\n284.5 \"--targetable--\"\r\n284.5 \"--sync--\" Ability { id: \"EFD\", source: \"Living Liquid\" }\r\n\r\n294.6 \"Cascade 1\" Ability { id: \"EFE\", source: \"Living Liquid\" } window 300,10\r\n304.8 \"Ferrofluid\" Ability { id: \"F01\", source: \"Living Liquid\" }\r\n306.0 \"Magnetism/Repel\" Ability { id: \"F1[35]\", source: \"Living Liquid\" }\r\n310.0 \"Splash x3\" #Ability { id: \"EF4\", source: \"Living Liquid\" } duration 2.2\r\n315.3 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n325.4 \"Sluice\" Ability { id: \"EFA\", source: \"Living Liquid\" }\r\n328.6 \"Protean Wave\" Ability { id: \"EF5\", source: \"Living Liquid\" }\r\n330.3 \"Protean Wave\" Ability { id: \"EF6\", source: \"Living Liquid\" }\r\n334.4 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n340.5 \"Splash x3\" #Ability { id: \"EF4\", source: \"Living Liquid\" } duration 2.2\r\n345.8 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n355.9 \"Sluice\" Ability { id: \"EFA\", source: \"Living Liquid\" }\r\n361.0 \"Digititis\" Ability { id: \"F00\", source: \"Living Liquid\" }\r\n364.2 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n\r\n370.3 \"Cascade 2\" Ability { id: \"EFE\", source: \"Living Liquid\" } window 40,40\r\n380.1 \"Throttle\" #Ability { id: \"F02\", source: \"Living Liquid\" }\r\n384.0 \"Fluid Claw\" Ability { id: \"F0D\", source: \"Liquid Limb\" }\r\n385.0 \"--targetable--\"\r\n385.3 \"Splash x3\" #Ability { id: \"EF4\", source: \"Living Liquid\" } duration 2.2\r\n390.6 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n398.7 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n402.8 \"Splash x3\" #Ability { id: \"EF4\", source: \"Living Liquid\" } duration 2.2\r\n418.1 \"Digititis\" Ability { id: \"F00\", source: \"Living Liquid\" }\r\n422.3 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n426.4 \"Splash x6\" #Ability { id: \"EF4\", source: \"Living Liquid\" } duration 5.5\r\n435.0 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n\r\n441.1 \"Cascade 3\" Ability { id: \"EFE\", source: \"Living Liquid\" } window 40,40\r\n450.3 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n453.5 \"Throttle\" #Ability { id: \"F1A\", source: \"Liquid Rage\" }\r\n455.5 \"Protean Wave\" Ability { id: \"F19\", source: \"Liquid Rage\" }\r\n455.6 \"Throttle\" #Ability { id: \"F1A\", source: \"Liquid Rage\" }\r\n459.4 \"Drainage\" Ability { id: \"F18\", source: \"Liquid Rage\" }\r\n461.6 \"Protean Wave\" Ability { id: \"F19\", source: \"Liquid Rage\" }\r\n463.3 \"Ferrofluid\" Ability { id: \"F01\", source: \"Living Liquid\" }\r\n464.5 \"Magnetism/Repel\" Ability { id: \"F1[35]\", source: \"Living Liquid\" }\r\n471.5 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n476.6 \"Throttle\" #Ability { id: \"F1A\", source: \"Liquid Rage\" }\r\n478.7 \"Embolus\" Ability { id: \"F1B\", source: \"Liquid Rage\" }\r\n478.8 \"Throttle\" #Ability { id: \"F1A\", source: \"Liquid Rage\" }\r\n488.7 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n496.9 \"Embolus\" Ability { id: \"F1B\", source: \"Liquid Rage\" }\r\n496.9 \"Protean Wave\" Ability { id: \"F19\", source: \"Liquid Rage\" }\r\n500.8 \"Sluice\" Ability { id: \"EFA\", source: \"Living Liquid\" }\r\n500.8 \"Drainage\" Ability { id: \"F18\", source: \"Liquid Rage\" }\r\n503.2 \"Protean Wave\" Ability { id: \"F19\", source: \"Liquid Rage\" }\r\n508.9 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n\r\n516.1 \"Cascade 4\" Ability { id: \"EFE\", source: \"Living Liquid\" } window 40,40\r\n526.3 \"Ferrofluid\" Ability { id: \"F01\", source: \"Living Liquid\" }\r\n527.5 \"Magnetism/Repel\" Ability { id: \"F1[35]\", source: \"Living Liquid\" }\r\n531.5 \"Splash x3\" #Ability { id: \"EF4\", source: \"Living Liquid\" } duration 2.2\r\n537.0 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n547.1 \"Sluice\" Ability { id: \"EFA\", source: \"Living Liquid\" }\r\n550.4 \"Protean Wave\" Ability { id: \"EF5\", source: \"Living Liquid\" }\r\n552.1 \"Protean Wave\" Ability { id: \"EF6\", source: \"Living Liquid\" }\r\n556.2 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n562.3 \"Splash x3\" #Ability { id: \"EF4\", source: \"Living Liquid\" } duration 2.2\r\n567.6 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n577.7 \"Sluice\" Ability { id: \"EFA\", source: \"Living Liquid\" }\r\n582.8 \"Digititis\" Ability { id: \"F00\", source: \"Living Liquid\" }\r\n586.0 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n\r\n592.1 \"Cascade 5\" Ability { id: \"EFE\", source: \"Living Liquid\" } window 40,40\r\n602.0 \"Throttle\" #Ability { id: \"F02\", source: \"Living Liquid\" }\r\n605.9 \"Fluid Claw\" Ability { id: \"F0D\", source: \"Liquid Limb\" }\r\n606.9 \"--targetable--\"\r\n607.1 \"Splash x3\" #Ability { id: \"EF4\", source: \"Living Liquid\" } duration 2.2\r\n612.4 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n620.5 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n624.6 \"Splash x3\" #Ability { id: \"EF4\", source: \"Living Liquid\" } duration 2.2\r\n639.9 \"Digititis\" Ability { id: \"F00\", source: \"Living Liquid\" }\r\n644.0 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n648.1 \"Splash x6\" #Ability { id: \"EF4\", source: \"Living Liquid\" } duration 5.5\r\n656.7 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n\r\n662.8 \"Cascade 6\" Ability { id: \"EFE\", source: \"Living Liquid\" } window 40,40\r\n672.0 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n675.2 \"Throttle\" #Ability { id: \"F1A\", source: \"Liquid Rage\" }\r\n677.2 \"Protean Wave\" Ability { id: \"F19\", source: \"Liquid Rage\" }\r\n677.4 \"Throttle\" #Ability { id: \"F1A\", source: \"Liquid Rage\" }\r\n681.2 \"Drainage\" Ability { id: \"F18\", source: \"Liquid Rage\" }\r\n683.4 \"Protean Wave\" Ability { id: \"F19\", source: \"Liquid Rage\" }\r\n685.2 \"Ferrofluid\" Ability { id: \"F01\", source: \"Living Liquid\" }\r\n686.4 \"Magnetism/Repel\" Ability { id: \"F1[35]\", source: \"Living Liquid\" }\r\n693.4 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n698.6 \"Throttle\" #Ability { id: \"F1A\", source: \"Liquid Rage\" }\r\n700.6 \"Embolus\" Ability { id: \"F1B\", source: \"Liquid Rage\" }\r\n700.7 \"Throttle\" #Ability { id: \"F1A\", source: \"Liquid Rage\" }\r\n710.5 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n718.7 \"Protean Wave\" Ability { id: \"F19\", source: \"Liquid Rage\" }\r\n718.7 \"Embolus\" Ability { id: \"F1B\", source: \"Liquid Rage\" }\r\n722.6 \"Sluice\" Ability { id: \"EFA\", source: \"Living Liquid\" }\r\n722.6 \"Drainage\" Ability { id: \"F18\", source: \"Liquid Rage\" }\r\n725.3 \"Protean Wave\" Ability { id: \"F19\", source: \"Liquid Rage\" }\r\n730.7 \"Fluid Swing\" Ability { id: \"EFC\", source: \"Living Liquid\" }\r\n\r\n737.8 \"Cascade 7\" Ability { id: \"EFE\", source: \"Living Liquid\" } window 40,40\r\n748.0 \"Ferrofluid\" Ability { id: \"F01\", source: \"Living Liquid\" }\r\n749.2 \"Magnetism/Repel\" Ability { id: \"F1[35]\", source: \"Living Liquid\" }\r\n\r\n751.2 \"--sync--\" StartsUsing { id: \"EFF\", source: \"Living Liquid\" } window 1000,1000\r\n761.2 \"Cascade Enrage\" Ability { id: \"EFF\", source: \"Living Liquid\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a4s.ts



const a4s_triggerSet = {
  id: 'AlexanderTheBurdenOfTheFatherSavage',
  zoneId: zone_id/* default.AlexanderTheBurdenOfTheFatherSavage */.Z.AlexanderTheBurdenOfTheFatherSavage,
  timelineFile: 'a4s.txt',
  timelineTriggers: [{
    id: 'A4S Hydrothermal Missile',
    regex: /Hydrothermal Missile/,
    beforeSeconds: 5,
    suppressSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'A4S Discord Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '00AE'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.orbsOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.orbsOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      orbsOn: {
        en: 'Orbs on ${player}',
        de: 'Orbs auf ${player}',
        fr: 'Orbes sur ${player}',
        ja: '${player}に玉',
        cn: '球点${player}',
        ko: '"${player}" 구슬'
      },
      orbsOnYou: {
        en: 'Orbs on YOU',
        de: 'Orbs auf DIR',
        fr: 'Orbes sur VOUS',
        ja: '自分に玉',
        cn: '球点名',
        ko: '구슬 대상자'
      }
    }
  }, {
    // Stun Resistance.
    id: 'A4S Stun Leg',
    type: 'LosesEffect',
    netRegex: {
      effectId: '27'
    },
    condition: data => data.CanStun(),
    alertText: (_data, matches, output) => output.text({
      name: matches.target
    }),
    outputStrings: {
      text: {
        en: 'Stun ${name}',
        de: 'Unterbreche ${name}',
        fr: 'Étourdissez ${name}',
        ja: 'スタン: ${name}',
        cn: '眩晕${name}',
        ko: '${name}기절 시키기'
      }
    }
  }, {
    id: 'A4S Mortal Revolution',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Manipulator',
      id: '13E7',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe('alert')
  }, {
    // This is an 0011 tether, but there's not an easy way to know who it is on 100%,
    // as a set of tethers come out from bits and some may be pre-intercepted.
    id: 'A4S Carnage',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Manipulator',
      id: 'F5E',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Laser Tethers',
        de: 'Laser Verbindungen',
        fr: 'Liens laser',
        ja: 'レーザー線',
        cn: '镭射连线',
        ko: '레이저 선'
      }
    }
  }, {
    id: 'A4S Judgment Nisi A',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Manipulator',
      id: 'F64'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Nisi A on YOU',
        de: 'Nisi A auf DIR',
        fr: 'Peine A sur VOUS',
        ja: '自分に仮判決α',
        cn: '蓝BUFF点名',
        ko: '임시 판결 A 대상자'
      }
    }
  }, {
    id: 'A4S Judgment Nisi B',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Manipulator',
      id: 'F65'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Nisi B on YOU',
        de: 'Nisi B auf DIR',
        fr: 'Peine B sur VOUS',
        ja: '自分に仮判決β',
        cn: '红BUFF点名',
        ko: '임시 판결 B 대상자'
      }
    }
  }, {
    id: 'A4S Carnage Zero',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Manipulator',
      id: 'F5E',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'The Manipulator': 'Manipulator'
    },
    'replaceText': {
      'Carnage(?! Zero)': 'Carnage',
      'Carnage Zero': 'Carnage Zero',
      'Discoid': 'Diskoid',
      'Emergency Quarantine': 'Notquarantäne',
      'Hydrothermal Missile': 'Hydrothermales Geschoss',
      'Jagd Doll': 'Jagdpuppe',
      'Judgment Nisi': 'Vorläufige Vollstreckung',
      'Mortal Revolution': 'Rechte Retribution',
      'Perpetual Ray': 'Perpetueller Strahl',
      'Royal Pentacle': 'Penta-Kaustik',
      'Seed Of The Sky': 'Samen des Himmels',
      'Straf Doll': 'Strafpuppe'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'The Manipulator': 'Manipulateur'
    },
    'replaceText': {
      'Carnage(?! Zero)': 'Carnage',
      'Carnage Zero': 'Carnage Zéro',
      'Discoid': 'Discoïde',
      'Emergency Quarantine': 'Quarantaine d\'urgence',
      'Hydrothermal Missile': 'Missile hydrothermique',
      'Jagd Doll': 'Poupée jagd',
      'Judgment Nisi': 'Jugement conditionnel',
      'Mortal Revolution': 'Révolution mortelle',
      'Perpetual Ray': 'Rayon perpétuel',
      'Royal Pentacle': 'Pentacle royal',
      'Seed Of The Sky': 'Graine du ciel',
      'Straf Doll': 'Poupée straf'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'The Manipulator': 'マニピュレーター'
    },
    'replaceText': {
      'Carnage(?! Zero)': 'カーネイジ',
      'Carnage Zero': 'カーネイジ・ゼロ',
      'Discoid': 'ディスコイド',
      'Emergency Quarantine': '緊急隔離',
      'Hydrothermal Missile': '蒸気ミサイル',
      'Jagd Doll': 'ヤークトドール',
      'Judgment Nisi': 'ジャッジメントナイサイ',
      'Mortal Revolution': 'モータルレボリューション',
      'Perpetual Ray': 'パーペチュアルレイ',
      'Royal Pentacle': 'スチームジャッジ',
      'Seed Of The Sky': 'シード・オブ・スカイ',
      'Straf Doll': 'ストラッフドール'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'The Manipulator': '操纵者'
    },
    'replaceText': {
      'Carnage(?! Zero)': '灭绝',
      'Carnage Zero': '零式灭绝',
      'Discoid': '圆盘',
      'Emergency Quarantine': '紧急隔离',
      'Hydrothermal Missile': '蒸汽导弹',
      'Jagd Doll': '狩猎人偶',
      'Judgment Nisi': '非最终审判',
      'Mortal Revolution': '致命进化',
      'Perpetual Ray': '永恒射线',
      'Royal Pentacle': '蒸汽审判',
      'Seed Of The Sky': '天空之种',
      'Straf Doll': '惩罚人偶'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'The Manipulator': '조종자'
    },
    'replaceText': {
      'Carnage(?! Zero)': '대학살',
      'Carnage Zero': '대학살의 근원',
      'Discoid': '원반',
      'Emergency Quarantine': '긴급 격리',
      'Hydrothermal Missile': '증기 미사일',
      'Jagd Doll': '인형 수렵병',
      'Judgment Nisi': '임시처분',
      'Mortal Revolution': '필멸의 격변',
      'Perpetual Ray': '영원한 빛줄기',
      'Royal Pentacle': '증기 심판',
      'Seed Of The Sky': '하늘의 원천',
      'Straf Doll': '인형 기총병'
    }
  }]
};
/* harmony default export */ const a4s = (a4s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a4s.txt
const raid_a4s_namespaceObject = "### A4S\r\n# Alexander - The Burden of the Father (Savage)\r\n# https://dtguilds.enjin.com/a4sguide\r\n# -p F5B:3 13E7:518.2 F64:1528.4 F5E:2033.3\r\n# -ii F67 F68 F6A F6F F70 F6E F78 F6D F6B F65 F71 F73 F6C F77\r\n\r\n# Note: stun timing is a little bit suspect here.\r\n#       From most logs it seemed like ~5.8 seconds before the first ray.\r\n#       So, I applied that to all perpetual rays.\r\n\r\n### Leg 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n3.0 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" } window 3,13\r\n14.1 \"Discoid\" Ability { id: \"F61\", source: \"The Manipulator\" }\r\n21.2 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n21.2 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n26.3 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n26.4 \"--stun--\" duration 5\r\n32.2 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n41.3 \"Emergency Quarantine\" Ability { id: \"F62\", source: \"The Manipulator\" }\r\n\r\n43.4 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n48.5 \"Discoid\" Ability { id: \"F61\", source: \"The Manipulator\" }\r\n53.6 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n55.6 \"--stun--\" duration 5\r\n58.6 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n61.4 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n71.5 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n\r\n85.6 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n96.7 \"Discoid\" Ability { id: \"F61\", source: \"The Manipulator\" } window 20,20 jump 14.1\r\n103.8 \"Seed Of The Sky\" #Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n103.8 \"Hydrothermal Missile\" #Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n108.9 \"Seed Of The Sky\" #Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n109.0 \"--stun--\" duration 5\r\n114.8 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n123.9 \"Emergency Quarantine\" #Ability { id: \"F62\", source: \"The Manipulator\" }\r\n\r\n126.0 \"Hydrothermal Missile\" #Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n131.1 \"Discoid\" #Ability { id: \"F61\", source: \"The Manipulator\" }\r\n136.2 \"Seed Of The Sky\" #Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n138.2 \"--stun--\" duration 5\r\n141.2 \"Seed Of The Sky\" #Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n144.0 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n154.1 \"Hydrothermal Missile\" #Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n\r\n\r\n### Leg 2\r\n500.0 \"--sync--\" NameToggle { name: \"The Manipulator\", toggle: \"01\" } window 500,0\r\n512.1 \"--untargetable--\"\r\n516.2 \"--sync--\" StartsUsing { id: \"13E7\", source: \"The Manipulator\" } window 517,5\r\n522.2 \"Mortal Revolution\" Ability { id: \"13E7\", source: \"The Manipulator\" }\r\n524.2 \"--targetable--\"\r\n532.3 \"Emergency Quarantine\" Ability { id: \"F62\", source: \"The Manipulator\" }\r\n543.4 \"Carnage\" Ability { id: \"F63\", source: \"The Manipulator\" }\r\n545.5 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n547.6 \"--stun--\" duration 5\r\n553.4 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n564.5 \"Carnage\" Ability { id: \"F63\", source: \"The Manipulator\" }\r\n566.6 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n569.6 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n\r\n578.7 \"Emergency Quarantine\" Ability { id: \"F62\", source: \"The Manipulator\" }\r\n580.8 \"--stun--\" duration 5\r\n586.6 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n590.7 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n597.8 \"Carnage\" Ability { id: \"F63\", source: \"The Manipulator\" }\r\n602.9 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n612.9 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n\r\n625.0 \"Emergency Quarantine\" Ability { id: \"F62\", source: \"The Manipulator\" } window 30,30 jump 532.3\r\n636.1 \"Carnage\" #Ability { id: \"F63\", source: \"The Manipulator\" }\r\n638.2 \"Hydrothermal Missile\" #Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n640.3 \"--stun--\" duration 5\r\n646.1 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n657.2 \"Carnage\" #Ability { id: \"F63\", source: \"The Manipulator\" }\r\n659.3 \"Hydrothermal Missile\" #Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n662.3 \"Seed Of The Sky\" #Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n\r\n671.4 \"Emergency Quarantine\" #Ability { id: \"F62\", source: \"The Manipulator\" }\r\n673.5 \"--stun--\" duration 5\r\n679.3 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n683.4 \"Hydrothermal Missile\" #Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n690.5 \"Carnage\" #Ability { id: \"F63\", source: \"The Manipulator\" }\r\n695.6 \"Seed Of The Sky\" #Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n705.6 \"Hydrothermal Missile\" #Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n\r\n\r\n### Leg 3\r\n1000.0 \"--sync--\" NameToggle { name: \"The Manipulator\", toggle: \"01\" } window 490,0\r\n1012.1 \"--untargetable--\"\r\n1016.2 \"--sync--\" StartsUsing { id: \"13E7\", source: \"The Manipulator\" } window 490,5\r\n1022.2 \"Mortal Revolution\" Ability { id: \"13E7\", source: \"The Manipulator\" }\r\n1024.2 \"--targetable--\"\r\n1027.4 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" } window 10,10\r\n1034.5 \"Carnage\" Ability { id: \"F63\", source: \"The Manipulator\" }\r\n1040.2 \"Straf Doll x1\"\r\n1040.2 \"Jagd Doll x3\"\r\n1044.6 \"--stun--\" duration 5\r\n1050.4 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n1057.6 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n1062.6 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n1071.7 \"Carnage\" Ability { id: \"F63\", source: \"The Manipulator\" }\r\n1075.4 \"--stun--\" duration 5\r\n1081.2 \"Perpetual Ray x2\" #Ability { id: \"F5D\", source: \"The Manipulator\" }\r\n\r\n1098.9 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" } window 10,10\r\n1107.5 \"Straf Doll x1\"\r\n1107.5 \"Jagd Doll x3\"\r\n1108.0 \"--stun--\" duration 5\r\n1113.8 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n1120.8 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n1124.8 \"Carnage\" Ability { id: \"F63\", source: \"The Manipulator\" }\r\n1129.9 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n1129.9 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n1135.6 \"--stun--\" duration 5\r\n1141.4 \"Perpetual Ray x2\" #Ability { id: \"F5D\", source: \"The Manipulator\" }\r\n\r\n1160.2 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" } window 10,10\r\n1167.3 \"Carnage\" Ability { id: \"F63\", source: \"The Manipulator\" } window 20,20 jump 1034.5\r\n1173.0 \"Straf Doll x1\"\r\n1173.0 \"Jagd Doll x3\"\r\n1177.4 \"--stun--\" duration 5\r\n1183.2 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n1190.4 \"Seed Of The Sky\" #Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n1195.4 \"Hydrothermal Missile\" #Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n1204.5 \"Carnage\" #Ability { id: \"F63\", source: \"The Manipulator\" }\r\n1208.2 \"--stun--\" duration 5\r\n1214.0 \"Perpetual Ray x2\" #Ability { id: \"F5D\", source: \"The Manipulator\" }\r\n\r\n1231.7 \"Hydrothermal Missile\" #Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n1240.3 \"Straf Doll x1\"\r\n1240.3 \"Jagd Doll x3\"\r\n1240.8 \"--stun--\" duration 5\r\n1246.6 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n1253.6 \"Seed Of The Sky\" #Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n1257.6 \"Carnage\" #Ability { id: \"F63\", source: \"The Manipulator\" }\r\n1262.7 \"Seed Of The Sky\" #Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n1262.7 \"Hydrothermal Missile\" #Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n1268.4 \"--stun--\" duration 5\r\n1274.2 \"Perpetual Ray x2\" #Ability { id: \"F5D\", source: \"The Manipulator\" }\r\n\r\n\r\n### Leg 4\r\n1500.0 \"--sync--\" NameToggle { name: \"The Manipulator\", toggle: \"01\" } window 490,0\r\n1512.1 \"--untargetable--\"\r\n1516.2 \"--sync--\" StartsUsing { id: \"13E7\", source: \"The Manipulator\" } window 490,5\r\n1522.2 \"Mortal Revolution\" Ability { id: \"13E7\", source: \"The Manipulator\" }\r\n1524.2 \"--targetable--\"\r\n1528.4 \"Judgment Nisi\" Ability { id: \"F64\", source: \"The Manipulator\" }\r\n1535.9 \"Straf Doll x1\"\r\n1535.9 \"Jagd Doll x3\"\r\n1540.6 \"--stun--\" duration 5\r\n1546.4 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n1556.5 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n1563.5 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" } window 10,10\r\n\r\n1573.6 \"Discoid\" Ability { id: \"F61\", source: \"The Manipulator\" }\r\n1582.8 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n1587.8 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n1589.8 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" } window 10,10\r\n1598.0 \"Straf Doll x1\"\r\n1598.0 \"Jagd Doll x3\"\r\n1605.0 \"--stun--\" duration 5\r\n1610.8 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n1615.9 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" } window 10,10\r\n\r\n# ??? Guessing at this loop.\r\n1621.0 \"Discoid\" Ability { id: \"F61\", source: \"The Manipulator\" } window 30,30 jump 1573.6\r\n1630.2 \"Seed Of The Sky\" #Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n1635.2 \"Seed Of The Sky\" #Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n1637.2 \"Hydrothermal Missile\" #Ability { id: \"F5B\", source: \"The Manipulator\" } window 10,10\r\n1645.4 \"Straf Doll x1\"\r\n1645.4 \"Jagd Doll x3\"\r\n1652.4 \"--stun--\" duration 5\r\n1658.2 \"Perpetual Ray x2\" #Ability { id: \"F5F\", source: \"The Manipulator\" }\r\n\r\n\r\n### Final Phase\r\n2000.0 \"--sync--\" NameToggle { name: \"The Manipulator\", toggle: \"01\" } window 490,0\r\n2012.1 \"--untargetable--\"\r\n2016.2 \"--sync--\" StartsUsing { id: \"13E7\", source: \"The Manipulator\" } window 490,5\r\n2022.2 \"Mortal Revolution\" Ability { id: \"13E7\", source: \"The Manipulator\" }\r\n2024.2 \"--targetable--\"\r\n\r\n2033.3 \"Carnage Zero\" Ability { id: \"F5E\", source: \"The Manipulator\" }\r\n2041.4 \"Discoid\" Ability { id: \"F61\", source: \"The Manipulator\" }\r\n2052.5 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n2053.5 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n2058.6 \"Carnage Zero\" Ability { id: \"F5E\", source: \"The Manipulator\" }\r\n\r\n2072.8 \"Royal Pentacle\" Ability { id: \"F66\", source: \"The Manipulator\" }\r\n2074.9 \"Perpetual Ray x5\" duration 8.4 #Ability { id: \"13B6\", source: \"The Manipulator\" }\r\n2085.4 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n2105.6 \"Carnage\" Ability { id: \"F63\", source: \"The Manipulator\" }\r\n2114.6 \"Straf Doll x1\"\r\n2114.6 \"Jagd Doll x3\"\r\n2116.8 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n2122.9 \"Carnage Zero\" Ability { id: \"F5E\", source: \"The Manipulator\" }\r\n2122.9 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n2128.0 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n2140.0 \"Carnage Zero\" Ability { id: \"F5E\", source: \"The Manipulator\" }\r\n2148.2 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n\r\n2161.3 \"Carnage Zero\" Ability { id: \"F5E\", source: \"The Manipulator\" }\r\n2169.5 \"Discoid\" Ability { id: \"F61\", source: \"The Manipulator\" }\r\n2180.6 \"Seed Of The Sky\" Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n2181.6 \"Hydrothermal Missile\" Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n2186.7 \"Carnage Zero\" Ability { id: \"F5E\", source: \"The Manipulator\" }\r\n\r\n2200.9 \"Royal Pentacle\" Ability { id: \"F66\", source: \"The Manipulator\" } window 40,40 jump 2072.8\r\n2203.0 \"Perpetual Ray x5\" duration 8.4 #Ability { id: \"13B6\", source: \"The Manipulator\" }\r\n2213.5 \"Hydrothermal Missile\" #Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n2233.7 \"Carnage\" #Ability { id: \"F63\", source: \"The Manipulator\" }\r\n2244.9 \"Hydrothermal Missile\" #Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n2251.0 \"Carnage Zero\" #Ability { id: \"F5E\", source: \"The Manipulator\" }\r\n2251.0 \"Seed Of The Sky\" #Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n2256.1 \"Seed Of The Sky\" #Ability { id: \"13D0\", source: \"The Manipulator\" }\r\n2268.1 \"Carnage Zero\" #Ability { id: \"F5E\", source: \"The Manipulator\" }\r\n2276.3 \"Hydrothermal Missile\" #Ability { id: \"F5B\", source: \"The Manipulator\" }\r\n\r\n\r\n### Enrage\r\n# Note: Manipulator won't enrage until all legs have been killed.\r\n2500.0 \"--sync--\" StartsUsing { id: \"13E7\", source: \"The Manipulator\" } window 480,480\r\n2506.0 \"Mortal Revolution Enrage\" Ability { id: \"13E7\", source: \"The Manipulator\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a5s.ts




// export type Data = RaidbossData;

// TODO: do the gobcut and gobstraight really alternate?
// if so, then maybe we could call out which was coming.
// I thought some of them were fixed and don't have enough data.

// TODO: is it worth calling out where to hide for Bomb's Away?
// There's a callout for where to hit the bombs to that everybody
// will see, and it's natural to go away from that.  An extra
// callout seems noisy.

// TODO: is it worth calling out a safe spot for the second boost?
// There's some notes below, but good words for directions are hard.
const bombLocation = matches => {
  // x = -15, -5, +5, +15 (east to west)
  // y = -205, -195, -185, -175 (north to south)
  return {
    x: Math.round((parseFloat(matches.x) + 15) / 10),
    y: Math.round((parseFloat(matches.y) + 205) / 10)
  };
};
const a5s_triggerSet = {
  id: 'AlexanderTheFistOfTheSonSavage',
  zoneId: zone_id/* default.AlexanderTheFistOfTheSonSavage */.Z.AlexanderTheFistOfTheSonSavage,
  timelineFile: 'a5s.txt',
  initData: () => {
    return {
      bombCount: 0,
      boostCount: 0
    };
  },
  timelineTriggers: [{
    id: 'A5S Kaltstrahl',
    regex: /Kaltstrahl/,
    // Hopefully you'll figure it out the first time.
    suppressSeconds: 9999,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'A5S Panzerschreck',
    regex: /Panzerschreck/,
    beforeSeconds: 10,
    suppressSeconds: 10,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'A5S Gobhook',
    regex: /Gobhook/,
    // Needs more warning than the cast.
    beforeSeconds: 7,
    suppressSeconds: 1,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'A5S Boost',
    regex: /Boost/,
    beforeSeconds: 10,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bird Soon (Purple)',
        de: 'Vogel bald (Lila)',
        fr: 'Oiseau bientôt (Violet)',
        ja: 'まもなく鳥に変化 (紫の薬)',
        cn: '准备变鸟（紫药）',
        ko: '새 변신 준비 (보라)'
      }
    }
  }, {
    id: 'A5S Bomb\'s Away Soon',
    regex: /Bomb's Away/,
    beforeSeconds: 10,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Gorilla Soon (Red)',
        de: 'Gorilla bald (Rot)',
        fr: 'Gorille bientôt (Rouge)',
        ja: 'まもなくゴリラに変化 (赤の薬)',
        cn: '准备变猩猩（红药）',
        ko: '고릴라 변신 준비 (빨강)'
      }
    }
  }, {
    id: 'A5S Debuff Refresh',
    regex: /Disorienting Groan/,
    beforeSeconds: 1,
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'refresh debuff in puddle soon',
        de: 'Debuff in der Fläche bald erneuern',
        fr: 'Rafraîchissez le debuff dans la zone au sol bientôt',
        ja: 'デバフを癒す',
        cn: '踩圈刷新debuff',
        ko: '디버프 해제하기'
      }
    }
  }],
  triggers: [{
    id: 'A5S Gobcut Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'A5S Concussion',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3E4'
    },
    condition: (data, matches) => {
      if (data.me !== matches.target) return false;
      return data.role === 'tank';
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'A5S Concussion BLU',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3E4'
    },
    condition: (data, matches) => {
      if (data.me !== matches.target) return false;
      return data.role !== 'tank' && data.job === 'BLU';
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap('info')
  }, {
    id: 'A5S Bomb Direction',
    type: 'Ability',
    netRegex: {
      source: 'Ratfinx Twinkledinks',
      id: '1590',
      capture: false
    },
    preRun: data => data.bombCount++,
    // We could give directions here, but "into / opposite spikey" is pretty succinct.
    infoText: (data, _matches, output) => {
      if (data.bombCount === 1) return output.knockBombsIntoSpikey();
      return output.knockBombsOppositeSpikey();
    },
    outputStrings: {
      knockBombsIntoSpikey: {
        en: 'Knock Bombs Into Spikey',
        de: 'Bombe in die Spike-Bombe stoßen',
        fr: 'Poussez les bombes dans la bombe à pointe',
        ja: 'トゲ爆弾を飛ばす',
        cn: '把炸弹拍到地雷处',
        ko: '지뢰쪽으로 폭탄 밀기'
      },
      knockBombsOppositeSpikey: {
        en: 'Knock Bombs Opposite Spikey',
        de: 'Bombe gegnüber der Spike-Bombe stoßen',
        fr: 'Poussez les bombes à l\'opposé de la bombe à pointe',
        ja: 'トゲ爆弾を対角に飛ばす',
        cn: '把炸弹拍到地雷处',
        ko: '지뢰 반대쪽으로 폭탄 밀기'
      }
    }
  }, {
    id: 'A5S Boost Count',
    type: 'Ability',
    netRegex: {
      source: 'Ratfinx Twinkledinks',
      id: '16A6',
      capture: false
    },
    run: data => {
      data.boostCount++;
      data.boostBombs = [];
    }
  }, {
    id: 'A5S Bomb',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Bomb'
    },
    preRun: (data, matches) => {
      data.boostBombs ??= [];
      data.boostBombs.push(bombLocation(matches));
    },
    alertText: (data, _matches, output) => {
      if (data.boostBombs && data.boostCount === 1) {
        const firstBomb = data.boostBombs[0];
        if (!firstBomb) return;
        // index 0 = NW, 3 = NE, 12 = SW, 15 = SE
        const index = firstBomb.x + firstBomb.y * 4;
        const outputs = {
          0: output.northwestFirst(),
          3: output.northeastFirst(),
          12: output.southwestFirst(),
          15: output.southeastFirst()
        };
        return outputs[index];
      }

      // Otherwise, we're on the second and final set of boost bombs.
      // TODO: This would be trivial to find the safe spot,
      // buuuuut this is hard to find good words for 16 spots.
      // Do you call it "NNW" or "East of NW But Also Outside" @_@
    },

    outputStrings: {
      northwestFirst: {
        en: 'NW first',
        de: 'NW zuerst',
        fr: 'NO en premier',
        ja: 'まずは北西',
        cn: '先左上',
        ko: '북서쪽 먼저'
      },
      northeastFirst: {
        en: 'NE first',
        de: 'NO zuerst',
        fr: 'NE en premier',
        ja: 'まずは北東',
        cn: '先右上',
        ko: '북동쪽 먼저'
      },
      southwestFirst: {
        en: 'SW first',
        de: 'SW zuerst',
        fr: 'SO en premier',
        ja: 'まずは南西',
        cn: '先左下',
        ko: '남서쪽 먼저'
      },
      southeastFirst: {
        en: 'SE first',
        de: 'SO zuerst',
        fr: 'SE en premier',
        ja: 'まずは南東',
        cn: '先右下',
        ko: '남동쪽 먼저'
      }
    }
  }, {
    id: 'A5S Prey',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Away',
        de: 'Weg gehen',
        fr: 'Éloignez-vous',
        ja: '外へ',
        cn: '快出去',
        ko: '멀리 떨어지기'
      }
    }
  }, {
    id: 'A5S Prey Healer',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    condition: data => data.role === 'healer',
    infoText: (data, matches, output) => {
      return output.text({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Shield ${player}',
        de: 'Schild ${player}',
        fr: 'Bouclier sur ${player}',
        ja: '${player}にバリア',
        cn: '给${player}单盾',
        ko: '"${player}" 에게 보호막'
      }
    }
  }, {
    id: 'A5S Glupgloop',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'GLOOPYGLOOP~',
        de: 'GLOOPYGLOOP~',
        fr: 'Gobacide gluant',
        ja: '強酸性劇物薬',
        cn: '强酸剧毒药',
        ko: '강산성 극약'
      }
    }
  }, {
    id: 'A5S Snake Adds',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Glassy-Eyed Cobra',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'A5S Steel Scales',
    type: 'StartsUsing',
    netRegex: {
      source: 'Glassy-Eyed Cobra',
      id: '16A2'
    },
    condition: data => data.CanStun(),
    suppressSeconds: 60,
    response: responses/* Responses.stun */.n3.stun()
  }, {
    id: 'A5S Anti-Coagulant Cleanse',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3EC'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 8,
    suppressSeconds: 30,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse (Green)',
        de: 'Reinigen (Grün)',
        fr: 'Purifiez-vous (Vert)',
        ja: 'エスナ (緑の薬)',
        cn: '解毒（绿药）',
        ko: '디버프 해제 (초록)'
      }
    }
  }, {
    id: 'A5S Gobbledygroper',
    type: 'Ability',
    // FIXME: this is a case where the tether is part of the added combatant network data,
    // but isn't exposed as a separate tether line.  Instead, just assume the first auto
    // is going to hit the tethered person, and suppress everything else.
    netRegex: {
      source: 'Gobbledygroper',
      id: '366'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 100,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Break Tether (Blue)',
        de: 'Verbindungen brechen (Blau)',
        fr: 'Cassez le lien (Bleu)',
        ja: '線を断つ (青の薬)',
        cn: '消除连线（蓝药）',
        ko: '선 끊기 (파랑)'
      }
    }
  }, {
    id: 'A5S Oogle',
    type: 'StartsUsing',
    netRegex: {
      source: 'Gobbledygawker',
      id: '169C',
      capture: false
    },
    // These seem to come within ~2s of each other, so just have one trigger.
    suppressSeconds: 5,
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      '(?<!Hummel)Faust': 'Faust',
      '(?<!Smart)Bomb': 'Bombe',
      'Hummelfaust': 'Hummelfaust',
      'Glassy-Eyed Cobra': 'aufgerüstet(?:e|er|es|en) Kobra',
      'Gobbledygawker': 'Gobglotzer',
      'Gobbledygroper': 'Gobgreifer',
      'Ratfinx Twinkledinks': 'Ratfix Blinkdings',
      'Smartbomb': 'Best(?:e|er|es|en) Sprengenkörper',
      'The Clevering': 'Forschenraum'
    },
    'replaceText': {
      '--big--': '--Groß--',
      '--small--': '--Klein--',
      '10-Tonze Slash': '11-Tonzen-Schlag',
      'Big Burst': 'Detonation',
      'Bomb\'s Away': 'Plumpsbombe',
      'Boost': 'Starksammeln',
      'Cobra': 'Kobra',
      'Disorienting Groan': 'Kampfgebrüll',
      'Feast': 'Festmahl',
      'Glupgloop': 'Sauresaft',
      'Gobbledygawker': 'Gobglotzer',
      'Gobbledygroper Add': 'Gobgreifer  Add',
      'Gobcut/Straight': 'Gobhaken/gerade',
      'Gobdash': 'Große Karacho',
      'Gobhook': 'Bogene Haken',
      'Gobjab': 'Hüpfzzu mal',
      'Gobstraight/Cut': 'Gobgerade/haken',
      'Gobswing': 'Schwirrenschwung',
      'Guzzle': 'Gluckgluck',
      'Kaltstrahl': 'Kaltstrahl',
      'Minotaur': 'Minotaurus',
      'Oogle': 'Steinstarren',
      'Panzer Vor': 'Panzer vor',
      'Panzerschreck': 'Panzerschreck',
      'Regorge': 'Auswürgen',
      'Relaxant': 'Ausnüchterung',
      'Shabti': 'Shabti',
      'Shock Therapy': 'Kleine Knisterklaps',
      'Steel Scales': 'Stahlschuppen',
      'Tetra Burst': 'Tetra-Detonation',
      'The Lion\'s Breath': 'Atem des Löwen',
      'Yorn Pig': 'Mankei'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '(?<!Smart)Bomb(?!e)': 'Bombe',
      '(?<!Hummel)Faust': 'Faust',
      'Glassy-Eyed Minotaur': 'Minotaure au regard vide',
      'Glassy-Eyed Cobra': 'cobra au regard vide',
      'Gobbledygawker': 'Gobœil',
      'Gobbledygroper': 'Gobchimère',
      'Hummelfaust': 'Hummelfaust',
      'Ratfinx Twinkledinks': 'Ratfinx le Génie',
      'Smartbomb': 'mégagobbombe',
      'The Clevering': 'la gobexpérimentation super-avancée'
    },
    'replaceText': {
      '\\(NW\\)': '(NO)',
      '\\(SE/SW\\)': '(SE/SO)',
      '--big--': '--grand--',
      '--small--': '--petit--',
      '10-Tonze Slash': 'Taillade de 10 tonz',
      'Big Burst': 'Grande explosion',
      'Bomb\'s Away': 'Lâcher de bombe',
      'Boost': 'Contraction musculaire',
      'Cobra': 'Cobra',
      'Disorienting Groan': 'Cri désorientant',
      'Feast': 'Festin',
      'Glupgloop': 'Gobacide gluant',
      'Gobbledygawker': 'Gobœil',
      'Gobbledygroper Add': 'Add Gobchimère',
      'Gobcut/Straight': 'Uppercut/Direct du droit',
      'Gobdash': 'Gobcharge',
      'Gobhook': 'Gobcrochet',
      'Gobjab': 'Gobcoup du gauche',
      'Gobstraight/Cut': 'Direct du droit/Uppercut',
      'Gobswing': 'Gobcrochet plongeant',
      'Guzzle': 'Glouglou',
      'Kaltstrahl': 'Kaltstrahl',
      'Minotaur': 'Minotaure',
      'Oogle': 'Vue pétrifiante',
      'Panzer Vor': 'Panzer Vor',
      'Panzerschreck': 'Panzerschreck',
      'Regorge': 'Vomissure',
      'Relaxant': 'Décontracturant',
      'Shabti': 'Chaouabti',
      'Shock Therapy': 'Thérapie de choc',
      'Steel Scales': 'Écailles d\'acier',
      'Tetra Burst': 'Explosion en croix',
      'The Lion\'s Breath': 'Souffle du lion',
      'Yorn Pig': 'Cochon de Yorn'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '(?<!Hummel)Faust': 'ファウスト',
      '(?<!Smart)Bomb': '爆弾',
      'Hummelfaust': 'ネオ・ファウスト',
      'Gobbledygroper': 'ゴブリキマイラ',
      'Ratfinx Twinkledinks': '奇才のラットフィンクス',
      'Smartbomb': '超高性能爆弾',
      'The Clevering': 'ゴブリサイエンス研究室',
      'Glassy-Eyed Cobra': 'ドーピング・コブラ',
      'Gobbledygawker': 'ゴブリアイ'
    },
    'replaceText': {
      '--big--': '--巨大化--',
      '--small--': '--小さくなる--',
      '10-Tonze Slash': '10トンズ・スラッシュ',
      'Big Burst': '大爆発',
      'Bomb\'s Away': '爆弾投下',
      'Boost': '力溜め',
      'Cobra': 'コブラ',
      'Disorienting Groan': '雄叫び',
      'Feast': 'フィースト',
      'Glupgloop': '強酸性劇物薬',
      'Gobbledygawker': 'ゴブリアイ',
      'Gobbledygroper Add': '雑魚: ゴブリキマイラ',
      'Gobcut/Straight': '衝撃のアッパー/渾身のストレート',
      'Gobdash': '怒濤のダッシュブロー',
      'Gobhook': '剛力のフック',
      'Gobjab': '牽制のジャブ',
      'Gobstraight/Cut': '渾身のストレート/衝撃のアッパー',
      'Gobswing': '激震のオーバーハンド',
      'Guzzle': 'ガブ飲み',
      'Kaltstrahl': 'カルトシュトラール',
      'Minotaur': 'ミノタウロス',
      'Oogle': '石化の視線',
      'Panzer Vor': 'パンツァーフォー',
      'Panzerschreck': 'パンツァーシュレッケ',
      'Regorge': 'リゴージ',
      'Relaxant': '薬効切れ',
      'Shabti': 'シュワブチ',
      'Shock Therapy': '雷気ショック',
      'Steel Scales': 'スチールスケール',
      'Tetra Burst': '四方爆発',
      'The Lion\'s Breath': 'フレイムブレス',
      'Yorn Pig': 'モルモット'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '(?<!Smart)Bomb(?!e)': '炸弹',
      '(?<!Hummel)Faust': '浮士德',
      'Glassy-Eyed Minotaur': '兴奋弥诺陶洛斯',
      'Gobbledygawker': '哥布之眼',
      'Gobbledygroper': '哥布林奇美拉',
      'Hummelfaust': '新型浮士德',
      'Ratfinx Twinkledinks': '奇才 拉特芬克斯',
      'Smartbomb': '超高性能炸弹',
      'The Clevering': '哥布林科学研究室',
      'Glassy-Eyed Cobra': '兴奋眼镜蛇'
    },
    'replaceText': {
      '--big--': '--大--',
      '--small--': '--小--',
      '10-Tonze Slash': '十吨挥打',
      'Big Burst': '大爆炸',
      'Bomb\'s Away': '投放炸弹',
      'Boost': '蓄力',
      'Cobra': 'Cobra',
      'Disorienting Groan': '吼叫',
      'Feast': '飨宴',
      'Glupgloop': '强酸剧毒药',
      'Gobbledygawker': '哥布之眼',
      'Gobbledygroper Add': '哥布林奇美拉出现',
      'Gobcut/Straight': '猛击上勾拳/全力重拳',
      'Gobdash': '怒涛冲拳',
      'Gobhook': '刚猛勾拳',
      'Gobjab': '牵制刺拳',
      'Gobstraight/Cut': '全力重拳/猛击上勾拳',
      'Gobswing': '激震抛拳',
      'Guzzle': '一饮而尽',
      'Kaltstrahl': '寒光',
      'Minotaur': '弥诺陶洛斯',
      'Oogle': '石化视线',
      'Panzer Vor': '战车前进',
      'Panzerschreck': '反坦克火箭筒',
      'Regorge': '喷毒',
      'Relaxant': '药物失效',
      'Shabti': '沙布提',
      'Shock Therapy': '电气冲击',
      'Steel Scales': '钢鳞',
      'Tetra Burst': '四方爆炸',
      'The Lion\'s Breath': '火焰吐息',
      'Yorn Pig': '豚鼠'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '(?<!Hummel)Faust': '파우스트',
      '(?<!Smart)Bomb': '폭탄',
      'Hummelfaust': '네오 파우스트',
      'Gobbledygroper': '고블키마이라',
      'Ratfinx Twinkledinks': '재주꾼 랫핑크스',
      'Smartbomb': '초고성능 폭탄',
      'The Clevering': '고블린 과학 연구실',
      'Gobbledygawker': '고블주시자',
      'Glassy-Eyed Cobra': '약에 찌든 코브라',
      'Glassy-Eyed Minotaur': '약에 찌든 미노타우로스'
    },
    'replaceText': {
      '--big--': '--커짐--',
      '--small--': '--작아짐--',
      '10-Tonze Slash': '10톤즈 베기',
      'Big Burst': '대폭발',
      'Bomb\'s Away': '폭탄 투하',
      'Boost': '힘 모으기',
      'Cobra': '코브라',
      'Disorienting Groan': '우렁찬 외침',
      'Feast': '사육제',
      'Glupgloop': '강산성 극약',
      'Gobbledygawker': '고블주시자',
      'Gobbledygroper Add': '고블주시자 등장',
      'Gobcut/Straight': '올려치기/직격타',
      'Gobdash': '노도의 접근 강타',
      'Gobhook': '저력의 옆치기',
      'Gobjab': '견제타',
      'Gobswing': '격진의 주먹 휘두르기',
      'Guzzle': '들이켜기',
      'Gobstraight/Cut': '직격타/올려치기',
      'Kaltstrahl': '냉병기 공격',
      'Minotaur': '미노타우로스',
      'Oogle': '석화 시선',
      'Panzer Vor': '기갑 전진',
      'Panzerschreck': '대전차포',
      'Regorge': '게워내기',
      'Relaxant': '약효 소진',
      'Shabti': '샤브티',
      'Shock Therapy': '감전 충격',
      'Steel Scales': '강철 비늘',
      'Tetra Burst': '사방 폭발',
      'The Lion\'s Breath': '화염 숨결',
      'Yorn Pig': '모르모트'
    }
  }]
};
/* harmony default export */ const a5s = (a5s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a5s.txt
const raid_a5s_namespaceObject = "### A5S\r\n# Alexander - The Fist of the Son (Savage)\r\n# https://dtguilds.enjin.com/a5sguide\r\n# -p 16CC:1009.8 1598:2001\r\n# -ii 16AD 169D 16A4\r\n\r\nhideall \"Guzzle\"\r\nhideall \"Relaxant\"\r\n\r\n### Hummel and Friends\r\n# The Clevering will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"6AF\" } window 1000,0\r\n1009.8 \"Kaltstrahl x1\" Ability { id: \"16CC\", source: \"Faust\" } window 10,5\r\n1018.9 \"Kaltstrahl x2\" Ability { id: \"16CC\", source: \"Faust\" } duration 2.1 window 5,0.5\r\n#1021.0 \"Kaltstrahl\" Ability { id: \"16CC\", source: \"Faust\" }\r\n1032.1 \"Kaltstrahl x3\" Ability { id: \"16CC\", source: \"Faust\" } duration 4.2 window 5,0.5\r\n#1034.2 \"Kaltstrahl\" Ability { id: \"16CC\", source: \"Faust\" }\r\n#1036.3 \"Kaltstrahl\" Ability { id: \"16CC\", source: \"Faust\" }\r\n1043.4 \"Kaltstrahl x3\" Ability { id: \"16CC\", source: \"Faust\" } duration 4.2 window 5,0.5\r\n#1045.5 \"Kaltstrahl\" Ability { id: \"16CC\", source: \"Faust\" }\r\n#1047.6 \"Kaltstrahl\" Ability { id: \"16CC\", source: \"Faust\" }\r\n\r\n1051.6 \"--sync--\" StartsUsing { id: \"16D2\", source: \"Hummelfaust\" } window 52,10\r\n\r\n# Note: if previous Fausts haven't been destroyed,\r\n# There's a 3.7 second delay for Reducible Complexity + Pressure Increase.\r\n# These two have been adjusted backwards in time by this to re-sync for it.\r\n# Assume this will not happen in general though.\r\n1053.4 \"--sync--\" Ability { id: \"16CF\", source: \"Faust\" } window 10,10 # Reducible Complexity\r\n1056.0 \"--sync--\" Ability { id: \"16CD\", source: \"Hummelfaust\" } window 10,10 # Pressure Increase.\r\n\r\n1056.6 \"Panzer Vor\" Ability { id: \"16D2\", source: \"Hummelfaust\" }\r\n1065.2 \"Kaltstrahl x2\" Ability { id: \"16CE\", source: \"Hummelfaust\" } duration 2.1 window 5,0.5\r\n#1067.3 \"Kaltstrahl\" Ability { id: \"16CE\", source: \"Hummelfaust\" }\r\n1085.4 \"Kaltstrahl x3\" Ability { id: \"16CE\", source: \"Hummelfaust\" } duration 4.2 window 5,0.5\r\n#1087.5 \"Kaltstrahl\" Ability { id: \"16CE\", source: \"Hummelfaust\" }\r\n#1089.6 \"Kaltstrahl\" Ability { id: \"16CE\", source: \"Hummelfaust\" }\r\n1101.7 \"Panzerschreck\" Ability { id: \"16D0\", source: \"Hummelfaust\" } window 15,15\r\n1110.9 \"Kaltstrahl x4\" Ability { id: \"16CE\", source: \"Hummelfaust\" } duration 6.3 window 5,0.5\r\n#1113.0 \"Kaltstrahl\" Ability { id: \"16CE\", source: \"Hummelfaust\" }\r\n#1115.1 \"Kaltstrahl\" Ability { id: \"16CE\", source: \"Hummelfaust\" }\r\n#1117.2 \"Kaltstrahl\" Ability { id: \"16CE\", source: \"Hummelfaust\" }\r\n1128.3 \"Panzerschreck\" Ability { id: \"16D0\", source: \"Hummelfaust\" }\r\n1134.4 \"Panzerschreck\" Ability { id: \"16D0\", source: \"Hummelfaust\" }\r\n1138.5 \"Kaltstrahl x4\" Ability { id: \"16CE\", source: \"Hummelfaust\" } duration 6.3 window 5,0.5\r\n#1140.6 \"Kaltstrahl\" Ability { id: \"16CE\", source: \"Hummelfaust\" }\r\n#1142.7 \"Kaltstrahl\" Ability { id: \"16CE\", source: \"Hummelfaust\" }\r\n#1144.8 \"Kaltstrahl\" Ability { id: \"16CE\", source: \"Hummelfaust\" }\r\n# FIXME: maybe more abilities if Fausts are pushed quickly?\r\n\r\n# Time-based enrage.\r\n1150.7 \"--sync--\" StartsUsing { id: \"16D1\", source: \"Hummelfaust\" } window 151,20\r\n1154.7 \"Panzerschreck Enrage\" Ability { id: \"16D1\", source: \"Hummelfaust\" }\r\n\r\n\r\n\r\n### Ratfinx Twinkledinks\r\n# This happens so quickly, no need for \"Advanced Clevering will be sealed off\".\r\n2000.0 \"Start\"\r\n2001.0 \"Guzzle\" Ability { id: \"1598\", source: \"Ratfinx Twinkledinks\" } window 2001,30\r\n2005.6 \"--big--\" Ability { id: \"1599\", source: \"Ratfinx Twinkledinks\" }\r\n2009.1 \"Gobjab 1\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2013.2 \"Gobjab 2\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2017.3 \"Gobjab 3\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2021.4 \"Gobjab 4\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2028.5 \"Gobstraight/Cut\" Ability { id: \"16A[AC]\", source: \"Ratfinx Twinkledinks\" }\r\n2041.1 \"Gobdash\" Ability { id: \"16AF\", source: \"Ratfinx Twinkledinks\" }\r\n\r\n# will push at 90%\r\n2047.3 \"Relaxant\" Ability { id: \"159B\", source: \"Ratfinx Twinkledinks\" } window 50,20\r\n2049.4 \"--small--\" Ability { id: \"1687\", source: \"Ratfinx Twinkledinks\" }\r\n2058.9 \"Glupgloop\" Ability { id: \"16AE\", source: \"Ratfinx Twinkledinks\" }\r\n2068.0 \"Cobra x2 (NE/SE)\"\r\n2069.0 \"Glupgloop\" Ability { id: \"16AE\", source: \"Ratfinx Twinkledinks\" }\r\n2074.1 \"Shock Therapy\" Ability { id: \"159C\", source: \"Ratfinx Twinkledinks\" }\r\n2077.3 \"Steel Scales\" #Ability { id: \"16A2\", source: \"Glassy-Eyed Cobra\" }\r\n2078.5 \"Regorge\" #Ability { id: \"16A1\", source: \"Glassy-Eyed Cobra\" }\r\n2085.3 \"Shock Therapy\" Ability { id: \"159C\", source: \"Ratfinx Twinkledinks\" }\r\n\r\n2098.5 \"Bomb's Away\" Ability { id: \"1590\", source: \"Ratfinx Twinkledinks\" }\r\n2112.4 \"Tetra Burst\" Ability { id: \"16A3\", source: \"Bomb\" }\r\n2112.6 \"Big Burst\" Ability { id: \"16A5\", source: \"Smartbomb\" }\r\n2118.6 \"Shock Therapy\" Ability { id: \"159C\", source: \"Ratfinx Twinkledinks\" }\r\n\r\n2123.8 \"Guzzle\" Ability { id: \"1598\", source: \"Ratfinx Twinkledinks\" } window 110,20\r\n2128.4 \"--big--\" Ability { id: \"1599\", source: \"Ratfinx Twinkledinks\" }\r\n2135.9 \"Boost\" Ability { id: \"16A6\", source: \"Ratfinx Twinkledinks\" }\r\n2139.1 \"Gobswing x4\" duration 6.3 #Ability { id: \"16A7\", source: \"Ratfinx Twinkledinks\" }\r\n2144.9 \"Tetra Burst 1\" #Ability { id: \"16A3\", source: \"Bomb\" }\r\n2145.9 \"Tetra Burst 2\" #Ability { id: \"16A3\", source: \"Bomb\" }\r\n2146.9 \"Tetra Burst 3\" #Ability { id: \"16A3\", source: \"Bomb\" }\r\n2147.9 \"Tetra Burst 4\" #Ability { id: \"16A3\", source: \"Bomb\" }\r\n2158.1 \"Gobdash\" Ability { id: \"16AF\", source: \"Ratfinx Twinkledinks\" }\r\n2164.2 \"Gobhook\" Ability { id: \"15A0\", source: \"Ratfinx Twinkledinks\" }\r\n2171.4 \"Gobjab 1\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2175.5 \"Gobjab 2\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2179.6 \"Gobjab 3\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2183.7 \"Gobjab 4\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2191.8 \"Gobcut/Straight\" Ability { id: \"16A[AC]\", source: \"Ratfinx Twinkledinks\" }\r\n\r\n2201.0 \"Relaxant\" Ability { id: \"159B\", source: \"Ratfinx Twinkledinks\" } window 140,20\r\n2203.1 \"--small--\" Ability { id: \"1687\", source: \"Ratfinx Twinkledinks\" }\r\n2203.6 \"Gobbledygroper Add\"\r\n2214.1 \"The Lion's Breath\" #Ability { id: \"16A8\", source: \"Gobbledygroper\" }\r\n2230.6 \"Glupgloop\" Ability { id: \"16AE\", source: \"Ratfinx Twinkledinks\" }\r\n2237.7 \"Bomb's Away\" Ability { id: \"1590\", source: \"Ratfinx Twinkledinks\" }\r\n2242.8 \"Shock Therapy\" Ability { id: \"159C\", source: \"Ratfinx Twinkledinks\" }\r\n2243.0 \"Tetra Burst\" Ability { id: \"16A3\", source: \"Bomb\" }\r\n2250.9 \"Shock Therapy\" Ability { id: \"159C\", source: \"Ratfinx Twinkledinks\" }\r\n2251.8 \"Big Burst\" Ability { id: \"16A5\", source: \"Smartbomb\" }\r\n2252.0 \"Tetra Burst\" Ability { id: \"16A3\", source: \"Bomb\" }\r\n2259.0 \"Shock Therapy\" Ability { id: \"159C\", source: \"Ratfinx Twinkledinks\" }\r\n2267.1 \"Shock Therapy\" Ability { id: \"159C\", source: \"Ratfinx Twinkledinks\" }\r\n2275.3 \"Shock Therapy\" Ability { id: \"159C\", source: \"Ratfinx Twinkledinks\" }\r\n\r\n2277.5 \"Guzzle\" Ability { id: \"1598\", source: \"Ratfinx Twinkledinks\" } window 140,20\r\n2282.1 \"--big--\" Ability { id: \"1599\", source: \"Ratfinx Twinkledinks\" }\r\n2289.6 \"Boost\" Ability { id: \"16A6\", source: \"Ratfinx Twinkledinks\" }\r\n2292.8 \"Gobswing x4\" duration 6.3 #Ability { id: \"16A7\", source: \"Ratfinx Twinkledinks\" }\r\n2298.7 \"Tetra Burst x4\" Ability { id: \"16A3\", source: \"Bomb\" }\r\n2321.2 \"Gobstraight/Cut\" Ability { id: \"16A[AC]\", source: \"Ratfinx Twinkledinks\" }\r\n2325.5 \"Gobdash\" Ability { id: \"16AF\", source: \"Ratfinx Twinkledinks\" }\r\n2329.2 \"Gobdash\" Ability { id: \"16AF\", source: \"Ratfinx Twinkledinks\" }\r\n2336.0 \"Gobhook\" Ability { id: \"15A0\", source: \"Ratfinx Twinkledinks\" }\r\n\r\n2343.5 \"Gobjab 1\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2347.6 \"Gobjab 2\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2351.7 \"Gobjab 3\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2355.8 \"Gobjab 4\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2362.9 \"Gobcut/Straight\" Ability { id: \"16A[AC]\", source: \"Ratfinx Twinkledinks\" }\r\n\r\n2381.1 \"Relaxant\" Ability { id: \"159B\", source: \"Ratfinx Twinkledinks\" } window 170,20\r\n2383.2 \"--small--\" Ability { id: \"1687\", source: \"Ratfinx Twinkledinks\" }\r\n2386.7 \"Minotaur (NW)\"\r\n2386.7 \"Yorn Pig x6 (NE)\"\r\n2390.8 \"Gobbledygawker x2 (SE/SW)\"\r\n2398.1 \"10-Tonze Slash\" #Ability { id: \"16A0\", source: \"Glassy-Eyed Minotaur\" }\r\n2399.2 \"Oogle\" #Ability { id: \"169C\", source: \"Gobbledygawker\" }\r\n2407.6 \"Yorn Pig x3 (NW)\"\r\n2410.8 \"Glupgloop\" Ability { id: \"16AE\", source: \"Ratfinx Twinkledinks\" }\r\n2411.8 \"Cobra (NE)\"\r\n2414.4 \"Shabti (SE)\"\r\n2415.3 \"Feast\" #Ability { id: \"169A\", source: \"Glassy-Eyed Minotaur\" }\r\n2420.4 \"Disorienting Groan\" #Ability { id: \"169B\", source: \"Glassy-Eyed Minotaur\" }\r\n2433.5 \"10-Tonze Slash\" #Ability { id: \"16A0\", source: \"Glassy-Eyed Minotaur\" }\r\n2435.0 \"Shock Therapy\" Ability { id: \"159C\", source: \"Ratfinx Twinkledinks\" }\r\n2443.2 \"Shock Therapy\" Ability { id: \"159C\", source: \"Ratfinx Twinkledinks\" }\r\n2451.4 \"Shock Therapy\" Ability { id: \"159C\", source: \"Ratfinx Twinkledinks\" }\r\n2459.5 \"Shock Therapy\" Ability { id: \"159C\", source: \"Ratfinx Twinkledinks\" }\r\n2467.7 \"Shock Therapy\" Ability { id: \"159C\", source: \"Ratfinx Twinkledinks\" }\r\n\r\n2472.9 \"Guzzle\" Ability { id: \"1598\", source: \"Ratfinx Twinkledinks\" } window 190,20\r\n2477.5 \"--big--\" Ability { id: \"1599\", source: \"Ratfinx Twinkledinks\" }\r\n2485.0 \"Gobjab 1\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2489.1 \"Gobjab 2\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2493.2 \"Gobjab 3\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2497.3 \"Gobjab 4\" Ability { id: \"16A9\", source: \"Ratfinx Twinkledinks\" }\r\n2505.4 \"Gobstraight/Cut\" Ability { id: \"16A[AC]\", source: \"Ratfinx Twinkledinks\" }\r\n\r\n2513.6 \"Relaxant\" Ability { id: \"159B\", source: \"Ratfinx Twinkledinks\" } window 180,20\r\n2515.7 \"--small--\" Ability { id: \"1687\", source: \"Ratfinx Twinkledinks\" }\r\n2516.4 \"Gobbledygroper Add\"\r\n2526.7 \"The Lion's Breath\" #Ability { id: \"16A8\", source: \"Gobbledygroper\" }\r\n2532.9 \"The Lion's Breath\" #Ability { id: \"16A8\", source: \"Gobbledygroper\" }\r\n2543.3 \"Glupgloop\" Ability { id: \"16AE\", source: \"Ratfinx Twinkledinks\" }\r\n2555.7 \"Tetra Burst\" Ability { id: \"16A3\", source: \"Bomb\" }\r\n# TODO: Maybe there are more mechanics here if you pushed the first phase quickly?\r\n\r\n\r\n### Enrage (time-based)\r\n# We could sync down here on an 16A4 ability, which is the damage,\r\n# but that point you're dead.\r\n2700.0 \"--sync--\" StartsUsing { id: \"159C\", source: \"Ratfinx Twinkledinks\" } window 200,200\r\n2703.0 \"Shock Therapy Enrage\" Ability { id: \"159C\", source: \"Ratfinx Twinkledinks\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a6n.ts



const a6n_triggerSet = {
  id: 'AlexanderTheCuffOfTheSon',
  zoneId: zone_id/* default.AlexanderTheCuffOfTheSon */.Z.AlexanderTheCuffOfTheSon,
  timelineFile: 'a6n.txt',
  timelineTriggers: [{
    id: 'A6N Mind Blast',
    regex: /Mind Blast/,
    beforeSeconds: 4,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // The busters are often enough and mild enough to be not worth notifying for Feint/Addle.
    id: 'A6N Brute Force',
    regex: /Brute Force/,
    beforeSeconds: 4,
    condition: data => data.role === 'tank' || data.role === 'healer' || data.job === 'BLU',
    response: responses/* Responses.miniBuster */.n3.miniBuster()
  }, {
    id: 'A6N Magicked Mark',
    regex: /Magicked Mark/,
    beforeSeconds: 4,
    condition: data => data.role === 'tank' || data.role === 'healer' || data.job === 'BLU',
    response: responses/* Responses.miniBuster */.n3.miniBuster()
  }],
  triggers: [{
    id: 'A6N Minefield',
    type: 'StartsUsing',
    netRegex: {
      source: 'Blaster',
      id: '170D',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.avoidMines(),
    outputStrings: {
      avoidMines: {
        en: 'Avoid Mines',
        de: 'Mienen vermeiden',
        fr: 'Évitez les mines',
        ja: '地雷を踏まない',
        cn: '躲开地雷',
        ko: '지뢰 피하기'
      }
    }
  }, {
    id: 'A6N Supercharge',
    type: 'StartsUsing',
    netRegex: {
      source: 'Blaster Mirage',
      id: '1713',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge Mirage Charge',
        de: 'Superladung ausweichen',
        fr: 'Esquivez la charge de la réplique',
        ja: 'スーパーチャージを避ける',
        cn: '躲开冲锋',
        ko: '환영 돌진 피하기'
      }
    }
  }, {
    id: 'A6N Low Arithmeticks',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3FD'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go High',
        de: 'Geh Hoch',
        fr: 'Allez en haut',
        ja: '高い床に乗る',
        cn: '上高台',
        ko: '높은곳으로'
      }
    }
  }, {
    id: 'A6N High Arithmeticks',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3FE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Low',
        de: 'Geh Runter',
        fr: 'Allez en bas',
        ja: '低い床に乗る',
        cn: '下低台',
        ko: '낮은곳으로'
      }
    }
  }, {
    id: 'A6N Bio-arithmeticks',
    type: 'StartsUsing',
    netRegex: {
      source: 'Swindler',
      id: '171F',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'A6N Enumeration',
    type: 'HeadMarker',
    netRegex: {
      id: ['0040', '0041', '0042']
    },
    infoText: (data, matches, output) => {
      // 0040 = 2, 0041 = 3, 0042 = 4
      const count = 2 + parseInt(matches.id, 16) - parseInt('0040', 16);
      return output.text({
        player: data.party.member(matches.target),
        count: count
      });
    },
    outputStrings: {
      text: {
        en: '${player}: ${count}',
        de: '${player}: ${count}',
        fr: '${player}: ${count}',
        ja: '${player}: ${count}',
        cn: '${player}生命计算法: ${count}',
        ko: '${player}: ${count}'
      }
    }
  }, {
    id: 'A6N Super Cyclone',
    type: 'StartsUsing',
    netRegex: {
      source: 'Vortexer',
      id: '1728',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'A6N Ultra Flash',
    type: 'StartsUsing',
    netRegex: {
      source: 'Vortexer',
      id: '1722',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Ice',
        de: 'Hinter dem Eis verstecken',
        fr: 'Cachez-vous derrière la glace',
        ja: '氷柱の後ろに',
        cn: '躲在冰柱之后',
        ko: '얼음 뒤에 숨기'
      }
    }
  }, {
    id: 'A6N Ice Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0043'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Ice: Freeze Tornado',
        de: 'Eis: Tornado einfrieren',
        fr: 'Glace : Gelez la tornade',
        ja: '氷柱: 竜巻を凍結',
        cn: '冰柱: 冻结龙卷风',
        ko: '얼음: 물기둥 얼리기'
      }
    }
  }, {
    id: 'A6N Compressed Water Initial',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3FF'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Water on YOU',
        de: 'Wasser auf DIR',
        fr: 'Eau sur VOUS',
        ja: '自分に水',
        cn: '水点名',
        ko: '물징 대상자'
      }
    }
  }, {
    id: 'A6N Compressed Water Explode',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3FF'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 5,
    alertText: (_data, _matches, output) => {
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'Drop Water Soon',
        de: 'Gleich Wasser ablegen',
        fr: 'Déposez l\'eau bientôt',
        ja: '水来るよ',
        cn: '马上水分摊',
        ko: '곧 물징 폭발'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Single Buster/Double Buster/Rocket Drill': 'Buster/Drill'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Blaster(?! Mirage)': 'Blaster',
      'Blaster Mirage': 'Blaster-Replikant',
      'Brawler': 'Blechbrecher',
      'Machinery Bay 67': 'Kampfmaschinen-Baracke 67',
      'Machinery Bay 68': 'Kampfmaschinen-Baracke 68',
      'Machinery Bay 69': 'Kampfmaschinen-Baracke 69',
      'Machinery Bay 70': 'Kampfmaschinen-Baracke 70',
      'Swindler': 'Schwindler',
      'Vortexer': 'Wirbler'
    },
    'replaceText': {
      '--unseal--': '--öffnen--',
      'Attachment': 'Anlegen',
      'Ballistic Missile': 'Ballistische Rakete',
      'Bio-Arithmeticks': 'Biomathematik',
      'Brute Force': 'Brutaler Schlag',
      'Crashing Wave': 'Brechende Welle',
      'Earth Missile': 'Erd-Geschoss',
      'Elemental Jammer': 'Elementarstörer',
      'Enumeration': 'Zählen',
      'Height': 'Nivellierung',
      'Ice Missile': 'Eisgeschoss',
      'Magicked Mark': 'Magiegeschoss',
      'Mind Blast': 'Geiststoß',
      'Mirage': 'Illusion',
      'Super Cyclone': 'Superzyklon',
      'Ultra Flash': 'Ultrablitz',
      'Minefield': 'Minenfeld',
      'Supercharge': 'Superladung',
      'Single Buster': 'Einzelsprenger',
      'Double Buster': 'Doppelsprenger',
      'Rocket Drill': 'Raketenbohrer'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Blaster(?! Mirage)': 'Fracasseur',
      'Blaster Mirage': 'réplique du Fracasseur',
      'Brawler': 'Bagarreur',
      'Machinery Bay 67': 'Hangar d\'armement HA-67',
      'Machinery Bay 68': 'Hangar d\'armement HA-68',
      'Machinery Bay 69': 'Hangar d\'armement HA-69',
      'Machinery Bay 70': 'Hangar d\'armement HA-70',
      'Swindler': 'Arnaqueur',
      'Vortexer': 'Tourbillonneur'
    },
    'replaceText': {
      '--unseal--': '--descellement--',
      'Attachment': 'Extension',
      'Ballistic Missile': 'Missiles balistiques',
      'Bio-Arithmeticks': 'Biomathématiques',
      'Brute Force': 'Force brute',
      'Crashing Wave': 'Vague percutante',
      'Earth Missile': 'Missile de terre',
      'Elemental Jammer': 'Grippage élémentaire',
      'Enumeration': 'Compte',
      'Height': 'Dénivellation',
      'Ice Missile': 'Missile de glace',
      'Magicked Mark': 'Tir magique',
      'Mind Blast': 'Explosion mentale',
      'Mirage': 'Mirage',
      'Super Cyclone': 'Super cyclone',
      'Ultra Flash': 'Ultraflash',
      'Minefield': 'Champ de mines',
      'Supercharge': 'Super charge',
      'Single Buster/Double Buster/Rocket Drill': 'Réacteur/Foreuse'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Blaster(?! Mirage)': 'ブラスター',
      'Blaster Mirage': 'ブラスター・ミラージュ',
      'Brawler': 'ブロウラー',
      'Machinery Bay 67': '第67機工兵格納庫',
      'Machinery Bay 68': '第68機工兵格納庫',
      'Machinery Bay 69': '第69機工兵格納庫',
      'Machinery Bay 70': '第70機工兵格納庫',
      'Swindler': 'スウィンドラー',
      'Vortexer': 'ボルテッカー'
    },
    'replaceText': {
      '--unseal--': '--エリア開放--',
      'Attachment': 'アタッチメント',
      'Ballistic Missile': 'ミサイル発射',
      'Bio-Arithmeticks': '生命計算術',
      'Brute Force': 'ブルートパンチ',
      'Crashing Wave': 'クラッシュウェーブ',
      'Earth Missile': 'アースミサイル',
      'Elemental Jammer': 'エレメンタルジャミング',
      'Enumeration': 'カウント',
      'Height': 'ハイト',
      'Ice Missile': 'アイスミサイル',
      'Magicked Mark': 'マジックショット',
      'Mind Blast': 'マインドブラスト',
      'Mirage': 'ミラージュシステム',
      'Super Cyclone': 'スーパーサイクロン',
      'Ultra Flash': 'ウルトラフラッシュ',
      'Minefield': '地雷散布',
      'Supercharge': 'スーパーチャージ',
      'Single Buster': 'バスターアタック',
      'Double Buster': 'ダブルバスターアタック',
      'Rocket Drill': 'ロケットドリル'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Blaster(?! Mirage)': '爆破者',
      'Blaster Mirage': '爆破者幻象',
      'Brawler': '争斗者',
      'Machinery Bay 67': '第67机工兵仓库',
      'Machinery Bay 68': '第68机工兵仓库',
      'Machinery Bay 69': '第69机工兵仓库',
      'Machinery Bay 70': '第70机工兵仓库',
      'Swindler': '欺诈者',
      'Vortexer': '环旋者'
    },
    'replaceText': {
      '--unseal--': '--解除封锁--',
      'Attachment': '配件更换',
      'Ballistic Missile': '导弹发射',
      'Bio-Arithmeticks': '生命计算术',
      'Brute Force': '残暴铁拳',
      'Crashing Wave': '冲击波',
      'Earth Missile': '大地导弹',
      'Elemental Jammer': '元素干扰',
      'Enumeration': '计数',
      'Height': '高度算术',
      'Ice Missile': '寒冰导弹',
      'Magicked Mark': '魔力射击',
      'Mind Blast': '精神冲击',
      'Mirage': '幻影系统',
      'Super Cyclone': '超级气旋',
      'Ultra Flash': '究极闪光',
      'Minefield': '地雷散布',
      'Supercharge': '超突击',
      'Single Buster': '破坏炮击',
      'Double Buster': '双重破坏炮击',
      'Rocket Drill': '火箭飞钻'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Blaster(?! Mirage)': '폭파자',
      'Blaster Mirage': '폭파자의 환영',
      'Brawler': '폭격자',
      'Machinery Bay 67': '제67기공병 격납고',
      'Machinery Bay 68': '제68기공병 격납고',
      'Machinery Bay 69': '제69기공병 격납고',
      'Machinery Bay 70': '제70기공병 격납고',
      'Swindler': '조작자',
      'Vortexer': '교반자'
    },
    'replaceText': {
      '--unseal--': '--봉인 해제--',
      'Attachment': '무기 장착',
      'Ballistic Missile': '미사일 발사',
      'Bio-Arithmeticks': '생명계산술',
      'Brute Force': '폭력적인 주먹',
      'Crashing Wave': '충격의 파도',
      'Earth Missile': '대지 미사일',
      'Elemental Jammer': '원소 간섭',
      'Enumeration': '계산',
      'Height': '고도',
      'Ice Missile': '얼음 미사일',
      'Magicked Mark': '마법 사격',
      'Mind Blast': '정신파괴',
      'Mirage': '환영 시스템',
      'Super Cyclone': '대형 돌개바람',
      'Ultra Flash': '초섬광',
      'Minefield': '지뢰 살포',
      'Supercharge': '강력 돌진',
      'Single Buster': '한손 버스터',
      'Double Buster': '양손 버스터',
      'Rocket Drill': '한손 드릴'
    }
  }]
};
/* harmony default export */ const a6n = (a6n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a6n.txt
const raid_a6n_namespaceObject = "### A6N\r\n# Alexander - The Cuff Of The Son\r\n\r\n### Blaster\r\n\r\n# -ii 170E\r\n# Machinery Bay 67 will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"6B7\" } window 1,0\r\n6.8 \"Brute Force\" Ability { id: \"170A\", source: \"Blaster\" } window 6.8,5\r\n10.9 \"Mind Blast\" Ability { id: \"170B\", source: \"Blaster\" }\r\n15.0 \"Ballistic Missile\" Ability { id: \"15F4\", source: \"Blaster\" }\r\n19.1 \"Brute Force\" Ability { id: \"170A\", source: \"Blaster\" }\r\n20.0 \"Minefield\" Ability { id: \"170D\", source: \"Blaster\" }\r\n29.2 \"Brute Force\" Ability { id: \"170A\", source: \"Blaster\" }\r\n33.3 \"Mind Blast\" Ability { id: \"170B\", source: \"Blaster\" }\r\n42.5 \"Mirage\" Ability { id: \"1712\", source: \"Blaster Mirage\" } window 15,15\r\n48.7 \"Supercharge\" # Ability { id: \"1713\", source: \"Blaster Mirage\" }\r\n53.8 \"Mind Blast\" Ability { id: \"170B\", source: \"Blaster\" }\r\n\r\n61.9 \"Brute Force\" Ability { id: \"170A\", source: \"Blaster\" } jump 6.8\r\n66.0 \"Mind Blast\"\r\n70.1 \"Ballistic Missile\"\r\n74.2 \"Brute Force\"\r\n75.1 \"Minefield\"\r\n84.3 \"Brute Force\"\r\n\r\n\r\n### Brawler\r\n# Machinery Bay 68 will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"6B8\" } window 1000,0\r\n1008.7 \"Magicked Mark\" Ability { id: \"1715\", source: \"Brawler\" } window 8.7,5\r\n1010.8 \"Attachment\" Ability { id: \"1601\", source: \"Brawler\" }\r\n1017.0 \"Single Buster/Double Buster/Rocket Drill\" Ability { id: [\"1717\", \"1718\", \"1719\"], source: \"Brawler\" }\r\n\r\n1022.1 \"Magicked Mark\" Ability { id: \"1715\", source: \"Brawler\" }\r\n1024.2 \"Attachment\" Ability { id: \"1601\", source: \"Brawler\" } window 5,5\r\n1030.3 \"Single Buster/Double Buster/Rocket Drill\" Ability { id: [\"1717\", \"1718\", \"1719\"], source: \"Brawler\" }\r\n\r\n1035.4 \"Magicked Mark\" Ability { id: \"1715\", source: \"Brawler\" } jump 1022.1\r\n1037.5 \"Attachment\"\r\n1043.6 \"Single Buster/Double Buster/Rocket Drill\"\r\n1048.7 \"Magicked Mark\"\r\n1050.8 \"Attachment\"\r\n1057.1 \"Single Buster/Double Buster/Rocket Drill\"\r\n\r\n\r\n### Swindler\r\n# -ii 171D\r\n# Machinery Bay 69 will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"6B9\" } window 2000,0\r\n2006.5 \"Magicked Mark\" Ability { id: \"171B\", source: \"Swindler\" }\r\n2015.6 \"Height\" Ability { id: \"171C\", source: \"Swindler\" } window 15.6,20\r\n2018.8 \"Magicked Mark\" Ability { id: \"171B\", source: \"Swindler\" }\r\n2026.9 \"Bio-Arithmeticks\" Ability { id: \"171F\", source: \"Swindler\" }\r\n2029.0 \"Magicked Mark\" Ability { id: \"171B\", source: \"Swindler\" }\r\n2034.0 \"Enumeration\" Ability { id: \"171E\", source: \"Swindler\" } window 20,20\r\n2039.1 \"Magicked Mark\" Ability { id: \"171B\", source: \"Swindler\" }\r\n2044.2 \"Bio-Arithmeticks\" Ability { id: \"171F\", source: \"Swindler\" }\r\n\r\n2052.4 \"Magicked Mark\" Ability { id: \"171B\", source: \"Swindler\" } jump 2006.5\r\n2061.5 \"Height\"\r\n2064.7 \"Magicked Mark\"\r\n2072.8 \"Bio-Arithmeticks\"\r\n2074.9 \"Magicked Mark\"\r\n2079.9 \"Enumeration\"\r\n\r\n\r\n### Vortexer\r\n# Machinery Bay 70 will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"6BA\" } window 3000,0\r\n3007.3 \"Brute Force\" Ability { id: \"1721\", source: \"Vortexer\" } window 7.3,5\r\n3017.4 \"Elemental Jammer\" Ability { id: \"161B\", source: \"Vortexer\" }\r\n3019.5 \"Ballistic Missile\" Ability { id: \"1622\", source: \"Vortexer\" }\r\n3023.6 \"Brute Force\" Ability { id: \"1721\", source: \"Vortexer\" }\r\n3025.5 \"Earth Missile\" Ability { id: \"1726\", source: \"Vortexer\" }\r\n3031.7 \"Super Cyclone\" Ability { id: \"1728\", source: \"Vortexer\" } window 15,15\r\n3039.1 \"Crashing Wave\" Ability { id: \"1724\", source: \"Vortexer\" }\r\n3040.9 \"Brute Force\" Ability { id: \"1721\", source: \"Vortexer\" }\r\n3047.0 \"Ballistic Missile\" Ability { id: \"1622\", source: \"Vortexer\" }\r\n3052.3 \"Ice Missile\" Ability { id: \"1727\", source: \"Vortexer\" }\r\n3059.1 \"Super Cyclone\" Ability { id: \"1728\", source: \"Vortexer\" }\r\n3065.3 \"Brute Force\" Ability { id: \"1721\", source: \"Vortexer\" }\r\n3080.4 \"Ultra Flash\" Ability { id: \"1722\", source: \"Vortexer\" } window 30,30\r\n\r\n3082.5 \"Brute Force\" Ability { id: \"1721\", source: \"Vortexer\" } jump 3007.3\r\n3092.6 \"Elemental Jammer\"\r\n3094.7 \"Ballistic Missile\"\r\n3098.8 \"Brute Force\"\r\n3100.7 \"Earth Missile\"\r\n3106.9 \"Super Cyclone\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a6s.ts



const a6s_triggerSet = {
  id: 'AlexanderTheCuffOfTheSonSavage',
  zoneId: zone_id/* default.AlexanderTheCuffOfTheSonSavage */.Z.AlexanderTheCuffOfTheSonSavage,
  timelineFile: 'a6s.txt',
  triggers: [{
    id: 'A6S Magic Vulnerability Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '292'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.magicVulnerability = true
  }, {
    id: 'A6S Magic Vulnerability Loss',
    type: 'LosesEffect',
    netRegex: {
      effectId: '292'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.magicVulnerability = false
  }, {
    id: 'A6S Mind Blast',
    type: 'StartsUsing',
    netRegex: {
      source: 'Blaster',
      id: '15F3'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'A6S Hidden Minefield',
    type: 'StartsUsing',
    netRegex: {
      source: 'Blaster',
      id: '15F7',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.role === 'tank' && !data.magicVulnerability) return output.getMines();
      return output.avoidMines();
    },
    outputStrings: {
      getMines: {
        en: 'Get Mines',
        de: 'Mienen nehmen',
        fr: 'Prenez les mines',
        ja: '地雷を踏む',
        cn: '踩雷',
        ko: '지뢰 밟기'
      },
      avoidMines: {
        en: 'Avoid Mines',
        de: 'Mienen vermeiden',
        fr: 'Évitez les mines',
        ja: '地雷を踏まない',
        cn: '躲开地雷',
        ko: '지뢰 피하기'
      }
    }
  }, {
    id: 'A6S Supercharge',
    type: 'StartsUsing',
    netRegex: {
      source: 'Blaster Mirage',
      id: '15FB',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge Mirage Charge',
        de: 'Superladung ausweichen',
        fr: 'Esquivez la charge de la réplique',
        ja: 'スーパーチャージを避ける',
        cn: '躲开冲锋',
        ko: '환영 돌진 피하기'
      }
    }
  }, {
    id: 'A6S Blinder',
    type: 'StartsUsing',
    netRegex: {
      source: 'Blaster Mirage',
      id: '15FC'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look Away from Mirage',
        de: 'Von Replikant wegschauen',
        fr: 'Ne regardez pas la réplique',
        ja: 'ミラージュを見ない',
        cn: '背对幻象',
        ko: '환영 쳐다보지 않기'
      }
    }
  }, {
    id: 'A6S Power Tackle',
    type: 'StartsUsing',
    netRegex: {
      source: 'Blaster Mirage',
      id: '15FD'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look Towards Mirage',
        de: 'Von Replikant hinschauen',
        fr: 'Regardez la réplique',
        ja: 'ミラージュを見る',
        cn: '面向幻象',
        ko: '환영 쳐다보기'
      }
    }
  }, {
    id: 'A6S Low Arithmeticks',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3FD'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go High',
        de: 'Geh Hoch',
        fr: 'Allez en haut',
        ja: '高い床に乗る',
        cn: '上高台',
        ko: '높은곳으로'
      }
    }
  }, {
    id: 'A6S High Arithmeticks',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3FE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Low',
        de: 'Geh Runter',
        fr: 'Allez en bas',
        ja: '低い床に乗る',
        cn: '下低台',
        ko: '낮은곳으로'
      }
    }
  }, {
    id: 'A6S Bio-arithmeticks',
    type: 'StartsUsing',
    netRegex: {
      source: 'Swindler',
      id: '1610',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'A6S Midan Hardhelm',
    type: 'StartsUsing',
    netRegex: {
      source: 'Midan Hardhelm',
      id: '1612'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun()
  }, {
    id: 'A6S Midan Hardmind',
    type: 'StartsUsing',
    netRegex: {
      source: 'Midan Hardhelm',
      id: '1613'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun()
  }, {
    id: 'A6S Enumeration',
    type: 'HeadMarker',
    netRegex: {
      id: ['0040', '0041', '0042']
    },
    infoText: (data, matches, output) => {
      // 0040 = 2, 0041 = 3, 0042 = 4
      const count = 2 + parseInt(matches.id, 16) - parseInt('0040', 16);
      return output.text({
        player: data.party.member(matches.target),
        count: count
      });
    },
    outputStrings: {
      text: {
        en: '${player}: ${count}',
        de: '${player}: ${count}',
        fr: '${player}: ${count}',
        ja: '${player}: ${count}',
        cn: '${player}生命计算法: ${count}',
        ko: '${player}: ${count}'
      }
    }
  }, {
    id: 'A6S Super Cyclone',
    type: 'StartsUsing',
    netRegex: {
      source: 'Vortexer',
      id: '1627',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'A6S Ultra Flash',
    type: 'StartsUsing',
    netRegex: {
      source: 'Vortexer',
      id: '161A',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Ice',
        de: 'Hinter dem Eis verstecken',
        fr: 'Cachez-vous derrière la glace',
        ja: '氷柱の後ろに',
        cn: '躲在冰柱之后',
        ko: '얼음 뒤에 숨기'
      }
    }
  }, {
    id: 'A6S Ice Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0043'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Ice: Freeze Tornado',
        de: 'Eis: Tornado einfrieren',
        fr: 'Glace : Gelez la tornade',
        ja: '氷柱: 竜巻を凍結',
        cn: '冰柱: 冻结龙卷风',
        ko: '얼음: 물기둥 얼리기'
      }
    }
  }, {
    id: 'A6S Fire Beam',
    type: 'HeadMarker',
    netRegex: {
      id: '0019'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // TODO: maybe this should say "hit tornado / avoid ice" but that's wordy.
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fire Beam on YOU',
        de: 'Feuer Strahl auf DIR',
        fr: 'Rayon de feu sur VOUS',
        ja: '自分にファイアビーム',
        cn: '火焰光束点名',
        ko: '화염 광선 대상자'
      }
    }
  }, {
    id: 'A6S Compressed Water Initial',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3FF'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.haveWater = true,
    outputStrings: {
      text: {
        en: 'Water on YOU',
        de: 'Wasser auf DIR',
        fr: 'Eau sur VOUS',
        ja: '自分に水',
        cn: '水点名',
        ko: '물징 대상자'
      }
    }
  }, {
    id: 'A6S Compressed Water Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '3FF'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.haveWater = false
  }, {
    id: 'A6S Compressed Water Explode',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3FF'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 5,
    alertText: (data, _matches, output) => {
      if (!data.haveWater) return;
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'Drop Water Soon',
        de: 'Gleich Wasser ablegen',
        fr: 'Déposez l\'eau bientôt',
        ja: '水来るよ',
        cn: '马上水分摊',
        ko: '곧 물징 폭발'
      }
    }
  }, {
    id: 'A6S Compressed Lightning Initial',
    type: 'GainsEffect',
    netRegex: {
      effectId: '400'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.haveLightning = true,
    outputStrings: {
      text: {
        en: 'Lightning on YOU',
        de: 'Blitz auf DIR',
        fr: 'Éclair sur VOUS',
        ja: '自分に雷',
        cn: '雷点名',
        ko: '번개징 대상자'
      }
    }
  }, {
    id: 'A6S Compressed Lightning Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '400'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.haveLightning = false
  }, {
    id: 'A6S Compressed Lightning Explode',
    type: 'GainsEffect',
    netRegex: {
      effectId: '400'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 5,
    alertText: (data, _matches, output) => {
      if (!data.haveLightning) return;
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'Drop Lightning Soon',
        de: 'Gleich Blitz ablegen',
        fr: 'Déposez l\'éclair bientôt',
        ja: '雷来るよ',
        cn: '马上雷分摊',
        ko: '곧 번개징 폭발'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Blaster(?! Mirage)': 'Blaster',
      'Blaster Mirage': 'Blaster-Replikant',
      'Brawler': 'Blechbrecher',
      'Machinery Bay 67': 'Kampfmaschinen-Baracke 67',
      'Machinery Bay 68': 'Kampfmaschinen-Baracke 68',
      'Machinery Bay 69': 'Kampfmaschinen-Baracke 69',
      'Machinery Bay 70': 'Kampfmaschinen-Baracke 70',
      'Midan Gunner': 'Midas-Schütze',
      'Midan Hardhelm': 'Midas-Harthelm',
      'Power Plasma Alpha': 'Kraftplasma Alpha',
      'Swindler': 'Schwindler',
      'Vortexer': 'Wirbler'
    },
    'replaceText': {
      '--unseal--': '--öffnen--',
      'Attachment': 'Anlegen',
      'Auxiliary Power': 'Notstrom',
      'Ballistic Missile': 'Ballistische Rakete',
      'Bio-Arithmeticks': 'Biomathematik',
      'Brawler Mechanic': 'Brawler Mechanik',
      'Brute Force': 'Brutaler Schlag',
      'Crashing Thunder': 'Brechende Wolke',
      'Crashing Wave': 'Brechende Welle',
      'Earth Missile': 'Erd-Geschoss',
      'Elemental Jammer': 'Elementarstörer',
      'Enumeration': 'Zählen',
      'Fire Beam': 'Feuerstrahl',
      'Gobwalker': 'Gobwalker',
      'Height': 'Nivellierung',
      'Hidden Minefield': 'Getarntes Minenfeld',
      'Ice Missile': 'Eisgeschoss',
      'Magicked Mark': 'Magiegeschoss',
      'Midan Gunner': 'Midas-Schütze',
      'Midan Hardhelm': 'Midas-Harthelm',
      'Midan Hardmind': 'Midas-Sturschale',
      'Midan Soldier': 'Midas-Soldat',
      'Mind Blast': 'Geiststoß',
      'Mirage': 'Illusion',
      'Power Plasma Alpha': 'Kraftplasma Alpha',
      'Power Plasma Beta': 'Kraftplasma Beta',
      'Power Plasma Gamma': 'Kraftplasma Gamma',
      'Snipethoom': 'Fangschuss',
      'Super Cyclone': 'Superzyklon',
      'Ultra Flash': 'Ultrablitz'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Blaster(?! Mirage)': 'Fracasseur',
      'Blaster Mirage': 'réplique du Fracasseur',
      'Brawler': 'Bagarreur',
      'Machinery Bay 67': 'Hangar d\'armement HA-67',
      'Machinery Bay 68': 'Hangar d\'armement HA-68',
      'Machinery Bay 69': 'Hangar d\'armement HA-69',
      'Machinery Bay 70': 'Hangar d\'armement HA-70',
      'Midan Gunner': 'canonnier midin',
      'Power Plasma Alpha': 'plasma puissant α',
      'Swindler': 'Arnaqueur',
      'Vortexer': 'Tourbillonneur',
      'Midan Hardhelm': 'casque-dur midin'
    },
    'replaceText': {
      '--unseal--': '--descellement--',
      'Attachment': 'Extension',
      'Auxiliary Power': 'Soutien énergétique',
      'Ballistic Missile': 'Missiles balistiques',
      'Bio-Arithmeticks': 'Biomathématiques',
      'Brawler Mechanic': 'Mécanique du Bagarreur',
      'Brute Force': 'Force brute',
      'Crashing Thunder': 'Éclair percutant',
      'Crashing Wave': 'Vague percutante',
      'Earth Missile': 'Missile de terre',
      'Elemental Jammer': 'Grippage élémentaire',
      'Enumeration': 'Compte',
      'Fire Beam': 'Rayon de feu',
      'Gobwalker': 'Gobblindé',
      'Height': 'Dénivellation',
      'Hidden Minefield': 'Champ de mines caché',
      'Ice Missile': 'Missile de glace',
      'Magicked Mark': 'Tir magique',
      'Midan Gunner': 'canonnier midin',
      'Midan Hardhelm': 'casque-dur midin',
      'Midan Hardmind': 'cerveau-dur midin',
      'Midan Soldier': 'soldat midin',
      'Mind Blast': 'Explosion mentale',
      'Mirage': 'Mirage',
      'Power Plasma Alpha': 'plasma puissant α',
      'Power Plasma Beta': 'plasma puissant β',
      'Power Plasma Gamma': 'plasma puissant γ',
      'Snipethoom': 'Tir précis',
      'Super Cyclone': 'Super cyclone',
      'Ultra Flash': 'Ultraflash'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Blaster(?! Mirage)': 'ブラスター',
      'Blaster Mirage': 'ブラスター・ミラージュ',
      'Brawler': 'ブロウラー',
      'Machinery Bay 67': '第67機工兵格納庫',
      'Machinery Bay 68': '第68機工兵格納庫',
      'Machinery Bay 69': '第69機工兵格納庫',
      'Machinery Bay 70': '第70機工兵格納庫',
      'Midan Gunner': 'ミダース・ガンナー',
      'Power Plasma Alpha': 'パワープラズマα',
      'Swindler': 'スウィンドラー',
      'Vortexer': 'ボルテッカー',
      'Midan Hardhelm': 'ミダース・ハードヘルム'
    },
    'replaceText': {
      '--unseal--': '--エリア開放--',
      'Attachment': 'アタッチメント',
      'Auxiliary Power': 'エネルギー支援',
      'Ballistic Missile': 'ミサイル発射',
      'Bio-Arithmeticks': '生命計算術',
      'Brawler Mechanic': 'ブロウラー ギミック',
      'Brute Force': 'ブルートパンチ',
      'Crashing Thunder': 'クラッシュサンダー',
      'Crashing Wave': 'クラッシュウェーブ',
      'Earth Missile': 'アースミサイル',
      'Elemental Jammer': 'エレメンタルジャミング',
      'Enumeration': 'カウント',
      'Fire Beam': 'ファイアビーム',
      'Gobwalker': 'ゴブリウォーカーL型',
      'Height': 'ハイト',
      'Hidden Minefield': 'ステルス地雷散布',
      'Ice Missile': 'アイスミサイル',
      'Magicked Mark': 'マジックショット',
      'Midan Gunner': 'ミダース・ガンナー',
      'Midan Hardhelm': 'ミダース・ハードヘルム',
      'Midan Hardmind': 'ミダース・ハードマインド',
      'Midan Soldier': 'ミダース・ソルジャー',
      'Mind Blast': 'マインドブラスト',
      'Mirage': 'ミラージュシステム',
      'Power Plasma Alpha': 'パワープラズマα',
      'Power Plasma Beta': 'パワープラズマβ',
      'Power Plasma Gamma': 'パワープラズマγ',
      'Snipethoom': '狙撃',
      'Super Cyclone': 'スーパーサイクロン',
      'Ultra Flash': 'ウルトラフラッシュ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Blaster(?! Mirage)': '爆破者',
      'Blaster Mirage': '爆破者幻象',
      'Brawler': '争斗者',
      'Machinery Bay 67': '第67机工兵仓库',
      'Machinery Bay 68': '第68机工兵仓库',
      'Machinery Bay 69': '第69机工兵仓库',
      'Machinery Bay 70': '第70机工兵仓库',
      'Midan Gunner': '弥达斯炮手',
      'Power Plasma Alpha': '强离子体α',
      'Swindler': '欺诈者',
      'Vortexer': '环旋者',
      'Midan Hardhelm': '弥达斯硬盔兵'
    },
    'replaceText': {
      '--unseal--': '--解除封锁--',
      'Attachment': '配件更换',
      'Auxiliary Power': '能量支援',
      'Ballistic Missile': '导弹发射',
      'Bio-Arithmeticks': '生命计算术',
      'Brawler Mechanic': '争斗者技能',
      'Brute Force': '残暴铁拳',
      'Crashing Thunder': '冲击雷',
      'Crashing Wave': '冲击波',
      'Earth Missile': '大地导弹',
      'Elemental Jammer': '元素干扰',
      'Enumeration': '计数',
      'Fire Beam': '火焰光束',
      'Gobwalker': '哥布林战车',
      'Height': '高度算术',
      'Hidden Minefield': '隐形地雷散布',
      'Ice Missile': '寒冰导弹',
      'Magicked Mark': '魔力射击',
      'Midan Gunner': '弥达斯炮手',
      'Midan Hardhelm': '弥达斯硬盔兵',
      'Midan Hardmind': '弥达斯铁心兵',
      'Midan Soldier': '弥达斯士兵',
      'Mind Blast': '精神冲击',
      'Mirage': '幻影系统',
      'Power Plasma Alpha': '强离子体α',
      'Power Plasma Beta': '强离子体β',
      'Power Plasma Gamma': '强离子体γ',
      'Snipethoom': '狙击',
      'Super Cyclone': '超级气旋',
      'Ultra Flash': '究极闪光'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Blaster(?! Mirage)': '폭파자',
      'Blaster Mirage': '폭파자의 환영',
      'Brawler': '폭격자',
      'Machinery Bay 67': '제67기공병 격납고',
      'Machinery Bay 68': '제68기공병 격납고',
      'Machinery Bay 69': '제69기공병 격납고',
      'Machinery Bay 70': '제70기공병 격납고',
      'Midan Gunner': '미다스 총잡이',
      'Power Plasma Alpha': '파워 플라스마 α',
      'Swindler': '조작자',
      'Vortexer': '교반자',
      'Midan Hardhelm': '미다스 강화투구'
    },
    'replaceText': {
      '--unseal--': '--봉인 해제--',
      'Attachment': '무기 장착',
      'Auxiliary Power': '에너지 지원',
      'Ballistic Missile': '미사일 발사',
      'Bio-Arithmeticks': '생명계산술',
      'Brute Force': '폭력적인 주먹',
      'Brawler Mechanic': '한손/양손 버스터/드릴',
      'Crashing Thunder': '충격의 번개',
      'Crashing Wave': '충격의 파도',
      'Earth Missile': '대지 미사일',
      'Elemental Jammer': '원소 간섭',
      'Enumeration': '계산',
      'Fire Beam': '화염 광선',
      'Gobwalker': '고블린워커',
      'Height': '고도',
      'Hidden Minefield': '은폐 지뢰 살포',
      'Ice Missile': '얼음 미사일',
      'Magicked Mark': '마법 사격',
      'Midan Gunner': '미다스 총잡이',
      'Midan Hardhelm': '미다스 강화투구',
      'Midan Hardmind': '미다스 강화두뇌',
      'Midan Soldier': '미다스 병사',
      'Mind Blast': '정신파괴',
      'Mirage': '환영 시스템',
      'Power Plasma Alpha': '파워 플라스마 α',
      'Power Plasma Beta': '파워 플라스마 β',
      'Power Plasma Gamma': '파워 플라스마 γ',
      'Snipethoom': '저격',
      'Super Cyclone': '대형 돌개바람',
      'Ultra Flash': '초섬광'
    }
  }]
};
/* harmony default export */ const a6s = (a6s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a6s.txt
const raid_a6s_namespaceObject = "### A6S\r\n# Alexander - The Cuff Of The Son (Savage)\r\n# https://dtguilds.enjin.com/a6sguide\r\n# -p 15F2:7 1600:1008.8 160D:2021.2 1619:3006.7\r\n# -ii 1607 1606 1616 160C 1618 1615 1626 1620 15F5 15FB 15F9 15FC 15FD\r\n\r\nhideall \"Ballistic Missile\"\r\n\r\n### Blaster\r\n# Machinery Bay 67 will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"6B7\" } window 1,0\r\n7.0 \"Brute Force\" Ability { id: \"15F2\", source: \"Blaster\" } window 10,10\r\n14.1 \"Mind Blast\" Ability { id: \"15F3\", source: \"Blaster\" }\r\n18.2 \"Ballistic Missile\" Ability { id: \"15F4\", source: \"Blaster\" }\r\n23.2 \"Hidden Minefield\" Ability { id: \"15F7\", source: \"Blaster\" }\r\n31.4 \"Mirage\" Ability { id: \"15FA\", source: \"Blaster Mirage\" }\r\n39.6 \"Brute Force\" #Ability { id: \"15F2\", source: \"Blaster\" }\r\n43.7 \"Brute Force\" #Ability { id: \"15F2\", source: \"Blaster\" }\r\n\r\n# add phase\r\n46.7 \"--untargetable--\"\r\n49.9 \"--targetable--\"\r\n78.0 \"Mind Blast\" Ability { id: \"15FE\", source: \"Blaster Mirage\" }\r\n\r\n85.2 \"Mirage\" Ability { id: \"15FA\", source: \"Blaster\" } window 40,40\r\n86.2 \"--targetable--\"\r\n91.3 \"Mind Blast\" Ability { id: \"15F3\", source: \"Blaster\" }\r\n94.5 \"Brute Force\" Ability { id: \"15F2\", source: \"Blaster\" }\r\n\r\n97.6 \"Ballistic Missile\" Ability { id: \"15F4\", source: \"Blaster\" }\r\n101.7 \"Brute Force\" Ability { id: \"15F2\", source: \"Blaster\" }\r\n102.6 \"Hidden Minefield\" Ability { id: \"15F7\", source: \"Blaster\" }\r\n110.9 \"Mirage\" Ability { id: \"15FA\", source: \"Blaster Mirage\" }\r\n120.2 \"Brute Force\" Ability { id: \"15F2\", source: \"Blaster\" }\r\n128.3 \"Mind Blast\" Ability { id: \"15F3\", source: \"Blaster\" }\r\n\r\n130.4 \"Ballistic Missile\" Ability { id: \"15F4\", source: \"Blaster\" }\r\n134.5 \"Brute Force\" Ability { id: \"15F2\", source: \"Blaster\" }\r\n135.4 \"Hidden Minefield\" Ability { id: \"15F7\", source: \"Blaster\" }\r\n143.6 \"Mirage\" Ability { id: \"15FA\", source: \"Blaster Mirage\" }\r\n151.8 \"Brute Force\" Ability { id: \"15F2\", source: \"Blaster\" }\r\n162.9 \"Mind Blast\" Ability { id: \"15F3\", source: \"Blaster\" }\r\n166.1 \"Brute Force\" Ability { id: \"15F2\", source: \"Blaster\" }\r\n\r\n169.2 \"Ballistic Missile\" Ability { id: \"15F4\", source: \"Blaster\" } window 20,20 jump 97.6\r\n173.3 \"Brute Force\" #Ability { id: \"15F2\", source: \"Blaster\" }\r\n174.2 \"Hidden Minefield\" #Ability { id: \"15F7\", source: \"Blaster\" }\r\n182.5 \"Mirage\" #Ability { id: \"15FA\", source: \"Blaster Mirage\" }\r\n191.8 \"Brute Force\" #Ability { id: \"15F2\", source: \"Blaster\" }\r\n199.9 \"Mind Blast\" #Ability { id: \"15F3\", source: \"Blaster\" }\r\n\r\n202.0 \"Ballistic Missile\" #Ability { id: \"15F4\", source: \"Blaster\" }\r\n206.1 \"Brute Force\" #Ability { id: \"15F2\", source: \"Blaster\" }\r\n207.0 \"Hidden Minefield\" #Ability { id: \"15F7\", source: \"Blaster\" }\r\n215.2 \"Mirage\" #Ability { id: \"15FA\", source: \"Blaster Mirage\" }\r\n223.4 \"Brute Force\" #Ability { id: \"15F2\", source: \"Blaster\" }\r\n234.5 \"Mind Blast\" #Ability { id: \"15F3\", source: \"Blaster\" }\r\n237.7 \"Brute Force\" #Ability { id: \"15F2\", source: \"Blaster\" }\r\n\r\n\r\n\r\n### Brawler\r\n# Note: \"Brawler Mechanic\" drifts relative to attachment depending on type.\r\n# Brawler Mechanics seem entirely/mostly random?\r\n# Machinery Bay 68 will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"6B8\" } window 1000,0\r\n1008.8 \"Magicked Mark\" Ability { id: \"1600\", source: \"Brawler\" } window 100,100\r\n1011.0 \"Attachment\" Ability { id: \"1601\", source: \"Brawler\" }\r\n1017.2 \"Brawler Mechanic\" #Ability { id: \"160[2345]\", source: \"Brawler\" }\r\n\r\n1022.2 \"Magicked Mark\" #Ability { id: \"1600\", source: \"Brawler\" }\r\n1024.4 \"Attachment\" #Ability { id: \"1601\", source: \"Brawler\" }\r\n1030.6 \"Brawler Mechanic\" #Ability { id: \"160[2345]\", source: \"Brawler\" }\r\n\r\n1035.6 \"Magicked Mark\" #Ability { id: \"1600\", source: \"Brawler\" }\r\n1037.8 \"Attachment\" #Ability { id: \"1601\", source: \"Brawler\" }\r\n1044.0 \"Brawler Mechanic\" #Ability { id: \"160[2345]\", source: \"Brawler\" }\r\n\r\n1049.0 \"Magicked Mark\" #Ability { id: \"1600\", source: \"Brawler\" }\r\n1051.2 \"Attachment\" #Ability { id: \"1601\", source: \"Brawler\" }\r\n1057.4 \"Brawler Mechanic\" #Ability { id: \"160[2345]\", source: \"Brawler\" }\r\n\r\n## Brawler Orb Phase\r\n1500.0 \"--sync--\" NameToggle { name: \"Brawler\", toggle: \"00\" } window 500,0\r\n1503.4 \"Power Plasma Alpha x2\" AddedCombatant { name: \"Power Plasma Alpha\" } window 500,5\r\n1503.4 \"Power Plasma Gamma x2\"\r\n\r\n1508.6 \"Attachment\" Ability { id: \"1601\", source: \"Brawler\" }\r\n1514.7 \"Brawler Mechanic\" #Ability { id: \"160[2345]\", source: \"Brawler\" }\r\n\r\n1517.5 \"Power Plasma Alpha x2\"\r\n1517.5 \"Power Plasma Beta x2\"\r\n1517.5 \"Power Plasma Gamma x1\"\r\n\r\n1529.6 \"Power Plasma Alpha x2\"\r\n1529.6 \"Power Plasma Gamma x1\"\r\n\r\n1534.0 \"Attachment\" Ability { id: \"1601\", source: \"Brawler\" }\r\n1540.1 \"Brawler Mechanic\" #Ability { id: \"160[2345]\", source: \"Brawler\" }\r\n\r\n1548.6 \"Power Plasma Alpha x3\"\r\n1548.6 \"Power Plasma Gamma x1\"\r\n\r\n1551.6 \"Attachment\" Ability { id: \"1601\", source: \"Brawler\" }\r\n1557.7 \"Brawler Mechanic\" #Ability { id: \"160[2345]\", source: \"Brawler\" }\r\n\r\n1561.2 \"--unseal--\"\r\n\r\n\r\n### Swindler\r\n# Machinery Bay 69 will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"6B9\" } window 2000,0\r\n2021.2 \"Height\" Ability { id: \"160D\", source: \"Swindler\" } window 22,7\r\n2021.2 \"Enumeration\" Ability { id: \"160F\", source: \"Swindler\" }\r\n2029.3 \"Bio-Arithmeticks\" Ability { id: \"1610\", source: \"Swindler\" }\r\n\r\n# Add phase 1\r\n2031.4 \"Gobwalker x1\"\r\n2031.4 \"Midan Hardhelm x1\"\r\n2031.4 \"Midan Hardmind x1\"\r\n2031.4 \"Midan Soldier x9\"\r\n\r\n2040.6 \"Auxiliary Power\" Ability { id: \"1611\", source: \"Swindler\" }\r\n\r\n2051.8 \"Height\" Ability { id: \"160D\", source: \"Swindler\" }\r\n2061.0 \"Enumeration\" Ability { id: \"160F\", source: \"Swindler\" }\r\n2070.1 \"Bio-Arithmeticks\" Ability { id: \"1610\", source: \"Swindler\" }\r\n\r\n# Add phase 2\r\n2072.1 \"Midan Gunner x4\"\r\n\r\n2077.4 \"Snipethoom\" #Ability { id: \"1617\", source: \"Midan Gunner\" }\r\n2078.3 \"Auxiliary Power\" Ability { id: \"1611\", source: \"Swindler\" }\r\n2086.4 \"Height\" Ability { id: \"160D\", source: \"Swindler\" }\r\n2087.5 \"Snipethoom\" #Ability { id: \"1617\", source: \"Midan Gunner\" }\r\n2088.6 \"Auxiliary Power\" Ability { id: \"1611\", source: \"Swindler\" }\r\n\r\n2095.7 \"Height\" Ability { id: \"160D\", source: \"Swindler\" }\r\n2095.7 \"Enumeration\" Ability { id: \"160F\", source: \"Swindler\" }\r\n2102.9 \"Bio-Arithmeticks\" Ability { id: \"1610\", source: \"Swindler\" }\r\n\r\n# Final loop\r\n2111.1 \"Bio-Arithmeticks\" Ability { id: \"1610\", source: \"Swindler\" }\r\n2133.5 \"Height\" Ability { id: \"160D\", source: \"Swindler\" }\r\n2133.5 \"Enumeration\" Ability { id: \"160F\", source: \"Swindler\" }\r\n\r\n2141.7 \"Bio-Arithmeticks\" Ability { id: \"1610\", source: \"Swindler\" } window 20,20 jump 2111.1\r\n2164.1 \"Height\" #Ability { id: \"160D\", source: \"Swindler\" }\r\n2164.1 \"Enumeration\" #Ability { id: \"160F\", source: \"Swindler\" }\r\n\r\n2172.3 \"Bio-Arithmeticks\" #Ability { id: \"1610\", source: \"Swindler\" }\r\n2194.7 \"Height\" #Ability { id: \"160D\", source: \"Swindler\" }\r\n2194.7 \"Enumeration\" #Ability { id: \"160F\", source: \"Swindler\" }\r\n\r\n\r\n### Vortexer\r\n# Machinery Bay 70 will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"6BA\" } window 3000,0\r\n3006.7 \"Brute Force\" Ability { id: \"1619\", source: \"Vortexer\" } window 10,10\r\n3016.8 \"Elemental Jammer\" Ability { id: \"161B\", source: \"Vortexer\" }\r\n3022.0 \"Ballistic Missile\" Ability { id: \"1622\", source: \"Vortexer\" }\r\n3028.0 \"Earth Missile x4\" Ability { id: \"1623\", source: \"Vortexer\" }\r\n3028.0 \"Fire Beam x4\" Ability { id: \"1625\", source: \"Vortexer\" }\r\n3032.2 \"Brute Force\" Ability { id: \"1619\", source: \"Vortexer\" }\r\n3038.4 \"Crashing Thunder\" Ability { id: \"161D\", source: \"Vortexer\" }\r\n3038.4 \"Crashing Wave\" Ability { id: \"161C\", source: \"Vortexer\" }\r\n3041.3 \"Ballistic Missile\" Ability { id: \"1622\", source: \"Vortexer\" }\r\n3046.3 \"Ice Missile x2\" #Ability { id: \"1624\", source: \"Vortexer\" }\r\n3054.3 \"Brute Force\" Ability { id: \"1619\", source: \"Vortexer\" }\r\n3060.1 \"Crashing Thunder\" Ability { id: \"161D\", source: \"Vortexer\" }\r\n3060.2 \"Crashing Wave\" Ability { id: \"161C\", source: \"Vortexer\" }\r\n3066.4 \"Ballistic Missile\" Ability { id: \"1622\", source: \"Vortexer\" }\r\n3072.4 \"Earth Missile x4\" Ability { id: \"1623\", source: \"Vortexer\" }\r\n3072.4 \"Fire Beam x4\" Ability { id: \"1625\", source: \"Vortexer\" }\r\n3077.6 \"Super Cyclone\" Ability { id: \"1627\", source: \"Vortexer\" }\r\n3082.1 \"Crashing Thunder\" Ability { id: \"161D\", source: \"Vortexer\" }\r\n3082.2 \"Crashing Wave\" Ability { id: \"161C\", source: \"Vortexer\" }\r\n3084.8 \"Brute Force\" Ability { id: \"1619\", source: \"Vortexer\" }\r\n3096.9 \"Ultra Flash\" Ability { id: \"161A\", source: \"Vortexer\" }\r\n\r\n3099.7 \"Brute Force\" #Ability { id: \"1619\", source: \"Vortexer\" }\r\n3109.8 \"Elemental Jammer\" Ability { id: \"161B\", source: \"Vortexer\" } window 50,50 jump 3016.8\r\n3115.0 \"Ballistic Missile\" #Ability { id: \"1622\", source: \"Vortexer\" }\r\n3121.0 \"Earth Missile\" #Ability { id: \"1623\", source: \"Vortexer\" }\r\n3121.0 \"Fire Beam\" #Ability { id: \"1625\", source: \"Vortexer\" }\r\n3125.2 \"Brute Force\" #Ability { id: \"1619\", source: \"Vortexer\" }\r\n3131.4 \"Crashing Thunder\" #Ability { id: \"161D\", source: \"Vortexer\" }\r\n3131.4 \"Crashing Wave\" #Ability { id: \"161C\", source: \"Vortexer\" }\r\n3134.3 \"Ballistic Missile\" #Ability { id: \"1622\", source: \"Vortexer\" }\r\n3139.3 \"Ice Missile\" #Ability { id: \"1624\", source: \"Vortexer\" }\r\n3147.3 \"Brute Force\" #Ability { id: \"1619\", source: \"Vortexer\" }\r\n3153.1 \"Crashing Thunder\" #Ability { id: \"161D\", source: \"Vortexer\" }\r\n3153.2 \"Crashing Wave\" #Ability { id: \"161C\", source: \"Vortexer\" }\r\n3159.4 \"Ballistic Missile\" #Ability { id: \"1622\", source: \"Vortexer\" }\r\n3165.4 \"Earth Missile\" #Ability { id: \"1623\", source: \"Vortexer\" }\r\n3165.4 \"Fire Beam\" #Ability { id: \"1625\", source: \"Vortexer\" }\r\n3170.6 \"Super Cyclone\" #Ability { id: \"1627\", source: \"Vortexer\" }\r\n3175.1 \"Crashing Thunder\" #Ability { id: \"161D\", source: \"Vortexer\" }\r\n3175.2 \"Crashing Wave\" #Ability { id: \"161C\", source: \"Vortexer\" }\r\n3177.8 \"Brute Force\" #Ability { id: \"1619\", source: \"Vortexer\" }\r\n3189.9 \"Ultra Flash\" #Ability { id: \"161A\", source: \"Vortexer\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a7s.ts



// TODO: stun call for True Heart sprint ability?

// TODO: can we figure out jails from the location of the tethering gobbie?
// TODO: you can figure out who it is from who the bomb is on, but 8 blu <_<
// Red jail can stay up forever.  The same color can be in different spots.
// Is it possible that for each jail phase, each color is in the same spot?
// One data point:
//   Jail 1: purple(NE), red (NW), green (SE), white (NE)
//   Jail 2: red(NW), green (SW), white (SW), purple (NW)
//   Jail 3: green (NE), purple (SE), red (SW), white (SE)
//   * in this example jail 1 red persisted through jail 1 green/white, but jail 2 red did not.
// Alarums and Lumbertype Magitek get added too late to be useful.

// Timeline:
// Jail 1:
//   Option 1: (bomb on healer)
//     green tether / white prey
//     purple tether / red prey
//   Option 2: (bomb on melee)
//     purple tether / red prey
//     green tether / white prey
// Cat Phase 1
// Jail 2:
//   Option 1: (bomb on healer)
//     red tether / green prey
//     white tether / purple prey
//   Option 2: (bomb on ranged/caster)
//     white tether / purple prey
//     red tether / green prey
// Hammertime
// Cat Phase 2
// Jail 3:
//   Option 1: (2x bombs)
//     green tether / purple prey
//     red tether / white prey
//   Option 2: (sizzlebeam on OT)
//     red tether / white prey
//     green tether / purple prey
const a7s_triggerSet = {
  id: 'AlexanderTheArmOfTheSonSavage',
  zoneId: zone_id/* default.AlexanderTheArmOfTheSonSavage */.Z.AlexanderTheArmOfTheSonSavage,
  timelineNeedsFixing: true,
  timelineFile: 'a7s.txt',
  initData: () => {
    return {
      phase: 0,
      grabbed: []
    };
  },
  triggers: [{
    id: 'A7S Phase Counter',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Shanoa',
      capture: false
    },
    run: data => data.phase++
  }, {
    id: 'A7S Sizzlebeam',
    type: 'HeadMarker',
    netRegex: {
      id: '0018'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.sizzlebeamOnYou();
    },
    infoText: (data, matches, output) => {
      if (matches.target !== data.me) return output.sizzlebeamOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      sizzlebeamOn: {
        en: 'Sizzlebeam on ${player}',
        de: 'Gobpartikelstrahl auf ${player}',
        fr: 'Gobrayon sur ${player}',
        ja: '${player}にゴブ式波動砲',
        cn: '波动炮点${player}',
        ko: '"${player}" 고블린식 파동포'
      },
      sizzlebeamOnYou: {
        en: 'Sizzlebeam on YOU',
        de: 'Gobpartikelstrahl auf DIR',
        fr: 'Gobrayon sur VOUS',
        ja: '自分にゴブ式波動砲',
        cn: '波动炮点名',
        ko: '고블린식 파동포 대상자'
      }
    }
  }, {
    id: 'A7S Sizzlespark',
    type: 'StartsUsing',
    netRegex: {
      source: 'Quickthinx Allthoughts',
      id: '16F8',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'A7S Bomb Tether',
    type: 'Tether',
    netRegex: {
      source: 'Bomb',
      id: '001F'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bomb Spread',
        de: 'Bomben verteilen',
        fr: 'Bombe, dispersez-vous',
        ja: '爆弾、散開',
        cn: '炸弹，散开',
        ko: '폭탄 뿌리기'
      }
    }
  }, {
    id: 'A7S Jail Prey',
    type: 'HeadMarker',
    netRegex: {
      id: '0029'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Jail Prey',
        de: 'Gefängnis Markierung',
        fr: 'Marquage prison',
        ja: '隔離部屋',
        cn: '监狱点名',
        ko: '감옥 징 대상자'
      }
    }
  }, {
    id: 'A7S Jail Tether',
    type: 'Tether',
    // This does not include the initial tether, unfortunately.
    // This is another case of "added combatant with initial tether".
    netRegex: {
      source: 'Boomtype Magitek Gobwalker G-VII',
      id: '0011'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Jail Tether',
        de: 'Gefängnis Verbindung',
        fr: 'Lien prison',
        ja: '隔離部屋線',
        cn: '监狱连线',
        ko: '감옥 줄 대상자'
      }
    }
  }, {
    id: 'A7S Kugelblitz',
    type: 'StartsUsing',
    netRegex: {
      source: 'Sturm Doll',
      id: '16FE'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun()
  }, {
    id: 'A7S Zoomdoom Clear',
    type: 'StartsUsing',
    netRegex: {
      source: 'Quickthinx Allthoughts',
      id: '16F4',
      capture: false
    },
    run: data => {
      data.grabbed = [];
      delete data.stickyloom;
    }
  }, {
    id: 'A7S Gobbie Grab',
    type: 'Ability',
    netRegex: {
      source: 'Quickthinx Allthoughts',
      id: '15C0'
    },
    run: (data, matches) => data.grabbed.push(matches.target)
  }, {
    id: 'A7S Stickyloom',
    type: 'Ability',
    netRegex: {
      source: 'Boomtype Magitek Gobwalker G-VII',
      id: '16F2'
    },
    run: (data, matches) => data.stickyloom = matches.target
  }, {
    id: 'A7S Padlock',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Padlock',
      capture: false
    },
    condition: data => {
      // If you're not in a jail, kill the padlock.
      return !data.grabbed.includes(data.me) && data.stickyloom !== data.me;
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Break Padlock',
        de: 'Schloss zerstören',
        fr: 'Cassez le cadenas',
        ja: '錠前を破れ',
        cn: '打破锁',
        ko: '자물쇠 부수기'
      }
    }
  }, {
    id: 'A7S True Heart',
    type: 'Ability',
    netRegex: {
      source: 'Shanoa',
      id: '15EC',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Heart',
        de: 'Herz besiegen',
        fr: 'Tuez le cœur',
        ja: '真心を倒す',
        cn: '击杀真心',
        ko: '진심 없애기'
      }
    }
  }, {
    id: 'A7S Searing Wind',
    type: 'GainsEffect',
    netRegex: {
      effectId: '178'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Searing Wind on YOU',
        de: 'Versengen auf DIR',
        fr: 'Fournaise sur VOUS',
        ja: '自分に灼熱',
        cn: '热风点名',
        ko: '뜨거운 바람 대상자'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bomb': 'Bombe',
      'Boomtype Magitek Gobwalker G-VII': 'Gob-Stampfer VII-L',
      'Frostbite': 'Erfrierung',
      'Padlock': 'Vorhängeschloss',
      'Pyretic': 'Pyretisch',
      'Quickthinx Allthoughts': 'Denkfix',
      'Shanoa': 'Schwarz(?:e|er|es|en) Katze',
      'Sturm Doll': 'Sturmpuppe',
      'The electrocution gallery': 'Platz für Strafezeigen'
    },
    'replaceText': {
      'Big Doll': 'Große Puppe',
      'Bomb(?!(s|en))': 'Bombe',
      'Bombs': 'Bomben',
      '(?<! )Doll': 'Puppe',
      'Flamethrower': 'Flammenwerfer',
      'Hammertime': 'Hammertime',
      'Jails': 'Gefängnisse',
      'Get Prey': 'Markierung hohlen',
      'Get Tether': 'Verbindung hohlen',
      'Kill Heart': 'Herz besiegen',
      'Resync': 'Resync',
      'Sizzlebeam': 'Gobpartikelstrahl',
      'Sizzlespark': 'Brutzelblitz',
      'Small Doll(?!s)': 'kleine Puppe',
      'Small Dolls': 'kleine Puppen',
      'Stun Heart': 'Herz unterbrechen',
      'Uplander Doom': 'Knallregen',
      'Zoomdoom': 'Gobrakete'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bomb': 'bombe',
      'Boomtype Magitek Gobwalker G-VII': 'gobblindé magitek G-VII Lamineur',
      'Frostbite': 'Gelure',
      'Padlock': 'cadenas',
      'Pyretic': 'Chaleur',
      'Quickthinx Allthoughts': 'Quickthinx le Cerveau',
      'Shanoa': 'Chat-noir',
      'Sturm Doll': 'poupée sturm',
      'The electrocution gallery': 'square d\'exécution publique'
    },
    'replaceText': {
      'Big Doll': 'Grosse poupée',
      'Bomb': 'Bombe',
      '(?<! )Doll': 'Poupée',
      'Flamethrower': 'Lance-flammes',
      'Hammertime': 'Coup de marteau',
      'Jails': 'Prison',
      'Get Prey': 'Prenez le repère',
      'Get Tether': 'Prenez le lien',
      'Kill Heart': 'Tuez le cœur',
      'Resync': 'Resynchro',
      'Sizzlebeam': 'Gobrayon',
      'Sizzlespark': 'Gobétincelle',
      'Small Doll(?!s)': 'Petite poupée',
      'Small Dolls': 'Petites poupées',
      'Stun Heart': 'Étourdissez le cœur',
      'Uplander Doom': 'Fusillade',
      'Zoomdoom': 'Gobroquette'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bomb': '爆弾',
      'Boomtype Magitek Gobwalker G-VII': 'VII号ゴブリウォーカーL型',
      'Frostbite': '凍傷',
      'Padlock': '錠前',
      'Pyretic': 'ヒート',
      'Quickthinx Allthoughts': '万能のクイックシンクス',
      'Shanoa': 'シャノア',
      'Sturm Doll': 'シュツルムドール',
      'The electrocution gallery': '公開処刑広場'
    },
    'replaceText': {
      'Big Doll': '大きいドール',
      'Bomb(?!s)': '爆弾',
      'Bombs': '爆弾',
      '(?<! )Doll': 'ドール',
      'Flamethrower': 'フレイムスロアー',
      'Hammertime': 'オシオキ',
      'Jails': '隔離部屋',
      'Get Prey': 'マーキングを取る',
      'Get Tether': '線を取る',
      'Kill Heart': '真心を倒す',
      'Resync': 'シンク',
      'Sizzlebeam': 'ゴブ式波動砲',
      'Sizzlespark': 'ゴブリスパーク',
      'Small Doll(?!s)': '小さいドール',
      'Small Dolls': '小さいドール',
      'Stun Heart': 'スタン: 真心',
      'Uplander Doom': '一斉射撃',
      'Zoomdoom': 'ゴブロケット'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bomb': '炸弹',
      'Boomtype Magitek Gobwalker G-VII': '7号哥布林战车L型',
      'Frostbite': '冻伤',
      'Padlock': '牢门的锁',
      'Pyretic': '热病',
      'Quickthinx Allthoughts': '万事通 奎克辛克斯',
      'Shanoa': '夏诺雅',
      'Sturm Doll': '风暴人偶',
      'The electrocution gallery': '公开处刑广场'
    },
    'replaceText': {
      'Big Doll': '大人偶',
      'Bomb(?!(s|en))': '炸弹',
      'Bombs': '炸弹',
      '(?<! )Doll': '人偶',
      'Flamethrower': '火焰喷射器',
      'Hammertime': '惩戒',
      'Jails': '监狱',
      'Get Prey': '监狱点名',
      'Get Tether': '监狱连线',
      'Kill Heart': '击杀真心',
      'Resync': '重新同步',
      'Sizzlebeam': '哥布式波动炮',
      'Sizzlespark': '哥布林火花',
      'Small Doll(?!s)': '小人偶',
      'Small Dolls': '小人偶',
      'Stun Heart': '击晕真心',
      'Uplander Doom': '齐射',
      'Zoomdoom': '哥布火箭'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bomb': '폭탄',
      'Boomtype Magitek Gobwalker G-VII': 'VII호 고블린워커 L형',
      'Frostbite': '동상',
      'Padlock': '자물쇠',
      'Quickthinx Allthoughts': '만능의 퀵싱크스',
      'Shanoa': '샤노아',
      'Sturm Doll': '인형 폭기병',
      'The electrocution gallery': '공개처형 광장',
      'Pyretic': '열병'
    },
    'replaceText': {
      'Big Doll': '큰 인형',
      'Bomb(?!s)': '폭탄',
      'Bombs': '폭탄',
      '(?<! )Doll': '인형',
      'Flamethrower': '화염 방사',
      'Get Prey': '인형뽑기',
      'Get Tether': '밧줄',
      'Hammertime': '장판',
      'Jails': '감옥',
      'Kill Heart': '진심 없애기',
      'Resync': '재동기화',
      'Small Doll(?!s)': '작은 인형',
      'Small Dolls': '작은 인형',
      'Sizzlebeam': '고블린식 파동포',
      'Sizzlespark': '고블린 불꽃',
      'Stun Heart': '진심 기절시키기',
      'Uplander Doom': '일제 사격',
      'Zoomdoom': '고블린 로켓'
    }
  }]
};
/* harmony default export */ const a7s = (a7s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a7s.txt
const raid_a7s_namespaceObject = "# Alexander - Arm of the Son (Savage) - A7S / M3S\r\n# Created by Shasta Kota of Death & Taxes (DnT) on Gilgamesh\r\n# Shasta's reddit: /u/shastaxc\r\n# Last Updated: 5/19/2016\r\n\r\n# TODO:  Fix this up to conform to cactbot style guidelines\r\n# TODO:  Look at whether jails are MapEffect lines?\r\n\r\n#############################################################\r\n########CUSTOMIZE your timeline. Remove the hashtag from\r\n########the beginning of the following lines to prevent\r\n########them from appearing on your timeline.\r\n\r\n#########DPS CAN HIDE THESE\r\n#hideall \"Sizzlespark\"\r\n#hideall \"Uplander Doom\"\r\n#hideall \"Big Doll\"\r\n#hideall \"Small Doll\"\r\n#hideall \"Small Dolls x2\"\r\n\r\n#########HEALERS CAN HIDE THESE\r\n#hideall \"Big Doll\"\r\n#hideall \"Small Doll\"\r\n#hideall \"Small Dolls x2\"\r\n#hideall \"Zoomdoom\"\r\n#hideall \"Stun Heart\"\r\n\r\n##############################################################\r\n################## Windows 8 & 10 Voices ##################\r\n########REMOVE THE HASTAG to select a voice\r\n#define speaker \"voice\" \"Microsoft Zira Desktop\" 0 100\r\n#define speaker \"voice\" \"Microsoft David Desktop\" 0 100\r\n\r\n#################### Windows 7 Voices ####################\r\n########REMOVE THE HASTAG to select a voice\r\n#define speaker \"voice\" \"Microsoft Anna\" 0 100\r\n\r\n################ CUSTOMIZE Call Outs #####################\r\n########REMOVE THE HASHTAG to enable each call out\r\n#alertall \"Zoomdoom\" before 3 speak \"voice\" \"Back Up\"\r\n#alertall \"Sizzlespark\" before 4 speak \"voice\" \"Spark\"\r\n#alertall \"Sizzlebeam\" before 4 speak \"voice\" \"Beam\"\r\n#alertall \"Bombs x8\" before 3 speak \"voice\" \"Bombs\"\r\n#alertall \"Bomb x1\" before 3 speak \"voice\" \"Bomb\"\r\n#alertall \"Flamethrower\" before 4 speak \"voice\" \"Flame\"\r\n#alertall \"Kill Heart\" before 0 speak \"voice\" \"Kill Heart\"\r\n\r\n#alertall \"Stun Heart\" before 1 speak \"voice\" \"Stun\"\r\n#alertall \"Uplander Doom\" before 3 speak \"voice\" \"buster\"\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n##############################################################\r\n################# Intro\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n8 \"Hammertime x2\"\r\n21 \"Sizzlebeam\"\r\n31 \"Sizzlespark\"\r\n35 \"Bombs x8\"\r\n\r\n################# Version 1 - Phase 1\r\n59 \"Bomb x1\"\r\n66 \"Jails\" #White Prey & Green Tether\r\n68 \"Zoomdoom\" Ability { id: \"15BE\", source: \"Quickthinx Allthoughts\" } window 30,30\r\n69 \"Doll\"\r\n84 \"Resync\" GainsEffect { effect: \"Pyretic\" } window 10,10 jump 384\r\n103 \"Sizzlespark\"\r\n116 \"Uplander Doom\"\r\n130 \"Bomb x1\"\r\n137 \"Jails - Get Tether\" #Red Prey & Purple Tether\r\n139 \"Zoomdoom\" Ability { id: \"15BE\", source: \"Quickthinx Allthoughts\" } window 30,30\r\n140 \"Small Doll\"\r\n178 \"Sizzlebeam\"\r\n190 \"Sizzlespark\"\r\n\r\n################# Version 1 - Phase 2\r\n194 \"Uplander Doom\" Ability { id: \"15F0\", source: \"Quickthinx Allthoughts\" } window 65,0\r\n204 \"Kill Heart\" StartsUsing { id: \"15EC\", source: \"Shanoa\" } window 145,10\r\n219 \"Stun Heart\"\r\n219 \"Sizzlespark\"\r\n229 \"Flamethrower\" Ability { id: \"1CFA\", source: \"Quickthinx Allthoughts\" } window 10,10\r\n234 \"Kill Heart\" StartsUsing { id: \"15EC\", source: \"Shanoa\" } window 10,10\r\n249 \"Stun Heart\"\r\n249 \"Sizzlebeam\"\r\n258 \"Sizzlespark\" #can be skipped\r\n266 \"Bomb x1\" AddedCombatant { name: \"Bomb\" } window 25,25 jump 561\r\n267 \"\"\r\n267 \"\"\r\n267 \"\"\r\n267 \"\"\r\n267 \"\"\r\n267 \"\"\r\n267 \"\"\r\n267 \"\"\r\n267 \"\"\r\n267 \"\"\r\n\r\n############################################\r\n################# Version 2 - Phase 1\r\n359 \"Bomb x1\"\r\n366 \"Jails\" #Purple Tether, Red Prey\r\n368 \"Zoomdoom\" Ability { id: \"15BE\", source: \"Quickthinx Allthoughts\" } window 30,30\r\n369 \"Doll\"\r\n397 \"Uplander Doom\"\r\n409 \"Sizzlebeam\"\r\n428 \"Bomb x1\"\r\n435 \"Jails\" #Green Tether, White Prey\r\n437 \"Zoomdoom\"\r\n438 \"Big Doll\"\r\n473 \"Sizzlespark\"\r\n485 \"Sizzlespark\"\r\n\r\n################# Version 2 - Phase 2\r\n489 \"Uplander Doom\" Ability { id: \"15F0\", source: \"Quickthinx Allthoughts\" } window 78,0\r\n499 \"Kill Heart\" StartsUsing { id: \"15EC\", source: \"Shanoa\" } window 130,10\r\n514 \"Stun Heart\"\r\n514 \"Sizzlespark\"\r\n524 \"Flamethrower\" Ability { id: \"1CFA\", source: \"Quickthinx Allthoughts\" } window 10,10\r\n529 \"Kill Heart\" StartsUsing { id: \"15EC\", source: \"Shanoa\" } window 5,5\r\n544 \"Stun Heart\"\r\n544 \"Sizzlebeam\"\r\n553 \"Sizzlespark\" #can be skipped\r\n\r\n############################################\r\n################# Version 1 - Phase 3\r\n561 \"Bomb x1\" AddedCombatant { name: \"Bomb\" } window 50,20\r\n567 \"Jails\" #Green Prey & Red Tether\r\n570 \"Zoomdoom\" Ability { id: \"15BE\", source: \"Quickthinx Allthoughts\" } window 30,30\r\n570 \"Doll\"\r\n582 \"Resync\" GainsEffect { effect: \"Frostbite\" } window 10,10 jump 983\r\n596 \"Uplander Doom\"\r\n613 \"Sizzlespark\"\r\n621 \"Sizzlespark\"\r\n628 \"Bomb x1\"\r\n636 \"Jails - Get Prey\" #Purple Prey & White Tether\r\n640 \"Zoomdoom\" Ability { id: \"15BE\", source: \"Quickthinx Allthoughts\" } window 30,30\r\n640 \"Small Dolls x2\"\r\n678 \"Sizzlebeam\"\r\n\r\n################# Phase 4\r\n686 \"Sizzlespark\" Ability { id: \"16F8\", source: \"Quickthinx Allthoughts\" } window 63,0\r\n694 \"Sizzlespark\"\r\n707 \"Sizzlebeam\" Ability { id: \"15EE\", source: \"Quickthinx Allthoughts\" } window 10,10\r\n711 \"Bombs x8\"\r\n740 \"Sizzlespark\"\r\n748 \"Sizzlespark\"\r\n755 \"Uplander Doom\"\r\n773 \"Flamethrower\" Ability { id: \"1CFA\", source: \"Quickthinx Allthoughts\" } window 15,15\r\n779 \"Hammertime x4\"\r\n790 \"Sizzlespark\"\r\n793 \"Hammertime x4\"\r\n800 \"Sizzlespark\"\r\n806 \"Sizzlespark\"\r\n812 \"Sizzlespark\"\r\n828 \"Sizzlebeam\"\r\n836 \"Sizzlespark\"\r\n842 \"Sizzlespark\"\r\n\r\n################# Phase 5\r\n854 \"Flamethrower\" Ability { id: \"1CFA\", source: \"Quickthinx Allthoughts\" } window 60,10\r\n858 \"Kill Heart\" StartsUsing { id: \"15EC\", source: \"Shanoa\" } window 200,10\r\n865 \"Uplander Doom\"\r\n873 \"Stun Heart\"\r\n879 \"Sizzlebeam\"\r\n888 \"Flamethrower\"\r\n888 \"Kill Heart\" StartsUsing { id: \"15EC\", source: \"Shanoa\" } window 5,5\r\n901 \"Sizzlespark\"\r\n903 \"Stun Heart\"\r\n909 \"Sizzlespark\"\r\n917 \"Sizzlespark\"\r\n923 \"Bombs / Sizzlebeam\" AddedCombatant { name: \"Bomb\" } window 10,10 jump 1326\r\n924 \"\" Ability { id: \"15EE\", source: \"Quickthinx Allthoughts\" } window 10,10 jump 1526\r\n924 \"\"\r\n924 \"\"\r\n924 \"\"\r\n924 \"\"\r\n924 \"\"\r\n924 \"\"\r\n924 \"\"\r\n924 \"\"\r\n924 \"\"\r\n\r\n############################################\r\n################# Version 2 - Phase 3\r\n962 \"Bomb x1\"\r\n970 \"Jails\" #White Tether, Purple Prey\r\n972 \"Zoomdoom\"\r\n972 \"Doll\"\r\n1011 \"Sizzlebeam\" Ability { id: \"15EE\", source: \"Quickthinx Allthoughts\" } window 5,5\r\n1019 \"Sizzlespark\"\r\n1027 \"Sizzlespark\"\r\n1034 \"Bomb x1\"\r\n1041 \"Jails\" #Red Tether, Green Prey\r\n1043 \"Zoomdoom\" Ability { id: \"15BE\", source: \"Quickthinx Allthoughts\" } window 30,30\r\n1043 \"Big Doll\"\r\n1071 \"Uplander Doom\"\r\n\r\n################# Phase 4\r\n1087 \"Sizzlespark\"\r\n1095 \"Sizzlespark\"\r\n1108 \"Sizzlebeam\" Ability { id: \"15EE\", source: \"Quickthinx Allthoughts\" } window 10,10\r\n1111 \"Bombs x8\"\r\n1141 \"Sizzlespark\"\r\n1149 \"Sizzlespark\"\r\n1156 \"Uplander Doom\"\r\n1174 \"Flamethrower\" Ability { id: \"1CFA\", source: \"Quickthinx Allthoughts\" } window 15,15\r\n1180 \"Hammertime x4\"\r\n1191 \"Sizzlespark\"\r\n1194 \"Hammertime x4\"\r\n1200 \"Sizzlespark\"\r\n1206 \"Sizzlespark\"\r\n1212 \"Sizzlespark\"\r\n1229 \"Sizzlebeam\"\r\n1236 \"Sizzlespark\"\r\n1243 \"Sizzlespark\"\r\n\r\n############################################\r\n################# Phase 5\r\n1253 \"Flamethrower\" Ability { id: \"1CFA\", source: \"Quickthinx Allthoughts\" } window 60,10\r\n1258 \"Kill Heart\" StartsUsing { id: \"15EC\", source: \"Shanoa\" } window 200,10\r\n1263 \"Uplander Doom\"\r\n1273 \"Stun Heart\"\r\n1280 \"Sizzlebeam\"\r\n1288 \"Flamethrower\"\r\n1288 \"Kill Heart\" StartsUsing { id: \"15EC\", source: \"Shanoa\" } window 5,5\r\n1301 \"Sizzlespark\"\r\n1303 \"Stun Heart\"\r\n1308 \"Sizzlespark\"\r\n1316 \"Sizzlespark\"\r\n\r\n############################################\r\n################# Version 1 - Phase 6\r\n1326 \"Bombs x2\" Ability { id: \"15EE\", source: \"Quickthinx Allthoughts\" } window 40,10 jump 1526\r\n1333 \"Jails\" #Green Tether, Purple Prey\r\n1335 \"Small Doll\"\r\n1336 \"Zoomdoom\" Ability { id: \"15BE\", source: \"Quickthinx Allthoughts\" } window 30,30\r\n1344 \"Big Doll\"\r\n1348 \"Resync\" GainsEffect { effect: \"Pyretic\" } window 10,10 jump 1548\r\n1348 \"Resync\" GainsEffect { effect: \"Pyretic\" } window 10,10 jump 1548\r\n1362 \"Uplander Doom\"\r\n1381 \"Sizzlespark\"\r\n1392 \"Sizzlebeam\"\r\n1396 \"Jails\" #Red Tether, White Prey\r\n1398 \"Zoomdoom\" Ability { id: \"15BE\", source: \"Quickthinx Allthoughts\" } window 30,30\r\n1398 \"Small Dolls x2\"\r\n1426 \"Sizzlespark\"\r\n1433 \"Sizzlebeam\"\r\n1441 \"Sizzlespark\"\r\n1448 \"Sizzlespark\"\r\n1455 \"Sizzlespark\"\r\n1474 \"Enrage\"\r\n\r\n################# Version 2 - Phase 6\r\n1526 \"Sizzlebeam\"\r\n1530 \"Jails\" #White Prey & Red Tether\r\n1532 \"Zoomdoom\" Ability { id: \"15BE\", source: \"Quickthinx Allthoughts\" } window 30,30\r\n1533 \"Small Dolls x2\"\r\n1560 \"Sizzlespark\"\r\n1568 \"Sizzlebeam\"\r\n1576 \"Sizzlespark\"\r\n1583 \"Sizzlespark\"\r\n1590 \"Sizzlespark\"\r\n1595 \"Bombs x2\"\r\n1601 \"Jails - Get Prey\" #Purple Prey & Green Tether\r\n1603 \"Zoomdoom\" Ability { id: \"15BE\", source: \"Quickthinx Allthoughts\" } window 30,30\r\n1603 \"Small Doll\"\r\n1612 \"Big Doll\"\r\n1630 \"Uplander Doom\"\r\n1647 \"Sizzlespark\"\r\n1654 \"Sizzlespark\"\r\n1673 \"Enrage\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a8n.ts



// ALEXANDER - THE BURDEN OF THE SON NORMAL
// A8N
const a8n_triggerSet = {
  id: 'AlexanderTheBurdenOfTheSon',
  zoneId: zone_id/* default.AlexanderTheBurdenOfTheSon */.Z.AlexanderTheBurdenOfTheSon,
  timelineFile: 'a8n.txt',
  timelineTriggers: [{
    id: 'A8N Hydrothermal Missile',
    regex: /Hydrothermal Missile/,
    beforeSeconds: 4,
    suppressSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'A8N Flarethrower',
    regex: /Flarethrower/,
    beforeSeconds: 4,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'A8N Short Needle',
    regex: /Short Needle/,
    beforeSeconds: 4,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'A8N Super Jump Soon',
    regex: /Super Jump/,
    beforeSeconds: 8,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Super Jump',
        de: 'Supersprung ködern',
        fr: 'Attirez le Super saut',
        ja: 'スーパージャンプを誘導',
        cn: '引导超级跳',
        ko: '슈퍼 점프'
      }
    }
  }],
  triggers: [{
    id: 'A8N Megabeam Onslaughter',
    type: 'StartsUsing',
    netRegex: {
      source: 'Onslaughter',
      id: '1732',
      capture: false
    },
    // Insert sound effect from Arthars here.
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Megabeamu~',
        de: 'Megalaser~',
        fr: 'Mégarayon~',
        ja: 'メガビーム～',
        cn: '巨型光束炮~',
        ko: '고출력 광선~'
      }
    }
  }, {
    id: 'A8N Megabeam Brute Justice',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brute Justice',
      id: '174F',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Megabeamu~!',
        de: 'Megalaser~!',
        fr: 'Mégarayon~ !',
        ja: 'メガビーム～',
        cn: '巨型光束炮~!',
        ko: '고출력 광선~!'
      }
    }
  }, {
    id: 'A8N Execution',
    type: 'Ability',
    netRegex: {
      source: 'Onslaughter',
      id: '1632',
      capture: false
    },
    condition: data => data.role === 'dps' || data.job === 'BLU',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Regulators',
        de: 'Dampfregler besiegen',
        fr: 'Tuez les Régulateurs',
        ja: 'スチームジャッジを倒す',
        cn: '击杀小怪',
        ko: '증기 감독 없애기'
      }
    }
  }, {
    id: 'A8N Perpetual Ray',
    type: 'StartsUsing',
    netRegex: {
      source: 'Onslaughter',
      id: '1730'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'A8N Low Arithmeticks',
    type: 'GainsEffect',
    // Note: both high and low use '0025' headmarker
    netRegex: {
      effectId: '3FD'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 10,
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get High',
        de: 'Geh nach Oben',
        fr: 'Montez',
        ja: '高い床に乗る',
        cn: '上高台',
        ko: '높은곳으로'
      }
    }
  }, {
    id: 'A8N High Arithmeticks',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3FE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 10,
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Down',
        de: 'Geh nach Unten',
        fr: 'Descendez',
        ja: '低い床に乗る',
        cn: '下低台',
        ko: '낮은곳으로'
      }
    }
  }, {
    id: 'A8N Super Cyclone',
    type: 'StartsUsing',
    netRegex: {
      source: 'Vortexer',
      id: '1747',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'A8N Enumeration',
    type: 'HeadMarker',
    netRegex: {
      id: ['0040', '0041', '0042']
    },
    infoText: (data, matches, output) => {
      // 0040 = 2, 0041 = 3, 0042 = 4
      const count = 2 + parseInt(matches.id, 16) - parseInt('0040', 16);
      return output.text({
        player: data.party.member(matches.target),
        count: count
      });
    },
    outputStrings: {
      text: {
        en: '${player}: ${count}',
        de: '${player}: ${count}',
        fr: '${player}: ${count}',
        ja: '${player}: ${count}',
        cn: '${player}生命计算法: ${count}',
        ko: '${player}: ${count}'
      }
    }
  }, {
    id: 'A8N Double Rocket Punch',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brute Justice',
      id: '174E'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    // Flarethrower comes up at the same time as Long Needle at multiple points.
    // This is *very* dangerous if the healers aren't ready, so we collect the active tank
    // in order to warn them not to stack.
    id: 'A8N Brute Active Tank',
    type: 'Ability',
    netRegex: {
      source: 'Brute Justice',
      id: '174C'
    },
    run: (data, matches) => data.bruteTank = matches.target
  }, {
    // The only dangerous Flarethrower is the first one in any rotation.
    // This one is always after J-Kick but before Super Jump,
    // so we can just look for those two abilities and activate triggers on that basis.
    // (The first dangerous Flarethrower is before Super Jump,
    // so all Long Needle triggers will check against false values,
    // since data.bruteTankOut will not be initialized at that point.)
    // 1750 is Super Jump, 1756 is J-Kick.
    id: 'A8N Long Needle Toggle',
    type: 'Ability',
    netRegex: {
      source: 'Brute Justice',
      id: ['1750', '1756']
    },
    suppressSeconds: 5,
    run: (data, matches) => data.bruteTankOut = matches.id === '1756'
  }, {
    id: 'A8N Long Needle Party',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    condition: data => !(data.me === data.bruteTank && data.bruteTankOut),
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'A8N Long Needle Active Tank',
    type: 'HeadMarker',
    netRegex: {
      id: '003E',
      capture: false
    },
    condition: data => data.me === data.bruteTank && data.bruteTankOut,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Don\'t Stack! (tank cleave)',
        de: 'Nicht Sammeln! (Tank Cleave)',
        fr: 'Ne vous packez pas ! (tank cleave)',
        ja: '集まらない! (タンクへのスラッシュ)',
        cn: '别去集合！（坦克顺劈）',
        ko: '산개하기! (광역 탱버)'
      }
    }
  }, {
    id: 'A8N Apocalyptic Ray',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brute Justice',
      id: '1751',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'A8N Super Jump',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brute Justice',
      id: '1750'
    },
    alertText: (data, matches, output) => {
      if (data.me !== matches.target) return;
      return output.superJumpOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return;
      return output.superJumpOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      superJumpOn: {
        en: 'Super Jump on ${player}',
        de: 'Supersprung auf ${player}',
        fr: 'Super saut sur ${player}',
        ja: '${player}にスーパージャンプ',
        cn: '超级跳点${player}',
        ko: '"${player}" 슈퍼 점프'
      },
      superJumpOnYou: {
        en: 'Super Jump on YOU',
        de: 'Supersprung auf DIR',
        fr: 'Super saut sur VOUS',
        ja: '自分にスーパージャンプ',
        cn: '超级跳点名',
        ko: '슈퍼 점프 대상자'
      }
    }
  }, {
    id: 'A8N Mirage Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0008'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mirage on YOU',
        de: 'Mirage auf DIR',
        fr: 'Mirage sur VOUS',
        ja: '自分にミラージュ',
        cn: '分身点名',
        ko: '환영 징 대상자'
      }
    }
  }, {
    id: 'A8N Ice Missile Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0043'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Ice Missile on YOU',
        de: 'Eis-Rakete auf DIR',
        fr: 'Missile de glace sur VOUS',
        ja: '自分にアイスミサイル',
        cn: '冰点名',
        ko: '얼음 미사일 대상자'
      }
    }
  }, {
    id: 'A8N Mirage Supercharge',
    type: 'StartsUsing',
    netRegex: {
      source: 'Blaster Mirage',
      id: '1749',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Mirage Dashes',
        de: 'Weiche den Replikant Ansturm aus',
        fr: 'Évitez la charge de la Réplique',
        ja: 'ミラージュの正面から離れる',
        cn: '躲避分身冲锋',
        ko: '환영 돌진 피하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Blaster Mirage': 'Blaster-Replikant',
      'Blaster(?! Mirage)': 'Blaster',
      'Brawler': 'Blechbrecher',
      'Brute Justice': 'Brutalus',
      'Hidden Mine': 'Minenfalle',
      'Onslaughter': 'Schlachter',
      'Steam Regulator B': 'β-Dampfregler',
      'Swindler': 'Schwindler',
      'Vortexer': 'Wirbler'
    },
    'replaceText': {
      '--orbs--': '--kugeln--',
      '--regulator check--': '--dampfregler check--',
      '100-Megatonze Shock': '100-Megatonzen-Schock',
      'Apocalyptic Ray': 'Apokalyptischer Strahl ',
      'Attachment': 'Anlegen',
      'Ballistic Missile': 'Ballistische Rakete',
      'Brute Force': 'Brutaler Schlag',
      'Discoid': 'Diskoid',
      'Double Buster': 'Doppelsprenger',
      'Double Rocket Punch': 'Doppelraketenschlag',
      'Earth Missile': 'Erd-Geschoss',
      'Enumeration': 'Zählen',
      'Execution': 'Exekutive',
      'Flarethrower': 'Großflammenwerfer',
      'Height': 'Nivellierung',
      'Hydrothermal Missile': 'Hydrothermales Geschoss',
      'Ice Missile': 'Eisgeschoss',
      'J Kick': 'Gewissenstritt',
      'Long Needle': 'Großes Kaliber',
      'Magicked Mark': 'Magiegeschoss',
      'Mega Beam': 'Megastrahl',
      'Minefield': 'Minenfeld',
      'Mind Blast': 'Geiststoß',
      'Mirage': 'Illusion',
      'Missile Command': 'Raketenkommando',
      'Perpetual Ray': 'Perpetueller Strahl',
      'Seed of the Sky': 'Samen des Himmels',
      'Short Needle': 'Kleines Kaliber',
      'Single Buster': 'Einzelsprenger',
      'Super Cyclone': 'Superzyklon',
      'Super Jump': 'Supersprung',
      'Supercharge': 'Superladung',
      'Transform': 'Geballte Rechtsgewalt'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Blaster Mirage': 'Réplique du Fracasseur',
      'Blaster(?! Mirage)': 'Fracasseur',
      'Brawler': 'Bagarreur',
      'Brute Justice': 'Justicier',
      'Hidden Mine': 'Explosion de mine',
      'Onslaughter': 'Attaqueur',
      'Steam Regulator B': 'Régulateur de vapeur β',
      'Swindler': 'Arnaqueur',
      'Vortexer': 'Tourbillonneur'
    },
    'replaceText': {
      '--orbs--': '--orbes--',
      '--regulator check--': '--vérification du régulateur--',
      '100-Megatonze Shock': 'Choc de 100 mégatonz',
      'Apocalyptic Ray': 'Rayon apocalyptique',
      'Attachment': 'Extension',
      'Ballistic Missile': 'Missiles balistiques',
      'Brute Force': 'Force brute',
      'Discoid': 'Discoïde',
      'Double Buster': 'Double pulsoréacteur',
      'Double Rocket Punch': 'Double coup de roquette',
      'Earth Missile': 'Missile de terre',
      'Enumeration': 'Compte',
      'Execution': 'Exécution',
      'Flarethrower': 'Lance-brasiers',
      'Height': 'Dénivellation',
      'Hydrothermal Missile': 'Missile hydrothermique',
      'Ice Missile': 'Missile de glace',
      'J Kick': 'Pied justicier',
      'Long Needle': 'Gros missiles',
      'Magicked Mark': 'Tir magique',
      'Mega Beam': 'Mégarayon',
      'Minefield': 'Champ de mines',
      'Mind Blast': 'Explosion mentale',
      'Mirage': 'Mirage',
      'Missile Command': 'Commande missile',
      'Perpetual Ray': 'Rayon perpétuel',
      'Seed Of The Sky': 'Graine du ciel',
      'Short Needle': 'Petits missiles',
      'Single Buster': 'Pulsoréacteur',
      'Super Cyclone': 'Super cyclone',
      'Super Jump': 'Super saut',
      'Supercharge': 'Super charge',
      'Transform': 'Assemblage Justicier'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Blaster Mirage': 'ブラスター・ミラージュ',
      'Blaster(?! Mirage)': 'ブラスター',
      'Brawler': 'ブロウラー',
      'Brute Justice': 'ブルートジャスティス',
      'Hidden Mine': '地雷爆発',
      'Onslaughter': 'オンスローター',
      'Steam Regulator B': 'スチームジャッジβ',
      'Swindler': 'スウィンドラー',
      'Vortexer': 'ボルテッカー'
    },
    'replaceText': {
      '--orbs--': '--オーブ--',
      '--regulator check--': '--レギュレーターチェック--',
      '100-Megatonze Shock': '100メガトンズショック',
      'Apocalyptic Ray': 'アポカリプティクレイ',
      'Attachment': 'アタッチメント',
      'Ballistic Missile': 'ミサイル発射',
      'Brute Force': 'ブルートパンチ',
      'Discoid': 'ディスコイド',
      'Double Buster': 'ダブルバスターアタック',
      'Double Rocket Punch': 'ダブルロケットパンチ',
      'Earth Missile': 'アースミサイル',
      'Enumeration': 'カウント',
      'Execution': '執行準備',
      'Flarethrower': '大火炎放射',
      'Height': 'ハイト',
      'Hydrothermal Missile': '蒸気ミサイル',
      'Ice Missile': 'アイスミサイル',
      'J Kick': 'ジャスティスキック',
      'Long Needle': '大型ミサイル',
      'Magicked Mark': 'マジックショット',
      'Mega Beam': 'メガビーム',
      'Minefield': '地雷散布',
      'Mind Blast': 'マインドブラスト',
      'Mirage': 'ミラージュシステム',
      'Missile Command': 'ミサイル全弾発射',
      'Perpetual Ray': 'パーペチュアルレイ',
      'Seed of the Sky': 'シード・オブ・スカイ',
      'Short Needle': '小型ミサイル',
      'Single Buster': 'バスターアタック',
      'Super Cyclone': 'スーパーサイクロン',
      'Super Jump': 'スーパージャンプ',
      'Supercharge': 'スーパーチャージ',
      'Transform': 'ジャスティス合体'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Blaster Mirage': '爆破者幻象',
      'Blaster(?! Mirage)': '爆破者',
      'Brawler': '争斗者',
      'Brute Justice': '残暴正义号',
      'Hidden Mine': '地雷爆炸',
      'Onslaughter': '突击者',
      'Steam Regulator B': '蒸汽调整者β',
      'Swindler': '欺诈者',
      'Vortexer': '环旋者'
    },
    'replaceText': {
      '--orbs--': '--球--',
      '--regulator check--': '--调节器检查--',
      '100-Megatonze Shock': '亿万吨震荡',
      'Apocalyptic Ray': '末世宣言',
      'Attachment': '配件更换',
      'Ballistic Missile': '导弹发射',
      'Brute Force': '残暴铁拳',
      'Discoid': '圆盘',
      'Double Buster': '双重破坏炮击',
      'Double Rocket Punch': '双重火箭飞拳',
      'Earth Missile': '大地导弹',
      'Enumeration': '计数',
      'Execution': '执行准备',
      'Flarethrower': '大火炎放射',
      'Height': '高度算术',
      'Hydrothermal Missile': '蒸汽导弹',
      'Ice Missile': '寒冰导弹',
      'J Kick': '正义飞踢',
      'Long Needle': '大型导弹',
      'Magicked Mark': '魔力射击',
      'Mega Beam': '巨型光束炮',
      'Minefield': '地雷散布',
      'Mind Blast': '精神冲击',
      'Mirage': '幻影系统',
      'Missile Command': '导弹齐发',
      'Perpetual Ray': '永恒射线',
      'Seed of the Sky': '天空之种',
      'Short Needle': '小型导弹',
      'Single Buster': '破坏炮击',
      'Super Cyclone': '超级气旋',
      'Super Jump': '超级跳跃',
      'Supercharge': '超突击',
      'Transform': '正义合体'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Blaster Mirage': '폭파자의 환영',
      'Blaster(?! Mirage)': '폭파자',
      'Brawler': '폭격자',
      'Brute Justice': '포악한 심판자',
      'Hidden Mine': '지뢰 폭발',
      'Onslaughter': '맹습자',
      'Steam Regulator B': '증기 감독 β',
      'Swindler': '조작자',
      'Vortexer': '교반자'
    },
    'replaceText': {
      '--orbs--': '--구슬--',
      '--regulator check--': '--증기 감옥 확인--',
      '100-Megatonze Shock': '100메가톤즈 충격',
      'Apocalyptic Ray': '파멸 계시',
      'Attachment': '무기 장착',
      'Auxiliary Power': '에너지 지원',
      'Ballistic Missile': '미사일 발사',
      'Brute Force': '폭력적인 주먹',
      'Discoid': '원반',
      'Double Buster': '양손 버스터',
      'Double Rocket Punch': '양손 로켓 주먹',
      'Earth Missile': '대지 미사일',
      'Enumeration': '계산',
      'Execution': '집행 준비',
      'Flarethrower': '대화염방사',
      'Height': '고도',
      'Hydrothermal Missile': '증기 미사일',
      'Ice Missile': '얼음 미사일',
      'J Kick': '정의의 발차기',
      'Long Needle': '대형 미사일',
      'Magicked Mark': '마법 사격',
      'Mega Beam': '고출력 광선',
      'Minefield': '지뢰 살포',
      'Mind Blast': '정신파괴',
      'Mirage': '환영 시스템',
      'Missile Command': '미사일 전탄 발사',
      'Perpetual Ray': '영원한 빛줄기',
      'Seed of the Sky': '하늘의 원천',
      'Short Needle': '소형 미사일',
      'Single Buster': '한손 버스터',
      'Super Cyclone': '대형 돌개바람',
      'Super Jump': '슈퍼 점프',
      'Supercharge': '강력 돌진',
      'Transform': '정의의 합체'
    }
  }]
};
/* harmony default export */ const a8n = (a8n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a8n.txt
const raid_a8n_namespaceObject = "### A8N\r\n# Alexander - The Burden of the Son\r\n\r\n# -ii 172E 1733 1735 174B 1752 1755\r\n# -p 173B:214.3 173F:510.3 174E:826.9 1756:902.4\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Magicked Mark\"\r\nhideall \"Brute Force\"\r\n\r\n# Overall enrage is 12 minutes, but it doesn't interrupt any rotations.\r\n# It just starts a \"10 seconds to auto-clean\" counter,\r\n# ending with a Final Judgment sword drop.\r\n\r\n# ONSLAUGHTER\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n5.4 \"Hydrothermal Missile\" Ability { id: \"172F\", source: \"Onslaughter\" } window 5.4,5\r\n12.6 \"Mega Beam\" Ability { id: \"1732\", source: \"Onslaughter\" }\r\n\r\n18.8 \"Perpetual Ray\" Ability { id: \"1730\", source: \"Onslaughter\" }\r\n24.0 \"Hydrothermal Missile\" # Ability { id: \"172F\", source: \"Onslaughter\" }\r\n27.1 \"Hydrothermal Missile\" # Ability { id: \"172F\", source: \"Onslaughter\" }\r\n33.2 \"Execution\" Ability { id: \"1632\", source: \"Onslaughter\" }\r\n37.3 \"Hydrothermal Missile\" Ability { id: \"172F\", source: \"Onslaughter\" }\r\n45.5 \"Seed Of The Sky\" Ability { id: \"1731\", source: \"Onslaughter\" }\r\n52.5 \"Mega Beam\" Ability { id: \"1732\", source: \"Onslaughter\" }\r\n55.2 \"--regulator check--\" # Ability { id: \"1735\", source: \"Steam Regulator B\" }\r\n55.6 \"Hydrothermal Missile\" Ability { id: \"172F\", source: \"Onslaughter\" }\r\n61.8 \"Perpetual Ray\" Ability { id: \"1730\", source: \"Onslaughter\" }\r\n67.0 \"Hydrothermal Missile\" # Ability { id: \"172F\", source: \"Onslaughter\" }\r\n70.1 \"Hydrothermal Missile\" # Ability { id: \"172F\", source: \"Onslaughter\" }\r\n75.2 \"Discoid\" Ability { id: \"162F\", source: \"Onslaughter\" }\r\n79.3 \"Hydrothermal Missile\" Ability { id: \"172F\", source: \"Onslaughter\" }\r\n90.5 \"Seed Of The Sky\" Ability { id: \"1731\", source: \"Onslaughter\" }\r\n95.5 \"Mega Beam\" Ability { id: \"1732\", source: \"Onslaughter\" }\r\n98.6 \"Hydrothermal Missile\" Ability { id: \"172F\", source: \"Onslaughter\" }\r\n\r\n104.7 \"Perpetual Ray\" Ability { id: \"1730\", source: \"Onslaughter\" } jump 18.8\r\n109.9 \"Hydrothermal Missile\"\r\n113.0 \"Hydrothermal Missile\"\r\n119.1 \"Execution\"\r\n123.2 \"Hydrothermal Missile\"\r\n131.4 \"Seed Of The Sky\"\r\n\r\n# CUTE ROBOTS 1\r\n# There's no way to know which robot will die first or when,\r\n# so we just do one full rotation and hope for the best.\r\n# If it would have looped past here, there are bigger problems!\r\n200.0 \"--sync--\" NameToggle { name: \"Onslaughter\", toggle: \"00\" } window 200,0\r\n203.8 \"--sync--\" AddedCombatant { name: \"Brawler\" } window 150,30\r\n206.2 \"--targetable--\"\r\n214.3 \"Magicked Mark\" Ability { id: \"173B\", source: \"Brawler\" }\r\n214.3 \"Brute Force\" Ability { id: \"1744\", source: \"Vortexer\" }\r\n218.5 \"Ballistic Missile\" Ability { id: \"1650\", source: \"Vortexer\" } window 18,10\r\n223.7 \"Ice Missile\" Ability { id: \"1746\", source: \"Vortexer\" }\r\n224.5 \"Earth Missile\" Ability { id: \"1745\", source: \"Vortexer\" }\r\n226.5 \"Magicked Mark\" Ability { id: \"173B\", source: \"Brawler\" }\r\n226.6 \"Brute Force\" Ability { id: \"1744\", source: \"Vortexer\" }\r\n\r\n229.6 \"Attachment\" Ability { id: \"163C\", source: \"Brawler\" }\r\n235.7 \"Single Buster/Double Buster\" Ability { id: \"173D\", source: \"Brawler\" } window 30,30\r\n238.7 \"Brute Force\" Ability { id: \"1744\", source: \"Vortexer\" }\r\n241.8 \"Ballistic Missile\" Ability { id: \"1650\", source: \"Vortexer\" } window 15,15\r\n242.8 \"Magicked Mark\" Ability { id: \"173B\", source: \"Brawler\" }\r\n246.8 \"Ice Missile\" Ability { id: \"1746\", source: \"Vortexer\" }\r\n247.8 \"Earth Missile\" Ability { id: \"1745\", source: \"Vortexer\" }\r\n253.9 \"Super Cyclone\" Ability { id: \"1747\", source: \"Vortexer\" }\r\n255.9 \"Attachment\" Ability { id: \"163C\", source: \"Brawler\" }\r\n258.0 \"Brute Force\" Ability { id: \"1744\", source: \"Vortexer\" }\r\n262.4 \"Single Buster/Double Buster\" Ability { id: \"173C\", source: \"Brawler\" } window 30,30\r\n269.1 \"Brute Force\" Ability { id: \"1744\", source: \"Vortexer\" }\r\n269.5 \"Magicked Mark\" Ability { id: \"173B\", source: \"Brawler\" }\r\n273.2 \"Ballistic Missile\" Ability { id: \"1650\", source: \"Vortexer\" } window 15,15\r\n278.2 \"Ice Missile\" Ability { id: \"1746\", source: \"Vortexer\" }\r\n279.2 \"Earth Missile\" Ability { id: \"1745\", source: \"Vortexer\" }\r\n281.3 \"Brute Force\" Ability { id: \"1744\", source: \"Vortexer\" }\r\n281.7 \"Magicked Mark\" Ability { id: \"173B\", source: \"Brawler\" }\r\n\r\n284.9 \"Attachment\" Ability { id: \"163C\", source: \"Brawler\" }\r\n291.0 \"Single Buster/Double Buster\"\r\n297.1 \"Ballistic Missile\"\r\n302.1 \"Ice Missile\"\r\n303.1 \"Earth Missile\"\r\n309.2 \"Super Cyclone\"\r\n311.2 \"Attachment\"\r\n\r\n# CUTE ROBOTS 2\r\n# One full rotation plus a tail again, for the same reasons. Don't be slow!\r\n500.0 \"--sync--\" AddedCombatant { name: \"Blaster\" } window 300,30\r\n502.1 \"--targetable--\"\r\n510.3 \"Magicked Mark\" Ability { id: \"173F\", source: \"Swindler\" }\r\n510.3 \"Brute Force\" Ability { id: \"1738\", source: \"Blaster\" }\r\n520.4 \"Height\" Ability { id: \"1740\", source: \"Swindler\" } window 20.4,20\r\n523.4 \"Brute Force\" Ability { id: \"1738\", source: \"Blaster\" }\r\n523.6 \"Magicked Mark\" Ability { id: \"173F\", source: \"Swindler\" }\r\n526.5 \"Mind Blast\" Ability { id: \"1739\", source: \"Blaster\" }\r\n\r\n537.7 \"Mirage\" Ability { id: \"1748\", source: \"Blaster Mirage\" }\r\n543.8 \"Supercharge\" # Ability { id: \"1749\", source: \"Blaster Mirage\" }\r\n545.7 \"Magicked Mark\" Ability { id: \"173F\", source: \"Swindler\" }\r\n546.0 \"Brute Force\" Ability { id: \"1738\", source: \"Blaster\" }\r\n549.2 \"Mind Blast\" Ability { id: \"1739\", source: \"Blaster\" }\r\n555.9 \"Magicked Mark\" Ability { id: \"173F\", source: \"Swindler\" }\r\n556.3 \"Brute Force\" Ability { id: \"1738\", source: \"Blaster\" }\r\n558.8 \"Enumeration\" Ability { id: \"1742\", source: \"Swindler\" }\r\n563.4 \"Mind Blast\" Ability { id: \"1739\", source: \"Blaster\" }\r\n565.0 \"Magicked Mark\" Ability { id: \"173F\", source: \"Swindler\" }\r\n565.5 \"Brute Force\" Ability { id: \"1738\", source: \"Blaster\" }\r\n575.1 \"Height\" Ability { id: \"1740\", source: \"Swindler\" }\r\n578.3 \"Magicked Mark\" Ability { id: \"173F\", source: \"Swindler\" }\r\n578.7 \"Brute Force\" Ability { id: \"1738\", source: \"Blaster\" }\r\n581.8 \"Mind Blast\" Ability { id: \"1739\", source: \"Blaster\" }\r\n\r\n593.0 \"Mirage\" Ability { id: \"1748\", source: \"Blaster Mirage\" }\r\n599.1 \"Supercharge\"\r\n604.5 \"Mind Blast\"\r\n614.1 \"Enumeration\"\r\n618.7 \"Mind Blast\"\r\n\r\n# GO, GO, MEGAZORD MODE (BRUTE JUSTICE)\r\n800.0 \"--sync--\" AddedCombatant { name: \"Brute Justice\" } window 300,30\r\n810.3 \"--sync--\" Ability { id: \"1758\", source: \"Brute Justice\" } window 610.3,30\r\n813.0 \"--targetable--\"\r\n826.9 \"Double Rocket Punch\" Ability { id: \"174E\", source: \"Brute Justice\" } window 26,30\r\n829.0 \"Missile Command\" Ability { id: \"1668\", source: \"Brute Justice\" }\r\n832.4 \"Flarethrower\" Ability { id: \"174D\", source: \"Brute Justice\" }\r\n833.0 \"Long Needle\" Ability { id: \"1754\", source: \"Brute Justice\" }\r\n840.5 \"Apocalyptic Ray\" Ability { id: \"1751\", source: \"Brute Justice\" } duration 5 window 30,30\r\n852.4 \"Super Jump\" Ability { id: \"1750\", source: \"Brute Justice\" }\r\n858.6 \"Flarethrower\" Ability { id: \"174D\", source: \"Brute Justice\" }\r\n863.7 \"Missile Command\" Ability { id: \"1668\", source: \"Brute Justice\" }\r\n865.7 \"Short Needle x3\" duration 6 # Ability { id: \"1753\", source: \"Brute Justice\" }\r\n871.8 \"Double Rocket Punch\" Ability { id: \"174E\", source: \"Brute Justice\" } window 30,30\r\n879.0 \"Flarethrower\" Ability { id: \"174D\", source: \"Brute Justice\" }\r\n885.1 \"Missile Command\" Ability { id: \"1668\", source: \"Brute Justice\" }\r\n889.1 \"Long Needle\" Ability { id: \"1754\", source: \"Brute Justice\" }\r\n897.1 \"Mega Beam\" Ability { id: \"174F\", source: \"Brute Justice\" } window 30,30\r\n899.2 \"--untargetable--\"\r\n\r\n# ABBREVIATED INTERMISSION\r\n902.4 \"J Kick\" Ability { id: \"1756\", source: \"Brute Justice\" }\r\n914.7 \"Minefield\" Ability { id: \"174A\", source: \"Hidden Mine\" }\r\n915.7 \"Ice Missile\" Ability { id: \"1746\", source: \"Vortexer\" }\r\n916.7 \"Earth Missile\" Ability { id: \"1745\", source: \"Vortexer\" }\r\n919.9 \"Attachment\" Ability { id: \"163C\", source: \"Brawler\" }\r\n926.1 \"Single Buster/Double Buster\" Ability { id: \"173D\", source: \"Brawler\" }\r\n932.0 \"--sync--\" Ability { id: \"1636\", source: \"Brute Justice\" }\r\n933.1 \"100-Megatonze Shock\" Ability { id: \"1736\", source: \"Onslaughter\" }\r\n936.9 \"Height\" Ability { id: \"1740\", source: \"Swindler\" }\r\n939.4 \"Mega Beam\" Ability { id: \"1732\", source: \"Onslaughter\" }\r\n\r\n# FOR GREAT JUSTICE\r\n947.8 \"--targetable--\"\r\n957.9 \"Double Rocket Punch\" Ability { id: \"174E\", source: \"Brute Justice\" } window 30,30\r\n960.1 \"Missile Command\" Ability { id: \"1668\", source: \"Brute Justice\" }\r\n964.0 \"Flarethrower\" Ability { id: \"174D\", source: \"Brute Justice\" }\r\n964.0 \"Long Needle\" Ability { id: \"1754\", source: \"Brute Justice\" }\r\n972.2 \"Apocalyptic Ray\" Ability { id: \"1751\", source: \"Brute Justice\" } duration 5 window 30,30\r\n984.1 \"Super Jump\" Ability { id: \"1750\", source: \"Brute Justice\" }\r\n990.3 \"Flarethrower\" Ability { id: \"174D\", source: \"Brute Justice\" }\r\n995.4 \"Missile Command\" Ability { id: \"1668\", source: \"Brute Justice\" }\r\n997.4 \"Short Needle x3\" duration 6 # Ability { id: \"1753\", source: \"Brute Justice\" }\r\n1003.4 \"Double Rocket Punch\" Ability { id: \"174E\", source: \"Brute Justice\" } window 30,30\r\n1010.6 \"Flarethrower\" Ability { id: \"174D\", source: \"Brute Justice\" }\r\n1016.7 \"Missile Command\" Ability { id: \"1668\", source: \"Brute Justice\" }\r\n1020.7 \"Long Needle\" Ability { id: \"1754\", source: \"Brute Justice\" }\r\n1028.8 \"Mega Beam\" Ability { id: \"174F\", source: \"Brute Justice\" } window 30,30\r\n1030.9 \"--untargetable--\"\r\n1034.1 \"J Kick\" Ability { id: \"1756\", source: \"Brute Justice\" }\r\n\r\n1037.1 \"--targetable--\"\r\n1047.2 \"Double Rocket Punch\" Ability { id: \"174E\", source: \"Brute Justice\" } jump 957.9\r\n1049.4 \"Missile Command\"\r\n1053.3 \"Flarethrower\"\r\n1053.3 \"Long Needle\"\r\n1061.5 \"Apocalyptic Ray\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a8s.ts




// TODO: Final Punishment stack counts are in the network log, but not in ACT log :C
// e.g. 4 stacks:
//   26|2020-02-08T21:03:07.8080000-08:00|403|Final Punishment|
//   39.95|E0000000||1068E9CB|Potato Chippy|04|19062|||0bd20f2b57d49b17a19caa10e1fb8734
// TODO: chakram safe spots lol?
const a8s_triggerSet = {
  id: 'AlexanderTheBurdenOfTheSonSavage',
  zoneId: zone_id/* default.AlexanderTheBurdenOfTheSonSavage */.Z.AlexanderTheBurdenOfTheSonSavage,
  timelineFile: 'a8s.txt',
  initData: () => {
    return {
      longNeedlePrey: []
    };
  },
  timelineTriggers: [{
    id: 'A8S Hydrothermal Missile',
    regex: /Hydrothermal Missile/,
    beforeSeconds: 3,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'A8S Swindler Add',
    regex: /Swindler/,
    beforeSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Swindler Soon',
        de: 'Bald Schwindler',
        fr: 'Arnaqueur bientôt',
        ja: 'まもなくスウィンドラー',
        cn: '欺诈者即将出现',
        ko: '곧 조작자 등장'
      }
    }
  }, {
    id: 'A8S Vortexer Add',
    regex: /Vortexer/,
    beforeSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Vortexer Soon',
        de: 'Bald Vortexer',
        fr: 'Tourbillonneur bientôt',
        ja: 'まもなくボルテッカー',
        cn: '环旋者即将出现',
        ko: '곧 교반자 등장'
      }
    }
  }, {
    id: 'A8S Flarethrower',
    regex: /Flarethrower/,
    beforeSeconds: 3,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'A8S Super Jump Soon',
    regex: /Super Jump/,
    beforeSeconds: 8,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Super Jump',
        de: 'Supersprung ködern',
        fr: 'Attirez le Super saut',
        ja: 'スーパージャンプを誘導',
        cn: '引导超级跳',
        ko: '슈퍼 점프'
      }
    }
  }],
  triggers: [{
    id: 'A8S Megabeam Onslaughter',
    type: 'StartsUsing',
    netRegex: {
      source: 'Onslaughter',
      id: '162E',
      capture: false
    },
    // Insert sound effect from Arthars here.
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Megabeamu~',
        de: 'Megalaser~',
        fr: 'Mégarayon~',
        ja: 'メガビーム～',
        cn: '巨型光束炮~',
        ko: '고출력 광선~'
      }
    }
  }, {
    id: 'A8S Megabeam Brute Justice',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brute Justice',
      id: '1664',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Megabeamu~!',
        de: 'Megalaser~!',
        fr: 'Mégarayon~ !',
        ja: 'メガビーム～',
        cn: '巨型光束炮~!',
        ko: '고출력 광선~!'
      }
    }
  }, {
    id: 'A8S Execution',
    type: 'Ability',
    netRegex: {
      source: 'Onslaughter',
      id: '1632',
      capture: false
    },
    condition: data => data.role === 'dps' || data.job === 'BLU',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Regulators',
        de: 'Dampfregler besiegen',
        fr: 'Tuez les Régulateurs',
        ja: 'スチームジャッジを倒す',
        cn: '击杀小怪',
        ko: '증기 감독 없애기'
      }
    }
  }, {
    id: 'A8S Perpetual Ray',
    type: 'StartsUsing',
    netRegex: {
      source: 'Onslaughter',
      id: '162B'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'A8S Blaster Mirage',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Blaster Mirage',
      capture: false
    },
    suppressSeconds: 99999,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mirage',
        de: 'Mirage',
        fr: 'Mirage',
        ja: 'ミラージュ',
        cn: '幻象',
        ko: '환영'
      }
    }
  }, {
    id: 'A8S Discoid',
    type: 'HeadMarker',
    netRegex: {
      id: '0023'
    },
    condition: (data, matches) => {
      // Verdict comes with the same headmarker.
      return data.me === matches.target && !data.seenLinkUp;
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Orb on YOU',
        de: 'Orb auf DIR',
        fr: 'Orbe sur VOUS',
        ja: '自分に玉',
        cn: '球点名',
        ko: '구슬 대상자'
      }
    }
  }, {
    id: 'A8S Mind Blast',
    type: 'StartsUsing',
    netRegex: {
      source: 'Blaster',
      id: '1639'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt('alarm')
  }, {
    id: 'A8S Low Arithmeticks',
    type: 'GainsEffect',
    // Note: both high and low use '0025' headmarker
    netRegex: {
      effectId: '3FD'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 10,
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get High',
        de: 'Geh nach Oben',
        fr: 'Montez',
        ja: '高い床に乗る',
        cn: '上高台',
        ko: '높은곳으로'
      }
    }
  }, {
    id: 'A8S High Arithmeticks',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3FE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 10,
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Down',
        de: 'Geh nach Unten',
        fr: 'Descendez',
        ja: '低い床に乗る',
        cn: '下低台',
        ko: '낮은곳으로'
      }
    }
  }, {
    id: 'A8S Bio-Arithmeticks',
    type: 'StartsUsing',
    netRegex: {
      source: 'Swindler',
      id: '164A',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'A8S Super Cyclone',
    type: 'StartsUsing',
    netRegex: {
      source: 'Vortexer',
      id: '1657',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback('alarm')
  }, {
    id: 'A8S Compressed Lightning',
    type: 'GainsEffect',
    // Note: also the 0045 headmarker.
    netRegex: {
      effectId: '400'
    },
    // TODO: do we need a Responses.effectOn() that uses matches.effect?
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) return output.thunderOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return output.thunderOn({
        player: data.party.member(matches.target)
      });
    },
    run: (data, matches) => data.lightning = matches.target,
    outputStrings: {
      thunderOn: {
        en: 'Thunder on ${player}',
        de: 'Blitz auf ${player}',
        fr: 'Foudre sur ${player}',
        ja: '${player}に雷',
        cn: '雷点${player}',
        ko: '"${player}" 번개징'
      },
      thunderOnYou: {
        en: 'Thunder on YOU',
        de: 'Blitz auf DIR',
        fr: 'Foudre sur VOUS',
        ja: '自分に雷',
        cn: '雷点名',
        ko: '번개징 대상자'
      }
    }
  }, {
    id: 'A8S Compressed Lightning Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '400',
      capture: false
    },
    run: data => delete data.lightning
  }, {
    id: 'A8S Compressed Lightning Soon',
    type: 'GainsEffect',
    netRegex: {
      effectId: '400'
    },
    condition: data => data.lightning !== undefined,
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 5,
    infoText: (data, _matches, output) => {
      return output.text({
        player: data.party.member(data.lightning)
      });
    },
    outputStrings: {
      text: {
        en: 'Thunder Soon on ${player}',
        de: 'Blitz bald auf ${player}',
        fr: 'Foudre bientôt sur ${player}',
        ja: '${player}に雷頭割り',
        cn: '马上雷分摊${player}',
        ko: '"${player}" 번개징 곧 터짐'
      }
    }
  }, {
    id: 'A8S Enumeration',
    type: 'HeadMarker',
    netRegex: {
      id: ['0040', '0041', '0042']
    },
    infoText: (data, matches, output) => {
      // 0040 = 2, 0041 = 3, 0042 = 4
      const count = 2 + parseInt(matches.id, 16) - parseInt('0040', 16);
      return output.text({
        player: data.party.member(matches.target),
        count: count
      });
    },
    outputStrings: {
      text: {
        en: '${player}: ${count}',
        de: '${player}: ${count}',
        fr: '${player}: ${count}',
        ja: '${player}: ${count}',
        cn: '${player}生命计算法: ${count}',
        ko: '${player}: ${count}'
      }
    }
  }, {
    id: 'A8S Double Rocket Punch',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brute Justice',
      id: '1663'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.sharedTankbusterOnYou();
      if (data.role === 'tank' || data.role === 'healer') return output.sharedTankbusterOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      sharedTankbusterOnYou: {
        en: 'Shared Tankbuster on YOU',
        de: 'geteilter Tankbuster auf DIR',
        fr: 'Tank buster à partager sur VOUS',
        ja: '自分にタンクシェア',
        cn: '分摊死刑点名',
        ko: '쉐어 탱버 대상자'
      },
      sharedTankbusterOn: {
        en: 'Shared Tankbuster on ${player}',
        de: 'geteilter Tankbuster on ${player}',
        fr: 'Tank buster à partager sur ${player}',
        ja: '${player} にタンクシェア',
        cn: '分摊死刑点 ${player}',
        ko: '"${player}" 쉐어 탱버'
      }
    }
  }, {
    id: 'A8S Long Needle Stack Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    run: (data, matches) => data.longNeedleStack = matches.target
  }, {
    id: 'A8S Long Needle Prey Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    run: (data, matches) => data.longNeedlePrey.push(matches.target)
  }, {
    id: 'A8S Short Needle',
    type: 'Ability',
    netRegex: {
      source: 'Brute Justice',
      id: '1668',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'A8S Long Needle',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brute Justice',
      id: '166A',
      capture: false
    },
    condition: data => data.longNeedleStack !== undefined && data.longNeedlePrey.length !== 0,
    suppressSeconds: 10,
    alarmText: (data, _matches, output) => {
      if (data.longNeedlePrey.includes(data.me)) return output.preyGetOut();
    },
    alertText: (data, _matches, output) => {
      if (data.longNeedlePrey.includes(data.me)) return;
      const target = data.longNeedleStack;
      if (target === data.me) return output.stackOnYou();
      return output.stackOn({
        player: data.party.member(target)
      });
    },
    run: data => {
      delete data.longNeedleStack;
      data.longNeedlePrey = [];
    },
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer,
      preyGetOut: {
        en: 'Prey: Get Out',
        de: 'Makiert: Geh raus',
        fr: 'Marquage : À l\'extérieur',
        ja: '赤いマーク: 外へ',
        cn: '红点名离开人群',
        ko: '빨간징: 밖으로'
      }
    }
  }, {
    id: 'A8S Super Jump',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brute Justice',
      id: '1665'
    },
    alertText: (data, matches, output) => {
      if (data.me !== matches.target) return;
      return output.superJumpOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return;
      return output.superJumpOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      superJumpOn: {
        en: 'Super Jump on ${player}',
        de: 'Supersprung auf ${player}',
        fr: 'Super saut sur ${player}',
        ja: '${player}にスーパージャンプ',
        cn: '超级跳点${player}',
        ko: '"${player}" 슈퍼 점프'
      },
      superJumpOnYou: {
        en: 'Super Jump on YOU',
        de: 'Supersprung auf DIR',
        fr: 'Super saut sur VOUS',
        ja: '自分にスーパージャンプ',
        cn: '超级跳点名',
        ko: '슈퍼 점프 대상자'
      }
    }
  }, {
    id: 'A8S Mirage Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0008'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mirage on YOU',
        de: 'Mirage auf DIR',
        fr: 'Mirage sur VOUS',
        ja: '自分にミラージュ',
        cn: '分身点名',
        ko: '환영 징 대상자'
      }
    }
  }, {
    id: 'A8S Ice Missile Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0043'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Ice Missile on YOU',
        de: 'Eis-Rakete auf DIR',
        fr: 'Missile de glace sur VOUS',
        ja: '自分にアイスミサイル',
        cn: '冰点名',
        ko: '얼음 미사일 대상자'
      }
    }
  }, {
    id: 'A8S Hidden Minefield Intermission',
    type: 'Ability',
    // 165E used in both intermission and in final phase
    // 165C only used for intermission
    netRegex: {
      source: 'Hidden Mine',
      id: '165E',
      capture: false
    },
    condition: data => !data.seenLinkUp,
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Mines',
        de: 'Mienen nehmen',
        fr: 'Prenez les mines',
        ja: '地雷を踏む',
        cn: '踩雷',
        ko: '지뢰 밟기'
      }
    }
  }, {
    id: 'A8S Mirage Blinder',
    type: 'StartsUsing',
    netRegex: {
      source: 'Blaster Mirage',
      id: '165A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look Away from Mirage',
        de: 'Von Replikant wegschauen',
        fr: 'Ne regardez pas la Réplique',
        ja: 'ミラージュを見ない',
        cn: '背对幻象',
        ko: '환영 쳐다보지 않기'
      }
    }
  }, {
    id: 'A8S Mirage Power Tackle',
    type: 'StartsUsing',
    netRegex: {
      source: 'Blaster Mirage',
      id: '165B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look Towards Mirage',
        de: 'Zu Replikant hinschauen',
        fr: 'Regardez la Réplique',
        ja: 'ミラージュを見る',
        cn: '面向幻象',
        ko: '환영 쳐다보기'
      }
    }
  }, {
    id: 'A8S Link Up',
    type: 'Ability',
    netRegex: {
      source: 'Brute Justice',
      id: '1673',
      capture: false
    },
    run: data => data.seenLinkUp = true
  }, {
    id: 'A8S Verdict Min HP',
    type: 'GainsEffect',
    netRegex: {
      effectId: '408'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 8,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Min HP: Provoke Boss => Late NE Tornado',
        de: 'Min HP: Boss herrausfordern => Später No Tornado',
        fr: 'PV Min : Provocation Boss => Cyclone NE en retard',
        ja: 'HP最小: ボスに挑発 => 北東竜巻',
        cn: '最少HP:挑衅BOSS => 东北龙卷风',
        ko: 'HP 최소: 보스 도발 => 북동쪽 회오리'
      }
    }
  }, {
    id: 'A8S Verdict Min HP Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: '408'
    },
    run: (data, matches) => data.verdictMin = matches.target
  }, {
    id: 'A8S Verdict Min HP Tornado',
    type: 'GainsEffect',
    netRegex: {
      effectId: '408'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 27,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get NE Tornado',
        de: 'Nimm NO Tornado',
        fr: 'Prenez le Cyclone NE',
        ja: '北東竜巻に',
        cn: '去东北龙卷风',
        ko: '북동쪽 회오리 밟기'
      }
    }
  }, {
    id: 'A8S Verdict Max HP Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: '407'
    },
    run: (data, matches) => data.verdictMax = matches.target
  }, {
    id: 'A8S Verdict Max HP',
    type: 'GainsEffect',
    netRegex: {
      effectId: '407'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Max HP: Provoke Boss Second',
        de: 'Max HP: Boss als Zweites herrausfordern',
        fr: 'PV Max : Seconde Provocation Boss',
        ja: 'HP最大: 第二のボスを挑発',
        cn: '最多HP:第二个挑衅BOSS',
        ko: 'HP 최대: 두번째로 보스 도발'
      }
    }
  }, {
    // Final Punishment effect falling off due to auto.
    id: 'A8S Verdict Max HP Provoke',
    type: 'LosesEffect',
    netRegex: {
      effectId: '403'
    },
    condition: (data, matches) => {
      return matches.target === data.verdictMin && data.me === data.verdictMax;
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Provoke Boss',
        de: 'Boss herrausfordern',
        fr: 'Provocation Boss',
        ja: 'ボスを挑発',
        cn: '挑衅BOSS',
        ko: '보스 도발'
      }
    }
  }, {
    id: 'A8S Verdict Max HP Blu Devour',
    type: 'GainsEffect',
    netRegex: {
      effectId: '407'
    },
    condition: (data, matches) => data.me === matches.target && data.job === 'BLU',
    delaySeconds: 27,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Use Devour',
        de: 'Benutze Verschlingen',
        fr: 'Utilisez Dévoration',
        ja: '捕食を使う',
        cn: '使用捕食',
        ko: '포식 사용하기'
      }
    }
  }, {
    id: 'A8S Verdict Penalty 1',
    type: 'GainsEffect',
    netRegex: {
      effectId: '409'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 10,
    // TODO: we could say who to share north orbs with?
    // TODO: we could also repeat the "share north orbs" after sw orb Explosion.
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Penalty 1: SW orb -> Share 2x North Orbs',
        de: 'Schwächung 1: SW orb -> 2x nördliche Orbs teilen',
        fr: 'Altération 1 : Orbe SO -> Partagez 2x Orbes Nord',
        ja: '1番: 南西にいる玉を喰らう => 北にいる玉と頭割り',
        cn: '1号：吃西南球然后分摊北边双球',
        ko: '약화 1: 남서쪽 구슬 -> 북쪽 구슬 2개'
      }
    }
  }, {
    id: 'A8S Verdict Penalty 2',
    type: 'GainsEffect',
    netRegex: {
      effectId: '40A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Penalty 2: NW Tornado',
        de: 'Schwächung 2: NW Tornado',
        fr: 'Altérations 2 : Cyclone NO',
        ja: '2番: 北西竜巻',
        cn: '2号：西北龙卷风',
        ko: '약화 2: 북서쪽 회오리'
      }
    }
  }, {
    id: 'A8S Verdict Penalty 3',
    type: 'GainsEffect',
    netRegex: {
      effectId: '40B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Penalty 3: Get a South Tornado',
        de: 'Schwächung 3: Nimm südlichen Tornado',
        fr: 'Altérations 3 : Prenez le Cyclone Sud',
        ja: '3番: 南竜巻',
        cn: '3号：南边龙卷风',
        ko: '약화 3: 남쪽 회오리 중 하나 밟기'
      }
    }
  }, {
    id: 'A8S Verdict Penalty 3 Orb',
    type: 'GainsEffect',
    netRegex: {
      effectId: '40B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 28,
    // TODO: we could collect who else has penalty 3 to share the orb with?
    // TODO: we could also say who to share north orb with.
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Share last orb after gavel',
        de: 'Orn mach Prozessende teilen',
        fr: 'Partagez l\'orbe après le procès',
        ja: 'そして最後の玉と頭割り',
        cn: '等待锤子判定后分摊最后球',
        ko: '폐정 이후 구슬 남은거 처리'
      }
    }
  }, {
    id: 'A8S Verdict Nisi A',
    type: 'GainsEffect',
    netRegex: {
      effectId: '40C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // TODO: we could say east or west here after the regulators spawn?
    // TODO: we could also say who to share north orb with.
    // TODO: we could also repeat the share after the regular dies?
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Blue Regulator -> Share 1x North Orb',
        de: 'Blauer Dampfregler -> 1x nördlichen Orb teilen',
        fr: 'Régulateur bleu -> Partagez 1x Orbe Nord',
        ja: '青いスチームジャッジ => 北の玉と頭割り',
        cn: '蓝色小怪然后北边分摊球',
        ko: '파란색 쫄 -> 북쪽 구슬 하나 처리'
      }
    }
  }, {
    id: 'A8S Verdict Nisi B',
    type: 'GainsEffect',
    netRegex: {
      effectId: '40D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Red Regulator -> Share 1x North Orb',
        de: 'Roter Dampfregler -> 1x nördlichen Orb teilen',
        fr: 'Régulateur rouge -> Partagez 1x Orbe Nord',
        ja: '赤いスチームジャッジ => 北の玉と頭割り',
        cn: '红色小怪然后北边分摊球',
        ko: '빨간색 쫄 -> 북쪽 구슬 하나 처리'
      }
    }
  }, {
    id: 'A8S Compressed Water',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3FF'
    },
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) return output.waterOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return output.waterOn({
        player: data.party.member(matches.target)
      });
    },
    run: (data, matches) => data.water = matches.target,
    outputStrings: {
      waterOn: {
        en: 'Water on ${player}',
        de: 'Wasser auf ${player}',
        fr: 'Eau sur ${player}',
        ja: '${player}に水',
        cn: '水点${player}',
        ko: '"${player}" 물징'
      },
      waterOnYou: {
        en: 'Water on YOU',
        de: 'Wasser auf DIR',
        fr: 'Eau sur VOUS',
        ja: '自分に水',
        cn: '水点名',
        ko: '물징 대상자'
      }
    }
  }, {
    id: 'A8S Compressed Water Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '3FF',
      capture: false
    },
    run: data => {
      // rip, valiant mine sac
      delete data.water;
    }
  }, {
    id: 'A8S Compressed Water Soon',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3FF'
    },
    condition: data => data.water !== undefined,
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 5,
    infoText: (data, _matches, output) => {
      return output.text({
        player: data.party.member(data.water)
      });
    },
    outputStrings: {
      text: {
        en: 'Water Soon on ${player}',
        de: 'Wasser bald auf ${player}',
        fr: 'Eau bientôt sur ${player}',
        ja: 'まもなく、${player}に頭割り',
        cn: '马上水分摊${player}',
        ko: '"${player}" 물징 곧 터짐'
      }
    }
  }, {
    id: 'A8S Final Punch',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brute Justice',
      id: '170C'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'A8S Final Beam',
    type: 'Ability',
    // id is for Final Apocalypse Ability
    netRegex: {
      source: 'Brute Justice',
      id: '1716',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack for Final Beam',
        de: 'Stack für Finaler Megastrahl',
        fr: 'Packez-vous pour Mégarayon final',
        ja: 'ファイナルメガビームに頭割り',
        cn: '集合分摊',
        ko: '최후의 고출력 광선 쉐어'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Blaster Mirage': 'Blaster-Replikant',
      'Blaster(?! Mirage)': 'Blaster',
      'Brawler': 'Blechbrecher',
      'Brute Justice': 'Brutalus',
      'Hidden Mine': 'Minenfalle',
      'Onslaughter': 'Schlachter',
      'Steam Chakram': 'Dampf-Chakram',
      'Steam Regulator B': 'β-Dampfregler',
      'Swindler': 'Schwindler',
      'Vortexer': 'Wirbler'
    },
    'replaceText': {
      '--orbs--': '--kugeln--',
      '--regulator check--': '--dampfregler check--',
      '100-Megatonze Shock': '100-Megatonzen-Schock',
      'Apocalyptic Ray': 'Apokalyptischer Strahl',
      'Attachment': 'Anlegen',
      'Auxiliary Power': 'Notstrom',
      'Ballistic Missile': 'Ballistische Rakete',
      'Blaster': 'Blaster',
      'Blinder': 'Blendgeschoss',
      'Brawler': 'Blechbrecher',
      'Brute Force': 'Brutaler Schlag',
      'Crashing Thunder': 'Brechende Welle',
      'Discoid': 'Diskoid',
      'Double Buster': 'Doppelsprenger',
      'Double Drill Crush': 'Doppeldrill',
      'Double Rocket Punch': 'Doppelraketenschlag',
      'Drill Drive': 'Bohrschub',
      'Earth Missile': 'Erd-Geschoss',
      'Elemental Jammer': 'Elementarstörer',
      'Enumeration': 'Zählen',
      'Execution': 'Exekutive',
      'Eye of the Chakram': 'Auge des Chakrams',
      'Final Apocalypse': 'Finaler Apokalyptischer Strahl',
      'Final Beam': 'Finaler Megastrahl',
      'Final Punch': 'Endgültiger Doppelraketenschlag',
      'Flarethrower': 'Großflammenwerfer',
      'Gavel': 'Prozessende',
      'Height': 'Nivellierung',
      'Hidden Minefield': 'Getarntes Minenfeld',
      'Hydrothermal Missile': 'Hydrothermales Geschoss',
      'Ice Missile': 'Eisgeschoss',
      'J Kick': 'Gewissenstritt',
      'J Storm': 'Gerechter Sturm',
      'J Wave': 'Gerechte Schockwelle',
      'Justice': 'Großer Richter',
      'Legislation': 'Legislative',
      'Link-Up': 'Zusammenschluss',
      'Long Needle': 'Großes Kaliber',
      'Magicked Mark': 'Magiegeschoss',
      'Mechanic': 'Mechanik',
      'Mega Beam': 'Megastrahl',
      'Mind Blast': 'Geiststoß',
      'Mirage': 'Illusion',
      'Missile Command': 'Raketenkommando',
      'Perpetual Ray': 'Perpetueller Strahl',
      'Power Tackle': 'Niederringen',
      'Rocket Drill': 'Raketenbohrer',
      'Seed of the Sky': 'Samen des Himmels',
      'Short Needle': 'Kleines Kaliber',
      'Single Buster': 'Einzelsprenger',
      'Super Cyclone': 'Superzyklon',
      'Super Jump': 'Supersprung',
      'Supercharge': 'Superladung',
      'Swindler': 'Schwindler',
      'Transform': 'Geballte Rechtsgewalt',
      'Ultra Flash': 'Ultrablitz',
      'Verdict': 'Prozesseröffnung',
      'Vortexer': 'Wirbler'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Blaster Mirage': 'Réplique du Fracasseur',
      'Blaster(?! Mirage)': 'Fracasseur',
      'Brawler': 'Bagarreur',
      'Brute Justice': 'Justicier',
      'Hidden Mine': 'mine furtive',
      'Onslaughter': 'Attaqueur',
      'Steam Chakram': 'Chakram de vapeur',
      'Steam Regulator B': 'Régulateur de vapeur β',
      'Swindler': 'Arnaqueur',
      'Vortexer': 'Tourbillonneur'
    },
    'replaceText': {
      '--orbs--': '--orbes--',
      '--regulator check--': '--vérification du régulateur--',
      '100-Megatonze Shock': 'Choc de 100 mégatonz',
      'Apocalyptic Ray': 'Rayon apocalyptique',
      'Attachment': 'Extension',
      'Auxiliary Power': 'Soutien énergétique',
      'Ballistic Missile': 'Missiles balistiques',
      'Blaster': 'Fracasseur',
      'Blinder': 'Missile aveuglant',
      'Brawler(?! Mechanic)': 'Bagarreur',
      'Brawler Mechanic': 'Mécanique du Bagarreur',
      'Brute Force': 'Force brute',
      'Crashing Thunder': 'Éclair percutant',
      'Discoid': 'Discoïde',
      'Double Buster': 'Double pulsoréacteur',
      'Double Drill Crush': 'Écrasement foreuse double',
      'Double Rocket Punch': 'Double coup de roquette',
      'Drill Drive': 'Frappe foreuse',
      'Earth Missile': 'Missile de terre',
      'Elemental Jammer': 'Grippage élémentaire',
      'Enumeration': 'Compte',
      'Execution': 'Exécution',
      'Eye of the Chakram': 'Œil du chakram',
      'Final Apocalypse': 'Rayon apocalyptique final',
      'Final Beam': 'Mégarayon final',
      'Final Punch': 'Double coup de roquette final',
      'Flarethrower': 'Lance-brasiers',
      'Gavel': 'Conclusion de procès',
      'Height': 'Dénivellation',
      'Hidden Minefield': 'Champ de mines caché',
      'Hydrothermal Missile': 'Missile hydrothermique',
      'Ice Missile': 'Missile de glace',
      'J Kick': 'Pied justicier',
      'J Storm': 'Tempête justicière',
      'J Wave': 'Onde de choc justicière',
      'Justice': 'Justicier',
      'Legislation': 'Législation',
      'Link-Up': 'Effort collectif',
      'Long Needle': 'Gros missiles',
      'Magicked Mark': 'Tir magique',
      'Mega Beam': 'Mégarayon',
      'Mind Blast\\?': 'Explosion mentale ?',
      'Mirage': 'Mirage',
      'Missile Command': 'Commande missile',
      'Perpetual Ray': 'Rayon perpétuel',
      'Power Tackle': 'Tacle puissant',
      'Rocket Drill': 'Roquette-foreuse',
      'Seed Of The Sky': 'Graine du ciel',
      'Short Needle': 'Petits missiles',
      'Single Buster': 'Pulsoréacteur',
      'Super Cyclone': 'Super cyclone',
      'Super Jump': 'Super saut',
      'Supercharge': 'Super charge',
      'Swindler': 'Arnaqueur',
      'Transform': 'Assemblage Justicier',
      'Ultra Flash': 'Ultraflash',
      'Verdict': 'Ouverture de procès',
      'Vortexer': 'Tourbillonneur'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Blaster Mirage': 'ブラスター・ミラージュ',
      'Blaster(?! Mirage)': 'ブラスター',
      'Brawler': 'ブロウラー',
      'Brute Justice': 'ブルートジャスティス',
      'Hidden Mine': 'ステルス地雷',
      'Onslaughter': 'オンスローター',
      'Steam Chakram': 'スチームチャクラム',
      'Steam Regulator B': 'スチームジャッジβ',
      'Swindler': 'スウィンドラー',
      'Vortexer': 'ボルテッカー'
    },
    'replaceText': {
      '--orbs--': '--オーブ--',
      '--regulator check--': '--レギュレーターチェック--',
      '100-Megatonze Shock': '100メガトンズショック',
      'Apocalyptic Ray': 'アポカリプティクレイ',
      'Attachment': 'アタッチメント',
      'Auxiliary Power': 'エネルギー支援',
      'Ballistic Missile': 'ミサイル発射',
      'Blaster': 'ブラスター',
      'Blinder': 'ブラインダーミサイル',
      'Brawler(?! Mechanic)': 'ブロウラー',
      'Brawler Mechanic': 'ブロウラー ギミック',
      'Brute Force': 'ブルートパンチ',
      'Crashing Thunder': 'クラッシュサンダー',
      'Discoid': 'ディスコイド',
      'Double Buster': 'ダブルバスターアタック',
      'Double Drill Crush': 'ダブルドリルクラッシュ',
      'Double Rocket Punch': 'ダブルロケットパンチ',
      'Drill Drive': 'ドリルドライブ',
      'Earth Missile': 'アースミサイル',
      'Elemental Jammer': 'エレメンタルジャミング',
      'Enumeration': 'カウント',
      'Execution': '執行準備',
      'Eye of the Chakram': 'ビームチャクラム',
      'Final Apocalypse': 'ファイナルアポカリプティクレイ',
      'Final Beam': 'ファイナルメガビーム',
      'Final Punch': 'ファイナルダブルロケットパンチ',
      'Flarethrower': '大火炎放射',
      'Gavel': '最後の審判：結審',
      'Height': 'ハイト',
      'Hidden Minefield': 'ステルス地雷',
      'Hydrothermal Missile': '蒸気ミサイル',
      'Ice Missile': 'アイスミサイル',
      'J Kick': 'ジャスティスキック',
      'J Storm': 'ジャスティスストーム',
      'J Wave': 'ジャスティスショックウェーブ',
      'Justice': 'ジャスティス合神',
      'Legislation': '法整備',
      'Link-Up': 'システムリンク',
      'Long Needle': '大型ミサイル',
      'Magicked Mark': 'マジックショット',
      'Mega Beam': 'メガビーム',
      'Mind Blast': 'マインドブラスト',
      'Mirage': 'ミラージュシステム',
      'Missile Command': 'ミサイル全弾発射',
      'Perpetual Ray': 'パーペチュアルレイ',
      'Power Tackle': 'パワータックル',
      'Rocket Drill': 'ロケットドリル',
      'Seed of the Sky': 'シード・オブ・スカイ',
      'Short Needle': '小型ミサイル',
      'Single Buster': 'バスターアタック',
      'Super Cyclone': 'スーパーサイクロン',
      'Super Jump': 'スーパージャンプ',
      'Supercharge': 'スーパーチャージ',
      'Swindler': 'スウィンドラー',
      'Transform': 'ジャスティス合体',
      'Ultra Flash': 'ウルトラフラッシュ',
      'Verdict': '最後の審判：開廷',
      'Vortexer': 'ボルテッカー',
      'Seed Of The Sky': 'シード・オブ・スカイ',
      'Eye Of The Chakram': 'ビームチャクラム'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Blaster Mirage': '爆破者幻象',
      'Blaster(?! Mirage)': '爆破者',
      'Brawler': '争斗者',
      'Brute Justice': '残暴正义号',
      'Hidden Mine': '隐形地雷',
      'Onslaughter': '突击者',
      'Steam Chakram': '蒸汽战轮',
      'Steam Regulator B': '蒸汽调整者β',
      'Swindler': '欺诈者',
      'Vortexer': '环旋者'
    },
    'replaceText': {
      '--orbs--': '--球--',
      '--regulator check--': '--调节器检查--',
      '100-Megatonze Shock': '亿万吨震荡',
      'Apocalyptic Ray': '末世宣言',
      'Attachment': '配件更换',
      'Auxiliary Power': '能量支援',
      'Ballistic Missile': '导弹发射',
      'Blaster': '冲击波',
      'Blinder': '混合导弹',
      'Brawler': '争斗者',
      'Brute Force': '残暴铁拳',
      'Crashing Thunder': '冲击雷',
      'Discoid': '圆盘',
      'Double Buster': '双重破坏炮击',
      'Double Drill Crush': '双重飞钻冲击',
      'Double Rocket Punch': '双重火箭飞拳',
      'Drill Drive': '钻头驱动',
      'Earth Missile': '大地导弹',
      'Elemental Jammer': '元素干扰',
      'Enumeration': '计数',
      'Execution': '执行准备',
      'Eye of the Chakram': '激光战轮',
      'Final Apocalypse': '终极末世宣言',
      'Final Beam': '终极巨型光束炮',
      'Final Punch': '终极双重火箭飞拳',
      'Flarethrower': '大火炎放射',
      'Gavel': '终审闭庭',
      'Height': '高度算术',
      'Hidden Minefield': '隐形地雷散布',
      'Hydrothermal Missile': '蒸汽导弹',
      'Ice Missile': '寒冰导弹',
      'J Kick': '正义飞踢',
      'J Storm': '正义风暴',
      'J Wave': '正义震荡波',
      'Justice': '正义合神',
      'Legislation': '法制整顿',
      'Link-Up': '系统连接',
      'Long Needle': '大型导弹',
      'Magicked Mark': '魔力射击',
      'Mechanic': '争斗者变形',
      'Mega Beam': '巨型光束炮',
      'Mind Blast': '精神冲击',
      'Mirage': '幻影系统',
      'Missile Command': '导弹齐发',
      'Perpetual Ray': '永恒射线',
      'Power Tackle': '强力前冲拳',
      'Rocket Drill': '火箭飞钻',
      'Seed of the Sky': '天空之种',
      'Short Needle': '小型导弹',
      'Single Buster': '破坏炮击',
      'Super Cyclone': '超级气旋',
      'Super Jump': '超级跳跃',
      'Supercharge': '超突击',
      'Swindler': '欺诈者',
      'Transform': '正义合体',
      'Ultra Flash': '究极闪光',
      'Verdict': '终审开庭',
      'Vortexer': '环旋者'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Blaster Mirage': '폭파자의 환영',
      'Blaster(?! Mirage)': '폭파자',
      'Brawler': '폭격자',
      'Brute Justice': '포악한 심판자',
      'Hidden Mine': '은폐 지뢰',
      'Onslaughter': '맹습자',
      'Steam Chakram': '증기 차크람',
      'Steam Regulator B': '증기 감독 β',
      'Swindler': '조작자',
      'Vortexer': '교반자'
    },
    'replaceText': {
      '--orbs--': '--구슬--',
      '--regulator check--': '--증기 감옥 확인--',
      '100-Megatonze Shock': '100메가톤즈 충격',
      'Apocalyptic Ray': '파멸 계시',
      'Attachment': '무기 장착',
      'Auxiliary Power': '에너지 지원',
      'Ballistic Missile': '미사일 발사',
      'Blaster': '폭파자',
      'Blinder': '섬광 미사일',
      'Brawler(?! Mechanic)': '폭격자',
      'Brawler Mechanic': '한손/양손 버스터/드릴',
      'Brute Force': '폭력적인 주먹',
      'Crashing Thunder': '충격의 번개',
      'Discoid': '원반',
      'Double Buster': '양손 버스터',
      'Double Drill Crush': '양손 드릴 분쇄',
      'Double Rocket Punch': '양손 로켓 주먹',
      'Drill Drive': '드릴 구동',
      'Earth Missile': '대지 미사일',
      'Elemental Jammer': '원소 간섭',
      'Enumeration': '계산',
      'Execution': '집행 준비',
      'Eye of the Chakram': '광선 차크람',
      'Final Apocalypse': '최후의 파멸 계시',
      'Final Beam': '최후의 고출력 광선',
      'Final Punch': '최후의 양손 로켓 주먹',
      'Flarethrower': '대화염방사',
      'Gavel': '최후의 심판: 폐정',
      'Height': '고도',
      'Hidden Minefield': '은폐 지뢰 살포',
      'Hydrothermal Missile': '증기 미사일',
      'Ice Missile': '얼음 미사일',
      'J Kick': '정의의 발차기',
      'J Storm': '정의의 폭풍',
      'J Wave': '정의의 충격파',
      'Justice': '정의의 합신',
      'Legislation': '법률 정비',
      'Link-Up': '시스템 연결',
      'Long Needle': '대형 미사일',
      'Magicked Mark': '마법 사격',
      'Mega Beam': '고출력 광선',
      'Mind Blast': '정신파괴',
      'Mirage': '환영 시스템',
      'Missile Command': '미사일 전탄 발사',
      'Perpetual Ray': '영원한 빛줄기',
      'Power Tackle': '강력 들이받기',
      'Rocket Drill': '한손 드릴',
      'Seed of the Sky': '하늘의 원천',
      'Short Needle': '소형 미사일',
      'Single Buster': '한손 버스터',
      'Super Cyclone': '대형 돌개바람',
      'Super Jump': '슈퍼 점프',
      'Supercharge': '강력 돌진',
      'Swindler': '조작자',
      'Transform': '정의의 합체',
      'Ultra Flash': '초섬광',
      'Verdict': '최후의 심판: 개정',
      'Vortexer': '교반자'
    }
  }]
};
/* harmony default export */ const a8s = (a8s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a8s.txt
const raid_a8s_namespaceObject = "### A8S\r\n# Alexander - The Burden of the Son (Savage)\r\n# https://dtguilds.enjin.com/a8sguide\r\n# -p 162A:6.7 163B:313.5 1657:603 167C:800 166E:1257.1\r\n# -ii 1629 162C 1630 1644 1643 164F 1667 166A 166B 165F 1671 1723 165C 1641\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Magicked Mark\"\r\nhideall \"Brute Force\"\r\n\r\n### Phase 1: Onslaughter: Execution and Legislation\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n6.7 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" } window 7,5\r\n15.9 \"Seed Of The Sky\" Ability { id: \"162D\", source: \"Onslaughter\" }\r\n17.9 \"Mega Beam\" Ability { id: \"162E\", source: \"Onslaughter\" }\r\n22.1 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" }\r\n\r\n29.3 \"Execution\" Ability { id: \"1632\", source: \"Onslaughter\" }\r\n31.5 \"--targetable--\"\r\n31.5 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" }\r\n38.7 \"Seed Of The Sky\" Ability { id: \"162D\", source: \"Onslaughter\" }\r\n40.7 \"Mega Beam\" Ability { id: \"162E\", source: \"Onslaughter\" }\r\n47.9 \"Perpetual Ray\" Ability { id: \"162B\", source: \"Onslaughter\" } duration 3.3\r\n51.5 \"--regulator check--\" #Ability { id: \"1634\", source: \"Steam Regulator B\" }\r\n54.7 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" }\r\n61.8 \"Mega Beam\" Ability { id: \"162E\", source: \"Onslaughter\" }\r\n66.0 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" }\r\n\r\n73.2 \"Legislation\" Ability { id: \"1631\", source: \"Onslaughter\" }\r\n78.3 \"Discoid\" Ability { id: \"162F\", source: \"Onslaughter\" }\r\n79.9 \"--orbs--\"\r\n80.5 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" }\r\n90.7 \"Seed Of The Sky\" Ability { id: \"162D\", source: \"Onslaughter\" }\r\n93.0 \"Mega Beam\" Ability { id: \"162E\", source: \"Onslaughter\" }\r\n95.4 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" }\r\n\r\n102.5 \"Perpetual Ray\" Ability { id: \"162B\", source: \"Onslaughter\" } duration 3.3\r\n106.9 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" }\r\n117.1 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" }\r\n126.3 \"Seed Of The Sky\" Ability { id: \"162D\", source: \"Onslaughter\" }\r\n127.4 \"Mega Beam\" Ability { id: \"162E\", source: \"Onslaughter\" }\r\n132.6 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" }\r\n138.7 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" }\r\n\r\n145.8 \"Perpetual Ray\" Ability { id: \"162B\", source: \"Onslaughter\" } duration 3.3\r\n150.2 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" }\r\n155.3 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" }\r\n164.5 \"Seed Of The Sky\" Ability { id: \"162D\", source: \"Onslaughter\" }\r\n165.6 \"Mega Beam\" Ability { id: \"162E\", source: \"Onslaughter\" }\r\n170.8 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" }\r\n176.9 \"Hydrothermal Missile\" Ability { id: \"162A\", source: \"Onslaughter\" }\r\n\r\n184.0 \"Perpetual Ray\" Ability { id: \"162B\", source: \"Onslaughter\" } duration 3.3 window 30,30 jump 145.8\r\n188.4 \"Hydrothermal Missile\"\r\n193.5 \"Hydrothermal Missile\"\r\n202.7 \"Seed Of The Sky\"\r\n203.8 \"Mega Beam\"\r\n209.0 \"Hydrothermal Missile\"\r\n215.1 \"Hydrothermal Missile\"\r\n\r\n\r\n### Phase 2: Robots\r\n300.0 \"--sync--\" NameToggle { name: \"Onslaughter\", toggle: \"00\" } window 300,0\r\n303.0 \"--sync--\" AddedCombatant { name: \"Blaster\" } window 303,30\r\n304.0 \"Blaster (north)\"\r\n304.0 \"Brawler (middle)\"\r\n306.2 \"--targetable--\"\r\n313.5 \"Magicked Mark\" Ability { id: \"163B\", source: \"Brawler\" } window 314,5\r\n314.5 \"Brute Force\" Ability { id: \"1638\", source: \"Blaster\" }\r\n316.6 \"Auxiliary Power\" Ability { id: \"164B\", source: \"Brawler\" }\r\n\r\n319.8 \"Attachment\" Ability { id: \"163C\", source: \"Brawler\" }\r\n322.4 \"Mind Blast?\" #Ability { id: \"1639\", source: \"Blaster\" } # 3 second cast, interruptible\r\n324.5 \"Brute Force\" #Ability { id: \"1638\", source: \"Blaster Mirage\" }\r\n325.6 \"Brute Force\" Ability { id: \"1638\", source: \"Blaster\" }\r\n326.0 \"Brawler Mechanic\" Ability { id: [\"163D\", \"163E\", \"163F\", \"1640\"], source: \"Brawler\" }\r\n\r\n329.4 \"Swindler (east)\" #NameToggle { name: \"Swindler\", toggle: \"01\" }\r\n330.1 \"Auxiliary Power\" Ability { id: \"164B\", source: \"Brawler\" }\r\n333.7 \"Brute Force\" Ability { id: \"1638\", source: \"Blaster\" }\r\n334.2 \"Magicked Mark\" Ability { id: \"163B\", source: \"Brawler\" }\r\n334.6 \"Brute Force\" #Ability { id: \"1638\", source: \"Blaster Mirage\" }\r\n337.5 \"Magicked Mark\" Ability { id: \"1646\", source: \"Swindler\" }\r\n341.7 \"Brute Force\" Ability { id: \"1638\", source: \"Blaster\" }\r\n343.2 \"Magicked Mark\" Ability { id: \"163B\", source: \"Brawler\" }\r\n346.3 \"Auxiliary Power\" Ability { id: \"164B\", source: \"Brawler\" }\r\n348.5 \"Height\" Ability { id: \"1647\", source: \"Swindler\" }\r\n349.4 \"Attachment\" Ability { id: \"163C\", source: \"Brawler\" }\r\n\r\n352.4 \"Vortexer (south)\" #NameToggle { name: \"Vortexer\", toggle: \"01\" }\r\n354.6 \"Magicked Mark\" Ability { id: \"1646\", source: \"Swindler\" }\r\n355.5 \"Brawler Mechanic\" Ability { id: [\"163D\", \"163E\", \"163F\", \"1640\"], source: \"Brawler\" }\r\n359.6 \"Auxiliary Power\" Ability { id: \"164B\", source: \"Brawler\" }\r\n360.4 \"Brute Force\" Ability { id: \"164D\", source: \"Vortexer\" }\r\n363.7 \"Magicked Mark\" Ability { id: \"163B\", source: \"Brawler\" }\r\n370.4 \"Brute Force\" Ability { id: \"164D\", source: \"Vortexer\" }\r\n372.8 \"Magicked Mark\" Ability { id: \"163B\", source: \"Brawler\" }\r\n375.9 \"Auxiliary Power\" Ability { id: \"164B\", source: \"Brawler\" }\r\n379.0 \"Attachment\" Ability { id: \"163C\", source: \"Brawler\" }\r\n380.5 \"Brute Force\" Ability { id: \"164D\", source: \"Vortexer\" }\r\n385.0 \"Brawler Mechanic\" Ability { id: [\"163D\", \"163E\", \"163F\", \"1640\"], source: \"Brawler\" }\r\n390.2 \"Auxiliary Power\" Ability { id: \"164B\", source: \"Brawler\" }\r\n390.6 \"Brute Force\" Ability { id: \"164D\", source: \"Vortexer\" }\r\n393.4 \"Attachment\" Ability { id: \"163C\", source: \"Brawler\" }\r\n399.5 \"Brawler Mechanic\" Ability { id: [\"163D\", \"163E\", \"163F\", \"1640\"], source: \"Brawler\" }\r\n400.7 \"Brute Force\" Ability { id: \"164D\", source: \"Vortexer\" }\r\n403.6 \"Auxiliary Power\" Ability { id: \"164B\", source: \"Brawler\" }\r\n407.7 \"Magicked Mark\" Ability { id: \"163B\", source: \"Brawler\" }\r\n\r\n\r\n# All of the robots have their own rotation <50%\r\n# Messing up thunder seems the most punishing, so here's Vortexer.\r\n600.0 \"--sync--\" StartsUsing { id: \"1657\", source: \"Vortexer\" } window 600,0\r\n603.0 \"Super Cyclone\" Ability { id: \"1657\", source: \"Vortexer\" }\r\n608.1 \"Elemental Jammer\" Ability { id: \"167E\", source: \"Vortexer\" }\r\n615.4 \"Ballistic Missile\" Ability { id: \"1650\", source: \"Vortexer\" }\r\n621.4 \"Earth Missile\" Ability { id: \"1651\", source: \"Vortexer\" }\r\n645.8 \"Ballistic Missile\" Ability { id: \"1650\", source: \"Vortexer\" }\r\n650.0 \"Crashing Thunder\" Ability { id: \"164E\", source: \"Vortexer\" }\r\n651.7 \"Earth Missile\" Ability { id: \"1651\", source: \"Vortexer\" }\r\n671.6 \"Crashing Thunder\" Ability { id: \"164E\", source: \"Vortexer\" }\r\n676.1 \"Ballistic Missile\" Ability { id: \"1650\", source: \"Vortexer\" }\r\n682.1 \"Earth Missile\" Ability { id: \"1651\", source: \"Vortexer\" }\r\n\r\n\r\n### Phase 3: Brute Justice\r\n800.0 \"Transform\" Ability { id: \"167C\", source: \"Brute Justice\" } window 800,0\r\n802.7 \"--targetable--\"\r\n810.9 \"Flarethrower\" Ability { id: \"1662\", source: \"Brute Justice\" }\r\n818.0 \"Double Rocket Punch\" Ability { id: \"1663\", source: \"Brute Justice\" }\r\n821.2 \"Missile Command\" Ability { id: \"1668\", source: \"Brute Justice\" }\r\n824.2 \"Short Needle\" Ability { id: \"1669\", source: \"Brute Justice\" }\r\n825.3 \"Flarethrower\" Ability { id: \"1662\", source: \"Brute Justice\" }\r\n# 166A (ground), 166B (prey), 166C (stack)\r\n828.2 \"Long Needle\" Ability { id: \"166C\", source: \"Brute Justice\" }\r\n831.1 \"Short Needle\" Ability { id: \"1669\", source: \"Brute Justice\" }\r\n831.6 \"Mega Beam\" Ability { id: \"1664\", source: \"Brute Justice\" }\r\n837.0 \"Super Jump\" Ability { id: \"1665\", source: \"Brute Justice\" }\r\n841.6 \"Apocalyptic Ray\" Ability { id: \"1666\", source: \"Brute Justice\" } duration 5\r\n850.9 \"Flarethrower\" Ability { id: \"1662\", source: \"Brute Justice\" }\r\n857.0 \"Double Rocket Punch\" Ability { id: \"1663\", source: \"Brute Justice\" }\r\n859.1 \"Flarethrower\" Ability { id: \"1662\", source: \"Brute Justice\" }\r\n862.2 \"Missile Command\" Ability { id: \"1668\", source: \"Brute Justice\" }\r\n865.2 \"Short Needle\" Ability { id: \"1669\", source: \"Brute Justice\" }\r\n866.3 \"Flarethrower\" Ability { id: \"1662\", source: \"Brute Justice\" }\r\n869.2 \"Long Needle\" Ability { id: \"166C\", source: \"Brute Justice\" }\r\n872.2 \"Short Needle\" Ability { id: \"1669\", source: \"Brute Justice\" }\r\n872.9 \"Mega Beam\" Ability { id: \"1664\", source: \"Brute Justice\" }\r\n878.1 \"Super Jump\" Ability { id: \"1665\", source: \"Brute Justice\" }\r\n881.2 \"--untargetable--\"\r\n\r\n\r\n### Phase 4: First Intermission\r\n884.4 \"J Kick\" Ability { id: \"166D\", source: \"Brute Justice\" } window 890,5\r\n892.7 \"--sync--\" Ability { id: \"1636\", source: \"Brute Justice\" }\r\n893.9 \"100-Megatonze Shock\" Ability { id: \"1635\", source: \"Onslaughter\" }\r\n894.7 \"Mirage\" Ability { id: \"1658\", source: \"Blaster Mirage\" }\r\n895.7 \"Attachment\" Ability { id: \"163C\", source: \"Brawler\" }\r\n899.7 \"Supercharge\" #Ability { id: \"1659\", source: \"Blaster Mirage\" }\r\n901.9 \"Double Buster\" Ability { id: \"163E\", source: \"Brawler\" }\r\n906.2 \"Mega Beam\" Ability { id: \"162E\", source: \"Onslaughter\" }\r\n906.5 \"Eye Of The Chakram\" Ability { id: \"1654\", source: \"Steam Chakram\" }\r\n914.0 \"Attachment\" Ability { id: \"163C\", source: \"Brawler\" }\r\n915.5 \"Height\" Ability { id: \"1647\", source: \"Swindler\" }\r\n915.6 \"Ice Missile\" #Ability { id: \"1655\", source: \"Vortexer\" }\r\n916.4 \"Earth Missile\" Ability { id: \"1651\", source: \"Vortexer\" }\r\n919.5 \"Mega Beam\" Ability { id: \"162E\", source: \"Onslaughter\" }\r\n920.6 \"Single Buster\" Ability { id: \"163D\", source: \"Brawler\" }\r\n\r\n\r\n### Phase 5: Round 2, Fighto!\r\n933.1 \"--targetable--\"\r\n936.2 \"Flarethrower\" Ability { id: \"1662\", source: \"Brute Justice\" }\r\n943.3 \"Double Rocket Punch\" Ability { id: \"1663\", source: \"Brute Justice\" }\r\n946.5 \"Missile Command\" Ability { id: \"1668\", source: \"Brute Justice\" }\r\n949.5 \"Short Needle\" Ability { id: \"1669\", source: \"Brute Justice\" }\r\n950.6 \"Flarethrower\" Ability { id: \"1662\", source: \"Brute Justice\" }\r\n953.5 \"Long Needle\" Ability { id: \"166C\", source: \"Brute Justice\" }\r\n956.4 \"Short Needle\" Ability { id: \"1669\", source: \"Brute Justice\" }\r\n956.9 \"Mega Beam\" Ability { id: \"1664\", source: \"Brute Justice\" }\r\n962.3 \"Super Jump\" Ability { id: \"1665\", source: \"Brute Justice\" }\r\n966.9 \"Apocalyptic Ray\" Ability { id: \"1666\", source: \"Brute Justice\" } duration 5\r\n976.2 \"Flarethrower\" Ability { id: \"1662\", source: \"Brute Justice\" }\r\n982.3 \"Double Rocket Punch\" Ability { id: \"1663\", source: \"Brute Justice\" }\r\n984.4 \"Flarethrower\" Ability { id: \"1662\", source: \"Brute Justice\" }\r\n987.5 \"Missile Command\" Ability { id: \"1668\", source: \"Brute Justice\" }\r\n990.5 \"Short Needle\" Ability { id: \"1669\", source: \"Brute Justice\" }\r\n991.6 \"Flarethrower\" Ability { id: \"1662\", source: \"Brute Justice\" }\r\n994.5 \"Long Needle\" Ability { id: \"166C\", source: \"Brute Justice\" }\r\n997.5 \"Short Needle\" Ability { id: \"1669\", source: \"Brute Justice\" }\r\n998.2 \"Mega Beam\" Ability { id: \"1664\", source: \"Brute Justice\" }\r\n1003.4 \"Super Jump\" Ability { id: \"1665\", source: \"Brute Justice\" }\r\n1006.5 \"--untargetable--\"\r\n1009.7 \"J Kick\" Ability { id: \"166D\", source: \"Brute Justice\" }\r\n# FIXME: some pause here, before looping back to targetable?\r\n1012.0 \"--targetable--\"\r\n\r\n\r\n### Phase 6: Second Intermission\r\n1200.0 \"--untargetable--\"\r\n1203.2 \"J Kick\" Ability { id: \"166D\", source: \"Brute Justice\" }\r\n1211.5 \"Attachment\" Ability { id: \"163C\", source: \"Brawler\" } window 291.5,5\r\n1211.5 \"--sync--\" Ability { id: \"1636\", source: \"Brute Justice\" }\r\n1212.6 \"100-Megatonze Shock\" Ability { id: \"1635\", source: \"Onslaughter\" }\r\n# First Intermission can be skipped, but this is the first different ability.\r\n1217.5 \"Hidden Minefield\" Ability { id: \"165E\", source: \"Hidden Mine\" } duration 9 window 1220,5\r\n1217.6 \"Double Drill Crush\" Ability { id: \"1640\", source: \"Brawler\" }\r\n1218.6 \"Drill Drive\" Ability { id: \"1641\", source: \"Brawler\" }\r\n1222.1 \"Mega Beam\" Ability { id: \"162E\", source: \"Onslaughter\" }\r\n1223.7 \"Attachment\" Ability { id: \"163C\", source: \"Brawler\" }\r\n1228.5 \"Mirage\" Ability { id: \"1658\", source: \"Blaster Mirage\" }\r\n1229.8 \"Rocket Drill\" Ability { id: \"163F\", source: \"Brawler\" }\r\n1232.6 \"Mega Beam\" Ability { id: \"162E\", source: \"Onslaughter\" }\r\n1232.6 \"Eye Of The Chakram\" Ability { id: \"1654\", source: \"Steam Chakram\" }\r\n1233.6 \"Power Tackle\" #Ability { id: \"165B\", source: \"Blaster Mirage\" }\r\n1233.6 \"Blinder\" #Ability { id: \"165A\", source: \"Blaster Mirage\" }\r\n1241.4 \"Enumeration\" Ability { id: \"1649\", source: \"Swindler\" }\r\n1241.4 \"Ultra Flash\" Ability { id: \"1656\", source: \"Vortexer\" }\r\n\r\n\r\n### Phase 7: Gavel\r\n1252.1 \"--targetable--\" StartsUsing { id: \"166E\", source: \"Brute Justice\" } window 1255,100\r\n1257.1 \"Justice\" Ability { id: \"166E\", source: \"Brute Justice\" }\r\n1264.2 \"Verdict\" Ability { id: \"166F\", source: \"Brute Justice\" }\r\n1296.3 \"Gavel\" Ability { id: \"1670\", source: \"Brute Justice\" }\r\n1304.4 \"--untargetable--\"\r\n\r\n\r\n### Phase 8: Final Justice\r\n1307.6 \"J Kick\" Ability { id: \"166D\", source: \"Brute Justice\" }\r\n1310.6 \"--targetable--\"\r\n1313.7 \"Link-Up\" Ability { id: \"1673\", source: \"Brute Justice\" }\r\n1324.8 \"Final Punch\" Ability { id: \"170C\", source: \"Brute Justice\" }\r\n1326.0 \"Final Apocalypse\" Ability { id: \"1716\", source: \"Brute Justice\" }\r\n1332.1 \"Final Beam\" Ability { id: \"1725\", source: \"Brute Justice\" }\r\n1335.2 \"Missile Command\" Ability { id: \"1668\", source: \"Brute Justice\" }\r\n1339.2 \"Hidden Minefield\" Ability { id: \"165E\", source: \"Hidden Mine\" } duration 9\r\n1340.3 \"Flarethrower\" Ability { id: \"1662\", source: \"Brute Justice\" }\r\n1341.4 \"Long Needle\" Ability { id: \"166C\", source: \"Brute Justice\" }\r\n1353.6 \"Eye Of The Chakram\" Ability { id: \"1654\", source: \"Steam Chakram\" }\r\n1354.6 \"Enumeration\" Ability { id: \"1649\", source: \"Brute Justice\" }\r\n1360.0 \"Mega Beam\" Ability { id: \"1664\", source: \"Brute Justice\" }\r\n1365.1 \"Super Jump\" Ability { id: \"1665\", source: \"Brute Justice\" }\r\n1371.3 \"Flarethrower\" Ability { id: \"1662\", source: \"Brute Justice\" }\r\n1376.4 \"Missile Command\" Ability { id: \"1668\", source: \"Brute Justice\" }\r\n1383.5 \"Final Punch\" Ability { id: \"170C\", source: \"Brute Justice\" }\r\n1385.0 \"Final Apocalypse\" Ability { id: \"1716\", source: \"Brute Justice\" }\r\n1391.1 \"Final Beam\" Ability { id: \"1725\", source: \"Brute Justice\" }\r\n1398.2 \"--untargetable--\"\r\n\r\n\r\n### Phase 9: J-Storm\r\n1401.4 \"J Storm\" Ability { id: \"1674\", source: \"Brute Justice\" } window 1500,1000\r\n1403.4 \"--targetable--\"\r\n1407.5 \"J Wave\" Ability { id: \"1675\", source: \"Brute Justice\" } window 100,100\r\n1412.5 \"J Wave\" Ability { id: \"1675\", source: \"Brute Justice\" }\r\n1417.5 \"J Wave\" Ability { id: \"1675\", source: \"Brute Justice\" }\r\n1422.5 \"J Wave\" Ability { id: \"1675\", source: \"Brute Justice\" }\r\n1427.5 \"J Wave\" Ability { id: \"1675\", source: \"Brute Justice\" }\r\n1432.5 \"J Wave\" Ability { id: \"1675\", source: \"Brute Justice\" }\r\n1437.5 \"J Wave\" Ability { id: \"1675\", source: \"Brute Justice\" }\r\n1442.5 \"J Wave\" Ability { id: \"1675\", source: \"Brute Justice\" }\r\n1447.5 \"J Wave\" Ability { id: \"1675\", source: \"Brute Justice\" }\r\n1452.5 \"J Wave\" Ability { id: \"1675\", source: \"Brute Justice\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a9s.ts



const a9s_triggerSet = {
  id: 'AlexanderTheEyesOfTheCreatorSavage',
  zoneId: zone_id/* default.AlexanderTheEyesOfTheCreatorSavage */.Z.AlexanderTheEyesOfTheCreatorSavage,
  timelineFile: 'a9s.txt',
  initData: () => {
    return {
      stockpileCount: 0
    };
  },
  timelineTriggers: [{
    id: 'A9S Panzerschreck',
    regex: /Panzerschreck/,
    beforeSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'A9S Power Generator',
    regex: /Power Generator/,
    infoText: (data, _matches, output) => {
      const outputs = {
        1: output.oneEachNWSE(),
        2: output.twoNW(),
        // 3: faust,
        4: output.oneNW(),
        5: output.twoSE(),
        6: output.oneNW(),
        7: output.twoSE(),
        8: output.oneNW()
      };
      return outputs[data.stockpileCount];
    },
    outputStrings: {
      oneEachNWSE: {
        en: 'Place Generators NW/SE',
        de: 'Plaziere Generatoren NW/SO',
        fr: 'Placez les Générateurs NO/SE',
        ja: 'パワージェネレーターを北西/南東に運ぶ',
        cn: '搬运发电器到西北/东南',
        ko: '발전기 놓기: 북서/남동'
      },
      twoNW: {
        en: 'Place Generators NW',
        de: 'Plaziere Generatoren NW',
        fr: 'Placez les Générateurs NO',
        ja: 'パワージェネレーターを北西に運ぶ',
        cn: '搬运发电器到西北',
        ko: '발전기 놓기: 북서'
      },
      oneNW: {
        en: 'Place Generator NW',
        de: 'Plaziere Generator NW',
        fr: 'Placez les Générateurs NO',
        ja: 'パワージェネレーターを北西に運ぶ',
        cn: '搬运发电器到西北',
        ko: '발전기 놓기: 북서/남동'
      },
      twoSE: {
        en: 'Place Generators SE',
        de: 'Plaziere Generatoren SO',
        fr: 'Placez les Générateurs SE',
        ja: 'パワージェネレーターを南東に運ぶ',
        cn: '搬运发电器到东南',
        ko: '발전기 놓기: 남동'
      }
    }
  }, {
    id: 'A9S Alarum',
    regex: /Alarum/,
    delaySeconds: 1,
    infoText: (data, _matches, output) => {
      const outputs = {
        5: output.southeast(),
        6: output.southwest(),
        7: output.southeast(),
        8: output.southwest()
      };
      return outputs[data.stockpileCount];
    },
    outputStrings: {
      southeast: {
        // .. or anywhere not NW
        en: 'Kill Alarum SE',
        de: 'SO Alarm besiegen',
        fr: 'Tuez l\'Alarum SE',
        ja: '南東のアラームを倒す',
        cn: '在东南击杀警报',
        ko: '남동쪽 경보기 없애기'
      },
      southwest: {
        // ... or anywhere not NW/SE
        en: 'Kill Alarum SW',
        de: 'SW Alarm besiegen',
        fr: 'Tuez l\'Alarum SO',
        ja: '南西のアラームを倒す',
        cn: '在西南击杀警报',
        ko: '남서쪽 경보기 없애기'
      }
    }
  }, {
    id: 'A9S Bomb Explosion',
    regex: /Explosion/,
    beforeSeconds: 7,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bombs Soon',
        de: 'Bomben bald',
        fr: 'Bombes bientôt',
        ja: 'まもなく爆弾',
        cn: '炸弹马上爆炸',
        ko: '곧 폭탄 폭발'
      }
    }
  }],
  triggers: [{
    id: 'A9S Stockpile Count',
    type: 'StartsUsing',
    netRegex: {
      source: 'Refurbisher 0',
      id: '1A38',
      capture: false
    },
    run: data => data.stockpileCount++
  }, {
    id: 'A9S Scrapline',
    type: 'StartsUsing',
    netRegex: {
      source: 'Refurbisher 0',
      id: '1A3C',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.mainTank === data.me) return;
      return output.getBehind();
    },
    infoText: (data, _matches, output) => {
      if (data.mainTank !== data.me) return;
      return output.scraplineOnYou();
    },
    outputStrings: {
      scraplineOnYou: {
        en: 'Scrapline on YOU',
        de: 'Schrottlinie auf DIR',
        fr: 'Corde à ferraille sur VOUS',
        ja: '自分にスクラップラリアット',
        cn: '死刑',
        ko: '후려갈기기 대상자'
      },
      getBehind: {
        en: 'Get Behind',
        de: 'Hinter ihn',
        fr: 'Passez derrière',
        ja: '背面へ',
        cn: '去背后',
        ko: '보스 뒤로'
      }
    }
  }, {
    id: 'A9S Double Scrapline',
    type: 'StartsUsing',
    netRegex: {
      source: 'Refurbisher 0',
      id: '1A3D',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in Alarum Puddle',
        de: 'In Alarm Fläche stehen',
        fr: 'Placez-vous dans la zone de l\'Alarum',
        ja: '紫色の沼に入る',
        cn: '站进紫色圈圈',
        ko: '경보기 장판 밟기'
      }
    }
  }, {
    id: 'A9S Scrap Rock',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Rock on YOU',
        de: 'Stein auf DIR',
        fr: 'Rocher sur VOUS',
        ja: '自分に落石',
        cn: '落石点名',
        ko: '돌 징 대상자'
      }
    }
  }, {
    id: 'A9S Scrap Burst',
    type: 'HeadMarker',
    netRegex: {
      id: '0017',
      capture: false
    },
    delaySeconds: 5,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Fully Behind Rock',
        de: 'Komplett hinter dem Stein verstecken',
        fr: 'Cachez-vous derrière le rocher',
        ja: '壁の後ろに',
        cn: '躲在石头后',
        ko: '돌 뒤에 숨기'
      }
    }
  }, {
    id: 'A9S Scrap Bomb Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    // TODO: dubious to tell the person tanking to do it here.
    // But maybe fine to inform.
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'A9S Spread',
    type: 'HeadMarker',
    netRegex: {
      id: '000E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'A9S Auto',
    type: 'Ability',
    netRegex: {
      source: 'Refurbisher 0',
      id: '1AFE'
    },
    run: (data, matches) => data.mainTank = matches.target
  }, {
    id: 'A9S Power Generator Add Tether',
    type: 'Tether',
    netRegex: {
      id: '0011',
      capture: false
    },
    suppressSeconds: 30,
    infoText: (data, _matches, output) => {
      // Some of the last phases have multiple options.
      // This is an old fight, so just pick one for people.
      const outputs = {
        1: output.northeast(),
        2: output.southeast(),
        // 3: faust,
        4: output.southwest(),
        5: output.northwest(),
        6: output.southwest(),
        7: output.northwest(),
        8: output.southwest()
      };
      return outputs[data.stockpileCount];
    },
    outputStrings: {
      northeast: {
        en: 'Adds to NE Lava',
        de: 'Adds in NO Lava',
        fr: 'Adds dans la lave NE',
        ja: '北東でパワージェネレーターを倒す',
        cn: '拉小怪到东北击杀',
        ko: '쫄을 북동쪽 용암으로'
      },
      southeast: {
        en: 'Adds to SE Lava',
        de: 'Adds in SO Lava',
        fr: 'Adds dans la lave SE',
        ja: '南東でパワージェネレーターを倒す',
        cn: '拉小怪到东南击杀',
        ko: '쫄을 남동쪽 용암으로'
      },
      southwest: {
        en: 'Adds to SW Lava',
        de: 'Adds in SW Lava',
        fr: 'Adds dans la lave SO',
        ja: '南西でパワージェネレーターを倒す',
        cn: '拉小怪到西南击杀',
        ko: '쫄을 남서쪽 용암으로'
      },
      northwest: {
        en: 'Adds to NW Lava',
        de: 'Adds in NW Lava',
        fr: 'Adds dans la lave NO',
        ja: '北西でパワージェネレーターを倒す',
        cn: '拉小怪到西北击杀',
        ko: '쫄을 북서쪽 용암으로'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bomb': 'Bombe',
      'Faust Z': 'Endfaust',
      'Full-Metal Faust': 'Vollmetall-Faust',
      'Refurbisher 0': 'Rekompositor',
      'Scrap': 'Verschrotten',
      'The Cranial Plate': 'Schädeldecke',
      'Life Support': 'Wiederaufbereitungsanlage'
    },
    'replaceText': {
      '--rocks fall--': '--Felsen fallen--',
      'Acid Rain': 'Säureregen',
      'Alarum': 'Alarm',
      '(?<!Scrap )Bomb(?!e)': 'Bombe',
      'Explosion': 'Explosion',
      'Full-Metal Faust Add': 'Vollmetall-Faust Add',
      'Heat Shielding Reassembly': 'Hitzeschild-Regeneration',
      'Kaltstrahl': 'Kaltstrahl',
      'Lava': 'Lava',
      'Left Arm Reassembly': 'Linke Regeneration',
      'Panzer Vor': 'Panzer vor',
      'Panzerschreck': 'Panzerschreck',
      'Power Generator': 'Generator',
      'Right Arm Reassembly': 'Rechte Regeneration',
      'Scrap Bomb': 'Schrottbombe',
      'Scrap Burst': 'Schrottknall',
      'Scrap Storm': 'Schrottsprengung',
      'Scrap(?! )': 'Verschrotten',
      'Stockpile': 'Absorption'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bomb': 'Bombe',
      'Faust Z': 'Endfaust',
      'Full-Metal Faust': 'Eisernfaust',
      'Life Support': 'la chambre de recyclage CR',
      'Refurbisher 0': 'Récupérateur',
      'Scrap': 'Ferraille',
      'The Cranial Plate': 'pont nasal'
    },
    'replaceText': {
      '\\(NE/SW\\)': '(NE/SO)',
      '\\(NW\\)': '(NO)',
      '\\(NW/SE\\)': '(NO/SE)',
      '\\(SW\\)': '(SO)',
      '(?<!Double )Scrapline': 'Corde à ferraille',
      '(?<!Scrap )Bomb(?!e)': 'Bombe',
      '--rocks fall--': '--chute des rochers--',
      'Acid Rain': 'Pluie acide',
      'Alarum': 'Alarum',
      'Double Scrapline': 'Double corde à ferraille',
      'Explosion': 'Explosion',
      'Full-Metal Faust Add': 'Add Eisernfaust',
      'Heat Shielding Reassembly': 'Régénération du bouclier thermique',
      'Kaltstrahl': 'Kaltstrahl',
      'Lava': 'Lave',
      'Left Arm Reassembly': 'Régénération du bras gauche',
      'Panzer Vor': 'Panzer Vor',
      'Panzerschreck': 'Panzerschreck',
      'Power Generator': 'Générateur d\'énergie',
      'Right Arm Reassembly': 'Régénération du bras droit',
      'Scrap Bomb': 'Bombe de ferraille',
      'Scrap Burst': 'Déflagration de ferraille',
      'Scrap Storm': 'Tempête de ferraille',
      'Scrap(?! |line)': 'Ferraille',
      'Stockpile': 'Agglomération'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bomb': '爆弾',
      'Faust Z': 'ファイナル・ファウスト',
      'Full-Metal Faust': 'フルアーマー・ファウスト',
      'Refurbisher 0': 'リファビッシャー',
      'Scrap': 'スクラップパンチ',
      'The Cranial Plate': '頭部甲板',
      'Life Support': '再生処理室'
    },
    'replaceText': {
      '--rocks fall--': '--落石--',
      'Acid Rain': '酸性雨',
      'Alarum': 'アラーム',
      '(?<!Scrap )Bomb': '爆弾',
      'Double Scrapline': 'ダブルラリアット',
      'Explosion': '爆発',
      'Full-Metal Faust Add': '雑魚: フルアーマー・ファウスト',
      'Heat Shielding Reassembly': '装甲再生',
      'Kaltstrahl': 'カルトシュトラール',
      'Lava': 'ラーヴァ',
      'Left Arm Reassembly': '左腕再生',
      'Panzer Vor': 'パンツァーフォー',
      'Panzerschreck': 'パンツァーシュレッケ',
      'Power Generator': 'パワージェネレーター',
      'Right Arm Reassembly': '右腕再生',
      'Scrap Bomb': 'スクラップボム',
      'Scrap Burst': 'スクラップバースト',
      'Scrap Storm': 'スクラップストーム',
      'Scrap(?! |line)': 'スクラップパンチ',
      '(?<! )Scrapline': 'スクラップラリアット',
      'Stockpile': '吸収'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bomb': '炸弹',
      'Faust Z': '终极浮士德',
      'Full-Metal Faust': '全装甲浮士德',
      'Life Support': '再生处理室',
      'Refurbisher 0': '废品翻新装置',
      'Scrap': '废料拳',
      'The Cranial Plate': '头部甲板'
    },
    'replaceText': {
      '(?<!Double )Scrapline': '废料碎颈臂',
      '--rocks fall--': '--石头落下--',
      'Acid Rain': '酸雨',
      'Alarum': '警报',
      '(?<!Scrap )Bomb': '炸弹',
      'Double Scrapline': '二重碎颈臂',
      'Explosion': '爆炸',
      'Full-Metal Faust Add': '全装甲浮士德出现',
      'Heat Shielding Reassembly': '装甲再生',
      'Kaltstrahl': '寒光',
      'Lava': '岩浆',
      'Left Arm Reassembly': '左臂再生',
      'Panzer Vor': '战车前进',
      'Panzerschreck': '反坦克火箭筒',
      'Power Generator': '动力发生器',
      'Right Arm Reassembly': '右臂再生',
      'Scrap Bomb': '废料炸弹',
      'Scrap Burst': '废料爆发',
      'Scrap Storm': '废料风暴',
      'Scrap(?! |line)': '废料拳',
      'Stockpile': '吸收'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bomb': '폭탄',
      'Faust Z': '최종형 파우스트',
      'Full-Metal Faust': '완전무장 파우스트',
      'Life Support': '재생처리실',
      'Refurbisher 0': '재생자',
      'Scrap': '고물',
      'The Cranial Plate': '머리 갑판'
    },
    'replaceText': {
      '(?<!Double )Scrapline': '한팔 후려갈기기',
      '--rocks fall--': '--바위 낙하--',
      'Acid Rain': '산성비',
      'Alarum': '경보기',
      '(?<!Scrap )Bomb': '폭탄',
      'Double Scrapline': '양팔 후려갈기기',
      'Explosion': '폭발',
      'Full-Metal Faust Add': '파우스트 등장',
      'Heat Shielding Reassembly': '장갑 재생',
      'Kaltstrahl': '냉병기 공격',
      'Lava': '용암',
      'Left Arm Reassembly': '왼팔 재생',
      'Panzer Vor': '기갑 전진',
      'Panzerschreck': '대전차포',
      'Power Generator': '발전기',
      'Right Arm Reassembly': '오른팔 재생',
      'Scrap Bomb': '고철 폭탄',
      'Scrap Burst': '고철 폭발',
      'Scrap Storm': '고철 폭풍',
      'Scrap(?! |line)': '고철 주먹',
      'Stockpile': '흡수'
    }
  }]
};
/* harmony default export */ const a9s = (a9s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/raid/a9s.txt
const raid_a9s_namespaceObject = "### A9S\r\n# Alexander - The Eyes of the Creator (Savage)\r\n# https://dtguilds.enjin.com/a9sguide\r\n\r\nhideall \"--rocks fall--\"\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Faust Z\r\n# -p 1A2B:1006.5\r\n# The Cranial Plate will be sealed off\r\n1000.0\t\"--sync--\"\tSystemLogMessage { id: \"7DC\", param1: \"72F\" } window 10000\r\n1006.5 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" } window 1007,2.5\r\n1013.6 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" }\r\n1020.7 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" }\r\n1027.8 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" }\r\n1030.9 \"Panzerschreck\" Ability { id: \"1A2C\", source: \"Faust Z\" }\r\n1038.0 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" }\r\n1045.1 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" }\r\n1052.2 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" }\r\n1055.3 \"Panzerschreck x2\" duration 2.1 #Ability { id: \"1A2C\", source: \"Faust Z\" }\r\n1059.5 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" }\r\n1066.6 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" }\r\n1073.7 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" }\r\n1080.8 \"Panzerschreck x2\" duration 2.1 #Ability { id: \"1A2C\", source: \"Faust Z\" }\r\n1085.0 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" }\r\n1092.2 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" }\r\n1099.3 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" }\r\n1106.4 \"Panzerschreck x2\" duration 2.1 #Ability { id: \"1A2C\", source: \"Faust Z\" }\r\n1110.6 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" }\r\n1117.7 \"Kaltstrahl\" Ability { id: \"1A2B\", source: \"Faust Z\" }\r\n1126.1 \"Panzerschreck Enrage\" Ability { id: \"1A2D\", source: \"Faust Z\" } window 1200,100\r\n1136.3 \"Panzerschreck Enrage\" #Ability { id: \"1A2D\", source: \"Faust Z\" }\r\n1146.5 \"Panzerschreck Enrage\" #Ability { id: \"1A2D\", source: \"Faust Z\" }\r\n1156.7 \"Panzerschreck Enrage\" #Ability { id: \"1A2D\", source: \"Faust Z\" }\r\n1166.9 \"Panzerschreck Enrage\" #Ability { id: \"1A2D\", source: \"Faust Z\" }\r\n\r\n\r\n### Refurbisher Zero\r\n# -p 1A38:2010 -ii 1AFE 1AB5 1AB6 1AB7 1A36 FD7 1A3F\r\n\r\n# Note: this timeline assumes perfect feeding of adds.\r\n# It's possible to reassemble things earlier than here.\r\n# Any reassembly after stockpile delays the scrapline that follows.\r\n# If you've hit enrage, then any Scrap Storm further delays it,\r\n# hence large windows and multiple syncs on all the scraplines.\r\n# Power Generator \"added combatants\" are when they drop, so no syncs.\r\n# Lava doesn't show up in the log either.\r\n\r\n# Phase 1\r\n# Life Support will be sealed off\r\n2000.0\t\"--sync--\"\tSystemLogMessage { id: \"7DC\", param1: \"730\" } window 10000\r\n2010.0 \"Stockpile\" Ability { id: \"1A38\", source: \"Refurbisher 0\" } window 2010,5\r\n2012.1 \"Right Arm Reassembly\" Ability { id: \"1A2E\", source: \"Refurbisher 0\" }\r\n2014.3 \"Power Generator x2 (NE)\"\r\n2014.3 \"Lava (NE)\" duration 42\r\n2023.4 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2034.4 \"--rocks fall--\" #AddedCombatant { name: \"Scrap\" }\r\n2039.6 \"Scrap Burst\" Ability { id: \"1A3A\", source: \"Refurbisher 0\" }\r\n2048.8 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2055.9 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n\r\n# Phase 2\r\n2066.0 \"Stockpile\" Ability { id: \"1A38\", source: \"Refurbisher 0\" }\r\n2074.2 \"Scrapline\" Ability { id: \"1A3[CD]\", source: \"Refurbisher 0\" } window 30,30\r\n2078.2 \"Power Generator x2 (SE)\"\r\n2078.2 \"Lava (SE)\" duration 42\r\n2087.5 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2099.7 \"Acid Rain\" #Ability { id: \"1C0A\", source: \"Refurbisher 0\" }\r\n2099.7 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2106.8 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2121.0 \"Scrap Bomb\" Ability { id: \"1A3E\", source: \"Refurbisher 0\" }\r\n\r\n# Phase 3\r\n2133.2 \"Stockpile\" Ability { id: \"1A38\", source: \"Refurbisher 0\" }\r\n2141.4 \"Scrapline\" Ability { id: \"1A3[CD]\", source: \"Refurbisher 0\" } window 30,30\r\n2145.4 \"Lava (NW)\" duration 15\r\n2146.6 \"Full-Metal Faust Add\"\r\n2152.7 \"Panzer Vor\" Ability { id: \"1C05\", source: \"Full-Metal Faust\" }\r\n2152.7 \"--targetable--\"\r\n2160.7 \"Lava (NE)\" duration 15\r\n2164.9 \"Scrapline\" Ability { id: \"1A3C\", source: \"Refurbisher 0\" }\r\n2173.9 \"Lava (SW)\" duration 15\r\n2180.2 \"Acid Rain\" #Ability { id: \"1C0A\", source: \"Refurbisher 0\" }\r\n2189.3 \"Lava (SE)\" duration 15\r\n2195.1 \"--rocks fall--\" #AddedCombatant { name: \"Scrap\" }\r\n2200.3 \"Scrap Burst\" Ability { id: \"1A3A\", source: \"Refurbisher 0\" }\r\n\r\n# Phase 4\r\n2215.5 \"Stockpile\" Ability { id: \"1A38\", source: \"Refurbisher 0\" }\r\n2226.5 \"Power Generator x1 (SW)\"\r\n2226.5 \"Alarum x1 (SW)\"\r\n2226.5 \"Lava (SW)\" duration 42\r\n2238.7 \"--rocks fall--\" #AddedCombatant { name: \"Scrap\" }\r\n2243.9 \"Scrap Burst\" Ability { id: \"1A3A\", source: \"Refurbisher 0\" }\r\n2253.1 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2260.2 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2269.4 \"Scrap Bomb\" Ability { id: \"1A3E\", source: \"Refurbisher 0\" }\r\n\r\n# Phase 5\r\n2281.6 \"Stockpile\" Ability { id: \"1A38\", source: \"Refurbisher 0\" }\r\n2283.7 \"Left Arm Reassembly\" Ability { id: \"1A2F\", source: \"Refurbisher 0\" }\r\n2294.9 \"Double Scrapline\" Ability { id: \"1A3[CD]\", source: \"Refurbisher 0\" } window 40,40\r\n2298.9 \"Power Generator x2 (NW)\"\r\n2298.9 \"Alarum x1 (NW)\"\r\n2298.9 \"Bomb x2 (NE)\"\r\n2298.9 \"Lava (NW)\" duration 42\r\n2306.2 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2313.3 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2320.5 \"Acid Rain\" #Ability { id: \"1C0A\", source: \"Refurbisher 0\" }\r\n2325.5 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2332.6 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2337.1 \"Explosion (NE)\" Ability { id: \"1A35\", source: \"Bomb\" }\r\n2339.7 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2344.7 \"Acid Rain\" #Ability { id: \"1C0A\", source: \"Refurbisher 0\" }\r\n\r\n# Phase 6\r\n2350.8 \"Stockpile\" Ability { id: \"1A38\", source: \"Refurbisher 0\" }\r\n2361.0 \"Double Scrapline\" Ability { id: \"1A3[CD]\", source: \"Refurbisher 0\" } window 40,40\r\n2365.0 \"Power Generator x1 (SW)\"\r\n2365.0 \"Alarum x1 (SW)\"\r\n2365.0 \"Bomb x2 (NW/SE)\"\r\n2365.0 \"Lava (NE/SW)\" duration 42\r\n2376.4 \"Scrap Bomb\" Ability { id: \"1A3E\", source: \"Refurbisher 0\" }\r\n2384.6 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2398.5 \"--rocks fall--\" #AddedCombatant { name: \"Scrap\" }\r\n2403.3 \"Explosion (NW/SE)\" Ability { id: \"1A35\", source: \"Bomb\" }\r\n2403.7 \"Scrap Burst\" Ability { id: \"1A3A\", source: \"Refurbisher 0\" }\r\n\r\n# Phase 7\r\n2418.9 \"Stockpile\" Ability { id: \"1A38\", source: \"Refurbisher 0\" }\r\n2429.1 \"Double Scrapline\" Ability { id: \"1A3[CD]\", source: \"Refurbisher 0\" } window 40,40\r\n2433.1 \"Power Generator x2 (NW)\"\r\n2433.1 \"Alarum (NW)\"\r\n2433.1 \"Bomb x2 (NE)\"\r\n2433.1 \"Lava (NW)\" duration 42\r\n2440.4 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2447.5 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2454.7 \"Acid Rain\" #Ability { id: \"1C0A\", source: \"Refurbisher 0\" }\r\n2459.7 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2466.9 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2471.4 \"Explosion (NE)\" Ability { id: \"1A35\", source: \"Bomb\" }\r\n2474.1 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2479.1 \"Acid Rain\" #Ability { id: \"1C0A\", source: \"Refurbisher 0\" }\r\n\r\n# Phase 8\r\n# TODO: double check this phase timings against a clean pull\r\n2485.2 \"Stockpile\" Ability { id: \"1A38\", source: \"Refurbisher 0\" }\r\n2495.4 \"Double Scrapline\" Ability { id: \"1A3[CD]\", source: \"Refurbisher 0\" } window 40,40\r\n2499.4 \"Power Generator x1 (SW)\"\r\n2499.4 \"Alarum x1 (SW)\"\r\n2499.4 \"Bomb x2 (NW/SE)\"\r\n2499.4 \"Lava (NE/SW)\" duration 42\r\n2510.8 \"Scrap Bomb\" Ability { id: \"1A3E\", source: \"Refurbisher 0\" }\r\n2524.9 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2537.7 \"Explosion (NW/SE)\" Ability { id: \"1A35\", source: \"Bomb\" }\r\n2546.1 \"Scrap Storm\" Ability { id: \"1A3B\", source: \"Refurbisher 0\" }\r\n\r\n### Enrage\r\n2554.3 \"Stockpile\" Ability { id: \"1A38\", source: \"Refurbisher 0\" }\r\n2556.5 \"Heat Shielding Reassembly\" Ability { id: \"1A30\", source: \"Refurbisher 0\" }\r\n2562.6 \"Scrap Storm Enrage\" Ability { id: \"1A3B\", source: \"Refurbisher 0\" }\r\n\r\n\r\n### Post-enrage timeline science\r\n2572.7 \"Double Scrapline\" Ability { id: \"1A3[CD]\", source: \"Refurbisher 0\" } window 40,40\r\n2576.7 \"Power Generator x1 (NW)\"\r\n2576.7 \"Alarum x1 (NW)\"\r\n2576.7 \"Bomb x2 (NE)\"\r\n2576.7 \"Lava (NW)\" duration 42\r\n2584.0 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2591.1 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2598.3 \"Acid Rain\" #Ability { id: \"1C0A\", source: \"Refurbisher 0\" }\r\n2603.3 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2610.5 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2615.0 \"Explosion (NE)\" Ability { id: \"1A35\", source: \"Bomb\" }\r\n2617.6 \"Scrap\" Ability { id: \"1A39\", source: \"Refurbisher 0\" }\r\n2622.6 \"Acid Rain\" #Ability { id: \"1C0A\", source: \"Refurbisher 0\" }\r\n\r\n2628.7 \"Stockpile\" Ability { id: \"1A38\", source: \"Refurbisher 0\" }\r\n2638.9 \"Double Scrapline\" Ability { id: \"1A3[CD]\", source: \"Refurbisher 0\" } window 40,40\r\n2642.9 \"Power Generator x1 (SW)\"\r\n2642.9 \"Alarum x1 (SW)\"\r\n2642.9 \"Bomb x2 (NW/SE)\"\r\n2642.9 \"Lava (NE/SW)\" duration 42\r\n2654.4 \"Scrap Bomb\" Ability { id: \"1A3E\", source: \"Refurbisher 0\" }\r\n\r\n# 11 minute less soft enrage, in case you weren't killed by previous enrage.\r\n2659.2 \"--sync--\" StartsUsing { id: \"1A3B\", source: \"Refurbisher 0\" } window 50,10000\r\n2659.5 \"Scrap Storm Enrage\" Ability { id: \"1A3B\", source: \"Refurbisher 0\" }\r\n2659.5 \"Scrap Storm Enrage\" #Ability { id: \"1A3B\", source: \"Refurbisher 0\" }\r\n2667.7 \"Scrap Storm Enrage\" #Ability { id: \"1A3B\", source: \"Refurbisher 0\" }\r\n2675.9 \"Scrap Storm Enrage\" #Ability { id: \"1A3B\", source: \"Refurbisher 0\" }\r\n2684.1 \"Scrap Storm Enrage\" #Ability { id: \"1A3B\", source: \"Refurbisher 0\" }\r\n2692.3 \"Scrap Storm Enrage\" #Ability { id: \"1A3B\", source: \"Refurbisher 0\" }\r\n# &c &c &c\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/trial/bismarck-ex.ts


const bismarck_ex_triggerSet = {
  id: 'TheLimitlessBlueExtreme',
  zoneId: zone_id/* default.TheLimitlessBlueExtreme */.Z.TheLimitlessBlueExtreme,
  triggers: [{
    id: 'Bismarck Sharp Gust',
    type: 'StartsUsing',
    netRegex: {
      id: 'FAF',
      source: 'Bismarck',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bismarck': 'Bismarck'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bismarck': 'Bismarck'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bismarck': 'ビスマルク'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bismarck': '俾斯麦'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bismarck': '비스마르크'
    }
  }]
};
/* harmony default export */ const bismarck_ex = (bismarck_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/trial/ravana-ex.ts

const ravana_ex_triggerSet = {
  id: 'ThokAstThokExtreme',
  zoneId: zone_id/* default.ThokAstThokExtreme */.Z.ThokAstThokExtreme,
  timelineFile: 'ravana-ex.txt',
  triggers: [],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Ravana': 'Ravana'
    },
    'replaceText': {
      '\\(1st Double Prey\\)': '(1. Doppel-Markierung)',
      '\\(2nd Double Prey\\)': '(2. Doppel-Markierung)',
      '\\(Circles\\)': '(Kreise)',
      '\\(Flames\\)': '(Flammen) ',
      'Atma-Linga': 'Atma-Linga',
      'Beetle Avatar': 'Käfer-Inkarnation',
      'Blades of Carnage and Liberation': 'Klingen des Gemetzels und der Befreiung',
      'Blinding Blade': 'Blendende Klinge',
      'Bloody Fuller': 'Blutrille',
      'Chandrahas': 'Chandrahas',
      'Clone Spawn': 'Klon erscheint #',
      'Clone Dash': 'Klon stürmt #',
      'Dragonfly Avatar': 'Libellen-Inkarnation',
      'Final Liberation': 'Endgültige Befreiung',
      'Inner AOE': 'AoE innen',
      'Laughing Rose': 'Lachende Rose',
      '(?<! )Liberation': 'Befreiung',
      'Outer AOE': 'AoE außen',
      'Pillars of Heaven': 'Säulen des Himmels',
      'Prelude to Liberation': 'Auftakt zur Befreiung',
      'Scorpion Avatar': 'Skorpion-Inkarnation',
      'Surpanakha': 'Surpanakha',
      'Swift Liberation': 'Schnelle Befreiung',
      'Tapasya': 'Tapasya',
      'The Rose Of Conquest': 'Rose der Eroberung',
      'The Rose Of Conviction': 'Rose der Überzeugung',
      'The Rose Of Hate': 'Rose des Hasses',
      'The Seeing': 'Sehende',
      'Warlord Flame': 'Kriegsherren-Flamme',
      'Warlord Shell': 'Kriegsherren-Hülle'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ravana': 'Ravana'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(1st Double Prey\\)': '(1er Double marquage)',
      '\\(2nd Double Prey\\)': '(2ème Double marquage)',
      '\\(Circles\\)': '(Cercles)',
      '\\(Flames\\)': '(Flammes) ',
      '\\(Inner AoE\\)': '(AoE intérieur)',
      '\\(Outer AoE\\)': '(AoE extérieur)',
      'Atma-Linga': 'Atma-Linga',
      'Beetle Avatar': 'Incarnation du scarabée',
      'Blades of Carnage and Liberation': 'Lames ardentes',
      'Blinding Blade': 'Lame aveuglante',
      'Bloody Fuller': 'Entaille sanglante',
      'Chandrahas': 'Chandrahas',
      'Clone Spawn': 'Apparition du clone',
      'Clone Dash': 'Charge du clone',
      'Dragonfly Avatar': 'Incarnation de la libellule',
      'Final Liberation': 'Libération rapide',
      'Laughing Rose': 'Rose rieuse',
      '(?<! )Liberation': 'Libération',
      'Pillars of Heaven': 'Piliers du ciel',
      'Prelude to Liberation': 'Prélude de la libération',
      'Scorpion Avatar': 'Incarnation du scorpion',
      'Surpanakha': 'Surpanakha',
      'Swift Liberation(?! Dash)': 'Libération rapide',
      'Swift Liberation Dash': 'Libération rapide + Charge',
      'Tapasya': 'Tapasya',
      'The Rose Of Conquest': 'Rose de la conquête',
      'The Rose Of Conviction': 'Rose de la conviction',
      'The Rose Of Hate': 'Rose de la célérité',
      'The Seeing': 'Élytre(s)',
      'Warlord Flame': 'Flamme du Maître des lames',
      'Warlord Shell': 'Bouclier du Maître des lames'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ravana': 'ラーヴァナ'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(1st Double Prey\\)': '(マーキング１)',
      '\\(2nd Double Prey\\)': '(マーキング２)',
      '\\(Circles\\)': '(輪)',
      '\\(Flames\\)': '(炎) ',
      '\\(Inner AoE\\)': '(AoE: 中)',
      '\\(Outer AoE\\)': '(AoE: 外)',
      'Atma-Linga': 'アートマリンガ',
      'Beetle Avatar': '甲殻の化身',
      'Blades of Carnage and Liberation': '焔剣',
      'Blinding Blade': '武神閃',
      'Bloody Fuller': '神通力',
      'Chandrahas': 'チャンドラハース',
      'Clone Spawn': '幻影出現',
      'Clone Dash': '幻影突進',
      'Dragonfly Avatar': '武辺の化身',
      'Final Liberation': '光焔【滅】',
      'Laughing Rose': '月気弾',
      '(?<! )Liberation': '光焔【破】',
      'Pillars of Heaven': '衝天撃',
      'Prelude to Liberation': '光焔【序】',
      'Scorpion Avatar': '光焔の化身',
      'Surpanakha': '徹甲散弾',
      'Swift Liberation(?! Dash)': '光焔【急】',
      'Swift Liberation Dash': '光焔【急】突進',
      'Tapasya': '鬼武神',
      'The Rose Of Conquest': '闘気爆砕',
      'The Rose Of Conviction': '闘気弾',
      'The Rose Of Hate': '闘気砲',
      'The Seeing': '左翼防御/右翼防御/两翼防御',
      'Warlord Flame': '武神焔',
      'Warlord Shell': '武神甲'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ravana': '罗波那'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(1st Double Prey\\)': '(第1次双红球点名)',
      '\\(2nd Double Prey\\)': '(第2次双红球点名)',
      '\\(Circles\\)': '(圆圈)',
      '\\(Flames\\)': '(十字火) ',
      '\\(Inner AoE\\)': '(中间AOE)',
      '\\(Outer AoE\\)': '(外圈AOE)',
      'Atma-Linga': '武神魂',
      'Beetle Avatar': '甲壳化身',
      'Blades of Carnage and Liberation': '焰剑',
      'Blinding Blade': '武神闪',
      'Bloody Fuller': '神通力',
      'Chandrahas': '明月之笑',
      'Clone Spawn': '分身出现',
      'Clone Dash': '分身冲锋',
      'Dragonfly Avatar': '武毅化身',
      'Final Liberation': '光焰【灭】',
      'Laughing Rose': '月气弹',
      '(?<! )Liberation': '光焰【破】',
      'Pillars of Heaven': '冲天击',
      'Prelude to Liberation': '光焰【序】',
      'Scorpion Avatar': '光焰化身',
      'Surpanakha': '穿甲散弹',
      'Swift Liberation(?! Dash)': '光焰【急】',
      'Swift Liberation Dash': '光焰【急】+冲锋',
      'Tapasya': '鬼武神',
      'The Rose Of Conquest': '斗气爆碎',
      'The Rose Of Conviction': '斗气弹',
      'The Rose Of Hate': '斗气炮',
      'The Seeing': '左翼防御/右翼防御/两翼防御',
      'Warlord Flame': '武神焰',
      'Warlord Shell': '武神甲'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ravana': '라바나'
    },
    'replaceText': {
      '\\(1st Double Prey\\)': '(첫번째 표식)',
      '\\(2nd Double Prey\\)': '(두번째 표식)',
      '\\(Circles\\)': '(원형)',
      '\\(Flames\\)': '(화염) ',
      '\\(Inner AoE\\)': '(내부 장판)',
      '\\(Outer AoE\\)': '(외부 장판)',
      'Atma-Linga': '불멸혼',
      'Beetle Avatar': '갑각의 화신',
      'Blades of Carnage and Liberation': '불꽃검',
      'Blinding Blade': '무신섬',
      'Bloody Fuller': '신통력',
      'Chandrahas': '찬드라하스',
      'Clone Spawn': '분신 소환',
      'Clone Dash': '분신 돌진',
      'Dragonfly Avatar': '무도의 화신',
      'Final Liberation': '광염: 파멸',
      'Laughing Rose': '월기탄',
      '(?<! )Liberation': '광염: 전개',
      'Pillars of Heaven': '충천격',
      'Prelude to Liberation': '광염: 발단',
      'Scorpion Avatar': '광염의 화신',
      'Surpanakha': '관통산탄',
      'Swift Liberation': '광염: 절정',
      'Tapasya': '귀무신',
      'The Rose Of Conquest': '투기탄쇄',
      'The Rose Of Conviction': '투기탄',
      'The Rose Of Hate': '투기포',
      'The Seeing': '좌익/우익/양익 방어',
      'Warlord Flame': '돌연변이',
      'Warlord Shell': '무신갑'
    }
  }]
};
/* harmony default export */ const ravana_ex = (ravana_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/trial/ravana-ex.txt
const trial_ravana_ex_namespaceObject = "# -ii EC1 EC2 EA5 EAA EBE 1299 13BC 13BF 140F\r\n# ic \"Spirit Gana\" \"Moon Gana\" \"Chandrahas\"\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# During all phases, any attacks will increase Ravana's Bloodlust meter.\r\n# The relationship between increases and damage done is not fully understood.\r\n# The meter also increases passively during all phases except the opening block.\r\n# Any displayed phase lengths are the maximum that could occur with no \"extra\" Bloodlust.\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.1 \"Blinding Blade\" Ability { id: \"E9F\", source: \"Ravana\" } window 7.1,10\r\n11.9 \"The Seeing\" Ability { id: \"EA[012]\", source: \"Ravana\" }\r\n16.0 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n22.2 \"Tapasya x3\" Ability { id: \"EA4\", source: \"Ravana\" } window 20,20\r\n29.4 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n32.5 \"Blinding Blade\" Ability { id: \"E9F\", source: \"Ravana\" }\r\n37.3 \"The Seeing\" Ability { id: \"EA[012]\", source: \"Ravana\" }\r\n42.5 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n\r\n51.7 \"Blinding Blade\" Ability { id: \"E9F\", source: \"Ravana\" }\r\n56.5 \"The Seeing\" Ability { id: \"EA[012]\", source: \"Ravana\" }\r\n60.6 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n66.8 \"Tapasya x3\" Ability { id: \"EA4\", source: \"Ravana\" } window 20,20\r\n74.0 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n77.1 \"Blinding Blade\" Ability { id: \"E9F\", source: \"Ravana\" }\r\n81.9 \"The Seeing\" Ability { id: \"EA[012]\", source: \"Ravana\" }\r\n87.1 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" } jump 42.5\r\n\r\n96.3 \"Blinding Blade\"\r\n101.1 \"The Seeing\"\r\n105.2 \"Atma-Linga\"\r\n111.4 \"Tapasya x3\"\r\n118.6 \"Atma-Linga\"\r\n121.7 \"Blinding Blade\"\r\n126.5 \"The Seeing\"\r\n\r\n# Block initiates at 100 bloodlust. Loosely linked to HP%, exact connection unknown.\r\n150.0 \"Scorpion Avatar\" Ability { id: \"E81\", source: \"Ravana\" } window 150,5\r\n155.2 \"Blades Of Carnage And Liberation\" Ability { id: \"137A\", source: \"Ravana\" }\r\n175.3 \"Prelude To Liberation\" Ability { id: \"EBC\", source: \"Ravana\" }\r\n175.3 \"--untargetable--\"\r\n182.4 \"Prelude To Liberation (Flames)\" Ability { id: \"EBD\", source: \"Ravana\" }\r\n183.4 \"--sync--\" Ability { id: \"13BC\", source: \"Ravana\" }\r\n189.6 \"Prelude To Liberation (Circles)\" Ability { id: \"EBF\", source: \"Ravana\" }\r\n194.8 \"--targetable--\"\r\n195.0 \"Blades Of Carnage And Liberation\" Ability { id: \"137A\", source: \"Ravana\" }\r\n215.6 \"Liberation\" Ability { id: \"EC0\", source: \"Ravana\" }\r\n215.6 \"--untargetable--\"\r\n219.8 \"Clone Spawn 1\" # Ability { id: \"EC1\", source: \"Ravana\" }\r\n220.8 \"Clone Spawn 2\" # Ability { id: \"EC1\", source: \"Ravana\" }\r\n221.8 \"Clone Spawn 3\" # Ability { id: \"EC1\", source: \"Ravana\" }\r\n222.8 \"Clone Spawn 4\" # Ability { id: \"EC1\", source: \"Ravana\" }\r\n226.9 \"Clone Dash 1\" # Ability { id: \"EC2\", source: \"Ravana\" }\r\n228.4 \"Clone Dash 2\" # Ability { id: \"EC2\", source: \"Ravana\" }\r\n229.9 \"Clone Dash 3\" # Ability { id: \"EC2\", source: \"Ravana\" }\r\n231.4 \"Clone Dash 4\" # Ability { id: \"EC2\", source: \"Ravana\" }\r\n235.6 \"--targetable--\"\r\n\r\n# Initiates immediately following Liberation block.\r\n235.7 \"Dragonfly Avatar\" Ability { id: \"E80\", source: \"Ravana\" }\r\n242.8 \"Warlord Shell\" Ability { id: \"EB1\", source: \"Ravana\" }\r\n247.6 \"The Seeing\" Ability { id: \"EA[012]\", source: \"Ravana\" }\r\n255.4 \"The Seeing\" Ability { id: \"EA[012]\", source: \"Ravana\" }\r\n264.6 \"Warlord Flame?\" Ability { id: \"EB2\", source: \"Ravana\" } # Skipped if Ravana's shield is burned.\r\n267.8 \"--sync--\" Ability { id: \"EB0\", source: \"Ravana\" }\r\n272.0 \"Tapasya x3\" Ability { id: \"EA4\", source: \"Ravana\" } window 30,5\r\n279.1 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n286.8 \"The Seeing\" Ability { id: \"EA[012]\", source: \"Ravana\" }\r\n290.9 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n296.2 \"Tapasya x3\" Ability { id: \"EA4\", source: \"Ravana\" }\r\n303.3 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n306.4 \"Blinding Blade\" Ability { id: \"E9F\", source: \"Ravana\" }\r\n309.5 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n312.7 \"Tapasya x3\" Ability { id: \"EA4\", source: \"Ravana\" }\r\n320.8 \"Blinding Blade\" Ability { id: \"E9F\", source: \"Ravana\" }\r\n325.5 \"The Seeing\" Ability { id: \"EA[012]\", source: \"Ravana\" }\r\n330.7 \"Atma-Linga x2\" # Ability { id: \"EA6\", source: \"Ravana\" }\r\n\r\n# The intermission can have 0-10 Laughing Moon charges before Ravana uses the Chandrahas ultimate.\r\n# The number is dependent on how many Gana are able to finish their Falling Laughter casts.\r\n# More than 1-2 is typically a wipe, as each inflicts a Vulnerability Up stack to the party.\r\n336.8 \"Bloody Fuller\" StartsUsing { id: \"EB3\", source: \"Ravana\" } duration 4.7 window 336.8,5\r\n341.1 \"--untargetable--\"\r\n\r\n400.0 \"Chandrahas\" Ability { id: \"EB5\", source: \"Ravana\" } window 400,5\r\n413.9 \"Beetle Avatar\" Ability { id: \"E82\", source: \"Ravana\" } window 15,15\r\n414.0 \"--targetable--\" # Technically slightly before, but invulnerability drops here.\r\n422.0 \"Pillars Of Heaven\" Ability { id: \"EB8\", source: \"Ravana\" }\r\n429.1 \"--sync--\" Ability { id: \"EB9\", source: \"Ravana\" }\r\n429.8 \"Laughing Rose\" # The EB9 skill resolves well before the damage displays\r\n445.4 \"Surpanakha x4\" # Ability { id: \"EBA\", source: \"Ravana\" }\r\n453.1 \"The Rose Of Conviction\" Ability { id: \"EB6\", source: \"Ravana\" }\r\n460.2 \"The Rose Of Hate\" Ability { id: \"EBB\", source: \"Ravana\" }\r\n465.4 \"Surpanakha x7\" # Ability { id: \"EBA\", source: \"Ravana\" }\r\n466.3 \"The Rose Of Conquest\" Ability { id: \"EB7\", source: \"Ravana's Will\" }\r\n485.8 \"Pillars Of Heaven\" Ability { id: \"EB8\", source: \"Ravana\" }\r\n493.0 \"--sync--\" Ability { id: \"EB9\", source: \"Ravana\" }\r\n493.7 \"Laughing Rose\"\r\n506.2 \"Surpanakha x7?\" # Ability { id: \"EBA\", source: \"Ravana\" }\r\n# This phase ends at 100 Bloodlust.\r\n\r\n514.0 \"Scorpion Avatar\" Ability { id: \"E81\", source: \"Ravana\" } window 114,5\r\n514.1 \"--sync--\" Ability { id: \"13BF\", source: \"Ravana\" }\r\n519.2 \"Blades Of Carnage And Liberation\" Ability { id: \"137A\", source: \"Ravana\" }\r\n540.4 \"Swift Liberation\" Ability { id: \"EA7\", source: \"Ravana\" }\r\n540.4 \"--untargetable--\"\r\n540.5 \"Swift Liberation Dash 1\" # Ability { id: \"EA8\", source: \"Ravana\" }\r\n543.5 \"Swift Liberation Dash 2\" # Ability { id: \"EA8\", source: \"Ravana\" }\r\n546.5 \"Swift Liberation Dash 3\" # Ability { id: \"EA8\", source: \"Ravana\" }\r\n549.5 \"Swift Liberation Dash 4\" # Ability { id: \"EA8\", source: \"Ravana\" }\r\n552.7 \"Swift Liberation (Flames)\" # Ability { id: \"EA9\", source: \"Ravana\" }\r\n556.9 \"Swift Liberation (Circles)\" # Ability { id: \"EAB\", source: \"Ravana\" }\r\n562.1 \"--targetable--\"\r\n562.3 \"Blades Of Carnage And Liberation\" Ability { id: \"137A\", source: \"Ravana\" } window 20,20\r\n583.5 \"Final Liberation\" Ability { id: \"EAC\", source: \"Ravana\" }\r\n583.5 \"--untargetable--\"\r\n583.6 \"Final Liberation (1st Double Prey)\" Ability { id: \"EAD\", source: \"Ravana\" }\r\n591.6 \"Final Liberation (2nd Double Prey)\" Ability { id: \"EAD\", source: \"Ravana\" }\r\n597.7 \"--sync--\" Ability { id: \"13C4\", source: \"Ravana\" }\r\n597.7 \"Final Liberation (Outer AoE)\" Ability { id: \"EAE\", source: \"Ravana\" }\r\n598.9 \"--targetable--\"\r\n603.9 \"Final Liberation (Inner AoE)\" Ability { id: \"EAF\", source: \"Ravana\" }\r\n603.9 \"--untargetable--\"\r\n610.1 \"--targetable--\"\r\n\r\n610.2 \"Dragonfly Avatar\" Ability { id: \"E80\", source: \"Ravana\" } window 96,20\r\n610.3 \"--sync--\" Ability { id: \"1299\", source: \"Ravana\" }\r\n617.3 \"Warlord Shell\" Ability { id: \"EB1\", source: \"Ravana\" }\r\n622.5 \"The Seeing\" Ability { id: \"EA[012]\", source: \"Ravana\" }\r\n626.7 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n631.0 \"The Seeing\" Ability { id: \"EA[012]\", source: \"Ravana\" }\r\n\r\n# If Blessing of Earth is not damaged off Ravana, he uses Warlord Flame at 640.2.\r\n# If it is, Flame is skipped and things go directly to Blinding Blade.\r\n# We assume the skip, and re-sync if it doesn't happen.\r\n636.4 \"--sync--\" Ability { id: \"EB2\", source: \"Ravana\" } window 15,15\r\n640.2 \"Blinding Blade/Warlord Flame?\" Ability { id: \"E9F\", source: \"Ravana\" } window 30,2.5\r\n643.3 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n646.1 \"Tapasya x3\" Ability { id: \"EA4\", source: \"Ravana\" }\r\n652.2 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n655.3 \"Blinding Blade\" Ability { id: \"E9F\", source: \"Ravana\" }\r\n658.4 \"Atma-Linga x2\" # Ability { id: \"EA6\", source: \"Ravana\" }\r\n663.1 \"Tapasya x3\" Ability { id: \"EA4\", source: \"Ravana\" }\r\n669.2 \"Blinding Blade\" Ability { id: \"E9F\", source: \"Ravana\" }\r\n672.3 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n\r\n679.5 \"Blinding Blade\" Ability { id: \"E9F\", source: \"Ravana\" }\r\n682.6 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n685.0 \"Tapasya x3\" Ability { id: \"EA4\", source: \"Ravana\" }\r\n691.2 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n694.3 \"Blinding Blade\" Ability { id: \"E9F\", source: \"Ravana\" }\r\n697.4 \"Atma-Linga x2\" # Ability { id: \"EA6\", source: \"Ravana\" }\r\n701.7 \"Tapasya x3\" Ability { id: \"EA4\", source: \"Ravana\" }\r\n708.1 \"Blinding Blade\" Ability { id: \"E9F\", source: \"Ravana\" }\r\n711.2 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n718.3 \"Blinding Blade\" Ability { id: \"E9F\", source: \"Ravana\" }\r\n\r\n721.4 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n723.9 \"Tapasya x3\" Ability { id: \"EA4\", source: \"Ravana\" }\r\n730.0 \"Atma-Linga\" Ability { id: \"EA6\", source: \"Ravana\" }\r\n\r\n736.5 \"Beetle Avatar\" Ability { id: \"E82\", source: \"Ravana\" } window 130,10 jump 413.9\r\n744.6 \"Pillars Of Heaven\"\r\n751.7 \"Laughing Rose\"\r\n768.0 \"Surpanakha x4\"\r\n\r\n# Enrage follows this sequence, but unfortunately there's no way to sync to it.\r\n# 1781.6 \"Dragonfly Avatar\" Ability { id: \"E80\", source: \"Ravana\" }\r\n# 1781.7 \"--sync--\" Ability { id: \"1299\", source: \"Ravana\" }\r\n# 1786.7 \"--untargetable--\"\r\n# 1791.8 \"Bloody Fuller\" Ability { id: \"EB3\", source: \"Ravana\" }\r\n# Laughing Moon until wipe\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/trial/sephirot-ex.ts




const sephirot_ex_triggerSet = {
  id: 'ContainmentBayS1T7Extreme',
  zoneId: zone_id/* default.ContainmentBayS1T7Extreme */.Z.ContainmentBayS1T7Extreme,
  timelineFile: 'sephirot-ex.txt',
  initData: () => {
    return {
      phase: 1,
      pillarActive: false
    };
  },
  timelineTriggers: [{
    id: 'SephirotEx Tiferet',
    regex: /Tiferet/,
    beforeSeconds: 4,
    suppressSeconds: 5,
    // Timeline syncs can otherwise make this extra-noisy
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'SephirotEx Triple Trial',
    regex: /Triple Trial/,
    beforeSeconds: 4,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'SephirotEx Ein Sof Rage',
    regex: /Ein Sof \(4 puddles\)/,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move to safe quadrant',
        de: 'Beweg dich in den sicheren Quadranten',
        fr: 'Allez dans le quart sur',
        cn: '移动到安全区域',
        ko: '안전한 지역으로 이동'
      }
    }
  }, {
    id: 'SephirotEx Ein Sof Ratzon',
    regex: /Ein Sof \(1 puddle\)/,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait toward puddle',
        de: 'In Richtung Fläche ködern',
        fr: 'Bait vers le puddle',
        cn: '靠近圈圈集合诱导AOE',
        ko: '장판 쪽으로 아인 유도'
      }
    }
  }, {
    id: 'SephirotEx Yesod Bait',
    regex: /Yesod/,
    beforeSeconds: 6,
    alertText: (data, _matches, output) => {
      if (data.pillarActive) return output.withPillar();
      return output.noPillar();
    },
    outputStrings: {
      noPillar: {
        en: 'Bait Yesod',
        de: 'Yesod ködern',
        fr: 'Attirez Yesod',
        cn: '集合诱导基盘碎击',
        ko: '예소드 붕괴 유도'
      },
      withPillar: {
        en: 'Bait Yesod inside puddle',
        de: 'Yesod in die Fläche ködern',
        fr: 'Attirez Yesod dans le puddle',
        cn: '圈圈内集合诱导基盘碎击',
        ko: '장판 안에 예소드 유도하기'
      }
    }
  }, {
    id: 'SephirotEx Pillar Activate',
    regex: /Pillar of Mercy 1/,
    beforeSeconds: 10,
    run: data => data.pillarActive = true
  }, {
    id: 'SephirotEx Pillar Deactivate',
    regex: /Pillar of Mercy 3/,
    run: data => data.pillarActive = false
  }],
  triggers: [{
    id: 'SephirotEx Main Tank',
    type: 'Ability',
    netRegex: {
      id: '368',
      source: 'Sephirot'
    },
    // We make this conditional to avoid constant noise in the raid emulator.
    condition: (data, matches) => data.mainTank !== matches.target,
    run: (data, matches) => data.mainTank = matches.target
  }, {
    id: 'SephirotEx Chesed Buster',
    type: 'StartsUsing',
    netRegex: {
      id: '1567',
      source: 'Sephirot'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'SephirotEx Ain',
    type: 'StartsUsing',
    netRegex: {
      id: '1569',
      source: 'Sephirot',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'SephirotEx Ratzon Spread',
    type: 'HeadMarker',
    netRegex: {
      id: ['0046', '0047']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'SephirotEx Fiendish Rage',
    type: 'HeadMarker',
    netRegex: {
      id: '0048',
      capture: false
    },
    condition: data => data.phase === 1,
    suppressSeconds: 10,
    alertText: (data, _matches, output) => {
      if (data.me === data.mainTank) return output.noStack();
      return output.stack();
    },
    outputStrings: {
      noStack: {
        en: 'Don\'t Stack!',
        de: 'Nicht sammeln!',
        fr: 'Ne vous packez pas !',
        cn: '不要重合！',
        ko: '겹치면 안됨!'
      },
      stack: {
        en: 'Group Stacks',
        de: 'In der Gruppe sammeln',
        fr: 'Package en groupe',
        cn: '分组集合',
        ko: '그룹 쉐어'
      }
    }
  }, {
    id: 'SephirotEx Da\'at Spread',
    type: 'StartsUsing',
    netRegex: {
      id: '1572',
      source: 'Sephirot',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'SephirotEx Malkuth',
    type: 'StartsUsing',
    netRegex: {
      id: '1582',
      source: 'Sephirot',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'SephirotEx Yesod Move',
    type: 'StartsUsing',
    netRegex: {
      id: '157E',
      source: 'Sephirot',
      capture: false
    },
    suppressSeconds: 2,
    response: responses/* Responses.moveAway */.n3.moveAway('alarm') // This *will* kill if a non-tank takes 2+.
  }, {
    id: 'SephirotEx Force Against Might',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3ED'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, matches, output) => output.text({
      force: matches.effect
    }),
    run: (data, matches) => data.force = matches.effectId,
    outputStrings: {
      text: {
        en: 'Orange (${force})',
        de: 'Orange (${force})',
        fr: '${force} Orange',
        ja: '自分に${force}',
        // FIXME
        cn: '橙点名 ${force}',
        ko: '노랑 (${force})'
      }
    }
  }, {
    id: 'SephirotEx Force Against Magic',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3EE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, matches, output) => output.text({
      force: matches.effect
    }),
    run: (data, matches) => data.force = matches.effectId,
    outputStrings: {
      text: {
        en: 'Green (${force})',
        de: 'Grün (${force})',
        fr: '${force} Vert',
        ja: '自分に${force}',
        // FIXME
        cn: '绿点名 ${force}',
        ko: '초록 (${force})'
      }
    }
  }, {
    // Orange left, Green right. Match color to Force debuff.
    id: 'SephirotEx Gevurah Chesed',
    type: 'StartsUsing',
    netRegex: {
      id: '1578',
      capture: false
    },
    alertText: (data, _matches, output) => {
      // Here and for Chesed Gevurah, if the player doesn't have a color debuff,
      // they just take moderate AoE damage.
      // Unlike Flood of Naught (colors) in O4s,
      // standing center is safe if the user has no debuff.
      if (data.force !== undefined) return data.force === '3ED' ? output.left() : output.right();
      return output.aoe();
    },
    outputStrings: {
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      aoe: outputs/* default.aoe */.Z.aoe
    }
  }, {
    // Green left, Orange right. Match color to Force debuff.
    id: 'SephirotEx Chesed Gevurah',
    type: 'StartsUsing',
    netRegex: {
      id: '1579',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.force !== undefined) return data.force === '3EE' ? output.left() : output.right();
      return output.aoe();
    },
    outputStrings: {
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      aoe: outputs/* default.aoe */.Z.aoe
    }
  }, {
    id: 'SephirotEx Fiendish Wail',
    type: 'Ability',
    netRegex: {
      id: '1575',
      source: 'Sephirot',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.force === '3ED' || data.force === undefined && data.role === 'tank') return output.getTower();
      return output.avoidTower();
    },
    outputStrings: {
      getTower: {
        en: 'Get a tower',
        de: 'Nimm einen Turm',
        fr: 'Prenez une tour',
        cn: '踩塔',
        ko: '기둥 밟기'
      },
      avoidTower: {
        en: 'Avoid towers',
        de: 'Turm meiden',
        fr: 'Évitez les tours',
        cn: '躲塔',
        ko: '기둥 피하기'
      }
    }
  }, {
    id: 'SephirotEx Da\'at Tethers',
    type: 'Tether',
    netRegex: {
      id: '0030',
      capture: false
    },
    suppressSeconds: 30,
    // The tethers jump around a lot
    alertText: (data, _matches, output) => {
      if (data.force === '3EE') return output.magic();
      return output.might();
    },
    outputStrings: {
      might: {
        en: 'Get Away, Avoid Puddles + Tethers',
        de: 'Geh weg, weiche Flächen und Verbindungen aus',
        fr: 'Sortez, évitez les puddles et les liens',
        cn: '远离, 躲避圈圈 + 连线',
        ko: '멀리 떨어지고, 장판 + 선 피하기'
      },
      magic: {
        en: 'Go Front; Get Tether',
        de: 'Geh nach Vorne; Nimm eine Verbindung',
        fr: 'Allez devant, prenez les liens',
        cn: '去前面; 接线',
        ko: '앞으로 가서 선 가져가기'
      }
    }
  }, {
    id: 'SephirotEx Force Against Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: ['3ED', '3EE'],
      capture: false
    },
    run: data => delete data.force
  }, {
    id: 'SephirotEx Earth Shaker Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '0028'
    },
    run: (data, matches) => {
      data.shakerTargets = data.shakerTargets ??= [];
      data.shakerTargets.push(matches.target);
    }
  }, {
    id: 'SephirotEx Earth Shaker Call',
    type: 'HeadMarker',
    netRegex: {
      id: '0028',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      if (data.shakerTargets?.includes(data.me)) return output.shakerTarget();
      return output.shakerAvoid();
    },
    outputStrings: {
      shakerTarget: {
        en: 'Earth Shaker (Max Melee)',
        de: 'Erdstoß (Max Nahkampf)',
        fr: 'Secousse (Max CàC)',
        cn: '大地摇动 (最远近战距离)',
        ko: '어스징 (칼끝딜 거리)'
      },
      shakerAvoid: {
        en: 'Avoid Earth Shakers',
        de: 'Weiche Erdstoß aus',
        fr: 'Évitez les secousses',
        cn: '躲避大地摇动',
        ko: '어스징 피하기'
      }
    }
  }, {
    id: 'SephirotEx Earth Shaker Cleanup',
    type: 'HeadMarker',
    netRegex: {
      id: '0028',
      capture: false
    },
    delaySeconds: 5,
    run: data => delete data.shakerTargets
  }, {
    id: 'SephirotEx Storm of Words Revelation',
    type: 'StartsUsing',
    netRegex: {
      id: '1583',
      source: 'Storm of Words',
      capture: false
    },
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Storm of Words',
        de: 'Wörtersturm besiegen',
        fr: 'Tuez Tempête de mots ou mourrez',
        cn: '击杀言语风暴!',
        ko: '신언의 폭풍 제거'
      }
    }
  }, {
    id: 'SephirotEx Ascension',
    type: 'HeadMarker',
    netRegex: {
      id: '003E',
      capture: false
    },
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Coronal Wind': 'Koronalwind',
      'Sephirot': 'Sephirot',
      'Storm Of Words': 'Wörtersturm'
    },
    'replaceText': {
      'Tethers': 'Verbindungen',
      'spread': 'verteilen',
      'puddles': 'Flächen',
      'puddle(?!s)': 'Fläche',
      'Adds Spawn': 'Adds erscheinen',
      'Ascension': 'Himmelfahrt',
      'Chesed': 'Chesed',
      'Da\'at': 'Da\'at',
      'Earth Shaker': 'Erdstoß',
      'Ein Sof': 'En Sof',
      'Fiendish Rage': 'Dämonischer Zorn',
      'Fiendish Wail': 'Dämonische Klage',
      'Force Field': 'Kraftfeld',
      'Impact of Hod': 'Macht von Hod',
      'Life Force': 'Lebenskraft',
      'Malkuth': 'Malkuth',
      'Pillar of Mercy': 'Pfeiler der Gnade',
      'Pillar of Severity': 'Pfeiler der Strenge',
      'Ratzon': 'Ratzon',
      'Spirit': 'Geist',
      'Tiferet': 'Tiferet',
      'Triple Trial': 'Tripel-Triade',
      'Yesod': 'Yesod'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Coronal Wind': 'vent coronaire',
      'Sephirot': 'Sephirot',
      'Storm Of Words': 'tempête de mots'
    },
    'replaceText': {
      'Adds Spawn': 'Apparition d\'adds',
      'Ascension': 'Ascension',
      'Chesed': 'Chesed',
      'Chesed Gevurah': 'Chesed Gevurah',
      'Da\'at Tethers': 'Liens Da\'at',
      'Da\'at spread': 'Dispersion Da\'at',
      'Earth Shaker': 'Secousse',
      'Ein Sof': 'Ein Sof',
      'Fiendish Rage': 'Colère de Sephirot',
      'Fiendish Wail': 'Plainte de Sephirot',
      'Force Field': 'Champ de force',
      'Impact of Hod': 'Impact Hod',
      'Life Force': 'Force vitale',
      'Malkuth': 'Malkuth',
      'Pillar of Mercy': 'Pilier de la miséricorde',
      'Pillar of Severity': 'Pilier de la rigueur',
      'Ratzon': 'Ratzon',
      'Spirit': 'Esprit',
      'Tiferet': 'Tiferet',
      'Triple Trial': 'Triple coup',
      'Yesod': 'Yesod'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Coronal Wind': 'コロナルウィンド',
      'Sephirot': 'セフィロト',
      'Storm Of Words': 'ストーム・オブ・ワード'
    },
    'replaceText': {
      'Adds Spawn': '雑魚',
      'Ascension': 'アセンション',
      '(?! )Chesed(?! )': 'ケセド',
      'Chesed Gevurah': 'ケセド・ゲブラー',
      'Da\'at': 'ダアト',
      'Earth Shaker': 'アースシェイカー',
      'Ein Sof(?! )': 'アイン・ソフ',
      'Ein Sof Ohr': 'アイン・ソフ・オウル',
      'Fiendish Rage': '魔神の怒り',
      'Fiendish Wail': '魔神の嘆き',
      'Force Field': 'フォースフィールド',
      'Impact of Hod': 'ホドインパクト',
      'Life Force': 'ライフフォース',
      'Malkuth': 'マルクト',
      'Pillar of Mercy': 'ピラー・オブ・メルシー',
      'Pillar of Severity': 'ピラー・オブ・セベリティ',
      'Ratzon': 'ラツォン',
      '(?<= )spread': '散開',
      'Spirit': 'スピリット',
      '(?<= )Tethers': '線',
      'Tiferet': 'ティファレト',
      'Triple Trial': 'トリプルブロー',
      'Yesod': 'イェソドクラッシュ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Coronal Wind': '冠状气流',
      'Sephirot': '萨菲洛特',
      'Storm Of Words': '言语风暴'
    },
    'replaceText': {
      'puddle(?:s)?': '圈圈',
      'spread': '散开',
      'Tethers': '连线',
      'Adds Spawn': '小怪出现',
      'Ascension': '上升气流',
      'Chesed(?! Gevurah)': '仁慈',
      'Chesed Gevurah': '仁慈之严酷',
      'Da\'at': '知识',
      'Earth Shaker': '大地摇动',
      'Ein Sof': '无限',
      'Fiendish Rage': '魔神之怒',
      'Fiendish Wail': '魔神之叹',
      'Force Field': '力场',
      'Impact of Hod': '荣光撞击',
      'Life Force': '生命领域',
      'Malkuth': '王国',
      'Pillar of Mercy': '慈悲之柱',
      'Pillar of Severity': '严厉之柱',
      'Ratzon': '意志',
      'Spirit': '圣灵领域',
      'Tiferet': '美丽',
      'Triple Trial': '三重强击',
      'Yesod': '基盘碎击'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Coronal Wind': '관상기류',
      'Sephirot': '세피로트',
      'Storm Of Words': '신언의 폭풍'
    },
    'replaceText': {
      'puddle(?:s)?': '장판',
      'Adds Spawn': '쫄 등장',
      'Ascension': '승천',
      'Chesed(?! Gevurah)': '헤세드',
      'Chesed Gevurah': '헤세드 게부라',
      'Da\'at spread': '다아트 산개',
      'Da\'at Tethers': '다아트 선',
      'Earth Shaker': '요동치는 대지',
      'Ein Sof(?! Ohr)': '아인 소프',
      'Ein Sof Ohr': '아인 소프 오르',
      'Fiendish Rage': '마신의 분노',
      'Fiendish Wail': '마신의 탄식',
      'Force Field': '역장',
      'Impact of Hod': '호드 대충격',
      'Life Force': '생명의 권능',
      'Malkuth': '말쿠트',
      'Pillar of Mercy': '자비의 기둥',
      'Pillar of Severity': '준엄의 기둥',
      'Ratzon': '라촌',
      'Spirit': '성령의 은사',
      'Tiferet': '티페레트',
      'Triple Trial': '삼중 강타',
      'Yesod': '예소드 붕괴'
    }
  }]
};
/* harmony default export */ const sephirot_ex = (sephirot_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/trial/sephirot-ex.txt
const trial_sephirot_ex_namespaceObject = "# Containment Bay S1-T7 (Extreme)\r\n# Sephirot Extreme\r\n\r\n# -ic Binah Cochma\r\n# -ii 368 15CB 156A 156C 1570 1572 1575 1577 157C 1581\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.1 \"Triple Trial\" Ability { id: \"1566\", source: \"Sephirot\" } window 7.1,5\r\n11.2 \"Tiferet\" Ability { id: \"1568\", source: \"Sephirot\" }\r\n17.4 \"Tiferet\" Ability { id: \"1568\", source: \"Sephirot\" }\r\n\r\n# Phase 1 rotation block, 76.3 seconds\r\n21.6 \"Triple Trial\" Ability { id: \"1566\", source: \"Sephirot\" }\r\n25.6 \"Ein Sof (4 puddles)\" Ability { id: \"156E\", source: \"Sephirot\" }\r\n29.7 \"Tiferet\" Ability { id: \"1568\", source: \"Sephirot\" }\r\n38.3 \"Fiendish Rage 1\" Ability { id: \"156D\", source: \"Sephirot\" }\r\n42.0 \"Fiendish Rage 2\" Ability { id: \"156D\", source: \"Sephirot\" }\r\n49.2 \"Tiferet\" Ability { id: \"1568\", source: \"Sephirot\" }\r\n53.3 \"Tiferet\" Ability { id: \"1568\", source: \"Sephirot\" }\r\n59.4 \"Chesed\" Ability { id: \"1567\", source: \"Sephirot\" } window 20,20\r\n61.6 \"Triple Trial\" Ability { id: \"1566\", source: \"Sephirot\" }\r\n67.7 \"Ein Sof (1 puddle)\" Ability { id: \"156E\", source: \"Sephirot\" }\r\n70.9 \"Tiferet\" Ability { id: \"1568\", source: \"Sephirot\" }\r\n81.3 \"Ratzon\" # Ability { id: \"156B\", source: \"Sephirot\" }\r\n85.5 \"Tiferet\" Ability { id: \"1568\", source: \"Sephirot\" }\r\n89.6 \"Tiferet\" Ability { id: \"1568\", source: \"Sephirot\" }\r\n95.7 \"Chesed\" Ability { id: \"1567\", source: \"Sephirot\" } window 20,20\r\n\r\n97.9 \"Triple Trial\" Ability { id: \"1566\", source: \"Sephirot\" }\r\n101.9 \"Ein Sof (4 puddles)\" Ability { id: \"156E\", source: \"Sephirot\" }\r\n106.0 \"Tiferet\" Ability { id: \"1568\", source: \"Sephirot\" }\r\n114.6 \"Fiendish Rage 1\" Ability { id: \"156D\", source: \"Sephirot\" }\r\n118.3 \"Fiendish Rage 2\" Ability { id: \"156D\", source: \"Sephirot\" }\r\n125.5 \"Tiferet\" Ability { id: \"1568\", source: \"Sephirot\" }\r\n129.6 \"Tiferet\" Ability { id: \"1568\", source: \"Sephirot\" }\r\n135.7 \"Chesed\" Ability { id: \"1567\", source: \"Sephirot\" } window 20,20\r\n137.9 \"Triple Trial\" Ability { id: \"1566\", source: \"Sephirot\" }\r\n144.0 \"Ein Sof (1 puddle)\" Ability { id: \"156E\", source: \"Sephirot\" }\r\n147.2 \"Tiferet\" Ability { id: \"1568\", source: \"Sephirot\" }\r\n157.6 \"Ratzon\" # Ability { id: \"156B\", source: \"Sephirot\" }\r\n161.8 \"Tiferet\" Ability { id: \"1568\", source: \"Sephirot\" }\r\n165.9 \"Tiferet\" Ability { id: \"1568\", source: \"Sephirot\" }\r\n172.0 \"Chesed\" Ability { id: \"1567\", source: \"Sephirot\" } window 20,20 jump 95.7\r\n\r\n174.2 \"Triple Trial\"\r\n178.2 \"Ein Sof (4 puddles)\"\r\n182.3 \"Tiferet\"\r\n190.9 \"Fiendish Rage 1\"\r\n194.6 \"Fiendish Rage 2\"\r\n201.8 \"Tiferet\"\r\n205.9 \"Tiferet\"\r\n\r\n\r\n# The intermission doesn't have anything worthwhile to sync.\r\n# Instead we just go straight for the ultimate cast. (It has no cast time.)\r\n# However, we don't want timeline triggers firing during the intermission.\r\n\r\n500.0 \"--sync--\" NameToggle { name: \"Sephirot\", toggle: \"00\" } window 500,0\r\n1000.0 \"Ein Sof Ohr\" Ability { id: \"1571\", source: \"Sephirot\" } window 1000,5\r\n\r\n# Phase 2 rotation block, 197.3 seconds\r\n1013.2 \"Yesod\" Ability { id: \"157E\", source: \"Sephirot\" } window 30,30\r\n1016.2 \"Force Field\" Ability { id: \"1587\", source: \"Sephirot\" }\r\n1028.4 \"Chesed Gevurah\" Ability { id: [\"1578\", \"1579\"], source: \"Sephirot\" }\r\n1029.0 \"Life Force + Spirit\" Ability { id: [\"157A\", \"157B\"], source: \"Sephirot\" }\r\n1034.6 \"Fiendish Wail\" Ability { id: \"1576\", source: \"Sephirot\" }\r\n1042.7 \"Da'at Tethers\" duration 5 #Ability { id: \"1574\", source: \"Sephirot\" }\r\n1053.3 \"Fiendish Wail\" Ability { id: \"1576\", source: \"Sephirot\" }\r\n1060.3 \"Chesed Gevurah\" Ability { id: [\"1578\", \"1579\"], source: \"Sephirot\" }\r\n1060.9 \"Life Force + Spirit\" Ability { id: [\"157A\", \"157B\"], source: \"Sephirot\" }\r\n1068.4 \"Earth Shaker\" Ability { id: \"157D\", source: \"Sephirot\" }\r\n1070.1 \"Yesod\" Ability { id: \"157E\", source: \"Sephirot\" } window 20,20\r\n1077.7 \"Da'at spread\" duration 3.2 #Ability { id: \"1573\", source: \"Sephirot\" }\r\n1085.1 \"Fiendish Wail\" Ability { id: \"1576\", source: \"Sephirot\" }\r\n1092.2 \"Chesed Gevurah\" Ability { id: [\"1578\", \"1579\"], source: \"Sephirot\" }\r\n1092.9 \"Life Force + Spirit\" Ability { id: [\"157A\", \"157B\"], source: \"Sephirot\" }\r\n1101.0 \"Pillar of Mercy 1\" Ability { id: \"1580\", source: \"Sephirot\" }\r\n1101.3 \"Yesod\" Ability { id: \"157E\", source: \"Sephirot\" } window 20,20\r\n1106.2 \"Pillar of Mercy 2\" Ability { id: \"1580\", source: \"Sephirot\" }\r\n1110.1 \"Pillar of Mercy 3\" Ability { id: \"1580\", source: \"Sephirot\" }\r\n1119.3 \"Earth Shaker\" Ability { id: \"157D\", source: \"Sephirot\" }\r\n1128.8 \"Da'at spread\" duration 3.2 #Ability { id: \"1573\", source: \"Sephirot\" }\r\n1129.7 \"Yesod\" Ability { id: \"157E\", source: \"Sephirot\" } window 20,20\r\n1136.1 \"Fiendish Wail\" Ability { id: \"1576\", source: \"Sephirot\" }\r\n1143.2 \"Chesed Gevurah\" Ability { id: [\"1578\", \"1579\"], source: \"Sephirot\" }\r\n1143.8 \"Life Force + Spirit\" Ability { id: [\"157A\", \"157B\"], source: \"Sephirot\" }\r\n1149.4 \"Malkuth\" Ability { id: \"1582\", source: \"Sephirot\" } window 30,30\r\n1150.5 \"Adds Spawn\" AddedCombatant { name: \"Storm Of Words\" }\r\n1158.7 \"Chesed Gevurah\" Ability { id: [\"1578\", \"1579\"], source: \"Sephirot\" }\r\n1159.3 \"Life Force + Spirit\" Ability { id: [\"157A\", \"157B\"], source: \"Sephirot\" }\r\n1164.9 \"Fiendish Wail\" Ability { id: \"1576\", source: \"Sephirot\" }\r\n1166.5 \"Yesod\" Ability { id: \"157E\", source: \"Sephirot\" }\r\n1172.2 \"Chesed Gevurah\" Ability { id: [\"1578\", \"1579\"], source: \"Sephirot\" }\r\n1172.8 \"Life Force + Spirit\" Ability { id: [\"157A\", \"157B\"], source: \"Sephirot\" }\r\n1185.8 \"Yesod\" Ability { id: \"157E\", source: \"Sephirot\" }\r\n1188.4 \"Chesed Gevurah\" Ability { id: [\"1578\", \"1579\"], source: \"Sephirot\" }\r\n1189.0 \"Life Force + Spirit\" Ability { id: [\"157A\", \"157B\"], source: \"Sephirot\" }\r\n1191.6 \"Pillar of Severity\" Ability { id: \"1585\", source: \"Sephirot\" }\r\n1195.3 \"Impact of Hod\" Ability { id: \"172C\", source: \"Sephirot\" }\r\n1199.7 \"Ascension\" Ability { id: \"1584\", source: \"Coronal Wind\" }\r\n\r\n1210.4 \"Yesod\" Ability { id: \"157E\", source: \"Sephirot\" } window 30,30\r\n1213.5 \"Force Field\" Ability { id: \"1587\", source: \"Sephirot\" }\r\n1225.7 \"Chesed Gevurah\" Ability { id: [\"1578\", \"1579\"], source: \"Sephirot\" }\r\n1226.3 \"Life Force + Spirit\" Ability { id: [\"157A\", \"157B\"], source: \"Sephirot\" }\r\n1231.9 \"Fiendish Wail\" Ability { id: \"1576\", source: \"Sephirot\" }\r\n1240.0 \"Da'at Tethers\" duration 5 #Ability { id: \"1574\", source: \"Sephirot\" }\r\n1250.6 \"Fiendish Wail\" Ability { id: \"1576\", source: \"Sephirot\" }\r\n1257.6 \"Chesed Gevurah\" Ability { id: [\"1578\", \"1579\"], source: \"Sephirot\" }\r\n1258.2 \"Life Force + Spirit\" Ability { id: [\"157A\", \"157B\"], source: \"Sephirot\" }\r\n1265.7 \"Earth Shaker\" Ability { id: \"157D\", source: \"Sephirot\" }\r\n1267.4 \"Yesod\" Ability { id: \"157E\", source: \"Sephirot\" } window 20,20\r\n1275.0 \"Da'at spread\" duration 3.2 #Ability { id: \"1573\", source: \"Sephirot\" }\r\n1282.4 \"Fiendish Wail\" Ability { id: \"1576\", source: \"Sephirot\" }\r\n1289.5 \"Chesed Gevurah\" Ability { id: [\"1578\", \"1579\"], source: \"Sephirot\" }\r\n1290.2 \"Life Force + Spirit\" Ability { id: [\"157A\", \"157B\"], source: \"Sephirot\" }\r\n1298.3 \"Pillar of Mercy 1\" Ability { id: \"1580\", source: \"Sephirot\" }\r\n1298.6 \"Yesod\" Ability { id: \"157E\", source: \"Sephirot\" } window 20,20\r\n1303.5 \"Pillar of Mercy 2\" Ability { id: \"1580\", source: \"Sephirot\" }\r\n1307.4 \"Pillar of Mercy 3\" Ability { id: \"1580\", source: \"Sephirot\" }\r\n1316.6 \"Earth Shaker\" Ability { id: \"157D\", source: \"Sephirot\" }\r\n1326.1 \"Da'at spread\" duration 3.2 #Ability { id: \"1573\", source: \"Sephirot\" }\r\n1327.0 \"Yesod\" Ability { id: \"157E\", source: \"Sephirot\" } window 20,20\r\n1333.4 \"Fiendish Wail\" Ability { id: \"1576\", source: \"Sephirot\" }\r\n1340.5 \"Chesed Gevurah\" Ability { id: [\"1578\", \"1579\"], source: \"Sephirot\" }\r\n1341.1 \"Life Force + Spirit\" Ability { id: [\"157A\", \"157B\"], source: \"Sephirot\" }\r\n1346.7 \"Malkuth\" Ability { id: \"1582\", source: \"Sephirot\" }\r\n1347.8 \"Adds Spawn\" AddedCombatant { name: \"Storm Of Words\" }\r\n1356.0 \"Chesed Gevurah\" Ability { id: [\"1578\", \"1579\"], source: \"Sephirot\" }\r\n1356.6 \"Life Force + Spirit\" Ability { id: [\"157A\", \"157B\"], source: \"Sephirot\" }\r\n1362.2 \"Fiendish Wail\" Ability { id: \"1576\", source: \"Sephirot\" }\r\n1363.8 \"Yesod\" Ability { id: \"157E\", source: \"Sephirot\" }\r\n1369.5 \"Chesed Gevurah\" Ability { id: [\"1578\", \"1579\"], source: \"Sephirot\" }\r\n1370.1 \"Life Force + Spirit\" Ability { id: [\"157A\", \"157B\"], source: \"Sephirot\" }\r\n1382.9 \"Yesod\" Ability { id: \"157E\", source: \"Sephirot\" }\r\n1385.7 \"Chesed Gevurah\" Ability { id: [\"1578\", \"1579\"], source: \"Sephirot\" }\r\n1386.3 \"Life Force + Spirit\" Ability { id: [\"157A\", \"157B\"], source: \"Sephirot\" }\r\n1388.9 \"Pillar of Severity\" Ability { id: \"1585\", source: \"Sephirot\" }\r\n1392.6 \"Impact of Hod\" Ability { id: \"172C\", source: \"Sephirot\" }\r\n1397.0 \"Pillar of Severity Enrage\" Ability { id: \"1585\", source: \"Sephirot\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/trial/sephirot.ts



const sephirot_triggerSet = {
  id: 'ContainmentBayS1T7',
  zoneId: zone_id/* default.ContainmentBayS1T7 */.Z.ContainmentBayS1T7,
  triggers: [{
    id: 'Sephirot Fiendish Rage',
    type: 'HeadMarker',
    netRegex: {
      id: '0048'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Sephirot Ratzon',
    type: 'HeadMarker',
    netRegex: {
      id: '0046'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Sephirot Ain',
    type: 'StartsUsing',
    netRegex: {
      id: '16DD',
      source: 'Sephirot',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Sephirot Earth Shaker',
    type: 'HeadMarker',
    netRegex: {
      id: '0028'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.earthshaker */.n3.earthshaker()
  }, {
    // The coordinates for skill are inconsistent and can't be used to
    // reliably determine the position of the knockback.
    id: 'Sephirot Pillar of Mercy',
    type: 'StartsUsing',
    netRegex: {
      id: '16EA',
      source: 'Sephirot',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Sephirot Storm of Words Revelation',
    type: 'StartsUsing',
    netRegex: {
      id: '16EC',
      source: 'Storm of Words',
      capture: false
    },
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Storm of Words or die',
        de: 'Wörtersturm besiegen',
        fr: 'Tuez Tempête de mots ou mourrez',
        cn: '击杀言语风暴!',
        ko: '신언의 폭풍 제거'
      }
    }
  }, {
    id: 'Sephirot Malkuth',
    type: 'StartsUsing',
    netRegex: {
      id: '16EB',
      source: 'Sephirot',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Sephirot': 'Sephirot',
      'Storm of Words': 'Wörtersturm'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Sephirot': 'Sephirot',
      'Storm of Words': 'tempête de mots'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Sephirot': 'セフィロト',
      'Storm of Words': 'ストーム・オブ・ワード'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Sephirot': '萨菲洛特',
      'Storm of Words': '言语风暴'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Sephirot': '세피로트',
      'Storm of Words': '신언의 폭풍'
    }
  }]
};
/* harmony default export */ const sephirot = (sephirot_triggerSet);
// EXTERNAL MODULE: ./resources/not_reached.ts
var not_reached = __webpack_require__(62);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/trial/sophia-ex.ts




const findSafeDir = data => {
  // Tethers are ordered with all East tethers first. This *doesn't* mean that the East
  // or West tethers are themselves in order within their half!
  // The eight scale entities are listed in the data object, with West at indices 0-3,
  // under data.scaleSophias.
  let safeDir = 0;
  // If there's a side with more tethers, we know for sure that's the safe side.
  // This will give us the tilt direction for all but the 1/1, 2/2, and 3/3 cases.
  // The safe side is represented here by whether safeDir is positive or negative.
  // (West/negative, East/positive.)
  for (const tether of data.quasarTethers ?? []) {
    const idx = data.scaleSophias?.indexOf(tether);
    if (idx === undefined) throw new not_reached/* UnreachableCode */.$();
    safeDir += idx < 4 ? -1 : 1;
  }
  return safeDir;
};
const callSafeDir = (callIndex, output) => {
  const outputs = {
    '2': output.goEastHardTilt(),
    '1': output.goEastSoftTilt(),
    '-2': output.goWestHardTilt(),
    '-1': output.goWestSoftTilt()
    // Stringified because Javascript doesn't do negative-integer key values.
  };

  return outputs[callIndex.toString()];
};
const tiltOutputStrings = {
  goEastHardTilt: {
    en: 'Go East (Hard Tilt)',
    de: 'Nach Osten gehen (starke Neigung)',
    fr: 'Allez à l\'Est (Inclinaison forte)',
    ja: '東へ (大きい斜め)',
    cn: '去东边（大倾斜）',
    ko: '동쪽으로 (크게 기울어짐)'
  },
  goEastSoftTilt: {
    en: 'Go East (Soft Tilt)',
    de: 'Nach Osten gehen (leichte Neigung)',
    fr: 'Allez à l\'Est (Inclinaison faible)',
    ja: '東へ (小さい斜め)',
    cn: '去东边（小倾斜）',
    ko: '동쪽으로 (작게 기울어짐)'
  },
  goWestHardTilt: {
    en: 'Go West (Hard Tilt)',
    de: 'Nach Westen gehen (starke Neigung)',
    fr: 'Allez à l\'Ouest (Inclinaison forte)',
    ja: '西へ (大きい斜め)',
    cn: '去西边（大倾斜）',
    ko: '서쪽으로 (크게 기울어짐)'
  },
  goWestSoftTilt: {
    en: 'Go West (Soft Tilt)',
    de: 'Nach Westen gehen (leichte Neigung)',
    fr: 'Allez à l\'Ouest (Inclinaison faible)',
    ja: '西へ (小さい斜め)',
    cn: '去西边（小倾斜）',
    ko: '서쪽으로 (작게 기울어짐)'
  }
};
const sophia_ex_triggerSet = {
  id: 'ContainmentBayP1T6Extreme',
  zoneId: zone_id/* default.ContainmentBayP1T6Extreme */.Z.ContainmentBayP1T6Extreme,
  timelineFile: 'sophia-ex.txt',
  initData: () => {
    return {
      isQuadrantSafe: {
        NW: true,
        NE: true,
        SW: true,
        SE: true
      }
    };
  },
  timelineTriggers: [{
    // Gnosis does in fact have a cast time, but it's only 2.7 seconds.
    // It's safer to warn via the timeline.
    id: 'SophiaEX Gnosis',
    regex: /Gnosis/,
    beforeSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    // Onrush also has a 2.7 second cast time and thus is best notified from the timeline.
    id: 'SophiaEX Onrush',
    regex: /Onrush/,
    beforeSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Dash Attack',
        de: 'Ansturm-Angriff ausweichen',
        fr: 'Évitez l\'attaque Charge',
        ja: '突進回避',
        cn: '躲避击飞',
        ko: '돌진 공격 피하기'
      }
    }
  }, {
    id: 'SophiaEX Cintamani',
    regex: /Cintamani/,
    beforeSeconds: 4,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'SophiaEX Dischordant Cleansing',
    regex: /Dischordant Cleansing/,
    beforeSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack With Partner',
        de: 'Mit Partner stacken',
        fr: 'Packez-vous avec votre partenaire',
        ja: '白と黒で重なる',
        cn: '黑白配',
        ko: '흑백 파트너랑 모이기'
      }
    }
  }, {
    id: 'SophiaEX Quasar Bait',
    regex: /Quasar \(Snapshot\)/,
    beforeSeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Quasar Meteors',
        de: 'Quasar Meteore ködern',
        fr: 'Attirez les météores du Quasar',
        ja: 'メテオを誘導',
        cn: '诱导陨石',
        ko: '운석 유도하기'
      }
    }
  }],
  triggers: [{
    id: 'SophiaEX Tank Buster',
    type: 'StartsUsing',
    netRegex: {
      id: '19C4',
      source: 'Sophia'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'SophiaEX Thunder 2',
    type: 'StartsUsing',
    netRegex: {
      id: '19B0',
      source: 'Sophia',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'SophiaEX Thunder 3',
    type: 'StartsUsing',
    netRegex: {
      id: '19AC',
      source: 'Sophia',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    // Technically this one does have a telegraph, but it feels really weird
    // to have Thunder 3 with popup text and this one not.
    id: 'SophiaEX Aero 3',
    type: 'StartsUsing',
    netRegex: {
      id: '19AE',
      source: 'Sophia',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'SophiaEX Divine Spark',
    type: 'StartsUsing',
    netRegex: {
      id: '19B6',
      source: 'The Second Demiurge'
    },
    response: responses/* Responses.lookAwayFromSource */.n3.lookAwayFromSource()
  }, {
    id: 'SophiaEX Gnostic Rant',
    type: 'StartsUsing',
    netRegex: {
      id: '19B8',
      source: 'The Third Demiurge',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get behind lancer',
        de: 'Geh hinter dem 3. Demiurg',
        fr: 'Passez derrière le lancier',
        ja: '三の従者の後ろに',
        cn: '躲在3号小怪后',
        ko: '제3신도 뒤로 가기'
      }
    }
  }, {
    id: 'SophiaEX Infusion',
    type: 'StartsUsing',
    netRegex: {
      id: '1988',
      source: 'The First Demiurge'
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.infusionOnYou();
      return output.infusionOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      infusionOnYou: {
        en: 'Infusion on YOU',
        de: 'Schneisenschläger auf DIR',
        fr: 'Infusion sur VOUS',
        ja: '自分に猛突進',
        cn: '冲锋点名',
        ko: '맹돌진 대상자'
      },
      infusionOn: {
        en: 'Infusion on ${player}',
        de: 'Schneisenschläger auf ${player}',
        fr: 'Infusion sur ${player}',
        ja: '${player}に猛突進',
        cn: '冲锋点${player}',
        ko: '${player} 에게 맹돌진'
      }
    }
  }, {
    // The Aion Teleos clones have 10 fixed points where they can appear, but not all
    // combinations are valid:
    // (0,9), (0,-9), (-10,9), (-10,-9), (10,9), (10,-9), (-15,9), (-15,-9), (15,9), (15,-9).
    // Each quadrant can contain 0 or 1 clones, and the center can have 0-2.
    // There will always be 4 clones.
    // There can never be more than 3 clones North or South.

    // The full sequence for clones is:
    // 1. Clones appear, alongside a Cintamani cast
    // If it's the first clone set:
    // 2. Sophia casts Thunder III
    // 3. Sophia casts Aero
    // 4. Sophia casts Arms of Wisdom
    // 5. Barbelo moves to cast Light Dew
    // 6. Barbelo casts Light Dew and Sophia casts Execute
    // 7. Clones disappear

    // If it's not the first clone set:
    // 2. Sophia casts Arms Of Wisdom
    // 3. Sophia casts Thunder
    // 4. Sophia casts Aero
    // 5. Quasars cast, snapshot, and resolve
    // 6. Sophia casts Arms Of Wisdom again
    // 7. Dischordant Cleansing circles go out and resolve
    // 8. Sophia casts Execute
    // 9. Clones disappear
    id: 'SophiaEX Clone Collect',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Aion Teleos'
    },
    run: (data, matches) => {
      data.cloneSpots ??= {};
      const x = parseFloat(matches.x);
      const y = parseFloat(matches.y);
      // We start with Y since it's a binary choice.
      // Note that Y-values are inverted! (In-game, 0,1 is one unit South from the origin)
      let positionString = y > 0 ? 'S' : 'N';
      // The center two clones aren't exactly on the centerline, so we round the X coordinates.
      if (Math.round(x) !== 0) positionString += Math.round(x) < 0 ? 'W' : 'E';
      // Yes, we have to specifically uppercase this for 03 log lines.
      // No, we don't know why. Blame Square/Ravahn/Hydaelyn.
      data.cloneSpots[matches.id.toUpperCase()] = positionString;
    }
  }, {
    // Thunder is always cast first when the Aion Teleos spawn.
    // Because we don't know whether there will be one or two Thunder tethers,
    // we have to separate out the "seen Thunder" logic.
    id: 'SophiaEX Duplicate Collect',
    type: 'Tether',
    netRegex: {
      id: '002D'
    },
    run: (data, matches) => {
      const spot = data.cloneSpots?.[matches.sourceId];
      if (spot === undefined) throw new not_reached/* UnreachableCode */.$();
      // Only Thunder 2 is ever used on centerline clones,
      // so center clones will never affect quadrant safety.
      if (spot === 'N' || spot === 'S') {
        return;
      }
      if (data.seenThunder) {
        data.isQuadrantSafe[spot] = false;
      }
    }
  }, {
    id: 'SophiaEX Thunder Seen',
    type: 'StartsUsing',
    netRegex: {
      id: '19AB',
      source: 'Aion Teleos',
      capture: false
    },
    delaySeconds: 1,
    suppressSeconds: 5,
    run: data => data.seenThunder = true
  }, {
    // Quasar can either be meteor baits or a platform tilt,
    // but the platform will not tilt while clones are active.
    // Since both have the same tethers and initial cast,
    // our best way to call the mechanic is to check whether clones are active.
    id: 'SophiaEX Clones Active',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Aion Teleos',
      capture: false
    },
    run: data => data.clonesActive = true
  }, {
    // During the first post-intermission clones sequence,
    // Barbelo separates and makes one safespot dangerous with Light Dew, the orange laser.
    // Unfortunately Barbelo doesn't have a cast time on Light Dew, so we can't use that.
    // Instead, we warn the user when Barbelo separates from Sophia, which is 1983.
    id: 'SophiaEX Light Dew',
    type: 'Ability',
    netRegex: {
      id: '1983',
      source: 'Sophia',
      capture: false
    },
    condition: data => data.clonesActive,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid head laser',
        de: 'Kopflaser ausweichen',
        fr: 'Évitez le laser de la tête',
        ja: '頭レーザー回避',
        cn: '躲避人头炮',
        ko: '머리 레이저 피하기'
      }
    }
  }, {
    id: 'SophiaEX Execute',
    type: 'StartsUsing',
    netRegex: {
      id: '19AA',
      source: 'Sophia'
    },
    durationSeconds: (_data, matches) => parseFloat(matches.castTime),
    alertText: (data, _matches, output) => {
      const localeCompass = {
        'NW': output.northwest(),
        'NE': output.northeast(),
        'SW': output.southwest(),
        'SE': output.southeast()
      };
      const safeSpots = [];
      for (const dir of Object.keys(data.isQuadrantSafe)) {
        if (data.isQuadrantSafe[dir]) safeSpots.push(localeCompass[dir]);
      }
      if (safeSpots.length === 1) {
        return safeSpots[0];
      }
      return output.multiple({
        dir1: safeSpots[0],
        dir2: safeSpots[1]
      });
    },
    outputStrings: {
      northwest: outputs/* default.northwest */.Z.northwest,
      northeast: outputs/* default.northeast */.Z.northeast,
      southwest: outputs/* default.southwest */.Z.southwest,
      southeast: outputs/* default.southeast */.Z.southeast,
      multiple: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        ja: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      }
    }
  }, {
    id: 'SophiaEX Clone Cleanup',
    type: 'Ability',
    netRegex: {
      id: '19AA',
      source: 'Sophia',
      capture: false
    },
    delaySeconds: 5,
    run: data => {
      delete data.clonesActive;
      delete data.seenThunder;
      data.isQuadrantSafe = {
        NW: true,
        NE: true,
        SW: true,
        SE: true
      };
    }
  }, {
    // The eight Sophia entities on the scale pans have IDs that run sequentially,
    // from n + 0 to n + 7. They spawn into the instance in a random order, but the
    // locations where they spawn have a fixed association with their sequence number offset:

    // 0: (-55.0637, -3.496415)
    // 1: (-55.06367, -10.1404)
    // 2: (-55.06363, 9.5766)
    // 3: (-55.0637, 3.523648)
    // 4: (54.9907, 3.387837)
    // 5: (54.98699, 9.576593)
    // 6: (54.9907, -3.50686)
    // 7: (54.99068, -10.14043)

    // Because of this, we need only see one entity use a 21 log line and we can find the rest.
    id: 'SophiaEX Quasar Setup',
    type: 'Ability',
    netRegex: {
      id: ['19A8', '19A9']
    },
    condition: data => !data.scaleSophias,
    // We *really* shouldn't have to suppress this...
    suppressSeconds: 5,
    run: (data, matches) => {
      let offset;
      const yKey = Math.floor(parseFloat(matches.y)).toString();
      if (parseFloat(matches.x) < 0) {
        const offsetMap = {
          '-4': 0,
          '-11': 1,
          '9': 2,
          '3': 3
        };
        offset = offsetMap[yKey];
      } else {
        const offsetMap = {
          '3': 4,
          '9': 5,
          '-4': 6,
          '-11': 7
        };
        offset = offsetMap[yKey];
      }
      if (offset === undefined) throw new not_reached/* UnreachableCode */.$();
      const seqStart = parseInt(matches.sourceId, 16) - offset;
      for (let i = 0; i < 8; i++) {
        data.scaleSophias ??= [];
        data.scaleSophias.push((seqStart + i).toString(16).toUpperCase());
      }
    }
  }, {
    // We collect tethers here for later use on Quasar calls.
    // Blue Quasars (19A9) weigh 3 units, while orange ones (19A8) weigh 1.
    // Meteor Quasars happen only when we have a 3/1 split of tethers (balanced).
    // If the tether split is not 3/1, it will always be one of these possibilities:
    // 1/1, 2/2, 3/3, 2/1, 3/2, 4/2, 4/3
    // If the difference of the sum of weights on each side is 1, the tilt will be soft.
    // Otherwise it will be hard.
    // There will always be exactly one blue Quasar, unless the split is 4/2.
    id: 'SophiaEX Quasar Tether Collect',
    type: 'Tether',
    netRegex: {
      id: '0011'
    },
    condition: data => {
      // We shouldn't run this while Aion Teleos mechanics are active.
      return !data.clonesActive;
    },
    run: (data, matches) => {
      data.quasarTethers ??= [];
      data.quasarTethers.push(matches.sourceId);
    }
  }, {
    id: 'SophiaEX Tilt Via Tether',
    type: 'Tether',
    netRegex: {
      id: '0011',
      capture: false
    },
    condition: data => {
      // No platform tilts if clones are up.
      return !data.clonesActive;
    },
    // We let the storage triggers catch up before calling.
    delaySeconds: .5,
    durationSeconds: 12,
    // Ensuring that forgetful people aren't forgotten.
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      // If we somehow skipped the first set of Quasars, we won't know the locations of
      // the scale entities. Activate the sadTethers flag and wait for the actual casts.
      if (!data.scaleSophias) {
        data.sadTethers = true;
        return;
      }
      const safeDir = findSafeDir(data);
      if (safeDir === 0) {
        // If it's the 1/1, 2/2, or 3/3 case, we sadly don't have enough information.
        // We have to quit here and wait for the actual cast.
        data.sadTethers = true;
        return;
      }
      return callSafeDir(safeDir, output);
    },
    outputStrings: tiltOutputStrings
  }, {
    // This specifically calls the case where it's 1/1;2/2;3/3 tethers,
    // or any tether combination if we skipped the first Meteor Quasars.
    // The blue Quasar, 19A9, is *alway* on the dangerous side.
    // The 20/startsUsing log lines don't actually have position data,
    // but we enumerated all the locations earlier,
    // so anytime one of these entities casts, we know where it is.
    id: 'SophiaEX Tilt Via Cast',
    type: 'StartsUsing',
    netRegex: {
      id: '19A9',
      source: 'Sophia'
    },
    condition: data => data.sadTethers,
    durationSeconds: 10,
    suppressSeconds: 5,
    alertText: (data, matches, output) => {
      let safeDir = findSafeDir(data);
      // If this is the first set of Meteor Quasars, there is no tilt.
      if (data.quasarTethers?.length === 4 && safeDir !== 0) return;
      if (safeDir === 0) {
        const idx = data.scaleSophias?.indexOf(matches.sourceId);
        if (idx === undefined) throw new not_reached/* UnreachableCode */.$();
        safeDir = idx < 4 ? 2 : -2;
      }
      return callSafeDir(safeDir, output);
    },
    outputStrings: tiltOutputStrings
  }, {
    id: 'SophiaEX Quasar Cleanup',
    type: 'Ability',
    netRegex: {
      id: '19A9',
      capture: false
    },
    run: data => {
      delete data.quasarTethers;
      delete data.sadTethers;
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aion Teleos': 'Aion Teleos',
      'Barbelo': 'Barbelo',
      'Sophia': 'Sophia',
      'The First Demiurge': 'Erst(?:e|er|es|en) Demiurg',
      'The Second Demiurge': 'Zweit(?:e|er|es|en) Demiurg',
      'The Third Demiurge': 'Dritt(?:e|er|es|en) Demiurg'
    },
    'replaceText': {
      '\\(Meteor Detonate\\)': '(Meteor Explosion)',
      '\\(Snapshot\\)': '(Meteor Positionen)',
      '\\(Tilt\\)': '(Neigung)',
      'Aero III': 'Windga',
      'Arms of Wisdom': 'Arme der Weisheit',
      'Cintamani': 'Chintamani',
      'Cloudy Heavens': 'Nebulöse Himmel',
      'Dischordant Cleansing': 'Dissonante Buße',
      'Divine Spark': 'Göttlicher Funke',
      'Execute': 'Exekutieren',
      'Gnosis': 'Gnosis',
      'Gnostic Spear': 'Gnostischer Speer',
      'Horizontal Kenoma': 'Horizontales Kenoma',
      'Light Dew': 'Lichttau',
      'Onrush': 'Heranstürmen',
      'Quasar': 'Quasar',
      'Ring of Pain': 'Ring des Schmerzes',
      'The Scales Of Wisdom': 'Waage der Weisheit',
      'Tethers': 'Verbindungen',
      'Thunder II\\/III': 'Blitzra/Blitzga',
      'Thunder II(?!(?:I|\\/))': 'Blitzra',
      'Thunder III': 'Blitzga',
      'Vertical Kenoma': 'Vertikales Kenoma',
      'Zombification': 'Zombie'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aion Teleos': 'Aion Teleos',
      'Barbelo': 'Barbelo',
      'Sophia': 'Sophia',
      'The First Demiurge': 'Premier Démiurge',
      'The Second Demiurge': 'Second Démiurge',
      'The Third Demiurge': 'Troisième Démiurge'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(Meteor Detonate\\)': '(Explosion des météores)',
      '\\(Snapshot\\)': '(Instantané)',
      '\\(Tilt\\)': '(Inclinaison)',
      'Aero III': 'Méga Vent',
      'Arms of Wisdom': 'Bras de la sagesse',
      'Cintamani': 'Chintamani',
      'Cloudy Heavens': 'Ciel nébuleux',
      'Dischordant Cleansing': 'Purification Discordante',
      'Divine Spark': 'Étincelle divine',
      'Execute': 'Exécution',
      'Gnosis': 'Gnose',
      'Gnostic Spear': 'Épieu Gnostique',
      'Horizontal Kenoma': 'Kenoma horizontal',
      'Light Dew': 'Rosée De Lumière',
      'Onrush': 'Charge',
      'Quasar': 'Quasar',
      'Quasar Tethers': 'Liens Quasar',
      'Ring of Pain': 'Anneau de douleur',
      'The Scales Of Wisdom': 'Balance de la sagesse',
      'Thunder II\\/III': 'Extra Foudre/Mega Foudre',
      'Thunder II(?!(?:I|\\/))': 'Extra Foudre',
      'Thunder III': 'Méga Foudre',
      'Vertical Kenoma': 'Kenoma Vertical',
      'Zombification': 'Zombification'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aion Teleos': 'アイオーン・ソフィア',
      'Barbelo': 'バルベロ',
      'Sophia': 'ソフィア',
      'The First Demiurge': '一の従者',
      'The Second Demiurge': '二の従者',
      'The Third Demiurge': '三の従者'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(Meteor Detonate\\)': '(メテオ)',
      '\\(Snapshot\\)': '(ヘッド)',
      '\\(Tilt\\)': '(斜め)',
      'Aero III': 'エアロガ',
      'Arms of Wisdom': 'ウィズダムアームズ',
      'Cintamani': 'チンターマニ',
      'Cloudy Heavens': 'クラウディヘヴン',
      'Dischordant Cleansing': '不調和の罰',
      'Divine Spark': '熱いまなざし',
      'Execute': 'エクセキュート',
      'Gnosis': 'グノーシス',
      'Gnostic Spear': '魔槍突き',
      'Horizontal Kenoma': '側面堅守',
      'Light Dew': 'ライトデュー',
      'Onrush': 'オンラッシュ',
      'Quasar': 'クエーサー',
      'Ring of Pain': 'リング・オブ・ペイン',
      'The Scales Of Wisdom': 'バランス・オブ・ウィズダム',
      '(?<= )Tethers': '線',
      'Thunder II\\/III': 'サンダー/サンダガ',
      'Thunder II(?!(?:I|\\/I))': 'サンダラ',
      'Thunder III': 'サンダガ',
      'Vertical Kenoma': '前後堅守',
      'Zombification': 'ゾンビー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aion Teleos': '移涌',
      'Barbelo': '芭碧萝',
      'Sophia': '索菲娅',
      'The First Demiurge': '信徒其一',
      'The Second Demiurge': '信徒其二',
      'The Third Demiurge': '信徒其三'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(Meteor Detonate\\)': '(陨石爆炸)',
      '\\(Snapshot\\)': '(快照)',
      '\\(Tilt\\)': '(倾斜)',
      'Aero III': '暴风',
      'Arms of Wisdom': '睿智之秤',
      'Cintamani': '如意宝珠',
      'Cloudy Heavens': '阴云天堂',
      'Dischordant Cleansing': '不平衡之罚',
      'Divine Spark': '灼热视线',
      'Execute': '处决',
      'Gnosis': '灵知',
      'Gnostic Spear': '魔枪突刺',
      'Horizontal Kenoma': '侧面坚守',
      'Light Dew': '光露',
      'Onrush': '突袭',
      'Quasar': '类星体',
      'Ring of Pain': '痛苦环刺',
      'The Scales Of Wisdom': '睿智之天平',
      'Thunder II\\/III': '震雷/暴雷',
      'Thunder II(?!(?:I|\\/))': '震雷',
      'Thunder III': '暴雷',
      'Vertical Kenoma': '前后坚守',
      'Zombification': '僵尸'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aion Teleos': '아이온 소피아',
      'Barbelo': '바르벨로',
      'Sophia': '소피아',
      'The First Demiurge': '제1신도',
      'The Second Demiurge': '제2신도',
      'The Third Demiurge': '제3신도'
    },
    'replaceText': {
      'Aero III': '에어로가',
      'Arms of Wisdom': '지혜의 무기',
      'Cintamani': '친타마니',
      'Cloudy Heavens': '흐린 낙원',
      'Dischordant Cleansing': '부조화의 벌',
      'Divine Spark': '뜨거운 시선',
      'Execute': '이행',
      'Gnosis': '영적 지혜',
      'Gnostic Spear': '마창 찌르기',
      'Horizontal Kenoma': '측면 견제',
      'Light Dew': '빛의 이슬',
      'Onrush': '돌진',
      'Quasar': '퀘이사',
      'Ring Of Pain': '고통의 소용돌이',
      'The Scales Of Wisdom': '지혜의 저울',
      'Thunder II\\/III': '선더라/선더가',
      'Thunder II(?!(?:I|\\/))': '선더라',
      'Thunder III': '선더가',
      'Vertical Kenoma': '앞뒤 견제',
      'Zombification': '좀비'
    }
  }]
};
/* harmony default export */ const sophia_ex = (sophia_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/trial/sophia-ex.txt
const trial_sophia_ex_namespaceObject = "# Containment Bay S1-T6 (Extreme)\r\n# Sophia Extreme\r\n\r\n# -ii 1983 1984 1989 19A8 19A9 19AD 19AF 19B1 1A4C 1ABE 1ABF\r\n\r\n# Enrage is 1AE0, but it comes up immediately after the impossible Sin/Suffering.\r\n# There's no way to differentiate this in the timeline.\r\n\r\n# 1A4C is not a Quasar ability. It's instead one of two \"unknown\" abilities that\r\n# move the stage background and slide the player.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n12.0 \"Thunder II\" Ability { id: \"19B0\", source: \"Sophia\" } window 12,5\r\n22.4 \"Gnosis\" Ability { id: \"19C2\", source: \"Barbelo\" }\r\n41.4 \"Arms Of Wisdom?\" Ability { id: \"19C4\", source: \"Sophia\" } # May be skipped depending on DPS\r\n\r\n# This section will be reached either at 56.0, or at the time she is pushed to 90%\r\n56.0 \"--clones appear--\" AddedCombatant { name: \"Aion Teleos\" } window 56,5\r\n63.6 \"Thunder II/III\" Ability { id: [\"19AC\", \"19B0\"], source: \"Sophia\" }\r\n63.6 \"--sync--\" Ability { id: \"19AB\", source: \"Aion Teleos\" } window 30,2.5\r\n69.7 \"Aero III\" Ability { id: \"19AE\", source: \"Sophia\" }\r\n69.7 \"--sync--\" Ability { id: \"19AB\", source: \"Aion Teleos\" }\r\n79.8 \"Execute\" Ability { id: \"19AA\", source: \"Sophia\" }\r\n#79.8 \"Execute\" Ability { id: \"19AF\", source: \"Aion Teleos\" }\r\n90.2 \"Arms Of Wisdom\" Ability { id: \"19C4\", source: \"Sophia\" }\r\n\r\n# Intermission.\r\n# Divine Spark can be pushed and thus is not synced.\r\n# Gnostic Rant and Infusion are purely HP-based pushes.\r\n110.6 \"Cloudy Heavens\" Ability { id: \"19BE\", source: \"Sophia\" } window 110.6,0\r\n111.6 \"--untargetable--\"\r\n111.6 \"--adds spawn--\"\r\n120.9 \"Horizontal Kenoma/Vertical Kenoma\" Ability { id: [\"19BB\", \"19BC\"], source: \"The First Demiurge\" }\r\n121.9 \"Gnostic Spear\" Ability { id: \"19B9\", source: \"The Third Demiurge\" }\r\n125.9 \"Divine Spark\" # Ability { id: \"19B6\", source: \"The Second Demiurge\" }\r\n129.0 \"Ring Of Pain\" Ability { id: \"19BA\", source: \"The Third Demiurge\" }\r\n135.1 \"Horizontal Kenoma/Vertical Kenoma\" Ability { id: [\"19BB\", \"19BC\"], source: \"The First Demiurge\" }\r\n147.3 \"Gnostic Spear?\" Ability { id: \"19B9\", source: \"The Third Demiurge\" }\r\n149.2 \"Horizontal Kenoma/Vertical Kenoma\" Ability { id: [\"19BB\", \"19BC\"], source: \"The First Demiurge\" }\r\n191.6 \"Zombification Enrage?\"\r\n\r\n# There's an introductory block leading into a rotation.\r\n250.0 \"The Scales Of Wisdom\" Ability { id: \"1981\", source: \"Sophia\" } window 250,5\r\n267.5 \"The Scales Of Wisdom\" Ability { id: \"1AE1\", source: \"Sophia\" }\r\n272.9 \"--targetable--\"\r\n280.8 \"Quasar (Snapshot)\" Ability { id: [\"196E\", \"19A7\"], source: \"Sophia\" }\r\n286.8 \"Quasar (Meteor Detonate)\" Ability { id: \"1A87\", source: \"Sophia\" }\r\n291.3 \"Aero III/Thunder II/Thunder III\" Ability { id: [\"19AC\", \"19AE\", \"19B0\"], source: \"Sophia\" } window 41.3,5\r\n297.1 \"Quasar Tethers\" Ability { id: \"196E\", source: \"Sophia\" }\r\n305.7 \"Quasar (Tilt)\" Ability { id: \"1A4C\", source: \"Sophia\" }\r\n310.7 \"Cintamani x2\" duration 3 # Ability { id: \"19C5\", source: \"Sophia\" }\r\n318.8 \"Arms Of Wisdom\" Ability { id: \"19C4\", source: \"Sophia\" }\r\n\r\n # Potential landing point if DPS is high. Push seems to be 70%?\r\n328.3 \"Thunder II\" Ability { id: \"19B0\", source: \"Sophia\" } window 35.8,5\r\n334.0 \"Quasar Tethers\" Ability { id: \"19A7\", source: \"Sophia\" }\r\n335.0 \"--untargetable--\"\r\n341.2 \"Onrush\" Ability { id: \"19C1\", source: \"Sophia\" }\r\n341.8 \"Quasar (Tilt)\" # Ability { id: \"1A4C\", source: \"Sophia\" }\r\n345.4 \"--targetable--\"\r\n361.5 \"Dischordant Cleansing\" # Ability { id: [\"19B3\", \"19B5\"], source: \"Sophia\" }\r\n361.5 \"Cintamani x2\" duration 3 # Ability { id: \"19C5\", source: \"Sophia\" }\r\n370.8 \"Arms Of Wisdom\" Ability { id: \"19C4\", source: \"Sophia\" } window 30,5\r\n379.0 \"--clones appear--\" AddedCombatant { name: \"Aion Teleos\" } window 60,20\r\n382.0 \"Cintamani x3\" duration 6 # Ability { id: \"19C5\", source: \"Sophia\" }\r\n393.3 \"--sync--\" Ability { id: \"19AB\", source: \"Aion Teleos\" }\r\n393.3 \"Thunder II/III\" Ability { id: [\"19AC\", \"19B0\"], source: \"Sophia\" }\r\n399.4 \"--sync--\" Ability { id: \"19AB\", source: \"Aion Teleos\" }\r\n399.4 \"Aero III\" Ability { id: \"19AE\", source: \"Sophia\" } window 30,5\r\n408.5 \"Arms Of Wisdom\" Ability { id: \"19C4\", source: \"Sophia\" }\r\n419.8 \"Light Dew\" Ability { id: \"19BF\", source: \"Barbelo\" }\r\n420.5 \"Execute\" Ability { id: \"19AA\", source: \"Sophia\" } window 30,30\r\n\r\n# Rotation block.\r\n# Technically it can loop, but unless party DPS is VERY high,\r\n# enrage will occur long before the second loop completes.\r\n429.3 \"Cintamani x3\" duration 6 # Ability { id: \"19C5\", source: \"Sophia\" } duration 5\r\n440.7 \"Arms Of Wisdom\" Ability { id: \"19C4\", source: \"Sophia\" }\r\n446.5 \"Quasar Tethers\" Ability { id: \"196E\", source: \"Sophia\" }\r\n455.2 \"Quasar (Tilt)\" Ability { id: \"1A4C\", source: \"Sophia\" }\r\n457.7 \"Light Dew\" Ability { id: \"19BF\", source: \"Barbelo\" } window 30,30\r\n470.0 \"Thunder III\" Ability { id: \"19AC\", source: \"Sophia\" }\r\n478.3 \"Arms Of Wisdom\" Ability { id: \"19C4\", source: \"Sophia\" }\r\n484.5 \"Quasar Tethers\" Ability { id: \"19A7\", source: \"Sophia\" }\r\n485.5 \"--untargetable--\"\r\n493.2 \"Quasar (Tilt)\" Ability { id: \"1A4C\", source: \"Sophia\" }\r\n494.7 \"Onrush\" Ability { id: \"19C1\", source: \"Sophia\" }\r\n495.7 \"Light Dew\" Ability { id: \"19C0\", source: \"Barbelo\" } window 30,30\r\n499.0 \"--targetable--\"\r\n507.1 \"Cintamani x3\" duration 6 # Ability { id: \"19C5\", source: \"Sophia\" }\r\n518.3 \"Arms Of Wisdom\" Ability { id: \"19C4\", source: \"Sophia\" }\r\n525.4 \"Thunder II\" Ability { id: \"19B0\", source: \"Sophia\" }\r\n535.9 \"Dischordant Cleansing\" # Ability { id: [\"19B3\", \"19B5\"], source: \"Sophia\" }\r\n539.7 \"Gnosis\" Ability { id: \"19C2\", source: \"Barbelo\" } window 30,5\r\n552.2 \"Arms Of Wisdom\" Ability { id: \"19C4\", source: \"Sophia\" }\r\n567.0 \"Quasar Tethers\" Ability { id: \"196E\", source: \"Sophia\" }\r\n568.3 \"Dischordant Cleansing\" # Ability { id: [\"19B3\", \"19B5\"], source: \"Sophia\" }\r\n575.7 \"Quasar (Tilt)\" # Ability { id: \"1A4C\", source: \"Sophia\" }\r\n577.5 \"--clones appear--\" AddedCombatant { name: \"Aion Teleos\" } window 60,5\r\n581.5 \"Cintamani x3\" duration 6 # Ability { id: \"19C5\", source: \"Sophia\" }\r\n592.8 \"Arms Of Wisdom\" Ability { id: \"19C4\", source: \"Sophia\" }\r\n599.9 \"--sync--\" Ability { id: \"19AB\", source: \"Aion Teleos\" } window 10,2.5\r\n599.9 \"Thunder II/III\" Ability { id: [\"19AC\", \"19B0\"], source: \"Sophia\" }\r\n606.1 \"--sync--\" Ability { id: \"19AB\", source: \"Aion Teleos\" }\r\n606.1 \"Aero III\" Ability { id: \"19AE\", source: \"Sophia\" }\r\n611.9 \"Quasar (Snapshot)\" Ability { id: [\"196E\", \"19A7\"], source: \"Sophia\" }\r\n617.9 \"Quasar (Meteor Detonate)\" Ability { id: \"1A87\", source: \"Sophia\" }\r\n624.4 \"Arms Of Wisdom\" Ability { id: \"19C4\", source: \"Sophia\" }\r\n636.6 \"Dischordant Cleansing\" # Ability { id: [\"19B3\", \"19B5\"], source: \"Sophia\" }\r\n639.0 \"Execute\" Ability { id: \"19AA\", source: \"Sophia\" } window 30,30 jump 420.5\r\n\r\n650.9 \"Cintamani x3\"\r\n662.3 \"Arms Of Wisdom\"\r\n668.1 \"Quasar Tethers\"\r\n676.9 \"Quasar (Tilt)\"\r\n679.3 \"Light Dew\"\r\n691.6 \"Thunder III\"\r\n699.9 \"Arms Of Wisdom\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/trial/thordan-ex.ts





const unsafeMap = {
  dirN: 'dirS',
  dirNE: 'dirSW',
  dirE: 'dirW',
  dirSE: 'dirNW',
  dirS: 'dirN',
  dirSW: 'dirNE',
  dirW: 'dirE',
  dirNW: 'dirSE'
};
const fullDirNameMap = {
  dirN: outputs/* default.north */.Z.north,
  dirNE: outputs/* default.northeast */.Z.northeast,
  dirE: outputs/* default.east */.Z.east,
  dirSE: outputs/* default.southeast */.Z.southeast,
  dirS: outputs/* default.south */.Z.south,
  dirSW: outputs/* default.southwest */.Z.southwest,
  dirW: outputs/* default.west */.Z.west,
  dirNW: outputs/* default.northwest */.Z.northwest,
  unknown: outputs/* default.unknown */.Z.unknown
};
const thordan_ex_triggerSet = {
  id: 'TheMinstrelsBalladThordansReign',
  zoneId: zone_id/* default.TheMinstrelsBalladThordansReign */.Z.TheMinstrelsBalladThordansReign,
  timelineFile: 'thordan-ex.txt',
  initData: () => {
    return {
      phase: 1,
      thrustPositions: [],
      seenThrust: false,
      defCounter: 1
    };
  },
  timelineTriggers: [
  // All timeline triggers include a base suppression of 5 seconds
  // to avoid potential noise from timeline jitter.
  {
    id: 'ThordanEX Ascalons Might',
    regex: /Ascalon's Might/,
    beforeSeconds: 4,
    suppressSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    // Puddle positions snapshot well before the actual Heavensflame explosion.
    // BeforeSeconds: 10 is correct, as it ends up being only 5-6 seconds
    // in practice.
    id: 'ThordanEX Heavensflame',
    regex: /Heavensflame 1/,
    beforeSeconds: 10,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.baitPuddles(),
    outputStrings: {
      baitPuddles: {
        en: 'Bait puddles',
        de: 'Flächen Ködern',
        fr: 'Attirez les flaques',
        ja: 'AOE誘導',
        cn: '诱导圈圈',
        ko: '장판 유도'
      }
    }
  }, {
    id: 'ThordanEX Heavenly Slash',
    regex: /Heavenly Slash/,
    beforeSeconds: 4,
    suppressSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'ThordanEX Faith Unmoving',
    regex: /Faith Unmoving/,
    beforeSeconds: 6,
    condition: data => data.phase === 2,
    suppressSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'ThordanEX Dimensional Collapse',
    regex: /Dimensional Collapse/,
    beforeSeconds: 10,
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.baitPuddles(),
    outputStrings: {
      baitPuddles: {
        en: 'Bait gravity puddles',
        de: 'Köder Gravitationsflächen',
        fr: 'Attirez les flaques de gravité',
        ja: '黒AOE誘導',
        cn: '诱导黑圈',
        ko: '검은색 장판 유도'
      }
    }
  }, {
    id: 'ThordanEX Light Of Ascalon',
    regex: /The Light of Ascalon 1/,
    beforeSeconds: 5,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.knockbackAoe(),
    outputStrings: {
      knockbackAoe: {
        en: 'AOE + knockback x7',
        de: 'AoE + Rückstoß x7',
        fr: 'AoE + Poussée x7',
        ja: '全体攻撃 + ノックバック x7',
        cn: 'AOE + 击退 x7',
        ko: '전체공격 + 넉백x7'
      }
    }
  }, {
    id: 'ThordanEX Ultimate End',
    regex: /Ultimate End/,
    beforeSeconds: 6,
    suppressSeconds: 5,
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }],
  triggers: [
  // Phase tracking
  {
    // Cue off Thordan's movement ability alongside him going untargetable
    id: 'ThordanEX Intermission Phase',
    type: 'Ability',
    netRegex: {
      id: '105A',
      source: 'King Thordan',
      capture: false
    },
    run: data => data.phase = 2
  }, {
    // Cue off Knights of the Round
    id: 'ThordanEX Post-Intermission Phase Tracker',
    type: 'Ability',
    netRegex: {
      id: '148C',
      source: 'King Thordan',
      capture: false
    },
    run: data => data.phase += 1
  }, {
    id: 'ThordanEX Main Tank Tracker',
    type: 'Ability',
    netRegex: {
      id: '147D',
      source: 'King Thordan'
    },
    condition: (data, matches) => data.mainTank !== matches.target,
    run: (data, matches) => data.mainTank = matches.target
  }, {
    id: 'ThordanEX Lightning Storm',
    type: 'HeadMarker',
    netRegex: {
      id: '0018'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'ThordanEX Dragons Rage',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'ThordanEX Ancient Quaga',
    type: 'StartsUsing',
    netRegex: {
      id: '1485',
      source: 'King Thordan',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'ThordanEX Heavenly Heel',
    type: 'StartsUsing',
    netRegex: {
      id: '1487',
      source: 'King Thordan'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'ThordanEX Holy Chains',
    type: 'Tether',
    netRegex: {
      id: '0009'
    },
    condition: (data, matches) => data.me === matches.source || data.me === matches.target,
    alertText: (data, matches, output) => {
      const partner = data.me === matches.source ? matches.target : matches.source;
      return output.breakChains({
        partner: data.party.member(partner)
      });
    },
    outputStrings: {
      breakChains: {
        en: 'Break chains with ${partner}',
        de: 'Ketten mit ${partner} zerbrechen',
        fr: 'Cassez les chaînes avec ${partner}',
        ja: '線切り: ${partner}',
        cn: '与 ${partner} 拉断连锁',
        ko: '${partner} 사슬 끊기'
      }
    }
  }, {
    id: 'ThordanEX Conviction',
    type: 'StartsUsing',
    netRegex: {
      id: '149D',
      source: 'Ser Hermenost',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.getTowers */.n3.getTowers()
  }, {
    id: 'ThordanEX Dragons Gaze',
    type: 'StartsUsing',
    netRegex: {
      id: '1489',
      source: 'King Thordan',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.phase === 1) return output.singleGaze();
      return output.doubleGaze();
    },
    outputStrings: {
      singleGaze: {
        en: 'Look away from Thordan',
        de: 'Schau weg von Thordan',
        fr: 'Ne regardez pas Thordan',
        ja: 'ボスを見ないで',
        cn: '背对托尔丹',
        ko: '토르당에게서 뒤돌기'
      },
      doubleGaze: {
        en: 'Look away from Thordan and Eye',
        de: 'Schau weg von Thordan und dem Auge',
        fr: 'Ne regardez pas Thordan ni l\'œil',
        ja: 'ボスと目を見ないで',
        cn: '背对托尔丹和眼睛',
        ko: '토르당과 눈에 대해 뒤돌기'
      }
    }
  }, {
    id: 'ThordanEX Triple Spiral Thrust Collect',
    type: 'Ability',
    netRegex: {
      id: '1018',
      source: ['Ser Ignasse', 'Ser Paulecrain', 'Ser Vellguine']
    },
    // Shared ability from all knights when they teleport in.
    condition: data => data.phase === 2 && !data.seenThrust,
    run: (data, matches) => data.thrustPositions.push(matches)
  }, {
    id: 'ThordanEX Triple Spiral Thrust Call',
    type: 'Ability',
    netRegex: {
      id: '1018',
      source: ['Ser Ignasse', 'Ser Paulecrain', 'Ser Vellguine'],
      capture: false
    },
    // Shared ability from all knights when they teleport in.
    condition: data => data.phase === 2 && !data.seenThrust,
    delaySeconds: 0.5,
    infoText: (data, _matches, output) => {
      if (data.thrustPositions.length !== 3) return;
      let safeDirs = Object.keys(unsafeMap);
      data.thrustPositions.forEach(knight => {
        const knightNum = util/* Directions.hdgTo8DirNum */.N.hdgTo8DirNum(parseFloat(knight.heading));
        const knightDir = util/* Directions.outputFrom8DirNum */.N.outputFrom8DirNum(knightNum);
        const pairedDir = unsafeMap[knightDir];
        safeDirs = safeDirs.filter(dir => dir !== knightDir && dir !== pairedDir);
      });
      if (safeDirs.length !== 2) return;
      const [dir1, dir2] = safeDirs.sort();
      if (dir1 === undefined || dir2 === undefined) return;
      return output.combined({
        dir1: output[dir1](),
        dir2: output[dir2]()
      });
    },
    run: data => {
      data.thrustPositions = [];
      data.seenThrust = true;
    },
    outputStrings: {
      combined: {
        en: '${dir1} / ${dir2} Safe',
        de: '${dir1} / ${dir2} Sicher',
        fr: '${dir1} / ${dir2} Sûr',
        ja: '${dir1} / ${dir2} 安置',
        cn: '${dir1} / ${dir2} 安全',
        ko: '${dir1} / ${dir2} 안전'
      },
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  }, {
    id: 'ThordanEX Sword Of The Heavens',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3B0'
    },
    infoText: (_data, matches, output) => output.attackSword({
      swordKnight: matches.target
    }),
    run: (data, matches) => data.swordKnight = matches.target,
    outputStrings: {
      attackSword: {
        en: 'Attack ${swordKnight}',
        de: 'Greife ${swordKnight} an',
        fr: 'Attaquez ${swordKnight}',
        ja: '攻撃: ${swordKnight}',
        cn: '攻击 ${swordKnight}',
        ko: '${swordKnight} 공격'
      }
    }
  }, {
    id: 'ThordanEX Shield Of The Heavens',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3B1'
    },
    run: (data, matches) => data.shieldKnight = matches.target
  }, {
    id: 'ThordanEX Holiest Of Holy',
    type: 'StartsUsing',
    netRegex: {
      id: '1495',
      source: ['Ser Adelphel', 'Ser Janlenoux'],
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'ThordanEX Holy Bladedance Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '1496',
      source: ['Ser Adelphel', 'Ser Janlenoux']
    },
    run: (data, matches) => {
      if (data.swordKnight === matches.source) data.swordTarget = matches.target;
      if (data.shieldKnight === matches.source) data.shieldTarget = matches.target;
    }
  }, {
    id: 'ThordanEX Holy Bladedance Call',
    type: 'StartsUsing',
    netRegex: {
      id: '1496',
      source: ['Ser Adelphel', 'Ser Janlenoux'],
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      if (data.swordTarget === undefined || data.shieldTarget === undefined) return output.unknownDance();
      const swordTarget = data.party.member(data.swordTarget);
      const shieldTarget = data.party.member(data.shieldTarget);
      if (data.swordTarget === data.shieldTarget) return output.singleDance({
        target: swordTarget
      });
      return output.doubleDance({
        sword: swordTarget,
        shield: shieldTarget
      });
    },
    run: data => {
      delete data.shieldKnight;
      delete data.swordKnight;
      delete data.shieldTarget;
      delete data.swordTarget;
    },
    outputStrings: {
      unknownDance: {
        en: 'Heavy busters',
        de: 'Harter Tankbuster',
        fr: 'Gros busters',
        ja: 'タン強',
        cn: '高伤死刑',
        ko: '탱버'
      },
      singleDance: {
        en: '2x buster on ${target}',
        de: '2x Tankbuster auf ${target}',
        fr: 'Buster x2 sur ${target}',
        ja: '${target} タン強 x2',
        cn: '双死刑点 ${target}',
        ko: '${target} 탱버 x2'
      },
      doubleDance: {
        en: 'Sword buster on ${sword} (shield on ${shield})',
        de: 'Schwert-Tankbuster auf ${sword} (Schild auf ${shield})',
        fr: 'Buster épée sur ${sword} (bouclier sur ${shield})',
        ja: '剣のタン強: ${sword} (盾: ${shield})',
        cn: '剑死刑点 ${sword} (盾死刑点 ${shield})',
        ko: '칼 탱버 ${sword} (방패 ${shield})'
      }
    }
  }, {
    id: 'ThordanEX Skyward Leap',
    type: 'HeadMarker',
    netRegex: {
      id: '000E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (data, _matches, output) => {
      if (data.phase !== 2) return output.defamationNoNumber();
      return output.defamationCounted({
        number: data.defCounter
      });
    },
    run: data => data.defCounter += 1,
    outputStrings: {
      defamationNoNumber: {
        en: 'Defamation on YOU',
        de: 'Große AoE auf YOU',
        fr: 'Diffamation sur VOUS',
        ja: '自分に青サークル',
        cn: '穿天点名',
        ko: '광역 대상자'
      },
      defamationCounted: {
        en: 'Defamation #${number} on YOU',
        de: 'Große AoE #${number} auf DIR',
        fr: 'Diffamation #${number} sur VOUS',
        ja: '自分に青サークル#${number}',
        cn: '穿天 #${number} 点名',
        ko: '광역 #${number} 대상자'
      }
    }
  }, {
    id: 'ThordanEX Spiral Pierce',
    type: 'Tether',
    netRegex: {
      id: '0005'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.pierceYou(),
    outputStrings: {
      pierceYou: {
        en: 'Line AoE on YOU',
        de: 'Linien-AoE auf DIR',
        fr: 'AoE en ligne sur VOUS',
        ja: '自分に直線AOE',
        cn: '直线AOE点名',
        ko: '직선 쉐어 대상자'
      }
    }
  }, {
    id: 'ThordanEX Hiemal Storm',
    type: 'HeadMarker',
    netRegex: {
      id: '001D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.icePuddleYou(),
    outputStrings: {
      icePuddleYou: {
        en: 'Ice puddle on YOU',
        de: 'Eisfläche auf DIR',
        fr: 'Flaque de glace sur VOUS',
        ja: '自分にAOE',
        cn: '冰圈点名',
        ko: '얼음 장판 대상자'
      }
    }
  }, {
    id: 'ThordanEX Comet Puddles',
    type: 'HeadMarker',
    netRegex: {
      id: '000B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.meteorYou(),
    outputStrings: {
      meteorYou: {
        en: '4x meteor puddles on YOU',
        de: '4x Meteorflächen auf DIR',
        fr: '4x Météor sur VOUS',
        ja: '自分に4xメテオ',
        cn: '4连陨石点名',
        ko: '4연속 운석 장판 대상자'
      }
    }
  }, {
    id: 'ThordanEX Fury Spear',
    type: 'HeadMarker',
    netRegex: {
      id: '0010'
    },
    alarmText: (data, matches, output) => {
      // Whoever is actively tanking Thordan must not stack,
      // because they will be taking Heavenly Heel shortly after.
      // If they stack, they will receive the physical vulnerability up and auto-die.
      if (data.me !== data.mainTank) return;
      if (data.me === matches.target) return output.spearYou();
      return output.spearMainTank();
    },
    alertText: (data, matches, output) => {
      if (data.me === data.mainTank) return;
      if (data.me === matches.target) return output.spearYou();
      return output.spearOther({
        spearTarget: matches.target
      });
    },
    outputStrings: {
      spearYou: {
        en: 'Wild Charge on YOU',
        de: 'Ansturm auf DIR',
        fr: 'Charge sauvage sur VOUS',
        ja: '自分に突進',
        cn: '奶枪点名',
        ko: '돌진 대상자'
      },
      spearMainTank: {
        en: 'Wild Charge: STAY OUT',
        de: 'Ansturm: BLEIB DRAUSEN',
        fr: 'Charge sauvage : RESTEZ À L\'EXTÉRIEUR',
        ja: '突進: そのままヘイト取り',
        cn: '奶枪: 保持远离',
        ko: '돌진: 밖으로'
      },
      spearOther: {
        en: 'Wild Charge: Intercept ${spearTarget}',
        de: 'Ansturm: Zwichen ${spearTarget} stehen',
        fr: 'Charge sauvage : Interceptez ${spearTarget}',
        ja: '突進: ${spearTarget}のカバー',
        cn: '奶枪: 挡住 ${spearTarget}',
        ko: '돌진: ${spearTarget} 앞으로'
      }
    }
  }, {
    id: 'ThordanEX Pure Of Soul',
    type: 'StartsUsing',
    netRegex: {
      id: '14B1',
      source: 'Ser Charibert',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'ThordanEX Single Spiral Thrust',
    type: 'Ability',
    netRegex: {
      id: '1018',
      source: 'Ser Vellguine'
    },
    // Shared ability from all knights when they teleport in.
    condition: data => data.phase === 5,
    infoText: (_data, matches, output) => {
      const knightNum = util/* Directions.hdgTo8DirNum */.N.hdgTo8DirNum(parseFloat(matches.heading));
      const knightDir = util/* Directions.outputFrom8DirNum */.N.outputFrom8DirNum(knightNum);
      const [dir1, dir2] = [knightDir, unsafeMap[knightDir]].sort();
      if (dir1 === undefined || dir2 === undefined) return;
      return output.combined({
        dir1: output[dir1](),
        dir2: output[dir2]()
      });
    },
    outputStrings: {
      combined: {
        en: '${dir1} / ${dir2} Unsafe',
        de: '${dir1} / ${dir2} Nicht Sicher',
        fr: '${dir1} / ${dir2} non-sûr',
        ja: '${dir1} / ${dir2} 危険場',
        cn: '${dir1} / ${dir2} 危险',
        ko: '${dir1} / ${dir2} 위험'
      },
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  }, {
    id: 'ThordanEX Faith Unmoving Off Center',
    type: 'Ability',
    netRegex: {
      id: '1018',
      source: 'Ser Grinnaux'
    },
    // Shared ability from all knights when they teleport in.
    condition: data => data.phase === 4,
    delaySeconds: 7,
    // Grinnaux insta-casts Faith Unmoving 13s after appearing. Give ~6s of warning.
    alertText: (_data, matches, output) => {
      const knightX = parseFloat(matches.x);
      const knightY = parseFloat(matches.y);
      const knightDir = util/* Directions.xyTo8DirOutput */.N.xyTo8DirOutput(knightX, knightY, 0, 0);
      return output.knockbackWarn({
        knightDir: output[knightDir]()
      });
    },
    outputStrings: {
      knockbackWarn: {
        en: 'Knockback from ${knightDir}',
        de: 'Rückstoß von ${knightDir}',
        fr: 'Poussée depuis ${knightDir}',
        ja: '${knightDir} ノックバック',
        cn: '${knightDir} 击退',
        ko: '${knightDir} 넉백'
      },
      ...fullDirNameMap
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'The Dragon\'s Gaze/The Dragon\'s Glory': 'The Dragon\'s Gaze/Glory'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Comet Circle': 'Meteoritensiegel',
      'King Thordan': 'Thordan',
      'Meteor Circle': 'Meteorsiegel',
      'Ser Adelphel': 'Adelphel',
      'Ser Charibert': 'Charibert',
      'Ser Grinnaux': 'Grinnaux',
      'Ser Guerrique': 'Guerrique',
      'Ser Haumeric': 'Haumeric',
      'Ser Hermenost': 'Hermenost',
      'Ser Ignasse': 'Ignasse',
      'Ser Janlenoux': 'Janlenoux',
      'Ser Noudenet': 'Noudenet',
      'Ser Paulecrain': 'Paulecrain',
      'Ser Vellguine': 'Vellguine',
      'Ser Zephirin': 'Zephirin'
    },
    'replaceText': {
      '--chains appear--': '--Ketten erscheinen--',
      '--towers spawn--': '--Türme erscheinen--',
      'Absolute Conviction': 'Absolute Konviktion',
      'Ancient Quaga': 'Seisga Antiqua',
      'Ascalon\'s Mercy': 'Gnade von Askalon',
      'Ascalon\'s Might': 'Macht von Askalon',
      'Comet(?! Impact)': 'Komet',
      'Comet Impact': 'Kometeneinschlag',
      '(?<!Absolute )Conviction': 'Konviktion',
      'Dimensional Collapse': 'Dimensionskollaps',
      'Divine Right': 'Göttliches Recht',
      'Faith Unmoving': 'Fester Glaube',
      'Heavenly Heel': 'Himmelsschritt',
      'Heavenly Slash': 'Himmelsschlag',
      'Heavensflame': 'Himmlische Flamme',
      'Heavensward Leap': 'Sprung himmelwärts',
      'Heavy Impact': 'Heftiger Einschlag',
      'Hiemal Storm': 'Hiemaler Sturm',
      'Holiest Of Holy': 'Quell der Heiligkeit',
      'Holy Bladedance': 'Geweihter Schwerttanz',
      'Holy Meteor': 'Heiliger Meteor',
      'Holy Shield Bash': 'Heiliger Schildschlag',
      'Knights Of the Round': 'Ritter der Runde',
      'Lightning Storm': 'Blitzsturm',
      'Meteor Impact': 'Meteoreinschlag',
      'Meteorain': 'Meteorregen',
      'Pure Of Soul': 'Reine Seele',
      'Sacred Cross': 'Heiliges Kreuz',
      'Skyward Leap': 'Luftsprung',
      'Spear Of the Fury': 'Speer der Furie',
      'Spiral Pierce': 'Spiralstich',
      'Spiral Thrust': 'Spiralstoß',
      'The Dragon\'s Gaze': 'Blick des Drachen',
      'The Dragon\'s Glory': 'Ruhm des Drachen',
      'The Light Of Ascalon': 'Licht von Askalon',
      'Ultimate End': 'Ultimatives Ende',
      'the Dragon\'s Eye': 'Auge des Drachen',
      'the Dragon\'s Gaze': 'Blick des Drachen',
      'the Dragon\'s Rage': 'Zorn des Drachen'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Comet Circle': 'sceau de la comète',
      'King Thordan': 'roi Thordan',
      'Meteor Circle': 'sceau du météore',
      'Ser Adelphel': 'sire Adelphel',
      'Ser Charibert': 'sire Charibert',
      'Ser Grinnaux': 'sire Grinnaux',
      'Ser Guerrique': 'sire Guerrique',
      'Ser Haumeric': 'sire Haumeric',
      'Ser Hermenost': 'sire Hermenoist',
      'Ser Ignasse': 'sire Ignassel',
      'Ser Janlenoux': 'sire Janlenoux',
      'Ser Noudenet': 'sire Noudenet',
      'Ser Paulecrain': 'sire Paulecrain',
      'Ser Vellguine': 'sire Vellguine',
      'Ser Zephirin': 'sire Zéphirin'
    },
    'replaceText': {
      '--chains appear--': '--Apparition des chaines--',
      '--towers spawn--': '--Apparition des tours--',
      'Absolute Conviction': 'Conviction absolue',
      'Ancient Quaga': 'Méga Séisme ancien',
      'Ascalon\'s Mercy': 'Grâce d\'Ascalon',
      'Ascalon\'s Might': 'Puissance d\'Ascalon',
      'Comet(?! Impact)': 'Comète',
      'Comet Impact': 'Impact de comète',
      '(?<!Absolute )Conviction': 'Conviction',
      'Dimensional Collapse': 'Effondrement dimensionnel',
      'Divine Right': 'Droit divin',
      'Faith Unmoving': 'Foi immuable',
      'Heavenly Heel': 'Estoc céleste',
      'Heavenly Slash': 'Lacération céleste',
      'Heavensflame': 'Flamme céleste',
      'Heavensward Leap': 'Bond divin',
      'Heavy Impact': 'Impact violent',
      'Hiemal Storm': 'Tempête hiémale',
      'Holiest Of Holy': 'Saint des saints',
      'Holy Bladedance': 'Danse de la lame céleste',
      'Holy Meteor': 'Météore sacré',
      'Holy Shield Bash': 'Coup de bouclier saint',
      'Knights Of the Round': 'Chevaliers de la Table ronde',
      'Lightning Storm': 'Pluie d\'éclairs',
      'Meteor Impact': 'Impact de météore',
      'Meteorain': 'Pluie de météorites',
      'Pure Of Soul': 'Pureté d\'âme',
      'Sacred Cross': 'Croix sacrée',
      'Skyward Leap': 'Bond céleste',
      'Spear Of the Fury': 'Lance de la Conquérante',
      'Spiral Pierce': 'Empalement tournoyant',
      'Spiral Thrust': 'Transpercement tournoyant',
      'The Dragon\'s Gaze': 'Regard du dragon',
      'The Dragon\'s Glory': 'Gloire du dragon',
      'The Light Of Ascalon': 'Lumière d\'Ascalon',
      'Ultimate End': 'Fin ultime',
      'the Dragon\'s Eye': 'Œil du dragon',
      'the Dragon\'s Gaze': 'Regard du dragon',
      'the Dragon\'s Rage': 'Colère du dragon'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Comet Circle': '星片の聖紋',
      'King Thordan': '騎神トールダン',
      'Meteor Circle': '流星の聖紋',
      'Ser Adelphel': '聖騎士アデルフェル',
      'Ser Charibert': '聖騎士シャリベル',
      'Ser Grinnaux': '聖騎士グリノー',
      'Ser Guerrique': '聖騎士ゲリック',
      'Ser Haumeric': '聖騎士オムリク',
      'Ser Hermenost': '聖騎士エルムノスト',
      'Ser Ignasse': '聖騎士イニアセル',
      'Ser Janlenoux': '聖騎士ジャンルヌ',
      'Ser Noudenet': '聖騎士ヌドゥネー',
      'Ser Paulecrain': '聖騎士ポールクラン',
      'Ser Vellguine': '聖騎士ヴェルギーン',
      'Ser Zephirin': '聖騎士ゼフィラン'
    },
    'replaceText': {
      '--chains appear--': '--線連結--',
      '--towers spawn--': '--塔--',
      'Absolute Conviction': 'アブソルートコンヴィクション',
      'Ancient Quaga': 'エンシェントクエイガ',
      'Ascalon\'s Mercy': 'アスカロンメルシー',
      'Ascalon\'s Might': 'アスカロンマイト',
      'Comet(?! Impact)': 'コメット',
      'Comet Impact': 'コメットインパクト',
      '(?<!Absolute )Conviction': 'コンヴィクション',
      'Dimensional Collapse': 'ディメンションクラッシュ',
      'Divine Right': '蒼天の構え',
      'Faith Unmoving': 'フェイスアンムーブ',
      'Heavenly Heel': 'ヘヴンリーヒール',
      'Heavenly Slash': 'ヘヴンリースラッシュ',
      'Heavensflame': 'ヘヴンフレイム',
      'Heavensward Leap': 'ヘヴンスリープ',
      'Heavy Impact': 'ヘヴィインパクト',
      'Hiemal Storm': 'ハイマルストーム',
      'Holiest Of Holy': 'ホリエストホーリー',
      'Holy Bladedance': 'ホーリーブレードダンス',
      'Holy Meteor': 'ホーリーメテオ',
      'Holy Shield Bash': 'ホーリーシールドバッシュ',
      'Knights Of the Round': 'ナイツ・オブ・ラウンド',
      'Lightning Storm': '百雷',
      'Meteor Impact': 'メテオインパクト',
      'Meteorain': 'メテオレイン',
      'Pure Of Soul': 'ピュア・オブ・ソウル',
      'Sacred Cross': 'セイクリッドクロス',
      'Skyward Leap': 'スカイワードリープ',
      'Spear Of the Fury': 'スピア・オブ・ハルオーネ',
      'Spiral Pierce': 'スパイラルピアス',
      'Spiral Thrust': 'スパイラルスラスト',
      'The Dragon\'s Gaze': '竜の邪眼',
      'The Dragon\'s Glory': '邪竜の眼光',
      'The Light Of Ascalon': 'ライト・オブ・アスカロン',
      'Ultimate End': 'アルティメットエンド',
      'the Dragon\'s Eye': '竜の眼',
      'the Dragon\'s Gaze': '竜の邪眼',
      'the Dragon\'s Rage': '邪竜の魔炎'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Comet Circle': '星屑圣纹',
      'King Thordan': '骑神托尔丹',
      'Meteor Circle': '流星圣纹',
      'Ser Adelphel': '圣骑士阿代尔斐尔',
      'Ser Charibert': '圣骑士沙里贝尔',
      'Ser Grinnaux': '圣骑士格里诺',
      'Ser Guerrique': '圣骑士盖里克',
      'Ser Haumeric': '圣骑士奥默里克',
      'Ser Hermenost': '圣骑士埃尔姆诺斯特',
      'Ser Ignasse': '圣骑士伊尼亚斯',
      'Ser Janlenoux': '圣骑士让勒努',
      'Ser Noudenet': '圣骑士努德内',
      'Ser Paulecrain': '圣骑士波勒克兰',
      'Ser Vellguine': '圣骑士韦尔吉纳',
      'Ser Zephirin': '圣骑士泽菲兰'
    },
    'replaceText': {
      '--chains appear--': '--锁链出现--',
      '--towers spawn--': '--塔生成--',
      'Absolute Conviction': '绝对信仰',
      'Ancient Quaga': '古代爆震',
      'Ascalon\'s Mercy': '阿斯卡隆之仁',
      'Ascalon\'s Might': '阿斯卡隆之威',
      'Comet(?! Impact)': '彗星',
      'Comet Impact': '星屑冲击',
      '(?<!Absolute )Conviction': '信仰',
      'Dimensional Collapse': '空间破碎',
      'Divine Right': '苍穹体势',
      'Faith Unmoving': '坚定信仰',
      'Heavenly Heel': '天踵',
      'Heavenly Slash': '天斩',
      'Heavensflame': '天火',
      'Heavensward Leap': '穿越苍穹',
      'Heavy Impact': '沉重冲击',
      'Hiemal Storm': '严冬风暴',
      'Holiest Of Holy': '至圣',
      'Holy Bladedance': '圣光剑舞',
      'Holy Meteor': '陨石圣星',
      'Holy Shield Bash': '圣盾猛击',
      'Knights Of the Round': '圆桌骑士',
      'Lightning Storm': '百雷',
      'Meteor Impact': '陨石冲击',
      'Meteorain': '流星雨',
      'Pure Of Soul': '纯粹灵魂',
      'Sacred Cross': '神圣十字',
      'Skyward Leap': '穿天',
      'Spear Of the Fury': '战女神之枪',
      'Spiral Pierce': '螺旋枪',
      'Spiral Thrust': '螺旋刺',
      'The Dragon\'s Gaze': '龙眼之邪',
      'The Dragon\'s Glory': '邪龙目光',
      'The Light Of Ascalon': '阿斯卡隆之光',
      'Ultimate End': '万物终结',
      'the Dragon\'s Eye': '龙眼之光',
      'the Dragon\'s Gaze': '龙眼之邪',
      'the Dragon\'s Rage': '邪龙魔炎'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Comet Circle': '성스러운 별조각 문양',
      'King Thordan': '기사신 토르당',
      'Meteor Circle': '성스러운 별똥별 문양',
      'Ser Adelphel': '성기사 아델펠',
      'Ser Charibert': '성기사 샤리베르',
      'Ser Grinnaux': '성기사 그리노',
      'Ser Guerrique': '성기사 게리크',
      'Ser Haumeric': '성기사 오메리크',
      'Ser Hermenost': '성기사 에르메노',
      'Ser Ignasse': '성기사 이냐스',
      'Ser Janlenoux': '성기사 장르누',
      'Ser Noudenet': '성기사 누데네',
      'Ser Paulecrain': '성기사 폴르크랭',
      'Ser Vellguine': '성기사 벨긴',
      'Ser Zephirin': '성기사 제피랭'
    },
    'replaceText': {
      '--chains appear--': '--사슬 연결--',
      '--towers spawn--': '--기둥 등장--',
      'Absolute Conviction': '절대적 신념',
      'Ancient Quaga': '에인션트 퀘이가',
      'Ascalon\'s Mercy': '아스칼론의 자비',
      'Ascalon\'s Might': '아스칼론의 권능',
      'Comet(?! Impact)': '혜성',
      'Comet Impact': '혜성 낙하',
      '(?<!Absolute )Conviction': '신념',
      'Dimensional Collapse': '차원 파괴',
      'Divine Right': '창천 태세',
      'Faith Unmoving': '굳건한 신앙',
      'Heavenly Heel': '천상의 발꿈치',
      'Heavenly Slash': '천상의 참격',
      'Heavensflame': '천상의 불꽃',
      'Heavensward Leap': '천상의 도약',
      'Heavy Impact': '무거운 충격',
      'Hiemal Storm': '동장군 폭풍',
      'Holiest Of Holy': '지고한 신성',
      'Holy Bladedance': '신성한 검무',
      'Holy Meteor': '홀리 메테오',
      'Holy Shield Bash': '성스러운 방패 강타',
      'Knights Of the Round': '나이츠 오브 라운드',
      'Lightning Storm': '백뢰',
      'Meteor Impact': '운석 낙하',
      'Meteorain': '메테오 레인',
      'Pure Of Soul': '영혼의 순수',
      'Sacred Cross': '거룩한 십자가',
      'Skyward Leap': '공중 도약',
      'Spear Of the Fury': '할로네의 창',
      'Spiral Pierce': '나선 관통',
      'Spiral Thrust': '나선 찌르기',
      'The Dragon\'s Gaze': '용의 마안',
      'The Dragon\'s Glory': '사룡의 눈빛',
      'The Light Of Ascalon': '아스칼론의 광휘',
      'Ultimate End': '궁극의 종말',
      'the Dragon\'s Eye': '용의 눈',
      'the Dragon\'s Gaze': '용의 마안',
      'the Dragon\'s Rage': '사룡의 마염'
    }
  }]
};
/* harmony default export */ const thordan_ex = (thordan_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/trial/thordan-ex.txt
const trial_thordan_ex_namespaceObject = "### THE MINSTREL'S BALLAD: THORDAN'S REIGN\r\n# ZoneId: 1\r\n\r\n# -ii 1019 1480 149F\r\n# -it \"King Thordan\" \"Ser Janlenoux\"\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Phase 1. Pushes at 70% HP?\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n5.0 \"Ascalon's Might\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n14.8 \"Meteorain\" Ability { id: \"1483\", source: \"King Thordan\" }\r\n15.1 \"--sync--\" Ability { id: \"1484\", source: \"King Thordan\" } # Meteorain\r\n20.0 \"--sync--\" Ability { id: \"147F\", source: \"King Thordan\" }\r\n20.0 \"Ascalon's Mercy\" Ability { id: \"1480\", source: \"King Thordan\" }\r\n22.1 \"Ascalon's Might\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n27.2 \"the Dragon's Eye\" Ability { id: \"1488\", source: \"King Thordan\" }\r\n37.3 \"the Dragon's Gaze\" Ability { id: \"1489\", source: \"King Thordan\" }\r\n42.4 \"Ascalon's Might\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n51.1 \"Lightning Storm\" Ability { id: \"1481\", source: \"King Thordan\" }\r\n51.5 \"--sync--\" Ability { id: \"1482\", source: \"King Thordan\" } # Lightning Storm\r\n58.2 \"the Dragon's Rage\" Ability { id: \"148B\", source: \"King Thordan\" }\r\n63.3 \"Ancient Quaga\" Ability { id: \"1485\", source: \"King Thordan\" }\r\n69.4 \"Ascalon's Might\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n75.4 \"Heavenly Heel\" Ability { id: \"1487\", source: \"King Thordan\" }\r\n77.5 \"Ascalon's Might\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n79.6 \"--untargetable--\"\r\n\r\n# Phase 2\r\n# Intermission part 1\r\n82.4 \"--sync--\" Ability { id: \"105A\", source: \"King Thordan\" } window 82.4,10\r\n91.4 \"--sync--\" Ability { id: \"1018\", source: \"Ser Charibert\" }\r\n93.4 \"--sync--\" Ability { id: \"1018\", source: \"Ser Hermenost\" }\r\n95.7 \"--chains appear--\"\r\n98.0 \"--sync--\" Ability { id: \"14AB\", source: \"Ser Charibert\" } window 10,10 # Heavensflame cast\r\n98.4 \"Heavensflame 1\" #Ability { id: \"14AC\", source: \"Ser Charibert\" }\r\n99.4 \"Heavensflame 2\" #Ability { id: \"14AC\", source: \"Ser Charibert\" }\r\n99.4 \"--towers spawn--\"\r\n100.4 \"Heavensflame 3\" #Ability { id: \"14AC\", source: \"Ser Charibert\" }\r\n101.4 \"Heavensflame 4\" #Ability { id: \"14AC\", source: \"Ser Charibert\" }\r\n101.5 \"--sync--\" Ability { id: \"149C\", source: \"Ser Hermenost\" } # Conviction (model animation, no actual snapshot)\r\n104.3 \"Conviction\" Ability { id: \"149D\", source: \"Ser Hermenost\" }\r\n107.4 \"Sacred Cross\" StartsUsing { id: \"1490\", source: \"Ser Zephirin\" } duration 19.7\r\n127.1 \"--sync--\" Ability { id: \"1490\", source: \"Ser Zephirin\" }\r\n133.1 \"Spiral Thrust\" Ability { id: \"14A6\", source: [\"Ser Ignasse\", \"Ser Paulecrain\", \"Ser Vellguine\"] }\r\n\r\n# Intermission part 2\r\n# This loops until both Adelphel and Janlenoux are dead.\r\n# 3x Skyward Leaps happen during this loop,\r\n# but the other knights hold their mechanics until after both are dead.\r\n\r\n# Adelphel and Janlenoux's shared mechanics can be offset by 0.1 seconds,\r\n# but it's more important that we sync during the loop,\r\n# so we accept a small amount of jumpiness in the timeline.\r\n140.2 \"--targetable--\"\r\n150.2 \"Divine Right\" Ability { id: \"1493\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n159.3 \"Holy Bladedance\" Ability { id: \"1496\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n175.3 \"Skyward Leap 1\" Ability { id: \"14A9\", source: \"Ser Vellguine\" }\r\n177.3 \"Divine Right\" Ability { id: \"1493\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n178.3 \"Skyward Leap 2\" Ability { id: \"14A9\", source: \"Ser Paulecrain\" }\r\n179.4 \"Heavenly Slash\" Ability { id: \"1494\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n181.3 \"Skyward Leap 3\" Ability { id: \"14A9\", source: \"Ser Ignasse\" }\r\n192.4 \"Holiest Of Holy\" Ability { id: \"1495\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n198.5 \"Holy Bladedance\" Ability { id: \"1496\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n205.6 \"Divine Right\" Ability { id: \"1493\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n212.7 \"Holiest Of Holy\" Ability { id: \"1495\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n216.8 \"Heavenly Slash\" Ability { id: \"1494\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n\r\n232.9 \"Divine Right\" Ability { id: \"1493\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n242.0 \"Holy Bladedance\" Ability { id: \"1496\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n260.0 \"Divine Right\" Ability { id: \"1493\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n262.1 \"Heavenly Slash\" Ability { id: \"1494\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n275.2 \"Holiest Of Holy\" Ability { id: \"1495\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n281.3 \"Holy Bladedance\" Ability { id: \"1496\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n288.3 \"Divine Right\" Ability { id: \"1493\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n295.4 \"Holiest Of Holy\" Ability { id: \"1495\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n299.5 \"Heavenly Slash\" Ability { id: \"1494\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] } forcejump 216.8\r\n\r\n\r\n# Intermission part 3\r\n350.0 \"--sync--\" Ability { id: \"1018\", source: \"Ser Paulecrain\" } window 150,10\r\n352.0 \"--sync--\" Ability { id: \"1018\", source: \"Ser Grinnaux\" } window 150,10\r\n353.0 \"--sync--\" Ability { id: \"1018\", source: \"Ser Haumeric\" } window 150,10\r\n359.6 \"Hiemal Storm\" Ability { id: \"14AE\", source: \"Ser Haumeric\" } window 328,10\r\n359.8 \"--sync--\" Ability { id: \"14AF\", source: [\"Ser Haumeric\", \"Ser Noudenet\"] } # Hiemal Storm\r\n360.2 \"Spiral Pierce\" Ability { id: \"14A7\", source: [\"Ser Ignasse\", \"Ser Paulecrain\", \"Ser Vellguine\"] }\r\n361.5 \"Dimensional Collapse\" Ability { id: \"1499\", source: \"Ser Grinnaux\" }\r\n361.9 \"--sync--\" Ability { id: \"149A\", source: \"Ser Grinnaux\" } # Dimensional Collapse\r\n365.0 \"Faith Unmoving\" Ability { id: \"149B\", source: \"Ser Grinnaux\" }\r\n\r\n# Intermission part 4\r\n# Two sets of four Heavy Impacts used during this intermission.\r\n# They overlap heavily. Because they use different IDs for each ring,\r\n# it's safe to leave them all synced.\r\n366.0 \"Holy Meteor\" Ability { id: \"14B0\", source: \"Ser Noudenet\" } window 220,10\r\n374.6 \"Heavy Impact Set 1\" Ability { id: \"149F\", source: \"Ser Guerrique\" } duration 10\r\n376.0 \"Comet x4\" duration 4 #Ability { id: \"14B5\", source: \"Ser Noudenet\" }\r\n379.9 \"Heavy Impact Set 2\" Ability { id: \"149F\", source: \"Ser Guerrique\" } duration 10\r\n383.8 \"Comet x4\" duration 4 #Ability { id: \"14B5\", source: \"Ser Noudenet\" }\r\n398.1 \"Comet Impact\" Ability { id: \"14B3\", source: \"Comet Circle\" }\r\n420.7 \"Meteor Impact Enrage\" Ability { id: \"14B4\", source: \"Meteor Circle\" }\r\n\r\n\r\n427.0 \"--sync--\" Ability { id: \"105B\", source: \"King Thordan\" } window 260,10\r\n437.7 \"The Light Of Ascalon 1\" #Ability { id: \"148F\", source: \"Ascalon\" }\r\n439.1 \"The Light Of Ascalon 2\" #Ability { id: \"148F\", source: \"Ascalon\" }\r\n440.5 \"The Light Of Ascalon 3\" #Ability { id: \"148F\", source: \"Ascalon\" }\r\n441.9 \"The Light Of Ascalon 4\" #Ability { id: \"148F\", source: \"Ascalon\" }\r\n443.3 \"The Light Of Ascalon 5\" #Ability { id: \"148F\", source: \"Ascalon\" }\r\n444.7 \"The Light Of Ascalon 6\" #Ability { id: \"148F\", source: \"Ascalon\" }\r\n446.1 \"The Light Of Ascalon 7\" #Ability { id: \"148F\", source: \"Ascalon\" }\r\n447.2 \"--sync--\" Ability { id: \"148D\", source: \"King Thordan\" } # Ultimate End wind-up\r\n451.8 \"--sync--\" Ability { id: \"1059\" } # All the knights use this unknown attack here\r\n455.8 \"Ultimate End\" Ability { id: \"148E\", source: \"King Thordan\" }\r\n460.3 \"--targetable--\"\r\n\r\n# Phase 3\r\n# Save the [healer]!\r\n466.4 \"the Dragon's Eye\" Ability { id: \"1488\", source: \"King Thordan\" }\r\n476.6 \"Knights Of the Round\" Ability { id: \"148C\", source: \"King Thordan\" }\r\n481.7 \"Ascalon's Might\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n488.1 \"Holy Shield Bash\" Ability { id: \"1497\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n497.1 \"Spear Of the Fury\" Ability { id: \"1492\", source: \"Ser Zephirin\" } # A smile better suits a hero\r\n499.5 \"Heavenly Heel\" Ability { id: \"1487\", source: \"King Thordan\" }\r\n504.6 \"The Dragon's Gaze/The Dragon's Glory\" Ability { id: [\"1489\", \"148A\"], source: \"King Thordan\" }\r\n516.6 \"Ancient Quaga\" Ability { id: \"1485\", source: \"King Thordan\" }\r\n\r\n#Phase 4\r\n# Conviction Trio\r\n521.8 \"the Dragon's Eye\" Ability { id: \"1488\", source: \"King Thordan\" }\r\n532.0 \"Knights Of the Round\" Ability { id: \"148C\", source: \"King Thordan\" }\r\n543.1 \"The Dragon's Gaze/The Dragon's Glory\" Ability { id: [\"1489\", \"148A\"], source: \"King Thordan\" }\r\n543.2 \"Conviction\" Ability { id: \"149C\", source: \"Ser Hermenost\" }\r\n544.1 \"Heavy Impact 1\" Ability { id: \"14A0\", source: \"Ser Guerrique\" }\r\n546.0 \"Conviction\" Ability { id: \"149D\", source: \"Ser Hermenost\" }\r\n546.0 \"Heavy Impact 2\" Ability { id: \"14A1\", source: \"Ser Guerrique\" }\r\n548.0 \"Heavy Impact 3\" Ability { id: \"14A2\", source: \"Ser Guerrique\" }\r\n550.0 \"Heavy Impact 4\" Ability { id: \"14A3\", source: \"Ser Guerrique\" }\r\n552.4 \"Dimensional Collapse\" Ability { id: \"1499\", source: \"Ser Grinnaux\" }\r\n552.8 \"--sync--\" Ability { id: \"149A\", source: \"Ser Grinnaux\" } # Dimensional Collapse\r\n555.9 \"Faith Unmoving\" Ability { id: \"149B\", source: \"Ser Grinnaux\" }\r\n557.9 \"the Dragon's Rage\" Ability { id: \"148B\", source: \"King Thordan\" }\r\n563.0 \"Ascalon's Might\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n\r\n# Phase 5\r\n# Spiral Sky Trio\r\n572.1 \"the Dragon's Eye\" Ability { id: \"1488\", source: \"King Thordan\" }\r\n582.2 \"Knights Of the Round\" Ability { id: \"148C\", source: \"King Thordan\" }\r\n588.9 \"Lightning Storm\" Ability { id: \"1481\", source: \"King Thordan\" }\r\n589.3 \"--sync--\" Ability { id: \"1482\", source: \"King Thordan\" }# Lightning Storm\r\n597.3 \"Spiral Thrust\" Ability { id: \"14A6\", source: \"Ser Vellguine\" }\r\n597.3 \"Spiral Pierce\" Ability { id: \"14A7\", source: \"Ser Paulecrain\" }\r\n597.5 \"Skyward Leap\" Ability { id: \"14A9\", source: \"Ser Ignasse\" }\r\n598.9 \"the Dragon's Rage\" Ability { id: \"148B\", source: \"King Thordan\" }\r\n609.9 \"Heavenly Heel\" Ability { id: \"1487\", source: \"King Thordan\" }\r\n612.0 \"Ascalon's Might\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n\r\n# Phase 6\r\n# Meteor Trio\r\n622.1 \"the Dragon's Eye\" Ability { id: \"1488\", source: \"King Thordan\" }\r\n632.3 \"Knights Of the Round\" Ability { id: \"148C\", source: \"King Thordan\" }\r\n638.4 \"Ascalon's Might\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n641.5 \"--chains appear--\"\r\n642.4 \"Holy Meteor\" Ability { id: \"14B0\", source: \"Ser Noudenet\" }\r\n643.5 \"Comet x4\" duration 4 #Ability { id: \"14B5\", source: \"Ser Noudenet\" }\r\n643.5 \"The Dragon's Gaze/The Dragon's Glory\" Ability { id: [\"1489\", \"148A\"], source: \"King Thordan\" }\r\n643.8 \"--sync--\" Ability { id: \"14AB\", source: \"Ser Charibert\" } # Heavensflame (cast)\r\n644.2 \"Heavensflame 1\" #Ability { id: \"14AC\", source: \"Ser Charibert\" }\r\n645.3 \"Heavensflame 2\" #Ability { id: \"14AC\", source: \"Ser Charibert\" }\r\n646.4 \"Heavensflame 3\" #Ability { id: \"14AC\", source: \"Ser Charibert\" }\r\n646.8 \"Hiemal Storm\" Ability { id: \"14AE\", source: \"Ser Haumeric\" }\r\n647.4 \"--sync--\" Ability { id: \"14AF\", source: [\"Ser Haumeric\", \"Ser Noudenet\"] } # Hiemal Storm\r\n648.7 \"Ascalon's Mercy\" Ability { id: \"147F\", source: \"King Thordan\" }\r\n656.8 \"Ancient Quaga\" Ability { id: \"1485\", source: \"King Thordan\" }\r\n662.9 \"Heavenly Heel\" Ability { id: \"1487\", source: \"King Thordan\" }\r\n668.0 \"Ancient Quaga\" Ability { id: \"1485\", source: \"King Thordan\" }\r\n\r\n# Phase 7 -- zomg SO MUCH AOE DAMAGE\r\n# Heavensward Trio\r\n673.1 \"the Dragon's Eye\" Ability { id: \"1488\", source: \"King Thordan\" }\r\n683.3 \"Knights Of the Round\" Ability { id: \"148C\", source: \"King Thordan\" }\r\n688.4 \"Ascalon's Might\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n693.4 \"Holiest Of Holy\" Ability { id: \"1495\", source: \"Ser Janlenoux\" }\r\n698.5 \"Ascalon's Might\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n704.6 \"Heavensward Leap 1\" Ability { id: \"14AA\", source: \"Ser Vellguine\" }\r\n707.6 \"Heavensward Leap 2\" Ability { id: \"14AA\", source: \"Ser Paulecrain\" }\r\n710.6 \"Heavensward Leap 3\" Ability { id: \"14AA\", source: \"Ser Ignasse\" }\r\n718.7 \"Sacred Cross\" StartsUsing { id: \"1491\", source: \"Ser Zephirin\" } duration 24.7\r\n724.6 \"Pure Of Soul\" Ability { id: [\"14B1\", \"14B2\"], source: [\"Ser Charibert\", \"Ser Noudenet\", \"Ser Haumeric\"] }\r\n732.6 \"Absolute Conviction 1\" Ability { id: \"14A4\", source: \"Ser Guerrique\" }\r\n735.5 \"Absolute Conviction 2\" Ability { id: \"14A5\", source: \"Ser Hermenost\" }\r\n740.6 \"The Dragon's Gaze/The Dragon's Glory\" Ability { id: [\"1489\", \"148A\"], source: \"King Thordan\" }\r\n743.4 \"--sync--\" Ability { id: \"1491\", source: \"Ser Zephirin\" } # Sacred Cross resolves\r\n750.7 \"Ancient Quaga\" Ability { id: \"1485\", source: \"King Thordan\" }\r\n\r\n# Enrage sequence\r\n759.8 \"Heavenly Heel\" Ability { id: \"1487\", source: \"King Thordan\" }\r\n761.9 \"Ascalon's Might 1\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n767.0 \"Ascalon's Might 2\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n770.1 \"Ascalon's Might 3\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n773.2 \"Ascalon's Might 4\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n776.3 \"Ascalon's Might 5\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n779.4 \"Ascalon's Might 6\" Ability { id: \"147E\", source: \"King Thordan\" }\r\n791.4 \"Ancient Quaga\" Ability { id: \"1486\", source: \"King Thordan\" }\r\n\r\n# IGNORED ABILITIES\r\n# 1018 --sync--\r\n# 1019 --sync--\r\n# 1480 Ascalon's Mercy\r\n# 149E Eternal Conviction\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 366 attack\r\n# 1018 --sync--\r\n# 1019 --sync--\r\n# 1059 --sync--\r\n# 105A --sync--\r\n# 105B --sync--\r\n# 147D attack\r\n# 147E Ascalon's Might\r\n# 147F Ascalon's Mercy\r\n# 1480 Ascalon's Mercy\r\n# 1481 Lightning Storm\r\n# 1482 Lightning Storm\r\n# 1483 Meteorain\r\n# 1484 Meteorain\r\n# 1485 Ancient Quaga\r\n# 1486 Ancient Quaga\r\n# 1487 Heavenly Heel\r\n# 1488 the Dragon's Eye\r\n# 1489 the Dragon's Gaze\r\n# 148A the Dragon's Glory\r\n# 148B the Dragon's Rage\r\n# 148C Knights Of the Round\r\n# 148D Ultimate End\r\n# 148E Ultimate End\r\n# 148F the Light Of Ascalon\r\n# 1490 Sacred Cross\r\n# 1491 Sacred Cross\r\n# 1492 Spear Of the Fury\r\n# 1493 Divine Right\r\n# 1494 Heavenly Slash\r\n# 1495 Holiest Of Holy\r\n# 1496 Holy Bladedance\r\n# 1497 Holy Shield Bash\r\n# 1499 Dimensional Collapse\r\n# 149A Dimensional Collapse\r\n# 149B Faith Unmoving\r\n# 149C Conviction\r\n# 149D Conviction\r\n# 149E Eternal Conviction\r\n# 149F Heavy Impact\r\n# 14A0 Heavy Impact\r\n# 14A1 Heavy Impact\r\n# 14A2 Heavy Impact\r\n# 14A3 Heavy Impact\r\n# 14A4 Absolute Conviction\r\n# 14A5 Absolute Conviction\r\n# 14A6 Spiral Thrust\r\n# 14A7 Spiral Pierce\r\n# 14A9 Skyward Leap\r\n# 14AA Heavensward Leap\r\n# 14AB Heavensflame\r\n# 14AC Heavensflame\r\n# 14AE Hiemal Storm\r\n# 14AF Hiemal Storm\r\n# 14B0 Holy Meteor\r\n# 14B1 Pure Of Soul\r\n# 14B2 Pure Of Soul\r\n# 14B3 Comet Impact\r\n# 14B4 Meteor Impact\r\n# 14B5 Comet\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/trial/zurvan-ex.ts




const zurvan_ex_triggerSet = {
  id: 'ContainmentBayZ1T9Extreme',
  zoneId: zone_id/* default.ContainmentBayZ1T9Extreme */.Z.ContainmentBayZ1T9Extreme,
  timelineFile: 'zurvan-ex.txt',
  initData: () => {
    return {
      isPhaseOne: true
    };
  },
  timelineTriggers: [{
    id: 'ZurvanEX Metal Cutter',
    regex: /Metal Cutter/,
    beforeSeconds: 4,
    suppressSeconds: data => data.isPhaseOne === true ? 10 : 16,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'ZurvanEX Phase Tracker',
    type: 'Ability',
    netRegex: {
      id: '1C50',
      source: 'Zurvan',
      capture: false
    },
    run: data => data.isPhaseOne = false
  }, {
    id: 'ZurvanEX Wave Cannon Avoid',
    type: 'HeadMarker',
    netRegex: {
      id: '000E'
    },
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) return output.waveCannonTarget();
    },
    alertText: (data, matches, output) => {
      if (!(data.me === matches.target)) return output.avoidWaveCannon({
        target: data.party.member(matches.target)
      });
    },
    outputStrings: {
      waveCannonTarget: {
        en: 'Wave Cannon on YOU',
        de: 'Wellenkanone auf DIR',
        fr: 'Canon plasma sur VOUS',
        ja: '波動砲対象',
        cn: '波动炮点名',
        ko: '파동포 대상자'
      },
      avoidWaveCannon: {
        en: 'Away from ${target} -- Wave Cannon',
        de: 'Weg von ${target} -- Wellenkanone',
        fr: 'Éloignez-vous de ${target} -- Canon plasma',
        ja: '${target} から離れる -- 波動砲',
        cn: '远离 ${target} -- 波动炮',
        ko: '${target} 피하기 -- 파동포'
      }
    }
  }, {
    id: 'ZurvanEX Wave Cannon Stack',
    // Zurvan targets himself with this attack
    type: 'StartsUsing',
    netRegex: {
      id: '1C72',
      source: 'Zurvan',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data?.waveTarget === data.me)
        // The target is stunned during this mechanic
        return;
      if (data.waveTarget === undefined) return output.unknownStackTarget();
      return output.stackOn({
        player: data.party.member(data.waveTarget)
      });
    },
    outputStrings: {
      unknownStackTarget: outputs/* default.stackMarker */.Z.stackMarker,
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'ZurvanEX Wave Cannon Stack Cleanup',
    type: 'Ability',
    netRegex: {
      id: '1C72',
      source: 'Zurvan',
      capture: false
    },
    run: data => delete data.waveTarget
  }, {
    id: 'ZurvanEX Demon Claw',
    type: 'StartsUsing',
    netRegex: {
      id: '1C71',
      source: 'Zurvan'
    },
    preRun: (data, matches) => data.waveTarget ??= matches.target,
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.demonClawYou();
    },
    outputStrings: {
      demonClawYou: {
        en: 'Knockback from boss on YOU',
        de: 'Rückstoß vom Boss auf DIR',
        fr: 'Poussée depuis le boss sur VOUS',
        ja: 'デモンクロー ノックバック対象',
        cn: 'BOSS击退点名',
        ko: '넉백공격 대상자'
      }
    }
  }, {
    id: 'ZurvanEX Flaming Halberd',
    type: 'HeadMarker',
    netRegex: {
      id: '002C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 1,
    // Don't spam people who run this solo.
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'ZurvanEX Demonic Dive',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    delaySeconds: 1,
    alertText: (data, matches, output) => {
      if (data?.flameTarget === data.me) return;
      if (matches.target === data.me) return output.stackYou();
      return output.stackOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      stackYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'ZurvanEX Cool Flame Call',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: (data, matches) => data.flameTarget ??= matches.target,
    alertText: (_data, _matches, output) => output.demonicSpread(),
    outputStrings: {
      demonicSpread: {
        en: 'Spread -- Don\'t stack!',
        de: 'Verteilen -- Nicht aufeinander!',
        fr: 'Écartez-vous - Ne vous packez pas !',
        ja: '散開 -- 重ならないで！',
        cn: '分散 -- 不要集合!',
        ko: '산개 -- 쉐어맞으면 안됨!'
      }
    }
  }, {
    id: 'ZurvanEX Cool Flame Cleanup',
    type: 'Ability',
    netRegex: {
      id: '1C56',
      source: 'Zurvan',
      capture: false
    },
    run: data => delete data.flameTarget
  }, {
    id: 'ZurvanEX Biting Halberd',
    type: 'StartsUsing',
    netRegex: {
      id: '1C59',
      source: 'Zurvan',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'ZurvanEX Tail End',
    type: 'StartsUsing',
    netRegex: {
      id: '1C5A',
      source: 'Zurvan',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'ZurvanEX Ciclicle',
    type: 'StartsUsing',
    netRegex: {
      id: '1C5B',
      source: 'Zurvan',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'ZurvanEX Ice And Fire',
    type: 'Ability',
    netRegex: {
      id: '1C58',
      source: 'Zurvan',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stay outside hitbox',
        de: 'Auserhalb der Hitbox stehen',
        fr: 'Restez à l\'extérieur de la hitbox',
        ja: '範囲攻撃を避ける',
        cn: '站在判定圈外',
        ko: '히트박스 밖으로'
      }
    }
  }, {
    id: 'ZurvanEX Meracydian Fear',
    type: 'StartsUsing',
    netRegex: {
      id: '1E36',
      source: 'Execrated Wile'
    },
    response: responses/* Responses.lookAwayFromSource */.n3.lookAwayFromSource()
  }, {
    id: 'ZurvanEX Tyrfing',
    type: 'StartsUsing',
    netRegex: {
      id: '1C6D',
      source: 'Zurvan'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave() // Tyrfing doesn't cleave, but the Fire III follow-up does
  }, {
    id: 'ZurvanEX Southern Cross Stack',
    type: 'StartsUsing',
    netRegex: {
      id: '1C5C',
      source: 'Zurvan',
      capture: false
    },
    suppressSeconds: 1,
    alarmText: (_data, _matches, output) => output.baitSouthernCross(),
    outputStrings: {
      baitSouthernCross: {
        en: 'Bait Ice Puddles',
        de: 'Eisflächen ködern',
        fr: 'Bait les puddles de glace',
        ja: '氷範囲を捨てる',
        cn: '诱导冰圈',
        ko: '얼음장판 유도'
      }
    }
  }, {
    id: 'ZurvanEX Southern Cross Move',
    type: 'StartsUsing',
    netRegex: {
      id: '1C5D',
      source: 'Zurvan',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'ZurvanEX Infinite Tethers',
    type: 'Tether',
    netRegex: {
      id: ['0005', '0008']
    },
    condition: (data, matches) => [matches.source, matches.target].includes(data.me),
    preRun: (data, matches) => {
      const buddy = data.me === matches.source ? matches.target : matches.source;
      data.tetherBuddy ??= buddy;
    },
    alertText: (data, _matches, output) => {
      return output.tetherBuddy({
        buddy: data.party.member(data.tetherBuddy)
      });
    },
    outputStrings: {
      tetherBuddy: {
        en: 'Tethered with ${buddy}',
        de: 'Mit ${buddy} verbunden',
        fr: 'Lié avec ${buddy}',
        ja: '${buddy} とペア',
        cn: '与 ${buddy} 连线',
        ko: '선 연결 ${buddy}'
      }
    }
  }, {
    // 477 is Infinite Fire, 478 is Infinite Ice
    id: 'ZurvanEX Infinite Debuffs',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['477', '478']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: (data, matches) => {
      const element = matches.effectId === '477' ? 'fire' : 'ice';
      data.infiniteElement ??= element;
    },
    delaySeconds: 2,
    // Don't overlap the tether buddy call
    infoText: (data, _matches, output) => {
      let element = output.unknown();
      if (data.infiniteElement === 'fire') element = output.fire();
      if (data.infiniteElement === 'ice') element = output.ice();
      return output.infiniteDebuff({
        element: element
      });
    },
    outputStrings: {
      infiniteDebuff: {
        en: '${element} on you',
        de: '${element} auf dir',
        fr: '${element} sur vous',
        ja: '${element} 付与',
        cn: '${element} 点名',
        ko: '${element}'
      },
      fire: {
        en: 'Fire',
        de: 'Feuer',
        fr: 'Feu',
        ja: '炎',
        cn: '火',
        ko: '불'
      },
      ice: {
        en: 'Ice',
        de: 'Eis',
        fr: 'Glace',
        ja: '氷',
        cn: '冰',
        ko: '얼음'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'ZurvanEX Broken Seal',
    type: 'StartsUsing',
    netRegex: {
      id: '1DC7',
      source: 'Zurvan',
      capture: false
    },
    alertText: (data, _matches, output) => {
      let element = output.unknown();
      if (data.infiniteElement === 'fire') element = output.fire();
      if (data.infiniteElement === 'ice') element = output.ice();
      const buddy = data.tetherBuddy;
      return output.sealTowers({
        element: element,
        buddy: data.party.member(buddy)
      });
    },
    outputStrings: {
      sealTowers: {
        en: '${element} towers with ${buddy}',
        de: '${element} Türme mit ${buddy}',
        fr: 'Tour de ${element} avec ${buddy}',
        ja: '${buddy} と ${element} の塔に入る',
        cn: '与${buddy}踩${element}塔',
        ko: '${element} 기둥 +${buddy}'
      },
      fire: {
        en: 'Fire',
        de: 'Feuer',
        fr: 'Feu',
        ja: '炎',
        cn: '火',
        ko: '불'
      },
      ice: {
        en: 'Ice',
        de: 'Eis',
        fr: 'Glace',
        ja: '氷',
        cn: '冰',
        ko: '얼음'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'ZurvanEX Seal Cleanup',
    type: 'Ability',
    netRegex: {
      id: '1DC7',
      source: 'Zurvan',
      capture: false
    },
    run: data => {
      delete data.tetherBuddy;
      delete data.infiniteElement;
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Execrated Wile': 'verflucht(?:e|er|es|en) List',
      'Zurvan': 'Zurvan'
    },
    'replaceText': {
      '\\(circles\\)': '(Kreise)',
      '\\(explosion\\)': '(Explosion)',
      '\\(puddle\\)': '(Fläche)',
      '\\(snapshot\\)': '(Speichern)',
      '\\(avoid\\)': '(Vermeiden)',
      '\\(stack\\)': '(Sammeln)',
      'Ahura Mazda': 'Ahura Mazda',
      'Biting Halberd': 'Beißende Hellebarde',
      'Broken Seal': 'Endloses Siegel',
      'Ciclicle': 'Cyclotit',
      'Cool Flame': 'Kühle Flamme',
      'Demonic Dive': 'Dämonenschwung',
      'Fire III': 'Feuga',
      'Flaming Halberd': 'Flammenhellebarde',
      'Flare Star': 'Flare-Stern',
      'Ice and Fire': 'Eis und Feuer',
      'Infinite Fire': 'Endloses Feuer',
      'Infinite Ice': 'Endloses Eis',
      'Metal Cutter': 'Metallschneider',
      'Sarva': 'Sarva',
      'Soar': 'Auffliegen',
      'Southern Cross': 'Kreuz des Südens',
      'Tail End': 'Schweifspitze',
      'The Demon\'s Claw': 'Klaue des Dämonen',
      'Twin Spirit': 'Zwiegeist',
      'Tyrfing': 'Tyrfing',
      'Wave Cannon': 'Wellenkanone',
      'the Purge': 'Läuterung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Execrated Wile': 'ruse honnie',
      'Zurvan': 'Zurvan'
    },
    'replaceText': {
      '\\(circles\\)': '(Cerles)',
      '\\(explosion\\)': '(Explosion)',
      '\\(puddle\\)': '(Puddle)',
      '\\(snapshot\\)': '(Copie)',
      '\\(avoid\\)': '(Évitez)',
      '\\(stack\\)': '(Package)',
      'Ahura Mazda': 'Ahura Mazda',
      'Biting Halberd': 'Hallebarde mordante',
      'Broken Seal': 'Marque brisée',
      'Ciclicle': 'Cyclictite',
      'Cool Flame': 'Flamme froide',
      'Demonic Dive': 'Plongeon du démon',
      'Fire III': 'Méga Feu',
      'Flaming Halberd': 'Hallebarde de flammes',
      'Flare Star': 'Astre flamboyant',
      'Ice and Fire': 'Glace et feu',
      'Infinite Fire': 'Feu infini',
      'Infinite Ice': 'Glace infinie',
      'Metal Cutter': 'Métaillade',
      'Sarva': 'Sarva',
      'Soar': 'Ascension',
      'Southern Cross': 'Croix du sud',
      'Tail End': 'Pointe de queue',
      'The Demon\'s Claw': 'Griffe du démon',
      'Twin Spirit': 'Double spirituel',
      'Tyrfing': 'Tyrfing',
      'Wave Cannon': 'Canon plasma',
      'the Purge': 'Purge'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Execrated Wile': 'テンパード・ワイル',
      'Zurvan': 'ズルワーン'
    },
    'replaceText': {
      'Ahura Mazda': 'アフラ・マズダー',
      'Biting Halberd': 'バイティングハルバード',
      'Broken Seal': '氷炎の紋',
      'Ciclicle': 'シクリクル',
      'Cool Flame': 'クールフレイム',
      'Demonic Dive': 'デモンダイブ',
      'Fire III': 'ファイガ',
      'Flaming Halberd': 'フレイムハルバード',
      'Flare Star': 'フレアスター',
      'Ice and Fire': 'アイス・アンド・ファイア',
      'Infinite Fire': '炎の刻印',
      'Infinite Ice': '氷の刻印',
      'Metal Cutter': 'メタルカッター',
      'Sarva': '変異',
      'Soar': '飛翔',
      'Southern Cross': 'サザンクロス',
      'Tail End': 'テイルエンド',
      'The Demon\'s Claw': 'デモンクロー',
      'Twin Spirit': 'ツインスピリット',
      'Tyrfing': 'ティルフィング',
      'Wave Cannon': '波動砲',
      'the Purge': 'パージ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Execrated Wile': '狡诈信徒',
      'Zurvan': '祖尔宛'
    },
    'replaceText': {
      '\\(circles\\)': '(圆)',
      '\\(explosion\\)': '(爆炸)',
      '\\(puddle\\)': '(圈)',
      '\\(snapshot\\)': '(快照)',
      '\\(avoid\\)': '(躲避)',
      '\\(stack\\)': '(集合)',
      'Ahura Mazda': '阿胡拉·马兹达',
      'Biting Halberd': '刺骨冰戟',
      'Broken Seal': '冰炎之纹',
      'Ciclicle': '旋冰射线',
      'Cool Flame': '冷炎',
      'Demonic Dive': '鬼神冲',
      'Fire III': '爆炎',
      'Flaming Halberd': '焚身炎戟',
      'Flare Star': '耀星',
      'Ice and Fire': '冰与火',
      'Infinite Fire': '炎之刻印',
      'Infinite Ice': '冰之刻印',
      'Metal Cutter': '金属利刃',
      'Sarva': '变异',
      'Soar': '飞翔',
      'Southern Cross': '南十字星',
      'Tail End': '煞尾',
      'The Demon\'s Claw': '鬼神之爪',
      'Twin Spirit': '多重灵身',
      'Tyrfing': '提尔锋',
      'Wave Cannon': '波动炮',
      'the Purge': '肃清'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Execrated Wile': '책략의 신도',
      'Zurvan': '주르반'
    },
    'replaceText': {
      '\\(circles\\)': '(원)',
      '\\(explosion\\)': '(폭발)',
      '\\(puddle\\)': '(장판)',
      '\\(snapshot\\)': '(유도)',
      '\\(avoid\\)': '(피하기)',
      '\\(stack\\)': '(쉐어)',
      'Ahura Mazda': '아후라 마즈다',
      'Biting Halberd': '매서운 얼음창',
      'Broken Seal': '얼음불 문장',
      'Ciclicle': '얼음 선풍',
      'Cool Flame': '서늘한 불덩이',
      'Demonic Dive': '귀신강하',
      'Fire III': '파이가',
      'Flaming Halberd': '화염창',
      'Flare Star': '타오르는 별',
      'Ice and Fire': '얼음과 불',
      'Infinite Fire': '불의 각인',
      'Infinite Ice': '얼음의 각인',
      'Metal Cutter': '금속 절단',
      'Sarva': '변이',
      'Soar': '비상',
      'Southern Cross': '남십자성',
      'Tail End': '꼬리 쓸기',
      'The Demon\'s Claw': '귀신의 발톱',
      'Twin Spirit': '쌍둥이 영혼',
      'Tyrfing': '티르핑',
      'Wave Cannon': '파동포',
      'the Purge': '숙청'
    }
  }]
};
/* harmony default export */ const zurvan_ex = (zurvan_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/03-hw/trial/zurvan-ex.txt
const trial_zurvan_ex_namespaceObject = "# Containment Bay Z1-T9 (Extreme)\r\n# Zurvan Extreme\r\n\r\n# -ic \"Execrated Wile\" \"Execrated Will\" \"Execrated Wit\"\r\n# -ii 1C52 1C53 1C6B 1C6C 1C6E 1E64 1E65\r\n# -it Zurvan\r\n\r\n# 1C52: Twin Spirit\r\n# 1C53: Twin Spirit\r\n# 1C6B: the South Star\r\n# 1C6C: the North Star\r\n# 1C6E: Tyrfing\r\n# 1E64: the South Star\r\n# 1E65: the North Star\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Preliminary phase. No pushes.\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n6.4 \"Metal Cutter\" Ability { id: \"1E3F\", source: \"Zurvan\" } window 6.5,2.5\r\n10.5 \"Metal Cutter\" Ability { id: \"1E3F\", source: \"Zurvan\" }\r\n16.6 \"Flare Star (circles)\" Ability { id: \"1C4E\", source: \"Zurvan\" }\r\n17.3 \"Flare Star (explosion)\" Ability { id: \"1C4F\", source: \"Zurvan\" }\r\n21.9 \"Metal Cutter\" Ability { id: \"1E3F\", source: \"Zurvan\" }\r\n28.0 \"Metal Cutter\" Ability { id: \"1E3F\", source: \"Zurvan\" }\r\n35.0 \"Flare Star (circles)\" Ability { id: \"1C4E\", source: \"Zurvan\" }\r\n35.7 \"Flare Star (explosion)\" Ability { id: \"1C4F\", source: \"Zurvan\" }\r\n40.6 \"the Purge\" Ability { id: \"1C50\", source: \"Zurvan\" } window 40.6,10\r\n49.6 \"--untargetable--\"\r\n\r\n\r\n58.6 \"--targetable--\"\r\n61.7 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" } window 61.7,2.5 # Different from preliminary phase, so this is safe.\r\n66.8 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n73.9 \"Wave Cannon (avoid)\" Ability { id: \"1C73\", source: \"Zurvan\" }\r\n\r\n80.0 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n85.1 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n90.2 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n95.3 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n102.4 \"Wave Cannon (avoid)\" Ability { id: \"1C73\", source: \"Zurvan\" }\r\n\r\n108.5 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" } jump 80\r\n113.6 \"Metal Cutter\"\r\n118.7 \"Metal Cutter\"\r\n123.8 \"Metal Cutter\"\r\n130.9 \"Wave Cannon (avoid)\"\r\n137.0 \"Metal Cutter\"\r\n142.1 \"Metal Cutter\"\r\n\r\n\r\n#Phase push at <90%\r\n# It may look like this is two copies of one block,\r\n# but it alternates between one and two Metal Cutters after Soar.\r\n200.0 \"Sarva\" Ability { id: \"1C51\", source: \"Zurvan\" } window 200,10\r\n206.1 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n211.2 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n\r\n221.3 \"Soar\" Ability { id: \"1E09\", source: \"Zurvan\" } window 30,30\r\n221.4 \"--untargetable--\"\r\n230.4 \"Flaming Halberd\" Ability { id: \"1C54\", source: \"Zurvan\" }\r\n235.5 \"Demonic Dive\" Ability { id: \"1C55\", source: \"Zurvan\" }\r\n236.4 \"Cool Flame\" Ability { id: \"1C56\", source: \"Zurvan\" }\r\n238.5 \"--targetable--\"\r\n241.6 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n246.7 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n254.8 \"The Demon's Claw\" Ability { id: \"1C71\", source: \"Zurvan\" }\r\n261.9 \"Wave Cannon (stack)\" Ability { id: \"1C72\", source: \"Zurvan\" }\r\n268.0 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n273.1 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n\r\n283.1 \"Soar\" Ability { id: \"1E09\", source: \"Zurvan\" } window 30,30\r\n283.2 \"--untargetable--\"\r\n292.2 \"Flaming Halberd\" Ability { id: \"1C54\", source: \"Zurvan\" }\r\n297.3 \"Demonic Dive\" Ability { id: \"1C55\", source: \"Zurvan\" }\r\n298.2 \"Cool Flame\" Ability { id: \"1C56\", source: \"Zurvan\" }\r\n300.3 \"--targetable--\"\r\n303.4 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n311.5 \"The Demon's Claw\" Ability { id: \"1C71\", source: \"Zurvan\" }\r\n318.6 \"Wave Cannon (stack)\" Ability { id: \"1C72\", source: \"Zurvan\" }\r\n324.7 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n329.8 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n\r\n339.8 \"Soar\" Ability { id: \"1E09\", source: \"Zurvan\" } window 30,30 jump 221.3\r\n339.8 \"Twin Spirit\"\r\n339.9 \"--untargetable--\"\r\n348.9 \"Flaming Halberd\"\r\n348.9 \"Twin Spirit\"\r\n354.0 \"Demonic Dive\"\r\n355.0 \"Cool Flame\"\r\n357.1 \"--targetable--\"\r\n\r\n\r\n\r\n# Phase push at <75%\r\n\r\n400.0 \"Sarva\" Ability { id: \"1C57\", source: \"Zurvan\" } window 150,50\r\n403.1 \"Ice and Fire\" Ability { id: \"1C58\", source: \"Zurvan\" } window 403.1,10\r\n407.2 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n411.2 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n415.2 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n\r\n423.2 \"Biting Halberd\" Ability { id: \"1C59\", source: \"Zurvan\" }\r\n429.3 \"Southern Cross (snapshot)\" Ability { id: \"1C5C\", source: \"Zurvan\" } window 430,10\r\n432.9 \"Southern Cross (puddle)\" Ability { id: \"1C5D\", source: \"Zurvan\" }\r\n434.6 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n444.7 \"Biting Halberd/Ciclicle/Tail End\" Ability { id: [\"1C59\", \"1C5A\", \"1C5B\"], source: \"Zurvan\" }\r\n\r\n# This is the earliest point this phase can push\r\n448.8 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n452.9 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n457.0 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n465.1 \"Biting Halberd\" Ability { id: \"1C59\", source: \"Zurvan\" } window 15,15 jump 423.2\r\n471.2 \"Southern Cross (snapshot)\"\r\n474.8 \"Southern Cross (puddle)\"\r\n476.5 \"Metal Cutter\"\r\n486.6 \"Biting Halberd/Ciclicle/Tail End\"\r\n494.9 \"Metal Cutter\"\r\n\r\n\r\n\r\n# Intermission push at <69%\r\n# This ability is untranslated, so we ensure it doesn't cause issues in non-JP timelines.\r\n# 鬼神：履行技スタート：演出アクション：極\r\n500.0 \"--sync--\" Ability { id: \"1C5E\", source: \"Zurvan\" } window 500,10\r\n\r\n# Intermission gauge increases will vary depnding on how fast mobs die and in what order.\r\n# There's no good way to figure out the gauge timing here,\r\n# so just ignore it and hope for the best.\r\n\r\n\r\n\r\n990.3 \"Sarva\" Ability { id: \"1C5F\", source: \"Zurvan\" } window 500,10\r\n1000.0 \"Ahura Mazda\" Ability { id: \"1C60\", source: \"Zurvan\" } window 1000,10\r\n1018.2 \"--targetable--\"\r\n1024.4 \"Infinite Fire/Infinite Ice\" Ability { id: [\"1C67\", \"1C68\"], source: \"Zurvan\" }\r\n1032.5 \"Wave Cannon (avoid)\" Ability { id: \"1C73\", source: \"Zurvan\" }\r\n1039.7 \"Tyrfing x5\" Ability { id: \"1C6D\", source: \"Zurvan\" } duration 5 window 1040,5\r\n1044.8 \"Fire III\" Ability { id: \"1C6F\", source: \"Zurvan\" }\r\n1050.9 \"Southern Cross (snapshot)\" Ability { id: \"1C5C\", source: \"Zurvan\" }\r\n1054.5 \"Southern Cross (puddle)\" Ability { id: \"1C5D\", source: \"Zurvan\" }\r\n1056.2 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n1065.3 \"Broken Seal\" Ability { id: \"1DC7\", source: \"Zurvan\" } window 30,30\r\n1081.0 \"Biting Halberd/Ciclicle/Tail End\" Ability { id: [\"1C59\", \"1C5B\", \"1C5A\"], source: \"Zurvan\" }\r\n1086.3 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n1091.1 \"Infinite Fire/Infinite Ice\" Ability { id: [\"1C67\", \"1C68\"], source: \"Zurvan\" }\r\n1099.5 \"Wave Cannon (avoid)\" Ability { id: \"1C73\", source: \"Zurvan\" }\r\n1106.6 \"Tyrfing x6\" Ability { id: \"1C6D\", source: \"Zurvan\" } duration 6\r\n1112.7 \"Fire III\" Ability { id: \"1C6F\", source: \"Zurvan\" }\r\n1118.8 \"Southern Cross (snapshot)\" Ability { id: \"1C5C\", source: \"Zurvan\" }\r\n1122.4 \"Southern Cross (puddle)\" Ability { id: \"1C5D\", source: \"Zurvan\" }\r\n1124.1 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n1133.2 \"Broken Seal\" Ability { id: \"1DC7\", source: \"Zurvan\" }\r\n1147.9 \"Biting Halberd/Ciclicle/Tail End\" Ability { id: [\"1C59\", \"1C5B\", \"1C5A\"], source: \"Zurvan\" }\r\n1154.0 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n1164.1 \"Soar\" Ability { id: \"1E09\", source: \"Zurvan\" } window 100,20\r\n1164.2 \"--untargetable--\"\r\n1173.2 \"Flaming Halberd\" Ability { id: \"1C54\", source: \"Zurvan\" }\r\n1178.3 \"Demonic Dive\" Ability { id: \"1C55\", source: \"Zurvan\" }\r\n1179.2 \"Cool Flame\" Ability { id: \"1C56\", source: \"Zurvan\" }\r\n1181.3 \"--targetable--\"\r\n1187.4 \"The Demon's Claw\" Ability { id: \"1C71\", source: \"Zurvan\" }\r\n1194.5 \"Wave Cannon (stack)\" Ability { id: \"1C72\", source: \"Zurvan\" }\r\n1200.6 \"Infinite Fire/Infinite Ice\" Ability { id: [\"1C67\", \"1C68\"], source: \"Zurvan\" }\r\n1208.7 \"Wave Cannon (avoid)\" Ability { id: \"1C73\", source: \"Zurvan\" }\r\n1215.8 \"Tyrfing x7\" Ability { id: \"1C6D\", source: \"Zurvan\" } duration 7\r\n1222.9 \"Fire III\" Ability { id: \"1C6F\", source: \"Zurvan\" }\r\n1229.0 \"Southern Cross (snapshot)\" Ability { id: \"1C5C\", source: \"Zurvan\" }\r\n1232.6 \"Southern Cross (puddle)\" Ability { id: \"1C5D\", source: \"Zurvan\" }\r\n1234.3 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n1243.4 \"Broken Seal\" Ability { id: \"1DC7\", source: \"Zurvan\" } window 30,30\r\n1258.4 \"Biting Halberd/Ciclicle/Tail End\" Ability { id: [\"1C59\", \"1C5B\", \"1C5A\"], source: \"Zurvan\" }\r\n1264.5 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n1269.6 \"Infinite Fire/Infinite Ice\" Ability { id: [\"1C67\", \"1C68\"], source: \"Zurvan\" }\r\n1277.7 \"Wave Cannon (avoid)\" Ability { id: \"1C73\", source: \"Zurvan\" }\r\n1284.8 \"Tyrfing x8\" Ability { id: \"1C6D\", source: \"Zurvan\" } duration 8\r\n1292.9 \"Fire III\" Ability { id: \"1C6F\", source: \"Zurvan\" }\r\n1299.0 \"Southern Cross (snapshot)\" Ability { id: \"1C5C\", source: \"Zurvan\" }\r\n1302.6 \"Southern Cross (puddle)\" Ability { id: \"1C5D\", source: \"Zurvan\" }\r\n1304.3 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n1313.4 \"Broken Seal\" Ability { id: \"1DC7\", source: \"Zurvan\" }\r\n1328.6 \"Biting Halberd/Ciclicle/Tail End\" Ability { id: [\"1C59\", \"1C5B\", \"1C5A\"], source: \"Zurvan\" }\r\n1334.8 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n1344.8 \"Soar\" Ability { id: \"1E09\", source: \"Zurvan\" } window 100,20\r\n1344.9 \"--untargetable--\"\r\n1353.9 \"Flaming Halberd\" Ability { id: \"1C54\", source: \"Zurvan\" }\r\n1359.0 \"Demonic Dive\" Ability { id: \"1C55\", source: \"Zurvan\" }\r\n1359.9 \"Cool Flame\" Ability { id: \"1C56\", source: \"Zurvan\" }\r\n1362.0 \"--targetable--\"\r\n1368.1 \"The Demon's Claw\" Ability { id: \"1C71\", source: \"Zurvan\" }\r\n1375.2 \"Wave Cannon (stack)\" Ability { id: \"1C72\", source: \"Zurvan\" }\r\n1381.3 \"Infinite Fire/Infinite Ice\" Ability { id: [\"1C67\", \"1C68\"], source: \"Zurvan\" }\r\n1389.5 \"Wave Cannon (avoid)\" Ability { id: \"1C73\", source: \"Zurvan\" }\r\n1396.6 \"Tyrfing x9\" Ability { id: \"1C6D\", source: \"Zurvan\" } duration 9\r\n1405.7 \"Fire III\" Ability { id: \"1C6F\", source: \"Zurvan\" }\r\n1411.8 \"Southern Cross (snapshot)\" Ability { id: \"1C5C\", source: \"Zurvan\" }\r\n1415.4 \"Southern Cross (puddle)\" Ability { id: \"1C5D\", source: \"Zurvan\" }\r\n1417.1 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n1426.2 \"Broken Seal\" Ability { id: \"1DC7\", source: \"Zurvan\" } window 30,30\r\n1441.2 \"Biting Halberd/Ciclicle/Tail End\" Ability { id: [\"1C59\", \"1C5B\", \"1C5A\"], source: \"Zurvan\" }\r\n\r\n# It should theoretically be impossible to reach here before enrage,\r\n# but just in case we'll unroll a bit more to get to 10x Tyrfings.\r\n1447.4 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n1452.5 \"Infinite Fire/Infinite Ice\" Ability { id: [\"1C67\", \"1C68\"], source: \"Zurvan\" }\r\n1460.6 \"Wave Cannon (avoid)\" Ability { id: \"1C73\", source: \"Zurvan\" }\r\n1467.7 \"Tyrfing x10\" Ability { id: \"1C6D\", source: \"Zurvan\" } duration 10\r\n1475.8 \"Fire III\" Ability { id: \"1C6F\", source: \"Zurvan\" }\r\n1481.9 \"Southern Cross (snapshot)\" Ability { id: \"1C5C\", source: \"Zurvan\" }\r\n1485.5 \"Southern Cross (puddle)\" Ability { id: \"1C5D\", source: \"Zurvan\" }\r\n1487.2 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n1496.3 \"Broken Seal\" Ability { id: \"1DC7\", source: \"Zurvan\" }\r\n1511.5 \"Biting Halberd/Ciclicle/Tail End\" Ability { id: [\"1C59\", \"1C5B\", \"1C5A\"], source: \"Zurvan\" }\r\n1517.7 \"Metal Cutter\" Ability { id: \"1C70\", source: \"Zurvan\" }\r\n1527.7 \"Soar\" Ability { id: \"1E09\", source: \"Zurvan\" }\r\n1527.8 \"--untargetable--\"\r\n\r\n\r\n\r\n# Enrage at 12 minutes\r\n1989.7 \"--sync--\" StartsUsing { id: \"1E59\", source: \"Zurvan\" } window 2000,100\r\n1998.8 \"Flame Halberd Enrage\" Ability { id: \"1E59\", source: \"Zurvan\" }\r\n1998.8 \"--untargetable--\"\r\n2000.0 \"--sync--\" Ability { id: \"1E58\", source: \"Zurvan\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/alliance/orbonne_monastery.ts



// TODO: grand cross "plummet" attacks have locations,
// so it should be possible to tell people where to go.
// This is not true for Mustadio's Maintenance.
const orbonne_monastery_triggerSet = {
  id: 'TheOrbonneMonastery',
  zoneId: zone_id/* default.TheOrbonneMonastery */.Z.TheOrbonneMonastery,
  timelineFile: 'orbonne_monastery.txt',
  timelineTriggers: [{
    // I know, I know, there's two warnings for this.
    // But like seriously you've got like at least thirty years,
    // and if you do it wrong it wipes the raid.  So... /shrug??
    id: 'Orbonne Agrias Duskblade',
    regex: /Duskblade/,
    beforeSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get to your pads',
        de: 'Geh auf Dein Feld',
        fr: 'Allez sur votre tour',
        ja: '各サークルに入る',
        cn: '踩塔',
        ko: '장판 밟기'
      }
    }
  }, {
    id: 'Orbonne Ultima Dominion Tether',
    regex: /Demi-Virgo.*Tether/,
    condition: data => data.role === 'tank',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pick up tether',
        de: 'Verbindung abnehmen',
        fr: 'Prenez le lien',
        ja: '線を取る',
        cn: '坦克接线',
        ko: '선 가져오기'
      }
    }
  }],
  triggers: [{
    id: 'Orbonne Harpy Devitalize',
    type: 'StartsUsing',
    netRegex: {
      id: '3778',
      source: 'Harpy',
      capture: false
    },
    suppressSeconds: 10,
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Orbonne Mustadio Right Handgonne',
    type: 'StartsUsing',
    netRegex: {
      id: '373E',
      source: 'Mustadio',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Orbonne Mustadio Left Handgonne',
    type: 'StartsUsing',
    netRegex: {
      id: '373F',
      source: 'Mustadio',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Orbonne Mustadio Last Testament',
    type: 'StartsUsing',
    netRegex: {
      id: '3737',
      source: 'Mustadio',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Point opening at Mustadio',
        de: 'Richte Öffnung auf Mustadio',
        fr: 'Pointez l\'ouverture vers Mustadio',
        ja: '未解析の方角をボスに向ける',
        cn: '脚下光环缺口对准boss',
        ko: '문양이 빈 쪽을 무스타디오쪽으로 향하게 하기'
      }
    }
  }, {
    id: 'Orbonne Mustadio Arm Shot',
    type: 'StartsUsing',
    netRegex: {
      id: '3739',
      source: 'Mustadio'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Orbonne Mustadio Searchlight',
    type: 'HeadMarker',
    netRegex: {
      id: '00A4'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Searchlight on YOU',
        de: 'Suchscheinwerfer auf DIR',
        fr: 'Repérage sur VOUS',
        ja: '地雷を外に放置（踏まない）',
        cn: '远离人群放地雷后离开',
        ko: '탐조등 대상자'
      }
    }
  }, {
    id: 'Orbonne Spread Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Orbonne Agrias Thunder Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '3866',
      source: 'Agrias'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Orbonne Agrias Cleansing Strike',
    type: 'StartsUsing',
    netRegex: {
      id: '3854',
      source: 'Agrias',
      capture: false
    },
    preRun: data => data.halidom = [],
    delaySeconds: 50,
    run: data => delete data.agriasGhostCleanse
  }, {
    id: 'Orbonne Agrias Vacuum',
    type: 'HeadMarker',
    netRegex: {
      id: '00A5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.agriasGhostCleanse = true
  }, {
    id: 'Orbonne Agrias Consecration',
    type: 'StartsUsing',
    netRegex: {
      id: '3850',
      source: 'Agrias',
      capture: false
    },
    condition: data => !data.agriasGhostCleanse,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pick up swords',
        de: 'Schwerter aufnehmen',
        fr: 'Prenez les épées',
        ja: 'ソード（剣）を取る',
        cn: '进入附近的剑标记圈',
        ko: '검 들기'
      }
    }
  }, {
    id: 'Orbonne Agrias Halidom Inside',
    type: 'Ability',
    netRegex: {
      id: '3851',
      source: 'Halidom'
    },
    run: (data, matches) => {
      data.halidom ??= [];
      data.halidom.push(matches.target);
    }
  }, {
    id: 'Orbonne Agrias Halidom Outside',
    type: 'Ability',
    netRegex: {
      id: '3851',
      source: 'Halidom',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 10,
    alertText: (data, _matches, output) => {
      if (data.agriasGhostCleanse || data.halidom?.includes(data.me)) return;
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'Use Swords On Jails',
        de: 'Kristalle mit Schwert zerschlagen',
        fr: 'Utilisez les épées sur les prisons',
        ja: '（コンテンツアクション）剣で魂を討つ',
        cn: '使用额外技能攻击',
        ko: '감옥에 검 사용하기'
      }
    }
  }, {
    id: 'Orbonne Agrias Hallowed Bolt',
    type: 'HeadMarker',
    netRegex: {
      id: '00A6'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go To Center',
        de: 'In die Mitte gehen',
        fr: 'Allez au centre',
        ja: '中央に入る',
        cn: '前往中间',
        ko: '중앙으로 이동'
      }
    }
  }, {
    id: 'Orbonne Agrias Adds Phase',
    type: 'Ability',
    netRegex: {
      id: '385D',
      source: 'Agrias',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Shield',
        de: 'Schild nehmen',
        fr: 'Prenez un bouclier',
        ja: 'シールド（盾）を取る',
        cn: '进入盾标记圈',
        ko: '방패 들기'
      }
    }
  }, {
    id: 'Orbonne Agrias Mortal Blow',
    type: 'StartsUsing',
    netRegex: {
      id: '385E',
      source: 'Sword Knight',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Use Shield, Face Knights',
        de: 'Schild benutzen, Ritter anschauen',
        fr: 'Utilisez un bouclier, face aux chevaliers',
        ja: '騎士に向けてシールドを使う',
        cn: '面对剑骑使用盾牌',
        ko: '방패 사용하고, 기사 바라보기'
      }
    }
  }, {
    id: 'Orbonne Agrias Extra Adds',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Emblazoned Shield',
      capture: false
    },
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill shields with sword',
        de: 'Schilde mit Schwert zerstören',
        fr: 'Détruisez les boucliers avec les épées',
        ja: '剣で大盾を破れ',
        cn: '用剑摧毁护盾',
        ko: '방패에 검 사용하기'
      }
    }
  }, {
    id: 'Orbonne Agrias Judgment Blade',
    type: 'StartsUsing',
    netRegex: {
      id: '3857',
      source: 'Agrias',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Use shield, face boss',
        de: 'Schild benutzen, Boss anschauen',
        fr: 'Utilisez un bouclier, face au boss',
        ja: 'ボスに向いてシールドを使う',
        cn: '面对boss使用盾牌',
        ko: '방패 사용하고, 보스 바라보기'
      }
    }
  }, {
    id: 'Orbonne Agrias Divine Ruination',
    type: 'StartsUsing',
    netRegex: {
      id: '3858',
      source: 'Agrias',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Use shield if tethered',
        de: 'Schild benutzen, wenn verbunden',
        fr: 'Utilisez un bouclier si lié',
        ja: '線と繋ったらシールドを使う',
        cn: '被连线使用盾牌',
        ko: '선 연결되면 방패 사용하기'
      }
    }
  }, {
    id: 'Orbonne Cid Crush Helm Healer',
    type: 'StartsUsing',
    netRegex: {
      id: '3752',
      source: 'The Thunder God'
    },
    condition: data => data.role === 'healer',
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'Orbonne Cid Crush Helm Feint',
    type: 'StartsUsing',
    netRegex: {
      id: '3752',
      source: 'The Thunder God',
      capture: false
    },
    condition: data => data.CanFeint(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Feint Tank Buster',
        de: 'Tankbuster Zermürben',
        fr: 'Évitez le Tank buster',
        ja: 'タンクバスター（牽制使って）',
        cn: '坦克死刑',
        ko: '성천폭격타 탱버'
      }
    }
  }, {
    id: 'Orbonne Cid Crush Helm Tank',
    type: 'Ability',
    netRegex: {
      id: '3753',
      source: 'The Thunder God'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Orbonne Cid Crush Armor Tank',
    type: 'StartsUsing',
    netRegex: {
      id: '3758',
      source: 'The Thunder God',
      capture: false
    },
    condition: data => data.role === 'tank',
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Give Tether Away',
        de: 'Verbindung abgeben',
        fr: 'Éloignez-vous et donnez le lien',
        ja: '線を取らない！',
        cn: '获取连线受到一次伤害后转给下一个',
        ko: '선 건네주기'
      }
    }
  }, {
    id: 'Orbonne Cid Crush Armor',
    type: 'Ability',
    netRegex: {
      id: '3759',
      source: 'The Thunder God'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Give Tether Away',
        de: 'Verbindung abgeben',
        fr: 'Éloignez-vous et donnez le lien',
        ja: '線を次の人と交代',
        cn: '获取连线受到一次伤害后转给下一个',
        ko: '선 맞고, 다음 사람에게 건네주기'
      }
    }
  }, {
    id: 'Orbonne Cid Crush Accessory',
    type: 'StartsUsing',
    netRegex: {
      id: '375A',
      source: 'The Thunder God',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Icewolf Adds',
        de: 'Besiege die Eiswolf Adds',
        fr: 'Tuez les Grêlons de glace',
        ja: '氷狼を討つ',
        cn: '速度消灭冰狼',
        ko: '얼음 잡기'
      }
    }
  }, {
    id: 'Orbonne Cid Cleansing Strike',
    type: 'Ability',
    netRegex: {
      id: '3751',
      source: 'The Thunder God',
      capture: false
    },
    condition: data => data.role === 'healer' || data.job === 'BLU',
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Heal To Full',
        de: 'Vollheilen',
        fr: 'Soignez complètement',
        ja: '全員のHPを全回復',
        cn: '奶满全队',
        ko: '체력 풀피로'
      }
    }
  }, {
    id: 'Orbonne Cid Shadowblade Pads',
    type: 'StartsUsing',
    netRegex: {
      id: '3761',
      source: 'The Thunder God',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand on Pads',
        de: 'Auf Felder stellen',
        fr: 'Placez-vous sur les pads',
        ja: '各サークルに入る',
        cn: '踩塔',
        ko: '장판 밟기'
      }
    }
  }, {
    id: 'Orbonne Cid Shadowblade Bubble',
    type: 'HeadMarker',
    netRegex: {
      id: '00AA'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Bubble In Back',
        de: 'Blase hinten ablegen',
        fr: 'Déposez les bulles derrière',
        ja: '後ろに捨てる',
        cn: '将身上圆圈放在圆型区域后方',
        ko: '징 뒤쪽에 깔기'
      }
    }
  }, {
    id: 'Orbonne Cid Hallowed Bolt',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bolt on YOU',
        de: 'Blitz auf DIR',
        fr: 'Éclair sur VOUS',
        ja: '剣から離れる',
        cn: '离开剑所指的区域',
        ko: '번개찌르기 대상자'
      }
    }
  }, {
    id: 'Orbonne Cid Crush Weapon',
    type: 'HeadMarker',
    netRegex: {
      id: '005C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.getOut */.n3.getOut('alarm')
  }, {
    id: 'Orbonne Cid Hallowed Bolt Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E',
      capture: false
    },
    suppressSeconds: 10,
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }, {
    id: 'Orbonne Cid Divine Ruination',
    type: 'HeadMarker',
    netRegex: {
      id: '006E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Point Line Outside',
        de: 'Linie nach Außen',
        fr: 'Pointez la ligne vers l\'extérieur',
        ja: '（線形AoE）外周に向かって捨てる',
        cn: '向外远离',
        ko: '성광폭렬파 바깥으로 빼기'
      }
    }
  }, {
    id: 'Orbonne Cid Holy Sword In',
    type: 'StartsUsing',
    netRegex: {
      id: '3750',
      source: 'The Thunder God',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Orbonne Cid Holy Sword Out',
    type: 'StartsUsing',
    netRegex: {
      id: '374F',
      source: 'The Thunder God',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Orbonne Cid Holy Sword Thunder Left',
    type: 'StartsUsing',
    netRegex: {
      id: '3749',
      source: 'The Thunder God',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Orbonne Cid Holy Sword Thunder Right',
    type: 'StartsUsing',
    netRegex: {
      id: '374A',
      source: 'The Thunder God',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Orbonne Cid Holy Sword Three 1',
    type: 'StartsUsing',
    netRegex: {
      id: '374C',
      source: 'The Thunder God',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // e.g. E / NE / NW platforms
        en: 'Rotate right',
        de: 'Im Uhrzeigersinn ausweichen',
        fr: 'Tournez dans le sens anti-horaire',
        ja: '右へ（反時計回り）',
        cn: '向右移动避开',
        ko: '오른쪽으로 돌기'
      }
    }
  }, {
    id: 'Orbonne Cid Holy Sword Three 2',
    type: 'StartsUsing',
    netRegex: {
      id: '374D',
      source: 'The Thunder God',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // NW / NE / E platforms
        en: 'Rotate left',
        de: 'Schwertern im Uhrzeigersinn ausweichen',
        fr: 'Tournez dans le sens horaire',
        ja: '左へ（時計回り）',
        cn: '向左移动避开',
        ko: '왼쪽으로 돌기'
      }
    }
  }, {
    id: 'Orbonne Ultima Redemption',
    type: 'StartsUsing',
    netRegex: {
      id: '38AA',
      source: 'Ultima, The High Seraph'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Orbonne Ultima Dark Cannonade',
    type: 'HeadMarker',
    netRegex: {
      id: '0037'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.doritoStack */.n3.doritoStack()
  }, {
    id: 'Orbonne Ultima Eruption',
    type: 'HeadMarker',
    netRegex: {
      id: '0066'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Eruption on YOU',
        de: 'Eruption auf DIR',
        fr: 'Éruption sur vous',
        ja: '自分にエラプション',
        cn: '地火喷发',
        ko: '불기둥 대상자'
      }
    }
  }, {
    id: 'Orbonne Ultima Flare IV',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.getOut */.n3.getOut('alarm')
  }, {
    id: 'Orbonne Ultima Time Eruption',
    type: 'StartsUsing',
    netRegex: {
      id: '38CF',
      source: 'Demi-Belias',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand on Slow Clock',
        de: 'In der langsamen Uhr stehen',
        fr: 'Placez-vous sur une horloge lente',
        ja: '遅い時計で待機（早い方が爆発したらすぐ安置へ）',
        cn: '站慢速时钟等待快速爆炸后立即离开',
        ko: '느린 시계 위로'
      }
    }
  }, {
    id: 'Orbonne Ultima Extreme Edge',
    type: 'StartsUsing',
    netRegex: {
      id: '38DA',
      source: 'Demi-Hashmal',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look for Hashmal dash',
        de: 'Nach Hashmal-Dash ausschau halten',
        fr: 'Repérez Hashmal pour la ruée',
        ja: '十字レーザーを避ける',
        cn: '观察场地三个大十字路径并远离',
        ko: '하쉬말 돌진 확인'
      }
    }
  }, {
    id: 'Orbonne Ultima Ultimate Illusion Healer',
    type: 'StartsUsing',
    netRegex: {
      id: '3895',
      source: 'Ultima, The High Seraph',
      capture: false
    },
    condition: data => data.role === 'healer' || data.job === 'BLU',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Heal Like Whoa',
        de: 'Heilen was das Zeug hält',
        fr: 'Soignez à mort',
        ja: 'ヒーラー頑張って！',
        cn: '加大治疗',
        ko: '계속 힐 돌리기'
      }
    }
  }, {
    id: 'Orbonne Ultima Ultimate Illusion',
    type: 'Ability',
    netRegex: {
      id: '3895',
      source: 'Ultima, The High Seraph',
      capture: false
    },
    condition: data => data.role !== 'healer',
    // zzz
    delaySeconds: 23.5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Ruination!',
        de: 'Zerstörung vernichten',
        fr: 'Tuez la Marque des déchus',
        ja: '堕天の証を倒す',
        cn: '速度消灭堕天之证',
        ko: '타락의 증거 잡기'
      }
    }
  }, {
    id: 'Orbonne Ultima Acceleration Bomb',
    type: 'GainsEffect',
    netRegex: {
      effectId: '430'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 1,
    response: responses/* Responses.stopEverything */.n3.stopEverything()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Agrias': 'Agrias',
      'Aspersory': 'Aspersorium',
      'Dark Crusader': 'Düsterritter',
      'Demi-Belias': 'Demi-Belias',
      'Demi-Famfrit': 'Demi-Famfrit',
      'Demi-Hashmal': 'Demi-Hashmallim',
      'Dominion': 'Dominion',
      'Early Turret': 'alt(?:e|er|es|en) Gefechtsturm',
      'Emblazoned Shield': 'geschmückt(?:e|er|es|en) Schild',
      'Ephemeral Knight': 'vergänglich(?:e|er|es|en) Ritter',
      'Halidom': 'Falsch(?:e|er|es|en) Heiligtum',
      'Harpy': 'Harpyie',
      'I see it now': 'Ich sehe ihn in dir!',
      'Iron Construct': 'Eisenkonstrukt',
      'Mustadio': 'Mustadio',
      'Ramza': 'Ramza',
      'Sword Knight': 'Schwertritter',
      'The Crystalline Gaol': 'Kristallkerker',
      'The Realm of the Machinists': 'Reich der Maschinisten',
      'The Realm of the Templars': 'Reich der Tempelritter',
      'The Realm of the Thunder God': 'Reich des Donnergottes',
      '(?<! )The Thunder God': 'Cidolfus',
      'The lifeless alley': 'Leblosen Pfad',
      'Ultima, the High Seraph': 'Cherub Ultima'
    },
    'replaceText': {
      '--ghost stun--': '--Geist unterbrechen--',
      '--crystal stun--': '--Kristall unterbrechen--',
      'Analysis': 'Analyse',
      'Arm Shot': 'Armschuss',
      'Auralight': 'Aurastrahl',
      'Balance Asunder': 'Bruch des Gleichgewichts',
      'Ballistic Impact': 'Ballistischer Einschlag',
      'Ballistic Missile': 'Ballistische Rakete',
      'Cataclysm': 'Kosmischer Kataklysmus',
      'Cleansing Flame': 'Flamme der Läuterung',
      'Cleansing Strike': 'Säuberungsschlag',
      'Colosseum': 'Kolosseum',
      'Compress': 'Zerdrücken',
      'Consecration': 'Konsekration',
      'Control Tower': 'Turmkontrolle',
      'Crush Accessory': 'Hagelkörner',
      'Crush Armor': 'Helmspalter',
      'Crush Helm': 'Himmelsbombardement',
      'Crush Weapon': 'Jenseitsschrei',
      'Dark Cannonade': 'Dunkler Blitz',
      'Dark Ewer': 'Dunkler Wasserkrug',
      'Dark Rite': 'Dunkler Brauch',
      'Demi-Aquarius': 'Demi-Aquarius',
      'Demi-Aries': 'Demi-Aries',
      'Demi-Leo': 'Demi-Leo',
      'Demi-Virgo Feet': 'Demi-Virgo Füße',
      'Demi-Virgo Line(?!\/)': 'Demi-Virgo Linie',
      'Demi-Virgo Line/Tether': 'Demi-Virgo Linie/Verbindung',
      'Demi-Virgo Tether(?!\/)': 'Demi-Virgo Verbindung',
      'Demi-Virgo Tether/Feet': 'Demi-Virgo Verbindung/Füße',
      'Divine Light': 'Göttliches Licht',
      'Divine Ruination': 'Göttliche Zerstörung',
      'Duskblade': 'Dämmerklinge',
      'Earth Hammer': 'Erdhammer',
      'East/West March': 'Ost-/West-Marsch',
      'Embrace': 'Umschließen',
      'Energy Burst': 'Energiestoß',
      '(?<![\\w| ])Eruption': 'Eruption',
      'Extreme Edge': 'Extremkante',
      'Flare IV': 'Giga-Flare',
      'Grand Cross': 'Supernova',
      'Hallowed Bolt': 'Geheiligter Blitz',
      'Hammerfall': 'Hammerschlag',
      'Heavenly Judgment': 'Urteil des Himmels',
      'Holy IV': 'Giga-Sanctus',
      'Infernal Wave': 'Infernowelle',
      'Judgment Blade': 'Klinge des Urteils',
      'L/R Handgonne': 'L/R Donnerbüchse',
      'Last Testament': 'Letztes Vermächtnis',
      'Leg Shot': 'Beinschuss',
      'Maintenance': 'Wartung',
      'Materialize': 'Trugbild',
      'Mortal Blow': 'Tödlicher Hieb',
      'Noahionto': 'Noahionto',
      'Northswain\'s Strike': 'Schlag des Polarsterns',
      'Ray of Light': 'Lichtstrahl',
      'Redemption': 'Zerstörung',
      'Sanction': 'Sanktion',
      'Satellite Beam': 'Satellit',
      'Searchlight': 'Suchscheinwerfer',
      'Shadowblade': 'Schattenklinge',
      'Shockwave': 'Schockwelle',
      'Stack': 'Sammeln',
      'Sword In/Out': 'Schwert Rein/Raus',
      'Sword L/R': 'Schwert L/R',
      'Sword Out/In': 'Schwert Raus/Rein',
      'Sword Three In A Row': 'Schwertreihenschlag',
      'Thunder Slash': 'Donnerhieb',
      'Time Eruption': 'Zeiteruption',
      'Towerfall': 'Turmsturz',
      'Ultimate Illusion': 'Ultimative Illusion',
      'Marks': 'Markierungen',
      '(?<!Sword )In/Out': 'Rein/Raus',
      '(?<!Sword )Out/In': 'Raus/Rein'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Agrias': 'Agrias',
      'Aspersory': 'aiguière bénie',
      'Dark Crusader': 'conquérant sombre',
      'Demi-Belias': 'Demi-Belias',
      'Demi-Famfrit': 'Demi-Famfrit',
      'Demi-Hashmal': 'Demi-Hashmal',
      'Dominion': 'Dominion',
      'Early Turret': 'tourelle archaïque',
      'Emblazoned Shield': 'pavois miroitant',
      'Ephemeral Knight': 'chevalier évanescent',
      'Halidom': 'faux sanctuaire',
      'Harpy': 'harpie',
      'I see it now': 'À vous, maintenant',
      'Iron Construct': 'bâtisseur de fer',
      'Mustadio': 'Mustadio',
      'Ramza': 'Ramza',
      'Sword Knight': 'chevalier à l\'épée',
      'The Crystalline Gaol': 'la Geôle cristalline',
      'The Realm of the Machinists': 'cloître de l\'ingénieur',
      'The Realm of the Templars': 'cloître de la chevalière sacrée',
      'The Realm of the Thunder God': 'cloître du Dieu de la Foudre',
      '(?<! )The Thunder God': 'Cid le Dieu de la Foudre',
      'The lifeless alley': 'corridors silencieux',
      'Ultima, the High Seraph': 'Ultima la Grande Séraphine'
    },
    'replaceText': {
      '--crystal stun--': '--Étourdissement et Cristaux--',
      '--ghost stun--': '--Étourdissement et Fantômes--',
      'Analysis': 'Analyse',
      'Arm Shot': 'Visée des bras',
      'Auralight': 'Rayon auralithe',
      'Balance Asunder': 'Bouleversement de l\'équilibre',
      'Ballistic Impact': 'Impact de missile',
      'Ballistic Missile': 'Missiles balistiques',
      'Cataclysm': 'Cataclysme cosmique',
      'Cleansing Flame': 'Irradiation divine',
      'Cleansing Strike': 'Impact purifiant',
      'Colosseum': 'Arène des Braves',
      'Compress': 'Écraser',
      'Consecration': 'Joug sanctifié',
      'Control Tower': 'Tour de contrôle',
      'Crush Accessory': 'Grêlons fracassants',
      'Crush Armor': 'Brèche insidieuse',
      'Crush Helm': 'Bombardement céleste',
      'Crush Weapon': 'Cri de l\'au-delà',
      'Dark Cannonade': 'Bombardement ténébreux',
      'Dark Ewer': 'Aiguières ténèbreuses',
      'Dark Rite': 'Cérémonie ténébreuse',
      'Demi-Aquarius': 'Demi-Verseau',
      'Demi-Aries': 'Demi-Bélier',
      'Demi-Leo': 'Demi-Lion',
      'Demi-Virgo Feet': 'Demi-Vierge pieds',
      'Demi-Virgo Line(?!\/)': 'Demi-Vierge ligne',
      'Demi-Virgo Line/Tether': 'Demi-Vierge ligne/lien',
      'Demi-Virgo Tether(?!\/)': 'Demi-Vierge lien',
      'Demi-Virgo Tether/Feet': 'Demi-Vierge lien/pieds',
      'Divine Light': 'Onde de lumière évanescente',
      'Divine Ruination': 'Ire céleste',
      'Duskblade': 'Lame sombre',
      'Earth Hammer': 'Marteau tellurique',
      'East/West March': 'Marche Est/Ouest',
      'Embrace': 'Étreinte',
      'Energy Burst': 'Éruption d\'énergie',
      '(?<![\\w| ])Eruption': 'Éruption',
      'Extreme Edge': 'Taille suprême',
      'Flare IV': 'Giga Brasier',
      'Grand Cross': 'Croix suprême',
      'Hallowed Bolt': 'Éclair sacré',
      'Hammerfall': 'Aplatissoir',
      'Heavenly Judgment': 'Jugement céleste',
      'Holy IV(?! Ground)': 'Giga Miracle',
      'Holy IV Ground': 'Giga Miracle au sol',
      '(?<!\\w)In/Out': 'à l\'intérieur/extérieur',
      'Infernal Wave': 'Onde infernale',
      'Judgment Blade': 'Lame du jugement',
      'Handgonne': 'Mitraillage',
      'Last Testament': 'Dernier testament',
      'Leg Shot': 'Visée des jambes',
      'L/R': 'G/D',
      'Maintenance': 'Maintenance',
      'Marks': 'marques',
      'Materialize': 'Apparition',
      'Mortal Blow': 'Frappe brutale',
      'Noahionto': 'Noahionto',
      'Northswain\'s Strike': 'Frappe de l\'Étoile Polaire',
      '(?<!\\w)Out/In': 'à l\'extérieur/intérieur',
      'Ray of Light': 'Onde de lumière',
      'Redemption': 'Destruction',
      'Sanction': 'Sanction',
      'Satellite Beam': 'Rayon satellite',
      'Searchlight': 'Repérage lumineux',
      'Shadowblade': 'Lame des ténèbres',
      'Shockwave': 'Onde de choc',
      'Stack': 'Packez-vous',
      'Sword(?! Three In A Row)': 'Épée',
      'Sword Three In A Row': '3 coups d\'épée à la suite',
      'Thunder Slash': 'Foudrolle',
      'Time Eruption': 'Éruption à retardement',
      'Towerfall': 'Écroulement',
      'Ultimate Illusion': 'Fantaisie finale'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Agrias': '聖騎士アグリアス',
      'Aspersory': '聖雲の水瓶',
      'Dark Crusader': 'ダーククルセイダー',
      'Demi-Belias': 'デミ・ベリアス',
      'Demi-Famfrit': 'デミ・ファムフリート',
      'Demi-Hashmal': 'デミ・ハシュマリム',
      'Dominion': 'ドミニオン',
      'Early Turret': '古の機工兵器',
      'Emblazoned Shield': '光輝の大盾',
      'Ephemeral Knight': '幻影の騎士',
      'Halidom': '模造聖域',
      'Harpy': 'ハーピー',
      'I see it now': '我ノ力、スベテ解キ放トウゾ……！',
      'Iron Construct': '労働型鉄巨人',
      'Mustadio': '機工士ムスタディオ',
      'Ramza': '勇者ラムザ',
      'Sword Knight': '剣の騎士',
      'The Crystalline Gaol': '水晶の監獄',
      'The Realm of the Machinists': '機工士の領域',
      'The Realm of the Templars': '聖騎士の領域',
      'The Realm of the Thunder God': '雷神の領域',
      '(?<! )The Thunder God': '雷神シド',
      'The lifeless alley': '命なき街路',
      'Ultima, the High Seraph': '聖天使アルテマ'
    },
    'replaceText': {
      '--ghost stun--': 'ゴーストスタン',
      '--crystal stun--': 'クリスタルスタン',
      'Analysis': 'アナライズ',
      'Arm Shot': '腕を狙う',
      'Auralight': '聖石光',
      'Balance Asunder': 'バランスブレイク',
      'Ballistic Impact': 'ミサイル着弾',
      'Ballistic Missile': 'ミサイル発射',
      'Cataclysm': '天変地異',
      'Cleansing Flame': '聖光焼却撃',
      'Cleansing Strike': '乱命割殺打',
      'Colosseum': '剣闘技場',
      'Compress': '圧縮する',
      'Consecration': '聖域束縛式',
      'Control Tower': '統制の塔',
      'Crush Accessory': '咬撃氷狼破',
      'Crush Armor': '強甲破点突き',
      'Crush Helm': '星天爆撃打',
      'Crush Weapon': '冥界恐叫打',
      'Dark Cannonade': '闇の砲撃',
      'Dark Ewer': '暗雲の水瓶',
      'Dark Rite': '闇の儀式',
      'Demi-Aquarius': 'デミ・アクエリアス',
      'Demi-Aries': 'デミ・アリエス',
      'Demi-Leo': 'デミ・レオ',
      'Demi-Virgo Feet': 'デミ・ヴァルゴ（足）',
      'Demi-Virgo Line(?!\/)': 'デミ・ヴァルゴ（直線）',
      'Demi-Virgo Line/Tether': 'デミ・ヴァルゴ（直線/線繋ぐ）',
      'Demi-Virgo Tether(?!\/)': 'デミ・ヴァルゴ（線繋ぐ）',
      'Demi-Virgo Tether/Feet': 'デミ・ヴァルゴ（線繋ぐ/足）',
      'Divine Light': '幻光波',
      'Divine Ruination': '聖光爆裂破',
      'Duskblade': '暗の剣',
      'Earth Hammer': '大地のハンマー',
      'East/West March': '東/西マーチ',
      'Embrace': '抱締',
      'Energy Burst': 'エネルギーバースト',
      '(?<![\\w| ])Eruption': 'エラプション',
      'Extreme Edge': 'ブーストエッジ',
      'Flare IV': 'フレアジャ',
      'Grand Cross': 'グランドクロス',
      'Hallowed Bolt(?! )': '無双稲妻突き',
      'Hallowed Bolt In/Out': '無双稲妻突き (入る/出る)',
      'Hallowed Bolt Marks': '無双稲妻突き (マーク)',
      'Hallowed Bolt Out/In': '無双稲妻突き (出る/入る)',
      'Hammerfall': 'ハンマークラッシュ',
      'Heavenly Judgment': 'ヘヴンリージャッジメント',
      'Holy IV(?! )': 'ホーリジャ',
      'Holy IV Ground': 'ホーリジャ (床)',
      'Infernal Wave': 'インファーナルウェーブ',
      'Judgment Blade': '不動無明剣',
      'L/R Handgonne': '左舷掃射/右舷掃射',
      'Last Testament': 'ファイナルテスタメント',
      'Leg Shot': '足を狙う',
      'Maintenance': 'メンテナンス',
      'Materialize': '幻出',
      'Mortal Blow': '強打',
      'Noahionto': 'ノアヒオント',
      'Northswain\'s Strike': '北斗骨砕打',
      'Ray of Light': '光波',
      'Redemption': '破壊',
      'Sanction': '制裁の刃',
      'Satellite Beam': 'サテライトビーム',
      'Searchlight': 'サーチライト',
      'Shadowblade': '闇の剣',
      'Shockwave': '衝撃波',
      'Stack': '集合',
      'Sword In/Out': '雷神式聖剣技（入る/出る）',
      'Sword L/R': '雷神式聖剣技（左/右）',
      'Sword Out/In': '雷神式聖剣技（出る/入る）',
      'Sword Three In A Row': '雷神式聖剣技（三つの剣）',
      'Thunder Slash': '雷鳴剣',
      'Time Eruption': 'タイムエラプション',
      'Towerfall': '倒壊',
      'Ultimate Illusion': '究極幻想'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Agrias': '圣骑士阿格莉亚丝',
      'Aspersory': '圣云水瓶',
      'Dark Crusader': '黑暗十字军',
      'Demi-Belias': '亚灵贝利亚斯',
      'Demi-Famfrit': '亚灵法姆弗里特',
      'Demi-Hashmal': '亚灵哈修马利姆',
      'Dominion': '主天使',
      'Early Turret': '古代机工兵器',
      'Emblazoned Shield': '光辉的大盾',
      'Ephemeral Knight': '幻影骑士',
      'Halidom': '仿制圣域',
      'Harpy': '哈比鸟',
      'I see it now': '我将释放全部力量……',
      'Iron Construct': '劳动型铁巨人',
      'Mustadio': '机工士姆斯塔迪奥',
      'Ramza': '勇者拉姆萨',
      'Sword Knight': '剑之骑士',
      'The Crystalline Gaol': '水晶监狱',
      'The Realm of the Machinists': '机工士的领域',
      'The Realm of the Templars': '圣骑士的领域',
      'The Realm of the Thunder God': '雷神的领域',
      '(?<! )The Thunder God': '雷神西德',
      'The lifeless alley': '无命街路',
      'Ultima, the High Seraph': '圣天使阿尔蒂玛'
    },
    'replaceText': {
      '--ghost stun--': '幽灵击晕',
      '--crystal stun--': '水晶击晕',
      'Analysis': '分析',
      'Arm Shot': '击腕',
      'Auralight': '圣石光',
      'Balance Asunder': '平衡崩坏',
      'Ballistic Impact': '导弹命中',
      'Ballistic Missile': '导弹发射',
      'Cataclysm': '天崩地裂',
      'Cleansing Flame': '圣光烧却击',
      'Cleansing Strike': '乱命割杀打',
      'Colosseum': '剑斗技场',
      'Compress': '执行压缩',
      'Consecration': '圣域束缚式',
      'Control Tower': '统治之塔',
      'Crush Accessory': '咬击冰狼破',
      'Crush Armor': '强甲破点突',
      'Crush Helm': '星天爆击打',
      'Crush Weapon': '冥界恐叫打',
      'Dark Cannonade': '暗炮击',
      'Dark Ewer': '暗云水瓶',
      'Dark Rite': '暗之仪式',
      'Demi-Aquarius': '亚灵水瓶座',
      'Demi-Aries': '亚灵白羊座',
      'Demi-Leo': '亚灵狮子座',
      'Demi-Virgo Feet': '亚灵室女座 脚',
      'Demi-Virgo Line(?!\/)': '亚灵室女座 直线',
      'Demi-Virgo Line/Tether': '亚灵室女座 直线/连线',
      'Demi-Virgo Tether(?!\/)': '亚灵室女座 连线',
      'Demi-Virgo Tether/Feet': '亚灵室女座 连线/脚',
      'Divine Light': '幻光波',
      'Divine Ruination': '圣光爆裂破',
      'Duskblade': '暗影之剑',
      'Earth Hammer': '大地之锤',
      'East/West March': '东/西进军',
      'Embrace': '抱拥',
      'Energy Burst': '能量爆发',
      '(?<![\\w| ])Eruption': '地火喷发',
      'Extreme Edge': '加速刃',
      'Flare IV': '核轰',
      'Grand Cross': '大十字',
      'Hallowed Bolt': '无双惊电突',
      'Hammerfall': '锤击',
      'Heavenly Judgment': '圣天击灭斩',
      'Holy IV': '极圣',
      'Infernal Wave': '地狱波动',
      'Judgment Blade': '不动无明剑',
      'L/R Handgonne': '左/右舷扫射',
      'Last Testament': '最终圣约',
      'Leg Shot': '击足',
      'Maintenance': '维护',
      'Materialize': '现身',
      'Mortal Blow': '强击',
      'Noahionto': '新烈光',
      'Northswain\'s Strike': '北斗骨碎打',
      'Ray of Light': '光波',
      'Redemption': '破坏',
      'Sanction': '制裁之刃',
      'Satellite Beam': '卫星光束',
      'Searchlight': '探照灯',
      'Shadowblade': '暗黑之剑',
      'Shockwave': '冲击波',
      'Stack': '集合',
      'Sword In/Out': '剑 靠近/远离',
      'Sword L/R': '剑 左/右',
      'Sword Out/In': '剑 远离/靠近',
      'Sword Three In A Row': '一行三剑',
      'Thunder Slash': '雷鸣剑',
      'Time Eruption': '时空地火喷发',
      'Towerfall': '崩塌',
      'Ultimate Illusion': '究极幻想'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Agrias': '성기사 아그리아스',
      'Aspersory': '성운의 물병',
      'Dark Crusader': '암흑 성전사',
      'Demi-Belias': '데미벨리아스',
      'Demi-Famfrit': '데미팜프리트',
      'Demi-Hashmal': '데미하쉬말림',
      'Dominion': '도미니온',
      'Early Turret': '고대 기공병기',
      'Emblazoned Shield': '찬란한 방패',
      'Ephemeral Knight': '환영 기사',
      'Halidom': '모조 성역',
      'Harpy': '하피',
      'I see it now': '물병이여,  곧장 진격하여',
      'Iron Construct': '노동형 철거인',
      'Mustadio': '기공사 무스타디오',
      'Ramza': '용사 람자',
      'Sword Knight': '검의 기사',
      'The Crystalline Gaol': '수정 감옥',
      'The Realm of the Machinists': '기공사의 영역',
      'The Realm of the Templars': '성기사의 영역',
      'The Realm of the Thunder God': '뇌신의 영역',
      '(?<! )The Thunder God': '뇌신 시드',
      'The lifeless alley': '생명 없는 길',
      'Ultima, the High Seraph': '성천사 알테마'
    },
    'replaceText': {
      'Analysis': '분석',
      'Arm Shot': '팔 조준',
      'Auralight': '성석광',
      'Balance Asunder': '미사일 착탄',
      'Ballistic Impact': '충격탄',
      'Ballistic Missile': '미사일 발사',
      'Cataclysm': '천재지변',
      'Cleansing Flame': '성광소각격',
      'Cleansing Strike': '난명할살타',
      'Colosseum': '검투기장',
      'Compress': '압축',
      'Consecration': '성역 속박식',
      'Control Tower': '통제의 탑',
      'Crush Accessory': '교격빙랑파',
      'Crush Armor': '강갑 파점 찌르기',
      'Crush Helm': '성천폭격타',
      'Crush Weapon': '명계공규타',
      'Dark Cannonade': '어둠의 포격',
      'Dark Ewer': '암운의 물병',
      'Dark Rite': '어둠의 의식',
      'Demi-Aquarius': '데미아쿠아리우스',
      'Demi-Aries': '데미아리에스',
      'Demi-Leo': '데미레오',
      'Demi-Virgo Feet': '데미비르고 화살표',
      'Demi-Virgo Line(?!\/)': '데미비르고 직선장판',
      'Demi-Virgo Line/Tether': '데미비르고 직선장판/선연결',
      'Demi-Virgo Tether(?!\/)': '데미비르고 선연결',
      'Demi-Virgo Tether/Feet': '데미비르고 선연결/화살표',
      'Divine Light': '환광파',
      'Divine Ruination': '성광폭렬파',
      'Duskblade': '암흑의 검',
      'Earth Hammer': '대지의 망치',
      'East/West March': '동/서 행진',
      'Embrace': '껴안기',
      'Energy Burst': '에너지 폭발',
      '(?<![\\w| ])Eruption': '용암 분출',
      'Extreme Edge': '돌격하는 칼날',
      'Flare IV': '플레어쟈',
      'Grand Cross': '그랜드크로스',
      'Hallowed Bolt(?! )': '무쌍 번개 찌르기',
      'Hallowed Bolt In/Out': '무쌍 번개 찌르기 (안/밖)',
      'Hallowed Bolt Marks': '무쌍 번개 찌르기 (징)',
      'Hallowed Bolt Out/In': '무쌍 번개 찌르기 (밖/안)',
      'Hammerfall': '망치 강타',
      'Heavenly Judgment': '성스러운 심판',
      'Holy IV(?! Ground)': '홀리쟈',
      'Holy IV Ground': '홀리쟈 장판',
      'Infernal Wave': '지옥의 파동',
      'Judgment Blade': '부동무명검',
      'L/R Handgonne': '좌/우현 소사',
      'Last Testament': '최후의 증명',
      'Leg Shot': '다리 조준',
      'Maintenance': '수리',
      'Materialize': '환출',
      'Mortal Blow': '강타',
      'Noahionto': '노아히온토',
      'Northswain\'s Strike': '북두골쇄타',
      'Ray of Light': '빛살',
      'Redemption': '파괴',
      'Sanction': '제재의 칼날',
      'Satellite Beam': '위성 저격',
      'Searchlight': '탐조등',
      'Shadowblade': '어둠의 검',
      'Shockwave': '충격파',
      'Stack': '모이기',
      'Sword In/Out': '검 안/밖',
      'Sword L/R': '검 좌/우',
      'Sword Out/In': '검 밖/안',
      'Sword Three In A Row': '3연속 검',
      'Thunder Slash': '뇌명검',
      'Time Eruption': '시간의 불기둥',
      'Towerfall': '무너지는 탑',
      'Ultimate Illusion': '궁극의 환상',
      'crystal stun': '크리스탈 스턴',
      'ghost stun': '유령 스턴'
    }
  }]
};
/* harmony default export */ const orbonne_monastery = (orbonne_monastery_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/alliance/orbonne_monastery.txt
const alliance_orbonne_monastery_namespaceObject = "# Orbonne Monastery\r\n# https://docs.google.com/document/d/1_TIg1l5ce36I2ACnyRIsCUIgVME6rr6GgtYarGlFTUA/edit\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n############\r\n# Mustadio #\r\n############\r\n# -p 373B:1012 -ii 3744 3742\r\n\r\n### Phase 1\r\n# Realm of the Machinists will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"B35\" } window 1000,0\r\n1012.0 \"Energy Burst\" Ability { id: \"373B\", source: \"Mustadio\" }\r\n1022.7 \"Arm Shot\" Ability { id: \"3739\", source: \"Mustadio\" }\r\n1033.2 \"L/R Handgonne\" Ability { id: \"373[EF]\", source: \"Mustadio\" }\r\n1042.5 \"L/R Handgonne\" Ability { id: \"373[EF]\", source: \"Mustadio\" }\r\n1058.6 \"Maintenance\" Ability { id: \"3734\", source: \"Mustadio\" }\r\n1065.1 \"Compress\" Ability { id: \"3740\", source: \"Iron Construct\" }\r\n1066.2 \"Searchlight\" Ability { id: \"373D\", source: \"Mustadio\" }\r\n1078.9 \"Energy Burst\" Ability { id: \"373B\", source: \"Mustadio\" }\r\n1085.6 \"Arm Shot\" Ability { id: \"3739\", source: \"Mustadio\" }\r\n1099.3 \"Analysis\" Ability { id: \"3735\", source: \"Mustadio\" }\r\n1099.5 \"--untargetable--\"\r\n1100.8 \"Ballistic Impact\" Ability { id: \"3745\", source: \"Mustadio\" }\r\n\r\n### DRAMATIC CUTSCENE~!\r\n1105.0 \"--sync--\" Ability { id: \"3746\", source: \"Mustadio\" } window 100,100\r\n1117.8 \"--sync--\" Ability { id: \"376C\", source: \"Mustadio\" }\r\n1123.8 \"Last Testament\" Ability { id: \"3737\", source: \"Mustadio\" }\r\n1131.5 \"--targetable--\"\r\n1141.4 \"Leg Shot\" Ability { id: \"3738\", source: \"Mustadio\" } duration 20\r\n1151.1 \"L/R Handgonne\" Ability { id: \"373[EF]\", source: \"Mustadio\" }\r\n1161.7 \"Energy Burst\" Ability { id: \"373B\", source: \"Mustadio\" }\r\n1178.0 \"Maintenance\" Ability { id: \"3734\", source: \"Mustadio\" }\r\n1184.7 \"Satellite Beam\" Ability { id: \"3741\", source: \"Early Turret\" }\r\n1190.7 \"Ballistic Missile\" Ability { id: \"373C\", source: \"Mustadio\" }\r\n1197.6 \"L/R Handgonne\" Ability { id: \"373[EF]\", source: \"Mustadio\" }\r\n1198.7 \"Ballistic Impact\" Ability { id: \"3743\", source: \"Mustadio\" }\r\n1204.0 \"L/R Handgonne\" Ability { id: \"373[EF]\", source: \"Mustadio\" }\r\n1213.4 \"Arm Shot\" Ability { id: \"3739\", source: \"Mustadio\" }\r\n1230.3 \"Maintenance\" Ability { id: \"3734\", source: \"Mustadio\" }\r\n1236.9 \"Satellite Beam\" Ability { id: \"3741\", source: \"Early Turret\" }\r\n1236.9 \"Compress\" Ability { id: \"3740\", source: \"Iron Construct\" }\r\n1241.1 \"Ballistic Missile\" Ability { id: \"373C\", source: \"Mustadio\" }\r\n1249.0 \"Ballistic Impact\" Ability { id: \"3743\", source: \"Mustadio\" }\r\n1256.4 \"Maintenance\" Ability { id: \"3734\", source: \"Mustadio\" }\r\n1263.0 \"Satellite Beam\" Ability { id: \"3741\", source: \"Early Turret\" }\r\n1263.0 \"Compress\" Ability { id: \"3740\", source: \"Iron Construct\" }\r\n1270.1 \"Energy Burst\" Ability { id: \"373B\", source: \"Mustadio\" }\r\n\r\n### Phase 3 Loop\r\n1281.0 \"Searchlight\" Ability { id: \"373D\", source: \"Mustadio\" }\r\n1287.9 \"Analysis\" Ability { id: \"3735\", source: \"Mustadio\" }\r\n1288.5 \"--untargetable--\"\r\n1291.2 \"--sync--\" Ability { id: \"3736\", source: \"Mustadio\" }\r\n1295.3 \"--sync--\" Ability { id: \"376C\", source: \"Mustadio\" }\r\n1301.3 \"Last Testament\" Ability { id: \"3737\", source: \"Mustadio\" } window 100,100\r\n1308.8 \"--targetable--\"\r\n1315.0 \"Energy Burst\" Ability { id: \"373B\", source: \"Mustadio\" }\r\n1327.9 \"Leg Shot\" Ability { id: \"3738\", source: \"Mustadio\" } duration 20\r\n1337.5 \"L/R Handgonne\" Ability { id: \"373[EF]\", source: \"Mustadio\" }\r\n1344.1 \"L/R Handgonne\" Ability { id: \"373[EF]\", source: \"Mustadio\" }\r\n1354.7 \"Energy Burst\" Ability { id: \"373B\", source: \"Mustadio\" }\r\n1361.5 \"Arm Shot\" Ability { id: \"3739\", source: \"Mustadio\" }\r\n1378.7 \"Maintenance\" Ability { id: \"3734\", source: \"Mustadio\" }\r\n1385.2 \"Satellite Beam\" Ability { id: \"3741\", source: \"Early Turret\" }\r\n1385.2 \"Compress\" Ability { id: \"3740\", source: \"Iron Construct\" }\r\n1389.3 \"Ballistic Missile\" Ability { id: \"373C\", source: \"Mustadio\" }\r\n1397.1 \"Ballistic Impact\" Ability { id: \"3743\", source: \"Mustadio\" }\r\n1403.8 \"Maintenance\" Ability { id: \"3734\", source: \"Mustadio\" }\r\n1410.4 \"Satellite Beam\" Ability { id: \"3741\", source: \"Early Turret\" }\r\n1410.4 \"Compress\" Ability { id: \"3740\", source: \"Iron Construct\" }\r\n1417.5 \"Energy Burst\" Ability { id: \"373B\", source: \"Mustadio\" }\r\n1428.4 \"Arm Shot\" Ability { id: \"3739\", source: \"Mustadio\" }\r\n1438.1 \"Ballistic Missile\" Ability { id: \"373C\", source: \"Mustadio\" }\r\n1445.0 \"L/R Handgonne\" Ability { id: \"373[EF]\", source: \"Mustadio\" }\r\n1446.0 \"Ballistic Impact\" Ability { id: \"3743\", source: \"Mustadio\" }\r\n1451.5 \"L/R Handgonne\" Ability { id: \"373[EF]\", source: \"Mustadio\" }\r\n1462.1 \"Energy Burst\" Ability { id: \"373B\", source: \"Mustadio\" }\r\n\r\n# fake loop\r\n1465.0 \"Searchlight\" Ability { id: \"373D\", source: \"Mustadio\" } window 100,100 jump 1281\r\n1471.9 \"Analysis\"\r\n1475.2 \"--sync--\"\r\n1479.3 \"--sync--\"\r\n1485.3 \"Last Testament\"\r\n\r\n##########\r\n# Agrias #\r\n##########\r\n# -p 3867:2012.8 3861:2504 -ii 3865 3853 3859 3AD2 3851 3860\r\n\r\n### Phase 1\r\n# Realm of the Templars will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"B36\" } window 2000,0\r\n2012.8 \"Divine Light\" Ability { id: \"3867\", source: \"Agrias\" }\r\n2023.3 \"Thunder Slash\" Ability { id: \"3866\", source: \"Agrias\" }\r\n2043.5 \"Judgment Blade\" Ability { id: \"3857\", source: \"Agrias\" }\r\n2054.9 \"Divine Light\" Ability { id: \"3867\", source: \"Agrias\" }\r\n2065.4 \"Thunder Slash\" Ability { id: \"3866\", source: \"Agrias\" }\r\n2076.4 \"Cleansing Flame\" Ability { id: \"3864\", source: \"Agrias\" }\r\n2085.0 \"--ghost stun--\"\r\n2091.0 \"Cleansing Strike\" Ability { id: \"3854\", source: \"Agrias\" }\r\n2106.2 \"Consecration\" Ability { id: \"3850\", source: \"Agrias\" }\r\n2106.2 \"--crystal stun--\"\r\n2123.9 \"Northswain's Strike\" Ability { id: \"3A86\", source: \"Agrias\" }\r\n2131.1 \"Divine Light\" Ability { id: \"3867\", source: \"Agrias\" }\r\n2136.6 \"Thunder Slash\" Ability { id: \"3866\", source: \"Agrias\" }\r\n2147.6 \"Hallowed Bolt Marks\" Ability { id: \"385A\", source: \"Agrias\" }\r\n2151.6 \"Hallowed Bolt In/Out\" Ability { id: \"385[BC]\", source: \"Agrias\" }\r\n2156.1 \"Hallowed Bolt Out/In\" Ability { id: \"385[BC]\", source: \"Agrias\" }\r\n2166.8 \"Cleansing Flame\" Ability { id: \"3864\", source: \"Agrias\" } window 50,50 # extra sync for folks inside\r\n2183.4 \"Judgment Blade\" Ability { id: \"3857\", source: \"Agrias\" }\r\n2189.8 \"Divine Light\" Ability { id: \"3867\", source: \"Agrias\" }\r\n\r\n### Adds Phase\r\n2196.6 \"--sync--\" Ability { id: \"385D\", source: \"Agrias\" }\r\n2222.3 \"Mortal Blow\" Ability { id: \"385E\", source: \"Sword Knight\" }\r\n2262.6 \"Enrage\"\r\n2500.0 \"--sync--\" StartsUsing { id: \"3861\", source: \"Agrias\" } window 500,0\r\n2508.0 \"Heavenly Judgment\" Ability { id: \"3861\", source: \"Agrias\" } window 10,10\r\n\r\n### Phase 3 Loop\r\n2524.4 \"Divine Ruination\" Ability { id: \"3858\", source: \"Agrias\" }\r\n2535.6 \"Divine Light\" Ability { id: \"3867\", source: \"Agrias\" }\r\n2546.1 \"Thunder Slash\" Ability { id: \"3866\", source: \"Agrias\" }\r\n2558.1 \"Cleansing Flame\" Ability { id: \"3864\", source: \"Agrias\" }\r\n2567.6 \"--ghost stun--\"\r\n2573.6 \"Cleansing Strike\" Ability { id: \"3854\", source: \"Agrias\" }\r\n2581.8 \"Consecration\" Ability { id: \"3850\", source: \"Agrias\" }\r\n2581.8 \"--crystal stun--\"\r\n2599.5 \"Northswain's Strike\" Ability { id: \"3A86\", source: \"Agrias\" }\r\n2606.7 \"Divine Light\" Ability { id: \"3867\", source: \"Agrias\" }\r\n2617.2 \"Hallowed Bolt Marks\" Ability { id: \"385A\", source: \"Agrias\" }\r\n2621.2 \"Hallowed Bolt In/Out\" Ability { id: \"385[BC]\", source: \"Agrias\" }\r\n2624.4 \"Cleansing Flame\" Ability { id: \"3864\", source: \"Agrias\" }\r\n2625.7 \"Hallowed Bolt Out/In\" Ability { id: \"385[BC]\", source: \"Agrias\" }\r\n# Ask me how I know that this can desync if everybody who is alive has\r\n# been vacuumed up to deal with ghosts and Agrias is left by her lonesome.\r\n2636.6 \"Thunder Slash\" Ability { id: \"3866\", source: \"Agrias\" } window 40,40\r\n2647.6 \"Divine Light\" Ability { id: \"3867\", source: \"Agrias\" } window 30,5\r\n2653.1 \"Divine Light\" Ability { id: \"3867\", source: \"Agrias\" }\r\n2667.7 \"Judgment Blade\" Ability { id: \"3857\", source: \"Agrias\" } window 50,50\r\n\r\n# fake loop lookahead\r\n2689.6 \"Divine Ruination\" Ability { id: \"3858\", source: \"Agrias\" } window 30,30 jump 2524.4\r\n2700.8 \"Divine Light\"\r\n2711.3 \"Thunder Slash\"\r\n2723.3 \"Cleansing Flame\"\r\n\r\n#######################\r\n# Dark Crusader Trash #\r\n#######################\r\n# -p 377F:3500 -ii 3780\r\n# Lifeless Alley will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"B37\" } window 3000,0\r\n3491.0 \"--sync--\" StartsUsing { id: \"377F\", source: \"Dark Crusader\" } window 500,0\r\n3500.0 \"Dark Rite\" Ability { id: \"377F\", source: \"Dark Crusader\" }\r\n3509.0 \"Noahionto\" Ability { id: \"377E\", source: \"Dark Crusader\" }\r\n3520.0 \"Infernal Wave\" #Ability { id: \"3781\", source: \"Dark Crusader\" }\r\n3523.5 \"Infernal Wave\" #Ability { id: \"3781\", source: \"Dark Crusader\" }\r\n3528.0 \"Noahionto\" Ability { id: \"377E\", source: \"Dark Crusader\" }\r\n3537.0 \"Noahionto\" Ability { id: \"377E\", source: \"Dark Crusader\" }\r\n3544.0 \"Noahionto\" Ability { id: \"377E\", source: \"Dark Crusader\" }\r\n\r\n3566.0 \"Dark Rite\" Ability { id: \"377F\", source: \"Dark Crusader\" }\r\n3575.0 \"Noahionto\" Ability { id: \"377E\", source: \"Dark Crusader\" }\r\n3584.0 \"Infernal Wave\" #Ability { id: \"3781\", source: \"Dark Crusader\" }\r\n3588.5 \"Infernal Wave\" #Ability { id: \"3781\", source: \"Dark Crusader\" }\r\n3594.0 \"Noahionto\" Ability { id: \"377E\", source: \"Dark Crusader\" }\r\n3603.0 \"Noahionto\" Ability { id: \"377E\", source: \"Dark Crusader\" }\r\n3610.5 \"Noahionto\" Ability { id: \"377E\", source: \"Dark Crusader\" }\r\n3625.5 \"Noahionto\" Ability { id: \"377E\", source: \"Dark Crusader\" }\r\n\r\n# FIXME: not sure what happens after this?\r\n# This isn't really a loop as there's 4x Noahionto in round 2.\r\n\r\n#######\r\n# Cid #\r\n#######\r\n#-p 3751:4015 36EB:4400 -ii 375F 3756 3757 3759 376B 3753 3752 375E 374B 3AD4 3AD3 3766 3767 3764 375B 374E\r\n\r\n### Phase 1\r\n# Realm of the Thunder God will be sealed off\r\n4000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"B38\" } window 4000,0\r\n4015.0 \"Cleansing Strike\" Ability { id: \"3751\", source: \"The Thunder God\" }\r\n4032.5 \"Sword L/R\" Ability { id: \"374[9A]\", source: \"The Thunder God\" }\r\n4042.5 \"Sword In/Out\" Ability { id: \"37(50|4F)\", source: \"The Thunder God\" }\r\n4057.0 \"Shadowblade\" Ability { id: \"375D\", source: \"The Thunder God\" }\r\n4062.6 \"Crush Helm\" duration 7\r\n4069.6 \"--sync--\" Ability { id: \"3754\", source: \"The Thunder God\" }\r\n4080.1 \"Sword L/R\" Ability { id: \"374[9A]\", source: \"The Thunder God\" }\r\n4090.1 \"Sword Out/In\" Ability { id: \"37(50|4F)\", source: \"The Thunder God\" }\r\n4110.2 \"Duskblade\" Ability { id: \"3761\", source: \"The Thunder God\" } # drift -0.045\r\n4123.2 \"Crush Weapon\" Ability { id: \"3755\", source: \"The Thunder God\" } # drift 0.046\r\n\r\n### Adds Phase\r\n4136.0 \"--untargetable--\"\r\n4136.0 \"Colosseum\" Ability { id: \"3762\", source: \"The Thunder God\" }\r\n4143.4 \"--targetable--\"\r\n4163.0 \"Hallowed Bolt\" Ability { id: \"3765\", source: \"Ephemeral Knight\" }\r\n4173.0 \"Stack\" Ability { id: \"3768\", source: \"Ephemeral Knight\" }\r\n4191.0 \"Hallowed Bolt\" Ability { id: \"3765\", source: \"Ephemeral Knight\" }\r\n4201.0 \"Divine Ruination\" Ability { id: \"3763\", source: \"Ephemeral Knight\" }\r\n4219.0 \"Hallowed Bolt\" Ability { id: \"3765\", source: \"Ephemeral Knight\" }\r\n4239.0 \"Enrage\"\r\n\r\n4400.0 \"--sync--\" Ability { id: \"36EB\", source: \"The Thunder God\" } window 400,0\r\n4401.0 \"--sync--\" Ability { id: \"3824\", source: \"The Thunder God\" } window 400,5\r\n4403.0 \"Balance Asunder\" Ability { id: \"376A\", source: \"The Thunder God\" }\r\n4420.0 \"--targetable--\"\r\n\r\n### Phase 3 Loop\r\n4438.5 \"Sword L/R\" Ability { id: \"374[9A]\", source: \"The Thunder God\" }\r\n4448.5 \"Sword In/Out\" Ability { id: \"37(50|4F)\", source: \"The Thunder God\" }\r\n4462.5 \"Crush Weapon\" Ability { id: \"3755\", source: \"The Thunder God\" }\r\n4465.6 \"Crush Helm\" duration 7\r\n4472.6 \"--sync--\" Ability { id: \"3754\", source: \"The Thunder God\" }\r\n4483.1 \"Sword Out/In\" Ability { id: \"37(50|4F)\", source: \"The Thunder God\" }\r\n4495.2 \"Sword Three In A Row\" Ability { id: \"374[CD]\", source: \"The Thunder God\" }\r\n4509.7 \"Cleansing Strike\" Ability { id: \"3751\", source: \"The Thunder God\" }\r\n4526.2 \"Crush Armor\" Ability { id: \"3758\", source: \"The Thunder God\" }\r\n4560.8 \"Shadowblade\" Ability { id: \"375D\", source: \"The Thunder God\" }\r\n4566.4 \"Crush Helm\" duration 7\r\n4573.4 \"--sync--\" Ability { id: \"3754\", source: \"The Thunder God\" }\r\n4587.9 \"Duskblade\" Ability { id: \"3761\", source: \"The Thunder God\" }\r\n4601.4 \"Crush Accessory\" Ability { id: \"375A\", source: \"The Thunder God\" }\r\n\r\n# fake loop\r\n4641.2 \"Sword L/R\" Ability { id: \"374[9A]\", source: \"The Thunder God\" } jump 4438.5\r\n4651.2 \"Sword In/Out\"\r\n4665.2 \"Crush Weapon\"\r\n4668.3 \"Crush Helm\"\r\n\r\n#################\r\n# Ultima part 1 #\r\n#################\r\n# -p 3899:5015 38D8:5413 3A79:5800 38C2:6007 -ii 389A 3897 38EA 38CC 3896 3C78 3A9B 38B6 389E 38BC 38B9 38BA 38BB 38BE 38AB 38A8 38A9 389F 38A6 38BD 38AE 38AD 3C78 38CF 38CD\r\n\r\n### Phase 1: Throwbacks\r\n# Crystalline Gaol will be sealed off\r\n5000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"B39\" } window 5000,0\r\n5015.0 \"Holy IV Ground\" Ability { id: \"3899\", source: \"Ultima, the High Seraph\" }\r\n5029.2 \"Auralight\" Ability { id: \"3898\", source: \"Ultima, the High Seraph\" }\r\n5035.7 \"Holy IV\" Ability { id: \"389B\", source: \"Ultima, the High Seraph\" }\r\n5045.4 \"Grand Cross\" Ability { id: \"38AC\", source: \"Ultima, the High Seraph\" } duration 15.5\r\n\r\n5071.8 \"Demi-Aquarius\" Ability { id: \"38BF\", source: \"Ultima, the High Seraph\" }\r\n5080.3 \"Dark Ewer\" Ability { id: \"38CA\", source: \"Demi-Famfrit\" }\r\n5083.5 \"Materialize\" Ability { id: \"38CB\", source: \"Aspersory\" }\r\n5089.1 \"Auralight\" Ability { id: \"3898\", source: \"Ultima, the High Seraph\" }\r\n5095.5 \"Holy IV\" Ability { id: \"389B\", source: \"Ultima, the High Seraph\" }\r\n\r\n5102.2 \"Demi-Aries\" Ability { id: \"38C0\", source: \"Ultima, the High Seraph\" }\r\n5116.7 \"Time Eruption\" Ability { id: \"38D0\", source: \"Demi-Belias\" }\r\n5119.5 \"Holy IV\" Ability { id: \"389B\", source: \"Ultima, the High Seraph\" }\r\n5119.7 \"Time Eruption\" Ability { id: \"38D1\", source: \"Demi-Belias\" }\r\n\r\n5127.7 \"Demi-Leo\" Ability { id: \"38C1\", source: \"Ultima, the High Seraph\" }\r\n5136.1 \"Control Tower\" Ability { id: \"38D4\", source: \"Demi-Hashmal\" }\r\n5137.1 \"Control Tower\" Ability { id: \"38D5\", source: \"Demi-Hashmal\" }\r\n5139.2 \"Sanction\" Ability { id: \"38D6\", source: \"Demi-Hashmal\" }\r\n5144.9 \"Holy IV Ground\" Ability { id: \"3899\", source: \"Ultima, the High Seraph\" }\r\n5146.7 \"Towerfall\" Ability { id: \"38D7\", source: \"Demi-Hashmal\" }\r\n5147.5 \"Holy IV\" Ability { id: \"389B\", source: \"Ultima, the High Seraph\" }\r\n\r\n5160.3 \"Grand Cross\" Ability { id: \"38AC\", source: \"Ultima, the High Seraph\" } duration 15.5\r\n5189.6 \"Auralight\" Ability { id: \"3898\", source: \"Ultima, the High Seraph\" }\r\n5196.1 \"Holy IV\" Ability { id: \"389B\", source: \"Ultima, the High Seraph\" }\r\n5207.8 \"Flare IV\" Ability { id: \"389C\", source: \"Ultima, the High Seraph\" }\r\n5208.3 \"Flare IV\" Ability { id: \"389D\", source: \"Ultima, the High Seraph\" }\r\n\r\n### Phase 2: 50% Push Remix \"Death awaits defiance!\"\r\n5400.0 \"--sync--\" AddedCombatant { name: \"Mustadio\" } window 400,0\r\n5413.0 \"Earth Hammer\" Ability { id: \"38D8\", source: \"Demi-Hashmal\" } window 400,5\r\n5415.9 \"Time Eruption\" Ability { id: \"38D0\", source: \"Demi-Belias\" }\r\n5418.9 \"Time Eruption\" Ability { id: \"38D1\", source: \"Demi-Belias\" }\r\n5421.3 \"Dark Ewer\" Ability { id: \"38CA\", source: \"Demi-Famfrit\" }\r\n5422.6 \"Dark Cannonade\" Ability { id: \"38CE\", source: \"Demi-Famfrit\" }\r\n5424.3 \"Materialize\" Ability { id: \"38CB\", source: \"Aspersory\" }\r\n5424.4 \"Hammerfall\" Ability { id: \"38D9\", source: \"Demi-Hashmal\" }\r\n5430.4 \"Eruption\" Ability { id: \"3C77\", source: \"Demi-Belias\" }\r\n5433.6 \"Extreme Edge\" Ability { id: \"38DA\", source: \"Demi-Hashmal\" }\r\n\r\n#5446.5 \"Crush Weapon\" Ability { id: \"38B3\", source: \"The Thunder God\" }\r\n#5449.6 \"Hallowed Bolt\" Ability { id: \"38B2\", source: \"Agrias\" }\r\n#5452.6 \"Searchlight\" Ability { id: \"38B1\", source: \"Mustadio\" }\r\n5482.0 \"Ultimate Illusion\" Ability { id: \"3895\", source: \"Ultima, the High Seraph\" }\r\n5505.5 \"--targetable--\"\r\n5523.0 \"Enrage\"\r\n\r\n5963.4 \"--sync--\" Ability { id: \"3A79\", source: \"Mustadio\" } window 1000,0\r\n5971.0 \"--sync--\" Ability { id: \"38B5\", source: \"Ramza\" } window 1000,5\r\n# 5991.0 \"Few can claim to have endured the might of my will.\"\r\n5995.6 \"--targetable--\"\r\n\r\n#################\r\n# Ultima part 2 #\r\n#################\r\n\r\n### Phase 1: March\r\n6004.0 \"--sync--\" StartsUsing { id: \"38C2\", source: \"Ultima, the High Seraph\" } window 1000,0\r\n6007.0 \"Demi-Virgo Line\" Ability { id: \"38C2\", source: \"Ultima, the High Seraph\" }\r\n6016.0 \"East/West March\" Ability { id: \"38A[01]\", source: \"Ultima, the High Seraph\" }\r\n6018.0 \"Ray of Light\" Ability { id: \"38B7\", source: \"Dominion\" }\r\n6026.4 \"Redemption\" Ability { id: \"38AA\", source: \"Ultima, the High Seraph\" }\r\n6035.5 \"Grand Cross\" Ability { id: \"38C8\", source: \"Ultima, the High Seraph\" } duration 15.5\r\n6043.4 \"East/West March\" Ability { id: \"38A[01]\", source: \"Ultima, the High Seraph\" }\r\n\r\n6062.0 \"Demi-Virgo Feet\" Ability { id: \"38C2\", source: \"Ultima, the High Seraph\" }\r\n6073.2 \"Redemption\" Ability { id: \"38AA\", source: \"Ultima, the High Seraph\" }\r\n\r\n6082.4 \"Demi-Virgo Tether\" Ability { id: \"38C2\", source: \"Ultima, the High Seraph\" }\r\n6087.5 \"Embrace\" Ability { id: \"38B8\", source: \"Dominion\" }\r\n6098.6 \"Holy IV Ground\" Ability { id: \"38C6\", source: \"Ultima, the High Seraph\" }\r\n6101.1 \"Holy IV\" Ability { id: \"389B\", source: \"Ultima, the High Seraph\" }\r\n\r\n### Phase 2: Maze Loop\r\n6124.9 \"Cataclysm\" Ability { id: \"38A4\", source: \"Ultima, the High Seraph\" }\r\n6126.8 \"Shockwave\" Ability { id: \"3894\", source: \"Ultima, the High Seraph\" }\r\n6143.4 \"East/West March\" Ability { id: \"38A[01]\", source: \"Ultima, the High Seraph\" }\r\n6157.8 \"Holy IV\" Ability { id: \"389B\", source: \"Ultima, the High Seraph\" }\r\n6170.8 \"Flare IV\" Ability { id: \"389D\", source: \"Ultima, the High Seraph\" }\r\n\r\n6186.6 \"Demi-Virgo Feet\" Ability { id: \"38C2\", source: \"Ultima, the High Seraph\" }\r\n6205.7 \"Grand Cross\" Ability { id: \"38C8\", source: \"Ultima, the High Seraph\" } duration 15.5\r\n6213.5 \"East/West March\" Ability { id: \"38A[01]\", source: \"Ultima, the High Seraph\" }\r\n6228.2 \"Redemption\" Ability { id: \"38AA\", source: \"Ultima, the High Seraph\" }\r\n6229.7 \"Holy IV\" Ability { id: \"389B\", source: \"Ultima, the High Seraph\" }\r\n\r\n6241.3 \"Demi-Virgo Tether\" Ability { id: \"38C2\", source: \"Ultima, the High Seraph\" }\r\n6246.5 \"Embrace\" Ability { id: \"38B8\", source: \"Dominion\" }\r\n\r\n6253.6 \"Demi-Virgo Line\" Ability { id: \"38C2\", source: \"Ultima, the High Seraph\" }\r\n6262.5 \"East/West March\" Ability { id: \"38A[01]\", source: \"Ultima, the High Seraph\" }\r\n6264.7 \"Ray of Light\" Ability { id: \"38B7\", source: \"Dominion\" }\r\n6271.1 \"Redemption\" Ability { id: \"38AA\", source: \"Ultima, the High Seraph\" }\r\n6272.5 \"Holy IV\" Ability { id: \"389B\", source: \"Ultima, the High Seraph\" }\r\n\r\n6280.3 \"Demi-Virgo Feet\" Ability { id: \"38C2\", source: \"Ultima, the High Seraph\" }\r\n6290.0 \"Holy IV\" Ability { id: \"389B\", source: \"Ultima, the High Seraph\" }\r\n6299.5 \"Grand Cross\" Ability { id: \"38C8\", source: \"Ultima, the High Seraph\" } duration 15.5\r\n6307.3 \"East/West March\" Ability { id: \"38A[01]\", source: \"Ultima, the High Seraph\" }\r\n\r\n# fake loop\r\n6325.4 \"Cataclysm\" Ability { id: \"38A4\", source: \"Ultima, the High Seraph\" } window 200,100 jump 6124.9\r\n6327.3 \"Shockwave\"\r\n6343.9 \"East/West March\"\r\n6358.3 \"Holy IV\"\r\n6371.3 \"Flare IV\"\r\n\r\n### Phase 3: 15% off Demi-Virgo Combo Platter\r\n# https://xivapi.com/InstanceContentTextData/20933\r\n# en: I see it now. In you...his blood, my vanquisher in times...long past. But not so soon...shall I accept defeat...\r\n6500.0 \"--sync--\" BattleTalk2 { instanceContentTextId: \"51C5\" } window 500,0\r\n\r\n6503.0 \"Demi-Virgo Line/Tether\" Ability { id: \"38C2\", source: \"Ultima, the High Seraph\" } window 8,8\r\n6509.1 \"Redemption\" Ability { id: \"38AA\", source: \"Ultima, the High Seraph\" }\r\n6510.4 \"Holy IV\" Ability { id: \"389B\", source: \"Ultima, the High Seraph\" }\r\n6513.9 \"Ray of Light\" Ability { id: \"38B7\", source: \"Dominion\" } # drift -0.044\r\n\r\n6516.3 \"Demi-Virgo Tether/Feet\" Ability { id: \"38C2\", source: \"Ultima, the High Seraph\" } window 8,8\r\n6518.8 \"Holy IV\" Ability { id: \"389B\", source: \"Ultima, the High Seraph\" }\r\n6524.6 \"Redemption\" Ability { id: \"38AA\", source: \"Ultima, the High Seraph\" }\r\n6526.1 \"Holy IV\" Ability { id: \"389B\", source: \"Ultima, the High Seraph\" }\r\n6532.8 \"Redemption\" Ability { id: \"38AA\", source: \"Ultima, the High Seraph\" }\r\n\r\n# fake loop\r\n6540.0 \"Demi-Virgo Line/Tether\" Ability { id: \"38C2\", source: \"Ultima, the High Seraph\" } window 20,20 jump 6503\r\n6546.1 \"Redemption\"\r\n6547.4 \"Holy IV\"\r\n6550.9 \"Ray of Light\"\r\n\r\n6553.3 \"Demi-Virgo Tether/Feet\"\r\n6555.8 \"Holy IV\"\r\n6561.6 \"Redemption\"\r\n6563.1 \"Holy IV\"\r\n6569.8 \"Redemption\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/alliance/ridorana_lighthouse.ts




const mathDirection = (mathBaseValue, correctMath, output) => {
  if (mathBaseValue === undefined) return;
  if (mathBaseValue < 1 || mathBaseValue > 9) {
    console.error(`Bad math: ${mathBaseValue}`);
    return;
  }
  const correctValue = correctMath[mathBaseValue];
  if (correctValue === undefined) throw new not_reached/* UnreachableCode */.$();
  return [output.stayOut(), output.standIn1(), output.standIn2(), output.standIn3(), output.standIn4()][correctValue];
};
const mathOutputStrings = {
  stayOut: {
    en: 'Stay out',
    de: 'Draußen stehen',
    fr: 'Restez à l\'extérieur',
    ja: '入らない',
    cn: '远离',
    ko: '바깥에 있기'
  },
  standIn1: {
    en: 'Stand in 1',
    de: 'In 1 stehen',
    fr: 'Placez-vous sur le 1',
    ja: '１を踏む',
    cn: '站在 1',
    ko: '답: 1'
  },
  standIn2: {
    en: 'Stand in 2',
    de: 'In 2 stehen',
    fr: 'Placez-vous sur le 2',
    ja: '２を踏む',
    cn: '站在 2',
    ko: '답: 2'
  },
  standIn3: {
    en: 'Stand in 3',
    de: 'In 3 stehen',
    fr: 'Placez-vous sur le 3',
    ja: '３を踏む',
    cn: '站在 3',
    ko: '답: 3'
  },
  standIn4: {
    en: 'Stand in 4',
    de: 'In 4 stehen',
    fr: 'Placez-vous sur le 4',
    ja: '４を踏む',
    cn: '站在 4',
    ko: '답: 4'
  }
};
const ridorana_lighthouse_triggerSet = {
  id: 'TheRidoranaLighthouse',
  zoneId: zone_id/* default.TheRidoranaLighthouse */.Z.TheRidoranaLighthouse,
  timelineFile: 'ridorana_lighthouse.txt',
  timelineTriggers: [{
    id: 'Ridorana Stone Breath',
    regex: /Stone Breath/,
    beforeSeconds: 7,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }],
  triggers: [{
    id: 'Ridorana Famfrit Tide Pode',
    type: 'StartsUsing',
    netRegex: {
      id: '2C3E',
      source: 'Famfrit, The Darkening Cloud'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ridorana Famfrit Tsunami 1',
    type: 'StartsUsing',
    netRegex: {
      id: '2C50',
      source: 'Famfrit, The Darkening Cloud',
      capture: false
    },
    delaySeconds: 4.5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look for Tsunami',
        de: 'Auf Krug achten',
        fr: 'Repérez le Tsunami',
        ja: '水瓶が向いてる方向から離れる',
        cn: '离开水瓶口方向',
        ko: '대해일 확인'
      }
    }
  }, {
    id: 'Ridorana Famfrit Tsunami 2',
    type: 'StartsUsing',
    netRegex: {
      id: '2C50',
      source: 'Famfrit, The Darkening Cloud',
      capture: false
    },
    delaySeconds: 16.5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look for Tsunami',
        de: 'Auf Krug achten',
        fr: 'Repérez le Tsunami',
        ja: '水瓶が向いてる方向から離れる',
        cn: '离开水瓶口方向',
        ko: '대해일 확인'
      }
    }
  }, {
    id: 'Ridorana Famfrit Tsunami 3',
    type: 'StartsUsing',
    netRegex: {
      id: '2C50',
      source: 'Famfrit, The Darkening Cloud',
      capture: false
    },
    delaySeconds: 28.5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look for Tsunami',
        de: 'Auf Krug achten',
        fr: 'Repérez le Tsunami',
        ja: '水瓶が向いてる方向から離れる',
        cn: '离开水瓶口方向',
        ko: '대해일 확인'
      }
    }
  }, {
    id: 'Ridorana Famfrit Dark Cannonade',
    type: 'HeadMarker',
    netRegex: {
      id: '0037'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.doritoStack */.n3.doritoStack()
  }, {
    id: 'Ridorana Famfrit Briny Cannonade',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Ridorana Famfrit Dark Rain',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Dark Rain',
      capture: false
    },
    suppressSeconds: 10,
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'Ridorana Belias Fire',
    type: 'StartsUsing',
    netRegex: {
      id: '2CDB',
      source: 'Belias, The Gigas'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ridorana Belias Time Eruption',
    type: 'StartsUsing',
    netRegex: {
      id: '2CDE',
      source: 'Belias, The Gigas',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand on Slow Clock',
        de: 'In der langsamen Uhr stehen',
        fr: 'Placez-vous sur une horloge lente',
        ja: '遅い時計で待機（早い方が爆発したらすぐ安置へ）',
        cn: '站慢速时钟等待',
        ko: '느린 시계 위로'
      }
    }
  }, {
    // Burns effect.
    id: 'Ridorana Belias Hand of Time',
    type: 'GainsEffect',
    netRegex: {
      effectId: '212'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stretch Tether Outside',
        de: 'Verbindung nach außen strecken',
        fr: 'Étirez le lien vers l\'exterieur',
        ja: '線を伸ばして外に向ける',
        cn: '将连线朝外远离人群',
        ko: '줄 바깥으로 늘이기'
      }
    }
  }, {
    id: 'Ridorana Belias Time Bomb',
    type: 'StartsUsing',
    netRegex: {
      id: '2CE6',
      source: 'Belias, The Gigas',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stop Clocks',
        de: 'Uhrzeiger nach außen',
        fr: 'Arrêtez les horloges',
        ja: '針を外に向ける',
        cn: '定时炸弹',
        ko: '시간 폭탄'
      }
    }
  }, {
    id: 'Ridorana Belias Gigas',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Gigas',
      capture: false
    },
    suppressSeconds: 10,
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'Ridorana Construct Destroy',
    type: 'StartsUsing',
    netRegex: {
      id: ['2C5A', '2C71'],
      source: 'Construct 7'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ridorana Construct Accelerate Spread',
    type: 'HeadMarker',
    netRegex: {
      id: '008A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: data => data.accelerateSpreadOnMe = true,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Ridorana Construct Accelerate Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '0064'
    },
    condition: data => !data.accelerateSpreadOnMe,
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Ridorana Construct Accelerate Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '2C65',
      source: 'Construct 7',
      capture: false
    },
    run: data => delete data.accelerateSpreadOnMe
  }, {
    id: 'Ridorana Construct Math Setup',
    type: 'StartsUsing',
    netRegex: {
      id: '2C6C',
      source: 'Construct 7',
      capture: false
    },
    run: data => data.mathBaseValue = 0
  }, {
    // Hp Penalty effect.
    id: 'Ridorana Construct Math HP Check 1',
    type: 'GainsEffect',
    netRegex: {
      effectId: '615'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: data => {
      if (!data.mathBaseValue && data.currentHP > 0 && data.currentHP < 10) data.mathBaseValue = data.currentHP;
    }
  }, {
    // Not 100% convinced that hp will have updated exactly when the hp penalty
    // trigger happens.  However, by t=1 second in testing, standing a circle
    // will apply.  So, hope for the best by testing at t=0.5 as well, but not
    // overwriting any results from t=0 if that was valid.
    id: 'Ridorana Construct Math HP Check 2',
    type: 'GainsEffect',
    netRegex: {
      effectId: '615'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: data => {
      if (!data.mathBaseValue && data.currentHP > 0 && data.currentHP < 10) data.mathBaseValue = data.currentHP;
    },
    delaySeconds: 0.5
  }, {
    id: 'Ridorana Construct Divide By Five',
    type: 'StartsUsing',
    netRegex: {
      id: '2CCD',
      source: 'Construct 7',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const correctMath = [-1, 4, 3, 2, 1, 0, 4, 3, 2, 1];
      return mathDirection(data.mathBaseValue, correctMath, output);
    },
    outputStrings: mathOutputStrings
  }, {
    id: 'Ridorana Construct Divide By Four',
    type: 'StartsUsing',
    netRegex: {
      id: '2CCC',
      source: 'Construct 7',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const correctMath = [-1, 3, 2, 1, 0, 3, 2, 1, 0, 3];
      return mathDirection(data.mathBaseValue, correctMath, output);
    },
    outputStrings: mathOutputStrings
  }, {
    id: 'Ridorana Construct Divide By Three',
    type: 'StartsUsing',
    netRegex: {
      id: '2CCA',
      source: 'Construct 7',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const correctMath = [-1, 2, 1, 0, 2, 1, 0, 2, 1, 0];
      return mathDirection(data.mathBaseValue, correctMath, output);
    },
    outputStrings: mathOutputStrings
  }, {
    id: 'Ridorana Construct Indivisible',
    type: 'StartsUsing',
    netRegex: {
      id: '2CCE',
      source: 'Construct 7',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const correctMath = [-1, 1, 0, 0, 1, 0, 1, 0, 3, 2];
      return mathDirection(data.mathBaseValue, correctMath, output);
    },
    outputStrings: mathOutputStrings
  }, {
    id: 'Ridorana Construct Pulverize',
    type: 'StartsUsing',
    netRegex: {
      id: '2C61',
      source: 'Construct 7',
      capture: false
    },
    // 16 yalms
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Ridorana Construct Dispose',
    type: 'StartsUsing',
    netRegex: {
      id: ['2C5F', '2CE9'],
      source: 'Construct 7',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Ridorana Construct Acceleration Bomb',
    type: 'GainsEffect',
    netRegex: {
      effectId: '568'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 2,
    response: responses/* Responses.stopEverything */.n3.stopEverything()
  }, {
    id: 'Ridorana Yiazmat Rake Buster',
    type: 'StartsUsing',
    netRegex: {
      id: '2D4E',
      source: 'Yiazmat'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ridorana Yiazmat Rake Charge',
    type: 'StartsUsing',
    netRegex: {
      id: '2E32',
      source: 'Yiazmat',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Ridorana Yiazmat White Breath',
    type: 'StartsUsing',
    netRegex: {
      id: '2C31',
      source: 'Yiazmat',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Ridorana Yiazmat Magnetic Negative',
    type: 'GainsEffect',
    netRegex: {
      effectId: '60F'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move to Positive',
        de: 'Ins Positive laufen',
        fr: 'Allez sur le positif',
        ja: 'プラス（＋）へ',
        cn: '移动到正极',
        ko: '+전하 쪽으로'
      }
    }
  }, {
    id: 'Ridorana Yiazmat Magnetic Positive',
    type: 'GainsEffect',
    netRegex: {
      effectId: '60E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move to Negative',
        de: 'Ins Negative laufen',
        fr: 'Allez sur le négatif',
        ja: 'マイナス（－）へ',
        cn: '移动到负极',
        ko: '-전하 쪽으로'
      }
    }
  }, {
    id: 'Ridorana Yiazmat Archaeodemon',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Archaeodemon',
      capture: false
    },
    suppressSeconds: 10,
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'Ridorana Yiazmat Heart',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Heart Of The Dragon',
      capture: false
    },
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Heart',
        de: 'Herz',
        fr: 'Tuer le cœur',
        ja: '心核を討つ',
        cn: '消灭boss核心',
        ko: '심핵 처리'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Archaeodemon': 'Archaeodämon',
      'Belias, The Gigas': 'Dämonid Belias',
      'Construct 7': 'Automat Nr\\. 7',
      'Dark Rain': 'Dunkler Regen',
      'Echoes from Time\'s Garden': 'Garten ewiger Zeit',
      'Famfrit, The Darkening Cloud': 'Dunkelfürst Famfrit',
      '(?<!Belias, The )Gigas': 'Diener von Belias',
      'Heart of the Dragon': 'Herz des Drachen',
      'The Cleft of Profaning Wind': 'Kluft entweihender Winde',
      'The Clockwork Coliseum': 'Kolosseum von Gog',
      'The Spire\'s Bounds': 'Katastase',
      'Yiazmat': 'Yiasmat'
    },
    'replaceText': {
      '\\(close\\)': '(Nahe)',
      '\\(cross\\)': '(Kreuz)',
      '\\(combo\\)': '(Kombo)',
      '\\(orbit\\)': '(Orbit)',
      '\\(far\\)': '(Entfernt)',
      '\\(single\\)': '(Einzeln)',
      'Accelerate': 'Beschleunigen',
      'Annihilation Mode': 'Auslöschungsmodul',
      'Archaeodemon spawn': 'Archaeodämon erscheint',
      'Area Lockdown': 'Gebiet geschlossen',
      'Briny Cannonade': 'Aquarion',
      'Compress': 'Zerdrücken',
      'Computation Mode': 'Standardmodul',
      'Crimson Cyclone': 'Zinnober-Zyklon',
      '(?<! )Cyclone': 'Zyklon',
      'Dark Cannonade': 'Dunkler Blitz',
      'Dark Ewer': 'Dunkler Wasserkrug',
      'Dark Rain': 'Dunkler Regen',
      'Darkening Deluge': 'Düstere Flut',
      'Darkening Rainfall': 'Verdunkelnder Niederschlag',
      'Death Strike': 'Extonso Tod',
      'Destroy': 'Zerstören',
      'Dispose': 'Entsorgen',
      'Division': 'Division',
      'Dust Storm': 'Staubsturm',
      '(?<![\\w| ])Eruption': 'Eruption',
      'Fast Hands': 'Schnelle Hände',
      '(?<!\\w)Fire(?! )': 'Feuer',
      'Fire IV': 'Feuka',
      'Gale Gaol': 'Windgefängnis',
      'Gigas spawns': 'Gigas erscheint',
      'Growing Threat': 'Mirakel',
      'Gust Front': 'Böenfront',
      'Hellfire': 'Höllenfeuer',
      'Ignite': 'Entzünden',
      'Incinerate': 'Einäschern',
      'Karma': 'Lebensbruch',
      'Lithobrake': 'Erledigen',
      'Magnetic Genesis': 'Magnetische Stabilisierung',
      'Magnetic Lysis': 'Magnetische Auflösung',
      'Pulverize': 'Zermahlen',
      '(?<!\\w)Rake': 'Prankenhieb',
      'Slow Hands': 'Langsame Hände',
      'Solar Storm': 'Sonnensturm',
      'Stone Breath': 'Petri-Atem',
      'Subtract': 'Subtrahieren',
      'Summon': 'Beschwörung',
      'Tartarus Mode': 'Tartarus-Modul',
      'The Hand Of Time': 'Die Hand der Zeit',
      'Tide Pod': 'Gezeitenschlag',
      'Time Bomb': 'Zeitbombe',
      'Time Eruption': 'Zeiteruption',
      'Tsunami': 'Sturzflut',
      'Unholy Darkness': 'Unheiliges Dunkel',
      'Ventilate': 'Abkühlen',
      'Water IV': 'Giga-Aqua',
      'White Breath': 'Kalkatem'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Archaeodemon': 'archéodémon',
      'Belias, The Gigas': 'Bélias le Titan',
      'Construct 7': 'Bâtisseur n°7',
      'Dark Rain': 'sphère d\'eau ténébreuse',
      'Echoes from Time\'s Garden': 'Jardin d\'un autre temps',
      'Famfrit, The Darkening Cloud': 'Famfrit le Nuage Ténébreux',
      '(?<! )Gigas': 'serviteur de Bélias',
      'Heart of the Dragon': 'cœur de Yiazmat',
      'The Cleft of Profaning Wind': 'la corniche des Vents distordants',
      'The Clockwork Coliseum': 'l\'arène de Goug',
      'The Spire\'s Bounds': 'l\'orée des Cieux',
      'Yiazmat': 'Yiazmat'
    },
    'replaceText': {
      '\\(close\\)': '(proche)',
      '\\(combo\\)': '(combo)',
      '\\(far\\)': '(loin)',
      '\\(single\\)': '(unique)',
      'Accelerate': 'Aplatir',
      'Annihilation Mode': 'Module Exterminator',
      'Archaeodemon spawn': 'Apparition des Archéodémons',
      'Area Lockdown': 'Verrouillage de la zone',
      'Briny Cannonade': 'Aqua-canon',
      'Compress': 'Écraser',
      'Computation Mode': 'Module d\'arithmétique',
      'Crimson Cyclone': 'Cyclone écarlate',
      '(?<! )Cyclone': 'Cyclone',
      'Dark Cannonade': 'Bombardement ténébreux',
      'Dark Ewer': 'Aiguières ténèbreuses',
      'Dark Rain': 'Trombe d\'eau',
      'Darkening Deluge': 'Nuage stagnant',
      'Darkening Rainfall': 'Averse ténébreuse',
      'Death Strike': 'Pentacle mortel',
      'Destroy': 'Détruire',
      'Dispose': 'Annihiler',
      'Division': 'Division',
      'Dust Storm': 'Tempête de poussière',
      '(?<![\\w| ])Eruption': 'Éruption',
      'Fast Hands': 'Mains rapides',
      '(?<!\\w)Fire(?! )': 'Feu',
      'Fire IV': 'Giga Feu',
      'Gale Gaol': 'Prison de vent',
      'Gigas spawns': 'Apparition des serviteurs de Bélias',
      'Growing Threat': 'Exacerbation',
      'Gust Front': 'Front de rafales',
      'Hellfire': 'Flammes de l\'enfer',
      'Ignite': 'Carboniser',
      'Incinerate': 'Incinérer',
      'Karma': 'Souffrance',
      'Lithobrake': 'Percuter',
      'Magnetic Genesis': 'Stabilisation du champ magnétique',
      'Magnetic Lysis': 'Dérèglement magnétique',
      'Pulverize': 'Broyer',
      '(?<!\\w)Rake': 'Griffes',
      'Slow Hands': 'Mains lente',
      'Solar Storm': 'Tempête solaire',
      'Stone Breath': 'Souffle pétrifiant',
      'Subtract': 'Soustraire',
      'Summon': 'Invocation',
      'Tartarus Mode': 'Module Tartaros',
      'The Hand Of Time': 'Trotteuse de l\'au-delà',
      'Tide Pod': 'Frappe aqueuse',
      'Time Bomb': 'Bombe à retardement',
      'Time Eruption': 'Éruption à retardement',
      'Tsunami': 'Tsunami',
      'Unholy Darkness': 'Miracle sombre',
      'Ventilate': 'Réfrigérer',
      'Water IV': 'Giga eau',
      'White Breath': 'Souffle blanc'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Archaeodemon': 'アルケオデーモン',
      'Belias, The Gigas': '魔人ベリアス',
      'Construct 7': '労働七号',
      'Dark Rain': '暗黒の雨水',
      'Echoes from Time\'s Garden': 'はるかなる時の庭',
      'Famfrit, The Darkening Cloud': '暗黒の雲ファムフリート',
      '(?<! )Gigas': '魔人兵',
      'Heart of the Dragon': 'ヤズマットの心核',
      'The Cleft of Profaning Wind': '異なる風吹く白き戦場',
      'The Clockwork Coliseum': 'ゴーグ・コロセウム',
      'The Spire\'s Bounds': '至頂の封域',
      'Yiazmat': '鬼龍ヤズマット'
    },
    'replaceText': {
      '\\(close\\)': '(近い)',
      '\\(combo\\)': '(コンボ)',
      '\\(orbit\\)': '(曲線)',
      '\\(far\\)': '(遠い)',
      '\\(single\\)': '(一撃)',
      'Accelerate': '突貫する',
      'Annihilation Mode': 'ジェノサイドチップ',
      'Archaeodemon spawn': 'アルケオデーモン',
      'Area Lockdown': '領域封鎖',
      'Briny Cannonade': '蒼の砲撃',
      'Compress': '圧縮する',
      'Computation Mode': '算術チップ',
      'Crimson Cyclone': 'クリムゾンサイクロン',
      '(?<! )Cyclone': 'サイクロン',
      'Dark Cannonade': '闇の砲撃',
      'Dark Ewer': '暗雲の水瓶',
      'Dark Rain': '暗雲の雨水',
      'Darkening Deluge': '暗雲の淀み',
      'Darkening Rainfall': '暗雲の雨',
      'Death Strike': '必殺',
      'Destroy': '破壊する',
      'Dispose': '処理する',
      'Division': '算術',
      'Dust Storm': 'ダストストーム',
      '(?<![\\w| ])Eruption': 'エラプション',
      'Fast Hands': '早い手',
      '(?<!\\w)Fire(?! )': 'ファイア',
      'Fire IV': 'ファイジャ',
      'Gale Gaol': '風牢',
      'Gigas spawns': 'ギガス',
      'Growing Threat': '驚異',
      'Gust Front': 'ガストフロント',
      'Hellfire': '地獄の火炎',
      'Ignite': '放熱する',
      'Incinerate': '焼却する',
      'Karma': 'ライフブレイク',
      'Lithobrake': '落着する',
      'Magnetic Genesis': '磁場生成',
      'Magnetic Lysis': '磁場崩壊',
      'Pulverize': '粉砕する',
      '(?<!\\w)Rake': 'ひっかき',
      'Slow Hands': '遅い手',
      'Solar Storm': 'ソーラーストーム',
      'Stone Breath': 'ペトロブレス',
      'Subtract': '減算する',
      'Summon': '召喚',
      'Tartarus Mode': 'タルタロスチップ',
      'The Hand Of Time': '異界の時針',
      'Tide Pod': '水流弾',
      'Time Bomb': 'タイムボム',
      'Time Eruption': 'タイムエラプション',
      'Tsunami': '大海嘯',
      'Unholy Darkness': 'ダークホーリー',
      'Ventilate': '冷却する',
      'Water IV': 'ウォタジャ',
      'White Breath': 'ホワイトブレス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Archaeodemon': '古恶魔',
      'Belias, The Gigas': '魔人贝利亚斯',
      'Construct 7': '劳动七号',
      'Dark Rain': '暗黑雨水',
      'Echoes from Time\'s Garden': '悠久时光庭园',
      'Famfrit, The Darkening Cloud': '暗黑之云法姆弗里特',
      '(?<! )Gigas': '魔人兵',
      'Heart of the Dragon': '鬼龙的核心',
      'The Cleft of Profaning Wind': '吹拂异风的白色战场',
      'The Clockwork Coliseum': '高古斗技场',
      'The Spire\'s Bounds': '至顶封域',
      'Yiazmat': '鬼龙雅兹玛特'
    },
    'replaceText': {
      '\\(close\\)': '(靠近)',
      '\\(cross\\)': '(X)',
      '\\(combo\\)': '(组合)',
      '\\(orbit\\)': '(曲线)',
      '\\(far\\)': '(远离)',
      '\\(single\\)': '(单个)',
      'Accelerate': '执行贯穿',
      'Annihilation Mode': '灭绝芯片',
      'Archaeodemon spawn': '古恶魔出现',
      'Area Lockdown': '区域封锁',
      'Briny Cannonade': '苍炮击',
      'Compress': '执行压缩',
      'Computation Mode': '算术芯片',
      'Crimson Cyclone': '深红旋风',
      '(?<! )Cyclone': '气旋',
      'Dark Cannonade': '暗炮击',
      'Dark Ewer': '暗云水瓶',
      'Dark Rain': '暗黑雨水',
      'Darkening Deluge': '暗云沉淀',
      'Darkening Rainfall': '暗云之雨',
      'Death Strike': '必杀',
      'Destroy': '执行破坏',
      'Dispose': '执行清理',
      'Division': '除法',
      'Dust Storm': '尘暴',
      '(?<![\\w| ])Eruption': '地火喷发',
      'Fast Hands': '快手',
      '(?<!\\w)Fire(?! )': '火炎',
      'Fire IV': '炽炎',
      'Gale Gaol': '风牢',
      'Gigas spawns': '魔人兵出现',
      'Growing Threat': '惊异',
      'Gust Front': '飑风',
      'Hellfire': '地狱之火炎',
      'Ignite': '执行放热',
      'Incinerate': '执行焚烧',
      'Karma': '生命停止',
      'Lithobrake': '执行落地',
      'Magnetic Genesis': '磁场生成',
      'Magnetic Lysis': '磁场崩坏',
      'Pulverize': '执行粉碎',
      '(?<!\\w)Rake': '利爪',
      'Slow Hands': '慢手',
      'Solar Storm': '太阳风暴',
      'Stone Breath': '石化吐息',
      'Subtract': '执行减算',
      'Summon': '召唤',
      'Tartarus Mode': '冥狱芯片',
      'The Hand Of Time': '异界时针',
      'Tide Pod': '水流弹',
      'Time Bomb': '时空爆弹',
      'Time Eruption': '时空地火喷发',
      'Tsunami': '大海啸',
      'Unholy Darkness': '黑暗神圣',
      'Ventilate': '执行冷却',
      'Water IV': '骇水',
      'White Breath': '苍白吐息'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Archaeodemon': '원시 악마',
      'Belias, The Gigas': '마인 벨리아스',
      'Construct 7': '노동 7호',
      'Dark Rain': '암흑의 빗물',
      'Echoes from Time\'s Garden': '아득한 시간의 정원',
      'Famfrit, The Darkening Cloud': '암흑의 구름 팜프리트',
      '(?<! )Gigas': '마인병',
      'Heart of the Dragon': '야즈마트의 심핵',
      'The Cleft of Profaning Wind': '다른 바람이 부는 하얀 전장',
      'The Clockwork Coliseum': '거그 투기장',
      'The Spire\'s Bounds': '정점의 봉인 영역',
      'Yiazmat': '귀룡 야즈마트'
    },
    'replaceText': {
      '\\(close\\)': '(가까이)',
      '\\(cross\\)': '(X)',
      '\\(combo\\)': '(콤보)',
      '\\(far\\)': '(멀리)',
      '\\(orbit\\)': '(떠있음)',
      '\\(single\\)': '(1회)',
      'Accelerate': '관통',
      'Annihilation Mode': '제노사이드 칩',
      'Archaeodemon spawn': '원시 악마 생성',
      'Area Lockdown': '지역 봉쇄',
      'Briny Cannonade': '푸른 포격',
      'Compress': '압축',
      'Computation Mode': '계산 칩',
      'Crimson Cyclone': '진홍 회오리',
      '(?<! )Cyclone': '회오리',
      'Dark Cannonade': '어둠의 포격',
      'Dark Ewer': '암운의 물병',
      'Dark Rain': '암운의 빗물',
      'Darkening Deluge': '암운의 웅덩이',
      'Darkening Rainfall': '암운의 비',
      'Death Strike': '필살',
      'Destroy': '파괴',
      'Dispose': '처리',
      'Division': '나눗셈',
      'Dust Storm': '먼지 폭풍',
      '(?<![\\w| ])Eruption': '용암 분출',
      'Fast Hands': '빠른 시계 터짐',
      '(?<!\\w)Fire(?! )': '파이어',
      'Fire IV': '파이쟈',
      'Gale Gaol': '바람 감옥',
      'Gigas spawns': '마인병 생성',
      'Growing Threat': '경이',
      'Gust Front': '돌풍전선',
      'Hellfire': '지옥의 화염',
      'Ignite': '열 방출',
      'Incinerate': '소각',
      'Karma': '생명 파괴',
      'Lithobrake': '착륙',
      'Magnetic Genesis': '자기장 생성',
      'Magnetic Lysis': '자기장 붕괴',
      'Pulverize': '분쇄',
      '(?<!\\w)Rake': '할퀴기',
      'Slow Hands': '느린 시계 터짐',
      'Solar Storm': '태양 폭풍',
      'Stone Breath': '석화 숨결',
      'Subtract': '뺄셈',
      'Summon': '소환',
      'Tartarus Mode': '타르타로스 칩',
      'The Hand Of Time': '이계의 시침',
      'Tide Pod': '물 탄환',
      'Time Bomb': '시간 폭탄',
      'Time Eruption': '시간의 불기둥',
      'Tsunami': '대해일',
      'Unholy Darkness': '다크 홀리',
      'Ventilate': '냉각',
      'Water IV': '워터쟈',
      'White Breath': '하얀 숨결'
    }
  }]
};
/* harmony default export */ const ridorana_lighthouse = (ridorana_lighthouse_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/alliance/ridorana_lighthouse.txt
const alliance_ridorana_lighthouse_namespaceObject = "# The Ridorana Lighthouse\r\n# https://docs.google.com/document/d/1EJMARltDR6Pmts1o5gqMl9pd5weTfROVFu1o1YwgAPk/edit\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n###########\r\n# Famfrit #\r\n###########\r\n# Echoes from Time's Garden will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"998\" } window 0,1\r\n13 \"Tide Pod\" Ability { id: \"2C3E\", source: \"Famfrit, The Darkening Cloud\" } window 13,1\r\n26 \"Water IV\" Ability { id: \"2C3D\", source: \"Famfrit, The Darkening Cloud\" }\r\n35 \"Briny Cannonade\" Ability { id: \"2C45\", source: \"Famfrit, The Darkening Cloud\" }\r\n47 \"Tsunami\" Ability { id: \"2C50\", source: \"Famfrit, The Darkening Cloud\" }\r\n54 \"Tsunami\" duration 3\r\n66 \"Tsunami\" duration 3\r\n78 \"Tsunami\" duration 3\r\n86 \"Water IV\" Ability { id: \"2C3D\", source: \"Famfrit, The Darkening Cloud\" }\r\n97 \"Dark Ewer (cross)\" Ability { id: \"2C43\", source: \"Famfrit, The Darkening Cloud\" }\r\n110 \"Tide Pod\" Ability { id: \"2C3E\", source: \"Famfrit, The Darkening Cloud\" }\r\n118 \"Briny Cannonade\" Ability { id: \"2C41\", source: \"Famfrit, The Darkening Cloud\" }\r\n119 \"Briny Cannonade\" Ability { id: \"2C45\", source: \"Famfrit, The Darkening Cloud\" }\r\n124 \"Dark Ewer (orbit)\" Ability { id: \"2C43\", source: \"Famfrit, The Darkening Cloud\" }\r\n139 \"Dark Rain\" Ability { id: \"2C40\", source: \"Famfrit, The Darkening Cloud\" }\r\n\r\n# Begin loop\r\n151 \"Water IV\" Ability { id: \"2C3D\", source: \"Famfrit, The Darkening Cloud\" }\r\n164 \"Darkening Rainfall\" Ability { id: \"2C3F\", source: \"Famfrit, The Darkening Cloud\" }\r\n169 \"Darkening Deluge\" Ability { id: \"2C56\", source: \"Famfrit, The Darkening Cloud\" }\r\n176 \"Dark Cannonade\" Ability { id: \"2C42\", source: \"Famfrit, The Darkening Cloud\" }\r\n200 \"Water IV\" Ability { id: \"2C3D\", source: \"Famfrit, The Darkening Cloud\" }\r\n208 \"Tsunami\" Ability { id: \"2C50\", source: \"Famfrit, The Darkening Cloud\" }\r\n215 \"Tsunami\" duration 3\r\n227 \"Tsunami\" duration 3\r\n228 \"Briny Cannonade\" Ability { id: \"2C45\", source: \"Famfrit, The Darkening Cloud\" }\r\n239 \"Tsunami\" duration 3\r\n247 \"Water IV\" Ability { id: \"2C3D\", source: \"Famfrit, The Darkening Cloud\" }\r\n259 \"Tide Pod\" Ability { id: \"2C3E\", source: \"Famfrit, The Darkening Cloud\" }\r\n272 \"Water IV\" Ability { id: \"2C3D\", source: \"Famfrit, The Darkening Cloud\" }\r\n279 \"Tide Pod\" Ability { id: \"2C3E\", source: \"Famfrit, The Darkening Cloud\" }\r\n291 \"Dark Ewer (cross)\" Ability { id: \"2C43\", source: \"Famfrit, The Darkening Cloud\" }\r\n302 \"Water IV\" Ability { id: \"2C3D\", source: \"Famfrit, The Darkening Cloud\" }\r\n311 \"Briny Cannonade\" Ability { id: \"2C45\", source: \"Famfrit, The Darkening Cloud\" }\r\n318 \"Dark Ewer (orbit)\" Ability { id: \"2C43\", source: \"Famfrit, The Darkening Cloud\" }\r\n324 \"Tsunami\" Ability { id: \"2C48\", source: \"Famfrit, The Darkening Cloud\" }\r\n331 \"Tsunami\" duration 3\r\n343 \"Tsunami\" duration 3\r\n355 \"Tsunami\" duration 3\r\n357 \"Briny Cannonade\" Ability { id: \"2C45\", source: \"Famfrit, The Darkening Cloud\" }\r\n364 \"Water IV\" Ability { id: \"2C3D\", source: \"Famfrit, The Darkening Cloud\" }\r\n371 \"Water IV\" Ability { id: \"2C3D\", source: \"Famfrit, The Darkening Cloud\" }\r\n386 \"Tide Pod\" Ability { id: \"2C3E\", source: \"Famfrit, The Darkening Cloud\" }\r\n397 \"Tide Pod\" Ability { id: \"2C3E\", source: \"Famfrit, The Darkening Cloud\" }\r\n404 \"Water IV\" Ability { id: \"2C3D\", source: \"Famfrit, The Darkening Cloud\" } jump 151\r\n# End loop\r\n\r\n# Dummy loop future\r\n418 \"Darkening Rainfall\"\r\n423 \"Darkening Deluge\"\r\n430 \"Dark Cannonade\"\r\n\r\n##########\r\n# Belias #\r\n##########\r\n\r\n# The Spire's Bounds will be sealed off\r\n1000 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"99A\" } window 1000,0\r\n1012 \"Fire\" Ability { id: \"2CDB\", source: \"Belias, the Gigas\" } window 1012,5\r\n1024 \"Fire IV\" Ability { id: \"2CDC\", source: \"Belias, the Gigas\" }\r\n1033 \"Time Eruption\" Ability { id: \"2CDE\", source: \"Belias, the Gigas\" }\r\n1038 \"Fast Hands\" Ability { id: \"2CDF\", source: \"Belias, the Gigas\" }\r\n1041 \"Slow Hands\" Ability { id: \"2CE0\", source: \"Belias, the Gigas\" }\r\n1041 \"--untargetable--\"\r\n1048 \"Crimson Cyclone\" Ability { id: \"2CE2\", source: \"Belias, the Gigas\" }\r\n1051 \"Crimson Cyclone\" Ability { id: \"2D5F\", source: \"Belias, the Gigas\" }\r\n1054 \"--targetable--\"\r\n1062 \"Fire\" Ability { id: \"2CDB\", source: \"Belias, the Gigas\" }\r\n1070 \"Fire IV\" Ability { id: \"2CDC\", source: \"Belias, the Gigas\" }\r\n1079 \"The Hand Of Time\" Ability { id: \"2CE5\", source: \"Belias, the Gigas\" }\r\n1089 \"Fire IV\" Ability { id: \"2CDC\", source: \"Belias, the Gigas\" }\r\n1095 \"Eruption\" duration 4\r\n1100 \"Fire\" Ability { id: \"2CDB\", source: \"Belias, the Gigas\" }\r\n1110 \"Fire IV\" Ability { id: \"2CDC\", source: \"Belias, the Gigas\" }\r\n1118 \"Gigas spawns\"\r\n\r\n# Adds dead\r\n1300 \"Hellfire\" Ability { id: \"2CE8\", source: \"Belias, the Gigas\" } window 5000,700\r\n1313 \"Time Bomb\" duration 15\r\n1322 \"Fire\" Ability { id: \"2CDB\", source: \"Belias, the Gigas\" }\r\n\r\n# Begin loop\r\n1342 \"The Hand Of Time\" Ability { id: \"2CE5\", source: \"Belias, the Gigas\" }\r\n1345 \"--untargetable--\"\r\n1352 \"Crimson Cyclone\" Ability { id: \"2CE2\", source: \"Belias, the Gigas\" }\r\n1355 \"Crimson Cyclone\" Ability { id: \"2D5F\", source: \"Belias, the Gigas\" }\r\n1358 \"--targetable--\"\r\n1365 \"Fire IV\" Ability { id: \"2CDC\", source: \"Belias, the Gigas\" }\r\n1375 \"Time Eruption\" Ability { id: \"2CDE\", source: \"Belias, the Gigas\" }\r\n1380 \"Fast Hands\" Ability { id: \"2CDF\", source: \"Belias, the Gigas\" }\r\n1380 \"Time Bomb\" duration 15\r\n1383 \"Slow Hands\" Ability { id: \"2CE0\", source: \"Belias, the Gigas\" }\r\n1396 \"Fire\" Ability { id: \"2CDB\", source: \"Belias, the Gigas\" }\r\n1411 \"The Hand Of Time\" Ability { id: \"2CE5\", source: \"Belias, the Gigas\" }\r\n1421 \"Fire IV\" Ability { id: \"2CDC\", source: \"Belias, the Gigas\" }\r\n1422 \"Eruption\" duration 4\r\n1436 \"Time Bomb\" duration 15\r\n1442 \"--untargetable--\"\r\n1449 \"Crimson Cyclone\" Ability { id: \"2CE2\", source: \"Belias, the Gigas\" }\r\n1451 \"Crimson Cyclone\" Ability { id: \"2D5F\", source: \"Belias, the Gigas\" }\r\n1454 \"--targetable--\"\r\n1466 \"Time Eruption\" Ability { id: \"2CDE\", source: \"Belias, the Gigas\" }\r\n1471 \"Fast Hands\" Ability { id: \"2CDF\", source: \"Belias, the Gigas\" }\r\n1474 \"Slow Hands\" Ability { id: \"2CE0\", source: \"Belias, the Gigas\" }\r\n1486 \"The Hand Of Time\" Ability { id: \"2CE5\", source: \"Belias, the Gigas\" } jump 1342\r\n# End loop\r\n\r\n# Dummy loop future\r\n1489 \"--untargetable--\"\r\n1496 \"Crimson Cyclone\"\r\n1499 \"Crimson Cyclone\"\r\n1502 \"--targetable--\"\r\n1509 \"Fire IV\"\r\n\r\n###############\r\n# Construct 7 #\r\n###############\r\n# The Cleft of Profaning Wind will be sealed off\r\n2000 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"99C\" } window 2000,0\r\n2016 \"Destroy\" Ability { id: \"2C5A\", source: \"Construct 7\" } window 2016,0\r\n2026 \"Ignite\" Ability { id: \"2C67\", source: \"Construct 7\" }\r\n2029 \"Accelerate\" Ability { id: \"2C65\", source: \"Construct 7\" }\r\n2043 \"Pulverize (close)\" Ability { id: \"2C61\", source: \"Construct 7\" }\r\n2048 \"Pulverize (far)\" Ability { id: \"2C62\", source: \"Construct 7\" }\r\n2049 \"Compress\" Ability { id: \"2C5C\", source: \"Construct 7\" }\r\n2057 \"--untargetable--\" Ability { id: \"2C66\", source: \"Construct 7\" }\r\n2072 \"Ignite\" Ability { id: \"2C67\", source: \"Construct 7\" }\r\n2074 \"Lithobrake\" Ability { id: \"2C68\", source: \"Construct 7\" }\r\n2083 \"Dispose\" duration 5\r\n2101 \"Incinerate\" Ability { id: \"2C64\", source: \"Construct 7\" }\r\n2113 \"Computation Mode\" Ability { id: \"2C57\", source: \"Construct 7\" } # drift -0.356\r\n2120 \"Subtract\" Ability { id: \"2C6C\", source: \"Construct 7\" } # drift 0.204\r\n2138 \"Division\" Ability { id: \"2CC(A|C|D|E)\", source: \"Construct 7\" } # drift 0.246\r\n2153 \"Division\" Ability { id: \"2CC(A|C|D|E)\", source: \"Construct 7\" } # drift 0.355\r\n2168 \"Incinerate\" Ability { id: \"2CC8\", source: \"Construct 7\" }\r\n2176 \"Tartarus Mode\" Ability { id: \"2C58\", source: \"Construct 7\" }\r\n2178 \"--untargetable--\" Ability { id: \"2C63\", source: \"Construct 7\" }\r\n\r\n# Adds. This doesn't currently show because of combat dropping\r\n2230 \"Area Lockdown\"\r\n\r\n# After adds\r\n2244 \"--sync--\" StartsUsing { id: \"2C59\", source: \"Construct 7\" } window 5000,766\r\n2254 \"Annihilation Mode\" Ability { id: \"2C59\", source: \"Construct 7\" } window 5000,756\r\n2264 \"Destroy\" Ability { id: \"2C71\", source: \"Construct 7\" }\r\n2274 \"Ignite\" Ability { id: \"2C67\", source: \"Construct 7\" }\r\n2277 \"Accelerate\" Ability { id: \"2C65\", source: \"Construct 7\" } window 150,150\r\n2291 \"Pulverize (close)\" Ability { id: \"2C61\", source: \"Construct 7\" }\r\n2296 \"Pulverize (far)\" duration 4\r\n2297 \"Compress\" Ability { id: \"2C5D\", source: \"Construct 7\" }\r\n2310 \"Incinerate\" Ability { id: \"2D5C\", source: \"Construct 7\" }\r\n2322 \"Computation Mode\" Ability { id: \"2C57\", source: \"Construct 7\" }\r\n2329 \"Subtract\" Ability { id: \"2C6C\", source: \"Construct 7\" }\r\n2347 \"Division\" Ability { id: \"2CC(A|C|D|E)\", source: \"Construct 7\" }\r\n2362 \"Division\" Ability { id: \"2CC(A|C|D|E)\", source: \"Construct 7\" }\r\n2377 \"Incinerate\" Ability { id: \"2D5D\", source: \"Construct 7\" }\r\n2383 \"--untargetable--\"\r\n\r\n# Begin loop\r\n2392 \"Ignite\" Ability { id: \"2C66\", source: \"Construct 7\" }\r\n2401 \"Lithobrake\" Ability { id: \"2D1E\", source: \"Construct 7\" }\r\n2410 \"Dispose\" duration 9\r\n2431 \"Incinerate\" Ability { id: \"2D5C\", source: \"Construct 7\" }\r\n2444 \"Ventilate\" Ability { id: \"2C69\", source: \"Construct 7\" }\r\n2454 \"Destroy\" Ability { id: \"2C71\", source: \"Construct 7\" }\r\n2464 \"Ignite\" Ability { id: \"2C67\", source: \"Construct 7\" }\r\n2467 \"Accelerate\" Ability { id: \"2C65\", source: \"Construct 7\" }\r\n2481 \"Pulverize (close)\" Ability { id: \"2C61\", source: \"Construct 7\" }\r\n2486 \"Pulverize (far)\" duration 4\r\n2487 \"Compress\" Ability { id: \"2C5D\", source: \"Construct 7\" }\r\n2495 \"--untargetable--\"\r\n2504 \"Ignite\" Ability { id: \"2C66\", source: \"Construct 7\" } jump 2392\r\n# End loop\r\n\r\n# Dummy loop future\r\n2513 \"Lithobrake\"\r\n2522 \"Dispose\"\r\n\r\n\r\n### Yiazmat\r\n# The Clockwork Coliseum will be sealed off\r\n3000 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"99D\" } window 3000,0\r\n3016 \"Rake (single)\" Ability { id: \"2C26\", source: \"Yiazmat\" } window 3016,0\r\n3026 \"Gust Front\" duration 4\r\n3034 \"Stone Breath\" Ability { id: \"2C29\", source: \"Yiazmat\" }\r\n3046 \"Dust Storm\" Ability { id: \"2C36\", source: \"Yiazmat\" }\r\n3059 \"White Breath\" Ability { id: \"2C31\", source: \"Yiazmat\" }\r\n3074 \"Magnetic Lysis\" Ability { id: \"2C2A\", source: \"Yiazmat\" }\r\n3082 \"Dust Storm\" Ability { id: \"2C36\", source: \"Yiazmat\" }\r\n3088 \"Gust Front\" duration 4\r\n3092 \"Stone Breath\" Ability { id: \"2C29\", source: \"Yiazmat\" }\r\n3098 \"Dust Storm\" Ability { id: \"2C36\", source: \"Yiazmat\" }\r\n3101 \"Magnetic Genesis\" Ability { id: \"2C2B\", source: \"Yiazmat\" }\r\n3114 \"Rake (combo)\" duration 14\r\n3134 \"White Breath\" Ability { id: \"2C31\", source: \"Yiazmat\" }\r\n3149 \"Rake (single)\" Ability { id: \"2C26\", source: \"Yiazmat\" }\r\n3160 \"Gust Front\" duration 4\r\n3162 \"Stone Breath\" Ability { id: \"2C29\", source: \"Yiazmat\" }\r\n3175 \"Summon\" Ability { id: \"2C37\", source: \"Yiazmat\" }\r\n3186 \"Magnetic Lysis\" Ability { id: \"2C2A\", source: \"Yiazmat\" }\r\n3194 \"White Breath\" Ability { id: \"2C31\", source: \"Yiazmat\" }\r\n3201 \"Dust Storm\" Ability { id: \"2C36\", source: \"Yiazmat\" }\r\n3208 \"Death Strike\" Ability { id: \"2C34\", source: \"Yiazmat\" }\r\n3213 \"Magnetic Genesis\" Ability { id: \"2C2B\", source: \"Yiazmat\" }\r\n3222 \"Cyclone\" Ability { id: \"2C23\", source: \"Yiazmat\" } duration 4\r\n\r\n# Adds\r\n3241 \"Archaeodemon spawn\"\r\n3248 \"Gust Front\" duration 4\r\n3250 \"Karma/Unholy Darkness\"\r\n3258 \"Death Strike\" Ability { id: \"2C33\", source: \"Yiazmat\" }\r\n3262 \"Karma/Unholy Darkness\"\r\n3301 \"Enrage\"\r\n\r\n# Adds complete\r\n3400 \"Solar Storm\" Ability { id: \"2C2C\", source: \"Yiazmat\" } window 5000,600\r\n3420 \"Rake (combo)\" duration 14\r\n3425 \"Gust Front\" duration 4\r\n3439 \"White Breath\" Ability { id: \"2C31\", source: \"Yiazmat\" }\r\n3450 \"Rake (single)\" Ability { id: \"2C26\", source: \"Yiazmat\" }\r\n\r\n# Begin loop\r\n3456 \"Magnetic Lysis\" Ability { id: \"2C2A\", source: \"Yiazmat\" }\r\n3463 \"Rake (combo)\" duration 14\r\n3481 \"Dust Storm\" Ability { id: \"2C36\", source: \"Yiazmat\" }\r\n3483 \"Magnetic Genesis\" Ability { id: \"2C2B\", source: \"Yiazmat\" }\r\n3493 \"Cyclone\" Ability { id: \"2C23\", source: \"Yiazmat\" } duration 4\r\n3505 \"Death Strike\" Ability { id: \"2C34\", source: \"Yiazmat\" }\r\n3510 \"Gust Front\" duration 4\r\n3520 \"White Breath\" Ability { id: \"2C31\", source: \"Yiazmat\" }\r\n3531 \"Rake (single)\" Ability { id: \"2C26\", source: \"Yiazmat\" }\r\n3537 \"Magnetic Lysis\" Ability { id: \"2C2A\", source: \"Yiazmat\" }\r\n3544 \"Dust Storm\" Ability { id: \"2C36\", source: \"Yiazmat\" }\r\n3551 \"White Breath\" Ability { id: \"2C31\", source: \"Yiazmat\" }\r\n3553 \"Gust Front\" duration 4\r\n3561 \"Dust Storm\" Ability { id: \"2C36\", source: \"Yiazmat\" }\r\n3565 \"Magnetic Genesis\" Ability { id: \"2C2B\", source: \"Yiazmat\" }\r\n3577 \"Gale Gaol\" Ability { id: \"2C2D\", source: \"Yiazmat\" }\r\n3584 \"Gust Front\" duration 4\r\n3587 \"Stone Breath\" Ability { id: \"2C29\", source: \"Yiazmat\" }\r\n3595 \"Rake (single)\" Ability { id: \"2C26\", source: \"Yiazmat\" }\r\n3600 \"Dust Storm\" Ability { id: \"2C36\", source: \"Yiazmat\" }\r\n3610 \"Magnetic Lysis\" Ability { id: \"2C2A\", source: \"Yiazmat\" } jump 3456\r\n# End loop\r\n\r\n# Dummy loop future\r\n3617 \"Rake (combo)\"\r\n3634 \"Dust Storm\"\r\n\r\n# 9.99% push\r\n3694 \"--sync--\" StartsUsing { id: \"2C32\", source: \"Yiazmat\" } window 5000,306\r\n3700 \"Growing Threat\" Ability { id: \"2C32\", source: \"Yiazmat\" } window 5000,300\r\n3707 \"Rake (combo)\" duration 14\r\n3727 \"White Breath\" Ability { id: \"2C31\", source: \"Yiazmat\" }\r\n3734 \"Dust Storm\" Ability { id: \"2C36\", source: \"Yiazmat\" }\r\n3740 \"Rake (combo)\" duration 14\r\n3752 \"Gust Front\" duration 4\r\n3761 \"Stone Breath\" Ability { id: \"2C29\", source: \"Yiazmat\" }\r\n3767 \"Dust Storm\" Ability { id: \"2C36\", source: \"Yiazmat\" }\r\n# more?\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/alliance/royal_city_of_rabanastre.ts




const royal_city_of_rabanastre_triggerSet = {
  id: 'TheRoyalCityOfRabanastre',
  zoneId: zone_id/* default.TheRoyalCityOfRabanastre */.Z.TheRoyalCityOfRabanastre,
  timelineFile: 'royal_city_of_rabanastre.txt',
  triggers: [{
    id: 'Rab Mateus Aqua Sphere',
    type: 'StartsUsing',
    netRegex: {
      id: '2633',
      source: 'Mateus, The Corrupt',
      capture: false
    },
    delaySeconds: 11,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Aqua Spheres',
        de: 'Wasserkugeln zerstören',
        fr: 'Détruire les bulles d\'eau',
        ja: 'アクアスフィアを倒す',
        cn: '击杀水球',
        ko: '물 구체 죽이기'
      }
    }
  }, {
    id: 'Rab Mateus Breathless',
    type: 'GainsEffect',
    netRegex: {
      effectId: '595'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, matches, output) => {
      if (parseInt(matches.count) === 6) return output.getInBubble();
    },
    infoText: (_data, matches, output) => {
      const count = parseInt(matches.count);
      if (count >= 7) return output.breathless({
        num: count
      });
    },
    outputStrings: {
      breathless: {
        en: 'Breathless: ${num}',
        de: 'Atemnot: ${num}',
        fr: 'Suffocation : ${num}',
        ja: '呼吸困難 :${num}',
        cn: '窒息层数:${num}',
        ko: '호흡곤란: ${num}'
      },
      getInBubble: {
        en: 'Get In Bubble',
        de: 'Geh in die Blase',
        fr: 'Allez dans une bulle',
        ja: '泡に入る',
        cn: '进气泡',
        ko: '물방울 안으로'
      }
    }
  }, {
    id: 'Rab Mateus Blizzard IV',
    type: 'StartsUsing',
    netRegex: {
      id: '263D',
      source: 'Mateus, The Corrupt',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move To Safe Spot',
        de: 'Zur sicheren Zone',
        fr: 'Allez en zone safe',
        ja: '安置へ',
        cn: '去安全点',
        ko: '안전 지대로 이동'
      }
    }
  }, {
    id: 'Rab Hashmal Quake IV',
    type: 'StartsUsing',
    netRegex: {
      id: '25D8',
      source: 'Hashmal, Bringer Of Order',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Rab Hashmal Extreme Edge Left',
    type: 'StartsUsing',
    netRegex: {
      id: '25D0',
      source: 'Hashmal, Bringer Of Order',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Find Hashmal; Dodge Left',
        de: 'Finde Hashmallim; Weiche nach Links aus',
        fr: 'Trouvez Hashmal, Esquivez à gauche',
        ja: 'ボスに向かって左に',
        cn: '找到BOSS; 向左躲避',
        ko: '하쉬말림 찾고, 왼쪽으로 피하기'
      }
    }
  }, {
    id: 'Rab Hashmal Extreme Edge Right',
    type: 'StartsUsing',
    netRegex: {
      id: '25CE',
      source: 'Hashmal, Bringer Of Order',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Find Hashmal; Dodge Right',
        de: 'Finde Hashmallim; Weiche nach Rechts aus',
        fr: 'Trouvez Hashmal, Esquivez à droite',
        ja: 'ボスに向かって右に',
        cn: '找到BOSS; 向右躲避',
        ko: '하쉬말림 찾고, 오른쪽으로 피하기'
      }
    }
  }, {
    id: 'Rab Hashmal Rock Cutter',
    type: 'StartsUsing',
    netRegex: {
      id: '25D7',
      source: 'Hashmal, Bringer Of Order'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Rab Hashmal Falling Boulder',
    type: 'StartsUsing',
    netRegex: {
      id: '25D2',
      source: 'Hashmal, Bringer Of Order',
      capture: false
    },
    // There's three of these, so just say stack.
    suppressSeconds: 1,
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }, {
    id: 'Rab Hashmal Falling Rock',
    type: 'StartsUsing',
    netRegex: {
      id: '25D3',
      source: 'Hashmal, Bringer Of Order'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Rab Hashmal Earth Hammer',
    type: 'StartsUsing',
    netRegex: {
      id: '25CB',
      source: 'Hashmal, Bringer Of Order',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move Away',
        de: 'Weg da',
        fr: 'Éloignez-vous',
        ja: 'ハンマーから離れる',
        cn: '远离大锤落点',
        ko: '기둥 피하기'
      }
    }
  }, {
    id: 'Rab Hashmal Golems',
    type: 'StartsUsing',
    netRegex: {
      id: '25D4',
      source: 'Hashmal, Bringer Of Order',
      capture: false
    },
    delaySeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Golems',
        de: 'Golems töten',
        fr: 'Tuez les golems',
        ja: 'ゴーレムを倒す',
        cn: '击杀小怪',
        ko: '골렘 죽이기'
      }
    }
  }, {
    id: 'Rab Trash Dragon Voice',
    type: 'StartsUsing',
    netRegex: {
      id: 'D10',
      source: 'Archaeolion',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Rab Trash Ram Voice',
    type: 'StartsUsing',
    netRegex: {
      id: ['D0F', '273B'],
      source: 'Archaeolion',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Rab Rofocale Crush Helm',
    type: 'Ability',
    netRegex: {
      id: '2681',
      source: 'Rofocale'
    },
    suppressSeconds: 10,
    // 2680 is on Rofocale with a castbar, then multiple 2681 and a final 2682 ability.
    // TODO: should this say "multi-hit tankbuster?"
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Rab Rofocale Chariot',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.getIn */.n3.getIn('alarm')
  }, {
    id: 'Rab Rofocale Trample',
    type: 'StartsUsing',
    netRegex: {
      id: '2676',
      source: 'Rofocale',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Trample',
        de: 'Zertrampeln',
        fr: 'Fauchage',
        ja: '蹂躙',
        cn: '蹂躏',
        ko: '유린'
      }
    }
  }, {
    id: 'Rab Argath Fire IV',
    type: 'StartsUsing',
    netRegex: {
      source: 'Argath Thadalfus',
      id: '262E',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Rab Argath Crippling Blow',
    type: 'StartsUsing',
    netRegex: {
      source: 'Argath Thadalfus',
      id: '262D'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Rab Argath Trepidation',
    type: 'Ability',
    netRegex: {
      source: 'Argath Thadalfus',
      id: '2622',
      capture: false
    },
    infoText: (_data, _matches, output) => output.getTowers(),
    outputStrings: {
      getTowers: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '기둥 하나씩 들어가기'
      }
    }
  }, {
    id: 'Rab Argath Mask of Truth',
    type: 'Ability',
    netRegex: {
      source: 'Argath Thadalfus',
      id: '261A',
      capture: false
    },
    run: data => data.maskValue = true
  }, {
    id: 'Rab Argath Mask of Lies',
    type: 'Ability',
    netRegex: {
      source: 'Argath Thadalfus',
      id: '2619',
      capture: false
    },
    run: data => data.maskValue = false
  }, {
    id: 'Rab Argath Command Scatter',
    type: 'HeadMarker',
    netRegex: {
      id: '007B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (data, _matches, output) => {
      if (data.maskValue) return output.move();
      return output.stop();
    },
    outputStrings: {
      move: outputs/* default.moveAround */.Z.moveAround,
      stop: outputs/* default.stopEverything */.Z.stopEverything
    }
  }, {
    id: 'Rab Argath Command Turn',
    type: 'HeadMarker',
    netRegex: {
      id: '007C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (data, _matches, output) => {
      if (data.maskValue) return output.lookAway();
      return output.lookTowards();
    },
    outputStrings: {
      lookAway: outputs/* default.lookAway */.Z.lookAway,
      lookTowards: outputs/* default.lookTowardsBoss */.Z.lookTowardsBoss
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Mask Of Truth/Mask Of Lies': 'Mask Of Truth/Lies'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Aqua Sphere': 'Wassersphäre',
      'Archaeodemon': 'Archaeodämon',
      'Archaeolion': 'Archaeolöwe',
      'Argath Thadalfus': 'Argath Thadalfus',
      'Azure Guard': 'Azurwächter',
      'Command Tower': 'Turmkommando',
      'Control Tower': 'Turmkontrolle',
      'Flume Toad': 'Abflusskröte',
      'Hashmal, Bringer of Order': 'Hashmallim der Einiger',
      'Heartless': 'Kalte Klinge',
      'Icicle': 'Eiszapfen',
      'Mateus, The Corrupt': 'Mateus (?:der|die|das) Peiniger',
      'Pennantstone Golem': 'Sandstein-Golem',
      'Rofocale': 'Rofocale',
      'Sand Sphere': 'Sandwirbel',
      'Submission Tower': 'Turmdivision',
      'The Crumbling Bridge': 'Die verwitterte Brücke',
      'The Lesalia Garden Ruins': 'Verfallene Gärten',
      'The Lesalia Temple Ruins': 'Tempelruine',
      'The Palace Square': 'Palasthof',
      'The heavens tremble in my wake': 'Mein Streitwagen donnert empor in luftige Höhen'
    },
    'replaceText': {
      '--Shade--': '--Schatten--',
      '--Shard--': '--Kristall--',
      '--enrage--': '--Finalangriff--',
      '--invulnerable--': '--unverwundbar--',
      '--lock out--': '--ausgesperrt--',
      'Adds': 'Adds',
      'Aqua Sphere': 'Wassersphäre',
      'Archaeodemon': 'Archaeodämon',
      'Azure Guard': 'Azurwächter',
      'Blizzard IV': 'Eiska',
      'Blizzard Sphere': 'Eissphäre',
      'Chariot': 'Streitwagen',
      'Coldblood': 'Kaltblut',
      'Command Tower': 'Turmkommando',
      'Control Tower': 'Turmkontrolle',
      'Crippling Blow': 'Verkrüppelnder Schlag',
      'Crush Helm': 'Zenitspaltung',
      'Crush Weapon': 'Jenseitsschrei',
      'Cry Of Victory': 'Kampfruf',
      'Cry of Victory': 'Kampfruf',
      'Dark Geas': 'Dunkles Gelöbnis',
      'Dark Ultima': 'Dunkel-Ultima',
      'Demolish': 'Ausradieren',
      'Dendrite': 'Eisdendriten',
      'Dualcast': 'Doppelzauber',
      'Earth Hammer': 'Erdhammer',
      'Earth Shaker': 'Erdstoß',
      'Embrace': 'Umschließen',
      'Empty Soul': 'Leere Seele',
      'Extreme Edge': 'Extremkante',
      'Falling Boulder': 'Felsschlag',
      'Falling Rock': 'Steinschlag',
      'Fire IV': 'Feuka',
      'Flash-Freeze': 'Frostlanze',
      'Flume Toad': 'Abflusskröte',
      'Frostwave': 'Polarlanze',
      'Gnawing Dread': 'Nagende Angst',
      'Golem': 'Golem',
      'Hammerfall': 'Hammerschlag',
      'Heartless': 'Kalte Klinge',
      'Heavenly Subjugation': 'Himmelsgewalt',
      'Hole In One': 'Hole In One',
      'Impact': 'Impakt',
      'Jagged Edge': 'Schartenkante',
      'Judgment Blade': 'Klinge des Urteils',
      'Landwaster': 'Landverwüster',
      'Mask Of Lies': 'Maske der Lüge',
      'Mask Of Truth': 'Maske der Wahrheit',
      'Maverick': 'Einzelgänger',
      'Might': 'Steinstärke',
      'Pomp And Circumstance': 'Pauken und Trompeten',
      'Pomp and Circumstance': 'Pauken und Trompeten',
      'Quake IV': 'Seiska',
      'Rail Of The Rat': 'Rache der Ratte',
      'Rebind': 'Zusammenfrieren',
      'Rock Cutter': 'Steinfräse',
      'Royal Blood': 'Blaues Blut',
      'Sanction': 'Sanktion',
      'Sand Sphere': 'Sandwirbel',
      'Snowpierce': 'Schneestich',
      'Soulfix': 'Seelenspießer',
      'Submission Tower': 'Turmdivision',
      'Summon': 'Rufen',
      'The Word': 'Gottes Wort',
      'Towerfall': 'Turmsturz',
      'Trample': 'Zertrampeln',
      'Trepidation': 'Beklemmung',
      'Unbind': 'Loseisen',
      'Unrelenting': 'Unerbittliche Klinge'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aqua Sphere': 'sphère d\'eau',
      'Archaeodemon': 'archéodémon',
      'Archaeolion': 'archéochimère',
      'Argath Thadalfus': 'Argath Thadalfus',
      'Azure Guard': 'gardien azur',
      'Command Tower': 'Tour de commandement',
      'Control Tower': 'Tour de contrôle',
      'Flume Toad': 'crapaud des torrents',
      'Hashmal, Bringer of Order': 'Hashmal le Grand Ordonnateur',
      'Heartless': 'Sans-cœur',
      'Icicle': 'stalactite',
      'Mateus, The Corrupt': 'Mateus le Corrompu',
      'Pennantstone Golem': 'golem de dalles',
      'Rofocale': 'Rofocale le Roi centaure',
      'Sand Sphere': 'Sphère de Sable',
      'Submission Tower': 'Tour de soumission',
      'The Crumbling Bridge': 'Pont démoli',
      'The heavens tremble in my wake': 'Mon char arpente le ciel aussi aisément que les plaines',
      'The Lesalia Garden Ruins': 'Jardins ravagés de Lesalia',
      'The Lesalia Temple Ruins': 'Ruines du temple de Lesalia',
      'The Palace Square': 'Place du palais'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(Hole In One\\)': '(Un seul trou)',
      '--Aqua Sphere Adds--': '--Adds Sphères d\'eau--',
      '--Azure Guard Adds--': 'Adds Gardiens azur',
      '--Blizzard Sphere Adds--': '--Adds Sphères de glace--',
      '--Flume Toad Adds--': '--Adds Crapauds des torrents--',
      '--Golem Adds--': 'Adds Golems',
      '--invulnerable--': '--invulnérable--',
      '--lock out--': '--verrouiller--',
      '--Sand Sphere Adds--': 'Adds Sphères de Sable',
      '--Shade Adds--': '--Adds Ombres--',
      '--Shard Adds--': '--Adds Cristaux du néant--',
      'Archaeodemon Adds': 'Adds Archéodémon',
      'Blizzard IV': 'Giga Glace',
      'Chariot': 'Charge centaure',
      'Coldblood': 'Sang-froid',
      'Command Tower': 'Tour de commandement',
      'Control Tower': 'Tour de contrôle',
      'Crippling Blow': 'Coup handicapant',
      'Crush Helm': 'Bombardement céleste',
      'Crush Weapon': 'Cri de l\'au-delà',
      'Cry Of Victory': 'Cri de triomphe',
      'Dark Geas': 'Invocation ténébreuse',
      'Dark Ultima': 'Ultima ténébreuse',
      'Demolish': 'Oblitération',
      'Dendrite': 'Dendrite',
      'Dualcast': 'Chaîne de sorts',
      'Earth Hammer': 'Marteau tellurique',
      'Earth Shaker': 'Secousse',
      'Embrace': 'Étreinte',
      'Empty Soul': 'Âme du vide',
      'Extreme Edge': 'Taille suprême',
      'Falling Boulder': 'Chute de pierre',
      'Falling Rock': 'Chute de rocher',
      'Fire IV': 'Giga Feu',
      'Flash-Freeze': 'Glaciation instantanée',
      'Frostwave': 'Vague réfrigérante',
      'Gnawing Dread': 'Peur calamiteuse',
      'Hammerfall': 'Aplatissoir',
      'Heartless': 'Sans-cœur',
      'Heavenly Subjugation': 'Marche triomphale',
      'Impact': 'Impact',
      'Jagged Edge': 'Pointes acérées',
      'Judgment Blade': 'Lame du jugement',
      'Landwaster': 'Dislocation terrestre',
      '(?<!/)Mask Of Lies': 'Masque du mensonge',
      'Mask Of Truth/Mask Of Lies': 'Masque du mensonge/vérité',
      'Mask Of Truth(?!/)': 'Masque de la vérité',
      'Maverick': 'Franc-tireur',
      'Might': 'Bras de fer',
      'Pomp And Circumstance': 'La pompe et l\'attirail',
      'Quake IV': 'Giga Séisme',
      'Rail Of The Rat': 'Coup du rat',
      'Rebind': 'Emprisonnement',
      'Rock Cutter': 'Trancheur rocheux',
      'Royal Blood': 'Sang royal',
      'Sanction': 'Sanction',
      'Snowpierce': 'Perçage algide',
      'Soulfix': 'Fixage d\'âme',
      'Submission Tower': 'Tour de soumission',
      'Summon': 'Invocation',
      'The Word': 'Châtiment céleste',
      'Towerfall': 'Écroulement',
      'Trample': 'Fauchage',
      'Trepidation': 'Trépidation',
      'Unbind': 'Délivrance',
      'Unrelenting': 'Déferlement'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Aqua Sphere': 'アクアスフィア',
      'Archaeodemon': 'アルケオデーモン',
      'Archaeolion': 'アルケオキマイラ',
      'Argath Thadalfus': '冷血剣アルガス',
      'Azure Guard': 'アズールガード',
      'Command Tower': '支配の塔',
      'Control Tower': '統制の塔',
      'Flume Toad': 'フルームトード',
      'Hashmal, Bringer of Order': '統制者ハシュマリム',
      'Heartless': '冷血剣',
      'Icicle': 'アイシクル',
      'Mateus, The Corrupt': '背徳の皇帝マティウス',
      'Pennantstone Golem': 'ペナント・ゴーレム',
      'Rofocale': '人馬王ロフォカレ',
      'Sand Sphere': '砂球',
      'Submission Tower': '服従の塔',
      'The Crumbling Bridge': '崩れかけた橋',
      'The Lesalia Garden Ruins': 'ルザリア円庭跡',
      'The Lesalia Temple Ruins': 'ルザリア神殿跡',
      'The Palace Square': '王宮前広場',
      'The heavens tremble in my wake': '我が戦車の車輪は、天をも駆ける！\\s+ゆくぞ……！'
    },
    'replaceText': {
      '--invulnerable--': '--インヴィンシブル--',
      '--lock out--': '--ロックオン--',
      'Aqua Sphere Adds': 'アクアスフィア',
      'Archaeodemon Adds': 'アルケオデーモン',
      'Azure Guard Adds': 'アズールガード',
      'Blizzard IV': 'ブリザジャ',
      'Blizzard Sphere': 'ブリザードスフィア',
      'Chariot': '人馬戦車',
      'Coldblood': '冷血乱舞',
      'Command Tower(?! )': '支配の塔',
      'Command Tower Add': '支配の塔',
      'Control Tower': '統制の塔',
      'Crippling Blow': '痛打',
      'Crush Helm': '星天爆撃打',
      'Crush Weapon': '冥界恐叫打',
      'Cry Of Victory': '鬨の声',
      'Dark Geas': '暗黒魔法陣',
      'Dark Ultima': 'ダークアルテマ',
      'Demolish': 'デモリッシュ',
      'Dendrite': '凍結晶',
      'Dualcast': '連続魔',
      'Earth Hammer': '大地のハンマー',
      'Earth Shaker': 'アースシェイカー',
      'Embrace': '抱締',
      'Empty Soul': '虚無の魂',
      'Extreme Edge': 'ブーストエッジ',
      'Falling Boulder': '大落石',
      'Falling Rock': '落石',
      'Fire IV': 'ファイジャ',
      'Flash-Freeze': '凍天撃',
      'Flume Toad': 'フルームトード',
      'Frostwave': '凍てつく波動',
      'Gnawing Dread': '喪失の恐怖',
      'Golem Adds': 'ゴーレム',
      'Hammerfall': 'ハンマークラッシュ',
      'Heartless': '冷血剣',
      'Heavenly Subjugation': '天将覇道撃',
      'Hole In One': 'ボスと貼りつく',
      'Impact': '衝撃',
      'Jagged Edge': 'ロックスパイク',
      'Judgment Blade': '不動無明剣',
      'Landwaster': 'ランドワスター',
      'Mask Of Lies': '虚構の仮面',
      'Mask Of Truth': '真実の仮面',
      'Maverick': '独立独行',
      'Might': '豪腕',
      'Pomp And Circumstance': '威風堂々',
      'Quake IV': 'クエイジャ',
      'Rail Of The Rat': '鼠の一撃',
      'Rebind': '再拘束',
      'Rock Cutter': 'ロックカッター',
      'Royal Blood': '高貴なる血脈',
      'Sanction': '制裁の刃',
      'Sand Sphere Adds': '砂球',
      'Snowpierce': '凍槍突',
      'Soulfix': '呪槍串刺',
      'Submission Tower': '服従の塔',
      'Summon': '召喚',
      'The Word': '神罰',
      'Towerfall': '倒壊',
      'Trample': '蹂躙',
      'Trepidation': '狐鶏鼠',
      'Unbind': '拘束解放',
      'Unrelenting': '千手無双剣'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aqua Sphere': '水球',
      'Archaeodemon': '古恶魔',
      'Archaeolion': '古奇美拉',
      'Argath Thadalfus': '冷血剑阿加斯',
      'Azure Guard': '蔚蓝护卫',
      'Command Tower': '支配之塔',
      'Control Tower': '统治之塔',
      'Flume Toad': '渡槽蟾蜍',
      'Hashmal, Bringer of Order': '统治者哈修马利姆',
      'Heartless': '冷血剑',
      'Icicle': '冰柱',
      'Mateus, The Corrupt': '背德皇帝马提乌斯',
      'Pennantstone Golem': '石板巨像',
      'Rofocale': '人马王洛弗卡勒',
      'Sand Sphere': '沙球',
      'Submission Tower': '服从之塔',
      'The Crumbling Bridge': '崩塌的桥',
      'The Lesalia Garden Ruins': '勒萨利亚圆庭遗迹',
      'The Lesalia Temple Ruins': '勒萨利亚神殿遗迹',
      'The Palace Square': '王宫前广场',
      'The heavens tremble in my wake': '我的战车驰骋天际！'
    },
    'replaceText': {
      '--Shade--': '--阴影--',
      '--Shard--': '--碎片--',
      '--enrage--': '--狂暴--',
      '--invulnerable--': '--无敌--',
      '--lock out--': '--封锁--',
      'Adds': '出现',
      'Aqua Sphere': '水球',
      'Archaeodemon': '古恶魔',
      'Azure Guard': '蔚蓝护卫',
      'Blizzard IV': '冰澈',
      'Blizzard Sphere': '冰结球',
      'Chariot': '人马战车',
      'Coldblood': '冷血乱舞',
      'Command Tower': '支配之塔',
      'Control Tower': '统治之塔',
      'Crippling Blow': '痛击',
      'Crush Helm': '星天爆击打',
      'Crush Weapon': '冥界恐叫打',
      'Cry Of Victory': '战吼',
      'Dark Geas': '暗黑魔法阵',
      'Dark Ultima': '暗黑究极',
      'Demolish': '破魔震',
      'Dendrite': '冰结晶',
      'Dualcast': '连续咏唱',
      'Earth Hammer': '大地之锤',
      'Earth Shaker': '大地摇动',
      'Embrace': '抱拥',
      'Empty Soul': '虚无之魂',
      'Extreme Edge': '加速刃',
      'Falling Boulder': '大落石',
      'Falling Rock': '落石',
      'Fire IV': '炽炎',
      'Flash-Freeze': '冻天击',
      'Flume Toad': '渡槽蟾蜍',
      'Frostwave': '寒冰波动',
      'Gnawing Dread': '丧失之痛',
      'Golem': '巨像兵',
      'Hammerfall': '锤击',
      'Heartless': '冷血剑',
      'Heavenly Subjugation': '天将霸道击',
      'Hole In One': '去BOSS脚下',
      'Impact': '冲击',
      'Jagged Edge': '岩石突击',
      'Judgment Blade': '不动无明剑',
      'Landwaster': '地动',
      'Mask Of Lies': '虚假的面具',
      'Mask Of Truth': '真实的面具',
      'Maverick': '特立独行',
      'Might': '强腕',
      'Pomp And Circumstance': '威风凛凛',
      'Quake IV': '激震',
      'Rail Of The Rat': '鼠击',
      'Rebind': '再拘束',
      'Rock Cutter': '石刃',
      'Royal Blood': '高贵血脉',
      'Sanction': '制裁之刃',
      'Sand Sphere': '沙球',
      'Snowpierce': '冰枪突刺',
      'Soulfix': '咒枪穿刺',
      'Submission Tower': '服从之塔',
      'Summon': '召唤',
      'The Word': '神罚',
      'Towerfall': '崩塌',
      'Trample': '蹂躏',
      'Trepidation': '狐鸡鼠',
      'Unbind': '拘束解放',
      'Unrelenting': '千手无双剑'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aqua Sphere': '물 구체',
      'Archaeodemon': '원시 악마',
      'Archaeolion': '원시 키마이라',
      'Argath Thadalfus': '냉혈검 아르가스',
      'Azure Guard': '푸른 파수꾼',
      'Command Tower': '지배의 탑',
      'Control Tower': '통제의 탑',
      'Flume Toad': '수로 두꺼비',
      'Hashmal, Bringer of Order': '통제자 하쉬말림',
      'Heartless': '냉혈검',
      'Icicle': '고드름',
      'Mateus, The Corrupt': '배덕의 황제 마티우스',
      'Pennantstone Golem': '페넌트 골렘',
      'Rofocale': '인마왕 로포칼레',
      'Sand Sphere': '모래공',
      'Submission Tower': '복종의 탑',
      'The Crumbling Bridge': '무너진 다리',
      'The Lesalia Garden Ruins': '르잘리아 정원 옛터',
      'The Lesalia Temple Ruins': '르잘리아 신전 옛터',
      'The Palace Square': '왕궁 광장',
      'The heavens tremble in my wake': '이것이 바로 빛나는 \'성석\'의 힘이다!'
    },
    'replaceText': {
      '--invulnerable--': '--무적--',
      '--lock out--': '--지역 분리--',
      '--Shade Adds--': '--쫄 등장--',
      '--Shard Adds--': '--결정 등장--',
      '--Aqua Sphere Adds--': '--물 구체 등장--',
      '--Azure Guard Adds--': '--푸른 파수꾼 등장--',
      '--Blizzard Sphere Adds--': '--눈보라 구체 등장--',
      '--Golem Adds--': '--골렘 등장--',
      '--Flume Toad Adds--': '--수로 두꺼비 등장--',
      '--Sand Sphere Adds--': '--모래공 등장--',
      'Archaeodemon Adds': '원시 악마 등장',
      'Blizzard IV': '블리자쟈',
      'Chariot': '인마전차',
      'Coldblood': '냉혈난무',
      'Command Tower': '지배의 탑',
      'Control Tower': '통제의 탑',
      'Crippling Blow': '통타',
      'Crush Helm': '성천폭격타',
      'Crush Weapon': '명계공규타',
      'Cry Of Victory': '승리의 함성',
      'Dark Geas': '암흑 마법진',
      'Dark Ultima': '다크 알테마',
      'Demolish': '완전 파괴',
      'Dendrite': '얼음 결정',
      'Dualcast': '연속 마법',
      'Earth Hammer': '대지의 망치',
      'Earth Shaker': '요동치는 대지',
      'Embrace': '껴안기',
      'Empty Soul': '허무의 혼',
      'Extreme Edge': '돌격하는 칼날',
      'Falling Boulder': '대낙석',
      'Falling Rock': '낙석',
      'Fire IV': '파이쟈',
      'Flash-Freeze': '동천격',
      'Frostwave': '얼어붙은 파동',
      'Gnawing Dread': '상실의 공포',
      'Hammerfall': '망치 강타',
      'Heartless': '냉혈검',
      'Heavenly Subjugation': '천장패도격',
      'Hole In One': '보스 밑으로',
      'Impact': '충격',
      'Jagged Edge': '바위 꿰기',
      'Judgment Blade': '부동무명검',
      'Landwaster': '대지 황폐화',
      'Mask Of Lies': '허구의 가면',
      'Mask Of Truth': '진실의 가면',
      'Maverick': '독립독행',
      'Might': '완력 강화',
      'Pomp And Circumstance': '위풍당당',
      'Quake IV': '퀘이쟈',
      'Rail Of The Rat': '쥐의 일격',
      'Rebind': '재구속',
      'Rock Cutter': '바위 가르기',
      'Royal Blood': '고귀한 혈통',
      'Sanction': '제재의 칼날',
      'Snowpierce': '얼음창 찌르기',
      'Soulfix': '저주창 내리꽂기',
      'Submission Tower': '복종의 탑',
      'Summon': '소환',
      'The Word': '신벌',
      'Towerfall': '무너지는 탑',
      'Trample': '유린',
      'Trepidation': '여우 닭 쥐',
      'Unbind': '구속 해방',
      'Unrelenting': '천수무쌍검'
    }
  }]
};
/* harmony default export */ const royal_city_of_rabanastre = (royal_city_of_rabanastre_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/alliance/royal_city_of_rabanastre.txt
const alliance_royal_city_of_rabanastre_namespaceObject = "# Royal City of Rabanstre\r\n# https://www.bestinslot.co/ffxiv-the-royal-city-of-rabanastre-guide/\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"--start--\"\r\n\r\n### Mateus, The Corrupt\r\n# -p 2633:27.6 2641:500\r\n# -ii 2638 2639 2634 263E 2714 273E 263F 2646 2642\r\n# -it \"Mateus, The Corrupt\"\r\n\r\n# Crumbling Bridge will be sealed off\r\n0.0 \"--start--\" SystemLogMessage { id: \"7DC\", param1: \"949\" } window 0,1\r\n# TODO: does this only start when the adds are dead?\r\n22.6 \"--sync--\" StartsUsing { id: \"2633\", source: \"Mateus, The Corrupt\" } window 30,10\r\n\r\n# Ice phase\r\n27.6 \"Unbind\" Ability { id: \"2633\", source: \"Mateus, The Corrupt\" }\r\n33.6 \"--sync--\" Ability { id: \"26A2\", source: \"Mateus, The Corrupt\" }\r\n34.3 \"--Aqua Sphere Adds--\" AddedCombatant { name: \"Aqua Sphere\" }\r\n57.5 \"Flash-Freeze\" Ability { id: \"2647\", source: \"Mateus, The Corrupt\" }\r\n66.7 \"--sync--\" Ability { id: \"2637\", source: \"Mateus, The Corrupt\" }\r\n74.6 \"Flash-Freeze\" Ability { id: \"2647\", source: \"Mateus, The Corrupt\" }\r\n91.8 \"Flash-Freeze\" Ability { id: \"2647\", source: \"Mateus, The Corrupt\" }\r\n\r\n# Frog phase\r\n114.1 \"Rebind\" Ability { id: \"2635\", source: \"Mateus, The Corrupt\" } window 120,20\r\n124.5 \"Dualcast\" Ability { id: \"263C\", source: \"Mateus, The Corrupt\" }\r\n127.8 \"--sync--\" Ability { id: \"263B\", source: \"Mateus, The Corrupt\" }\r\n139.9 \"Blizzard IV\" Ability { id: \"263D\", source: \"Mateus, The Corrupt\" }\r\n152.1 \"Flash-Freeze\" Ability { id: \"2647\", source: \"Mateus, The Corrupt\" }\r\n165.4 \"--Flume Toad Adds--\" AddedCombatant { name: \"Flume Toad\" }\r\n192.5 \"Snowpierce 1\" Ability { id: \"2640\", source: \"Icicle\" }\r\n# ??? More flume toads, hard to tell from logs\r\n214.6 \"Snowpierce 2\" Ability { id: \"2640\", source: \"Icicle\" }\r\n225.6 \"Dendrite\" Ability { id: \"2645\", source: \"Mateus, The Corrupt\" }\r\n227.5 \"--Blizzard Sphere Adds--\"\r\n\r\n# Adds\r\n259.2 \"--untargetable--\" # ??? from video\r\n259.8 \"--sync--\" Ability { id: \"266C\", source: \"Mateus, The Corrupt\" } window 260,20\r\n262.9 \"--Azure Guard Adds--\" AddedCombatant { name: \"Azure Guard\" }\r\n333.2 \"--enrage--\" # ??? estimating from video\r\n\r\n# End of add phase aoe\r\n500.0 \"Frostwave\" Ability { id: \"2641\", source: \"Mateus, The Corrupt\" }\r\n\r\n# loop\r\n524.3 \"Unbind\" Ability { id: \"2633\", source: \"Mateus, The Corrupt\" } window 200,200 jump 27.6\r\n530.3 \"--sync--\" #Ability { id: \"26A2\", source: \"Mateus, The Corrupt\" }\r\n531.0 \"--Aqua Sphere Adds--\" #AddedCombatant { name: \"Aqua Sphere\" }\r\n554.2 \"Flash-Freeze\" #Ability { id: \"2647\", source: \"Mateus, The Corrupt\" }\r\n563.4 \"--sync--\" #Ability { id: \"2637\", source: \"Mateus, The Corrupt\" }\r\n571.3 \"Flash-Freeze\" #Ability { id: \"2647\", source: \"Mateus, The Corrupt\" }\r\n588.5 \"Flash-Freeze\" #Ability { id: \"2647\", source: \"Mateus, The Corrupt\" }\r\n\r\n\r\n### Hashmal, Bringer of Order\r\n# -p 25D8:1015 25C5:1305\r\n# -ii 25C2 25C6 266E\r\n# -it \"Hashmal, Bringer of Order\"\r\n\r\n# Palace Square will be sealed off\r\n1000.0 \"--start--\" SystemLogMessage { id: \"7DC\", param1: \"94C\" } window 10000,0\r\n1011.0 \"--sync--\" StartsUsing { id: \"25D8\", source: \"Hashmal, Bringer of Order\" } window 20,20\r\n1015.0 \"Quake IV\" Ability { id: \"25D8\", source: \"Hashmal, Bringer of Order\" }\r\n1020.4 \"Jagged Edge 1\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1022.5 \"Jagged Edge 2\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1024.6 \"Jagged Edge 3\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n\r\n1028.6 \"Control Tower x1\" Ability { id: \"25C1\", source: \"Hashmal, Bringer of Order\" }\r\n1031.8 \"Sanction\" Ability { id: \"25C3\", source: \"Hashmal, Bringer of Order\" }\r\n1038.1 \"--untargetable--\" # ??? from video\r\n1039.4 \"Towerfall\" Ability { id: \"25C4\", source: \"Control Tower\" }\r\n1046.2 \"Extreme Edge\" Ability { id: [\"25CE\", \"25D0\"], source: \"Hashmal, Bringer of Order\" }\r\n1050.1 \"--targetable--\" # ??? from video\r\n\r\n1056.1 \"Earth Hammer\" Ability { id: \"25CB\", source: \"Hashmal, Bringer of Order\" }\r\n1064.3 \"Hammerfall\" Ability { id: \"25CC\", source: \"Hashmal, Bringer of Order\" }\r\n1073.3 \"Quake IV\" Ability { id: \"25D8\", source: \"Hashmal, Bringer of Order\" }\r\n1082.6 \"Rock Cutter\" Ability { id: \"25D7\", source: \"Hashmal, Bringer of Order\" }\r\n\r\n# This can push early.\r\n1087.0 \"--sync--\" StartsUsing { id: \"25BC\", source: \"Hashmal, Bringer of Order\" } window 100,20\r\n1090.0 \"Command Tower\" Ability { id: \"25BC\", source: \"Hashmal, Bringer of Order\" }\r\n1101.3 \"Earth Shaker\" Ability { id: \"25C8\", source: \"Command Tower\" }\r\n1106.2 \"Earth Shaker\" Ability { id: \"25C8\", source: \"Command Tower\" }\r\n1106.6 \"Jagged Edge 1\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1108.4 \"Impact\" Ability { id: \"25C7\", source: \"Command Tower\" } window 30,3\r\n1108.7 \"Jagged Edge 2\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1110.7 \"Jagged Edge 3\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1113.2 \"--Sand Sphere Adds--\"\r\n1128.5 \"Falling Boulder\" Ability { id: \"25D2\", source: \"Hashmal, Bringer of Order\" }\r\n1135.8 \"Impact\" Ability { id: \"25C7\", source: \"Command Tower\" } window 24,3 # can push early and skip Sand Spheres\r\n1145.7 \"Earth Shaker\" #Ability { id: \"25C8\", source: \"Command Tower\" }\r\n1147.8 \"Earth Shaker\" #Ability { id: \"25C8\", source: \"Command Tower\" }\r\n1149.8 \"Falling Rock\" Ability { id: \"25D3\", source: \"Hashmal, Bringer of Order\" }\r\n# ??? more earth shaker, more jagged edge (seen on video, but no logs)\r\n\r\n1300.0 \"--sync--\" StartsUsing { id: \"25C5\", source: \"Hashmal, Bringer of Order\" } window 300,0\r\n1305.0 \"Landwaster\" Ability { id: \"25C5\", source: \"Hashmal, Bringer of Order\" }\r\n\r\n1314.4 \"Control Tower x2\" Ability { id: \"25C1\", source: \"Hashmal, Bringer of Order\" }\r\n1317.6 \"Sanction\" Ability { id: \"25C3\", source: \"Hashmal, Bringer of Order\" }\r\n1325.1 \"Towerfall\" Ability { id: \"25C4\", source: \"Control Tower\" }\r\n1326.0 \"Jagged Edge 1\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1328.1 \"Jagged Edge 2\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1330.2 \"Jagged Edge 3\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n\r\n1330.9 \"Control Tower x2\" Ability { id: \"25C1\", source: \"Hashmal, Bringer of Order\" }\r\n1334.1 \"Sanction\" Ability { id: \"25C3\", source: \"Hashmal, Bringer of Order\" }\r\n1341.7 \"Towerfall\" Ability { id: \"25C4\", source: \"Control Tower\" }\r\n1343.9 \"--untargetable--\" # ??? from video\r\n1348.2 \"Jagged Edge 1\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1348.5 \"Extreme Edge\" Ability { id: [\"25CE\", \"25D0\"], source: \"Hashmal, Bringer of Order\" }\r\n1350.3 \"Jagged Edge 2\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1352.3 \"Jagged Edge 3\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1355.4 \"--targetable--\" # ??? from video\r\n\r\n1360.3 \"Quake IV\" Ability { id: \"25D8\", source: \"Hashmal, Bringer of Order\" }\r\n1369.5 \"Quake IV\" Ability { id: \"25D8\", source: \"Hashmal, Bringer of Order\" }\r\n1378.9 \"Rock Cutter\" Ability { id: \"25D7\", source: \"Hashmal, Bringer of Order\" }\r\n1387.1 \"Earth Hammer\" Ability { id: \"25CB\", source: \"Hashmal, Bringer of Order\" }\r\n1395.3 \"Hammerfall x3\" Ability { id: \"25CC\", source: \"Hashmal, Bringer of Order\" }\r\n\r\n1398.3 \"Summon\" Ability { id: \"25D4\", source: \"Hashmal, Bringer of Order\" }\r\n1398.6 \"Jagged Edge 1\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1399.1 \"--Golem Adds--\"\r\n1400.7 \"Jagged Edge 2\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1402.8 \"Jagged Edge 3\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1411.3 \"Demolish\" Ability { id: \"25D6\", source: \"Pennantstone Golem\" }\r\n1414.5 \"Might\" Ability { id: \"25D5\", source: \"Pennantstone Golem\" }\r\n1415.8 \"Rock Cutter\" Ability { id: \"25D7\", source: \"Hashmal, Bringer of Order\" }\r\n1428.2 \"Rock Cutter\" Ability { id: \"25D7\", source: \"Hashmal, Bringer of Order\" }\r\n1437.3 \"Quake IV\" Ability { id: \"25D8\", source: \"Hashmal, Bringer of Order\" }\r\n\r\n1447.8 \"Submission Tower\" Ability { id: \"266D\", source: \"Hashmal, Bringer of Order\" }\r\n1451.0 \"Sanction\" Ability { id: \"2703\", source: \"Hashmal, Bringer of Order\" }\r\n1454.1 \"--Sand Sphere Adds--\"\r\n# 1459.1 \"--sync--\" StartsUsing { id: \"25C9\", source: \"Sand Sphere\" } # To Dust starts casting, probably the phase over when 20s cast complete\r\n1460.9 \"Towerfall\" Ability { id: \"25CA\", source: \"Submission Tower\" }\r\n1469.7 \"Falling Boulder\" Ability { id: \"25D2\", source: \"Hashmal, Bringer of Order\" }\r\n\r\n# Starts roughly after Sand Sphere adds are dead, guessing at this natural time if To Dust goes off\r\n1480.6 \"--sync--\" StartsUsing { id: [\"25CE\", \"25D0\"], source: \"Hashmal, Bringer of Order\" } window 40,40\r\n1486.6 \"Extreme Edge\" Ability { id: [\"25CE\", \"25D0\"], source: \"Hashmal, Bringer of Order\" }\r\n1489.1 \"Falling Rock\" Ability { id: \"25D3\", source: \"Hashmal, Bringer of Order\" }\r\n1499.3 \"Quake IV\" Ability { id: \"25D8\", source: \"Hashmal, Bringer of Order\" }\r\n1508.5 \"Rock Cutter\" Ability { id: \"25D7\", source: \"Hashmal, Bringer of Order\" }\r\n\r\n# loop\r\n1515.8 \"Control Tower x2\" Ability { id: \"25C1\", source: \"Hashmal, Bringer of Order\" } window 100,100 jump 1314.4\r\n1519.0 \"Sanction\" #Ability { id: \"25C3\", source: \"Hashmal, Bringer of Order\" }\r\n1526.5 \"Towerfall\" #Ability { id: \"25C4\", source: \"Control Tower\" }\r\n1527.4 \"Jagged Edge 1\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1529.5 \"Jagged Edge 2\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1531.6 \"Jagged Edge 3\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n\r\n1532.3 \"Control Tower x2\" #Ability { id: \"25C1\", source: \"Hashmal, Bringer of Order\" }\r\n1535.5 \"Sanction\" #Ability { id: \"25C3\", source: \"Hashmal, Bringer of Order\" }\r\n1543.1 \"Towerfall\" #Ability { id: \"25C4\", source: \"Control Tower\" }\r\n1545.3 \"--untargetable--\" # ??? from video\r\n1549.6 \"Jagged Edge 1\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1549.9 \"Extreme Edge\" #Ability { id: [\"25CE\", \"25D0\"], source: \"Hashmal, Bringer of Order\" }\r\n1551.7 \"Jagged Edge 2\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1553.7 \"Jagged Edge 3\" #Ability { id: \"25CD\", source: \"Hashmal, Bringer of Order\" }\r\n1556.8 \"--targetable--\" # ??? from video\r\n\r\n\r\n### Rofocale\r\n# -p 2680:2015.8 268A:2421.1\r\n# -ii 2681 2682 2684 2677 2678 2679 267A 267B 267C 267D 267E 267F 268C 2672 2673 268B 2686 2687 367 368\r\n# -it \"Rofocale\"\r\n\r\n# Lesalia Garden Ruins will be sealed off\r\n2000.0 \"--start--\" SystemLogMessage { id: \"7DC\", param1: \"94D\" } window 10000,0\r\n2012.8 \"--sync--\" StartsUsing { id: \"2680\", source: \"Rofocale\" } window 20,20\r\n2015.8 \"Crush Helm\" Ability { id: \"2680\", source: \"Rofocale\" } duration 3.4\r\n2035.5 \"Chariot\" Ability { id: \"2674\", source: \"Rofocale\" }\r\n2040.8 \"Cry Of Victory\" Ability { id: \"2675\", source: \"Rofocale\" }\r\n2052.5 \"Crush Weapon x3\" Ability { id: \"2683\", source: \"Rofocale\" }\r\n2073.4 \"Trample\" Ability { id: \"2676\", source: \"Rofocale\" } duration 3.2\r\n2093.9 \"Maverick\" Ability { id: \"2689\", source: \"Rofocale\" }\r\n2104.8 \"Crush Helm\" Ability { id: \"2680\", source: \"Rofocale\" } duration 3.4\r\n2117.7 \"Crush Weapon x3\" Ability { id: \"2683\", source: \"Rofocale\" }\r\n2124.5 \"Trample\" Ability { id: \"2676\", source: \"Rofocale\" }\r\n2142.5 \"Chariot\" Ability { id: \"2674\", source: \"Rofocale\" }\r\n2147.8 \"Cry Of Victory\" Ability { id: \"2675\", source: \"Rofocale\" }\r\n2154.6 \"Trample\" Ability { id: \"2676\", source: \"Rofocale\" } duration 3.2\r\n2165.8 \"Crush Weapon x3\" Ability { id: \"2683\", source: \"Rofocale\" }\r\n2178.5 \"Maverick\" Ability { id: \"2689\", source: \"Rofocale\" }\r\n2189.4 \"Crush Helm\" Ability { id: \"2680\", source: \"Rofocale\" } duration 3.4\r\n\r\n2199.3 \"--invulnerable--\" # ??? from video, no debuff in logs, can push to this by hp%\r\n2201.3 \"Archaeodemon Adds\" AddedCombatant { name: \"Archaeodemon\" } window 300,300\r\n2208.3 \"--lock out--\" # ??? from video\r\n\r\n# https://xivapi.com/InstanceContentTextData/18031\r\n# en: The heavens tremble in my wake!\r\n2400.0 \"--sync--\" BattleTalk2 { instanceContentTextId: \"466F\" } window 500,0\r\n2417.6 \"--sync--\" StartsUsing { id: \"268A\", source: \"Rofocale\" } window 500,10\r\n2421.1 \"Heavenly Subjugation\"\r\n2433.5 \"Embrace\" Ability { id: \"2685\", source: \"Rofocale\" }\r\n2450.8 \"Chariot\" Ability { id: \"2674\", source: \"Rofocale\" }\r\n2456.0 \"Cry Of Victory\" Ability { id: \"2675\", source: \"Rofocale\" }\r\n2466.7 \"Trample\" Ability { id: \"2676\", source: \"Rofocale\" } duration 3.2\r\n2473.5 \"Cry Of Victory\" Ability { id: \"274C\", source: \"Rofocale\" }\r\n2484.6 \"Pomp And Circumstance\" Ability { id: \"268D\", source: \"Rofocale\" }\r\n2492.8 \"Embrace\" Ability { id: \"2685\", source: \"Rofocale\" }\r\n2500.4 \"Crush Weapon x4\" Ability { id: \"2683\", source: \"Rofocale\" }\r\n2512.6 \"Maverick\" Ability { id: \"2689\", source: \"Rofocale\" } # targetable Maverick\r\n2519.6 \"Crush Helm\" Ability { id: \"2680\", source: \"Rofocale\" }\r\n2531.0 \"Embrace\" Ability { id: \"2685\", source: \"Rofocale\" }\r\n2539.2 \"Pomp And Circumstance\" Ability { id: \"268D\", source: \"Rofocale\" }\r\n2545.4 \"Dark Geas\" Ability { id: \"2688\", source: \"Rofocale\" }\r\n# => variable time turning off the lights\r\n\r\n# Seen 2734 only once in the loop fflogs link below.\r\n2700.0 \"--sync--\" StartsUsing { id: [\"2734\", \"2726\"], source: \"Rofocale\" } window 160,0\r\n2706.0 \"Maverick\" Ability { id: [\"2734\", \"2726\"], source: \"Rofocale\" }\r\n2716.9 \"Crush Helm\" Ability { id: \"2680\", source: \"Rofocale\" }\r\n2726.3 \"Embrace\" Ability { id: \"2685\", source: \"Rofocale\" }\r\n2735.5 \"Maverick\" Ability { id: \"2689\", source: \"Rofocale\" }\r\n2736.5 \"Chariot\" Ability { id: \"2674\", source: \"Rofocale\" }\r\n2741.7 \"Cry Of Victory\" Ability { id: \"2675\", source: \"Rofocale\" }\r\n2751.0 \"Maverick\" Ability { id: \"2689\", source: \"Rofocale\" }\r\n2753.5 \"Trample\" Ability { id: \"2676\", source: \"Rofocale\" }\r\n2760.3 \"Cry Of Victory\" Ability { id: \"274C\", source: \"Rofocale\" }\r\n2774.0 \"Crush Weapon x4\" Ability { id: \"2683\", source: \"Rofocale\" }\r\n2779.1 \"Dark Geas\" Ability { id: \"2688\", source: \"Rofocale\" }\r\n# => variable time turning off the lights\r\n\r\n2900.0 \"--sync--\" StartsUsing { id: [\"2734\", \"2726\"], source: \"Rofocale\" } window 160,0\r\n2906.0 \"Maverick\" Ability { id: [\"2734\", \"2726\"], source: \"Rofocale\" }\r\n2917.3 \"Crush Weapon x4\" Ability { id: \"2683\", source: \"Rofocale\" }\r\n2924.2 \"Trample\" Ability { id: \"2676\", source: \"Rofocale\" }\r\n2931.0 \"Cry Of Victory\" Ability { id: \"274C\", source: \"Rofocale\" }\r\n2937.2 \"Crush Helm\" Ability { id: \"2680\", source: \"Rofocale\" }\r\n2948.6 \"Embrace\" Ability { id: \"2685\", source: \"Rofocale\" }\r\n2958.9 \"Chariot\" Ability { id: \"2674\", source: \"Rofocale\" }\r\n2964.3 \"Cry Of Victory\" Ability { id: \"2675\", source: \"Rofocale\" }\r\n2971.4 \"Pomp And Circumstance\" Ability { id: \"268D\", source: \"Rofocale\" }\r\n2983.0 \"Crush Weapon x4\" Ability { id: \"2683\", source: \"Rofocale\" }\r\n2990.1 \"Pomp And Circumstance\" Ability { id: \"268D\", source: \"Rofocale\" }\r\n3006.3 \"Crush Helm\" Ability { id: \"2680\", source: \"Rofocale\" }\r\n3015.8 \"Embrace\" Ability { id: \"2685\", source: \"Rofocale\" }\r\n3022.7 \"Trample\" Ability { id: \"2676\", source: \"Rofocale\" }\r\n3029.5 \"Cry Of Victory\" Ability { id: \"274C\", source: \"Rofocale\" }\r\n3036.4 \"Trample\" Ability { id: \"2676\", source: \"Rofocale\" }\r\n3043.1 \"Cry Of Victory\" Ability { id: \"274C\", source: \"Rofocale\" }\r\n3056.8 \"Crush Weapon x3\" Ability { id: \"2683\", source: \"Rofocale\" }\r\n\r\n# begin loop\r\n# Thanks to https://www.fflogs.com/reports/zpg2CQNMqFBmawcW#fight=8 for this loop.  @_@;;;\r\n3068.0 \"Maverick\" Ability { id: \"2689\", source: \"Rofocale\" }\r\n3069.2 \"Chariot\" Ability { id: \"2674\", source: \"Rofocale\" }\r\n3074.5 \"Cry of Victory\" Ability { id: \"2675\", source: \"Rofocale\" }\r\n3083.6 \"Crush Helm\" Ability { id: \"2680\", source: \"Rofocale\" }\r\n3094.8 \"Embrace\" Ability { id: \"2685\", source: \"Rofocale\" }\r\n3102.8 \"Pomp and Circumstance\" Ability { id: \"268D\", source: \"Rofocale\" }\r\n3104.8 \"Maverick\" Ability { id: \"2689\", source: \"Rofocale\" }\r\n3119.3 \"Crush Weapon\" Ability { id: \"2683\", source: \"Rofocale\" }\r\n3126.3 \"Pomp and Circumstance\" Ability { id: \"268D\", source: \"Rofocale\" }\r\n3142.3 \"Crush Helm\" Ability { id: \"2680\", source: \"Rofocale\" }\r\n3149.5 \"Embrace\" Ability { id: \"2685\", source: \"Rofocale\" }\r\n3156.1 \"Trample\" Ability { id: \"2676\", source: \"Rofocale\" }\r\n3162.9 \"Cry of Victory\" Ability { id: \"274C\", source: \"Rofocale\" }\r\n3169.6 \"Trample\" Ability { id: \"2676\", source: \"Rofocale\" }\r\n3176.4 \"Cry of Victory\" Ability { id: \"274C\", source: \"Rofocale\" }\r\n3189.9 \"Crush Weapon\" Ability { id: \"2683\", source: \"Rofocale\" }\r\n\r\n# loop\r\n3200.9 \"Maverick\" Ability { id: \"2689\", source: \"Rofocale\" } window 80,80 jump 3068\r\n3202.1 \"Chariot\" #Ability { id: \"2674\", source: \"Rofocale\" }\r\n3207.4 \"Cry of Victory\" #Ability { id: \"2675\", source: \"Rofocale\" }\r\n3216.5 \"Crush Helm\" #Ability { id: \"2680\", source: \"Rofocale\" }\r\n3227.7 \"Embrace\" #Ability { id: \"2685\", source: \"Rofocale\" }\r\n\r\n\r\n### Argath Thadalfus\r\n# -p 262D:4009.7 26505 261F:4605 2620:4702.5\r\n# -ii 2713 262C 2631\r\n# -it \"Argath Thadalfus\"\r\n#\r\n#                                                 +-> Phase 4a -+\r\n# Phase 1 -> Phase 2, 72% (adds) -> Phase 3, 45% -+             +-> Phase 3 (loop)\r\n#                                                 +-> Phase 4b -+\r\n#\r\n# Note: Coldblood (2625) is ignored because that's when the boss disappears?\r\n\r\n## Phase 1\r\n# Lesalia Temple Ruins will be sealed off\r\n4000.0 \"--start--\" SystemLogMessage { id: \"7DC\", param1: \"94E\" } window 10000,0\r\n4006.7 \"--sync--\" StartsUsing { id: \"262D\", source: \"Argath Thadalfus\" } window 20,20\r\n4009.7 \"Crippling Blow\" Ability { id: \"262D\", source: \"Argath Thadalfus\" }\r\n4017.9 \"Crush Weapon x3\" Ability { id: \"2628\", source: \"Argath Thadalfus\" }\r\n4023.9 \"Soulfix\" Ability { id: \"262A\", source: \"Argath Thadalfus\" }\r\n4030.0 \"Mask Of Truth\" Ability { id: \"261A\", source: \"Argath Thadalfus\" }\r\n4038.0 \"The Word\" Ability { id: \"24A0\", source: \"Argath Thadalfus\" }\r\n4049.8 \"Fire IV\" Ability { id: \"262E\", source: \"Argath Thadalfus\" }\r\n4058.1 \"Crippling Blow\" Ability { id: \"262D\", source: \"Argath Thadalfus\" }\r\n\r\n# Note: adding a larger sync in case there's a push here just to be safe.\r\n4064.3 \"--sync--\" StartsUsing { id: \"2622\", source: \"Argath Thadalfus\" } window 100,10\r\n4067.3 \"Trepidation\" Ability { id: \"2622\", source: \"Argath Thadalfus\" }\r\n4075.8 \"Unrelenting\" Ability { id: \"262B\", source: \"Argath Thadalfus\" }\r\n4077.3 \"Rail Of The Rat 1\" Ability { id: \"2624\", source: \"Argath Thadalfus\" }\r\n4080.3 \"Rail Of The Rat 2\" Ability { id: \"2624\", source: \"Argath Thadalfus\" }\r\n4083.5 \"Rail Of The Rat 3\" Ability { id: \"2624\", source: \"Argath Thadalfus\" }\r\n4084.1 \"Crippling Blow\" Ability { id: \"262D\", source: \"Argath Thadalfus\" }\r\n4086.8 \"Mask Of Truth\" Ability { id: \"261A\", source: \"Argath Thadalfus\" }\r\n4094.9 \"The Word\" Ability { id: \"24A0\", source: \"Argath Thadalfus\" }\r\n\r\n# Can early push (before Trepidation) to Judgment Blade.\r\n# TODO: is this an HP push? or is this a bug? I see this in <5% of logs atmost.\r\n4099.0 \"--sync--\" StartsUsing { id: \"2629\", source: \"Argath Thadalfus\" } window 100,10\r\n4102.0 \"Judgment Blade\" Ability { id: \"2629\", source: \"Argath Thadalfus\" }\r\n4108.3 \"Crippling Blow\" Ability { id: \"262D\", source: \"Argath Thadalfus\" }\r\n4110.4 \"--sync--\" Ability { id: \"2625\", source: \"Argath Thadalfus\" }\r\n4117.7 \"Heartless\" Ability { id: \"2632\", source: \"Heartless\" }\r\n4120.4 \"Coldblood\" Ability { id: \"2627\", source: \"Argath Thadalfus\" }\r\n4129.2 \"Royal Blood\" #Ability { id: \"261E\", source: \"Argath Thadalfus\" }\r\n\r\n## Phase 2: Shades and Shards (percentage push to this, 72%?)\r\n4500.0 \"--sync--\" StartsUsing { id: \"261E\", source: \"Argath Thadalfus\" } window 500,0\r\n4505.0 \"Royal Blood\" Ability { id: \"261E\", source: \"Argath Thadalfus\" }\r\n4505.3 \"--Shade Adds--\"\r\n4515.2 \"Crippling Blow\" Ability { id: \"262D\", source: \"Argath Thadalfus\" }\r\n4525.4 \"Unrelenting\" Ability { id: \"262B\", source: \"Argath Thadalfus\" }\r\n# => variable amount of time until all shades are dead or explode\r\n\r\n4600.0 \"--sync--\" StartsUsing { id: \"261F\", source: \"Argath Thadalfus\" } window 600,0\r\n4605.0 \"Empty Soul\" Ability { id: \"261F\", source: \"Argath Thadalfus\" }\r\n4605.9 \"--Shard Adds--\"\r\n4607.1 \"--sync--\" Ability { id: \"270B\", source: \"Argath Thadalfus\" }\r\n# => variable amount of time until all shards are dead or you wipe\r\n\r\n4700.0 \"--sync--\" StartsUsing { id: \"2620\", source: \"Argath Thadalfus\" } window 700,0\r\n4702.5 \"Dark Ultima\" Ability { id: \"2620\", source: \"Argath Thadalfus\" }\r\n4715.4 \"Mask Of Lies\" Ability { id: \"2619\", source: \"Argath Thadalfus\" }\r\n4723.4 \"The Word\" Ability { id: \"24A0\", source: \"Argath Thadalfus\" }\r\n4732.5 \"Gnawing Dread\" Ability { id: \"2621\", source: \"Argath Thadalfus\" }\r\n4740.7 \"Soulfix\" Ability { id: \"262A\", source: \"Argath Thadalfus\" }\r\n4746.6 \"Unrelenting\" Ability { id: \"262B\", source: \"Argath Thadalfus\" }\r\n4756.5 \"Crippling Blow\" Ability { id: \"262D\", source: \"Argath Thadalfus\" }\r\n4762.7 \"Soulfix\" Ability { id: \"262A\", source: \"Argath Thadalfus\" }\r\n4771.9 \"Crush Weapon\" Ability { id: \"2628\", source: \"Argath Thadalfus\" }\r\n4777.2 \"Unrelenting\" Ability { id: \"262B\", source: \"Argath Thadalfus\" }\r\n4786.4 \"Fire IV\" Ability { id: \"262E\", source: \"Argath Thadalfus\" }\r\n# => natural push into phase 3\r\n# (probably, based on https://www.fflogs.com/reports/8Wmfp6FZ72DtcjKn#fight=last at hp=67%)\r\n\r\n## Phase 3: ~45% (can push early)\r\n4795.0 \"Mask Of Truth/Mask Of Lies\" Ability { id: [\"2619\", \"261A\"], source: \"Argath Thadalfus\" } window 100,10\r\n4803.0 \"The Word\" Ability { id: \"24A0\", source: \"Argath Thadalfus\" }\r\n4813.6 \"Mask Of Truth/Mask Of Lies\" Ability { id: [\"2619\", \"261A\"], source: \"Argath Thadalfus\" }\r\n4821.8 \"The Word\" Ability { id: \"24A0\", source: \"Argath Thadalfus\" }\r\n4828.8 \"Judgment Blade?\" Ability { id: \"2629\", source: \"Argath Thadalfus\" } window 100,100 jump 5000\r\n4830.7 \"Gnawing Dread?\" Ability { id: \"2621\", source: \"Argath Thadalfus\" } window 100,100 jump 5300\r\n\r\n## Phase 4a: Judgment blade first\r\n5000.0 \"Judgment Blade\" Ability { id: \"2629\", source: \"Argath Thadalfus\" }\r\n5006.1 \"Unrelenting\" Ability { id: \"262B\", source: \"Argath Thadalfus\" }\r\n5008.2 \"--sync--\" Ability { id: \"2625\", source: \"Argath Thadalfus\" }\r\n5015.9 \"Heartless\" Ability { id: \"2632\", source: \"Heartless\" }\r\n5018.2 \"Coldblood\" Ability { id: \"2627\", source: \"Argath Thadalfus\" }\r\n5032.2 \"Fire IV\" Ability { id: \"262E\", source: \"Argath Thadalfus\" }\r\n5040.4 \"Crippling Blow\" Ability { id: \"262D\", source: \"Argath Thadalfus\" }\r\n5045.5 \"Trepidation\" Ability { id: \"2622\", source: \"Argath Thadalfus\" }\r\n5050.6 \"Crush Weapon\" Ability { id: \"2628\", source: \"Argath Thadalfus\" }\r\n5055.6 \"Rail Of The Rat 1\" Ability { id: \"2624\", source: \"Argath Thadalfus\" }\r\n5058.6 \"Rail Of The Rat 2\" Ability { id: \"2624\", source: \"Argath Thadalfus\" }\r\n5061.6 \"Rail Of The Rat 3\" Ability { id: \"2624\", source: \"Argath Thadalfus\" }\r\n5065.8 \"Soulfix\" Ability { id: \"262A\", source: \"Argath Thadalfus\" }\r\n5076.4 \"Mask Of Truth/Mask Of Lies\" Ability { id: [\"2619\", \"261A\"], source: \"Argath Thadalfus\" }\r\n5084.5 \"The Word\" Ability { id: \"24A0\", source: \"Argath Thadalfus\" }\r\n5095.0 \"Mask Of Truth/Mask Of Lies\" Ability { id: [\"2619\", \"261A\"], source: \"Argath Thadalfus\" }\r\n5103.1 \"The Word\" Ability { id: \"24A0\", source: \"Argath Thadalfus\" }\r\n5112.0 \"Gnawing Dread\" Ability { id: \"2621\", source: \"Argath Thadalfus\" }\r\n5114.1 \"--sync--\" Ability { id: \"2625\", source: \"Argath Thadalfus\" }\r\n5128.1 \"Coldblood (Hole In One)\" Ability { id: \"2626\", source: \"Argath Thadalfus\" }\r\n5135.3 \"Soulfix\" Ability { id: \"262A\", source: \"Argath Thadalfus\" }\r\n5148.2 \"Crippling Blow\" Ability { id: \"262D\", source: \"Argath Thadalfus\" }\r\n5159.5 \"Gnawing Dread\" Ability { id: \"2621\", source: \"Argath Thadalfus\" }\r\n5168.7 \"Crush Weapon\" Ability { id: \"2628\", source: \"Argath Thadalfus\" }\r\n5173.9 \"Unrelenting\" Ability { id: \"262B\", source: \"Argath Thadalfus\" }\r\n5180.0 \"Fire IV\" Ability { id: \"262E\", source: \"Argath Thadalfus\" }\r\n5189.1 \"Fire IV\" Ability { id: \"262E\", source: \"Argath Thadalfus\" }\r\n5197.1 \"Crippling Blow\" Ability { id: \"262D\", source: \"Argath Thadalfus\" }\r\n\r\n# loop\r\n5207.2 \"Mask Of Truth/Mask Of Lies\" Ability { id: [\"2619\", \"261A\"], source: \"Argath Thadalfus\" } window 100,100 jump 4795\r\n5215.3 \"The Word\" #Ability { id: \"24A0\", source: \"Argath Thadalfus\" }\r\n5225.6 \"Mask Of Truth/Mask Of Lies\" #Ability { id: [\"2619\", \"261A\"], source: \"Argath Thadalfus\" }\r\n5233.7 \"The Word\" #Ability { id: \"24A0\", source: \"Argath Thadalfus\" }\r\n\r\n\r\n## Phase 4b: Putt Putt first\r\n5300.0 \"Gnawing Dread\" Ability { id: \"2621\", source: \"Argath Thadalfus\" }\r\n5302.1 \"--sync--\" Ability { id: \"2625\", source: \"Argath Thadalfus\" }\r\n5316.0 \"Coldblood (Hole In One)\" Ability { id: \"2626\", source: \"Argath Thadalfus\" }\r\n5323.2 \"Soulfix\" Ability { id: \"262A\", source: \"Argath Thadalfus\" }\r\n5337.2 \"Fire IV\" Ability { id: \"262E\", source: \"Argath Thadalfus\" }\r\n5345.5 \"Crippling Blow\" Ability { id: \"262D\", source: \"Argath Thadalfus\" }\r\n5350.7 \"Trepidation\" Ability { id: \"2622\", source: \"Argath Thadalfus\" }\r\n5355.8 \"Crush Weapon\" Ability { id: \"2628\", source: \"Argath Thadalfus\" }\r\n5360.8 \"Rail Of The Rat 1\" Ability { id: \"2624\", source: \"Argath Thadalfus\" }\r\n5363.8 \"Rail Of The Rat 2\" Ability { id: \"2624\", source: \"Argath Thadalfus\" }\r\n5366.9 \"Rail Of The Rat 3\" Ability { id: \"2624\", source: \"Argath Thadalfus\" }\r\n5371.1 \"Soulfix\" Ability { id: \"262A\", source: \"Argath Thadalfus\" }\r\n5384.3 \"Mask Of Truth/Mask Of Lies\" Ability { id: [\"2619\", \"261A\"], source: \"Argath Thadalfus\" }\r\n5392.3 \"The Word\" Ability { id: \"24A0\", source: \"Argath Thadalfus\" }\r\n5402.9 \"Mask Of Truth/Mask Of Lies\" Ability { id: [\"2619\", \"261A\"], source: \"Argath Thadalfus\" }\r\n5411.1 \"The Word\" Ability { id: \"24A0\", source: \"Argath Thadalfus\" }\r\n5418.0 \"Judgment Blade\" Ability { id: \"2629\", source: \"Argath Thadalfus\" }\r\n5424.4 \"Unrelenting\" Ability { id: \"262B\", source: \"Argath Thadalfus\" }\r\n5426.5 \"--sync--\" Ability { id: \"2625\", source: \"Argath Thadalfus\" }\r\n5433.9 \"Heartless\" Ability { id: \"2632\", source: \"Heartless\" }\r\n5436.6 \"Coldblood\" Ability { id: \"2627\", source: \"Argath Thadalfus\" }\r\n5449.5 \"Crippling Blow\" Ability { id: \"262D\", source: \"Argath Thadalfus\" }\r\n5460.7 \"Gnawing Dread\" Ability { id: \"2621\", source: \"Argath Thadalfus\" }\r\n5469.9 \"Crush Weapon\" Ability { id: \"2628\", source: \"Argath Thadalfus\" }\r\n5475.1 \"Unrelenting\" Ability { id: \"262B\", source: \"Argath Thadalfus\" }\r\n5481.2 \"Fire IV\" Ability { id: \"262E\", source: \"Argath Thadalfus\" }\r\n5490.3 \"Fire IV\" Ability { id: \"262E\", source: \"Argath Thadalfus\" }\r\n5498.3 \"Crippling Blow\" Ability { id: \"262D\", source: \"Argath Thadalfus\" }\r\n\r\n# loop\r\n5508.4 \"Mask Of Truth/Mask Of Lies\" Ability { id: [\"2619\", \"261A\"], source: \"Argath Thadalfus\" } window 100,100 jump 4795\r\n5516.5 \"The Word\" #Ability { id: \"24A0\", source: \"Argath Thadalfus\" }\r\n5526.8 \"Mask Of Truth/Mask Of Lies\" #Ability { id: [\"2619\", \"261A\"], source: \"Argath Thadalfus\" }\r\n5534.9 \"The Word\" #Ability { id: \"24A0\", source: \"Argath Thadalfus\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/deepdungeon/heaven-on-high_floors_01-10.ts



// Heaven-on-High Floors 01-10
// TODO: Heavenly Shark Jaws tankbuster, can stun
const heaven_on_high_floors_01_10_triggerSet = {
  id: 'HeavenOnHighFloors1_10',
  zoneId: zone_id/* default.HeavenOnHighFloors1_10 */.Z.HeavenOnHighFloors1_10,
  triggers: [
  // ---------------- Floor 01-09 Mobs ----------------
  {
    id: 'HoH 01-10 Heavenly Amikiri Shuck',
    // tankbuster, can stun
    type: 'StartsUsing',
    netRegex: {
      id: '2ECE',
      source: 'Heavenly Amikiri'
    },
    response: responses/* Responses.stunIfPossible */.n3.stunIfPossible()
  }, {
    id: 'HoH 01-10 Heavenly Uwabami Stone Gaze',
    // inflicts Petrify
    type: 'StartsUsing',
    netRegex: {
      id: '18CF',
      source: 'Heavenly Uwabami',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  },
  // ---------------- Floor 10 Boss: Mojabune ----------------
  {
    id: 'HoH 01-10 Mojabune Overtow',
    // knockback, knockback prevention does not work
    type: 'StartsUsing',
    netRegex: {
      id: '2E65',
      source: 'Mojabune',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Heavenly Amikiri': 'Himmelssäulen-Amikiri',
      'Heavenly Uwabami': 'Himmelssäulen-Uwabami',
      'Mojabune': 'Mojabune'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Heavenly Amikiri': 'Amikiri des Cieux',
      'Heavenly Uwabami': 'uwabami des Cieux',
      'Mojabune': 'Môjabune'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Heavenly Amikiri': 'アメノ・アミキリ',
      'Heavenly Uwabami': 'アメノ・ウワバミ',
      'Mojabune': 'モウジャブネ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Heavenly Amikiri': '天之切网虾蛄',
      'Heavenly Uwabami': '天之蟒蛇',
      'Mojabune': '亡者船'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Heavenly Amikiri': '천궁 아미키리',
      'Heavenly Uwabami': '천궁 이무기',
      'Mojabune': '망자의 배'
    }
  }]
};
/* harmony default export */ const heaven_on_high_floors_01_10 = (heaven_on_high_floors_01_10_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/deepdungeon/heaven-on-high_floors_11-20.ts



// Heaven-on-High Floors 11-20
// TODO: Heavenly Hand Wash Away, high damage + knockback enrage, can stun or interrupt
const heaven_on_high_floors_11_20_triggerSet = {
  id: 'HeavenOnHighFloors11_20',
  zoneId: zone_id/* default.HeavenOnHighFloors11_20 */.Z.HeavenOnHighFloors11_20,
  triggers: [
  // ---------------- Floor 11-19 Mobs ----------------
  {
    id: 'HoH 11-20 Heavenly Otokage Nightmarish Light',
    // gaze, inflicts Seduction, immediately combos with Garish Light (inflicts Minimum)
    type: 'StartsUsing',
    netRegex: {
      id: '3022',
      source: 'Heavenly Otokage',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  },
  // ---------------- Floor 20 Boss: Beccho ----------------
  {
    id: 'HoH 11-20 Beccho Neuro Squama',
    // gaze, inflicts Hysteria, combos with Psycho Squama (2E7B) and Fragility (2E7D)
    type: 'StartsUsing',
    netRegex: {
      id: '2E7C',
      source: 'Beccho',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Beccho': 'Beccho',
      'Heavenly Otokage': 'Himmelssäulen-Otokage'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Beccho': 'Becchô',
      'Heavenly Otokage': 'ô-tokage des Cieux'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Beccho': 'ベッチョウ',
      'Heavenly Otokage': 'アメノ・オオトカゲ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Beccho': '别蝶',
      'Heavenly Otokage': '天之巨蜥'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Beccho': '벳쵸',
      'Heavenly Otokage': '천궁 왕도마뱀'
    }
  }]
};
/* harmony default export */ const heaven_on_high_floors_11_20 = (heaven_on_high_floors_11_20_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/deepdungeon/heaven-on-high_floors_21-30.ts



// Heaven-on-High Floors 21-30

const heaven_on_high_floors_21_30_triggerSet = {
  id: 'HeavenOnHighFloors21_30',
  zoneId: zone_id/* default.HeavenOnHighFloors21_30 */.Z.HeavenOnHighFloors21_30,
  triggers: [
  // ---------------- Floor 21-29 Mobs ----------------
  {
    id: 'HoH 21-30 Heavenly Onibi Blinding Burst',
    type: 'StartsUsing',
    netRegex: {
      id: '2F8E',
      source: 'Heavenly Onibi',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'HoH 21-30 Heavenly Hatamoto Tenka Goken',
    type: 'StartsUsing',
    netRegex: {
      id: '2F47',
      source: 'Heavenly Hatamoto',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  },
  // ---------------- Floor 30 Boss: Hiruko ----------------
  {
    id: 'HoH 21-30 Hiruko Shiko',
    // boss does a proximity damage stomp that knocks players into the air
    // getting knocked up into a cloud kills the cloud
    // remaining clouds do an untelegraphed AoE (Lightning Bolt, 2C1E) that inflict Vulnerability Up stacks (63D)
    type: 'StartsUsing',
    netRegex: {
      id: '2C1B',
      source: 'Hiruko',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand under a cloud',
        de: 'Steh unter einer Wolke',
        fr: 'Restez sous un nuage',
        cn: '站在一朵云下',
        ko: '구름 아래에 서기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Heavenly Hatamoto': 'Himmelssäulen-Hatamoto',
      'Heavenly Onibi': 'Himmelssäulen-Onibi',
      'Hiruko': 'Hiruko'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Heavenly Hatamoto': 'hatamoto des Cieux',
      'Heavenly Onibi': 'onibi des Cieux',
      'Hiruko': 'Hiruko'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Heavenly Hatamoto': 'アメノ・ハタモト',
      'Heavenly Onibi': 'アメノ・オニビ',
      'Hiruko': 'ヒルコ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Heavenly Hatamoto': '天之旗本',
      'Heavenly Onibi': '天之鬼火',
      'Hiruko': '蛭子'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Heavenly Hatamoto': '천궁 직속 무사',
      'Heavenly Onibi': '천궁 도깨비불',
      'Hiruko': '히루코'
    }
  }]
};
/* harmony default export */ const heaven_on_high_floors_21_30 = (heaven_on_high_floors_21_30_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/deepdungeon/heaven-on-high_floors_31-40.ts



// Heaven-on-High Floors 31-40
// TODO: Heavenly Vanara unknown untelegraphed front cone AoE
// TODO: Bhima Ancient Aero III
const heaven_on_high_floors_31_40_triggerSet = {
  id: 'HeavenOnHighFloors31_40',
  zoneId: zone_id/* default.HeavenOnHighFloors31_40 */.Z.HeavenOnHighFloors31_40,
  triggers: [
  // ---------------- Floor 31-39 Mobs ----------------
  {
    id: 'HoH 31-40 Heavenly Dogu Shifting Light',
    type: 'StartsUsing',
    netRegex: {
      id: '3045',
      source: 'Heavenly Dogu',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }
  // ---------------- Floor 40 Boss: Bhima ----------------
  // {
  //   id: 'HoH 31-40 Bhima Ancient Aero III',
  //   // spawns whirlwinds on either E/W or N/S sides of arena
  //   // does a knockback from center, knockback prevention doesn't work
  //   // whirlwinds do a simultaneous aoe as the knockback goes off
  //   type: 'StartsUsing',
  //   netRegex: { id: '', source: 'Bhima', capture: false },
  //   alertText: (_data, _matches, output) => output.text!(),
  //   outputStrings: {
  //     text: {
  //       en: 'Knockback away from whirlwinds',
  //     },
  //   },
  // },
  ],

  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bhima': 'Bhima',
      'Heavenly Dogu': 'Himmelssäulen-Dogu'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bhima': 'Bhima',
      'Heavenly Dogu': 'dogû des Cieux'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bhima': 'ビーマ',
      'Heavenly Dogu': 'アメノ・ドグウ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bhima': '怖军',
      'Heavenly Dogu': '天之土偶'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bhima': '비마',
      'Heavenly Dogu': '천궁 토우'
    }
  }]
};
/* harmony default export */ const heaven_on_high_floors_31_40 = (heaven_on_high_floors_31_40_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/deepdungeon/heaven-on-high_floors_41-50.ts



// Heaven-on-High Floors 41-50
// TODO: Gozu The Spin
const heaven_on_high_floors_41_50_triggerSet = {
  id: 'HeavenOnHighFloors41_50',
  zoneId: zone_id/* default.HeavenOnHighFloors41_50 */.Z.HeavenOnHighFloors41_50,
  triggers: [
  // ---------------- Floor 41-49 Mobs ----------------
  // intentionally blank
  // ---------------- Floor 50 Boss: Gozu ----------------
  {
    id: 'HoH 41-50 Gozu Rusting Claw',
    // untelegraphed front cone AoE
    type: 'StartsUsing',
    netRegex: {
      id: '2E8F',
      source: 'Gozu',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'HoH 41-50 Gozu Words of Woe',
    // untelegraphed front line AoE
    type: 'StartsUsing',
    netRegex: {
      id: '2E90',
      source: 'Gozu',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'HoH 41-50 Gozu Eye of the Fire',
    // gaze, inflicts Confusion
    type: 'StartsUsing',
    netRegex: {
      id: '2E92',
      source: 'Gozu',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }
  // {
  //   id: 'HoH 41-50 Gozu The Spin',
  //   // spawns several Glooms (orbs) around the arena
  //   // does a roomwide proximity AoE while the Glooms pulse PBAoEs
  //   type: 'StartsUsing',
  //   netRegex: { id: '', source: 'Gozu', capture: false },
  //   alertText: (_data, _matches, output) => output.text!(),
  //   outputStrings: {
  //     text: {
  //       en: 'Away from boss and orbs',
  //     },
  //   },
  // },
  ],

  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Gozu': 'Gozu'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Gozu': 'Gozu'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Gozu': 'ゴズ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Gozu': '牛头'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Gozu': '소머리'
    }
  }]
};
/* harmony default export */ const heaven_on_high_floors_41_50 = (heaven_on_high_floors_41_50_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/deepdungeon/heaven-on-high_floors_51-60.ts



// Heaven-on-High Floors 51-60
// TODO: Heavenly Naga Baleful Roar, untelegraphed large PBAoE (can stun or interrupt)
// TODO: Heavenly Tesso Wash Away, knockback with high damage (enrage)
const heaven_on_high_floors_51_60_triggerSet = {
  id: 'HeavenOnHighFloors51_60',
  zoneId: zone_id/* default.HeavenOnHighFloors51_60 */.Z.HeavenOnHighFloors51_60,
  triggers: [
  // ---------------- Floor 51-59 Mobs ----------------
  {
    id: 'HoH 51-60 Heavenly Naga Calcifying Mist',
    // front cone gaze AoE
    type: 'StartsUsing',
    netRegex: {
      id: '306D',
      source: 'Heavenly Naga',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Behind or Look Away',
        de: 'Geh hinter oder schau weg',
        fr: 'Allez derrière ou Regardez ailleurs',
        cn: '去背后或看向其他方向',
        ko: '보스 뒤로 또는 뒤돌기'
      }
    }
  }, {
    id: 'HoH 51-60 Heavenly Gowan Electromagnetism',
    type: 'StartsUsing',
    netRegex: {
      id: '3068',
      source: 'Heavenly Gowan'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  },
  // ---------------- Floor 60 Boss: Suikazura ----------------
  {
    id: 'HoH 51-60 Suikazura Ancient Flare',
    type: 'StartsUsing',
    netRegex: {
      id: '2E98',
      source: 'Suikazura',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Heavenly Gowan': 'Himmelssäulen-Gowan',
      'Heavenly Naga': 'Himmelssäulen-Naga',
      'Suikazura': 'Suikazura'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Heavenly Gowan': 'gôwan des Cieux',
      'Heavenly Naga': 'naga des Cieux',
      'Suikazura': 'Suikazura'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Heavenly Gowan': 'アメノ・ゴウワン',
      'Heavenly Naga': 'アメノ・ナーガ',
      'Suikazura': 'スイカズラ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Heavenly Gowan': '天之铁臂',
      'Heavenly Naga': '天之那迦',
      'Suikazura': '忍冬'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Heavenly Gowan': '천궁 힘센팔이',
      'Heavenly Naga': '천궁 나가',
      'Suikazura': '인동덩굴'
    }
  }]
};
/* harmony default export */ const heaven_on_high_floors_51_60 = (heaven_on_high_floors_51_60_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/deepdungeon/heaven-on-high_floors_61-70.ts




// Heaven-on-High Floors 61-70
// TODO: Heavenly Shitaibana unknown untelegraphed cone AoE, inflicts Poison
const heaven_on_high_floors_61_70_triggerSet = {
  id: 'HeavenOnHighFloors61_70',
  zoneId: zone_id/* default.HeavenOnHighFloors61_70 */.Z.HeavenOnHighFloors61_70,
  triggers: [
  // ---------------- Floor 61-69 Mobs ----------------
  {
    id: 'HoH 61-70 Heavenly Hashiri-dokoro Atropine Spore',
    type: 'StartsUsing',
    netRegex: {
      id: '307F',
      source: 'Heavenly Hashiri-dokoro',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'HoH 61-70 Heavenly Hashiri-dokoro Frond Fatale',
    type: 'StartsUsing',
    netRegex: {
      id: '3080',
      source: 'Heavenly Hashiri-dokoro',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  },
  // ---------------- Floor 70 Boss: Kenko ----------------
  {
    id: 'HoH 61-70 Kenko Predator Claws',
    // untelegraphed front cone AoE
    type: 'StartsUsing',
    netRegex: {
      id: '2FAD',
      source: 'Kenko',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'HoH 61-70 Kenko Innerspace',
    // leaves puddle that inflicts Minimum (1B6)
    type: 'StartsUsing',
    netRegex: {
      id: '2FAF',
      source: 'Kenko',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Puddle',
        de: 'Flächen vermeiden',
        fr: 'Évitez la zone au sol',
        cn: '躲避圈圈',
        ko: '장판 피하기'
      }
    }
  }, {
    id: 'HoH 61-70 Kenko Ululation',
    // roomwide AoE, fatal if Minimum (1B6)
    type: 'StartsUsing',
    netRegex: {
      id: '2FB0',
      source: 'Kenko',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'HoH 61-70 Kenko Hound out of Hell',
    // charge AoE, fatal if not Minimum (1B6)
    type: 'StartsUsing',
    netRegex: {
      id: '2FAE',
      source: 'Kenko'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get In Puddle',
        de: 'Geh in die Flächen',
        fr: 'Prenez une zone au sol',
        cn: '进入圈圈',
        ko: '장판 밟기'
      }
    }
  }, {
    id: 'HoH 61-70 Kenko Devour',
    // immediately after Devour, get out of puddle so not Minimum for follow-up Ululation
    type: 'Ability',
    netRegex: {
      id: '2FAC',
      source: 'Kenko'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out of Puddle',
        de: 'Raus aus der Fläche',
        fr: 'À l\'extérieur de la zone au sol',
        cn: '离开圈圈',
        ko: '장판 밖으로'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Heavenly Hashiri-dokoro': 'Himmelssäulen-Hashiri-Dokoro',
      'Kenko': 'Kenko'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Heavenly Hashiri-dokoro': 'hashidokoro des Cieux',
      'Kenko': 'Kenko'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Heavenly Hashiri-dokoro': 'アメノ・ハシリドコロ',
      'Kenko': 'ケンコ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Heavenly Hashiri-dokoro': '天之东莨菪',
      'Kenko': '犬蛊'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Heavenly Hashiri-dokoro': '천궁 미치광이풀',
      'Kenko': '켄코'
    }
  }]
};
/* harmony default export */ const heaven_on_high_floors_61_70 = (heaven_on_high_floors_61_70_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/deepdungeon/heaven-on-high_floors_71-80.ts



// Heaven-on-High Floors 71-80
// TODO: Heavenly Yak Horrisonous Blast, large PBAoE used after draw-in, can interrupt
// TODO: Heavenly Yuki-Otoko Northerlies, large PBAoE used after Frozen Mist, can stun or interrupt
// TODO: Heavenly Jujishi Winds of Winter, large high damage PBAoE, gains Haste, can stun
const heaven_on_high_floors_71_80_triggerSet = {
  id: 'HeavenOnHighFloors71_80',
  zoneId: zone_id/* default.HeavenOnHighFloors71_80 */.Z.HeavenOnHighFloors71_80,
  triggers: [
  // ---------------- Floor 71-79 Mobs ----------------
  {
    id: 'HoH 71-80 Heavenly Ichijama Scream',
    // inflicts Terror (42)
    type: 'StartsUsing',
    netRegex: {
      id: '2FA3',
      source: 'Heavenly Ichijama'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'HoH 71-80 Heavenly Hyoga Eyeshine',
    type: 'StartsUsing',
    netRegex: {
      id: '2FE5',
      source: 'Heavenly Hyoga',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'HoH 71-80 Heavenly Mammoth Wooly Inspiration',
    // front cone AoE draw-in, follows up with Tusk Butt (instant, untelegraphed front cone AoE)
    type: 'StartsUsing',
    netRegex: {
      id: '2FBA',
      source: 'Heavenly Mammoth',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'HoH 71-80 Heavenly Tofu Golden Tongue',
    // gains Magic Damage Up (39)
    type: 'StartsUsing',
    netRegex: {
      id: '2FBE',
      source: 'Heavenly Tofu'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  },
  // ---------------- Floor 80 Boss: Kajigakaka ----------------
  {
    id: 'HoH 71-80 Kajigakaka Lunar Cry',
    type: 'StartsUsing',
    netRegex: {
      id: '2ED3',
      source: 'Kajigakaka',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Heavenly Hyoga': 'Himmelssäulen-Hyoga',
      'Heavenly Ichijama': 'Himmelssäulen-Ichijama',
      'Heavenly Mammoth': 'Himmelssäulen-Mammut',
      'Heavenly Tofu': 'Himmelssäulen-Tofu',
      'Kajigakaka': 'Kajigakaka'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Heavenly Hyoga': 'hyôga des Cieux',
      'Heavenly Ichijama': 'ichijama des Cieux',
      'Heavenly Mammoth': 'mammouth des Cieux',
      'Heavenly Tofu': 'tôfu des Cieux',
      'Kajigakaka': 'Kajigakaka'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Heavenly Hyoga': 'アメノ・ヒョウガ',
      'Heavenly Ichijama': 'アメノ・イチジャマ',
      'Heavenly Mammoth': 'アメノ・マンモス',
      'Heavenly Tofu': 'アメノ・トウフ',
      'Kajigakaka': 'カジガカカ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Heavenly Hyoga': '天之冰牙',
      'Heavenly Ichijama': '天之生邪魔',
      'Heavenly Mammoth': '天之长毛象',
      'Heavenly Tofu': '天之豆腐',
      'Kajigakaka': '锻冶媪'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Heavenly Hyoga': '천궁 효우가',
      'Heavenly Ichijama': '천궁 생령',
      'Heavenly Mammoth': '천궁 매머드',
      'Heavenly Tofu': '천궁 두부',
      'Kajigakaka': '카지가카카'
    }
  }]
};
/* harmony default export */ const heaven_on_high_floors_71_80 = (heaven_on_high_floors_71_80_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/deepdungeon/heaven-on-high_floors_81-90.ts




// Heaven-on-High Floors 81-90
// TODO: Heavenly Koki unknown large PBAoE, inflicts stacking Vulnerability Up
const heaven_on_high_floors_81_90_triggerSet = {
  id: 'HeavenOnHighFloors81_90',
  zoneId: zone_id/* default.HeavenOnHighFloors81_90 */.Z.HeavenOnHighFloors81_90,
  triggers: [
  // ---------------- Floor 81-89 Mobs ----------------
  {
    id: 'HoH 81-90 Heavenly Mukai-inu Ram\'s Voice',
    // untelegraphed PBAoE
    type: 'StartsUsing',
    netRegex: {
      id: '308F',
      source: 'Heavenly Mukai-inu'
    },
    alertText: (data, matches, output) => {
      if (data.CanSilence()) return output.interruptOrOut({
        name: matches.source
      });
      return output.out();
    },
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      interruptOrOut: {
        en: 'Out or interrupt ${name}',
        de: 'Raus oder unterbreche ${name}',
        fr: 'Extérieur ou interrompez ${name}',
        cn: '出去或打断 ${name}',
        ko: '밖으로 또는 ${name} 시전 끊기'
      }
    }
  }, {
    id: 'HoH 81-90 Heavenly Mukai-inu Dragon\'s Voice',
    // untelegraphed donut AoE
    type: 'StartsUsing',
    netRegex: {
      id: '3090',
      source: 'Heavenly Mukai-inu'
    },
    alertText: (data, matches, output) => {
      if (data.CanSilence()) return output.interruptOrUnder({
        name: matches.source
      });
      return output.getUnder();
    },
    outputStrings: {
      getUnder: outputs/* default.getUnder */.Z.getUnder,
      interruptOrUnder: {
        en: 'Get Under or interrupt ${name}',
        de: 'Unter oder unterbreche ${name}',
        fr: 'Dessous ou interrompez ${name}',
        cn: '去脚下或打断 ${name}',
        ko: '밑으로 또는 ${name} 시전 끊기'
      }
    }
  }, {
    id: 'HoH 81-90 Heavenly Gozu 11-tonze Swipe',
    // untelegraphed front cone AoE
    type: 'StartsUsing',
    netRegex: {
      id: '309C',
      source: 'Heavenly Gozu',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'HoH 81-90 Heavenly Gozu Hex',
    // gaze, inflicts Pig, will Devour (instant kill) pigs after
    type: 'StartsUsing',
    netRegex: {
      id: '309A',
      source: 'Heavenly Gozu',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'HoH 81-90 Heavenly Shinzei Thunder II',
    // AoE on marked target, can interrupt
    type: 'StartsUsing',
    netRegex: {
      id: '30C9',
      source: 'Heavenly Shinzei'
    },
    response: responses/* Responses.interruptIfPossible */.n3.interruptIfPossible()
  }, {
    id: 'HoH 81-90 Heavenly Ryujin Elbow Drop',
    // untelegraphed back cone AoE, fast cast, used immediately after Firewater if there is someone behind
    type: 'StartsUsing',
    netRegex: {
      id: '30A2',
      source: 'Heavenly Ryujin',
      capture: false
    },
    response: responses/* Responses.goFront */.n3.goFront()
  }, {
    id: 'HoH 81-90 Heavenly Hitotsume Glower',
    // untelegraphed front line AoE
    type: 'StartsUsing',
    netRegex: {
      id: '30A3',
      source: 'Heavenly Hitotsume',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'HoH 81-90 Heavenly Hitotsume 100-tonze Swing',
    // untelegraphed PBAoE
    type: 'StartsUsing',
    netRegex: {
      id: '30A4',
      source: 'Heavenly Hitotsume',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'HoH 81-90 Heavenly Araragi Moldy Sneeze',
    // 30A7 = Inhale, draw-in
    // 30A8 = Moldy Sneeze, front cone AoE, used immediately after Inhale
    type: 'StartsUsing',
    netRegex: {
      id: '30A7',
      source: 'Heavenly Araragi',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'HoH 81-90 Heavenly Koki Spiral Spin',
    // donut AoE
    type: 'StartsUsing',
    netRegex: {
      id: '30AE',
      source: 'Heavenly Koki',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'HoH 81-90 Heavenly Rakshasa Ripper Claw',
    // untelegraphed front cone AoE
    type: 'StartsUsing',
    netRegex: {
      id: '30DC',
      source: 'Heavenly Rakshasa',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  },
  // ---------------- Floor 90 Boss: Onra ----------------
  {
    id: 'HoH 81-90 Onra Ancient Quaga',
    // 50% max HP damage
    type: 'StartsUsing',
    netRegex: {
      id: '2FB6',
      source: 'Onra',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe('alert')
  }, {
    id: 'HoH 81-90 Onra Meteor Impact',
    // large proximity AoE
    // 2FB3 = Meteor Impact (2.7s), marks location of proximity AoE
    // 2FB4 = Meteor Impact (5.7s), actual damage cast
    type: 'StartsUsing',
    netRegex: {
      id: '2FB4',
      source: 'Onra'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 3,
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Heavenly Araragi': 'Himmelssäulen-Araragi',
      'Heavenly Gozu': 'Himmelssäulen-Gozu',
      'Heavenly Hitotsume': 'Himmelssäulen-Hitotsume',
      'Heavenly Koki': 'Himmelssäulen-Koki',
      'Heavenly Mukai-inu': 'Himmelssäulen-Mukai-Inu',
      'Heavenly Rakshasa': 'Himmelssäulen-Rakshasa',
      'Heavenly Ryujin': 'Himmelssäulen-Ryujin',
      'Heavenly Shinzei': 'Himmelssäulen-Shinzei',
      'Onra': 'Onra'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Heavenly Araragi': 'araragi des Cieux',
      'Heavenly Gozu': 'gozu des Cieux',
      'Heavenly Hitotsume': 'hitotsume des Cieux',
      'Heavenly Koki': 'kôki des Cieux',
      'Heavenly Mukai-inu': 'mukai-inu des Cieux',
      'Heavenly Rakshasa': 'rakshasa des Cieux',
      'Heavenly Ryujin': 'ryûjin des Cieux',
      'Heavenly Shinzei': 'shinzei des Cieux',
      'Onra': 'Onra'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Heavenly Araragi': 'アメノ・アララギ',
      'Heavenly Gozu': 'アメノ・ゴズ',
      'Heavenly Hitotsume': 'アメノ・ヒトツメ',
      'Heavenly Koki': 'アメノ・コウキ',
      'Heavenly Mukai-inu': 'アメノ・ムカイイヌ',
      'Heavenly Rakshasa': 'アメノ・ラセツ',
      'Heavenly Ryujin': 'アメノ・リュウジン',
      'Heavenly Shinzei': 'アメノ・シンゼイ',
      'Onra': 'オンラ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Heavenly Araragi': '天之紫衫',
      'Heavenly Gozu': '天之牛头',
      'Heavenly Hitotsume': '天之独眼',
      'Heavenly Koki': '天之钢鬼',
      'Heavenly Mukai-inu': '天之送狼',
      'Heavenly Rakshasa': '天之罗刹',
      'Heavenly Ryujin': '天之龙人',
      'Heavenly Shinzei': '天之真济',
      'Onra': '温罗'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Heavenly Araragi': '천궁 산달래',
      'Heavenly Gozu': '천궁 소머리',
      'Heavenly Hitotsume': '천궁 외눈박이',
      'Heavenly Koki': '천궁 코우키',
      'Heavenly Mukai-inu': '천궁 마중견',
      'Heavenly Rakshasa': '천궁 나찰',
      'Heavenly Ryujin': '천궁 용인',
      'Heavenly Shinzei': '천궁 신제이',
      'Onra': '온라'
    }
  }]
};
/* harmony default export */ const heaven_on_high_floors_81_90 = (heaven_on_high_floors_81_90_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/deepdungeon/heaven-on-high_floors_91-100.ts




// Heaven-on-High Floors 91-100
// TODO: Heavenly Gozu 128-tonze Swing untelegraphed PBAoE
// TODO: Heavenly Kubinashi Black Nebula, high damage roomwide AoE, can interrupt
const heaven_on_high_floors_91_100_triggerSet = {
  id: 'HeavenOnHighFloors91_100',
  zoneId: zone_id/* default.HeavenOnHighFloors91_100 */.Z.HeavenOnHighFloors91_100,
  triggers: [
  // ---------------- Floor 91-99 Mobs ----------------
  {
    id: 'HoH 91-100 Heavenly Gozu 32-tonze Swipe',
    // untelegraphed instant front cone AoE
    type: 'StartsUsing',
    netRegex: {
      id: '3005',
      source: 'Heavenly Gozu',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'HoH 91-100 Heavenly Mifune Valfodr',
    // charge + knockback on targeted player
    type: 'StartsUsing',
    netRegex: {
      id: '2F83',
      source: 'Heavenly Mifune'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'HoH 91-100 Heavenly Jaki Charybdis',
    // circle AoE on marked player, drops target to 1 HP
    type: 'StartsUsing',
    netRegex: {
      id: '2FF4',
      source: 'Heavenly Jaki'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'HoH 91-100 Heavenly Jinba Allagan Fear',
    // gaze
    type: 'StartsUsing',
    netRegex: {
      id: '2FF9',
      source: 'Heavenly Jinba',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'HoH 91-100 Heavenly Kyozo Filoplumage',
    // gains Vulnerability Down (3F) on self and nearby enemies
    type: 'StartsUsing',
    netRegex: {
      id: '2FFA',
      source: 'Heavenly Kyozo'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'HoH 91-100 Heavenly Tenma Burning Bright',
    // untelegraphed instant front line AoE
    type: 'StartsUsing',
    netRegex: {
      id: '3011',
      source: 'Heavenly Tenma',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'HoH 91-100 Heavenly Tenma Nicker',
    // large PBAoE, inflcits Confuse, goes through walls (can't LoS)
    type: 'StartsUsing',
    netRegex: {
      id: '3013',
      source: 'Heavenly Tenma'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Heavenly Gozu': 'Himmelssäulen-Gozu',
      'Heavenly Jaki': 'Himmelssäulen-Jaki',
      'Heavenly Jinba': 'Himmelssäulen-Jinba',
      'Heavenly Kyozo': 'Himmelssäulen-Kyozo',
      'Heavenly Mifune': 'Himmelssäulen-Mifune',
      'Heavenly Tenma': 'Himmelssäulen-Tenma'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Heavenly Gozu': 'gozu des Cieux',
      'Heavenly Jaki': 'jaki des Cieux',
      'Heavenly Jinba': 'jinba des Cieux',
      'Heavenly Kyozo': 'kyôzô des Cieux',
      'Heavenly Mifune': 'mifune des Cieux',
      'Heavenly Tenma': 'tenma des Cieux'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Heavenly Gozu': 'アメノ・ゴズ',
      'Heavenly Jaki': 'アメノ・ジャキ',
      'Heavenly Jinba': 'アメノ・ジンバ',
      'Heavenly Kyozo': 'アメノ・キョウゾウ',
      'Heavenly Mifune': 'アメノ・ミフネ',
      'Heavenly Tenma': 'アメノ・テンマ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Heavenly Gozu': '天之牛头',
      'Heavenly Jaki': '天之邪鬼',
      'Heavenly Jinba': '天之人马',
      'Heavenly Kyozo': '天之镜像',
      'Heavenly Mifune': '天之三船',
      'Heavenly Tenma': '天之马'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Heavenly Gozu': '천궁 소머리',
      'Heavenly Jaki': '천궁 사귀',
      'Heavenly Jinba': '천궁 인마',
      'Heavenly Kyozo': '천궁 거울기사',
      'Heavenly Mifune': '천궁 미후네',
      'Heavenly Tenma': '천궁 천마'
    }
  }]
};
/* harmony default export */ const heaven_on_high_floors_91_100 = (heaven_on_high_floors_91_100_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/deepdungeon/heaven-on-high_general.ts



// Triggers applicable to all Heaven-on-High floors.

const heaven_on_high_general_triggerSet = {
  id: 'HeavenOnHighGeneral',
  zoneId: [zone_id/* default.HeavenOnHighFloors1_10 */.Z.HeavenOnHighFloors1_10, zone_id/* default.HeavenOnHighFloors11_20 */.Z.HeavenOnHighFloors11_20, zone_id/* default.HeavenOnHighFloors21_30 */.Z.HeavenOnHighFloors21_30, zone_id/* default.HeavenOnHighFloors31_40 */.Z.HeavenOnHighFloors31_40, zone_id/* default.HeavenOnHighFloors41_50 */.Z.HeavenOnHighFloors41_50, zone_id/* default.HeavenOnHighFloors51_60 */.Z.HeavenOnHighFloors51_60, zone_id/* default.HeavenOnHighFloors61_70 */.Z.HeavenOnHighFloors61_70, zone_id/* default.HeavenOnHighFloors71_80 */.Z.HeavenOnHighFloors71_80, zone_id/* default.HeavenOnHighFloors81_90 */.Z.HeavenOnHighFloors81_90, zone_id/* default.HeavenOnHighFloors91_100 */.Z.HeavenOnHighFloors91_100],
  zoneLabel: {
    en: 'Heaven-on-High (All Floors)',
    de: 'Himmelssäule (Alle Ebenen)',
    fr: 'Pilier des cieux (Tous niveaux)',
    cn: '天之御柱 (全楼层)',
    ko: '천궁탑 (전체 층)'
  },
  triggers: [
  // ---------------- Quivering Coffers ----------------
  {
    id: 'HoH General Quivering Coffer Spawn',
    // 7392 = Quivering Coffer (floor 1-30 bronze chests, can stun or interrupt)
    // 7393 = Quivering Coffer (floor 31-60 silver chests, can stun or interrupt)
    // 7394 = Quivering Coffer (floor 61+ gold chests, can interrupt, immune to stun)
    // TODO: some Quivering Coffers may spawn after transference between floors and get called early before being found
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '739[2-4]',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Quivering Coffer spawned!',
        de: 'zuckende Schnapptruhe ist erschienen',
        fr: 'Coffre gigotant apparaît !',
        cn: '已生成 抖动的宝箱!',
        ko: '꿈틀거리는 보물상자 등장!'
      }
    }
  }, {
    id: 'HoH General Quivering Coffer Malice',
    // same id regardless of which "type" of Quivering Coffer
    // inflicts Accursed Pox (43F) if not interrupted
    type: 'StartsUsing',
    netRegex: {
      id: '3019',
      source: 'Quivering Coffer'
    },
    response: responses/* Responses.interruptIfPossible */.n3.interruptIfPossible()
  },
  // ---------------- Pomanders and Magicite ----------------
  {
    id: 'HoH General Pomander Duplicate',
    // duplicate item message: https://xivapi.com/LogMessage/7222?pretty=true
    // en: You return the pomander of ${pomander} to the coffer. You cannot carry any more of that item.
    type: 'SystemLogMessage',
    netRegex: {
      id: '1C36'
    },
    infoText: (_data, matches, output) => {
      switch (parseInt(matches.param1, 16)) {
        case 1:
          return output.duplicate({
            pomander: output.safety()
          });
        case 2:
          return output.duplicate({
            pomander: output.sight()
          });
        case 3:
          return output.duplicate({
            pomander: output.strength()
          });
        case 4:
          return output.duplicate({
            pomander: output.steel()
          });
        case 5:
          return output.duplicate({
            pomander: output.affluence()
          });
        case 6:
          return output.duplicate({
            pomander: output.flight()
          });
        case 7:
          return output.duplicate({
            pomander: output.alteration()
          });
        case 8:
          return output.duplicate({
            pomander: output.purity()
          });
        case 9:
          return output.duplicate({
            pomander: output.fortune()
          });
        case 10:
          return output.duplicate({
            pomander: output.witching()
          });
        case 11:
          return output.duplicate({
            pomander: output.serenity()
          });
        case 12:
          return output.duplicate({
            pomander: output.rage()
          });
        case 13:
          return output.duplicate({
            pomander: output.lust()
          });
        case 14:
          return output.duplicate({
            pomander: output.intuition()
          });
        case 15:
          return output.duplicate({
            pomander: output.raising()
          });
        case 16:
          return output.duplicate({
            pomander: output.resolution()
          });
        case 17:
          return output.duplicate({
            pomander: output.frailty()
          });
        case 18:
          return output.duplicate({
            pomander: output.concealment()
          });
        case 19:
          return output.duplicate({
            pomander: output.petrification()
          });
      }
    },
    outputStrings: {
      duplicate: {
        en: '${pomander} duplicate',
        de: 'Doppelter ${pomander}',
        fr: '${pomander} dupliquée',
        cn: '${pomander} 重复',
        ko: '${pomander} 중복'
      },
      // pomanders: https://xivapi.com/deepdungeonItem?pretty=true
      safety: {
        en: 'Safety',
        de: 'Siegelbruchs',
        fr: 'Désamorçage',
        ja: '呪印解除',
        cn: '咒印解除',
        ko: '함정 해제'
      },
      sight: {
        en: 'Sight',
        de: 'Sicht',
        fr: 'Localisation',
        ja: 'サイトロ',
        cn: '全景',
        ko: '사이트로'
      },
      strength: {
        en: 'Strength',
        de: 'Stärkung',
        fr: 'Puissance',
        ja: '自己強化',
        cn: '强化自身',
        ko: '자기 강화'
      },
      steel: {
        en: 'Steel',
        de: 'Abwehr',
        fr: 'Protection',
        ja: '防御強化',
        cn: '强化防御',
        ko: '방어 강화'
      },
      affluence: {
        en: 'Affluence',
        de: 'Schätze',
        fr: 'Décèlement',
        ja: '宝箱増加',
        cn: '宝箱增加',
        ko: '보물상자 증가'
      },
      flight: {
        en: 'Flight',
        de: 'Feindtods',
        fr: 'Sécurisation',
        ja: '敵排除',
        cn: '减少敌人',
        ko: '적 감소'
      },
      alteration: {
        en: 'Alteration',
        de: 'Feindwandlung',
        fr: 'Affaiblissement',
        ja: '敵変化',
        cn: '改变敌人',
        ko: '적 대체'
      },
      purity: {
        en: 'Purity',
        de: 'Entzauberung',
        fr: 'Anti-maléfice',
        ja: '解呪',
        cn: '解咒',
        ko: '저주 해제'
      },
      fortune: {
        en: 'Fortune',
        de: 'Glücks',
        fr: 'Chance',
        ja: '運気上昇',
        cn: '运气上升',
        ko: '운 상승'
      },
      witching: {
        en: 'Witching',
        de: 'Wandlung',
        fr: 'Mutation',
        ja: '形態変化',
        cn: '形态变化',
        ko: '적 변형'
      },
      serenity: {
        en: 'Serenity',
        de: 'Enthexung',
        fr: 'Dissipation',
        ja: '魔法効果解除',
        cn: '魔法效果解除',
        ko: '마법 효과 해제'
      },
      rage: {
        en: 'Rage',
        de: 'Manticoren',
        fr: 'Manticore',
        ja: 'マンティコア化',
        cn: '曼提克化',
        ko: '만티코어 변신'
      },
      lust: {
        en: 'Lust',
        de: 'Sukkuben',
        fr: 'Succube',
        ja: 'サキュバス化',
        cn: '梦魔化',
        ko: '서큐버스 변신'
      },
      intuition: {
        en: 'Intuition',
        de: 'Finders',
        fr: 'Intuition',
        ja: '財宝感知',
        cn: '感知宝藏',
        ko: '보물 탐지'
      },
      raising: {
        en: 'Raising',
        de: 'Lebens',
        fr: 'Résurrection',
        ja: 'リレイズ',
        cn: '重生',
        ko: '리레이즈'
      },
      resolution: {
        en: 'Resolution',
        de: 'Kuribu',
        fr: 'Kuribu',
        ja: 'クリブ化',
        cn: '基路伯化',
        ko: '쿠리부 변신'
      },
      frailty: {
        en: 'Frailty',
        de: 'Feindschwächung',
        fr: 'Incapacité',
        ja: '敵弱体',
        cn: '弱化敌人',
        ko: '적 약화'
      },
      concealment: {
        en: 'Concealment',
        de: 'Verschwindens',
        fr: 'Invisibilité',
        ja: 'バニシュ',
        cn: '隐形',
        ko: '배니시'
      },
      petrification: {
        en: 'Petrification',
        de: 'Feindversteinerung',
        fr: 'Pétrification',
        ja: '敵石化',
        cn: '石化敌人',
        ko: '적 석화'
      }
    }
  }, {
    id: 'HoH General Magicite Duplicate',
    // duplicate item message: https://xivapi.com/LogMessage/9208?pretty=true
    // en: You return the splinter of ${magicite} magicite to the coffer. You cannot carry any more of that item.
    type: 'SystemLogMessage',
    netRegex: {
      id: '23F8'
    },
    infoText: (_data, matches, output) => {
      switch (parseInt(matches.param1, 16)) {
        case 1:
          return output.duplicate({
            magicite: output.inferno()
          });
        case 2:
          return output.duplicate({
            magicite: output.crag()
          });
        case 3:
          return output.duplicate({
            magicite: output.vortex()
          });
        case 4:
          return output.duplicate({
            magicite: output.elder()
          });
      }
    },
    outputStrings: {
      duplicate: {
        en: '${magicite} duplicate',
        de: 'Doppelter ${magicite} Stein',
        fr: '${magicite} dupliquée',
        cn: '${magicite} 重复',
        ko: '${magicite} 중복'
      },
      // magicite: https://xivapi.com/DeepDungeonMagicStone?pretty=true
      inferno: {
        en: 'Inferno',
        de: 'Ifrit',
        fr: 'Ifrit',
        ja: 'イフリート',
        cn: '伊弗利特',
        ko: '이프리트'
      },
      crag: {
        en: 'Crag',
        de: 'Titan',
        fr: 'Titan',
        ja: 'タイタン',
        cn: '泰坦',
        ko: '타이탄'
      },
      vortex: {
        en: 'Vortex',
        de: 'Garuda',
        fr: 'Garuda',
        ja: 'ガルーダ',
        cn: '迦楼罗',
        ko: '가루다'
      },
      elder: {
        en: 'Elder',
        de: 'Odin',
        fr: 'Odin',
        ja: 'オーディン',
        cn: '奥丁',
        ko: '오딘'
      }
    }
  },
  // ---------------- Floor Notifications ----------------
  {
    id: 'HoH General Beacon of Passage',
    // portal to transfer between floors
    // Beacon of Passage activation message: https://xivapi.com/LogMessage/7245?pretty=true
    // en: The Beacon of Passage is activated!
    type: 'SystemLogMessage',
    netRegex: {
      id: '1C4D',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Beacon of Passage activated',
        de: 'Weglaterne aktiviert',
        fr: 'La lanterne de téléportation s\'est activée !',
        cn: '转移灯笼已启动',
        ko: '전송 등불 활성화'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Quivering Coffer': 'zuckend(?:e|er|es|en) Schnapptruhe'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Quivering Coffer': 'Coffre gigotant'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Quivering Coffer': 'うごめく宝箱'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Quivering Coffer': '抖动的宝箱'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Quivering Coffer': '꿈틀거리는 보물상자'
    }
  }]
};
/* harmony default export */ const heaven_on_high_general = (heaven_on_high_general_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/ala_mhigo.ts



const ala_mhigo_triggerSet = {
  id: 'AlaMhigo',
  zoneId: zone_id/* default.AlaMhigo */.Z.AlaMhigo,
  timelineFile: 'ala_mhigo.txt',
  timelineTriggers: [{
    id: 'Ala Mhigo Umoving Troika',
    regex: /Unmoving Troika/,
    beforeSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'Ala Mhigo Electromagnetic Field',
    type: 'StartsUsing',
    netRegex: {
      id: '204D',
      source: 'Magitek Scorpion',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Ala Mhigo Mana Burst',
    type: 'StartsUsing',
    netRegex: {
      id: '204F',
      source: 'Aulus Mal Asina',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Ala Mhigo Demimagicks',
    type: 'StartsUsing',
    netRegex: {
      id: '205D',
      source: 'Aulus Mal Asina',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Ala Mhigo Storm',
    type: 'StartsUsing',
    netRegex: {
      id: ['2066', '2587'],
      source: 'Zenos Yae Galvus',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out of blue circle',
        de: 'Raus aus dem blauen Kreis',
        fr: 'Sortez du cercle bleu',
        ja: '青い円から離れる',
        cn: '离开蓝圈',
        ko: '파란 원 바깥으로'
      }
    }
  }, {
    id: 'Ala Mhigo Swell',
    type: 'StartsUsing',
    netRegex: {
      id: ['2065', '2586'],
      source: 'Zenos Yae Galvus',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Ala Mhigo Sword',
    type: 'StartsUsing',
    netRegex: {
      id: ['2068', '2588'],
      source: 'Zenos Yae Galvus',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Protean',
        de: 'Um den Boss verteilen',
        fr: 'Changement',
        ja: 'ボスを基準として散開',
        cn: '和队友分散路径',
        ko: '산개'
      }
    }
  }, {
    id: 'Ala Mhigo Lightless Spark',
    type: 'Tether',
    netRegex: {
      id: '0029',
      source: 'Zenos Yae Galvus'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Face tether out',
        de: 'Verbindung nach draußen richten',
        fr: 'Lien vers l\'extérieur',
        ja: '線を外へ向ける',
        cn: '离开人群背对连线',
        ko: '본진 바깥으로 선 유도하기'
      }
    }
  }, {
    id: 'Ala Mhigo Concentrativity',
    type: 'StartsUsing',
    netRegex: {
      id: '206D',
      source: 'Zenos Yae Galvus',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aulus Mal Asina': 'Aulus mal Asina',
      'Magitek Scorpion': 'Wachskorpion',
      'Prototype Bit': 'experimentell(?:e|er|es|en) Drohne',
      'Rhalgr\'s Gate': 'Rhalgrs Tor',
      'The Chamber of Knowledge': 'Wiege des Wissens',
      'The Hall of the Griffin': 'Halle des Greifen',
      'The Storm': 'Durch den Mahlstrom',
      'Zenos Yae Galvus': 'Zenos yae Galvus'
    },
    'replaceText': {
      'Aetherochemical Grenado': 'Magitek-Granate',
      'Art of the Storm': 'Kunst des Sturmes',
      'Art of the Swell': 'Kunst des Windes',
      'Art of the Sword': 'Kunst des Schwertes',
      'Concentrativity': 'Konzentriertheit',
      'Demimagicks': 'Demimagie',
      'Electromagnetic Field': 'Elektromagnetisches Feld',
      'Integrated Aetheromodulator': 'Linearbeschleuniger',
      'Lightless Spark': 'Lichtloser Funke',
      'Lock On': 'Feststellen',
      'Magitek Disruptor': 'Magitek-Disruptor',
      'Magitek Ray': 'Magitek-Laser',
      'Mana Burst': 'Mana-Knall',
      'Mindjack': 'Gehirnwäsche',
      'Order To Charge': 'Angriffsbefehl',
      'Order To Fire': 'Feuerbefehl',
      'Storm, Swell, Sword': 'Wind, Sturm, Schwert',
      'Storm\\?/Swell\\?(?!/Sword)': 'Wind?/Sturm?',
      'Storm\\?/Swell\\?/Sword\\?': 'Wind?/Sturm?/Schwert?',
      'Swell/Sword': 'Sturm/Win',
      'Tail Laser': 'Schweiflaser',
      'Target Search': 'Zielsucher',
      'Unmoving Troika': 'Unbewegte Troika',
      'Vein Splitter': 'Erdader-Spalter'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aulus Mal Asina': 'Aulus mal Asina',
      'Magitek Scorpion': 'Scorpion magitek',
      'Prototype Bit': 'Drone prototype',
      'Rhalgr\'s Gate': 'Porte de Rhalgr',
      'The Chamber of Knowledge': 'Chambre du Savoir',
      'The Hall of the Griffin': 'Salle du Griffon',
      'The Storm': 'Spirale du chaos',
      'Zenos Yae Galvus': 'Zenos yae Galvus'
    },
    'replaceText': {
      '\\?': ' ?',
      'Aetherochemical Grenado': 'Grenade magitek',
      'Art of the Storm': 'Art de l\'orage',
      'Art of the Swell': 'Art de la tempête',
      'Art of the Sword': 'Art de l\'épée',
      'Concentrativity': 'Kenki concentré',
      'Demimagicks': 'Demimagie',
      'Electromagnetic Field': 'Champ électromagnétique',
      'Integrated Aetheromodulator': 'Rayon accélérateur',
      'Lightless Spark': 'Étincelle sans lueur',
      'Lock On': 'Verrouillage',
      'Magitek Disruptor': 'Disrupteur magitek',
      'Magitek Ray': 'Rayon magitek',
      'Mana Burst': 'Explosion de mana',
      'Mindjack': 'Détournement cérébral',
      'Order To Charge': 'Ordre d\'attaquer',
      'Order To Fire': 'Ordre d\'attaquer',
      '(?<!Art of the )Storm': 'Tempête',
      '(?<!Art of the )Swell': 'Orage',
      '(?<!Art of the )Sword': 'Épée',
      'Tail Laser': 'Laser caudal',
      'Target Search': 'Recherche de cible',
      'Unmoving Troika': 'Troïka immobile',
      'Vein Splitter': 'Fendeur du sol'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aulus Mal Asina': 'アウルス・マル・アシナ',
      'Magitek Scorpion': 'ガードスコーピオン',
      'Prototype Bit': '実験型ビット',
      'Rhalgr\'s Gate': '壊神門前',
      'The Chamber of Knowledge': 'アシナ仮設実験場',
      'The Hall of the Griffin': '鷲獅子の間',
      'The Storm': '混沌の渦動',
      'Zenos Yae Galvus': 'ゼノス・イェー・ガルヴァス'
    },
    'replaceText': {
      'Aetherochemical Grenado': '魔導榴弾',
      'Art of the Storm': '雷切一閃',
      'Art of the Swell': '風断一閃',
      'Art of the Sword': '妖刀一閃',
      'Concentrativity': '圧縮剣気',
      'Demimagicks': 'デミマジック',
      'Electromagnetic Field': '電磁フィールド',
      'Integrated Aetheromodulator': '加速レーザー',
      'Lightless Spark': '無明閃',
      'Lock On': 'ロックオン',
      'Magitek Disruptor': '魔導ジャマー',
      'Magitek Ray': '魔導レーザー',
      'Mana Burst': 'マナバースト',
      'Mindjack': 'ブレインジャック',
      'Order To Charge': '出撃命令',
      'Order To Fire': '攻撃命令',
      'Storm, Swell, Sword': '秘剣風雷妖',
      'Storm\\?/Swell\\?(?!/Sword)': '風?/雷?',
      'Storm\\?/Swell\\?/Sword\\?': '風?/雷?/妖?',
      'Swell/Sword': '雷/妖',
      'Tail Laser': 'テイルレーザー',
      'Target Search': 'ターゲット・サーチ',
      'Unmoving Troika': '不動三段',
      'Vein Splitter': '地脈断ち'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aulus Mal Asina': '奥卢斯·玛尔·亚希纳',
      'Magitek Scorpion': '守卫机蝎',
      'Prototype Bit': '试验型魔导浮游炮',
      'Rhalgr\'s Gate': '破坏神之门',
      'The Chamber of Knowledge': '亚希纳临时实验场',
      'The Hall of the Griffin': '狮鹫之间',
      'The Storm': '混沌波动',
      'Zenos Yae Galvus': '芝诺斯·耶·加尔乌斯'
    },
    'replaceText': {
      'Aetherochemical Grenado': '魔导榴弹',
      'Art of the Storm': '雷切一闪',
      'Art of the Swell': '风断一闪',
      'Art of the Sword': '妖刀一闪',
      'Concentrativity': '压缩剑气',
      'Demimagicks': '亚魔法',
      'Electromagnetic Field': '电磁力场',
      'Integrated Aetheromodulator': '加速激光',
      'Lightless Spark': '无明闪',
      'Lock On': '锁定目标',
      'Magitek Disruptor': '魔导干扰器',
      'Magitek Ray': '魔导激光',
      'Mana Burst': '魔力爆发',
      'Mindjack': '精神劫持',
      'Order To Charge': '出击命令',
      'Order To Fire': '攻击命令',
      'Storm, Swell, Sword': '秘剑风雷妖',
      'Storm\\?/Swell\\?(?!/Sword)': '雷切?/风断?',
      'Storm\\?/Swell\\?/Sword\\?': '雷切?/风断?/妖刀?',
      'Swell/Sword': '风断/妖刀',
      'Tail Laser': '尾部射线',
      'Target Search': '寻找目标',
      'Unmoving Troika': '不动三段',
      'Vein Splitter': '地脉断'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aulus Mal Asina': '아울루스 말 아시나',
      'Magitek Scorpion': '경비 전갈',
      'Prototype Bit': '실험형 비트',
      'Rhalgr\'s Gate': '파괴신의 문',
      'The Chamber of Knowledge': '아시나 가설 실험장',
      'The Hall of the Griffin': '그리핀 전당',
      'The Storm': '뇌절',
      'Zenos Yae Galvus': '제노스 예 갈부스'
    },
    'replaceText': {
      'Aetherochemical Grenado': '마도 유탄',
      'Art of the Storm': '뇌절일섬',
      'Art of the Swell': '풍단일섬',
      'Art of the Sword': '요도일섬',
      'Concentrativity': '압축 검기',
      'Demimagicks': '유사 마법',
      'Electromagnetic Field': '전자기장',
      'Integrated Aetheromodulator': '가속 레이저',
      'Lightless Spark': '무명섬',
      'Lock On': '조준',
      'Magitek Disruptor': '마도 교란기',
      'Magitek Ray': '마도 레이저',
      'Mana Burst': '마나 폭발',
      'Mindjack': '두뇌 장악',
      'Order To Charge': '출격 명령',
      'Order To Fire': '공격 명령',
      'Storm, Swell, Sword': '비검 풍뇌요',
      'Storm\\?/Swell\\?(?!/Sword)': '뇌절?/풍단?',
      'Storm\\?/Swell\\?/Sword\\?': '뇌절?/풍단?/요도?',
      'Swell/Sword': '풍단/요도',
      'Tail Laser': '꼬리 레이저',
      'Target Search': '대상 찾기',
      'Unmoving Troika': '부동삼단',
      'Vein Splitter': '지맥 끊기'
    }
  }]
};
/* harmony default export */ const ala_mhigo = (ala_mhigo_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/ala_mhigo.txt
const dungeon_ala_mhigo_namespaceObject = "hideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Guard Scorpion\r\n# -ii 2049 204A 204B 204C\r\n# boss will walk center before using 2048 Tail Laser, causes timeline drift\r\n# Rhalgr's Gate will be sealed off\r\n0.0 \"--Start--\" SystemLogMessage { id: \"7DC\", param1: \"8F1\" }\r\n9.6 \"Electromagnetic Field\" Ability { id: \"204D\", source: \"Magitek Scorpion\" } window 10,5\r\n18.8 \"Target Search\" Ability { id: \"2046\", source: \"Magitek Scorpion\" }\r\n29.4 \"Lock On\" Ability { id: \"2047\", source: \"Magitek Scorpion\" }\r\n31.5 \"Tail Laser\" Ability { id: \"2048\", source: \"Magitek Scorpion\" } window 5,5\r\n56.7 \"Electromagnetic Field\" Ability { id: \"204D\", source: \"Magitek Scorpion\" }\r\n\r\n64.9 \"Target Search\" Ability { id: \"2046\", source: \"Magitek Scorpion\" }\r\n72.2 \"Tail Laser\" Ability { id: \"2048\", source: \"Magitek Scorpion\" } window 5,5\r\n75.5 \"Lock On\" Ability { id: \"2047\", source: \"Magitek Scorpion\" }\r\n85.5 \"Tail Laser\" Ability { id: \"2048\", source: \"Magitek Scorpion\" } window 5,5\r\n93.9 \"Lock On\" Ability { id: \"2047\", source: \"Magitek Scorpion\" }\r\n101.6 \"Electromagnetic Field\" Ability { id: \"204D\", source: \"Magitek Scorpion\" }\r\n111.8 \"Electromagnetic Field\" Ability { id: \"204D\", source: \"Magitek Scorpion\" }\r\n126.0 \"Electromagnetic Field\" Ability { id: \"204D\", source: \"Magitek Scorpion\" } jump 56.7\r\n\r\n134.2 \"Target Search\"\r\n141.5 \"Tail Laser\"\r\n144.8 \"Lock On\"\r\n154.8 \"Tail Laser\"\r\n163.2 \"Lock On\"\r\n\r\n# Aulus Mal Asina\r\n# -ii 2051 2052 205E\r\n# The Chamber of Knowledge will be sealed off\r\n1000.0 \"--Start--\" SystemLogMessage { id: \"7DC\", param1: \"8F2\" } window 1000,5\r\n1013.0 \"Mana Burst\" Ability { id: \"204F\", source: \"Aulus mal Asina\" } window 14,5\r\n1019.1 \"Order to Charge\" Ability { id: \"2057\", source: \"Aulus mal Asina\" }\r\n1020.0 \"--sync--\" Ability { id: \"2053\", source: \"Prototype Bit\" }\r\n1025.3 \"Order to Fire\" Ability { id: \"2058\", source: \"Aulus mal Asina\" }\r\n1028.9 \"Aetherochemical Grenado\" Ability { id: \"205A\", source: \"Prototype Bit\" }\r\n1033.3 \"Integrated Aetheromodulator\" Ability { id: \"205B\", source: \"Prototype Bit\" }\r\n1035.3 \"--sync--\" Ability { id: \"2053\", source: \"Prototype Bit\" }\r\n1053.3 \"Mana Burst\" Ability { id: \"204F\", source: \"Aulus mal Asina\" }\r\n1059.4 \"Order to Charge\" Ability { id: \"2057\", source: \"Aulus mal Asina\" }\r\n\r\n# Phase 1 loop\r\n1060.3 \"--sync--\" Ability { id: \"2053\", source: \"Prototype Bit\" } jump 1020\r\n1065.6 \"Order to Fire\" #Ability { id: \"2058\", source: \"Aulus mal Asina\" }\r\n1069.2 \"Aetherochemical Grenado\" #Ability { id: \"205A\", source: \"Prototype Bit\" }\r\n1073.7 \"Integrated Aetheromodulator\" #Ability { id: \"205B\", source: \"Prototype Bit\" }\r\n1075.7 \"--sync--\" #Ability { id: \"2053\", source: \"Prototype Bit\" }\r\n1093.7 \"Mana Burst\" #Ability { id: \"204F\", source: \"Aulus mal Asina\" }\r\n1099.8 \"Order to Charge\" #Ability { id: \"2057\", source: \"Aulus mal Asina\" }\r\n\r\n# Intermission at <= 60% HP\r\n1500.0 \"--sync--\" StartsUsing { id: \"2050\", source: \"Aulus Mal Asina\" } window 500,1\r\n1503.0 \"Magitek Disruptor\" Ability { id: \"2050\", source: \"Aulus mal Asina\" }\r\n1508.0 \"Mindjack\" Ability { id: \"204E\", source: \"Aulus mal Asina\" }\r\n1509.2 \"--sync--\" Ability { id: \"2053\", source: \"Prototype Bit\" }\r\n1517.8 \"Magitek Ray\" Ability { id: \"2054\", source: \"Prototype Bit\" }\r\n1522.2 \"Magitek Ray\" Ability { id: \"2054\", source: \"Prototype Bit\" } jump 1517.8\r\n1528.3 \"Magitek Ray\"\r\n1534.3 \"Magitek Ray\"\r\n1540.3 \"Magitek Ray\"\r\n1546.3 \"Magitek Ray\"\r\n\r\n# Phase 2\r\n1600.0 \"--sync--\" Ability { id: \"2053\", source: \"Prototype Bit\" } window 85,1\r\n1615.0 \"Mana Burst\" Ability { id: \"204F\", source: \"Aulus mal Asina\" }\r\n1621.1 \"Order to Charge\" Ability { id: \"2057\", source: \"Aulus mal Asina\" }\r\n\r\n1622.0 \"--sync--\" Ability { id: \"2053\", source: \"Prototype Bit\" }\r\n1627.3 \"Order to Fire\" Ability { id: \"2058\", source: \"Aulus mal Asina\" }\r\n1630.3 \"Integrated Aetheromodulator\" Ability { id: \"205B\", source: \"Prototype Bit\" }\r\n1630.7 \"Aetherochemical Grenado\" Ability { id: \"205A\", source: \"Prototype Bit\" }\r\n1635.2 \"Integrated Aetheromodulator\" Ability { id: \"205B\", source: \"Prototype Bit\" }\r\n1635.2 \"Demimagicks\" Ability { id: \"205D\", source: \"Aulus mal Asina\" }\r\n1637.3 \"--sync--\" Ability { id: \"2053\", source: \"Prototype Bit\" }\r\n1645.3 \"Mana Burst\" Ability { id: \"204F\", source: \"Aulus mal Asina\" }\r\n1658.5 \"Mana Burst\" Ability { id: \"204F\", source: \"Aulus mal Asina\" }\r\n1664.6 \"Order to Charge\" Ability { id: \"2057\", source: \"Aulus mal Asina\" }\r\n\r\n# Phase 2 loop\r\n1665.5 \"--sync--\" Ability { id: \"2053\", source: \"Prototype Bit\" } jump 1622\r\n1670.8 \"Order to Fire\" #Ability { id: \"2058\", source: \"Aulus mal Asina\" }\r\n1673.8 \"Integrated Aetheromodulator\" #Ability { id: \"205B\", source: \"Prototype Bit\" }\r\n1674.4 \"Aetherochemical Grenado\" #Ability { id: \"205A\", source: \"Prototype Bit\" }\r\n1678.8 \"Integrated Aetheromodulator\" #Ability { id: \"205B\", source: \"Prototype Bit\" }\r\n1678.8 \"Demimagicks\" #Ability { id: \"205D\", source: \"Aulus mal Asina\" }\r\n1680.9 \"--sync--\" #Ability { id: \"2053\", source: \"Prototype Bit\" }\r\n1688.9 \"Mana Burst\" #Ability { id: \"204F\", source: \"Aulus mal Asina\" }\r\n1702.1 \"Mana Burst\" #Ability { id: \"204F\", source: \"Aulus mal Asina\" }\r\n1708.2 \"Order to Charge\" #Ability { id: \"2057\", source: \"Aulus mal Asina\" }\r\n\r\n# Zenos Yae Galvus\r\n# -ii 2061 2062 2064 2067 2069 2589\r\n# boss will walk center before using 2065/2066/2068 Art of the Swell/Storm/Sword, causes timeline drift\r\n# The Hall of the Griffin will be sealed off\r\n2000.0 \"--Start--\" SystemLogMessage { id: \"7DC\", param1: \"8F3\" } window 2000,5\r\n2009.7 \"--sync--\" Ability { id: \"205F\", source: \"Zenos Yae Galvus\" } window 10,5\r\n2023.4 \"Storm?/Swell?\" Ability { id: \"206[56]\", source: \"Zenos Yae Galvus\" } window 5,5\r\n\r\n2032.8 \"Unmoving Troika\" Ability { id: \"2060\", source: \"Zenos Yae Galvus\" }\r\n2050.6 \"Storm?/Swell?\" Ability { id: \"206[56]\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2059.3 \"Art of the Sword\" Ability { id: \"2068\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2068.5 \"Unmoving Troika\" Ability { id: \"2060\", source: \"Zenos Yae Galvus\" }\r\n\r\n2088.4 \"Storm?/Swell?\" Ability { id: \"206[56]\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2097.1 \"Art of the Sword\" Ability { id: \"2068\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2106.4 \"Unmoving Troika\" Ability { id: \"2060\", source: \"Zenos Yae Galvus\" }\r\n2126.2 \"Storm?/Swell?\" Ability { id: \"206[56]\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2134.9 \"Art of the Sword\" Ability { id: \"2068\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2144.2 \"Unmoving Troika\" Ability { id: \"2060\", source: \"Zenos Yae Galvus\" } jump 2068.5\r\n\r\n2164.0 \"Storm?/Swell?\"\r\n2172.7 \"Art of the Sword\"\r\n2182.0 \"Unmoving Troika\"\r\n2201.8 \"Storm?/Swell?\"\r\n2210.5 \"Art of the Sword\"\r\n2219.8 \"Unmoving Troika\"\r\n\r\n# Phase 2 at <= 65% HP\r\n2300.0 \"--sync--\" Ability { id: \"239F\", source: \"Zenos Yae Galvus\" } window 300,5\r\n2307.5 \"Vein Splitter\" Ability { id: \"24B6\", source: \"Zenos Yae Galvus\" }\r\n2310.1 \"Vein Splitter\" Ability { id: \"206C\", source: \"Zenos Yae Galvus\" }\r\n2323.3 \"Lightless Spark\" Ability { id: \"206B\", source: \"Zenos Yae Galvus\" }\r\n2331.6 \"Unmoving Troika\" Ability { id: \"2060\", source: \"Zenos Yae Galvus\" }\r\n2341.7 \"Concentrativity\" Ability { id: \"206D\", source: \"Zenos Yae Galvus\" }\r\n2354.4 \"Storm?/Swell?/Sword?\" Ability { id: \"206[568]\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2366.5 \"Concentrativity\" Ability { id: \"206D\", source: \"Zenos Yae Galvus\" }\r\n2371.7 \"--sync--\" Ability { id: \"239F\", source: \"Zenos Yae Galvus\" }\r\n\r\n# Paths diverge into Storm/Swell blocks\r\n# Blocks loop at random to 20% HP\r\n2379.3 \"Art of the Swell?\" Ability { id: \"2065\", source: \"Zenos Yae Galvus\" } window 5,5 jump 2600\r\n2379.3 \"Art of the Storm?\" Ability { id: \"2066\", source: \"Zenos Yae Galvus\" } window 5,5 jump 2500\r\n2381.8 \"Vein Splitter\"\r\n2385.3 \"Lightless Spark?\"\r\n2388.0 \"Art of the Sword\"\r\n2396.3 \"Unmoving Troika\"\r\n2406.3 \"Concentrativity\"\r\n\r\n# Storm block\r\n2500.0 \"Art of the Storm\" Ability { id: \"2066\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2502.5 \"Vein Splitter\" Ability { id: \"206C\", source: \"Zenos Yae Galvus\" }\r\n2508.7 \"Art of the Sword\" Ability { id: \"2068\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2517.0 \"Unmoving Troika\" Ability { id: \"2060\", source: \"Zenos Yae Galvus\" }\r\n2527.0 \"Concentrativity\" Ability { id: \"206D\", source: \"Zenos Yae Galvus\" }\r\n2539.3 \"Storm?/Swell?/Sword?\" Ability { id: \"206[568]\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2551.4 \"Concentrativity\" Ability { id: \"206D\", source: \"Zenos Yae Galvus\" }\r\n2556.4 \"--sync--\" Ability { id: \"239F\", source: \"Zenos Yae Galvus\" } window 20,20\r\n\r\n2564.0 \"Art of the Swell?\" Ability { id: \"2065\", source: \"Zenos Yae Galvus\" } window 5,5 jump 2600\r\n2564.0 \"Art of the Storm?\" Ability { id: \"2066\", source: \"Zenos Yae Galvus\" } window 5,5 jump 2500\r\n2566.5 \"Vein Splitter\"\r\n2570.0 \"Lightless Spark?\"\r\n2572.7 \"Art of the Sword\"\r\n2581.0 \"Unmoving Troika\"\r\n2591.0 \"Concentrativity\"\r\n\r\n# Swell block\r\n2600.0 \"Art of the Swell\" Ability { id: \"2065\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2602.5 \"Vein Splitter\" Ability { id: \"206C\", source: \"Zenos Yae Galvus\" }\r\n2606.0 \"Lightless Spark\" Ability { id: \"206B\", source: \"Zenos Yae Galvus\" }\r\n2608.7 \"Art of the Sword\" Ability { id: \"2068\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2617.0 \"Unmoving Troika\" Ability { id: \"2060\", source: \"Zenos Yae Galvus\" }\r\n2627.0 \"Concentrativity\" Ability { id: \"206D\", source: \"Zenos Yae Galvus\" }\r\n2639.8 \"Storm?/Swell?/Sword?\" Ability { id: \"206[568]\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2651.8 \"Concentrativity\" Ability { id: \"206D\", source: \"Zenos Yae Galvus\" }\r\n2656.8 \"--sync--\" Ability { id: \"239F\", source: \"Zenos Yae Galvus\" } window 20,20\r\n\r\n2664.4 \"Art of the Storm?\" Ability { id: \"2066\", source: \"Zenos Yae Galvus\" } window 5,5 jump 2500\r\n2664.4 \"Art of the Swell?\" Ability { id: \"2065\", source: \"Zenos Yae Galvus\" } window 5,5 jump 2600\r\n2666.9 \"Vein Splitter\"\r\n2670.4 \"Lightless Spark?\"\r\n2673.1 \"Art of the Sword\"\r\n2681.4 \"Unmoving Troika\"\r\n2691.4 \"Concentrativity\"\r\n\r\n# Intermission at < 20% HP\r\n2700.0 \"--sync--\" Ability { id: \"206E\", source: \"Zenos Yae Galvus\" } window 700,5\r\n2706.0 \"--sync--\" Ability { id: \"239F\", source: \"Zenos Yae Galvus\" }\r\n2712.7 \"Swell/Sword\" Ability { id: \"258[68]\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2715.1 \"Art of the Storm\" Ability { id: \"2587\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2732.0 \"--sync--\" Ability { id: \"239F\", source: \"Zenos Yae Galvus\" }\r\n2739.1 \"Swell/Sword\" Ability { id: \"258[68]\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2741.1 \"Art of the Storm\" Ability { id: \"2587\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2763.0 \"--sync--\" Ability { id: \"239F\", source: \"Zenos Yae Galvus\" }\r\n2769.6 \"Swell/Sword\" Ability { id: \"258[68]\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2772.0 \"Art of the Storm\" Ability { id: \"2587\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2789.0 \"--sync--\" Ability { id: \"239F\", source: \"Zenos Yae Galvus\" }\r\n2796.0 \"Swell/Sword\" Ability { id: \"258[68]\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2798.0 \"Art of the Storm\" Ability { id: \"2587\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2815.0 \"--sync--\" Ability { id: \"239F\", source: \"Zenos Yae Galvus\" }\r\n2822.0 \"Swell/Sword\" Ability { id: \"258[68]\", source: \"Zenos Yae Galvus\" } window 5,5\r\n2824.0 \"Art of the Storm\" Ability { id: \"2587\", source: \"Zenos Yae Galvus\" } window 5,5\r\n\r\n# The intermission closes here regardless.\r\n# Parties reaching here naturally will die to a full boss gauge.\r\n2836.1 \"Storm, Swell, Sword\" Ability { id: \"206F\", source: \"Zenos Yae Galvus\" } window 135,10\r\n2839.0 \"--sync--\" Ability { id: \"239E\", source: \"The Storm\" }\r\n2843.1 \"Storm, Swell, Sword\" Ability { id: \"2070\", source: \"Zenos Yae Galvus\" } window 5,5\r\n\r\n2855.9 \"Concentrativity\" Ability { id: \"206D\", source: \"Zenos Yae Galvus\" } window 20,5\r\n2866.1 \"Concentrativity\" Ability { id: \"206D\", source: \"Zenos Yae Galvus\" }\r\n2876.3 \"Concentrativity\" Ability { id: \"206D\", source: \"Zenos Yae Galvus\" }\r\n2886.5 \"Concentrativity\" Ability { id: \"206D\", source: \"Zenos Yae Galvus\" } jump 2855.9\r\n2896.7 \"Concentrativity\"\r\n2906.9 \"Concentrativity\"\r\n2917.1 \"Concentrativity\"\r\n2927.3 \"Concentrativity\"\r\n2937.5 \"Concentrativity\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/bardams_mettle.ts



const bardams_mettle_triggerSet = {
  id: 'BardamsMettle',
  zoneId: zone_id/* default.BardamsMettle */.Z.BardamsMettle,
  timelineFile: 'bardams_mettle.txt',
  timelineTriggers: [{
    id: 'Bardam\'s Mettle Feathercut',
    // untelegraphed, instant tank cleave
    regex: /Feathercut/,
    beforeSeconds: 4,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'Bardam\'s Mettle Rush',
    type: 'Tether',
    // 0039 = pink, un-stretched tether
    // 0001 = purple, stretched tether
    // capture both in case we start already stretched
    netRegex: {
      id: ['0039', '0001'],
      source: 'Garula'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 15,
    // tether log line is sent repeatedly until mechanic finishes
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Run Away From Boss',
        de: 'Renn weg vom Boss',
        fr: 'Courez loin du boss',
        ja: 'ボスから離れる',
        cn: '远离Boss',
        ko: '보스와 거리 벌리기'
      }
    }
  }, {
    id: 'Bardam\'s Mettle War Cry + Earthquake',
    // War Cry (1EFA, small raidwide, triggers adds) and Earthquake (1EFB, medium raidwide w/ 2s stun)
    // are instant and used after Rush (1EF9, charge on tethered player)
    type: 'Ability',
    netRegex: {
      id: '1EF9',
      source: 'Garula',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Both Bardam and Yol use the 0017 head marker.
    // If we're in the Yol encounter, we're obviously not fighting Bardam.
    // trigger off Yol's first auto in case of chat lines being turned off
    id: 'Bardam\'s Mettle Dead Bardam',
    type: 'Ability',
    netRegex: {
      id: '367',
      source: 'Yol',
      capture: false
    },
    suppressSeconds: 99999,
    run: data => data.deadBardam = true
  }, {
    id: 'Bardam\'s Mettle Empty Gaze',
    type: 'StartsUsing',
    netRegex: {
      id: '1F04',
      source: 'Hunter Of Bardam',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Bardam\'s Mettle Sacrifice',
    type: 'StartsUsing',
    netRegex: {
      id: '1F01',
      source: 'Bardam',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in a tower',
        de: 'Im Turm stehen',
        fr: 'Placez-vous dans une tour',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 들어가기'
      }
    }
  }, {
    // Bardam casts Comet repeatedly during this phase,
    // but 257D is used only once. The others are 257E.
    id: 'Bardam\'s Mettle Comet',
    type: 'StartsUsing',
    netRegex: {
      id: '257D',
      source: 'Bardam',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '8x puddles on YOU',
        de: '8x Fläche auf DIR',
        fr: '8x Zones au sol sur VOUS',
        ja: '8つ波動砲',
        cn: '躲避8连追踪AOE',
        ko: '8연속 장판 준비'
      }
    }
  }, {
    id: 'Bardam\'s Mettle Meteor Impact',
    type: 'StartsUsing',
    netRegex: {
      id: '2582',
      source: 'Looming Shadow'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide behind boulder',
        de: 'Hinter dem Brocken verstecken',
        fr: 'Cachez-vous derrière le rocher',
        ja: 'メテオの後ろに',
        cn: '站在陨石后',
        ko: '운석 뒤에 숨기'
      }
    }
  }, {
    id: 'Bardam\'s Mettle Wind Unbound',
    type: 'StartsUsing',
    netRegex: {
      id: '1F0A',
      source: 'Yol',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Bardam\'s Mettle Flutterfall',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: (data, matches) => data.me === matches.target && data.deadBardam,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Bardam\'s Mettle Eye Of The Fierce',
    type: 'StartsUsing',
    netRegex: {
      id: '1F0D',
      source: 'Yol',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'Bardam\'s Mettle Wingbeat You',
    type: 'HeadMarker',
    netRegex: {
      id: '0010'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback Laser on YOU',
        de: 'Rückstoß-Laser auf DIR',
        fr: 'Poussée laser sur VOUS',
        ja: '自分にノックバック',
        cn: '击退点名',
        ko: '날갯짓 대상자'
      }
    }
  }, {
    id: 'Bardam\'s Mettle Wingbeat Others',
    type: 'HeadMarker',
    netRegex: {
      id: '0010'
    },
    condition: conditions/* default.targetIsNotYou */.Z.targetIsNotYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Laser',
        de: 'Laser ausweichen',
        fr: 'Évitez le laser',
        ja: 'ノックバックレーザーを避ける',
        cn: '躲避击退点名',
        ko: '날갯짓 피하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Yol(?! )': 'Yol',
      'Yol Feather': 'Yol-Feder',
      'Warrior Of Bardam': 'Bardams Krieger',
      'Voiceless Muse': 'Stumme Muse',
      'Throwing Spear': 'Wurfspeer',
      'Star Shard': 'Sternensplitter',
      'Rebirth Of Bardam The Brave': 'Bardams Wiedergeburt',
      'Looming Shadow': 'Lauernd(?:e|er|es|en) Schatten',
      'Hunter Of Bardam': 'Bardams Jäger',
      'Corpsecleaner Eagle': 'Leichenputzer',
      'Garula': 'Garula',
      'Bardam\'s Hunt': 'Bardams Jagdgrund',
      '(?<! )Bardam(?!( |s|\'))': 'Bardams Statue'
    },
    'replaceText': {
      'Wingbeat': 'Flügelschlag',
      'Wind Unbound': 'Entfesselter Wind',
      'War Cry': 'Kampfgebrüll',
      'Tremblor': 'Erdbeben',
      'Travail': 'Probe',
      'Sacrifice': 'Opfer',
      'Rush': 'Stürmen',
      'Reconstruct': 'Rekonstruieren',
      'Pinion': 'Flotter Fittich',
      'Meteor Impact': 'Meteoreinschlag',
      'Magnetism': 'Magnetismus',
      'Heavy Strike': 'Schwerer Schlag',
      'Heave': 'Hochhieven',
      'Flutterfall': 'Federsturm',
      'Feathercut': 'Federschnitt',
      'Eye of the Fierce': 'Grimmiger Blick',
      'Empty Gaze': 'Stierer Blick',
      'Earthquake': 'Erdbeben',
      'Crumbling Crust': 'Zerberstende Erde',
      'Comet Impact': 'Kometeneinschlag',
      'Comet(?! Impact)': 'Komet',
      'Charge': 'Sturm',
      'Bardam\'s Ring': 'Bardams Ring'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Yol(?! )': 'Yol',
      'Yol Feather': 'plume de Yol',
      'Warrior Of Bardam': 'guerrier de Bardam',
      'Voiceless Muse': 'la Muse sans voix',
      'Throwing Spear': 'lance de jet',
      'Star Shard': 'éclat d\'étoile',
      'Rebirth Of Bardam The Brave': 'la Renaissance de Bardam le Brave',
      'Looming Shadow': 'ombre grandissante',
      'Hunter Of Bardam': 'chasseur de Bardam',
      'Corpsecleaner Eagle': 'aigle charognard',
      'Garula': 'Garula',
      'Bardam\'s Hunt': 'la Chasse de Bardam',
      '(?<! )Bardam(?!( |s|\'))': 'Bardam'
    },
    'replaceText': {
      'Wingbeat': 'Battement d\'ailes',
      'Wind Unbound': 'Relâche de vent',
      'War Cry': 'Cri désorientant',
      'Tremblor': 'Tremblement de terre',
      'Travail': 'Labeur',
      'Sacrifice': 'Sacrifice',
      'Rush': 'Ruée',
      'Reconstruct': 'Reconstruction',
      'Pinion': 'Rémiges',
      'Meteor Impact': 'Impact de météore',
      'Magnetism': 'Magnétisme',
      'Heavy Strike': 'Frappe lourde',
      'Heave': 'Soulèvement',
      'Flutterfall': 'Tempête de plumes',
      'Feathercut': 'Coupe de plumes',
      'Eye of the Fierce': 'Œil de rapace',
      'Empty Gaze': 'Œil terne',
      'Earthquake': 'Tremblement de terre',
      'Crumbling Crust': 'Croûte croulante',
      'Comet Impact': 'Impact de comète',
      'Comet(?! Impact)': 'Comète',
      'Charge': 'Charge',
      'Bardam\'s Ring': 'Anneau de Bardam'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Yol(?! )': 'ヨル',
      'Yol Feather': 'ヨルの羽根',
      'Warrior Of Bardam': 'バルダムズ・ウォーリアー',
      'Voiceless Muse': '物言わぬ語り部',
      'Throwing Spear': '投げ槍',
      'Star Shard': '星片',
      'Rebirth Of Bardam The Brave': '勇士バルダムの再誕地',
      'Looming Shadow': '落下地点',
      'Hunter Of Bardam': 'バルダムズ・ハンター',
      'Corpsecleaner Eagle': 'スカヴェンジング・イーグル',
      'Garula': 'ガルラ',
      'Bardam\'s Hunt': '戦士バルダムの狩場',
      '(?<! )Bardam(?!( |s|\'))': 'バルダムの巨像'
    },
    'replaceText': {
      'Wingbeat': 'ウィングガスト',
      'Wind Unbound': 'ウィンドアンバウンド',
      'War Cry': '雄叫び',
      'Tremblor': '地震',
      'Travail': '試練',
      'Sacrifice': '犠牲',
      'Rush': '突進',
      'Reconstruct': '破壊再生',
      'Pinion': 'フェザーダーツ',
      'Meteor Impact': 'メテオインパクト',
      'Magnetism': '磁力',
      'Heavy Strike': 'ヘヴィストライク',
      'Heave': 'しゃくり上げ',
      'Flutterfall': 'フェザーストーム',
      'Feathercut': 'フェザーカッター',
      'Eye of the Fierce': '猛禽の眼',
      'Empty Gaze': '虚無の瞳',
      'Earthquake': '地震',
      'Crumbling Crust': '地盤崩し',
      'Comet Impact': 'コメットインパクト',
      'Comet(?! Impact)': 'コメット',
      'Charge': 'チャージ',
      'Bardam\'s Ring': 'バルダムリング'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Yol(?! )': '胡鹰',
      'Yol Feather': '胡鹰的羽毛',
      'Warrior Of Bardam': '巴儿达木的战士',
      'Voiceless Muse': '无声的叙事者',
      'Throwing Spear': '投枪',
      'Star Shard': '星体碎片',
      'Rebirth Of Bardam The Brave': '勇猛巴儿达木的重生',
      'Looming Shadow': '坠落地点',
      'Hunter Of Bardam': '巴儿达木的猎人',
      'Corpsecleaner Eagle': '清道雄鹰',
      'Garula': '加鲁拉',
      'Bardam\'s Hunt': '战士巴儿达木的猎场',
      '(?<! )Bardam(?!( |s|\'))': '巴儿达木巨像'
    },
    'replaceText': {
      'Wingbeat': '翼唤狂风',
      'Wind Unbound': '无拘之风',
      'War Cry': '吼叫',
      'Tremblor': '地震',
      'Travail': '试炼',
      'Sacrifice': '牺牲',
      'Rush': '突进',
      'Reconstruct': '破坏再生',
      'Pinion': '飞羽镖',
      'Meteor Impact': '陨石冲击',
      'Magnetism': '磁力',
      'Heavy Strike': '灵极重击',
      'Heave': '掀地',
      'Flutterfall': '羽落如雨',
      'Feathercut': '飞羽斩',
      'Eye of the Fierce': '猛禽之眼',
      'Empty Gaze': '空洞之瞳',
      'Earthquake': '地震',
      'Crumbling Crust': '地面崩裂',
      'Comet Impact': '星屑冲击',
      'Comet(?! Impact)': '彗星',
      'Charge': '刺冲',
      'Bardam\'s Ring': '巴儿达木之环'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Yol(?! )': '욜',
      'Yol Feather': '욜의 깃털',
      'Warrior Of Bardam': '바르담 전사',
      'Voiceless Muse': '말 없는 이야기꾼',
      'Throwing Spear': '투척창',
      'Star Shard': '별의 파편',
      'Rebirth Of Bardam The Brave': '용사 바르담의 재탄생지',
      'Looming Shadow': '낙하지점',
      'Hunter Of Bardam': '바르담 사냥꾼',
      'Corpsecleaner Eagle': '청소 독수리',
      'Garula': '가루라',
      'Bardam\'s Hunt': '전사 바르담의 사냥터',
      '(?<! )Bardam(?!( |s|\'))': '바르담 조각상'
    },
    'replaceText': {
      'Wingbeat': '날갯짓',
      'Wind Unbound': '바람 해방',
      'War Cry': '우렁찬 외침',
      'Tremblor': '지진',
      'Travail': '시련',
      'Sacrifice': '희생',
      'Rush': '돌진',
      'Reconstruct': '파괴 재생',
      'Pinion': '깃털 쏘기',
      'Meteor Impact': '운석 낙하',
      'Magnetism': '자력',
      'Heavy Strike': '무거운 충격',
      'Heave': '흐느낌',
      'Flutterfall': '깃털 폭풍',
      'Feathercut': '칼날 깃털',
      'Eye of the Fierce': '맹금류의 눈',
      'Empty Gaze': '허무한 눈동자',
      'Earthquake': '대지진',
      'Crumbling Crust': '지반 붕괴',
      'Comet Impact': '혜성 낙하',
      'Comet(?! Impact)': '혜성',
      'Charge': '돌격',
      'Bardam\'s Ring': '바르담의 고리'
    }
  }]
};
/* harmony default export */ const bardams_mettle = (bardams_mettle_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/bardams_mettle.txt
const dungeon_bardams_mettle_namespaceObject = "hideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Travail\"\r\nhideall \"Reconstruct\"\r\n\r\n#~~~~~~~~#\r\n# Garula #\r\n#~~~~~~~~#\r\n\r\n# -ic \"Steppe Coeurl\" \"Steppe Sheep\" \"Steppe Yamaa\"\r\n\r\n# Bardam's Hunt will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"7B8\" }\r\n11.7 \"Heave\" Ability { id: \"1EF7\", source: \"Garula\" } window 11.7,5\r\n20.9 \"--sync--\" Ability { id: \"1EF8\", source: \"Garula\" }\r\n22.4 \"Crumbling Crust\" Ability { id: \"1F13\", source: \"Garula\" }\r\n34.1 \"Rush\" Ability { id: \"1EF9\", source: \"Garula\" }\r\n36.2 \"War Cry\" Ability { id: \"1EFA\", source: \"Garula\" }\r\n38.9 \"Earthquake\" Ability { id: \"1EFB\", source: \"Garula\" } window 15,15\r\n49.5 \"Heave\" Ability { id: \"1EF7\", source: \"Garula\" }\r\n58.7 \"--sync--\" Ability { id: \"1EF8\", source: \"Garula\" }\r\n60.2 \"Crumbling Crust\" Ability { id: \"1F13\", source: \"Garula\" }\r\n\r\n66.6 \"Heave\" Ability { id: \"1EF7\", source: \"Garula\" } jump 11.7\r\n77.3 \"Crumbling Crust\"\r\n89.0 \"Rush\"\r\n91.1 \"War Cry\"\r\n93.8 \"Earthquake\"\r\n\r\n#~~~~~~~~#\r\n# BARDAM #\r\n#~~~~~~~~#\r\n\r\n# -ii 1EFE 2578 2579 257A 257E 257B\r\n\r\n# The Rebirth of Bardam the Brave will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"7B9\" } window 1000,5\r\n1007.8 \"Travail\" Ability { id: \"1EFF\", source: \"Bardam\" } window 7.8,5\r\n1014.1 \"Magnetism\" Ability { id: \"1F08\", source: \"Hunter Of Bardam\" }\r\n1020.3 \"Tremblor\" Ability { id: \"257C\", source: \"Bardam\" }\r\n1022.8 \"Empty Gaze\" Ability { id: \"1F04\", source: \"Hunter Of Bardam\" }\r\n1025.0 \"Travail\" Ability { id: \"1EFF\", source: \"Bardam\" }\r\n1029.8 \"Charge x3\" # Ability { id: \"257F\", source: \"Throwing Spear\" }\r\n1038.8 \"Empty Gaze\" Ability { id: \"1F04\", source: \"Hunter Of Bardam\" }\r\n1038.9 \"Charge\" Ability { id: \"257F\", source: \"Throwing Spear\" }\r\n1044.6 \"--sync--\" Ability { id: \"24EA\", source: \"Bardam\" } window 15,15\r\n1052.3 \"Travail\" Ability { id: \"1EFF\", source: \"Bardam\" }\r\n1060.5 \"Sacrifice\" Ability { id: \"1F01\", source: \"Bardam\" }\r\n1060.7 \"Travail\" Ability { id: \"1EFF\", source: \"Bardam\" }\r\n1065.5 \"Bardam's Ring\" Ability { id: \"2581\", source: \"Bardam\" }\r\n1066.2 \"Travail\" Ability { id: \"1EFF\", source: \"Bardam\" }\r\n1076.4 \"Comet x8\" duration 12 # Ability { id: \"257D\", source: \"Bardam\" }\r\n1093.4 \"Heavy Strike x3\" Ability { id: \"2577\", source: \"Hunter Of Bardam\" } duration 4\r\n1099.0 \"Travail\" Ability { id: \"1EFF\", source: \"Bardam\" }\r\n1105.3 \"Comet Impact\" Ability { id: \"2580\", source: \"Star Shard\" }\r\n1109.3 \"--sync--\" Ability { id: \"24EA\", source: \"Bardam\" } window 15,15\r\n1116.9 \"Travail\" Ability { id: \"1EFF\", source: \"Bardam\" }\r\n1125.3 \"Reconstruct\" Ability { id: \"1EFD\", source: \"Bardam\" }\r\n1126.7 \"--sync--\" Ability { id: \"258B\", source: \"Star Shard\" }\r\n1128.3 \"Travail\" Ability { id: \"1EFF\", source: \"Bardam\" }\r\n1133.1 \"Charge\" Ability { id: \"257F\", source: \"Throwing Spear\" }\r\n1133.9 \"Magnetism\" Ability { id: \"1F08\", source: \"Hunter Of Bardam\" }\r\n1139.5 \"Tremblor\" Ability { id: \"2585\", source: \"Hunter Of Bardam\" }\r\n1140.0 \"Heavy Strike x3\" Ability { id: \"2577\", source: \"Warrior Of Bardam\" } duration 4\r\n1153.0 \"Meteor Impact\" Ability { id: \"2582\", source: \"Looming Shadow\" }\r\n1153.4 \"--sync--\" Ability { id: \"258B\", source: \"Star Shard\" }\r\n\r\n#~~~~~#\r\n# YOL #\r\n#~~~~~#\r\n\r\n# -ii 1F0B 1F0E\r\n\r\n# The Voiceless Muse will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"7BA\" } window 2000,5\r\n2008.1 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" }\r\n2015.2 \"Wind Unbound\" Ability { id: \"1F0A\", source: \"Yol\" }\r\n2023.9 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2025.8 \"Flutterfall\" Ability { id: \"1F0C\", source: \"Yol\" }\r\n2027.2 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" }\r\n2033.9 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2034.7 \"Flutterfall\" Ability { id: \"1F0C\", source: \"Yol\" }\r\n2042.2 \"Wind Unbound\" Ability { id: \"1F0A\", source: \"Yol\" } window 15,15\r\n2046.4 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" }\r\n2050.9 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2054.0 \"Eye Of The Fierce\" Ability { id: \"1F0D\", source: \"Yol\" }\r\n2059.2 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" }\r\n2060.9 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2069.3 \"Wind Unbound\" Ability { id: \"1F0A\", source: \"Yol\" }\r\n2071.4 \"--untargetable--\"\r\n2071.4 \"--adds spawn--\" AddedCombatant { name: \"Corpsecleaner Eagle\" } window 71.4,5\r\n2078.0 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2088.0 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2098.0 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2108.0 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2118.0 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" } jump 2078\r\n2128.0 \"Pinion\"\r\n2138.0 \"Pinion\"\r\n2148.0 \"Pinion\"\r\n\r\n# Unfortunately, because there are two Corpsecleaner Eagles,\r\n# we can't just sync to a 04 log line.\r\n2189.7 \"--targetable--\" NameToggle { name: \"Yol\", toggle: \"01\" } window 120,5\r\n2196.8 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" } window 125,5\r\n2204.0 \"Wind Unbound\" Ability { id: \"1F0A\", source: \"Yol\" }\r\n2212.7 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2214.5 \"Flutterfall\" Ability { id: \"1F0C\", source: \"Yol\" }\r\n2215.8 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" }\r\n2222.6 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2223.3 \"Flutterfall\" Ability { id: \"1F0C\", source: \"Yol\" }\r\n2230.7 \"Wind Unbound\" Ability { id: \"1F0A\", source: \"Yol\" } window 15,15\r\n2234.9 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" }\r\n2239.4 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2242.5 \"Eye Of The Fierce\" Ability { id: \"1F0D\", source: \"Yol\" }\r\n2247.7 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" }\r\n2249.4 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n\r\n2253.8 \"--untargetable--\" NameToggle { name: \"Yol\", toggle: \"00\" } window 60,5\r\n2260.3 \"Flutterfall\" Ability { id: \"1F10\", source: \"Yol\" } window 60,5\r\n2267.5 \"Wingbeat\" Ability { id: \"1F0F\", source: \"Yol\" }\r\n2276.9 \"Flutterfall\" Ability { id: \"1F0C\", source: \"Yol\" }\r\n2284.3 \"Wingbeat\" Ability { id: \"1F0F\", source: \"Yol\" }\r\n2284.7 \"Pinion\" Ability { id: \"2593\", source: \"Yol Feather\" }\r\n2293.8 \"Flutterfall\" Ability { id: \"1F0C\", source: \"Yol\" }\r\n2301.2 \"Wingbeat\" Ability { id: \"1F0F\", source: \"Yol\" }\r\n2301.6 \"Pinion\" Ability { id: \"2593\", source: \"Yol Feather\" }\r\n2310.7 \"Flutterfall\" Ability { id: \"1F0C\", source: \"Yol\" }\r\n2318.2 \"Wingbeat\" Ability { id: \"1F0F\", source: \"Yol\" }\r\n2318.6 \"Pinion\" Ability { id: \"2593\", source: \"Yol Feather\" } jump 2284.7\r\n2327.7 \"Flutterfall\"\r\n2335.1 \"Wingbeat\"\r\n2335.5 \"Pinion\"\r\n2344.6 \"Flutterfall\"\r\n2352.1 \"Wingbeat\"\r\n2352.5 \"Pinion\"\r\n\r\n\r\n2361.7 \"--targetable--\" NameToggle { name: \"Yol\", toggle: \"01\" } window 110,5\r\n2368.8 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" } window 110,5\r\n2376.0 \"Wind Unbound\" Ability { id: \"1F0A\", source: \"Yol\" }\r\n2384.7 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2386.6 \"Flutterfall\" Ability { id: \"1F0C\", source: \"Yol\" }\r\n2388.0 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" }\r\n2394.7 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2395.5 \"Flutterfall\" Ability { id: \"1F0C\", source: \"Yol\" }\r\n2402.9 \"Wind Unbound\" Ability { id: \"1F0A\", source: \"Yol\" } window 15,15\r\n2407.1 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" }\r\n2411.6 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2414.7 \"Eye Of The Fierce\" Ability { id: \"1F0D\", source: \"Yol\" }\r\n2419.9 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" }\r\n2421.5 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2433.1 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" }\r\n2440.2 \"Wind Unbound\" Ability { id: \"1F0A\", source: \"Yol\" } window 15,15\r\n2448.9 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2450.7 \"Flutterfall\" Ability { id: \"1F0C\", source: \"Yol\" }\r\n2452.1 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" }\r\n2458.9 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2459.6 \"Flutterfall\" Ability { id: \"1F0C\", source: \"Yol\" }\r\n2467.0 \"Wind Unbound\" Ability { id: \"1F0A\", source: \"Yol\" } window 15,15\r\n2471.1 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" }\r\n2475.7 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2478.7 \"Eye Of The Fierce\" Ability { id: \"1F0D\", source: \"Yol\" }\r\n2483.9 \"Feathercut\" Ability { id: \"1F09\", source: \"Yol\" }\r\n2485.7 \"Pinion\" Ability { id: \"1F11\", source: \"Yol Feather\" }\r\n2490.0 \"--untargetable--\" NameToggle { name: \"Yol\", toggle: \"00\" } window 130,5 jump 2253.8\r\n\r\n2496.5 \"Flutterfall\"\r\n2503.7 \"Wingbeat\"\r\n2513.1 \"Flutterfall\"\r\n2520.5 \"Wingbeat\"\r\n2520.9 \"Pinion\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/castrum_abania.ts



const castrum_abania_triggerSet = {
  id: 'CastrumAbania',
  zoneId: zone_id/* default.CastrumAbania */.Z.CastrumAbania,
  timelineFile: 'castrum_abania.txt',
  timelineTriggers: [{
    id: 'CastrumAbania Magna Roader Wheel',
    // no cast, untelegraphed tankbuster
    regex: /Wheel/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'CastrumAbania Subject Number XXIV Sparking Current',
    // no cast, line AoEs on each player
    regex: /Sparking Current/,
    beforeSeconds: 4,
    response: responses/* Responses.spread */.n3.spread()
  }],
  triggers: [{
    id: 'CastrumAbania Magna Roader Fire III',
    type: 'StartsUsing',
    netRegex: {
      source: 'Magna Roader',
      id: '1F16',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe(),
    run: data => data.calledWildSpeed = data.calledUseCannon = false
  }, {
    id: 'CastrumAbania Magna Roader Wild Speed',
    type: 'StartsUsing',
    netRegex: {
      source: 'Magna Roader',
      id: '207E',
      capture: false
    },
    // This repeats indefinitely, so only call the first one per Wild Speed phase.
    condition: data => !data.calledWildSpeed,
    delaySeconds: 6,
    response: responses/* Responses.killAdds */.n3.killAdds(),
    run: data => data.calledWildSpeed = true
  }, {
    id: 'CastrumAbania Magna Roader Mark XLIII Mini Cannon',
    type: 'NameToggle',
    netRegex: {
      name: 'Mark XLIII Mini Cannon',
      toggle: '01',
      capture: false
    },
    // There's two cannons, so only say something when the first one is targetable.
    condition: data => !data.calledUseCannon,
    delaySeconds: 6,
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.calledUseCannon = true,
    outputStrings: {
      text: {
        en: 'Fire cannon at boss',
        de: 'Feuere Kanonen auf den Boss',
        fr: 'Tirez le canon sur le boss',
        cn: '用炮射BOSS',
        ko: '보스 파동탄 맞추기'
      }
    }
  }, {
    id: 'CastrumAbania Subject Number XXIV Elemental Overload',
    type: 'StartsUsing',
    netRegex: {
      source: 'Subject Number XXIV',
      id: '82A[89A-D]',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'CastrumAbania Subject Number XXIV Fire II',
    type: 'HeadMarker',
    netRegex: {
      id: '00A1'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'CastrumAbania Subject Number XXIV Blizzard II',
    type: 'HeadMarker',
    netRegex: {
      id: '0178'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'CastrumAbania Subject Number XXIV Thunder II',
    type: 'StartsUsing',
    netRegex: {
      source: 'Subject Number XXIV',
      id: '82B8',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.getTowers(),
    outputStrings: {
      getTowers: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 하나씩 들어가기'
      }
    }
  }, {
    id: 'CastrumAbania Inferno Ketu Slash',
    type: 'StartsUsing',
    netRegex: {
      source: 'Inferno',
      id: ['1F26', '208B', '208C']
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'CastrumAbania Inferno Adds',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '6270',
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'CastrumAbania Inferno Rahu Ray',
    type: 'HeadMarker',
    netRegex: {
      id: '004A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'CastrumAbania Inferno Rahu Comet',
    type: 'StartsUsing',
    // Rahu Comet (1F2B) does not do knockback until it has been empowered at least once.
    netRegex: {
      source: 'Inferno',
      id: ['2088', '2089'],
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // Knockback comes from the proximity marker, not the boss.
        en: 'Small comet knockback',
        de: 'Kleiner Kometenrückstoß',
        fr: 'Poussée de la petite comète',
        cn: '小彗星击退',
        ko: '작은 혜성 넉백'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Inferno': 'Inferno',
      'Magna Roader': 'Magna Rotula',
      'Mark XLIII Mini Cannon': 'Kleingeschütz Xliii',
      'Project Aegis': 'Projekt Aegis',
      'Subject Number XXIV': 'Experiment Nummer XXIV',
      'Terrestrial Weaponry': 'Bodenwaffenentwicklung',
      'The Assessment Grounds': 'Evaluationsgelände'
    },
    'replaceText': {
      '--adds--': '--Adds--',
      'Barrier Shift': 'Barrierewechsel',
      'Blizzard II': 'Eisra',
      'Elemental Overload': 'Elementarschub',
      '(?<!Magitek )Fire II(?!I)': 'Feura',
      'Gale Cut': 'Sturmschnitt',
      'Ice Grid': 'Eisgitter',
      'Ketu & Rahu': 'Ketoh & Rahu',
      'Ketu Cut': 'Ketoh-Schnitt',
      'Ketu Slash': 'Ketoh-Hieb',
      'Magitek Fire II(?!I)': 'Magitek-Feura',
      'Magitek Fire III': 'Magitek-Feuga',
      'Rahu Blaster': 'Rahu-Blaster',
      'Rahu Cut': 'Rahu-Schnitt',
      'Sparking Current': 'Elektrofunke',
      'Stab': 'Durchstoß',
      'System Error': 'Systemfehler',
      'Thunder II': 'Blitzra',
      'Towers': 'Türme',
      'Triflame': 'Dreifachflamme',
      'Wheel': 'Rad',
      'Wild Speed': 'Heißlaufen'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Inferno': 'Inferno',
      'Magna Roader': 'magna rouleur magitek',
      'Mark XLIII Mini Cannon': 'Mortier Type Xliii',
      'Project Aegis': 'Projet Aegis',
      'Subject Number XXIV': 'sujet expérimental Numéro XXIV',
      'Terrestrial Weaponry': 'Armement terrestre',
      'The Assessment Grounds': 'Terrain d\'évaluation'
    },
    'replaceText': {
      '--adds--': '--adds--',
      'Barrier Shift': 'Change-Barrière',
      'Blizzard II': 'Extra Glace',
      'Elemental Overload': 'Amplification élémentaire',
      '(?<!Magitek )Fire II(?!I)': 'Extra Feu',
      'Gale Cut': 'Chute de pointes',
      'Ice Grid': 'Lacis glacé',
      'Ketu & Rahu': 'Ketu et Rahu',
      'Ketu Cut': 'Dépassement Ketu',
      'Ketu Slash': 'Taillade Ketu',
      'Magitek Fire II(?!I)': 'Extra Feu magitek',
      'Magitek Fire III': 'Méga Feu magitek',
      'Rahu Blaster': 'Canon Rahu',
      'Rahu Cut': 'Dépassement Rahu',
      'Sparking Current': 'Courant étincelant',
      'Stab': 'Poignardage',
      'System Error': 'Erreur système',
      'Thunder II': 'Extra Foudre',
      'Towers': 'Tours',
      'Triflame': 'Triflamme',
      'Wheel': 'Roue',
      'Wild Speed': 'Course folle'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Inferno': 'インフェルノ',
      'Magna Roader': '魔導マグナローダー',
      'Mark XLIII Mini Cannon': 'Xliii式小臼砲',
      'Project Aegis': '強化実験房',
      'Subject Number XXIV': '実験体ナンバーXXIV',
      'Terrestrial Weaponry': '陸戦兵器開発房',
      'The Assessment Grounds': '性能試験場'
    },
    'replaceText': {
      '--adds--': '--雑魚--',
      'Barrier Shift': 'バリアチェンジ',
      'Blizzard II': 'ブリザラ',
      'Elemental Overload': 'エレメンタルブースト',
      '(?<!Magitek )Fire II(?!I)': 'ファイラ',
      'Gale Cut': '烈風殺',
      'Ice Grid': 'アイスグリッド',
      'Ketu & Rahu': 'ケトゥ＆ラフ',
      'Ketu Cut': 'ケトゥ・リミッターカット',
      'Ketu Slash': 'ケトゥ・スラッシュ',
      'Magitek Fire II(?!I)': '魔導ファイラ',
      'Magitek Fire III': '魔導ファイガ',
      'Rahu Blaster': 'ラフ・ブラスター',
      'Rahu Cut': 'ラフ・リミッターカット',
      'Sparking Current': 'カレントスパーク',
      'Stab': '刺突',
      'Towers': '塔',
      'System Error': 'システムエラー',
      'Thunder II': 'サンダラ',
      'Triflame': 'スリーフレイム',
      'Wheel': 'ホイール',
      'Wild Speed': '暴走'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Inferno': '炼狱炎魔',
      'Magna Roader': '魔导机车大魔',
      'Mark XLIII Mini Cannon': '43式小迫击炮',
      'Project Aegis': '强化实验室',
      'Subject Number XXIV': '024号',
      'Terrestrial Weaponry': '陆战兵器开发室',
      'The Assessment Grounds': '性能试验场'
    },
    'replaceText': {
      '--adds--': '--小怪--',
      'Barrier Shift': '护盾转换',
      'Blizzard II': '冰冻',
      'Elemental Overload': '元素过载',
      '(?<!Magitek )Fire II(?!I)': '烈炎',
      'Gale Cut': '烈风杀',
      'Ice Grid': '冰格',
      'Ketu & Rahu': '罗睺计都',
      'Ketu Cut': '计都限制器减档',
      'Ketu Slash': '计都挥',
      'Magitek Fire II(?!I)': '魔导烈炎',
      'Magitek Fire III': '魔导爆炎',
      'Rahu Blaster': '罗睺冲击波',
      'Rahu Cut': '罗睺限制器减档',
      'Sparking Current': '电流火花',
      'Stab': '突刺',
      'System Error': '系统错误',
      'Thunder II': '震雷',
      'Towers': '塔',
      'Triflame': '三炎',
      'Wheel': '车轮',
      'Wild Speed': '猛冲'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Inferno': '인페르노',
      'Magna Roader': '마도 마그나로더',
      'Mark XLIII Mini Cannon': 'XLIII식 소형 박격포',
      'Project Aegis': '강화실험실',
      'Subject Number XXIV': '실험체 XXIV호',
      'Terrestrial Weaponry': '지상 병기 개발실',
      'The Assessment Grounds': '성능 시험장'
    },
    'replaceText': {
      '--adds--': '--쫄--',
      'Barrier Shift': '보호막 변환',
      'Blizzard II': '블리자라',
      'Elemental Overload': '속성 충전',
      '(?<!Magitek )Fire II(?!I)': '파이라',
      'Gale Cut': '진공 칼날',
      'Ice Grid': '얼음 격자',
      'Ketu & Rahu': '케투와 라후',
      'Ketu Cut': '케투 리미터 해제',
      'Ketu Slash': '케투 난도질',
      'Magitek Fire II(?!I)': '마도 파이라',
      'Magitek Fire III': '마도 파이가',
      'Rahu Blaster': '라후 폭파',
      'Rahu Cut': '라후 리미터 해제',
      'Sparking Current': '전류 방사',
      'Stab': '찌르기',
      'System Error': '시스템 오류',
      'Thunder II': '선더라',
      'Towers': '기둥',
      'Triflame': '세 갈래 화염',
      'Wheel': '바퀴',
      'Wild Speed': '폭주'
    }
  }]
};
/* harmony default export */ const castrum_abania = (castrum_abania_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/castrum_abania.txt
const dungeon_castrum_abania_namespaceObject = "hideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Magna Roader\r\n# -p 1F14:9.4\r\n# -ii 1F17 1F18 2090 1F19 2085\r\n# -it \"Magna Roader\"\r\n\r\n# initial\r\n# Terrestrial Weaponry will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"790\" } window 0,1\r\n13.5 \"Magitek Fire II\" Ability { id: \"1F15\", source: \"Magna Roader\" }\r\n18.6 \"Magitek Fire II\" Ability { id: \"1F15\", source: \"Magna Roader\" }\r\n25.7 \"Magitek Fire III\" Ability { id: \"1F16\", source: \"Magna Roader\" }\r\n\r\n# Wild Speed Loop (until stunned, max 4 cycles)\r\n35.5 \"--untargetable--\"\r\n35.5 \"--sync--\" Ability { id: \"207E\", source: \"Magna Roader\" } window 5,5 # boss moves south first, can delay timeline\r\n35.6 \"Wild Speed 1\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n36.6 \"Wild Speed 2\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n37.6 \"Wild Speed 3\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n38.6 \"Wild Speed 4\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n\r\n45.7 \"--sync--\" Ability { id: \"207E\", source: \"Magna Roader\" }\r\n45.8 \"Wild Speed 1\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n46.8 \"Wild Speed 2\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n47.8 \"Wild Speed 3\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n48.8 \"Wild Speed 4\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n\r\n55.9 \"--sync--\" Ability { id: \"207E\", source: \"Magna Roader\" }\r\n56.0 \"Wild Speed 1\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n57.0 \"Wild Speed 2\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n58.0 \"Wild Speed 3\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n59.0 \"Wild Speed 4\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n\r\n66.1 \"--sync--\" Ability { id: \"207E\", source: \"Magna Roader\" }\r\n66.2 \"Wild Speed 1\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n67.2 \"Wild Speed 2\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n68.2 \"Wild Speed 3\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n69.2 \"Wild Speed 4\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n\r\n# Post Wild Speed loop -> back into Wild Speed loop\r\n70.2 \"--targetable--\"\r\n70.2 \"--sync--\" StartsUsing { id: \"1F16\", source: \"Magna Roader\" } window 40,10\r\n73.2 \"Magitek Fire III\" Ability { id: \"1F16\", source: \"Magna Roader\" }\r\n77.3 \"Wheel\" Ability { id: \"1F14\", source: \"Magna Roader\" } window 47,10 # can jump here instead after being hit with the cannons\r\n84.8 \"Magitek Fire II\" Ability { id: \"1F15\", source: \"Magna Roader\" }\r\n89.9 \"Magitek Fire II\" Ability { id: \"1F15\", source: \"Magna Roader\" }\r\n94.1 \"Wheel\" Ability { id: \"1F14\", source: \"Magna Roader\" }\r\n101.6 \"Magitek Fire III\" Ability { id: \"1F16\", source: \"Magna Roader\" }\r\n105.7 \"Wheel\" Ability { id: \"1F14\", source: \"Magna Roader\" }\r\n113.2 \"Magitek Fire II\" Ability { id: \"1F15\", source: \"Magna Roader\" }\r\n118.4 \"Magitek Fire II\" Ability { id: \"1F15\", source: \"Magna Roader\" }\r\n\r\n133.3 \"--untargetable--\"\r\n133.3 \"--sync--\" Ability { id: \"207E\", source: \"Magna Roader\" } window 60,60 jump 35.5\r\n133.4 \"Wild Speed 1\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n134.4 \"Wild Speed 2\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n135.4 \"Wild Speed 3\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n136.4 \"Wild Speed 4\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n\r\n143.5 \"--sync--\" #Ability { id: \"207E\", source: \"Magna Roader\" }\r\n143.6 \"Wild Speed 1\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n144.6 \"Wild Speed 2\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n145.6 \"Wild Speed 3\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n146.6 \"Wild Speed 4\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n\r\n153.7 \"--sync--\" #Ability { id: \"207E\", source: \"Magna Roader\" }\r\n153.8 \"Wild Speed 1\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n154.8 \"Wild Speed 2\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n155.8 \"Wild Speed 3\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n156.8 \"Wild Speed 4\" #Ability { id: \"1FF8\", source: \"Magna Roader\" }\r\n\r\n\r\n### Subject Number XXIV\r\n# first phase is random, cycle order is always fire > ice > thunder > fire (repeat)\r\n# -ii 82B1 82B2 83D3 82AE 82AF 82B0 83D4 83D5 83D6 82B9\r\n\r\n# Project Aegis will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"791\" } window 10000,0\r\n1008.3 \"--sync--\" StartsUsing { id: \"82A9\", source: \"Subject Number XXIV\" } window 10,10 jump 1095 # fire phase first\r\n1008.3 \"--sync--\" StartsUsing { id: \"82A8\", source: \"Subject Number XXIV\" } window 10,10 jump 1144.7 # ice phase first\r\n1008.3 \"--sync--\" StartsUsing { id: \"82AA\", source: \"Subject Number XXIV\" } window 10,10 jump 1193.6 # thunder phase first\r\n1013.2 \"Elemental Overload (Random)\"\r\n\r\n# fire phase\r\n1100.0 \"Elemental Overload (Fire)\" Ability { id: \"82A(9|C)\", source: \"Subject Number XXIV\" }\r\n1112.2 \"Triflame\" Ability { id: \"82B7\", source: \"Subject Number XXIV\" }\r\n1118.9 \"Fire II\" Ability { id: \"82B6\", source: \"Subject Number XXIV\" }\r\n1130.0 \"Triflame\" Ability { id: \"82B7\", source: \"Subject Number XXIV\" }\r\n1132.6 \"Triflame\" Ability { id: \"82B7\", source: \"Subject Number XXIV\" }\r\n1133.6 \"Fire II\" Ability { id: \"82B6\", source: \"Subject Number XXIV\" }\r\n1134.6 \"System Error\" Ability { id: \"82B3\", source: \"Subject Number XXIV\" }\r\n\r\n# ice phase\r\n1149.7 \"Elemental Overload (Ice)\" Ability { id: \"82A(8|B)\", source: \"Subject Number XXIV\" }\r\n1161.1 \"Ice Grid\" Ability { id: \"82B4\", source: \"Subject Number XXIV\" }\r\n1167.8 \"Blizzard II\" Ability { id: \"82B5\", source: \"Subject Number XXIV\" }\r\n1178.8 \"Ice Grid\" Ability { id: \"82B4\", source: \"Subject Number XXIV\" }\r\n1181.4 \"Ice Grid\" Ability { id: \"82B4\", source: \"Subject Number XXIV\" }\r\n1182.4 \"Blizzard II\" Ability { id: \"82B5\", source: \"Subject Number XXIV\" }\r\n1183.5 \"System Error\" Ability { id: \"82B3\", source: \"Subject Number XXIV\" }\r\n\r\n# thunder phase\r\n1198.6 \"Elemental Overload (Thunder)\" Ability { id: \"82A(A|D)\", source: \"Subject Number XXIV\" }\r\n1211.6 \"Thunder II\" Ability { id: \"82B8\", source: \"Subject Number XXIV\" }\r\n1213.1 \"--sync--\" Ability { id: \"82BB\", source: \"Subject Number XXIV\" }\r\n1218.1 \"Sparking Current\" Ability { id: \"82BA\", source: \"Subject Number XXIV\" }\r\n1227.0 \"--sync--\" Ability { id: \"82BB\", source: \"Subject Number XXIV\" }\r\n1230.4 \"Thunder II\" Ability { id: \"82B8\", source: \"Subject Number XXIV\" }\r\n1232.1 \"Sparking Current\" Ability { id: \"82BA\", source: \"Subject Number XXIV\" }\r\n1234.5 \"Thunder II\" Ability { id: \"82B8\", source: \"Subject Number XXIV\" }\r\n1236.1 \"System Error\" Ability { id: \"82B3\", source: \"Subject Number XXIV\" }\r\n\r\n# loop\r\n1251.2 \"Elemental Overload (Fire)\" Ability { id: \"82AC\", source: \"Subject Number XXIV\" } jump 1100\r\n1262.5 \"Triflame\" #Ability { id: \"82B7\", source: \"Subject Number XXIV\" }\r\n1269.2 \"Fire II\" #Ability { id: \"82B6\", source: \"Subject Number XXIV\" }\r\n1280.2 \"Triflame\" #Ability { id: \"82B7\", source: \"Subject Number XXIV\" }\r\n1282.8 \"Triflame\" #Ability { id: \"82B7\", source: \"Subject Number XXIV\" }\r\n1283.8 \"Fire II\" #Ability { id: \"82B6\", source: \"Subject Number XXIV\" }\r\n1284.9 \"System Error\" #Ability { id: \"82B3\", source: \"Subject Number XXIV\" }\r\n\r\n\r\n### Inferno\r\n# -p 1F26:2010.4\r\n# -ii 1F2B 2088 2089 1F2A 1F28 1F27 2086\r\n#\r\n# TODO: if Quick Charge (2127) goes off, the timeline goes a bit wonky until\r\n# Inferno is fully charged.  Solve this by adding a large jump on Rahu Cut 2.\r\n# Additionally, there are two opportunities for Quick Charge (yikes).\r\n# We could theoretically jump to two extra timelines if Quick Charge happens,\r\n# but that's a lot of work for a dungeon, especially one where it's lucky\r\n# that you'll ever see Rahu Cut 1.\r\n#\r\n# Note: Ketu & Rahu is always a pair of two mechanics, which picks from some combination\r\n# of Rahu Comet/Rahu Ray + Ketu Wave/Ketu Cutter.  Rahu Comet knocks back (at Rahu >=1)\r\n# and also its ability happens 1.5 seconds before its accompanying Wave/Cutter.\r\n# This makes everything hard to time.  For simplicity, we'll just ignore it all.\r\n# * Rahu Comet (1F2B, 2088, 2089): prox marker, knockback on 2088/2089\r\n# * Rahu Ray (1F2A): spread marker\r\n# * Ketu Wave (1F28): 1, 2, or 3 large circles\r\n# * Ketu Cutter (1F27): 180/360 degree pinwheel\r\n# * Ketu Cut (2086) / Rahu Cut (2087) is powering up.\r\n# Assessment Grounds will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"792\" } window 10000,0\r\n2010.4 \"Ketu Slash\" Ability { id: \"1F26\", source: \"Inferno\" }\r\n2017.9 \"Rahu Blaster\" Ability { id: \"1F29\", source: \"Inferno\" }\r\n2028.8 \"Ketu & Rahu\" Ability { id: \"1F25\", source: \"Inferno\" }\r\n\r\n2045.0 \"Ketu Cut 1\" Ability { id: \"2086\", source: \"Inferno\" } window 50,50\r\n2054.7 \"Ketu Slash\" Ability { id: \"208B\", source: \"Inferno\" }\r\n2062.3 \"Rahu Blaster\" Ability { id: \"1F29\", source: \"Inferno\" }\r\n2069.8 \"Ketu Slash\" Ability { id: \"208B\", source: \"Inferno\" }\r\n2079.9 \"Ketu & Rahu\" Ability { id: \"1F25\", source: \"Inferno\" }\r\n2087.9 \"Ketu & Rahu\" Ability { id: \"1F25\", source: \"Inferno\" }\r\n2096.8 \"Rahu Blaster\" Ability { id: \"1F29\", source: \"Inferno\" }\r\n2104.3 \"Ketu Slash\" Ability { id: \"208B\", source: \"Inferno\" }\r\n\r\n2119.2 \"Rahu Cut 1\" Ability { id: \"2087\", source: \"Inferno\" } window 50,50\r\n2123.3 \"--adds--\"\r\n2128.8 \"Ketu Slash\" Ability { id: \"208B\", source: \"Inferno\" }\r\n2136.3 \"Rahu Blaster\" Ability { id: \"208E\", source: \"Inferno\" }\r\n2143.9 \"Ketu Slash\" Ability { id: \"208B\", source: \"Inferno\" }\r\n2151.4 \"Rahu Blaster\" Ability { id: \"208E\", source: \"Inferno\" }\r\n# 2159 Quick Charge can go off here, which delays Ketu & Rahu by 30s, throws off timeline.\r\n# Hopefully the large sync on Rahu Cut below will get it sorted again.\r\n2159.8 \"Ketu & Rahu\" Ability { id: \"1F25\", source: \"Inferno\" }\r\n2167.8 \"Ketu & Rahu\" Ability { id: \"1F25\", source: \"Inferno\" }\r\n2175.6 \"Rahu Blaster\" Ability { id: \"208E\", source: \"Inferno\" }\r\n2183.1 \"Ketu Slash\" Ability { id: \"208B\", source: \"Inferno\" }\r\n\r\n2197.9 \"Ketu Cut 2\" Ability { id: \"2086\", source: \"Inferno\" } window 50,50\r\n2201.8 \"--adds--\"\r\n2207.7 \"Ketu Slash\" Ability { id: \"208C\", source: \"Inferno\" }\r\n2215.3 \"Rahu Blaster\" Ability { id: \"208E\", source: \"Inferno\" }\r\n2222.9 \"Ketu Slash\" Ability { id: \"208C\", source: \"Inferno\" }\r\n2230.4 \"Rahu Blaster\" Ability { id: \"208E\", source: \"Inferno\" }\r\n# 2237.5 Quick Charge?\r\n2238.5 \"Ketu & Rahu\" Ability { id: \"1F25\", source: \"Inferno\" }\r\n2246.5 \"Ketu & Rahu\" Ability { id: \"1F25\", source: \"Inferno\" }\r\n2254.3 \"Rahu Blaster\" Ability { id: \"208E\", source: \"Inferno\" }\r\n2261.9 \"Ketu Slash\" Ability { id: \"208C\", source: \"Inferno\" }\r\n\r\n# Once we get to this Rahu Cut, then it is fully powered.\r\n2276.8 \"Rahu Cut 2\" Ability { id: \"2087\", source: \"Inferno\" } window 150,150\r\n2286.4 \"Ketu Slash\" Ability { id: \"208C\", source: \"Inferno\" }\r\n2294.0 \"Rahu Blaster\" Ability { id: \"208F\", source: \"Inferno\" }\r\n2301.5 \"Ketu Slash\" Ability { id: \"208C\", source: \"Inferno\" }\r\n2309.0 \"Rahu Blaster\" Ability { id: \"208F\", source: \"Inferno\" }\r\n2317.3 \"Ketu & Rahu\" Ability { id: \"1F25\", source: \"Inferno\" }\r\n2325.4 \"Ketu & Rahu\" Ability { id: \"1F25\", source: \"Inferno\" }\r\n2333.2 \"Rahu Blaster\" Ability { id: \"208F\", source: \"Inferno\" }\r\n\r\n# loop\r\n2340.7 \"Ketu Slash\" Ability { id: \"208C\", source: \"Inferno\" }\r\n2351.6 \"Ketu & Rahu\" Ability { id: \"1F25\", source: \"Inferno\" }\r\n2359.7 \"Ketu & Rahu\" Ability { id: \"1F25\", source: \"Inferno\" }\r\n2367.6 \"Rahu Blaster\" Ability { id: \"208F\", source: \"Inferno\" }\r\n\r\n2375.2 \"Ketu Slash\" Ability { id: \"208C\", source: \"Inferno\" } window 20,200 jump 2340.7\r\n2386.1 \"Ketu & Rahu\" #Ability { id: \"1F25\", source: \"Inferno\" }\r\n2394.2 \"Ketu & Rahu\" #Ability { id: \"1F25\", source: \"Inferno\" }\r\n2402.1 \"Rahu Blaster\" #Ability { id: \"208F\", source: \"Inferno\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/doma_castle.ts



const doma_castle_triggerSet = {
  id: 'DomaCastle',
  zoneId: zone_id/* default.DomaCastle */.Z.DomaCastle,
  timelineFile: 'doma_castle.txt',
  timelineTriggers: [{
    id: 'Doma Castle Magitek Rearguard Cermet Pile',
    // untelegraphed, instant tank cleave
    regex: /Cermet Pile/,
    beforeSeconds: 4,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'Doma Castle Magitek Hexadrone 2-Tonze Magitek Missile',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Doma Castle Magitek Hexadrone Magitek Missiles',
    type: 'StartsUsing',
    netRegex: {
      source: 'Magitek Hexadrone',
      id: '20A4',
      capture: false
    },
    infoText: (data, _matches, output) => {
      return data.seenTowers ? output.getTowers() : output.getTower();
    },
    run: data => data.seenTowers = true,
    outputStrings: {
      getTower: {
        en: 'Get Tower',
        de: 'Turm nehmen',
        fr: 'Prenez la tour',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 들어가기'
      },
      getTowers: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 하나씩 들어가기'
      }
    }
  }, {
    id: 'Doma Castle Hypertuned Grynewaht Delay-Action Charge',
    type: 'HeadMarker',
    netRegex: {
      id: '0063'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Doma Castle Hypertuned Grynewaht Thermobaric Charge',
    type: 'GainsEffect',
    // There's no 0x1B line or 0x14/0x15 target for this prox marker, only the Prey debuff.
    netRegex: {
      effectId: '4E5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Charge Away',
        de: 'Lege Markierung weit weg ab',
        fr: 'Déposez la charge au loin',
        ja: 'マーカーを外に捨てる',
        cn: '将标记放远',
        ko: '징 멀리 두고 오기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Hexadrone Bit': 'Hexadrohnen-Modul',
      'Hypertuned Grynewaht': 'hyperisiert(?:e|er|es|en) Grynewaht',
      'Magitek Chakram': 'Magitek-Chakram',
      'Magitek Hexadrone': 'Magitek-Hexadrohne',
      'Magitek Rearguard': 'Magitek-Rückendecker',
      'Rearguard Bit': 'Rückendecker-Drohne',
      'Retuned Magitek Bit': 'verbessert(?:e|er|es|en) Magitek-Drohne',
      'The Third Armory': 'Dritte Waffenkammer',
      'The Training Grounds': 'Exerzierplatz',
      'The Hall Of The Scarlet Swallow': 'Halle der Blutroten Schwalbe'
    },
    'replaceText': {
      '2-Tonze Magitek Missile': 'Magitek-Großrakete',
      'Bits Activate': 'Aktivierung der Module',
      'Cermet Pile': 'Cermet-Pfahl',
      'Chainsaw': 'Kettensäge',
      'Circle Of Death': 'Todeskreis',
      'Clean Cut': 'Durchschlag',
      'Delay-Action Charge': 'Zeitzünder',
      'Garlean Fire': 'Garleischer Brandsatz',
      'Gunsaw': 'Kanonensäge',
      'Hexadrone Bits': 'Hexadrohnen-Module',
      'Magitek Bits': 'Magitek-Drohnen',
      'Magitek Missiles': 'Magitek-Rakete',
      'Magitek Ray': 'Magitek-Laser',
      'Rearguard Mines': 'Rückendecker-Minen',
      'Thermobaric Charge': 'Aerosolbombe'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Hexadrone Bit': 'module d\'hexadrone',
      'Hypertuned Grynewaht': 'Grynewaht hyper-renforcé',
      'Magitek Chakram': 'chakram magitek',
      'Magitek Hexadrone': 'hexadrone magitek',
      'Magitek Rearguard': 'arrière-garde magitek',
      'Rearguard Bit': 'drone d\'arrière-garde',
      'Retuned Magitek Bit': 'drone magitek reréglé',
      'The Third Armory': 'Arsenal A3',
      'The Training Grounds': 'Terrain de manœuvres',
      'The Hall Of The Scarlet Swallow': 'Salle de l\'Hirondelle écarlate'
    },
    'replaceText': {
      '2-Tonze Magitek Missile': 'Missiles magitek de 2 tonz',
      'Bits Activate': 'Activation des modules',
      'Cermet Pile': 'Amas de cermet',
      'Chainsaw': 'Tronçonneuse',
      'Circle Of Death': 'Cercle de la mort',
      'Clean Cut': 'Tranchage net',
      'Delay-Action Charge': 'Charge à retardement',
      'Hexadrone Bits': 'Modules d\'hexadrone',
      'Magitek Bits': 'Drones magitek',
      'Garlean Fire': 'Feu garlemaldais',
      'Gunsaw': 'Canon-tronçonneur',
      'Magitek Missiles': 'Missiles magitek',
      'Magitek Ray': 'Rayon magitek',
      'Rearguard Mines': 'Drones d\'arrière-garde',
      'Thermobaric Charge': 'Charge thermobarique'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Hexadrone Bit': 'ヘキサローラー・ビット',
      'Hypertuned Grynewaht': '強化グリーンワート',
      'Magitek Chakram': '魔導チャクラム',
      'Magitek Hexadrone': '魔導ヘキサローラー',
      'Magitek Rearguard': '魔導リアガード',
      'Rearguard Bit': 'リアガード・ビット',
      'Retuned Magitek Bit': '魔導ビット改',
      'The Third Armory': '第III兵器庫',
      'The Training Grounds': '練兵場',
      'The Hall Of The Scarlet Swallow': '赤燕の間'
    },
    'replaceText': {
      '2-Tonze Magitek Missile': '大型魔導ミサイル',
      'Cermet Pile': 'サーメットパイル',
      'Chainsaw': 'チェーンソー',
      'Circle Of Death': 'サークル・オブ・デス',
      'Clean Cut': '激突',
      'Delay-Action Charge': '時限爆弾',
      'Hexadrone Bits': 'ヘキサローラー・ビット',
      'Magitek Bits': '魔導ビット',
      'Garlean Fire': 'ガレアンファイア',
      'Gunsaw': 'ガンチェーンソー',
      'Magitek Missiles': '魔導ミサイル',
      'Magitek Ray': '魔導レーザー',
      'Thermobaric Charge': '気化爆弾'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Hexadrone Bit': '魔导六轮装甲浮游炮',
      'Hypertuned Grynewaht': '强化格林瓦特',
      'Magitek Chakram': '魔导战轮',
      'Magitek Hexadrone': '魔导六轮装甲',
      'Magitek Rearguard': '魔导后卫',
      'Rearguard Bit': '魔导后卫浮游炮',
      'Retuned Magitek Bit': '改良版魔导浮游炮',
      'The Third Armory': '第三兵器库',
      'The Training Grounds': '练兵场',
      'The Hall Of The Scarlet Swallow': '赤燕之间'
    },
    'replaceText': {
      '2-Tonze Magitek Missile': '大型魔导导弹',
      'Bits Activate': '浮游炮激活',
      'Cermet Pile': '陶瓷合金桩',
      'Chainsaw': '链锯',
      'Circle Of Death': '死亡回旋',
      'Clean Cut': '激突',
      'Delay-Action Charge': '定时炸弹',
      'Garlean Fire': '加雷马火炎',
      'Gunsaw': '链锯枪',
      'Hexadrone Bits': '魔导六轮装甲浮游炮',
      'Magitek Bits': '魔导浮游炮',
      'Magitek Missiles': '魔导飞弹',
      'Magitek Ray': '魔导激光',
      'Rearguard Mines': '魔导后卫炸雷',
      'Thermobaric Charge': '气化炸弹'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Hexadrone Bit': '헥사롤러 비트',
      'Hypertuned Grynewaht': '강화된 그륀바트',
      'Magitek Chakram': '마도 차크람',
      'Magitek Hexadrone': '마도 헥사롤러',
      'Magitek Rearguard': '마도 리어가드',
      'Rearguard Bit': '리어가드 비트',
      'Retuned Magitek Bit': '개량형 마도 비트',
      'The Third Armory': '제III병기고',
      'The Training Grounds': '연병장',
      'The Hall Of The Scarlet Swallow': '세키엔의 방'
    },
    'replaceText': {
      '2-Tonze Magitek Missile': '대형 마도 미사일',
      'Bits Activate': '비트 활성화',
      'Cermet Pile': '합금 말뚝',
      'Chainsaw': '전기톱',
      'Circle Of Death': '죽음의 원',
      'Clean Cut': '격돌',
      'Delay-Action Charge': '시한폭탄',
      'Garlean Fire': '갈레안 파이어',
      'Gunsaw': '기관총',
      'Hexadrone Bits': '헥사롤러 비트',
      'Magitek Bits': '마도 비트',
      'Magitek Missiles': '마도 미사일',
      'Magitek Ray': '마도 레이저',
      'Rearguard Mines': '리어가드 폭뢰',
      'Thermobaric Charge': '기화폭탄'
    }
  }]
};
/* harmony default export */ const doma_castle = (doma_castle_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/doma_castle.txt
const dungeon_doma_castle_namespaceObject = "hideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Magitek Rearguard\r\n# -ii 209F 20A0\r\n# boss will walk center before using 209D Cermet Pile, causes timeline drift\r\n# The Third Armory will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"7C1\" }\r\n7.4 \"Cermet Pile\" Ability { id: \"209D\", source: \"Magitek Rearguard\" } window 10,10\r\n15.0 \"Garlean Fire\" Ability { id: \"209E\", source: \"Magitek Rearguard\" }\r\n30.6 \"Magitek Ray\" Ability { id: \"20A1\", source: \"Rearguard Bit\" }\r\n35.6 \"Rearguard Mines\" #AddedCombatant { name: \"Rearguard Mine\" }\r\n37.8 \"Cermet Pile\" Ability { id: \"209D\", source: \"Magitek Rearguard\" } window 10,10\r\n40.8 \"Magitek Ray\" Ability { id: \"20A1\", source: \"Rearguard Bit\" }\r\n43.4 \"Garlean Fire\" Ability { id: \"209E\", source: \"Magitek Rearguard\" }\r\n48.9 \"Magitek Ray\" Ability { id: \"20A1\", source: \"Rearguard Bit\" }\r\n53.9 \"Magitek Ray\" Ability { id: \"20A1\", source: \"Rearguard Bit\" }\r\n60.9 \"Cermet Pile\" Ability { id: \"209D\", source: \"Magitek Rearguard\" } window 10,5\r\n68.5 \"Rearguard Mines\" #AddedCombatant { name: \"Rearguard Mine\" }\r\n\r\n70.7 \"Cermet Pile\" Ability { id: \"209D\", source: \"Magitek Rearguard\" } window 5,10\r\n73.7 \"Magitek Ray\" Ability { id: \"20A1\", source: \"Rearguard Bit\" }\r\n76.4 \"Garlean Fire\" Ability { id: \"209E\", source: \"Magitek Rearguard\" }\r\n81.9 \"Magitek Ray\" Ability { id: \"20A1\", source: \"Rearguard Bit\" }\r\n86.0 \"Cermet Pile\" Ability { id: \"209D\", source: \"Magitek Rearguard\" } window 10,10\r\n88.9 \"Magitek Ray\" Ability { id: \"20A1\", source: \"Rearguard Bit\" }\r\n91.6 \"Garlean Fire\" Ability { id: \"209E\", source: \"Magitek Rearguard\" }\r\n97.2 \"Magitek Ray\" Ability { id: \"20A1\", source: \"Rearguard Bit\" }\r\n98.7 \"Rearguard Mines\" #AddedCombatant { name: \"Rearguard Mine\" }\r\n101.3 \"Cermet Pile\" Ability { id: \"209D\", source: \"Magitek Rearguard\" } window 10,10\r\n104.3 \"Magitek Ray\" Ability { id: \"20A1\", source: \"Rearguard Bit\" }\r\n107.0 \"Garlean Fire\" Ability { id: \"209E\", source: \"Magitek Rearguard\" }\r\n112.5 \"Magitek Ray\" Ability { id: \"20A1\", source: \"Rearguard Bit\" }\r\n115.6 \"Cermet Pile\" Ability { id: \"209D\", source: \"Magitek Rearguard\" } window 10,10\r\n118.6 \"Magitek Ray\" Ability { id: \"20A1\", source: \"Rearguard Bit\" }\r\n131.3 \"Rearguard Mines\" #AddedCombatant { name: \"Rearguard Mine\" }\r\n\r\n133.2 \"Cermet Pile\" Ability { id: \"209D\", source: \"Magitek Rearguard\" } window 5,10 jump 70.7\r\n136.2 \"Magitek Ray\"\r\n138.9 \"Garlean Fire\"\r\n144.4 \"Magitek Ray\"\r\n148.5 \"Cermet Pile\"\r\n151.4 \"Magitek Ray\"\r\n154.1 \"Garlean Fire\"\r\n159.7 \"Magitek Ray\"\r\n161.2 \"Rearguard Mines\"\r\n\r\n### Magitek Hexadrone\r\n# -ii 20A4 20A6 20A7 2447\r\n# boss does not re-center\r\n# Training Grounds will be sealed off\r\n1000 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"7C2\" } window 1000,0\r\n1010.6 \"Circle Of Death\" Ability { id: \"20A2\", source: \"Magitek Hexadrone\" }\r\n1018.9 \"2-Tonze Magitek Missile\" Ability { id: \"20A3\", source: \"Magitek Hexadrone\" }\r\n1024.1 \"Hexadrone Bits\" AddedCombatant { name: \"Hexadrone Bit\" }\r\n1029.6 \"Bits Activate\"\r\n1039.6 \"Circle Of Death\" Ability { id: \"20A2\", source: \"Magitek Hexadrone\" }\r\n1045.7 \"Hexadrone Bits\" AddedCombatant { name: \"Hexadrone Bit\" }\r\n1049.8 \"Circle Of Death\" Ability { id: \"20A2\", source: \"Magitek Hexadrone\" }\r\n1051.2 \"Bits Activate\"\r\n1064.5 \"Magitek Missiles\" Ability { id: \"20A5\", source: \"Magitek Hexadrone\" }\r\n1068.9 \"Hexadrone Bits\" AddedCombatant { name: \"Hexadrone Bit\" }\r\n1074.4 \"Bits Activate\"\r\n1077.3 \"2-Tonze Magitek Missile\" Ability { id: \"20A3\", source: \"Magitek Hexadrone\" }\r\n\r\n1083.9 \"Circle Of Death\" Ability { id: \"20A2\", source: \"Magitek Hexadrone\" }\r\n1090.0 \"Hexadrone Bits\" AddedCombatant { name: \"Hexadrone Bit\" }\r\n1095.5 \"Bits Activate\"\r\n1098.6 \"Magitek Missiles\" Ability { id: \"20A5\", source: \"Magitek Hexadrone\" }\r\n1111.2 \"Hexadrone Bits\" AddedCombatant { name: \"Hexadrone Bit\" }\r\n1112.9 \"Magitek Missiles\" Ability { id: \"20A5\", source: \"Magitek Hexadrone\" }\r\n1116.7 \"Bits Activate\"\r\n1125.6 \"Circle Of Death\" Ability { id: \"20A2\", source: \"Magitek Hexadrone\" }\r\n1132.0 \"Hexadrone Bits\" AddedCombatant { name: \"Hexadrone Bit\" }\r\n1137.5 \"Bits Activate\"\r\n1140.0 \"2-Tonze Magitek Missile\" Ability { id: \"20A3\", source: \"Magitek Hexadrone\" }\r\n1150.1 \"Magitek Missiles\" Ability { id: \"20A5\", source: \"Magitek Hexadrone\" }\r\n1159.5 \"Hexadrone Bits\" AddedCombatant { name: \"Hexadrone Bit\" }\r\n1165.0 \"Bits Activate\"\r\n1168.0 \"2-Tonze Magitek Missile\" Ability { id: \"20A3\", source: \"Magitek Hexadrone\" }\r\n\r\n1174.6 \"Circle Of Death\" Ability { id: \"20A2\", source: \"Magitek Hexadrone\" } jump 1083.9\r\n1180.7 \"Hexadrone Bits\"\r\n1186.2 \"Bits Activate\"\r\n1189.3 \"Magitek Missiles\"\r\n1201.9 \"Hexadrone Bits\"\r\n1203.6 \"Magitek Missiles\"\r\n1207.4 \"Bits Activate\"\r\n\r\n### Hypertuned Grynewaht\r\n# -ii 20A9 20AB 20AC 20AE 20A7 2447\r\n# boss will walk center on 20B0 and stay center for 20AA Gunsaw, causes timeline drift\r\n# Hall of the Scarlet Swallow will be sealed off\r\n2000 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"7C3\" } window 2000,0\r\n2009.4 \"Chainsaw\" Ability { id: \"20A8\", source: \"Hypertuned Grynewaht\" } duration 5.5\r\n2022.7 \"--center--\"\r\n2022.7 \"Delay-Action Charge\" Ability { id: \"20AD\", source: \"Hypertuned Grynewaht\" } window 10,10 # boss walks center before using\r\n2023.1 \"Gunsaw\" Ability { id: \"20AA\", source: \"Hypertuned Grynewaht\" } duration 5\r\n2045.4 \"Thermobaric Charge\" Ability { id: \"20AF\", source: \"Hypertuned Grynewaht\" }\r\n2053.8 \"--center--\" Ability { id: \"20B0\", source: \"Hypertuned Grynewaht\" } window 10,10\r\n2062.0 \"Gunsaw\" Ability { id: \"20AA\", source: \"Hypertuned Grynewaht\" } duration 5\r\n2075.3 \"Delay-Action Charge\" Ability { id: \"20AD\", source: \"Hypertuned Grynewaht\" }\r\n2075.3 \"Clean Cut\" #Ability { id: \"20B1\", source: \"Magitek Chakram\" }\r\n2076.7 \"--center--\" Ability { id: \"20B0\", source: \"Hypertuned Grynewaht\" } window 10,10\r\n2084.9 \"Gunsaw\" Ability { id: \"20AA\", source: \"Hypertuned Grynewaht\" } duration 5\r\n2098.2 \"Delay-Action Charge\" Ability { id: \"20AD\", source: \"Hypertuned Grynewaht\" }\r\n2098.2 \"Clean Cut\" #Ability { id: \"20B1\", source: \"Magitek Chakram\" }\r\n2102.6 \"Magitek Bits\" AddedCombatant { name: \"Retuned Magitek Bit\" }\r\n2108.1 \"Bits Activate\"\r\n2117.9 \"Chainsaw\" Ability { id: \"20A8\", source: \"Hypertuned Grynewaht\" } duration 5.5\r\n2120.9 \"Thermobaric Charge\" Ability { id: \"20AF\", source: \"Hypertuned Grynewaht\" }\r\n2127.9 \"--center--\" Ability { id: \"20B0\", source: \"Hypertuned Grynewaht\" } window 10,10\r\n2134.2 \"Gunsaw\" Ability { id: \"20AA\", source: \"Hypertuned Grynewaht\" } duration 5\r\n2147.5 \"Delay-Action Charge\" Ability { id: \"20AD\", source: \"Hypertuned Grynewaht\" }\r\n2149.5 \"Clean Cut\" Ability { id: \"20B1\", source: \"Magitek Chakram\" }\r\n2152.6 \"--center--\" Ability { id: \"20B0\", source: \"Hypertuned Grynewaht\" } window 10,10\r\n2160.8 \"Gunsaw\" Ability { id: \"20AA\", source: \"Hypertuned Grynewaht\" } duration 5\r\n2174.1 \"Delay-Action Charge\" Ability { id: \"20AD\", source: \"Hypertuned Grynewaht\" }\r\n2174.1 \"Clean Cut\" #Ability { id: \"20B1\", source: \"Magitek Chakram\" }\r\n2179.7 \"--center--\" Ability { id: \"20B0\", source: \"Hypertuned Grynewaht\" } window 10,10\r\n2179.7 \"Magitek Bits\" AddedCombatant { name: \"Retuned Magitek Bit\" }\r\n2185.2 \"Bits Activate\"\r\n2194.8 \"Chainsaw\" Ability { id: \"20A8\", source: \"Hypertuned Grynewaht\" } duration 5.5\r\n2199.9 \"Thermobaric Charge\" Ability { id: \"20AF\", source: \"Hypertuned Grynewaht\" }\r\n2201.2 \"Clean Cut\" Ability { id: \"20B1\", source: \"Magitek Chakram\" }\r\n\r\n2208.5 \"--center--\" Ability { id: \"20B0\", source: \"Hypertuned Grynewaht\" } window 10,10\r\n2216.7 \"Gunsaw\" Ability { id: \"20AA\", source: \"Hypertuned Grynewaht\" } duration 5\r\n2230.0 \"Delay-Action Charge\" Ability { id: \"20AD\", source: \"Hypertuned Grynewaht\" }\r\n2230.0 \"Clean Cut\" #Ability { id: \"20B1\", source: \"Magitek Chakram\" }\r\n2232.5 \"Magitek Bits\" AddedCombatant { name: \"Retuned Magitek Bit\" }\r\n2238.0 \"Bits Activate\"\r\n2245.7 \"Chainsaw\" Ability { id: \"20A8\", source: \"Hypertuned Grynewaht\" } duration 5.5\r\n2253.4 \"Thermobaric Charge\" Ability { id: \"20AF\", source: \"Hypertuned Grynewaht\" }\r\n2259.8 \"Chainsaw\" Ability { id: \"20A8\", source: \"Hypertuned Grynewaht\" } duration 5.5\r\n\r\n2274.0 \"--center--\" Ability { id: \"20B0\", source: \"Hypertuned Grynewaht\" } window 10,10\r\n# Loop begins here, but the jump is attached to the Delay-Action Charge to preserve the duration timer for Gunsaw\r\n2282.2 \"Gunsaw\" Ability { id: \"20AA\", source: \"Hypertuned Grynewaht\" } duration 5\r\n2295.5 \"Delay-Action Charge\" Ability { id: \"20AD\", source: \"Hypertuned Grynewaht\" } jump 2230\r\n2295.5 \"Clean Cut\"\r\n2298.0 \"Magitek Bits\"\r\n2303.5 \"Bits Activate\"\r\n2308.5 \"Chainsaw\" duration 5.5\r\n2316.2 \"Thermobaric Charge\"\r\n2322.6 \"Chainsaw\" duration 5.5\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/drowned_city_of_skalla.ts



const drowned_city_of_skalla_triggerSet = {
  id: 'TheDrownedCityOfSkalla',
  zoneId: zone_id/* default.TheDrownedCityOfSkalla */.Z.TheDrownedCityOfSkalla,
  timelineFile: 'drowned_city_of_skalla.txt',
  timelineTriggers: [{
    // There is a startsUsing line, but the cast time is under 3 seconds.
    id: 'Skalla Torpedo',
    regex: /Torpedo/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Skalla Bubble Burst',
    regex: /Bubble Burst/,
    beforeSeconds: 3,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Bubble Explosions',
        de: 'Vermeide die Blasen-Explosionen',
        fr: 'Évitez les explosions des bulles',
        ja: '泡の爆発から避ける',
        cn: '躲开泡泡爆炸',
        ko: '거품 폭발 피하기'
      }
    }
  }],
  triggers: [{
    id: 'Skalla Rising Seas',
    type: 'StartsUsing',
    netRegex: {
      id: '2650',
      source: 'Kelpie',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Skalla Hydro Pull',
    type: 'StartsUsing',
    netRegex: {
      id: '2651',
      source: 'Kelpie',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Skalla Hydro Push',
    type: 'StartsUsing',
    netRegex: {
      id: '2652',
      source: 'Kelpie',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Skalla Bloody Puddle',
    type: 'HeadMarker',
    netRegex: {
      id: '002B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Skalla Rusting Claw',
    type: 'StartsUsing',
    netRegex: {
      id: '2661',
      source: 'Hrodric Poisontongue'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Skalla Tail Drive',
    type: 'StartsUsing',
    netRegex: {
      id: '2663',
      source: 'Hrodric Poisontongue',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'tail cleave',
        de: 'Schweif-Flächenangriff',
        fr: 'Évitez la queue',
        ja: 'しっぽ！',
        cn: '尾巴攻击',
        ko: '꼬리쓸기'
      }
    }
  }, {
    id: 'Skalla The Spin',
    type: 'StartsUsing',
    netRegex: {
      id: '2664',
      source: 'Hrodric Poisontongue',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Skalla Ring Of Chaos',
    type: 'HeadMarker',
    netRegex: {
      id: '0079'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Ring on YOU',
        de: 'Ring auf DIR',
        fr: 'Anneau sur VOUS',
        ja: '自分にドーナツ範囲',
        cn: '环形AoE点名',
        ko: '나에게 도넛 장판'
      }
    }
  }, {
    id: 'Skalla Cross Of Chaos',
    type: 'HeadMarker',
    netRegex: {
      id: '007A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cross on YOU',
        de: 'Kreuz auf DIR',
        fr: 'Croix sur VOUS',
        ja: '自分に十字範囲',
        cn: '十字AoE点名',
        ko: '나에게 십자 장판'
      }
    }
  }, {
    id: 'Skalla Circle Of Chaos',
    type: 'HeadMarker',
    netRegex: {
      id: '001C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Skalla Eye Of The Fire',
    type: 'StartsUsing',
    netRegex: {
      id: '2665',
      source: 'Hrodric Poisontongue',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Skalla Words Of Woe',
    type: 'StartsUsing',
    netRegex: {
      id: '2662',
      source: 'Hrodric Poisontongue',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Cross Of Chaos/Circle Of Chaos': 'Circle/Cross',
      'Ring Of Chaos/Cross Of Chaos': 'Cross/Ring',
      'Ring Of Chaos/Circle Of Chaos': 'Circle/Ring',
      'Hydro Pull/Hydro Push': 'Hydro Pull/Push',
      'Order To Detonate \\(cast\\)': 'Order To Detonate'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'A Door Unopened': 'Siegelpforte',
      'Hrodric Poisontongue': 'Hrodric Giftzunge',
      'Hydrosphere': 'Hydrosphäre',
      'Kelpie': 'Kelpie',
      'The Golden Walls Of Ruin': 'Theoderics Schatzkammer',
      'The Green Screams': 'Kelpies Revier',
      'The Old One': 'Altvorder(?:e|er|es|en)'
    },
    'replaceText': {
      'Bloody Puddle': 'Blutlache',
      'Bubble Burst': 'Platzende Blasen',
      'Circle Of Chaos': 'Chaoskreis',
      'Cross Of Chaos': 'Chaoskreuz',
      'Eye Of The Fire': 'Feuerauge',
      'Gallop': 'Galopp',
      'Hydro Pull': 'Hydrosog',
      'Hydro Push': 'Hydroschub',
      'Mystic Flame': 'Mystische Flamme',
      'Mystic Light': 'Mystisches Licht',
      'Order To Detonate': 'Selbstzerstörungsbefehl',
      'Ring Of Chaos': 'Chaosring',
      'Rising Seas': 'Steigender Spiegel',
      'Rusting Claw': 'Rostklaue',
      'Self-Detonate': 'Zerbersten',
      'Shifting Light': 'Lichtspiel',
      'Tail Drive': 'Schwanzfetzer',
      'The Spin': 'Doller Drall',
      'Torpedo': 'Torpedo',
      'Words Of Woe': 'Wehklagende Worte'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'A Door Unopened': 'La voie scellée',
      'Hrodric Poisontongue': 'Hrodric le Médisant',
      'Hydrosphere': 'hydrosphère',
      'Kelpie': 'Kelpie',
      'The Golden Walls Of Ruin': 'Salle du trésor',
      'The Green Screams': 'Domaine de Kelpie',
      'The Old One': 'Ancien'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(cast\\)': '(lancement)',
      'Bloody Puddle': 'Mare ensanglantée',
      'Bubble Burst': 'Bulles explosives',
      '(?<!/)Cross Of Chaos(?!/)': 'Croix du chaos',
      'Cross Of Chaos/Circle Of Chaos': 'Croix/Cercle du chaos',
      'Eye Of The Fire': 'Œil des flammes',
      'Gallop': 'Galop',
      'Hydro Pull': 'Hydrotraction',
      'Hydro Push': 'Hydropoussée',
      'Mystic Flame': 'Flammes mystiques',
      'Mystic Light': 'Lumière mystique',
      'Order To Detonate': 'Ordre de s\'auto-détruire',
      'Ring Of Chaos(?!/)': 'Anneau du chaos',
      'Ring Of Chaos/Cross Of Chaos': 'Anneau/Croix du chaos',
      'Ring Of Chaos/Circle Of Chaos': 'Anneau/Cercle du chaos',
      'Rising Seas': 'Montée des eaux',
      'Rusting Claw': 'Griffes de ruine',
      'Self-Detonate': 'Auto-atomisation',
      'Shifting Light': 'Lumière tremblante',
      'Tail Drive': 'Coup de queue',
      'The Spin': 'Balayage',
      'Torpedo': 'Ruée saumâtre',
      'Words Of Woe': 'Mots de malheur'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'A Door Unopened': '封印された門扉',
      'Hrodric Poisontongue': '直言のフロドリック',
      'Hydrosphere': 'ハイドロスフィア',
      'Kelpie': 'ケルピー',
      'The Golden Walls Of Ruin': 'テオドリックの黄金堂',
      'The Green Screams': 'ケルピーの縄張り',
      'The Old One': 'オールドワン'
    },
    'replaceText': {
      'Bloody Puddle': 'ブラッディパドル',
      'Bubble Burst': 'バブルバースト',
      'Circle Of Chaos': 'カオスサークル',
      'Cross Of Chaos': 'カオスクロス',
      'Eye Of The Fire': 'フィアーアイ',
      'Gallop': 'ギャロップ',
      'Hydro Pull': 'ハイドロプル',
      'Hydro Push': 'ハイドロプッシュ',
      'Mystic Flame': '魔光炎',
      'Mystic Light': '魔光線',
      'Order To Detonate': '自爆命令',
      'Ring Of Chaos': 'カオスリング',
      'Rising Seas': 'ライジングシー',
      'Rusting Claw': 'ラスティクロウ',
      'Self-Detonate': '爆発霧散',
      'Shifting Light': '変化光',
      'Tail Drive': 'テイルドライブ',
      'The Spin': 'トルネードスピン',
      'Torpedo': 'トルペド',
      'Words Of Woe': 'ワード・オブ・ウー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'A Door Unopened': '封闭的门扉',
      'Hrodric Poisontongue': '直言不讳 赫罗德里克',
      'Hydrosphere': '水化球体',
      'Kelpie': '凯尔派',
      'The Golden Walls Of Ruin': '黄金堂',
      'The Green Screams': '凯尔派的领地',
      'The Old One': '旧日灵偶'
    },
    'replaceText': {
      'Bloody Puddle': '血池',
      'Bubble Burst': '泡泡炸裂',
      'Circle Of Chaos': '混沌之圈',
      'Cross Of Chaos': '混沌十字',
      'Eye Of The Fire': '惧乱之眼',
      'Gallop': '飞驰',
      'Hydro Pull': '水力吸引',
      'Hydro Push': '水力推行',
      'Mystic Flame': '魔光炎',
      'Mystic Light': '魔光线',
      'Order To Detonate': '自爆命令',
      'Ring Of Chaos': '混沌之环',
      'Rising Seas': '水平面上升',
      'Rusting Claw': '锈爪',
      'Self-Detonate': '雾散爆发',
      'Shifting Light': '变化光',
      'Tail Drive': '尾部打击',
      'The Spin': '龙卷回旋',
      'Torpedo': '鱼雷',
      'Words Of Woe': '灾厄之语'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'A Door Unopened': '봉인된 문',
      'Hrodric Poisontongue': '입바른 흐로드릭',
      'Hydrosphere': '액체 구체',
      'Kelpie': '켈피',
      'The Golden Walls Of Ruin': '테오도리크의 보물고',
      'The Green Screams': '켈피의 영역',
      'The Old One': '옛 존재'
    },
    'replaceText': {
      'Bloody Puddle': '피 웅덩이',
      'Bubble Burst': '거품 작렬',
      'Circle Of Chaos': '혼돈의 원',
      'Cross Of Chaos': '혼돈의 십자가',
      'Eye Of The Fire': '공포의 눈동자',
      'Gallop': '습보',
      'Hydro Pull': '수력 당기기',
      'Hydro Push': '수력 밀치기',
      'Mystic Flame': '마광염',
      'Mystic Light': '마광선',
      'Order To Detonate': '자폭 명령',
      'Ring Of Chaos': '혼돈의 고리',
      'Rising Seas': '솟구치는 바다',
      'Rusting Claw': '녹슨 발톱',
      'Self-Detonate': '자가폭발',
      'Shifting Light': '변화광',
      'Tail Drive': '꼬리쓸기',
      'The Spin': '대회전',
      'Torpedo': '뒷발질',
      'Words Of Woe': '비통한 외침'
    }
  }]
};
/* harmony default export */ const drowned_city_of_skalla = (drowned_city_of_skalla_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/drowned_city_of_skalla.txt
const dungeon_drowned_city_of_skalla_namespaceObject = "#Drowned City of Skalla\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~#\r\n# Kelpie #\r\n#~~~~~~~~#\r\n\r\n# -ii 2655\r\n\r\n# The Green Screams will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"93A\" } window 0,1\r\n7.4 \"Torpedo\" Ability { id: \"264F\", source: \"Kelpie\" } window 7.4,5\r\n15.0 \"Rising Seas\" Ability { id: \"2650\", source: \"Kelpie\" }\r\n26.7 \"Gallop\" Ability { id: \"2653\", source: \"Kelpie\" }\r\n37.0 \"Hydro Pull/Hydro Push\" Ability { id: [\"2651\", \"2652\"], source: \"Kelpie\" }\r\n43.5 \"Torpedo\" Ability { id: \"264F\", source: \"Kelpie\" }\r\n51.1 \"Rising Seas\" Ability { id: \"2650\", source: \"Kelpie\" }\r\n62.7 \"Bloody Puddle\" Ability { id: \"2654\", source: \"Kelpie\" }\r\n65.9 \"Gallop\" Ability { id: \"2653\", source: \"Kelpie\" } window 20,20\r\n73.9 \"Bubble Burst\" Ability { id: \"261B\", source: \"Hydrosphere\" }\r\n76.2 \"Hydro Pull/Hydro Push\" Ability { id: [\"2651\", \"2652\"], source: \"Kelpie\" }\r\n92.6 \"Rising Seas\" Ability { id: \"2650\", source: \"Kelpie\" }\r\n\r\n# A near-perfect 50-second rotation\r\n102.2 \"Torpedo\" Ability { id: \"264F\", source: \"Kelpie\" } window 20,20\r\n107.8 \"Rising Seas\" Ability { id: \"2650\", source: \"Kelpie\" }\r\n117.3 \"Bloody Puddle\" Ability { id: \"2654\", source: \"Kelpie\" }\r\n120.5 \"Gallop\" Ability { id: \"2653\", source: \"Kelpie\" }\r\n128.6 \"Bubble Burst\" Ability { id: \"261B\", source: \"Hydrosphere\" }\r\n130.7 \"Hydro Pull/Hydro Push\" Ability { id: [\"2651\", \"2652\"], source: \"Kelpie\" }\r\n\r\n152.2 \"Torpedo\" Ability { id: \"264F\", source: \"Kelpie\" } window 20,20 jump 102.2\r\n157.8 \"Rising Seas\"\r\n167.3 \"Bloody Puddle\"\r\n170.5 \"Gallop\"\r\n178.6 \"Bubble Burst\"\r\n180.7 \"Hydro Push/Hydro Pull\"\r\n\r\n#~~~~~~~~~~~~~#\r\n# The Old One #\r\n#~~~~~~~~~~~~~#\r\n\r\n# -ii 2659\r\n\r\n\r\n\r\n# A Door Unopened will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"93C\" } window 1000,5\r\n1009.2 \"Mystic Light\" Ability { id: \"2657\", source: \"The Old One\" }\r\n1015.0 \"Mystic Flame\" Ability { id: \"2658\", source: \"The Old One\" }\r\n1018.1 \"Order To Detonate (cast)\" StartsUsing { id: \"265B\", source: \"The Old One\" } duration 19.7 window 18.1,5\r\n1037.8 \"Order To Detonate?\" # Ability { id: \"265B\", source: \"The Old One\" }\r\n1040.6 \"Self-Detonate?\" # Ability { id: \"265C\", source: \"Subservient\" }\r\n1047.7 \"Mystic Flame\" Ability { id: \"2658\", source: \"The Old One\" } window 20,20\r\n1058.8 \"Mystic Light\" Ability { id: \"2657\", source: \"The Old One\" }\r\n1074.7 \"Mystic Flame\" Ability { id: \"2658\", source: \"The Old One\" } jump 1047.7\r\n1085.8 \"Mystic Light\"\r\n1101.7 \"Mystic Flame\"\r\n1112.8 \"Mystic Light\"\r\n1128.7 \"Mystic Flame\"\r\n1139.8 \"Mystic Light\"\r\n\r\n1200.0 \"--sync--\" StartsUsing { id: \"265A\", source: \"The Old One\" } window 200,10\r\n1202.7 \"Shifting Light\" Ability { id: \"265A\", source: \"The Old One\" }\r\n1205.8 \"Order To Detonate (cast)\" StartsUsing { id: \"265B\", source: \"The Old One\" } duration 19.7\r\n# 1225.5 \"Order To Detonate?\" Ability { id: \"265B\", source: \"The Old One\" }\r\n1228.3 \"Self-Detonate?\" # Ability { id: \"265C\", source: \"Subservient\" }\r\n1232.6 \"--sync--\" StartsUsing { id: \"2657\", source: \"The Old One\" } window 32.6,5\r\n1236.3 \"Mystic Light\" Ability { id: \"2657\", source: \"The Old One\" }\r\n1244.1 \"Mystic Flame\" Ability { id: \"2658\", source: \"The Old One\" }\r\n1252.2 \"Mystic Light\" Ability { id: \"2657\", source: \"The Old One\" }\r\n1269.0 \"Mystic Light\" Ability { id: \"2657\", source: \"The Old One\" } jump 1236.3\r\n1276.8 \"Mystic Flame\"\r\n1284.9 \"Mystic Light\"\r\n1301.7 \"Mystic Light\"\r\n1309.5 \"Mystic Flame\"\r\n1317.6 \"Mystic Light\"\r\n\r\n1400.0 \"--sync--\" StartsUsing { id: \"265A\", source: \"The Old One\" } window 190,5\r\n1402.7 \"Shifting Light\" Ability { id: \"265A\", source: \"The Old One\" }\r\n1405.8 \"Order To Detonate (cast)\" StartsUsing { id: \"265B\", source: \"The Old One\" } duration 19.7\r\n# 1425.5 \"Order To Detonate?\" Ability { id: \"265B\", source: \"The Old One\" }\r\n1428.3 \"Self-Detonate?\" # Ability { id: \"265C\", source: \"Subservient\" }\r\n1432.6 \"--sync--\" StartsUsing { id: \"2657\", source: \"The Old One\" } window 32.6,5\r\n1436.3 \"Mystic Light\" Ability { id: \"2657\", source: \"The Old One\" }\r\n1444.1 \"Mystic Flame\" Ability { id: \"2658\", source: \"The Old One\" }\r\n1452.2 \"Mystic Light\" Ability { id: \"2657\", source: \"The Old One\" }\r\n1469.0 \"Mystic Light\" Ability { id: \"2657\", source: \"The Old One\" } jump 1436.3\r\n1476.8 \"Mystic Flame\"\r\n1484.9 \"Mystic Light\"\r\n1501.7 \"Mystic Light\"\r\n1509.5 \"Mystic Flame\"\r\n1517.6 \"Mystic Light\"\r\n\r\n#~~~~~~~~~~~~~~~~~~~~~~#\r\n# Hrodric Poisontongue #\r\n#~~~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# The Golden Walls of Ruin will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"93E\" } window 2000,5\r\n2012.6 \"Rusting Claw\" Ability { id: \"2661\", source: \"Hrodric Poisontongue\" } window 2012.6,0\r\n2026.2 \"Tail Drive\" Ability { id: \"2663\", source: \"Hrodric Poisontongue\" }\r\n2035.9 \"The Spin\" Ability { id: \"2664\", source: \"Hrodric Poisontongue\" } window 35.9,5\r\n2041.6 \"--sync--\" Ability { id: \"2666\", source: \"Hrodric Poisontongue\" }\r\n2046.7 \"Ring Of Chaos\" Ability { id: \"2667\", source: \"Hrodric Poisontongue\" }\r\n2052.2 \"Eye Of The Fire\" Ability { id: \"2665\", source: \"Hrodric Poisontongue\" } window 2052.2,10\r\n2057.9 \"--sync--\" Ability { id: \"2666\", source: \"Hrodric Poisontongue\" }\r\n2063.0 \"Cross Of Chaos/Circle Of Chaos\" Ability { id: [\"2668\", \"2669\"], source: \"Hrodric Poisontongue\" }\r\n2068.7 \"Words Of Woe\" Ability { id: \"2662\", source: \"Hrodric Poisontongue\" }\r\n2074.4 \"Words Of Woe\" Ability { id: \"2662\", source: \"Hrodric Poisontongue\" }\r\n2080.2 \"Words Of Woe\" Ability { id: \"2662\", source: \"Hrodric Poisontongue\" }\r\n2087.9 \"--sync--\" Ability { id: \"2666\", source: \"Hrodric Poisontongue\" } window 15,2.5 # Solo/duo runners will see only one or two lasers\r\n\r\n2093.0 \"Ring Of Chaos/Cross Of Chaos\" Ability { id: [\"2667\", \"2668\"], source: \"Hrodric Poisontongue\" }\r\n2095.5 \"--sync--\" Ability { id: \"2666\", source: \"Hrodric Poisontongue\" }\r\n2100.6 \"Ring Of Chaos\" Ability { id: \"2667\", source: \"Hrodric Poisontongue\" }\r\n2103.0 \"Tail Drive\" Ability { id: \"2663\", source: \"Hrodric Poisontongue\" }\r\n2115.6 \"The Spin\" Ability { id: \"2664\", source: \"Hrodric Poisontongue\" } window 30,30\r\n2126.3 \"Rusting Claw\" Ability { id: \"2661\", source: \"Hrodric Poisontongue\" }\r\n2132.0 \"--sync--\" Ability { id: \"2666\", source: \"Hrodric Poisontongue\" }\r\n2137.1 \"Cross Of Chaos/Circle Of Chaos\" Ability { id: [\"2668\", \"2669\"], source: \"Hrodric Poisontongue\" }\r\n2139.6 \"--sync--\" Ability { id: \"2666\", source: \"Hrodric Poisontongue\" }\r\n2144.7 \"Ring Of Chaos\" Ability { id: \"2667\", source: \"Hrodric Poisontongue\" }\r\n2145.2 \"Eye Of The Fire\" Ability { id: \"2665\", source: \"Hrodric Poisontongue\" } window 30,30\r\n2155.8 \"Rusting Claw\" Ability { id: \"2661\", source: \"Hrodric Poisontongue\" }\r\n2166.4 \"Tail Drive\" Ability { id: \"2663\", source: \"Hrodric Poisontongue\" }\r\n2174.1 \"--sync--\" Ability { id: \"2666\", source: \"Hrodric Poisontongue\" }\r\n2179.2 \"Ring Of Chaos/Circle Of Chaos\" Ability { id: [\"2667\", \"2669\"], source: \"Hrodric Poisontongue\" }\r\n2181.7 \"--sync--\" Ability { id: \"2666\", source: \"Hrodric Poisontongue\" }\r\n2186.8 \"Cross Of Chaos\" Ability { id: \"2668\", source: \"Hrodric Poisontongue\" }\r\n2187.5 \"Words Of Woe\" Ability { id: \"2662\", source: \"Hrodric Poisontongue\" }\r\n2195.2 \"--sync--\" Ability { id: \"2666\", source: \"Hrodric Poisontongue\" }\r\n\r\n2200.3 \"Ring Of Chaos/Cross Of Chaos\" Ability { id: [\"2667\", \"2668\"], source: \"Hrodric Poisontongue\" } jump 2093\r\n2202.8 \"--sync--\"\r\n2207.9 \"Ring Of Chaos\"\r\n2210.3 \"Tail Drive\"\r\n2222.9 \"The Spin\"\r\n2233.6 \"Rusting Claw\"\r\n\r\n\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/fractal_continuum_hard.ts



const fractal_continuum_hard_triggerSet = {
  id: 'TheFractalContinuumHard',
  zoneId: zone_id/* default.TheFractalContinuumHard */.Z.TheFractalContinuumHard,
  timelineFile: 'fractal_continuum_hard.txt',
  timelineTriggers: [{
    // Technically this one has a cast time, but it's less than a GCD.
    // Safer to warn via timeline.
    id: 'Fractal Hard Diffractive Laser',
    regex: /Diffractive Laser/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }],
  triggers: [{
    id: 'Fractal Hard Swipe Servo',
    type: 'StartsUsing',
    netRegex: {
      id: '2AE5',
      source: 'Servomechanical Minotaur',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'swipe',
        de: 'Hieb',
        fr: 'Fauche',
        ja: 'スワイプ',
        cn: '去目标背后',
        ko: '전방 피하기'
      }
    }
  }, {
    id: 'Fractal Hard Swipe Bio',
    type: 'StartsUsing',
    netRegex: {
      id: '29A2',
      source: 'Biomanufactured Minotaur',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'swipe',
        de: 'Hieb',
        fr: 'Fauche',
        ja: 'スワイプ',
        cn: '去目标背后',
        ko: '전방 피하기'
      }
    }
  }, {
    id: 'Fractal Hard Swing Servo',
    type: 'StartsUsing',
    netRegex: {
      id: '2AE4',
      source: 'Servomechanical Minotaur',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Swing',
        de: 'Schwung',
        fr: 'Swing',
        ja: 'スウィング',
        cn: '远离目标',
        ko: '밖으로'
      }
    }
  }, {
    id: 'Fractal Hard Swing Bio',
    type: 'StartsUsing',
    netRegex: {
      id: '29A1',
      source: 'Biomanufactured Minotaur',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Swing',
        de: 'Schwung',
        fr: 'Swing',
        ja: 'スウィング',
        cn: '远离目标',
        ko: '밖으로'
      }
    }
  }, {
    id: 'Fractal Hard Dragon Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '861',
      source: 'Servomechanical Chimera',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dragon\'s Voice',
        de: 'Stimme Des Drachen',
        fr: 'Voix Du Dragon',
        ja: '雷電の咆哮',
        cn: '靠近奇美拉',
        ko: '뇌전의 포효'
      }
    }
  }, {
    id: 'Fractal Hard Ram Voice Servo',
    type: 'StartsUsing',
    netRegex: {
      id: '860',
      source: 'Servomechanical Chimera',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Ram\'s Voice',
        de: 'Stimme Des Widders',
        fr: 'Voix Du Bélier',
        ja: '氷結の咆哮',
        cn: '远离奇美拉',
        ko: '빙결의 포효'
      }
    }
  }, {
    id: 'Fractal Hard Ram Voice Proto',
    type: 'StartsUsing',
    netRegex: {
      id: '860',
      source: 'Proto-Chimera',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Ram\'s Voice',
        de: 'Stimme Des Widders',
        fr: 'Voix Du Bélier',
        ja: '氷結の咆哮',
        cn: '远离奇美拉',
        ko: '빙결의 포효'
      }
    }
  }, {
    id: 'Fractal Hard Citadel Buster Motherbit',
    type: 'StartsUsing',
    netRegex: {
      id: '27A5',
      source: 'Motherbit',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Fractal Hard Aetheroplasm',
    type: 'StartsUsing',
    netRegex: {
      id: '2793',
      source: 'The Ultima Warrior'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Fractal Hard Citadel Buster Warrior',
    type: 'StartsUsing',
    netRegex: {
      id: '2792',
      source: 'The Ultima Warrior',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Fractal Hard Ceruleum Vent',
    type: 'StartsUsing',
    netRegex: {
      id: '2794',
      source: 'The Ultima Warrior',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Fractal Hard Ratzon',
    type: 'HeadMarker',
    netRegex: {
      id: '0046'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Puddle on YOU',
        de: 'Fläche auf DIR',
        fr: 'Zone au sol sur VOUS',
        ja: '自分に円範囲',
        cn: '圈圈点名',
        ko: '나에게 장판'
      }
    }
  }, {
    id: 'Fractal Hard Dischord Collect',
    type: 'HeadMarker',
    netRegex: {
      id: ['004D', '004E']
    },
    run: (data, matches) => {
      data.dischord ??= {};
      data.dischord[matches.id] = matches.target;
    }
  }, {
    id: 'Fractal Hard Dischord Resolve',
    type: 'HeadMarker',
    netRegex: {
      id: ['004D', '004E']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 0.5,
    infoText: (data, matches, output) => {
      const partnerId = matches.id === '004D' ? '004E' : '004D';
      // If for some reason there is no partner, we get a vulnerability or bleed and are sad.
      const partner = data.dischord?.[partnerId];
      if (partner === undefined) return;
      return output.text({
        player: data.party.member(partner)
      });
    },
    outputStrings: {
      text: {
        en: 'Stack with ${player}',
        de: 'Sammeln mit ${player}',
        fr: 'Packez-vous avec ${player}',
        ja: '${player}と頭割り',
        cn: '靠近${player}集合',
        ko: '${player} 쉐어징'
      }
    }
  }, {
    id: 'Fractal Hard Dischord Cleanup',
    type: 'HeadMarker',
    netRegex: {
      id: ['004D', '004F'],
      capture: false
    },
    delaySeconds: 2,
    suppressSeconds: 2,
    run: data => {
      delete data.dischord;
    }
  }, {
    id: 'Fractal Hard Mass Aetheroplasm',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    // 477 is Infinite Fire, 478 is Infinite Ice
    id: 'Fractal Hard Infinite Elements',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['477', '478']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // The circles don't come up until the Ceruleum Vent cast.
    // Rather than doing collection nonsense to be used on the Ceruleum cast,
    // it's better to just delay, since it's always a consistent 8 seconds
    // from the time effects are applied until the circles come up.
    delaySeconds: 8,
    infoText: (_data, matches, output) => {
      if (matches.effectId === '477') return output.standOnRedCircle();
      return output.standOnBlueCircle();
    },
    outputStrings: {
      standOnRedCircle: {
        en: 'Stand on red circle',
        de: 'Im roten Kreis stehen',
        fr: 'Restez dans le cercle rouge',
        ja: '赤い輪に',
        cn: '站在红圈',
        ko: '빨간 원 밟기'
      },
      standOnBlueCircle: {
        en: 'Stand on blue circle',
        de: 'Im blauen Kreis stehen',
        fr: 'Restez dans le cercle bleu',
        ja: '青い輪に',
        cn: '站在蓝圈',
        ko: '파란 원 밟기'
      }
    }
  }, {
    id: 'Fractal Hard Death Spin',
    type: 'StartsUsing',
    netRegex: {
      id: ['27AD', '27AE'],
      source: 'The Ultima Beast',
      capture: false
    },
    response: responses/* Responses.outOfMelee */.n3.outOfMelee()
  }, {
    id: 'Fractal Hard Aether Bend',
    type: 'StartsUsing',
    netRegex: {
      id: ['27AF', '27B0'],
      source: 'The Ultima Beast',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Fractal Hard Allagan Gravity',
    type: 'StartsUsing',
    netRegex: {
      id: '27B5',
      source: 'The Ultima Beast',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Fractal Hard Demi Ultima',
    type: 'StartsUsing',
    netRegex: {
      id: '27B2',
      source: 'The Ultima Beast',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Fractal Hard Allagan Flare',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    response: responses/* Responses.awayFrom */.n3.awayFrom()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Exhibit level VIII': 'Ausstellungssektor VIII',
      'Motherbit': 'Mutterdrohne',
      'Prototype Bit': 'Drohnen-Prototyp',
      'Successfully mimicking the Demon Zurvan': 'Modell Zurvan (Patent 42) wird angewendet',
      'The Genesis Engine': 'Testkammer',
      'The Ultima Beast': 'ultimativ(?:e|er|es|en) Bestie',
      'The Ultima Warrior': 'ultimativ(?:e|er|es|en) Krieger',
      'The reality augmentation bay': 'Dilatationskammer',
      'This humanoid prototype can perfectly replicate': 'Als Referenz wurde die Kraft der Ikonen herangezogen',
      'Utilizing our data on Sophia': 'Nun folgt die Emulierung von Sophia',
      'Vocal Guidance System': 'Stimmleitsystem',
      'Servomechanical Minotaur': 'servomechanisch(?:e|er|es|en) Minotaurus',
      'Servomechanical Chimera': 'servomechanisch(?:e|er|es|en) Chimära',
      'Proto-Chimera': 'Proto-Chimära',
      'Biomanufactured Minotaur': 'Biotech-Minotaurus'
    },
    'replaceText': {
      'Aether Bend': 'Ätherbeugung',
      'Aetherochemical Laser': 'Ätherochemischer Laser',
      '(?<! )Aetheroplasm': 'Ätheroplasma',
      'Allagan Flare': 'Allagisches Flare',
      'Allagan Gravity': 'Allagische Schwerkraft',
      'Ceruleum Vent': 'Erdseim-Entlüfter',
      'Citadel Buster': 'Zitadellensprenger',
      'Death Spin': 'Strudel des Todes',
      'Demi Ultima': 'Demi-Ultima',
      'Diffractive Laser': 'Diffraktiver Laser',
      'Dischordant Cleansing': 'Dissonante Buße',
      'Electrochemical Transfer': 'Elektrochemischer Transfer',
      'Flare Star': 'Flare-Stern',
      'Forborn Beast': 'Verwilderung',
      'Infinite Fire': 'Endloses Feuer',
      'Infinite Ice': 'Endloses Eis',
      'Light Pillar': 'Lichtsäule',
      'Mass Aetheroplasm': 'Massives Ätheroplasma',
      'Northern Star': 'Nordstern',
      'Primordial Aether': 'Ur-Äther',
      'Ratzon': 'Ratzon',
      'Southern Star': 'Südstern'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Exhibit level VIII': 'Secteur d\'exposition VIII',
      'Motherbit': 'drone mère',
      'Prototype Bit': 'proto-drone',
      'Successfully mimicking the Demon Zurvan': 'La restitution des techniques de Zurvan',
      'The Genesis Engine': 'Salle d\'expérimentation',
      'The Ultima Beast': 'Ultima-monstre',
      'The Ultima Warrior': 'Ultima-guerrier',
      'The reality augmentation bay': 'Salle de distorsion de la réalité',
      'This humanoid prototype can perfectly replicate': 'Ce modèle exceptionnel est basé sur les non moins exceptionnelles divinités guerrières',
      'Utilizing our data on Sophia': 'Quoi de mieux pour dominer les divinités guerrières que de retourner leur puissance contre elles?♪',
      'Vocal Guidance System': 'système de guidage vocal',
      'Servomechanical Minotaur': 'minotaure servomécanique',
      'Servomechanical Chimera': 'chimère servomécanique',
      'Proto-Chimera': 'protochimère',
      'Biomanufactured Minotaur': 'minotaure biologique'
    },
    'replaceText': {
      'Aether Bend': 'Diffraction éthérée',
      'Aetherochemical Laser': 'Laser magismologique',
      '(?<! )Aetheroplasm': 'Éthéroplasma',
      'Allagan Flare': 'Brasier allagois',
      'Allagan Gravity': 'Gravité allagoise',
      'Ceruleum Vent': 'Exutoire à céruleum',
      'Citadel Buster': 'Casse-citadelle',
      'Death Spin': 'Tourbillon mortel',
      'Demi Ultima': 'Demi-Ultima',
      'Diffractive Laser': 'Laser diffractif',
      'Dischordant Cleansing': 'Purification discordante',
      'Electrochemical Transfer': 'Charge éléctro-chimique',
      'Flare Star': 'Astre flamboyant',
      'Forborn Beast': 'Bête ancestrale',
      'Infinite Fire': 'Feu infini',
      'Infinite Ice': 'Glace infinie',
      'Light Pillar': 'Colonne lumineuse',
      'Mass Aetheroplasm': 'Éthéroplasma géant',
      'Northern Star': 'Étoile du nord',
      'Primordial Aether': 'Éther primordial',
      'Ratzon': 'Ratzon',
      'Southern Star': 'Étoile du sud'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Exhibit level VIII': '第VIII展示区',
      'Motherbit': 'マザービット',
      'Prototype Bit': 'プロトビット',
      'Successfully mimicking the Demon Zurvan': '鬼神ズルワーン',
      'The Genesis Engine': '起動試験室',
      'The Ultima Beast': 'アルテマビースト',
      'The Ultima Warrior': 'アルテマウォリアー',
      'The reality augmentation bay': '現実拡張室',
      'This humanoid prototype can perfectly replicate': 'そこで考案されたのが、',
      'Utilizing our data on Sophia': '闘神の力を以て、闘神を征す♪',
      'Vocal Guidance System': '音声ガイダンス',
      'Servomechanical Minotaur': 'サーヴォ・ミノタウロス',
      'Servomechanical Chimera': 'サーヴォ・キマイラ',
      'Proto-Chimera': 'プロトキマイラ',
      'Biomanufactured Minotaur': 'バイオ・ミノタウロス'
    },
    'replaceText': {
      'Aether Bend': 'エーテルベント',
      'Aetherochemical Laser': '魔科学レーザー',
      '(?<! )Aetheroplasm': 'エーテル爆雷',
      'Allagan Flare': 'アラガンフレア',
      'Allagan Gravity': 'アラガングラビデ',
      'Ceruleum Vent': 'セルレアムベント',
      'Citadel Buster': 'シタデルバスター',
      'Death Spin': 'デススピン',
      'Demi Ultima': 'デミアルテマ',
      'Diffractive Laser': '拡散レーザー',
      'Dischordant Cleansing': '不調和の罰',
      'Electrochemical Transfer': '雷力供給',
      'Flare Star': 'フレアスター',
      'Forborn Beast': 'アクワイヤードビースト',
      'Infinite Fire': '炎の刻印',
      'Infinite Ice': '氷の刻印',
      'Light Pillar': 'リヒト・ゾイレ',
      'Mass Aetheroplasm': '大型エーテル爆雷',
      'Northern Star': 'ノーザンスター',
      'Primordial Aether': 'プライマルエーテル',
      'Ratzon': 'ラツォン',
      'Southern Star': 'サザンスター'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Exhibit level VIII': '第八展示区',
      'Motherbit': '浮游炮主板',
      'Prototype Bit': '原型浮游炮',
      'Successfully mimicking the Demon Zurvan': '随着对鬼神祖尔宛力量的应用，',
      'The Genesis Engine': '启动试验室',
      'The Ultima Beast': '究极神兽',
      'The Ultima Warrior': '究极战士',
      'The reality augmentation bay': '现实增强室',
      'This humanoid prototype can perfectly replicate': '我们研究出了如何利用斗神力量的方法！',
      'Utilizing our data on Sophia': '利用斗神的力量去征服斗神！',
      'Vocal Guidance System': '语音向导',
      'Servomechanical Minotaur': '自控化弥诺陶洛斯',
      'Servomechanical Chimera': '自控化奇美拉',
      'Proto-Chimera': '原型奇美拉',
      'Biomanufactured Minotaur': '生化弥诺陶洛斯'
    },
    'replaceText': {
      'Aether Bend': '以太曲折',
      'Aetherochemical Laser': '魔科学激光',
      '(?<! )Aetheroplasm': '以太爆雷',
      'Allagan Flare': '亚拉戈核爆',
      'Allagan Gravity': '亚拉戈重力',
      'Ceruleum Vent': '青磷放射',
      'Citadel Buster': '攻城炮',
      'Death Spin': '死亡回旋',
      'Demi Ultima': '亚究极',
      'Diffractive Laser': '扩散射线',
      'Dischordant Cleansing': '不平衡之罚',
      'Electrochemical Transfer': '雷力供给',
      'Flare Star': '耀星',
      'Forborn Beast': '后天野兽',
      'Infinite Fire': '炎之刻印',
      'Infinite Ice': '冰之刻印',
      'Light Pillar': '光柱',
      'Mass Aetheroplasm': '大型以太爆雷',
      'Northern Star': '北极星',
      'Primordial Aether': '荒蛮以太',
      'Ratzon': '意志',
      'Southern Star': '南极星'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Exhibit level VIII': '제VIII전시구역',
      'Motherbit': '마더 비트',
      'Prototype Bit': '프로토 비트',
      'Successfully mimicking the Demon Zurvan': '연구자들은 귀신 주르반',
      'The Genesis Engine': '기동시험실',
      'The Ultima Beast': '알테마 비스트',
      'The Ultima Warrior': '알테마 워리어',
      'The reality augmentation bay': '현실확장실',
      'This humanoid prototype can perfectly replicate': '그래서 투신의 힘을 이용하는',
      'Utilizing our data on Sophia': '투신의 힘으로 투신을 다스린다♪',
      'Vocal Guidance System': '음성 안내 시스템',
      'Servomechanical Minotaur': '자동제어 미노타우로스',
      'Servomechanical Chimera': '자동제어 키마이라',
      'Proto-Chimera': '프로토 키마이라',
      'Biomanufactured Minotaur': '양산체 미노타우로스'
    },
    'replaceText': {
      'Aether Bend': '에테르 굴절',
      'Aetherochemical Laser': '마과학 레이저',
      '(?<! )Aetheroplasm': '에테르 폭뢰',
      'Allagan Flare': '알라그 플레어',
      'Allagan Gravity': '알라그 그라비데',
      'Ceruleum Vent': '청린 방출',
      'Citadel Buster': '공성포',
      'Death Spin': '죽음의 회전',
      'Demi Ultima': '데미알테마',
      'Diffractive Laser': '확산 레이저',
      'Dischordant Cleansing': '부조화의 벌',
      'Electrochemical Transfer': '뇌력 공급',
      'Flare Star': '타오르는 별',
      'Forborn Beast': '야수 각성',
      'Infinite Fire': '불의 각인',
      'Infinite Ice': '얼음의 각인',
      'Light Pillar': '빛 기둥',
      'Mass Aetheroplasm': '대형 에테르 폭뢰',
      'Northern Star': '북극성',
      'Primordial Aether': '야만신 에테르',
      'Ratzon': '라촌',
      'Southern Star': '남극성'
    }
  }]
};
/* harmony default export */ const fractal_continuum_hard = (fractal_continuum_hard_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/fractal_continuum_hard.txt
const dungeon_fractal_continuum_hard_namespaceObject = "### FRACTAL CONTINUUM (HARD)\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~~~#\r\n# MOTHERBIT #\r\n#~~~~~~~~~~~#\r\n\r\n# -ii 27A3 27A7 27A9\r\n\r\n# Reality Augmentation Bay will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"612\" }\r\n\r\n10.1 \"Electrochemical Transfer\" Ability { id: \"27A4\", source: \"Motherbit\" } window 11,5\r\n15.7 \"--sync--\" Ability { id: \"27AB\", source: \"Prototype Bit\" }\r\n18.8 \"Aetherochemical Laser\" # Ability { id: \"27AA\", source: \"Prototype Bit\" }\r\n20.1 \"Diffractive Laser\" Ability { id: \"27A8\", source: \"Prototype Bit\" }\r\n20.7 \"--sync--\" Ability { id: \"27AB\", source: \"Prototype Bit\" }\r\n22.8 \"Aetherochemical Laser\" # Ability { id: \"27AA\", source: \"Prototype Bit\" }\r\n29.8 \"Allagan Gravity\" Ability { id: \"27A6\", source: \"Motherbit\" }\r\n\r\n37.9 \"Electrochemical Transfer\" Ability { id: \"27A4\", source: \"Motherbit\" }\r\n43.5 \"--sync--\" Ability { id: \"27AB\", source: \"Prototype Bit\" }\r\n54.2 \"Citadel Buster\" Ability { id: \"27A5\", source: \"Motherbit\" } window 30,30\r\n\r\n77.9 \"Electrochemical Transfer\" Ability { id: \"27A4\", source: \"Motherbit\" } jump 10.1\r\n86.6 \"Aetherochemical Laser\"\r\n87.9 \"Diffractive Laser\"\r\n90.6 \"Aetherochemical Laser\"\r\n97.6 \"Allagan Gravity\"\r\n105.7 \"Electrochemical Transfer\"\r\n\r\n#~~~~~~~~~~~~~~~~~~~~#\r\n# THE ULTIMA WARRIOR #\r\n#~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 2798\r\n\r\n# Unfortunately, we have no choice but to use BattleTalk2 lines here.\r\n# The statues the boss tethers to are useless for timeline syncs,\r\n# and the boss gains no buffs for each form.\r\n\r\n# Each form is guaranteed to cycle once in three rounds,\r\n# but it is possible to have the same form back-to-back,\r\n# if the end of a round lines up with the beginning of the next.\r\n# That is, Sephirot->Sophia->Zurvan can immediately be followed by Zurvan->Sophia->Sephirot.\r\n\r\n# Each form has a set amount of dead time before announcing the next one.\r\n# That is, for Form X into whatever, the dead time is determined solely by X,\r\n# regardless of whether X is followed by Y or by Z.\r\n\r\n# Because the BattleTalk2 syncs are repeated below, the links and 'en' text are listed once:\r\n# https://xivapi.com/InstanceContentTextData/18509 (0x484D)\r\n# en: This humanoid prototype can perfectly replicate eikon abilities. In fact, it's already loading our data on Sephirot.\r\n# https://xivapi.com/InstanceContentTextData/18510 (0x484E)\r\n# en: Utilizing our data on Sophia, we can at last tip the scales in our favor.\r\n# https://xivapi.com/InstanceContentTextData/18511 (0x484F)\r\n# en: Successfully mimicking the Demon Zurvan earned our researchers a patent under article 42? <buzzzzzz>\r\n\r\n# Exhibit Level VIII will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"95D\" } window 1000,5\r\n1008.5 \"Aetheroplasm\" Ability { id: \"2793\", source: \"The Ultima Warrior\" } window 8.5,5\r\n1018.9 \"Citadel Buster\" Ability { id: \"2792\", source: \"The Ultima Warrior\" }\r\n1029.8 \"Ceruleum Vent\" Ability { id: \"2794\", source: \"The Ultima Warrior\" }\r\n1042.0 \"Aetheroplasm\" Ability { id: \"2793\", source: \"The Ultima Warrior\" } # skipped if boss is at or below 95% HP\r\n\r\n1053.4 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484D\" } window 53.4,10 jump 1100\r\n1053.4 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484E\" } window 53.4,10 jump 1200\r\n1053.4 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484F\" } window 53.4,10 jump 1300\r\n1060.9 \"Primordial Aether\"\r\n1062.0 \"Ceruleum Vent?\"\r\n1063.5 \"Infinite Fire/Infinite Ice?\"\r\n1071.5 \"Ceruleum Vent?\"\r\n1072.5 \"Citadel Buster?\"\r\n1073.5 \"Ratzon?\"\r\n1078.6 \"Citadel Buster?\"\r\n\r\n\r\n# Sephirot's block\r\n\r\n1100.0 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484D\" }\r\n1107.5 \"Primordial Aether\" Ability { id: \"2796\", source: \"The Ultima Warrior\" } window 10,10\r\n1119.1 \"Citadel Buster\" Ability { id: \"2792\", source: \"The Ultima Warrior\" }\r\n1120.1 \"Ratzon\" Ability { id: \"2797\", source: \"The Ultima Warrior\" }\r\n1125.2 \"Citadel Buster\" Ability { id: \"2792\", source: \"The Ultima Warrior\" }\r\n1139.2 \"Mass Aetheroplasm\" Ability { id: \"2795\", source: \"The Ultima Warrior\" }\r\n1149.7 \"Aetheroplasm\" Ability { id: \"2793\", source: \"The Ultima Warrior\" }\r\n\r\n1154.8 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484D\" } window 50,10 jump 1100\r\n1154.8 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484E\" } window 50,10 jump 1200\r\n1154.8 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484F\" } window 50,10 jump 1300\r\n1162.3 \"Primordial Aether\"\r\n1163.4 \"Ceruleum Vent?\"\r\n1164.9 \"Infinite Fire/Infinite Ice?\"\r\n1172.9 \"Ceruleum Vent?\"\r\n1173.9 \"Citadel Buster?\"\r\n1174.9 \"Ratzon?\"\r\n1180.0 \"Citadel Buster?\"\r\n\r\n\r\n# Sophia's Block\r\n\r\n1200.0 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484E\" }\r\n1207.5 \"Primordial Aether\" Ability { id: \"2796\", source: \"The Ultima Warrior\" } window 10,10\r\n1218.1 \"Ceruleum Vent\" Ability { id: \"2794\", source: \"The Ultima Warrior\" }\r\n1225.3 \"Citadel Buster\" Ability { id: \"2792\", source: \"The Ultima Warrior\" }\r\n1226.3 \"Dischordant Cleansing\" Ability { id: \"279C\", source: \"The Ultima Warrior\" }\r\n1231.4 \"Citadel Buster\" Ability { id: \"2792\", source: \"The Ultima Warrior\" }\r\n1232.3 \"Dischordant Cleansing\" Ability { id: \"279A\", source: \"The Ultima Warrior\" }\r\n1242.3 \"Aetheroplasm\" Ability { id: \"2793\", source: \"The Ultima Warrior\" }\r\n\r\n1248.5 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484D\" } window 50,10 jump 1100\r\n1248.5 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484E\" } window 50,10 jump 1200\r\n1248.5 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484F\" } window 50,10 jump 1300\r\n1256.0 \"Primordial Aether\"\r\n1257.1 \"Ceruleum Vent?\"\r\n1258.6 \"Infinite Fire/Infinite Ice?\"\r\n1266.6 \"Ceruleum Vent?\"\r\n1267.6 \"Citadel Buster?\"\r\n1268.6 \"Ratzon?\"\r\n1273.7 \"Citadel Buster?\"\r\n\r\n\r\n# Zurvan's Block\r\n\r\n1300.0 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484F\" }\r\n1308.5 \"Primordial Aether\" Ability { id: \"2796\", source: \"The Ultima Warrior\" } window 10,10\r\n1311.1 \"Infinite Fire/Infinite Ice\" Ability { id: \"279[DE]\", source: \"The Ultima Warrior\" }\r\n1319.1 \"Ceruleum Vent\" Ability { id: \"2794\", source: \"The Ultima Warrior\" }\r\n1330.3 \"Northern Star/Southern Star\" Ability { id: \"27A[01]\", source: \"The Ultima Warrior\" }\r\n1336.4 \"Mass Aetheroplasm\" Ability { id: \"2795\", source: \"The Ultima Warrior\" }\r\n1343.0 \"Citadel Buster\" Ability { id: \"2792\", source: \"The Ultima Warrior\" }\r\n1354.0 \"Aetheroplasm\" Ability { id: \"2793\", source: \"The Ultima Warrior\" }\r\n\r\n1365.5 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484D\" } window 50,10 jump 1100\r\n1365.5 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484E\" } window 50,10 jump 1200\r\n1365.5 \"--sync--\" BattleTalk2 { instanceContentTextId: \"484F\" } window 50,10 jump 1300\r\n1373.0 \"Primordial Aether\"\r\n1374.1 \"Ceruleum Vent?\"\r\n1375.6 \"Infinite Fire/Infinite Ice?\"\r\n1383.6 \"Ceruleum Vent?\"\r\n1384.6 \"Citadel Buster?\"\r\n1385.6 \"Ratzon?\"\r\n1390.7 \"Citadel Buster?\"\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~#\r\n# THE ULTIMA BEAST #\r\n#~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 27B9 27BC 27BA 27BB\r\n\r\n# Genesis Engine will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"95E\" } window 2000,5\r\n2012.0 \"Death Spin\" Ability { id: \"27AD\", source: \"The Ultima Beast\" } window 12,5\r\n2025.6 \"Aether Bend\" Ability { id: \"27AF\", source: \"The Ultima Beast\" }\r\n2035.2 \"--sync--\" Ability { id: \"27B6\", source: \"The Ultima Beast\" }\r\n2044.1 \"Flare Star\" Ability { id: \"27BD\", source: \"The Ultima Beast\" }\r\n2044.3 \"Allagan Gravity\" Ability { id: \"27B5\", source: \"The Ultima Beast\" } window 30,30\r\n2057.9 \"Light Pillar\" Ability { id: \"27B7\", source: \"The Ultima Beast\" }\r\n2076.5 \"Forborn Beast\" Ability { id: \"27B1\", source: \"The Ultima Beast\" } window 76.5,5\r\n2085.0 \"Demi Ultima\" Ability { id: \"27B2\", source: \"The Ultima Beast\" }\r\n2102.9 \"Aether Bend/Death Spin\" Ability { id: \"27(AD|B0)\", source: \"The Ultima Beast\" }\r\n2113.4 \"--sync--\" Ability { id: \"27B4\", source: \"The Ultima Beast\" }\r\n2115.4 \"Allagan Flare\" Ability { id: \"27B8\", source: \"The Ultima Beast\" }\r\n\r\n2128.0 \"--sync--\" Ability { id: \"27B6\", source: \"The Ultima Beast\" } window 30,30\r\n2136.9 \"Flare Star\" Ability { id: \"27BD\", source: \"The Ultima Beast\" }\r\n2141.5 \"--sync--\" Ability { id: \"27B4\", source: \"The Ultima Beast\" }\r\n2143.5 \"Allagan Flare\" Ability { id: \"27B8\", source: \"The Ultima Beast\" }\r\n2158.1 \"Aether Bend/Death Spin\" Ability { id: \"27(AD|B0)\", source: \"The Ultima Beast\" }\r\n2168.7 \"Light Pillar\" Ability { id: \"27B7\", source: \"The Ultima Beast\" }\r\n2176.7 \"Allagan Gravity\" Ability { id: \"27B5\", source: \"The Ultima Beast\" }\r\n\r\n2196.2 \"--sync--\" Ability { id: \"27B6\", source: \"The Ultima Beast\" } window 30,30 jump 2128\r\n2205.1 \"Flare Star\"\r\n2211.7 \"Allagan Flare\"\r\n2226.3 \"Aether Bend/Death Spin\"\r\n\r\n\r\n3000.0 \"--sync--\" StartsUsing { id: \"27B3\", source: \"The Ultima Beast\" } window 1000,5\r\n3039.7 \"Demi Ultima (Enrage)\" Ability { id: \"27B3\", source: \"The Ultima Beast\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/ghimlyt_dark.ts



const ghimlyt_dark_triggerSet = {
  id: 'TheGhimlytDark',
  zoneId: zone_id/* default.TheGhimlytDark */.Z.TheGhimlytDark,
  timelineFile: 'ghimlyt_dark.txt',
  timelineTriggers: [{
    id: 'Ghimlyt Dark Prometheus Laser',
    regex: /Heat/,
    beforeSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid wall laser',
        de: 'Weiche dem Wand-Laser aus',
        fr: 'Évitez le laser du mur',
        ja: 'レーザーを避ける',
        cn: '躲避墙壁激光',
        ko: '벽 레이저 피하기'
      }
    }
  }],
  triggers: [{
    id: 'Ghimlyt Dark Jarring Blow',
    type: 'StartsUsing',
    netRegex: {
      id: '376E',
      source: 'Mark III-B Magitek Colossus'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ghimlyt Dark Wild Fire Beam',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Ghimlyt Dark Ceruleum Vent',
    type: 'StartsUsing',
    netRegex: {
      id: '3773',
      source: 'Mark III-B Magitek Colossus',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Ghimlyt Dark Magitek Ray',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    // 00A7 is the orange clockwise indicator. 00A8 is the blue counterclockwise one.
    id: 'Ghimlyt Dark Magitek Slash',
    type: 'HeadMarker',
    netRegex: {
      id: ['00A7', '00A8']
    },
    infoText: (_data, matches, output) => matches.id === '00A7' ? output.left() : output.right(),
    outputStrings: {
      left: {
        en: 'Rotate left',
        de: 'Nach links rotieren',
        fr: 'Tournez vers la gauche',
        ja: '左回転',
        cn: '向左转',
        ko: '왼쪽으로 회전'
      },
      right: {
        en: 'Rotate right',
        de: 'Nach rechts rotieren',
        fr: 'Tournez vers la droite',
        ja: '右回転',
        cn: '向右转',
        ko: '오른쪽으로 회전'
      }
    }
  }, {
    id: 'Ghimlyt Dark Nitrospin',
    type: 'StartsUsing',
    netRegex: {
      id: '3455',
      source: 'Prometheus',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Ghimlyt Dark Cermet Drill',
    type: 'StartsUsing',
    netRegex: {
      id: '3459',
      source: 'Prometheus'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ghimlyt Dark Freezing Missile',
    type: 'StartsUsing',
    netRegex: {
      id: '345C',
      source: 'Prometheus',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'Ghimlyt Dark Artifical Plasma',
    type: 'StartsUsing',
    netRegex: {
      id: '3727',
      source: 'Julia Quo Soranus',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Ghimlyt Dark Innocence',
    type: 'StartsUsing',
    netRegex: {
      id: '3729',
      source: 'Julia Quo Soranus'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ghimlyt Dark Delta Trance',
    type: 'StartsUsing',
    netRegex: {
      id: '372A',
      source: 'Annia Quo Soranus'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    // This head marker is used on players and NPCs, so we have to exclude NPCs explicitly.
    id: 'Ghimlyt Dark Heirsbane',
    type: 'HeadMarker',
    netRegex: {
      id: '0001'
    },
    condition: (_data, matches) => !matches.targetId.startsWith('4'),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ghimlyt Dark Order To Bombard',
    type: 'Ability',
    netRegex: {
      id: '3710',
      source: 'Annia Quo Soranus',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Ghimlyt Dark Covering Fire',
    type: 'HeadMarker',
    netRegex: {
      id: '0078'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Annia Quo Soranus': 'Annia quo Soranus',
      'Ceruleum Tank': 'Erdseim-Tank',
      'Julia Quo Soranus': 'Julia quo Soranus',
      'Mark III-B Magitek Colossus': 'Magitek-Stahlriese',
      'Prometheus': 'Prometheus',
      'Soranus Duo': 'tödlich(?:e|er|es|en) Schwesternpaar Julia und Annia',
      'The Field Of Dust': 'Feld des Staubs',
      'The Impact Crater': 'Bombenkrater',
      'The Provisional Imperial Landing': 'Provisorischer Landeplatz'
    },
    'replaceText': {
      '\\(windup\\)': '(Vorbereitung)',
      '\\(cast\\)': '(Wirkung)',
      'Aglaia Bite': 'Aglaia-Biss',
      'Angry Salamander': 'Zorniger Salamander',
      'Artificial Boost': 'Magitek-Verstärker',
      'Artificial Plasma': 'Magitek-Plasma',
      'Bombardment': 'Bombardement',
      'Burst': 'Explosion',
      'Ceruleum Vent': 'Erdseim-Entlüfter',
      'Commence Air Strike': 'Abwurfbefehl',
      'Covering Fire': 'Artillerieangriff',
      'Crossbones': 'Totenschädel',
      'Crosshatch': 'Kreuzmanöver',
      'Delta Trance': 'Delta-Trance',
      'Exhaust': 'Exhaustor',
      'Freezing Missile': 'Frostrakete',
      'Heat': 'Hitzestrahl',
      'Heirsbane': 'Erbenbann',
      'Imperial Authority': 'Imperiale Autorität',
      'Innocence': 'Unschuld',
      'Jarring Blow': 'Harter Aufschlag',
      'Magitek Ray': 'Magitek-Laser',
      'Magitek Slash': 'Magitek-Schlag',
      'Missile Impact': 'Raketenangriff',
      'Needle Gun': 'Nadelgewitter',
      'Nitrospin': 'Nitroturbine',
      'Oil Shower': 'Kerosindusche',
      'Order To Bombard': 'Bombardierungsbefehl',
      'Order To Fire': 'Feuerbefehl',
      'Order To Support': 'Artilleriebefehl',
      'Quaternity': 'Verwertung',
      'Roundhouse': 'Rückhandschlag',
      'Stunning Sweep': 'Blitzfeger',
      'The Order': 'Befehl',
      'Tunnel': 'Tauchgang',
      'Unbreakable Cermet Drill': 'Verstärkter Cermet-Bohrer',
      'Wild Fire Beam': 'Diffuser Feuerstrahl'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Annia Quo Soranus': 'Annia quo Soranus',
      'Ceruleum Tank': 'réservoir de céruleum',
      'Julia Quo Soranus': 'Julia quo Soranus',
      'Mark III-B Magitek Colossus': 'colosse magitek IIIB',
      'Prometheus': 'Prometheus',
      'Soranus Duo': 'duo Soranus',
      'The Field Of Dust': 'Champ de poussière',
      'The Impact Crater': 'Gigantesque cratère',
      'The Provisional Imperial Landing': 'Aire d\'atterrissage provisoire'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(windup\\)': '(préparation)',
      '\\(cast\\)': '(lancement)',
      'Aglaia Bite': 'Morsure d\'Aglaia',
      'Angry Salamander': 'Colère de la salamandre',
      'Artificial Boost': 'Amplificateur magitek',
      'Artificial Plasma': 'Plasma magitek',
      'Bombardment': 'Bombardement',
      'Burst': 'Explosion',
      'Ceruleum Vent': 'Exutoire à céruleum',
      'Commence Air Strike': 'Largage de matériel',
      'Covering Fire': 'Tir de couverture',
      'Crossbones': 'Tête de mort',
      'Crosshatch': 'Croisillons',
      'Delta Trance': 'Transe delta',
      'Exhaust': 'Échappement',
      'Freezing Missile': 'Missile cryogène',
      'Heat': 'Rayons infrarouges',
      'Heirsbane': 'Fléau de l\'héritier',
      'Imperial Authority': 'Autorité impériale',
      'Innocence': 'Innocence',
      'Jarring Blow': 'Impact redoutable',
      'Magitek Ray': 'Rayon magitek',
      'Magitek Slash': 'Taillade magitek',
      'Missile Impact': 'Frappe de missile',
      'Needle Gun': 'Pistolet à clous',
      'Nitrospin': 'Nitrotourbillon',
      'Oil Shower': 'Pluie de kérosène',
      'Order To Bombard': 'Ordre de bombardement',
      'Order To Fire': 'Ordre d\'attaquer',
      'Order To Support': 'Demande d\'appui',
      'Quaternity': 'Équarrissage',
      'Roundhouse': 'Crochet',
      'Stunning Sweep': 'Balayette étourdissante',
      'The Order': 'Directive',
      'Tunnel': 'Enfouissement',
      'Unbreakable Cermet Drill': 'Foret en cermet renforcé',
      'Wild Fire Beam': 'Rayon de feu diffusé'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Annia Quo Soranus': 'アンニア・クォ・ソラノス',
      'Ceruleum Tank': '青燐水タンク',
      'Julia Quo Soranus': 'ユリア・クォ・ソラノス',
      'Mark III-B Magitek Colossus': '魔導コロッサスIIIB型',
      'Prometheus': 'プロメテウス',
      'Soranus Duo': 'ユリア＆アンニア ',
      'The Field Of Dust': '薄汚れた広場',
      'The Impact Crater': '巨大爆撃痕',
      'The Provisional Imperial Landing': '帝国軍仮設ランディング'
    },
    'replaceText': {
      '\\(windup\\)': '(発射)',
      '\\(cast\\)': '(着弾)',
      'Aglaia Bite': 'アグライアバイト',
      'Angry Salamander': '炎獣心火撃',
      'Artificial Boost': '魔導ブースター',
      'Artificial Plasma': '魔導プラズマ',
      'Bombardment': '爆撃',
      'Burst': '爆発',
      'Ceruleum Vent': 'セルレアムベント',
      'Commence Air Strike': '投下要請',
      'Covering Fire': '援護射撃',
      'Crossbones': 'クロスボーン',
      'Crosshatch': 'クロスハッチ',
      'Delta Trance': 'デルタトランス',
      'Exhaust': 'エグゾースト',
      'Freezing Missile': '冷凍ミサイル',
      'Heat': '熱線',
      'Heirsbane': 'No.IX',
      'Imperial Authority': 'インペリアルオーソリティ',
      'Innocence': 'イノセンス',
      'Jarring Blow': 'ハードヒット',
      'Magitek Ray': '魔導レーザー',
      'Magitek Slash': 'マジテックスラッシュ',
      'Missile Impact': 'ミサイル攻撃',
      'Needle Gun': 'ニードルガン',
      'Nitrospin': 'ニトロスピン',
      'Oil Shower': 'ケロシンシャワー',
      'Order To Bombard': '爆撃命令',
      'Order To Fire': '攻撃命令',
      'Order To Support': '援護命令',
      'Quaternity': 'クォターニティ',
      'Roundhouse': '無尽旋風斬',
      'Stunning Sweep': '雷光水面蹴',
      'The Order': 'オーダー',
      'Tunnel': '潜航',
      'Unbreakable Cermet Drill': '超硬サーメットドリル',
      'Wild Fire Beam': '拡散ファイアビーム'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Annia Quo Soranus': '安妮亚・库奥・索拉努斯',
      'Ceruleum Tank': '青磷水罐',
      'Julia Quo Soranus': '茱莉亚・库奥・索拉努斯',
      'Mark III-B Magitek Colossus': '魔导巨兵三型B式',
      'Prometheus': '普罗米修斯',
      'Soranus Duo': '茱莉亚&安妮亚',
      'The Field Of Dust': '破乱的广场',
      'The Impact Crater': '大爆炸痕迹',
      'The Provisional Imperial Landing': '帝国临时飞艇坪'
    },
    'replaceText': {
      '\\(windup\\)': '(发射)',
      '\\(cast\\)': '(判定)',
      'Aglaia Bite': '典雅女神枪',
      'Angry Salamander': '炎兽心火击',
      'Artificial Boost': '魔导增幅器',
      'Artificial Plasma': '魔导离子',
      'Bombardment': '轰炸',
      'Burst': '爆炸',
      'Ceruleum Vent': '青磷放射',
      'Commence Air Strike': '请求投放',
      'Covering Fire': '掩护射击',
      'Crossbones': '剔骨十字',
      'Crosshatch': '交叉冲击',
      'Delta Trance': '三角迷失斩',
      'Exhaust': '排气',
      'Freezing Missile': '冷冻导弹',
      'Heat': '射线',
      'Heirsbane': '遗祸',
      'Imperial Authority': '帝国权威',
      'Innocence': '无罪斩',
      'Jarring Blow': '沉重一击',
      'Magitek Ray': '魔导激光',
      'Magitek Slash': '魔导斩',
      'Missile Impact': '导弹攻击',
      'Needle Gun': '飞针枪',
      'Nitrospin': '爆炸回旋',
      'Oil Shower': '黄雨',
      'Order To Bombard': '轰炸命令',
      'Order To Fire': '攻击命令',
      'Order To Support': '掩护命令',
      'Quaternity': '四位一体',
      'Roundhouse': '无尽旋风斩',
      'Stunning Sweep': '雷光水面踢',
      'The Order': '下令',
      'Tunnel': '潜航',
      'Unbreakable Cermet Drill': '超硬陶瓷合金钻头',
      'Wild Fire Beam': '扩散火焰光束'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Annia Quo Soranus': '안니아 쿠오 소라누스',
      'Ceruleum Tank': '청린수 탱크',
      'Julia Quo Soranus': '율리아 쿠오 소라누스',
      'Mark III-B Magitek Colossus': '마도 콜로서스 III-B형',
      'Prometheus': '프로메테우스',
      'Soranus Duo': '율리아와 안니아',
      'The Field Of Dust': '먼지투성이 광장',
      'The Impact Crater': '거대한 폭격 흔적',
      'The Provisional Imperial Landing': '제국군 가설 비행장'
    },
    'replaceText': {
      'Aglaia Bite': '아글라이아 쌍격',
      'Angry Salamander': '맹수화염격',
      'Artificial Boost': '마도 부스터',
      'Artificial Plasma': '마도 플라스마',
      'Bombardment': '폭격',
      'Burst': '폭발',
      'Ceruleum Vent': '청린 방출',
      'Commence Air Strike': '투하 요청',
      'Covering Fire': '지원 사격',
      'Crossbones': '십자베기',
      'Crosshatch': '십자선',
      'Delta Trance': '무아삼각권',
      'Exhaust': '고갈',
      'Freezing Missile': '냉동 미사일',
      'Heat': '열선',
      'Heirsbane': '제IX호',
      'Imperial Authority': '제국의 권위',
      'Innocence': '순수',
      'Jarring Blow': '단단한 공격',
      'Magitek Ray': '마도 레이저',
      'Magitek Slash': '마도 참격',
      'Missile Impact': '미사일 공격',
      'Needle Gun': '바늘총',
      'Nitrospin': '니트로 회전',
      'Oil Shower': '기름 세례',
      'Order To Bombard': '폭격 명령',
      'Order To Fire': '공격 명령',
      'Order To Support': '지원 명령',
      'Quaternity': '사위일체',
      'Roundhouse': '종횡질풍참',
      'Stunning Sweep': '뇌광수면축',
      'The Order': '명령',
      'Tunnel': '잠항',
      'Unbreakable Cermet Drill': '초경도 합금 드릴',
      'Wild Fire Beam': '확산 화염 광선'
    }
  }]
};
/* harmony default export */ const ghimlyt_dark = (ghimlyt_dark_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/ghimlyt_dark.txt
const dungeon_ghimlyt_dark_namespaceObject = "### THE GHIMLYT DARK\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~~~~~~~~~~#\r\n# MAGITEK COLOSSUS #\r\n#~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 394F 3775\r\n\r\n# The Field of Dust will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"AB8\" } window 0,1\r\n12.9 \"Jarring Blow\" Ability { id: \"376E\", source: \"Mark III-B Magitek Colossus\" }\r\n15.0 \"--sync--\" Ability { id: \"3771\", source: \"Mark III-B Magitek Colossus\" }\r\n22.1 \"Wild Fire Beam\" Ability { id: \"3772\", source: \"Mark III-B Magitek Colossus\" } window 30,30\r\n28.8 \"Magitek Slash x5\" Ability { id: \"3774\", source: \"Mark III-B Magitek Colossus\" } duration 8\r\n45.5 \"Exhaust\" Ability { id: \"3770\", source: \"Mark III-B Magitek Colossus\" }\r\n55.7 \"Ceruleum Vent\" Ability { id: \"3773\", source: \"Mark III-B Magitek Colossus\" }\r\n\r\n68.0 \"Magitek Slash x5\" Ability { id: \"3774\", source: \"Mark III-B Magitek Colossus\" } duration 8\r\n80.2 \"Magitek Slash x5\" Ability { id: \"3774\", source: \"Mark III-B Magitek Colossus\" } duration 8\r\n97.4 \"Magitek Ray\" Ability { id: \"376F\", source: \"Mark III-B Magitek Colossus\" }\r\n102.6 \"Exhaust\" Ability { id: \"3770\", source: \"Mark III-B Magitek Colossus\" }\r\n116.8 \"Ceruleum Vent\" Ability { id: \"3773\", source: \"Mark III-B Magitek Colossus\" } window 20,20\r\n120.0 \"--sync--\" Ability { id: \"3771\", source: \"Mark III-B Magitek Colossus\" }\r\n127.1 \"Wild Fire Beam\" Ability { id: \"3772\", source: \"Mark III-B Magitek Colossus\" }\r\n133.1 \"Magitek Ray\" Ability { id: \"376F\", source: \"Mark III-B Magitek Colossus\" }\r\n138.3 \"Exhaust\" Ability { id: \"3770\", source: \"Mark III-B Magitek Colossus\" }\r\n143.7 \"Exhaust\" Ability { id: \"3770\", source: \"Mark III-B Magitek Colossus\" }\r\n156.0 \"Jarring Blow\" Ability { id: \"376E\", source: \"Mark III-B Magitek Colossus\" } window 30,30\r\n162.1 \"Ceruleum Vent\" Ability { id: \"3773\", source: \"Mark III-B Magitek Colossus\" }\r\n169.3 \"Ceruleum Vent\" Ability { id: \"3773\", source: \"Mark III-B Magitek Colossus\" }\r\n\r\n176.5 \"Magitek Slash x5\" Ability { id: \"3774\", source: \"Mark III-B Magitek Colossus\" } jump 68\r\n188.7 \"Magitek Slash x5\"\r\n205.9 \"Magitek Ray\"\r\n211.1 \"Exhaust\"\r\n\r\n#~~~~~~~~~~~~#\r\n# PROMETHEUS #\r\n#~~~~~~~~~~~~#\r\n\r\n# Unfortunately there are no log lines for when Prometheus fires after using Heat.\r\n\r\n# -ic \"Lyse\" \"Pipin Of The Steel Heart\" \"Schola Centurion\" \"Schola Laquearius\" \"Schola Signifer\"\r\n# -ii 3AC6\r\n\r\n# Impact Crater will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"ABB\" } window 1000,1\r\n1012.2 \"Nitrospin\" Ability { id: \"3455\", source: \"Prometheus\" }\r\n1023.4 \"Needle Gun\" Ability { id: \"345A\", source: \"Prometheus\" }\r\n1031.1 \"--untargetable--\"\r\n1031.2 \"Tunnel\" Ability { id: \"3457\", source: \"Prometheus\" } window 31.2,5\r\n1042.8 \"Heat\" duration 4 # Ability { id: \"3458\", source: \"Prometheus\" }\r\n1048.0 \"--targetable--\"\r\n\r\n1056.2 \"Unbreakable Cermet Drill\" Ability { id: \"3459\", source: \"Prometheus\" } window 30,30\r\n1068.3 \"Needle Gun\" Ability { id: \"345A\", source: \"Prometheus\" }\r\n1075.4 \"Needle Gun/Oil Shower\" Ability { id: [\"345A\", \"3456\"], source: \"Prometheus\" }\r\n1086.4 \"Nitrospin\" Ability { id: \"3455\", source: \"Prometheus\" }\r\n1097.8 \"Freezing Missile (windup)\" Ability { id: \"345B\", source: \"Prometheus\" }\r\n1100.4 \"--untargetable--\"\r\n1100.5 \"Tunnel\" Ability { id: \"3457\", source: \"Prometheus\" } window 30,30\r\n1108.9 \"Freezing Missile (cast)\" Ability { id: \"345C\", source: \"Prometheus\" }\r\n1113.1 \"Heat\" duration 4 # Ability { id: \"3458\", source: \"Prometheus\" }\r\n1118.2 \"--targetable--\"\r\n\r\n1131.5 \"Unbreakable Cermet Drill\" Ability { id: \"3459\", source: \"Prometheus\" } jump 1056.2\r\n1143.6 \"Needle Gun\"\r\n1150.7 \"Needle Gun/Oil Shower\"\r\n1161.9 \"Nitrospin\"\r\n\r\n\r\n#~~~~~~~~~~~~~#\r\n# SORANUS DUO #\r\n#~~~~~~~~~~~~~#\r\n\r\n# Provisional Imperial Landing will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"ABD\" } window 2000,5\r\n2000.4 \"--sync--\" Ability { id: \"370F\", source: \"Annia Quo Soranus\" } jump 2097\r\n2000.4 \"--sync--\" Ability { id: \"370E\", source: \"Julia Quo Soranus\" } jump 2297\r\n2003.4 \"Artificial Plasma?\"\r\n2010.6 \"Heirsbane?\"\r\n2011.6 \"Angry Salamander?\"\r\n2011.8 \"Innocence?\"\r\n2013.5 \"Delta Trance?\"\r\n2018.2 \"Heirsbane?\"\r\n2020.9 \"Commence Air Strike?\"\r\n\r\n\r\n# Julia active\r\n\r\n2097.0 \"--sync--\" Ability { id: \"370F\", source: \"Annia Quo Soranus\" }\r\n2100.0 \"Artificial Plasma\" Ability { id: \"3727\", source: \"Julia Quo Soranus\" }\r\n2108.2 \"Angry Salamander\" # Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2108.4 \"Innocence\" Ability { id: \"3729\", source: \"Julia Quo Soranus\" }\r\n2117.5 \"Commence Air Strike\" Ability { id: \"3716\", source: \"Julia Quo Soranus\" }\r\n2119.3 \"--sync--\" Ability { id: \"370E\", source: \"Julia Quo Soranus\" }\r\n2121.8 \"Roundhouse\" Ability { id: \"3718\", source: \"Annia Quo Soranus\" }\r\n\r\n# We have to sync widely here because if Julia is first she skips one Aglaia Bite.\r\n2124.7 \"Heirsbane\" Ability { id: \"3719\", source: \"Julia Quo Soranus\" } window 15,15\r\n2127.6 \"Burst x5\" duration 8 # Ability { id: \"371A\", source: \"Ceruleum Tank\" }\r\n2132.3 \"Angry Salamander\" Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2145.2 \"Artificial Plasma\" Ability { id: \"3727\", source: \"Julia Quo Soranus\" }\r\n2147.9 \"Angry Salamander\" Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2151.4 \"--sync--\" Ability { id: \"370E\", source: \"Julia Quo Soranus\" }\r\n\r\n# During the rotation block, we can't sync Aglaia Bite,\r\n# since the double usage is just too close together.\r\n2153.2 \"The Order\" Ability { id: \"3713\", source: \"Julia Quo Soranus\" } window 30,30\r\n2158.3 \"Order To Fire\" Ability { id: \"372D\", source: \"Annia Quo Soranus\" }\r\n2158.3 \"Missile Impact\" Ability { id: \"372E\", source: \"Annia Quo Soranus\" }\r\n2159.3 \"The Order\" Ability { id: \"39BA\", source: \"Julia Quo Soranus\" }\r\n2159.3 \"Quaternity\" Ability { id: \"3989\", source: \"Soranus Duo\" }\r\n2164.6 \"Artificial Plasma\" Ability { id: \"3727\", source: \"Julia Quo Soranus\" }\r\n2168.8 \"Angry Salamander\" Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2174.9 \"Artificial Plasma\" Ability { id: \"3727\", source: \"Julia Quo Soranus\" }\r\n2182.2 \"Angry Salamander\" Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2183.2 \"Innocence\" Ability { id: \"3729\", source: \"Julia Quo Soranus\" }\r\n2192.5 \"Commence Air Strike\" Ability { id: \"3716\", source: \"Julia Quo Soranus\" } window 30,30\r\n2194.1 \"--sync--\" Ability { id: \"370E\", source: \"Julia Quo Soranus\" }\r\n2194.8 \"Aglaia Bite\" # Ability { id: \"3717\", source: \"Annia Quo Soranus\" }\r\n2196.9 \"Aglaia Bite/Roundhouse\" # Ability { id: \"371[78]\", source: \"Annia Quo Soranus\" }\r\n2199.6 \"Heirsbane\" Ability { id: \"3719\", source: \"Julia Quo Soranus\" }\r\n2202.5 \"Burst x5\" duration 12 # Ability { id: \"371A\", source: \"Ceruleum Tank\" }\r\n2207.2 \"Angry Salamander\" Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2220.2 \"Artificial Plasma\" Ability { id: \"3727\", source: \"Julia Quo Soranus\" }\r\n2222.8 \"Angry Salamander\" Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2226.3 \"--sync--\" Ability { id: \"370E\", source: \"Julia Quo Soranus\" }\r\n\r\n2228.1 \"The Order\" Ability { id: \"3713\", source: \"Julia Quo Soranus\" } window 30,30 jump 2153.2\r\n2233.2 \"Order To Fire\"\r\n2233.2 \"Missile Impact\"\r\n2234.2 \"The Order\"\r\n2234.2 \"Quaternity\"\r\n2239.5 \"Artificial Plasma\"\r\n2243.7 \"Angry Salamander\"\r\n2249.8 \"Artificial Plasma\"\r\n2257.1 \"Angry Salamander\"\r\n2258.1 \"Innocence\"\r\n\r\n# Annia active\r\n\r\n2297.0 \"--sync--\" Ability { id: \"370E\", source: \"Julia Quo Soranus\" }\r\n2307.2 \"Heirsbane\" Ability { id: \"372B\", source: \"Julia Quo Soranus\" }\r\n2310.3 \"Delta Trance\" Ability { id: \"372A\", source: \"Annia Quo Soranus\" }\r\n2314.9 \"Heirsbane\" Ability { id: \"372B\", source: \"Julia Quo Soranus\" }\r\n2321.3 \"The Order\" Ability { id: \"3713\", source: \"Julia Quo Soranus\" }\r\n2325.1 \"Order To Bombard\" Ability { id: \"3710\", source: \"Annia Quo Soranus\" }\r\n2327.5 \"--sync--\" Ability { id: \"370F\", source: \"Annia Quo Soranus\" }\r\n\r\n2329.5 \"The Order\" Ability { id: \"3714\", source: \"Julia Quo Soranus\" } window 30,30\r\n2329.7 \"Crossbones\" Ability { id: \"3C80\", source: \"Soranus Duo\" }\r\n2331.6 \"Angry Salamander\" Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2332.4 \"Bombardment\" Ability { id: \"3711\", source: \"Annia Quo Soranus\" }\r\n2340.5 \"The Order\" Ability { id: \"3713\", source: \"Julia Quo Soranus\" }\r\n2341.9 \"Artificial Plasma\" Ability { id: \"3728\", source: \"Annia Quo Soranus\" }\r\n2347.1 \"Quaternity\" Ability { id: \"3733\", source: \"Soranus Duo\" }\r\n2347.1 \"The Order\" Ability { id: \"39BA\", source: \"Julia Quo Soranus\" } window 30,30\r\n2351.7 \"Delta Trance\" Ability { id: \"372A\", source: \"Annia Quo Soranus\" }\r\n2355.8 \"Heirsbane\" Ability { id: \"372B\", source: \"Julia Quo Soranus\" }\r\n2361.8 \"Stunning Sweep\" Ability { id: \"3712\", source: \"Annia Quo Soranus\" }\r\n2363.1 \"Heirsbane\" Ability { id: \"372B\", source: \"Julia Quo Soranus\" }\r\n2370.8 \"Artificial Plasma\" Ability { id: \"3728\", source: \"Annia Quo Soranus\" }\r\n2382.3 \"The Order\" Ability { id: \"3713\", source: \"Julia Quo Soranus\" }\r\n2386.1 \"Order To Bombard\" Ability { id: \"3710\", source: \"Annia Quo Soranus\" }\r\n2388.5 \"--sync--\" Ability { id: \"370F\", source: \"Annia Quo Soranus\" }\r\n\r\n2390.5 \"The Order\" Ability { id: \"3714\", source: \"Julia Quo Soranus\" } window 30,30 jump 2329.5\r\n2390.7 \"Crossbones\"\r\n2392.6 \"Angry Salamander\"\r\n2393.4 \"Bombardment\"\r\n2401.5 \"The Order\"\r\n2402.9 \"Artificial Plasma\"\r\n2408.1 \"Quaternity\"\r\n2408.1 \"The Order\"\r\n2412.7 \"Delta Trance\"\r\n2416.8 \"Heirsbane\"\r\n\r\n# Intermission\r\n\r\n# Order To Support and Covering Fire are only on the second intermission.\r\n\r\n\r\n2494.3 \"Order To Support\" Ability { id: \"371B\", source: \"Annia Quo Soranus\" } window 494.3,5\r\n2500.0 \"Crosshatch\" Ability { id: \"3721\", source: \"Soranus Duo\" } window 500,5\r\n2506.6 \"--sync--\" Ability { id: \"3723\", source: \"Annia Quo Soranus\" }\r\n2506.8 \"--sync--\" Ability { id: \"384B\", source: \"Julia Quo Soranus\" }\r\n2507.1 \"--sync--\" Ability { id: \"384C\", source: \"Annia Quo Soranus\" }\r\n2507.4 \"--sync--\" Ability { id: \"3724\", source: \"Julia Quo Soranus\" }\r\n2508.2 \"--sync--\" Ability { id: \"396A\", source: \"Annia Quo Soranus\" }\r\n2508.6 \"--sync--\" Ability { id: \"3969\", source: \"Julia Quo Soranus\" }\r\n2508.7 \"Crosshatch 1\" # Ability { id: \"3722\", source: \"Annia Quo Soranus\" }\r\n2508.9 \"Crosshatch 2\" # Ability { id: \"3722\", source: \"Julia Quo Soranus\" }\r\n2509.0 \"--sync--\" Ability { id: \"384D\", source: \"Annia Quo Soranus\" }\r\n2509.4 \"Covering Fire?\" Ability { id: \"371C\", source: \"Annia Quo Soranus\" }\r\n2509.4 \"Crosshatch 3\" # Ability { id: \"3722\", source: \"Annia Quo Soranus\" }\r\n2509.6 \"--sync--\" Ability { id: \"396B\", source: \"Julia Quo Soranus\" }\r\n2509.9 \"Crosshatch 4\" # Ability { id: \"3722\", source: \"Julia Quo Soranus\" }\r\n2511.1 \"Crosshatch 5\" # Ability { id: \"3722\", source: \"Annia Quo Soranus\" }\r\n2511.8 \"Crosshatch 6\" # Ability { id: \"3722\", source: \"Julia Quo Soranus\" }\r\n2512.3 \"Crosshatch 7\" # Ability { id: \"3722\", source: \"Annia Quo Soranus\" }\r\n2512.8 \"Crosshatch 8\" # Ability { id: \"3722\", source: \"Julia Quo Soranus\" }\r\n2515.9 \"--sync--\" Ability { id: \"3726\", source: \"Julia Quo Soranus\" }\r\n2516.0 \"--sync--\" Ability { id: \"3725\", source: \"Annia Quo Soranus\" }\r\n2519.0 \"--sync--\" Ability { id: \"370F\", source: \"Annia Quo Soranus\" } window 10,10 jump 2097\r\n2519.0 \"--sync--\" Ability { id: \"370E\", source: \"Julia Quo Soranus\" } window 10,10 jump 2297\r\n2522.4 \"Artificial Plasma?\"\r\n2529.6 \"Heirsbane?\"\r\n2530.6 \"Angry Salamander?\"\r\n2530.8 \"Innocence?\"\r\n2532.5 \"Delta Trance?\"\r\n2537.2 \"Heirsbane?\"\r\n2539.9 \"Commence Air Strike?\"\r\n\r\n# Enrage after two intermissions.\r\n\r\n# 2597.3 \"--sync--\" StartsUsing { id: \"372F\", source: \"Julia Quo Soranus\" } window 597.3\r\n2597.3 \"Artificial Boost\" StartsUsing { id: \"3730\", source: \"Annia Quo Soranus\" } window 597.3,0\r\n# 2600.0 \"--sync--\" Ability { id: \"372F\", source: \"Julia Quo Soranus\" } window 600,5\r\n2600.0 \"Artificial Boost\" Ability { id: \"3730\", source: \"Annia Quo Soranus\" } window 600,5\r\n# 2603.2 \"--sync--\" StartsUsing { id: \"3731\", source: \"Julia Quo Soranus\" }\r\n2603.2 \"Imperial Authority\" StartsUsing { id: \"3732\", source: \"Annia Quo Soranus\" } duration 39.7\r\n2642.9 \"Imperial Authority Enrage\" Ability { id: \"3732\", source: \"Annia Quo Soranus\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/ghimlyt_dark64.ts



const ghimlyt_dark64_triggerSet = {
  id: 'TheGhimlytDark64',
  zoneId: zone_id/* default.TheGhimlytDark64 */.Z.TheGhimlytDark64,
  timelineFile: 'ghimlyt_dark64.txt',
  timelineTriggers: [{
    id: 'Ghimlyt64 Prometheus Laser',
    regex: /Heat/,
    beforeSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid wall laser',
        de: 'Weiche dem Wand-Laser aus',
        fr: 'Évitez le laser du mur',
        ja: 'レーザーを避ける',
        cn: '躲避墙壁激光',
        ko: '벽 레이저 피하기'
      }
    }
  }],
  triggers: [{
    id: 'Ghimlyt64 Jarring Blow',
    type: 'StartsUsing',
    netRegex: {
      id: '376E',
      source: 'Mark III-B Magitek Colossus'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ghimlyt64 Wild Fire Beam',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Ghimlyt64 Ceruleum Vent',
    type: 'StartsUsing',
    netRegex: {
      id: '3773',
      source: 'Mark III-B Magitek Colossus',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Ghimlyt64 Magitek Ray',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    // 00A7 is the orange clockwise indicator. 00A8 is the blue counterclockwise one.
    id: 'Ghimlyt64 Magitek Slash',
    type: 'HeadMarker',
    netRegex: {
      id: ['00A7', '00A8']
    },
    infoText: (_data, matches, output) => matches.id === '00A7' ? output.left() : output.right(),
    outputStrings: {
      left: {
        en: 'Rotate left',
        de: 'Nach links rotieren',
        fr: 'Tournez vers la gauche',
        ja: '左回転',
        cn: '向左转',
        ko: '왼쪽으로 회전'
      },
      right: {
        en: 'Rotate right',
        de: 'Nach rechts rotieren',
        fr: 'Tournez vers la droite',
        ja: '右回転',
        cn: '向右转',
        ko: '오른쪽으로 회전'
      }
    }
  }, {
    id: 'Ghimlyt64 Nitrospin',
    type: 'StartsUsing',
    netRegex: {
      id: '3455',
      source: 'Prometheus',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Ghimlyt64 Cermet Drill',
    type: 'StartsUsing',
    netRegex: {
      id: '3459',
      source: 'Prometheus'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ghimlyt64 Freezing Missile',
    type: 'StartsUsing',
    netRegex: {
      id: '345C',
      source: 'Prometheus',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'Ghimlyt64 Artifical Plasma',
    type: 'StartsUsing',
    netRegex: {
      id: '3727',
      source: 'Julia Quo Soranus',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Ghimlyt64 Innocence',
    type: 'StartsUsing',
    netRegex: {
      id: '3729',
      source: 'Julia Quo Soranus'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ghimlyt64 Delta Trance',
    type: 'StartsUsing',
    netRegex: {
      id: '372A',
      source: 'Annia Quo Soranus'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    // This head marker is used on players and NPCs, so we have to exclude NPCs explicitly.
    id: 'Ghimlyt64 Heirsbane',
    type: 'HeadMarker',
    netRegex: {
      id: '0001'
    },
    condition: (_data, matches) => !matches.targetId.startsWith('4'),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ghimlyt64 Order To Bombard',
    type: 'Ability',
    netRegex: {
      id: '3710',
      source: 'Annia Quo Soranus',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Ghimlyt64 Covering Fire',
    type: 'HeadMarker',
    netRegex: {
      id: '0078'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Annia Quo Soranus': 'Annia quo Soranus',
      'Ceruleum Tank': 'Erdseim-Tank',
      'Julia Quo Soranus': 'Julia quo Soranus',
      'Mark III-B Magitek Colossus': 'Magitek-Stahlriese',
      'Prometheus': 'Prometheus',
      'Soranus Duo': 'tödlich(?:e|er|es|en) Schwesternpaar Julia und Annia',
      'The Field Of Dust': 'Feld des Staubs',
      'The Impact Crater': 'Bombenkrater',
      'The Provisional Imperial Landing': 'Provisorischer Landeplatz'
    },
    'replaceText': {
      '\\(windup\\)': '(Vorbereitung)',
      '\\(cast\\)': '(Wirkung)',
      'Aglaia Bite': 'Aglaia-Biss',
      'Angry Salamander': 'Zorniger Salamander',
      'Artificial Boost': 'Magitek-Verstärker',
      'Artificial Plasma': 'Magitek-Plasma',
      'Bombardment': 'Bombardement',
      'Burst': 'Explosion',
      'Ceruleum Vent': 'Erdseim-Entlüfter',
      'Commence Air Strike': 'Abwurfbefehl',
      'Covering Fire': 'Artillerieangriff',
      'Crossbones': 'Totenschädel',
      'Crosshatch': 'Kreuzmanöver',
      'Delta Trance': 'Delta-Trance',
      'Exhaust': 'Exhaustor',
      'Freezing Missile': 'Frostrakete',
      'Heat': 'Hitzestrahl',
      'Heirsbane': 'Erbenbann',
      'Imperial Authority': 'Imperiale Autorität',
      'Innocence': 'Unschuld',
      'Jarring Blow': 'Harter Aufschlag',
      'Magitek Ray': 'Magitek-Laser',
      'Magitek Slash': 'Magitek-Schlag',
      'Missile Impact': 'Raketenangriff',
      'Needle Gun': 'Nadelgewitter',
      'Nitrospin': 'Nitroturbine',
      'Oil Shower': 'Kerosindusche',
      'Order To Bombard': 'Bombardierungsbefehl',
      'Order To Fire': 'Feuerbefehl',
      'Order To Support': 'Artilleriebefehl',
      'Quaternity': 'Verwertung',
      'Roundhouse': 'Rückhandschlag',
      'Stunning Sweep': 'Blitzfeger',
      'The Order': 'Befehl',
      'Tunnel': 'Tauchgang',
      'Unbreakable Cermet Drill': 'Verstärkter Cermet-Bohrer',
      'Wild Fire Beam': 'Diffuser Feuerstrahl'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Annia Quo Soranus': 'Annia quo Soranus',
      'Ceruleum Tank': 'réservoir de céruleum',
      'Julia Quo Soranus': 'Julia quo Soranus',
      'Mark III-B Magitek Colossus': 'colosse magitek IIIB',
      'Prometheus': 'Prometheus',
      'Soranus Duo': 'duo Soranus',
      'The Field Of Dust': 'Champ de poussière',
      'The Impact Crater': 'Gigantesque cratère',
      'The Provisional Imperial Landing': 'Aire d\'atterrissage provisoire'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(windup\\)': '(préparation)',
      '\\(cast\\)': '(lancement)',
      'Aglaia Bite': 'Morsure d\'Aglaia',
      'Angry Salamander': 'Colère de la salamandre',
      'Artificial Boost': 'Amplificateur magitek',
      'Artificial Plasma': 'Plasma magitek',
      'Bombardment': 'Bombardement',
      'Burst': 'Explosion',
      'Ceruleum Vent': 'Exutoire à céruleum',
      'Commence Air Strike': 'Largage de matériel',
      'Covering Fire': 'Tir de couverture',
      'Crossbones': 'Tête de mort',
      'Crosshatch': 'Croisillons',
      'Delta Trance': 'Transe delta',
      'Exhaust': 'Échappement',
      'Freezing Missile': 'Missile cryogène',
      'Heat': 'Rayons infrarouges',
      'Heirsbane': 'Fléau de l\'héritier',
      'Imperial Authority': 'Autorité impériale',
      'Innocence': 'Innocence',
      'Jarring Blow': 'Impact redoutable',
      'Magitek Ray': 'Rayon magitek',
      'Magitek Slash': 'Taillade magitek',
      'Missile Impact': 'Frappe de missile',
      'Needle Gun': 'Pistolet à clous',
      'Nitrospin': 'Nitrotourbillon',
      'Oil Shower': 'Pluie de kérosène',
      'Order To Bombard': 'Ordre de bombardement',
      'Order To Fire': 'Ordre d\'attaquer',
      'Order To Support': 'Demande d\'appui',
      'Quaternity': 'Équarrissage',
      'Roundhouse': 'Crochet',
      'Stunning Sweep': 'Balayette étourdissante',
      'The Order': 'Directive',
      'Tunnel': 'Enfouissement',
      'Unbreakable Cermet Drill': 'Foret en cermet renforcé',
      'Wild Fire Beam': 'Rayon de feu diffusé'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Annia Quo Soranus': 'アンニア・クォ・ソラノス',
      'Ceruleum Tank': '青燐水タンク',
      'Julia Quo Soranus': 'ユリア・クォ・ソラノス',
      'Mark III-B Magitek Colossus': '魔導コロッサスIIIB型',
      'Prometheus': 'プロメテウス',
      'Soranus Duo': 'ユリア＆アンニア ',
      'The Field Of Dust': '薄汚れた広場',
      'The Impact Crater': '巨大爆撃痕',
      'The Provisional Imperial Landing': '帝国軍仮設ランディング'
    },
    'replaceText': {
      '\\(windup\\)': '(発射)',
      '\\(cast\\)': '(着弾)',
      'Aglaia Bite': 'アグライアバイト',
      'Angry Salamander': '炎獣心火撃',
      'Artificial Boost': '魔導ブースター',
      'Artificial Plasma': '魔導プラズマ',
      'Bombardment': '爆撃',
      'Burst': '爆発',
      'Ceruleum Vent': 'セルレアムベント',
      'Commence Air Strike': '投下要請',
      'Covering Fire': '援護射撃',
      'Crossbones': 'クロスボーン',
      'Crosshatch': 'クロスハッチ',
      'Delta Trance': 'デルタトランス',
      'Exhaust': 'エグゾースト',
      'Freezing Missile': '冷凍ミサイル',
      'Heat': '熱線',
      'Heirsbane': 'No.IX',
      'Imperial Authority': 'インペリアルオーソリティ',
      'Innocence': 'イノセンス',
      'Jarring Blow': 'ハードヒット',
      'Magitek Ray': '魔導レーザー',
      'Magitek Slash': 'マジテックスラッシュ',
      'Missile Impact': 'ミサイル攻撃',
      'Needle Gun': 'ニードルガン',
      'Nitrospin': 'ニトロスピン',
      'Oil Shower': 'ケロシンシャワー',
      'Order To Bombard': '爆撃命令',
      'Order To Fire': '攻撃命令',
      'Order To Support': '援護命令',
      'Quaternity': 'クォターニティ',
      'Roundhouse': '無尽旋風斬',
      'Stunning Sweep': '雷光水面蹴',
      'The Order': 'オーダー',
      'Tunnel': '潜航',
      'Unbreakable Cermet Drill': '超硬サーメットドリル',
      'Wild Fire Beam': '拡散ファイアビーム'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Annia Quo Soranus': '安妮亚・库奥・索拉努斯',
      'Ceruleum Tank': '青磷水罐',
      'Julia Quo Soranus': '茱莉亚・库奥・索拉努斯',
      'Mark III-B Magitek Colossus': '魔导巨兵三型B式',
      'Prometheus': '普罗米修斯',
      'Soranus Duo': '茱莉亚&安妮亚',
      'The Field Of Dust': '破乱的广场',
      'The Impact Crater': '大爆炸痕迹',
      'The Provisional Imperial Landing': '帝国临时飞艇坪'
    },
    'replaceText': {
      '\\(windup\\)': '(发射)',
      '\\(cast\\)': '(判定)',
      'Aglaia Bite': '典雅女神枪',
      'Angry Salamander': '炎兽心火击',
      'Artificial Boost': '魔导增幅器',
      'Artificial Plasma': '魔导离子',
      'Bombardment': '轰炸',
      'Burst': '爆炸',
      'Ceruleum Vent': '青磷放射',
      'Commence Air Strike': '请求投放',
      'Covering Fire': '掩护射击',
      'Crossbones': '剔骨十字',
      'Crosshatch': '交叉冲击',
      'Delta Trance': '三角迷失斩',
      'Exhaust': '排气',
      'Freezing Missile': '冷冻导弹',
      'Heat': '射线',
      'Heirsbane': '遗祸',
      'Imperial Authority': '帝国权威',
      'Innocence': '无罪斩',
      'Jarring Blow': '沉重一击',
      'Magitek Ray': '魔导激光',
      'Magitek Slash': '魔导斩',
      'Missile Impact': '导弹攻击',
      'Needle Gun': '飞针枪',
      'Nitrospin': '爆炸回旋',
      'Oil Shower': '黄雨',
      'Order To Bombard': '轰炸命令',
      'Order To Fire': '攻击命令',
      'Order To Support': '掩护命令',
      'Quaternity': '四位一体',
      'Roundhouse': '无尽旋风斩',
      'Stunning Sweep': '雷光水面踢',
      'The Order': '下令',
      'Tunnel': '潜航',
      'Unbreakable Cermet Drill': '超硬陶瓷合金钻头',
      'Wild Fire Beam': '扩散火焰光束'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Annia Quo Soranus': '안니아 쿠오 소라누스',
      'Ceruleum Tank': '청린수 탱크',
      'Julia Quo Soranus': '율리아 쿠오 소라누스',
      'Mark III-B Magitek Colossus': '마도 콜로서스 III-B형',
      'Prometheus': '프로메테우스',
      'Soranus Duo': '율리아와 안니아',
      'The Field Of Dust': '먼지투성이 광장',
      'The Impact Crater': '거대한 폭격 흔적',
      'The Provisional Imperial Landing': '제국군 가설 비행장'
    },
    'replaceText': {
      'Aglaia Bite': '아글라이아 쌍격',
      'Angry Salamander': '맹수화염격',
      'Artificial Boost': '마도 부스터',
      'Artificial Plasma': '마도 플라스마',
      'Bombardment': '폭격',
      'Burst': '폭발',
      'Ceruleum Vent': '청린 방출',
      'Commence Air Strike': '투하 요청',
      'Covering Fire': '지원 사격',
      'Crossbones': '십자베기',
      'Crosshatch': '십자선',
      'Delta Trance': '무아삼각권',
      'Exhaust': '고갈',
      'Freezing Missile': '냉동 미사일',
      'Heat': '열선',
      'Heirsbane': '제IX호',
      'Imperial Authority': '제국의 권위',
      'Innocence': '순수',
      'Jarring Blow': '단단한 공격',
      'Magitek Ray': '마도 레이저',
      'Magitek Slash': '마도 참격',
      'Missile Impact': '미사일 공격',
      'Needle Gun': '바늘총',
      'Nitrospin': '니트로 회전',
      'Oil Shower': '기름 세례',
      'Order To Bombard': '폭격 명령',
      'Order To Fire': '공격 명령',
      'Order To Support': '지원 명령',
      'Quaternity': '사위일체',
      'Roundhouse': '종횡질풍참',
      'Stunning Sweep': '뇌광수면축',
      'The Order': '명령',
      'Tunnel': '잠항',
      'Unbreakable Cermet Drill': '초경도 합금 드릴',
      'Wild Fire Beam': '확산 화염 광선'
    }
  }]
};
/* harmony default export */ const ghimlyt_dark64 = (ghimlyt_dark64_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/ghimlyt_dark64.txt
const dungeon_ghimlyt_dark64_namespaceObject = "### THE GHIMLYT DARK (6.4)\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~~~~~~~~~~#\r\n# MAGITEK COLOSSUS #\r\n#~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 394F 3775\r\n\r\n# The Field of Dust will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"AB8\" } window 0,1\r\n12.9 \"Jarring Blow\" Ability { id: \"376E\", source: \"Mark III-B Magitek Colossus\" }\r\n15.0 \"--sync--\" Ability { id: \"3771\", source: \"Mark III-B Magitek Colossus\" }\r\n22.1 \"Wild Fire Beam\" Ability { id: \"3772\", source: \"Mark III-B Magitek Colossus\" } window 30,30\r\n28.8 \"Magitek Slash x5\" Ability { id: \"3774\", source: \"Mark III-B Magitek Colossus\" } duration 8\r\n45.5 \"Exhaust\" Ability { id: \"3770\", source: \"Mark III-B Magitek Colossus\" }\r\n55.7 \"Ceruleum Vent\" Ability { id: \"3773\", source: \"Mark III-B Magitek Colossus\" }\r\n\r\n68.0 \"Magitek Slash x5\" Ability { id: \"3774\", source: \"Mark III-B Magitek Colossus\" } duration 8\r\n80.2 \"Magitek Slash x5\" Ability { id: \"3774\", source: \"Mark III-B Magitek Colossus\" } duration 8\r\n97.4 \"Magitek Ray\" Ability { id: \"376F\", source: \"Mark III-B Magitek Colossus\" }\r\n102.6 \"Exhaust\" Ability { id: \"3770\", source: \"Mark III-B Magitek Colossus\" }\r\n116.8 \"Ceruleum Vent\" Ability { id: \"3773\", source: \"Mark III-B Magitek Colossus\" } window 20,20\r\n120.0 \"--sync--\" Ability { id: \"3771\", source: \"Mark III-B Magitek Colossus\" }\r\n127.1 \"Wild Fire Beam\" Ability { id: \"3772\", source: \"Mark III-B Magitek Colossus\" }\r\n133.1 \"Magitek Ray\" Ability { id: \"376F\", source: \"Mark III-B Magitek Colossus\" }\r\n138.3 \"Exhaust\" Ability { id: \"3770\", source: \"Mark III-B Magitek Colossus\" }\r\n143.7 \"Exhaust\" Ability { id: \"3770\", source: \"Mark III-B Magitek Colossus\" }\r\n156.0 \"Jarring Blow\" Ability { id: \"376E\", source: \"Mark III-B Magitek Colossus\" } window 30,30\r\n162.1 \"Ceruleum Vent\" Ability { id: \"3773\", source: \"Mark III-B Magitek Colossus\" }\r\n169.3 \"Ceruleum Vent\" Ability { id: \"3773\", source: \"Mark III-B Magitek Colossus\" }\r\n\r\n176.5 \"Magitek Slash x5\" Ability { id: \"3774\", source: \"Mark III-B Magitek Colossus\" } jump 68\r\n188.7 \"Magitek Slash x5\"\r\n205.9 \"Magitek Ray\"\r\n211.1 \"Exhaust\"\r\n\r\n#~~~~~~~~~~~~#\r\n# PROMETHEUS #\r\n#~~~~~~~~~~~~#\r\n\r\n# Unfortunately there are no log lines for when Prometheus fires after using Heat.\r\n\r\n# -ic \"Lyse\" \"Pipin Of The Steel Heart\" \"Schola Centurion\" \"Schola Laquearius\" \"Schola Signifer\"\r\n# -ii 3AC6\r\n\r\n# Impact Crater will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"ABB\" } window 1000,1\r\n1012.2 \"Nitrospin\" Ability { id: \"3455\", source: \"Prometheus\" }\r\n1023.4 \"Needle Gun\" Ability { id: \"345A\", source: \"Prometheus\" }\r\n1031.1 \"--untargetable--\"\r\n1031.2 \"Tunnel\" Ability { id: \"3457\", source: \"Prometheus\" } window 31.2,5\r\n1042.8 \"Heat\" duration 4 # Ability { id: \"3458\", source: \"Prometheus\" }\r\n1048.0 \"--targetable--\"\r\n\r\n1056.2 \"Unbreakable Cermet Drill\" Ability { id: \"3459\", source: \"Prometheus\" } window 30,30\r\n1068.3 \"Needle Gun\" Ability { id: \"345A\", source: \"Prometheus\" }\r\n1075.4 \"Needle Gun/Oil Shower\" Ability { id: [\"345A\", \"3456\"], source: \"Prometheus\" }\r\n1086.4 \"Nitrospin\" Ability { id: \"3455\", source: \"Prometheus\" }\r\n1097.8 \"Freezing Missile (windup)\" Ability { id: \"345B\", source: \"Prometheus\" }\r\n1100.4 \"--untargetable--\"\r\n1100.5 \"Tunnel\" Ability { id: \"3457\", source: \"Prometheus\" } window 30,30\r\n1108.9 \"Freezing Missile (cast)\" Ability { id: \"345C\", source: \"Prometheus\" }\r\n1113.1 \"Heat\" duration 4 # Ability { id: \"3458\", source: \"Prometheus\" }\r\n1118.2 \"--targetable--\"\r\n\r\n1131.5 \"Unbreakable Cermet Drill\" Ability { id: \"3459\", source: \"Prometheus\" } jump 1056.2\r\n1143.6 \"Needle Gun\"\r\n1150.7 \"Needle Gun/Oil Shower\"\r\n1161.9 \"Nitrospin\"\r\n\r\n\r\n#~~~~~~~~~~~~~#\r\n# SORANUS DUO #\r\n#~~~~~~~~~~~~~#\r\n\r\n# Provisional Imperial Landing will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"ABD\" } window 2000,5\r\n2000.4 \"--sync--\" Ability { id: \"370F\", source: \"Annia Quo Soranus\" } jump 2097\r\n2000.4 \"--sync--\" Ability { id: \"370E\", source: \"Julia Quo Soranus\" } jump 2297\r\n2003.4 \"Artificial Plasma?\"\r\n2010.6 \"Heirsbane?\"\r\n2011.6 \"Angry Salamander?\"\r\n2011.8 \"Innocence?\"\r\n2013.5 \"Delta Trance?\"\r\n2018.2 \"Heirsbane?\"\r\n2020.9 \"Commence Air Strike?\"\r\n\r\n\r\n# Julia active\r\n\r\n2097.0 \"--sync--\" Ability { id: \"370F\", source: \"Annia Quo Soranus\" }\r\n2100.0 \"Artificial Plasma\" Ability { id: \"3727\", source: \"Julia Quo Soranus\" }\r\n2108.2 \"Angry Salamander\" # Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2108.4 \"Innocence\" Ability { id: \"3729\", source: \"Julia Quo Soranus\" }\r\n2117.5 \"Commence Air Strike\" Ability { id: \"3716\", source: \"Julia Quo Soranus\" }\r\n2119.3 \"--sync--\" Ability { id: \"370E\", source: \"Julia Quo Soranus\" }\r\n2121.8 \"Roundhouse\" Ability { id: \"3718\", source: \"Annia Quo Soranus\" }\r\n\r\n# We have to sync widely here because if Julia is first she skips one Aglaia Bite.\r\n2124.7 \"Heirsbane\" Ability { id: \"3719\", source: \"Julia Quo Soranus\" } window 15,15\r\n2127.6 \"Burst x5\" duration 8 # Ability { id: \"371A\", source: \"Ceruleum Tank\" }\r\n2132.3 \"Angry Salamander\" Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2145.2 \"Artificial Plasma\" Ability { id: \"3727\", source: \"Julia Quo Soranus\" }\r\n2147.9 \"Angry Salamander\" Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2151.4 \"--sync--\" Ability { id: \"370E\", source: \"Julia Quo Soranus\" }\r\n\r\n# During the rotation block, we can't sync Aglaia Bite,\r\n# since the double usage is just too close together.\r\n2153.2 \"The Order\" Ability { id: \"3713\", source: \"Julia Quo Soranus\" } window 30,30\r\n2158.3 \"Order To Fire\" Ability { id: \"372D\", source: \"Annia Quo Soranus\" }\r\n2158.3 \"Missile Impact\" Ability { id: \"372E\", source: \"Annia Quo Soranus\" }\r\n2159.3 \"The Order\" Ability { id: \"39BA\", source: \"Julia Quo Soranus\" }\r\n2159.3 \"Quaternity\" Ability { id: \"3989\", source: \"Soranus Duo\" }\r\n2164.6 \"Artificial Plasma\" Ability { id: \"3727\", source: \"Julia Quo Soranus\" }\r\n2168.8 \"Angry Salamander\" Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2174.9 \"Artificial Plasma\" Ability { id: \"3727\", source: \"Julia Quo Soranus\" }\r\n2182.2 \"Angry Salamander\" Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2183.2 \"Innocence\" Ability { id: \"3729\", source: \"Julia Quo Soranus\" }\r\n2192.5 \"Commence Air Strike\" Ability { id: \"3716\", source: \"Julia Quo Soranus\" } window 30,30\r\n2194.1 \"--sync--\" Ability { id: \"370E\", source: \"Julia Quo Soranus\" }\r\n2194.8 \"Aglaia Bite\" # Ability { id: \"3717\", source: \"Annia Quo Soranus\" }\r\n2196.9 \"Aglaia Bite/Roundhouse\" # Ability { id: \"371[78]\", source: \"Annia Quo Soranus\" }\r\n2199.6 \"Heirsbane\" Ability { id: \"3719\", source: \"Julia Quo Soranus\" }\r\n2202.5 \"Burst x5\" duration 12 # Ability { id: \"371A\", source: \"Ceruleum Tank\" }\r\n2207.2 \"Angry Salamander\" Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2220.2 \"Artificial Plasma\" Ability { id: \"3727\", source: \"Julia Quo Soranus\" }\r\n2222.8 \"Angry Salamander\" Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2226.3 \"--sync--\" Ability { id: \"370E\", source: \"Julia Quo Soranus\" }\r\n\r\n2228.1 \"The Order\" Ability { id: \"3713\", source: \"Julia Quo Soranus\" } window 30,30 jump 2153.2\r\n2233.2 \"Order To Fire\"\r\n2233.2 \"Missile Impact\"\r\n2234.2 \"The Order\"\r\n2234.2 \"Quaternity\"\r\n2239.5 \"Artificial Plasma\"\r\n2243.7 \"Angry Salamander\"\r\n2249.8 \"Artificial Plasma\"\r\n2257.1 \"Angry Salamander\"\r\n2258.1 \"Innocence\"\r\n\r\n# Annia active\r\n\r\n2297.0 \"--sync--\" Ability { id: \"370E\", source: \"Julia Quo Soranus\" }\r\n2307.2 \"Heirsbane\" Ability { id: \"372B\", source: \"Julia Quo Soranus\" }\r\n2310.3 \"Delta Trance\" Ability { id: \"372A\", source: \"Annia Quo Soranus\" }\r\n2314.9 \"Heirsbane\" Ability { id: \"372B\", source: \"Julia Quo Soranus\" }\r\n2321.3 \"The Order\" Ability { id: \"3713\", source: \"Julia Quo Soranus\" }\r\n2325.1 \"Order To Bombard\" Ability { id: \"3710\", source: \"Annia Quo Soranus\" }\r\n2327.5 \"--sync--\" Ability { id: \"370F\", source: \"Annia Quo Soranus\" }\r\n\r\n2329.5 \"The Order\" Ability { id: \"3714\", source: \"Julia Quo Soranus\" } window 30,30\r\n2329.7 \"Crossbones\" Ability { id: \"3C80\", source: \"Soranus Duo\" }\r\n2331.6 \"Angry Salamander\" Ability { id: \"372C\", source: \"Annia Quo Soranus\" }\r\n2332.4 \"Bombardment\" Ability { id: \"3711\", source: \"Annia Quo Soranus\" }\r\n2340.5 \"The Order\" Ability { id: \"3713\", source: \"Julia Quo Soranus\" }\r\n2341.9 \"Artificial Plasma\" Ability { id: \"3728\", source: \"Annia Quo Soranus\" }\r\n2347.1 \"Quaternity\" Ability { id: \"3733\", source: \"Soranus Duo\" }\r\n2347.1 \"The Order\" Ability { id: \"39BA\", source: \"Julia Quo Soranus\" } window 30,30\r\n2351.7 \"Delta Trance\" Ability { id: \"372A\", source: \"Annia Quo Soranus\" }\r\n2355.8 \"Heirsbane\" Ability { id: \"372B\", source: \"Julia Quo Soranus\" }\r\n2361.8 \"Stunning Sweep\" Ability { id: \"3712\", source: \"Annia Quo Soranus\" }\r\n2363.1 \"Heirsbane\" Ability { id: \"372B\", source: \"Julia Quo Soranus\" }\r\n2370.8 \"Artificial Plasma\" Ability { id: \"3728\", source: \"Annia Quo Soranus\" }\r\n2382.3 \"The Order\" Ability { id: \"3713\", source: \"Julia Quo Soranus\" }\r\n2386.1 \"Order To Bombard\" Ability { id: \"3710\", source: \"Annia Quo Soranus\" }\r\n2388.5 \"--sync--\" Ability { id: \"370F\", source: \"Annia Quo Soranus\" }\r\n\r\n2390.5 \"The Order\" Ability { id: \"3714\", source: \"Julia Quo Soranus\" } window 30,30 jump 2329.5\r\n2390.7 \"Crossbones\"\r\n2392.6 \"Angry Salamander\"\r\n2393.4 \"Bombardment\"\r\n2401.5 \"The Order\"\r\n2402.9 \"Artificial Plasma\"\r\n2408.1 \"Quaternity\"\r\n2408.1 \"The Order\"\r\n2412.7 \"Delta Trance\"\r\n2416.8 \"Heirsbane\"\r\n\r\n# Intermission\r\n\r\n# Order To Support and Covering Fire are only on the second intermission.\r\n\r\n\r\n2494.3 \"Order To Support\" Ability { id: \"371B\", source: \"Annia Quo Soranus\" } window 494.3,5\r\n2500.0 \"Crosshatch\" Ability { id: \"3721\", source: \"Soranus Duo\" } window 500,5\r\n2506.6 \"--sync--\" Ability { id: \"3723\", source: \"Annia Quo Soranus\" }\r\n2506.8 \"--sync--\" Ability { id: \"384B\", source: \"Julia Quo Soranus\" }\r\n2507.1 \"--sync--\" Ability { id: \"384C\", source: \"Annia Quo Soranus\" }\r\n2507.4 \"--sync--\" Ability { id: \"3724\", source: \"Julia Quo Soranus\" }\r\n2508.2 \"--sync--\" Ability { id: \"396A\", source: \"Annia Quo Soranus\" }\r\n2508.6 \"--sync--\" Ability { id: \"3969\", source: \"Julia Quo Soranus\" }\r\n2508.7 \"Crosshatch 1\" # Ability { id: \"3722\", source: \"Annia Quo Soranus\" }\r\n2508.9 \"Crosshatch 2\" # Ability { id: \"3722\", source: \"Julia Quo Soranus\" }\r\n2509.0 \"--sync--\" Ability { id: \"384D\", source: \"Annia Quo Soranus\" }\r\n2509.4 \"Covering Fire?\" Ability { id: \"371C\", source: \"Annia Quo Soranus\" }\r\n2509.4 \"Crosshatch 3\" # Ability { id: \"3722\", source: \"Annia Quo Soranus\" }\r\n2509.6 \"--sync--\" Ability { id: \"396B\", source: \"Julia Quo Soranus\" }\r\n2509.9 \"Crosshatch 4\" # Ability { id: \"3722\", source: \"Julia Quo Soranus\" }\r\n2511.1 \"Crosshatch 5\" # Ability { id: \"3722\", source: \"Annia Quo Soranus\" }\r\n2511.8 \"Crosshatch 6\" # Ability { id: \"3722\", source: \"Julia Quo Soranus\" }\r\n2512.3 \"Crosshatch 7\" # Ability { id: \"3722\", source: \"Annia Quo Soranus\" }\r\n2512.8 \"Crosshatch 8\" # Ability { id: \"3722\", source: \"Julia Quo Soranus\" }\r\n2515.9 \"--sync--\" Ability { id: \"3726\", source: \"Julia Quo Soranus\" }\r\n2516.0 \"--sync--\" Ability { id: \"3725\", source: \"Annia Quo Soranus\" }\r\n2519.0 \"--sync--\" Ability { id: \"370F\", source: \"Annia Quo Soranus\" } window 10,10 jump 2097\r\n2519.0 \"--sync--\" Ability { id: \"370E\", source: \"Julia Quo Soranus\" } window 10,10 jump 2297\r\n2522.4 \"Artificial Plasma?\"\r\n2529.6 \"Heirsbane?\"\r\n2530.6 \"Angry Salamander?\"\r\n2530.8 \"Innocence?\"\r\n2532.5 \"Delta Trance?\"\r\n2537.2 \"Heirsbane?\"\r\n2539.9 \"Commence Air Strike?\"\r\n\r\n# Enrage after two intermissions.\r\n\r\n# 2597.3 \"--sync--\" StartsUsing { id: \"372F\", source: \"Julia Quo Soranus\" } window 597.3\r\n2597.3 \"Artificial Boost\" StartsUsing { id: \"3730\", source: \"Annia Quo Soranus\" } window 597.3,0\r\n# 2600.0 \"--sync--\" Ability { id: \"372F\", source: \"Julia Quo Soranus\" } window 600,5\r\n2600.0 \"Artificial Boost\" Ability { id: \"3730\", source: \"Annia Quo Soranus\" } window 600,5\r\n# 2603.2 \"--sync--\" StartsUsing { id: \"3731\", source: \"Julia Quo Soranus\" }\r\n2603.2 \"Imperial Authority\" StartsUsing { id: \"3732\", source: \"Annia Quo Soranus\" } duration 39.7\r\n2642.9 \"Imperial Authority Enrage\" Ability { id: \"3732\", source: \"Annia Quo Soranus\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/hells_lid.ts



const hells_lid_triggerSet = {
  id: 'HellsLid',
  zoneId: zone_id/* default.HellsLid */.Z.HellsLid,
  timelineFile: 'hells_lid.txt',
  timelineTriggers: [{
    id: 'Hells Lid Stone Cudgel',
    regex: /Stone Cudgel/,
    beforeSeconds: 4,
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from club/shield',
        de: 'Weg von der Keule/dem Schild',
        fr: 'Éloignez-vous du bouclier/fauche',
        ja: '岩棍棒から離れる',
        cn: '远离棍棍和盾盾',
        ko: '검/방패에게서 멀어지기'
      }
    }
  }, {
    id: 'Hells Lid Whittret',
    regex: /Whipping Whittret/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Hells Lid Caduceus',
    regex: /Caduceus/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }],
  triggers: [{
    id: 'Hells Lid Swing',
    type: 'StartsUsing',
    netRegex: {
      id: '27BE',
      source: 'Otake-Maru',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hells Lid Targeted Leap',
    type: 'HeadMarker',
    netRegex: {
      id: '0001'
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.targetText();
      return output.otherText();
    },
    outputStrings: {
      targetText: {
        en: 'Boss chasing--GET AWAY',
        de: 'Boss-Verfolgung--RENN WEG',
        fr: 'Ruée du boss -- ÉLOIGNEZ-VOUS',
        ja: 'ボス追いつけるよ～早く走れ！',
        cn: 'BOSS追逐点名———快跑鸭',
        ko: '보스 추격중 --도망가세요'
      },
      otherText: {
        en: 'Avoid boss',
        de: 'Weiche dem Boss aus',
        fr: 'Évitez le boss',
        ja: 'ボスから離れる',
        cn: '远离BOSS',
        ko: '도망가기'
      }
    }
  }, {
    id: 'Hells Lid Circling Winds',
    type: 'StartsUsing',
    netRegex: {
      id: '27C8',
      source: 'Kamaitachi',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Hells Lid Rolling Winds',
    type: 'StartsUsing',
    netRegex: {
      id: '27C9',
      source: 'Kamaitachi',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'Hells Lid Sinister Tide',
    type: 'StartsUsing',
    netRegex: {
      id: '27D4',
      source: 'Genbu',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid water orb',
        de: 'Weiche dem Wasser-Orb aus',
        fr: 'Évitez l\'orbe d\'eau',
        ja: '水玉から離れる',
        cn: '躲避水球移动路径',
        ko: '물구슬 피하기'
      }
    }
  }, {
    id: 'Hells Lid Hell Of Waste',
    type: 'HeadMarker',
    netRegex: {
      id: '002B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Hells Lid Hell Of Waves',
    type: 'StartsUsing',
    netRegex: {
      id: '27D3',
      source: 'Genbu',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Demonsgate': 'Dämonentor',
      'The Furnace': 'Höllenkessel',
      'Genbu': 'Genbu',
      'Kamaitachi': 'Kamaitachi',
      'Otake-Maru': 'Otake-Maru',
      'The Polished Shell': 'Schildpanzer',
      'Volcanic Debris': 'Schlacke'
    },
    'replaceText': {
      '10-Tonze Slash': '11-Tonzen-Schlag',
      '100-Tonze Swing': '100-Tonzen-Schwung',
      'Caduceus': 'Caduceus',
      'Circling Winds': 'Sturmkreis',
      'Disrobe': 'Abmanteln',
      'Divine Cataract': 'Wasserwand',
      'Eruptive Leap': 'Eruptiver Sprung',
      'Hell Of Waste': 'Windhölle',
      'Hell Of Water': 'Wasserhölle',
      'Hell Of Waves': 'Wellenhölle',
      'Late Harvest': 'Späte Ernte',
      'Reaper\'s Gale': 'Sensenwind',
      'Rolling Winds': 'Wirbelnde Bö',
      'Shell Shower': 'Panzerquetsche',
      'Sinister Tide': 'Tückische Gezeiten',
      'Stone Cudgel': 'Felsknüttel',
      'The Patient Blade': 'Geduldige Klinge',
      'Volcanic Debris': 'Schlacke',
      'Whipping Whittret': 'Wieselpeitsche',
      'Whisper In The Wind': 'Flüstern des Windes'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Demonsgate': 'Porte des Oni',
      'The Furnace': 'Chaudron des enfers',
      'Genbu': 'Genbu',
      'Kamaitachi': 'Kamaitachi',
      'Otake-Maru': 'Ôtake Maru',
      'The Polished Shell': 'Vénérable Carapace',
      'Volcanic Debris': 'Débris volcanique'
    },
    'replaceText': {
      '10-Tonze Slash': 'Taillade de 10 tonz',
      '100-Tonze Swing': 'Swing de 100 tonz',
      'Caduceus': 'Caducée',
      'Circling Winds': 'Vents circulaires',
      'Disrobe': 'Déshabillage',
      'Divine Cataract': 'Cataracte divine',
      'Eruptive Leap': 'Bond éruptif',
      'Hell Of Waste': 'Enfer de vent',
      'Hell Of Water': 'Enfer d\'eau',
      'Hell Of Waves': 'Enfer de vagues',
      'Late Harvest': 'Moisson tardive',
      'Reaper\'s Gale': 'Rafale fauchante',
      'Rolling Winds': 'Vents perçants',
      'Shell Shower': 'Pluie de carapaces',
      'Sinister Tide': 'Marée sinistre',
      'Stone Cudgel': 'Gourdin de pierre',
      'The Patient Blade': 'Lame patiente',
      'Volcanic Debris': 'Débris volcanique',
      'Whipping Whittret': 'Fouine fouettante',
      'Whisper In The Wind': 'Murmure du vent'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Demonsgate': '鬼之門',
      'The Furnace': '獄之釜',
      'Genbu': '玄武',
      'Kamaitachi': 'カマイタチ',
      'Otake-Maru': 'オオタケ丸',
      'The Polished Shell': '亀甲舞台',
      'Volcanic Debris': '噴石'
    },
    'replaceText': {
      '10-Tonze Slash': '10トンズ・スラッシュ',
      '100-Tonze Swing': '100トンズ・スイング',
      'Caduceus': '蛇杖撃',
      'Circling Winds': '疾風衝',
      'Disrobe': '無手法',
      'Divine Cataract': '玄天武水壁',
      'Eruptive Leap': '噴火飛び',
      'Hell Of Waste': '玄冥瀑',
      'Hell Of Water': '玄冥流',
      'Hell Of Waves': '玄冥波',
      'Late Harvest': '野鎌',
      'Reaper\'s Gale': '鎌風',
      'Rolling Winds': '突風衝',
      'Shell Shower': '亀甲流',
      'Sinister Tide': '迷潮流',
      'Stone Cudgel': '岩棍棒',
      'The Patient Blade': '構え太刀',
      'Volcanic Debris': '噴石',
      'Whipping Whittret': '鞭イタチ',
      'Whisper In The Wind': '風の呼び声'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Demonsgate': '鬼之门',
      'The Furnace': '狱之釜',
      'Genbu': '玄武',
      'Kamaitachi': '镰鼬',
      'Otake-Maru': '大岳丸',
      'The Polished Shell': '龟甲舞台',
      'Volcanic Debris': '喷石'
    },
    'replaceText': {
      '10-Tonze Slash': '十吨挥打',
      '100-Tonze Swing': '百吨回转',
      'Caduceus': '蛇杖击',
      'Circling Winds': '疾风冲',
      'Disrobe': '徒手',
      'Divine Cataract': '玄天武水壁',
      'Eruptive Leap': '爆发跳跃',
      'Hell Of Waste': '玄冥瀑',
      'Hell Of Water': '玄冥流',
      'Hell Of Waves': '玄冥波',
      'Late Harvest': '野镰',
      'Reaper\'s Gale': '镰风',
      'Rolling Winds': '突风冲',
      'Shell Shower': '龟甲流',
      'Sinister Tide': '迷潮',
      'Stone Cudgel': '岩棍',
      'The Patient Blade': '镰鼬斩',
      'Volcanic Debris': '喷石',
      'Whipping Whittret': '鞭鼬',
      'Whisper In The Wind': '风的呼声'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Demonsgate': '귀문',
      'The Furnace': '지옥솥',
      'Genbu': '현무',
      'Kamaitachi': '카마이타치',
      'Otake-Maru': '오오타케마루',
      'The Polished Shell': '귀갑 무대',
      'Volcanic Debris': '화산재'
    },
    'replaceText': {
      '10-Tonze Slash': '10톤즈 베기',
      '100-Tonze Swing': '100톤즈 휘두르기',
      'Caduceus': '뱀 지팡이',
      'Circling Winds': '질풍 충격',
      'Disrobe': '마구잡이',
      'Divine Cataract': '현천무수벽',
      'Eruptive Leap': '분화',
      'Hell Of Waste': '명계의 검은 폭발',
      'Hell Of Water': '명계의 검은 물',
      'Hell Of Waves': '명계의 검은 파도',
      'Late Harvest': '늦수확',
      'Reaper\'s Gale': '낫바람',
      'Rolling Winds': '돌풍 충격',
      'Shell Shower': '귀갑류',
      'Sinister Tide': '어지러운 파도',
      'Stone Cudgel': '돌방망이',
      'The Patient Blade': '족제비 칼날',
      'Volcanic Debris': '용암 조각',
      'Whipping Whittret': '족제비 채찍',
      'Whisper In The Wind': '바람의 속삭임'
    }
  }]
};
/* harmony default export */ const hells_lid = (hells_lid_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/hells_lid.txt
const dungeon_hells_lid_namespaceObject = "### HELL'S LID\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~~~~#\r\n# OTAKE-MARU #\r\n#~~~~~~~~~~~~#\r\n\r\n# -ii 27C0\r\n\r\n# Demonsgate will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"954\" } window 0,1\r\n19.7 \"100-Tonze Swing\" Ability { id: \"27BE\", source: \"Otake-Maru\" } window 19.7,5\r\n27.3 \"Volcanic Debris x8\" # Ability { id: \"27C5\", source: \"Volcanic Debris\" }\r\n28.3 \"10-Tonze Slash\" Ability { id: \"27BF\", source: \"Otake-Maru\" }\r\n39.4 \"100-Tonze Swing\" Ability { id: \"27BE\", source: \"Otake-Maru\" } window 20,20\r\n56.2 \"Eruptive Leap\" Ability { id: \"27C4\", source: \"Otake-Maru\" }\r\n57.3 \"Disrobe 1\" Ability { id: \"27C1\", source: \"Otake-Maru\" }\r\n62.1 \"Disrobe 2\" Ability { id: \"27C2\", source: \"Otake-Maru\" }\r\n69.3 \"Eruptive Leap\" Ability { id: \"27C4\", source: \"Otake-Maru\" }\r\n70.4 \"Stone Cudgel\" Ability { id: \"27C3\", source: \"Otake-Maru\" }\r\n73.1 \"Eruptive Leap\" Ability { id: \"27C4\", source: \"Otake-Maru\" }\r\n74.2 \"Stone Cudgel\" Ability { id: \"27C3\", source: \"Otake-Maru\" }\r\n79.9 \"10-Tonze Slash\" Ability { id: \"27BF\", source: \"Otake-Maru\" }\r\n\r\n101.1 \"100-Tonze Swing\" Ability { id: \"27BE\", source: \"Otake-Maru\" } window 20,20\r\n108.8 \"Eruptive Leap\" Ability { id: \"27C4\", source: \"Otake-Maru\" }\r\n109.9 \"Disrobe 1\" Ability { id: \"27C1\", source: \"Otake-Maru\" }\r\n114.6 \"Disrobe 2\" Ability { id: \"27C2\", source: \"Otake-Maru\" }\r\n115.7 \"Volcanic Debris x14\" # Ability { id: \"27C5\", source: \"Volcanic Debris\" }\r\n121.9 \"Eruptive Leap\" Ability { id: \"27C4\", source: \"Otake-Maru\" }\r\n123.0 \"Stone Cudgel\" Ability { id: \"27C3\", source: \"Otake-Maru\" }\r\n125.6 \"Eruptive Leap\" Ability { id: \"27C4\", source: \"Otake-Maru\" }\r\n126.7 \"Stone Cudgel\" Ability { id: \"27C3\", source: \"Otake-Maru\" }\r\n132.4 \"10-Tonze Slash\" Ability { id: \"27BF\", source: \"Otake-Maru\" }\r\n\r\n168.6 \"100-Tonze Swing\" Ability { id: \"27BE\", source: \"Otake-Maru\" } window 20,20 jump 101.1\r\n176.3 \"Eruptive Leap\"\r\n177.4 \"Disrobe1 \"\r\n182.1 \"Disrobe 2\"\r\n183.2 \"Volcanic Debris x14\"\r\n189.4 \"Eruptive Leap\"\r\n190.5 \"Stone Cudgel\"\r\n193.1 \"Eruptive Leap\"\r\n194.2 \"Stone Cudgel\"\r\n199.9 \"10-Tonze Slash\"\r\n\r\n\r\n#~~~~~~~~~~~~#\r\n# KAMAITACHI #\r\n#~~~~~~~~~~~~#\r\n\r\n# -ic \"Tsumuji-Kaze\"\r\n\r\n# The Furnace will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"956\" } window 1000,1\r\n1011.5 \"Whipping Whittret\" Ability { id: \"27C6\", source: \"Kamaitachi\" } window 11.5,5\r\n1024.1 \"Circling Winds\" Ability { id: \"27C8\", source: \"Kamaitachi\" }\r\n1037.8 \"The Patient Blade\" Ability { id: \"27C7\", source: \"Kamaitachi\" }\r\n1050.5 \"Rolling Winds\" Ability { id: \"27C9\", source: \"Kamaitachi\" }\r\n1064.2 \"Whisper In The Wind\" Ability { id: \"27CA\", source: \"Kamaitachi\" }\r\n1066.3 \"--untargetable--\"\r\n\r\n1066.4 \"--sync--\" Ability { id: \"284F\", source: \"Kamaitachi\" } window 66.4,5\r\n1084.2 \"Late Harvest\" Ability { id: \"27CC\", source: \"Kamaitachi\" } window 30,0\r\n1084.8 \"Late Harvest\" # Ability { id: \"27CC\", source: \"Kamaitachi\" }\r\n1085.4 \"Late Harvest\" # Ability { id: \"27CC\", source: \"Kamaitachi\" }\r\n1092.2 \"Late Harvest\" Ability { id: \"27CC\", source: \"Kamaitachi\" } window 5,0\r\n1092.8 \"Late Harvest\" # Ability { id: \"27CC\", source: \"Kamaitachi\" }\r\n1093.4 \"Late Harvest\" # Ability { id: \"27CC\", source: \"Kamaitachi\" }\r\n1099.2 \"Reaper's Gale\" Ability { id: \"27CB\", source: \"Kamaitachi\" }\r\n1099.3 \"--sync--\" Ability { id: \"2967\", source: \"Kamaitachi\" }\r\n1105.6 \"--targetable--\"\r\n\r\n1110.9 \"The Patient Blade\" Ability { id: \"27C7\", source: \"Kamaitachi\" } window 50,5\r\n1116.6 \"Whipping Whittret\" Ability { id: \"27C6\", source: \"Kamaitachi\" }\r\n1127.2 \"Circling Winds\" Ability { id: \"27C8\", source: \"Kamaitachi\" }\r\n1138.9 \"Rolling Winds\" Ability { id: \"27C9\", source: \"Kamaitachi\" }\r\n\r\n1151.6 \"The Patient Blade\" Ability { id: \"27C7\", source: \"Kamaitachi\" } window 30,30 jump 1110.9\r\n1157.3 \"Whipping Whittret\"\r\n1167.9 \"Circling Winds\"\r\n1179.6 \"Rolling Winds\"\r\n\r\n\r\n#~~~~~~~#\r\n# GENBU #\r\n#~~~~~~~#\r\n\r\n# -ii 27D2 27D5\r\n\r\n# The Polished Shell will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"959\" } window 2000,1\r\n2005.0 \"Caduceus\" Ability { id: \"27CF\", source: \"Genbu\" } window 5,5\r\n2013.1 \"Hell Of Water\" Ability { id: \"27D0\", source: \"Genbu\" }\r\n2021.9 \"Hell Of Waste\" Ability { id: \"27D1\", source: \"Genbu\" }\r\n2033.6 \"Sinister Tide\" Ability { id: \"27D4\", source: \"Genbu\" }\r\n2050.7 \"Caduceus\" Ability { id: \"27CF\", source: \"Genbu\" } window 20,20\r\n2055.8 \"Sinister Tide\" Ability { id: \"27D4\", source: \"Genbu\" }\r\n2079.0 \"Hell Of Water\" Ability { id: \"27D0\", source: \"Genbu\" }\r\n2085.7 \"Sinister Tide\" Ability { id: \"27D4\", source: \"Genbu\" }\r\n2092.9 \"Hell Of Waste\" Ability { id: \"27D1\", source: \"Genbu\" }\r\n2103.6 \"Caduceus\" Ability { id: \"27CF\", source: \"Genbu\" } window 20,20\r\n2109.7 \"--untargetable--\"\r\n\r\n# This intermission has a boss limit break charging.\r\n# Its progress determines how powerful Divine Cataract will be.\r\n# This timeline is the maximum the intermission will run.\r\n2113.9 \"Hell Of Waves\" Ability { id: \"27D3\", source: \"Genbu\" } window 113.9,5\r\n2125.4 \"Shell Shower\" Ability { id: \"2850\", source: \"Genbu\" }\r\n2140.5 \"Shell Shower\" Ability { id: \"2850\", source: \"Genbu\" }\r\n2155.6 \"Shell Shower\" Ability { id: \"2850\", source: \"Genbu\" }\r\n2170.6 \"Shell Shower\" Ability { id: \"2850\", source: \"Genbu\" }\r\n2175.3 \"Divine Cataract\" Ability { id: \"27D7\", source: \"Genbu\" } window 61.4,10\r\n2178.3 \"--targetable--\"\r\n\r\n# Extra-aggressive syncs here, since Waste/Wave timings can drift.\r\n2182.4 \"Sinister Tide\" Ability { id: \"27D4\", source: \"Genbu\" } window 20,20\r\n2189.5 \"Hell Of Waste/Hell Of Waves\" Ability { id: \"27(D1|7E)\", source: \"Genbu\" }\r\n2202.6 \"Hell Of Water\" Ability { id: \"27D0\", source: \"Genbu\" } window 15,15\r\n2208.3 \"Caduceus\" Ability { id: \"27CF\", source: \"Genbu\" } window 15,15\r\n\r\n2214.4 \"Sinister Tide\" Ability { id: \"27D4\", source: \"Genbu\" } window 20,20 jump 2182.4\r\n2221.5 \"Hell Of Waste/Hell Of Waves\"\r\n2234.6 \"Hell Of Water\"\r\n2240.3 \"Caduceus\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/kugane_castle.ts



const kugane_castle_triggerSet = {
  id: 'KuganeCastle',
  zoneId: zone_id/* default.KuganeCastle */.Z.KuganeCastle,
  timelineFile: 'kugane_castle.txt',
  timelineTriggers: [{
    id: 'Kugane Castle Issen',
    regex: /Issen/,
    beforeSeconds: 4,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Kugane Castle Wakizashi',
    regex: /Wakizashi/,
    beforeSeconds: 4,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }],
  triggers: [{
    id: 'Kugane Castle Kenki Release',
    type: 'StartsUsing',
    netRegex: {
      id: '1E93',
      source: 'Zuiko-Maru',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Kugane Castle Helm Crack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    // The tether has no actual skill name,
    // but the Harakiri Koshu uses Cordage on the tether target after about 4 seconds.
    id: 'Kugane Castle Cordage',
    type: 'Tether',
    netRegex: {
      id: '0011'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Harakiri tether on YOU',
        de: 'Harakiri Verbindung auf DIR',
        fr: 'Lien Harakiri sur VOUS',
        ja: '自分にはらきり',
        cn: '切腹点名',
        ko: '자폭 대상자'
      }
    }
  }, {
    id: 'Kugane Castle Clockwork Raiton',
    type: 'HeadMarker',
    netRegex: {
      id: '005F'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Kugane Castle Gratuity',
    type: 'Ability',
    netRegex: {
      id: '1EAE',
      source: 'Kageyama',
      capture: false
    },
    suppressSeconds: 15,
    // No point in notifying repeatedly
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Grab gold piles',
        de: 'Sammle die Goldhaufen',
        fr: 'Prenez les pièces d\'or',
        ja: '大判小判を拾う',
        cn: '捡金币',
        ko: '금화 은화 줍기'
      }
    }
  }, {
    id: 'Kugane Castle Dragons Lair',
    type: 'Ability',
    netRegex: {
      id: '1EA6',
      source: 'Yojimbo',
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Daigoro': 'Daigoro',
      'Dojun-Maru': 'Dojun-Maru',
      'Elite Onmitsu': 'Joi Onmitsu',
      'Kageyama': 'Kageyama',
      'The Budokan Training Grounds': 'Budokan',
      'The Keisen Garden': 'Keisen-Garten',
      'The Noh Theater': 'Noh-Theater',
      'Yojimbo': 'Yojinbo',
      'Zuiko-Maru': 'Zuiko-Maru'
    },
    'replaceText': {
      'Clearout': 'Kreisfeger',
      'Clockwork Medium': 'Mechanik-Medium',
      'Clockwork Raiton': 'Mechanik-Raiton',
      'Dragon\'s Lair': 'Drachenhort',
      'Dragonfire': 'Drachenfeuer',
      'Dragonstrike': 'Drachenschlag',
      'Fragility': 'Zerbrechlichkeit',
      'Gratuity': 'Zuwendung',
      'Harakiri': 'Harakiri',
      'Helm Crack': 'Helmspalter',
      'Iai-Giri': 'Iai-giri',
      'Inoshikacho': 'Ino-shika-cho',
      'Issen': 'Issen',
      'Juji Shuriken': 'Juji Shuriken',
      'Kenki Release': 'Entfesseltes Schwert',
      'Metta-Giri': 'Metta-giri',
      'Tatami-Gaeshi': 'Tatami-gaeshi',
      'Wakizashi': 'Wakizashi',
      'Zanmato': 'Zanmato',
      'Zeni Masshigura': 'Zeni Masshigura'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Daigoro': 'Daigoro',
      'Dojun-Maru': 'Dôjun Maru',
      'Elite Onmitsu': 'onmitsu joi',
      'Kageyama': 'Kageyama',
      'The Budokan Training Grounds': 'Budokan',
      'The Keisen Garden': 'Keisen-en',
      'The Noh Theater': 'Théâtre de nô',
      'Yojimbo': 'Yojimbo',
      'Zuiko-Maru': 'Zuiko Maru'
    },
    'replaceText': {
      '\\?': ' ?',
      'Clearout': 'Fauchage',
      'Clockwork Medium': 'Kuchiyose mécanique',
      'Clockwork Raiton': 'Raiton mécanique',
      'Dragon\'s Lair': 'Fléau du dragon',
      'Dragonfire': 'Feu du dragon',
      'Dragonstrike': 'Frappe du dragon',
      'Fragility': 'Fragilité',
      'Gratuity': 'Gracieuseté',
      'Harakiri': 'Hara-kiri',
      'Helm Crack': 'Fendeur de casque',
      'Iai-Giri': 'Iai-giri',
      'Inoshikacho': 'Ino-shika-cho',
      'Issen': 'Issen',
      'Juji Shuriken': 'Juji Shuriken',
      'Kenki Release': 'Décharge Kenki',
      'Metta-Giri': 'Metta-giri',
      'Tatami-Gaeshi': 'Tatami-gaeshi',
      'Wakizashi': 'Wakizashi',
      'Zanmato': 'Zanmato',
      'Zeni Masshigura': 'Zeni Masshigura'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Daigoro': 'ダイゴロウ',
      'Dojun-Maru': 'ドウジュン丸',
      'Elite Onmitsu': 'ジョウ・オンミツ',
      'Kageyama': 'カゲヤマ',
      'The Budokan Training Grounds': '天守武道館',
      'The Keisen Garden': '渓泉園',
      'The Noh Theater': '天守能楽堂',
      'Yojimbo': 'ヨウジンボウ',
      'Zuiko-Maru': 'ズイコウ丸'
    },
    'replaceText': {
      'Clearout': 'なぎ払い',
      'Clockwork Medium': 'からくり口寄せ',
      'Clockwork Raiton': 'からくり雷遁',
      'Dragon\'s Lair': '雲蒸竜変',
      'Dragonfire': '暴竜',
      'Dragonstrike': '画竜点睛',
      'Fragility': '儚き命',
      'Gratuity': '心づけ',
      'Harakiri': '腹切り',
      'Helm Crack': '兜割り',
      'Iai-Giri': '居合斬り',
      'Inoshikacho': '猪鹿蝶',
      'Issen': '一閃',
      'Juji Shuriken': '十字手裏剣',
      'Kenki Release': '剣気解放',
      'Metta-Giri': '居合滅多斬り',
      'Tatami-Gaeshi': '畳返しの術',
      'Wakizashi': '脇差',
      'Zanmato': '斬魔刀',
      'Zeni Masshigura': '銭まっしぐら'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Daigoro': '大五郎',
      'Dojun-Maru': '道顺丸',
      'Elite Onmitsu': '攘夷隐密',
      'Kageyama': '景山',
      'The Budokan Training Grounds': '天守武道馆',
      'The Keisen Garden': '溪泉园',
      'The Noh Theater': '天守能乐堂',
      'Yojimbo': '保镖',
      'Zuiko-Maru': '瑞光丸'
    },
    'replaceText': {
      'Clearout': '横扫',
      'Clockwork Medium': '机关召集',
      'Clockwork Raiton': '机关雷遁',
      'Dragon\'s Lair': '云蒸龙变',
      'Dragonfire': '龙火',
      'Dragonstrike': '画龙点睛',
      'Fragility': '人生短暂',
      'Gratuity': '赏钱',
      'Harakiri': '切腹',
      'Helm Crack': '破盔',
      'Iai-Giri': '居合斩',
      'Inoshikacho': '猪鹿蝶',
      'Issen': '一闪',
      'Juji Shuriken': '十字手里剑',
      'Kenki Release': '剑气解放',
      'Metta-Giri': '居合多段斩',
      'Tatami-Gaeshi': '掀地板之术',
      'Wakizashi': '腰刀',
      'Zanmato': '斩魔刀',
      'Zeni Masshigura': '见钱眼开'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Daigoro': '다이고로',
      'Dojun-Maru': '도우준마루',
      'Elite Onmitsu': '상급 밀정',
      'Kageyama': '카게야마',
      'The Budokan Training Grounds': '천수 무도관',
      'The Keisen Garden': '케이센 정원',
      'The Noh Theater': '가면극장',
      'Yojimbo': '요우진보',
      'Zuiko-Maru': '즈이코우마루'
    },
    'replaceText': {
      'Clearout': '휩쓸기',
      'Clockwork Medium': '꼭두각시 소환',
      'Clockwork Raiton': '꼭두각시 뇌둔술',
      'Dragon\'s Lair': '운증용변',
      'Dragonfire': '폭룡',
      'Dragonstrike': '화룡점정',
      'Fragility': '덧없는 목숨',
      'Gratuity': '사례금',
      'Harakiri': '공멸',
      'Helm Crack': '투구 가르기',
      'Iai-Giri': '거합 베기',
      'Inoshikacho': '멧돼지사슴나비',
      'Issen': '일섬',
      'Juji Shuriken': '십자수리검',
      'Kenki Release': '검기 해방',
      'Metta-Giri': '거합 마구베기',
      'Tatami-Gaeshi': '장판 뒤집기',
      'Wakizashi': '소도',
      'Zanmato': '참마도',
      'Zeni Masshigura': '엽전 돌진'
    }
  }]
};
/* harmony default export */ const kugane_castle = (kugane_castle_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/kugane_castle.txt
const dungeon_kugane_castle_namespaceObject = "### KUGANE CASTLE\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~~~~#\r\n# ZUIKO-MARU #\r\n#~~~~~~~~~~~~#\r\n\r\n# -ic Harakiri Kosho\r\n\r\n# The Harakiri Kosho adds seem to be on a separate timer and thus aren't included here.\r\n\r\n# Keisen Garden will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"7AF\" } window 0,1\r\n9.6 \"Clearout\" Ability { id: \"1E92\", source: \"Zuiko-Maru\" } window 9.6,5\r\n21.8 \"Kenki Release\" Ability { id: \"1E93\", source: \"Zuiko-Maru\" } window 21.8,10\r\n30.9 \"Clearout\" Ability { id: \"1E92\", source: \"Zuiko-Maru\" }\r\n\r\n40.0 \"Kenki Release\" Ability { id: \"1E93\", source: \"Zuiko-Maru\" }\r\n50.2 \"Clearout\" Ability { id: \"1E92\", source: \"Zuiko-Maru\" }\r\n60.4 \"Helm Crack\" Ability { id: \"1E94\", source: \"Zuiko-Maru\" } window 15,15\r\n65.5 \"Kenki Release\" Ability { id: \"1E93\", source: \"Zuiko-Maru\" }\r\n75.8 \"Clearout\" Ability { id: \"1E92\", source: \"Zuiko-Maru\" }\r\n86.0 \"Kenki Release\" Ability { id: \"1E93\", source: \"Zuiko-Maru\" }\r\n98.2 \"Helm Crack\" Ability { id: \"1E94\", source: \"Zuiko-Maru\" } window 15,15\r\n103.4 \"Clearout\" Ability { id: \"1E92\", source: \"Zuiko-Maru\" }\r\n113.6 \"Kenki Release\" Ability { id: \"1E93\", source: \"Zuiko-Maru\" }\r\n\r\n121.7 \"Kenki Release\" Ability { id: \"1E93\", source: \"Zuiko-Maru\" } jump 40\r\n131.9 \"Clearout\"\r\n142.1 \"Helm Crack\"\r\n147.2 \"Kenki Release\"\r\n157.4 \"Clearout\"\r\n167.6 \"Kenki Release\"\r\n\r\n\r\n#~~~~~~~~~~~~#\r\n# DOJUN-MARU #\r\n#~~~~~~~~~~~~#\r\n\r\n# -ii 1E9C 1E9E\r\n\r\n# Budokan Training Grounds will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"7B3\" } window 1000,5\r\n1006.5 \"Issen\" Ability { id: \"1E97\", source: \"Dojun-Maru\" } window 1006.5,5\r\n1016.6 \"Clockwork Medium\" Ability { id: \"1E99\", source: \"Dojun-Maru\" }\r\n1019.8 \"Issen\" Ability { id: \"1E97\", source: \"Dojun-Maru\" }\r\n1025.5 \"Tatami-Gaeshi\" Ability { id: \"1E9D\", source: \"Elite Onmitsu\" }\r\n1027.6 \"--sync--\" Ability { id: \"1E9A\", source: \"Elite Onmitsu\" }\r\n1028.9 \"Clockwork Raiton\" Ability { id: \"1E9B\", source: \"Dojun-Maru\" } window 1028.9,10\r\n\r\n1036.1 \"Issen\" Ability { id: \"1E97\", source: \"Dojun-Maru\" }\r\n1042.2 \"Clockwork Medium\" Ability { id: \"1E99\", source: \"Dojun-Maru\" }\r\n1051.0 \"Juji Shuriken\" Ability { id: \"1E98\", source: \"Dojun-Maru\" }\r\n1056.7 \"Issen\" Ability { id: \"1E97\", source: \"Dojun-Maru\" }\r\n1061.8 \"Issen\" Ability { id: \"1E97\", source: \"Dojun-Maru\" }\r\n1068.2 \"Harakiri?\" # Ability { id: \"1E9F\", source: \"Elite Onmitsu\" }\r\n1070.1 \"Juji Shuriken\" Ability { id: \"1E98\", source: \"Dojun-Maru\" }\r\n1079.3 \"Clockwork Medium\" Ability { id: \"1E99\", source: \"Dojun-Maru\" } window 15,15\r\n1088.1 \"Tatami-Gaeshi 1\" Ability { id: \"1E9D\", source: \"Elite Onmitsu\" }\r\n1091.5 \"Clockwork Raiton\" Ability { id: \"1E9B\", source: \"Dojun-Maru\" }\r\n1092.1 \"Tatami-Gaeshi 2\" Ability { id: \"1E9D\", source: \"Elite Onmitsu\" }\r\n1093.4 \"Juji Shuriken\" Ability { id: \"1EA0\", source: \"Elite Onmitsu\" }\r\n1095.5 \"--adds spawn--\" Ability { id: \"1E9A\", source: \"Elite Onmitsu\" }\r\n1096.7 \"Juji Shuriken\" Ability { id: \"1E98\", source: \"Dojun-Maru\" }\r\n1099.4 \"--sync--\" Ability { id: \"1E9A\", source: \"Elite Onmitsu\" }\r\n1103.8 \"Issen\" Ability { id: \"1E97\", source: \"Dojun-Maru\" } window 30,2.5\r\n\r\n1111.1 \"Issen\" Ability { id: \"1E97\", source: \"Dojun-Maru\" } jump 1036.1\r\n1117.2 \"Clockwork Medium\"\r\n1126.0 \"Juji Shuriken\"\r\n1131.7 \"Issen\"\r\n1136.8 \"Issen\"\r\n1143.2 \"Harakiri?\"\r\n\r\n#~~~~~~~~~#\r\n# YOJIMBO #\r\n#~~~~~~~~~#\r\n\r\n# -ii 1EA8 1EA9 1EA4\r\n\r\n# Short opener\r\n# Noh Theater will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"7B5\" } window 2000,5\r\n2009.5 \"Iai-Giri\" Ability { id: \"1EA2\", source: \"Yojimbo\" } window 2009.5,5\r\n2012.7 \"Wakizashi\" Ability { id: \"1EA1\", source: \"Yojimbo\" }\r\n2018.9 \"Wakizashi\" Ability { id: \"1EA1\", source: \"Yojimbo\" }\r\n2024.9 \"--untargetable--\"\r\n\r\n# Intermission 1\r\n2028.9 \"--sync--\" Ability { id: \"2517\", source: \"Kageyama\" } window 2028.9,5\r\n2031.0 \"Gratuity\" Ability { id: \"1EAE\", source: \"Kageyama\" }\r\n2037.1 \"Gratuity\" Ability { id: \"1EAE\", source: \"Kageyama\" }\r\n2039.1 \"Zeni Masshigura x4\" Ability { id: \"1EA7\", source: \"Daigoro\" }\r\n2043.1 \"--sync--\" Ability { id: \"2517\", source: \"Kageyama\" }\r\n2047.7 \"Zeni Masshigura x4\" Ability { id: \"1EA7\", source: \"Daigoro\" }\r\n2059.2 \"Zanmato\" Ability { id: \"2072\", source: \"Yojimbo\" } window 2059.2,10\r\n\r\n# Bridge\r\n2062.2 \"--targetable--\"\r\n2074.7 \"Wakizashi\" Ability { id: \"1EA1\", source: \"Yojimbo\" }\r\n2079.8 \"Metta-Giri\" Ability { id: \"1EA3\", source: \"Yojimbo\" }\r\n2091.0 \"Inoshikacho\" Ability { id: \"1EA5\", source: \"Yojimbo\" } window 30,30\r\n2096.2 \"Wakizashi\" Ability { id: \"1EA1\", source: \"Yojimbo\" }\r\n2100.2 \"Fragility (inner)\" # Ability { id: \"1EAA\", source: \"Inoshikacho\" }\r\n2104.2 \"Fragility (outer)\" # Ability { id: \"1EAA\", source: \"Inoshikacho\" }\r\n2106.2 \"Iai-Giri\" Ability { id: \"1EA2\", source: \"Yojimbo\" }\r\n2115.1 \"Dragon's Lair\" Ability { id: \"1EA6\", source: \"Yojimbo\" }\r\n2117.2 \"--untargetable--\"\r\n\r\n# Intermission 2\r\n2121.2 \"--sync--\" Ability { id: \"2517\", source: \"Kageyama\" }\r\n2123.3 \"Gratuity\" Ability { id: \"1EAE\", source: \"Kageyama\" }\r\n2125.3 \"Dragonfire\" # Ability { id: \"1EAB\", source: \"Dragon's Head\" }\r\n2129.4 \"Gratuity\" Ability { id: \"1EAE\", source: \"Kageyama\" }\r\n2131.4 \"Zeni Masshigura x4\" Ability { id: \"1EA7\", source: \"Daigoro\" } window 30,2.5\r\n2135.4 \"Gratuity\" Ability { id: \"1EAE\", source: \"Kageyama\" }\r\n2135.8 \"Dragonfire\" # Ability { id: \"1EAB\", source: \"Dragon's Head\" }\r\n2138.6 \"--sync--\" Ability { id: \"2517\", source: \"Kageyama\" }\r\n2140.1 \"Zeni Masshigura x4\" Ability { id: \"1EA7\", source: \"Daigoro\" }\r\n2146.2 \"Dragonfire\" # Ability { id: \"1EAB\", source: \"Dragon's Head\" }\r\n2148.8 \"Zeni Masshigura x4\" Ability { id: \"1EA7\", source: \"Daigoro\" }\r\n2155.1 \"Dragonstrike?\" # Ability { id: \"1EAD\", source: \"Dragon's Head\" }\r\n2159.5 \"Zanmato\" Ability { id: \"2072\", source: \"Yojimbo\" } window 90,10 # Making sure of no overlap with previous use.\r\n\r\n# Rotation\r\n2162.4 \"--targetable--\"\r\n2176.9 \"Metta-Giri\" Ability { id: \"1EA3\", source: \"Yojimbo\" }\r\n2184.1 \"Wakizashi\" Ability { id: \"1EA1\", source: \"Yojimbo\" }\r\n2189.2 \"Inoshikacho\" Ability { id: \"1EA5\", source: \"Yojimbo\" } window 30,30\r\n2194.3 \"Metta-Giri\" Ability { id: \"1EA3\", source: \"Yojimbo\" }\r\n2198.4 \"Fragility (inner)\" # Ability { id: \"1EAA\", source: \"Inoshikacho\" }\r\n2202.4 \"Fragility (outer)\" # Ability { id: \"1EAA\", source: \"Inoshikacho\" }\r\n2205.5 \"Iai-Giri\" Ability { id: \"1EA2\", source: \"Yojimbo\" }\r\n2215.7 \"Dragon's Lair\" Ability { id: \"1EA6\", source: \"Yojimbo\" }\r\n2224.9 \"Iai-Giri\" Ability { id: \"1EA2\", source: \"Yojimbo\" }\r\n2225.9 \"Dragonfire\" # Ability { id: \"1EAB\", source: \"Dragon's Head\" }\r\n2232.0 \"Wakizashi\" Ability { id: \"1EA1\", source: \"Yojimbo\" }\r\n2236.4 \"Dragonfire\" # Ability { id: \"1EAB\", source: \"Dragon's Head\" }\r\n2238.0 \"Wakizashi\" Ability { id: \"1EA1\", source: \"Yojimbo\" }\r\n2245.1 \"Iai-Giri\" Ability { id: \"1EA2\", source: \"Yojimbo\" } window 15,15\r\n2247.2 \"Dragonfire\" # Ability { id: \"1EAB\", source: \"Dragon's Head\" }\r\n2255.2 \"Metta-Giri\" Ability { id: \"1EA3\", source: \"Yojimbo\" }\r\n2255.8 \"Dragonstrike?\" # Ability { id: \"1EAD\", source: \"Dragon's Head\" }\r\n2262.4 \"Wakizashi\" Ability { id: \"1EA1\", source: \"Yojimbo\" }\r\n2268.5 \"Wakizashi\" Ability { id: \"1EA1\", source: \"Yojimbo\" }\r\n\r\n2278.7 \"Metta-Giri\" Ability { id: \"1EA3\", source: \"Yojimbo\" } jump 2176.9\r\n2285.9 \"Wakizashi\"\r\n2291.0 \"Inoshikacho\"\r\n2296.1 \"Metta-Giri\"\r\n2300.2 \"Fragility (inner)\"\r\n2304.2 \"Fragility (outer)\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/shisui_of_the_violet_tides.ts



const shisui_of_the_violet_tides_triggerSet = {
  id: 'ShisuiOfTheVioletTides',
  zoneId: zone_id/* default.ShisuiOfTheVioletTides */.Z.ShisuiOfTheVioletTides,
  timelineFile: 'shisui_of_the_violet_tides.txt',
  triggers: [{
    id: 'Shisui Amikiri Kamikiri Add',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '6238'
    },
    alertText: (_data, matches, output) => output.kill({
      name: matches.name
    }),
    outputStrings: {
      kill: {
        en: 'Kill ${name}',
        de: 'Besiege ${name}',
        fr: 'Tuez ${name}',
        ja: '${name}を倒す',
        cn: '击杀 ${name}',
        ko: '${name} 처치'
      }
    }
  }, {
    id: 'Shisui Amikiri Digestive Fluid',
    type: 'HeadMarker',
    netRegex: {
      id: '000E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Shisui Ruby Princess Seduce',
    type: 'StartsUsing',
    netRegex: {
      source: 'Ruby Princess',
      id: '1F7A',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get In Box',
        de: 'Geh in die Box',
        fr: 'Allez dans la boîte',
        ja: '箱に入る',
        cn: '进盒子',
        ko: '상자에 들어가기'
      }
    }
  }, {
    // This is what it's called!
    id: 'Shisui Ruby Princess Geothermal Flatulence',
    type: 'HeadMarker',
    netRegex: {
      id: '0001'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Chasing AOE on YOU',
        de: 'Verfolgende AoE auf DIR',
        fr: 'Ruée sur VOUS',
        ja: '追跡AOE',
        cn: '追踪AOE点名',
        ko: '연속장판 대상자'
      }
    }
  }, {
    id: 'Shisui Shisui Yohi Naishi-No-Kami',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '6244',
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'Shisui Shisui Yohi Mad Stare',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shisui Yohi',
      id: '1F82',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Amikiri': 'Amikiri',
      'Naishi-No-Kami': 'Naishi no Kami',
      'Ruby Princess': 'Rubinprinzessin',
      'Shisui Gokagura': 'Shisui Gokagura',
      'Shisui Yohi': 'Shisui Yohi',
      'The Akashio Hall': 'Akashio-Halle',
      'The Harutsuge Gate': 'Haratsuge-Tor'
    },
    'replaceText': {
      '--add--': '--Add--',
      '--adds--': '--Adds--',
      'Abyssal Volcano': 'Submariner Vulkan',
      'Black Tide': 'Schwarze Flut',
      'Coriolis Kick': 'Coriolis-Kick',
      'Digest': 'Verdauen',
      'Foul Nail': 'Hexenkralle',
      'Geothermal Flatulence': 'Vulkanausbruch',
      'Mad Stare': 'Verrückter Blick',
      'Mucal Glob': 'Schleimklumpen',
      'Seduce': 'Versuchung',
      'Sharp Strike': 'Spitzer Schlag',
      'Shuck': 'Enthülsen',
      'Thick Fog': 'Dichter Nebel',
      'Tornadogenesis': 'Tornadogenese'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Amikiri': 'Amikiri',
      'Naishi-No-Kami': 'Naishi no Kami',
      'Ruby Princess': 'Princesse de Rubis',
      'Shisui Gokagura': 'Shisui Gokagura',
      'Shisui Yohi': 'Shisui Yohi',
      'The Akashio Hall': 'Chambre d\'Akashio',
      'The Harutsuge Gate': 'Porte de Harutsuge'
    },
    'replaceText': {
      '\\?': ' ?',
      '--add--': '--add--',
      '--adds--': '--adds--',
      'Abyssal Volcano': 'Volcan abyssal',
      'Black Tide': 'Marée noire',
      'Coriolis Kick': 'Coup de pied Coriolis',
      'Digest': 'Digestion',
      'Foul Nail': 'Ongle fétide',
      'Geothermal Flatulence': 'Éruption volcanique',
      'Mad Stare': 'Regard fou',
      'Mucal Glob': 'Globe de mucus',
      'Seduce': 'Séduction',
      'Sharp Strike': 'Frappe tranchante',
      'Shuck': 'Décorticage',
      'Thick Fog': 'Brouillard épais',
      'Tornadogenesis': 'Tornadogénèse'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Amikiri': 'アミキリ',
      'Naishi-No-Kami': 'ナイシノカミ',
      'Ruby Princess': '紅玉姫',
      'Shisui Gokagura': '紫水御神楽',
      'Shisui Yohi': '紫水妖妃',
      'The Akashio Hall': '紅潮之間',
      'The Harutsuge Gate': '春告門前'
    },
    'replaceText': {
      'Abyssal Volcano': '海底火山',
      'Black Tide': 'ブラックタイド',
      'Coriolis Kick': '大嵐蹴',
      'Digest': '消化',
      'Foul Nail': 'ウィッチクロウ',
      'Geothermal Flatulence': '噴火',
      'Mad Stare': '狂気の視線',
      'Mucal Glob': '粘液玉',
      'Seduce': '誘惑',
      'Sharp Strike': 'シャープストライク',
      'Shuck': 'シェルブレイカー',
      'Thick Fog': '濃霧',
      'Tornadogenesis': '竜巻蹴'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Amikiri': '切网虾蛄',
      'Naishi-No-Kami': '尚侍',
      'Ruby Princess': '红玉公主',
      'Shisui Gokagura': '紫水御神乐',
      'Shisui Yohi': '紫水妖妃',
      'The Akashio Hall': '红潮之间',
      'The Harutsuge Gate': '春告门前'
    },
    'replaceText': {
      '--add--': '--小怪--',
      '--adds--': '--小怪--',
      'Abyssal Volcano': '海底火山',
      'Black Tide': '黑潮',
      'Coriolis Kick': '暴风踢',
      'Digest': '消化',
      'Foul Nail': '巫婆魔爪',
      'Geothermal Flatulence': '火山喷发',
      'Mad Stare': '疯狂视线',
      'Mucal Glob': '粘液球',
      'Seduce': '诱惑',
      'Sharp Strike': '突然袭击',
      'Shuck': '碎壳重击',
      'Thick Fog': '浓雾',
      'Tornadogenesis': '旋风踢'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Amikiri': '아미키리',
      'Naishi-No-Kami': '시스이 상궁',
      'Ruby Princess': '홍옥 공주',
      'Shisui Gokagura': '시스이 누대',
      'Shisui Yohi': '시스이 요비',
      'The Akashio Hall': '아카시오의 방',
      'The Harutsuge Gate': '하루츠게 문'
    },
    'replaceText': {
      '--add--': '--쫄--',
      '--adds--': '--쫄--',
      'Abyssal Volcano': '해저 화산',
      'Black Tide': '검은 파도',
      'Coriolis Kick': '태풍차기',
      'Digest': '소화',
      'Foul Nail': '마녀의 손톱',
      'Geothermal Flatulence': '분화',
      'Mad Stare': '광기 어린 시선',
      'Mucal Glob': '점액 방울',
      'Seduce': '유혹',
      'Sharp Strike': '날카로운 일격',
      'Shuck': '껍데기 파괴',
      'Thick Fog': '짙은 안개',
      'Tornadogenesis': '회오리차기'
    }
  }]
};
/* harmony default export */ const shisui_of_the_violet_tides = (shisui_of_the_violet_tides_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/shisui_of_the_violet_tides.txt
const dungeon_shisui_of_the_violet_tides_namespaceObject = "hideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Amikiri\r\n# -p 1F72:4.5 1F73:100\r\n# -ii 1F74 1F78 1F77\r\n# -ic \"Kamikiri\"\r\n\r\n# Phase 1: 100% -> 90%, autos + mini busters\r\n# Harutsuge Gate will be sealed off\r\n0.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"796\" } window 10000,0\r\n4.5 \"Sharp Strike\" Ability { id: \"1F72\", source: \"Amikiri\" } window 20,20\r\n12.7 \"Sharp Strike\" #Ability { id: \"1F72\", source: \"Amikiri\" }\r\n20.9 \"Sharp Strike\" #Ability { id: \"1F72\", source: \"Amikiri\" }\r\n29.1 \"Sharp Strike\" #Ability { id: \"1F72\", source: \"Amikiri\" }\r\n37.3 \"Sharp Strike\" #Ability { id: \"1F72\", source: \"Amikiri\" }\r\n\r\n# Phase 2: 90% -> 0%\r\n# Ignoring Sharp Strike (1F72) at this point, as timing is odd depending on Shuck failure.\r\n# There's also Sharp Strikes from the Kamikiri add as well, with its own inconsistent timing.\r\n# Also, there's no 0x14 lines for any of these things but Shuck.\r\n100.0 \"Mucal Glob\" Ability { id: \"1F73\", source: \"Amikiri\" } window 100,0\r\n132.2 \"Shuck?\" Ability { id: \"1F75\", source: \"Amikiri\" }\r\n149.1 \"--add--\"\r\n161.8 \"Digest\" Ability { id: \"1F79\", source: \"Amikiri\" }\r\n\r\n# TODO: is there another phase push in here that makes this Mucal Glob come earlier?\r\n181.7 \"--add--\"\r\n182.2 \"Mucal Glob\" Ability { id: \"1F73\", source: \"Amikiri\" } window 30,30\r\n194.4 \"Digest\" Ability { id: \"1F79\", source: \"Amikiri\" }\r\n214.4 \"Shuck?\" Ability { id: \"1F75\", source: \"Amikiri\" }\r\n229.5 \"Digest\" Ability { id: \"1F79\", source: \"Amikiri\" }\r\n\r\n249.4 \"--add--\"\r\n249.9 \"Mucal Glob\" Ability { id: \"1F73\", source: \"Amikiri\" } window 30,30 jump 182.2\r\n262.1 \"Digest\" #Ability { id: \"1F79\", source: \"Amikiri\" }\r\n282.1 \"Shuck?\" #Ability { id: \"1F75\", source: \"Amikiri\" }\r\n292.2 \"Digest\" #Ability { id: \"1F79\", source: \"Amikiri\" }\r\n\r\n\r\n### Ruby Princess\r\n# -p 1F7F:1006.4 1F7A:1107.0 1F7C:1203\r\n# -ii 1F7E 1F7D\r\n\r\n# Phase 1: 100 -> 90%, autos + mini busters\r\n# Akashio Hall will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"797\" } window 10000,0\r\n1006.4 \"Tornadogenesis\" Ability { id: \"1F7F\", source: \"Ruby Princess\" } window 20,20\r\n1013.5 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1020.6 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1027.7 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1034.8 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1041.9 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n\r\n# Phase 2: 90% -> 75%, one seduce, more mini busters\r\n1100.0 \"--sync--\" StartsUsing { id: \"1F7A\", source: \"Ruby Princess\" } window 100,0\r\n1107.0 \"Seduce\" Ability { id: \"1F7A\", source: \"Ruby Princess\" }\r\n1115.1 \"Coriolis Kick\" Ability { id: \"1F7B\", source: \"Ruby Princess\" }\r\n1121.3 \"Tornadogenesis\" Ability { id: \"1F7F\", source: \"Ruby Princess\" } window 20,20\r\n1126.4 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1131.5 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1136.6 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1141.7 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1146.8 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n\r\n# Phase 3: 75% -> 60%, introduction to chasing AOE\r\n1200.0 \"--sync--\" StartsUsing { id: \"1F7C\", source: \"Ruby Princess\" } window 200,0\r\n1203.0 \"Abyssal Volcano\" Ability { id: \"1F7C\", source: \"Ruby Princess\" }\r\n1203.8 \"Geothermal Flatulence x11\" Ability { id: \"24D7\", source: \"Ruby Princess\" } duration 8.1\r\n1217.2 \"Coriolis Kick\" Ability { id: \"1F7B\", source: \"Ruby Princess\" }\r\n1225.4 \"Tornadogenesis\" Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1232.5 \"Tornadogenesis\" Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n\r\n1244.7 \"Abyssal Volcano\" Ability { id: \"1F7C\", source: \"Ruby Princess\" } window 30,30 jump 1203\r\n1245.5 \"Geothermal Flatulence x11\" #Ability { id: \"24D7\", source: \"Ruby Princess\" } duration 8.1\r\n1258.9 \"Coriolis Kick\" #Ability { id: \"1F7B\", source: \"Ruby Princess\" }\r\n1267.1 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1274.2 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n\r\n# Phase 4: 60% -> 0%, seduce loop\r\n1400.0 \"--sync--\" StartsUsing { id: \"1F7A\", source: \"Ruby Princess\" } window 290,0\r\n1407.0 \"Seduce\" Ability { id: \"1F7A\", source: \"Ruby Princess\" }\r\n1415.1 \"Coriolis Kick\" Ability { id: \"1F7B\", source: \"Ruby Princess\" }\r\n1423.3 \"Tornadogenesis\" Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1430.4 \"Tornadogenesis\" Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1437.5 \"Tornadogenesis\" Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n\r\n1449.7 \"Abyssal Volcano\" Ability { id: \"1F7C\", source: \"Ruby Princess\" }\r\n1450.5 \"Geothermal Flatulence x11\" Ability { id: \"24D7\", source: \"Ruby Princess\" } duration 8.1\r\n1465.7 \"Seduce\" Ability { id: \"1F7A\", source: \"Ruby Princess\" }\r\n1473.8 \"Coriolis Kick\" Ability { id: \"1F7B\", source: \"Ruby Princess\" }\r\n1482.0 \"Tornadogenesis\" Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1489.1 \"Tornadogenesis\" Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1496.2 \"Tornadogenesis\" Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1512.9 \"Seduce\" Ability { id: \"1F7A\", source: \"Ruby Princess\" }\r\n1521.1 \"Coriolis Kick\" Ability { id: \"1F7B\", source: \"Ruby Princess\" }\r\n1529.3 \"Tornadogenesis\" Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1536.4 \"Tornadogenesis\" Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1543.5 \"Tornadogenesis\" Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n\r\n1555.6 \"Abyssal Volcano\" Ability { id: \"1F7C\", source: \"Ruby Princess\" } window 50,50 jump 1449.7\r\n1556.4 \"Geothermal Flatulence x11\" #Ability { id: \"24D7\", source: \"Ruby Princess\" } duration 8.1\r\n1571.4 \"Seduce\" #Ability { id: \"1F7A\", source: \"Ruby Princess\" }\r\n1579.5 \"Coriolis Kick\" #Ability { id: \"1F7B\", source: \"Ruby Princess\" }\r\n1587.7 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1594.8 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1602.0 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1618.9 \"Seduce\" #Ability { id: \"1F7A\", source: \"Ruby Princess\" }\r\n1627.0 \"Coriolis Kick\" #Ability { id: \"1F7B\", source: \"Ruby Princess\" }\r\n1635.2 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1642.3 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n1649.4 \"Tornadogenesis\" #Ability { id: \"1F7F\", source: \"Ruby Princess\" }\r\n\r\n\r\n### Shisui Yohi (and friends)\r\n# -p 1F87:2006.5 1F80:2105\r\n# -ii 1FF7 1F83 1F84 1F85 1F86\r\n# -it \"Shisui Yohi\"\r\n\r\n# Phase 1: 100% -> 90%, autos and mini busters\r\n# Shisui Gokagura will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"798\" } window 10000,0\r\n2006.5 \"Foul Nail\" Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2013.6 \"Foul Nail\" Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n\r\n2023.8 \"Foul Nail\" Ability { id: \"1F87\", source: \"Shisui Yohi\" } window 5,5 jump 2006.5\r\n2030.9 \"Foul Nail\" #Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n\r\n2041.1 \"Foul Nail\" #Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2048.2 \"Foul Nail\" #Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n\r\n# Phase 2: 90% -> 75%, one (1) thick fog\r\n2100.0 \"--sync--\" StartsUsing { id: \"1F80\", source: \"Shisui Yohi\" } window 100,0\r\n2105.0 \"Thick Fog\" Ability { id: \"1F80\", source: \"Shisui Yohi\" }\r\n2108.1 \"--untargetable--\"\r\n2128.3 \"Black Tide\" Ability { id: \"1F81\", source: \"Shisui Yohi\" } window 30,30\r\n2131.3 \"--targetable--\"\r\n\r\n2136.4 \"Foul Nail\" Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2146.5 \"Mad Stare\" Ability { id: \"1F82\", source: \"Shisui Yohi\" }\r\n2153.7 \"Foul Nail\" Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2160.8 \"Foul Nail\" Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n\r\n2170.9 \"Mad Stare\" Ability { id: \"1F82\", source: \"Shisui Yohi\" } window 10,10 jump 2146.5\r\n2178.1 \"Foul Nail\" #Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2185.2 \"Foul Nail\" #Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n\r\n2195.3 \"Mad Stare\" #Ability { id: \"1F82\", source: \"Shisui Yohi\" }\r\n2202.5 \"Foul Nail\" #Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2209.6 \"Foul Nail\" #Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n\r\n# Phase 3: 75% -> 60%, introduction to adds\r\n2300.0 \"--adds--\" AddedCombatant { name: \"Naishi-No-Kami\" } window 300,0\r\n2303.4 \"Foul Nail\" Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2313.5 \"Mad Stare\" Ability { id: \"1F82\", source: \"Shisui Yohi\" }\r\n\r\n2320.7 \"Foul Nail\" Ability { id: \"1F87\", source: \"Shisui Yohi\" } window 5,30\r\n2325.8 \"Foul Nail\" Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2330.9 \"Foul Nail\" #Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2336.0 \"Foul Nail\" #Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2343.1 \"Foul Nail\" #Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2350.2 \"Foul Nail\" #Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n\r\n# Phase 4: 60% -> 0%, thick fog and adds loop\r\n2400.0 \"--sync--\" StartsUsing { id: \"1F80\", source: \"Shisui Yohi\" } window 100,0\r\n2405.0 \"Thick Fog\" Ability { id: \"1F80\", source: \"Shisui Yohi\" }\r\n2408.1 \"--untargetable--\"\r\n2428.3 \"Black Tide\" Ability { id: \"1F81\", source: \"Shisui Yohi\" }\r\n2431.3 \"--targetable--\"\r\n2435.4 \"Foul Nail\" Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2441.5 \"Foul Nail\" Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2447.7 \"Foul Nail\" Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2457.8 \"Mad Stare\" Ability { id: \"1F82\", source: \"Shisui Yohi\" }\r\n2459.3 \"--adds--\"\r\n\r\n2477.0 \"Thick Fog\" Ability { id: \"1F80\", source: \"Shisui Yohi\" } window 30,30 jump 2405\r\n2480.1 \"--untargetable--\"\r\n2510.4 \"Black Tide\" #Ability { id: \"1F81\", source: \"Shisui Yohi\" }\r\n2513.4 \"--targetable--\"\r\n2517.5 \"Foul Nail\" #Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2523.6 \"Foul Nail\" #Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2529.7 \"Foul Nail\" #Ability { id: \"1F87\", source: \"Shisui Yohi\" }\r\n2539.8 \"Mad Stare\" #Ability { id: \"1F82\", source: \"Shisui Yohi\" }\r\n2541.3 \"--adds--\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/sirensong_sea.ts



const sirensong_sea_triggerSet = {
  id: 'TheSirensongSea',
  zoneId: zone_id/* default.TheSirensongSea */.Z.TheSirensongSea,
  timelineFile: 'sirensong_sea.txt',
  timelineTriggers: [{
    id: 'Sirensong Lorelei Head Butt',
    regex: /Head Butt/,
    beforeSeconds: 6,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }],
  triggers: [{
    id: 'Sirensong Lugat Hydroball',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Sirensong Lugat Sea Swallows All',
    type: 'StartsUsing',
    netRegex: {
      source: 'Lugat',
      id: '1F58',
      capture: false
    },
    response: responses/* Responses.drawIn */.n3.drawIn()
  }, {
    id: 'Sirensong Lugat Overtow',
    type: 'StartsUsing',
    netRegex: {
      source: 'Lugat',
      id: '1F59',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback('info')
  }, {
    id: 'Sirensong Governor Shadowflow',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Governor',
      id: '1F5E',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Shadows',
        de: 'Schatten ausweichen',
        fr: 'Évitez les ombres',
        ja: '影を避ける',
        cn: '避开阴影',
        ko: '그림자 피하기'
      }
    }
  }, {
    id: 'Sirensong Governor Bloodburst',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Governor',
      id: '1F5C',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Sirensong Governor Enter Night',
    type: 'HeadMarker',
    netRegex: {
      id: '0016'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Sirensong Fleshless Captive Seductive Scream',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fleshless Captive',
      id: '2352'
    },
    response: responses/* Responses.stunOrInterruptIfPossible */.n3.stunOrInterruptIfPossible()
  }, {
    id: 'Sirensong Lorelei Morbid Advance',
    type: 'StartsUsing',
    netRegex: {
      source: 'Lorelei',
      id: '1F65',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Forward March',
        de: 'Marchiere Vorwärts',
        fr: 'Marche avant forcée',
        ja: '強制移動: 前',
        cn: '强制移动: 前',
        ko: '정신 장악: 앞'
      }
    }
  }, {
    id: 'Sirensong Lorelei Morbid Retreat',
    type: 'StartsUsing',
    netRegex: {
      source: 'Lorelei',
      id: '1F66',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Backwards March',
        de: 'Marchiere Rückwärts',
        fr: 'Marche forcée en arrière',
        ja: '強制移動: 後ろ',
        cn: '强制移动: 后',
        ko: '정신 장악: 뒤'
      }
    }
  }, {
    id: 'Sirensong Lorelei Somber Melody',
    type: 'StartsUsing',
    netRegex: {
      source: 'Lorelei',
      id: '1F67',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Morbid Advance/Morbid Retreat': 'Morbid Advance/Retreat'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Spae Rock': 'Gespensterfelsen',
      'Lugat': 'Lugat',
      'Warden\'s Delight': 'Trauersteg',
      'The Governor': 'Friedhofsvorsteher',
      'The Groveller': 'Knecht',
      'Glowering Krautz': 'Krautz-Leuchtturm',
      'Lorelei': 'Loreley',
      'Fleshless Captive': 'entfleischt(?:e|er|es|en) Gefangen(?:e|er|es|en)'
    },
    'replaceText': {
      'Amorphous Applause': 'Amorpher Applaus',
      'Hydroball': 'Wasserbombe',
      'Sea Swallows All': 'Strudel',
      'Concussive Oscillation': 'Erschütternde Oszillation',
      'Overtow': 'Schnellfluss',
      'Shadowflow': 'Schattenfluss',
      'Bloodburst': 'Blutstoß',
      'Enter Night': 'Einbruch der Nacht',
      'Shadow Split': 'Splitterschatten',
      'Virgin Tears': 'Jungferntränen',
      'Morbid Advance': 'Morbider Marsch',
      'Morbid Retreat': 'Morbider Rückzug',
      'Head Butt': 'Kopfstoß',
      'Somber Melody': 'Schwermütige Melodie',
      'Void Water III': 'Nichts-Aquaga'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Spae Rock': 'Rocher aux Spectres',
      'Lugat': 'Lugat',
      'Warden\'s Delight': 'Délice du gardien',
      'The Governor': 'Gouverneur',
      'The Groveller': 'Quémandeur',
      'Glowering Krautz': 'Phare de Krautz',
      'Lorelei': 'Lorelei',
      'Fleshless Captive': 'fantôme de prisonnier'
    },
    'replaceText': {
      'Amorphous Applause': 'Applaudissement amorphe',
      'Hydroball': 'Hydroballe',
      'Sea Swallows All': 'Gouffre de la mer',
      'Concussive Oscillation': 'Oscillation commotionnelle',
      'Overtow': 'Débordement',
      'Shadowflow': 'Flux d\'ombre',
      'Bloodburst': 'Explosion sanguine',
      'Enter Night': 'Appel de la nuit',
      'Shadow Split': 'Division d\'ombre',
      'Virgin Tears': 'Larmes de vierge',
      'Morbid Advance/Morbid Retreat': 'Avancée/Retraite morbide',
      'Head Butt': 'Coup de tête',
      'Somber Melody': 'Sombre mélodie',
      'Void Water III': 'Méga Eau du néant'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Spae Rock': '亡霊の岩場',
      'Lugat': 'ルガト',
      'Warden\'s Delight': '看守長の遊技場',
      'The Governor': 'ガバナー',
      'The Groveller': 'グロヴェラー',
      'Glowering Krautz': 'クラウツ大灯台',
      'Lorelei': 'ローレライ',
      'Fleshless Captive': 'レイス・プリズナー'
    },
    'replaceText': {
      'Amorphous Applause': 'ハンドクラップ',
      'Hydroball': 'ハイドロボール',
      'Sea Swallows All': 'ホワールプール',
      'Concussive Oscillation': 'コンカシヴ・オレーション',
      'Overtow': 'ハイフロウ',
      'Shadowflow': 'シャドウフロウ',
      'Bloodburst': 'ブラッドバースト',
      'Enter Night': 'エンターナイト',
      'Shadow Split': 'シャドウスプリット',
      'Virgin Tears': '乙女の涙',
      'Morbid Advance': 'デスマーチ：前進',
      'Morbid Retreat': 'デスマーチ：後退',
      'Head Butt': 'ヘッドバット',
      'Somber Melody': 'ソンバーメロディー',
      'Void Water III': 'ヴォイド・ウォタガ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Spae Rock': '亡灵岩场',
      'Lugat': '卢加特',
      'Warden\'s Delight': '狱长的娱乐场',
      'The Governor': '狱长',
      'The Groveller': '奴仆',
      'Glowering Krautz': '克劳茨大灯塔',
      'Lorelei': '罗蕾莱',
      'Fleshless Captive': '幽灵囚徒'
    },
    'replaceText': {
      'Amorphous Applause': '莫名击掌',
      'Hydroball': '水力球',
      'Sea Swallows All': '漩涡',
      'Concussive Oscillation': '振荡气流',
      'Overtow': '潮起',
      'Shadowflow': '暗影流',
      'Bloodburst': '血爆',
      'Enter Night': '入夜',
      'Shadow Split': '暗影分裂',
      'Virgin Tears': '少女之泪',
      'Morbid Advance': '死亡行进：前',
      'Morbid Retreat': '死亡行进：后',
      'Head Butt': '冲顶',
      'Somber Melody': '忧郁旋律',
      'Void Water III': '虚空狂水'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Spae Rock': '망령의 바위터',
      'Lugat': '루가트',
      'Warden\'s Delight': '간수장의 놀이터',
      'The Governor': '간수장',
      'The Groveller': '그림자 죄수',
      'Glowering Krautz': '크라우츠 대등대',
      'Lorelei': '로렐라이',
      'Fleshless Captive': '망령 죄수'
    },
    'replaceText': {
      'Amorphous Applause': '무형의 갈채',
      'Hydroball': '물탄환',
      'Sea Swallows All': '소용돌이',
      'Concussive Oscillation': '격렬한 진동',
      'Overtow': '높은 밀물',
      'Shadowflow': '그림자 흐름',
      'Bloodburst': '피의 범람',
      'Enter Night': '밤의 서막',
      'Shadow Split': '그림자 분열',
      'Virgin Tears': '소녀의 눈물',
      'Morbid Advance': '죽음의 전진',
      'Morbid Retreat': '죽음의 후진',
      'Head Butt': '박치기',
      'Somber Melody': '침울한 선율',
      'Void Water III': '보이드 워터가'
    }
  }]
};
/* harmony default export */ const sirensong_sea = (sirensong_sea_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/sirensong_sea.txt
const dungeon_sirensong_sea_namespaceObject = "### The Sirensong Sea\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Lugat\r\n# -p 1F56:18.5\r\n# -ii 1F5A\r\n\r\n# Spae Rock will be sealed off\r\n0.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"7A9\" } window 0,1\r\n18.5 \"Amorphous Applause\" Ability { id: \"1F56\", source: \"Lugat\" }\r\n29.6 \"Hydroball\" Ability { id: \"1F57\", source: \"Lugat\" }\r\n\r\n41.4 \"Sea Swallows All\" Ability { id: \"1F58\", source: \"Lugat\" }\r\n47.1 \"Concussive Oscillation\" Ability { id: \"1F5B\", source: \"Lugat\" }\r\n54.0 \"Amorphous Applause\" Ability { id: \"1F56\", source: \"Lugat\" }\r\n70.2 \"Amorphous Applause\" Ability { id: \"1F56\", source: \"Lugat\" }\r\n80.0 \"Overtow\" Ability { id: \"1F59\", source: \"Lugat\" }\r\n87.3 \"Hydroball\" Ability { id: \"1F57\", source: \"Lugat\" }\r\n94.5 \"Amorphous Applause\" Ability { id: \"1F56\", source: \"Lugat\" }\r\n110.7 \"Amorphous Applause\" Ability { id: \"1F56\", source: \"Lugat\" }\r\n\r\n120.2 \"Sea Swallows All\" Ability { id: \"1F58\", source: \"Lugat\" } window 30,30 jump 41.4\r\n125.9 \"Concussive Oscillation\" #Ability { id: \"1F5B\", source: \"Lugat\" }\r\n132.8 \"Amorphous Applause\" #Ability { id: \"1F56\", source: \"Lugat\" }\r\n149.0 \"Amorphous Applause\" #Ability { id: \"1F56\", source: \"Lugat\" }\r\n158.8 \"Overtow\" #Ability { id: \"1F59\", source: \"Lugat\" }\r\n166.1 \"Hydroball\" #Ability { id: \"1F57\", source: \"Lugat\" }\r\n173.3 \"Amorphous Applause\" #Ability { id: \"1F56\", source: \"Lugat\" }\r\n189.5 \"Amorphous Applause\" #Ability { id: \"1F56\", source: \"Lugat\" }\r\n\r\n\r\n### The Governor\r\n# -p 1F5E:1017.5\r\n# -ii 1F5D\r\n\r\n# Warden's Delight will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"7AB\" } window 1000,5\r\n1017.5 \"Shadowflow\" Ability { id: \"1F5E\", source: \"The Governor\" }\r\n1018.0 \"--sync--\" Ability { id: \"1F5F\", source: \"The Governor\" }\r\n1034.6 \"Bloodburst\" Ability { id: \"1F5C\", source: \"The Governor\" }\r\n\r\n1042.8 \"Enter Night\" Ability { id: \"1F60\", source: \"The Governor\" } window 10,10\r\n# Enter Night can take 12-17 seconds.  There is added delay when the mechanic\r\n# is failed due to Shadowstrike (1F5D) attacks.\r\n1055.9 \"--sync--\" StartsUsing { id: \"1F5C\", source: \"The Governor\" } window 10,10\r\n1059.9 \"Bloodburst\" Ability { id: \"1F5C\", source: \"The Governor\" }\r\n# There is potential delay before Shadow Split due to the boss moving to the middle.\r\n1065.0 \"--sync--\" StartsUsing { id: \"1F61\", source: \"The Governor\" } window 10,10\r\n1068.0 \"Shadow Split\" Ability { id: \"1F61\", source: \"The Governor\" }\r\n1076.2 \"Shadowflow\" Ability { id: \"1F5E\", source: \"The Governor\" }\r\n1076.7 \"--sync--\" Ability { id: \"1F5F\", source: \"The Governor\" }\r\n1077.1 \"Shadowflow\" Ability { id: \"1F62\", source: \"The Groveller\" }\r\n1093.4 \"Bloodburst\" Ability { id: \"1F5C\", source: \"The Governor\" }\r\n\r\n1102.6 \"Enter Night\" Ability { id: \"1F60\", source: \"The Governor\" } window 30,30 jump 1042.8\r\n1115.7 \"--sync--\" #StartsUsing { id: \"1F5C\", source: \"The Governor\" } window 10,10\r\n1119.7 \"Bloodburst\" #Ability { id: \"1F5C\", source: \"The Governor\" }\r\n1124.8 \"--sync--\" #StartsUsing { id: \"1F61\", source: \"The Governor\" } window 10,10\r\n1127.8 \"Shadow Split\" #Ability { id: \"1F61\", source: \"The Governor\" }\r\n1136.0 \"Shadowflow\" #Ability { id: \"1F5E\", source: \"The Governor\" }\r\n1136.5 \"--sync--\" #Ability { id: \"1F5F\", source: \"The Governor\" }\r\n1136.9 \"Shadowflow\" #Ability { id: \"1F62\", source: \"The Groveller\" }\r\n1153.2 \"Bloodburst\" #Ability { id: \"1F5C\", source: \"The Governor\" }\r\n\r\n\r\n### Lorelei\r\n# -p 1F69:2011.5\r\n# -ii 1F63\r\n\r\n# Glowering Krautz will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"7AD\" } window 2000,5\r\n2011.5 \"Virgin Tears\" Ability { id: \"1F69\", source: \"Lorelei\" }\r\n2024.7 \"Morbid Advance/Morbid Retreat\" Ability { id: \"1F6[56]\", source: \"Lorelei\" }\r\n2033.9 \"Head Butt\" Ability { id: \"1F64\", source: \"Lorelei\" }\r\n\r\n2041.1 \"Virgin Tears\" Ability { id: \"1F69\", source: \"Lorelei\" }\r\n2054.2 \"Morbid Advance/Morbid Retreat\" Ability { id: \"1F6[56]\", source: \"Lorelei\" }\r\n2062.3 \"Somber Melody\" Ability { id: \"1F67\", source: \"Lorelei\" }\r\n2066.0 \"Head Butt\" Ability { id: \"1F64\", source: \"Lorelei\" }\r\n\r\n2072.2 \"Virgin Tears\" Ability { id: \"1F69\", source: \"Lorelei\" }\r\n2085.4 \"Morbid Advance/Morbid Retreat\" Ability { id: \"1F6[56]\", source: \"Lorelei\" }\r\n2094.6 \"Head Butt\" Ability { id: \"1F64\", source: \"Lorelei\" }\r\n\r\n2102.8 \"Virgin Tears\" Ability { id: \"1F69\", source: \"Lorelei\" } window 10,10\r\n2116.5 \"Morbid Advance/Morbid Retreat\" Ability { id: \"1F6[56]\", source: \"Lorelei\" }\r\n2123.7 \"Void Water III\" Ability { id: \"1F68\", source: \"Lorelei\" }\r\n2129.8 \"Somber Melody\" Ability { id: \"1F67\", source: \"Lorelei\" }\r\n2135.0 \"Head Butt\" Ability { id: \"1F64\", source: \"Lorelei\" }\r\n2143.6 \"Void Water III\" Ability { id: \"1F68\", source: \"Lorelei\" }\r\n\r\n# the first 2x void water section above has a slightly different timing\r\n# on advance/retreat (0.5s longer?) so extend this out one more loop.\r\n2155.9 \"Virgin Tears\" Ability { id: \"1F69\", source: \"Lorelei\" } window 10,10\r\n2169.1 \"Morbid Advance/Morbid Retreat\" Ability { id: \"1F6[56]\", source: \"Lorelei\" }\r\n2176.4 \"Void Water III\" Ability { id: \"1F68\", source: \"Lorelei\" }\r\n2182.5 \"Somber Melody\" Ability { id: \"1F67\", source: \"Lorelei\" }\r\n2187.7 \"Head Butt\" Ability { id: \"1F64\", source: \"Lorelei\" }\r\n2196.3 \"Void Water III\" Ability { id: \"1F68\", source: \"Lorelei\" }\r\n\r\n2208.5 \"Virgin Tears\" Ability { id: \"1F69\", source: \"Lorelei\" } window 30,30 jump 2155.9\r\n2221.7 \"Morbid Advance/Morbid Retreat\" #Ability { id: \"1F6[56]\", source: \"Lorelei\" }\r\n2229.0 \"Void Water III\" #Ability { id: \"1F68\", source: \"Lorelei\" }\r\n2235.1 \"Somber Melody\" #Ability { id: \"1F67\", source: \"Lorelei\" }\r\n2240.3 \"Head Butt\" #Ability { id: \"1F64\", source: \"Lorelei\" }\r\n2248.9 \"Void Water III\" #Ability { id: \"1F68\", source: \"Lorelei\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/st_mocianne_hard.ts



const st_mocianne_hard_triggerSet = {
  id: 'SaintMociannesArboretumHard',
  zoneId: zone_id/* default.SaintMociannesArboretumHard */.Z.SaintMociannesArboretumHard,
  timelineFile: 'st_mocianne_hard.txt',
  timelineTriggers: [{
    id: 'St Mocianne Hard Quickmire',
    regex: /Quickmire/,
    beforeSeconds: 7,
    // This is approximately when the sewage surge begins.
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Be On A Platform',
        de: 'Sei auf einer Plattform',
        fr: 'Restez sur une plateforme ',
        ja: '円形床の上へ',
        cn: '站台子上',
        ko: '원형 바닥 위로'
      }
    }
  }],
  triggers: [{
    // Trash mob gaze attack
    id: 'St Mocianne Hard Frond Fatale',
    type: 'StartsUsing',
    netRegex: {
      id: '31A4',
      source: 'Withered Belladonna'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'St Mocianne Hard Vine Whip',
    type: 'StartsUsing',
    netRegex: {
      id: '2E48',
      source: 'Nullchu'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'St Mocianne Hard Sludge Bomb',
    type: 'HeadMarker',
    netRegex: {
      id: '0001'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sludge puddle on YOU',
        de: 'Schlammfläche auf DIR',
        fr: 'Zone de poison au sol sur VOUS',
        ja: '自分にスラッジボム',
        cn: '泥浆炸弹点名',
        ko: '독장판 대상자'
      }
    }
  }, {
    id: 'St Mocianne Hard Fault Warren',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    suppressSeconds: 5,
    // There are two (!!) simultaneous head markers on the same target here.
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'St Mocianne Hard Taproot',
    type: 'HeadMarker',
    netRegex: {
      id: '008D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'St Mocianne Hard Devour',
    type: 'StartsUsing',
    netRegex: {
      id: '2E4F',
      source: 'Nullchu',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get behind flower',
        de: 'Geh hinter die Blume',
        fr: 'Passez derrière la plante',
        ja: 'ボスの後ろへ',
        cn: '躲背后',
        ko: '꽃 뒤로'
      }
    }
  }, {
    id: 'St Mocianne Hard Stone II',
    type: 'StartsUsing',
    netRegex: {
      id: '312A',
      source: 'Lakhamu'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'St Mocianne Hard Tectonics',
    type: 'StartsUsing',
    netRegex: {
      id: '312C',
      source: 'Lakhamu',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'St Mocianne Hard Landslip',
    type: 'StartsUsing',
    netRegex: {
      id: '3132',
      source: 'Silt Golem'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Conveyors: Avoid Golem Lines',
        de: 'Transportbänder: Weiche den Golemlinien aus',
        fr: 'Transporteurs : Évitez les lignes des golems',
        ja: '強制移動: ゴーレムの直線を避ける',
        cn: '传送: 注意躲开巨像的直线AoE',
        ko: '넉백: 골렘이 있는 줄 피하기'
      }
    }
  }, {
    id: 'St Mocianne Hard Eath Shaker',
    type: 'HeadMarker',
    netRegex: {
      id: '0028'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.earthshaker */.n3.earthshaker()
  }, {
    id: 'St Mocianne Empty Gaze',
    type: 'StartsUsing',
    netRegex: {
      id: '312B',
      source: 'Lakhamu'
    },
    response: responses/* Responses.lookAwayFromSource */.n3.lookAwayFromSource()
  }, {
    id: 'St Mocianne Mudsling',
    type: 'StartsUsing',
    netRegex: {
      id: '3135',
      source: 'Tokkapchi'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'St Mocianne Hard Quagmire',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread + Stay Off Platforms',
        de: 'Verteilen + runter von den Plattformen',
        fr: 'Dispersion + Restez hors des platesformes',
        ja: '散開、円形床に落とさないよう',
        cn: '分散，出台子',
        ko: '산개, 초록 장판 피하기'
      }
    }
  }, {
    id: 'St Mocianne Hard Mud Pie',
    type: 'StartsUsing',
    netRegex: {
      id: '3137',
      source: 'Tokkapchi',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Push Mud Pie On Platform',
        de: 'Schiebe Schlammklumpen auf eine Plattform',
        fr: 'Poussez la Boule de boue sur la platesforme',
        ja: 'スライムを円形床に吹き飛ばす',
        cn: '把小怪推到台子上',
        ko: '진흙 슬라임 초록 장판으로'
      }
    }
  }, {
    id: 'St Mocianne Hard Feculent Flood',
    type: 'StartsUsing',
    netRegex: {
      id: '313C',
      source: 'Tokkapchi',
      capture: false
    },
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Push Mud Pie Out Of Cone',
        de: 'Schiebe Schlammklumpen aus der Kegel-AoE',
        fr: 'Poussez la Boule de boue hors du cône',
        ja: 'スライムを範囲外へ吹き飛ばす',
        cn: '把小怪推出AoE',
        ko: '진흙 슬라임 초록 장판 바깥으로'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Kingsloam': 'Hort des Schlammkönigs',
      'Lakhamu': 'Lakhamu',
      'Nullchu': 'Nullchu',
      'Silt Golem': 'Schlickgolem',
      'The Soil Bed': 'Das Beet',
      'Tokkapchi': 'Tokkapchi',
      'Zymology': 'Zymologie',
      'Withered Belladonna': 'verwittert(?:e|er|es|en) Belladonna'
    },
    'replaceText': {
      'Bog Bequest': 'Maliziöser Modder',
      'Devour': 'Verschlingen',
      'Earth Shaker': 'Erdstoß',
      'Earthquake': 'Erdbeben',
      'Empty Gaze': 'Stierer Blick',
      'Fault Warren': 'Pfahlwurzel',
      'Feculent Flood': 'Modrige Flut',
      'From Mud': 'Schlammgeburt',
      'Landslip': 'Einsturz',
      'Mud Pie': 'Schlammklumpen',
      'Mudsling': 'Schlammschleuder',
      'Odious Air': 'Abstoßender Odem',
      'Odious Atmosphere': 'Abstoßende Atmosphäre',
      'Quagmire': 'Morast',
      'Quickmire': 'Schlammspritzer',
      'Rockslide': 'Erdrutsch',
      'Sludge Bomb': 'Schlammbombe',
      'Stone II': 'Steinra',
      'Taproot': 'Pfahlwurzel',
      'Tectonics': 'Tektonik',
      'Vine Whip': 'Rankenpeitsche'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Kingsloam': 'Salle d\'audience du roi fangeux',
      'Lakhamu': 'Lakhamu',
      'Nullchu': 'nullchu',
      'Silt Golem': 'golem de bourbe',
      'The Soil Bed': 'La Litière',
      'Tokkapchi': 'Tokkapchi',
      'Zymology': 'Zymologie',
      'Withered Belladonna': 'belladone flétrie'
    },
    'replaceText': {
      '\\?': ' ?',
      'Bog Bequest': 'Sotomusô-gadoue',
      'Devour': 'Dévoration',
      'Earth Shaker': 'Secousse',
      'Earthquake': 'Grand séisme',
      'Empty Gaze': 'Œil terne',
      'Fault Warren': 'Faille des élus',
      'Feculent Flood': 'Sukuinage-gadoue',
      'From Mud': 'Yobidashi-gadoue',
      'Landslip': 'Sol mouvant',
      'Mud Pie': 'Boule de boue',
      'Mudsling': 'Mandale bourbeuse',
      'Odious Air': 'Pestilence',
      'Odious Atmosphere': 'Air vicié',
      'Quagmire': 'Bourbe',
      'Quickmire': 'Jaillissement de bourbe',
      'Rockslide': 'Éboulement',
      'Sludge Bomb': 'Bombe de vase',
      'Stone II': 'Extra Terre',
      'Taproot': 'Racine pivotante',
      'Tectonics': 'Diastrophisme',
      'Vine Whip': 'Fouet de vigne'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Kingsloam': '汚泥王の謁見室',
      'Lakhamu': 'ラハム',
      'Nullchu': 'ヌルチュー',
      'Silt Golem': 'シルトゴーレム',
      'The Soil Bed': '沃土の寝室',
      'Tokkapchi': 'トカップチ',
      'Zymology': '腐臭の庭',
      'Withered Belladonna': 'ウィザード・ベラドンナ'
    },
    'replaceText': {
      'Bog Bequest': 'ドロドロ外無双',
      'Devour': '捕食',
      'Earth Shaker': 'アースシェイカー',
      'Earthquake': '大地震',
      'Empty Gaze': '虚無の瞳',
      'Fault Warren': 'フォルトウォーレン',
      'Feculent Flood': 'ドロドロ掬い投げ',
      'From Mud': 'ドロドロ呼び出し',
      'Landslip': '地滑り',
      'Mud Pie': '泥団子',
      'Mudsling': 'ドロドロ突っ張り',
      'Odious Air': 'オディアスエアー',
      'Odious Atmosphere': 'オディアスアトモスフィアー',
      'Quagmire': '汚泥',
      'Quickmire': '汚泥噴出',
      'Rockslide': 'ロックスライド',
      'Sludge Bomb': 'スラッジボム',
      'Stone II': 'ストンラ',
      'Taproot': 'タップルート',
      'Tectonics': '地殻変動',
      'Vine Whip': 'ヴァインウィップ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Kingsloam': '污泥王谒见室',
      'Lakhamu': '拉哈穆',
      'Nullchu': '泥口花',
      'Silt Golem': '淤泥巨像',
      'The Soil Bed': '沃土寝室',
      'Tokkapchi': '枯腐泥妖',
      'Zymology': '腐臭庭园',
      'Withered Belladonna': '枯萎剧毒美人'
    },
    'replaceText': {
      'Bog Bequest': '污泥外无双',
      'Devour': '捕食',
      'Earth Shaker': '大地摇动',
      'Earthquake': '大地震',
      'Empty Gaze': '空洞之瞳',
      'Fault Warren': '地层穿刺',
      'Feculent Flood': '污泥破散',
      'From Mud': '污泥呼唤',
      'Landslip': '滑坡',
      'Mud Pie': '泥丸子',
      'Mudsling': '污泥猛抽',
      'Odious Air': '恶意毒气',
      'Odious Atmosphere': '恶意毒境',
      'Quagmire': '污泥',
      'Quickmire': '污泥喷出',
      'Rockslide': '岩石崩溃',
      'Sludge Bomb': '泥浆炸弹',
      'Stone II': '坚石',
      'Taproot': '主根',
      'Tectonics': '地壳变动',
      'Vine Whip': '藤鞭'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Kingsloam': '진흙왕의 알현실',
      'Lakhamu': '라하무',
      'Nullchu': '누루츄',
      'Silt Golem': '실트 골렘',
      'The Soil Bed': '비옥토 침실',
      'Tokkapchi': '진흙장사',
      'Zymology': '썩은 내 정원',
      'Withered Belladonna': '시든 벨라돈나'
    },
    'replaceText': {
      'Bog Bequest': '흙흙 밭다리',
      'Devour': '포식',
      'Earth Shaker': '요동치는 대지',
      'Earthquake': '요동치는 대지',
      'Empty Gaze': '허무한 눈동자',
      'Fault Warren': '촉수 융기',
      'Feculent Flood': '흙흙 배지기',
      'From Mud': '흙흙 불러내기',
      'Landslip': '흐르는 대지',
      'Mud Pie': '흙경단',
      'Mudsling': '흙흙 때리기',
      'Odious Air': '끔찍한 공기',
      'Odious Atmosphere': '끔찍한 대기',
      'Quagmire': '진흙탕',
      'Quickmire': '진흙 분출',
      'Rockslide': '낙석',
      'Sludge Bomb': '진흙 폭탄',
      'Stone II': '스톤라',
      'Taproot': '원뿌리',
      'Tectonics': '지각 변동',
      'Vine Whip': '덩굴 채찍'
    }
  }]
};
/* harmony default export */ const st_mocianne_hard = (st_mocianne_hard_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/st_mocianne_hard.txt
const dungeon_st_mocianne_hard_namespaceObject = "# SAINT MOCIANNE'S ARBORETUM (hard)\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~#\r\n# NULLCHU #\r\n#~~~~~~~~~#\r\n\r\n# -ii 2E51 2E4C\r\n\r\n# Zymology will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"68D\" } window 0,1\r\n9.7 \"Odious Air\" Ability { id: \"2E49\", source: \"Nullchu\" } window 9.7,5\r\n21.8 \"Vine Whip\" Ability { id: \"2E48\", source: \"Nullchu\" }\r\n33.9 \"--sync--\" Ability { id: \"2E4D\", source: \"Nullchu\" }\r\n36.9 \"Sludge Bomb\" Ability { id: \"2E4E\", source: \"Nullchu\" }\r\n42.4 \"Fault Warren\" Ability { id: \"2E4A\", source: \"Nullchu\" }\r\n\r\n53.9 \"Devour\" Ability { id: \"2E4F\", source: \"Nullchu\" } window 53.9,10\r\n57.8 \"Odious Atmosphere\" Ability { id: \"2E50\", source: \"Nullchu\" } duration 6\r\n74.3 \"Vine Whip\" Ability { id: \"2E48\", source: \"Nullchu\" }\r\n84.8 \"Taproot\" Ability { id: \"2E4B\", source: \"Nullchu\" }\r\n95.3 \"Devour\" Ability { id: \"2E4F\", source: \"Nullchu\" } window 15,15\r\n99.2 \"Odious Atmosphere\" Ability { id: \"2E50\", source: \"Nullchu\" } duration 6\r\n116.7 \"Vine Whip\" Ability { id: \"2E48\", source: \"Nullchu\" }\r\n122.7 \"--sync--\" Ability { id: \"2E4D\", source: \"Nullchu\" }\r\n125.7 \"Sludge Bomb\" Ability { id: \"2E4E\", source: \"Nullchu\" }\r\n130.2 \"Devour\" Ability { id: \"2E4F\", source: \"Nullchu\" } window 15,15\r\n134.1 \"Odious Atmosphere\" Ability { id: \"2E50\", source: \"Nullchu\" } duration 6\r\n146.9 \"Odious Air\" Ability { id: \"2E49\", source: \"Nullchu\" }\r\n157.6 \"--sync--\" Ability { id: \"2E4D\", source: \"Nullchu\" }\r\n160.6 \"Sludge Bomb\" Ability { id: \"2E4E\", source: \"Nullchu\" }\r\n166.1 \"Fault Warren\" Ability { id: \"2E4A\", source: \"Nullchu\" } window 30,30\r\n174.6 \"Devour\" Ability { id: \"2E4F\", source: \"Nullchu\" }\r\n178.3 \"Odious Atmosphere\" Ability { id: \"2E50\", source: \"Nullchu\" } duration 6\r\n190.8 \"Taproot\" Ability { id: \"2E4B\", source: \"Nullchu\" }\r\n205.9 \"--sync--\" Ability { id: \"2E4D\", source: \"Nullchu\" }\r\n208.9 \"Sludge Bomb\" Ability { id: \"2E4E\", source: \"Nullchu\" }\r\n214.3 \"Fault Warren\" Ability { id: \"2E4A\", source: \"Nullchu\" }\r\n\r\n225.8 \"Devour\" Ability { id: \"2E4F\", source: \"Nullchu\" } window 30,30 jump 53.9\r\n229.7 \"Odious Atmosphere\"\r\n246.2 \"Vine Whip\"\r\n256.7 \"Taproot\"\r\n267.2 \"Devour\"\r\n\r\n\r\n#~~~~~~~~~#\r\n# LAKHAMU #\r\n#~~~~~~~~~#\r\n\r\n# -ii 312D 3131 3133 313F\r\n\r\n\r\n# The Soil Bed will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"AAA\" } window 1000,5\r\n1008.9 \"Stone II\" Ability { id: \"312A\", source: \"Lakhamu\" } window 1008.9,10\r\n1019.5 \"Tectonics\" Ability { id: \"312C\", source: \"Lakhamu\" }\r\n1039.1 \"Landslip\" Ability { id: \"3132\", source: \"Lakhamu\" }\r\n1041.1 \"Rockslide\" Ability { id: \"3134\", source: \"Silt Golem\" } window 1041.1,10\r\n1049.2 \"Earthquake (inner)\" Ability { id: \"312E\", source: \"Lakhamu\" }\r\n1051.8 \"Earthquake (outer)\" Ability { id: \"312F\", source: \"Lakhamu\" }\r\n1062.3 \"Earth Shaker\" Ability { id: \"3130\", source: \"Lakhamu\" }\r\n1074.0 \"Empty Gaze\" Ability { id: \"312B\", source: \"Lakhamu\" } window 1074.0,10\r\n1086.1 \"Landslip\" Ability { id: \"3132\", source: \"Lakhamu\" }\r\n1088.2 \"Rockslide\" Ability { id: \"3134\", source: \"Silt Golem\" }\r\n\r\n1091.3 \"Earthquake (inner)?\" Ability { id: \"312E\", source: \"Lakhamu\" } jump 1200\r\n1093.8 \"Earthquake (outer)?\"\r\n1094.8 \"Earth Shaker?\" Ability { id: \"3130\", source: \"Lakhamu\" } jump 1400\r\n1110.9 \"Tectonics\"\r\n1120.0 \"Stone II\"\r\n1132.7 \"Empty Gaze\"\r\n1144.8 \"Landslip\"\r\n\r\n\r\n1200.0 \"Earthquake (inner)\" Ability { id: \"312E\", source: \"Lakhamu\" }\r\n1202.5 \"Earthquake (outer)\" Ability { id: \"312F\", source: \"Lakhamu\" }\r\n1219.6 \"Tectonics\" Ability { id: \"312C\", source: \"Lakhamu\" } window 30,30\r\n1228.7 \"Stone II\" Ability { id: \"312A\", source: \"Lakhamu\" }\r\n1241.4 \"Empty Gaze\" Ability { id: \"312B\", source: \"Lakhamu\" }\r\n1253.5 \"Landslip\" Ability { id: \"3132\", source: \"Lakhamu\" } window 30,30\r\n1255.6 \"Rockslide\" Ability { id: \"3134\", source: \"Silt Golem\" }\r\n\r\n1258.7 \"Earthquake (inner)?\" Ability { id: \"312E\", source: \"Lakhamu\" } jump 1200\r\n1261.3 \"Earthquake (outer)?\"\r\n1261.3 \"Earth Shaker?\" Ability { id: \"3130\", source: \"Lakhamu\" } jump 1400\r\n1278.4 \"Tectonics\"\r\n1287.4 \"Stone II\"\r\n1300.1 \"Empty Gaze\"\r\n1312.2 \"Landslip\"\r\n\r\n\r\n1400.0 \"Earth Shaker\" Ability { id: \"3130\", source: \"Lakhamu\" }\r\n1414.7 \"Tectonics\" Ability { id: \"312C\", source: \"Lakhamu\" } window 30,30\r\n1423.8 \"Stone II\" Ability { id: \"312A\", source: \"Lakhamu\" }\r\n1436.5 \"Empty Gaze\" Ability { id: \"312B\", source: \"Lakhamu\" }\r\n1448.7 \"Landslip\" Ability { id: \"3132\", source: \"Lakhamu\" } window 30,30\r\n1450.7 \"Rockslide\" Ability { id: \"3134\", source: \"Silt Golem\" }\r\n\r\n1453.8 \"Earthquake (inner)?\" Ability { id: \"312E\", source: \"Lakhamu\" } jump 1200\r\n1455.8 \"Earthquake (outer)?\"\r\n1455.8 \"Earth Shaker?\" Ability { id: \"3130\", source: \"Lakhamu\" } jump 1400\r\n1469.5 \"Tectonics\"\r\n1478.6 \"Stone II\"\r\n1491.2 \"Empty Gaze\"\r\n1503.3 \"Landslip\"\r\n\r\n\r\n#~~~~~~~~~~~#\r\n# TOKKAPCHI #\r\n#~~~~~~~~~~~#\r\n\r\n# -ii 3139 321C 33A0\r\n\r\n# Kingsloam will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"AAF\" } window 2000,5\r\n2008.6 \"Mudsling\" Ability { id: \"3135\", source: \"Tokkapchi\" }\r\n2021.8 \"Quickmire\" Ability { id: \"3136\", source: \"Tokkapchi\" }\r\n2028.8 \"Quagmire\" Ability { id: \"3138\", source: \"Tokkapchi\" }\r\n2042.4 \"Quickmire\" Ability { id: \"3136\", source: \"Tokkapchi\" }\r\n2043.7 \"--center--\" Ability { id: \"313E\", source: \"Tokkapchi\" } window 2043.7,10\r\n2048.5 \"Mud Pie\" Ability { id: \"3137\", source: \"Tokkapchi\" }\r\n2060.7 \"Quickmire\" Ability { id: \"3136\", source: \"Tokkapchi\" }\r\n2068.7 \"Quagmire\" Ability { id: \"3138\", source: \"Tokkapchi\" }\r\n2084.3 \"Quickmire\" Ability { id: \"3136\", source: \"Tokkapchi\" }\r\n2091.3 \"Bog Bequest\" Ability { id: \"313B\", source: \"Tokkapchi\" } window 2091.3,30\r\n2098.9 \"From Mud\" Ability { id: \"313D\", source: \"Tokkapchi\" }\r\n\r\n2106.3 \"--center--\" Ability { id: \"313E\", source: \"Tokkapchi\" } window 30,30\r\n2111.1 \"Mud Pie\" Ability { id: \"3137\", source: \"Tokkapchi\" }\r\n2123.2 \"Quickmire\" Ability { id: \"3136\", source: \"Tokkapchi\" }\r\n2133.2 \"Quagmire\" Ability { id: \"3138\", source: \"Tokkapchi\" }\r\n2147.4 \"Feculent Flood\" Ability { id: \"313C\", source: \"Tokkapchi\" } window 30,30\r\n2157.5 \"Quagmire\" Ability { id: \"3138\", source: \"Tokkapchi\" }\r\n2169.1 \"Quickmire\" Ability { id: \"3136\", source: \"Tokkapchi\" }\r\n2174.1 \"Bog Bequest\" Ability { id: \"313B\", source: \"Tokkapchi\" } window 30,30\r\n2187.7 \"Quickmire\" Ability { id: \"3136\", source: \"Tokkapchi\" }\r\n2190.7 \"Mudsling\" Ability { id: \"3135\", source: \"Tokkapchi\" }\r\n\r\n2195.0 \"--center--\" Ability { id: \"313E\", source: \"Tokkapchi\" } window 30,30 jump 2106.3\r\n2199.8 \"Mud Pie\"\r\n2211.9 \"Quickmire\"\r\n2221.9 \"Quagmire\"\r\n2236.1 \"Feculent Flood\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/swallows_compass.ts



const swallows_compass_triggerSet = {
  id: 'TheSwallowsCompass',
  zoneId: zone_id/* default.TheSwallowsCompass */.Z.TheSwallowsCompass,
  timelineFile: 'swallows_compass.txt',
  triggers: [{
    id: 'Swallows Compass Tengu Clout',
    type: 'StartsUsing',
    netRegex: {
      id: '2B95',
      source: 'Otengu',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Swallows Compass Tengu Might',
    type: 'StartsUsing',
    netRegex: {
      id: '2B94',
      source: 'Otengu'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Swallows Compass Tengu Wile',
    type: 'StartsUsing',
    netRegex: {
      id: '2B97',
      source: 'Otengu',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    // 7201 is Tengu Ember.
    id: 'Swallows Compass Ember Spawn',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '7201',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Fire Orbs',
        de: 'Weiche den Feuerorbs aus',
        fr: 'Évitez les orbes de feu',
        ja: '火の玉を避ける',
        cn: '躲避小火球',
        ko: '불구슬 피하기'
      }
    }
  }, {
    id: 'Swallows Compass Flames Of Hate',
    type: 'StartsUsing',
    netRegex: {
      id: '2898',
      source: 'Tengu Ember',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Fireballs',
        de: 'Weg von den Feuerkugeln',
        fr: 'Éloignez-vous des boules de feu',
        ja: '(大きい)火の玉を避ける',
        cn: '远离大火球',
        ko: '불구슬 피하기'
      }
    }
  }, {
    id: 'Swallows Compass Right Palm',
    type: 'StartsUsing',
    netRegex: {
      id: '2B9D',
      source: 'Daidarabotchi',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Swallows Compass Left Palm',
    type: 'StartsUsing',
    netRegex: {
      id: '2B9E',
      source: 'Daidarabotchi',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Swallows Compass Mountain Falls',
    type: 'HeadMarker',
    netRegex: {
      id: '0087'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Swallows Compass Mirage',
    type: 'HeadMarker',
    netRegex: {
      id: '0001'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '5x Puddles on YOU',
        de: '5x Flächen auf DIR',
        fr: '5x Zones au sol sur VOUS',
        ja: '自分に追尾AoE',
        cn: '5连追踪AOE点名',
        ko: '5회 장판 대상자'
      }
    }
  }, {
    id: 'Swallows Compass Mythmaker',
    type: 'Ability',
    netRegex: {
      id: '2BA3',
      source: 'Daidarabotchi',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Swallows Compass Six Fulms Under',
    type: 'GainsEffect',
    netRegex: {
      effectId: '237'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 2,
    // If the user stays in, they will get more reminders.
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'OUT OF THE LAKE',
        de: 'RAUS AUS DEM SEE',
        fr: 'SORTEZ DU LAC',
        ja: '青いエリアを踏まない',
        cn: '不要踩进水坑',
        ko: '물웅덩이에서 벗어나기'
      }
    }
  }, {
    id: 'Swallows Compass Short End',
    type: 'StartsUsing',
    netRegex: {
      id: ['2BA6', '2D07'],
      source: ['Qitian Dasheng', 'Shadow Of The Sage']
    },
    suppressSeconds: 5,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Swallows Compass Mount Huaguo',
    type: 'StartsUsing',
    netRegex: {
      id: ['2BAA', '2D08'],
      source: ['Qitian Dasheng', 'Shadow Of The Sage'],
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Both Ends has a number of different possibilities for how it's used.
    // It can be alone, or it can be accompanied by the other form,
    // or it can be alongside Five-Fingered Punishment.
    // If there's a blue one on the field, we want to be in, no matter what.
    // If there's no blue, we want to be away from red.
    // In order to avoid collisions and confusion, we collect first.
    id: 'Swallows Compass Both Ends Collect',
    type: 'StartsUsing',
    netRegex: {
      id: ['2BA9', '2BAF'],
      source: ['Qitian Dasheng', 'Shadow Of The Sage'],
      capture: false
    },
    run: data => data.dynamo = true
  }, {
    // 2BA8,2BAE is red, chariot, 2BA9,2BAF is blue, dynamo.
    id: 'Swallows Compass Both Ends Call',
    type: 'StartsUsing',
    netRegex: {
      id: ['2BA8', '2BA9', '2BAE', '2BAF'],
      source: ['Qitian Dasheng', 'Shadow Of The Sage'],
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      if (data.dynamo) return output.dynamo();
      return output.chariot();
    },
    run: data => delete data.dynamo,
    outputStrings: {
      dynamo: {
        en: 'Close to blue staff',
        de: 'Nahe am blauen Stab',
        fr: 'Rapprochez-vous du bâton bleu',
        ja: '如意棒に近づく',
        cn: '靠近蓝色大圣',
        ko: '파랑 지팡이 근처로'
      },
      chariot: {
        en: 'Away from red staff',
        de: 'Weg vom roten Stab',
        fr: 'Éloignez-vous du bâton rouge',
        ja: '如意棒から離れる',
        cn: '远离红色大圣',
        ko: '빨강 지팡이에서 떨어지기'
      }
    }
  }, {
    id: 'Swallows Compass Five Fingered Punishment',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn('info') // Info rather than alert to avoid collision with Both Ends.
  }, {
    // The Long end is a knockback in phase 1, but not in phase 2.
    // Using the source name for tethers runs into localizing issues,
    // so we just track the phase instead.
    // The ability use here is unnamed, the teleport to the center to begin the intermission.
    id: 'Swallows Compass Intermission Tracking',
    type: 'Ability',
    netRegex: {
      id: '2CC7',
      source: 'Qitian Dasheng',
      capture: false
    },
    run: data => data.seenIntermission = true
  }, {
    // Either one or two tethers can be present for Long End.
    // We have to handle both possibilities, so we collect targets first for later analysis.
    id: 'Swallows Compass Long End Collect',
    type: 'Tether',
    netRegex: {
      id: '0029'
    },
    run: (data, matches) => {
      data.tethers ??= [];
      data.tethers.push(matches.target);
    }
  }, {
    id: 'Swallows Compass Long End Call',
    type: 'Tether',
    netRegex: {
      id: '0029',
      capture: false
    },
    delaySeconds: 0.5,
    alertText: (data, _matches, output) => {
      if (data.tethers?.includes(data.me)) {
        if (data.seenIntermission) return output.target();
        return output.knockback();
      }
      return output.avoid();
    },
    run: data => delete data.tethers,
    outputStrings: {
      target: {
        en: 'Laser on YOU',
        de: 'Laser auf DIR',
        fr: 'Laser sur VOUS',
        ja: '自分にレーザー',
        cn: '直线激光点名',
        ko: '레이저 대상자'
      },
      knockback: {
        en: 'Knockback laser on YOU',
        de: 'Rückstoßlaser auf DIR',
        fr: 'Poussée laser sur VOUS',
        ja: '自分にノックバックレーザー',
        cn: '击退激光点名',
        ko: '넉백 레이저 대상자'
      },
      avoid: {
        en: 'Avoid tethers',
        de: 'Vermeide die Verbindungen',
        fr: 'Évitez les liens',
        ja: '線から離れる',
        cn: '远离连线',
        ko: '선 피하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Daidarabotchi': 'Daidarabotchi',
      'Otengu': 'Otengu',
      'Qitian Dasheng': 'Qitian Dasheng',
      'Serenity': 'Die Stille',
      'Shadow Of The Sage': 'Schatten des Weisen',
      'Tengu Ember': 'Tengu-Glut',
      'The Dragon\'s Mouth': 'Maul des Drachen',
      'The Heart Of The Dragon': 'Herz des Drachen'
    },
    'replaceText': {
      'Both Ends': 'Beide Enden',
      'Clout Of The Tengu': 'Atem des Tengu',
      'Equal Of Heaven': 'Dem Himmel gleich',
      'Five-Fingered Punishment': 'Strafende Finger',
      'Flames Of Hate': 'Flammen des Hasses',
      'Greater Palm': 'Große Handfläche',
      'Might Of The Tengu': 'Fäuste des Tengu',
      'Mirage': 'Mirage',
      'Mount Huaguo': 'Huaguo',
      'Mountain Falls': 'Bergrutsch',
      'Mythmaker': 'Erdrütteln',
      'Second Heaven': 'Dreiunddreißig Himmel',
      'Splitting Hairs': 'Haarspalterei',
      'The Long End': 'Langes Ende',
      'The Short End': 'Kurzes Ende',
      'Tributary': 'Großer Fall',
      'Wile Of The Tengu': 'Tricks des Tengu',
      'Yama-Kagura': 'Yamakagura'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Daidarabotchi': 'Daidarabotchi',
      'Otengu': 'ô-tengu',
      'Qitian Dasheng': 'Qitian Dasheng',
      'Serenity': 'Sanctuaire de Jade',
      'Shadow Of The Sage': 'ombre de Qitian Dasheng',
      'Tengu Ember': 'tengu-bi',
      'The Dragon\'s Mouth': 'Porte de Dairyu',
      'The Heart Of The Dragon': 'Salle des Alignements'
    },
    'replaceText': {
      '\\?': ' ?',
      'Both Ends': 'Coup de bâton tournicotant',
      'Clout Of The Tengu': 'Tengu-kaze',
      'Equal Of Heaven': 'Égal des Cieux',
      'Five-Fingered Punishment': 'Mont Wuxing',
      'Flames Of Hate': 'Rancune furieuse',
      'Greater Palm': 'Paume colossale',
      'Might Of The Tengu': 'Tengu-tsubute',
      'Mirage': 'Mirage',
      'Mount Huaguo': 'Mont Haguo',
      'Mountain Falls': 'Raz-de-montagne',
      'Mythmaker': 'Grand bouleversement',
      'Second Heaven': 'Trayastrimsha',
      'Splitting Hairs': 'Dédoublement',
      'The Long End': 'Coup de bâton long',
      'The Short End': 'Coup de bâton court',
      'Tributary': 'Cascade colossale',
      'Wile Of The Tengu': 'Malice de tengu',
      'Yama-Kagura': 'Yama-kagura'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Daidarabotchi': 'ダイダラボッチ',
      'Otengu': 'オオテング',
      'Qitian Dasheng': 'セイテンタイセイ',
      'Serenity': '玉聖祠',
      'Shadow Of The Sage': 'セイテンタイセイの影',
      'Tengu Ember': '天狗火',
      'The Dragon\'s Mouth': '大龍関門',
      'The Heart Of The Dragon': '龍脈之間'
    },
    'replaceText': {
      'Both Ends': '如意大旋風',
      'Clout Of The Tengu': '天狗風',
      'Equal Of Heaven': '斉天撃',
      'Five-Fingered Punishment': '五行山',
      'Flames Of Hate': '怨念の炎',
      'Greater Palm': '大掌底',
      'Might Of The Tengu': '天狗礫',
      'Mirage': '蜃気楼',
      'Mount Huaguo': '花果山',
      'Mountain Falls': '山津波',
      'Mythmaker': '驚天動地',
      'Second Heaven': '三十三天',
      'Splitting Hairs': '地サツ数',
      'The Long End': '如意剛力突',
      'The Short End': '如意烈風突',
      'Tributary': '大瀑布',
      'Wile Of The Tengu': '天狗の仕業',
      'Yama-Kagura': '山神楽'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Daidarabotchi': '大太法师',
      'Otengu': '大天狗',
      'Qitian Dasheng': '齐天大圣',
      'Serenity': '玉圣祠',
      'Shadow Of The Sage': '齐天大圣的幻影',
      'Tengu Ember': '天狗火',
      'The Dragon\'s Mouth': '大龙关门',
      'The Heart Of The Dragon': '龙脉之间'
    },
    'replaceText': {
      'Both Ends': '如意大旋风',
      'Clout Of The Tengu': '天狗风',
      'Equal Of Heaven': '齐天击',
      'Five-Fingered Punishment': '五行山',
      'Flames Of Hate': '怨念之火',
      'Greater Palm': '掌击',
      'Might Of The Tengu': '天狗碾',
      'Mirage': 'Mirage',
      'Mount Huaguo': '花果山',
      'Mountain Falls': '泥石流',
      'Mythmaker': '惊天动地',
      'Second Heaven': '三十三天',
      'Splitting Hairs': '地煞数',
      'The Long End': '如意刚力突',
      'The Short End': '如意烈风突',
      'Tributary': '大瀑布',
      'Wile Of The Tengu': '天狗妙计',
      'Yama-Kagura': '山神乐'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Daidarabotchi': '다이다라봇치',
      'Otengu': '대텐구',
      'Qitian Dasheng': '제천대성',
      'Serenity': '옥성 사당',
      'Shadow Of The Sage': '제천대성의 분신',
      'Tengu Ember': '텐구불',
      'The Dragon\'s Mouth': '대룡 관문',
      'The Heart Of The Dragon': '용맥의 방'
    },
    'replaceText': {
      'Both Ends': '여의 대선풍',
      'Clout Of The Tengu': '회오리바람',
      'Equal Of Heaven': '제천격',
      'Five-Fingered Punishment': '오행산',
      'Flames Of Hate': '원념의 불꽃',
      'Greater Palm': '큰 손바닥',
      'Might Of The Tengu': '돌팔매',
      'Mirage': 'Mirage',
      'Mount Huaguo': '화과산',
      'Mountain Falls': '산해일',
      'Mythmaker': '경천동지',
      'Second Heaven': '삼십삼천',
      'Splitting Hairs': '분신술',
      'The Long End': '여의 강력 찌르기',
      'The Short End': '여의 열풍 찌르기',
      'Tributary': '대폭포',
      'Wile Of The Tengu': '텐구의 소행',
      'Yama-Kagura': '산타령'
    }
  }]
};
/* harmony default export */ const swallows_compass = (swallows_compass_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/swallows_compass.txt
const dungeon_swallows_compass_namespaceObject = "### THE SWALLOW'S COMPASS\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~#\r\n# OTENGU #\r\n#~~~~~~~~#\r\n\r\n# -ii 2B99\r\n\r\n# The Heart of the Dragon will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"98B\" } window 0,1\r\n11.6 \"Clout Of The Tengu\" Ability { id: \"2B95\", source: \"Otengu\" }\r\n22.5 \"Yama-Kagura\" Ability { id: \"2B96\", source: \"Otengu\" } window 22.5,5\r\n33.1 \"Might Of The Tengu\" Ability { id: \"2B94\", source: \"Otengu\" }\r\n53.1 \"Yama-Kagura\" Ability { id: \"2B96\", source: \"Otengu\" } window 20,20\r\n64.2 \"Wile Of The Tengu\" Ability { id: \"2B97\", source: \"Otengu\" }\r\n76.7 \"Clout Of The Tengu\" Ability { id: \"2B95\", source: \"Otengu\" }\r\n85.5 \"Flames Of Hate\" Ability { id: \"2B98\", source: \"Tengu Ember\" } window 85.5,5\r\n93.1 \"Might Of The Tengu\" Ability { id: \"2B94\", source: \"Otengu\" }\r\n106.1 \"Clout Of The Tengu\" Ability { id: \"2B95\", source: \"Otengu\" }\r\n\r\n125.0 \"Yama-Kagura\" Ability { id: \"2B96\", source: \"Otengu\" } window 30,30\r\n136.1 \"Wile Of The Tengu\" Ability { id: \"2B97\", source: \"Otengu\" }\r\n148.6 \"Clout Of The Tengu\" Ability { id: \"2B95\", source: \"Otengu\" }\r\n157.4 \"Flames Of Hate\" Ability { id: \"2B98\", source: \"Tengu Ember\" }\r\n164.9 \"Might Of The Tengu\" Ability { id: \"2B94\", source: \"Otengu\" }\r\n177.9 \"Clout Of The Tengu\" Ability { id: \"2B95\", source: \"Otengu\" }\r\n189.8 \"Yama-Kagura\" Ability { id: \"2B96\", source: \"Otengu\" } window 30,10\r\n\r\n211.2 \"Yama-Kagura\" Ability { id: \"2B96\", source: \"Otengu\" } jump 125\r\n222.3 \"Wile Of The Tengu\"\r\n234.8 \"Clout Of The Tengu\"\r\n243.6 \"Flames Of Hate\"\r\n\r\n#~~~~~~~~~~~~~~~#\r\n# DAIDARABOTCHI #\r\n#~~~~~~~~~~~~~~~#\r\n\r\n# -ii 2CD1 2B9B 2B9C 2B9F\r\n\r\n# The Dragon's Mouth will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"98E\" } window 1000,1\r\n1011.2 \"Greater Palm\" Ability { id: \"2B9[DE]\", source: \"Daidarabotchi\" } window 11.2,5\r\n1023.1 \"Greater Palm\" Ability { id: \"2B9[DE]\", source: \"Daidarabotchi\" }\r\n1035.3 \"Tributary\" Ability { id: \"2BA0\", source: \"Daidarabotchi\" } window 35,0\r\n1035.5 \"Mountain Falls\" Ability { id: \"2BA5\", source: \"Daidarabotchi\" } window 35,5\r\n1051.4 \"Mirage x5\" Ability { id: \"2BA1\", source: \"Daidarabotchi\" } duration 5\r\n\r\n1062.5 \"--sync--\" Ability { id: \"2BA3\", source: \"Daidarabotchi\" } window 62.5,10\r\n1067.5 \"Mythmaker\" Ability { id: \"2BA4\", source: \"Daidarabotchi\" }\r\n1085.6 \"Mountain Falls\" Ability { id: \"2BA5\", source: \"Daidarabotchi\" }\r\n1091.1 \"Greater Palm\" Ability { id: \"2B9[DE]\", source: \"Daidarabotchi\" } window 30,10\r\n1104.4 \"Tributary\" Ability { id: \"2BA0\", source: \"Daidarabotchi\" }\r\n1121.4 \"Mirage x5\" Ability { id: \"2BA1\", source: \"Daidarabotchi\" } duration 5\r\n1131.9 \"Greater Palm 1\" Ability { id: \"2B9[DE]\", source: \"Daidarabotchi\" }\r\n1138.7 \"Greater Palm 2\" Ability { id: \"2B9[DE]\", source: \"Daidarabotchi\" }\r\n1151.9 \"Tributary\" Ability { id: \"2BA0\", source: \"Daidarabotchi\" }\r\n1152.1 \"Mountain Falls\" Ability { id: \"2BA5\", source: \"Daidarabotchi\" } window 30,30\r\n1164.4 \"Greater Palm\" Ability { id: \"2B9[DE]\", source: \"Daidarabotchi\" }\r\n1181.8 \"Mirage x5\" Ability { id: \"2BA1\", source: \"Daidarabotchi\" } duration 5\r\n1191.3 \"Greater Palm\" Ability { id: \"2B9[DE]\", source: \"Daidarabotchi\" }\r\n\r\n1203.7 \"--sync--\" Ability { id: \"2BA3\", source: \"Daidarabotchi\" } window 100,10 jump 1062.5\r\n1208.7 \"Mythmaker\"\r\n1226.8 \"Mountain Falls\"\r\n1232.3 \"Greater Palm\"\r\n1245.6 \"Tributary\"\r\n1262.6 \"Mirage x5\"\r\n\r\n#~~~~~~~~~~~~~~~~#\r\n# QITIAN DASHENG #\r\n#~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 2BAC\r\n# -p 2CC7:2300.0 2BB2:2383.9\r\n\r\n# The opening block repeats without interrruption above 50% HP.\r\n# Note that Dasheng's abilities are not the same as those of the shadows!\r\n# Serenity will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"98F\" } window 2000,5\r\n2011.8 \"The Short End\" Ability { id: \"2BA6\", source: \"Qitian Dasheng\" } window 11.8,5\r\n2025.5 \"Both Ends\" Ability { id: \"2BA[89]\", source: \"Qitian Dasheng\" }\r\n2036.1 \"Mount Huaguo\" Ability { id: \"2BAA\", source: \"Qitian Dasheng\" } window 36.1,5\r\n2052.3 \"Both Ends\" Ability { id: \"2BA[89]\", source: \"Qitian Dasheng\" }\r\n2069.2 \"The Long End\" Ability { id: \"2BA7\", source: \"Qitian Dasheng\" }\r\n2076.3 \"Five-Fingered Punishment\" Ability { id: \"2BAB\", source: \"Qitian Dasheng\" } window 76.3,10\r\n2084.9 \"Both Ends\" Ability { id: \"2BA[89]\", source: \"Qitian Dasheng\" }\r\n\r\n2102.7 \"Both Ends\" Ability { id: \"2BA[89]\", source: \"Qitian Dasheng\" }\r\n2113.3 \"Mount Huaguo\" Ability { id: \"2BAA\", source: \"Qitian Dasheng\" }\r\n2132.6 \"Both Ends\" Ability { id: \"2BA[89]\", source: \"Qitian Dasheng\" }\r\n2143.2 \"The Short End\" Ability { id: \"2BA6\", source: \"Qitian Dasheng\" } window 30,30\r\n\r\n2162.2 \"Both Ends\" Ability { id: \"2BA[89]\", source: \"Qitian Dasheng\" } jump 2102.7\r\n2172.8 \"Mount Huaguo\"\r\n2192.1 \"Both Ends\"\r\n2202.7 \"The Short End\"\r\n\r\n# Intermission at <50% HP.\r\n2300.0 \"--sync--\" Ability { id: \"2CC7\", source: \"Qitian Dasheng\" } window 300,5\r\n2310.3 \"Equal Of Heaven\" Ability { id: \"2BB4\", source: \"Qitian Dasheng\" }\r\n2324.3 \"Equal Of Heaven\" Ability { id: \"2BB4\", source: \"Qitian Dasheng\" }\r\n2338.3 \"Equal Of Heaven\" Ability { id: \"2BB4\", source: \"Qitian Dasheng\" }\r\n2373.9 \"Second Heaven\" Ability { id: \"2BB1\", source: \"Qitian Dasheng\" } window 73.9,5\r\n\r\n\r\n# An interruptible rotation continues to the end.\r\n2383.9 \"Splitting Hairs\" Ability { id: \"2BB2\", source: \"Qitian Dasheng\" }\r\n\r\n2392.0 \"Equal Of Heaven\" Ability { id: \"2BB4\", source: \"Qitian Dasheng\" } window 30,15\r\n2396.0 \"Both Ends\" Ability { id: \"2BA[EF]\", source: \"Shadow Of The Sage\" }\r\n2407.6 \"Mount Huaguo\" Ability { id: \"2D08\", source: \"Shadow Of The Sage\" }\r\n2421.9 \"Equal Of Heaven\" Ability { id: \"2BB4\", source: \"Qitian Dasheng\" }\r\n2424.0 \"The Long End\" Ability { id: \"2BAD\", source: \"Shadow Of The Sage\" } window 30,30\r\n2435.2 \"The Short End\" Ability { id: \"2D07\", source: \"Shadow Of The Sage\" }\r\n2449.1 \"Equal Of Heaven\" Ability { id: \"2BB4\", source: \"Qitian Dasheng\" }\r\n2451.1 \"Five-Fingered Punishment\" Ability { id: \"2BB0\", source: \"Shadow Of The Sage\" } window 30,30\r\n2453.1 \"Both Ends\" Ability { id: \"2BA[EF]\", source: \"Shadow Of The Sage\" }\r\n2464.7 \"Mount Huaguo\" Ability { id: \"2D08\", source: \"Shadow Of The Sage\" }\r\n2464.7 \"The Short End\" Ability { id: \"2D07\", source: \"Shadow Of The Sage\" }\r\n\r\n2479.0 \"Equal Of Heaven\" Ability { id: \"2BB4\", source: \"Qitian Dasheng\" } window 15,15 jump 2392\r\n2483.0 \"Both Ends\"\r\n2494.6 \"Mount Huaguo\"\r\n2508.9 \"Equal Of Heaven\"\r\n2511.0 \"The Long End\"\r\n2522.2 \"The Short End\"\r\n\r\n\r\n# Any time one shadow is reduced to 0% HP,\r\n# the other teleports to the center and casts Splitting Hairs.\r\n# Upon resolution, the shadows pick up approximately where they left off.\r\n# Unfortunately, this means we can't do a nice lookahead,\r\n# since it would just be a jumbled mess.\r\n\r\n# This is a safe sync. The usage immediately after the intermission is 2BB2 from Dasheng.\r\n#\r\n2590.3 \"--sync--\" StartsUsing { id: \"2BB3\", source: \"Shadow Of The Sage\" } window 2590.3,10\r\n2600.0 \"Splitting Hairs\" Ability { id: \"2BB3\", source: \"Shadow Of The Sage\" } window 2600,5\r\n2608.0 \"Equal Of Heaven\" Ability { id: \"2BB4\", source: \"Qitian Dasheng\" }\r\n2610.0 \"Five-Fingered Punishment?\" Ability { id: \"2BB0\", source: \"Shadow Of The Sage\" } jump 2451.1\r\n2610.0 \"The Long End?\" Ability { id: \"2BAD\", source: \"Shadow Of The Sage\" } jump 2424\r\n2612.0 \"Both Ends?\" Ability { id: \"2BA[EF]\", source: \"Shadow Of The Sage\" } jump 2396\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/temple_of_the_fist.ts



const temple_of_the_fist_triggerSet = {
  id: 'TheTempleOfTheFist',
  zoneId: zone_id/* default.TheTempleOfTheFist */.Z.TheTempleOfTheFist,
  timelineFile: 'temple_of_the_fist.txt',
  timelineTriggers: [{
    id: 'Temple Pounce',
    regex: /Pounce/,
    beforeSeconds: 5,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Temple Cardinal Shift',
    regex: /Cardinal Shift/,
    beforeSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  triggers: [{
    id: 'Temple Electric Burst Sruti',
    type: 'StartsUsing',
    netRegex: {
      id: '1FD6',
      source: 'Coeurl Sruti',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Temple Electric Burst Smriti',
    type: 'StartsUsing',
    netRegex: {
      id: '1FD6',
      source: 'Coeurl Smriti',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Temple Fourfold Shear',
    type: 'StartsUsing',
    netRegex: {
      id: '1FD9',
      source: 'Arbuda'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Temple Moonseal',
    type: 'HeadMarker',
    netRegex: {
      id: '0059'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in blue',
        de: 'Im Blauen stehen',
        fr: 'Placez-vous dans le bleu',
        ja: '青色を踏む',
        cn: '站在蓝色区域',
        ko: '파랑장판에 서기'
      }
    }
  }, {
    id: 'Temple Sunseal',
    type: 'HeadMarker',
    netRegex: {
      id: '0058'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in red',
        de: 'Im Roten stehen',
        fr: 'Placez-vous dans le rouge',
        ja: '赤色を踏む',
        cn: '站在红色区域',
        ko: '빨강장판에 서기'
      }
    }
  }, {
    id: 'Temple Port And Star',
    type: 'StartsUsing',
    netRegex: {
      id: '1FDC',
      source: 'Arbuda',
      capture: false
    },
    response: responses/* Responses.goFrontBack */.n3.goFrontBack()
  }, {
    id: 'Temple Fore And Aft',
    type: 'StartsUsing',
    netRegex: {
      id: '1FDB',
      source: 'Arbuda',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'Temple Killer Instinct',
    type: 'StartsUsing',
    netRegex: {
      id: '1FDE',
      source: 'Arbuda',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'watch for safe',
        de: 'nach sicherer Position schauen',
        fr: 'Trouvez une zone safe',
        ja: '安置へ',
        cn: '前往安全区',
        ko: '안전지대 찾기'
      }
    }
  }, {
    id: 'Temple Spirit Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '1FE7',
      source: 'Ivon Coeurlfist',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Temple Touch Of Slaughter',
    type: 'StartsUsing',
    netRegex: {
      id: '1FE6',
      source: 'Ivon Coeurlfist'
    },
    condition: data => data.role === 'healer' || data.job === 'BLU',
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.target)
    }),
    outputStrings: {
      text: {
        en: 'Heal ${player} soon',
        de: 'Bald ${player} heilen',
        fr: 'Soignez ${player} bientôt',
        ja: 'すぐに${player}をヒール',
        cn: '马上奶 ${player}',
        ko: '${player}힐 준비'
      }
    }
  }, {
    id: 'Temple Coeurl Heads',
    type: 'Ability',
    netRegex: {
      id: '1FE9',
      source: 'Ivon Coeurlfist',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid floating heads',
        de: 'Weiche den fliegenden Köpfen aus',
        fr: 'Évitez les têtes flottantes',
        ja: 'ヘッドを避ける',
        cn: '避开漂浮的头',
        ko: '커얼머리 피하기'
      }
    }
  }, {
    id: 'Temple Rhalgr\'s Piece',
    type: 'StartsUsing',
    netRegex: {
      id: '1FED',
      source: 'Ivon Coeurlfist',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from marker',
        de: 'Weg von den Markierungen',
        fr: 'Éloignez-vous du marqueur',
        ja: 'マーカーから離れる',
        cn: '远离标记',
        ko: '마커에게서 멀어지기'
      }
    }
  }, {
    id: 'Temple Rose Of Destruction',
    type: 'StartsUsing',
    netRegex: {
      id: '1FEE',
      source: 'Ivon Coeurlfist'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Arbuda': 'Arbuda',
      'Coeurl Smriti': 'Coeurl Smriti',
      'Coeurl Sruti': 'Coeurl Sruti',
      'Guidance': 'Unterweisung',
      'Harmony': 'Harmonie',
      'Ivon Coeurlfist': 'Ivon Coeurlfaust',
      'Tourmaline Pond': 'Turmalinteich'
    },
    'replaceText': {
      '--Smriti Appears--': '--Smriti erscheint--',
      'Basic Instinct': 'Kampfinstinkt',
      'Cardinal Shift': 'Großrotation',
      'Coeurl Whisper': 'Coeurl-Flüstern',
      'Electric Burst': 'Stromstoß',
      'Fourfold Shear': 'Vierschere',
      'Front/Back\\?Sides\\?': 'Vorne/Hinten?Seiten?',
      'Furious Fists': 'Todeskralle',
      'Heat Lightning': 'Hitzeblitz',
      'Hellseal': 'Höllensiegel',
      'Hurricane Kick': 'Hurrikan-Tritt',
      'Impact': 'Einschlag',
      'Killer Instinct': 'Vorausahnung',
      'Pounce': 'Raubtiertatze',
      'Radial Blaster': 'Radial-Blaster',
      'Rhalgr\'s Piece': 'Gewalt des Zerstörers',
      'Silent Roar': 'Stilles Brüllen',
      'Spirit Wave': 'Mentale Welle',
      'Tapas': 'Kasteiung',
      'The Rose Of Destruction': 'Zermalmender Geist',
      'Touch of Slaughter': 'Hauch des Gemetzels',
      'Wide Blaster': 'Weitwinkel-Blaster'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Arbuda': 'Arbuda',
      'Coeurl Smriti': 'Coeurl smriti',
      'Coeurl Sruti': 'Coeurl sruti',
      'Guidance': 'la Conduite',
      'Harmony': 'l\'Harmonie',
      'Ivon Coeurlfist': 'Ivon le Coeurl',
      'Tourmaline Pond': 'l\'étang de Tourmaline'
    },
    'replaceText': {
      '--Smriti Appears--': '-- Apparition de Smriti --',
      'Basic Instinct': 'Instinct profond',
      'Cardinal Shift': 'Rotation cardinale',
      'Coeurl Whisper': 'Murmure du Coeurl',
      'Electric Burst': 'Salve électrique',
      'Fourfold Shear': 'Quadruple cisaille',
      'Front/Back\\?Sides\\?': 'Devant/Derrière ? Côtés ?',
      'Furious Fists': 'Poings furieux',
      'Heat Lightning': 'Éclair de chaleur',
      'Hellseal': 'Sceau infernal',
      'Hurricane Kick': 'Coup de pied ouragan',
      'Impact': 'Impact',
      'Killer Instinct': 'Instinct meurtrier',
      'Pounce': 'Attaque subite',
      'Radial/Wide Blaster': 'Fulguration radiale/large',
      'Radial Blaster': 'Fulguration radiale',
      'Rhalgr\'s Piece': 'Force de Rhalgr',
      'Silent Roar': 'Hurlement silencieux',
      'Spirit Wave': 'Onde spirituelle',
      'Tapas': 'Tapas',
      'The Rose Of Destruction': 'Rose de la destruction',
      'Touch of Slaughter': 'Toucher massacreur',
      '(?<!Radial/)Wide Blaster': 'Fulguration large'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Arbuda': 'アブダ',
      'Coeurl Smriti': 'クァール・スムリティ',
      'Coeurl Sruti': 'クァール・シュルティ',
      'Guidance': '導霊殿',
      'Harmony': '陰陽苑',
      'Ivon Coeurlfist': '双豹のイヴォン',
      'Tourmaline Pond': '水苔池'
    },
    'replaceText': {
      '--Smriti Appears--': '--雑魚: スムリティ--',
      'Basic Instinct': '闘争本能',
      'Cardinal Shift': '四剣大回転',
      'Coeurl Whisper': '双豹招来',
      'Electric Burst': 'エレクトリックバースト',
      'Fourfold Shear': '四連双斬',
      'Front/Back\\?Sides\\?': '縦? 横?',
      'Furious Fists': '双豹蒼連撃',
      'Heat Lightning': 'ヒートライトニング',
      'Hellseal': '試練の刻印',
      'Hurricane Kick': '霊魂旋風脚',
      'Impact': 'ラールガーズインパクト',
      'Killer Instinct': '見切り',
      'Pounce': 'パウンス',
      'Radial Blaster': 'ラディアルブラスター',
      'Rhalgr\'s Piece': '壊神拳',
      'Silent Roar': '双豹撃',
      'Spirit Wave': '真霊波',
      'Tapas': '苦行',
      'The Rose Of Destruction': '闘霊弾',
      'Touch of Slaughter': '霊魂秘孔拳',
      'Wide Blaster': 'ワイドブラスター'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Arbuda': '额部陀',
      'Coeurl Smriti': '凶豹所忆',
      'Coeurl Sruti': '凶豹所闻',
      'Guidance': '导灵殿',
      'Harmony': '阴阳苑',
      'Ivon Coeurlfist': '双豹伊沃恩',
      'Tourmaline Pond': '水苔池'
    },
    'replaceText': {
      '--Smriti Appears--': '--凶豹出现--',
      'Basic Instinct': '斗争本能',
      'Cardinal Shift': '四剑大回旋',
      'Coeurl Whisper': '双豹招来',
      'Electric Burst': '电光爆发',
      'Fourfold Shear': '四连双斩',
      'Front/Back\\?Sides\\?': '前/后?两侧?',
      'Furious Fists': '双豹苍连击',
      'Heat Lightning': '惊电',
      'Hellseal': '试炼刻印',
      'Hurricane Kick': '灵魂旋风脚',
      'Impact': '拉尔戈冲击',
      'Killer Instinct': '预判',
      'Pounce': '爪袭',
      'Radial Blaster': '放射冲击波',
      'Rhalgr\'s Piece': '破坏神拳',
      'Silent Roar': '双豹击',
      'Spirit Wave': '真灵波',
      'Tapas': '苦行',
      'The Rose Of Destruction': '斗灵弹',
      'Touch of Slaughter': '灵魂秘孔拳',
      'Wide Blaster': '广域冲击波'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Arbuda': '아부다',
      'Coeurl Smriti': '커얼 스므리티',
      'Coeurl Sruti': '커얼 슈루티',
      'Guidance': '도령전',
      'Harmony': '음양원',
      'Ivon Coeurlfist': '쌍표범 이본',
      'Tourmaline Pond': '물이끼 연못'
    },
    'replaceText': {
      '--Smriti Appears--': '--스므리티 등장--',
      'Basic Instinct': '투쟁 본능',
      'Cardinal Shift': '사중 대회전',
      'Coeurl Whisper': '쌍표범 소환',
      'Electric Burst': '전하 폭발',
      'Fourfold Shear': '사연속 베기',
      'Front/Back\\?Sides\\?': '앞/뒤? 양옆?',
      'Furious Fists': '쌍표창연격',
      'Heat Lightning': '뜨거운 번개',
      'Hellseal': '시련의 각인',
      'Hurricane Kick': '영혼의 선풍각',
      'Impact': '랄거의 충격',
      'Killer Instinct': '간파',
      'Pounce': '덮치기',
      'Radial Blaster': '방사형 블래스터',
      'Rhalgr\'s Piece': '파신권',
      'Silent Roar': '쌍표격',
      'Spirit Wave': '진령파',
      'Tapas': '고행',
      'The Rose Of Destruction': '투령탄',
      'Touch of Slaughter': '영혼의 혈도 찌르기',
      'Wide Blaster': '광범위 블래스터'
    }
  }]
};
/* harmony default export */ const temple_of_the_fist = (temple_of_the_fist_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/temple_of_the_fist.txt
const dungeon_temple_of_the_fist_namespaceObject = "hideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Coeurl Twins\r\n# -ii 1FD2 1FD8\r\n\r\n# Tourmaline Pond will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"788\" }\r\n6.4 \"Pounce\" Ability { id: \"1FD1\", source: \"Coeurl Sruti\" } window 7,7\r\n17.8 \"Radial Blaster\" Ability { id: \"1FD3\", source: \"Coeurl Sruti\" }\r\n22.0 \"Pounce\" Ability { id: \"1FD1\", source: \"Coeurl Sruti\" }\r\n\r\n38.5 \"--Smriti Appears--\" AddedCombatant { name: \"Coeurl Smriti\" } window 10,10\r\n46.5 \"Wide Blaster\" Ability { id: \"1FD4\", source: \"Coeurl Smriti\" } window 15,15\r\n46.5 \"Radial Blaster\" Ability { id: \"1FD3\", source: \"Coeurl Sruti\" }\r\n52.6 \"Pounce x2\" Ability { id: \"1FD1\", source: \"Coeurl Smriti\" }\r\n60.7 \"Pounce x2\" Ability { id: \"1FD1\", source: \"Coeurl Smriti\" }\r\n\r\n72.3 \"Wide Blaster\" Ability { id: \"1FD4\", source: \"Coeurl Smriti\" } window 15,15\r\n72.3 \"Radial Blaster\" Ability { id: \"1FD3\", source: \"Coeurl Sruti\" }\r\n78.4 \"Pounce x2\" Ability { id: \"1FD1\", source: \"Coeurl Smriti\" }\r\n86.5 \"Pounce x2\" Ability { id: \"1FD1\", source: \"Coeurl Smriti\" } jump 60.7\r\n\r\n98.1 \"Wide Blaster\"\r\n98.1 \"Radial Blaster\"\r\n104.2 \"Pounce\"\r\n112.3 \"Pounce\"\r\n123.9 \"Wide Blaster\"\r\n123.9 \"Radial Blaster\"\r\n\r\n# Phase change after one dies\r\n150.0 \"Basic Instinct\" Ability { id: \"1FD5\", source: [\"Coeurl Sruti\", \"Coeurl Smriti\"] } window 150,10\r\n\r\n156.2 \"Electric Burst\" Ability { id: \"1FD6\", source: [\"Coeurl Sruti\", \"Coeurl Smriti\"] }\r\n160.3 \"Pounce\" Ability { id: \"1FD1\", source: [\"Coeurl Sruti\", \"Coeurl Smriti\"] }\r\n167.8 \"Heat Lightning\" Ability { id: \"1FD7\", source: \"Coeurl Sruti\" }\r\n175.2 \"Radial/Wide Blaster\" Ability { id: \"1FD[34]\", source: [\"Coeurl Sruti\", \"Coeurl Smriti\"] }\r\n180.4 \"Pounce\" Ability { id: \"1FD1\", source: [\"Coeurl Sruti\", \"Coeurl Smriti\"] }\r\n\r\n191.6 \"Electric Burst\" Ability { id: \"1FD6\", source: [\"Coeurl Sruti\", \"Coeurl Smriti\"] } window 20,20\r\n195.7 \"Pounce\" Ability { id: \"1FD1\", source: [\"Coeurl Sruti\", \"Coeurl Smriti\"] }\r\n203.2 \"Heat Lightning\" Ability { id: \"1FD7\", source: [\"Coeurl Sruti\", \"Coeurl Smriti\"] }\r\n210.6 \"Radial/Wide Blaster\" Ability { id: \"1FD[34]\", source: [\"Coeurl Sruti\", \"Coeurl Smriti\"] }\r\n215.8 \"Pounce\" Ability { id: \"1FD1\", source: [\"Coeurl Sruti\", \"Coeurl Smriti\"] } jump 180.4\r\n\r\n227.0 \"Electric Burst\"\r\n231.1 \"Pounce\"\r\n238.6 \"Heat Lightning\"\r\n246.0 \"Radial/Wide Blaster\"\r\n251.2 \"Pounce\"\r\n\r\n\r\n# Arbuda\r\n\r\n# Harmony will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"789\" } window 1000,10\r\n1006.5 \"Cardinal Shift\" Ability { id: \"1FDA\", source: \"Arbuda\" } window 7,7\r\n1014.6 \"Fourfold Shear\" Ability { id: \"1FD9\", source: \"Arbuda\" }\r\n1022.6 \"Front/Back?Sides?\" Ability { id: \"1FD[BC]\", source: \"Arbuda\" }\r\n1026.7 \"Cardinal Shift\" Ability { id: \"1FDA\", source: \"Arbuda\" }\r\n1033.8 \"Killer Instinct\" Ability { id: \"1FDE\", source: \"Arbuda\" }\r\n1046.8 \"Front/Back?Sides?\" Ability { id: \"1FD[BC]\", source: \"Arbuda\" }\r\n1055.0 \"Fourfold Shear\" Ability { id: \"1FD9\", source: \"Arbuda\" }\r\n1064.9 \"Hellseal\" Ability { id: \"1FE1\", source: \"Arbuda\" }\r\n1071.5 \"Front/Back?Sides?\" Ability { id: \"1FD[BC]\", source: \"Arbuda\" }\r\n1075.6 \"Cardinal Shift\" Ability { id: \"1FDA\", source: \"Arbuda\" }\r\n1079.7 \"Cardinal Shift\" Ability { id: \"1FDA\", source: \"Arbuda\" }\r\n1088.9 \"Tapas\" Ability { id: \"1FE3\", source: \"Arbuda\" }\r\n\r\n1094.9 \"Front/Back?Sides?\" Ability { id: \"1FD[BC]\", source: \"Arbuda\" }\r\n1099.0 \"Cardinal Shift\" Ability { id: \"1FDA\", source: \"Arbuda\" }\r\n1107.2 \"Fourfold Shear\" Ability { id: \"1FD9\", source: \"Arbuda\" }\r\n1115.2 \"Front/Back?Sides?\" Ability { id: \"1FD[BC]\", source: \"Arbuda\" }\r\n1119.3 \"Cardinal Shift\" Ability { id: \"1FDA\", source: \"Arbuda\" }\r\n1126.4 \"Killer Instinct\" Ability { id: \"1FDE\", source: \"Arbuda\" }\r\n1139.4 \"Front/Back?Sides?\" Ability { id: \"1FD[BC]\", source: \"Arbuda\" }\r\n1147.7 \"Fourfold Shear\" Ability { id: \"1FD9\", source: \"Arbuda\" }\r\n1157.4 \"Hellseal\" Ability { id: \"1FE1\", source: \"Arbuda\" }\r\n1163.5 \"Front/Back?Sides?\" Ability { id: \"1FD[BC]\", source: \"Arbuda\" }\r\n1167.6 \"Cardinal Shift\" Ability { id: \"1FDA\", source: \"Arbuda\" }\r\n1171.7 \"Cardinal Shift\" Ability { id: \"1FDA\", source: \"Arbuda\" }\r\n1180.9 \"Tapas\" Ability { id: \"1FE3\", source: \"Arbuda\" }\r\n\r\n1186.9 \"Front/Back?Sides?\"\r\n1191.0 \"Cardinal Shift\"\r\n1199.2 \"Fourfold Shear\"\r\n1207.2 \"Front/Back?Sides?\"\r\n1211.3 \"Cardinal Shift\"\r\n1218.4 \"Killer Instinct\"\r\n\r\n# Ivon Coeurlfist\r\n# -ii 1FF0 1FE8 1FEC\r\n\r\n# Guidance will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"78A\" } window 2000,10\r\n2010.9 \"Spirit Wave\" Ability { id: \"1FE7\", source: \"Ivon Coeurlfist\" }\r\n2018.6 \"Hurricane Kick\" Ability { id: \"1FE5\", source: \"Ivon Coeurlfist\" }\r\n2026.7 \"Touch of Slaughter\" Ability { id: \"1FE6\", source: \"Ivon Coeurlfist\" }\r\n2030.9 \"Coeurl Whisper\" Ability { id: \"1FE9\", source: \"Ivon Coeurlfist\" }\r\n2042.0 \"Silent Roar\" Ability { id: \"1FEB\", source: \"Ivon Coeurlfist\" }\r\n2062.0 \"Rhalgr's Piece\" Ability { id: \"1FED\", source: \"Ivon Coeurlfist\" }\r\n2069.1 \"The Rose Of Destruction\" Ability { id: \"1FEE\", source: \"Ivon Coeurlfist\" } window 20,20\r\n2073.7 \"Hurricane Kick\" Ability { id: \"1FE5\", source: \"Ivon Coeurlfist\" }\r\n\r\n# Intermission happens here naturally, or at HP < 50%\r\n2086.1 \"--sync--\" Ability { id: \"1FEC\", source: \"Ivon Coeurlfist\" } window 80,5\r\n2106.2 \"Furious Fists\" Ability { id: \"1FEF\", source: \"Ivon Coeurlfist\" }\r\n2114.6 \"Impact\" Ability { id: \"1FF1\", source: \"Ivon Coeurlfist\" } window 120,20\r\n\r\n2125.3 \"Spirit Wave\" Ability { id: \"1FE7\", source: \"Ivon Coeurlfist\" }\r\n2127.5 \"Coeurl Whisper\" Ability { id: \"1FE9\", source: \"Ivon Coeurlfist\" }\r\n2137.4 \"Rhalgr's Piece\" Ability { id: \"1FED\", source: \"Ivon Coeurlfist\" }\r\n2142.8 \"Silent Roar\" Ability { id: \"1FEB\", source: \"Ivon Coeurlfist\" }\r\n2156.9 \"Touch of Slaughter\" Ability { id: \"1FE6\", source: \"Ivon Coeurlfist\" } window 30,30\r\n2161.6 \"Hurricane Kick\" Ability { id: \"1FE5\", source: \"Ivon Coeurlfist\" }\r\n2175.8 \"Spirit Wave\" Ability { id: \"1FE7\", source: \"Ivon Coeurlfist\" }\r\n2178.0 \"Coeurl Whisper\" Ability { id: \"1FE9\", source: \"Ivon Coeurlfist\" }\r\n2187.2 \"The Rose Of Destruction\" Ability { id: \"1FEE\", source: \"Ivon Coeurlfist\" }\r\n2192.3 \"Silent Roar\" Ability { id: \"1FEB\", source: \"Ivon Coeurlfist\" }\r\n\r\n2210.5 \"Spirit Wave\" Ability { id: \"1FE7\", source: \"Ivon Coeurlfist\" } window 30,30\r\n2212.7 \"Coeurl Whisper\" Ability { id: \"1FE9\", source: \"Ivon Coeurlfist\" }\r\n2222.6 \"Rhalgr's Piece\" Ability { id: \"1FED\", source: \"Ivon Coeurlfist\" }\r\n2228.0 \"Silent Roar\" Ability { id: \"1FEB\", source: \"Ivon Coeurlfist\" }\r\n2242.1 \"Touch of Slaughter\" Ability { id: \"1FE6\", source: \"Ivon Coeurlfist\" } window 30,30\r\n2246.8 \"Hurricane Kick\" Ability { id: \"1FE5\", source: \"Ivon Coeurlfist\" }\r\n2261.0 \"Spirit Wave\" Ability { id: \"1FE7\", source: \"Ivon Coeurlfist\" }\r\n2263.2 \"Coeurl Whisper\" Ability { id: \"1FE9\", source: \"Ivon Coeurlfist\" }\r\n2272.4 \"The Rose Of Destruction\" Ability { id: \"1FEE\", source: \"Ivon Coeurlfist\" }\r\n2277.5 \"Silent Roar\" Ability { id: \"1FEB\", source: \"Ivon Coeurlfist\" } jump 2192.3\r\n\r\n2295.7 \"Spirit Wave\"\r\n2297.9 \"Coeurl Whisper\"\r\n2307.8 \"Rhalgr's Piece\"\r\n2313.2 \"Silent Roar\"\r\n2327.3 \"Touch of Slaughter\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/the_burn.ts



const the_burn_triggerSet = {
  id: 'TheBurn',
  zoneId: zone_id/* default.TheBurn */.Z.TheBurn,
  timelineFile: 'the_burn.txt',
  triggers: [{
    id: 'The Burn Crystal Needle',
    type: 'StartsUsing',
    netRegex: {
      id: '3193',
      source: 'Hedetet'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'The Burn Hailfire',
    type: 'HeadMarker',
    netRegex: {
      id: '0002',
      capture: false
    },
    condition: data => !data.hedetet,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide behind crystal',
        de: 'Hinter dem Kristall verstecken',
        fr: 'Cachez-vous derrière le cristal',
        ja: '水晶の後ろに',
        cn: '躲在水晶后',
        ko: '크리스탈 뒤에 숨기'
      }
    }
  }, {
    id: 'The Burn Shardstrike',
    type: 'HeadMarker',
    netRegex: {
      id: '0060'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread + Avoid Crystals',
        de: 'Verteilen + Kristall meiden',
        fr: 'Dispersez-vous + évitez les cristaux',
        ja: '散開 + 水晶を避ける',
        cn: '散开并远离水晶',
        ko: '산개 + 크리스탈 피하기'
      }
    }
  }, {
    id: 'The Burn Crystal Shardfall',
    type: 'StartsUsing',
    netRegex: {
      id: '3191',
      source: 'Hedetet',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide behind crystal',
        de: 'Hinter dem Kristall verstecken',
        fr: 'Cachez-vous derrière le cristal',
        ja: '水晶の後ろに',
        cn: '躲在水晶后',
        ko: '크리스탈 뒤에 숨기'
      }
    }
  }, {
    // This has a visible donut AoE, but the user must be inside the target ring to be safe.
    id: 'The Burn Crystal Dissonance',
    type: 'StartsUsing',
    netRegex: {
      id: '3192',
      source: 'Hedetet',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    // Head marker 0002 is used in both the first two encounters.
    id: 'The Burn Dead Hedetet',
    type: 'Ability',
    netRegex: {
      id: '368',
      source: 'Defective Drone',
      capture: false
    },
    condition: data => !data.hedetet,
    run: data => data.hedetet = true
  }, {
    id: 'The Burn Aetherochemical Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '2D73',
      source: 'Defective Drone',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'The Burn Aetherochemical Coil',
    type: 'StartsUsing',
    netRegex: {
      id: '2D72',
      source: 'Defective Drone'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'The Burn Aetherochemical Residue',
    type: 'HeadMarker',
    netRegex: {
      id: '0002'
    },
    condition: (data, matches) => data.me === matches.target && data.hedetet,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Puddle on YOU',
        de: 'Fläche auf DIR',
        fr: 'Zone au sol sur VOUS',
        ja: '自分に粘液',
        cn: '圈圈点名',
        ko: '장판 대상자'
      }
    }
  }, {
    // The NPC here is Mining Drone.
    id: 'The Burn Throttle',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '7670',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'In line with smoking drone',
        de: 'In einer Linie mit der rauchenden Drohne stellen',
        fr: 'En ligne avec le drone endommagé',
        ja: 'ドローンの直線に',
        cn: '站在冒烟小怪直线上',
        ko: '연기나는 드론 앞으로'
      }
    }
  }, {
    id: 'The Burn Adit Driver',
    type: 'StartsUsing',
    netRegex: {
      id: '2D78',
      source: 'Rock Biter',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Rock Biters',
        de: 'Felsbeißer meiden',
        fr: 'Évitez le trancheur de pierre',
        ja: 'ロックカッターを避ける',
        cn: '躲开电锯',
        ko: '톱니바퀴 피하기'
      }
    }
  }, {
    id: 'The Burn Rime Wreath',
    type: 'StartsUsing',
    netRegex: {
      id: '314B',
      source: 'Mist Dragon',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Also handles Chilling Aspiration, which is randomly targeted.
    id: 'The Burn Frost Breath',
    type: 'HeadMarker',
    netRegex: {
      id: ['001A', '000E']
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.puddleCleaveOnYou();
      return output.avoidMarkerCone();
    },
    outputStrings: {
      puddleCleaveOnYou: {
        en: 'Puddle + cleave on YOU',
        de: 'Fläche + Cleave auf DIR',
        fr: 'Zone au sol + Cleave sur VOUS',
        ja: '自分に沼 + フロストブレス',
        cn: '圈圈+吐息点名',
        ko: '장판 + 브레스 대상자'
      },
      avoidMarkerCone: {
        en: 'Avoid marker cone',
        de: 'Kegel-Markierung ausweichen',
        fr: 'Évitez le marqueur de cône',
        ja: 'マーカーを避ける',
        cn: '远离锥形点名',
        ko: '표식 피하기'
      }
    }
  }, {
    id: 'The Burn Fog Plume',
    type: 'StartsUsing',
    netRegex: {
      id: '3144',
      source: 'Mist Dragon',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Star Explosions',
        de: 'Stern Explosion ködern',
        fr: 'Évitez l\'AoE en ligne des étoiles',
        ja: '放射霧を誘導',
        cn: '诱导放射雾',
        ko: '별모양 장판 피하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'The Scorpion\'s Den': 'Nistplatz der Hedetet',
      'The Gamma Segregate': 'Gamma-Isolationsbereich',
      'The Aspersory': 'Nebelhort',
      'Rock Biter': 'Felsbeißer',
      'Mist Dragon': 'Nebeldrache',
      'Dim Crystal': 'trüber Kristall',
      'Defective Drone': 'defekt(?:e|er|es|en) Drohne',
      'Hedetet': 'Hedetet'
    },
    'replaceText': {
      'Vaporize': 'Vaporisieren',
      'Shardstrike': 'Splitterschlag',
      'Shardfall': 'Splitterregen',
      'Rime Wreath': 'Frostkalter Reif',
      'Resonant Frequency': 'Resonanzfrequenz',
      'Hailfire': 'Hagelfeuer',
      'Full Throttle': 'Vollgas',
      'Frost Breath': 'Frostiger Atem',
      'Fog Plume': 'Nebelschwaden',
      'Dissonance': 'Dissonanz',
      'Deep Fog': 'Dichter Nebel',
      'Crystalline Fracture': 'Kristallfraktur',
      'Crystal Needle': 'Kristallnadel',
      'Cold Fog': 'Eisiger Nebel',
      'Chilling Aspiration': 'Nebelatem',
      'Cauterize': 'Kauterisieren',
      'Aetherochemical Residue': 'Ätherochemischer Rückstand',
      'Aetherochemical Flame': 'Ätherochemische Flamme',
      'Aetherochemical Coil': 'Ätherochemische Windung',
      'Adit Driver': 'Steinbohrer'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'The Scorpion\'s Den': 'Nid du scorpion',
      'The Gamma Segregate': 'Ancien répartiteur gamma',
      'The Aspersory': 'Plateau des Brumes',
      'Rock Biter': 'Trancheur de pierre',
      'Mist Dragon': 'Dragon des brumes',
      'Dim Crystal': 'Cristal décoloré',
      'Defective Drone': 'Drone défectueux',
      'Hedetet': 'Hedetet'
    },
    'replaceText': {
      'Vaporize': 'Vaporisation',
      'Shardstrike': 'Coup d\'éclats',
      'Shardfall': 'Pluie d\'éclats',
      'Rime Wreath': 'Enveloppe de givre',
      'Resonant Frequency': 'Explosion résonante',
      'Hailfire': 'Feu grêleux',
      'Full Throttle': 'Cadence infernale',
      'Frost Breath': 'Souffle glacé',
      'Fog Plume': 'Panache brumeux',
      'Dissonance': 'Dissonance',
      'Deep Fog': 'Brouillard épais',
      'Crystalline Fracture': 'Fragmentation cristalline',
      'Crystal Needle': 'Aiguille cristalline',
      'Cold Fog': 'Brume glaciale',
      'Chilling Aspiration': 'Souffle de brume',
      'Cauterize': 'Cautérisation',
      'Aetherochemical Residue': 'Mucus magismologique',
      'Aetherochemical Flame': 'Flammes magismologiques',
      'Aetherochemical Coil': 'Roue magismologique',
      'Adit Driver': 'Sciage de pierre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'The Scorpion\'s Den': 'ヘデテトの縄張り',
      'The Gamma Segregate': '旧ガンマ分離区',
      'The Aspersory': '霧の皿',
      'Rock Biter': 'ロックカッター',
      'Mist Dragon': 'ミストドラゴン',
      'Dim Crystal': '色あせたクリスタル',
      'Defective Drone': 'デフェクティブ・ドローン',
      'Hedetet': 'ヘデテト'
    },
    'replaceText': {
      'Vaporize': '霧散',
      'Shardstrike': 'シャードストライク',
      'Shardfall': 'シャードフォール',
      'Rime Wreath': 'ライムリリース',
      'Resonant Frequency': '共振炸裂',
      'Hailfire': 'ヘイルファイア',
      'Full Throttle': 'フルスロットル',
      'Frost Breath': 'フロストブレス',
      'Fog Plume': '放射霧',
      'Dissonance': 'ディソナンス',
      'Deep Fog': '濃霧',
      'Crystalline Fracture': '水晶剥落',
      'Crystal Needle': 'クリスタルニードル',
      'Cold Fog': '冷たい霧',
      'Chilling Aspiration': 'ミストブレス',
      'Cauterize': 'カータライズ',
      'Aetherochemical Residue': '魔科学粘液',
      'Aetherochemical Flame': '魔科学フレイム',
      'Aetherochemical Coil': '魔科学ホイール',
      'Adit Driver': '削岩'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'The Scorpion\'s Den': '赫德提特的领地',
      'The Gamma Segregate': '伽马隔离区',
      'The Aspersory': '雾碟',
      'Rock Biter': '石刃',
      'Mist Dragon': '雾龙',
      'Dim Crystal': '褪色水晶',
      'Defective Drone': '次品无人机',
      'Hedetet': '赫德提特'
    },
    'replaceText': {
      'Vaporize': '雾散',
      'Shardstrike': '碎片打击',
      'Shardfall': '碎片脱落',
      'Rime Wreath': '白霜环绕',
      'Resonant Frequency': '共振炸裂',
      'Hailfire': '冰雹发射',
      'Full Throttle': '全力轰油起步',
      'Frost Breath': '寒霜吐息',
      'Fog Plume': '放射雾',
      'Dissonance': '不和谐音',
      'Deep Fog': '浓雾',
      'Crystalline Fracture': '水晶剥落',
      'Crystal Needle': '水晶针',
      'Cold Fog': '彻骨雾寒',
      'Chilling Aspiration': '迷雾吐息',
      'Cauterize': '低温俯冲',
      'Aetherochemical Residue': '魔科学粘液',
      'Aetherochemical Flame': '魔科学烈焰',
      'Aetherochemical Coil': '魔科学车轮',
      'Adit Driver': '削岩'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'The Scorpion\'s Den': '헤데테트의 영역',
      'The Gamma Segregate': '구 감마 분리구역',
      'The Aspersory': '안개접시',
      'Rock Biter': '암석 절단날',
      'Mist Dragon': '안개 드래곤',
      'Dim Crystal': '빛바랜 크리스탈',
      'Defective Drone': '고장난 무인기',
      'Hedetet': '헤데테트'
    },
    'replaceText': {
      'Vaporize': '흩어지는 안개',
      'Shardstrike': '샤드 스트라이크',
      'Shardfall': '샤드 낙하',
      'Rime Wreath': '분노의 서릿발',
      'Resonant Frequency': '공진 작렬',
      'Hailfire': '우박 발사',
      'Full Throttle': '초고속 주행',
      'Frost Breath': '서리 숨결',
      'Fog Plume': '안개 방사',
      'Dissonance': '충돌',
      'Deep Fog': '짙은 안개',
      'Crystalline Fracture': '수정 조각',
      'Crystal Needle': '크리스탈 바늘',
      'Cold Fog': '차가운 안개',
      'Chilling Aspiration': '안개 숨결',
      'Cauterize': '인두질',
      'Aetherochemical Residue': '마과학 점액',
      'Aetherochemical Flame': '마과학 불꽃',
      'Aetherochemical Coil': '마과학 톱니바퀴',
      'Adit Driver': '암석 절단'
    }
  }]
};
/* harmony default export */ const the_burn = (the_burn_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/the_burn.txt
const dungeon_the_burn_namespaceObject = "### THE BURN\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~#\r\n# HEDETET #\r\n#~~~~~~~~~#\r\n\r\n# -ii 3198 3199\r\n\r\n# The Scorpion's Den will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"9B7\" } window 0,1\r\n10.4 \"Crystal Needle\" Ability { id: \"3193\", source: \"Hedetet\" }\r\n25.8 \"Hailfire\" Ability { id: \"3194\", source: \"Hedetet\" } window 25,30\r\n29.8 \"Resonant Frequency\" Ability { id: \"3198\", source: \"Dim Crystal\" }\r\n39.8 \"Shardstrike\" Ability { id: \"3195\", source: \"Hedetet\" }\r\n53.9 \"Shardfall\" Ability { id: \"3191\", source: \"Hedetet\" }\r\n62.0 \"Dissonance\" Ability { id: \"3192\", source: \"Hedetet\" } window 30,30\r\n69.1 \"Crystalline Fracture\" Ability { id: \"3197\", source: \"Dim Crystal\" }\r\n\r\n74.2 \"Crystal Needle\" Ability { id: \"3193\", source: \"Hedetet\" } window 20,20\r\n83.4 \"--jump--\" Ability { id: \"3196\", source: \"Hedetet\" }\r\n92.8 \"Hailfire\" Ability { id: \"3194\", source: \"Hedetet\" } window 30,30\r\n103.9 \"Shardstrike\" Ability { id: \"3195\", source: \"Hedetet\" }\r\n118.1 \"Shardfall\" Ability { id: \"3191\", source: \"Hedetet\" }\r\n126.1 \"Dissonance\" Ability { id: \"3192\", source: \"Hedetet\" } window 30,30\r\n133.2 \"Crystalline Fracture\" Ability { id: \"3197\", source: \"Dim Crystal\" }\r\n\r\n138.3 \"Crystal Needle\" Ability { id: \"3193\", source: \"Hedetet\" } window 20,20 jump 74.2\r\n147.5 \"--jump--\"\r\n156.9 \"Hailfire\"\r\n168.0 \"Shardstrike\"\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~#\r\n# DEFECTIVE DRONE #\r\n#~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 2D76 2D77 34D5 34D6 34D9\r\n\r\n# The Gamma Segregate will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"9BA\" } window 1000,5\r\n1012.7 \"Aetherochemical Flame\" Ability { id: \"2D73\", source: \"Defective Drone\" }\r\n1026.7 \"Aetherochemical Residue\" Ability { id: \"2D74\", source: \"Defective Drone\" }\r\n1030.9 \"--untargetable--\"\r\n1039.1 \"Full Throttle\" Ability { id: \"2D75\", source: \"Defective Drone\" } window 39,30\r\n1042.2 \"--targetable--\"\r\n\r\n1059.3 \"Aetherochemical Coil\" Ability { id: \"2D72\", source: \"Defective Drone\" } window 30,15\r\n1074.5 \"Adit Driver\" # Ability { id: \"2D78\", source: \"Rock Biter\" }\r\n1080.4 \"Aetherochemical Flame\" Ability { id: \"2D73\", source: \"Defective Drone\" }\r\n1094.5 \"Aetherochemical Coil\" Ability { id: \"2D72\", source: \"Defective Drone\" }\r\n1111.7 \"Aetherochemical Residue\" Ability { id: \"2D74\", source: \"Defective Drone\" }\r\n1115.6 \"--untargetable--\"\r\n1123.8 \"Full Throttle\" Ability { id: \"2D75\", source: \"Defective Drone\" } window 30,30\r\n1123.8 \"Adit Driver\" # Ability { id: \"2D78\", source: \"Rock Biter\" }\r\n1126.9 \"--targetable--\"\r\n\r\n1144.0 \"Aetherochemical Coil\" Ability { id: \"2D72\", source: \"Defective Drone\" } window 30,15 jump 1059.3\r\n1159.2 \"Adit Driver\"\r\n1165.1 \"Aetherochemical Flame\"\r\n1179.2 \"Aetherochemical Coil\"\r\n\r\n#~~~~~~~~~~~~~#\r\n# MIST DRAGON #\r\n#~~~~~~~~~~~~~#\r\n\r\n# -ii 3142 3145 3146 3149\r\n\r\n# The Aspersory will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"9BD\" } window 2000,5\r\n2013.2 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n2021.4 \"Frost Breath\" Ability { id: \"314C\", source: \"Mist Dragon\" }\r\n2030.7 \"Fog Plume\" Ability { id: \"3144\", source: \"Mist Dragon\" }\r\n2050.9 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n\r\n\r\n2061.9 \"Vaporize\" Ability { id: \"3140\", source: \"Mist Dragon\" } window 62,30\r\n2064.1 \"--untargetable--\"\r\n2073.1 \"--targetable--\"\r\n2093.1 \"Cold Fog\" Ability { id: \"3141\", source: \"Mist Dragon\" }\r\n2104.4 \"Chilling Aspiration\" Ability { id: \"314D\", source: \"Mist Dragon\" }\r\n2111.6 \"Frost Breath\" Ability { id: \"314C\", source: \"Mist Dragon\" }\r\n2119.7 \"Fog Plume\" Ability { id: \"3144\", source: \"Mist Dragon\" }\r\n2137.9 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n2152.2 \"Deep Fog\" Ability { id: \"3147\", source: \"Mist Dragon\" } window 150,30\r\n2157.3 \"--untargetable--\"\r\n2167.4 \"Cauterize\" Ability { id: \"3148\", source: \"Mist Dragon\" }\r\n2178.0 \"Cauterize\" Ability { id: \"3148\", source: \"Mist Dragon\" }\r\n2187.0 \"--targetable--\" Ability { id: \"314A\", source: \"Mist Dragon\" }\r\n2196.2 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n2205.4 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n2214.6 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n2224.8 \"Chilling Aspiration\" Ability { id: \"314D\", source: \"Mist Dragon\" } window 30,30\r\n2232.0 \"Frost Breath\" Ability { id: \"314C\", source: \"Mist Dragon\" }\r\n2240.1 \"Fog Plume\" Ability { id: \"3144\", source: \"Mist Dragon\" }\r\n2254.3 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n2263.5 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n2273.7 \"Deep Fog\" Ability { id: \"3147\", source: \"Mist Dragon\" } window 30,30\r\n2278.8 \"--untargetable--\"\r\n2288.9 \"Cauterize\" Ability { id: \"3148\", source: \"Mist Dragon\" }\r\n2299.5 \"Cauterize\" Ability { id: \"3148\", source: \"Mist Dragon\" }\r\n2308.5 \"--targetable--\" Ability { id: \"314A\", source: \"Mist Dragon\" }\r\n2317.7 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n\r\n\r\n2329.8 \"Vaporize\" Ability { id: \"3140\", source: \"Mist Dragon\" } window 30,30 jump 2061.9\r\n2332.0 \"--untargetable--\"\r\n2341.0 \"--targetable--\"\r\n2361.0 \"Cold Fog\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/the_burn64.ts



const the_burn64_triggerSet = {
  id: 'TheBurn64',
  zoneId: zone_id/* default.TheBurn64 */.Z.TheBurn64,
  timelineFile: 'the_burn64.txt',
  triggers: [{
    id: 'TheBurn64 Crystal Needle',
    type: 'StartsUsing',
    netRegex: {
      id: '3193',
      source: 'Hedetet'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'TheBurn64 Hailfire',
    type: 'HeadMarker',
    netRegex: {
      id: '0002',
      capture: false
    },
    condition: data => !data.hedetet,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide behind crystal',
        de: 'Hinter dem Kristall verstecken',
        fr: 'Cachez-vous derrière le cristal',
        ja: '水晶の後ろに',
        cn: '躲在水晶后',
        ko: '크리스탈 뒤에 숨기'
      }
    }
  }, {
    id: 'TheBurn64 Shardstrike',
    type: 'HeadMarker',
    netRegex: {
      id: '0060'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread + Avoid Crystals',
        de: 'Verteilen + Kristall meiden',
        fr: 'Dispersez-vous + évitez les cristaux',
        ja: '散開 + 水晶を避ける',
        cn: '散开并远离水晶',
        ko: '산개 + 크리스탈 피하기'
      }
    }
  }, {
    id: 'TheBurn64 Crystal Shardfall',
    type: 'StartsUsing',
    netRegex: {
      id: '3191',
      source: 'Hedetet',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide behind crystal',
        de: 'Hinter dem Kristall verstecken',
        fr: 'Cachez-vous derrière le cristal',
        ja: '水晶の後ろに',
        cn: '躲在水晶后',
        ko: '크리스탈 뒤에 숨기'
      }
    }
  }, {
    // This has a visible donut AoE, but the user must be inside the target ring to be safe.
    id: 'TheBurn64 Crystal Dissonance',
    type: 'StartsUsing',
    netRegex: {
      id: '3192',
      source: 'Hedetet',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    // Head marker 0002 is used in both the first two encounters.
    id: 'TheBurn64 Dead Hedetet',
    type: 'Ability',
    netRegex: {
      id: '368',
      source: 'Defective Drone',
      capture: false
    },
    condition: data => !data.hedetet,
    run: data => data.hedetet = true
  }, {
    id: 'TheBurn64 Aetherochemical Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '2D73',
      source: 'Defective Drone',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'TheBurn64 Aetherochemical Coil',
    type: 'StartsUsing',
    netRegex: {
      id: '2D72',
      source: 'Defective Drone'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'TheBurn64 Aetherochemical Residue',
    type: 'HeadMarker',
    netRegex: {
      id: '0002'
    },
    condition: (data, matches) => data.me === matches.target && data.hedetet,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Puddle on YOU',
        de: 'Fläche auf DIR',
        fr: 'Zone au sol sur VOUS',
        ja: '自分に粘液',
        cn: '圈圈点名',
        ko: '장판 대상자'
      }
    }
  }, {
    // The NPC here is Mining Drone.
    id: 'TheBurn64 Throttle',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '7670',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'In line with smoking drone',
        de: 'In einer Linie mit der rauchenden Drohne stellen',
        fr: 'En ligne avec le drone endommagé',
        ja: 'ドローンの直線に',
        cn: '站在冒烟小怪直线上',
        ko: '연기나는 드론 앞으로'
      }
    }
  }, {
    id: 'TheBurn64 Adit Driver',
    type: 'StartsUsing',
    netRegex: {
      id: '2D78',
      source: 'Rock Biter',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Rock Biters',
        de: 'Felsbeißer meiden',
        fr: 'Évitez le trancheur de pierre',
        ja: 'ロックカッターを避ける',
        cn: '躲开电锯',
        ko: '톱니바퀴 피하기'
      }
    }
  }, {
    id: 'TheBurn64 Rime Wreath',
    type: 'StartsUsing',
    netRegex: {
      id: '314B',
      source: 'Mist Dragon',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Also handles Chilling Aspiration, which is randomly targeted.
    id: 'TheBurn64 Frost Breath',
    type: 'HeadMarker',
    netRegex: {
      id: ['001A', '000E']
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.puddleCleaveOnYou();
      return output.avoidMarkerCone();
    },
    outputStrings: {
      puddleCleaveOnYou: {
        en: 'Puddle + cleave on YOU',
        de: 'Fläche + Cleave auf DIR',
        fr: 'Zone au sol + Cleave sur VOUS',
        ja: '自分に沼 + フロストブレス',
        cn: '圈圈+吐息点名',
        ko: '장판 + 브레스 대상자'
      },
      avoidMarkerCone: {
        en: 'Avoid marker cone',
        de: 'Kegel-Markierung ausweichen',
        fr: 'Évitez le marqueur de cône',
        ja: 'マーカーを避ける',
        cn: '远离锥形点名',
        ko: '표식 피하기'
      }
    }
  }, {
    id: 'TheBurn64 Fog Plume',
    type: 'StartsUsing',
    netRegex: {
      id: '3144',
      source: 'Mist Dragon',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Star Explosions',
        de: 'Stern Explosion ködern',
        fr: 'Attirez les explosions d\'étoiles',
        ja: '放射霧を誘導',
        cn: '诱导放射雾',
        ko: '별모양 장판 피하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'The Scorpion\'s Den': 'Nistplatz der Hedetet',
      'The Gamma Segregate': 'Gamma-Isolationsbereich',
      'The Aspersory': 'Nebelhort',
      'Rock Biter': 'Felsbeißer',
      'Mist Dragon': 'Nebeldrache',
      'Dim Crystal': 'trüber Kristall',
      'Defective Drone': 'defekt(?:e|er|es|en) Drohne',
      'Hedetet': 'Hedetet'
    },
    'replaceText': {
      'Vaporize': 'Vaporisieren',
      'Shardstrike': 'Splitterschlag',
      'Shardfall': 'Splitterregen',
      'Rime Wreath': 'Frostkalter Reif',
      'Resonant Frequency': 'Resonanzfrequenz',
      'Hailfire': 'Hagelfeuer',
      'Full Throttle': 'Vollgas',
      'Frost Breath': 'Frostiger Atem',
      'Fog Plume': 'Nebelschwaden',
      'Dissonance': 'Dissonanz',
      'Deep Fog': 'Dichter Nebel',
      'Crystalline Fracture': 'Kristallfraktur',
      'Crystal Needle': 'Kristallnadel',
      'Cold Fog': 'Eisiger Nebel',
      'Chilling Aspiration': 'Nebelatem',
      'Cauterize': 'Kauterisieren',
      'Aetherochemical Residue': 'Ätherochemischer Rückstand',
      'Aetherochemical Flame': 'Ätherochemische Flamme',
      'Aetherochemical Coil': 'Ätherochemische Windung',
      'Adit Driver': 'Steinbohrer'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'The Scorpion\'s Den': 'Nid du scorpion',
      'The Gamma Segregate': 'Ancien répartiteur gamma',
      'The Aspersory': 'Plateau des Brumes',
      'Rock Biter': 'Trancheur de pierre',
      'Mist Dragon': 'Dragon des brumes',
      'Dim Crystal': 'Cristal décoloré',
      'Defective Drone': 'Drone défectueux',
      'Hedetet': 'Hedetet'
    },
    'replaceText': {
      'Vaporize': 'Vaporisation',
      'Shardstrike': 'Coup d\'éclats',
      'Shardfall': 'Pluie d\'éclats',
      'Rime Wreath': 'Enveloppe de givre',
      'Resonant Frequency': 'Explosion résonante',
      'Hailfire': 'Feu grêleux',
      'Full Throttle': 'Cadence infernale',
      'Frost Breath': 'Souffle glacé',
      'Fog Plume': 'Panache brumeux',
      'Dissonance': 'Dissonance',
      'Deep Fog': 'Brouillard épais',
      'Crystalline Fracture': 'Fragmentation cristalline',
      'Crystal Needle': 'Aiguille cristalline',
      'Cold Fog': 'Brume glaciale',
      'Chilling Aspiration': 'Souffle de brume',
      'Cauterize': 'Cautérisation',
      'Aetherochemical Residue': 'Mucus magismologique',
      'Aetherochemical Flame': 'Flammes magismologiques',
      'Aetherochemical Coil': 'Roue magismologique',
      'Adit Driver': 'Sciage de pierre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'The Scorpion\'s Den': 'ヘデテトの縄張り',
      'The Gamma Segregate': '旧ガンマ分離区',
      'The Aspersory': '霧の皿',
      'Rock Biter': 'ロックカッター',
      'Mist Dragon': 'ミストドラゴン',
      'Dim Crystal': '色あせたクリスタル',
      'Defective Drone': 'デフェクティブ・ドローン',
      'Hedetet': 'ヘデテト'
    },
    'replaceText': {
      'Vaporize': '霧散',
      'Shardstrike': 'シャードストライク',
      'Shardfall': 'シャードフォール',
      'Rime Wreath': 'ライムリリース',
      'Resonant Frequency': '共振炸裂',
      'Hailfire': 'ヘイルファイア',
      'Full Throttle': 'フルスロットル',
      'Frost Breath': 'フロストブレス',
      'Fog Plume': '放射霧',
      'Dissonance': 'ディソナンス',
      'Deep Fog': '濃霧',
      'Crystalline Fracture': '水晶剥落',
      'Crystal Needle': 'クリスタルニードル',
      'Cold Fog': '冷たい霧',
      'Chilling Aspiration': 'ミストブレス',
      'Cauterize': 'カータライズ',
      'Aetherochemical Residue': '魔科学粘液',
      'Aetherochemical Flame': '魔科学フレイム',
      'Aetherochemical Coil': '魔科学ホイール',
      'Adit Driver': '削岩'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'The Scorpion\'s Den': '赫德提特的领地',
      'The Gamma Segregate': '伽马隔离区',
      'The Aspersory': '雾碟',
      'Rock Biter': '石刃',
      'Mist Dragon': '雾龙',
      'Dim Crystal': '褪色水晶',
      'Defective Drone': '次品无人机',
      'Hedetet': '赫德提特'
    },
    'replaceText': {
      'Vaporize': '雾散',
      'Shardstrike': '碎片打击',
      'Shardfall': '碎片脱落',
      'Rime Wreath': '白霜环绕',
      'Resonant Frequency': '共振炸裂',
      'Hailfire': '冰雹发射',
      'Full Throttle': '全力轰油起步',
      'Frost Breath': '寒霜吐息',
      'Fog Plume': '放射雾',
      'Dissonance': '不和谐音',
      'Deep Fog': '浓雾',
      'Crystalline Fracture': '水晶剥落',
      'Crystal Needle': '水晶针',
      'Cold Fog': '彻骨雾寒',
      'Chilling Aspiration': '迷雾吐息',
      'Cauterize': '低温俯冲',
      'Aetherochemical Residue': '魔科学粘液',
      'Aetherochemical Flame': '魔科学烈焰',
      'Aetherochemical Coil': '魔科学车轮',
      'Adit Driver': '削岩'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'The Scorpion\'s Den': '헤데테트의 영역',
      'The Gamma Segregate': '구 감마 분리구역',
      'The Aspersory': '안개접시',
      'Rock Biter': '암석 절단날',
      'Mist Dragon': '안개 드래곤',
      'Dim Crystal': '빛바랜 크리스탈',
      'Defective Drone': '고장난 무인기',
      'Hedetet': '헤데테트'
    },
    'replaceText': {
      'Vaporize': '흩어지는 안개',
      'Shardstrike': '샤드 스트라이크',
      'Shardfall': '샤드 낙하',
      'Rime Wreath': '분노의 서릿발',
      'Resonant Frequency': '공진 작렬',
      'Hailfire': '우박 발사',
      'Full Throttle': '초고속 주행',
      'Frost Breath': '서리 숨결',
      'Fog Plume': '안개 방사',
      'Dissonance': '충돌',
      'Deep Fog': '짙은 안개',
      'Crystalline Fracture': '수정 조각',
      'Crystal Needle': '크리스탈 바늘',
      'Cold Fog': '차가운 안개',
      'Chilling Aspiration': '안개 숨결',
      'Cauterize': '인두질',
      'Aetherochemical Residue': '마과학 점액',
      'Aetherochemical Flame': '마과학 불꽃',
      'Aetherochemical Coil': '마과학 톱니바퀴',
      'Adit Driver': '암석 절단'
    }
  }]
};
/* harmony default export */ const the_burn64 = (the_burn64_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/dungeon/the_burn64.txt
const dungeon_the_burn64_namespaceObject = "### THE BURN (6.4)\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~#\r\n# HEDETET #\r\n#~~~~~~~~~#\r\n\r\n# -ii 3198 3199\r\n\r\n# The Scorpion's Den will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"9B7\" } window 0,1\r\n10.4 \"Crystal Needle\" Ability { id: \"3193\", source: \"Hedetet\" }\r\n25.8 \"Hailfire\" Ability { id: \"3194\", source: \"Hedetet\" } window 25,30\r\n29.8 \"Resonant Frequency\" Ability { id: \"3198\", source: \"Dim Crystal\" }\r\n39.8 \"Shardstrike\" Ability { id: \"3195\", source: \"Hedetet\" }\r\n53.9 \"Shardfall\" Ability { id: \"3191\", source: \"Hedetet\" }\r\n62.0 \"Dissonance\" Ability { id: \"3192\", source: \"Hedetet\" } window 30,30\r\n69.1 \"Crystalline Fracture\" Ability { id: \"3197\", source: \"Dim Crystal\" }\r\n\r\n74.2 \"Crystal Needle\" Ability { id: \"3193\", source: \"Hedetet\" } window 20,20\r\n83.4 \"--jump--\" Ability { id: \"3196\", source: \"Hedetet\" }\r\n92.8 \"Hailfire\" Ability { id: \"3194\", source: \"Hedetet\" } window 30,30\r\n103.9 \"Shardstrike\" Ability { id: \"3195\", source: \"Hedetet\" }\r\n118.1 \"Shardfall\" Ability { id: \"3191\", source: \"Hedetet\" }\r\n126.1 \"Dissonance\" Ability { id: \"3192\", source: \"Hedetet\" } window 30,30\r\n133.2 \"Crystalline Fracture\" Ability { id: \"3197\", source: \"Dim Crystal\" }\r\n\r\n138.3 \"Crystal Needle\" Ability { id: \"3193\", source: \"Hedetet\" } window 20,20 jump 74.2\r\n147.5 \"--jump--\"\r\n156.9 \"Hailfire\"\r\n168.0 \"Shardstrike\"\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~#\r\n# DEFECTIVE DRONE #\r\n#~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 2D76 2D77 34D5 34D6 34D9\r\n\r\n# The Gamma Segregate will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"9BA\" } window 1000,5\r\n1012.7 \"Aetherochemical Flame\" Ability { id: \"2D73\", source: \"Defective Drone\" }\r\n1026.7 \"Aetherochemical Residue\" Ability { id: \"2D74\", source: \"Defective Drone\" }\r\n1030.9 \"--untargetable--\"\r\n1039.1 \"Full Throttle\" Ability { id: \"2D75\", source: \"Defective Drone\" } window 39,30\r\n1042.2 \"--targetable--\"\r\n\r\n1059.3 \"Aetherochemical Coil\" Ability { id: \"2D72\", source: \"Defective Drone\" } window 30,15\r\n1074.5 \"Adit Driver\" # Ability { id: \"2D78\", source: \"Rock Biter\" }\r\n1080.4 \"Aetherochemical Flame\" Ability { id: \"2D73\", source: \"Defective Drone\" }\r\n1094.5 \"Aetherochemical Coil\" Ability { id: \"2D72\", source: \"Defective Drone\" }\r\n1111.7 \"Aetherochemical Residue\" Ability { id: \"2D74\", source: \"Defective Drone\" }\r\n1115.6 \"--untargetable--\"\r\n1123.8 \"Full Throttle\" Ability { id: \"2D75\", source: \"Defective Drone\" } window 30,30\r\n1123.8 \"Adit Driver\" # Ability { id: \"2D78\", source: \"Rock Biter\" }\r\n1126.9 \"--targetable--\"\r\n\r\n1144.0 \"Aetherochemical Coil\" Ability { id: \"2D72\", source: \"Defective Drone\" } window 30,15 jump 1059.3\r\n1159.2 \"Adit Driver\"\r\n1165.1 \"Aetherochemical Flame\"\r\n1179.2 \"Aetherochemical Coil\"\r\n\r\n#~~~~~~~~~~~~~#\r\n# MIST DRAGON #\r\n#~~~~~~~~~~~~~#\r\n\r\n# -ii 3142 3145 3146 3149\r\n\r\n# The Aspersory will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"9BD\" } window 2000,5\r\n2013.2 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n2021.4 \"Frost Breath\" Ability { id: \"314C\", source: \"Mist Dragon\" }\r\n2030.7 \"Fog Plume\" Ability { id: \"3144\", source: \"Mist Dragon\" }\r\n2050.9 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n\r\n\r\n2061.9 \"Vaporize\" Ability { id: \"3140\", source: \"Mist Dragon\" } window 62,30\r\n2064.1 \"--untargetable--\"\r\n2073.1 \"--targetable--\"\r\n2093.1 \"Cold Fog\" Ability { id: \"3141\", source: \"Mist Dragon\" }\r\n2104.4 \"Chilling Aspiration\" Ability { id: \"314D\", source: \"Mist Dragon\" }\r\n2111.6 \"Frost Breath\" Ability { id: \"314C\", source: \"Mist Dragon\" }\r\n2119.7 \"Fog Plume\" Ability { id: \"3144\", source: \"Mist Dragon\" }\r\n2137.9 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n2152.2 \"Deep Fog\" Ability { id: \"3147\", source: \"Mist Dragon\" } window 150,30\r\n2157.3 \"--untargetable--\"\r\n2167.4 \"Cauterize\" Ability { id: \"3148\", source: \"Mist Dragon\" }\r\n2178.0 \"Cauterize\" Ability { id: \"3148\", source: \"Mist Dragon\" }\r\n2187.0 \"--targetable--\" Ability { id: \"314A\", source: \"Mist Dragon\" }\r\n2196.2 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n2205.4 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n2214.6 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n2224.8 \"Chilling Aspiration\" Ability { id: \"314D\", source: \"Mist Dragon\" } window 30,30\r\n2232.0 \"Frost Breath\" Ability { id: \"314C\", source: \"Mist Dragon\" }\r\n2240.1 \"Fog Plume\" Ability { id: \"3144\", source: \"Mist Dragon\" }\r\n2254.3 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n2263.5 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n2273.7 \"Deep Fog\" Ability { id: \"3147\", source: \"Mist Dragon\" } window 30,30\r\n2278.8 \"--untargetable--\"\r\n2288.9 \"Cauterize\" Ability { id: \"3148\", source: \"Mist Dragon\" }\r\n2299.5 \"Cauterize\" Ability { id: \"3148\", source: \"Mist Dragon\" }\r\n2308.5 \"--targetable--\" Ability { id: \"314A\", source: \"Mist Dragon\" }\r\n2317.7 \"Rime Wreath\" Ability { id: \"314B\", source: \"Mist Dragon\" }\r\n\r\n\r\n2329.8 \"Vaporize\" Ability { id: \"3140\", source: \"Mist Dragon\" } window 30,30 jump 2061.9\r\n2332.0 \"--untargetable--\"\r\n2341.0 \"--targetable--\"\r\n2361.0 \"Cold Fog\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/eureka/eureka_anemos.ts



const eureka_anemos_triggerSet = {
  id: 'TheForbiddenLandEurekaAnemos',
  zoneId: zone_id/* default.TheForbiddenLandEurekaAnemos */.Z.TheForbiddenLandEurekaAnemos,
  resetWhenOutOfCombat: false,
  triggers: [{
    id: 'Eureka Garm Dragon Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '2AD5',
      source: 'Void Garm',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dragon\'s Voice',
        de: 'Stimme Des Drachen',
        fr: 'Voix du dragon',
        ja: '雷電の咆哮',
        cn: '雷电咆哮',
        ko: '뇌전의 포효'
      }
    }
  }, {
    id: 'Eureka Sabotender Stack Marker',
    type: 'StartsUsing',
    netRegex: {
      id: '29EB',
      source: 'Sabotender Corrido'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Eureka Poly Swipe',
    type: 'StartsUsing',
    netRegex: {
      id: '2A71',
      source: 'Polyphemus',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Swipe',
        de: 'Hieb',
        fr: 'Fauche',
        ja: 'スワイプ',
        cn: '横扫',
        ko: '휘두르기'
      }
    }
  }, {
    id: 'Eureka Poly Swing',
    type: 'StartsUsing',
    netRegex: {
      id: '2A6E',
      source: 'Polyphemus',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Eureka Poly Eye',
    type: 'StartsUsing',
    netRegex: {
      id: '2A73',
      source: 'Polyphemus',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Eye Donut',
        de: 'Augendonut',
        fr: 'Donut œil',
        ja: 'アイ・オブ・ビホルダー',
        cn: '月环',
        ko: '눈알 도넛 장판'
      }
    }
  }, {
    id: 'Eureka Poly Glower',
    type: 'StartsUsing',
    netRegex: {
      id: '2A72',
      source: 'Polyphemus',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Glower Laser',
        de: 'Blick Laser',
        fr: 'Regard laser',
        ja: 'グラワー',
        cn: '怒视',
        ko: '광선'
      }
    }
  }, {
    id: 'Eureka Caym Eye',
    type: 'StartsUsing',
    netRegex: {
      id: '2A64',
      source: 'Caym',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Eureka Fafnir Terror',
    type: 'StartsUsing',
    netRegex: {
      id: '29B7',
      source: 'Fafnir',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Eureka Voidscale Ice',
    type: 'StartsUsing',
    netRegex: {
      id: '29C3',
      source: 'Voidscale'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Ice ball on you!',
        de: 'Eisball auf dir!',
        fr: 'Boule de glace sur vous !',
        ja: '自分に氷玉',
        cn: '点名冰球！',
        ko: '얼음 구슬 대상자'
      }
    }
  }, {
    id: 'Eureka Pazuzu Dread Wind',
    type: 'StartsUsing',
    netRegex: {
      id: '2899',
      source: 'Pazuzu',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Eureka Pazuzu Camisado',
    type: 'StartsUsing',
    netRegex: {
      id: '289F',
      source: 'Pazuzu'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Eureka Pazuzu Cloud of Locust',
    type: 'StartsUsing',
    netRegex: {
      id: '2897',
      source: 'Pazuzu',
      capture: false
    },
    response: responses/* Responses.outOfMelee */.n3.outOfMelee()
  }, {
    id: 'Eureka Pazuzu Plague of Locust',
    type: 'StartsUsing',
    netRegex: {
      id: '2896',
      source: 'Pazuzu',
      capture: false
    },
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Plague Donut',
        de: 'Plagen-Donut',
        fr: 'Donut Nuée',
        ja: 'ローカストプレイグ',
        cn: '月环',
        ko: '역병 도넛 장판'
      }
    }
  }, {
    id: 'Eureka Wraith Count',
    type: 'WasDefeated',
    netRegex: {
      target: 'Shadow Wraith',
      capture: false
    },
    soundVolume: 0,
    infoText: (data, _matches, output) => {
      data.wraithCount = (data.wraithCount ?? 0) + 1;
      return output.text({
        num: data.wraithCount
      });
    },
    outputStrings: {
      text: {
        en: 'wraiths: ${num}',
        de: 'Geister: ${num}',
        fr: 'spectres: ${num}',
        ja: 'レイス: ${num}',
        cn: '幽灵击杀: ${num}',
        ko: '망령: ${num}'
      }
    }
  }, {
    id: 'Eureka Pazuzu Pop',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Pazuzu',
      capture: false
    },
    run: data => data.wraithCount = 0
  },
  // https://xivapi.com/LogMessage/916
  // en: 7 minutes have elapsed since your last activity. [...]
  // There is no network packet for these log lines; so have to use GameLog.
  {
    id: 'Eureka Falling Asleep',
    type: 'GameLog',
    netRegex: {
      line: '7 minutes have elapsed since your last activity..*?',
      capture: false
    },
    response: responses/* Responses.wakeUp */.n3.wakeUp()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      '7 minutes have elapsed since your last activity..*?': 'Seit deiner letzten Aktivität sind 7 Minuten vergangen.',
      'Caym': 'Caym',
      'Fafnir': 'Fafnir',
      'Pazuzu': 'Pazuzu',
      'Polyphemus': 'Polyphemus',
      'Sabotender Corrido': 'Sabotender Corrido',
      'Shadow Wraith': 'Schatten-Geist',
      'Void Garm': 'Nichts-Garm',
      'Voidscale': 'Nichtsschuppe'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '7 minutes have elapsed since your last activity.': 'Votre personnage est inactif depuis 7 minutes',
      'Caym': 'Caym',
      'Fafnir': 'Fafnir',
      'Pazuzu': 'Pazuzu',
      'Polyphemus': 'Polyphemus',
      'Sabotender Corrido': 'pampa corrido',
      'Shadow Wraith': 'spectre des ombres',
      'Void Garm': 'garm du néant',
      'Voidscale': 'vidécailles'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '7 minutes have elapsed since your last activity.': '操作がない状態になってから7分が経過しました。',
      'Caym': 'カイム',
      'Fafnir': 'ファヴニル',
      'Pazuzu': 'パズズ',
      'Polyphemus': 'ポリュペモス',
      'Sabotender Corrido': '賞金首：サボテンダー・コリード',
      'Shadow Wraith': 'シャドウ・レイス',
      'Void Garm': 'ヴォイドガルム',
      'Voidscale': 'ヴォイドスケイル'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '7 minutes have elapsed since your last activity.': '已经7分钟没有进行任何操作',
      'Caym': '盖因',
      'Fafnir': '法夫纳',
      'Pazuzu': '帕祖祖',
      'Polyphemus': '波吕斐摩斯',
      'Sabotender Corrido': '悬赏魔物：科里多仙人刺',
      'Shadow Wraith': '暗影幽灵',
      'Void Garm': '虚无加姆',
      'Voidscale': '虚无鳞龙'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '7 minutes have elapsed since your last activity..*?': '7분 동안 아무 조작을 하지 않았습니다',
      'Caym': '카임',
      'Fafnir': '파프니르',
      'Pazuzu': '파주주',
      'Polyphemus': '폴리페모스',
      'Sabotender Corrido': '현상수배: 사보텐더 코리도',
      'Shadow Wraith': '그림자 망령',
      'Void Garm': '보이드 가름',
      'Voidscale': '보이드비늘'
    }
  }]
};
/* harmony default export */ const eureka_anemos = (eureka_anemos_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/eureka/eureka_hydatos.ts



const eureka_hydatos_triggerSet = {
  id: 'TheForbiddenLandEurekaHydatos',
  zoneId: zone_id/* default.TheForbiddenLandEurekaHydatos */.Z.TheForbiddenLandEurekaHydatos,
  timelineFile: 'eureka_hydatos.txt',
  resetWhenOutOfCombat: false,
  timelineTriggers: [{
    id: 'BA Art Geas',
    regex: /Legendary Geas/,
    beforeSeconds: 0,
    response: responses/* Responses.stopMoving */.n3.stopMoving()
  }, {
    id: 'BA Raiden Levinwhorl',
    regex: /Levinwhorl/,
    beforeSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Shields and Mitigation',
        de: 'Schilde und Abschwächungen',
        fr: 'Boucliers et mitigation',
        ja: 'ダメージ軽減とバリアを',
        cn: '切盾减伤',
        ko: '뎀감, 보호막'
      }
    }
  }, {
    id: 'BA AV Eurekan Potion',
    regex: /Explosive Impulse/,
    beforeSeconds: 10,
    suppressSeconds: 60,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pop Eurekan Potions',
        de: 'Eureka-Heiltränke benutzen',
        fr: 'Utilisez potion d\'Eurêka',
        ja: 'エウレカ回復薬',
        cn: '磕优雷卡回复药',
        ko: '에우레카 포션 먹기'
      }
    }
  }, {
    id: 'BA Ozma Black Hole Warning',
    regex: /Black Hole/,
    beforeSeconds: 12,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Black Hole Soon',
        de: 'Schwarzes Loch',
        fr: 'Trou noir bientôt',
        ja: 'まもなくブラックホール',
        cn: '黑洞警告',
        ko: '곧 블랙홀'
      }
    }
  }],
  triggers: [
  // https://xivapi.com/LogMessage/916
  // en: 7 minutes have elapsed since your last activity. [...]
  // There is no network packet for these log lines; so have to use GameLog.
  {
    id: 'BA Falling Asleep',
    type: 'GameLog',
    netRegex: {
      line: '7 minutes have elapsed since your last activity..*?',
      capture: false
    },
    response: responses/* Responses.wakeUp */.n3.wakeUp()
  },
  // https://xivapi.com/LogMessage/9069
  // en: The memories of heroes past live on again!
  // TODO: Update to ActorControlSelf (category=0x020F, param1=0x236D) when available
  // See OverlayPlugin/cactbot#99 and OverlayPlugin/OverlayPlugin#329 for further info
  {
    id: 'BA Saved By Remembrance',
    type: 'GameLog',
    netRegex: {
      line: 'The memories of heroes past live on again.*?',
      capture: false
    },
    sound: 'Long'
  }, {
    id: 'BA Seal',
    type: 'SystemLogMessage',
    // "will be sealed off"
    netRegex: {
      id: '7DC',
      capture: false
    },
    run: data => data.sealed = true
  }, {
    id: 'BA Clear Data',
    type: 'SystemLogMessage',
    // "is no longer sealed"
    netRegex: {
      id: '7DE',
      capture: false
    },
    run: data => {
      delete data.side;
      delete data.mythcall;
      delete data.clones;
      delete data.bracelets;
      delete data.sealed;
      delete data.blackHoleCount;
      delete data.seenHostile;
    }
  }, {
    id: 'BA West Side',
    type: 'Ability',
    // The two sides are far enough apart that even though you see the autos
    // from the opposite boss, you don't see the player target (which is blank).
    // This considers you on the west side if Art autos somebody, and the name isn't blank.
    netRegex: {
      id: '3956',
      source: 'Art',
      target: '[^:]+',
      capture: false
    },
    suppressSeconds: 1000,
    run: data => data.side = 'west'
  }, {
    id: 'BA East Side',
    type: 'Ability',
    netRegex: {
      id: '3957',
      source: 'Owain',
      target: '[^:]+',
      capture: false
    },
    suppressSeconds: 1000,
    run: data => data.side = 'east'
  }, {
    id: 'BA Art Mythcall',
    type: 'StartsUsing',
    netRegex: {
      id: '3927',
      source: 'Art',
      capture: false
    },
    condition: data => data.side === 'west',
    run: data => data.mythcall = true
  }, {
    id: 'BA Art Tankbuster',
    type: 'StartsUsing',
    netRegex: {
      id: '3934',
      source: 'Art'
    },
    condition: data => data.side === 'west',
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'BA Art Orb Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '005C'
    },
    condition: data => data.side === 'west',
    alarmText: (data, matches, output) => {
      if (data.me !== matches.target) return;
      return output.orbOnYou();
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return;
      return output.awayFromOrbMarker();
    },
    outputStrings: {
      awayFromOrbMarker: {
        en: 'Away From Orb Marker',
        de: 'Weg vom Orb-Marker',
        fr: 'Éloignez-vous du marquage Orbe',
        ja: '玉から離れる',
        cn: '远离点名',
        ko: '구슬 대상자에서 떨어지기'
      },
      orbOnYou: {
        en: 'Orb on YOU',
        de: 'Orb auf DIR',
        fr: 'Orbe sur VOUS',
        ja: '自分に玉',
        cn: '点名',
        ko: '구슬 대상자'
      }
    }
  }, {
    id: 'BA Art Piercing Dark Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: (data, matches) => data.side === 'west' && data.me === matches.target,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'BA Art Legendcarver',
    type: 'StartsUsing',
    netRegex: {
      id: '3928',
      source: 'Art',
      capture: false
    },
    condition: data => data.side === 'west',
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'BA Art Legendspinner',
    type: 'StartsUsing',
    netRegex: {
      id: '3929',
      source: 'Art',
      capture: false
    },
    condition: data => data.side === 'west',
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'BA Art Mythcall Legendcarver',
    type: 'StartsUsing',
    netRegex: {
      id: '3928',
      source: 'Art',
      capture: false
    },
    condition: data => data.side === 'west' && data.mythcall,
    delaySeconds: 3.5,
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'BA Art Mythcall Legendspinner',
    type: 'StartsUsing',
    netRegex: {
      id: '3929',
      source: 'Art',
      capture: false
    },
    condition: data => data.side === 'west' && data.mythcall,
    delaySeconds: 3.5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Under Spears',
        de: 'Unter einen Speer',
        fr: 'En dessous des lances',
        ja: '妖槍旋',
        cn: '枪脚下',
        ko: '창 아래로'
      }
    }
  }, {
    id: 'BA Owain Tankbuster',
    type: 'StartsUsing',
    netRegex: {
      id: '3945',
      source: 'Owain'
    },
    condition: data => data.side === 'west',
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'BA Owain Piercing Light Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: (data, matches) => data.side === 'east' && data.me === matches.target,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'BA Owain Dorito Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: (data, matches) => data.side === 'east' && data.me === matches.target,
    response: responses/* Responses.doritoStack */.n3.doritoStack()
  },
  // https://xivapi.com/PublicContentTextData/2122
  // en: Munderg, turn flesh to ash!
  // TODO: Update to ActorControl (category=0x0834, param1=0x84A) when available
  // See OverlayPlugin/cactbot#99 and OverlayPlugin/OverlayPlugin#329 for further info
  {
    id: 'BA Owain Fire Element',
    type: 'GameLog',
    netRegex: {
      line: '[^:]*:Munderg, turn flesh to ash.*?',
      code: util/* default.gameLogCodes.dialog */.Z.gameLogCodes.dialog,
      capture: false
    },
    condition: data => data.side === 'east',
    alertText: (_data, _matches, output) => output.getToIce(),
    infoText: (_data, _matches, output) => output.switchMagia(),
    outputStrings: {
      switchMagia: {
        en: 'Switch Magia',
        de: 'Magia-Brett drehen',
        fr: 'Changez de Magia',
        ja: 'マギアボードを切替',
        cn: '切换元素板',
        ko: '마기아 전환'
      },
      getToIce: {
        en: 'Get to Ice',
        de: 'Geh zum Eis',
        fr: 'Allez à la glace',
        ja: '氷に',
        cn: '冰',
        ko: '얼음'
      }
    }
  },
  // https://xivapi.com/PublicContentTextData/2123
  // en: Munderg, turn blood to ice!
  // TODO: Update to ActorControl (category=0x0834, param1=0x84B) when available
  // See OverlayPlugin/cactbot#99 and OverlayPlugin/OverlayPlugin#329 for further info
  {
    id: 'BA Owain Ice Element',
    type: 'GameLog',
    netRegex: {
      line: '[^:]*:Munderg, turn blood to ice.*?',
      code: util/* default.gameLogCodes.dialog */.Z.gameLogCodes.dialog,
      capture: false
    },
    condition: data => data.side === 'east',
    alertText: (_data, _matches, output) => output.getToFire(),
    infoText: (_data, _matches, output) => output.switchMagia(),
    outputStrings: {
      switchMagia: {
        en: 'Switch Magia',
        de: 'Magia-Brett drehen',
        fr: 'Changez de Magia',
        ja: 'マギアボードを切替',
        cn: '切换元素板',
        ko: '마기아 전환'
      },
      getToFire: {
        en: 'Get to Fire',
        de: 'Geh zum Feuer',
        fr: 'Allez au feu',
        ja: '火',
        cn: '火',
        ko: '불'
      }
    }
  }, {
    id: 'BA Owain Ivory Palm',
    type: 'Ability',
    netRegex: {
      id: '3941',
      source: 'Ivory Palm'
    },
    condition: (data, matches) => data.side === 'east' && data.me === matches.target,
    response: responses/* Responses.doritoStack */.n3.doritoStack()
  }, {
    id: 'BA Owain Pitfall',
    type: 'StartsUsing',
    netRegex: {
      id: '394D',
      source: 'Owain',
      capture: false
    },
    condition: data => data.side === 'east',
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'BA Silence Centaur',
    type: 'StartsUsing',
    netRegex: {
      id: '3BFE',
      source: 'Arsenal Centaur'
    },
    condition: data => data.CanSleep(),
    response: responses/* Responses.sleep */.n3.sleep()
  }, {
    id: 'BA Raiden Tankbuster',
    type: 'StartsUsing',
    netRegex: {
      id: '387B',
      source: 'Raiden'
    },
    condition: data => data.sealed,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'BA Raiden Lancing Bolt',
    type: 'HeadMarker',
    netRegex: {
      id: '008A'
    },
    condition: (data, matches) => data.sealed && data.me === matches.target,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'BA Raiden Ame',
    type: 'StartsUsing',
    netRegex: {
      id: '3868',
      source: 'Raiden',
      capture: false
    },
    condition: data => data.sealed,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'BA Raiden Whirling',
    type: 'StartsUsing',
    netRegex: {
      id: '386A',
      source: 'Raiden',
      capture: false
    },
    condition: data => data.sealed,
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'BA Raiden For Honor',
    type: 'StartsUsing',
    netRegex: {
      id: '387C',
      source: 'Raiden',
      capture: false
    },
    condition: data => data.sealed,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'BA Raiden Lateral 1',
    type: 'StartsUsing',
    netRegex: {
      id: '386C',
      source: 'Raiden',
      capture: false
    },
    condition: data => data.sealed,
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'BA Raiden Lateral 2',
    type: 'StartsUsing',
    netRegex: {
      id: '386B',
      source: 'Raiden',
      capture: false
    },
    condition: data => data.sealed,
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'BA AV Tankbuster',
    type: 'StartsUsing',
    netRegex: {
      id: '379A',
      source: 'Absolute Virtue'
    },
    condition: data => data.sealed,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'BA AV Eidos Dark Bracelets',
    type: 'StartsUsing',
    netRegex: {
      id: '3787',
      source: 'Absolute Virtue',
      capture: false
    },
    condition: data => data.sealed,
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.bracelets = 'dark',
    outputStrings: {
      text: {
        en: 'Dark Bracelets',
        de: 'Dunkle Armreife',
        fr: 'Bracelets ténèbreux',
        ja: '黒リング',
        cn: '黑光环',
        ko: '어두운 고리'
      }
    }
  }, {
    id: 'BA AV Eidos Light Bracelets',
    type: 'StartsUsing',
    netRegex: {
      id: '3786',
      source: 'Absolute Virtue',
      capture: false
    },
    condition: data => data.sealed,
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.bracelets = 'light',
    outputStrings: {
      text: {
        en: 'Light Bracelets',
        de: 'Helle Armreife',
        fr: 'Bracelets lumineux',
        ja: '白リング',
        cn: '白光环',
        ko: '빛 고리'
      }
    }
  }, {
    id: 'BA AV Eidos Hostile Aspect',
    type: 'StartsUsing',
    netRegex: {
      id: '378B',
      source: 'Absolute Virtue',
      capture: false
    },
    condition: data => data.sealed,
    alertText: (data, _matches, output) => {
      if (!data.seenHostile) {
        if (data.bracelets === 'light') return output.awayFromLightCircles();
        if (data.bracelets === 'dark') return output.awayFromDarkCircles();
        return;
      }
      if (data.bracelets === 'light') return output.standByDarkCircles();
      if (data.bracelets === 'dark') return output.standByLightCircles();
    },
    run: data => data.seenHostile = true,
    outputStrings: {
      awayFromLightCircles: {
        en: 'Away From Light Circles',
        de: 'Weg von hellen Kreisen',
        fr: 'Éloignez-vous des cercles lumineux',
        ja: '白リングから離れる',
        cn: '远离白圈',
        ko: '밝은 원에서 떨어지기'
      },
      awayFromDarkCircles: {
        en: 'Away From Dark Circles',
        de: 'Weg von dunklen Kreisen',
        fr: 'Éloignez-vous des cercles ténèbreux',
        ja: '黒リングから離れる',
        cn: '远离黑圈',
        ko: '어두운 원에서 떨어지기'
      },
      standByDarkCircles: {
        en: 'Stand By Dark Circles',
        de: 'Zu den dunklen Kreisen',
        fr: 'Placez-vous près des cercles ténèbreux',
        ja: '黒リングに近づく',
        cn: '靠近黑圈',
        ko: '어두운 원 옆에 서기'
      },
      standByLightCircles: {
        en: 'Stand By Light Circles',
        de: 'zu den hellen Kreisen',
        fr: 'Placez-vous près des cercles lumineux',
        ja: '白リングに近づく',
        cn: '靠近白圈',
        ko: '밝은 원 옆에 서기'
      }
    }
  }, {
    id: 'BA AV Eidos Impact Stream',
    type: 'StartsUsing',
    netRegex: {
      id: '3788',
      source: 'Absolute Virtue',
      capture: false
    },
    condition: data => data.sealed,
    alertText: (data, _matches, output) => {
      if (data.bracelets === 'light') return output.dark();
      if (data.bracelets === 'dark') return output.light();
    },
    outputStrings: {
      dark: {
        en: 'Dark',
        de: 'Dunkel',
        fr: 'Ténèbres',
        ja: '黒',
        cn: '黑',
        ko: '어둠'
      },
      light: {
        en: 'Light',
        de: 'Hell',
        fr: 'Lumière',
        ja: '白',
        cn: '白',
        ko: '빛'
      }
    }
  }, {
    // Note: These use 00:3...: lines, without any proper "gains effect" lines.
    // In other words, they need to be fully translated in the game log.
    // There are no "gainsEffect" lines for the clones, only for Absolute Virtue directly.
    // Ideally parser logic could be added for this case, but this is where we are.
    // Note: Use .*? in the regex, as it appears from recent logs that special characters
    // may be included in these lines, e.g.:
    // 332E||Relative Virtue gains the effect of Umbral Essence.|
    //
    // TODO: There are ActorControl packets (GainEffect, category=0x0014) for these effects,
    // but the FFXIV parsing plugin does not emit 0x1A lines. This is being looked at.
    // See OverlayPlugin/cactbot#99 for further info.
    id: 'BA AV Eidos Relative Virtue Astral',
    type: 'GameLog',
    netRegex: {
      line: 'Relative Virtue gains the effect of .*?Astral Essence.*?',
      capture: false
    },
    condition: data => data.sealed,
    run: data => {
      // RV clones get buffs in the reverse order that they do their attacks in.
      data.clones ??= [];
      data.clones.push('astral');
    }
  }, {
    // See note above for `BA AV Eidos Relative Virtue Astral`.
    id: 'BA AV Eidos Relative Virtue Umbral',
    type: 'GameLog',
    netRegex: {
      line: 'Relative Virtue gains the effect of .*?Umbral Essence.*?',
      capture: false
    },
    condition: data => data.sealed,
    run: data => {
      // RV clones get buffs in the reverse order that they do their attacks in.
      data.clones ??= [];
      data.clones.push('umbral');
    }
  }, {
    id: 'BA AV Triple Impact Stream',
    type: 'StartsUsing',
    netRegex: {
      id: '3797',
      source: 'Absolute Virtue',
      capture: false
    },
    condition: data => data.sealed,
    alertText: (data, _matches, output) => {
      if (!data.clones) return;
      const wrists = data.clones.pop();
      if (wrists === 'Astral') return output.dark();
      if (wrists === 'Umbral') return output.light();
    },
    outputStrings: {
      dark: {
        en: 'Dark',
        de: 'Dunkel',
        fr: 'Ténèbres',
        ja: '黒',
        cn: '黑',
        ko: '어둠'
      },
      light: {
        en: 'Light',
        de: 'Hell',
        fr: 'Lumière',
        ja: '白',
        cn: '白',
        ko: '빛'
      }
    }
  }, {
    id: 'BA AV Eidos Turbulent Aether',
    type: 'Ability',
    netRegex: {
      id: '3790',
      source: 'Absolute Virtue',
      capture: false
    },
    condition: data => data.sealed,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Orbs to Opposite Colors',
        de: 'Kugeln zu umgekehrter Farbe',
        fr: 'Orbes aux couleurs opposées',
        ja: '反対の色に',
        cn: '连线去相反颜色',
        ko: '구슬 반대 색깔로'
      }
    }
  }, {
    id: 'BA AV Call Wyvern',
    type: 'Ability',
    netRegex: {
      id: '3798',
      source: 'Absolute Virtue',
      capture: false
    },
    condition: data => data.sealed,
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'BA Ozma Sphere Form',
    type: 'Ability',
    netRegex: {
      source: 'Proto Ozma',
      id: ['37B3', '37A5', '379F'],
      capture: false
    },
    condition: data => data.sealed,
    preRun: data => {
      data.blackHoleCount = (data.blackHoleCount ?? 0) + 1;
    },
    alarmText: (data, _matches, output) => output.blackHole({
      num: data.blackHoleCount
    }),
    tts: (data, _matches, output) => output.blackHoleTTS({
      num: data.blackHoleCount
    }),
    outputStrings: {
      blackHole: {
        en: 'Black Hole ${num} / 6',
        de: 'Schwarzes Loch ${num} / 6',
        fr: 'Trou noir ${num} / 6',
        ja: 'ブラックホール: ${num} / 6',
        cn: '黑洞 ${num} / 6',
        ko: '블랙홀${num} / 6'
      },
      blackHoleTTS: {
        en: 'Black Hole ${num}',
        de: 'Schwarzes Loch ${num}',
        fr: 'Trou noir ${num}',
        ja: 'ブラックホール ${num}',
        cn: '黑洞 ${num}',
        ko: '블랙홀${num}'
      }
    }
  },
  // FIXME: on all these forms, most of the time they come with double mechanics,
  // so probably need some "Then," text so folks don't leave the first mechanic early.
  // FIXME: random shade mechanic mid ozma form comes with holy/acceleration bomb/knockback
  // so call out something like "get off + holy" or "get knocked in".
  // FIXME: need callouts for knockback, and maybe "holy soon"?
  {
    id: 'BA Ozma Pyramid Form',
    type: 'Ability',
    netRegex: {
      source: 'Proto Ozma',
      id: '37A4',
      capture: false
    },
    condition: data => data.sealed,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Off the Platform',
        de: 'Weg von der Fläche',
        fr: 'Hors de la plateforme',
        ja: '回避',
        cn: '远离平台',
        ko: '멀어지기'
      }
    }
  }, {
    id: 'BA Ozma Pyramid Form 2',
    type: 'Ability',
    netRegex: {
      source: 'Proto Ozma',
      id: '37A4',
      capture: false
    },
    condition: data => data.sealed,
    delaySeconds: 9,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread for Bleed',
        de: 'Blutung verteilen',
        fr: 'Dispersez-vous pour le saignement',
        ja: '散開',
        cn: '分散',
        ko: '산개'
      }
    }
  }, {
    id: 'BA Ozma Star Form',
    type: 'Ability',
    netRegex: {
      source: 'Proto Ozma',
      id: '37B2',
      capture: false
    },
    condition: data => data.sealed,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Far',
        de: 'Weit weg',
        fr: 'Éloignez-vous',
        ja: '離れる',
        cn: '远离',
        ko: '멀리가기'
      }
    }
  }, {
    id: 'BA Ozma Star Form 2',
    type: 'Ability',
    netRegex: {
      source: 'Proto Ozma',
      id: '37B2',
      capture: false
    },
    condition: data => data.sealed,
    delaySeconds: 9,
    infoText: (data, _matches, output) => {
      // FIXME: taking multiple autos probably means tanking,
      // so probably could figure this out automatically.
      if (data.role === 'tank') return output.stackIfNotTanking();
      return output.stackUp();
    },
    outputStrings: {
      stackIfNotTanking: {
        en: 'Stack (if not tanking)',
        de: 'Stack (wenn nicht am tanken)',
        fr: 'Packez-vous (sauf les tanks)',
        ja: '集合 (MTではないなら)',
        cn: '集合（如果没在坦怪）',
        ko: '집합 (탱킹 중인 사람 제외)'
      },
      stackUp: {
        en: 'Stack Up',
        de: 'Stacken',
        fr: 'Packez-vous en haut',
        ja: '集合',
        cn: '集合',
        ko: '집합'
      }
    }
  }, {
    id: 'BA Ozma Cube Form',
    type: 'Ability',
    netRegex: {
      source: 'Proto Ozma',
      id: '379E',
      capture: false
    },
    condition: data => data.sealed,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Close',
        de: 'Nah dran',
        fr: 'Rapprochez-vous',
        ja: '近づく',
        cn: '靠近',
        ko: '가까이'
      }
    }
  }, {
    id: 'BA Ozma Cube Form 2',
    type: 'Ability',
    netRegex: {
      source: 'Proto Ozma',
      id: '379E',
      capture: false
    },
    condition: data => data.sealed,
    delaySeconds: 9,
    alertText: (data, _matches, output) => {
      // FIXME: taking multiple autos probably means tanking,
      // so probably could figure this out automatically.
      if (data.role === 'tank') return output.offtanksGetOrbs();
    },
    infoText: (data, _matches, output) => {
      if (data.role !== 'tank') return output.stackAwayFromTank();
    },
    outputStrings: {
      stackAwayFromTank: {
        en: 'Stack Away From Tank',
        de: 'Weg vom Tank stacken',
        fr: 'Packez-vous loin du tank',
        ja: 'タンクにから離れて集合',
        cn: '远离坦克集合',
        ko: '탱커에서 멀어지기'
      },
      offtanksGetOrbs: {
        en: 'Offtanks Get Orbs',
        de: 'Offtanks holt Kugeln',
        fr: 'Offtanks, prenez les orbes',
        ja: 'STは玉を処理',
        cn: 'ST撞球',
        ko: '섭탱 구슬 가져가기'
      }
    }
  }, {
    id: 'BA Ozma Pyramid Shade',
    type: 'Ability',
    netRegex: {
      source: ['Ozmashade', 'Shadow'],
      id: '37A4',
      capture: false
    },
    condition: data => data.sealed,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Off',
        de: 'Weg da',
        fr: 'Descendez',
        ja: '回避',
        cn: '远离平台',
        ko: '멀어지기'
      }
    }
  }, {
    id: 'BA Ozma Star Shade',
    type: 'Ability',
    netRegex: {
      source: ['Ozmashade', 'Shadow'],
      id: '37B2',
      capture: false
    },
    condition: data => data.sealed,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Close',
        de: 'Nah dran',
        fr: 'Rapprochez-vous',
        ja: '近づく',
        cn: '靠近',
        ko: '가까이'
      }
    }
  }, {
    id: 'BA Ozma Cube Shade',
    type: 'Ability',
    netRegex: {
      source: ['Ozmashade', 'Shadow'],
      id: '379E',
      capture: false
    },
    condition: data => data.sealed,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Far',
        de: 'Weit weg',
        fr: 'Éloignez-vous',
        ja: '離れる',
        cn: '远离',
        ko: '멀리'
      }
    }
  }, {
    id: 'BA Ozma Adds',
    type: 'Ability',
    netRegex: {
      source: 'Arsenal Urolith',
      id: '37B0',
      capture: false
    },
    condition: data => data.sealed,
    delaySeconds: 2,
    suppressSeconds: 1,
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'BA Ozma Acceleration Bomb',
    type: 'Ability',
    netRegex: {
      id: '37AA',
      source: 'Proto Ozma'
    },
    condition: (data, matches) => data.sealed && data.me === matches.target,
    response: responses/* Responses.stopEverything */.n3.stopEverything()
  }, {
    id: 'BA Ozma Meteor',
    type: 'HeadMarker',
    netRegex: {
      id: '0039'
    },
    condition: (data, matches) => data.sealed && data.me === matches.target,
    response: responses/* Responses.meteorOnYou */.n3.meteorOnYou()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      '7 minutes have elapsed since your last activity..*?': 'Seit deiner letzten Aktivität sind 7 Minuten vergangen.',
      'Absolute Virtue': 'Absolut(?:e|er|es|en) Tugend',
      'Arsenal Centaur': 'Arsenal-Zentaur',
      'Art': 'Art',
      'Ball Lightning': 'Elektrosphäre',
      'Arsenal Urolith': 'Arsenal-Urolith',
      'Ivory Palm': 'weiß(?:e|er|es|en) Hand',
      'Orlasrach': 'Orlasrach',
      'Owain': 'Owain',
      '(?<! )Ozma(?!\\w)': 'Yadis',
      'Ozmashade': 'Yadis-Schatten',
      'Proto Ozma(?! containment)': 'Proto-Yadis',
      'Raiden': 'Raiden',
      'Relative Virtue(?! gains)': 'Relative Tugend',
      'Shadow': 'Proto-Yadis-Schatten',
      'Streak Lightning': 'Blitzladung',
      '5 minutes have elapsed since your last activity': 'Seit deiner letzten Aktivität sind 5 Minuten vergangen',
      'The memories of heroes past live on again': 'Das Vermächtnis vergangener Helden lebt von Neuem auf',
      'Munderg, turn flesh to ash': 'Munderg, entfessele den Flammeneid',
      'Munderg, turn blood to ice': 'Munderg, das Eis der Ewigkeit soll sie für Äonen bannen',
      'The Shin-Zantetsuken Containment Unit': 'Shin-Zantetsuken-Quarantäneblock',
      'The Lance of Virtue Containment Unit': 'Lanze der Tugend-Quarantäneblock',
      'The Proto Ozma Containment Unit': 'Proto-Yadis-Quarantäneblock',
      'Relative Virtue gains the effect of .*?Astral Essence.*?': 'Die Relative Tugend erhält den Effekt von.*?Arm der Lichts',
      'Relative Virtue gains the effect of .*?Umbral Essence.*?': 'Die Relative Tugend erhält den Effekt von.*?Arm der Dunkelheit'
    },
    'replaceText': {
      '\\(Stack\\)': '(Sammeln)',
      'Acallam Na Senorach': 'Legendärer Lanzenwirbel',
      'Acceleration Bomb': 'Beschleunigungsbombe',
      'Adds': 'Adds',
      'Ame-no-Sakahoko': 'Himmelsriposte',
      'Auroral Wind': 'Aurorawind',
      'Bitter Barbs': 'Dornige Schuld',
      'Black Hole': 'Schwarzes Loch',
      'Bleed Attack': 'Blutungs-Angriff',
      'Booming Lament': 'Donnerschlag der Trauer',
      'Call Wyvern': 'Wyvernruf',
      'Carver/Spinner': 'Schnitzer/Spinner',
      'Cloud to Ground': 'Sturmkonzentration',
      'Cube Form': 'Würfel Form',
      'Eidos': 'Sarva',
      'Elemental Magicks': 'Elementmagie',
      'Elemental Shift': 'Elementwechsel',
      'Execration': 'Exsekration',
      'Explosive Impulse': 'Explosiver Impuls',
      'Flare Star': 'Flare-Stern',
      'For Honor': 'Hieb der Gefallenen',
      'Holy': 'Sanctus',
      'Hostile Aspect': 'Polarisierte Welle',
      'Impact Stream': 'Durchschlagsstrom',
      'Ivory Palm': 'weiße Hand',
      'Lancing Bolt': 'Donnerlanze',
      'Lateral Zantetsuken': 'Kata-Zantetsuken',
      'Legendary Geas': 'Legendenhieb',
      'Legendary Imbas': 'Legendäre Boshaftigkeit',
      'Legendcarver': 'Legendenschnitzer',
      'Legendspinner': 'Legendenspinner',
      'Levinwhorl': 'Wirbelsturm',
      'Medusa Javelin': 'Medusenspeer',
      'Meteor': 'Meteor',
      'Mourning Star': 'Morgenstern',
      'Mythcall': 'Mythenruf',
      'Orb x5': 'Kugel x5',
      'Ozma Ability': 'Yadis Fähigkeit',
      'Piercing Dark': 'Lanze der Finsternis',
      'Piercing Light': 'Lanze des Lichts',
      'Pitfall': 'Berstender Boden',
      'Pyramid Form': 'Pyramiden Form',
      'Random Form': 'Zufällige Form',
      'Random Shade': 'Zufällige Schatten',
      'Shade Ability': 'Schatten Fähigkeit',
      'Shingan': 'Betäubungsschlag',
      'Shooting Star': 'Sternschnuppe',
      'Soak Attack': 'Angriff absorbieren',
      'Spear Copy': 'Speer kopieren',
      'Spear Shade': 'Speer Schatten',
      'Sphere Form': 'Kugel Form',
      'Spiritcull': 'Kettendämon',
      'Spirits of the Fallen': 'Heroische Seele',
      'Star Form': 'Stern Form',
      'Streak Lightning': 'Blitzladung',
      'Thricecull': 'Dreifachlanze',
      'Thundercall': 'Donnerruf',
      'Turbulent Aether': 'Äthersturm',
      'Ultimate Zantetsuken': 'Goku-Zantetsuken',
      'Whirling Zantetsuken': 'Sen-Zantetsuken',
      'Wyvern Explosion': 'Wyvern Explosion'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '7 minutes have elapsed since your last activity.': 'Votre personnage est inactif depuis 7 minutes',
      'Absolute Virtue': 'Vertu absolue',
      'Arsenal Centaur': 'Centaure de l\'Arsenal',
      'Art': 'Art',
      'Ball Lightning': 'Orbe de foudre',
      'Arsenal Urolith': 'Urolithe de l\'Arsenal',
      'Ivory Palm': 'Paume d\'ivoire',
      'Munderg, turn blood to ice': 'C\'est bien, Munderg... Glace le sang de mes ennemis',
      'Munderg, turn flesh to ash': 'Oui... Munderg, sens le feu embraser nos âmes',
      'Orlasrach': 'Orlasrach',
      'Owain': 'Owain',
      '(?<! )Ozma(?!\\w)': 'Ozma',
      'Ozmashade': 'Ombre d\'Ozma',
      'Proto Ozma(?! containment)': 'Proto-Ozma',
      'Raiden': 'Raiden',
      'Relative Virtue(?! gains)': 'Vertu relative',
      'Relative Virtue gains the effect of .*?Astral Essence.*?': 'Vertu relative bénéficie de l\'effet.*?Bras de Lumière',
      'Relative Virtue gains the effect of .*?Umbral Essence.*?': 'Vertu relative bénéficie de l\'effet.*?Bras de Ténèbres',
      'Shadow': 'Ombre de Proto-Ozma',
      'Streak Lightning': 'Éclair chargeant',
      'The Lance of Virtue Containment Unit': 'l\'enceinte de confinement de la lance de la vertu',
      'The memories of heroes past live on again': 'L\'égide des héros vaillants vous a ressuscité',
      'The Proto Ozma Containment Unit': 'l\'enceinte de confinement de Proto-Ozma',
      'The Shin-Zantetsuken Containment Unit': 'l\'enceinte de confinement de Shin-Zantetsuken'
    },
    'replaceText': {
      '\\?': ' ?',
      'Acallam Na Senorach': 'Spirale sépulcrale',
      'Acceleration Bomb': 'Bombe accélératrice',
      'Adds': 'Adds',
      'Ame-no-Sakahoko': 'Ama-no-sakahoko',
      'Astral Essence': 'Bras de Lumière',
      'Auroral Wind': 'Vent d\'aurore',
      'Bitter Barbs': 'Ronce du péché',
      'Black Hole': 'Trou noir',
      'Bleed Attack': 'Attaque saignement',
      'Booming Lament': 'Tonnerre du regret',
      'Call Wyvern': 'Appel de wyverne',
      'Carver/Spinner': 'Taillade/Spirale',
      'Cloud to Ground': 'Attaque fulminante',
      'Cube Form': 'Forme cube',
      'Eidos': 'Sarva',
      'Elemental Magicks': 'Magie élémentaire',
      'Elemental Shift': 'Changement d\'élément',
      'Execration': 'Exécration',
      'Explosion Enrage': 'Explosion Enrage',
      'Explosive Impulse': 'Impulsion explosive',
      'Flare Star': 'Astre flamboyant',
      'For Honor': 'Carnage martial',
      'Holy': 'Miracle',
      'Hostile Aspect': 'Onde polarisée',
      'Impact Stream': 'Courant d\'impact',
      'Ivory Palm': 'Paume d\'ivoire',
      'Lancing Bolt': 'Lance fulminante',
      'Lateral Zantetsuken': 'Hen Zantetsuken',
      'Legendary Geas': 'Tuerie spectrale',
      'Legendary Imbas': 'Fiel spectral',
      'Legendcarver': 'Taillade spectrale',
      'Legendspinner': 'Spirale spectrale',
      'Levinwhorl': 'Vortex de foudre',
      'Medusa Javelin': 'Javelot de Méduse',
      'Meteor': 'Météore',
      'Mourning Star': 'Étoile du matin',
      'Mythcall': 'Invitation fantasmagorique',
      'Orb x5': 'Orbe x5',
      'Ozma Ability': 'Aptitude d\'Ozma',
      'Piercing Dark': 'Lance des ténèbres',
      'Piercing Light': 'Lance de lumière',
      'Pitfall': 'Embûche',
      'Pyramid Form': 'Forme pyramide',
      'Random Form': 'Forme aléatoire',
      'Random Shade': 'Ombre aléatoire',
      'Shade Ability': 'Aptitude d\'Ombre',
      'Shingan': 'Impact oculaire',
      'Shooting Star': 'Étoile filante',
      'Soak Attack': 'Absorbez l\'attaque',
      'Spear Copy': 'Copie de lance',
      'Spear Shade': 'Ombre de lance',
      'Sphere Form': 'Forme sphère',
      'Spiritcull': 'Salve magique',
      'Spirits of the Fallen': 'Âme héroïque',
      'Stack': 'Package',
      'Star Form': 'Forme étoile',
      'Streak Lightning': 'Éclair chargeant',
      'Thricecull': 'Triple perforation',
      'Thundercall': 'Drain fulminant',
      'Turbulent Aether': 'Turbulence éthérée',
      'Ultimate Zantetsuken': 'Goku Zantetsuken',
      'Umbral Essence': 'Bras de Ténèbres',
      'Whirling Zantetsuken': 'Sen Zantetsuken',
      'Wyvern Explosion': 'Wyverne Explosion'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '7 minutes have elapsed since your last activity.': '操作がない状態になってから7分が経過しました。',
      'Absolute Virtue': 'アブソリュートヴァーチュー',
      'Arsenal Centaur': 'アーセナル・セントール',
      'Art': 'アルト',
      'Ball Lightning': '雷球',
      'Arsenal Urolith': 'アーセナル・ウロリス',
      'Ivory Palm': '白き手',
      'Orlasrach': 'オールラスラッハ',
      'Owain': 'オーウェン',
      '(?<! )Ozma(?!\\w)': 'オズマ',
      'Ozmashade': 'オズマの影',
      'Proto Ozma(?! containment)': 'プロトオズマ',
      'Raiden': 'ライディーン',
      'Relative Virtue': 'レラティブヴァーチュー',
      'Shadow': 'プロトオズマの影',
      'Streak Lightning': 'ストリークライトニング',
      'The Lance of Virtue Containment Unit': 'ランス・オブ・ヴァーチュー封印区',
      'The Proto Ozma Containment Unit': 'プロトオズマ封印区',
      'The Shin-Zantetsuken Containment Unit': '真・斬鉄剣封印区',
      'The memories of heroes past live on again': '英傑の加護の効果が発揮され、蘇生された',
      'Munderg, turn flesh to ash': '白の妖槍「ムンジャルグ」、燃え上がれ！',
      'Munderg, turn blood to ice': '白の妖槍「ムンジャルグ」、震え凍れよ！'
    },
    'replaceText': {
      '\\?': ' ?',
      'Acallam Na Senorach': '真妖槍旋',
      'Acceleration Bomb': '加速度爆弾',
      'Adds': '雑魚',
      'Ame-no-Sakahoko': '天逆鉾',
      'Astral Essence': '光の腕',
      'Auroral Wind': 'オーロラルウィンド',
      'Bitter Barbs': '罪の荊棘',
      'Black Hole': 'ブラックホール',
      'Bleed Attack': 'ブリードアタック',
      'Booming Lament': '哀惜の雷鳴',
      'Call Wyvern': 'コールワイバーン',
      'Carver/Spinner': '妖槍振/妖槍旋',
      'Cloud to Ground': '襲雷',
      'Cube Form': '立方体',
      'Eidos': '変異',
      'Elemental Magicks': 'エレメンタルマジック',
      'Elemental Shift': 'エレメントスイッチ',
      'Execration': 'エクセクレイション',
      '(?<! )Explosion': '爆発',
      'Explosive Impulse': 'エクスプロシブインパルス',
      'Flare Star': 'フレアスター',
      'For Honor': '戦死撃',
      'Holy': 'ホーリー',
      'Hostile Aspect': '極性波動',
      'Impact Stream': 'インパクトストリーム',
      'Ivory Palm': '白き手',
      'Lancing Bolt': '雷槍',
      'Lateral Zantetsuken': '片・斬鉄剣',
      'Legendary Geas': '妖槍乱撃',
      'Legendary Imbas': '妖槍邪念',
      'Legendcarver': '妖槍振',
      'Legendspinner': '妖槍旋',
      'Levinwhorl': '渦雷',
      'Medusa Javelin': 'メデューサジャベリン',
      'Meteor': 'メテオ',
      'Mourning Star': 'モーニングスター',
      'Mythcall': '幻槍招来',
      'Orb x5': '玉 x5',
      'Ozma Ability': 'オズマ スキル',
      'Piercing Dark': '闇の槍',
      'Piercing Light': '光の槍',
      'Pitfall': '強襲',
      'Pyramid Form': '角錐形態',
      'Random Form': 'ランダム形態',
      'Random Shade': 'ランダム形',
      'Shade Ability': '幻影 スキル',
      'Shingan': '真眼撃',
      'Shooting Star': 'シューティングスター',
      'Soak Attack': 'アタック',
      'Spear Copy': '剣幻影',
      'Spear Shade': '剣形',
      'Sphere Form': '球形態',
      'Spiritcull': '連装魔',
      'Spirits of the Fallen': '英霊魂',
      'Stack': '集合',
      'Star Form': '星形',
      'Streak Lightning': 'ストリークライトニング',
      'Thricecull': '三連槍',
      'Thundercall': '招雷',
      'Turbulent Aether': 'エーテル乱流',
      'Ultimate Zantetsuken': '極・斬鉄剣',
      'Umbral Essence': '闇の腕',
      'Whirling Zantetsuken': '旋・斬鉄剣',
      'Wyvern Explosion': 'ワイバーン 爆発'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '7 minutes have elapsed since your last activity.': '已经7分钟没有进行任何操作',
      'Absolute Virtue': '绝对的美德',
      'Arsenal Centaur': '兵武半人马',
      'Art': '亚特',
      'Ball Lightning': '雷球',
      'Arsenal Urolith': '兵武乌洛里石',
      'Ivory Palm': '白手',
      'Orlasrach': '烈焰金枪',
      'Owain': '欧文',
      '(?<! )Ozma(?!\\w)': '奥兹玛',
      'Ozmashade': '奥兹玛之影',
      'Proto Ozma(?! Containment)': '奥兹玛原型',
      'Raiden': '莱丁',
      'Relative Virtue(?! gains)': '相对的美德',
      'Shadow': '奥兹玛原型之影',
      'Streak Lightning': '强袭雷光',
      '5 minutes have elapsed since your last activity.': '已经5分钟没有进行任何操作',
      'The memories of heroes past live on again': '发动了英杰的加护的效果，重新苏醒了过来',
      'Munderg, turn flesh to ash': '红颈妖枪，点燃一切！',
      'Munderg, turn blood to ice': '红颈妖枪，冻结万物！',
      'The Lance of Virtue Containment Unit': '美德之枪封印区',
      'The Shin-Zantetsuken Containment Unit': '真·斩铁剑封印区',
      'The Proto Ozma Containment Unit': '奥兹玛原型封印区',
      'Relative Virtue gains the effect of .*?Astral Essence.*?': '相对的美德附加了“光之腕”效果',
      'Relative Virtue gains the effect of .*?Umbral Essence.*?': '相对的美德附加了“暗之腕”效果'
    },
    'replaceText': {
      'Acallam Na Senorach': '真妖枪旋',
      'Acceleration Bomb': '加速度炸弹',
      'Adds': '小怪',
      'Ame-no-Sakahoko': '天逆矛',
      'Astral Essence': '光之腕',
      'Auroral Wind': '极光之风',
      'Bitter Barbs': '罪恶荆棘',
      'Black Hole': '黑洞',
      'Bleed Attack': '流血攻击',
      'Booming Lament': '哀痛雷鸣',
      'Call Wyvern': '召唤飞龙',
      'Carver/Spinner': '靠近/远离',
      'Cloud to Ground': '袭雷',
      'Cube Form': '立方体形式',
      'Eidos': '变异',
      'Elemental Magicks': '元素魔法',
      'Elemental Shift': '元素开关',
      'Execration': '缩小射线',
      'Explosive Impulse': '爆炸性冲击',
      'Flare Star': '耀星',
      'For Honor': '战死击',
      'Holy': '神圣',
      'Hostile Aspect': '极性波动',
      'Impact Stream': '冲击流',
      'Ivory Palm': '白手',
      'Lancing Bolt': '雷枪',
      'Lateral Zantetsuken': '片·斩铁剑',
      'Legendary Geas': '妖枪乱击',
      'Legendary Imbas': '妖枪邪念',
      'Legendcarver': '妖枪振',
      'Legendspinner': '妖枪振',
      'Levinwhorl': '涡雷',
      'Medusa Javelin': '美杜莎投枪',
      'Meteor': '陨石',
      'Mourning Star': '启明星',
      'Mythcall': '幻枪招来',
      'Orb x5': '球 x5',
      'Ozma Ability': '奥兹玛技能',
      'Piercing Dark': '暗之枪',
      'Piercing Light': '光之枪',
      'Pitfall': '强袭',
      'Pyramid Form': '金字塔形式',
      'Random Form': '随机形式',
      'Random Shade': '随机影子',
      'Shade Ability': '影子技能',
      'Shingan': '真眼击',
      'Shooting Star': '流星',
      'Soak Attack': '被攻击',
      'Spear Copy': '矛复制',
      'Spear Shade': '矛影子',
      'Sphere Form': '球形式',
      'Spiritcull': '连装魔',
      'Spirits of the Fallen': '英灵魂',
      'Stack': '分摊',
      'Star Form': '星星形式',
      'Streak Lightning': '强袭雷光',
      'Thricecull': '三连枪',
      'Thundercall': '招雷',
      'Turbulent Aether': '以太乱流',
      'Ultimate Zantetsuken': '极·斩铁剑',
      'Umbral Essence': '暗之腕',
      'Whirling Zantetsuken': '旋·斩铁剑',
      'Wyvern Explosion': '飞龙爆炸'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '7 minutes have elapsed since your last activity..*?': '7분 동안 아무 조작을 하지 않았습니다',
      'Absolute Virtue': '절대미덕',
      'Arsenal Centaur': '무기고 켄타우로스',
      'Art': '아르트',
      'Ball Lightning': '전기 구체',
      'Arsenal Urolith': '무기고 요결석',
      'Ivory Palm': '하얀 손',
      'Orlasrach': '오를라스라흐',
      'Owain': '오와인',
      '(?<! )Ozma(?!\\w)': '오즈마',
      'Ozmashade': '오즈마의 그림자',
      'Proto Ozma(?! Containment)': '프로토 오즈마',
      'Raiden': '라이딘',
      'Relative Virtue': '상대미덕',
      'Shadow': '프로토 오즈마의 그림자',
      'Streak Lightning': '연쇄 번개',
      'Munderg, turn flesh to ash': '하얀 요창 \'문데르크\'여, 불타올라라!',
      'Munderg, turn blood to ice': '하얀 요창 \'문데르크\'여, 얼어붙어라!',
      'The Lance of Virtue Containment Unit': '미덕의 창 봉인 구역',
      'The Shin-Zantetsuken Containment Unit': '진 참철검 봉인 구역',
      'The Proto Ozma Containment Unit': '프로토 오즈마 봉인 구역',
      'The memories of heroes past live on again': '영걸의 가호의 효과가 발휘되어 부활했습니다'
    },
    'replaceText': {
      'Acallam Na Senorach': '피어너의 창',
      'Acceleration Bomb': '가속도 폭탄',
      'Adds': '쫄',
      'Ame-no-Sakahoko': '아메노사카호코',
      'Astral Essence': '빛의 팔',
      'Auroral Wind': '오로라 바람',
      'Bitter Barbs': '죄의 가시',
      'Black Hole': '블랙홀',
      'Bleed Attack': '출혈 공격',
      'Booming Lament': '애도의 뇌명',
      'Call Wyvern': '와이번 소환',
      'Carver/Spinner': '요창 떨치기/후리기',
      'Cloud to Ground': '습뢰',
      'Cube Form': '네모 모양',
      'Eidos': '변이',
      'Elemental Magicks': '엘리멘탈 마법',
      'Elemental Shift': '엘리멘탈 변환',
      'Execration': '혐오의 저주',
      '(?<! )Explosion': '폭발',
      'Explosive Impulse': '폭발적 추진력',
      'Flare Star': '타오르는 별',
      'For Honor': '전사격',
      'Holy': '홀리',
      'Hostile Aspect': '극성 파동',
      'Impact Stream': '충격 기류',
      'Ivory Palm': '하얀 손',
      'Lancing Bolt': '뇌창',
      'Lateral Zantetsuken': '편 참철검',
      'Legendary Geas': '요창난격',
      'Legendary Imbas': '요창의 사념',
      'Legendcarver': '요창 떨치기',
      'Legendspinner': '요창 후리기',
      'Levinwhorl': '와뢰',
      'Medusa Javelin': '메두사의 투창',
      'Meteor': '메테오',
      'Mourning Star': '샛별',
      'Mythcall': '환창 소환',
      'Orb x5': '구슬 5회',
      'Ozma Ability': '오즈마 능력',
      'Piercing Dark': '어둠의 창',
      'Piercing Light': '빛의 창',
      'Pitfall': '강습',
      'Pyramid Form': '세모 모양',
      'Random Form': '무작위 모양',
      'Random Shade': '무작위 그림자',
      'Shade Ability': '그림자 능력',
      'Shingan': '진안격',
      'Shooting Star': '유성',
      'Soak Attack': '평타 쉐어 공격',
      'Spear Copy': '창 복사',
      'Spear Shade': '창 그림자',
      'Sphere Form': '원 모양',
      'Spiritcull': '마법 연발',
      'Spirits of the Fallen': '영령혼',
      'Stack': '모이기',
      'Star Form': '별 모양',
      'Streak Lightning': '연쇄 번개',
      'Thricecull': '삼연창',
      'Thundercall': '초뢰',
      'Turbulent Aether': '에테르 난류',
      'Ultimate Zantetsuken': '극 참철검',
      'Umbral Essence': '어둠의 팔',
      'Whirling Zantetsuken': '선 참철검',
      'Wyvern Explosion': '와이번 폭발'
    }
  }]
};
/* harmony default export */ const eureka_hydatos = (eureka_hydatos_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/eureka/eureka_hydatos.txt
const eureka_eureka_hydatos_namespaceObject = "# Eureka Hydatos - Baldesion Armory\r\n# http://elysium.gg/guides/baldesion-arsenal-primer/\r\n# http://elysium.gg/guides/baldesion-arsenal-raid-guide/\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Use zone-unseal & Proto Ozma Reset lines\r\n# Trigger set contains 'resetWhenOutOfCombat: false'\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n0.0 \"--Reset--\" RemovedCombatant { name: \"Proto Ozma\" } window 0,100000 jump 0\r\n\r\n\r\n#####################\r\n# WEST BRANCH / ART #\r\n#####################\r\n# -ic Owain -ii 3956 392D -p 3934:1014.5\r\n\r\n# Note: This checks that Art's auto hits a target close enough for you to see.\r\n# You can see Owain's auto abilities, but the target is listed as empty.\r\n1002.5 \"--sync--\" Ability { id: \"3956\", source: \"Art\", target: \"[^|]+\" } window 1500,0\r\n1014.5 \"Thricecull\" Ability { id: \"3934\", source: \"Art\" }\r\n1023.1 \"Legendcarver\" Ability { id: \"3928\", source: \"Art\" }\r\n1030.7 \"Legendspinner\" Ability { id: \"3929\", source: \"Art\" }\r\n1038.8 \"Acallam Na Senorach\" Ability { id: \"3935\", source: \"Art\" }\r\n1047.5 \"Mythcall\" Ability { id: \"3927\", source: \"Art\" }\r\n1058.1 \"Carver/Spinner\" Ability { id: \"392[89]\", source: \"Art\" }\r\n1061.1 \"Spear Copy\" Ability { id: \"392[AB]\", source: \"Orlasrach\" }\r\n1068.2 \"Acallam Na Senorach\" Ability { id: \"3935\", source: \"Art\" }\r\n1075.3 \"Thricecull\" Ability { id: \"3934\", source: \"Art\" }\r\n1081.7 \"Mythcall\" Ability { id: \"3927\", source: \"Art\" }\r\n1092.3 \"Carver/Spinner\" Ability { id: \"392[89]\", source: \"Art\" }\r\n1095.3 \"Spear Copy\" Ability { id: \"392B\", source: \"Orlasrach\" }\r\n1102.4 \"Legendary Geas\" Ability { id: \"3932\", source: \"Art\" }\r\n1109.2 \"--sync--\" Ability { id: \"3933\", source: \"Art\" }\r\n1113.7 \"Acallam Na Senorach\" Ability { id: \"3935\", source: \"Art\" }\r\n1116.7 \"--untargetable--\"\r\n1123.3 \"Orb x5\" Ability { id: \"392C\", source: \"Art\" } duration 6\r\n1125.8 \"Pitfall\" Ability { id: \"392F\", source: \"Art\" }\r\n1126.8 \"--targetable--\"\r\n1138.3 \"Thricecull\" Ability { id: \"3934\", source: \"Art\" }\r\n1145.4 \"Acallam Na Senorach\" Ability { id: \"3935\", source: \"Art\" }\r\n1155.1 \"Mythcall\" Ability { id: \"3927\", source: \"Art\" }\r\n1155.1 \"(Legendary Geas)\"\r\n1165.6 \"Carver/Spinner\" Ability { id: \"392[89]\", source: \"Art\" }\r\n1168.7 \"Spear Copy\" Ability { id: \"392[AB]\", source: \"Orlasrach\" }\r\n1175.7 \"Thricecull\" Ability { id: \"3934\", source: \"Art\" }\r\n1182.8 \"Acallam Na Senorach\" Ability { id: \"3935\", source: \"Art\" }\r\n1189.2 \"Mythcall\" Ability { id: \"3927\", source: \"Art\" }\r\n1197.8 \"Piercing Dark\" Ability { id: \"3930\", source: \"Art\" } duration 6.5\r\n# FIXME: is this one always spinner because piercing dark?\r\n1203.9 \"Carver/Spinner\" Ability { id: \"392[89]\", source: \"Art\" }\r\n1204.3 \"--sync--\" Ability { id: \"3931\", source: \"Art\" }\r\n1206.9 \"Spear Shade\" Ability { id: \"392[AB]\", source: \"Orlasrach\" }\r\n1218.0 \"Legendary Geas\" Ability { id: \"3932\", source: \"Art\" }\r\n# FIXME: spiritcall somewhere in here, and then a loop?\r\n\r\n\r\n\r\n#######################\r\n# EAST BRANCH / OWAIN #\r\n#######################\r\n# -ic Orlasrach Art -ii 3957 3941 3939 393C 393D 3938 -p 3945:2016.0\r\n2002.5 \"--sync--\" Ability { id: \"3957\", source: \"Owain\", target: \"[^|]+\" } window 2500,0\r\n2016.0 \"Thricecull\" Ability { id: \"3945\", source: \"Owain\" }\r\n2028.1 \"Acallam Na Senorach\" Ability { id: \"3946\", source: \"Owain\" } #3:29\r\n2037.7 \"Mythcall\" Ability { id: \"3936\", source: \"Owain\" } #3:39\r\n2041.7 \"Elemental Shift\" Ability { id: \"3937\", source: \"Owain\" }\r\n2052.8 \"Elemental Magicks\" Ability { id: \"393[AB]\", source: \"Owain\" }\r\n2067.8 \"Thricecull\" Ability { id: \"3945\", source: \"Owain\" }\r\n2079.9 \"Acallam Na Senorach\" Ability { id: \"3946\", source: \"Owain\" }\r\n2089.3 \"Elemental Shift\" Ability { id: \"3937\", source: \"Owain\" }\r\n2100.4 \"Elemental Magicks\" Ability { id: \"393[AB]\", source: \"Owain\" }\r\n2116.4 \"Thricecull\" Ability { id: \"3945\", source: \"Owain\" }\r\n2127.5 \"Spiritcull\" Ability { id: \"393E\", source: \"Owain\" }\r\n2132.5 \"Legendary Imbas\" Ability { id: \"3940\", source: \"Owain\" }\r\n2132.5 \"Piercing Light\" Ability { id: \"393F\", source: \"Owain\" }\r\n2142.5 \"Thricecull\" Ability { id: \"3945\", source: \"Owain\" }\r\n2153.6 \"Acallam Na Senorach\" Ability { id: \"3946\", source: \"Owain\" }\r\n2157.7 \"--untargetable--\"\r\n2164.7 \"Piercing Light\" Ability { id: \"3944\", source: \"Owain\" }\r\n2165.7 \"Pitfall\" Ability { id: \"394D\", source: \"Owain\" }\r\n2166.0 \"--targetable--\"\r\n2180.3 \"Acallam Na Senorach\" Ability { id: \"3946\", source: \"Owain\" }\r\n2190.3 \"Acallam Na Senorach\" Ability { id: \"3946\", source: \"Owain\" }\r\n2199.9 \"Elemental Shift\" Ability { id: \"3937\", source: \"Owain\" }\r\n2209.0 \"Spiritcull\" Ability { id: \"393E\", source: \"Owain\" }\r\n2214.0 \"Legendary Imbas\" Ability { id: \"3940\", source: \"Owain\" }\r\n2214.0 \"Piercing Light\" Ability { id: \"393F\", source: \"Owain\" }\r\n2216.0 \"Elemental Magicks\" Ability { id: \"393[AB]\", source: \"Owain\" }\r\n2230.0 \"Thricecull\" Ability { id: \"3945\", source: \"Owain\" }\r\n2252.1 \"Acallam Na Senorach\" Ability { id: \"3946\", source: \"Owain\" }\r\n2261.4 \"Elemental Shift\" Ability { id: \"3937\", source: \"Owain\" }\r\n2267.5 \"Ivory Palm Adds\" # Ability { id: \"3941\", source: \"Ivory Palm\" }\r\n2272.5 \"Elemental Magicks\" Ability { id: \"393[AB]\", source: \"Owain\" }\r\n2283.5 \"Thricecull\" Ability { id: \"3945\", source: \"Owain\" }\r\n2290.5 \"(Explosion Enrage)\"\r\n2291.6 \"Spiritcull\" Ability { id: \"393E\", source: \"Owain\" }\r\n2296.6 \"Legendary Imbas\" Ability { id: \"3940\", source: \"Owain\" }\r\n2296.6 \"Piercing Light\" Ability { id: \"393F\", source: \"Owain\" }\r\n2306.6 \"Thricecull\" Ability { id: \"3945\", source: \"Owain\" }\r\n2317.6 \"Acallam Na Senorach\" Ability { id: \"3946\", source: \"Owain\" }\r\n2328.6 \"Piercing Light\" Ability { id: \"3944\", source: \"Owain\" }\r\n2329.6 \"Pitfall\" Ability { id: \"394D\", source: \"Owain\" }\r\n2344.2 \"Acallam Na Senorach\" Ability { id: \"3946\", source: \"Owain\" }\r\n\r\n\r\n\r\n##########\r\n# Raiden #\r\n##########\r\n# -ii 39B9 3994 3996 3995 3997 3872 3871 3873 -p 387A:3013 386D:3091\r\n# Shin-Zantetsuken Containment Unit will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"B51\" } window 3000,0\r\n3013.0 \"Spirits of the Fallen\" Ability { id: \"387A\", source: \"Raiden\" } # drift -0.041\r\n3023.0 \"Shingan\" Ability { id: \"387B\", source: \"Raiden\" } # drift 0.05\r\n3034.1 \"Thundercall\" Ability { id: \"387F\", source: \"Raiden\" }\r\n3044.2 \"--sync--\" StartsUsing { id: \"3868\", source: \"Raiden\" } window 10,10\r\n3048.7 \"Ame-no-Sakahoko\" Ability { id: \"3868\", source: \"Raiden\" }\r\n3051.7 \"--sync--\" Ability { id: \"3869\", source: \"Raiden\" }\r\n3058.3 \"Whirling Zantetsuken\" Ability { id: \"386A\", source: \"Raiden\" }\r\n3065.4 \"--sync--\" StartsUsing { id: \"3868\", source: \"Raiden\" } window 10,10\r\n3069.9 \"Ame-no-Sakahoko\" Ability { id: \"3868\", source: \"Raiden\" }\r\n3072.9 \"--sync--\" Ability { id: \"3869\", source: \"Raiden\" }\r\n3079.5 \"Whirling Zantetsuken\" Ability { id: \"386A\", source: \"Raiden\" }\r\n# FIXME: does this loop doing Ame forever or does it naturally go into Lateral?\r\n# FIXME: Are these always Whirling?\r\n\r\n# Adds Phase at 60%\r\n3095.0 \"--sync--\" Ability { id: \"386D\", source: \"Ball Lightning\" } window 100,10\r\n3099.1 \"Lateral Zantetsuken\" Ability { id: \"386[BC]\", source: \"Raiden\" }\r\n3109.8 \"Spirits of the Fallen\" Ability { id: \"387A\", source: \"Raiden\" }\r\n3118.9 \"Lancing Bolt\" Ability { id: \"3876\", source: \"Raiden\" }\r\n3124.4 \"Streak Lightning\" #Ability { id: \"3877\", source: \"Streak Lightning\" }\r\n3134.9 \"Ultimate Zantetsuken\" StartsUsing { id: \"3878\", source: \"Raiden\" } duration 20\r\n\r\n3154.9 \"--sync--\" NetworkCancelAbility { id: \"3878\", source: \"Raiden\" } window 40,0\r\n3164.9 \"Spirits of the Fallen\" Ability { id: \"387A\", source: \"Raiden\" } window 40,5\r\n3171.2 \"Booming Lament\" Ability { id: \"387D\", source: \"Raiden\" }\r\n3177.3 \"Cloud to Ground\" Ability { id: \"3870\", source: \"Raiden\" }\r\n3193.4 \"Bitter Barbs\" Ability { id: \"3874\", source: \"Raiden\" }\r\n3210.5 \"Whirling Zantetsuken\" Ability { id: \"386A\", source: \"Raiden\" }\r\n3220.5 \"Spirits of the Fallen\" Ability { id: \"387A\", source: \"Raiden\" }\r\n\r\n3233.6 \"Cloud to Ground\" Ability { id: \"3870\", source: \"Raiden\" }\r\n3247.7 \"Levinwhorl\" Ability { id: \"386E\", source: \"Raiden\" }\r\n3247.7 \"--sync--\" Ability { id: \"386F\", source: \"Raiden\" }\r\n3266.3 \"Ame-no-Sakahoko\" Ability { id: \"3868\", source: \"Raiden\" }\r\n3269.3 \"--sync--\" Ability { id: \"3869\", source: \"Raiden\" }\r\n3275.9 \"Whirling Zantetsuken\" Ability { id: \"386A\", source: \"Raiden\" }\r\n3283.1 \"Booming Lament\" Ability { id: \"387D\", source: \"Raiden\" }\r\n3293.2 \"Spirits of the Fallen\" Ability { id: \"387A\", source: \"Raiden\" }\r\n\r\n3308.5 \"--sync--\" Ability { id: \"386D\", source: \"Ball Lightning\" } window 100,10\r\n3310.7 \"Streak Lightning\" Ability { id: \"3877\", source: \"Streak Lightning\" } # drift 0.043\r\n3316.0 \"Lateral Zantetsuken\" Ability { id: \"386[BC]\", source: \"Raiden\" }\r\n3321.7 \"Ultimate Zantetsuken\" StartsUsing { id: \"3878\", source: \"Raiden\" } duration 20\r\n\r\n3341.7 \"--sync--\" NetworkCancelAbility { id: \"3878\", source: \"Raiden\" } window 40,0\r\n3347.7 \"Spirits of the Fallen\" Ability { id: \"387A\", source: \"Raiden\" } window 40,5\r\n3353.8 \"Shingan\" Ability { id: \"387B\", source: \"Raiden\" }\r\n3365.4 \"Ame-no-Sakahoko\" Ability { id: \"3868\", source: \"Raiden\" }\r\n3368.4 \"--sync--\" Ability { id: \"3869\", source: \"Raiden\" }\r\n3373.9 \"For Honor\" Ability { id: \"387C\", source: \"Raiden\" }\r\n3381.5 \"Whirling Zantetsuken\" Ability { id: \"386A\", source: \"Raiden\" } # drift -0.048\r\n3390.7 \"Booming Lament\" Ability { id: \"387D\", source: \"Raiden\" }\r\n\r\n\r\n\r\n###################\r\n# Absolute Virtue #\r\n###################\r\n# -p 3799:4016 -ii 38C4 378F 3791 3792 3954 378C\r\n# Lance of Virtue Containment Unit will be sealed off\r\n4000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"B52\" } window 4000,0\r\n4016.0 \"Meteor\" Ability { id: \"3799\", source: \"Absolute Virtue\" }\r\n4022.0 \"Eidos\" Ability { id: \"378[67]\", source: \"Absolute Virtue\" }\r\n4033.6 \"Hostile Aspect\" Ability { id: \"378B\", source: \"Absolute Virtue\" }\r\n4039.8 \"Medusa Javelin\" Ability { id: \"379B\", source: \"Absolute Virtue\" }\r\n4046.8 \"Eidos\" Ability { id: \"378[67]\", source: \"Absolute Virtue\" }\r\n4053.6 \"Impact Stream\" Ability { id: \"3788\", source: \"Absolute Virtue\" }\r\n4064.6 \"Auroral Wind\" Ability { id: \"379A\", source: \"Absolute Virtue\" }\r\n4078.7 \"Eidos\" Ability { id: \"378[67]\", source: \"Absolute Virtue\" }\r\n4090.5 \"Hostile Aspect\" Ability { id: \"378B\", source: \"Absolute Virtue\" }\r\n4108.5 \"Meteor\" Ability { id: \"3799\", source: \"Absolute Virtue\" }\r\n4118.6 \"Turbulent Aether\" Ability { id: \"3790\", source: \"Absolute Virtue\" }\r\n4126.9 \"Medusa Javelin\" Ability { id: \"379B\", source: \"Absolute Virtue\" }\r\n4134.9 \"Auroral Wind\" Ability { id: \"379A\", source: \"Absolute Virtue\" }\r\n4142.9 \"Meteor\" Ability { id: \"3799\", source: \"Absolute Virtue\" }\r\n4151.9 \"Meteor\" Ability { id: \"3799\", source: \"Absolute Virtue\" }\r\n\r\n# Triple Stream\r\n4161.0 \"--untargetable--\"\r\n4166.5 \"Explosive Impulse\" Ability { id: \"3793\", source: \"Relative Virtue\" }\r\n4174.5 \"Impact Stream\"\r\n4175.5 \"Impact Stream\"\r\n4184.5 \"Impact Stream\"\r\n4190.5 \"Explosive Impulse\" Ability { id: \"3794\", source: \"Absolute Virtue\" }\r\n4191.0 \"--targetable--\"\r\n4196.5 \"Medusa Javelin\" Ability { id: \"379B\", source: \"Absolute Virtue\" }\r\n4208.5 \"Auroral Wind\" Ability { id: \"379A\", source: \"Absolute Virtue\" }\r\n4216.5 \"Meteor\" Ability { id: \"3799\", source: \"Absolute Virtue\" }\r\n\r\n# Wyvern Pair 1\r\n4225.6 \"Call Wyvern\" Ability { id: \"3798\", source: \"Absolute Virtue\" }\r\n4231.6 \"Turbulent Aether\" Ability { id: \"3790\", source: \"Absolute Virtue\" }\r\n4239.8 \"Medusa Javelin\" Ability { id: \"379B\", source: \"Absolute Virtue\" }\r\n4241.6 \"(Wyvern Explosion)\"\r\n4247.8 \"Auroral Wind\" Ability { id: \"379A\", source: \"Absolute Virtue\" }\r\n4264.8 \"Meteor\" Ability { id: \"3799\", source: \"Absolute Virtue\" }\r\n4270.8 \"Eidos\" Ability { id: \"378[67]\", source: \"Absolute Virtue\" }\r\n4283.0 \"Hostile Aspect\" Ability { id: \"378B\", source: \"Absolute Virtue\" }\r\n\r\n# Double Stream 1\r\n4286.9 \"Explosive Impulse\" Ability { id: \"3793\", source: \"Relative Virtue\" }\r\n4294.1 \"Eidos\" Ability { id: \"378[67]\", source: \"Absolute Virtue\" }\r\n4296.1 \"Impact Stream\" Ability { id: \"3797\", source: \"Absolute Virtue\" }\r\n4300.8 \"Impact Stream\" Ability { id: \"3788\", source: \"Absolute Virtue\" }\r\n4311.8 \"Medusa Javelin\" Ability { id: \"379B\", source: \"Absolute Virtue\" }\r\n4318.8 \"Meteor\" Ability { id: \"3799\", source: \"Absolute Virtue\" }\r\n\r\n# Wyvern Pair 2\r\n4333.8 \"Call Wyvern\" Ability { id: \"3798\", source: \"Absolute Virtue\" }\r\n4339.8 \"Turbulent Aether\" Ability { id: \"3790\", source: \"Absolute Virtue\" }\r\n4348.1 \"Medusa Javelin\" Ability { id: \"379B\", source: \"Absolute Virtue\" }\r\n4349.8 \"(Wyvern Explosion)\"\r\n4356.1 \"Auroral Wind\" Ability { id: \"379A\", source: \"Absolute Virtue\" }\r\n4373.1 \"Meteor\" Ability { id: \"3799\", source: \"Absolute Virtue\" }\r\n4379.1 \"Eidos\" Ability { id: \"378[67]\", source: \"Absolute Virtue\" }\r\n4391.2 \"Hostile Aspect\" Ability { id: \"378B\", source: \"Absolute Virtue\" }\r\n\r\n# Double Stream 2\r\n4395.1 \"Explosive Impulse\" Ability { id: \"3793\", source: \"Relative Virtue\" }\r\n4402.3 \"Eidos\" Ability { id: \"378[67]\", source: \"Absolute Virtue\" }\r\n4404.3 \"Impact Stream\" Ability { id: \"3797\", source: \"Absolute Virtue\" }\r\n4408.4 \"Impact Stream\" Ability { id: \"3788\", source: \"Absolute Virtue\" }\r\n4419.6 \"Medusa Javelin\" Ability { id: \"379B\", source: \"Absolute Virtue\" }\r\n4426.6 \"Meteor\" Ability { id: \"3799\", source: \"Absolute Virtue\" }\r\n\r\n4443.4 \"Meteor Enrage\" Ability { id: \"396C\", source: \"Absolute Virtue\" }\r\n4446.4 \"Meteor Enrage\" Ability { id: \"396F\", source: \"Absolute Virtue\" }\r\n4451.4 \"Meteor Enrage\" Ability { id: \"396F\", source: \"Absolute Virtue\" }\r\n\r\n\r\n\r\n##############\r\n# Proto Ozma #\r\n##############\r\n# -ii 37AB 37B8 37A2 37AC 396E 397B 397C -p 37B2:5021.5\r\n# Proto Ozma Containment Unit will be sealed off\r\n5000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"B53\" } window 5000,0\r\n\r\n### Initial Star Form (no meteor)\r\n5021.5 \"Star Form\" Ability { id: \"37B2\", source: \"Proto Ozma\" }\r\n5028.5 \"--sync--\" Ability { id: \"37B4\", source: \"Proto Ozma\" }\r\n5029.5 \"Mourning Star\" Ability { id: \"37B5\", source: \"Ozma\" }\r\n\r\n5032.5 \"Soak Attack\" Ability { id: \"37B6\", source: \"Ozma\" }\r\n5038.5 \"Soak Attack\" Ability { id: \"37B6\", source: \"Ozma\" }\r\n5044.5 \"Soak Attack\" Ability { id: \"37B6\", source: \"Ozma\" }\r\n\r\n5051.5 \"Shooting Star\" Ability { id: \"37B7\", source: \"Proto Ozma\" }\r\n\r\n5056.5 \"Soak Attack\" Ability { id: \"37B6\", source: \"Ozma\" }\r\n5062.5 \"Soak Attack\" Ability { id: \"37B6\", source: \"Ozma\" }\r\n5068.5 \"Soak Attack\" Ability { id: \"37B6\", source: \"Ozma\" }\r\n\r\n5070.5 \"Sphere Form\" Ability { id: [\"37B3\", \"37A5\", \"379F\"], source: \"Proto Ozma\" }\r\n5079.5 \"Black Hole\" Ability { id: \"379D\", source: \"Proto Ozma\" }\r\n\r\n5092.5 \"Random Shade\" Ability { id: [\"37A4\", \"37B2\", \"379E\"], source: \"Ozmashade\" }\r\n5099.5 \"--sync--\" Ability { id: [\"37A6\", \"37B4\", \"37A0\"], source: \"Ozmashade\" }\r\n5101.0 \"Shade Ability\" # Ability { id: [\"37A7\", \"37B5\", \"37A1\"], source: \"Shadow\" }\r\n\r\n5121.5 \"Random Shade\" Ability { id: [\"37A4\", \"37B2\", \"379E\"], source: \"Ozmashade\" }\r\n\r\n# fake loop\r\n5125.5 \"Random Form\"\r\n5130.0 \"Shade Ability\"\r\n5134.2 \"Ozma Ability\"\r\n5136.5 \"Soak Attack?\"\r\n5136.5 \"Acceleration Bomb?\"\r\n5138.5 \"Bleed Attack?\"\r\n5144.5 \"Bleed Attack?\"\r\n5144.5 \"Meteor (Stack)?\"\r\n5147.5 \"Holy?\"\r\n5151.5 \"Meteor (Adds)?\"\r\n5154.5 \"Shooting Star?\"\r\n5157.5 \"Meteor (Adds)?\"\r\n\r\n\r\n### Pyramid Phase\r\n5300.0 \"Pyramid Form\" Ability { id: \"37A4\", source: \"Proto Ozma\" } window 800,800\r\n5303.0 \"--sync--\" Ability { id: [\"37A6\", \"37B4\", \"37A0\"], source: \"Ozmashade\" }\r\n5304.5 \"Shade Ability\" # Ability { id: [\"37A7\", \"37B5\", \"37A1\"], source: \"Shadow\" }\r\n\r\n5307.0 \"--sync--\" Ability { id: \"37A6\", source: \"Proto Ozma\" }\r\n5308.7 \"Execration\" Ability { id: \"37A7\", source: \"Ozma\" }\r\n\r\n5311.0 \"Acceleration Bomb\" Ability { id: \"37AA\", source: \"Proto Ozma\" }\r\n5313.0 \"Bleed Attack\" Ability { id: \"37AD\", source: \"Ozma\" }\r\n5319.0 \"Bleed Attack\" Ability { id: \"37AD\", source: \"Ozma\" }\r\n\r\n5332.0 \"Meteor (Adds)\" Ability { id: \"37B0\", source: \"Arsenal urolith\" }\r\n5337.0 \"Bleed Attack\" Ability { id: \"37AD\", source: \"Ozma\" }\r\n5343.0 \"Bleed Attack\" Ability { id: \"37AD\", source: \"Ozma\" }\r\n\r\n5346.0 \"Random Shade\" Ability { id: [\"37A4\", \"37B2\", \"379E\"], source: \"Ozmashade\" }\r\n5349.0 \"Acceleration Bomb\" Ability { id: \"37AA\", source: \"Proto Ozma\" }\r\n5353.0 \"--sync--\" Ability { id: [\"37A6\", \"37B4\", \"37A0\"], source: \"Ozmashade\" }\r\n5354.5 \"Shade Ability\" # Ability { id: [\"37A7\", \"37B5\", \"37A1\"], source: \"Shadow\" }\r\n\r\n5364.0 \"Meteor (Stack)\" Ability { id: \"37A8\", source: \"Ozma\" }\r\n5370.0 \"Bleed Attack\" Ability { id: \"37AD\", source: \"Ozma\" }\r\n\r\n5373.0 \"Sphere Form\" Ability { id: [\"37B3\", \"37A5\", \"379F\"], source: \"Proto Ozma\" }\r\n5382.0 \"Black Hole\" Ability { id: \"379D\", source: \"Proto Ozma\" }\r\n\r\n5395.0 \"Random Shade\" Ability { id: [\"37A4\", \"37B2\", \"379E\"], source: \"Ozmashade\" }\r\n\r\n# fake loop\r\n5399.0 \"Random Form\"\r\n5403.5 \"Shade Ability\"\r\n5407.7 \"Ozma Ability\"\r\n5410.0 \"Soak Attack?\"\r\n5410.0 \"Acceleration Bomb?\"\r\n5412.0 \"Bleed Attack?\"\r\n5418.0 \"Bleed Attack?\"\r\n5418.0 \"Meteor (Stack)?\"\r\n5421.0 \"Holy?\"\r\n5425.0 \"Meteor (Adds)?\"\r\n5428.0 \"Shooting Star?\"\r\n5431.0 \"Meteor (Adds)?\"\r\n\r\n\r\n### Cube Phase\r\n5600.0 \"Cube Form\" Ability { id: \"379E\", source: \"Proto Ozma\" } window 800,800\r\n\r\n5603.0 \"--sync--\" Ability { id: [\"37A6\", \"37B4\", \"37A0\"], source: \"Ozmashade\" }\r\n5604.5 \"Shade Ability\" # Ability { id: [\"37A7\", \"37B5\", \"37A1\"], source: \"Shadow\" }\r\n\r\n5607.0 \"--sync--\" Ability { id: \"37A0\", source: \"Proto Ozma\" }\r\n5608.5 \"Flare Star\" Ability { id: \"37A1\", source: \"Ozma\" }\r\n\r\n5619.0 \"Meteor (Stack)\" Ability { id: \"37A8\", source: \"Ozma\" }\r\n5622.0 \"Holy\" Ability { id: \"37A9\", source: \"Proto Ozma\" }\r\n\r\n5649.0 \"Random Shade\" Ability { id: [\"37A4\", \"37B2\", \"379E\"], source: \"Ozmashade\" }\r\n5655.0 \"Meteor (Stack)\" Ability { id: \"37A8\", source: \"Ozma\" }\r\n5656.0 \"Holy\" Ability { id: \"37A9\", source: \"Proto Ozma\" }\r\n5656.0 \"--sync--\" Ability { id: [\"37A6\", \"37B4\", \"37A0\"], source: \"Ozmashade\" }\r\n5657.5 \"Shade Ability\" # Ability { id: [\"37A7\", \"37B5\", \"37A1\"], source: \"Shadow\" }\r\n\r\n5673.0 \"Sphere Form\" Ability { id: [\"37B3\", \"37A5\", \"379F\"], source: \"Proto Ozma\" }\r\n5682.0 \"Black Hole\" Ability { id: \"379D\", source: \"Proto Ozma\" }\r\n\r\n5695.0 \"Random Shade\" Ability { id: [\"37A4\", \"37B2\", \"379E\"], source: \"Ozmashade\" }\r\n\r\n# fake loop\r\n5699.0 \"Random Form\"\r\n5703.5 \"Shade Ability\"\r\n5707.7 \"Ozma Ability\"\r\n5710.0 \"Soak Attack?\"\r\n5710.0 \"Acceleration Bomb?\"\r\n5712.0 \"Bleed Attack?\"\r\n5718.0 \"Bleed Attack?\"\r\n5718.0 \"Meteor (Stack)?\"\r\n5721.0 \"Holy?\"\r\n5725.0 \"Meteor (Adds)?\"\r\n5728.0 \"Shooting Star?\"\r\n5731.0 \"Meteor (Adds)?\"\r\n\r\n\r\n### Star Phase\r\n5900.0 \"Star Form\" Ability { id: \"37B2\", source: \"Proto Ozma\" } window 800,800\r\n5903.0 \"--sync--\" Ability { id: [\"37A6\", \"37B4\", \"37A0\"], source: \"Ozmashade\" }\r\n5904.5 \"Shade Ability\" # Ability { id: [\"37A7\", \"37B5\", \"37A1\"], source: \"Shadow\" }\r\n5907.0 \"--sync--\" Ability { id: \"37B4\", source: \"Proto Ozma\" }\r\n5908.0 \"Mourning Star\" Ability { id: \"37B5\", source: \"Ozma\" }\r\n5911.0 \"Soak Attack\" Ability { id: \"37B6\", source: \"Ozma\" }\r\n#5917.1 \"Shooting Star Enrage\" (if this is the enrage)\r\n5926.0 \"Meteor (Adds)\" Ability { id: \"37B0\", source: \"Arsenal urolith\" }\r\n5929.0 \"Shooting Star\" Ability { id: \"37B7\", source: \"Proto Ozma\" }\r\n5938.0 \"Soak Attack\" Ability { id: \"37B6\", source: \"Ozma\" }\r\n5944.0 \"Soak Attack\" Ability { id: \"37B6\", source: \"Ozma\" }\r\n\r\n5949.0 \"Random Shade\" Ability { id: [\"37A4\", \"37B2\", \"379E\"], source: \"Ozmashade\" }\r\n5954.0 \"Shooting Star\" Ability { id: \"37B7\", source: \"Proto Ozma\" }\r\n5956.0 \"--sync--\" Ability { id: [\"37A6\", \"37B4\", \"37A0\"], source: \"Ozmashade\" }\r\n5957.5 \"Shade Ability\" # Ability { id: [\"37A7\", \"37B5\", \"37A1\"], source: \"Shadow\" }\r\n5959.0 \"Soak Attack\" Ability { id: \"37B6\", source: \"Ozma\" }\r\n5959.0 \"Soak Attack\" Ability { id: \"37B6\", source: \"Ozma\" }\r\n5965.0 \"Soak Attack\" Ability { id: \"37B6\", source: \"Ozma\" }\r\n\r\n5973.0 \"Sphere Form\" Ability { id: [\"37B3\", \"37A5\", \"379F\"], source: \"Proto Ozma\" }\r\n5982.0 \"Black Hole\" Ability { id: \"379D\", source: \"Proto Ozma\" }\r\n\r\n5995.0 \"Random Shade\" Ability { id: [\"37A4\", \"37B2\", \"379E\"], source: \"Ozmashade\" }\r\n\r\n# fake loop\r\n5999.0 \"Random Form\"\r\n6003.5 \"Shade Ability\"\r\n6007.7 \"Ozma Ability\"\r\n6010.0 \"Soak Attack?\"\r\n6010.0 \"Acceleration Bomb?\"\r\n6012.0 \"Bleed Attack?\"\r\n6018.0 \"Bleed Attack?\"\r\n6018.0 \"Meteor (Stack)?\"\r\n6021.0 \"Holy?\"\r\n6025.0 \"Meteor (Adds)?\"\r\n6028.0 \"Shooting Star?\"\r\n6031.0 \"Meteor (Adds)?\"\r\n\r\n\r\n### Star Form Enrage\r\n6200.0 \"--sync--\" StartsUsing { id: \"396D\", source: \"Proto Ozma\" } window 300,0\r\n6210.0 \"Shooting Star Enrage\" Ability { id: \"396D\", source: \"Proto Ozma\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/eureka/eureka_pagos.ts


const eureka_pagos_triggerSet = {
  id: 'TheForbiddenLandEurekaPagos',
  zoneId: zone_id/* default.TheForbiddenLandEurekaPagos */.Z.TheForbiddenLandEurekaPagos,
  resetWhenOutOfCombat: false,
  triggers: [
  // https://xivapi.com/LogMessage/916
  // en: 7 minutes have elapsed since your last activity. [...]
  // There is no network packet for these log lines; so have to use GameLog.
  {
    id: 'Eureka Pagos Falling Asleep',
    type: 'GameLog',
    netRegex: {
      line: '7 minutes have elapsed since your last activity..*?',
      capture: false
    },
    response: responses/* Responses.wakeUp */.n3.wakeUp()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      '7 minutes have elapsed since your last activity..*?': 'Seit deiner letzten Aktivität sind 7 Minuten vergangen.'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '7 minutes have elapsed since your last activity.': 'Votre personnage est inactif depuis 7 minutes'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '7 minutes have elapsed since your last activity.': '操作がない状態になってから7分が経過しました。'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '7 minutes have elapsed since your last activity.': '已经7分钟没有进行任何操作'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '7 minutes have elapsed since your last activity..*?': '7분 동안 아무 조작을 하지 않았습니다'
    }
  }]
};
/* harmony default export */ const eureka_pagos = (eureka_pagos_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/eureka/eureka_pyros.ts


const eureka_pyros_triggerSet = {
  id: 'TheForbiddenLandEurekaPyros',
  zoneId: zone_id/* default.TheForbiddenLandEurekaPyros */.Z.TheForbiddenLandEurekaPyros,
  resetWhenOutOfCombat: false,
  triggers: [{
    id: 'Eureka Pyros Skoll Hoarhound Halo',
    type: 'StartsUsing',
    netRegex: {
      id: '36E0',
      source: 'Skoll',
      capture: false
    },
    response: responses/* Responses.goFrontOrSides */.n3.goFrontOrSides()
  }, {
    id: 'Eureka Pyros Skoll Heavensward Howl',
    type: 'StartsUsing',
    netRegex: {
      id: '36DB',
      source: 'Skoll',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  },
  // https://xivapi.com/LogMessage/916
  // en: 7 minutes have elapsed since your last activity. [...]
  // There is no network packet for these log lines; so have to use GameLog.
  {
    id: 'Eureka Pyros Falling Asleep',
    type: 'GameLog',
    netRegex: {
      line: '7 minutes have elapsed since your last activity..*?',
      capture: false
    },
    response: responses/* Responses.wakeUp */.n3.wakeUp()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      '7 minutes have elapsed since your last activity..*?': 'Seit deiner letzten Aktivität sind 7 Minuten vergangen.',
      'Skoll': 'Skalli'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '7 minutes have elapsed since your last activity.': 'Votre personnage est inactif depuis 7 minutes',
      'Skoll': 'Sköll'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '7 minutes have elapsed since your last activity.': '操作がない状態になってから7分が経過しました。',
      'Skoll': 'スコル'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '7 minutes have elapsed since your last activity.': '已经7分钟没有进行任何操作',
      'Skoll': '斯库尔'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '7 minutes have elapsed since your last activity..*?': '7분 동안 아무 조작을 하지 않았습니다',
      'Skoll': '스콜'
    }
  }]
};
/* harmony default export */ const eureka_pyros = (eureka_pyros_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/hunts/yanxia.ts


const yanxia_triggerSet = {
  id: 'Yanxia',
  zoneId: zone_id/* default.Yanxia */.Z.Yanxia,
  triggers: [{
    id: 'Angada Scythe Tail',
    type: 'StartsUsing',
    netRegex: {
      id: '1FFE',
      source: 'Angada',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Angada Butcher',
    type: 'StartsUsing',
    netRegex: {
      id: '1FFF',
      source: 'Angada',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }]
};
/* harmony default export */ const yanxia = (yanxia_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/map/the_hidden_canals_of_uznair.ts

// TODO: Airavata (final chamber boss)

const uznairOutputStrings = {
  spawn: {
    en: '${name} spawned!',
    de: '${name} erscheint!',
    fr: '${name} apparaît !',
    cn: '已生成 ${name}!',
    ko: '${name} 등장!'
  }
};
const the_hidden_canals_of_uznair_triggerSet = {
  id: 'TheHiddenCanalsOfUznair',
  zoneId: zone_id/* default.TheHiddenCanalsOfUznair */.Z.TheHiddenCanalsOfUznair,
  triggers: [
  // ---------------- random treasure mobs ----------------
  {
    id: 'Hidden Canals of Uznair Namazu Stickywhisker Spawn',
    // 6567 = Namazu Stickywhisker
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '6567'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: uznairOutputStrings.spawn
    }
  }, {
    id: 'Hidden Canals of Uznair Abharamu Spawn',
    // 6568 = Abharamu
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '6568'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: uznairOutputStrings.spawn
    }
  }, {
    id: 'Hidden Canals of Uznair Canal Crew Spawn',
    // 6847 = Canal Onion
    // 6848 = Canal Egg
    // 6849 = Canal Garlic
    // 6850 = Canal Tomato
    // 6851 = Canal Queen
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: ['684[7-9]', '685[01]'],
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Canal Crew spawned, kill in order!',
        de: 'Kanal-Mandragora erscheinen, in Reihenfolge besiegen!',
        fr: 'Les mandragores du canal apparaissent, tuez les dans l\'ordre',
        cn: '已生成 运河蔓德拉战队, 依次击杀!',
        ko: '만드라즈 등장, 순서대로 잡기!'
      }
    }
  }
  // ---------------- final chamber boss: Airavata ----------------
  // Spin - front cleave?
  // Buffet - tankbuster?
  ]
};

/* harmony default export */ const the_hidden_canals_of_uznair = (the_hidden_canals_of_uznair_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/map/the_lost_canals_of_uznair.ts


// TODO: Canal Flamebeast (alternate final chamber boss)
// TODO: Canal Windbeast (alternate final chamber boss)
const the_lost_canals_of_uznair_uznairOutputStrings = {
  spawn: {
    en: '${name} spawned!',
    de: '${name} erscheint!',
    fr: '${name} apparaît !',
    cn: '已生成 ${name}!',
    ko: '${name} 등장!'
  }
};
const the_lost_canals_of_uznair_triggerSet = {
  id: 'TheLostCanalsOfUznair',
  zoneId: zone_id/* default.TheLostCanalsOfUznair */.Z.TheLostCanalsOfUznair,
  triggers: [
  // ---------------- random treasure mobs ----------------
  {
    id: 'Lost Canals of Uznair Namazu Stickywhisker Spawn',
    // 6567 = Namazu Stickywhisker
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '6567'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: the_lost_canals_of_uznair_uznairOutputStrings.spawn
    }
  }, {
    id: 'Lost Canals of Uznair Abharamu Spawn',
    // 6568 = Abharamu
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '6568'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: the_lost_canals_of_uznair_uznairOutputStrings.spawn
    }
  },
  // ---------------- cage mobs ----------------
  {
    id: 'Lost Canals of Uznair Canal Scorpion Flying Press',
    type: 'StartsUsing',
    netRegex: {
      id: '2535',
      source: 'Canal Scorpion'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Lost Canals of Uznair Canal Wraith Shadow Flare',
    type: 'StartsUsing',
    netRegex: {
      id: '253A',
      source: 'Canal Wraith',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  },
  // ---------------- final chamber boss: Canal Thunderbeast ----------------
  {
    id: 'Lost Canals of Uznair Canal Thunderbeast Sparkstorm',
    // pulsing AoE on target
    type: 'StartsUsing',
    netRegex: {
      id: '255B',
      source: 'Canal Thunderbeast'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Lost Canals of Uznair Canal Thunderbeast Spark',
    type: 'StartsUsing',
    netRegex: {
      id: '255D',
      source: 'Canal Thunderbeast',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }
  // ---------------- alternate final chamber boss: Canal Flamebeast ----------------
  // Inferno Blast - wide line AoE on main threat?
  // Incinerating Lahar - pulsing roomwide AoE?
  // ---------------- alternate final chamber boss: Canal Windbeast ----------------
  // Twister - front cleave?
  // Crosswind - pulsing AoE with knockback?
  ]
};

/* harmony default export */ const the_lost_canals_of_uznair = (the_lost_canals_of_uznair_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/map/the_shifting_altars_of_uznair.ts



// TODO: Altar Manticore (alternate final summon)
// TODO: Altar Diresaur (alternate final summon)
const the_shifting_altars_of_uznair_uznairOutputStrings = {
  spawn: {
    en: '${name} spawned!',
    de: '${name} erscheint!',
    fr: '${name} apparaît !',
    cn: '已生成 ${name}!',
    ko: '${name} 등장!'
  },
  adds: {
    en: 'Adds soon',
    de: 'Bald Adds',
    fr: 'Adds bientôt',
    cn: '小怪即将出现',
    ko: '곧 쫄 나옴'
  }
};
const the_shifting_altars_of_uznair_triggerSet = {
  id: 'TheShiftingAltarsOfUznair',
  zoneId: zone_id/* default.TheShiftingAltarsOfUznair */.Z.TheShiftingAltarsOfUznair,
  triggers: [
  // ---------------- random treasure mobs ----------------
  {
    id: 'Shifting Altars of Uznair Gold Whisker Spawn',
    // 7602 = Gold Whisker
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '7602'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: the_shifting_altars_of_uznair_uznairOutputStrings.spawn
    }
  }, {
    id: 'Shifting Altars of Uznair Altar Matanga Spawn',
    // 7603 = Altar Matanga
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '7603'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: the_shifting_altars_of_uznair_uznairOutputStrings.spawn
    }
  }, {
    id: 'Shifting Altars of Uznair Altar Assembly Spawn',
    // 7604 = Altar Onion
    // 7605 = Altar Egg
    // 7606 = Altar Garlic
    // 7607 = Altar Tomato
    // 7608 = Altar Queen
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '760[4-8]',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Altar Assembly spawned, kill in order!',
        de: 'Altar-Mandragora erscheinen, in Reihenfolge besiegen!',
        fr: 'Les mandragores d\'Altar apparaissent, tuez les dans l\'ordre',
        cn: '已生成 神殿蔓德拉战队, 依次击杀!',
        ko: '만드라즈 등장, 순서대로 잡기!'
      }
    }
  },
  // ---------------- lesser summons ----------------
  {
    id: 'Shifting Altars of Uznair Altar Chimera Ram\'s Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '3452',
      source: 'Altar Chimera',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Shifting Altars of Uznair Altar Chimera Dragon\'s Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '3453',
      source: 'Altar Chimera',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'Shifting Altars of Uznair Altar Skatene Reckless Abandon',
    type: 'StartsUsing',
    netRegex: {
      id: '33FF',
      source: 'Altar Skatene'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Altars of Uznair Altar Skatene Void Call',
    type: 'StartsUsing',
    netRegex: {
      id: '3400',
      source: 'Altar Skatene',
      capture: false
    },
    infoText: (_data, _matches, output) => output.adds(),
    outputStrings: {
      adds: the_shifting_altars_of_uznair_uznairOutputStrings.adds
    }
  }, {
    id: 'Shifting Altars of Uznair Altar Totem Flames of Fury Collect',
    // triggers off of the first autoattack from Altar Totem
    type: 'Ability',
    netRegex: {
      id: '366',
      source: 'Altar Totem',
      capture: false
    },
    preRun: data => data.altarTotem = true,
    suppressSeconds: 999999
  }, {
    id: 'Shifting Altars of Uznair Altar Totem Flames of Fury',
    // 3 baited AoEs that leave persistent flame puddles
    // same headmarker is used by multiple summons for different attacks
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (data, _matches, output) => {
      if (data.altarTotem) return output.text();
    },
    outputStrings: {
      text: {
        en: 'Bait three puddles',
        de: '3 Flächen ködern',
        fr: 'Déposez 3 flaques',
        cn: '诱导三个圈圈',
        ko: '장판 3개 유도'
      }
    }
  }, {
    id: 'Shifting Altars of Uznair Altar Totem Flames of Fury Cleanup',
    type: 'WasDefeated',
    netRegex: {
      target: 'Altar Totem',
      capture: false
    },
    preRun: data => delete data.altarTotem
  }, {
    id: 'Shifting Altars of Uznair Altar Beast Words of Woe',
    type: 'StartsUsing',
    netRegex: {
      id: '33CC',
      source: 'Altar Beast',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Shifting Altars of Uznair Altar Beast Eye of the Fire',
    type: 'StartsUsing',
    netRegex: {
      id: '33CF',
      source: 'Altar Beast',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'Shifting Altars of Uznair Altar Beast The Spin',
    // proximity AoE from boss
    type: 'StartsUsing',
    netRegex: {
      id: '33CE',
      source: 'Altar Beast',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Shifting Altars of Uznair Hati Polar Roar',
    type: 'StartsUsing',
    netRegex: {
      id: '3430',
      source: 'Hati',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Shifting Altars of Uznair Hati Brain Freeze',
    type: 'StartsUsing',
    netRegex: {
      id: '3431',
      source: 'Hati',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Shifting Altars of Uznair Altar Dullahan Stygian Release',
    type: 'StartsUsing',
    netRegex: {
      id: '3402',
      source: 'Altar Dullahan',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Shifting Altars of Uznair Altar Dullahan Villainous Rebuke',
    type: 'StartsUsing',
    netRegex: {
      id: '3403',
      source: 'Altar Dullahan'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  },
  // ---------------- greater summons ----------------
  {
    id: 'Shifting Altars of Uznair The Winged Sideslip',
    // summons Feather of the Winged orbs (cast Pinion, hatch-pattern line AoEs)
    type: 'StartsUsing',
    netRegex: {
      id: '3444',
      source: 'The Winged',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Shifting Altars of Uznair The Older One Mystic Flash',
    type: 'StartsUsing',
    netRegex: {
      id: '3449',
      source: 'The Older One'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Altars of Uznair The Older One Mystic Levin',
    // summons Altar Idol adds (cast Msytic Heat line AoE and Self Detonate PBAoE)
    type: 'StartsUsing',
    netRegex: {
      id: '344D',
      source: 'The Older One',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Shifting Altars of Uznair Altar Kelpie Torpedo',
    type: 'StartsUsing',
    netRegex: {
      id: '347E',
      source: 'Altar Kelpie'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Altars of Uznair Altar Kelpie Rising Seas',
    // also a roomwide AoE
    type: 'StartsUsing',
    netRegex: {
      id: '3480',
      source: 'Altar Kelpie',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Shifting Altars of Uznair Altar Kelpie Hydro Push',
    type: 'StartsUsing',
    netRegex: {
      id: '3482',
      source: 'Altar Kelpie',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Shifting Altars of Uznair Altar Arachne Dark Spike',
    type: 'StartsUsing',
    netRegex: {
      id: '341E',
      source: 'Altar Arachne'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Altars of Uznair Altar Arachne Frond Affeared',
    type: 'StartsUsing',
    netRegex: {
      id: '35D8',
      source: 'Altar Arachne',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Shifting Altars of Uznair Altar Arachne Implosion',
    type: 'StartsUsing',
    netRegex: {
      id: '341F',
      source: 'Altar Arachne',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  },
  // ---------------- elder summons ----------------
  {
    id: 'Shifting Altars of Uznair Altar Mandragora Optical Intrusion',
    type: 'StartsUsing',
    netRegex: {
      id: '3437',
      source: 'Altar Mandragora'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Altars of Uznair Altar Mandragora Saibai Mandragora',
    type: 'StartsUsing',
    netRegex: {
      id: '343A',
      source: 'Altar Mandragora',
      capture: false
    },
    infoText: (_data, _matches, output) => output.adds(),
    outputStrings: {
      adds: the_shifting_altars_of_uznair_uznairOutputStrings.adds
    }
  }, {
    id: 'Shifting Altars of Uznair Altar Airavata Huff',
    type: 'StartsUsing',
    netRegex: {
      id: '343B',
      source: 'Altar Airavata'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Altars of Uznair Altar Airavata Buffet',
    // uses Spin immediately after (large front cone in direction of Buffet target)
    type: 'StartsUsing',
    netRegex: {
      id: '343E',
      source: 'Altar Airavata'
    },
    response: responses/* Responses.knockbackOn */.n3.knockbackOn()
  }, {
    id: 'Shifting Altars of Uznair The Great Gold Whisker Triple Trident',
    type: 'StartsUsing',
    netRegex: {
      id: '3434',
      source: 'The Great Gold Whisker'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Altars of Uznair The Great Gold Whisker Fish out of Water',
    type: 'StartsUsing',
    netRegex: {
      id: '3436',
      source: 'The Great Gold Whisker',
      capture: false
    },
    infoText: (_data, _matches, output) => output.adds(),
    outputStrings: {
      adds: the_shifting_altars_of_uznair_uznairOutputStrings.adds
    }
  },
  // ---------------- final summon: Altar Apanda ----------------
  {
    id: 'Shifting Altars of Uznair Altar Apanda Deadly Hold',
    type: 'StartsUsing',
    netRegex: {
      id: '3484',
      source: 'Altar Apanda'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Altars of Uznair Altar Apanda Tail Swing',
    // proximity AoE from boss
    type: 'StartsUsing',
    netRegex: {
      id: '3495',
      source: 'Altar Apanda',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Shifting Altars of Uznair Altar Apanda Bone Shaker',
    // summons Profane Cane adds (cast cast Arcane Tide hatch-pattern line AoEs)
    type: 'StartsUsing',
    netRegex: {
      id: '3496',
      source: 'Altar Apanda',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }
  // ---------------- alternate final summon: Altar Manticore ----------------
  // Altar Manticore: Deadly Hold - tankbuster*
  // Altar Manticore: Fireball - stack*
  // Altar Manticore: Volcanic Howl - roomwide AoE*
  // Altar Manticore: Wild Charge - line AoE + knockback on marked player (marked player can aim)*
  // Altar Manticore: Tail Smash - large rear cone AoE, follows Wild Charge?
  // Altar Manticore: Ripper Claw - front cone AoE
  // ---------------- alternate final summon: Altar Diresaur ----------------
  // Altar Diresaur: Deadly Hold - tankbuster*
  // Altar Diresaur: Raging Inferno - roomwide AoE + several dodgable AoEs*
  // Altar Diresaur: Heat Breath - front cone AoE
  // Altar Diresaur: Tail Smash - large rear cone AoE
  ]
};

/* harmony default export */ const the_shifting_altars_of_uznair = (the_shifting_altars_of_uznair_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o10n.ts



// O10N - Alphascape 2.0
const o10n_triggerSet = {
  id: 'AlphascapeV20',
  zoneId: zone_id/* default.AlphascapeV20 */.Z.AlphascapeV20,
  timelineFile: 'o10n.txt',
  triggers: [{
    // Spin Table
    // 31C7 + 31C9 = 31CD (horiz + horiz = out)
    // 31C7 + 31CB = 31CF (horiz + vert = in)
    // 31C8 + 31CB = 31D0 (vert + vert = +)
    id: 'O10N Spin Cleanup',
    type: 'Ability',
    netRegex: {
      id: '31C[78]',
      source: 'Midgardsormr',
      capture: false
    },
    delaySeconds: 10,
    run: data => delete data.lastSpinWasHorizontal
  }, {
    id: 'O10N Horizontal Spin 1',
    type: 'Ability',
    netRegex: {
      id: '31C7',
      source: 'Midgardsormr',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.lastSpinWasHorizontal = true,
    outputStrings: {
      text: {
        en: 'Next Spin: In or Out',
        de: 'Nächste Drehung: Rein oder raus',
        fr: 'Tour suivant : Intérieur ou Extérieur',
        ja: '次: 中/外',
        cn: '下一转:内圈/外圈',
        ko: '다음: 안으로 혹은 밖으로'
      }
    }
  }, {
    id: 'O10N Vertical Spin 1',
    type: 'Ability',
    netRegex: {
      id: '31C8',
      source: 'Midgardsormr',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.lastSpinWasHorizontal = false,
    outputStrings: {
      text: {
        en: 'Next Spin: Corners',
        de: 'Nächste Drehung: Ecken',
        fr: 'Tour suivant : Coins',
        ja: '次: コーナー',
        cn: '下一转:角落',
        ko: '다음: 모서리로'
      }
    }
  }, {
    id: 'O10N Horizontal Spin 2',
    type: 'Ability',
    netRegex: {
      id: '31C9',
      source: 'Midgardsormr',
      capture: false
    },
    condition: data => data.lastSpinWasHorizontal !== undefined,
    alertText: (data, _matches, output) => {
      if (data.lastSpinWasHorizontal) return output.getOut();

      // This shouldn't happen.
      return output.goToCardinals();
    },
    outputStrings: {
      getOut: {
        en: 'Get Out',
        de: 'Raus da',
        fr: 'Sortez',
        ja: '外へ',
        cn: '远离',
        ko: '밖으로'
      },
      goToCardinals: {
        en: 'Go To Cardinals',
        de: 'Geh zu den Kanten',
        fr: 'Allez sur un point cardinal',
        ja: '横や縦へ',
        cn: '去正点',
        ko: '십자 산개'
      }
    }
  }, {
    id: 'O10N Vertical Spin 2',
    type: 'Ability',
    netRegex: {
      id: '31CB',
      source: 'Midgardsormr',
      capture: false
    },
    condition: data => data.lastSpinWasHorizontal !== undefined,
    alertText: (data, _matches, output) => {
      if (data.lastSpinWasHorizontal) return output.getIn();
      return output.goToCorners();
    },
    outputStrings: {
      getIn: {
        en: 'Get In',
        de: 'Rein da',
        fr: 'Passez en dessous',
        ja: '中へ',
        cn: '靠近',
        ko: '안으로'
      },
      goToCorners: {
        en: 'Go To Corners',
        de: 'In die Ecken',
        fr: 'Allez dans les coins',
        ja: '角へ',
        cn: '去角落',
        ko: '구석으로'
      }
    }
  }, {
    id: 'O10N Earth Shaker',
    type: 'HeadMarker',
    netRegex: {
      id: '0028'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.earthshaker */.n3.earthshaker()
  }, {
    id: 'O10N Akh Morn',
    type: 'HeadMarker',
    // This corresponds with 316C ability cast (for initial hit).
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'O10N Thunderstorm',
    type: 'HeadMarker',
    // This corresponds with the 31D2 ability cast.
    netRegex: {
      id: '00A0'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'O10N Dry Ice',
    type: 'HeadMarker',
    netRegex: {
      id: '0043'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Ice Outside',
        de: 'Eis draußen ablegen',
        fr: 'Déposez la glace à l\'extérieur',
        cn: '把冰放在外面',
        ko: '필드 외각으로 유도'
      }
    }
  }, {
    id: 'O10N Tail End',
    type: 'StartsUsing',
    netRegex: {
      id: '31C5',
      source: 'Midgardsormr'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O10N Rime Wreath',
    type: 'StartsUsing',
    netRegex: {
      id: '33EF',
      source: 'Ancient Dragon',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O10N Akh Rhai',
    type: 'Ability',
    // Damage starts hitting ~2s after this ability.
    // Assuming that it locks in on cast and not on starts casting.
    // Technically this is only on DPS, but it's not targeted, so just tell everybody.
    netRegex: {
      id: '3622',
      source: 'Midgardsormr',
      capture: false
    },
    response: responses/* Responses.moveAway */.n3.moveAway()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Ancient Dragon': 'antik(?:e|er|es|en) Drache',
      'Midgardsormr': 'Midgardsormr'
    },
    'replaceText': {
      '(?<!/)Out': 'Raus',
      '(?<!\\w)In(?!/)': 'Rein',
      'Akh Morn': 'Akh Morn',
      'Akh Rhai': 'Akh Rhai',
      'Cauterize': 'Kauterisieren',
      'Corners': 'Ecken',
      'Dry Ice': 'Trockeneis',
      'Earth Shaker': 'Erdstoß',
      'Exaflare': 'Exaflare',
      'Flip': 'Rolle',
      'Frost Breath': 'Frostiger Atem',
      'Horrid Roar': 'Entsetzliches Brüllen',
      'In/Out': 'Rein/Raus',
      'Northern Cross': 'Kreuz des Nordens',
      'Protostar': 'Protostern',
      'Spin': 'Drehung',
      'Tail End': 'Schweifspitze',
      'Thunderstorm': 'Gewitter'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ancient Dragon': 'dragon ancien',
      'Midgardsormr': 'Midgardsormr'
    },
    'replaceText': {
      'Akh Morn': 'Akh Morn',
      'Akh Rhai': 'Akh Rhai',
      'Cauterize': 'Cautérisation',
      'Corners': 'Coins',
      'Dry Ice': 'Poussière glaçante',
      'Earth Shaker': 'Secousse',
      'Exaflare': 'ExaBrasier',
      'Flip(?!/)': 'Tour vertical',
      'Flip/Spin': 'Tour vertical/horizontal',
      'Frost Breath': 'Souffle glacé',
      'Horrid Roar': 'Rugissement horrible',
      '(?<!\\w)In(?!\\w)': 'Intérieur',
      'Northern Cross': 'Croix du nord',
      '(?<!\\w)Out(?!\\w)': 'Extérieur',
      'Protostar': 'Proto-étoile',
      'ready': 'prêt',
      '(?<!/)Spin': 'Tour horizontal',
      'Tail End': 'Pointe de queue',
      'Thunderstorm': 'Tempête de foudre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ancient Dragon': 'エンシェントドラゴン',
      'Midgardsormr': 'ミドガルズオルム'
    },
    'replaceText': {
      '(?<!/)Out': '外',
      '(?<!\\w)In(?!/)': '中',
      'Akh Morn': 'アク・モーン',
      'Akh Rhai': 'アク・ラーイ',
      'Cauterize': 'カータライズ',
      'Corners': '角',
      'Dry Ice': 'フリージングダスト',
      'Earth Shaker': 'アースシェイカー',
      'Exaflare': 'エクサフレア',
      'Flip': '回転',
      'Frost Breath': 'フロストブレス',
      'Horrid Roar': 'ホリッドロア',
      'In/Out': '中/外',
      'Northern Cross': 'ノーザンクロス',
      'Protostar': 'プロトスター',
      'Spin': 'ぶん回す',
      'Tail End': 'テイルエンド',
      'Thunderstorm': 'サンダーストーム'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ancient Dragon': '远古之龙',
      'Midgardsormr': '尘世幻龙'
    },
    'replaceText': {
      'ready': '准备',
      'Akh Morn': '死亡轮回',
      'Akh Rhai': '天光轮回',
      'Cauterize': '低温俯冲',
      'Corners': '角',
      'Dry Ice': '冰尘',
      'Earth Shaker': '大地摇动',
      'Exaflare': '百京核爆',
      'Flip': '竖转',
      'Frost Breath': '寒霜吐息',
      'Horrid Roar': '恐惧咆哮',
      '(?<!\\w)In(?!/)': '靠近',
      'In/Out': '靠近/远离',
      '(?<!/)Out': '远离',
      'Northern Cross': '北十字星',
      'Protostar': '原恒星',
      'Spin': '回转',
      'Tail End': '煞尾',
      'Thunderstorm': '雷暴'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ancient Dragon': '고룡',
      'Midgardsormr': '미드가르드오름'
    },
    'replaceText': {
      'Out': '밖으로',
      '(?<!Sp)In': '안으로',
      'Flip': '미드가르드오름 앞구르기',
      'Corners': '모서리',
      'Akh Morn': '아크 몬',
      'Akh Rhai': '아크 라이',
      'Cauterize': '인두질',
      'Dry Ice': '지면 동결',
      'Earth Shaker': '요동치는 대지',
      'Exaflare': '엑사플레어',
      'Frost Breath': '서리 숨결',
      'Horrid Roar': '소름끼치는 포효',
      'Northern Cross': '북십자성',
      'Protostar': '원시별',
      'Spin': '회전',
      'Tail End': '꼬리 쓸기',
      'Thunderstorm': '번개 폭풍'
    }
  }]
};
/* harmony default export */ const o10n = (o10n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o10n.txt
const raid_o10n_namespaceObject = "# Omega - Alphascape V2.0 - O10N\r\n# -r MGmYR8kHQta1vN4D -rf 54 -ii 31F9 362D 31D5 3624 3630 31FB 3638\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n## Common start\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n13.1 \"Spin\" Ability { id: \"31C7\", source: \"Midgardsormr\" } window 14,5\r\n19.2 \"Spin\" Ability { id: \"31C9\", source: \"Midgardsormr\" }\r\n22.9 \"Out\" Ability { id: \"31CD\", source: \"Midgardsormr\" }\r\n31.6 \"Spin\" Ability { id: \"31C7\", source: \"Midgardsormr\" }\r\n37.7 \"Spin\" Ability { id: \"31C9\", source: \"Midgardsormr\" }\r\n41.3 \"Out\" Ability { id: \"31CD\", source: \"Midgardsormr\" }\r\n45.8 \"Earth Shaker\" Ability { id: \"31D1\", source: \"Midgardsormr\" }\r\n57.1 \"Akh Morn\" Ability { id: \"31C6\", source: \"Midgardsormr\" } duration 4\r\n62.5 \"--sync--\" Ability { id: \"3249\", source: \"Midgardsormr\" }\r\n68.9 \"Spin\" Ability { id: \"31C7\", source: \"Midgardsormr\" }\r\n75.0 \"Flip\" Ability { id: \"31CB\", source: \"Midgardsormr\" }\r\n78.6 \"In\" Ability { id: \"31CF\", source: \"Midgardsormr\" }\r\n87.3 \"Spin\" Ability { id: \"31C7\", source: \"Midgardsormr\" }\r\n93.4 \"Flip/Spin\" Ability { id: \"31C[B9]\", source: \"Midgardsormr\" }\r\n96.9 \"In/Out\" Ability { id: \"31C[FD]\", source: \"Midgardsormr\" }\r\n100.4 \"Thunderstorm\" Ability { id: \"31D2\", source: \"Midgardsormr\" }\r\n104.9 \"Horrid Roar\" Ability { id: \"31D3\", source: \"Midgardsormr\" }\r\n117.3 \"Flip\" Ability { id: \"31C8\", source: \"Midgardsormr\" }\r\n123.4 \"Flip\" Ability { id: \"31CB\", source: \"Midgardsormr\" }\r\n127.5 \"Corners\" Ability { id: \"31D0\", source: \"Midgardsormr\" }\r\n140.6 \"Dry Ice\" Ability { id: \"3632\", source: \"Midgardsormr\" }\r\n142.8 \"Flip\" Ability { id: \"31C8\", source: \"Midgardsormr\" }\r\n149.0 \"Flip\" Ability { id: \"31CB\", source: \"Midgardsormr\" }\r\n151.4 \"--sync--\" Ability { id: \"35BB\", source: \"Midgardsormr\" }\r\n153.1 \"Corners\" Ability { id: \"31D0\", source: \"Midgardsormr\" }\r\n156.3 \"--untargetable--\"\r\n159.4 \"--sync--\" Ability { id: \"35BC\", source: \"Midgardsormr\" }\r\n167.2 \"Cauterize\" Ability { id: \"3241\", source: \"Midgardsormr\" }\r\n\r\n183.5 \"Frost Breath\" Ability { id: \"33EE\", source: \"Ancient Dragon\" } window 30,30\r\n195.5 \"Frost Breath ready\"\r\n\r\n500.0 \"Protostar x4\" Ability { id: \"31C3\", source: \"Midgardsormr\" } duration 12 window 500,500\r\n523.4 \"--targetable--\"\r\n536.6 \"Tail End\" Ability { id: \"31C5\", source: \"Midgardsormr\" }\r\n544.6 \"Exaflare\"\r\n547.6 \"Exaflare\"\r\n550.6 \"Exaflare\"\r\n553.6 \"Exaflare\"\r\n556.6 \"Exaflare\"\r\n\r\n# Loop\r\n559.1 \"Horrid Roar\" Ability { id: \"31D3\", source: \"Midgardsormr\" }\r\n570.6 \"Northern Cross\" Ability { id: \"3629\", source: \"Midgardsormr\" }\r\n575.2 \"Flip/Spin\" Ability { id: \"31C[78]\", source: \"Midgardsormr\" }\r\n581.2 \"Flip/Spin\" Ability { id: \"31C[B9]\", source: \"Midgardsormr\" }\r\n584.7 \"In/Out/Corners\" Ability { id: \"31(CF|CD|D0)\", source: \"Midgardsormr\" }\r\n596.2 \"Akh Rhai\" Ability { id: \"3622\", source: \"Midgardsormr\" }\r\n598.2 \"Flip\" Ability { id: \"31C8\", source: \"Midgardsormr\" }\r\n604.2 \"Flip\" Ability { id: \"31CB\", source: \"Midgardsormr\" }\r\n608.2 \"Corners\" Ability { id: \"31D0\", source: \"Midgardsormr\" }\r\n611.2 \"Thunderstorm\" Ability { id: \"31D2\", source: \"Midgardsormr\" }\r\n615.4 \"--untargetable--\"\r\n621.2 \"Exaflare\"\r\n624.2 \"Exaflare\"\r\n624.7 \"Cauterize\" Ability { id: \"3241\", source: \"Midgardsormr\" }\r\n627.2 \"Exaflare\"\r\n630.2 \"Exaflare\"\r\n633.2 \"Exaflare\"\r\n635.3 \"Cauterize\" Ability { id: \"3241\", source: \"Midgardsormr\" }\r\n642.7 \"--targetable--\"\r\n646.9 \"Flip/Spin\" Ability { id: \"31C[78]\", source: \"Midgardsormr\" }\r\n652.9 \"Flip/Spin\" Ability { id: \"31C[B9]\", source: \"Midgardsormr\" }\r\n656.9 \"In/Out/Corners\" Ability { id: \"31(CF|CD|D0)\", source: \"Midgardsormr\" }\r\n660.9 \"Earth Shaker\" Ability { id: \"31D1\", source: \"Midgardsormr\" }\r\n\r\n669.4 \"Horrid Roar\" Ability { id: \"31D3\", source: \"Midgardsormr\" }\r\n671.1 \"Akh Morn\" Ability { id: \"31C6\", source: \"Midgardsormr\" } duration 4\r\n676.3 \"--sync--\" Ability { id: \"3249\", source: \"Midgardsormr\" }\r\n687.3 \"Tail End\" Ability { id: \"31C5\", source: \"Midgardsormr\" }\r\n698.3 \"Northern Cross\" Ability { id: \"3629\", source: \"Midgardsormr\" }\r\n706.8 \"Thunderstorm\" Ability { id: \"320F\", source: \"Midgardsormr\" }\r\n707.3 \"Thunderstorm\" Ability { id: \"31D2\", source: \"Midgardsormr\" }\r\n713.8 \"Dry Ice\" Ability { id: \"3632\", source: \"Midgardsormr\" }\r\n721.8 \"Exaflare\"\r\n724.4 \"--sync--\" Ability { id: \"35BB\", source: \"Midgardsormr\" }\r\n724.8 \"Exaflare\"\r\n727.8 \"Exaflare\"\r\n730.8 \"Exaflare\"\r\n732.4 \"--sync--\" Ability { id: \"35BC\", source: \"Midgardsormr\" }\r\n733.8 \"Exaflare\"\r\n\r\n736.3 \"Horrid Roar\" Ability { id: \"31D3\", source: \"Midgardsormr\" } window 50,50 jump 559.1\r\n747.8 \"Northern Cross\"\r\n752.4 \"Flip/Spin\"\r\n758.4 \"Flip/Spin\"\r\n761.9 \"In/Out/Corners\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o10s.ts



// TODO: fix tail end (seemed to not work??)
// TODO: add phase tracking (so death from above/below can tell you to swap or not)
// TODO: add swap callout after exaflares
// TODO: debuff tracking for when you lose the barrier to remind you to run?
// TODO: ice head markers
// TODO: stack head markers
// O10S - Alphascape 2.0 Savage
const o10s_triggerSet = {
  id: 'AlphascapeV20Savage',
  zoneId: zone_id/* default.AlphascapeV20Savage */.Z.AlphascapeV20Savage,
  timelineFile: 'o10s.txt',
  triggers: [{
    id: 'O10S Tail End',
    type: 'StartsUsing',
    netRegex: {
      id: '31AA',
      source: 'Midgardsormr'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O10S Fire Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) return output.fireOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return output.fireOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      fireOnYou: {
        en: 'Fire Marker on YOU',
        de: 'Feuer Marker auf DIR',
        fr: 'Marqueur feu sur VOUS',
        ja: '自分にマーカー',
        cn: '喷火点名',
        ko: '불징 대상자'
      },
      fireOn: {
        en: 'Fire Marker on ${player}',
        de: 'Feuer Markierung auf ${player}',
        fr: 'Marqueur feu sur ${player}',
        ja: '${player} にマーカー',
        cn: '喷火点${player}',
        ko: '${player} 불징'
      }
    }
  }, {
    id: 'O10S Death From Below',
    type: 'HeadMarker',
    netRegex: {
      id: '008F'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Death From Below',
        de: 'Tod von unten',
        fr: 'Désastre terrestre',
        ja: '地の災厄',
        cn: '地之灾厄',
        ko: '디버프 확인'
      }
    }
  }, {
    id: 'O10S Death From Above',
    type: 'HeadMarker',
    netRegex: {
      id: '008E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Death From Above',
        de: 'Tod von oben',
        fr: 'Désastre céleste',
        ja: '天の災厄',
        cn: '天之灾厄',
        ko: '디버프 확인'
      }
    }
  }, {
    // Spin Table
    // 31AC + 31AE = 31B2 (horiz + horiz = out)
    // 31AC + 31B0 = 31B4 (horiz + vert = in)
    // 31AD + 31AE = 31B3 (vert + horiz = x)
    // 31AD + 31B0 = 31B5 (vert + vert = +)
    id: 'O10S Spin Cleanup',
    type: 'Ability',
    // 16 if it doesn't hit anybody, 15 if it does.
    // Also, some log lines are inconsistent here and don't always list
    // Midgardsormr's name and are sometimes blank.
    netRegex: {
      id: '31B[2345]',
      source: ['Midgardsormr', ''],
      capture: false
    },
    run: data => delete data.lastSpinWasHorizontal
  }, {
    id: 'O10S Horizontal Spin 1',
    type: 'Ability',
    netRegex: {
      id: '31AC',
      source: 'Midgardsormr',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.lastSpinWasHorizontal = true,
    outputStrings: {
      text: {
        en: 'Next Spin: In or Out',
        de: 'Nächste Drehung: Rein oder Raus',
        fr: 'Tour suivant : Intérieur ou Extérieur',
        ja: '次: 中/外',
        cn: '下一转：靠近或远离',
        ko: '안쪽 / 바깥쪽'
      }
    }
  }, {
    id: 'O10S Vertical Spin 1',
    type: 'Ability',
    netRegex: {
      id: '31AD',
      source: 'Midgardsormr',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.lastSpinWasHorizontal = false,
    outputStrings: {
      text: {
        en: 'Next Spin: Cardinals or Corners',
        de: 'Nächste Drehung: Kanten oder Ecken',
        fr: 'Tour suivant : Cardinal ou Coins',
        ja: '次: コーナー',
        cn: '下一转：靠边火角落',
        ko: '십자 / 대각선'
      }
    }
  }, {
    id: 'O10S Horizontal Spin 2',
    type: 'Ability',
    netRegex: {
      id: '31AE',
      source: 'Midgardsormr',
      capture: false
    },
    condition: data => data.lastSpinWasHorizontal !== undefined,
    alertText: (data, _matches, output) => {
      if (data.lastSpinWasHorizontal) return output.getOut();
      return output.goToCardinals();
    },
    outputStrings: {
      getOut: {
        en: 'Get Out',
        de: 'Raus da',
        fr: 'Sortez',
        ja: '外へ',
        cn: '远离',
        ko: '밖으로'
      },
      goToCardinals: {
        en: 'Go To Cardinals',
        de: 'An die Kanten',
        fr: 'Allez sur un cardinal',
        ja: '横や縦へ',
        cn: '靠边',
        ko: '십자 산개'
      }
    }
  }, {
    id: 'O10S Vertical Spin 2',
    type: 'Ability',
    netRegex: {
      id: '31B0',
      source: 'Midgardsormr',
      capture: false
    },
    condition: data => data.lastSpinWasHorizontal !== undefined,
    alertText: (data, _matches, output) => {
      if (data.lastSpinWasHorizontal) return output.getIn();
      return output.goToCorners();
    },
    outputStrings: {
      getIn: {
        en: 'Get In',
        de: 'Rein da',
        fr: 'Passez en dessous',
        ja: '中へ',
        cn: '靠近',
        ko: '안으로'
      },
      goToCorners: {
        en: 'Go To Corners',
        de: 'In die Ecken',
        fr: 'Allez dans les coins',
        ja: '角へ',
        cn: '角落',
        ko: '구석 산개'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Ancient Dragon': 'antik(?:e|er|es|en) Drache',
      'Midgardsormr': 'Midgardsormr'
    },
    'replaceText': {
      'Akh Morn': 'Akh Morn',
      'Akh Rhai': 'Akh Rhai',
      'Cardinals': 'Kanten',
      'Cauterize': 'Kauterisieren',
      'Corners': 'Ecken',
      'Crimson Breath': 'Purpurschwingen',
      'Dry Ice': 'Trockeneis',
      'Earth Shaker': 'Erdstoß',
      'Exaflare': 'Exaflare',
      'Flame Blast': 'Flammenhölle',
      'Flip': 'Rolle',
      'Frost Breath': 'Frostiger Atem',
      'Horrid Roar': 'Entsetzliches Brüllen',
      'Hot Tail': 'Schwelender Schweif',
      'In/Out': 'Rein/Raus',
      '(?<!\/)Out': 'Raus',
      'Northern Cross': 'Kreuz des Nordens',
      'Position': 'Position',
      'Protostar': 'Protostern',
      'Shaker/Thunder': 'Erdstoß/Blitz',
      'Signal': 'Signal',
      'Spin': 'Drehung',
      'Tail End': 'Schweifspitze',
      'Thunderstorm': 'Gewitter',
      'Time Immemorial': 'Urknall',
      'Touchdown': 'Himmelssturz'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ancient Dragon': 'dragon ancien',
      'Midgardsormr': 'Midgardsormr'
    },
    'replaceText': {
      '\\?': ' ?',
      'Akh Morn': 'Akh Morn',
      'Akh Rhai': 'Akh Rhai',
      'Cardinals': 'Cardinaux',
      'Cauterize': 'Cautérisation',
      'Corners': 'Coins',
      'Crimson Breath': 'Souffle écarlate',
      'Dry Ice': 'Poussière glaçante',
      'Earth Shaker': 'Secousse',
      'Enrage Hit': 'Enrage coup',
      'Exaflare': 'ExaBrasier',
      'Flame Blast': 'Fournaise',
      '(?<!/)Flip(?!/)': 'Tour vertical',
      'Flip/Spin': 'Tour vertical/horizontal',
      'Frost Breath': 'Souffle glacé',
      'Horrid Roar': 'Rugissement horrible',
      'Hot Tail': 'Queue calorifique',
      '(?<!\\w)In(?!\\w)': 'Intérieur',
      '(?<!\\w)Out': 'Extérieur',
      'Northern Cross': 'Croix du nord',
      'Position': 'Position',
      'Protostar': 'Proto-étoile',
      'Shaker/Thunder': 'Secousse/Tempête',
      '(?<!/)Spin(?!/)': 'Tour horizontal',
      'Spin/Flip': 'Tour horizontal/vertical',
      'Tail End': 'Pointe de queue',
      'Thunderstorm': 'Tempête de foudre',
      'Time Immemorial': 'Big bang',
      'Touchdown': 'Atterrissage'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ancient Dragon': 'エンシェントドラゴン',
      'Midgardsormr': 'ミドガルズオルム'
    },
    'replaceText': {
      'Akh Morn': 'アク・モーン',
      'Akh Rhai': 'アク・ラーイ',
      'Cardinals': '横や縦',
      'Cauterize': 'カータライズ',
      'Corners': '角',
      'Crimson Breath': 'クリムゾンブレス',
      'Dry Ice': 'フリージングダスト',
      'Earth Shaker': 'アースシェイカー',
      'Exaflare': 'エクサフレア',
      'Flame Blast': 'フレイムブラスト',
      'Flip': '回転',
      'Frost Breath': 'フロストブレス',
      'Horrid Roar': 'ホリッドロア',
      'Hot Tail': 'ヒートテイル',
      'In/Out': '中/外',
      '(?<!\/)Out': '外',
      'Northern Cross': 'ノーザンクロス',
      'Position': 'ポジション',
      'Protostar': 'プロトスター',
      'Shaker/Thunder': 'シェーカー/サンダー',
      'Signal': 'フラグ',
      'Spin': 'ぶん回す',
      'Tail End': 'テイルエンド',
      'Thunderstorm': 'サンダーストーム',
      'Time Immemorial': '天地開闢',
      'Touchdown': 'タッチダウン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ancient Dragon': '远古之龙',
      'Midgardsormr': '尘世幻龙'
    },
    'replaceText': {
      'ready': '准备',
      'Akh Morn': '死亡轮回',
      'Akh Rhai': '天光轮回',
      'Cardinals': '边',
      'Cauterize': '低温俯冲',
      'Corners': '角',
      'Crimson Breath': '深红吐息',
      'Dry Ice': '冰尘',
      'Earth Shaker': '大地摇动',
      'Exaflare': '百京核爆',
      'Flame Blast': '烈焰十字爆',
      'Flip': '竖转',
      'Frost Breath': '寒霜吐息',
      'Horrid Roar': '恐惧咆哮',
      'Hot Tail': '燃烧之尾',
      'In/Out': '靠近/远离',
      '(?<!\/)Out': '远离',
      'Northern Cross': '北十字星',
      'Position': '站位',
      'Protostar': '原恒星',
      'Shaker/Thunder': '大地摇动/闪雷风暴',
      'Signal': '信号',
      'Spin': '回转',
      'Tail End': '煞尾',
      'Thunderstorm': '雷暴',
      'Time Immemorial': '开天辟地',
      'Touchdown': '空降'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Midgardsormr': '미드가르드오름',
      'Ancient Dragon': '고룡'
    },
    'replaceText': {
      ' ready': ' 준비 완료',
      'Akh Morn': '아크 몬',
      'Akh Rhai': '아크 라이',
      'Cardinals': '맵 측면',
      'Cauterize': '인두질',
      'Corners': '구석',
      'Crimson Breath': '진홍빛 숨결',
      'Dry Ice': '지면 동결',
      'Earth Shaker': '요동치는 대지',
      'Exaflare': '엑사플레어',
      'Flame Blast': '화염 작렬',
      'Flip': '앞회전',
      'Frost Breath': '서리 숨결',
      'Horrid Roar': '소름끼치는 포효',
      'Hot Tail': '뜨거운 꼬리',
      'In/Out': '안/밖',
      '(?<!\/)Out': '밖',
      'Northern Cross': '북십자성',
      'Position': '위치',
      'Protostar': '원시별',
      'Shaker/Thunder': '어스/번개',
      'Signal': '신호',
      'Spin': '마구 돌리기',
      'Tail End': '꼬리 쓸기',
      'Thunderstorm': '번개 폭풍',
      'Time Immemorial': '천지개벽',
      'Touchdown': '착지'
    }
  }]
};
/* harmony default export */ const o10s = (o10s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o10s.txt
const raid_o10s_namespaceObject = "# Omega - Alphascape V2.0 (Savage) - O10S\r\n# -ii 31FA 3249 3630 3623 35BB 35BC 31D6 31B7 31C4 362C 321E 320D\r\n# TODO: update to use forcejump\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n12.3 \"Flip\" Ability { id: \"31AD\", source: \"Midgardsormr\" } window 13,10\r\n23.5 \"Spin\" Ability { id: \"31AE\", source: \"Midgardsormr\" }\r\n27.4 \"Cardinals\" Ability { id: \"31B3\", source: \"Midgardsormr\" } # X hit, not sure of sync yet\r\n\r\n35.9 \"Spin\" Ability { id: \"31AC\", source: \"Midgardsormr\" } # drift 0.029\r\n47.1 \"Akh Morn\" Ability { id: \"31AB\", source: \"Midgardsormr\" }\r\n53.6 \"Spin\" Ability { id: \"31AE\", source: \"Midgardsormr\" }\r\n57.2 \"Out\" Ability { id: \"31B2\", source: \"Midgardsormr\" }\r\n69.9 \"Tail End\" Ability { id: \"31AA\", source: \"Midgardsormr\" }\r\n\r\n78.2 \"Spin\" Ability { id: \"31AC\", source: \"Midgardsormr\" } # drift 0.039\r\n89.4 \"Flip/Spin\" Ability { id: \"31(AE|B0)\", source: \"Midgardsormr\" }\r\n92.9 \"In/Out\" Ability { id: \"31B(2|4)\", source: \"(Midgardsormr)?\" } # Sometimes missing actor name\r\n92.9 \"Earth Shaker\" Ability { id: \"31B6\", source: \"Midgardsormr\" } # Missing actor name on all but one\r\n\r\n101.8 \"Flip\" Ability { id: \"31AD\", source: \"Midgardsormr\" }\r\n112.0 \"Tail End\" Ability { id: \"31AA\", source: \"Midgardsormr\" }\r\n114.1 \"Flip/Spin\" Ability { id: \"31(AE|B0)\", source: \"Midgardsormr\" }\r\n118.1 \"Corners/Cardinals\" Ability { id: \"31B(3|5)\", source: \"Midgardsormr\" }\r\n118.7 \"Thunderstorm\" Ability { id: \"31B8\", source: \"Midgardsormr\" }\r\n\r\n131.2 \"Time Immemorial\" Ability { id: \"32EF\", source: \"Midgardsormr\" }\r\n141.5 \"Tail End\" Ability { id: \"31AA\", source: \"Midgardsormr\" }\r\n149.8 \"Spin\" Ability { id: \"31AC\", source: \"Midgardsormr\" } # drift 0.041\r\n158.9 \"Northern Cross\" Ability { id: \"3625\", source: \"Midgardsormr\" }\r\n163.1 \"Flip/Spin\" Ability { id: \"31AE\", source: \"Midgardsormr\" } # drift 0.021\r\n166.6 \"In/Out\" Ability { id: \"31B(2|4)\", source: \"Midgardsormr\" }\r\n173.4 \"Akh Rhai\" Ability { id: \"3622\", source: \"Midgardsormr\" }\r\n175.3 \"Dry Ice\" Ability { id: \"3631\", source: \"Midgardsormr\" }\r\n\r\n179.7 \"Spin\" Ability { id: \"31AC\", source: \"Midgardsormr\" } # drift 0.036\r\n191.0 \"Flip/Spin\" Ability { id: \"31(AE|B0)\", source: \"Midgardsormr\" }\r\n194.5 \"In/Out\" Ability { id: \"31B(2|4)\", source: \"Midgardsormr\" }\r\n194.9 \"Horrid Roar\" Ability { id: \"31B9\", source: \"Midgardsormr\" }\r\n202.9 \"--untargetable--\"\r\n\r\n# Add phase\r\n215.9 \"Frost Breath\" Ability { id: \"33F1\", source: \"Ancient Dragon\" } window 2.5,30\r\n226.2 \"Frost Breath ready\"\r\n\r\n282.0 \"--sync--\" Ability { id: \"341A\", source: \"Ancient Dragon\" } window 80,10\r\n284.2 \"Protostar\" Ability { id: \"31C3\", source: \"Midgardsormr\" } window 500,500\r\n294.8 \"Protostar\" # Damage instances\r\n295.9 \"Protostar\"\r\n297.0 \"Protostar\"\r\n\r\n310.9 \"Horrid Roar\" Ability { id: \"31B9\", source: \"Midgardsormr\" }\r\n312.5 \"Thunderstorm\" Ability { id: \"31B8\", source: \"Midgardsormr\" }\r\n313.0 \"Cauterize\" Ability { id: \"3240\", source: \"Midgardsormr\" }\r\n321.8 \"Horrid Roar\" Ability { id: \"31B9\", source: \"Midgardsormr\" }\r\n323.3 \"Thunderstorm\" Ability { id: \"31B8\", source: \"Midgardsormr\" }\r\n323.9 \"Cauterize\" Ability { id: \"3240\", source: \"Midgardsormr\" }\r\n328.0 \"Touchdown\" Ability { id: \"31BB\", source: \"Midgardsormr\" }\r\n332.5 \"--targetable--\"\r\n\r\n339.2 \"Time Immemorial\" Ability { id: \"31BF\", source: \"Midgardsormr\" }\r\n350.7 \"Crimson Breath\" Ability { id: \"31BC\", source: \"Midgardsormr\" }\r\n357.9 \"Crimson Breath\" Ability { id: \"31BC\", source: \"Midgardsormr\" }\r\n365.3 \"Crimson Breath\" Ability { id: \"31BC\", source: \"Midgardsormr\" }\r\n372.5 \"Crimson Breath\" Ability { id: \"31BC\", source: \"Midgardsormr\" }\r\n390.3 \"Horrid Roar\" Ability { id: \"3414\", source: \"Midgardsormr\" }\r\n390.3 \"Flame Blast\"\r\n392.9 \"Flame Blast\"\r\n395.3 \"Flame Blast\"\r\n396.9 \"Hot Tail\" Ability { id: \"31BD\", source: \"Midgardsormr\" }\r\n\r\n408.1 \"--untargetable--\"\r\n412.3 \"Exaflare\"\r\n412.8 \"Horrid Roar\" Ability { id: \"31B9\", source: \"Midgardsormr\" }\r\n414.9 \"Cauterize\" Ability { id: \"3240\", source: \"Midgardsormr\" }\r\n415.3 \"Exaflare\"\r\n418.3 \"Exaflare\"\r\n421.4 \"Exaflare\"\r\n423.7 \"Horrid Roar\" Ability { id: \"31B9\", source: \"Midgardsormr\" } # drift 0.033\r\n424.4 \"Exaflare\"\r\n425.8 \"Cauterize\" Ability { id: \"3240\", source: \"Midgardsormr\" } # drift 0.048\r\n\r\n431.8 \"--targetable--\"\r\n444.8 \"Tail End\" Ability { id: \"31AA\", source: \"Midgardsormr\" }\r\n456.0 \"Akh Morn\" Ability { id: \"31AB\", source: \"Midgardsormr\" } # drift -0.033\r\n466.0 \"Horrid Roar\" Ability { id: \"31B9\", source: \"Midgardsormr\" }\r\n467.6 \"Thunderstorm\" Ability { id: \"31B8\", source: \"Midgardsormr\" }\r\n\r\n##################\r\n## Branch point ##\r\n##################\r\n\r\n474.4 \"Flip/Spin\" Ability { id: \"31AC\", source: \"Midgardsormr\" } jump 1474.4 # C means spin\r\n474.4 \"--sync--\" Ability { id: \"31AD\", source: \"Midgardsormr\" } jump 2474.4 # D means flip\r\n484.5 \"Tail End\" # Cosmetic\r\n486.6 \"Flip/Spin\"\r\n490.6 \"Signal?\"\r\n492.1 \"Position?\"\r\n\r\n## Branch A1: Spin->Earthshaker\r\n\r\n1474.4 \"Spin\" Ability { id: \"31AC\", source: \"Midgardsormr\" }\r\n1484.5 \"Tail End\" Ability { id: \"31AA\", source: \"Midgardsormr\" }\r\n1486.6 \"Flip/Spin\" Ability { id: \"31AE\", source: \"Midgardsormr\" }\r\n1490.6 \"In/Out\" Ability { id: \"31B(2|4)\", source: \"Midgardsormr\" }\r\n1490.6 \"Earth Shaker\" Ability { id: \"31B6\", source: \"Midgardsormr\" }\r\n1502.3 \"Time Immemorial\" Ability { id: \"32EF\", source: \"Midgardsormr\" } jump 3502.3\r\n1512.6 \"Exaflare\" # Cosmetic\r\n1513.7 \"Dry Ice\"\r\n1515.7 \"Exaflare\"\r\n1518.6 \"Exaflare\"\r\n1520.8 \"Akh Morn\"\r\n1521.7 \"Exaflare\"\r\n\r\n## Branch B1: Flip->Thunderstorm\r\n\r\n2474.4 \"Flip\" Ability { id: \"31AD\", source: \"Midgardsormr\" }\r\n2484.5 \"Tail End\" Ability { id: \"31AA\", source: \"Midgardsormr\" }\r\n2486.6 \"Flip/Spin\" Ability { id: \"31AE\", source: \"Midgardsormr\" }\r\n2490.6 \"Corners/Cardinals\" Ability { id: \"31B(3|5)\", source: \"Midgardsormr\" }\r\n2492.1 \"Thunderstorm\" Ability { id: \"31B8\", source: \"Midgardsormr\" }\r\n2502.3 \"Time Immemorial\" Ability { id: \"32EF\", source: \"Midgardsormr\" } jump 3502.3\r\n2512.6 \"Exaflare\" # Cosmetic\r\n2513.7 \"Dry Ice\"\r\n2515.7 \"Exaflare\"\r\n2518.6 \"Exaflare\"\r\n2520.8 \"Akh Morn\"\r\n2521.7 \"Exaflare\"\r\n\r\n##################################\r\n## Branches A1/B1 converge back ##\r\n##################################\r\n\r\n3502.3 \"Time Immemorial\" Ability { id: \"32EF\", source: \"Midgardsormr\" }\r\n3512.6 \"Exaflare\"\r\n3513.7 \"Dry Ice\" Ability { id: \"3631\", source: \"Midgardsormr\" }\r\n3515.7 \"Exaflare\"\r\n3518.6 \"Exaflare\"\r\n3520.8 \"Akh Morn\" Ability { id: \"31AB\", source: \"Midgardsormr\" }\r\n3521.7 \"Exaflare\"\r\n3524.7 \"Exaflare\"\r\n\r\n##################\r\n## Branch point ##\r\n##################\r\n\r\n3536.8 \"Flip/Spin\" Ability { id: \"31AC\", source: \"Midgardsormr\" } jump 4536.8 # C means spin->shaker\r\n3536.8 \"--sync--\" Ability { id: \"31AD\", source: \"Midgardsormr\" } jump 5536.8 # D means flip->thunder\r\n3545.9 \"Northern Cross\" # Cosmetic\r\n3550.1 \"Spin/Flip\"\r\n3553.6 \"Position\"\r\n3553.6 \"Shaker/Thunder\"\r\n\r\n## Branch A2: Spin->Earthshaker\r\n4536.8 \"Spin\" Ability { id: \"31AC\", source: \"Midgardsormr\" }\r\n4545.9 \"Northern Cross\" Ability { id: \"3625\", source: \"Midgardsormr\" }\r\n4550.1 \"Spin/Flip\" Ability { id: \"31AE\", source: \"Midgardsormr\" }\r\n4553.6 \"In/Out\" Ability { id: \"31B(2|4)\", source: \"Midgardsormr\" }\r\n4553.6 \"Earth Shaker\" Ability { id: \"31B6\", source: \"Midgardsormr\" }\r\n4562.3 \"Horrid Roar\" Ability { id: \"31B9\", source: \"Midgardsormr\" } jump 6562.3\r\n4573.4 \"Akh Rhai\" # Cosmetic\r\n4579.6 \"Tail End\"\r\n4587.9 \"Flip/Spin\"\r\n\r\n## Branch B2: Flip->Thunderstorm\r\n5536.8 \"Flip\" Ability { id: \"31AD\", source: \"Midgardsormr\" }\r\n5545.9 \"Northern Cross\" Ability { id: \"3625\", source: \"Midgardsormr\" }\r\n5550.1 \"Spin/Flip\" Ability { id: \"31AE\", source: \"Midgardsormr\" }\r\n5553.6 \"Corners/Cardinals\" Ability { id: \"31B(3|5)\", source: \"Midgardsormr\" }\r\n5555.1 \"Thunderstorm\" Ability { id: \"31B8\", source: \"Midgardsormr\" }\r\n5562.3 \"Horrid Roar\" Ability { id: \"31B9\", source: \"Midgardsormr\" } jump 6562.3\r\n5573.4 \"Akh Rhai\" # Cosmetic\r\n5579.6 \"Tail End\"\r\n5587.9 \"Flip/Spin\"\r\n\r\n##################################\r\n## Branches A2/B2 converge back ##\r\n##################################\r\n\r\n6562.3 \"Horrid Roar\" Ability { id: \"31B9\", source: \"Midgardsormr\" }\r\n6573.4 \"Akh Rhai\" Ability { id: \"3622\", source: \"Midgardsormr\" }\r\n6579.6 \"Tail End\" Ability { id: \"31AA\", source: \"Midgardsormr\" } # drift 0.026\r\n\r\n##################\r\n## Branch point ##\r\n##################\r\n\r\n# Return to A1/B1\r\n6587.9 \"Flip/Spin\" Ability { id: \"31AC\", source: \"Midgardsormr\" } jump 1474.4 # C means spin->shaker\r\n6587.9 \"--sync--\" Ability { id: \"31AD\", source: \"Midgardsormr\" } jump 2474.4 # D means flip->thunder\r\n6598.0 \"Tail End\" # Cosmetic\r\n6600.1 \"Flip/Spin\"\r\n6604.1 \"Signal?\"\r\n6605.6 \"Position?\"\r\n6615.8 \"Time Immemorial\"\r\n\r\n# Enrage\r\n6700.0 \"--sync--\" StartsUsing { id: \"3247\", source: \"Midgardsormr\" } window 6700,3000\r\n6704.9 \"Enrage Hit 1\"\r\n6707.2 \"Enrage Hit 2\"\r\n6708.5 \"Enrage Hit 3\"\r\n6709.8 \"Enrage Hit 4\"\r\n6711.1 \"Enrage Hit 5\"\r\n6712.2 \"Enrage Hit 6\"\r\n6713.3 \"Enrage Hit 7\"\r\n6714.4 \"Enrage Hit 8\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o11n.ts



// O11N - Alphascape 3.0
const o11n_triggerSet = {
  id: 'AlphascapeV30',
  zoneId: zone_id/* default.AlphascapeV30 */.Z.AlphascapeV30,
  timelineFile: 'o11n.txt',
  timelineTriggers: [{
    id: 'O11N Blaster',
    regex: /Blaster/,
    beforeSeconds: 3,
    condition: data => data.role === 'tank' || data.job === 'BLU',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank Tether',
        de: 'Tank Verbindung',
        fr: 'Lien tank',
        ja: 'タンク 線を取る',
        cn: '坦克接线远离人群',
        ko: '탱 블래스터 징'
      }
    }
  }],
  triggers: [{
    id: 'O11N Atomic Ray',
    type: 'StartsUsing',
    netRegex: {
      id: '3286',
      source: 'Omega',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O11N Mustard Bomb',
    type: 'StartsUsing',
    netRegex: {
      id: '3287',
      source: 'Omega'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster('alarm')
  }, {
    // Ability IDs:
    // Starboard 1: 3281
    // Starboard 2: 3282
    // Larboard 1: 3283
    // Larboard 2: 3284
    // For the cannons, match #1 and #2 for the first one.  This is so
    // that if a log entry for the first is dropped for some reason, it
    // will at least say left/right for the second.
    id: 'O11N Cannon Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '328[13]',
      source: 'Omega',
      capture: false
    },
    delaySeconds: 15,
    run: data => delete data.lastWasStarboard
  }, {
    id: 'O11N Starboard Cannon 1',
    type: 'StartsUsing',
    netRegex: {
      id: '328[12]',
      source: 'Omega',
      capture: false
    },
    condition: data => data.lastWasStarboard === undefined,
    response: responses/* Responses.goLeft */.n3.goLeft(),
    run: data => data.lastWasStarboard = true
  }, {
    id: 'O11N Larboard Cannon 1',
    type: 'StartsUsing',
    netRegex: {
      id: '328[34]',
      source: 'Omega',
      capture: false
    },
    condition: data => data.lastWasStarboard === undefined,
    response: responses/* Responses.goRight */.n3.goRight(),
    run: data => data.lastWasStarboard = false
  }, {
    id: 'O11N Starboard Cannon 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3282',
      source: 'Omega',
      capture: false
    },
    condition: data => data.lastWasStarboard !== undefined,
    alertText: (data, _matches, output) => {
      if (data.lastWasStarboard) return output.moveLeft();
      return output.stayLeft();
    },
    outputStrings: {
      moveLeft: {
        en: 'Move (Left)',
        de: 'Bewegen (Links)',
        fr: 'Bougez (À gauche)',
        ja: '動け (左へ)',
        cn: '去左边',
        ko: '이동 (왼쪽)'
      },
      stayLeft: {
        en: 'Stay (Left)',
        de: 'Stehenbleiben (Links)',
        fr: 'Restez (À gauche)',
        ja: 'そのまま (左に)',
        cn: '呆在左边',
        ko: '멈추기 (왼쪽)'
      }
    }
  }, {
    id: 'O11N Larboard Cannon 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3284',
      source: 'Omega',
      capture: false
    },
    condition: data => data.lastWasStarboard !== undefined,
    alertText: (data, _matches, output) => {
      if (data.lastWasStarboard) return output.stayRight();
      return output.moveRight();
    },
    outputStrings: {
      stayRight: {
        en: 'Stay (Right)',
        de: 'Stehenbleiben (Rechts)',
        fr: 'Restez (À droite)',
        ja: 'そのまま (右に)',
        cn: '呆在右边',
        ko: '멈추기 (오른쪽)'
      },
      moveRight: {
        en: 'Move (Right)',
        de: 'Bewegen (Rechts)',
        fr: 'Bougez (À droite)',
        ja: '動け (右へ)',
        cn: '去右边',
        ko: '이동 (오른쪽)'
      }
    }
  }, {
    id: 'O11N Ballistic Missile',
    type: 'HeadMarker',
    netRegex: {
      id: '0065'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Fire Outside',
        de: 'Feuer draußen ablegen',
        fr: 'Déposez le feu à l\'extérieur',
        cn: '把火放在外面',
        ko: '불 장판 바깥으로 유도'
      }
    }
  }, {
    id: 'O11N Electric Slide',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'O11N Delta Attack',
    type: 'StartsUsing',
    netRegex: {
      id: '327B',
      source: 'Omega',
      capture: false
    },
    delaySeconds: 3,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Use duty action on Conductive Focus',
        de: 'Benutze Spezialkommando auf "Ziel des Blitzstrahls"',
        fr: 'Utilisez l\'action spéciale sur le Point de convergence électrique',
        cn: '在雷力投射点上使用任务指令',
        ko: '뇌력 투사 지점에 교란기 사용'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Engaging Delta Attack protocol': 'Reinitialisiere Deltaprotokoll',
      'Level Checker': 'Monitor',
      'Omega': 'Omega',
      'Program failure detected': '<biep> Programmfehler registriert.',
      'Rocket Punch': 'Raketenschlag'
    },
    'replaceText': {
      'Atomic Ray': 'Atomstrahlung',
      'Ballistic Impact': 'Ballistischer Einschlag',
      'Ballistic Missile': 'Ballistische Rakete',
      'Blaster': 'Blaster',
      'Delta Attack': 'Delta-Attacke',
      'Electric Slide': 'Elektrosturz',
      'Executable': 'Programmstart',
      'Flamethrower': 'Flammenwerfer',
      'Force Quit': 'Erzwungenes Herunterfahren',
      'Mustard Bomb': 'Senfbombe',
      'Peripheral Synthesis': 'Ausdrucken',
      'Program Loop': 'Programmschleife',
      'Reformat': 'Optimierung',
      'Reset': 'Zurücksetzen',
      'Rush': 'Stürmen',
      'Starboard/Larboard Cannon': 'Steuerbord/Backbord Kanone'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Engaging Delta Attack protocol': 'Nécessité d\'utiliser l\'attaque Delta',
      'Level Checker': 'vérifiniveau',
      'Omega': 'Oméga',
      'Program failure detected': 'Arrêt de la boucle de programme Alpha...',
      'Rocket Punch': 'Astéropoing'
    },
    'replaceText': {
      '\\?': ' ?',
      'Atomic Ray': 'Rayon atomique',
      'Ballistic Impact': 'Impact de missile',
      'Ballistic Missile': 'Tir de missile',
      'Blaster': 'Électrochoc',
      'Delta Attack': 'Attaque Delta',
      'Electric Slide': 'Glissement Oméga',
      'Executable': 'Exécution de programme',
      'Flamethrower': 'Lance-flammes',
      'Force Quit': 'Interruption forcée',
      'Mustard Bomb': 'Obus d\'ypérite',
      'Peripheral Synthesis': 'Impression',
      'Program Loop': 'Boucle de programme',
      'Reformat': 'Optimisation',
      'Reset': 'Réinitialisation',
      'Rush': 'Ruée',
      'Starboard/Larboard Cannon': 'Tribord/Bâbord'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Engaging Delta Attack protocol': 'デルタアタックの必要性を認定します',
      'Level Checker': 'レベルチェッカー',
      'Omega': 'オメガ',
      'Program failure detected': 'サークルプログラム・アルファの失敗を確認……',
      'Rocket Punch': 'ロケットパンチ'
    },
    'replaceText': {
      'Atomic Ray': 'アトミックレイ',
      'Ballistic Impact': 'ミサイル着弾',
      'Ballistic Missile': 'ミサイル発射',
      'Blaster': 'ブラスター',
      'Delta Attack': 'デルタアタック',
      'Electric Slide': 'オメガスライド',
      'Executable': 'プログラム実行',
      'Flamethrower': '火炎放射',
      'Force Quit': '強制終了',
      'Mustard Bomb': 'マスタードボム',
      'Peripheral Synthesis': 'プリントアウト',
      'Program Loop': 'サークルプログラム',
      'Reformat': '最適化',
      'Reset': '初期化',
      'Rush': '突進',
      'Starboard/Larboard Cannon': '右舷/左舷・波動砲'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Engaging Delta Attack protocol': '认定有必要使用三角攻击。',
      'Level Checker': '等级检测仪',
      'Omega': '欧米茄',
      'Program failure detected': '确认到循环程序·阿尔法启动失败……',
      'Rocket Punch': '火箭飞拳'
    },
    'replaceText': {
      'Atomic Ray': '原子射线',
      'Ballistic Impact': '导弹命中',
      'Ballistic Missile': '导弹发射',
      'Blaster': '冲击波',
      'Delta Attack': '三角攻击',
      'Electric Slide': '欧米茄滑跃',
      'Executable': '运行程序',
      'Flamethrower': '火焰喷射器',
      'Force Quit': '强制结束',
      'Mustard Bomb': '芥末爆弹',
      'Peripheral Synthesis': '生成外设',
      'Program Loop': '循环程序',
      'Reformat': '最优化',
      'Reset': '初始化',
      'Rush': '突进',
      'Starboard/Larboard Cannon': '右/左舷齐射·波动炮'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Engaging Delta Attack protocol': '델타 공격의 필요성을 인정합니다',
      'Level Checker': '레벨 측정기',
      'Omega': '오메가',
      'Program failure detected': '순환 프로그램 알파 실패 확인…….',
      'Rocket Punch': '로켓 주먹'
    },
    'replaceText': {
      'Atomic Ray': '원자 파동',
      'Ballistic Impact': '미사일 착탄',
      'Ballistic Missile': '미사일 발사',
      'Blaster': '블래스터',
      'Delta Attack': '델타 공격',
      'Electric Slide': '오메가 슬라이드',
      'Executable': '프로그램 실행',
      'Flamethrower': '화염 방사',
      'Force Quit': '강제 종료',
      'Mustard Bomb': '겨자 폭탄',
      'Peripheral Synthesis': '출력',
      'Program Loop': '순환 프로그램',
      'Reformat': '최적화',
      'Reset': '초기화',
      'Rush': '돌진',
      'Starboard/Larboard Cannon': '좌/우현 사격 파동포'
    }
  }]
};
/* harmony default export */ const o11n = (o11n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o11n.txt
const raid_o11n_namespaceObject = "# Omega - Alphascape V3.0 - O11N\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n## Common start\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n12.8 \"Atomic Ray\" Ability { id: \"3286\", source: \"Omega\" } window 20,80\r\n24.9 \"Mustard Bomb\" Ability { id: \"3287\", source: \"Omega\" }\r\n27.0 \"Ballistic Missile?\" Ability { id: \"327E\", source: \"Omega\" } window 30,40 jump 2227\r\n37.1 \"Flamethrower?\"\r\n38.1 \"Starboard/Larboard Cannon?\" Ability { id: \"328[13]\", source: \"Omega\" } window 40,40 jump 1138.1\r\n43.8 \"Starboard/Larboard Cannon?\"\r\n\r\n## Starboard/Larboard first path\r\n1138.1 \"Starboard/Larboard Cannon\" Ability { id: \"328[13]\", source: \"Omega\" }\r\n1143.8 \"Starboard/Larboard Cannon\" Ability { id: \"328[24]\", source: \"Omega\" }\r\n1146.5 \"Ballistic Missile\" Ability { id: \"327E\", source: \"Omega\" }\r\n1156.7 \"Flamethrower\" Ability { id: \"327D\", source: \"Omega\" }\r\n1156.7 \"Ballistic Impact\" Ability { id: \"327F\", source: \"Omega\" }\r\n1167.8 \"Mustard Bomb\" Ability { id: \"3287\", source: \"Omega\" } # drift 0.044\r\n1178.7 \"Peripheral Synthesis\" Ability { id: \"3270\", source: \"Omega\" } window 50,10 jump 2478.7\r\n1203.5 \"Peripheral Synthesis\"\r\n1217.6 \"Flamethrower\"\r\n1227.8 \"Atomic Ray\"\r\n\r\n## Ballistic Missile first path\r\n2227.0 \"Ballistic Missile\" Ability { id: \"327E\", source: \"Omega\" }\r\n2237.1 \"Flamethrower\" Ability { id: \"327D\", source: \"Omega\" }\r\n2237.1 \"Ballistic Impact\" Ability { id: \"327F\", source: \"Omega\" }\r\n2248.2 \"Mustard Bomb\" Ability { id: \"3287\", source: \"Omega\" }\r\n2261.4 \"Starboard/Larboard Cannon\" Ability { id: \"328[13]\", source: \"Omega\" }\r\n2267.0 \"Starboard/Larboard Cannon\" Ability { id: \"328[24]\", source: \"Omega\" }\r\n2278.7 \"Peripheral Synthesis\" Ability { id: \"3270\", source: \"Omega\" } window 50,10 jump 2478.7\r\n2303.5 \"Peripheral Synthesis\"\r\n2317.6 \"Flamethrower\"\r\n2327.8 \"Atomic Ray\"\r\n\r\n## Paths converge\r\n2478.7 \"Peripheral Synthesis\" Ability { id: \"3270\", source: \"Omega\" }\r\n2503.5 \"Peripheral Synthesis\" Ability { id: \"3270\", source: \"Omega\" }\r\n2517.6 \"Flamethrower\" Ability { id: \"327D\", source: \"Omega\" }\r\n2527.8 \"Atomic Ray\" Ability { id: \"3286\", source: \"Omega\" }\r\n\r\n## Midphase\r\n2534.5 \"Program Loop\" Ability { id: \"3273\", source: \"Omega\" } window 150,150\r\n2534.5 \"--untargetable--\"\r\n2549.6 \"Executable 1\" Ability { id: \"35A8\", source: \"Level Checker\" }\r\n2570.6 \"Executable 2\" Ability { id: \"35A8\", source: \"Level Checker\" }\r\n2574.6 \"Reset\" Ability { id: \"35AA\", source: \"Level Checker\" }\r\n2578.6 \"Reformat\" Ability { id: \"35A9\", source: \"Level Checker\" }\r\n2587.6 \"--sync--\" StartsUsing { id: \"327A\", source: \"Level Checker\" }\r\n2611.6 \"Force Quit\" Ability { id: \"327A\", source: \"Level Checker\" }\r\n\r\n## Delta Attack\r\n# https://xivapi.com/InstanceContentTextData/20109\r\n# en: Program failure detected. <blip> Engaging Delta Attack protocol.\r\n# Note: This BattleTalk2 log line arrives in sequence with another, both with a 4000ms display time.\r\n# As a result, this line shows up 4000ms before the message is displayed (and the GameLog line is emitted).\r\n2996.0 \"--sync--\" BattleTalk2 { instanceContentTextId: \"4E8D\" } window 2996,100\r\n3007.0 \"--sync--\" StartsUsing { id: \"327B\", source: \"Omega\" } window 3007,100\r\n3037.0 \"Delta Attack\" Ability { id: \"327B\", source: \"Omega\" } window 3037,100\r\n3048.4 \"--targetable--\"\r\n\r\n## Loop\r\n3060.3 \"Peripheral Synthesis\" Ability { id: \"3270\", source: \"Omega\" } window 10,10\r\n3070.5 \"Flamethrower\" Ability { id: \"327D\", source: \"Omega\" }\r\n3072.9 \"Rush\" Ability { id: \"359C\", source: \"Rocket Punch\" }\r\n3078.7 \"Peripheral Synthesis\" Ability { id: \"3270\", source: \"Omega\" }\r\n3081.8 \"Ballistic Missile\" Ability { id: \"327E\", source: \"Omega\" }\r\n3091.3 \"Rush\" Ability { id: \"359C\", source: \"Rocket Punch\" } # drift -0.041999\r\n3091.9 \"Ballistic Impact\" Ability { id: \"327F\", source: \"Omega\" }\r\n3101.0 \"Electric Slide\" Ability { id: \"3285\", source: \"Omega\" }\r\n3115.3 \"Mustard Bomb\" Ability { id: \"3287\", source: \"Omega\" }\r\n3117.6 \"Blaster\" Ability { id: \"3280\", source: \"Omega\" }\r\n3127.7 \"Starboard/Larboard Cannon\" Ability { id: \"328[13]\", source: \"Omega\" }\r\n3133.4 \"Starboard/Larboard Cannon\" Ability { id: \"328[24]\", source: \"Omega\" }\r\n3140.1 \"Atomic Ray\" Ability { id: \"3286\", source: \"Omega\" }\r\n3150.3 \"Peripheral Synthesis\" Ability { id: \"3270\", source: \"Omega\" } # drift 0.046\r\n3163.0 \"Rush\" Ability { id: \"359C\", source: \"Rocket Punch\" }\r\n3175.1 \"Peripheral Synthesis\" Ability { id: \"3270\", source: \"Omega\" }\r\n3185.3 \"Flamethrower\" Ability { id: \"327D\", source: \"Omega\" }\r\n3187.6 \"Rush\" Ability { id: \"359C\", source: \"Rocket Punch\" }\r\n3196.4 \"Atomic Ray\" Ability { id: \"3286\", source: \"Omega\" }\r\n3204.5 \"Ballistic Missile\" Ability { id: \"327E\", source: \"Omega\" } # drift 0.042\r\n3214.6 \"Flamethrower\" Ability { id: \"327D\", source: \"Omega\" }\r\n3214.6 \"Ballistic Impact\" Ability { id: \"327F\", source: \"Omega\" }\r\n3221.7 \"Starboard/Larboard Cannon\" Ability { id: \"328[13]\", source: \"Omega\" }\r\n3227.3 \"Starboard/Larboard Cannon\" Ability { id: \"328[24]\", source: \"Omega\" }\r\n3237.1 \"Peripheral Synthesis\" Ability { id: \"3270\", source: \"Omega\" }\r\n3249.8 \"Rush\" Ability { id: \"359C\", source: \"Rocket Punch\" }\r\n3255.6 \"Electric Slide\" Ability { id: \"3285\", source: \"Omega\" } # drift -0.049\r\n3262.7 \"Starboard/Larboard Cannon\" Ability { id: \"328[13]\", source: \"Omega\" }\r\n3268.4 \"Starboard/Larboard Cannon\" Ability { id: \"328[24]\", source: \"Omega\" }\r\n3275.0 \"Atomic Ray\" Ability { id: \"3286\", source: \"Omega\" } # drift 0.042999\r\n3290.3 \"Mustard Bomb\" Ability { id: \"3287\", source: \"Omega\" }\r\n3303.5 \"Mustard Bomb\" Ability { id: \"3287\", source: \"Omega\" }\r\n3305.6 \"Blaster\" Ability { id: \"3280\", source: \"Omega\" } # drift 0.046001\r\n3314.8 \"Atomic Ray\" Ability { id: \"3286\", source: \"Omega\" }\r\n3320.9 \"Atomic Ray\" Ability { id: \"3286\", source: \"Omega\" }\r\n\r\n# Loop lookahead\r\n3334.2 \"Peripheral Synthesis\" Ability { id: \"3270\", source: \"Omega\" } window 50,50 jump 3060.3\r\n3344.4 \"Flamethrower\"\r\n3346.8 \"Rush\"\r\n3352.6 \"Peripheral Synthesis\"\r\n3355.7 \"Ballistic Missile\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o11s.ts


// O11S - Alphascape 3.0 Savage
const o11s_triggerSet = {
  id: 'AlphascapeV30Savage',
  zoneId: zone_id/* default.AlphascapeV30Savage */.Z.AlphascapeV30Savage,
  timelineFile: 'o11s.txt',
  triggers: [{
    id: 'O11S Mustard Bomb',
    type: 'StartsUsing',
    netRegex: {
      id: '326D',
      source: 'Omega'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster('alarm')
  }, {
    // Ability IDs:
    // Starboard 1: 3262
    // Starboard 2: 3263
    // Larboard 1: 3264
    // Larboard 2: 3265
    // For the cannons, match #1 and #2 for the first one.  This is so
    // that if a log entry for the first is dropped for some reason, it
    // will at least say left/right for the second.
    id: 'O11S Cannon Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '326[24]',
      source: 'Omega',
      capture: false
    },
    delaySeconds: 15,
    run: data => delete data.lastWasStarboard
  }, {
    id: 'O11S Starboard Cannon 1',
    type: 'StartsUsing',
    netRegex: {
      id: '326[23]',
      source: 'Omega',
      capture: false
    },
    condition: data => data.lastWasStarboard === undefined,
    response: responses/* Responses.goLeft */.n3.goLeft(),
    run: data => data.lastWasStarboard = true
  }, {
    id: 'O11S Larboard Cannon 1',
    type: 'StartsUsing',
    netRegex: {
      id: '326[45]',
      source: 'Omega',
      capture: false
    },
    condition: data => data.lastWasStarboard === undefined,
    response: responses/* Responses.goRight */.n3.goRight(),
    run: data => data.lastWasStarboard = false
  }, {
    id: 'O11S Starboard Cannon 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3263',
      source: 'Omega',
      capture: false
    },
    condition: data => data.lastWasStarboard !== undefined,
    alertText: (data, _matches, output) => {
      if (data.lastWasStarboard) return output.moveLeft();
      return output.stayLeft();
    },
    outputStrings: {
      moveLeft: {
        en: 'Move (Left)',
        de: 'Bewegen (Links)',
        fr: 'Bougez (À gauche)',
        ja: '反対へ (左)',
        cn: '移动 (左)',
        ko: '오른쪽으로'
      },
      stayLeft: {
        en: 'Stay (Left)',
        de: 'Stehenbleiben (Links)',
        fr: 'Restez (À gauche)',
        ja: 'そのまま (左)',
        cn: '不动 (左)',
        ko: '대기 (오른쪽)'
      }
    }
  }, {
    id: 'O11S Larboard Cannon 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3265',
      source: 'Omega',
      capture: false
    },
    condition: data => data.lastWasStarboard !== undefined,
    alertText: (data, _matches, output) => {
      if (data.lastWasStarboard) return output.stayRight();
      return output.moveRight();
    },
    outputStrings: {
      stayRight: {
        en: 'Stay (Right)',
        de: 'Stehenbleiben (Rechts)',
        fr: 'Restez (À droite)',
        ja: 'そのまま (右)',
        cn: '不动 (右)',
        ko: '대기 (왼쪽)'
      },
      moveRight: {
        en: 'Move (Right)',
        de: 'Bewegen (Rechts)',
        fr: 'Bougez (À droite)',
        ja: '反対へ (右)',
        cn: '移动 (右)',
        ko: '왼쪽으로'
      }
    }
  }, {
    id: 'O11S Starboard Surge 1',
    type: 'StartsUsing',
    netRegex: {
      id: '3266',
      source: 'Omega',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Left (then opposite)',
        de: 'Links (dann umgekehrt)',
        fr: 'À gauche (puis à l\'opposée)',
        ja: '左 (零式)',
        cn: '左 (零式)',
        ko: '왼쪽으로 (바로 반대로)'
      }
    }
  }, {
    id: 'O11S Larboard Surge 1',
    type: 'StartsUsing',
    netRegex: {
      id: '3268',
      source: 'Omega',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Right (then opposite)',
        de: 'Rechts (dann umgekehrt)',
        fr: 'À droite (puis à l\'opposée)',
        ja: '右 (零式)',
        cn: '右 (零式)',
        ko: '오른쪽으로 (바로 반대로)'
      }
    }
  }, {
    id: 'O11S Starboard Surge 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3266',
      source: 'Omega',
      capture: false
    },
    delaySeconds: 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Opposite (Left)',
        de: 'Umgekehrt (Links)',
        fr: 'À l\'opposée (À gauche)',
        ja: '反対へ (左)',
        cn: '对面 (左)',
        ko: '오른쪽으로'
      }
    }
  }, {
    id: 'O11S Larboard Surge 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3268',
      source: 'Omega',
      capture: false
    },
    delaySeconds: 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Opposite (Right)',
        de: 'Umgekehrt (Rechts)',
        fr: 'À l\'opposée (À droite)',
        ja: '反対へ (右)',
        cn: '对面 (右)',
        ko: '왼쪽으로'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Level Checker': 'Monitor',
      'Omega': 'Omega',
      'Rocket Punch': 'Raketenschlag'
    },
    'replaceText': {
      'Afterburner': 'Nachbrenner',
      'Atomic Ray': 'Atomstrahlung',
      'Ballistic Impact': 'Ballistischer Einschlag',
      'Ballistic Missile': 'Ballistische Rakete',
      'Blaster': 'Blaster',
      'Charybdis': 'Charybdis',
      'Condensed Wave Cannon Kyrios': 'Hochleistungswellenkanone P',
      'Delta Attack': 'Delta-Attacke',
      'Diffuse Wave Cannon Kyrios': 'Streuende Wellenkanone P',
      'Dual Storage Violation': 'Speicherverletzung P',
      'Electric Slide': 'Elektrosturz',
      'Executable': 'Programmstart',
      'Ferrofluid': 'Ferrofluid',
      'Flamethrower': 'Flammenwerfer',
      'Force Quit': 'Erzwungenes Herunterfahren',
      'Guided Missile Kyrios': 'Lenkrakete P',
      'Long Needle Kyrios': 'Großes Kaliber P',
      '(?<! )Loop': 'Schleife',
      'Magnetism': 'Magnetismus',
      'Mustard Bomb': 'Senfbombe',
      'Pantokrator': 'Pantokrator',
      'Peripheral Synthesis': 'Ausdrucken',
      'Program Loop': 'Programmschleife',
      'Reformat': 'Optimierung',
      'Repel': 'Repulsion',
      'Reset': 'Zurücksetzen',
      'Rush': 'Stürmen',
      'Starboard/Larboard Cannon': 'Steuerbord/Backbord Kanone',
      'Starboard/Larboard Surge': 'Steuerbord/Backbord Strahl',
      '(?<! )Storage Violation': 'Speicherverletzung S',
      'Unmitigated Explosion': 'Detonation',
      'Update Program': 'Programmschleifen-Update',
      '(?<! )Wave Cannon Kyrios': 'Wellenkanone P'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Level Checker': 'vérifiniveau',
      'Omega': 'Oméga',
      'Rocket Punch': 'Astéropoing'
    },
    'replaceText': {
      'Afterburner': 'Postcombustion',
      'Atomic Ray': 'Rayon atomique',
      'Ballistic Impact': 'Impact de missile',
      'Ballistic Missile': 'Tir de missile',
      'Blaster': 'Électrochoc',
      'Charybdis': 'Charybde',
      'Condensed Wave Cannon Kyrios': 'Canon plasma surchargé P',
      'Delta Attack': 'Attaque Delta',
      'Diffuse Wave Cannon Kyrios': 'Canon plasma diffuseur P',
      'Dual Storage Violation': 'Corruption de données P',
      'Electric Slide': 'Glissement Oméga',
      'Executable': 'Exécution de programme',
      'Ferrofluid': 'Ferrofluide',
      'Flamethrower': 'Lance-flammes',
      'Force Quit': 'Interruption forcée',
      'Guided Missile Kyrios': 'Missile guidé P',
      'Long Needle Kyrios': 'Gros missile P',
      '(?<! )Loop': 'Boucle',
      'Magnetism': 'Magnétisme',
      'Mustard Bomb': 'Obus d\'ypérite',
      'Pantokrator': 'Pantokrator',
      'Peripheral Synthesis': 'Impression',
      'Program Loop': 'Boucle de programme',
      'Reformat': 'Optimisation',
      'Repel': 'Répulsion',
      'Reset': 'Réinitialisation',
      'Rush': 'Ruée',
      'Starboard/Larboard Cannon': 'Canon à tribord/bâbord',
      'Starboard/Larboard Surge': 'Canon à tribord/bâbord',
      '(?<! )Storage Violation': 'Corruption de données S',
      'Unmitigated Explosion': 'Grosse explosion',
      'Update Program': 'Boucle de programme : mise à jour',
      '(?<! )Wave Cannon Kyrios': 'Canon plasma P'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Level Checker': 'レベルチェッカー',
      'Omega': 'オメガ',
      'Rocket Punch': 'ロケットパンチ'
    },
    'replaceText': {
      'Afterburner': 'アフターバーナー',
      'Atomic Ray': 'アトミックレイ',
      'Ballistic Impact': 'ミサイル着弾',
      'Ballistic Missile': 'ミサイル発射',
      'Blaster': 'ブラスター',
      'Charybdis': 'ミールストーム',
      'Condensed Wave Cannon Kyrios': '高出力波動砲P',
      'Delta Attack': 'デルタアタック',
      'Diffuse Wave Cannon Kyrios': '拡散波動砲P',
      'Dual Storage Violation': '記憶汚染除去P',
      'Electric Slide': 'オメガスライド',
      'Executable': 'プログラム実行',
      'Ferrofluid': 'マグネット',
      'Flamethrower': '火炎放射',
      'Force Quit': '強制終了',
      'Guided Missile Kyrios': '誘導ミサイルP',
      'Long Needle Kyrios': '大型ミサイルP',
      '(?<! )Loop': 'サークル',
      'Magnetism': '磁力',
      'Mustard Bomb': 'マスタードボム',
      'Pantokrator': 'パントクラトル',
      'Peripheral Synthesis': 'プリントアウト',
      'Program Loop': 'サークルプログラム',
      'Reformat': '最適化',
      'Repel': '反発',
      'Reset': '初期化',
      'Rush': '突進',
      'Starboard/Larboard Cannon': '右舷/左舷・波動砲',
      'Starboard/Larboard Surge': '右舷/左舷・零式波動砲',
      '(?<! )Storage Violation': '記憶汚染除去S',
      'Unmitigated Explosion': '大爆発',
      'Update Program': 'サークルプログラム更新',
      '(?<! )Wave Cannon Kyrios': '波動砲P'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Level Checker': '等级检测仪',
      'Omega': '欧米茄',
      'Rocket Punch': '火箭飞拳'
    },
    'replaceText': {
      'Afterburner': '燃烧室排热',
      'Atomic Ray': '原子射线',
      'Ballistic Impact': '导弹命中',
      'Ballistic Missile': '导弹发射',
      'Blaster': '冲击波',
      'Charybdis': '大漩涡',
      'Condensed Wave Cannon Kyrios': '大功率波动炮P',
      'Delta Attack': '三角攻击',
      'Diffuse Wave Cannon Kyrios': '扩散波动炮P',
      'Dual Storage Violation': '清除记忆污染P',
      'Electric Slide': '欧米茄滑跃',
      'Executable': '运行程序',
      'Ferrofluid': '磁铁',
      'Flamethrower': '火炎放射',
      'Force Quit': '强制结束',
      'Guided Missile Kyrios': '跟踪导弹P',
      'Long Needle Kyrios': '大型导弹P',
      '(?<! )Loop': '空翻',
      'Magnetism': '磁力',
      'Mustard Bomb': '芥末爆弹',
      'Pantokrator': '全能之主',
      'Peripheral Synthesis': '生成外设',
      'Program Loop': '循环程序',
      'Reformat': '最优化',
      'Repel': '相斥',
      'Reset': '初始化',
      'Rush': '突进',
      'Starboard/Larboard Cannon': '右/左舷齐射·波动炮',
      'Starboard/Larboard Surge': '右/左舷齐射·零式波动炮',
      '(?<! )Storage Violation': '清除记忆污染S',
      'Unmitigated Explosion': '大爆炸',
      'Update Program': '更新循环程序',
      '(?<! )Wave Cannon Kyrios': '波动炮P'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Level Checker': '레벨 측정기',
      'Omega': '오메가',
      'Rocket Punch': '로켓 주먹'
    },
    'replaceText': {
      'Afterburner': '재연소 장치',
      'Atomic Ray': '원자 파동',
      'Ballistic Impact': '미사일 착탄',
      'Ballistic Missile': '미사일 발사',
      'Blaster': '블래스터',
      'Charybdis': '대소용돌이',
      'Condensed Wave Cannon Kyrios': '고출력 파동포 P',
      'Delta Attack': '델타 공격',
      'Diffuse Wave Cannon Kyrios': '확산 파동포 P',
      'Dual Storage Violation': '기억 오염 제거 P',
      'Electric Slide': '오메가 슬라이드',
      'Executable': '프로그램 실행',
      'Ferrofluid': '자석',
      'Flamethrower': '화염방사',
      'Force Quit': '강제 종료',
      'Guided Missile Kyrios': '유도 미사일 P',
      'Long Needle Kyrios': '대형 미사일 P',
      '(?<! )Loop': '순환',
      'Magnetism': '자력',
      'Mustard Bomb': '겨자 폭탄',
      'Pantokrator': '전지전능',
      'Peripheral Synthesis': '출력',
      'Program Loop': '순환 프로그램',
      'Reformat': '최적화',
      'Repel': '반발',
      'Reset': '초기화',
      'Rush': '돌진',
      'Starboard/Larboard Cannon': '좌/우현 파동포',
      'Starboard/Larboard Surge': '좌/우현 0식 파동포',
      '(?<! )Storage Violation': '기억 오염 제거 S',
      'Unmitigated Explosion': '대폭발',
      'Update Program': '프로그램 업데이트',
      '(?<! )Wave Cannon Kyrios': '파동포 P'
    }
  }]
};
/* harmony default export */ const o11s = (o11s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o11s.txt
const raid_o11s_namespaceObject = "# Omega - Alphascape V3.0 (Savage) - O11S\r\n# -ii 2799 3608 3703 370D 325D 36FF 3708 370B 370A 3707 3705\r\n# -p 325B:310 326C:12.0\r\n# -it \"Omega\" / -it \"Level Checker\"\r\n# manually add in flamethrower during panto #2, diffuse wave cannon, panto ballistic impact\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n8.0 \"--sync--\" StartsUsing { id: \"326C\", source: \"Omega\" } window 8,8\r\n12.0 \"Atomic Ray\" Ability { id: \"326C\", source: \"Omega\" }\r\n24.0 \"Mustard Bomb\" Ability { id: \"326D\", source: \"Omega\" }\r\n30.0 \"Flamethrower\" Ability { id: \"325C\", source: \"Omega\" }\r\n32.0 \"Afterburner\" Ability { id: \"325E\", source: \"Omega\" }\r\n39.5 \"Starboard/Larboard Cannon\" Ability { id: \"326[24]\", source: \"Omega\" }\r\n45.0 \"Starboard/Larboard Cannon\" Ability { id: \"326[35]\", source: \"Omega\" }\r\n# Note: this looks like it can push early.\r\n53.5 \"--sync--\" StartsUsing { id: \"324A\", source: \"Omega\" } window 60,10\r\n56.5 \"Peripheral Synthesis\" Ability { id: \"324A\", source: \"Omega\" }\r\n72.5 \"Mustard Bomb\" Ability { id: \"326D\", source: \"Omega\" }\r\n\r\n### Phase 2: Tower Dance\r\n87.5 \"--sync--\" StartsUsing { id: \"3251\", source: \"Omega\" } window 90,10\r\n91.5 \"--untargetable--\"\r\n91.5 \"Program Loop\" Ability { id: \"3251\", source: \"Omega\" }\r\n101.6 \"--targetable--\"\r\n106.5 \"Executable\" Ability { id: \"3626\", source: \"Level Checker\" }\r\n115.5 \"Ferrofluid\" Ability { id: \"3253\", source: \"Level Checker\" }\r\n116.5 \"Magnetism\" Ability { id: \"3254\", source: \"Level Checker\" }\r\n116.5 \"Repel\" Ability { id: \"3255\", source: \"Level Checker\" }\r\n116.5 \"Magnetism\" Ability { id: \"3254\", source: \"Level Checker\" }\r\n118.5 \"Dual Storage Violation\" Ability { id: \"3258\", source: \"Omega\" }\r\n128.5 \"Executable\" Ability { id: \"3626\", source: \"Level Checker\" }\r\n139.5 \"Dual Storage Violation\" Ability { id: \"3258\", source: \"Omega\" }\r\n145.5 \"Storage Violation\" Ability { id: \"3256\", source: \"Omega\" }\r\n147.5 \"Dual Storage Violation\" Ability { id: \"3258\", source: \"Omega\" }\r\n153.5 \"Storage Violation\" Ability { id: \"3256\", source: \"Omega\" }\r\n155.5 \"Dual Storage Violation\" Ability { id: \"3258\", source: \"Omega\" }\r\n158.4 \"Reset\" Ability { id: \"3628\", source: \"Level Checker\" }\r\n161.4 \"Storage Violation\" Ability { id: \"3256\", source: \"Omega\" }\r\n164.4 \"Reformat\" Ability { id: \"3627\", source: \"Level Checker\" }\r\n185.9 \"Force Quit Enrage\"\r\n\r\n### Phase 3\r\n300.0 \"--sync--\" StartsUsing { id: \"325B\", source: \"Omega\" } window 200,200\r\n310.0 \"Delta Attack\" Ability { id: \"325B\", source: \"Omega\" }\r\n321.4 \"--targetable--\"\r\n330.1 \"Ballistic Missile\" Ability { id: \"325F\", source: \"Omega\" }\r\n337.2 \"Flamethrower\" Ability { id: \"325C\", source: \"Omega\" }\r\n339.3 \"Afterburner\" Ability { id: \"325E\", source: \"Omega\" }\r\n340.3 \"Ballistic Impact\" Ability { id: \"3260\", source: \"Omega\" }\r\n346.8 \"Starboard/Larboard Cannon\" Ability { id: \"326[24]\", source: \"Omega\" }\r\n352.3 \"Starboard/Larboard Cannon\" Ability { id: \"326[35]\", source: \"Omega\" }\r\n366.8 \"Mustard Bomb\" Ability { id: \"326D\", source: \"Omega\" }\r\n368.9 \"Blaster\" Ability { id: \"3261\", source: \"Omega\" }\r\n377.0 \"Atomic Ray\" Ability { id: \"326C\", source: \"Omega\" }\r\n\r\n387.0 \"--sync--\" StartsUsing { id: \"324A\", source: \"Omega\" } window 90,10\r\n390.0 \"Peripheral Synthesis\" Ability { id: \"324A\", source: \"Omega\" }\r\n403.0 \"Rush\" Ability { id: \"3250\", source: \"Rocket Punch\" }\r\n410.0 \"Electric Slide\" Ability { id: \"326B\", source: \"Omega\" }\r\n419.0 \"Peripheral Synthesis\" Ability { id: \"324A\", source: \"Omega\" }\r\n432.0 \"Rush\" Ability { id: \"3250\", source: \"Rocket Punch\" }\r\n438.0 \"Starboard/Larboard Cannon\" Ability { id: \"326[24]\", source: \"Omega\" }\r\n443.5 \"Starboard/Larboard Cannon\" Ability { id: \"326[35]\", source: \"Omega\" }\r\n\r\n### Phase 4: Updated Program Light Show\r\n457.0 \"Update Program\" Ability { id: \"36FC\", source: \"Omega\" }\r\n469.0 \"Flamethrower\" Ability { id: \"36FE\", source: \"Omega\" }\r\n471.0 \"Afterburner\" Ability { id: \"3700\", source: \"Omega\" }\r\n477.5 \"Starboard/Larboard Surge\" Ability { id: \"326[68]\", source: \"Omega\" }\r\n480.0 \"Starboard/Larboard Surge\" Ability { id: \"326[79]\", source: \"Omega\" }\r\n\r\n496.0 \"Pantokrator 1\" Ability { id: \"3702\", source: \"Omega\" }\r\n500.0 \"Ballistic Impact\" duration 8\r\n510.1 \"Condensed Wave Cannon Kyrios\" Ability { id: \"3704\", source: \"Omega\" }\r\n519.1 \"Wave Cannon Kyrios 1\" Ability { id: \"3706\", source: \"Omega\" }\r\n526.2 \"Wave Cannon Kyrios 2\" Ability { id: \"3706\", source: \"Omega\" }\r\n535.2 \"Long Needle Kyrios\" Ability { id: \"370C\", source: \"Omega\" }\r\n544.6 \"Blaster\" Ability { id: \"3261\", source: \"Omega\" }\r\n550.7 \"Atomic Ray\" Ability { id: \"326C\", source: \"Omega\" }\r\n\r\n561.8 \"Peripheral Synthesis\" Ability { id: \"324A\", source: \"Omega\" }\r\n565.8 \"Unmitigated Explosion\" # Ability { id: \"36F8\", source: \"Omega\" } # no sync\r\n586.8 \"Mustard Bomb\" Ability { id: \"326D\", source: \"Omega\" }\r\n598.8 \"Atomic Ray\" Ability { id: \"326C\", source: \"Omega\" }\r\n600.8 \"Ballistic Missile\" Ability { id: \"325F\", source: \"Omega\" }\r\n607.8 \"Flamethrower\" Ability { id: \"36FE\", source: \"Omega\" }\r\n609.8 \"Afterburner\" Ability { id: \"3700\", source: \"Omega\" }\r\n610.8 \"Ballistic Impact\" Ability { id: \"3260\", source: \"Omega\" }\r\n616.3 \"Starboard/Larboard Surge\" Ability { id: \"326[68]\", source: \"Omega\" }\r\n618.8 \"Starboard/Larboard Surge\" Ability { id: \"326[79]\", source: \"Omega\" }\r\n\r\n634.7 \"Pantokrator 2\" Ability { id: \"3702\", source: \"Omega\" }\r\n639.7 \"Ballistic Impact\" duration 18 # +5\r\n642.7 \"Flamethrower\" duration 5.5 # +3\r\n646.7 \"Guided Missile Kyrios\" Ability { id: \"3709\", source: \"Omega\" } duration 6.5\r\n660.7 \"Condensed Wave Cannon Kyrios\" Ability { id: \"3704\", source: \"Omega\" }\r\n662.7 \"Diffuse Wave Cannon Kyrios\" duration 16 # +2\r\n670.7 \"Wave Cannon Kyrios 1\" Ability { id: \"3706\", source: \"Omega\" }\r\n677.7 \"Wave Cannon Kyrios 2\" Ability { id: \"3706\", source: \"Omega\" }\r\n700.8 \"Starboard/Larboard Surge\" Ability { id: \"326[68]\", source: \"Omega\" }\r\n703.3 \"Starboard/Larboard Surge\" Ability { id: \"326[79]\", source: \"Omega\" }\r\n709.8 \"Starboard/Larboard Surge\" Ability { id: \"326[68]\", source: \"Omega\" }\r\n712.3 \"Starboard/Larboard Surge\" Ability { id: \"326[79]\", source: \"Omega\" }\r\n\r\n724.8 \"Charybdis\" Ability { id: \"326E\", source: \"Omega\" } window 10,10\r\n738.8 \"Mustard Bomb\" Ability { id: \"326D\", source: \"Omega\" }\r\n740.9 \"Blaster\" Ability { id: \"3261\", source: \"Omega\" }\r\n748.9 \"Atomic Ray\" Ability { id: \"326A\", source: \"Omega\" }\r\n754.9 \"Atomic Ray\" Ability { id: \"326A\", source: \"Omega\" }\r\n760.9 \"Atomic Ray\" Ability { id: \"326A\", source: \"Omega\" }\r\n780.9 \"Loop Enrage\" # guessing at time\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o12n.ts




// O12N - Alphascape 4.0
const o12n_triggerSet = {
  id: 'AlphascapeV40',
  zoneId: zone_id/* default.AlphascapeV40 */.Z.AlphascapeV40,
  timelineFile: 'o12n.txt',
  timelineTriggers: [{
    id: 'O12N Knockback',
    regex: /Discharger/,
    beforeSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  triggers: [{
    id: 'O12N Solar Ray',
    type: 'StartsUsing',
    netRegex: {
      id: ['330F', '3310'],
      source: ['Omega', 'Omega-M']
    },
    suppressSeconds: 1,
    response: responses/* Responses.tankCleave */.n3.tankCleave('alert')
  }, {
    id: 'O12N Optimized Blade Dance',
    type: 'StartsUsing',
    netRegex: {
      id: ['3321', '3322'],
      source: ['Omega', 'Omega-M']
    },
    suppressSeconds: 1,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O12N Laser Shower',
    type: 'StartsUsing',
    netRegex: {
      id: ['3311', '3312'],
      source: ['Omega', 'Omega-M'],
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O12N Cosmo Memory',
    type: 'StartsUsing',
    netRegex: {
      id: ['331C', '331D'],
      source: ['Omega', 'Omega-M'],
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'O12N Efficient Bladework',
    type: 'Ability',
    // 12.1 seconds after Subject Simulation M is an untelegraphed Efficient Bladework.
    netRegex: {
      id: '32F4',
      source: 'Omega-M',
      capture: false
    },
    delaySeconds: 8,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'O12N Local Resonance',
    type: 'GainsEffect',
    netRegex: {
      target: 'Omega',
      effectId: '67E',
      capture: false
    },
    condition: data => data.role === 'tank' || data.job === 'BLU',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move bosses apart',
        de: 'Bosse auseinander ziehen',
        fr: 'Déplacez les boss séparément',
        ja: 'ボスを引き離す',
        cn: '拉开boss',
        ko: '보스 서로 떨어뜨리기'
      }
    }
  }, {
    id: 'O12N Optimized Meteor',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.meteorOnYou */.n3.meteorOnYou()
  }, {
    id: 'O12N Ground Zero',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.getOut(),
    run: (data, matches) => data.groundZero = matches.target,
    outputStrings: {
      getOut: {
        en: 'Get Out',
        de: 'Raus da',
        fr: 'Sortez',
        ja: '外へ',
        cn: '远离',
        ko: '파티에서 멀어지기'
      }
    }
  }, {
    id: 'O12N Goo Instructions',
    type: 'HeadMarker',
    netRegex: {
      id: '008B',
      capture: false
    },
    delaySeconds: 8,
    infoText: (_data, _matches, output) => output.text(),
    run: data => delete data.groundZero,
    outputStrings: {
      text: {
        en: 'Knockback from F; Away from M',
        de: 'Rückstoß von F; Weg von M',
        fr: 'Poussée depuis F; Éloignez-vous de M',
        cn: '被女性击退; 远离男性',
        ko: 'F 넉백, M 광역기'
      }
    }
  }, {
    id: 'O12N Stack Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    delaySeconds: 0.3,
    infoText: (data, matches, output) => {
      if (data.me === data.groundZero) return;
      // TODO: Should this say something different during the blob phase,
      // since it's stack, but also get away from Ground Zero purple marker.
      if (data.me === matches.target) return output.stackOnYou();
      return output.stackOnPlayer({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOnPlayer: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'O12N Optimized Fire III',
    type: 'HeadMarker',
    netRegex: {
      id: '0060'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'O12N Packet Filter F',
    type: 'GainsEffect',
    netRegex: {
      effectId: '67D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Attack Omega-M',
        de: 'Omega-M angreifen',
        fr: 'Attaquez Oméga-M',
        ja: 'オメガMに攻撃',
        cn: '攻击男性',
        ko: '오메가 M 공격'
      }
    }
  }, {
    id: 'O12N Packet Filter M',
    type: 'GainsEffect',
    netRegex: {
      effectId: '67C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Attack Omega-F',
        de: 'Omega-W angreifen',
        fr: 'Attaquez Oméga-F',
        ja: 'オメガFに攻撃',
        cn: '攻击女性',
        ko: '오메가 F 공격'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Calculations indicate increased probability of defeat': 'Warnung. Erhöhte Wahrscheinlichkeit einer Niederlage',
      'Omega(?!-)': 'Omega',
      'Omega-M': 'Omega-M',
      'Optical Unit': 'Optikmodul',
      'Progress to party combat': 'Initiiere Gruppenkampf',
      '<blip> Limits of single combatant': '<biep> Leistungsgrenze als Einzelkämpfer',
      '<blip> Warning\\. Calculations indicate': '<biep> Warnung. Erhöhte Wahrscheinlichkeit'
    },
    'replaceText': {
      'Beyond Strength': 'Schildkombo G',
      'Cosmo Memory': 'Kosmospeicher',
      'Discharger': 'Entlader',
      'Efficient Bladework': 'Effiziente Klingenführung',
      'Electric Slide': 'Elektrosturz',
      'Firewall': 'Sicherungssystem',
      'Floodlight': 'Flutlicht',
      'Ground Zero': 'Explosionszentrum',
      'Laser Shower': 'Laserschauer',
      'Optical Laser': 'Optischer Laser F',
      'Optimized Blade Dance': 'Omega-Schwertertanz',
      'Optimized Blizzard III': 'Omega-Eisga',
      'Optimized Fire III': 'Omega-Feuga',
      'Optimized Meteor': 'Omega-Meteor',
      'Optimized Passage of Arms': 'Optimierter Waffengang',
      'Optimized Sagittarius Arrow': 'Omega-Choral der Pfeile',
      'Program Alpha': 'Alpha-Programm',
      'Resonance': 'Resonanz',
      'Solar Ray': 'Sonnenstrahl',
      'Spotlight': 'Scheinwerfer',
      'Subject Simulation F': 'Transformation W',
      'Subject Simulation M': 'Transformation M',
      'Superliminal Steel': 'Klingenkombo B',
      'Suppression': 'Hilfsprogramm F',
      'Synthetic Blades': 'Synthetische Klinge',
      'Synthetic Shield': 'Synthetischer Schild'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Calculations indicate increased probability of defeat': 'Forte augmentation des probabilités de défaite',
      'Omega(?!-)': 'Oméga',
      'Omega-M': 'Oméga-M',
      'Optical Unit': 'unité optique',
      'Progress to party combat': 'Limites du combat en solitaire atteintes',
      '<blip> Limits of single combatant': 'Bip... Bip... Limites du combat en solitaire',
      '<blip> Warning\\. Calculations indicate': 'Alerte... Alerte... Forte augmentation'
    },
    'replaceText': {
      'Beyond Strength': 'Combo bouclier G',
      'Cosmo Memory': 'Cosmomémoire',
      'Discharger': 'Déchargeur',
      'Efficient Bladework': 'Lame active',
      'Electric Slide': 'Glissement Oméga',
      'Firewall': 'Programme protecteur',
      'Floodlight': 'Projecteur',
      'Ground Zero': 'Ruée féroce',
      'Laser Shower': 'Pluie de lasers',
      'Optical Laser': 'Laser optique F',
      'Optimized Blade Dance': 'Danse de la lame Oméga',
      'Optimized Blizzard III': 'Méga Glace Oméga',
      'Optimized Fire III': 'Méga Feu Oméga',
      'Optimized Meteor': 'Météore Oméga',
      'Optimized Passage of Arms': 'Passe d\'armes Oméga',
      'Optimized Sagittarius Arrow': 'Flèche du sagittaire Oméga',
      'Program Alpha': 'Programme Alpha',
      'Resonance': 'Résonance',
      'Solar Ray': 'Rayon solaire',
      'Spotlight': 'Phare',
      'Subject Simulation F': 'Transformation F',
      'Subject Simulation M': 'Simulation de sujet M',
      'Superliminal Steel': 'Combo lame B',
      'Suppression': 'Programme d\'assistance F',
      'Synthetic Blades': 'Lame optionnelle',
      'Synthetic Shield': 'Bouclier optionnel'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Omega(?!-)': 'オメガ',
      'Omega-M': 'オメガM',
      'Optical Unit': 'オプチカルユニット',
      'Progress to party combat': '単独戦闘による限界を確認',
      '<blip> Limits of single combatant': '分析……単独戦闘による',
      '<blip> Warning\\. Calculations indicate': '警告……警告……敗北の危険性が上昇……'
    },
    'replaceText': {
      'Beyond Strength': 'シールドコンボG',
      'Cosmo Memory': 'コスモメモリー',
      'Discharger': 'ディスチャージャー',
      'Efficient Bladework': 'ソードアクション',
      'Electric Slide': 'オメガスライド',
      'Firewall': 'ガードプログラム',
      'Floodlight': 'フラッドライト',
      'Ground Zero': '急襲',
      'Laser Shower': 'レーザーシャワー',
      'Optical Laser': 'オプチカルレーザーF',
      'Optimized Blade Dance': 'ブレードダンス・オメガ',
      'Optimized Blizzard III': 'ブリザガ・オメガ',
      'Optimized Fire III': 'ファイラ・オメガ',
      'Optimized Meteor': 'メテオ・オメガ',
      'Optimized Passage of Arms': 'パッセージ・オブ・オメガ',
      'Optimized Sagittarius Arrow': 'サジタリウスアロー・オメガ',
      'Program Alpha': 'プログラム・アルファ',
      'Resonance': 'レゾナンス',
      'Solar Ray': 'ソーラレイ',
      'Spotlight': 'スポットライト',
      'Subject Simulation F': 'トランスフォームF',
      'Subject Simulation M': 'トランスフォームM',
      'Superliminal Steel': 'ブレードコンボB',
      'Suppression': '援護プログラムF',
      'Synthetic Blades': 'ブレードオプション',
      'Synthetic Shield': 'シールドオプション'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Calculations indicate increased probability of defeat': '警告……警告……失败的危险性上升……',
      'Omega(?!-)': '欧米茄',
      'Omega-M': '欧米茄M',
      'Optical Unit': '视觉组',
      'Progress to party combat': '确认到单独战斗的极限',
      '<blip> Limits of single combatant': '分析……确认到单',
      '<blip> Warning\\. Calculations indicate': '警告……警告……失败的危险性上升……'
    },
    'replaceText': {
      'Beyond Strength': '盾连击G',
      'Cosmo Memory': '宇宙记忆',
      'Discharger': '能量放出',
      'Efficient Bladework': '剑击',
      'Electric Slide': '欧米茄滑跃',
      'Firewall': '防御程序',
      'Floodlight': '泛光灯',
      'Ground Zero': '急袭',
      'Laser Shower': '激光骤雨',
      'Optical Laser': '光学射线F',
      'Optimized Blade Dance': '欧米茄刀光剑舞',
      'Optimized Blizzard III': '欧米茄冰封',
      'Optimized Fire III': '欧米茄烈炎',
      'Optimized Meteor': '欧米茄陨石流星',
      'Optimized Passage of Arms': '欧米茄通道',
      'Optimized Sagittarius Arrow': '欧米茄射手天箭',
      'Program Alpha': '程序·阿尔法',
      'Resonance': '共鸣',
      'Solar Ray': '太阳射线',
      'Spotlight': '聚光灯',
      'Subject Simulation F': '变形F',
      'Subject Simulation M': '变形M',
      'Superliminal Steel': '剑连击B',
      'Suppression': '援护程序F',
      'Synthetic Blades': '合成剑',
      'Synthetic Shield': '合成盾'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Omega(?!-)': '오메가',
      'Omega-M': '오메가 M',
      'Optical Unit': '광학 유닛',
      'Progress to party combat': '단독 전투 한계 확인',
      'Calculations indicate increased probability of defeat': '패배 위험성 상승',
      '<blip> Limits of single combatant': '분석…… 단독 전투 한계',
      '<blip> Warning\\. Calculations indicate': '패배 위험성 상승'
    },
    'replaceText': {
      'Beyond Strength': '방패 연격 G',
      'Cosmo Memory': '세계의 기억',
      'Discharger': '방출',
      'Efficient Bladework': '검격',
      'Electric Slide': '오메가 슬라이드',
      'Firewall': '방어 프로그램',
      'Floodlight': '투광 조명',
      'Ground Zero': '급습',
      'Laser Shower': '레이저 세례',
      'Optical Laser': '광학 레이저 F',
      'Optimized Blade Dance': '쾌검난무: 오메가',
      'Optimized Blizzard III': '블리자가: 오메가',
      'Optimized Fire III': '파이라: 오메가',
      'Optimized Meteor': '메테오: 오메가',
      'Optimized Passage of Arms': '오메가의 결의',
      'Optimized Sagittarius Arrow': '궁수자리 화살: 오메가',
      'Program Alpha': '프로그램 알파',
      'Resonance': '공명',
      'Solar Ray': '태양 광선',
      'Spotlight': '집중 조명',
      'Subject Simulation F': '형태 변경 F',
      'Subject Simulation M': '형태 변경 M',
      'Superliminal Steel': '칼날 연격 B',
      'Suppression': '지원 프로그램 F',
      'Synthetic Blades': '칼날 장착',
      'Synthetic Shield': '방패 장착'
    }
  }]
};
/* harmony default export */ const o12n = (o12n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o12n.txt
const raid_o12n_namespaceObject = "# Omega - Alphascape V4.0 - O12N\r\n# -ii 3326 32FA 32FC 32F5 330C 330B 32FE 3302 34CB 32F7 32FB 32F2 32F8 32F9 330E 3318 3306 3307 331C 331D 3395 331F 3324 3321 3310 3393 -p 330F:15.3 3319:700\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1 (loops until low%)\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n15.3 \"Solar Ray\" Ability { id: \"330F\", source: \"Omega-M\" } window 16,3\r\n20.4 \"Program Alpha\" Ability { id: \"3308\", source: \"Omega-M\" }\r\n23.5 \"Floodlight\" Ability { id: \"3309\", source: \"Omega-M\" }\r\n27.5 \"Spotlight\" Ability { id: \"330A\", source: \"Omega-M\" }\r\n27.7 \"Efficient Bladework\" Ability { id: \"32FF\", source: \"Omega-M\" }\r\n38.0 \"Subject Simulation F\" Ability { id: \"32F1\", source: \"Omega-M\" }\r\n50.4 \"Discharger\" Ability { id: \"32F6\", source: \"Omega-M\" }\r\n61.7 \"Optimized Fire III\" Ability { id: \"330D\", source: \"Omega-M\" }\r\n66.9 \"Optimized Blizzard III\" Ability { id: \"3303\", source: \"Omega-M\" }\r\n75.1 \"Laser Shower\" Ability { id: \"3312\", source: \"Omega-M\" }\r\n92.5 \"Synthetic Blades\" Ability { id: \"3301\", source: \"Omega-M\" }\r\n100.6 \"Optimized Fire III\" Ability { id: \"330D\", source: \"Omega-M\" }\r\n105.9 \"Superliminal Steel\" Ability { id: \"3305\", source: \"Omega-M\" }\r\n111.0 \"Optimized Blizzard III\" Ability { id: \"3303\", source: \"Omega-M\" }\r\n122.3 \"Subject Simulation M\" Ability { id: \"32F4\", source: \"Omega-M\" }\r\n134.7 \"Efficient Bladework\" Ability { id: \"32F3\", source: \"Omega-M\" }\r\n141.0 \"Synthetic Shield\" Ability { id: \"32FD\", source: \"Omega-M\" }\r\n149.1 \"Program Alpha\" Ability { id: \"3308\", source: \"Omega-M\" }\r\n152.2 \"Floodlight\" Ability { id: \"3309\", source: \"Omega-M\" }\r\n156.2 \"Spotlight\" Ability { id: \"330A\", source: \"Omega-M\" }\r\n156.4 \"Beyond Strength\" Ability { id: \"3300\", source: \"Omega-M\" }\r\n162.6 \"Efficient Bladework\" Ability { id: \"32FF\", source: \"Omega-M\" }\r\n175.9 \"Laser Shower\" Ability { id: \"3311\", source: \"Omega-M\" }\r\n184.2 \"Solar Ray\" Ability { id: \"330F\", source: \"Omega-M\" } # drift -0.047\r\n191.4 \"Laser Shower\" Ability { id: \"3311\", source: \"Omega-M\" } # drift 0.045\r\n196.7 \"Subject Simulation F\" Ability { id: \"32F1\", source: \"Omega-M\" }\r\n209.1 \"Discharger\" Ability { id: \"32F6\", source: \"Omega-M\" }\r\n215.3 \"Synthetic Blades\" Ability { id: \"3301\", source: \"Omega-M\" }\r\n223.5 \"Optimized Fire III\" Ability { id: \"330D\", source: \"Omega-M\" } # drift -0.043001\r\n228.7 \"Superliminal Steel\" Ability { id: \"3305\", source: \"Omega-M\" } # drift -0.046\r\n233.8 \"Optimized Blizzard III\" Ability { id: \"3303\", source: \"Omega-M\" }\r\n246.9 \"Laser Shower\" Ability { id: \"3312\", source: \"Omega-M\" }\r\n\r\n# Fake lookahead window before loop back to beginning\r\n282.2 \"Solar Ray\" Ability { id: \"330F\", source: \"Omega-M\" } window 20,20 jump 15.3\r\n287.3 \"Program Alpha\"\r\n290.4 \"Floodlight\"\r\n294.4 \"Spotlight\"\r\n294.6 \"Efficient Bladework\"\r\n304.9 \"Subject Simulation F\"\r\n317.3 \"Discharger\"\r\n\r\n\r\n### Phase 2: Passage of Arms\r\n# https://xivapi.com/InstanceContentTextData/20620\r\n# en: <blip> Limits of single combatant capability reached. Progress to party combat analysis.\r\n500.0 \"--sync--\" BattleTalk2 { instanceContentTextId: \"508C\" } window 500,0\r\n514.0 \"Ground Zero\" Ability { id: \"3313\", source: \"Omega-M\" } # drift 0.045001\r\n514.0 \"Electric Slide\" Ability { id: \"3314\", source: \"Omega\" }\r\n522.0 \"Efficient Bladework\" Ability { id: \"32F3\", source: \"Omega-M\" } # drift -0.045\r\n522.0 \"Discharger\" Ability { id: \"32F6\", source: \"Omega\" }\r\n\r\n526.3 \"Optimized Passage of Arms\" Ability { id: \"3316\", source: \"Omega-M\" } window 550,50\r\n587.5 \"Laser Shower Enrage\"\r\n\r\n\r\n### Phase 3: Everyone dies, loops forever\r\n# Post-passage of arms startup\r\n700.0 \"--sync--\" Ability { id: \"3319\", source: \"Omega\" } window 700,0\r\n711.0 \"Ground Zero\" Ability { id: \"3313\", source: \"Omega-M\" }\r\n711.0 \"Electric Slide\" Ability { id: \"3314\", source: \"Omega\" }\r\n719.1 \"Efficient Bladework\" Ability { id: \"32F3\", source: \"Omega-M\" } # drift -0.044\r\n719.1 \"Discharger\" Ability { id: \"32F6\", source: \"Omega\" }\r\n725.1 \"Firewall\" Ability { id: \"3392\", source: \"Omega-M\" } window 100,10\r\n\r\n737.1 \"Synthetic Blades/Shield\" # branching\r\n737.1 \"--sync--\" Ability { id: \"32FD\", source: \"Omega-M\" } window 20,20 jump 937.1 # shield\r\n737.1 \"--sync--\" Ability { id: \"3301\", source: \"Omega\" } window 20,20 jump 1137.1 # blades\r\n739.1 \"Laser Shower\"\r\n\r\n# Two paths here.  The 1st Shield/Blades has a Solar Ray that the others don't.\r\n# Assuming it alternates shield/blades though.\r\n# PoA -> Firewall -> 1st Shield -> 2nd Blades -> 2nd Shield -> 2nd Blades -> etc\r\n# PoA -> Firewall -> 1st Blades -> 2nd Shield -> 2nd Blades -> 2nd Shield -> etc\r\n\r\n# first time shield loop (with solar ray)\r\n937.1 \"Synthetic Shield\" Ability { id: \"32FD\", source: \"Omega-M\" }\r\n939.1 \"Laser Shower\" Ability { id: \"3312\", source: \"Omega\" }\r\n947.1 \"Optimized Fire III\" Ability { id: \"330D\", source: \"Omega\" }\r\n947.1 \"Beyond Strength\" Ability { id: \"3300\", source: \"Omega-M\" }\r\n952.1 \"Optimized Blizzard III\" Ability { id: \"3303\", source: \"Omega\" }\r\n953.1 \"Efficient Bladework\" Ability { id: \"32FF\", source: \"Omega-M\" }\r\n963.1 \"Solar Ray\" Ability { id: \"330F\", source: \"Omega-M\" }\r\n985.4 \"Cosmo Memory\" Ability { id: \"331B\", source: \"Omega-M\" }\r\n992.5 \"Resonance\" Ability { id: \"3394\", source: \"Omega-M\" } # drift -0.046001\r\n1008.6 \"Suppression\" Ability { id: \"331E\", source: \"Omega-M\" } # drift -0.044999\r\n1013.6 \"Optical Laser\" Ability { id: \"3320\", source: \"Optical Unit\" }\r\n1016.6 \"Optimized Meteor\" Ability { id: \"3325\", source: \"Omega-M\" }\r\n1016.8 \"Optimized Sagittarius Arrow\" Ability { id: \"3323\", source: \"Omega-M\" } # drift -0.044\r\n1027.7 \"Optimized Blade Dance\" Ability { id: \"3322\", source: \"Omega\" }\r\n1035.7 \"Synthetic Blades\" Ability { id: \"3301\", source: \"Omega\" } window 20,20 jump 1478.4\r\n\r\n# fake lookahead into 2nd blades loop\r\n1037.7 \"Laser Shower\"\r\n1044.9 \"Program Alpha\"\r\n1044.9 \"Optimized Fire III\"\r\n1047.9 \"Floodlight\"\r\n1051.1 \"Superliminal Steel\"\r\n1051.9 \"Spotlight\"\r\n1055.9 \"Efficient Bladework\"\r\n1056.1 \"Optimized Blizzard III\"\r\n\r\n# first time blades loop (with solar ray)\r\n1137.1 \"Synthetic Blades\" Ability { id: \"3301\", source: \"Omega\" }\r\n1139.1 \"Laser Shower\" Ability { id: \"3311\", source: \"Omega-M\" }\r\n1146.4 \"Program Alpha\" Ability { id: \"3308\", source: \"Omega-M\" }\r\n1146.5 \"Optimized Fire III\" Ability { id: \"330D\", source: \"Omega\" }\r\n1149.5 \"Floodlight\" Ability { id: \"3309\", source: \"Omega-M\" }\r\n1152.9 \"Superliminal Steel\" Ability { id: \"3305\", source: \"Omega\" }\r\n1153.5 \"Spotlight\" Ability { id: \"331A\", source: \"Omega-M\" } # drift -0.049001\r\n1157.6 \"Efficient Bladework\" Ability { id: \"32FF\", source: \"Omega-M\" }\r\n1158.1 \"Optimized Blizzard III\" Ability { id: \"3303\", source: \"Omega\" }\r\n1168.9 \"Solar Ray\" Ability { id: \"330F\", source: \"Omega-M\" }\r\n1192.0 \"Cosmo Memory\" Ability { id: \"331B\", source: \"Omega-M\" }\r\n1199.3 \"Resonance\" Ability { id: \"3394\", source: \"Omega-M\" }\r\n1215.8 \"Suppression\" Ability { id: \"331E\", source: \"Omega-M\" }\r\n1220.9 \"Optical Laser\" Ability { id: \"3320\", source: \"Optical Unit\" }\r\n1224.1 \"Optimized Meteor\" Ability { id: \"3325\", source: \"Omega-M\" }\r\n1224.3 \"Optimized Sagittarius Arrow\" Ability { id: \"3323\", source: \"Omega-M\" }\r\n1235.4 \"Optimized Blade Dance\" Ability { id: \"3322\", source: \"Omega\" }\r\n1243.6 \"Synthetic Shield\" Ability { id: \"32FD\", source: \"Omega-M\" } window 20,20 jump 1400\r\n\r\n# fake lookahead into 2nd shield loop\r\n1245.6 \"Laser Shower\"\r\n1254.1 \"Optimized Fire III\"\r\n1254.2 \"Beyond Strength\"\r\n1259.3 \"Optimized Blizzard III\"\r\n1260.3 \"Efficient Bladework\"\r\n1270.6 \"Cosmo Memory\"\r\n1277.8 \"Resonance\"\r\n\r\n# second time shield loop (no solar ray)\r\n1400.0 \"Synthetic Shield\" Ability { id: \"32FD\", source: \"Omega-M\" }\r\n1402.0 \"Laser Shower\" Ability { id: \"3312\", source: \"Omega\" }\r\n1410.5 \"Optimized Fire III\" Ability { id: \"330D\", source: \"Omega\" }\r\n1410.6 \"Beyond Strength\" Ability { id: \"3300\", source: \"Omega-M\" }\r\n1415.7 \"Optimized Blizzard III\" Ability { id: \"3303\", source: \"Omega\" }\r\n1416.7 \"Efficient Bladework\" Ability { id: \"32FF\", source: \"Omega-M\" }\r\n1427.0 \"Cosmo Memory\" Ability { id: \"331B\", source: \"Omega-M\" }\r\n1434.2 \"Resonance\" Ability { id: \"3394\", source: \"Omega-M\" } # drift 0.045001\r\n1450.8 \"Suppression\" Ability { id: \"331E\", source: \"Omega-M\" }\r\n1455.8 \"Optical Laser\" Ability { id: \"3320\", source: \"Optical Unit\" }\r\n1459.0 \"Optimized Meteor\" Ability { id: \"3325\", source: \"Omega-M\" }\r\n1459.2 \"Optimized Sagittarius Arrow\" Ability { id: \"3323\", source: \"Omega-M\" }\r\n1470.3 \"Optimized Blade Dance\" Ability { id: \"3322\", source: \"Omega\" }\r\n\r\n# second time blades loop (no solar ray)\r\n1478.4 \"Synthetic Blades\" Ability { id: \"3301\", source: \"Omega\" }\r\n1480.4 \"Laser Shower\" Ability { id: \"3311\", source: \"Omega-M\" }\r\n1487.6 \"Program Alpha\" Ability { id: \"3308\", source: \"Omega-M\" }\r\n1487.6 \"Optimized Fire III\" Ability { id: \"330D\", source: \"Omega\" }\r\n1490.6 \"Floodlight\" Ability { id: \"3309\", source: \"Omega-M\" }\r\n1493.8 \"Superliminal Steel\" Ability { id: \"3305\", source: \"Omega\" }\r\n1494.6 \"Spotlight\" Ability { id: \"331A\", source: \"Omega-M\" }\r\n1498.6 \"Efficient Bladework\" Ability { id: \"32FF\", source: \"Omega-M\" }\r\n1498.8 \"Optimized Blizzard III\" Ability { id: \"3303\", source: \"Omega\" }\r\n1509.8 \"Cosmo Memory\" Ability { id: \"331B\", source: \"Omega-M\" }\r\n1516.8 \"Resonance\" Ability { id: \"3394\", source: \"Omega-M\" }\r\n1532.9 \"Suppression\" Ability { id: \"331E\", source: \"Omega-M\" }\r\n1537.9 \"Optical Laser\" Ability { id: \"3320\", source: \"Optical Unit\" }\r\n1540.9 \"Optimized Meteor\" Ability { id: \"3325\", source: \"Omega-M\" }\r\n1541.1 \"Optimized Sagittarius Arrow\" Ability { id: \"3323\", source: \"Omega-M\" }\r\n1551.9 \"Optimized Blade Dance\" Ability { id: \"3322\", source: \"Omega\" }\r\n\r\n# Loop with fake lookahead window\r\n1560.0 \"Synthetic Shield\" Ability { id: \"32FD\", source: \"Omega-M\" } window 20,20 jump 1400\r\n1562.0 \"Laser Shower\"\r\n1570.5 \"Optimized Fire III\"\r\n1570.6 \"Beyond Strength\"\r\n1575.7 \"Optimized Blizzard III\"\r\n1576.7 \"Efficient Bladework\"\r\n1587.0 \"Cosmo Memory\"\r\n1594.2 \"Resonance\"\r\n\r\n\r\n### Phase 4: Laser Show Forever\r\n# https://xivapi.com/InstanceContentTextData/20623\r\n# https://xivapi.com/InstanceContentTextData/20624\r\n# en: <blip> Warning. Calculations indicate increased probability of defeat.\\n\\n<bleep> Error. Further data analysis required.\r\n# May be either id depending on which is alive.\r\n1800.0 \"Enrage\" BattleTalk2 { instanceContentTextId: \"(508F|5090)\" } window 1800,0\r\n1806.0 \"Laser Shower Enrage\" Ability { id: \"3311\", source: \"Omega-M\" } window 20,20\r\n1806.0 \"Laser Shower Enrage\" Ability { id: \"3312\", source: \"Omega\" } window 20,20\r\n1812.0 \"Laser Shower Enrage\"\r\n1818.0 \"Laser Shower Enrage\"\r\n1824.0 \"Laser Shower Enrage\"\r\n1832.0 \"Laser Shower Enrage\"\r\n1838.0 \"Laser Shower Enrage\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o12s.ts




// O12S - Alphascape 4.0 Savage
// TODO: targetable lines in timeline
const o12s_triggerSet = {
  id: 'AlphascapeV40Savage',
  zoneId: zone_id/* default.AlphascapeV40Savage */.Z.AlphascapeV40Savage,
  timelineFile: 'o12s.txt',
  timelineTriggers: [{
    id: 'O12S Discharger',
    regex: /Discharger/,
    beforeSeconds: 5,
    alertText: (data, _matches, output) => {
      if (data.seenDischarger) return output.knockbackAndAvoid();
      return output.knockback();
    },
    run: data => data.seenDischarger = true,
    outputStrings: {
      knockback: outputs/* default.knockback */.Z.knockback,
      knockbackAndAvoid: {
        en: 'Knockback F + Avoid M',
        de: 'Rückstoß W + Weiche M aus',
        fr: 'Poussée F + Évitez M',
        ja: 'Fのノックバック + Mに避ける',
        cn: '女性击退 + 远离男性',
        ko: 'F쪽에서 넉백, M 피하기'
      }
    }
  }],
  triggers: [{
    id: 'O12S Ion Efflux Phase Reset',
    type: 'StartsUsing',
    netRegex: {
      id: '3357',
      source: 'Omega',
      capture: false
    },
    run: data => {
      data.isFinalOmega = true;
      data.dpsShortStack = true;
      data.helloDebuffs = {};
      data.calledHelloNoMarker = false;
      data.archiveMarkers = {};
      data.armValue = 0;
      data.numArms = 0;
    }
  }, {
    id: 'O12S Beyond Defense Spread',
    type: 'StartsUsing',
    netRegex: {
      id: '332C',
      source: 'Omega-M',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'O12S Beyond Defense Vuln',
    type: 'Ability',
    netRegex: {
      id: '332C',
      source: 'Omega-M'
    },
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    run: (data, matches) => {
      data.beyondDefenseVuln ??= [];
      data.beyondDefenseVuln.push(matches.target);
    },
    outputStrings: {
      text: {
        en: 'Don\'t Stack!',
        de: 'Nicht stacken!',
        fr: 'Ne vous packez pas !',
        ja: 'スタックするな！',
        cn: '分散站位！',
        ko: '쉐어 맞지 말것'
      }
    }
  }, {
    id: 'O12S Beyond Defense Stack',
    type: 'Ability',
    netRegex: {
      id: '332C',
      source: 'Omega-M',
      capture: false
    },
    delaySeconds: 0.5,
    // Sometimes multiple people get hit.
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      if (data.beyondDefenseVuln && !data.beyondDefenseVuln.includes(data.me)) return output.text();
    },
    run: data => delete data.beyondDefenseVuln,
    outputStrings: {
      text: outputs/* default.stackMarker */.Z.stackMarker
    }
  }, {
    id: 'O12S Superliminal Motion Initial',
    type: 'StartsUsing',
    netRegex: {
      id: '3334',
      source: 'Omega-M',
      capture: false
    },
    // This is also used during the Blades phase.
    condition: data => data.weaponPhase !== 'blades',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Behind => Spread',
        de: 'Hinter => Verteilen',
        fr: 'Derrière => Dispersez-vous',
        ja: '後ろ -> 散開',
        cn: '背后 => 分散',
        ko: '뒤 => 산개'
      }
    }
  }, {
    id: 'O12S Laser Shower',
    type: 'StartsUsing',
    netRegex: {
      id: '3352',
      source: 'Omega-M',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O12S Cosmo Memory',
    type: 'StartsUsing',
    netRegex: {
      id: '3342',
      source: 'Omega-M',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe('alert')
  }, {
    id: 'O12S Local Resonance',
    type: 'GainsEffect',
    netRegex: {
      target: 'Omega',
      effectId: '67E',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move Bosses Apart',
        de: 'Bosse auseinander ziehen',
        fr: 'Déplacez les boss séparément',
        ja: 'ボスを離して',
        cn: '拉开Boss',
        ko: '보스 떨어뜨리기'
      }
    }
  }, {
    id: 'O12S Remote Resonance',
    type: 'GainsEffect',
    netRegex: {
      target: 'Omega',
      effectId: '67F',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move Bosses Together',
        de: 'Bosse zusammenziehen',
        fr: 'Déplacez les boss ensembles',
        ja: 'ボスを重ねて',
        cn: '拉近Boss',
        ko: '보스 붙이기'
      }
    }
  }, {
    id: 'O12S Solar Ray Collect',
    type: 'StartsUsing',
    netRegex: {
      id: ['3350', '3351'],
      source: ['Omega', 'Omega-M']
    },
    run: (data, matches) => {
      data.solarRayTargets ??= [];
      data.solarRayTargets.push(matches.target);
      data.seenSolarRay = true;
    }
  }, {
    id: 'O12S Solar Ray',
    type: 'StartsUsing',
    netRegex: {
      id: ['3350', '3351'],
      source: ['Omega', 'Omega-M']
    },
    suppressSeconds: 1,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O12S Solar Ray Not You',
    type: 'StartsUsing',
    netRegex: {
      id: ['3350', '3351'],
      source: ['Omega', 'Omega-M'],
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      if (data.solarRayTargets && !data.solarRayTargets.includes(data.me)) return output.text();
    },
    run: data => delete data.solarRayTargets,
    outputStrings: {
      text: outputs/* default.avoidTankCleave */.Z.avoidTankCleave
    }
  }, {
    id: 'O12S Shield Blades Setup',
    type: 'Ability',
    netRegex: {
      id: ['3350', '3351'],
      source: ['Omega', 'Omega-M'],
      capture: false
    },
    condition: data => data.role === 'tank' || data.job === 'BLU',
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    run: data => delete data.weaponPhase,
    outputStrings: {
      text: {
        en: 'Bring Bosses Middle, Face Eye',
        de: 'Zieh Bosse zur Mitte, zum Auge drehen',
        fr: 'Placez les boss au milieu, face à l\'œil',
        ja: 'ボスを中央に、目を見る',
        cn: '把BOSS拉到中间，面向眼睛',
        ko: '보스들 중앙으로 데려오고, 눈쪽 보기'
      }
    }
  }, {
    id: 'O12S Synthetic Blades',
    type: 'StartsUsing',
    netRegex: {
      id: '3301',
      source: 'Omega',
      capture: false
    },
    condition: data => data.seenSolarRay,
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.weaponPhase = 'blades',
    outputStrings: {
      text: {
        en: 'Get Middle (Blades)',
        de: 'Zur Mitte (Schwerter)',
        fr: 'Allez au milieu (Lames)',
        ja: '中へ (剣)',
        cn: '去中间 (剑)',
        ko: '중앙으로 (검)'
      }
    }
  }, {
    id: 'O12S Blades Superliminal Steel',
    type: 'Ability',
    netRegex: {
      id: '332F',
      source: 'Omega',
      capture: false
    },
    condition: data => data.weaponPhase === 'blades',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Intercards + Stack',
        de: 'Interkardinal + Sammeln',
        fr: 'Intercardinal + Package',
        ja: '斜め + 頭割り',
        cn: '躲十字AoE + 分摊',
        ko: '대각선 + 쉐어'
      }
    }
  }, {
    id: 'O12S Blades Superliminal Motion',
    type: 'StartsUsing',
    netRegex: {
      id: '3334',
      source: 'Omega',
      capture: false
    },
    condition: data => data.weaponPhase === 'blades',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Behind => Out + Spread',
        de: 'Hinter => Raus + Verteilen',
        fr: 'Derrière => Extérieur + Dispersion',
        ja: '後ろ => 外へ + 散開',
        cn: '去背后 => 远离 + 分散',
        ko: '뒤 => 밖으로 + 산개'
      }
    }
  }, {
    id: 'O12S Synthetic Shield',
    type: 'StartsUsing',
    netRegex: {
      id: '32FD',
      source: 'Omega-M',
      capture: false
    },
    condition: data => data.seenSolarRay,
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.weaponPhase = 'shield',
    outputStrings: {
      text: {
        en: 'Intercards + Spread (Shield)',
        de: 'Interkardinal + Verteilen (Schild)',
        fr: 'Intercardinal + Dispersion (Bouclier)',
        ja: '斜め + 散開 (盾)',
        cn: '躲十字AoE + 分散 (盾)',
        ko: '대각선 + 산개 (방패)'
      }
    }
  }, {
    id: 'O12S Shield Beyond Strength',
    type: 'Ability',
    // Warn on Pile Pitch damage for Beyond Strength before it starts casting
    netRegex: {
      id: '332E',
      source: 'Omega-M',
      capture: false
    },
    condition: data => data.weaponPhase === 'shield',
    // No castbar, this is the stack damage.
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread => Follow M',
        de: 'Verteilen => Folge M',
        fr: 'Dispersion => Suivez M',
        ja: '散開 -> Mを追う',
        cn: '分散 => 去男性脚下',
        ko: '산개 => M 따라가기'
      }
    }
  }, {
    id: 'O12S Shield Beyond Defense',
    type: 'Ability',
    // Warn on Beyond Strength ability for uncasted Efficient Bladework.
    netRegex: {
      id: '3328',
      source: 'Omega-M',
      capture: false
    },
    condition: data => data.weaponPhase === 'shield',
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from M',
        de: 'Weg von M',
        fr: 'Éloignez-vous de M',
        ja: 'Mから離れる',
        cn: '远离男性',
        ko: 'M으로부터 멀어지기'
      }
    }
  }, {
    id: 'O12S Optimized Blade Dance',
    type: 'StartsUsing',
    netRegex: {
      id: ['334B', '334C'],
      source: ['Omega', 'Omega-M']
    },
    suppressSeconds: 1,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O12S Electric Slide Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '009[12345678]'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: (_data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        square: {
          en: '#${num} Square',
          de: '#${num} Viereck',
          fr: '#${num} Carré',
          ja: '#${num} 四角',
          cn: '#${num} 四角',
          ko: '#${num} 짝수'
        },
        triangle: {
          en: '#${num} Triangle',
          de: '#${num} Dreieck',
          fr: '#${num} Triangle',
          ja: '#${num} 三角',
          cn: '#${num} 三角',
          ko: '#${num} 홀수'
        }
      };
      const id = matches.id;
      if (!id) return;
      let num = parseInt(id);
      const isTriangle = num >= 95;
      num -= 90;
      if (isTriangle) num -= 4;

      // Odd numbers have to run to the other side, so make this louder.
      // TODO: should this be alarm/alert instead of alert/info?
      const isOdd = num % 2;
      const text = isTriangle ? output.triangle({
        num: num
      }) : output.square({
        num: num
      });
      return {
        [isOdd ? 'alertText' : 'infoText']: text
      };
    }
  }, {
    id: 'O12S MF Stack Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '003E',
      capture: false
    },
    condition: data => !data.isFinalOmega,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack Groups',
        de: 'Gruppen-Sammeln',
        fr: 'Package en groupes',
        ja: '組み分け頭割り',
        cn: '分组分摊',
        ko: '그룹별 쉐어'
      }
    }
  }, {
    id: 'O12S Optimized Meteor',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.meteorOnYou */.n3.meteorOnYou()
  }, {
    id: 'O12S Optimized Sagittarius Arrow',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Arrow on YOU',
        de: 'Pfeil auf DIR',
        fr: 'Flèche sur VOUS',
        ja: '自分にアロー',
        cn: '天箭点名',
        ko: '나에게 화살징'
      }
    }
  }, {
    id: 'O12S Packet Filter F',
    type: 'GainsEffect',
    netRegex: {
      effectId: '67D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Attack Omega-M',
        de: 'Omega-M angreifen',
        fr: 'Attaquez Oméga-M',
        ja: 'Mを攻撃',
        cn: '攻击男性',
        ko: '오메가 M 공격'
      }
    }
  }, {
    id: 'O12S Packet Filter M',
    type: 'GainsEffect',
    netRegex: {
      effectId: '67C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Attack Omega-F',
        de: 'Omega-W angreifen',
        fr: 'Attaquez Oméga-F',
        ja: 'Fを攻撃',
        cn: '攻击女性',
        ko: '오메가 F 공격'
      }
    }
  }, {
    id: 'O12S Diffuse Wave Cannon Sides',
    type: 'StartsUsing',
    netRegex: {
      id: '3367',
      source: 'Omega',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides('info')
  }, {
    id: 'O12S Diffuse Wave Cannon Front/Back',
    type: 'StartsUsing',
    netRegex: {
      id: '3368',
      source: 'Omega',
      capture: false
    },
    response: responses/* Responses.goFrontBack */.n3.goFrontBack('info')
  }, {
    id: 'O12S Oversampled Wave Cannon Right',
    type: 'StartsUsing',
    netRegex: {
      id: '3364',
      source: 'Omega',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.role === 'tank' || data.job === 'BLU') return output.monitorsLeft();
      return output.dodgeLeft();
    },
    outputStrings: {
      monitorsLeft: {
        en: 'Monitors Left',
        de: 'Monitore Links',
        fr: 'Moniteurs à gauche',
        ja: '波動砲 (左)',
        cn: '探测左边',
        ko: '모니터 왼쪽'
      },
      dodgeLeft: {
        en: 'Dodge Left',
        de: 'Links ausweichen',
        fr: 'Évitez à gauche',
        ja: '左側に離れる',
        cn: '左侧躲闪',
        ko: '오른쪽으로'
      }
    }
  }, {
    id: 'O12S Oversampled Wave Cannon Left',
    type: 'StartsUsing',
    netRegex: {
      id: '3365',
      source: 'Omega',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.role === 'tank' || data.job === 'BLU') return output.monitorsRight();
      return output.dodgeRight();
    },
    outputStrings: {
      monitorsRight: {
        en: 'Monitors Right',
        de: 'Monitore Rechts',
        fr: 'Moniteurs à droite',
        ja: '波動砲 (右)',
        cn: '探测右边',
        ko: '모니터 오른쪽'
      },
      dodgeRight: {
        en: 'Dodge Right',
        de: 'Rechts ausweichen',
        fr: 'Évitez à droite',
        ja: '右側に離れる',
        cn: '右侧躲闪',
        ko: '왼쪽으로'
      }
    }
  }, {
    id: 'O12S Target Analysis Target',
    type: 'HeadMarker',
    netRegex: {
      id: '000E'
    },
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) return output.vulnOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return;
      if (data.role !== 'tank' && data.job !== 'BLU') return;
      return output.vulnOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      vulnOn: {
        en: 'Vuln on ${player}',
        de: 'Verwundbarkeit auf ${player}',
        fr: 'Vulnérabilité sur ${player}',
        ja: '${player}に標的',
        cn: '目标识别 点${player}',
        ko: '"${player}" 표적식별'
      },
      vulnOnYou: {
        en: 'Vuln on YOU',
        de: 'Verwundbarkeit auf DIR',
        fr: 'Vulnérabilité sur VOUS',
        ja: '自分に標的',
        cn: '目标识别',
        ko: '표적식별 대상자'
      }
    }
  }, {
    // Local Regression
    id: 'O12S Local Tethers',
    type: 'GainsEffect',
    netRegex: {
      effectId: '688'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Close Tethers',
        de: 'Nahe Verbindungen',
        fr: 'Liens proches',
        ja: 'ニアー',
        cn: '靠近连线',
        ko: '가까이 붙는 줄'
      }
    }
  }, {
    // Remote Regression
    id: 'O12S Far Tethers',
    type: 'GainsEffect',
    netRegex: {
      effectId: '689'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Far Tethers',
        de: 'Entfernte Verbindungen',
        fr: 'Liens éloignés',
        ja: 'ファー',
        cn: '远离连线',
        ko: '멀리 떨어지는 줄'
      }
    }
  }, {
    // Critical Overflow Bug
    id: 'O12S Defamation',
    type: 'GainsEffect',
    netRegex: {
      effectId: '681'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Defamation on YOU',
        de: 'Urteil auf DIR',
        fr: 'Médisance sur VOUS',
        ja: 'サークルついた',
        cn: '严重错误：上溢',
        ko: '치명적오류:광역 8초'
      }
    }
  }, {
    id: 'O12S Latent Defect',
    type: 'GainsEffect',
    netRegex: {
      effectId: '686'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Blue Marker',
        de: 'Blauer Marker',
        fr: 'Marqueur bleu',
        ja: 'レイテントついた',
        cn: '蓝点名',
        ko: '잠재적오류 10초'
      }
    }
  }, {
    // Critical Underflow Bug
    id: 'O12S Rot',
    type: 'GainsEffect',
    netRegex: {
      effectId: '682'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Rot',
        de: 'Fäulnis',
        fr: 'Pourriture',
        ja: 'デグレードついた',
        cn: '红点名',
        ko: '치명적오류:전이 14초'
      }
    }
  }, {
    // Critical Synchronization Bug
    id: 'O12S Hello World Stack',
    type: 'GainsEffect',
    netRegex: {
      effectId: '680'
    },
    delaySeconds: (data, matches) => matches.target === data.me ? 0 : 1,
    alertText: (data, matches, output) => {
      const t = parseFloat(matches.duration);
      if (data.me !== matches.target) return;
      if (!(t > 0)) return;
      if (t <= 8) return output.shortStackOnYou();
      return output.longStackOnYou();
    },
    infoText: (data, matches, output) => {
      const t = parseFloat(matches.duration);
      if (data.me === matches.target) return;
      if (!data.dpsShortStack) return;
      if (!(t > 0)) return;
      if (t <= 8) {
        data.dpsShortStack = false;
        // It can be useful to know who has the short stack because they
        // might need an extra shield.  However, common blu strats have
        // folks diamondback this, so it's just noise.
        if (data.job !== 'BLU') return output.shortStackOn({
          player: data.party.member(matches.target)
        });
      }
      return;
    },
    outputStrings: {
      shortStackOn: {
        en: 'Short Stack on ${player}',
        de: 'Kurzer Stack auf ${player}',
        fr: 'Marque courte sur ${player}',
        ja: '${player}に早シェア',
        cn: '短D 点${player}',
        ko: '"${player}" 쉐어'
      },
      shortStackOnYou: {
        en: 'Short Stack on YOU',
        de: 'Kurzer Stack auf YOU',
        fr: 'Marque courte sur VOUS',
        ja: '自分に早シェア',
        cn: '短D',
        ko: '8초 치명적오류:분배(쉐어)'
      },
      longStackOnYou: {
        en: 'Long Stack on YOU',
        de: 'Langer Stack auf YOU',
        fr: 'Marque longue sur VOUS',
        ja: '自分に遅シェア',
        cn: '长D',
        ko: '13초 치명적오류:분배(쉐어)'
      }
    }
  }, {
    id: 'O12S Hello World Initial Debuff Collect',
    type: 'GainsEffect',
    // These effects are all handled elsewhere.
    // Collect who has them, but don't call them out here.
    // 680 = Critical Synchronization Bug (short/long stack)
    // 681 = Critical Overflow Bug (defamation)
    // 682 = Critical Underflow Bug (rot, only on HW2)
    // 686 = Latent Defect (blue dna marker)
    netRegex: {
      effectId: ['680', '681', '682', '686']
    },
    condition: data => !data.calledHelloNoMarker,
    run: (data, matches) => {
      data.helloDebuffs ??= {};
      data.helloDebuffs[matches.target] = matches.effectId;
    }
  }, {
    id: 'O12S Hello World No Marker',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['680', '681', '682', '686'],
      capture: false
    },
    condition: data => !data.calledHelloNoMarker,
    delaySeconds: 0.3,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      if (data.me in (data.helloDebuffs ?? {})) return;
      return output.text();
    },
    run: data => data.calledHelloNoMarker = true,
    outputStrings: {
      text: {
        en: 'No Marker',
        de: 'Kein Marker',
        fr: 'Aucun marqueur',
        ja: '無職',
        cn: '无BUFF',
        ko: '무징 대상자'
      }
    }
  }, {
    // Cascading Latent Defect
    id: 'O12S Hello World Tower Complete',
    type: 'GainsEffect',
    netRegex: {
      effectId: '687'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move out for Defamation',
        de: 'Rausgehen für Urteil',
        fr: 'Sortez pour Médisance',
        ja: 'サークルを捨てる',
        cn: '离开人群传毒',
        ko: '잠재적 오류: 전이'
      }
    }
  }, {
    id: 'O12S Archive All Marker Tracking',
    type: 'HeadMarker',
    netRegex: {
      id: ['003E', '0060']
    },
    condition: data => data.isFinalOmega,
    run: (data, matches) => {
      data.archiveMarkers ??= {};
      data.archiveMarkers[matches.target] = matches.id;
    }
  }, {
    id: 'O12S Archive All No Marker',
    type: 'HeadMarker',
    netRegex: {
      id: ['003E', '0060'],
      capture: false
    },
    condition: data => {
      // 4 fire markers, 1 stack marker.
      if (!data.isFinalOmega) return false;
      return data.archiveMarkers && Object.keys(data.archiveMarkers).length === 5;
    },
    infoText: (data, _matches, output) => {
      if (data.me in (data.archiveMarkers ?? {})) return;
      for (const player in data.archiveMarkers) {
        if (data.archiveMarkers[player] !== '003E') continue;
        return output.text({
          player: data.party.member(player)
        });
      }
    },
    outputStrings: {
      text: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'O12S Archive All Stack Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    condition: (data, matches) => data.isFinalOmega && matches.target === data.me,
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn('info')
  }, {
    id: 'O12S Archive All Spread Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0060'
    },
    condition: (data, matches) => data.isFinalOmega && matches.target === data.me,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'O12S Archive All Blue Arrow',
    type: 'HeadMarker',
    netRegex: {
      target: 'Rear Power Unit',
      id: '009D',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Back Left',
        de: 'Hinten Links',
        fr: 'Derrière à gauche',
        ja: '左後ろ',
        cn: '左后',
        ko: '좌측 후방'
      }
    }
  }, {
    id: 'O12S Archive All Red Arrow',
    type: 'HeadMarker',
    netRegex: {
      target: 'Rear Power Unit',
      id: '009C',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Back Right',
        de: 'Hinten Rechts',
        fr: 'Derrière à droite',
        ja: '右後ろ',
        cn: '右后',
        ko: '우측 후방'
      }
    }
  }, {
    id: 'O12S Archive  Peripheral Tracking',
    type: 'HeadMarker',
    netRegex: {
      target: 'Right Arm Unit',
      id: ['009C', '009D']
    },
    run: (data, matches) => {
      // Create a 3 digit binary value, R = 0, B = 1.
      // e.g. BBR = 110 = 6
      data.armValue ??= 0;
      data.numArms ??= 0;
      data.armValue *= 2;
      if (matches.id === '009D') data.armValue += 1;
      data.numArms++;
    }
  }, {
    id: 'O12S Archive Peripheral',
    type: 'HeadMarker',
    netRegex: {
      target: 'Right Arm Unit',
      id: ['009C', '009D'],
      capture: false
    },
    condition: data => data.numArms === 3,
    alertText: (data, _matches, output) => {
      if (!data.armValue || !(data.armValue >= 0) || data.armValue > 7) return;
      const outputs = {
        0b000: output.east(),
        0b001: output.northeast(),
        0b010: undefined,
        0b011: output.northwest(),
        0b100: output.southeast(),
        0b101: undefined,
        0b110: output.southwest(),
        0b111: output.west()
      };
      return outputs[data.armValue];
    },
    outputStrings: {
      east: outputs/* default.east */.Z.east,
      northeast: outputs/* default.northeast */.Z.northeast,
      northwest: outputs/* default.northwest */.Z.northwest,
      southeast: outputs/* default.southeast */.Z.southeast,
      southwest: outputs/* default.southwest */.Z.southwest,
      west: outputs/* default.west */.Z.west
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Synthetic Blades/Synthetic Shield': 'Synthetic Blades/Shield'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Left Arm Unit': 'link(?:e|er|es|en) Arm',
      'Omega(?!-)': 'Omega',
      'Omega-F': 'Omega-W',
      'Omega-M': 'Omega-M',
      'Optical Unit': 'Optikmodul',
      'Rear Power Unit': 'hinter(?:e|er|es|en) Antriebseinheit',
      'Right Arm Unit': 'rechter Arm'
    },
    'replaceText': {
      'Advanced Optical Laser': 'Optischer Laser S',
      'Advanced Suppression': 'Hilfsprogramm S',
      '(?<! )Archive All': 'Alles archivieren',
      '(?<! )Archive Peripheral': 'Archiv-Peripherie',
      'Beyond Defense': 'Schildkombo S',
      'Beyond Strength': 'Schildkombo G',
      'Cascading Latent Defect': 'Latenter Defekt: Zersetzung',
      'Colossal Blow': 'Kolossaler Hieb',
      'Cosmo Memory': 'Kosmospeicher',
      'Critical Error': 'Schwerer Ausnahmefehler',
      'Critical Overflow Bug': 'Kritischer Bug: Überlauf',
      'Critical Synchronization Bug': 'Kritischer Bug: Synchronisierung',
      'Critical Underflow Bug': 'Kritischer Bug: Unterlauf',
      'Delta Attack': 'Delta-Attacke',
      'Diffuse Wave Cannon': 'Streuende Wellenkanone',
      'Discharger': 'Entlader',
      'Efficient Bladework': 'Effiziente Klingenführung',
      'Electric Slide': 'Elektrosturz',
      'Firewall': 'Sicherungssystem',
      'Floodlight': 'Flutlicht',
      'Fundamental Synergy': 'Synergieprogramm C',
      'Hello, World': 'Hallo, Welt!',
      'Hyper Pulse': 'Hyper-Impuls',
      'Index and Archive Peripheral': 'Archiv-Peripherie X',
      'Ion Efflux': 'Ionenstrom',
      'Laser Shower': 'Laserschauer',
      'Operational Synergy': 'Synergieprogramm W',
      '(?<! )Optical Laser': 'Optischer Laser F',
      'Optimized Blade Dance': 'Omega-Schwertertanz',
      'Optimized Blizzard III': 'Omega-Eisga',
      'Optimized Fire III': 'Omega-Feuga',
      'Optimized Meteor': 'Omega-Meteor',
      'Optimized Sagittarius Arrow': 'Omega-Choral der Pfeile',
      'Oversampled Wave Cannon': 'Fokussierte Wellenkanone',
      'Patch': 'Regression',
      'Pile Pitch': 'Neigungsstoß',
      'Program Omega': 'Programm Omega',
      'Resonance': 'Resonanz',
      'Savage Wave Cannon': 'Grausame Wellenkanone',
      'Solar Ray': 'Sonnenstrahl',
      'Spotlight': 'Scheinwerfer',
      'Subject Simulation F': 'Transformation W',
      'Subject Simulation M': 'Transformation M',
      'Superliminal Motion': 'Klingenkombo F',
      'Superliminal Steel': 'Klingenkombo B',
      '(?<! )Suppression': 'Hilfsprogramm F',
      'Synthetic Blades': 'Synthetische Klinge',
      'Synthetic Shield': 'Synthetischer Schild',
      'Target Analysis': 'Wellenkanone',
      '(?<! )Wave Cannon': 'Wellenkanone'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Left Arm Unit': 'unité bras gauche',
      'Omega(?!-)': 'Oméga',
      'Omega-F': 'Oméga-F',
      'Omega-M': 'Oméga-M',
      'Optical Unit': 'unité optique',
      'Rear Power Unit': 'unité arrière',
      'Right Arm Unit': 'unité bras droit'
    },
    'replaceText': {
      '\\?': ' ?',
      'Advanced Optical Laser': 'Laser optique S',
      'Advanced Suppression': 'Programme d\'assistance S',
      '(?<! )Archive All': 'Archivage intégral',
      '(?<! )Archive Peripheral': 'Périphérique d\'archivage',
      'Beyond Defense': 'Combo bouclier S',
      'Beyond Strength': 'Combo bouclier G',
      'Cascading Latent Defect': 'Bogue latent : dégradation',
      'Colossal Blow': 'Coup colossal',
      'Cosmo Memory': 'Cosmomémoire',
      'Critical Error': 'Erreur critique',
      'Critical Overflow Bug': 'Bogue critique : boucle',
      'Critical Synchronization Bug': 'Bogue critique : partage',
      'Critical Underflow Bug': 'Bogue critique : dégradation',
      'Delta Attack': 'Attaque Delta',
      'Diffuse Wave Cannon': 'Canon plasma diffuseur',
      'Discharger': 'Déchargeur',
      'Efficient Bladework': 'Lame active',
      'Electric Slide': 'Glissement Oméga',
      'Firewall': 'Programme protecteur',
      'Floodlight': 'Projecteur',
      'Fundamental Synergy': 'Programme synergique C',
      'Hello, World': 'Bonjour, le monde',
      'Hyper Pulse': 'Hyperpulsion',
      'Index and Archive Peripheral': 'Périphérique d\'archivage X',
      'Ion Efflux': 'Fuite d\'ions',
      'Laser Shower': 'Pluie de lasers',
      'Operational Synergy': 'Programme synergique W',
      '(?<! )Optical Laser': 'Laser optique F',
      'Optimized Blade Dance': 'Danse de la lame Oméga',
      'Optimized Blizzard III': 'Méga Glace Oméga',
      'Optimized Fire III': 'Méga Feu Oméga',
      'Optimized Meteor': 'Météore Oméga',
      'Optimized Sagittarius Arrow': 'Flèche du sagittaire Oméga',
      'Oversampled Wave Cannon': 'Canon plasma chercheur',
      'Patch': 'Bogue intentionnel',
      'Pile Pitch': 'Lancement de pieu',
      'Program Omega': 'Programme Oméga',
      'Resonance': 'Résonance',
      'Savage Wave Cannon': 'Canon plasma absolu',
      'Solar Ray': 'Rayon solaire',
      'Spotlight': 'Phare',
      'Subject Simulation F': 'Transformation F',
      'Subject Simulation M': 'Simulation de sujet M',
      'Superliminal Motion': 'Combo lame F',
      'Superliminal Steel': 'Combo lame B',
      '(?<! )Suppression': 'Programme d\'assistance F',
      'Synthetic Blades(?!/)': 'Lame optionnelle',
      'Synthetic Blades/Synthetic Shield': 'Lame/Bouclier optionel',
      '(?<!/)Synthetic Shield': 'Bouclier optionnel',
      'Target Analysis': 'Analyse de cible',
      '(?<! )Wave Cannon': 'Canon plasma'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Left Arm Unit': 'レフトアームユニット',
      '(?<! )Omega(?!-)': 'オメガ',
      'Omega-F': 'オメガF',
      'Omega-M': 'オメガM',
      'Optical Unit': 'オプチカルユニット',
      'Rear Power Unit': 'リアユニット',
      'Right Arm Unit': 'ライトアームユニット',
      'I am the Omega': 'ワタシはオメガであり'
    },
    'replaceText': {
      'Advanced Optical Laser': 'オプチカルレーザーS',
      'Advanced Suppression': '援護プログラムS',
      '(?<! )Archive All': 'アーカイブオール',
      '(?<! )Archive Peripheral': 'アーカイブアーム',
      'Beyond Defense': 'シールドコンボS',
      'Beyond Strength': 'シールドコンボG',
      'Cascading Latent Defect': 'レイテンドバグ：デグレード',
      'Colossal Blow': 'コロッサスブロー',
      'Cosmo Memory': 'コスモメモリー',
      'Critical Error': 'クリティカルエラー',
      'Critical Overflow Bug': 'クリティカルバグ：サークル',
      'Critical Synchronization Bug': 'クリティカルバグ：シェア',
      'Critical Underflow Bug': 'クリティカルバグ：デグレード',
      'Delta Attack': 'デルタアタック',
      'Diffuse Wave Cannon': '拡散波動砲',
      'Discharger': 'ディスチャージャー',
      'Efficient Bladework': 'ソードアクション',
      'Electric Slide': 'オメガスライド',
      'Firewall': 'ガードプログラム',
      'Floodlight': 'フラッドライト',
      'Fundamental Synergy': '連携プログラムC',
      'Hello, World': 'ハロー・ワールド',
      'Hyper Pulse': 'ハイパーパルス',
      'Index and Archive Peripheral': 'アーカイブアームX',
      'Ion Efflux': 'イオンエフラクス',
      'Laser Shower': 'レーザーシャワー',
      'Operational Synergy': '連携プログラムW',
      '(?<! )Optical Laser': 'オプチカルレーザーF',
      'Optimized Blade Dance': 'ブレードダンス・オメガ',
      'Optimized Blizzard III': 'ブリザガ・オメガ',
      'Optimized Fire III': 'ファイラ・オメガ',
      'Optimized Meteor': 'メテオ・オメガ',
      'Optimized Sagittarius Arrow': 'サジタリウスアロー・オメガ',
      'Oversampled Wave Cannon': '検知式波動砲',
      'Patch': 'エンバグ',
      'Pile Pitch': 'パイルピッチ',
      'Program Omega': 'プログラム・オメガ',
      'Resonance': 'レゾナンス',
      'Savage Wave Cannon': '零式波動砲',
      'Solar Ray': 'ソーラレイ',
      'Spotlight': 'スポットライト',
      'Subject Simulation F': 'トランスフォームF',
      'Subject Simulation M': 'トランスフォームM',
      'Superliminal Motion': 'ブレードコンボF',
      'Superliminal Steel': 'ブレードコンボB',
      '(?<! )Suppression': '援護プログラムF',
      'Synthetic Blades': 'ブレードオプション',
      'Synthetic Shield': 'シールドオプション',
      'Target Analysis': '標的識別',
      '(?<! )Wave Cannon': '波動砲'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Left Arm Unit': '左臂组',
      'Omega(?!-)': '欧米茄',
      'Omega-F': '欧米茄F',
      'Omega-M': '欧米茄M',
      'Optical Unit': '视觉组',
      'Rear Power Unit': '尾部组',
      'Right Arm Unit': '右臂组'
    },
    'replaceText': {
      'Advanced Optical Laser': '光学射线S',
      'Advanced Suppression': '援护程序S',
      '(?<! )Archive All': '全归档',
      '(?<! )Archive Peripheral': '手臂归档',
      'Beyond Defense': '盾连击S',
      'Beyond Strength': '盾连击G',
      'Cascading Latent Defect': '潜在错误：下溢',
      'Colossal Blow': '巨能爆散',
      'Cosmo Memory': '宇宙记忆',
      'Critical Error': '严重错误',
      'Critical Overflow Bug': '严重错误：上溢',
      'Critical Synchronization Bug': '严重错误：同步',
      'Critical Underflow Bug': '严重错误：下溢',
      'Delta Attack': '三角攻击',
      'Diffuse Wave Cannon': '扩散波动炮',
      'Discharger': '能量放出',
      'Efficient Bladework': '剑击',
      'Electric Slide': '欧米茄滑跃',
      'Firewall': '防御程序',
      'Floodlight': '泛光灯',
      'Fundamental Synergy': '协作程序C',
      'Hello, World': '你好，世界',
      'Hyper Pulse': '超能脉冲',
      'Index and Archive Peripheral': '手臂归档X',
      'Ion Efflux': '离子流出',
      'Laser Shower': '激光骤雨',
      'Operational Synergy': '协作程序W',
      '(?<! )Optical Laser': '光学射线F',
      'Optimized Blade Dance': '欧米茄刀光剑舞',
      'Optimized Blizzard III': '欧米茄冰封',
      'Optimized Fire III': '欧米茄烈炎',
      'Optimized Meteor': '欧米茄陨石流星',
      'Optimized Sagittarius Arrow': '欧米茄射手天箭',
      'Oversampled Wave Cannon': '探测式波动炮',
      'Patch': '补丁',
      'Pile Pitch': '能量投射',
      'Program Omega': '程序·欧米茄',
      'Resonance': '共鸣',
      'Savage Wave Cannon': '零式波动炮',
      'Solar Ray': '太阳射线',
      'Spotlight': '聚光灯',
      'Subject Simulation F': '变形F',
      'Subject Simulation M': '变形M',
      'Superliminal Motion': '剑连击F',
      'Superliminal Steel': '剑连击B',
      '(?<! )Suppression': '援护程序F',
      'Synthetic Blades': '合成剑',
      'Synthetic Shield': '合成盾',
      'Target Analysis': '目标识别',
      '(?<! )Wave Cannon': '波动炮'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Left Arm Unit': '왼팔 유닛',
      'Omega(?!-)': '오메가',
      'Omega-F': '오메가 F',
      'Omega-M': '오메가 M',
      'Optical Unit': '광학 유닛',
      'Rear Power Unit': '후면 유닛',
      'Right Arm Unit': '오른팔 유닛'
    },
    'replaceText': {
      'Advanced Optical Laser': '광학 레이저 S',
      'Advanced Suppression': '지원 프로그램 S',
      '(?<! )Archive All': '전체 기록 보존',
      '(?<! )Archive Peripheral': '기록 보존 장치',
      'Beyond Defense': '방패 연격 S',
      'Beyond Strength': '방패 연격 G',
      'Cascading Latent Defect': '잠재적 오류: 전이',
      'Colossal Blow': '광역 폭파',
      'Cosmo Memory': '세계의 기억',
      'Critical Error': '치명적인 오류',
      'Critical Overflow Bug': '치명적 오류: 광역',
      'Critical Synchronization Bug': '치명적 오류: 분배',
      'Critical Underflow Bug': '치명적 오류: 전이',
      'Delta Attack': '델타 공격',
      'Diffuse Wave Cannon': '확산 파동포',
      'Discharger': '방출',
      'Efficient Bladework': '검격',
      'Electric Slide': '오메가 슬라이드',
      'Firewall': '방어 프로그램',
      'Floodlight': '투광 조명',
      'Fundamental Synergy': '연계 프로그램 C',
      'Hello, World': '헬로 월드',
      'Hyper Pulse': '초파동 광선',
      'Index and Archive Peripheral': '기록 보존 장치 X',
      'Ion Efflux': '이온 유출',
      'Laser Shower': '레이저 세례',
      'Operational Synergy': '연계 프로그램 W',
      '(?<! )Optical Laser': '광학 레이저 F',
      'Optimized Blade Dance': '쾌검난무: 오메가',
      'Optimized Blizzard III': '블리자가: 오메가',
      'Optimized Fire III': '파이라: 오메가',
      'Optimized Meteor': '메테오 : 오메가',
      'Optimized Sagittarius Arrow': '궁수자리 화살: 오메가',
      'Oversampled Wave Cannon': '감지식 파동포',
      'Patch': '연쇄 오류',
      'Pile Pitch': '에너지 투사',
      'Program Omega': '프로그램: 오메가',
      'Resonance': '공명',
      'Savage Wave Cannon': '프로그램: 오메가',
      'Solar Ray': '태양 광선',
      'Spotlight': '집중 조명',
      'Subject Simulation F': '형태 변경 F',
      'Subject Simulation M': '형태 변경 M',
      'Superliminal Motion': '칼날 연격 F',
      'Superliminal Steel': '칼날 연격 B',
      '(?<! )Suppression': '지원 프로그램 F',
      'Synthetic Blades': '칼날 장착',
      'Synthetic Shield': '방패 장착',
      'Target Analysis': '표적 식별',
      '(?<! )Wave Cannon': '파동포'
    }
  }]
};
/* harmony default export */ const o12s = (o12s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o12s.txt
const raid_o12s_namespaceObject = "# Omega - Alphascape V4.0 (Savage) - O12S\r\n# -p 32FD:11.7\r\n# -it \"Omega-M\"\r\n# -ii 3326 337D 32F7 32FA 32F5 3302 32FC 32F9 32FA 32F8 32FB 32FC 330C 330B 32FE 32F2 3348 332C 3340 3350 3352 332D 3330 3331 3337 3338 333A 333C 333E\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n# Use autos/BattleTalk2 instead of InCombat lines to start timelines for door & final boss\r\n# as timeline resets out of combat.\r\n\r\n# https://xivapi.com/InstanceContentTextData/20600\r\n# en: I am the Omega and the Alpha. I will mimic your weakness to comprehend your strength.\r\n0.0 \"Start\" BattleTalk2 { instanceContentTextId: \"5078\" } window 1,1\r\n2.4 \"--sync--\" Ability { id: \"337D\", source: \"Omega-M\" } window 2.4,0.5 # first auto\r\n11.7 \"Synthetic Shield\" Ability { id: \"32FD\", source: \"Omega-M\" } window 12,5\r\n19.7 \"Suppression\" Ability { id: \"3345\", source: \"Omega-M\" }\r\n26.6 \"Beyond Defense\" Ability { id: \"332B\", source: \"Omega-M\" }\r\n26.7 \"Optical Laser\" Ability { id: \"3347\", source: \"Optical Unit\" }\r\n26.9 \"Beyond Defense\" Ability { id: \"332C\", source: \"Omega-M\" }\r\n30.1 \"Pile Pitch\" Ability { id: \"332E\", source: \"Omega-M\" }\r\n\r\n# F phase\r\n49.1 \"Subject Simulation F\" Ability { id: \"32F1\", source: \"Omega-M\" }\r\n61.2 \"Discharger\" Ability { id: \"3327\", source: \"Omega-M\" } # drift -0.044\r\n73.2 \"Synthetic Blades\" Ability { id: \"3301\", source: \"Omega-M\" }\r\n81.2 \"Advanced Suppression\" Ability { id: \"3349\", source: \"Omega-M\" }\r\n87.2 \"Superliminal Motion\" Ability { id: \"3334\", source: \"Omega-M\" }\r\n88.2 \"Advanced Optical Laser\" Ability { id: \"334A\", source: \"Optical Unit\" }\r\n90.3 \"Optimized Fire III\" Ability { id: \"3335\", source: \"Omega-M\" } # drift 0.047\r\n\r\n# Twin phase\r\n102.6 \"Subject Simulation M\" Ability { id: \"32F4\", source: \"Omega-M\" } window 200,10\r\n108.9 \"--untargetable--\"\r\n114.1 \"Electric Slide\" Ability { id: \"3354\", source: \"Omega\" }\r\n122.7 \"Discharger\" Ability { id: \"3327\", source: \"Omega\" }\r\n122.7 \"Efficient Bladework\" Ability { id: \"3329\", source: \"Omega-M\" }\r\n125.7 \"--targetable--\"\r\n132.0 \"Firewall\" Ability { id: \"3339\", source: \"Omega\" } window 132,0\r\n141.2 \"Resonance\" Ability { id: \"333B\", source: \"Omega\" }\r\n155.6 \"Fundamental Synergy\" Ability { id: \"333D\", source: \"Omega\" }\r\n\r\n# Slides\r\n160.7 \"Advanced Suppression\" Ability { id: \"3349\", source: \"Omega\" }\r\n163.9 \"--untargetable--\"\r\n164.2 \"Electric Slide 1\"\r\n166.0 \"Electric Slide 2\"\r\n167.7 \"Electric Slide 3\"\r\n167.8 \"Advanced Optical Laser\" Ability { id: \"334A\", source: \"Optical Unit\" }\r\n169.4 \"Electric Slide 4\"\r\n170.7 \"--targetable--\"\r\n180.1 \"Laser Shower\" Ability { id: \"3353\", source: \"Omega\" }\r\n189.3 \"Solar Ray\" Ability { id: \"3351\", source: \"Omega\" }\r\n\r\n# Branch point\r\n200.5 \"Synthetic Blades/Synthetic Shield\" Ability { id: \"32FD\", source: \"Omega-M\" } jump 1200.5  # shield -> blades path\r\n200.5 \"--sync--\" Ability { id: \"3301\", source: \"Omega\" } jump 2200.5 # blades -> shield path\r\n212.2 \"Operational Synergy\"\r\n218.2 \"Beyond Defense?\"\r\n218.2 \"Superliminal Steel?\"\r\n219.8 \"Optimized Blizzard III\"\r\n221.5 \"Pile Pitch\"\r\n228.8 \"Optimized Fire III\"\r\n\r\n# Shield-first path\r\n1200.5 \"Synthetic Shield\" Ability { id: \"32FD\", source: \"Omega-M\" }\r\n1212.2 \"Operational Synergy\" Ability { id: \"3341\", source: \"Omega\" }\r\n1219.2 \"Beyond Defense\" Ability { id: \"332B\", source: \"Omega-M\" }\r\n1219.4 \"Optimized Blizzard III\" Ability { id: \"3333\", source: \"Omega\" }\r\n1222.7 \"Pile Pitch\" Ability { id: \"332E\", source: \"Omega-M\" }\r\n1227.4 \"Optimized Fire III\" Ability { id: \"3337\", source: \"Omega-F\" }\r\n1230.7 \"Beyond Strength\" Ability { id: \"3328\", source: \"Omega-M\" }\r\n1233.7 \"Efficient Bladework\" Ability { id: \"3329\", source: \"Omega-M\" }\r\n1234.4 \"Laser Shower\" Ability { id: \"3353\", source: \"Omega\" }\r\n1241.4 \"Laser Shower\" Ability { id: \"3353\", source: \"Omega\" }\r\n1250.9 \"Firewall\" Ability { id: \"3339\", source: \"Omega\" }\r\n1260.1 \"Resonance\" Ability { id: \"333B\", source: \"Omega\" }\r\n1274.5 \"Fundamental Synergy\" Ability { id: \"333D\", source: \"Omega\" }\r\n1279.6 \"Advanced Suppression\" Ability { id: \"3349\", source: \"Omega\" }\r\n1282.3 \"--untargetable--\"\r\n1282.6 \"Electric Slide 1\" #Ability { id: \"333F\", source: \"Omega\" }\r\n1284.3 \"Electric Slide 2\" #Ability { id: \"333F\", source: \"Omega\" }\r\n1286.0 \"Electric Slide 3\" #Ability { id: \"333F\", source: \"Omega\" }\r\n1286.5 \"Advanced Optical Laser\" Ability { id: \"334A\", source: \"Optical Unit\" }\r\n1287.7 \"Electric Slide 4\" #Ability { id: \"333F\", source: \"Omega\" }\r\n1289.0 \"--targetable--\"\r\n1298.4 \"Laser Shower\" Ability { id: \"3353\", source: \"Omega\" }\r\n1307.4 \"Solar Ray\" Ability { id: \"3351\", source: \"Omega\" }\r\n1318.4 \"Synthetic Blades\" Ability { id: \"3301\", source: \"Omega\" }\r\n1329.4 \"Operational Synergy\" Ability { id: \"3341\", source: \"Omega\" }\r\n1334.4 \"Superliminal Steel\" Ability { id: \"3331\", source: \"Omega-F\" }\r\n1337.6 \"Optimized Blizzard III\" Ability { id: \"3332\", source: \"Omega\" }\r\n1337.7 \"Pile Pitch\" Ability { id: \"332E\", source: \"Omega-M\" }\r\n1343.8 \"Superliminal Motion\" Ability { id: \"3334\", source: \"Omega\" }\r\n1347.0 \"Optimized Fire III\" Ability { id: \"3337\", source: \"Omega-F\" }\r\n1348.2 \"Efficient Bladework\" Ability { id: \"332A\", source: \"Omega-M\" }\r\n1356.4 \"Laser Shower\" Ability { id: \"3352\", source: \"Omega-M\" }\r\n1363.4 \"Laser Shower\" Ability { id: \"3353\", source: \"Omega\" }\r\n1378.0 \"Suppression\" Ability { id: \"3346\", source: \"Omega\" } jump 2578\r\n1385.1 \"Optical Laser\" # Cosmetic\r\n1385.4 \"Optimized Meteor\"\r\n1385.6 \"Optimized Sagittarius Arrow\"\r\n1396.4 \"Cosmo Memory\"\r\n1404.4 \"Laser Shower\"\r\n\r\n# Blades-first path\r\n2200.5 \"Synthetic Blades\" Ability { id: \"3301\", source: \"Omega\" }\r\n2212.2 \"Operational Synergy\" Ability { id: \"3341\", source: \"Omega\" }\r\n2217.2 \"Superliminal Steel\" Ability { id: \"332F\", source: \"Omega\" }\r\n2220.3 \"Optimized Blizzard III\" Ability { id: \"3332\", source: \"Omega\" }\r\n2220.3 \"Pile Pitch\" Ability { id: \"332E\", source: \"Omega-M\" }\r\n2226.2 \"Superliminal Motion\" Ability { id: \"3334\", source: \"Omega\" }\r\n2229.2 \"Optimized Fire III\" Ability { id: \"3335\", source: \"Omega\" }\r\n2230.4 \"Efficient Bladework\" Ability { id: \"332A\", source: \"Omega-M\" }\r\n2238.2 \"Laser Shower\" Ability { id: \"3353\", source: \"Omega\" }\r\n2250.4 \"Firewall\" Ability { id: \"3339\", source: \"Omega\" }\r\n2259.4 \"Resonance\" Ability { id: \"333B\", source: \"Omega\" }\r\n2273.4 \"Fundamental Synergy\" Ability { id: \"333D\", source: \"Omega\" }\r\n2278.4 \"Advanced Suppression\" Ability { id: \"3349\", source: \"Omega\" }\r\n2281.6 \"--untargetable--\"\r\n2282.0 \"Electric Slide 1\" #Ability { id: \"333F\", source: \"Omega\" }\r\n2283.9 \"Electric Slide 2\" #Ability { id: \"333F\", source: \"Omega\" }\r\n2285.5 \"Advanced Optical Laser\" Ability { id: \"334A\", source: \"Optical Unit\" }\r\n2285.8 \"Electric Slide 3\" #Ability { id: \"333F\", source: \"Omega\" }\r\n2287.7 \"Electric Slide 4\" #Ability { id: \"333F\", source: \"Omega\" }\r\n2288.8 \"--targetable--\"\r\n2298.2 \"Laser Shower\" Ability { id: \"3353\", source: \"Omega\" }\r\n2306.2 \"Solar Ray\" Ability { id: \"3351\", source: \"Omega\" }\r\n2317.2 \"Synthetic Shield\" Ability { id: \"32FD\", source: \"Omega-M\" }\r\n2328.2 \"Operational Synergy\" Ability { id: \"3341\", source: \"Omega\" }\r\n2335.1 \"Beyond Defense\" Ability { id: \"332B\", source: \"Omega-M\" }\r\n2335.4 \"Optimized Blizzard III\" Ability { id: \"3333\", source: \"Omega\" }\r\n2338.6 \"Pile Pitch\" Ability { id: \"332E\", source: \"Omega-M\" }\r\n2343.4 \"Optimized Fire III\" Ability { id: \"3336\", source: \"Omega\" }\r\n2346.6 \"Beyond Strength\" Ability { id: \"3328\", source: \"Omega-M\" }\r\n2349.6 \"Efficient Bladework\" Ability { id: \"3329\", source: \"Omega-M\" }\r\n2350.4 \"Laser Shower\" Ability { id: \"3353\", source: \"Omega\" }\r\n2357.4 \"Laser Shower\" Ability { id: \"3353\", source: \"Omega\" }\r\n2375.7 \"Suppression\" Ability { id: \"3346\", source: \"Omega\" } jump 2578\r\n2382.7 \"Optical Laser\" # Cosmetic\r\n2382.7 \"Optimized Meteor\"\r\n2382.8 \"Optimized Sagittarius Arrow\"\r\n2393.3 \"Cosmo Memory\"\r\n2401.3 \"Laser Shower\"\r\n\r\n# Paths converge to enrage sequence\r\n2578.0 \"Suppression\" Ability { id: \"3346\", source: \"Omega\" }\r\n2585.1 \"Optical Laser\" Ability { id: \"3347\", source: \"Optical Unit\" }\r\n2585.4 \"Optimized Meteor\" Ability { id: \"334F\", source: \"Omega-F\" }\r\n2585.6 \"Optimized Sagittarius Arrow\" Ability { id: \"334D\", source: \"Omega-M\" }\r\n2596.4 \"Cosmo Memory\" Ability { id: \"3343\", source: \"Omega\" }\r\n2604.4 \"Laser Shower\" Ability { id: \"3353\", source: \"Omega\" }\r\n2612.4 \"Optimized Blade Dance\" Ability { id: \"334C\", source: \"Omega\" }\r\n2630.4 \"Advanced Suppression\" Ability { id: \"3349\", source: \"Omega\" }\r\n2637.4 \"Advanced Optical Laser\" Ability { id: \"334A\", source: \"Optical Unit\" }\r\n2637.4 \"Optimized Meteor\" Ability { id: \"334F\", source: \"Omega-F\" }\r\n2637.4 \"Optimized Sagittarius Arrow\" Ability { id: \"334D\", source: \"Omega-M\" }\r\n2647.9 \"Cosmo Memory\" Ability { id: \"3343\", source: \"Omega\" }\r\n2655.9 \"Laser Shower\" Ability { id: \"3353\", source: \"Omega\" }\r\n2663.9 \"Optimized Blade Dance\" Ability { id: \"334C\", source: \"Omega\" }\r\n2679.4 \"Cosmo Memory\" Ability { id: \"33EC\", source: \"Omega\" }\r\n\r\n# Final Omega - Alphascape V4.0 (Savage) - O12S+\r\n# -r ch1gtabdwN7QYDR6 -p 336C:3016 -ii 3380 3369 3366 335F 3377 336B 33B5\r\n\r\n3000.0 \"Start\"\r\n3002.5 \"--sync--\" Ability { id: \"3380\", source: \"Omega\" } window 3003,0\r\n3016.0 \"Target Analysis\" Ability { id: \"336C\", source: \"Omega\" }\r\n3019.0 \"Savage Wave Cannon\" Ability { id: \"336D\", source: \"Omega\" }\r\n3027.5 \"Patch\" Ability { id: \"3376\", source: \"Omega\" }\r\n3034.5 \"Diffuse Wave Cannon\" Ability { id: \"336[78]\", source: \"Omega\" } # drift 0.046001\r\n3042.5 \"Oversampled Wave Cannon\" Ability { id: \"336[45]\", source: \"Omega\" }\r\n3054.5 \"Ion Efflux\" Ability { id: \"3357\", source: \"Omega\" }\r\n3062.6 \"--sync--\" Ability { id: \"3381\", source: \"Omega\" }\r\n3069.9 \"Hello, World\" Ability { id: \"336E\", source: \"Omega\" }\r\n3078.0 \"Critical Synchronization Bug\" #Ability { id: \"336F\", source: \"Omega\" }\r\n3078.0 \"Critical Overflow Bug\" #Ability { id: \"34E7\", source: \"Omega\" }\r\n3082.9 \"Critical Synchronization Bug\" #Ability { id: \"336F\", source: \"Omega\" }\r\n3086.1 \"Critical Overflow Bug\" #Ability { id: \"34E7\", source: \"Omega\" }\r\n3086.1 \"Critical Synchronization Bug\" #Ability { id: \"336F\", source: \"Omega\" }\r\n3094.2 \"Critical Overflow Bug\" #Ability { id: \"34E7\", source: \"Omega\" }\r\n3097.0 \"Critical Error\" Ability { id: \"337E\", source: \"Omega\" }\r\n3105.1 \"Critical Overflow Bug\" #Ability { id: \"34E7\", source: \"Omega\" }\r\n3105.1 \"Critical Overflow Bug\" #Ability { id: \"34E7\", source: \"Omega\" }\r\n3113.1 \"Ion Efflux\" Ability { id: \"3357\", source: \"Omega\" }\r\n3119.3 \"--sync--\" Ability { id: \"3381\", source: \"Omega\" }\r\n3124.4 \"Archive Peripheral\" Ability { id: \"3358\", source: \"Omega\" } # drift -0.042999\r\n3140.5 \"Hyper Pulse\" Ability { id: \"335A\", source: \"Right Arm Unit\" }\r\n3145.6 \"Target Analysis\" Ability { id: \"336C\", source: \"Omega\" }\r\n3149.0 \"Savage Wave Cannon\" Ability { id: \"336D\", source: \"Omega\" }\r\n3152.0 \"--sync--\" Ability { id: \"3359\", source: \"Omega\" } # drift 0.05\r\n3161.2 \"Diffuse Wave Cannon\" Ability { id: \"336[78]\", source: \"Omega\" }\r\n3169.4 \"Oversampled Wave Cannon\" Ability { id: \"336[45]\", source: \"Omega\" }\r\n3183.6 \"Index and Archive Peripheral\" Ability { id: \"339A\", source: \"Omega\" }\r\n3188.8 \"--sync--\" Ability { id: \"3381\", source: \"Omega\" }\r\n3197.8 \"Hyper Pulse\" Ability { id: \"335C\", source: \"Right Arm Unit\" } duration 6.5\r\n3198.0 \"Wave Cannon\" Ability { id: \"336A\", source: \"Omega\" }\r\n3206.2 \"Target Analysis\" Ability { id: \"336C\", source: \"Omega\" }\r\n3209.2 \"Savage Wave Cannon\" Ability { id: \"336D\", source: \"Omega\" } # drift 0.047\r\n3212.2 \"--sync--\" Ability { id: \"3359\", source: \"Omega\" }\r\n3234.2 \"Patch\" Ability { id: \"3376\", source: \"Omega\" }\r\n3241.2 \"Diffuse Wave Cannon\" Ability { id: \"336[78]\", source: \"Omega\" }\r\n3249.4 \"Oversampled Wave Cannon\" Ability { id: \"336[45]\", source: \"Omega\" }\r\n3261.5 \"Ion Efflux\" Ability { id: \"3357\", source: \"Omega\" } # drift -0.049001\r\n3269.8 \"Archive All\" Ability { id: \"335D\", source: \"Omega\" }\r\n3283.0 \"Electric Slide\" Ability { id: \"3363\", source: \"Omega\" } # drift 0.05\r\n3289.1 \"Delta Attack\" Ability { id: \"3378\", source: \"Omega\" }\r\n3292.2 \"Floodlight\" Ability { id: \"337A\", source: \"Omega\" }\r\n3294.1 \"Optimized Fire III\" Ability { id: \"3379\", source: \"Omega\" } # drift 0.042001\r\n3294.1 \"Spotlight\" Ability { id: \"337B\", source: \"Omega\" }\r\n3297.0 \"Colossal Blow\" Ability { id: \"3360\", source: \"Left Arm Unit\" }\r\n3299.3 \"--sync--\" Ability { id: \"335E\", source: \"Omega\" }\r\n3307.5 \"Diffuse Wave Cannon\" Ability { id: \"336[78]\", source: \"Omega\" }\r\n3320.8 \"--sync--\" Ability { id: \"3381\", source: \"Omega\" }\r\n3328.0 \"Hello, World\" Ability { id: \"336E\", source: \"Omega\" }\r\n3336.1 \"Critical Synchronization Bug\" #Ability { id: \"336F\", source: \"Omega\" }\r\n3336.1 \"Critical Overflow Bug\" #Ability { id: \"34E7\", source: \"Omega\" }\r\n3341.1 \"Critical Synchronization Bug\" #Ability { id: \"336F\", source: \"Omega\" }\r\n3343.2 \"Critical Underflow Bug\" #Ability { id: \"3371\", source: \"Omega\" }\r\n3344.2 \"Critical Overflow Bug\" #Ability { id: \"34E7\", source: \"Omega\" }\r\n3344.2 \"Critical Synchronization Bug\" #Ability { id: \"336F\", source: \"Omega\" }\r\n3344.2 \"Critical Overflow Bug\" #Ability { id: \"34E7\", source: \"Omega\" }\r\n3345.8 \"Critical Underflow Bug\" #Ability { id: \"3371\", source: \"Omega\" }\r\n3349.2 \"Critical Underflow Bug\" #Ability { id: \"3371\", source: \"Omega\" }\r\n3352.2 \"Critical Overflow Bug\" #Ability { id: \"34E7\", source: \"Omega\" }\r\n3353.3 \"Critical Underflow Bug\" #Ability { id: \"3371\", source: \"Omega\" }\r\n3355.3 \"Critical Error\" Ability { id: \"337E\", source: \"Omega\" }\r\n3358.3 \"Cascading Latent Defect\" Ability { id: \"3373\", source: \"Omega\" }\r\n3360.9 \"Critical Underflow Bug\" #Ability { id: \"3371\", source: \"Omega\" } # drift 0.042999\r\n3362.6 \"Critical Underflow Bug\" #Ability { id: \"3371\", source: \"Omega\" }\r\n3362.8 \"Critical Underflow Bug\" #Ability { id: \"3371\", source: \"Omega\" }\r\n3363.4 \"Critical Overflow Bug\" #Ability { id: \"34E7\", source: \"Omega\" } # drift -0.041\r\n3371.5 \"Ion Efflux\" Ability { id: \"3357\", source: \"Omega\" }\r\n3377.7 \"--sync--\" Ability { id: \"3381\", source: \"Omega\" } # drift 0.042001\r\n3382.7 \"Archive Peripheral\" Ability { id: \"3358\", source: \"Omega\" }\r\n3399.0 \"Hyper Pulse\" Ability { id: \"335A\", source: \"Right Arm Unit\" } duration 6.5\r\n3403.9 \"Target Analysis\" Ability { id: \"336C\", source: \"Omega\" }\r\n3407.4 \"Savage Wave Cannon\" Ability { id: \"336D\", source: \"Omega\" } # drift 0.043999\r\n3410.5 \"--sync--\" Ability { id: \"3359\", source: \"Omega\" }\r\n3419.6 \"Diffuse Wave Cannon\" Ability { id: \"336[78]\", source: \"Omega\" }\r\n3427.8 \"Oversampled Wave Cannon\" Ability { id: \"336[45]\", source: \"Omega\" }\r\n3442.0 \"Index and Archive Peripheral\" Ability { id: \"339A\", source: \"Omega\" }\r\n3447.2 \"--sync--\" Ability { id: \"3381\", source: \"Omega\" }\r\n3456.3 \"Hyper Pulse\" Ability { id: \"335C\", source: \"Right Arm Unit\" } duration 6.5\r\n3456.4 \"Wave Cannon\" Ability { id: \"336A\", source: \"Omega\" }\r\n3464.5 \"Target Analysis\" Ability { id: \"336C\", source: \"Omega\" }\r\n3467.8 \"Savage Wave Cannon\" Ability { id: \"336D\", source: \"Omega\" }\r\n3470.9 \"--sync--\" Ability { id: \"3359\", source: \"Omega\" } # drift -0.047\r\n3493.1 \"Patch\" Ability { id: \"3376\", source: \"Omega\" }\r\n3500.2 \"Diffuse Wave Cannon\" Ability { id: \"336[78]\", source: \"Omega\" }\r\n3508.4 \"Oversampled Wave Cannon\" Ability { id: \"336[45]\", source: \"Omega\" }\r\n3520.7 \"Ion Efflux\" Ability { id: \"3357\", source: \"Omega\" }\r\n3529.0 \"Archive All\" Ability { id: \"335D\", source: \"Omega\" } # drift -0.045999\r\n3542.1 \"Electric Slide\" Ability { id: \"3363\", source: \"Omega\" }\r\n3548.2 \"Delta Attack\" Ability { id: \"3378\", source: \"Omega\" }\r\n3551.3 \"Floodlight\" Ability { id: \"337A\", source: \"Omega\" }\r\n3553.3 \"Optimized Fire III\" Ability { id: \"3379\", source: \"Omega\" } # drift 0.043999\r\n3553.3 \"Spotlight\" Ability { id: \"337B\", source: \"Omega\" }\r\n3556.1 \"Colossal Blow\" Ability { id: \"3360\", source: \"Left Arm Unit\" }\r\n3558.3 \"--sync--\" Ability { id: \"335E\", source: \"Omega\" }\r\n3566.5 \"Diffuse Wave Cannon\" Ability { id: \"336[78]\", source: \"Omega\" } # drift -0.042\r\n3579.8 \"--sync--\" Ability { id: \"3381\", source: \"Omega\" }\r\n3585.2 \"Program Omega\" Ability { id: \"360A\", source: \"Omega\" }\r\n3587.3 \"Ion Efflux\" Ability { id: \"3355\", source: \"Omega\" }\r\n# Skipping the 3356 small explosions\r\n3596.4 \"Ion Efflux\" Ability { id: \"35E1\", source: \"Omega\" }\r\n3599.6 \"Ion Efflux\" Ability { id: \"3355\", source: \"Omega\" }\r\n3608.7 \"Ion Efflux\" Ability { id: \"35E1\", source: \"Omega\" }\r\n3611.8 \"Ion Efflux\" Ability { id: \"3355\", source: \"Omega\" }\r\n3620.9 \"Ion Efflux\" Ability { id: \"35E1\", source: \"Omega\" }\r\n3624.1 \"Ion Efflux\" Ability { id: \"3355\", source: \"Omega\" }\r\n3633.3 \"Ion Efflux\" Ability { id: \"35E1\", source: \"Omega\" }\r\n3646.4 \"Enrage\" Ability { id: \"337C\", source: \"Omega\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o1n.ts


// O1S - Deltascape 1.0 Normal
const o1n_triggerSet = {
  id: 'DeltascapeV10',
  zoneId: zone_id/* default.DeltascapeV10 */.Z.DeltascapeV10,
  timelineFile: 'o1n.txt',
  timelineTriggers: [{
    id: 'O1N Wyrm Tail',
    regex: /Wyrm Tail/,
    beforeSeconds: 4,
    response: responses/* Responses.miniBuster */.n3.miniBuster()
  }],
  triggers: [{
    id: 'O1N Blaze',
    type: 'StartsUsing',
    netRegex: {
      id: '23E1',
      source: 'Alte Roite'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'O1N Breath Wing',
    type: 'StartsUsing',
    netRegex: {
      id: '23DE',
      source: 'Alte Roite',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Breath Wing: Be beside boss',
        de: 'Atemschwinge: Neben Boss gehen',
        fr: 'Aile déferlante : Placez-vous à côté du boss',
        ja: 'ブレスウィング: ボスに近づく',
        cn: '站boss附近',
        ko: '날개바람: 보스 옆으로'
      }
    }
  }, {
    id: 'O1N Clamp',
    type: 'StartsUsing',
    netRegex: {
      id: '23E2',
      source: 'Alte Roite',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    // Knockback immunities don't work.
    id: 'O1N Downburst',
    type: 'StartsUsing',
    netRegex: {
      id: '1ED8',
      source: 'Alte Roite',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'O1N Roar',
    type: 'StartsUsing',
    netRegex: {
      id: '23DC',
      source: 'Alte Roite',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O1N Charybdis',
    type: 'StartsUsing',
    netRegex: {
      id: '23DB',
      source: 'Alte Roite',
      capture: false
    },
    condition: data => data.role === 'healer' || data.job === 'BLU',
    // Alert rather than info, as any further raid damage is lethal if unhealed.
    response: responses/* Responses.aoe */.n3.aoe('alert')
  }, {
    id: 'O1N Twin Bolt',
    type: 'StartsUsing',
    netRegex: {
      id: '23D7',
      source: 'Alte Roite'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    // This ID is NOT the same as the one that actually hits players. Levinbolt is first
    // cast by Alte Roite on Alte Roite, and when that resolves the markers on players resolve
    // with 23DA.
    id: 'O1N Levinbolt',
    type: 'StartsUsing',
    netRegex: {
      id: '23D9',
      source: 'Alte Roite',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Ball Of Fire': 'Feuerkugel',
      'Alte Roite': 'Alte Roite'
    },
    'replaceText': {
      'Wyrm Tail': 'Antiker Drachenschweif',
      'Twin Bolt': 'Zwillingsschlag',
      'The Classical Elements': 'Klassisches Element',
      'Roar': 'Brüllen',
      'Levinbolt': 'Blitzschlag',
      'Flash Freeze': 'Blitzeis',
      'Flame': 'Flamme',
      'Downburst': 'Fallböe',
      'Clamp': 'Klammer',
      'Charybdis': 'Charybdis',
      'Burn': 'Verbrennung',
      'Breath Wing': 'Atemschwinge',
      'Blaze': 'Frost'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ball Of Fire': 'boule ardente',
      'Alte Roite': 'Alte Roite'
    },
    'replaceText': {
      'Wyrm Tail': 'Queue du dragon ancestral',
      'Twin Bolt': 'Éclairs jumeaux',
      'The Classical Elements': 'Élément neutre',
      'Roar': 'Rugissement',
      'Levinbolt': 'Fulguration',
      'Flash Freeze': 'Glaciation instantanée',
      'Flame': 'Flamme',
      'Downburst': 'Rafale descendante',
      'Clamp': 'Pinçage',
      'Charybdis': 'Charybde',
      'Burn': 'Combustion',
      'Breath Wing': 'Aile déferlante',
      'Blaze': 'Givre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ball Of Fire': '火炎球',
      'Alte Roite': 'アルテ・ロイテ'
    },
    'replaceText': {
      'Wyrm Tail': '太古の龍尾',
      'Twin Bolt': 'ツインボルト',
      'The Classical Elements': 'クラシカルエレメント',
      'Roar': '咆哮',
      'Levinbolt': '稲妻',
      'Flash Freeze': 'フラッシュフリーズ',
      'Flame': '炎',
      'Downburst': 'ダウンバースト',
      'Clamp': 'クランプ',
      'Charybdis': 'ミールストーム',
      'Burn': '燃焼',
      'Breath Wing': 'ブレスウィング',
      'Blaze': 'ブレイズ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ball Of Fire': '火焰球',
      'Alte Roite': '老者'
    },
    'replaceText': {
      'Wyrm Tail': '太古龙尾',
      'Twin Bolt': '双重落雷',
      'The Classical elements': '经典元素',
      'Roar': '咆哮',
      'Levinbolt': '闪电',
      'Flash Freeze': '闪耀冻结',
      'Flame': '火焰',
      'Downburst': '下行突风',
      'Clamp': '压迫',
      'Charybdis': '大漩涡',
      'Burn': '燃烧',
      'Breath Wing': '风息之翼',
      'Blaze': '冰焰'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Alte Roite': '알테 로이테',
      'Ball Of Fire': '화염 구체'
    },
    'replaceText': {
      'Wyrm Tail': '태고의 용 꼬리',
      'Twin Bolt': '이중 낙뢰',
      'The Classical Elements': '고대의 원소',
      'Roar': '포효',
      'Levinbolt': '우레',
      'Flash Freeze': '급속 동결',
      'Flame': '불꽃',
      'Downburst': '하강 기류',
      'Clamp': '압박',
      'Charybdis': '대소용돌이',
      'Burn': '연소',
      'Breath Wing': '날개바람',
      'Blaze': '화염'
    }
  }]
};
/* harmony default export */ const o1n = (o1n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o1n.txt
const raid_o1n_namespaceObject = "\r\n# DELTASCAPE V1.0--O1N\r\n# ALTE ROITE \r\n\r\n# Enrage is approximately 13:40. Yes, Normal has an enrage.\r\n# -ii 1ED9 1EDA 23D7 23D9 2583\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n6.6 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" } window 6.6,2.5\r\n12.8 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n19.0 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" } window 19,10\r\n29.1 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n37.3 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n38.1 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n52.6 \"Breath Wing\" Ability { id: \"23DE\", source: \"Alte Roite\" } window 30,30\r\n56.8 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n62.7 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n68.9 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n75.0 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n82.7 \"Twin Bolt x2\" # Ability { id: \"23D8\", source: \"Alte Roite\" }\r\n87.2 \"Clamp\" Ability { id: \"23E2\", source: \"Alte Roite\" } window 30,30\r\n93.4 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n99.5 \"Flash Freeze\" Ability { id: \"23DF\", source: \"Alte Roite\" }\r\n112.7 \"Levinbolt\" Ability { id: \"23DA\", source: \"Alte Roite\" } window 30,30\r\n118.7 \"Blaze\" Ability { id: \"23E1\", source: \"Alte Roite\" }\r\n125.9 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n\r\n140.3 \"The Classical Elements\" Ability { id: \"23E0\", source: \"Alte Roite\" } window 30,30\r\n143.4 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n145.5 \"Flash Freeze\" Ability { id: \"23DF\", source: \"Alte Roite\" }\r\n155.6 \"Downburst\" Ability { id: \"1ED8\", source: \"Alte Roite\" }\r\n162.9 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n166.9 \"Levinbolt\" Ability { id: \"23DA\", source: \"Alte Roite\" } window 30,30\r\n171.9 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n178.0 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n185.7 \"Twin Bolt x2\" # Ability { id: \"23D8\", source: \"Alte Roite\" }\r\n191.2 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n194.3 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n209.7 \"Breath Wing\" Ability { id: \"23DE\", source: \"Alte Roite\" } window 30,30\r\n210.4 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n213.8 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n216.8 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n223.0 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n229.1 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n236.2 \"Charybdis\" Ability { id: \"23DB\", source: \"Alte Roite\" } window 30,30\r\n243.3 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n249.4 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n257.1 \"Twin Bolt x2\" # Ability { id: \"23D8\", source: \"Alte Roite\" }\r\n261.6 \"Clamp\" Ability { id: \"23E2\", source: \"Alte Roite\" }\r\n267.7 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n\r\n278.1 \"The Classical Elements\" Ability { id: \"23E0\", source: \"Alte Roite\" } window 30,30\r\n281.3 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n284.4 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n289.5 \"Flash Freeze\" Ability { id: \"23DF\", source: \"Alte Roite\" }\r\n299.6 \"Downburst\" Ability { id: \"1ED8\", source: \"Alte Roite\" } window 30,30\r\n300.4 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n303.9 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n309.8 \"Blaze\" Ability { id: \"23E1\", source: \"Alte Roite\" }\r\n322.0 \"Charybdis\" Ability { id: \"23DB\", source: \"Alte Roite\" } window 30,30\r\n329.1 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n331.2 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n333.3 \"Flash Freeze\" Ability { id: \"23DF\", source: \"Alte Roite\" }\r\n343.4 \"Downburst\" Ability { id: \"1ED8\", source: \"Alte Roite\" }\r\n350.7 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n354.7 \"Levinbolt\" Ability { id: \"23DA\", source: \"Alte Roite\" } window 30,30\r\n361.3 \"Twin Bolt x2\" # Ability { id: \"23D8\", source: \"Alte Roite\" }\r\n366.8 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n372.9 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n380.6 \"Twin Bolt x2\" # Ability { id: \"23D8\", source: \"Alte Roite\" }\r\n386.1 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n389.2 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n404.6 \"Breath Wing\" Ability { id: \"23DE\", source: \"Alte Roite\" } window 30,30\r\n405.3 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n408.7 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n411.7 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n417.9 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n424.0 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n431.1 \"Charybdis\" Ability { id: \"23DB\", source: \"Alte Roite\" }\r\n438.2 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n444.3 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n452.0 \"Twin Bolt x2\" # Ability { id: \"23D8\", source: \"Alte Roite\" }\r\n456.5 \"Clamp\" Ability { id: \"23E2\", source: \"Alte Roite\" }\r\n462.6 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n\r\n473.0 \"The Classical Elements\" Ability { id: \"23E0\", source: \"Alte Roite\" }\r\n476.2 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n479.3 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n484.4 \"Flash Freeze\" Ability { id: \"23DF\", source: \"Alte Roite\" }\r\n494.5 \"Downburst\" Ability { id: \"1ED8\", source: \"Alte Roite\" }\r\n495.3 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n498.8 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n504.7 \"Blaze\" Ability { id: \"23E1\", source: \"Alte Roite\" }\r\n516.8 \"Charybdis\" Ability { id: \"23DB\", source: \"Alte Roite\" } window 30,30\r\n523.9 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n526.0 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n528.1 \"Flash Freeze\" Ability { id: \"23DF\", source: \"Alte Roite\" }\r\n538.2 \"Downburst\" Ability { id: \"1ED8\", source: \"Alte Roite\" }\r\n545.5 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n549.6 \"Levinbolt\" Ability { id: \"23DA\", source: \"Alte Roite\" } window 30,30\r\n556.2 \"Twin Bolt x2\" # Ability { id: \"23D8\", source: \"Alte Roite\" }\r\n561.7 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n567.8 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n575.5 \"Twin Bolt x2\" # Ability { id: \"23D8\", source: \"Alte Roite\" }\r\n581.0 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n584.1 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n599.5 \"Breath Wing\" Ability { id: \"23DE\", source: \"Alte Roite\" } window 30,30\r\n600.2 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n603.6 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n606.6 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n612.8 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n618.9 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n626.0 \"Charybdis\" Ability { id: \"23DB\", source: \"Alte Roite\" } window 30,30\r\n633.1 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n639.2 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n646.9 \"Twin Bolt x2\" # Ability { id: \"23D8\", source: \"Alte Roite\" }\r\n651.4 \"Clamp\" Ability { id: \"23E2\", source: \"Alte Roite\" }\r\n657.5 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n\r\n667.9 \"The Classical Elements\" Ability { id: \"23E0\", source: \"Alte Roite\" }\r\n671.1 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n674.2 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n679.3 \"Flash Freeze\" Ability { id: \"23DF\", source: \"Alte Roite\" }\r\n689.4 \"Downburst\" Ability { id: \"1ED8\", source: \"Alte Roite\" }\r\n690.2 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n693.6 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n699.5 \"Blaze\" Ability { id: \"23E1\", source: \"Alte Roite\" }\r\n711.7 \"Charybdis\" Ability { id: \"23DB\", source: \"Alte Roite\" } window 30,30\r\n718.8 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n720.9 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" }\r\n723.0 \"Flash Freeze\" Ability { id: \"23DF\", source: \"Alte Roite\" }\r\n733.1 \"Downburst\" Ability { id: \"1ED8\", source: \"Alte Roite\" }\r\n740.4 \"Burn\" Ability { id: \"23D5\", source: \"Ball Of Fire\" }\r\n744.5 \"Levinbolt\" Ability { id: \"23DA\", source: \"Alte Roite\" } window 30,30\r\n751.1 \"Twin Bolt x2\" # Ability { id: \"23D8\", source: \"Alte Roite\" }\r\n756.6 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n762.7 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n769.8 \"Charybdis\" Ability { id: \"23DB\", source: \"Alte Roite\" }\r\n776.9 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" } window 30,15\r\n783.0 \"Wyrm Tail\" Ability { id: \"23D6\", source: \"Alte Roite\" }\r\n790.7 \"Twin Bolt x2\" # Ability { id: \"23D8\", source: \"Alte Roite\" }\r\n795.2 \"Clamp\" Ability { id: \"23E2\", source: \"Alte Roite\" }\r\n801.3 \"Roar\" Ability { id: \"23DC\", source: \"Alte Roite\" }\r\n803.5 \"Flame\" Ability { id: \"23DD\", source: \"Alte Roite\" } window 50,5\r\n820.7 \"Burn Enrage\" Ability { id: \"23E4\", source: \"Ball Of Fire\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o1s.ts


// O1S - Deltascape 1.0 Savage
const o1s_triggerSet = {
  id: 'DeltascapeV10Savage',
  zoneId: zone_id/* default.DeltascapeV10Savage */.Z.DeltascapeV10Savage,
  timelineFile: 'o1s.txt',
  triggers: [{
    id: 'O1S Blaze',
    type: 'StartsUsing',
    netRegex: {
      id: '1EDD',
      source: 'Alte Roite',
      capture: false
    },
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }, {
    id: 'O1S Breath Wing',
    type: 'StartsUsing',
    netRegex: {
      id: '1ED6',
      source: 'Alte Roite',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Breath Wing: Be beside boss',
        de: 'Atemschwinge: Neben Boss gehen',
        fr: 'Aile déferlante : Placez-vous à côté du boss',
        ja: 'ブレスウィング: ボスに近づく',
        cn: '站boss附近',
        ko: '날개바람: 보스 옆으로'
      }
    }
  }, {
    id: 'O1S Clamp',
    type: 'StartsUsing',
    netRegex: {
      id: '1EDE',
      source: 'Alte Roite',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'O1S Downburst',
    type: 'StartsUsing',
    netRegex: {
      id: '1ED8',
      source: 'Alte Roite',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'O1S Roar',
    type: 'StartsUsing',
    netRegex: {
      id: '1ED4',
      source: 'Alte Roite',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O1S Charybdis',
    type: 'StartsUsing',
    netRegex: {
      id: '1ED3',
      source: 'Alte Roite',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Alte Roite': 'Alte Roite',
      'Ball Of Fire': 'Feuerball',
      'Wyrm Tail': 'Antiker Drachenschweif'
    },
    'replaceText': {
      '\\(safe\\)': '(sicher)',
      '\\(spread\\)': '(verteilen)',
      '\\(stack\\)': '(sammeln)',
      'Blaze': 'Frost',
      'Breath Wing': 'Atemschwinge',
      'Charybdis': 'Charybdis',
      'Clamp': 'Klammer',
      'Classical': 'Klassisch',
      'Downburst': 'Fallböe',
      'Flash Freeze': 'Blitzeis',
      'Flame': 'Flamme',
      'Inner Fireballs': 'Innere Feuerbälle',
      'Levinbolt': 'Blitzschlag',
      'Outer Fireballs': 'Äusere Feuerbälle',
      'Roar': 'Brüllen',
      'Twin Bolt': 'Zwillingsschlag',
      'Wyrm Tail': 'Antiker Drachenschweif'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Alte Roite': 'Alte Roite',
      'Ball Of Fire': 'Boule de flammes',
      'Wyrm Tail': 'Queue du dragon ancestral'
    },
    'replaceText': {
      '\\(safe\\)': '(safe)',
      '\\(spread\\)': '(dispersion)',
      '\\(stack\\)': '(package)',
      'Blaze': 'Givre',
      'Breath Wing': 'Aile déferlante',
      'Charybdis': 'Charybde',
      'Clamp': 'Pinçage',
      'Classical': 'Élément',
      'Downburst': 'Rafale descendante',
      'Flash Freeze': 'Glaciation instantanée',
      'Flame': 'Flamme',
      'Inner Fireballs': 'Boules de feu intérieur',
      'Levinbolt': 'Fulguration',
      'Outer Fireballs': 'Boules de feu extérieur',
      'Roar': 'Rugissement',
      'Twin Bolt': 'Éclairs jumeaux',
      'Wyrm Tail': 'Queue du dragon ancestral'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Alte Roite': 'アルテ・ロイテ',
      'Ball Of Fire': '火炎球',
      'Wyrm Tail': '太古の龍尾'
    },
    'replaceText': {
      '\\(safe\\)': '(安置)',
      '\\(spread\\)': '(散開)',
      '\\(stack\\)': '(頭割り)',
      'Blaze': 'ブレイズ',
      'Breath Wing': 'ブレスウィング',
      'Charybdis': 'ミールストーム',
      'Clamp': 'クランプ',
      'Classical': 'クラシカル',
      'Downburst': 'ダウンバースト',
      'Flash Freeze': 'フラッシュフリーズ',
      'Flame': '炎',
      'Inner Fireballs': '火炎球 (十)',
      'Levinbolt': '稲妻',
      'Outer Fireballs': '火炎球 (外)',
      'Roar': '咆哮',
      'Twin Bolt': 'ツインボルト',
      'Wyrm Tail': '太古の龍尾'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Alte Roite': '老者',
      'Ball Of Fire': '火焰球',
      'Wyrm Tail': '太古龙尾'
    },
    'replaceText': {
      '\\(safe\\)': '(安全)',
      '\\(spread\\)': '(分散)',
      '\\(stack\\)': '(分摊)',
      'Blaze': '冰焰',
      'Breath Wing': '风息之翼',
      'Charybdis': '大漩涡',
      'Clamp': '压迫',
      'Classical': '经典',
      'Downburst': '下行突风',
      'Flash Freeze': '闪耀冻结',
      'Flame': '火焰',
      'Inner Fireballs': '内圈火球',
      'Levinbolt': '闪电',
      'Outer Fireballs': '外圈火球',
      'Roar': '咆哮',
      'Twin Bolt': '双重落雷',
      'Wyrm Tail': '太古龙尾'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Alte Roite': '알테 로이테',
      'Ball Of Fire': '화염 구체',
      'Wyrm Tail': '태고의 용 꼬리'
    },
    'replaceText': {
      'Blaze': '화염',
      'Breath Wing': '날개바람',
      'Charybdis': '대소용돌이',
      'Clamp': '압박',
      'Classical': '고대 원소',
      'safe': '안전',
      'spread': '산개',
      'stack': '쉐어',
      'Downburst': '하강 기류',
      'Flash Freeze': '급속 동결',
      'Flame': '불꽃',
      'Inner Fireballs': '안쪽 화염구',
      'Levinbolt': '우레',
      'Outer Fireballs': '바깥 화염구',
      'Roar': '포효',
      'Twin Bolt': '이중 낙뢰',
      'Wyrm Tail': '태고의 용 꼬리'
    }
  }]
};
/* harmony default export */ const o1s = (o1s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o1s.txt
const raid_o1s_namespaceObject = "### Omega 1 (Savage)\r\n# Omega - Deltascape V1.0 (Savage)\r\n# -p 1ECE:6.9\r\n# -ii 1ED0 1EDA 1ED9 2584 1ED2\r\n\r\nhideall \"--sync--\"\r\nhideall \"--Reset--\"\r\nhideall \"Flame\"\r\n\r\n###### 1st Classical Elements\r\n# spread: knockback => in => spread+lightning\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n6.9 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" } window 7,3\r\n13.0 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" }\r\n20.1 \"Twin Bolt\" Ability { id: \"1ECF\", source: \"Alte Roite\" }\r\n\r\n34.6 \"Classical (spread)\" Ability { id: \"1EDC\", source: \"Alte Roite\" } window 80,80\r\n37.7 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n41.8 \"Flash Freeze\" Ability { id: \"1ED7\", source: \"Alte Roite\" }\r\n51.9 \"Downburst\" Ability { id: \"1ED8\", source: \"Alte Roite\" }\r\n57.2 \"Outer Fireballs\" Ability { id: \"1ECB\", source: \"Ball Of Fire\" }\r\n60.5 \"Levinbolt\" Ability { id: \"1ED1\", source: \"Alte Roite\" }\r\n66.6 \"Roar\" Ability { id: \"1ED4\", source: \"Alte Roite\" }\r\n72.8 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" }\r\n78.9 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" }\r\n90.0 \"Twin Bolt\" Ability { id: \"1ECF\", source: \"Alte Roite\" }\r\n96.1 \"Clamp\" Ability { id: \"1EDE\", source: \"Alte Roite\" }\r\n98.2 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n103.3 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n109.4 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" }\r\n117.4 \"Outer Fireballs\" Ability { id: \"1ECB\", source: \"Ball Of Fire\" }\r\n120.5 \"Levinbolt\" Ability { id: \"1ED1\", source: \"Alte Roite\" }\r\n122.5 \"Inner Fireballs\" Ability { id: \"1ECB\", source: \"Ball Of Fire\" }\r\n127.6 \"Blaze\" Ability { id: \"1EDD\", source: \"Alte Roite\" }\r\n134.8 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" }\r\n140.9 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" }\r\n148.0 \"Twin Bolt\" Ability { id: \"1ECF\", source: \"Alte Roite\" }\r\n158.1 \"Roar\" Ability { id: \"1ED4\", source: \"Alte Roite\" }\r\n164.2 \"Roar\" Ability { id: \"1ED4\", source: \"Alte Roite\" }\r\n170.4 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" }\r\n177.5 \"Charybdis\" Ability { id: \"1ED3\", source: \"Alte Roite\" }\r\n184.7 \"Roar\" Ability { id: \"1ED4\", source: \"Alte Roite\" }\r\n\r\n\r\n###### 2nd Classical Elements\r\n# safe: knockback safe spot => spread+lightning\r\n\r\n195.1 \"Classical (safe)\" Ability { id: \"1EDC\", source: \"Alte Roite\" } window 80,80\r\n198.2 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n204.8 \"Flash Freeze\" Ability { id: \"1ED7\", source: \"Alte Roite\" }\r\n213.9 \"Downburst\" Ability { id: \"1ED8\", source: \"Alte Roite\" }\r\n217.7 \"Outer Fireballs\" Ability { id: \"1ECB\", source: \"Ball Of Fire\" }\r\n223.0 \"Levinbolt\" Ability { id: \"1ED1\", source: \"Alte Roite\" }\r\n225.2 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n230.3 \"Flash Freeze\" Ability { id: \"1ED7\", source: \"Alte Roite\" }\r\n240.7 \"Breath Wing\" Ability { id: \"1ED6\", source: \"Alte Roite\" }\r\n244.8 \"Inner Fireballs\" Ability { id: \"1ECB\", source: \"Ball Of Fire\" }\r\n248.6 \"Clamp\" Ability { id: \"1EDE\", source: \"Alte Roite\" }\r\n255.7 \"Blaze\" Ability { id: \"1EDD\", source: \"Alte Roite\" }\r\n262.8 \"Roar\" Ability { id: \"1ED4\", source: \"Alte Roite\" }\r\n269.0 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" }\r\n275.1 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" }\r\n286.2 \"Charybdis\" Ability { id: \"1ED3\", source: \"Alte Roite\" }\r\n294.3 \"Twin Bolt\" Ability { id: \"1ECF\", source: \"Alte Roite\" }\r\n300.5 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n308.6 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n317.7 \"Levinbolt\" Ability { id: \"1ED1\", source: \"Alte Roite\" }\r\n319.7 \"Inner Fireballs\" Ability { id: \"1ECB\", source: \"Ball Of Fire\" }\r\n327.4 \"Clamp\" Ability { id: \"1EDE\", source: \"Alte Roite\" }\r\n327.8 \"Outer Fireballs\" Ability { id: \"1ECB\", source: \"Ball Of Fire\" }\r\n333.5 \"Roar\" Ability { id: \"1ED4\", source: \"Alte Roite\" }\r\n339.6 \"Roar\" Ability { id: \"1ED4\", source: \"Alte Roite\" }\r\n\r\n\r\n###### 3rd Classical Elements\r\n# stack: knockback => in => blaze stack\r\n\r\n350.0 \"Classical (stack)\" Ability { id: \"1EDC\", source: \"Alte Roite\" } window 80,80\r\n353.1 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n356.2 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n361.3 \"Flash Freeze\" Ability { id: \"1ED7\", source: \"Alte Roite\" }\r\n371.4 \"Downburst\" Ability { id: \"1ED8\", source: \"Alte Roite\" }\r\n372.3 \"Outer Fireballs\" Ability { id: \"1ECB\", source: \"Ball Of Fire\" }\r\n375.8 \"Inner Fireballs\" Ability { id: \"1ECB\", source: \"Ball Of Fire\" }\r\n380.6 \"Blaze\" Ability { id: \"1EDD\", source: \"Alte Roite\" }\r\n387.7 \"Roar\" Ability { id: \"1ED4\", source: \"Alte Roite\" }\r\n393.9 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" }\r\n400.0 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" }\r\n411.1 \"Twin Bolt\" Ability { id: \"1ECF\", source: \"Alte Roite\" }\r\n417.2 \"Clamp\" Ability { id: \"1EDE\", source: \"Alte Roite\" }\r\n419.4 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n424.5 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n430.6 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" }\r\n438.6 \"Outer Fireballs\" Ability { id: \"1ECB\", source: \"Ball Of Fire\" }\r\n441.7 \"Levinbolt\" Ability { id: \"1ED1\", source: \"Alte Roite\" }\r\n443.7 \"Inner Fireballs\" Ability { id: \"1ECB\", source: \"Ball Of Fire\" }\r\n448.9 \"Blaze\" Ability { id: \"1EDD\", source: \"Alte Roite\" }\r\n\r\n\r\n##### 4th Classical Elements\r\n# spread: knockback => in => spread+lightning\r\n\r\n460.3 \"Classical (spread)\" Ability { id: \"1EDC\", source: \"Alte Roite\" } window 80,80\r\n463.4 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n467.5 \"Flash Freeze\" Ability { id: \"1ED7\", source: \"Alte Roite\" }\r\n477.6 \"Downburst\" Ability { id: \"1ED8\", source: \"Alte Roite\" }\r\n483.0 \"Outer Fireballs\" Ability { id: \"1ECB\", source: \"Ball Of Fire\" }\r\n486.3 \"Levinbolt\" Ability { id: \"1ED1\", source: \"Alte Roite\" }\r\n492.4 \"Roar\" Ability { id: \"1ED4\", source: \"Alte Roite\" }\r\n498.6 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" }\r\n504.7 \"Wyrm Tail\" Ability { id: \"1ECE\", source: \"Alte Roite\" }\r\n515.8 \"Charybdis\" Ability { id: \"1ED3\", source: \"Alte Roite\" }\r\n523.9 \"Twin Bolt\" Ability { id: \"1ECF\", source: \"Alte Roite\" }\r\n530.1 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n538.3 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n547.4 \"Levinbolt\" Ability { id: \"1ED1\", source: \"Alte Roite\" }\r\n549.4 \"Inner Fireballs\" Ability { id: \"1ECB\", source: \"Ball Of Fire\" }\r\n557.1 \"Clamp\" Ability { id: \"1EDE\", source: \"Alte Roite\" }\r\n557.6 \"Outer Fireballs\" Ability { id: \"1ECB\", source: \"Ball Of Fire\" }\r\n563.3 \"Roar\" Ability { id: \"1ED4\", source: \"Alte Roite\" }\r\n569.5 \"Roar\" Ability { id: \"1ED4\", source: \"Alte Roite\" }\r\n\r\n571.7 \"Flame\" Ability { id: \"1ED5\", source: \"Alte Roite\" }\r\n589.0 \"Enrage\" Ability { id: \"23E4\", source: \"Ball Of Fire\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o2n.ts




// O2N - Deltascape 2.0 Normal
const o2n_triggerSet = {
  id: 'DeltascapeV20',
  zoneId: zone_id/* default.DeltascapeV20 */.Z.DeltascapeV20,
  timelineFile: 'o2n.txt',
  timelineTriggers: [{
    id: 'O2N Paranormal Wave',
    regex: /Paranormal Wave/,
    beforeSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'O2N Levitation Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '556'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.levitating = true
  }, {
    id: 'O2N Levitation Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '556'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.levitating = false
  }, {
    id: 'O2N Gravitational Manipulation Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '0071'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.stackMarkerOnYou();
      return output.stackOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      stackMarkerOnYou: {
        en: 'Stack marker on YOU',
        de: 'Sammeln Marker auf DIR',
        fr: 'Marqueur de package sur VOUS',
        ja: '自分に集合',
        cn: '集合点名',
        ko: '쉐어징 대상자'
      },
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'O2N Gravitational Manipulation Float',
    type: 'HeadMarker',
    netRegex: {
      id: '0071'
    },
    condition: (data, matches) => !data.levitating && conditions/* default.targetIsNotYou */.Z.targetIsNotYou()(data, matches),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Levitate',
        de: 'Schweben',
        fr: 'Lévitation',
        ja: '浮上',
        cn: '浮空',
        ko: '공중부양'
      }
    }
  }, {
    id: 'O2N Evilsphere',
    type: 'StartsUsing',
    netRegex: {
      id: '250F',
      source: 'Catastrophe'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O2N -100Gs',
    type: 'StartsUsing',
    netRegex: {
      id: '24FF',
      source: 'Catastrophe',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '-100 Gs: Go north/south',
        de: '-100G: Nach Norden/Süden',
        fr: 'Gravité -100 : Allez au nord/sud',
        ja: '-100 G: 北/南へ',
        cn: '去北边/南边',
        ko: '중력 마이너스 100: 남/북쪽으로'
      }
    }
  }, {
    id: 'O2N Demon Eye',
    type: 'StartsUsing',
    netRegex: {
      id: '250D',
      source: 'Catastrophe',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'O2N Earthquake',
    type: 'StartsUsing',
    netRegex: {
      id: '2512',
      source: 'Catastrophe',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (!data.levitating) return output.levitate();
    },
    infoText: (data, _matches, output) => {
      if (data.levitating) return output.earthquake();
    },
    outputStrings: {
      earthquake: {
        en: 'Earthquake',
        de: 'Erdbeben',
        fr: 'Grand séisme',
        ja: '地震',
        cn: '地震',
        ko: '대지진'
      },
      levitate: {
        en: 'Levitate',
        de: 'Schweben',
        fr: 'Lévitation',
        ja: '浮上',
        cn: '浮空',
        ko: '공중부양'
      }
    }
  }, {
    id: 'O2N Gravitational Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '2510',
      source: 'Catastrophe',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O2N Six Fulms Under',
    type: 'GainsEffect',
    netRegex: {
      effectId: '237'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 5,
    suppressSeconds: 10,
    alertText: (data, _matches, output) => {
      if (!data.levitating) return output.levitate();
    },
    infoText: (data, _matches, output) => {
      if (data.levitating) return output.sixFulmsUnder();
    },
    tts: (_data, _matches, output) => output.float(),
    outputStrings: {
      sixFulmsUnder: {
        en: '6 Fulms Under',
        de: 'Versinkend',
        fr: 'Enfoncement',
        ja: '沈下',
        cn: '下陷',
        ko: '하강'
      },
      levitate: {
        en: 'Levitate',
        de: 'Schweben',
        fr: 'Lévitation',
        ja: '浮上',
        cn: '浮空',
        ko: '공중부양'
      },
      float: {
        en: 'float',
        de: 'schweben',
        fr: 'Flottez',
        ja: '浮上',
        cn: '浮空',
        ko: '공중부양'
      }
    }
  }, {
    id: 'O2N Antilight',
    type: 'StartsUsing',
    netRegex: {
      id: '2502',
      source: 'Catastrophe',
      capture: false
    },
    preRun: data => data.antiCounter ??= 0,
    durationSeconds: data => {
      if (data.antiCounter === 0 && data.levitating) return 3;
      return 8;
    },
    alertText: (data, _matches, output) => {
      // The first Antilight is always blue.
      if (data.antiCounter === 0) {
        // Players who are already floating should just get an info about Petrospheres.
        if (data.levitating) return;
        return output.levitate();
      }
      // It's always safe not to levitate after the first Antilight.
      // The second, fifth, eighth, etc Antilights require moving to the center as well.
      if (data.antiCounter && data.antiCounter % 3 === 1) return output.goCenterAndDontLevitate();
      return output.dontLevitate();
    },
    infoText: (data, _matches, output) => {
      if (data.antiCounter === 0 && data.levitating) return output.antilight();
    },
    run: data => {
      data.antiCounter = (data.antiCounter ?? 0) + 1;
      data.antiCounter += 1;
    },
    outputStrings: {
      antilight: {
        en: 'Antilight',
        de: 'Dunkellicht',
        fr: 'Lumière obscure',
        ja: '暗黒光',
        cn: '暗黑光',
        ko: '암흑광'
      },
      levitate: {
        en: 'Levitate',
        de: 'Levitation',
        fr: 'Lévitation',
        ja: '浮上',
        cn: '浮空',
        ko: '공중부양'
      },
      goCenterAndDontLevitate: {
        en: 'Go center and don\'t levitate',
        de: 'Geh in die Mitte und nicht schweben',
        fr: 'Allez au centre et pas de lévitation',
        ja: '中央に浮かばず集合',
        cn: '中间集合不要浮空',
        ko: '공중부양 하지않고 가운데로'
      },
      dontLevitate: {
        en: 'Don\'t levitate',
        de: 'Nicht schweben',
        fr: 'Pas de lévitation',
        ja: '浮上はしない',
        cn: '不要浮空',
        ko: '공중부양 하지않기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Potent Petrosphere': 'Petrosphäre I',
      '(?<! )Petrosphere': 'Petrosphäre II',
      'Fleshy Member': 'Tentakel',
      'Catastrophe': 'Katastroph'
    },
    'replaceText': {
      'Tremblor': 'Erschütterung',
      'Paranormal Wave': 'Paranormale Welle',
      'Maniacal Probe': 'Tentakeltanz',
      'Main Quake': 'Hauptbeben',
      'Gravitational Wave': 'Gravitationswelle',
      'Gravitational Manipulation': 'Schwerkraftmanipulation',
      'Gravitational Explosion': 'Gravitationsknall',
      'Gravitational Distortion': 'Massenverzerrung',
      '(?<! )Explosion': 'Explosion',
      'Evilsphere': 'Sphäre des Bösen',
      'Erosion': 'Erosion',
      'Epicenter': 'Epizentrum',
      'Earthquake': 'Erdbeben',
      'Demon Eye': 'Dämonenauge',
      'Antilight': 'Dunkles Licht',
      '(?<!-)100 Gs': '100 G',
      '-100 Gs': 'Minus 100 G'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Potent Petrosphere': 'super pétrosphère',
      '(?<! )Petrosphere': 'pétrosphère',
      'Fleshy Member': 'tentacule',
      'Catastrophe': 'Catastrophe'
    },
    'replaceText': {
      'Tremblor': 'Tremblement de terre',
      'Paranormal Wave': 'Onde maudite',
      'Maniacal Probe': 'Farandole de tentacules',
      'Main Quake': 'Secousse principale',
      'Gravitational Wave': 'Onde gravitationnelle',
      'Gravitational Manipulation': 'Manipulation gravitationnelle',
      'Gravitational Explosion': 'Explosion gravitationnelle',
      'Gravitational Distortion': 'Distorsion gravitationnelle',
      '(?<! )Explosion': 'Explosion',
      'Evilsphere': 'Sphère démoniaque',
      'Erosion': 'Érosion',
      'Epicenter': 'Épicentre',
      'Earthquake': 'Grand séisme',
      'Demon Eye': 'Œil diabolique',
      'Antilight': 'Lumière obscure',
      '(?<!-)100 Gs': 'Gravité 100',
      '-100 Gs': 'Gravité -100'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Potent Petrosphere': 'ペトロスフィアII',
      '(?<! )Petrosphere': 'ペトロスフィアI',
      'Fleshy Member': '触手',
      'Catastrophe': 'カタストロフィー'
    },
    'replaceText': {
      'Tremblor': '地震',
      'Paranormal Wave': '呪詛波',
      'Maniacal Probe': '触手乱舞',
      'Main Quake': '本震',
      'Gravitational Wave': '重力波',
      'Gravitational Manipulation': '重力操作',
      'Gravitational Explosion': '重力爆発',
      'Gravitational Distortion': '重力歪曲',
      '(?<! )Explosion': '爆散',
      'Evilsphere': 'イビルスフィア',
      'Erosion': '浸食',
      'Epicenter': '震源生成',
      'Earthquake': '大地震',
      'Demon Eye': '悪魔の瞳',
      'Antilight': '暗黒光',
      '(?<!-)100 Gs': '重力100',
      '-100 Gs': '重力マイナス100'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Potent Petrosphere': '石化球II',
      '(?<! )Petrosphere': '石化球I',
      'Fleshy Member': '触手',
      'Catastrophe': '灾变者'
    },
    'replaceText': {
      'Tremblor': '地震',
      'Paranormal Wave': '诅咒波',
      'Maniacal Probe': '触手乱舞',
      'Main Quake': '主震',
      'Gravitational Wave': '重力波',
      'Gravitational Manipulation': '重力操纵',
      'Gravitational Explosion': '重力爆发',
      'Gravitational Distortion': '重力扭曲',
      '(?<! )Explosion': '爆炸',
      'Evilsphere': '邪球',
      'Erosion': '侵入',
      'Epicenter': '震源制造',
      'Earthquake': '大地震',
      'Demon Eye': '恶魔之瞳',
      'Antilight': '暗黑光',
      '(?<!-)100 Gs': '重力100',
      '-100 Gs': '重力-100'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Potent Petrosphere': '석화 구체 II',
      '(?<! )Petrosphere': '석화 구체 I',
      'Fleshy Member': '촉수',
      'Catastrophe': '카타스트로피'
    },
    'replaceText': {
      'Tremblor': '지진',
      'Paranormal Wave': '저주 파동',
      'Maniacal Probe': '촉수 난무',
      'Main Quake': '본진',
      'Gravitational Wave': '중력파',
      'Gravitational Manipulation': '중력 조작',
      'Gravitational Explosion': '중력 폭발',
      'Gravitational Distortion': '중력 왜곡',
      '(?<! )Explosion': '폭산',
      'Evilsphere': '악의 세력권',
      'Erosion': '침식',
      'Epicenter': '진원 생성',
      'Earthquake': '대지진',
      'Demon Eye': '악마의 눈동자',
      'Antilight': '암흑광',
      '(?<!-)100 Gs': '중력 100',
      '-100 Gs': '중력 -100'
    }
  }]
};
/* harmony default export */ const o2n = (o2n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o2n.txt
const raid_o2n_namespaceObject = "# DELTASCAPE V2.0--O2N\r\n# CATASTROPHE\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Unlike O1N and O3N, Catastrophe has no enrage.\r\n# -ii 24E8 24FC 2500 2501 2505 2514 2515 2516\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n5.6 \"Tremblor\" Ability { id: \"2511\", source: \"Catastrophe\" } window 5.6,2\r\n9.2 \"Tremblor\" Ability { id: \"2511\", source: \"Catastrophe\" }\r\n17.8 \"Earthquake\" Ability { id: \"2512\", source: \"Catastrophe\" }\r\n25.0 \"100 Gs\" Ability { id: \"24FB\", source: \"Catastrophe\" }\r\n32.1 \"Evilsphere\" Ability { id: \"250F\", source: \"Catastrophe\" }\r\n37.3 \"Gravitational Distortion\" Ability { id: \"250A\", source: \"Catastrophe\" }\r\n53.4 \"100 Gs\" Ability { id: \"24FB\", source: \"Catastrophe\" }\r\n65.5 \"Gravitational Manipulation\" Ability { id: \"2504\", source: \"Catastrophe\" }\r\n72.7 \"Gravitational Explosion\" Ability { id: \"2506\", source: \"Catastrophe\" }\r\n79.7 \"Paranormal Wave\" Ability { id: \"250E\", source: \"Catastrophe\" }\r\n87.8 \"100 Gs\" Ability { id: \"24FB\", source: \"Catastrophe\" }\r\n98.0 \"Maniacal Probe\" Ability { id: \"258F\", source: \"Catastrophe\" }\r\n104.1 \"Erosion\" Ability { id: \"2590\", source: \"Fleshy Member\" } window 30,30\r\n108.2 \"Epicenter\" Ability { id: \"24A2\", source: \"Catastrophe\" }\r\n116.3 \"Gravitational Wave\" Ability { id: \"2510\", source: \"Catastrophe\" }\r\n126.3 \"Main Quake\" Ability { id: \"24A5\", source: \"Catastrophe\" }\r\n133.4 \"100 Gs\" Ability { id: \"24FB\", source: \"Catastrophe\" }\r\n141.5 \"Antilight\" Ability { id: \"2502\", source: \"Catastrophe\" }\r\n153.6 \"Demon Eye\" Ability { id: \"250D\", source: \"Catastrophe\" }\r\n154.6 \"Explosion\" Ability { id: \"2513\", source: \"Petrosphere\" }\r\n156.8 \"Paranormal Wave\" Ability { id: \"250E\", source: \"Catastrophe\" }\r\n165.9 \"Evilsphere\" Ability { id: \"250F\", source: \"Catastrophe\" }\r\n171.1 \"Paranormal Wave\" Ability { id: \"250E\", source: \"Catastrophe\" }\r\n179.3 \"Antilight\" Ability { id: \"2502\", source: \"Catastrophe\" }\r\n189.4 \"100 Gs\" Ability { id: \"24FB\", source: \"Catastrophe\" }\r\n# 192.5 \"Explosion\" Ability { id: \"2513\", source: \"Petrosphere\" }\r\n192.5 \"Explosion\" Ability { id: \"2503\", source: \"Potent Petrosphere\" }\r\n199.6 \"Demon Eye\" Ability { id: \"250D\", source: \"Catastrophe\" }\r\n207.8 \"Maniacal Probe\" Ability { id: \"258F\", source: \"Catastrophe\" }\r\n213.9 \"Erosion\" Ability { id: \"2590\", source: \"Fleshy Member\" } window 30,30\r\n218.0 \"Epicenter\" Ability { id: \"24A2\", source: \"Catastrophe\" }\r\n236.2 \"Main Quake\" Ability { id: \"24A5\", source: \"Catastrophe\" }\r\n243.1 \"100 Gs\" Ability { id: \"24FB\", source: \"Catastrophe\" }\r\n257.3 \" -100 Gs\" Ability { id: \"24FF\", source: \"Catastrophe\" }\r\n# 264.8 \"Explosion\" Ability { id: \"2513\", source: \"Petrosphere\" }\r\n264.8 \"Explosion\" Ability { id: \"2503\", source: \"Potent Petrosphere\" }\r\n\r\n# A short intermission block after -100Gs\r\n268.4 \"Gravitational Wave\" Ability { id: \"2510\", source: \"Catastrophe\" } window 30,30\r\n280.5 \"Evilsphere\" Ability { id: \"250F\", source: \"Catastrophe\" }\r\n290.7 \"100 Gs\" Ability { id: \"24FB\", source: \"Catastrophe\" }\r\n298.8 \"Antilight\" Ability { id: \"2502\", source: \"Catastrophe\" }\r\n308.0 \"Gravitational Distortion\" Ability { id: \"250A\", source: \"Catastrophe\" }\r\n312.0 \"Explosion\" Ability { id: \"2503\", source: \"Potent Petrosphere\" }\r\n329.1 \"Maniacal Probe\" Ability { id: \"258F\", source: \"Catastrophe\" }\r\n335.2 \"Erosion\" Ability { id: \"2590\", source: \"Fleshy Member\" }\r\n339.2 \"Epicenter\" Ability { id: \"24A2\", source: \"Catastrophe\" }\r\n344.3 \"100 Gs\" Ability { id: \"24FB\", source: \"Catastrophe\" }\r\n354.5 \"Demon Eye\" Ability { id: \"250D\", source: \"Catastrophe\" }\r\n357.4 \"Main Quake\" Ability { id: \"24A5\", source: \"Catastrophe\" }\r\n\r\n# Rotation block\r\n362.7 \"Gravitational Wave\" Ability { id: \"2510\", source: \"Catastrophe\" } window 30,30\r\n372.8 \"Antilight\" Ability { id: \"2502\", source: \"Catastrophe\" }\r\n379.9 \"Tremblor\" Ability { id: \"2511\", source: \"Catastrophe\" }\r\n383.6 \"Tremblor\" Ability { id: \"2511\", source: \"Catastrophe\" }\r\n386.0 \"Explosion\" Ability { id: \"2503\", source: \"Potent Petrosphere\" }\r\n392.3 \"Earthquake\" Ability { id: \"2512\", source: \"Catastrophe\" } window 30,30\r\n400.5 \"Gravitational Wave\" Ability { id: \"2510\", source: \"Catastrophe\" }\r\n410.6 \"Antilight\" Ability { id: \"2502\", source: \"Catastrophe\" }\r\n415.7 \"100 Gs\" Ability { id: \"24FB\", source: \"Catastrophe\" }\r\n# 423.7 \"Explosion\" Ability { id: \"2513\", source: \"Petrosphere\" }\r\n423.7 \"Explosion\" Ability { id: \"2503\", source: \"Potent Petrosphere\" }\r\n425.8 \"Demon Eye\" Ability { id: \"250D\", source: \"Catastrophe\" } window 30,30\r\n441.0 \"100 Gs\" Ability { id: \"24FB\", source: \"Catastrophe\" }\r\n449.1 \"Antilight\" Ability { id: \"2502\", source: \"Catastrophe\" }\r\n458.3 \"Gravitational Distortion\" Ability { id: \"250A\", source: \"Catastrophe\" }\r\n462.3 \"Explosion\" Ability { id: \"2503\", source: \"Potent Petrosphere\" }\r\n479.4 \"Maniacal Probe\" Ability { id: \"258F\", source: \"Catastrophe\" }\r\n485.5 \"Erosion\" Ability { id: \"2590\", source: \"Fleshy Member\" }\r\n489.5 \"Epicenter\" Ability { id: \"24A2\", source: \"Catastrophe\" }\r\n494.7 \"100 Gs\" Ability { id: \"24FB\", source: \"Catastrophe\" }\r\n504.9 \"Demon Eye\" Ability { id: \"250D\", source: \"Catastrophe\" }\r\n507.8 \"Main Quake\" Ability { id: \"24A5\", source: \"Catastrophe\" } window 30,30\r\n\r\n513.1 \"Gravitational Wave\" Ability { id: \"2510\", source: \"Catastrophe\" } window 30,30\r\n523.2 \"Antilight\" Ability { id: \"2502\", source: \"Catastrophe\" }\r\n530.3 \"Tremblor\" Ability { id: \"2511\", source: \"Catastrophe\" }\r\n534.0 \"Tremblor\" Ability { id: \"2511\", source: \"Catastrophe\" }\r\n536.4 \"Explosion\" Ability { id: \"2503\", source: \"Potent Petrosphere\" }\r\n542.7 \"Earthquake\" Ability { id: \"2512\", source: \"Catastrophe\" } window 30,30\r\n550.9 \"Gravitational Wave\" Ability { id: \"2510\", source: \"Catastrophe\" }\r\n561.0 \"Antilight\" Ability { id: \"2502\", source: \"Catastrophe\" }\r\n566.1 \"100 Gs\" Ability { id: \"24FB\", source: \"Catastrophe\" }\r\n# 574.1 \"Explosion\" Ability { id: \"2513\", source: \"Petrosphere\" }\r\n574.1 \"Explosion\" Ability { id: \"2503\", source: \"Potent Petrosphere\" }\r\n576.2 \"Demon Eye\" Ability { id: \"250D\", source: \"Catastrophe\" } window 30,30\r\n591.4 \"100 Gs\" Ability { id: \"24FB\", source: \"Catastrophe\" }\r\n599.5 \"Antilight\" Ability { id: \"2502\", source: \"Catastrophe\" }\r\n608.7 \"Gravitational Distortion\" Ability { id: \"250A\", source: \"Catastrophe\" } window 30,30\r\n612.7 \"Explosion\" Ability { id: \"2503\", source: \"Potent Petrosphere\" }\r\n629.8 \"Maniacal Probe\" Ability { id: \"258F\", source: \"Catastrophe\" }\r\n635.9 \"Erosion\" Ability { id: \"2590\", source: \"Fleshy Member\" }\r\n639.9 \"Epicenter\" Ability { id: \"24A2\", source: \"Catastrophe\" }\r\n645.1 \"100 Gs\" Ability { id: \"24FB\", source: \"Catastrophe\" }\r\n655.3 \"Demon Eye\" Ability { id: \"250D\", source: \"Catastrophe\" } window 30,30\r\n658.2 \"Main Quake\" Ability { id: \"24A5\", source: \"Catastrophe\" } jump 507.8\r\n\r\n663.5 \"Gravitational Wave\"\r\n673.6 \"Antilight\"\r\n680.7 \"Tremblor\"\r\n684.4 \"Tremblor\"\r\n686.8 \"Explosion\"\r\n693.1 \"Earthquake\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o2s.ts



// O2S - Deltascape 2.0 Savage
const o2s_triggerSet = {
  id: 'DeltascapeV20Savage',
  zoneId: zone_id/* default.DeltascapeV20Savage */.Z.DeltascapeV20Savage,
  timelineFile: 'o2s.txt',
  timelineTriggers: [{
    id: 'O2S Double Stack',
    regex: /Gravitational Manipulation/,
    beforeSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'DPS: Levitate',
        de: 'DDs hoch',
        fr: 'DPS : Lévitation',
        ja: 'DPS: 浮上',
        cn: 'DPS浮空',
        ko: '딜러: 공중부양'
      }
    }
  }, {
    id: 'O2S Paranormal Wave',
    regex: /Paranormal Wave/,
    beforeSeconds: 5,
    suppressSeconds: 10,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'O2S Phase Probe Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: '235A',
      source: 'Catastrophe',
      capture: false
    },
    run: data => {
      data.probeCount = (data.probeCount ?? 0) + 1;
      data.dpsProbe = data.probeCount === 2 || data.probeCount === 4;
      data.myProbe = data.dpsProbe === data.role.startsWith('dps');
    }
  }, {
    id: 'O2S Levitation Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '556'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.levitating = true
  }, {
    id: 'O2S Levitation Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '556'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.levitating = false
  }, {
    id: 'O2S Evilsphere',
    type: 'StartsUsing',
    netRegex: {
      id: '2371',
      source: 'Catastrophe'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'O2S 100Gs',
    type: 'HeadMarker',
    netRegex: {
      id: '0069'
    },
    preRun: (data, matches) => {
      data.blueCircle ??= [];
      data.blueCircle.push(matches.target);
    },
    delaySeconds: 0.3,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        onYou: {
          en: '100Gs on YOU',
          de: '100Gs auf DIR',
          fr: 'Gravité 100 sur VOUS',
          cn: '重力100点名',
          ko: '중력 100 대상자'
        },
        beIn: {
          en: 'Be in 100Gs Circle',
          de: 'Sei in einem 100Gs Kreis',
          fr: 'Placez-vous dans le centre de gravité 100',
          cn: '站在重力100圈内',
          ko: '중력 100 원 안에 있기'
        }
      };
      if (!data.blueCircle) return;
      if (data.blueCircle.includes(data.me)) return {
        alertText: output.onYou()
      };
      return {
        infoText: output.beIn()
      };
    },
    run: data => delete data.blueCircle
  }, {
    id: 'O2S -100Gs',
    type: 'StartsUsing',
    netRegex: {
      id: '235E',
      source: 'Catastrophe',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '-100 Gs: Go north/south and look away',
        de: '-100G: Nach Norden/Süden und wegschauen',
        fr: 'Gravité -100 : Allez au nord/sud et détournez le regard',
        ja: '-100 G: 北/南へ、ボスを見ないで',
        cn: '前往南边/北边并背对boss',
        ko: '중력 마이너스 100: 남/북쪽에서 바깥쪽 보기'
      }
    }
  }, {
    id: 'O2S Death\'s Gaze',
    type: 'StartsUsing',
    netRegex: {
      id: '236F',
      source: 'Catastrophe',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'O2S Earthquake',
    type: 'StartsUsing',
    netRegex: {
      id: '2374',
      source: 'Catastrophe',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (!data.levitating) return output.earthquakeLevitate();
    },
    infoText: (data, _matches, output) => {
      if (data.levitating) return output.earthquake();
    },
    tts: (data, _matches, output) => {
      if (!data.levitating) return output.levitate();
    },
    outputStrings: {
      earthquake: {
        en: 'Earthquake',
        de: 'Erdbeben',
        fr: 'Grand séisme',
        ja: '地震',
        cn: '地震',
        ko: '대지진'
      },
      earthquakeLevitate: {
        en: 'Earthquake: Levitate',
        de: 'Erdbeben: Schweben',
        fr: 'Grand séisme : Lévitation',
        ja: '地震: 浮上',
        cn: '地震：漂浮',
        ko: '대지진: 공중부양'
      },
      levitate: {
        en: 'levitate',
        de: 'schweben',
        fr: 'Lévitation',
        ja: '浮上',
        cn: '漂浮',
        ko: '공중부양'
      }
    }
  }, {
    id: 'O2S Elevated',
    type: 'GainsEffect',
    netRegex: {
      effectId: '54E',
      capture: false
    },
    condition: data => data.job !== 'BLU',
    alarmText: (data, _matches, output) => {
      if (data.role.startsWith('dps') && !data.levitating) return output.dpsLevitate();
    },
    infoText: (data, _matches, output) => {
      if (!data.role.startsWith('dps')) return output.dpsUpTanksHealersDown();
    },
    tts: (_data, _matches, output) => output.dpsUp(),
    outputStrings: {
      dpsUpTanksHealersDown: {
        en: 'DPS up, T/H down',
        de: 'DDs hoch, T/H runter',
        fr: 'DPS en haut, T/H en bas',
        ja: 'DPS浮上 タンクヒラ降下',
        cn: 'DPS升起，T奶下降',
        ko: '딜러 공중부양, 탱힐 강하'
      },
      dpsLevitate: {
        en: 'DPS: Levitate',
        de: 'DDs: Schweben',
        fr: 'DPS : Lévitation',
        ja: 'DPS: 浮上',
        cn: 'DPS浮空',
        ko: '딜러: 공중부양'
      },
      dpsUp: {
        en: 'dps up',
        de: 'dee dees hoch',
        fr: 'DPS en haut',
        ja: 'DPS浮上',
        cn: 'DPS升起',
        ko: '딜러 공중부양'
      }
    }
  }, {
    id: 'O2S Gravitational Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '2372',
      source: 'Catastrophe',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O2S Maniacal Probe',
    type: 'StartsUsing',
    netRegex: {
      id: '235A',
      source: 'Catastrophe',
      capture: false
    },
    condition: data => data.job !== 'BLU',
    alertText: (data, _matches, output) => {
      if (data.myProbe) {
        if (!data.dpsProbe) return output.maniacalProbeTanksHealers();
        return output.maniacalProbeDps();
      }
    },
    infoText: (data, _matches, output) => {
      if (!data.myProbe) {
        if (!data.dpsProbe) return output.maniacalProbeTanksHealers();
        return output.maniacalProbeDps();
      }
    },
    tts: (data, _matches, output) => {
      if (data.dpsProbe) return output.dpsProbe();
      return output.tankHealProbe();
    },
    outputStrings: {
      maniacalProbeTanksHealers: {
        en: 'Maniacal Probe: Tanks & Healers',
        de: 'Tentakeltanz: Tanks & Heiler',
        fr: 'Farandole de tentacules : Tank et Heals',
        ja: '触手乱舞: タンク/ヒーラー',
        cn: 'T奶触手',
        ko: '촉수 난무: 탱/힐'
      },
      maniacalProbeDps: {
        en: 'Maniacal Probe: DPS',
        de: 'Tentakeltanz: DDs',
        fr: 'Farandole de tentacules : DPS',
        ja: '触手乱舞: DPS',
        cn: 'DPS触手',
        ko: '촉수 난무: 딜러'
      },
      dpsProbe: {
        en: 'dps probe',
        de: 'dee dees tentakel',
        fr: 'DPS tentacules',
        ja: 'dpsに触手乱舞',
        cn: 'dps触手',
        ko: '딜러 촉수 난무'
      },
      tankHealProbe: {
        en: 'tank heal probe',
        de: 'tenks heiler tentakel',
        fr: 'Tank/Heal tentacules',
        ja: 'タンクヒラに触手乱舞',
        cn: 'T奶触手',
        ko: '탱힐 촉수난무'
      }
    }
  }, {
    id: 'O2S Maniacal Probe You',
    type: 'HeadMarker',
    netRegex: {
      id: '0005 '
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Probe on YOU',
        de: 'Sonde auf DIR',
        fr: 'Sonde sur VOUS',
        cn: '触手点名',
        ko: '촉수 대상자'
      }
    }
  }, {
    id: 'O2S Unstable Gravity',
    type: 'GainsEffect',
    netRegex: {
      effectId: '550'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Elevate (Unstable Gravity)',
        de: 'Sei erhöht (Schwerkraftschwankung)',
        fr: 'Élévation (Gravité instable)',
        cn: '悬浮 (重力爆发)',
        ko: '공중부양하기 (중력 폭발)'
      }
    }
  }, {
    id: 'O2S Unstable Gravity Delayed',
    type: 'GainsEffect',
    netRegex: {
      effectId: '550'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 9,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Knocked to Edge',
        de: 'Zur Kante zurückstoßen lassen',
        fr: 'Faites-vous pousser au bord',
        cn: '击退到场边',
        ko: '가장자리로 넉백되기'
      }
    }
  }, {
    id: 'O2S 6 Fulms Under Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '237'
    },
    condition: (data, matches) => !data.under && matches.target === data.me,
    delaySeconds: 5,
    alertText: (data, _matches, output) => {
      if (!data.levitating) return output.sixFulmsUnderLevitate();
    },
    infoText: (data, _matches, output) => {
      if (data.levitating) return output.sixFulmsUnder();
    },
    tts: (_data, _matches, output) => output.float(),
    run: data => data.under = true,
    outputStrings: {
      sixFulmsUnder: {
        en: '6 Fulms Under',
        de: 'Versinkend',
        fr: 'Enfoncement',
        ja: '沈下',
        cn: '下陷',
        ko: '하강'
      },
      sixFulmsUnderLevitate: {
        en: '6 Fulms Under: Levitate',
        de: 'Versinkend: Schweben',
        fr: 'Enfoncement : Lévitation',
        ja: '沈下: 浮上',
        cn: '下陷：悬浮',
        ko: '하강: 공중부양'
      },
      float: {
        en: 'float',
        de: 'schweben',
        fr: 'Flottez',
        ja: '浮上',
        cn: '悬浮',
        ko: '공중부양'
      }
    }
  }, {
    id: 'O2S 6 Fulms Under Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '237'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.under = false
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Catastrophe': 'Katastroph',
      'Fleshy Member': 'Tentakel'
    },
    'replaceText': {
      '\\(ground\\)': '(Boden)',
      '-100 Gs': 'Minus 100 G',
      '(?<!-)100 Gs': '100 G',
      'Antilight': 'Dunkellicht',
      'Death\'s Gaze': 'Todesblick',
      'Double Stack': 'Doppelt Sammeln',
      'Earthquake': 'Erdbeben',
      'Epicenter': 'Epizentrum',
      'Evilsphere': 'Sphäre des Bösen',
      'Gravitational Distortion': 'Massenverzerrung',
      'Gravitational Wave': 'Gravitationswelle',
      'Long Drop': 'Tiefer Fall',
      'Paranormal Wave': 'Paranormale Welle',
      'Probes': 'Sonden',
      'Unstable Gravity': 'Schwerkraftschwankung',
      'Tremblor': 'Erschütterung',
      'Gravitational Manipulation': 'Schwerkraftmanipulation',
      'Gravitational Explosion': 'Gravitationsknall',
      'Erosion': 'Erosion',
      'Main Quake': 'Hauptbeben',
      'Maniacal Probe': 'Tentakeltanz',
      'Gravitational Collapse': 'Gravitationseinbruch'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Catastrophe': 'Catastrophe',
      'Fleshy Member': 'tentacule'
    },
    'replaceText': {
      '\\(ground\\)': 'sol',
      '-100 Gs': 'Gravité -100',
      '(?<!-)100 Gs': 'Gravité 100',
      'Antilight': 'Lumière obscure',
      'Death\'s Gaze': 'Œil de la Mort',
      'Double Stack': 'Double package',
      'Earthquake': 'Grand séisme',
      'Epicenter': 'Épicentre',
      'Erosion': 'Érosion',
      'Evilsphere': 'Sphère démoniaque',
      'Gravitational Collapse': '',
      'Gravitational Distortion': 'Distorsion gravitationnelle',
      'Gravitational Explosion': 'Explosion gravitationnelle',
      'Gravitational Manipulation': 'Manipulation gravitationnelle',
      'Gravitational Wave': 'Onde gravitationnelle',
      'Long Drop': 'Chute ininterrompue',
      'Main Quake': 'Secousse principale',
      'Maniacal Probe': 'Farandole de tentacules',
      'Paranormal Wave': 'Onde maudite',
      'Tremblor': 'Tremblement de terre',
      'Unstable Gravity': 'Gravité instable'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Catastrophe': 'カタストロフィー',
      'Fleshy Member': '触手'
    },
    'replaceText': {
      '\\(T/H\\)': '(タンク/ヒラ)',
      '-100 Gs': '重力マイナス100',
      '(?<!-)100 Gs': '重力100',
      'Antilight': '暗黒光',
      'Death\'s Gaze': '死神の瞳',
      'Double Stack': '二重頭割り',
      'Earthquake': '大地震',
      'Epicenter': '震源生成',
      'Evilsphere': 'イビルスフィア',
      'Gravitational Distortion': '重力歪曲',
      'Gravitational Wave': '重力波',
      'Long Drop': '自由落下',
      'Paranormal Wave': '呪詛波',
      'Probes': '触手乱舞',
      'Unstable Gravity': 'グラビティバースト',
      'Tremblor': '地震',
      'Gravitational Manipulation': '重力操作',
      'Gravitational Explosion': '重力爆発',
      'Erosion': '浸食',
      'Main Quake': '本震',
      'Maniacal Probe': '触手乱舞',
      'Gravitational Collapse': '重力崩壊'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Catastrophe': '灾变者',
      'Fleshy Member': '触手'
    },
    'replaceText': {
      '\\(T/H\\)': '(T/奶)',
      '-100 Gs': '重力-100',
      '(?<!-)100 Gs': '重力100',
      'Antilight': '暗黑光',
      'Death\'s Gaze': '死神之瞳',
      'Double Stack': '二连分摊',
      'Earthquake': '大地震',
      'Epicenter': '震源制造',
      'Evilsphere': '邪球',
      'Gravitational Distortion': '重力扭曲',
      'Gravitational Wave': '重力波',
      'Long Drop': '自由落体',
      'Paranormal Wave': '诅咒波',
      'Probes': '引导',
      'Unstable Gravity': '重力爆发',
      'Tremblor': '地震',
      'Gravitational Manipulation': '重力操纵',
      'Gravitational Explosion': '重力爆发',
      'Erosion': '侵入',
      'Main Quake': '主震',
      'Maniacal Probe': '触手乱舞',
      'Gravitational Collapse': '重力崩坏'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Catastrophe': '카타스트로피',
      'Fleshy Member': '촉수'
    },
    'replaceText': {
      '-100 Gs': '중력 -100',
      '(?<!-)100 Gs': '중력 100',
      'Antilight': '암흑광',
      '(?<!Epi)center': '중앙',
      'Death\'s Gaze': '사신의 눈동자',
      'Double Stack': '이중쉐어',
      'Earthquake': '대지진',
      'Epicenter': '진원 생성',
      'Evilsphere': '악의 세력권',
      'Gravitational Distortion': '중력 왜곡',
      'Gravitational Wave': '중력파',
      'Long Drop': '자유낙하',
      'Paranormal Wave': '저주 파동',
      'Probes': '촉수 유도',
      'Unstable Gravity': '중력 폭발',
      'T/H': '탱/힐',
      'Tremblor': '지진',
      'Gravitational Manipulation': '중력 조작',
      'Gravitational Explosion': '중력 폭발',
      'Erosion': '침식',
      'Main Quake': '본진',
      'Maniacal Probe': '촉수 난무',
      'Gravitational Collapse': '중력 붕괴'
    }
  }]
};
/* harmony default export */ const o2s = (o2s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o2s.txt
const raid_o2s_namespaceObject = "### Omega 2 (Savage)\r\n# Omega - Deltascape V2.0 (Savage)\r\n# -ii 25B6 2479 247A 2356 2364 245D 2368 2365 2366 24DB 235F 236D 2360 23EF 2362 235D\r\n# -p 2373:5\r\n\r\n# Note: Weighted Wing (236C) is renamed to Unstable Gravity, the effect it gives.\r\n\r\nhideall \"--sync--\"\r\nhideall \"--Reset--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n5.0 \"Tremblor\" Ability { id: \"2373\", source: \"Catastrophe\" } window 5,2.5\r\n8.7 \"Tremblor\" Ability { id: \"2373\", source: \"Catastrophe\" }\r\n17.4 \"Earthquake\" Ability { id: \"2374\", source: \"Catastrophe\" } window 18,10\r\n24.6 \"100 Gs\" Ability { id: \"2355\", source: \"Catastrophe\" }\r\n32.8 \"Antilight (center)\" Ability { id: \"2361\", source: \"Catastrophe\" }\r\n50.0 \"Gravitational Wave\" Ability { id: \"2372\", source: \"Catastrophe\" }\r\n60.3 \"Gravitational Manipulation\" Ability { id: \"2363\", source: \"Catastrophe\" }\r\n63.4 \"Gravitational Distortion\" Ability { id: \"2369\", source: \"Catastrophe\" }\r\n67.5 \"Gravitational Explosion\" Ability { id: \"2367\", source: \"Catastrophe\" }\r\n\r\n73.6 \"Paranormal Wave 1\" Ability { id: \"2370\", source: \"Catastrophe\" }\r\n78.8 \"Paranormal Wave 2\" Ability { id: \"2370\", source: \"Catastrophe\" }\r\n89.0 \"Evilsphere\" Ability { id: \"2371\", source: \"Catastrophe\" }\r\n96.2 \"Paranormal Wave 3\" Ability { id: \"2370\", source: \"Catastrophe\" }\r\n\r\n106.3 \"Maniacal Probe (T/H)\" Ability { id: \"235A\", source: \"Catastrophe\" }\r\n116.4 \"Erosion\" Ability { id: \"235B\", source: \"Fleshy Member\" }\r\n117.5 \"Death's Gaze\" Ability { id: \"236F\", source: \"Catastrophe\" }\r\n122.7 \"Epicenter\" Ability { id: \"2357\", source: \"Catastrophe\" }\r\n129.9 \"Gravitational Wave\" Ability { id: \"2372\", source: \"Catastrophe\" }\r\n137.1 \"100 Gs\" Ability { id: \"2355\", source: \"Catastrophe\" }\r\n140.9 \"Main Quake\" Ability { id: \"2359\", source: \"Catastrophe\" }\r\n145.2 \"Gravitational Wave\" Ability { id: \"2372\", source: \"Catastrophe\" }\r\n\r\n150.5 \"Paranormal Wave 1\" Ability { id: \"2370\", source: \"Catastrophe\" }\r\n160.7 \"Gravitational Manipulation\" Ability { id: \"2363\", source: \"Catastrophe\" }\r\n167.9 \"Gravitational Explosion\" Ability { id: \"2367\", source: \"Catastrophe\" }\r\n175.8 \"Paranormal Wave 2\" Ability { id: \"2370\", source: \"Catastrophe\" }\r\n185.8 \"Evilsphere\" Ability { id: \"2371\", source: \"Catastrophe\" }\r\n192.8 \"Paranormal Wave 3\" Ability { id: \"2370\", source: \"Catastrophe\" }\r\n\r\n207.8 \"-100 Gs\" Ability { id: \"235E\", source: \"Catastrophe\" }\r\n217.8 \"Death's Gaze\" Ability { id: \"236F\", source: \"Catastrophe\" }\r\n227.8 \"100 Gs\" Ability { id: \"2355\", source: \"Catastrophe\" }\r\n\r\n235.8 \"Antilight (center)\" Ability { id: \"2361\", source: \"Catastrophe\" }\r\n238.3 \"Unstable Gravity (T/H)\" Ability { id: \"236C\", source: \"Catastrophe\" }\r\n243.3 \"Gravitational Wave\" Ability { id: \"2372\", source: \"Catastrophe\" }\r\n254.3 \"Long Drop\" Ability { id: \"236B\", source: \"Catastrophe\" }\r\n265.2 \"100 Gs\" Ability { id: \"2355\", source: \"Catastrophe\" }\r\n\r\n273.2 \"Antilight (ground)\" Ability { id: \"2361\", source: \"Catastrophe\" }\r\n277.2 \"Tremblor\" Ability { id: \"2373\", source: \"Catastrophe\" }\r\n280.7 \"Tremblor\" Ability { id: \"2373\", source: \"Catastrophe\" }\r\n289.2 \"Earthquake\" Ability { id: \"2374\", source: \"Catastrophe\" }\r\n299.2 \"100 Gs\" Ability { id: \"2355\", source: \"Catastrophe\" }\r\n\r\n314.2 \"Maniacal Probe (DPS)\" Ability { id: \"235A\", source: \"Catastrophe\" }\r\n324.2 \"Erosion\" Ability { id: \"235B\", source: \"Fleshy Member\" }\r\n325.2 \"Death's Gaze\" Ability { id: \"236F\", source: \"Catastrophe\" }\r\n330.2 \"Epicenter\" Ability { id: \"2357\", source: \"Catastrophe\" }\r\n339.2 \"Gravitational Manipulation\" Ability { id: \"2363\", source: \"Catastrophe\" }\r\n346.2 \"Gravitational Explosion\" Ability { id: \"2367\", source: \"Catastrophe\" }\r\n348.2 \"Main Quake\" Ability { id: \"2359\", source: \"Catastrophe\" }\r\n\r\n349.2 \"Antilight (center)\" Ability { id: \"2361\", source: \"Catastrophe\" }\r\n351.7 \"Unstable Gravity (DPS)\" Ability { id: \"236C\", source: \"Catastrophe\" }\r\n356.7 \"100 Gs\" Ability { id: \"2355\", source: \"Catastrophe\" }\r\n367.7 \"Long Drop\" Ability { id: \"236B\", source: \"Catastrophe\" }\r\n377.6 \"Paranormal Wave 1\" Ability { id: \"2370\", source: \"Catastrophe\" }\r\n382.6 \"Paranormal Wave 2\" Ability { id: \"2370\", source: \"Catastrophe\" }\r\n392.6 \"Evilsphere\" Ability { id: \"2371\", source: \"Catastrophe\" }\r\n399.6 \"Paranormal Wave 3\" Ability { id: \"2370\", source: \"Catastrophe\" }\r\n\r\n409.6 \"Antilight (ground)\" Ability { id: \"2361\", source: \"Catastrophe\" }\r\n416.6 \"100 Gs\" Ability { id: \"2355\", source: \"Catastrophe\" }\r\n427.6 \"Maniacal Probe (T/H)\" Ability { id: \"235A\", source: \"Catastrophe\" }\r\n437.6 \"Erosion\" Ability { id: \"235B\", source: \"Fleshy Member\" }\r\n438.6 \"Death's Gaze\" Ability { id: \"236F\", source: \"Catastrophe\" }\r\n443.6 \"Epicenter\" Ability { id: \"2357\", source: \"Catastrophe\" }\r\n452.6 \"Gravitational Manipulation\" Ability { id: \"2363\", source: \"Catastrophe\" }\r\n459.6 \"Gravitational Explosion\" Ability { id: \"2367\", source: \"Catastrophe\" }\r\n461.6 \"Main Quake\" Ability { id: \"2359\", source: \"Catastrophe\" }\r\n\r\n462.6 \"Antilight (center)\" Ability { id: \"2361\", source: \"Catastrophe\" }\r\n465.1 \"Unstable Gravity (T/H)\" Ability { id: \"236C\", source: \"Catastrophe\" }\r\n470.1 \"100 Gs\" Ability { id: \"2355\", source: \"Catastrophe\" }\r\n481.1 \"Long Drop\" Ability { id: \"236B\", source: \"Catastrophe\" }\r\n482.0 \"Gravitational Distortion\" Ability { id: \"2369\", source: \"Catastrophe\" }\r\n489.0 \"Death's Gaze\" Ability { id: \"236F\", source: \"Catastrophe\" }\r\n497.0 \"Gravitational Wave\" Ability { id: \"2372\", source: \"Catastrophe\" }\r\n\r\n499.0 \"Paranormal Wave 1\" Ability { id: \"2370\", source: \"Catastrophe\" }\r\n507.0 \"Antilight (ground)\" Ability { id: \"2361\", source: \"Catastrophe\" }\r\n514.0 \"100 Gs\" Ability { id: \"2355\", source: \"Catastrophe\" }\r\n519.0 \"Paranormal Wave 2\" Ability { id: \"2370\", source: \"Catastrophe\" }\r\n531.0 \"Evilsphere\" Ability { id: \"2371\", source: \"Catastrophe\" }\r\n538.0 \"Paranormal Wave 3\" Ability { id: \"2370\", source: \"Catastrophe\" }\r\n548.0 \"Gravitational Manipulation\" Ability { id: \"2363\", source: \"Catastrophe\" }\r\n550.0 \"Gravitational Distortion\" Ability { id: \"2369\", source: \"Catastrophe\" }\r\n555.0 \"Gravitational Explosion\" Ability { id: \"2367\", source: \"Catastrophe\" }\r\n\r\n562.0 \"Antilight (ground)\" Ability { id: \"2361\", source: \"Catastrophe\" }\r\n568.0 \"Tremblor\" #Ability { id: \"2373\", source: \"Catastrophe\" }\r\n568.5 \"100 Gs\" Ability { id: \"2355\", source: \"Catastrophe\" }\r\n570.5 \"Tremblor\" #Ability { id: \"2373\", source: \"Catastrophe\" }\r\n579.0 \"Earthquake\" Ability { id: \"2374\", source: \"Catastrophe\" }\r\n587.0 \"Gravitational Wave\" Ability { id: \"2372\", source: \"Catastrophe\" }\r\n600.0 \"Gravitational Collapse\" Ability { id: \"235D\", source: \"Catastrophe\" }\r\n600.0 \"-100 Gs\" Ability { id: \"235E\", source: \"Catastrophe\" }\r\n610.0 \"Death's Gaze\" Ability { id: \"236F\", source: \"Catastrophe\" }\r\n\r\n615.0 \"Antilight (ground)\" Ability { id: \"2361\", source: \"Catastrophe\" }\r\n621.0 \"Tremblor\" #Ability { id: \"2373\", source: \"Catastrophe\" }\r\n621.5 \"100 Gs\" Ability { id: \"2355\", source: \"Catastrophe\" }\r\n623.5 \"Tremblor\" #Ability { id: \"2373\", source: \"Catastrophe\" }\r\n632.0 \"Earthquake\" Ability { id: \"2374\", source: \"Catastrophe\" }\r\n\r\n633.3 \"--sync--\" StartsUsing { id: \"25A2\", source: \"Catastrophe\" }\r\n643.3 \"Gravitational Wave Enrage\" Ability { id: \"25A2\", source: \"Catastrophe\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o3n.ts



// O3 - Deltascape 3.0 Normal
const o3n_triggerSet = {
  id: 'DeltascapeV30',
  zoneId: zone_id/* default.DeltascapeV30 */.Z.DeltascapeV30,
  timelineFile: 'o3n.txt',
  initData: () => {
    return {
      holyCounter: 0,
      gameCount: 0,
      phaseNumber: 1
    };
  },
  timelineTriggers: [{
    id: 'O3N Frost Breath',
    regex: /Frost Breath/,
    beforeSeconds: 4,
    response: responses/* Responses.tankCleave */.n3.tankCleave('alert')
  }],
  triggers: [{
    id: 'O3N Phase Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: '2304',
      source: 'Halicarnassus',
      capture: false
    },
    run: data => data.phaseNumber += 1
  }, {
    // Normal spellblade holy with one stack point.
    // "64" is a stack marker.  "65" is the prey marker.
    // The debuff order in the logs is:
    //   (1) stack marker
    //   (2) prey marker
    //   (3) prey marker
    id: 'O3N Spellblade Holy Standard',
    type: 'HeadMarker',
    netRegex: {
      id: ['0064', '0065']
    },
    condition: (data, matches) => {
      // Cave phase has no stack markers.
      if (data.phaseNumber === 2) return false;
      data.holyTargets ??= [];
      data.holyTargets.push(matches.target);
      return data.holyTargets.length === 3;
    },
    alertText: (data, _matches, output) => {
      if (data.holyTargets?.[0] === data.me) return output.stackOnYou();
      for (let i = 1; i < 3; i++) {
        if (data.holyTargets?.[i] === data.me) return output.out();
      }
      return output.stackOnHolytargets({
        player: data.holyTargets?.[0]
      });
    },
    run: data => delete data.holyTargets,
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      out: {
        en: 'Out',
        de: 'Raus',
        fr: 'Extérieur',
        ja: '外へ',
        cn: '远离',
        ko: '밖으로'
      },
      stackOnHolytargets: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'O3N Spellblade Holy Cave',
    type: 'HeadMarker',
    netRegex: {
      id: '0065'
    },
    condition: (data, matches) => data.phaseNumber === 2 && data.me === matches.target,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'O3N Spellblade Holy Mindjack',
    type: 'HeadMarker',
    netRegex: {
      id: '0064'
    },
    condition: data => {
      if (data.phaseNumber < 3) return false;
      return data.holyCounter % 2 === 0;
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn(),
    run: data => {
      data.holyCounter += 1;
      delete data.holyTargets;
    }
  }, {
    id: 'O3N The Queen\'s Waltz: Crystal Square',
    type: 'StartsUsing',
    netRegex: {
      id: '2471',
      source: 'Halicarnassus',
      capture: false
    },
    infoText: (_data, _matches, output) => output.getOnCrystalSquare(),
    tts: (_data, _matches, output) => output.blueSquare(),
    outputStrings: {
      getOnCrystalSquare: {
        en: 'Get on crystal square',
        de: 'Kristallfeld',
        fr: 'Allez sur un carré de cristal',
        ja: '青い床に',
        cn: '站在蓝地板',
        ko: '파란 장판으로'
      },
      blueSquare: {
        en: 'blue square',
        de: 'blaues feld',
        fr: 'Carré bleu',
        ja: '青い床',
        cn: '蓝地板',
        ko: '파란 장판'
      }
    }
  }, {
    id: 'O3N Great Dragon',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Great Dragon',
      capture: false
    },
    condition: data => data.role === 'tank',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Grab dragon',
        de: 'Drachen nehmen',
        fr: 'Attrapez le dragon',
        ja: 'ドラゴンを取って',
        cn: '拉住巨龙',
        ko: '용 잡기'
      }
    }
  }, {
    id: 'O3N Game Counter Initialize',
    type: 'StartsUsing',
    netRegex: {
      id: '2304',
      source: 'Halicarnassus',
      capture: false
    },
    run: data => data.gameCount = 1
  }, {
    id: 'O3N Good Ribbit',
    type: 'StartsUsing',
    netRegex: {
      id: '2466',
      source: 'Halicarnassus',
      capture: false
    },
    condition: data => data.phaseNumber === 3 && data.gameCount % 2 === 0,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get hit by Ribbit',
        de: 'Lass dich von Quaaak treffen',
        fr: 'Faites-vous frapper par Coâââ',
        ja: 'クルルルルを受ける',
        cn: 'BOSS正面吃呱呱',
        ko: '개굴장판 맞기'
      }
    }
  }, {
    id: 'O3N Bad Ribbit',
    type: 'StartsUsing',
    netRegex: {
      id: '2466',
      source: 'Halicarnassus',
      capture: false
    },
    condition: data => !(data.phaseNumber === 3 && data.gameCount % 2 === 0),
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'O3N The Game',
    type: 'StartsUsing',
    netRegex: {
      id: '246D',
      source: 'Halicarnassus',
      capture: false
    },
    // No point in checking whether the user has the frog debuff,
    // if they didn't get it, or got it when they shouldn't have, there's no fixing things.
    infoText: (data, _matches, output) => {
      if (data.phaseNumber === 3 && data.gameCount % 2 === 0) return output.standOnFrogTile();

      // Maybe there's a cleaner way to do this than just enumerating roles?
      if (data.role === 'tank') return output.standOnShield();
      if (data.role === 'healer') return output.standOnCross();
      if (data.role === 'dps') return output.standOnSword();
    },
    run: data => data.gameCount += 1,
    outputStrings: {
      standOnFrogTile: {
        en: 'Stand on frog tile',
        de: 'Auf Frosch-Fläche stehen',
        fr: 'Placez-vous sur la grenouille',
        ja: 'カエルパネルを踏む',
        cn: '站在呱呱方块',
        ko: '개구리 장판으로'
      },
      standOnShield: {
        en: 'Stand on shield',
        de: 'Auf Schild-Fläche stehen',
        fr: 'Placez-vous sur le bouclier',
        ja: 'タンクパネルを踏む',
        cn: '站在坦克方块',
        ko: '방패 장판으로'
      },
      standOnCross: {
        en: 'Stand on cross',
        de: 'Auf Kreuz-Fläche stehen',
        fr: 'Placez-vous sur la croix',
        ja: 'ヒーラーパネルを踏む',
        cn: '站在治疗方块',
        ko: '십자가 장판으로'
      },
      standOnSword: {
        en: 'Stand on sword',
        de: 'Auf Schwert-Fläche stehen',
        fr: 'Placez-vous sur l\'épée',
        ja: 'DPSパネルを踏む',
        cn: '站在DPS方块',
        ko: '검 장판으로'
      }
    }
  }, {
    id: 'O3N Mindjack Forward',
    type: 'StartsUsing',
    netRegex: {
      id: '2467',
      source: 'Halicarnassus',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mindjack: Forward',
        de: 'Geistlenkung: Vorwärts',
        fr: 'Contrainte mentale : vers l\'avant',
        ja: 'マインドジャック: 前進',
        cn: '精神控制：向前',
        ko: '정신 장악: 앞쪽'
      }
    }
  }, {
    id: 'O3N Mindjack Backward',
    type: 'StartsUsing',
    netRegex: {
      id: '2468',
      source: 'Halicarnassus',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mindjack: Back',
        de: 'Geistlenkung: Zurück',
        fr: 'Contrainte mentale : vers l\'arrière',
        ja: 'マインドジャック: 後退',
        cn: '精神控制：向后',
        ko: '정신 장악: 뒤쪽'
      }
    }
  }, {
    id: 'O3N Mindjack Left',
    type: 'StartsUsing',
    netRegex: {
      id: '2469',
      source: 'Halicarnassus',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mindjack: Left',
        de: 'Geistlenkung: Links',
        fr: 'Contrainte mentale : vers la gauche',
        ja: 'マインドジャック: 左折',
        cn: '精神控制：向左',
        ko: '정신 장악: 왼쪽'
      }
    }
  }, {
    id: 'O3N Mindjack Right',
    type: 'StartsUsing',
    netRegex: {
      id: '246A',
      source: 'Halicarnassus',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mindjack: Right',
        de: 'Geistlenkung: Rechts',
        fr: 'Contrainte mentale : vers la droite',
        ja: 'マインドジャック: 右折',
        cn: '精神控制：向右',
        ko: '정신 장악: 오른쪽'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aetherial Tear': 'Ätherspalt',
      'Great Dragon': 'Riesendrache',
      'Halicarnassus': 'Halikarnassos',
      'Soul Reaper': 'Seelenschnitter'
    },
    'replaceText': {
      '\\(avoid\\)': '(ausweichen)',
      '\\(Starry End\\)': '(Sternhimmel Ende)',
      '\\(symbols\\)': '(Symbole)',
      '\\(take\\)': '(drin stehen)',
      '\\(toad\\)': '(Frosch)',
      'Aetherial Pull': 'Einsaugen',
      'Aetherial Tear': 'Ätherspalt',
      'Cross Reaper': 'Sensenschwung',
      'Dimensional Wave': 'Dimensionswelle',
      'Frost Breath': 'Frostiger Atem',
      'Gusting Gouge': 'Meißelstoß',
      'Holy Blur': 'Heiliger Nebel',
      'Holy Edge': 'Heiliger Grat',
      'Mindjack': 'Geistlenkung',
      'Panel Swap': 'Neuaufstellung',
      'Place Dark Token': 'Todesspielstein',
      'Place Token': 'Spielstein',
      'Ribbit': 'Quaaak',
      'Spellblade Blizzard III': 'Magieklinge Eisga',
      'Spellblade Fire III': 'Magieklinge Feuga',
      'Spellblade Holy': 'Magieklinge Sanctus',
      'Spellblade Thunder III': 'Magieklinge Blitzga',
      'Sword Dance': 'Schwerttanz',
      'The Game': 'Spielbeginn',
      'The Playing Field': 'Spielfeld',
      'The Queen\'s Waltz': 'Tanz der Königin',
      'Ultimum': 'Ende der Dimension',
      'Uplift': 'Erhöhung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aetherial Tear': 'Déchirure dimensionnelle',
      'Great Dragon': 'dragon suprême',
      'Halicarnassus': 'Halicarnasse',
      'Soul Reaper': 'faucheur d\'âmes'
    },
    'replaceText': {
      '\\(avoid\\)': '(éviter)',
      '\\(Starry End\\)': '(Fin étoilée)',
      '\\(Sword Dance\\)': '(Danse du sabre)',
      '\\(symbols\\)': '(symboles)',
      '\\(take\\)': '(prendre)',
      '\\(toad\\)': '(crapaud)',
      '\\(Uplift\\)': '(Exhaussement)',
      'Aetherial Pull': 'Aspiration',
      'Aetherial Tear': 'Déchirure dimensionnelle',
      'Cross Reaper': 'Fauchaison',
      'Dimensional Wave': 'Onde dimensionnelle',
      'Frost Breath\\?': 'Souffle glacé ?',
      'Gusting Gouge': 'Gouge cisaillante',
      'Holy Blur': 'Brume sacrée',
      'Holy Edge': 'Taille sacrée',
      'Mindjack': 'Contrainte mentale',
      'Panel Swap': 'Remplacement des cases',
      'Place Dark Token': 'Pions obscurs en jeu',
      'Place Token': 'Pion en jeu',
      'Ribbit': 'Coâââ',
      'Spellblade Blizzard III': 'Magilame Méga Glace',
      'Spellblade Fire III': 'Magilame Méga Feu',
      'Spellblade Holy': 'Magilame Miracle',
      'Spellblade Thunder III': 'Magilame Méga Foudre',
      'Sword Dance': 'Danse du sabre',
      'The Game': 'Début de partie',
      'The Playing Field': 'Plateau de jeu',
      'The Queen\'s Waltz': 'Danse de la reine',
      'Ultimum': 'Déclin dimensionnel'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aetherial Tear': '次元の裂け目',
      'Great Dragon': 'ドラゴングレイト',
      'Halicarnassus': 'ハリカルナッソス',
      'Soul Reaper': 'ソウルリーパー'
    },
    'replaceText': {
      'Aetherial Pull': '吸引',
      'Aetherial Tear': '次元の裂け目',
      'Cross Reaper': 'クロスリーパー',
      'Dimensional Wave': '次元波動',
      'Frost Breath': 'フロストブレス',
      'Gusting Gouge': 'ガスティンググージ',
      'Holy Blur': 'ホーリーミスト',
      'Holy Edge': 'ホーリーエッジ',
      'Mindjack': 'マインドジャック',
      'Panel Swap': 'パネルシャッフル',
      'Place Dark Token': 'サモンデストークン',
      'Place Token': 'サモントークン',
      'Ribbit': 'クルルルル！',
      'Spellblade Blizzard III': '魔法剣ブリザガ',
      'Spellblade Fire III': '魔法剣ファイガ',
      'Spellblade Holy': '魔法剣ホーリー',
      'Spellblade Thunder III': '魔法剣サンダガ',
      'Sword Dance': '剣の舞い',
      'The Game': 'ゲームスタート',
      'The Playing Field': 'ゲームボード',
      'The Queen\'s Waltz': '女王の舞い',
      'Ultimum': '次元の終焉',
      'Uplift': '隆起'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aetherial Tear': '次元裂缝',
      'Great Dragon': '巨龙',
      'Halicarnassus': '哈利卡纳苏斯',
      'Soul Reaper': '灵魂收割者'
    },
    'replaceText': {
      'Aetherial Pull': '吸引',
      'Aetherial Tear': '次元裂缝',
      'Cross Reaper': '交叉斩击',
      'Dimensional Wave': '次元波动',
      'Frost Breath': '寒霜吐息',
      'Gusting Gouge': '削风',
      'Holy Blur': '神圣雾',
      'Holy Edge': '神圣刃',
      'Mindjack': '精神控制',
      'Panel Swap': '刷新盘面',
      'Place Dark Token': '召唤死形',
      'Place Token': '召唤魔形',
      'Ribbit': '呱呱呱呱呱！',
      'Spellblade Blizzard III': '魔法剑·冰封',
      'Spellblade Fire III': '魔法剑·爆炎',
      'Spellblade Holy': '魔法剑·神圣',
      'Spellblade Thunder III': '魔法剑·暴雷',
      'Sword Dance': '剑舞',
      'The Game': '游戏开始',
      'The Playing Field': '游戏盘面',
      'The Queen\'s Waltz': '女王之舞',
      'Ultimum': '次元终结',
      'Uplift': '隆起'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aetherial Tear': '차원의 틈새',
      'Great Dragon': '거대 드래곤',
      'Halicarnassus': '할리카르나소스',
      'Soul Reaper': '영혼 수확자'
    },
    'replaceText': {
      'Aetherial Pull': '흡인',
      'Aetherial Tear': '차원의 틈새',
      'Cross Reaper': '사신의 낫',
      'Dimensional Wave': '차원 파동',
      'Frost Breath': '서리 숨결',
      'Gusting Gouge': '칼날 돌풍',
      'Holy Blur': '성스러운 안개',
      'Holy Edge': '성스러운 칼날',
      'Mindjack': '정신 장악',
      'Panel Swap': '판 바꾸기',
      'Place Dark Token': '죽음의 토큰 소환',
      'Place Token': '토큰 소환',
      'Ribbit': '개굴개굴!',
      'Spellblade Blizzard III': '마법검 블리자가',
      'Spellblade Fire III': '마법검 파이가',
      'Spellblade Holy': '마법검 홀리',
      'Spellblade Thunder III': '마법검 선더가',
      'Sword Dance': '칼춤',
      'The Game': '게임 시작',
      'The Playing Field': '게임판',
      'The Queen\'s Waltz': '여왕의 춤',
      'Ultimum': '차원의 종언',
      'Uplift': '융기'
    }
  }]
};
/* harmony default export */ const o3n = (o3n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o3n.txt
const raid_o3n_namespaceObject = "\r\n# DELTASCAPE V3.0--O3N\r\n# HALICARNASSUS\r\n\r\n# Enrage is approximately 13:10-13:30, depending on intermission length. Yes, Normal has an enrage.\r\n# -ii 230C 2470 2472 2473\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n9.7 \"Ribbit (avoid)\" Ability { id: \"2466\", source: \"Halicarnassus\" } window 9.7,10\r\n17.3 \"Spellblade Thunder III\" Ability { id: \"2462\", source: \"Halicarnassus\" }\r\n22.4 \"Spellblade Holy\" Ability { id: \"22EF\", source: \"Halicarnassus\" }\r\n31.4 \"Holy Blur\" Ability { id: \"2464\", source: \"Halicarnassus\" } window 30,30\r\n36.5 \"Spellblade Blizzard III\" Ability { id: \"2461\", source: \"Halicarnassus\" }\r\n41.6 \"Spellblade Fire III\" Ability { id: \"2460\", source: \"Halicarnassus\" }\r\n49.8 \"Place Dark Token\" Ability { id: \"22FC\", source: \"Halicarnassus\" }\r\n61.9 \"The Queen's Waltz (Sword Dance)\" Ability { id: \"246F\", source: \"Halicarnassus\" } window 30,30\r\n62.2 \"Cross Reaper\" Ability { id: \"246B\", source: \"Soul Reaper\" }\r\n70.0 \"The Playing Field\" Ability { id: \"2300\", source: \"Halicarnassus\" }\r\n80.2 \"The Game (symbols)\" Ability { id: \"246D\", source: \"Halicarnassus\" }\r\n\r\n# Cave phase\r\n89.4 \"Panel Swap\" Ability { id: \"2304\", source: \"Halicarnassus\" }\r\n100.5 \"The Queen's Waltz\" Ability { id: \"2471\", source: \"Halicarnassus\" }\r\n110.7 \"Place Token\" Ability { id: \"22FB\", source: \"Halicarnassus\" } window 30,30\r\n126.7 \"Frost Breath?\" # Ability { id: \"2476\", source: \"Great Dragon\" }\r\n128.8 \"The Queen's Waltz (Uplift)\" Ability { id: \"2471\", source: \"Halicarnassus\" }\r\n133.9 \"Spellblade Blizzard III\" Ability { id: \"2461\", source: \"Halicarnassus\" }\r\n134.7 \"Frost Breath?\" # Ability { id: \"2476\", source: \"Great Dragon\" }\r\n139.0 \"Spellblade Fire III\" Ability { id: \"2460\", source: \"Halicarnassus\" }\r\n142.8 \"Frost Breath?\" # Ability { id: \"2476\", source: \"Great Dragon\" }\r\n143.7 \"Spellblade Thunder III\" Ability { id: \"2462\", source: \"Halicarnassus\" }\r\n150.9 \"Frost Breath?\" # Ability { id: \"2476\", source: \"Great Dragon\" }\r\n151.8 \"Mindjack\" Ability { id: \"246[789A]\", source: \"Halicarnassus\" } window 30,30\r\n158.9 \"The Queen's Waltz (Uplift)\" Ability { id: \"2471\", source: \"Halicarnassus\" }\r\n165.1 \"Ribbit (avoid)\" Ability { id: \"2466\", source: \"Halicarnassus\" }\r\n172.2 \"Place Dark Token\" Ability { id: \"22FC\", source: \"Halicarnassus\" }\r\n177.3 \"Spellblade Holy\" Ability { id: \"22EF\", source: \"Halicarnassus\" }\r\n184.6 \"Cross Reaper\" Ability { id: \"246B\", source: \"Soul Reaper\" }\r\n186.3 \"Holy Edge\" Ability { id: \"2463\", source: \"Halicarnassus\" }\r\n190.4 \"The Queen's Waltz (Uplift)\" Ability { id: \"2471\", source: \"Halicarnassus\" }\r\n202.4 \"Aetherial Tear\" Ability { id: \"2474\", source: \"Halicarnassus\" } window 202.4,5\r\n206.5 \"--untargetable--\"\r\n\r\n# Intermission. Nothing of import happens here.\r\n216.6 \"Aetherial Pull\" Ability { id: \"2475\", source: \"Aetherial Tear\" }\r\n272.9 \"Ultimum (Starry End)\" # Ability { id: \"2477\", source: \"Halicarnassus\" }\r\n# There is unfortunately no way to continue to display\r\n# Ultimum if another player escapes before the user\r\n# We also haven't got a good way to display exactly when\r\n# Halicarnassus is targetable again.\r\n\r\n# Post-intermission.\r\n300.0 \"Panel Swap\" Ability { id: \"2304\", source: \"Halicarnassus\" } window 150,10\r\n305.1 \"The Playing Field\" Ability { id: \"2300\", source: \"Halicarnassus\" }\r\n313.3 \"Ribbit (avoid)\" Ability { id: \"2466\", source: \"Halicarnassus\" }\r\n320.5 \"The Game (symbols)\" Ability { id: \"246D\", source: \"Halicarnassus\" }\r\n329.6 \"Spellblade Holy\" Ability { id: \"22EF\", source: \"Halicarnassus\" }\r\n334.7 \"Mindjack\" Ability { id: \"246[789A]\", source: \"Halicarnassus\" } window 30,30\r\n338.6 \"Holy Blur\" Ability { id: \"2464\", source: \"Halicarnassus\" }\r\n340.4 \"Spellblade Thunder III\" Ability { id: \"2462\", source: \"Halicarnassus\" }\r\n347.6 \"Place Dark Token\" Ability { id: \"22FC\", source: \"Halicarnassus\" }\r\n360.0 \"Gusting Gouge\" Ability { id: \"246C\", source: \"Soul Reaper\" }\r\n361.7 \"Spellblade Blizzard III\" Ability { id: \"2461\", source: \"Halicarnassus\" }\r\n368.9 \"The Playing Field\" Ability { id: \"2300\", source: \"Halicarnassus\" }\r\n377.1 \"Ribbit (take)\" Ability { id: \"2466\", source: \"Halicarnassus\" } window 30,30\r\n384.2 \"The Game (toad)\" Ability { id: \"246D\", source: \"Halicarnassus\" }\r\n394.3 \"Dimensional Wave\" Ability { id: \"2465\", source: \"Halicarnassus\" }\r\n403.5 \"Spellblade Holy\" Ability { id: \"22EF\", source: \"Halicarnassus\" }\r\n407.6 \"Spellblade Fire III\" Ability { id: \"2460\", source: \"Halicarnassus\" }\r\n412.5 \"Holy Blur\" Ability { id: \"2464\", source: \"Halicarnassus\" }\r\n412.7 \"The Queen's Waltz (Sword Dance)\" Ability { id: \"246F\", source: \"Halicarnassus\" } window 30,30\r\n421.8 \"Dimensional Wave\" Ability { id: \"2465\", source: \"Halicarnassus\" }\r\n\r\n# The blocks don't change, but if we don't track them we can't note the enrage.\r\n430.0 \"The Playing Field\" Ability { id: \"2300\", source: \"Halicarnassus\" }\r\n438.2 \"Ribbit (avoid)\" Ability { id: \"2466\", source: \"Halicarnassus\" }\r\n445.3 \"The Game (symbols)\" Ability { id: \"246D\", source: \"Halicarnassus\" }\r\n454.4 \"Spellblade Holy\" Ability { id: \"22EF\", source: \"Halicarnassus\" }\r\n459.6 \"Mindjack\" Ability { id: \"246[789A]\", source: \"Halicarnassus\" } window 30,30\r\n463.5 \"Holy Blur\" Ability { id: \"2464\", source: \"Halicarnassus\" }\r\n465.3 \"Spellblade Thunder III\" Ability { id: \"2462\", source: \"Halicarnassus\" }\r\n472.4 \"Place Dark Token\" Ability { id: \"22FC\", source: \"Halicarnassus\" }\r\n484.8 \"Gusting Gouge\" Ability { id: \"246C\", source: \"Soul Reaper\" }\r\n486.5 \"Spellblade Blizzard III\" Ability { id: \"2461\", source: \"Halicarnassus\" }\r\n493.7 \"The Playing Field\" Ability { id: \"2300\", source: \"Halicarnassus\" }\r\n501.9 \"Ribbit (take)\" Ability { id: \"2466\", source: \"Halicarnassus\" } window 30,30\r\n509.1 \"The Game (toad)\" Ability { id: \"246D\", source: \"Halicarnassus\" }\r\n519.3 \"Dimensional Wave\" Ability { id: \"2465\", source: \"Halicarnassus\" }\r\n528.5 \"Spellblade Holy\" Ability { id: \"22EF\", source: \"Halicarnassus\" }\r\n532.6 \"Spellblade Fire III\" Ability { id: \"2460\", source: \"Halicarnassus\" }\r\n537.5 \"Holy Blur\" Ability { id: \"2464\", source: \"Halicarnassus\" }\r\n537.7 \"The Queen's Waltz (Sword Dance)\" Ability { id: \"246F\", source: \"Halicarnassus\" } window 30,30\r\n546.8 \"Dimensional Wave\" Ability { id: \"2465\", source: \"Halicarnassus\" }\r\n\r\n555.0 \"The Playing Field\" Ability { id: \"2300\", source: \"Halicarnassus\" }\r\n563.2 \"Ribbit (avoid)\" Ability { id: \"2466\", source: \"Halicarnassus\" }\r\n570.3 \"The Game (symbols)\" Ability { id: \"246D\", source: \"Halicarnassus\" }\r\n579.5 \"Spellblade Holy\" Ability { id: \"22EF\", source: \"Halicarnassus\" }\r\n584.6 \"Mindjack\" Ability { id: \"246[789A]\", source: \"Halicarnassus\" } window 30,30\r\n588.5 \"Holy Blur\" Ability { id: \"2464\", source: \"Halicarnassus\" }\r\n590.3 \"Spellblade Thunder III\" Ability { id: \"2462\", source: \"Halicarnassus\" }\r\n597.4 \"Place Dark Token\" Ability { id: \"22FC\", source: \"Halicarnassus\" }\r\n609.9 \"Gusting Gouge\" Ability { id: \"246C\", source: \"Soul Reaper\" }\r\n611.6 \"Spellblade Blizzard III\" Ability { id: \"2461\", source: \"Halicarnassus\" }\r\n618.8 \"The Playing Field\" Ability { id: \"2300\", source: \"Halicarnassus\" }\r\n626.9 \"Ribbit (take)\" Ability { id: \"2466\", source: \"Halicarnassus\" } window 30,30\r\n634.0 \"The Game (toad)\" Ability { id: \"246D\", source: \"Halicarnassus\" }\r\n644.1 \"Dimensional Wave\" Ability { id: \"2465\", source: \"Halicarnassus\" }\r\n653.3 \"Spellblade Holy\" Ability { id: \"22EF\", source: \"Halicarnassus\" }\r\n657.4 \"Spellblade Fire III\" Ability { id: \"2460\", source: \"Halicarnassus\" }\r\n662.3 \"Holy Blur\" Ability { id: \"2464\", source: \"Halicarnassus\" }\r\n662.5 \"The Queen's Waltz (Sword Dance)\" Ability { id: \"246F\", source: \"Halicarnassus\" } window 30,30\r\n671.7 \"Dimensional Wave\" Ability { id: \"2465\", source: \"Halicarnassus\" }\r\n\r\n679.9 \"The Playing Field\" Ability { id: \"2300\", source: \"Halicarnassus\" }\r\n688.0 \"Ribbit (avoid)\" Ability { id: \"2466\", source: \"Halicarnassus\" }\r\n695.1 \"The Game (symbols)\" Ability { id: \"246D\", source: \"Halicarnassus\" }\r\n704.3 \"Spellblade Holy\" Ability { id: \"22EF\", source: \"Halicarnassus\" }\r\n709.4 \"Mindjack\" Ability { id: \"246[789A]\", source: \"Halicarnassus\" } window 30,30\r\n713.3 \"Holy Blur\" Ability { id: \"2464\", source: \"Halicarnassus\" }\r\n715.0 \"Spellblade Thunder III\" Ability { id: \"2462\", source: \"Halicarnassus\" }\r\n722.1 \"Place Dark Token\" Ability { id: \"22FC\", source: \"Halicarnassus\" }\r\n734.6 \"Gusting Gouge\" Ability { id: \"246C\", source: \"Soul Reaper\" }\r\n736.3 \"Spellblade Blizzard III\" Ability { id: \"2461\", source: \"Halicarnassus\" }\r\n743.5 \"The Playing Field\" Ability { id: \"2300\", source: \"Halicarnassus\" }\r\n751.6 \"Ribbit (take)\" Ability { id: \"2466\", source: \"Halicarnassus\" } window 30,30\r\n758.7 \"The Game (toad)\" Ability { id: \"246D\", source: \"Halicarnassus\" }\r\n768.8 \"Dimensional Wave\" Ability { id: \"2465\", source: \"Halicarnassus\" }\r\n777.9 \"Spellblade Holy\" Ability { id: \"22EF\", source: \"Halicarnassus\" }\r\n782.1 \"Spellblade Fire III\" Ability { id: \"2460\", source: \"Halicarnassus\" }\r\n787.0 \"Holy Blur\" Ability { id: \"2464\", source: \"Halicarnassus\" }\r\n787.2 \"The Queen's Waltz (Sword Dance)\" Ability { id: \"246F\", source: \"Halicarnassus\" } window 30,30\r\n796.3 \"Dimensional Wave\" Ability { id: \"2465\", source: \"Halicarnassus\" }\r\n804.5 \"The Playing Field\" Ability { id: \"2300\", source: \"Halicarnassus\" }\r\n811.6 \"The Game (enrage)\" Ability { id: \"246D\", source: \"Halicarnassus\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o3s.ts





// export type Data = RaidbossData;

// O3S - Deltascape 3.0 Savage
const o3s_triggerSet = {
  id: 'DeltascapeV30Savage',
  zoneId: zone_id/* default.DeltascapeV30Savage */.Z.DeltascapeV30Savage,
  timelineFile: 'o3s.txt',
  timelineTriggers: [{
    id: 'O3S Great Dragon Frost Breath',
    regex: /Frost Breath/,
    beforeSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dragon Cleave',
        de: 'Drachen-Cleave',
        fr: 'Cleave du dragon',
        cn: '巨龙吐息',
        ko: '용 브레스'
      }
    }
  }],
  triggers: [{
    id: 'O3S Panel Swap Phase Counter',
    type: 'StartsUsing',
    netRegex: {
      id: '2304',
      source: 'Halicarnassus',
      capture: false
    },
    run: data => {
      data.phase = (data.phase ?? 0) + 1;
      delete data.seenHolyThisPhase;
    }
  }, {
    id: 'O3S Critical Hit',
    type: 'StartsUsing',
    netRegex: {
      id: '22EB',
      source: 'Halicarnassus'
    },
    // "Use Awareness!! <se.6>"
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O3S Dimensional Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '22F6',
      source: 'Halicarnassus',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Look for spellblade holy so that the last noisy waltz
    // books message in the library phase can be ignored.
    id: 'O3S Spellblade Holy Counter',
    type: 'Ability',
    netRegex: {
      id: '22EF',
      source: 'Halicarnassus',
      capture: false
    },
    run: data => {
      // In case something went awry, clean up any holy targets
      // so the next spellblade holy can start afresh.
      delete data.holyTargets;
      data.seenHolyThisPhase = true;
    }
  }, {
    // Normal spellblade holy with tethers and one stack point.
    // "64" is a stack marker.  "65" is the prey marker.
    // The debuff order in the logs is:
    //   (0) tethers go out
    //   (1) stack marker (tethered to #2)
    //   (2) prey marker (tethered to #1)
    //   (3) prey marker (tethered to #4)
    //   (4) prey marker (tethered to #3)
    // So, #2 is the person everybody should stack on.
    id: 'O3S Spellblade Holy',
    type: 'HeadMarker',
    netRegex: {
      id: ['0064', '0065']
    },
    condition: (data, matches) => {
      // Library phase stack markers behave differently.
      if (data.phase === 3) return false;
      data.holyTargets ??= [];
      data.holyTargets.push(matches.target);
      return true;
    },
    delaySeconds: 0.3,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        othersStackOnHoly: {
          en: '(others stack on ${player})',
          de: 'andere stacken auf ${player}',
          fr: 'Les autres se packent sur ${player}',
          ja: '他は${player}と頭割り',
          cn: '其他分摊${player}',
          ko: '${player} 다른 쉐어징'
        },
        spread: outputs/* default.spread */.Z.spread,
        stackOnHoly: outputs/* default.stackOnPlayer */.Z.stackOnPlayer,
        stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou
      };

      // If already run, abort.
      if (!data.holyTargets || data.holyTargets.length < 2) return;
      const stackTarget = data.holyTargets[1];
      const ret = {};
      if (data.me === stackTarget) {
        ret.alarmText = output.stackOnYou();
      } else {
        if (data.holyTargets.includes(data.me)) {
          ret.alertText = output.spread();
          ret.infoText = output.othersStackOnHoly({
            player: data.party.member(stackTarget)
          });
        } else {
          ret.infoText = output.stackOnHoly({
            player: data.party.member(stackTarget)
          });
        }
      }
      return ret;
    },
    run: data => delete data.holyTargets
  }, {
    // Library phase spellblade holy with 2 stacks / 4 preys / 2 unmarked.
    id: 'O3S Library Spellblade',
    type: 'HeadMarker',
    netRegex: {
      id: ['0064', '0065']
    },
    condition: (data, matches) => {
      // This is only for library phase.
      if (data.phase !== 3) return false;
      if (matches.target === data.me) data.librarySpellbladeMe = matches.id;
      return true;
    },
    // Because people can be dead and there are eight marks, delay to
    // accumulate logs instead of counting marks.  Instantly print if
    // anything is on you.  The 6 triggers will all have condition=true
    // and run, but only the first one will print.
    delaySeconds: (data, matches) => matches.target === data.me ? 0 : 0.5,
    alertText: (data, _matches, output) => {
      if (data.librarySpellbladePrinted) return;
      data.librarySpellbladePrinted = true;
      if (data.librarySpellbladeMe === '0064') return output.goSouthStackOnYou();
      if (data.librarySpellbladeMe === '0065') return output.goNorth();
      return output.goSouthStackOnFriend();
    },
    outputStrings: {
      goSouthStackOnYou: {
        en: 'Go South: Stack on YOU',
        de: 'Nach Süden: stack auf DIR',
        fr: 'Allez au sud : Package sur VOUS',
        ja: '南へ: 自分に頭割り',
        cn: '去南边分摊点名',
        ko: '남쪽으로: 쉐어징 대상자'
      },
      goNorth: {
        en: 'Go North',
        de: 'nach norden',
        fr: 'Allez au nord',
        ja: '南へ',
        cn: '去南边',
        ko: '북쪽으로'
      },
      goSouthStackOnFriend: {
        en: 'Go South: Stack on Friend',
        de: 'nach süden: stack auf freund',
        fr: 'Allez au sud : Package sur un ami',
        ja: '南へ: 頭割り',
        cn: '去南边分摊',
        ko: '남쪽으로: 쉐어징'
      }
    }
  }, {
    id: 'O3S Right Face',
    type: 'GainsEffect',
    netRegex: {
      effectId: '510'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 8,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mindjack: Right',
        de: 'Geistlenkung: Rechts',
        fr: 'Contrainte mentale : Vers la droite',
        ja: 'マインドジャック: 右折',
        cn: '右',
        ko: '정신장악: 오른쪽'
      }
    }
  }, {
    id: 'O3S Forward March',
    type: 'GainsEffect',
    netRegex: {
      effectId: '50D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 8,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mindjack: Forward',
        de: 'Geistlenkung: Vorwärts',
        fr: 'Contrainte mentale : Vers l\'avant',
        ja: 'マインドジャック: 前進',
        cn: '前',
        ko: '정신장악: 앞쪽'
      }
    }
  }, {
    id: 'O3S Left Face',
    type: 'GainsEffect',
    netRegex: {
      effectId: '50F'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 8,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mindjack: Left',
        de: 'Geistlenkung: Links',
        fr: 'Contrainte mentale : Vers la gauche',
        ja: 'マインドジャック: 左折',
        cn: '左',
        ko: '정신장악: 왼쪽'
      }
    }
  }, {
    id: 'O3S About Face',
    type: 'GainsEffect',
    netRegex: {
      effectId: '50E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 8,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mindjack: Back',
        de: 'Geistlenkung: Zurück',
        fr: 'Contrainte mentale : Vers l\'arrière',
        ja: 'マインドジャック: 後退',
        cn: '后',
        ko: '정신장악: 뒤쪽'
      }
    }
  }, {
    id: 'O3S Ribbit',
    type: 'StartsUsing',
    netRegex: {
      id: '22F7',
      source: 'Halicarnassus',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'O3S Oink',
    type: 'StartsUsing',
    netRegex: {
      id: '22F9',
      source: 'Halicarnassus',
      capture: false
    },
    response: responses/* Responses.doritoStack */.n3.doritoStack()
  }, {
    id: 'O3S Squelch',
    type: 'StartsUsing',
    netRegex: {
      id: '22F8',
      source: 'Halicarnassus',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'O3S Individual Adds',
    type: 'AddedCombatant',
    // npcNameId, npcBaseId
    // 5626, 7399 = White Flame
    // 6724, 7400 = Great Dragon
    // 6056, 7401 = Apanda
    // There are a bunch of 6056, 7404 Apandas that get added at the beginning.
    netRegex: {
      npcNameId: ['5626', '6724', '6056'],
      npcBaseId: ['7399', '7400', '7401']
    },
    infoText: (_data, matches, output) => output.kill({
      name: matches.name
    }),
    outputStrings: {
      kill: {
        en: 'Kill ${name}',
        de: 'Töte ${name}',
        fr: 'Tuez ${name}',
        cn: '击杀 ${name}',
        ko: '${name} 잡기'
      }
    }
  }, {
    id: 'O3S Iron Giant',
    type: 'AddedCombatant',
    // 5636 = Iron Giant
    netRegex: {
      npcNameId: '5636',
      capture: false
    },
    infoText: (_data, _matches, output) => output.kill(),
    outputStrings: {
      kill: {
        en: 'Kill Giant + Ninjas',
        de: 'Töte Riese + Ninjas',
        fr: 'Tuez le Géant + Ninjas',
        cn: '击杀 巨人 + 忍者',
        ko: '철거인 + 닌자 잡기'
      }
    }
  }, {
    id: 'O3S The Queen\'s Waltz: Books',
    type: 'StartsUsing',
    netRegex: {
      id: '230E',
      source: 'Halicarnassus',
      capture: false
    },
    condition: data => {
      // Deliberately skip printing the waltz message for the
      // spellblade holy -> waltz that ends the library phase.
      return data.phase !== 3 || !data.seenHolyThisPhase;
    },
    alertText: (data, _matches, output) => {
      data.bookCount = (data.bookCount ?? 0) + 1;
      // The second books (with the Apanda) has big magic hammer circles.
      // Usually folks handle this by going to the inner corners.
      return data.bookCount !== 2 ? output.books() : output.magicHammer();
    },
    outputStrings: {
      books: {
        en: 'Books (One Per Square)',
        de: 'Bücher (Eins pro Feld)',
        fr: 'Livres (Un par carré)',
        ja: '女王の舞い: 本',
        // FIXME
        cn: '中间两排分格站位',
        ko: '책 (칸마다 한명)'
      },
      magicHammer: {
        en: 'Books + Magic Hammer',
        de: 'Bücher + Zauberhammer',
        fr: 'Livres + Marteau magique',
        cn: '书 + 魔法锤',
        ko: '책 + 마법망치'
      }
    }
  }, {
    id: 'O3S The Queen\'s Waltz: Clock',
    type: 'StartsUsing',
    netRegex: {
      id: '2306',
      source: 'Halicarnassus',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Clock',
        de: 'Himmelsrichtungen',
        fr: 'Positions',
        ja: '女王の舞い: 散開',
        // FIXME
        cn: '八方站位',
        ko: '산개'
      }
    }
  }, {
    id: 'O3S The Queen\'s Waltz: Crystal Square',
    type: 'StartsUsing',
    netRegex: {
      id: '230A',
      source: 'Halicarnassus',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Be On Blue Square',
        de: 'Stehe auf einem blauem Feld',
        fr: 'Placez-vous sur un carré bleu',
        ja: '女王の舞い: 床',
        // FIXME
        cn: '站在蓝地板',
        ko: '파란 바닥 위로'
      }
    }
  }, {
    id: 'O3S The Queen\'s Waltz: Tethers',
    type: 'StartsUsing',
    netRegex: {
      id: '2308',
      source: 'Halicarnassus',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tethers',
        de: 'Dornenranken-Verbindungen',
        fr: 'Liens',
        ja: '女王の舞い: 茨',
        // FIXME
        cn: '先集中后扯线',
        ko: '가시줄 끊기'
      }
    }
  }, {
    id: 'O3S The Queen\'s Waltz: Tethers You',
    type: 'Tether',
    netRegex: {
      id: '0012'
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.breakTether({
        player: data.party.member(matches.source)
      });else if (data.me === matches.source) return output.breakTether({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      breakTether: {
        en: 'Break Tether (${player})',
        de: 'Verbindung trennen (${player})',
        fr: 'Cassez le lien (${player})',
        cn: '扯断连线 (${player})',
        ko: '가시줄 끊기 ("${player}")'
      }
    }
  }, {
    id: 'O3S Soul Reaper',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '5634'
    },
    alertText: (data, matches, output) => {
      data.reapers ??= [];
      data.reapers.push(matches);
      if (data.reapers.length !== 4) return;

      // Everything is symmetrical and safe spots are on the diagonal,
      // so treat this as a linear problem.
      const safeSpots = new Set([0, 1, 2, 3]);

      // x, y coordinates: -15, 5, 5, 15 on rows/columns.
      // x, y coordinates: -19 or 19 if outside.
      const mapPosToIndex = coord => Math.round((coord + 15) / 10);
      for (const reaper of data.reapers) {
        const x = parseFloat(reaper.x);
        const y = parseFloat(reaper.y);

        // Skip the ~center one.
        if (Math.abs(x) < 1 && Math.abs(y) < 1) continue;
        if (Math.abs(x) < 17) safeSpots.delete(mapPosToIndex(x));
        if (Math.abs(y) < 17) safeSpots.delete(mapPosToIndex(y));
      }
      const spots = Array.from(safeSpots);
      const safeSpot = spots[0];
      if (!safeSpot || spots.length !== 1) return output.unknown();
      const outputs = {
        0: output.nwOutside(),
        1: output.nwInside(),
        2: output.seInside(),
        3: output.seOutside()
      };
      return outputs[safeSpot];
    },
    outputStrings: {
      unknown: outputs/* default.unknown */.Z.unknown,
      nwOutside: {
        en: 'NW Outside',
        de: 'NW Außen',
        fr: 'NO Extérieur',
        cn: '西北 外',
        ko: '북서쪽 바깥'
      },
      nwInside: {
        en: 'NW Inside',
        de: 'NW Innen',
        fr: 'NO Intérieur',
        cn: '西北 内',
        ko: '북서쪽 안'
      },
      seInside: {
        en: 'SE Inside',
        de: 'SO Innen',
        fr: 'SE Intérieur',
        cn: '东南 内',
        ko: '남동쪽 바깥'
      },
      seOutside: {
        en: 'SE Outside',
        de: 'SO Außen',
        fr: 'SE Intérieur',
        cn: '东南 外',
        ko: '남동쪽 안'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Oink/Ribbit/Squelch': 'Random Animal',
      'Spellblade Blizzard/Fire/Thunder': 'Elemental Spellblade'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Halicarnassus': 'Halikarnassos',
      'Apanda': 'Apanda',
      'Soul Reaper': 'Seelenschnitter'
    },
    'replaceText': {
      '\\(Apanda\\)': '(Apanda)',
      '\\(Books\\)': '(Bücher)',
      '\\(Cave\\)': '(Positionen)',
      '\\(Clock\\)': '(Positionen)',
      '\\(Crystals\\)': '(Kristalle)',
      '\\(Great Dragon\\)': '(Riesendrache)',
      '\\(library\\)': '(Bibliothek)',
      '\\(Ninjas/Giant\\)': '(Ninjas/Eisengigant)',
      '\\(Random\\)': '(Zufall)',
      '\\(Soul Reapers\\)': '(Seelenschnitter)',
      '\\(Spellblade Books\\)': '(Magieklingen Bücher)',
      '\\(Thorns\\)': '(Dornen)',
      '\\(White Flame\\)': '(Weiße Flamme)',
      'Blizzard': 'Eis',
      'Critical Hit': 'Kritischer Treffer',
      'Dimensional Wave': 'Dimensionswelle',
      'Fire': 'Feuer',
      'Haste': 'Hast',
      'Magic Hammer': 'Zauberhammer',
      'Mindjack': 'Geistlenkung',
      'Oink': 'Quiiiek',
      'Panel Swap': 'Neuaufstellung',
      'Place Dark Token': 'Todesspielstein',
      'Place Token': 'Spielstein',
      'Ribbit': 'Quaaak',
      'Spellblade Holy': 'Magieklinge Sanctus',
      'Squelch': 'Gurrr',
      'Tethers': 'Verbindungen',
      'The Game': 'Spielbeginn',
      'The Playing Field': 'Spielfeld',
      '(The )?Queen\'s Waltz': 'Tanz Der Königin',
      'Thunder': 'Blitz',
      'Cross Reaper': 'Sensenschwung',
      'Frost Breath': 'Frostiger Atem',
      'Grand Sword': 'Großschwert',
      'Gusting Gouge': 'Meißelstoß',
      'Holy Blur': 'Heiliger Nebel',
      'Holy Edge': 'Heiliger Grat',
      'Pole Shift': 'Umpolung',
      'Pummel': 'Deftige Dachtel',
      'Ray of White': 'Weißer Strahl',
      'Sword Dance': 'Schwerttanz',
      'Uplift': 'Erhöhung',
      'White Wind': 'Weißer Wind'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Apanda': 'Apanda',
      'Halicarnassus': 'Halicarnasse',
      'Soul Reaper': 'Faucheur D\'âmes'
    },
    'replaceText': {
      '\\(Books\\)': '(Livres)',
      '\\(Clock\\)': '(Positions)',
      '\\(Crystals\\)': '(Cristaux)',
      '\\(Great Dragon\\)': '(Dragon suprême)',
      '\\(Ninjas/Giant\\)': '(Ninjas/Géant)',
      '\\(Random\\)': '(Aléatoire)',
      '\\(Soul Reapers\\)': '(Faucheurs D\'âmes)',
      '\\(Spellblade Books\\)': '(Livres de sorts)',
      '\\(Thorns\\)': '(Ronces)',
      '\\(Tethers\\)': '(Liens)',
      '\\(White Flame\\)': '(Flamme blanche)',
      'Critical Hit': 'Attaque critique',
      'Cross Reaper': 'Fauchaison',
      'Dimensional Wave': 'Onde dimensionnelle',
      'Frost Breath': 'Souffle glacé',
      'Grand Sword': 'Grande épée',
      'Gusting Gouge': 'Gouge cisaillante',
      'Haste': 'Hâte',
      'Holy Blur': 'Brume sacrée',
      'Holy Edge': 'Taille sacrée',
      'Magic Hammer': 'Marteau magique',
      'Mindjack': 'Contrainte mentale',
      'Oink(?!/)': 'Abracadabri',
      'Oink/Ribbit/Squelch': 'Animal aléatoire',
      'Panel Swap': 'Remplacement des cases',
      'Place Dark Token': 'Pions obscurs en jeu',
      'Place Token': 'Pion en jeu',
      'Pole Shift': 'Inversion des pôles',
      'Pummel': 'Torgnole',
      'Ray of White': 'Tir blanc',
      '(?<!/)Ribbit(?!/)': 'Coâââ',
      'Spellblade Blizzard/Fire/Thunder': 'Magilame élémentaire',
      'Spellblade Blizzard III': 'Magilame Méga Glace',
      'Spellblade Fire III': 'Magilame Méga Feu',
      'Spellblade Holy': 'Magilame Miracle',
      'Spellblade Thunder III': 'Magilame Méga Foudre',
      '(?<!/)Squelch': 'Abracadabra',
      'Sword Dance': 'Danse du sabre',
      'The Game': 'Début de partie',
      'The Playing Field': 'Plateau de jeu',
      'The Queen\'s Waltz': 'Danse de la reine',
      'Uplift': 'Exhaussement',
      'White Wind': 'Vent blanc'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Halicarnassus': 'ハリカルナッソス',
      'Apanda': 'アパンダ',
      'Soul Reaper': 'ソウルリーパー'
    },
    'replaceText': {
      'Blizzard': 'ブリザド',
      'Books': '本',
      'Clock': '散開',
      'Critical Hit': 'クリティカル',
      'Crystals': '床',
      'Dimensional Wave': '次元波動',
      'Fire': 'ファイア',
      'Haste': 'ヘイスト',
      'Magic Hammer': 'マジックハンマー',
      'Mindjack': 'マインドジャック',
      'Ninjas/Giant': 'ニンジャ / 鉄巨人',
      'Oink': 'ポルルルル！',
      'Panel Swap': 'パネルシャッフル',
      'Place Dark Token': 'サモンデストークン',
      'Place Token': 'サモントークン',
      '(?<=\\()Random(?=\\))': 'ランダム',
      'Ribbit': 'クルルルル！',
      'Spellblade Holy': '魔法剣ホーリー',
      'Squelch': 'カルルルル！',
      'Tethers': '茨',
      'The Game': 'ゲームスタート',
      'The Playing Field': 'ゲームボード',
      '(The )?Queen\'s Waltz': '女王の舞い',
      'Thunder': 'サンダー',
      'Cross Reaper': 'クロスリーパー',
      'Frost Breath': 'フロストブレス',
      'Grand Sword': 'グランドソード',
      'Gusting Gouge': 'ガスティンググージ',
      'Holy Blur': 'ホーリーミスト',
      'Holy Edge': 'ホーリーエッジ',
      'Pole Shift': '磁場転換',
      'Pummel': '殴打',
      'Ray of White': 'ホワイトショット',
      'Sword Dance': '剣の舞い',
      'Uplift': '隆起',
      'White Wind': 'ホワイトウィンド'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Halicarnassus': '哈利卡纳苏斯',
      'Apanda': '阿班达',
      'Soul Reaper': '灵魂收割者'
    },
    'replaceText': {
      '\\(Apanda\\)': '(阿班达)',
      '\\(Books\\)': '(图书)',
      '\\(Cave\\)': '(监狱)',
      '\\(Clock\\)': '(八方)',
      '\\(Crystals\\)': '(水晶)',
      '\\(Great Dragon\\)': '(巨龙)',
      '\\(library\\)': '(图书馆)',
      '\\(Ninjas/Giant\\)': '(忍者/巨人)',
      '\\(Random\\)': '(随机)',
      '\\(Soul Reapers\\)': '(死神)',
      '\\(Spellblade Books\\)': '(魔法剑)',
      '\\(Thorns\\)': '(荆棘)',
      '\\(White Flame\\)': '(白焰)',
      'Blizzard': '冰结',
      'Critical Hit': '暴击',
      'Dimensional Wave': '次元波动',
      'Fire': '火炎',
      'Haste': '加速',
      'Magic Hammer': '魔法锤',
      'Mindjack': '精神控制',
      'Oink': '哼哼哼哼哼！',
      'Panel Swap': '刷新盘面',
      'Place Dark Token': '召唤死形',
      'Place Token': '召唤魔形',
      '(The )?Queen\'s Waltz': '女王之舞',
      'Ribbit': '呱呱呱呱呱！',
      'Spellblade Holy': '魔法剑·神圣',
      'Squelch': '喀喀喀喀喀！',
      'Tethers': '连线',
      'The Game': '游戏开始',
      'The Playing Field': '游戏盘面',
      'Thunder': '闪雷',
      'Cross Reaper': '交叉斩击',
      'Frost Breath': '寒霜吐息',
      'Grand Sword': '巨剑',
      'Gusting Gouge': '削风',
      'Holy Blur': '神圣雾',
      'Holy Edge': '神圣刃',
      'Pole Shift': '磁场转换',
      'Pummel': '殴打',
      'Ray of White': '苍白射击',
      'Sword Dance': '剑舞',
      'Uplift': '隆起',
      'White Wind': '白风'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Halicarnassus': '할리카르나소스',
      'Apanda': '아판다',
      'Soul Reaper': '영혼 수확자'
    },
    'replaceText': {
      '\\(Random\\)': '(무작위)',
      '\\(Apanda\\)': '(아판다)',
      '\\(Books\\)': '(책)',
      '\\(Clock\\)': '(팔방 산개)',
      '\\(Crystals\\)': '(크리스탈)',
      '\\(Ultimate\\)': '(최종)',
      'Blizzard': '블리자드',
      'Critical Hit': '극대화',
      'Dimensional Wave': '차원 파동',
      'Fire': '파이어',
      'Haste(?! )': '헤이스트',
      'Haste III': '헤이스가',
      'Magic Hammer': '마법 망치',
      'Mindjack': '정신 장악',
      'Oink': '꿀꿀꿀꿀!',
      'Panel Swap': '판 바꾸기',
      'Place Dark Token': '죽음의 토큰 소환',
      'Place Token': '토큰 소환',
      'Ribbit': '개굴개굴!',
      'Spellblade Holy': '마법검 홀리',
      'Squelch': '보글보글!',
      'Tethers': '선',
      'The Game': '게임 시작',
      'The Playing Field': '게임판',
      '(The )?Queen\'s Waltz': '여왕의 춤',
      'Thunder': '선더',
      'Ninjas/Giant': '닌자/철거인',
      'Cross Reaper': '사신의 낫',
      'Frost Breath': '서리 숨결',
      'Grand Sword': '웅장한 검격',
      'Gusting Gouge': '칼날 돌풍',
      'Holy Blur': '성스러운 안개',
      'Holy Edge': '성스러운 칼날',
      'Pole Shift': '자기장 전환',
      'Pummel': '구타',
      'Ray of White': '하얀 사격',
      'Sword Dance': '칼춤',
      'Uplift': '융기',
      'White Wind': '하얀 바람'
    }
  }]
};
/* harmony default export */ const o3s = (o3s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o3s.txt
const raid_o3s_namespaceObject = "# Omega - Deltascape V3.0 (Savage) - O3S\r\n# Halicarnassus\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# -ii 22EA 22FE 2309 230C 230F 2315\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n10.7 \"Critical Hit\" Ability { id: \"22EB\", source: \"Halicarnassus\" } window 10.7,5\r\n19.7 \"Spellblade Holy\" Ability { id: \"22EF\", source: \"Halicarnassus\" }\r\n25.4 \"Pole Shift\" # Ability { id: \"22F[23]\", source: \"Halicarnassus\" }\r\n28.4 \"Holy Blur/Holy Edge\" Ability { id: \"22F[01]\", source: \"Halicarnassus\" }\r\n37.4 \"The Queen's Waltz (Clock)\" Ability { id: \"2306\", source: \"Halicarnassus\" } window 37.4,5\r\n37.9 \"Sword Dance\" Ability { id: \"2307\", source: \"Halicarnassus\" }\r\n41.4 \"Haste\" Ability { id: \"22F4\", source: \"Halicarnassus\" }\r\n44.8 \"Spellblade Thunder III\" Ability { id: \"22EE\", source: \"Halicarnassus\" }\r\n50.3 \"Dimensional Wave\" Ability { id: \"22F6\", source: \"Halicarnassus\" }\r\n59.3 \"The Playing Field\" Ability { id: \"2300\", source: \"Halicarnassus\" }\r\n65.3 \"Oink\" Ability { id: \"22F9\", source: \"Halicarnassus\" }\r\n72.3 \"The Game\" Ability { id: \"2301\", source: \"Halicarnassus\" } window 72.3,10\r\n\r\n81.2 \"Panel Swap (Thorns)\" Ability { id: \"2304\", source: \"Halicarnassus\" }\r\n83.2 \"--center--\" Ability { id: \"2305\", source: \"Halicarnassus\" }\r\n89.5 \"The Queen's Waltz (Tethers)\" Ability { id: \"2308\", source: \"Halicarnassus\" }\r\n94.2 \"Spellblade Fire III\" Ability { id: \"22EC\", source: \"Halicarnassus\" }\r\n98.2 \"Haste\" Ability { id: \"22F4\", source: \"Halicarnassus\" }\r\n101.5 \"Spellblade Thunder III\" Ability { id: \"22EE\", source: \"Halicarnassus\" }\r\n107.0 \"Critical Hit\" Ability { id: \"22EB\", source: \"Halicarnassus\" }\r\n113.0 \"Dimensional Wave\" Ability { id: \"22F6\", source: \"Halicarnassus\" } window 30,30\r\n119.0 \"Place Token (White Flame)\" Ability { id: \"22FB\", source: \"Halicarnassus\" }\r\n124.9 \"Ray of White\" # Ability { id: \"2310\", source: \"White Flame\" }\r\n129.9 \"White Wind\" # Ability { id: \"2311\", source: \"White Flame\" }\r\n130.0 \"Haste\" Ability { id: \"22F4\", source: \"Halicarnassus\" }\r\n131.9 \"Ray of White\" # Ability { id: \"2310\", source: \"White Flame\" }\r\n133.5 \"Spellblade Blizzard III\" Ability { id: \"22ED\", source: \"Halicarnassus\" }\r\n135.9 \"Ray of White\" # Ability { id: \"2310\", source: \"White Flame\" }\r\n140.5 \"Mindjack\" Ability { id: \"22FA\", source: \"Halicarnassus\" } window 140,10\r\n146.0 \"--center--\" Ability { id: \"2305\", source: \"Halicarnassus\" }\r\n152.6 \"The Queen's Waltz (Tethers)\" Ability { id: \"2308\", source: \"Halicarnassus\" }\r\n157.6 \"Spellblade Fire III\" Ability { id: \"22EC\", source: \"Halicarnassus\" }\r\n163.6 \"Dimensional Wave\" Ability { id: \"22F6\", source: \"Halicarnassus\" }\r\n\r\n171.1 \"Panel Swap (Cave)\" Ability { id: \"2304\", source: \"Halicarnassus\" } window 85,10\r\n176.1 \"Place Token (Great Dragon)\" Ability { id: \"22FB\", source: \"Halicarnassus\" }\r\n187.1 \"The Queen's Waltz (Crystals)\" Ability { id: \"230A\", source: \"Halicarnassus\" }\r\n187.9 \"Frost Breath\" # Ability { id: \"2312\", source: \"Great Dragon\" }\r\n188.0 \"--sync--\" Ability { id: \"230B\", source: \"Halicarnassus\" }\r\n188.4 \"Uplift\" Ability { id: \"230D\", source: \"Halicarnassus\" }\r\n193.3 \"Ribbit\" Ability { id: \"22F7\", source: \"Halicarnassus\" } window 193.3,10\r\n197.9 \"Frost Breath\" # Ability { id: \"2312\", source: \"Great Dragon\" }\r\n199.3 \"Dimensional Wave\" Ability { id: \"22F6\", source: \"Halicarnassus\" }\r\n212.3 \"Critical Hit\" Ability { id: \"22EB\", source: \"Halicarnassus\" }\r\n223.3 \"Place Dark Token (Soul Reapers)\" Ability { id: \"22FC\", source: \"Halicarnassus\" }\r\n235.3 \"The Queen's Waltz (Crystals)\" Ability { id: \"230A\", source: \"Halicarnassus\" }\r\n236.2 \"--sync--\" Ability { id: \"230B\", source: \"Halicarnassus\" }\r\n236.6 \"Uplift\" Ability { id: \"230D\", source: \"Halicarnassus\" }\r\n236.6 \"Cross Reaper/Gusting Gouge\" Ability { id: \"22F[DF]\", source: \"Soul Reaper\" }\r\n239.3 \"Haste\" Ability { id: \"22F4\", source: \"Halicarnassus\" }\r\n242.9 \"Spellblade Blizzard/Fire/Thunder\" Ability { id: \"22E[CDE]\", source: \"Halicarnassus\" }\r\n248.3 \"Dimensional Wave\" Ability { id: \"22F6\", source: \"Halicarnassus\" } window 30,30\r\n\r\n254.3 \"Panel Swap (library)\" Ability { id: \"2304\", source: \"Halicarnassus\" }\r\n261.3 \"The Queen's Waltz (Books)\" Ability { id: \"230E\", source: \"Halicarnassus\" } window 261.3,10\r\n268.3 \"Oink\" Ability { id: \"22F9\", source: \"Halicarnassus\" }\r\n273.3 \"Place Token (Apanda)\" Ability { id: \"22FB\", source: \"Halicarnassus\" }\r\n281.2 \"Pummel\" # Ability { id: \"2313\", source: \"Apanda\" }\r\n286.4 \"The Queen's Waltz (Books)\" Ability { id: \"230E\", source: \"Halicarnassus\" }\r\n288.7 \"Magic Hammer\" Ability { id: \"2314\", source: \"Apanda\" }\r\n292.4 \"Squelch\" Ability { id: \"22F8\", source: \"Halicarnassus\" } window 292.4,10\r\n294.8 \"Pummel\" # Ability { id: \"2313\", source: \"Apanda\" }\r\n298.5 \"Dimensional Wave\" Ability { id: \"22F6\", source: \"Halicarnassus\" }\r\n302.9 \"Pummel\" # Ability { id: \"2313\", source: \"Apanda\" }\r\n304.6 \"Critical Hit\" Ability { id: \"22EB\", source: \"Halicarnassus\" }\r\n316.6 \"Dimensional Wave\" Ability { id: \"22F6\", source: \"Halicarnassus\" }\r\n321.6 \"Spellblade Holy\" Ability { id: \"22EF\", source: \"Halicarnassus\" }\r\n329.6 \"The Queen's Waltz (Spellblade Books)\" Ability { id: \"230E\", source: \"Halicarnassus\" } window 30,30\r\n330.5 \"Holy Blur/Holy Edge\" Ability { id: \"22F[01]\", source: \"Halicarnassus\" }\r\n339.5 \"Dimensional Wave\" Ability { id: \"22F6\", source: \"Halicarnassus\" }\r\n\r\n347.5 \"Panel Swap (thorns)\" Ability { id: \"2304\", source: \"Halicarnassus\" }\r\n352.5 \"The Playing Field\" Ability { id: \"2300\", source: \"Halicarnassus\" } window 250,20\r\n362.5 \"Oink/Ribbit/Squelch 1\" Ability { id: \"22F[789]\", source: \"Halicarnassus\" }\r\n368.7 \"Oink/Ribbit/Squelch 2\" Ability { id: \"22F[789]\", source: \"Halicarnassus\" }\r\n374.7 \"Oink/Ribbit/Squelch 3\" Ability { id: \"22F[789]\", source: \"Halicarnassus\" }\r\n381.7 \"The Game\" Ability { id: \"2301\", source: \"Halicarnassus\" }\r\n388.0 \"--teleport--\" Ability { id: \"2305\", source: \"Halicarnassus\" }\r\n394.5 \"The Queen's Waltz (Random)\" Ability { id: \"230[68AE]\", source: \"Halicarnassus\" }\r\n403.8 \"Spellblade Holy\" Ability { id: \"22EF\", source: \"Halicarnassus\" }\r\n409.9 \"Pole Shift\" # Ability { id: \"22F[23]\", source: \"Halicarnassus\" }\r\n412.9 \"Holy Blur/Holy Edge\" Ability { id: \"22F[01]\", source: \"Halicarnassus\" }\r\n420.1 \"Critical Hit\" Ability { id: \"22EB\", source: \"Halicarnassus\" }\r\n429.3 \"Mindjack\" Ability { id: \"22FA\", source: \"Halicarnassus\" }\r\n434.5 \"Place Dark Token (Soul Reapers)\" Ability { id: \"22FC\", source: \"Halicarnassus\" }\r\n448.1 \"Cross Reaper/Gusting Gouge\" Ability { id: \"22F[DF]\", source: \"Soul Reaper\" }\r\n449.7 \"--teleport--\" Ability { id: \"2305\", source: \"Halicarnassus\" }\r\n456.0 \"The Queen's Waltz (Random)\" Ability { id: \"230[68AE]\", source: \"Halicarnassus\" }\r\n469.0 \"Dimensional Wave\" Ability { id: \"22F6\", source: \"Halicarnassus\" }\r\n477.1 \"Haste\" Ability { id: \"22F4\", source: \"Halicarnassus\" } window 30,30\r\n480.8 \"Spellblade Blizzard/Fire/Thunder 1\" Ability { id: \"22E[CDE]\", source: \"Halicarnassus\" }\r\n485.4 \"Spellblade Blizzard/Fire/Thunder 2\" Ability { id: \"22E[CDE]\", source: \"Halicarnassus\" }\r\n491.5 \"Dimensional Wave\" Ability { id: \"22F6\", source: \"Halicarnassus\" }\r\n501.7 \"Place Token (Ninjas/Giant)\" Ability { id: \"22FB\", source: \"Halicarnassus\" }\r\n512.0 \"Haste III\" Ability { id: \"22F5\", source: \"Halicarnassus\" }\r\n512.7 \"Grand Sword\" # Ability { id: \"2316\", source: \"Iron Giant\" }\r\n516.5 \"Dimensional Wave 1\" Ability { id: \"22F6\", source: \"Halicarnassus\" }\r\n518.7 \"Grand Sword\" # Ability { id: \"2316\", source: \"Iron Giant\" }\r\n522.1 \"Dimensional Wave 2\" Ability { id: \"22F6\", source: \"Halicarnassus\" }\r\n527.7 \"Dimensional Wave 3\" Ability { id: \"22F6\", source: \"Halicarnassus\" }\r\n533.3 \"Dimensional Wave 4\" Ability { id: \"22F6\", source: \"Halicarnassus\" }\r\n535.5 \"--teleport--\" Ability { id: \"2305\", source: \"Halicarnassus\" }\r\n540.9 \"The Queen's Waltz (Random)\" Ability { id: \"230[68AE]\", source: \"Halicarnassus\" }\r\n545.5 \"Spellblade Blizzard/Fire/Thunder\" Ability { id: \"22E[CDE]\", source: \"Halicarnassus\" }\r\n555.6 \"Dimensional Wave\" Ability { id: \"22F6\", source: \"Halicarnassus\" }\r\n561.7 \"Critical Hit\" Ability { id: \"22EB\", source: \"Halicarnassus\" } window 30,15\r\n567.0 \"--teleport--\" Ability { id: \"2305\", source: \"Halicarnassus\" }\r\n573.3 \"The Queen's Waltz (Random)\" Ability { id: \"230[68AE]\", source: \"Halicarnassus\" }\r\n582.6 \"Spellblade Holy\" Ability { id: \"22EF\", source: \"Halicarnassus\" }\r\n588.6 \"Pole Shift\" # Ability { id: \"22F[23]\", source: \"Halicarnassus\" }\r\n591.6 \"Holy Blur/Holy Edge\" Ability { id: \"22F[01]\", source: \"Halicarnassus\" }\r\n598.8 \"Critical Hit\" Ability { id: \"22EB\", source: \"Halicarnassus\" }\r\n608.0 \"Mindjack\" Ability { id: \"22FA\", source: \"Halicarnassus\" }\r\n613.2 \"Place Dark Token (Soul Reapers)\" Ability { id: \"22FC\", source: \"Halicarnassus\" }\r\n626.7 \"Cross Reaper/Gusting Gouge\" Ability { id: \"22F[DF]\", source: \"Soul Reaper\" }\r\n628.5 \"--teleport--\" Ability { id: \"2305\", source: \"Halicarnassus\" }\r\n635.2 \"The Queen's Waltz (Random)\" Ability { id: \"230[68AE]\", source: \"Halicarnassus\" }\r\n648.4 \"Dimensional Wave\" Ability { id: \"22F6\", source: \"Halicarnassus\" } window 30,15\r\n656.5 \"Haste\" Ability { id: \"22F4\", source: \"Halicarnassus\" }\r\n660.1 \"Spellblade Blizzard/Fire/Thunder 1\" Ability { id: \"22E[CDE]\", source: \"Halicarnassus\" }\r\n665.0 \"Spellblade Blizzard/Fire/Thunder 2\" Ability { id: \"22E[CDE]\", source: \"Halicarnassus\" }\r\n671.1 \"Dimensional Wave\" Ability { id: \"22F6\", source: \"Halicarnassus\" }\r\n681.2 \"The Playing Field\" Ability { id: \"2300\", source: \"Halicarnassus\" }\r\n688.3 \"The Game (Enrage)\" Ability { id: \"2301\", source: \"Halicarnassus\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o4n.ts



// O4N - Deltascape 4.0 Normal
const o4n_triggerSet = {
  id: 'DeltascapeV40',
  zoneId: zone_id/* default.DeltascapeV40 */.Z.DeltascapeV40,
  timelineFile: 'o4n.txt',
  triggers: [{
    id: 'O4N Doom',
    type: 'StartsUsing',
    netRegex: {
      id: '24B7',
      source: 'Exdeath',
      capture: false
    },
    condition: data => data.CanCleanse(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse Doom soon',
        de: 'Reinige Verhängnis bald',
        fr: 'Guérison du Glas bientôt',
        ja: '死の宣告にエスナ',
        cn: '驱散死宣',
        ko: '죽음의 선고 해제하기'
      }
    }
  }, {
    id: 'O4N Standard Thunder',
    type: 'StartsUsing',
    netRegex: {
      id: '24BD',
      source: 'Exdeath'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'O4N Standard Fire',
    type: 'StartsUsing',
    netRegex: {
      id: '24BA',
      source: 'Exdeath',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'O4N Empowered Blizzard',
    type: 'StartsUsing',
    netRegex: {
      id: '24C0',
      source: 'Exdeath',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move around',
        de: 'Bewegen',
        fr: 'Bougez',
        ja: '動き続ける',
        cn: '不停移动',
        ko: '움직이기'
      }
    }
  }, {
    id: 'O4N Empowered Fire',
    type: 'StartsUsing',
    netRegex: {
      id: '24BF',
      source: 'Exdeath',
      capture: false
    },
    response: responses/* Responses.stopEverything */.n3.stopEverything()
  }, {
    id: 'O4N Empowered Thunder',
    type: 'StartsUsing',
    netRegex: {
      id: '24C1',
      source: 'Exdeath',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'O4N Decisive Battle ',
    type: 'StartsUsing',
    netRegex: {
      id: '2408',
      source: 'Exdeath',
      capture: false
    },
    condition: data => {
      // Without a condition, this notifies on the first one, where it's meaningless.
      data.battleCount = (data.battleCount ?? 0) + 1;
      return data.battleCount > 1;
    },
    delaySeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in the gap',
        de: 'In der Lücke stehen',
        fr: 'Placez-vous à l\'écart',
        ja: '狭間に',
        cn: '远离中间位置',
        ko: '빈틈에 서기'
      }
    }
  }, {
    id: 'O4N Zombie Breath',
    type: 'StartsUsing',
    netRegex: {
      id: '240A',
      source: 'Exdeath',
      capture: false
    },
    delaySeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Behind head--Avoid zombie breath',
        de: 'Hinter den Kopf - Vermeide den Zombie-Atem',
        fr: 'Derrière la tête - Évitez l\'haleine zombie',
        ja: '頭の後ろに - ゾンビブレス来るぞ',
        cn: '站头后方',
        ko: '머리 뒤로 - 좀비 숨결 피하기'
      }
    }
  }, {
    id: 'O4N Black Hole',
    type: 'StartsUsing',
    netRegex: {
      id: '24C8',
      source: 'Exdeath',
      target: 'Exdeath',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid black holes',
        de: 'Weiche den Schwarzen Löchern aus',
        fr: 'Évitez les trous noirs',
        ja: 'ブラックホールから離れる',
        cn: '远离黑洞',
        ko: '블랙홀 피하기'
      }
    }
  }, {
    id: 'O4N Vacuum Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '24B8',
      source: 'Exdeath',
      target: 'Exdeath',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'O4N Flare',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Flare on YOU',
        de: 'Flare auf DIR',
        fr: 'Brasier sur VOUS',
        ja: '自分にフレア',
        cn: '核爆点名',
        ko: '플레어 대상자'
      }
    }
  }, {
    id: 'O4N Holy',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'O4N Meteor',
    type: 'StartsUsing',
    netRegex: {
      id: '24C6',
      source: 'Exdeath',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Deathly Vine': 'Seelenbaumranke',
      'Exdeath': 'Exdeath'
    },
    'replaceText': {
      '\\(Buster\\)': '(Tankbuster)',
      'Black Hole': 'Schwarzes Loch',
      'Blizzard/Fire III': 'Eisga/Feuga',
      'Clearout': 'Kreisfeger',
      'Collision': 'Aufprall',
      'Doom': 'Verhängnis',
      'Flare': 'Flare',
      'Holy': 'Sanctus',
      'Mega Blizzard/Fire/Thunder': 'Eisga/Feuga/Blitzga ++',
      'Meteor': 'Meteor',
      'The Decisive Battle': 'Entscheidungsschlacht',
      '(?<!/)Thunder III': 'Blitzga',
      'Vacuum Wave': 'Vakuumwelle',
      'Zombie Breath': 'Zombie-Atem'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Deathly Vine': 'Lierre mortuaire',
      'Exdeath': 'Exdeath'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(Buster\\)': '(Tank buster)',
      'Black Hole': 'Trou noir',
      'Blizzard/Fire III': 'Méga Glace/Feu',
      'Clearout': 'Fauchage',
      'Collision': 'Impact',
      'Doom': 'Glas',
      'Flare': 'Brasier',
      'Holy': 'Miracle',
      'Mega Blizzard/Fire/Thunder': 'Extra Glace/Feu/Foudre',
      'Meteor': 'Météore',
      'The Decisive Battle': 'Combat décisif',
      '(?<!/)Thunder III': 'Méga Foudre',
      'Vacuum Wave': 'Vague de vide',
      'Zombie Breath': 'Haleine zombie'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Deathly Vine': '霊樹の蔦',
      'Exdeath': 'エクスデス'
    },
    'replaceText': {
      'Black Hole': 'ブラックホール',
      'Blizzard/Fire III': 'ブリザガ/ファイガ',
      'Clearout': 'なぎ払い',
      'Collision': '衝撃',
      'Doom': '死の宣告',
      'Flare': 'フレア',
      'Holy': 'ホーリー',
      'Mega Blizzard/Fire/Thunder': 'ブリザガ/ファイガ/サンダガ ++',
      'Meteor': 'メテオ',
      'The Decisive Battle': '決戦',
      '(?<!/)Thunder III': 'サンダガ',
      'Vacuum Wave': '真空波',
      'Zombie Breath': 'ゾンビブレス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Deathly Vine': '灵树藤',
      'Exdeath': '艾克斯迪司'
    },
    'replaceText': {
      'Black Hole': '黑洞',
      'Blizzard/Fire III': '冰封/爆炎',
      'Clearout': '横扫',
      'Collision': '冲击',
      'Doom': '死亡宣告',
      'Flare': '核爆',
      'Holy': '神圣',
      'Mega Blizzard/Fire/Thunder': '冰封/爆炎/暴雷 ++',
      'Meteor': '陨石',
      'The Decisive Battle': '决战',
      '(?<!/)Thunder III': '暴雷',
      'Vacuum Wave': '真空波',
      'Zombie Breath': '死亡吐息'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Deathly Vine': '영목 덩굴',
      'Exdeath': '엑스데스'
    },
    'replaceText': {
      'Black Hole': '블랙홀',
      'Blizzard/Fire III': '블리자가/파이가',
      'Clearout': '휩쓸기',
      'Collision': '충격',
      'Doom': '죽음의 선고',
      'Flare': '플레어',
      'Holy': '홀리',
      'Mega Blizzard/Fire/Thunder': '블리자가/파이가/선더가 ++',
      'Meteor': '메테오',
      'The Decisive Battle': '결전',
      '(?<!/)Thunder III': '선더가',
      'Vacuum Wave': '진공파',
      'Zombie Breath': '좀비 숨결'
    }
  }]
};
/* harmony default export */ const o4n = (o4n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o4n.txt
const raid_o4n_namespaceObject = "# DELTASCAPE V4.0--O4N\r\n# EXDEATH\r\n\r\n# Enrage appears to be 25 minutes. No way to accurately warn about it\r\n# as the second phase is HP-dependent.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# -ii 24BA 24BC 24BE 24C3 24C5\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n9.5 \"Doom\" Ability { id: \"24B7\", source: \"Exdeath\" } window 9.5,5\r\n19.1 \"Blizzard/Fire III\" Ability { id: \"24B[9B]\", source: \"Exdeath\" }\r\n28.8 \"Thunder III (Buster)\" Ability { id: \"24BD\", source: \"Exdeath\" }\r\n37.4 \"Blizzard/Fire III\" Ability { id: \"24B[9B]\", source: \"Exdeath\" }\r\n50.3 \"Mega Blizzard/Fire/Thunder\" Ability { id: \"24(BF|C[01])\", source: \"Exdeath\" }\r\n63.6 \"Mega Blizzard/Fire/Thunder\" Ability { id: \"24(BF|C[01])\", source: \"Exdeath\" }\r\n74.8 \"Mega Blizzard/Fire/Thunder\" Ability { id: \"24(BF|C[01])\", source: \"Exdeath\" }\r\n87.0 \"Mega Blizzard/Fire/Thunder\" Ability { id: \"24(BF|C[01])\", source: \"Exdeath\" }\r\n92.6 \"Blizzard/Fire III\" Ability { id: \"24B[9B]\", source: \"Exdeath\" }\r\n103.2 \"Thunder III (Buster)\" Ability { id: \"24BD\", source: \"Exdeath\" }\r\n\r\n113.3 \"Vacuum Wave\" Ability { id: \"24B8\", source: \"Exdeath\" } window 40,30\r\n121.5 \"Holy\" Ability { id: \"24C4\", source: \"Exdeath\" }\r\n132.8 \"Mega Blizzard/Fire/Thunder\" Ability { id: \"24(BF|C[01])\", source: \"Exdeath\" }\r\n138.4 \"Blizzard/Fire III\" Ability { id: \"24B[9B]\", source: \"Exdeath\" }\r\n149.1 \"Thunder III (Buster)\" Ability { id: \"24BD\", source: \"Exdeath\" }\r\n\r\n159.2 \"Vacuum Wave\" Ability { id: \"24B8\", source: \"Exdeath\" } window 20,20\r\n167.4 \"Holy\" Ability { id: \"24C4\", source: \"Exdeath\" }\r\n178.7 \"Mega Blizzard/Fire/Thunder\" Ability { id: \"24(BF|C[01])\", source: \"Exdeath\" }\r\n184.3 \"Blizzard/Fire III\" Ability { id: \"24B[9B]\", source: \"Exdeath\" }\r\n195.0 \"Thunder III (Buster)\" Ability { id: \"24BD\", source: \"Exdeath\" } jump 149.1\r\n\r\n205.1 \"Vacuum Wave\"\r\n213.3 \"Holy\"\r\n224.6 \"Mega Blizzard/Fire/Thunder\"\r\n230.2 \"Blizzard/Fire III\"\r\n\r\n# Phase change appears to be 65% HP.\r\n# This first section is not quite the same as the main rotation.\r\n300.0 \"The Decisive Battle\" Ability { id: \"2408\", source: \"Exdeath\" } window 300,5\r\n301.4 \"--untargetable--\"\r\n305.9 \"--sync--\" Ability { id: \"240A\", source: \"Exdeath\" }\r\n307.0 \"Collision\" Ability { id: \"24CA\", source: \"Exdeath\" }\r\n312.0 \"Zombie Breath\" Ability { id: \"24CB\", source: \"Exdeath\" }\r\n317.0 \"--targetable--\"\r\n322.4 \"Holy\" Ability { id: \"24C4\", source: \"Exdeath\" } window 20,20\r\n329.5 \"Flare\" Ability { id: \"24C2\", source: \"Exdeath\" }\r\n338.6 \"Meteor\" Ability { id: \"24C6\", source: \"Exdeath\" }\r\n353.8 \"Black Hole\" Ability { id: \"24C8\", source: \"Exdeath\" } window 30,30\r\n365.1 \"Mega Blizzard/Fire/Thunder\" Ability { id: \"24(BF|C[01])\", source: \"Exdeath\" }\r\n\r\n# This section has choices.\r\n370.7 \"Blizzard/Fire III?\" Ability { id: \"24B[9B]\", source: \"Exdeath\" }\r\n372.2 \"Holy?\" Ability { id: \"24C4\", source: \"Exdeath\" }\r\n386.3 \"Meteor\" Ability { id: \"24C6\", source: \"Exdeath\" }\r\n396.4 \"Thunder III (Buster)\" Ability { id: \"24BD\", source: \"Exdeath\" } window 30,30\r\n410.7 \"Black Hole\" Ability { id: \"24C8\", source: \"Exdeath\" }\r\n421.0 \"Mega Blizzard/Fire/Thunder\" Ability { id: \"24(BF|C[01])\", source: \"Exdeath\" }\r\n427.1 \"Flare?\" Ability { id: \"24C2\", source: \"Exdeath\" }\r\n427.1 \"Vacuum Wave?\" Ability { id: \"24B8\", source: \"Exdeath\" }\r\n442.3 \"Meteor\" Ability { id: \"24C6\", source: \"Exdeath\" } window 30,30\r\n452.4 \"Thunder III (Buster)\" Ability { id: \"24BD\", source: \"Exdeath\" }\r\n\r\n# Actual rotation block begins. Consistent first half...\r\n466.8 \"The Decisive Battle\" Ability { id: \"2408\", source: \"Exdeath\" } window 30,30\r\n468.2 \"--untargetable--\"\r\n472.6 \"--sync--\" Ability { id: \"240A\", source: \"Exdeath\" }\r\n473.7 \"Collision\" Ability { id: \"24CA\", source: \"Exdeath\" }\r\n475.1 \"Clearout\" Ability { id: \"24CC\", source: \"Deathly Vine\" }\r\n478.8 \"Zombie Breath\" Ability { id: \"24CB\", source: \"Exdeath\" }\r\n483.8 \"--targetable--\"\r\n488.3 \"Vacuum Wave\" Ability { id: \"24B8\", source: \"Exdeath\" }\r\n496.5 \"Holy\" Ability { id: \"24C4\", source: \"Exdeath\" } window 30,30\r\n503.6 \"Flare\" Ability { id: \"24C2\", source: \"Exdeath\" }\r\n512.7 \"Meteor\" Ability { id: \"24C6\", source: \"Exdeath\" }\r\n528.0 \"Black Hole\" Ability { id: \"24C8\", source: \"Exdeath\" }\r\n538.2 \"Mega Blizzard/Fire/Thunder\" Ability { id: \"24(BF|C[01])\", source: \"Exdeath\" }\r\n\r\n# Leading into choices in the second half.\r\n543.8 \"Blizzard/Fire III?\" Ability { id: \"24B[9B]\", source: \"Exdeath\" }\r\n545.3 \"Holy?\" Ability { id: \"24C4\", source: \"Exdeath\" }\r\n557.5 \"Meteor\" Ability { id: \"24C6\", source: \"Exdeath\" }\r\n567.7 \"Thunder III (Buster)\" Ability { id: \"24BD\", source: \"Exdeath\" } window 30,30\r\n582.0 \"Black Hole\" Ability { id: \"24C8\", source: \"Exdeath\" }\r\n592.3 \"Mega Blizzard/Fire/Thunder\" Ability { id: \"24(BF|C[01])\", source: \"Exdeath\" }\r\n599.4 \"Flare?\" Ability { id: \"24C2\", source: \"Exdeath\" }\r\n599.4 \"Vacuum Wave?\" Ability { id: \"24B8\", source: \"Exdeath\" }\r\n613.5 \"Meteor\" Ability { id: \"24C6\", source: \"Exdeath\" } window 30,30\r\n623.7 \"Thunder III (Buster)\" Ability { id: \"24BD\", source: \"Exdeath\" }\r\n\r\n637.9 \"The Decisive Battle\" Ability { id: \"2408\", source: \"Exdeath\" } jump 466.8\r\n639.3 \"--untargetable--\"\r\n644.8 \"Collision\"\r\n646.2 \"Clearout\"\r\n649.9 \"Zombie Breath\"\r\n659.4 \"Vacuum Wave\"\r\n667.6 \"Holy\"\r\n674.7 \"Flare\"\r\n\r\n\r\n# Enrage. Exdeath is untargetable at this point.\r\n# \"Nothingness is my weapon, and nothingness alone can strike me down!\"\r\n1000.0 \"--sync--\" StartsUsing { id: \"24C7\", source: \"Exdeath\" } window 1000,0\r\n1005.0 \"Meteor Enrage\" Ability { id: \"24C7\", source: \"Exdeath\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o4s.ts




const shouldDieOnLaser = data => {
  if (!data.beyondDeath) return false;
  // Beyond death doesn't update for laser #2 if you died on
  // laser #1, so don't tell anybody to die on laser #2.
  // If you still have beyond death, it'll remind you for #3.
  if (data.omegaLaserCount === 2 && data.omegaProbablyDiedOnLaser) return false;
  if (data.phase !== 'omega') return true;
  if (data.dieOnLaser === undefined || data.omegaLaserCount === undefined) return false;
  return data.omegaLaserCount >= data.dieOnLaser;
};

// O4S - Deltascape 4.0 Savage
const o4s_triggerSet = {
  id: 'DeltascapeV40Savage',
  zoneId: zone_id/* default.DeltascapeV40Savage */.Z.DeltascapeV40Savage,
  timelineFile: 'o4s.txt',
  timelineTriggers: [{
    id: 'O4S Neo Vacuum Wave',
    regex: /Vacuum Wave/,
    beforeSeconds: 8,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Vacuum Wave soon',
        de: 'Vakuumwelle bald',
        fr: 'Vague de vide bientôt',
        ja: 'まもなく真空波',
        cn: '马上真空波',
        ko: '곧 진공파'
      }
    }
  }],
  triggers: [
  // Part 1
  {
    // Phase Tracker: Thunder III not after Dualcast.
    id: 'O4S Exdeath Thunder III Counter',
    type: 'StartsUsing',
    netRegex: {
      id: '23F9',
      source: 'Exdeath',
      capture: false
    },
    run: data => {
      data.thunderCount = (data.thunderCount ?? 0) + 1;
    }
  }, {
    // Fire III + Dualcast.
    id: 'O4S Exdeath Fire III Counter',
    type: 'StartsUsing',
    netRegex: {
      id: '23F5',
      source: 'Exdeath',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fire III',
        de: 'Feuga',
        fr: 'Méga Feu',
        ja: 'ファイガ',
        cn: '静止',
        ko: '파이가'
      }
    }
  }, {
    // Blizzard III + Dualcast.
    id: 'O4S Exdeath Blizzard III',
    type: 'StartsUsing',
    netRegex: {
      id: '23F7',
      source: 'Exdeath',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Blizzard III',
        de: 'Eisga',
        fr: 'Méga Glace',
        ja: 'ブリザガ',
        cn: '蛇皮走位',
        ko: '블리자가'
      }
    }
  }, {
    // Thunder III + Dualcast.
    id: 'O4S Exdeath Thunder III',
    type: 'StartsUsing',
    netRegex: {
      id: '23F9',
      source: 'Exdeath',
      capture: false
    },
    alertText: (data, _matches, output) => {
      // Tanks/healers always get an alert.
      if (data.role === 'tank' || data.role === 'healer') return output.thunderBuster();
    },
    infoText: (data, _matches, output) => {
      // Tanks/healers always get an alert.
      if (data.role === 'tank' || data.role === 'healer') return false;
      return output.thunder();
    },
    tts: (data, _matches, output) => {
      if (data.role === 'tank' || data.role === 'healer') return output.thunderTTS();
    },
    outputStrings: {
      thunderBuster: {
        en: 'Thunder III: Tank buster',
        de: 'Blitzga: Tank buster',
        fr: 'Méga Foudre : Tank buster',
        ja: 'サンダガ: タンクバスター',
        cn: '雷三：坦克死刑',
        ko: '선더가: 탱버'
      },
      thunder: {
        en: 'Thunder III',
        de: 'Blitzga',
        fr: 'Méga Foudre',
        ja: 'サンダガ',
        cn: '雷三',
        ko: '선더가'
      },
      thunderTTS: {
        en: 'thunder',
        de: 'blitzga',
        fr: 'foudre',
        ja: '離れる',
        cn: '远离',
        ko: '선더가'
      }
    }
  }, {
    // Fire III after Dualcast.
    id: 'O4S Exdeath Ultimate Fire III',
    type: 'StartsUsing',
    netRegex: {
      id: '23FB',
      source: 'Exdeath',
      capture: false
    },
    response: responses/* Responses.stopMoving */.n3.stopMoving()
  }, {
    // Blizzard III after Dualcast.
    id: 'O4S Exdeath Ultimate Blizzard III',
    type: 'StartsUsing',
    netRegex: {
      id: '23FC',
      source: 'Exdeath',
      capture: false
    },
    response: responses/* Responses.moveAround */.n3.moveAround()
  }, {
    // Thunder III after Dualcast.
    id: 'O4S Exdeath Ultimate Thunder III',
    type: 'StartsUsing',
    netRegex: {
      id: '23FD',
      source: 'Exdeath',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    // Flare
    id: 'O4S Exdeath Flare',
    type: 'StartsUsing',
    netRegex: {
      id: '2401',
      source: 'Exdeath'
    },
    condition: (data, matches) => {
      data.flareTargets ??= [];
      data.flareTargets.push(matches.target);
      return data.flareTargets.length === 3;
    },
    alarmText: (data, _matches, output) => {
      if (data.flareTargets?.includes(data.me)) return output.text();
    },
    run: data => delete data.flareTargets,
    outputStrings: {
      text: {
        en: 'Flare on you',
        de: 'Flare auf dir',
        fr: 'Brasier sur vous',
        ja: '自分にフレア',
        cn: '核爆点名',
        ko: '플레어 대상자'
      }
    }
  },
  // Part 2
  {
    id: 'O4S Neo Grand Cross Alpha Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: '242B',
      source: 'Neo Exdeath',
      capture: false
    },
    run: data => {
      data.phase = 'alpha';
      data.alphaCount = (data.alphaCount ?? 0) + 1;

      // TODO: should have options for this.
      data.dieOnLaser = 1;
    }
  }, {
    id: 'O4S Neo Grand Cross Delta Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: '242C',
      source: 'Neo Exdeath',
      capture: false
    },
    run: data => {
      data.phase = 'delta';
      delete data.waterHealer;
    }
  }, {
    id: 'O4S Neo Grand Cross Omega Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: '242D',
      source: 'Neo Exdeath',
      capture: false
    },
    run: data => {
      data.phase = 'omega';
      delete data.waterHealer;
      data.omegaLaserCount = 1;
    }
  }, {
    id: 'O4S Neo Neverwhere Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: '2426',
      source: 'Neo Exdeath',
      capture: false
    },
    run: data => data.finalphase = true
  }, {
    id: 'O4S Neo White Wound Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '564'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.whiteWound = true
  }, {
    id: 'O4S Neo White Wound Lost',
    type: 'LosesEffect',
    netRegex: {
      effectId: '564'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.whiteWound = false
  }, {
    id: 'O4S Neo Black Wound Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '565'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.blackWound = true
  }, {
    id: 'O4S Neo Black Wound Lost',
    type: 'LosesEffect',
    netRegex: {
      effectId: '565'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.blackWound = false
  }, {
    id: 'O4S Neo Beyond Death Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '566'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.beyondDeath = true
  }, {
    id: 'O4S Neo Beyond Death Lost',
    type: 'LosesEffect',
    netRegex: {
      effectId: '566'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.beyondDeath = false
  }, {
    id: 'O4S Neo Allagan Field Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '1C6'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.allaganField = true
  }, {
    id: 'O4S Neo Allagan Field Lost',
    type: 'LosesEffect',
    netRegex: {
      effectId: '1C6'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.allaganField = false
  }, {
    id: 'O4S Neo Flood of Naught: Inside',
    type: 'StartsUsing',
    netRegex: {
      id: '240E',
      source: 'Neo Exdeath',
      capture: false
    },
    durationSeconds: 6,
    alarmText: (data, _matches, output) => {
      if (shouldDieOnLaser(data)) return output.dieOnInside();
    },
    alertText: (data, _matches, output) => {
      if (!shouldDieOnLaser(data)) return output.goOutside();
    },
    tts: (data, _matches, output) => {
      if (shouldDieOnLaser(data)) return output.dieInInIn();
      return output.outOutOut();
    },
    outputStrings: {
      goOutside: {
        en: 'Go Outside',
        de: 'Nach Außen',
        fr: 'Allez à l\'extérieur',
        ja: '外に出る',
        cn: '去外面',
        ko: '바깥으로'
      },
      dieOnInside: {
        en: 'Die on Inside',
        de: 'Innen sterben',
        fr: 'Mourrez à l\'intérieur',
        ja: '中で死ぬ',
        cn: '在里面死亡',
        ko: '안쪽 레이저 맞기'
      },
      dieInInIn: {
        en: 'die in in in',
        de: 'sterben rein rein rein',
        fr: 'Mourrez à l\'intérieur !',
        ja: '死になさい！',
        cn: '死亡',
        ko: '안쪽 레이저 맞기'
      },
      outOutOut: {
        en: 'out out out',
        de: 'raus raus raus',
        fr: 'Extérieur !',
        ja: '出て出て！',
        cn: '出去出去',
        ko: '바깥으로'
      }
    }
  }, {
    id: 'O4S Neo Flood of Naught: Outside',
    type: 'StartsUsing',
    netRegex: {
      id: '240F',
      source: 'Neo Exdeath',
      capture: false
    },
    durationSeconds: 6,
    alarmText: (data, _matches, output) => {
      if (shouldDieOnLaser(data)) return output.dieOnOutside();
    },
    alertText: (data, _matches, output) => {
      if (!shouldDieOnLaser(data)) return output.goInside();
    },
    tts: (data, _matches, output) => {
      if (shouldDieOnLaser(data)) return output.dieOutOutOut();
      return output.inInIn();
    },
    outputStrings: {
      goInside: {
        en: 'Go Inside',
        de: 'Rein gehen',
        fr: 'Allez à l\'intérieur',
        ja: '中に入る',
        cn: '去里面',
        ko: '안으로'
      },
      dieOnOutside: {
        en: 'Die on Outside',
        de: 'Außen sterben',
        fr: 'Mourrez à l\'extérieur',
        ja: '外で死ぬ',
        cn: '在外面死亡',
        ko: '바깥 레이저 맞기'
      },
      dieOutOutOut: {
        en: 'die out out out',
        de: 'sterben raus raus raus',
        fr: 'Mourrez à l\'extérieur !',
        ja: '死になさい！',
        cn: '在外面死亡',
        ko: '바깥 레이저 맞기'
      },
      inInIn: {
        en: 'in in in',
        de: 'rein rein rein',
        fr: 'Intérieur !',
        ja: '入れ入れ',
        cn: '进去进去',
        ko: '안으로'
      }
    }
  }, {
    id: 'O4S Neo Flood of Naught: Colors Purple Blue',
    type: 'StartsUsing',
    netRegex: {
      id: '2411',
      source: 'Neo Exdeath',
      capture: false
    },
    durationSeconds: 6,
    alarmText: (data, _matches, output) => {
      if (!shouldDieOnLaser(data)) return;
      if (data.blackWound) return output.dieOnRightBlue();else if (data.whiteWound) return output.dieOnLeftPurple();
      return output.dieOnColorSides();
    },
    alertText: (data, _matches, output) => {
      if (shouldDieOnLaser(data)) return;
      if (data.blackWound) return output.leftOnPurple();else if (data.whiteWound) return output.rightOnBlue();
      return output.colorSides();
    },
    tts: (_data, _matches, output) => output.colors(),
    outputStrings: {
      leftOnPurple: {
        en: 'Left On Purple',
        de: 'Links auf Pink',
        fr: 'À gauche sur le violet',
        ja: '左の紫色に',
        cn: '左边紫色',
        ko: '왼쪽 보라'
      },
      rightOnBlue: {
        en: 'Right On Blue',
        de: 'Rechts auf Blau',
        fr: 'À droite sur le bleu',
        ja: '右の青色に',
        cn: '右边蓝色',
        ko: '오른쪽 파랑'
      },
      colorSides: {
        en: 'Color sides',
        de: 'Farbige Seiten',
        fr: 'Côtés de couleur',
        ja: '同じ色に',
        cn: '颜色一侧',
        ko: '색깔 맞기'
      },
      dieOnRightBlue: {
        en: 'Die On Right Blue',
        de: 'In Blauem rechts sterben',
        fr: 'Mourrez à droite sur le bleu',
        ja: '右の青色で死ぬ',
        cn: '在右边蓝色死亡',
        ko: '오른쪽 파랑 맞기'
      },
      dieOnLeftPurple: {
        en: 'Die On Left Purple',
        de: 'In Pinkem links sterben',
        fr: 'Mourrez à gauche sur le violet',
        ja: '左の紫色で死ぬ',
        cn: '在左边紫色死亡',
        ko: '왼쪽 보라 맞기'
      },
      dieOnColorSides: {
        en: 'Die on color sides',
        de: 'Auf Farben sterben',
        fr: 'Mourrez sur les côtés de couleur',
        ja: '同じ色で死ぬ',
        cn: '在同色一边死亡',
        ko: '색깔 맞기'
      },
      colors: {
        en: 'colors',
        de: 'Farben',
        fr: 'Couleurs',
        ja: '色',
        cn: '看颜色',
        ko: '색깔'
      }
    }
  }, {
    id: 'O4S Neo Flood of Naught: Colors Blue Purple',
    type: 'StartsUsing',
    netRegex: {
      id: '2412',
      source: 'Neo Exdeath',
      capture: false
    },
    durationSeconds: 6,
    alarmText: (data, _matches, output) => {
      if (!shouldDieOnLaser(data)) return;
      if (data.blackWound) return output.dieOnLeftBlue();else if (data.whiteWound) return output.dieOnRightPurple();
      return output.dieOnColorSides();
    },
    alertText: (data, _matches, output) => {
      if (shouldDieOnLaser(data)) return;
      if (data.blackWound) return output.beRightOnPurple();else if (data.whiteWound) return output.beLeftOnBlue();
      return output.colorSides();
    },
    tts: (_data, _matches, output) => output.colors(),
    outputStrings: {
      beRightOnPurple: {
        en: 'Be Right On Purple',
        de: 'Rechts auf Pink',
        fr: 'Placez-vous à droite sur le violet',
        ja: '右の紫色に',
        cn: '去右边紫色',
        ko: '오른쪽 보라 맞기'
      },
      beLeftOnBlue: {
        en: 'Be Left On Blue',
        de: 'Links auf Blau',
        fr: 'Placez-vous à gauche sur le bleu',
        ja: '左の青色に',
        cn: '去左边蓝色',
        ko: '왼쪽 파랑 맞기'
      },
      colorSides: {
        en: 'Color sides',
        de: 'Farbige Seiten',
        fr: 'Côtés de couleur',
        ja: '同じ色に',
        cn: '颜色一侧',
        ko: '색깔 방향'
      },
      dieOnLeftBlue: {
        en: 'Die On Left Blue',
        de: 'Auf Blauem links sterben',
        fr: 'Mourrez à gauche sur le bleu',
        ja: '左の青色で死ぬ',
        cn: '在左边蓝色死亡',
        ko: '왼쪽 파랑 맞기'
      },
      dieOnRightPurple: {
        en: 'Die On Right Purple',
        de: 'Auf Pinkem rechts sterben',
        fr: 'Mourrez à droite sur le violet',
        ja: '右の紫色で死ぬ',
        cn: '在右边紫色死亡',
        ko: '오른쪽 보라 맞기'
      },
      dieOnColorSides: {
        en: 'Die on color sides',
        de: 'Auf Farben sterben',
        fr: 'Mourrez sur les côtés de couleur',
        ja: '同じ色で死ぬ',
        cn: '在同色一边死亡',
        ko: '색깔 맞기'
      },
      colors: {
        en: 'colors',
        de: 'farben',
        fr: 'Couleurs',
        ja: '色',
        cn: '颜色',
        ko: '색깔'
      }
    }
  }, {
    id: 'O4S Neo Laser Counter',
    type: 'StartsUsing',
    netRegex: {
      id: ['240E', '240F', '2411', '2412'],
      source: 'Neo Exdeath',
      capture: false
    },
    run: data => {
      if (data.phase !== 'omega') return;

      // See comments in shouldDieOnLaser.  Beyond Death
      // doesn't get removed until after the 2nd laser
      // appears.  However, colors (THANKFULLY) apply
      // before the next laser appears.
      if (shouldDieOnLaser(data)) data.omegaProbablyDiedOnLaser = true;
      data.omegaLaserCount = (data.omegaLaserCount ?? 1) + 1;
    }
  }, {
    id: 'O4S Neo Flood of Naught: Charge',
    type: 'StartsUsing',
    netRegex: {
      id: '2416',
      source: 'Neo Exdeath',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.allaganField) {
        if (data.role === 'tank') return output.chargeBeBehindOtherTank();
        return output.chargeBeInTheVeryBack();
      }
      if (data.role === 'tank') return output.chargeBeInFront();
      return output.chargeBeBehindTanks();
    },
    tts: (_data, _matches, output) => output.charge(),
    outputStrings: {
      chargeBeBehindOtherTank: {
        en: 'Charge: be behind other tank',
        de: 'Aufladung: hinter anderen Tank',
        fr: 'Charge : Placez-vous derrière l\'autre tank',
        ja: '突進: 他のタンクの後ろに',
        cn: '站在另一个坦克后面',
        ko: '탱커 뒤에 있기'
      },
      chargeBeInTheVeryBack: {
        en: 'Charge: be in the very back',
        de: 'Aufladung: Ganz nach hinten',
        fr: 'Charge : Placez-vous tout au fond',
        ja: '突進: 後ろの遠くへ',
        cn: '去后面',
        ko: '가장 뒤에 있기'
      },
      chargeBeInFront: {
        en: 'Charge: be in front!',
        de: 'Aufladung: Ganz nach vorn',
        fr: 'Charge : Placez-vous devant !',
        ja: '突進: 前方に',
        cn: '去前面',
        ko: '앞쪽으로'
      },
      chargeBeBehindTanks: {
        en: 'Charge: be behind tanks',
        de: 'Aufladung: Hinter die Tanks',
        fr: 'Charge : Placez-vous derrière les tanks',
        ja: '突進: タンクの後ろに',
        cn: '站在坦克后面',
        ko: '탱커 뒤로'
      },
      charge: {
        en: 'charge',
        de: 'aufladung',
        fr: 'Charge',
        ja: '無の氾濫',
        cn: '充能',
        ko: '무의 범람'
      }
    }
  }, {
    id: 'O4S Neo Double Attack',
    type: 'StartsUsing',
    netRegex: {
      id: '241C',
      source: 'Neo Exdeath',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.role === 'tank') return output.doubleAttack();
      return output.doubleAttackGetOut();
    },
    tts: (_data, _matches, output) => output.doubleAttack(),
    outputStrings: {
      doubleAttack: {
        en: 'Double Attack',
        de: 'Doppelangriff',
        fr: 'Double attaque',
        ja: 'ダブルアタック',
        cn: '双重攻击',
        ko: '이중 공격'
      },
      doubleAttackGetOut: {
        en: 'Double Attack: Get out',
        de: 'Doppelangriff: Raus da',
        fr: 'Double attaque : À l\'extérieur',
        ja: 'ダブルアタック: 外へ',
        cn: '双重攻击：去外面',
        ko: '이중 공격: 밖으로'
      }
    }
  }, {
    // Grand Cross Alpha.
    id: 'O4S Neo Grand Cross Alpha',
    type: 'StartsUsing',
    netRegex: {
      id: '242B',
      source: 'Neo Exdeath',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    tts: (_data, _matches, output) => output.tts(),
    outputStrings: {
      text: {
        en: 'Grand Cross Alpha: Go to middle',
        de: 'Supernova Alpha: In die Mitte',
        fr: 'Croix suprême alpha : Allez au milieu',
        ja: 'グランドクロス・アルファ: 中央に',
        cn: '前往中间集合',
        ko: '그랜드크로스: 알파, 중앙으로'
      },
      tts: {
        en: 'go to middle',
        de: 'In die Mitte',
        fr: 'Allez au milieu',
        ja: '中央に',
        cn: '前往中间',
        ko: '중앙으로'
      }
    }
  }, {
    id: 'O4S Neo Grand Cross Delta',
    type: 'StartsUsing',
    netRegex: {
      id: '242C',
      source: 'Neo Exdeath',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.role === 'tank') return output.beInFront();
      if (data.role === 'healer') return output.beOnSides();
      return output.beInsideBoss();
    },
    tts: (data, _matches, output) => {
      if (data.role === 'tank') return output.beInFrontTTS();
      if (data.role === 'healer') return output.beOnSidesTTS();
      return output.beInsideBossTTS();
    },
    outputStrings: {
      beInFront: {
        en: 'Grand Cross Delta: Be in front of boss',
        de: 'Supernova Delta: Vor den Boss',
        fr: 'Croix suprême delta : Placez-vous devant le boss',
        ja: 'グランドクロス・デルタ: ボスの前に',
        cn: '站在boss前面',
        ko: '그랜드크로스: 델타, 보스 범위 끝으로'
      },
      beOnSides: {
        en: 'Grand Cross Delta: Be on sides of boss',
        de: 'Supernova Delta: An die Seiten vom Boss',
        fr: 'Croix suprême delta : Placez-vous sur les côtés du boss',
        ja: 'グランドクロス・デルタ: ボスの横に',
        cn: '站在boss后面',
        ko: '그랜드크로스: 델타, 보스 옆쪽으로'
      },
      beInsideBoss: {
        en: 'Grand Cross Delta: Inside boss',
        de: 'Supernvoa Delta: In den Boss',
        fr: 'Croix suprême delta : À l\'intérieur du boss',
        ja: 'グランドクロス・デルタ: ボスの真ん中に',
        cn: '站在boss中间',
        ko: '그랜드크로스: 델타, 보스 안쪽으로'
      },
      beInFrontTTS: {
        en: 'delta: be in front',
        de: 'delta: vor den boss',
        fr: 'delta : Placez-vous devant',
        ja: 'ボスの前に',
        cn: '去前面',
        ko: '델타, 보스 범위 끝으로'
      },
      beOnSidesTTS: {
        en: 'delta: be on sides',
        de: 'delta: an die seiten',
        fr: 'delta : Placez-vous sur les côtés',
        ja: 'ボスの横に',
        cn: '去两侧',
        ko: '델타, 보스 옆쪽으로'
      },
      beInsideBossTTS: {
        en: 'delta: be inside boss',
        de: 'delta: in den boss',
        fr: 'delta : À l\'intérieur du boss',
        ja: 'ボスの真ん中に',
        cn: '去boss中间',
        ko: '델타, 보스 안쪽으로'
      }
    }
  }, {
    id: 'O4S Neo Grand Cross Omega',
    type: 'StartsUsing',
    netRegex: {
      id: '242D',
      source: 'Neo Exdeath',
      capture: false
    },
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'O4S Neo Forked Lightning',
    type: 'GainsEffect',
    netRegex: {
      effectId: '24B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 1,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'O4S Neo Acceleration Bomb',
    type: 'GainsEffect',
    netRegex: {
      effectId: '568'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 4,
    // 4 second warning.
    alarmText: (data, _matches, output) => {
      if (data.phase === 'omega') return output.lookAwayAndStop();
      return output.stop();
    },
    outputStrings: {
      lookAwayAndStop: {
        en: 'look away and stop',
        de: 'wegschauen und stehenbleiben',
        fr: 'Regardez ailleurs et arrêtez',
        ja: '見ない、動かない',
        cn: '看外面并静止',
        ko: '바라보지 말고 멈추기'
      },
      stop: {
        en: 'stop',
        de: 'Stopp',
        fr: 'Arrêtez',
        ja: '動かない',
        cn: '静止',
        ko: '멈추기'
      }
    }
  }, {
    id: 'O4S Neo Acceleration Bomb Delta',
    type: 'GainsEffect',
    netRegex: {
      effectId: '568'
    },
    condition: (data, matches) => matches.target === data.me && data.phase === 'delta',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Acceleration Bomb',
        de: 'Beschleunigungsbombe',
        fr: 'Bombe à accélération',
        ja: '加速度爆弾',
        cn: '加速度炸弹',
        ko: '가속도 폭탄'
      }
    }
  }, {
    id: 'O4S Neo Omega Shriek',
    type: 'GainsEffect',
    netRegex: {
      effectId: '1C4'
    },
    condition: (data, matches) => matches.target === data.me && data.phase === 'omega',
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'shriek: get mid, look away',
        de: 'Schrei: Zur mitte und wegschauen',
        fr: 'Cri : Allez au milieu, regardez ailleurs',
        ja: '呪詛の叫声: 中へ、外を向け',
        cn: '石化点名',
        ko: '중앙으로, 바깥보기'
      }
    }
  }, {
    id: 'O4S Neo Water Tracker',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3FF'
    },
    run: (data, matches) => data.waterHealer = matches.target
  }, {
    // Water Me (Delta/Omega)
    id: 'O4S Neo Water Me',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3FF'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (data, _matches, output) => {
      // Not clear where to tell the healer where to go on delta
      // due to picking a side for uptime strat, or other strats.
      if (data.phase === 'delta') return output.waterOnYou();else if (data.phase === 'omega') return output.waterStackUnderNeo();
    },
    outputStrings: {
      waterOnYou: {
        en: 'water on you',
        de: 'wasser auf dir',
        fr: 'Eau sur vous',
        ja: '自分に水属性圧縮',
        cn: '水点名',
        ko: '물 대상자'
      },
      waterStackUnderNeo: {
        en: 'water: stack under neo',
        de: 'Wasser: Unter Neo stacken',
        fr: 'Eau : packez-vous sous Néo',
        ja: '水属性圧縮: ボスの下で頭割り',
        cn: '去下面',
        ko: '물: 보스 아래 모이기'
      }
    }
  }, {
    // Beyond Death Tank (Delta)
    id: 'O4S Neo Beyond Death Delta Tank',
    type: 'GainsEffect',
    netRegex: {
      effectId: '566'
    },
    condition: (data, matches) => data.phase === 'delta' && matches.target === data.me && data.role === 'tank',
    delaySeconds: 0.5,
    infoText: (data, _matches, output) => {
      // Something went awry, or maybe healers dead.  Just say stack on water anyway,
      // instead of trying to be smart when the healers die.
      if (data.waterHealer !== undefined) return output.stackOnWaterhealer({
        player: data.waterHealer
      });
      return output.stackOnWater();
    },
    outputStrings: {
      stackOnWaterhealer: outputs/* default.stackOnPlayer */.Z.stackOnPlayer,
      stackOnWater: {
        en: 'Stack on water',
        de: 'Bei Wasser stacken',
        fr: 'Packez-vous sur l\'eau',
        ja: '水持ちと頭割り',
        cn: '和水点名分摊',
        ko: '물 쉐어'
      }
    }
  }, {
    // Beyond Death (Delta)
    id: 'O4S Neo Beyond Death Delta Initial',
    type: 'GainsEffect',
    netRegex: {
      effectId: '566'
    },
    condition: (data, matches) => data.phase === 'delta' && matches.target === data.me && data.role !== 'tank',
    infoText: (_data, _matches, output) => output.beyondDeath(),
    outputStrings: {
      beyondDeath: {
        en: 'Beyond Death',
        de: 'Jenseis Des Jenseits',
        fr: 'Outre-mort',
        ja: '死の超越',
        cn: '超越死亡',
        ko: '죽음 초월'
      }
    }
  }, {
    // Off Balance (Omega)
    id: 'O4S Neo Off Balance Omega',
    type: 'GainsEffect',
    netRegex: {
      effectId: '569'
    },
    condition: (data, matches) => data.phase === 'omega' && matches.target === data.me,
    delaySeconds: 0.5,
    infoText: (data, _matches, output) => {
      // Good for both dps and tanks.
      if (data.waterHealer !== undefined) return output.stackUnderBossOnWaterhealer({
        waterHealer: data.waterHealer
      });
      return output.stackOnWater();
    },
    outputStrings: {
      stackUnderBossOnWaterhealer: {
        en: 'Stack under boss on ${waterHealer}',
        de: 'Unter Boss auf ${waterHealer} stacken',
        fr: 'Packez-vous sous le boss sur ${waterHealer}',
        ja: 'ボスの下で${waterHealer}と頭割り',
        cn: '分摊于${waterHealer}',
        ko: '보스 아래에서 "${waterHealer}"에게 모이기'
      },
      stackOnWater: {
        en: 'Stack on water',
        de: 'Auf Wasser stacken',
        fr: 'Packez-vous sur l\'eau',
        ja: '水と頭割り',
        cn: '和水点名分摊',
        ko: '물 쉐어'
      }
    }
  }, {
    id: 'O4S Neo Earthshaker on Tank',
    type: 'HeadMarker',
    netRegex: {
      id: '0028'
    },
    condition: (data, matches) => matches.target === data.me && data.role === 'tank',
    response: responses/* Responses.earthshaker */.n3.earthshaker('info')
  }, {
    id: 'O4S Neo Earthshaker on not Tank',
    type: 'HeadMarker',
    netRegex: {
      id: '0028'
    },
    condition: (data, matches) => matches.target === data.me && data.role !== 'tank',
    response: responses/* Responses.earthshaker */.n3.earthshaker('alarm')
  }, {
    id: 'O4S Neo Delta Attack',
    type: 'StartsUsing',
    netRegex: {
      id: '241E',
      source: 'Neo Exdeath',
      capture: false
    },
    response: responses/* Responses.getTogether */.n3.getTogether()
  }, {
    id: 'O4S Neo Almagest',
    type: 'StartsUsing',
    netRegex: {
      id: '2417',
      source: 'Neo Exdeath',
      capture: false
    },
    alertText: (_data, _matches, output) => output.almagest(),
    run: data => {
      data.almagestCount = (data.almagestCount ?? 0) + 1;
    },
    outputStrings: {
      almagest: {
        en: 'Almagest',
        de: 'Almagest',
        fr: 'Almageste',
        ja: 'アルマゲスト',
        cn: '大AOE',
        ko: '알마게스트'
      }
    }
  }, {
    id: 'O4S Neo Flare',
    type: 'StartsUsing',
    netRegex: {
      id: '2401',
      source: 'Neo Exdeath'
    },
    condition: (data, matches) => {
      data.flareTargets ??= [];
      data.flareTargets.push(matches.target);
      return data.flareTargets.length === 3;
    },
    alarmText: (data, _matches, output) => {
      if (data.flareTargets?.includes(data.me)) return output.flareOnYou();
    },
    infoText: (data, _matches, output) => {
      if (!data.flareTargets?.includes(data.me)) return output.stack();
    },
    tts: (data, _matches, output) => {
      if (data.flareTargets?.includes(data.me)) return output.flareOnYou();
      return output.stackTTS();
    },
    run: data => delete data.flareTargets,
    outputStrings: {
      stack: {
        en: 'Light and Darkness: Stack',
        de: 'Licht und Dunkel: Stack',
        fr: 'Clair-obscur : Packez-vous',
        ja: 'ライト・アンド・ダークネス: 頭割り',
        cn: '分摊点名',
        ko: '빛과 어둠: 모이기'
      },
      flareOnYou: {
        en: 'Flare on you',
        de: 'Flare auf dir',
        fr: 'Brasier sur vous',
        ja: '自分にフレア',
        cn: '核爆点名',
        ko: '플레어 대상자'
      },
      stackTTS: {
        en: 'stack',
        de: 'stek',
        fr: 'packez-vous',
        ja: '頭割り',
        cn: '分摊',
        ko: '모이기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Blizzard III/Fire III/Thunder III': 'Blizzard/Fire/Thunder III'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      '(?<! )Exdeath': 'Exdeath',
      'Neo Exdeath': 'Neo Exdeath'
    },
    'replaceText': {
      '\\(charge\\)': '(Aufladung)',
      '\\(colors': '(Farben',
      'lasers\\)': 'Laser)',
      'Aero III': 'Windga',
      'Almagest': 'Almagest',
      'Black Hole': 'Schwarzes Loch',
      'Blizzard III': 'Eisga',
      'Charybdis': 'Charybdis',
      'Collision': 'Aufprall',
      'Delta Attack': 'Delta-Attacke',
      'Double Attack': 'Doppelangriff',
      'Dualcast': 'Doppelzauber',
      'Earth Shaker': 'Erdstoß',
      'Emptiness': 'Tobende Leere',
      'Final Battle': 'Finaler Kampf',
      'Fire III': 'Feuga',
      'Flare': 'Flare',
      'Flood of Naught': 'Flut der Leere',
      'Flying Frenzy': 'Rasender Sturz',
      'Frenzied Fist': 'Rasende Faust',
      'Frenzied Sphere': 'Rasender Orbis',
      'Grand Cross Alpha': 'Supernova Alpha',
      'Grand Cross Delta': 'Supernova Delta',
      'Grand Cross Omega': 'Supernova Omega',
      'Holy': 'Sanctus',
      'Light and Darkness': 'Licht und Dunkelheit',
      'Meteor': 'Meteor',
      'Neverwhere': 'Nirgendwann',
      'The Decisive Battle': 'Entscheidungsschlacht',
      'Thunder III': 'Blitzga',
      'Vacuum Wave': 'Vakuumwelle',
      'White Hole': 'Weißes Loch',
      'Zombie Breath': 'Zombie-Atem'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '(?<! )Exdeath': 'Exdeath',
      'Neo Exdeath': 'Néo-Exdeath'
    },
    'replaceText': {
      '\\(colors\\)': '(couleurs)',
      '\\(colors/lasers\\)': '(couleurs/lasers)',
      'Aero III': 'Méga Vent',
      'Almagest': 'Almageste',
      'Black Hole': 'Trou noir',
      'Blizzard III(?!/)': 'Méga Glace',
      'Blizzard III/Fire III/Thunder III': 'Méga Glace/Feu/Foudre',
      'Charybdis': 'Charybde',
      'Collision': 'Impact',
      'Delta Attack': 'Attaque Delta',
      'Double Attack': 'Double attaque',
      'Dualcast': 'Chaîne de sorts',
      'Earth Shaker': 'Secousse',
      'Emptiness': 'Désolation du néant',
      '(?<!/)Fire III(?!/)': 'Méga Feu',
      'Flare': 'Brasier',
      'Flood of Naught': 'Crue du néant',
      'Flying Frenzy': 'Démence',
      'Frenzied Fist': 'Poing de la démence',
      'Frenzied Sphere': 'Démence terminale',
      'Grand Cross Alpha': 'Croix suprême alpha',
      'Grand Cross Delta': 'Croix suprême delta',
      'Grand Cross Omega': 'Croix suprême oméga',
      'Holy': 'Miracle',
      'Light and Darkness': 'Clair-obscur',
      'Meteor': 'Météore',
      'Neverwhere': 'Anarchie',
      'The Decisive Battle': 'Combat décisif',
      'The Final Battle': 'Lutte finale',
      '(?<!/)Thunder III': 'Méga Foudre',
      'Vacuum Wave': 'Vague de vide',
      'White Hole': 'Trou blanc',
      'Zombie Breath': 'Haleine zombie'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '(?<! )Exdeath': 'エクスデス',
      'Neo Exdeath': 'ネオエクスデス'
    },
    'replaceText': {
      'Aero III': 'エアロガ',
      'Almagest': 'アルマゲスト',
      'Black Hole': 'ブラックホール',
      'Blizzard III': 'ブリザガ',
      'Charybdis': 'ミールストーム',
      'Collision': '衝撃',
      'Delta Attack': 'デルタアタック',
      'Double Attack': 'ダブルアタック',
      'Dualcast': '連続魔',
      'Earth Shaker': 'アースシェイカー',
      'Emptiness': '無の暴走',
      'Final Battle': '最後の闘い',
      'Fire III': 'ファイガ',
      'Flare': 'フレア',
      'Flying Frenzy': '狂乱',
      'Flood of Naught': '無の氾濫',
      'Frenzied Fist': '狂乱の拳',
      'Frenzied Sphere': '狂乱の極地',
      'Grand Cross Alpha': 'グランドクロス・アルファ',
      'Grand Cross Delta': 'グランドクロス・デルタ',
      'Grand Cross Omega': 'グランドクロス・オメガ',
      'Holy': 'ホーリー',
      'Light and Darkness': 'ライト・アンド・ダークネス',
      'Meteor': 'メテオ',
      'Neverwhere': '法則崩壊',
      'The Decisive Battle': '決戦',
      'Thunder III': 'サンダガ',
      'Vacuum Wave': '真空波',
      'White Hole': 'ホワイトホール',
      'Zombie Breath': 'ゾンビブレス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '(?<! )Exdeath': '艾克斯迪司',
      'Neo Exdeath': '新生艾克斯迪司'
    },
    'replaceText': {
      '\\(charge\\)': '(排队)',
      '\\(colors': '(鸳鸯锅',
      'lasers\\)': '激光)',
      'Aero III': '暴风',
      'Almagest': '至高无上',
      'Black Hole': '黑洞',
      'Blizzard III': '冰封',
      'Charybdis': '大漩涡',
      'Collision': '冲击',
      'Delta Attack': '三角攻击',
      'Double Attack': '双重攻击',
      'Tethers': '连线',
      'Dualcast': '连续咏唱',
      'Earth Shaker': '大地摇动',
      'Emptiness': '无之失控',
      'Final Battle': '最终之战',
      'Fire III': '爆炎',
      'Flare': '核爆',
      'Flying Frenzy': '狂乱',
      'Flood of Naught': '无之泛滥',
      'Frenzied Fist': '狂乱之拳',
      'Frenzied Sphere': '狂乱领域',
      'Grand Cross Alpha': '大十字·阿尔法',
      'Grand Cross Delta': '大十字·德尔塔',
      'Grand Cross Omega': '大十字·欧米茄',
      'Holy': '神圣',
      'Light and Darkness': '光与暗',
      'Meteor': '陨石',
      'Neverwhere': '规律崩坏',
      'The Decisive Battle': '决战',
      'Thunder III': '暴雷',
      'T/H': 'T/奶',
      'Vacuum Wave': '真空波',
      'White Hole': '白洞',
      'Zombie Breath': '死亡吐息'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '(?<! )Exdeath': '엑스데스',
      'Neo Exdeath': '네오 엑스데스'
    },
    'replaceText': {
      'Aero III': '에어로가',
      'Almagest': '알마게스트',
      'Black Hole': '블랙홀',
      'Blizzard III': '블리자가',
      'Charybdis': '대소용돌이',
      'Collision': '충격',
      'Delta Attack': '델타 공격',
      'Double Attack': '이중 공격',
      'Dualcast': '연속 마법',
      'Earth Shaker': '요동치는 대지',
      'Emptiness': '무의 폭주',
      'Fire III': '파이가',
      'Flare': '플레어',
      'Flood of Naught': '무의 범람',
      'Final Battle': '마지막 싸움',
      'Flying Frenzy': '광란',
      'Frenzied Fist': '광란의 주먹',
      'Frenzied Sphere': '광란의 극지',
      'Grand Cross Alpha': '그랜드크로스: 알파',
      'Grand Cross Delta': '그랜드크로스: 델타',
      'Grand Cross Omega': '그랜드크로스: 오메가',
      'Holy': '홀리',
      'Light and Darkness': '빛과 어둠',
      'Tethers': '선',
      'Meteor': '메테오',
      'Neverwhere': '법칙 붕괴',
      'The Decisive Battle': '결전',
      'Thunder III': '선더가',
      'T/H': '탱/힐',
      'Vacuum Wave': '진공파',
      'White Hole': '화이트홀',
      'Zombie Breath': '좀비 숨결'
    }
  }]
};
/* harmony default export */ const o4s = (o4s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o4s.txt
const raid_o4s_namespaceObject = "# Omega - Deltascape V4.0 (Savage) - O4S\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# -ii 23F2 23F8 2400 240C\r\n\r\n# Use autos instead of InCombat lines to start timelines for door & final boss\r\n# as timeline resets out of combat.\r\n\r\n# Exfaust\r\n3.8 \"--sync--\" Ability { id: \"23F2\", source: \"Exdeath\" } window 3.8,0\r\n12.2 \"Dualcast\" Ability { id: \"23F4\", source: \"Exdeath\" } window 12.2,5\r\n16.8 \"--sync--\" Ability { id: \"23F7\", source: \"Exdeath\" }\r\n17.3 \"Blizzard III\" # Ability { id: \"23F8\", source: \"Exdeath\" }\r\n19.9 \"Blizzard III\" # Ability { id: \"23F8\", source: \"Exdeath\" }\r\n24.8 \"Dualcast\" Ability { id: \"23F4\", source: \"Exdeath\" }\r\n30.8 \"--sync--\" Ability { id: \"23F9\", source: \"Exdeath\" }\r\n31.5 \"Thunder III\" # Ability { id: \"23FA\", source: \"Exdeath\" }\r\n32.6 \"Thunder III\" # Ability { id: \"23FA\", source: \"Exdeath\" }\r\n37.9 \"Dualcast\" Ability { id: \"23F4\", source: \"Exdeath\" }\r\n42.5 \"--sync--\" Ability { id: \"23F5\", source: \"Exdeath\" }\r\n43.1 \"Fire III\" # Ability { id: \"23F6\", source: \"Exdeath\" }\r\n47.1 \"Fire III\" # Ability { id: \"23F6\", source: \"Exdeath\" }\r\n53.6 \"White Hole\" Ability { id: \"23FF\", source: \"Exdeath\" }\r\n64.7 \"The Decisive Battle\" Ability { id: \"2408\", source: \"Exdeath\" }\r\n66.5 \"--untargetable--\"\r\n\r\n70.6 \"--sync--\" Ability { id: \"240A\", source: \"Exdeath\" }\r\n71.8 \"Collision\" Ability { id: \"2409\", source: \"Exdeath\" }\r\n73.8 \"Holy\" Ability { id: \"2403\", source: \"Exdeath\" }\r\n77.7 \"Zombie Breath\" Ability { id: \"240B\", source: \"Exdeath\" }\r\n82.4 \"Flare\" Ability { id: \"2401\", source: \"Exdeath\" }\r\n\r\n85.2 \"--targetable--\"\r\n89.2 \"Blizzard III/Fire III/Thunder III\" Ability { id: \"23F[BCD]\", source: \"Exdeath\" } window 10,10\r\n95.4 \"Vacuum Wave\" Ability { id: \"23FE\", source: \"Exdeath\" }\r\n105.6 \"White Hole\" Ability { id: \"23FF\", source: \"Exdeath\" }\r\n118.0 \"Black Hole\" Ability { id: \"2406\", source: \"Exdeath\" }\r\n123.1 \"Dualcast\" Ability { id: \"23F4\", source: \"Exdeath\" }\r\n127.7 \"--sync--\" Ability { id: \"23F5\", source: \"Exdeath\" }\r\n128.3 \"Fire III\" # Ability { id: \"23F6\", source: \"Exdeath\" }\r\n132.2 \"Fire III\" # Ability { id: \"23F6\", source: \"Exdeath\" }\r\n134.8 \"Holy\" Ability { id: \"240[23]\", source: \"Exdeath\" }\r\n144.0 \"White Hole\" Ability { id: \"23FF\", source: \"Exdeath\" }\r\n153.1 \"Dualcast\" Ability { id: \"23F4\", source: \"Exdeath\" }\r\n159.1 \"--sync--\" Ability { id: \"23F9\", source: \"Exdeath\" }\r\n159.8 \"Thunder III\" # Ability { id: \"23FA\", source: \"Exdeath\" }\r\n160.9 \"Thunder III\" # Ability { id: \"23FA\", source: \"Exdeath\" }\r\n166.1 \"Meteor\" Ability { id: \"2404\", source: \"Exdeath\" }\r\n179.4 \"The Decisive Battle\" Ability { id: \"2408\", source: \"Exdeath\" }\r\n181.5 \"--untargetable--\"\r\n\r\n185.3 \"--sync--\" Ability { id: \"240A\", source: \"Exdeath\" }\r\n186.4 \"Collision\" Ability { id: \"2409\", source: \"Exdeath\" }\r\n188.7 \"Holy\" Ability { id: \"2403\", source: \"Exdeath\" }\r\n192.4 \"Zombie Breath\" Ability { id: \"240B\", source: \"Exdeath\" }\r\n197.1 \"Flare\" Ability { id: \"2401\", source: \"Exdeath\" }\r\n\r\n200.0 \"--targetable--\"\r\n203.9 \"Blizzard III/Fire III/Thunder III\" Ability { id: \"23F[BCD]\", source: \"Exdeath\" }\r\n210.3 \"Vacuum Wave\" Ability { id: \"23FE\", source: \"Exdeath\" }\r\n220.5 \"White Hole\" Ability { id: \"23FF\", source: \"Exdeath\" }\r\n232.8 \"Black Hole\" Ability { id: \"2406\", source: \"Exdeath\" }\r\n237.9 \"Dualcast\" Ability { id: \"23F4\", source: \"Exdeath\" }\r\n242.5 \"--sync--\" Ability { id: \"23F7\", source: \"Exdeath\" }\r\n243.0 \"Blizzard III\" # Ability { id: \"23F8\", source: \"Exdeath\" }\r\n245.6 \"Blizzard III\" # Ability { id: \"23F8\", source: \"Exdeath\" }\r\n249.6 \"Flare\" Ability { id: \"2401\", source: \"Exdeath\" }\r\n258.8 \"White Hole\" Ability { id: \"23FF\", source: \"Exdeath\" }\r\n267.9 \"Dualcast\" Ability { id: \"23F4\", source: \"Exdeath\" }\r\n274.0 \"--sync--\" Ability { id: \"23F9\", source: \"Exdeath\" }\r\n274.7 \"Thunder III\" # Ability { id: \"23FA\", source: \"Exdeath\" }\r\n275.8 \"Thunder III\" # Ability { id: \"23FA\", source: \"Exdeath\" }\r\n281.0 \"Meteor\" Ability { id: \"2404\", source: \"Exdeath\" }\r\n282.0 \"--untargetable--\"\r\n\r\n\r\n# -ii 2410 2413 2414 2415 241B 2421 2422 242F 2431 2432 244C 244D 245E 24DC\r\n# -p 242C:1116 242D:1339.5 2426:1652.1\r\n\r\n# Neo Exdeath\r\n1002.0 \"--sync--\" StartsUsing { id: \"2417\", source: \"Neo Exdeath\" } window 1002,5\r\n1007.7 \"Almagest\" Ability { id: \"2417\", source: \"Neo Exdeath\" } window 1008,5\r\n1016.7 \"Aero III\" Ability { id: \"2419\", source: \"Neo Exdeath\" }\r\n1026.7 \"Delta Attack\" Ability { id: \"241E\", source: \"Neo Exdeath\" }\r\n1027.2 \"Blizzard III\" # Ability { id: \"23F8\", source: \"Neo Exdeath\" }\r\n1027.4 \"Thunder III\" # Ability { id: \"23FA\", source: \"Neo Exdeath\" }\r\n1027.7 \"Fire III\" # Ability { id: \"23F6\", source: \"Neo Exdeath\" }\r\n1028.4 \"Thunder III\" # Ability { id: \"23FA\", source: \"Neo Exdeath\" }\r\n1030.2 \"Blizzard III\" # Ability { id: \"23F8\", source: \"Neo Exdeath\" }\r\n1030.7 \"Fire III\" # Ability { id: \"23F6\", source: \"Neo Exdeath\" }\r\n\r\n1042.7 \"Grand Cross Alpha\" Ability { id: \"242B\", source: \"Neo Exdeath\" }\r\n1045.8 \"--untargetable--\"\r\n1048.9 \"--targetable--\"\r\n1053.7 \"Flood Of Naught (charge)\" Ability { id: \"2416\", source: \"Neo Exdeath\" }\r\n1061.7 \"Flood Of Naught (colors)\" Ability { id: [\"2411\", \"2412\"], source: \"Neo Exdeath\" }\r\n1073.2 \"Double Attack\" Ability { id: \"241C\", source: \"Neo Exdeath\" }\r\n1083.8 \"Emptiness x8\" Ability { id: \"2420\", source: \"Neo Exdeath\" } duration 10\r\n1091.8 \"Flood Of Naught (lasers)\" Ability { id: [\"240E\", \"240F\"], source: \"Neo Exdeath\" }\r\n1101.9 \"Aero III\" Ability { id: \"2419\", source: \"Neo Exdeath\" }\r\n\r\n1116.0 \"Grand Cross Delta\" Ability { id: \"242C\", source: \"Neo Exdeath\" } window 116,10\r\n1129.0 \"Flood Of Naught (colors/lasers)\" Ability { id: [\"2411\", \"2412\", \"240E\", \"240F\"], source: \"Neo Exdeath\" }\r\n1138.0 \"Almagest\" Ability { id: \"2417\", source: \"Neo Exdeath\" }\r\n1149.1 \"Aero III\" Ability { id: \"2419\", source: \"Neo Exdeath\" }\r\n1158.9 \"Earth Shaker\" Ability { id: \"241A\", source: \"Neo Exdeath\" }\r\n1164.4 \"Vacuum Wave\" Ability { id: \"241D\", source: \"Neo Exdeath\" }\r\n1178.4 \"Emptiness x8\" Ability { id: \"2420\", source: \"Neo Exdeath\" } duration 10\r\n1186.4 \"Light And Darkness\" Ability { id: \"241F\", source: \"Neo Exdeath\" }\r\n1189.5 \"--untargetable--\"\r\n1192.4 \"Flare\" Ability { id: \"2401\", source: \"Neo Exdeath\" }\r\n1192.4 \"Holy\" Ability { id: \"2403\", source: \"Neo Exdeath\" }\r\n1192.8 \"--targetable--\"\r\n1197.6 \"Flood Of Naught (lasers)\" Ability { id: [\"240E\", \"240F\"], source: \"Neo Exdeath\" }\r\n1211.6 \"Meteor\" Ability { id: \"2424\", source: \"Neo Exdeath\" }\r\n1212.3 \"--adds targetable--\"\r\n1224.7 \"Flood Of Naught (colors)\" Ability { id: [\"2411\", \"2412\"], source: \"Neo Exdeath\" }\r\n1237.4 \"Charybdis\" Ability { id: \"2423\", source: \"Neo Exdeath\" }\r\n1244.9 \"Double Attack\" Ability { id: \"241C\", source: \"Neo Exdeath\" }\r\n1260.4 \"Almagest\" Ability { id: \"2417\", source: \"Neo Exdeath\" }\r\n1266.4 \"Vacuum Wave\" Ability { id: \"241D\", source: \"Neo Exdeath\" }\r\n1272.4 \"Aero III\" Ability { id: \"2419\", source: \"Neo Exdeath\" }\r\n1277.5 \"Emptiness x8\" Ability { id: \"2420\", source: \"Neo Exdeath\" } duration 10\r\n\r\n1286.5 \"Grand Cross Alpha\" Ability { id: \"242B\", source: \"Neo Exdeath\" } window 170,10\r\n1289.6 \"--untargetable--\"\r\n1292.7 \"--targetable--\"\r\n1297.5 \"Flood Of Naught (charge)\" Ability { id: \"2416\", source: \"Neo Exdeath\" }\r\n1305.5 \"Flood Of Naught (colors)\" Ability { id: [\"2411\", \"2412\"], source: \"Neo Exdeath\" }\r\n1322.5 \"Delta Attack\" Ability { id: \"241E\", source: \"Neo Exdeath\" }\r\n1323.0 \"Blizzard III\" # Ability { id: \"23F8\", source: \"Neo Exdeath\" }\r\n1323.2 \"Thunder III\" # Ability { id: \"23FA\", source: \"Neo Exdeath\" }\r\n1323.5 \"Fire III\" # Ability { id: \"23F6\", source: \"Neo Exdeath\" }\r\n1324.2 \"Thunder III\" # Ability { id: \"23FA\", source: \"Neo Exdeath\" }\r\n1326.0 \"Blizzard III\" # Ability { id: \"23F8\", source: \"Neo Exdeath\" }\r\n1326.5 \"Fire III\" # Ability { id: \"23F6\", source: \"Neo Exdeath\" }\r\n1330.5 \"Flood Of Naught (lasers)\" Ability { id: [\"240E\", \"240F\"], source: \"Neo Exdeath\" }\r\n\r\n1339.5 \"Grand Cross Omega\" Ability { id: \"242D\", source: \"Neo Exdeath\" } window 340,10\r\n1345.5 \"--untargetable--\"\r\n1346.5 \"The Final Battle\" Ability { id: \"242A\", source: \"Neo Exdeath\" }\r\n1354.6 \"Flood Of Naught (colors/lasers)\" Ability { id: [\"2411\", \"2412\", \"240E\", \"240F\"], source: \"Neo Exdeath\" }\r\n1359.6 \"Flood Of Naught (colors/lasers)\" Ability { id: [\"2411\", \"2412\", \"240E\", \"240F\"], source: \"Neo Exdeath\" }\r\n1365.6 \"Flood Of Naught (lasers)\" Ability { id: [\"240E\", \"240F\"], source: \"Neo Exdeath\" }\r\n1371.7 \"--targetable--\"\r\n1378.1 \"Flood Of Naught (charge)\" Ability { id: \"2416\", source: \"Neo Exdeath\" }\r\n1389.1 \"Almagest\" Ability { id: \"2417\", source: \"Neo Exdeath\" }\r\n\r\n1396.3 \"Emptiness x8\" Ability { id: \"2420\", source: \"Neo Exdeath\" } duration 10\r\n1404.4 \"Flood Of Naught\" Ability { id: [\"2411\", \"2412\", \"240E\", \"240F\"], source: \"Neo Exdeath\" }\r\n1414.6 \"Aero III\" Ability { id: \"2419\", source: \"Neo Exdeath\" }\r\n\r\n1428.6 \"Grand Cross Delta\" Ability { id: \"242C\", source: \"Neo Exdeath\" } window 90,10\r\n1441.6 \"Flood Of Naught (colors/lasers)\" Ability { id: [\"2411\", \"2412\", \"240E\", \"240F\"], source: \"Neo Exdeath\" }\r\n1450.6 \"Almagest\" Ability { id: \"2417\", source: \"Neo Exdeath\" }\r\n1461.6 \"Aero III\" Ability { id: \"2419\", source: \"Neo Exdeath\" }\r\n1471.3 \"Earth Shaker\" Ability { id: \"241A\", source: \"Neo Exdeath\" }\r\n1476.8 \"Vacuum Wave\" Ability { id: \"241D\", source: \"Neo Exdeath\" }\r\n1490.8 \"Emptiness x8\" Ability { id: \"2420\", source: \"Neo Exdeath\" } duration 10\r\n1498.8 \"Light And Darkness\" Ability { id: \"241F\", source: \"Neo Exdeath\" }\r\n1501.9 \"--untargetable--\"\r\n1504.8 \"Flare\" Ability { id: \"2401\", source: \"Neo Exdeath\" }\r\n1504.8 \"Holy\" Ability { id: \"2403\", source: \"Neo Exdeath\" }\r\n1505.2 \"--targetable--\"\r\n1509.8 \"Flood Of Naught (lasers)\" Ability { id: [\"240E\", \"240F\"], source: \"Neo Exdeath\" }\r\n1523.8 \"Meteor\" Ability { id: \"2424\", source: \"Neo Exdeath\" }\r\n1524.5 \"--adds targetable--\"\r\n1536.8 \"Flood Of Naught (colors)\" Ability { id: [\"2411\", \"2412\"], source: \"Neo Exdeath\" }\r\n1549.8 \"Charybdis\" Ability { id: \"2423\", source: \"Neo Exdeath\" }\r\n1557.3 \"Double Attack\" Ability { id: \"241C\", source: \"Neo Exdeath\" }\r\n1572.8 \"Almagest\" Ability { id: \"2417\", source: \"Neo Exdeath\" }\r\n1578.8 \"Vacuum Wave\" Ability { id: \"241D\", source: \"Neo Exdeath\" }\r\n1584.8 \"Aero III\" Ability { id: \"2419\", source: \"Neo Exdeath\" }\r\n1589.9 \"Emptiness x8\" Ability { id: \"2420\", source: \"Neo Exdeath\" } duration 10\r\n\r\n1598.9 \"Grand Cross Alpha\" Ability { id: \"242B\", source: \"Neo Exdeath\" } window 170,10\r\n1602.0 \"--untargetable--\"\r\n1605.3 \"--targetable--\"\r\n1609.9 \"Flood Of Naught (charge)\" Ability { id: \"2416\", source: \"Neo Exdeath\" }\r\n1617.9 \"Flood Of Naught (colors)\" Ability { id: [\"2411\", \"2412\"], source: \"Neo Exdeath\" }\r\n1634.9 \"Delta Attack\" Ability { id: \"241E\", source: \"Neo Exdeath\" }\r\n1635.4 \"Blizzard III\" # Ability { id: \"23F8\", source: \"Neo Exdeath\" }\r\n1635.6 \"Thunder III\" # Ability { id: \"23FA\", source: \"Neo Exdeath\" }\r\n1635.9 \"Fire III\" # Ability { id: \"23F6\", source: \"Neo Exdeath\" }\r\n1636.6 \"Thunder III\" # Ability { id: \"23FA\", source: \"Neo Exdeath\" }\r\n1638.4 \"Blizzard III\" # Ability { id: \"23F8\", source: \"Neo Exdeath\" }\r\n1638.9 \"Fire III\" # Ability { id: \"23F6\", source: \"Neo Exdeath\" }\r\n1642.9 \"Flood Of Naught (lasers)\" Ability { id: [\"240E\", \"240F\"], source: \"Neo Exdeath\" }\r\n\r\n1652.1 \"Neverwhere\" Ability { id: \"2426\", source: \"Neo Exdeath\" } window 652.1,10\r\n1660.2 \"Charybdis\" Ability { id: \"2423\", source: \"Neo Exdeath\" }\r\n1663.4 \"Flying Frenzy\" Ability { id: \"2427\", source: \"Neo Exdeath\" }\r\n1664.4 \"Frenzied Fist x9\" # Ability { id: \"2428\", source: \"Neo Exdeath\" }\r\n1671.2 \"Frenzied Sphere 1\" Ability { id: \"2429\", source: \"Neo Exdeath\" }\r\n1673.2 \"Flying Frenzy\" Ability { id: \"2427\", source: \"Neo Exdeath\" }\r\n1674.1 \"Frenzied Fist x9\" # Ability { id: \"2428\", source: \"Neo Exdeath\" }\r\n1681.0 \"Frenzied Sphere 2\" Ability { id: \"2429\", source: \"Neo Exdeath\" }\r\n1683.2 \"Flying Frenzy\" Ability { id: \"2427\", source: \"Neo Exdeath\" }\r\n1684.1 \"Frenzied Fist x9\" # Ability { id: \"2428\", source: \"Neo Exdeath\" }\r\n1691.0 \"Frenzied Sphere 3\" Ability { id: \"2429\", source: \"Neo Exdeath\" }\r\n1693.2 \"Flying Frenzy\" Ability { id: \"2427\", source: \"Neo Exdeath\" }\r\n1694.1 \"Frenzied Fist x9\" # Ability { id: \"2428\", source: \"Neo Exdeath\" }\r\n1701.0 \"Frenzied Sphere 4\" Ability { id: \"2429\", source: \"Neo Exdeath\" }\r\n1703.2 \"Flying Frenzy\" Ability { id: \"2427\", source: \"Neo Exdeath\" }\r\n1704.1 \"Frenzied Fist x9\" # Ability { id: \"2428\", source: \"Neo Exdeath\" }\r\n1711.0 \"Frenzied Sphere 5\" Ability { id: \"2429\", source: \"Neo Exdeath\" }\r\n1713.2 \"Flying Frenzy\" Ability { id: \"2427\", source: \"Neo Exdeath\" }\r\n1714.1 \"Frenzied Fist x9\" # Ability { id: \"2428\", source: \"Neo Exdeath\" }\r\n1721.0 \"Frenzied Sphere 6\" Ability { id: \"2429\", source: \"Neo Exdeath\" }\r\n1723.2 \"Flying Frenzy\" Ability { id: \"2427\", source: \"Neo Exdeath\" }\r\n1724.1 \"Frenzied Fist x9\" # Ability { id: \"2428\", source: \"Neo Exdeath\" }\r\n1731.0 \"Frenzied Sphere 7\" Ability { id: \"2429\", source: \"Neo Exdeath\" }\r\n1733.2 \"Flying Frenzy\" Ability { id: \"2427\", source: \"Neo Exdeath\" }\r\n1734.1 \"Frenzied Fist x9\" # Ability { id: \"2428\", source: \"Neo Exdeath\" }\r\n1741.0 \"Frenzied Sphere 8\" Ability { id: \"2429\", source: \"Neo Exdeath\" }\r\n1753.2 \"Almagest (enrage)\" Ability { id: \"2418\", source: \"Neo Exdeath\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o5n.ts



// O5N - Sigmascape 1.0 Normal
const o5n_triggerSet = {
  id: 'SigmascapeV10',
  zoneId: zone_id/* default.SigmascapeV10 */.Z.SigmascapeV10,
  timelineFile: 'o5n.txt',
  resetWhenOutOfCombat: false,
  triggers: [{
    id: 'O5N Stop Combat',
    type: 'RemovedCombatant',
    netRegex: {
      name: 'Phantom Train',
      capture: false
    },
    run: data => data.StopCombat()
  }, {
    id: 'O5N Acid Rain',
    type: 'StartsUsing',
    netRegex: {
      source: 'Phantom Train',
      id: '28BB',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O5N Doom Strike',
    type: 'StartsUsing',
    netRegex: {
      source: 'Phantom Train',
      id: '28A3'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O5N Head On',
    type: 'StartsUsing',
    netRegex: {
      id: '28A4',
      source: 'Phantom Train',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'O5N Diabolic Headlamp',
    type: 'StartsUsing',
    netRegex: {
      id: '28A6',
      source: 'Phantom Train',
      capture: false
    },
    response: responses/* Responses.stackMiddle */.n3.stackMiddle()
  }, {
    id: 'O5N Ghost Tether',
    type: 'Tether',
    netRegex: {
      id: '0001'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait ghost into light circle',
        de: 'Geist in das Licht ködern',
        fr: 'Attirez le fantôme dans la lumière',
        cn: '诱导幽灵进光圈',
        ko: '유령 빛장판으로 유도'
      }
    }
  }, {
    id: 'O5N Diabolic Light',
    type: 'HeadMarker',
    netRegex: {
      id: '0001'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Marker Away',
        de: 'Licht am Rand ablegen',
        fr: 'Déposez la marque au loin',
        ja: '魔界の光',
        // FIXME
        cn: '远离放置光点名',
        ko: '빛장판 유도'
      }
    }
  }, {
    id: 'O5N Diabolic Wind',
    type: 'HeadMarker',
    netRegex: {
      id: '0046'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'O5N Throttle',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3AA'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Touch ghost',
        de: 'Geist berühren',
        fr: 'Touchez le fantôme',
        cn: '撞幽灵',
        ko: '유령 접촉'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Phantom Train': 'Phantomzug',
      'Wroth Ghost': 'erzürnt(?:e|er|es|en) Geist'
    },
    'replaceText': {
      'Acid Rain': 'Säureregen',
      'Add Wave': 'Add Welle',
      'Crossing Whistle': 'Kreuzend Pfeife',
      'Diabolic Chimney': 'Diabolischer Schlot',
      'Diabolic Headlamp': 'Diabolische Leuchte',
      'Diabolic Light': 'Diabolisches Licht',
      'Diabolic Wind': 'Diabolischer Wind',
      'Doom Strike': 'Vernichtungsschlag',
      'Encumber': 'Wegsperrung',
      'Ghost Beams': 'Geisterstrahlen',
      'Ghosts': 'Geister',
      'Head On': 'Frontalangriff',
      'Saintly Beam': 'Heiligenstrahl',
      'Tether Whistle': 'Verfolger Pfeife'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Phantom Train': 'train fantôme',
      'Wroth Ghost': 'fantôme furieux'
    },
    'replaceText': {
      'Acid Rain': 'Pluie acide',
      'Add Wave': 'Vague d\'adds',
      'Crossing Whistle': 'Sifflet traversée',
      'Diabolic Chimney': 'Cheminée diabolique',
      'Diabolic Headlamp': 'Phare diabolique',
      'Diabolic Light': 'Lueur diabolique',
      'Diabolic Wind': 'Vent diabolique',
      'Doom Strike': 'Frappe létale',
      'Encumber': 'Encombrement',
      'Ghost Beams': 'Faisceaux Sacrés',
      'Ghosts': 'Fantômes',
      'Head On': 'Plein fouet',
      'Saintly Beam': 'Faisceaux sacrés',
      'Tether Whistle': 'Liens sifflet'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Phantom Train': '魔列車',
      'Wroth Ghost': 'ロスゴースト'
    },
    'replaceText': {
      'Acid Rain': '酸性雨',
      'Add Wave': '雑魚いっぱい',
      'Crossing Whistle': '魔界の汽笛: 通路ゴースト',
      'Diabolic Chimney': '魔界の噴煙',
      'Diabolic Headlamp': '魔界の前照灯',
      'Diabolic Light': '魔界の光',
      'Diabolic Wind': '魔界の風',
      'Doom Strike': '魔霊撃',
      'Encumber': '進路妨害',
      'Ghost Beams': 'ゴーストビーム',
      'Ghosts': 'ゴースト',
      'Head On': '追突',
      'Saintly Beam': 'セイントビーム',
      'Tether Whistle': '魔界の汽笛: 線繋ぐゴースト'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Phantom Train': '魔列车',
      'Wroth Ghost': '怒灵'
    },
    'replaceText': {
      'Acid Rain': '酸雨',
      'Add Wave': '一波小怪',
      'Crossing Whistle': '交叉汽笛',
      'Diabolic Chimney': '魔界喷烟',
      'Diabolic Headlamp': '魔界前照灯',
      'Diabolic Light': '魔界光',
      'Diabolic Wind': '魔界风',
      'Doom Strike': '魔灵击',
      'Encumber': '挡路',
      'Ghost Beams': '幽灵出现',
      'Ghosts': '幽灵',
      'Head On': '追尾',
      'Saintly Beam': '圣光射线',
      'Tether Whistle': '连线汽笛'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Phantom Train': '마열차',
      'Wroth Ghost': '격노하는 유령'
    },
    'replaceText': {
      'Acid Rain': '산성비',
      'Add Wave': '쫄 등장',
      'Crossing Whistle': '행진 유령',
      'Diabolic Chimney': '마계의 연기',
      'Diabolic Headlamp': '마계의 전조등',
      'Diabolic Light': '마계의 빛',
      'Diabolic Wind': '마계의 바람',
      'Doom Strike': '마령격',
      'Encumber': '진로 방해',
      'Head On': '추돌',
      'Saintly Beam': '성스러운 광선',
      'Ghost Beams': '유령 빛 장판',
      'Ghosts': '유령',
      'Tether Whistle': '선 연결 유령'
    }
  }]
};
/* harmony default export */ const o5n = (o5n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o5n.txt
const raid_o5n_namespaceObject = "# Omega - Sigmascape V1.0 - O5N\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Saintly Beam: 0 light appears, 5 target, 12 hit\r\n# Diabolic Light: 0 target appears, 8 target, 13 hit\r\n\r\n# Use ActorControl (0x21) Reset line\r\n# Trigger set contains 'resetWhenOutOfCombat: false'\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n8 \"--sync--\" StartsUsing { id: \"28AE\", source: \"Wroth Ghost\" } window 8,3\r\n13 \"Encumber\" Ability { id: \"28AE\", source: \"Wroth Ghost\" }\r\n27 \"Head On\" Ability { id: \"28AF\", source: \"Phantom Train\" }\r\n38 \"Ghost Beams\" Ability { id: \"28AA\", source: \"Phantom Train\" }\r\n47 \"Saintly Beam\" duration 12\r\n63 \"Diabolic Headlamp\" Ability { id: \"28B0\", source: \"Phantom Train\" } window 5,5\r\n73 \"Tether Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n80 \"Saintly Beam\" duration 12\r\n102 \"Doom Strike\" Ability { id: \"28A3\", source: \"Phantom Train\" }\r\n116 \"Diabolic Wind\" Ability { id: \"28B9\", source: \"Phantom Train\" }\r\n119 \"Crossing Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n139 \"Diabolic Light\" duration 13\r\n162 \"Acid Rain\" Ability { id: \"28AB\", source: \"Phantom Train\" }\r\n\r\n# add phase start\r\n163 \"--untargetable--\" Ability { id: \"28A7\", source: \"Phantom Train\" }\r\n178 \"Add Wave\"\r\n193 \"Diabolic Wind\" Ability { id: \"28B9\", source: \"Phantom Train\" }\r\n250 \"Diabolic Chimney\" Ability { id: \"28A9\", source: \"Phantom Train\" } window 100,100\r\n260 \"Ghosts\"\r\n\r\n# add phase end\r\n320 \"--sync--\" Ability { id: \"28A8\", source: \"Phantom Train\" } window 320,320 # boss reappears\r\n324 \"--targetable--\"\r\n338 \"Tether Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n342 \"Saintly Beam\" duration 12\r\n346 \"Acid Rain\" Ability { id: \"28AB\", source: \"Phantom Train\" }\r\n366 \"Doom Strike\" Ability { id: \"28A3\", source: \"Phantom Train\" }\r\n376 \"Crossing Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n386 \"Head On\" Ability { id: \"28AF\", source: \"Phantom Train\" }\r\n391 \"Acid Rain\" Ability { id: \"28AB\", source: \"Phantom Train\" }\r\n398 \"Diabolic Light\" duration 13\r\n403 \"Diabolic Headlamp\" Ability { id: \"28B0\", source: \"Phantom Train\" }\r\n425 \"Doom Strike\" Ability { id: \"28A3\", source: \"Phantom Train\" }\r\n\r\n# Loop starts here\r\n433 \"Tether Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n437 \"Saintly Beam\" duration 12\r\n441 \"Acid Rain\" Ability { id: \"28AB\", source: \"Phantom Train\" }\r\n463 \"Head On\" Ability { id: \"28AF\", source: \"Phantom Train\" }\r\n465 \"Diabolic Wind\" Ability { id: \"28B9\", source: \"Phantom Train\" }\r\n470 \"Acid Rain\" Ability { id: \"28AB\", source: \"Phantom Train\" }\r\n477 \"Crossing Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n483 \"Encumber\" Ability { id: \"28AE\", source: \"Wroth Ghost\" }\r\n491 \"Diabolic Wind\" Ability { id: \"28B9\", source: \"Phantom Train\" }\r\n498 \"Diabolic Headlamp\" Ability { id: \"28B0\", source: \"Phantom Train\" }\r\n504 \"Acid Rain\" Ability { id: \"28AB\", source: \"Phantom Train\" }\r\n509 \"Diabolic Light\" duration 13\r\n513 \"Doom Strike\" Ability { id: \"28A3\", source: \"Phantom Train\" }\r\n527 \"Saintly Beam\" duration 12\r\n528 \"Acid Rain\" Ability { id: \"28AB\", source: \"Phantom Train\" }\r\n544 \"Diabolic Wind\" Ability { id: \"28B9\", source: \"Phantom Train\" }\r\n559 \"Doom Strike\" Ability { id: \"28A3\", source: \"Phantom Train\" }\r\n\r\n567 \"Tether Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" } jump 433 # repeats after this?\r\n\r\n# Visual continuity\r\n571 \"Saintly Beam\" duration 12\r\n575 \"Acid Rain\"\r\n597 \"Head On\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o5s.ts



// O5S - Sigmascape 1.0 Savage
const o5s_triggerSet = {
  id: 'SigmascapeV10Savage',
  zoneId: zone_id/* default.SigmascapeV10Savage */.Z.SigmascapeV10Savage,
  timelineFile: 'o5s.txt',
  resetWhenOutOfCombat: false,
  triggers: [{
    id: 'O5S Stop Combat',
    type: 'RemovedCombatant',
    netRegex: {
      name: 'Phantom Train',
      capture: false
    },
    run: data => data.StopCombat()
  }, {
    id: 'O5S Doom Strike',
    type: 'StartsUsing',
    netRegex: {
      id: '28B1',
      source: 'Phantom Train'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O5S Head On',
    type: 'StartsUsing',
    netRegex: {
      id: '28A4',
      source: 'Phantom Train',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'O5S Diabolic Headlamp',
    type: 'StartsUsing',
    netRegex: {
      id: '28B2',
      source: 'Phantom Train',
      capture: false
    },
    response: responses/* Responses.stackMiddle */.n3.stackMiddle()
  }, {
    id: 'O5S Diabolic Light',
    type: 'HeadMarker',
    netRegex: {
      id: '0001'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Light',
        de: 'Licht',
        fr: 'Lumière',
        ja: '魔界の光',
        cn: '光点名',
        ko: '빛장판'
      }
    }
  }, {
    id: 'O5S Diabolic Wind',
    type: 'HeadMarker',
    netRegex: {
      id: '0046'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Wind',
        de: 'Wind',
        fr: 'Vent',
        ja: '魔界の風',
        cn: '圆圈点名',
        ko: '초록징'
      }
    }
  }, {
    id: 'O5S Remorse',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Remorse',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Agony': 'Gequälter Geist',
      'Malice': 'Boshaftigkeit',
      'Phantom Train': 'Phantomzug',
      'Remorse': 'melancholisch(?:e|er|es|en) Geist',
      'Wroth Ghost': 'erzürnt(?:e|er|es|en) Geist'
    },
    'replaceText': {
      ' Ghosts': ' Geister',
      'Acid Rain': 'Säureregen',
      'Add Wave': 'Add Welle',
      'All In The Mind': 'Psychokinese',
      'Crossing Whistle': 'Kreuzend Pfeife',
      'Diabolic Headlamp': 'Diabolische Leuchte',
      'Diabolic Light': 'Diabolisches Licht',
      'Diabolic Wind': 'Diabolischer Wind',
      'Doom Strike': 'Vernichtungsschlag',
      'Encumber': 'Wegsperrung',
      'Ghosts spawn': 'Geister erscheinen',
      'Head On': 'Frontalangriff',
      'Knockback Whistle': 'Rückstoß Pfeife',
      'Saintly Beam': 'Heiligenstrahl',
      'Tether Whistle': 'Verfolger Pfeife'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Agony': 'Fantôme Souffrant',
      'Malice': 'Malveillance',
      'Phantom Train': 'train fantôme',
      'Remorse': 'fantôme mélancolique',
      'Wroth Ghost': 'fantôme furieux'
    },
    'replaceText': {
      ' Ghosts': ' Fantômes',
      'Acid Rain': 'Pluie acide',
      'Add Wave': 'Vague d\'adds',
      'All In The Mind': 'Force de volonté',
      'Crossing Whistle': 'Sifflet traversée',
      'Diabolic Headlamp': 'Phare diabolique',
      'Diabolic Light': 'Lueur diabolique',
      'Diabolic Wind': 'Vent diabolique',
      'Doom Strike': 'Frappe létale',
      'Encumber': 'Encombrement',
      'Ghosts spawn': 'Apparition des Fantômes',
      'Head On': 'Plein fouet',
      'Knockback Whistle': 'Poussée sifflet',
      'Saintly Beam': 'Faisceaux sacrés',
      'Tether Whistle': 'Liens sifflet'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Agony': '苦悶のゴースト',
      'Malice': '怨念',
      'Phantom Train': '魔列車',
      'Remorse': '未練のゴースト',
      'Wroth Ghost': 'ロスゴースト'
    },
    'replaceText': {
      ' Ghosts': ' ゴースト',
      'Acid Rain': '酸性雨',
      'Add Wave': '雑魚いっぱい',
      'All In The Mind': '念力',
      'Crossing Whistle': '魔界の汽笛: 通路ゴースト',
      'Diabolic Headlamp': '魔界の前照灯',
      'Diabolic Light': '魔界の光',
      'Diabolic Wind': '魔界の風',
      'Doom Strike': '魔霊撃',
      'Encumber': '進路妨害',
      'Ghosts spawn': '雑魚: ゴースト',
      'Head On': '追突',
      'Knockback Whistle': '魔界の汽笛: ノックバック',
      'Saintly Beam': 'セイントビーム',
      'Tether Whistle': '魔界の汽笛: 線繋ぐゴースト'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Agony': '苦闷幽灵',
      'Malice': '怨念',
      'Phantom Train': '魔列车',
      'Remorse': '留恋幽灵',
      'Wroth Ghost': '怒灵'
    },
    'replaceText': {
      ' Ghosts': ' 幽灵',
      'Acid Rain': '酸雨',
      'Add Wave': '一波小怪',
      'All In The Mind': '念力',
      'Crossing Whistle': '交叉汽笛',
      'Diabolic Headlamp': '魔界前照灯',
      'Diabolic Light': '魔界光',
      'Diabolic Wind': '魔界风',
      'Doom Strike': '魔灵击',
      'Encumber': '挡路',
      'Ghosts spawn': '幽灵出现',
      'Head On': '追尾',
      'Knockback Whistle': '击退汽笛',
      'Saintly Beam': '圣光射线',
      'Tether Whistle': '连线汽笛'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Agony': '고뇌하는 유령',
      'Malice': '원한',
      'Phantom Train': '마열차',
      'Remorse': '미련이 남은 유령',
      'Wroth Ghost': '격노하는 유령'
    },
    'replaceText': {
      'DPS': '딜러',
      'T/H': '탱/힐',
      ' Ghosts': ' 유령',
      'Acid Rain': '산성비',
      'Add Wave': '쫄 소환',
      'All In The Mind': '염력',
      'Crossing Whistle': '행진 유령',
      'Diabolic Headlamp': '마계의 전조등',
      'Diabolic Light': '마계의 빛',
      'Diabolic Wind': '마계의 바람',
      'Doom Strike': '마령격',
      'Encumber': '진로 방해',
      'Ghosts spawn': '유령 소환',
      'Head On': '추돌',
      'Knockback Whistle': '넉백 유령',
      'Saintly Beam': '성스러운 광선',
      'Tether Whistle': '선 연결 유령'
    }
  }]
};
/* harmony default export */ const o5s = (o5s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o5s.txt
const raid_o5s_namespaceObject = "# Omega - Sigmascape V1.0 (Savage) - O5S\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Saintly Beam: 0 light appears, 5 target, 10 hit\r\n# Diabolic Light: 0 target appears, 8 target, 13 hit\r\n\r\n# Use ActorControl (0x21) Reset line\r\n# Trigger set contains 'resetWhenOutOfCombat: false'\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11 \"Encumber\" Ability { id: \"28B6\", source: \"Wroth Ghost\" } window 11,5\r\n18 \"Saintly Beam\" duration 10\r\n31 \"Knockback Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n41 \"All In The Mind\" Ability { id: \"28AD\", source: \"Remorse\" }\r\n50 \"Doom Strike\" Ability { id: \"28B1\", source: \"Phantom Train\" }\r\n64 \"Head On\" Ability { id: \"28B7\", source: \"Phantom Train\" }\r\n65 \"Diabolic Wind\" Ability { id: \"28BD\", source: \"Phantom Train\" }\r\n71 \"Acid Rain\" Ability { id: \"28B5\", source: \"Phantom Train\" }\r\n80 \"Crossing Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n90 \"Saintly Beam\" duration 10\r\n104 \"Diabolic Headlamp\" Ability { id: \"28B8\", source: \"Phantom Train\" }\r\n116 \"Tether Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n125 \"Saintly Beam\" duration 10\r\n141 \"Diabolic Light\" duration 13\r\n152 \"Doom Strike\" Ability { id: \"28B1\", source: \"Phantom Train\" }\r\n159 \"Acid Rain\" Ability { id: \"28B5\", source: \"Phantom Train\" }\r\n\r\n\r\n# add phase\r\n\r\n168 \"--untargetable--\" Ability { id: \"28A7\", source: \"Phantom Train\" } window 500,500\r\n180 \"Add Wave\"\r\n196 \"(DPS) Diabolic Wind\" Ability { id: \"28BD\", source: \"Phantom Train\" }\r\n203 \"(T/H) Diabolic Wind\" Ability { id: \"28BD\", source: \"Phantom Train\" }\r\n\r\n# chimney + train cars\r\n300 \"--sync--\" Ability { id: \"28B3\", source: \"Phantom Train\" } window 500,500\r\n305 \"(T/H) Ghosts\" AddedCombatant { name: \"Agony\" }\r\n309 \"(DPS) Ghosts\" AddedCombatant { name: \"Malice\" }\r\n\r\n\r\n491 \"--sync--\" Ability { id: \"28A8\", source: \"Phantom Train\" } window 500,500\r\n500 \"--targetable--\"\r\n517 \"Encumber\" Ability { id: \"28B6\", source: \"Wroth Ghost\" } window 80,80\r\n525 \"Diabolic Light\" duration 13\r\n530 \"Diabolic Headlamp\" Ability { id: \"28B8\", source: \"Phantom Train\" }\r\n534 \"Saintly Beam\" duration 10\r\n547 \"Doom Strike\" Ability { id: \"28B1\", source: \"Phantom Train\" }\r\n\r\n556 \"Tether Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n563 \"Saintly Beam\" duration 10\r\n580 \"Knockback Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n589 \"All In The Mind\" Ability { id: \"28AD\", source: \"Remorse\" }\r\n593 \"Diabolic Headlamp\" Ability { id: \"28B8\", source: \"Phantom Train\" }\r\n611 \"Head On\" Ability { id: \"28B7\", source: \"Phantom Train\" }\r\n612 \"Saintly Beam\" duration 10\r\n616 \"Ghosts spawn\"\r\n\r\n629 \"Crossing Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n637 \"Diabolic Headlamp\" Ability { id: \"28B8\", source: \"Phantom Train\" }\r\n645 \"Diabolic Wind\" Ability { id: \"28BD\", source: \"Phantom Train\" }\r\n646 \"Tether Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n653 \"Saintly Beam\" duration 10\r\n659 \"Diabolic Wind\" Ability { id: \"28BD\", source: \"Phantom Train\" }\r\n\r\n665 \"Diabolic Light\" duration 13\r\n676 \"Doom Strike\" Ability { id: \"28B1\", source: \"Phantom Train\" }\r\n683 \"Acid Rain\" Ability { id: \"28B5\", source: \"Phantom Train\" }\r\n697 \"Diabolic Headlamp\" Ability { id: \"28B8\", source: \"Phantom Train\" }\r\n699 \"Saintly Beam\" duration 10\r\n704 \"Acid Rain\" Ability { id: \"28B5\", source: \"Phantom Train\" }\r\n\r\n718 \"Tether Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n728 \"Saintly Beam\" duration 10\r\n731 \"Encumber\" Ability { id: \"28B6\", source: \"Wroth Ghost\" }\r\n732 \"Diabolic Wind\" Ability { id: \"28BD\", source: \"Phantom Train\" }\r\n\r\n737 \"Diabolic Light\" duration 13\r\n748 \"Doom Strike\" Ability { id: \"28B1\", source: \"Phantom Train\" }\r\n760 \"Knockback Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n769 \"All In The Mind\" Ability { id: \"28AD\", source: \"Remorse\" }\r\n774 \"Diabolic Headlamp\" Ability { id: \"28B8\", source: \"Phantom Train\" }\r\n\r\n789 \"Head On\" Ability { id: \"28B7\", source: \"Phantom Train\" }\r\n791 \"Diabolic Wind\" Ability { id: \"28BD\", source: \"Phantom Train\" }\r\n797 \"Acid Rain\" Ability { id: \"28B5\", source: \"Phantom Train\" }\r\n808 \"Encumber\" Ability { id: \"28B6\", source: \"Wroth Ghost\" }\r\n811 \"Crossing Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n819 \"Diabolic Headlamp\" Ability { id: \"28B8\", source: \"Phantom Train\" }\r\n827 \"Diabolic Wind\" Ability { id: \"28BD\", source: \"Phantom Train\" }\r\n828 \"Tether Whistle\" Ability { id: \"28A5\", source: \"Phantom Train\" }\r\n\r\n# 10:00 enrage, final phase length depends on add phase time\r\n1021 \"--sync--\" StartsUsing { id: \"2A87\", source: \"Phantom Train\" } window 1021,500\r\n1031 \"Saintly Beam\" Ability { id: \"2A87\", source: \"Phantom Train\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o6n.ts



// TODO: handle paintings? <_<
// O6N - Sigmascape 2.0 Normal
const o6n_triggerSet = {
  id: 'SigmascapeV20',
  zoneId: zone_id/* default.SigmascapeV20 */.Z.SigmascapeV20,
  timelineFile: 'o6n.txt',
  triggers: [{
    id: 'O6N Demonic Howl',
    type: 'StartsUsing',
    netRegex: {
      id: '282C',
      source: 'Demon Chadarnook',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O6N Demonic Shear',
    type: 'StartsUsing',
    netRegex: {
      id: '282A',
      source: 'Demon Chadarnook'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O6N Demonic Pain',
    type: 'Tether',
    // 0001 = far enough, 0039 = too close
    netRegex: {
      id: ['0001', '0039']
    },
    condition: (data, matches) => data.me === matches.target || data.me === matches.source,
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Boss',
        de: 'Weg vom Boss',
        fr: 'Éloignez-vous du boss',
        cn: '远离BOSS',
        ko: '보스에게서 떨어지기'
      }
    }
  }, {
    id: 'O6N Demonic Stone',
    type: 'HeadMarker',
    netRegex: {
      id: '0001'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Chasing AOE Away',
        de: 'AoEs weglocken',
        fr: 'Déposez les AoEs au loin',
        ja: '離れてAoEを置く',
        // FIXME
        cn: '远离放置追踪AOE',
        ko: '연속장판 멀리빼기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Demon Chadarnook': 'gefallen(?:e|er|es|en) Chadarnook',
      'Easterly': 'Ostwind',
      'Haunt': 'Verfolgung',
      'I have claimed the girl in the picture!': 'Das Mädchen in diesem Bildnis gehört mir!',
      'Portrayal of Earth': 'Erdgemälde',
      'Portrayal of Fire': 'Feuergemälde',
      'Portrayal of Water': 'Wassergemälde'
    },
    'replaceText': {
      'Demonic Howl': 'Dämonisches Heulen',
      'Demonic Pain': 'Dämonischer Schmerz',
      'Demonic Shear': 'Dämonische Schere',
      'Demonic Spout': 'Dämonischer Überschwang',
      'Demonic Stone': 'Dämonischer Stein',
      'Demonic Typhoon': 'Dämonischer Taifun',
      'Demonic Wave': 'Dämonische Welle',
      'Earthquake': 'Erdbeben',
      'Featherlance': 'Federlanze',
      'Flash Fire': 'Blitzfeuer',
      'Flash Gale': 'Blitzwind',
      'Materialize': 'Materialisierung',
      'Possession': 'Besessenheit',
      'Release': 'Befreiung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Demon Chadarnook': 'démon Chadarnouk',
      'Easterly': 'rafale ultime',
      'Haunt': 'Cauchemar corporel',
      'I have claimed the girl in the picture!': 'Héhéhé... La fille du tableau m\'appartient.',
      'Portrayal of Earth': 'peinture de la terre',
      'Portrayal of Fire': 'peinture du feu',
      'Portrayal of Water': 'peinture de l\'eau'
    },
    'replaceText': {
      'Demonic Howl': 'Hurlement démoniaque',
      'Demonic Pain': 'Douleur démoniaque',
      'Demonic Shear': 'Cisailles démoniaques',
      'Demonic Spout': 'Vague démoniaque',
      'Demonic Stone': 'Pierre démoniaque',
      'Demonic Typhoon': 'Typhon démoniaque',
      'Demonic Wave': 'Vague démoniaque',
      'Earthquake': 'Grand séisme',
      'Featherlance': 'Lance de plume',
      'Flash Fire': 'Flammes subites',
      'Flash Gale': 'Vent subit',
      'Materialize': 'Matérialisation',
      'Possession': 'Possession',
      'Release': 'Libération'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Demon Chadarnook': 'チャダルヌーク・デーモン',
      'Easterly': '極風',
      'Haunt': '思念体',
      'I have claimed the girl in the picture!': 'グフフフ……この絵の女は、わしがいただいた……。',
      'Portrayal of Earth': '土の絵画',
      'Portrayal of Fire': '火の絵画',
      'Portrayal of Water': '水の絵画'
    },
    'replaceText': {
      'Demonic Howl': 'デモニックハウル',
      'Demonic Pain': 'デモニックペイン',
      'Demonic Shear': 'デモニックシアー',
      'Demonic Spout': 'デモニックスパウト',
      'Demonic Stone': 'デモニックストーン',
      'Demonic Typhoon': 'デモニックタイフーン',
      'Demonic Wave': 'デモニックウェーブ',
      'Earthquake': '大地震',
      'Featherlance': 'フェザーランス',
      'Flash Fire': 'フラッシュファイア',
      'Flash Gale': 'フラッシュウィンド',
      'Materialize': '実体化',
      'Possession': '絵画憑依',
      'Release': '憑依解除'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Demon Chadarnook': '恶魔查达奴克',
      'Easterly': '极风',
      'Haunt': '幻影',
      'I have claimed the girl in the picture!': '呵哼哼……这个画作的女人就归我了',
      'Portrayal of Earth': '土之画作',
      'Portrayal of Fire': '火之画作',
      'Portrayal of Water': '水之画作'
    },
    'replaceText': {
      'Demonic Howl': '恶魔啸',
      'Demonic Pain': '恶魔痛',
      'Demonic Shear': '恶魔斩',
      'Demonic Spout': '恶魔喷',
      'Demonic Stone': '恶魔飞石',
      'Demonic Typhoon': '恶魔台风',
      'Demonic Wave': '恶魔波',
      'Earthquake': '大地震',
      'Featherlance': '羽枪',
      'Flash Fire': '闪光炎',
      'Flash Gale': '闪光风',
      'Materialize': '实体化',
      'Possession': '附身画像',
      'Release': '附身解除'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Demon Chadarnook': '차다르누크 악령',
      'Easterly': '극풍',
      'Haunt': '사념체',
      'I have claimed the girl in the picture!': '우후후후…… 그림 속 여자는 내가 데려가마……',
      'Portrayal of Earth': '땅의 그림',
      'Portrayal of Fire': '불의 그림',
      'Portrayal of Water': '물의 그림'
    },
    'replaceText': {
      'Demonic Howl': '악령의 외침',
      'Demonic Pain': '악령의 고통',
      'Demonic Shear': '악령의 참격',
      'Demonic Spout': '악령의 물기둥',
      'Demonic Stone': '악령의 돌',
      'Demonic Typhoon': '악령의 태풍',
      'Demonic Wave': '악령의 물결',
      'Earthquake': '대지진',
      'Featherlance': '깃털창',
      'Flash Fire': '불바다',
      'Flash Gale': '돌풍',
      'Materialize': '실체화',
      'Possession': '그림 빙의',
      'Release': '빙의 해제'
    }
  }]
};
/* harmony default export */ const o6n = (o6n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o6n.txt
const raid_o6n_namespaceObject = "# Omega - Sigmascape V2.0 - O6N\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Note: Although there is a 18 sec. delay between the chatlog line and the boss being targetable\r\n# the player's InCombat status is changed at nearly the same time and can be reliably used to start the timeline.\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n18 \"--targetable--\"\r\n21 \"Demonic Howl\" Ability { id: \"282C\", source: \"Demon Chadarnook\" } window 21,2.5\r\n30 \"Demonic Shear\" Ability { id: \"282A\", source: \"Demon Chadarnook\" }\r\n\r\n54 \"Possession\" Ability { id: \"2803\", source: \"Demon Chadarnook\" }\r\n59 \"Flash Fire\" Ability { id: \"280B\", source: \"Portrayal of Fire\" }\r\n66 \"Demonic Howl\" Ability { id: \"282C\", source: \"Demon Chadarnook\" }\r\n76 \"Demonic Shear\" Ability { id: \"282A\", source: \"Demon Chadarnook\" }\r\n86 \"Release\" Ability { id: \"2804\", source: \"Demon Chadarnook\" }\r\n\r\n99 \"Possession\" Ability { id: \"2803\", source: \"Demon Chadarnook\" }\r\n104 \"Earthquake\" Ability { id: \"2811\", source: \"Portrayal of Earth\" }\r\n118 \"Demonic Stone\" Ability { id: \"2847\", source: \"Demon Chadarnook\" }\r\n125 \"Demonic Howl\" Ability { id: \"282C\", source: \"Demon Chadarnook\" }\r\n138 \"Demonic Shear\" Ability { id: \"282A\", source: \"Demon Chadarnook\" }\r\n146 \"Release\" Ability { id: \"2804\", source: \"Demon Chadarnook\" }\r\n\r\n159 \"Possession\" Ability { id: \"2803\", source: \"Demon Chadarnook\" }\r\n170 \"Demonic Wave\" Ability { id: \"2831\", source: \"Portrayal of Water\" }\r\n179 \"Demonic Howl\" Ability { id: \"282C\", source: \"Demon Chadarnook\" }\r\n187 \"Demonic Shear\" Ability { id: \"282A\", source: \"Demon Chadarnook\" }\r\n195 \"Demonic Spout\" Ability { id: \"2835\", source: \"Demon Chadarnook\" }\r\n200 \"Demonic Spout\" Ability { id: \"2837\", source: \"Demon Chadarnook\" }\r\n209 \"Release\" Ability { id: \"2804\", source: \"Demon Chadarnook\" }\r\n\r\n222 \"Possession\" Ability { id: \"2803\", source: \"Demon Chadarnook\" }\r\n227 \"Demonic Typhoon\" Ability { id: \"283D\", source: \"Demon Chadarnook\" }\r\n244 \"Demonic Howl\" Ability { id: \"282C\", source: \"Demon Chadarnook\" }\r\n245 \"Featherlance\" Ability { id: \"2AE8\", source: \"Easterly\" }\r\n253 \"Demonic Pain\" Ability { id: \"2AEB\", source: \"Demon Chadarnook\" }\r\n264 \"Flash Gale\" Ability { id: \"2842\", source: \"Demon Chadarnook\" }\r\n275 \"Release\" Ability { id: \"2804\", source: \"Demon Chadarnook\" }\r\n\r\n# loop starts here\r\n288 \"Possession\" Ability { id: \"2803\", source: \"Demon Chadarnook\" }\r\n293 \"Flash Fire\" Ability { id: \"280B\", source: \"Portrayal of Fire\" }\r\n299 \"Demonic Wave\" Ability { id: \"2831\", source: \"Portrayal of Water\" }\r\n308 \"Demonic Howl\" Ability { id: \"282C\", source: \"Demon Chadarnook\" }\r\n318 \"Demonic Spout\" Ability { id: \"2835\", source: \"Demon Chadarnook\" }\r\n323 \"Demonic Spout\" Ability { id: \"2837\", source: \"Demon Chadarnook\" }\r\n330 \"Demonic Shear\" Ability { id: \"282A\", source: \"Demon Chadarnook\" }\r\n341 \"Release\" Ability { id: \"2809\", source: \"Haunt\" }\r\n\r\n354 \"Possession\" Ability { id: \"2803\", source: \"Demon Chadarnook\" }\r\n359 \"Earthquake\" Ability { id: \"2811\", source: \"Portrayal of Earth\" }\r\n359 \"Flash Fire\" Ability { id: \"280B\", source: \"Portrayal of Fire\" }\r\n368 \"Materialize\" Ability { id: \"282D\", source: \"Demon Chadarnook\" }\r\n381 \"Demonic Stone\" Ability { id: \"2847\", source: \"Demon Chadarnook\" }\r\n384 \"Demonic Howl\" Ability { id: \"282C\", source: \"Demon Chadarnook\" }\r\n394 \"Demonic Shear\" Ability { id: \"282A\", source: \"Demon Chadarnook\" }\r\n404 \"Demonic Howl\" Ability { id: \"282C\", source: \"Demon Chadarnook\" }\r\n415 \"Release\" Ability { id: \"2804\", source: \"Demon Chadarnook\" }\r\n# loop ends here\r\n\r\n428 \"Possession\" Ability { id: \"2803\", source: \"Demon Chadarnook\" } jump 288\r\n433 \"Flash Fire\"\r\n439 \"Demonic Wave\"\r\n448 \"Demonic Howl\"\r\n455 \"Demonic Spout\"\r\n458 \"Demonic Spout\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o6s.ts



// O6S - Sigmascape 2.0 Savage
const o6s_triggerSet = {
  id: 'SigmascapeV20Savage',
  zoneId: zone_id/* default.SigmascapeV20Savage */.Z.SigmascapeV20Savage,
  timelineFile: 'o6s.txt',
  triggers: [{
    id: 'O6S Demonic Shear',
    type: 'StartsUsing',
    netRegex: {
      id: '2829',
      source: 'Demon Chadarnook'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O6S Storms Grip',
    type: 'AddedCombatant',
    netRegex: {
      name: 'The Storm\'s Grip',
      capture: false
    },
    condition: data => data.role === 'tank',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hallowed Wind Stack',
        de: 'Heiliger Boden Wind',
        fr: 'Packez-vous dans le vent',
        ja: '隅で頭割り',
        cn: '风分摊',
        ko: '쉐어징'
      }
    }
  }, {
    id: 'O6S Demonic Stone',
    type: 'HeadMarker',
    netRegex: {
      id: '0001'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Demonic Stone on YOU',
        de: 'Dämonischer Stein auf DIR',
        fr: 'Pierre démoniaque sur VOUS',
        ja: '自分にデモニックストーン',
        cn: '引导aoe',
        ko: '악령의 돌 장판 대상자'
      }
    }
  }, {
    id: 'O6S Last Kiss Tracker',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    run: (data, matches) => data.lastKiss = matches.target
  }, {
    id: 'O6S Last Kiss Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Last Kiss on YOU',
        de: 'Letzter Kuss auf DIR',
        fr: 'Baiser fatal sur VOUS',
        ja: '自分に口づけ',
        cn: '死亡之吻点名',
        ko: '죽음의 입맞춤 대상자'
      }
    }
  }, {
    id: 'O6S Last Kiss',
    type: 'GainsEffect',
    netRegex: {
      effectId: '5BF'
    },
    condition: (data, matches) => {
      // The person who gets the marker briefly gets the effect, so
      // don't tell them twice.
      return data.me === matches.target && data.lastKiss !== data.me;
    },
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Last Kiss on YOU',
        de: 'Letzter Kuss auf DIR',
        fr: 'Baiser fatal sur VOUS',
        ja: '自分に口づけ',
        cn: '死亡之吻点名',
        ko: '죽음의 입맞춤 대상자'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Demon Chadarnook': 'gefallen(?:e|er|es|en) Chadarnook',
      'Easterly': 'Ostwind',
      'Goddess Chadarnook': 'heilig(?:e|er|es|en) Chadarnook',
      'Haunt': 'Verfolgung',
      'I have claimed the girl in the picture!': 'Das Mädchen in diesem Bildnis gehört mir!',
      'Portrayal of Earth': 'Erdgemälde',
      'Portrayal of Fire': 'Feuergemälde',
      'Portrayal of Water': 'Wassergemälde',
      'Portrayal of Wind': 'Windgemälde',
      'The Storm\'s Grip': 'Sturmgebiet'
    },
    'replaceText': {
      'Demonic Howl': 'Dämonisches Heulen',
      'Demonic Pain': 'Dämonischer Schmerz',
      'Demonic Shear': 'Dämonische Schere',
      'Demonic Spout': 'Dämonischer Überschwang',
      'Demonic Stone': 'Dämonischer Stein',
      'Demonic Storm': 'Dämonischer Sturm',
      'Demonic Wave': 'Dämonische Welle',
      'Divine Lure': 'Göttliche Verlockung',
      'Earthquake': 'Erdbeben',
      'Easterlies': 'Ostwinde',
      'Featherlance': 'Federlanze',
      'Flash Fire': 'Blitzfeuer',
      'Flash Flood': 'Blitzregen',
      'Flash Gale': 'Blitzwind',
      'Flash Torrent': 'Blitzregen',
      'Last Kiss': 'Todeskuss',
      'Lullaby': 'Wiegenlied',
      'Materialize': 'Materialisierung',
      'Poltergeist': 'Poltergeist',
      'Possession': 'Besessenheit',
      'Release': 'Befreiung',
      'Rock Hard': 'Felsspalter',
      'The Price': 'Tödliche Versuchung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Demon Chadarnook': 'démon Chadarnouk',
      'Easterly': 'rafale ultime',
      'Goddess Chadarnook': 'déesse Chadarnouk',
      'Haunt': 'Cauchemar corporel',
      'I have claimed the girl in the picture!': 'Héhéhé... La fille du tableau m\'appartient.',
      'Portrayal of Earth': 'peinture de la terre',
      'Portrayal of Fire': 'peinture du feu',
      'Portrayal of Water': 'peinture de l\'eau',
      'Portrayal of Wind': 'peinture du vent',
      'The Storm\'s Grip': 'Zone de tempête'
    },
    'replaceText': {
      'Demonic Howl': 'Hurlement démoniaque',
      'Demonic Pain': 'Douleur démoniaque',
      'Demonic Shear': 'Cisailles démoniaques',
      'Demonic Spout': 'Vague démoniaque',
      'Demonic Stone': 'Pierre démoniaque',
      'Demonic Storm': 'Tempête démoniaque',
      'Demonic Wave': 'Vague démoniaque',
      'Divine Lure': 'Séduction divine',
      'Earthquake': 'Grand séisme',
      'Easterlies': 'Rafales ultimes',
      'Featherlance': 'Lance de plume',
      'Flash Fire': 'Flammes subites',
      'Flash Flood': 'Pluie subite',
      'Flash Gale': 'Vent subit',
      'Flash Torrent': 'Pluie subite',
      'Last Kiss': 'Baiser fatal',
      'Lullaby': 'Berceuse',
      'Materialize': 'Matérialisation',
      'Poltergeist': 'Esprit frappeur',
      'Possession': 'Possession',
      'Release': 'Libération',
      'Rock Hard': 'Brise-roc',
      'The Price': 'Tentation mortelle'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Demon Chadarnook': 'チャダルヌーク・デーモン',
      'Easterly': '極風',
      'Goddess Chadarnook': 'チャダルヌーク・ゴッデス',
      'Haunt': '思念体',
      'I have claimed the girl in the picture!': 'グフフフ……この絵の女は、わしがいただいた……。',
      'Portrayal of Earth': '土の絵画',
      'Portrayal of Fire': '火の絵画',
      'Portrayal of Water': '水の絵画',
      'Portrayal of Wind': '風の絵画',
      'The Storm\'s Grip': '暴風域'
    },
    'replaceText': {
      'Demonic Howl': 'デモニックハウル',
      'Demonic Pain': 'デモニックペイン',
      'Demonic Shear': 'デモニックシアー',
      'Demonic Spout': 'デモニックスパウト',
      'Demonic Stone': 'デモニックストーン',
      'Demonic Storm': 'デモニックストーム',
      'Demonic Wave': 'デモニックウェーブ',
      'Divine Lure': '女神の誘惑',
      'Earthquake': '大地震',
      'Easterlies': '極風',
      'Featherlance': 'フェザーランス',
      'Flash Fire': 'フラッシュファイア',
      'Flash Flood': 'フラッシュレイン',
      'Flash Gale': 'フラッシュウィンド',
      'Flash Torrent': 'フラッシュレイン',
      'Last Kiss': '死の口づけ',
      'Lullaby': '子守歌',
      'Materialize': '実体化',
      'Poltergeist': 'ポルターガイスト',
      'Possession': '絵画憑依',
      'Release': '憑依解除',
      'Rock Hard': 'ロッククラッシャー',
      'The Price': '死の誘い'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Demon Chadarnook': '恶魔查达奴克',
      'Easterly': '极风',
      'Goddess Chadarnook': '神圣查达奴克',
      'Haunt': '幻影',
      'I have claimed the girl in the picture!': '呵哼哼……这个画作的女人就归我了',
      'Portrayal of Earth': '土之画作',
      'Portrayal of Fire': '火之画作',
      'Portrayal of Water': '水之画作',
      'Portrayal of Wind': '风之画作',
      'The Storm\'s Grip': '暴风领域'
    },
    'replaceText': {
      'Demonic Howl': '恶魔啸',
      'Demonic Pain': '恶魔痛',
      'Demonic Shear': '恶魔斩',
      'Demonic Spout': '恶魔喷',
      'Demonic Stone': '恶魔飞石',
      'Demonic Storm': '恶魔风暴',
      'Demonic Wave': '恶魔波',
      'Divine Lure': '女神的诱惑',
      'Earthquake': '大地震',
      'Easterlies': '极风',
      'Featherlance': '羽枪',
      'Flash Fire': '闪光炎',
      'Flash Flood': '闪光雨',
      'Flash Gale': '闪光风',
      'Flash Torrent': '闪光雨',
      'Last Kiss': '死亡之吻',
      'Lullaby': '摇篮曲',
      'Materialize': '实体化',
      'Poltergeist': '骚灵',
      'Possession': '附身画像',
      'Release': '附身解除',
      'Rock Hard': '碎岩',
      'The Price': '死亡诱惑'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Demon Chadarnook': '차다르누크 악령',
      'Easterly': '극풍',
      'Goddess Chadarnook': '차다르누크 여신',
      'Haunt': '사념체',
      'I have claimed the girl in the picture!': '우후후후…… 그림 속 여자는 내가 데려가마……',
      'Portrayal of Earth': '땅의 그림',
      'Portrayal of Fire': '불의 그림',
      'Portrayal of Water': '물의 그림',
      'Portrayal of Wind': '바람의 그림',
      'The Storm\'s Grip': '폭풍 영역'
    },
    'replaceText': {
      'Demonic Howl': '악령의 외침',
      'Demonic Pain': '악령의 고통',
      'Demonic Shear': '악령의 참격',
      'Demonic Spout': '악령의 물기둥',
      'Demonic Stone': '악령의 돌',
      'Demonic Storm': '악령의 폭풍',
      'Demonic Wave': '악령의 물결',
      'Divine Lure': '여신의 유혹',
      'Earthquake': '대지진',
      'Easterlies': '극풍',
      'Featherlance': '깃털창',
      'Flash Fire': '불바다',
      'Flash Flood': '급류',
      'Flash Gale': '돌풍',
      'Flash Torrent': '급류',
      'Last Kiss': '죽음의 입맞춤',
      'Lullaby': '자장가',
      'Materialize': '실체화',
      'Poltergeist': '폴터가이스트',
      'Possession': '그림 빙의',
      'Release': '빙의 해제',
      'Rock Hard': '암석 분쇄',
      'The Price': '죽음의 유혹'
    }
  }]
};
/* harmony default export */ const o6s = (o6s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o6s.txt
const raid_o6s_namespaceObject = "# Omega - Sigmascape V2.0 (Savage) - O6S\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Note: Although there is a 18 sec. delay between the chatlog line and the boss being targetable\r\n# the player's InCombat status is changed at nearly the same time and can be reliably used to start the timeline.\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n18 \"--targetable--\"\r\n21 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" } window 21,0\r\n31 \"Demonic Shear\" Ability { id: \"2829\", source: \"Demon Chadarnook\" }\r\n\r\n57 \"Possession\" Ability { id: \"2803\", source: \"Demon Chadarnook\" } window 20,20\r\n62 \"Flash Fire\" Ability { id: \"280A\", source: \"Portrayal of Fire\" }\r\n71 \"Flash Gale\" Ability { id: \"2ABA\", source: \"Portrayal of Wind\" }\r\n73 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n87 \"Poltergeist\" Ability { id: \"2824\", source: \"Goddess Chadarnook\" }\r\n92 \"Demonic Shear\" Ability { id: \"2829\", source: \"Demon Chadarnook\" }\r\n98 \"Divine Lure\" Ability { id: \"2822\", source: \"Goddess Chadarnook\" }\r\n100 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n109 \"Demonic Pain\" Ability { id: \"2AEC\", source: \"Demon Chadarnook\" }\r\n121 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n130 \"Release\" Ability { id: \"2804\", source: \"Demon Chadarnook\" }\r\n\r\n143 \"Possession\" Ability { id: \"2803\", source: \"Demon Chadarnook\" } window 10,10\r\n150 \"Easterlies\" AddedCombatant { name: \"Easterly\" }\r\n153 \"Rock Hard\" Ability { id: \"2812\", source: \"Portrayal of Earth\" }\r\n155 \"Demonic Shear\" Ability { id: \"2829\", source: \"Demon Chadarnook\" }\r\n164 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n166 \"Featherlance\" Ability { id: \"283E\", source: \"Easterly\" }\r\n171 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n184 \"Last Kiss\" Ability { id: \"2826\", source: \"Demon Chadarnook\" }\r\n195 \"The Price\" Ability { id: \"2827\", source: \"Demon Chadarnook\" }\r\n198 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n200 \"Poltergeist\" Ability { id: \"2824\", source: \"Goddess Chadarnook\" }\r\n208 \"Demonic Shear\" Ability { id: \"2829\", source: \"Demon Chadarnook\" }\r\n211 \"Divine Lure\" Ability { id: \"2822\", source: \"Goddess Chadarnook\" }\r\n216 \"Demonic Storm\" Ability { id: \"2840\", source: \"Demon Chadarnook\" }\r\n225 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n238 \"Release\" Ability { id: \"2804\", source: \"Demon Chadarnook\" }\r\n\r\n251 \"Possession\" Ability { id: \"2803\", source: \"Demon Chadarnook\" } window 10,10\r\n256 \"Earthquake\" Ability { id: \"2810\", source: \"Portrayal of Earth\" }\r\n256 \"Flash Fire\" Ability { id: \"280A\", source: \"Portrayal of Fire\" }\r\n261 \"Flash Torrent\" Ability { id: \"2AB9\", source: \"Portrayal of Water\" }\r\n270 \"Materialize\" Ability { id: \"282D\", source: \"Demon Chadarnook\" }\r\n281 \"Demonic Pain\" Ability { id: \"2AEC\", source: \"Haunt\" }\r\n286 \"Lullaby\" Ability { id: \"2828\", source: \"Goddess Chadarnook\" }\r\n294 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n300 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n306 \"Demonic Shear\" Ability { id: \"2829\", source: \"Demon Chadarnook\" }\r\n319 \"Demonic Stone\" duration 5\r\n329 \"Last Kiss\" Ability { id: \"2826\", source: \"Demon Chadarnook\" }\r\n333 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n340 \"The Price\" Ability { id: \"2827\", source: \"Demon Chadarnook\" }\r\n352 \"Release\" Ability { id: \"2804\", source: \"Demon Chadarnook\" }\r\n\r\n365 \"Possession\" Ability { id: \"2803\", source: \"Demon Chadarnook\" } window 10,10\r\n373 \"Easterlies\" AddedCombatant { name: \"Easterly\" }\r\n375 \"Rock Hard\" Ability { id: \"2812\", source: \"Portrayal of Earth\" }\r\n376 \"Demonic Wave\" Ability { id: \"2830\", source: \"Portrayal of Water\" }\r\n384 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n388 \"Featherlance\" Ability { id: \"283E\", source: \"Easterly\" }\r\n396 \"Materialize\" Ability { id: \"282D\", source: \"Demon Chadarnook\" }\r\n403 \"Demonic Spout\" Ability { id: \"2834\", source: \"Demon Chadarnook\" }\r\n408 \"Demonic Storm\" Ability { id: \"2840\", source: \"Demon Chadarnook\" }\r\n408 \"Demonic Spout\" Ability { id: \"2836\", source: \"Demon Chadarnook\" }\r\n425 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n438 \"Demonic Pain\" Ability { id: \"2AEC\", source: \"Demon Chadarnook\" }\r\n443 \"Last Kiss\" Ability { id: \"2826\", source: \"Demon Chadarnook\" }\r\n447 \"Flash Torrent\" Ability { id: \"280C\", source: \"Demon Chadarnook\" }\r\n449 \"Flash Flood\" Ability { id: \"2AEA\", source: \"Haunt\" }\r\n454 \"The Price\" Ability { id: \"2827\", source: \"Demon Chadarnook\" }\r\n454 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n469 \"Demonic Shear\" Ability { id: \"2829\", source: \"Demon Chadarnook\" }\r\n482 \"Release\" Ability { id: \"2804\", source: \"Demon Chadarnook\" }\r\n\r\n495 \"Possession\" Ability { id: \"2803\", source: \"Demon Chadarnook\" } window 10,10\r\n500 \"Earthquake\" Ability { id: \"2810\", source: \"Portrayal of Earth\" }\r\n500 \"Flash Fire\" Ability { id: \"280A\", source: \"Portrayal of Fire\" }\r\n509 \"Flash Gale\" Ability { id: \"2ABA\", source: \"Portrayal of Wind\" }\r\n511 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n519 \"Demonic Shear\" Ability { id: \"2829\", source: \"Demon Chadarnook\" }\r\n531 \"Materialize\" Ability { id: \"282D\", source: \"Demon Chadarnook\" }\r\n538 \"Poltergeist\" Ability { id: \"2824\", source: \"Goddess Chadarnook\" }\r\n546 \"Demonic Stone\" duration 5\r\n552 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n554 \"Divine Lure\" Ability { id: \"2822\", source: \"Goddess Chadarnook\" }\r\n560 \"Demonic Shear\" Ability { id: \"2829\", source: \"Demon Chadarnook\" }\r\n573 \"Demonic Pain\" Ability { id: \"2AEC\", source: \"Demon Chadarnook\" }\r\n581 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n590 \"Release\" Ability { id: \"2804\", source: \"Demon Chadarnook\" }\r\n\r\n603 \"Possession\" Ability { id: \"2803\", source: \"Demon Chadarnook\" } window 10,10\r\n611 \"Easterlies\" AddedCombatant { name: \"Easterly\" }\r\n613 \"Rock Hard\" Ability { id: \"2812\", source: \"Portrayal of Earth\" }\r\n614 \"Demonic Wave\" Ability { id: \"2830\", source: \"Portrayal of Water\" }\r\n622 \"Demonic Howl\" Ability { id: \"282B\", source: \"Demon Chadarnook\" }\r\n626 \"Featherlance\" Ability { id: \"283E\", source: \"Easterly\" }\r\n\r\n626 \"--sync--\" StartsUsing { id: \"284D\", source: \"Demon Chadarnook\" }\r\n641 \"Enrage\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o7n.ts



// TODO: kill adds from failed Demon Simulation?

// O7N - Sigmascape 3.0 Normal
const o7n_triggerSet = {
  id: 'SigmascapeV30',
  zoneId: zone_id/* default.SigmascapeV30 */.Z.SigmascapeV30,
  timelineFile: 'o7n.txt',
  timelineTriggers: [{
    id: 'O7N Chakra Burst Towers',
    regex: /Chakra Burst/,
    beforeSeconds: 9,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 하나씩 들어가기'
      }
    }
  }],
  triggers: [{
    id: 'O7N Diffractive Plasma',
    type: 'StartsUsing',
    netRegex: {
      id: '276E',
      source: 'Guardian',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O7N Magitek Ray',
    type: 'StartsUsing',
    netRegex: {
      id: '276B',
      source: 'Guardian',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'O7N Arm And Hammer',
    type: 'StartsUsing',
    netRegex: {
      id: '276C',
      source: 'Guardian'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O7N Shockwave',
    type: 'StartsUsing',
    netRegex: {
      id: '2766',
      source: 'Guardian',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'O7N Diffractive Laser',
    type: 'GainsEffect',
    // Air Force Simulation effect happens ~3 seconds before Diffractive Laser (2761) starts casting.
    netRegex: {
      effectId: '5D2',
      capture: false
    },
    // All of the various hidden Guardian adds all get this effect.
    suppressSeconds: 5,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'O7N Prey',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    response: responses/* Responses.preyOn */.n3.preyOn('info')
  }, {
    id: 'O7N Bomb Deployment',
    type: 'StartsUsing',
    netRegex: {
      id: '2762',
      source: 'Guardian',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in glowing bomb circle',
        de: 'Steh im grün-leuchtenden Kreis der Bombe',
        fr: 'Placez-vous dans le cercle lumineux',
        cn: '站在炸弹发光圈内',
        ko: '장판에 한명씩 들어가기'
      }
    }
  }, {
    id: 'O7N Demon Simulation',
    type: 'StartsUsing',
    netRegex: {
      id: '2752',
      source: 'Guardian',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Activate 3 person towers',
        de: 'Aktiviere 3 Spieler-Türme',
        fr: 'Activez les tours avec 3 personnes',
        cn: '3人踩塔',
        ko: '3인장판 처리하기'
      }
    }
  }, {
    id: 'O7N Kill Phase Adds',
    type: 'AddedCombatant',
    // 7018 = Air Force
    // 7110 = Dadaluma
    // 7111 = Ultros
    // 7113 = Bibliotaph
    netRegex: {
      npcNameId: ['7018', '7110', '7111', '7113']
    },
    infoText: (_data, matches, output) => {
      return output.kill({
        name: matches.name
      });
    },
    outputStrings: {
      kill: {
        en: 'Kill ${name} add',
        de: 'Besiege ${name} Add',
        fr: 'Tuez l\'add ${name}',
        cn: '击杀 ${name} 小怪',
        ko: '${name} 처치'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Air Force': 'Luftwaffe',
      'Bibliotaph': 'Bibliotaph',
      'Dadaluma': 'Dadarma',
      'Guardian': 'Wächter',
      'Tentacle': 'Tentakel',
      'Ultros': 'Ultros',
      'WEAPON SYSTEMS ONLINE': 'Feuerkontrollsystem aktiviert'
    },
    'replaceText': {
      'Arm And Hammer': 'Arm-Hammer',
      'Aura Cannon': 'Aura-Kanone',
      'Bomb Deployment': 'Bombeneinsatz',
      'Burst/Darkness': 'Burst/Dunkelheit',
      'Chain Cannon': 'Kettenkanone',
      'Chakra Burst': 'Chakra-Ausbruch',
      'Demon Simulation': 'Dämonensimulation',
      'Diffractive Laser': 'Diffusionslaser',
      'Diffractive Plasma': 'Diffusionsplasma',
      'Ink': 'Tinte',
      'Load': 'Laden',
      'Magitek Ray': 'Magitek-Laser',
      'Main Cannon': 'Hauptkanone',
      'Missile Simulation': 'Raketensimulation',
      'Plane Laser': 'Luftwaffe Add Laser',
      'Prey': 'Beute',
      'Run Program': 'Programm starten',
      'Shockwave': 'Schockwelle',
      'Tentacle Simulation': 'Tentakelsimulation',
      'Tentacle(?! )': 'Tentakel',
      'Wallop': 'Tentakelklatsche'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Air Force': 'force aérienne',
      'Bibliotaph': 'bibliotaphe',
      'Dadaluma': 'Dadaluma',
      'Guardian': 'gardien',
      'Tentacle': 'Tentacule',
      'Ultros': 'Orthros',
      'WEAPON SYSTEMS ONLINE': 'Démarrage du système de contrôle'
    },
    'replaceText': {
      'Arm And Hammer': 'Marteau stratégique',
      'Aura Cannon': 'Rayon d\'aura',
      'Bomb Deployment': 'Déploiement de bombes',
      'Burst/Darkness': 'Explosion/Aura',
      'Chain Cannon': 'Canon automatique',
      'Chakra Burst': 'Explosion d\'aura',
      'Demon Simulation': 'Chargement : démon',
      'Diffractive Laser': 'Laser diffracteur',
      'Diffractive Plasma': 'Plasma diffracteur',
      'Ink': 'Encre',
      'Load': 'Chargement',
      'Magitek Ray': 'Rayon magitek',
      'Main Cannon': 'Canon principal',
      'Missile Simulation': 'Chargement : missiles',
      'Plane Laser': 'Laser d\'avion',
      'Prey': 'Proie',
      'Run Program': 'Programme de matérialisation',
      'Shockwave': 'Onde de choc',
      'Tentacle Simulation': 'Chargement : tentacule',
      'Tentacle(?! )': 'Tentacule',
      'Wallop': 'Taloche tentaculaire'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Air Force': 'エアフォース',
      'Bibliotaph': 'ビブリオタフ',
      'Dadaluma': 'ダダルマー',
      'Guardian': 'ガーディアン',
      'Tentacle': 'たこあし',
      'Ultros': 'オルトロス',
      'WEAPON SYSTEMS ONLINE': 'ファイアコントロールシステム起動'
    },
    'replaceText': {
      'Arm And Hammer': 'アームハンマー',
      'Aura Cannon': 'オーラキャノン',
      'Bomb Deployment': '爆弾設置',
      'Burst/Darkness': 'バースト/ダークネス',
      'Chain Cannon': 'チェーンガン',
      'Chakra Burst': 'チャクラバースト',
      'Demon Simulation': 'ローディング：デーモン',
      'Diffractive Laser': '拡散レーザー',
      'Diffractive Plasma': '拡散プラズマ',
      'Ink': '墨',
      'Load': 'ローディング',
      'Magitek Ray': '魔導レーザー',
      'Main Cannon': 'メインカノン',
      'Missile Simulation': 'ローディング：ミサイル',
      'Plane Laser': 'エアフォース レザー',
      'Prey': 'プレイ',
      'Run Program': '実体化プログラム',
      'Shockwave': '衝撃波',
      'Tentacle Simulation': 'ローディング：たこあし',
      'Tentacle(?! )': 'たこあし',
      'Wallop': '叩きつけ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Air Force': '空军装甲',
      'Bibliotaph': '永世珍本',
      'Dadaluma': '达达鲁玛',
      'Guardian': '守护者',
      'Tentacle': '腕足',
      'Ultros': '奥尔特罗斯',
      'WEAPON SYSTEMS ONLINE': '武器火控系统启动'
    },
    'replaceText': {
      'Arm And Hammer': '臂锤',
      'Aura Cannon': '斗气炮',
      'Bomb Deployment': '设置炸弹',
      'Burst/Darkness': '脉轮爆发/黑暗',
      'Chain Cannon': '链式机关炮',
      'Chakra Burst': '脉轮爆发',
      'Demon Simulation': '加载恶魔模拟程序',
      'Diffractive Laser': '扩散射线',
      'Diffractive Plasma': '扩散离子',
      'Ink': '墨汁',
      'Load': '加载',
      'Magitek Ray': '魔导激光',
      'Main Cannon': '主加农炮',
      'Missile Simulation': '加载导弹模拟程序',
      'Plane Laser': '平面激光',
      'Prey': '猎物',
      'Run Program': '实体化程序',
      'Shockwave': '冲击波',
      'Tentacle Simulation': '加载腕足模拟程序',
      'Tentacle(?! )': '触手(?! )',
      'Wallop': '敲击'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Air Force': '에어포스',
      'Bibliotaph': '비블리오타프',
      'Dadaluma': '다다루마',
      'Guardian': '가디언',
      'Tentacle': '문어발',
      'Ultros': '오르트로스',
      'WEAPON SYSTEMS ONLINE': '병기 제어 시스템 기동……'
    },
    'replaceText': {
      'Arm And Hammer': '양팔 내리치기',
      'Aura Cannon': '오라 포격',
      'Bomb Deployment': '폭탄 설치',
      'Burst/Darkness': '마법작렬/보이드',
      'Chain Cannon': '기관총',
      'Chakra Burst': '차크라 폭발',
      'Demon Simulation': '불러오기: 악마',
      'Diffractive Laser': '확산 레이저',
      'Diffractive Plasma': '확산 플라스마',
      'Ink': '먹물',
      'Load': '불러오기',
      'Magitek Ray': '마도 레이저',
      'Main Cannon': '주포',
      'Missile Simulation': '불러오기: 미사일',
      'Plane Laser': '에어포스 레이저',
      'Prey': '표식',
      'Run Program': '실체화 프로그램',
      'Shockwave': '충격파',
      'Tentacle Simulation': '불러오기: 문어발',
      'Tentacle(?! )': '문어발',
      'Wallop': '매질'
    }
  }]
};
/* harmony default export */ const o7n = (o7n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o7n.txt
const raid_o7n_namespaceObject = "# Omega - Sigmascape V3.0 - O7N\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11 \"Magitek Ray\" Ability { id: \"276B\", source: \"Guardian\" } window 11,10\r\n21 \"Arm And Hammer\" Ability { id: \"276C\", source: \"Guardian\" }\r\n31 \"Prey\" Ability { id: \"276D\", source: \"Guardian\" }\r\n39 \"Load\" Ability { id: \"275C\", source: \"Guardian\" }\r\n\r\n# Ultros\r\n200 \"--sync--\" GainsEffect { effectId: \"5D1\", effect: \"Ultros Simulation\", target: \"Guardian\" } window 2000,2000\r\n203 \"Ink\" Ability { id: \"275D\", source: \"Guardian\" }\r\n209 \"Diffractive Plasma\" Ability { id: \"276E\", source: \"Guardian\" }\r\n219 \"Tentacle Simulation\" Ability { id: \"275E\", source: \"Guardian\" }\r\n223 \"Tentacle\" Ability { id: \"275F\", source: \"Tentacle\" }\r\n229 \"Wallop\" Ability { id: \"2760\", source: \"Tentacle\" }\r\n231 \"Run Program\" Ability { id: \"276F\", source: \"Guardian\" }\r\n237 \"--untargetable--\" Ability { id: \"2937\", source: \"Guardian\" }\r\n244 \"Chain Cannon\" duration 2\r\n250 \"Main Cannon\" Ability { id: \"2771\", source: \"Guardian\" }\r\n253 \"--targetable--\" Ability { id: \"2938\", source: \"Guardian\" }\r\n260 \"Diffractive Plasma\" Ability { id: \"276E\", source: \"Guardian\" }\r\n266 \"Magitek Ray\" Ability { id: \"276B\", source: \"Guardian\" } # drift 0.35\r\n275 \"Arm And Hammer\" Ability { id: \"276C\", source: \"Guardian\" }\r\n284 \"Load\" Ability { id: \"275C\", source: \"Guardian\" }\r\n\r\n# Dadaluma\r\n400 \"--sync--\" GainsEffect { effectId: \"5D3\", effect: \"Dadaluma Simulation\", target: \"Guardian\" } window 2000,2000\r\n404 \"Shockwave\" Ability { id: \"2766\", source: \"Guardian\" }\r\n415 \"--sync--\" Ability { id: \"276B\", source: \"Guardian\" } jump 1215 # rare version\r\n424 \"Chakra Burst\" Ability { id: \"276A\", source: \"Guardian\" }\r\n427 \"Run Program\" Ability { id: \"276F\", source: \"Guardian\" }\r\n436 \"Aura Cannon\"\r\n441 \"Prey\" Ability { id: \"276D\", source: \"Guardian\" }\r\n449 \"Magitek Ray\" Ability { id: \"276B\", source: \"Guardian\" }\r\n460 \"Load\" Ability { id: \"275C\", source: \"Guardian\" }\r\n\r\n# Air Force\r\n600 \"--sync--\" GainsEffect { effectId: \"5D2\", effect: \"Air Force Simulation\", target: \"Guardian\" } window 2000,2000\r\n604 \"Diffractive Laser\" Ability { id: \"2761\", source: \"Guardian\" }\r\n613 \"Missile Simulation\" Ability { id: \"2764\", source: \"Guardian\" }\r\n614 \"--sync--\" Ability { id: \"276F\", source: \"Guardian\" } jump 1014 # rare version\r\n623 \"Diffractive Plasma\" Ability { id: \"276E\", source: \"Guardian\" }\r\n637 \"Bomb Deployment\" Ability { id: \"2762\", source: \"Guardian\" }\r\n648 \"Arm And Hammer\" Ability { id: \"276C\", source: \"Guardian\" }\r\n659 \"Run Program\" Ability { id: \"276F\", source: \"Guardian\" }\r\n672 \"Prey\" Ability { id: \"276D\", source: \"Guardian\" }\r\n678 \"Plane Laser\"\r\n682 \"Diffractive Plasma\" Ability { id: \"276E\", source: \"Guardian\" }\r\n688 \"Load\" Ability { id: \"275C\", source: \"Guardian\" }\r\n\r\n# Bibliotaph\r\n800 \"--sync--\" GainsEffect { effectId: \"5D4\", effect: \"Bibliotaph Simulation\", target: \"Guardian\" } window 2000,2000\r\n817 \"Demon Simulation\" Ability { id: \"2752\", source: \"Guardian\" }\r\n824 \"Run Program\" Ability { id: \"276F\", source: \"Guardian\" }\r\n838 \"Burst/Darkness\" Ability { id: \"29(BF|C0)\", source: \"Bibliotaph\" }\r\n840 \"Magitek Ray\" Ability { id: \"276B\", source: \"Guardian\" }\r\n851 \"Arm And Hammer\" Ability { id: \"276C\", source: \"Guardian\" }\r\n860 \"Diffractive Plasma\" Ability { id: \"276E\", source: \"Guardian\" }\r\n870 \"Load\" Ability { id: \"275C\", source: \"Guardian\" }\r\n\r\n# Air Force later\r\n1000 \"--sync--\"\r\n1004 \"Diffractive Laser\" Ability { id: \"2761\", source: \"Guardian\" }\r\n1014 \"Run Program\" Ability { id: \"276F\", source: \"Guardian\" }\r\n1033 \"Missile Simulation\" Ability { id: \"2764\", source: \"Guardian\" }\r\n1034 \"Plane Laser\"\r\n1036 \"--untargetable--\" Ability { id: \"2937\", source: \"Guardian\" }\r\n1043 \"Chain Cannon\" duration 2\r\n1049 \"Main Cannon\" Ability { id: \"2771\", source: \"Guardian\" }\r\n1052 \"--targetable--\" Ability { id: \"2938\", source: \"Guardian\" }\r\n1062 \"Bomb Deployment\" Ability { id: \"2762\", source: \"Guardian\" }\r\n1085 \"Load\" Ability { id: \"275C\", source: \"Guardian\" }\r\n\r\n# Dadaluma later\r\n1200 \"--sync--\"\r\n1204 \"Shockwave\" Ability { id: \"2766\", source: \"Guardian\" }\r\n1215 \"Magitek Ray\" Ability { id: \"276B\", source: \"Guardian\" }\r\n1224 \"Chakra Burst\" Ability { id: \"276A\", source: \"Guardian\" }\r\n1227 \"Magitek Ray\" Ability { id: \"276B\", source: \"Guardian\" }\r\n1238 \"Diffractive Plasma\" Ability { id: \"276E\", source: \"Guardian\" }\r\n1246 \"Prey\" Ability { id: \"276D\", source: \"Guardian\" }\r\n1254 \"Arm And Hammer\" Ability { id: \"276C\", source: \"Guardian\" }\r\n1266 \"Load\" Ability { id: \"275C\", source: \"Guardian\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o7s.ts



// O7S - Sigmascape 3.0 Savage
const o7s_triggerSet = {
  id: 'SigmascapeV30Savage',
  zoneId: zone_id/* default.SigmascapeV30Savage */.Z.SigmascapeV30Savage,
  timelineFile: 'o7s.txt',
  triggers: [
  // State
  {
    id: 'O7S Aether Rot Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '5C3'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.rot = true
  }, {
    id: 'O7S Aether Rot Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '5C3'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.rot = false
  }, {
    id: 'O7S Dadaluma Simulation',
    type: 'GainsEffect',
    netRegex: {
      target: 'Guardian',
      effectId: '5D3',
      capture: false
    },
    condition: data => !data.first || data.seenVirus && !data.second,
    run: data => {
      if (data.seenVirus) data.second = 'dada';else data.first = 'dada';
    }
  }, {
    id: 'O7S Bibliotaph Simulation',
    type: 'GainsEffect',
    netRegex: {
      target: 'Guardian',
      effectId: '5D4',
      capture: false
    },
    condition: data => !data.first || data.seenVirus && !data.second,
    run: data => {
      if (data.seenVirus) data.second = 'biblio';else data.first = 'biblio';
    }
  }, {
    id: 'O7S Virus Tracker',
    type: 'GainsEffect',
    netRegex: {
      target: 'Guardian',
      effectId: '5D5',
      capture: false
    },
    run: data => data.seenVirus = true
  }, {
    id: 'O7S Magitek Ray',
    type: 'StartsUsing',
    netRegex: {
      id: '2788',
      source: 'Guardian',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Magitek Ray',
        de: 'Magitek-Laser',
        fr: 'Rayon Magitek',
        ja: '魔導レーザー',
        cn: '直线AOE',
        ko: '마도 레이저'
      }
    }
  }, {
    id: 'O7S Arm And Hammer',
    type: 'StartsUsing',
    netRegex: {
      id: '2789',
      source: 'Guardian'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O7S Orb Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Orb Marker',
        de: 'Orb Marker',
        fr: 'Orbe',
        ja: 'マーカー',
        cn: '死刑点名',
        ko: '원자 파동 징'
      }
    }
  }, {
    id: 'O7S Blue Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '000E'
    },
    alarmText: (data, matches, output) => {
      if (data.me !== matches.target) return;
      return output.blueMarkerOnYou();
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return;
      return output.blueMarkerOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      blueMarkerOn: {
        en: 'Blue Marker on ${player}',
        de: 'Aura-Kanone auf ${player}',
        fr: 'Marque Bleue sur ${player}',
        ja: '${player}に青玉',
        cn: '蓝球点名${player}',
        ko: '"${player}" 파란징'
      },
      blueMarkerOnYou: {
        en: 'Blue Marker on YOU',
        de: 'Aura-Kanone auf DIR',
        fr: 'Marque Bleue sur VOUS',
        ja: '自分に青玉',
        cn: '蓝球点名',
        ko: '파란징 대상자'
      }
    }
  }, {
    id: 'O7S Prey',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    response: responses/* Responses.preyOn */.n3.preyOn('info')
  }, {
    id: 'O7S Searing Wind',
    type: 'GainsEffect',
    netRegex: {
      effectId: '178'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'O7S Abandonment',
    type: 'GainsEffect',
    netRegex: {
      effectId: '58A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Abandonment: stay middle',
        de: 'Verlassen: Bleib mittig',
        fr: 'Isolement : restez au milieu',
        ja: '孤独: 内側へ',
        cn: '呆在中间',
        ko: '고독감: 중앙에 있기'
      }
    }
  }, {
    // Aether Rot
    id: 'O7S Rot',
    type: 'GainsEffect',
    netRegex: {
      effectId: '5C3'
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.rotOnYou();
      return output.rotOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      rotOnYou: {
        en: 'Rot on you',
        de: 'Fäule auf DIR',
        fr: 'Pourriture sur VOUS',
        ja: '自分にロット',
        cn: '以太病毒点名',
        ko: '에테르 대상자'
      },
      rotOn: {
        en: 'Rot on ${player}',
        de: 'Fäule auf ${player}',
        fr: 'Pourriture sur ${player}',
        ja: '${player}にロット',
        cn: '以太病毒点名${player}',
        ko: '"${player}" 에테르'
      }
    }
  }, {
    id: 'O7S Stoneskin',
    type: 'StartsUsing',
    netRegex: {
      id: '2AB5',
      source: 'Ultros'
    },
    response: responses/* Responses.interrupt */.n3.interrupt('alarm')
  }, {
    id: 'O7S Load',
    type: 'StartsUsing',
    // Load: 275C
    // Skip: 2773
    // Retrieve: 2774
    // Paste: 2776
    netRegex: {
      id: ['275C', '2773', '2774', '2776'],
      source: 'Guardian',
      capture: false
    },
    alertText: (data, _matches, output) => {
      data.loadCount = (data.loadCount ?? 0) + 1;
      if (data.loadCount === 1) {
        // First load is unknown.
        return output.screen();
      } else if (data.loadCount === 2) {
        return data.first === 'biblio' ? output.dada() : output.biblio();
      } else if (data.loadCount === 3) {
        return data.first === 'biblio' ? output.ultros() : output.ships();
      } else if (data.loadCount === 4) {
        return data.first === 'biblio' ? output.ships() : output.ultros();
      } else if (data.loadCount === 5) {
        return output.virus();
      } else if (data.loadCount === 6) {
        return data.first === 'biblio' ? output.ultros() : output.ships();
      } else if (data.loadCount === 7) {
        // This is the post-virus Load/Skip divergence.
        return output.screen();
      } else if (data.loadCount === 8) {
        return data.first === 'biblio' ? output.dada() : output.biblio();
      } else if (data.loadCount === 9) {
        return data.first === 'biblio' ? output.ships() : output.ultros();
      }
      console.error(`Unknown load: ${data.loadCount}`);
    },
    outputStrings: {
      screen: {
        en: 'Biblio?/Knockback?',
        de: 'Biblio?/Rückstoß?',
        fr: 'Biblio ?/Poussée ?',
        ja: 'ビブリオタフ?/ノックバック?',
        cn: '图书？/击退？',
        ko: '비블리오?/넉백?'
      },
      biblio: {
        en: 'Biblio: Positions',
        de: 'Biblio: Positionen',
        fr: 'Biblio : Positions',
        ja: 'ビブリオタフ: 定めた位置へ',
        cn: '图书：站位',
        ko: '비블리오: 지정 위치로'
      },
      dada: {
        en: 'Dada: Knockback',
        de: 'Dada: Rückstoß',
        fr: 'Dada : Poussée',
        ja: 'ダダルマー: ノックバック',
        cn: '达达：击退',
        ko: '다다루마: 넉백'
      },
      ships: {
        en: 'Ships: Out of Melee',
        de: 'Flieger: Raus aus Nahkampf-Reichweite',
        fr: 'Vaisseaux : Sortez de la mêlée',
        ja: 'エアフォース: 離れる',
        cn: '飞机：远离近战范围',
        ko: '에어포스: 근접 범위 밖으로'
      },
      ultros: {
        en: 'Ultros: Ink Spread',
        de: 'Ultros: Tine - Verteilen',
        fr: 'Orthros : Encre, dispersez-vous',
        ja: 'オルトロス: インク 散開',
        cn: '章鱼：墨汁快散开',
        ko: '오르트로스: 먹물 산개'
      },
      virus: {
        en: 'VIRUS',
        de: 'VIRUS',
        fr: 'VIRUS',
        ja: 'ウイルス',
        cn: '病毒',
        ko: '바이러스'
      }
    }
  }, {
    id: 'O7S Run',
    type: 'StartsUsing',
    netRegex: {
      id: '276F',
      source: 'Guardian',
      capture: false
    },
    infoText: (data, _matches, output) => {
      data.runCount = (data.runCount ?? 0) + 1;
      if (data.runCount === 1) return output.dada();else if (data.runCount === 2) return data.first === 'biblio' ? output.ultros() : output.ships();else if (data.runCount === 3) return data.first === 'biblio' ? output.ships() : output.ultros();else if (data.runCount === 4) return data.first === 'biblio' ? output.ultros() : output.ships();else if (data.runCount === 5) return output.biblio();else if (data.runCount === 6) return data.first === 'biblio' ? output.ships() : output.ultros();
    },
    outputStrings: {
      biblio: {
        en: 'Biblio Add',
        de: 'Biblio Add',
        fr: 'Add Biblio',
        ja: '雑魚: ビブリオタフ',
        cn: '图书出现',
        ko: '비블리오 등장'
      },
      dada: {
        en: 'Dada Add',
        de: 'Dada Add',
        fr: 'Add Dada',
        ja: '雑魚: ダダルマー',
        cn: '达达出现',
        ko: '다다루마 등장'
      },
      ships: {
        en: 'Ship Add',
        de: 'Flieger Add',
        fr: 'Add Vaisseau',
        ja: '雑魚: エアフォース',
        cn: '飞机出现',
        ko: '에어포스 등장'
      },
      ultros: {
        en: 'Ultros Add',
        de: 'Ultros Add',
        fr: 'Add Orthros',
        ja: '雑魚: オルトロス',
        cn: '章鱼出现',
        ko: '오르트로스 등장'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Fire Control System': 'Feuerleitsystem',
      'Guardian': 'Wächter',
      'Ultros': 'Ultros',
      'WEAPON SYSTEMS ONLINE': 'Feuerkontrollsystem aktiviert'
    },
    'replaceText': {
      'Aether Rot': 'Ätherfäule',
      'Arm And Hammer': 'Arm-Hammer',
      'Atomic Ray': 'Atomstrahlung',
      'Aura Cannon': 'Aura-Kanone',
      'Biblio': 'Bibliotaph',
      'Bomb Deployment': 'Bombeneinsatz',
      'Chain Cannon': 'Kettenkanone',
      'Chakra Burst': 'Chakra-Ausbruch',
      'Copy(?! Program)': 'Kopieren:',
      'Dada': 'Dadarma',
      'Demon Simulation': 'Dämonensimulation',
      'Diffractive Laser': 'Diffusionslaser',
      'Diffractive Plasma': 'Diffusionsplasma',
      'Ink': 'Tinte',
      'Interrupt Stoneskin': 'Steinhaut unterbrechen',
      'Load': 'Laden:',
      'Magitek Ray': 'Magitek-Laser',
      'Magnetism': 'Magnetismus',
      'Main Cannon': 'Hauptkanone',
      'Missile Simulation': 'Raketensimulation',
      'Paste(?! Program)': 'Einfügen:',
      'Plane Laser': 'Luftwaffe Add Laser',
      'Prey': 'Beute',
      'Radar': 'Radar',
      'Repel': 'Abstoßung',
      'Run(?! Program)': 'Start:',
      'Shockwave': 'Schockwelle',
      'Skip(?! Program)': 'Überspringen:',
      'Temporary Misdirection': 'Plötzliche Panik',
      'Tentacle(?! )': 'Tentakel',
      'Tentacle Simulation': 'Tentakelsimulation',
      'Viral Weapon': 'Panikvirus',
      '(?<!\\w)Virus': 'Virus',
      'Wallop': 'Tentakelklatsche',
      'Air Force': 'Luftwaffe',
      'Ultros': 'Ultros',
      'Retrieve': 'Wiederherstellen:'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Dadaluma': 'Dadaluma',
      'Fire Control System': 'système de contrôle',
      'Guardian': 'gardien',
      'Ultros': 'Orthros',
      'WEAPON SYSTEMS ONLINE': 'Démarrage du système de contrôle'
    },
    'replaceText': {
      '\\?': ' ?',
      'Aether Rot': 'Pourriture éthéréenne',
      'Air Force': 'Force aérienne',
      'Arm And Hammer': 'Marteau stratégique',
      'Atomic Ray': 'Rayon atomique',
      'Aura Cannon': 'Rayon d\'aura',
      'Biblio': 'Bibliotaphe',
      'Bomb Deployment': 'Déploiement de bombes',
      'Chain Cannon': 'Canon automatique',
      'Chakra Burst': 'Explosion d\'aura',
      'Copy': 'Copie',
      'Dada': 'Dadaluma',
      'Demon Simulation': 'Chargement : démon',
      'Diffractive Laser': 'Laser diffracteur',
      'Diffractive Plasma': 'Plasma diffracteur',
      'Ink': 'Encre',
      'Interrupt Stoneskin': 'Interrompre Cuirasse',
      'Load': 'Chargement',
      'Magitek Ray': 'Rayon magitek',
      'Magnetism': 'Magnétisme',
      'Main Cannon': 'Canon principal',
      'Missile Simulation': 'Chargement : missiles',
      'Paste': 'Collage',
      'Plane Laser': 'Laser force aérienne',
      'Prey': 'Proie',
      'Radar': 'Radar',
      'Repel': 'Répulsion',
      'Retrieve': 'Programme Précédent',
      'Run': 'Programme',
      'Shockwave': 'Onde de choc',
      'Skip': 'Saut',
      'Temporary Misdirection': 'Démence',
      'Tentacle(?! Simulation)': 'Tentacule',
      'Tentacle Simulation': 'Chargement : tentacule',
      'Ultros': 'Orthros',
      'Viral Weapon': 'Arme virologique',
      '(?<!\\w)Virus': 'Virus',
      'Wallop': 'Taloche tentaculaire'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bibliotaph Simulation': 'ビブリオタフ・プログラム',
      'Dadaluma Simulation': 'ダダルマー・プログラム',
      'Fire Control System': 'ファイアコントロールシステム',
      'Guardian': 'ガーディアン',
      'Ultros': 'オルトロス',
      'WEAPON SYSTEMS ONLINE': 'ファイアコントロールシステム起動'
    },
    'replaceText': {
      '\\(H\\)': '(ヒラ)',
      'Aether Rot': 'エーテルロット',
      'Air Force': 'エアフォース',
      'Arm And Hammer': 'アームハンマー',
      'Atomic Ray': 'アトミックレイ',
      'Aura Cannon': 'オーラキャノン',
      'Biblio': 'ビブリオタフ',
      'Bomb Deployment': '爆弾設置',
      'Chain Cannon': 'チェーンガン',
      'Chakra Burst': 'チャクラバースト',
      'Copy(?! Program)': 'コピー',
      'Dada': 'ダダルマー',
      'Demon Simulation': 'ローディング：デーモン',
      'Diffractive Laser': '拡散レーザー',
      'Diffractive Plasma': '拡散プラズマ',
      'Ink': '墨',
      'Interrupt Stoneskin': '沈黙: ストーンスキン',
      'Load': 'ローディング',
      'Magitek Ray': '魔導レーザー',
      'Magnetism': '磁力',
      'Main Cannon': 'メインカノン',
      'Missile Simulation': 'ローディング：ミサイル',
      'Paste(?! Program)': 'ペースト',
      'Plane Laser': 'エアフォース レザー',
      'Prey': 'プレイ',
      'Radar': 'レイダー',
      'Repel': '反発',
      'Retrieve': 'リバース',
      'Run(?! Program)': '実体化',
      'Shockwave': '衝撃波',
      'Skip(?! Program)': 'スキップ',
      'Temporary Misdirection': '心神喪失',
      'Tentacle(?! )': 'たこあし',
      'Tentacle Simulation': 'ローディング：たこあし',
      'Ultros': 'オルトロス',
      'Viral Weapon': 'ウィルス兵器',
      '(?<!\\w)Virus': 'ウイルス',
      'Wallop': '叩きつけ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Dadaluma': '达达鲁玛',
      'Fire Control System': '武器火控系统',
      'Guardian': '守护者',
      'Ultros': '奥尔特罗斯',
      'WEAPON SYSTEMS ONLINE': '武器火控系统启动'
    },
    'replaceText': {
      'Aether Rot': '以太病毒',
      'Arm And Hammer': '臂锤',
      'Atomic Ray': '原子射线',
      'Aura Cannon': '斗气炮',
      'Biblio': '永世珍本',
      'Bomb Deployment': '设置炸弹',
      'Chain Cannon': '链式机关炮',
      'Chakra Burst': '脉轮爆发',
      'Copy(?! Program)': '复制',
      'Dada': '达达鲁玛',
      'Demon Simulation': '加载恶魔模拟程序',
      'Diffractive Laser': '扩散射线',
      'Diffractive Plasma': '扩散离子',
      'Ink': '墨汁',
      'Interrupt Stoneskin': '打断石肤',
      'Load': '加载',
      'Magitek Ray': '魔导激光',
      'Magnetism': '磁力',
      'Main Cannon': '主加农炮',
      'Missile Simulation': '加载导弹模拟程序',
      'Paste(?! Program)': '粘贴',
      'Plane Laser': '平面激光',
      'Prey': '猎物',
      'Radar': '雷达',
      'Repel': '相斥',
      'Retrieve Air Force': '接小飞机',
      'Retrieve Ultros': '接奥尔特罗斯',
      'Run(?! Program)': '跑',
      'Shockwave': '冲击波',
      'Skip(?! Program)': '跳跃',
      'Temporary Misdirection': '精神失常',
      'Tentacle(?! )': '腕足',
      'Tentacle Simulation': '加载腕足模拟程序',
      'Viral Weapon': '病毒兵器',
      '(?<!\\w)Virus': '病毒',
      'Wallop': '敲击'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Dadaluma': '다다루마',
      'Fire Control System': '병기 제어 시스템',
      'Guardian': '가디언',
      'Ultros': '오르트로스',
      'WEAPON SYSTEMS ONLINE': '병기 제어 시스템 기동……'
    },
    'replaceText': {
      '\\(H\\)': '(힐러)',
      '\\(DPS\\)': '(딜러)',
      'Aether Rot': '에테르 부패',
      'Air Force': '에어포스',
      'Arm And Hammer': '양팔 내리치기',
      'Atomic Ray': '원자 파동',
      'Aura Cannon': '오라 포격',
      'Biblio': '비블리오',
      'Bomb Deployment': '폭탄 설치',
      'Chain Cannon': '기관총',
      'Chakra Burst': '차크라 폭발',
      'Copy(?! Program)': '복사',
      'Dada': '다다',
      'Demon Simulation': '불러오기: 악마',
      'Diffractive Laser': '확산 레이저',
      'Diffractive Plasma': '확산 플라스마',
      'Ink': '먹물',
      'Interrupt Stoneskin': '스톤스킨 침묵하기',
      'Load': '불러오기',
      'Magitek Ray': '마도 레이저',
      'Magnetism': '자력',
      'Main Cannon': '주포',
      'Missile Simulation': '불러오기: 미사일',
      'Paste(?! Program)': '붙여넣기',
      'Plane Laser': '에어포스 레이저',
      'Prey': '표식',
      'Radar': '레이더',
      'Repel': '반발',
      'Run(?! Program)': '실체화',
      'Shockwave': '충격파',
      'Skip(?! Program)': '건너뛰기',
      'Temporary Misdirection': '심신상실',
      'Tentacle(?! )': '문어발',
      'Tentacle Simulation': '불러오기: 문어발',
      'Retrieve Ultros': '역순 불러오기: 오르트로스',
      'Viral Weapon': '바이러스 병기',
      '(?<!\\w)Virus': '바이러스',
      'Wallop': '매질'
    }
  }]
};
/* harmony default export */ const o7s = (o7s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o7s.txt
const raid_o7s_namespaceObject = "# Omega - Sigmascape V3.0 (Savage) - O7S\r\n\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" } window 11,10\r\n21 \"Arm And Hammer\" Ability { id: \"2789\", source: \"Guardian\" }\r\n31 \"Atomic Ray\" Ability { id: \"278D\", source: \"Guardian\" }\r\n40 \"Prey\" Ability { id: \"278A\", source: \"Guardian\" }\r\n49 \"Load?\" Ability { id: \"275C\", source: \"Guardian\" }\r\n50 \"--sync--\" GainsEffect { effectId: \"5D3\", effect: \"Dadaluma Simulation\", target: \"Guardian\" } jump 10050 # Version B\r\n52 \"Shockwave?\"\r\n\r\n# This is Version A of the encounter, with Bibliotaph first\r\n\r\n59 \"Demon Simulation\" Ability { id: \"2B36\", source: \"Guardian\" }\r\n\r\n# Dadaluma\r\n67 \"Load Dada / Skip Ultros\" Ability { id: \"2773\", source: \"Guardian\" }\r\n70 \"Shockwave\" Ability { id: \"2783\", source: \"Guardian\" }\r\n77 \"Missile Simulation\" Ability { id: \"2764\", source: \"Guardian\" }\r\n92 \"Chakra Burst\" Ability { id: \"2787\", source: \"Guardian\" }\r\n95 \"Run Dada (NW)\" Ability { id: \"276F\", source: \"Guardian\" }\r\n108 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n113 \"(H) Aura Cannon\"\r\n123 \"(DPS) Aura Cannon\"\r\n124 \"Arm And Hammer\" Ability { id: \"2789\", source: \"Guardian\" }\r\n136 \"Prey\" Ability { id: \"278A\", source: \"Guardian\" }\r\n144 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n\r\n# Ultros\r\n153 \"Retrieve Ultros\" Ability { id: \"2774\", source: \"Guardian\" }\r\n154 \"Ink\" Ability { id: \"277D\", source: \"Guardian\" }\r\n163 \"Copy Ultros\" Ability { id: \"2775\", source: \"Guardian\" }\r\n170 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n179 \"Tentacle Simulation\" Ability { id: \"275E\", source: \"Guardian\" }\r\n183 \"Tentacle\"\r\n189 \"Wallop\"\r\n191 \"Run Ultros (NE)\" Ability { id: \"276F\", source: \"Guardian\" }\r\n198 \"Interrupt Stoneskin\" duration 4\r\n200 \"--untargetable--\" Ability { id: \"2937\", source: \"Guardian\" }\r\n207 \"Chain Cannon\" duration 2\r\n213 \"Main Cannon\" Ability { id: \"2790\", source: \"Guardian\" } window 10,10\r\n216 \"--targetable--\" Ability { id: \"2938\", source: \"Guardian\" }\r\n228 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n\r\n# Air Force\r\n236 \"Load Air Force\" Ability { id: \"275C\", source: \"Guardian\" }\r\n239 \"Diffractive Laser\" Ability { id: \"2780\", source: \"Guardian\" }\r\n254 \"Missile Simulation\" Ability { id: \"2764\", source: \"Guardian\" }\r\n264 \"Run Air Force\" Ability { id: \"276F\", source: \"Guardian\" }\r\n278 \"Bomb Deployment\" Ability { id: \"2762\", source: \"Guardian\" }\r\n279 \"Plane Laser\" duration 2\r\n287 \"Plane Laser\" duration 2\r\n290 \"Arm And Hammer\" Ability { id: \"2789\", source: \"Guardian\" }\r\n298 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n\r\n# Virus\r\n306 \"Virus\" Ability { id: \"2773\", source: \"Guardian\" }\r\n309 \"Aether Rot\"\r\n319 \"Magnetism/Repel\" Ability { id: \"2779\", source: \"Fire Control System\" }\r\n332 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n344 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n356 \"Prey\" Ability { id: \"278A\", source: \"Guardian\" }\r\n366 \"Viral Weapon\" Ability { id: \"277C\", source: \"Guardian\" }\r\n367 \"Temporary Misdirection\" duration 15\r\n372 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n375 \"--untargetable--\" Ability { id: \"2937\", source: \"Guardian\" }\r\n382 \"Chain Cannon\" duration 2\r\n388 \"Main Cannon\" Ability { id: \"2790\", source: \"Guardian\" }\r\n389 \"Radar\" duration 2\r\n391 \"--targetable--\" Ability { id: \"2938\", source: \"Guardian\" }\r\n400 \"Arm And Hammer\" Ability { id: \"2789\", source: \"Guardian\" }\r\n408 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n\r\n# Ultros\r\n416 \"Paste Ultros\" Ability { id: \"2776\", source: \"Guardian\" }\r\n417 \"Ink\" Ability { id: \"277D\", source: \"Guardian\" }\r\n424 \"Tentacle Simulation\" Ability { id: \"275E\", source: \"Guardian\" }\r\n430 \"Bomb Deployment\" Ability { id: \"2762\", source: \"Guardian\" }\r\n439 \"Atomic Ray\" Ability { id: \"278D\", source: \"Guardian\" }\r\n444 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n453 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n463 \"Run Ultros (SW)\" Ability { id: \"276F\", source: \"Guardian\" }\r\n469 \"Missile Simulation\" Ability { id: \"2764\", source: \"Guardian\" }\r\n472 \"Interrupt Stoneskin\" duration 4\r\n474 \"--untargetable--\" Ability { id: \"2937\", source: \"Guardian\" }\r\n481 \"Chain Cannon\" duration 2\r\n487 \"Main Cannon\" Ability { id: \"2790\", source: \"Guardian\" }\r\n490 \"--targetable--\" Ability { id: \"2937\", source: \"Guardian\" }\r\n499 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n\r\n# Divergence point\r\n509 \"Load/Skip?\" Ability { id: [\"275C\", \"2773\"], source: \"Guardian\" }\r\n510 \"--sync--\" GainsEffect { effectId: \"5D4\", effect: \"Bibliotaph Simulation\", target: \"Guardian\" } jump 2510  # Bibliotaph buff, jump to A1\r\n510 \"--sync--\" GainsEffect { effectId: \"5D3\", effect: \"Dadaluma Simulation\", target: \"Guardian\" } jump 3510  # Dadaluma buff, jump to A2\r\n512 \"Shockwave?\"\r\n519 \"Demon Simulation?\"\r\n\r\n########################################################\r\n##### Divergent path, Version A1: Biblio->Dadaluma #####\r\n########################################################\r\n\r\n# Bibliotaph\r\n2509 \"Load Biblio\" Ability { id: [\"275C\", \"2773\"], source: \"Guardian\" }\r\n2518 \"Radar\" duration 2\r\n2519 \"Demon Simulation\" Ability { id: \"2B36\", source: \"Guardian\" }\r\n2532 \"Run Biblio\" Ability { id: \"276F\", source: \"Guardian\" }\r\n2539 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n2546 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n2553 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n2561 \"Prey\" Ability { id: \"278A\", source: \"Guardian\" }\r\n2570 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n2579 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n\r\n# Dadaluma\r\n2590 \"Load Dada\" Ability { id: [\"275C\", \"2774\"], source: \"Guardian\" }\r\n2593 \"Shockwave\" Ability { id: \"2783\", source: \"Guardian\" }\r\n2597 \"Radar\" duration 2\r\n2603 \"Missile Simulation\" Ability { id: \"2764\", source: \"Guardian\" }\r\n2612 \"Atomic Ray\" Ability { id: \"278D\", source: \"Guardian\" }\r\n2617 \"Chakra Burst\" Ability { id: \"2787\", source: \"Guardian\" }\r\n2629 \"Prey\" Ability { id: \"278A\", source: \"Guardian\" }\r\n2635 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n2643 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n2648 \"--sync--\" StartsUsing { id: [\"275C\", \"2773\"], source: \"Guardian\" } jump 4648  # Load/Skip starts casting, return to A\r\n\r\n# Should be unreachable, only here for visual continuity before/after jump\r\n2653 \"Load Air Force\"\r\n2656 \"Diffractive Laser\"\r\n2659 \"Radar\"\r\n2666 \"Diffractive Plasma\"\r\n2678 \"Run Air Force\"\r\n\r\n#### Divergent path, Version A2: Dadaluma->Biblio\r\n\r\n# Dadaluma\r\n3509 \"Load Dada\" Ability { id: [\"275C\", \"2773\"], source: \"Guardian\" }\r\n3512 \"Shockwave\" Ability { id: \"2783\", source: \"Guardian\" }\r\n3516 \"Radar\" duration 2\r\n3522 \"Missile Simulation\" Ability { id: \"2764\", source: \"Guardian\" }\r\n3531 \"Atomic Ray\" Ability { id: \"278D\", source: \"Guardian\" }\r\n3536 \"Chakra Burst\" Ability { id: \"2787\", source: \"Guardian\" }\r\n3548 \"Prey\" Ability { id: \"278A\", source: \"Guardian\" }\r\n3554 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n3562 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n\r\n# Bibliotaph\r\n3572 \"Load Biblio\" Ability { id: [\"275C\", \"2774\"], source: \"Guardian\" }\r\n3581 \"Radar\" duration 2\r\n3582 \"Demon Simulation\" Ability { id: \"2B36\", source: \"Guardian\" }\r\n3595 \"Run Biblio\" Ability { id: \"276F\", source: \"Guardian\" }\r\n3602 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n3609 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n3616 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n3624 \"Prey\" Ability { id: \"278A\", source: \"Guardian\" }\r\n3633 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n3642 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n3648 \"--sync--\" StartsUsing { id: [\"275C\", \"2773\"], source: \"Guardian\" } jump 4648 # Load/Skip starts casting, return to A\r\n\r\n# Should be unreachable, only here for visual continuity before/after jump\r\n3653 \"Load Air Force\"\r\n3656 \"Diffractive Laser\"\r\n3659 \"Radar\"\r\n3666 \"Diffractive Plasma\"\r\n3678 \"Run Air Force\"\r\n\r\n\r\n##########################################################\r\n##### Divergent paths reconverge back into Version A #####\r\n##########################################################\r\n\r\n# Air Force\r\n4653 \"Load Air Force\" Ability { id: [\"275C\", \"2773\"], source: \"Guardian\" }\r\n4656 \"Diffractive Laser\" Ability { id: \"2780\", source: \"Guardian\" }\r\n4659 \"Radar\" duration 2\r\n4666 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n4678 \"Run Air Force\" Ability { id: \"276F\", source: \"Guardian\" }\r\n4684 \"Bomb Deployment\" Ability { id: \"2762\", source: \"Guardian\" }\r\n4685 \"Plane Laser\" duration 2\r\n4691 \"Arm And Hammer\" Ability { id: \"2789\", source: \"Guardian\" }\r\n4693 \"Plane Laser\" duration 2\r\n4699 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n\r\n4700 \"--sync--\" StartsUsing { id: \"2791\", source: \"Guardian\" } window 100,100\r\n4715 \"Enrage\" Ability { id: \"2791\", source: \"Guardian\" } jump 0\r\n\r\n######################################\r\n########## END of Version A ##########\r\n########## START Version B ###########\r\n######################################\r\n\r\n# Only for reference\r\n10000 \"Start\"\r\n10011 \"Magitek Ray\"\r\n10021 \"Arm And Hammer\"\r\n10031 \"Atomic Ray\"\r\n10040 \"Prey\"\r\n10049 \"Load\"\r\n\r\n# This is Version B of the encounter, with Dadaluma first\r\n\r\n10052 \"Shockwave\" Ability { id: \"2783\", source: \"Guardian\" }\r\n10059 \"Missile Simulation\" Ability { id: \"2764\", source: \"Guardian\" }\r\n10074 \"Chakra Burst\" Ability { id: \"2787\", source: \"Guardian\" }\r\n10077 \"Run Dada (NW)\" Ability { id: \"276F\", source: \"Guardian\" }\r\n10090 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n10095 \"(H) Aura Cannon\"\r\n10105 \"(DPS) Aura Cannon\"\r\n10106 \"Arm And Hammer\" Ability { id: \"2789\", source: \"Guardian\" }\r\n10118 \"Prey\" Ability { id: \"278A\", source: \"Guardian\" }\r\n10126 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n\r\n# Bibliotaph\r\n10135 \"Load Biblio / Skip Air Force\" Ability { id: \"2773\", source: \"Guardian\" }\r\n10145 \"Demon Simulation\" Ability { id: \"2B36\", source: \"Guardian\" }\r\n10153 \"Retrieve Air Force\" Ability { id: \"2774\", source: \"Guardian\" }\r\n10156 \"Diffractive Laser\" Ability { id: \"2780\", source: \"Guardian\" }\r\n10164 \"Copy Air Force\" Ability { id: \"2775\", source: \"Guardian\" }\r\n10171 \"Missile Simulation\" Ability { id: \"2764\", source: \"Guardian\" }\r\n\r\n# Air Force\r\n10181 \"Run Air Force\" Ability { id: \"276F\", source: \"Guardian\" }\r\n10195 \"Bomb Deployment\" Ability { id: \"2762\", source: \"Guardian\" }\r\n10196 \"Plane Laser\" duration 2\r\n10204 \"Plane Laser\" duration 2\r\n10206 \"Arm And Hammer\" Ability { id: \"2789\", source: \"Guardian\" }\r\n10214 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n\r\n# Ultros\r\n10222 \"Load Ultros\" Ability { id: \"275C\", source: \"Guardian\" }\r\n10223 \"Ink\" Ability { id: \"277D\", source: \"Guardian\" }\r\n10239 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n10248 \"Tentacle Simulation\" Ability { id: \"275E\", source: \"Guardian\" }\r\n10252 \"Tentacle\"\r\n10258 \"Wallop\"\r\n10260 \"Run Ultros (SE)\" Ability { id: \"276F\", source: \"Guardian\" }\r\n10267 \"Interrupt Stoneskin\" duration 4\r\n10269 \"--targetable--\" Ability { id: \"2937\", source: \"Guardian\" }\r\n10276 \"Chain Cannon\" duration 2\r\n10282 \"Main Cannon\" Ability { id: \"2790\", source: \"Guardian\" }\r\n10285 \"--untargetable--\" Ability { id: \"2938\", source: \"Guardian\" }\r\n10297 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n\r\n# Virus\r\n10305 \"Virus\" Ability { id: \"2773\", source: \"Guardian\" }\r\n10308 \"Aether Rot\"\r\n10318 \"Magnetism/Repel\" Ability { id: \"2779\", source: \"Fire Control System\" } # optional?\r\n10331 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n10343 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n10355 \"Prey\" Ability { id: \"278A\", source: \"Guardian\" }\r\n10365 \"Viral Weapon\" Ability { id: \"277C\", source: \"Guardian\" }\r\n10366 \"Temporary Misdirection\" duration 15\r\n10371 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n10375 \"--untargetable--\" Ability { id: \"2937\", source: \"Guardian\" }\r\n10382 \"Chain Cannon\" duration 2\r\n10388 \"Main Cannon\" Ability { id: \"2790\", source: \"Guardian\" }\r\n10389 \"Radar\" duration 2\r\n10391 \"--targetable--\" Ability { id: \"2938\", source: \"Guardian\" }\r\n10400 \"Arm And Hammer\" Ability { id: \"2789\", source: \"Guardian\" }\r\n10408 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n\r\n# Air Force\r\n10416 \"Paste Air Force\" Ability { id: \"2776\", source: \"Guardian\" } window 10,10\r\n10419 \"Diffractive Laser\" Ability { id: \"2780\", source: \"Guardian\" }\r\n10422 \"Radar\" duration 2\r\n10431 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n10441 \"Run Air Force\" Ability { id: \"276F\", source: \"Guardian\" }\r\n10447 \"Bomb Deployment\" Ability { id: \"2762\", source: \"Guardian\" }\r\n10454 \"Plane Laser\" duration 2\r\n10462 \"Plane Laser\" duration 2\r\n10462 \"Arm And Hammer\" Ability { id: \"2789\", source: \"Guardian\" }\r\n10470 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n\r\n# Divergence point\r\n10481 \"Load/Skip?\" Ability { id: [\"275C\", \"2773\"], source: \"Guardian\" }\r\n10482 \"--sync--\" GainsEffect { effectId: \"5D4\", effect: \"Bibliotaph Simulation\", target: \"Guardian\" } jump 14482  # Bibliotaph buff, jump to B1\r\n10482 \"--sync--\" GainsEffect { effectId: \"5D3\", effect: \"Dadaluma Simulation\", target: \"Guardian\" } jump 15482  # Dadaluma buff, jump to B2\r\n10484 \"Shockwave?\"\r\n10491 \"Demon Simulation?\"\r\n\r\n##########################################################\r\n##### Divergent path, Version B1: Biblio -> Dadaluma #####\r\n##########################################################\r\n\r\n# Bibliotaph\r\n14481 \"Load Biblio\" Ability { id: [\"275C\", \"2773\"], source: \"Guardian\" }\r\n14490 \"Radar\" duration 2\r\n14491 \"Demon Simulation\" Ability { id: \"2B36\", source: \"Guardian\" }\r\n14504 \"Run Biblio\" Ability { id: \"276F\", source: \"Guardian\" }\r\n14511 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n14518 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n14525 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n14533 \"Prey\" Ability { id: \"278A\", source: \"Guardian\" }\r\n14542 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n14551 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n\r\n# Dadaluma\r\n14562 \"Load Dada\" Ability { id: [\"275C\", \"2774\"], source: \"Guardian\" }\r\n14565 \"Shockwave\" Ability { id: \"2783\", source: \"Guardian\" }\r\n14569 \"Radar\" duration 2\r\n14575 \"Missile Simulation\" Ability { id: \"2764\", source: \"Guardian\" }\r\n14584 \"Atomic Ray\" Ability { id: \"278D\", source: \"Guardian\" }\r\n14589 \"Chakra Burst\" Ability { id: \"2787\", source: \"Guardian\" }\r\n14601 \"Prey\" Ability { id: \"278A\", source: \"Guardian\" }\r\n14607 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n14615 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n14620 \"--sync--\" StartsUsing { id: [\"275C\", \"2773\"], source: \"Guardian\" } jump 16020  # Load/Skip casting, return to B\r\n\r\n# Should be unreachable, only here for visual continuity before/after jump\r\n14625 \"Load Ultros\"\r\n14626 \"Ink\"\r\n14633 \"Tentacle Simulation\"\r\n14637 \"Tentacle\"\r\n14639 \"Bomb Deployment\"\r\n14643 \"Wallop\"\r\n14648 \"Atomic Ray\"\r\n\r\n#### Divergent path, Version B2: Dadaluma -> Bibliotaph\r\n\r\n# Dadaluma\r\n15481 \"Load Dada\" Ability { id: [\"275C\", \"2773\"], source: \"Guardian\" }\r\n15484 \"Shockwave\" Ability { id: \"2783\", source: \"Guardian\" }\r\n15488 \"Radar\" duration 2\r\n15494 \"Missile Simulation\" Ability { id: \"2764\", source: \"Guardian\" }\r\n15503 \"Atomic Ray\" Ability { id: \"278D\", source: \"Guardian\" }\r\n15508 \"Chakra Burst\" Ability { id: \"2787\", source: \"Guardian\" }\r\n15520 \"Prey\" Ability { id: \"278A\", source: \"Guardian\" }\r\n15526 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n15534 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n\r\n# Bibliotaph\r\n15544 \"Load Biblio\" Ability { id: [\"275C\", \"2774\"], source: \"Guardian\" }\r\n15553 \"Radar\" duration 2\r\n15554 \"Demon Simulation\" Ability { id: \"2B36\", source: \"Guardian\" }\r\n15567 \"Run Biblio\" Ability { id: \"276F\", source: \"Guardian\" }\r\n15574 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n15581 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n15588 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n15596 \"Prey\" Ability { id: \"278A\", source: \"Guardian\" }\r\n15605 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n15614 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n15620 \"--sync--\" StartsUsing { id: [\"275C\", \"2773\"], source: \"Guardian\" } jump 16020  # Load/Skip casting, return to B\r\n\r\n# Should be unreachable, only here for visual continuity before/after jump\r\n15625 \"Load Ultros\"\r\n15626 \"Ink\"\r\n15633 \"Tentacle Simulation\"\r\n15637 \"Tentacle\"\r\n15639 \"Bomb Deployment\"\r\n15643 \"Wallop\"\r\n15648 \"Atomic Ray\"\r\n\r\n##########################################################\r\n##### Divergent paths reconverge, continue Version B #####\r\n##########################################################\r\n\r\n# Ultros\r\n16025 \"Load Ultros\" Ability { id: [\"275C\", \"2773\"], source: \"Guardian\" }\r\n16026 \"Ink\" Ability { id: \"277D\", source: \"Guardian\" }\r\n16033 \"Tentacle Simulation\" Ability { id: \"275E\", source: \"Guardian\" }\r\n16037 \"Tentacle\"\r\n16039 \"Bomb Deployment\" Ability { id: \"2762\", source: \"Guardian\" }\r\n16043 \"Wallop\"\r\n16048 \"Atomic Ray\" Ability { id: \"278D\", source: \"Guardian\" }\r\n16053 \"Magitek Ray\" Ability { id: \"2788\", source: \"Guardian\" }\r\n16062 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n16072 \"Run Ultros (NE)\" Ability { id: \"276F\", source: \"Guardian\" }\r\n16078 \"Missile Simulation\" Ability { id: \"2764\", source: \"Guardian\" }\r\n16081 \"Interrupt Stoneskin\" duration 4\r\n16081 \"--untargetable--\" Ability { id: \"2937\", source: \"Guardian\" }\r\n16088 \"Chain Cannon\" duration 2\r\n16094 \"Main Cannon\" Ability { id: \"2790\", source: \"Guardian\" }\r\n16097 \"--targetable--\" Ability { id: \"2938\", source: \"Guardian\" }\r\n17006 \"Diffractive Plasma\" Ability { id: \"278B\", source: \"Guardian\" }\r\n\r\n# Enrage\r\n17011 \"--sync--\" StartsUsing { id: \"2791\", source: \"Guardian\" } window 100,100\r\n17026 \"Enrage\" Ability { id: \"2791\", source: \"Guardian\" } jump 0\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o8n.ts



// O8N - Sigmascape 4.0 Normal
const o8n_triggerSet = {
  id: 'SigmascapeV40',
  zoneId: zone_id/* default.SigmascapeV40 */.Z.SigmascapeV40,
  timelineFile: 'o8n.txt',
  triggers: [{
    id: 'O8N Hyper Drive',
    type: 'StartsUsing',
    netRegex: {
      id: '292E',
      source: 'Kefka'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O8N Shockwave',
    type: 'StartsUsing',
    netRegex: {
      id: '2927',
      source: 'Graven Image',
      capture: false
    },
    delaySeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'O8N Gravitational Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '2929',
      source: 'Graven Image',
      capture: false
    },
    response: responses/* Responses.goEast */.n3.goEast()
  }, {
    id: 'O8N Intemperate Will',
    type: 'StartsUsing',
    netRegex: {
      id: '292A',
      source: 'Graven Image',
      capture: false
    },
    response: responses/* Responses.goWest */.n3.goWest()
  }, {
    id: 'O8N Ave Maria',
    type: 'StartsUsing',
    netRegex: {
      id: '292B',
      source: 'Graven Image',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look At Statue',
        de: 'Statue anschauen',
        fr: 'Regardez la statue',
        ja: '神々の像を見て',
        cn: '面对神像',
        ko: '시선 바라보기'
      }
    }
  }, {
    id: 'O8N Indolent Will',
    type: 'StartsUsing',
    netRegex: {
      id: '292C',
      source: 'Graven Image',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look Away From Statue',
        de: 'Von Statue wegschauen',
        fr: 'Ne regardez pas la statue',
        ja: '神々の像を見ない',
        cn: '背对神像',
        ko: '시선 피하기'
      }
    }
  }, {
    id: 'O8N Timely Teleport',
    type: 'StartsUsing',
    netRegex: {
      id: '2921',
      source: 'Kefka',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Outside Destination',
        de: 'Geh aus dem Zielkreis raus',
        fr: 'Allez à côté du cercle extérieur',
        cn: '去传送目的地的外圈',
        ko: '마법진 바깥쪽으로 이동'
      }
    }
  }, {
    id: 'O8N Aero Assault',
    type: 'StartsUsing',
    netRegex: {
      id: '2924',
      source: 'Kefka',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'O8N Flagrant Fire Single',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'fire on YOU',
        de: 'Feuer auf DIR',
        fr: 'Feu sur VOUS',
        ja: '自分にファイガ',
        cn: '火点名',
        ko: '파이가 대상자'
      }
    }
  }, {
    id: 'O8N Flagrant Fire Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'O8N Thrumming Thunder Real',
    type: 'StartsUsing',
    netRegex: {
      id: '291D',
      source: 'Kefka',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'True Thunder',
        de: 'Wahrer Blitz',
        fr: 'Vraie foudre',
        ja: '真サンダガ',
        cn: '真雷',
        ko: '진실 선더가'
      }
    }
  }, {
    id: 'O8N Thrumming Thunder Fake',
    type: 'StartsUsing',
    netRegex: {
      id: '291B',
      source: 'Kefka',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fake Thunder',
        de: 'Falscher Blitz',
        fr: 'Fausse foudre',
        ja: '偽サンダガ',
        cn: '假雷',
        ko: '거짓 선더가'
      }
    }
  }, {
    id: 'O8N Blizzard Fake Donut',
    type: 'StartsUsing',
    netRegex: {
      id: '2916',
      source: 'Kefka',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fake Ice: Get out',
        de: 'Falsches Eis: Rausgehen',
        fr: 'Fausse glace : Sortez',
        ja: '偽ブリザガ: 外へ',
        cn: '假冰：远离',
        ko: '거짓 블리자가: 밖으로'
      }
    }
  }, {
    id: 'O8N Blizzard True Donut',
    type: 'StartsUsing',
    netRegex: {
      id: '2919',
      source: 'Kefka',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'True Ice: Get in',
        de: 'Wahre Eis: Reingehen',
        fr: 'Vraie glace : À l\'intérieur',
        ja: '真ブリザガ: 入る',
        cn: '真冰：靠近',
        ko: '진실 블리자가: 안으로'
      }
    }
  }, {
    id: 'O8N Blizzard Fake Near',
    type: 'StartsUsing',
    netRegex: {
      id: '2914',
      source: 'Kefka',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fake Ice: Get in',
        de: 'Falsches Eis: Reingehen',
        fr: 'Fausse glace: À l\'intérieur',
        ja: '偽ブリザガ: 入る',
        cn: '假冰：靠近',
        ko: '거짓 블리자가: 안으로'
      }
    }
  }, {
    id: 'O8N Blizzard True Near',
    type: 'StartsUsing',
    netRegex: {
      id: '2918',
      source: 'Kefka',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'True Ice: Get out',
        de: 'Wahres Eis: Rausgehen',
        fr: 'Vraie glace: Sortez',
        ja: '真ブリザガ: 外へ',
        cn: '真冰：远离',
        ko: '진실 블리자가: 밖으로'
      }
    }
  }, {
    id: 'O8N Ultima Upsurge',
    type: 'StartsUsing',
    netRegex: {
      id: '292D',
      source: 'Kefka',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Destroy! Destroy! Destroy! I will destroy it all!': 'Nichts wird mir standhalten, nichts! Alles will ich vernichten!',
      'Graven Image': 'heilig(?:e|er|es|en) Statue',
      'Kefka': 'Kefka'
    },
    'replaceText': {
      'Aero Assault': 'Wallendes Windga',
      'Aero/Ruin': 'Wind/Ruin',
      'Blizzard Blitz': 'Erstarrendes Eisga',
      'Flagrant Fire': 'Flammendes Feuga',
      'Graven Image': 'Göttliche Statue',
      'Half Arena': 'Halbe Arena',
      'Hyperdrive': 'Hyperantrieb',
      'Shockwave': 'Schockwelle',
      'Statue Gaze': 'Statuenblick',
      'Thrumming Thunder': 'Brachiales Blitzga',
      'Timely Teleport': 'Turbulenter Teleport',
      'Ultima Upsurge': 'Ultima-Wallung',
      'Wave Cannon': 'Wellenkanone'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Graven Image': 'Statue divine',
      'Destroy! Destroy! Destroy! I will destroy it all!': 'Je détruirai le monde entier ! Plus personne ne pourra rêver !',
      'Kefka': 'Kefka'
    },
    'replaceText': {
      'Aero Assault': 'Méga Vent véhément',
      'Aero/Ruin': 'Vent/Ruine',
      'Blizzard Blitz': 'Méga Glace glissante',
      'Flagrant Fire': 'Méga Feu faufilant',
      'Graven Image': 'Statue divine',
      'Half Arena': 'Moitié d\'arène',
      'Hyperdrive': 'Colonne de feu',
      'Shockwave': 'Onde de choc',
      'Statue Gaze': 'Regard de statue',
      'Thrumming Thunder': 'Méga Foudre fourmillante',
      'Timely Teleport': 'Téléportation turbulente',
      'Ultima Upsurge': 'Ultima ulcérante',
      'Wave Cannon': 'Canon plasma'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Destroy! Destroy! Destroy! I will destroy it all!': 'どれもこれもゼ～ンブ、ハカイ、ハカイ、ハカイ！\\s*ゼ～ンブ、ハカイだ！！',
      'Graven Image': '神々の像',
      'Kefka': 'ケフカ'
    },
    'replaceText': {
      'Aero Assault': 'ずんずんエアロガ',
      'Aero/Ruin': 'エアロガ/ルインガ',
      'Blizzard Blitz': 'ぐるぐるブリザガ',
      'Flagrant Fire': 'めらめらファイガ',
      'Graven Image': '神々の像',
      'Half Arena': 'フィールド半分即死',
      'Hyperdrive': 'ハイパードライブ',
      'Shockwave': '衝撃波',
      'Statue Gaze': '像ギミック',
      'Thrumming Thunder': 'もりもりサンダガ',
      'Timely Teleport': 'ぶっとびテレポ',
      'Ultima Upsurge': 'どきどきアルテマ',
      'Wave Cannon': '波動砲'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Destroy! Destroy! Destroy! I will destroy it all!': '我要破坏一切！破坏！破坏！破坏！',
      'Graven Image': '众神之像',
      'Kefka': '凯夫卡'
    },
    'replaceText': {
      'Aero Assault': '疼飕飕暴风',
      'Aero/Ruin': '暴风/毁荡',
      'Blizzard Blitz': '滴溜溜冰封',
      'Flagrant Fire': '呼啦啦爆炎',
      'Graven Image': '众神之像',
      'Half Arena': '半场',
      'Hyperdrive': '超驱动',
      'Shockwave': '冲击波',
      'Statue Gaze': '神像视线',
      'Thrumming Thunder': '劈啪啪暴雷',
      'Timely Teleport': '跳蹦蹦传送',
      'Ultima Upsurge': '扑腾腾究极',
      'Wave Cannon': '波动炮'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Destroy! Destroy! Destroy! I will destroy it all!': '이것저것 모~두, 파괴, 파괴, 파괴!',
      'Graven Image': '신들의 상',
      'Kefka': '케프카'
    },
    'replaceText': {
      'Aero Assault': '갈기갈기 에어로가',
      'Aero/Ruin': '에어로가/루인가',
      'Blizzard Blitz': '빙글빙글 블리자가',
      'Flagrant Fire': '이글이글 파이가',
      'Graven Image': '신들의 상',
      'Half Arena': '절반 장판',
      'Hyperdrive': '하이퍼드라이브',
      'Shockwave': '충격파',
      'Statue Gaze': '동상 작동',
      'Thrumming Thunder': '찌릿찌릿 선더가',
      'Timely Teleport': '껑충껑충 텔레포',
      'Ultima Upsurge': '두근두근 알테마',
      'Wave Cannon': '파동포'
    }
  }]
};
/* harmony default export */ const o8n = (o8n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o8n.txt
const raid_o8n_namespaceObject = "# Omega - Sigmascape V4.0 - O8N\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n15 \"Hyperdrive\" Ability { id: \"292E\", source: \"Kefka\" } window 16,3\r\n23 \"Blizzard Blitz\" Ability { id: \"291(4|6|8|9)\", source: \"Kefka\" }\r\n36 \"Flagrant Fire\" Ability { id: \"291F\", source: \"Kefka\" }\r\n38 \"Thrumming Thunder\" Ability { id: \"291(B|D)\", source: \"Kefka\" }\r\n54 \"Blizzard Blitz\" Ability { id: \"291(4|6|8|9)\", source: \"Kefka\" }\r\n62 \"Thrumming Thunder\" Ability { id: \"291(B|D)\", source: \"Kefka\" }\r\n\r\n82 \"Graven Image\" Ability { id: \"2925\", source: \"Kefka\" }\r\n94 \"Wave Cannon\" Ability { id: \"2928\", source: \"Graven Image\" }\r\n95 \"Shockwave\" Ability { id: \"2927\", source: \"Graven Image\" }\r\n107 \"Ultima Upsurge\" Ability { id: \"292D\", source: \"Kefka\" }\r\n115 \"Hyperdrive\" Ability { id: \"292E\", source: \"Kefka\" }\r\n129 \"Flagrant Fire\" Ability { id: \"2920\", source: \"Kefka\" }\r\n131 \"Blizzard Blitz\" Ability { id: \"291(4|6|8|9)\", source: \"Kefka\" }\r\n137 \"Timely Teleport\" Ability { id: \"2922\", source: \"Kefka\" }\r\n137 \"--untargetable--\"\r\n140 \"--targetable--\"\r\n140 \"Aero/Ruin\" duration 3\r\n148 \"Aero Assault\" Ability { id: \"2924\", source: \"Kefka\" }\r\n\r\n160 \"Graven Image\" Ability { id: \"2925\", source: \"Kefka\" }\r\n170 \"Thrumming Thunder\" Ability { id: \"291(B|D)\", source: \"Kefka\" }\r\n172 \"Wave Cannon\" Ability { id: \"2928\", source: \"Graven Image\" }\r\n173 \"Shockwave\" Ability { id: \"2927\", source: \"Graven Image\" }\r\n183 \"Ultima Upsurge\" Ability { id: \"292D\", source: \"Kefka\" }\r\n190 \"Hyperdrive\" Ability { id: \"292E\", source: \"Kefka\" }\r\n\r\n204 \"Graven Image\" Ability { id: \"2925\", source: \"Kefka\" }\r\n210 \"Half Arena\" Ability { id: [\"292A\", \"2929\"], source: \"Graven Image\" }\r\n218 \"Ultima Upsurge\" Ability { id: \"292D\", source: \"Kefka\" }\r\n\r\n228 \"Graven Image\" Ability { id: \"2925\", source: \"Kefka\" }\r\n234 \"Half Arena\" Ability { id: [\"292A\", \"2929\"], source: \"Graven Image\" }\r\n240 \"Flagrant Fire\" Ability { id: \"291F\", source: \"Kefka\" }\r\n242 \"Thrumming Thunder\" Ability { id: \"291(B|D)\", source: \"Kefka\" }\r\n248 \"Timely Teleport\" Ability { id: \"2922\", source: \"Kefka\" }\r\n248 \"--untargetable--\"\r\n251 \"--targetable--\"\r\n251 \"Aero/Ruin\" duration 3\r\n\r\n268 \"Graven Image\" Ability { id: \"2925\", source: \"Kefka\" }\r\n274 \"Half Arena\" Ability { id: \"292(9|A)\", source: \"Graven Image\" }\r\n275 \"Thrumming Thunder\" Ability { id: \"291(B|D)\", source: \"Kefka\" }\r\n282 \"Ultima Upsurge\" Ability { id: \"292D\", source: \"Kefka\" }\r\n289 \"Hyperdrive\" Ability { id: \"292E\", source: \"Kefka\" }\r\n\r\n302 \"Graven Image\" Ability { id: \"2925\", source: \"Kefka\" }\r\n308 \"Statue Gaze\" Ability { id: \"292C\", source: \"Graven Image\" }\r\n318 \"Ultima Upsurge\" Ability { id: \"292D\", source: \"Kefka\" }\r\n325 \"Ultima Upsurge\" Ability { id: \"292D\", source: \"Kefka\" }\r\n\r\n# loop here\r\n335 \"Graven Image\" Ability { id: \"2925\", source: \"Kefka\" }\r\n341 \"Statue Gaze\" Ability { id: \"292(B|C)\", source: \"Graven Image\" }\r\n342 \"Thrumming Thunder\" Ability { id: \"291(B|D)\", source: \"Kefka\" }\r\n348 \"Timely Teleport\" Ability { id: \"2922\", source: \"Kefka\" }\r\n348 \"--untargetable--\"\r\n351 \"--targetable--\"\r\n351 \"Aero/Ruin\" duration 3\r\n366 \"Hyperdrive\" Ability { id: \"292E\", source: \"Kefka\" }\r\n\r\n374 \"Graven Image\" Ability { id: \"2925\", source: \"Kefka\" }\r\n380 \"Statue Gaze\" Ability { id: \"292(B|C)\", source: \"Graven Image\" }\r\n386 \"Flagrant Fire\" Ability { id: \"291F\", source: \"Kefka\" }\r\n388 \"Blizzard Blitz\" Ability { id: \"291(4|6|8|9)\", source: \"Kefka\" }\r\n401 \"Ultima Upsurge\" Ability { id: \"292D\", source: \"Kefka\" }\r\n408 \"Ultima Upsurge\" Ability { id: \"292D\", source: \"Kefka\" }\r\n# end loop\r\n\r\n418 \"Graven Image\" Ability { id: \"2925\", source: \"Kefka\" } jump 333\r\n424 \"Statue Gaze\"\r\n425 \"Thrumming Thunder\"\r\n431 \"Timely Teleport\"\r\n431 \"--untargetable--\"\r\n434 \"--targetable--\"\r\n434 \"Aero/Ruin\" duration 3\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o8s.ts




const strings = {
  typeAndDir: {
    en: '${type}: ${dir}',
    de: '${type}: ${dir}',
    fr: '${type}: ${dir}',
    ja: '${type}: ${dir}',
    cn: '${type}: ${dir}',
    ko: '${type}: ${dir}'
  },
  spread: outputs/* default.spread */.Z.spread,
  stack: {
    en: 'Stack',
    de: 'Stacken',
    fr: 'Packez-vous',
    ja: 'スタック',
    cn: '集合',
    ko: '집합'
  },
  getOut: {
    en: 'Get Out',
    de: 'raus da',
    fr: 'Sortez',
    ja: '外へ',
    cn: '远离',
    ko: '밖으로'
  },
  getIn: {
    en: 'Get In',
    de: 'reingehen',
    fr: 'À l\'intérieur',
    ja: '中へ',
    cn: '靠近',
    ko: '안으로'
  },
  trueThunder: {
    en: 'True Thunder',
    de: 'Wahrer Blitz',
    fr: 'Vraie foudre',
    ja: '真サンダガ',
    cn: '真雷',
    ko: '진실 선더가'
  },
  fakeThunder: {
    en: 'Fake Thunder',
    de: 'Falscher Blitz',
    fr: 'Fausse foudre',
    ja: 'にせサンダガ',
    cn: '假雷',
    ko: '거짓 선더가'
  },
  trueIce: {
    en: 'True Ice',
    de: 'Wahres Eis',
    fr: 'Vraie glace',
    ja: '真ブリザガ',
    cn: '真冰',
    ko: '진실 블리자가'
  },
  fakeIce: {
    en: 'Fake Ice',
    de: 'Falsches Eis',
    fr: 'Fausse glace',
    ja: 'にせブリザガ',
    cn: '假冰',
    ko: '거짓 블리자가'
  }
};

// O8S - Sigmascape 4.0 Savage
const o8s_triggerSet = {
  id: 'SigmascapeV40Savage',
  zoneId: zone_id/* default.SigmascapeV40Savage */.Z.SigmascapeV40Savage,
  timelineFile: 'o8s.txt',
  triggers: [{
    id: 'O8S Shockwave',
    type: 'StartsUsing',
    netRegex: {
      id: '28DB',
      source: 'Graven Image',
      capture: false
    },
    delaySeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'O8S Indolent Will',
    type: 'StartsUsing',
    netRegex: {
      id: '28E4',
      source: 'Graven Image',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look Away From Statue',
        de: 'Von Statue wegschauen',
        fr: 'Ne regardez pas la statue',
        ja: '塔を見ない！',
        cn: '背对神像',
        ko: '시선 피하기'
      }
    }
  }, {
    id: 'O8S Intemperate Will',
    type: 'StartsUsing',
    netRegex: {
      id: '28DF',
      source: 'Graven Image',
      capture: false
    },
    response: responses/* Responses.goWest */.n3.goWest()
  }, {
    id: 'O8S Gravitational Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '28DE',
      source: 'Graven Image',
      capture: false
    },
    response: responses/* Responses.goEast */.n3.goEast()
  }, {
    id: 'O8S Ave Maria',
    type: 'StartsUsing',
    netRegex: {
      id: '28E3',
      source: 'Graven Image',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look At Statue',
        de: 'Statue anschauen',
        fr: 'Regardez la statue',
        ja: '像を見る！',
        cn: '面对神像',
        ko: '시선 바라보기'
      }
    }
  }, {
    id: 'O8S Pasts Forgotten',
    type: 'StartsUsing',
    netRegex: {
      id: '28F1',
      source: 'Kefka',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Past: Stack and Stay',
        de: 'Vergangenheit: Sammeln und Stehenbleiben',
        fr: 'Passé : Packez-vous et restez',
        ja: '過去: スタックしてそのまま',
        cn: '分摊不动',
        ko: '과거: 맞고 가만히있기'
      }
    }
  }, {
    id: 'O8S Futures Numbered',
    type: 'StartsUsing',
    netRegex: {
      id: '28EE',
      source: 'Kefka',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Future: Stack and Through',
        de: 'Zukunft: Sammeln und Durchlaufen',
        fr: 'Futur : Packez-vous et traversez',
        ja: '未来: 頭割り後ボスを通り抜ける',
        cn: '分摊穿boss',
        ko: '미래: 맞고 통과해가기'
      }
    }
  }, {
    // TODO: not sure if this cast is 7 or 8.
    id: 'O8S Past\'s End',
    type: 'StartsUsing',
    netRegex: {
      id: '28F[78]',
      source: 'Kefka',
      capture: false
    },
    condition: data => data.role === 'tank' || data.role === 'healer',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Past: Bait, then through',
        de: 'Vergangenheit : Anlocken und Durchlaufen',
        fr: 'Passé : Attirez, puis traversez',
        ja: '過去: 飛んできたら反対に向ける',
        cn: '诱导然后穿boss',
        ko: '과거: 맞고, 이동'
      }
    }
  }, {
    // TODO: not sure if this cast is 4 or 5.
    id: 'O8S Future\'s End',
    type: 'StartsUsing',
    netRegex: {
      id: '28F[45]',
      source: 'Kefka',
      capture: false
    },
    condition: data => data.role === 'tank' || data.role === 'healer',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Future: Bait, then stay',
        de: 'Zukunft: Anlocken und Stehenbleiben',
        fr: 'Futur : Attirez, puis restez',
        ja: '未来: 飛んできたらそのまま',
        cn: '诱导然后不动',
        ko: '미래: 맞고, 가만히'
      }
    }
  }, {
    id: 'O8S Pulse Wave You',
    type: 'StartsUsing',
    netRegex: {
      id: '28DD',
      source: 'Graven Image'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.knockbackOn */.n3.knockbackOn()
  }, {
    id: 'O8S Wings of Destruction',
    type: 'StartsUsing',
    netRegex: {
      id: '2900',
      source: 'Kefka',
      capture: false
    },
    alarmText: (data, _matches, output) => {
      if (data.role === 'tank') return output.wingsBeNearFar();
    },
    infoText: (data, _matches, output) => {
      if (data.role !== 'tank') return output.maxMeleeAvoidTanks();
    },
    outputStrings: {
      maxMeleeAvoidTanks: {
        en: 'Max Melee: Avoid Tanks',
        de: 'Max Nahkampf: Weg von den Tanks',
        fr: 'Max mêlée : éloignez-vous des tanks',
        ja: '近接最大レンジ タンクから離れる',
        cn: '最远距离',
        ko: '칼끝딜: 탱커 피하기'
      },
      wingsBeNearFar: {
        en: 'Wings: Be Near/Far',
        de: 'Schwingen: Nah/Fern',
        fr: 'Ailes : Placez-vous près/loin',
        ja: '翼: めり込む/離れる',
        cn: '双翅膀：近或远',
        ko: '양날개: 가까이/멀리'
      }
    }
  }, {
    id: 'O8S Single Wing of Destruction',
    type: 'StartsUsing',
    netRegex: {
      id: '28F[EF]',
      source: 'Kefka',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Single Wing',
        de: 'Einzelner Flügel',
        fr: 'Aile unique',
        ja: '片翼',
        cn: '单翅膀',
        ko: '한쪽 날개'
      }
    }
  }, {
    id: 'O8S Ultimate Embrace',
    type: 'StartsUsing',
    netRegex: {
      id: '2910',
      source: 'Kefka'
    },
    alertText: (data, matches, output) => {
      if (matches.target !== data.me) return;
      return output.embraceOnYou();
    },
    infoText: (data, matches, output) => {
      if (matches.target === data.me) return;
      return output.embraceOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      embraceOn: {
        en: 'Embrace on ${player}',
        de: 'Umarmung auf ${player}',
        fr: 'Étreinte sur ${player}',
        ja: '${player}に双腕',
        cn: '分摊死刑${player}',
        ko: '"${player}" 종말의 포옹'
      },
      embraceOnYou: {
        en: 'Embrace on YOU',
        de: 'Umarmung auf DIR',
        fr: 'Étreinte sur VOUS',
        ja: '自分に双腕',
        cn: '分摊死刑点名',
        ko: '종말의 포옹 대상자'
      }
    }
  }, {
    // 28E8: clown hyperdrive, 2912: god hyperdrive
    id: 'O8S Hyperdrive',
    type: 'StartsUsing',
    netRegex: {
      id: ['28E8', '2912'],
      source: 'Kefka'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O8S Indulgent Will',
    type: 'StartsUsing',
    netRegex: {
      id: '28E5',
      source: 'Graven Image'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Confusion: Go Outside',
        de: 'Konfusion: Nach außen',
        fr: 'Confusion : Allez à l\'extérieur',
        ja: '混乱: 外へ',
        cn: '去外面',
        ko: '혼란: 바깥으로'
      }
    }
  }, {
    id: 'O8S Idyllic Will',
    type: 'StartsUsing',
    netRegex: {
      id: '28E6',
      source: 'Graven Image'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sleep: Go Inside',
        de: 'Schlaf: Zur Mitte',
        fr: 'Sommeil : Allez à l\'intérieur',
        ja: '睡眠: 中へ',
        cn: '去中间',
        ko: '수면: 안으로'
      }
    }
  }, {
    // Precedes fake abilities
    id: 'O8S Jester\'s Antics',
    type: 'GainsEffect',
    netRegex: {
      effectId: '5CE',
      capture: false
    },
    suppressSeconds: 1,
    // Every Kefka entity gains this at once.
    run: data => data.antics = true
  }, {
    // Precedes real abilities
    id: 'O8S Jester\'s Truths',
    type: 'GainsEffect',
    netRegex: {
      effectId: '5CF',
      capture: false
    },
    suppressSeconds: 1,
    // Every Kefka entity gains this at once.
    run: data => data.truths = true
  }, {
    id: 'O8S Jester Cleanup',
    type: 'LosesEffect',
    netRegex: {
      effectId: ['5CE', '5CF'],
      capture: false
    },
    suppressSeconds: 1,
    run: data => {
      delete data.antics;
      delete data.truths;
    }
  }, {
    id: 'O8S Mana Charge',
    type: 'StartsUsing',
    netRegex: {
      id: '28D1',
      source: 'Kefka',
      capture: false
    },
    run: data => {
      delete data.lastFire;
      delete data.lastThunder;
      delete data.lastIceDir;
      delete data.manaReleaseText;
    }
  }, {
    id: 'O8S Mana Release',
    type: 'StartsUsing',
    netRegex: {
      id: '28D2',
      source: 'Kefka',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.lastFire) return output[data.lastFire]();
      if (!data.lastIceDir || !data.lastThunder) return;
      return output.thunderIce({
        thunder: output[data.lastThunder](),
        dir: output[data.lastIceDir]()
      });
    },
    outputStrings: {
      thunderIce: {
        en: '${thunder}, ${dir}',
        de: '${thunder}, ${dir}',
        fr: '${thunder}, ${dir}',
        ja: '${thunder}, ${dir}',
        cn: '${thunder}, ${dir}',
        ko: '${thunder}, ${dir}'
      },
      fakeThunder: strings.fakeThunder,
      trueThunder: strings.trueThunder,
      getIn: strings.getIn,
      getOut: strings.getOut,
      spread: strings.spread,
      stack: strings.stack
    }
  }, {
    // This may be real or fake. We're just storing this briefly
    // so we can use it to call the first fire correctly.
    // 007F is the spread marker, 0080 is the stack marker
    id: 'O8S Fire Head Marker',
    type: 'HeadMarker',
    netRegex: {
      id: ['007F', '0080']
    },
    suppressSeconds: 2,
    run: (data, matches) => data.fireMarker = matches.id === '007F' ? 'spread' : 'stack'
  }, {
    // Kefka doesn't directly use the Fire abilities. Rather, he casts 28CE on himself,
    // then instantly casts either the real or fake Fire on resolution.
    //
    // 28CE: ability id on use
    // 28CF: damage from mana charge
    // 2B32: damage from mana release
    id: 'O8S Fire Spread',
    type: 'StartsUsing',
    netRegex: {
      id: '28CE',
      source: 'Kefka',
      capture: false
    },
    condition: data => {
      const isTrueSpread = data.truths && data.fireMarker === 'spread';
      const isFakeStack = data.antics && data.fireMarker === 'stack';
      return isTrueSpread || isFakeStack;
    },
    response: responses/* Responses.spread */.n3.spread(),
    run: data => {
      data.lastFire = 'spread';
      delete data.fireMarker;
    }
  }, {
    // 28CE: ability id on use
    // 28D0: damage from mana charge
    // 2B33: damage from mana release
    id: 'O8S Fire Stack',
    type: 'StartsUsing',
    netRegex: {
      id: '28CE',
      source: 'Kefka',
      capture: false
    },
    condition: data => {
      const isFakeSpread = data.antics && data.fireMarker === 'spread';
      const isTrueStack = data.truths && data.fireMarker === 'stack';
      return isFakeSpread || isTrueStack;
    },
    response: responses/* Responses.getTogether */.n3.getTogether(),
    run: data => {
      data.lastFire = 'stack';
      delete data.fireMarker;
    }
  }, {
    // 28CA: mana charge (both types)
    // 28CD: mana charge
    // 2B31: mana release
    id: 'O8S Thrumming Thunder Real',
    type: 'StartsUsing',
    netRegex: {
      id: ['28CD', '2B31'],
      source: 'Kefka',
      capture: false
    },
    preRun: data => data.lastThunder = 'trueThunder',
    suppressSeconds: 40,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: strings.trueThunder
    }
  }, {
    // 28CA: mana charge (both types)
    // 28CB, 28CC: mana charge
    // 2B2F, 2B30: mana release
    id: 'O8S Thrumming Thunder Fake',
    type: 'StartsUsing',
    netRegex: {
      id: ['28CC', '2B30'],
      source: 'Kefka',
      capture: false
    },
    preRun: data => data.lastThunder = 'fakeThunder',
    suppressSeconds: 40,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: strings.fakeThunder
    }
  }, {
    // 28C7: mana charge (all ice types)
    // 28C5, 28C6: mana charge
    // 2B2B, 2B2E: mana release
    id: 'O8S Blizzard Fake Donut',
    type: 'StartsUsing',
    netRegex: {
      id: ['28C5', '2B2B'],
      source: 'Kefka',
      capture: false
    },
    preRun: data => data.lastIceDir = 'getOut',
    suppressSeconds: 40,
    infoText: (_data, _matches, output) => {
      return output.text({
        type: output.type(),
        dir: output.dir()
      });
    },
    tts: (_data, _matches, output) => output.dir(),
    outputStrings: {
      text: strings.typeAndDir,
      type: strings.fakeIce,
      dir: strings.getOut
    }
  }, {
    // 28C7: mana charge (all ice types)
    // 28C9: mana charge
    // 2B2E: mana release
    id: 'O8S Blizzard True Donut',
    type: 'StartsUsing',
    netRegex: {
      id: ['28C9', '2B2E'],
      source: 'Kefka',
      capture: false
    },
    preRun: data => data.lastIceDir = 'getIn',
    suppressSeconds: 40,
    infoText: (_data, _matches, output) => {
      return output.text({
        type: output.type(),
        dir: output.dir()
      });
    },
    tts: (_data, _matches, output) => output.dir(),
    outputStrings: {
      text: strings.typeAndDir,
      type: strings.trueIce,
      dir: strings.getIn
    }
  }, {
    // 28C7: mana charge (all ice types)
    // 28C3, 28C4: mana charge
    // 2B29, 2B2A: mana release
    id: 'O8S Blizzard Fake Near',
    type: 'StartsUsing',
    netRegex: {
      id: ['28C4', '2B2A'],
      source: 'Kefka',
      capture: false
    },
    preRun: data => data.lastIceDir = 'getIn',
    suppressSeconds: 40,
    infoText: (_data, _matches, output) => {
      return output.text({
        type: output.type(),
        dir: output.dir()
      });
    },
    tts: (_data, _matches, output) => output.dir(),
    outputStrings: {
      text: strings.typeAndDir,
      type: strings.fakeIce,
      dir: strings.getIn
    }
  }, {
    // 28C7: mana charge (all ice types)
    // 28C8: mana charge
    // 2B2D: mana release
    id: 'O8S Blizzard True Near',
    type: 'StartsUsing',
    netRegex: {
      id: ['28C8', '2B2D'],
      source: 'Kefka',
      capture: false
    },
    preRun: data => data.lastIceDir = 'getOut',
    suppressSeconds: 40,
    infoText: (_data, _matches, output) => {
      return output.text({
        type: output.type(),
        dir: output.dir()
      });
    },
    tts: (_data, _matches, output) => output.dir(),
    outputStrings: {
      text: strings.typeAndDir,
      type: strings.trueIce,
      dir: strings.getOut
    }
  }, {
    id: 'O8S Ultima Upsurge',
    type: 'StartsUsing',
    netRegex: {
      id: '28E7',
      source: 'Kefka',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O8S Ultima',
    type: 'StartsUsing',
    netRegex: {
      id: '2911',
      source: 'Kefka',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Graven Image': 'heilig(?:e|er|es|en) Statue',
      'Kefka': 'Kefka',
      'Light Of Consecration': 'Licht der Weihe',
      'The limit gauge resets!': 'Der Limitrausch-Balken wurde geleert.'
    },
    'replaceText': {
      '\\(small\\)': '(klein)',
      '\\(big\\)': '(groß)',
      'Aero Assault': 'Wallendes Windga',
      'All Things Ending': 'Ende aller Dinge',
      'Blizzard Blitz': 'Erstarrendes Eisga',
      'Blizzard\\+Thunder': 'Eis+Blitz',
      'Celestriad': 'Dreigestirn',
      'Fire III': 'Feuga',
      'Flagrant Fire': 'Flammendes Feuga',
      'Forsaken': 'Verloren',
      'Graven Image': 'Göttliche Statue',
      'Gravitas': 'Gravitas',
      'Half Arena': 'Halbe Arena',
      'Heartless Angel': 'Herzloser Engel',
      'Heartless Archangel': 'Herzloser Erzengel',
      'Hyperdrive': 'Hyperantrieb',
      'Indomitable Will': 'Unzähmbarer Wille',
      'Inexorable Will': 'Unerbittlicher Wille',
      'Knockback Tethers': 'Rückstoß Verbindungen',
      'Light Of Judgment': 'Licht des Urteils',
      'Mana Charge': 'Mana-Aufladung',
      'Mana Release': 'Mana-Entladung',
      'Meteor': 'Meteor',
      'Past/Future(?! )': 'Vergangenheit/Zukunft',
      'Past/Future End': 'Vergangenheit/Zukunft Ende',
      'Pulse Wave': 'Pulswelle',
      'Revolting Ruin': 'Revoltierendes Ruinga',
      'Shockwave': 'Schockwelle',
      'Sleep/Confuse Tethers': 'Schlaf/Konfusion Verbindungen',
      'Soak': 'Aufsaugen',
      'Starstrafe': 'Sternentanz',
      'Statue Gaze': 'Statuenblick',
      'Statue Half Cleave': 'Statue Halber Cleave',
      'Thrumming Thunder': 'Brachiales Blitzga',
      'Thunder III': 'Blitzga',
      'Timely Teleport': 'Turbulenter Teleport',
      'Trine': 'Trine',
      'Ultima Upsurge': 'Ultima-Wallung',
      'Ultimate Embrace': 'Ultima-Umarmung',
      'Ultima(?![ |\\w])': 'Ultima',
      'Vitrophyre': 'Vitrophyr',
      'Wave Cannon': 'Wellenkanone',
      'Wings Of Destruction': 'Vernichtungsschwinge'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Graven Image': 'Statue divine',
      'Kefka': 'Kefka',
      'Light Of Consecration': 'lumière de la consécration',
      'The limit gauge resets!': 'La jauge de Transcendance a été réinitialisée.'
    },
    'replaceText': {
      '\\(small\\)': '(petite)',
      '\\(big\\)': '(grande)',
      'Aero Assault': 'Méga Vent véhément',
      'All Things Ending': 'Fin de toutes choses',
      'Blizzard Blitz': 'Méga Glace glissante',
      'Blizzard\\+Thunder': 'Méga Glace + Méga Foudre',
      'Celestriad': 'Tristella',
      'Fire III': 'Méga Feu',
      'Flagrant Fire': 'Méga Feu faufilant',
      'Forsaken': 'Cataclysme',
      'Graven Image': 'Statue divine',
      'Gravitas': 'Tir gravitationnel',
      'Half Arena': 'Moitié d\'arène',
      'Heartless Angel': 'Ange sans cœur',
      'Heartless Archangel': 'Archange sans cœur',
      'Hyperdrive': 'Colonne de feu',
      'Indomitable Will': 'Volonté indomptable',
      'Inexorable Will': 'Volonté inexorable',
      'Knockback Tethers': 'Liens de poussée',
      'Light Of Judgment': 'Triade guerrière',
      'Mana Charge': 'Concentration de mana',
      'Mana Release': 'Décharge de mana',
      'Meteor': 'Météore',
      'Past/Future(?! )': 'Passé/Futur',
      'Past/Future End': 'Fin du passé/futur',
      'Pulse Wave': 'Pulsation spirituelle',
      'Revolting Ruin': 'Méga Ruine ravageuse',
      'Shockwave': 'Onde de choc',
      'Sleep/Confuse Tethers': 'Liens de sommeil/confusion',
      'Soak': 'Absorber',
      'Starstrafe': 'Fou dansant',
      'Statue Gaze': 'Regard statue',
      'Statue Half Cleave': 'Demi clivage de la statue',
      'Thrumming Thunder': 'Méga Foudre fourmillante',
      'Thunder III': 'Méga Foudre',
      'Timely Teleport': 'Téléportation turbulente',
      'Trine': 'Trine',
      'Ultima Upsurge': 'Ultima ulcérante',
      'Ultimate Embrace': 'Étreinte fatidique',
      'Ultima(?![ |\\w])': 'Ultima',
      'Vitrophyre': 'Vitrophyre',
      'Wave Cannon': 'Canon plasma',
      'Wings Of Destruction': 'Aile de la destruction'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Graven Image': '神々の像',
      'Kefka': 'ケフカ',
      'Light Of Consecration': '聖別の光',
      'The limit gauge resets!': 'リミットゲージがリセットされた……'
    },
    'replaceText': {
      'Aero Assault': 'ずんずんエアロガ',
      'All Things Ending': '消滅の脚',
      'Blizzard Blitz': 'ぐるぐるブリザガ',
      'Blizzard\\+Thunder': 'ブリザガ + サンダガ',
      'Celestriad': 'スリースターズ',
      'Fire III': 'ファイガ',
      'Flagrant Fire': 'めらめらファイガ',
      'Forsaken': 'ミッシング',
      'Graven Image': '神々の像',
      'Gravitas': '重力弾',
      'Half Arena': 'フィールド半分即死',
      'Heartless Angel': '心ない天使',
      'Heartless Archangel': '心ない大天使',
      'Hyperdrive': 'ハイパードライブ',
      'Indomitable Will': '豪腕の神気',
      'Inexorable Will': '無情の神気',
      'Knockback Tethers': '吹き飛ばし 線',
      'Light Of Judgment': '裁きの光',
      'Mana Charge': 'マジックチャージ',
      'Mana Release': 'マジックアウト',
      'Meteor': 'メテオ',
      'Past/Future(?! )': '過去/未来',
      'Past/Future End': '過去/未来 終了',
      'Pulse Wave': '波動弾',
      'Revolting Ruin': 'ばりばりルインガ',
      'Shockwave': '衝撃波',
      'Sleep/Confuse Tethers': '混乱/睡眠 線',
      'Soak': '光の波動',
      'Starstrafe': '妖星乱舞',
      'Statue Gaze': '像ギミック',
      'Statue Half Cleave': '像 フィールド半分即死',
      'Thrumming Thunder': 'もりもりサンダガ',
      'Thunder III': 'サンダガ',
      'Timely Teleport': 'ぶっとびテレポ',
      'Trine': 'トライン',
      'Ultima Upsurge': 'どきどきアルテマ',
      'Ultimate Embrace': '終末の双腕',
      'Ultima(?![ |\\w])': 'アルテマ',
      'Vitrophyre': '岩石弾',
      'Wave Cannon': '波動砲',
      'Wings Of Destruction': '破壊の翼'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Graven Image': '众神之像',
      'Kefka': '凯夫卡',
      'Light Of Consecration': '祝圣之光',
      'The limit gauge resets!': '极限槽被清零了……'
    },
    'replaceText': {
      'Aero Assault': '疼飕飕暴风',
      'All Things Ending': '消灭之脚',
      'Blizzard Blitz': '滴溜溜冰封',
      'Blizzard\\+Thunder': '冰封+暴雷',
      'Celestriad': '三星',
      'Fire III': '爆炎',
      'Flagrant Fire': '呼啦啦爆炎',
      'Forsaken': '遗弃末世',
      'Graven Image': '众神之像',
      'Gravitas': '重力弹',
      'Half Arena': '半场',
      'Heartless Angel': '无心天使',
      'Heartless Archangel': '无心大天使',
      'Hyperdrive': '超驱动',
      'Indomitable Will': '强腕的神气',
      'Inexorable Will': '无情的神气',
      'Knockback Tethers': '击退连线',
      'Light Of Judgment': '制裁之光',
      'Mana Charge': '魔法储存',
      'Mana Release': '魔法放出',
      'Meteor': '陨石',
      'Past/Future(?! )': '过去/未来',
      'Past/Future End': '过去/未来 结束',
      'Pulse Wave': '波动弹',
      'Revolting Ruin': '恶狠狠毁荡',
      'Shockwave': '冲击波',
      'Sleep/Confuse Tethers': '睡眠/混乱 连线',
      'Soak': '踩',
      'Starstrafe': '妖星乱舞',
      'Statue Gaze': '神像视线',
      'Statue Half Cleave': '神像半场AOE',
      'Thrumming Thunder': '劈啪啪暴雷',
      'Thunder III': '暴雷',
      'Timely Teleport': '跳蹦蹦传送',
      'Trine': '异三角',
      'Ultima Upsurge': '扑腾腾究极',
      'Ultimate Embrace': '终末双腕',
      'Ultima(?![ |\\w])': '究极',
      'Vitrophyre': '岩石弹',
      'Wave Cannon': '波动炮',
      'Wings Of Destruction': '破坏之翼'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Graven Image': '신들의 상',
      'Kefka': '케프카',
      'Light Of Consecration': '성결의 빛',
      'The limit gauge resets!': '리미트 게이지가 초기화되었습니다…….'
    },
    'replaceText': {
      'Aero Assault': '갈기갈기 에어로가',
      'All Things Ending': '소멸의 발차기',
      'big': '큼',
      'small': '작음',
      'Blizzard Blitz': '빙글빙글 블리자가',
      'Blizzard\\+Thunder': '블리자드+선더',
      'Celestriad': '세 개의 별',
      'DPS': '딜러',
      'End(?!ing)': '종료',
      'Fire III': '파이가',
      'Flagrant Fire': '이글이글 파이가',
      'Forsaken': '행방불명',
      'Graven Image': '신들의 상',
      'Gravitas': '중력탄',
      'Half Arena': '절반 장판',
      'Heartless Angel': '비정한 천사',
      'Heartless Archangel': '비정한 대천사',
      'Hyperdrive': '하이퍼드라이브',
      'Indomitable Will': '호완의 신기',
      'Inexorable Will': '무정의 신기',
      'Knockback Tethers': '넉백 선',
      'Light Of Judgment': '심판의 빛',
      'Mana Charge': '마력 충전',
      'Mana Release': '마력 방출',
      'Meteor': '메테오',
      'Past/Future': '과거/미래',
      'Pulse Wave': '파동탄',
      'Revolting Ruin': '파삭파삭 루인가',
      'Statue Half Cleave': '전장 절반 강한 공격',
      'Shockwave': '충격파',
      'Sleep/Confuse Tethers': '수면/혼란 선',
      'Soak': '흡수',
      'Starstrafe': '요성난무',
      'Statue Gaze': '동상 작동',
      'Thrumming Thunder': '찌릿찌릿 선더가',
      'Thunder III': '선더가',
      'Timely Teleport': '껑충껑충 텔레포',
      'Trine': '트라인',
      'Ultima Upsurge': '두근두근 알테마',
      'Ultimate Embrace': '종말의 포옹',
      'Ultima(?![ |\\w])': '알테마',
      'Vitrophyre': '암석탄',
      'Wave Cannon': '파동포',
      'Wings Of Destruction': '파괴의 날개'
    }
  }]
};
/* harmony default export */ const o8s = (o8s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o8s.txt
const raid_o8s_namespaceObject = "# Omega - Sigmascape V4.0 (Savage) - O8S\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Use autos instead of InCombat lines to start timelines for door & final boss\r\n# as timeline resets out of combat.\r\n\r\n4 \"--sync--\" Ability { id: \"28C2\", source: \"Kefka\" } window 5,0\r\n13 \"Mana Charge\" Ability { id: \"28D1\", source: \"Kefka\" } window 20,20 # drift 0.476\r\n19 \"Flagrant Fire\" #Ability { id: \"28CE\", source: \"Kefka\" } # drift 0.215\r\n28 \"Hyperdrive\" Ability { id: \"28E8\", source: \"Kefka\" }\r\n36 \"Mana Release\" Ability { id: \"28D2\", source: \"Kefka\" }\r\n41 \"Flagrant Fire\" #Ability { id: \"2B32\", source: \"Kefka\" }\r\n44 \"Thrumming Thunder\" #Ability { id: \"28CA\", source: \"Kefka\" }\r\n50 \"Ultima Upsurge\" Ability { id: \"28E7\", source: \"Kefka\" }\r\n\r\n# First Graven\r\n71 \"Graven Image\" Ability { id: \"28D7\", source: \"Kefka\" }\r\n73 \"--untargetable--\" StartsUsing { id: \"2B34\", source: \"Kefka\" }\r\n75 \"Inexorable Will\" Ability { id: \"28DA\", source: \"Graven Image\" }\r\n76 \"Wave Cannon\" Ability { id: \"28DC\", source: \"Graven Image\" }\r\n79 \"Inexorable Will\" Ability { id: \"28DA\", source: \"Graven Image\" }\r\n81 \"Wave Cannon\" Ability { id: \"28DC\", source: \"Graven Image\" }\r\n83 \"Pulse Wave\" Ability { id: \"28DD\", source: \"Graven Image\" }\r\n83 \"Inexorable Will\" Ability { id: \"28DA\", source: \"Graven Image\" }\r\n86 \"Indomitable Will\" Ability { id: \"28D9\", source: \"Graven Image\" }\r\n87 \"Timely Teleport\" Ability { id: \"28D3\", source: \"Kefka\" }\r\n90 \"Revolting Ruin\" Ability { id: \"28D5\", source: \"Kefka\" }\r\n98 \"Light Of Judgment\" Ability { id: \"28D8\", source: \"Kefka\" }\r\n\r\n# Second Graven\r\n108 \"Mana Charge\" Ability { id: \"28D1\", source: \"Kefka\" }\r\n115 \"Thrumming Thunder\" #Ability { id: \"28CA\", source: \"Kefka\" }\r\n122 \"Blizzard Blitz\" #Ability { id: \"28C7\", source: \"Kefka\" }\r\n130 \"Graven Image\" Ability { id: \"28D7\", source: \"Kefka\" }\r\n139 \"Mana Release\" Ability { id: \"28D2\", source: \"Kefka\" }\r\n140 \"Shockwave\" Ability { id: \"28DB\", source: \"Graven Image\" }\r\n146 \"Blizzard+Thunder\" #Ability { id: \"2B2(E|F)\", source: \"Kefka\" }\r\n156 \"Ultima Upsurge\" Ability { id: \"28E7\", source: \"Kefka\" }\r\n163 \"Hyperdrive\" Ability { id: \"28E8\", source: \"Kefka\" }\r\n\r\n# Third Graven\r\n178 \"Graven Image\" Ability { id: \"28D7\", source: \"Kefka\" }\r\n181 \"--untargetable--\" StartsUsing { id: \"2B34\", source: \"Kefka\" }\r\n183 \"Gravitas\" Ability { id: \"28E0\", source: \"Graven Image\" }\r\n186 \"Vitrophyre\" Ability { id: \"28E2\", source: \"Graven Image\" }\r\n190 \"Half Arena\" Ability { id: \"28D(E|F)\", source: \"Graven Image\" }\r\n193 \"Gravitas\" Ability { id: \"28E0\", source: \"Graven Image\" }\r\n195 \"--targetable--\"\r\n196 \"Vitrophyre\" Ability { id: \"28E2\", source: \"Graven Image\" }\r\n200 \"Aero Assault\" Ability { id: \"28D6\", source: \"Kefka\" }\r\n208 \"Light Of Judgment\" Ability { id: \"28D8\", source: \"Kefka\" }\r\n\r\n# Fourth Graven\r\n218 \"Mana Charge\" Ability { id: \"28D1\", source: \"Kefka\" } # drift 0.296\r\n224 \"Flagrant Fire\" #Ability { id: \"28CE\", source: \"Kefka\" } # drift 0.304\r\n232 \"Ultima Upsurge\" Ability { id: \"28E7\", source: \"Kefka\" }\r\n240 \"Graven Image\" Ability { id: \"28D7\", source: \"Kefka\" } # drift 0.203\r\n245 \"Half Arena\" Ability { id: \"28D(E|F)\", source: \"Graven Image\" }\r\n246 \"Mana Release\" Ability { id: \"28D2\", source: \"Kefka\" } # drift 0.302\r\n251 \"Flagrant Fire\" #Ability { id: \"2B32\", source: \"Kefka\" }\r\n254 \"Thrumming Thunder\" #Ability { id: \"28CA\", source: \"Kefka\" }\r\n261 \"Ultima Upsurge\" Ability { id: \"28E7\", source: \"Kefka\" }\r\n268 \"Hyperdrive\" Ability { id: \"28E8\", source: \"Kefka\" }\r\n\r\n# Fifth Graven\r\n288 \"Graven Image\" Ability { id: \"28D7\", source: \"Kefka\" } # drift 0.259\r\n290 \"--untargetable--\" StartsUsing { id: \"2B34\", source: \"Kefka\" }\r\n293 \"Inexorable Will\" Ability { id: \"28DA\", source: \"Graven Image\" }\r\n293 \"Statue Gaze\" #Ability { id: \"28E(3|4)\", source: \"Graven Image\" }\r\n308 \"Statue Gaze\" Ability { id: \"28E(3|4)\", source: \"Graven Image\" } # drift -0.387\r\n310 \"Timely Teleport\" Ability { id: \"28D3\", source: \"Kefka\" }\r\n313 \"Revolting Ruin\" Ability { id: \"28D5\", source: \"Kefka\" } # drift 0.227\r\n322 \"Light Of Judgment\" Ability { id: \"28D8\", source: \"Kefka\" }\r\n329 \"Ultima Upsurge\" Ability { id: \"28E7\", source: \"Kefka\" } # drift 0.31\r\n\r\n# Sixth Graven\r\n336 \"Mana Charge\" Ability { id: \"28D1\", source: \"Kefka\" } # drift 0.256\r\n343 \"Thrumming Thunder\" #Ability { id: \"28CA\", source: \"Kefka\" }\r\n350 \"Blizzard Blitz\" #Ability { id: \"28C7\", source: \"Kefka\" }\r\n358 \"Graven Image\" Ability { id: \"28D7\", source: \"Kefka\" }\r\n363 \"Statue Gaze\" Ability { id: \"28E(3|4)\", source: \"Graven Image\" }\r\n364 \"Mana Release\" Ability { id: \"28D2\", source: \"Kefka\" }\r\n371 \"Blizzard+Thunder\" #Ability { id: \"2B2(E|F)\", source: \"Kefka\" }\r\n377 \"Hyperdrive\" Ability { id: \"28E8\", source: \"Kefka\" }\r\n\r\n# Enrage\r\n384 \"Ultima Upsurge\" Ability { id: \"28E7\", source: \"Kefka\" } # drift 0.285\r\n392 \"Ultima Upsurge\" Ability { id: \"28E7\", source: \"Kefka\" }\r\n400 \"Ultima Upsurge\" Ability { id: \"28E7\", source: \"Kefka\" }\r\n404 \"--untargetable--\"\r\n408 \"Light Of Judgment\" Ability { id: \"2A51\", source: \"Kefka\" }\r\n\r\n#############\r\n# GOD KEFKA #\r\n#############\r\n\r\n1000 \"Start\"\r\n1001 \"--sync--\" Ability { id: \"28EC\", source: \"Kefka\" } window 1001,0\r\n1006 \"--sync--\" StartsUsing { id: \"28FA\", source: \"Kefka\" } window 10,0\r\n1010 \"Heartless Angel\" Ability { id: \"28FA\", source: \"Kefka\" }\r\n1016 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n1023 \"Hyperdrive\" Ability { id: \"2912\", source: \"Kefka\" }\r\n1032 \"Celestriad\" Ability { id: \"2907\", source: \"Kefka\" }\r\n1034 \"Thunder III\" Ability { id: \"290A\", source: \"Kefka\" }\r\n1035 \"(DPS) Fire III\" Ability { id: \"290B\", source: \"Kefka\" }\r\n1041 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n\r\n# Forsaken 1\r\n1048 \"--sync--\" StartsUsing { id: \"28E9\", source: \"Kefka\" } window 120,60\r\n1053 \"Forsaken #1\" Ability { id: \"28E9\", source: \"Kefka\" }\r\n1064 \"Heartless Archangel\" Ability { id: \"28FB\", source: \"Kefka\" }\r\n1067 \"Soak\" Ability { id: \"28EA\", source: \"Light Of Consecration\" }\r\n1077 \"2x Wings Of Destruction\" Ability { id: \"2900\", source: \"Kefka\" }\r\n1083 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n1093 \"Heartless Archangel\" Ability { id: \"28FB\", source: \"Kefka\" }\r\n1096 \"Soak\" Ability { id: \"28EA\", source: \"Light Of Consecration\" }\r\n\r\n# Light 1\r\n1108 \"Light Of Judgment\" Ability { id: \"28ED\", source: \"Kefka\" }\r\n1122 \"Trine (small)\" Ability { id: \"290D\", source: \"Kefka\" }\r\n1129 \"1x Wings Of Destruction\" Ability { id: \"28FE\", source: \"Kefka\" }\r\n1140 \"2x Wings Of Destruction\" Ability { id: \"2900\", source: \"Kefka\" }\r\n1157 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n1165 \"Past/Future\" Ability { id: \"28(EF|F1)\", source: \"Kefka\" }\r\n1175 \"Ultimate Embrace\" Ability { id: \"2910\", source: \"Kefka\" }\r\n1182 \"Hyperdrive\" Ability { id: \"2912\", source: \"Kefka\" }\r\n1189 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n\r\n# Forsaken 2\r\n1201 \"--sync--\" StartsUsing { id: \"28E9\", source: \"Kefka\" } window 120,60\r\n1206 \"Forsaken #2\" Ability { id: \"28E9\", source: \"Kefka\" }\r\n1214 \"Starstrafe\" Ability { id: \"2902\", source: \"Kefka\" }\r\n1221 \"Past/Future End\" Ability { id: \"28F(5|8)\", source: \"Kefka\" }\r\n1228 \"All Things Ending\" Ability { id: \"28F6\", source: \"Kefka\" }\r\n1233 \"Meteor\" Ability { id: \"2905\", source: \"Kefka\" }\r\n\r\n# Light 2\r\n1240 \"Light Of Judgment\" Ability { id: \"28ED\", source: \"Kefka\" }\r\n1256 \"Celestriad\" Ability { id: \"2907\", source: \"Kefka\" }\r\n1258 \"Thunder III\" Ability { id: \"290A\", source: \"Kefka\" }\r\n1259 \"(DPS) Fire III\" Ability { id: \"290B\", source: \"Kefka\" }\r\n1264 \"1x Wings Of Destruction\" Ability { id: \"28FF\", source: \"Kefka\" }\r\n1271 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n1287 \"Trine (big)\" Ability { id: \"290D\", source: \"Kefka\" }\r\n1297 \"Past/Future\" Ability { id: \"28(EF|F1)\", source: \"Kefka\" }\r\n1307 \"2x Wings Of Destruction\" Ability { id: \"2900\", source: \"Kefka\" }\r\n1313 \"Ultimate Embrace\" Ability { id: \"2910\", source: \"Kefka\" }\r\n1320 \"Hyperdrive\" Ability { id: \"2912\", source: \"Kefka\" }\r\n1328 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n\r\n# Forsaken 3\r\n1340 \"--sync--\" StartsUsing { id: \"28E9\", source: \"Kefka\" } window 120,60\r\n1345 \"Forsaken #3\" Ability { id: \"28E9\", source: \"Kefka\" }\r\n1358 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n1359 \"Knockback Tethers\" Ability { id: \"28DD\", source: \"Graven Image\" }\r\n1362 \"Soak\" Ability { id: \"28EA\", source: \"Light Of Consecration\" }\r\n1364 \"Ultimate Embrace\" Ability { id: \"2910\", source: \"Kefka\" }\r\n1371 \"Sleep/Confuse Tethers\" Ability { id: \"28E(5|6)\", source: \"Graven Image\" }\r\n1377 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n1386 \"Heartless Archangel\" Ability { id: \"28FB\", source: \"Kefka\" }\r\n1389 \"Soak\" Ability { id: \"28EA\", source: \"Light Of Consecration\" }\r\n1399 \"2x Wings Of Destruction\" Ability { id: \"2900\", source: \"Kefka\" }\r\n1400 \"Soak\"\r\n1405 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n1412 \"Statue Half Cleave\" Ability { id: \"28D(E|F)\", source: \"Graven Image\" }\r\n1413 \"1x Wings Of Destruction\" Ability { id: \"28FF\", source: \"Kefka\" }\r\n\r\n# Light 3\r\n1421 \"Light Of Judgment\" Ability { id: \"28ED\", source: \"Kefka\" }\r\n1435 \"Trine (small)\" Ability { id: \"290D\", source: \"Kefka\" }\r\n1442 \"1x Wings Of Destruction\" Ability { id: \"28FF\", source: \"Kefka\" }\r\n1453 \"2x Wings Of Destruction\" Ability { id: \"2900\", source: \"Kefka\" }\r\n1459 \"Ultimate Embrace\" Ability { id: \"2910\", source: \"Kefka\" }\r\n1475 \"Trine (big)\" Ability { id: \"290D\", source: \"Kefka\" }\r\n1485 \"Past/Future\" Ability { id: \"28(EF|F1)\", source: \"Kefka\" }\r\n1496 \"Hyperdrive\" Ability { id: \"2912\", source: \"Kefka\" }\r\n1504 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n1512 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n\r\n# Forsaken 4 (repeats #3)\r\n1525 \"--sync--\" StartsUsing { id: \"28E9\", source: \"Kefka\" } window 120,60\r\n1530 \"Forsaken #4\" Ability { id: \"28E9\", source: \"Kefka\" }\r\n1543 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n1544 \"Knockback Tethers\" Ability { id: \"28DD\", source: \"Graven Image\" }\r\n1547 \"Soak\" Ability { id: \"28EA\", source: \"Light Of Consecration\" }\r\n1549 \"Ultimate Embrace\" Ability { id: \"2910\", source: \"Kefka\" }\r\n1556 \"Sleep/Confuse Tethers\" Ability { id: \"28E(5|6)\", source: \"Graven Image\" }\r\n1562 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n1571 \"Heartless Archangel\" Ability { id: \"28FB\", source: \"Kefka\" }\r\n1574 \"Soak\"\r\n1584 \"2x Wings Of Destruction\" Ability { id: \"2900\", source: \"Kefka\" }\r\n1586 \"Soak\"\r\n1590 \"Ultima\" Ability { id: \"2911\", source: \"Kefka\" }\r\n1595 \"Statue Half Cleave\"\r\n1596 \"1x Wings Of Destruction\" Ability { id: \"28FF\", source: \"Kefka\" }\r\n\r\n# Enrage\r\n1602 \"Ultima\" Ability { id: \"283D\", source: \"Kefka\" }\r\n1610 \"Ultima\" Ability { id: \"283D\", source: \"Kefka\" }\r\n1618 \"Ultima\" Ability { id: \"283D\", source: \"Kefka\" }\r\n1626 \"Ultima\" Ability { id: \"283D\", source: \"Kefka\" }\r\n1630 \"--sync--\" StartsUsing { id: \"2A52\", source: \"Kefka\" }\r\n1640 \"Enrage\" Ability { id: \"2A52\", source: \"Kefka\" } jump 0\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o9n.ts




// O9N - Alphascape 1.0
const o9n_triggerSet = {
  id: 'AlphascapeV10',
  zoneId: zone_id/* default.AlphascapeV10 */.Z.AlphascapeV10,
  timelineFile: 'o9n.txt',
  triggers: [{
    id: 'O9N Chaotic Dispersion',
    type: 'StartsUsing',
    netRegex: {
      id: '314F',
      source: 'Chaos'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O9N Orbs Fiend',
    type: 'StartsUsing',
    netRegex: {
      id: '315C',
      source: 'Chaos',
      capture: false
    },
    condition: data => data.role === 'tank' || data.job === 'BLU',
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Orb Tethers',
        de: 'Kugel-Verbindungen',
        fr: 'Liens orbes',
        ja: '線',
        cn: '连线',
        ko: '구슬 줄'
      }
    }
  }, {
    id: 'O9N Entropy',
    type: 'GainsEffect',
    // This corresponds with an 0060 headmarker.
    netRegex: {
      effectId: '640'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // Entropy comes out with 8 and 14 seconds during the Fire phase, for two sets of spreads.
    // During the midphase, it is only 14.  To make this less complicated, add a delay that
    // makes this work for all three cases.
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 6,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'O9N Dynamic Fluid',
    type: 'GainsEffect',
    // This corresponds with an 0099 headmarker.
    netRegex: {
      effectId: '641'
    },
    // Dynamic Fluid is 8 and 14 seconds during the Water phase.  During midphase, it is 20.
    // However, in all cases, there's no reason not to pre-position the donut stack.
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack for Donuts',
        de: 'Für Donuts sammeln',
        fr: 'Packez-vous pour les donuts',
        cn: '集合水环',
        ko: '모여서 도넛장판 피하기'
      }
    }
  }, {
    id: 'O9N Blaze',
    type: 'StartsUsing',
    netRegex: {
      id: '3165',
      source: 'Chaos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O9N Tsunami',
    type: 'StartsUsing',
    netRegex: {
      id: '3166',
      source: 'Chaos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O9N Cyclone',
    type: 'StartsUsing',
    netRegex: {
      id: '3167',
      source: 'Chaos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O9N Earthquake',
    type: 'StartsUsing',
    netRegex: {
      id: '3168',
      source: 'Chaos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'O9N Bowels of Agony',
    type: 'StartsUsing',
    netRegex: {
      id: '3169',
      source: 'Chaos',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'O9N Knockdown',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // This isn't quite "flare on you", because there's a follow-up large ground
        // "Big Bang" circle that appears from where this is dropped, on top of the
        // proximity damage.  So this is trying to communicate more of a GTFO.
        en: 'Drop Flare Away',
        de: 'Flare weit weg ablegen',
        fr: 'Déposez le brasier au loin',
        cn: '核爆放在远处',
        ko: '플레어 바깥으로 유도'
      }
    }
  }, {
    id: 'O9N Stack Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    // these stack markers come out in pairs, so collect them.
    run: (data, matches) => (data.stackMarker ??= []).push(matches.target)
  }, {
    id: 'O9N Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      if (data.stackMarker?.includes(data.me)) return output.stackOnYou();
      return output.stackGroups();
    },
    run: data => delete data.stackMarker,
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackGroups: {
        en: 'Split into stack groups',
        de: 'In Sammel-Gruppen aufteilen',
        fr: 'Divisez-vous en groupes packés',
        cn: '分组分摊',
        ko: '쉐어징끼리 떨어지기'
      }
    }
  }, {
    id: 'O9N Earthquake Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '3148',
      source: 'Chaos',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'O9N Cyclone Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '316D',
      source: 'Chaos',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Chaos': 'Chaos',
      'The crystal...destroyed!?': 'Ihr habt den Kristall zerstört?!',
      'YOU DARE!': 'Wie könnt ihr es wagen?!'
    },
    'replaceText': {
      'Big Bang': 'Quantengravitation',
      'Blaze': 'Flamme',
      'Bowels of Agony': 'Quälende Eingeweide',
      'Chaosphere': 'Chaossphäre',
      'Chaotic Dispersion': 'Chaos-Dispersion',
      'Cyclone': 'Tornado',
      'Damning Edict': 'Verdammendes Edikt',
      'Earthquake': 'Erdbeben',
      'Fiendish Orbs': 'Höllenkugeln',
      'Knock(?! )': 'Einschlag',
      'Long/Lat Implosion': 'Horizontale/Vertikale Implosion',
      'Soul of Chaos': 'Chaosseele',
      'Stray Flames': 'Chaosflammen',
      'Stray Spray': 'Chaosspritzer',
      'Tsunami': 'Tsunami'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Chaos': 'Chaos',
      'The crystal...destroyed!?': '... Mon cristal!?',
      'YOU DARE!': '... Mon cristal !? Impossible !'
    },
    'replaceText': {
      'Big Bang': 'Saillie',
      'Blaze': 'Flammes',
      'Bowels of Agony': 'Entrailles de l\'agonie',
      'Chaosphere': 'Sphère de chaos',
      'Chaotic Dispersion': 'Dispersion chaotique',
      'Cyclone': 'Tornade',
      'Damning Edict': 'Décret accablant',
      'Earthquake': 'Grand séisme',
      'Fiendish Orbs': 'Ordre de poursuite',
      'Knock(?! )': 'Impact',
      'Long/Lat Implosion': 'Implosion horizontale/verticale',
      'Soul of Chaos': 'Âme du chaos',
      'Stray Flames': 'Flammes du chaos',
      'Stray Spray': 'Eaux du chaos',
      'Tsunami': 'Raz-de-marée'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Chaos': 'カオス',
      'The crystal...destroyed!?': 'まさか……黒水晶を……！？',
      'YOU DARE!': 'まさか……黒水晶を……！？'
    },
    'replaceText': {
      'Big Bang': '突出せよ',
      'Blaze': 'ほのお',
      'Bowels of Agony': 'バウル・オブ・アゴニー',
      'Chaosphere': 'カオススフィア',
      'Chaotic Dispersion': 'カオティックディスパーション',
      'Cyclone': 'たつまき',
      'Damning Edict': 'ダミングイーディクト',
      'Earthquake': 'じしん',
      'Fiendish Orbs': '追尾せよ',
      'Knock(?! )': '着弾',
      'Long/Lat Implosion': 'インプロージョン 横/縦',
      'Soul of Chaos': 'ソウル・オブ・カオス',
      'Stray Flames': '混沌の炎',
      'Stray Spray': '混沌の水',
      'Tsunami': 'つなみ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Chaos': '卡奥斯',
      'The crystal...destroyed!?': '居然……把黑水晶给',
      'YOU DARE!': '居然……把黑水晶给……'
    },
    'replaceText': {
      'Big Bang': '顶起',
      'Blaze': '烈焰',
      'Bowels of Agony': '深层痛楚',
      'Chaosphere': '混沌晶球',
      'Chaotic Dispersion': '散布混沌',
      'Cyclone': '龙卷风',
      'Damning Edict': '诅咒敕令',
      'Earthquake': '大地震',
      'Fiendish Orbs': '追踪',
      'Knock(?! )': '中弹',
      'Long/Lat Implosion': '经/纬度聚爆',
      'Soul of Chaos': '混沌之魂',
      'Stray Flames': '混沌之炎',
      'Stray Spray': '混沌之水',
      'Tsunami': '海啸'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Chaos': '카오스',
      'The crystal...destroyed!?': '설마…… 흑수정을……!?',
      'YOU DARE!': '네 이노오오옴'
    },
    'replaceText': {
      'Big Bang': '돌출하라',
      'Blaze': '화염',
      'Bowels of Agony': '고통의 심핵',
      'Chaosphere': '혼돈의 구체',
      'Chaotic Dispersion': '혼돈 유포',
      'Cyclone': '회오리',
      'Damning Edict': '파멸 포고',
      'Earthquake': '대지진',
      'Fiendish Orbs': '추격하라',
      'Knock': '착탄',
      'Long/Lat Implosion': '가로/세로 내파',
      'Soul of Chaos': '혼돈의 영혼',
      'Stray Flames': '혼돈의 불',
      'Stray Spray': '혼돈의 물',
      'Tsunami': '해일'
    }
  }]
};
/* harmony default export */ const o9n = (o9n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o9n.txt
const raid_o9n_namespaceObject = "# Omega - Alphascape V1.0 - O9N\r\n# -r v7g6rkfjhNGDzLn8 -rf 2 -ii 314E 3202 3161 3164 3157 316E 315F  3162 3163 3204 3160 3203 3158 3164 3205 3148 3153\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Start branch\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n# This buster at slightly different times depending on the window.\r\n15.0 \"Chaotic Dispersion\" Ability { id: \"314F\", source: \"Chaos\" } window 15,10\r\n25.7 \"Long/Lat Implosion?\" Ability { id: \"315[12]\", source: \"Chaos\" } window 30,10 jump 1025.7\r\n28.0 \"Damning Edict?\" Ability { id: \"3150\", source: \"Chaos\" } window 30,10 jump 2028\r\n\r\n\r\n## Fire -> Air start\r\n1014.4 \"Chaotic Dispersion\" Ability { id: \"314F\", source: \"Chaos\" }\r\n1025.7 \"Long/Lat Implosion\" Ability { id: \"315[12]\", source: \"Chaos\" }\r\n1040.0 \"Blaze\" Ability { id: \"3165\", source: \"Chaos\" }\r\n1040.0 \"--sync--\" Ability { id: \"319A\", source: \"Chaos\" }\r\n1050.0 \"(T/H) Stray Flames\" Ability { id: \"316B\", source: \"Chaos\" }\r\n1056.2 \"Chaosphere\" Ability { id: \"3155\", source: \"Chaos\" }\r\n1056.2 \"(DPS) Stray Flames\" Ability { id: \"316B\", source: \"Chaos\" }\r\n1064.3 \"Knock\"\r\n1070.9 \"Knock\"\r\n1080.0 \"Big Bang\" Ability { id: \"3159\", source: \"Chaos\" }\r\n1089.5 \"Fiendish Orbs\" Ability { id: \"315B\", source: \"Chaos\" }\r\n1111.7 \"Cyclone\" Ability { id: \"3167\", source: \"Chaos\" }\r\n1111.7 \"--sync--\" Ability { id: \"319C\", source: \"Chaos\" }\r\n1127.1 \"Damning Edict\" Ability { id: \"3150\", source: \"Chaos\" }\r\n1140.3 \"Chaotic Dispersion\" Ability { id: \"314F\", source: \"Chaos\" }\r\n1152.4 \"Chaosphere\" Ability { id: \"3156\", source: \"Chaos\" }\r\n1152.5 \"Cyclone\" Ability { id: \"316D\", source: \"Chaos\" }\r\n1160.5 \"Knock\" Ability { id: \"315E\", source: \"Chaos\" }\r\n1166.6 \"Big Bang\" Ability { id: \"315A\", source: \"Chaos\" }\r\n1178.8 \"Fiendish Orbs\" Ability { id: \"315C\", source: \"Chaos\" }\r\n\r\n## Fire->Water Midphase\r\n1204.1 \"Bowels of Agony\" Ability { id: \"3169\", source: \"Chaos\" }\r\n1208.1 \"--untargetable--\"\r\n1211.6 \"--sync--\" Ability { id: \"3215\", source: \"Chaos\" }\r\n1218.3 \"Stray Flames\" Ability { id: \"316B\", source: \"Chaos\" }\r\n1224.2 \"Stray Spray\" Ability { id: \"316C\", source: \"Chaos\" }\r\n\r\n# https://xivapi.com/InstanceContentTextData/20006\r\n# en: The crystal...destroyed!? YOU DARE!\r\n1500.0 \"--sync--\" BattleTalk2 { instanceContentTextId: \"4E26\" } window 500,10\r\n1503.0 \"Soul of Chaos\" Ability { id: \"316A\", source: \"Chaos\" } window 500,10\r\n1513.1 \"--targetable--\"\r\n# fake window into Water->Earth loop\r\n1530.0 \"Chaotic Dispersion\" Ability { id: \"314F\", source: \"Chaos\" } window 50,50 jump 3015.7\r\n\r\n\r\n## Water -> Earth start\r\n2015.7 \"Chaotic Dispersion\" Ability { id: \"314F\", source: \"Chaos\" }\r\n2028.0 \"Damning Edict\" Ability { id: \"3150\", source: \"Chaos\" }\r\n2041.1 \"Tsunami\" Ability { id: \"3166\", source: \"Chaos\" }\r\n2041.1 \"--sync--\" Ability { id: \"319B\", source: \"Chaos\" }\r\n2050.0 \"(T/H) Stray Spray\" Ability { id: \"316C\", source: \"Chaos\" }\r\n2056.2 \"(DPS) Stray Spray\" Ability { id: \"316C\", source: \"Chaos\" }\r\n2057.3 \"Chaosphere\" Ability { id: \"3156\", source: \"Chaos\" }\r\n2065.4 \"Knock\" Ability { id: \"315E\", source: \"Chaos\" }\r\n2076.6 \"Big Bang\" Ability { id: \"315A\", source: \"Chaos\" }\r\n2088.8 \"Fiendish Orbs\" Ability { id: \"315C\", source: \"Chaos\" }\r\n\r\n2111.1 \"Earthquake\" Ability { id: \"3168\", source: \"Chaos\" }\r\n2111.1 \"--sync--\" Ability { id: \"319D\", source: \"Chaos\" }\r\n2125.4 \"Long/Lat Implosion\" Ability { id: \"315[12]\", source: \"Chaos\" }\r\n2139.6 \"Chaotic Dispersion\" Ability { id: \"314F\", source: \"Chaos\" }\r\n2151.8 \"Earthquake\" Ability { id: \"3418\", source: \"Chaos\" }\r\n2151.8 \"Chaosphere\" Ability { id: \"3155\", source: \"Chaos\" }\r\n2159.9 \"Knock\" Ability { id: \"315D\", source: \"Chaos\" }\r\n2166.6 \"Knock\" Ability { id: \"315D\", source: \"Chaos\" }\r\n2170.8 \"Big Bang\" Ability { id: \"3159\", source: \"Chaos\" }\r\n2180.3 \"Fiendish Orbs\" Ability { id: \"315B\", source: \"Chaos\" }\r\n\r\n2205.3 \"Bowels of Agony\" Ability { id: \"3169\", source: \"Chaos\" }\r\n2212.8 \"--sync--\" Ability { id: \"3215\", source: \"Chaos\" }\r\n2219.5 \"Stray Flames\" Ability { id: \"316B\", source: \"Chaos\" }\r\n2225.4 \"Stray Spray\" Ability { id: \"316C\", source: \"Chaos\" }\r\n\r\n# https://xivapi.com/InstanceContentTextData/20006\r\n# en: The crystal...destroyed!? YOU DARE!\r\n2500.0 \"--sync--\" BattleTalk2 { instanceContentTextId: \"4E26\" } window 500,10\r\n2503.0 \"Soul of Chaos\" Ability { id: \"316A\", source: \"Chaos\" } window 500,10\r\n# fake window into Fire->Air loop\r\n2529.5 \"Chaotic Dispersion\" Ability { id: \"314F\", source: \"Chaos\" } window 50,50 jump 3212.6\r\n\r\n\r\n#### Water -> Earth -> Fire -> Air loop\r\n\r\n# fake lookbehind window into air for reference\r\n2983.7 \"Fiendish Orbs\"\r\n\r\n## Water\r\n3015.7 \"Chaotic Dispersion\" Ability { id: \"314F\", source: \"Chaos\" }\r\n3028.0 \"Damning Edict\" Ability { id: \"3150\", source: \"Chaos\" }\r\n3041.1 \"Tsunami\" Ability { id: \"3166\", source: \"Chaos\" }\r\n3041.1 \"--sync--\" Ability { id: \"319B\", source: \"Chaos\" }\r\n3050.0 \"(T/H) Stray Spray\" Ability { id: \"316C\", source: \"Chaos\" }\r\n3056.2 \"(DPS) Stray Spray\" Ability { id: \"316C\", source: \"Chaos\" }\r\n3057.3 \"Chaosphere\" Ability { id: \"3156\", source: \"Chaos\" }\r\n3065.4 \"Knock\" Ability { id: \"315E\", source: \"Chaos\" }\r\n3076.6 \"Big Bang\" Ability { id: \"315A\", source: \"Chaos\" }\r\n3088.8 \"Fiendish Orbs\" Ability { id: \"315C\", source: \"Chaos\" }\r\n\r\n## Earth\r\n3111.1 \"Earthquake\" Ability { id: \"3168\", source: \"Chaos\" }\r\n3111.1 \"--sync--\" Ability { id: \"319D\", source: \"Chaos\" }\r\n3125.4 \"Long/Lat Implosion\" Ability { id: \"315[12]\", source: \"Chaos\" }\r\n3139.6 \"Chaotic Dispersion\" Ability { id: \"314F\", source: \"Chaos\" }\r\n3151.8 \"Earthquake\" Ability { id: \"3418\", source: \"Chaos\" }\r\n3151.8 \"Chaosphere\" Ability { id: \"3155\", source: \"Chaos\" }\r\n3159.9 \"Knock\" Ability { id: \"315D\", source: \"Chaos\" }\r\n3166.6 \"Knock\" Ability { id: \"315D\", source: \"Chaos\" }\r\n3170.8 \"Big Bang\" Ability { id: \"3159\", source: \"Chaos\" }\r\n3180.3 \"Fiendish Orbs\" Ability { id: \"315B\", source: \"Chaos\" }\r\n\r\n## Fire\r\n3212.6 \"Chaotic Dispersion\" Ability { id: \"314F\", source: \"Chaos\" }\r\n3223.9 \"Long/Lat Implosion\" Ability { id: \"315[12]\", source: \"Chaos\" }\r\n3238.2 \"Blaze\" Ability { id: \"3165\", source: \"Chaos\" }\r\n3238.2 \"--sync--\" Ability { id: \"319A\", source: \"Chaos\" }\r\n3248.2 \"(T/H) Stray Flames\" Ability { id: \"316B\", source: \"Chaos\" }\r\n3254.4 \"Chaosphere\" Ability { id: \"3155\", source: \"Chaos\" }\r\n3254.4 \"(DPS) Stray Flames\" Ability { id: \"316B\", source: \"Chaos\" }\r\n3262.5 \"Knock\"\r\n3269.1 \"Knock\"\r\n3278.2 \"Big Bang\" Ability { id: \"3159\", source: \"Chaos\" }\r\n3287.7 \"Fiendish Orbs\" Ability { id: \"315B\", source: \"Chaos\" }\r\n\r\n## Air\r\n3309.9 \"Cyclone\" Ability { id: \"3167\", source: \"Chaos\" }\r\n3309.9 \"--sync--\" Ability { id: \"319C\", source: \"Chaos\" }\r\n3325.3 \"Damning Edict\" Ability { id: \"3150\", source: \"Chaos\" }\r\n3338.5 \"Chaotic Dispersion\" Ability { id: \"314F\", source: \"Chaos\" }\r\n3350.6 \"Chaosphere\" Ability { id: \"3156\", source: \"Chaos\" }\r\n3350.7 \"Cyclone\" Ability { id: \"316D\", source: \"Chaos\" }\r\n3358.7 \"Knock\" Ability { id: \"315E\", source: \"Chaos\" }\r\n3364.8 \"Big Bang\" Ability { id: \"315A\", source: \"Chaos\" }\r\n3377.0 \"Fiendish Orbs\" Ability { id: \"315C\", source: \"Chaos\" } window 50,50 jump 2983.7\r\n\r\n# fake lookahead window into water\r\n3409.0 \"Chaotic Dispersion\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o9s.ts




// O9S - Alphascape 1.0 Savage
const o9s_triggerSet = {
  id: 'AlphascapeV10Savage',
  zoneId: zone_id/* default.AlphascapeV10Savage */.Z.AlphascapeV10Savage,
  timelineFile: 'o9s.txt',
  triggers: [
  // General actions
  {
    id: 'O9S Chaotic Dispersion',
    type: 'StartsUsing',
    netRegex: {
      id: '3170',
      source: 'Chaos'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'O9S Longitudinal Implosion',
    type: 'StartsUsing',
    netRegex: {
      id: '3172',
      source: 'Chaos',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.primordialCrust) return output.dieOnFrontBack();
    },
    infoText: (data, _matches, output) => {
      if (!data.primordialCrust) return output.sides();
    },
    outputStrings: {
      sides: {
        en: 'Sides -> Front/Back',
        de: 'Seiten -> Vorne/Hinten',
        fr: 'Côtés -> Devant/Derrière',
        ja: '横 -> 縦',
        cn: '左右 -> 前后',
        ko: '양옆 -> 앞뒤'
      },
      dieOnFrontBack: {
        en: 'Die on Front/Back -> Sides',
        de: 'Stirb Vorne/Hinten -> Seiten',
        fr: 'Mourrez devant/derrière -> Côtés',
        ja: '縦 -> 横で死ぬ',
        cn: '死：前后 -> 左右',
        ko: '앞뒤 -> 양옆 (디버프)'
      }
    }
  }, {
    id: 'O9S Latitudinal Implosion',
    type: 'StartsUsing',
    netRegex: {
      id: '3173',
      source: 'Chaos',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.primordialCrust) return output.dieOnSides();
    },
    infoText: (data, _matches, output) => {
      if (!data.primordialCrust) return output.frontBack();
    },
    outputStrings: {
      frontBack: {
        en: 'Front/Back -> Sides',
        de: 'Vorne/Hinten -> Seiten',
        fr: 'Devant/Derrière -> Côtés',
        ja: '縦 -> 横',
        cn: '前后 -> 左右',
        ko: '앞뒤 -> 양옆'
      },
      dieOnSides: {
        en: 'Die on Sides -> Front/Back',
        de: 'Stirb an Seiten -> Vorne/Hinten',
        fr: 'Mourrez sur les côtés -> Devant/Derrière',
        ja: '横 -> 縦で死ぬ',
        cn: '死：左右 -> 前后',
        ko: '양옆 -> 앞뒤 (디버프)'
      }
    }
  }, {
    id: 'O9S Damning Edict',
    type: 'StartsUsing',
    netRegex: {
      id: '3171',
      source: 'Chaos',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'O9S Orbs Fiend',
    type: 'StartsUsing',
    netRegex: {
      id: '317D',
      source: 'Chaos',
      capture: false
    },
    alarmText: (data, _matches, output) => {
      if (data.role === 'tank') return output.orbTethers();
    },
    infoText: (data, _matches, output) => {
      if (data.role === 'healer' || data.job === 'BLU') return output.orbTethers();
    },
    outputStrings: {
      orbTethers: {
        en: 'Orb Tethers',
        de: 'Kugel-Verbindungen',
        fr: 'Liens orbes',
        ja: '線出たよ',
        cn: '坦克接线注意治疗',
        ko: '구슬 연결'
      }
    }
  },
  // Fire Path
  {
    id: 'O9S Fire Phase Tracking',
    type: 'StartsUsing',
    netRegex: {
      id: '3186',
      source: 'Chaos',
      capture: false
    },
    run: data => {
      if (data.phaseType !== 'enrage') data.phaseType = 'fire';
    }
  }, {
    id: 'O9S Entropy Spread',
    type: 'GainsEffect',
    netRegex: {
      effectId: '640'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: data => {
      data.entropyCount = (data.entropyCount ?? 0) + 1;
    },
    delaySeconds: (data, matches) => {
      // Warn dps earlier to stack.
      if (data.role !== 'tank' && data.role !== 'healer' && data.entropyCount === 2) return parseFloat(matches.duration) - 12;
      return parseFloat(matches.duration) - 5;
    },
    alertText: (data, _matches, output) => {
      if (data.phaseType === 'enrage' || data.phaseType === 'orb' || data.entropyCount === 1) return output.spread();else if (data.role === 'tank' || data.role === 'healer') return output.spreadAndStay();

      // DPS entropy #2
      return output.stackAndStayOut();
    },
    run: data => {
      if (data.phaseType === 'orb' || data.entropyCount === 2) delete data.entropyCount;
    },
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread,
      spreadAndStay: {
        en: 'Spread and Stay',
        de: 'Verteilen und bleiben',
        fr: 'Dispersez-vous et restez',
        ja: '散開して待機',
        cn: '分散并停留',
        ko: '산개하고 가만히'
      },
      stackAndStayOut: {
        en: 'Stack and Stay Out',
        de: 'Stack und Bleiben',
        fr: 'Packez-vous et restez à l\'extérieur',
        ja: '中央に集合',
        cn: '中间集合',
        ko: '산개하고 바깥에 있기'
      }
    }
  }, {
    id: 'O9S Entropy Avoid Hit',
    type: 'GainsEffect',
    netRegex: {
      effectId: '640'
    },
    condition: (data, matches) => matches.target === data.me && data.phaseType === 'fire',
    delaySeconds: (_data, matches) => {
      // Folks get either the 24 second or the 10 second.
      // So, delay for the opposite minus 5.
      const seconds = parseFloat(matches.duration);
      // Got 24 seconds (dps)
      if (seconds > 11) return 5;
      // Got 10 seconds (tank)
      return 19;
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Middle',
        de: 'Zur Mitte',
        fr: 'Cachez-vous au milieu',
        ja: '中央へ',
        cn: '中间躲避',
        ko: '중앙으로 모이기'
      }
    }
  }, {
    id: 'O9S Fire Big Bang',
    type: 'StartsUsing',
    netRegex: {
      id: '3180',
      source: 'Chaos',
      capture: false
    },
    condition: data => data.phaseType === 'fire',
    // Each big bang has its own cast, so suppress.
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Middle',
        de: 'Zur Mitte',
        fr: 'Cachez-vous au milieu',
        ja: '中央へ',
        cn: '中间躲避',
        ko: '중앙으로 모이기'
      }
    }
  },
  // Water Path
  {
    id: 'O9S Water Phase Tracking',
    type: 'StartsUsing',
    netRegex: {
      id: '3187',
      source: 'Chaos',
      capture: false
    },
    run: data => {
      if (data.phaseType !== 'enrage') data.phaseType = 'water';
    }
  }, {
    id: 'O9S Dynamic Fluid 1',
    type: 'GainsEffect',
    netRegex: {
      effectId: '641',
      capture: false
    },
    condition: data => data.phaseType === 'water',
    delaySeconds: 5,
    suppressSeconds: 1,
    // T/H get 10s & DPS get 17s
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack Donut',
        de: 'Sammeln Donut',
        fr: 'Packez-vous, donut',
        ja: 'スタック',
        cn: '集合放月环',
        ko: '도넛 쉐어'
      }
    }
  }, {
    id: 'O9S Dynamic Fluid 2',
    type: 'GainsEffect',
    netRegex: {
      effectId: '641',
      capture: false
    },
    condition: data => data.phaseType === 'water',
    // T/H get 10s & DPS get 17s
    delaySeconds: 12,
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack Donut',
        de: 'Sammeln Donut',
        fr: 'Packez-vous, donut',
        ja: 'スタック',
        cn: '集合放月环',
        ko: '도넛 쉐어'
      }
    }
  }, {
    id: 'O9S Dynamic Fluid 3',
    type: 'GainsEffect',
    netRegex: {
      effectId: '641',
      capture: false
    },
    condition: data => data.phaseType === 'enrage',
    // enrage -> 6s
    delaySeconds: 1,
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack Donut',
        de: 'Sammeln Donut',
        fr: 'Packez-vous, donut',
        ja: 'スタック',
        cn: '集合放月环',
        ko: '도넛 쉐어'
      }
    }
  }, {
    id: 'O9S Knock Down Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (data, _matches, output) => {
      if (data.phaseType === 'water') return output.dropOutside();else if (data.phaseType === 'wind') return output.dropOutsideKnockback();
    },
    outputStrings: {
      dropOutside: {
        en: 'Drop Outside',
        de: 'Gehe Nord / Süd',
        fr: 'Déposez à l\'extérieur',
        ja: 'メテオ捨てて',
        cn: '远离放点名',
        ko: '바깥으로 빼기'
      },
      dropOutsideKnockback: {
        en: 'Drop Outside + Knockback',
        de: 'Geh nächste Ecke nah am Tornado',
        fr: 'Déposez à l\'extérieur + Poussée',
        ja: 'メテオ捨てて + ノックバック',
        cn: '远离放点名 + 冲回人群',
        ko: '바깥으로 빼기 + 넉백'
      }
    }
  },
  // Wind Path
  {
    id: 'O9S Wind Phase Tracking',
    type: 'StartsUsing',
    netRegex: {
      id: '3188',
      source: 'Chaos',
      capture: false
    },
    run: data => {
      if (data.phaseType !== 'enrage') data.phaseType = 'wind';
    }
  }, {
    id: 'O9S Headwind',
    type: 'GainsEffect',
    netRegex: {
      effectId: '642'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.wind = 'head'
  }, {
    id: 'O9S Tailwind',
    type: 'GainsEffect',
    netRegex: {
      effectId: '643'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.wind = 'tail'
  }, {
    id: 'O9S Cyclone Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '318F',
      source: 'Chaos',
      capture: false
    },
    alarmText: (data, _matches, output) => {
      if (data.wind === 'head') return output.backToTornado();
      if (data.wind === 'tail') return output.faceTheTornado();
    },
    run: data => delete data.wind,
    outputStrings: {
      backToTornado: {
        en: 'Back to Tornado',
        de: 'Rücken zum Tornado',
        fr: 'Derrière la tornade',
        ja: '竜巻を見ない',
        cn: '背对龙卷风',
        ko: '토네이도 뒤돌기'
      },
      faceTheTornado: {
        en: 'Face the Tornado',
        de: 'Zum Tornado hin',
        fr: 'Regardez la tornade',
        ja: '竜巻を見る',
        cn: '面对龙卷风',
        ko: '토네이도 바라보기'
      }
    }
  },
  // Earth Path
  {
    id: 'O9S Earth Phase Tracking',
    type: 'StartsUsing',
    netRegex: {
      id: '3189',
      source: 'Chaos',
      capture: false
    },
    run: data => {
      if (data.phaseType !== 'enrage') data.phaseType = 'earth';
    }
  }, {
    id: 'O9S Accretion',
    type: 'GainsEffect',
    netRegex: {
      effectId: '644',
      capture: false
    },
    condition: data => data.role === 'healer' || data.job === 'BLU',
    suppressSeconds: 10,
    infoText: (data, _matches, output) => {
      if (data.phaseType !== 'earth') return output.healAllToFull();
      return output.healTankshealersToFull();
    },
    outputStrings: {
      healAllToFull: {
        en: 'Heal All to Full',
        de: 'Alle vollheilen',
        fr: 'Soignez l\'équipe complètement',
        ja: 'HP戻して',
        cn: '奶满全队',
        ko: '전원 체력 풀피로'
      },
      healTankshealersToFull: {
        en: 'Heal Tanks/Healers to full',
        de: 'Tanks/Heiler vollheilen',
        fr: 'Soignez Heals/Tanks complètement',
        ja: 'HP戻して',
        cn: '奶满T奶',
        ko: '탱/힐 체력 풀피로'
      }
    }
  }, {
    id: 'O9S Primordial Crust',
    type: 'GainsEffect',
    netRegex: {
      effectId: '645'
    },
    condition: (data, matches) => data.me === matches.target && data.phaseType !== 'orb',
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.primordialCrust = true,
    outputStrings: {
      text: {
        en: 'Die on next mechanic',
        de: 'An nächster Mechanik tödlichen Schaden nehmen',
        fr: 'Mourrez sur la mécanique suivante',
        ja: '次のギミックで死んでね',
        cn: '想办法找死',
        ko: '다음 기믹에 맞기 (디버프)'
      }
    }
  }, {
    id: 'O9S Primordial Crust Cleanup',
    type: 'GainsEffect',
    netRegex: {
      effectId: '645'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 30,
    run: data => delete data.primordialCrust
  }, {
    id: 'O9S Earth Stack Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '003E',
      capture: false
    },
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack with partner',
        de: 'Stacks verteilen',
        fr: 'Packez-vous avec votre partenaire',
        ja: '相手と頭割り',
        cn: '与伙伴重合',
        ko: '파트너랑 모이기'
      }
    }
  },
  // Orb Phase
  {
    id: 'O9S Orb Phase Tracking',
    type: 'StartsUsing',
    netRegex: {
      id: '318A',
      source: 'Chaos',
      capture: false
    },
    preRun: data => data.phaseType = 'orb'
  }, {
    id: 'O9S Orb Entropy',
    type: 'GainsEffect',
    netRegex: {
      effectId: '640'
    },
    condition: (data, matches) => matches.target !== data.me && data.phaseType === 'orb',
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 3,
    suppressSeconds: 10,
    alertText: (data, _matches, output) => {
      if (data.head === 'wind') return output.text();
    },
    run: data => delete data.wind,
    outputStrings: {
      text: {
        en: 'Back to DPS',
        de: 'Rücken zum DPS',
        fr: 'Derrière les DPS',
        ja: 'DPSの後ろへ',
        cn: '背对DPS',
        ko: '딜러한테서 뒤돌기'
      }
    }
  }, {
    id: 'O9S Orb Dynamic Fluid',
    type: 'GainsEffect',
    netRegex: {
      effectId: '641'
    },
    condition: (data, matches) => matches.target === data.me && data.phaseType === 'orb',
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hit DPS with Water',
        de: 'töte deinen DPS',
        fr: 'Touchez les DPS avec l\'eau',
        ja: '水当てて',
        cn: '水环害死DPS',
        ko: '딜러 물 맞기'
      }
    }
  },
  // Enrage Phase
  {
    id: 'O9S Enrage Phase Tracking',
    type: 'StartsUsing',
    netRegex: {
      id: '3186',
      source: 'Chaos',
      capture: false
    },
    run: data => {
      data.blazeCount = (data.blazeCount ?? 0) + 1;
      if (data.blazeCount >= 3) data.phaseType = 'enrage';
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Chaos': 'Chaos'
    },
    'replaceText': {
      'Big Bang': 'Quantengravitation',
      'Blaze': 'Flamme',
      'Bowels of Agony': 'Quälende Eingeweide',
      'Chaotic Dispersion': 'Chaos-Dispersion',
      'Cyclone': 'Tornado',
      'Damning Edict': 'Verdammendes Edikt',
      'Earthquake': 'Erdbeben',
      'Fiendish Orbs': 'Höllenkugeln',
      'Knock(?! )': 'Einschlag',
      'Long/Lat Implosion': 'Horizontale/Vertikale Implosion',
      'Soul of Chaos': 'Chaosseele',
      'Stray Earth': 'Chaoserde',
      'Stray Flames': 'Chaosflammen',
      'Stray Gusts': 'Chaosböen',
      'Stray Spray': 'Chaosspritzer',
      'Tsunami': 'Tsunami',
      'Umbra Smash': 'Schattenschlag',
      '\\(ALL\\)': '(ALLE)'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Chaos': 'Chaos'
    },
    'replaceText': {
      '\\?': ' ?',
      'Big Bang': 'Saillie',
      'Blaze': 'Flammes',
      'Bowels of Agony': 'Entrailles de l\'agonie',
      'Chaotic Dispersion': 'Dispersion chaotique',
      'Cyclone': 'Tornade',
      'Damning Edict': 'Décret accablant',
      'Earthquake': 'Grand séisme',
      'Fiendish Orbs': 'Ordre de poursuite',
      'Knock(?! )': 'Impact',
      'Long/Lat Implosion': 'Implosion horizontale/verticale',
      'Soul of Chaos': 'Âme du chaos',
      'Stray Earth': 'Terre du chaos',
      'Stray Flames': 'Flammes du chaos',
      'Stray Gusts': 'Vent du chaos',
      'Stray Spray': 'Eaux du chaos',
      'Tsunami': 'Raz-de-marée',
      'Umbra Smash': 'Fracas ombral',
      '\\(ALL\\)': '(Tous)'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Chaos': 'カオス'
    },
    'replaceText': {
      'Big Bang': '突出',
      'Blaze': 'ほのお',
      'Bowels of Agony': 'バウル・オブ・アゴニー',
      'Chaotic Dispersion': 'カオティックディスパーション',
      'Cyclone': 'たつまき',
      'Damning Edict': 'ダミングイーディクト',
      'Earthquake': 'じしん',
      'Fiendish Orbs': '追尾せよ',
      'Knock(?! )': '着弾',
      'Long/Lat Implosion': 'インプロージョン 横/縦',
      'Soul of Chaos': 'ソウル・オブ・カオス',
      'Stray Earth': '混沌の土',
      'Stray Flames': '混沌の炎',
      'Stray Gusts': '混沌の風',
      'Stray Spray': '混沌の水',
      'Tsunami': 'つなみ',
      'Umbra Smash': 'アンブラスマッシュ',
      '\\(ALL\\)': '(全て)'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Chaos': '卡奥斯'
    },
    'replaceText': {
      'Big Bang': '돌출',
      'Blaze': '烈焰',
      'Bowels of Agony': '深层痛楚',
      'Chaotic Dispersion': '散布混沌',
      'Cyclone': '龙卷风',
      'Damning Edict': '诅咒敕令',
      'Earthquake': '地震',
      'Fiendish Orbs': '追踪',
      'Knock(?! )': '中弹',
      'Long/Lat Implosion': '经/纬聚爆',
      'Soul of Chaos': '混沌之魂',
      'Stray Earth': '混沌之土',
      'Stray Flames': '混沌之炎',
      'Stray Gusts': '混沌之风',
      'Stray Spray': '混沌之水',
      'Tsunami': '海啸',
      'Umbra Smash': '本影爆碎',
      '\\(ALL\\)': '\\(全部\\)'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Chaos': '카오스'
    },
    'replaceText': {
      'Big Bang': '돌출하라',
      'Blaze': '화염',
      'Bowels of Agony': '고통의 심핵',
      'Chaotic Dispersion': '혼돈 유포',
      'Cyclone': '회오리',
      'Damning Edict': '파멸 포고',
      'Earthquake': '지진',
      'Fiendish Orbs': '추격하라',
      'Knock(?! )': '착탄',
      'Long/Lat Implosion': '가로/세로 내파',
      'Soul of Chaos': '혼돈의 영혼',
      'Stray Earth': '혼돈의 흙',
      'Stray Flames': '혼돈의 불',
      'Stray Gusts': '혼돈의 바람',
      'Stray Spray': '혼돈의 물',
      'Tsunami': '해일',
      'Umbra Smash': '그림자 타격',
      '\\(ALL\\)': '(모두)'
    }
  }]
};
/* harmony default export */ const o9s = (o9s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/raid/o9s.txt
const raid_o9s_namespaceObject = "# Omega - Alphascape V1.0 Savage - O9S\r\n# -ii 319E 3174 3186 3176 3177 3178 3179 3182 3183 3184 3185 3187 3188 3189 319F 317A 317B 31A0 31A1 31A2 3419 3215 33C0 33C1 33C2\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n\r\n## Branch between Fire/Water paths\r\n10.7 \"--sync--\" StartsUsing { id: \"317(2|3)\", source: \"Chaos\" } window 12,12 jump 2010.1 # Long/lat means water path\r\n10.7 \"--sync--\" StartsUsing { id: \"3171\", source: \"Chaos\" } window 12,12 jump 1010.7 # Edict means fire path\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# Fake water path\r\n15.7 \"Long/Lat Implosion?\"\r\n29.7 \"Tsunami?\"\r\n38.7 \"Umbra Smash?\"\r\n40.2 \"Stray Spray?\"\r\n\r\n# Fake fire path\r\n16.7 \"Damning Edict?\"\r\n29.9 \"Blaze?\"\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n#############\r\n# Fire path #\r\n#############\r\n\r\n# Fire phase\r\n1016.7 \"Damning Edict\" Ability { id: \"3171\", source: \"Chaos\" }\r\n1029.9 \"Blaze\" Ability { id: \"3206\", source: \"Chaos\" }\r\n1041.7 \"(T/H) Stray Flames\" Ability { id: \"318C\", source: \"Chaos\" }\r\n1047.6 \"Long/Lat Implosion\" Ability { id: \"317(2|3)\", source: \"Chaos\" }\r\n1055.8 \"(DPS) Stray Flames\" Ability { id: \"318C\", source: \"Chaos\" }\r\n1066.8 \"Chaotic Dispersion\" Ability { id: \"3170\", source: \"Chaos\" }\r\n1079.1 \"Blaze\" Ability { id: \"3206\", source: \"Chaos\" } # drift 0.028\r\n1090.9 \"(T/H) Stray Flames\" Ability { id: \"318C\", source: \"Chaos\" }\r\n1098.8 \"Knock\" Ability { id: \"317E\", source: \"Chaos\" }\r\n1104.9 \"(DPS) Stray Flames\" Ability { id: \"318C\", source: \"Chaos\" }\r\n1109.8 \"Big Bang\" Ability { id: \"3180\", source: \"Chaos\" }\r\n1118.6 \"Fiendish Orbs\" Ability { id: \"317C\", source: \"Chaos\" }\r\n\r\n# Wind phase\r\n1141.0 \"Cyclone\" Ability { id: \"3208\", source: \"Chaos\" }\r\n1153.2 \"Umbra Smash\" Ability { id: \"3175\", source: \"Chaos\" }\r\n1160.7 \"Cyclone\" Ability { id: \"318F\", source: \"Chaos\" }\r\n1163.4 \"Damning Edict\" Ability { id: \"3171\", source: \"Chaos\" }\r\n1181.6 \"Chaotic Dispersion\" Ability { id: \"3170\", source: \"Chaos\" }\r\n1194.0 \"Cyclone\" Ability { id: \"3208\", source: \"Chaos\" }\r\n1207.2 \"Knock\" Ability { id: \"317F\", source: \"Chaos\" }\r\n1214.2 \"Big Bang\" Ability { id: \"3181\", source: \"Chaos\" }\r\n1225.6 \"Fiendish Orbs\" Ability { id: \"317D\", source: \"Chaos\" }\r\n\r\n# Orb phase\r\n1251.0 \"Bowels of Agony\" Ability { id: \"318A\", source: \"Chaos\" } # drift 0.04\r\n1265.1 \"(DPS) Stray Flames\" Ability { id: \"318C\", source: \"Chaos\" }\r\n1268.1 \"(T/H) Stray Spray\" Ability { id: \"318D\", source: \"Chaos\" }\r\n1293.1 \"Soul of Chaos\" Ability { id: \"318B\", source: \"Chaos\" } window 500,500\r\n\r\n# Water phase\r\n1320.1 \"Long/Lat Implosion\" Ability { id: \"317(2|3)\", source: \"Chaos\" }\r\n1334.5 \"Tsunami\" Ability { id: \"3207\", source: \"Chaos\" }\r\n1343.6 \"Umbra Smash\" Ability { id: \"3175\", source: \"Chaos\" }\r\n1345.1 \"(T/H) Stray Spray\" Ability { id: \"318D\", source: \"Chaos\" }\r\n1352.1 \"(DPS) Stray Spray\" Ability { id: \"318D\", source: \"Chaos\" }\r\n1353.8 \"Damning Edict\" Ability { id: \"3171\", source: \"Chaos\" }\r\n1371.9 \"Chaotic Dispersion\" Ability { id: \"3170\", source: \"Chaos\" }\r\n1384.3 \"Tsunami\" Ability { id: \"3207\", source: \"Chaos\" }\r\n1395.0 \"(T/H) Stray Spray\" Ability { id: \"318D\", source: \"Chaos\" }\r\n1395.4 \"Knock\" Ability { id: \"317F\", source: \"Chaos\" }\r\n1402.0 \"(DPS) Stray Spray\" Ability { id: \"318D\", source: \"Chaos\" }\r\n1402.3 \"Big Bang\" Ability { id: \"3181\", source: \"Chaos\" }\r\n1413.7 \"Fiendish Orbs\" Ability { id: \"317D\", source: \"Chaos\" }\r\n\r\n# Earth phase\r\n1436.0 \"Earthquake\" Ability { id: \"3209\", source: \"Chaos\" }\r\n1446.0 \"Earthquake\" Ability { id: \"3190\", source: \"Chaos\" }\r\n1449.6 \"Long/Lat Implosion\" Ability { id: \"317(2|3)\", source: \"Chaos\" }\r\n1468.8 \"Chaotic Dispersion\" Ability { id: \"3170\", source: \"Chaos\" }\r\n1491.1 \"Earthquake\" Ability { id: \"3190\", source: \"Chaos\" }\r\n1494.2 \"Knock\" Ability { id: \"317E\", source: \"Chaos\" }\r\n1499.1 \"Big Bang\" Ability { id: \"3180\", source: \"Chaos\" }\r\n1507.9 \"Fiendish Orbs\" Ability { id: \"317C\", source: \"Chaos\" }\r\n\r\n# Enrage phase\r\n1538.4 \"Blaze\" Ability { id: \"3206\", source: \"Chaos\" }\r\n1546.1 \"(ALL) Stray Flames\" Ability { id: \"318C\", source: \"Chaos\" }\r\n1551.4 \"Tsunami\" Ability { id: \"3207\", source: \"Chaos\" }\r\n1558.0 \"(ALL) Stray Spray\" Ability { id: \"318D\", source: \"Chaos\" }\r\n1564.6 \"Cyclone\" Ability { id: \"3208\", source: \"Chaos\" }\r\n1571.3 \"Stray Gusts\"\r\n1577.6 \"Earthquake\" Ability { id: \"3209\", source: \"Chaos\" }\r\n1585.9 \"Stray Earth\"\r\n\r\n##############\r\n# Water Path #\r\n##############\r\n\r\n# Water phase\r\n2015.7 \"Long/Lat Implosion\" Ability { id: \"317(2|3)\", source: \"Chaos\" }\r\n2029.7 \"Tsunami\" Ability { id: \"3207\", source: \"Chaos\" }\r\n2038.7 \"Umbra Smash\" Ability { id: \"3175\", source: \"Chaos\" }\r\n2040.2 \"(T/H) Stray Spray\" Ability { id: \"318D\", source: \"Chaos\" }\r\n2048.8 \"Damning Edict\" Ability { id: \"3171\", source: \"Chaos\" }\r\n2066.8 \"Chaotic Dispersion\" Ability { id: \"3170\", source: \"Chaos\" }\r\n2078.8 \"Tsunami\" Ability { id: \"3207\", source: \"Chaos\" }\r\n2089.6 \"Knock\" Ability { id: \"317F\", source: \"Chaos\" }\r\n# TODO: Stray Spray may be incorrect - see comments on OverlayPlugin/cactbot#106\r\n2096.3 \"(T/H) Stray Spray\" Ability { id: \"318D\", source: \"Chaos\" }\r\n2096.3 \"(DPS) Stray Spray\" Ability { id: \"318D\", source: \"Chaos\" }\r\n2096.5 \"Big Bang\" Ability { id: \"3181\", source: \"Chaos\" }\r\n2107.8 \"Fiendish Orbs\" Ability { id: \"317D\", source: \"Chaos\" }\r\n\r\n# Earth phase\r\n2129.8 \"Earthquake\" Ability { id: \"3209\", source: \"Chaos\" }\r\n2139.8 \"Earthquake\" Ability { id: \"3190\", source: \"Chaos\" }\r\n2143.3 \"Long/Lat Implosion\" Ability { id: \"317(2|3)\", source: \"Chaos\" }\r\n2162.3 \"Chaotic Dispersion\" Ability { id: \"3170\", source: \"Chaos\" }\r\n2174.3 \"Earthquake\" Ability { id: \"3209\", source: \"Chaos\" }\r\n2184.3 \"Earthquake\" Ability { id: \"3190\", source: \"Chaos\" }\r\n2187.2 \"Knock\" Ability { id: \"317E\", source: \"Chaos\" }\r\n2192.0 \"Big Bang\" Ability { id: \"3180\", source: \"Chaos\" }\r\n2200.6 \"Fiendish Orbs\" Ability { id: \"317C\", source: \"Chaos\" }\r\n\r\n# Orb phase\r\n2225.6 \"Bowels of Agony\" Ability { id: \"318A\", source: \"Chaos\" } # drift 0.038\r\n2239.6 \"(DPS) Stray Flames\" Ability { id: \"318C\", source: \"Chaos\" }\r\n2242.6 \"(T/H) Stray Spray\" Ability { id: \"318D\", source: \"Chaos\" }\r\n2267.6 \"Soul of Chaos\" Ability { id: \"318B\", source: \"Chaos\" } window 500,500\r\n\r\n# Fire phase\r\n2295.3 \"Damning Edict\" Ability { id: \"3171\", source: \"Chaos\" }\r\n2308.3 \"Blaze\" Ability { id: \"3206\", source: \"Chaos\" }\r\n2320.0 \"(T/H) Stray Flames\" Ability { id: \"318C\", source: \"Chaos\" }\r\n2325.8 \"Long/Lat Implosion\" Ability { id: \"317(2|3)\", source: \"Chaos\" }\r\n2334.0 \"(DPS) Stray Flames\" Ability { id: \"318C\", source: \"Chaos\" }\r\n2344.8 \"Chaotic Dispersion\" Ability { id: \"3170\", source: \"Chaos\" }\r\n2356.8 \"Blaze\" Ability { id: \"3206\", source: \"Chaos\" }\r\n2368.5 \"(T/H) Stray Flames\" Ability { id: \"318C\", source: \"Chaos\" }\r\n2376.2 \"Knock\" Ability { id: \"317E\", source: \"Chaos\" }\r\n2382.5 \"(DPS) Stray Flames\" Ability { id: \"318C\", source: \"Chaos\" }\r\n2387.0 \"Big Bang\" Ability { id: \"3180\", source: \"Chaos\" }\r\n2395.6 \"Fiendish Orbs\" Ability { id: \"317C\", source: \"Chaos\" }\r\n\r\n# Wind phase\r\n2417.6 \"Cyclone\" Ability { id: \"3208\", source: \"Chaos\" }\r\n2429.6 \"Umbra Smash\" Ability { id: \"3175\", source: \"Chaos\" }\r\n2437.1 \"Cyclone\" Ability { id: \"318F\", source: \"Chaos\" }\r\n2439.7 \"Damning Edict\" Ability { id: \"3171\", source: \"Chaos\" }\r\n2457.7 \"Chaotic Dispersion\" Ability { id: \"3170\", source: \"Chaos\" }\r\n2469.7 \"Cyclone\" Ability { id: \"3208\", source: \"Chaos\" }\r\n2482.6 \"Knock\" Ability { id: \"317F\", source: \"Chaos\" }\r\n2482.7 \"Cyclone\" Ability { id: \"318F\", source: \"Chaos\" }\r\n2489.4 \"Big Bang\" Ability { id: \"3181\", source: \"Chaos\" }\r\n2500.7 \"Fiendish Orbs\" Ability { id: \"317D\", source: \"Chaos\" }\r\n\r\n# Enrage phase\r\n2530.8 \"Blaze\" Ability { id: \"3206\", source: \"Chaos\" }\r\n2538.5 \"(ALL) Stray Flames\" Ability { id: \"318C\", source: \"Chaos\" }\r\n2543.8 \"Tsunami\" Ability { id: \"3207\", source: \"Chaos\" }\r\n2550.4 \"(ALL) Stray Spray\" Ability { id: \"318D\", source: \"Chaos\" }\r\n2556.9 \"Cyclone\" Ability { id: \"3208\", source: \"Chaos\" }\r\n2563.5 \"Stray Gusts\"\r\n2569.7 \"Earthquake\" Ability { id: \"3209\", source: \"Chaos\" }\r\n2578.0 \"Stray Earth\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/byakko-ex.ts



// Byakko Extreme
const byakko_ex_triggerSet = {
  id: 'TheJadeStoaExtreme',
  zoneId: zone_id/* default.TheJadeStoaExtreme */.Z.TheJadeStoaExtreme,
  timelineFile: 'byakko-ex.txt',
  triggers: [{
    id: 'ByaEx Heavenly Strike',
    type: 'StartsUsing',
    netRegex: {
      id: '27DA',
      source: 'Byakko'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'ByaEx Flying Donut',
    type: 'StartsUsing',
    netRegex: {
      id: '27F4',
      source: 'Byakko',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'ByaEx Sweep The Leg',
    type: 'StartsUsing',
    netRegex: {
      id: '27DB',
      source: 'Byakko',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'ByaEx Storm Pulse',
    type: 'StartsUsing',
    netRegex: {
      id: '27DC',
      source: 'Byakko',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'ByaEx Distant Clap',
    type: 'StartsUsing',
    netRegex: {
      id: '27DD',
      source: 'Byakko',
      target: 'Byakko',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Distant Clap',
        de: 'Donnergrollen',
        fr: 'Tonnerre lointain',
        ja: '遠雷',
        cn: '远雷',
        ko: '원뢰'
      }
    }
  }, {
    id: 'ByaEx State Of Shock Tank 1',
    type: 'StartsUsing',
    netRegex: {
      id: '27E0',
      source: 'Byakko'
    },
    condition: (data, matches) => data.role === 'tank' && matches.target !== data.me,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Provoke Boss',
        de: 'Boss abspotten',
        fr: 'Provoquez le Boss',
        ja: '挑発',
        cn: '挑衅',
        ko: '보스 도발'
      }
    }
  }, {
    id: 'ByaEx State Of Shock Tank 2',
    type: 'StartsUsing',
    netRegex: {
      id: '27E0',
      source: 'Byakko'
    },
    condition: (data, matches) => data.role === 'tank' && matches.target === data.me,
    delaySeconds: 12,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Provoke Boss',
        de: 'Boss abspotten',
        fr: 'Provoquez le Boss',
        ja: '挑発',
        cn: '挑衅',
        ko: '보스 도발'
      }
    }
  }, {
    id: 'ByaEx Roar Counter',
    type: 'StartsUsing',
    netRegex: {
      id: '27F9',
      source: 'Hakutei',
      capture: false
    },
    run: data => {
      data.roarCount = (data.roarCount ?? 0) + 1;
    }
  }, {
    id: 'ByaEx Roar of Thunder',
    type: 'StartsUsing',
    netRegex: {
      id: '27F9',
      source: 'Hakutei',
      capture: false
    },
    delaySeconds: 14,
    alarmText: (data, _matches, output) => {
      if (data.roarCount !== 2) return;
      if (data.role === 'tank' || data.job === 'BLU') return output.text();
    },
    outputStrings: {
      text: {
        en: 'Tank LB NOW',
        de: 'JETZT Tank LB',
        fr: 'Transcendance Tank maintenant !',
        ja: '今タンクLB',
        cn: '坦克LB',
        ko: '탱리밋'
      }
    }
  }, {
    id: 'ByaEx Bubble',
    type: 'HeadMarker',
    netRegex: {
      id: '0065'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop bubble outside',
        de: 'Blase außen ablegen',
        fr: 'Déposez la bulle à l\'extérieur',
        ja: '外にマーカーを置く',
        cn: '边缘放点名',
        ko: '장판 바깥에 깔기'
      }
    }
  }, {
    id: 'ByaEx Ominous Wind',
    type: 'GainsEffect',
    netRegex: {
      effectId: '5C9'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pink bubble',
        de: 'Pinke Blase',
        fr: 'Bulle violette',
        ja: '祟り目',
        cn: '泡泡',
        ko: '핑크 구슬'
      }
    }
  }, {
    id: 'ByaEx Puddle Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0004'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Puddles on YOU',
        de: 'Pfützen auf DIR',
        fr: 'Zones au sol sur VOUS',
        ja: '自分に床範囲',
        cn: '点名',
        ko: '장판 바깥에 깔기 (3번)'
      }
    }
  }, {
    id: 'ByaEx G100',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get away',
        de: 'Weg da',
        fr: 'Éloignez-vous',
        ja: '離れる',
        cn: '远离',
        ko: '멀리가기'
      }
    }
  },
  // https://xivapi.com/InstanceContentTextData/18606
  // en: Twofold is my wrath, twice-cursed my foes!
  {
    id: 'ByaEx Tiger Add',
    type: 'BattleTalk2',
    netRegex: {
      instanceContentTextId: '48AE',
      capture: false
    },
    condition: data => data.role === 'tank' || data.job === 'BLU',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tiger Add',
        de: 'Tiger Add',
        fr: 'Add Tigre',
        ja: '虎分離',
        cn: '虎分离',
        ko: '호랑이 쫄'
      }
    }
  }, {
    id: 'ByaEx Stake Counter',
    type: 'StartsUsing',
    netRegex: {
      id: '27E2',
      source: 'Byakko',
      capture: false
    },
    run: data => {
      data.stakeCount = (data.stakeCount ?? 0) + 1;
    }
  }, {
    id: 'ByaEx Stake Counter Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '27E2',
      source: 'Byakko',
      capture: false
    },
    delaySeconds: 20,
    run: data => delete data.stakeCount
  }, {
    id: 'ByaEx Highest Stakes',
    type: 'StartsUsing',
    netRegex: {
      id: '27E2',
      source: 'Byakko',
      capture: false
    },
    infoText: (data, _matches, output) => output.text({
      num: data.stakeCount
    }),
    outputStrings: {
      text: {
        en: 'Stack #${num}',
        de: 'Stack #${num}',
        fr: 'Packez-vous #${num}',
        ja: '頭割り #${num}',
        cn: '集合 #${num}',
        ko: '쉐어 #${num}'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Byakko': 'Byakko',
      'Hakutei': 'Hakutei',
      'Twofold is my wrath, twice-cursed my foes!': 'Stürmt los, meine zwei Gesichter!'
    },
    'replaceText': {
      '--Hakutei Add--': '--Hakutei Add--',
      '--leap north--': '--Sprung nach Norden--',
      '--tiger targetable--': '--Tiger anvisierbar--',
      '--tiger untargetable--': '--Tiger nicht anvisierbar--',
      'Answer On High': 'Himmlische Antwort',
      'Bombogenesis': 'Plötzliches Orkantief',
      'Clutch': 'Umklammerung',
      'Dance Of The Incomplete': 'Tanz der zwei Gesichter',
      'Distant Clap': 'Donnergrollen',
      'Fell Swoop': 'Auf einen Streich',
      'Fire and Lightning': 'Feuer und Blitz',
      'Gale Force': 'Orkan',
      'Heavenly Strike': 'Himmlischer Schlag',
      'Highest Stakes': 'Höchstes Risiko',
      'Hundredfold Havoc': 'Hundertfache Verwüstung',
      'Imperial Guard': 'Herbststurm',
      'Ominous Wind': 'Unheilvoller Wind',
      'State of Shock': 'Bannblitze',
      'Steel Claw': 'Stahlklaue',
      'Storm Pulse': 'Gewitterwelle',
      'Sweep the Leg': 'Vertikalität',
      'The Roar Of Thunder': 'Brüllen des Donners',
      'The Voice Of Thunder': 'Stimme des Donners',
      'Unrelenting Anguish': 'Pandämonium',
      'White Herald': 'Herbstböe'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Byakko': 'Byakko',
      'Hakutei': 'Hakutei',
      'Twofold is my wrath, twice-cursed my foes!': 'Ma colère devient double !'
    },
    'replaceText': {
      '--Hakutei Add--': '--Add Hakutei--',
      '--leap north--': '--saut au nord--',
      '--tiger targetable--': '--tigre ciblable--',
      '--tiger untargetable--': '--tigre non ciblable--',
      'Answer On High': 'Foudre céleste',
      'Bombogenesis': 'Bombogénèse',
      'Clutch': 'Empoignement',
      'Dance Of The Incomplete': 'Danse semi-bestiale',
      'Distant Clap': 'Tonnerre lointain',
      'Fell Swoop': 'Éléments déchaînés',
      'Fire and Lightning': 'Feu et foudre',
      'Gale Force': 'Coup de rafale',
      'Heavenly Strike': 'Frappe céleste',
      'Highest Stakes': 'Tout pour le tout',
      'Hundredfold Havoc': 'Ravages centuples',
      'Imperial Guard': 'Garde impériale',
      'Ominous Wind': 'Vent mauvais',
      'State of Shock': 'Foudroiement brutal',
      'Steel Claw': 'Griffe d\'acier',
      'Storm Pulse': 'Pulsion de tempête',
      'Sweep the Leg': 'Verticalité',
      'The Roar Of Thunder': 'Rugissement du tonnerre',
      'The Voice Of Thunder': 'Voix du tonnerre',
      'Unrelenting Anguish': 'Douleur continuelle',
      'White Herald': 'Héraut blanc'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Byakko': '白虎',
      'Hakutei': '白帝',
      'Twofold is my wrath, twice-cursed my foes!': '駆けろ、我が半身ッ！歯向かう者どもに、牙と爪を突き立ててやれ！'
    },
    'replaceText': {
      '--leap north--': '--北に飛ぶ--',
      '--tiger untargetable--': '--白帝タゲ不可--',
      'Answer On High': '天つ雷',
      'Bombogenesis': '爆弾低気圧',
      'Clutch': '掌握',
      'Dance Of The Incomplete': '半獣舞踏',
      'Distant Clap': '遠雷',
      'Fell Swoop': '迅雷風烈波',
      'Fire and Lightning': '雷火一閃',
      'Gale Force': '暴風',
      'Heavenly Strike': '天雷掌',
      'Highest Stakes': '乾坤一擲',
      'Hundredfold Havoc': '百雷繚乱',
      'Imperial Guard': '白帝一陣',
      'Ominous Wind': '祟り風',
      'State of Shock': '呪縛雷',
      'Steel Claw': '鉄爪斬',
      'Storm Pulse': '風雷波動',
      'Sweep the Leg': '旋体脚',
      'The Roar Of Thunder': '雷轟',
      'The Voice Of Thunder': '雷声',
      'Unrelenting Anguish': '無間地獄',
      'White Herald': '白帝衝'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Byakko': '白虎',
      'Hakutei': '白帝',
      'Twofold is my wrath, twice-cursed my foes!': '半身分离，助我杀敌！向胆敢抵抗的家伙们露出你的爪牙！'
    },
    'replaceText': {
      '--Hakutei Add--': '--白帝出现--',
      '--leap north--': '--跳北--',
      '--tiger targetable--': '--白帝可选中--',
      '--tiger untargetable--': '--白帝无法选中--',
      'Answer On High': '天雷',
      'Bombogenesis': '炸弹低气压',
      'Clutch': '紧握',
      'Dance Of The Incomplete': '半兽舞蹈',
      'Distant Clap': '远雷',
      'Fell Swoop': '迅雷风烈波',
      'Fire and Lightning': '雷火一闪',
      'Gale Force': '暴风',
      'Heavenly Strike': '天雷掌',
      'Highest Stakes': '乾坤一掷',
      'Hundredfold Havoc': '百雷缭乱',
      'Imperial Guard': '白帝降临',
      'Ominous Wind': '妖风',
      'State of Shock': '咒缚雷',
      'Steel Claw': '铁爪斩',
      'Storm Pulse': '风雷波动',
      'Sweep the Leg': '旋体脚',
      'The Roar Of Thunder': '雷轰',
      'The Voice Of Thunder': '雷声',
      'Unrelenting Anguish': '无间地狱',
      'White Herald': '白帝冲'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Byakko': '백호',
      'Hakutei': '하얀 제왕',
      'Twofold is my wrath, twice-cursed my foes!': '달려라! 나의 반신이여! 맞서는 자들에게 이빨과 발톱을 찔러넣어라!'
    },
    'replaceText': {
      '--Hakutei Add--': '--하얀 제왕 등장--',
      '--leap north--': '--보스 북쪽으로 이동--',
      '--tiger targetable--': '--호랑이 타겟가능--',
      '--tiger untargetable--': '--호랑이 타겟불가--',
      'Answer On High': '하늘의 번개',
      'Bombogenesis': '폭탄 저기압',
      'Clutch': '장악',
      'Dance Of The Incomplete': '반수의 춤',
      'Distant Clap': '원뢰',
      'Fell Swoop': '신뢰풍렬파',
      'Fire and Lightning': '뇌화일섬',
      'Gale Force': '폭풍',
      'Heavenly Strike': '천뢰장',
      'Highest Stakes': '건곤일척',
      'Hundredfold Havoc': '백뢰요란',
      'Imperial Guard': '제왕의 진격',
      'Ominous Wind': '불길한 바람',
      'State of Shock': '주박뢰',
      'Steel Claw': '강철 발톱',
      'Storm Pulse': '풍뢰파동',
      'Sweep the Leg': '돌려차기',
      'The Roar Of Thunder': '뇌굉',
      'The Voice Of Thunder': '뇌성',
      'Unrelenting Anguish': '무간지옥',
      'White Herald': '제왕의 충격'
    }
  }]
};
/* harmony default export */ const byakko_ex = (byakko_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/byakko-ex.txt
const trial_byakko_ex_namespaceObject = "### Byakko Extreme\r\n# -p 27DC:10.9\r\n# -it Hakutei / -it Byakko\r\n# -ii 27E3 27F6 265D 29A3 27EF 27F0 25CF 27F4 27E6 2944 27E9\r\n\r\nhideall \"--sync--\"\r\nhideall \"--Reset--\"\r\n# not useful to see\r\nhideall \"Answer On High\"\r\n\r\n### Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n10.9 \"Storm Pulse\" Ability { id: \"27DC\", source: \"Byakko\" } window 11,5\r\n17.1 \"Heavenly Strike\" Ability { id: \"27DA\", source: \"Byakko\" }\r\n27.3 \"State of Shock 1\" Ability { id: \"27E0\", source: \"Byakko\" }\r\n28.5 \"Clutch\" Ability { id: \"27E1\", source: \"Byakko\" }\r\n34.7 \"Highest Stakes\" Ability { id: \"27E2\", source: \"Byakko\" }\r\n37.5 \"State of Shock 2\" Ability { id: \"2756\", source: \"Byakko\" }\r\n38.5 \"Clutch\" Ability { id: \"27E1\", source: \"Byakko\" }\r\n44.7 \"Highest Stakes\" Ability { id: \"27E2\", source: \"Byakko\" }\r\n\r\n55.5 \"--middle--\" Ability { id: \"2757\", source: \"Byakko\" }\r\n59.6 \"Unrelenting Anguish\" Ability { id: \"27ED\", source: \"Byakko\" }\r\n65.8 \"Storm Pulse\" Ability { id: \"27DC\", source: \"Byakko\" }\r\n68.0 \"Ominous Wind\" Ability { id: \"27EB\", source: \"Byakko\" }\r\n77.4 \"Fire and Lightning\" Ability { id: \"27D9\", source: \"Byakko\" }\r\n85.7 \"--leap north--\" Ability { id: \"2757\", source: \"Byakko\" }\r\n87.3 \"Dance Of The Incomplete\" Ability { id: \"25D1\", source: \"Byakko\" }\r\n92.2 \"--Hakutei Add--\"\r\n103.4 \"Storm Pulse\" Ability { id: \"27DC\", source: \"Byakko\" }\r\n103.4 \"Steel Claw\" Ability { id: \"27DF\", source: \"Hakutei\" }\r\n109.6 \"Steel Claw\" Ability { id: \"27DF\", source: \"Hakutei\" }\r\n113.7 \"Heavenly Strike\" Ability { id: \"27DA\", source: \"Byakko\" }\r\n116.6 \"--tiger untargetable--\"\r\n122.4 \"White Herald\" Ability { id: \"27FA\", source: \"Hakutei\" }\r\n124.4 \"--tiger targetable--\"\r\n124.8 \"Distant Clap\" Ability { id: \"27DD\", source: \"Byakko\" }\r\n128.6 \"Fire and Lightning\" Ability { id: \"27DE\", source: \"Hakutei\" }\r\n133.0 \"Storm Pulse\" Ability { id: \"27DC\", source: \"Byakko\" }\r\n135.1 \"--untargetable--\"\r\n135.2 \"--sync--\" Ability { id: \"265E\", source: \"Hakutei\" }\r\n136.6 \"The Voice Of Thunder\" Ability { id: \"27F7\", source: \"Hakutei\" }\r\n159.8 \"The Roar Of Thunder\" Ability { id: \"27F9\", source: \"Hakutei\" }\r\n162.9 \"--untargetable--\"\r\n\r\n\r\n### Phase 2: zzz x infinity\r\n191.1 \"--sync--\" Ability { id: \"27EE\", source: \"Byakko\" } window 200,5\r\n197.2 \"Sweep the Leg\" Ability { id: \"27F3\", source: \"Byakko\" }\r\n208.1 \"Imperial Guard\" Ability { id: \"27F1\", source: \"Hakutei\" }\r\n208.4 \"--sync--\" Ability { id: \"27EE\", source: \"Byakko\" }\r\n220.2 \"Imperial Guard\" Ability { id: \"27F1\", source: \"Hakutei\" }\r\n222.6 \"--sync--\" Ability { id: \"27EE\", source: \"Byakko\" }\r\n228.7 \"Sweep the Leg\" Ability { id: \"27F3\", source: \"Byakko\" }\r\n237.3 \"Imperial Guard\" Ability { id: \"27F1\", source: \"Hakutei\" }\r\n\r\n\r\n### Phase 3: More Bubbles\r\n250.1 \"--sync--\" Ability { id: \"2A2A\", source: \"Byakko\" }\r\n265.1 \"Fell Swoop\" Ability { id: \"27FB\", source: \"Byakko\" } window 300,10\r\n284.4 \"Heavenly Strike\" Ability { id: \"27DA\", source: \"Byakko\" }\r\n290.5 \"Answer On High\" Ability { id: \"27E4\", source: \"Byakko\" }\r\n295.6 \"Hundredfold Havoc\" Ability { id: \"27E5\", source: \"Byakko\" } duration 3.2\r\n296.6 \"State of Shock 1\" Ability { id: \"27E0\", source: \"Byakko\" }\r\n297.7 \"Clutch\" Ability { id: \"27E1\", source: \"Byakko\" }\r\n298.6 \"Hundredfold Havoc\" Ability { id: \"27E5\", source: \"Byakko\" } duration 3.2\r\n304.0 \"Highest Stakes\" Ability { id: \"27E2\", source: \"Byakko\" }\r\n306.9 \"State of Shock 2\" Ability { id: \"2756\", source: \"Byakko\" }\r\n307.9 \"Clutch\" Ability { id: \"27E1\", source: \"Byakko\" }\r\n314.1 \"Highest Stakes\" Ability { id: \"27E2\", source: \"Byakko\" }\r\n320.8 \"Sweep the Leg\" Ability { id: \"27DB\", source: \"Byakko\" }\r\n\r\n330.9 \"--sync--\" Ability { id: \"2757\", source: \"Byakko\" } window 10,10\r\n335.2 \"Unrelenting Anguish\" Ability { id: \"27ED\", source: \"Byakko\" }\r\n341.4 \"Storm Pulse x2\" Ability { id: \"27DC\", source: \"Byakko\" }\r\n345.6 \"Bombogenesis\" Ability { id: \"27E7\", source: \"Byakko\" }\r\n351.6 \"Ominous Wind\" Ability { id: \"27EB\", source: \"Byakko\" }\r\n353.6 \"Gale Force\" Ability { id: \"27E8\", source: \"Byakko\" }\r\n361.0 \"Fire and Lightning\" Ability { id: \"27D9\", source: \"Byakko\" }\r\n364.1 \"--north--\" Ability { id: \"2757\", source: \"Byakko\" }\r\n369.9 \"Fire and Lightning\" Ability { id: \"27D9\", source: \"Byakko\" }\r\n\r\n373.1 \"--sync--\" Ability { id: \"2757\", source: \"Byakko\" }\r\n374.5 \"Dance Of The Incomplete\" Ability { id: \"25D1\", source: \"Byakko\" }\r\n379.5 \"--tiger targetable--\"\r\n388.8 \"--tiger untargetable--\"\r\n394.5 \"White Herald\" Ability { id: \"27FA\", source: \"Hakutei\" }\r\n396.5 \"--tiger targetable--\"\r\n396.8 \"Distant Clap\" Ability { id: \"27DD\", source: \"Byakko\" }\r\n400.7 \"Fire and Lightning\" Ability { id: \"27DE\", source: \"Hakutei\" }\r\n405.0 \"Distant Clap\" Ability { id: \"27DD\", source: \"Byakko\" }\r\n408.9 \"Fire and Lightning\" Ability { id: \"27DE\", source: \"Hakutei\" }\r\n416.1 \"Steel Claw\" Ability { id: \"27DF\", source: \"Hakutei\" }\r\n416.4 \"Heavenly Strike\" Ability { id: \"27DA\", source: \"Byakko\" }\r\n422.4 \"--sync--\" Ability { id: \"265E\", source: \"Hakutei\" }\r\n423.9 \"The Voice Of Thunder\" Ability { id: \"27F7\", source: \"Hakutei\" }\r\n436.5 \"Storm Pulse x2\" Ability { id: \"27DC\", source: \"Byakko\" }\r\n447.1 \"The Roar Of Thunder\" Ability { id: \"27F9\", source: \"Hakutei\" }\r\n450.6 \"--sync--\" Ability { id: \"29E5\", source: \"Hakutei\" }\r\n\r\n451.5 \"--sync--\" Ability { id: \"29E4\", source: \"Byakko\" }\r\n453.5 \"--sync--\" Ability { id: \"2757\", source: \"Byakko\" }\r\n459.3 \"Fire and Lightning\" Ability { id: \"27D9\", source: \"Byakko\" }\r\n474.5 \"Storm Pulse x2\" Ability { id: \"27DC\", source: \"Byakko\" }\r\n484.8 \"Bombogenesis\" Ability { id: \"27E7\", source: \"Byakko\" }\r\n487.0 \"Answer On High\" Ability { id: \"27E4\", source: \"Byakko\" }\r\n492.0 \"Hundredfold Havoc\" Ability { id: \"27E5\", source: \"Byakko\" } duration 3.2\r\n492.9 \"Gale Force\" Ability { id: \"27E8\", source: \"Byakko\" }\r\n495.1 \"Hundredfold Havoc\" Ability { id: \"27E5\", source: \"Byakko\" } duration 3.2\r\n495.8 \"State of Shock 1\" Ability { id: \"27E0\", source: \"Byakko\" }\r\n496.9 \"Clutch\" Ability { id: \"27E1\", source: \"Byakko\" }\r\n503.2 \"Highest Stakes\" Ability { id: \"27E2\", source: \"Byakko\" }\r\n505.8 \"State of Shock 2\" Ability { id: \"2756\", source: \"Byakko\" }\r\n506.9 \"Clutch\" Ability { id: \"27E1\", source: \"Byakko\" }\r\n513.2 \"Highest Stakes\" Ability { id: \"27E2\", source: \"Byakko\" }\r\n519.7 \"Sweep the Leg\" Ability { id: \"27DB\", source: \"Byakko\" }\r\n534.2 \"Heavenly Strike\" Ability { id: \"27DA\", source: \"Byakko\" }\r\n544.5 \"Storm Pulse x2\" Ability { id: \"27DC\", source: \"Byakko\" }\r\n557.9 \"Distant Clap\" Ability { id: \"27DD\", source: \"Byakko\" }\r\n564.1 \"Heavenly Strike\" Ability { id: \"27DA\", source: \"Byakko\" }\r\n\r\n572.2 \"--middle--\" Ability { id: \"2757\", source: \"Byakko\" }\r\n576.3 \"Unrelenting Anguish\" Ability { id: \"27ED\", source: \"Byakko\" }\r\n582.4 \"Storm Pulse x2\" Ability { id: \"27DC\", source: \"Byakko\" }\r\n586.7 \"Bombogenesis\" Ability { id: \"27E7\", source: \"Byakko\" }\r\n592.8 \"Ominous Wind\" Ability { id: \"27EB\", source: \"Byakko\" }\r\n594.7 \"Gale Force\" Ability { id: \"27E8\", source: \"Byakko\" }\r\n602.1 \"Fire and Lightning\" Ability { id: \"27D9\", source: \"Byakko\" }\r\n605.3 \"--north--\" Ability { id: \"2757\", source: \"Byakko\" }\r\n611.0 \"Fire and Lightning\" Ability { id: \"27D9\", source: \"Byakko\" }\r\n626.2 \"Storm Pulse x2\" Ability { id: \"27DC\", source: \"Byakko\" }\r\n634.4 \"Answer On High\" Ability { id: \"27E4\", source: \"Byakko\" }\r\n639.4 \"Hundredfold Havoc\" Ability { id: \"27E5\", source: \"Byakko\" }\r\n640.5 \"State of Shock 1\" Ability { id: \"27E0\", source: \"Byakko\" }\r\n641.6 \"Clutch\" Ability { id: \"27E1\", source: \"Byakko\" }\r\n642.5 \"Hundredfold Havoc\" Ability { id: \"27E5\", source: \"Byakko\" }\r\n647.9 \"Highest Stakes\" Ability { id: \"27E2\", source: \"Byakko\" }\r\n650.8 \"State of Shock 2\" Ability { id: \"2756\", source: \"Byakko\" }\r\n651.8 \"Clutch\" Ability { id: \"27E1\", source: \"Byakko\" }\r\n658.1 \"Highest Stakes\" Ability { id: \"27E2\", source: \"Byakko\" }\r\n664.8 \"Sweep the Leg\" Ability { id: \"27DB\", source: \"Byakko\" }\r\n\r\n674.9 \"--middle--\" Ability { id: \"2757\", source: \"Byakko\" }\r\n680.2 \"Storm Pulse x4\" Ability { id: \"27DC\", source: \"Byakko\" }\r\n696.3 \"Storm Pulse Enrage\" Ability { id: \"2A09\", source: \"Byakko\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/byakko.ts



// Byakko Normal
const byakko_triggerSet = {
  id: 'TheJadeStoa',
  zoneId: zone_id/* default.TheJadeStoa */.Z.TheJadeStoa,
  timelineFile: 'byakko.txt',
  triggers: [{
    id: 'Byakko Storm Pulse',
    type: 'StartsUsing',
    netRegex: {
      source: 'Byakko',
      id: '2A2F',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Byakko Heavenly Strike',
    type: 'StartsUsing',
    netRegex: {
      source: 'Byakko',
      id: '2A2D'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    // TODO: we could not call this out for the person who was caught by Clutch (27E1).
    id: 'Byakko Highest Stakes',
    type: 'StartsUsing',
    netRegex: {
      source: 'Byakko',
      id: '27E2',
      capture: false
    },
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }, {
    id: 'Byakko White Herald',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    response: responses/* Responses.awayFrom */.n3.awayFrom()
  }, {
    id: 'Byakko Bombogenesis',
    type: 'HeadMarker',
    netRegex: {
      id: '0065'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aratama Force': 'Aratama-Kraft',
      'Byakko': 'Byakko',
      'Hakutei': 'Hakutei'
    },
    'replaceText': {
      'Answer On High': 'Himmlische Antwort',
      'Aratama': 'Aratama',
      'Bombogenesis': 'Plötzliches Orkantief',
      'Clutch': 'Umklammerung',
      'Dance Of The Incomplete': 'Tanz der zwei Gesichter',
      'Distant Clap': 'Donnergrollen',
      'Fell Swoop': 'Auf einen Schlag',
      'Fire And Lightning': 'Feuer und Blitz',
      'Heavenly Strike': 'Himmlischer Schlag',
      'Highest Stakes': 'Höchstes Risiko',
      'Hundredfold Havoc': 'Hundertfache Verwüstung',
      'Imperial Guard': 'Herbststurm',
      'State Of Shock': 'Bannblitze',
      'Steel Claw': 'Stahlklaue',
      'Storm Pulse': 'Gewitterwelle',
      'Sweep The Leg': 'Vertikalität',
      'The Roar Of Thunder': 'Brüllen des Donners',
      'The Voice Of Thunder': 'Stimme des Donners',
      'Unrelenting Anguish': 'Pandämonium',
      'White Herald': 'Herbstböe'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aratama Force': 'aramitama',
      'Byakko': 'Byakko',
      'Hakutei': 'Hakutei'
    },
    'replaceText': {
      'Answer On High': 'Foudre céleste',
      'Aratama': 'Aratama',
      'Bombogenesis': 'Bombogénèse',
      'Clutch': 'Empoignement',
      'Dance Of The Incomplete': 'Danse semi-bestiale',
      'Distant Clap': 'Tonnerre lointain',
      'Fell Swoop': 'Éléments déchaînés',
      'Fire And Lightning': 'Feu et foudre',
      'Heavenly Strike': 'Frappe céleste',
      'Highest Stakes': 'Tout pour le tout',
      'Hundredfold Havoc': 'Ravages centuples',
      'Imperial Guard': 'Garde impériale',
      'State Of Shock': 'Foudroiement brutal',
      'Steel Claw': 'Griffe d\'acier',
      'Storm Pulse': 'Pulsion de tempête',
      'Sweep The Leg': 'Verticalité',
      'The Roar Of Thunder': 'Rugissement du tonnerre',
      'The Voice Of Thunder': 'Voix du tonnerre',
      'Unrelenting Anguish': 'Douleur continuelle',
      'White Herald': 'Héraut blanc'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aratama Force': '荒弾',
      'Byakko': '白虎',
      'Hakutei': '白帝'
    },
    'replaceText': {
      'Answer On High': '天つ雷',
      'Aratama': '荒弾',
      'Bombogenesis': '爆弾低気圧',
      'Clutch': '掌握',
      'Dance Of The Incomplete': '半獣舞踏',
      'Distant Clap': '遠雷',
      'Fell Swoop': '迅雷風烈波',
      'Fire And Lightning': '雷火一閃',
      'Heavenly Strike': '天雷掌',
      'Highest Stakes': '乾坤一擲',
      'Hundredfold Havoc': '百雷繚乱',
      'Imperial Guard': '白帝一陣',
      'State Of Shock': '呪縛雷',
      'Steel Claw': '鉄爪斬',
      'Storm Pulse': '風雷波動',
      'Sweep The Leg': '旋体脚',
      'The Roar Of Thunder': '雷轟',
      'The Voice Of Thunder': '雷声',
      'Unrelenting Anguish': '無間地獄',
      'White Herald': '白帝衝'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aratama Force': '荒弹',
      'Byakko': '白虎',
      'Hakutei': '白帝'
    },
    'replaceText': {
      'Answer On High': '天雷',
      'Aratama': '荒弹',
      'Bombogenesis': '炸弹低气压',
      'Clutch': '紧握',
      'Dance Of The Incomplete': '半兽舞蹈',
      'Distant Clap': '远雷',
      'Fell Swoop': '迅雷风烈波',
      'Fire And Lightning': '雷火一闪',
      'Heavenly Strike': '天雷掌',
      'Highest Stakes': '乾坤一掷',
      'Hundredfold Havoc': '百雷缭乱',
      'Imperial Guard': '白帝降临',
      'State Of Shock': '咒缚雷',
      'Steel Claw': '铁爪斩',
      'Storm Pulse': '风雷波动',
      'Sweep The Leg': '旋体脚',
      'The Roar Of Thunder': '雷轰',
      'The Voice Of Thunder': '雷声',
      'Unrelenting Anguish': '无间地狱',
      'White Herald': '白帝冲'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aratama Force': '아라미타마 탄환',
      'Byakko': '백호',
      'Hakutei': '하얀 제왕'
    },
    'replaceText': {
      'Answer On High': '하늘의 번개',
      'Aratama': '아라미타마 탄환',
      'Bombogenesis': '폭탄 저기압',
      'Clutch': '장악',
      'Dance Of The Incomplete': '반수의 춤',
      'Distant Clap': '원뢰',
      'Fell Swoop': '신뢰풍렬파',
      'Fire And Lightning': '뇌화일섬',
      'Heavenly Strike': '천뢰장',
      'Highest Stakes': '건곤일척',
      'Hundredfold Havoc': '백뢰요란',
      'Imperial Guard': '제왕의 진격',
      'State Of Shock': '주박뢰',
      'Steel Claw': '강철 발톱',
      'Storm Pulse': '풍뢰파동',
      'Sweep The Leg': '돌려차기',
      'The Roar Of Thunder': '뇌굉',
      'The Voice Of Thunder': '뇌성',
      'Unrelenting Anguish': '무간지옥',
      'White Herald': '제왕의 충격'
    }
  }]
};
/* harmony default export */ const byakko = (byakko_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/byakko.txt
const trial_byakko_namespaceObject = "### Byakko Normal\r\n# -p 2A2F:11.4 27EE:204.3 2A2A:259.3\r\n# -ii 2A36 2A41 2A42 2A48 2A45 2A39 2A4E 27E7\r\n# -it \"Byakko\"\r\n# -it \"Hakutei\"\r\n\r\nhideall \"--sync--\"\r\n# redundant with Hundredfold Havoc\r\nhideall \"Answer On High\"\r\n# redundant with Highest Stakes\r\nhideall \"Clutch\"\r\n\r\n### Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11.4 \"Storm Pulse\" Ability { id: \"2A2F\", source: \"Byakko\" } window 12,5\r\n17.6 \"Heavenly Strike\" Ability { id: \"2A2D\", source: \"Byakko\" }\r\n28.7 \"State Of Shock\" Ability { id: \"27E0\", source: \"Byakko\" }\r\n29.8 \"Clutch\" Ability { id: \"27E1\", source: \"Byakko\" }\r\n36.1 \"Highest Stakes\" Ability { id: \"27E2\", source: \"Byakko\" }\r\n42.7 \"Sweep The Leg\" Ability { id: \"2A2E\", source: \"Byakko\" }\r\n54.9 \"Heavenly Strike\" Ability { id: \"2A2D\", source: \"Byakko\" }\r\n62.0 \"--middle--\" Ability { id: \"2757\", source: \"Byakko\" }\r\n66.1 \"Unrelenting Anguish\" Ability { id: \"27ED\", source: \"Byakko\" }\r\n71.4 \"Aratama\" Ability { id: \"2A48\", source: \"Aratama Force\" }\r\n72.3 \"Storm Pulse\" Ability { id: \"2A2F\", source: \"Byakko\" }\r\n78.5 \"Fire And Lightning\" Ability { id: \"2A2C\", source: \"Byakko\" }\r\n85.8 \"Fire And Lightning\" Ability { id: \"2A2C\", source: \"Byakko\" }\r\n89.0 \"--jump--\" Ability { id: \"2757\", source: \"Byakko\" }\r\n94.7 \"Fire And Lightning\" Ability { id: \"2A2C\", source: \"Byakko\" }\r\n105.9 \"--sync--\" Ability { id: \"2757\", source: \"Byakko\" }\r\n107.7 \"Dance Of The Incomplete\" Ability { id: \"25D1\", source: \"Byakko\" }\r\n107.8 \"--sync--\" Ability { id: \"25CF\", source: \"Hakutei\" }\r\n111.7 \"--untargetable--\"\r\n\r\n### Hakutei add\r\n112.7 \"--targetable--\"\r\n119.3 \"Aratama\" Ability { id: \"2A29\", source: \"Hakutei\" }\r\n121.9 \"Steel Claw 1\" Ability { id: \"2A32\", source: \"Hakutei\" }\r\n128.0 \"Steel Claw 2\" Ability { id: \"2A32\", source: \"Hakutei\" }\r\n134.0 \"--untargetable--\"\r\n139.8 \"White Herald\" Ability { id: \"2A4C\", source: \"Hakutei\" }\r\n141.8 \"--targetable--\"\r\n145.9 \"Fire And Lightning\" Ability { id: \"2A31\", source: \"Hakutei\" }\r\n149.1 \"--sync--\" Ability { id: \"265E\", source: \"Hakutei\" }\r\n150.3 \"The Voice Of Thunder\" Ability { id: \"2A49\", source: \"Hakutei\" }\r\n173.4 \"The Roar Of Thunder\" Ability { id: \"2A4B\", source: \"Hakutei\" }\r\n176.5 \"--untargetable--\"\r\n\r\n### Midphase\r\n204.3 \"--sync--\" Ability { id: \"27EE\", source: \"Byakko\" } window 210,10\r\n218.6 \"Sweep The Leg\" Ability { id: \"2A46\", source: \"Byakko\" }\r\n222.6 \"--sync--\" Ability { id: \"27EE\", source: \"Byakko\" }\r\n224.3 \"Imperial Guard\" Ability { id: \"2A43\", source: \"Hakutei\" }\r\n238.3 \"Imperial Guard\" Ability { id: \"2A43\", source: \"Hakutei\" }\r\n242.8 \"Sweep The Leg\" Ability { id: \"2A46\", source: \"Byakko\" }\r\n248.3 \"Imperial Guard\" Ability { id: \"2A43\", source: \"Hakutei\" }\r\n\r\n### Final phase loop\r\n259.3 \"--sync--\" Ability { id: \"2A2A\", source: \"Byakko\" } window 260,100\r\n274.3 \"Fell Swoop\" Ability { id: \"2A4D\", source: \"Byakko\" }\r\n\r\n294.5 \"Heavenly Strike\" Ability { id: \"2A2D\", source: \"Byakko\" }\r\n300.6 \"Answer On High\" Ability { id: \"27E4\", source: \"Byakko\" }\r\n305.6 \"Hundredfold Havoc 1\" Ability { id: \"2A38\", source: \"Byakko\" }\r\n308.6 \"Hundredfold Havoc 2\" Ability { id: \"2A38\", source: \"Byakko\" }\r\n316.7 \"Bombogenesis\" Ability { id: \"2A3B\", source: \"Byakko\" }\r\n320.8 \"Distant Clap\" Ability { id: \"2A30\", source: \"Byakko\" }\r\n\r\n326.9 \"Answer On High\" Ability { id: \"27E4\", source: \"Byakko\" }\r\n331.9 \"Hundredfold Havoc 1\" Ability { id: \"2A38\", source: \"Byakko\" }\r\n333.0 \"State Of Shock 1\" Ability { id: \"27E0\", source: \"Byakko\" }\r\n334.1 \"Clutch\" Ability { id: \"27E1\", source: \"Byakko\" }\r\n334.9 \"Hundredfold Havoc 2\" Ability { id: \"2A38\", source: \"Byakko\" }\r\n340.3 \"Highest Stakes 1\" Ability { id: \"27E2\", source: \"Byakko\" }\r\n342.9 \"State Of Shock 2\" Ability { id: \"2756\", source: \"Byakko\" }\r\n344.0 \"Clutch\" Ability { id: \"27E1\", source: \"Byakko\" }\r\n350.3 \"Highest Stakes 2\" Ability { id: \"27E2\", source: \"Byakko\" }\r\n356.9 \"Sweep The Leg\" Ability { id: \"2A2E\", source: \"Byakko\" }\r\n362.2 \"--sync--\" Ability { id: \"2757\", source: \"Byakko\" }\r\n367.0 \"Bombogenesis\" Ability { id: \"2A3B\", source: \"Byakko\" }\r\n367.8 \"Fire And Lightning\" Ability { id: \"2A2C\", source: \"Byakko\" }\r\n383.1 \"Heavenly Strike\" Ability { id: \"2A2D\", source: \"Byakko\" }\r\n393.2 \"Sweep The Leg\" Ability { id: \"2A2E\", source: \"Byakko\" }\r\n\r\n399.4 \"--middle--\" Ability { id: \"2757\", source: \"Byakko\" }\r\n403.7 \"Unrelenting Anguish\" Ability { id: \"27ED\", source: \"Byakko\" }\r\n409.8 \"Storm Pulse x2\" Ability { id: \"2A2F\", source: \"Byakko\" }\r\n418.2 \"Fire And Lightning\" Ability { id: \"2A2C\", source: \"Byakko\" }\r\n424.5 \"--sync--\" Ability { id: \"2757\", source: \"Byakko\" }\r\n429.4 \"Bombogenesis\" Ability { id: \"2A3B\", source: \"Byakko\" }\r\n430.3 \"Fire And Lightning\" Ability { id: \"2A2C\", source: \"Byakko\" }\r\n445.6 \"Heavenly Strike\" Ability { id: \"2A2D\", source: \"Byakko\" }\r\n455.7 \"Storm Pulse x2\" Ability { id: \"2A2F\", source: \"Byakko\" }\r\n463.9 \"Sweep The Leg\" Ability { id: \"2A2E\", source: \"Byakko\" }\r\n474.0 \"Storm Pulse x2\" Ability { id: \"2A2F\", source: \"Byakko\" }\r\n\r\n483.3 \"Answer On High\" Ability { id: \"27E4\", source: \"Byakko\" }\r\n488.3 \"Hundredfold Havoc 1\" Ability { id: \"2A38\", source: \"Byakko\" }\r\n491.3 \"Hundredfold Havoc 2\" Ability { id: \"2A38\", source: \"Byakko\" }\r\n499.4 \"Bombogenesis\" Ability { id: \"2A3B\", source: \"Byakko\" }\r\n503.5 \"Distant Clap\" Ability { id: \"2A30\", source: \"Byakko\" }\r\n509.6 \"Storm Pulse x2\" Ability { id: \"2A2F\", source: \"Byakko\" }\r\n\r\n# loop\r\n517.8 \"Answer On High\" Ability { id: \"27E4\", source: \"Byakko\" } window 20,20 jump 326.9\r\n522.8 \"Hundredfold Havoc 1\" #Ability { id: \"2A38\", source: \"Byakko\" }\r\n523.9 \"State Of Shock 1\" #Ability { id: \"27E0\", source: \"Byakko\" }\r\n525.0 \"Clutch\" #Ability { id: \"27E1\", source: \"Byakko\" }\r\n525.8 \"Hundredfold Havoc 2\" #Ability { id: \"2A38\", source: \"Byakko\" }\r\n531.2 \"Highest Stakes 1\" #Ability { id: \"27E2\", source: \"Byakko\" }\r\n533.8 \"State Of Shock 2\" #Ability { id: \"2756\", source: \"Byakko\" }\r\n534.9 \"Clutch\" #Ability { id: \"27E1\", source: \"Byakko\" }\r\n541.2 \"Highest Stakes 2\" #Ability { id: \"27E2\", source: \"Byakko\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/lakshmi-ex.ts




// Lakshmi Extreme
const lakshmi_ex_triggerSet = {
  id: 'EmanationExtreme',
  zoneId: zone_id/* default.EmanationExtreme */.Z.EmanationExtreme,
  timelineFile: 'lakshmi-ex.txt',
  timelineTriggers: [{
    id: 'LakshmiEx Path of Light',
    regex: /Path of Light/,
    beforeSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'LakshmiEx Chanchala Gain',
    type: 'StartsUsing',
    netRegex: {
      id: '2148',
      source: 'Lakshmi',
      capture: false
    },
    run: data => data.chanchala = true
  }, {
    id: 'LakshmiEx Chanchala Lose',
    type: 'LosesEffect',
    netRegex: {
      target: 'Lakshmi',
      effectId: '582',
      capture: false
    },
    run: data => data.chanchala = false
  }, {
    id: 'LakshmiEx Pull of Light Tank',
    type: 'StartsUsing',
    netRegex: {
      id: '215E',
      source: 'Lakshmi'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'LakshmiEx Pull of Light Unexpected',
    type: 'StartsUsing',
    netRegex: {
      id: '215E',
      source: 'Lakshmi'
    },
    condition: data => data.role !== 'tank' && data.role !== 'healer',
    response: responses/* Responses.tankBuster */.n3.tankBuster('alarm')
  }, {
    id: 'LakshmiEx Divine Denial',
    type: 'StartsUsing',
    netRegex: {
      id: '2149',
      source: 'Lakshmi',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Vrill + Knockback',
        de: 'Vril + Rückstoß',
        fr: 'Vril + Poussée',
        ja: 'エーテル + 完全なる拒絶',
        cn: '完全拒绝',
        ko: '락슈미 에테르 + 넉백'
      }
    }
  }, {
    id: 'LakshmiEx Divine Desire',
    type: 'StartsUsing',
    netRegex: {
      id: '214B',
      source: 'Lakshmi',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Vrill + Be Outside',
        de: 'Vril + Außen',
        fr: 'Vril + Extérieur',
        ja: 'エーテル + 完全なる誘引',
        cn: '完全吸引',
        ko: '락슈미 에테르 + 바깥으로'
      }
    }
  }, {
    id: 'LakshmiEx Divine Doubt',
    type: 'StartsUsing',
    netRegex: {
      id: '214A',
      source: 'Lakshmi',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Vrill + Pair Up',
        de: 'Vril + Pärchen bilden',
        fr: 'Vril + Paire',
        ja: 'エーテル + 完全なる惑乱',
        cn: '完全惑乱',
        ko: '락슈미 에테르 + 파트너끼리'
      }
    }
  }, {
    // Stack marker
    id: 'LakshmiEx Pall of Light',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    alertText: (data, matches, output) => {
      if (!data.chanchala) return;
      if (data.me === matches.target) return output.vrillStackOnYou();
      return output.vrillStack();
    },
    infoText: (data, matches, output) => {
      if (data.chanchala) return;
      if (data.me === matches.target) return output.stackOnYou();
      return output.stack();
    },
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stack: {
        en: 'Stack',
        de: 'Stack',
        fr: 'Packez-vous',
        ja: '頭割り',
        cn: '集合',
        ko: '쉐어'
      },
      vrillStackOnYou: {
        en: 'Vrill + Stack on YOU',
        de: 'Vril + Stack auf DIR',
        fr: 'Vril + Package sur VOUS',
        ja: '自分に頭割り (エーテル)',
        cn: '元气攻击点名',
        ko: '락슈미 에테르 + 쉐어징 대상자'
      },
      vrillStack: {
        en: 'Vrill + Stack',
        de: 'Vril + Stack',
        fr: 'Vril + Packez-vous',
        ja: 'エーテル と 頭割り',
        cn: '元气攻击',
        ko: '락슈미 에테르 쉐어징'
      }
    }
  }, {
    id: 'LakshmiEx Stotram',
    type: 'StartsUsing',
    netRegex: {
      id: '2147',
      source: 'Lakshmi',
      capture: false
    },
    condition: data => data.chanchala,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Vrill for AOE',
        de: 'Vril fuer Flaechenangriff',
        fr: 'Vril pour AoE',
        ja: 'ストトラム (エーテル)',
        cn: '元气AOE',
        ko: '락슈미 에테르 (광딜)'
      }
    }
  }, {
    // Offtank cleave
    id: 'LakshmiEx Path of Light Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '000E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (data, _matches, output) => {
      if (data.chanchala) return output.vrillCleaveOnYou();
      return output.cleaveOnYou();
    },
    outputStrings: {
      vrillCleaveOnYou: {
        en: 'Vrill + Cleave on YOU',
        de: 'Vril + Cleave auf DIR',
        fr: 'Vril + Cleave sur VOUS',
        ja: '自分に波動 (エーテル)',
        cn: '元气 死刑点名',
        ko: '락슈미 에테르 + 광역 탱버 대상자'
      },
      cleaveOnYou: {
        en: 'Cleave on YOU',
        de: 'Cleave auf DIR',
        fr: 'Cleave sur VOUS',
        ja: '自分に波動',
        cn: '死刑点名',
        ko: '광역 탱버 대상자'
      }
    }
  }, {
    // Cross aoe
    id: 'LakshmiEx Hand of Grace',
    type: 'HeadMarker',
    netRegex: {
      id: '006B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (data, _matches, output) => {
      if (data.chanchala) return output.vrillCrossMarker();
      return output.crossMarker();
    },
    outputStrings: {
      vrillCrossMarker: {
        en: 'Vrill + Cross Marker',
        de: 'Vril + Kreuz-Marker',
        fr: 'Vril + Marqueur croix',
        ja: '自分に右手 (エーテル)',
        cn: '元气 十字点名',
        ko: '락슈미 에테르 + 십자 장판 징'
      },
      crossMarker: {
        en: 'Cross Marker',
        de: 'Kreuz-Marker',
        fr: 'Marqueur croix',
        ja: '自分に右手',
        cn: '十字点名',
        ko: '십자 장판 징'
      }
    }
  }, {
    // Flower marker (healers)
    id: 'LakshmiEx Hand of Beauty',
    type: 'HeadMarker',
    netRegex: {
      id: '006D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (data, _matches, output) => {
      if (data.chanchala) return output.vrillFlowerMarker();
      return output.flowerMarker();
    },
    outputStrings: {
      vrillFlowerMarker: {
        en: 'Vrill + Flower Marker',
        de: 'Vril + Blumen-Marker',
        fr: 'Vril + Marqueur fleur',
        ja: '自分に左手 (エーテル)',
        cn: '元气 花点名',
        ko: '락슈미 에테르 + 원형 장판 징'
      },
      flowerMarker: {
        en: 'Flower Marker',
        de: 'Blumen-Marker',
        fr: 'Marqueur fleur',
        ja: '自分に左手',
        cn: '花点名',
        ko: '원형 장판 징'
      }
    }
  }, {
    // Red marker during add phase
    id: 'LakshmiEx Water III',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // Soloing can get you two of these.
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move Away',
        de: 'Weg da',
        fr: 'Éloignez-vous',
        ja: '離れる',
        cn: '远离大锤落点',
        ko: '피하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Blissful Arrow': 'Blissful Arrow (cross)',
      'Blissful Hammer': 'Blissful Hammer (circle)',
      'The Pall Of Light': 'Pall Of Light (stack)',
      'The Path Of Light': 'Path Of Light (OT cleave)',
      'The Pull Of Light': 'Pull Of Light (MT buster)'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Dreaming Kshatriya': 'verträumt(?:e|er|es|en) Kshatriya',
      'Lakshmi': 'Lakshmi'
    },
    'replaceText': {
      '--chanchala end--': '--Chanchala endet--',
      '\\(mid\\)': '(Mitte)',
      '/dance': '/tanz',
      'Alluring Arm': 'Anziehender Arm',
      'Blissful Spear': 'Speer der Gnade',
      'Chanchala': 'Chanchala',
      'Divine Denial': 'Göttliche Leugnung',
      'Divine Desire': 'Göttliche Lockung',
      'Divine Doubt': 'Göttliche Bestürzung',
      'Hand Of Beauty': 'Hand der Schönheit',
      'Hand Of Grace': 'Hand der Anmut',
      'Inner Demons': 'Dämonen in dir',
      'Stotram': 'Stotram',
      'The Pall Of Light': 'Flut des Lichts',
      'The Path Of Light': 'Pfad des Lichts',
      'The Pull Of Light': 'Strom des Lichts',
      'Vril': 'Vril',
      'Tail Slap': 'Schwanzklapser',
      'Blissful Arrow': 'Heiliger Pfeil',
      'Blissful Hammer': 'Hammer der Gnade',
      'Jagadishwari': 'Jagadishwari',
      'Alluring Embrace': 'Lockende Umarmung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Dreaming Kshatriya': 'kshatriya rêveuse',
      'Lakshmi': 'Lakshmi'
    },
    'replaceText': {
      '--chanchala end--': '--fin de chanchala--',
      '/dance': '/danse',
      '\\(mid\\)': '(milieu)',
      'Alluring Arm': 'Bras séduisants',
      'Blissful Spear': 'Épieu béatifiant',
      '(?<! )Chanchala': 'Chanchala',
      'Divine Denial': 'Refus divin',
      'Divine Desire': 'Désir divin',
      'Divine Doubt': 'Doute divin',
      'Hand Of Beauty': 'Main de la beauté',
      'Hand Of Grace': 'Main de la grâce',
      'Inner Demons': 'Démons intérieurs',
      'Stotram': 'Stotram',
      'The Pall Of Light': 'Voile de lumière (package)',
      'The Path Of Light': 'Voie de lumière (OT cleave)',
      'The Pull Of Light': 'Flot de lumière (MT buster)',
      'Vril': 'Vril',
      'Tail Slap': 'Gifle caudale',
      'Blissful Arrow': 'Flèche béatifiante (croix)',
      'Blissful Hammer': 'Marteau béatifiant (cercle)',
      'Jagadishwari': 'Jagadishwari',
      'Alluring Embrace': 'Étreinte séduisante'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Dreaming Kshatriya': 'テンパード・クシャトリア',
      'Lakshmi': 'ラクシュミ'
    },
    'replaceText': {
      '/dance': '/dance',
      '\\(mid\\)': '(中央)',
      'Alluring Arm': '魅惑の腕',
      'Blissful Spear': '聖なる槍',
      'Chanchala': 'チャンチャラー',
      'Divine Denial': '完全なる拒絶',
      'Divine Desire': '完全なる誘引',
      'Divine Doubt': '完全なる惑乱',
      'Hand Of Beauty': '優美なる左手',
      'Hand Of Grace': '優雅なる右手',
      'Inner Demons': 'イナーデーモン',
      'Stotram': 'ストトラム',
      'The Pall Of Light': '光の瀑布',
      'The Path Of Light': '光の波動',
      'The Pull Of Light': '光の奔流',
      'Vril': 'ラクシュミエーテル',
      'Tail Slap': 'テールスラップ',
      'Blissful Arrow': '聖なる矢',
      'Blissful Hammer': '聖なる槌',
      'Jagadishwari': 'ジャガディッシュワリ',
      'Alluring Embrace': '魅惑の抱擁'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Dreaming Kshatriya': '梦寐的刹帝利',
      'Lakshmi': '吉祥天女'
    },
    'replaceText': {
      '--chanchala end--': '--反复无常结束--',
      '\\(mid\\)': '(中)',
      '\\(out\\)': '(外)',
      '/dance': '/跳舞',
      'Alluring Arm': '魅惑之臂',
      'Blissful Spear': '圣枪',
      '(?<!-)Chanchala': '反复无常',
      'Divine Denial': '完全拒绝',
      'Divine Desire': '完全引诱',
      'Divine Doubt': '完全惑乱',
      'Hand Of Beauty': '优美的左手',
      'Hand Of Grace': '优雅的右手',
      'Inner Demons': '心魔',
      'Stotram': '赞歌',
      'The Pall Of Light': '光之瀑布',
      'The Path Of Light': '光之波动',
      'The Pull Of Light': '光之奔流',
      'Vril': '元气',
      'Tail Slap': '尾部猛击',
      'Blissful Arrow': '圣箭',
      'Blissful Hammer': '圣锤',
      'Jagadishwari': '至上天母',
      'Alluring Embrace': '魅惑拥抱'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Dreaming Kshatriya': '신도화된 크샤트리아',
      'Lakshmi': '락슈미'
    },
    'replaceText': {
      '/dance': '/춤',
      'Alluring Arm': '매혹적인 팔',
      'Blissful Spear': '성스러운 창',
      'Chanchala': '찬찰라',
      'Divine Denial': '완전한 거절',
      'Divine Desire': '완전한 유인',
      'Divine Doubt': '완전한 혼란',
      'Hand Of Beauty': '아름다운 왼손',
      'Hand Of Grace': '우아한 오른손',
      'Inner Demons': '내면의 악마',
      'Stotram': '스토트람',
      'The Pall Of Light': '빛의 폭포',
      'The Path Of Light': '빛의 파동',
      'The Pull Of Light': '빛의 급류',
      'Vril': '락슈미 에테르',
      'Tail Slap': '꼬리치기',
      'Blissful Arrow': '성스러운 화살',
      'Blissful Hammer': '성스러운 망치',
      'Jagadishwari': '자가디슈와리',
      'Alluring Embrace': '매혹적인 포옹'
    }
  }]
};
/* harmony default export */ const lakshmi_ex = (lakshmi_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/lakshmi-ex.txt
const trial_lakshmi_ex_namespaceObject = "# Lakshmi Extreme\r\n # -p 2146:4 2157:100 214C:107.2 2342:400\r\n # -it \"Lakshmi\"\r\n # -ii 2157 249F 2153 2459 245A 23A8 23A9 255F 2158 2388 2389 23A4 2526 2525 2561\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Alluring Arm\"\r\n\r\n### Adds\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n4.0 \"Vril\" Ability { id: \"2146\", source: \"Dreaming Kshatriya\" } window 10,10\r\n12.1 \"Tail Slap\" Ability { id: \"258C\", source: \"Dreaming Kshatriya\" }\r\n16.0 \"Stotram\" Ability { id: \"2147\", source: \"Lakshmi\" }\r\n16.9 \"Inner Demons\" Ability { id: \"258D\", source: \"Dreaming Kshatriya\" }\r\n28.1 \"Inner Demons\" Ability { id: \"258D\", source: \"Dreaming Kshatriya\" }\r\n29.0 \"Tail Slap\" Ability { id: \"258C\", source: \"Dreaming Kshatriya\" }\r\n\r\n\r\n### Warmup\r\n# first auto comes out before rp text.\r\n500.0 \"Hand Of Grace\" Ability { id: \"214C\", source: \"Lakshmi\" } window 500,0\r\n507.2 \"The Pull Of Light\" Ability { id: \"215E\", source: \"Lakshmi\" }\r\n514.2 \"Blissful Arrow\" Ability { id: \"214F\", source: \"Lakshmi\" }\r\n514.8 \"Blissful Spear\" Ability { id: \"2151\", source: \"Lakshmi\" }\r\n517.4 \"Stotram\" Ability { id: \"2147\", source: \"Lakshmi\" }\r\n528.6 \"The Pull Of Light\" Ability { id: \"215E\", source: \"Lakshmi\" }\r\n535.9 \"The Path Of Light\" Ability { id: \"215A\", source: \"Lakshmi\" }\r\n546.0 \"Alluring Arm\" Ability { id: \"214E\", source: \"Lakshmi\" }\r\n553.2 \"The Pull Of Light\" Ability { id: \"215E\", source: \"Lakshmi\" }\r\n560.3 \"Blissful Hammer\" Ability { id: \"21DC\", source: \"Lakshmi\" }\r\n563.4 \"Stotram\" Ability { id: \"2147\", source: \"Lakshmi\" }\r\n570.6 \"The Pall Of Light\" Ability { id: \"215C\", source: \"Lakshmi\" }\r\n579.8 \"The Pull Of Light\" Ability { id: \"215E\", source: \"Lakshmi\" }\r\n\r\n### Chanchala #1\r\n588.0 \"Chanchala #1\" Ability { id: \"2148\", source: \"Lakshmi\" }\r\n601.8 \"Divine Denial\" Ability { id: \"2149\", source: \"Lakshmi\" }\r\n610.0 \"Hand Of Beauty\" Ability { id: \"214D\", source: \"Lakshmi\" }\r\n617.2 \"The Pull Of Light\" Ability { id: \"215F\", source: \"Lakshmi\" }\r\n624.2 \"Blissful Hammer\" Ability { id: \"21DD\", source: \"Lakshmi\" }\r\n624.5 \"The Path Of Light\" Ability { id: \"215B\", source: \"Lakshmi\" }\r\n637.8 \"Divine Desire\" Ability { id: \"214B\", source: \"Lakshmi\" }\r\n639.9 \"--chanchala end--\"\r\n\r\n650.1 \"The Pull Of Light\" Ability { id: \"215E\", source: \"Lakshmi\" }\r\n662.5 \"The Path Of Light\" Ability { id: \"215A\", source: \"Lakshmi\" }\r\n670.6 \"Stotram\" Ability { id: \"2147\", source: \"Lakshmi\" }\r\n674.3 \"--untargetable--\"\r\n\r\n### More Adds\r\n679.9 \"--targetable--\"\r\n\r\n### Hugging\r\n2000.0 \"Jagadishwari\" Ability { id: \"2342\", source: \"Lakshmi\" } window 2000,0\r\n2021.4 \"/dance\"\r\n2021.4 \"--sync--\" Ability { id: \"2159\", source: \"Lakshmi\" }\r\n2037.1 \"Alluring Embrace\" Ability { id: \"2343\", source: \"Lakshmi\" }\r\n2041.5 \"--targetable--\"\r\n\r\n### Chanchala #2\r\n2041.7 \"--sync--\" StartsUsing { id: \"2148\", source: \"Lakshmi\" } window 50,10\r\n2044.7 \"Chanchala #2\" Ability { id: \"2148\", source: \"Lakshmi\" }\r\n2058.5 \"Divine Doubt\" Ability { id: \"214A\", source: \"Lakshmi\" }\r\n2073.9 \"The Path Of Light\" Ability { id: \"215B\", source: \"Lakshmi\" }\r\n2084.0 \"The Pull Of Light\" Ability { id: \"215F\", source: \"Lakshmi\" }\r\n2086.0 \"--chanchala end--\"\r\n2109.5 \"The Pull Of Light\" Ability { id: \"215E\", source: \"Lakshmi\" }\r\n2111.5 \"Blissful Spear (Z)\" Ability { id: \"2166\", source: \"Lakshmi\" }\r\n\r\n2125.9 \"The Path Of Light\" Ability { id: \"215A\", source: \"Lakshmi\" }\r\n2128.8 \"Blissful Spear (mid)\" Ability { id: \"2156\", source: \"Lakshmi\" }\r\n2133.1 \"The Pall Of Light\" Ability { id: \"215C\", source: \"Lakshmi\" }\r\n2144.3 \"Alluring Arm\" Ability { id: \"214E\", source: \"Lakshmi\" }\r\n2151.5 \"The Pull Of Light\" Ability { id: \"215E\", source: \"Lakshmi\" }\r\n2158.6 \"Blissful Hammer\" Ability { id: \"21DC\", source: \"Lakshmi\" }\r\n2158.9 \"The Path Of Light\" Ability { id: \"215A\", source: \"Lakshmi\" }\r\n2169.0 \"Stotram\" Ability { id: \"2147\", source: \"Lakshmi\" }\r\n\r\n### Chanchala #3\r\n2180.3 \"Chanchala #3\" Ability { id: \"2148\", source: \"Lakshmi\" }\r\n2195.6 \"Divine Doubt\" Ability { id: \"214A\", source: \"Lakshmi\" }\r\n2210.8 \"The Pall Of Light\" Ability { id: \"215D\", source: \"Lakshmi\" }\r\n2236.5 \"Divine Desire\" Ability { id: \"214B\", source: \"Lakshmi\" }\r\n2238.2 \"Blissful Spear (out)\" Ability { id: \"2154\", source: \"Lakshmi\" }\r\n2250.8 \"The Pall Of Light\" Ability { id: \"215D\", source: \"Lakshmi\" }\r\n2251.8 \"Blissful Spear (Z)\" Ability { id: \"2166\", source: \"Lakshmi\" }\r\n2264.0 \"Stotram\" Ability { id: \"249D\", source: \"Lakshmi\" }\r\n2266.1 \"--chanchala end--\"\r\n2275.3 \"Alluring Arm\" Ability { id: \"214E\", source: \"Lakshmi\" }\r\n2282.5 \"The Pall Of Light\" Ability { id: \"215C\", source: \"Lakshmi\" }\r\n2289.5 \"Blissful Hammer\" Ability { id: \"21DC\", source: \"Lakshmi\" }\r\n2289.8 \"The Path Of Light\" Ability { id: \"215A\", source: \"Lakshmi\" }\r\n2297.9 \"Stotram\" Ability { id: \"2147\", source: \"Lakshmi\" }\r\n\r\n2308.1 \"The Pull Of Light\" Ability { id: \"215E\", source: \"Lakshmi\" }\r\n2318.3 \"Alluring Arm\" Ability { id: \"214E\", source: \"Lakshmi\" }\r\n2332.6 \"Blissful Hammer\" Ability { id: \"21DD\", source: \"Lakshmi\" }\r\n\r\n### Chanchala #4\r\n2332.8 \"Chanchala #4\" Ability { id: \"2148\", source: \"Lakshmi\" }\r\n2335.0 \"--sync--\" StartsUsing { id: \"2560\", source: \"Lakshmi\" } window 1000,1000\r\n2350.0 \"Divine Denial Enrage\" Ability { id: \"2560\", source: \"Lakshmi\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/lakshmi.ts




// Lakshmi Normal
const lakshmi_triggerSet = {
  id: 'Emanation',
  zoneId: zone_id/* default.Emanation */.Z.Emanation,
  timelineFile: 'lakshmi.txt',
  triggers: [{
    id: 'Lakshmi Chanchala Gain',
    type: 'GainsEffect',
    netRegex: {
      target: 'Lakshmi',
      effectId: '582',
      capture: false
    },
    run: data => data.chanchala = true
  }, {
    id: 'Lakshmi Chanchala Lose',
    type: 'LosesEffect',
    netRegex: {
      target: 'Lakshmi',
      effectId: '582',
      capture: false
    },
    run: data => data.chanchala = false
  }, {
    // 2492 is normal, 2493 is under Chanchala
    id: 'Lakshmi Pull of Light',
    type: 'StartsUsing',
    netRegex: {
      id: ['2492', '2493'],
      source: 'Lakshmi'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'Lakshmi Stotram',
    type: 'StartsUsing',
    netRegex: {
      id: '249E',
      source: 'Lakshmi',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Intermission ability. The user WILL die if they don't use Vril.
    id: 'Lakshmi Jagadishwari',
    type: 'Ability',
    netRegex: {
      id: '2342',
      source: 'Lakshmi',
      capture: false
    },
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'USE VRIL OR DIE',
        de: 'BENUTZT VRIL ODER STIRB',
        fr: 'UTILISEZ LE VRIL OU MOURREZ',
        ja: 'エーテル使って！！',
        cn: '快用元气啊！！',
        ko: '락슈미 에테르를 쓰지 않으면 죽습니다'
      }
    }
  }, {
    id: 'Lakshmi Divine Denial',
    type: 'StartsUsing',
    netRegex: {
      id: '2485',
      source: 'Lakshmi',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Vril + Knockback',
        de: 'Vril + Rückstoß',
        fr: 'Vril + Poussée',
        ja: 'エーテル + 完全なる拒絶',
        cn: '完全拒绝',
        ko: '락슈미 에테르 + 넉백'
      }
    }
  }, {
    // Nobody with a different marker should be told to stack.
    id: 'Lakshmi Headmarker Collect',
    type: 'HeadMarker',
    netRegex: {},
    run: (data, matches) => {
      data.avoidStack ??= [];
      if (matches.id !== '003E') data.avoidStack.push(matches.target);
    }
  }, {
    // Activating on any use of Hand of Beauty/Grace or Alluring Arm.
    // Head markers don't appear until the end of the castbar,
    // and every head marker section begins with one of these abilities,
    // so this should be perfectly safe.
    id: 'Lakshmi Headmarker Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: ['2486', '2487', '2488'],
      source: 'Lakshmi',
      capture: false
    },
    run: data => delete data.avoidStack
  }, {
    // Stack marker
    id: 'Lakshmi Pall of Light',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    delaySeconds: 0.5,
    alertText: (data, _matches, output) => {
      if (!data.avoidStack || !data.avoidStack.includes(data.me)) return;
      return output.dontStack();
    },
    infoText: (data, matches, output) => {
      if (data.avoidStack?.includes(data.me)) return;
      if (data.me === matches.target) return output.stackOnYou();
      return output.stackOn({
        player: matches.target
      });
    },
    outputStrings: {
      dontStack: {
        en: 'Don\'t Stack!',
        de: 'Nicht Sammeln!',
        fr: 'Ne vous packez pas !',
        ja: '重ならないで！',
        cn: '不要重叠！',
        ko: '아직 모이지 말기!'
      },
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    // Off-tank cleave
    id: 'Lakshmi Path of Light',
    type: 'HeadMarker',
    netRegex: {
      id: '000E'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    // Cross aoe
    id: 'Lakshmi Hand of Grace',
    type: 'HeadMarker',
    netRegex: {
      id: '006B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cross Marker',
        de: 'Kreuz-Marker',
        fr: 'Marqueur croix',
        ja: '自分に右手',
        cn: '十字点名',
        ko: '십자 장판 징'
      }
    }
  }, {
    // Circle
    id: 'Lakshmi Hand of Beauty',
    type: 'HeadMarker',
    netRegex: {
      id: '006D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (data, _matches, output) => {
      if (data.chanchala) return output.powerFlower();
      return output.flower();
    },
    outputStrings: {
      powerFlower: {
        en: 'Expanding Flower Marker',
        de: 'Ausdehnender Blumen-Marker',
        fr: 'Marqueur fleur en extension',
        ja: '自分に左手 (拡大する)',
        cn: '大花点名',
        ko: '커지는 원형 장판 징'
      },
      flower: {
        en: 'Flower Marker',
        de: 'Blumen-Marker',
        fr: 'Marqueur fleur',
        ja: '自分に左手',
        cn: '花点名',
        ko: '원형 장판 징'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Blissful Arrow': 'Blissful Arrow (cross)',
      'Blissful Spear': 'Blissful Spear (circle)',
      'The Pall Of Light': 'Pall Of Light (stack)',
      'The Path Of Light': 'Path Of Light (OT cleave)',
      'The Pull Of Light': 'Pull Of Light (MT buster)'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Dreaming Kshatriya': 'verträumt(?:e|er|es|en) Kshatriya',
      'Lakshmi': 'Lakshmi',
      'Vril': 'Vril'
    },
    'replaceText': {
      '--chanchala start--': '--Chanchala startet--',
      '--chanchala end--': '--Chanchala endet--',
      '--vril spawn--': '--Vril erscheint--',
      '--vril despawn--': '--Vril verschwindet--',
      'Adds Appear': 'Adds erscheinen',
      'Aether Drain': 'Ätherabsorption',
      'Alluring Arm': 'Anziehender Arm',
      'Alluring Embrace': 'Lockende Umarmung',
      'Blissful Arrow': 'Heiliger Pfeil',
      'Blissful Spear': 'Speer der Gnade',
      '(?<!-)Chanchala': 'Chanchala',
      'Divine Denial': 'Göttliche Leugnung',
      'Divine Desire': 'Göttliche Lockung',
      'Divine Doubt': 'Göttliche Bestürzung',
      'Hand Of Beauty': 'Hand der Schönheit',
      'Hand Of Grace': 'Hand der Anmut',
      'Hands Of Grace/Beauty': 'Hand Der Anmut/Schönheit',
      'Inner Demons': 'Dämonen in dir',
      'Jagadishwari': 'Jagadishwari',
      'Stotram': 'Stotram',
      '\/Spear': '/Speer',
      'Tail Slap': 'Schwanzklapser',
      'The Pall Of Light': 'Flut des Lichts',
      'The Path Of Light': 'Pfad des Lichts',
      'The Pull Of Light': 'Strom des Lichts',
      '(?<!-)Vril': 'Vril'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Dreaming Kshatriya': 'kshatriya rêveuse',
      'Lakshmi': 'Lakshmi',
      'Vril': 'Vril'
    },
    'replaceText': {
      '--chanchala start--': '--début de chanchala--',
      '--chanchala end--': '--fin de chanchala--',
      '--vril despawn--': '--disparition de vril--',
      '--vril spawn--': '--apparition de vril--',
      'Adds Appear': 'Apparition d\'adds',
      'Aether Drain': 'Absorption d\'éther',
      'Alluring Arm': 'Bras séduisants',
      'Alluring Embrace': 'Étreinte séduisante',
      'Blissful Arrow(?!/Spear)': 'Flèche béatifiante (croix)',
      'Blissful Arrow/Spear': 'Flèche/Épieu béatifiant',
      'Blissful Spear': 'Épieu béatifiant (cercle)',
      '(?<! )Chanchala(?! )': 'Chanchala',
      'Divine Denial': 'Refus divin',
      'Divine Desire': 'Désir divin',
      'Divine Doubt': 'Doute divin',
      'Hand Of Beauty': 'Main de la beauté',
      'Hand Of Grace': 'Main de la grâce',
      'Hands Of Grace/Beauty': 'Main De La Grâce/Beauté',
      'Inner Demons': 'Démons intérieurs',
      'Jagadishwari': 'Jagadishwari',
      'Stotram': 'Stotram',
      'Tail Slap': 'Gifle caudale',
      'The Pall Of Light': 'Voile de lumière (package)',
      'The Path Of Light': 'Voie de lumière (OT cleave)',
      'The Pull Of Light': 'Flot de lumière (MT buster)',
      '(?<! )Vril(?! )': 'Vril'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Dreaming Kshatriya': 'テンパード・クシャトリア',
      'Lakshmi': 'ラクシュミ',
      'Vril': 'ラクシュミエーテル'
    },
    'replaceText': {
      'Adds Appear': '雑魚',
      'Alluring Arm': '魅惑の腕',
      'Blissful Spear': '聖なる槍',
      'Chanchala': 'チャンチャラー',
      'Divine Denial': '完全なる拒絶',
      'Divine Desire': '完全なる誘引',
      'Divine Doubt': '完全なる惑乱',
      'Hand Of Beauty': '優美なる左手',
      'Hand Of Grace': '優雅なる右手',
      'Hands Of Grace/Beauty': '右手/左手',
      'Inner Demons': 'イナーデーモン',
      'Stotram': 'ストトラム',
      'The Pall Of Light': '光の瀑布',
      'The Path Of Light': '光の波動',
      'The Pull Of Light': '光の奔流'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Dreaming Kshatriya': '梦寐的刹帝利',
      'Lakshmi': '吉祥天女',
      'Vril': '元气'
    },
    'replaceText': {
      '--chanchala start--': '--反复无常开始--',
      '--chanchala end--': '--反复无常结束--',
      '--vril spawn--': '--元气出现--',
      '--vril despawn--': '--元气消失--',
      'Adds Appear': '小怪出现',
      'Aether Drain': '以太吸收',
      'Alluring Arm': '魅惑之臂',
      'Alluring Embrace': '魅惑拥抱',
      'Blissful Arrow': '圣箭',
      'Blissful Spear': '圣枪',
      '(?<!-)Chanchala': '反复无常',
      'Divine Denial': '完全拒绝',
      'Divine Desire': '完全引诱',
      'Divine Doubt': '完全惑乱',
      'Hand Of Beauty': '优美的左手',
      'Hand Of Grace': '优雅的右手',
      'Hands Of Grace/Beauty': '右手/左手',
      'Inner Demons': '心魔',
      'Jagadishwari': '至上天母',
      'Stotram': '赞歌',
      '\/Spear': '/圣枪',
      'Tail Slap': '尾部猛击',
      'The Pall Of Light': '光之瀑布',
      'The Path Of Light': '光之波动',
      'The Pull Of Light': '光之奔流',
      '(?<!-)Vril': '元气'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Dreaming Kshatriya': '신도화된 크샤트리아',
      'Lakshmi': '락슈미',
      'Vril': '락슈미 에테르'
    },
    'replaceText': {
      '--chanchala start--': '--찬찰라 시작--',
      '--chanchala end--': '--찬찰라 종료--',
      '--vril despawn--': '--락슈미 에테르 사라짐--',
      '--vril spawn--': '--락슈미 에테르 생성--',
      'Adds Appear': '쫄',
      'Aether Drain': '에테르 흡수',
      'Alluring Arm': '매혹적인 팔',
      'Alluring Embrace': '매혹적인 포옹',
      'Blissful Arrow(?!/Spear)': '성스러운 화살',
      'Blissful Arrow/Spear': '성스러운 화살/창',
      'Blissful Spear': '성스러운 창',
      '(?<! )Chanchala(?! )': '찬찰라',
      'Divine Denial': '완전한 거절',
      'Divine Desire': '완전한 유인',
      'Divine Doubt': '완전한 혼란',
      'Hand Of Beauty': '아름다운 왼손',
      'Hand Of Grace': '우아한 오른손',
      'Hands Of Grace/Beauty': '아름다운 왼손/오른손',
      'Inner Demons': '내면의 악마',
      'Jagadishwari': '자가디슈와리',
      'Stotram': '스토트람',
      'Tail Slap': '꼬리치기',
      'The Pall Of Light': '빛의 폭포',
      'The Path Of Light': '빛의 파동',
      'The Pull Of Light': '빛의 급류',
      '(?<! )Vril(?! )': '락슈미 에테르'
    }
  }]
};
/* harmony default export */ const lakshmi = (lakshmi_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/lakshmi.txt
const trial_lakshmi_namespaceObject = "# Emanation (normal mode)\r\n# Lakshmi\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Alluring Arm\"\r\n\r\n# -ii 2157 248B 248D\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n3.9 \"Vril\" Ability { id: \"2482\", source: \"Dreaming Kshatriya\" } window 3.9,5\r\n13.0 \"Stotram\" Ability { id: \"2483\", source: \"Lakshmi\" } window 13,5\r\n16.1 \"Inner Demons\" # Ability { id: \"258D\", source: \"Dreaming Kshatriya\" }\r\n19.0 \"Aether Drain\" Ability { id: \"248D\", source: \"Vril\" }\r\n29.3 \"Tail Slap\" # Ability { id: \"258C\", source: \"Dreaming Kshatriya\" }\r\n\r\n# We can't sync to abilities here to make the loop visible,\r\n# since two adds are present, and the timeline would jerk around.\r\n# A group that actually manages to bridge this gap is doing so deliberately,\r\n# and it's probably not necessary to account for that edge case.\r\n\r\n1000.0 \"--sync--\" Ability { id: \"2157\", source: \"Lakshmi\" } window 1000,5\r\n1007.1 \"Hand Of Grace\" Ability { id: \"2486\", source: \"Lakshmi\" }\r\n1021.3 \"Blissful Arrow\" Ability { id: \"2489\", source: \"Lakshmi\" }\r\n1021.9 \"Blissful Spear\" Ability { id: \"248B\", source: \"Lakshmi\" }\r\n1032.3 \"The Pull Of Light\" Ability { id: \"2492\", source: \"Lakshmi\" }\r\n1044.5 \"Hand Of Beauty\" Ability { id: \"2487\", source: \"Lakshmi\" }\r\n1058.8 \"Blissful Spear\" Ability { id: \"2494\", source: \"Lakshmi\" }\r\n1065.7 \"Stotram\" Ability { id: \"2483\", source: \"Lakshmi\" }\r\n1067.9 \"--vril spawn--\"\r\n1069.0 \"--untargetable--\"\r\n\r\n1069.9 \"Jagadishwari\" Ability { id: \"2342\", source: \"Lakshmi\" } window 169.9,30\r\n1086.1 \"--sync--\" Ability { id: \"2459\", source: \"Lakshmi\" }\r\n1089.6 \"--stun--\"\r\n1090.4 \"--sync--\" Ability { id: \"245A\", source: \"Lakshmi\" }\r\n1091.2 \"--sync--\" Ability { id: \"248E\", source: \"Lakshmi\" }\r\n1106.9 \"Alluring Embrace\" Ability { id: \"2496\", source: \"Lakshmi\" }\r\n1111.3 \"--targetable--\"\r\n\r\n1114.5 \"Chanchala\" Ability { id: \"2484\", source: \"Lakshmi\" } window 214.5,15\r\n1116.7 \"--chanchala start--\"\r\n1122.6 \"Stotram\" Ability { id: \"249E\", source: \"Lakshmi\" }\r\n1124.5 \"--vril spawn--\"\r\n1134.9 \"Divine Denial\" Ability { id: \"2485\", source: \"Lakshmi\" } window 234.9,30\r\n1134.9 \"--vril despawn--\"\r\n1147.1 \"Hand Of Beauty\" Ability { id: \"2487\", source: \"Lakshmi\" }\r\n1154.3 \"The Pull Of Light\" Ability { id: \"2493\", source: \"Lakshmi\" }\r\n1161.4 \"Blissful Spear\" Ability { id: \"2495\", source: \"Lakshmi\" }\r\n1170.7 \"The Path Of Light\" Ability { id: \"24A1\", source: \"Lakshmi\" } window 270.7,30\r\n1184.9 \"Hand Of Grace\" Ability { id: \"2486\", source: \"Lakshmi\" }\r\n1192.1 \"The Pall Of Light\" Ability { id: \"2491\", source: \"Lakshmi\" }\r\n1199.1 \"Blissful Arrow\" Ability { id: \"248A\", source: \"Lakshmi\" }\r\n1199.7 \"Blissful Spear\" Ability { id: \"248C\", source: \"Lakshmi\" }\r\n1205.3 \"Stotram\" Ability { id: \"249E\", source: \"Lakshmi\" }\r\n1207.6 \"--vril spawn--\"\r\n1220.2 \"Divine Denial\" Ability { id: \"2485\", source: \"Lakshmi\" } window 30,30\r\n1220.2 \"--vril despawn--\"\r\n1221.6 \"--chanchala end--\"\r\n1234.5 \"Alluring Arm\" Ability { id: \"2488\", source: \"Lakshmi\" }\r\n1248.8 \"Blissful Arrow/Spear\" Ability { id: [\"2489\", \"2494\"], source: \"Lakshmi\" }\r\n1256.8 \"The Pull Of Light\" Ability { id: \"2492\", source: \"Lakshmi\" }\r\n\r\n1265.0 \"Chanchala\" Ability { id: \"2484\", source: \"Lakshmi\" } window 30,30\r\n1265.9 \"--chanchala start--\"\r\n1279.2 \"Hand Of Grace\" Ability { id: \"2486\", source: \"Lakshmi\" }\r\n1292.4 \"The Pall Of Light\" Ability { id: \"2491\", source: \"Lakshmi\" }\r\n1293.4 \"Blissful Arrow\" Ability { id: \"248A\", source: \"Lakshmi\" }\r\n1294.0 \"Blissful Spear\" Ability { id: \"248C\", source: \"Lakshmi\" }\r\n1302.6 \"Stotram\" Ability { id: \"249E\", source: \"Lakshmi\" }\r\n1304.4 \"--vril spawn--\"\r\n1317.9 \"Divine Denial\" Ability { id: \"2485\", source: \"Lakshmi\" } window 30,30\r\n1317.9 \"--vril despawn--\"\r\n1332.1 \"Alluring Arm\" Ability { id: \"2488\", source: \"Lakshmi\" }\r\n1346.4 \"Blissful Arrow/Spear\" Ability { id: [\"248A\", \"2495\"], source: \"Lakshmi\" }\r\n1348.4 \"The Pall Of Light\" Ability { id: \"2491\", source: \"Lakshmi\" } window 30,30\r\n1360.5 \"The Pull Of Light\" Ability { id: \"2493\", source: \"Lakshmi\" }\r\n1360.9 \"--chanchala end--\"\r\n1378.9 \"Alluring Arm\" Ability { id: \"2488\", source: \"Lakshmi\" }\r\n1392.1 \"Stotram\" Ability { id: \"2483\", source: \"Lakshmi\" } window 30,30\r\n1393.2 \"Blissful Spear\" Ability { id: \"2494\", source: \"Lakshmi\" }\r\n1393.9 \"--vril spawn--\"\r\n1402.3 \"The Pull Of Light\" Ability { id: \"2492\", source: \"Lakshmi\" }\r\n1407.4 \"--vril despawn--\"\r\n1421.5 \"Alluring Arm\" Ability { id: \"2488\", source: \"Lakshmi\" }\r\n1430.9 \"The Path Of Light\" Ability { id: \"248F\", source: \"Lakshmi\" } window 30,30\r\n1435.7 \"Blissful Spear\" Ability { id: \"2494\", source: \"Lakshmi\" }\r\n1440.0 \"The Pall Of Light\" Ability { id: \"2490\", source: \"Lakshmi\" }\r\n1452.2 \"The Pull Of Light\" Ability { id: \"2492\", source: \"Lakshmi\" }\r\n\r\n1465.5 \"Chanchala\" Ability { id: \"2484\", source: \"Lakshmi\" } window 30,30 jump 1365\r\n1466.4 \"--chanchala start--\"\r\n1479.7 \"Hand Of Grace\"\r\n1492.9 \"The Pall Of Light\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/rathalos-ex.ts



// Note: no warning for Roar (2CC3, 285D).
// Rathalos Extreme
const rathalos_ex_triggerSet = {
  id: 'TheGreatHuntExtreme',
  zoneId: zone_id/* default.TheGreatHuntExtreme */.Z.TheGreatHuntExtreme,
  // Mechanics are random, no timeline is possible.
  hasNoTimeline: true,
  triggers: [{
    // Frontal conal + tail swipe on left side.
    // The front conal is 90 degrees, facing front.  The tail swipe starts from direct left
    // and goes counter-clockwise to (?) back right.  This means that the right flank is
    // entirely safe, but the left flank has only a 1/8 pie slice of safety.  For consistency,
    // call this out as "right flank" as "right or front left" is hard to parse.
    id: 'RathEx Mangle Phase 1',
    type: 'StartsUsing',
    netRegex: {
      id: '2853',
      source: 'Rathalos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Right Flank (or out)',
        de: 'Rechte Flanke (oder raus gehen)',
        fr: 'Flanc droit (ou extérieur)',
        cn: '右侧 (或远离)',
        ko: '오른쪽 (혹은 멀리 가기)'
      }
    }
  }, {
    id: 'RathEx Mangle Phase 2',
    type: 'StartsUsing',
    netRegex: {
      id: '2863',
      source: 'Rathalos',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront('info')
  }, {
    // Tail swipe on the right side (and then 180 flip, repeat).
    id: 'RathEx Tail Swing',
    type: 'Ability',
    // No starts using for this.
    netRegex: {
      id: '2855',
      source: 'Rathalos',
      capture: false
    },
    // This hits multiple people.
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // TODO: we could be fancier and say "Run through" or something for #2.
        en: 'Left Flank (or out)',
        de: 'Linke Flanke (oder raus gehen)',
        fr: 'Suivez le flanc gauche (ou extérieur)',
        cn: '左侧 (或远离)',
        ko: '왼쪽 (혹은 멀리가기)'
      }
    }
  }, {
    id: 'RathEx Flaming Recoil',
    type: 'StartsUsing',
    netRegex: {
      id: ['2859', '285B'],
      source: 'Rathalos',
      capture: false
    },
    // This can one-shot, so alarm.
    // It seems to be 180 degrees in front, so "Get Behind" rather than "Away From Front".
    response: responses/* Responses.getBehind */.n3.getBehind('alarm')
  }, {
    id: 'RathEx Rush',
    type: 'StartsUsing',
    netRegex: {
      id: ['2856', '2861'],
      source: 'Rathalos',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // For ranged players, Rush is different than Flaming Recoil because they may have to move.
        en: 'Avoid Charge',
        de: 'Weiche dem Ansturm aus',
        fr: 'Évitez la charge',
        cn: '避开冲锋',
        ko: '돌진 피하기'
      }
    }
  }, {
    id: 'RathEx Adds',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Steppe Sheep',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'RathEx Garula Add',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '6173',
      capture: false
    },
    // Garula stuns and then puts down the telegraph from the east.
    // We could be like "go somewhere other than east", but "go west" is clearer.
    response: responses/* Responses.goWest */.n3.goWest()
  }, {
    id: 'RathEx Garula Targetable',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '6173',
      capture: false
    },
    delaySeconds: 15,
    // This is obnoxious to have as an alarm, but it will cause a wipe if nobody does this.
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Use Foothold for QTE',
        de: 'Benutze Standbein für QTE',
        fr: 'Utilisez le point d\'appui',
        cn: '上龙背QTE',
        ko: '등에 올라타기'
      }
    }
  }, {
    id: 'RathEx Fire Breath',
    type: 'HeadMarker',
    netRegex: {
      id: '0081'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    // First fireball.
    id: 'RathEx Fireball Initial',
    type: 'HeadMarker',
    netRegex: {
      id: '005D'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    // Second and third fireball.
    id: 'RathEx Fireball',
    type: 'HeadMarker',
    netRegex: {
      id: ['0084']
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn('info')
  }, {
    id: 'RathEx Sweeping Flames',
    type: 'Ability',
    // No starts using for this.
    netRegex: {
      id: '2862',
      source: 'Rathalos',
      capture: false
    },
    // This hits multiple people.
    suppressSeconds: 1,
    response: responses/* Responses.awayFromFront */.n3.awayFromFront('info')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Rathalos': 'Rathalos',
      'Steppe Sheep': 'Steppenschaf'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Rathalos': 'Rathalos',
      'Steppe Sheep': 'mouton de la steppe'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Rathalos': 'リオレウス',
      'Steppe Sheep': 'ステップ・シープ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Rathalos': '火龙',
      'Steppe Sheep': '草原绵羊'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Rathalos': '리오레우스',
      'Steppe Sheep': '초원 양'
    }
  }]
};
/* harmony default export */ const rathalos_ex = (rathalos_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/rathalos.ts




// Note: To avoid too many alert-level triggers here, all of the "out of front"
// ones are info, under the assumption that you should never be in front.
// Rathalos Extreme
const rathalos_triggerSet = {
  id: 'TheGreatHunt',
  zoneId: zone_id/* default.TheGreatHunt */.Z.TheGreatHunt,
  // Mechanics are random, no timeline is possible.
  hasNoTimeline: true,
  triggers: [{
    // Frontal conal + tail swipe on left side.
    // The front conal is 90 degrees, facing front.  The tail swipe starts from direct left
    // and goes counter-clockwise to (?) back right.  This means that the right flank is
    // entirely safe, but the left flank has only a 1/8 pie slice of safety.  For consistency,
    // call this out as "right flank" as "right or front left" is hard to parse.
    id: 'Rathalos Mangle Phase 1',
    type: 'StartsUsing',
    netRegex: {
      source: 'Rathalos',
      id: '286A',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Right Flank (or out)',
        de: 'Rechte Flanke (oder raus gehen)',
        fr: 'Flanc droit (ou extérieur)',
        cn: '右侧 (或远离)',
        ko: '오른쪽 (혹은 멀리 가기)'
      }
    }
  }, {
    id: 'Rathalos Mangle Phase 2',
    type: 'StartsUsing',
    netRegex: {
      source: 'Rathalos',
      id: '287A',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront('info')
  }, {
    // Tail swipe on the right side (and then 180 flip, repeat).
    id: 'Rathalos Tail Swing',
    type: 'Ability',
    // No starts using for this, but this ability is 1.5s warning.
    netRegex: {
      source: 'Rathalos',
      id: '286C',
      capture: false
    },
    // This hits multiple people.
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // TODO: we could be fancier and say "Run through" or something for #2.
        en: 'Left Flank (or out)',
        de: 'Linke Flanke (oder raus gehen)',
        fr: 'Suivez le flanc gauche (ou extérieur)',
        cn: '左侧 (或远离)',
        ko: '왼쪽 (혹은 멀리가기)'
      }
    }
  }, {
    id: 'Rathalos Flaming Recoil',
    type: 'StartsUsing',
    netRegex: {
      source: 'Rathalos',
      id: ['2870', '2872'],
      capture: false
    },
    // It seems to be 180 degrees in front, so "Get Behind" rather than "Away From Front".
    // This is less severe in normal mode than in extreme, so leave as info here.
    response: responses/* Responses.getBehind */.n3.getBehind('info')
  }, {
    id: 'Rathalos Rush',
    type: 'StartsUsing',
    netRegex: {
      source: 'Rathalos',
      id: ['286D', '2878'],
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // For ranged players, Rush is different than Flaming Recoil because they may have to move.
        en: 'Avoid Charge',
        de: 'Weiche dem Ansturm aus',
        fr: 'Évitez la charge',
        cn: '避开冲锋',
        ko: '돌진 피하기'
      }
    }
  }, {
    id: 'Rathalos Garula Add',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '6173',
      capture: false
    },
    // Garula stuns and then puts down the telegraph from the east.
    // We could be like "go somewhere other than east", but "go west" is clearer.
    response: responses/* Responses.goWest */.n3.goWest()
  }, {
    id: 'Rathalos Garula Targetable',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '6173',
      capture: false
    },
    delaySeconds: 15,
    // This is obnoxious to have as an alarm, but it will cause a wipe if nobody does this.
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Use Foothold for QTE',
        de: 'Benutze Standbein für QTE',
        fr: 'Utilisez le point d\'appui',
        cn: '上龙背QTE',
        ko: '등에 올라타기'
      }
    }
  }, {
    id: 'Rathalos Fire Breath',
    type: 'HeadMarker',
    // Corresponds with 28CE/2CBD ability.
    netRegex: {
      id: '0081'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Rathalos Fireball',
    type: 'HeadMarker',
    // Corresponds with 2876/2CBA ability.
    netRegex: {
      id: '005D'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Rathalos Sweeping Flames',
    type: 'Ability',
    // No starts using for this, but this ability is 1.5s warning.
    netRegex: {
      source: 'Rathalos',
      id: '2879',
      capture: false
    },
    // This hits multiple people.
    suppressSeconds: 1,
    response: responses/* Responses.awayFromFront */.n3.awayFromFront('info')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Rathalos': 'Rathalos'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Rathalos': 'Rathalos'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Rathalos': 'リオレウス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Rathalos': '火龙'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Rathalos': '리오레우스'
    }
  }]
};
/* harmony default export */ const rathalos = (rathalos_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/seiryu-ex.ts



// Seiryu Extreme
const seiryu_ex_triggerSet = {
  id: 'TheWreathOfSnakesExtreme',
  zoneId: zone_id/* default.TheWreathOfSnakesExtreme */.Z.TheWreathOfSnakesExtreme,
  timelineFile: 'seiryu-ex.txt',
  timelineTriggers: [{
    id: 'SeiryuEx Split Group',
    regex: /Forbidden Arts 1/,
    beforeSeconds: 4,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'stack with your group',
        de: 'mit der Gruppe stacken',
        fr: 'Packez avec votre groupe',
        ja: 'グループ別にスタック',
        cn: '双组分摊',
        ko: '쉐어징'
      }
    }
  }, {
    id: 'SeiryuEx Line Stack',
    regex: /Forbidden Arts$/,
    beforeSeconds: 1,
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'line stack',
        de: 'Linien-Stack',
        fr: 'Packez-vous en ligne',
        ja: 'スタック',
        cn: '直线分摊',
        ko: '직선 쉐어'
      }
    }
  }, {
    id: 'SeiryuEx Tether',
    regex: /Kanabo/,
    beforeSeconds: 7,
    condition: data => data.role === 'tank' || data.job === 'BLU',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Grab Tether, Point Away',
        de: 'Verbindung nehmen und wegdrehen',
        fr: 'Prenez le lien, pointez vers l\'extérieur',
        ja: '線を取って外に向ける',
        cn: '接线引导',
        ko: '선 가로채고 구석으로 유도하기'
      }
    }
  }],
  triggers: [{
    id: 'SeiryuEx Aramitama Tracking',
    type: 'StartsUsing',
    netRegex: {
      id: '37E4',
      source: 'Seiryu',
      capture: false
    },
    run: data => data.blazing = true
  }, {
    id: 'SeiryuEx Cursekeeper',
    type: 'StartsUsing',
    netRegex: {
      id: '37D2',
      source: 'Seiryu'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.tankSwap();
      if (data.role === 'tank') return output.swapThenBuster();
    },
    outputStrings: {
      tankSwap: outputs/* default.tankSwap */.Z.tankSwap,
      swapThenBuster: {
        en: 'Swap, then Buster',
        de: 'Tankwechsel, danach Tankbuster',
        fr: 'Tank swap puis Tank buster',
        ja: 'スイッチ後強攻撃',
        cn: '换T+死刑',
        ko: '교대 후 탱버'
      }
    }
  }, {
    id: 'SeiryuEx Infirm Soul',
    type: 'StartsUsing',
    netRegex: {
      id: '37D2',
      source: 'Seiryu',
      capture: false
    },
    condition: data => {
      // TODO: it'd be nice to figure out who the tanks are so this
      // could also apply to the person Cursekeeper was on.
      return data.role !== 'tank';
    },
    delaySeconds: 3,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Tanks',
        de: 'Weg von den Tanks',
        fr: 'Éloignez-vous des Tanks',
        ja: 'タンクから離れる',
        cn: '远离坦克',
        ko: '탱커한테서 멀어지기'
      }
    }
  }, {
    id: 'SeiryuEx Ascending Tracking',
    type: 'StartsUsing',
    netRegex: {
      id: '3C25',
      source: 'Seiryu',
      capture: false
    },
    run: data => data.markers = []
  }, {
    id: 'SeiryuEx Ascending Stack',
    type: 'StartsUsing',
    netRegex: {
      id: '3C25',
      source: 'Seiryu',
      capture: false
    },
    delaySeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack for Puddle AOEs',
        de: 'Stacken (Pfützen)',
        fr: 'Packez-vous pour l\'AoE',
        ja: 'スタック',
        cn: '集合放置AOE',
        ko: '중앙에 모이기'
      }
    }
  }, {
    id: 'SeiryuEx Ascending Marker Tracking',
    type: 'HeadMarker',
    netRegex: {
      id: '00A9'
    },
    condition: data => data.blazing,
    run: (data, matches) => {
      data.markers ??= [];
      data.markers.push(matches.target);
    }
  }, {
    id: 'SeiryuEx Ascending Marker You',
    type: 'HeadMarker',
    netRegex: {
      id: '00A9'
    },
    condition: (data, matches) => data.blazing && matches.target === data.me,
    infoText: (data, _matches, output) => {
      if (data.role === 'tank' || data.role === 'healer') return output.spreadDpsGetTowers();
      return output.spreadTanksHealersGetTowers();
    },
    outputStrings: {
      spreadDpsGetTowers: {
        en: 'Spread (dps get towers)',
        de: 'Verteilen (nicht in den Turm)',
        fr: 'Dispersion (DPS prenez les tours)',
        ja: '散開 (DPSが塔)',
        cn: '分散（DPS踩塔）',
        ko: '산개 (딜러 기둥 처리)'
      },
      spreadTanksHealersGetTowers: {
        en: 'Spread (tanks/healers get towers)',
        de: 'Verteilen (nicht in den Turm)',
        fr: 'Dispersion (Tanks/Healers prenez les tours)',
        ja: '散開 (タンクヒラが塔)',
        cn: '分散（坦克/治疗踩塔）',
        ko: '산개 (탱/힐 기둥 처리)'
      }
    }
  }, {
    id: 'SeiryuEx Ascending Tower You',
    type: 'HeadMarker',
    netRegex: {
      id: '00A9',
      capture: false
    },
    condition: data => {
      if (!data.blazing || data.markers?.length !== 4) return false;
      return !data.markers.includes(data.me);
    },
    alarmText: (data, _matches, output) => {
      if (data.role === 'tank' || data.role === 'healer') return output.getTowerTankHealerTowers();
      return output.getTowerDpsTowers();
    },
    outputStrings: {
      getTowerTankHealerTowers: {
        en: 'Get Tower (tank/healer towers)',
        de: 'In den Turm',
        fr: 'Prenez votre tour (tours T/H)',
        ja: '塔 (タンクヒラが塔)',
        cn: '踩塔（坦克/治疗踩塔）',
        ko: '기둥 처리 (탱/힐)'
      },
      getTowerDpsTowers: {
        en: 'Get Tower (dps towers)',
        de: 'In den Turm',
        fr: 'Prenez votre tour (tours DPS)',
        ja: '塔 (DPSが塔)',
        cn: '踩塔（DPS踩塔）',
        ko: '기둥 처리 (딜러)'
      }
    }
  }, {
    id: 'SeiryuEx Handprint East',
    type: 'Ability',
    netRegex: {
      id: '37E5',
      source: 'Yama-No-Shiki',
      capture: false
    },
    response: responses/* Responses.goEast */.n3.goEast()
  }, {
    id: 'SeiryuEx Handprint West',
    type: 'Ability',
    netRegex: {
      id: '37E6',
      source: 'Yama-No-Shiki',
      capture: false
    },
    response: responses/* Responses.goWest */.n3.goWest()
  }, {
    id: 'SeiryuEx Find Sneks',
    type: 'StartsUsing',
    netRegex: {
      id: '37F7',
      source: 'Seiryu',
      capture: false
    },
    alarmText: (data, _matches, output) => {
      if (data.withForce === undefined) return output.goToSnakes();
      return output.outOfMiddleTowardSnakes();
    },
    run: data => data.withForce = true,
    outputStrings: {
      goToSnakes: {
        en: 'Go To Snakes',
        de: 'Zu den Schlangen',
        fr: 'Allez vers les serpents',
        ja: '蛇側へ',
        cn: '靠近蛇蛇',
        ko: '뱀쪽으로 이동'
      },
      outOfMiddleTowardSnakes: {
        en: 'Out of Middle, Toward Snakes',
        de: 'Raus aus der Mitte, Zu den Schlangen',
        fr: 'Sortez du milieu, vers les serpents',
        ja: '真ん中からずれて蛇に向く',
        cn: '靠近中心，面向蛇蛇',
        ko: '중앙 피하고 뱀쪽으로 밀리기'
      }
    }
  }, {
    id: 'SeiryuEx Silence',
    type: 'StartsUsing',
    netRegex: {
      id: '37F4',
      source: 'Numa-No-Shiki'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'SeiryuEx Stack',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Ao-No-Shiki',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.role === 'tank' || data.role === 'healer') return output.stackSouth();
      return output.stackIfNoTether();
    },
    outputStrings: {
      stackSouth: {
        en: 'Stack South',
        de: 'Im Süden stacken',
        fr: 'Packez-vous au sud',
        ja: '南でスタック',
        cn: '南侧集合',
        ko: '남쪽에서 모이기'
      },
      stackIfNoTether: {
        en: 'Stack if no tether',
        de: 'Stacken, wenn keine Verbindung',
        fr: 'Packez-vous si pas de lien',
        ja: '線無しはスタック',
        cn: '未连线则集合',
        ko: '징 없으면 모이기'
      }
    }
  }, {
    // This comes a good bit after the symbol on screen,
    // but it's still 2.5s of warning if you've fallen asleep.
    id: 'SeiryuEx Sigil Single Out',
    type: 'StartsUsing',
    netRegex: {
      id: '3A01',
      source: 'Seiryu',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut('info')
  }, {
    id: 'SeiryuEx Sigil In Out 1',
    type: 'StartsUsing',
    netRegex: {
      id: '3A05',
      source: 'Seiryu',
      capture: false
    },
    response: responses/* Responses.getInThenOut */.n3.getInThenOut()
  }, {
    id: 'SeiryuEx Sigil In Out 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3A05',
      source: 'Seiryu',
      capture: false
    },
    delaySeconds: 2.7,
    response: responses/* Responses.getOut */.n3.getOut('info')
  }, {
    id: 'SeiryuEx Sigil Out In 1',
    type: 'StartsUsing',
    netRegex: {
      id: '3A03',
      source: 'Seiryu',
      capture: false
    },
    response: responses/* Responses.getOutThenIn */.n3.getOutThenIn()
  }, {
    id: 'SeiryuEx Sigil Out In 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3A03',
      source: 'Seiryu',
      capture: false
    },
    delaySeconds: 2.7,
    response: responses/* Responses.getIn */.n3.getIn('info')
  }, {
    id: 'SeiryuEx Swim Lessons',
    type: 'StartsUsing',
    netRegex: {
      id: '37CB',
      source: 'Seiryu',
      capture: false
    },
    delaySeconds: 28,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pop Sprint',
        de: 'Sprinten',
        fr: 'Sprintez',
        ja: 'スプリント',
        cn: '冲冲冲',
        ko: '전력 질주'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aka-no-shiki': 'Aka no Shiki',
      'Ao-no-shiki': 'Ao no Shiki',
      'Iwa-no-shiki': 'Iwa no Shiki',
      'Numa-no-shiki': 'Numa no Shiki',
      'Seiryu': 'Seiryu',
      'Yama-no-shiki': 'Yama no Shiki'
    },
    'replaceText': {
      '100-tonze Swing': '100-Tonzen-Schwung',
      'Blazing Aramitama': 'Flammende Aramitama',
      'Blue Bolt': 'Blauer Blitz',
      'Coursing River': 'Woge der Schlange',
      'Cursekeeper': 'Wächter des Fluchs',
      'Dragon\'s Wake': 'Erwachen des Drachen',
      'Fifth Element': 'Fünftes Element',
      'Forbidden Arts': 'Verbotene Künste',
      'Force of Nature': 'Naturgewalt',
      'Handprint': 'Handabdruck',
      'In/Out': 'Rein/Raus',
      'Kanabo': 'Kanabo',
      'Kuji-kiri': 'Kuji-kiri',
      'Onmyo Sigil': 'Onmyo-Siegel',
      'Out/In': 'Raus/Rein',
      'Red Rush': 'Roter Ansturm',
      'Serpent Ascending': 'Aufstieg der Schlange',
      'Serpent Descending': 'Niedergang der Schlange',
      'Serpent\'s Fang': 'Schlangengiftzahn',
      'Strength of Spirit': 'Stärke des Geistes',
      'Summon Shiki': 'Shiki-Beschwörung '
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aka-no-shiki': 'shiki écarlate',
      'Ao-no-shiki': 'shiki céruléen',
      'Iwa-no-shiki': 'shiki rocailleux',
      'Numa-no-shiki': 'shiki uligineux',
      'Seiryu': 'Seiryû',
      'Yama-no-shiki': 'shiki montagneux'
    },
    'replaceText': {
      '100-tonze Swing': 'Swing de 100 tonz',
      'Blazing Aramitama': 'Aramitama incandescent',
      'Blue Bolt': 'Percée bleue',
      'Coursing River': 'Vague de serpents',
      'Cursekeeper': 'Katashiro',
      'Dragon\'s Wake': 'Ascension draconique',
      'Fifth Element': 'Cinq éléments',
      'Forbidden Arts': 'Lame interdite',
      'Force of Nature': 'Main écrasante',
      'Handprint': 'Main lourde',
      'In/Out': 'Intérieur/Extérieur',
      'Kanabo': 'Massue démoniaque',
      'Kuji-kiri': 'Kuji-kiri',
      'Onmyo Sigil': 'Onmyo',
      'Out/In': 'Extérieur/Intérieur',
      'Red Rush': 'Percée rouge',
      'Serpent Ascending': 'Serpent levant',
      'Serpent Descending': 'Serpent couchant',
      'Serpent\'s Fang': 'Dent de serpent',
      'Strength of Spirit': 'Chakra',
      'Summon Shiki': 'Invocation de shiki'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aka-no-shiki': '紅の式鬼',
      'Ao-no-shiki': '蒼の式鬼',
      'Iwa-no-shiki': '岩の式鬼',
      'Numa-no-shiki': '沼の式鬼',
      'Seiryu': '青龍',
      'Yama-no-shiki': '山の式鬼'
    },
    'replaceText': {
      '100-tonze Swing': '100トンズ・スイング',
      'Blazing Aramitama': '荒魂燃焼',
      'Blue Bolt': '青の突進',
      'Coursing River': '蛇崩',
      'Cursekeeper': '呪怨の形代',
      'Dragon\'s Wake': '雲蒸龍変',
      'Fifth Element': '陰陽五行',
      'Forbidden Arts': '刀禁呪',
      'Force of Nature': '大圧殺',
      'Handprint': '圧殺掌',
      'In/Out': '中/外',
      'Kanabo': '鬼に金棒',
      'Kuji-kiri': '九字切り',
      'Onmyo Sigil': '陰陽の印',
      'Out/In': '外/中',
      'Red Rush': '赤の突進',
      'Serpent Ascending': '登り龍',
      'Serpent Descending': '降り蛇',
      'Serpent\'s Fang': '蛇牙',
      'Strength of Spirit': '霊気',
      'Summon Shiki': '式鬼召喚'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aka-no-shiki': '红之式鬼',
      'Ao-no-shiki': '苍之式鬼',
      'Iwa-no-shiki': '岩之式鬼',
      'Numa-no-shiki': '沼之式鬼',
      'Seiryu': '青龙',
      'Yama-no-shiki': '山之式鬼'
    },
    'replaceText': {
      '100-tonze Swing': '百吨回转',
      'Blazing Aramitama': '荒魂燃烧',
      'Blue Bolt': '青突进',
      'Coursing River': '蛇崩',
      'Cursekeeper': '咒怨的替身',
      'Dragon\'s Wake': '云蒸龙变',
      'Fifth Element': '阴阳五行',
      'Forbidden Arts': '刀禁咒',
      'Force of Nature': '大压杀',
      'Handprint': '压杀掌',
      'In/Out': '靠近/远离',
      'Kanabo': '如虎添翼',
      'Kuji-kiri': '九字切',
      'Onmyo Sigil': '阴阳之印',
      'Out/In': '远离/靠近',
      'Red Rush': '赤突进',
      'Serpent Ascending': '升龙',
      'Serpent Descending': '降蛇',
      'Serpent\'s Fang': '蛇牙',
      'Strength of Spirit': '灵气',
      'Summon Shiki': '式鬼召唤'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aka-no-shiki': '붉은 사역귀',
      'Ao-no-shiki': '푸른 사역귀',
      'Iwa-no-shiki': '바위 사역귀',
      'Numa-no-shiki': '늪 사역귀',
      'Seiryu': '청룡',
      'Yama-no-shiki': '산 사역귀'
    },
    'replaceText': {
      '100-tonze Swing': '100톤즈 휘두르기',
      'Blazing Aramitama': '아라미타마 연소',
      'Blue Bolt': '푸른 돌진',
      'Coursing River': '뱀의 행진',
      'Cursekeeper': '저주 인형',
      'Dragon\'s Wake': '운증용변',
      'Fifth Element': '음양오행',
      'Forbidden Arts': '금단의 주술검',
      'Force of Nature': '대압살',
      'Handprint': '압살장',
      'In/Out': '안/밖',
      'Kanabo': '도깨비 방망이',
      'Kuji-kiri': '구자호신법',
      'Onmyo Sigil': '음양의 인',
      'Out/In': '밖/안',
      'Red Rush': '붉은 돌진',
      'Serpent Ascending': '승천하는 뱀',
      'Serpent Descending': '강림하는 뱀',
      'Serpent\'s Fang': '뱀송곳니',
      'Strength of Spirit': '영기',
      'Summon Shiki': '사역귀 소환'
    }
  }]
};
/* harmony default export */ const seiryu_ex = (seiryu_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/seiryu-ex.txt
const trial_seiryu_ex_namespaceObject = "# Seiryu Extreme\r\n# -ii 37F3 37F7 37E7 37FB 37D3 37D4 3814 37F2 37F8 37FA 37F9 37CF 37EA 37C5 37EC 37DD 37CA 37E2 37E3 -p 37C9:400\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n12.5 \"Fifth Element\" Ability { id: \"37C3\", source: \"Seiryu\" } window 13,5\r\n#18.5 \"Serpent Ascending\" Ability { id: \"37DC\", source: \"Seiryu\" } # towers later, but nothing here\r\n20.5 \"--rotate--\" Ability { id: \"37C4\", source: \"Seiryu\" }\r\n27.0 \"Kuji-kiri\" Ability { id: \"37E1\", source: \"Seiryu\" }\r\n30.0 \"--jump--\" Ability { id: \"37D5\", source: \"Seiryu\" }\r\n#33.5 \"Onmyo Sigil\" Ability { id: \"37D6\", source: \"Seiryu\" }\r\n36.5 \"Onmyo Sigil\" Ability { id: \"3A01\", source: \"Seiryu\" }\r\n46.5 \"Cursekeeper\" Ability { id: \"37D2\", source: \"Seiryu\" }\r\n62.8 \"Summon Shiki\" Ability { id: \"37CE\", source: \"Seiryu\" }\r\n#64.8 \"--rotate--\" Ability { id: \"37C4\", source: \"Seiryu\" }\r\n69.8 \"--sync--\" Ability { id: \"37EF\", source: \"Seiryu\" }\r\n75.8 \"Red Rush\" Ability { id: \"37F1\", source: \"Aka-no-shiki\" }\r\n75.8 \"Blue Bolt\" Ability { id: \"37F0\", source: \"Ao-no-shiki\" }\r\n80.5 \"100-tonze Swing\" Ability { id: \"37ED\", source: \"Iwa-no-shiki\" }\r\n89.5 \"Kanabo\" Ability { id: \"37EE\", source: \"Iwa-no-shiki\" }\r\n\r\n# Phase 2\r\n160.0 \"Enrage\"\r\n\r\n# Phase 3\r\n400.0 \"Strength of Spirit\" Ability { id: \"37C9\", source: \"Seiryu\" } window 400,0\r\n427.0 \"Dragon's Wake\" Ability { id: \"37CB\", source: \"Seiryu\" }\r\n#429.5 \"--rotate--\" Ability { id: \"37C4\", source: \"Seiryu\" }\r\n437.5 \"Summon Shiki\" Ability { id: \"37D0\", source: \"Seiryu\" }\r\n448.0 \"Coursing River\" Ability { id: \"37F6\", source: \"Seiryu\" }\r\n462.0 \"Handprint\" Ability { id: \"37E8\", source: \"Seiryu\" }\r\n466.5 \"Fifth Element\" Ability { id: \"37C3\", source: \"Seiryu\" }\r\n470.0 \"Handprint\" Ability { id: \"37E8\", source: \"Seiryu\" }\r\n478.0 \"Summon Shiki\" Ability { id: \"37D0\", source: \"Seiryu\" }\r\n478.0 \"Handprint\" Ability { id: \"37E8\", source: \"Seiryu\" }\r\n486.5 \"Force of Nature\" Ability { id: \"37EB\", source: \"Seiryu\" }\r\n488.5 \"Coursing River\" Ability { id: \"37F6\", source: \"Seiryu\" }\r\n494.3 \"Forbidden Arts\" Ability { id: \"37C7\", source: \"Seiryu\" }\r\n496.3 \"Forbidden Arts\" Ability { id: \"37C8\", source: \"Seiryu\" }\r\n504.3 \"--rotate--\" Ability { id: \"37C4\", source: \"Seiryu\" }\r\n511.9 \"Blazing Aramitama\" Ability { id: \"37E4\", source: \"Seiryu\" }\r\n515.9 \"--jump--\" Ability { id: \"37D5\", source: \"Seiryu\" }\r\n#519.4 \"In/Out\" Ability { id: [\"37DA\", \"37D8\"], source: \"Seiryu\" }\r\n522.4 \"In/Out\" Ability { id: [\"3A05\", \"3A03\"], source: \"Seiryu\" }\r\n#524.9 \"Out/In\" Ability { id: [\"37DB\", \"37D9\"], source: \"Seiryu\" }\r\n525.4 \"Out/In\" Ability { id: [\"3A06\", \"3A04\"], source: \"Seiryu\" }\r\n531.9 \"--rotate--\" Ability { id: \"37C4\", source: \"Seiryu\" }\r\n538.6 \"Kuji-kiri\" Ability { id: \"37E1\", source: \"Seiryu\" }\r\n541.6 \"--jump--\" Ability { id: \"37D5\", source: \"Seiryu\" }\r\n#545.1 \"In/Out\" Ability { id: [\"37DA\", \"37D8\"], source: \"Seiryu\" }\r\n548.1 \"In/Out\" Ability { id: [\"3A05\", \"3A03\"], source: \"Seiryu\" }\r\n#550.6 \"Out/In\" Ability { id: [\"37DB\", \"37D9\"], source: \"Seiryu\" }\r\n551.1 \"Out/In\" Ability { id: [\"3A06\", \"3A04\"], source: \"Seiryu\" }\r\n558.6 \"Fifth Element\" Ability { id: \"37C3\", source: \"Seiryu\" }\r\n572.6 \"Serpent Ascending\" Ability { id: \"3C25\", source: \"Seiryu\" }\r\n578.6 \"Serpent Descending\" Ability { id: \"37DE\", source: \"Seiryu\" }\r\n582.6 \"Serpent's Fang\" Ability { id: \"37DF\", source: \"Seiryu\" }\r\n589.8 \"Forbidden Arts 1\" Ability { id: \"3C22\", source: \"Seiryu\" }\r\n592.0 \"Forbidden Arts 2\" Ability { id: \"3C23\", source: \"Seiryu\" }\r\n599.0 \"Fifth Element\" Ability { id: \"37C3\", source: \"Seiryu\" }\r\n611.0 \"Cursekeeper\" Ability { id: \"37D2\", source: \"Seiryu\" }\r\n624.1 \"Cursekeeper\" Ability { id: \"37D2\", source: \"Seiryu\" }\r\n633.3 \"Fifth Element\" Ability { id: \"37C3\", source: \"Seiryu\" }\r\n646.3 \"Summon Shiki\" Ability { id: \"37CD\", source: \"Seiryu\" }\r\n652.3 \"--jump--\" Ability { id: \"37D5\", source: \"Seiryu\" }\r\n#655.8 \"In/Out\" Ability { id: [\"37DA\", \"37D8\"], source: \"Seiryu\" }\r\n658.4 \"100-tonze Swing\" Ability { id: \"37ED\", source: \"Iwa-no-shiki\" }\r\n658.8 \"In/Out\" Ability { id: [\"3A05\", \"3A03\"], source: \"Seiryu\" }\r\n#661.3 \"Out/In\" Ability { id: [\"37DB\", \"37D9\"], source: \"Seiryu\" }\r\n661.8 \"Out/In\" Ability { id: [\"3A06\", \"3A04\"], source: \"Seiryu\" }\r\n667.5 \"Kanabo\" Ability { id: \"37EE\", source: \"Iwa-no-shiki\" }\r\n671.3 \"--sync--\" Ability { id: \"37EF\", source: \"Seiryu\" }\r\n676.3 \"Serpent Ascending\" Ability { id: \"37DC\", source: \"Seiryu\" }\r\n677.3 \"Red Rush\" Ability { id: \"37F1\", source: \"Aka-no-shiki\" }\r\n677.3 \"Blue Bolt\" Ability { id: \"37F0\", source: \"Ao-no-shiki\" }\r\n678.3 \"--rotate--\" Ability { id: \"37C4\", source: \"Seiryu\" }\r\n685.0 \"Kuji-kiri\" Ability { id: \"37E1\", source: \"Seiryu\" }\r\n691.9 \"Handprint\" Ability { id: \"37E8\", source: \"Seiryu\" }\r\n697.1 \"Fifth Element\" Ability { id: \"37C3\", source: \"Seiryu\" }\r\n700.0 \"Handprint\" Ability { id: \"37E8\", source: \"Seiryu\" }\r\n708.0 \"Handprint\" Ability { id: \"37E8\", source: \"Seiryu\" }\r\n708.6 \"Summon Shiki\" Ability { id: \"37D0\", source: \"Seiryu\" }\r\n716.5 \"Force of Nature\" Ability { id: \"37EB\", source: \"Seiryu\" }\r\n719.1 \"Coursing River\" Ability { id: \"37F6\", source: \"Seiryu\" }\r\n721.6 \"--jump--\" Ability { id: \"37D5\", source: \"Seiryu\" }\r\n#725.1 \"In/Out\" Ability { id: [\"37DA\", \"37D8\"], source: \"Seiryu\" }\r\n728.1 \"In/Out\" Ability { id: [\"3A05\", \"3A03\"], source: \"Seiryu\" }\r\n#730.6 \"Out/In\" Ability { id: [\"37DB\", \"37D9\"], source: \"Seiryu\" }\r\n731.1 \"Out/In\" Ability { id: [\"3A06\", \"3A04\"], source: \"Seiryu\" }\r\n733.9 \"Handprint\" Ability { id: \"37E8\", source: \"Seiryu\" }\r\n741.9 \"Handprint\" Ability { id: \"37E8\", source: \"Seiryu\" }\r\n749.9 \"Handprint\" Ability { id: \"37E8\", source: \"Seiryu\" }\r\n751.0 \"Summon Shiki\" Ability { id: \"37D0\", source: \"Seiryu\" }\r\n758.4 \"Force of Nature\" Ability { id: \"37EB\", source: \"Seiryu\" }\r\n761.5 \"Coursing River\" Ability { id: \"37F6\", source: \"Seiryu\" }\r\n768.6 \"Forbidden Arts 1\" Ability { id: \"3C22\", source: \"Seiryu\" }\r\n770.6 \"Forbidden Arts 2\" Ability { id: \"3C23\", source: \"Seiryu\" }\r\n777.6 \"Fifth Element\" Ability { id: \"37C3\", source: \"Seiryu\" }\r\n794.6 \"Cursekeeper\" Ability { id: \"37D2\", source: \"Seiryu\" }\r\n807.8 \"Cursekeeper\" Ability { id: \"37D2\", source: \"Seiryu\" }\r\n817.0 \"Fifth Element\" Ability { id: \"37C3\", source: \"Seiryu\" }\r\n823.0 \"--jump--\" Ability { id: \"37D5\", source: \"Seiryu\" }\r\n#826.5 \"In/Out\" Ability { id: [\"37DA\", \"37D8\"], source: \"Seiryu\" }\r\n829.5 \"In/Out\" Ability { id: [\"3A05\", \"3A03\"], source: \"Seiryu\" }\r\n#832.0 \"Out/In\" Ability { id: [\"37DB\", \"37D9\"], source: \"Seiryu\" }\r\n832.5 \"Out/In\" Ability { id: [\"3A06\", \"3A04\"], source: \"Seiryu\" }\r\n839.0 \"Serpent Ascending\" Ability { id: \"3C25\", source: \"Seiryu\" }\r\n842.5 \"--rotate--\" Ability { id: \"37C4\", source: \"Seiryu\" }\r\n845.0 \"Serpent Descending\" Ability { id: \"37DE\", source: \"Seiryu\" }\r\n849.0 \"Serpent's Fang\" Ability { id: \"37DF\", source: \"Seiryu\" }\r\n849.0 \"Kuji-kiri\" Ability { id: \"37E1\", source: \"Seiryu\" }\r\n857.6 \"Fifth Element\" Ability { id: \"37C3\", source: \"Seiryu\" }\r\n869.6 \"--rotate--\" Ability { id: \"37C4\", source: \"Seiryu\" }\r\n876.9 \"Fifth Element\" Ability { id: \"37C3\", source: \"Seiryu\" }\r\n883.9 \"Fifth Element\" Ability { id: \"37C3\", source: \"Seiryu\" }\r\n906.0 \"Enrage\" Ability { id: \"3CA9\", source: \"Seiryu\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/seiryu.ts




// Seiryu Normal
const seiryu_triggerSet = {
  id: 'TheWreathOfSnakes',
  zoneId: zone_id/* default.TheWreathOfSnakes */.Z.TheWreathOfSnakes,
  timelineFile: 'seiryu.txt',
  timelineTriggers: [{
    id: 'Seiryu Line Stack',
    regex: /Forbidden Arts/,
    beforeSeconds: 1,
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'line stack',
        de: 'Linien-Stack',
        fr: 'Packez-vous en ligne',
        ja: 'スタック',
        cn: '直线分摊',
        ko: '직선 쉐어'
      }
    }
  }],
  triggers: [{
    id: 'Seiryu Fifth Element',
    type: 'StartsUsing',
    netRegex: {
      source: 'Seiryu',
      id: '37FE',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Seiryu Serpent-Eye Sigil',
    type: 'StartsUsing',
    netRegex: {
      source: 'Seiryu',
      id: '3A08',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Seiryu Onmyo Sigil',
    type: 'StartsUsing',
    netRegex: {
      source: 'Seiryu',
      id: '3A07',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Seiryu Infirm Soul',
    type: 'StartsUsing',
    netRegex: {
      source: 'Seiryu',
      id: '37FD'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Seiryu Serpent Ascending Towers',
    type: 'Ability',
    netRegex: {
      source: 'Seiryu',
      id: '3C25',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 하나씩 들어가기'
      }
    }
  }, {
    id: 'Seiryu Serpent Descending',
    type: 'HeadMarker',
    netRegex: {
      id: '00A9'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Seiryu Blue Bolt',
    type: 'Tether',
    netRegex: {
      source: 'Ao-No-Shiki',
      id: '0011'
    },
    delaySeconds: 0.5,
    infoText: (data, matches, output) => {
      if (data.redRush?.includes(data.me)) return;
      if (matches.target === data.me) return output.stackOnYou();
      return output.stackOnPlayer({
        player: data.party.member(matches.target)
      });
    },
    run: data => delete data.redRush,
    outputStrings: {
      stackOnPlayer: outputs/* default.stackOnPlayer */.Z.stackOnPlayer,
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou
    }
  }, {
    id: 'Seiryu Red Rush',
    type: 'Tether',
    netRegex: {
      source: 'Aka-No-Shiki',
      id: '0011'
    },
    alertText: (data, matches, output) => {
      // If targeted by two, skip.
      if (data.redRush?.includes(data.me)) return;
      if (data.me === matches.target) return output.text();
    },
    run: (data, matches) => (data.redRush ??= []).push(matches.target),
    outputStrings: {
      text: {
        en: 'Point Knockback Tether Outside',
        de: 'Rückstoß-Verbindung nach draußen zeigen',
        fr: 'Orientez les liens de poussée vers l\'extérieur',
        cn: '将击退连线指向场外',
        ko: '외곽으로 유도하기'
      }
    }
  }, {
    id: 'Seiryu Kanabo',
    type: 'Tether',
    netRegex: {
      source: 'Iwa-No-Shiki',
      id: '0011'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 1,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Point Cleave Tether Outside',
        de: 'Cleave nach draußen zeigen',
        fr: 'Orientez les liens de cleave vers l\'extérieur',
        cn: '将顺劈连线指向场外',
        ko: '선 구석으로 유도하기'
      }
    }
  }, {
    id: 'Seiryu Handprint East',
    type: 'Ability',
    netRegex: {
      source: 'Yama-No-Shiki',
      id: '37E5',
      capture: false
    },
    response: responses/* Responses.goEast */.n3.goEast()
  }, {
    id: 'Seiryu Handprint West',
    type: 'Ability',
    netRegex: {
      source: 'Yama-No-Shiki',
      id: '37E6',
      capture: false
    },
    response: responses/* Responses.goWest */.n3.goWest()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Onmyo Sigil / Serpent-Eye Sigil': 'Onmyo / Serpent-Eye Sigil',
      'Serpent-Eye Sigil / Onmyo Sigil': 'Serpent-Eye / Onmyo Sigil'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Aka-No-Shiki': 'Aka no Shiki',
      'Ao-No-Shiki': 'Ao no Shiki',
      'Blue Orochi': 'blau(?:e|er|es|en) Orochi',
      'Iwa-No-Shiki': 'Iwa no Shiki',
      'Seiryu': 'Seiryu',
      'Ten-No-Shiki': 'Ten no Shiki',
      'Yama-No-Shiki': 'Yama no Shiki'
    },
    'replaceText': {
      '100-Tonze Swing': '100-Tonzen-Schwung',
      'Blue Bolt': 'Blauer Blitz',
      'Coursing River': 'Woge der Schlange',
      'Doro-No-Shiki': 'Doro no Shiki',
      'Dragon\'s Wake': 'Erwachen des Drachen',
      'Fifth Element': 'Fünftes Element',
      'Forbidden Arts': 'Verbotene Künste',
      'Force Of Nature': 'Naturgewalt',
      'Fortune-Blade Sigil': 'Glücksklingen-Siegel',
      'Handprint': 'Handabdruck',
      'Infirm Soul': 'Kraftlose Seele',
      'Kanabo': 'Kanabo',
      'Kuji-Kiri': 'Kuji-kiri',
      'Numa-No-Shiki': 'Numa no Shiki',
      'Onmyo Sigil': 'Onmyo-Siegel',
      'Red Rush': 'Roter Ansturm',
      'Serpent Ascending': 'Aufstieg der Schlange',
      'Serpent Descending': 'Niedergang der Schlange',
      'Serpent\'s Fang': 'Schlangengiftzahn',
      'Serpent-Eye Sigil': 'Siegel des Schlangenauges',
      'Strength Of Spirit': 'Stärke des Geistes',
      'Summon Shiki': 'Shiki-Beschwörung',
      'Yama-Kagura': 'Yamakagura'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aka-No-Shiki': 'shiki écarlate',
      'Ao-No-Shiki': 'shiki céruléen',
      'Blue Orochi': 'orochi azur',
      'Iwa-No-Shiki': 'shiki rocailleux',
      'Seiryu': 'Seiryû',
      'Ten-No-Shiki': 'shiki céleste',
      'Yama-No-Shiki': 'shiki montagneux'
    },
    'replaceText': {
      '100-Tonze Swing': 'Swing de 100 tonz',
      'Blue Bolt': 'Percée bleue',
      'Coursing River': 'Vague de serpents',
      'Doro-No-Shiki': 'shiki fangeux',
      'Dragon\'s Wake': 'Ascension draconique',
      'Fifth Element': 'Cinq éléments',
      'Forbidden Arts': 'Lame interdite',
      'Force Of Nature': 'Main écrasante',
      'Fortune-Blade Sigil': 'Lame solaire',
      'Handprint': 'Main lourde',
      'Infirm Soul': 'Onde d\'amertume',
      'Kanabo': 'Massue démoniaque',
      'Kuji-Kiri': 'Kuji-kiri',
      'Numa-No-Shiki': 'shiki uligineux',
      'Onmyo Sigil': 'Onmyo',
      'Red Rush': 'Percée rouge',
      'Serpent Ascending': 'Dragon levant',
      'Serpent Descending': 'Serpent couchant',
      'Serpent\'s Fang': 'Dent de serpent',
      'Serpent-Eye Sigil': 'Œil de serpent',
      'Strength Of Spirit': 'Chakra',
      'Summon Shiki': 'Invocation de shiki',
      'Yama-Kagura': 'Yama-kagura'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aka-No-Shiki': '紅の式鬼',
      'Ao-No-Shiki': '蒼の式鬼',
      'Blue Orochi': '青のオロチ',
      'Iwa-No-Shiki': '岩の式鬼',
      'Seiryu': '青龍',
      'Ten-No-Shiki': '天の式鬼',
      'Yama-No-Shiki': '山の式鬼'
    },
    'replaceText': {
      '100-Tonze Swing': '100トンズ・スイング',
      'Blue Bolt': '青の突進',
      'Coursing River': '蛇崩',
      'Doro-No-Shiki': '泥の式鬼',
      'Dragon\'s Wake': '雲蒸龍変',
      'Fifth Element': '陰陽五行',
      'Forbidden Arts': '刀禁呪',
      'Force Of Nature': '大圧殺',
      'Fortune-Blade Sigil': '陽の刀印',
      'Handprint': '圧殺掌',
      'Infirm Soul': '虚証弾',
      'Kanabo': '鬼に金棒',
      'Kuji-Kiri': '九字切り',
      'Numa-No-Shiki': '沼の式鬼',
      'Onmyo Sigil': '陰陽の印',
      'Red Rush': '赤の突進',
      'Serpent Ascending': '登り龍',
      'Serpent Descending': '降り蛇',
      'Serpent\'s Fang': '蛇牙',
      'Serpent-Eye Sigil': '蛇眼の印',
      'Strength Of Spirit': '霊気',
      'Summon Shiki': '式鬼召喚',
      'Yama-Kagura': '山神楽'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aka-No-Shiki': '红之式鬼',
      'Ao-No-Shiki': '苍之式鬼',
      'Blue Orochi': '青之大蛇',
      'Iwa-No-Shiki': '岩之式鬼',
      'Seiryu': '青龙',
      'Ten-No-Shiki': '天之式鬼',
      'Yama-No-Shiki': '山之式鬼'
    },
    'replaceText': {
      '100-Tonze Swing': '百吨回转',
      'Blue Bolt': '青突进',
      'Coursing River': '蛇崩',
      'Doro-No-Shiki': '泥之式鬼',
      'Dragon\'s Wake': '云蒸龙变',
      'Fifth Element': '阴阳五行',
      'Forbidden Arts': '刀禁咒',
      'Force Of Nature': '大压杀',
      'Fortune-Blade Sigil': '阳之刀印',
      'Handprint': '压杀掌',
      'Infirm Soul': '虚证弹',
      'Kanabo': '如虎添翼',
      'Kuji-Kiri': '九字切',
      'Numa-No-Shiki': '沼之式鬼',
      'Onmyo Sigil': '阴阳之印',
      'Red Rush': '赤突进',
      'Serpent Ascending': '升龙',
      'Serpent Descending': '降蛇',
      'Serpent\'s Fang': '蛇牙',
      'Serpent-Eye Sigil': '蛇眼之印',
      'Strength Of Spirit': '灵气',
      'Summon Shiki': '式鬼召唤',
      'Yama-Kagura': '山神乐'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aka-No-Shiki': '붉은 사역귀',
      'Ao-No-Shiki': '푸른 사역귀',
      'Blue Orochi': '푸른 이무기',
      'Iwa-No-Shiki': '바위 사역귀',
      'Seiryu': '청룡',
      'Ten-No-Shiki': '하늘 사역귀',
      'Yama-No-Shiki': '산 사역귀'
    },
    'replaceText': {
      '100-Tonze Swing': '100톤즈 휘두르기',
      'Blue Bolt': '푸른 돌진',
      'Coursing River': '뱀의 행진',
      'Doro-No-Shiki': '진흙 사역귀',
      'Dragon\'s Wake': '운증용변',
      'Fifth Element': '음양오행',
      'Forbidden Arts': '금단의 주술검',
      'Force Of Nature': '대압살',
      'Fortune-Blade Sigil': '양의 칼',
      'Handprint': '압살장',
      'Infirm Soul': '허증탄',
      'Kanabo': '도깨비 방망이',
      'Kuji-Kiri': '구자호신법',
      'Numa-No-Shiki': '늪 사역귀',
      'Onmyo Sigil': '음양의 인',
      'Red Rush': '붉은 돌진',
      'Serpent Ascending': '승천하는 용',
      'Serpent Descending': '강림하는 뱀',
      'Serpent\'s Fang': '뱀송곳니',
      'Serpent-Eye Sigil': '뱀눈의 인',
      'Strength Of Spirit': '영기',
      'Summon Shiki': '사역귀 소환',
      'Yama-Kagura': '산타령'
    }
  }]
};
/* harmony default export */ const seiryu = (seiryu_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/seiryu.txt
const trial_seiryu_namespaceObject = "### Seiryu Normal\r\n# -p 37FE:12.7 37C4:90.7 37C9:205\r\n# -ii 380C 3802 3803 3C20 380B 3922 3923 380D 380E 3810 3811 3812 3C82 3807 3808 380A 3809 3A8D 37DC\r\n# -it Seiryu\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n12.7 \"Fifth Element\" Ability { id: \"37FE\", source: \"Seiryu\" } window 13,10\r\n24.8 \"Infirm Soul\" Ability { id: \"37FD\", source: \"Seiryu\" }\r\n33.1 \"--sync--\" Ability { id: \"37D5\", source: \"Seiryu\" }\r\n39.8 \"Onmyo Sigil / Serpent-Eye Sigil\" Ability { id: \"3A0[78]\", source: \"Seiryu\" }\r\n52.9 \"Serpent Descending\" Ability { id: \"3804\", source: \"Seiryu\" }\r\n54.1 \"--sync--\" Ability { id: \"37D5\", source: \"Seiryu\" }\r\n60.8 \"Serpent-Eye Sigil / Onmyo Sigil\" Ability { id: \"3A0[78]\", source: \"Seiryu\" }\r\n62.9 \"--sync--\" Ability { id: \"37C4\", source: \"Seiryu\" }\r\n69.3 \"Kuji-Kiri\" Ability { id: \"37E1\", source: \"Seiryu\" }\r\n71.8 \"Fortune-Blade Sigil\" Ability { id: \"3806\", source: \"Seiryu\" }\r\n88.6 \"Summon Shiki\" Ability { id: \"37CE\", source: \"Seiryu\" }\r\n90.7 \"--untargetable--\"\r\n\r\n### Add Phase\r\n90.7 \"--sync--\" Ability { id: \"37C4\", source: \"Seiryu\" } window 20,50\r\n95.7 \"--sync--\" Ability { id: \"37EF\", source: \"Ao-No-Shiki\" }\r\n100.7 \"--sync--\" Ability { id: \"37EC\", source: \"Iwa-No-Shiki\" }\r\n101.7 \"Red Rush\" Ability { id: \"3C1D\", source: \"Aka-No-Shiki\" }\r\n101.7 \"Blue Bolt\" Ability { id: \"3C1C\", source: \"Ao-No-Shiki\" }\r\n106.5 \"100-Tonze Swing\" Ability { id: \"3C1E\", source: \"Iwa-No-Shiki\" }\r\n107.4 \"3x Doro-No-Shiki\"\r\n107.4 \"1x Numa-No-Shiki\"\r\n112.7 \"Yama-Kagura\" Ability { id: \"3813\", source: \"Ten-No-Shiki\" }\r\n118.8 \"Kanabo\" Ability { id: \"3C1F\", source: \"Iwa-No-Shiki\" }\r\n123.8 \"3x Doro-No-Shiki\"\r\n123.8 \"1x Numa-No-Shiki\"\r\n\r\n### Final Phase\r\n200.0 \"--sync--\" StartsUsing { id: \"37C9\", source: \"Seiryu\" } window 200,0\r\n205.0 \"Strength Of Spirit\" Ability { id: \"37C9\", source: \"Seiryu\" }\r\n208.1 \"--sync--\" Ability { id: \"37CA\", source: \"Seiryu\" }\r\n232.1 \"Dragon's Wake\" Ability { id: \"3800\", source: \"Seiryu\" }\r\n234.6 \"--targetable--\"\r\n234.7 \"--sync--\" Ability { id: \"37C4\", source: \"Seiryu\" }\r\n243.9 \"Summon Shiki\" Ability { id: \"37D0\", source: \"Seiryu\" }\r\n251.9 \"Coursing River\" Ability { id: \"37F5\", source: \"Blue Orochi\" }\r\n262.0 \"Summon Shiki\" Ability { id: \"37D0\", source: \"Seiryu\" }\r\n270.0 \"Coursing River\" Ability { id: \"37F5\", source: \"Blue Orochi\" }\r\n271.2 \"Forbidden Arts 1\" Ability { id: \"37C5\", source: \"Seiryu\" }\r\n278.6 \"Forbidden Arts 2\" Ability { id: \"3C72\", source: \"Seiryu\" }\r\n\r\n283.7 \"Summon Shiki\" Ability { id: \"37CF\", source: \"Seiryu\" }\r\n293.8 \"Handprint\" Ability { id: \"37E[56]\", source: \"Yama-No-Shiki\" }\r\n302.0 \"Handprint\" Ability { id: \"37E[56]\", source: \"Yama-No-Shiki\" }\r\n309.8 \"Fifth Element\" Ability { id: \"37FE\", source: \"Seiryu\" }\r\n310.1 \"Handprint\" Ability { id: \"37E[56]\", source: \"Yama-No-Shiki\" }\r\n318.2 \"Force Of Nature\" Ability { id: \"37E9\", source: \"Yama-No-Shiki\" }\r\n334.1 \"--sync--\" Ability { id: \"37D5\", source: \"Seiryu\" }\r\n340.7 \"Onmyo Sigil / Serpent-Eye Sigil\" Ability { id: \"3A0[78]\", source: \"Seiryu\" }\r\n342.9 \"--sync--\" Ability { id: \"37C4\", source: \"Seiryu\" }\r\n349.0 \"Serpent Descending\" Ability { id: \"3804\", source: \"Seiryu\" }\r\n349.7 \"Kuji-Kiri\" Ability { id: \"37E1\", source: \"Seiryu\" }\r\n352.2 \"Fortune-Blade Sigil\" Ability { id: \"3806\", source: \"Seiryu\" }\r\n356.8 \"Fifth Element\" Ability { id: \"37FE\", source: \"Seiryu\" }\r\n370.0 \"Infirm Soul\" Ability { id: \"37FD\", source: \"Seiryu\" }\r\n376.1 \"Fifth Element\" Ability { id: \"37FE\", source: \"Seiryu\" }\r\n\r\n# More adds\r\n387.3 \"Summon Shiki\" Ability { id: \"37CD\", source: \"Seiryu\" }\r\n393.4 \"--sync--\" Ability { id: \"37EC\", source: \"Iwa-No-Shiki\" }\r\n394.6 \"--sync--\" Ability { id: \"37D5\", source: \"Seiryu\" }\r\n399.2 \"100-Tonze Swing\" Ability { id: \"3C1E\", source: \"Iwa-No-Shiki\" }\r\n401.2 \"Onmyo Sigil / Serpent-Eye Sigil\" Ability { id: \"3A0[78]\", source: \"Seiryu\" }\r\n411.5 \"Kanabo\" Ability { id: \"3C1F\", source: \"Iwa-No-Shiki\" }\r\n415.3 \"--sync--\" Ability { id: \"37EF\", source: \"Ao-No-Shiki\" }\r\n421.3 \"Red Rush\" Ability { id: \"3C1D\", source: \"Aka-No-Shiki\" }\r\n421.3 \"Blue Bolt\" Ability { id: \"3C1C\", source: \"Ao-No-Shiki\" }\r\n424.4 \"--sync--\" Ability { id: \"37C4\", source: \"Seiryu\" }\r\n429.3 \"Serpent Descending\" Ability { id: \"3804\", source: \"Seiryu\" }\r\n430.3 \"Yama-Kagura\" Ability { id: \"3813\", source: \"Ten-No-Shiki\" }\r\n431.0 \"Kuji-Kiri\" Ability { id: \"37E1\", source: \"Seiryu\" }\r\n433.5 \"Fortune-Blade Sigil\" Ability { id: \"3806\", source: \"Seiryu\" }\r\n443.2 \"Handprint\" Ability { id: \"37E[56]\", source: \"Yama-No-Shiki\" }\r\n\r\n448.1 \"Summon Shiki\" Ability { id: \"37D0\", source: \"Seiryu\" }\r\n451.4 \"Handprint\" Ability { id: \"37E[56]\", source: \"Yama-No-Shiki\" }\r\n456.2 \"Coursing River\" Ability { id: \"37F5\", source: \"Blue Orochi\" }\r\n459.5 \"Handprint\" Ability { id: \"37E[56]\", source: \"Yama-No-Shiki\" }\r\n467.7 \"Force Of Nature\" Ability { id: \"37E9\", source: \"Yama-No-Shiki\" }\r\n\r\n# towers\r\n470.2 \"Serpent Ascending\" Ability { id: \"3C25\", source: \"Seiryu\" }\r\n480.4 \"Serpent's Fang\" Ability { id: \"3A8C\", source: \"Seiryu\" }\r\n484.4 \"Fifth Element\" Ability { id: \"37FE\", source: \"Seiryu\" }\r\n498.7 \"--sync--\" Ability { id: \"37C4\", source: \"Seiryu\" }\r\n505.2 \"Kuji-Kiri\" Ability { id: \"37E1\", source: \"Seiryu\" }\r\n505.6 \"Serpent Descending\" Ability { id: \"3804\", source: \"Seiryu\" }\r\n507.7 \"Fortune-Blade Sigil\" Ability { id: \"3806\", source: \"Seiryu\" }\r\n508.4 \"--sync--\" Ability { id: \"37D5\", source: \"Seiryu\" }\r\n515.0 \"Onmyo Sigil / Serpent-Eye Sigil\" Ability { id: \"3A0[78]\", source: \"Seiryu\" }\r\n524.1 \"Infirm Soul\" Ability { id: \"37FD\", source: \"Seiryu\" }\r\n530.2 \"Fifth Element\" Ability { id: \"37FE\", source: \"Seiryu\" }\r\n540.4 \"--sync--\" Ability { id: \"37C4\", source: \"Seiryu\" }\r\n\r\n547.6 \"Summon Shiki\" Ability { id: \"37D0\", source: \"Seiryu\" }\r\n555.7 \"Coursing River\" Ability { id: \"37F5\", source: \"Blue Orochi\" }\r\n558.8 \"Fifth Element\" Ability { id: \"37FE\", source: \"Seiryu\" }\r\n565.9 \"Summon Shiki\" Ability { id: \"37D0\", source: \"Seiryu\" }\r\n573.9 \"Coursing River\" Ability { id: \"37F5\", source: \"Blue Orochi\" }\r\n575.1 \"Forbidden Arts\" Ability { id: \"37C5\", source: \"Seiryu\" }\r\n582.4 \"Forbidden Arts\" Ability { id: \"3C72\", source: \"Seiryu\" }\r\n588.5 \"Fifth Element\" Ability { id: \"37FE\", source: \"Seiryu\" }\r\n595.6 \"Fifth Element\" Ability { id: \"37FE\", source: \"Seiryu\" }\r\n\r\n# adds loop\r\n610.8 \"Summon Shiki\" Ability { id: \"37CD\", source: \"Seiryu\" } window 100,100 jump 387.3\r\n616.9 \"--sync--\" #Ability { id: \"37EC\", source: \"Iwa-No-Shiki\" }\r\n618.1 \"--sync--\" #Ability { id: \"37D5\", source: \"Seiryu\" }\r\n622.7 \"100-Tonze Swing\" #Ability { id: \"3C1E\", source: \"Iwa-No-Shiki\" }\r\n624.7 \"Onmyo Sigil / Serpent-Eye Sigil\" #ync /:Seiryu:3A0[78]:/\r\n635.0 \"Kanabo\" #Ability { id: \"3C1F\", source: \"Iwa-No-Shiki\" }\r\n638.8 \"--sync--\" #Ability { id: \"37EF\", source: \"Ao-No-Shiki\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/shinryu-ex.ts



// Shinryu Extreme
const shinryu_ex_triggerSet = {
  id: 'TheMinstrelsBalladShinryusDomain',
  zoneId: zone_id/* default.TheMinstrelsBalladShinryusDomain */.Z.TheMinstrelsBalladShinryusDomain,
  timelineFile: 'shinryu-ex.txt',
  triggers: [{
    id: 'ShinryuEx Heart Cleanup',
    type: 'RemovedCombatant',
    netRegex: {
      name: 'Shinryu',
      capture: false
    },
    run: data => {
      // Explicitly clear so ugly heart message doesn't appear after wipe.
      delete data.phase;
    }
  }, {
    id: 'ShinryuEx Phase 1',
    type: 'StartsUsing',
    netRegex: {
      id: '25DE',
      source: 'Shinryu',
      capture: false
    },
    run: data => data.phase = 1
  }, {
    id: 'ShinryuEx Phase 2',
    type: 'StartsUsing',
    netRegex: {
      id: '25E7',
      source: 'Shinryu',
      capture: false
    },
    run: data => data.phase = 2
  }, {
    id: 'ShinryuEx Phase 3',
    type: 'StartsUsing',
    netRegex: {
      id: '25E4',
      source: 'Shinryu',
      capture: false
    },
    run: data => data.phase = 3
  }, {
    id: 'ShinryuEx Phase 4',
    type: 'StartsUsing',
    netRegex: {
      id: '264E',
      source: 'Shinryu',
      capture: false
    },
    run: data => data.phase = 4
  }, {
    id: 'ShinryuEx Akh Morn',
    type: 'StartsUsing',
    netRegex: {
      id: '25F3',
      source: 'Shinryu'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.akhMornOnYou();else if (data.role === 'tank') return output.akhMornOn({
        player: data.party.member(matches.target)
      });
    },
    infoText: (data, matches, output) => {
      if (matches.target === data.me || data.role === 'tank') return;
      return output.akhRhaiSpreadAndMove();
    },
    outputStrings: {
      akhRhaiSpreadAndMove: {
        en: 'Akh Rhai: spread and move',
        de: 'Akh Rhai: Verteilen und bewegen',
        fr: 'Akh Rhai : Dispersion et bougez',
        ja: 'アク・ラーイ: 散開 動け',
        cn: '天光轮回：散开和移动',
        ko: '아크 라이: 산개, 이동'
      },
      akhMornOnYou: {
        en: 'Akh Morn on YOU',
        de: 'Akh Morn auf DIR',
        fr: 'Akh Morn sur VOUS',
        ja: '自分にアク・モーン',
        cn: '死亡轮回点名',
        ko: '아크몬 대상자'
      },
      akhMornOn: {
        en: 'Akh Morn on ${player}',
        de: 'Akh Morn auf ${player}',
        fr: 'Akh Morn sur ${player}',
        ja: '${player}にアク・モーン',
        cn: '死亡轮回点${player}',
        ko: '"${player}" 아크몬'
      }
    }
  }, {
    id: 'ShinryuEx Diamond Dust',
    type: 'StartsUsing',
    netRegex: {
      id: '25DD',
      source: 'Shinryu',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Ice: Stack and Stop',
        de: 'Eis: Stack und Stehenbleiben',
        fr: 'Glace : Packez-vous et arrêtez',
        ja: '氷: スタック 動かない',
        cn: '冰地面：站一起和停止移动',
        ko: '얼음: 집합하고 이동하지 않기'
      }
    }
  }, {
    id: 'ShinryuEx Dragonfist',
    type: 'StartsUsing',
    netRegex: {
      id: '2611',
      source: 'Shinryu',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out of middle',
        de: 'Raus aus der Mitte',
        fr: 'Sortez du milieu',
        ja: '中央から離れ',
        cn: '离开中间',
        ko: '중앙 피하기'
      }
    }
  }, {
    id: 'ShinryuEx Hellfire',
    type: 'StartsUsing',
    netRegex: {
      id: '25DB',
      source: 'Shinryu',
      capture: false
    },
    durationSeconds: 7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get in water',
        de: 'In\'s Wasser',
        fr: 'Allez dans l\'eau',
        ja: '水に入る',
        cn: '进水圈',
        ko: '물 장판에 들어가기'
      }
    }
  }, {
    // TODO: the original trigger didn't differentiate the two ability ids.
    // Probably the phase conditional could get removed if it did.
    id: 'ShinryuEx Hypernova',
    type: 'StartsUsing',
    netRegex: {
      id: ['271F', '25E8'],
      source: 'Right Wing',
      capture: false
    },
    durationSeconds: 7,
    alertText: (data, _matches, output) => {
      if (data.phase === 3) return output.stopToGetFrozen();
      return output.stackInWater();
    },
    outputStrings: {
      stopToGetFrozen: {
        en: 'stop to get frozen',
        de: 'Stopp! Einfrieren lassen',
        fr: 'Arrêtez, laissez-vous geler',
        ja: '止まれ、凍結',
        cn: '停下，冰地面',
        ko: '멈춰서 얼기'
      },
      stackInWater: {
        en: 'Stack in water',
        de: 'In Wasser stacken',
        fr: 'Packez-vous dans l\'eau',
        ja: '水に集合',
        cn: '在水圈攻击',
        ko: '물 장판에 모이기'
      }
    }
  }, {
    id: 'ShinryuEx Judgement Bolt',
    type: 'StartsUsing',
    netRegex: {
      id: '25DC',
      source: 'Shinryu',
      capture: false
    },
    durationSeconds: 7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'out of water',
        de: 'Raus aus dem Wasser',
        fr: 'Sortez de l\'eau',
        ja: '水から離れ',
        cn: '离开水圈',
        ko: '물 장판 밖으로'
      }
    }
  }, {
    id: 'ShinryuEx Levinbolt',
    type: 'StartsUsing',
    netRegex: {
      id: ['25EA', '2720', '2725'],
      source: 'Right Wing',
      target: 'Right Wing',
      capture: false
    },
    durationSeconds: 7,
    alertText: (data, _matches, output) => {
      if (data.phase === 3) return output.baitBoltKeepMoving();
      return output.spreadOutNoWater();
    },
    outputStrings: {
      baitBoltKeepMoving: {
        en: 'bait bolt, keep moving',
        de: 'Blitz ködern, weiterbewegen',
        fr: 'Attirez la foudre, continuez à bouger',
        ja: '稲妻: 動き続ける',
        cn: '闪电，保持移动',
        ko: '번개 공격 산개, 계속 움직이기'
      },
      spreadOutNoWater: {
        en: 'Spread out, no water',
        de: 'Verteilen und nicht in\'s Wasser',
        fr: 'Dispersez-vous en dehors de l\'eau',
        ja: '散開、水に入らない',
        cn: '散开，离开水圈',
        ko: '산개, 물장판 X'
      }
    }
  }, {
    id: 'ShinryuEx Levinbolt Phase 3',
    type: 'StartsUsing',
    netRegex: {
      id: ['25EA', '2720', '2725'],
      source: 'Right Wing',
      target: 'Right Wing',
      capture: false
    },
    condition: data => data.phase === 3,
    delaySeconds: 9.5,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'move away',
        de: 'wegbewegen',
        fr: 'Éloignez-vous',
        ja: '散開',
        cn: '散开',
        ko: '떨어지기'
      }
    }
  }, {
    id: 'ShinryuEx Icicle Left',
    type: 'Ability',
    netRegex: {
      id: '25EF',
      source: 'Icicle'
    },
    condition: (_data, matches) => {
      return Math.round(parseFloat(matches.x)) === -30 && Math.round(parseFloat(matches.y)) === -15;
    },
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'icicle, lean west',
        de: 'Eiszapfen, nach westen',
        fr: 'Stalactite, penchez vers l\'ouest',
        ja: 'アイシクル: 西へ',
        cn: '冰柱，去左边',
        ko: '고드름, 왼쪽 먼저'
      }
    }
  }, {
    id: 'ShinryuEx Icicle Right',
    type: 'Ability',
    netRegex: {
      id: '25EF',
      source: 'Icicle'
    },
    condition: (_data, matches) => {
      return Math.round(parseFloat(matches.x)) === -30 && Math.round(parseFloat(matches.y)) === -25;
    },
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'icicle, lean east',
        de: 'Eiszapfen, nach Osten',
        fr: 'Stalactite, penchez vers l\'est',
        ja: 'アイシクル: 東へ',
        cn: '冰柱，去右边',
        ko: '고드름, 오른쪽 먼저'
      }
    }
  }, {
    id: 'ShinryuEx Tidal Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '25DA',
      source: 'Shinryu',
      capture: false
    },
    delaySeconds: 3,
    durationSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback, look for water',
        de: 'Rückstoß, nach Wasser schauen',
        fr: 'Poussée, cherchez l\'eau',
        ja: 'ノックバック、水を探せ',
        cn: '击退，找水圈',
        ko: '넉백, 물기둥 확인'
      }
    }
  }, {
    id: 'ShinryuEx Final Tidal Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '264E',
      source: 'Shinryu',
      capture: false
    },
    condition: data => data.role === 'healer',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'no more heals needed',
        de: 'keine Heilung mehr nötig',
        fr: 'Plus besoin de soigner',
        ja: 'ヒールはもう要らない',
        cn: '不需要更多奶了',
        ko: '힐 그만'
      }
    }
  }, {
    id: 'ShinryuEx Tail Slap',
    type: 'StartsUsing',
    netRegex: {
      id: '25E2',
      source: 'Tail',
      capture: false
    },
    delaySeconds: 2,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tail: Switch targets',
        de: 'Schweif: Zielwechsel',
        fr: 'Queue : Changez de cible',
        ja: '尾: タゲチェンジ',
        cn: '打尾巴',
        ko: '꼬리 공격'
      }
    }
  }, {
    id: 'ShinryuEx Heart',
    type: 'AddedCombatant',
    netRegex: {
      name: 'The Worm\'s Heart',
      capture: false
    },
    condition: data => {
      // Prevent ugly heart message on wipe.
      return data.phase === 1;
    },
    // TODO: If tail is alive, delay this message?
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Heart: Switch targets',
        de: 'Herz: Ziel wechseln',
        fr: 'Cœur : Changez de cible',
        ja: '心核: タゲチェンジ',
        cn: '打核心',
        ko: '심핵 공격'
      }
    }
  }, {
    // TODO: can't find the id of this, so using all of them.
    id: 'ShinryuEx Divebomb',
    type: 'StartsUsing',
    netRegex: {
      id: ['1FA8', '1FF4', '2603'],
      source: 'Shinryu',
      capture: false
    },
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'avoid divebomb',
        de: 'Divebomb ausweichen',
        fr: 'Évitez la bombe plongeante',
        ja: 'ダイブボムに避け',
        cn: '前方顺劈',
        ko: '회전 돌진 피하기'
      }
    }
  }, {
    id: 'ShinryuEx Death Sentence',
    type: 'StartsUsing',
    netRegex: {
      id: '260A',
      source: 'Hakkinryu'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.deathSentenceOnYou();else if (data.role === 'healer') return output.deathSentenceOn({
        player: data.party.member(matches.target)
      });
    },
    infoText: (data, matches, output) => {
      if (matches.target !== data.me && data.role !== 'healer') return output.deathSentenceOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      deathSentenceOn: {
        en: 'Death Sentence on ${player}',
        de: 'Todesurteil auf ${player}',
        fr: 'Peine de mort sur ${player}',
        ja: '${player}にデスセンテンス',
        cn: '死刑点名${player}',
        ko: '"${player}" 사형 선고'
      },
      deathSentenceOnYou: {
        en: 'Death Sentence on YOU',
        de: 'Todesurteil auf DIR',
        fr: 'Peine de mort sur VOUS',
        ja: '自分にデスセンテンス',
        cn: '死刑点名',
        ko: '사형 선고 대상자'
      }
    }
  }, {
    id: 'ShinryuEx Tera Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '264B',
      source: 'Shinryu'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'ShinryuEx Wormwail',
    type: 'StartsUsing',
    netRegex: {
      id: '2648',
      source: 'Shinryu',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'ShinryuEx Breath',
    type: 'StartsUsing',
    netRegex: {
      id: '264A',
      source: 'Shinryu',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'front cleave',
        de: 'Frontalcleave',
        fr: 'Cleave devant',
        ja: '正面から離れ',
        cn: '离开正面',
        ko: '범위 밖으로'
      }
    }
  }, {
    id: 'ShinryuEx Final Left Wing',
    type: 'StartsUsing',
    netRegex: {
      id: '2718',
      source: 'Left Wing',
      capture: false
    },
    condition: data => !data.finalWing,
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.finalWing = true,
    outputStrings: {
      text: {
        en: 'kill left first',
        de: 'linken Flügel zuerst',
        fr: 'Tuez l\'aile gauche d\'abord',
        ja: 'レフトウィングに攻撃',
        cn: '击杀左翼',
        ko: '왼쪽 날개 먼저'
      }
    }
  }, {
    id: 'ShinryuEx Final Right Wing',
    type: 'StartsUsing',
    netRegex: {
      id: '2719',
      source: 'Right Wing',
      capture: false
    },
    condition: data => !data.finalWing,
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.finalWing = true,
    outputStrings: {
      text: {
        en: 'kill right first',
        de: 'rechten Flügel zuerst',
        fr: 'Tuez l\'aile droite d\'abord',
        ja: 'ライトウィングに攻撃',
        cn: '击杀右翼',
        ko: '오른쪽 날개 먼저'
      }
    }
  }, {
    id: 'ShinryuEx Tethers',
    type: 'HeadMarker',
    netRegex: {
      id: '0061'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 3.8,
    infoText: (data, _matches, output) => {
      if (data.phase === 3) return output.breakTethersThenStack();
      return output.breakTethers();
    },
    outputStrings: {
      breakTethersThenStack: {
        en: 'break tethers then stack',
        de: 'Kette zerreissen, dann stack',
        fr: 'Cassez les liens, puis packez-vous',
        ja: '鎖を引き、集合',
        cn: '拉断锁链然后攻击',
        ko: '선 끊고 모이기'
      },
      breakTethers: {
        en: 'break tethers',
        de: 'Ketten zerreissen',
        fr: 'Cassez les liens',
        ja: '鎖',
        cn: '拉断锁链',
        ko: '선 끊기'
      }
    }
  }, {
    id: 'ShinryuEx Tail Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '007E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'tail marker on you',
        de: 'Schweifmarker auf dir',
        fr: 'Marqueur Queue sur VOUS',
        ja: '自分にテイル',
        cn: '龙尾点名',
        ko: '꼬리 징 대상자'
      }
    }
  }, {
    id: 'ShinryuEx Shakers',
    type: 'HeadMarker',
    netRegex: {
      id: '0028'
    },
    condition: (data, matches) => {
      data.shakerTargets ??= [];
      data.shakerTargets.push(matches.target);
      return data.shakerTargets.length === 2;
    },
    alarmText: (data, _matches, output) => {
      if (data.shakerTargets?.includes(data.me)) return output.earthshakerOnYou();
    },
    alertText: (data, _matches, output) => {
      if (!data.shakerTargets || !data.shakerTargets.includes(data.me)) return output.avoidEarthshakers();
    },
    run: data => delete data.shakerTargets,
    outputStrings: {
      avoidEarthshakers: {
        en: 'avoid earthshakers',
        de: 'Stöße ausweichen',
        fr: 'Évitez les secousses',
        ja: 'アースシェーカーに避け',
        cn: '远离大地动摇',
        ko: '어스 피하기'
      },
      earthshakerOnYou: {
        en: 'earthshaker on you',
        de: 'Erdstoss auf dir',
        fr: 'Secousse sur VOUS',
        ja: '自分にアースシェーカー',
        cn: '大地动摇点名',
        ko: '어스 대상자'
      }
    }
  }, {
    id: 'ShinryuEx Cocoon Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0039'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Hakkinryu': 'Hakkinryu',
      'Left Wing': 'link(?:e|er|es|en) Schwinge',
      'Right Wing': 'recht(?:e|er|es|en) Schwinge',
      'Shinryu': 'Shinryu',
      'Tail': 'Schwanz',
      'The Worm\'s Heart': 'Shinryus Herz',
      'Icicle': 'Eiszapfen',
      'Cocoon': 'Lichtsphäre'
    },
    'replaceText': {
      '--Reiryu Adds--': '--Reiryu Adds--',
      'Aerial Blast': 'Windschlag',
      'Akh Morn': 'Akh Morn',
      'Akh Rhai': 'Akh Rhai',
      'Atomic Ray': 'Atomstrahlung',
      'Benighting Breath': 'Dunkelhauch',
      'Cocoon Markers': 'Kokon Marker',
      'Dark Matter': 'Dunkelmaterie',
      'Diamond Dust': 'Diamantenstaub',
      'Dragonfist': 'Drachenfaust',
      'Earth Breath': 'Erdatem',
      'Earthen Fury': 'Gaias Zorn',
      'First Wing': 'Erster Flügel',
      'Gyre Charge': 'Wirbel-Aufladung',
      'Hellfire': 'Höllenfeuer',
      'Hypernova': 'Supernova',
      'Ice Storm': 'Eissturm',
      'Icicle Impact': 'Eiszapfen-Schlag',
      'Judgment Bolt': 'Ionenschlag',
      'Levinbolt': 'Keraunisches Feld',
      'Meteor Impact': 'Meteoreinschlag',
      'Phase': 'Phase',
      'Protostar': 'Protostern',
      'Reiyu Adds': 'Reiyu Adds',
      'Second Wing': 'Zweiter Flügel',
      'Spikesicle': 'Eislanze',
      'Super Cyclone': 'Superzyklon',
      'Shatter': 'Zerfallen',
      'Summon Icicle': 'Flugeis',
      'TAP BUTTON OR ELSE': 'DRÜCKE TASTEN ETC',
      'Tail Marker': 'Schweifmarker',
      'Tail Slap': 'Schweifklapser',
      'Tail Spit': 'Schweifspieß',
      'Tera Slash': 'Tera-Schlag',
      'Tethers': 'Verbindungen',
      'Tidal Wave': 'Flutwelle',
      'Touchdown': 'Himmelssturz',
      'Wormwail': 'Shinryus Ruf'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Hakkinryu': 'Hakkinryu',
      'Icicle': 'stalactite',
      'Left Wing': 'aile gauche',
      'Right Wing': 'aile droite',
      'Shinryu': 'Shinryu',
      'The Worm\'s Heart': 'cœur du dragon',
      'Tail': 'queue',
      'Cocoon': 'cocon de lumière'
    },
    'replaceText': {
      '--Phase': '--Phase',
      '--Reiryu Adds--': '--Adds Reiryu--',
      'Aerial Blast': 'Rafale aérienne',
      'Atomic Ray': 'Rayon atomique',
      'Cocoon Markers': 'Marqueurs Cocon',
      'Dark Matter': 'Matière sombre',
      'Diamond Dust': 'Poussière de diamant',
      'Dragonfist': 'Poing dragon',
      'Earth Breath': 'Souffle de terre',
      'Earthen Fury': 'Fureur tellurique',
      'First Wing': 'Première aile',
      'Gyre Charge': 'Gyrocharge',
      'Hellfire': 'Flammes de l\'enfer',
      'Hypernova': 'Hypernova',
      'Ice Storm': 'Tempête de glace',
      'Judgment Bolt': 'Éclair du jugement',
      'Levinbolt': 'Fulguration',
      'Meteor Impact': 'Impact de météore',
      'Protostar': 'Proto-étoile',
      'Reiyu Adds': 'Adds Ryu',
      'Second Wing': 'Seconde aile',
      'Summon Icicle': 'Appel de stalactite',
      'Tail Marker': 'Marqueur Queue',
      'Tail Slap': 'Gifle caudale',
      'Tail Spit': 'Broche caudale',
      'TAP BUTTON OR ELSE': 'CLIQUEZ SUR LE BOUTON OU AUTRE',
      'Tera Slash': 'TéraTaillade',
      'Tethers': 'Liens',
      'Tidal Wave': 'Raz-de-marée',
      'Touchdown': 'Atterrissage',
      'Akh Morn': 'Akh Morn',
      'Icicle Impact': 'Impact de stalactite',
      'Spikesicle': 'Stalactopointe',
      'Akh Rhai': 'Akh Rhai',
      'Super Cyclone': 'Super cyclone',
      'Shatter': 'Éclatement',
      'Wormwail': 'Gémissement draconique',
      'Benighting Breath': 'Souffle enténébrant'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Left Wing': 'レフトウィング',
      'Right Wing': 'ライトウィング',
      'Shinryu': '神龍',
      'Tail': '神龍の尾',
      'The Worm\'s Heart': '神龍の心核',
      'Icicle': 'アイシクル',
      'Cocoon': '光の繭',
      'Hakkinryu': '白金龍'
    },
    'replaceText': {
      'Aerial Blast': 'エリアルブラスト',
      'Akh Morn': 'アク・モーン',
      'Atomic Ray': 'アトミックレイ',
      'Cocoon Markers': 'マユ マーク',
      'Dark Matter': 'ダークマター',
      'Diamond Dust': 'ダイアモンドダスト',
      'Dragonfist': '龍掌',
      'Earth Breath': 'アースブレス',
      'Earthen Fury': '大地の怒り',
      'First Wing': '翼一つ目',
      'Gyre Charge': 'ジャイヤチャージ',
      'Hellfire': '地獄の火炎',
      'Hypernova': 'スーパーノヴァ',
      'Ice Storm': '吹雪',
      'Judgment Bolt': '裁きの雷',
      'Levinbolt': '稲妻',
      'Meteor Impact': 'メテオインパクト',
      'Phase': 'フェイス',
      'Protostar': 'プロトスター',
      'Reiyu Adds': '雑魚',
      'Second Wing': '翼二つ目',
      'Summon Icicle': 'サモン・アイシクル',
      'TAP BUTTON OR ELSE': 'ボタンを押せ！',
      'Tail Marker': 'テイル マーク',
      'Tail Slap': 'テールスラップ',
      'Tail Spit': 'テールスピット',
      'Tera Slash': 'テラスラッシュ',
      'Tethers': '線',
      'Tidal Wave': 'タイダルウェイブ',
      'Touchdown': 'タッチダウン',
      'Icicle Impact': 'アイシクルインパクト',
      'Spikesicle': 'アイシクルスパイク',
      'Akh Rhai': 'アク・ラーイ',
      'Super Cyclone': 'スーパーサイクロン',
      'Shatter': '破砕',
      'Wormwail': '神龍の咆哮',
      'Benighting Breath': 'ダークネスブレス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Cocoon': '光茧',
      'Icicle': '冰柱',
      'Left Wing': '左翼',
      'Right Wing': '右翼',
      'Shinryu': '神龙',
      'Tail': '龙尾',
      'The Worm\'s Heart': '神龙的核心',
      'Hakkinryu': '白金龙'
    },
    'replaceText': {
      'Aerial Blast': '大气爆发',
      'Akh Morn': '死亡轮回',
      'Akh Rhai': '天光轮回',
      'Atomic Ray': '原子射线',
      'Benighting Breath': '黑暗吐息',
      'Cocoon Markers': '光茧点名',
      'Dark Matter': '暗物质',
      'Diamond Dust': '钻石星尘',
      'Dragonfist': '龙掌',
      'Earth Breath': '大地吐息',
      'Earthen Fury': '大地之怒',
      'First Wing': '第一只翅膀',
      'Gyre Charge': '螺旋冲锋',
      'Hellfire': '地狱之火炎',
      'Hypernova': '超新星',
      'Icicle Impact': '冰柱冲击',
      'Ice Storm': '吹雪',
      'Judgment Bolt': '制裁之雷',
      'Levinbolt': '闪电',
      'Meteor Impact': '陨石冲击',
      'Phase': '阶段',
      'Protostar': '原恒星',
      'Reiryu Adds': '灵龙出现',
      'Second Wing': '第二只翅膀',
      'Shatter': '破碎',
      'Spikesicle': '冰柱突刺',
      'Summon Icicle': '召唤冰柱',
      'Super Cyclone': '超级气旋',
      'TAP BUTTON OR ELSE': 'XJB按',
      'Tail Marker': '尾巴点名',
      'Tail Slap': '尾部猛击',
      'Tail Spit': '尾部重击',
      'Tera Slash': '万亿斩击',
      'Tethers': '连线',
      'Tidal Wave': '巨浪',
      'Touchdown': '空降',
      'Wormwail': '神龙啸'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Hakkinryu': '백금룡',
      'Left Wing': '왼쪽 날개',
      'Right Wing': '오른쪽 날개',
      'Shinryu': '신룡',
      'Tail(?! )': '신룡의 꼬리',
      'The Worm\'s Heart': '신룡의 심핵',
      'Icicle': '고드름',
      'Cocoon': '빛의 고치'
    },
    'replaceText': {
      'T\\/H': '탱/힐',
      'healer[s]*': '힐러',
      'dps': '딜러',
      'tank': '탱커',
      'Aerial Blast': '대기 폭발',
      'Akh Morn': '아크 몬',
      'Atomic Ray': '원자 파동',
      'Cocoon Markers': '빛의 고체 징',
      'Dark Matter': '암흑물질',
      'Diamond Dust': '다이아몬드 더스트',
      'Dragonfist': '용의 손바닥',
      'Earth Breath': '대지의 숨결',
      'Earthen Fury': '대지의 분노',
      'First Wing': '첫번째 날개',
      'Gyre Charge': '회전 돌진',
      'Hellfire': '지옥의 화염',
      'Hypernova': '초신성',
      'Ice Storm': '눈보라',
      'Judgment Bolt': '심판의 벼락',
      'Levinbolt': '우레',
      'Meteor Impact': '운석 낙하',
      'Phase': '페이즈',
      'Protostar': '원시별',
      'Reiryu Adds': '영룡 등장',
      'Second Wing': '두번째 날개',
      'Summon Icicle': '고드름 소환',
      'TAP BUTTON OR ELSE': '긴 급 조 작',
      'Tail Marker': '꼬리 징',
      'Tail Slap': '꼬리치기',
      'Tail Spit': '꼬리 찌르기',
      'Tera Slash': '테라 슬래시',
      'Tethers': '선',
      'Tidal Wave': '해일',
      'Touchdown': '착지',
      'Icicle Impact': '고드름 낙하',
      'Spikesicle': '고드름 돌진',
      'Akh Rhai': '아크 라이',
      'Super Cyclone': '대형 돌개바람',
      'Shatter': '파쇄',
      'Wormwail': '신룡의 포효',
      'Benighting Breath': '어둠의 숨결'
    }
  }]
};
/* harmony default export */ const shinryu_ex = (shinryu_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/shinryu-ex.txt
const trial_shinryu_ex_namespaceObject = "# Shinryu Ex\r\n# Text Guide: http://clees.me/guides/shinryu-ex/\r\n#\r\n# -p 25DE:21.3 25E7:503 25E4:806 264B:859.5\r\n# -it Shinryu\r\n# -ii 25FD 25DA 25E9 25EB 2611 25FF 2616 1DD1 2614 25DB 25F6 25F4 25F2 25DF 25ED 260E 25DD 260F 2608 2609 260A 260B 25E6 25E3 2618 25DC 1DD3 264D 2612 2725 25E0 25E1 2600 2601\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Heart add not listed here. Seems to be on an independent respawn timer.\r\n\r\n### PHASE 1: Elemental carousel\r\n###\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11.3 \"--sync--\" StartsUsing { id: \"25FD\", source: \"Shinryu\" } window 20,20\r\n21.3 \"Earthen Fury\" Ability { id: \"25DE\", source: \"Shinryu\" }\r\n36.4 \"--Tethers--\" # Burning Chains (301) effect\r\n44.5 \"Tidal Wave\" Ability { id: \"25F9\", source: \"Shinryu\" }\r\n49.7 \"--Tail Marker (healer)--\" # 007E headmarker\r\n61.7 \"Summon Icicle\" Ability { id: \"25EE\", source: \"Left Wing\" }\r\n62.4 \"Icicle Impact\" Ability { id: \"25EF\", source: \"Icicle\" }\r\n67.0 \"Spikesicle\" Ability { id: \"25F0\", source: \"Icicle\" }\r\n67.9 \"Tail Slap\" Ability { id: \"25E2\", source: \"Tail\" }\r\n79.8 \"Hypernova / Levinbolt\" Ability { id: [\"25E8\", \"25EA\"], source: \"Right Wing\" }\r\n90.9 \"Dragonfist\" Ability { id: \"2610\", source: \"Shinryu\" }\r\n97.8 \"Ice Storm\" Ability { id: \"25F1\", source: \"Left Wing\" } # sometimes 3 seconds earlier?\r\n108.0 \"Akh Morn 1\" Ability { id: \"25F3\", source: \"Shinryu\" } duration 3.2\r\n110.1 \"Akh Rhai\" Ability { id: \"25F5\", source: \"Shinryu\" } duration 5.3\r\n116.3 \"Summon Icicle\" Ability { id: \"25EE\", source: \"Left Wing\" }\r\n116.9 \"Icicle Impact\" Ability { id: \"25EF\", source: \"Icicle\" }\r\n121.4 \"Spikesicle\" Ability { id: \"25F0\", source: \"Icicle\" }\r\n123.3 \"Judgment Bolt / Hellfire\" Ability { id: [\"25FA\", \"25DC\"], source: \"Shinryu\" }\r\n\r\n138.4 \"--Tail Marker (dps)--\"\r\n149.5 \"Levinbolt\" Ability { id: \"25EA\", source: \"Right Wing\" }\r\n156.6 \"Tail Slap\" Ability { id: \"25E2\", source: \"Tail\" }\r\n164.5 \"Ice Storm\" Ability { id: \"25F1\", source: \"Left Wing\" }\r\n171.8 \"--Tethers (T/H)--\"\r\n180.6 \"Earth Breath\" Ability { id: \"25EC\", source: \"Shinryu\" }\r\n188.0 \"Akh Morn 2\" Ability { id: \"25F3\", source: \"Shinryu\" } duration 3.2\r\n190.1 \"Akh Rhai\" Ability { id: \"25F5\", source: \"Shinryu\" } duration 5.3\r\n194.0 \"Ice Storm\" Ability { id: \"25F1\", source: \"Left Wing\" }\r\n206.6 \"--Tethers (healers)--\"\r\n208.2 \"Diamond Dust\" Ability { id: \"25FC\", source: \"Shinryu\" }\r\n224.9 \"--Reiryu Adds--\"\r\n\r\n233.3 \"--Tail Marker (tank)--\"\r\n251.5 \"Tail Slap\" Ability { id: \"260D\", source: \"Tail\" }\r\n268.5 \"Summon Icicle\" Ability { id: \"25EE\", source: \"Left Wing\" }\r\n269.1 \"Icicle Impact\" Ability { id: \"25EF\", source: \"Icicle\" }\r\n272.4 \"Akh Morn 3\" Ability { id: \"25F3\", source: \"Shinryu\" } duration 3.2\r\n273.6 \"Spikesicle\" Ability { id: \"25F0\", source: \"Icicle\" }\r\n274.5 \"Akh Rhai\" Ability { id: \"25F5\", source: \"Shinryu\" } duration 5.3\r\n285.3 \"Super Cyclone 1\" #Ability { id: \"260C\", source: \"Shinryu\" }\r\n287.4 \"Super Cyclone 2\" #Ability { id: \"260C\", source: \"Shinryu\" }\r\n289.5 \"Super Cyclone 3\" #Ability { id: \"260C\", source: \"Shinryu\" }\r\n291.7 \"Aerial Blast\" Ability { id: \"25FE\", source: \"Shinryu\" }\r\n292.7 \"--Tethers (dps)--\"\r\n318.9 \"Earth Breath\" Ability { id: \"25EC\", source: \"Shinryu\" }\r\n321.9 \"Ice Storm\" Ability { id: \"25F1\", source: \"Left Wing\" }\r\n\r\n325.3 \"--untargetable--\"\r\n334.7 \"--sync--\" Ability { id: \"25F7\", source: \"Shinryu\" }\r\n335.9 \"Gyre Charge\" Ability { id: \"2603\", source: \"Shinryu\" }\r\n341.8 \"--targetable--\"\r\n\r\n350.9 \"Hypernova\" Ability { id: \"25E8\", source: \"Right Wing\" }\r\n363.0 \"Akh Morn 4\" Ability { id: \"25F3\", source: \"Shinryu\" } duration 4.3\r\n365.1 \"Akh Rhai\" Ability { id: \"25F5\", source: \"Shinryu\" } duration 5.3\r\n378.3 \"Hypernova / Levinbolt\" Ability { id: [\"25E8\", \"25EA\"], source: \"Right Wing\" }\r\n384.3 \"Tidal Wave\" Ability { id: \"25F9\", source: \"Shinryu\" }\r\n387.4 \"--untargetable--\"\r\n394.8 \"Dark Matter\" #Ability { id: \"25E7\", source: \"Shinryu\" }\r\n\r\n\r\n### PHASE 2: Adds, explosions, dramatic tail climbing\r\n###\r\n500.0 \"--Phase 2--\" StartsUsing { id: \"25E7\", source: \"Shinryu\" } window 500,500\r\n503.0 \"Dark Matter\" Ability { id: \"25E7\", source: \"Shinryu\" }\r\n513.0 \"TAP BUTTON OR ELSE\" duration 5\r\n540.7 \"Touchdown\" Ability { id: \"2613\", source: \"Shinryu\" }\r\n545.2 \"--sync--\" Ability { id: \"25D9\", source: \"Shinryu\" }\r\n552.3 \"Meteor Impact 1\" Ability { id: \"25E5\", source: \"Cocoon\" }\r\n553.9 \"--sync--\" Ability { id: \"2605\", source: \"Cocoon\" }\r\n571.1 \"Meteor Impact 2\" Ability { id: \"25E5\", source: \"Cocoon\" }\r\n572.7 \"--sync--\" Ability { id: \"2605\", source: \"Cocoon\" }\r\n588.0 \"--Cocoon Markers--\"\r\n601.0 \"Meteor Impact 3\" Ability { id: \"25E5\", source: \"Cocoon\" }\r\n602.6 \"--sync--\" Ability { id: \"2605\", source: \"Cocoon\" }\r\n\r\n### PHASE 3: Anticlimax\r\n###\r\n800.0 \"--Phase 3--\" StartsUsing { id: \"25E4\", source: \"Shinryu\" } window 500,500\r\n806.0 \"Protostar\" Ability { id: \"25E4\", source: \"Shinryu\" }\r\n813.1 \"Tail Spit\" Ability { id: \"2615\", source: \"Shinryu\" }\r\n837.4 \"Shatter\" Ability { id: \"2617\", source: \"Shinryu\" } window 50,50\r\n843.4 \"--targetable--\"\r\n\r\n# Loop 1\r\n855.5 \"--sync--\" StartsUsing { id: \"264B\", source: \"Shinryu\" } window 20,20\r\n859.5 \"Tera Slash\" Ability { id: \"264B\", source: \"Shinryu\" }\r\n868.2 \"Atomic Ray\" Ability { id: \"264C\", source: \"Shinryu\" }\r\n885.9 \"Ice Storm\" Ability { id: \"2722\", source: \"Left Wing\" }\r\n889.9 \"Levinbolt / Hypernova\" Ability { id: [\"2720\", \"271F\"], source: \"Right Wing\" }\r\n897.9 \"Wormwail / Benighting Breath\" Ability { id: [\"2648\", \"2649\"], source: \"Shinryu\" }\r\n907.1 \"Tera Slash\" Ability { id: \"264B\", source: \"Shinryu\" }\r\n910.8 \"--Reiryu Adds--\"\r\n\r\n# Loop 2\r\n957.4 \"Tera Slash\" Ability { id: \"264B\", source: \"Shinryu\" } window 20,20\r\n966.1 \"Atomic Ray\" Ability { id: \"264C\", source: \"Shinryu\" }\r\n983.8 \"Ice Storm\" Ability { id: \"2722\", source: \"Left Wing\" }\r\n987.8 \"Levinbolt / Hypernova\" Ability { id: [\"2720\", \"271F\"], source: \"Right Wing\" }\r\n995.9 \"Wormwail / Benighting Breath\" Ability { id: [\"2648\", \"2649\"], source: \"Shinryu\" }\r\n1005.1 \"Tera Slash\" Ability { id: \"264B\", source: \"Shinryu\" }\r\n1009.1 \"--Reiryu Adds--\"\r\n\r\n### PHASE 4: Race to the finish!\r\n###\r\n1046.0 \"--sync--\" StartsUsing { id: \"264E\", source: \"Shinryu\" } window 300,300\r\n1085.0 \"First Wing\" # 35 second cast, starts 4 seconds later, 2718/2719\r\n1090.0 \"Second Wing\" # 35 second cast, starts 9 seconds later, 2719/2718\r\n1116.0 \"Tidal Wave\" Ability { id: \"264E\", source: \"Shinryu\" } # 70 second cast\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/shinryu.ts



// Shinryu Normal
const shinryu_triggerSet = {
  id: 'TheRoyalMenagerie',
  zoneId: zone_id/* default.TheRoyalMenagerie */.Z.TheRoyalMenagerie,
  timelineFile: 'shinryu.txt',
  triggers: [{
    id: 'Shinryu Normal Akh Morn',
    type: 'StartsUsing',
    netRegex: {
      id: '1FA4',
      source: 'Shinryu'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.akhMornOnYou();else if (data.role === 'tank') return output.akhMornOn({
        player: data.party.member(matches.target)
      });
    },
    infoText: (data, matches, output) => {
      // Nobody with Akh Morn is a direct target for Akh Rai,
      // and tanks should never be targeted for it.
      // Additionally, Akh Rai happens only after the intermission.
      if (matches.target === data.me || data.role === 'tank' || !data.finalPhase) return;
      return output.akhRhaiSpreadAndMove();
    },
    outputStrings: {
      akhRhaiSpreadAndMove: {
        en: 'Akh Rhai: spread and move',
        de: 'Akh Rhai: Verteilen und bewegen',
        fr: 'Akh Rhai : Dispersion et bougez',
        ja: 'アク・ラーイ: 散開 動け',
        cn: '天光轮回：散开和移动',
        ko: '아크 라이: 산개, 이동'
      },
      akhMornOnYou: {
        en: 'Akh Morn on YOU',
        de: 'Akh Morn auf DIR',
        fr: 'Akh Morn sur VOUS',
        ja: '自分にアク・モーン',
        cn: '死亡轮回点名',
        ko: '아크몬 대상자'
      },
      akhMornOn: {
        en: 'Akh Morn on ${player}',
        de: 'Akh Morn auf ${player}',
        fr: 'Akh Morn sur ${player}',
        ja: '${player}にアク・モーン',
        cn: '死亡轮回点${player}',
        ko: '"${player}" 아크몬'
      }
    }
  }, {
    id: 'Shinryu Normal Diamond Dust',
    type: 'StartsUsing',
    netRegex: {
      id: '1FAD',
      source: 'Shinryu'
    },
    // Here and elsewhere, timings aren't always completely usable. Instead we give the user
    // a quasi-standard amount of time when notifying.
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 4,
    response: responses/* Responses.stopMoving */.n3.stopMoving()
  }, {
    id: 'Shinryu Normal Dragonfist',
    type: 'StartsUsing',
    netRegex: {
      id: '24EF',
      source: 'Shinryu',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out of middle',
        de: 'Raus aus der Mitte',
        fr: 'Sortez du milieu',
        ja: '中央から離れる',
        cn: '离开中间',
        ko: '중앙 피하기'
      }
    }
  }, {
    id: 'Shinryu Normal Hellfire',
    type: 'StartsUsing',
    netRegex: {
      id: '1FAB',
      source: 'Shinryu',
      capture: false
    },
    durationSeconds: 7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get in water',
        de: 'In\'s Wasser',
        fr: 'Allez dans l\'eau',
        ja: '水に入る',
        cn: '进水圈',
        ko: '물 장판에 들어가기'
      }
    }
  }, {
    id: 'Shinryu Normal Hypernova',
    type: 'StartsUsing',
    netRegex: {
      id: ['1F99', '1F9A'],
      source: 'Right Wing',
      capture: false
    },
    durationSeconds: 7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack in water',
        de: 'In Wasser stacken',
        fr: 'Packez-vous dans l\'eau',
        ja: '水に集合',
        cn: '水圈集合',
        ko: '물 장판에 모이기'
      }
    }
  }, {
    id: 'Shinryu Normal Judgement Bolt',
    type: 'StartsUsing',
    netRegex: {
      id: '1FAC',
      source: 'Shinryu',
      capture: false
    },
    durationSeconds: 7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'out of water',
        de: 'Raus aus dem Wasser',
        fr: 'Sortez de l\'eau',
        ja: '水から離れる',
        cn: '离开水圈',
        ko: '물 장판 밖으로'
      }
    }
  }, {
    id: 'Shinryu Normal Levinbolt',
    type: 'StartsUsing',
    netRegex: {
      id: '1F9B',
      source: 'Right Wing',
      capture: false
    },
    durationSeconds: 7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread out, no water',
        de: 'Verteilen und nicht in\'s Wasser',
        fr: 'Dispersez-vous en dehors de l\'eau',
        ja: '散開、水に入らない',
        cn: '散开，离开水圈',
        ko: '산개, 물장판 X'
      }
    }
  }, {
    id: 'Shinryu Normal Tidal Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '1FAA',
      source: 'Shinryu'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 6,
    durationSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback, look for water',
        de: 'Rückstoß, nach Wasser schauen',
        fr: 'Poussée, cherchez l\'eau',
        ja: 'ノックバック、水を探せ',
        cn: '击退，找水圈',
        ko: '넉백, 물기둥 확인'
      }
    }
  }, {
    id: 'Shinryu Normal Ice Storm',
    type: 'StartsUsing',
    netRegex: {
      id: '1FA2',
      source: 'Left Wing'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 4,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Shinryu Normal Tail Slap',
    type: 'StartsUsing',
    netRegex: {
      id: '1F93',
      source: 'Tail',
      capture: false
    },
    delaySeconds: 2,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tail: Switch targets',
        de: 'Schweif: Zielwechsel',
        fr: 'Queue : Changez de cible',
        ja: '尾: タゲチェンジ',
        cn: '打尾巴',
        ko: '꼬리 공격'
      }
    }
  }, {
    // Re-using the Gyre Charge triggers since they're convenient and already translated.
    id: 'Shinryu Normal Akh Rai Activation',
    type: 'StartsUsing',
    netRegex: {
      id: '1FF4',
      source: 'Shinryu',
      capture: false
    },
    condition: data => !data.finalPhase,
    run: data => data.finalPhase = true
  }, {
    id: 'Shinryu Normal Divebomb',
    type: 'StartsUsing',
    netRegex: {
      id: '1FF4',
      source: 'Shinryu',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'avoid divebomb',
        de: 'Divebomb ausweichen',
        fr: 'Évitez la bombe plongeante',
        ja: 'ダイブボムを避ける',
        cn: '前方顺劈',
        ko: '회전 돌진 피하기'
      }
    }
  }, {
    id: 'Shinryu Normal Tethers',
    type: 'HeadMarker',
    netRegex: {
      id: '0061'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 3.8,
    response: responses/* Responses.breakChains */.n3.breakChains()
  }, {
    // There doesn't really seem to be any verified information about this marker.
    // It usually appears around Burning Chains, but it's wildly inconsistent.
    // However, it *seems* that the tail attacks from the side the target is on.
    id: 'Shinryu Normal Slap Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0062'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait onto unbroken squares',
        de: 'Auf nicht kaputter Fläche ködern',
        fr: 'Attirez sur les carrés non brisés',
        ja: '壊れなかった床に誘導',
        cn: '在未损坏方格上诱导',
        ko: '꼬리 내리치기 유도'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Cocoon': 'Lichtsphäre',
      'Left Wing': 'link(?:e|er|es|en) Schwinge',
      'Right Wing': 'recht(?:e|er|es|en) Schwinge',
      'Shinryu': 'Shinryu',
      'Tail': 'Schwanz',
      'Icicle': 'Eiszapfen'
    },
    'replaceText': {
      'Akh Morn': 'Akh Morn',
      'Elemental Attack': 'Elemental Attack',
      'Dark Matter': 'Dunkelmaterie',
      'Dragonfist': 'Drachenfaust',
      'Earth Breath': 'Erdatem',
      'Gyre Charge': 'Wirbel-Aufladung',
      'Hellfire': 'Höllenfeuer',
      'Hypernova': 'Supernova',
      'Ice Storm': 'Eissturm',
      'Icicle Impact': 'Eiszapfen-Schlag',
      'Judgment Bolt': 'Ionenschlag',
      'Levinbolt': 'Keraunisches Feld',
      'Meteor Impact': 'Meteoreinschlag',
      'Protostar': 'Protostern',
      'Spikesicle': 'Eislanze',
      'Summon Icicle': 'Flugeis',
      'TAP BUTTON OR ELSE': 'DRÜCKE TASTEN ETC',
      'Tail Slap': 'Schweifklapser',
      'Tidal Wave': 'Flutwelle'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Cocoon': 'cocon de lumière',
      'Icicle': 'stalactite',
      'Left Wing': 'aile gauche',
      'Right Wing': 'aile droite',
      'Shinryu': 'Shinryu',
      'Tail': 'queue'
    },
    'replaceText': {
      'Akh Morn': 'Akh Morn',
      'Elemental Attack': 'Attaque élémentaire',
      'Dark Matter': 'Matière sombre',
      'Dragonfist': 'Poing dragon',
      'Earth Breath': 'Souffle de terre',
      'Gyre Charge': 'Gyrocharge',
      'Hellfire': 'Flammes de l\'enfer',
      'Hypernova': 'Hypernova',
      'Ice Storm': 'Tempête de glace',
      'Icicle Impact': 'Impact de stalactite',
      'Judgment Bolt': 'Éclair du jugement',
      'Levinbolt': 'Fulguration',
      'Meteor Impact': 'Impact de météore',
      'Protostar': 'Proto-étoile',
      'Spikesicle': 'Stalactopointe',
      'Summon Icicle': 'Appel de stalactite',
      'Tail Slap': 'Gifle caudale',
      'TAP BUTTON OR ELSE': 'CLIQUEZ SUR LE BOUTON OU AUTRE',
      'Tidal Wave': 'Raz-de-marée'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Cocoon': '光の繭',
      'Left Wing': 'レフトウィング',
      'Right Wing': 'ライトウィング',
      'Shinryu': '神龍',
      'Tail': '神龍の尾',
      'Icicle': 'アイシクル'
    },
    'replaceText': {
      'Akh Morn': 'アク・モーン',
      'Elemental Attack': 'エレメンタル攻撃',
      'Dark Matter': 'ダークマター',
      'Dragonfist': '龍掌',
      'Earth Breath': 'アースブレス',
      'Gyre Charge': 'ジャイヤチャージ',
      'Hellfire': '地獄の火炎',
      'Hypernova': 'スーパーノヴァ',
      'Ice Storm': '吹雪',
      'Icicle Impact': 'アイシクルインパクト',
      'Judgment Bolt': '裁きの雷',
      'Levinbolt': '稲妻',
      'Meteor Impact': 'メテオインパクト',
      'Protostar': 'プロトスター',
      'Spikesicle': 'アイシクルスパイク',
      'Summon Icicle': 'サモン・アイシクル',
      'TAP BUTTON OR ELSE': 'ボタンを押せ！',
      'Tail Slap': 'テールスラップ',
      'Tidal Wave': 'タイダルウェイブ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Cocoon': '光茧',
      'Left Wing': '左翼',
      'Right Wing': '右翼',
      'Shinryu': '神龙',
      'Tail': '龙尾',
      'Icicle': '冰柱'
    },
    'replaceText': {
      'Akh Morn': '死亡轮回',
      'Elemental Attack': '元素攻击',
      'Dark Matter': '暗物质',
      'Dragonfist': '龙掌',
      'Earth Breath': '大地吐息',
      'Gyre Charge': '螺旋冲锋',
      'Hellfire': '地狱之火炎',
      'Hypernova': '超新星',
      'Ice Storm': '吹雪',
      'Icicle Impact': '冰柱冲击',
      'Judgment Bolt': '制裁之雷',
      'Levinbolt': '闪电',
      'Meteor Impact': '陨石冲击',
      'Protostar': '原恒星',
      'Spikesicle': '冰柱突刺',
      'Summon Icicle': '召唤冰柱',
      'TAP BUTTON OR ELSE': 'XJB按',
      'Tail Slap': '尾部猛击',
      'Tidal Wave': '巨浪'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Cocoon': '빛의 고치',
      'Left Wing': '왼쪽 날개',
      'Right Wing': '오른쪽 날개',
      'Shinryu': '신룡',
      'Tail(?! )': '신룡의 꼬리'
    },
    'replaceText': {
      'Akh Morn': '아크 몬',
      'Dark Matter': '암흑물질',
      'Dragonfist': '용의 손바닥',
      'Elemental Attack': '원소 공격',
      'Earth Breath': '대지의 숨결',
      'Gyre Charge': '회전 돌진',
      'Hellfire': '지옥의 화염',
      'Hypernova': '초신성',
      'Ice Storm': '눈보라',
      'Icicle Impact': '고드름 낙하',
      'Judgment Bolt': '심판의 벼락',
      'Levinbolt': '우레',
      'Meteor Impact': '운석 낙하',
      'Protostar': '원시별',
      'Spikesicle': '고드름 돌진',
      'Summon Icicle': '고드름 소환',
      'TAP BUTTON OR ELSE': '긴 급 조 작',
      'Tail Slap': '꼬리치기',
      'Tidal Wave': '해일'
    }
  }]
};
/* harmony default export */ const shinryu = (shinryu_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/shinryu.txt
const trial_shinryu_namespaceObject = "hideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# ii 1F8B 1F8D 1F8E 1F8F 1F90 1F94 1F9A 1F9C 1F9E 1FA3 1FBB 1FCE 1FCF 1FF4 2218 2219 221A 244B 24F0\r\n\r\n# Elemental Attack is one of:\r\n# Aerial Blast, Judgment Bolt, Diamond Dust, Hellfire, Earthen Fury, Tidal Wave\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n20.6 \"Tidal Wave\" Ability { id: \"1FAA\", source: \"Shinryu\" } window 20.6,5\r\n38.8 \"Hypernova/Levinbolt\" Ability { id: \"1F9[9B]\", source: \"Right Wing\" }\r\n49.9 \"Akh Morn\" Ability { id: \"1FA4\", source: \"Shinryu\" }\r\n59.2 \"Summon Icicle\" Ability { id: \"1F9F\", source: \"Left Wing\" }\r\n59.9 \"Icicle Impact x2\" # Ability { id: \"1FA0\", source: \"Icicle\" }\r\n64.4 \"Spikesicle x2\" # Ability { id: \"1FA1\", source: \"Icicle\" }\r\n75.2 \"Ice Storm\" Ability { id: \"1FA2\", source: \"Left Wing\" }\r\n88.3 \"Earth Breath\" Ability { id: \"1F9D\", source: \"Shinryu\" } # May be skipped with high DPS\r\n115.8 \"Hellfire/Judgment Bolt\"Ability { id: \"1FA[BC]\", source: \"Shinryu\" } window 30,30\r\n118.1 \"--untargetable--\"\r\n\r\n# Intermission.\r\n# The given times for Meteor Impact are the latest they can occur.\r\n119.0 \"--sync--\" Ability { id: \"1F8A\", source: \"Shinryu\" } window 120,5\r\n125.4 \"--sync--\" StartsUsing { id: \"1F96\", source: \"Cocoon\" } window 10,5\r\n129.1 \"Meteor Impact\" Ability { id: \"1F96\", source: \"Cocoon\" }\r\n130.6 \"--adds spawn--\" Ability { id: \"2142\", source: \"Cocoon\" }\r\n146.2 \"--sync--\" StartsUsing { id: \"1F96\", source: \"Cocoon\" } window 15,5\r\n150.9 \"Meteor Impact\" Ability { id: \"1F96\", source: \"Cocoon\" }\r\n152.5 \"--adds spawn--\" Ability { id: \"2142\", source: \"Cocoon\" }\r\n176.1 \"--sync--\" StartsUsing { id: \"1F96\", source: \"Cocoon\" } window 25,5\r\n180.8 \"Meteor Impact\" Ability { id: \"1F96\", source: \"Cocoon\" }\r\n182.4 \"--adds spawn--\" Ability { id: \"2142\", source: \"Cocoon\" }\r\n219.7 \"--sync--\" StartsUsing { id: \"1F95\", source: \"Shinryu\" } window 220,5\r\n225.2 \"Protostar\" Ability { id: \"1F95\", source: \"Shinryu\" }\r\n234.3 \"Dark Matter\" Ability { id: \"1F98\", source: \"Shinryu\" }\r\n240.5 \"--sync--\" Ability { id: \"2128\", source: \"Shinryu\" }\r\n244.9 \"TAP BUTTON OR ELSE\" # Doesn't seem to have an actual log line to sync\r\n\r\n# Post-intermission block\r\n271.9 \"Gyre Charge\" Ability { id: \"1FA8\", source: \"Shinryu\" }\r\n279.1 \"--targetable--\"\r\n290.3 \"Tail Slap\" Ability { id: \"1F93\", source: \"Tail\" }\r\n311.3 \"Ice Storm\" Ability { id: \"1FA2\", source: \"Left Wing\" }\r\n317.4 \"Tail Slap\" Ability { id: \"1F93\", source: \"Tail\" }\r\n328.4 \"Ice Storm\" Ability { id: \"1FA2\", source: \"Left Wing\" }\r\n335.5 \"Dragonfist\" Ability { id: \"24EF\", source: \"Shinryu\" } window 30,30\r\n353.6 \"Elemental Attack\" Ability { id: \"1FA[ABCDEF]\", source: \"Shinryu\" }\r\n360.8 \"--sync--\" Ability { id: \"1F9[12]\", source: \"Shinryu\" } window 30,15\r\n363.7 \"Summon Icicle\" Ability { id: \"1F9F\", source: \"Left Wing\" }\r\n364.3 \"Icicle Impact x2\" # Ability { id: \"1FA0\", source: \"Icicle\" }\r\n368.8 \"Spikesicle x2\" # Ability { id: \"1FA1\", source: \"Icicle\" }\r\n370.8 \"Tail Slap\" Ability { id: \"1F93\", source: \"Tail\" }\r\n377.8 \"Ice Storm\" Ability { id: \"1FA2\", source: \"Left Wing\" }\r\n387.8 \"Hypernova/Levinbolt\" Ability { id: \"1F9[9B]\", source: \"Right Wing\" }\r\n388.0 \"--sync--\" Ability { id: \"1F9[12]\", source: \"Shinryu\" }\r\n398.1 \"Tail Slap\" Ability { id: \"1F93\", source: \"Tail\" }\r\n425.2 \"Elemental Attack\" Ability { id: \"1FA[ABCDEF]\", source: \"Shinryu\" }\r\n425.2 \"--sync--\" Ability { id: \"23BA\", source: \"Shinryu\" }\r\n\r\n# Rotation to 0% HP\r\n434.4 \"Akh Morn x3\" Ability { id: \"1FA4\", source: \"Shinryu\" } window 30,30\r\n440.7 \"--untargetable--\"\r\n450.1 \"Gyre Charge\" Ability { id: \"1FA8\", source: \"Shinryu\" }\r\n457.2 \"--targetable--\"\r\n466.4 \"Ice Storm\" Ability { id: \"1FA2\", source: \"Left Wing\" }\r\n478.4 \"Dragonfist\" Ability { id: \"24EF\", source: \"Shinryu\" } window 30,30\r\n484.4 \"Hypernova/Levinbolt\" Ability { id: \"1F9[9B]\", source: \"Right Wing\" }\r\n496.5 \"Elemental Attack\" Ability { id: \"1FA[ABCDEF]\", source: \"Shinryu\" }\r\n507.7 \"--sync--\" Ability { id: \"1F9[12]\", source: \"Shinryu\" } window 30,15\r\n509.7 \"Summon Icicle\" Ability { id: \"1F9F\", source: \"Left Wing\" }\r\n510.3 \"Icicle Impact\" # Ability { id: \"1FA0\", source: \"Icicle\" }\r\n514.8 \"Spikesicle x2\" # Ability { id: \"1FA1\", source: \"Icicle\" }\r\n517.9 \"Tail Slap\" Ability { id: \"1F93\", source: \"Tail\" }\r\n527.8 \"Hypernova/Levinbolt\" Ability { id: \"1F9[9B]\", source: \"Right Wing\" }\r\n540.8 \"Akh Morn x3\" # Ability { id: \"1FA4\", source: \"Shinryu\" } duration 5\r\n548.9 \"Ice Storm\" Ability { id: \"1FA2\", source: \"Left Wing\" }\r\n555.2 \"Earth Breath\" Ability { id: \"1F9D\", source: \"Shinryu\" }\r\n569.6 \"Elemental Attack\" Ability { id: \"1FA[ABCDEF]\", source: \"Shinryu\" }\r\n\r\n578.8 \"Akh Morn x3\" Ability { id: \"1FA4\", source: \"Shinryu\" } jump 434.4\r\n585.1 \"--untargetable--\"\r\n594.5 \"Gyre Charge\"\r\n601.6 \"--targetable--\"\r\n610.8 \"Ice Storm\"\r\n\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/susano-ex.ts




// Susano Extreme
const susano_ex_triggerSet = {
  id: 'ThePoolOfTributeExtreme',
  zoneId: zone_id/* default.ThePoolOfTributeExtreme */.Z.ThePoolOfTributeExtreme,
  timelineFile: 'susano-ex.txt',
  timelineTriggers: [{
    id: 'SusEx Cloud',
    regex: /--knockback cloud--/,
    beforeSeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'look for cloud',
        de: 'Nach Wolke ausschau halten',
        fr: 'Cherchez le nuage',
        ja: '雷雲を探せ',
        cn: '寻找雷云',
        ko: '구름 확인'
      }
    }
  }, {
    id: 'SusEx Assail',
    regex: /Assail/,
    beforeSeconds: 6,
    response: responses/* Responses.miniBuster */.n3.miniBuster()
  }],
  triggers: [{
    id: 'SusEx Thundercloud Tracker',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Thunderhead',
      capture: false
    },
    run: data => data.cloud = true
  }, {
    // Stop tracking the cloud after it casts lightning instead of
    // when it disappears.  This is because there are several
    // levinbolts with the same cloud, but only one levinbolt has
    // lightning attached to it.
    id: 'SusEx Thundercloud Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '2041',
      source: 'Thunderhead',
      target: 'Thunderhead',
      capture: false
    },
    run: data => data.cloud = false
  }, {
    id: 'SusEx Churning Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '4F6',
      capture: false
    },
    condition: data => !data.churning,
    run: data => data.churning = true
  }, {
    // We could track the number of people with churning here, but
    // that seems a bit fragile.  This might not work if somebody dies
    // while having churning, but is probably ok in most cases.
    id: 'SusEx Churning Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '4F6',
      capture: false
    },
    condition: data => data.churning,
    run: data => data.churning = false
  }, {
    id: 'SusEx Stormsplitter',
    type: 'StartsUsing',
    netRegex: {
      source: 'Susano',
      id: '2033'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap('alert', 'info')
  }, {
    // Red knockback marker indicator
    id: 'SusEx Knockback',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (data, _matches, output) => {
      if (data.cloud) return output.knockbackWithCloud();else if (data.churning) return output.knockbackWithDice();
      return output.knockback();
    },
    tts: (data, _matches, output) => {
      if (data.cloud) return output.knockbackWithCloudTTS();else if (data.churning) return output.knockbackWithDiceTTS();
      return output.knockbackTTS();
    },
    outputStrings: {
      knockbackWithCloud: {
        en: 'Knockback on you (cloud)',
        de: 'Rückstoss auf Dir (Wolke)',
        fr: 'Poussée sur VOUS (nuage)',
        ja: '自分にノックバック (雷雲)',
        cn: '击退点名（雷云）',
        ko: '넉백 대상자 (구름)'
      },
      knockbackWithDice: {
        en: 'Knockback + dice (STOP)',
        de: 'Rückstoss + Würfel (STOPP)',
        fr: 'Poussée + dé (ARRÊTEZ)',
        ja: 'ノックバック + 禍泡 (そのまま)',
        cn: '击退+水泡（静止）',
        ko: '넉백 + 주사위 (가만히)'
      },
      knockback: outputs/* default.knockbackOnYou */.Z.knockbackOnYou,
      knockbackWithCloudTTS: {
        en: 'knockback with cloud',
        de: 'Rückstoß mit wolke',
        fr: 'Poussée avec nuage',
        ja: '雷雲ノックバック',
        cn: '雷云击退',
        ko: '넉백과 구름 장판'
      },
      knockbackWithDiceTTS: {
        en: 'Knockback with dice',
        de: 'Rückstoß mit Würfel',
        fr: 'Poussée avec dé',
        ja: '禍泡ノックバック',
        cn: '水泡击退',
        ko: '넉백과 주사위'
      },
      knockbackTTS: outputs/* default.knockback */.Z.knockback
    }
  }, {
    id: 'SusEx Brightstorm Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'SusEx Levinbolt',
    type: 'HeadMarker',
    netRegex: {
      id: '006E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (data, _matches, output) => {
      if (data.cloud) return output.levinboltWithCloud();
      return output.levinboltOnYou();
    },
    tts: (data, _matches, output) => {
      if (data.cloud) return output.levinboltWithCloudTTS();
      return output.levinboltOnYouTTS();
    },
    outputStrings: {
      levinboltWithCloud: {
        en: 'Levinbolt on you (cloud)',
        de: 'Blitz auf Dir (Wolke)',
        fr: 'Fulguration sur VOUS (nuage)',
        ja: '自分に稲妻 (雷雲)',
        cn: '闪电点名（雷云）',
        ko: '우레 대상자 (구름)'
      },
      levinboltOnYou: {
        en: 'Levinbolt on you',
        de: 'Blitz auf dir',
        fr: 'Fulguration sur VOUS',
        ja: '自分に稲妻',
        cn: '闪电点名',
        ko: '우레 대상자'
      },
      levinboltWithCloudTTS: {
        en: 'bolt with cloud',
        de: 'blitz mit wolke',
        fr: 'foudre avec nuage',
        ja: '雷雲 稲妻',
        cn: '闪电带雷云',
        ko: '구름 번개'
      },
      levinboltOnYouTTS: {
        en: 'bolt',
        de: 'blitz',
        fr: 'foudre',
        ja: '稲妻',
        cn: '闪电',
        ko: '번개'
      }
    }
  }, {
    id: 'SusEx Levinbolt Stun',
    type: 'HeadMarker',
    netRegex: {
      id: '006F'
    },
    infoText: (data, matches, output) => {
      // It's sometimes hard for tanks to see the line, so just give a
      // sound indicator for jumping rope back and forth.
      if (data.role === 'tank') return output.text({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Stun: ${player}',
        de: 'Paralyse ${player}',
        fr: 'Étourdi(e) :  ${player}',
        ja: '${player}にスタン',
        cn: '击晕${player}',
        ko: '${player}스턴'
      }
    }
  }, {
    id: 'SusEx Churning',
    type: 'GainsEffect',
    netRegex: {
      effectId: '4F6'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 3,
    response: responses/* Responses.stopEverything */.n3.stopEverything('alert')
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Yata-No-Kagami': '--knockback--'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Ame-No-Murakumo': 'Ame no Murakumo',
      'Susano': 'Susano',
      'Thunderhead': 'Gewitterwolke',
      'Ama-No-Iwato': 'Ama no Iwato'
    },
    'replaceText': {
      '(?<! )cloud': 'Wolke',
      'Ame-No-Murakumo(?! )': 'Ame No Murakumo',
      'Assail': 'Schwere Attacke',
      'Churn': 'Schaum',
      'Dark Levin': 'violetter Blitz',
      'Knockback': 'Rückstoß',
      'Levinbolt': 'Keraunisches Feld',
      'Rasen Kaikyo': 'Rasen Kaikyo',
      'Seasplitter': 'Seespalter',
      'Stun': 'Betäuben',
      'Stormsplitter': 'Sturmspalter',
      'The Hidden Gate': 'Verschwundenes Tor',
      'The Sealed Gate': 'Versiegeltes Tor',
      'Ukehi': 'Ukehi',
      'Yata-No-Kagami': 'Yata no Kagami',
      'Brightstorm': 'Heller Sturm',
      'Yasakani-No-Magatama': 'Yasakani no Magatama',
      'The Parting Clouds': 'Wolkenriss'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ame-No-Murakumo': 'Ame no Murakumo',
      'Susano': 'Susano',
      'Thunderhead': 'nuage orageux',
      'Ama-No-Iwato': 'ama no iwato'
    },
    'replaceText': {
      '(?<! )cloud': 'nuage',
      'Assail': 'Assaut',
      'Churn': 'Agitation',
      'Dark Levin': 'foudre violette',
      'Knockback': 'Poussée',
      'Levinbolt': 'Fulguration',
      'Rasen Kaikyo': 'Rasen Kaikyo',
      'Seasplitter': 'Fendeur de mers',
      'Stun': 'Étourdissement',
      'Stormsplitter': 'Fendeur de tempêtes',
      'The Hidden Gate': 'Porte cachée',
      'The Sealed Gate': 'Porte scellée',
      'Ukehi': 'Ukehi',
      'Yata-No-Kagami': '--poussée--',
      'Brightstorm': 'Claire tempête',
      'Yasakani-No-Magatama': 'Yasakani no Magatama',
      'The Parting Clouds': 'Dispersion de nuages',
      'Ame-No-Murakumo(?! )': 'Ame no Murakumo'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ame-No-Murakumo': 'アメノムラクモ',
      'Susano': 'スサノオ',
      'Thunderhead': '雷雲',
      'Ama-No-Iwato': '天岩戸'
    },
    'replaceText': {
      'Assail': '強撃',
      'Churn': '禍泡付着',
      'Dark Levin': '紫電',
      'Knockback': 'ノックバック',
      'Levinbolt': '稲妻',
      'Phase': 'フェイス',
      'Rasen Kaikyo': '螺旋海峡',
      'Seasplitter': '海割り',
      'Stormsplitter': '海嵐斬',
      'The Hidden Gate': '岩戸隠れ',
      'The Sealed Gate': '岩戸閉め',
      'Ukehi': '宇気比',
      '(?<! )cloud': '雲',
      'Ame-No-Murakumo(?! )': 'アメノムラクモ',
      'Stun': 'スタン',
      'Yata-No-Kagami': 'ヤタノカガミ',
      'Brightstorm': '晴嵐',
      'Yasakani-No-Magatama': 'ヤサカニノマガタマ',
      'The Parting Clouds': '雲間放電'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ame-No-Murakumo': '天之丛云',
      'Susano': '须佐之男',
      'Thunderhead': '雷云',
      'Ama-No-Iwato': '天之岩户'
    },
    'replaceText': {
      'Assail': '强击',
      'Churn': '祸泡附身',
      'Dark Levin': '紫电',
      'Knockback': '击退',
      'Levinbolt': '闪电',
      'Phase': '阶段',
      'Rasen Kaikyo': '螺旋海峡',
      'Seasplitter': '断海',
      'Stormsplitter': '破浪斩',
      'The Hidden Gate': '岩户隐',
      'The Sealed Gate': '岩户闭合',
      'Ukehi': '祈请',
      '(?<! )cloud': '云',
      'Ame-No-Murakumo(?! )': '天之丛云',
      'Stun': '眩晕',
      'Yata-No-Kagami': '八咫镜',
      'Brightstorm': '晴岚',
      'Yasakani-No-Magatama': '八尺琼勾玉',
      'The Parting Clouds': '云间放电'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ame-No-Murakumo(?! )': '아메노무라쿠모',
      'Susano': '스사노오',
      'Thunderhead': '번개구름',
      'Ama-No-Iwato': '신의 바위'
    },
    'replaceText': {
      'Assail': '강력 공격',
      'Churn': '재앙거품 부착',
      'Dark Levin': '번갯불',
      'Knockback': '넉백',
      'Levinbolt': '우레',
      'Phase': '페이즈',
      'Rasen Kaikyo': '나선 해협',
      'Seasplitter': '바다 가르기',
      'Stun': '기절',
      'Stormsplitter': '해풍참',
      'The Hidden Gate': '바위 숨기기',
      'The Sealed Gate': '바위 조이기',
      'Ukehi': '내기 선언',
      '(?<! )cloud': '구름',
      'Ame-No-Murakumo(?! )': '아메노무라쿠모',
      'Yata-No-Kagami': '야타의 거울',
      'Brightstorm': '산바람',
      'Yasakani-No-Magatama': '야사카니의 곡옥',
      'The Parting Clouds': '구름 방전'
    }
  }]
};
/* harmony default export */ const susano_ex = (susano_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/susano-ex.txt
const trial_susano_ex_namespaceObject = "# Susano Extreme\r\n# -it Susano\r\n# -p 202C:9.1 21C6:300 2032:400\r\n# -ii 203F 2038 2039 203A 203B 202E 2037 208D 203D 2031 2044\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n# Seasplitter knockback marker appearing, hidden for noise reasons.\r\nhideall \"Yasakani-No-Magatama\"\r\n# Used for triggers.\r\nhideall \"--knockback cloud--\"\r\n\r\n### Phase 1 ###\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n9.1 \"Assail\" Ability { id: \"202C\", source: \"Susano\" } window 10,10\r\n12.3 \"Churn\" Ability { id: \"203E\", source: \"Susano\" }\r\n36.4 \"Yata-No-Kagami\" Ability { id: \"202F\", source: \"Susano\" }\r\n40.7 \"Seasplitter\" Ability { id: \"25BD\", source: \"Susano\" }\r\n42.5 \"Brightstorm\" Ability { id: \"2030\", source: \"Susano\" }\r\n47.7 \"Assail\" Ability { id: \"202C\", source: \"Susano\" }\r\n50.8 \"Churn\" Ability { id: \"203E\", source: \"Susano\" }\r\n58.8 \"Rasen Kaikyo\" Ability { id: \"202D\", source: \"Susano\" }\r\n70.0 \"Yasakani-No-Magatama\" Ability { id: \"2040\", source: \"Susano\" }\r\n77.1 \"Yata-No-Kagami\" Ability { id: \"202F\", source: \"Susano\" }\r\n81.4 \"Seasplitter\" Ability { id: \"25BD\", source: \"Susano\" }\r\n81.5 \"The Parting Clouds\" Ability { id: \"2041\", source: \"Thunderhead\" }\r\n88.2 \"Assail\" Ability { id: \"202C\", source: \"Susano\" }\r\n93.8 \"--untargetable--\"\r\n\r\n### Phase 2 (hp push at ???% / time push)\r\n# sync to touching the Blade's Shadow, this happens twice\r\n300.0 \"--sync--\" Ability { id: \"21C6\", source: \"Susano\" } window 300,100\r\n305.6 \"--targetable--\"\r\n305.6 \"--Dark Levin 1--\"\r\n308.4 \"--Dark Levin 2--\"\r\n311.5 \"--Dark Levin 3--\"\r\n314.4 \"--Dark Levin 4--\"\r\n\r\n### Phase 3 ###\r\n400.0 \"Ame-No-Murakumo\" Ability { id: \"2032\", source: \"Susano\" } window 400,100\r\n404.1 \"Ame-No-Murakumo\" Ability { id: \"218C\", source: \"Susano\" }\r\n413.6 \"--targetable--\"\r\n\r\n425.9 \"Stormsplitter\" Ability { id: \"2033\", source: \"Susano\" }\r\n432.6 \"Levinbolt 1\" Ability { id: \"203C\", source: \"Susano\" }\r\n438.1 \"Levinbolt 2\" Ability { id: \"203C\", source: \"Susano\" }\r\n443.5 \"Levinbolt 3\" Ability { id: \"203C\", source: \"Susano\" }\r\n449.0 \"Levinbolt 4\" Ability { id: \"203C\", source: \"Susano\" }\r\n458.9 \"Ukehi x2\" Ability { id: \"2036\", source: \"Susano\" }\r\n467.2 \"Yasakani-No-Magatama\" Ability { id: \"2040\", source: \"Susano\" }\r\n474.5 \"--knockback cloud--\"\r\n474.5 \"Yata-No-Kagami\" Ability { id: \"202F\", source: \"Susano\" }\r\n478.8 \"Seasplitter\" Ability { id: \"25BD\", source: \"Susano\" }\r\n478.9 \"The Parting Clouds\" Ability { id: \"2041\", source: \"Thunderhead\" }\r\n480.6 \"Brightstorm\" Ability { id: \"2030\", source: \"Susano\" }\r\n\r\n490.8 \"Stormsplitter\" Ability { id: \"2033\", source: \"Susano\" }\r\n495.9 \"Yasakani-No-Magatama\" Ability { id: \"2040\", source: \"Susano\" }\r\n497.5 \"Levinbolt 1\" Ability { id: \"203C\", source: \"Susano\" }\r\n503.0 \"Levinbolt 2\" Ability { id: \"203C\", source: \"Susano\" }\r\n506.7 \"The Parting Clouds\" Ability { id: \"2041\", source: \"Thunderhead\" }\r\n508.5 \"Levinbolt 3\" Ability { id: \"203C\", source: \"Susano\" }\r\n514.0 \"Levinbolt 4\" Ability { id: \"203C\", source: \"Susano\" }\r\n521.1 \"Ukehi x3\" Ability { id: \"2036\", source: \"Susano\" }\r\n\r\n531.5 \"The Hidden Gate\" Ability { id: \"2034\", source: \"Susano\" }\r\n547.2 \"Rasen Kaikyo\" Ability { id: \"202D\", source: \"Susano\" }\r\n554.5 \"Stormsplitter\" Ability { id: \"2033\", source: \"Susano\" }\r\n557.1 \"The Sealed Gate\" Ability { id: \"2035\", source: \"Ama-No-Iwato\" }\r\n566.7 \"Levinbolt Stun 1\" Ability { id: \"203C\", source: \"Susano\" }\r\n573.2 \"Levinbolt Stun 2\" Ability { id: \"203C\", source: \"Susano\" }\r\n579.7 \"Levinbolt Stun 3\" Ability { id: \"203C\", source: \"Susano\" }\r\n586.2 \"Levinbolt Stun 4\" Ability { id: \"203C\", source: \"Susano\" }\r\n592.6 \"Ukehi x3\" Ability { id: \"2036\", source: \"Susano\" }\r\n604.0 \"Churn\" Ability { id: \"203E\", source: \"Susano\" }\r\n611.2 \"Yata-No-Kagami\" Ability { id: \"202F\", source: \"Susano\" }\r\n615.5 \"Seasplitter\" Ability { id: \"25BD\", source: \"Susano\" }\r\n617.3 \"Brightstorm\" Ability { id: \"2030\", source: \"Susano\" }\r\n622.4 \"Rasen Kaikyo\" Ability { id: \"202D\", source: \"Susano\" }\r\n\r\n632.7 \"Stormsplitter\" Ability { id: \"2033\", source: \"Susano\" }\r\n642.9 \"Levinbolt Stun 1\" Ability { id: \"203C\", source: \"Susano\" }\r\n649.3 \"Levinbolt Stun 2\" Ability { id: \"203C\", source: \"Susano\" }\r\n655.9 \"Levinbolt Stun 3\" Ability { id: \"203C\", source: \"Susano\" }\r\n662.4 \"Levinbolt Stun 4\" Ability { id: \"203C\", source: \"Susano\" }\r\n669.8 \"Ukehi x3\" Ability { id: \"2036\", source: \"Susano\" }\r\n676.1 \"Churn\" Ability { id: \"203E\", source: \"Susano\" }\r\n684.1 \"Rasen Kaikyo 1\" Ability { id: \"202D\", source: \"Susano\" }\r\n689.3 \"Rasen Kaikyo 2\" Ability { id: \"202D\", source: \"Susano\" }\r\n\r\n701.6 \"Stormsplitter\" Ability { id: \"2033\", source: \"Susano\" }\r\n706.7 \"Yasakani-No-Magatama\" Ability { id: \"2040\", source: \"Susano\" }\r\n708.3 \"Levinbolt 1\" Ability { id: \"203C\", source: \"Susano\" }\r\n713.8 \"Levinbolt 2\" Ability { id: \"203C\", source: \"Susano\" }\r\n713.8 \"Rasen Kaikyo\" Ability { id: \"202D\", source: \"Susano\" }\r\n717.4 \"The Parting Clouds\" Ability { id: \"2041\", source: \"Thunderhead\" }\r\n719.2 \"Levinbolt 3\" Ability { id: \"203C\", source: \"Susano\" }\r\n723.9 \"Rasen Kaikyo\" Ability { id: \"202D\", source: \"Susano\" }\r\n724.7 \"Levinbolt 4\" Ability { id: \"203C\", source: \"Susano\" }\r\n728.1 \"Yasakani-No-Magatama\" Ability { id: \"2040\", source: \"Susano\" }\r\n735.3 \"--knockback cloud--\"\r\n735.3 \"Yata-No-Kagami\" Ability { id: \"202F\", source: \"Susano\" }\r\n739.6 \"Seasplitter\" Ability { id: \"25BD\", source: \"Susano\" }\r\n739.7 \"The Parting Clouds\" Ability { id: \"2041\", source: \"Thunderhead\" }\r\n741.4 \"Brightstorm\" Ability { id: \"2030\", source: \"Susano\" }\r\n748.5 \"Ukehi x3\" Ability { id: \"2036\", source: \"Susano\" }\r\n\r\n760.0 \"The Hidden Gate\" Ability { id: \"2034\", source: \"Susano\" }\r\n776.0 \"Stormsplitter\" Ability { id: \"2033\", source: \"Susano\" }\r\n781.1 \"Yasakani-No-Magatama\" Ability { id: \"2040\", source: \"Susano\" }\r\n782.7 \"Levinbolt 1\" Ability { id: \"203C\", source: \"Susano\" }\r\n785.6 \"The Sealed Gate\" Ability { id: \"2035\", source: \"Ama-No-Iwato\" }\r\n788.2 \"Levinbolt 2\" Ability { id: \"203C\", source: \"Susano\" }\r\n791.9 \"The Parting Clouds\" Ability { id: \"2041\", source: \"Thunderhead\" }\r\n793.7 \"Levinbolt 3\" Ability { id: \"203C\", source: \"Susano\" }\r\n797.3 \"Seasplitter\" Ability { id: \"25BD\", source: \"Susano\" }\r\n799.2 \"Levinbolt 4\" Ability { id: \"203C\", source: \"Susano\" }\r\n807.3 \"Yasakani-No-Magatama\" Ability { id: \"2040\", source: \"Susano\" }\r\n812.4 \"Rasen Kaikyo\" Ability { id: \"202D\", source: \"Susano\" }\r\n814.8 \"Yata-No-Kagami\" Ability { id: \"202F\", source: \"Susano\" }\r\n819.1 \"Seasplitter\" Ability { id: \"25BD\", source: \"Susano\" }\r\n819.2 \"The Parting Clouds\" Ability { id: \"2041\", source: \"Thunderhead\" }\r\n820.9 \"Brightstorm\" Ability { id: \"2030\", source: \"Susano\" }\r\n826.0 \"Rasen Kaikyo\" Ability { id: \"202D\", source: \"Susano\" }\r\n832.1 \"Ukehi x3\" Ability { id: \"2036\", source: \"Susano\" }\r\n\r\n843.6 \"The Hidden Gate\" Ability { id: \"2034\", source: \"Susano\" } window 40,40 jump 531.5\r\n859.3 \"Rasen Kaikyo\" #Ability { id: \"202D\", source: \"Susano\" }\r\n866.6 \"Stormsplitter\" #Ability { id: \"2033\", source: \"Susano\" }\r\n869.2 \"The Sealed Gate\" #Ability { id: \"2035\", source: \"Ama-No-Iwato\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/susano.ts



// Susano Normal
const susano_triggerSet = {
  id: 'ThePoolOfTribute',
  zoneId: zone_id/* default.ThePoolOfTribute */.Z.ThePoolOfTribute,
  timelineFile: 'susano.txt',
  timelineTriggers: [{
    id: 'Susano Assail',
    regex: /Assail/,
    beforeSeconds: 6,
    response: responses/* Responses.miniBuster */.n3.miniBuster()
  }],
  triggers: [{
    id: 'Susano Brightstorm',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Susano Seasplitter',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback on YOU',
        de: 'Rückstoß auf DIR',
        fr: 'Poussée sur VOUS',
        cn: '击退点名',
        ko: '넉백 대상자'
      }
    }
  }, {
    id: 'Susano Ukehi',
    type: 'StartsUsing',
    netRegex: {
      source: 'Susano',
      id: '2026',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Susano Stormsplitter',
    type: 'StartsUsing',
    netRegex: {
      source: 'Susano',
      id: '2023'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave('alert')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Ama-No-Iwato': 'Ama no Iwato',
      'Dark Cloud': 'dunkl(?:e|er|es|en) Wolke',
      'Susano': 'Susano'
    },
    'replaceText': {
      'Ame-No-Murakumo': 'Ame no Murakumo',
      'Assail': 'Anstürmen',
      'Brightstorm': 'Heller Sturm',
      'Dark Levin': 'violett(?:e|er|es|en) Blitz',
      'Rasen Kaikyo': 'Rasen Kaikyo',
      'Seasplitter': 'Seespalter',
      'Stormsplitter': 'Sturmspalter',
      'The Hidden Gate': 'Verschwundenes Tor',
      'The Parting Clouds': 'Wolkenriss',
      'The Sealed Gate': 'Versiegeltes Tor',
      'Ukehi': 'Ukehi',
      'Yasakani-No-Magatama': 'Yasakani no Magatama',
      'Yata-No-Kagami': 'Yata no Kagami'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ama-No-Iwato': 'ama no iwato',
      'Dark Cloud': 'nuage sombre',
      'Susano': 'Susano'
    },
    'replaceText': {
      'Ame-No-Murakumo': 'Ame no Murakumo',
      'Assail': 'Ordre de couverture',
      'Brightstorm': 'Claire tempête',
      'Dark Levin': 'foudre violette',
      'Rasen Kaikyo': 'Rasen Kaikyo',
      'Seasplitter': 'Fendeur de mers',
      'Stormsplitter': 'Fendeur de tempêtes',
      'The Hidden Gate': 'Porte cachée',
      'The Parting Clouds': 'Dispersion de nuages',
      'The Sealed Gate': 'Porte scellée',
      'Ukehi': 'Ukehi',
      'Yasakani-No-Magatama': 'Yasakani no Magatama',
      'Yata-No-Kagami': 'Yata no Kagami'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ama-No-Iwato': '天岩戸',
      'Dark Cloud': '暗雲',
      'Susano': 'スサノオ'
    },
    'replaceText': {
      'Ame-No-Murakumo': 'アメノムラクモ',
      'Assail': '攻撃指示',
      'Brightstorm': '晴嵐',
      'Dark Levin': '紫電',
      'Rasen Kaikyo': '螺旋海峡',
      'Seasplitter': '海割り',
      'Stormsplitter': '海嵐斬',
      'The Hidden Gate': '岩戸隠れ',
      'The Parting Clouds': '雲間放電',
      'The Sealed Gate': '岩戸閉め',
      'Ukehi': '宇気比',
      'Yasakani-No-Magatama': 'ヤサカニノマガタマ',
      'Yata-No-Kagami': 'ヤタノカガミ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ama-No-Iwato': '天之岩户',
      'Dark Cloud': '暗云',
      'Susano': '须佐之男'
    },
    'replaceText': {
      'Ame-No-Murakumo': '天之丛云',
      'Assail': '强击',
      'Brightstorm': '晴岚',
      'Dark Levin': '紫电',
      'Rasen Kaikyo': '螺旋海峡',
      'Seasplitter': '断海',
      'Stormsplitter': '破浪斩',
      'The Hidden Gate': '岩户隐',
      'The Parting Clouds': '云间放电',
      'The Sealed Gate': '岩户闭合',
      'Ukehi': '祈请',
      'Yasakani-No-Magatama': '八尺琼勾玉',
      'Yata-No-Kagami': '八咫镜'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ama-No-Iwato': '신의 바위',
      'Dark Cloud': '암운',
      'Susano': '스사노오'
    },
    'replaceText': {
      'Ame-No-Murakumo': '아메노무라쿠모',
      'Assail': '공격 지시',
      'Brightstorm': '산바람',
      'Dark Levin': '번갯불',
      'Rasen Kaikyo': '나선 해협',
      'Seasplitter': '바다 가르기',
      'Stormsplitter': '해풍참',
      'The Hidden Gate': '바위 숨기기',
      'The Parting Clouds': '구름 방전',
      'The Sealed Gate': '바위 조이기',
      'Ukehi': '내기 선언',
      'Yasakani-No-Magatama': '야사카니의 곡옥',
      'Yata-No-Kagami': '야타의 거울'
    }
  }]
};
/* harmony default export */ const susano = (susano_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/susano.txt
const trial_susano_namespaceObject = "# Susano Normal\r\n# -p 201C:8.5\r\n# -ii 201E 2027 2028 2029 202A 202B 208D 2021\r\n# -it Susano\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Yata-No-Kagami\"\r\nhideall \"Yasakani-No-Magatama\"\r\n\r\n### Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n8.5 \"Assail\" Ability { id: \"201C\", source: \"Susano\" } window 10,0\r\n19.6 \"Rasen Kaikyo\" Ability { id: \"201D\", source: \"Susano\" }\r\n32.8 \"Yata-No-Kagami\" Ability { id: \"201F\", source: \"Susano\" }\r\n38.9 \"Brightstorm\" Ability { id: \"2020\", source: \"Susano\" }\r\n47.1 \"Assail\" Ability { id: \"201C\", source: \"Susano\" }\r\n54.3 \"Yasakani-No-Magatama\" Ability { id: \"25A1\", source: \"Susano\" }\r\n63.0 \"The Parting Clouds\" Ability { id: \"259F\", source: \"Dark Cloud\" }\r\n73.5 \"Yata-No-Kagami\" Ability { id: \"201F\", source: \"Susano\" }\r\n77.8 \"Seasplitter\" Ability { id: \"25BD\", source: \"Susano\" }\r\n82.6 \"Rasen Kaikyo\" Ability { id: \"201D\", source: \"Susano\" }\r\n89.8 \"Brightstorm\" Ability { id: \"2020\", source: \"Susano\" }\r\n98.9 \"Assail\" Ability { id: \"201C\", source: \"Susano\" }\r\n112.1 \"Yata-No-Kagami\" Ability { id: \"201F\", source: \"Susano\" }\r\n116.4 \"Seasplitter\" Ability { id: \"25BD\", source: \"Susano\" }\r\n118.2 \"Brightstorm\" Ability { id: \"2020\", source: \"Susano\" }\r\n125.4 \"Yasakani-No-Magatama\" Ability { id: \"25A1\", source: \"Susano\" }\r\n134.1 \"The Parting Clouds\" Ability { id: \"259F\", source: \"Dark Cloud\" }\r\n138.5 \"The Parting Clouds\" Ability { id: \"259F\", source: \"Dark Cloud\" }\r\n142.9 \"The Parting Clouds\" Ability { id: \"259F\", source: \"Dark Cloud\" }\r\n147.5 \"Assail\" Ability { id: \"201C\", source: \"Susano\" }\r\n160.7 \"Yata-No-Kagami\" Ability { id: \"201F\", source: \"Susano\" }\r\n165.0 \"Seasplitter\" Ability { id: \"25BD\", source: \"Susano\" }\r\n166.8 \"Brightstorm\" Ability { id: \"2020\", source: \"Susano\" }\r\n174.6 \"--untargetable--\"\r\n\r\n### Phase 2 (hp push at ???% / time push)\r\n# sync to touching the Blade's Shadow, this happens twice\r\n300.0 \"--sync--\" Ability { id: \"21C6\", source: \"Susano\" } window 300,100\r\n305.2 \"--targetable--\"\r\n305.2 \"--Dark Levin--\"\r\n308.2 \"--Dark Levin--\"\r\n312.2 \"--Dark Levin--\"\r\n\r\n### Phase 3\r\n400.0 \"Ame-No-Murakumo\" Ability { id: \"2022\", source: \"Susano\" } window 400,0\r\n404.0 \"Ame-No-Murakumo\" Ability { id: \"218C\", source: \"Susano\" }\r\n413.6 \"--targetable--\"\r\n\r\n425.9 \"Stormsplitter\" Ability { id: \"2023\", source: \"Susano\" }\r\n431.1 \"The Hidden Gate\" Ability { id: \"2024\", source: \"Susano\" }\r\n456.6 \"The Sealed Gate\" Ability { id: \"2025\", source: \"Ama-No-Iwato\" }\r\n458.7 \"Rasen Kaikyo\" Ability { id: \"201D\", source: \"Susano\" }\r\n466.8 \"Ukehi\" Ability { id: \"2026\", source: \"Susano\" }\r\n\r\n478.1 \"Stormsplitter\" Ability { id: \"2023\", source: \"Susano\" }\r\n488.3 \"Yata-No-Kagami\" Ability { id: \"201F\", source: \"Susano\" }\r\n492.6 \"Seasplitter\" Ability { id: \"25BD\", source: \"Susano\" }\r\n494.4 \"Brightstorm\" Ability { id: \"2020\", source: \"Susano\" }\r\n499.5 \"Rasen Kaikyo\" Ability { id: \"201D\", source: \"Susano\" }\r\n507.6 \"Ukehi\" Ability { id: \"2026\", source: \"Susano\" }\r\n514.9 \"Yasakani-No-Magatama\" Ability { id: \"25A1\", source: \"Susano\" }\r\n523.6 \"The Parting Clouds\" Ability { id: \"259F\", source: \"Dark Cloud\" }\r\n528.0 \"The Parting Clouds\" Ability { id: \"259F\", source: \"Dark Cloud\" }\r\n532.4 \"The Parting Clouds\" Ability { id: \"259F\", source: \"Dark Cloud\" }\r\n540.1 \"Stormsplitter\" Ability { id: \"2023\", source: \"Susano\" }\r\n548.3 \"Rasen Kaikyo\" Ability { id: \"201D\", source: \"Susano\" }\r\n552.4 \"Brightstorm\" Ability { id: \"2020\", source: \"Susano\" }\r\n554.5 \"The Hidden Gate\" Ability { id: \"2024\", source: \"Susano\" }\r\n573.1 \"Ukehi\" Ability { id: \"2026\", source: \"Susano\" }\r\n580.0 \"The Sealed Gate\" Ability { id: \"2025\", source: \"Ama-No-Iwato\" }\r\n588.4 \"Stormsplitter\" Ability { id: \"2023\", source: \"Susano\" }\r\n593.5 \"Rasen Kaikyo\" Ability { id: \"201D\", source: \"Susano\" }\r\n595.8 \"Yata-No-Kagami\" Ability { id: \"201F\", source: \"Susano\" }\r\n600.1 \"Seasplitter\" Ability { id: \"25BD\", source: \"Susano\" }\r\n601.9 \"Brightstorm\" Ability { id: \"2020\", source: \"Susano\" }\r\n605.1 \"Yasakani-No-Magatama\" Ability { id: \"25A1\", source: \"Susano\" }\r\n613.8 \"The Parting Clouds\" Ability { id: \"259F\", source: \"Dark Cloud\" }\r\n618.2 \"The Parting Clouds\" Ability { id: \"259F\", source: \"Dark Cloud\" }\r\n622.6 \"The Parting Clouds\" Ability { id: \"259F\", source: \"Dark Cloud\" }\r\n624.2 \"Rasen Kaikyo\" Ability { id: \"201D\", source: \"Susano\" }\r\n633.3 \"Ukehi\" Ability { id: \"2026\", source: \"Susano\" }\r\n\r\n646.6 \"Stormsplitter\" Ability { id: \"2023\", source: \"Susano\" } window 40,100 jump 478.1\r\n656.8 \"Yata-No-Kagami\" #Ability { id: \"201F\", source: \"Susano\" }\r\n661.1 \"Seasplitter\" #Ability { id: \"25BD\", source: \"Susano\" }\r\n662.9 \"Brightstorm\" #Ability { id: \"2020\", source: \"Susano\" }\r\n668.0 \"Rasen Kaikyo\" #Ability { id: \"201D\", source: \"Susano\" }\r\n676.1 \"Ukehi\" #Ability { id: \"2026\", source: \"Susano\" }\r\n683.4 \"Yasakani-No-Magatama\" #Ability { id: \"25A1\", source: \"Susano\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/suzaku-ex.ts



// Suzaku Extreme
const suzaku_ex_triggerSet = {
  id: 'HellsKierExtreme',
  zoneId: zone_id/* default.HellsKierExtreme */.Z.HellsKierExtreme,
  timelineFile: 'suzaku-ex.txt',
  triggers: [{
    id: 'SuzEx Cremate',
    type: 'StartsUsing',
    netRegex: {
      id: '32D1',
      source: 'Suzaku'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'SuzEx Phantom Flurry',
    type: 'StartsUsing',
    netRegex: {
      id: '32DC',
      source: 'Suzaku',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.tankBuster */.Z.tankBuster
    }
  }, {
    id: 'SuzEx Mesmerizing Melody',
    type: 'StartsUsing',
    netRegex: {
      id: '32DA',
      source: 'Suzaku',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Out',
        de: 'Raus da',
        fr: 'Allez au bord extérieur',
        ja: '誘引',
        cn: '远离',
        ko: '밖으로'
      }
    }
  }, {
    id: 'SuzEx Ruthless Refrain',
    type: 'StartsUsing',
    netRegex: {
      id: '32DB',
      source: 'Suzaku',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get In',
        de: 'Rein da',
        fr: 'Allez au bord intérieur',
        ja: '拒絶',
        cn: '靠近',
        ko: '안으로'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Tenzen': 'Tenzen',
      'Scarlet Tail Feather': 'Schwanzfeder',
      'Suzaku': 'Suzaku'
    },
    'replaceText': {
      'Close-Quarter Crescendo': 'Puppencrescendo',
      'Cremate': 'Einäschern',
      'Eternal Flame': 'Ewige Flamme',
      'Fleeting Summer': 'Vergänglicher Sommer',
      'Hotspot': 'Hitzestau',
      'Incandescent Interlude': 'Glühendes Intermezzo',
      'Mesmerizing Melody': 'Bezaubernde Melodie',
      'Pay The Piper': 'Lied des Fängers',
      'Phantom Flurry': 'Phantomhast',
      'Phantom Half': 'Phantom Hälfte',
      'Phoenix Down': 'Phönixsturz',
      'Rekindle': 'Wiederaufleben',
      'Rout': 'Kolossgalopp',
      'Ruthless Refrain': 'Rabiater Refrain',
      'Ruthless/Mesmerizing': 'Refrain/Melodie',
      'Scarlet Fever': 'Feuertod',
      'Scarlet Hymn': 'Zinnoberhymne',
      'Scathing Net': 'Vernichtendes Netz',
      'Screams Of The Damned': 'Schreie der Verdammten',
      'Southron Star': 'Stern des Südens',
      'Well Of Flame': 'Flammenbrunnen',
      'Wing And A Prayer': 'Letztes Gebet'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Tenzen': 'Tenzen',
      'Scarlet Tail Feather': 'plume de queue de Suzaku',
      'Suzaku': 'Suzaku'
    },
    'replaceText': {
      'Close-Quarter Crescendo': 'Mélopée fantoche',
      'Cremate': 'Crématorium',
      'Eternal Flame': 'Flamme éternelle',
      'Fleeting Summer': 'Ailes vermillon',
      'Hotspot': 'Couleurs',
      'Incandescent Interlude': 'Mélopée incandescente',
      'Mesmerizing Melody': 'Mélodie hypnotique',
      'Pay The Piper': 'Poème fantoche',
      'Phantom Flurry': 'Frénésie spectrale',
      'Phantom Half': 'Frénésie - Moitié de plateau',
      'Phoenix Down': 'Queue de phénix',
      'Rekindle': 'Ravivement',
      'Rout': 'Irruption',
      'Ruthless/Mesmerizing': 'Refrain/Mélodie',
      'Ruthless Refrain': 'Refrain impitoyable',
      'Scarlet Fever': 'Fièvre écarlate',
      'Scarlet Hymn': 'Hymne vermillon',
      'Scathing Net': 'Étoiles des enfers',
      'Screams Of The Damned': 'Cris des damnés',
      'Southron Star': 'Étoile australe',
      'Well Of Flame': 'Puits ardent',
      'Wing And A Prayer': 'Prière de pennes'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Tenzen': 'テンゼン',
      'Scarlet Tail Feather': '朱雀の尾羽根',
      'Suzaku': '朱雀'
    },
    'replaceText': {
      'Close-Quarter Crescendo': '傀儡の調べ',
      'Cremate': '赤熱撃',
      'Eternal Flame': '再生の大火',
      'Fleeting Summer': '翼宿撃',
      'Hotspot': '紅蓮炎',
      'Incandescent Interlude': '灼熱の調べ',
      'Mesmerizing Melody': '誘引の旋律',
      'Pay The Piper': '傀儡詩',
      'Phantom Flurry': '鬼宿脚',
      'Phantom Half': '鬼宿脚 (フィールド半分)',
      'Phoenix Down': '再生の羽根',
      'Rekindle': '再生の炎',
      'Rout': '猛進',
      'Ruthless Refrain': '拒絶の旋律',
      'Ruthless/Mesmerizing': '拒絶/誘引',
      'Scarlet Fever': '焼滅天火',
      'Scarlet Hymn': '朱の旋律',
      'Scathing Net': '張宿業火',
      'Screams Of The Damned': '叫喚地獄',
      'Southron Star': '星宿波',
      'Well Of Flame': '井宿焔',
      'Wing And A Prayer': '再生の神通力'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Tenzen': '典膳',
      'Scarlet Tail Feather': '朱雀的尾羽',
      'Suzaku': '朱雀'
    },
    'replaceText': {
      'Close-Quarter Crescendo': '傀儡旋律',
      'Cremate': '赤热击',
      'Eternal Flame': '苏生大火',
      'Fleeting Summer': '翼宿击',
      'Hotspot': '红莲炎',
      'Incandescent Interlude': '灼热旋律',
      'Mesmerizing Melody': '引诱旋律',
      'Pay The Piper': '傀儡诗',
      'Phantom Flurry': '鬼宿脚',
      'Phantom Half': '半场AOE',
      'Phoenix Down': '苏生之羽',
      'Rekindle': '苏生之炎',
      'Rout': '猛进',
      'Ruthless Refrain': '拒绝旋律',
      'Ruthless/Mesmerizing': '拒绝/引诱',
      'Scarlet Fever': '灭尽天火',
      'Scarlet Hymn': '朱红旋律',
      'Scathing Net': '张宿业火',
      'Screams Of The Damned': '叫唤地狱',
      'Southron Star': '星宿波',
      'Well Of Flame': '井宿焰',
      'Wing And A Prayer': '苏生神通力'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Tenzen': '텐젠',
      'Scarlet Tail Feather': '주작의 꽁지깃',
      'Suzaku': '주작'
    },
    'replaceText': {
      'Close-Quarter Crescendo': '꼭두각시의 음률',
      'Cremate': '적열격',
      'Eternal Flame': '재생의 불길',
      'Fleeting Summer': '익수격',
      'Hotspot': '홍련염',
      'Incandescent Interlude': '작열의 음률',
      'Mesmerizing Melody': '유인의 선율',
      'Pay The Piper': '꼭두각시의 노래',
      'Phantom Flurry': '귀수각',
      'Phantom Half': '전방 피하기',
      'Phoenix Down': '재생의 깃털',
      'Rekindle': '재생의 불꽃',
      'Rout': '맹진',
      'Ruthless Refrain': '거절의 선율',
      'Ruthless/Mesmerizing': '거절/유인의 선율',
      'Scarlet Fever': '소멸천화',
      'Scarlet Hymn': '붉은 선율',
      'Scathing Net': '장수업화',
      'Screams Of The Damned': '규환지옥',
      'Southron Star': '성수파',
      'Well Of Flame': '정수염',
      'Wing And A Prayer': '재생의 신통력'
    }
  }]
};
/* harmony default export */ const suzaku_ex = (suzaku_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/suzaku-ex.txt
const trial_suzaku_ex_namespaceObject = "# Suzaku Extreme\r\n# -ii 32DC 32E5\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11.5 \"Screams Of The Damned\" Ability { id: \"32D2\", source: \"Suzaku\" } window 12,20\r\n18.9 \"--untargetable--\"\r\n24.5 \"Rout\" Ability { id: \"32F0\", source: \"Suzaku\" }\r\n26.2 \"Rekindle\" Ability { id: \"32E0\", source: \"Suzaku\" }\r\n29.0 \"--targetable--\"\r\n35.3 \"Fleeting Summer\" Ability { id: \"32D3\", source: \"Suzaku\" }\r\n42.8 \"Cremate\" Ability { id: \"32D1\", source: \"Suzaku\" }\r\n54.3 \"Phoenix Down\" Ability { id: \"3224\", source: \"Suzaku\" }\r\n67.4 \"Rekindle\" Ability { id: \"32E0\", source: \"Suzaku\" }\r\n78.5 \"Cremate\" Ability { id: \"32D1\", source: \"Suzaku\" }\r\n79.6 \"Wing And A Prayer\" Ability { id: \"32D4\", source: \"Scarlet Tail Feather\" }\r\n92.2 \"Screams Of The Damned\" Ability { id: \"32D2\", source: \"Suzaku\" }\r\n109.2 \"Eternal Flame\" Ability { id: \"3222\", source: \"Suzaku\" } # drift 0.023\r\n111.3 \"--untargetable--\"\r\n\r\n# DDR phase\r\n126.5 \"--sync--\" Ability { id: \"3226\", source: \"Suzaku\" }\r\n132.7 \"--sync--\" Ability { id: \"3485\", source: \"Suzaku\" }\r\n137.8 \"Scarlet Hymn\"\r\n138.9 \"Scarlet Hymn\"\r\n140.0 \"Scarlet Hymn\"\r\n144.6 \"--sync--\" Ability { id: \"3486\", source: \"Suzaku\" }\r\n147.7 \"Scarlet Hymn\"\r\n149.8 \"Scarlet Hymn\"\r\n150.9 \"Scarlet Hymn\"\r\n152.0 \"Scarlet Hymn\"\r\n154.2 \"Scarlet Hymn\"\r\n156.3 \"Scarlet Hymn\"\r\n157.5 \"Scarlet Hymn\"\r\n174.7 \"Scarlet Fever\" Ability { id: \"32D9\", source: \"Suzaku\" } window 165,20\r\n\r\n# Main phase\r\n179.9 \"--targetable--\"\r\n189.4 \"Southron Star\" Ability { id: \"32DF\", source: \"Suzaku\" } window 20,20\r\n195.0 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n200.1 \"Mesmerizing Melody\" Ability { id: \"32DA\", source: \"Suzaku\" }\r\n208.1 \"Well Of Flame\" Ability { id: \"32E1\", source: \"Suzaku\" }\r\n208.8 \"Rekindle\" Ability { id: \"32E0\", source: \"Suzaku\" }\r\n215.2 \"Scathing Net\" Ability { id: \"3243\", source: \"Suzaku\" }\r\n220.2 \"Phantom Flurry\" Ability { id: \"32DD\", source: \"Suzaku\" } # drift 0.035\r\n226.3 \"Phantom Half\" Ability { id: \"32DE\", source: \"Suzaku\" }\r\n\r\n# Simon says 1 (8+8)\r\n231.0 \"Scarlet Hymn\" Ability { id: \"3237\", source: \"Suzaku\" }\r\n252.1 \"Hotspot x8\" duration 7.7\r\n269.9 \"Hotspot x8\" duration 7.7\r\n\r\n# Back to center\r\n286.7 \"--sync--\" Ability { id: \"323A\", source: \"Suzaku\" } window 20,20\r\n288.8 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n294.2 \"Ruthless/Mesmerizing\" Ability { id: \"32D(A|B)\", source: \"Suzaku\" }\r\n305.3 \"Close-Quarter Crescendo\" Ability { id: \"32E4\", source: \"Suzaku\" }\r\n317.4 \"Pay The Piper\"\r\n321.1 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n327.0 \"Well Of Flame\" Ability { id: \"32E1\", source: \"Suzaku\" }\r\n327.6 \"Rekindle\" Ability { id: \"32E0\", source: \"Suzaku\" }\r\n334.1 \"Scathing Net\" Ability { id: \"3243\", source: \"Suzaku\" }\r\n338.2 \"Phantom Flurry\" Ability { id: \"32DD\", source: \"Suzaku\" }\r\n344.4 \"Phantom Half\" Ability { id: \"32DE\", source: \"Suzaku\" }\r\n\r\n# Simon Says 2 (8+8 with aoe)\r\n350.7 \"Scarlet Hymn\" Ability { id: \"3237\", source: \"Suzaku\" }\r\n360.2 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n365.3 \"Ruthless/Mesmerizing\" Ability { id: \"32D(A|B)\", source: \"Suzaku\" }\r\n370.4 \"Hotspot x8\" duration 7.7\r\n385.9 \"Southron Star\" Ability { id: \"32DF\", source: \"Suzaku\" }\r\n391.0 \"Hotspot x8\" duration 7.7\r\n\r\n# Back to center\r\n407.5 \"--sync--\" Ability { id: \"323A\", source: \"Suzaku\" }\r\n413.6 \"Phantom Flurry\" Ability { id: \"32DD\", source: \"Suzaku\" }\r\n419.7 \"Phantom Half\" Ability { id: \"32DE\", source: \"Suzaku\" }\r\n430.4 \"Southron Star\" Ability { id: \"32DF\", source: \"Suzaku\" }\r\n442.0 \"Incandescent Interlude\" Ability { id: \"323C\", source: \"Suzaku\" }\r\n446.1 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n452.1 \"Ruthless Refrain\" Ability { id: \"32DB\", source: \"Suzaku\" }\r\n454.6 \"Rekindle\" Ability { id: \"32E0\", source: \"Suzaku\" }\r\n459.5 \"Well Of Flame\" Ability { id: \"32E1\", source: \"Suzaku\" }\r\n\r\n# Simon Says 2 (4+4+4+4 with forced march, knock/draw, phantom half)\r\n466.7 \"Scarlet Hymn\" Ability { id: \"3237\", source: \"Suzaku\" }\r\n483.6 \"Well Of Flame\" Ability { id: \"32E1\", source: \"Suzaku\" }\r\n484.3 \"Rekindle\" Ability { id: \"32E0\", source: \"Suzaku\" }\r\n489.4 \"Hotspot x4\" duration 3.3\r\n496.6 \"Close-Quarter Crescendo\" Ability { id: \"32E4\", source: \"Suzaku\" }\r\n508.7 \"Pay the Piper\"\r\n508.8 \"Hotspot x4\" duration 3.3\r\n517.9 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n523.4 \"Ruthless/Mesmerizing\" Ability { id: \"32D(A|B)\", source: \"Suzaku\" }\r\n528.5 \"Hotspot x4\" duration 3.3\r\n539.6 \"Phantom Flurry\" Ability { id: \"32DD\", source: \"Suzaku\" }\r\n545.8 \"Phantom Half\" Ability { id: \"32DE\", source: \"Suzaku\" }\r\n547.9 \"Hotspot x4\" duration 3.3\r\n\r\n# Back to center\r\n562.4 \"--sync--\" Ability { id: \"323A\", source: \"Suzaku\" }\r\n572.5 \"Southron Star\" Ability { id: \"32DF\", source: \"Suzaku\" }\r\n580.0 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n585.5 \"Ruthless/Mesmerizing\" Ability { id: \"32D(A|B)\", source: \"Suzaku\" }\r\n597.9 \"Well Of Flame\" Ability { id: \"32E1\", source: \"Suzaku\" }\r\n598.5 \"Rekindle\" Ability { id: \"32E0\", source: \"Suzaku\" }\r\n605.1 \"Scathing Net\" Ability { id: \"3243\", source: \"Suzaku\" }\r\n610.2 \"Phantom Flurry\" Ability { id: \"32DD\", source: \"Suzaku\" }\r\n616.4 \"Phantom Half\" Ability { id: \"32DE\", source: \"Suzaku\" }\r\n626.5 \"Southron Star\" Ability { id: \"32DF\", source: \"Suzaku\" }\r\n633.6 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n639.0 \"Ruthless/Mesmerizing\" Ability { id: \"32D(A|B)\", source: \"Suzaku\" }\r\n652.0 \"Southron Star\" Ability { id: \"32DF\", source: \"Suzaku\" }\r\n658.4 \"Phantom Flurry\" Ability { id: \"32DD\", source: \"Suzaku\" }\r\n664.5 \"Phantom Half\" Ability { id: \"32DE\", source: \"Suzaku\" }\r\n674.1 \"Scarlet Hymn\" Ability { id: \"3237\", source: \"Suzaku\" }\r\n683.6 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n689.0 \"Ruthless/Mesmerizing\" Ability { id: \"32D(A|B)\", source: \"Suzaku\" }\r\n695.0 \"Hotspot x8\" duration 7.7\r\n708.8 \"Southron Star\" Ability { id: \"32DF\", source: \"Suzaku\" } # drift -0.047\r\n714.2 \"Hotspot x8\" duration 7.7\r\n730.1 \"--sync--\" Ability { id: \"323A\", source: \"Suzaku\" }\r\n736.1 \"Phantom Flurry\" Ability { id: \"32DD\", source: \"Suzaku\" }\r\n742.2 \"Phantom Half\" Ability { id: \"32DE\", source: \"Suzaku\" }\r\n743.8 \"Scarlet Hymn\" Ability { id: \"3237\", source: \"Suzaku\" }\r\n755.3 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n766.7 \"Hotspot Enrage\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/suzaku.ts



// Suzaku Normal
const suzaku_triggerSet = {
  id: 'HellsKier',
  zoneId: zone_id/* default.HellsKier */.Z.HellsKier,
  timelineFile: 'suzaku.txt',
  triggers: [{
    id: 'Suzaku Cremate',
    type: 'StartsUsing',
    netRegex: {
      id: '3220',
      source: 'Suzaku'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Suzaku Screams Of The Damned',
    type: 'StartsUsing',
    netRegex: {
      id: '3221',
      source: 'Suzaku',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Suzaku Primary Target',
    type: 'GainsEffect',
    netRegex: {
      effectId: '699'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Lady tether on YOU',
        de: 'Verbindung auf DIR',
        fr: 'Lien sur VOUS',
        ja: '線ついた',
        cn: '连线点名',
        ko: '화염조 대상자'
      }
    }
  }, {
    id: 'Suzaku Southron Star',
    type: 'StartsUsing',
    netRegex: {
      id: '3234',
      source: 'Suzaku',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Suzaku Phantom Flurry',
    type: 'StartsUsing',
    netRegex: {
      id: '3231',
      source: 'Suzaku'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Suzaku Rekindle',
    type: 'HeadMarker',
    netRegex: {
      id: '3230'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Suzaku Ruthless Refrain',
    type: 'StartsUsing',
    netRegex: {
      id: '3230',
      source: 'Suzaku',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Rapturous Echo': 'Klang[p] der Liebe',
      'Scarlet Plume': 'Flügelfeder',
      'Scarlet Tail Feather': 'Schwanzfeder',
      'Suzaku': 'Suzaku',
      'Tenzen': 'Tenzen'
    },
    'replaceText': {
      'Ashes To Ashes': 'Asche zu Asche',
      'Burn': 'Verbrennung',
      'Cremate': 'Einäschern',
      'Eternal Flame': 'Ewige Flamme',
      'Fleeting Summer': 'Vergänglicher Sommer',
      'Hotspot': 'Hitzestau',
      'Immolate': 'Opferung',
      'Incandescent Interlude': 'Glühendes Intermezzo',
      'Phantom Flurry': 'Phantomhast',
      'Phantom Half': 'Phantom Hälfte',
      'Phoenix Down': 'Phönixsturz',
      'Rekindle': 'Wiederaufleben',
      'Ruthless Refrain': 'Rabiater Refrain',
      'Scarlet Fever': 'Feuertod',
      'Scarlet Hymn': 'Zinnoberhymne',
      'Screams Of The Damned': 'Schreie der Verdammten',
      'Southron Star': 'Stern des Südens',
      'Swoop': 'Sturzflug',
      'Well Of Flame': 'Flammenbrunnen',
      'Wing And A Prayer': 'Letztes Gebet'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Rapturous Echo': 'chant d\'amour',
      'Scarlet Plume': 'plume de Suzaku',
      'Scarlet Tail Feather': 'plume de queue de Suzaku',
      'Suzaku': 'Suzaku',
      'Tenzen': 'Tenzen'
    },
    'replaceText': {
      '\\?': ' ?',
      'Ashes To Ashes': 'Cendres du phénix',
      'Burn': 'Combustion',
      'Cremate': 'Crématorium',
      'Eternal Flame': 'Flamme éternelle',
      'Fleeting Summer': 'Ailes vermillon',
      'Hotspot': 'Couleurs',
      'Immolate': 'Immolation',
      'Incandescent Interlude': 'Mélopée incandescente',
      'Phantom Flurry': 'Frénésie spectrale',
      'Phantom Half': 'Frénésie - Moitié de plateau',
      'Phoenix Down': 'Queue de phénix',
      'Rekindle': 'Ravivement',
      'Ruthless Refrain': 'Refrain impitoyable',
      'Scarlet Fever': 'Fièvre écarlate',
      'Scarlet Hymn': 'Hymne vermillon',
      'Screams Of The Damned': 'Cris des damnés',
      'Southron Star': 'Étoile australe',
      'Swoop': 'Ruée embrasée',
      'Well Of Flame': 'Puits ardent',
      'Wing And A Prayer': 'Prière de pennes'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Rapturous Echo': '愛の音色',
      'Scarlet Plume': '朱雀の羽根',
      'Scarlet Tail Feather': '朱雀の尾羽根',
      'Suzaku': '朱雀',
      'Tenzen': 'テンゼン'
    },
    'replaceText': {
      'Ashes To Ashes': '昇天',
      'Burn': '燃焼',
      'Cremate': '赤熱撃',
      'Eternal Flame': '再生の大火',
      'Fleeting Summer': '翼宿撃',
      'Hotspot': '紅蓮炎',
      'Immolate': '大燃焼',
      'Incandescent Interlude': '灼熱の調べ',
      'Phantom Flurry': '鬼宿脚',
      'Phantom Half': '鬼宿脚 (フィールド半分)',
      'Phoenix Down': '再生の羽根',
      'Rekindle': '再生の炎',
      'Ruthless Refrain': '拒絶の旋律',
      'Scarlet Fever': '焼滅天火',
      'Scarlet Hymn': '朱の旋律',
      'Screams Of The Damned': '叫喚地獄',
      'Southron Star': '星宿波',
      'Swoop': '突撃',
      'Well Of Flame': '井宿焔',
      'Wing And A Prayer': '再生の神通力'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Rapturous Echo': '爱之音',
      'Scarlet Plume': '朱雀的羽毛',
      'Scarlet Tail Feather': '朱雀的尾羽',
      'Suzaku': '朱雀',
      'Tenzen': '典膳'
    },
    'replaceText': {
      'Ashes To Ashes': '升天',
      'Burn': '燃烧',
      'Cremate': '赤热击',
      'Eternal Flame': '苏生大火',
      'Fleeting Summer': '翼宿击',
      'Hotspot': '红莲炎',
      'Immolate': '大燃烧',
      'Incandescent Interlude': '灼热旋律',
      'Phantom Flurry': '鬼宿脚',
      'Phantom Half': '半场AOE',
      'Phoenix Down': '苏生之羽',
      'Rekindle': '苏生之炎',
      'Ruthless Refrain': '拒绝旋律',
      'Scarlet Fever': '灭尽天火',
      'Scarlet Hymn': '朱红旋律',
      'Screams Of The Damned': '叫唤地狱',
      'Southron Star': '星宿波',
      'Swoop': '突击',
      'Well Of Flame': '井宿焰',
      'Wing And A Prayer': '苏生神通力'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Rapturous Echo': '사랑의 음색',
      'Scarlet Plume': '주작의 깃털',
      'Scarlet Tail Feather': '주작의 꽁지깃',
      'Suzaku': '주작',
      'Tenzen': '텐젠'
    },
    'replaceText': {
      'Ashes To Ashes': '승천',
      'Burn': '연소',
      'Cremate': '적열격',
      'Eternal Flame': '재생의 불길',
      'Fleeting Summer': '익수격',
      'Hotspot': '홍련염',
      'Immolate': '대연소',
      'Incandescent Interlude': '작열의 음률',
      'Phantom Flurry': '귀수각',
      'Phantom Half': '전방 피하기',
      'Phoenix Down': '재생의 깃털',
      'Rekindle': '재생의 불꽃',
      'Ruthless Refrain': '거절의 선율',
      'Scarlet Fever': '소멸천화',
      'Scarlet Hymn': '붉은 선율',
      'Screams Of The Damned': '규환지옥',
      'Southron Star': '성수파',
      'Swoop': '돌격',
      'Well Of Flame': '정수염',
      'Wing And A Prayer': '재생의 신통력'
    }
  }]
};
/* harmony default export */ const suzaku = (suzaku_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/suzaku.txt
const trial_suzaku_namespaceObject = "# Suzaku Normal\r\n# -ii 3232 323D\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n9.1 \"Cremate\" Ability { id: \"3220\", source: \"Suzaku\" } window 9.1,5\r\n18.7 \"Eternal Flame\" Ability { id: \"3222\", source: \"Suzaku\" }\r\n29.9 \"Fleeting Summer\" Ability { id: \"3223\", source: \"Suzaku\" }\r\n40.0 \"Ashes To Ashes?\" # Ability { id: \"321F\", source: \"Scarlet Lady\" }\r\n42.5 \"Screams Of The Damned\" Ability { id: \"3221\", source: \"Suzaku\" }\r\n50.6 \"Phoenix Down\" Ability { id: \"3224\", source: \"Suzaku\" }\r\n62.1 \"Cremate\" Ability { id: \"3220\", source: \"Suzaku\" }\r\n71.2 \"Wing And A Prayer\" Ability { id: \"3225\", source: \"Scarlet Plume\" }\r\n71.6 \"Screams Of The Damned\" Ability { id: \"3221\", source: \"Suzaku\" }\r\n85.1 \"Fleeting Summer\" Ability { id: \"3223\", source: \"Suzaku\" }\r\n93.7 \"Ashes To Ashes?\" # Ability { id: \"321F\", source: \"Scarlet Lady\" }\r\n100.0 \"Eternal Flame\" Ability { id: \"3222\", source: \"Suzaku\" }\r\n102.0 \"--untargetable--\"\r\n\r\n117.3 \"--sync--\" Ability { id: \"3226\", source: \"Suzaku\" } window 117.3,0\r\n132.4 \"--sync--\" Ability { id: \"3485\", source: \"Suzaku\" }\r\n133.9 \"Scarlet Hymn 1\" Ability { id: \"3228\", source: \"Rapturous Echo\" }\r\n144.0 \"Scarlet Hymn 2\" Ability { id: \"3228\", source: \"Rapturous Echo\" }\r\n153.2 \"--sync--\" Ability { id: \"3486\", source: \"Suzaku\" }\r\n153.5 \"Scarlet Hymn 3\" Ability { id: \"3228\", source: \"Rapturous Echo\" }\r\n156.5 \"Scarlet Hymn 4\" Ability { id: \"3228\", source: \"Rapturous Echo\" }\r\n165.6 \"Scarlet Hymn 5\" Ability { id: \"3228\", source: \"Rapturous Echo\" }\r\n167.6 \"Scarlet Hymn 6\" Ability { id: \"3228\", source: \"Rapturous Echo\" }\r\n169.6 \"Scarlet Hymn 7\" Ability { id: \"3228\", source: \"Rapturous Echo\" }\r\n182.8 \"Scarlet Fever\" Ability { id: \"322C\", source: \"Suzaku\" } window 182.8,0\r\n187.4 \"--targetable--\"\r\n\r\n197.6 \"Southron Star\" Ability { id: \"3234\", source: \"Suzaku\" }\r\n205.2 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n210.7 \"Ruthless Refrain\" Ability { id: \"3230\", source: \"Suzaku\" }\r\n222.9 \"Phantom Flurry\" Ability { id: \"3231\", source: \"Suzaku\" }\r\n229.0 \"Phantom Half\" Ability { id: \"3233\", source: \"Suzaku\" }\r\n239.7 \"Well Of Flame\" Ability { id: \"3236\", source: \"Suzaku\" }\r\n246.9 \"Scarlet Hymn\" Ability { id: \"3237\", source: \"Suzaku\" } window 246.9,0\r\n270.8 \"Hotspot 1\" Ability { id: \"3238\", source: \"Suzaku\" }\r\n286.0 \"Hotspot 2\" Ability { id: \"3238\", source: \"Suzaku\" }\r\n291.6 \"Well Of Flame\" Ability { id: \"3236\", source: \"Suzaku\" }\r\n302.3 \"Hotspot 3\" Ability { id: \"3238\", source: \"Suzaku\" }\r\n304.8 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n310.3 \"Ruthless Refrain\" Ability { id: \"3230\", source: \"Suzaku\" }\r\n318.6 \"Hotspot 4\" Ability { id: \"3238\", source: \"Suzaku\" }\r\n329.5 \"--sync--\" Ability { id: \"323A\", source: \"Suzaku\" }\r\n335.6 \"Southron Star\" Ability { id: \"3234\", source: \"Suzaku\" }\r\n\r\n346.2 \"Incandescent Interlude\" Ability { id: \"323C\", source: \"Suzaku\" } window 346.2,0\r\n355.6 \"Rekindle\" Ability { id: \"3235\", source: \"Suzaku\" }\r\n358.6 \"Immolate\" Ability { id: \"323E\", source: \"Suzaku\" }\r\n366.6 \"Phantom Flurry\" Ability { id: \"3231\", source: \"Suzaku\" }\r\n372.9 \"Phantom Half\" Ability { id: \"3233\", source: \"Suzaku\" }\r\n378.5 \"--sync--\" Ability { id: \"3239\", source: \"Suzaku\" }\r\n380.7 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n386.5 \"Well Of Flame\" Ability { id: \"3236\", source: \"Suzaku\" }\r\n387.0 \"Swoop\" Ability { id: \"323B\", source: \"Suzaku\" } window 30,30\r\n389.7 \"--sync--\" Ability { id: \"323A\", source: \"Suzaku\" }\r\n395.8 \"Southron Star\" Ability { id: \"3234\", source: \"Suzaku\" }\r\n402.4 \"Scarlet Hymn\" Ability { id: \"3237\", source: \"Suzaku\" }\r\n420.0 \"Southron Star\" Ability { id: \"3234\", source: \"Suzaku\" }\r\n430.8 \"Hotspot 1\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n432.9 \"Hotspot 2\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n435.0 \"Hotspot 3\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n437.0 \"Hotspot 4\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n443.6 \"Phantom Flurry\" Ability { id: \"3231\", source: \"Suzaku\" } window 30,30\r\n449.9 \"Phantom Half\" Ability { id: \"3233\", source: \"Suzaku\" }\r\n462.7 \"Hotspot 1\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n464.8 \"Hotspot 2\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n466.8 \"Hotspot 3\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n468.9 \"Hotspot 4\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n474.6 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n480.2 \"Well Of Flame\" Ability { id: \"3236\", source: \"Suzaku\" } window 30,30\r\n481.1 \"Rekindle\" Ability { id: \"3235\", source: \"Suzaku\" }\r\n493.7 \"Hotspot 1\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n494.4 \"Phantom Flurry\" Ability { id: \"3231\", source: \"Suzaku\" }\r\n495.7 \"Hotspot 2\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n497.8 \"Hotspot 3\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n499.8 \"Hotspot 4\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n500.5 \"Phantom Half\" Ability { id: \"3233\", source: \"Suzaku\" }\r\n512.1 \"Southron Star\" Ability { id: \"3234\", source: \"Suzaku\" }\r\n519.7 \"--sync--\" Ability { id: \"322E\", source: \"Suzaku\" }\r\n525.3 \"Well Of Flame\" Ability { id: \"3236\", source: \"Suzaku\" } window 30,30\r\n525.3 \"Hotspot 1\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n527.4 \"Hotspot 2\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n529.5 \"Hotspot 3\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n531.6 \"Hotspot 4\" # Ability { id: \"3238\", source: \"Suzaku\" }\r\n542.5 \"Southron Star\" Ability { id: \"3234\", source: \"Suzaku\" }\r\n548.1 \"--sync--\" Ability { id: \"323A\", source: \"Suzaku\" }\r\n554.2 \"Southron Star\" Ability { id: \"3234\", source: \"Suzaku\" }\r\n566.9 \"Phantom Flurry\" Ability { id: \"3231\", source: \"Suzaku\" }\r\n573.1 \"Phantom Half\" Ability { id: \"3233\", source: \"Suzaku\" }\r\n584.8 \"Well Of Flame\" Ability { id: \"3236\", source: \"Suzaku\" }\r\n585.7 \"Rekindle\" Ability { id: \"3235\", source: \"Suzaku\" }\r\n596.9 \"Southron Star\" Ability { id: \"3234\", source: \"Suzaku\" }\r\n\r\n609.4 \"Incandescent Interlude\" Ability { id: \"323C\", source: \"Suzaku\" } window 30,30 jump 346.2\r\n618.8 \"Rekindle\"\r\n621.8 \"Immolate\"\r\n629.9 \"Phantom Flurry\"\r\n636.0 \"Phantom Half\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/tsukuyomi-ex.ts




// Tsukuyomi Extreme
const tsukuyomi_ex_triggerSet = {
  id: 'TheMinstrelsBalladTsukuyomisPain',
  zoneId: zone_id/* default.TheMinstrelsBalladTsukuyomisPain */.Z.TheMinstrelsBalladTsukuyomisPain,
  timelineFile: 'tsukuyomi-ex.txt',
  triggers: [{
    id: 'TsukuyomiEx Nightfall Gun',
    type: 'StartsUsing',
    netRegex: {
      id: '2BBC',
      source: 'Tsukuyomi',
      capture: false
    },
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }, {
    id: 'TsukuyomiEx Nightfall Spear',
    type: 'StartsUsing',
    netRegex: {
      id: '2BBD',
      source: 'Tsukuyomi',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'TsukuyomiEx Torment',
    type: 'StartsUsing',
    netRegex: {
      id: ['2BBB', '2EB2'],
      source: 'Tsukuyomi'
    },
    alarmText: (data, matches, output) => {
      if (matches.target === data.me || data.role !== 'tank') return;
      return output.tankSwap();
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.tankBusterOnYou();
      if (data.role === 'healer') return output.busterOn({
        player: data.party.member(matches.target)
      });
    },
    infoText: (data, matches, output) => {
      if (matches.target === data.me || data.role === 'tank' || data.role === 'healer') return;
      return output.getOutOfFront();
    },
    outputStrings: {
      getOutOfFront: {
        en: 'Get out of front',
        de: 'Weg von vorn',
        fr: 'Éloignez-vous de l\'avant',
        ja: '正面から離れる',
        cn: '远离正面',
        ko: '정면 피하기'
      },
      tankBusterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
      busterOn: outputs/* default.tankBusterOnPlayer */.Z.tankBusterOnPlayer,
      tankSwap: outputs/* default.tankSwap */.Z.tankSwap
    }
  }, {
    id: 'TsukuyomiEx Full Moon',
    type: 'GainsEffect',
    netRegex: {
      target: 'Tsukuyomi',
      effectId: '5FF',
      capture: false
    },
    run: data => data.moonIsOut = true
  }, {
    id: 'TsukuyomiEx New Moon',
    type: 'GainsEffect',
    netRegex: {
      target: 'Tsukuyomi',
      effectId: '600',
      capture: false
    },
    run: data => data.moonIsOut = false
  }, {
    id: 'TsukuyomiEx Dark Blade',
    type: 'StartsUsing',
    netRegex: {
      id: '2BDA',
      source: 'Tsukuyomi',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.moonIsOut) return output.leftAndOut();
      return output.leftAndIn();
    },
    outputStrings: {
      leftAndOut: {
        en: 'Left + Out',
        de: 'Links + Raus',
        fr: 'À gauche + Extérieur',
        ja: '左へ + 外へ',
        cn: '左边 + 远离',
        ko: '왼쪽 + 밖'
      },
      leftAndIn: {
        en: 'Left + In',
        de: 'Links + Rein',
        fr: 'À gauche + Intérieur',
        ja: '左へ + 中へ',
        cn: '左边 + 靠近',
        ko: '왼쪽 + 안'
      }
    }
  }, {
    id: 'TsukuyomiEx Bright Blade',
    type: 'StartsUsing',
    netRegex: {
      id: '2BDB',
      source: 'Tsukuyomi',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.moonIsOut) return output.rightAndOut();
      return output.rightAndIn();
    },
    outputStrings: {
      rightAndOut: {
        en: 'Right + Out',
        de: 'Rechts + Raus',
        fr: 'À droite + Extérieur',
        ja: '右へ + 外へ',
        cn: '右边 + 远离',
        ko: '오른쪽 + 밖'
      },
      rightAndIn: {
        en: 'Right + In',
        de: 'Rechts + Rein',
        fr: 'À droite + Intérieur',
        ja: '右へ + 中へ',
        cn: '右边 + 靠近',
        ko: '오른쪽 + 안'
      }
    }
  }, {
    id: 'TsukuyomiEx Meteor Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0083'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.meteorOnYou */.n3.meteorOnYou()
  }, {
    id: 'TsukuyomiEx Lunacy',
    type: 'HeadMarker',
    netRegex: {
      id: '003E',
      capture: false
    },
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }, {
    id: 'TsukuyomiEx Hagetsu',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  },
  // https://xivapi.com/InstanceContentTextData/19521
  // en: No. No... Not yet. Not. Yet.
  {
    id: 'TsukuyomiEx Dance of the Dead',
    type: 'BattleTalk2',
    // There's no "starts using" here.  She pushes at 35% to this ability.
    // This happens after 2nd meteors naturally, but if dps is good
    // then this could push unexpectedly earlier (or paired with buster).
    netRegex: {
      instanceContentTextId: '4C41',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'TsukuyomiEx Supreme Selenomancy',
    type: 'Ability',
    netRegex: {
      source: 'Tsukuyomi',
      id: '2EB0',
      capture: false
    },
    suppressSeconds: 5,
    run: data => {
      delete data.moonlitCount;
      delete data.moonshadowedCount;
    }
  }, {
    id: 'TsukuyomiEx Moonlit Debuff Logic',
    type: 'GainsEffect',
    netRegex: {
      effectId: '602'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: data => {
      // init at 3 so we can start at 4 stacks to give the initial instruction to move
      if (typeof data.moonlitCount === 'undefined') data.moonlitCount = 3;
      data.moonlitCount += 1;
      data.moonshadowedCount = 0;
      // dead/reset?
      if (data.moonlitCount > 4) data.moonlitCount = 0;
    }
  }, {
    id: 'TsukuyomiEx Moonlit Debuff',
    type: 'GainsEffect',
    netRegex: {
      effectId: '602'
    },
    condition: (data, matches) => {
      if (matches.target !== data.me) return false;
      return data.moonlitCount !== undefined && data.moonlitCount >= 4;
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move to Black!',
        de: 'In\'s schwarze laufen!',
        fr: 'Allez en zone noire !',
        ja: '新月に！',
        cn: '踩黑色！',
        ko: '검정색으로 이동!'
      }
    }
  }, {
    id: 'TsukuyomiEx Moonshadowed Debuff Logic',
    type: 'GainsEffect',
    netRegex: {
      effectId: '603'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: data => {
      // init at 3 so we can start at 4 stacks to give the initial instruction to move
      if (typeof data.moonshadowedCount === 'undefined') data.moonshadowedCount = 3;
      data.moonshadowedCount += 1;
      data.moonlitCount = 0;
      // dead/reset?
      if (data.moonshadowedCount > 4) data.moonshadowedCount = 0;
    }
  }, {
    id: 'TsukuyomiEx Moonshadowed Debuff',
    type: 'GainsEffect',
    netRegex: {
      effectId: '603'
    },
    condition: (data, matches) => {
      if (matches.target !== data.me) return false;
      return data.moonlitCount !== undefined && data.moonlitCount >= 4;
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move to White!',
        de: 'In\'s weiße laufen!',
        fr: 'Allez en zone blanche !',
        ja: '満月に！',
        cn: '踩白色！',
        ko: '흰색으로 이동!'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Bright Blade/Dark Blade': 'Bright/Dark Blade',
      'Waning Grudge/Waxing Grudge': 'Waning/Waxing Grudge',
      'Lead Of The Underworld/Steel Of The Underworld': 'Lead/Steel Of The Underworld'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Dancing Fan': 'tanzend(?:e|er|es|en) Fächer',
      'Moondust': 'Mondfragment',
      'Moonlight': 'Mondlicht',
      'No\. No\.\.\. Not yet\. Not\. Yet\.': 'Meine Rache ... Ich will... meine Rache...',
      'Specter(?! )': 'Schemen',
      'Specter Of Asahi': 'Asahi',
      'Specter Of Gosetsu': 'Gosetsu',
      'Specter Of The Patriarch': 'Yotsuyus Ziehvater',
      'Specter Of Zenos': 'Zenos',
      'Specter of Zenos': 'Zenos',
      'Tsukuyomi': 'Tsukuyomi'
    },
    'replaceText': {
      '\\(gun': '(Pistole',
      'spear\\)': 'Speer)',
      'Antitwilight': 'Schönheit der Nacht',
      'Bright Blade': 'Helle Klinge',
      'Concentrativity': 'Konzentriertheit',
      'Crater': 'Krater',
      'Dance Of The Dead': 'Tanz der Toten',
      'Dark Blade': 'Dunkle Klinge',
      'Dispersivity': 'Dispersivität',
      'Empire adds': 'Soldaten Adds',
      'Hagetsu': 'Hagetsu',
      'Homeland adds': 'Domaner Adds',
      'Lead Of The Underworld': 'Blei der Unterwelt',
      'Lunacy': 'Mondscheinblüte',
      'Lunar Halo': 'Flammender Mond',
      'Lunar Rays': 'Mondschimmer',
      'Midnight Rain': 'Mitternachtsregen',
      'Moonbeam': 'Mondstrahl',
      'Moonfall': 'Mondfall',
      'Nightbloom': 'Monddämmerung',
      'Perilune': 'Zenit des Mondes',
      'Reprimand': 'Maßregelung',
      'Steel Of The Underworld': 'Stahl der Unterwelt',
      'Supreme Selenomancy': 'Hohe Mondprophezeiung',
      'Torment Unto Death': 'Todesqualen',
      'Tsuki-No-Kakera': 'Mondsplitter',
      'Tsuki-No-Maiogi': 'Mondfächer',
      'Unmoving Troika': 'Unbewegte Troika',
      'Waning Grudge': 'Schwindender Groll',
      'Waxing Grudge': 'Wachsender Groll',
      'Zashiki-Asobi': 'Zashiki-Asobi'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Dancing Fan': 'maiôgi',
      'Moondust': 'fragment de lune',
      'Moonlight': 'Clair de lune',
      'No\. No\.\.\. Not yet\. Not\. Yet\.': 'Non, je ne peux pas... échouer...',
      'Specter(?! )': 'spector',
      'Specter Of Asahi': 'apparition d\'Asahi',
      'Specter Of Gosetsu': 'apparition de Gosetsu',
      'Specter Of The Patriarch': 'spectre du parâtre',
      'Specter Of Zenos': 'spectre de Zenos',
      'Tsukuyomi': 'Tsukuyomi',
      'Specter of Zenos': 'spectre de Zenos'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(E->W\\)': '(E->O)',
      '\\(SW->NW\\)': '(SO->NO)',
      '\\(gun\\)': '(fusil)',
      '\\(gun/spear\\)': '(fusil/lance)',
      '\\(spear\\)': '(lance)',
      'Antitwilight': 'Belle-de-nuit',
      'Bright Blade/Dark Blade': 'Lame blafarde/ténébreuse',
      'Concentrativity': 'Kenki concentré',
      'Crater': 'Explosion de fragment lunaire',
      'Dance Of The Dead': 'Danse des morts',
      'Dispersivity': 'Onde Kenki',
      'Empire adds': 'Adds Impériaux',
      'Hagetsu': 'Pulvérisation lunaire',
      'Homeland adds': 'Adds Domiens',
      'Lead Of The Underworld(?!/)': 'Tir de l\'au-delà',
      'Lead Of The Underworld/Steel Of The Underworld': 'Tir/Pointes de l\'au-delà',
      'Lunacy': 'Efflorescence au clair de lune',
      'Lunar Halo': 'Flamboiement lunaire',
      'Lunar Rays': 'Rayons lunaires',
      'Midnight Rain': 'Bruine nocturne',
      'Moonbeam': 'Faisceau lunaire',
      'Moonfall': 'Impact de fragment lunaire',
      'Nightbloom': 'Lis araignée',
      'Nightfall': 'Jeune nuit',
      'Perilune': 'Zénith lunaire',
      'Reprimand': 'Correction',
      '(?<!/)Steel Of The Underworld': 'Pointes de l\'au-delà',
      'Supreme Selenomancy': 'Sélénomancie suprême',
      'Torment Unto Death': 'Brimade meurtrière',
      'Tsuki-No-Kakera': 'Fragments lunaires',
      'Tsuki-No-Maiogi': 'Maiôgi lunaire',
      'Unmoving Troika': 'Troïka immobile',
      'Waning Grudge/Waxing Grudge': 'Rancœur blafarde/ténébreuse',
      'Zashiki-Asobi': 'Zashiki asobi'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Dancing Fan': '舞扇',
      'Moondust': '月の欠片',
      'Moonlight': '月光',
      'No\. No\.\.\. Not yet\. Not\. Yet\.': '嗚呼、まだ、あたしは…………。',
      'Specter(?! )': 'スペクター',
      'Specter Of Asahi': 'アサヒの幻影',
      'Specter Of Gosetsu': 'ゴウセツの幻影',
      'Specter Of The Patriarch': '養父の幻影',
      'Specter Of Zenos': 'ゼノスの幻影',
      'Tsukuyomi': 'ツクヨミ',
      'Specter of Zenos': 'ゼノスの幻影'
    },
    'replaceText': {
      'Antitwilight': '月下美人',
      'Bright Blade': '月刀左近',
      'Concentrativity': '圧縮剣気',
      'Crater': '氷輪',
      'Dance Of The Dead': '黄泉の舞',
      'Dark Blade': '月刀右近',
      'Dispersivity': '剣気波動',
      'Empire adds': '雑魚: 帝国軍',
      'Hagetsu': '破月',
      'Homeland adds': '雑魚: 幻影',
      'Lead Of The Underworld': '黄泉の銃弾',
      'Lunacy': '月下繚乱',
      'Lunar Halo': '百月光',
      'Lunar Rays': '残月',
      'Midnight Rain': '月時雨',
      'Moonbeam': '月光流転',
      'Moonfall': '月片落下',
      'Nightbloom': '月下彼岸花',
      'Perilune': '月天心',
      'Reprimand': '折檻',
      'Steel Of The Underworld': '黄泉の穂先',
      'Supreme Selenomancy': '極の月読',
      'Torment Unto Death': 'なぶり殺し',
      'Tsuki-No-Kakera': '月の欠片',
      'Tsuki-No-Maiogi': '月の舞扇',
      'Unmoving Troika': '不動三段',
      'Waning Grudge': '黒き怨念',
      'Waxing Grudge': '白き怨念',
      'Zashiki-Asobi': '座敷遊び'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Dancing Fan': '舞扇',
      'Moondust': '月之碎片',
      'Moonlight': '月光',
      'No\. No\.\.\. Not yet\. Not\. Yet\.': '我不能输.*我还没有.*',
      'Specter(?! )': '妖影',
      'Specter Of Asahi': '朝阳的幻影',
      'Specter Of Gosetsu': '豪雪的幻影',
      'Specter Of The Patriarch': '养父的幻影',
      'Specter Of Zenos': '芝诺斯的幻影',
      'Tsukuyomi': '月读',
      'Specter of Zenos': '芝诺斯的幻影'
    },
    'replaceText': {
      '\\(gun': '(枪',
      'spear\\)': '长矛)',
      'Antitwilight': '月下美人',
      'Bright Blade': '月刀左斩',
      'Concentrativity': '压缩剑气',
      'Crater': '冰轮',
      'Dance Of The Dead': '黄泉之舞',
      'Dark Blade': '月刀右斩',
      'Dispersivity': '剑气波动',
      'Empire adds': '帝国幻影',
      'Hagetsu': '破月',
      'Homeland adds': '家人幻影',
      'Lead Of The Underworld': '黄泉之弹',
      'Lunacy': '月下缭乱',
      'Lunar Halo': '百月光',
      'Lunar Rays': '残月',
      'Midnight Rain': '月时雨',
      'Moonbeam': '月光流转',
      'Moonfall': '碎片散落',
      'Nightbloom': '月下彼岸花',
      'Perilune': '月天心',
      'Reprimand': '责难',
      'Steel Of The Underworld': '黄泉之枪',
      'Supreme Selenomancy': '极月读',
      'Torment Unto Death': '折磨',
      'Tsuki-No-Kakera': '月之碎片',
      'Tsuki-No-Maiogi': '月下舞扇',
      'Unmoving Troika': '不动三段',
      'Waning Grudge': '漆黑怨念',
      'Waxing Grudge': '纯白怨念',
      'Zashiki-Asobi': '宴会游乐'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Dancing Fan': '춤추는 부채',
      'Moondust': '달조각',
      'Moonlight': '월광',
      'No\. No\.\.\. Not yet\. Not\. Yet\.': '아아, 나는 아직…….',
      'Specter(?! )': '그림자요괴',
      'Specter Of Asahi': '아사히의 환영',
      'Specter Of Gosetsu': '고우세츠의 환영',
      'Specter Of The Patriarch': '양아버지의 환영',
      'Specter Of Zenos': '제노스의 환영',
      'Tsukuyomi': '츠쿠요미',
      'Specter of Zenos': '제노스의 환영'
    },
    'replaceText': {
      'Antitwilight': '월하미인',
      'Bright Blade': '하현달 베기',
      'Concentrativity': '압축 검기',
      'Crater': '빙륜',
      'Dance Of The Dead': '황천의 춤',
      'Dark Blade': '상현달 베기',
      'Dispersivity': '검기 파동',
      'Empire adds': '제국군 쫄',
      'Hagetsu': '파월',
      'Homeland adds': '도마 쫄',
      'Lead Of The Underworld': '황천의 총탄',
      'Lunacy': '월하요란',
      'Lunar Halo': '백월광',
      'Lunar Rays': '잔월',
      'Midnight Rain': '달의 눈물',
      'Moonbeam': '달빛 윤회',
      'Moonfall': '달조각 낙하',
      'Nightbloom': '달빛 저승꽃',
      'Perilune': '중천의 달',
      'Reprimand': '절함',
      'Steel Of The Underworld': '황천의 창끝',
      'Supreme Selenomancy': '궁극의 달읽기',
      'Torment Unto Death': '고문살인',
      'Tsuki-No-Kakera': '달조각',
      'Tsuki-No-Maiogi': '춤추는 달 부채',
      'Unmoving Troika': '부동삼단',
      'Waning Grudge': '검은 원념',
      'Waxing Grudge': '하얀 원념',
      'Zashiki-Asobi': '유흥',
      'gun': '총',
      'spear': '창'
    }
  }]
};
/* harmony default export */ const tsukuyomi_ex = (tsukuyomi_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/tsukuyomi-ex.txt
const trial_tsukuyomi_ex_namespaceObject = "# Tsukuyomi Extreme\r\n# http://clees.me/guides/tsukuyomi-ex/\r\n#\r\n# -p 2BBA:514.8 2BC8:1000 2CD6:1100 2CD0:1355.3\r\n# -it \"Tsukuyomi\"\r\n# -ii 2CAE 2CAA 2CA9 2CCF 2BCF 2EDF 2E23 2BC0 2BFD 2BFE 2D1D\r\n\r\nhideall \"--sync--\"\r\nhideall \"--Reset--\"\r\n\r\n# Timings get slightly off if there's lead or steel first, so do a split.\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n10.8 \"--sync--\" StartsUsing { id: \"2BBA\", source: \"Tsukuyomi\" } window 30,30\r\n14.8 \"Reprimand\" Ability { id: \"2BBA\", source: \"Tsukuyomi\" }\r\n25.0 \"Nightfall (gun/spear)\" Ability { id: \"2BB[CD]\", source: \"Tsukuyomi\" }\r\n25.0 \"--sync--\" Ability { id: \"2BBC\", source: \"Tsukuyomi\" } window 30,30 jump 225\r\n25.0 \"--sync--\" Ability { id: \"2BBD\", source: \"Tsukuyomi\" } window 30,30 jump 525\r\n31.1 \"Lead Of The Underworld?\" Ability { id: \"2BBE\", source: \"Tsukuyomi\" }\r\n31.8 \"Steel Of The Underworld 1?\" Ability { id: \"2BBF\", source: \"Tsukuyomi\" }\r\n33.6 \"Steel Of The Underworld 2?\" Ability { id: \"2BBF\", source: \"Tsukuyomi\" }\r\n35.4 \"Steel Of The Underworld 3?\" Ability { id: \"2BBF\", source: \"Tsukuyomi\" }\r\n\r\n# Lead first\r\n214.8 \"Reprimand\" Ability { id: \"2BBA\", source: \"Tsukuyomi\" }\r\n225.0 \"Nightfall (gun)\" Ability { id: \"2BBC\", source: \"Tsukuyomi\" }\r\n231.1 \"Lead Of The Underworld\" Ability { id: \"2BBE\", source: \"Tsukuyomi\" }\r\n236.2 \"--sync--\" Ability { id: \"2CCF\", source: \"Tsukuyomi\" }\r\n242.3 \"Nightfall (spear)\" Ability { id: \"2BBD\", source: \"Tsukuyomi\" }\r\n249.1 \"Steel Of The Underworld 1\" #Ability { id: \"2BBF\", source: \"Tsukuyomi\" }\r\n250.9 \"Steel Of The Underworld 2\" #Ability { id: \"2BBF\", source: \"Tsukuyomi\" }\r\n252.7 \"Steel Of The Underworld 3\" #Ability { id: \"2BBF\", source: \"Tsukuyomi\" }\r\n255.9 \"--sync--\" Ability { id: \"2BC0\", source: \"Tsukuyomi\" }\r\n267.0 \"Reprimand\" Ability { id: \"2BBA\", source: \"Tsukuyomi\" }\r\n281.0 \"Nightbloom\" #Ability { id: \"2BC7\", source: \"Tsukuyomi\" }\r\n281.8 \"--untargetable--\"\r\n\r\n# Steel first\r\n514.8 \"Reprimand\" Ability { id: \"2BBA\", source: \"Tsukuyomi\" }\r\n525.0 \"Nightfall (spear)\" Ability { id: \"2BBD\", source: \"Tsukuyomi\" }\r\n531.8 \"Steel Of The Underworld 1\" #Ability { id: \"2BBF\", source: \"Tsukuyomi\" }\r\n533.6 \"Steel Of The Underworld 2\" #Ability { id: \"2BBF\", source: \"Tsukuyomi\" }\r\n535.4 \"Steel Of The Underworld 3\" #Ability { id: \"2BBF\", source: \"Tsukuyomi\" }\r\n538.5 \"--sync--\" Ability { id: \"2BC0\", source: \"Tsukuyomi\" }\r\n545.6 \"Nightfall (gun)\" Ability { id: \"2BBC\", source: \"Tsukuyomi\" }\r\n551.8 \"Lead Of The Underworld\" Ability { id: \"2BBE\", source: \"Tsukuyomi\" }\r\n556.9 \"--sync--\" Ability { id: \"2CCF\", source: \"Tsukuyomi\" }\r\n567.0 \"Reprimand\" Ability { id: \"2BBA\", source: \"Tsukuyomi\" }\r\n581.0 \"Nightbloom\" #Ability { id: \"2BC7\", source: \"Tsukuyomi\" }\r\n581.8 \"--untargetable--\"\r\n\r\n# Add phase\r\n781.0 \"Nightbloom\" Ability { id: \"2BC7\", source: \"Tsukuyomi\" } window 800,0\r\n781.8 \"--untargetable--\"\r\n792.3 \"Homeland adds (E->W)\" AddedCombatant { name: \"Specter Of The Patriarch\" } window 40,20\r\n852.3 \"Empire adds (SW->NW)\" AddedCombatant { name: \"Specter Of Asahi\" } window 160,20\r\n886.3 \"Enrage\"\r\n\r\n1000.0 \"Concentrativity\" Ability { id: \"2BC8\", source: \"Specter of Zenos\" } window 1000,0\r\n1006.7 \"Unmoving Troika\" Ability { id: \"2CA8\", source: \"Specter Of Zenos\" }\r\n1013.7 \"--sync--\" Ability { id: \"2BCA\", source: \"Specter Of Zenos\" }\r\n1013.7 \"--sync--\" Ability { id: \"2BCB\", source: \"Specter Of Gosetsu\" }\r\n1023.7 \"Dispersivity\" Ability { id: \"2BCC\", source: \"Specter\" }\r\n1029.8 \"Dispersivity\" Ability { id: \"2BCC\", source: \"Specter\" }\r\n1035.9 \"Dispersivity\" Ability { id: \"2BCC\", source: \"Specter\" }\r\n1042.0 \"Dispersivity\" Ability { id: \"2BCC\", source: \"Specter\" }\r\n1048.1 \"Dispersivity\" Ability { id: \"2BCC\", source: \"Specter\" }\r\n\r\n# Adds complete, crescent phase\r\n1100.0 \"--sync--\" Ability { id: \"2CD6\", source: \"Specter Of Gosetsu\" } window 1200,0\r\n1114.3 \"Nightbloom\" Ability { id: \"2CAF\", source: \"Tsukuyomi\" } window 1200,0\r\n1120.1 \"--targetable--\"\r\n1134.5 \"Supreme Selenomancy\" Ability { id: \"2EB0\", source: \"Tsukuyomi\" }\r\n1143.5 \"Lunar Halo\" Ability { id: \"2BD6\", source: \"Moonlight\" }\r\n1153.8 \"Tsuki-No-Kakera\" Ability { id: \"2BD0\", source: \"Tsukuyomi\" }\r\n1159.9 \"Nightfall (gun)\" Ability { id: \"2BBC\", source: \"Tsukuyomi\" }\r\n1166.4 \"Lead Of The Underworld\" Ability { id: \"2BBE\", source: \"Tsukuyomi\" }\r\n1179.0 \"Moonfall\" Ability { id: \"2BD1\", source: \"Moondust\" }\r\n1180.8 \"Midnight Rain\" Ability { id: \"2BCE\", source: \"Tsukuyomi\" }\r\n1189.7 \"Lunar Halo\" Ability { id: \"2BD6\", source: \"Moonlight\" }\r\n1195.2 \"Lunar Rays\" Ability { id: \"2BD3\", source: \"Tsukuyomi\" }\r\n1196.8 \"Lunar Halo\" Ability { id: \"2BD6\", source: \"Moonlight\" }\r\n1197.2 \"Crater\" Ability { id: \"2CD7\", source: \"Moondust\" }\r\n1197.2 \"Moonbeam\" Ability { id: \"2BD4\", source: \"Moondust\" }\r\n1208.3 \"Antitwilight/Perilune\" Ability { id: [\"2BD7\", \"2BD8\"], source: \"Tsukuyomi\" }\r\n\r\n1223.4 \"Reprimand\" Ability { id: \"2BBA\", source: \"Tsukuyomi\" }\r\n1230.6 \"Zashiki-Asobi\" Ability { id: \"2BC5\", source: \"Tsukuyomi\" }\r\n1239.8 \"Nightfall (gun/spear)\" Ability { id: \"2BB[CD]\", source: \"Tsukuyomi\" }\r\n1241.7 \"Tsuki-No-Maiogi\" Ability { id: \"2BC6\", source: \"Dancing Fan\" }\r\n1244.7 \"Tsuki-No-Maiogi\" Ability { id: \"2BC6\", source: \"Dancing Fan\" }\r\n# don't match 2BBF here because there's three of them, close in time.\r\n1246.3 \"Lead Of The Underworld/Steel Of The Underworld\" Ability { id: \"2BBE\", source: \"Tsukuyomi\" }\r\n\r\n# Torment Unto Death can be delayed by ~2s if it's Steel\r\n1257.5 \"--sync--\" StartsUsing { id: \"2BBB\", source: \"Tsukuyomi\" } window 10,10\r\n1262.5 \"Torment Unto Death\" Ability { id: \"2BBB\", source: \"Tsukuyomi\" }\r\n1273.8 \"Supreme Selenomancy\" Ability { id: \"2EB0\", source: \"Tsukuyomi\" }\r\n1282.8 \"Lunar Halo\" Ability { id: \"2BD6\", source: \"Moonlight\" }\r\n1292.8 \"Tsuki-No-Kakera\" Ability { id: \"2BD0\", source: \"Tsukuyomi\" }\r\n1298.8 \"Nightfall (spear)\" Ability { id: \"2BBD\", source: \"Tsukuyomi\" }\r\n1305.4 \"Steel Of The Underworld 1\" #Ability { id: \"2BBF\", source: \"Tsukuyomi\" }\r\n1307.2 \"Steel Of The Underworld 2\" #Ability { id: \"2BBF\", source: \"Tsukuyomi\" }\r\n1308.8 \"Steel Of The Underworld 3\" #Ability { id: \"2BBF\", source: \"Tsukuyomi\" }\r\n1317.8 \"Moonfall\" Ability { id: \"2BD1\", source: \"Moondust\" }\r\n1318.9 \"Midnight Rain\" Ability { id: \"2BCE\", source: \"Tsukuyomi\" }\r\n1328.9 \"Lunar Halo\" Ability { id: \"2BD6\", source: \"Moonlight\" }\r\n1332.9 \"Lunar Rays\" Ability { id: \"2BD3\", source: \"Tsukuyomi\" }\r\n1334.9 \"Moonbeam\" Ability { id: \"2BD4\", source: \"Moondust\" }\r\n1334.9 \"Crater\" Ability { id: \"2CD7\", source: \"Moondust\" }\r\n1335.9 \"Lunar Halo\" Ability { id: \"2BD6\", source: \"Moonlight\" }\r\n1346.0 \"Antitwilight/Perilune\" Ability { id: [\"2BD7\", \"2BD8\"], source: \"Tsukuyomi\" }\r\n\r\n# 35% push\r\n1361.3 \"Dance Of The Dead\" Ability { id: \"2CD0\", source: \"Tsukuyomi\" } window 1400,20\r\n1378.6 \"Bright Blade/Dark Blade\" Ability { id: \"2BD(A|B)\", source: \"Tsukuyomi\" }\r\n1379.5 \"Waning Grudge/Waxing Grudge\" Ability { id: \"2BD(E|F)\", source: \"Tsukuyomi\" }\r\n1392.0 \"Bright Blade/Dark Blade\" Ability { id: \"2BD(A|B)\", source: \"Tsukuyomi\" }\r\n1393.0 \"Waning Grudge/Waxing Grudge\" Ability { id: \"2BD(E|F)\", source: \"Tsukuyomi\" }\r\n\r\n# loop begins\r\n1403.1 \"Reprimand\" Ability { id: \"2BBA\", source: \"Tsukuyomi\" }\r\n1415.3 \"Lunacy\" Ability { id: \"2BDC\", source: \"Tsukuyomi\" }\r\n1416.1 \"Tsuki-No-Maiogi\" duration 4 #Ability { id: \"2BC6\", source: \"Dancing Fan\" }\r\n1417.4 \"Lunacy x3\" #Ability { id: \"2BDD\", source: \"Tsukuyomi\" }\r\n#1418.4 \"Lunacy\" Ability { id: \"2BDD\", source: \"Tsukuyomi\" }\r\n#1419.4 \"Lunacy\" Ability { id: \"2BDD\", source: \"Tsukuyomi\" }\r\n\r\n1427.4 \"Bright Blade/Dark Blade\" Ability { id: \"2BD(A|B)\", source: \"Tsukuyomi\" }\r\n1428.4 \"Waning Grudge/Waxing Grudge\" Ability { id: \"2BD(E|F)\", source: \"Tsukuyomi\" }\r\n1437.5 \"Torment Unto Death\" Ability { id: \"2EB2\", source: \"Tsukuyomi\" }\r\n\r\n1450.7 \"Hagetsu\" Ability { id: \"2D1C\", source: \"Tsukuyomi\" }\r\n1452.5 \"Tsuki-No-Maiogi\" Ability { id: \"2BC6\", source: \"Dancing Fan\" }\r\n1455.5 \"Tsuki-No-Maiogi\" Ability { id: \"2BC6\", source: \"Dancing Fan\" }\r\n\r\n1460.9 \"Bright Blade/Dark Blade\" Ability { id: \"2BD(A|B)\", source: \"Tsukuyomi\" }\r\n1461.9 \"Waning Grudge/Waxing Grudge\" Ability { id: \"2BD(E|F)\", source: \"Tsukuyomi\" }\r\n1469.9 \"Reprimand\" Ability { id: \"2BBA\", source: \"Tsukuyomi\" }\r\n\r\n# loop\r\n1476.9 \"Reprimand\" Ability { id: \"2BBA\", source: \"Tsukuyomi\" }\r\n1489.2 \"Lunacy\" Ability { id: \"2BDC\", source: \"Tsukuyomi\" } window 50,50 jump 1415.3\r\n1490.0 \"Tsuki-No-Maiogi\" #duration 4 #Ability { id: \"2BC6\", source: \"Dancing Fan\" }\r\n1491.3 \"Lunacy x3\" #Ability { id: \"2BDD\", source: \"Tsukuyomi\" }\r\n#1492.3 \"Lunacy\" Ability { id: \"2BDD\", source: \"Tsukuyomi\" }\r\n#1493.3 \"Lunacy\" Ability { id: \"2BDD\", source: \"Tsukuyomi\" }\r\n\r\n1501.3 \"Bright Blade/Dark Blade\" #Ability { id: \"2BD(A|B)\", source: \"Tsukuyomi\" }\r\n1502.3 \"Waning Grudge/Waxing Grudge\" #Ability { id: \"2BD(E|F)\", source: \"Tsukuyomi\" }\r\n1511.4 \"Torment Unto Death\" #Ability { id: \"2EB2\", source: \"Tsukuyomi\" }\r\n\r\n1524.6 \"Hagetsu\" #Ability { id: \"2D1C\", source: \"Tsukuyomi\" }\r\n1526.4 \"Tsuki-No-Maiogi\" #Ability { id: \"2BC6\", source: \"Dancing Fan\" }\r\n1529.4 \"Tsuki-No-Maiogi\" #Ability { id: \"2BC6\", source: \"Dancing Fan\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/tsukuyomi.ts


// Tsukuyomi Normal
const tsukuyomi_triggerSet = {
  id: 'CastrumFluminis',
  zoneId: zone_id/* default.CastrumFluminis */.Z.CastrumFluminis,
  timelineFile: 'tsukuyomi.txt',
  triggers: [{
    id: 'Tsukuyomi Torment Unto Death',
    type: 'StartsUsing',
    netRegex: {
      id: '2BE3',
      source: 'Tsukuyomi'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Tsukuyomi Reprimand',
    type: 'StartsUsing',
    netRegex: {
      id: '2BE2',
      source: 'Tsukuyomi',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Tsukuyomi Midnight Haze',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '7230',
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'Tsukuyomi Lead Of The Underworld',
    type: 'StartsUsing',
    netRegex: {
      id: '2BE6',
      source: 'Tsukuyomi'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.lineStackOnYou();
      return output.lineStackOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      lineStackOnYou: {
        en: 'Line Stack on YOU',
        de: 'Linien Stack auf DIR',
        fr: 'Package en ligne sur VOUS',
        ja: '直線頭割り',
        cn: '直线分摊点名',
        ko: '직선 쉐어 대상자'
      },
      lineStackOn: {
        en: 'Line Stack on ${player}',
        de: 'Linien Stack auf ${player}',
        fr: 'Package en ligne sur ${player}',
        ja: '${player}に直線頭割り',
        cn: '直线分摊点${player}',
        ko: '${player} 직선 쉐어'
      }
    }
  }, {
    id: 'Tsukuyomi Nightbloom',
    type: 'StartsUsing',
    netRegex: {
      id: '2CB0',
      source: 'Tsukuyomi',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Tsukuyomi Lunacy',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Tsukuyomi Moonlit Debuff',
    type: 'GainsEffect',
    netRegex: {
      effectId: '602'
    },
    condition: (data, matches) => {
      if (matches.target !== data.me) return false;
      return parseInt(matches.count) >= 4;
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move to Black!',
        de: 'In\'s schwarze laufen!',
        fr: 'Allez en zone noire !',
        ja: '新月に！',
        cn: '踩黑色！',
        ko: '검정색으로 이동!'
      }
    }
  }, {
    id: 'Tsukuyomi Moonshadowed Debuff',
    type: 'GainsEffect',
    netRegex: {
      effectId: '603'
    },
    condition: (data, matches) => {
      if (matches.target !== data.me) return false;
      return parseInt(matches.count) >= 4;
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move to White!',
        de: 'In\'s weiße laufen!',
        fr: 'Allez en zone blanche !',
        ja: '満月に！',
        cn: '踩白色！',
        ko: '흰색으로 이동!'
      }
    }
  }, {
    id: 'Tsukuyomi Dance Of The Dead',
    // 2BFD is an unnamed ability that happens ~5 seconds before Dance Of The Dead.
    // Dance Of The Dead has no castbar.
    type: 'Ability',
    netRegex: {
      id: '2BFD',
      source: 'Tsukuyomi',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Bright Blade/Dark Blade': 'Bright/Dark Blade'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Dancing Fan': 'tanzend(?:e|er|es|en) Fächer',
      'Moonlight': 'Mondlicht',
      'Specter(?! )': 'Schemen',
      'Specter Of The Empire': 'garleisch(?:e|er|es|en) Soldat',
      'Specter Of The Matriarch': 'Yotsuyus Ziehmutter',
      'Specter of Zenos': 'Zenos',
      'Tsukuyomi': 'Tsukuyomi'
    },
    'replaceText': {
      'Antitwilight': 'Schönheit der Nacht',
      'Bright Blade': 'Helle Klinge',
      'Concentrativity': 'Konzentriertheit',
      'Dance Of The Dead': 'Tanz der Toten',
      'Dark Blade': 'Dunkle Klinge',
      'Dispersivity': 'Dispersivität',
      'Empire': 'Soldat',
      'Homeland': 'Domaner',
      'Lead Of The Underworld': 'Blei der Unterwelt',
      'Lunacy': 'Mondscheinblüte',
      'Lunar Halo': 'Flammender Mond',
      'Matriarch': 'Ziehmutter',
      'Midnight Haze': 'Mitternachtsnebel',
      'Nightbloom': 'Monddämmerung',
      'Nightfall': 'Einbruch der Dunkelheit',
      'Patriarch': 'Ziehvater',
      'Perilune': 'Zenit des Mondes',
      'Reprimand': 'Maßregelung',
      'Selenomancy': 'Mondprophezeiung',
      'Steel Of The Underworld': 'Stahl der Unterwelt',
      'Torment Unto Death': 'Todesqualen',
      'Tsuki-No-Maiogi': 'Mondfächer',
      'Unmoving Troika': 'Unbewegte Troika',
      'Zashiki-Asobi': 'Zashiki-Asobi'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Dancing Fan': 'maiôgi',
      'Moonlight': 'Clair de lune',
      'Specter(?! )': 'spector',
      'Specter Of The Empire': 'spectre de soldat impérial',
      'Specter Of The Matriarch': 'spectre de la marâtre',
      'Specter of Zenos': 'spectre de Zenos',
      'Tsukuyomi': 'Tsukuyomi'
    },
    'replaceText': {
      '--Empire/Homeland Adds': '--Adds Impériaux/Domiens--',
      '--Patriarch/Matriarch Adds--': '--Adds Parâtres/Marâtres--',
      'Antitwilight': 'Belle-de-nuit',
      'Bright Blade/Dark Blade': 'Lame blafarde/ténébreuse',
      'Concentrativity': 'Kenki concentré',
      'Dance Of The Dead': 'Danse des morts',
      'Dispersivity': 'Onde Kenki',
      'Lead Of The Underworld': 'Tir de l\'au-delà',
      'Lunacy': 'Efflorescence au clair de lune',
      'Lunar Halo': 'Flamboiement lunaire',
      'Midnight Haze': 'Brume nocturne',
      'Nightbloom': 'Lis araignée',
      'Nightfall': 'Jeune nuit',
      'Perilune': 'Zénith lunaire',
      'Reprimand': 'Correction',
      'Selenomancy': 'Sélénomancie',
      'Steel Of The Underworld': 'Pointes de l\'au-delà',
      'Torment Unto Death': 'Brimade meurtrière',
      'Tsuki-No-Maiogi': 'Maiôgi lunaire',
      'Unmoving Troika': 'Troïka immobile',
      'Zashiki-Asobi': 'Zashiki asobi'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Dancing Fan': '舞扇',
      'Moonlight': '月光',
      'Specter(?! )': 'スペクター',
      'Specter Of The Empire': '帝国兵の幻影',
      'Specter Of The Matriarch': '養母の幻影',
      'Specter of Zenos': 'ゼノスの幻影',
      'Tsukuyomi': 'ツクヨミ'
    },
    'replaceText': {
      'Antitwilight': '月下美人',
      'Bright Blade': '月刀左近',
      'Concentrativity': '圧縮剣気',
      'Dance Of The Dead': '黄泉の舞',
      'Dark Blade': '月刀右近',
      'Dispersivity': '剣気波動',
      'Lead Of The Underworld': '黄泉の銃弾',
      'Lunacy': '月下繚乱',
      'Lunar Halo': '百月光',
      'Midnight Haze': '夜の煙',
      'Nightbloom': '月下彼岸花',
      'Nightfall': '宵の早替え',
      'Perilune': '月天心',
      'Reprimand': '折檻',
      'Selenomancy': '月読',
      'Steel Of The Underworld': '黄泉の穂先',
      'Torment Unto Death': 'なぶり殺し',
      'Tsuki-No-Maiogi': '月の舞扇',
      'Unmoving Troika': '不動三段',
      'Zashiki-Asobi': '座敷遊び'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Dancing Fan': '舞扇',
      'Moonlight': '月光',
      'Specter(?! )': '妖影',
      'Specter Of The Empire': '帝国兵的幻影',
      'Specter Of The Matriarch': '养母的幻影',
      'Specter of Zenos': '芝诺斯的幻影',
      'Tsukuyomi': '月读'
    },
    'replaceText': {
      'Adds': '小怪',
      'Antitwilight': '月下美人',
      'Bright Blade': '月刀左斩',
      'Concentrativity': '压缩剑气',
      'Dance Of The Dead': '黄泉之舞',
      'Dark Blade': '月刀右斩',
      'Dispersivity': '剑气波动',
      'Empire': '帝国',
      'Homeland': '家乡',
      'Lead Of The Underworld': '黄泉之弹',
      'Lunacy': '月下缭乱',
      'Lunar Halo': '百月光',
      'Midnight Haze': '夜烟',
      'Nightbloom': '月下彼岸花',
      'Nightfall': '深宵换装',
      'Perilune': '月天心',
      'Reprimand': '责难',
      'Selenomancy': '月读',
      'Steel Of The Underworld': '黄泉之枪',
      'Torment Unto Death': '折磨',
      'Tsuki-No-Maiogi': '月下舞扇',
      'Unmoving Troika': '不动三段',
      'Zashiki-Asobi': '宴会游乐'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Dancing Fan': '춤추는 부채',
      'Moonlight': '월광',
      'Specter(?! )': '그림자요괴',
      'Specter Of The Empire': '제국 병사의 환영',
      'Specter Of The Matriarch': '양어머니의 환영',
      'Specter of Zenos': '제노스의 환영',
      'Tsukuyomi': '츠쿠요미'
    },
    'replaceText': {
      '--Patriarch/Matriarch Adds--': '--양아버지/양어머니 등장--',
      '--Empire/Homeland Adds--': '--제국 병사/도마인 등장--',
      'Antitwilight': '월하미인',
      'Bright Blade': '하현달 베기',
      'Concentrativity': '압축 검기',
      'Dance Of The Dead': '황천의 춤',
      'Dark Blade': '상현달 베기',
      'Dispersivity': '검기 파동',
      'Lead Of The Underworld': '황천의 총탄',
      'Lunacy': '월하요란',
      'Lunar Halo': '백월광',
      'Midnight Haze': '밤의 연기',
      'Nightbloom': '달빛 저승꽃',
      'Nightfall': '밤의 옷차림',
      'Perilune': '중천의 달',
      'Reprimand': '절함',
      'Selenomancy': '달읽기',
      'Steel Of The Underworld': '황천의 창끝',
      'Torment Unto Death': '고문살인',
      'Tsuki-No-Maiogi': '춤추는 달 부채',
      'Unmoving Troika': '부동삼단',
      'Zashiki-Asobi': '유흥'
    }
  }]
};
/* harmony default export */ const tsukuyomi = (tsukuyomi_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/tsukuyomi.txt
const trial_tsukuyomi_namespaceObject = "### Tsukuyomi Normal\r\n# -p 2BE3:14.2 2CB0:504 2BFD:677.3\r\n# -it \"Tsukuyomi\" / -it \"Specter of Zenos\"\r\n# -ii 2BEA 2CAC 2CAD 2BCB 2CAE\r\n\r\nhideall \"--sync--\"\r\nhideall \"--Reset--\"\r\n\r\n### Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n10.2 \"--sync--\" StartsUsing { id: \"2BE3\", source: \"Tsukuyomi\" } window 20,20\r\n14.2 \"Torment Unto Death\" Ability { id: \"2BE3\", source: \"Tsukuyomi\" }\r\n24.3 \"Zashiki-Asobi\" Ability { id: \"2BEC\", source: \"Tsukuyomi\" }\r\n30.4 \"Nightfall\" Ability { id: \"2BE5\", source: \"Tsukuyomi\" }\r\n35.3 \"Tsuki-No-Maiogi\" duration 4 #Ability { id: \"2BED\", source: \"Dancing Fan\" }\r\n36.6 \"Steel Of The Underworld\" Ability { id: \"2BE7\", source: \"Tsukuyomi\" }\r\n39.8 \"--sync--\" Ability { id: \"2BC0\", source: \"Tsukuyomi\" }\r\n49.9 \"Reprimand\" Ability { id: \"2BE2\", source: \"Tsukuyomi\" }\r\n65.2 \"Midnight Haze 1\" Ability { id: \"2BE8\", source: \"Tsukuyomi\" }\r\n69.6 \"Midnight Haze 2\" Ability { id: \"2BE9\", source: \"Tsukuyomi\" }\r\n77.7 \"Nightfall\" Ability { id: \"2BE4\", source: \"Tsukuyomi\" }\r\n79.9 \"--sync--\" Ability { id: \"2CB1\", source: \"Tsukuyomi\" }\r\n85.0 \"Lead Of The Underworld\" Ability { id: \"2BE6\", source: \"Tsukuyomi\" }\r\n88.1 \"--sync--\" Ability { id: \"2CCF\", source: \"Tsukuyomi\" }\r\n107.0 \"Nightbloom\" Ability { id: \"2BEE\", source: \"Tsukuyomi\" } window 110,10\r\n108.0 \"--untargetable--\"\r\n\r\n\r\n### Phase 2: Adds\r\n127.8 \"--Patriarch/Matriarch Adds--\" AddedCombatant { name: \"Specter Of The Matriarch\" } window 30,10\r\n174.5 \"--Empire/Homeland Adds--\" AddedCombatant { name: \"Specter Of The Empire\" } window 80,10\r\n# TODO: Specter of Asahi shows up alone after all other adds are dead, so can't have a timeline entry.\r\n\r\n400.0 \"Concentrativity\" Ability { id: \"2BEF\", source: \"Specter of Zenos\" } window 400,0\r\n406.7 \"Unmoving Troika\" Ability { id: \"2CAB\", source: \"Specter of Zenos\" }\r\n413.6 \"--sync--\" Ability { id: \"2BCA\", source: \"Specter of Zenos\" }\r\n416.6 \"--targetable--\"\r\n423.7 \"Dispersivity\" Ability { id: \"2BF0\", source: \"Specter\" } window 40,40\r\n429.7 \"Dispersivity\" #Ability { id: \"2BF0\", source: \"Specter\" }\r\n435.7 \"Dispersivity\" #Ability { id: \"2BF0\", source: \"Specter\" }\r\n441.7 \"Dispersivity\" #Ability { id: \"2BF0\", source: \"Specter\" }\r\n447.7 \"Dispersivity\" #Ability { id: \"2BF0\", source: \"Specter\" }\r\n453.7 \"Dispersivity\" #Ability { id: \"2BF0\", source: \"Specter\" }\r\n\r\n\r\n### Phase 3: Selenomancy\r\n500.0 \"--sync--\" StartsUsing { id: \"2CB0\", source: \"Tsukuyomi\" } window 500,0\r\n504.0 \"Nightbloom\" Ability { id: \"2CB0\", source: \"Tsukuyomi\" }\r\n509.9 \"--targetable--\"\r\n524.4 \"Selenomancy\" Ability { id: \"2BF1\", source: \"Tsukuyomi\" }\r\n541.6 \"Nightfall\" Ability { id: \"2BE4\", source: \"Tsukuyomi\" }\r\n543.6 \"Lunar Halo\" Ability { id: \"2C73\", source: \"Moonlight\" }\r\n543.8 \"--sync--\" Ability { id: \"2CB1\", source: \"Tsukuyomi\" }\r\n549.0 \"Lead Of The Underworld\" Ability { id: \"2BE6\", source: \"Tsukuyomi\" }\r\n552.1 \"--sync--\" Ability { id: \"2CCF\", source: \"Tsukuyomi\" }\r\n565.3 \"Antitwilight\" Ability { id: \"2BF8\", source: \"Tsukuyomi\" }\r\n575.5 \"Torment Unto Death\" Ability { id: \"2BE3\", source: \"Tsukuyomi\" }\r\n582.7 \"Zashiki-Asobi\" Ability { id: \"2BEC\", source: \"Tsukuyomi\" }\r\n588.8 \"Nightfall\" Ability { id: \"2BE4\", source: \"Tsukuyomi\" }\r\n591.0 \"--sync--\" Ability { id: \"2CB1\", source: \"Tsukuyomi\" }\r\n593.7 \"Tsuki-No-Maiogi\" Ability { id: \"2BED\", source: \"Dancing Fan\" } duration 4\r\n596.2 \"Lead Of The Underworld\" Ability { id: \"2BE6\", source: \"Tsukuyomi\" }\r\n599.3 \"--sync--\" Ability { id: \"2CCF\", source: \"Tsukuyomi\" }\r\n611.5 \"Torment Unto Death\" Ability { id: \"2BE3\", source: \"Tsukuyomi\" }\r\n623.2 \"Selenomancy\" Ability { id: \"2BF1\", source: \"Tsukuyomi\" }\r\n630.5 \"Midnight Haze\" Ability { id: \"2BE8\", source: \"Tsukuyomi\" }\r\n635.0 \"Midnight Haze\" Ability { id: \"2BE9\", source: \"Tsukuyomi\" }\r\n643.1 \"Nightfall\" Ability { id: \"2BE5\", source: \"Tsukuyomi\" }\r\n649.3 \"Steel Of The Underworld\" Ability { id: \"2BE7\", source: \"Tsukuyomi\" }\r\n652.2 \"Lunar Halo\" Ability { id: \"2C73\", source: \"Moonlight\" }\r\n652.5 \"--sync--\" Ability { id: \"2BC0\", source: \"Tsukuyomi\" }\r\n667.7 \"Perilune\" Ability { id: \"2BF7\", source: \"Tsukuyomi\" }\r\n\r\n\r\n### Phase 4: Dance Of The Dead -> Bright/Dark Blade (hp push and timed)\r\n677.3 \"--sync--\" Ability { id: \"2BFD\", source: \"Tsukuyomi\" } window 700,50\r\n678.3 \"--sync--\" Ability { id: \"2D1F\", source: \"Tsukuyomi\" }\r\n683.2 \"Dance Of The Dead\" Ability { id: \"2E79\", source: \"Tsukuyomi\" }\r\n693.5 \"Lunacy x3\" Ability { id: \"2BFB\", source: \"Tsukuyomi\" }\r\n701.8 \"Bright Blade/Dark Blade\" Ability { id: [\"2BF9\", \"2BFA\"], source: \"Tsukuyomi\" }\r\n709.0 \"Reprimand\" Ability { id: \"2BE2\", source: \"Tsukuyomi\" }\r\n719.2 \"Bright Blade/Dark Blade\" Ability { id: [\"2BF9\", \"2BFA\"], source: \"Tsukuyomi\" }\r\n725.2 \"Tsuki-No-Maiogi\" Ability { id: \"2BED\", source: \"Dancing Fan\" } duration 4\r\n726.5 \"Lunacy x4\" Ability { id: \"2BFB\", source: \"Tsukuyomi\" }\r\n738.8 \"Reprimand\" Ability { id: \"2BE2\", source: \"Tsukuyomi\" }\r\n749.1 \"Torment Unto Death\" Ability { id: \"2EB3\", source: \"Tsukuyomi\" }\r\n758.2 \"Reprimand\" Ability { id: \"2BE2\", source: \"Tsukuyomi\" }\r\n759.0 \"Tsuki-No-Maiogi\" Ability { id: \"2BED\", source: \"Dancing Fan\" } duration 4\r\n763.4 \"Bright Blade/Dark Blade\" Ability { id: [\"2BF9\", \"2BFA\"], source: \"Tsukuyomi\" }\r\n770.6 \"Reprimand\" Ability { id: \"2BE2\", source: \"Tsukuyomi\" }\r\n780.7 \"Bright Blade/Dark Blade\" Ability { id: [\"2BF9\", \"2BFA\"], source: \"Tsukuyomi\" }\r\n786.7 \"Tsuki-No-Maiogi\" Ability { id: \"2BED\", source: \"Dancing Fan\" } duration 4\r\n788.1 \"Lunacy x5\" Ability { id: \"2BFB\", source: \"Tsukuyomi\" }\r\n801.5 \"Reprimand\" Ability { id: \"2BE2\", source: \"Tsukuyomi\" }\r\n\r\n# begin loop\r\n811.7 \"Torment Unto Death\" Ability { id: \"2EB3\", source: \"Tsukuyomi\" }\r\n820.8 \"Reprimand\" Ability { id: \"2BE2\", source: \"Tsukuyomi\" }\r\n821.7 \"Tsuki-No-Maiogi\" Ability { id: \"2BED\", source: \"Dancing Fan\" } duration 4\r\n826.1 \"Bright Blade/Dark Blade\" Ability { id: [\"2BF9\", \"2BFA\"], source: \"Tsukuyomi\" }\r\n833.2 \"Reprimand\" Ability { id: \"2BE2\", source: \"Tsukuyomi\" }\r\n843.4 \"Bright Blade/Dark Blade\" Ability { id: [\"2BF9\", \"2BFA\"], source: \"Tsukuyomi\" }\r\n849.4 \"Tsuki-No-Maiogi\" Ability { id: \"2BED\", source: \"Dancing Fan\" } duration 4\r\n850.7 \"Lunacy x5\" Ability { id: \"2BFB\", source: \"Tsukuyomi\" }\r\n864.1 \"Reprimand\" Ability { id: \"2BE2\", source: \"Tsukuyomi\" }\r\n\r\n# loop\r\n874.3 \"Torment Unto Death\" Ability { id: \"2EB3\", source: \"Tsukuyomi\" } window 50,50 jump 811.7\r\n883.4 \"Reprimand\" #Ability { id: \"2BE2\", source: \"Tsukuyomi\" }\r\n884.3 \"Tsuki-No-Maiogi\" #Ability { id: \"2BED\", source: \"Dancing Fan\" } duration 4\r\n888.7 \"Bright Blade/Dark Blade\" #Ability { id: [\"2BF9\", \"2BFA\"], source: \"Tsukuyomi\" }\r\n895.8 \"Reprimand\" #Ability { id: \"2BE2\", source: \"Tsukuyomi\" }\r\n906.0 \"Bright Blade/Dark Blade\" #Ability { id: [\"2BF9\", \"2BFA\"], source: \"Tsukuyomi\" }\r\n912.0 \"Tsuki-No-Maiogi\" #Ability { id: \"2BED\", source: \"Dancing Fan\" } duration 4\r\n913.3 \"Lunacy x5\" #Ability { id: \"2BFB\", source: \"Tsukuyomi\" }\r\n926.7 \"Reprimand\" #Ability { id: \"2BE2\", source: \"Tsukuyomi\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/yojimbo.ts



const yojimbo_triggerSet = {
  id: 'KuganeOhashi',
  zoneId: zone_id/* default.KuganeOhashi */.Z.KuganeOhashi,
  timelineFile: 'yojimbo.txt',
  triggers: [{
    id: 'Yojimbo Giga Jump',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Run Marker Away',
        de: 'Mit Marker weglaufen',
        fr: 'Fuyez avec le marqueur',
        ja: 'マーカーから離れる',
        cn: '远离点名',
        ko: '징 멀리 떨어뜨리기'
      }
    }
  }, {
    id: 'Yojimbo Dorito',
    type: 'HeadMarker',
    netRegex: {
      id: '0037'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.doritoStack */.n3.doritoStack()
  }, {
    id: 'Yojimbo Gekko',
    type: 'HeadMarker',
    netRegex: {
      id: '0090'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Gekko Marker',
        de: 'Gekko Marker',
        fr: 'Marqueur Gekkô',
        ja: '月光マーキング',
        cn: '月光点名',
        ko: '월광 징'
      }
    }
  }, {
    id: 'Yojimbo Enchain',
    type: 'HeadMarker',
    netRegex: {
      id: '0005'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.getOut */.n3.getOut()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Electrogenetic Force': 'Elektro-Kraft',
      'Embodiment': 'Gilgamesch-Doppelgänger',
      'Gilgamesh': 'Gilgamesch',
      'Inoshikacho': 'Ino-shika-cho',
      'Yojimbo': 'Yojinbo'
    },
    'replaceText': {
      'A Giant Me': 'Dann wirf mal \'nen Blick hinter uns!',
      'Ame-no-Murakumo': 'Ame no Murakumo',
      'Bitter End': 'Klingenschimmer',
      'Dragon Night': 'Drachennacht',
      'Dragon\'s Lair': 'Drachenhort',
      'Electrogenetic Force': 'Elektro-Kraft',
      'Enchain': 'Fesseln',
      'Epic Stormsplitter': 'Fließende Welt',
      'Gekko': 'Gekko',
      'Giga Jump': 'Giga-Sprung',
      'Hell\'s Gate': 'Höllentor',
      'Inoshikacho': 'Ino-shika-cho',
      'Kasha': 'Kasha',
      'Masamune': 'Masamune',
      'Metta-giri': 'Metta-giri',
      'Tiny Song': 'Liliputlied',
      'Unveiling': 'Enthüllung',
      'Wakizashi': 'Wakizashi',
      'Yukikaze': 'Yukikaze',
      'Zanma Zanmai': 'Zanma-zanmai'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Electrogenetic Force': 'Force électrogénétique',
      'Embodiment': 'double de Gilgamesh',
      'Gilgamesh': 'Gilgamesh',
      'Inoshikacho': 'Ino-shika-cho',
      'Yojimbo': 'Yojimbo'
    },
    'replaceText': {
      'A Giant Me': 'J\'ai toujours eu la folie des grandeurs',
      'Ame-no-Murakumo': 'Ame no Murakumo',
      'Bitter End': 'Éradication',
      'Dragon Night': 'Nuit du dragon',
      'Dragon\'s Lair': 'Fléau du dragon',
      'Electrogenetic Force': 'Force électrogénétique',
      'Enchain': 'Garrotage',
      'Epic Stormsplitter': 'Monde flottant',
      'Gekko': 'Gekkô',
      'Giga Jump': 'Giga saut',
      'Hell\'s Gate': 'Portes de l\'enfer',
      'Inoshikacho': 'Ino-shika-cho',
      'Kasha': 'Kasha',
      'Masamune': 'Masamune',
      'Metta-giri': 'Metta-giri',
      'Tiny Song': 'Air lilliputien',
      'Unveiling': 'Dévoilement',
      'Wakizashi': 'Wakizashi',
      'Yukikaze': 'Yukikaze',
      'Zanma Zanmai': 'Zanma zanmai'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Electrogenetic Force': '電撃',
      'Embodiment': 'ギルガメッシュの分身',
      'Gilgamesh': 'ギルガメッシュ',
      'Inoshikacho': '猪鹿蝶',
      'Yojimbo': 'ヨウジンボウ'
    },
    'replaceText': {
      'A Giant Me': '巨身の術',
      'Ame-no-Murakumo': 'アメノムラクモ',
      'Bitter End': 'ヒット・ジ・エンド',
      'Dragon Night': '竜星撃',
      'Dragon\'s Lair': '雲蒸竜変',
      'Electrogenetic Force': '電撃',
      'Enchain': '大捕物',
      'Epic Stormsplitter': '我流海嵐斬',
      'Gekko': '月光',
      'Giga Jump': 'ギガジャンプ',
      'Hell\'s Gate': '獄門',
      'Inoshikacho': '猪鹿蝶',
      'Kasha': '花車',
      'Masamune': 'マサムネ',
      'Metta-giri': '居合滅多斬り',
      'Tiny Song': '小さなメロディ',
      'Unveiling': '真ギルガメッシュチェンジ',
      'Wakizashi': '脇差',
      'Yukikaze': '雪風',
      'Zanma Zanmai': '斬魔三昧'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Electrogenetic Force': '电击',
      'Embodiment': '吉尔伽美什的分身',
      'Gilgamesh': '吉尔伽美什',
      'Inoshikacho': '猪鹿蝶',
      'Yojimbo': '保镖'
    },
    'replaceText': {
      'A Giant Me': '巨大化之术',
      'Ame-no-Murakumo': '天之丛云',
      'Bitter End': '命尽于此',
      'Dragon Night': '龙星击',
      'Dragon\'s Lair': '云蒸龙变',
      'Electrogenetic Force': '电击',
      'Enchain': '捕获',
      'Epic Stormsplitter': '我流破浪斩',
      'Gekko': '月光',
      'Giga Jump': '十亿跳跃',
      'Hell\'s Gate': '狱门',
      'Inoshikacho': '猪鹿蝶',
      'Kasha': '花车',
      'Masamune': '正宗',
      'Metta-giri': '居合多段斩',
      'Tiny Song': '缩小旋律',
      'Unveiling': '显露原形',
      'Wakizashi': '腰刀',
      'Yukikaze': '雪风',
      'Zanma Zanmai': '斩魔三昧'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Electrogenetic Force': '전류',
      'Embodiment': '길가메시의 분신',
      'Gilgamesh': '길가메시',
      'Inoshikacho': '멧돼지사슴나비',
      'Yojimbo': '요우진보'
    },
    'replaceText': {
      'A Giant Me': '거대 길가메시',
      'Ame-no-Murakumo': '아메노무라쿠모',
      'Bitter End': '끝장타',
      'Dragon Night': '용성격',
      'Dragon\'s Lair': '운증용변',
      'Electrogenetic Force': '전류',
      'Enchain': '사슬 묶기',
      'Epic Stormsplitter': '아류해풍참',
      'Gekko': '월광',
      'Giga Jump': '기가 점프',
      'Hell\'s Gate': '지옥문',
      'Inoshikacho': '멧돼지사슴나비',
      'Kasha': '화차',
      'Masamune': '마사무네',
      'Metta-giri': '거합 마구베기',
      'Tiny Song': '작은 멜로디',
      'Unveiling': '진 길가메시 변신',
      'Wakizashi': '소도',
      'Yukikaze': '설풍',
      'Zanma Zanmai': '참마삼매'
    }
  }]
};
/* harmony default export */ const yojimbo = (yojimbo_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/trial/yojimbo.txt
const trial_yojimbo_namespaceObject = "### Yojimbo (Kugane Ohashi)\r\n# -ii 383C 3831 384A 3849 3846 3847 3848 -p 383D:300\r\n\r\n### Mini-guide:\r\n#\r\n# Wakizashi: mini tank buster\r\n# Inoshikacho: butterfly summon that drop aoes\r\n# Metta-giri: raid aoe\r\n# Yukikaze: ice waffles\r\n# Gekko: initial markers for Kasha with aoe\r\n# Kasha: donut aoes from Gekko\r\n# Bitter End: frontal cleave\r\n# Dragon's Lair: summon dragons\r\n# Dragon Night: raidwide aoe\r\n# Tiny Song: dorito stack\r\n# Ame-no-Murakumo: susano-esque sword attack\r\n# Giga Jump: GA-100 proxmity head marker\r\n# Electrogenetic Force: lightning floor aoes\r\n# Enchain: distance-based gaols\r\n# Hell's Gate: gaol death\r\n# Masamune: line aoe\r\n# Zanma Zanmai: set to 1 hp\r\n# Epic Stormsplitter: line aoe that becomes a safe spot\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n6.4 \"Wakizashi\" Ability { id: \"3827\", source: \"Yojimbo\" } window 7,7\r\n14.5 \"Inoshikacho\" Ability { id: \"3829\", source: \"Yojimbo\" } duration 9.2\r\n23.7 \"--sync--\" Ability { id: \"382A\", source: \"Inoshikacho\" }\r\n28.8 \"Metta-giri\" Ability { id: \"3828\", source: \"Yojimbo\" }\r\n32.0 \"--untargetable--\" Ability { id: \"382B\", source: \"Yojimbo\" }\r\n37.2 \"--sync--\" Ability { id: \"382C\", source: \"Yojimbo\" }\r\n44.0 \"Unveiling\" Ability { id: \"382D\", source: \"Yojimbo\" }\r\n55.6 \"--sync--\" Ability { id: \"382F\", source: \"Yojimbo\" }\r\n58.5 \"Yukikaze\" #Ability { id: \"3832\", source: \"Yojimbo\" }\r\n59.6 \"--sync--\" Ability { id: \"3830\", source: \"Yojimbo\" }\r\n62.1 \"Yukikaze\" #Ability { id: \"3832\", source: \"Yojimbo\" }\r\n63.7 \"Gekko\" Ability { id: \"3833\", source: \"Yojimbo\" }\r\n67.7 \"Kasha\" Ability { id: \"3834\", source: \"Gilgamesh\" }\r\n73.7 \"Bitter End\" Ability { id: \"31DE\", source: \"Yojimbo\" }\r\n84.2 \"Tiny Song\" Ability { id: \"3835\", source: \"Yojimbo\" }\r\n88.8 \"Dragon's Lair\" Ability { id: \"3836\", source: \"Yojimbo\" }\r\n97.4 \"Bitter End\" Ability { id: \"382E\", source: \"Yojimbo\" }\r\n103.8 \"Bitter End\" Ability { id: \"382E\", source: \"Yojimbo\" }\r\n106.8 \"Dragon Night\" Ability { id: \"3838\", source: \"Yojimbo\" }\r\n123.2 \"Tiny Song\" Ability { id: \"3835\", source: \"Yojimbo\" }\r\n128.8 \"--sync--\" Ability { id: \"382F\", source: \"Yojimbo\" }\r\n131.8 \"Yukikaze\" #Ability { id: \"3832\", source: \"Yojimbo\" }\r\n132.9 \"--sync--\" Ability { id: \"3830\", source: \"Yojimbo\" }\r\n135.4 \"Yukikaze\" #Ability { id: \"3832\", source: \"Yojimbo\" }\r\n136.9 \"Gekko\" Ability { id: \"3833\", source: \"Yojimbo\" }\r\n141.0 \"Kasha\" Ability { id: \"3834\", source: \"Gilgamesh\" }\r\n\r\n147.1 \"Bitter End\" Ability { id: \"382E\", source: \"Yojimbo\" }\r\n151.5 \"Bitter End\" Ability { id: \"382E\", source: \"Yojimbo\" }\r\n\r\n# \"\"\"Adds\"\"\" phase\r\n157.3 \"--untargetable--\"\r\n# starts 100 seconds of gauge\r\n157.7 \"--sync--\" Ability { id: \"383A\", source: \"Yojimbo\" } window 200,200\r\n161.2 \"Giga Jump\" Ability { id: \"383B\", source: \"Embodiment\" }\r\n164.0 \"--targetable--\"\r\n\r\n169.6 \"Bitter End\" #Ability { id: \"382E\", source: \"Embodiment\" }\r\n175.1 \"Bitter End\" #Ability { id: \"382E\", source: \"Embodiment\" }\r\n175.3 \"A Giant Me\" Ability { id: \"3830\", source: \"Embodiment\" }\r\n179.3 \"Gekko\" Ability { id: \"3833\", source: \"Yojimbo\" }\r\n182.4 \"Bitter End\" #Ability { id: \"382E\", source: \"Embodiment\" }\r\n183.4 \"Kasha\" Ability { id: \"3834\", source: \"Gilgamesh\" }\r\n187.5 \"Bitter End\" #Ability { id: \"382E\", source: \"Embodiment\" }\r\n198.9 \"Kasha\" Ability { id: \"3834\", source: \"Yojimbo\" }\r\n203.2 \"Gekko\" Ability { id: \"3833\", source: \"Yojimbo\" }\r\n206.0 \"Bitter End\" #Ability { id: \"382E\", source: \"Embodiment\" }\r\n210.3 \"Bitter End\" #Ability { id: \"382E\", source: \"Embodiment\" }\r\n223.7 \"Bitter End\" #Ability { id: \"382E\", source: \"Embodiment\" }\r\n229.1 \"Bitter End\" #Ability { id: \"382E\", source: \"Embodiment\" }\r\n# ???\r\n\r\n296.0 \"--sync--\" StartsUsing { id: \"383D\", source: \"Gilgamesh\" } window 100,0\r\n300.0 \"Ame-no-Murakumo\" Ability { id: \"383D\", source: \"Gilgamesh\" } window 300,300\r\n316.4 \"Giga Jump\" Ability { id: \"383E\", source: \"Yojimbo\" } # drift -0.048\r\n316.4 \"--targetable--\"\r\n319.0 \"Electrogenetic Force\" Ability { id: \"383F\", source: \"Yojimbo\" } duration 9.6\r\n328.6 \"--sync--\" Ability { id: \"3840\", source: \"Electrogenetic Force\" }\r\n338.6 \"Enchain\" Ability { id: \"3841\", source: \"Yojimbo\" }\r\n361.1 \"Hell's Gate\" Ability { id: \"3842\", source: \"Yojimbo\" }\r\n\r\n# final loop\r\n374.5 \"Masamune\" Ability { id: \"3843\", source: \"Yojimbo\" }\r\n380.4 \"Zanma Zanmai\" Ability { id: \"3844\", source: \"Yojimbo\" }\r\n388.0 \"Epic Stormsplitter\" Ability { id: \"3845\", source: \"Yojimbo\" }\r\n396.5 \"Dragon's Lair\" Ability { id: \"3836\", source: \"Yojimbo\" }\r\n399.0 \"Electrogenetic Force\" Ability { id: \"383F\", source: \"Yojimbo\" } duration 9.6\r\n408.7 \"--sync--\" Ability { id: \"3840\", source: \"Electrogenetic Force\" }\r\n414.5 \"Dragon Night\" Ability { id: \"3838\", source: \"Yojimbo\" }\r\n416.6 \"Bitter End\" Ability { id: \"382E\", source: \"Yojimbo\" }\r\n422.0 \"Bitter End\" Ability { id: \"382E\", source: \"Yojimbo\" }\r\n\r\n430.0 \"Yukikaze\" #Ability { id: \"3832\", source: \"Yojimbo\" }\r\n433.5 \"--sync--\" Ability { id: \"382F\", source: \"Yojimbo\" }\r\n436.5 \"Yukikaze\" #Ability { id: \"3832\", source: \"Yojimbo\" }\r\n437.6 \"--sync--\" Ability { id: \"3830\", source: \"Yojimbo\" }\r\n441.6 \"Gekko\" Ability { id: \"3833\", source: \"Yojimbo\" }\r\n445.7 \"Kasha\" Ability { id: \"3834\", source: \"Gilgamesh\" }\r\n445.8 \"Dragon's Lair\" Ability { id: \"3836\", source: \"Yojimbo\" }\r\n456.5 \"Tiny Song\" Ability { id: \"3835\", source: \"Yojimbo\" }\r\n463.8 \"Dragon Night\" Ability { id: \"3838\", source: \"Yojimbo\" }\r\n469.1 \"Bitter End\" Ability { id: \"382E\", source: \"Yojimbo\" }\r\n\r\n474.4 \"--sync--\" Ability { id: \"382F\", source: \"Yojimbo\" }\r\n477.4 \"Yukikaze\" Ability { id: \"3832\", source: \"Yojimbo\" }\r\n478.5 \"--sync--\" Ability { id: \"3830\", source: \"Yojimbo\" }\r\n480.9 \"Yukikaze\" Ability { id: \"3832\", source: \"Yojimbo\" }\r\n482.5 \"Gekko\" Ability { id: \"3833\", source: \"Yojimbo\" }\r\n486.6 \"Kasha\" Ability { id: \"3834\", source: \"Gilgamesh\" }\r\n489.8 \"Bitter End\" Ability { id: \"382E\", source: \"Yojimbo\" }\r\n\r\n# fake loop lookahead\r\n505.0 \"Masamune\" Ability { id: \"3843\", source: \"Yojimbo\" } window 40,40 jump 374.5\r\n510.9 \"Zanma Zanmai\"\r\n518.5 \"Epic Stormsplitter\"\r\n527.0 \"Dragon's Lair\"\r\n529.5 \"Electrogenetic Force\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/ultimate/ultima_weapon_ultimate.ts






// Note: without extra network data that is not exposed, it seems impossible to know where Titan
// looks briefly before jumping for Geocrush. A getCombatants trigger on NameToggle 00 was
// extremely inaccurate and so that is likely too late to know.
const centerX = 100;
const centerY = 100;
const gaolConfig = id => {
  // Since these are all explicit string types, get the number from the string.
  const numStr = id.replace('gaolOrder', '');
  return {
    id: id,
    name: {
      en: `Titan Gaol Order ${numStr}`,
      de: `Titan Gefängnis Reihenfolge ${numStr}`,
      fr: `Ordre geôle de Titan ${numStr}`,
      cn: `泰坦石牢顺序 ${numStr}`,
      ko: `돌감옥 순서 ${numStr}`
    },
    type: 'string',
    default: ''
  };
};

// Ultima Weapon Ultimate
const ultima_weapon_ultimate_triggerSet = {
  id: 'TheWeaponsRefrainUltimate',
  zoneId: zone_id/* default.TheWeaponsRefrainUltimate */.Z.TheWeaponsRefrainUltimate,
  config: [
  // Yes yes, a textarea would be nice here to put everything on separate lines,
  // but OverlayPlugin does not seem to support delivering the enter key and
  // so there's no way to have one box with names on separate lines.  Sorry!
  /* eslint-disable max-len */
  {
    ...gaolConfig('gaolOrder1'),
    comment: {
      en: 'Each entry can be the three letter job (e.g. "war" or "SGE") or the full name (e.g. "Tini Poutini"), all case insensitive. Smaller numbers will be listed first in the gaol order. Duplicate jobs will sort players alphabetically. Anybody not listed will be added to the end alphabetically. Blank entries are ignored. If players are listed multiple times by name or job, the lower number will be considered.',
      de: 'Jeder Eintrag kann aus drei Buchstaben des Jobs bestehen (z. B. "war" oder "SGE") oder aus dem vollständigen Namen (z. B. "Tini Poutini"), wobei Groß- und Kleinschreibung nicht berücksichtigt werden. Kleinere Nummern werden in der Reihenfolge der Gefängnisse zuerst aufgeführt. Bei doppelten Aufträgen werden die Spieler alphabetisch sortiert. Jeder nicht aufgeführte Spieler wird am Ende alphabetisch eingeordnet. Leere Einträge werden ignoriert. Wenn Spieler mehrfach nach Namen oder Beruf aufgelistet sind, wird die niedrigere Nummer berücksichtigt.',
      fr: 'Chaque entrée peut être désigné par les jobs en trois lettres (par exemple "war" ou "SGE") ou le nom complet (par exemple "Tini Poutini"), sans tenir compte des majuscules et minuscules. Les plus petits numéros seront classés en premier dans l\'ordre des geôles. Les doublons seront classés par ordre alphabétique. Toute personne ne figurant pas sur la liste sera ajoutée à la fin par ordre alphabétique. Les entrées vides sont ignorées. Si des joueurs sont listés plusieurs fois par nom ou par fonction, le numéro le plus bas sera pris en compte.',
      cn: '每个条目可以是三个字母的职业缩写 (例如 "war" 或  "SGE") 或玩家全名（例如 "Tini Poutini"），所有字母不区分大小写。编号较小的将在石牢顺序中排列在前。重复的职业将按姓名字母顺序对玩家进行排序。未列出的队员将按字母顺序添加到末尾。空白条目将被忽略。如果玩家按姓名或职业被多次列出，则以较小编号为准。',
      ko: '각 항목에는 대소문자를 구분하지 않는 세 글자 직업명(예: "war" 또는 "SGE") 또는 전체 이름(예: "빛의전사")을 입력할 수 있습니다. 먼저 입력된 항목이 감옥 순서에서 먼저 나열됩니다. 직업이 중복된 경우에는  알파벳 순(가나다 순)으로 나타납니다. 목록에 없는 사람은 알파벳 순으로 맨 끝에 추가됩니다. 빈 칸은 무시됩니다. 플레이어가 이름 또는 직업별로 여러 번 나열된 경우, 먼저 입력된 항목이 사용됩니다.'
    }
  }, gaolConfig('gaolOrder2'), gaolConfig('gaolOrder3'), gaolConfig('gaolOrder4'), gaolConfig('gaolOrder5'), gaolConfig('gaolOrder6'), gaolConfig('gaolOrder7'), gaolConfig('gaolOrder8'), gaolConfig('gaolOrder9'), gaolConfig('gaolOrder10'), gaolConfig('gaolOrder11'), gaolConfig('gaolOrder12'), gaolConfig('gaolOrder13'), gaolConfig('gaolOrder14'), gaolConfig('gaolOrder15'), gaolConfig('gaolOrder16'), gaolConfig('gaolOrder17'), gaolConfig('gaolOrder18'), gaolConfig('gaolOrder19'), gaolConfig('gaolOrder20')
  /* eslint-enable max-len */],

  timelineFile: 'ultima_weapon_ultimate.txt',
  initData: () => {
    return {
      combatantData: [],
      phase: 'garuda',
      bossId: {},
      garudaAwoken: false,
      ifritAwoken: false,
      thermalLow: {},
      beyondLimits: new Set(),
      slipstreamCount: 0,
      nailAdds: [],
      nailDeaths: {},
      nailDeathOrder: [],
      ifritUntargetableCount: 0,
      titanGaols: [],
      titanBury: [],
      ifritRadiantPlumeLocations: [],
      possibleIfritIDs: []
    };
  },
  timelineTriggers: [{
    id: 'UWU Diffractive Laser',
    regex: /Diffractive Laser/,
    beforeSeconds: 5,
    suppressSeconds: 3,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'UWU Feather Rain',
    regex: /Feather Rain/,
    beforeSeconds: 3,
    suppressSeconds: 3,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move!',
        de: 'Bewegen',
        fr: 'Bougez !',
        ja: 'フェザーレイン',
        cn: '躲羽毛',
        ko: '이동'
      }
    }
  }, {
    id: 'UWU Eruption',
    regex: /Eruption 1/,
    beforeSeconds: 10,
    condition: data => data.phase !== 'suppression',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Eruption Baits',
        de: 'Köder Eruption',
        fr: 'Attirez les éruptions',
        cn: '诱导地火',
        ko: '용암 분출 유도'
      }
    }
  }],
  triggers: [
  // --------- Phases & Buff Tracking ----------
  {
    id: 'UWU Phase Tracker',
    type: 'Ability',
    // 2B53 = Slipstream
    // 2B5F = Crimson Cyclone
    // 2CFD = Geocrush
    // 2CF5 = Intermission
    // 2B87 = Tank Purge
    // 2D4C = Ultimate Annihilation
    // 2D4D = Ultimate Suppression
    netRegex: {
      id: ['2B53', '2B5F', '2CFD', '2CF5', '2B87', '2D4C', '2D4D']
    },
    run: (data, matches) => {
      if (data.phase === 'garuda' && matches.id === '2B53') {
        data.bossId.garuda = matches.sourceId;
      } else if (data.phase === 'garuda' && matches.id === '2B5F') {
        data.phase = 'ifrit';
        data.bossId.ifrit = matches.sourceId;
      } else if (data.phase === 'ifrit' && matches.id === '2CFD') {
        data.phase = 'titan';
        data.bossId.titan = matches.sourceId;
      } else if (data.phase === 'titan' && matches.id === '2CF5') {
        data.phase = 'intermission';
      } else if (data.phase === 'intermission' && matches.id === '2B87') {
        data.phase = 'predation';
        data.bossId.ultima = matches.sourceId;
      } else if (matches.id === '2D4C') {
        data.phase = 'annihilation';
      } else if (matches.id === '2D4D') {
        data.phase = 'suppression';
      }
    }
  }, {
    // Wait after suppression for primal triggers at the end.
    id: 'UWU Phase Tracker Finale',
    type: 'Ability',
    netRegex: {
      source: 'The Ultima Weapon',
      id: '2D4D',
      capture: false
    },
    delaySeconds: 74,
    run: data => data.phase = 'finale'
  }, {
    id: 'UWU Garuda Woken',
    type: 'GainsEffect',
    netRegex: {
      target: 'Garuda',
      effectId: '5F9',
      capture: false
    },
    sound: 'Long',
    run: data => data.garudaAwoken = true
  }, {
    id: 'UWU Ifrit Woken',
    type: 'GainsEffect',
    netRegex: {
      target: 'Ifrit',
      effectId: '5F9',
      capture: false
    },
    sound: 'Long',
    run: data => data.ifritAwoken = true
  }, {
    id: 'UWU Titan Woken',
    type: 'GainsEffect',
    netRegex: {
      target: 'Titan',
      effectId: '5F9',
      capture: false
    },
    sound: 'Long'
  }, {
    id: 'UWU Thermal Low Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '5F5'
    },
    run: (data, matches) => data.thermalLow[matches.target] = parseInt(matches.count)
  }, {
    id: 'UWU Thermal Low Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '5F5'
    },
    run: (data, matches) => data.thermalLow[matches.target] = 0
  }, {
    id: 'UWU Beyond Limits Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '5FA'
    },
    run: (data, matches) => data.beyondLimits.add(matches.target)
  }, {
    id: 'UWU Beyond Limits Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '5FA'
    },
    run: (data, matches) => data.beyondLimits.delete(matches.target)
  },
  // --------- Garuda ----------
  {
    id: 'UWU Garuda Slipstream',
    type: 'StartsUsing',
    netRegex: {
      id: '2B53',
      source: 'Garuda',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind(),
    run: data => data.slipstreamCount++
  }, {
    id: 'UWU Garuda Downburst',
    // This always comes after a Slipstream so use that to trigger.
    // There is no castbar and the ability ids are the same.
    type: 'Ability',
    netRegex: {
      id: '2B53',
      source: 'Garuda',
      capture: false
    },
    delaySeconds: data => data.slipstreamCount === 4 ? 10 : 0,
    suppressSeconds: 3,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        // TODO: we could track who Garuda is tanking here and say "on you" or "stack on"
        tankCleave: outputs/* default.tankCleave */.Z.tankCleave,
        partyStack: outputs/* default.stackMarker */.Z.stackMarker,
        tankCleavePartyOut: {
          en: 'Tank Cleave (PARTY OUT)',
          de: 'Tank Cleave (GRUPPE RAUS)',
          fr: 'Tank cleave (Groupe à l\'extérieur)',
          cn: '坦克顺劈 (人群出)',
          ko: '광역 탱버 (본대 밖으로)'
        }
      };
      if (data.slipstreamCount === 1 || data.slipstreamCount > 4) return;

      // You need to have awoken Garuda by this point to beat the fight, but if you haven't
      // and are just progging it's easy to forget that this is not a party share.
      // This is also mostly skipped these days.
      if (!data.garudaAwoken && data.slipstreamCount === 4) return {
        alarmText: output.tankCleavePartyOut()
      };
      if (data.garudaAwoken) return {
        alertText: output.partyStack()
      };
      return {
        infoText: output.tankCleave()
      };
    }
  }, {
    id: 'UWU Garuda Mistral Song Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0010'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mistral on YOU',
        de: 'Mistral-Song',
        fr: 'Mistral sur VOUS',
        ja: 'ミストラルソング',
        cn: '寒风之歌点名',
        ko: '삭풍 징'
      }
    }
  }, {
    id: 'UWU Garuda Mistral Song Tank',
    type: 'HeadMarker',
    netRegex: {
      id: '0010',
      capture: false
    },
    condition: data => data.role === 'tank',
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Block Mistral Song',
        de: 'Mistral-Song',
        fr: 'Chant du mistral',
        ja: 'ミストラルソング',
        cn: '寒风之歌',
        ko: '삭풍 징'
      }
    }
  }, {
    id: 'UWU Garuda Spiny Plume',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Spiny Plume',
      capture: false
    },
    condition: data => data.role === 'tank',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spiny Plume Add',
        de: 'Dorniger Federsturm',
        fr: 'Add Plume perforante',
        ja: 'スパイニープルーム',
        cn: '刺羽出现',
        ko: '가시돋힌 깃털 등장'
      }
    }
  }, {
    id: 'UWU Garuda Wicked Wheel',
    type: 'StartsUsing',
    netRegex: {
      id: '2B4E',
      source: 'Garuda',
      capture: false
    },
    condition: data => data.phase === 'garuda',
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        unawokenOut: outputs/* default.out */.Z.out,
        awokenOutThenIn: outputs/* default.outThenIn */.Z.outThenIn
      };
      if (data.garudaAwoken) return {
        alertText: output.awokenOutThenIn()
      };
      return {
        infoText: output.unawokenOut()
      };
    }
  }, {
    id: 'UWU Garuda Aerial Blast',
    type: 'StartsUsing',
    netRegex: {
      id: '2B55',
      source: 'Garuda',
      capture: false
    },
    condition: data => data.phase === 'garuda',
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'UWU Garuda Sisters Location',
    comment: {
      en: 'Where the two sisters are for the tanks to block. dir1 is always the first sister location starting North and going clockwise',
      de: 'Wo sich die beiden Schwestern befinden, die die Tanks blockieren sollen. dir1 ist immer die erste Schwester, die im Norden beginnt und im Uhrzeigersinn verläuft.',
      fr: 'L\'emplacement des deux sœurs à bloquer pour les tanks. dir1 est toujours le premier emplacement de la sœur en commençant par le nord et en allant dans le sens des aiguilles d\'une montre.',
      cn: '两分身待坦克阻挡的位置。dir1 始终是从上 (北) 开始顺时针方向的第一个分身位置',
      ko: '탱커가 막을 두 분신의 위치. dir1은 북쪽에서 시계방향으로 도는 것을 기준으로 항상 첫 번째 분신의 위치입니다'
    },
    type: 'StartsUsing',
    netRegex: {
      id: '2B55',
      source: 'Garuda',
      capture: false
    },
    /*
    [21:13:53.626] StartsCasting 14:400188D4:Garuda:2B55:Aerial Blast:400188D4:Garuda:2.700:100.00:100.00:0.00:0.00
    [21:13:56.607] AOEActionEffect 16:400188D4:Garuda:2B55:Aerial Blast:XXXXXXXX:Tiny Poutini:350003:1F560000:1B:2B558000:0:0:0:0:0:0:0:0:0:0:0:0:22867:25795:10000:10000:::100.33:97.62:0.00:0.01:693098:1664845:34464:10000:::100.00:100.00:0.00:0.00:0000D57F:7:8
    [21:14:07.587] 261 105:Change:400188CC:Heading:0.0000:PosX:94.0000:PosY:100.0000:PosZ:0.0000
    [21:14:07.587] 261 105:Change:400188CB:Heading:0.0000:PosX:106.0000:PosY:100.0000:PosZ:0.0000
    [21:14:11.772] StartsCasting 14:400188C6:Garuda:2B4D:Feather Rain:E0000000::0.700:101.06:101.93:0.00:0.00
    [21:14:11.772] StartsCasting 14:400188C7:Garuda:2B4D:Feather Rain:E0000000::0.700:101.30:101.74:0.00:0.00
    [21:14:11.772] StartsCasting 14:400188C8:Garuda:2B4D:Feather Rain:E0000000::0.700:100.79:102.21:0.00:0.00
    [21:14:11.772] StartsCasting 14:400188C9:Garuda:2B4D:Feather Rain:E0000000::0.700:100.50:101.45:0.00:0.00
    [21:14:11.772] StartsCasting 14:400188CA:Garuda:2B4D:Feather Rain:E0000000::0.700:100.80:102.30:0.00:0.00
    [21:14:11.969] 261 105:Change:400188CB:Heading:0.0000:ModelStatus:16384:PosX:100.0000:PosY:80.5000:PosZ:0.0000
    [21:14:11.969] 261 105:Change:400188CC:Heading:3.1416:ModelStatus:16384:PosX:100.0000:PosY:119.5000:PosZ:0.0000
    [21:14:14.448] TargetIcon 1B:XXXXXXXX:Tiny Poutini:0000:0000:0010:0000:0000:0000
    */
    condition: data => data.phase === 'garuda',
    delaySeconds: 19,
    promise: async data => {
      data.combatantData = [];

      // TODO: it'd be nice if this function allowed filtering by name ids.
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants'
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      // These two sisters are added before the pull starts,
      // but they are the only two with these names.
      // 1645 = Suparna
      // 1646 = Chirada
      const sisters = data.combatantData.filter(x => x.BNpcNameID === 1645 || x.BNpcNameID === 1646);
      const [dir1, dir2] = sisters.map(c => util/* Directions.xyTo4DirNum */.N.xyTo4DirNum(c.PosX, c.PosY, centerX, centerY)).sort();
      if (dir1 === undefined || dir2 === undefined || sisters.length !== 2) return;
      const map = {
        0: output.dirN(),
        1: output.dirE(),
        2: output.dirS(),
        3: output.dirW()
      };
      return output.text({
        dir1: map[dir1],
        dir2: map[dir2]
      });
    },
    outputStrings: {
      text: {
        en: 'Sisters: ${dir1} / ${dir2}',
        de: 'Schwestern: ${dir1} / ${dir2}',
        fr: 'Sœurs : ${dir1} / ${dir2}',
        cn: '分身：${dir1} / ${dir2}',
        ko: '분신: ${dir1} / ${dir2}'
      },
      // TODO: the lint fails if you `...Directions.outputStringsCardinalDir` :C
      dirN: outputs/* default.dirN */.Z.dirN,
      dirE: outputs/* default.dirE */.Z.dirE,
      dirS: outputs/* default.dirS */.Z.dirS,
      dirW: outputs/* default.dirW */.Z.dirW
    }
  }, {
    id: 'UWU Ultima Mesohigh Tether',
    type: 'Tether',
    // This happens in Garuda, as well in Annihilation and Suppression.
    netRegex: {
      id: '0004',
      capture: false
    },
    suppressSeconds: 30,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        // The person with two stacks must get a tether.
        garuda2: {
          en: 'Get Sister Tether!!!',
          de: 'Nimm Verbindung von der Schwester!!!',
          fr: 'Prenez le lien de la sœur !!!',
          cn: '接分身的线!!!',
          ko: '분신 줄 가져가기!!!'
        },
        // Other people with 1 stack can be informed about it.
        garuda1: {
          en: 'Sister Tethers',
          de: 'Schwester Verbindungen',
          fr: 'Lien de la sœur',
          cn: '分身连线',
          ko: '분신 줄'
        },
        // Usually static on a ranged.
        annihilation1: {
          en: 'Tether',
          de: 'Verbindungen',
          fr: 'Lien',
          cn: '连线',
          ko: '줄'
        },
        // Late in the raid, so make sure anybody with a stack remembers this.
        suppression1: {
          en: 'Tether!!!',
          de: 'Verbindungen!!!',
          fr: 'Lien !!!',
          cn: '连线!!!',
          ko: '줄!!!'
        }
      };
      const myStacks = data.thermalLow[data.me];
      if (myStacks === undefined || myStacks === 0) return;
      if (myStacks === 2) {
        if (data.phase === 'garuda' && !data.garudaAwoken) return {
          alarmText: output.garuda2()
        };
        return;
      }
      if (data.phase === 'garuda') return {
        alertText: output.garuda1()
      };
      if (data.phase === 'annihilation') return {
        infoText: output.annihilation1()
      };
      if (data.phase === 'suppression') return {
        alarmText: output.suppression1()
      };
    }
  },
  // --------- Ifrit ----------
  {
    id: 'UWU Ifrit Possible ID Locator',
    type: 'StartsUsing',
    netRegex: {
      id: '2B55',
      source: 'Garuda',
      capture: false
    },
    // Run this after the initial Garuda trigger and just piggyback off its call to `getCombatants`
    // We're just looking to pluck the four possible IDs from the array pre-emptively to avoid doing
    // that filter on every `CombatantMemory` line
    delaySeconds: 25,
    run: data => {
      data.possibleIfritIDs = data.combatantData.filter(c => c.BNpcNameID === 0x4A1).map(c => c.ID?.toString(16).toUpperCase() ?? '');
    }
  }, {
    id: 'UWU Ifrit Initial Dash Collector',
    type: 'CombatantMemory',
    // Filter to only enemy actors for performance
    netRegex: {
      id: '4[0-9A-Fa-f]{7}',
      capture: true
    },
    condition: (data, matches) => {
      if (!data.possibleIfritIDs.includes(matches.id)) return false;
      const posXVal = parseFloat(matches.pairPosX ?? '0');
      const posYVal = parseFloat(matches.pairPosY ?? '0');
      if (posXVal === 0 || posYVal === 0) return false;

      // If the Ifrit actor has jumped to exactly 19.5 out on a cardinal, that's our dash spot
      if (Math.abs(posXVal - 100) - 19.5 < Number.EPSILON || Math.abs(posYVal - 100) - 19.5 < Number.EPSILON) return true;
      return false;
    },
    suppressSeconds: 9999,
    infoText: (data, matches, output) => {
      const posXVal = parseFloat(matches.pairPosX ?? '0');
      const posYVal = parseFloat(matches.pairPosY ?? '0');
      let ifritDir = 'unknown';

      // Flag both sides that ifrit is dashing through as unsafe, while also tracking where he's actually
      // jumped to so we can use it for the infoText
      if (posXVal < 95) {
        data.ifritRadiantPlumeLocations.push('dirW', 'dirE');
        ifritDir = 'dirW';
      } else if (posXVal > 105) {
        data.ifritRadiantPlumeLocations.push('dirW', 'dirE');
        ifritDir = 'dirE';
      } else if (posYVal < 95) {
        data.ifritRadiantPlumeLocations.push('dirN', 'dirS');
        ifritDir = 'dirN';
      } else if (posYVal > 105) {
        data.ifritRadiantPlumeLocations.push('dirN', 'dirS');
        ifritDir = 'dirS';
      }

      // Remove duplicates
      data.ifritRadiantPlumeLocations = data.ifritRadiantPlumeLocations.filter((pos, index) => data.ifritRadiantPlumeLocations.indexOf(pos) === index);
      return output.text({
        dir: output[ifritDir]()
      });
    },
    outputStrings: {
      text: {
        en: 'Ifrit ${dir}',
        de: 'Ifrit ${dir}',
        fr: 'Ifrit ${dir}',
        cn: '火神 ${dir}',
        ko: '이프리트 ${dir}'
      },
      unknown: outputs/* default.unknown */.Z.unknown,
      ...util/* Directions.outputStringsCardinalDir */.N.outputStringsCardinalDir
    }
  }, {
    id: 'UWU Ifrit Initial Radiant Plume Collector',
    type: 'StartsUsingExtra',
    netRegex: {
      id: '2B61'
    },
    condition: (data, matches) => {
      const posXVal = parseFloat(matches.x);
      const posYVal = parseFloat(matches.y);

      // Possible plume locations:
      // 100.009, 106.998
      // 100.009, 118.015  = south
      // 100.009, 92.990
      // 100.009, 82.003   = north
      // 106.998, 100.009
      // 110.996, 110.996
      // 110.996, 88.992
      // 118.015, 100.009  = east
      // 82.003,  100.009  = west
      // 88.992,  110.996
      // 88.992,  88.992
      // 92.990,  100.009

      if (Math.abs(posXVal - 100) < 1) {
        if (Math.abs(posYVal - 83) < 1) {
          // North unsafe
          data.ifritRadiantPlumeLocations.push('dirN');
        } else if (Math.abs(posYVal - 118) < 1) {
          // South unsafe
          data.ifritRadiantPlumeLocations.push('dirS');
        }
      } else if (Math.abs(posYVal - 100) < 1) {
        if (Math.abs(posXVal - 83) < 1) {
          // West unsafe
          data.ifritRadiantPlumeLocations.push('dirW');
        } else if (Math.abs(posXVal - 118) < 1) {
          // East unsafe
          data.ifritRadiantPlumeLocations.push('dirE');
        }
      }

      // Remove duplicates
      data.ifritRadiantPlumeLocations = data.ifritRadiantPlumeLocations.filter((pos, index) => data.ifritRadiantPlumeLocations.indexOf(pos) === index);

      // 3 danger spots means we only have one safe spot left
      return data.ifritRadiantPlumeLocations.length === 3;
    },
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (data.ifritRadiantPlumeLocations.length < 3) return;
      const safeDir = util/* Directions.outputCardinalDir.filter */.N.outputCardinalDir.filter(dir => !data.ifritRadiantPlumeLocations.includes(dir))[0];
      return output[safeDir ?? 'unknown']();
    },
    outputStrings: {
      unknown: outputs/* default.unknown */.Z.unknown,
      ...util/* Directions.outputStringsCardinalDir */.N.outputStringsCardinalDir
    }
  }, {
    id: 'UWU Ifrit Vulcan Burst',
    type: 'StartsUsing',
    netRegex: {
      id: '25B7',
      source: 'Ifrit',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'UWU Ifrit Nail Adds',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '1186',
      npcBaseId: '8731'
    },
    condition: (data, matches) => {
      data.nailAdds.push(matches);
      return data.nailAdds.length === 4;
    },
    alertText: (data, _matches, output) => {
      // Nails are always on cardinals and intercardinals.
      // The back two nails are always 135 degrees apart and the front two are 45 degrees apart,
      // and the front and back nails are 90 degrees apart from each other. Thus, you can figure
      // out the orientation based on relative positions from the origin.
      //
      // One possible example of directions:
      // 0 = back right
      // 3 = back left
      // 5 = front left
      // 6 = front right
      const dirs = data.nailAdds.map(m => {
        return util/* Directions.addedCombatantPosTo8Dir */.N.addedCombatantPosTo8Dir(m, centerX, centerY);
      }).sort();
      for (let i = 0; i < dirs.length; ++i) {
        const this8Dir = dirs[i];
        const next8Dir = dirs[(i + 1) % dirs.length];
        if (this8Dir === undefined || next8Dir === undefined) break;
        // The two close nails are 45 degrees apart.
        if (next8Dir - this8Dir === 1 || this8Dir - next8Dir === 7) {
          const between16Dir = this8Dir * 2 + 1;
          const outputKey = util/* Directions.output16Dir */.N.output16Dir[between16Dir] ?? 'unknown';
          return output.text({
            dir: output[outputKey]()
          });
        }
      }
    },
    outputStrings: {
      text: {
        en: 'Near: ${dir}',
        de: 'Nahe: ${dir}',
        fr: 'Proche : ${dir}',
        cn: '近: ${dir}',
        ko: '가까운 기둥: ${dir}'
      },
      ...util/* Directions.outputStrings16Dir */.N.outputStrings16Dir
    }
  }, {
    id: 'UWU Ifrit Nail Deaths',
    type: 'Ability',
    netRegex: {
      id: '2B58'
    },
    condition: (data, matches) => {
      if (data.nailDeaths[matches.sourceId] === undefined) {
        data.nailDeaths[matches.sourceId] = matches;
        data.nailDeathOrder.push(matches.sourceId);
      }
      return data.nailDeathOrder.length === 4;
    },
    suppressSeconds: 999999,
    run: data => {
      // No need to check awoken status here, we'll just look for the status effect later.
      const idToDir = {};

      // lastDir is an 8-value direction but modulo 4.
      let lastDir;
      let lastRotationDir;
      for (const key of data.nailDeathOrder) {
        const m = data.nailDeaths[key];
        if (m === undefined) return;
        const x = parseFloat(m.x);
        const y = parseFloat(m.y);
        // Since dashes go through one direction and its opposite, map to N/NE/E/SE zone.
        // Consider a valid kill order to be sequential in either direction.
        // Most people do Z or reverse Z, but there's many valid orders (e.g. bowtie/fish).
        const this8Dir = util/* Directions.xyTo8DirNum */.N.xyTo8DirNum(x, y, centerX, centerY);
        idToDir[m.sourceId] = this8Dir;
        const thisDir = this8Dir % 4;
        if (lastDir === undefined) {
          lastDir = thisDir;
          continue;
        }
        const isCW = thisDir - lastDir === 1 || lastDir - thisDir === 3;
        const isCCW = lastDir - thisDir === 1 || thisDir - lastDir === 3;
        const thisRotationDir = isCW ? 'cw' : isCCW ? 'ccw' : undefined;
        lastDir = thisDir;

        // Invalid nail kill order.
        if (thisRotationDir === undefined) return;
        if (lastRotationDir === undefined) {
          lastRotationDir = thisRotationDir;
          continue;
        }
        // Invalid nail kill order.
        if (thisRotationDir !== lastRotationDir) return;
      }
      const firstNailId = data.nailDeathOrder[0];
      const lastNailId = data.nailDeathOrder[3];
      data.nailDeathRotationDir = lastRotationDir;
      if (firstNailId !== undefined) data.nailDeathFirst8Dir = idToDir[firstNailId];
      if (lastNailId !== undefined) data.nailDeathLast8Dir = idToDir[lastNailId];
    }
  }, {
    id: 'UWU Ifrit Fetters',
    type: 'Tether',
    // This is GainsEffect effectId 179 as well applied to each player
    // but reapplied when the count changes due to distance.
    netRegex: {
      id: '0009'
    },
    condition: (data, matches) => matches.target === data.me || matches.source === data.me,
    infoText: (data, matches, output) => {
      const otherPlayer = matches.target === data.me ? matches.source : matches.target;
      return output.fetters({
        player: data.party.member(otherPlayer)
      });
    },
    outputStrings: {
      fetters: {
        en: 'Fetters (w/${player})',
        de: 'Fesseln (mit ${player})',
        fr: 'Entraves (avec ${player})',
        cn: '锁链 (与 /${player})',
        ko: '사슬 (+${player})'
      }
    }
  }, {
    id: 'UWU Ifrit Searing Wind',
    type: 'StartsUsing',
    netRegex: {
      id: '2B5B',
      source: 'Ifrit'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Searing Wind on YOU',
        de: 'Versengen auf DIR',
        fr: 'Carbonisation sur VOUS',
        ja: '自分に灼熱',
        cn: '灼热咆哮点名',
        ko: '작열 대상자'
      }
    }
  }, {
    id: 'UWU Ifrit Hellfire',
    type: 'StartsUsing',
    netRegex: {
      id: '2B5E',
      source: 'Ifrit',
      capture: false
    },
    condition: data => data.phase === 'ifrit',
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'UWU Ifrit Name Toggle Counter',
    type: 'NameToggle',
    netRegex: {
      name: 'Ifrit',
      toggle: '00',
      capture: false
    },
    run: data => data.ifritUntargetableCount++
  }, {
    id: 'UWU Ifrit Dash Safe Spot 1',
    // TODO: we could add a config option for the other set of safe spots, as it's also
    // valid to go SW/NE instead of SE/NW for the first dashes. It would just change
    // the adjust call.
    comment: {
      en: `If the first nail is SE, this will call SE/NW for both reverse-Z and normal-Z.
             If the first nail is S, this will call SE/NW for reverse-Z and SW/NE for normal-Z.
             Other nail orders are also supported, these are just examples.`,
      de: `Wenn der erste Nagel SO ist, wird dies SO/NW sowohl für Umgekehrtes-Z als auch für Normal-Z aufgerufen.
             Wenn der erste Nagel S ist, wird dies SO/NW für Umgekehrtes-Z und SW/NO für Normal-Z aufgerufen.
             Andere Nagelreihenfolgen werden ebenfalls unterstützt, dies sind nur Beispiele.`,
      fr: `Si le premier clou est SE, on annoncera SE/NO pour les Z inversés et les Z normaux.
             Si le premier clou est S, on annoncera SE/NO pour la zone inversée et SW/NO pour la zone normale.
             D'autres ordres de clous sont également possibles, il ne s'agit que d'exemples.`,
      cn: `如果第一个火神柱在东南，则反向 Z 和正常 Z 都会提示东南/西北
             如果第一个火神柱在南, 则反向 Z 将提示东南/西北，正常 Z 将提示西南/东北。
             这些只是示例, 还支持其他火神柱顺序。`,
      ko: `첫 번째 기둥이 남동쪽인 경우, 역방향 Z와 일반 Z 모두에 대해 남동/북서를 호출합니다.
             첫 번째 기둥이 남쪽인 경우, 역방향 Z는 남동/북서를, 일반 Z는 남서/북동를 호출합니다.
             다른 기둥 순서도 지원되며, 이는 예시일 뿐입니다.`
    },
    type: 'NameToggle',
    netRegex: {
      name: 'Ifrit',
      toggle: '00',
      capture: false
    },
    condition: data => data.ifritUntargetableCount === 1,
    durationSeconds: 5,
    alertText: (data, _matches, output) => {
      const firstNailDir = data.nailDeathFirst8Dir;
      const rotationType = data.nailDeathRotationDir;
      if (firstNailDir === undefined || rotationType === undefined) return;
      const oppositeRotation = rotationType === 'cw' ? 7 : 1;
      const isIntercard = firstNailDir % 2 === 1;

      // For the first jump, we need to end on an intercard.
      // If we're already on an intercard, just stop there. IMO, it's better to have the first
      // Ifrit jump directly on the party where it's obvious which way you need to adjusut.
      // For the second jump, the first Ifrit jumps directly on the first nail location,
      // if that's not an intercard, initial start is good, otherwise party needs to rotate 45
      // in the opposite direction they will be rotating to avoid dashes.
      const dir1 = isIntercard ? firstNailDir : (firstNailDir + oppositeRotation) % 8;
      const dir2 = (dir1 + 4) % 8;
      const dir1Str = output[util/* Directions.outputFrom8DirNum */.N.outputFrom8DirNum(dir1)]();
      const dir2Str = output[util/* Directions.outputFrom8DirNum */.N.outputFrom8DirNum(dir2)]();
      return output.intercardSafeSpot({
        dir1: dir1Str,
        dir2: dir2Str
      });
    },
    outputStrings: {
      intercardSafeSpot: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      },
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  }, {
    id: 'UWU Ifrit Dash Safe Spot 2 Adjust',
    comment: {
      en: `If the first nail was on an intercard, then the first Ifrit dash is on an intercard
             and this optional call is to move to be adjacent to that first dash.
             If you are already safe, this will not be called.`,
      de: `Wenn der erste Nagel Interkardinal war, dann ist der erste Ifrit-Ansturm auf einer Interkardinalen
             und dieser optionale Aufruf besteht darin, sich in die Nähe dieses ersten Ansturms zu bewegen.
             Wenn man bereits in Sicherheit ist, wird dies nicht aufgerufen.`,
      fr: `Si le premier clou était en intercardinal, alors le premier dash d'Ifrit est en intercardinal
             et cette annonce optionnelle vous préviens de vous déplacer pour être adjacent à ce premier dash.
             Si vous êtes déjà en sécurité, cette option n'est pas activée.`,
      cn: `如果第一个火神柱在对角线上，那么第一次火神冲也在对角线上。
             这个可选提示会提示你移动到第一次火神冲附近的位置。
             如果你已在安全区，则不会输出此提示。`,
      ko: `첫 번째 기둥이 대각선에 있으면 첫 번째 이프리트 돌진도 대각선에 있으며,
             이 알람은 첫 번째 돌진 옆으로 이동하라는 것이 됩니다.
             이미 안전하다면 이 알람은 호출되지 않습니다.`
    },
    type: 'NameToggle',
    netRegex: {
      name: 'Ifrit',
      toggle: '00',
      capture: false
    },
    // Unfortunately no way to know for sure if Ifrit dies before dashes.
    condition: data => data.ifritUntargetableCount === 2 && data.ifritAwoken,
    infoText: (data, _matches, output) => {
      const firstNailDir = data.nailDeathFirst8Dir;
      const rotationType = data.nailDeathRotationDir;
      if (firstNailDir === undefined || rotationType === undefined) return;

      // If we didn't start on an intercard, then we are already safe.
      const isIntercard = firstNailDir % 2 === 1;
      if (!isIntercard) return;

      // Adjust the opposite direction of rotation, e.g. we are rotating clockwise
      // and Ifrit hops on the party SE, the party needs to go to E to rotate into
      // the first Ifrit at SE.
      const dirStr = rotationType === 'cw' ? output.counterclockwise() : output.clockwise();
      return output.text({
        rotation: dirStr
      });
    },
    outputStrings: {
      text: {
        en: 'Adjust 45° ${rotation}',
        de: 'Rotiere 45° ${rotation}',
        fr: 'Ajustez de 45° ${rotation}',
        cn: '${rotation} 旋转 45°',
        ko: '${rotation} 45° 이동'
      },
      clockwise: outputs/* default.clockwise */.Z.clockwise,
      counterclockwise: outputs/* default.counterclockwise */.Z.counterclockwise
    }
  }, {
    id: 'UWU Ifrit Dash Safe Spot 2',
    comment: {
      en: `This is the major movement for the Ifrit dashes starting adjacent to the first dash.
             Both the party and the healer will move either 45 or 90 degrees.
             It is a "fast" movement if you need to move fast to avoid the Ifrit follow-up dash.
             It is a "slow" movement if you have extra time to do this.`,
      de: `Dies ist die Hauptbewegung für die Ifrit-Anstürme, die in der Nähe des ersten Ansturms beginnt.
             Sowohl die Gruppe als auch der Heiler bewegen sich entweder um 45 oder 90 Grad.
             Es ist eine "schnelle" Bewegung, wenn man sich schnell bewegen muss, um dem Ifrit-Folgeschlag auszuweichen.
             Es ist eine "langsame" Bewegung, wenn man mehr Zeit hat, dies zu tun.`,
      fr: `Il s'agit du mouvement principal pour les dashs d'Ifrit qui commencent à côté du premier dash.
             Le groupe et le soigneur se déplacent de 45 ou 90 degrés.
             Il s'agit d'un mouvement "rapide" si vous devez vous déplacer rapidement pour éviter le dash suivant d'Ifrit.
             Il s'agit d'un mouvement "lent" si vous avez plus de temps pour le faire.`,
      cn: `这是从第一次火神冲附近开始的火神冲主要移动。
             人群和奶妈都将移动 45 度或 90 度。
             "快" 可以让你快速移动，躲避第二次火神冲。
             "慢" 当你有足够的时间来移动时使用。`,
      ko: `첫 번째 돌진 직후부터 시작되는 이프리트 돌진의 주요 동선입니다.
             본대와 힐러 모두 45도 또는 90도로 움직입니다.
             이프리트의 후속 돌진을 피하기 위해 빠르게 이동해야 하는 경우 "빠른" 이동입니다.
             시간적 여유가 있다면 "느린" 이동입니다.`
    },
    type: 'NameToggle',
    netRegex: {
      name: 'Ifrit',
      toggle: '00',
      capture: false
    },
    condition: data => data.ifritUntargetableCount === 2 && data.ifritAwoken,
    // Here's one log file example for this timing.
    // [20:38:36.510] NameToggle 22:40017C12:Ifrit:40017C12:Ifrit:00
    // [20:38:38.245] 261 105:Change:40017C12:Heading:2.3562:PosX:86.3000:PosY:113.7000:PosZ:0.0000
    // [20:38:40.919] StartsCasting 14:40017C0F:Ifrit:2B5F:Crimson Cyclone:40017C0F:Ifrit:2.700:113.70:113.70:0.00:-2.36
    // [20:38:42.343] StartsCasting 14:40017C11:Ifrit:2B5F:Crimson Cyclone:40017C11:Ifrit:2.700:100.00:80.50:0.00:0.00
    // [20:38:43.725] StartsCasting 14:40017C12:Ifrit:2B5F:Crimson Cyclone:40017C12:Ifrit:2.700:86.30:113.70:0.00:2.36
    // [20:38:45.152] StartsCasting 14:40017C10:Ifrit:2B5F:Crimson Cyclone:40017C10:Ifrit:2.700:80.50:100.00:0.00:1.57
    delaySeconds: 2.5,
    promise: async data => {
      data.combatantData = [];
      if (data.bossId.ifrit === undefined) return;

      // The real Ifrit is the one that is Awoken so find where he is.
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(data.bossId.ifrit, 16)]
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      // If killed before dashes occur, and geocrush has started casting, suppress this.
      if (data.phase === 'titan') return;
      const [combatant] = data.combatantData;
      if (combatant === undefined || data.combatantData.length !== 1) return;
      const firstNailDir = data.nailDeathFirst8Dir;
      const rotationType = data.nailDeathRotationDir;
      if (firstNailDir === undefined || rotationType === undefined) return;
      const oppositeRotationDir = rotationType === 'cw' ? -1 : 1;
      const rotationDir = rotationType === 'cw' ? 1 : -1;
      const startDir = (firstNailDir + oppositeRotationDir + 8) % 8;
      const ifritDir = util/* Directions.combatantStatePosTo8Dir */.N.combatantStatePosTo8Dir(combatant, centerX, centerY);
      for (let i = 1; i <= 4; ++i) {
        const dashDir = (startDir + i * rotationDir + 8) % 8;
        if (dashDir % 4 !== ifritDir % 4) continue;

        // If Ifrit is the first or third dash, we rotate 45 degrees, otherwise 90.
        const finalRotation = i === 1 || i === 3 ? rotationDir : rotationDir * 2;
        const finalDir = (startDir + finalRotation + 8) % 8;
        const finalDirStr = output[util/* Directions.outputFrom8DirNum */.N.outputFrom8DirNum(finalDir)]();
        const rotation = rotationType === 'cw' ? output.clockwise() : output.counterclockwise();
        if (i === 1) return output.awokenDash1({
          rotation: rotation,
          dir: finalDirStr
        });
        if (i === 2) return output.awokenDash2({
          rotation: rotation,
          dir: finalDirStr
        });
        if (i === 3) return output.awokenDash3({
          rotation: rotation,
          dir: finalDirStr
        });
        if (i === 4) return output.awokenDash4({
          rotation: rotation,
          dir: finalDirStr
        });
      }
    },
    outputStrings: {
      awokenDash1: {
        en: '${rotation} 45° to ${dir} (fast)',
        de: '${rotation} 45° nach ${dir} (schnell)',
        fr: '${rotation} 45° vers ${dir} (rapide)',
        cn: '${rotation} 45° 到 ${dir} (快)',
        ko: '${rotation} 45° ${dir}까지 (빠름)'
      },
      awokenDash2: {
        en: '${rotation} 90° to ${dir} (fast)',
        de: '${rotation} 90° nach ${dir} (schnell)',
        fr: '${rotation} 90° vers ${dir} (rapide)',
        cn: '${rotation} 90° 到 ${dir} (快)',
        ko: '${rotation} 90° ${dir}까지 (빠름)'
      },
      awokenDash3: {
        en: '${rotation} 45° to ${dir} (slow)',
        de: '${rotation} 45° nach ${dir} (langsam)',
        fr: '${rotation} 45° vers ${dir} (lent)',
        cn: '${rotation} 45° 到 ${dir} (慢)',
        ko: '${rotation} 45° ${dir}까지 (느림)'
      },
      awokenDash4: {
        en: '${rotation} 90° to ${dir} (slow)',
        de: '${rotation} 90° nach ${dir} (langsam)',
        fr: '${rotation} 90° vers ${dir} (lent)',
        cn: '${rotation} 90° 到 ${dir} (慢)',
        ko: '${rotation} 90° ${dir}까지 (느림)'
      },
      clockwise: outputs/* default.clockwise */.Z.clockwise,
      counterclockwise: outputs/* default.counterclockwise */.Z.counterclockwise,
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  }, {
    id: 'UWU Ifrit Flaming Crush',
    type: 'HeadMarker',
    netRegex: {
      id: '0075',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack',
        de: 'Stack',
        fr: 'Packez-vous',
        ja: '頭割り',
        cn: '集合',
        ko: '집합'
      }
    }
  },
  // --------- Titan ----------
  {
    id: 'UWU Titan Bury Direction',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '1803'
    },
    condition: (data, matches) => {
      (data.titanBury ??= []).push(matches);
      return data.titanBury.length === 5;
    },
    alertText: (data, _matches, output) => {
      const bombs = (data.titanBury ?? []).map(matches => {
        return {
          x: parseFloat(matches.x),
          y: parseFloat(matches.y)
        };
      });
      if (bombs.length !== 5) {
        console.error(`Titan Bury: wrong bombs size: ${JSON.stringify(data.titanBury)}`);
        return;
      }
      // 5 bombs drop, and then a 6th later.
      // They all drop on one half of the arena, and then 3 on one half and 2 on the other.
      // e.g. all 5 drop on north half, 3 on west half, 2 on east half.
      const numDir = [0, 0, 0, 0]; // north, east, south, west
      for (const bomb of bombs) {
        if (bomb.y < centerY) numDir[0]++;else numDir[2]++;
        if (bomb.x < centerX) numDir[3]++;else numDir[1]++;
      }
      for (let idx = 0; idx < numDir.length; ++idx) {
        if (numDir[idx] !== 5) continue;
        // Example: dir is 1 (east), party is west, facing west.
        // We need to check dir 0 (north, aka "right") and dir 2 (south, aka "left").
        const numLeft = numDir[(idx + 1) % 4] ?? -1;
        const numRight = numDir[(idx - 1 + 4) % 4] ?? -1;
        if (numRight === 2 && numLeft === 3) return output.right();
        if (numRight === 3 && numLeft === 2) return output.left();
        console.error(`Titan Bury: bad counts: ${JSON.stringify(data.titanBury)}, ${idx}, ${numLeft}, ${numRight}`);
        return;
      }
      console.error(`Titan Bury: failed to find dir: ${JSON.stringify(data.titanBury)}`);
    },
    outputStrings: {
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'UWU Titan Gaols',
    type: 'Ability',
    netRegex: {
      id: ['2B6C', '2B6B'],
      source: ['Garuda', 'Titan']
    },
    condition: data => !data.seenTitanGaols,
    preRun: (data, matches) => {
      data.titanGaols.push(matches.target);
      if (data.titanGaols.length !== 3) return;
      const rawGaolOrder = [data.triggerSetConfig.gaolOrder1, data.triggerSetConfig.gaolOrder2, data.triggerSetConfig.gaolOrder3, data.triggerSetConfig.gaolOrder4, data.triggerSetConfig.gaolOrder5, data.triggerSetConfig.gaolOrder6, data.triggerSetConfig.gaolOrder7, data.triggerSetConfig.gaolOrder8, data.triggerSetConfig.gaolOrder9, data.triggerSetConfig.gaolOrder10, data.triggerSetConfig.gaolOrder11, data.triggerSetConfig.gaolOrder12, data.triggerSetConfig.gaolOrder13, data.triggerSetConfig.gaolOrder14, data.triggerSetConfig.gaolOrder15, data.triggerSetConfig.gaolOrder16, data.triggerSetConfig.gaolOrder17, data.triggerSetConfig.gaolOrder18, data.triggerSetConfig.gaolOrder19, data.triggerSetConfig.gaolOrder20].map(x => x.trim()).filter(x => x !== '');
      const partyNames = [...data.party.partyNames].sort((a, b) => a.localeCompare(b));

      // Merge jobs and names into a single list of names.
      const gaolOrder = [];
      for (const entry of rawGaolOrder) {
        if (entry.length !== 3) {
          gaolOrder.push(entry.toLocaleLowerCase());
          continue;
        }
        const uppercaseJobEntry = entry.toUpperCase();
        for (const name of partyNames) {
          const jobStr = data.party.jobName(name);
          if (jobStr === uppercaseJobEntry) gaolOrder.push(name.toLocaleLowerCase());
        }
      }
      data.titanGaols.sort((a, b) => {
        // Sort by `gaolOrder` and then alphabetical for names not in the list.
        const aIdx = gaolOrder.indexOf(a.toLocaleLowerCase());
        const bIdx = gaolOrder.indexOf(b.toLocaleLowerCase());
        if (aIdx === -1 && bIdx !== -1) return 1;
        if (bIdx === -1 && aIdx !== -1) return -1;
        if (aIdx < bIdx) return -1;
        if (bIdx < aIdx) return 1;
        return a.localeCompare(b);
      });
      if (data.options.Debug) {
        console.log(`GAOL CONFIG: ${JSON.stringify(rawGaolOrder)}`);
        console.log(`GAOL CONFIG NAME ORDER: ${JSON.stringify(gaolOrder)}`);
        console.log(`GAOL FINAL ORDER: ${JSON.stringify(data.titanGaols)}`);
      }
    },
    alertText: (data, _matches, output) => {
      if (data.titanGaols.length !== 3) return;
      const idx = data.titanGaols.indexOf(data.me);
      if (idx < 0) return;
      // Just return your number.
      return output[`num${idx + 1}`]();
    },
    infoText: (data, _matches, output) => {
      if (data.titanGaols.length !== 3) return;
      return output.text({
        player1: data.party.member(data.titanGaols[0]),
        player2: data.party.member(data.titanGaols[1]),
        player3: data.party.member(data.titanGaols[2])
      });
    },
    outputStrings: {
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      text: {
        en: '${player1}, ${player2}, ${player3}',
        de: '${player1}, ${player2}, ${player3}',
        fr: '${player1}, ${player2}, ${player3}',
        ja: '${player1}, ${player2}, ${player3}',
        cn: '${player1}, ${player2}, ${player3}',
        ko: '${player1}, ${player2}, ${player3}'
      }
    }
  }, {
    // If anybody dies to bombs (WHY) and a rock is on them, then glhf.
    id: 'UWU Titan Bomb Failure',
    type: 'Ability',
    netRegex: {
      id: '2B6A',
      source: 'Bomb Boulder'
    },
    condition: data => !data.seenTitanGaols,
    alarmText: (data, matches, output) => {
      const idx = data.titanGaols.indexOf(matches.target);
      if (idx === -1) return;
      const numStr = output[`num${idx + 1}`]();
      return output.text({
        num: numStr,
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      // In case people want to replace 1/2/3 with front/mid/back or something.
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      text: {
        en: 'Everyone to ${num} (${player} died)',
        de: 'Alle zur ${num} (${player} ist gestorben)',
        fr: 'Tout le monde sur ${num} (${player} est mort)',
        cn: '所有人到 ${num} (${player}死亡)',
        ko: '전부다 ${num} 쪽으로 (${player} 죽음)'
      }
    }
  }, {
    id: 'UWU Titan Gaol Granite Impact',
    type: 'StartsUsing',
    netRegex: {
      id: '2B6D',
      capture: false
    },
    // Prevent Titan Bomb Failure from happening later in the phase.
    run: data => data.seenTitanGaols = true
  },
  // --------- Intermission ----------
  {
    id: 'UWU Caster LB',
    type: 'AddedCombatant',
    // 2137 = Magitek Bit
    netRegex: {
      npcNameId: '2137',
      capture: false
    },
    condition: data => util/* default.isCasterDpsJob */.Z.isCasterDpsJob(data.job) && data.beyondLimits.has(data.me) && data.phase === 'intermission',
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Caster LB NOW!',
        de: 'Magier LB JETZT!',
        fr: 'LB MAINTENANT !',
        cn: '法系LB!',
        ko: '캐스터 리밋!'
      }
    }
  }, {
    id: 'UWU Healer LB',
    type: 'Ability',
    // 2B73 = Blight
    netRegex: {
      id: '2B73',
      source: 'Lahabrea',
      capture: false
    },
    condition: data => util/* default.isHealerJob */.Z.isHealerJob(data.job) && data.beyondLimits.has(data.me),
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Healer LB NOW!',
        de: 'Heiler LB JETZT!',
        fr: 'Healer LB MAINTENANT !',
        cn: '奶妈LB!',
        ko: '힐러 리밋!'
      }
    }
  }, {
    id: 'UWU Melee LB',
    type: 'StartsUsing',
    // 2B74 = Dark IV
    netRegex: {
      id: '2B74',
      source: 'Lahabrea',
      capture: false
    },
    condition: data => util/* default.isMeleeDpsJob */.Z.isMeleeDpsJob(data.job) && data.beyondLimits.has(data.me),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Melee LB NOW!',
        de: 'Nahkämpfer LB JETZT!',
        fr: 'LB melee MAINTENANT !',
        cn: '近战LB!',
        ko: '근딜 리밋!'
      }
    }
  }, {
    id: 'UWU Ultima',
    type: 'StartsUsing',
    netRegex: {
      id: '2B8B',
      capture: false
    },
    condition: data => data.role === 'tank',
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank LB NOW',
        de: 'JETZT Tank LB',
        fr: 'LB Tank MAINTENANT !',
        ja: '今タンクLB',
        cn: '坦克LB',
        ko: '탱리밋'
      }
    }
  },
  // --------- Predation ----------
  {
    id: 'UWU Predation',
    comment: {
      en: '"early safe" here means that you can move before the first Ifrit dash.',
      de: '"früh sicher" bedeutet hier, dass man such auch schon for dem ersten Ifrit Dash bewegen kann.',
      fr: '"sûr avant" veut dire que vous pouvez bouger avant le dash d\'Ifrit.',
      cn: '这里的 "提前安全" 指你可以在伊弗利特第一次冲锋前移动。',
      ko: '여기서 "안전"이란 첫 이프리트 돌진 전에 미리 가 있어도 된다는 의미입니다.'
    },
    type: 'StartsUsing',
    netRegex: {
      id: '2B76',
      source: 'The Ultima Weapon',
      capture: false
    },
    // [21:55:41.426] StartsCasting 14:4000BB88:The Ultima Weapon:2B76:Ultimate Predation:4000BB88:The Ultima Weapon:2.700:99.99:89.98:0.00:3.14
    // [21:55:44.404] ActionEffect 15:4000BB88:The Ultima Weapon:2B76:Ultimate Predation:4000BB88:The Ultima Weapon:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:3215688:3746181:0:10000:::99.99:89.98:0.00:3.14:3215688:3746181:0:10000:::99.99:89.98:0.00:3.14:0000A459:0:1
    // [21:55:48.850] NameToggle 22:4000BB88:The Ultima Weapon:4000BB88:The Ultima Weapon:00
    // [21:55:50.500] 261 105:Change:4000BB8E:Heading:-2.3563:PosX:103.0000:PosY:103.0000:PosZ:0.0000
    // [21:55:50.500] 261 105:Change:4000BB89:Heading:-1.5709:PosX:117.0000:PosY:97.0000:PosZ:0.0000
    // [21:55:50.500] 261 105:Change:4000BB8D:Heading:-2.3563:PosX:113.7000:PosY:113.7000:PosZ:0.0000
    // [21:55:50.500] 261 105:Change:4000BB88:Heading:2.3562:PosX:88.0000:PosY:112.0000:PosZ:0.0000
    // [21:55:56.229] StartsCasting 14:4000BB8D:Ifrit:2B5F:Crimson Cyclone:4000BB8D:Ifrit:2.700:113.70:113.70:0.00:-2.36
    delaySeconds: 10,
    durationSeconds: 5,
    promise: async data => {
      data.combatantData = [];
      const hexIds = Object.values(data.bossId);
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: hexIds.map(x => parseInt(x, 16))
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      const findBoss = key => {
        const hexId = data.bossId[key];
        if (hexId === undefined) return undefined;
        const decId = parseInt(hexId, 16);
        return data.combatantData.find(x => x.ID === decId);
      };
      const garuda = findBoss('garuda');
      const ifrit = findBoss('ifrit');
      const titan = findBoss('titan');
      const ultima = findBoss('ultima');
      if (garuda === undefined || ifrit === undefined || titan === undefined || ultima === undefined) return;

      // Garuda always at +/- 3 from center on an intercardinal.
      const garudaDir = util/* Directions.xyTo8DirNum */.N.xyTo8DirNum(garuda.PosX, garuda.PosY, centerX, centerY);
      if (garudaDir % 2 === 0) return;

      // e.g. Garuda is NW (7), the two safe directions are E (2) and S (4).
      let safeDir = [(garudaDir + 3) % 8, (garudaDir + 5) % 8];

      // Titan appears slightly offset from a cardinal. Never run out towards Titan.
      // TODO: Titan is slightly offset and you could theoretically pick a slightly
      // safer cardinal in some cases (I think?) depending on how landslides aim from there.
      const titanDir = util/* Directions.xyTo8DirNum */.N.xyTo8DirNum(titan.PosX, titan.PosY, centerX, centerY);
      safeDir = safeDir.filter(x => x !== titanDir);

      // Ultima appears on an intercardinal. If Ultima is adjacent to only one of the safe spots,
      // then pick the other safe spot because it will have more safe directions to run 2nd.
      const ultimaDir = util/* Directions.xyTo8DirNum */.N.xyTo8DirNum(ultima.PosX, ultima.PosY, centerX, centerY);
      const notAdjacentToUltima = safeDir.filter(x => {
        const isAdjacentToUltima = x === (ultimaDir + 1) % 8 || ultimaDir === (x + 1) % 8;
        return !isAdjacentToUltima;
      });
      // If there's at least one cardinal not next to Ultima, pick one of those.
      if (notAdjacentToUltima.length !== 0) safeDir = safeDir.filter(x => notAdjacentToUltima.includes(x));

      // Ifrit always is on an intercard and dashes through it.
      const ifritDir = util/* Directions.xyTo8DirNum */.N.xyTo8DirNum(ifrit.PosX, ifrit.PosY, centerX, centerY);
      const dirStrMap = {
        0: output.dirN(),
        2: output.dirE(),
        4: output.dirS(),
        6: output.dirW()
      };

      // (1) Do any of our safe spots have an early safe spot where you could
      // go stand on the wall immediately?
      for (const dir of safeDir) {
        for (const run of [-1, 1]) {
          const final = (dir + run + 8) % 8;
          if (final === ultimaDir) continue;
          // Will Ifrit dash through this or the opposite side?
          if (final % 4 === ifritDir % 4) continue;
          const rotation = run === -1 ? output.counterclockwise() : output.clockwise();
          return output.early({
            dir: dirStrMap[dir],
            rotation: rotation
          });
        }
      }

      // (2) Are any safe spots opposite of Garuda (and not by Ultima)?
      const garudaOpposite = (garudaDir + 4) % 8;
      for (const dir of safeDir) {
        for (const run of [-1, 1]) {
          const final = (dir + run + 8) % 8;
          if (final === ultimaDir) continue;
          if (final !== garudaOpposite) continue;
          const rotation = run === -1 ? output.counterclockwise() : output.clockwise();
          return output.normal({
            dir: dirStrMap[dir],
            rotation: rotation
          });
        }
      }

      // (3) Otherwise, just pick any safe spot and direction away from Ultima.
      for (const dir of safeDir) {
        for (const run of [-1, 1]) {
          // If both directions were safe from Ultima, we would have found an early spot,
          // since one of them would be safe from Ifrit as well. So, not possible to
          // say "either direction" here, so just pick the first safe direction.
          const final = (dir + run + 8) % 8;
          if (final === ultimaDir) continue;
          const rotation = run === -1 ? output.counterclockwise() : output.clockwise();
          return output.normal({
            dir: dirStrMap[dir],
            rotation: rotation
          });
        }
      }
    },
    outputStrings: {
      early: {
        en: '${dir} => ${rotation} (early safe)',
        de: '${dir} => ${rotation} (früh sicher)',
        fr: '${dir} => ${rotation} (sûr avant)',
        cn: '${dir} => ${rotation} (提前安全)',
        ko: '${dir} => ${rotation} (안전)'
      },
      normal: {
        en: '${dir} => ${rotation}',
        de: '${dir} => ${rotation}',
        fr: '${dir} => ${rotation}',
        cn: '${dir} => ${rotation}',
        ko: '${dir} => ${rotation}'
      },
      clockwise: outputs/* default.clockwise */.Z.clockwise,
      counterclockwise: outputs/* default.counterclockwise */.Z.counterclockwise,
      dirN: outputs/* default.dirN */.Z.dirN,
      dirE: outputs/* default.dirE */.Z.dirE,
      dirS: outputs/* default.dirS */.Z.dirS,
      dirW: outputs/* default.dirW */.Z.dirW
    }
  },
  // --------- Suppression ----------
  {
    id: 'UWU Suppression Gaol',
    type: 'Ability',
    netRegex: {
      id: '2B6B',
      source: 'Titan'
    },
    condition: (data, matches) => data.phase === 'suppression' && data.me === matches.target,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Gaol on YOU',
        de: 'Granitgefängnis',
        fr: 'Geôle sur VOUS',
        ja: 'ジェイル',
        cn: '石牢点名',
        ko: '돌감옥 대상자'
      }
    }
  }, {
    id: 'UWU Aetherochemical Laser Middle',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ultima Weapon',
      id: '2B84',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Middle Laser',
        de: 'Laser (Mitte)',
        fr: 'Laser (Milieu)',
        ja: 'レーザー (中央)',
        cn: '中间激光',
        ko: '가운데 레이저'
      }
    }
  }, {
    id: 'UWU Aetherochemical Laser Right',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ultima Weapon',
      id: '2B85',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'North Laser',
        de: 'Laser (Norden)',
        fr: 'Laser (Nord)',
        ja: 'レーザー (北)',
        cn: '右侧激光',
        ko: '북쪽 레이저'
      }
    }
  }, {
    id: 'UWU Aetherochemical Laser Left',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ultima Weapon',
      id: '2B86',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'East Laser',
        de: 'Laser (Osten)',
        fr: 'Laser (Est)',
        ja: 'レーザー (東)',
        cn: '左侧激光',
        ko: '동쪽 레이저'
      }
    }
  },
  // --------- Primal Roulette ----------
  {
    id: 'UWU Garuda Finale',
    type: 'Ability',
    netRegex: {
      source: 'The Ultima Weapon',
      id: '2CD3',
      capture: false
    },
    condition: data => data.phase === 'finale',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Garuda',
        de: 'Garuda',
        fr: 'Garuda',
        ja: 'ガルーダ',
        cn: '迦楼罗',
        ko: '가루다'
      }
    }
  }, {
    id: 'UWU Ifrit Finale',
    type: 'Ability',
    netRegex: {
      source: 'The Ultima Weapon',
      id: '2CD4',
      capture: false
    },
    condition: data => data.phase === 'finale',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Ifrit',
        de: 'Ifrit',
        fr: 'Ifrit',
        ja: 'イフリート',
        cn: '伊弗利特',
        ko: '이프리트'
      }
    }
  }, {
    id: 'UWU Titan Finale',
    type: 'Ability',
    netRegex: {
      source: 'The Ultima Weapon',
      id: '2CD5',
      capture: false
    },
    condition: data => data.phase === 'finale',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Titan',
        de: 'Titan',
        fr: 'Titan',
        ja: 'タイタン',
        cn: '泰坦',
        ko: '타이탄'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bomb Boulder': 'Bomber-Brocken',
      'Chirada': 'Chirada',
      'Garuda': 'Garuda',
      'Ifrit': 'Ifrit',
      'Lahabrea': 'Lahabrea',
      'Magitek Bit': 'Magitek-Drohne',
      'Spiny Plume': 'dornig(?:e|er|es|en) Federsturm',
      'Suparna': 'Suparna',
      'The Ultima Weapon': 'Ultima-Waffe',
      'Titan': 'Titan'
    },
    'replaceText': {
      'Aerial Blast': 'Windschlag',
      'Aetheric Boom': 'Ätherknall',
      'Aetherochemical Laser': 'Ätherochemischer Laser',
      '(?<! )Aetheroplasm': 'Ätheroplasma',
      'Apply Viscous': 'Ätheroplasma wirkt',
      'Blight': 'Pesthauch',
      'Bury': 'Begraben',
      'Ceruleum Vent': 'Erdseim-Entlüfter',
      'Citadel Siege': 'Belagerung der Zitadelle',
      'Crimson Cyclone': 'Zinnober-Zyklon',
      'Dark IV': 'Neka',
      'Diffractive Laser': 'Diffraktiver Laser',
      'Downburst': 'Fallböe',
      'Earthen Fury': 'Gaias Zorn',
      'Eruption': 'Eruption',
      'Eye Of The Storm': 'Auge des Sturms',
      'Feather Rain': 'Federregen',
      'Flaming Crush': 'Flammenstoß',
      'Freefire': 'Schwerer Beschuss',
      'Friction': 'Windklinge',
      'Geocrush': 'Geo-Stoß',
      'Great Whirlwind': 'Windhose',
      'Hellfire': 'Höllenfeuer',
      'Homing Lasers': 'Leitlaser',
      'Incinerate': 'Einäschern',
      'Infernal Fetters': 'Infernofesseln',
      'Inferno Howl': 'Brennende Wut',
      'Landslide': 'Bergsturz',
      'Light Pillar': 'Lichtsäule',
      'Mesohigh': 'Meso-Hoch',
      'Mistral Shriek': 'Mistral-Schrei',
      'Mistral Song': 'Mistral-Song',
      'Mountain Buster': 'Bergsprenger',
      'Nail Adds': 'Fessel Adds',
      'Radiant Plume': 'Scheiterhaufen',
      'Rock Buster': 'Steinsprenger',
      'Rock Throw': 'Granitgefängnis',
      'Searing Wind': 'Versengen',
      'Self-detonate': 'Zerbersten',
      'Slipstream': 'Wirbelströmung',
      'Summon Random Primal': 'Zufällige Primaebeschwörung',
      'Tank Purge': 'Tankreinigung',
      'Tumult': 'Urerschütterung',
      'Ultima(?!\\w)': 'Ultima',
      'Ultimate Annihilation': 'Ultimative Vernichtung',
      'Ultimate Predation': 'Ultimative Prädation',
      'Ultimate Suppression': 'Ultimative Unterdrückung',
      'Upheaval': 'Urtrauma',
      'Viscous Aetheroplasm': 'Viskoses Ätheroplasma',
      'Vulcan Burst': 'Feuerstoß',
      'Weight Of The Land': 'Gaias Gewicht',
      'Wicked Tornado': 'Tornado der Bosheit',
      'Wicked Wheel': 'Rad der Bosheit'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bomb Boulder': 'bombo rocher',
      'Chirada': 'Chirada',
      'Garuda': 'Garuda',
      'Ifrit': 'Ifrit',
      'Lahabrea': 'Lahabrea',
      'Magitek Bit': 'drone magitek',
      'Spiny Plume': 'plume perforante',
      'Suparna': 'Suparna',
      'The Ultima Weapon': 'Ultima Arma',
      'Titan': 'Titan'
    },
    'replaceText': {
      'Aerial Blast': 'Rafale aérienne',
      'Aetheric Boom': 'Onde d\'éther',
      'Aetherochemical Laser': 'Laser magismologique',
      '(?<! )Aetheroplasm': 'Éthéroplasma',
      'Apply Viscous': 'Debuff Éthéroplasma',
      'Blight': 'Supplice',
      'Bury': 'Impact',
      'Ceruleum Vent': 'Exutoire à Céruleum',
      'Citadel Siege': 'Siège de citadelle',
      'Crimson Cyclone': 'Cyclone écarlate',
      'Dark IV': 'Giga Ténèbres',
      'Diffractive Laser': 'Laser diffractif',
      'Downburst': 'Rafale descendante',
      'Earthen Fury': 'Fureur tellurique',
      'Eruption': 'Éruption',
      'Eye Of The Storm': 'Œil du cyclone',
      'Feather Rain': 'Pluie de plumes',
      'Flaming Crush': 'Fracas de flammes',
      'Freefire': 'Tir d\'artillerie lourde',
      'Friction': 'Lame de vent',
      'Geocrush': 'Broie-terre',
      'Great Whirlwind': 'Grand tourbillon',
      'Hellfire': 'Flammes de l\'enfer',
      'Homing Lasers': 'Lasers autoguidés',
      'Incinerate': 'Incinération',
      'Infernal Fetters': 'Chaînes infernales',
      'Inferno Howl': 'Rugissement infernal',
      'Landslide': 'Glissement de terrain',
      'Light Pillar': 'Colonne lumineuse',
      'Mesohigh': 'Anticyclone de méso-échelle',
      'Mistral Shriek': 'Cri du mistral',
      'Mistral Song': 'Chant du mistral',
      'Mountain Buster': 'Casse-montagnes',
      'Nail Adds': 'Adds Clou',
      'Radiant Plume': 'Panache radiant',
      'Rock Buster': 'Casse-roc',
      'Rock Throw': 'Jeté de rocs',
      'Searing Wind': 'Carbonisation',
      'Self-detonate': 'Auto-atomisation',
      'Slipstream': 'Sillage',
      'Summon Random Primal': 'Invocation de primordial aléatoire',
      'Tank Purge': 'Vidange de réservoir',
      'Tumult': 'Tumulte',
      'Ultima(?!\\w)': 'Ultima',
      'Ultimate Annihilation': 'Fantasmagorie infernale',
      'Ultimate Predation': 'Fantasmagorie prédatrice',
      'Ultimate Suppression': 'Fantasmagorie bestiale',
      'Upheaval': 'Bouleversement',
      'Viscous Aetheroplasm': 'Éthéroplasma poisseux',
      'Vulcan Burst': 'Explosion volcanique',
      'Weight Of The Land': 'Poids de la terre',
      'Wicked Tornado': 'Tornade meurtrière',
      'Wicked Wheel': 'Roue mauvaise'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bomb Boulder': 'ボムボルダー',
      'Chirada': 'チラーダ',
      'Garuda': 'ガルーダ',
      'Ifrit': 'イフリート',
      'Lahabrea': 'アシエン・ラハブレア',
      'Magitek Bit': '魔導ビット',
      'Spiny Plume': 'スパイニープルーム',
      'Suparna': 'スパルナ',
      'The Ultima Weapon': 'アルテマウェポン',
      'Titan': 'タイタン'
    },
    'replaceText': {
      'Aerial Blast': 'エリアルブラスト',
      'Aetheric Boom': 'エーテル波動',
      'Aetherochemical Laser': '魔科学レーザー',
      '(?<! )Aetheroplasm': 'エーテル爆雷',
      'Apply Viscous': '吸着式エーテル爆雷',
      'Blight': 'クラウダ',
      'Bury': '衝撃',
      'Ceruleum Vent': 'セルレアムベント',
      'Citadel Siege': 'シタデルシージ',
      'Crimson Cyclone': 'クリムゾンサイクロン',
      'Dark IV': 'ダージャ',
      'Diffractive Laser': '拡散レーザー',
      'Downburst': 'ダウンバースト',
      'Earthen Fury': '大地の怒り',
      'Eruption': 'エラプション',
      'Eye Of The Storm': 'アイ・オブ・ストーム',
      'Feather Rain': 'フェザーレイン',
      'Flaming Crush': 'フレイムクラッシュ',
      'Freefire': '誘爆',
      'Friction': 'ウィンドブレード',
      'Geocrush': 'ジオクラッシュ',
      'Great Whirlwind': '大旋風',
      'Hellfire': '地獄の火炎',
      'Homing Lasers': '誘導レーザー',
      'Incinerate': 'インシネレート',
      'Infernal Fetters': '炎獄の鎖',
      'Inferno Howl': '灼熱の咆吼',
      'Landslide': 'ランドスライド',
      'Light Pillar': 'リヒト・ゾイレ',
      'Mesohigh': 'メソハイ',
      'Mistral Shriek': 'ミストラルシュリーク',
      'Mistral Song': 'ミストラルソング',
      'Mountain Buster': 'マウンテンバスター',
      'Nail Adds': '雑魚: 楔',
      'Radiant Plume': '光輝の炎柱',
      'Rock Buster': 'ロックバスター',
      'Rock Throw': 'グラナイト・ジェイル',
      'Searing Wind': '熱風',
      'Self-detonate': '爆発霧散',
      'Slipstream': 'スリップストリーム',
      'Summon Random Primal': 'ランダム蛮神を召喚',
      'Tank Purge': '魔導フレア',
      'Tumult': '激震',
      'Ultima(?!\\w)': 'アルテマ',
      'Ultimate Annihilation': '爆撃の究極幻想',
      'Ultimate Predation': '追撃の究極幻想',
      'Ultimate Suppression': '乱撃の究極幻想',
      'Upheaval': '大激震',
      'Viscous Aetheroplasm': '吸着爆雷起爆',
      'Vulcan Burst': 'バルカンバースト',
      'Weight Of The Land': '大地の重み',
      'Wicked Tornado': 'ウィケッドトルネード',
      'Wicked Wheel': 'ウィケッドホイール'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bomb Boulder': '爆破岩石',
      'Chirada': '妙翅',
      'Garuda': '迦楼罗',
      'Ifrit': '伊弗利特',
      'Lahabrea': '拉哈布雷亚',
      'Magitek Bit': '浮游炮射出',
      'Spiny Plume': '刺羽',
      'Suparna': '美翼',
      'The Ultima Weapon': '究极神兵',
      'Titan': '泰坦'
    },
    'replaceText': {
      'Aerial Blast': '大气爆发',
      'Aetheric Boom': '以太波动',
      'Aetherochemical Laser': '魔科学激光',
      '(?<! )Aetheroplasm': '以太爆雷',
      'Apply Viscous': '吸附式炸弹',
      'Blight': '毒雾',
      'Bury': '塌方',
      'Ceruleum Vent': '青磷放射',
      'Citadel Siege': '堡垒围攻',
      'Crimson Cyclone': '深红旋风',
      'Dark IV': '冥暗',
      'Diffractive Laser': '扩散射线',
      'Downburst': '下行突风',
      'Earthen Fury': '大地之怒',
      'Eruption': '地火喷发',
      'Eye Of The Storm': '台风眼',
      'Feather Rain': '飞翎雨',
      'Flaming Crush': '烈焰碎击',
      'Freefire': '诱导爆炸',
      'Friction': '烈风刃',
      'Geocrush': '大地粉碎',
      'Great Whirlwind': '大龙卷风',
      'Hellfire': '地狱之火炎',
      'Homing Lasers': '诱导射线',
      'Incinerate': '烈焰焚烧',
      'Infernal Fetters': '火狱之锁',
      'Inferno Howl': '灼热咆哮',
      'Landslide': '地裂',
      'Light Pillar': '光柱',
      'Mesohigh': '中高压',
      'Mistral Shriek': '寒风之啸',
      'Mistral Song': '寒风之歌',
      'Mountain Buster': '山崩',
      'Nail Adds': '火神柱',
      'Radiant Plume': '光辉炎柱',
      'Rock Buster': '碎岩',
      'Rock Throw': '花岗岩牢狱',
      'Searing Wind': '灼热',
      'Self-detonate': '雾散爆发',
      'Slipstream': '螺旋气流',
      'Summon Random Primal': '召唤随机蛮神',
      'Tank Purge': '魔导核爆',
      'Tumult': '怒震',
      'Ultima(?!\\w)': '究极',
      'Ultimate Annihilation': '爆击之究极幻想',
      'Ultimate Predation': '追击之究极幻想',
      'Ultimate Suppression': '乱击之究极幻想',
      'Upheaval': '大怒震',
      'Viscous Aetheroplasm': '引爆吸附式炸弹',
      'Vulcan Burst': '火神爆裂',
      'Weight Of The Land': '大地之重',
      'Wicked Tornado': '邪气龙卷',
      'Wicked Wheel': '邪轮旋风'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bomb Boulder': '바위폭탄',
      'Chirada': '치라다',
      'Garuda': '가루다',
      'Ifrit': '이프리트',
      'Lahabrea': '아씨엔 라하브레아',
      'Magitek Bit': '마도 비트',
      'Spiny Plume': '가시돋힌 깃털',
      'Suparna': '수파르나',
      'The Ultima Weapon': '알테마 웨폰',
      'Titan': '타이탄'
    },
    'replaceText': {
      'Aerial Blast': '대기 폭발',
      'Aetheric Boom': '에테르 파동',
      'Aetherochemical Laser': '마과학 레이저',
      '(?<! )Aetheroplasm': '에테르 폭뢰',
      'Apply Viscous': '흡착식 에테르 폭뢰',
      'Blight': '독안개',
      'Bury': '충격',
      'Ceruleum Vent': '청린 방출',
      'Citadel Siege': '공성',
      'Crimson Cyclone': '진홍 회오리',
      'Dark IV': '다쟈',
      'Diffractive Laser': '확산 레이저',
      'Downburst': '하강 기류',
      'Earthen Fury': '대지의 분노',
      'Eruption': '용암 분출',
      'Eye Of The Storm': '태풍의 눈',
      'Feather Rain': '깃털비',
      'Flaming Crush': '화염 작열',
      'Freefire': '유폭',
      'Friction': '바람의 칼날',
      'Geocrush': '대지 붕괴',
      'Great Whirlwind': '대선풍',
      'Hellfire': '지옥의 화염',
      'Homing Lasers': '유도 레이저',
      'Incinerate': '소각',
      'Infernal Fetters': '염옥의 사슬',
      'Inferno Howl': '작열의 포효',
      'Landslide': '산사태',
      'Light Pillar': '빛 기둥',
      'Mesohigh': '뇌우고기압',
      'Mistral Shriek': '삭풍의 비명',
      'Mistral Song': '삭풍의 노래',
      'Mountain Buster': '산 쪼개기',
      'Nail Adds': '염옥의 말뚝',
      'Radiant Plume': '광휘의 불기둥',
      'Rock Buster': '바위 쪼개기',
      'Rock Throw': '화강암 감옥',
      'Searing Wind': '열풍',
      'Self-detonate': '자가폭발',
      'Slipstream': '반동 기류',
      'Summon Random Primal': '무작위 야만신 소환',
      'Tank Purge': '마도 플레어',
      'Tumult': '격진',
      'Ultima(?!\\w)': '알테마',
      'Ultimate Annihilation': '궁극의 폭격 환상',
      'Ultimate Predation': '궁극의 추격 환상',
      'Ultimate Suppression': '궁극의 난격 환상',
      'Upheaval': '대격진',
      'Viscous Aetheroplasm': '흡착 폭뢰 기폭',
      'Vulcan Burst': '폭렬 난사',
      'Weight Of The Land': '대지의 무게',
      'Wicked Tornado': '마녀의 회오리',
      'Wicked Wheel': '마녀의 수레바퀴'
    }
  }]
};
/* harmony default export */ const ultima_weapon_ultimate = (ultima_weapon_ultimate_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/ultimate/ultima_weapon_ultimate.txt
const ultimate_ultima_weapon_ultimate_namespaceObject = "# Ultima Weapon Ultimate\r\n## http://clees.me/guides/uwu/\r\n\r\n# -ii 2B51 2B59 2B58 2BB5 2B44 2B45 2B46 2B47 2B64 2B6E 2B77 2B6A 2B98 2B89 2B83 2B91 2DB8 2B75 2C20 2C21 2C1F 2B80 2B5C 2B6D 25BC 2B60 2B6F 2B71 2B7F 2B61 2CB8 2B43 2CD3 2CD4 2CD5\r\n# -p 2B5F:303 2CFD:603 2CF5:800 2B87:1004 2CD3:1300\r\n# -it \"Ifrit\" \"Garuda\" \"Titan\" \"The Ultima Weapon\"\r\n\r\n# NOTE: this was an old timeline that was rounded to seconds instead of tenths of seconds.\r\n# There are portions at the ends of phases that need to be retimed more accurately if\r\n# anybody sees them again. See \"retime below\" sections.\r\n\r\nhideall \"--sync--\"\r\nhideall \"--Reset--\"\r\n\r\n\r\n### Phase 1: Garuda ###\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n6.3 \"--sync--\" StartsUsing { id: \"2B53\", source: \"Garuda\" } window 10,10\r\n8.8 \"Slipstream\" Ability { id: \"2B53\", source: \"Garuda\" }\r\n11.4 \"Mistral Song\" Ability { id: \"2B42\", source: \"Garuda\" }\r\n17.5 \"Great Whirlwind\" Ability { id: \"2B41\", source: \"Garuda\" }\r\n23.6 \"Great Whirlwind\" Ability { id: \"2B41\", source: \"Garuda\" }\r\n24.2 \"Slipstream\" Ability { id: \"2B53\", source: \"Garuda\" }\r\n27.6 \"Downburst\" Ability { id: \"2B50\", source: \"Garuda\" }\r\n29.7 \"Great Whirlwind\" Ability { id: \"2B41\", source: \"Garuda\" }\r\n34.9 \"--untargetable--\"\r\n37.5 \"Feather Rain\" Ability { id: \"2B4D\", source: \"Garuda\" }\r\n39.2 \"--targetable--\"\r\n42.2 \"Mistral Shriek\" Ability { id: \"2B54\", source: \"Garuda\" }\r\n51.5 \"Friction 1\" Ability { id: \"2B48\", source: \"Garuda\" }\r\n57.6 \"Friction 2\" Ability { id: \"2B48\", source: \"Garuda\" }\r\n69.5 \"--untargetable--\"\r\n72.1 \"Feather Rain\" Ability { id: \"2B4D\", source: \"Garuda\" }\r\n73.8 \"--targetable--\"\r\n76.8 \"Aerial Blast\" Ability { id: \"2B55\", source: \"Garuda\" }\r\n92.9 \"Feather Rain\" Ability { id: \"2B4D\", source: \"Garuda\" }\r\n99.8 \"Mistral Song x2\" Ability { id: \"2B4B\", source: \"Chirada\" }\r\n100.1 \"Eye of the Storm\" Ability { id: \"2B52\", source: \"Garuda\" }\r\n100.2 \"Wicked Wheel\" Ability { id: \"2B4E\", source: \"Garuda\" }\r\n104.2 \"Feather Rain\" Ability { id: \"2B4D\", source: \"Garuda\" }\r\n105.8 \"Great Whirlwind\" Ability { id: \"2B41\", source: \"Suparna\" }\r\n121.8 \"Slipstream\" Ability { id: \"2B53\", source: \"Garuda\" }\r\n123.0 \"Eye of the Storm\" Ability { id: \"2B52\", source: \"Garuda\" }\r\n125.0 \"Mesohigh x2\" Ability { id: \"2B49\", source: \"Chirada\" }\r\n125.1 \"Downburst\" Ability { id: \"2B50\", source: \"Garuda\" }\r\n129.6 \"Feather Rain\" Ability { id: \"2B4D\", source: \"Garuda\" }\r\n142.2 \"Slipstream\" Ability { id: \"2B53\", source: \"Garuda\" }\r\n150.6 \"Wicked Wheel\" Ability { id: \"2B4E\", source: \"Garuda\" }\r\n152.6 \"Wicked Tornado\" Ability { id: \"2B4F\", source: \"Garuda\" }\r\n155.4 \"Downburst\" Ability { id: \"2B50\", source: \"Garuda\" }\r\n163.4 \"Slipstream\" Ability { id: \"2B53\", source: \"Garuda\" }\r\n# retime below\r\n176.5 \"--untargetable--\" Ability { id: \"2B4D\", source: \"Garuda\" }\r\n181.5 \"Aerial Blast\" Ability { id: \"2B55\", source: \"Garuda\" }\r\n\r\n\r\n### Phase 2: Ifrit ###\r\n300.0 \"--sync--\" StartsUsing { id: \"2B5F\", source: \"Ifrit\" } window 300,0\r\n303.0 \"Crimson Cyclone\" Ability { id: \"2B5F\", source: \"Ifrit\" }\r\n304.0 \"Radiant Plume\" Ability { id: \"2B61\", source: \"Ifrit\" }\r\n307.1 \"--targetable--\"\r\n310.1 \"Hellfire\" Ability { id: \"2B5E\", source: \"Ifrit\" }\r\n318.3 \"Vulcan Burst\" Ability { id: \"2B57\", source: \"Ifrit\" }\r\n321.2 \"Incinerate 1\" Ability { id: \"2B56\", source: \"Ifrit\" }\r\n324.3 \"Incinerate 2\" Ability { id: \"2B56\", source: \"Ifrit\" }\r\n328.4 \"Incinerate 3\" Ability { id: \"2B56\", source: \"Ifrit\" }\r\n331.5 \"--nail adds--\" Ability { id: \"1CD\", source: \"Ifrit\" }\r\n340.6 \"Infernal Fetters\" Ability { id: \"2C19\", source: \"Ifrit\" }\r\n342.7 \"Inferno Howl\" Ability { id: \"2B5B\", source: \"Ifrit\" } duration 18\r\n348.8 \"Eruption 1\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n350.8 \"Eruption 2\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n352.8 \"Eruption 3\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n354.8 \"Eruption 4\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n365.7 \"--untargetable--\"\r\n369.9 \"--targetable--\"\r\n369.9 \"--sync--\" StartsUsing { id: \"2B5E\", source: \"Ifrit\" } window 10,10\r\n372.9 \"Hellfire\" Ability { id: \"2B5E\", source: \"Ifrit\" }\r\n381.2 \"Inferno Howl 1\" Ability { id: \"2B5B\", source: \"Ifrit\" } duration 30\r\n387.3 \"Eruption 1\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n389.3 \"Eruption 2\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n391.3 \"Eruption 3\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n393.3 \"Eruption 4\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n394.3 \"Crimson Cyclone\" Ability { id: \"2B5F\", source: \"Ifrit\" }\r\n399.2 \"Inferno Howl 2\" Ability { id: \"2B5B\", source: \"Ifrit\" } duration 30\r\n409.6 \"Flaming Crush\" Ability { id: \"2B5D\", source: \"Ifrit\" }\r\n413.6 \"--untargetable--\"\r\n421.1 \"Crimson Cyclone 1\" #Ability { id: \"2B5F\", source: \"Ifrit\" }\r\n422.5 \"Crimson Cyclone 2\" #Ability { id: \"2B5F\", source: \"Ifrit\" }\r\n424.0 \"Crimson Cyclone 3\" #Ability { id: \"2B5F\", source: \"Ifrit\" }\r\n425.4 \"Crimson Cyclone 4\" #Ability { id: \"2B5F\", source: \"Ifrit\" }\r\n429.5 \"--targetable--\"\r\n433.6 \"Incinerate 1\" Ability { id: \"2B56\", source: \"Ifrit\" }\r\n436.7 \"Incinerate 2\" Ability { id: \"2B56\", source: \"Ifrit\" }\r\n440.8 \"Incinerate 3\" Ability { id: \"2B56\", source: \"Ifrit\" }\r\n# retime below\r\n447.0 \"Eruption 1\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n449.0 \"Eruption 2\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n451.0 \"Eruption 3\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n453.0 \"Eruption 4\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n456.0 \"Flaming Crush\" Ability { id: \"2B5D\", source: \"Ifrit\" }\r\n# ??? unknown enrage\r\n\r\n\r\n### Phase 3: Titan ###\r\n600.0 \"--sync--\" StartsUsing { id: \"2CFD\", source: \"Titan\" } window 600,0\r\n603.0 \"Geocrush\" Ability { id: \"2CFD\", source: \"Titan\" }\r\n605.3 \"--targetable--\"\r\n608.3 \"Earthen Fury\" Ability { id: \"2B90\", source: \"Titan\" }\r\n616.4 \"Rock Buster\" Ability { id: \"2B62\", source: \"Titan\" }\r\n619.5 \"Mountain Buster\" Ability { id: \"2B63\", source: \"Titan\" }\r\n624.5 \"Weight of the Land 1\" Ability { id: \"2B65\", source: \"Titan\" }\r\n627.5 \"Weight of the Land 2\" Ability { id: \"2B65\", source: \"Titan\" }\r\n627.6 \"--untargetable--\"\r\n632.8 \"Geocrush\" Ability { id: \"2B66\", source: \"Titan\" }\r\n635.1 \"--targetable--\"\r\n635.1 \"--sync--\" Ability { id: \"2B68\", source: \"Titan\" }\r\n638.1 \"Bury\" Ability { id: \"2B69\", source: \"Bomb Boulder\" }\r\n641.1 \"Upheaval\" Ability { id: \"2B67\", source: \"Titan\" }\r\n643.2 \"Rock Throw\" Ability { id: \"2B6B\", source: \"Titan\" }\r\n646.1 \"Bury\" Ability { id: \"2B69\", source: \"Bomb Boulder\" }\r\n647.7 \"Landslide 1\" Ability { id: \"2B70\", source: \"Titan\" }\r\n652.1 \"Landslide 2\" Ability { id: \"2B70\", source: \"Titan\" }\r\n654.2 \"Tumult x8\" duration 7.7 #Ability { id: \"2C18\", source: \"Titan\" }\r\n670.0 \"Weight of the Land 1\" Ability { id: \"2B65\", source: \"Titan\" }\r\n673.0 \"Weight of the Land 2\" Ability { id: \"2B65\", source: \"Titan\" }\r\n675.0 \"Landslide 1\" Ability { id: \"2B70\", source: \"Titan\" }\r\n677.0 \"Landslide 2\" Ability { id: \"2C22\", source: \"Titan\" }\r\n681.1 \"--untargetable--\"\r\n686.3 \"Geocrush\" Ability { id: \"2B66\", source: \"Titan\" }\r\n688.6 \"--targetable--\"\r\n688.6 \"Rock Throw\" Ability { id: \"2B6B\", source: \"Titan\" }\r\n702.9 \"Landslide 1\" Ability { id: \"2B70\", source: \"Titan\" }\r\n704.9 \"Landslide 2\" Ability { id: \"2C22\", source: \"Titan\" }\r\n708.0 \"Tumult x6\" duration 5.5 #Ability { id: \"2C18\", source: \"Titan\" }\r\n715.6 \"Rock Buster\" Ability { id: \"2B62\", source: \"Titan\" }\r\n719.6 \"Mountain Buster\" Ability { id: \"2B63\", source: \"Titan\" }\r\n721.6 \"--sync--\" Ability { id: \"2B68\", source: \"Titan\" }\r\n724.6 \"Bury\" #Ability { id: \"2B69\", source: \"Bomb Boulder\" }\r\n726.6 \"Bury\" #Ability { id: \"2B69\", source: \"Bomb Boulder\" }\r\n726.6 \"Weight of the Land 1\" Ability { id: \"2B65\", source: \"Titan\" }\r\n728.6 \"Bury\" #Ability { id: \"2B69\", source: \"Bomb Boulder\" }\r\n729.6 \"Weight of the Land 2\" Ability { id: \"2B65\", source: \"Titan\" }\r\n730.6 \"Bury\" #Ability { id: \"2B69\", source: \"Bomb Boulder\" }\r\n731.9 \"Landslide 1\" Ability { id: \"2B70\", source: \"Titan\" }\r\n732.7 \"Weight of the Land 3\" Ability { id: \"2B65\", source: \"Titan\" }\r\n733.9 \"Landslide 2\" Ability { id: \"2C22\", source: \"Titan\" }\r\n740.0 \"Rock Buster\" Ability { id: \"2B62\", source: \"Titan\" }\r\n744.0 \"Mountain Buster\" Ability { id: \"2B63\", source: \"Titan\" }\r\n749.1 \"Weight of the Land 1\" Ability { id: \"2B65\", source: \"Titan\" }\r\n752.1 \"Weight of the Land 2\" Ability { id: \"2B65\", source: \"Titan\" }\r\n755.1 \"Weight of the Land 3\" Ability { id: \"2B65\", source: \"Titan\" }\r\n756.8 \"Tumult x8\" duration 7.7 #Ability { id: \"2C18\", source: \"Titan\" }\r\n772.5 \"--untargetable--\"\r\n779.8 \"Earthen Fury Enrage\" Ability { id: \"2B90\", source: \"Titan\" }\r\n\r\n\r\n### Phase 4: Snacks ###\r\n800.0 \"Freefire\" Ability { id: \"2CF5\" } window 800,0\r\n802.0 \"--targetable--\"\r\n803.0 \"--sync--\" StartsUsing { id: \"2B72\", source: \"Magitek Bit\" }\r\n815.0 \"Self-detonate\" Ability { id: \"2B72\", source: \"Magitek Bit\" }\r\n815.2 \"Blight\" Ability { id: \"2B73\", source: \"Lahabrea\" } window 50,10\r\n824.2 \"--sync--\" StartsUsing { id: \"2B74\", source: \"Lahabrea\" } window 50,10\r\n841.2 \"Dark IV\" Ability { id: \"2B74\", source: \"Lahabrea\" } window 50,10\r\n845.4 \"--sync--\" StartsUsing { id: \"2B8B\", source: \"The Ultima Weapon\" } window 50,10\r\n850.4 \"Ultima\" Ability { id: \"2B8B\", source: \"The Ultima Weapon\" } window 50,10 forcejump 960.3\r\n\r\n\r\n### Phase 5: Ultima ###\r\n960.3 \"Ultima\" Ability { id: \"2B8B\", source: \"The Ultima Weapon\" }\r\n1000 \"--targetable--\" StartsUsing { id: \"2B87\", source: \"The Ultima Weapon\" } window 1000,100\r\n1004.0 \"Tank Purge\" Ability { id: \"2B87\", source: \"The Ultima Weapon\" }\r\n1006.3 \"--apply viscous--\" Ability { id: \"2B79\", source: \"The Ultima Weapon\" }\r\n1012.4 \"Homing Lasers\" Ability { id: \"2B7B\", source: \"The Ultima Weapon\" }\r\n1017.4 \"Viscous Aetheroplasm\" Ability { id: \"2B7A\", source: \"The Ultima Weapon\" }\r\n\r\n## Ultimate Predation\r\n1020.5 \"--sync--\" StartsUsing { id: \"2B76\", source: \"The Ultima Weapon\" } window 30,30\r\n1023.5 \"Ultimate Predation\" Ability { id: \"2B76\", source: \"The Ultima Weapon\" }\r\n1027.9 \"--untargetable--\"\r\n1038.2 \"Landslide\" Ability { id: \"2B70\", source: \"Titan\" }\r\n1038.2 \"Crimson Cyclone\" Ability { id: \"2B5F\", source: \"Ifrit\" }\r\n1038.2 \"Wicked Wheel\" Ability { id: \"2B4E\", source: \"Garuda\" }\r\n1040.2 \"Ceruleum Vent\" Ability { id: \"2B7C\", source: \"The Ultima Weapon\" }\r\n1040.2 \"Landslide\" Ability { id: \"2C22\", source: \"Titan\" }\r\n1040.2 \"Wicked Tornado\" Ability { id: \"2B4F\", source: \"Garuda\" }\r\n1045.4 \"Feather Rain\" Ability { id: \"2B4D\", source: \"Garuda\" }\r\n\r\n## Interlude Dance\r\n1047.4 \"--targetable--\"\r\n1059.8 \"Eruption 1\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n1061.8 \"Eruption 2\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n1063.8 \"Eruption 3\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n1064.8 \"Infernal Fetters\" Ability { id: \"2C19\", source: \"Ifrit\" }\r\n1065.8 \"Eruption 4\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n1067.9 \"--sync--\" Ability { id: \"2B68\", source: \"Titan\" }\r\n1069.9 \"Radiant Plume\" Ability { id: \"2B7D\", source: \"The Ultima Weapon\" }\r\n1070.9 \"Bury x6\" duration 10 #Ability { id: \"2B69\", source: \"Bomb Boulder\" }\r\n#1074.2 \"Landslide 1\" Ability { id: \"2B70\", source: \"Titan\" }\r\n1074.9 \"Landslide 1\" Ability { id: \"2B7E\", source: \"The Ultima Weapon\" }\r\n1076.2 \"Landslide 2\" Ability { id: \"2C22\", source: \"Titan\" }\r\n1079.3 \"Tumult x7\" duration 6.9 #Ability { id: \"2C18\", source: \"Titan\" }\r\n1082.3 \"--apply viscous--\" Ability { id: \"2B79\", source: \"The Ultima Weapon\" }\r\n1087.3 \"Wicked Wheel\" Ability { id: \"2B4C\", source: \"Chirada\" }\r\n1089.3 \"Mistral Shriek\" Ability { id: \"2B54\", source: \"Garuda\" }\r\n1092.6 \"Feather Rain\" Ability { id: \"2B4D\", source: \"Garuda\" }\r\n1093.4 \"Viscous Aetheroplasm\" Ability { id: \"2B7A\", source: \"The Ultima Weapon\" }\r\n1094.5 \"Homing Lasers\" Ability { id: \"2B7B\", source: \"The Ultima Weapon\" }\r\n1096.2 \"Feather Rain\" Ability { id: \"2B4D\", source: \"Garuda\" }\r\n\r\n## Ultimate Annihilation\r\n1098.8 \"--sync--\" StartsUsing { id: \"2D4C\", source: \"The Ultima Weapon\" } window 30,30\r\n1101.8 \"Ultimate Annihilation\" Ability { id: \"2D4C\", source: \"The Ultima Weapon\" }\r\n1106.2 \"--untargetable--\"\r\n1110.4 \"--targetable--\"\r\n1113.4 \"Weight of the Land 1\" Ability { id: \"2B65\", source: \"Titan\" }\r\n1115.4 \"Flaming Crush\" Ability { id: \"2B5D\", source: \"Ifrit\" }\r\n1116.4 \"Weight of the Land 2\" Ability { id: \"2B65\", source: \"Titan\" }\r\n1116.5 \"Eye of the Storm\" Ability { id: \"2B52\", source: \"Garuda\" }\r\n# This damage is when the orb is taken, but the timing is the first moment it could be taken.\r\n1118.2 \"Aetheroplasm 1\" #Ability { id: \"2B81\", source: \"Aetheroplasm\" }\r\n1118.6 \"Mesohigh\" Ability { id: \"2B49\", source: \"Garuda\" }\r\n1119.5 \"Weight of the Land 3\" Ability { id: \"2B65\", source: \"Titan\" }\r\n1119.5 \"Inferno Howl\" Ability { id: \"2B5B\", source: \"Ifrit\" }\r\n1123.2 \"Feather Rain\" Ability { id: \"2B4D\", source: \"Garuda\" }\r\n1123.6 \"Aetheroplasm 2\" #Ability { id: \"2B81\", source: \"Aetheroplasm\" }\r\n1127.7 \"Crimson Cyclone\" Ability { id: \"2B5F\", source: \"Ifrit\" }\r\n1128.6 \"Landslide 1\" Ability { id: \"2B70\", source: \"Titan\" }\r\n1130.6 \"Landslide 2\" Ability { id: \"2C22\", source: \"Titan\" }\r\n1132.6 \"Aetheroplasm 3\" #Ability { id: \"2B81\", source: \"Aetheroplasm\" }\r\n1133.7 \"Eye of the Storm\" Ability { id: \"2B52\", source: \"Garuda\" }\r\n1135.9 \"Aetheroplasm 4\" #Ability { id: \"2B81\", source: \"Aetheroplasm\" }\r\n1136.0 \"Mesohigh\" Ability { id: \"2B49\", source: \"Garuda\" }\r\n1138.8 \"Tank Purge\" Ability { id: \"2B87\", source: \"The Ultima Weapon\" }\r\n1140.7 \"Feather Rain\" Ability { id: \"2B4D\", source: \"Garuda\" }\r\n1142.9 \"--untargetable--\"\r\n1147.1 \"--targetable--\"\r\n1150.5 \"Eye of the Storm\" Ability { id: \"2B52\", source: \"Garuda\" }\r\n1154.2 \"Homing Lasers\" Ability { id: \"2B7B\", source: \"The Ultima Weapon\" }\r\n1162.3 \"Eye of the Storm\" Ability { id: \"2B52\", source: \"Garuda\" }\r\n1164.4 \"Radiant Plume\" Ability { id: \"2B7D\", source: \"The Ultima Weapon\" }\r\n1167.5 \"Diffractive Laser\" Ability { id: \"2B78\", source: \"The Ultima Weapon\" }\r\n1171.6 \"Vulcan Burst\" Ability { id: \"2CF4\", source: \"The Ultima Weapon\" }\r\n\r\n1173.6 \"Eye of the Storm\" Ability { id: \"2B52\", source: \"Garuda\" }\r\n1179.2 \"Homing Lasers\" Ability { id: \"2B7B\", source: \"The Ultima Weapon\" }\r\n1183.3 \"Vulcan Burst\" Ability { id: \"2CF4\", source: \"The Ultima Weapon\" }\r\n1185.5 \"Eye of the Storm\" Ability { id: \"2B52\", source: \"Garuda\" }\r\n# retime from here, into natural push below\r\n1190 \"Diffractive Laser\"\r\n\r\n## Ultimate Suppression (50%)\r\n1192.0 \"--sync--\" StartsUsing { id: \"2D4D\", source: \"The Ultima Weapon\" } window 1200,100\r\n1195.0 \"Ultimate Suppression\" Ability { id: \"2D4D\", source: \"The Ultima Weapon\" }\r\n1199.4 \"--untargetable--\"\r\n1205.7 \"Rock Throw\" Ability { id: \"2B6B\", source: \"Titan\" }\r\n1206.7 \"Eruption 1\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n1208.7 \"Eruption 2\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n1209.8 \"Mistral Song\" Ability { id: \"2B4B\", source: \"Suparna\" }\r\n1210.7 \"Eruption 3\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n1211.7 \"Light Pillar x6\" Ability { id: \"2B82\", source: \"The Ultima Weapon\" } duration 8\r\n1212.0 \"Mistral Song\" Ability { id: \"2B8E\", source: \"Garuda\" }\r\n1212.6 \"Eruption 4\" #Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n1214.4 \"Feather Rain 1\" #Ability { id: \"2B4D\", source: \"Garuda\" }\r\n1216.0 \"Great Whirlwind\" Ability { id: \"2B41\", source: \"Suparna\" }\r\n1216.4 \"Feather Rain 2\" #Ability { id: \"2B4D\", source: \"Garuda\" }\r\n1216.8 \"Aetherochemical Laser\" Ability { id: \"2B8[456]\", source: \"The Ultima Weapon\" }\r\n1221.0 \"Aetherochemical Laser\" Ability { id: \"2B8[456]\", source: \"The Ultima Weapon\" }\r\n1224.3 \"Landslide 1\" Ability { id: \"2B70\", source: \"Titan\" }\r\n1225.1 \"Aetherochemical Laser\" Ability { id: \"2B8[456]\", source: \"The Ultima Weapon\" }\r\n1226.3 \"Landslide 2\" Ability { id: \"2C22\", source: \"Titan\" }\r\n1227.1 \"Mesohigh\" Ability { id: \"2B49\", source: \"Garuda\" }\r\n1228.0 \"Flaming Crush\" Ability { id: \"2B5D\", source: \"Ifrit\" }\r\n1232.8 \"Feather Rain\" Ability { id: \"2B4D\", source: \"Garuda\" }\r\n1233.2 \"Tank Purge\" Ability { id: \"2B87\", source: \"The Ultima Weapon\" }\r\n1239.5 \"--targetable--\"\r\n1244.5 \"Ultima\" Ability { id: \"2B8B\", source: \"The Ultima Weapon\" }\r\n1254.7 \"Aetheric Boom\" Ability { id: \"2B88\", source: \"The Ultima Weapon\" }\r\n1275.9 \"Viscous Aetheroplasm\" Ability { id: \"2B8F\", source: \"The Ultima Weapon\" }\r\n1279.9 \"Summon Random Primal\" #Ability { id: \"2CD[345]\", source: \"The Ultima Weapon\" }\r\n\r\n\r\n## Random Primal Finale (summon all three in random order)\r\n# Note: 2CD3/2CD4/2CD5 get used at other points in the fight so can't have big syncs.\r\n\r\n## Summon Garuda (random order)\r\n1300.0 \"--sync--\" Ability { id: \"2CD3\", source: \"The Ultima Weapon\" } window 50,300\r\n1307.2 \"Wicked Wheel\" Ability { id: \"2B4E\", source: \"Garuda\" }\r\n1308.4 \"Viscous Aetheroplasm\" Ability { id: \"2B7A\", source: \"The Ultima Weapon\" }\r\n1309.3 \"Wicked Tornado\" Ability { id: \"2B4F\", source: \"Ifrit\" }\r\n1314.1 \"Aerial Blast\" Ability { id: \"2B55\", source: \"Garuda\" }\r\n# ??? is this timing correct if Garuda is not last?\r\n1318.1 \"Summon Random Primal\" #Ability { id: \"2CD[345]\", source: \"The Ultima Weapon\" }\r\n1321.8 \"Feather Rain\" Ability { id: \"2B4D\", source: \"Garuda\" }\r\n\r\n\r\n## Summon Ifrit (random order)\r\n1400.0 \"--sync--\" Ability { id: \"2CD4\", source: \"The Ultima Weapon\" } window 150,300\r\n1407.2 \"Crimson Cyclone\" Ability { id: \"2B5F\", source: \"Ifrit\" }\r\n1407.2 \"Eruption\" Ability { id: \"2B5A\", source: \"Ifrit\" }\r\n1408.5 \"Viscous Aetheroplasm\" Ability { id: \"2B7A\", source: \"Ifrit\" }\r\n1415.2 \"Hellfire\" Ability { id: \"2B5E\", source: \"Ifrit\" }\r\n1420.1 \"Summon Random Primal\" #Ability { id: \"2CD[345]\", source: \"The Ultima Weapon\" }\r\n\r\n## Summon Titan (random order)\r\n1500.0 \"--sync--\" Ability { id: \"2CD5\", source: \"The Ultima Weapon\" } window 250,300\r\n1505.1 \"Weight of the Land 1\" Ability { id: \"2B65\", source: \"Titan\" }\r\n1508.1 \"Weight of the Land 2\" Ability { id: \"2B65\", source: \"Titan\" }\r\n1508.8 \"Viscous Aetheroplasm\" Ability { id: \"2B7A\", source: \"Titan\" }\r\n1511.1 \"Weight of the Land 3\" Ability { id: \"2B65\", source: \"Titan\" }\r\n1514.2 \"Earthen Fury\" Ability { id: \"2B90\", source: \"Titan\" }\r\n1520.1 \"Summon Random Primal\" #Ability { id: \"2CD4\", source: \"The Ultima Weapon\" }\r\n\r\n\r\n## Enrage\r\n1600.0 \"Enrage\" Ability { id: \"2B8C\", source: \"The Ultima Weapon\" } window 400,0\r\n\r\n# FIXME: this waits until 100% aether, but unclear when that happens in the log.\r\n# The only indication is a 122 Damage Up ability 2 seconds before this.\r\n1625.0 \"Citadel Siege 1\" Ability { id: \"2B92\" } window 30,0\r\n1628.0 \"Citadel Siege 2\" Ability { id: \"2B92\" }\r\n1631.0 \"Citadel Siege 3\" Ability { id: \"2B92\" }\r\n1634.0 \"Citadel Siege 4\" Ability { id: \"2B92\" }\r\n1637.0 \"Citadel Siege 5\" Ability { id: \"2B92\" }\r\n1640.0 \"Citadel Siege 6\" Ability { id: \"2B92\" }\r\n1643.0 \"Citadel Siege 7\" Ability { id: \"2B92\" }\r\n# Is this really 6 seconds on the last person?\r\n1649.0 \"Citadel Siege 8\" Ability { id: \"2B92\" }\r\n1651.0 \"Sabik Enrage\" Ability { id: \"2B93\", source: \"The Ultima Weapon\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/ultimate/unending_coil_ultimate.ts






const resetTrio = (data, trio) => {
  data.trio = trio;
  data.shakers = [];
  data.megaStack = [];
};
const unending_coil_ultimate_centerX = 0;
const unending_coil_ultimate_centerY = 0;
const isClockwise = (start, compare) => {
  // assumes both start and compare are 0-360.
  // returns false if start = compare
  let isCW = false;
  if (compare > start) isCW = compare - start <= 180;else if (compare < start) isCW = start - compare >= 180;
  return isCW;
};

// Begin copy and paste from dragon_test.js.
const modDistance = (mark, dragon) => {
  const oneWay = (dragon - mark + 8) % 8;
  const otherWay = (mark - dragon + 8) % 8;
  const distance = Math.min(oneWay, otherWay);
  console.assert(distance >= 0);
  return distance;
};
const badSpots = (mark, dragon) => {
  // All spots between mark and dragon are bad.  If distance == 1,
  // then the dragon hits the spot behind the mark too.  e.g. N
  // mark, NE dragon will also hit NW.
  const bad = [];
  const distance = modDistance(mark, dragon);
  console.assert(distance > 0);
  console.assert(distance <= 2);
  if ((mark + distance + 8) % 8 === dragon) {
    // Clockwise.
    for (let i = 0; i <= distance; ++i) bad.push((mark + i) % 8);
    if (distance === 1) bad.push((mark - 1 + 8) % 8);
  } else {
    // Widdershins.
    for (let i = 0; i <= distance; ++i) bad.push((mark - i + 8) % 8);
    if (distance === 1) bad.push((mark + 1) % 8);
  }
  return bad;
};
const findDragonMarks = array => {
  const marks = [-1, -1, -1];
  let isWideThirdDive = false;
  const dragons = [];
  for (let i = 0; i < 8; ++i) {
    if (array[i]) dragons.push(i);
  }
  if (dragons.length !== 5) return;
  const [d0, d1, d2, d3, d4] = dragons;
  if (d0 === undefined || d1 === undefined || d2 === undefined || d3 === undefined || d4 === undefined) return;

  // MARK 1: counterclockwise of #1 if adjacent, clockwise if not.
  if (d0 + 1 === d1) {
    // If the first two dragons are adjacent, they *must* go CCW.
    // In the scenario of N, NE, SE, S, W dragons, the first marker
    // could be E, but that forces the second mark to be S (instead
    // of E), making SW unsafe for putting the mark between S and W.
    // Arguably, NW could be used here for the third mark, but then
    // the S dragon would cut off more of the middle of the arena
    // than desired.  This still could happen anyway in the
    // "tricksy" edge case below, but should be avoided if possible.
    marks[0] = (d0 - 1 + 8) % 8;
  } else {
    // Split dragons.  Bias towards first dragon.
    marks[0] = Math.floor((d0 + d1) / 2);
  }

  // MARK 2: go counterclockwise, unless dragon 2 is adjacent to 3.
  if (d1 === d2 - 1) {
    // Go clockwise.
    marks[1] = d2 + 1;
  } else {
    // Go counterclockwise.
    marks[1] = d2 - 1;
  }

  // MARK 3: if split, between 4 & 5.  If adjacent, clockwise of 5.
  if (d3 + 1 === d4) {
    // Adjacent dragons.
    // Clockwise is always ok.
    marks[2] = (d4 + 1) % 8;

    // Minor optimization:
    // See if counterclockwise is an option to avoid having mark 3
    // in a place that the first pair covers.
    //
    // If dragon 3 is going counterclockwise, then only need one
    // hole between #3 and #4, otherwise need all three holes.
    // e.g. N, NE, E, W, NW dragon pattern should prefer third
    // mark SW instead of N.
    const distance = marks[1] === d2 - 1 ? 2 : 4;
    if (d3 >= d2 + distance) marks[2] = d3 - 1;
  } else {
    // Split dragons.  Common case: bias towards last dragon, in case
    // 2nd charge is going towards this pair.
    marks[2] = Math.ceil((d3 + d4) / 2);
    if (marks[1] === d3 && marks[2] === marks[1] + 1) {
      // Tricksy edge case, e.g. N, NE, E, SE, SW.  S not safe for
      // third mark because second mark is at SE, and E dragon will
      // clip S.  Send all dragons CW even if this means eating more
      // arena space.
      marks[2] = (d4 + 1) % 8;
      isWideThirdDive = true;
    }
  }
  const bad = badSpots(marks[0], d0);
  bad.concat(badSpots(marks[0], d1));
  return {
    // Third drive is on a dragon three squares away and will cover
    // more of the middle than usual, e.g. SE dragon, SW dragon,
    // mark W (because S is unsafe from 2nd dive).
    wideThirdDive: isWideThirdDive,
    // Third mark spot is covered by the first dive so needs to be
    // patient.  Third mark should always be patient, but you never
    // know.
    unsafeThirdMark: bad.includes(marks[2]),
    marks: marks
  };
};
// End copy and paste.

// UCU - The Unending Coil Of Bahamut (Ultimate)
const unending_coil_ultimate_triggerSet = {
  id: 'TheUnendingCoilOfBahamutUltimate',
  zoneId: zone_id/* default.TheUnendingCoilOfBahamutUltimate */.Z.TheUnendingCoilOfBahamutUltimate,
  timelineFile: 'unending_coil_ultimate.txt',
  initData: () => {
    return {
      partyList: {},
      monitoringHP: false,
      hpThresholds: [0, 0, 0.75, 0.45],
      currentPhase: 2,
      fireDebuff: false,
      iceDebuff: false,
      thunderDebuffs: [],
      thunderOnYou: false,
      naelFireballCount: 0,
      fireballs: {
        1: [],
        2: [],
        3: [],
        4: []
      },
      seenDragon: {},
      naelDragons: [0, 0, 0, 0, 0, 0, 0, 0],
      calledNaelDragons: false,
      wideThirdDive: false,
      unsafeThirdMark: false,
      naelDiveMarkerCount: 0,
      trioSourceIds: {},
      combatantData: [],
      shakers: [],
      megaStack: [],
      octetMarker: [],
      exaflareCount: 0,
      akhMornCount: 0,
      mornAfahCount: 0
    };
  },
  timelineTriggers: [{
    id: 'UCU Bahamut\'s Claw',
    regex: /Bahamut's Claw x5/,
    beforeSeconds: 5,
    // It's tough to track who this is on, especially for the first one.
    // Both tanks should care about the tankbuster because they can throw
    // mitigation on the other, so just always play this for both tanks.
    suppressSeconds: 1,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'UCU Plummet',
    regex: /Plummet/,
    beforeSeconds: 3,
    suppressSeconds: 10,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'UCU Flare Breath',
    regex: /Flare Breath/,
    beforeSeconds: 4,
    suppressSeconds: 10,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [
  // --- State ---
  {
    id: 'UCU Firescorched Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '1D0'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.fireDebuff = true
  }, {
    id: 'UCU Firescorched Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '1D0'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.fireDebuff = false
  }, {
    id: 'UCU Icebitten Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '1D1'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.iceDebuff = true
  }, {
    id: 'UCU Icebitten Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '1D1'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.iceDebuff = false
  }, {
    id: 'UCU Fireball Counter',
    type: 'Ability',
    netRegex: {
      id: '26C5',
      source: 'Firehorn'
    },
    run: (data, matches) => {
      (data.fireballs[data.naelFireballCount] ??= []).push(matches.target);
    }
  }, {
    id: 'UCU Quickmarch Phase',
    type: 'StartsUsing',
    netRegex: {
      id: '26E2',
      source: 'Bahamut Prime',
      capture: false
    },
    run: data => resetTrio(data, 'quickmarch')
  }, {
    id: 'UCU Blackfire Phase',
    type: 'StartsUsing',
    netRegex: {
      id: '26E3',
      source: 'Bahamut Prime',
      capture: false
    },
    run: data => resetTrio(data, 'blackfire')
  }, {
    id: 'UCU Fellruin Phase',
    type: 'StartsUsing',
    netRegex: {
      id: '26E4',
      source: 'Bahamut Prime',
      capture: false
    },
    run: data => resetTrio(data, 'fellruin')
  }, {
    id: 'UCU Heavensfall Phase',
    type: 'StartsUsing',
    netRegex: {
      id: '26E5',
      source: 'Bahamut Prime',
      capture: false
    },
    run: data => resetTrio(data, 'heavensfall')
  }, {
    id: 'UCU Tenstrike Phase',
    type: 'StartsUsing',
    netRegex: {
      id: '26E6',
      source: 'Bahamut Prime',
      capture: false
    },
    run: data => resetTrio(data, 'tenstrike')
  }, {
    id: 'UCU Octet Phase',
    type: 'StartsUsing',
    netRegex: {
      id: '26E7',
      source: 'Bahamut Prime',
      capture: false
    },
    run: data => resetTrio(data, 'octet')
  }, {
    id: 'UCU Ragnarok Party Tracker',
    type: 'Ability',
    netRegex: {
      id: '26B8',
      source: 'Ragnarok'
    },
    run: (data, matches) => {
      // This happens once during the nael transition and again during
      // the heavensfall trio.  This should proooobably hit all 8
      // people by the time you get to octet.
      data.partyList[matches.target] = true;
    }
  },
  // --- Twintania ---
  {
    id: 'UCU Twisters',
    type: 'StartsUsing',
    netRegex: {
      id: '26AA',
      source: 'Twintania',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Twisters',
        de: 'Wirbelstürme',
        fr: 'Tornades',
        ja: '大竜巻',
        cn: '旋风',
        ko: '회오리'
      }
    }
  }, {
    id: 'UCU Death Sentence',
    type: 'StartsUsing',
    netRegex: {
      id: '26A9',
      source: 'Twintania'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'UCU Hatch Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '0076'
    },
    run: (data, matches) => {
      data.hatch ??= [];
      data.hatch.push(matches.target);
    }
  }, {
    id: 'UCU Hatch Marker YOU',
    type: 'HeadMarker',
    netRegex: {
      id: '0076'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hatch on YOU',
        de: 'Ausbrüten auf DIR',
        fr: 'Éclosion sur VOUS',
        ja: '自分に魔力爆散',
        cn: '点名魔力爆散',
        ko: '나에게 마력연성'
      }
    }
  }, {
    id: 'UCU Hatch Callouts',
    type: 'HeadMarker',
    netRegex: {
      id: '0076',
      capture: false
    },
    delaySeconds: 0.25,
    infoText: (data, _matches, output) => {
      if (!data.hatch) return;
      const hatches = data.hatch.map(n => data.party.member(n));
      delete data.hatch;
      return output.text({
        players: hatches
      });
    },
    outputStrings: {
      text: {
        en: 'Hatch: ${players}',
        de: 'Ausbrüten: ${players}',
        fr: 'Éclosion : ${players}',
        ja: '魔力爆散${players}',
        cn: '魔力爆散${players}',
        ko: '마력연성: ${players}'
      }
    }
  }, {
    id: 'UCU Hatch Cleanup',
    type: 'HeadMarker',
    netRegex: {
      id: '0076',
      capture: false
    },
    delaySeconds: 5,
    run: data => delete data.hatch
  }, {
    id: 'UCU Twintania Phase Change Watcher',
    type: 'StartsUsing',
    // On Twister or Generate.
    netRegex: {
      id: '26A[AE]',
      source: 'Twintania'
    },
    condition: data => !data.monitoringHP && data.hpThresholds[data.currentPhase] !== undefined,
    preRun: data => data.monitoringHP = true,
    promise: (data, matches) => util/* default.watchCombatant */.Z.watchCombatant({
      ids: [parseInt(matches.sourceId, 16)]
    }, ret => {
      return ret.combatants.some(c => {
        const currentHPCheck = data.hpThresholds[data.currentPhase] ?? -1;
        return c.CurrentHP / c.MaxHP <= currentHPCheck;
      });
    }),
    sound: 'Long',
    infoText: (data, _matches, output) => output.text({
      num: data.currentPhase
    }),
    run: data => {
      data.currentPhase++;
      data.monitoringHP = false;
    },
    outputStrings: {
      text: {
        en: 'Phase ${num} Push',
        de: 'Phase ${num} Stoß',
        fr: 'Phase ${num} poussée',
        ja: 'フェーズ${num}',
        cn: 'P${num}准备',
        ko: '트윈 페이즈${num}'
      }
    }
  },
  // --- Nael ---
  {
    // https://xivapi.com/NpcYell/6497?pretty=true
    // en: From on high I descend, the hallowed moon to call!
    id: 'UCU Nael Quote 1',
    type: 'NpcYell',
    netRegex: {
      npcYellId: '1961',
      capture: false
    },
    durationSeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread => In',
        de: 'Verteilen => Rein',
        fr: 'Dispersez-vous => Intérieur',
        ja: '散開 => 密着',
        cn: '分散 => 靠近',
        ko: '산개 => 안으로'
      }
    }
  }, {
    // https://xivapi.com/NpcYell/6496?pretty=true
    // en: From on high I descend, the iron path to walk!
    id: 'UCU Nael Quote 2',
    type: 'NpcYell',
    netRegex: {
      npcYellId: '1960',
      capture: false
    },
    durationSeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread => Out',
        de: 'Verteilen => Raus',
        fr: 'Dispersez-vous => Extérieur',
        ja: '散開 => 離れ',
        cn: '分散 => 远离',
        ko: '산개 => 밖으로'
      }
    }
  }, {
    // https://xivapi.com/NpcYell/6495?pretty=true
    // en: Take fire, O hallowed moon!
    id: 'UCU Nael Quote 3',
    type: 'NpcYell',
    netRegex: {
      npcYellId: '195F',
      capture: false
    },
    durationSeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack => In',
        de: 'Stack => Rein',
        fr: 'Packez-vous => Intérieur',
        ja: '頭割り => 密着',
        cn: '集合 => 靠近',
        ko: '쉐어 => 안으로'
      }
    }
  }, {
    // https://xivapi.com/NpcYell/6494?pretty=true
    // en: Blazing path, lead me to iron rule!
    id: 'UCU Nael Quote 4',
    type: 'NpcYell',
    netRegex: {
      npcYellId: '195E',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack => Out',
        de: 'Stack => Raus',
        fr: 'Packez-vous => Extérieur',
        ja: '頭割り => 離れ',
        cn: '集合 => 远离',
        ko: '쉐어 => 밖으로'
      }
    }
  }, {
    // https://xivapi.com/NpcYell/6493?pretty=true
    // en: O hallowed moon, take fire and scorch my foes!
    id: 'UCU Nael Quote 5',
    type: 'NpcYell',
    netRegex: {
      npcYellId: '195D',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'In => Stack',
        de: 'Rein => Stack',
        fr: 'Intérieur => Packez-vous',
        ja: '密着 => 頭割り',
        cn: '靠近 => 集合',
        ko: '안으로 => 쉐어'
      }
    }
  }, {
    // https://xivapi.com/NpcYell/6492?pretty=true
    // en: O hallowed moon, shine you the iron path!
    id: 'UCU Nael Quote 6',
    type: 'NpcYell',
    netRegex: {
      npcYellId: '195C',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'In => Out',
        de: 'Rein => Raus',
        fr: 'Intérieur => Extérieur',
        ja: '密着 => 離れ',
        cn: '靠近 => 远离',
        ko: '안으로 => 밖으로'
      }
    }
  }, {
    // https://xivapi.com/NpcYell/6501?pretty=true
    // en: Fleeting light! 'Neath the red moon, scorch you the earth!
    id: 'UCU Nael Quote 7',
    type: 'NpcYell',
    netRegex: {
      npcYellId: '1965',
      capture: false
    },
    delaySeconds: 4,
    durationSeconds: 6,
    // Make this alert so it doesn't overlap with the dive infoText occuring here.
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from Tank => Stack',
        de: 'Weg vom Tank => Stack',
        fr: 'Éloignez-vous du tank => Packez-vous',
        ja: 'タンクから離れ => 頭割り',
        cn: '远离坦克 => 集合',
        ko: '탱커 피하기 => 쉐어'
      }
    }
  }, {
    // https://xivapi.com/NpcYell/6500?pretty=true
    // en: Fleeting light! Amid a rain of stars, exalt you the red moon!
    id: 'UCU Nael Quote 8',
    type: 'NpcYell',
    netRegex: {
      npcYellId: '1964',
      capture: false
    },
    delaySeconds: 4,
    durationSeconds: 6,
    // Make this alert so it doesn't overlap with the dive infoText occuring here.
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread => Away from Tank',
        de: 'Verteilen => Weg vom Tank',
        fr: 'Dispersez-vous => Éloignez-vous du Tank',
        ja: '散開 => タンクから離れ',
        cn: '分散 => 远离坦克',
        ko: '산개 => 탱커 피하기'
      }
    }
  }, {
    // https://xivapi.com/NpcYell/6502?pretty=true
    // en: From on high I descend, the moon and stars to bring!
    id: 'UCU Nael Quote 9',
    type: 'NpcYell',
    netRegex: {
      npcYellId: '1966',
      capture: false
    },
    durationSeconds: 9,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread => In',
        de: 'Verteilen => Rein',
        fr: 'Dispersez-vous => Intérieur',
        ja: '散開 => 密着',
        cn: '分散 => 靠近',
        ko: '산개 => 안으로'
      }
    }
  }, {
    // https://xivapi.com/NpcYell/6503?pretty=true
    // en: From hallowed moon I descend, a rain of stars to bring!
    id: 'UCU Nael Quote 10',
    type: 'NpcYell',
    netRegex: {
      npcYellId: '1967',
      capture: false
    },
    durationSeconds: 9,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'In => Spread',
        de: 'Rein => Verteilen',
        fr: 'Intérieur => Dispersez-vous',
        ja: '密着 => 散開',
        cn: '靠近 => 分散',
        ko: '안으로 => 산개'
      }
    }
  }, {
    // https://xivapi.com/NpcYell/6507?pretty=true
    // en: From hallowed moon I bare iron, in my descent to wield!
    id: 'UCU Nael Quote 11',
    type: 'NpcYell',
    netRegex: {
      npcYellId: '196B',
      capture: false
    },
    durationSeconds: 9,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'In => Out => Spread',
        de: 'Rein => Raus => Verteilen',
        fr: 'Intérieur => Extérieur => Dispersion',
        ja: '密着 => 離れ => 散開',
        cn: '靠近 => 远离 => 分散',
        ko: '안으로 => 밖으로 => 산개'
      }
    }
  }, {
    // https://xivapi.com/NpcYell/6506?pretty=true
    // en: From hallowed moon I descend, upon burning earth to tread!
    id: 'UCU Nael Quote 12',
    type: 'NpcYell',
    netRegex: {
      npcYellId: '196A',
      capture: false
    },
    durationSeconds: 9,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'In => Spread => Stack',
        de: 'Rein => Verteilen => Stack',
        fr: 'Intérieur => Dispersion => Package',
        ja: '密着 => 散開 => 頭割り',
        cn: '靠近 => 分散 => 集合',
        ko: '안으로 => 산개 => 쉐어'
      }
    }
  }, {
    // https://xivapi.com/NpcYell/6504?pretty=true
    // en: Unbending iron, take fire and descend!
    id: 'UCU Nael Quote 13',
    type: 'NpcYell',
    netRegex: {
      npcYellId: '1968',
      capture: false
    },
    durationSeconds: 9,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out => Stack => Spread',
        de: 'Raus => Stack => Verteilen',
        fr: 'Extérieur => Package => Dispersion',
        ja: '離れ => 頭割り => 散開',
        cn: '远离 => 集合 => 分散',
        ko: '밖으로 => 쉐어 => 산개'
      }
    }
  }, {
    // https://xivapi.com/NpcYell/6505?pretty=true
    // en: Unbending iron, descend with fiery edge!
    id: 'UCU Nael Quote 14',
    type: 'NpcYell',
    netRegex: {
      npcYellId: '1969',
      capture: false
    },
    durationSeconds: 9,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out => Spread => Stack',
        de: 'Raus => Verteilen => Stack',
        fr: 'Extérieur => Dispersion => Package',
        ja: '離れ => 散開 => 頭割り',
        cn: '远离 => 分散 => 集合',
        ko: '밖으로 => 산개 => 쉐어'
      }
    }
  }, {
    id: 'UCU Nael Thunder Collect',
    type: 'Ability',
    netRegex: {
      source: 'Thunderwing',
      id: '26C7'
    },
    run: (data, matches) => {
      data.thunderDebuffs.push(matches.target);
      if (data.me === matches.target) data.thunderOnYou = true;
    }
  }, {
    id: 'UCU Nael Thunderstruck',
    type: 'Ability',
    // Note: The 0A event happens before 'gains the effect' and 'starts
    // casting on' only includes one person.
    netRegex: {
      source: 'Thunderwing',
      id: '26C7',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 5,
    alarmText: (data, _matches, output) => {
      if (data.thunderOnYou) return output.thunderOnYou();
    },
    infoText: (data, _matches, output) => {
      if (!data.thunderOnYou) {
        const [thunder1, thunder2] = data.thunderDebuffs.map(p => data.party.member(p));
        return output.thunderOnOthers({
          player1: thunder1,
          player2: thunder2
        });
      }
    },
    run: data => {
      data.thunderDebuffs = [];
      data.thunderOnYou = false;
    },
    outputStrings: {
      thunderOnYou: {
        en: 'Thunder on YOU',
        de: 'Blitz auf DIR',
        fr: 'Foudre sur VOUS',
        ja: '自分にサンダー',
        cn: '雷点名',
        ko: '나에게 번개'
      },
      thunderOnOthers: {
        en: 'Thunder on ${player1}, ${player2}',
        de: 'Blitz auf ${player1}, ${player2}',
        fr: 'Foudre sur ${player1}, ${player2}',
        cn: '雷点 ${player1}, ${player2}',
        ko: '번개 ${player1}, ${player2}'
      }
    }
  }, {
    id: 'UCU Nael Your Doom',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D2'
    },
    condition: (data, matches) => {
      return data.me === matches.target;
    },
    durationSeconds: (_data, matches) => {
      if (parseFloat(matches.duration) <= 6) return 3;
      if (parseFloat(matches.duration) <= 10) return 6;
      return 9;
    },
    suppressSeconds: 20,
    alarmText: (_data, matches, output) => {
      if (parseFloat(matches.duration) <= 6) return output.doom1();
      if (parseFloat(matches.duration) <= 10) return output.doom2();
      return output.doom3();
    },
    tts: (_data, matches, output) => {
      if (parseFloat(matches.duration) <= 6) return output.justNumber({
        num: '1'
      });
      if (parseFloat(matches.duration) <= 10) return output.justNumber({
        num: '2'
      });
      return output.justNumber({
        num: '3'
      });
    },
    outputStrings: {
      doom1: {
        en: 'Doom #1 on YOU',
        de: 'Verhängnis #1 auf DIR',
        fr: 'Glas #1 sur VOUS',
        ja: '自分に一番目死の宣告',
        cn: '死宣一号点名',
        ko: '죽음의 선고 1번'
      },
      doom2: {
        en: 'Doom #2 on YOU',
        de: 'Verhängnis #2 auf DIR',
        fr: 'Glas #2 sur VOUS',
        ja: '自分に二番目死の宣告',
        cn: '死宣二号点名',
        ko: '죽음의 선고 2번'
      },
      doom3: {
        en: 'Doom #3 on YOU',
        de: 'Verhängnis #3 auf DIR',
        fr: 'Glas #3 sur VOUS',
        ja: '自分に三番目死の宣告',
        cn: '死宣三号点名',
        ko: '죽음의 선고 3번'
      },
      justNumber: {
        en: '${num}',
        de: '${num}',
        fr: '${num}',
        ja: '${num}',
        cn: '${num}',
        ko: '${num}'
      }
    }
  }, {
    id: 'UCU Doom Init',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D2'
    },
    run: (data, matches) => {
      data.dooms ??= [null, null, null];
      let order = null;
      if (parseFloat(matches.duration) < 9) order = 0;else if (parseFloat(matches.duration) < 14) order = 1;else order = 2;

      // FIXME: temporary workaround for multiple gains effects messages.
      // https://github.com/ravahn/FFXIV_ACT_Plugin/issues/223#issuecomment-513486275
      if (order !== null && data.dooms[order] === null) data.dooms[order] = matches.target;
    }
  }, {
    id: 'UCU Doom Cleanup',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D2',
      capture: false
    },
    delaySeconds: 20,
    run: data => {
      delete data.dooms;
      delete data.doomCount;
    }
  }, {
    id: 'UCU Nael Cleanse Callout',
    type: 'Ability',
    netRegex: {
      source: 'Fang Of Light',
      id: '26CA',
      capture: false
    },
    infoText: (data, _matches, output) => {
      data.doomCount ??= 0;
      let name;
      if (data.dooms) name = data.dooms[data.doomCount];
      data.doomCount++;
      if (typeof name === 'string') return output.text({
        num: data.doomCount,
        player: data.party.member(name)
      });
    },
    outputStrings: {
      text: {
        en: 'Cleanse #${num}: ${player}',
        de: 'Medica #${num}: ${player}',
        fr: 'Purifiez #${num}: ${player}',
        ja: '解除に番目${num}: ${player}',
        cn: '解除死宣 #${num}: ${player}',
        ko: '선고 해제 ${num}: ${player}'
      }
    }
  }, {
    id: 'UCU Nael Fireball 1',
    type: 'Ability',
    netRegex: {
      source: 'Ragnarok',
      id: '26B8',
      capture: false
    },
    delaySeconds: 35,
    suppressSeconds: 99999,
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.naelFireballCount = 1,
    outputStrings: {
      text: {
        en: 'Fire IN',
        de: 'Feuer INNEN',
        fr: 'Feu à l\'INTÉRIEUR',
        ja: 'ファイアボールは密着',
        cn: '火1 分摊',
        ko: '불 같이맞기'
      }
    }
  }, {
    id: 'UCU Nael Fireball 2',
    type: 'Ability',
    netRegex: {
      source: 'Ragnarok',
      id: '26B8',
      capture: false
    },
    delaySeconds: 51,
    suppressSeconds: 99999,
    alertText: (data, _matches, output) => {
      // All players should be neutral by the time fire #2 happens.
      // If you have ice at this point, it means you missed the first
      // stack.  Therefore, make sure you stack.  It's possible you
      // can survive until fire 3 happens, but it's not 100%.
      // See: https://www.reddit.com/r/ffxiv/comments/78mdwd/bahamut_ultimate_mechanics_twin_and_nael_minutia/
      if (!data.fireballs[1]?.includes(data.me)) return output.fireOutBeInIt();
    },
    infoText: (data, _matches, output) => {
      if (data.fireballs[1]?.includes(data.me)) return output.fireOut();
    },
    run: data => data.naelFireballCount = 2,
    outputStrings: {
      fireOut: {
        en: 'Fire OUT',
        de: 'Feuer AUßEN',
        fr: 'Feu à l\'EXTÉRIEUR',
        ja: 'ファイアボールは離れ',
        cn: '火2 出人群',
        ko: '불 대상자 밖으로'
      },
      fireOutBeInIt: {
        en: 'Fire OUT: Be in it',
        de: 'Feuer AUßEN: Drin sein',
        fr: 'Feu à l\'EXTÉRIEUR : Allez dessus',
        ja: 'ファイアボールは離れ: 自分に密着',
        cn: '火2 补火',
        ko: '불 대상자 밖으로: 나는 같이 맞기'
      }
    }
  }, {
    id: 'UCU Nael Fireball 3',
    type: 'Ability',
    netRegex: {
      source: 'Ragnarok',
      id: '26B8',
      capture: false
    },
    delaySeconds: 77,
    suppressSeconds: 99999,
    alertText: (data, _matches, output) => {
      // If you were the person with fire tether #2, then you could
      // have fire debuff here and need to not stack.
      if (data.fireballs[1]?.includes(data.me) && data.fireballs[2]?.includes(data.me)) return output.fireInAvoid();
    },
    infoText: (data, _matches, output) => {
      const tookTwo = data.fireballs[1]?.filter(p => {
        return data.fireballs[2]?.includes(p);
      });
      if (tookTwo?.includes(data.me)) return;
      if (tookTwo && tookTwo.length > 0) {
        const players = tookTwo.map(name => data.party.member(name));
        return output.fireInPlayersOut({
          players: players
        });
      }
      return output.fireIn();
    },
    run: data => data.naelFireballCount = 3,
    outputStrings: {
      fireIn: {
        en: 'Fire IN',
        de: 'Feuer INNEN',
        fr: 'Feu à l\'INTÉRIEUR',
        ja: 'ファイアボールは密着',
        cn: '火3 分摊',
        ko: '불 같이맞기'
      },
      fireInPlayersOut: {
        en: 'Fire IN (${players} out)',
        de: 'Feuer INNEN (${players} raus)',
        fr: 'Feu à l\'INTÉRIEUR (${players} évitez)',
        ja: 'ファイアボールは密着 (${players}は外へ)',
        cn: '火3 (${players}躲避)',
        ko: '불 같이맞기 (${players} 는 피하기)'
      },
      fireInAvoid: {
        en: 'Fire IN: AVOID!',
        de: 'Feuer INNEN: AUSWEICHEN!',
        fr: 'Feu à l\'INTÉRIEUR : ÉVITEZ !',
        ja: 'ファイアボールは密着: 自分に離れ',
        cn: '火3 躲避！',
        ko: '불 같이맞기: 나는 피하기'
      }
    }
  }, {
    id: 'UCU Nael Fireball 4',
    type: 'Ability',
    netRegex: {
      source: 'Ragnarok',
      id: '26B8',
      capture: false
    },
    delaySeconds: 98,
    suppressSeconds: 99999,
    alertText: (data, _matches, output) => {
      const tookTwo = data.fireballs[1]?.filter(p => {
        return data.fireballs[2]?.includes(p);
      });
      const tookThree = (tookTwo ?? []).filter(p => {
        return data.fireballs[3]?.includes(p);
      });
      data.tookThreeFireballs = tookThree.includes(data.me);
      // It's possible that you can take 1, 2, and 3 even if nobody dies with
      // careful ice debuff luck.  However, this means you probably shouldn't
      // take 4.
      if (data.tookThreeFireballs) return output.fireInAvoid();
    },
    infoText: (data, _matches, output) => {
      if (!data.tookThreeFireballs) return output.fireIn();
    },
    run: data => data.naelFireballCount = 4,
    outputStrings: {
      fireIn: {
        en: 'Fire IN',
        de: 'Feuer INNEN',
        fr: 'Feu à l\'INTÉRIEUR',
        ja: 'ファイアボール密着',
        cn: '火4 分摊',
        ko: '불 같이맞기'
      },
      fireInAvoid: {
        en: 'Fire IN: AVOID!',
        de: 'Feuer INNEN: AUSWEICHEN!',
        fr: 'Feu à l\'INTÉRIEUR : ÉVITEZ !',
        ja: 'ファイアボールは密着: 自分に離れ',
        cn: '火4 躲避！',
        ko: '불 같이맞기: 나는 피하기'
      }
    }
  }, {
    id: 'UCU Dragon Tracker',
    type: 'Ability',
    netRegex: {
      source: ['Iceclaw', 'Thunderwing', 'Fang Of Light', 'Tail Of Darkness', 'Firehorn'],
      id: ['26C6', '26C7', '26CA', '26C9', '26C5']
    },
    condition: (data, matches) => !(matches.source in data.seenDragon),
    run: (data, matches) => {
      data.seenDragon[matches.source] = true;
      const x = parseFloat(matches.x);
      const y = parseFloat(matches.y);
      // Positions are the 8 cardinals + numerical slop on a radius=24 circle.
      // N = (0, -24), E = (24, 0), S = (0, 24), W = (-24, 0)
      const dir = util/* Directions.xyTo8DirNum */.N.xyTo8DirNum(x, y, unending_coil_ultimate_centerX, unending_coil_ultimate_centerY);
      data.naelDragons[dir] = 1;
      if (Object.keys(data.seenDragon).length !== 5) return;
      const result = findDragonMarks(data.naelDragons);
      if (!result) return;
      data.naelMarks = result.marks.map(i => {
        return util/* Directions.output8Dir */.N.output8Dir[i] ?? 'unknown';
      });
      data.wideThirdDive = result.wideThirdDive;
      data.unsafeThirdMark = result.unsafeThirdMark;
      // In case you forget, print marks in the log.
      // TODO: Maybe only if Options.Debug?
      console.log(data.naelMarks.join(', ') + (data.wideThirdDive ? ' (WIDE)' : ''));
    }
  }, {
    id: 'UCU Nael Ravensbeak',
    type: 'StartsUsing',
    netRegex: {
      source: 'Nael deus Darnus',
      id: '26B6'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap('alert')
  }, {
    // Called out after the 1st Ravensbeak.
    id: 'UCU Nael Dragon Placement',
    type: 'Ability',
    netRegex: {
      source: 'Nael deus Darnus',
      id: '26B6',
      capture: false
    },
    condition: data => data.naelMarks && !data.calledNaelDragons,
    durationSeconds: 10,
    infoText: (data, _matches, output) => {
      data.calledNaelDragons = true;
      const params = {
        dive1: output[data.naelMarks?.[0] ?? 'unknown'](),
        dive2: output[data.naelMarks?.[1] ?? 'unknown'](),
        dive3: output[data.naelMarks?.[2] ?? 'unknown']()
      };
      if (data.wideThirdDive) return output.marksWide(params);
      return output.marks(params);
    },
    outputStrings: {
      marks: {
        en: 'Marks: ${dive1}, ${dive2}, ${dive3}',
        de: 'Markierungen : ${dive1}, ${dive2}, ${dive3}',
        fr: 'Marque : ${dive1}, ${dive2}, ${dive3}',
        ja: 'マーカー: ${dive1}, ${dive2}, ${dive3}',
        cn: '标记: ${dive1}, ${dive2}, ${dive3}',
        ko: '징: ${dive1}, ${dive2}, ${dive3}'
      },
      marksWide: {
        en: 'Marks: ${dive1}, ${dive2}, ${dive3} (WIDE)',
        de: 'Markierungen : ${dive1}, ${dive2}, ${dive3} (GROß)',
        fr: 'Marque : ${dive1}, ${dive2}, ${dive3} (LARGE)',
        ja: 'マーカー: ${dive1}, ${dive2}, ${dive3} (広)',
        cn: '标记: ${dive1}, ${dive2}, ${dive3} (大)',
        ko: '징: ${dive1}, ${dive2}, ${dive3} (넓음)'
      },
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  }, {
    id: 'UCU Nael Dragon Dive Marker Me',
    type: 'HeadMarker',
    netRegex: {
      id: '0014'
    },
    condition: data => !data.trio,
    alarmText: (data, matches, output) => {
      if (matches.target !== data.me) return;
      const dir = data.naelMarks?.[data.naelDiveMarkerCount] ?? 'unknown';
      return output.text({
        dir: output[dir]()
      });
    },
    outputStrings: {
      text: {
        en: 'Go To ${dir} with marker',
        de: 'Gehe nach ${dir} mit dem Marker',
        fr: 'Allez direction ${dir} avec le marqueur',
        ja: 'マーカー付いたまま${dir}へ',
        cn: '带着点名去${dir}',
        ko: '${dir}으로 이동'
      },
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  }, {
    id: 'UCU Nael Dragon Dive Marker Others',
    type: 'HeadMarker',
    netRegex: {
      id: '0014'
    },
    condition: data => !data.trio,
    infoText: (data, matches, output) => {
      if (matches.target === data.me) return;
      const num = data.naelDiveMarkerCount + 1;
      return output.text({
        num: num,
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Dive #${num}: ${player}',
        de: 'Sturz #${num} : ${player}',
        fr: 'Plongeon #${num} : ${player}',
        ja: 'ダイブ${num}番目:${player}',
        cn: '冲 #${num}: ${player}',
        ko: '카탈 ${num}: ${player}'
      }
    }
  }, {
    id: 'UCU Nael Dragon Dive Marker Counter',
    type: 'HeadMarker',
    netRegex: {
      id: '0014',
      capture: false
    },
    condition: data => !data.trio,
    run: data => data.naelDiveMarkerCount++
  },
  // --- Bahamut Prime ---
  {
    // Octet marker tracking (77=nael, 14=dragon, 29=baha, 2A=twin)
    id: 'UCU Octet Marker Tracking',
    type: 'HeadMarker',
    netRegex: {
      id: ['0077', '0014', '0029']
    },
    condition: data => data.trio === 'octet',
    run: (data, matches) => {
      data.octetMarker.push(matches.target);
      if (data.octetMarker.length !== 7) return;
      const partyList = Object.keys(data.partyList);
      if (partyList.length !== 8) {
        console.error(`Octet error: bad party list size: ${JSON.stringify(partyList)}`);
        return;
      }
      const uniqDict = {};
      for (const marker of data.octetMarker) {
        uniqDict[marker] = true;
        if (!partyList.includes(marker)) {
          console.error(`Octet error: could not find ${marker} in ${JSON.stringify(partyList)}`);
          return;
        }
      }
      const uniq = Object.keys(uniqDict);
      // If the number of unique folks who took markers is not 7, then
      // somebody has died and somebody took two.  Could be on anybody.
      if (uniq.length !== 7) return;
      const remainingPlayers = partyList.filter(p => {
        return !data.octetMarker.includes(p);
      });
      if (remainingPlayers.length !== 1) {
        // This could happen if the party list wasn't unique.
        console.error(`Octet error: failed to find player, ${JSON.stringify(partyList)} ${JSON.stringify(data.octetMarker)}`);
        return;
      }

      // Finally, we found it!
      data.lastOctetMarker = remainingPlayers[0];
    }
  }, {
    id: 'UCU Octet Nael Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0077'
    },
    condition: data => data.trio === 'octet',
    infoText: (data, matches, output) => {
      const num = data.octetMarker.length;
      return output.text({
        num: num,
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: '${num}: ${player} (nael)',
        de: '${num}: ${player} (nael)',
        fr: '${num} : ${player} (nael)',
        ja: '${num}: ${player} (ネール)',
        cn: '${num}: ${player} (奈尔)',
        ko: '${num}: ${player} (넬)'
      }
    }
  }, {
    id: 'UCU Octet Dragon Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0014'
    },
    condition: data => data.trio === 'octet',
    infoText: (data, matches, output) => {
      const num = data.octetMarker.length;
      return output.text({
        num: num,
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: '${num}: ${player}',
        de: '${num}: ${player}',
        fr: '${num} : ${player}',
        ja: '${num}: ${player}',
        cn: '${num}：${player}',
        ko: '${num}: ${player}'
      }
    }
  }, {
    id: 'UCU Octet Baha Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0029'
    },
    condition: data => data.trio === 'octet',
    infoText: (data, matches, output) => {
      const num = data.octetMarker.length;
      return output.text({
        num: num,
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: '${num}: ${player} (baha)',
        de: '${num}: ${player} (baha)',
        fr: '${num} : ${player} (baha)',
        ja: '${num}: ${player} (バハ)',
        cn: '${num}: ${player} (巴哈)',
        ko: '${num}: ${player} (바하)'
      }
    }
  }, {
    id: 'UCU Octet Twin Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0029',
      capture: false
    },
    condition: data => data.trio === 'octet',
    delaySeconds: 0.5,
    alarmText: (data, _matches, output) => {
      if (data.lastOctetMarker === data.me) return output.twinOnYou();
    },
    infoText: (data, _matches, output) => {
      if (data.lastOctetMarker === undefined) return output.twinOnUnknown();

      // If this person is not alive, then everybody should stack,
      // but tracking whether folks are alive or not is a mess.
      if (data.lastOctetMarker !== data.me) return output.twinOnPlayer({
        player: data.party.member(data.lastOctetMarker)
      });
    },
    tts: (data, _matches, output) => {
      if (data.lastOctetMarker === undefined || data.lastOctetMarker === data.me) return output.stackTTS();
    },
    outputStrings: {
      twinOnYou: {
        en: 'YOU Stack for Twin',
        de: 'DU stackst für Twintania',
        fr: 'Packez-vous pour Gémellia',
        ja: '自分にタニアには頭割り',
        cn: '双塔集合',
        ko: '내가 트윈징 대상자'
      },
      twinOnPlayer: {
        en: '8: ${player} (twin)',
        de: '8: ${player} (Twintania)',
        fr: '8 : ${player} (Gémellia)',
        ja: '8: ${player} (ツインタニア)',
        cn: '8: ${player} (双塔)',
        ko: '8: ${player} (트윈타니아)'
      },
      twinOnUnknown: {
        en: '8: ??? (twin)',
        de: '8: ??? (Twintania)',
        fr: '8 : ??? (Gémellia)',
        ja: '8: ??? (ツインタニア)',
        cn: '8: ??? (双塔)',
        ko: '8: ??? (트윈타니아)'
      },
      stackTTS: {
        en: 'stack for twin',
        de: 'stek für twintania',
        fr: 'Packez-vous pour Gémellia',
        ja: '頭割り',
        cn: '双塔集合',
        ko: '트윈타니아 옆에 서기'
      }
    }
  }, {
    id: 'UCU Twister Dives',
    type: 'Ability',
    netRegex: {
      source: 'Twintania',
      id: '26B2',
      capture: false
    },
    suppressSeconds: 2,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Twisters',
        de: 'Wirbelstürme',
        fr: 'Tornades',
        ja: 'ツイスター',
        cn: '旋风冲',
        ko: '회오리'
      }
    }
  }, {
    id: 'UCU Bahamut Flatten',
    type: 'StartsUsing',
    netRegex: {
      id: '26D5',
      source: 'Bahamut Prime'
    },
    condition: conditions/* default.caresAboutPhysical */.Z.caresAboutPhysical(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'UCU Bahamut Gigaflare',
    type: 'StartsUsing',
    netRegex: {
      id: '26D6',
      source: 'Bahamut Prime',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Gigaflare',
        de: 'Gigaflare',
        fr: 'GigaBrasier',
        ja: 'ギガフレア',
        cn: '十亿核爆',
        ko: '기가플레어'
      }
    }
  }, {
    id: 'UCU Quickmarch Dive Dir',
    type: 'StartsUsing',
    netRegex: {
      id: '26E1',
      source: 'Bahamut Prime'
    },
    condition: data => data.trio === 'quickmarch',
    alertText: (_data, matches, output) => {
      // Bosses jump, and dive placement is locked once Bahamut starts casting.
      // Position data is always updated by now, so need to rely on combatant data from OP.
      // Bahamut will always be on an exact cardinal/intercardinal (w/Nael & Twin on either side)
      const x = parseFloat(matches.x);
      const y = parseFloat(matches.y);
      const diveDir = util/* Directions.xyTo8DirOutput */.N.xyTo8DirOutput(x, y, unending_coil_ultimate_centerX, unending_coil_ultimate_centerY);
      return output.dive({
        dir: output[diveDir]()
      });
    },
    outputStrings: {
      dive: {
        en: '${dir} Dive',
        de: '${dir} Sturzbombe',
        fr: 'Plongée ${dir}',
        cn: '${dir} 俯冲',
        ko: '${dir} 다이브'
      },
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  },
  // Collect sourceIds for Nael, Twin & Bahamut when they dive during Quickmarch
  // Will use these ids later to get combatant data from Overlay Plugin
  {
    id: 'UCU P3 Nael Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '26C3',
      source: 'Nael deus Darnus'
    },
    condition: data => data.trio === 'quickmarch',
    run: (data, matches) => data.trioSourceIds.nael = parseInt(matches.sourceId, 16)
  }, {
    id: 'UCU P3 Bahamut Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '26E1',
      source: 'Bahamut Prime'
    },
    condition: data => data.trio === 'quickmarch',
    run: (data, matches) => data.trioSourceIds.bahamut = parseInt(matches.sourceId, 16)
  }, {
    id: 'UCU P3 Twintania Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '26B2',
      source: 'Twintania'
    },
    condition: data => data.trio === 'quickmarch',
    run: (data, matches) => data.trioSourceIds.twin = parseInt(matches.sourceId, 16)
  },
  // For Blackfire:
  // After bosses jump, there's no clear log line we can trigger off of to find Nael's position
  // until it's effectively too late.  The best way to do this seems to be to fire the trigger
  // with a delay when Bahamut uses Blackfire Trio before all 3 bosses jump.
  {
    id: 'UCU Blackfire Party Dir',
    type: 'Ability',
    netRegex: {
      id: '26E3',
      source: 'Bahamut Prime',
      capture: false
    },
    condition: data => data.trio === 'blackfire',
    delaySeconds: 3.5,
    promise: async data => {
      if (data.trioSourceIds.nael === undefined) return;
      data.combatantData = [];
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [data.trioSourceIds.nael]
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      if (data.combatantData[0] === undefined) return;
      const nael = data.combatantData[0];
      const naelDirOutput = util/* Directions.combatantStatePosTo8DirOutput */.N.combatantStatePosTo8DirOutput(nael, unending_coil_ultimate_centerX, unending_coil_ultimate_centerY);
      return output.naelPosition({
        dir: output[naelDirOutput]()
      });
    },
    outputStrings: {
      naelPosition: {
        en: 'Nael is ${dir}',
        de: 'Nael ist im ${dir}',
        fr: 'Nael est vers ${dir}',
        cn: '奈尔在 ${dir}',
        ko: '넬 ${dir}'
      },
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  }, {
    id: 'UCU Megaflare Stack Me',
    type: 'HeadMarker',
    netRegex: {
      id: '0027'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Megaflare Stack',
        de: 'Megaflare Stack',
        fr: 'Mégabrasier, packez-vous',
        ja: 'メガフレア頭割り',
        cn: '百万核爆集合',
        ko: '기가플레어 쉐어'
      }
    }
  }, {
    id: 'UCU Megaflare Stack Tracking',
    type: 'HeadMarker',
    netRegex: {
      id: '0027'
    },
    run: (data, matches) => data.megaStack.push(matches.target)
  }, {
    id: 'UCU Megaflare Tower',
    type: 'HeadMarker',
    netRegex: {
      id: '0027',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.trio !== 'blackfire' && data.trio !== 'octet' || data.megaStack.length !== 4) return;
      if (data.megaStack.includes(data.me)) return;
      if (data.trio === 'blackfire') return output.blackfireTower();
      if (data.lastOctetMarker === undefined || data.lastOctetMarker === data.me) return output.octetTowerPlusTwin();
      return output.octetTower();
    },
    tts: (data, _matches, output) => {
      if (data.trio !== 'blackfire' && data.trio !== 'octet' || data.megaStack.length !== 4) return;
      if (!data.megaStack.includes(data.me)) return output.towerTTS();
    },
    outputStrings: {
      blackfireTower: {
        en: 'Tower, bait hypernova',
        de: 'Turm, Hypernova ködern',
        fr: 'Tour, attirez la Supernova',
        ja: 'タワーやスーパーノヴァ',
        cn: '踩塔, 引导超新星',
        ko: '초신성 피하고 기둥 밟기'
      },
      octetTowerPlusTwin: {
        en: 'Bait Twin, then tower',
        de: 'Twintania in Turm locken',
        fr: 'Attirez Gémellia, puis tour',
        ja: 'タニアダイブやタワー',
        cn: '引导双塔, 踩塔',
        ko: '트윈타니아 유도 후 기둥 밟기'
      },
      octetTower: {
        en: 'Get in a far tower',
        de: 'Geh in entfernten Turm',
        fr: 'Aller dans une tour lointaine',
        ja: '遠いタワー',
        cn: '踩远处的塔',
        ko: '기둥 밟기'
      },
      towerTTS: {
        en: 'tower',
        de: 'Turm',
        fr: 'Tour',
        ja: 'タワー',
        cn: '塔',
        ko: '기둥'
      }
    }
  }, {
    id: 'UCU Megaflare Twin Tower',
    type: 'HeadMarker',
    netRegex: {
      id: '0027',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      if (data.trio !== 'blackfire' && data.trio !== 'octet' || data.megaStack.length !== 4) return;
      if (data.lastOctetMarker === undefined || data.lastOctetMarker === data.me) return;
      const twin = data.party.member(data.lastOctetMarker);
      if (data.megaStack.includes(data.lastOctetMarker)) return output.twinHasMegaflare({
        player: twin
      });
      return output.twinHasTower({
        player: twin
      });
    },
    tts: null,
    outputStrings: {
      twinHasMegaflare: {
        en: '${player} (twin) has megaflare',
        de: '${player} (Twin) hat Megaflare',
        fr: '${player} (Gémellia) a mégabrasier',
        ja: '${player} (ツインタニア) メガ頭割り',
        cn: '${player} (双塔) 分摊点名',
        ko: '${player} (트윈 징 대상자) => 쉐어'
      },
      twinHasTower: {
        en: '${player} (twin) needs tower',
        de: '${player} (Twin) braucht einen Turm',
        fr: '${player} (Gémellia) ont besoin d\'une tour',
        ja: '${player} (ツインタニア) 塔を踏む',
        cn: '${player} (双塔) 需要踩塔',
        ko: '${player} (트윈 징 대상자) => 기둥'
      }
    }
  }, {
    id: 'UCU Heavensfall Nael Spot',
    type: 'StartsUsing',
    // Grab position data once Bahamut begins casting Megaflare Dive
    netRegex: {
      id: '26E1',
      source: 'Bahamut Prime',
      capture: false
    },
    condition: data => data.trio === 'heavensfall',
    promise: async data => {
      data.combatantData = [];
      if (data.trioSourceIds.nael === undefined || data.trioSourceIds.twin === undefined || data.trioSourceIds.bahamut === undefined) return;
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [data.trioSourceIds.nael, data.trioSourceIds.bahamut, data.trioSourceIds.twin]
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      // Bosses line up adjacent to one another, but don't necessarily have discrete directional positions (based on 8Dir scale).
      // But we can calculate their position as an angle (relative to circular arena): 0 = N, 90 = E, 180 = S, 270 = W, etc.
      let naelAngle;
      let bahamutAngle;
      let twinAngle;
      let naelPos = 'unknown';
      for (const mob of data.combatantData) {
        const mobAngle = Math.round(180 - 180 * Math.atan2(mob.PosX, mob.PosY) / Math.PI) % 360;
        // As OP does not return combatants in the order, they were passed, match based on sourceId.
        if (mob.ID === data.trioSourceIds.nael) naelAngle = mobAngle;else if (mob.ID === data.trioSourceIds.bahamut) bahamutAngle = mobAngle;else if (mob.ID === data.trioSourceIds.twin) twinAngle = mobAngle;
      }
      if (naelAngle === undefined || bahamutAngle === undefined || twinAngle === undefined) return;
      if (naelAngle >= 0 && bahamutAngle >= 0 && twinAngle >= 0) {
        if (isClockwise(naelAngle, bahamutAngle)) naelPos = isClockwise(naelAngle, twinAngle) ? 'left' : 'middle';else naelPos = isClockwise(naelAngle, twinAngle) ? 'middle' : 'right';
      }
      return output.naelPosition({
        dir: output[naelPos]()
      });
    },
    outputStrings: {
      naelPosition: {
        en: '${dir} Nael',
        de: '${dir} Nael',
        fr: 'Nael ${dir}',
        cn: '${dir} 奈尔',
        ko: '넬 ${dir}'
      },
      left: outputs/* default.left */.Z.left,
      middle: outputs/* default.middle */.Z.middle,
      right: outputs/* default.right */.Z.right,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'UCU Earthshaker Me',
    type: 'HeadMarker',
    netRegex: {
      id: '0028'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.earthshaker */.n3.earthshaker('alarm')
  }, {
    id: 'UCU Earthshaker Tracking',
    type: 'HeadMarker',
    netRegex: {
      id: '0028'
    },
    run: (data, matches) => data.shakers.push(matches.target)
  }, {
    id: 'UCU Earthshaker Not Me',
    type: 'HeadMarker',
    netRegex: {
      id: '0028',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.trio !== 'quickmarch') return;
      if (data.shakers.length !== 3) return;
      if (data.role === 'tank') return output.quickmarchTankTether();
    },
    infoText: (data, _matches, output) => {
      if (data.trio === 'quickmarch') {
        if (data.shakers.length !== 3) return;
        if (!data.shakers.includes(data.me) && data.role !== 'tank') return output.quickmarchNotOnYou();
      } else if (data.trio === 'tenstrike') {
        if (data.shakers.length === 4 && !data.shakers.includes(data.me)) return output.tenstrikeNotOnYou();
      }
    },
    run: data => {
      if (data.trio === 'tenstrike' && data.shakers.length === 4) data.shakers = [];
    },
    outputStrings: {
      quickmarchTankTether: {
        en: 'Pick up tether',
        de: 'Verbindung holen',
        fr: 'Prenez un lien',
        ja: 'テンペストウィング線',
        cn: '接线',
        ko: '줄 가로채기'
      },
      quickmarchNotOnYou: {
        en: 'No shaker; stack south.',
        de: 'Kein Erdstoß; im süden sammeln',
        fr: 'Pas de Secousse; packez-vous au Sud.',
        ja: 'シェイカーない；頭割りで南',
        cn: '无点名，南侧集合',
        ko: '징 없음, 모여서 쉐어'
      },
      tenstrikeNotOnYou: {
        en: 'Stack on safe spot',
        de: 'In Sicherheit steken',
        fr: 'Packez-vous au point safe',
        ja: '頭割りで安全',
        cn: '安全点集合',
        ko: '안전장소에 모이기'
      }
    }
  },
  // For Grand Octet:
  // After bosses and dragons start spawning, there's no clear log line we can trigger off of to find bosses' position
  // until it's effectively too late.  The best way to do this seems to be to fire the trigger
  // with a delay when Bahamut uses Grand Octet before all 3 bosses jump.
  {
    id: 'UCU Grand Octet Run & Rotate',
    type: 'Ability',
    // Grab mob position data after dragons/bosses are positioned
    netRegex: {
      id: '26E7',
      source: 'Bahamut Prime',
      capture: false
    },
    delaySeconds: 4.8,
    promise: async data => {
      data.combatantData = [];
      if (data.trioSourceIds.nael === undefined || data.trioSourceIds.bahamut === undefined) return;
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [data.trioSourceIds.nael, data.trioSourceIds.bahamut]
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      let naelDirIdx;
      let bahaDirIdx;
      for (const mob of data.combatantData) {
        const mobDirIdx = util/* Directions.combatantStatePosTo8Dir */.N.combatantStatePosTo8Dir(mob, unending_coil_ultimate_centerX, unending_coil_ultimate_centerY);
        if (mob.ID === data.trioSourceIds.nael) naelDirIdx = mobDirIdx;else if (mob.ID === data.trioSourceIds.bahamut) bahaDirIdx = mobDirIdx;
      }
      if (naelDirIdx === undefined || bahaDirIdx === undefined) return;

      // If Bahamut spaws on a cardinal, the party goes opposite and rotates counter-clockwise; if intercardinal, clockwise.
      // If Nael is directly opposite Bahamut, the party instead starts one directional position over (same as the rotation direction)
      // http://clees.me/guides/ucob/
      let rotationIdxModifier; // this is used to modify the party starting spot in directions[] if Nael is opposite Bahamut
      let rotationPath;
      const bahaOutputStr = util/* Directions.output8Dir */.N.output8Dir[bahaDirIdx];
      const cardinalDirs = util/* Directions.outputCardinalDir */.N.outputCardinalDir;
      if (bahaOutputStr === undefined) return;
      if (cardinalDirs.includes(bahaOutputStr)) {
        rotationIdxModifier = -1;
        rotationPath = 'counterclockwise';
      } else {
        rotationIdxModifier = 1;
        rotationPath = 'clockwise';
      }

      // start by going directly opposite Bahamut
      let partyStartIdx = bahaDirIdx >= 4 ? bahaDirIdx - 4 : bahaDirIdx + 4;
      // If Nael is there, instead go +1/-1 direction (depending on the rotation direction)
      if (naelDirIdx === partyStartIdx) {
        partyStartIdx += rotationIdxModifier;
        // if this pushes partyStartIdx beyond the array boundary, wrap around
        if (partyStartIdx === -1) {
          partyStartIdx = 7;
        } else if (partyStartIdx === 8) {
          partyStartIdx = 0;
        }
      }
      const partyStartDir = util/* Directions.output8Dir */.N.output8Dir[partyStartIdx] ?? 'unknown';
      if (partyStartDir === undefined || rotationPath === undefined) return;
      return output.grandOctet({
        startDir: output[partyStartDir](),
        path: output[rotationPath]()
      });
    },
    outputStrings: {
      grandOctet: {
        en: 'Bait dash, go ${startDir}, rotate ${path}',
        de: 'Ansturm ködern, gehe nach ${startDir}, rotiere ${path}',
        fr: 'Attirez le dash, allez ${startDir}, tournez ${path}',
        cn: '诱导俯冲, 去 ${startDir}, ${path} 转',
        ko: '돌진 유도, ${startDir}쪽으로, ${path}'
      },
      clockwise: outputs/* default.clockwise */.Z.clockwise,
      counterclockwise: outputs/* default.counterclockwise */.Z.counterclockwise,
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  },
  // --- Golden Bahamut ---
  {
    id: 'UCU Morn Afah',
    type: 'StartsUsing',
    netRegex: {
      id: '26EC',
      source: 'Bahamut Prime'
    },
    preRun: data => data.mornAfahCount++,
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.mornAfahYou({
        num: data.mornAfahCount
      });
      return output.mornAfahPlayer({
        num: data.mornAfahCount,
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      mornAfahYou: {
        en: 'Morn Afah #${num} (YOU)',
        de: 'Morn Afah #${num} (DU)',
        fr: 'Morn Afah #${num} (VOUS)',
        ja: 'モーン・アファー${num}回 (自分)',
        cn: '无尽顿悟 #${num}',
        ko: '몬 아파 ${num} (나에게)'
      },
      mornAfahPlayer: {
        en: 'Morn Afah #${num} (${player})',
        de: 'Morn Afah #${num} (${player})',
        fr: 'Morn Afah #${num} (${player})',
        ja: 'モーン・アファー${num}回 (${player})',
        cn: '无尽顿悟 #${num} (${player})',
        ko: '몬 아파 ${num} (${player})'
      }
    }
  }, {
    id: 'UCU Akh Morn',
    type: 'StartsUsing',
    netRegex: {
      id: '26EA',
      source: 'Bahamut Prime',
      capture: false
    },
    preRun: data => {
      data.akhMornCount++;
    },
    infoText: (data, _matches, output) => output.text({
      num: data.akhMornCount
    }),
    outputStrings: {
      text: {
        en: 'Akh Morn #${num}',
        de: 'Akh Morn #${num}',
        fr: 'Akh Morn #${num}',
        ja: 'アク・モーン #${num}',
        cn: '死亡轮回 #${num}',
        ko: '아크 몬 ${num}'
      }
    }
  }, {
    id: 'UCU Exaflare',
    type: 'StartsUsing',
    netRegex: {
      id: '26EF',
      source: 'Bahamut Prime',
      capture: false
    },
    preRun: data => data.exaflareCount++,
    infoText: (data, _matches, output) => output.text({
      num: data.exaflareCount
    }),
    outputStrings: {
      text: {
        en: 'Exaflare #${num}',
        de: 'Exaflare #${num}',
        fr: 'ExaBrasier #${num}',
        ja: 'エクサフレア${num}回',
        cn: '百京核爆 #${num}',
        ko: '엑사플레어 ${num}'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bahamut Prime': 'Prim-Bahamut',
      'Fang of Light': 'Lichtklaue',
      'Firehorn': 'Feuerhorn',
      'Iceclaw': 'Eisklaue',
      'Nael Deus Darnus': 'Nael deus Darnus',
      'Nael Geminus': 'Nael Geminus',
      'Ragnarok': 'Ragnarök',
      'Tail of Darkness': 'Dunkelschweif',
      'Thunderwing': 'Donnerschwinge',
      'Twintania': 'Twintania'
    },
    'replaceText': {
      '--push--': '--stoß--',
      'Aetheric Profusion': 'Ätherische Profusion',
      'Akh Morn': 'Akh Morn',
      'Bahamut Marker': 'Bahamut Marker',
      'Bahamut\'s Claw': 'Klauen Bahamuts',
      'Bahamut\'s Favor': 'Bahamuts Segen',
      'Blackfire Trio': 'Schwarzfeuer-Trio',
      'Calamitous Blaze': 'Katastrophale Lohe',
      'Calamitous Flame': 'Katastrophale Flammen',
      'Cauterize': 'Kauterisieren',
      'Chain Lightning': 'Kettenblitz',
      'Dalamud Dive': 'Dalamud-Sturzflug',
      'Death Sentence': 'Todesurteil',
      'Dive . Dynamo/Chariot': 'Sturzflug + Dynamo/Streitwagen',
      'Dive Dynamo Combo': 'Sturzflug Dynamo Kombo',
      'Doom': 'Verhängnis',
      'Dynamo . Beam/Chariot': 'Dynamo + Strahl/Streitwagen',
      'Earth Shaker': 'Erdstoß',
      'Exaflare': 'Exaflare',
      'Fellruin Trio': 'Untergangs-Trio',
      'Fireball(?! Soak)': 'Feuerball',
      'Flames Of Rebirth': 'Flammen der Wiedergeburt',
      'Flare Breath': 'Flare-Atem',
      'Flatten': 'Einebnen',
      'Generate': 'Formung',
      'Gigaflare': 'Gigaflare',
      'Grand Octet': 'Großes Oktett',
      'Heavensfall Trio': 'Himmelssturz-Trio',
      'Heavensfall(?! )': 'Himmelssturz',
      'Hypernova': 'Supernova',
      'Liquid Hell': 'Höllenschmelze',
      'Lunar Dive': 'Lunarer Sturz',
      '(?<! )Marker(?!\\w)': 'Marker',
      'Megaflare(?! Dive)': 'Megaflare',
      'Megaflare Dive': 'Megaflare-Sturz',
      'Meteor Stream': 'Meteorflug',
      'Meteor/Dive or Dive/Beam': 'Meteor/Sturzflug oder Sturzflug/Strahl',
      'Morn Afah': 'Morn Afah',
      'Nael Marker': 'Nael Marker',
      'Pepperoni': 'Salami',
      'Plummet(?!\/)': 'Herabstürzen',
      'Quickmarch Trio': 'Todesmarsch-Trio',
      'Random Combo Attack': 'Zufälliger Komboangriff',
      '(?<!\/)Ravensbeak': 'Bradamante',
      'Seventh Umbral Era': 'Siebte Ära des Schattens',
      'Spread': 'Verteilen',
      'Stack': 'Sammeln',
      'Targeted Fire': 'Feuer auf Ziel',
      'Tempest Wing': 'Sturm-Schwinge',
      'Tenstrike Trio': 'Zehnschlag-Trio',
      'Teraflare': 'Teraflare',
      'Thermionic . Dynamo/Chariot': 'Thermo + Dynamo/Streitwagen',
      'Thermionic Beam': 'Thermionischer Strahl',
      'Thermionic Burst': 'Thermionische Eruption',
      'Towers': 'Türme',
      'Triple Nael Quote': 'Drei Nael Zitate',
      'Twin Marker': 'Twin Marker',
      'Twister': 'Wirbelsturm',
      'Twisting Dive': 'Spiralschwinge',
      'Wings of Salvation': 'Rettende Schwinge'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bahamut Prime': 'Primo-Bahamut',
      'Fang of Light': 'croc de lumière',
      'Firehorn': 'corne-de-feu',
      'Iceclaw': 'griffe-de-glace',
      'Nael Deus Darnus': 'Nael deus Darnus',
      'Nael Geminus': 'Nael Geminus',
      'Ragnarok': 'Ragnarok',
      'Tail of Darkness': 'queue de ténèbres',
      'Thunderwing': 'aile-de-foudre',
      'Twintania': 'Gémellia'
    },
    'replaceText': {
      '--push--': '--poussé(e)--',
      'Aetheric Profusion': 'Excès d\'éther',
      'Akh Morn': 'Akh Morn',
      'Bahamut Marker': 'Marqueur de Bahamut',
      'Bahamut\'s Claw': 'Griffe de Bahamut',
      'Bahamut\'s Favor': 'Auspice du dragon',
      'Blackfire Trio': 'Trio des flammes noires',
      'Calamitous Blaze': 'Brasier du Fléau',
      'Calamitous Flame': 'Flammes du Fléau',
      'Cauterize': 'Cautérisation',
      'Chain Lightning': 'Chaîne d\'éclairs',
      'Dalamud Dive': 'Chute de Dalamud',
      'Death Sentence': 'Peine de mort',
      'Dive \\+ Dynamo/Chariot': 'Plongeon + Dynamo/Char',
      'Dive Dynamo Combo': 'Combo Plongeon Dynamo',
      'Doom': 'Glas',
      'Dynamo \\+ Beam/Chariot': 'Dynamo + Rayon/Char',
      'Earth Shaker': 'Secousse',
      'Exaflare': 'ExaBrasier',
      'Fellruin Trio': 'Trio du désastre',
      'Fireball': 'Boule de feu',
      'Flames Of Rebirth': 'Feu résurrecteur',
      'Flare Breath': 'Souffle brasier',
      'Flatten': 'Compression',
      'Generate': 'Synthèse de mana',
      'Gigaflare': 'GigaBrasier',
      'Grand Octet': 'Octuors des dragons',
      'Heavensfall Trio': 'Trio de l\'univers',
      'Heavensfall(?! Trio)': 'Destruction Universelle',
      'Hypernova': 'Hypernova',
      'Iron Chariot': 'Char de fer',
      'Liquid Hell': 'Enfer liquide',
      'Lunar Dive': 'Plongeon lunaire',
      'Lunar Dynamo': 'Dynamo lunaire',
      '(?<! )Marker(?!\\w)': 'Marqueur',
      'Megaflare(?! Dive)': 'MégaBrasier',
      'Megaflare Dive': 'Plongeon MégaBrasier',
      'Meteor Stream': 'Rayon météore',
      'Meteor/Dive or Dive/Beam': 'Météore/Plongeon ou Plongeon/Rayon',
      'Morn Afah': 'Morn Afah',
      'Nael Marker': 'Marqueur de Nael',
      'Pepperoni': 'Zones au sol',
      'Plummet': 'Piqué',
      'Quickmarch Trio': 'Trio de la marche militaire',
      'Random Combo Attack': 'Combo d\'attaque aléatoire',
      'Ravensbeak': 'Bec du rapace',
      'Raven Dive': 'Fonte du rapace',
      'Seventh Umbral Era': '7e fléau',
      'Spread': 'Dispersion',
      'Stack': 'Package',
      'Targeted Fire': 'Feu ciblé',
      'Tempest Wing': 'Aile de tempête',
      'Tenstrike Trio': 'Trio des attaques',
      'Teraflare': 'TéraBrasier',
      'Thermionic \\+ Dynamo/Chariot': 'Rayon + Dynamo/Char',
      'Thermionic Beam': 'Rayon thermoïonique',
      'Thermionic Burst': 'Rafale thermoïonique',
      'Towers': 'Tours',
      'Triple Nael Quote': 'Triple citation de Nael',
      'Twin Marker': 'Marqueur de Gémellia',
      'Twister': 'Grande trombe',
      'Twisting Dive': 'Plongeon-trombe',
      'Wings of Salvation': 'Aile de la salvation'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bahamut Prime': 'バハムート・プライム',
      'Fang of Light': 'ライトファング',
      'Firehorn': 'ファイアホーン',
      'Iceclaw': 'アイスクロウ',
      'Nael Deus Darnus': 'ネール・デウス・ダーナス',
      'Nael Geminus': 'ネール・ジェミナス',
      'Ragnarok': 'ラグナロク',
      'Tail of Darkness': 'ダークテイル',
      'Thunderwing': 'サンダーウィング',
      'Twintania': 'ツインタニア'
    },
    'replaceText': {
      '--push--': '--フェイス切替--',
      'Aetheric Profusion': 'エーテリックプロフュージョン',
      'Akh Morn': 'アク・モーン',
      'Bahamut Marker': 'バハムート マーク',
      'Bahamut\'s Claw': 'バハムートクロウ',
      'Bahamut\'s Favor': '龍神の加護',
      'Blackfire Trio': '黒炎の三重奏',
      'Calamitous Blaze': '災いの焔',
      'Calamitous Flame': '災いの炎',
      'Cauterize': 'カータライズ',
      'Chain Lightning': 'チェインライトニング',
      'Dalamud Dive': 'ダラガブダイブ',
      'Death Sentence': 'デスセンテンス',
      'Dive . Dynamo/Chariot': 'ダイブ + ダイナモ/チャリオット',
      'Dive Dynamo Combo': 'ダイブ ダイナモ コンボ',
      'Doom': '死の宣告',
      'Dynamo . Beam/Chariot': 'ダイナモ + ビーム/チャリオット',
      'Earth Shaker': 'アースシェイカー',
      'Exaflare': 'エクサフレア',
      'Fellruin Trio': '厄災の三重奏',
      'Fireball(?! Soak)': 'ファイアボール',
      'Flames Of Rebirth': '転生の炎',
      'Flare Breath': 'フレアブレス',
      'Flatten': 'フラッテン',
      'Generate': '魔力錬成',
      'Gigaflare': 'ギガフレア',
      'Grand Octet': '群竜の八重奏',
      'Heavensfall Trio': '天地の三重奏',
      'Heavensfall(?! )': '天地崩壊',
      'Hypernova': 'スーパーノヴァ',
      'Liquid Hell': 'ヘルリキッド',
      'Lunar Dive': 'ルナダイブ',
      '(?<! )Marker(?!\\w)': 'マーク',
      'Megaflare(?! Dive)': 'メガフレア',
      'Megaflare Dive': 'メガフレアダイブ',
      'Meteor Stream': 'メテオストリーム',
      'Meteor/Dive or Dive/Beam': 'メテオ/ダイブ や ダイブ/ビーム',
      'Morn Afah': 'モーン・アファー',
      'Nael Marker': 'ネール マーク',
      'Pepperoni': '輪',
      'Plummet(?!\/)': 'プラメット',
      'Quickmarch Trio': '進軍の三重奏',
      'Random Combo Attack': 'ランダムコンボ',
      '(?<!\/)Ravensbeak': 'レイヴェンズビーク',
      'Seventh Umbral Era': '第七霊災',
      'Spread': '散開',
      'Stack': '集合',
      'Targeted Fire': 'タゲしたファイヤ',
      'Tempest Wing': 'テンペストウィング',
      'Tenstrike Trio': '連撃の三重奏',
      'Teraflare': 'テラフレア',
      'Thermionic . Dynamo/Chariot': 'サーミオニック + ダイナモ/チャリオット',
      'Thermionic Beam': 'サーミオニックビーム',
      'Thermionic Burst': 'サーミオニックバースト',
      'Towers': '塔',
      'Triple Nael Quote': '三体の黒玉',
      'Twin Marker': 'Twin Marker',
      'Twister': 'ツイスター',
      'Twisting Dive': 'ツイスターダイブ',
      'Wings of Salvation': 'サルヴェーションウィング'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bahamut Prime': '至尊巴哈姆特',
      'Fang of Light': '光牙',
      'Firehorn': '火角',
      'Iceclaw': '冰爪',
      'Nael Deus Darnus': '奈尔·神·达纳斯',
      'Nael Geminus': '奈尔双生子',
      'Ragnarok': '诸神黄昏',
      'Tail of Darkness': '暗尾',
      'Thunderwing': '雷翼',
      'Twintania': '双塔尼亚'
    },
    'replaceText': {
      '--push--': '--开怪--',
      'Aetheric Profusion': '以太失控',
      'Akh Morn': '死亡轮回',
      'Bahamut Marker': '巴哈标记',
      'Bahamut\'s Claw': '巴哈姆特之爪',
      'Bahamut\'s Favor': '龙神的加护',
      'Blackfire Trio': '黑炎的三重奏',
      'Calamitous Blaze': '灵灾之焰',
      'Calamitous Flame': '灵灾之炎',
      'Cauterize': '低温俯冲',
      'Chain Lightning': '雷光链',
      'Dalamud Dive': '月华冲',
      'Death Sentence': '死刑',
      'Dive . Dynamo/Chariot': '冲 + 月环/钢铁',
      'Dive Dynamo Combo': '冲月环连招',
      'Doom': '死亡宣告',
      'Dynamo . Beam/Chariot': '月环 + 光束/钢铁',
      'Earth Shaker': '大地摇动',
      'Exaflare': '百京核爆',
      'Fellruin Trio': '灾厄的三重奏',
      'Fireball(?! Soak)': '火球',
      'Flames Of Rebirth': '转生之炎',
      'Flare Breath': '核爆吐息',
      'Flatten': '夷为平地',
      'Generate': '魔力炼成',
      'Gigaflare': '十亿核爆',
      'Grand Octet': '群龙的八重奏',
      'Heavensfall Trio': '天地的三重奏',
      'Heavensfall(?! )': '天崩地裂',
      'Hypernova': '超新星',
      'Liquid Hell': '液体地狱',
      'Lunar Dive': '月流冲',
      '(?<! )Marker(?!\\w)': '标记',
      'Megaflare(?! Dive)': '百万核爆',
      'Megaflare Dive': '百万核爆冲',
      'Meteor Stream': '陨石流',
      'Meteor/Dive or Dive/Beam': '陨石/冲 或 冲/光束',
      'Morn Afah': '无尽顿悟',
      'Nael Marker': '奈尔标记',
      'Pepperoni': '大圈',
      'Plummet(?!\/)': '垂直下落',
      'Quickmarch Trio': '进军的三重奏',
      'Random Combo Attack': '随机连招',
      '(?<!\/)Ravensbeak': '凶鸟尖喙',
      'Seventh Umbral Era': '第七灵灾',
      'Spread': '分散',
      'Stack': '集合',
      'Targeted Fire': '火球点名',
      'Tempest Wing': '风暴之翼',
      'Tenstrike Trio': '连击的三重奏',
      'Teraflare': '万亿核爆',
      'Thermionic . Dynamo/Chariot': '离子 + 月环/钢铁',
      'Thermionic Beam': '热离子光束',
      'Thermionic Burst': '热离子爆发',
      'Towers': '塔',
      'Triple Nael Quote': '三黑球',
      'Twin Marker': '双塔标记',
      'Twister': '旋风',
      'Twisting Dive': '旋风冲',
      'Wings of Salvation': '救世之翼'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bahamut Prime': '바하무트 프라임',
      'Fang of Light': '빛의 송곳니',
      'Firehorn': '화염뿔',
      'Iceclaw': '얼음발톱',
      'Nael Deus Darnus': '넬 데우스 다르누스',
      'Nael Geminus': '넬 게미누스',
      'Ragnarok': '라그나로크',
      'Tail of Darkness': '어둠의 꼬리',
      'Thunderwing': '번개날개',
      'Twintania': '트윈타니아'
    },
    'replaceText': {
      '--push--': '--최소 RDPS컷--',
      'Aetheric Profusion': '에테르 홍수',
      'Akh Morn': '아크 몬',
      'Bahamut Marker': '바하무트 징',
      'Bahamut\'s Claw': '바하무트의 발톱',
      'Bahamut\'s Favor': '용신의 가호',
      'Blackfire Trio': '흑염의 3중주',
      'Calamitous Blaze': '재앙의 화염',
      'Calamitous Flame': '재앙의 불꽃',
      'Cauterize': '인두질',
      'Chain Lightning': '번개 사슬',
      'Dalamud Dive': '달라가브 강하',
      'Death Sentence': '사형 선고',
      'Dive . Dynamo/Chariot': '강하 + 달/강철',
      'Dive Dynamo Combo': '강하 달 콤보',
      'Doom': '죽음의 선고',
      'Dynamo . Beam/Chariot': '달 + 광선/강철',
      'Earth Shaker': '요동치는 대지',
      'Exaflare': '엑사플레어',
      'Fellruin Trio': '재앙의 3중주',
      'Fireball(?! Soak)': '화염구',
      'Flames Of Rebirth': '윤회의 불꽃',
      'Flare Breath': '타오르는 숨결',
      'Flatten': '짓뭉개기',
      'Generate': '마력 연성',
      'Gigaflare': '기가플레어',
      'Grand Octet': '용들의 8중주',
      'Heavensfall Trio': '천지의 3중주',
      'Heavensfall(?! )': '천지붕괴(?! )',
      'Hypernova': '초신성',
      'Liquid Hell': '지옥의 늪',
      'Lunar Dive': '달 강하',
      '(?<! )Marker(?!\\w)': '징',
      'Megaflare(?! Dive)': '메가플레어',
      'Megaflare Dive': '메가플레어 다이브',
      'Meteor Stream': '유성 폭풍',
      'Meteor/Dive or Dive/Beam': '유성/강하 or 강하/광선',
      'Morn Afah': '몬 아파',
      'Nael Marker': '넬 징',
      'Pepperoni': '메가플레어 장판',
      'Plummet(?!\/)': '곤두박질',
      'Quickmarch Trio': '진군의 3중주',
      'Random Combo Attack': '랜덤 콤보 공격',
      '(?<!\/)Ravensbeak': '흉조의 부리',
      'Seventh Umbral Era': '제7재해',
      'Spread': '산개',
      'Stack': '모이기',
      'Targeted Fire': '대상자 화염구',
      'Tempest Wing': '폭풍우 날개',
      'Tenstrike Trio': '연격의 3중주',
      'Teraflare': '테라플레어',
      'Thermionic . Dynamo/Chariot': '열전자 + 달/강철',
      'Thermionic Beam': '열전자 광선',
      'Thermionic Burst': '열전자 폭발',
      'Towers': '기둥',
      'Triple Nael Quote': '넬 3회 대사',
      'Twin Marker': '트윈 징',
      'Twister': '회오리',
      'Twisting Dive': '회오리 강하',
      'Wings of Salvation': '구원의 날개'
    }
  }]
};
/* harmony default export */ const unending_coil_ultimate = (unending_coil_ultimate_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/04-sb/ultimate/unending_coil_ultimate.txt
const ultimate_unending_coil_ultimate_namespaceObject = "### Unending Coil of Bahamut (Ultimate)\r\n# http://clees.me/guides/ucob/\r\n# -ii 26A7 26B4 26D0 26C6 26C7 26DA 26D8 26AF 26F0 26F1\r\n# -p 26A8:7 26AD:47.5 26B8:200 26D1:500 26E9:1200\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n##### TWINTANIA #####\r\n### Twintania P1: 100% -> 75%\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.0 \"Plummet\" Ability { id: \"26A8\", source: \"Twintania\" } window 12,12\r\n13.1 \"Twister\" Ability { id: \"26AA\", source: \"Twintania\" }\r\n16.3 \"Fireball\" Ability { id: \"26AC\", source: \"Twintania\" }\r\n24.5 \"Death Sentence\" Ability { id: \"26A9\", source: \"Twintania\" }\r\n27.6 \"Plummet\" Ability { id: \"26A8\", source: \"Twintania\" }\r\n32.8 \"Twister\" Ability { id: \"26AA\", source: \"Twintania\" }\r\n36.0 \"Fireball\" Ability { id: \"26AC\", source: \"Twintania\" }\r\n40.0 \"--push--\"\r\n#44.2 \"Death Sentence\" Ability { id: \"26A9\", source: \"Twintania\" }\r\n# TODO: presumably 44.2 is a loop back to 24.5.\r\n\r\n### Twintania P2: 75% -> 45%\r\n47.5 \"Liquid Hell x5\" Ability { id: \"26AD\", source: \"Twintania\" } duration 4.5 window 50,0\r\n53.0 \"--sync--\" StartsUsing { id: \"26AE\", source: \"Twintania\" } window 53,10\r\n56.0 \"Generate\" Ability { id: \"26AE\", source: \"Twintania\" }\r\n59.1 \"Liquid Hell x5\" duration 4.5 #Ability { id: \"26AD\", source: \"Twintania\" }\r\n70.6 \"Death Sentence\" Ability { id: \"26A9\", source: \"Twintania\" }\r\n77.6 \"Generate\" Ability { id: \"26AE\", source: \"Twintania\" }\r\n80.6 \"Twister\" Ability { id: \"26AA\", source: \"Twintania\" }\r\n86.6 \"Plummet\" Ability { id: \"26A8\", source: \"Twintania\" }\r\n91.7 \"Liquid Hell x5\" duration 4.5 #Ability { id: \"26AD\", source: \"Twintania\" }\r\n99.0 \"--push--\"\r\n# TODO: presumably 91.7 is a loop back to 47.5.\r\n\r\n### Twintania P3: 45% -> 0%\r\n106.4 \"Liquid Hell x5\" duration 4.5 #Ability { id: \"26AD\", source: \"Twintania\" }\r\n111.9 \"--sync--\" StartsUsing { id: \"26AE\", source: \"Twintania\" } window 30,10\r\n114.9 \"Generate x2\" Ability { id: \"26AE\", source: \"Twintania\" }\r\n118.0 \"Targeted Fire x5\" duration 4.5 #Ability { id: \"26AD\", source: \"Twintania\" }\r\n124.6 \"Fireball\" Ability { id: \"26AC\", source: \"Twintania\" } window 70,10\r\n133.6 \"Death Sentence\" Ability { id: \"26A9\", source: \"Twintania\" }\r\n136.6 \"Plummet\" Ability { id: \"26A8\", source: \"Twintania\" }\r\n143.6 \"Generate x2\" Ability { id: \"26AE\", source: \"Twintania\" }\r\n146.6 \"Twister\" Ability { id: \"26AA\", source: \"Twintania\" }\r\n151.6 \"Plummet\" Ability { id: \"26A8\", source: \"Twintania\" }\r\n\r\n153.8 \"Liquid Hell x5\" duration 4.5 #Ability { id: \"26AD\", source: \"Twintania\" }\r\n162.3 \"Generate x2\" Ability { id: \"26AE\", source: \"Twintania\" }\r\n165.4 \"Targeted Fire x5\" duration 4.5 #Ability { id: \"26AD\", source: \"Twintania\" }\r\n172.0 \"Fireball\" Ability { id: \"26AC\", source: \"Twintania\" } window 20,20 jump 124.6\r\n181.0 \"Death Sentence\" #Ability { id: \"26A9\", source: \"Twintania\" }\r\n184.0 \"Plummet\" #Ability { id: \"26A8\", source: \"Twintania\" }\r\n191.0 \"Generate x2\" #Ability { id: \"26AE\", source: \"Twintania\" }\r\n194.0 \"Twister\" #Ability { id: \"26AA\", source: \"Twintania\" }\r\n199.0 \"Plummet\" #Ability { id: \"26A8\", source: \"Twintania\" }\r\n\r\n\r\n##### NAEL #####\r\n200.0 \"Heavensfall\" Ability { id: \"26B8\", source: \"Ragnarok\" } window 200,0\r\n205.5 \"Meteor Stream x4\" Ability { id: \"26C0\", source: \"Nael Geminus\" }\r\n207.0 \"Thermionic Burst\" Ability { id: \"26B9\", source: \"Ragnarok\" }\r\n208.5 \"Meteor Stream x4\" Ability { id: \"26C0\", source: \"Nael Geminus\" }\r\n211.0 \"Thermionic Burst\" Ability { id: \"26B9\", source: \"Ragnarok\" }\r\n211.5 \"Dalamud Dive\" Ability { id: \"26C1\", source: \"Nael deus Darnus\" }\r\n\r\n213.5 \"--targetable--\"\r\n213.6 \"Bahamut's Claw x5\" duration 2.8 #Ability { id: \"26B5\", source: \"Nael deus Darnus\" }\r\n222.1 \"Bahamut's Favor\" Ability { id: \"26C2\", source: \"Nael deus Darnus\" }\r\n\r\n230.6 \"Dynamo + Beam/Chariot\" duration 8\r\n235.1 \"Chain Lightning x2\" Ability { id: \"26C8\", source: \"Thunderwing\" }\r\n#235.1 \"Lunar Dynamo\" Ability { id: \"26BC\", source: \"Nael deus Darnus\" }\r\n#238.3 \"Thermionic Beam\" Ability { id: \"26BD\", source: \"Nael deus Darnus\" }\r\n239.1 \"Doom x2\" Ability { id: \"26C9\", source: \"Tail of Darkness\" }\r\n241.1 \"Fireball (1)\" Ability { id: \"26C5\", source: \"Firehorn\" }\r\n242.1 \"Wings Of Salvation x2\" Ability { id: \"26CA\", source: \"Fang of Light\" } duration 4\r\n249.3 \"Bahamut's Claw x5\" duration 2.8 #Ability { id: \"26B5\", source: \"Nael deus Darnus\" }\r\n256.0 \"Fireball (2)\" Ability { id: \"26C5\", source: \"Firehorn\" }\r\n\r\n258.0 \"Thermionic + Dynamo/Chariot\" duration 8\r\n260.0 \"Chain Lightning\" Ability { id: \"26C8\", source: \"Thunderwing\" }\r\n#262.8 \"Thermionic Beam\" Ability { id: \"26BD\", source: \"Nael deus Darnus\" }\r\n#265.8 \"Lunar Dynamo\" Ability { id: \"26BC\", source: \"Nael deus Darnus\" }\r\n268.0 \"Doom x3\" Ability { id: \"26C9\", source: \"Tail of Darkness\" }\r\n270.0 \"Wings Of Salvation x3\" Ability { id: \"26CA\", source: \"Fang of Light\" } duration 8\r\n278.9 \"Chain Lightning x2\" Ability { id: \"26C8\", source: \"Thunderwing\" }\r\n281.9 \"Fireball (3)\" Ability { id: \"26C5\", source: \"Firehorn\" }\r\n\r\n284.7 \"Bahamut's Claw x5\" Ability { id: \"26B5\", source: \"Nael deus Darnus\" } duration 2.8\r\n290.4 \"Dive + Dynamo/Chariot\" duration 8\r\n#295.3 \"Raven Dive\" Ability { id: \"26BE\", source: \"Nael deus Darnus\" }\r\n#298.3 \"Lunar Dynamo\" Ability { id: \"26BC\", source: \"Nael deus Darnus\" }\r\n302.9 \"Fireball (4)\" Ability { id: \"26C5\", source: \"Firehorn\" }\r\n303.9 \"Doom x3\" Ability { id: \"26C9\", source: \"Tail of Darkness\" }\r\n305.9 \"Chain Lightning x2\" Ability { id: \"26C8\", source: \"Thunderwing\" }\r\n306.0 \"Wings Of Salvation x3\" Ability { id: \"26CA\", source: \"Fang of Light\" } duration 8\r\n323.3 \"Ravensbeak\" Ability { id: \"26B6\", source: \"Nael deus Darnus\" }\r\n\r\n328.5 \"Marker 1\"\r\n332.5 \"Marker 2\"\r\n333.5 \"Hypernova x4\" duration 6 #Ability { id: \"26BF\", source: \"Nael deus Darnus\" }\r\n336.5 \"Marker 3\"\r\n339.5 \"Cauterize\" #Ability { id: \"26CD\", source: \"Thunderwing\" }\r\n#339.5 \"Cauterize\" #Ability { id: \"26CE\", source: \"Tail of Darkness\" }\r\n341.0 \"--untargetable--\"\r\n341.0 \"Meteor/Dive or Dive/Beam\" duration 3 # first mechanic -> second\r\n#342.7 \"Meteor Stream\" Ability { id: \"26C0\", source: \"Nael Geminus\" }\r\n343.5 \"Cauterize\" #Ability { id: \"26CB\", source: \"Firehorn\" }\r\n#345.7 \"Dalamud Dive\" Ability { id: \"26C1\", source: \"Nael deus Darnus\" }\r\n347.4 \"Cauterize\" #Ability { id: \"26CC\", source: \"Iceclaw\" }\r\n#347.5 \"Cauterize\" #Ability { id: \"26CF\", source: \"Fang of Light\" }\r\n\r\n349.7 \"Bahamut's Claw x5\" duration 2.8 #Ability { id: \"26B5\", source: \"Nael deus Darnus\" }\r\n\r\n361.2 \"Random Combo Attack\" duration 8\r\n#366.2 \"Thermionic Beam\" Ability { id: \"26BD\", source: \"Nael deus Darnus\" }\r\n#369.2 \"Lunar Dynamo\" Ability { id: \"26BC\", source: \"Nael deus Darnus\" }\r\n\r\n372.7 \"Random Combo Attack\" duration 8\r\n#377.3 \"Raven Dive\" Ability { id: \"26BE\", source: \"Nael deus Darnus\" }\r\n#380.3 \"Lunar Dynamo\" Ability { id: \"26BC\", source: \"Nael deus Darnus\" }\r\n\r\n388.7 \"Ravensbeak\" Ability { id: \"26B6\", source: \"Nael deus Darnus\" }\r\n395.7 \"Bahamut's Claw x5\" duration 2.8 #Ability { id: \"26B5\", source: \"Nael deus Darnus\" }\r\n403.2 \"--untargetable--\"\r\n408.2 \"Megaflare Enrage\" Ability { id: \"26BA\", source: \"Nael deus Darnus\" }\r\n\r\n\r\n##### BAHAMUT #####\r\n500.0 \"Seventh Umbral Era\" Ability { id: \"26D1\", source: \"Bahamut Prime\" } window 500,0\r\n503.0 \"Calamitous Flame x3\" Ability { id: \"26D2\", source: \"Bahamut Prime\" } duration 2\r\n508.0 \"Calamitous Blaze\" Ability { id: \"26D3\", source: \"Bahamut Prime\" }\r\n511.0 \"--targetable--\"\r\n517.0 \"Flare Breath\" Ability { id: \"26D4\", source: \"Bahamut Prime\" }\r\n525.0 \"Flatten\" Ability { id: \"26D5\", source: \"Bahamut Prime\" }\r\n\r\n### QUICKMARCH\r\n532.0 \"Quickmarch Trio\" Ability { id: \"26E2\", source: \"Bahamut Prime\" } window 30,10\r\n534.0 \"--untargetable--\"\r\n#540.0 \"Megaflare Dive\" Ability { id: \"26E1\", source: \"Bahamut Prime\" }\r\n#540.0 \"Lunar Dive\" Ability { id: \"26C3\", source: \"Nael deus Darnus\" }\r\n540.0 \"Twisting Dive\" Ability { id: \"26B2\", source: \"Twintania\" }\r\n544.0 \"Spread\" Ability { id: \"26DC\", source: \"Bahamut Prime\" }\r\n545.0 \"--targetable--\"\r\n546.0 \"Pepperoni\" Ability { id: \"26DD\", source: \"Bahamut Prime\" }\r\n548.0 \"Stack\" Ability { id: \"26DE\", source: \"Bahamut Prime\" }\r\n550.0 \"Earth Shaker x3\" Ability { id: \"26D9\", source: \"Bahamut Prime\" }\r\n552.0 \"Tempest Wing\" Ability { id: \"26D7\", source: \"Bahamut Prime\" }\r\n\r\n555.9 \"Flare Breath\" Ability { id: \"26D4\", source: \"Bahamut Prime\" }\r\n563.9 \"Flatten\" Ability { id: \"26D5\", source: \"Bahamut Prime\" }\r\n\r\n### BLACKFIRE\r\n572.0 \"Blackfire Trio\" Ability { id: \"26E3\", source: \"Bahamut Prime\" } window 70,10\r\n574.0 \"--untargetable--\"\r\n576.0 \"Liquid Hell x5\" duration 4.5 #Ability { id: \"26AD\", source: \"Twintania\" }\r\n579.0 \"Thermionic Beam\" Ability { id: \"26BD\", source: \"Nael deus Darnus\" }\r\n580.0 \"Megaflare Dive\" Ability { id: \"26E1\", source: \"Bahamut Prime\" }\r\n586.1 \"Hypernova x4\" duration 4.5 #Ability { id: \"26BF\", source: \"Nael deus Darnus\" }\r\n588.0 \"Stack\" Ability { id: \"26DE\", source: \"Bahamut Prime\" }\r\n590.0 \"Towers\" Ability { id: \"26DF\", source: \"Bahamut Prime\" }\r\n\r\n590.0 \"--targetable--\"\r\n596.0 \"Gigaflare\" Ability { id: \"26D6\", source: \"Bahamut Prime\" }\r\n605.0 \"Flare Breath 1\" #Ability { id: \"26D4\", source: \"Bahamut Prime\" }\r\n607.0 \"Flare Breath 2\" #Ability { id: \"26D4\", source: \"Bahamut Prime\" }\r\n609.0 \"Flare Breath 3\" #Ability { id: \"26D4\", source: \"Bahamut Prime\" }\r\n\r\n### FELLRUIN\r\n622.0 \"Fellruin Trio\" Ability { id: \"26E4\", source: \"Bahamut Prime\" } window 130,10\r\n624.0 \"--untargetable--\"\r\n626.6 \"Dive Dynamo Combo\" duration 8\r\n#631.1 \"Lunar Dynamo\" Ability { id: \"26BC\", source: \"Nael deus Darnus\" }\r\n#634.1 \"Raven Dive\" Ability { id: \"26BE\", source: \"Nael deus Darnus\" }\r\n637.1 \"Tempest Wing\" Ability { id: \"26D7\", source: \"Bahamut Prime\" }\r\n638.1 \"Aetheric Profusion\" Ability { id: \"26B1\", source: \"Twintania\" }\r\n\r\n640.1 \"--targetable--\"\r\n641.1 \"Meteor Stream\" Ability { id: \"26C0\", source: \"Nael Geminus\" }\r\n646.1 \"Gigaflare\" Ability { id: \"26D6\", source: \"Bahamut Prime\" }\r\n651.4 \"Flare Breath\" Ability { id: \"26D4\", source: \"Bahamut Prime\" }\r\n660.4 \"Flatten\" Ability { id: \"26D5\", source: \"Bahamut Prime\" }\r\n665.4 \"Flare Breath\" Ability { id: \"26D4\", source: \"Bahamut Prime\" }\r\n\r\n#### HEAVENSFALL\r\n673.4 \"Heavensfall Trio\" Ability { id: \"26E5\", source: \"Bahamut Prime\" } window 170,10\r\n675.4 \"--untargetable--\"\r\n#681.4 \"Megaflare Dive\" Ability { id: \"26E1\", source: \"Bahamut Prime\" }\r\n681.4 \"Twisting Dive\" Ability { id: \"26B2\", source: \"Twintania\" }\r\n686.9 \"Heavensfall\" Ability { id: \"26B7\", source: \"Nael deus Darnus\" }\r\n687.4 \"Pepperoni\" Ability { id: \"26DD\", source: \"Bahamut Prime\" }\r\n688.9 \"Heavensfall\" Ability { id: \"26B8\", source: \"Ragnarok\" }\r\n691.4 \"Towers\" Ability { id: \"26DF\", source: \"Bahamut Prime\" }\r\n694.5 \"Hypernova x3\" duration 3.2 #Ability { id: \"26BF\", source: \"Nael deus Darnus\" }\r\n696.0 \"Thermionic Burst x8\" duration 5 #Ability { id: \"26B9\", source: \"Ragnarok\" }\r\n\r\n702.5 \"--targetable--\"\r\n703.5 \"Fireball\" Ability { id: \"26AC\", source: \"Twintania\" }\r\n708.5 \"Gigaflare\" Ability { id: \"26D6\", source: \"Bahamut Prime\" }\r\n717.5 \"Flare Breath 1\" #Ability { id: \"26D4\", source: \"Bahamut Prime\" }\r\n719.5 \"Flare Breath 2\" #Ability { id: \"26D4\", source: \"Bahamut Prime\" }\r\n721.5 \"Flare Breath 3\" #Ability { id: \"26D4\", source: \"Bahamut Prime\" }\r\n\r\n### TENSTRIKE\r\n733.5 \"Tenstrike Trio\" Ability { id: \"26E6\", source: \"Bahamut Prime\" } window 200,10\r\n735.5 \"--untargetable--\"\r\n740.5 \"Generate x3\" Ability { id: \"26AE\", source: \"Twintania\" }\r\n741.5 \"Meteor Stream (dps)\" duration 3 #Ability { id: \"26C0\", source: \"Nael Geminus\" }\r\n744.5 \"Generate x3\" Ability { id: \"26AE\", source: \"Twintania\" }\r\n745.5 \"Meteor Stream (T/H)\" duration 3 #Ability { id: \"26C0\", source: \"Nael Geminus\" }\r\n754.4 \"--targetable--\"\r\n754.4 \"Earth Shaker x4\" Ability { id: \"26D9\", source: \"Bahamut Prime\" }\r\n759.4 \"Earth Shaker x4\" Ability { id: \"26D9\", source: \"Bahamut Prime\" }\r\n\r\n767.4 \"Gigaflare\" Ability { id: \"26D6\", source: \"Bahamut Prime\" }\r\n778.4 \"Flatten\" Ability { id: \"26D5\", source: \"Bahamut Prime\" }\r\n781.4 \"Flare Breath\" Ability { id: \"26D4\", source: \"Bahamut Prime\" }\r\n\r\n### GRAND OCTET\r\n789.4 \"Grand Octet\" Ability { id: \"26E7\", source: \"Bahamut Prime\" } window 200,10\r\n791.4 \"--untargetable--\"\r\n797.4 \"Nael Marker\"\r\n801.4 \"Lunar Dive\" Ability { id: \"26C3\", source: \"Nael deus Darnus\" }\r\n808.4 \"Cauterize\" #Ability { id: \"26CB\", source: \"Firehorn\" }\r\n810.6 \"Cauterize\" #Ability { id: \"26CC\", source: \"Iceclaw\" }\r\n812.6 \"Cauterize\" #Ability { id: \"26CF\", source: \"Fang of Light\" }\r\n814.4 \"Bahamut Marker\"\r\n814.6 \"Cauterize\" #Ability { id: \"26CD\", source: \"Thunderwing\" }\r\n816.6 \"Cauterize\" #Ability { id: \"26CE\", source: \"Tail of Darkness\" }\r\n818.6 \"Megaflare Dive\" Ability { id: \"26E1\", source: \"Bahamut Prime\" }\r\n823.4 \"Twin Marker\"\r\n826.4 \"Stack\" Ability { id: \"26DE\", source: \"Bahamut Prime\" }\r\n827.6 \"Twisting Dive\" Ability { id: \"26B2\", source: \"Twintania\" }\r\n828.4 \"Towers\" Ability { id: \"26DF\", source: \"Bahamut Prime\" }\r\n\r\n\r\n##### ADDS PHASE: NAEL + TWIN #####\r\n843.4 \"Bahamut's Favor\" Ability { id: \"26E8\", source: \"Bahamut Prime\" } window 1000,100\r\n844.9 \"--targetable--\"\r\n852.9 \"Bahamut's Claw x5\" duration 2.8 #Ability { id: \"26B5\", source: \"Nael deus Darnus\" }\r\n852.9 \"Plummet\" Ability { id: \"26A8\", source: \"Twintania\" }\r\n\r\n856.0 \"Liquid Hell x5\" duration 4.5 #Ability { id: \"26AD\", source: \"Twintania\" }\r\n864.5 \"Generate x3\" Ability { id: \"26AE\", source: \"Twintania\" }\r\n868.6 \"Twister\" Ability { id: \"26AA\", source: \"Twintania\" }\r\n871.6 \"Triple Nael Quote\"\r\n#876.3 \"Iron Chariot\" Ability { id: \"26BB\", source: \"Nael deus Darnus\" }\r\n#879.3 \"Thermionic Beam\" Ability { id: \"26BD\", source: \"Nael deus Darnus\" }\r\n#882.4 \"Raven Dive\" Ability { id: \"26BE\", source: \"Nael deus Darnus\" }\r\n885.5 \"Twister\" Ability { id: \"26AA\", source: \"Twintania\" }\r\n\r\n896.5 \"Megaflare\" Ability { id: \"26BA\", source: \"Nael deus Darnus\" }\r\n904.6 \"Death Sentence\" Ability { id: \"26A9\", source: \"Twintania\" }\r\n904.6 \"Ravensbeak\" Ability { id: \"26B6\", source: \"Nael deus Darnus\" }\r\n908.6 \"Plummet\" Ability { id: \"26A8\", source: \"Twintania\" }\r\n908.6 \"Bahamut's Claw x5\" duration 2.8 #Ability { id: \"26B5\", source: \"Nael deus Darnus\" }\r\n\r\n917.7 \"Liquid Hell x5\" duration 4.5 #Ability { id: \"26AD\", source: \"Twintania\" }\r\n926.5 \"Generate x3\" Ability { id: \"26AE\", source: \"Twintania\" }\r\n930.7 \"Twister\" Ability { id: \"26AA\", source: \"Twintania\" }\r\n934.7 \"Triple Nael Quote\"\r\n#938.3 \"Lunar Dynamo\" Ability { id: \"26BC\", source: \"Nael deus Darnus\" }\r\n#941.4 \"Iron Chariot\" Ability { id: \"26BB\", source: \"Nael deus Darnus\" }\r\n#944.6 \"Raven Dive\" Ability { id: \"26BE\", source: \"Nael deus Darnus\" }\r\n947.9 \"Twister\" Ability { id: \"26AA\", source: \"Twintania\" }\r\n\r\n960.1 \"Death Sentence\" Ability { id: \"26A9\", source: \"Twintania\" }\r\n960.7 \"Ravensbeak\" Ability { id: \"26B6\", source: \"Nael deus Darnus\" }\r\n973.0 \"Megaflare\" Ability { id: \"26BA\", source: \"Nael deus Darnus\" }\r\n984.0 \"Enrage\" # ???\r\n\r\n\r\n##### GOLDEN BAHAMUT #####\r\n1200.0 \"Teraflare\" Ability { id: \"26E9\", source: \"Bahamut Prime\" } window 1200,0\r\n1225.1 \"Flames Of Rebirth\" #Ability { id: \"26F2\", source: \"Phoenix\" }\r\n1230.9 \"--sync--\" Ability { id: \"2707\", source: \"Bahamut Prime\" } window 30,30 # Glowing ball\r\n1245.0 \"--targetable--\"\r\n1251.1 \"Morn Afah #1\" Ability { id: \"26EC\", source: \"Bahamut Prime\" }\r\n1257.5 \"Akh Morn #1\" Ability { id: \"26EA\", source: \"Bahamut Prime\" } duration 3.3\r\n1270.0 \"Exaflare #1\" Ability { id: \"26EF\", source: \"Bahamut Prime\" } window 10,10\r\n1289.3 \"Akh Morn #2\" Ability { id: \"26EA\", source: \"Bahamut Prime\" } duration 4.4\r\n1306.9 \"Morn Afah #2\" Ability { id: \"26EC\", source: \"Bahamut Prime\" }\r\n1319.2 \"Exaflare #2\" Ability { id: \"26EF\", source: \"Bahamut Prime\" } window 10,10\r\n1340.5 \"Morn Afah #3\" Ability { id: \"26EC\", source: \"Bahamut Prime\" }\r\n1352.7 \"Akh Morn #3\" Ability { id: \"26EA\", source: \"Bahamut Prime\" } duration 5.5\r\n1369.4 \"Exaflare #3\" Ability { id: \"26EF\", source: \"Bahamut Prime\" } window 10,10\r\n1390.6 \"Morn Afah #4\" Ability { id: \"26EC\", source: \"Bahamut Prime\" }\r\n1402.7 \"Akh Morn #4\" Ability { id: \"26EA\", source: \"Bahamut Prime\" } duration 6.6\r\n1420.5 \"Exaflare #4\" Ability { id: \"26EF\", source: \"Bahamut Prime\" } window 10,10\r\n1441.6 \"Morn Afah #5\" Ability { id: \"26EC\", source: \"Bahamut Prime\" }\r\n1453.7 \"Morn Afah Enrage\" Ability { id: \"26ED\", source: \"Bahamut Prime\" }\r\n#1455.9 \"Morn Afah\" Ability { id: \"26EE\", source: \"Bahamut Prime\" }\r\n#1457.2 \"Morn Afah\" Ability { id: \"26EE\", source: \"Bahamut Prime\" }\r\n\r\n# victory ezpz\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/alliance/the_copied_factory.ts



// The Copied Factory
// TODO: Tell people where to stand for Engels wall saws
// TODO: Tell people where to stand for 9S overhead saws
// TODO: Tell people where to go for 9S divebombs
// TODO: Tell people where to go for 9S tethered tank
const the_copied_factory_triggerSet = {
  id: 'TheCopiedFactory',
  zoneId: zone_id/* default.TheCopiedFactory */.Z.TheCopiedFactory,
  timelineFile: 'the_copied_factory.txt',
  timelineTriggers: [{
    id: 'Copied Flight Unit Lightfast',
    regex: /Lightfast Blade/,
    beforeSeconds: 15,
    infoText: (data, _matches, output) => {
      // The third lightfast blade comes very close to second,
      // so suppress its message.
      data.lightfastCount = (data.lightfastCount ?? 0) + 1;
      if (data.lightfastCount !== 3) return;
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'Be Near Boss',
        de: 'sei in der Nähe des Bosses',
        fr: 'Placez-vous près du boss',
        ja: 'ボスに貼りつく',
        cn: '靠近Boss',
        ko: '보스 근처로'
      }
    }
  }, {
    id: 'Copied Engels Demolish Structure',
    regex: /Demolish Structure/,
    beforeSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move to South Edge',
        de: 'zur südlichen Kante',
        fr: 'Allez vers le bord sud',
        ja: '南へ',
        cn: '前往南侧边缘',
        ko: '남쪽으로'
      }
    }
  }],
  triggers: [{
    id: 'Copied Serial Forceful Impact',
    type: 'StartsUsing',
    netRegex: {
      id: '48CF',
      source: 'Serial-Jointed Command Model',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Copied Serial Energy Assault',
    type: 'StartsUsing',
    netRegex: {
      id: '48B5',
      source: 'Serial-Jointed Command Model',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Copied Serial High-Caliber Laser',
    type: 'StartsUsing',
    netRegex: {
      id: '48FA',
      source: 'Serial-Jointed Service Model',
      capture: false
    },
    suppressSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look for Lasers',
        de: 'Pass auf die Laser auf',
        fr: 'Repérez les lasers',
        ja: 'レーザーを避ける',
        cn: '小心激光',
        ko: '레이저 확인'
      }
    }
  }, {
    id: 'Copied Serial Clanging Blow',
    type: 'StartsUsing',
    netRegex: {
      id: '48CE',
      source: 'Serial-Jointed Command Model'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Copied Serial Centrifugal Spin',
    type: 'StartsUsing',
    netRegex: {
      id: '48C8',
      source: 'Serial-Jointed Command Model',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'Copied Serial Sidestriking Spin',
    type: 'StartsUsing',
    netRegex: {
      id: '48CA',
      source: 'Serial-Jointed Command Model',
      capture: false
    },
    response: responses/* Responses.goFrontBack */.n3.goFrontBack()
  }, {
    id: 'Copied Serial Shockwave',
    type: 'StartsUsing',
    netRegex: {
      id: '48C3',
      source: 'Serial-Jointed Command Model',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback('info')
  }, {
    id: 'Copied Hobbes Laser-Resistance Test',
    type: 'StartsUsing',
    netRegex: {
      id: '4805',
      source: 'Hobbes',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  },
  // https://xivapi.com/LogMessage/9533
  // en: The wall-mounted right arm begins to move...
  {
    id: 'Copied Hobbes Right Arm',
    type: 'SystemLogMessage',
    netRegex: {
      id: '253D',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.alliance ??= 'A',
    outputStrings: {
      text: {
        en: 'Dodge Moving Circle',
        de: 'Bewegenden Kreisen ausweichen',
        fr: 'Esquivez les cercles mouvants',
        ja: '動いてるサークルを避ける',
        cn: '躲避移动圆圈',
        ko: '시계방향 회전하면서 나오는 장판 피하기'
      }
    }
  },
  // https://xivapi.com/LogMessage/9531
  // en: The wall-mounted flamethrowers activate.
  {
    id: 'Copied Hobbes Flamethrowers',
    type: 'SystemLogMessage',
    netRegex: {
      id: '253B',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.alliance ??= 'B',
    outputStrings: {
      text: {
        en: 'Look Behind For Flamethrowers',
        de: 'Flammenwerfer hinter dir',
        fr: 'Repérez les lance-flammes derrière',
        ja: '後ろに火炎放射器',
        cn: '观察后方放火',
        ko: '뒤에서 불 나오는 곳 확인'
      }
    }
  },
  // https://xivapi.com/LogMessage/9532
  // en: The wall-mounted left arm begins to move...
  {
    id: 'Copied Hobbes Left Arm 1',
    type: 'SystemLogMessage',
    netRegex: {
      id: '253C',
      capture: false
    },
    durationSeconds: 6,
    response: responses/* Responses.getOut */.n3.getOut('info'),
    run: data => data.alliance ??= 'C'
  }, {
    id: 'Copied Hobbes Left Arm 2',
    type: 'SystemLogMessage',
    netRegex: {
      id: '253C',
      capture: false
    },
    delaySeconds: 8,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge Falling Walls',
        de: 'Den fallenden Wände asuweichen',
        fr: 'Esquivez les murs tombants',
        ja: '倒れてくる壁を避ける',
        cn: '躲避倒塌墙壁',
        ko: '넘어지는 벽 피하기'
      }
    }
  }, {
    id: 'Copied Hobbes Left Arm 3',
    type: 'SystemLogMessage',
    netRegex: {
      id: '253C',
      capture: false
    },
    delaySeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread Tethers',
        de: 'Verbindungen Verteilen',
        fr: 'Dispersez les liens',
        ja: '散開、線を断つ',
        cn: '散开扯断连线',
        ko: '산개 선 (탱 혼자도 가능)'
      }
    }
  }, {
    id: 'Copied Hobbes Short Missile',
    type: 'HeadMarker',
    netRegex: {
      id: '00C4'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'Copied Hobbes Laser Sight',
    type: 'StartsUsing',
    netRegex: {
      id: '4807',
      source: 'Hobbes',
      capture: false
    },
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  },
  // https://xivapi.com/LogMessage/9528
  // en: You hear frenzied movement from machines beneath...
  {
    id: 'Copied Hobbes Electric Floor',
    type: 'SystemLogMessage',
    netRegex: {
      id: '2538',
      capture: false
    },
    durationSeconds: 10,
    suppressSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge Electric Floor',
        de: 'Elektrischem Boden ausweichen',
        fr: 'Esquivez le sol électrifié',
        ja: '電気床を避ける',
        cn: '躲避带电地板',
        ko: '바닥 장판 피하기'
      }
    }
  },
  // https://xivapi.com/LogMessage/9529
  // en: The conveyer belts whirr to life!
  {
    id: 'Copied Hobbes Conveyer Belts',
    type: 'SystemLogMessage',
    netRegex: {
      id: '2539',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Conveyor Belts',
        de: 'Förderbänder',
        fr: 'Tapis roulant',
        ja: 'ローラーコンベア',
        cn: '输送带',
        ko: '컨베이어 벨트'
      }
    }
  },
  // https://xivapi.com/LogMessage/9530
  // en: Flammable oil is leaking from the floor...
  {
    id: 'Copied Hobbes Oil 1',
    type: 'SystemLogMessage',
    netRegex: {
      id: '253A',
      capture: false
    },
    durationSeconds: 3,
    suppressSeconds: 15,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Oil Vats',
        de: 'Ölbehälter',
        fr: 'Cuves à huile',
        ja: 'オイルが沸く',
        cn: '油桶',
        ko: '뚫린 바닥 피하기'
      }
    }
  }, {
    id: 'Copied Hobbes Oil 2',
    type: 'SystemLogMessage',
    netRegex: {
      id: '253A',
      capture: false
    },
    delaySeconds: 6,
    durationSeconds: 3,
    suppressSeconds: 15,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Oil Vats',
        de: 'Ölbehälter',
        fr: 'Cuves à huile',
        ja: 'オイルが沸く',
        cn: '油桶',
        ko: '뚫린 바닥 피하기'
      }
    }
  }, {
    id: 'Copied Goliath Tank Exploder',
    type: 'Tether',
    netRegex: {
      id: '0011',
      source: 'Medium Exploder'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Exploder on YOU',
        de: 'Explosion auf DIR',
        fr: 'Explosion sur VOUS',
        ja: '自分に自爆',
        cn: '自爆点名',
        ko: '폭발 징'
      }
    }
  }, {
    id: 'Copied Flight Unit 360 Bombing Manuever',
    type: 'StartsUsing',
    netRegex: {
      id: '4941',
      source: 'Flight Unit',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Copied Flight Unit Ballistic Impact',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'Copied Engels Marx Smash Right',
    type: 'StartsUsing',
    netRegex: {
      id: '4727',
      source: 'Engels',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Copied Engels Marx Smash Left',
    type: 'StartsUsing',
    netRegex: {
      id: '4726',
      source: 'Engels',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Copied Engels Marx Smash Forward',
    type: 'StartsUsing',
    netRegex: {
      id: '472E',
      source: 'Engels',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Front and Center',
        de: 'Vorne und Mitte',
        fr: 'Devant et au centre',
        ja: '前方の中へ',
        cn: '前方中间',
        ko: '앞으로 => 중앙으로'
      }
    }
  }, {
    id: 'Copied Engels Marx Smash Back',
    type: 'StartsUsing',
    netRegex: {
      id: '472A',
      source: 'Engels',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Back and Sides',
        de: 'Hinten und Seiten',
        fr: 'Derrière et sur les côtés',
        ja: '後方の横へ',
        cn: '后方两侧',
        ko: '뒤로 => 양옆으로'
      }
    }
  }, {
    id: 'Copied Engels Marx Crush',
    type: 'StartsUsing',
    netRegex: {
      id: '4746',
      source: 'Engels',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Claws',
        de: 'Klauen töten',
        fr: 'Tuez les pinces',
        ja: 'マルクスを倒す',
        cn: '杀掉爪子',
        ko: '양옆 톱 처리'
      }
    }
  }, {
    id: 'Copied Engels Precision Guided Missile',
    type: 'HeadMarker',
    netRegex: {
      id: '00C6'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'Copied Engels Diffuse Laser',
    type: 'StartsUsing',
    netRegex: {
      id: '4755',
      source: 'Engels',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Technicallly this is Laser Sight 473A, but energy barrage
    // always precedes it and is an earlier warning.
    // Also suggest going to the front for towers.
    id: 'Copied Engels Energy Barrage 1',
    type: 'StartsUsing',
    netRegex: {
      id: '473C',
      source: 'Engels',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Sides (Near Front)',
        de: 'Zu den Seiten (Nahe der Front)',
        fr: 'Allez sur les côtés (vers l\'avant)',
        ja: '横へ (前に近づく)',
        cn: '两侧（靠近前方）',
        ko: '양옆으로 (앞 근처)'
      }
    }
  }, {
    id: 'Copied Engels Energy Barrage',
    type: 'StartsUsing',
    netRegex: {
      id: '473C',
      source: 'Engels',
      capture: false
    },
    delaySeconds: 8,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 하나씩 들어가기'
      }
    }
  }, {
    id: 'Copied Engels Incendiary Bombing',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Puddle on YOU',
        de: 'Fläche auf dir',
        fr: 'Zone au sol sur VOUS',
        ja: '自分に水溜り',
        cn: '水圈点名',
        ko: '징 대상자'
      }
    }
  }, {
    id: 'Copied Engels Guided Missile',
    type: 'HeadMarker',
    netRegex: {
      id: '00C5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Out + Dodge Homing AoE',
        de: 'Geh Raus + Zielsuch-AoE ausweichen',
        fr: 'À l\'extérieur + Esquivez l\'AoE',
        ja: '外 + AoE',
        cn: '远离 + 躲避弹幕',
        ko: '바깥으로 빠지고 따라오는 장판 피하기'
      }
    }
  }, {
    id: 'Copied Engels Reverse-Jointed Goliaths',
    type: 'Ability',
    netRegex: {
      id: '473F',
      source: 'Engels',
      capture: false
    },
    durationSeconds: 4,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Adds (Ignore Small)',
        de: 'Adds (kleine ignorieren)',
        fr: 'Adds (ignorez les petits)',
        ja: '雑魚 (小さいのは無視)',
        cn: '小怪（忽略小的）',
        ko: '쫄 나옴 (작은건 무시)'
      }
    }
  }, {
    id: 'Copied Engels Incendiary Saturation Bombing',
    type: 'StartsUsing',
    netRegex: {
      id: '474E',
      source: 'Engels',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Front and Center',
        de: 'Vorne und Mitte',
        fr: 'Devant et au centre',
        ja: '前方の中へ',
        cn: '前方中间',
        ko: '앞 중앙'
      }
    }
  }, {
    id: 'Copied Engels Marx Thrust',
    type: 'StartsUsing',
    netRegex: {
      id: '48A8',
      source: 'Engels',
      capture: false
    },
    delaySeconds: 9,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look For Wall Saws',
        de: 'Halt nach den kleinen Sägen ausschau',
        fr: 'Repérez les scies murales',
        ja: 'マルクス突撃',
        cn: '观察墙壁',
        ko: '양옆 톱 확인'
      }
    }
  }, {
    id: 'Copied 9S Neutralization',
    type: 'StartsUsing',
    netRegex: {
      id: '48F5',
      source: '9S-Operated Walking Fortress'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Copied 9S Laser Saturation',
    type: 'StartsUsing',
    netRegex: {
      id: '48F6',
      source: '9S-Operated Walking Fortress',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Copied 9S Laser Turret',
    type: 'StartsUsing',
    netRegex: {
      id: '4A74',
      source: '9S-Operated Walking Fortress',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Copied 9S Ballistic Impact',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'Copied 9S Goliath Laser Turret',
    type: 'HeadMarker',
    netRegex: {
      id: '00A4'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Laser Buster on YOU',
        de: 'Laser Tankbuster auf DIR',
        fr: 'Tank buster laser sur VOUS',
        ja: '自分にレーザー',
        cn: '激光点名',
        ko: '레이저 대상자'
      }
    }
  }, {
    id: 'Copied 9S Fore-Hind Cannons',
    type: 'StartsUsing',
    netRegex: {
      id: '48DF',
      source: '9S-Operated Walking Fortress',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides('info')
  }, {
    id: 'Copied 9S Dual-Flank Cannons',
    type: 'StartsUsing',
    netRegex: {
      id: '48DE',
      source: '9S-Operated Walking Fortress',
      capture: false
    },
    response: responses/* Responses.goFrontBack */.n3.goFrontBack('info')
  }, {
    id: 'Copied 9S Engage Marx Support',
    type: 'StartsUsing',
    netRegex: {
      id: '48D3',
      source: '9S-Operated Walking Fortress',
      capture: false
    },
    delaySeconds: 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge Overhead Saws',
        de: 'Sägen über dem Kopf ausweichen',
        fr: 'Esquivez les scies aériennes',
        ja: 'マルクス支援',
        cn: '躲避头顶锯',
        ko: '톱 없는 쪽으로 피하기'
      }
    }
  }, {
    // Use the ability before the adds show up, as looking for the added combatant
    // also triggers on the first boss.
    id: 'Copied 9S Serial-Jointed Service Models',
    type: 'Ability',
    netRegex: {
      id: '48EA',
      source: '9S-Operated Walking Fortress',
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'Copied 9S Engage Goliath Tank Support',
    type: 'StartsUsing',
    netRegex: {
      id: '48E5',
      source: '9S-Operated Walking Fortress',
      capture: false
    },
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'Copied 9S Hack Goliath Tank',
    type: 'StartsUsing',
    netRegex: {
      id: '48E7',
      source: '9S-Operated Walking Fortress',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Behind Untethered Tank',
        de: 'Hinter den nicht verbundenen Panzer gehen',
        fr: 'Allez derrière le tank non-lié',
        ja: '線のない戦車の後ろへ',
        cn: '没连线的坦克后躲避',
        ko: '연결되지 않은 탱크 뒤로 숨기'
      }
    }
  }, {
    id: 'Copied 9S Shrapnel Impact',
    type: 'StartsUsing',
    netRegex: {
      id: '48F3',
      source: '9S-Operated Walking Fortress',
      capture: false
    },
    suppressSeconds: 2,
    response: responses/* Responses.stackMarker */.n3.stackMarker('info')
  }, {
    id: 'Copied 9S Bubble',
    type: 'StartsUsing',
    netRegex: {
      id: '48EB',
      source: '9S-Operated Walking Fortress',
      capture: false
    },
    delaySeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get in the bubble',
        de: 'Geh in die Kuppel',
        fr: 'Allez dans la bulle',
        ja: '泡に入る',
        cn: '进入圈圈',
        ko: '안전지대 안으로 들어가기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      '9S-Operated Flight Unit': '9S\' Flugeinheit',
      '9S-Operated Walking Fortress': '9S\' mehrbeinig(?:e|er|es|en) Panzer',
      'Engels': 'Engels',
      '(?<! )Flight Unit': 'Flugeinheit',
      'Goliath Tank': 'Goliath-Panzer',
      'Hobbes': 'Hobbes',
      'Marx': 'Marx',
      'Medium Exploder': 'mittelgroß(?:e|er|es|en) Selbstzerstörung',
      'Multi-leg Medium Model': 'mittelgroßes mehrbeiniges Modell',
      'Quality assurance': 'Warenkontrollhalle',
      'Reverse-jointed Goliath': 'Goliath mit Inversgelenk',
      'Serial-jointed Command Model': 'Befehlsmodell mit Omnigelenk',
      'Serial-jointed Service Model': 'Modell mit Omnigelenk',
      'Small Biped': 'kleiner Zweibeiner',
      'Small Flyer': 'kleine Flugeinheit',
      'The forward deck': 'vordere Deck',
      'The rear deck': 'hintere Deck',
      'Warehouse A': 'Warenlager A',
      'Warehouse B': 'Warenlager B',
      'Warehouse C': 'Warenlager C'
    },
    'replaceText': {
      '360-Degree Bombing Maneuver': 'Offensive: Raketenring',
      'Adds': 'Adds',
      'Anti-Personnel Missile': 'Antipersonenrakete',
      'Area Bombardment': 'Blindraketen',
      'Area Bombing Maneuver': 'Offensive: Raketensalve',
      'Arm Laser': 'Armlaser',
      'Cannons': 'Kanonen',
      'Clanging Blow': 'Schwerer Angriff',
      'Convenient Self-Destruction': 'Selbstsprengung',
      'Crusher Adds': 'Zangenrad Adds',
      'Crushing Wheel': 'Zangenradoffensive',
      'Demolish Structure': 'Terraintilgung',
      'Diffuse Laser': 'Diffusionslaser',
      'Energy Assault': 'Energieschauer',
      'Energy Barrage': 'Energetisches Sperrfeuer',
      'Energy Blast': 'Energetische Explosion',
      'Energy Bombardment': 'Energiemörser',
      'Energy Ring': 'Omnidirektionalenergie',
      'Engage Goliath Tank Support': 'Verstärkung: Goliath-Panzer',
      'Engage Marx Support': 'Verstärkung: Marx',
      'Exploding Tethers': 'Explodierende Verbindungen',
      'Floor': 'Boden',
      'Forceful Impact': 'Heftiges Beben',
      'Frontal Somersault': 'Sprungoffensive',
      'Ground-To-Ground Missile': 'Boden-Boden-Rakete',
      '(?<! )Guided Missile': 'Lenkraketen',
      'Hack Goliath Tank': 'Hacken: Goliath-Panzer',
      'High-Caliber Laser': 'Großkaliberlaser',
      'High-Frequency Laser': 'Hochfrequenzlaser',
      'High-Powered Laser': 'Hochleistungslaser',
      'Incendiary Bombing': 'Brandraketen',
      'Incendiary Saturation Bombing': 'Streubrandraketen',
      'Laser Saturation': 'Omnidirektionallaser',
      'Laser Sight': 'Laserbestrahlung',
      'Laser Turret': 'Hauptgeschützlaser',
      'Laser-Resistance Test': 'Laserresistenztest',
      'Lightfast Blade': 'Lichtklingenschnitt',
      'Marx Activation': 'Marx-Aktivierung',
      'Marx Crush': 'Marxsche Offensive',
      'Marx Impact': 'Marxscher Sturz',
      'Marx Smash': 'Marxscher Schlag',
      '(?<= )Back': 'Hinten',
      '(?<= )Front': 'Vorne',
      'Marx Thrust': 'Marxscher Ansturm',
      'Neutralization': 'Unterwerfung',
      'Precision Guided Missile': 'Schwere Lenkrakete',
      'Radiate Heat': 'Thermaloffensive',
      'Ring Laser': 'Ringlaser',
      'Shockwave': 'Schockwelle',
      'Short-Range Missile': 'Kurzstreckenrakete',
      'Shrapnel Impact': 'Wrackteilregen',
      'Spin': 'Rotation',
      'Surface Missile': 'Raketenschlag',
      'Systematic Airstrike': 'Luftformation',
      'Systematic Siege': 'Kesselformation',
      'Systematic Suppression': 'Artillerieformation',
      'Systematic Targeting': 'Jagdformation',
      'Total Annihilation Maneuver': 'Offensive: Totale Vernichtung',
      'Undock': 'Abdocken',
      'Wall Mechanic': 'Wand Mechanik'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '9S-operated Flight Unit': '9S : module de vol équipé',
      '9S-Operated Walking Fortress': '9S : avec multipède esclave',
      'Engels': 'Engels',
      '(?<! )Flight Unit': 'Module de vol',
      'Goliath Tank': 'Char Goliath',
      'Hobbes': 'Hobbes',
      'Marx': 'Marx',
      'Medium Exploder': 'Unité kamikaze moyenne',
      'Multi-leg Medium Model': 'Multipède moyen',
      'Quality assurance': 'la salle de test',
      'Reverse-jointed Goliath': 'Goliath articulations inversées',
      'Serial-jointed Command Model': 'Modèle multiarticulé : commandant',
      'Serial-jointed Service Model': 'Modèle multiarticulé : soldat',
      'Small Biped': 'Petit bipède',
      'Small Flyer': 'Petite unité volante',
      'The forward deck': 'la plate-forme avant',
      'The rear deck': 'la plate-forme arrière',
      'Warehouse A': 'l\'entrepôt A',
      'Warehouse B': 'l\'entrepôt B',
      'Warehouse C': 'l\'entrepôt C'
    },
    'replaceText': {
      '\\?': ' ?',
      '360-Degree Bombing Maneuver': 'Attaque : tir de missiles circulaire',
      'Adds': 'Adds',
      'Anti-Personnel Missile': 'Pluie de missiles antipersonnel',
      'Area Bombardment': 'Déluge de missiles',
      'Area Bombing Maneuver': 'Attaque : salve de missiles',
      'Arm Laser': 'Lasers brachiaux',
      'Cannons': 'Canons',
      'Clanging Blow': 'Attaque puissante',
      'Convenient Self-Destruction': 'Autodestruction',
      'Crusher Adds': 'Broyeurs',
      'Crushing Wheel': 'Scie circulaire',
      'Demolish Structure': 'Démolition de plate-forme',
      '(?<!Wide-Angle )Diffuse Laser': 'Laser diffractif',
      'Energy Assault': 'Tirs en éventail',
      'Energy Barrage': 'Rideau de balles',
      'Energy Blast': 'Fission de balle',
      'Energy Bombardment': 'Tirs courbes',
      'Energy Ring': 'Tirs multidirectionnels',
      'Engage Goliath Tank Support': 'Appel de renfort : char Goliath',
      'Engage Marx Support': 'Appel de renforts : Marx',
      'Exploding Tethers': 'Liens explosifs',
      'Floor': 'Sol',
      'Forceful Impact': 'Forte secousse',
      'Frontal Somersault': 'Attaque sautée',
      'Ground-To-Ground Missile': 'Missile sol-sol',
      '(?<! )Guided Missile': 'Missile à tête chercheuse',
      'Hack Goliath Tank': 'Piratage : char Goliath',
      'High-Caliber Laser': 'Laser à large faisceau',
      'High-Frequency Laser': 'Laser à haute fréquence',
      'High-Powered Laser': 'Laser surpuissant',
      'Incendiary Bombing': 'Missiles incendiaires',
      'Incendiary Saturation Bombing': 'Salve incendiaire',
      'Laser Saturation': 'Laser multidirectionnel',
      'Laser Sight': 'Rayon laser',
      'Laser Turret': 'Canon laser',
      'Laser-Resistance Test': 'Test de résistance au laser',
      'Lightfast Blade': 'Lame éclair',
      'Marx Activation': 'Activation de Marx',
      'Marx Crush': 'Pinçage de Marx',
      'Marx Impact': 'Chute de Marx',
      'Marx Smash(?! )': 'Coup de Marx',
      'Marx Smash Back': 'Coup de Marx Der',
      'Marx Smash Front': 'Coup de Marx Dev',
      'Marx Smash B/F': 'Coup de Marx Der/Dev',
      'Marx Smash F/B': 'Coup de Marx Dev/Der',
      'Marx Smash L/R': 'Coup de Marx G/D',
      'Marx Smash R/L': 'Coup de Marx D/G',
      'Marx Thrust': 'Charge de Marx',
      'Neutralization': 'Tir de suppression',
      'Precision Guided Missile': 'Missile à tête chercheuse ultraprécise',
      'Radiate Heat': 'Relâchement de chaleur',
      'Ring Laser': 'Anneau laser',
      'Shockwave': 'Onde de choc',
      'Short-Range Missile': 'Missiles à courte portée',
      'Shrapnel Impact': 'Chute de débris',
      'Spin': 'Gyrocoup',
      'Surface Missile': 'Missiles sol-sol',
      'Systematic Airstrike': 'Formation de bombardement',
      'Systematic Siege': 'Formation d\'encerclement',
      'Systematic Suppression': 'Formation de balayage',
      'Systematic Targeting': 'Formation de tir',
      'Total Annihilation Maneuver': 'Attaque : bombardement dévastateur',
      'Undock': 'Désamarrage',
      'Wall Mechanic': 'Mécanique du mur',
      'Wide-Angle Diffuse Laser': 'Super laser diffractif'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '9S-operated Flight Unit': '９Ｓ：飛行ユニット装備',
      '9S-Operated Walking Fortress': '９Ｓ：多脚戦車従属',
      'Engels': 'エンゲルス',
      '(?<! )Flight Unit': '飛行ユニット',
      'Goliath Tank': '大型戦車',
      'Hobbes': 'ホッブス',
      'Marx': 'マルクス',
      'Medium Exploder': '中型自爆',
      'Multi-leg Medium Model': '中型多脚',
      'Quality assurance': '検品場',
      'Reverse-jointed Goliath': '大型逆関節',
      'Serial-jointed Command Model': '多関節型：司令機',
      'Serial-jointed Service Model': '多関節型：兵隊機',
      'Small Biped': '小型二足',
      'Small Flyer': '小型飛行体',
      'The forward deck': '前部甲板',
      'The rear deck': '後部甲板',
      'Warehouse A': '倉庫A',
      'Warehouse B': '倉庫B',
      'Warehouse C': '倉庫C'
    },
    'replaceText': {
      'Front(?!al)': '前',
      'Back': '後',
      '360-Degree Bombing Maneuver': '攻撃：ミサイル円射',
      '(?<! )Adds': '雑魚',
      'Anti-Personnel Missile': '対人ミサイル乱射',
      'Area Bombardment': 'ミサイル乱射',
      'Area Bombing Maneuver': '攻撃：ミサイル斉射',
      'Arm Laser': '腕部レーザー',
      'Cannons': 'カノン',
      'Clanging Blow': '強攻撃',
      'Convenient Self-Destruction': '自爆攻撃',
      'Crusher Adds': 'マルクス挟撃',
      'Crushing Wheel': '挟撃ホイール',
      'Demolish Structure': '地形破壊攻撃',
      '(?<! )Diffuse Laser': '拡散レーザー',
      'Energy Assault': '連続エネルギー弾',
      'Energy Barrage': 'エネルギー弾幕',
      'Energy Blast': 'エネルギー炸裂',
      'Energy Bombardment': '迫撃エネルギー弾',
      'Energy Ring': '全方位エネルギー弾',
      'Engage Goliath Tank Support': '支援要請：大型戦車',
      'Engage Marx Support': '支援要請：マルクス',
      'Exploding Tethers': '爆発',
      'Floor': '床',
      'Forceful Impact': '大震動',
      'Frontal Somersault': 'ジャンプ攻撃',
      'Ground-To-Ground Missile': '地対地ミサイル',
      '(?<! )Guided Missile': '誘導ミサイル',
      'Hack Goliath Tank': 'ハッキング：大型戦車',
      'High-Caliber Laser': '大口径レーザー',
      'High-Frequency Laser': '高周波レーザー',
      'High-Powered Laser': '高出力レーザー',
      'Incendiary Bombing': '焼尽ミサイル',
      'Incendiary Saturation Bombing': '拡散焼尽ミサイル',
      'Laser Saturation': '全方位レーザー',
      'Laser Sight': 'レーザー照射',
      'Laser Turret': '主砲レーザー',
      'Laser-Resistance Test': '耐レーザー検証',
      'Lightfast Blade': '光刃斬機',
      'Marx Activation': 'マルクス起動',
      'Marx Crush': 'マルクス挟撃',
      'Marx Impact': 'マルクス落下',
      'Marx Smash': 'マルクス打撃',
      'Marx Thrust': 'マルクス突撃',
      'Neutralization': '制圧射撃',
      'Precision Guided Missile': '高性能誘導ミサイル',
      'Radiate Heat': '放熱攻撃',
      'Ring Laser': 'リングレーザー',
      'Serial-Jointed Adds': '多関節型雑魚',
      'Shockwave': '衝撃波',
      'Short-Range Missile': '短距離ミサイル',
      'Shrapnel Impact': '残骸落下',
      'Spin': 'ぶん回す',
      'Surface Missile': '対地ミサイル',
      'Systematic Airstrike': '空爆陣形',
      'Systematic Siege': '包囲陣形',
      'Systematic Suppression': '掃射陣形',
      'Systematic Targeting': '照準陣形',
      'Tank Adds': '戦車',
      'Total Annihilation Maneuver': '攻撃：殲滅爆撃',
      'Undock': 'ドッキング解除',
      'Wide-Angle Diffuse Laser': '広拡散レーザー',
      'Wall Mechanic': '壁のギミック'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '9S-operated Flight Unit': '9S：装备飞行装置',
      '9S-Operated Walking Fortress': '9S：接入多脚战车',
      'Engels': '昂格士',
      '(?<! )Flight Unit': '飞行装置',
      'Goliath Tank': '大型战车',
      'Hobbes': '霍布斯',
      'Marx': '麦喀士',
      'Medium Exploder': '中型自爆',
      'Multi-leg Medium Model': '中型多脚',
      'Quality assurance': '质检场',
      'Reverse-jointed Goliath': '大型逆关节',
      'Serial-Jointed Command Model': '多关节型：司令机',
      'Serial-Jointed Service Model': '多关节型：士兵机',
      'Small Biped': '小型二足',
      'Small Flyer': '小型飞行体',
      'The forward deck': '前部甲板',
      'The rear deck': '后部甲板',
      'Warehouse A': '仓库A',
      'Warehouse B': '仓库B',
      'Warehouse C': '仓库C'
    },
    'replaceText': {
      '360-Degree Bombing Maneuver': '攻击：周边导弹轰炸',
      'Anti-Personnel Missile': '对人导弹乱射',
      'Area Bombardment': '导弹乱射',
      'Area Bombing Maneuver': '攻击：追踪导弹轰炸',
      'Arm Laser': '腕部激光',
      'Cannons': '加农',
      'Clanging Blow': '强攻击',
      'Convenient Self-Destruction': '自爆攻击',
      'Crusher Adds': '粉碎机小怪',
      'Tank Adds': '坦克小怪',
      'Serial-Jointed Adds': '多关节型小怪',
      '(?<! )Adds': '小怪',
      'Crushing Wheel': '碾轮夹击',
      'Demolish Structure': '地形破坏攻击',
      'Wide-Angle Diffuse Laser': '广角扩散射线',
      '(?<! )Diffuse Laser': '扩散射线',
      'Energy Assault': '连续能量弹',
      'Energy Barrage': '能量弹幕',
      'Energy Blast': '能量炸裂',
      'Energy Bombardment': '迫击能量弹',
      'Energy Ring': '全方位能量弹',
      'Engage Goliath Tank Support': '请求支援：大型战车',
      'Engage Marx Support': '请求支援：麦喀士',
      'Exploding Tethers': '爆炸连线',
      'Floor': '地板',
      'Forceful Impact': '大震动',
      'Frontal Somersault': '跳跃攻击',
      'Ground-To-Ground Missile': '地对地导弹',
      'Precision Guided Missile': '高性能追踪导弹',
      '(?<! )Guided Missile': '追踪导弹',
      'Hack Goliath Tank': '骇入：大型战车',
      'High-Caliber Laser': '大口径激光',
      'High-Frequency Laser': '高周波激光',
      'High-Powered Laser': '高功率激光',
      'Incendiary Bombing': '燃烧导弹',
      'Incendiary Saturation Bombing': '扩散燃烧导弹',
      'Laser Saturation': '全方位激光',
      'Laser Sight': '激光照射',
      'Laser Turret': '主炮激光',
      'Laser-Resistance Test': '耐激光检测',
      'Lightfast Blade': '光刃斩机',
      'Marx Activation': '麦喀士启动',
      'Marx Crush': '麦喀士夹击',
      'Marx Impact': '麦喀士冲击',
      'Marx Smash L/R': '麦喀士打击左/右',
      'Marx Smash R/L': '麦喀士打击右/左',
      'Marx Smash Back': '麦喀士打击后',
      'Marx Smash Front': '麦喀士打击前',
      'Marx Smash F/B': '麦喀士打击前/后',
      'Marx Smash B/F': '麦喀士打击后/前',
      'Marx Smash(?! )': '麦喀士打击',
      'Marx Thrust': '麦喀士突击',
      'Neutralization': '压制射击',
      'Radiate Heat': '放热攻击',
      'Ring Laser': '环形激光',
      'Shockwave': '冲击波',
      'Short-Range Missile': '短途导弹',
      'Shrapnel Impact': '残骸坠落',
      'Spin': '回转',
      'Surface Missile': '对地导弹',
      'Systematic Airstrike': '空袭阵型',
      'Systematic Siege': '包围阵型',
      'Systematic Suppression': '扫射阵型',
      'Systematic Targeting': '瞄准阵型',
      'Total Annihilation Maneuver': '攻击：歼灭轰炸',
      'Undock': '对接解除',
      'Wall Mechanic': '墙机制'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '9S-operated Flight Unit': '9S: 비행 유닛 장비',
      '9S-Operated Walking Fortress': '9S: 다각전차 종속',
      'Engels': '엥겔스',
      '(?<! )Flight Unit': '비행 유닛',
      '(?<! )Goliath Tank': '대형 전차',
      'Hobbes': '홉스',
      'Marx': '마르크스',
      'Medium Exploder': '중형 자폭',
      'Multi-leg Medium Model': '중형 다각',
      'Quality assurance': '검품장',
      'Reverse-jointed Goliath': '대형 역관절',
      'Serial-jointed Command Model': '다관절형: 사령기',
      'Serial-jointed Service Model': '다관절형: 병정기',
      'Small Biped': '소형 이족',
      'Small Flyer': '소형 비행체',
      'The forward deck': '전방 갑판',
      'The rear deck': '후방 갑판',
      'Warehouse A': '창고 A',
      'Warehouse B': '창고 B',
      'Warehouse C': '창고 C'
    },
    'replaceText': {
      'Front(?!al)': '앞',
      'Back': '뒤',
      'F/B': '앞/뒤',
      'B/F': '뒤/앞',
      'L/R': '좌/우',
      'R/L': '우/좌',
      '360-Degree Bombing Maneuver': '공격: 미사일 원형 사격',
      'Tank Adds': '대형 전차 쫄',
      'Serial-Jointed Adds': ' 다관절형 쫄',
      '(?<! )Adds': '쫄',
      'Anti-Personnel Missile': '대인 미사일 난사',
      'Area Bombardment': '미사일 난사',
      'Area Bombing Maneuver': '공격: 미사일 일제 사격',
      'Arm Laser': '팔 레이저',
      'Cannons': '일제 사격',
      'Clanging Blow': '강공격',
      'Convenient Self-Destruction': '자폭 공격',
      'Crusher Adds': '분쇄',
      'Crushing Wheel': '협공 차륜',
      'Demolish Structure': '지형 파괴 공격',
      '(?<! )Diffuse Laser': '확산 레이저',
      // 같은 영어에 다른 번역 - 광확산 레이저, 확산 레이저 번역 두 개
      'Energy Assault': '연속 에너지탄',
      'Energy Barrage': '에너지 탄막',
      'Energy Blast': '에너지 작렬',
      'Energy Bombardment': '박격 에너지탄',
      'Energy Ring': '전방위 에너지탄',
      'Engage Goliath Tank Support': '지원 요청: 대형 전차',
      'Engage Marx Support': '지원 요청: 마르크스',
      'Exploding Tethers': '선: 폭발',
      'Floor': '바닥 장판',
      'Forceful Impact': '대진동',
      'Frontal Somersault': '점프 공격',
      'Ground-To-Ground Missile': '지대지 미사일',
      '(?<! )Guided Missile': '유도 미사일',
      'Hack Goliath Tank': '해킹: 대형 전차',
      'High-Caliber Laser': '대구경 레이저',
      'High-Frequency Laser': '고주파 레이저',
      'High-Powered Laser': '고출력 레이저',
      'Incendiary Bombing': '소진 미사일',
      'Incendiary Saturation Bombing': '확산 소진 미사일',
      'Laser Saturation': '전방위 레이저',
      'Laser Sight': '레이저 광선',
      'Laser Turret': '주포 레이저',
      'Laser-Resistance Test': '레이저 저항 검증',
      'Lightfast Blade': '빛의 칼날 베기',
      'Marx Activation': '마르크스 기동',
      'Marx Crush': '마르크스 협공',
      'Marx Impact': '마르크스 낙하',
      'Marx Smash': '마르크스 타격',
      'Marx Thrust': '마르크스 돌격',
      'Neutralization': '제압 사격',
      'Precision Guided Missile': '고성능 유도 미사일',
      'Radiate Heat': '열 방출 공격',
      'Ring Laser': '고리 레이저',
      'Shockwave': '충격파',
      'Short-Range Missile': '단거리 미사일',
      'Shrapnel Impact': '잔해 낙하',
      'Spin': '회전 공격',
      'Surface Missile': '대지 미사일',
      'Systematic Airstrike': '공폭 진형',
      'Systematic Siege': '포위 진형',
      'Systematic Suppression': '소사 진형',
      'Systematic Targeting': '조준 진형',
      'Total Annihilation Maneuver': '공격: 섬멸 폭격',
      'Undock': '도킹 해제',
      'Wall Mechanic': '벽 기믹',
      'Wide-Angle Diffuse Laser': '광확산 레이저'
    }
  }]
};
/* harmony default export */ const the_copied_factory = (the_copied_factory_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/alliance/the_copied_factory.txt
const alliance_the_copied_factory_namespaceObject = "### The Copied Factory\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Serial-jointed Command Model\r\n# -ic 2P -p 48B2:108.5 -ii 4B31 48B3 48B4 48B7 48B6 48CB 48CC 48BA 4B32 48FA 48BC 48BD 48BE 48BF 48C0 48C1 48C2 48C9\r\n\r\n# Warehouse A will be sealed off\r\n100.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"D4C\" } window 100,0\r\n108.5 \"Systematic Siege\" Ability { id: \"48B2\", source: \"Serial-jointed Command Model\" } window 108.5,10\r\n122.6 \"Clanging Blow\" Ability { id: \"48CE\", source: \"Serial-jointed Command Model\" }\r\n134.1 \"Energy Bombardment\" Ability { id: \"48B8\", source: \"Serial-jointed Command Model\" }\r\n143.3 \"Forceful Impact\" Ability { id: \"48CF\", source: \"Serial-jointed Command Model\" }\r\n156.1 \"Energy Assault\" Ability { id: \"48B5\", source: \"Serial-jointed Command Model\" } duration 6.5\r\n163.2 \"--sync--\" Ability { id: \"4A10\", source: \"Serial-jointed Command Model\" }\r\n176.0 \"Systematic Targeting\" Ability { id: \"48C4\", source: \"Serial-jointed Command Model\" }\r\n188.5 \"High-Powered Laser\" #Ability { id: \"48C5\", source: \"Serial-jointed Service Model\" }\r\n193.8 \"Forceful Impact\" Ability { id: \"48CF\", source: \"Serial-jointed Command Model\" }\r\n206.7 \"Spin\" Ability { id: \"48C[A8]\", source: \"Serial-jointed Command Model\" }\r\n220.3 \"Systematic Airstrike\" Ability { id: \"48B9\", source: \"Serial-jointed Command Model\" } duration 24.8\r\n234.2 \"Clanging Blow\" Ability { id: \"48CE\", source: \"Serial-jointed Command Model\" }\r\n259.1 \"Systematic Suppression\" Ability { id: \"48C6\", source: \"Serial-jointed Command Model\" }\r\n272.0 \"High-Caliber Laser\" #Ability { id: \"48C7\", source: \"Serial-jointed Service Model\" }\r\n276.0 \"High-Caliber Laser\" #Ability { id: \"48C7\", source: \"Serial-jointed Service Model\" }\r\n281.9 \"Forceful Impact\" Ability { id: \"48CF\", source: \"Serial-jointed Command Model\" }\r\n\r\n# Maybe an HP push?\r\n292.3 \"Systematic Siege\" Ability { id: \"48B2\", source: \"Serial-jointed Command Model\" } window 150,5\r\n303.2 \"Energy Bombardment\" Ability { id: \"48B8\", source: \"Serial-jointed Command Model\" }\r\n306.8 \"Systematic Targeting\" Ability { id: \"48C4\", source: \"Serial-jointed Command Model\" }\r\n317.8 \"Clanging Blow\" Ability { id: \"48CE\", source: \"Serial-jointed Command Model\" }\r\n319.3 \"High-Powered Laser\" #Ability { id: \"48C5\", source: \"Serial-jointed Service Model\" }\r\n332.1 \"Spin\" Ability { id: \"48C[A8]\", source: \"Serial-jointed Command Model\" }\r\n343.2 \"Forceful Impact\" Ability { id: \"48CF\", source: \"Serial-jointed Command Model\" }\r\n352.6 \"Systematic Airstrike\" Ability { id: \"48B9\", source: \"Serial-jointed Command Model\" } duration 24.8\r\n371.5 \"Shockwave\" Ability { id: \"48C3\", source: \"Serial-jointed Command Model\" }\r\n387.9 \"Energy Ring\" Ability { id: \"48BB\", source: \"Serial-jointed Command Model\" } duration 7.2\r\n404.9 \"Energy Assault\" Ability { id: \"48B5\", source: \"Serial-jointed Command Model\" } duration 6.5\r\n412.1 \"--sync--\" Ability { id: \"4A10\", source: \"Serial-jointed Command Model\" }\r\n420.7 \"Systematic Suppression\" Ability { id: \"48C6\", source: \"Serial-jointed Command Model\" }\r\n433.5 \"High-Caliber Laser\" #Ability { id: \"48C7\", source: \"Serial-jointed Service Model\" }\r\n437.6 \"High-Caliber Laser\" #Ability { id: \"48C7\", source: \"Serial-jointed Service Model\" }\r\n442.6 \"Forceful Impact\" Ability { id: \"48CF\", source: \"Serial-jointed Command Model\" }\r\n457.4 \"Spin\" Ability { id: \"48C[A8]\", source: \"Serial-jointed Command Model\" }\r\n468.5 \"Clanging Blow\" Ability { id: \"48CE\", source: \"Serial-jointed Command Model\" }\r\n\r\n478.4 \"Systematic Siege\" Ability { id: \"48B2\", source: \"Serial-jointed Command Model\" } window 100,100 jump 292.3\r\n489.3 \"Energy Bombardment\"\r\n492.9 \"Systematic Targeting\"\r\n503.9 \"Clanging Blow\"\r\n505.4 \"High-Powered Laser\"\r\n518.2 \"Spin\"\r\n529.3 \"Forceful Impact\"\r\n\r\n\r\n### Trash\r\n# -ic 2P -ii 491D 491C -p 491B:715.5\r\n# Warehouse B will be sealed off\r\n600.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"D4D\" } window 600,0\r\n700.0 \"--sync--\" NameToggle { name: \"Small Flyer\", toggle: \"01\" } window 100,0\r\n715.5 \"Frontal Somersault\" Ability { id: \"491B\", source: \"Small Biped\" } window 116,2.5\r\n721.4 \"Frontal Somersault\" Ability { id: \"491B\", source: \"Small Biped\" }\r\n725.7 \"High-Frequency Laser\" Ability { id: \"491E\", source: \"Multi-leg Medium Model\" }\r\n732.1 \"High-Frequency Laser\" Ability { id: \"491E\", source: \"Multi-leg Medium Model\" }\r\n738.5 \"High-Frequency Laser\" Ability { id: \"491E\", source: \"Multi-leg Medium Model\" }\r\n740.8 \"Frontal Somersault\" Ability { id: \"491B\", source: \"Small Biped\" }\r\n746.9 \"Frontal Somersault\" Ability { id: \"491B\", source: \"Small Biped\" }\r\n751.2 \"High-Frequency Laser\" Ability { id: \"491E\", source: \"Multi-leg Medium Model\" }\r\n757.5 \"High-Frequency Laser\" Ability { id: \"491E\", source: \"Multi-leg Medium Model\" }\r\n763.9 \"High-Frequency Laser\" Ability { id: \"491E\", source: \"Multi-leg Medium Model\" }\r\n770.1 \"High-Frequency Laser\" Ability { id: \"491E\", source: \"Multi-leg Medium Model\" }\r\n776.3 \"High-Frequency Laser\" Ability { id: \"491E\", source: \"Multi-leg Medium Model\" }\r\n\r\n\r\n### Hobbes\r\n# -ic 2P -p 4805:913 -ii 481C 4811 4810 49C5 49C6 49C7 4917 490D 480C 4911 4918 490E 4910 4912 490F 4808 4809 4814 4800 4801 4802 4803 4804 4916 47FE 480F 4915\r\n# Alliance A floor: 4819\r\n# Alliance B floor: 481A\r\n# Alliance C floor: 481B\r\n\r\n# This is a mess, so has been simplified to just \"wall mechanic\" and \"floor mechanic\".\r\n# You can use the make_timeline parameters above to see the combined set of mechanics.\r\n\r\n# Notes for the future:\r\n# Alliance A's floor mechanic is \"Electromagnetic Pulse\" on \"Floor 1\" and \"Floor 2\"\r\n# Alliance B's floor mechanic is a single \"Unwilling Cargo\" on \"Floor 1\"\r\n# Alliance C's floor mechanic is \"Oil Well\" on \"Floor 1\" and \"Floor 2\"\r\n\r\n# Alliance A always starts with Variable Combat Test (wall-mounted right arm)\r\n# Alliance B always starts with Fire-Resistance Test (wall-mounted flamethrower)\r\n# Alliance C always starts with Impact/Towerfall (wall-mounted left arm)\r\n\r\n# Everybody will always get each of these mechanics as the first three wall mechanics,\r\n# however, they may rotate clockwise or counter-clockwise to begin with.\r\n\r\n# Just to make this even more worse for timelines, after the first floor mechanic\r\n# it rotates once more, then maybe changes direction, and rotates again (???)\r\n# It could also just be random after the floor mechanic?\r\n\r\n# This means these options are all valid wall rotations:\r\n# * Fire->Impact->Variable->(floor)->Variable->Impact->Fire->repeat\r\n# * Fire->Impact->Variable->(floor)->Impact->Variable->Fire->repeat\r\n# * Variable->Impact->Fire->(floor)->Impact->Fire->Variable->repeat\r\n\r\n# This is why the timeline has \"Wall 1 2 3\" and \"Wall A B C\".\r\n\r\n# TODO: you could use the initial rp text to figure out which alliance you're in,\r\n# and then from there also use the second rp text to figure out which of the initial\r\n# six possibilities you're in, then collapse back to three timelines, and then\r\n# branch out to six timelines again for the second half, but it'd be, well, a lot.\r\n\r\n# Quality Assurance will be sealed off\r\n900.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"D4E\" } window 900,0\r\n913.0 \"Laser-Resistance Test x3\" Ability { id: \"4805\", source: \"Hobbes\" } duration 2.3 window 913,10\r\n\r\n924.5 \"--sync--\" Ability { id: \"480A\", source: \"Hobbes\" }\r\n926.0 \"--sync--\" Ability { id: \"4913\", source: \"Hobbes\" }\r\n934.0 \"Wall Mechanic 1\"\r\n\r\n969.6 \"--sync--\" Ability { id: \"480A\", source: \"Hobbes\" }\r\n971.1 \"--sync--\" Ability { id: \"4913\", source: \"Hobbes\" }\r\n\r\n979.1 \"Wall Mechanic 2\"\r\n\r\n996.8 \"Ring Laser\" Ability { id: \"47FF\", source: \"Hobbes\" } duration 8.1\r\n\r\n1030.5 \"--sync--\" Ability { id: \"480A\", source: \"Hobbes\" }\r\n1032.1 \"--sync--\" Ability { id: \"4913\", source: \"Hobbes\" }\r\n\r\n1040.1 \"Wall Mechanic 3\"\r\n\r\n1061.3 \"Laser Sight\" Ability { id: \"4807\", source: \"Hobbes\" }\r\n\r\n1090.7 \"Floor 1\" Ability { id: \"481B\", source: \"Hobbes\" }\r\n1097.3 \"Floor 2\" Ability { id: \"481B\", source: \"Hobbes\" }\r\n\r\n1114.1 \"Laser-Resistance Test x4\" Ability { id: \"4805\", source: \"Hobbes\" } duration 3.3\r\n\r\n1128.6 \"Floor 1\" Ability { id: \"481B\", source: \"Hobbes\" }\r\n1130.5 \"Short-Range Missile\" Ability { id: \"4815\", source: \"Hobbes\" }\r\n1135.2 \"Floor 2\" Ability { id: \"481B\", source: \"Hobbes\" }\r\n\r\n1143.7 \"--sync--\" Ability { id: \"480A\", source: \"Hobbes\" }\r\n1149.2 \"--sync--\" Ability { id: \"4913\", source: \"Hobbes\" }\r\n1149.6 \"Laser Sight\" Ability { id: \"4807\", source: \"Hobbes\" }\r\n\r\n1157.2 \"Wall Mechanic A\"\r\n\r\n1187.9 \"Laser-Resistance Test x5\" Ability { id: \"4805\", source: \"Hobbes\" } duration 4.3\r\n\r\n1200.8 \"Ring Laser\" Ability { id: \"47FF\", source: \"Hobbes\" } duration 8.1\r\n1203.4 \"Floor 1\" Ability { id: \"481B\", source: \"Hobbes\" }\r\n1209.9 \"Floor 2\" Ability { id: \"481B\", source: \"Hobbes\" }\r\n\r\n1218.2 \"--sync--\" Ability { id: \"480A\", source: \"Hobbes\" }\r\n1223.8 \"--sync--\" Ability { id: \"4913\", source: \"Hobbes\" }\r\n1224.2 \"Short-Range Missile\" Ability { id: \"4815\", source: \"Hobbes\" }\r\n\r\n1231.8 \"Wall Mechanic B\"\r\n\r\n1262.6 \"Laser-Resistance Test x6\" Ability { id: \"4805\", source: \"Hobbes\" } duration 5.3\r\n\r\n1279.2 \"Floor 1\" Ability { id: \"481B\", source: \"Hobbes\" }\r\n1281.2 \"Laser Sight\" Ability { id: \"4807\", source: \"Hobbes\" }\r\n1285.8 \"Floor 2\" Ability { id: \"481B\", source: \"Hobbes\" }\r\n\r\n1294.5 \"--sync--\" Ability { id: \"480A\", source: \"Hobbes\" }\r\n1300.0 \"--sync--\" Ability { id: \"4913\", source: \"Hobbes\" }\r\n1301.9 \"Ring Laser\" Ability { id: \"47FF\", source: \"Hobbes\" } duration 8.1\r\n\r\n1308.0 \"Wall Mechanic C\"\r\n\r\n1339.0 \"Laser-Resistance Test x6\" Ability { id: \"4805\", source: \"Hobbes\" } duration 5.3\r\n\r\n1355.7 \"Floor 1\" Ability { id: \"481B\", source: \"Hobbes\" }\r\n1357.7 \"Short-Range Missile\" Ability { id: \"4815\", source: \"Hobbes\" }\r\n1362.3 \"Floor 2\" Ability { id: \"481B\", source: \"Hobbes\" }\r\n\r\n1370.9 \"--sync--\" Ability { id: \"480A\", source: \"Hobbes\" }\r\n1376.4 \"--sync--\" Ability { id: \"4913\", source: \"Hobbes\" }\r\n1376.8 \"Laser Sight\" Ability { id: \"4807\", source: \"Hobbes\" }\r\n1384.4 \"Wall Mechanic A\"\r\n\r\n1414.9 \"Laser-Resistance Test x6\" Ability { id: \"4805\", source: \"Hobbes\" } duration 5.3\r\n\r\n1429.0 \"Ring Laser\" Ability { id: \"47FF\", source: \"Hobbes\" } duration 8.1 window 100,100 jump 1200.8\r\n\r\n1431.6 \"Floor 1\"\r\n1438.1 \"Floor 2\"\r\n\r\n1446.4 \"--sync--\"\r\n1452.0 \"--sync--\"\r\n1452.4 \"Short-Range Missile\"\r\n\r\n1459.9 \"Wall Mechanic B\"\r\n\r\n\r\n### Goliath Tank\r\n# -ic 2P -p 4932:1509 493D:1800 -ii 4937 4934 4938 4935 4939 4936 493A 4933 470D 4943 493E\r\n# Warehouse C will be sealed off\r\n1500.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"D50\" } window 1500,0\r\n1509.0 \"Energy Ring\" Ability { id: \"4932\", source: \"Goliath Tank\" } duration 15.1 window 1509,10\r\n1516.9 \"Exploding Tethers\"\r\n1526.0 \"Convenient Self-Destruction\" Ability { id: \"493C\", source: \"Medium Exploder\" }\r\n1533.9 \"Laser Turret\" Ability { id: \"493B\", source: \"Goliath Tank\" }\r\n1547.2 \"Energy Ring\" Ability { id: \"4932\", source: \"Goliath Tank\" } duration 30\r\n1561.1 \"Exploding Tethers\"\r\n1570.2 \"Convenient Self-Destruction\" Ability { id: \"493C\", source: \"Medium Exploder\" }\r\n1584.2 \"Laser Turret\" Ability { id: \"493B\", source: \"Goliath Tank\" }\r\n1593.6 \"Laser Turret\" Ability { id: \"493B\", source: \"Goliath Tank\" }\r\n1603.0 \"Laser Turret\" Ability { id: \"493B\", source: \"Goliath Tank\" }\r\n\r\n1800.0 \"--sync--\" Ability { id: \"493D\", source: \"Flight Unit\" } window 300,0\r\n1810.0 \"--targetable--\"\r\n1817.2 \"--sync--\" Ability { id: \"493F\", source: \"Flight Unit\" }\r\n1821.7 \"Area Bombing Maneuver\" Ability { id: \"4942\", source: \"Flight Unit\" } duration 9.1\r\n1835.9 \"360-Degree Bombing Maneuver\" Ability { id: \"4941\", source: \"Flight Unit\" }\r\n1851.3 \"Lightfast Blade\" Ability { id: \"4940\", source: \"Flight Unit\" }\r\n1857.5 \"--sync--\" Ability { id: \"493F\", source: \"Flight Unit\" }\r\n1861.8 \"Area Bombing Maneuver\" Ability { id: \"4942\", source: \"Flight Unit\" } duration 9.1\r\n1871.1 \"Lightfast Blade\" Ability { id: \"4940\", source: \"Flight Unit\" }\r\n1873.2 \"--jump--\" Ability { id: \"493F\", source: \"Flight Unit\" }\r\n1879.7 \"Lightfast Blade\" Ability { id: \"4940\", source: \"Flight Unit\" }\r\n1888.8 \"360-Degree Bombing Maneuver\" Ability { id: \"4941\", source: \"Flight Unit\" }\r\n1899.1 \"360-Degree Bombing Maneuver\" Ability { id: \"4941\", source: \"Flight Unit\" }\r\n1918.5 \"Lightfast Blade\" Ability { id: \"4940\", source: \"Flight Unit\" }\r\n\r\n\r\n### Engels\r\n# -ic 2P -p 4727:2015.7 4740:2400 -ii 4751 4752 4729 4728 4753 4738 4735 4737 472F 4730 4731 4732 472B 472C 472D 473B 473D 4734 4758 4745 48FC 474F 4747 474D 4748\r\n\r\n# TODO: are the Marx Smashes after the crushers more specific?\r\n# One log has 472[6,7,7,A] as the four.  Left as all random for now.\r\n\r\n# Forward Deck will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"D52\" } window 2000,0\r\n2015.7 \"Marx Smash L/R\" Ability { id: \"472[67]\", source: \"Engels\" } window 2015.7,5\r\n2029.6 \"Marx Smash R/L\" Ability { id: \"472[67]\", source: \"Engels\" }\r\n2044.4 \"Precision Guided Missile\" Ability { id: \"4754\", source: \"Engels\" }\r\n2055.8 \"Incendiary Bombing\" Ability { id: \"4739\", source: \"Engels\" }\r\n2070.5 \"Guided Missile\" Ability { id: \"4736\", source: \"Engels\" } duration 3.4\r\n2078.8 \"Diffuse Laser\" Ability { id: \"4755\", source: \"Engels\" }\r\n2097.3 \"Marx Smash Back\" Ability { id: \"472[AE]\", source: \"Engels\" }\r\n2115.9 \"Marx Smash Front\" Ability { id: \"472[AE]\", source: \"Engels\" }\r\n2135.6 \"Energy Barrage\" Ability { id: \"473C\", source: \"Engels\" }\r\n2143.4 \"Laser Sight\" Ability { id: \"473A\", source: \"Engels\" }\r\n2154.1 \"Energy Blast\" Ability { id: \"473E\", source: \"Engels\" }\r\n2156.7 \"Surface Missile\" Ability { id: \"4733\", source: \"Engels\" }\r\n2171.6 \"Precision Guided Missile\" Ability { id: \"4754\", source: \"Engels\" }\r\n2178.0 \"Diffuse Laser\" Ability { id: \"4755\", source: \"Engels\" }\r\n\r\n# TODO: Maybe time-based or hp-based?\r\n2193.1 \"--untargetable--\"\r\n2193.2 \"--sync--\" Ability { id: \"473F\", source: \"Engels\" } window 200,50\r\n2197.0 \"Adds\"\r\n2198.3 \"--targetable--\"\r\n# These arm lasers can get desynced.\r\n2214.5 \"Arm Laser\" #Ability { id: \"4757\", source: \"Reverse-jointed Goliath\" }\r\n2229.7 \"Arm Laser\" #Ability { id: \"4757\", source: \"Reverse-jointed Goliath\" }\r\n2244.9 \"Arm Laser\" #Ability { id: \"4757\", source: \"Reverse-jointed Goliath\" }\r\n2258.3 \"Enrage\" # 60 seconds ???\r\n\r\n2400.0 \"Wide-Angle Diffuse Laser\" Ability { id: \"4740\", source: \"Engels\" } window 200,0\r\n2402.1 \"Diffuse Laser\" Ability { id: \"4741\", source: \"Engels\" }\r\n2412.2 \"--sync--\" Ability { id: \"4743\", source: \"Engels\" }\r\n2433.0 \"Demolish Structure\" Ability { id: \"4744\", source: \"Engels\" }\r\n\r\n2442.2 \"--targetable--\"\r\n2448.2 \"Marx Activation\" Ability { id: \"48A8\", source: \"Engels\" }\r\n2466.3 \"Marx Thrust\" Ability { id: \"4756\", source: \"Marx\" }\r\n2476.3 \"Marx Thrust\" Ability { id: \"4756\", source: \"Marx\" }\r\n2478.5 \"Area Bombardment\" Ability { id: \"4750\", source: \"Engels\" }\r\n2486.3 \"Marx Thrust\" Ability { id: \"4756\", source: \"Marx\" }\r\n2491.1 \"Incendiary Bombing\" Ability { id: \"4739\", source: \"Engels\" }\r\n2505.1 \"Guided Missile\" Ability { id: \"4736\", source: \"Engels\" }\r\n2511.4 \"Diffuse Laser\" Ability { id: \"4755\", source: \"Engels\" }\r\n2529.2 \"Incendiary Bombing\" Ability { id: \"4739\", source: \"Engels\" }\r\n2533.7 \"Marx Smash\" Ability { id: \"472E\", source: \"Engels\" }\r\n2553.9 \"Incendiary Bombing\" Ability { id: \"4739\", source: \"Engels\" }\r\n2558.5 \"Marx Smash\" Ability { id: \"472A\", source: \"Engels\" }\r\n2572.5 \"Incendiary Saturation Bombing\" Ability { id: \"474E\", source: \"Engels\" }\r\n\r\n2581.2 \"Crusher Adds\"\r\n2584.7 \"Marx Crush\" Ability { id: \"4746\", source: \"Engels\" }\r\n2586.8 \"Radiate Heat\" Ability { id: \"474C\", source: \"Engels\" }\r\n2586.8 \"Radiate Heat\" Ability { id: \"474C\", source: \"Engels\" }\r\n2593.9 \"Radiate Heat\" Ability { id: \"474C\", source: \"Engels\" }\r\n2600.0 \"Crushing Wheel\" Ability { id: \"474B\", source: \"Marx [LR]\" }\r\n2600.7 \"Radiate Heat\" Ability { id: \"474C\", source: \"Engels\" }\r\n2607.8 \"Radiate Heat\" Ability { id: \"474C\", source: \"Engels\" }\r\n2614.1 \"Crushing Wheel\" Ability { id: \"474B\", source: \"Marx [LR]\" }\r\n# guessing here for enrage ???\r\n2621.8 \"Radiate Heat\" Ability { id: \"474C\", source: \"Engels\" }\r\n2625.2 \"Crushing Wheel Enrage?\" Ability { id: \"474B\", source: \"Marx [LR]\" }\r\n\r\n2700.0 \"--targetable--\" NameToggle { name: \"Engels\", toggle: \"01\" } window 150,0\r\n2706.2 \"--sync--\" StartsUsing { id: \"4733\", source: \"Engels\" } window 150,5\r\n2709.7 \"Surface Missile\" Ability { id: \"4733\", source: \"Engels\" }\r\n2718.9 \"Marx Smash\" Ability { id: \"472[67AE]\", source: \"Engels\" }\r\n2728.6 \"Surface Missile\" Ability { id: \"4733\", source: \"Engels\" }\r\n2737.9 \"Marx Smash\" Ability { id: \"472[67AE]\", source: \"Engels\" }\r\n2747.0 \"Energy Barrage\" Ability { id: \"473C\", source: \"Engels\" }\r\n2754.8 \"Laser Sight\" Ability { id: \"473A\", source: \"Engels\" }\r\n2765.5 \"Energy Blast\" Ability { id: \"473E\", source: \"Engels\" }\r\n2768.1 \"Surface Missile\" Ability { id: \"4733\", source: \"Engels\" }\r\n2776.8 \"Diffuse Laser\" Ability { id: \"4755\", source: \"Engels\" }\r\n2790.6 \"Precision Guided Missile\" Ability { id: \"4754\", source: \"Engels\" }\r\n2795.0 \"Diffuse Laser\" Ability { id: \"4755\", source: \"Engels\" }\r\n2816.3 \"Surface Missile\" Ability { id: \"4733\", source: \"Engels\" }\r\n2825.5 \"Marx Smash\" Ability { id: \"472[67AE]\", source: \"Engels\" }\r\n2840.7 \"Incendiary Bombing\" Ability { id: \"4739\", source: \"Engels\" }\r\n2845.5 \"Marx Smash\" Ability { id: \"472[67AE]\", source: \"Engels\" }\r\n\r\n# TODO: it is unclear if this is the actual loop.\r\n# The log needs to be about ~14 min to verify if the\r\n# crusher phase happens again or if that's a one time thing.\r\n2859.3 \"Marx Activation\" Ability { id: \"48A8\", source: \"Engels\" } window 200,200 jump 2448.2\r\n2877.4 \"Marx Thrust\"\r\n2887.4 \"Marx Thrust\"\r\n2889.6 \"Area Bombardment\"\r\n2897.4 \"Marx Thrust\"\r\n2902.2 \"Incendiary Bombing\"\r\n2916.2 \"Guided Missile\"\r\n\r\n\r\n### 9S\r\n# -ic 2P -p 48F5:3013.3 48E7:3310 48EB:3510 -ii 49C4 48F9 48F7 48DC 485E 48E3 48E6 48E0 48EC 48A5 48A7 48D6 4ABE\r\n# Rear Deck will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"D53\" } window 3000,0\r\n3013.3 \"Neutralization\" Ability { id: \"48F5\", source: \"9S-Operated Walking Fortress\" } window 3013.3,10\r\n3021.5 \"Laser Saturation\" Ability { id: \"48F6\", source: \"9S-Operated Walking Fortress\" }\r\n3030.2 \"Laser Turret\" Ability { id: \"4A74\", source: \"9S-Operated Walking Fortress\" }\r\n3039.7 \"Ground-To-Ground Missile\" Ability { id: \"4974\", source: \"9S-Operated Walking Fortress\" }\r\n3049.3 \"Cannons\" Ability { id: \"48D[EF]\", source: \"9S-Operated Walking Fortress\" }\r\n3056.5 \"Cannons\" Ability { id: \"48D[EF]\", source: \"9S-Operated Walking Fortress\" }\r\n3065.7 \"Engage Marx Support\" Ability { id: \"48D3\", source: \"9S-Operated Walking Fortress\" }\r\n3081.9 \"Marx Impact\" Ability { id: \"48D4\", source: \"Marx\" }\r\n3087.5 \"Ground-To-Ground Missile\" Ability { id: \"4974\", source: \"9S-Operated Walking Fortress\" }\r\n3088.8 \"Laser Turret\" Ability { id: \"4A74\", source: \"9S-Operated Walking Fortress\" }\r\n3094.7 \"Laser Saturation\" Ability { id: \"48F6\", source: \"9S-Operated Walking Fortress\" }\r\n\r\n# Dodging Phase\r\n3108.2 \"--untargetable--\"\r\n3108.2 \"Undock\" Ability { id: \"4B37\", source: \"9S-Operated Walking Fortress\" }\r\n3108.5 \"--sync--\" Ability { id: \"4A5D\", source: \"9S-Operated Flight Unit\" }\r\n3123.6 \"--sync--\" Ability { id: \"48D8\", source: \"9S-Operated Flight Unit\" }\r\n3125.7 \"--sync--\" Ability { id: \"48D9\", source: \"9S-Operated Walking Fortress\" }\r\n3128.2 \"--sync--\" Ability { id: \"48DA\", source: \"9S-Operated Walking Fortress\" }\r\n3130.7 \"--sync--\" Ability { id: \"48DB\", source: \"9S-Operated Walking Fortress\" }\r\n3136.7 \"--sync--\" Ability { id: \"4B17\", source: \"9S-Operated Flight Unit\" }\r\n3138.9 \"--sync--\" Ability { id: \"48D9\", source: \"9S-Operated Walking Fortress\" }\r\n3141.4 \"--sync--\" Ability { id: \"48DA\", source: \"9S-Operated Walking Fortress\" }\r\n3143.9 \"--sync--\" Ability { id: \"48DB\", source: \"9S-Operated Walking Fortress\" }\r\n3146.8 \"--sync--\" Ability { id: \"48DD\", source: \"9S-Operated Walking Fortress\" }\r\n\r\n3151.7 \"--targetable--\"\r\n3152.0 \"--sync--\" StartsUsing { id: \"48F5\", source: \"9S-Operated Walking Fortress\" }\r\n3156.0 \"Neutralization\" Ability { id: \"48F5\", source: \"9S-Operated Walking Fortress\" }\r\n3170.7 \"Anti-Personnel Missile\" #Ability { id: \"48E4\", source: \"9S-Operated Walking Fortress\" }\r\n3172.7 \"Anti-Personnel Missile\" #Ability { id: \"48E4\", source: \"9S-Operated Walking Fortress\" }\r\n3178.3 \"Laser Turret\" Ability { id: \"4A74\", source: \"9S-Operated Walking Fortress\" }\r\n\r\n# Tank Adds\r\n3187.6 \"Engage Goliath Tank Support\" Ability { id: \"48E5\", source: \"9S-Operated Walking Fortress\" }\r\n3190.8 \"Tank Adds\"\r\n3196.9 \"--sync--\" Ability { id: \"48F8\", source: \"9S-Operated Walking Fortress\" }\r\n3202.5 \"Ground-To-Ground Missile\" Ability { id: \"4974\", source: \"9S-Operated Walking Fortress\" }\r\n3209.2 \"Laser Saturation\" Ability { id: \"48F6\", source: \"9S-Operated Walking Fortress\" }\r\n\r\n3217.4 \"--sync--\" Ability { id: \"48F8\", source: \"9S-Operated Walking Fortress\" } window 10,10 jump 3196.9\r\n3223.0 \"Ground-To-Ground Missile\"\r\n3229.7 \"Laser Saturation\"\r\n\r\n3243.5 \"Ground-To-Ground Missile\"\r\n3250.2 \"Laser Saturation\"\r\n\r\n3264.0 \"Ground-To-Ground Missile\"\r\n3270.7 \"Laser Saturation\"\r\n\r\n# Tank Explosions\r\n3300.0 \"--sync--\" StartsUsing { id: \"48E7\", source: \"9S-Operated Walking Fortress\" } window 200,0\r\n3310.0 \"Hack Goliath Tank\" Ability { id: \"48E7\", source: \"9S-Operated Walking Fortress\" }\r\n3310.0 \"Convenient Self-Destruction\" Ability { id: \"48E8\", source: \"Goliath Tank\" }\r\n3313.2 \"Ground-To-Ground Missile\" Ability { id: \"48F8\", source: \"9S-Operated Walking Fortress\" }\r\n3318.9 \"Convenient Self-Destruction\" Ability { id: \"48E9\", source: \"Goliath Tank\" }\r\n3325.4 \"Cannons\" Ability { id: \"48D[EF]\", source: \"9S-Operated Walking Fortress\" }\r\n3336.5 \"Laser Saturation\" Ability { id: \"48F6\", source: \"9S-Operated Walking Fortress\" }\r\n3342.6 \"Neutralization\" Ability { id: \"48F5\", source: \"9S-Operated Walking Fortress\" }\r\n\r\n# Three Adds\r\n# Adds independently can do Sidestriking or Centrifugal spin.\r\n3353.5 \"--untargetable--\"\r\n3353.6 \"--sync--\" Ability { id: \"48EA\", source: \"9S-Operated Walking Fortress\" }\r\n3360.0 \"Serial-Jointed Adds\"\r\n3362.7 \"--targetable--\"\r\n3379.8 \"Clanging Blow\" Ability { id: \"48F0\", source: \"Serial-jointed Service Model\" }\r\n3392.0 \"Shrapnel Impact\" Ability { id: \"48F3\", source: \"9S-Operated Walking Fortress\" }\r\n3398.0 \"Spin\" Ability { id: \"4A8[46]\", source: \"Serial-jointed Service Model\" }\r\n3407.1 \"Clanging Blow\" Ability { id: \"48F0\", source: \"Serial-jointed Service Model\" }\r\n3421.4 \"Shrapnel Impact\" Ability { id: \"48F3\", source: \"9S-Operated Walking Fortress\" }\r\n3422.3 \"Spin\" Ability { id: \"4A8[46]\", source: \"Serial-jointed Service Model\" }\r\n3432.7 \"Enrage?\" # 70s ???\r\n\r\n3500.0 \"--sync--\" StartsUsing { id: \"48EB\", source: \"9S-Operated Walking Fortress\" } window 300,0\r\n3510.0 \"Total Annihilation Maneuver\" Ability { id: \"48EB\", source: \"9S-Operated Walking Fortress\" }\r\n3520.0 \"--targetable--\"\r\n3530.1 \"Neutralization\" Ability { id: \"48F5\", source: \"9S-Operated Walking Fortress\" }\r\n3541.9 \"Ground-To-Ground Missile\" Ability { id: \"4974\", source: \"9S-Operated Walking Fortress\" }\r\n3543.2 \"Laser Turret\" Ability { id: \"4A74\", source: \"9S-Operated Walking Fortress\" }\r\n3562.0 \"Anti-Personnel Missile\" # Ability { id: \"48E4\", source: \"9S-Operated Walking Fortress\" }\r\n3564.0 \"Anti-Personnel Missile\" # Ability { id: \"48E4\", source: \"9S-Operated Walking Fortress\" }\r\n3566.0 \"Anti-Personnel Missile\" # Ability { id: \"48E4\", source: \"9S-Operated Walking Fortress\" }\r\n3573.0 \"Cannons\" Ability { id: \"48D[EF]\", source: \"9S-Operated Walking Fortress\" }\r\n3581.1 \"Laser Saturation\" Ability { id: \"48F6\", source: \"9S-Operated Walking Fortress\" }\r\n\r\n3591.1 \"--untargetable--\"\r\n3591.1 \"Undock\" Ability { id: \"48D5\", source: \"9S-Operated Walking Fortress\" }\r\n3600.3 \"--sync--\" Ability { id: \"48D8\", source: \"9S-Operated Flight Unit\" }\r\n3602.4 \"--sync--\" Ability { id: \"48D9\", source: \"9S-Operated Walking Fortress\" }\r\n3604.9 \"--sync--\" Ability { id: \"48DA\", source: \"9S-Operated Walking Fortress\" }\r\n3607.4 \"--sync--\" Ability { id: \"48DB\", source: \"9S-Operated Walking Fortress\" }\r\n3611.4 \"Anti-Personnel Missile\" Ability { id: \"4B11\", source: \"9S-Operated Walking Fortress\" }\r\n3614.6 \"--sync--\" Ability { id: \"48D8\", source: \"9S-Operated Flight Unit\" }\r\n3616.7 \"--sync--\" Ability { id: \"48D9\", source: \"9S-Operated Walking Fortress\" }\r\n3619.2 \"--sync--\" Ability { id: \"48DA\", source: \"9S-Operated Walking Fortress\" }\r\n3621.7 \"--sync--\" Ability { id: \"48DB\", source: \"9S-Operated Walking Fortress\" }\r\n3627.6 \"Anti-Personnel Missile\" Ability { id: \"4B11\", source: \"9S-Operated Walking Fortress\" }\r\n3628.7 \"--sync--\" Ability { id: \"4B17\", source: \"9S-Operated Flight Unit\" }\r\n3630.8 \"--sync--\" Ability { id: \"48D9\", source: \"9S-Operated Walking Fortress\" }\r\n3633.3 \"--sync--\" Ability { id: \"48DA\", source: \"9S-Operated Walking Fortress\" }\r\n3635.8 \"--sync--\" Ability { id: \"48DB\", source: \"9S-Operated Walking Fortress\" }\r\n3638.8 \"--sync--\" Ability { id: \"48DD\", source: \"9S-Operated Walking Fortress\" }\r\n\r\n3643.8 \"--targetable--\"\r\n3643.9 \"--sync--\" StartsUsing { id: \"48F6\", source: \"9S-Operated Walking Fortress\" } window 10,10\r\n3647.9 \"Laser Saturation\" Ability { id: \"48F6\", source: \"9S-Operated Walking Fortress\" }\r\n3659.3 \"Engage Marx Support\" Ability { id: \"48D3\", source: \"9S-Operated Walking Fortress\" }\r\n3674.5 \"Ground-To-Ground Missile\" Ability { id: \"48F8\", source: \"9S-Operated Walking Fortress\" }\r\n3675.6 \"Marx Impact\" Ability { id: \"48D4\", source: \"Marx\" }\r\n3681.6 \"Cannons\" Ability { id: \"48D[EF]\", source: \"9S-Operated Walking Fortress\" }\r\n3693.9 \"Neutralization\" Ability { id: \"48F5\", source: \"9S-Operated Walking Fortress\" }\r\n3705.7 \"Ground-To-Ground Missile\" Ability { id: \"4974\", source: \"9S-Operated Walking Fortress\" }\r\n3706.9 \"Laser Turret\" Ability { id: \"4A74\", source: \"9S-Operated Walking Fortress\" }\r\n3724.3 \"Anti-Personnel Missile\" #Ability { id: \"48E4\", source: \"9S-Operated Walking Fortress\" }\r\n3726.3 \"Anti-Personnel Missile\" #Ability { id: \"48E4\", source: \"9S-Operated Walking Fortress\" }\r\n3728.3 \"Anti-Personnel Missile\" #Ability { id: \"48E4\", source: \"9S-Operated Walking Fortress\" }\r\n3735.4 \"Cannons\" Ability { id: \"48D[EF]\", source: \"9S-Operated Walking Fortress\" }\r\n3743.5 \"Laser Saturation\" Ability { id: \"48F6\", source: \"9S-Operated Walking Fortress\" }\r\n3755.3 \"Ground-To-Ground Missile\" Ability { id: \"4974\", source: \"9S-Operated Walking Fortress\" }\r\n3756.5 \"Laser Turret\" Ability { id: \"4A74\", source: \"9S-Operated Walking Fortress\" }\r\n3763.4 \"Cannons\" Ability { id: \"48D[EF]\", source: \"9S-Operated Walking Fortress\" }\r\n3773.5 \"Neutralization\" Ability { id: \"48F5\", source: \"9S-Operated Walking Fortress\" }\r\n3783.6 \"Laser Saturation\" Ability { id: \"48F6\", source: \"9S-Operated Walking Fortress\" }\r\n\r\n3794.8 \"Engage Marx Support\" Ability { id: \"48D3\", source: \"9S-Operated Walking Fortress\" } window 100,100 jump 3659.3\r\n3810.0 \"Ground-To-Ground Missile\"\r\n3811.1 \"Marx Impact\"\r\n3817.1 \"Cannons\"\r\n3829.4 \"Neutralization\"\r\n3841.2 \"Ground-To-Ground Missile\"\r\n3842.4 \"Laser Turret\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/alliance/the_puppets_bunker.ts




// TODO: is it worth adding triggers for gaining/losing shield protocol? effect 8F[0-2]
// TODO: Incongruous Spin timeline trigger?
const swipeOutputStrings = {
  right: {
    en: 'Right',
    de: 'Rechts',
    fr: 'À droite ',
    ja: '右へ',
    cn: '右',
    ko: '오른쪽'
  },
  left: {
    en: 'Left',
    de: 'Links',
    fr: 'À gauche',
    ja: '左へ',
    cn: '左',
    ko: '왼쪽'
  }
};
const the_puppets_bunker_triggerSet = {
  id: 'ThePuppetsBunker',
  zoneId: zone_id/* default.ThePuppetsBunker */.Z.ThePuppetsBunker,
  timelineFile: 'the_puppets_bunker.txt',
  triggers: [{
    id: 'Puppet Aegis Anti-Personnel Laser You',
    type: 'HeadMarker',
    netRegex: {
      id: '00C6'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Puppet Aegis Anti-Personnel Laser Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '00C6'
    },
    run: (data, matches) => {
      data.busterTargets ??= [];
      data.busterTargets.push(matches.target);
    }
  }, {
    id: 'Puppet Aegis Anti-Personnel Laser Not You',
    type: 'HeadMarker',
    netRegex: {
      id: '00C6',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (!data.busterTargets) return;
      if (data.busterTargets.includes(data.me)) return;
      if (data.role === 'healer') return output.tankBuster();
      return output.avoidTankBuster();
    },
    run: data => delete data.busterTargets,
    outputStrings: {
      tankBuster: outputs/* default.tankBuster */.Z.tankBuster,
      avoidTankBuster: {
        en: 'Avoid tank buster',
        de: 'Tank buster ausweichen',
        fr: 'Évitez le tank buster',
        ja: 'タンクバスターを避ける',
        cn: '远离坦克死刑',
        ko: '탱버 피하기'
      }
    }
  }, {
    id: 'Puppet Aegis Beam Cannons',
    type: 'StartsUsing',
    netRegex: {
      source: '813P-Operated Aegis Unit',
      id: '5073',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go To Narrow Intersection',
        de: 'Geh zu der nahen Überschneidung',
        fr: 'Allez sur l\'intersection étroite',
        ja: '狭く重なっている範囲へ',
        cn: '去窄交叉口',
        ko: '조금 겹친 곳으로 이동'
      }
    }
  }, {
    id: 'Puppet Aegis Aerial Support Surface Laser',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: (data, matches) => data.me === matches.target && data.phase !== 'superior',
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Chasing Laser: Get Away',
        de: 'Verfolgende Laser: Weg gehen',
        fr: 'Soutien aérien : Éloignez-vous',
        ja: 'レーザー: 外へ',
        cn: '激光点名：快出去',
        ko: '추격 레이저: 이동'
      }
    }
  }, {
    id: 'Puppet Aegis Refraction Cannons 1',
    type: 'StartsUsing',
    netRegex: {
      source: '813P-Operated Aegis Unit',
      id: '5080',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Left, Behind Wing',
        de: 'Geh links hinter den Flügel',
        fr: 'Allez à gauche, derrière l\'aile',
        ja: '翼の左へ',
        cn: '去左边，翅膀后',
        ko: '왼쪽으로 이동 (날개 뒤)'
      }
    }
  }, {
    id: 'Puppet Aegis Refraction Cannons 2',
    type: 'StartsUsing',
    netRegex: {
      source: '813P-Operated Aegis Unit',
      id: '507F',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Right, Behind Wing',
        de: 'Geh rechts hinter den Flügel',
        fr: 'Allez à droite, derrière l\'aile',
        ja: '翼の右へ',
        cn: '去右边，翅膀后',
        ko: '오른쪽으로 이동 (날개 뒤)'
      }
    }
  }, {
    id: 'Puppet Aegis High-Powered Laser',
    type: 'StartsUsing',
    // This is also head marker 003E, but since there's three stacks, just say "stack".
    netRegex: {
      source: '813P-Operated Aegis Unit',
      id: '508F',
      capture: false
    },
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }, {
    id: 'Puppet Aegis Life\'s Last Song',
    type: 'StartsUsing',
    netRegex: {
      source: '813P-Operated Aegis Unit',
      id: '53B3',
      capture: false
    },
    // This is more a "if you haven't done this ever or in a while, here's a reminder."
    // Tell it once, but as this repeats nearly continously forever, only say it once.
    suppressSeconds: 9999,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge into ring gap',
        de: 'In die Lücke des Ringes ausweichen',
        fr: 'Esquivez dans les écarts de l\'anneau',
        ja: 'リングの切れ目へ',
        cn: '躲入环形缺口',
        ko: '고리 사이로 이동'
      }
    }
  }, {
    id: 'Puppet Light Volt Array',
    type: 'StartsUsing',
    netRegex: {
      source: 'Light Artillery Unit',
      id: '5211'
    },
    condition: data => data.CanSilence(),
    // Multiple of these cast at the same time.
    suppressSeconds: 5,
    response: responses/* Responses.interrupt */.n3.interrupt('alarm')
  }, {
    id: 'Puppet Spread Headmarker',
    type: 'HeadMarker',
    // Used for:
    // Homing Missile (Light Artillery)
    // Mechanical Contusion (The Compound)
    // R012: Laser (Compound 2P)
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Puppet Light Maneuver Martial Arm Target',
    type: 'StartsUsing',
    netRegex: {
      source: 'Light Artillery Unit',
      id: '5213'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Puppet Light Maneuver Martial Arm Collect',
    type: 'StartsUsing',
    netRegex: {
      source: 'Light Artillery Unit',
      id: '5213'
    },
    run: (data, matches) => {
      data.busterTargets ??= [];
      data.busterTargets.push(matches.target);
    }
  }, {
    id: 'Puppet Light Maneuver Martial Arm Healer',
    type: 'StartsUsing',
    netRegex: {
      source: 'Light Artillery Unit',
      id: '5213',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (!data.busterTargets) return;
      if (data.busterTargets.includes(data.me)) return;
      if (data.role === 'healer') return output.text();

      // Note: this doesn't cleave, so don't say anything about avoiding it.
    },

    run: data => delete data.busterTargets,
    outputStrings: {
      text: outputs/* default.tankBuster */.Z.tankBuster
    }
  }, {
    id: 'Puppet Superior Shield Protocol',
    type: 'StartsUsing',
    netRegex: {
      id: '4FA[678]',
      capture: false
    },
    run: data => data.phase = 'superior'
  }, {
    id: 'Puppet Superior Missile Command',
    type: 'StartsUsing',
    netRegex: {
      id: '4FBD',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // This is for Maneuver: Incendiary Bombing and Maneuver: Area Bombardment.
    id: 'Puppet Superior Incendiary Bombing',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: (data, matches) => data.me === matches.target && data.phase === 'superior',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fire Puddle on YOU',
        de: 'Feuer Fläche auf DIR',
        fr: 'Zone au sol de feu sur VOUS',
        ja: '自分にファイヤ',
        cn: '火圈点名',
        ko: '불 장판 대상자'
      }
    }
  }, {
    id: 'Puppet Superior High-Powered Laser',
    type: 'StartsUsing',
    // Note: no 1B marker for this???
    netRegex: {
      id: '4FB4',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Stack (Point Outside)',
        de: 'Auf einer Linie sammeln (nach außen zeigen)',
        fr: 'Package en ligne (orientez vers l\'extérieur)',
        ja: '直線頭割り (外に向ける)',
        cn: '直线分摊（指向场外）',
        ko: '쉐어 레이저 (밖으로 유도)'
      }
    }
  }, {
    id: 'Puppet Superior Sharp Turn Inside',
    type: 'StartsUsing',
    netRegex: {
      id: ['4FA9', '5511', '5513'],
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move to Inside',
        de: 'Nach Innen bewegen',
        fr: 'Allez à l\'intérieur',
        cn: '去里面',
        ko: '안으로'
      }
    }
  }, {
    id: 'Puppet Superior Sharp Turn Outside',
    type: 'StartsUsing',
    netRegex: {
      id: ['4FAA', '5512', '5514'],
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move to Outside',
        de: 'Nach Außen bewegen',
        fr: 'Allez à l\'extérieur',
        cn: '去外面',
        ko: '밖으로'
      }
    }
  }, {
    id: 'Puppet Superior Precision Guided Missile You',
    type: 'StartsUsing',
    netRegex: {
      id: '4FC5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Puppet Superior Precision Guided Missile Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '4FC5'
    },
    run: (data, matches) => {
      data.busterTargets ??= [];
      data.busterTargets.push(matches.target);
    }
  }, {
    id: 'Puppet Superior Precision Guided Missile Not You',
    type: 'StartsUsing',
    netRegex: {
      id: '4FC5',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (!data.busterTargets) return;
      if (data.busterTargets.includes(data.me)) return;
      if (data.role === 'healer') return output.tankBuster();
      return output.avoidTankBuster();
    },
    run: data => delete data.busterTargets,
    outputStrings: {
      tankBuster: outputs/* default.tankBuster */.Z.tankBuster,
      avoidTankBuster: {
        en: 'Avoid tank buster',
        de: 'Tank buster ausweichen',
        fr: 'Évitez le tank buster',
        ja: 'タンクバスターを避ける',
        cn: '远离坦克死刑',
        ko: '탱버 피하기'
      }
    }
  }, {
    id: 'Puppet Superior Sliding Swipe First',
    type: 'StartsUsing',
    netRegex: {
      id: ['4FA[CD]', '550[DEF]', '5510']
    },
    preRun: (data, matches) => {
      data.swipe ??= [];
      const swipeMap = {
        '4FAC': 'right',
        '4FAD': 'left',
        '550D': 'right',
        '550E': 'left',
        '550F': 'right',
        '5510': 'left'
      };
      data.swipe.push(swipeMap[matches.id]);
    },
    durationSeconds: 6,
    alertText: (data, _matches, output) => {
      data.swipe ??= [];
      if (data.swipe.length !== 1) return;

      // Call and clear the first swipe so we can not call it a second time below.
      const swipe = data.swipe[0];
      data.swipe[0] = undefined;
      return output[swipe ?? 'unknown']();
    },
    outputStrings: swipeOutputStrings
  }, {
    id: 'Puppet Superior Sliding Swipe Others',
    type: 'Ability',
    netRegex: {
      id: ['4FA[CD]', '550[DEF]', '5510'],
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (!data.swipe) return;

      // The first swipe callout has been cleared to undefined.
      // Deliberately skip it so that when the first swipe goes off, we call the second.
      let swipe = data.swipe.shift();
      if (swipe === undefined) swipe = data.swipe.shift();
      if (swipe === undefined) return;
      return output[swipe]();
    },
    outputStrings: swipeOutputStrings
  }, {
    id: 'Puppet Heavy Volt Array',
    type: 'StartsUsing',
    netRegex: {
      source: '905P-Operated Heavy Artillery Unit',
      id: '5006',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Puppet Heavy Active Laser Turret Initial',
    type: 'StartsUsing',
    netRegex: {
      source: '905P-Operated Heavy Artillery Unit',
      id: '4FED',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Outside Upper Laser',
        de: 'Raus aus dem oberen Laser',
        fr: 'À l\'extérieur des lasers supérieurs',
        ja: '高いレーザー放射装置の外へ',
        cn: '躲避远程激光',
        ko: '높은 레이저 쪽 밖으로 이동'
      }
    }
  }, {
    id: 'Puppet Heavy Active Laser Turret Move',
    type: 'StartsUsing',
    netRegex: {
      source: '905P-Operated Heavy Artillery Unit',
      id: '5086',
      capture: false
    },
    delaySeconds: 5.3,
    suppressSeconds: 5,
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'Puppet Heavy Unconventional Voltage',
    type: 'HeadMarker',
    netRegex: {
      id: '00AC'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Voltage cleave on YOU',
        de: 'Spannungs-Cleave auf DIR',
        fr: 'Arcs : Cleave sur VOUS',
        ja: '自分に扇形AoE',
        cn: '扇形AOE点名',
        ko: '전압 장판 대상자'
      }
    }
  }, {
    id: 'Puppet Heavy Revolving Laser',
    type: 'StartsUsing',
    netRegex: {
      source: '905P-Operated Heavy Artillery Unit',
      id: '5000',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Puppet Heavy High-Powered Laser',
    type: 'StartsUsing',
    // There's only one starts using, but it targets all the tanks sequentially.
    netRegex: {
      source: '905P-Operated Heavy Artillery Unit',
      id: '5001'
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankCleaveOnYou: {
          en: 'Tank Laser Cleave on YOU',
          de: 'Tank Laser cleave auf DIR',
          fr: 'Tank laser cleave sur VOUS',
          ja: '自分にタンクレーザー',
          cn: '坦克直线激光点名',
          ko: '탱커 레이저 대상자'
        },
        avoidTankCleaves: {
          en: 'Avoid tank laser cleaves',
          de: 'Tank Laser cleave ausweichen',
          fr: 'Évitez les Tanks laser cleaves',
          ja: 'タンクレーザーを避ける',
          cn: '躲避坦克直线激光',
          ko: '탱커 레이저 피하기'
        }
      };
      if (data.role === 'tank' || matches.target === data.me) return {
        alertText: output.tankCleaveOnYou()
      };
      return {
        infoText: output.avoidTankCleaves()
      };
    }
  }, {
    id: 'Puppet Heavy Support Pod',
    type: 'StartsUsing',
    netRegex: {
      source: '905P-Operated Heavy Artillery Unit',
      id: '4FE9',
      capture: false
    },
    // This is approximately when the pods appear.
    delaySeconds: 6,
    alertText: (data, _matches, output) => {
      data.heavyPodCount = (data.heavyPodCount ?? 0) + 1;
      if (data.heavyPodCount <= 2) {
        // The first two are lasers/hammers in either order.
        // The safe spot in both cases is the same direction.
        return output.getOutsideBetweenPods();
      }
      // There's nothing in the log that indicates what the screens do.
      // TODO: could check logs for tether target/source and say shift left/right?
      return output.getBetweenLasersWatchTethers();
    },
    outputStrings: {
      getOutsideBetweenPods: {
        en: 'Get Outside Between Pods',
        de: 'Zwischen den Pods raus gehen',
        fr: 'À l\'extérieur entre les Pods',
        ja: '外へ、二つのポッドの真ん中に',
        cn: '去场边两个辅助机之间',
        ko: '포드 사이로 이동'
      },
      getBetweenLasersWatchTethers: {
        en: 'Get Between Lasers (Watch Tethers)',
        de: 'Zwischen Laser gehen (auf die Verbindungen achten)',
        fr: 'Allez entre les lasers (regardez les liens)',
        ja: 'レーザーの真ん中に (線を気にして)',
        cn: '去激光之间（观察直线）',
        ko: '레이저 사이로 이동 (연결된 모니터 확인)'
      }
    }
  }, {
    id: 'Puppet Heavy Synthesize Compound',
    type: 'StartsUsing',
    netRegex: {
      source: '905P-Operated Heavy Artillery Unit',
      id: '4FEC',
      capture: false
    },
    // TODO: should this say "towers"? or...something else to indicate variable people needed?
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Turn Towers Blue',
        de: 'Türme zu Blau ändern',
        fr: 'Changez les tours en bleu',
        ja: '塔を青色に',
        cn: '多人踩圈至蓝色',
        ko: '장판이 파랑색이 되도록 들어가기'
      }
    }
  }, {
    id: 'Puppet Hallway Targeted Laser',
    type: 'HeadMarker',
    netRegex: {
      id: '00A4'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Laser on YOU',
        de: 'Laser auf DIR',
        fr: 'Laser sur VOUS',
        ja: '自分にレーザー',
        cn: '激光点名',
        ko: '레이저 대상자'
      }
    }
  }, {
    id: 'Puppet Compound Mechanical Laceration',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Compound',
      id: '51B8',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe(),
    run: data => data.phase = 'compound'
  }, {
    id: 'Puppet Compound Mechanical Dissection',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Compound',
      id: '51B3',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'Puppet Compound Mechanical Decapitation',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Compound',
      id: '51B4',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Puppet Compound 2P Centrifugal Slice',
    type: 'StartsUsing',
    netRegex: {
      source: 'Compound 2P',
      id: '51B8',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe(),
    // Cover this phase for the checkpoint as well.
    run: data => data.phase = 'compound'
  }, {
    id: 'Puppet Compound 2P Prime Blade Out',
    type: 'StartsUsing',
    netRegex: {
      source: 'Compound 2P',
      id: ['541F', '5198'],
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Puppet Compound 2P Prime Blade Behind',
    type: 'StartsUsing',
    netRegex: {
      source: 'Compound 2P',
      id: ['5420', '5199'],
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Puppet Compound 2P Prime Blade In',
    type: 'StartsUsing',
    netRegex: {
      source: 'Compound 2P',
      id: ['5421', '519A'],
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Puppet Compound 2P R012: Laser You',
    type: 'HeadMarker',
    // R012: Laser also puts out 008B headmarkers on non-tanks.
    netRegex: {
      id: '00DA'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster(),
    run: (data, matches) => {
      data.busterTargets ??= [];
      data.busterTargets.push(matches.target);
    }
  }, {
    id: 'Puppet Compound 2P R012: Laser Not You',
    type: 'HeadMarker',
    netRegex: {
      id: '00DA',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      if (!data.busterTargets) return;
      if (data.busterTargets.includes(data.me)) return;
      if (data.role === 'healer') return output.text();

      // Note: do not call out "avoid tank" here because there's a lot of markers going out.
    },

    run: data => delete data.busterTargets,
    outputStrings: {
      text: outputs/* default.tankBuster */.Z.tankBuster
    }
  }, {
    id: 'Puppet Compound 2P Three Parts Disdain',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    condition: data => data.phase === 'compound',
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Puppet Compound 2P Three Parts Disdain Knockback',
    type: 'HeadMarker',
    netRegex: {
      id: '003E',
      capture: false
    },
    condition: data => data.phase === 'compound',
    // Knockback prevention is 6 seconds long, and there's ~9.6s between marker and final hit.
    delaySeconds: 3.6,
    response: responses/* Responses.knockback */.n3.knockback('info')
  }, {
    id: 'Puppet Compound 2P Four Parts Resolve',
    type: 'HeadMarker',
    netRegex: {
      id: ['004F', '0050', '0051', '0052']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, matches, output) => {
      const fourPartsMap = {
        '004F': output.jump({
          num: 1
        }),
        '0050': output.cleave({
          num: 1
        }),
        '0051': output.jump({
          num: 2
        }),
        '0052': output.cleave({
          num: 2
        })
      };
      return fourPartsMap[matches.id] ?? output.unknown();
    },
    outputStrings: {
      jump: {
        en: 'Jump #${num} on YOU',
        de: 'Sprung #${num} auf DIR',
        fr: 'Saut #${num} sur VOUS',
        ja: '自分にジャンプ #${num}',
        cn: '单体跳砍#${num}点名',
        ko: '점프 #${num} 대상자'
      },
      cleave: {
        en: 'Cleave #${num} on YOU',
        de: 'Cleave #${num} auf DIR',
        fr: 'Cleave #${num} sur VOUS',
        ja: '自分に直線AoE #${num}',
        cn: '直线劈砍#${num}点名',
        ko: '직선공격 #${num} 대상자'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'Puppet Compound 2P Energy Compression',
    type: 'StartsUsing',
    netRegex: {
      source: 'Compound 2P',
      id: '51A6',
      capture: false
    },
    delaySeconds: 4,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 들어가기'
      }
    }
  }, {
    id: 'Puppet Compound Pod R011: Laser',
    type: 'StartsUsing',
    netRegex: {
      source: 'Compound Pod',
      id: '541B',
      capture: false
    },
    suppressSeconds: 2,
    // TODO: maybe this could be smarter and we could tell you where to go??
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Lasers',
        de: 'Laser ausweichen',
        fr: 'Évitez les lasers',
        ja: 'レーザーを避ける',
        cn: '躲避激光',
        ko: '레이저 피하기'
      }
    }
  }, {
    id: 'Puppet Puppet 2P Prime Blade Puppet Guaranteed In',
    type: 'StartsUsing',
    netRegex: {
      source: 'Puppet 2P',
      id: '5421',
      capture: false
    },
    suppressSeconds: 2,
    // TODO: have only seen this happen for the guaranteed Puppet In at 6250.7 with 4 clones.
    // TODO: can this happen at other times??
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Under Clone Corner',
        de: 'Unter den Klon in einer Ecke gehen',
        fr: 'Allez sous un clone dans un coin ',
        ja: 'コーナーの分裂体の下へ',
        cn: '去分身脚下',
        ko: '구석의 분신 아래로 이동'
      }
    }
  }, {
    id: 'Puppet Puppet 2P Prime Blade Puppet In',
    type: 'StartsUsing',
    netRegex: {
      source: 'Puppet 2P',
      id: '519A',
      capture: false
    },
    suppressSeconds: 2,
    // TODO: when I've seen this happen at 6379.4, it's been two clones, that start
    // at corners and then teleport to two cardinals across from each other with fake
    // teleports on the other cardinals.
    // TODO: fix this if these clones can go to corners.
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Under Cardinal Clone',
        de: 'Unter den Klon in einer der Himmelsrichtungen gehen',
        fr: 'Allez sous un clone sur un point cardinal',
        ja: '十字にいる分裂体の下へ',
        cn: '去真分身脚下',
        ko: '분신 아래로 이동'
      }
    }
  }, {
    id: 'Puppet Puppet 2P Prime Blade Puppet Out Corner',
    type: 'StartsUsing',
    netRegex: {
      source: 'Puppet 2P',
      id: '5198',
      capture: false
    },
    suppressSeconds: 2,
    // Have seen this be either:
    // * 4 clones teleporting around the outside of the arena (corner to corner)
    // * 4 clones teleporting in (to cardinals)
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Clones',
        de: 'Weg von den Klonen',
        fr: 'Éloignez-vous des clones',
        ja: '分裂体から離れる',
        cn: '远离分身',
        ko: '분신에게서 떨어지기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      '724P-operated superior flight unit \\(A-lpha\\)': '724P: Flugeinheit A-lpha',
      '767P-Operated Superior Flight Unit \\(B-Eta\\)': '767P: Flugeinheit B-eta',
      '772P-Operated Superior Flight Unit \\(C-Hi\\)': '772P: Flugeinheit C-hi',
      '813P-Operated Aegis Unit': '813P: Bollwerk',
      '905P-Operated Heavy Artillery Unit': '905P: Läufer',
      'Compound 2P': '2P: Fusion',
      'Compound Pod': 'Pod: Fusion',
      'Flight Unit': 'Flugeinheit',
      'Light Artillery Unit': 'leicht(?:e|er|es|en) Infanterieeinheit',
      '(?<!Compound )Pod': 'Pod',
      'Puppet 2P': '2P: Spaltung',
      'The Compound': 'Puppenklumpen',
      'The elevated detritus': 'Wrackteil A',
      'The sunken detritus': 'Wrackteil B',
      'The launch deck': 'Abschussdeck',
      'Core Command': 'Kommando-II',
      'The passage': 'Korridor'
    },
    'replaceText': {
      '(?<=\\(|/)Behind(?=\\))': 'Hinter',
      'Aerial Support: Bombardment': 'Luftunterstützung: Bombardement',
      'Aerial Support: Swoop': 'Luftunterstützung: Sturmangriff',
      'Anti-Personnel Missile': 'Abwehrraketen',
      'Apply Shield Protocol': 'Schutzsysteme aktivieren',
      'Authorization: No Restrictions': 'Verstärkung: Entsichern',
      'Centrifugal Slice': 'Spiralklinge',
      'Chemical Burn': 'Chemische Explosion',
      'Chemical Conflagration': 'Chemische Detonation',
      'Compound Pod: R011': 'Pod-Fusion: Programm R011',
      'Compound Pod: R012': 'Pod-Fusion: Programm R012',
      'Energy Bombardment': 'Energiemörser',
      'Energy Compression': 'Energetische Kondensation',
      'Explosion': 'Explosion',
      'Firing Order: Anti-Personnel Laser': 'Feuerbefehl: Antipersonenlaser',
      'Firing Order: High-Powered Laser': 'Feuerbefehl: Hochleistungslaser',
      'Firing Order: Surface Laser': 'Feuerbefehl: Laserschlag',
      'Flight Path': 'Sturmmanöver',
      'Forced Transfer': 'Erzwungener Teleport',
      'Formation: Air Raid': 'Synchronität: Luftschlag',
      'Formation: Sharp Turn': 'Synchronität: Rotationsangriff',
      'Formation: Sliding Swipe': 'Synchronität: Sturmangriff',
      'Four Parts Resolve': 'Vierfache Hiebsequenz',
      '(?<! )High-Powered Laser': 'Hochleistungslaser',
      'Homing Missile Impact': 'Suchraketeneinschlag',
      'Incendiary Barrage': 'Schwere Brandraketen',
      'Incongruous Spin': 'Laterale Rotation',
      'Initiate Self-Destruct': 'Selbstsprengungsysteme',
      'Lethal Revolution': 'Aureolenschlag',
      'Life\'s Last Song': 'Finale Kantate',
      'Lower Laser': 'Unterlaser',
      'Maneuver: Area Bombardment': 'Offensive: Blindraketen',
      'Maneuver: Beam Cannons': 'Offensive: Konvergenzgeschütze',
      'Maneuver: Collider Cannons': 'Offensive: Rotationsgeschütze',
      'Maneuver: High-Order Explosive Blast': 'Offensive: Explosivsprengköpfe',
      'Maneuver: High-Powered Laser': 'Offensive: Hochleistungslaser',
      'Maneuver: Impact Crusher': 'Offensive: Bodenlanze',
      'Maneuver: Incendiary Bombing': 'Offensive: Brandraketen',
      'Maneuver: Long-Barreled Laser': 'Offensive: Langlauf-Laser',
      'Maneuver: Martial Arm': 'Offensive: Nahkampf-Arm',
      'Maneuver: Missile Command': 'Offensive: Raketenkommando',
      'Maneuver: Precision Guided Missile': 'Offensive: Schwere Lenkrakete',
      'Maneuver: Refraction Cannons': 'Offensive: Coriolisgeschütze',
      'Maneuver: Revolving Laser': 'Offensive: Rotationslaser',
      'Maneuver: Saturation Bombing': 'Feuerbefehl: Omnidirektionalrakete',
      'Maneuver: Unconventional Voltage': 'Offensive: Konvergenzspannung',
      'Maneuver: Volt Array': 'Offensive: Diffusionsspannung',
      'Mechanical Contusion': 'Suchlaser',
      'Mechanical Decapitation': 'Zirkularlaser',
      'Mechanical Dissection': 'Linearlaser',
      'Mechanical Laceration': 'Omnilaser',
      'Operation: Access Self-Consciousness Data': 'Ausführen: Pseudo-21O',
      'Operation: Activate Laser Turret': 'Ausführen: Lasergeschütz',
      'Operation: Activate Suppressive Unit': 'Ausführen: Ringgeschütz',
      'Operation: Pod Program': 'Ausführen: Pod-Programm',
      'Operation: Synthesize Compound': 'Ausführen: Explosive Verbindung',
      'Prime Blade': 'Klingensequenz',
      'R010: Laser': 'R010: Laser',
      'R011: Laser': 'R011: Laser',
      'R012: Laser': 'R012: Laser',
      'R030: Hammer': 'R030: Hammer',
      'Relentless Spiral': 'Partikelspirale',
      'Reproduce': 'Teilung des Selbsts',
      '(?<!Formation: )Sharp Turn': 'Rotationsangriff',
      '(?<!Formation: )Sliding Swipe': 'Sturmangriff',
      'Support: Pod': 'Unterstützung: Pod-Schuss',
      'Surface Missile Impact': 'Raketeneinschlag',
      'Three Parts Disdain': 'Dreifache Hiebsequenz',
      'Upper Laser': 'Hauptlaser'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '724P-Operated Superior Flight Unit \\(A-Lpha\\)': '724P : avec module de vol renforcé [A-lpha]',
      '767P-Operated Superior Flight Unit \\(B-Eta\\)': '767P : avec module de vol renforcé [B-êta]',
      '772P-Operated Superior Flight Unit \\(C-Hi\\)': '772P : avec module de vol renforcé [C-hi]',
      '813P-Operated Aegis Unit': '813P : avec unité rempart',
      '905P-Operated Heavy Artillery Unit': '905P : avec unité terrestre lourde',
      'Compound 2P': '2P : amalgame',
      'Compound Pod': 'pod : amalgame',
      'Flight Unit': 'module de vol',
      'Light Artillery Unit': 'unité terrestre légère',
      '(?<!Compound )Pod': 'pod',
      'Puppet 2P': 'clone',
      'The Compound': 'agglomérat de pantins',
      'The elevated detritus': 'Plate-forme A',
      'The sunken detritus': 'Plate-forme B',
      'The launch deck': 'Aire de lancement',
      'Core Command': 'Salle de commandement n°2',
      'The passage': 'Couloir'
    },
    'replaceText': {
      '\\?': ' ?',
      '(?<=\\(|/)Behind(?=\\))': 'Derrière',
      'Aerial Support: Bombardment': 'Soutien aérien : pilonnage',
      'Aerial Support: Swoop': 'Soutien aérien : assaut',
      'Anti-Personnel Missile': 'Missile antipersonnel',
      'Apply Shield Protocol': 'Activation du programme défensif',
      'Authorization: No Restrictions': 'Extension : déverrouillage de l\'armement',
      'Centrifugal Slice': 'Brise-machine étendu',
      'Chemical Burn': 'Explosion chimique',
      'Chemical Conflagration': 'Grande explosion chimique',
      'Compound Pod: R011': 'Pods amalgames : R011',
      'Compound Pod: R012': 'Pods amalgames : R012',
      'Energy Bombardment': 'Tirs courbes',
      'Energy Compression': 'Condensation énergétique',
      '(?<!Grande )Explosion': 'Explosion',
      'Firing Order: Anti-Personnel Laser': 'Ordre de tir : lasers antipersonnels',
      'Firing Order: High-Powered Laser': 'Ordre de tir : laser surpuissant',
      'Firing Order: Surface Laser': 'Ordre de tir : lasers terrestres',
      'Flight Path': 'Manœuvre d\'assaut',
      'Forced Transfer': 'Téléportation forcée',
      'Formation: Air Raid': 'Combo : ruée explosive féroce',
      'Formation: Sharp Turn': 'Combo : taillade en triangle',
      'Formation: Sliding Swipe': 'Combo : taillade propulsée',
      'Four Parts Resolve': 'Grand impact tailladant',
      '(?<! )High-Powered Laser': 'Laser surpuissant',
      'Homing Missile Impact': 'Impact de missile à tête chercheuse',
      'Incendiary Barrage': 'Gros missiles incendiaires',
      'Incongruous Spin': 'Rotation calcinante',
      'Initiate Self-Destruct': 'Autodestruction',
      'Lethal Revolution': 'Taillade circulaire',
      'Life\'s Last Song': 'Ultime Cantate',
      'Lower Laser': 'Laser inférieur',
      'Maneuver: Area Bombardment': 'Attaque : déluge de missiles',
      'Maneuver: Beam Cannons': 'Attaque : canons à particules chargés',
      'Maneuver: Collider Cannons': 'Attaque : canons à particules rotatifs',
      'Maneuver: High-Order Explosive Blast': 'Attaque : ogive déflagrante',
      'Maneuver: High-Powered Laser': 'Attaque : laser surpuissant',
      'Maneuver: Impact Crusher': 'Attaque : marteau-piqueur',
      'Maneuver: Incendiary Bombing': 'Attaque : missiles incendiaires',
      'Maneuver: Long-Barreled Laser': 'Attaque : canon laser long',
      'Maneuver: Martial Arm': 'Attaque : bras de combat',
      'Maneuver: Missile Command': 'Attaque : tirs de missiles en chaîne',
      'Maneuver: Precision Guided Missile': 'Attaque : missiles à tête chercheuse ultraprécise',
      'Maneuver: Refraction Cannons': 'Attaque : canons à particules défléchissants',
      'Maneuver: Revolving Laser': 'Attaque : laser rotatif',
      'Maneuver: Saturation Bombing': 'Attaque : tir de missiles multidirectionnel',
      'Maneuver: Unconventional Voltage': 'Attaque : arcs convergents',
      'Maneuver: Volt Array': 'Attaque : arcs divergents',
      'Mechanical Contusion': 'Rayons fracassants',
      'Mechanical Decapitation': 'Rayons tailladants',
      'Mechanical Dissection': 'Rayons découpants',
      'Mechanical Laceration': 'Rayons multidirectionnels',
      'Operation: Access Self-Consciousness Data': 'Déploiement : données de conscience de 21O',
      'Operation: Activate Laser Turret': 'Déploiement : tourelle laser',
      'Operation: Activate Suppressive Unit': 'Déploiement : unité de tir annulaire',
      'Operation: Pod Program': 'Déploiement : programme de pod',
      'Operation: Synthesize Compound': 'Déploiement : composés explosifs',
      'Prime Blade': 'Brise-machine : coup chargé',
      'R010: Laser': 'R010 : Laser',
      'R011: Laser': 'R011 : Laser',
      'R012: Laser': 'R012 : Laser',
      'R030: Hammer': 'R030 : Marteau',
      'Relentless Spiral': 'Spirale rémanente',
      'Reproduce': 'Clonage',
      '(?<!Formation: )Sharp Turn': 'Taillade en triangle',
      '(?<!Formation: )Sliding Swipe': 'Taillade propulsée',
      'Support: Pod': 'Déploiement : pods',
      'Surface Missile Impact': 'Impact de missile terrestre',
      'Three Parts Disdain': 'Triple impact tailladant',
      'Upper Laser': 'Laser supérieur'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '724P-Operated Superior Flight Unit \\\\\\(A-Lpha\\\\\\)': '７２４Ｐ：強化型飛行ユニット［A-lpha］',
      '767P-Operated Superior Flight Unit \\\\\\(B-Eta\\\\\\)': '７６７Ｐ：強化型飛行ユニット［B-eta］',
      '772P-Operated Superior Flight Unit \\\\\\(C-Hi\\\\\\)': '７７２Ｐ：強化型飛行ユニット［C-hi］',
      '813P-Operated Aegis Unit': '８１３Ｐ：拠点防衛ユニット装備',
      '905P-Operated Heavy Artillery Unit': '９０５Ｐ：重陸戦ユニット装備',
      'Compound 2P': '２Ｐ：融合体',
      'Compound Pod': 'ポッド：融合体',
      '(?<!Superior )Flight Unit': '飛行ユニット',
      'Light Artillery Unit': '軽陸戦ユニット',
      '(?<!Compound )Pod': 'ポッド',
      'Puppet 2P': '２Ｐ：分裂体',
      'The Compound': '融合シタ人形タチ',
      'The elevated detritus': '残骸A',
      'The sunken detritus': '残骸B',
      'The launch deck': '射出デッキ',
      'Core Command': '第二司令室',
      'The passage': '通路'
    },
    'replaceText': {
      '(?<=\\(|/)Behind(?=\\))': '後ろに',
      'Aerial Support: Bombardment': '航空支援：爆撃',
      'Aerial Support: Swoop': '航空支援：突撃',
      'Anti-Personnel Missile': '対人ミサイル',
      'Apply Shield Protocol': '防御プログラム適用',
      'Authorization: No Restrictions': '拡張：武装ロック解除',
      'Centrifugal Slice': '全面斬機',
      'Chemical Burn': '化合物爆発',
      'Chemical Conflagration': '化合物大爆発',
      'Compound Pod: R011': 'ポッド融合体：R011',
      'Compound Pod: R012': 'ポッド融合体：R012',
      'Energy Bombardment': '迫撃エネルギー弾',
      'Energy Compression': 'エネルギー凝縮',
      'Explosion': '爆発',
      'Firing Order: Anti-Personnel Laser': '砲撃命令：対人レーザー',
      'Firing Order: High-Powered Laser': '砲撃命令：高出力レーザー',
      'Firing Order: Surface Laser': '砲撃命令：対地レーザー',
      'Flight Path': '突撃機動',
      'Forced Transfer': '強制転送',
      'Formation: Air Raid': '連携：急襲爆撃',
      'Formation: Sharp Turn': '連携：転回斬撃',
      'Formation: Sliding Swipe': '連携：突進斬撃',
      'Four Parts Resolve': '四連断重撃',
      '(?<!: )High-Powered Laser': '高出力レーザー',
      'Homing Missile Impact': '追尾ミサイル着弾',
      'Incendiary Barrage': '大型焼尽ミサイル',
      'Incongruous Spin': '逆断震回転',
      'Initiate Self-Destruct': '自爆システム起動',
      'Lethal Revolution': '旋回斬撃',
      'Life\'s Last Song': '終焉ノ歌',
      'Lower Laser': '下部レーザー',
      'Maneuver: Area Bombardment': '攻撃：ミサイル乱射',
      'Maneuver: Beam Cannons': '攻撃：収束粒子砲',
      'Maneuver: Collider Cannons': '攻撃：旋回粒子砲',
      'Maneuver: High-Order Explosive Blast': '攻撃：爆風効果弾頭',
      'Maneuver: High-Powered Laser': '攻撃：高出力レーザー',
      'Maneuver: Impact Crusher': '攻撃：地穿潰砕',
      'Maneuver: Incendiary Bombing': '攻撃：焼尽ミサイル',
      'Maneuver: Long-Barreled Laser': '攻撃：長砲身レーザー',
      'Maneuver: Martial Arm': '攻撃：格闘アーム',
      'Maneuver: Missile Command': '攻撃：ミサイル全弾発射',
      'Maneuver: Precision Guided Missile': '攻撃：高性能誘導ミサイル',
      'Maneuver: Refraction Cannons': '攻撃：偏向粒子砲',
      'Maneuver: Revolving Laser': '攻撃：回転レーザー',
      'Maneuver: Saturation Bombing': '攻撃：全方位ミサイル',
      'Maneuver: Unconventional Voltage': '攻撃：収束ヴォルト',
      'Maneuver: Volt Array': '攻撃：拡散ヴォルト',
      'Mechanical Contusion': '砕機光撃',
      'Mechanical Decapitation(?!/)': '斬機光撃',
      'Mechanical Decapitation/Dissection': '斬機光撃/断機光撃',
      'Mechanical Dissection(?!/)': '断機光撃',
      'Mechanical Dissection/Decapitation': '断機光撃/斬機光撃',
      'Mechanical Laceration': '制圧光撃',
      'Operation: Access Self-Consciousness Data': 'オペレート：２１Ｏ自我データ',
      'Operation: Activate Laser Turret': 'オペレート：レーザータレット',
      'Operation: Activate Suppressive Unit': 'オペレート：環状銃撃ユニット',
      'Operation: Pod Program': 'オペレート：ポッドプログラム',
      'Operation: Synthesize Compound': 'オペレート：爆発性化合物',
      'Prime Blade': '斬機撃：充填',
      'R010: Laser': 'R010：レーザー',
      'R011: Laser': 'R011：レーザー',
      'R012: Laser': 'R012：レーザー',
      'R030: Hammer': 'R030：ハンマー',
      'Relentless Spiral': '渦状光維奔突',
      'Reproduce': '分体生成',
      '(?<!Formation: )Sharp Turn': '転回斬撃',
      '(?<!Formation: )Sliding Swipe': '突進斬撃',
      'Support: Pod': '支援：ポッド射出',
      'Surface Missile Impact': '対地ミサイル着弾',
      'Three Parts Disdain': '三連衝撃斬',
      'Upper Laser': '上部レーザー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '724P-Operated Superior Flight Unit \\\\\\(A-Lpha\\\\\\)': '724P：强化型飞行装置[A-lpha]',
      '767P-Operated Superior Flight Unit \\\\\\(B-Eta\\\\\\)': '767P：强化型飞行装置[B-eta]',
      '772P-Operated Superior Flight Unit \\\\\\(C-Hi\\\\\\)': '772P：强化型飞行装置[C-hi]',
      '813P-Operated Aegis Unit': '813P：装备据点防卫装置',
      '905P-Operated Heavy Artillery Unit': '905P：装备重型陆战装置',
      'Compound 2P': '2P：融合体',
      'Compound Pod': '辅助机：融合体',
      '(?<!Superior )Flight Unit': '飞行装置',
      'Light Artillery Unit': '轻型陆战装置',
      '(?<!Compound )Pod': '辅助机',
      'Puppet 2P': '2P：分裂体',
      'The Compound': '融合的人偶群',
      'The elevated detritus': '残骸A',
      'The sunken detritus': '残骸B',
      'The launch deck': '发射甲板',
      'Core Command': '第二司令室',
      'The passage': '通道'
    },
    'replaceText': {
      '(?<=\\(|/)Behind(?=\\))': '后',
      'Aerial Support: Bombardment': '航空支援：轰炸',
      'Aerial Support: Swoop': '航空支援：突击',
      'Anti-Personnel Missile': '对人导弹乱射',
      'Apply Shield Protocol': '启用防御程序',
      'Authorization: No Restrictions': '扩展：解除武装锁定',
      'Centrifugal Slice': '全方位斩机',
      'Chemical Burn': '化合物爆炸',
      'Chemical Conflagration': '化合物大爆炸',
      'Compound Pod: R011': '辅助机融合体：R011',
      'Compound Pod: R012': '辅助机融合体：R012',
      'Energy Bombardment': '迫击能量弹',
      'Energy Compression': '能量凝缩',
      'Explosion': '爆炸',
      'Firing Order: Anti-Personnel Laser': '炮击命令：对人激光',
      'Firing Order: High-Powered Laser': '炮击命令：高功率激光',
      'Firing Order: Surface Laser': '炮击命令：对地激光',
      'Flight Path': '突击机动',
      'Forced Transfer': '强制传送',
      'Formation: Air Raid': '协作：突袭轰炸',
      'Formation: Sharp Turn': '协作：回转斩击',
      'Formation: Sliding Swipe': '协作：冲锋斩击',
      'Four Parts Resolve': '四连断重击',
      '(?<! )High-Powered Laser': '高功率激光',
      'Homing Missile Impact': '追尾导弹命中',
      'Incendiary Barrage': '大型燃烬导弹',
      'Incongruous Spin': '逆断震回旋',
      'Initiate Self-Destruct': '自爆系统启动',
      'Lethal Revolution': '旋回斩击',
      'Life\'s Last Song': '终焉之歌',
      'Lower Laser': '下方激光',
      'Maneuver: Area Bombardment': '攻击：导弹乱射',
      'Maneuver: Beam Cannons': '攻击：收束粒子炮',
      'Maneuver: Collider Cannons': '攻击：旋回粒子炮',
      'Maneuver: High-Order Explosive Blast': '攻击：气浪效果弹头',
      'Maneuver: High-Powered Laser': '攻击：高功率激光',
      'Maneuver: Impact Crusher': '攻击：穿地溃碎',
      'Maneuver: Incendiary Bombing': '攻击：燃烬导弹',
      'Maneuver: Long-Barreled Laser': '攻击：长炮激光',
      'Maneuver: Martial Arm': '攻击：格斗机械臂',
      'Maneuver: Missile Command': '攻击：导弹全弹发射',
      'Maneuver: Precision Guided Missile': '攻击：高性能诱导导弹',
      'Maneuver: Refraction Cannons': '攻击：偏向粒子炮',
      'Maneuver: Revolving Laser': '攻击：回旋激光',
      'Maneuver: Saturation Bombing': '攻击：全方位导弹轰炸',
      'Maneuver: Unconventional Voltage': '攻击：集束电压',
      'Maneuver: Volt Array': '攻击：扩散电压',
      'Mechanical Contusion': '碎机光击',
      'Mechanical Decapitation(?!/)': '斩机光击',
      'Mechanical Decapitation/Dissection': '斩机光击/断机光击',
      'Mechanical Dissection(?!/)': '断机光击',
      'Mechanical Dissection/Decapitation': '断机光击/斩机光击',
      'Mechanical Laceration': '压制光击',
      'Operation: Access Self-Consciousness Data': '通信：21O自我数据',
      'Operation: Activate Laser Turret': '通信：激光炮塔',
      'Operation: Activate Suppressive Unit': '通信：环状枪击装置',
      'Operation: Pod Program': '通信：辅助机程序',
      'Operation: Synthesize Compound': '通信：爆炸性化合物',
      'Prime Blade': '斩机击：填充',
      'R010: Laser': 'R010:激光',
      'R011: Laser': 'R011：激光',
      'R012: Laser': 'R012：激光',
      'R030: Hammer': 'R030:重锤',
      'Relentless Spiral': '涡状光线奔涌',
      'Reproduce': '分裂体生成',
      '(?<!Formation: )Sharp Turn': '回转斩击',
      '(?<!Formation: )Sliding Swipe': '冲锋斩击',
      'Support: Pod': '支援：辅助机射出',
      'Surface Missile Impact': '对地导弹命中',
      'Three Parts Disdain': '三连冲击斩',
      'Upper Laser': '上方激光'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '724P-Operated Superior Flight Unit \\\\\\(A-Lpha\\\\\\)': '강화형 비행 유닛 [A-lpha]',
      '767P-Operated Superior Flight Unit \\\\\\(B-Eta\\\\\\)': '767P: 강화형 비행 유닛 [B-eta]',
      '772P-Operated Superior Flight Unit \\\\\\(C-Hi\\\\\\)': '강화형 비행 유닛 [C-hi]',
      '813P-Operated Aegis Unit': '813P: 거점 방위 유닛 장비',
      '905P-Operated Heavy Artillery Unit': '905P: 중장 육지전 유닛 장비',
      'Compound 2P': '2P: 융합체',
      'Compound Pod': '포드: 융합체',
      '(?<!Superior )Flight Unit': '비행 유닛',
      'Light Artillery Unit': '경장 육지전 유닛',
      'Puppet 2P': '2P: 분열체',
      'The Compound': '융합한 인형들',
      '(?<!Compound )Pod': '포드',
      'The elevated detritus': '잔해 A',
      'The sunken detritus': '잔해 B',
      'The launch deck': '사출 갑판',
      'Core Command': '제2사령실',
      'The passage': '통로'
    },
    'replaceText': {
      '\\(Behind\\)': '(뒤)',
      '\\(Out/Behind\\)': '(밖/뒤)',
      '\\(In/Out\\)': '(안/밖)',
      'Aerial Support: Bombardment': '항공 지원: 폭격',
      'Aerial Support: Swoop': '항공 지원: 돌격',
      'Anti-Personnel Missile': '대인 미사일 난사',
      'Apply Shield Protocol': '방어 프로그램 적용',
      'Authorization: No Restrictions': '확장: 무장 잠금 해제',
      'Centrifugal Slice': '전체 베기',
      'Chemical Burn': '화합물 폭발',
      'Chemical Conflagration': '화합물 대폭발',
      'Compound Pod: R011': '포드 융합체: R011',
      'Compound Pod: R012': '포드 융합체: R012',
      'Energy Bombardment': '박격 에너지탄',
      'Energy Compression': '에너지 응축',
      'Explosion': '폭발',
      'Firing Order: Anti-Personnel Laser': '포격 명령: 대인 레이저',
      'Firing Order: High-Powered Laser': '포격 명령: 고출력 레이저',
      'Firing Order: Surface Laser': '포격 명령: 대지 레이저',
      'Flight Path': '돌격기동',
      'Forced Transfer': '강제 전송',
      'Formation: Air Raid': '연계: 급습폭격',
      'Formation: Sharp Turn': '연계: 회전참격',
      'Formation: Sliding Swipe': '연계: 돌진참격',
      'Four Parts Resolve': '사연속 단중격',
      'Homing Missile Impact': '추적 미사일 착탄',
      'Incendiary Barrage': '대형 소진 미사일',
      'Incongruous Spin': '역차진 회전',
      'Initiate Self-Destruct': '자폭 시스템 기동',
      'Lethal Revolution': '선회참격',
      'Life\'s Last Song': '종언의 노래',
      'Lower Laser': '하부 레이저',
      'Maneuver: Area Bombardment': '공격: 미사일 난사',
      'Maneuver: Beam Cannons': '공격: 집속입자포',
      'Maneuver: Collider Cannons': '공격: 선회입자포',
      'Maneuver: High-Order Explosive Blast': '공격: 폭파 탄두',
      'Maneuver: High-Powered Laser': '공격: 고출력 레이저',
      'Maneuver: Impact Crusher': '공격: 지면 타공',
      'Maneuver: Incendiary Bombing': '공격: 소진 미사일',
      'Maneuver: Long-Barreled Laser': '공격: 장포신 레이저',
      'Maneuver: Martial Arm': '공격: 격투 무기',
      'Maneuver: Missile Command': '공격: 미사일 전탄 발사',
      'Maneuver: Precision Guided Missile': '공격: 고성능 유도 미사일',
      'Maneuver: Refraction Cannons': '공격: 편향입자포',
      'Maneuver: Revolving Laser': '공격: 회전 레이저',
      'Maneuver: Saturation Bombing': '공격: 전방위 미사일',
      'Maneuver: Unconventional Voltage': '공격: 집속 볼트',
      'Maneuver: Volt Array': '공격: 확산 볼트',
      'Operation: Access Self-Consciousness Data': '오퍼레이션: 21O 자아 데이터',
      'Operation: Activate Laser Turret': '오퍼레이션: 레이저 포탑',
      'Operation: Activate Suppressive Unit': '오퍼레이션: 순환 총격 유닛',
      'Operation: Pod Program': '오퍼레이션: 포드 프로그램',
      'Operation: Synthesize Compound': '오퍼레이션: 폭발성 화합물',
      'Prime Blade': '검격: 충전',
      'R010: Laser': 'R010: 레이저',
      'R011: Laser': 'R011: 레이저',
      'R012: Laser': 'R012: 레이저',
      'R030: Hammer': 'R030: 해머',
      'Relentless Spiral': '나선광 분출',
      'Reproduce': '분열체 생성',
      'Support: Pod': '지원: 포드 사출',
      'Surface Missile Impact': '대지 미사일 착탄',
      'Three Parts Disdain': '삼연속 충격참',
      'Upper Laser': '상부 레이저',
      '(?<!: )High-Powered Laser': '고출력 레이저',
      'Mechanical Contusion': '분쇄 광격',
      'Mechanical Decapitation(?!/)': '참수 광격',
      'Mechanical Dissection(?!/)': '절단 광격',
      'Mechanical Laceration': '제압 광격',
      'Mechanical Decapitation/Dissection': '참수/절단 광격',
      'Mechanical Dissection/Decapitation': '절단/참수 광격',
      '(?<!Formation: )Sharp Turn': '회전참격',
      '(?<!Formation: )Sliding Swipe': '돌진참격',
      'Three Parts Resolve': '삼연속 단중격'
    }
  }]
};
/* harmony default export */ const the_puppets_bunker = (the_puppets_bunker_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/alliance/the_puppets_bunker.txt
const alliance_the_puppets_bunker_namespaceObject = "### The Puppets' Bunker\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### 813P-Operated Aegis Unit\r\n# -p 508D:112.8 -ii 5074 5075 5076 5091 5092 5081 5099 507E 5090 51BC\r\n\r\n# Elevated Detritus will be sealed off\r\n100.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"DB0\" } window 100,0\r\n112.8 \"Firing Order: Anti-Personnel Laser\" Ability { id: \"508D\", source: \"813P-Operated Aegis Unit\" } window 112.8,20\r\n125.1 \"--sync--\" Ability { id: \"507[789A]\", source: \"813P-Operated Aegis Unit\" }\r\n140.1 \"Maneuver: Beam Cannons\" Ability { id: \"5073\", source: \"813P-Operated Aegis Unit\" }\r\n158.4 \"Maneuver: Collider Cannons\" Ability { id: \"507[BCD]\", source: \"813P-Operated Aegis Unit\" }\r\n170.6 \"Firing Order: Surface Laser\" Ability { id: \"508E\", source: \"813P-Operated Aegis Unit\" }\r\n177.7 \"Aerial Support: Swoop\" Ability { id: \"50D2\", source: \"813P-Operated Aegis Unit\" }\r\n187.8 \"Flight Path\" Ability { id: \"508C\", source: \"Flight Unit\" }\r\n197.9 \"Maneuver: Refraction Cannons\" Ability { id: [\"507F\", \"5080\"], source: \"813P-Operated Aegis Unit\" }\r\n206.2 \"--sync--\" Ability { id: \"507[789A]\", source: \"813P-Operated Aegis Unit\" }\r\n220.2 \"Maneuver: Beam Cannons\" Ability { id: \"5073\", source: \"813P-Operated Aegis Unit\" }\r\n239.6 \"Aerial Support: Bombardment\" Ability { id: \"50D3\", source: \"813P-Operated Aegis Unit\" }\r\n244.4 \"--adds targetable--\"\r\n249.8 \"Firing Order: Surface Laser\" Ability { id: \"508E\", source: \"813P-Operated Aegis Unit\" }\r\n256.0 \"Firing Order: High-Powered Laser\" Ability { id: \"508F\", source: \"813P-Operated Aegis Unit\" }\r\n263.3 \"High-Powered Laser\" Ability { id: \"5093\", source: \"813P-Operated Aegis Unit\" }\r\n269.5 \"Maneuver: Saturation Bombing?\" Ability { id: \"5097\", source: \"Flight Unit\" }\r\n\r\n# Singing Rotation 1\r\n280.3 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n287.8 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n288.3 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n295.8 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n296.3 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n303.8 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n309.3 \"Aerial Support: Swoop\" Ability { id: \"50D2\", source: \"813P-Operated Aegis Unit\" }\r\n317.4 \"Maneuver: Refraction Cannons\" Ability { id: [\"507F\", \"5080\"], source: \"813P-Operated Aegis Unit\" }\r\n319.4 \"Flight Path\" Ability { id: \"508C\", source: \"Flight Unit\" }\r\n328.5 \"Firing Order: Surface Laser\" Ability { id: \"508E\", source: \"813P-Operated Aegis Unit\" }\r\n330.7 \"--sync--\" Ability { id: \"507[789A]\", source: \"813P-Operated Aegis Unit\" }\r\n345.7 \"Maneuver: Beam Cannons\" Ability { id: \"5073\", source: \"813P-Operated Aegis Unit\" }\r\n349.8 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n\r\n# Singing Rotation 2\r\n354.8 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n357.3 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n359.8 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n362.3 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n364.8 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n367.3 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n369.8 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n372.3 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n377.3 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n382.8 \"Aerial Support: Swoop\" Ability { id: \"50D2\", source: \"813P-Operated Aegis Unit\" }\r\n392.9 \"Flight Path\" Ability { id: \"508C\", source: \"Flight Unit\" }\r\n394.4 \"Maneuver: Collider Cannons\" Ability { id: \"507[BCD]\", source: \"813P-Operated Aegis Unit\" }\r\n411.7 \"Firing Order: Anti-Personnel Laser\" Ability { id: \"508D\", source: \"813P-Operated Aegis Unit\" }\r\n422.3 \"Maneuver: Collider Cannons\" Ability { id: \"507[BCD]\", source: \"813P-Operated Aegis Unit\" }\r\n441.6 \"Firing Order: Surface Laser\" Ability { id: \"508E\", source: \"813P-Operated Aegis Unit\" }\r\n443.8 \"--sync--\" Ability { id: \"507[789A]\", source: \"813P-Operated Aegis Unit\" }\r\n458.8 \"Maneuver: Beam Cannons\" Ability { id: \"5073\", source: \"813P-Operated Aegis Unit\" }\r\n462.9 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n\r\n# Singing Rotation Loop\r\n467.9 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n470.3 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n472.8 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n475.3 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n477.8 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n480.3 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n482.8 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n485.2 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n490.2 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n495.7 \"Aerial Support: Swoop\" Ability { id: \"50D2\", source: \"813P-Operated Aegis Unit\" }\r\n503.8 \"Maneuver: Refraction Cannons\" Ability { id: [\"507F\", \"5080\"], source: \"813P-Operated Aegis Unit\" }\r\n505.8 \"Flight Path\" Ability { id: \"508C\", source: \"Flight Unit\" }\r\n521.1 \"Firing Order: Anti-Personnel Laser\" Ability { id: \"508D\", source: \"813P-Operated Aegis Unit\" }\r\n531.1 \"Maneuver: Collider Cannons\" Ability { id: \"507[BCD]\", source: \"813P-Operated Aegis Unit\" }\r\n550.5 \"Firing Order: Surface Laser\" Ability { id: \"508E\", source: \"813P-Operated Aegis Unit\" }\r\n552.7 \"--sync--\" Ability { id: \"507[789A]\", source: \"813P-Operated Aegis Unit\" }\r\n566.7 \"Maneuver: Beam Cannons\" Ability { id: \"5073\", source: \"813P-Operated Aegis Unit\" }\r\n570.8 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n\r\n# lookahead loop\r\n575.8 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n578.2 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n580.7 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n583.2 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n585.7 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n588.2 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n590.7 \"--sync--\" Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n593.1 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n598.1 \"Life's Last Song\" Ability { id: \"53B3\", source: \"813P-Operated Aegis Unit\" }\r\n603.6 \"Aerial Support: Swoop\" Ability { id: \"50D2\", source: \"813P-Operated Aegis Unit\" } window 100,100 jump 495.7\r\n611.7 \"Maneuver: Refraction Cannons\" #Ability { id: [\"507F\", \"5080\"], source: \"813P-Operated Aegis Unit\" }\r\n613.7 \"Flight Path\" #Ability { id: \"508C\", source: \"Flight Unit\" }\r\n629.0 \"Firing Order: Anti-Personnel Laser\" #Ability { id: \"508D\", source: \"813P-Operated Aegis Unit\" }\r\n639.0 \"Maneuver: Collider Cannons\" #Ability { id: \"507[BCD]\", source: \"813P-Operated Aegis Unit\" }\r\n658.4 \"Firing Order: Surface Laser\" #Ability { id: \"508E\", source: \"813P-Operated Aegis Unit\" }\r\n660.6 \"--sync--\" #Ability { id: \"507[789A]\", source: \"813P-Operated Aegis Unit\" }\r\n674.6 \"Maneuver: Beam Cannons\" #Ability { id: \"5073\", source: \"813P-Operated Aegis Unit\" }\r\n678.7 \"--sync--\" #Ability { id: \"53B2\", source: \"813P-Operated Aegis Unit\" }\r\n\r\n\r\n### Light Artillery Unit x3 and friends\r\n# -ic \"Yorha Close-Combat Unit: Spear\" \"Yorha Close-Combat Unit: Blade\" \"Yorha Close-Combat Unit: Martial\"\r\n# -p 5212:1013.9 -ii 5214\r\n# Sunken Detritus will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"DB1\" } window 1000,0\r\n1013.9 \"Maneuver: Long-Barreled Laser\" Ability { id: \"5212\", source: \"Light Artillery Unit\" } window 1013.9,20\r\n1025.7 \"Maneuver: Volt Array\" Ability { id: \"5211\", source: \"Light Artillery Unit\" }\r\n1036.0 \"Authorization: No Restrictions\" Ability { id: \"520E\", source: \"Light Artillery Unit\" }\r\n1041.7 \"Surface Missile Impact\" Ability { id: \"520F\", source: \"Light Artillery Unit\" }\r\n1043.7 \"Homing Missile Impact\" Ability { id: \"5210\", source: \"Light Artillery Unit\" }\r\n\r\n1052.7 \"Maneuver: Long-Barreled Laser\" Ability { id: \"5212\", source: \"Light Artillery Unit\" }\r\n1059.5 \"Maneuver: Long-Barreled Laser\" Ability { id: \"5212\", source: \"Light Artillery Unit\" }\r\n1070.2 \"Maneuver: Volt Array\" Ability { id: \"5211\", source: \"Light Artillery Unit\" }\r\n1086.7 \"Maneuver: Martial Arm\" Ability { id: \"5213\", source: \"Light Artillery Unit\" }\r\n1097.1 \"Maneuver: Martial Arm\" Ability { id: \"5213\", source: \"Light Artillery Unit\" }\r\n1103.5 \"Maneuver: Long-Barreled Laser\" Ability { id: \"5212\", source: \"Light Artillery Unit\" }\r\n\r\n1103.7 \"Maneuver: Long-Barreled Laser\" Ability { id: \"5212\", source: \"Light Artillery Unit\" }\r\n1119.6 \"Maneuver: Volt Array\" Ability { id: \"5211\", source: \"Light Artillery Unit\" }\r\n1129.9 \"Authorization: No Restrictions\" Ability { id: \"520E\", source: \"Light Artillery Unit\" } window 50,50 jump 1036\r\n1135.6 \"Surface Missile Impact\" #Ability { id: \"520F\", source: \"Light Artillery Unit\" }\r\n1137.6 \"Homing Missile Impact\" #Ability { id: \"5210\", source: \"Light Artillery Unit\" }\r\n1153.7 \"Initiate Self-Destruct\" #Ability { id: \"5215\", source: \"Light Artillery Unit\" }\r\n1153.7 \"Initiate Self-Destruct\" #Ability { id: \"5215\", source: \"Light Artillery Unit\" }\r\n\r\n\r\n### Superior Flight Unit Swordy Boi Trio\r\n# -it \"772P-Operated Superior Flight Unit \\(C-Hi\\)\" -p 4FA6:2005.1 -ii 53AF 4FA7 4FBE 4FB5 4FA8 4FB6 4FB9 506E 5511 5512 5513 5514 506D 4FC5 4FB1 4FB2 4FBC 506F 5070 4FB8 4FBA 4FC0 4FC1\r\n# Notes:\r\n# * if one of the planes is dead, sliding swipe will end 2s earlier per dead plane\r\n# * most abilities are done by all planes, except:\r\n#   * Sliding Swipes done by individual planes, with unique ability ids.\r\n#   * Incendiary Barrage (4FAF) is only done by A???\r\n#   * Sharp Turn has unique ability ids per plane, but they all do it.\r\n# * however, syncing against multiple planes simultaneously might cause timeline jitter\r\n\r\n# Launch Deck will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"DB2\" } window 2000,0\r\n2005.1 \"Apply Shield Protocol\" Ability { id: \"4FA6\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" } window 2005.1,20\r\n2018.3 \"Maneuver: Missile Command\" Ability { id: \"4FBD\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2031.5 \"Maneuver: Incendiary Bombing\" Ability { id: \"4FC3\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2040.7 \"Maneuver: High-Powered Laser\" Ability { id: \"4FB4\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n\r\n2060.4 \"Formation: Sharp Turn\" Ability { id: \"4FAB\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2073.6 \"Sharp Turn\" Ability { id: \"4FA[9A]\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n\r\n2090.4 \"Maneuver: Precision Guided Missile\" Ability { id: \"4FC4\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2104.7 \"Formation: Air Raid\" Ability { id: \"4FB0\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n# Technically 2 missiles (4FB1/4FB2) come out during the 2.2s before this cast??\r\n2114.0 \"Lethal Revolution\" Ability { id: \"4FB3\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" } duration 5.8\r\n\r\n2142.4 \"Formation: Sliding Swipe\" Ability { id: \"4FAE\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2144.4 \"--untargetable--\"\r\n2153.5 \"Incendiary Barrage\" Ability { id: \"4FAF\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2155.0 \"Sliding Swipe 1\" Ability { id: \"4FA[CD]\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2157.0 \"Sliding Swipe 2\" Ability { id: \"550[DE]\", source: \"767P-Operated Superior Flight Unit \\\\(B-Eta\\\\)\" }\r\n2159.0 \"Sliding Swipe 3\" Ability { id: [\"550F\", \"5510\"], source: \"772P-Operated Superior Flight Unit \\\\(C-Hi\\\\)\" }\r\n2161.3 \"--targetable--\"\r\n\r\n2172.7 \"--sync--\" StartsUsing { id: \"4FC4\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" } window 70,20\r\n2172.7 \"--sync--\" StartsUsing { id: \"4FC4\", source: \"767P-Operated Superior Flight Unit \\\\(B-Eta\\\\)\" } window 70,20\r\n2172.7 \"--sync--\" StartsUsing { id: \"4FC4\", source: \"772P-Operated Superior Flight Unit \\\\(C-Hi\\\\)\" } window 70,20\r\n2176.7 \"Maneuver: Precision Guided Missile\" Ability { id: \"4FC4\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" } window 10,10\r\n2191.0 \"Maneuver: Area Bombardment\" Ability { id: \"4FB7\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" } duration 15\r\n2206.2 \"Maneuver: High-Powered Laser\" Ability { id: \"4FB4\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2224.8 \"Maneuver: Missile Command\" Ability { id: \"4FBD\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n\r\n2243.1 \"Formation: Air Raid\" Ability { id: \"4FB0\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2252.5 \"Lethal Revolution\" Ability { id: \"4FB3\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" } duration 5.8\r\n\r\n2273.8 \"Maneuver: Area Bombardment\" Ability { id: \"4FB7\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" } duration 15\r\n\r\n2304.1 \"Maneuver: Precision Guided Missile\" Ability { id: \"4FC4\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2315.3 \"Maneuver: Incendiary Bombing\" Ability { id: \"4FC3\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n\r\n# Loop begins roughly here:\r\n2321.5 \"Maneuver: High-Order Explosive Blast\" Ability { id: \"4FBF\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2339.8 \"Maneuver: Missile Command\" Ability { id: \"4FBD\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n\r\n2356.1 \"Formation: Sharp Turn\" Ability { id: \"4FAB\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2369.2 \"Sharp Turn\" Ability { id: \"4FA[9A]\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n\r\n2392.0 \"Formation: Sliding Swipe\" Ability { id: \"4FAE\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2394.0 \"--untargetable--\"\r\n2400.0 \"Anti-Personnel Missile\" Ability { id: \"4FBB\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2403.1 \"Incendiary Barrage\" Ability { id: \"4FAF\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2404.6 \"Sliding Swipe 1\" Ability { id: \"4FA[CD]\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2406.6 \"Sliding Swipe 2\" Ability { id: \"550[DE]\", source: \"767P-Operated Superior Flight Unit \\\\(B-Eta\\\\)\" }\r\n2408.6 \"Sliding Swipe 3\" Ability { id: [\"550F\", \"5510\"], source: \"772P-Operated Superior Flight Unit \\\\(C-Hi\\\\)\" }\r\n2410.9 \"--targetable--\"\r\n\r\n2427.2 \"--sync--\" StartsUsing { id: \"4FBD\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" } window 70,20\r\n2427.2 \"--sync--\" StartsUsing { id: \"4FBD\", source: \"767P-Operated Superior Flight Unit \\\\(B-Eta\\\\)\" } window 70,20\r\n2427.2 \"--sync--\" StartsUsing { id: \"4FBD\", source: \"772P-Operated Superior Flight Unit \\\\(C-Hi\\\\)\" } window 70,20\r\n2431.2 \"Maneuver: Missile Command\" Ability { id: \"4FBD\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" } window 10,10\r\n2447.4 \"Maneuver: Precision Guided Missile\" Ability { id: \"4FC4\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2467.7 \"Maneuver: Area Bombardment\" Ability { id: \"4FB7\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" } duration 15\r\n2482.9 \"Maneuver: High-Powered Laser\" Ability { id: \"4FB4\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2501.5 \"Maneuver: Missile Command\" Ability { id: \"4FBD\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2519.8 \"Formation: Air Raid\" Ability { id: \"4FB0\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2529.0 \"Lethal Revolution\" Ability { id: \"4FB3\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" } duration 5.8\r\n2550.5 \"Maneuver: Area Bombardment\" Ability { id: \"4FB7\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" } duration 15\r\n2565.6 \"Anti-Personnel Missile\" Ability { id: \"4FBB\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2580.8 \"Maneuver: Precision Guided Missile\" Ability { id: \"4FC4\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2592.0 \"Maneuver: Incendiary Bombing\" Ability { id: \"4FC3\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n\r\n2598.2 \"--sync--\" Ability { id: \"4FBF\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" } window 90,90 jump 2321.5\r\n2598.2 \"--sync--\" Ability { id: \"4FBF\", source: \"767P-Operated Superior Flight Unit \\\\(B-Eta\\\\)\" } window 90,90 jump 2321.5\r\n2598.2 \"--sync--\" Ability { id: \"4FBF\", source: \"772P-Operated Superior Flight Unit \\\\(C-Hi\\\\)\" } window 90,90 jump 2321.5\r\n\r\n2598.2 \"Maneuver: High-Order Explosive Blast\" #Ability { id: \"4FBF\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" } jump 2321.5\r\n2616.5 \"Maneuver: Missile Command\" #Ability { id: \"4FBD\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2632.8 \"Formation: Sharp Turn\" #Ability { id: \"4FAB\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2645.9 \"Sharp Turn\" #Ability { id: \"4FA[9A]\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n2668.7 \"Formation: Sliding Swipe\" #Ability { id: \"4FAE\", source: \"724P-Operated Superior Flight Unit \\\\(A-Lpha\\\\)\" }\r\n\r\n\r\n\r\n### 905P-Operated Heavy Artillery Unit\r\n# -p 5006:3012.1 -ii 4FF6 4FF7 4FF8 4FF9 4FFC 5004 4FFA 4FFF 4FFE 5002\r\n\r\n# Core Command will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"DB3\" } window 3000,0\r\n3012.1 \"Maneuver: Volt Array\" Ability { id: \"5006\", source: \"905P-Operated Heavy Artillery Unit\" } window 3012.1,20\r\n3024.5 \"Operation: Activate Laser Turret\" Ability { id: \"4FED\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3028.2 \"Lower Laser\" Ability { id: \"5086\", source: \"905P-Operated Heavy Artillery Unit\" } duration 3.5\r\n3028.2 \"Upper Laser\" Ability { id: \"5087\", source: \"905P-Operated Heavy Artillery Unit\" } duration 2.5\r\n3031.2 \"Upper Laser\" Ability { id: \"5088\", source: \"905P-Operated Heavy Artillery Unit\" } duration 2.5\r\n3034.2 \"Upper Laser\" Ability { id: \"5089\", source: \"905P-Operated Heavy Artillery Unit\" } duration 2.5\r\n3038.5 \"Maneuver: High-Powered Laser x2\" Ability { id: \"5001\", source: \"905P-Operated Heavy Artillery Unit\" } duration 2.3\r\n3048.3 \"--sync--\" Ability { id: \"5005\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3054.3 \"Maneuver: Unconventional Voltage\" Ability { id: \"5003\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3061.4 \"Energy Bombardment\" Ability { id: \"4FFB\", source: \"905P-Operated Heavy Artillery Unit\" } duration 9.2\r\n3072.5 \"Maneuver: Impact Crusher x3\" Ability { id: \"4FFD\", source: \"905P-Operated Heavy Artillery Unit\" } duration 3.3\r\n\r\n3078.8 \"Maneuver: Revolving Laser\" Ability { id: \"5000\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3087.9 \"Maneuver: Volt Array\" Ability { id: \"5006\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3109.9 \"Operation: Access Self-Consciousness Data\" Ability { id: \"4FEF\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3126.2 \"Operation: Activate Suppressive Unit\" Ability { id: \"4FEE\", source: \"905P-Operated Heavy Artillery Unit\" } duration 30\r\n\r\n3156.2 \"Maneuver: Volt Array\" Ability { id: \"5006\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3172.4 \"Support: Pod\" Ability { id: \"4FE9\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3182.7 \"Operation: Pod Program\" Ability { id: \"4FEA\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3194.6 \"R010: Laser / R030: Hammer\" Ability { id: \"4FF[01]\", source: \"Pod\" }\r\n3199.6 \"Support: Pod\" Ability { id: \"4FE9\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3210.8 \"Operation: Pod Program\" Ability { id: \"4FEA\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3222.7 \"R030: Hammer / R010: Laser\" Ability { id: \"4FF[01]\", source: \"Pod\" }\r\n3232.8 \"Operation: Synthesize Compound\" Ability { id: \"4FEC\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3249.8 \"Chemical Burn\" Ability { id: \"4FF4\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3254.8 \"Maneuver: Volt Array\" Ability { id: \"5006\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n\r\n3266.1 \"--sync--\" Ability { id: \"5005\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3272.1 \"Maneuver: Unconventional Voltage\" Ability { id: \"5003\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3276.2 \"Energy Bombardment\" Ability { id: \"4FFB\", source: \"905P-Operated Heavy Artillery Unit\" } duration 9.2\r\n3297.1 \"Maneuver: Volt Array\" Ability { id: \"5006\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3309.3 \"Maneuver: Volt Array\" Ability { id: \"5006\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3313.4 \"Support: Pod\" Ability { id: \"4FE9\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3323.7 \"Operation: Pod Program\" Ability { id: \"4FEA\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3335.6 \"R010: Laser\" Ability { id: \"4FF0\", source: \"Pod\" }\r\n3335.6 \"R030: Hammer\" Ability { id: \"4FF1\", source: \"Pod\" }\r\n3340.6 \"Support: Pod\" Ability { id: \"4FE9\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3351.9 \"Operation: Pod Program\" Ability { id: \"4FEA\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3363.9 \"R010: Laser\" Ability { id: \"4FF0\", source: \"Pod\" }\r\n3363.9 \"R030: Hammer\" Ability { id: \"4FF1\", source: \"Pod\" }\r\n3370.4 \"Operation: Activate Laser Turret\" Ability { id: \"4FED\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3374.1 \"Lower Laser\" Ability { id: \"5086\", source: \"905P-Operated Heavy Artillery Unit\" } duration 3.5\r\n3374.1 \"Upper Laser\" Ability { id: \"5087\", source: \"905P-Operated Heavy Artillery Unit\" } duration 2.5\r\n3377.1 \"Upper Laser\" Ability { id: \"5088\", source: \"905P-Operated Heavy Artillery Unit\" } duration 2.5\r\n3380.1 \"Upper Laser\" Ability { id: \"5089\", source: \"905P-Operated Heavy Artillery Unit\" } duration 2.5\r\n\r\n3381.3 \"Maneuver: Volt Array\" Ability { id: \"5006\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3395.5 \"Maneuver: Volt Array\" Ability { id: \"5006\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3404.7 \"Operation: Synthesize Compound\" Ability { id: \"4FEC\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3421.7 \"Chemical Conflagration\" Ability { id: \"4FF5\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n\r\n3424.7 \"Maneuver: Impact Crusher x3\" Ability { id: \"4FFD\", source: \"905P-Operated Heavy Artillery Unit\" } duration 3.3\r\n3431.0 \"Maneuver: Revolving Laser\" Ability { id: \"5000\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3439.1 \"Maneuver: Volt Array\" Ability { id: \"5006\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3456.4 \"Operation: Activate Suppressive Unit\" Ability { id: \"4FEE\", source: \"905P-Operated Heavy Artillery Unit\" } duration 30\r\n\r\n3480.4 \"--sync--\" Ability { id: \"5005\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3486.4 \"Maneuver: Unconventional Voltage\" Ability { id: \"5003\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3495.5 \"Maneuver: Volt Array\" Ability { id: \"5006\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3503.6 \"Maneuver: Volt Array\" Ability { id: \"5006\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n\r\n# loop back to the first hammer+laser combo deal pod program\r\n3515.8 \"--sync--\" Ability { id: \"5005\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3521.8 \"Maneuver: Unconventional Voltage\" Ability { id: \"5003\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3525.9 \"Energy Bombardment\" Ability { id: \"4FFB\", source: \"905P-Operated Heavy Artillery Unit\" } window 100,100 jump 3276.2\r\n3538.1 \"Maneuver: High-Powered Laser\" #Ability { id: \"5001\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3546.9 \"Maneuver: Volt Array\" #Ability { id: \"5006\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3559.1 \"Maneuver: Volt Array\" #Ability { id: \"5006\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3563.2 \"Support: Pod\" #Ability { id: \"4FE9\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n3573.5 \"Operation: Pod Program\" #Ability { id: \"4FEA\", source: \"905P-Operated Heavy Artillery Unit\" }\r\n\r\n\r\n### Heavy Artillery Unit: caster-friendly hallway section\r\n# Passage will be sealed off\r\n4000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"DB4\" } window 4000,0\r\n\r\n\r\n### The Compound\r\n# -p 51B8:5013.2 53D5:6000 -ii 53CA 53F2 51B1 51B6 51B7 -it \"The Compound\"\r\n# Notes:\r\n# * Contusion is 51B5 (cast) 51B6 (ground) 51B7 (headmarker).  Left as 51B5 for simplicity.\r\n# * Can't use \"The Bridge\" area sync due to checkpoint with Compound 2P.\r\n\r\n# The bridge will be sealed off\r\n#5000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"DB5\" } window 5000,0\r\n5002.0 \"--sync--\" Ability { id: \"53CA\", source: \"The Compound\" } window 5002,0\r\n5013.2 \"Mechanical Laceration\" Ability { id: \"51B8\", source: \"The Compound\" } window 6000,20\r\n5024.4 \"Mechanical Decapitation/Dissection\" Ability { id: \"51B[34]\", source: \"The Compound\" }\r\n5034.9 \"Mechanical Dissection/Decapitation\" Ability { id: \"51B[34]\", source: \"The Compound\" }\r\n5043.9 \"Mechanical Contusion\" Ability { id: \"51B5\", source: \"The Compound\" }\r\n\r\n5058.0 \"--untargetable--\"\r\n5068.7 \"Incongruous Spin x2\" #Ability { id: \"51B2\", source: \"The Compound\" }\r\n5073.9 \"--targetable--\"\r\n\r\n5088.0 \"Mechanical Laceration\" Ability { id: \"51B8\", source: \"The Compound\" }\r\n5099.1 \"Mechanical Decapitation\" Ability { id: \"51B4\", source: \"The Compound\" }\r\n5105.1 \"Mechanical Contusion\" Ability { id: \"51B5\", source: \"The Compound\" }\r\n5115.3 \"Mechanical Dissection\" Ability { id: \"51B3\", source: \"The Compound\" }\r\n5125.6 \"Mechanical Laceration\" Ability { id: \"51B8\", source: \"The Compound\" }\r\n5141.7 \"Mechanical Decapitation\" Ability { id: \"51B4\", source: \"The Compound\" }\r\n5147.7 \"Mechanical Contusion\" Ability { id: \"51B5\", source: \"The Compound\" }\r\n5157.9 \"Mechanical Dissection\" Ability { id: \"51B3\", source: \"The Compound\" }\r\n\r\n5168.2 \"Mechanical Laceration\" Ability { id: \"51B8\", source: \"The Compound\" }\r\n5184.5 \"Mechanical Dissection\" Ability { id: \"51B3\", source: \"The Compound\" }\r\n5190.8 \"Mechanical Contusion\" Ability { id: \"51B5\", source: \"The Compound\" }\r\n5200.9 \"Mechanical Decapitation\" Ability { id: \"51B4\", source: \"The Compound\" }\r\n\r\n5210.9 \"Mechanical Laceration\" Ability { id: \"51B8\", source: \"The Compound\" } window 30,30 jump 5168.2\r\n5227.2 \"Mechanical Dissection\" #Ability { id: \"51B3\", source: \"The Compound\" }\r\n5233.5 \"Mechanical Contusion\" #Ability { id: \"51B5\", source: \"The Compound\" }\r\n5243.6 \"Mechanical Decapitation\" #Ability { id: \"51B4\", source: \"The Compound\" }\r\n\r\n\r\n### Compound 2P\r\n# -p 53D5:6000 51B0:6068.3 -it \"Compound 2P\" -ii 53CA 53F2 51AA 541B 51AF 51AD 51AE 5363 51A8 519C 519D 51A0 519F 51CB\r\n# Notes:\r\n# * 51A3 is creating a thing that gets an energy tether.\r\n# * 51A3 is used for self-teleportation, forced transfer, and reproduce.\r\n# * 53D0 / 53D1 are included here as stand-ins for \"Forced Transfer\" when there is no ability.\r\n# * However, 53D0 / 53D1 are noisy so they're not included everywhere.\r\n\r\n6000.0 \"Mechanical Laceration\" Ability { id: \"53D5\", source: \"The Compound\" } window 6000,0\r\n6051.1 \"--targetable--\"\r\n6068.3 \"Centrifugal Slice\" Ability { id: \"51B0\", source: \"Compound 2P\" } window 7000,0\r\n6080.1 \"Relentless Spiral x3\" Ability { id: \"51A9\", source: \"Compound 2P\" } duration 4.1\r\n6099.9 \"Prime Blade (Out)\" Ability { id: \"541F\", source: \"Compound 2P\" }\r\n6110.5 \"Prime Blade (Behind)\" Ability { id: \"5420\", source: \"Compound 2P\" }\r\n6121.0 \"Prime Blade (In)\" Ability { id: \"5421\", source: \"Compound 2P\" }\r\n\r\n6131.5 \"--sync--\" Ability { id: \"51A3\", source: \"Compound 2P\" }\r\n6140.1 \"Forced Transfer\" Ability { id: \"53D0\", source: \"Compound 2P\" }\r\n6143.6 \"Prime Blade (In)\" Ability { id: \"519A\", source: \"Compound 2P\" }\r\n6153.1 \"Centrifugal Slice\" Ability { id: \"51B0\", source: \"Compound 2P\" }\r\n\r\n6166.6 \"Three Parts Disdain\" Ability { id: \"519B\", source: \"Compound 2P\" } duration 3.6\r\n\r\n6179.5 \"Compound Pod: R012\" Ability { id: \"51AB\", source: \"Compound 2P\" }\r\n6183.3 \"R012: Laser\" Ability { id: \"51AC\", source: \"Compound Pod\" }\r\n\r\n6204.6 \"Four Parts Resolve\" Ability { id: \"519E\", source: \"Compound 2P\" } duration 9.4\r\n\r\n6224.4 \"--sync--\" Ability { id: \"51A3\", source: \"Compound 2P\" }\r\n6230.6 \"Reproduce\" Ability { id: \"51A1\", source: \"Compound 2P\" }\r\n6240.3 \"Prime Blade (In)\" Ability { id: \"5421\", source: \"Compound 2P\" }\r\n6250.7 \"Prime Blade (In)\" Ability { id: \"5421\", source: \"Puppet 2P\" }\r\n\r\n6255.8 \"--sync--\" Ability { id: \"51A3\", source: \"Compound 2P\" }\r\n6261.9 \"Energy Compression\" Ability { id: \"51A6\", source: \"Compound 2P\" }\r\n6272.9 \"Explosion\" Ability { id: \"51A7\", source: \"Compound 2P\" }\r\n6287.4 \"Forced Transfer\" Ability { id: \"51A2\", source: \"Compound 2P\" }\r\n6291.2 \"Explosion\" Ability { id: \"51A7\", source: \"Compound 2P\" }\r\n\r\n6299.2 \"Compound Pod: R011\" Ability { id: \"51A4\", source: \"Compound 2P\" }\r\n6315.6 \"Forced Transfer\" Ability { id: \"543A\", source: \"Compound 2P\" }\r\n6318.5 \"R011: Laser\" Ability { id: \"51A5\", source: \"Compound Pod\" }\r\n6329.9 \"Relentless Spiral x3\" Ability { id: \"51A9\", source: \"Compound 2P\" } duration 4.1\r\n\r\n6332.7 \"--sync--\" Ability { id: \"51A3\", source: \"Compound 2P\" }\r\n6341.3 \"Forced Transfer\" Ability { id: \"53D1\", source: \"Compound 2P\" }\r\n6344.7 \"Prime Blade (Out/Behind)\" Ability { id: \"519[89]\", source: \"Compound 2P\" }\r\n\r\n# beginning of loop\r\n6350.2 \"--sync--\" Ability { id: \"51A3\", source: \"Compound 2P\" }\r\n6356.3 \"Reproduce\" Ability { id: \"51A1\", source: \"Compound 2P\" }\r\n6366.0 \"Prime Blade (In/Out)\" Ability { id: [\"541F\", \"5421\"], source: \"Compound 2P\" }\r\n6375.9 \"Forced Transfer\" Ability { id: \"51A2\", source: \"Compound 2P\" }\r\n6379.4 \"Prime Blade (In/Out)\" Ability { id: [\"5198\", \"519A\"], source: \"Puppet 2P\" }\r\n\r\n\r\n# Random Three Parts/ Four Parts\r\n6391.8 \"--sync--\" StartsUsing { id: \"519E\", source: \"Compound 2P\" } window 50,50\r\n6399.8 \"Four Parts Resolve?\" Ability { id: \"519E\", source: \"Compound 2P\" }\r\n\r\n# This is adjusted 9 seconds ahead so that Compound Pod: R012 lines up.  @_@;;\r\n6400.7 \"--sync--\" StartsUsing { id: \"519B\", source: \"Compound 2P\" } window 50,50\r\n6406.7 \"Three Parts Disdain?\" Ability { id: \"519B\", source: \"Compound 2P\" }\r\n\r\n\r\n6420.5 \"Compound Pod: R012\" Ability { id: \"51AB\", source: \"Compound 2P\" }\r\n6423.4 \"--sync--\" Ability { id: \"51A3\", source: \"Compound 2P\" }\r\n6424.3 \"R012: Laser\" Ability { id: \"51AC\", source: \"Compound Pod\" }\r\n6429.6 \"Energy Compression\" Ability { id: \"51A6\", source: \"Compound 2P\" }\r\n6440.6 \"Explosion\" Ability { id: \"51A7\", source: \"Compound 2P\" }\r\n\r\n6455.1 \"Forced Transfer\" Ability { id: \"51A2\", source: \"Compound 2P\" }\r\n6458.9 \"Explosion\" Ability { id: \"51A7\", source: \"Compound 2P\" }\r\n\r\n6471.9 \"Centrifugal Slice\" Ability { id: \"51B0\", source: \"Compound 2P\" }\r\n6490.2 \"Compound Pod: R011\" Ability { id: \"51A4\", source: \"Compound 2P\" }\r\n6506.6 \"Forced Transfer\" Ability { id: \"543A\", source: \"Compound 2P\" }\r\n6509.5 \"R011: Laser\" Ability { id: \"51A5\", source: \"Compound Pod\" }\r\n6520.9 \"Relentless Spiral x3\" Ability { id: \"51A9\", source: \"Compound 2P\" } duration 4.1\r\n\r\n6523.7 \"--sync--\" Ability { id: \"51A3\", source: \"Compound 2P\" }\r\n6532.5 \"Forced Transfer\" Ability { id: \"53D[01]\", source: \"Compound 2P\" }\r\n6535.8 \"Prime Blade (In/Out)\" Ability { id: [\"5198\", \"519A\"], source: \"Compound 2P\" }\r\n\r\n6541.3 \"--sync--\" Ability { id: \"51A3\", source: \"Compound 2P\" }\r\n6547.4 \"Reproduce\" Ability { id: \"51A1\", source: \"Compound 2P\" } window 100,100 jump 6356.3\r\n6557.2 \"Prime Blade (In/Out)\" Ability { id: [\"541F\", \"5421\"], source: \"Compound 2P\" }\r\n6567.1 \"Forced Transfer\" Ability { id: \"51A2\", source: \"Compound 2P\" }\r\n6570.6 \"Prime Blade (In/Out)\" Ability { id: [\"5198\", \"519A\"], source: \"Puppet 2P\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/alliance/the_tower_at_paradigms_breach.ts





// Object representing a "Deploy Armaments" attack.

// TODO:
//   Update Knave knockback directions to instead use cardinals
//   Hansel and Gretel Stronger Together Tethered
//   Hansel & Gretel Passing Lance
//   Hansel & Gretel Breakthrough
//   2P-operated Flight Unit adds
//   Red Girl
//   Meng-Zi / Xun-Zi
//   Better Her Inflorescence Recreate Structure
//   Her Inflorescence Distortion
//   Her Inflorescence Pillar Impact
const the_tower_at_paradigms_breach_triggerSet = {
  id: 'TheTowerAtParadigmsBreach',
  zoneId: zone_id/* default.TheTowerAtParadigmsBreach */.Z.TheTowerAtParadigmsBreach,
  timelineFile: 'the_tower_at_paradigms_breach.txt',
  triggers: [{
    id: 'Paradigm Knave Roar',
    type: 'StartsUsing',
    netRegex: {
      id: '5EB5',
      source: 'Knave Of Hearts',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Paradigm Knave Colossal Impact Sides',
    type: 'StartsUsing',
    netRegex: {
      id: '5EA4',
      source: 'Knave Of Hearts',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'Paradigm Copied Knave Colossal Impact Sides',
    type: 'StartsUsing',
    netRegex: {
      id: '5EA4',
      source: 'Copied Knave',
      capture: false
    },
    // Cast time of 8 seconds, clones start casting 6 seconds into the cast.
    delaySeconds: 2.1,
    durationSeconds: 5,
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'Paradigm Knave Colossal Impact Middle',
    type: 'StartsUsing',
    netRegex: {
      id: '5EA7',
      source: 'Knave Of Hearts',
      capture: false
    },
    durationSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    tts: (_data, _matches, output) => output.ttsText(),
    outputStrings: {
      text: {
        en: 'Go E/W Sides',
        de: 'Geh seitlich nach O/W',
        fr: 'Allez côtés E/O',
        ja: '東/西側へ',
        cn: '去东/西侧',
        ko: '동/서쪽으로'
      },
      ttsText: {
        en: 'Go East/West Sides',
        de: 'Geh seitlich nach Osten/Westen',
        fr: 'Allez côtés Est/Ouest',
        ja: '東側や西側へ',
        cn: '去东西侧',
        ko: '동쪽이나 서쪽으로'
      }
    }
  }, {
    id: 'Paradigm Copied Knave Colossal Impact Middle',
    type: 'StartsUsing',
    netRegex: {
      id: '5EA7',
      source: 'Copied Knave',
      capture: false
    },
    delaySeconds: 2.1,
    durationSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    tts: (_data, _matches, output) => output.ttsText(),
    outputStrings: {
      text: {
        en: 'Go N/S Sides',
        de: 'Geh seitlich nach N/S',
        fr: 'Allez côtés N/S',
        ja: '北/南側へ',
        cn: '去南/北侧',
        ko: '남/북쪽으로'
      },
      ttsText: {
        en: 'Go North/South Sides',
        de: 'Geh seitlich nach Norden/Süden',
        fr: 'Allez côtés Nord/Sud',
        ja: '北側や南側へ',
        cn: '去南北侧',
        ko: '남쪽이나 북쪽으로'
      }
    }
  }, {
    // Also applies for Red Girl Manipulate Energy
    id: 'Paradigm Knave Magic Artillery Beta You',
    type: 'HeadMarker',
    netRegex: {
      id: '00DA'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Paradigm Knave Magic Artillery Beta Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '00DA'
    },
    run: (data, matches) => {
      data.busterTargets ??= [];
      data.busterTargets.push(matches.target);
    }
  }, {
    id: 'Paradigm Knave Magic Artillery Beta',
    type: 'HeadMarker',
    netRegex: {
      id: '00DA',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (!data.busterTargets) return;
      if (data.busterTargets.includes(data.me)) return;
      if (data.role === 'healer') return output.tankBuster();
      return output.avoidTankBuster();
    },
    run: data => delete data.busterTargets,
    outputStrings: {
      tankBuster: outputs/* default.tankBuster */.Z.tankBuster,
      avoidTankBuster: {
        en: 'Avoid tank buster',
        de: 'Tank buster ausweichen',
        fr: 'Évitez le tank buster',
        ja: 'タンクバスターを避ける',
        cn: '远离坦克死刑',
        ko: '탱버 피하기'
      }
    }
  }, {
    id: 'Paradigm Knave Magic Artillery Alpha Spread',
    type: 'HeadMarker',
    netRegex: {
      id: '00A9'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Paradigm Knave Lunge',
    type: 'StartsUsing',
    netRegex: {
      id: '5EB1',
      source: 'Knave of Hearts'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 6,
    durationSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback (from boss)',
        de: 'Rückstoß (vom Boss)',
        fr: 'Poussée (depuis le boss)',
        ja: 'ノックバック (ボスから)',
        cn: '击退 (来自Boss)',
        ko: '보스기준 넉백'
      }
    }
  }, {
    id: 'Paradigm Copied Knave Lunge',
    type: 'StartsUsing',
    netRegex: {
      id: '5EB1',
      source: 'Copied Knave'
    },
    condition: data => !data.cloneLunge,
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 6,
    durationSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.cloneLunge = true,
    outputStrings: {
      text: {
        en: 'Knockback (from clone)',
        de: 'Rückstoß (vom Klon)',
        fr: 'Poussée (depuis le clone)',
        ja: 'ノックバック (複製体から)',
        cn: '击退 (来自复制体)',
        ko: '분신기준 넉백'
      }
    }
  }, {
    id: 'Paradigm Copied Knave Lunge Get Middle',
    type: 'StartsUsing',
    netRegex: {
      id: '60C7',
      source: 'Knave of Hearts'
    },
    // Half a second longer cast time than the Lunge itself
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 6.5,
    durationSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback -> Get Middle',
        de: 'Rückstoß -> Geh in die Mitte',
        fr: 'Poussée -> Allez au milieu',
        ja: 'ノックバック -> 中へ',
        cn: '击退 -> 去中间',
        ko: '넉백 -> 가운데로'
      }
    }
  }, {
    id: 'Paradigm Copied Knave Lunge Out of Middle',
    type: 'StartsUsing',
    netRegex: {
      id: '60C8',
      source: 'Knave of Hearts'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 6.5,
    durationSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback -> Out of Middle',
        de: 'Rückstoß -> Raus aus der Mitte',
        fr: 'Poussée -> Sortez du milieu',
        ja: 'ノックバック -> 外へ',
        cn: '击退 -> 去外面',
        ko: '넉백 -> 가운데 피하기'
      }
    }
  }, {
    id: 'Paradigm Gretel Upgraded Shield',
    type: 'StartsUsing',
    netRegex: {
      id: '5C69',
      source: 'Gretel',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Attack Hansel',
        de: 'Hänsel angreifen',
        fr: 'Attaquez Hansel',
        ja: 'ヘンゼルに攻撃',
        cn: '攻击韩塞尔',
        ko: '헨젤 공격'
      }
    }
  }, {
    id: 'Paradigm Hansel Upgraded Shield',
    type: 'StartsUsing',
    netRegex: {
      id: '5C6B',
      source: 'Hansel',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Attack Gretel',
        de: 'Gretel angreifen',
        fr: 'Attaquez Gretel',
        ja: 'グレーテルに攻撃',
        cn: '攻击格雷特',
        ko: '그레텔 공격'
      }
    }
  }, {
    id: 'Paradigm Hansel/Gretel Wail',
    type: 'StartsUsing',
    netRegex: {
      id: '5C7[67]',
      source: ['Hansel', 'Gretel'],
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Paradigm Hansel/Gretel Crippling Blow',
    type: 'StartsUsing',
    netRegex: {
      id: '5C7[89]',
      source: ['Hansel', 'Gretel']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Paradigm Hansel/Gretel Seed Of Magic Alpha',
    type: 'HeadMarker',
    netRegex: {
      id: '0060'
    },
    preRun: (data, matches) => {
      data.seedTargets ??= [];
      data.seedTargets.push(matches.target);
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    outputStrings: {
      text: outputs/* default.spread */.Z.spread
    }
  }, {
    id: 'Paradigm Hansel/Gretel Riot Of Magic',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    delaySeconds: 0.5,
    infoText: (data, matches, output) => {
      if (!data.seedTargets) return;
      if (data.seedTargets.includes(data.me)) return;
      if (matches.target === data.me) return output.stackOnYou();
      return output.stackOn({
        player: data.party.member(matches.target)
      });
    },
    run: data => delete data.seedTargets,
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'Paradigm Hansel/Gretel Lamentation',
    type: 'StartsUsing',
    netRegex: {
      id: '5C7[34]',
      source: ['Hansel', 'Gretel'],
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Paradigm Hansel/Gretel Bloody Sweep',
    type: 'StartsUsing',
    netRegex: {
      id: '5C5[4567]',
      source: ['Hansel', 'Gretel']
    },
    durationSeconds: 5,
    suppressSeconds: 1,
    alertText: (_data, matches, output) => {
      // Hansel and Gretel each have unique abilities which indicate which
      // side of the Bloody Sweep they're starting in. Hanssel is left
      // handed, and Gretel is right handed. 5C54 and 5C55 indicate that
      // Hansel is on the right and Gretel is on the left, relative to the
      // two bosses. Using this, we can identify if the safe area is
      // between the two, or on the opposite side of the arena.
      //
      // A further complication is that the pair might use Transference
      // first, which causes them to swap places. We can detect this based
      // on the cast time of the Bloody Sweep ability, since the cast time
      // will be extended to account for the Transference. If the swap
      // will take place, then the cast time will go from 7.7 seconds up
      // to 12.7 seconds. We use an average of 10 seconds to detect the
      // swap.
      if (matches.id === '5C54' || matches.id === '5C55') {
        // Hansel is on the right and Gretel is on the left.
        if (parseFloat(matches.castTime) > 10) {
          // Hansel and Gretel will switch places
          return output.between();
        }
        // Hansel and Gretel stay in same position
        return output.opposite();
      }
      // Gretel is on the right and Hansel is on the left.
      if (parseFloat(matches.castTime) > 10) {
        // Hansel and Gretel will switch places
        return output.opposite();
      }
      // Hansel and Gretel stay in same position
      return output.between();
    },
    outputStrings: {
      between: {
        en: 'Move between',
        de: 'Laufe zwischen beide Bosse',
        fr: 'Allez entre les boss',
        cn: '移动到BOSS之间',
        ko: '보스 사이로'
      },
      opposite: {
        en: 'Move opposite',
        de: 'Laufe entgegengesetzt beider Bosse',
        fr: 'Allez à l\'opposé des boss',
        cn: '移动到BOSS对面',
        ko: '보스 반대쪽으로'
      }
    }
  }, {
    id: 'Paradigm Red Girl Cruelty',
    type: 'StartsUsing',
    netRegex: {
      id: '601[23]',
      source: 'Red Girl',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Paradigm Red Sphere Wave: White',
    type: 'StartsUsing',
    netRegex: {
      id: '618D',
      source: 'Red Sphere',
      capture: false
    },
    infoText: (data, _matches, output) => {
      // Skip the first callout, since you're still zoning in
      if (data.seenSphere) return output.text();
    },
    run: data => data.seenSphere = true,
    outputStrings: {
      text: {
        en: 'Switch to white',
        de: 'Auf Weiß wechseln',
        fr: 'Changez en blanc',
        ja: '白に切替',
        cn: '切换白',
        ko: '하얀색으로 바꾸기'
      }
    }
  }, {
    id: 'Paradigm Red Sphere Wave: Black',
    type: 'StartsUsing',
    netRegex: {
      id: '618E',
      source: 'Red Sphere',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.seenSphere) return output.text();
    },
    run: data => data.seenSphere = true,
    outputStrings: {
      text: {
        en: 'Switch to black',
        de: 'Auf Schwarz wechseln',
        fr: 'Changez en noir',
        ja: '黒に切替',
        cn: '切换黑',
        ko: '검은색으로 바꾸기'
      }
    }
  }, {
    id: 'Paradigm Meng-Zi/Xun-Zi Universal Assault',
    type: 'StartsUsing',
    netRegex: {
      id: '5C06',
      source: ['Meng-Zi', 'Xun-Zi'],
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  },
  // Deploy Armaments
  //
  // This attack has two variations and can be cast from two headings. The
  // first variation causes two line AOEs to hit with the center being
  // safe. The second variation causes a single line AOE to be cast in the
  // middle, with the sides safe. It can either be cast horizontally or
  // vertically over the arena.
  //
  // There are several skill IDs involved:
  // 5C00: indicate start of a middle line attack. Always appears with one
  //       5C02 cast
  // 5C03: indicate start of a two side lines attack. Always appears with
  //       2x 5C05 casts
  // 5C01: indicates a single line attack comboing with the other boss.
  //       Always appears simultaneously with the other bosses abilities
  //       and a 6078 cast.
  // 5C04: indicates a two side lines attack comboing with the other boss
  //       Always appears simultaneously with the other bosses abilities
  //       and 2x 6079 casts.
  //
  // Because these attacks overlap, we use one trigger to collect the
  // active attacks, and a second trigger to display an alert on where to
  // go for safety.
  {
    id: 'Paradigm Meng-Zi/Xun-Zi Deploy Armaments Collect',
    type: 'StartsUsing',
    netRegex: {
      id: ['5C00', '5C01', '5C03', '5C04']
    },
    run: (data, matches) => {
      data.deployArmaments ??= [];

      // Convert the heading into 0=N, 1=E, 2=S, 3=W
      const direction = Math.round(2 - 2 * parseFloat(matches.heading) / Math.PI) % 4;
      const obj = {
        sides: matches.id === '5C03' || matches.id === '5C04',
        finishedTime: Date.parse(matches.timestamp) + parseFloat(matches.castTime) * 1000,
        vertical: direction === 0 || direction === 2
      };
      data.deployArmaments.push(obj);
    }
  }, {
    id: 'Paradigm Meng-Zi/Xun-Zi Deploy Armaments Trigger',
    type: 'StartsUsing',
    netRegex: {
      id: ['5C00', '5C01', '5C03', '5C04']
    },
    delaySeconds: 0.25,
    durationSeconds: 5,
    suppressSeconds: 1,
    alertText: (data, matches, output) => {
      if (!data.deployArmaments) return;

      // Get time of current cast
      const now = Date.parse(matches.timestamp);

      // filter and remove any active attacks that have finished
      const active = data.deployArmaments.filter(e => e.finishedTime > now);
      data.deployArmaments = active;
      if (active.some(e => e.vertical && !e.sides) && active.some(e => !e.vertical && !e.sides)) {
        // Two middle-line AOEs, so go to the corner
        return output.corner();
      } else if (active.some(e => e.vertical && e.sides) && active.some(e => !e.vertical && e.sides)) {
        // Two side-line AOEs, so go to the center
        return output.center();
      } else if (active.some(e => e.vertical && !e.sides) && active.some(e => !e.vertical && e.sides)) {
        // vertical middle-line and horizontal side-lines
        return output.westBoss();
      } else if (active.some(e => e.vertical && e.sides) && active.some(e => !e.vertical && !e.sides)) {
        // vertical side-lines and horizontal middle-line
        return output.northBoss();
      } else if (active.some(e => e.vertical && e.sides)) {
        // vertical side-lines
        return output.center();
      } else if (active.some(e => e.vertical && !e.sides)) {
        // vertical middle-line
        return output.west();
      } else if (active.some(e => !e.vertical && e.sides)) {
        // horizontal side-lines
        return output.center();
      } else if (active.some(e => !e.vertical && !e.sides)) {
        // horizontal middle-line
        return output.north();
      }
      // other combinations are unexpected
      return output.oops();
    },
    outputStrings: {
      center: {
        en: 'Go to Center',
        de: 'Geh in die Mitte',
        fr: 'Allez au centre',
        cn: '去中间',
        ko: '가운데로'
      },
      northBoss: {
        en: 'Go to North Boss',
        de: 'Geh zum nördlichen Boss',
        fr: 'Allez au Nord (boss)',
        cn: '去北(上)边BOSS脚下',
        ko: '북쪽 보스 근처로'
      },
      north: {
        en: 'Go North',
        de: 'Geh nach Norden',
        fr: 'Allez au Nord',
        cn: '去北(上)边',
        ko: '북쪽으로'
      },
      westBoss: {
        en: 'Go to West Boss',
        de: 'Geh zum westlichen Boss',
        fr: 'Allez à l\'Ouest (boss)',
        cn: '去西(左)边BOSS脚下',
        ko: '서쪽 보스 근처로'
      },
      west: {
        en: 'Go West',
        de: 'Geh nach Westen',
        fr: 'Allez à l\'Ouest',
        cn: '去西(左)边',
        ko: '서쪽으로'
      },
      corner: {
        en: 'Go to Corner',
        de: 'Geh in eine Ecke',
        fr: 'Allez dans un coin',
        cn: '去角落',
        ko: '구석으로'
      },
      oops: {
        en: 'Avoid line AOEs',
        de: 'Weiche den Linien AoEs aus',
        fr: 'Évitez les AoEs en ligne',
        cn: '躲避直线AOE',
        ko: '레이저 피하기'
      }
    }
  }, {
    id: 'Paradigm False Idol Screaming Score',
    type: 'StartsUsing',
    netRegex: {
      id: '5BDD',
      source: 'False Idol',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Paradigm False Idol Made Magic Left',
    type: 'StartsUsing',
    netRegex: {
      id: '5BD6',
      source: 'False Idol',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Paradigm False Idol Made Magic Right',
    type: 'StartsUsing',
    netRegex: {
      id: '5BD7',
      source: 'False Idol',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Paradigm False Idol Lighter Note',
    type: 'HeadMarker',
    netRegex: {
      id: '0001'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Lighter Note on YOU',
        de: 'Weißer Choral auf DIR',
        fr: 'Blanc : imprécation sur VOUS',
        ja: '自分に連続AoE',
        cn: '地火点名',
        ko: '장판 대상자'
      }
    }
  }, {
    id: 'Paradigm False Idol Darker Note You',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Paradigm False Idol Darker Note Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    run: (data, matches) => {
      data.busterTargets ??= [];
      data.busterTargets.push(matches.target);
    }
  }, {
    id: 'Paradigm False Idol Darker Note',
    type: 'HeadMarker',
    netRegex: {
      id: '008B',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (!data.busterTargets) return;
      if (data.busterTargets.includes(data.me)) return;
      if (data.role === 'healer') return output.tankBuster();
      return output.avoidTankBuster();
    },
    run: data => delete data.busterTargets,
    outputStrings: {
      tankBuster: outputs/* default.tankBuster */.Z.tankBuster,
      avoidTankBuster: {
        en: 'Avoid tank buster',
        de: 'Tank buster ausweichen',
        fr: 'Évitez le tank buster',
        ja: 'タンクバスターを避ける',
        cn: '远离坦克死刑',
        ko: '탱버 피하기'
      }
    }
  }, {
    id: 'Paradigm Her Inflorescence Screaming Score',
    type: 'StartsUsing',
    netRegex: {
      id: '5BF5',
      source: 'Her Inflorescence',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // startsUsing callout is too early, instead callout when the cast has finished
    id: 'Paradigm Her Inflorescence Recreate Structure',
    type: 'Ability',
    netRegex: {
      id: '5BE1',
      source: 'Her Inflorescence',
      capture: false
    },
    durationSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge Building Below',
        de: 'Gebäude unter einem ausweichen',
        fr: 'Esquivez le bâtiment arrivant d\'en dessous',
        ja: '下の建物に当たらないように',
        cn: '躲避下方建筑',
        ko: '컨테이너 박스 피하기'
      }
    }
  }, {
    id: 'Paradigm Her Inflorescence Recreate Signal',
    type: 'StartsUsing',
    netRegex: {
      id: '5BE3',
      source: 'Her Inflorescence',
      capture: false
    },
    run: data => data.signalCount = 0
  }, {
    id: 'Paradigm Her Inflorescence Recreate Signal Collect',
    type: 'Tether',
    netRegex: {
      id: '0036',
      target: 'Her Inflorescence',
      capture: false
    },
    preRun: data => data.signalCount = (data.signalCount ?? 0) + 1,
    durationSeconds: 5,
    alertText: (data, _matches, output) => {
      if ((data.signalCount ?? 0) % 5 === 0) return output.text();
    },
    outputStrings: {
      text: {
        en: 'Go To Red Light',
        de: 'Geh zum roten Licht',
        fr: 'Allez au feu rouge',
        ja: '赤信号の線路へ',
        cn: '去红灯',
        ko: '빨간 신호등으로'
      }
    }
  }, {
    id: 'Paradigm Her Inflorescence Heavy Arms Middle',
    type: 'StartsUsing',
    netRegex: {
      id: '5BED',
      source: 'Her Inflorescence',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'Paradigm Her Inflorescence Heavy Arms Sides',
    type: 'StartsUsing',
    netRegex: {
      id: '5BEF',
      source: 'Her Inflorescence',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.goFrontBack */.n3.goFrontBack()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'White Dissonance / Black Dissonance': 'White/Black Dissonance'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      '2P-Operated Flight Unit': '2Ps Flugeinheit',
      'Beyond': 'Zenit',
      'Black Lance': 'schwarz(?:e|er|es|en) Lanze',
      'Black Pylon': 'schwarz(?:e|er|es|en) Turm',
      'Closed Area A': 'Sperrgebiet A',
      'Copied Knave': 'Kopiert(?:e|er|es|en) Herzbube',
      'False Idol': 'Ihre Abgöttlichkeit',
      'Gretel': 'Gretel',
      'Hansel': 'Hänsel',
      'Her Inflorescence': 'Ihre Infloreszenz',
      'Knave Of Hearts': 'Herzbube',
      'Meng-Zi': 'Meng-Zi',
      'Red Girl': 'Rot(?:e|er|es|en) Mädchen',
      'Red Sphere': 'rot(?:e|er|es|en) Sphäre',
      'Serial-Jointed Model': 'Modell mit Omnigelenk',
      'Spheroid': 'Sphäre',
      'Staging Node B': 'Sammelknoten B',
      'Staging Node C': 'Sammelknoten C',
      'Staging Node D': 'Sammelknoten D',
      'The Ascension Platform': 'Aufzug',
      'White Lance': 'weiß(?:e|er|es|en) Lanze',
      'Xun-Zi': 'Xun-Zi',
      'Hansel & Gretel': 'Hänsel & Gretel'
    },
    'replaceText': {
      '--targetable\\?--': '--anvisierbar?--',
      'Black Dissonance': 'Schwarze Korrosion',
      '(?<!Tandem Assault: )Bloody Sweep': 'Zertrümmern',
      '(?<!Tandem Assault: )Breakthrough': 'Tjost',
      'Child\'s Play': 'Puppenspiel',
      'Colossal Impact': 'Schwerer Angriff',
      'Crash': 'Kollision',
      'Crippling Blow': 'Verkrüppelnder Schlag',
      'Cruelty': 'Berstender Boden',
      'Darker Note': 'Schwarzer Choral',
      'Deploy Armaments': 'Aktivierte Armierung',
      'Diffuse Energy': 'Diffusionsenergie',
      'Distortion': 'Kontaminierung',
      'Eminence': 'Hoheit',
      'Explosion': 'Explosion',
      'Generate: Barrier': 'Schöpfung: Barrieren',
      'Heavy Arms': 'Armierung',
      'High-Powered Laser': 'Hochleistungslaser',
      'Hungry Lance': 'Lanzentreffer',
      'Knavish Bullets': 'Störschuss',
      'Lamentation': 'Wehklagen',
      'Light Leap': 'Springen',
      'Lighter Note': 'Weißer Choral',
      'Lightfast Blade': 'Lichtklingenschnitt',
      'Lunge': 'Vliesabreibung',
      'Made Magic': 'Magiefeuer',
      'Magic Artillery Alpha': 'Magieschock α',
      'Magic Artillery Beta': 'Magieschock β',
      'Magic Barrage': 'Gebündelter Magiestoß',
      'Magical Interference': 'Magieinterferenz',
      'Maneuver: Standard Laser': 'Offensive: Laser',
      'Manipulate Energy': 'Energetische Ballung',
      'Mixed Signals': 'Signalschaltung',
      '(?<!Tandem Assault: )Passing Lance': 'Scharfrennen',
      'Pervasion': 'Klarheit',
      'Pillar Impact': 'Säuleneinschlag',
      'Place Of Power': 'Kraftfeld-Generierung',
      'Point: Black': 'Schwarzer Durchstoß',
      'Point: White': 'Weißer Durchstoß',
      'Recreate Meteor': 'Reprise: Meteor',
      'Recreate Signal': 'Reprise: Signal',
      'Recreate Structure': 'Reprise: Gebäude',
      'Replicate': 'Kopieren',
      'Rhythm Rings': 'Staccato',
      'Riot Of Magic': 'Magiewelle',
      'Roar': 'Biestschrei',
      'Scattered Magic': 'Magieschauer',
      'Screaming Score': 'Solmisation',
      'Seed Of Magic(?! )': 'Magiestoß',
      'Seed Of Magic Alpha': 'Magiestoß α',
      'Seed Of Magic Beta': 'Magiestoß β',
      'Shock: Black': 'Schwarzer Impakt',
      'Shock: White': 'Weißer Impakt',
      'Shockwave': 'Schockwelle',
      'Spheroids': 'Sphärisches Feuer',
      'Stacking The Deck': 'Kettenangriff',
      'Sublime Transcendence': 'Transzendenz',
      'Tandem(?! Assault)': 'Verbundenheit',
      'Tandem Assault: Bloody Sweep': 'Kettenangriff: Zertrümmern',
      'Tandem Assault: Breakthrough': 'Kettenangriff: Tjost',
      'Tandem Assault: Passing Lance': 'Kettenangriff: Scharfrennen',
      'The Final Song': 'Das Letzte Lied',
      'Towerfall': 'Turmsturz',
      'Transference': 'Transfer',
      'Uneven Footing': 'Aufschlag',
      'Universal Assault': 'Omnidirektionalangriff',
      'Upgraded Lance': 'Upgrade: Lanze',
      'Upgraded Shield': 'Upgrade: Schild',
      'Vortex': 'Einsaugen',
      'Wail': 'Feldgeschrei',
      'Wandering Trail': 'Ringstechen',
      'Wave: Black': 'Schwarze Partikel',
      'Wave: White': 'Weiße Partikel',
      'White Dissonance': 'Weiße Korrosion',
      'Wipe: Black': 'Schwarze Detonation',
      'Wipe: White': 'Weiße Detonation'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '2P-Operated Flight Unit': '2P : module de vol équipé',
      'Beyond': 'Sommet',
      'Black Lance': 'lance noire',
      'Black Pylon': 'pilier noir',
      'Closed Area A': 'Secteur cloisonné A',
      'Copied Knave': 'réplique de Jack',
      'False Idol': 'déesse factice',
      'Gretel': 'Gretel',
      'Hansel': 'Hansel',
      'Her Inflorescence': 'déesse éclose',
      'Knave Of Hearts': 'Jack',
      'Meng-Zi': 'Meng-Zi',
      'Red Girl': 'fille en rouge',
      'Red Sphere': 'noyau orange',
      'Serial-Jointed Model': 'modèle multiarticulé',
      'Spheroid': 'sphère',
      'Staging Node B': 'Pare-feu B',
      'Staging Node C': 'Pare-feu C',
      'Staging Node D': 'Pare-feu D',
      'The Ascension Platform': 'Plateforme élévatrice',
      'White Lance': 'lance blanche',
      'Xun-Zi': 'Xun-Zi',
      'Hansel & Gretel': 'duo d\'armures'
    },
    'replaceText': {
      '--targetable\\?--': '--ciblable ?--',
      '(?<!Tandem Assault: )Bloody Sweep': 'Balayage tranchant',
      '(?<!Tandem Assault: )Breakthrough': 'Grande ruée',
      'Child\'s Play': 'Marionnettiste',
      'Colossal Impact': 'Attaque puissante',
      'Crash': 'Collision',
      'Crippling Blow': 'Coup handicapant',
      'Cruelty': 'Embûche',
      'Darker Note': 'Noir : imprécation',
      'Deploy Armaments': 'Activation de l\'armement',
      'Diffuse Energy': 'Tirs dispersés',
      'Distortion': 'Corruption',
      'Eminence': 'Autorité',
      'Explosion': 'Explosion',
      'Generate: Barrier': 'Matérialisation : murs',
      'Heavy Arms': 'Bras armé',
      'High-Powered Laser': 'Laser surpuissant',
      'Hungry Lance': 'Lance tranchante',
      'Knavish Bullets': 'Projectile anti-magie',
      'Lamentation': 'Lamentation',
      'Light Leap': 'Bond',
      'Lighter Note': 'Blanc : imprécation',
      'Lightfast Blade(?! 1\\?)': 'Lame éclair',
      'Lightfast Blade 1\\?': 'Lame éclair 1 ?',
      'Lunge': 'Charge',
      'Made Magic': 'Déferlante magique',
      'Magic Artillery Alpha': 'Balles magiques percutantes α',
      'Magic Artillery Beta': 'Balles magiques percutantes β',
      'Magic Barrage': 'Rafale magique',
      'Magical Interference': 'Interférence magique',
      'Maneuver: Standard Laser': 'Attaque : laser',
      'Manipulate Energy': 'Concentration énergétique',
      'Mixed Signals': 'Allumage des feux',
      '(?<!Tandem Assault: )Passing Lance': 'Ruée des lances',
      'Pervasion': 'Perméabilisation',
      'Pillar Impact': 'Éboulis',
      'Place Of Power': 'Déploiement de champ de force',
      'Point: Black': 'Noir : poignardage',
      'Point: White': 'Blanc : poignardage',
      'Recreate Meteor': 'Recréation : météore',
      'Recreate Signal': 'Recréation : feux de circulation',
      'Recreate Structure': 'Recréation : immeuble',
      'Replicate': 'Réplication',
      'Rhythm Rings': 'Anneau d\'incantation',
      'Riot Of Magic': 'Pilonnage magique',
      'Roar': 'Rugissement',
      'Scattered Magic': 'Éclatement magique',
      'Screaming Score': 'Récital',
      'Seed Of Magic(?! )': 'Balles magiques',
      'Seed Of Magic Alpha': 'Balles magiques α',
      'Seed Of Magic Beta': 'Balles magiques β',
      'Shock: Black': 'Noir : impact',
      'Shock: White': 'Blanc : impact',
      'Shockwave': 'Onde de choc',
      'Spheroids': 'Déploiement de sphères',
      'Stacking The Deck': 'Combinaison',
      'Sublime Transcendence': 'Abstraction',
      'Tandem(?! Assault)': 'Combo',
      'Tandem Assault: Bloody Sweep': 'Combinaison : balayage tranchant',
      'Tandem Assault: Breakthrough': 'Combinaison : grande ruée',
      'Tandem Assault: Passing Lance': 'Combinaison : ruée des lances',
      'The Final Song': 'Ultime cantate',
      'Towerfall': 'Écroulement',
      'Transference': 'Transfert',
      'Uneven Footing': 'Impact frontal',
      'Universal Assault': 'Attaque multidirectionnelle',
      'Upgraded Lance': 'Renforcement : lance',
      'Upgraded Shield': 'Renforcement : bouclier',
      'Vortex': 'Aspiration',
      'Wail': 'Cri déchirant',
      'Wandering Trail': 'Disques magiques',
      'Wave: Black': 'Noir : onde',
      'Wave: White': 'Blanc : onde',
      'White Dissonance / Black Dissonance': 'Blanc/Noir : rongement',
      'Wipe: Black': 'Noir : grosse Explosion',
      'Wipe: White': 'Blanc : grosse Explosion'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      '2P-Operated Flight Unit': '２Ｐ：飛行ユニット装備',
      'Beyond': '頂上',
      'Black Lance': '黒槍',
      'Black Pylon': '黒柱',
      'Closed Area A': '封鎖区画A',
      'Copied Knave': '複製サレタジャック',
      'False Idol': '偽造サレタ神',
      '(?<!& )Gretel': 'グレーテル',
      'Hansel(?! &)': 'ヘンゼル',
      'Her Inflorescence': '開花シタ神',
      'Knave Of Hearts': 'ジャック',
      'Meng-Zi': 'モウシ',
      'Red Girl': '赤い少女',
      'Red Sphere': '赤球',
      'Serial-Jointed Model': '多関節型',
      'Spheroid': '球体',
      'Staging Node B': '迎撃区画B',
      'Staging Node C': '迎撃区画C',
      'Staging Node D': '迎撃区画D',
      'The Ascension Platform': '昇降機',
      'White Lance': '白槍',
      'Xun-Zi': 'ジュンシ',
      'Hansel & Gretel': 'ヘンゼル&グレーテル'
    },
    'replaceText': {
      'Black Dissonance': '浸食：黒',
      '(?<!Tandem Assault: )Bloody Sweep': '薙ぎ払い',
      '(?<!Tandem Assault: )Breakthrough': '重突進',
      'Child\'s Play': '人形遣い',
      'Colossal Impact': '強攻撃',
      'Crash': '衝突',
      'Crippling Blow': '痛打',
      'Cruelty': '強襲',
      'Darker Note': '断唱：黒',
      'Deploy Armaments': '武装起動',
      'Diffuse Energy': '拡散エネルギー弾',
      'Distortion': '汚染',
      'Eminence': '威光',
      'Explosion': '爆発',
      'Generate: Barrier': '生成：障壁',
      'Heavy Arms': '武装',
      'High-Powered Laser': '高出力レーザー',
      'Hungry Lance': '槍薙ぎ',
      'Knavish Bullets': '魔障弾',
      'Lamentation': '慟哭',
      'Light Leap': '跳躍',
      'Lighter Note': '断唱：白',
      'Lightfast Blade': '光刃斬機',
      'Lunge': '体当たり',
      'Made Magic': '魔力放出',
      'Magic Artillery Alpha': '魔法衝撃弾α',
      'Magic Artillery Beta': '魔法衝撃弾β',
      'Magic Barrage': '魔法弾連射',
      'Magical Interference': '魔力干渉',
      'Maneuver: Standard Laser': '攻撃：レーザー',
      'Manipulate Energy': 'エネルギー集中',
      'Mixed Signals': '信号切替',
      '(?<!Tandem Assault: )Passing Lance': '槍突進',
      'Pervasion': '透過',
      'Pillar Impact': '崩落',
      'Place Of Power': '力場生成',
      'Point: Black': '刺突：黒',
      'Point: White': '刺突：白',
      'Recreate Meteor': '再現：メテオ',
      'Recreate Signal': '再現：信号',
      'Recreate Structure': '再現：建物',
      'Replicate': '複製',
      'Rhythm Rings': '魔唱輪',
      'Riot Of Magic': '魔法弾放射',
      'Roar': '咆哮',
      'Scattered Magic': '魔力飛散',
      'Screaming Score': '唱譜',
      'Seed Of Magic(?! )': '魔法弾',
      'Seed Of Magic Alpha': '魔法弾α',
      'Seed Of Magic Beta': '魔法弾β',
      'Shock: Black': '衝撃：黒',
      'Shock: White': '衝撃：白',
      'Shockwave': '衝撃波',
      'Spheroids': '球体放出',
      'Stacking The Deck': '連携攻撃',
      'Sublime Transcendence': '超越',
      'Tandem(?! Assault)': '連携',
      'Tandem Assault: Bloody Sweep': '連携攻撃：薙ぎ払い',
      'Tandem Assault: Breakthrough': '連携攻撃：重突進',
      'Tandem Assault: Passing Lance': '連携攻撃：槍突進',
      'The Final Song': '最後の歌',
      'Towerfall': '倒壊',
      'Transference': '転移',
      'Uneven Footing': '激突衝撃',
      'Universal Assault': '全方位攻撃',
      'Upgraded Lance': '強化：槍',
      'Upgraded Shield': '強化：盾',
      'Vortex': '吸引',
      'Wail': '叫び声',
      'Wandering Trail': '魔障輪',
      'Wave: Black': '波動：黒',
      'Wave: White': '波動：白',
      'White Dissonance': '浸食：白',
      'Wipe: Black': '大爆発：黒',
      'Wipe: White': '大爆発：白'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '2P-Operated Flight Unit': '2P：装备飞行装置',
      'Beyond': '塔顶',
      'Black Lance': '黑枪',
      'Black Pylon': '黑柱',
      'Closed Area A': '封锁区域A',
      'Copied Knave': '复制的杰克',
      'False Idol': '伪造的神明',
      '(?<!& )Gretel': '格雷特',
      'Hansel(?! &)': '韩塞尔',
      'Her Inflorescence': '开花的神明',
      'Knave Of Hearts': '杰克',
      'Meng-Zi': '孟子',
      'Red Girl': '红衣少女',
      'Red Sphere': '红球',
      'Serial-Jointed Model': '多关节型',
      'Spheroid': '球体',
      'Staging Node B': '迎击区域B',
      'Staging Node C': '迎击区域C',
      'Staging Node D': '迎击区域D',
      'The Ascension Platform': '升降机',
      'White Lance': '白枪',
      'Xun-Zi': '荀子',
      'Hansel & Gretel': '韩塞尔与格雷特'
    },
    'replaceText': {
      '--targetable\\?--': '--可选中?--',
      'Black Dissonance': '侵蚀：黑',
      '(?<!Tandem Assault: )Bloody Sweep': '横扫',
      '(?<!Tandem Assault: )Breakthrough': '重突进',
      'Child\'s Play': '控制人偶',
      'Colossal Impact': '强攻击',
      'Crash': '冲撞',
      'Crippling Blow': '痛击',
      'Cruelty': '残忍',
      'Darker Note': '断唱：黑',
      'Deploy Armaments': '武装启动',
      'Diffuse Energy': '扩散能量弹',
      'Distortion': '污染',
      'Eminence': '威光',
      'Explosion': '爆炸',
      'Generate: Barrier': '生成：障壁',
      'Heavy Arms': '武装',
      'High-Powered Laser': '高功率激光',
      'Hungry Lance': '枪扫击',
      'Knavish Bullets': '魔障弹',
      'Lamentation': '恸哭',
      'Light Leap': '轻跃',
      'Lighter Note': '断唱：白',
      'Lightfast Blade': '光刃斩机',
      'Lunge': '冲撞',
      'Made Magic': '释放魔力',
      'Magic Artillery Alpha': '魔法冲击弹α',
      'Magic Artillery Beta': '魔法冲击弹β',
      'Magic Barrage': '魔法弹连射',
      'Magical Interference': '魔力干涉',
      'Maneuver: Standard Laser': '攻击：激光',
      'Manipulate Energy': '能量集中',
      'Mixed Signals': '切换信号',
      '(?<!Tandem Assault: )Passing Lance': '枪突进',
      'Pervasion': '穿透',
      'Pillar Impact': '崩落',
      'Place Of Power': '生成力场',
      'Point: Black': '突刺：黑',
      'Point: White': '突刺：白',
      'Recreate Meteor': '再现：陨石',
      'Recreate Signal': '再现：信号灯',
      'Recreate Structure': '再现：建筑物',
      'Replicate': '复制',
      'Rhythm Rings': '魔唱轮',
      'Riot Of Magic': '魔法弹放射',
      'Roar': '咆哮',
      'Scattered Magic': '魔力飞散',
      'Screaming Score': '唱谱',
      'Seed Of Magic(?! )': '魔法弹',
      'Seed Of Magic Alpha': '魔法弹α',
      'Seed Of Magic Beta': '魔法弹β',
      'Shock: Black': '冲击：黑',
      'Shock: White': '冲击：白',
      'Shockwave': '冲击波',
      'Spheroids': '球体放出',
      'Stacking The Deck': '协作攻击',
      'Sublime Transcendence': '超越',
      'Tandem(?! Assault)': '协作',
      'Tandem Assault: Bloody Sweep': '协作攻击：横扫',
      'Tandem Assault: Breakthrough': '协作攻击：重突进',
      'Tandem Assault: Passing Lance': '协作攻击：枪突进',
      'The Final Song': '最后之歌',
      'Towerfall': '崩塌',
      'Transference': '转移',
      'Uneven Footing': '激烈撞击',
      'Universal Assault': '全方位攻击',
      'Upgraded Lance': '强化：枪',
      'Upgraded Shield': '强化：盾',
      'Vortex': '吸引',
      'Wail': '喊叫',
      'Wandering Trail': '魔障轮',
      'Wave: Black': '波动：黑',
      'Wave: White': '波动：白',
      'White Dissonance': '侵蚀：白',
      'Wipe: Black': '大爆炸：黑',
      'Wipe: White': '大爆炸：白'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '2P-Operated Flight Unit': '2P: 비행 유닛 장비',
      'Beyond': '정상',
      'Black Lance': '검은 창',
      'Black Pylon': '검은 기둥',
      'Closed Area A': '봉쇄 구획 A',
      'Copied Knave': '복제된 잭',
      'False Idol': '위조된 신',
      'Her Inflorescence': '꽃피운 신',
      'Knave Of Hearts': '잭',
      'Meng-Zi': '맹자',
      'Red Girl': '붉은 소녀',
      'Red Sphere': '붉은 공',
      'Serial-Jointed Model': '다관절형',
      'Spheroid': '구체',
      'Staging Node B': '요격 구획 B',
      'Staging Node C': '요격 구획 C',
      'Staging Node D': '요격 구획 D',
      'The Ascension Platform': '승강기',
      'White Lance': '하얀 창',
      'Xun-Zi': '순자',
      'Hansel & Gretel': '헨젤과 그레텔',
      '(?<!& )Gretel': '그레텔',
      'Hansel(?! &)': '헨젤'
    },
    'replaceText': {
      '--targetable\\?--': '--타겟 가능?--',
      '\\(G\\)': '(그레텔)',
      '\\(H\\)': '(헨젤)',
      'Black Dissonance': '침식: 흑',
      '(?<!Tandem Assault: )Bloody Sweep': '내리치기',
      '(?<!Tandem Assault: )Breakthrough': '육중한 돌진',
      'Child\'s Play': '인형 놀이',
      'Colossal Impact': '강공격',
      'Crash': '충돌',
      'Crippling Blow': '통타',
      'Cruelty': '강습',
      'Darker Note': '노래 중단: 흑',
      'Deploy Armaments': '무장 기동',
      'Diffuse Energy': '확산 에너지탄',
      'Distortion': '오염',
      'Eminence': '위광',
      'Explosion': '폭발',
      'Generate: Barrier': '생성: 장벽',
      'Heavy Arms': '무장',
      'High-Powered Laser': '고출력 레이저',
      'Hungry Lance': '창 후리기',
      'Knavish Bullets': '마장탄',
      'Lamentation': '통곡',
      'Light Leap': '도약',
      'Lighter Note': '노래 중단: 백',
      'Lightfast Blade': '빛의 칼날 베기',
      'Lunge': '몸통 박치기',
      'Made Magic': '마력 방출',
      'Magic Artillery Alpha': '마법 충격탄 α',
      'Magic Artillery Beta': '마법 충격탄 β',
      'Magic Barrage': '마법탄 연사',
      'Magical Interference': '마력 간섭',
      'Maneuver: Standard Laser': '공격: 레이저',
      'Manipulate Energy': '에너지 집중',
      'Mixed Signals': '신호 변경',
      '(?<!Tandem Assault: )Passing Lance': '창 돌진',
      'Pervasion': '투과',
      'Pillar Impact': '낙하',
      'Place Of Power': '역장 생성',
      'Point: Black': '찌르기: 흑',
      'Point: White': '찌르기: 백',
      'Recreate Meteor': '재현: 메테오',
      'Recreate Signal': '재현: 신호등',
      'Recreate Structure': '재현: 건물',
      'Replicate': '복제',
      'Rhythm Rings': '노래 고리',
      'Riot Of Magic': '마법탄 발사',
      'Roar': '포효',
      'Scattered Magic': '마력 비산',
      'Screaming Score': '노래 악보',
      'Seed Of Magic(?! )': '마법탄',
      'Seed Of Magic Alpha': '마법탄 α',
      'Seed Of Magic Beta': '마법탄 β',
      'Shock: Black': '충격: 흑',
      'Shock: White': '충격: 백',
      'Shockwave': '충격파',
      'Spheroids': '구체 방출',
      'Stacking The Deck': '연계 공격',
      'Sublime Transcendence': '초월',
      'Tandem(?! Assault)': '연계',
      'Tandem Assault: Bloody Sweep': '연계 공격: 내리치기',
      'Tandem Assault: Breakthrough': '연계 공격: 육중한 돌진',
      'Tandem Assault: Passing Lance': '연계 공격: 창 돌진',
      'The Final Song': '마지막 노래',
      'Towerfall': '무너짐',
      'Transference': '전이',
      'Uneven Footing': '격돌 충격',
      'Universal Assault': '전방위 공격',
      'Upgraded Lance': '강화: 창',
      'Upgraded Shield': '강화: 방패',
      'Vortex': '흡인',
      'Wail': '고함',
      'Wandering Trail': '마장륜',
      'Wave: Black': '파동: 흑',
      'Wave: Black(?! )': '파동: 흑',
      'Wave: White': '파동: 백',
      'White Dissonance': '침식: 백',
      'Wipe: Black': '대폭발: 흑',
      'Wipe: White': '대폭발: 백'
    }
  }]
};
/* harmony default export */ const the_tower_at_paradigms_breach = (the_tower_at_paradigms_breach_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/alliance/the_tower_at_paradigms_breach.txt
const alliance_the_tower_at_paradigms_breach_namespaceObject = "### The Tower at Paradigm's Breach\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Knave of Hearts\r\n# -p 5EB5:1012\r\n# -ii 5CEC 5CED 5CEE 5CEF 5EA5 5EA6 5CF9 5EB4 5EAF\r\n# -ic \"2B\"\r\n# -it \"Knave Of Hearts\"\r\n\r\n# Note: 5EA7 (middle laser) is always 8 seconds, but 5EA4 (sides) is always 7 seconds.\r\n# This creates weird desyncing by ~1s around any place where there's randomness.\r\n# The starts casting of these two abilities overlaps, so there's not a great way\r\n# to come up with any timeline that will perfectly time both of them.\r\n# So, give up, and add extra syncs on abilities after.\r\n\r\n# Closed Area A will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E46\" } window 10000,0\r\n1012.0 \"Roar\" Ability { id: \"5EB5\", source: \"Knave Of Hearts\" } window 1012,10\r\n1022.1 \"Colossal Impact\" Ability { id: \"5EA7\", source: \"Knave Of Hearts\" }\r\n1033.2 \"Colossal Impact\" Ability { id: \"5EA4\", source: \"Knave Of Hearts\" }\r\n1040.3 \"--sync--\" Ability { id: \"5EB2\", source: \"Knave Of Hearts\" } # Magic Artillery Beta cast\r\n1047.4 \"Magic Artillery Beta\" Ability { id: \"5EB3\", source: \"Knave Of Hearts\" } # damage\r\n\r\n1050.5 \"Replicate\" Ability { id: \"5EA9\", source: \"Knave Of Hearts\" }\r\n1061.8 \"Stacking The Deck\" Ability { id: \"60F0\", source: \"Copied Knave\" }\r\n1072.0 \"Colossal Impact 1\" Ability { id: \"5EA[47]\", source: \"Knave Of Hearts\" } window 4,4\r\n1077.0 \"Colossal Impact 2\" Ability { id: \"5EA[47]\", source: \"Copied Knave\" } window 4,4\r\n1085.2 \"--sync--\" StartsUsing { id: \"5EA8\", source: \"Knave Of Hearts\" } window 10,10\r\n1089.2 \"Spheroids\" Ability { id: \"5EA8\", source: \"Knave Of Hearts\" }\r\n1093.4 \"Knavish Bullets\" Ability { id: \"5EAD\", source: \"Spheroid\" }\r\n1094.2 \"--sync--\" Ability { id: \"5EAA\", source: \"Knave Of Hearts\" } # Magic Artillery Alpha cast\r\n1102.3 \"Magic Artillery Alpha\" Ability { id: \"5EAB\", source: \"Knave Of Hearts\" } # damage\r\n1116.4 \"Light Leap\" Ability { id: \"5EAE\", source: \"Knave Of Hearts\" }\r\n1116.4 \"--untargetable--\"\r\n1118.5 \"--sync--\" Ability { id: \"5EB0\", source: \"Knave Of Hearts\" }\r\n1120.5 \"--targetable--\"\r\n\r\n1123.6 \"Replicate\" Ability { id: \"5EA9\", source: \"Knave Of Hearts\" }\r\n1134.9 \"Stacking The Deck\" Ability { id: \"60F0\", source: \"Copied Knave\" }\r\n1145.1 \"Lunge 1\" Ability { id: \"5EB1\", source: \"Knave Of Hearts\" }\r\n1146.2 \"--sync--\" Ability { id: \"5EB0\", source: \"Knave Of Hearts\" }\r\n1155.1 \"Lunge 2\" Ability { id: \"5EB1\", source: \"Copied Knave\" }\r\n1167.3 \"Roar\" Ability { id: \"5EB5\", source: \"Knave Of Hearts\" }\r\n\r\n1178.5 \"Replicate\" Ability { id: \"5EA9\", source: \"Knave Of Hearts\" }\r\n1189.8 \"Stacking The Deck\" Ability { id: \"60F0\", source: \"Copied Knave\" }\r\n1200.0 \"Colossal Impact 1\" Ability { id: \"5EA[47]\", source: \"Knave Of Hearts\" } window 4,4\r\n1206.0 \"Colossal Impact 2\" Ability { id: \"5EA[47]\", source: \"Copied Knave\" } window 4,4\r\n1208.1 \"Spheroids\" Ability { id: \"5EA8\", source: \"Knave Of Hearts\" } window 10,10\r\n1211.0 \"Colossal Impact 3\" #Ability { id: \"5EA[47]\", source: \"Copied Knave\" }\r\n1213.2 \"--sync--\" Ability { id: \"5EAA\", source: \"Knave Of Hearts\" } # Magic Artillery Alpha cast\r\n1221.2 \"Magic Barrage 1\" #Ability { id: \"5EAC\", source: \"Spheroid\" }\r\n1221.3 \"Magic Artillery Alpha\" Ability { id: \"5EAB\", source: \"Knave Of Hearts\" } # damage\r\n1224.2 \"Magic Barrage 2\" #Ability { id: \"5EAC\", source: \"Spheroid\" }\r\n1239.4 \"Light Leap\" Ability { id: \"5EAE\", source: \"Knave Of Hearts\" }\r\n1239.4 \"--untargetable--\"\r\n1241.5 \"--sync--\" Ability { id: \"5EB0\", source: \"Knave Of Hearts\" }\r\n1243.5 \"--targetable--\"\r\n\r\n1246.6 \"Replicate\" Ability { id: \"5EA9\", source: \"Knave Of Hearts\" }\r\n1257.9 \"Stacking The Deck\" Ability { id: \"60F0\", source: \"Copied Knave\" }\r\n1268.1 \"Lunge 1\" Ability { id: \"5EB1\", source: \"Knave Of Hearts\" }\r\n1269.2 \"--sync--\" Ability { id: \"5EB0\", source: \"Knave Of Hearts\" }\r\n1278.1 \"Lunge 2\" Ability { id: \"5EB1\", source: \"Copied Knave\" }\r\n1280.1 \"Colossal Impact\" Ability { id: [\"60C8\", \"5CFD\"], source: \"Knave Of Hearts\" }\r\n1287.2 \"--sync--\" Ability { id: \"5EB2\", source: \"Knave Of Hearts\" } # Magic Artillery Beta cast\r\n1294.3 \"Magic Artillery Beta\" Ability { id: \"5EB3\", source: \"Knave Of Hearts\" } # damage\r\n\r\n1305.4 \"Spheroids\" Ability { id: \"5EA8\", source: \"Knave Of Hearts\" }\r\n1309.6 \"Knavish Bullets\" Ability { id: \"5EAD\", source: \"Spheroid\" }\r\n1318.3 \"Colossal Impact\" Ability { id: \"5EA[47]\", source: \"Knave Of Hearts\" }\r\n1332.5 \"Roar\" Ability { id: \"5EB5\", source: \"Knave Of Hearts\" }\r\n\r\n# loop\r\n1342.7 \"Replicate\" Ability { id: \"5EA9\", source: \"Knave Of Hearts\" } window 50,50 jump 1178.5\r\n1354.0 \"Stacking The Deck\" #Ability { id: \"60F0\", source: \"Copied Knave\" }\r\n1364.2 \"Colossal Impact 1\" #Ability { id: \"5EA7\", source: \"Knave Of Hearts\" } window 4,4\r\n1370.2 \"Colossal Impact 2\" #Ability { id: \"5EA7\", source: \"Copied Knave\" } window 4,4\r\n1372.3 \"Spheroids\" #Ability { id: \"5EA8\", source: \"Knave Of Hearts\" } window 10,10\r\n1375.2 \"Colossal Impact 3\" #Ability { id: \"5EA4\", source: \"Copied Knave\" }\r\n1377.4 \"--sync--\" #Ability { id: \"5EAA\", source: \"Knave Of Hearts\" } # Magic Artillery Alpha cast\r\n1385.4 \"Magic Barrage 1\" #Ability { id: \"5EAC\", source: \"Spheroid\" }\r\n1385.5 \"Magic Artillery Alpha\" Ability { id: \"5EAB\", source: \"Knave Of Hearts\" } # damage\r\n1388.4 \"Magic Barrage 2\" #Ability { id: \"5EAC\", source: \"Spheroid\" }\r\n1403.6 \"Light Leap\" #Ability { id: \"5EAE\", source: \"Knave Of Hearts\" }\r\n1403.6 \"--untargetable--\"\r\n1405.7 \"--sync--\" #Ability { id: \"5EB0\", source: \"Knave Of Hearts\" }\r\n1407.7 \"--targetable--\"\r\n\r\n\r\n### Hansel & Gretel\r\n# -p 5C68:2012 (if Hansel starts with shield)\r\n# -p 5C69:2012 (if Gretel starts with shield)\r\n# -ii 5CEC 5CED 5CEE 5CEF 5C70 5C67 5C5C 5C6C 56CD 5C7F 5C55 61B9 61DB 5C65 5C66 5C6E 5C6F 5C57 5CF2 61BD 5C5B 5C72 61BB 55B3 5C5D 5C59 5C7D\r\n# -ic \"2B\"\r\n# -it \"Hansel\"\r\n\r\n# Staging Node B will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E49\" } window 2000,0\r\n2012.0 \"Upgraded Shield\" Ability { id: \"5C6[89]\", source: \"Gretel\" } window 2012,10\r\n2012.0 \"Upgraded Lance\" Ability { id: \"5C6[AB]\", source: \"Hansel\" } window 2012,10\r\n2025.2 \"Wail\" Ability { id: \"5C77\", source: \"Hansel\" }\r\n2025.3 \"Crippling Blow (G)\" Ability { id: \"5C78\", source: \"Gretel\" }\r\n2035.5 \"Wail\" Ability { id: \"5C76\", source: \"Gretel\" }\r\n2035.6 \"Crippling Blow (H)\" Ability { id: \"5C79\", source: \"Hansel\" }\r\n\r\n2043.8 \"Tandem Assault: Bloody Sweep\" Ability { id: \"61B8\", source: \"Gretel\" }\r\n2046.0 \"--sync--\" Ability { id: \"5C7E\", source: \"Gretel\" }\r\n2056.2 \"Bloody Sweep\" Ability { id: \"5C54\", source: \"Gretel\" }\r\n\r\n2070.4 \"Upgraded Shield\" Ability { id: \"5C6[89]\", source: \"Gretel\" }\r\n2070.4 \"Upgraded Lance\" Ability { id: \"5C6[AB]\", source: \"Hansel\" }\r\n2083.6 \"--sync--\" Ability { id: \"5C7A\", source: \"Gretel\" } # Seed Of Magic Alpha cast\r\n2083.6 \"--sync--\" Ability { id: \"5C7B\", source: \"Hansel\" } # Riot Of Magic cast\r\n2089.4 \"Seed Of Magic Alpha\" Ability { id: \"5C61\", source: \"Gretel\" } # damage\r\n2089.4 \"Riot Of Magic\" Ability { id: \"5C63\", source: \"Hansel\" } # damage\r\n\r\n2098.9 \"Tandem Assault: Passing Lance\" Ability { id: \"61BC\", source: \"Gretel\" }\r\n2101.0 \"--untargetable--\"\r\n2101.1 \"--sync--\" Ability { id: \"5C7E\", source: \"Gretel\" }\r\n2111.3 \"Passing Lance\" Ability { id: \"5C64\", source: \"Gretel\" }\r\n2116.1 \"--targetable--\"\r\n\r\n2126.2 \"Upgraded Shield\" Ability { id: \"5C6[89]\", source: \"Gretel\" }\r\n2126.2 \"Upgraded Lance\" Ability { id: \"5C6[AB]\", source: \"Hansel\" }\r\n2139.5 \"Wail\" Ability { id: \"5C77\", source: \"Hansel\" }\r\n2139.6 \"Crippling Blow (G)\" Ability { id: \"5C78\", source: \"Gretel\" }\r\n2149.8 \"Wail\" Ability { id: \"5C76\", source: \"Gretel\" }\r\n2149.9 \"Crippling Blow (H)\" Ability { id: \"5C79\", source: \"Hansel\" }\r\n\r\n2162.2 \"Tandem Assault: Bloody Sweep\" Ability { id: \"61B8\", source: \"Gretel\" }\r\n2164.4 \"--sync--\" Ability { id: \"5C7E\", source: \"Gretel\" }\r\n2166.5 \"Tandem\" Ability { id: \"5C58\", source: \"Gretel\" }\r\n2176.7 \"Transference\" Ability { id: \"5CF1\", source: \"Gretel\" }\r\n2181.6 \"Bloody Sweep\" Ability { id: \"5C56\", source: \"Gretel\" }\r\n\r\n2184.9 \"--sync--\" Ability { id: \"5C7E\", source: \"Gretel\" }\r\n2192.1 \"Wandering Trail\" Ability { id: \"5C5A\", source: \"Gretel\" }\r\n2199.3 \"Tandem Assault: Breakthrough\" Ability { id: \"61BA\", source: \"Gretel\" }\r\n2201.4 \"--untargetable--\"\r\n2201.5 \"--sync--\" Ability { id: \"5C7E\", source: \"Gretel\" }\r\n2212.8 \"Breakthrough\" Ability { id: \"5C5E\", source: \"Hansel\" }\r\n2213.1 \"Uneven Footing\" Ability { id: \"5C5F\", source: \"Hansel & Gretel\" }\r\n2214.9 \"--targetable--\"\r\n\r\n2227.0 \"Upgraded Shield\" Ability { id: \"5C6[89]\", source: \"Gretel\" }\r\n2227.0 \"Upgraded Lance\" Ability { id: \"5C6[AB]\", source: \"Hansel\" }\r\n2240.2 \"Wail\" Ability { id: \"5C77\", source: \"Hansel\" }\r\n2240.3 \"Crippling Blow (G)\" Ability { id: \"5C78\", source: \"Gretel\" }\r\n2250.5 \"Wail\" Ability { id: \"5C76\", source: \"Gretel\" }\r\n2250.6 \"Crippling Blow (H)\" Ability { id: \"5C79\", source: \"Hansel\" }\r\n\r\n2262.9 \"Tandem Assault: Passing Lance\" Ability { id: \"61BC\", source: \"Gretel\" }\r\n2266.1 \"--untargetable--\"\r\n2266.2 \"--sync--\" Ability { id: \"5C7E\", source: \"Gretel\" }\r\n2267.9 \"Seed Of Magic Alpha\" Ability { id: \"5C61\", source: \"Gretel\" }\r\n2267.9 \"Riot Of Magic\" Ability { id: \"5C63\", source: \"Hansel\" }\r\n2276.4 \"Passing Lance\" Ability { id: \"5C64\", source: \"Gretel\" }\r\n2281.2 \"--targetable--\"\r\n\r\n2291.3 \"Upgraded Shield\" Ability { id: \"5C6[89]\", source: \"Gretel\" }\r\n2291.3 \"Upgraded Lance\" Ability { id: \"5C6A\", source: \"Hansel\" }\r\n2307.6 \"Wandering Trail\" Ability { id: \"5C5A\", source: \"Gretel\" }\r\n2315.8 \"--sync--\" Ability { id: \"5C7E\", source: \"Gretel\" }\r\n2322.5 \"Hungry Lance\" Ability { id: \"5C71\", source: \"Gretel\" }\r\n\r\n2334.7 \"Upgraded Shield\" Ability { id: \"5C6[89]\", source: \"Gretel\" }\r\n2334.7 \"Upgraded Lance\" Ability { id: \"5C6[AB]\", source: \"Hansel\" }\r\n2351.0 \"--sync--\" Ability { id: \"5C7C\", source: \"Gretel\" } # Seed Of Magic Beta cast\r\n2353.2 \"--sync--\" Ability { id: \"5C7E\", source: \"Gretel\" }\r\n2359.9 \"Wandering Trail\" Ability { id: \"5C5A\", source: \"Gretel\" }\r\n2361.8 \"Seed Of Magic Beta\" Ability { id: \"5C75\", source: \"Gretel\" } # damage\r\n\r\n2367.1 \"Tandem Assault: Breakthrough\" Ability { id: \"61BA\", source: \"Gretel\" }\r\n2369.2 \"--untargetable--\"\r\n2369.3 \"--sync--\" Ability { id: \"5C7E\", source: \"Gretel\" }\r\n2380.6 \"Breakthrough\" Ability { id: \"5C5E\", source: \"Hansel\" }\r\n2380.9 \"Uneven Footing\" Ability { id: \"5C5F\", source: \"Hansel & Gretel\" }\r\n2382.7 \"--targetable--\"\r\n\r\n2394.8 \"Upgraded Shield\" Ability { id: \"5C6[89]\", source: \"Gretel\" }\r\n2394.8 \"Upgraded Lance\" Ability { id: \"5C6[AB]\", source: \"Hansel\" }\r\n2408.1 \"Wail\" Ability { id: \"5C77\", source: \"Hansel\" }\r\n2408.2 \"Crippling Blow (G)\" Ability { id: \"5C78\", source: \"Gretel\" }\r\n2418.4 \"Wail\" Ability { id: \"5C76\", source: \"Gretel\" }\r\n2418.5 \"Crippling Blow (H)\" Ability { id: \"5C79\", source: \"Hansel\" }\r\n\r\n2430.8 \"Tandem Assault: Bloody Sweep\" Ability { id: \"61B8\", source: \"Gretel\" }\r\n2433.0 \"--sync--\" Ability { id: \"5C7E\", source: \"Gretel\" }\r\n2435.3 \"Tandem\" Ability { id: \"5C58\", source: \"Gretel\" }\r\n2445.5 \"Transference\" Ability { id: \"5CF1\", source: \"Gretel\" }\r\n2450.4 \"Bloody Sweep\" Ability { id: \"5C56\", source: \"Gretel\" }\r\n2464.6 \"Upgraded Shield\" Ability { id: \"5C6[89]\", source: \"Gretel\" }\r\n2464.6 \"Upgraded Lance\" Ability { id: \"5C6[AB]\", source: \"Hansel\" }\r\n\r\n# loop\r\n2476.9 \"Tandem Assault: Passing Lance\" Ability { id: \"61BC\", source: \"Gretel\" } window 100,100 jump 2262.9\r\n2480.1 \"--untargetable--\"\r\n2480.2 \"--sync--\" #Ability { id: \"5C7E\", source: \"Gretel\" }\r\n2481.9 \"Seed Of Magic Alpha\" #Ability { id: \"5C61\", source: \"Gretel\" }\r\n2481.9 \"Riot Of Magic\" #Ability { id: \"5C63\", source: \"Hansel\" }\r\n2490.4 \"Passing Lance\" #Ability { id: \"5C64\", source: \"Gretel\" }\r\n2495.2 \"--targetable--\"\r\n\r\n2505.3 \"Upgraded Shield\" #Ability { id: \"5C6[89]\", source: \"Gretel\" }\r\n2505.3 \"Upgraded Lance\" #Ability { id: \"5C6A\", source: \"Hansel\" }\r\n2521.6 \"Wandering Trail\" #Ability { id: \"5C5A\", source: \"Gretel\" }\r\n2529.8 \"--sync--\" #Ability { id: \"5C7E\", source: \"Gretel\" }\r\n2536.5 \"Hungry Lance\" #Ability { id: \"5C71\", source: \"Gretel\" }\r\n\r\n\r\n# Enrage (when one dies)\r\n2700.0 \"--sync--\" StartsUsing { id: \"5C73\", source: \"Gretel\" } window 700,0\r\n2700.0 \"--sync--\" StartsUsing { id: \"5C74\", source: \"Hansel\" } window 700,0\r\n# Gretel does 57C3 and Hansel does 57C4, and they both do 5C75\r\n2708.0 \"Lamentation\" Ability { id: [\"5C73\", \"5C74\"], source: [\"Gretel\", \"Hansel\"] } window 100,100\r\n2713.8 \"Seed Of Magic Beta\" Ability { id: \"5C75\", source: [\"Gretel\", \"Hansel\"] }\r\n2718.1 \"Lamentation\" #Ability { id: [\"5C73\", \"5C74\"], source: [\"Gretel\", \"Hansel\"] }\r\n2723.9 \"Seed Of Magic Beta\" #Ability { id: \"5C75\", source: [\"Gretel\", \"Hansel\"] }\r\n2728.2 \"Lamentation\" #Ability { id: [\"5C73\", \"5C74\"], source: [\"Gretel\", \"Hansel\"] }\r\n2734.0 \"Seed Of Magic Beta\" #Ability { id: \"5C75\", source: [\"Gretel\", \"Hansel\"] }\r\n2738.3 \"Lamentation\" #Ability { id: [\"5C73\", \"5C74\"], source: [\"Gretel\", \"Hansel\"] }\r\n\r\n\r\n### Assorted Trash\r\n# -ic \"2B\"\r\n# -it \"2P-Operated Flight Unit\"\r\n# -ii 5BFD 5BF7 5BF8 592A\r\n# -p 5BFE:3513.1\r\n# Staging Node C will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E4A\" } window 10000,0\r\n\r\n# A bunch of 2P doing 5FB7/5BF8 blade flurry, but hard to sync this.\r\n# Presumably once they die, then flight units show up.\r\n# Here's a warning of what might be happening around here.\r\n3018.5 \"--targetable?--\"\r\n3031.6 \"Lightfast Blade 1?\"\r\n\r\n3500.0 \"--targetable--\"\r\n3501.1 \"--sync--\" StartsUsing { id: \"5BFE\", source: \"2P-Operated Flight Unit\" } window 3501.1,0\r\n3505.0 \"--targetable--\"\r\n3510.0 \"--targetable--\"\r\n3513.1 \"Lightfast Blade 1\" Ability { id: \"5BFE\", source: \"2P-Operated Flight Unit\" } window 3513.1,3\r\n3515.0 \"--targetable--\"\r\n3518.1 \"Lightfast Blade 2\" Ability { id: \"5BFE\", source: \"2P-Operated Flight Unit\" }\r\n3523.1 \"Lightfast Blade 3\" Ability { id: \"5BFE\", source: \"2P-Operated Flight Unit\" }\r\n3528.1 \"Lightfast Blade 4\" Ability { id: \"5BFE\", source: \"2P-Operated Flight Unit\" }\r\n3539.2 \"Maneuver: Standard Laser\" Ability { id: \"5BFF\", source: \"2P-Operated Flight Unit\" }\r\n3549.4 \"Maneuver: Standard Laser\" Ability { id: \"5BFF\", source: \"2P-Operated Flight Unit\" }\r\n3568.6 \"Maneuver: Standard Laser\" Ability { id: \"5BFF\", source: \"2P-Operated Flight Unit\" }\r\n### ??? more lasers?\r\n\r\n# After flight units die, then a bunch more 2P doing 5BFA Balanced Edge/5BFB Whirling Assault\r\n# which are also hard to sync, sorry.\r\n\r\n\r\n### Red Girl\r\n# -p 6012:4014\r\n# -ii 6014 6006 6007 6008 6009 6310 6311 6312 6313 6021 6022 601A 620B 6027 6010 618C 6056\r\n# -ic \"2B\"\r\n# -it \"Red Girl\"\r\n\r\n# Phase 1\r\n# Staging Node D will be sealed off\r\n4000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E4B\" } window 4000,0\r\n4009.0 \"--sync--\" StartsUsing { id: \"6012\", source: \"Red Girl\" } window 4009,10\r\n4014.0 \"Cruelty\" Ability { id: \"6012\", source: \"Red Girl\" }\r\n4019.9 \"Shockwave\" Ability { id: \"600E\", source: \"Red Girl\" }\r\n4026.0 \"Generate: Barrier\" Ability { id: \"6004\", source: \"Red Girl\" }\r\n4031.0 \"Shock: White\" Ability { id: \"600F\", source: \"Red Girl\" }\r\n4037.1 \"Generate: Barrier\" Ability { id: \"6004\", source: \"Red Girl\" }\r\n4041.1 \"Point: White\" Ability { id: \"601F\", source: \"White Lance\" }\r\n4043.2 \"Shockwave\" Ability { id: \"600E\", source: \"Red Girl\" }\r\n4054.3 \"Shock: Black\" Ability { id: \"6011\", source: \"Red Girl\" }\r\n4060.4 \"Generate: Barrier\" Ability { id: \"6004\", source: \"Red Girl\" }\r\n4064.5 \"Point: Black\" Ability { id: \"6020\", source: \"Black Lance\" }\r\n4074.7 \"Cruelty\" Ability { id: \"6012\", source: \"Red Girl\" }\r\n\r\n4086.7 \"Vortex\" Ability { id: \"6017\", source: \"Red Girl\" }\r\n4088.7 \"Generate: Barrier\" Ability { id: \"6004\", source: \"Red Girl\" }\r\n4092.8 \"Recreate Meteor\" Ability { id: \"6147\", source: \"Red Girl\" }\r\n4099.9 \"Shockwave\" Ability { id: \"600E\", source: \"Red Girl\" }\r\n4106.0 \"Shock: White\" Ability { id: \"600F\", source: \"Red Girl\" }\r\n4111.8 \"Wipe: White\" Ability { id: \"600C\", source: \"Red Girl\" }\r\n4118.1 \"Manipulate Energy\" Ability { id: \"6018\", source: \"Red Girl\" }\r\n4129.3 \"Cruelty\" Ability { id: \"6012\", source: \"Red Girl\" }\r\n4142.5 \"Replicate\" Ability { id: \"600A\", source: \"Red Girl\" }\r\n4153.6 \"Diffuse Energy\" Ability { id: \"6023\", source: \"Red Girl\" } duration 13.7\r\n4173.9 \"Manipulate Energy\" Ability { id: \"6018\", source: \"Red Girl\" }\r\n\r\n# Phase 2: hacking\r\n4189.1 \"Sublime Transcendence\" Ability { id: \"620A\", source: \"Red Girl\" }\r\n4193.2 \"--untargetable--\"\r\n4204.5 \"--sync--\" Ability { id: \"601D\", source: \"Red Girl\" } window 300,10\r\n4219.5 \"Wave: White / Wave: Black\" Ability { id: \"618[DE]\", source: \"Red Sphere\" }\r\n4229.7 \"Wave: White / Wave: Black\" Ability { id: \"618[DE]\", source: \"Red Sphere\" }\r\n4239.8 \"Wave: Black / Wave: Black\" Ability { id: \"618[DE]\", source: \"Red Sphere\" }\r\n4249.9 \"Wave: White / Wave: Black\" Ability { id: \"618[DE]\", source: \"Red Sphere\" } window 10,100\r\n4260.0 \"Wave: Black / Wave: Black\" #Ability { id: \"618[DE]\", source: \"Red Sphere\" }\r\n4270.1 \"Wave: Black / Wave: Black\" #Ability { id: \"618[DE]\", source: \"Red Sphere\" }\r\n4280.2 \"Wave: Black / Wave: Black\" #Ability { id: \"618[DE]\", source: \"Red Sphere\" }\r\n\r\n\r\n# Phase 3\r\n4500.0 \"--sync--\" StartsUsing { id: \"6013\", source: \"Red Girl\" } window 300,10\r\n4505.0 \"Cruelty\" Ability { id: \"6013\", source: \"Red Girl\" }\r\n4521.2 \"Child's Play\" Ability { id: \"6024\", source: \"Red Girl\" }\r\n4527.1 \"Explosion\" Ability { id: \"6026\", source: \"Black Pylon\" }\r\n4533.3 \"Shockwave\" Ability { id: \"600E\", source: \"Red Girl\" }\r\n4545.4 \"Shock: Black\" Ability { id: \"6011\", source: \"Red Girl\" }\r\n4545.5 \"Child's Play\" Ability { id: \"6025\", source: \"Red Girl\" }\r\n4551.4 \"Explosion\" Ability { id: \"6026\", source: \"Black Pylon\" }\r\n4559.7 \"Cruelty\" Ability { id: \"6013\", source: \"Red Girl\" }\r\n4572.9 \"Cruelty\" Ability { id: \"6013\", source: \"Red Girl\" }\r\n\r\n4581.0 \"Generate: Barrier\" Ability { id: \"6005\", source: \"Red Girl\" }\r\n4591.1 \"Point: Black\" Ability { id: \"6020\", source: \"Black Lance\" }\r\n4591.1 \"Point: White\" Ability { id: \"601F\", source: \"White Lance\" }\r\n4597.2 \"Generate: Barrier\" Ability { id: \"6005\", source: \"Red Girl\" }\r\n4601.3 \"Point: Black\" Ability { id: \"6020\", source: \"Black Lance\" }\r\n4601.3 \"Point: White\" Ability { id: \"601F\", source: \"White Lance\" }\r\n4601.3 \"Recreate Meteor\" Ability { id: \"6147\", source: \"Red Girl\" }\r\n4611.4 \"Point: Black\" Ability { id: \"6020\", source: \"Black Lance\" }\r\n4620.4 \"Wipe: Black\" Ability { id: \"600D\", source: \"Red Girl\" }\r\n4620.4 \"Wipe: White\" Ability { id: \"600C\", source: \"Red Girl\" }\r\n4628.6 \"Cruelty\" Ability { id: \"6013\", source: \"Red Girl\" }\r\n\r\n4647.9 \"Replicate\" Ability { id: \"600B\", source: \"Red Girl\" }\r\n4658.9 \"Diffuse Energy\" Ability { id: \"6023\", source: \"Red Girl\" } duration 13.7\r\n4663.1 \"Child's Play\" Ability { id: \"6024\", source: \"Red Girl\" }\r\n4676.2 \"Manipulate Energy\" Ability { id: \"6019\", source: \"Red Girl\" }\r\n4691.4 \"Cruelty\" Ability { id: \"6013\", source: \"Red Girl\" }\r\n4707.6 \"Child's Play\" Ability { id: \"6025\", source: \"Red Girl\" }\r\n4713.5 \"Explosion\" Ability { id: \"6026\", source: \"Black Pylon\" }\r\n4719.7 \"Shockwave\" Ability { id: \"600E\", source: \"Red Girl\" }\r\n4731.8 \"Shock: Black\" Ability { id: \"6011\", source: \"Red Girl\" }\r\n4731.9 \"Child's Play\" Ability { id: \"6025\", source: \"Red Girl\" }\r\n4737.8 \"Explosion\" Ability { id: \"6026\", source: \"Black Pylon\" }\r\n4746.1 \"Cruelty\" Ability { id: \"6013\", source: \"Red Girl\" }\r\n4756.3 \"Cruelty\" Ability { id: \"6013\", source: \"Red Girl\" }\r\n4763.4 \"Manipulate Energy\" Ability { id: \"6018\", source: \"Red Girl\" }\r\n4780.7 \"Cruelty\" Ability { id: \"6013\", source: \"Red Girl\" }\r\n\r\n# loop\r\n4788.8 \"Generate: Barrier\" Ability { id: \"6005\", source: \"Red Girl\" } window 100,100 jump 4581\r\n4798.9 \"Point: Black\" #Ability { id: \"6020\", source: \"Black Lance\" }\r\n4798.9 \"Point: White\" #Ability { id: \"601F\", source: \"White Lance\" }\r\n4805.0 \"Generate: Barrier\" #Ability { id: \"6005\", source: \"Red Girl\" }\r\n4809.1 \"Point: Black\" #Ability { id: \"6020\", source: \"Black Lance\" }\r\n4809.1 \"Point: White\" #Ability { id: \"601F\", source: \"White Lance\" }\r\n4809.1 \"Recreate Meteor\" #Ability { id: \"6147\", source: \"Red Girl\" }\r\n4819.2 \"Point: Black\" #Ability { id: \"6020\", source: \"Black Lance\" }\r\n4828.2 \"Wipe: Black\" #Ability { id: \"600D\", source: \"Red Girl\" }\r\n4828.2 \"Wipe: White\" #Ability { id: \"600C\", source: \"Red Girl\" }\r\n4836.4 \"Cruelty\" #Ability { id: \"6013\", source: \"Red Girl\" }\r\n\r\n\r\n### Trash-talking Philosophers\r\n# -ic \"2B\"\r\n# -it \"Xun-Zi\"\r\n# -p 5C00:5013.3\r\n# -ii 5CEC 5CED 5CEE 5C02 5C05 5C07 5C08\r\n# Ascension Platform will be sealed off\r\n5000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E4C\" } window 5000,0\r\n5013.3 \"Deploy Armaments\" Ability { id: \"5C0[03]\", source: \"Xun-Zi\" } window 5013.3,7\r\n5023.4 \"Deploy Armaments\" Ability { id: \"5C0[03]\", source: \"Xun-Zi\" }\r\n5036.4 \"Universal Assault\" Ability { id: \"5C06\", source: \"Xun-Zi\" }\r\n# ???\r\n\r\n# ~70% HP push?\r\n5200.0 \"--untargetable--\" NameToggle { name: \"Xun-Zi\", toggle: \"00\" } window 200,0\r\n5210.9 \"--targetable--\"\r\n5221.0 \"Deploy Armaments\" Ability { id: \"5C0[03]\", source: \"Xun-Zi\" }\r\n5224.0 \"Deploy Armaments\" Ability { id: \"5C0[03]\", source: \"Meng-Zi\" }\r\n\r\n5235.9 \"Deploy Armaments\" Ability { id: \"5C0[03]\", source: \"Meng-Zi\" }\r\n5238.9 \"Deploy Armaments\" Ability { id: \"5C0[03]\", source: \"Xun-Zi\" }\r\n\r\n5250.1 \"Deploy Armaments\" Ability { id: \"5C0[14]\", source: \"Xun-Zi\" }\r\n5250.1 \"Deploy Armaments\" Ability { id: \"5C0[14]\", source: \"Meng-Zi\" }\r\n\r\n5256.8 \"High-Powered Laser\" Ability { id: \"5C09\", source: \"Serial-Jointed Model\" }\r\n\r\n5267.1 \"Universal Assault\" Ability { id: \"5C06\", source: \"Xun-Zi\" }\r\n5270.1 \"Universal Assault\" Ability { id: \"5C06\", source: \"Meng-Zi\" }\r\n5290.3 \"Universal Assault\" Ability { id: \"5C06\", source: \"Meng-Zi\" }\r\n5293.3 \"Universal Assault\" Ability { id: \"5C06\", source: \"Xun-Zi\" }\r\n\r\n# loop?\r\n# not sure what happens if Xun-Zi is still alive here?\r\n5312.7 \"Deploy Armaments\" Ability { id: \"5C0[03]\", source: \"Meng-Zi\" }\r\n5322.8 \"Deploy Armaments\" Ability { id: \"5C0[03]\", source: \"Meng-Zi\" }\r\n5333.9 \"Deploy Armaments\" Ability { id: \"5C01\", source: \"Meng-Zi\" }\r\n5340.6 \"High-Powered Laser\" Ability { id: \"5C09\", source: \"Serial-Jointed Model\" }\r\n\r\n\r\n\r\n### False Idol\r\n# -ic \"2B\"\r\n# -it \"False Idol\"\r\n# -p 5BDD:6012.3\r\n# -ii 5CEC 5CED 5CEE 5CEF 5FFC 5FFF 5BDA 5BDC\r\n# Beyond will be sealed off\r\n6000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E4D\" } window 6000,0\r\n6007.3 \"--sync--\" StartsUsing { id: \"5BDD\", source: \"False Idol\" } window 6007.3,10\r\n6012.3 \"Screaming Score\" Ability { id: \"5BDD\", source: \"False Idol\" }\r\n6025.5 \"Made Magic\" Ability { id: \"5BD[67]\", source: \"False Idol\" }\r\n6035.7 \"Made Magic\" Ability { id: \"5BD[67]\", source: \"False Idol\" }\r\n6044.9 \"--sync--\" Ability { id: \"5BD8\", source: \"False Idol\" } # Lighter Note castbar\r\n6053.9 \"Lighter Note\" Ability { id: \"5BD9\", source: \"False Idol\" } duration 6.2\r\n6063.1 \"Rhythm Rings\" Ability { id: \"5BD4\", source: \"False Idol\" }\r\n6074.1 \"Magical Interference\" #Ability { id: \"5BD5\", source: \"False Idol\" }\r\n6076.1 \"Magical Interference\" #Ability { id: \"5BD5\", source: \"False Idol\" }\r\n6078.1 \"Magical Interference\" #Ability { id: \"5BD5\", source: \"False Idol\" }\r\n6080.1 \"Magical Interference\" #Ability { id: \"5BD5\", source: \"False Idol\" }\r\n6082.1 \"Magical Interference\" #Ability { id: \"5BD5\", source: \"False Idol\" }\r\n6092.3 \"Seed Of Magic\" Ability { id: \"5BDE\", source: \"False Idol\" }\r\n6093.4 \"Magical Interference\" #Ability { id: \"5BD5\", source: \"False Idol\" }\r\n6095.4 \"Scattered Magic\" Ability { id: \"5BDF\", source: \"False Idol\" }\r\n6097.0 \"Magical Interference\" #Ability { id: \"5BD5\", source: \"False Idol\" }\r\n6107.6 \"Made Magic\" Ability { id: \"5BD[67]\", source: \"False Idol\" }\r\n6115.8 \"Screaming Score\" Ability { id: \"5BDD\", source: \"False Idol\" }\r\n\r\n6128.0 \"Darker Note\" Ability { id: \"5BDB\", source: \"False Idol\" }\r\n6137.2 \"--sync--\" Ability { id: \"5BD8\", source: \"False Idol\" } # Lighter Note castbar\r\n6146.2 \"Lighter Note\" Ability { id: \"5BD9\", source: \"False Idol\" } duration 6.2\r\n6159.4 \"Made Magic\" Ability { id: \"5BD[67]\", source: \"False Idol\" }\r\n6167.6 \"Rhythm Rings\" Ability { id: \"5BD4\", source: \"False Idol\" }\r\n6173.8 \"Seed Of Magic\" Ability { id: \"5BDE\", source: \"False Idol\" }\r\n6176.8 \"Scattered Magic\" Ability { id: \"5BDF\", source: \"False Idol\" }\r\n6178.6 \"Magical Interference\" #Ability { id: \"5BD5\", source: \"False Idol\" }\r\n6180.6 \"Magical Interference\" #Ability { id: \"5BD5\", source: \"False Idol\" }\r\n6182.6 \"Magical Interference\" #Ability { id: \"5BD5\", source: \"False Idol\" }\r\n6184.6 \"Magical Interference\" #Ability { id: \"5BD5\", source: \"False Idol\" }\r\n6190.9 \"Seed Of Magic\" Ability { id: \"5BDE\", source: \"False Idol\" }\r\n6193.9 \"Scattered Magic\" Ability { id: \"5BDF\", source: \"False Idol\" }\r\n6197.0 \"Magical Interference\" #Ability { id: \"5BD5\", source: \"False Idol\" }\r\n6200.5 \"Magical Interference\" #Ability { id: \"5BD5\", source: \"False Idol\" }\r\n6209.0 \"Made Magic\" Ability { id: \"5BD[67]\", source: \"False Idol\" }\r\n6217.2 \"Screaming Score\" Ability { id: \"5BDD\", source: \"False Idol\" }\r\n6225.4 \"Screaming Score\" Ability { id: \"5BDD\", source: \"False Idol\" }\r\n\r\n# loop ??? (plz confirm)\r\n6239.6 \"Darker Note\" Ability { id: \"5BDB\", source: \"False Idol\" }\r\n6248.8 \"--sync--\" Ability { id: \"5BD8\", source: \"False Idol\" } # Lighter Note castbar\r\n6257.8 \"Lighter Note\" Ability { id: \"5BD9\", source: \"False Idol\" } duration 6.2\r\n\r\n\r\n### Her Inflorescence\r\n# -ic \"2B\"\r\n# -it \"Her Inflorescence\"\r\n# -p 5BE0:7013.2\r\n# -ii 5CEC 5CED 5CEE 5CEF 5FFF 5BDA 5BDC 5BEF 5BF2 5BE6 5BE8 5BE7\r\n# Whether there is a checkpoint is unclear, but sync as if there is.\r\n\r\n6963.3 \"--sync--\" StartsUsing { id: \"5DD5\", source: \"False Idol\" } window 1000,0\r\n6968.3 \"Eminence\" Ability { id: \"5DD5\", source: \"False Idol\" }\r\n6968.3 \"--untargetable--\"\r\n\r\n7000.0 \"--targetable--\"\r\n7010.2 \"--sync--\" StartsUsing { id: \"5BE0\", source: \"Her Inflorescence\" } window 7010.2,0\r\n7013.2 \"Pervasion\" Ability { id: \"5BE0\", source: \"Her Inflorescence\" }\r\n7019.3 \"Recreate Structure\" Ability { id: \"5BE1\", source: \"Her Inflorescence\" }\r\n7030.4 \"Uneven Footing\" Ability { id: \"5BE2\", source: \"Her Inflorescence\" }\r\n7033.9 \"Recreate Structure\" Ability { id: \"5BE1\", source: \"Her Inflorescence\" }\r\n7045.0 \"Uneven Footing\" Ability { id: \"5BE2\", source: \"Her Inflorescence\" }\r\n\r\n7050.6 \"Recreate Signal\" Ability { id: \"5BE3\", source: \"Her Inflorescence\" }\r\n7056.7 \"Mixed Signals\" Ability { id: \"5BE4\", source: \"Her Inflorescence\" }\r\n7066.6 \"Crash\" Ability { id: \"5BE5\", source: \"Her Inflorescence\" }\r\n7074.8 \"Mixed Signals\" Ability { id: \"5BE4\", source: \"Her Inflorescence\" }\r\n7082.7 \"Crash\" Ability { id: \"5BE5\", source: \"Her Inflorescence\" }\r\n7086.9 \"--sync--\" Ability { id: \"5C0C\", source: \"Her Inflorescence\" } # Lighter Note castbar\r\n7095.9 \"Lighter Note\" Ability { id: \"5BD9\", source: \"Her Inflorescence\" } # duration 6.2\r\n7105.0 \"Screaming Score\" Ability { id: \"5BF5\", source: \"Her Inflorescence\" }\r\n7113.2 \"Darker Note\" Ability { id: \"5C0A\", source: \"Her Inflorescence\" }\r\n7128.4 \"Heavy Arms\" Ability { id: \"5BE[DE]\", source: \"Her Inflorescence\" }\r\n7138.6 \"Heavy Arms\" Ability { id: \"5BE[DE]\", source: \"Her Inflorescence\" }\r\n\r\n7151.4 \"Distortion\" Ability { id: \"5BE9\", source: \"Her Inflorescence\" }\r\n7157.6 \"Place Of Power\" Ability { id: \"5C0D\", source: \"Her Inflorescence\" }\r\n7157.6 \"The Final Song\" Ability { id: \"5BEA\", source: \"Her Inflorescence\" }\r\n7167.7 \"White Dissonance / Black Dissonance\" Ability { id: \"5BE[BC]\", source: \"Her Inflorescence\" }\r\n7173.7 \"White Dissonance / Black Dissonance\" Ability { id: \"5BE[BC]\", source: \"Her Inflorescence\" }\r\n7179.7 \"White Dissonance / Black Dissonance\" Ability { id: \"5BE[BC]\", source: \"Her Inflorescence\" }\r\n\r\n7200.5 \"Pillar Impact\" Ability { id: \"5BF0\", source: \"Her Inflorescence\" }\r\n7202.0 \"Shockwave\" Ability { id: \"5BF1\", source: \"Her Inflorescence\" }\r\n7204.6 \"Pillar Impact\" Ability { id: \"5C0E\", source: \"Her Inflorescence\" }\r\n7206.0 \"Shockwave\" Ability { id: \"5BF1\", source: \"Her Inflorescence\" }\r\n7211.6 \"Towerfall\" Ability { id: \"5BF3\", source: \"Her Inflorescence\" }\r\n7220.8 \"Towerfall\" Ability { id: \"5BF4\", source: \"Her Inflorescence\" }\r\n\r\n7231.2 \"Recreate Signal\" Ability { id: \"5BE3\", source: \"Her Inflorescence\" }\r\n7237.3 \"Mixed Signals\" Ability { id: \"5BE4\", source: \"Her Inflorescence\" }\r\n7255.4 \"Distortion\" Ability { id: \"6058\", source: \"Her Inflorescence\" }\r\n7261.6 \"The Final Song\" Ability { id: \"5BEA\", source: \"Her Inflorescence\" }\r\n7270.7 \"White Dissonance / Black Dissonance\" #Ability { id: \"5BE[BC]\", source: \"Her Inflorescence\" }\r\n7272.7 \"White Dissonance / Black Dissonance\" #Ability { id: \"5BE[BC]\", source: \"Her Inflorescence\" }\r\n7274.7 \"White Dissonance / Black Dissonance\" #Ability { id: \"5BE[BC]\", source: \"Her Inflorescence\" }\r\n7283.7 \"Heavy Arms\" Ability { id: \"5BE[DE]\", source: \"Her Inflorescence\" }\r\n7289.8 \"--sync--\" Ability { id: \"5C0C\", source: \"Her Inflorescence\" } # Lighter Note castbar\r\n7298.8 \"Lighter Note\" Ability { id: \"5BD9\", source: \"Her Inflorescence\" } duration 6.2\r\n7309.9 \"Heavy Arms\" Ability { id: \"5BE[DE]\", source: \"Her Inflorescence\" }\r\n\r\n7316.0 \"Recreate Signal\" Ability { id: \"5BE3\", source: \"Her Inflorescence\" }\r\n7322.1 \"Mixed Signals\" Ability { id: \"5BE4\", source: \"Her Inflorescence\" }\r\n7328.2 \"Rhythm Rings\" Ability { id: \"5C0B\", source: \"Her Inflorescence\" }\r\n7330.0 \"Crash\" Ability { id: \"5BE5\", source: \"Her Inflorescence\" }\r\n7338.2 \"Magical Interference\" Ability { id: \"5BD5\", source: \"Her Inflorescence\" }\r\n7344.3 \"Screaming Score\" Ability { id: \"5BF5\", source: \"Her Inflorescence\" }\r\n7352.5 \"Darker Note\" Ability { id: \"5C0A\", source: \"Her Inflorescence\" }\r\n7364.7 \"Pervasion\" Ability { id: \"5BE0\", source: \"Her Inflorescence\" }\r\n\r\n7370.8 \"Recreate Structure\" Ability { id: \"5BE1\", source: \"Her Inflorescence\" }\r\n7381.0 \"Rhythm Rings\" Ability { id: \"5C0B\", source: \"Her Inflorescence\" }\r\n7383.0 \"Uneven Footing\" Ability { id: \"5BE2\", source: \"Her Inflorescence\" }\r\n7391.0 \"Magical Interference\" Ability { id: \"5BD5\", source: \"Her Inflorescence\" }\r\n7398.2 \"Heavy Arms\" Ability { id: \"5BE[DE]\", source: \"Her Inflorescence\" }\r\n7406.4 \"Screaming Score\" Ability { id: \"5BF5\", source: \"Her Inflorescence\" }\r\n\r\n7425.3 \"Pillar Impact\" Ability { id: \"5BF0\", source: \"Her Inflorescence\" }\r\n7426.8 \"Shockwave\" Ability { id: \"5BF1\", source: \"Her Inflorescence\" }\r\n7429.4 \"Pillar Impact\" Ability { id: \"5C0E\", source: \"Her Inflorescence\" }\r\n7430.8 \"Shockwave\" Ability { id: \"5BF1\", source: \"Her Inflorescence\" }\r\n7436.4 \"Towerfall\" Ability { id: \"5BF3\", source: \"Her Inflorescence\" }\r\n7445.6 \"Towerfall\" Ability { id: \"5BF4\", source: \"Her Inflorescence\" }\r\n\r\n# loop\r\n7455.8 \"Recreate Signal\" Ability { id: \"5BE3\", source: \"Her Inflorescence\" } window 100,100 jump 7231.2\r\n7461.9 \"Mixed Signals\" #Ability { id: \"5BE4\", source: \"Her Inflorescence\" }\r\n7480.0 \"Distortion\" #Ability { id: \"6058\", source: \"Her Inflorescence\" }\r\n7486.2 \"The Final Song\" #Ability { id: \"5BEA\", source: \"Her Inflorescence\" }\r\n7495.3 \"White Dissonance / Black Dissonance\" #Ability { id: \"5BE[BC]\", source: \"Her Inflorescence\" }\r\n7497.3 \"White Dissonance / Black Dissonance\" #Ability { id: \"5BE[BC]\", source: \"Her Inflorescence\" }\r\n7499.3 \"White Dissonance / Black Dissonance\" #Ability { id: \"5BE[BC]\", source: \"Her Inflorescence\" }\r\n7508.3 \"Heavy Arms\" #Ability { id: \"5BE[DE]\", source: \"Her Inflorescence\" }\r\n7514.4 \"--sync--\" #Ability { id: \"5C0C\", source: \"Her Inflorescence\" } # Lighter Note castbar\r\n7523.4 \"Lighter Note\" #Ability { id: \"5BD9\", source: \"Her Inflorescence\" } duration 6.2\r\n7534.5 \"Heavy Arms\" #Ability { id: \"5BE[DE]\", source: \"Her Inflorescence\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/akadaemia_anyder.ts



const akadaemia_anyder_triggerSet = {
  id: 'AkadaemiaAnyder',
  zoneId: zone_id/* default.AkadaemiaAnyder */.Z.AkadaemiaAnyder,
  timelineFile: 'akadaemia_anyder.txt',
  timelineTriggers: [{
    id: 'Anyder Lash',
    regex: /Lash/,
    beforeSeconds: 5,
    suppressSeconds: 10,
    response: responses/* Responses.miniBuster */.n3.miniBuster()
  }, {
    id: 'Anyder Putrid Breath',
    regex: /Putrid Breath/,
    beforeSeconds: 5,
    response: responses/* Responses.awayFromFront */.n3.awayFromFront('info')
  }],
  triggers: [{
    id: 'Anyder Aquatic Lance',
    type: 'HeadMarker',
    netRegex: {
      id: '0087'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'puddle on you',
        de: 'Fläche auf DIR',
        fr: 'Zone au sol sur VOUS',
        ja: '自分に水溜り',
        cn: '水球点名',
        ko: '징 대상자'
      }
    }
  }, {
    id: 'Anyder Puncture',
    type: 'StartsUsing',
    netRegex: {
      id: '3E04',
      source: ['Cladoselache', 'Doliodus']
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Anyder Tidal Guillotine',
    type: 'StartsUsing',
    netRegex: {
      id: '3E0A',
      source: 'Cladoselache',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Swimming Shark',
        de: 'Weg vom schwimmenden Hai',
        fr: 'Éloignez-vous du requin qui nage',
        ja: '水中サメから離れる',
        cn: '远离水中BOSS',
        ko: '물 속 상어 멀리 떨어지기'
      }
    }
  }, {
    id: 'Anyder Pelagic Cleaver',
    type: 'StartsUsing',
    netRegex: {
      id: '3E0B',
      source: 'Doliodus',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sides of Swimming Shark',
        de: 'Zu den Seiten vom schwimmenden Hai',
        fr: 'Sur les côtés du requin qui nage',
        ja: '水中サメの側へ',
        cn: '去水中BOSS的两侧',
        ko: '물 속 상어 측면으로 피하기'
      }
    }
  }, {
    id: 'Anyder Marine Mayhem',
    type: 'StartsUsing',
    netRegex: {
      id: '3E06',
      source: ['Cladoselache', 'Doliodus'],
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Anyder Sap Shower',
    type: 'HeadMarker',
    netRegex: {
      id: '0078'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Anyder Arbor Storm',
    type: 'StartsUsing',
    netRegex: {
      id: '3E17',
      source: 'Morbol Marquis',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Anyder Noahionto',
    type: 'StartsUsing',
    netRegex: {
      id: '430C',
      source: 'Evil Armor'
    },
    condition: data => data.CanStun() || data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Anyder Shockbolt',
    type: 'StartsUsing',
    netRegex: {
      id: '3E23',
      source: 'Quetzalcoatl'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Anyder Thunderbolt',
    type: 'StartsUsing',
    netRegex: {
      id: '3E24',
      source: 'Quetzalcoatl',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Anyder Thunderstorm',
    type: 'StartsUsing',
    netRegex: {
      id: '3E1A',
      source: 'Quetzalcoatl',
      capture: false
    },
    delaySeconds: 4.7,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'grab orbs',
        de: 'Orbs nehmen',
        fr: 'Prenez les orbes',
        ja: '雷丸を得る',
        cn: '吃球',
        ko: '구슬 줍기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Morbol Marquis': 'Marquis-Morbol',
      'Evil Armor': 'bös(?:e|er|es|en) Kampfmaschine',
      'Quetzalcoatl': 'Quetzalcoatl',
      'Doliodus': 'Doliodus',
      'Cladoselache': 'Cladoselache',
      'Ichthyology': 'Ichthyologie',
      'Phytobiology': 'Phytobiologie',
      'Phantomology': 'Phantomologie'
    },
    'replaceText': {
      'Winding Current': 'Spulenstrom',
      'Tidal Guillotine': 'Gezeitenguillotine',
      'Thunderstorm': 'Gewitter',
      'Thunderbolt': 'Donnerkeil',
      'Shocking Plumage': 'Elektrisierendes Gefieder',
      'Shockbolt': 'Blitzbogen',
      'Sap Shower': 'Pflanzensaftregen',
      'Reverse Current': 'Gegenstrom',
      'Putrid Breath': 'Fauliger Atem',
      'Protolithic Puncture': 'Paläolithische Punktion',
      'Pelagic Cleaver': 'Pelagische Pein',
      'Marine Mayhem': 'Meereschaos',
      'Lash': 'Peitschenschlag',
      'Extensible Tendrils': 'Streckende Ranken',
      'Blossom': 'Blüte',
      'Arbor Storm': 'Dornensturm',
      'Aquatic Lance': 'Aquaspeer',
      'Carcharian Verve': 'Haifischschwung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Morbol Marquis': 'Marquis morbol',
      'Evil Armor': 'Armure maléfique',
      'Quetzalcoatl': 'Quetzalcóatl',
      'Doliodus': 'Doliodus',
      'Cladoselache': 'Cladoselache',
      'Ichthyology': 'département d\'ichtyogénie',
      'Phytobiology': 'département de phytogénie',
      'Phantomology': 'département de phantasmagénie'
    },
    'replaceText': {
      'Winding Current': 'Volte-courant',
      'Tidal Guillotine': 'Marée-guillotine',
      'Thunderstorm': 'Feu purificateur',
      'Thunderbolt': 'Éclair',
      'Shocking Plumage': 'Plumage voltaïque',
      'Shockbolt': 'Arc d\'éclair',
      'Sap Shower': 'Averse de sève',
      'Reverse Current': 'Contre-courant',
      'Putrid Breath': 'Haleine putride',
      'Protolithic Puncture': 'Ponction paléolithique',
      'Pelagic Cleaver': 'Fendoir pélagique',
      'Marine Mayhem': 'Mutilation marine',
      'Lash': 'Coup de fouet',
      'Extensible Tendrils': 'Cep extensible',
      'Blossom': 'Floraison',
      'Arbor Storm': 'Tempête de charmilles',
      'Aquatic Lance': 'Lance aquatique',
      'Carcharian Verve': 'Verve carcharienne'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'morbol marquis': 'マーカス・モルボル',
      'Evil Armor': 'イビルアーマー',
      'Quetzalcoatl': 'ケツァクウァトル',
      'Doliodus': 'ドリオドゥス',
      'Cladoselache': 'クラドセラケ',
      'Ichthyology': '水棲生物創造場',
      'Phytobiology': '草木生物創造場',
      'Phantomology': '幻想生物創造場'
    },
    'replaceText': {
      'Winding Current': 'ループカレント',
      'Tidal Guillotine': 'タイダルギロチン',
      'Thunderstorm': 'サンダーストーム',
      'Thunderbolt': 'サンダーボルト',
      'Shocking Plumage': 'ショッキング・プルーミッジ',
      'Shockbolt': 'ショックボルト',
      'Sap Shower': 'サップシャワー',
      'Reverse Current': 'リバースカレント',
      'Putrid Breath': '忌まわしい嘆息',
      'Protolithic Puncture': 'プロトリシックパンクチャー',
      'Pelagic Cleaver': 'ペラジッククリーヴ',
      'Marine Mayhem': 'マリーンメイヘム',
      'Lash': 'ムチ打ち',
      'Extensible Tendrils': 'つるのムチ',
      'Blossom': 'ブロッサム',
      'Arbor Storm': 'アーバーストーム',
      'Aquatic Lance': 'アクアランス',
      'Carcharian Verve': 'カルカリアンヴァーヴ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Morbol Marquis': '侯爵魔界花',
      'Evil Armor': '恶魔装甲',
      'Quetzalcoatl': '克察尔科亚特尔',
      'Doliodus': '原祖鲨',
      'Cladoselache': '裂口鲨',
      'Ichthyology': '水生生物创造场',
      'Phytobiology': '草木生物创造场',
      'Phantomology': '幻想生物创造场'
    },
    'replaceText': {
      'Winding Current': '绕组电流',
      'Tidal Guillotine': '怒潮断头台',
      'Thunderstorm': '雷暴',
      'Thunderbolt': '霹雳',
      'Shocking Plumage': '羽翼震击',
      'Shockbolt': '雷电震击',
      'Sap Shower': '喷洒汁液',
      'Reverse Current': '反转电流',
      'Putrid Breath': '腐烂之息',
      'Protolithic Puncture': '原始穿孔',
      'Pelagic Cleaver': '深海切割者',
      'Marine Mayhem': '海之骚动',
      'Lash': '鞭打',
      'Extensible Tendrils': '藤条抽打',
      'Blossom': '花丛',
      'Arbor Storm': '树木风暴',
      'Aquatic Lance': '水之枪',
      'Carcharian Verve': '鲨之气魄'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Morbol Marquis': '몰볼 후작',
      'Evil Armor': '사악한 갑옷',
      'Quetzalcoatl': '케찰코아틀',
      'Doliodus': '돌리오두스',
      'Cladoselache': '클라도셀라케',
      'Ichthyology': '수생 생물 창조장',
      'Phytobiology': '초목 생물 창조장',
      'Phantomology': '환상 생물 창조장'
    },
    'replaceText': {
      'Winding Current': '원형전류',
      'Tidal Guillotine': '해일 단두대',
      'Thunderstorm': '번개 폭풍',
      'Thunderbolt': '낙뢰',
      'Shocking Plumage': '충격 깃털',
      'Shockbolt': '충격 전류',
      'Sap Shower': '수액 세례',
      'Reverse Current': '역전류',
      'Putrid Breath': '불길한 탄식',
      'Protolithic Puncture': '원시 찌르기',
      'Pelagic Cleaver': '대양의 도끼날',
      'Marine Mayhem': '바다의 파괴력',
      'Lash': '채찍',
      'Extensible Tendrils': '덩굴 채찍',
      'Blossom': '개화',
      'Arbor Storm': '나무 폭풍',
      'Aquatic Lance': '수창',
      'Carcharian Verve': '상어의 기백'
    }
  }]
};
/* harmony default export */ const akadaemia_anyder = (akadaemia_anyder_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/akadaemia_anyder.txt
const dungeon_akadaemia_anyder_namespaceObject = "### Akadaemia Anyder\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Cladoselache, Doliodus\r\n# -p 3E04:110.5 3E07:302\r\n# helpful log regex: ( 22:.*(Cladoselache|Doliodus)| 14:[^:]*:(Cladoselache|Doliodus)| 1[56]:........:(Cladoselache|Doliodus):(?!368:)|sealed| 19:(Cladoselache|Doliodus) was defeated)\r\n# Note: this is a little messy as the \"jumping in\" skills, i.e. 3E09/3E05, seem\r\n# to have a little bit of leeway on them as the bosses might swim around more.\r\n# This is maybe like +/- 1-2 seconds?\r\n\r\n# Ichthyology will be sealed off\r\n100.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"BC0\" } window 100,0\r\n110.5 \"Protolithic Puncture\" Ability { id: \"3E04\", source: \"Cladoselache\" } window 111,8\r\n119.5 \"Tidal Guillotine\" Ability { id: \"3E08\", source: \"Cladoselache\" }\r\n128.7 \"--2x targetable--\" NameToggle { name: \"Doliodus\", toggle: \"01\" }\r\n129.7 \"--1x targetable--\" NameToggle { name: \"Cladoselache\", toggle: \"00\" }\r\n\r\n138.5 \"Pelagic Cleaver\" Ability { id: \"3E09\", source: \"Doliodus\" }\r\n150.5 \"Tidal Guillotine\" Ability { id: \"3E0A\", source: \"Cladoselache\" } window 10,10\r\n152.7 \"--2x targetable--\" NameToggle { name: \"Cladoselache\", toggle: \"01\" }\r\n154.7 \"--1x targetable--\" NameToggle { name: \"Doliodus\", toggle: \"00\" }\r\n\r\n162.4 \"Aquatic Lance\" Ability { id: \"3E05\", source: \"Cladoselache\" }\r\n173.5 \"Protolithic Puncture\" Ability { id: \"3E04\", source: \"Cladoselache\" }\r\n179.9 \"Pelagic Cleaver\" Ability { id: \"3E0B\", source: \"Doliodus\" } window 10,10\r\n181.5 \"--untargetable--\" NameToggle { name: \"Cladoselache\", toggle: \"00\" }\r\n183.3 \"--targetable--\" NameToggle { name: \"Doliodus\", toggle: \"01\" }\r\n\r\n189.4 \"Marine Mayhem\" Ability { id: \"3E06\", source: \"Doliodus\" }\r\n199.8 \"Protolithic Puncture\" Ability { id: \"3E04\", source: \"Doliodus\" }\r\n201.4 \"Tidal Guillotine\" Ability { id: \"3E0A\", source: \"Cladoselache\" } window 10,10\r\n203.8 \"--2x targetable--\" NameToggle { name: \"Cladoselache\", toggle: \"01\" }\r\n205.1 \"--1x targetable--\" NameToggle { name: \"Doliodus\", toggle: \"00\" }\r\n\r\n213.2 \"Aquatic Lance\" Ability { id: \"3E05\", source: \"Cladoselache\" } window 30,30 jump 162.4\r\n224.3 \"Protolithic Puncture\"\r\n230.7 \"Pelagic Cleaver\"\r\n232.3 \"--untargetable--\"\r\n234.1 \"--targetable--\"\r\n\r\n240.2 \"Marine Mayhem\"\r\n250.6 \"Protolithic Puncture\"\r\n252.2 \"Tidal Guillotine\"\r\n254.6 \"--2x targetable--\"\r\n255.9 \"--1x targetable--\"\r\n\r\n# When one dies, the other powers up and starts casting stuff after it jumps back in.\r\n# However, I've never seen this cast get off, so just guessing on Marine Mayhem cast length.\r\n300.0 \"--sync--\" StartsUsing { id: \"3E07\", source: [\"Doliodus\", \"Cladoselache\"] } window 300,0\r\n302.0 \"Carcharian Verve\" Ability { id: \"3E07\", source: [\"Doliodus\", \"Cladoselache\"] } window 300,0\r\n305.5 \"Marine Mayhem\" Ability { id: \"3E06\", source: [\"Doliodus\", \"Cladoselache\"] }\r\n\r\n\r\n\r\n### Morbol Marquis\r\n# -p 3E16:508.5 -ii 3E11 3E14\r\n# Phytobiology will be sealed off\r\n500.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"BC1\" } window 500,0\r\n505.0 \"--sync--\" Ability { id: \"3E14\", source: \"Morbol Marquis\" } window 505,5\r\n508.5 \"Lash\" Ability { id: \"3E16\", source: \"Morbol Marquis\" }\r\n516.1 \"Sap Shower\" Ability { id: \"3E15\", source: \"Morbol Marquis\" }\r\n524.7 \"Arbor Storm\" Ability { id: \"3E17\", source: \"Morbol Marquis\" }\r\n\r\n# extensible tendrils appears to have some variation on start time\r\n532.3 \"--sync--\" StartsUsing { id: \"3E10\", source: \"Morbol Marquis\" } window 30,10\r\n537.3 \"Extensible Tendrils\" Ability { id: \"3E10\", source: \"Morbol Marquis\" } duration 25\r\n564.7 \"Putrid Breath\" Ability { id: \"3E12\", source: \"Morbol Marquis\" }\r\n569.0 \"Lash\" #Ability { id: \"3E16\", source: \"Morbol Marquis\" }\r\n575.0 \"Lash\" #Ability { id: \"3E16\", source: \"Morbol Marquis\" }\r\n581.1 \"Blossom\" Ability { id: \"3E13\", source: \"Morbol Marquis\" }\r\n589.7 \"Arbor Storm\" Ability { id: \"3E17\", source: \"Morbol Marquis\" }\r\n\r\n598.3 \"--sync--\" StartsUsing { id: \"3E10\", source: \"Morbol Marquis\" } window 10,10\r\n603.3 \"Extensible Tendrils\" Ability { id: \"3E10\", source: \"Morbol Marquis\" } duration 25\r\n611.4 \"Sap Shower\" Ability { id: \"3E15\", source: \"Morbol Marquis\" }\r\n630.8 \"Putrid Breath\" Ability { id: \"3E12\", source: \"Morbol Marquis\" }\r\n634.2 \"Lash\" Ability { id: \"3E16\", source: \"Morbol Marquis\" }\r\n646.6 \"Blossom\" Ability { id: \"3E13\", source: \"Morbol Marquis\" }\r\n653.3 \"Sap Shower\" Ability { id: \"3E15\", source: \"Morbol Marquis\" }\r\n657.1 \"Lash\" Ability { id: \"3E16\", source: \"Morbol Marquis\" }\r\n\r\n660.3 \"--sync--\" StartsUsing { id: \"3E10\", source: \"Morbol Marquis\" } window 10,10\r\n665.3 \"Extensible Tendrils\" Ability { id: \"3E10\", source: \"Morbol Marquis\" }\r\n692.6 \"Putrid Breath\" Ability { id: \"3E12\", source: \"Morbol Marquis\" }\r\n699.0 \"Arbor Storm\" Ability { id: \"3E17\", source: \"Morbol Marquis\" }\r\n707.6 \"Blossom\" Ability { id: \"3E13\", source: \"Morbol Marquis\" }\r\n716.1 \"Arbor Storm\" Ability { id: \"3E17\", source: \"Morbol Marquis\" }\r\n\r\n724.8 \"--sync--\" StartsUsing { id: \"3E10\", source: \"Morbol Marquis\" } window 10,10\r\n729.8 \"Extensible Tendrils\" Ability { id: \"3E10\", source: \"Morbol Marquis\" } duration 25\r\n737.9 \"Sap Shower\" Ability { id: \"3E15\", source: \"Morbol Marquis\" }\r\n757.3 \"Putrid Breath\" Ability { id: \"3E12\", source: \"Morbol Marquis\" }\r\n760.7 \"Lash\" Ability { id: \"3E16\", source: \"Morbol Marquis\" }\r\n773.1 \"Blossom\" Ability { id: \"3E13\", source: \"Morbol Marquis\" } window 50,50 jump 646.6\r\n779.8 \"Sap Shower\"\r\n783.6 \"Lash\"\r\n\r\n786.8 \"--sync--\"\r\n791.8 \"Extensible Tendrils\"\r\n819.1 \"Putrid Breath\"\r\n825.5 \"Arbor Storm\"\r\n834.1 \"Blossom\"\r\n842.6 \"Arbor Storm\"\r\n\r\n\r\n### Quetzalcoatl\r\n# -ii 3E1A 3E1B 3E22 3E20 -p 3E23:1008.2\r\n# Phantomology will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"BC2\" } window 1000,0\r\n1008.2 \"Shockbolt\" Ability { id: \"3E23\", source: \"Quetzalcoatl\" } window 1010,5\r\n1017.9 \"Thunderbolt\" Ability { id: \"3E24\", source: \"Quetzalcoatl\" }\r\n1031.4 \"Thunderstorm\" Ability { id: \"3E1C\", source: \"Quetzalcoatl\" }\r\n1045.2 \"Shocking Plumage\" Ability { id: \"3E21\", source: \"Quetzalcoatl\" }\r\n1057.5 \"Thunderstorm\" Ability { id: \"3E1C\", source: \"Quetzalcoatl\" }\r\n\r\n1067.6 \"Reverse Current\" Ability { id: \"3E1E\", source: \"Quetzalcoatl\" }\r\n1085.0 \"Winding Current\" Ability { id: \"3E1F\", source: \"Quetzalcoatl\" }\r\n1099.2 \"Thunderstorm\" Ability { id: \"3E1C\", source: \"Quetzalcoatl\" }\r\n1107.0 \"Shocking Plumage\" Ability { id: \"3E21\", source: \"Quetzalcoatl\" }\r\n1113.5 \"Shockbolt\" Ability { id: \"3E23\", source: \"Quetzalcoatl\" }\r\n1122.1 \"Thunderbolt\" Ability { id: \"3E24\", source: \"Quetzalcoatl\" }\r\n1131.5 \"Thunderstorm\" Ability { id: \"3E1C\", source: \"Quetzalcoatl\" }\r\n1140.3 \"Shocking Plumage\" Ability { id: \"3E21\", source: \"Quetzalcoatl\" }\r\n1148.8 \"Shocking Plumage\" Ability { id: \"3E21\", source: \"Quetzalcoatl\" }\r\n1155.2 \"Thunderbolt\" Ability { id: \"3E24\", source: \"Quetzalcoatl\" }\r\n\r\n1163.6 \"Reverse Current\" Ability { id: \"3E1E\", source: \"Quetzalcoatl\" } window 50,50 jump 1067.6\r\n1181.0 \"Winding Current\"\r\n1195.2 \"Thunderstorm\"\r\n1203.0 \"Shocking Plumage\"\r\n1209.5 \"Shockbolt\"\r\n1218.1 \"Thunderbolt\"\r\n1227.5 \"Thunderstorm\"\r\n1236.3 \"Shocking Plumage\"\r\n1244.8 \"Shocking Plumage\"\r\n1251.2 \"Thunderbolt\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/amaurot.ts



const amaurot_triggerSet = {
  id: 'Amaurot',
  zoneId: zone_id/* default.Amaurot */.Z.Amaurot,
  timelineFile: 'amaurot.txt',
  triggers: [{
    id: 'Amaurot Meteor',
    type: 'HeadMarker',
    netRegex: {
      id: '0039'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: data => data.meteor = (data.meteor ?? 0) + 1,
    infoText: (data, _matches, output) => {
      if (data.meteor === 1) return output.dropMeteorWest();else if (data.meteor === 2) return output.dropMeteorEast();
      return output.meteor();
    },
    outputStrings: {
      dropMeteorWest: {
        en: 'Drop Meteor West',
        de: 'Meteor im Westen ablegen',
        fr: 'Déposez le météore à l\'ouest',
        ja: 'メテオを西に',
        cn: '西侧放陨石',
        ko: '메테오 서쪽으로 빼기'
      },
      dropMeteorEast: {
        en: 'Drop Meteor East',
        de: 'Meteor im Osten ablegen',
        fr: 'Déposez le météore à l\'est',
        ja: 'メテオを東に',
        cn: '陨石放东边',
        ko: '메테오 동쪽으로 빼기'
      },
      meteor: {
        en: 'Meteor',
        de: 'Meteor',
        fr: 'Météore',
        ja: 'メテオ',
        cn: '陨石',
        ko: '메테오'
      }
    }
  }, {
    id: 'Amaurot Spread',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Amaurot Final Sky',
    type: 'StartsUsing',
    netRegex: {
      id: '3CCB',
      source: 'The First Beast',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Boulder',
        de: 'Hinter einem Felsen verstecken',
        fr: 'Cachez-vous derrière un rocher',
        ja: '隕石の後ろに',
        cn: '躲在岩石后',
        ko: '바위 뒤에 숨기'
      }
    }
  }, {
    id: 'Amaurot Shadow Wreck',
    type: 'StartsUsing',
    netRegex: {
      id: '3CE3',
      source: 'Therion',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Amaurot Apokalypsis',
    type: 'StartsUsing',
    netRegex: {
      id: '3CD7',
      source: 'Therion',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Off',
        de: 'Runter gehen',
        fr: 'Descendez',
        ja: '横へ',
        cn: '站左右小平台',
        ko: '바깥으로 피하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'The First Beast': '(?:der|die|das) erst(?:e|er|es|en) Unheil',
      'The Face of the Beast': 'Antlitz des Boten',
      'Fallen Star': 'Komet',
      'Therion': 'Therion',
      'Terminus Roiler': 'Terminus-Trüber',
      'Terminus Pursuer': 'Terminus-Verfolger',
      'Terminus Bellwether': 'Läuter der Totenglocke',
      'The First Doom': 'Ersten Unheil',
      'The Second Doom': 'Zweiten Unheil',
      'The Third Doom': 'Dritten Unheil'
    },
    'replaceText': {
      'Adds': 'Adds',
      'The Final Sky': 'Letzter Himmel',
      'The Falling Sky': 'Unheilvoller Himmel',
      'The Burning Sky': 'Brennender Himmel',
      'Venomous Breath': 'Giftatem',
      'Therion Charge': 'Therions Rage',
      'Shrill Shriek': 'Schriller Schrei',
      'Shadow Wreck': 'Schatten des Unheils',
      'Misfortune': 'Unglück',
      'Meteor Rain': 'Meteorschauer',
      'Earthquake': 'Erdbeben',
      'Deathly Ray': 'Tödlicher Strahl',
      'Cosmic Shrapnel': 'Kosmos-Splitter',
      'Cosmic Kiss': 'Einschlag',
      'Burst': 'Explosion',
      'Apokalypsis': 'Apokalypse'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'The First Beast': 'Annélide de l\'apocalypse',
      'The Face of the Beast': 'Visages de la Bête',
      'Fallen Star': 'Étoile',
      'Therion': 'Mégatherion',
      'Terminus Roiler': 'Nébulosité de l\'apocalypse',
      'Terminus Pursuer': 'Poursuivant de l\'apocalypse',
      'Terminus Bellwether': 'Sonneur de glas de l\'apocalypse',
      'The First Doom': 'La première Calamité',
      'The Second Doom': 'La deuxième Calamité',
      'The Third Doom': 'La troisième Calamité'
    },
    'replaceText': {
      'The Final Sky': 'Étoile de la ruine',
      'The Falling Sky': 'Étoile de la calamité',
      'The Burning Sky': 'Étoile du désastre',
      'Venomous Breath': 'Souffle venimeux',
      'Therion Charge': 'Charge de therion',
      'Shrill Shriek': 'Cri perçant',
      'Shadow Wreck': 'Calamité sombre',
      'Misfortune': 'Infortune',
      'Meteor Rain': 'Pluie d\'étoiles',
      'Earthquake': 'Tremblement de terre',
      'Deathly Ray': 'Rayon létal',
      'Cosmic Shrapnel': 'Éclatement',
      'Cosmic Kiss': 'Impact',
      'Burst': 'Explosion',
      'Apokalypsis': 'Apokalypsis',
      'Adds': 'Adds'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'The First Beast': 'ファースト・ビースト',
      'The Face of the Beast': 'フェイス・オブ・ビースト',
      'Fallen Star': '流星',
      'Therion': 'メガセリオン',
      'Terminus Roiler': 'ターミナス・ロイラー',
      'Terminus Pursuer': 'ターミナス・パースアー',
      'Terminus Bellwether': 'ターミナス・ベルウェザー',
      'The First Doom': '第一の災い',
      'The Second Doom': '第二の災い',
      'The Third Doom': '第三の災い'
    },
    'replaceText': {
      'Adds': '雑魚',
      'The Final Sky': '終末の流星',
      'The Falling Sky': '厄災の流星',
      'The Burning Sky': '変災の流星',
      'Venomous Breath': 'ベノムブレス',
      'Therion Charge': 'セリオンチャージ',
      'Shrill Shriek': '絶叫',
      'Shadow Wreck': 'シャドウレック',
      'Misfortune': 'ミスフォーチュン',
      'Meteor Rain': '流星群',
      'Earthquake': '地震',
      'Deathly Ray': 'デスリ―レイ',
      'Cosmic Shrapnel': '飛散',
      'Cosmic Kiss': '着弾',
      'Burst': '爆発',
      'Apokalypsis': 'アポカリュプシス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'The First Beast': '第一之兽',
      'The Face of the Beast': '灾兽之面',
      'Fallen Star': '流星',
      'Therion': '至大灾兽',
      'Terminus Roiler': '终末的动荡',
      'Terminus Pursuer': '终末的追捕',
      'Terminus Bellwether': '终末的指引',
      'The First Doom': '第一之灾难',
      'The Second Doom': '第二之灾难',
      'The Third Doom': '第三之灾难'
    },
    'replaceText': {
      'Adds': '小怪',
      'The Final Sky': '末日流星',
      'The Falling Sky': '灾厄流星',
      'The Burning Sky': '灾变流星',
      'Venomous Breath': '毒气吐息',
      'Therion Charge': '灾兽冲锋',
      'Shrill Shriek': '绝叫',
      'Shadow Wreck': '暗影毁灭',
      'Misfortune': '厄难',
      'Meteor Rain': '流星群',
      'Earthquake': '地震',
      'Deathly Ray': '灭亡射线',
      'Cosmic Shrapnel': '飞散',
      'Cosmic Kiss': '流星坠落',
      'Burst': '大爆炸',
      'Apokalypsis': '启示录'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'The First Beast': '최초의 야수',
      'The Face of the Beast': '야수의 얼굴',
      'Fallen Star': '별똥별',
      'Therion': '메가테리온',
      'Terminus Roiler': '종말의 교란자',
      'Terminus Pursuer': '종말의 추격자',
      'Terminus Bellwether': '종말의 선도자',
      'The First Doom': '첫 번째 재앙',
      'The Second Doom': '두 번째 재앙',
      'The Third Doom': '세 번째 재앙'
    },
    'replaceText': {
      'Adds': '쫄들',
      'The Final Sky': '종말의 유성',
      'The Falling Sky': '재앙의 유성',
      'The Burning Sky': '변재의 유성',
      'Venomous Breath': '독 숨결',
      'Therion Charge': '테리온 돌격',
      'Shrill Shriek': '절규',
      'Shadow Wreck': '그림자 파멸',
      'Misfortune': '불운',
      'Meteor Rain': '유성군',
      'Earthquake': '지진',
      'Deathly Ray': '죽음 광선',
      'Cosmic Shrapnel': '산산조각',
      'Cosmic Kiss': '착탄',
      'Burst': '대폭발',
      'Apokalypsis': '묵시록'
    }
  }]
};
/* harmony default export */ const amaurot = (amaurot_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/amaurot.txt
const dungeon_amaurot_namespaceObject = "### Amaurot\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### The First Beast\r\n# -p 3CCE:113.5 -ii 3CC6 3CCA 3CC8\r\n\r\n# The First Doom will be sealed off\r\n100.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"C8B\" } window 100,0\r\n113.5 \"Venomous Breath\" Ability { id: \"3CCE\", source: \"The First Beast\" } window 114,9\r\n122.7 \"Meteor Rain\" Ability { id: \"3CC4\", source: \"The First Beast\" }\r\n132.9 \"The Falling Sky\" Ability { id: \"3CC9\", source: \"The First Beast\" }\r\n136.3 \"Cosmic Kiss\" Ability { id: \"42D4\", source: \"Fallen Star\" }\r\n151.6 \"The Final Sky\" Ability { id: \"3CCB\", source: \"The First Beast\" }\r\n\r\n153.0 \"Cosmic Shrapnel\" Ability { id: \"42D6\", source: \"Fallen Star\" }\r\n171.0 \"Venomous Breath\" Ability { id: \"3CCE\", source: \"The First Beast\" }\r\n181.2 \"Earthquake\" Ability { id: \"3CCD\", source: \"The First Beast\" }\r\n190.4 \"Venomous Breath\" Ability { id: \"3CCE\", source: \"The First Beast\" }\r\n200.8 \"Meteor Rain\" Ability { id: \"3CC4\", source: \"The First Beast\" }\r\n211.1 \"The Falling Sky\" Ability { id: \"3CC9\", source: \"The First Beast\" }\r\n214.5 \"Cosmic Kiss\" Ability { id: \"42D4\", source: \"Fallen Star\" }\r\n220.5 \"The Burning Sky\" Ability { id: \"3CC7\", source: \"The First Beast\" }\r\n239.0 \"The Final Sky\" Ability { id: \"3CCB\", source: \"The First Beast\" }\r\n\r\n240.4 \"Cosmic Shrapnel\" Ability { id: \"42D6\", source: \"Fallen Star\" } window 30,30 jump 153\r\n258.4 \"Venomous Breath\"\r\n268.6 \"Earthquake\"\r\n277.8 \"Venomous Breath\"\r\n288.2 \"Meteor Rain\"\r\n298.5 \"The Falling Sky\"\r\n301.9 \"Cosmic Kiss\"\r\n307.9 \"The Burning Sky\"\r\n326.4 \"The Final Sky\"\r\n\r\n\r\n### Terminus Bellwether\r\n# -p 3CCF:523 -ii 465D 3CE4 3CD3 3CD2 3CD5 417D\r\n# The Second Doom will be sealed off\r\n500.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"C8C\" } window 500,0\r\n523.0 \"Shrill Shriek\" Ability { id: \"3CCF\", source: \"Terminus Bellwether\" } window 523,5\r\n525.0 \"--untargetable--\"\r\n525.0 \"Adds (N)\"\r\n561.3 \"Adds (SW)\" AddedCombatant { name: \"Terminus Roiler\" } window 60,60\r\n610.9 \"Adds (S)\" AddedCombatant { name: \"Terminus Pursuer\" } window 100,100\r\n800.0 \"--sync--\" StartsUsing { id: \"3CD0\", source: \"Terminus Bellwether\" } window 300,00\r\n840.0 \"Burst\" Ability { id: \"3CD0\", source: \"Terminus Bellwether\" } window 40,40\r\n\r\n\r\n### Therion\r\n# -ii 3CD6 3CDD 3CD9 3CDE 3CE1 3CDB 4191 4192 -p 3CE3:1013\r\n# The Third Doom will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"C8D\" } window 1000,0\r\n1013.0 \"Shadow Wreck\" Ability { id: \"3CE3\", source: \"Therion\" } window 1013,10\r\n1026.2 \"Apokalypsis\" Ability { id: \"3CD7\", source: \"Therion\" } duration 5.9\r\n1042.8 \"Therion Charge\" Ability { id: \"3CDA\", source: \"Therion\" }\r\n1051.1 \"Shadow Wreck\" Ability { id: \"3CE3\", source: \"Therion\" }\r\n1060.0 \"Deathly Ray\" Ability { id: \"3CDC\", source: \"The Face of the Beast\" } duration 4.4\r\n1068.9 \"Deathly Ray\" Ability { id: \"3CDC\", source: \"The Face of the Beast\" } duration 4.4\r\n1081.6 \"Shadow Wreck\" Ability { id: \"3CE3\", source: \"Therion\" }\r\n1091.5 \"Deathly Ray\" Ability { id: \"3CDF\", source: \"Therion\" } duration 4.3\r\n1096.5 \"--sync--\" Ability { id: \"42D3\", source: \"Therion\" }\r\n1099.2 \"Misfortune\" Ability { id: \"3CE2\", source: \"Therion\" }\r\n1100.2 \"Deathly Ray\" Ability { id: \"3CDF\", source: \"Therion\" } duration 4.3\r\n1105.3 \"--sync--\" Ability { id: \"42D3\", source: \"Therion\" }\r\n1115.1 \"Apokalypsis\" Ability { id: \"3CD7\", source: \"Therion\" } duration 5.9\r\n1131.7 \"Therion Charge\" Ability { id: \"3CDA\", source: \"Therion\" }\r\n1140.0 \"Shadow Wreck\" Ability { id: \"3CE3\", source: \"Therion\" }\r\n\r\n1148.8 \"Deathly Ray\" Ability { id: \"3CDC\", source: \"The Face of the Beast\" } duration 4.4\r\n1156.6 \"Misfortune\" Ability { id: \"3CE2\", source: \"Therion\" }\r\n1157.6 \"Deathly Ray\" Ability { id: \"3CDC\", source: \"The Face of the Beast\" } duration 4.4\r\n1170.3 \"Shadow Wreck\" Ability { id: \"3CE3\", source: \"Therion\" }\r\n1180.2 \"Deathly Ray\" Ability { id: \"3CDF\", source: \"Therion\" } duration 4.3\r\n1185.2 \"--sync--\" Ability { id: \"42D3\", source: \"Therion\" }\r\n1188.0 \"Misfortune\" Ability { id: \"3CE2\", source: \"Therion\" }\r\n1188.8 \"Deathly Ray\" Ability { id: \"3CDF\", source: \"Therion\" } duration 4.3\r\n1193.9 \"--sync--\" Ability { id: \"42D3\", source: \"Therion\" }\r\n1202.5 \"Shadow Wreck\" Ability { id: \"3CE3\", source: \"Therion\" }\r\n1213.7 \"Apokalypsis\" Ability { id: \"3CD7\", source: \"Therion\" } duration 5.9\r\n\r\n1230.7 \"Deathly Ray\" Ability { id: \"3CDC\", source: \"The Face of the Beast\" } duration 4.4 window 50,50 jump 1148.8\r\n1238.5 \"Misfortune\"\r\n1239.5 \"Deathly Ray\"\r\n1252.2 \"Shadow Wreck\"\r\n1262.1 \"Deathly Ray\"\r\n1267.1 \"--sync--\"\r\n1269.9 \"Misfortune\"\r\n1270.7 \"Deathly Ray\"\r\n1275.8 \"--sync--\"\r\n1284.4 \"Shadow Wreck\"\r\n1295.6 \"Apokalypsis\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/anamnesis_anyder.ts



const anamnesis_anyder_triggerSet = {
  id: 'AnamnesisAnyder',
  zoneId: zone_id/* default.AnamnesisAnyder */.Z.AnamnesisAnyder,
  timelineFile: 'anamnesis_anyder.txt',
  triggers: [{
    id: 'AnAnyder Fetid Fang',
    type: 'StartsUsing',
    netRegex: {
      source: 'Unknown',
      id: ['4B69', '4B72']
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AnAnyder Scrutiny',
    type: 'StartsUsing',
    netRegex: {
      source: 'Unknown',
      id: '4E25',
      capture: false
    },
    delaySeconds: 3,
    durationSeconds: 7,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Arrow',
        de: 'Pfeil ausweichen',
        fr: 'Évitez la flèche',
        ja: '矢印を避ける',
        cn: '躲箭头',
        ko: '화살표 피하기'
      }
    }
  }, {
    id: 'AnAnyder Inscrutability',
    type: 'StartsUsing',
    netRegex: {
      source: 'Unknown',
      id: '4B6A',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'AnAnyder Luminous Ray',
    type: 'StartsUsing',
    netRegex: {
      source: 'Unknown',
      id: '4E2[67]',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'AnAnyder The Final Verse',
    type: 'StartsUsing',
    netRegex: {
      source: 'Kyklops',
      id: '4B58',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'AnAnyder 2,000-Mina Swing',
    type: 'StartsUsing',
    netRegex: {
      source: 'Kyklops',
      id: '4B55',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'AnAnyder Eye Of The Cyclone',
    type: 'StartsUsing',
    netRegex: {
      source: 'Kyklops',
      id: '4B57',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'AnAnyder 2,000-Mina Swipe',
    type: 'StartsUsing',
    netRegex: {
      source: 'Kyklops',
      id: '4B54',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'AnAnyder Raging Glower',
    type: 'StartsUsing',
    netRegex: {
      source: 'Kyklops',
      id: '4B56',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'AnAnyder Open Hearth Flying Fount',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'AnAnyder Bonebreaker',
    type: 'StartsUsing',
    netRegex: {
      source: 'Rukshs Dheem',
      id: '4B8C'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AnAnyder Falling Water',
    type: 'StartsUsing',
    netRegex: {
      source: 'Rukshs Dheem',
      id: '4B7E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'AnAnyder Depth Grip',
    type: 'StartsUsing',
    netRegex: {
      source: 'Rukshs Dheem',
      id: '4B84',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Hands',
        de: 'Händen ausweichen',
        fr: 'Évitez les mains',
        ja: '手を避ける',
        cn: '躲手',
        ko: '손 피하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Sinister Bubble': 'Finster(?:e|er|es|en) Blase',
      'Rukshs Dheem': 'Rukshs Dheem',
      'Unknown': 'Abscheulich(?:e|er|es|en) Monstrum',
      'Kyklops': 'Kyklops',
      'Depth Grip': 'Hand des Ozeans',
      'Katharsis': 'Platz der Katharsis',
      'Doxa': 'Platz der Doxa',
      'Noesis': 'Noesis'
    },
    'replaceText': {
      'The Final Verse': 'Schreckensvers',
      'Wavebreaker': 'Wellenbrecher',
      'Terrible Hammer/Blade': 'Schreckenshammer/klinge',
      'Terrible Blade/Hammer': 'Schreckensklinge/Hammer',
      'Swift Shift': 'Schneller Wechsel',
      'Setback': 'Rücksetzer',
      'Seabed Ceremony': 'Riffsturmzeremonie',
      'Scrutiny': 'Überwachung',
      'Rising Tide': 'Steigende Flut',
      'Raging Glower': 'Wütender Blick',
      'Plain Weirdness': 'Unbekanntes Prinzip',
      'Luminous Ray': 'Lumineszenzstrahl',
      'Inscrutability': 'Unidentifizierbar',
      'Flying Fount': 'Spritzige Fontäne',
      'Fetid Fang': 'Kontaminierte Klaue',
      'Falling Water': 'Fallendes Wasser',
      'Explosion': 'Explosion',
      'Ectoplasmic Ray': 'Ektoplasmastrahl',
      'Depth Grip': 'Hand des Ozeans',
      'Command Current': 'Flutenruf',
      'Clearout': 'Kreisfeger',
      'Bonebreaker': 'Knochenbrecher',
      'Swing/Swipe/Cyclone': 'Hiebe/Schwung/Zyklons',
      'Hammer/Blade Mark': 'Hammer/Klingenmarkierung',
      'Blade/Hammer Mark': 'Klinge/Hammermarkierung',
      'Pyre/Hearth': 'Schreckensstachel/flammen',
      'Unknown Add': 'Unbekanntes Add'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Depth Grip': 'Emprise Des Profondeurs',
      'Doxa': 'la Doxa',
      'Katharsis': 'la Catharsis',
      'Kyklops': 'Kyklops',
      'Noesis': 'la Noesis',
      'Sinister Bubble': 'Bulle sinistre',
      'Rukshs Dheem': 'Rukshs Dheem',
      'Unknown': 'Inconnu'
    },
    'replaceText': {
      'The Final Verse': 'Le chapitre final',
      'Wavebreaker': 'Brise-vague',
      'Unknown Add': 'Add Inconnu',
      'Terrible Hammer/Blade': 'Marteau/Lame terrifiante',
      'Terrible Blade/Hammer': 'Lame/Marteau terrifiant',
      'Swing/Swipe/Cyclone': 'Swing/Fauche/Cyclone',
      'Swift Shift': 'Déplacement soudain',
      'Setback': 'Revers',
      'Seabed Ceremony': 'Cérémonie abyssale',
      'Scrutiny': 'Observation',
      'Rising Tide': 'Marée montante',
      'Raging Glower': 'Regard enragé',
      'Pyre/Hearth': 'Explosion/Flamme',
      'Plain Weirdness': 'Principe inconnu',
      'Luminous Ray': 'Rayon lumineux',
      'Inscrutability': 'Signification inconnue',
      'Hammer/Blade Mark': 'Marque Marteau/Lame',
      'Flying Fount': 'Cascade',
      'Fetid Fang': 'Croc contaminé',
      'Falling Water': 'Chute d\'eau',
      'Explosion': 'Explosion',
      'Ectoplasmic Ray': 'Rayon ectoplasmique',
      'Depth Grip': 'Emprise des profondeurs',
      'Command Current': 'Eau courante',
      'Clearout': 'Fauchage',
      'Bonebreaker': 'Brise-os',
      'Blade/Hammer Mark': 'Marque Lame/Marteau'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Depth Grip': 'ハンド・オブ・オーシャン',
      'Doxa': 'ドクサの広間',
      'Katharsis': 'カタルシスの広場',
      'Kyklops': 'クリュプス',
      'Noesis': 'ノエシスの間',
      'Rukshs Dheem': 'ルクスィー・ディーマ',
      'Sinister Bubble': '不気味な泡',
      'Unknown': '正体不明'
    },
    'replaceText': {
      'The Final Verse': '恐怖の最終章',
      'Wavebreaker': 'ウェーブブレイク',
      'Unknown Add': '雑魚：正体不明',
      'Terrible Hammer/Blade': '恐怖の戦鎚／恐怖の大剣',
      'Terrible Blade/Hammer': '恐怖の大剣／恐怖の戦鎚',
      'Swing/Swipe/Cyclone': 'スウィング／スワイプ／サイクロン',
      'Swift Shift': '高速移動',
      'Setback': '打ち払い',
      'Seabed Ceremony': '水底の儀式',
      'Scrutiny': '観察',
      'Rising Tide': '上げ潮',
      'Raging Glower': 'レイジング・グラワー',
      'Pyre/Hearth': '恐怖の爆炎／恐怖の火焔',
      'Plain Weirdness': '原理不明',
      'Luminous Ray': 'ルミナスレイ',
      'Inscrutability': '意味不明',
      'Hammer/Blade Mark': 'マーク：戦鎚／大剣',
      'Flying Fount': '飛泉',
      'Fetid Fang': '不快な牙',
      'Falling Water': '落水',
      'Explosion': '爆散',
      'Ectoplasmic Ray': 'エクトプラズミックレイ',
      'Depth Grip': 'ハンド・オブ・オーシャン',
      'Command Current': '流水',
      'Clearout': 'なぎ払い',
      'Bonebreaker': '骨砕き',
      'Blade/Hammer Mark': 'マーク：大剣／戦鎚'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Depth Grip': '海洋之手',
      'Doxa': '信仰大堂',
      'Katharsis': '净化广场',
      'Kyklops': '克琉普斯',
      'Noesis': '概念之间',
      'Rukshs Dheem': '鲁克嘶·蒂母',
      'Sinister Bubble': '怪异泡沫',
      'Unknown': '不明物体'
    },
    'replaceText': {
      'The Final Verse': '恐怖的最终章',
      'Wavebreaker': '水波破',
      'Terrible Hammer/Blade': '恐怖的战锤/恐怖的大剑',
      'Terrible Blade/Hammer': '恐怖的大剑/恐怖的战锤',
      'Swift Shift': '高速移动',
      'Setback': '驱赶',
      'Seabed Ceremony': '水底仪式',
      'Scrutiny': '观察',
      'Rising Tide': '涨潮',
      'Raging Glower': '暴怒注视',
      'Plain Weirdness': '原理不明',
      'Luminous Ray': '光流射线',
      'Inscrutability': '意义不明',
      'Flying Fount': '飞泉',
      'Fetid Fang': '恶臭尖牙',
      'Falling Water': '落水',
      'Explosion': '爆炸',
      'Ectoplasmic Ray': '外质射线',
      'Depth Grip': '海洋之手',
      'Command Current': '流水',
      'Clearout': '横扫',
      'Bonebreaker': '碎骨',
      'Swing/Swipe/Cyclone': '钢铁/横扫/月环',
      'Hammer/Blade Mark': '战锤/大剑标记',
      'Blade/Hammer Mark': '大剑/战锤标记',
      'Pyre/Hearth': '分散/分摊',
      'Unknown Add': '小怪出现'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Depth Grip': '바다의 손',
      'Doxa': '도크사의 방',
      'Katharsis': '카타르시스 광장',
      'Kyklops': '키클롭스',
      'Noesis': '노에시스의 방',
      'Rukshs Dheem': '루크쉬 디마',
      'Sinister Bubble': '불길한 거품',
      'Unknown': '정체불명'
    },
    'replaceText': {
      'The Final Verse': '공포의 최종장',
      'Wavebreaker': '방파제',
      'Terrible Hammer/Blade': '공포의 망치/대검',
      'Terrible Blade/Hammer': '공포의 대검/망치',
      'Swift Shift': '고속 이동',
      'Setback': '후리기',
      'Seabed Ceremony': '해저 의식',
      'Scrutiny': '관찰',
      'Rising Tide': '밀물',
      'Raging Glower': '성난 노려보기',
      'Plain Weirdness': '원리불명',
      'Luminous Ray': '눈부신 광선',
      'Inscrutability': '의미불명',
      'Flying Fount': '샘솟는 물',
      'Fetid Fang': '불쾌한 송곳니',
      'Falling Water': '낙수',
      'Explosion': '폭산',
      'Ectoplasmic Ray': '심령 광선',
      'Depth Grip': '바다손',
      'Command Current': '유수',
      'Clearout': '휩쓸기',
      'Bonebreaker': '뼈 부수기',
      'Swing/Swipe/Cyclone': '휘두르기/후려치기/사이클론의 눈',
      'Hammer/Blade Mark': '망치/대검 징',
      'Blade/Hammer Mark': '대검/망치 징',
      'Pyre/Hearth': '공포의 폭염/화염',
      'Unknown Add': '정체불명 추가'
    }
  }]
};
/* harmony default export */ const anamnesis_anyder = (anamnesis_anyder_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/anamnesis_anyder.txt
const dungeon_anamnesis_anyder_namespaceObject = "### Anamnesis Anyder\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Unknown\r\n# -p 4B69:1013.5 4E4B:1313\r\n# -ii 4B78 4B6D 4B6F\r\n# Katharsis will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"D86\" } window 1000,0\r\n1013.5 \"Fetid Fang\" Ability { id: \"4B69\", source: \"Unknown\" } window 1014,10\r\n1032.3 \"Scrutiny\" Ability { id: \"4E25\", source: \"Unknown\" }\r\n1034.3 \"Explosion\" Ability { id: \"4B6E\", source: \"Sinister Bubble\" }\r\n1042.2 \"Luminous Ray\" Ability { id: \"4E26\", source: \"Unknown\" }\r\n# ???\r\n\r\n# Two Adds (hp push???)\r\n# hopefully there's not an inscrutability cast before the one preceding the add?\r\n1047.4 \"--sync--\" StartsUsing { id: \"4B6A\", source: \"Unknown\" } window 50,0\r\n1051.4 \"Inscrutability\" Ability { id: \"4B6A\", source: \"Unknown\" }\r\n1059.8 \"Unknown Add\" Ability { id: \"4B77\", source: \"Unknown\" } window 60,60\r\n1064.8 \"Ectoplasmic Ray\" Ability { id: \"4B7A\", source: \"Unknown\" }\r\n1072.1 \"Scrutiny\" Ability { id: \"4E25\", source: \"Unknown\" }\r\n1074.1 \"Explosion\" Ability { id: \"4B6E\", source: \"Sinister Bubble\" }\r\n1082.3 \"Luminous Ray\" Ability { id: \"4E27\", source: \"Unknown\" }\r\n1090.9 \"Inscrutability\" Ability { id: \"4B6A\", source: \"Unknown\" }\r\n1100.2 \"Fetid Fang\" Ability { id: \"4B69\", source: \"Unknown\" }\r\n1108.9 \"Clearout\" Ability { id: \"4B74\", source: \"Unknown\" }\r\n1114.9 \"Clearout\" Ability { id: \"4B6B\", source: \"Unknown\" }\r\n1120.1 \"Setback\" Ability { id: \"4B6C\", source: \"Unknown\" }\r\n1126.3 \"--sync--\" Ability { id: \"4B70\", source: \"Unknown\" }\r\n1131.3 \"Ectoplasmic Ray\" Ability { id: \"4B79\", source: \"Unknown\" }\r\n1131.7 \"Ectoplasmic Ray\" Ability { id: \"4B71\", source: \"Unknown\" }\r\n1138.2 \"Luminous Ray\" Ability { id: \"4E27\", source: \"Unknown\" }\r\n1147.8 \"Inscrutability\" Ability { id: \"4B6A\", source: \"Unknown\" }\r\n\r\n1156.9 \"--sync--\" Ability { id: \"4B77\", source: \"Unknown\" } window 50,50 jump 1059.8\r\n1161.9 \"Ectoplasmic Ray\" Ability { id: \"4B7A\", source: \"Unknown\" }\r\n1169.5 \"Scrutiny\" Ability { id: \"4E25\", source: \"Unknown\" }\r\n1171.5 \"Explosion\" Ability { id: \"4B6E\", source: \"Sinister Bubble\" }\r\n1179.3 \"Luminous Ray\" Ability { id: \"4E27\", source: \"Unknown\" }\r\n1187.4 \"Inscrutability\" Ability { id: \"4B6A\", source: \"Unknown\" }\r\n1196.7 \"Fetid Fang\" Ability { id: \"4B69\", source: \"Unknown\" }\r\n1206.0 \"Clearout\" Ability { id: \"4B74\", source: \"Unknown\" }\r\n1212.0 \"Clearout\" Ability { id: \"4B6B\", source: \"Unknown\" }\r\n1217.2 \"Setback\" Ability { id: \"4B6C\", source: \"Unknown\" }\r\n\r\n# One add (???)\r\n# starts 3 second cast 10 seconds after other add dies?\r\n1310.0 \"--sync--\" StartsUsing { id: \"4E4B\", source: \"Unknown\" } window 310,0\r\n1313.0 \"Plain Weirdness\" Ability { id: \"4E4B\", source: \"Unknown\" }\r\n1319.2 \"Inscrutability\" Ability { id: \"4B73\", source: \"Unknown\" }\r\n1329.4 \"--sync--\" Ability { id: \"4B77\", source: \"Unknown\" }\r\n1334.4 \"Ectoplasmic Ray\" Ability { id: \"4B7A\", source: \"Unknown\" }\r\n1342.0 \"Luminous Ray\" Ability { id: \"4E27\", source: \"Unknown\" }\r\n1354.3 \"Fetid Fang\" Ability { id: \"4B72\", source: \"Unknown\" }\r\n1362.5 \"Inscrutability\" Ability { id: \"4B73\", source: \"Unknown\" }\r\n1383.6 \"Scrutiny\" Ability { id: \"4E25\", source: \"Unknown\" }\r\n1385.6 \"Explosion\" Ability { id: \"4B6E\", source: \"Sinister Bubble\" }\r\n1401.5 \"Inscrutability\" Ability { id: \"4B73\", source: \"Unknown\" }\r\n\r\n\r\n\r\n### Kyklops\r\n# -p 4B58:2011\r\n# -ii 4B53 4B5C 4B5B\r\n# Doxa will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"D87\" } window 2000,0\r\n2011.0 \"The Final Verse\" Ability { id: \"4B58\", source: \"Kyklops\" } window 2012,5\r\n2020.6 \"Swing/Swipe/Cyclone\" Ability { id: \"4B5[457]\", source: \"Kyklops\" }\r\n2030.9 \"Hammer/Blade Mark\" Ability { id: \"4B5[9A]\", source: \"Kyklops\" }\r\n2035.5 \"Blade/Hammer Mark\" Ability { id: \"4B5[9A]\", source: \"Kyklops\" }\r\n2044.2 \"Swing/Swipe/Cyclone\" Ability { id: \"4B5[457]\", source: \"Kyklops\" }\r\n2047.9 \"Terrible Hammer/Blade\" #Ability { id: \"4B5[DE]\", source: \"Kyklops\" }\r\n2050.0 \"Terrible Blade/Hammer\" #Ability { id: \"4B5[DE]\", source: \"Kyklops\" }\r\n2054.9 \"Raging Glower\" Ability { id: \"4B56\", source: \"Kyklops\" }\r\n2064.5 \"Swing/Swipe/Cyclone\" Ability { id: \"4B5[457]\", source: \"Kyklops\" }\r\n\r\n2073.2 \"The Final Verse\" Ability { id: \"4B58\", source: \"Kyklops\" }\r\n2083.1 \"Hammer/Blade Mark\" Ability { id: \"4B5[9A]\", source: \"Kyklops\" }\r\n2087.7 \"Blade/Hammer Mark\" Ability { id: \"4B5[9A]\", source: \"Kyklops\" }\r\n2095.4 \"Pyre/Hearth\" Ability { id: [\"4B5F\", \"4B60\"], source: \"Kyklops\" }\r\n2100.1 \"Terrible Hammer/Blade\" #Ability { id: \"4B5[DE]\", source: \"Kyklops\" }\r\n2102.2 \"Terrible Blade/Hammer\" #Ability { id: \"4B5[DE]\", source: \"Kyklops\" }\r\n2107.0 \"Swing/Swipe/Cyclone\" Ability { id: \"4B5[457]\", source: \"Kyklops\" }\r\n\r\n2117.5 \"The Final Verse\" Ability { id: \"4B58\", source: \"Kyklops\" } window 20,20 jump 2073.2\r\n2127.4 \"Hammer/Blade Mark\"\r\n2132.0 \"Blade/Hammer Mark\"\r\n2139.7 \"Pyre/Hearth\"\r\n2144.4 \"Terrible Hammer/Blade\"\r\n2146.5 \"Terrible Blade/Hammer\"\r\n2151.3 \"Swing/Swipe/Cyclone\"\r\n\r\n\r\n### Rukshs Dheem\r\n# -p 4B8C:3013\r\n# -ii 4B7C 4B7E 4B8A 4B86 4B85 4B80 4B82 4B87\r\n# Noesis will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"D89\" } window 3000,0\r\n3013.0 \"Bonebreaker\" Ability { id: \"4B8C\", source: \"Rukshs Dheem\" } window 3013,10\r\n3019.2 \"Swift Shift\" Ability { id: \"4B83\", source: \"Rukshs Dheem\" }\r\n3026.5 \"Seabed Ceremony\" Ability { id: \"4B7B\", source: \"Rukshs Dheem\" }\r\n3032.6 \"Depth Grip\" Ability { id: \"4B84\", source: \"Rukshs Dheem\" }\r\n3040.7 \"Falling Water\" Ability { id: \"4B7D\", source: \"Rukshs Dheem\" }\r\n3042.4 \"Wavebreaker x4\" duration 3 #Ability { id: \"33D4\", source: \"Depth Grip\" }\r\n3045.9 \"Rising Tide\" Ability { id: \"4B8B\", source: \"Rukshs Dheem\" }\r\n3056.2 \"Swift Shift\" Ability { id: \"4B83\", source: \"Rukshs Dheem\" }\r\n3063.6 \"Seabed Ceremony\" Ability { id: \"4B7B\", source: \"Rukshs Dheem\" } window 30,10\r\n3074.8 \"Falling Water\" Ability { id: \"4B7D\", source: \"Rukshs Dheem\" }\r\n3087.0 \"Bonebreaker\" Ability { id: \"4B8C\", source: \"Rukshs Dheem\" }\r\n3099.1 \"Seabed Ceremony\" Ability { id: \"4B7B\", source: \"Rukshs Dheem\" } window 30,10\r\n3105.2 \"Depth Grip\" Ability { id: \"4B84\", source: \"Rukshs Dheem\" }\r\n3115.5 \"Wavebreaker x8\" duration 7 #Ability { id: \"33D4\", source: \"Depth Grip\" }\r\n3131.8 \"Bonebreaker\" Ability { id: \"4B8C\", source: \"Rukshs Dheem\" }\r\n3141.0 \"Swift Shift\" Ability { id: \"4B83\", source: \"Rukshs Dheem\" }\r\n3148.4 \"Depth Grip\" Ability { id: \"4B84\", source: \"Rukshs Dheem\" }\r\n3158.5 \"Seabed Ceremony\" Ability { id: \"4B7B\", source: \"Rukshs Dheem\" }\r\n3160.5 \"Wavebreaker\" #Ability { id: \"33D5\", source: \"Depth Grip\" }\r\n3171.6 \"Flying Fount\" Ability { id: \"4B7F\", source: \"Rukshs Dheem\" }\r\n3178.8 \"Swift Shift\" Ability { id: \"4B83\", source: \"Rukshs Dheem\" }\r\n3186.9 \"Command Current\" Ability { id: \"4B81\", source: \"Rukshs Dheem\" }\r\n\r\n3193.6 \"Swift Shift\" Ability { id: \"4B83\", source: \"Rukshs Dheem\" }\r\n3200.9 \"Seabed Ceremony\" Ability { id: \"4B7B\", source: \"Rukshs Dheem\" }\r\n3207.0 \"Depth Grip\" Ability { id: \"4B84\", source: \"Rukshs Dheem\" }\r\n3215.1 \"Falling Water\" Ability { id: \"4B7D\", source: \"Rukshs Dheem\" }\r\n3216.8 \"Wavebreaker x4\" duration 3 #Ability { id: \"33D4\", source: \"Depth Grip\" }\r\n3220.2 \"Rising Tide\" Ability { id: \"4B8B\", source: \"Rukshs Dheem\" }\r\n3229.4 \"Bonebreaker\" Ability { id: \"4B8C\", source: \"Rukshs Dheem\" }\r\n3241.7 \"Seabed Ceremony\" Ability { id: \"4B7B\", source: \"Rukshs Dheem\" }\r\n3247.6 \"Depth Grip\" Ability { id: \"4B84\", source: \"Rukshs Dheem\" }\r\n3257.8 \"Wavebreaker x8\" duration 7 #Ability { id: \"33D4\", source: \"Depth Grip\" }\r\n3275.1 \"Bonebreaker\" Ability { id: \"4B8C\", source: \"Rukshs Dheem\" }\r\n\r\n3282.3 \"Swift Shift\" Ability { id: \"4B83\", source: \"Rukshs Dheem\" } window 50,50 jump 3193.6\r\n3289.6 \"Seabed Ceremony\"\r\n3295.7 \"Depth Grip\"\r\n3303.8 \"Falling Water\"\r\n3305.5 \"Wavebreaker x4\"\r\n3308.9 \"Rising Tide\"\r\n3318.1 \"Bonebreaker\"\r\n3330.2 \"Seabed Ceremony\"\r\n3336.3 \"Depth Grip\"\r\n3346.5 \"Wavebreaker x8\"\r\n3363.8 \"Bonebreaker\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/dohn_mheg.ts


const dohn_mheg_triggerSet = {
  id: 'DohnMheg',
  zoneId: zone_id/* default.DohnMheg */.Z.DohnMheg,
  timelineFile: 'dohn_mheg.txt',
  timelineTriggers: [{
    id: 'Dohn Mheg Rake',
    regex: /Rake/,
    beforeSeconds: 5,
    response: responses/* Responses.miniBuster */.n3.miniBuster()
  }],
  triggers: [{
    id: 'Dohn Mheg Watering Wheel',
    type: 'StartsUsing',
    // TODO: double check this with an import, is there a The??
    netRegex: {
      id: '3DAA',
      source: 'Dohnfast Fuath'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Dohn Mheg Straight Punch',
    type: 'StartsUsing',
    // TODO: double check this with an import, is there a The??
    netRegex: {
      id: '3DAB',
      source: 'Dohnfast Basket'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun('info')
  }, {
    id: 'Dohn Mheg Proboscis',
    type: 'StartsUsing',
    // TODO: double check this with an import, is there a The??
    netRegex: {
      id: '3DAF',
      source: 'Dohnfast Etainmoth'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun('info')
  }, {
    id: 'Dohn Mheg Torpedo',
    type: 'StartsUsing',
    // TODO: double check this with an import, is there a The??
    netRegex: {
      id: '3DB5',
      source: 'Dohnfast Kelpie'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun('info')
  }, {
    id: 'Dohn Mheg Candy Cane',
    type: 'StartsUsing',
    netRegex: {
      id: '2299',
      source: 'Aenc Thon, Lord Of The Lingering Gaze'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Dohn Mheg Landsblood',
    type: 'StartsUsing',
    netRegex: {
      id: '1E8E',
      source: 'Aenc Thon, Lord Of The Lingering Gaze',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Dohn Mheg Leap Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Dohn Mheg Timber',
    type: 'StartsUsing',
    netRegex: {
      id: '22D3',
      source: 'Griaule',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Dohn Mheg Crippling Blow',
    type: 'StartsUsing',
    netRegex: {
      id: '35A4',
      source: 'Aenc Thon, Lord Of The Lengthsome Gait'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Dohn Mheg Imp Choir',
    type: 'StartsUsing',
    netRegex: {
      id: '34F0',
      source: 'Aenc Thon, Lord Of The Lengthsome Gait',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'Dohn Mheg Toad Choir',
    type: 'StartsUsing',
    netRegex: {
      id: '34EF',
      source: 'Aenc Thon, Lord Of The Lengthsome Gait',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Dohn Mheg Virtuosic Cappriccio',
    type: 'StartsUsing',
    netRegex: {
      id: '358C',
      source: 'Aenc Thon, Lord Of The Lengthsome Gait',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Teag Gye': 'Taeg Gye',
      'The Atelier': 'Griaules Revier',
      'The throne room': 'Garten des Kronsaal',
      'Aenc Thon, Lord of the Lingering Gaze': 'Aenc Thon (?:der|die|das) Glupschäugig(?:e|er|es|en)',
      'Griaule': 'Griaule',
      'Painted Sapling': 'Griaules Sämling',
      'Aenc Thon, Lord of the Lengthsome Gait': 'Aenc Thon (?:der|die|das) Langbeinig(?:e|er|es|en)',
      'Shade of Fear': 'Schatten der Angst',
      'Dohnfast Fuath': 'Dohn-Fuath',
      'Dohnfast Basket': 'Dohn-Blumenkorb',
      'Dohnfast Etainmoth': 'Dohn-Edianmotte',
      'Dohnfast Kelpie': 'Dohn-Kelpie'
    },
    'replaceText': {
      'Swinge': 'Brutaler Odem',
      'Fodder': 'Hungriges Gebrüll',
      'Tiiimbeeer': 'Baum fääällt',
      'Feeding Time': 'Fütterungszeit',
      'Coiling Ivy': 'Verschlungener Efeu',
      'Crippling Blow': 'Verkrüppelnder Schlag',
      'Imp Choir': 'Koboldchor',
      'Corrosive Bile': 'Ätzende Galle',
      'Geyser': 'Geysir',
      'Hydrofall': 'Hydro-Sturz',
      'Laughing Leap': 'Freudensprung',
      'Landsblood': 'Erdblut',
      'Candy Cane': 'Quietschehammer',
      'Funambulist\'s Fantasia': 'Seiltanz-Fantasie',
      'Malaise': 'Malaise',
      'Bile Bombardment': 'Galliger Niederschlag',
      'Flailing Tentacles': 'Tentakelflegel',
      'Toad Choir': 'Froschchor',
      'Changeling\'s Fantasia': 'Wechselbalg-Fantasie',
      'Virtuosic Capriccio': 'Virtuoses Capriccio',
      'Rake': 'Prankenhieb'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aenc Thon, Lord of the Lengthsome Gait': 'Aenc Thon Le Virtuose',
      'Aenc Thon, Lord of the Lingering Gaze': 'Aenc Thon L\'Envoûtant',
      'Griaule': 'Griaule',
      'Painted Sapling': 'Pousse de Griaule',
      'Shade of Fear': 'Illusion terrifiante',
      'Teag Gye': 'la Teag Gye',
      'The Atelier': 'Repos de Griaule',
      'The throne room': 'la salle du trésor',
      'Dohnfast Fuath': 'Fuath de Dohn Mheg',
      'Dohnfast Basket': 'panier de Dohn Mheg',
      'Dohnfast Etainmoth': 'noctuétain de Dohn Mheg',
      'Dohnfast Kelpie': 'kelpie de Dohn Mheg'
    },
    'replaceText': {
      'Bile Bombardment': 'Bombardement bilieux',
      'Candy Cane': 'Canne en sucre d\'orge',
      'Changeling\'s Fantasia': 'Fantaisie du changelin',
      'Coiling Ivy': 'Étreinte de lierre',
      'Corrosive Bile': 'Bile corrosive',
      'Crippling Blow': 'Coup handicapant',
      'Feeding Time': 'Moisson',
      'Flailing Tentacles': 'Tentacules flagellants',
      'Fodder': 'Culture',
      'Funambulist\'s Fantasia': 'Fantaisie du funambule',
      'Geyser': 'Geyser',
      'Hydrofall': 'Pilonnage hydrique',
      'Imp Choir': 'Mélodie du kappa',
      'Landsblood': 'Pulsation phréatique',
      'Laughing Leap': 'Bond soudain',
      'Malaise': 'Malaise',
      'Rake': 'Griffes',
      'Swinge': 'Brutalité',
      'Tiiimbeeer': 'Ça tooombe',
      'Toad Choir': 'Mélodie du crapeau',
      'Virtuosic Capriccio': 'Capriccio effréné'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aenc Thon, Lord of the Lengthsome Gait': '楽聖のインク＝ゾン',
      'Aenc Thon, Lord of the Lingering Gaze': '美眼のインク＝ゾン',
      'Griaule': 'グリオール',
      'Painted Sapling': 'グリオール・サップリング',
      'Shade of Fear': '恐怖の幻影',
      'Teag Gye': '微睡みの泉',
      'The Atelier': 'グリオールの寝床',
      'The throne room': '王冠の間',
      'Dohnfast Fuath': 'ドォーヌ・フーア',
      'Dohnfast Basket': 'ドォーヌ・バスケット',
      'Dohnfast Etainmoth': 'ドォーヌ・エーディンモス',
      'Dohnfast Kelpie': 'ドォーヌ・ケルピー'
    },
    'replaceText': {
      'Bile Bombardment': '蟲毒飛散',
      'Candy Cane': 'キャンディケーン',
      'Changeling\'s Fantasia': '自己変異のファンタジア',
      'Coiling Ivy': '絡みつく蔦',
      'Corrosive Bile': 'コロシヴバイル',
      'Crippling Blow': '痛打',
      'Feeding Time': '養分献上',
      'Flailing Tentacles': '蠢く触手',
      'Fodder': '養分召喚',
      'Funambulist\'s Fantasia': '一本橋のファンタジア',
      'Geyser': '噴出',
      'Hydrofall': 'ハイドロフォール',
      'Imp Choir': 'カッパの調べ',
      'Landsblood': '水脈乱打',
      'Laughing Leap': '飛びかかり',
      'Malaise': '蟲毒瘴',
      'Rake': 'ひっかき',
      'Swinge': 'スイング',
      'Tiiimbeeer': 'ティーンバー',
      'Toad Choir': 'カエルの調べ',
      'Virtuosic Capriccio': '苛烈なるカプリッチョ'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Teag Gye': '선잠의 샘',
      'The Atelier': '그리올의 침상',
      'The throne room': '왕관의 방',
      'Aenc Thon, Lord of the Lingering Gaze': '눈이 예쁜 잉크 돈',
      'Griaule': '그리올',
      'Painted Sapling': '그리올 묘목',
      'Aenc Thon, Lord of the Lengthsome Gait': '대음악가 잉크 돈',
      'Shade of Fear': '공포의 환영',
      'Dohnfast Fuath': '도느 푸아',
      'Dohnfast Basket': '도느 바구니',
      'Dohnfast Etainmoth': '도느 에다인나방',
      'Dohnfast Kelpie': '도느 켈피'
    },
    'replaceText': {
      'Swinge': '징벌',
      'Fodder': '양분 소환',
      'Tiiimbeeer': '쓰러진다아아',
      'Feeding Time': '양분 헌상',
      'Coiling Ivy': '휘감는 덩굴',
      'Crippling Blow': '통타',
      'Imp Choir': '물요정의 음률',
      'Corrosive Bile': '부식성 담즙',
      'Geyser': '분출',
      'Hydrofall': '물 쏟기',
      'Laughing Leap': '달려들기',
      'Landsblood': '수맥 난타',
      'Candy Cane': '막대사탕',
      'Funambulist\'s Fantasia': '외나무다리 환상곡',
      'Malaise': '벌레독',
      'Bile Bombardment': '벌레독 살포',
      'Flailing Tentacles': '꿈틀대는 촉수',
      'Toad Choir': '개구리의 음률',
      'Changeling\'s Fantasia': '자기 변이 환상곡',
      'Virtuosic Capriccio': '가열찬 광상곡',
      'Rake': '할퀴기'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Teag Gye': '微睡之泉',
      'The Atelier': '格里奥勒的睡床',
      'The throne room': '王冠之间',
      'Aenc Thon, Lord of the Lingering Gaze': '美眼 因克·佐恩',
      'Griaule': '格里奥勒',
      'Painted Sapling': '格里奥勒花苗',
      'Aenc Thon, Lord of the Lengthsome Gait': '乐圣 因克·佐恩',
      'Shade of Fear': '恐怖幻影',
      'Dohnfast Fuath': '禁园水妖',
      'Dohnfast Basket': '禁园篮筐',
      'Dohnfast Etainmoth': '禁园爱蒂恩蛾',
      'Dohnfast Kelpie': '禁园凯尔派'
    },
    'replaceText': {
      'Swinge': '重击',
      'Fodder': '召唤养分',
      'Tiiimbeeer': '震木',
      'Feeding Time': '献上养分',
      'Coiling Ivy': '缠绕藤蔓',
      'Crippling Blow': '痛击',
      'Imp Choir': '河童歌唱队',
      'Corrosive Bile': '腐蚀咬',
      'Geyser': '幻水泉',
      'Hydrofall': '水瀑',
      'Laughing Leap': '飞扑',
      'Landsblood': '水脉乱打',
      'Candy Cane': '糖果手杖',
      'Funambulist\'s Fantasia': '独木桥幻想曲',
      'Malaise': '虫毒瘴',
      'Bile Bombardment': '虫毒飞散',
      'Flailing Tentacles': '触手轰击',
      'Toad Choir': '青蛙歌唱队',
      'Changeling\'s Fantasia': '自身变异幻想曲',
      'Virtuosic Capriccio': '残酷狂想曲',
      'Rake': '利爪'
    }
  }]
};
/* harmony default export */ const dohn_mheg = (dohn_mheg_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/dohn_mheg.txt
const dungeon_dohn_mheg_namespaceObject = "### Dohn Mheg\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Aenc Thon, Lord of the Lingering Gaze\r\n# -ii 1EDB 22BD -p 2299:112.2\r\n# Teag Gye will be sealed off\r\n100.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"B93\" } window 100,0\r\n\r\n112.2 \"Candy Cane\" Ability { id: \"2299\", source: \"Aenc Thon, Lord of the Lingering Gaze\" } window 113,5\r\n120.4 \"Hydrofall\" Ability { id: \"22A7\", source: \"Aenc Thon, Lord of the Lingering Gaze\" }\r\n128.7 \"Laughing Leap\" Ability { id: \"2294\", source: \"Aenc Thon, Lord of the Lingering Gaze\" }\r\n133.8 \"Landsblood\" Ability { id: \"1E8E\", source: \"Aenc Thon, Lord of the Lingering Gaze\" }\r\n139.6 \"Geyser x6\" duration 12.5\r\n161.1 \"Candy Cane\" Ability { id: \"2299\", source: \"Aenc Thon, Lord of the Lingering Gaze\" }\r\n\r\n170.4 \"Hydrofall\" Ability { id: \"22A7\", source: \"Aenc Thon, Lord of the Lingering Gaze\" }\r\n179.7 \"Laughing Leap Stack\" Ability { id: \"2288\", source: \"Aenc Thon, Lord of the Lingering Gaze\" }\r\n189.9 \"Candy Cane\" Ability { id: \"2299\", source: \"Aenc Thon, Lord of the Lingering Gaze\" }\r\n201.1 \"Laughing Leap\" Ability { id: \"2294\", source: \"Aenc Thon, Lord of the Lingering Gaze\" }\r\n206.2 \"Landsblood\" Ability { id: \"1E8E\", source: \"Aenc Thon, Lord of the Lingering Gaze\" }\r\n212.0 \"Geyser x6\" duration 12.5\r\n233.4 \"Candy Cane\" Ability { id: \"2299\", source: \"Aenc Thon, Lord of the Lingering Gaze\" }\r\n\r\n242.6 \"Hydrofall\" Ability { id: \"22A7\", source: \"Aenc Thon, Lord of the Lingering Gaze\" } window 50,50 jump 170.4\r\n251.9 \"Laughing Leap Stack\"\r\n262.1 \"Candy Cane\"\r\n273.3 \"Laughing Leap\"\r\n278.4 \"Landsblood\"\r\n284.2 \"Geyser x6\"\r\n305.6 \"Candy Cane\"\r\n\r\n\r\n### Griaule\r\n# -p 2873:507.5\r\n# The Atelier will be sealed off\r\n500.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"B96\" } window 500,0\r\n\r\n507.5 \"Rake\" Ability { id: \"2873\", source: \"Griaule\" } window 508,5\r\n518.0 \"Swinge\" Ability { id: \"22CA\", source: \"Griaule\" }\r\n525.4 \"Fodder\" Ability { id: \"22C1\", source: \"Griaule\" }\r\n533.5 \"Tiiimbeeer\" Ability { id: \"22D3\", source: \"Griaule\" }\r\n538.6 \"Feeding Time\" Ability { id: \"22C3\", source: \"Painted Sapling\" }\r\n541.7 \"Tiiimbeeer\" Ability { id: \"22D3\", source: \"Griaule\" }\r\n554.0 \"Swinge\" Ability { id: \"22CA\", source: \"Griaule\" }\r\n568.3 \"Tiiimbeeer\" Ability { id: \"22D3\", source: \"Griaule\" }\r\n573.5 \"Coiling Ivy\" Ability { id: \"22C5\", source: \"Griaule\" }\r\n580.7 \"Rake\" Ability { id: \"2873\", source: \"Griaule\" }\r\n\r\n591.1 \"Swinge\" Ability { id: \"22CA\", source: \"Griaule\" }\r\n605.4 \"Tiiimbeeer\" Ability { id: \"22D3\", source: \"Griaule\" }\r\n614.5 \"Rake\" Ability { id: \"2873\", source: \"Griaule\" }\r\n623.9 \"Coiling Ivy\" Ability { id: \"22C5\", source: \"Griaule\" }\r\n631.1 \"Fodder\" Ability { id: \"22C1\", source: \"Griaule\" }\r\n639.4 \"Tiiimbeeer\" Ability { id: \"22D3\", source: \"Griaule\" }\r\n644.6 \"Feeding Time\" Ability { id: \"22C3\", source: \"Painted Sapling\" }\r\n647.6 \"Tiiimbeeer\" Ability { id: \"22D3\", source: \"Griaule\" }\r\n658.1 \"Swinge\" Ability { id: \"22CA\", source: \"Griaule\" }\r\n665.4 \"Coiling Ivy\" Ability { id: \"22C5\", source: \"Griaule\" }\r\n672.6 \"Rake\" Ability { id: \"2873\", source: \"Griaule\" }\r\n\r\n682.8 \"Swinge\" Ability { id: \"22CA\", source: \"Griaule\" } window 10,10 jump 591.1\r\n697.1 \"Tiiimbeeer\"\r\n706.2 \"Rake\"\r\n715.6 \"Coiling Ivy\"\r\n722.8 \"Fodder\"\r\n731.1 \"Tiiimbeeer\"\r\n736.3 \"Feeding Time\"\r\n739.3 \"Tiiimbeeer\"\r\n749.8 \"Swinge\"\r\n757.1 \"Coiling Ivy\"\r\n764.3 \"Rake\"\r\n\r\n\r\n### Aenc Thon, Lord of the Lengthsome Gate\r\n# -p 35A4:1011 34D2:1300 -ii 34EC 3681 3396\r\n# The Throne Room will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"B98\" } window 1000,0\r\n\r\n1011.0 \"Crippling Blow\" Ability { id: \"35A4\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" } window 1011,5\r\n1018.2 \"Virtuosic Capriccio\" Ability { id: \"358C\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n1027.5 \"Imp Choir\" Ability { id: \"34F0\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n1033.9 \"Toad Choir\" Ability { id: \"34EF\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n1044.1 \"Crippling Blow\" Ability { id: \"35A4\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n\r\n1052.7 \"Funambulist's Fantasia\" Ability { id: \"34BA\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n1052.7 \"--stun--\" Ability { id: \"34CF\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n1112.7 \"Enrage\"\r\n\r\n1300.0 \"--sync--\" Ability { id: \"34D2\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" } window 300,0\r\n\r\n1302.1 \"Changeling's Fantasia\" Ability { id: \"34D1\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n1312.4 \"Malaise\" Ability { id: \"34ED\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n1318.5 \"Bile Bombardment\" Ability { id: \"34EE\", source: \"Shade of Fear\" }\r\n1326.7 \"Corrosive Bile\" Ability { id: \"34EB\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n1338.0 \"Malaise\" Ability { id: \"34ED\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n1344.1 \"Bile Bombardment\" Ability { id: \"34EE\", source: \"Shade of Fear\" }\r\n1345.1 \"Flailing Tentacles\" Ability { id: \"3680\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n1354.4 \"Corrosive Bile\" Ability { id: \"34EB\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n\r\n1375.7 \"Crippling Blow\" Ability { id: \"35A4\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n1389.0 \"Virtuosic Capriccio\" Ability { id: \"358C\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" } window 3,3\r\n1396.1 \"Virtuosic Capriccio\" Ability { id: \"358C\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" } window 3,3\r\n1403.2 \"Virtuosic Capriccio\" Ability { id: \"358C\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" } window 3,3\r\n1414.5 \"Imp Choir\" Ability { id: \"34F0\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n1420.9 \"Toad Choir\" Ability { id: \"34EF\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n\r\n1438.3 \"Crippling Blow\" Ability { id: \"35A4\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" } window 20,20 jump 1375.7\r\n1451.6 \"Virtuosic Capriccio\"\r\n1458.7 \"Virtuosic Capriccio\"\r\n1465.8 \"Virtuosic Capriccio\"\r\n1477.1 \"Imp Choir\"\r\n1483.5 \"Toad Choir\"\r\n\r\n\r\n1800.0 \"--sync--\" Ability { id: \"34D2\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" } window 590,0\r\n1802.0 \"Changeling's Fantasia\" Ability { id: \"34D1\", source: \"Aenc Thon, Lord of the Lengthsome Gait\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/heroes_gauntlet.ts




const heroes_gauntlet_triggerSet = {
  id: 'TheHeroesGauntlet',
  zoneId: zone_id/* default.TheHeroesGauntlet */.Z.TheHeroesGauntlet,
  timelineFile: 'heroes_gauntlet.txt',
  triggers: [{
    id: 'Heroes Gauntlet Spectral Dream',
    type: 'StartsUsing',
    netRegex: {
      id: '4FCB',
      source: 'Spectral Thief'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Heroes Gauntlet Spectral Gust',
    type: 'HeadMarker',
    netRegex: {
      id: '00A9'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Heroes Gauntlet Spectral Whirlwind',
    type: 'StartsUsing',
    netRegex: {
      id: '4FCC',
      source: 'Spectral Thief',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Spectral Thief tethers to the locations where it will attack.
    id: 'Heroes Gauntlet Spectral Tether',
    type: 'Tether',
    netRegex: {
      id: '000C',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from tether marker',
        de: 'Weg von der Verbindung',
        fr: 'Éloignez-vous du marqueur lié',
        ja: '線から離れる',
        cn: '远离连线标志',
        ko: '이어진 표식으로부터 떨어지기'
      }
    }
  }, {
    id: 'Heroes Gauntlet Spectral White Mage Absolute Protect',
    type: 'StartsUsing',
    netRegex: {
      id: '524D',
      source: 'Spectral White Mage'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Heroes Gauntlet Large Zombie Tether',
    type: 'Tether',
    netRegex: {
      id: '004F'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Heroes Gauntlet Twisted Touch',
    type: 'StartsUsing',
    netRegex: {
      id: '4F5E',
      source: 'Spectral Necromancer'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Heroes Gauntlet Chaos Storm',
    type: 'StartsUsing',
    netRegex: {
      id: '4F60',
      source: 'Spectral Necromancer',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Heroes Gauntlet Beastly Fury',
    type: 'StartsUsing',
    netRegex: {
      id: '520C',
      source: 'Spectral Berserker',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Both two and three uses of Slice can happen.
    id: 'Heroes Gauntlet Raging Slice',
    type: 'StartsUsing',
    netRegex: {
      id: ['520A', '520B'],
      source: 'Spectral Berserker',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Heroes Gauntlet Wild Rampage',
    type: 'StartsUsing',
    netRegex: {
      id: '5206',
      source: 'Spectral Berserker',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get in a crater',
        de: 'In den Krater gehen',
        fr: 'Allez dans un cratère',
        ja: '穴に入る',
        cn: '进入坑洞',
        ko: '구덩이에 들어가기'
      }
    }
  }, {
    id: 'Heroes Gauntlet Wild Rage',
    type: 'StartsUsing',
    netRegex: {
      id: ['5202', '5203', '5204'],
      source: 'Spectral Berserker',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    // The same head marker is used for the initial player stack and the rock stacks.
    // If there's one stack marker, the players stack.
    // Otherwise they stack on the rock they drop.
    id: 'Heroes Gauntlet Wild Anguish Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '005D'
    },
    run: (data, matches) => {
      data.anguish ??= [];
      data.anguish.push(matches.target);
    }
  }, {
    id: 'Heroes Gauntlet Wild Anguish Resolve',
    type: 'HeadMarker',
    netRegex: {
      id: '005D'
    },
    delaySeconds: 1,
    suppressSeconds: 5,
    alertText: (data, matches, output) => {
      if (data.anguish && data.anguish.length > 1) return output.stackOnYourRock();
      if (matches.target === data.me) return output.stackOnYou();
      return output.stackOn({
        player: data.party.member(matches.target)
      });
    },
    run: data => delete data.anguish,
    outputStrings: {
      stackOnYourRock: {
        en: 'Stack on your rock',
        de: 'Auf deinem Stein sammeln',
        fr: 'Packez-vous avec votre rocher',
        ja: '自分の岩に貼りつく',
        cn: '与自己的石堆重合',
        ko: '돌과 같이 맞기'
      },
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'Heroes Gauntlet Wild Anguish Spread',
    type: 'HeadMarker',
    netRegex: {
      id: '005E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Chicken Knife': 'Hühnermesserwurf',
      'Necrobomb': 'Nekrobomber',
      'Rubble': 'Trümmerhaufen',
      'Spectral Berserker': 'Phantom-Berserker',
      'Spectral Necromancer': 'Phantom-Nekromantin',
      'Spectral Thief': 'Phantom-Dieb',
      'Spectral White Mage': 'Phantom-Weißmagierin',
      'The Illuminated Plaza': 'Platz der Erleuchteten',
      'The Mount Argai Mines': 'Minen des Argai',
      'The Summer Ballroom': 'Ballsaal der Grasgrummel'
    },
    'replaceText': {
      'Absolute Dark II': 'Absolutes Negra',
      'Beastly Fury': 'Animalischer Zorn',
      'Chaos Storm': 'Chaossturm',
      'Chicken Knife': 'Hühnermesserwurf',
      'Coward\'s Cunning': 'Feiger Angriff',
      'Dark Deluge': 'Finsterwelle',
      '(?<!Shadow)Dash': 'Sprint',
      'Death Throes': 'Agonales Klammern',
      'Falling Rock': 'Steinschlag',
      'Necroburst': 'Nekro-Explosion',
      'Necromancy': 'Nekromantie',
      'Pain Mire': 'Schmerzmoor',
      'Papercutter': 'Tanzakugiri',
      'Raging Slice': 'Tobsüchtiger Sichelschnitt',
      'Shadowdash': 'Schattenspaltungssprint',
      'Spectral Dream': 'Phantom-Tripple',
      'Spectral Gust': 'Phantom-Böe',
      'Spectral Whirlwind': 'Phantom-Windhose',
      'Twisted Touch': 'Verseuchte Finger',
      'Vacuum Blade': 'Vakuum-Klinge',
      'Wild Anguish': 'Bestialischer Schmerz',
      'Wild Rage': 'Bestialischer Zorn',
      'Wild Rampage': 'Bestialische Raserei'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Chicken Knife': 'Lancer de couteau de poltron',
      'Necrobomb': 'bombe nécrotique',
      'Rubble': 'tas de gravats',
      'Spectral Berserker': 'berserker spectral',
      'Spectral Necromancer': 'nécromancienne spectrale',
      'Spectral Thief': 'voleur spectral',
      'The Illuminated Plaza': 'Carré de l\'Aurore',
      'The Mount Argai Mines': 'Mines du mont Argai',
      'The Summer Ballroom': 'Bal des enfeuillés',
      'Spectral White Mage': 'mage blanc spectral'
    },
    'replaceText': {
      'Absolute Dark II': 'Extra Ténèbres absolues',
      'Beastly Fury': 'Bête en furie',
      'Chaos Storm': 'Tempête de chaos',
      'Chicken Knife': 'Lancer de couteau de poltron',
      'Coward\'s Cunning': 'Frappe en traître',
      'Dark Deluge': 'Vague noire',
      '(?<!Shadow)Dash': 'Élan',
      'Death Throes': 'Affres de la mort',
      'Falling Rock': 'Chute de pierre',
      'Necroburst': 'Salve nécrotique',
      'Necromancy': 'Nécromancie',
      'Pain Mire': 'Marécage de souffrance',
      'Papercutter': 'Julienne de chair',
      'Raging Slice': 'Déchiquetage enragé',
      'Shadowdash': 'Élan d\'ombre',
      'Spectral Dream': 'Troïka spectrale',
      'Spectral Gust': 'Bourrasque spectrale',
      'Spectral Whirlwind': 'Grand tourbillon spectral',
      'Twisted Touch': 'Toucher purulent',
      'Vacuum Blade': 'Lame de vide',
      'Wild Anguish': 'Soubresaut bestiale',
      'Wild Rage': 'Colère bestiale',
      'Wild Rampage': 'Rage bestiale'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Chicken Knife': 'チキンナイフ投げ',
      'Necrobomb': 'ネクロボム',
      'Rubble': '瓦礫',
      'Spectral Berserker': '幻光のバーサーカー',
      'Spectral Necromancer': '幻光のネクロマンサー',
      'Spectral Thief': '幻光のシーフ',
      'The Illuminated Plaza': '大聖堂前広場',
      'The Mount Argai Mines': 'アルゲ鉱山',
      'The Summer Ballroom': '草人たちの踊り場',
      'Spectral White Mage': '幻光の白魔道士'
    },
    'replaceText': {
      'Absolute Dark II': 'アブソリュートダーラ',
      'Beastly Fury': 'ビーストフューリー',
      'Chaos Storm': 'カオスストーム',
      'Chicken Knife': 'チキンナイフ投げ',
      'Coward\'s Cunning': '臆病者の一撃',
      'Dark Deluge': '黒い波',
      '(?<!Shadow)Dash': 'ダッシュ',
      'Death Throes': '道連れ',
      'Falling Rock': '落石',
      'Necroburst': 'ネクロバースト',
      'Necromancy': 'ネクロマンシー',
      'Pain Mire': 'ペインボグ',
      'Papercutter': '短冊斬り',
      'Raging Slice': 'レイジングスライス',
      'Shadowdash': '分身ダッシュ',
      'Spectral Dream': '幻光三段',
      'Spectral Gust': '幻光旋風',
      'Spectral Whirlwind': '幻光大旋風',
      'Twisted Touch': '穢れた指先',
      'Vacuum Blade': '真空刃',
      'Wild Anguish': '獣魂の痛み',
      'Wild Rage': '獣魂の怒り',
      'Wild Rampage': '獣魂の猛り'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Chicken Knife': '投掷弱鸡匕首',
      'Necrobomb': '亡灵爆弹',
      'Rubble': '瓦砾',
      'Spectral Berserker': '幻光狂战士',
      'Spectral Necromancer': '幻光亡灵法师',
      'Spectral Thief': '幻光盗贼',
      'The Illuminated Plaza': '大圣堂前广场',
      'The Mount Argai Mines': '阿尔格矿山',
      'The Summer Ballroom': '草人的舞场',
      'Spectral White Mage': '幻光白魔法师'
    },
    'replaceText': {
      'Absolute Dark II': '绝对昏暗',
      'Beastly Fury': '野兽之怒',
      'Chaos Storm': '混沌风暴',
      'Chicken Knife': '投掷弱鸡匕首',
      'Coward\'s Cunning': '胆小鬼的一击',
      'Dark Deluge': '黑浪',
      '(?<!Shadow)Dash': '冲刺',
      'Death Throes': '死亡引领',
      'Falling Rock': '落石',
      'Necroburst': '亡灵爆发',
      'Necromancy': '亡灵术',
      'Pain Mire': '苦痛酸沼',
      'Papercutter': '残片斩',
      'Raging Slice': '暴怒劈',
      'Shadowdash': '分身冲刺',
      'Spectral Dream': '幻光三段',
      'Spectral Gust': '幻光旋风',
      'Spectral Whirlwind': '幻光大旋风',
      'Twisted Touch': '污秽之指',
      'Vacuum Blade': '真空刃',
      'Wild Anguish': '兽魂的苦痛',
      'Wild Rage': '兽魂的愤怒',
      'Wild Rampage': '兽魂的勇猛'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Chicken Knife': '치킨 나이프 던지기',
      'Necrobomb': '사령 폭탄',
      'Rubble': '잔해더미',
      'Spectral Berserker': '환상빛의 광전사',
      'Spectral Necromancer': '환상빛의 강령술사',
      'Spectral Thief': '환상빛의 도적',
      'The Illuminated Plaza': '대성당 앞 광장',
      'The Mount Argai Mines': '아르게 광산',
      'The Summer Ballroom': '풀인간의 무도회장',
      'Spectral White Mage': '환상빛의 백마도사'
    },
    'replaceText': {
      'Absolute Dark II': '앱솔루트 다라',
      'Beastly Fury': '짐승의 격분',
      'Chaos Storm': '혼돈의 폭풍',
      'Chicken Knife': '치킨 나이프 던지기',
      'Coward\'s Cunning': '겁쟁이의 일격',
      '(?<!Shadow)Dash': '달음질',
      'Dark Deluge': '검은 파도',
      'Death Throes': '물귀신 작전',
      'Falling Rock': '낙석',
      'Necroburst': '사령 폭발',
      'Necromancy': '강령술',
      'Pain Mire': '고통의 수렁',
      'Papercutter': '채썰기',
      'Raging Slice': '성난 베기',
      'Shadowdash': '분신 달음질',
      'Spectral Dream': '환광삼단',
      'Spectral Gust': '환광선풍',
      'Spectral Whirlwind': '환광대선풍',
      'Twisted Touch': '추악한 손길',
      'Vacuum Blade': '진공 베기',
      'Wild Anguish': '야수의 고통',
      'Wild Rage': '야수의 분노',
      'Wild Rampage': '야수의 격노'
    }
  }]
};
/* harmony default export */ const heroes_gauntlet = (heroes_gauntlet_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/heroes_gauntlet.txt
const dungeon_heroes_gauntlet_namespaceObject = "### HEROES' GAUNTLET\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~~~~~~~~#\r\n# SPECTRAL THIEF #\r\n#~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 4FCD 4FCE 4FCF 4FD0 4FD5 5015\r\n\r\n# Mount Argai Mines will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"DBB\" } window 0,1\r\n9.8 \"Spectral Dream\" Ability { id: \"4FCB\", source: \"Spectral Thief\" } window 9.8,5\r\n16.9 \"Dash\" Ability { id: \"4FD3\", source: \"Spectral Thief\" }\r\n26.7 \"Vacuum Blade\" Ability { id: \"506[12]\", source: \"Spectral Thief\" }\r\n37.8 \"Spectral Whirlwind\" Ability { id: \"4FCC\", source: \"Spectral Thief\" }\r\n44.0 \"--sync--\" Ability { id: \"53CE\", source: \"Spectral Thief\" }\r\n51.1 \"Spectral Gust\" Ability { id: \"53CF\", source: \"Spectral Thief\" }\r\n52.1 \"Chicken Knife\" Ability { id: \"4FD6\", source: \"Spectral Thief\" }\r\n59.2 \"Shadowdash\" Ability { id: \"4FD4\", source: \"Spectral Thief\" }\r\n63.4 \"Coward's Cunning\" Ability { id: \"4FD7\", source: \"Chicken Knife\" }\r\n\r\n69.0 \"Papercutter\" Ability { id: \"4FD[12]\", source: \"Spectral Thief\" }\r\n83.2 \"Spectral Dream\" Ability { id: \"4FCB\", source: \"Spectral Thief\" }\r\n88.4 \"Chicken Knife\" Ability { id: \"4FD6\", source: \"Spectral Thief\" } window 20,30\r\n95.5 \"Shadowdash\" Ability { id: \"4FD4\", source: \"Spectral Thief\" }\r\n97.2 \"Spectral Gust\" Ability { id: \"53CE\", source: \"Spectral Thief\" }\r\n99.7 \"Coward's Cunning\" Ability { id: \"4FD7\", source: \"Chicken Knife\" }\r\n104.2 \"Spectral Gust\" Ability { id: \"53CF\", source: \"Spectral Thief\" }\r\n\r\n107.4 \"Vacuum Blade\" Ability { id: \"506[12]\", source: \"Spectral Thief\" }\r\n121.5 \"Spectral Whirlwind\" Ability { id: \"4FCC\", source: \"Spectral Thief\" }\r\n129.6 \"Chicken Knife\" Ability { id: \"4FD6\", source: \"Spectral Thief\" } window 30,30\r\n136.8 \"Shadowdash\" Ability { id: \"4FD4\", source: \"Spectral Thief\" }\r\n138.5 \"Spectral Gust\" Ability { id: \"53CE\", source: \"Spectral Thief\" }\r\n141.0 \"Coward's Cunning\" Ability { id: \"4FD7\", source: \"Chicken Knife\" }\r\n145.6 \"Spectral Gust\" Ability { id: \"53CF\", source: \"Spectral Thief\" }\r\n\r\n148.8 \"Papercutter\" Ability { id: \"4FD[12]\", source: \"Spectral Thief\" } jump 69\r\n163.0 \"Spectral Dream\"\r\n168.2 \"Chicken Knife\"\r\n175.3 \"Shadowdash\"\r\n177.0 \"Spectral Gust\"\r\n179.5 \"Coward's Cunning\"\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~~~~#\r\n# SPECTRAL NECROMANCER #\r\n#~~~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ic Mustardseed \"Tupaq Amaro\" \"Nu Mou\" Peaseblossom\r\n# -ii 4F51 4F62 4F64 53B5 53B6 53B7 53B8 53B9 53BA\r\n\r\n# Summer Ballroom will be sealed off\r\n1000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"DBC\" } window 1000,5\r\n1012.8 \"Absolute Dark II\" Ability { id: \"4F61\", source: \"Spectral Necromancer\" } window 1012.8,5\r\n1020.0 \"Necromancy\" Ability { id: \"4F57\", source: \"Spectral Necromancer\" }\r\n1030.2 \"Twisted Touch\" Ability { id: \"4F5E\", source: \"Spectral Necromancer\" } window 30,30\r\n1046.7 \"Necroburst\" Ability { id: \"4F5[9A]\", source: \"Spectral Necromancer\" }\r\n1051.4 \"--sync--\" Ability { id: \"4FA3\", source: \"Spectral Necromancer\" }\r\n1059.0 \"Pain Mire\" Ability { id: \"4FA4\", source: \"Spectral Necromancer\" }\r\n1066.7 \"Necromancy\" Ability { id: \"4F58\", source: \"Spectral Necromancer\" }\r\n1074.2 \"Death Throes\" # Ability { id: \"4F63\", source: \"Necrobomb\" }\r\n1085.7 \"Necroburst\" Ability { id: \"4F5[9A]\", source: \"Spectral Necromancer\" }\r\n\r\n1096.8 \"Chaos Storm\" Ability { id: \"4F60\", source: \"Spectral Necromancer\" } window 100,30\r\n1105.4 \"Necromancy\" Ability { id: \"4F57\", source: \"Spectral Necromancer\" }\r\n1111.6 \"Necromancy\" Ability { id: \"4F58\", source: \"Spectral Necromancer\" }\r\n1121.7 \"--sync--\" Ability { id: \"4F5C\", source: \"Spectral Necromancer\" }\r\n1122.7 \"Dark Deluge\" Ability { id: \"4F5D\", source: \"Spectral Necromancer\" } window 30,30\r\n1124.0 \"Death Throes\" # Ability { id: \"4F63\", source: \"Necrobomb\" }\r\n1130.1 \"Necroburst\" Ability { id: \"4F5[9A]\", source: \"Spectral Necromancer\" }\r\n1142.6 \"Absolute Dark II\" Ability { id: \"4F61\", source: \"Spectral Necromancer\" }\r\n1149.8 \"--sync--\" Ability { id: \"4FA3\", source: \"Spectral Necromancer\" }\r\n1157.4 \"Pain Mire\" Ability { id: \"4FA4\", source: \"Spectral Necromancer\" }\r\n1164.9 \"Chaos Storm\" Ability { id: \"4F60\", source: \"Spectral Necromancer\" } window 30,30\r\n1176.0 \"Twisted Touch\" Ability { id: \"4F5E\", source: \"Spectral Necromancer\" }\r\n1182.4 \"--sync--\" Ability { id: \"4FA3\", source: \"Spectral Necromancer\" }\r\n1189.9 \"Pain Mire\" Ability { id: \"4FA4\", source: \"Spectral Necromancer\" }\r\n1196.4 \"Necromancy\" Ability { id: \"4F57\", source: \"Spectral Necromancer\" }\r\n1208.5 \"--sync--\" Ability { id: \"4F5C\", source: \"Spectral Necromancer\" }\r\n1209.5 \"Dark Deluge\" Ability { id: \"4F5D\", source: \"Spectral Necromancer\" }\r\n1218.9 \"Necroburst\" Ability { id: \"4F59\", source: \"Spectral Necromancer\" }\r\n\r\n1230.1 \"Chaos Storm\" Ability { id: \"4F60\", source: \"Spectral Necromancer\" } window 30,30 jump 1096.8\r\n1238.7 \"Necromancy\"\r\n1244.9 \"Necromancy\"\r\n1256.0 \"Dark Deluge\"\r\n1257.3 \"Death Throes\"\r\n1263.4 \"Necroburst\"\r\n\r\n#~~~~~~~~~~~~~~~~~~~~#\r\n# SPECTRAL BERSERKER #\r\n#~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 5203 5204 5209\r\n# -ic \"Steelarm Cerigg\" \"Giott The Aleforged\" \"Lue-Reeq Of The Gilded Bow\" \"Granson Of The Mournful Blade\"\r\n\r\n# Illuminated Plaza will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"DBD\" } window 2000,5\r\n2012.0 \"Beastly Fury\" Ability { id: \"520C\", source: \"Spectral Berserker\" } window 2012,5\r\n2024.4 \"Wild Anguish\" Ability { id: \"5208\", source: \"Spectral Berserker\" }\r\n2036.3 \"Raging Slice\" Ability { id: \"520A\", source: \"Spectral Berserker\" }\r\n2041.0 \"Raging Slice\" Ability { id: \"520B\", source: \"Spectral Berserker\" }\r\n2051.8 \"Beastly Fury\" Ability { id: \"520C\", source: \"Spectral Berserker\" }\r\n2066.0 \"Wild Rage\" Ability { id: \"5202\", source: \"Spectral Berserker\" } window 66,30\r\n2076.1 \"Falling Rock\" Ability { id: \"5205\", source: \"Rubble\" }\r\n2082.3 \"Wild Anguish x4\" Ability { id: \"5208\", source: \"Spectral Berserker\" }\r\n2105.7 \"--sync--\" Ability { id: \"5206\", source: \"Spectral Berserker\" }\r\n2106.2 \"Wild Rampage\" Ability { id: \"5207\", source: \"Spectral Berserker\" } window 106.2,5\r\n2117.7 \"Raging Slice\" Ability { id: \"520A\", source: \"Spectral Berserker\" }\r\n2122.6 \"Raging Slice\" Ability { id: \"520B\", source: \"Spectral Berserker\" }\r\n2127.7 \"Raging Slice\" Ability { id: \"520B\", source: \"Spectral Berserker\" }\r\n2137.6 \"Wild Rage\" Ability { id: \"5202\", source: \"Spectral Berserker\" } window 30,30\r\n2149.4 \"--sync--\" Ability { id: \"5206\", source: \"Spectral Berserker\" }\r\n2149.9 \"Wild Rampage\" Ability { id: \"5207\", source: \"Spectral Berserker\" }\r\n2157.4 \"Falling Rock\" Ability { id: \"5205\", source: \"Rubble\" }\r\n2162.6 \"Wild Anguish x4\" Ability { id: \"5208\", source: \"Spectral Berserker\" }\r\n\r\n2182.5 \"Beastly Fury\" Ability { id: \"520C\", source: \"Spectral Berserker\" } window 30,5\r\n2198.7 \"Beastly Fury\" Ability { id: \"520C\", source: \"Spectral Berserker\" }\r\n2207.8 \"Raging Slice\" Ability { id: \"520A\", source: \"Spectral Berserker\" }\r\n2212.3 \"Raging Slice\" Ability { id: \"520B\", source: \"Spectral Berserker\" }\r\n2217.2 \"Raging Slice\" Ability { id: \"520B\", source: \"Spectral Berserker\" }\r\n2226.1 \"Wild Anguish\" Ability { id: \"5208\", source: \"Spectral Berserker\" }\r\n\r\n2240.2 \"Beastly Fury\" Ability { id: \"520C\", source: \"Spectral Berserker\" } window 30,5 jump 2182.5\r\n2256.4 \"Beastly Fury\"\r\n2265.5 \"Raging Slice\"\r\n2270.0 \"Raging Slice\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/holminster_switch.ts



const holminster_switch_triggerSet = {
  id: 'HolminsterSwitch',
  zoneId: zone_id/* default.HolminsterSwitch */.Z.HolminsterSwitch,
  timelineFile: 'holminster_switch.txt',
  triggers: [{
    id: 'Holminster Path of Light',
    type: 'StartsUsing',
    netRegex: {
      id: '3DC5',
      source: 'Forgiven Dissonance',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Holminster Pillory',
    type: 'StartsUsing',
    netRegex: {
      id: '3DC4',
      source: 'Forgiven Dissonance'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Holminster Tickler',
    type: 'StartsUsing',
    netRegex: {
      id: '3DCF',
      source: 'Tesleen, The Forgiven'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Holminster Bridle',
    type: 'StartsUsing',
    netRegex: {
      id: '3DD0',
      source: 'Tesleen, The Forgiven',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Holminster Flagellation',
    type: 'StartsUsing',
    netRegex: {
      id: '3DD5',
      source: 'Tesleen, The Forgiven',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Holminster Exorcise Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Holminster Scavenger',
    type: 'StartsUsing',
    netRegex: {
      id: '3DD8',
      source: 'Philia',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Holminster Head Crusher',
    type: 'StartsUsing',
    netRegex: {
      id: '3DD7',
      source: 'Philia'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Holminster Chain Down',
    type: 'HeadMarker',
    netRegex: {
      id: '005C'
    },
    condition: conditions/* default.targetIsNotYou */.Z.targetIsNotYou(),
    infoText: (data, matches, output) => {
      return output.text({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Break chain on ${player}',
        de: 'Kette von ${player} brechen',
        fr: 'Cassez les chaînes de ${player}',
        ja: '${player}の線を取る',
        cn: '截断${player}的线',
        ko: '${player}의 사슬 부수기'
      }
    }
  }, {
    id: 'Holminster Taphephobia',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Holminster Into The Light',
    type: 'StartsUsing',
    netRegex: {
      id: '4350',
      source: 'Philia',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Stack',
        de: 'Sammeln in einer Linie',
        fr: 'Packez-vous en ligne',
        ja: '頭割り',
        cn: '直线分摊',
        ko: '직선 쉐어'
      }
    }
  }, {
    id: 'Holminster Left Knout',
    type: 'StartsUsing',
    netRegex: {
      id: '3DE7',
      source: 'Philia',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Holminster Right Knout',
    type: 'StartsUsing',
    netRegex: {
      id: '3DE6',
      source: 'Philia',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'The Wound': 'Lavendellichtung',
      'The Auction': 'Viehmarkt',
      'The manor house courtyard': 'Garten des Herrenhauses',
      'Forgiven Dissonance': 'Geläutert(?:e|er|es|en) Widerspruch',
      'Tesleen, the Forgiven': 'Tesleen (?:der|die|das) Bekehrt(?:e|er|es|en)',
      'Philia': 'Philia'
    },
    'replaceText': {
      'Aethersup': 'Ätherfresser',
      'Brazen Bull': 'Garotte',
      'Chain Down': 'Schneidende Fesseln',
      'Exorcise': 'Ikonenschreck',
      'Center': 'Mitte',
      'Fevered Flagellation': 'Grimmige Geißelung',
      'Fierce Beating': 'Gnadenlose Geißel',
      'Gibbet Cage': 'Eiserne Jungfrau',
      'Head Crusher': 'Knochenmalmer',
      'Heretic\'s Fork': 'Blutadler',
      'Holy Water': 'Segenszeichen',
      'Into The Light': 'Läuterndes Licht',
      'Left/Right Knout': 'Linker/Rechter Staupenschlag',
      'Light Shot': 'Lichtschuss',
      'Pendulum': 'Grube und Pendel',
      'Pillory': 'Herzreißer',
      'Right/Left Knout': 'Rechter/Linker Staupenschlag',
      'Scavenger\'s Daughter': 'Radebrechen',
      'Scold\'s Bridle': 'Schandmal',
      'Taphephobia': 'Taphephobie',
      'The Path Of Light': 'Pfad des Lichts',
      'The Tickler': 'Handauflegung',
      'Thumbscrew': 'Pfählung',
      'Wooden Horse': 'Estrapade'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Philia': 'Philia',
      'Forgiven Dissonance': 'Dissonance pardonnée',
      'Tesleen, the Forgiven': 'Tesleen pardonnée',
      'The Auction': 'la place du Cheptel',
      'The manor house courtyard': 'l\'esplanade du Manoir',
      'The Wound': 'La Talure'
    },
    'replaceText': {
      'The Path Of Light': 'Voie de lumière',
      'Brazen Bull': 'Taureau d\'airain',
      'Gibbet Cage': 'Gibet de fer',
      'Thumbscrew': 'Écraseur à vis',
      'Heretic\'s Fork': 'Fourche hérétique',
      'Light Shot': 'Tir de lumière',
      'Wooden Horse': 'Chevalet',
      'Pillory': 'Pilori',
      'The Tickler': 'Chatouillement',
      'Scold\'s Bridle': 'Bride-Bavarde',
      'Fevered Flagellation': 'Flagellation frénétique',
      'Exorcise': 'Exorcisme',
      'Holy Water': 'Eau bénite',
      'Into The Light': 'Dans la lumière',
      'Pendulum Tank': 'Lame pendulaire Tank',
      'Pendulum Center': 'Lame pendulaire Centre',
      'Left/Right Knout': 'Knout Gauche/Droit',
      'Right/Left Knout': 'Knout Droit/Gauche',
      'Chain Down': 'Enchaînement',
      'Aethersup': 'Sapement éthéréen',
      'Scavenger\'s Daughter': 'Fille du Boueur',
      'Head Crusher': 'Écraseur de tête',
      'Fierce Beating': 'Raclée brutale',
      'Taphephobia': 'Taphophobie'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Philia': 'フィリア',
      'Forgiven Dissonance': 'フォーギヴン・ディソナンス',
      'Tesleen, the Forgiven': 'フォーギヴン・テスリーン',
      'The Auction': '家畜市広場',
      'The manor house courtyard': 'マナーハウスの前庭',
      'The Wound': '紫黒のギャップ'
    },
    'replaceText': {
      'The Path Of Light': '光の波動',
      'Brazen Bull': 'ブレイズンブル',
      'Gibbet Cage': 'ジベットケージ',
      'Thumbscrew': 'サムスクリュー',
      'Heretic\'s Fork': 'ヘレティックフォーク',
      'Light Shot': 'ライトショット',
      'Wooden Horse': 'ウッデンホース',
      'Pillory': 'ピロリー',
      'The Tickler': 'ティッカー',
      'Scold\'s Bridle': 'スコルドブライダル',
      'Fevered Flagellation': 'フィバードフラジレーション',
      'Exorcise': 'エクソサイズ',
      'Holy Water': 'ホリーウォーター',
      'Into The Light': 'インツーライト',
      'Pendulum Tank': 'ペンデュラム：タンク',
      'Pendulum Center': 'ペンデュラム：中央',
      'Left/Right Knout': 'クヌート：左／右',
      'Right/Left Knout': 'クヌート：右／左',
      'Chain Down': 'チェーンダウン',
      'Aethersup': 'エーテルサップ',
      'Scavenger\'s Daughter': 'スカベンジャーズドーター',
      'Head Crusher': 'ヘッドクラッシャー',
      'Fierce Beating': 'フィアスビーティング',
      'Taphephobia': 'タフィフォビア'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'The Wound': '검보라 틈',
      'The Auction': '가축 시장',
      'The manor house courtyard': '저택 앞뜰',
      'Forgiven Dissonance': '면죄된 불화',
      'Tesleen, the Forgiven': '면죄된 테슬린',
      'Philia': '필리아'
    },
    'replaceText': {
      'The Path Of Light': '빛의 파동',
      'Brazen Bull': '빛올가미',
      'Gibbet Cage': '교형틀',
      'Thumbscrew': '손가락 으깨기',
      'Heretic\'s Fork': '이단자의 창',
      'Light Shot': '빛 발사',
      'Wooden Horse': '삼각목마',
      'Pillory': '항쇄',
      'The Tickler': '심장 찌르기',
      'Scold\'s Bridle': '입막음 굴레',
      'Fevered Flagellation': '불타는 채찍질',
      'Exorcise': '구마 의식',
      'Holy Water': '성수',
      'Into The Light': '빛 속으로',
      'Pendulum Tank': '진자 (탱커)',
      'Pendulum Center': '진자 (중앙)',
      'Left/Right Knout': '왼쪽/오른쪽 잡아채기',
      'Right/Left Knout': '오른쪽/왼쪽 잡아채기',
      'Chain Down': '사슬 구속',
      'Aethersup': '에테르 섭취',
      'Scavenger\'s Daughter': '쇠고랑',
      'Head Crusher': '머리 부수기',
      'Fierce Beating': '공포의 매질',
      'Taphephobia': '공포의 생매장'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'The Wound': '紫黑裂痕',
      'The Auction': '家畜卖场',
      'The manor house courtyard': '领主府前院',
      'Forgiven Dissonance': '得到宽恕的失调',
      'Tesleen, the Forgiven': '得到宽恕的泰丝琳',
      'Philia': '斐利亚'
    },
    'replaceText': {
      'Aethersup': '吸取以太',
      'Brazen Bull': '铜牛',
      'Chain Down': '束缚',
      'Exorcise': '驱魔',
      'Fevered Flagellation': '鞭笞',
      'Fierce Beating': '激烈捶打',
      'Gibbet Cage': '绞刑笼',
      'Head Crusher': '裂脑',
      'Heretic\'s Fork': '异端十字叉',
      'Holy Water': '圣水',
      'Into The Light': '埋没之光',
      'Left/Right Knout': '左/右鞭打',
      'Light Shot': '光线射击',
      'Pendulum': '钟摆',
      'Pillory': '颈手枷',
      'Right/Left Knout': '右/左鞭打',
      'Scavenger\'s Daughter': '拾荒者之女',
      'Scold\'s Bridle': '毒舌钩',
      'Taphephobia': '土埋',
      'The Path Of Light': '光之波动',
      'The Tickler': '抓挠',
      'Thumbscrew': '螺旋突刺',
      'Wooden Horse': '木马',
      'Tank': '坦克',
      'Center': '中心'
    }
  }]
};
/* harmony default export */ const holminster_switch = (holminster_switch_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/holminster_switch.txt
const dungeon_holminster_switch_namespaceObject = "### Holminster Switch (71 dungeon)\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Forgiven Dissonance\r\n# -p 3DC5:112\r\n# The Wound will be sealed off\r\n100.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"CD4\" } window 100,0\r\n112.0 \"The Path Of Light\" Ability { id: \"3DC5\", source: \"Forgiven Dissonance\" } window 112,0\r\n120.4 \"Brazen Bull\" Ability { id: \"3DC9\", source: \"Forgiven Dissonance\" }\r\n126.5 \"Gibbet Cage\" Ability { id: \"3DC8\", source: \"Forgiven Dissonance\" }\r\n134.4 \"Thumbscrew\" Ability { id: \"3DC6\", source: \"Forgiven Dissonance\" }\r\n134.6 \"Heretic's Fork\" Ability { id: \"3DCE\", source: \"Forgiven Dissonance\" }\r\n139.7 \"Light Shot\" Ability { id: \"3DCB\", source: \"Forgiven Dissonance\" }\r\n142.0 \"Wooden Horse\" Ability { id: \"3DC7\", source: \"Forgiven Dissonance\" }\r\n\r\n154.2 \"The Path Of Light\" Ability { id: \"3DC5\", source: \"Forgiven Dissonance\" }\r\n162.5 \"Pillory\" Ability { id: \"3DC4\", source: \"Forgiven Dissonance\" }\r\n173.0 \"Brazen Bull\" Ability { id: \"3DC9\", source: \"Forgiven Dissonance\" }\r\n182.3 \"Gibbet Cage\" Ability { id: \"3DC8\", source: \"Forgiven Dissonance\" }\r\n187.2 \"Heretic's Fork\" Ability { id: \"3DCE\", source: \"Forgiven Dissonance\" }\r\n190.3 \"Thumbscrew\" Ability { id: \"3DC6\", source: \"Forgiven Dissonance\" }\r\n192.3 \"Light Shot\" Ability { id: \"3DCB\", source: \"Forgiven Dissonance\" }\r\n\r\n202.8 \"The Path Of Light\" Ability { id: \"3DC5\", source: \"Forgiven Dissonance\" }\r\n211.1 \"Pillory\" Ability { id: \"3DC4\", source: \"Forgiven Dissonance\" }\r\n218.9 \"Brazen Bull\" Ability { id: \"3DC9\", source: \"Forgiven Dissonance\" }\r\n226.8 \"Thumbscrew\" Ability { id: \"3DC6\", source: \"Forgiven Dissonance\" }\r\n233.0 \"Heretic's Fork\" Ability { id: \"3DCE\", source: \"Forgiven Dissonance\" }\r\n234.5 \"Wooden Horse\" Ability { id: \"3DC7\", source: \"Forgiven Dissonance\" }\r\n238.2 \"Light Shot\" Ability { id: \"3DCB\", source: \"Forgiven Dissonance\" }\r\n241.4 \"Thumbscrew\" Ability { id: \"3DC6\", source: \"Forgiven Dissonance\" }\r\n243.2 \"Heretic's Fork\" Ability { id: \"3DCE\", source: \"Forgiven Dissonance\" }\r\n248.4 \"Light Shot\" Ability { id: \"3DCB\", source: \"Forgiven Dissonance\" }\r\n249.0 \"Wooden Horse\" Ability { id: \"3DC7\", source: \"Forgiven Dissonance\" }\r\n\r\n261.3 \"The Path Of Light\" Ability { id: \"3DC5\", source: \"Forgiven Dissonance\" } window 30,30 jump 154.2\r\n269.6 \"Pillory\"\r\n280.1 \"Brazen Bull\"\r\n289.4 \"Gibbet Cage\"\r\n294.3 \"Heretic's Fork\"\r\n297.4 \"Thumbscrew\"\r\n299.4 \"Light Shot\"\r\n309.9 \"The Path Of Light\"\r\n\r\n\r\n### Tesleen, the Forgiven\r\n# -ii 3DD6 3DD3 -p 3DCF:513.5\r\n# The Auction will be sealed off\r\n500.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"CD5\" } window 500,0\r\n513.5 \"The Tickler\" Ability { id: \"3DCF\", source: \"Tesleen, the Forgiven\" } window 514,5\r\n523.6 \"Scold's Bridle\" Ability { id: \"3DD0\", source: \"Tesleen, the Forgiven\" }\r\n533.8 \"Fevered Flagellation\" Ability { id: \"3DD5\", source: \"Tesleen, the Forgiven\" }\r\n548.3 \"Scold's Bridle\" Ability { id: \"3DD0\", source: \"Tesleen, the Forgiven\" }\r\n558.6 \"Exorcise\" Ability { id: \"3DD2\", source: \"Tesleen, the Forgiven\" }\r\n560.4 \"Holy Water\" Ability { id: \"3DD4\", source: \"Tesleen, the Forgiven\" }\r\n573.8 \"Fevered Flagellation\" Ability { id: \"3DD5\", source: \"Tesleen, the Forgiven\" }\r\n\r\n578.7 \"--sync--\" Ability { id: \"3DD1\", source: \"Tesleen, the Forgiven\" }\r\n594.8 \"Scold's Bridle\" Ability { id: \"3DD0\", source: \"Tesleen, the Forgiven\" } window 3,3\r\n602.0 \"Scold's Bridle\" Ability { id: \"3DD0\", source: \"Tesleen, the Forgiven\" } window 3,3\r\n612.1 \"The Tickler\" Ability { id: \"3DCF\", source: \"Tesleen, the Forgiven\" }\r\n619.2 \"Scold's Bridle\" Ability { id: \"3DD0\", source: \"Tesleen, the Forgiven\" }\r\n636.4 \"Exorcise\" Ability { id: \"3DD2\", source: \"Tesleen, the Forgiven\" }\r\n638.3 \"Holy Water\" Ability { id: \"3DD4\", source: \"Tesleen, the Forgiven\" }\r\n651.6 \"Fevered Flagellation\" Ability { id: \"3DD5\", source: \"Tesleen, the Forgiven\" }\r\n\r\n656.7 \"--sync--\" Ability { id: \"3DD1\", source: \"Tesleen, the Forgiven\" } window 30,30 jump 578.7\r\n672.8 \"Scold's Bridle\"\r\n680.0 \"Scold's Bridle\"\r\n690.1 \"The Tickler\"\r\n697.2 \"Scold's Bridle\"\r\n714.4 \"Exorcise\"\r\n716.3 \"Holy Water\"\r\n729.6 \"Fevered Flagellation\"\r\n\r\n\r\n### Philia\r\n# -ii 3DDD 3DDF 3DDE 3DDC 3DDB 3DE1 3DE0 3DE9 4196 3DE5 4181 -p 3DD8:1012.5\r\n# The Manor House Courtyard will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"CD7\" } window 1000,0\r\n1012.5 \"Scavenger's Daughter\" Ability { id: \"3DD8\", source: \"Philia\" } window 1012.5,10\r\n1022.8 \"Head Crusher\" Ability { id: \"3DD7\", source: \"Philia\" }\r\n1032.9 \"Pendulum Tank\" Ability { id: \"4189\", source: \"Philia\" }\r\n1035.0 \"Pendulum Center\" Ability { id: \"3DD9\", source: \"Philia\" }\r\n\r\n1035.5 \"--sync--\" Ability { id: \"418A\", source: \"Philia\" }\r\n1042.1 \"Chain Down\" Ability { id: \"429C\", source: \"Philia\" }\r\n1059.5 \"Aethersup\" Ability { id: \"3DE8\", source: \"Philia\" } duration 3.5\r\n\r\n1070.1 \"Left/Right Knout\" Ability { id: \"3DE[67]\", source: \"Philia\" }\r\n1077.1 \"Right/Left Knout\" Ability { id: \"3DE[67]\", source: \"Philia\" }\r\n1088.4 \"Head Crusher\" Ability { id: \"3DD7\", source: \"Philia\" }\r\n1095.0 \"Taphephobia\" Ability { id: \"3DE2\", source: \"Philia\" }\r\n\r\n1097.2 \"--sync--\" Ability { id: \"3DE4\", source: \"Philia\" }\r\n1102.1 \"Into The Light\" Ability { id: \"4350\", source: \"Philia\" }\r\n1122.8 \"Pendulum Tank\" Ability { id: \"4189\", source: \"Philia\" }\r\n1125.0 \"Pendulum Center\" Ability { id: \"3DD9\", source: \"Philia\" }\r\n\r\n1125.4 \"--sync--\" Ability { id: \"418A\", source: \"Philia\" }\r\n1132.3 \"Fierce Beating\" Ability { id: \"3DDA\", source: \"Philia\" } duration 42\r\n\r\n1165.8 \"--sync--\" Ability { id: \"3DE4\", source: \"Philia\" }\r\n1170.8 \"Into The Light\" Ability { id: \"4350\", source: \"Philia\" }\r\n1178.5 \"Left/Right Knout\" Ability { id: \"3DE[67]\", source: \"Philia\" }\r\n1185.7 \"Right/Left Knout\" Ability { id: \"3DE[67]\", source: \"Philia\" }\r\n1192.9 \"Chain Down\" Ability { id: \"429C\", source: \"Philia\" }\r\n1210.3 \"Aethersup\" Ability { id: \"3DE8\", source: \"Philia\" } duration 3.5\r\n1225.6 \"Scavenger's Daughter\" Ability { id: \"3DD8\", source: \"Philia\" }\r\n1244.9 \"Head Crusher\" Ability { id: \"3DD7\", source: \"Philia\" }\r\n1251.6 \"Taphephobia\" Ability { id: \"3DE2\", source: \"Philia\" }\r\n\r\n1253.8 \"--sync--\" Ability { id: \"3DE4\", source: \"Philia\" } window 30,30 jump 1097.2\r\n1258.7 \"Into The Light\"\r\n1279.4 \"Pendulum Tank\"\r\n1281.6 \"Pendulum Center\"\r\n\r\n1282.0 \"--sync--\"\r\n1288.9 \"Fierce Beating\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/malikahs_well.ts


const malikahs_well_triggerSet = {
  id: 'MalikahsWell',
  zoneId: zone_id/* default.MalikahsWell */.Z.MalikahsWell,
  timelineFile: 'malikahs_well.txt',
  triggers: [{
    id: 'Malikah Stone Flail',
    type: 'StartsUsing',
    netRegex: {
      id: '3CE5',
      source: 'Greater Armadillo'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Malikah Head Toss Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Malikah Right Round',
    type: 'StartsUsing',
    netRegex: {
      id: '3CE7',
      source: 'Greater Armadillo',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Melee Knockback',
        de: 'Nahkämpfer Rückstoß',
        fr: 'Poussée au CaC',
        ja: '近接最大距離ノックバック',
        cn: '近战击退',
        ko: '근거리 넉백'
      }
    }
  }, {
    id: 'Malikah Deep Draught',
    type: 'StartsUsing',
    netRegex: {
      id: '4188',
      source: 'Pack Armadillo'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt('info')
  }, {
    id: 'Malikah Efface',
    type: 'StartsUsing',
    netRegex: {
      id: '3CEB',
      source: 'Amphibious Talos'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Malikah High Pressure',
    type: 'StartsUsing',
    netRegex: {
      id: '3CEC',
      source: 'Amphibious Talos',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback('info')
  }, {
    id: 'Malikah Swift Spill',
    type: 'StartsUsing',
    netRegex: {
      id: '3CEF',
      source: 'Amphibious Talos',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind('info')
  }, {
    id: 'Malikah Intestinal Crank',
    type: 'StartsUsing',
    netRegex: {
      id: '3CF1',
      source: 'Storge',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Pack Armadillo': 'Rudel-Gürteltier',
      'Terminus': 'Drehscheibe',
      'Malikah\'s Gift': 'Malikahs Quelle',
      'Unquestioned Acceptance': 'Residenz der Großherzigkeit',
      'Greater Armadillo': 'Riesengürteltier',
      'Amphibious Talos': 'Wasserträger-Talos',
      'Storge': 'Storge',
      'Rhapsodic Nail': 'Keil der Liebe'
    },
    'replaceText': {
      'Pack Armadillo': 'Rudel-Gürteltier',
      'Stone Flail': 'Steindresche',
      'Head Toss': 'Kopfwurf',
      'Right Round': 'Rotation',
      'Flail Smash': 'Dresche',
      'Earthshake': 'Bodenbeber',
      'Efface': 'Zerstören',
      'Wellbore': 'Kübelwirbel',
      'Geyser Eruption': 'Geysir',
      'High Pressure': 'Überdruck',
      'Swift Spill': 'Schneller Abfluss',
      'Intestinal Crank': 'Geweiderupfer',
      'Heretic\'s Fork': 'Blutadler',
      'Breaking Wheel': 'Radbruch',
      'Crystal Nail': 'Kristallnagel',
      'Censure': 'Tadel',
      '(?!<Pack )Armadillo': 'Armadillo'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Pack Armadillo': 'Tatou Grégaire',
      'Amphibious Talos': 'Talos Amphibie',
      'Greater Armadillo': 'Grand Tatou',
      'Malikah\'s Gift': 'le Source de Malikah',
      'Rhapsodic Nail': 'Pieu Rhapsodique',
      'Storge': 'Storgê',
      'Terminus': 'cimetière de chariots',
      'Unquestioned Acceptance': 'l\'aven oublié'
    },
    'replaceText': {
      '\\?': ' ?',
      'Breaking Wheel': 'Roue de la torture',
      'Censure': 'Blâme',
      'Crystal Nail': 'Clou de cristal',
      'Earthshake': 'Vacillation',
      'Efface': 'Désintégration',
      'Flail Smash': 'Fléau fracassant',
      'Geyser Eruption': 'Geyser aqueux',
      'Head Toss': 'Tournis',
      'Heretic\'s Fork': 'Fourche de l\'hérétique',
      'High Pressure': 'Haute pression',
      'Intestinal Crank': 'Manivelle intestinale',
      'Pack Armadillo': 'Tatou grégaire',
      'Right Round': 'Grande culbute',
      'Stone Flail': 'Fléau rocheux',
      'Swift Spill': 'Déversement',
      'Wellbore': 'Forage profond'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Pack Armadillo': 'パック・アルマジロ',
      'Amphibious Talos': 'ハイドロタロース',
      'Greater Armadillo': 'グレーター・アルマジロ',
      'Malikah\'s Gift': 'マリカの水源',
      'Rhapsodic Nail': '愛の楔',
      'Storge': 'ストルゲー',
      'Terminus': 'トロッコターミナル',
      'Unquestioned Acceptance': '無償の離宮'
    },
    'replaceText': {
      '\\?': ' ?',
      'Breaking Wheel': 'ブレイキングホイール',
      'Censure': '執行',
      'Crystal Nail': '杭打ち',
      'Earthshake': '地盤振動',
      'Efface': 'デストロイ',
      'Flail Smash': 'フレイルスマッシュ',
      'Geyser Eruption': 'ガイザー',
      'Head Toss': 'ヘッドトス',
      'Heretic\'s Fork': 'ヘレティックフォーク',
      'High Pressure': 'ハイプレッシャー',
      'Intestinal Crank': 'インテスティナルクランク',
      'Pack Armadillo': 'パック・アルマジロ',
      'Right Round': '大回転',
      'Stone Flail': 'ロックフレイル',
      'Swift Spill': '強制放水',
      'Wellbore': 'ウェルボーラー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Pack Armadillo': '群落犰狳',
      'Terminus': '轨道车站',
      'Malikah\'s Gift': '马利卡水源',
      'Unquestioned Acceptance': '无偿离宫',
      'Greater Armadillo': '大犰狳',
      'Amphibious Talos': '水陆两用塔罗斯',
      'Storge': '斯托尔戈',
      'Rhapsodic Nail': '爱之桩柱'
    },
    'replaceText': {
      'Stone Flail': '落石重锤',
      'Head Toss': '甩尾锤',
      'Right Round': '大回旋',
      'Flail Smash': '重锤碎击',
      'Earthshake': '地盘震动',
      'Efface': '抹灭',
      'Wellbore': '钻井',
      'Geyser Eruption': '井水喷出',
      'High Pressure': '高压',
      'Swift Spill': '强制放水',
      'Intestinal Crank': '绞肠',
      'Heretic\'s Fork': '异端十字叉',
      'Breaking Wheel': '碎轮',
      'Crystal Nail': '打桩',
      'Censure': '执行',
      'Armadillo': '犰狳',
      'Pack': ''
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Pack Armadillo': '무리 아르마딜로',
      'Terminus': '광차 종점',
      'Malikah\'s Gift': '말리카의 수원',
      'Unquestioned Acceptance': '시민 별장',
      'Greater Armadillo': '거대 아르마딜로',
      'Amphibious Talos': '수력 탈로스',
      'Storge': '스토르게',
      'Rhapsodic Nail': '사랑의 말뚝'
    },
    'replaceText': {
      'Stone Flail': '바위 타작',
      'Head Toss': '머리 겨냥',
      'Right Round': '대회전',
      'Flail Smash': '타작 충돌',
      'Earthshake': '지반 진동',
      'Efface': '파괴',
      'Wellbore': '우물 파기',
      'Geyser Eruption': '간헐천',
      'High Pressure': '고압',
      'Swift Spill': '강제 급수',
      'Intestinal Crank': '창자 비틀기',
      'Heretic\'s Fork': '이단자의 창',
      'Breaking Wheel': '파괴의 바퀴',
      'Crystal Nail': '말뚝박기',
      'Censure': '집행',
      '2x Pack Armadillo': '쫄 2마리 소환'
    }
  }]
};
/* harmony default export */ const malikahs_well = (malikahs_well_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/malikahs_well.txt
const dungeon_malikahs_well_namespaceObject = "### Malikah's Well (lvl 77 dungeon)\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Greater Armadillo\r\n# -ii 3CEA 3CE8 -p 3CE5:115\r\n# Terminus will be sealed off\r\n100.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"BD5\" } window 100,0\r\n\r\n115.0 \"Stone Flail\" Ability { id: \"3CE5\", source: \"Greater Armadillo\" } window 115,5\r\n133.6 \"Head Toss\" Ability { id: \"3CE6\", source: \"Greater Armadillo\" }\r\n138.6 \"Right Round\" Ability { id: \"3CE7\", source: \"Greater Armadillo\" }\r\n144.2 \"Flail Smash\" Ability { id: \"3CE9\", source: \"Greater Armadillo\" }\r\n148.9 \"Earthshake\" Ability { id: \"3E39\", source: \"Greater Armadillo\" }\r\n\r\n160.7 \"2x Pack Armadillo\"\r\n\r\n175.3 \"Stone Flail\" Ability { id: \"3CE5\", source: \"Greater Armadillo\" }\r\n198.0 \"Head Toss\" Ability { id: \"3CE6\", source: \"Greater Armadillo\" }\r\n203.0 \"Right Round\" Ability { id: \"3CE7\", source: \"Greater Armadillo\" }\r\n208.6 \"Flail Smash\" Ability { id: \"3CE9\", source: \"Greater Armadillo\" }\r\n213.3 \"Earthshake\" Ability { id: \"3E39\", source: \"Greater Armadillo\" }\r\n\r\n225.1 \"2x Pack Armadillo\"\r\n\r\n239.6 \"Stone Flail\" Ability { id: \"3CE5\", source: \"Greater Armadillo\" }\r\n262.0 \"Head Toss\" Ability { id: \"3CE6\", source: \"Greater Armadillo\" }\r\n266.9 \"Right Round\" Ability { id: \"3CE7\", source: \"Greater Armadillo\" }\r\n272.5 \"Flail Smash\" Ability { id: \"3CE9\", source: \"Greater Armadillo\" }\r\n277.2 \"Earthshake\" Ability { id: \"3E39\", source: \"Greater Armadillo\" }\r\n\r\n289.0 \"2x Pack Armadillo\"\r\n\r\n303.5 \"Stone Flail\" Ability { id: \"3CE5\", source: \"Greater Armadillo\" } window 20,20 jump 175.3\r\n326.2 \"Head Toss\"\r\n331.2 \"Right Round\"\r\n336.8 \"Flail Smash\"\r\n341.5 \"Earthshake\"\r\n\r\n353.3 \"2x Pack Armadillo\"\r\n\r\n\r\n### Amphibious Talos\r\n# -ii 3CF0 -p 3CEB:515.5\r\n# Malikah's Gift will be sealed off\r\n500.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"BD6\" } window 500,0\r\n515.5 \"Efface\" Ability { id: \"3CEB\", source: \"Amphibious Talos\" } window 515.5,10\r\n527.1 \"Wellbore\" Ability { id: \"3CED\", source: \"Amphibious Talos\" }\r\n531.3 \"Geyser Eruption\" Ability { id: \"3CEE\", source: \"Amphibious Talos\" }\r\n534.1 \"High Pressure\" Ability { id: \"3CEC\", source: \"Amphibious Talos\" }\r\n544.5 \"Swift Spill x6\" Ability { id: \"3CEF\", source: \"Amphibious Talos\" } duration 6.4\r\n562.4 \"Efface\" Ability { id: \"3CEB\", source: \"Amphibious Talos\" }\r\n575.1 \"Efface\" Ability { id: \"3CEB\", source: \"Amphibious Talos\" }\r\n\r\n590.4 \"Wellbore\" Ability { id: \"3CED\", source: \"Amphibious Talos\" }\r\n594.6 \"Geyser Eruption\" Ability { id: \"3CEE\", source: \"Amphibious Talos\" }\r\n597.4 \"High Pressure\" Ability { id: \"3CEC\", source: \"Amphibious Talos\" }\r\n608.0 \"Swift Spill x6\" Ability { id: \"3CEF\", source: \"Amphibious Talos\" } duration 6.4\r\n625.9 \"Efface\" Ability { id: \"3CEB\", source: \"Amphibious Talos\" }\r\n638.6 \"Efface\" Ability { id: \"3CEB\", source: \"Amphibious Talos\" }\r\n\r\n653.9 \"Wellbore\" Ability { id: \"3CED\", source: \"Amphibious Talos\" } window 20,20 jump 590.4\r\n658.1 \"Geyser Eruption\"\r\n660.9 \"High Pressure\"\r\n671.5 \"Swift Spill x6\" duration 6.4\r\n689.4 \"Efface\"\r\n702.1 \"Efface\"\r\n\r\n\r\n### Storge\r\n# -ii 3CF7 3CA8 41A8 -p 3CF1:1015\r\n# Unquestioned Acceptance will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"BD7\" } window 1000,0\r\n1015.0 \"Intestinal Crank\" Ability { id: \"3CF1\", source: \"Storge\" } window 1015,5\r\n1028.2 \"Heretic's Fork\" Ability { id: \"3CF2\", source: \"Storge\" }\r\n1043.0 \"Breaking Wheel\" Ability { id: \"3CF5\", source: \"Storge\" }\r\n\r\n1056.1 \"Crystal Nail\" Ability { id: \"3CF6\", source: \"Storge\" }\r\n1063.2 \"Heretic's Fork?\" Ability { id: \"3CF2\", source: \"Storge\" } window 10,10 jump 2063.2\r\n1065.7 \"Breaking Wheel?\" Ability { id: \"3CF5\", source: \"Storge\" } window 10,10 jump 2156.2\r\n\r\n2056.1 \"Crystal Nail\" Ability { id: \"3CF6\", source: \"Storge\" }\r\n2063.2 \"Heretic's Fork\" Ability { id: \"3CF2\", source: \"Storge\" }\r\n2068.3 \"Censure\" Ability { id: \"3CF8\", source: \"Storge\" }\r\n2078.5 \"Heretic's Fork\" #Ability { id: \"3CF9\", source: \"Rhapsodic Nail\" }\r\n2082.5 \"Heretic's Fork\" #Ability { id: \"3CF9\", source: \"Rhapsodic Nail\" }\r\n2086.5 \"Heretic's Fork\" #Ability { id: \"3CF9\", source: \"Rhapsodic Nail\" }\r\n2090.5 \"Heretic's Fork\" #Ability { id: \"3CF9\", source: \"Rhapsodic Nail\" }\r\n2093.4 \"Heretic's Fork\" Ability { id: \"3E0E\", source: \"Storge\" }\r\n2105.6 \"Intestinal Crank\" Ability { id: \"3CF1\", source: \"Storge\" }\r\n2119.7 \"Intestinal Crank\" Ability { id: \"3CF1\", source: \"Storge\" }\r\n2133.8 \"Intestinal Crank\" Ability { id: \"3CF1\", source: \"Storge\" }\r\n\r\n2146.6 \"Crystal Nail\" Ability { id: \"3CF6\", source: \"Storge\" }\r\n2156.2 \"Breaking Wheel\" Ability { id: \"3CF5\", source: \"Storge\" }\r\n2161.4 \"Censure\" Ability { id: \"3E37\", source: \"Storge\" }\r\n2172.5 \"Breaking Wheel\" #Ability { id: \"3CFA\", source: \"Rhapsodic Nail\" }\r\n2177.7 \"Breaking Wheel\" #Ability { id: \"3CFA\", source: \"Rhapsodic Nail\" }\r\n2182.7 \"Breaking Wheel\" #Ability { id: \"3CFA\", source: \"Rhapsodic Nail\" }\r\n2187.7 \"Breaking Wheel\" #Ability { id: \"3CFA\", source: \"Rhapsodic Nail\" }\r\n2192.6 \"Breaking Wheel\" Ability { id: \"3E0F\", source: \"Storge\" }\r\n2212.4 \"Intestinal Crank\" Ability { id: \"3CF1\", source: \"Storge\" }\r\n2226.5 \"Intestinal Crank\" Ability { id: \"3CF1\", source: \"Storge\" }\r\n2240.6 \"Intestinal Crank\" Ability { id: \"3CF1\", source: \"Storge\" }\r\n\r\n2253.4 \"Crystal Nail\" Ability { id: \"3CF6\", source: \"Storge\" } window 50,50 jump 2056.1\r\n2260.5 \"Heretic's Fork\"\r\n2265.5 \"Censure\"\r\n2275.7 \"Heretic's Fork\"\r\n2279.7 \"Heretic's Fork\"\r\n2283.7 \"Heretic's Fork\"\r\n2287.7 \"Heretic's Fork\"\r\n2290.5 \"Heretic's Fork\"\r\n2302.7 \"Intestinal Crank\"\r\n2316.8 \"Intestinal Crank\"\r\n2331.0 \"Intestinal Crank\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/matoyas_relict.ts




const matoyas_relict_triggerSet = {
  id: 'MatoyasRelict',
  zoneId: zone_id/* default.MatoyasRelict */.Z.MatoyasRelict,
  timelineFile: 'matoyas_relict.txt',
  triggers: [{
    id: 'Matoyas Mudman Hard Rock',
    type: 'StartsUsing',
    netRegex: {
      id: '547F',
      source: 'Mudman'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Matoyas Mudman Peat Pelt',
    type: 'Ability',
    netRegex: {
      id: '5482',
      source: 'Mudman',
      capture: false
    },
    alertText: (_data, _matches, output) => output.pullOrb(),
    outputStrings: {
      pullOrb: {
        en: 'Pull orb to an empty hole',
        de: 'Orb in ein Loch lenken',
        fr: 'Tirez l\'orbe vers un trou vide',
        ja: '泥団子を四隅の穴に誘導',
        cn: '诱导泥球到无敌人的风圈',
        ko: '빈 구멍으로 구슬 보내기'
      }
    }
  }, {
    id: 'Matoyas Mudman Stone Age',
    type: 'StartsUsing',
    netRegex: {
      id: '5491',
      source: 'Mudman',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Matoyas Mudman Falling Rock',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Matoyas Mudman Sputter',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Matoyas Nixie Crash-smash',
    type: 'HeadMarker',
    netRegex: {
      id: '00E6'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.tankBuster();
      return output.avoidTether({
        player: matches.target
      });
    },
    outputStrings: {
      tankBuster: outputs/* default.tankBuster */.Z.tankBuster,
      avoidTether: {
        en: 'Avoid ${player} and tethers',
        de: 'Weiche ${player} und Verbindungen aus',
        fr: 'Évitez ${player} et les liens',
        ja: '${player}と線から離れる',
        cn: '远离${player}及其连线',
        ko: '${player}와 선 피하기'
      }
    }
  }, {
    id: 'Matoyas Nixie Shower Power',
    type: 'StartsUsing',
    netRegex: {
      id: '5991',
      source: 'Nixie',
      capture: false
    },
    alertText: (_data, _matches, output) => output.avoidWall(),
    outputStrings: {
      avoidWall: {
        en: 'Avoid Wall Flush',
        de: 'Weiche den Wand-Stömmungen aus',
        fr: 'Évitez le jet d\'eau',
        ja: '光ってない横列に移動',
        cn: '站在墙壁未发光的一列',
        ko: '벽 물줄기 피하기'
      }
    }
  }, {
    id: 'Matoyas Nixie Pitter-patter',
    type: 'Ability',
    netRegex: {
      id: '5988',
      source: 'Nixie',
      capture: false
    },
    delaySeconds: 3,
    durationSeconds: 6,
    infoText: (_data, _matches, output) => output.stepIn(),
    outputStrings: {
      stepIn: {
        en: 'Step in Puddle near the Cloud',
        de: 'In einer Fläche nahe der Wolke stehen',
        fr: 'Marchez dans la zone au sol près du nuage',
        ja: '雲に近い水を踏む',
        cn: '站在靠近云朵的水流里等待浮空',
        ko: '구름 근처 물줄기 위에 서기'
      }
    }
  }, {
    id: 'Matoyas Porxie Tender Loin',
    type: 'StartsUsing',
    netRegex: {
      id: '5913',
      source: 'Mother Porxie',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Matoyas Porxie Huff and Puff',
    type: 'StartsUsing',
    netRegex: {
      id: '5919',
      source: 'Mother Porxie',
      capture: false
    },
    alertText: (_data, _matches, output) => output.getKnocked(),
    outputStrings: {
      getKnocked: {
        en: 'Get Knocked into Safe (no anti-knockback)',
        de: 'Lass dich in den Safespot zurückstoßen (kein Rückstoßschutz)',
        fr: 'Faites-vous pousser en zone safe (pas d\'anti-poussée)',
        ja: 'ボスの正面に (堅実魔効かない)',
        cn: '站在Boss正面 (防击退无效)',
        ko: '안전한 구역으로 넉백당하기'
      }
    }
  }, {
    id: 'Matoyas Porxie Meat Mallet',
    type: 'StartsUsing',
    netRegex: {
      id: '5916',
      source: 'Mother Porxie',
      capture: false
    },
    alertText: (_data, _matches, output) => output.awayFromAoe(),
    outputStrings: {
      awayFromAoe: {
        en: 'Go to Opposite Side',
        de: 'Geh auf die andere Seite',
        fr: 'Allez du côté opposé',
        ja: '反対側へ',
        cn: '对面躲避坠落',
        ko: '반대편으로 이동'
      }
    }
  }, {
    id: 'Matoyas Porxie Sucked In',
    type: 'GainsEffect',
    netRegex: {
      effectId: '9B6'
    },
    suppressSeconds: (_data, matches) => parseFloat(matches.duration),
    alarmText: (_data, _matches, output) => output.runAway(),
    outputStrings: {
      runAway: {
        en: 'RUN AWAY',
        de: 'RENN WEG',
        fr: 'FUYEZ',
        ja: 'ボスから離れる',
        cn: '远离即死区',
        ko: '바람 반대로 뛰기'
      }
    }
  }, {
    id: 'Matoyas Porxie Minced Meat',
    type: 'StartsUsing',
    netRegex: {
      id: '5911',
      source: 'Mother Porxie'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Matoyas Porxie Sprite Explosion',
    type: 'StartsUsing',
    netRegex: {
      id: '4E34',
      source: 'aeolian cave sprite',
      capture: false
    },
    delaySeconds: 5,
    alertText: (_data, _matches, output) => output.goBoss(),
    outputStrings: {
      goBoss: {
        en: 'Go to Boss',
        de: 'Gehe zum Boss',
        fr: 'Allez vers le boss',
        ja: 'ボスの場所に移動',
        cn: '站在Boss正下方',
        ko: '보스쪽으로'
      }
    }
  }, {
    id: 'Matoyas Porxie Open Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '5922',
      source: 'Mother Porxie',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aeolian Cave Sprite': 'Windhöhlen-Exergon',
      'The Clayclot Cauldron': 'Lehmgrube',
      'The Clearnote Cauldron': 'Stromkreuz',
      'Mother Porxie': 'Muttersau',
      'Mud Bubble': 'Matschblase',
      'Mudman': 'Matschmann',
      'Nixie': 'Nixchen',
      'The Woebegone Workshop': 'Geht-Weg-Werkstatt'
    },
    'replaceText': {
      'Barbeque': 'Grillfest',
      'Brittle Breccia': 'Gesteinslawine',
      'Buffet': 'Bö',
      'Crash-Smash': 'Plitsch, platsch',
      'Explosion': 'Explosion',
      'Falling Rock': 'Steinschlag',
      'Hard Rock': 'Schlammstachel',
      'Huff And Puff': 'Pusten',
      'Meat Mallet': 'Fleischklopfer',
      'Medium Rear': 'Halb durch',
      'Minced Meat': 'Wolfer',
      'Open Flame': 'Auf offener Flamme',
      'Peat Pelt': 'Mjam Mjam Matschkuchen',
      'Petrified Peat': 'Matschkuchen',
      'Pitter-Patter': 'Plitter, platter',
      'Rocky Roll': 'Kullerklumpen',
      'Stone Age': 'Grollende Erde',
      'Shower Power': 'Glug, glug',
      'Sea Shanty': 'Pitsche, patsche',
      'Splish-Splash': 'Blubber, blubber',
      'Tender Loin': 'Plattierer',
      'To A Crisp': 'Komplett verkohlt'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aeolian Cave Sprite': 'élémentaire des cavernes venteuses',
      'The Clayclot Cauldron': 'La carrière clinquante',
      'The Clearnote Cauldron': 'La fontaine frisquette',
      'Mother Porxie': 'mère porxie',
      'Mud Bubble': 'bulle de boue',
      'Mudman': 'tadboue',
      'Nixie': 'nixe',
      'The Woebegone Workshop': 'Grand four délaissé'
    },
    'replaceText': {
      'Barbeque': 'Grillade au barbecue',
      'Brittle Breccia': 'Fracas de roche',
      'Buffet': 'Rafale',
      'Crash-Smash': 'Fracas nerveux',
      'Explosion': 'Explosion',
      'Falling Rock': 'Chute de pierre',
      'Hard Rock': 'Pilier de boue',
      'Huff And Puff': 'Souffle porcin',
      'Meat Mallet': 'Maillet à viande',
      'Medium Rear': 'Cuit à point',
      'Minced Meat': 'Hachoir à viande',
      'Open Flame': 'Flammes nues',
      'Peat Pelt': 'Lancer de boue',
      'Petrified Peat': 'Roulage de boue',
      'Pitter-Patter': 'Giboulée',
      'Rocky Roll': 'Roulé-boulé',
      'Stone Age': 'Grondement terrestre',
      'Shower Power': 'Éclaboussure',
      'Sea Shanty': 'Explosion tournicoton',
      'Splish-Splash': 'Bulles bouillonnantes',
      'Tender Loin': 'Attendrisseur',
      'To A Crisp': 'Roussissement'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aeolian Cave Sprite': 'ウィンドケイブ・スプライト',
      'The Clayclot Cauldron': '輝きの採土場',
      'The Clearnote Cauldron': '涼しの採水場',
      'Mother Porxie': 'マザーポークシー',
      'Mud Bubble': '泥団子',
      'Mudman': 'マッドマン',
      'Nixie': 'ノッケン',
      'The Woebegone Workshop': '居留守の工房'
    },
    'replaceText': {
      'Barbeque': 'バーベキューグリル',
      'Brittle Breccia': '岩盤崩れ',
      'Buffet': '突風',
      'Crash-Smash': 'ヒヤヒヤカチカチ',
      'Explosion': '爆散',
      'Falling Rock': '落石',
      'Hard Rock': '泥岩柱',
      'Huff And Puff': '吐出',
      'Meat Mallet': 'ミートマレット',
      'Medium Rear': 'ミディアムレア',
      'Minced Meat': 'ミートミンサー',
      'Open Flame': 'オープンフレイム',
      'Peat Pelt': '泥団子遊び',
      'Petrified Peat': '泥団子作り',
      'Pitter-Patter': 'モクモクザーザー',
      'Rocky Roll': 'コロコロ',
      'Stone Age': '地鳴り',
      'Shower Power': 'ザブザブジャブジャブ',
      'Sea Shanty': 'グルグルザパーン',
      'Splish-Splash': 'アワアワブクブ',
      'Tender Loin': 'テンダライザー',
      'To A Crisp': '丸焦げ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aeolian Cave Sprite': '洞窟风元精',
      'The Clayclot Cauldron': '发光的挖土场',
      'The Clearnote Cauldron': '凉爽的打水场',
      'Mother Porxie': '仙子猪之母',
      'Mud Bubble': '泥球',
      'Mudman': '土泥人',
      'Nixie': '水滴精',
      'The Woebegone Workshop': '假装无人的工房'
    },
    'replaceText': {
      'Barbeque': '烤烤肉',
      'Brittle Breccia': '岩层崩塌',
      'Buffet': '突风',
      'Crash-Smash': '咣当咣当',
      'Explosion': '爆炸',
      'Falling Rock': '落石',
      'Hard Rock': '泥岩柱',
      'Huff And Puff': '吐出',
      'Meat Mallet': '敲敲肉',
      'Medium Rear': '三分熟',
      'Minced Meat': '绞绞肉',
      'Open Flame': '明火',
      'Peat Pelt': '玩泥球',
      'Petrified Peat': '造泥球',
      'Pitter-Patter': '滴答滴答',
      'Rocky Roll': '骨碌骨碌',
      'Stone Age': '地鸣',
      'Shower Power': '哗啦哗啦',
      'Sea Shanty': '咕噜咕噜',
      'Splish-Splash': '咕嘟咕嘟',
      'Tender Loin': '松松肉',
      'To A Crisp': '烤焦'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aeolian Cave Sprite': '바람 동굴 정령',
      'The Clayclot Cauldron': '빛나는 채토장',
      'The Clearnote Cauldron': '시원한 채수장',
      'Mother Porxie': '마더 포크시',
      'Mud Bubble': '진흙공',
      'Mudman': '진흙인간',
      'Nixie': '뇌켄',
      'The Woebegone Workshop': '버려진 공방'
    },
    'replaceText': {
      'Barbeque': '바비큐 그릴',
      'Brittle Breccia': '암반 붕괴',
      'Buffet': '쥐어박기',
      'Crash-Smash': '오들오들',
      'Explosion': '폭발',
      'Falling Rock': '낙석',
      'Hard Rock': '진흙바위',
      'Huff And Puff': '내쉬기',
      'Meat Mallet': '고기망치',
      'Medium Rear': '미디엄 레어',
      'Minced Meat': '고기 다지기',
      'Open Flame': '불쏘시개',
      'Peat Pelt': '진흙공 굴리기',
      'Petrified Peat': '진흙공 만들기',
      'Pitter-Patter': '뭉게뭉게 쏴아아',
      'Rocky Roll': '데굴데굴',
      'Stone Age': '땅울음',
      'Shower Power': '첨벙첨벙',
      'Sea Shanty': '빙그르르 퐁당',
      'Splish-Splash': '보글보글',
      'Tender Loin': '연육기',
      'To A Crisp': '숯덩이'
    }
  }]
};
/* harmony default export */ const matoyas_relict = (matoyas_relict_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/matoyas_relict.txt
const dungeon_matoyas_relict_namespaceObject = "### Matoya's Relict\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Mudman\r\n# -p 547F:1011\r\n# -ii 368 5481 5487 548E 548F 5490 5492\r\n# Clayclot Cauldron will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E02\" } window 1000,0\r\n# Loop 3 times\r\n1011.0 \"Hard Rock\" Ability { id: \"547F\", source: \"Mudman\" } window 1012,10\r\n1020.2 \"Petrified Peat\" Ability { id: \"5480\", source: \"Mudman\" }\r\n1032.3 \"Peat Pelt\" Ability { id: \"5482\", source: \"Mudman\" }\r\n1041.4 \"Rocky Roll\" Ability { id: \"548(3|4)\", source: \"Mud Bubble\" }\r\n1050.7 \"Brittle Breccia\" Ability { id: \"548D\", source: \"Mudman\" }\r\n1051.1 \"Rocky Roll\" Ability { id: \"548(3|5)\", source: \"Mud Bubble\" }\r\n1066.7 \"Stone Age\" Ability { id: \"5491\", source: \"Mudman\" }\r\n\r\n1077.8 \"Hard Rock\" Ability { id: \"547F\", source: \"Mudman\" } window 10,10\r\n1087.0 \"Petrified Peat\" Ability { id: \"5480\", source: \"Mudman\" }\r\n1099.1 \"Peat Pelt\" Ability { id: \"5482\", source: \"Mudman\" }\r\n1108.2 \"Rocky Roll\" Ability { id: \"548(3|4)\", source: \"Mud Bubble\" }\r\n1117.5 \"Brittle Breccia\" Ability { id: \"548D\", source: \"Mudman\" }\r\n1117.9 \"Rocky Roll\" Ability { id: \"548(3|5)\", source: \"Mud Bubble\" }\r\n1133.5 \"Stone Age\" Ability { id: \"5491\", source: \"Mudman\" }\r\n\r\n# After this loop, each loop with \"Falling Rock\"\r\n1144.6 \"Hard Rock\" Ability { id: \"547F\", source: \"Mudman\" } window 10,10\r\n1153.8 \"Petrified Peat\" Ability { id: \"5480\", source: \"Mudman\" }\r\n1165.9 \"Peat Pelt\" Ability { id: \"5482\", source: \"Mudman\" }\r\n1175.0 \"Rocky Roll\" Ability { id: \"548(3|4)\", source: \"Mud Bubble\" }\r\n1184.3 \"Brittle Breccia\" Ability { id: \"548D\", source: \"Mudman\" }\r\n1184.7 \"Rocky Roll\" Ability { id: \"548(3|5)\", source: \"Mud Bubble\" }\r\n1200.3 \"Stone Age\" Ability { id: \"5491\", source: \"Mudman\" }\r\n\r\n1212.3 \"Falling Rock\" Ability { id: \"549(3|4)\", source: \"Mudman\" }\r\n\r\n1223.5 \"Hard Rock\" Ability { id: \"547F\", source: \"Mudman\" } window 10,10 jump 1144.6\r\n1232.7 \"Petrified Peat\" # Ability { id: \"5480\", source: \"Mudman\" }\r\n1244.8 \"Peat Pelt\" # Ability { id: \"5482\", source: \"Mudman\" }\r\n1253.9 \"Rocky Roll\" # Ability { id: \"548(3|4)\", source: \"Mud Bubble\" }\r\n1263.2 \"Brittle Breccia\" # Ability { id: \"548D\", source: \"Mudman\" }\r\n\r\n\r\n### Nixie\r\n# -p 598F:2009.2\r\n# -ii 598E 5990 5992 5993 5994 5995 5996 5BB9\r\n# Clearnote Cauldron will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E03\" } window 2000,0\r\n\r\n2009.2 \"Crash-Smash\" Ability { id: \"598F\", source: \"Nixie\" } window 2010,10\r\n2023.4 \"Shower Power\" Ability { id: \"5991\", source: \"Nixie\" }\r\n2038.1 \"--untargetable--\"\r\n2044.1 \"Pitter-Patter\" Ability { id: \"5988\", source: \"Nixie\" }\r\n2072.2 \"Sea Shanty\" Ability { id: \"598[AC]\", source: \"Nixie\" }\r\n2092.4 \"Shower Power\" Ability { id: \"5991\", source: \"Nixie\" }\r\n\r\n2110.5 \"Crash-Smash\" Ability { id: \"598F\", source: \"Nixie\" } window 10,10\r\n2130.7 \"Shower Power\" Ability { id: \"5991\", source: \"Nixie\" }\r\n2134.9 \"Splish-Splash\" Ability { id: \"598D\", source: \"Nixie\" }\r\n2160.0 \"Shower Power\" Ability { id: \"5991\", source: \"Nixie\" }\r\n\r\n2178.2 \"Crash-Smash\" Ability { id: \"598F\", source: \"Nixie\" } window 10,10 jump 2110.5\r\n2198.4 \"Shower Power\" # Ability { id: \"5991\", source: \"Nixie\" }\r\n2202.6 \"Splish-Splash\" # Ability { id: \"598D\", source: \"Nixie\" }\r\n2227.7 \"Shower Power\" # Ability { id: \"5991\", source: \"Nixie\" }\r\n\r\n\r\n### Mother Porxie\r\n# -p 5913:3010.0\r\n# -ii 4A8F 5912 5914 5917 5918 591E 591F 5923 5925\r\n# Woebegone Workshop will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E05\" } window 3000,0\r\n\r\n3011.3 \"Tender Loin\" Ability { id: \"5913\", source: \"Mother Porxie\" } window 3012,10\r\n3029.5 \"Huff And Puff\" Ability { id: \"5919\", source: \"Mother Porxie\" }\r\n3031.6 \"Medium Rear\" Ability { id: \"591D\", source: \"Mother Porxie\" }\r\n3045.7 \"Meat Mallet\" Ability { id: \"5916\", source: \"Mother Porxie\" }\r\n3045.7 \"--untargetable--\"\r\n3050.4 \"Barbeque\" Ability { id: \"5B23\", source: \"Mother Porxie\" }\r\n3072.4 \"To A Crisp\" Ability { id: \"5924\", source: \"Mother Porxie\" }\r\n3074.4 \"--targetable--\"\r\n3086.5 \"Minced Meat\" Ability { id: \"5911\", source: \"Mother Porxie\" } window 50,10\r\n3093.6 \"--untargetable--\"\r\n\r\n3096.6 \"Huff And Puff\" StartsUsing { id: \"591A\", source: \"Mother Porxie\" } duration 33.7 window 96.6,5\r\n3101.6 \"Buffet\" Ability { id: \"5926\", source: \"Aeolian Cave Sprite\" }\r\n3107.3 \"Buffet\" Ability { id: \"5926\", source: \"Aeolian Cave Sprite\" }\r\n3112.8 \"Buffet\" Ability { id: \"5926\", source: \"Aeolian Cave Sprite\" }\r\n3118.4 \"Buffet\" Ability { id: \"5926\", source: \"Aeolian Cave Sprite\" }\r\n3124.0 \"Buffet\" Ability { id: \"5926\", source: \"Aeolian Cave Sprite\" }\r\n3129.6 \"Buffet\" Ability { id: \"5926\", source: \"Aeolian Cave Sprite\" }\r\n3130.3 \"Huff And Puff Enrage?\" Ability { id: \"591B\", source: \"Mother Porxie\" } window 50,5\r\n\r\n3132.3 \"--targetable--\"\r\n# Loop\r\n3132.4 \"Medium Rear\" Ability { id: \"591D\", source: \"Mother Porxie\" }\r\n3148.5 \"Open Flame\" Ability { id: \"5922\", source: \"Mother Porxie\" }\r\n3160.6 \"Minced Meat\" Ability { id: \"5911\", source: \"Mother Porxie\" }\r\n3172.7 \"Tender Loin\" Ability { id: \"5913\", source: \"Mother Porxie\" }\r\n3186.8 \"Tender Loin\" Ability { id: \"5913\", source: \"Mother Porxie\" }\r\n3207.1 \"Huff And Puff\" Ability { id: \"5919\", source: \"Mother Porxie\" }\r\n\r\n3209.2 \"Medium Rear\" Ability { id: \"591D\", source: \"Mother Porxie\" }\r\n3225.3 \"Open Flame\" Ability { id: \"5922\", source: \"Mother Porxie\" }\r\n3237.5 \"Minced Meat\" Ability { id: \"5911\", source: \"Mother Porxie\" } jump 3160.6\r\n3249.6 \"Tender Loin\" # Ability { id: \"5913\", source: \"Mother Porxie\" }\r\n3263.7 \"Tender Loin\" # Ability { id: \"5913\", source: \"Mother Porxie\" }\r\n3281.9 \"Huff And Puff\" # Ability { id: \"5919\", source: \"Mother Porxie\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/mt_gulg.ts


const mt_gulg_triggerSet = {
  id: 'MtGulg',
  zoneId: zone_id/* default.MtGulg */.Z.MtGulg,
  timelineFile: 'mt_gulg.txt',
  triggers: [{
    id: 'Gulg Punitive Light',
    type: 'StartsUsing',
    netRegex: {
      id: '41AF',
      source: 'Forgiven Prejudice'
    },
    condition: data => data.CanStun() || data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt('info')
  }, {
    id: 'Gulg Tail Smash',
    type: 'StartsUsing',
    netRegex: {
      id: '41AB',
      source: 'Forgiven Ambition',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Ambition Tail Smash',
        de: 'Begierde Schweifschlag',
        fr: 'Ambition, Queue fracassante',
        ja: 'テールスマッシュ',
        cn: '尾巴横扫',
        ko: '꼬리 휘두르기 주의'
      }
    }
  }, {
    id: 'Gulg Rake',
    type: 'StartsUsing',
    netRegex: {
      id: '3CFB',
      source: 'Forgiven Cruelty'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Gulg Lumen Infinitum',
    type: 'StartsUsing',
    netRegex: {
      id: '41B2',
      source: 'Forgiven Cruelty',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Frontal Laser',
        de: 'Frontaler Laser',
        fr: 'Laser frontal',
        ja: 'ボス前方レーザー',
        cn: '面前激光',
        ko: '정면 레이저 공격'
      }
    }
  }, {
    id: 'Gulg Cyclone Wing',
    type: 'StartsUsing',
    netRegex: {
      id: '3CFC',
      source: 'Forgiven Cruelty',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Gulg Typhoon Wing 1',
    type: 'StartsUsing',
    netRegex: {
      id: '3D00',
      source: 'Forgiven Cruelty',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'dodge wind cones',
        de: 'Wind-Fächerflächen ausweichen',
        fr: 'Esquivez les cônes de vent',
        ja: '風の楔から離れる',
        cn: '躲风锥',
        ko: '부채꼴 공격 피하기'
      }
    }
  }, {
    id: 'Gulg Typhoon Wing 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3D0[12]',
      source: 'Forgiven Cruelty',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.outOfMelee */.n3.outOfMelee()
  }, {
    id: 'Gulg Sacrament of Penance',
    type: 'StartsUsing',
    netRegex: {
      id: '3D0B',
      source: 'Forgiven Whimsy',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Gulg Catechism',
    type: 'StartsUsing',
    // no target name
    netRegex: {
      id: '3D09',
      source: 'Forgiven Whimsy'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Gulg Judgment Day',
    type: 'StartsUsing',
    netRegex: {
      id: '3D0F',
      source: 'Forgiven Whimsy',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 들어가기'
      }
    }
  }, {
    id: 'Gulg Left Palm',
    type: 'StartsUsing',
    netRegex: {
      id: '3F7A',
      source: 'Forgiven Revelry',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft('info')
  }, {
    id: 'Gulg Right Palm',
    type: 'StartsUsing',
    netRegex: {
      id: '3F78',
      source: 'Forgiven Revelry',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight('info')
  }, {
    id: 'Gulg Orison Fortissimo',
    type: 'StartsUsing',
    netRegex: {
      id: '3D14',
      source: 'Forgiven Obscenity',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Gulg Sforzando',
    type: 'StartsUsing',
    // no target name
    netRegex: {
      id: '3D12',
      source: 'Forgiven Obscenity'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Gulg Divine Diminuendo',
    type: 'StartsUsing',
    netRegex: {
      id: '3D18',
      source: 'Forgiven Obscenity',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'max melee range',
        de: 'Maximale Nahkämpfer Entfernung',
        fr: 'À distance max du CaC',
        ja: '近接最大距離',
        cn: '最远近战距离',
        ko: '칼끝딜'
      }
    }
  }, {
    id: 'Gulg Conviction Marcato',
    type: 'StartsUsing',
    netRegex: {
      id: '3D1A',
      source: 'Forgiven Obscenity',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind('info')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Forgiven Revelry': 'Geläutert(?:e|er|es|en) Prasserei',
      'Forgiven Ambition': 'Geläutert(?:e|er|es|en) Begierde',
      'Forgiven Prejudice': 'Geläutert(?:e|er|es|en) Voreingenommenheit',
      'Forgiven Obscenity': 'geläutert(?:e|er|es|en) Unzucht',
      'Forgiven Cruelty': 'geläutert(?:e|er|es|en) Grausamkeit',
      'Forgiven Whimsy': 'geläutert(?:e|er|es|en) Gereiztheit',
      'Brightsphere': 'Lichtsphäre',
      'The Winding Flare': 'Strahlenden Stufen',
      'The White Gate': 'Weißen Pforte',
      'The Perished Path': 'Pfad ohne Halt'
    },
    'replaceText': {
      'Lumen Infinitum': 'Lumen Infinitem',
      'Typhoon Wing': 'Taifunschwinge',
      'Cyclone Wing': 'Zyklonschwinge',
      'Perfect Contrition': 'Buße',
      'Divine Diminuendo': 'Dogma diminuendo',
      'Exegesis': 'Strafpredigt',
      'Orison Fortissimo': 'Fürbitte fortissimo',
      'Ringsmith': 'Ring der Beständigkeit',
      'Judged': 'Verurteilung',
      'Sacrament Of Penance': 'Sakrament der Vergebung',
      'Reformation': 'Gegenreformation',
      'Catechism': 'Heiliger Vers',
      'Rite Of The Sacrament': 'Beichte',
      'Judgment Day': 'Gnädiges Urteil',
      'Conviction Marcato': 'Mette marcato',
      'Penance Pianissimo': 'Predigt pianissimo',
      'Feather Marionette': 'Lebendige Feder',
      'Solitaire Ring': 'Solitärring',
      'Gold Chaser': 'Goldene Feder',
      'Sacrament Sforzando': 'Sakrament sforzato',
      'Hurricane Wing': 'Hurrikanschwinge',
      'Rake': 'Prankenhieb'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Forgiven Revelry': 'Orgie Pardonnée',
      'Forgiven Ambition': 'Ambition Pardonnée',
      'Forgiven Prejudice': 'Préjugé Pardonné',
      'Brightsphere': 'Sphère incandescente',
      'Forgiven Cruelty': 'Cruauté Pardonnée',
      'Forgiven Obscenity': 'Obscénité Pardonnée',
      'Forgiven Whimsy': 'Caprice Pardonné',
      'The Perished Path': 'l\'Arête branlante',
      'The White Gate': 'la porte d\'Albâtre',
      'The Winding Flare': 'Marches rayonnantes'
    },
    'replaceText': {
      'Catechism': 'Texte sacré',
      'Conviction Marcato': 'Conviction - marcato',
      'Cyclone Wing': 'Aile de cyclone',
      'Divine Diminuendo': 'Divin - diminuendo',
      'Exegesis': 'Sermon',
      'Feather Marionette': 'Marionettes',
      'Gold Chaser': 'Traqueur doré',
      'Hurricane Wing': 'Aile d\'ouragan',
      'Judged': 'Réprobation',
      'Judgment Day': 'Condamnation sacramentelle',
      'Lumen Infinitum': 'Lumen infinitum',
      'Orison Fortissimo': 'Horizon - fortissimo',
      'Penance Pianissimo': 'Pénitence - pianissimo',
      'Perfect Contrition': 'Repentance',
      'Rake': 'Griffes',
      'Reformation': 'Transmutation',
      'Ringsmith': 'Forge d\'anneaux',
      'Rite Of The Sacrament': 'Confession sacramentelle',
      'Sacrament Of Penance': 'Sacrement de pénitence',
      'Sacrament Sforzando': 'Sacrement - sforzato',
      'Solitaire Ring': 'Bagues dorées',
      'Typhoon Wing': 'Aile de typhon'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Forgiven Revelry': 'フォーギヴン・レヴェルリー',
      'Forgiven Ambition': 'フォーギヴン・アンビション',
      'Forgiven Prejudice': 'フォーギヴン・プレジュディス',
      'Brightsphere': 'ブライトスフィア',
      'Forgiven Cruelty': 'フォーギヴン・クルエルティー',
      'Forgiven Obscenity': 'フォーギヴン・オブセニティー',
      'Forgiven Whimsy': 'フォーギヴン・ウィムズィー',
      'The Perished Path': '崩れかけた山道',
      'The White Gate': '純白門',
      'The Winding Flare': '光芒の階段'
    },
    'replaceText': {
      'Catechism': '聖句',
      'Conviction Marcato': 'コンヴィクション・マルカート',
      'Cyclone Wing': 'サイクロンウィング',
      'Divine Diminuendo': 'ディヴァイン・ディミヌエンド',
      'Exegesis': '説教',
      'Feather Marionette': 'フェザーマリオネット',
      'Gold Chaser': 'ゴールドチェイサー',
      'Hurricane Wing': 'ハリケーンウィング',
      'Judged': '断罪',
      'Judgment Day': '断罪礼儀',
      'Lumen Infinitum': 'ルーメンインフィニーテム',
      'Orison Fortissimo': 'オリゾン・フォルティッシモ',
      'Penance Pianissimo': 'ぺナンス・ピアニッシモ',
      'Perfect Contrition': '懺悔',
      'Rake': 'ひっかき',
      'Reformation': '形態変化',
      'Ringsmith': 'リングスミス',
      'Rite Of The Sacrament': '告解礼儀',
      'Sacrament Of Penance': '恩赦の秘跡',
      'Sacrament Sforzando': 'サクラメント・スフォルツァンド',
      'Solitaire Ring': 'ソリティアリング',
      'Typhoon Wing': 'タイフーンウィング'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Forgiven Revelry': '得到宽恕的放纵',
      'Forgiven Ambition': '得到宽恕的奢望',
      'Forgiven Prejudice': '得到宽恕的偏见',
      'Forgiven Obscenity': '得到宽恕的猥亵',
      'Forgiven Cruelty': '得到宽恕的残忍',
      'Forgiven Whimsy': '得到宽恕的无常',
      'Brightsphere': '光明晶球',
      'The Winding Flare': '光芒阶梯',
      'The White Gate': '纯白门',
      'The Perished Path': '破损的山路'
    },
    'replaceText': {
      'Lumen Infinitum': '流明无限',
      'Typhoon Wing': '台风之翼',
      'Cyclone Wing': '旋风之翼',
      'Perfect Contrition': '忏悔',
      'Divine Diminuendo': '渐弱神音',
      'Exegesis': '解经',
      'Orison Fortissimo': '洪声祷告',
      'Ringsmith': '制戒',
      'Judged': '断罪',
      'Sacrament Of Penance': '忏悔圣礼',
      'Reformation': '形态变化',
      'Catechism': '教理问答',
      'Rite Of The Sacrament': '告解礼仪',
      'Judgment Day': '审判日',
      'Conviction Marcato': '坚信',
      'Penance Pianissimo': '轻声忏悔',
      'Feather Marionette': '羽制傀儡',
      'Solitaire Ring': '指环之钻',
      'Gold Chaser': '戒钻相合',
      'Sacrament Sforzando': '圣礼强化',
      'Hurricane Wing': '飓风之翼',
      'Rake': '利爪'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Forgiven Revelry': '면죄된 환락',
      'Forgiven Ambition': '면죄된 야망',
      'Forgiven Prejudice': '면죄된 편견',
      'Forgiven Obscenity': '면죄된 외설',
      'Forgiven Cruelty': '면죄된 잔혹',
      'Forgiven Whimsy': '면죄된 변덕',
      'Brightsphere': '빛의 구체',
      'The Winding Flare': '광망의 계단',
      'The White Gate': '순백의 문',
      'The Perished Path': '무너진 산길'
    },
    'replaceText': {
      'Lumen Infinitum': '무한 섬광',
      'Typhoon Wing': '태풍 날개',
      'Cyclone Wing': '회오리 날개',
      'Perfect Contrition': '참회',
      'Divine Diminuendo': '신성한 디미누엔도',
      'Exegesis': '설교',
      'Orison Fortissimo': '기도의 포르티시모',
      'Ringsmith': '고리 생성',
      'Judged': '단죄',
      'Sacrament Of Penance': '은사의 기적',
      'Reformation': '형태 변화',
      'Catechism': '성구',
      'Rite Of The Sacrament': '고해 의례',
      'Judgment Day': '단죄 의례',
      'Conviction Marcato': '신념의 마르카토',
      'Penance Pianissimo': '속죄의 피아니시모',
      'Feather Marionette': '깃털 꼭두각시',
      'Solitaire Ring': '서약의 고리',
      'Gold Chaser': '금빛 추격',
      'Sacrament Sforzando': '성체의 스포르찬도',
      'Hurricane Wing': '폭풍 날개',
      'Rake': '할퀴기'
    }
  }]
};
/* harmony default export */ const mt_gulg = (mt_gulg_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/mt_gulg.txt
const dungeon_mt_gulg_namespaceObject = "### Mt. Gulg (lvl 79 dungeon)\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Reformation\"\r\nhideall \"Perfect Contrition\"\r\nhideall \"Rite Of The Sacrament\"\r\n\r\n### Forgiven Cruelty\r\n# -p 3CFB:113 -ii 3CFE 3CFD 4301 3CFF\r\n# The Perished Path will be sealed off\r\n100.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"BB6\" } window 100,0\r\n113.0 \"Rake\" Ability { id: \"3CFB\", source: \"Forgiven Cruelty\" } window 115,5\r\n121.2 \"Lumen Infinitum\" Ability { id: \"41B2\", source: \"Forgiven Cruelty\" }\r\n138.3 \"Typhoon Wing\" Ability { id: \"3D00\", source: \"Forgiven Cruelty\" }\r\n147.2 \"Cyclone Wing\" Ability { id: \"3CFC\", source: \"Forgiven Cruelty\" }\r\n160.8 \"Typhoon Wing\" Ability { id: \"3D00\", source: \"Forgiven Cruelty\" }\r\n171.6 \"Lumen Infinitum\" Ability { id: \"41B2\", source: \"Forgiven Cruelty\" }\r\n188.2 \"Typhoon Wing\" Ability { id: \"3D01\", source: \"Forgiven Cruelty\" }\r\n188.2 \"Hurricane Wing\" Ability { id: \"3D03\", source: \"Forgiven Cruelty\" }\r\n197.0 \"Cyclone Wing\" Ability { id: \"3CFC\", source: \"Forgiven Cruelty\" }\r\n\r\n205.3 \"Rake\" Ability { id: \"3CFB\", source: \"Forgiven Cruelty\" }\r\n214.4 \"Lumen Infinitum\" Ability { id: \"41B2\", source: \"Forgiven Cruelty\" }\r\n231.0 \"Typhoon Wing\" Ability { id: \"3D0[12]\", source: \"Forgiven Cruelty\" }\r\n231.0 \"Hurricane Wing\" Ability { id: \"3D03\", source: \"Forgiven Cruelty\" }\r\n239.8 \"Cyclone Wing\" Ability { id: \"3CFC\", source: \"Forgiven Cruelty\" }\r\n248.2 \"Rake\" Ability { id: \"3CFB\", source: \"Forgiven Cruelty\" }\r\n257.5 \"Lumen Infinitum\" Ability { id: \"41B2\", source: \"Forgiven Cruelty\" }\r\n274.2 \"Typhoon Wing\" Ability { id: \"3D0[12]\", source: \"Forgiven Cruelty\" }\r\n274.2 \"Hurricane Wing\" Ability { id: \"3D03\", source: \"Forgiven Cruelty\" }\r\n283.0 \"Cyclone Wing\" Ability { id: \"3CFC\", source: \"Forgiven Cruelty\" }\r\n\r\n291.3 \"Rake\" Ability { id: \"3CFB\", source: \"Forgiven Cruelty\" } window 20,20 jump 205.3\r\n300.4 \"Lumen Infinitum\"\r\n317.0 \"Typhoon Wing\"\r\n317.0 \"Hurricane Wing\"\r\n325.8 \"Cyclone Wing\"\r\n334.2 \"Rake\"\r\n343.5 \"Lumen Infinitum\"\r\n360.2 \"Typhoon Wing\"\r\n360.2 \"Hurricane Wing\"\r\n369.0 \"Cyclone Wing\"\r\n\r\n\r\n### Forgiven Whimsy\r\n# -p 3D0B:514.5 -ii 3D0C 3D07 3D0A\r\n# The White Gate will be sealed off\r\n500.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"BB7\" } window 500,0\r\n514.5 \"Sacrament Of Penance\" Ability { id: \"3D0B\", source: \"Forgiven Whimsy\" } window 515,5\r\n518.3 \"Reformation\" Ability { id: \"3D04\", source: \"Forgiven Whimsy\" }\r\n530.4 \"Exegesis\" Ability { id: \"425C\", source: \"Forgiven Whimsy\" }\r\n534.1 \"Reformation\" Ability { id: \"3D04\", source: \"Forgiven Whimsy\" }\r\n546.2 \"Exegesis\" Ability { id: \"425D\", source: \"Forgiven Whimsy\" }\r\n557.0 \"Catechism\" Ability { id: \"3D09\", source: \"Forgiven Whimsy\" }\r\n563.7 \"Judgment Day\" Ability { id: \"3D0F\", source: \"Forgiven Whimsy\" }\r\n575.3 \"Judged\" Ability { id: \"3D11\", source: \"Forgiven Whimsy\" }\r\n580.3 \"Catechism\" Ability { id: \"3D09\", source: \"Forgiven Whimsy\" }\r\n580.3 \"Judged\" Ability { id: \"3D11\", source: \"Forgiven Whimsy\" }\r\n584.0 \"Reformation\" Ability { id: \"3D04\", source: \"Forgiven Whimsy\" }\r\n\r\n591.3 \"Rite Of The Sacrament\" Ability { id: \"3D0D\", source: \"Forgiven Whimsy\" }\r\n603.6 \"Exegesis\" Ability { id: \"425B\", source: \"Forgiven Whimsy\" }\r\n604.1 \"Perfect Contrition\" Ability { id: \"3D0E\", source: \"Brightsphere\" }\r\n607.2 \"Reformation\" Ability { id: \"3D04\", source: \"Forgiven Whimsy\" }\r\n614.4 \"Rite Of The Sacrament\" Ability { id: \"3D0D\", source: \"Forgiven Whimsy\" }\r\n626.8 \"Exegesis\" Ability { id: \"3D06\", source: \"Forgiven Whimsy\" }\r\n627.2 \"Perfect Contrition\" Ability { id: \"3D0E\", source: \"Brightsphere\" }\r\n636.9 \"Sacrament Of Penance\" Ability { id: \"3D0B\", source: \"Forgiven Whimsy\" }\r\n640.6 \"Reformation\" Ability { id: \"3D04\", source: \"Forgiven Whimsy\" }\r\n\r\n647.7 \"Rite Of The Sacrament\" Ability { id: \"3D0D\", source: \"Forgiven Whimsy\" } window 20,20 jump 591.3\r\n660.0 \"Exegesis\"\r\n660.5 \"Perfect Contrition\"\r\n663.6 \"Reformation\"\r\n670.8 \"Rite Of The Sacrament\"\r\n683.2 \"Exegesis\"\r\n683.6 \"Perfect Contrition\"\r\n693.3 \"Sacrament Of Penance\"\r\n697.0 \"Reformation\"\r\n\r\n\r\n### Forgiven Obscenity\r\n# -ii 3D15 4669 3D19 3D19 3D21 3D13 41CE 3D1B 3D20 -p 3D14:1014\r\n# The Winding Flare will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"BB8\" } window 1000,0\r\n1014.0 \"Orison Fortissimo\" Ability { id: \"3D14\", source: \"Forgiven Obscenity\" } window 1014,5\r\n1023.2 \"Divine Diminuendo\" Ability { id: \"3D16\", source: \"Forgiven Obscenity\" }\r\n1032.4 \"--sync--\" Ability { id: \"3D17\", source: \"Forgiven Obscenity\" }\r\n1040.6 \"Divine Diminuendo\" Ability { id: \"3D18\", source: \"Forgiven Obscenity\" }\r\n1051.0 \"Conviction Marcato\" Ability { id: \"3D1A\", source: \"Forgiven Obscenity\" }\r\n1062.2 \"Penance Pianissimo\" Ability { id: \"3D1C\", source: \"Forgiven Obscenity\" }\r\n1070.4 \"Feather Marionette\" Ability { id: \"3D1D\", source: \"Forgiven Obscenity\" }\r\n1083.3 \"Divine Diminuendo\" Ability { id: \"3D18\", source: \"Forgiven Obscenity\" }\r\n1093.5 \"Conviction Marcato\" Ability { id: \"3D1A\", source: \"Forgiven Obscenity\" }\r\n1107.7 \"Orison Fortissimo\" Ability { id: \"3D14\", source: \"Forgiven Obscenity\" }\r\n\r\n1124.5 \"Solitaire Ring\" Ability { id: \"42AA\", source: \"Forgiven Obscenity\" }\r\n1129.5 \"Ringsmith\" Ability { id: \"3D24\", source: \"Forgiven Obscenity\" }\r\n1135.5 \"Gold Chaser\" Ability { id: \"3D25\", source: \"Forgiven Obscenity\" }\r\n1147.5 \"Sacrament Sforzando\" Ability { id: \"3D12\", source: \"Forgiven Obscenity\" }\r\n1158.6 \"Orison Fortissimo\" Ability { id: \"3D14\", source: \"Forgiven Obscenity\" }\r\n1169.8 \"Divine Diminuendo\" Ability { id: \"3D18\", source: \"Forgiven Obscenity\" }\r\n1189.2 \"Penance Pianissimo\" Ability { id: \"3D1C\", source: \"Forgiven Obscenity\" }\r\n1197.4 \"Feather Marionette\" Ability { id: \"3D1D\", source: \"Forgiven Obscenity\" }\r\n1210.5 \"Divine Diminuendo\" Ability { id: \"3D18\", source: \"Forgiven Obscenity\" }\r\n1220.6 \"Conviction Marcato\" Ability { id: \"3D1A\", source: \"Forgiven Obscenity\" }\r\n1234.9 \"Sacrament Sforzando\" Ability { id: \"3D12\", source: \"Forgiven Obscenity\" }\r\n\r\n1251.6 \"Solitaire Ring\" Ability { id: \"42AA\", source: \"Forgiven Obscenity\" } window 100,100 jump 1124.5\r\n1256.6 \"Ringsmith\"\r\n1262.6 \"Gold Chaser\"\r\n1274.6 \"Sacrament Sforzando\"\r\n1285.7 \"Orison Fortissimo\"\r\n1296.9 \"Divine Diminuendo\"\r\n1316.3 \"Penance Pianissimo\"\r\n1324.5 \"Feather Marionette\"\r\n1337.6 \"Divine Diminuendo\"\r\n1347.7 \"Conviction Marcato\"\r\n1362.0 \"Sacrament Sforzando\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/paglthan.ts



const paglthan_triggerSet = {
  id: 'Paglthan',
  zoneId: zone_id/* default.Paglthan */.Z.Paglthan,
  timelineFile: 'paglthan.txt',
  timelineTriggers: [{
    // This is a rear cone attack that always follows Wide Blaster.
    // It has a cast time of under a GCD, so we pre-warn during Wide Blaster.
    // Only the sides are safe to call at this moment.
    id: 'Paglthan Spike Flail',
    regex: /Spike Flail/,
    beforeSeconds: 4,
    response: responses/* Responses.goSides */.n3.goSides()
  }],
  triggers: [{
    id: 'Paglthan Critical Rip',
    type: 'StartsUsing',
    netRegex: {
      id: '5C4E',
      source: 'Amhuluk'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Paglthan Electric Burst',
    type: 'StartsUsing',
    netRegex: {
      id: '5C4D',
      source: 'Amhuluk',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Paglthan Lightning Rod Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'A0E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to a lightning rod',
        de: 'Geh zu einem Blitzableiter',
        fr: 'Allez sur un paratonnerre',
        ja: '避雷針に円範囲を転嫁',
        cn: '蹭一下无AoE的塔',
        ko: '장판 기둥에 넘기기'
      }
    }
  }, {
    id: 'Paglthan Lightning Rod Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: 'A0E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'Paglthan Ballistic',
    type: 'StartsUsing',
    netRegex: {
      id: '5C97',
      source: 'Magitek Fortress',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Paglthan Defensive Reaction',
    type: 'StartsUsing',
    netRegex: {
      id: '5C9E',
      source: 'Magitek Core',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Paglthan Twisted Scream',
    type: 'StartsUsing',
    netRegex: {
      id: '5B47',
      source: 'Lunar Bahamut',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Paglthan Akh Morn',
    type: 'HeadMarker',
    netRegex: {
      id: '005D'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Paglthan Mega Flare Spread',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Paglthan Mega Flare Move',
    type: 'Ability',
    netRegex: {
      id: '5B4D',
      source: 'Lunar Bahamut'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from circles',
        de: 'Weg von den Kreisen',
        fr: 'Éloignez-vous des cercles',
        ja: '円を避ける',
        cn: '远离圈圈',
        ko: '장판 피하기'
      }
    }
  }, {
    id: 'Paglthan Kan Rhai Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0104'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kan Rhai on YOU',
        de: 'Kan Rhai auf DIR',
        fr: 'Kan Rhai sur VOUS',
        ja: '自分にカン・ラーイ',
        cn: '十字AoE点名',
        ko: '십자 장판 대상자'
      }
    }
  }, {
    id: 'Paglthan Kan Rhai Move',
    type: 'Ability',
    netRegex: {
      id: '5B4F',
      source: 'Lunar Bahamut',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from crosses',
        de: 'Weg von dem Kreuz',
        fr: 'Éloignez-vous des croix',
        ja: '十字から離れる',
        cn: '远离十字',
        ko: '십자 피하기'
      }
    }
  }, {
    id: 'Paglthan Lunar Flare Reset',
    type: 'Ability',
    netRegex: {
      id: '5B49',
      source: 'Lunar Bahamut',
      capture: false
    },
    run: data => data.lunarFlares = 0
  }, {
    id: 'Paglthan Lunar Flare Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '5B4[AB]',
      source: 'Lunar Bahamut',
      capture: false
    },
    run: data => data.lunarFlares = (data.lunarFlares ?? 0) + 1
  }, {
    // Get middle is 4x5B4A and 4x5B4B, get outside is 5x5B4A
    id: 'Paglthan Lunar Flare',
    type: 'StartsUsing',
    netRegex: {
      id: '5B4[AB]',
      source: 'Lunar Bahamut',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      if (data.lunarFlares === 5) return output.getOutsideBetweenCircles();
      if (data.lunarFlares === 8) return output.getMiddle();
    },
    outputStrings: {
      getMiddle: {
        en: 'Get Middle',
        de: 'In die Mitte gehen',
        fr: 'Allez au milieu',
        ja: '中心へ',
        cn: '中间',
        ko: '중앙으로'
      },
      getOutsideBetweenCircles: {
        en: 'Get Outside Between Circles',
        de: 'Geh zum Rand zwichen den Kreisen',
        fr: 'Allez à l\'extérieur entre les cercles',
        ja: '外周の円の隙間へ',
        cn: '去外圈交接处',
        ko: '바깥 장판 사이로'
      }
    }
  }, {
    id: 'Paglthan Flatten',
    type: 'StartsUsing',
    netRegex: {
      id: '5B58',
      source: 'Lunar Bahamut'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Paglthan Giga Flare',
    type: 'StartsUsing',
    netRegex: {
      id: '5B57',
      source: 'Lunar Bahamut',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Amhuluk': 'Amhuluk',
      'Lunar Bahamut': 'Luna-Bahamut',
      'Magitek Fortress': 'Magitek-Festung',
      'Magitek Core': 'Magitek-Reaktor',
      'Sunseat': 'Dämmergarten',
      'The Gathering Ring': 'Festplatz von Zolm\'ak'
    },
    'replaceText': {
      '\\(circles\\)': '(Kreise)',
      '\\(explosions\\)': '(Explosionen)',
      '--Levin orbs--': '--Elektrosphären--',
      'Akh Morn': 'Akh Morn',
      'Big Burst': 'Detonation',
      'Critical Rip': 'Kritischer Riss',
      'Electric Burst': 'Stromstoß',
      'Flatten': 'Einebnen',
      'Gigaflare': 'Gigaflare',
      'Kan Rhai': 'Kan Rhai',
      'Lightning Bolt': 'Blitzschlag',
      'Lunar Flare': 'Lunaflare',
      'Megaflare(?! Dive)': 'Megaflare',
      'Megaflare Dive': 'Megaflare-Sturz',
      'Perigean Breath': 'Perigäum-Atem',
      'Spike Flail': 'Dornendresche',
      'Thundercall': 'Donnerruf',
      'Twisted Scream': 'Verzerrtes Brüllen',
      'Upburst': 'Quantengravitation',
      'Wide Blaster': 'Weitwinkel-Blaster'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Amhuluk': 'Amhuluk',
      'Lunar Bahamut': 'Luna-Bahamut',
      'Magitek Fortress': 'forteresse magitek',
      'Magitek Core': 'réacteur magitek',
      'Sunseat': 'Clos du Crépuscule',
      'The Gathering Ring': 'Autel de Zolm\'ak'
    },
    'replaceText': {
      '\\(circles\\)': '(cercles)',
      '\\(explosions\\)': '(explosions)',
      '--Levin orbs--': '--Orbes de foudre--',
      'Akh Morn': 'Akh Morn',
      'Big Burst': 'Grosse explosion',
      'Critical Rip': 'Griffure critique',
      'Electric Burst': 'Salve électrique',
      'Flatten': 'Compression',
      'Gigaflare': 'GigaBrasier',
      'Kan Rhai': 'Kan Rhai',
      'Lightning Bolt': 'Éclair de foudre',
      'Lunar Flare': 'LunaBrasier',
      'Megaflare(?! Dive)': 'MégaBrasier',
      'Megaflare Dive': 'Plongeon MégaBrasier',
      'Perigean Breath': 'Souffle de périgée',
      'Spike Flail': 'Fléau à pointes',
      'Thundercall': 'Drain fulminant',
      'Twisted Scream': 'Hurlement de l\'Anomalie',
      'Upburst': 'Saillie',
      'Wide Blaster': 'Fulguration large'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Amhuluk': 'アムルック',
      'Lunar Bahamut': 'ルナバハムート',
      'Magitek Fortress': '魔導フォートレス',
      'Magitek Core': '魔導コア',
      'Sunseat': '黄昏の庭',
      'The Gathering Ring': 'ゾレマク祭場'
    },
    'replaceText': {
      'Akh Morn': 'アク・モーン',
      'Big Burst': '大爆発',
      'Critical Rip': 'クリティカルリップ',
      'Electric Burst': 'エレクトリックバースト',
      'Flatten': 'フラッテン',
      'Gigaflare': 'ギガフレア',
      'Kan Rhai': 'カン・ラーイ',
      'Lightning Bolt': '落雷',
      'Lunar Flare': 'ルナフレア',
      'Megaflare(?! Dive)': 'メガフレア',
      'Megaflare Dive': 'メガフレアダイブ',
      'Perigean Breath': 'ペリジアンブレス',
      'Spike Flail': 'スパイクフレイル',
      'Thundercall': '招雷',
      'Twisted Scream': '異形の咆哮',
      'Upburst': '突出',
      'Wide Blaster': 'ワイドブラスター'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Amhuluk': '阿姆鲁克',
      'Lunar Bahamut': '真月巴哈姆特',
      'Magitek Fortress': '魔导要塞',
      'Magitek Core': '魔导核心',
      'Sunseat': '黄昏庭园',
      'The Gathering Ring': '佐尔玛刻祭场'
    },
    'replaceText': {
      '\\(circles\\)': '圈',
      '\\(explosions\\)': '(爆炸)',
      '--Levin orbs--': '--电球--',
      'Akh Morn': '死亡轮回',
      'Big Burst': '大爆炸',
      'Critical Rip': '暴击撕裂',
      'Electric Burst': '电光爆发',
      'Flatten': '夷为平地',
      'Gigaflare': '十亿核爆',
      'Kan Rhai': '天光交错',
      'Lightning Bolt': '落雷',
      'Lunar Flare': '真月核爆',
      'Megaflare(?! Dive)': '百万核爆',
      'Megaflare Dive': '百万核爆冲',
      'Perigean Breath': '近地吐息',
      'Spike Flail': '刃尾横扫',
      'Thundercall': '招雷',
      'Twisted Scream': '异形咆哮',
      'Upburst': '顶起',
      'Wide Blaster': '广域冲击波'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Amhuluk': '아물룩',
      'Lunar Bahamut': '루나 바하무트',
      'Magitek Fortress': '마도 요새',
      'Magitek Core': '마도핵',
      'Sunseat': '황혼의 뜰',
      'The Gathering Ring': '졸마크 제단'
    },
    'replaceText': {
      '\\(circles\\)': '원',
      '\\(explosions\\)': '(폭발)',
      '--Levin orbs--': '--번개 구슬--',
      'Akh Morn': '아크 몬',
      'Big Burst': '대폭발',
      'Critical Rip': '찢어가르기',
      'Electric Burst': '전하 폭발',
      'Flatten': '압사',
      'Gigaflare': '기가플레어',
      'Kan Rhai': '칸 라이',
      'Lightning Bolt': '번개 발생',
      'Lunar Flare': '루나 플레어',
      'Megaflare(?! Dive)': '메가플레어',
      'Megaflare Dive': '메가플레어 다이브',
      'Perigean Breath': '근지점 입김',
      'Spike Flail': '가시 매타작',
      'Thundercall': '초뢰',
      'Twisted Scream': '기괴한 포효',
      'Upburst': '돌출',
      'Wide Blaster': '광범위 블래스터'
    }
  }]
};
/* harmony default export */ const paglthan = (paglthan_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/paglthan.txt
const dungeon_paglthan_namespaceObject = "### PAGLTH'AN\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~#\r\n# AMHULUK #\r\n#~~~~~~~~~#\r\n\r\n# -ii 5C52 5C53\r\n\r\n# Gathering Ring will be sealed off\r\n0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"B7B\" } window 0,1\r\n12.6 \"Critical Rip\" Ability { id: \"5C4E\", source: \"Amhuluk\" } window 12.6,10\r\n18.8 \"--sync--\" Ability { id: \"5C51\", source: \"Amhuluk\" }\r\n30.2 \"Lightning Bolt\" Ability { id: \"5C4B\", source: \"Amhuluk\" }\r\n31.0 \"--sync--\" Ability { id: \"5C4C\", source: \"Amhuluk\" }\r\n36.8 \"Electric Burst\" Ability { id: \"5C4D\", source: \"Amhuluk\" }\r\n48.0 \"Thundercall\" Ability { id: \"5C50\", source: \"Amhuluk\" } window 48,10\r\n48.5 \"--Levin orbs--\"\r\n61.3 \"Wide Blaster\" Ability { id: \"60C5\", source: \"Amhuluk\" } window 61.3,10\r\n63.9 \"Spike Flail\" Ability { id: \"5C4F\", source: \"Amhuluk\" }\r\n66.1 \"--sync--\" Ability { id: \"5C51\", source: \"Amhuluk\" }\r\n77.6 \"Lightning Bolt\" Ability { id: \"5C4B\", source: \"Amhuluk\" }\r\n78.4 \"--sync--\" Ability { id: \"5C4C\", source: \"Amhuluk\" }\r\n84.2 \"Electric Burst\" Ability { id: \"5C4D\", source: \"Amhuluk\" }\r\n\r\n95.4 \"Critical Rip\" Ability { id: \"5C4E\", source: \"Amhuluk\" } window 45,30\r\n107.5 \"Thundercall\" Ability { id: \"5C50\", source: \"Amhuluk\" }\r\n108.0 \"--Levin orbs--\"\r\n109.6 \"--sync--\" Ability { id: \"5C51\", source: \"Amhuluk\" }\r\n121.0 \"Lightning Bolt\" Ability { id: \"5C4B\", source: \"Amhuluk\" }\r\n121.8 \"--sync--\" Ability { id: \"5C4C\", source: \"Amhuluk\" }\r\n127.6 \"Electric Burst\" Ability { id: \"5C4D\", source: \"Amhuluk\" }\r\n137.7 \"Wide Blaster\" Ability { id: \"60C5\", source: \"Amhuluk\" } window 30,30\r\n140.3 \"Spike Flail\" Ability { id: \"5C4F\", source: \"Amhuluk\" }\r\n\r\n160.4 \"Critical Rip\" Ability { id: \"5C4E\", source: \"Amhuluk\" } jump 95.4\r\n172.5 \"Thundercall\"\r\n173.0 \"--Levin orbs--\"\r\n186.0 \"Lightning Bolt\"\r\n192.6 \"Electric Burst\"\r\n\r\n# There's not a whole lot of stuff we can do with a timeline for boss 2,\r\n# and the timing on Stable Cannon seems to vary by up to a second or more.\r\n\r\n#~~~~~~~~~~~~~~~#\r\n# LUNAR BAHAMUT #\r\n#~~~~~~~~~~~~~~~#\r\n\r\n# -ii 5B56 5B50\r\n\r\n# Sunseat will be sealed off\r\n2000.0 \"Start\" SystemLogMessage { id: \"7DC\", param1: \"B7D\" } window 2000,5\r\n2010.0 \"Twisted Scream\" Ability { id: \"5B47\", source: \"Lunar Bahamut\" } window 2010,10\r\n2015.0 \"Upburst x4\" # Ability { id: \"605B\", source: \"Lunar Nail\" }\r\n2021.6 \"Big Burst x4\" # Ability { id: \"5B48\", source: \"Lunar Nail\" }\r\n2029.2 \"Perigean Breath\" Ability { id: \"5B59\", source: \"Lunar Bahamut\" } window 30,10\r\n2042.4 \"Akh Morn x4\" Ability { id: \"5B55\", source: \"Lunar Bahamut\" } duration 5\r\n2062.8 \"Megaflare x3\" Ability { id: \"5B4C\", source: \"Lunar Bahamut\" }\r\n2064.8 \"--sync--\" Ability { id: \"5B4D\", source: \"Lunar Bahamut\" }\r\n2068.9 \"--sync--\" Ability { id: \"5B4E\", source: \"Lunar Bahamut\" }\r\n2071.0 \"Twisted Scream\" Ability { id: \"5B47\", source: \"Lunar Bahamut\" }\r\n2076.0 \"Upburst x4\" # Ability { id: \"605B\", source: \"Lunar Nail\" }\r\n2082.6 \"Big Burst x4\" # Ability { id: \"5B48\", source: \"Lunar Nail\" }\r\n2083.9 \"Megaflare Dive\" Ability { id: \"5B52\", source: \"Lunar Bahamut\" } window 30,30\r\n2095.7 \"Kan Rhai\" Ability { id: \"5B4F\", source: \"Lunar Bahamut\" }\r\n2097.3 \"--sync--\" Ability { id: \"5B51\", source: \"Lunar Bahamut\" }\r\n2107.4 \"Lunar Flare (circles)\" Ability { id: \"5B49\", source: \"Lunar Bahamut\" }\r\n2119.5 \"Lunar Flare (explosions)\" Ability { id: \"5B4A\", source: \"Lunar Bahamut\" }\r\n\r\n2131.6 \"Gigaflare\" Ability { id: \"5B57\", source: \"Lunar Bahamut\" } window 131.6,10\r\n2150.7 \"Akh Morn x4\" Ability { id: \"5B55\", source: \"Lunar Bahamut\" } duration 5\r\n2168.1 \"Twisted Scream\" Ability { id: \"5B47\", source: \"Lunar Bahamut\" }\r\n2173.1 \"Upburst x4\" # Ability { id: \"605B\", source: \"Lunar Nail\" }\r\n2179.7 \"Big Burst x4\" # Ability { id: \"5B48\", source: \"Lunar Nail\" }\r\n2191.3 \"Lunar Flare (circles)\" Ability { id: \"5B49\", source: \"Lunar Bahamut\" } window 30,30\r\n2203.4 \"Lunar Flare (explosions)\" Ability { id: [\"5B4A\", \"5B4B\"], source: \"Lunar Bahamut\" }\r\n2215.5 \"Kan Rhai\" Ability { id: \"5B4F\", source: \"Lunar Bahamut\" }\r\n2217.1 \"--sync--\" Ability { id: \"5B51\", source: \"Lunar Bahamut\" }\r\n2223.5 \"Flatten\" Ability { id: \"5B58\", source: \"Lunar Bahamut\" }\r\n\r\n2241.6 \"Gigaflare\" Ability { id: \"5B57\", source: \"Lunar Bahamut\" } jump 2131.6\r\n2260.7 \"Akh Morn x4\"\r\n2278.1 \"Twisted Scream\"\r\n2283.1 \"Upburst x4\"\r\n2289.7 \"Big Burst x4\"\r\n2301.3 \"Lunar Flare (circles)\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/qitana_ravel.ts



const qitana_ravel_triggerSet = {
  id: 'TheQitanaRavel',
  zoneId: zone_id/* default.TheQitanaRavel */.Z.TheQitanaRavel,
  timelineFile: 'qitana_ravel.txt',
  triggers: [{
    id: 'Qitana Stonefist',
    type: 'StartsUsing',
    netRegex: {
      id: '3C89',
      source: 'Lozatl'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Qitana Scorn',
    type: 'StartsUsing',
    netRegex: {
      id: '3C8B',
      source: 'Lozatl',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Qitana Eerie Pillar',
    type: 'StartsUsing',
    netRegex: {
      id: '3C8B',
      source: 'Lozatl',
      capture: false
    },
    delaySeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look for pillar',
        de: 'Auf die Pfeiler schauen',
        fr: 'Cherchez les piliers',
        ja: '光った像を避ける',
        cn: '躲开发光石像的半场',
        ko: '빛나는 기둥 위치확인'
      }
    }
  }, {
    id: 'Qitana Heat Up Right',
    type: 'StartsUsing',
    netRegex: {
      id: '3C8D',
      source: 'Lozatl',
      capture: false
    },
    delaySeconds: 6,
    durationSeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stay on left flank',
        de: 'Auf seiner linken Seite stehen',
        fr: 'Restez sur le flanc gauche',
        ja: 'ボスの左側へ',
        cn: 'Boss左边躲避',
        ko: '보스 왼쪽 측면으로'
      }
    }
  }, {
    id: 'Qitana Heat Up Left',
    type: 'StartsUsing',
    netRegex: {
      id: '3C8E',
      source: 'Lozatl',
      capture: false
    },
    delaySeconds: 6,
    durationSeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stay on right flank',
        de: 'Auf seiner rechten Seite stehen',
        fr: 'Restez sur le flanc droit',
        ja: 'ボスの右側へ',
        cn: 'Boss右边躲避',
        ko: '보스 오른쪽 측면으로'
      }
    }
  }, {
    id: 'Qitana Ripper Fang',
    type: 'StartsUsing',
    netRegex: {
      id: '3C91',
      source: 'Batsquatch'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Qitana Soundwave',
    type: 'StartsUsing',
    netRegex: {
      id: '3C92',
      source: 'Batsquatch',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Qitana Subsonics',
    type: 'StartsUsing',
    netRegex: {
      id: '3C93',
      source: 'Batsquatch',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Qitana Rend',
    type: 'StartsUsing',
    netRegex: {
      id: '3C99',
      source: 'Eros'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Qitana Glossolalia',
    type: 'StartsUsing',
    netRegex: {
      id: '3C9B',
      source: 'Eros',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Qitana Hound Tether',
    type: 'Tether',
    netRegex: {
      id: '0039',
      source: 'Eros'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Run Away From Boss',
        de: 'Renn weg vom Boss',
        fr: 'Courez loin du boss',
        ja: 'ボスから離れる',
        cn: '远离Boss',
        ko: '보스와 거리 벌리기'
      }
    }
  }, {
    id: 'Qitana Viper Poison',
    type: 'HeadMarker',
    netRegex: {
      id: '00AB'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Poison Outside',
        de: 'Gift am Rand ablegen',
        fr: 'Déposez le poison à l\'extérieur',
        ja: '外周に捨てる',
        cn: '远处放毒',
        ko: '독 장판을 바깥 쪽에 버리기'
      }
    }
  }, {
    id: 'Qitana Confession of Faith Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Qitana Confession of Faith Spread',
    type: 'StartsUsing',
    netRegex: {
      id: '3CA1',
      source: 'Eros',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread to Sides',
        de: 'Auf die Seiten verteilen',
        fr: 'Dispersez-vous sur les côtés',
        ja: '横に散開',
        cn: '两侧分散',
        ko: '좌우 측면으로 산개'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Batsquatch': 'Fledersquatch',
      'Eros': 'Eros',
      'Lozatl': 'Lozatl',
      'The Divine Threshold': 'Götterpforte',
      'Shadowed Hollow': 'Bildnishalle',
      'The Song of Ox\'Gatorl': 'Altar des Ox\'Gatorl'
    },
    'replaceText': {
      'Confession Of Faith': 'Glaubensbekenntnis',
      'Glossolalia': 'Glossolalie',
      'Heat Up': 'Erhitzung',
      'Heaving Breath': 'Wogender Atem',
      'Hound Out Of Heaven': 'Himmelsangriff',
      'Inhale': 'Einsaugen',
      'Jump': 'Sprung',
      'Lozatl\'s Fury': 'Lozatls Wut',
      'Lozatl\'s Scorn': 'Lozatls Hohn',
      'Rend': 'Zerreißen',
      'Ripper Fang': 'Fetzzahn',
      'Ronkan Light': 'Licht Ronkas/Ronkalicht',
      'Soundwave': 'Schallwelle',
      'Stonefist': 'Steinfaust',
      'Subsonics': 'Unterschall',
      'Sun Toss': 'Projektion',
      'Towerfall': 'Turmsturz',
      'Viper Poison': 'Viperngift'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Batsquatch': 'Batsquatch',
      'Eros': 'Éros',
      'Lozatl': 'Lozatl',
      'Shadowed Hollow': 'la Cavité ombragée',
      'The Divine Threshold': 'la Porte divine',
      'The Song of Ox\'Gatorl': 'l\'Autel d\'Ox\'Gatorl'
    },
    'replaceText': {
      'Confession Of Faith': 'Confession de foi',
      'Glossolalia': 'Glossolalie',
      'Heat Up': 'Incandescence',
      'Heaving Breath': 'Souffle nauséeux',
      'Hound Out Of Heaven': 'Charge céleste',
      'Inhale': 'Aspiration',
      'Jump': 'Saut',
      'Lozatl\'s Fury': 'Furie de Lozatl',
      'Lozatl\'s Scorn': 'Injure de Lozatl',
      'Rend': 'Déchiquètement',
      'Ripper Fang': 'Croc éventreur',
      'Ronkan Light': 'Lumière ronka',
      'Soundwave': 'Onde sonore',
      'Stonefist': 'Poing rocheux',
      'Subsonics': 'Attaque subsonique',
      'Sun Toss': 'Émission lumineuse',
      'Towerfall': 'Écroulement',
      'Viper Poison': 'Toxine de vipère'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Batsquatch': 'バッツカッチ',
      'Eros': 'エロース',
      'Lozatl': 'ロツァトル',
      'Shadowed Hollow': '神影写しの虚',
      'The Divine Threshold': '神前の石扉',
      'The Song of Ox\'Gatorl': 'ガトル神の祭壇'
    },
    'replaceText': {
      'Confession Of Faith': 'コンフェッション・オブ・フェイス',
      'Glossolalia': 'グロソラリア',
      'Heat Up': '赤熱化',
      'Heaving Breath': 'ヒーヴィングブレス',
      'Hound Out Of Heaven': 'ヘヴンスチャージ',
      'Inhale': '吸引',
      'Jump': 'ジャンプ',
      'Lozatl\'s Fury': 'ロツァトルの憤怒',
      'Lozatl\'s Scorn': 'ロツァトルの罵声',
      'Rend': '引き裂き',
      'Ripper Fang': 'リッパーファング',
      'Ronkan Light': 'ロンカの光',
      'Soundwave': 'サウンドウェーブ',
      'Stonefist': '石の拳',
      'Subsonics': 'サブソニクス',
      'Sun Toss': '投射',
      'Towerfall': '倒壊',
      'Viper Poison': 'バイパーポイズン'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Batsquatch': '배츠콰치',
      'Eros': '에로스',
      'Lozatl': '로차틀',
      'The Divine Threshold': '신에게 가는 문',
      'Shadowed Hollow': '신 그림자 공터',
      'The Song of Ox\'Gatorl': '가톨 신의 제단'
    },
    'replaceText': {
      'Confession Of Faith': '신앙 고백',
      'Glossolalia': '방언',
      'Heat Up': '적열화',
      'Heaving Breath': '내쉬는 숨결',
      'Hound Out Of Heaven': '천상의 돌진',
      'Inhale': '흡인',
      'Jump': '점프',
      'Lozatl\'s Fury': '로차틀의 분노',
      'Lozatl\'s Scorn': '로차틀의 고성',
      'Rend': '잡아찢기',
      'Ripper Fang': '톱송곳니',
      'Ronkan Light': '롱카의 빛',
      'Soundwave': '소리의 파동',
      'Stonefist': '돌주먹',
      'Subsonics': '아음속',
      'Sun Toss': '투사',
      'Towerfall': '무너지는 탑',
      'Viper Poison': '독사 독'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Batsquatch': '大脚野蝠',
      'Eros': '艾洛斯',
      'Lozatl': '洛查特尔',
      'The Divine Threshold': '神前石门',
      'Shadowed Hollow': '映照神影之洞窟',
      'The Song of Ox\'Gatorl': '奥奇斯加托尔之祭坛'
    },
    'replaceText': {
      'Confession Of Faith': '信仰宣言',
      'Glossolalia': '灵语',
      'Heat Up': '赤热化',
      'Heaving Breath': '吐息',
      'Hound Out Of Heaven': '蓄力冲撞',
      'Inhale': '吸气',
      'Jump': '跳跃',
      'Lozatl\'s Fury': '洛查特尔的愤怒',
      'Lozatl\'s Scorn': '洛查特尔的骂声',
      'Rend': '撕碎',
      'Ripper Fang': '裂肉尖牙',
      'Ronkan Light': '隆卡之光',
      'Soundwave': '声波',
      'Stonefist': '石拳',
      'Subsonics': '亚音速',
      'Sun Toss': '投射石块',
      'Towerfall': '崩塌',
      'Viper Poison': '尾蛇毒'
    }
  }]
};
/* harmony default export */ const qitana_ravel = (qitana_ravel_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/qitana_ravel.txt
const dungeon_qitana_ravel_namespaceObject = "### The Qitana Ravel (lvl 75 dungeon)\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Lozatl\r\n# -p 3C89:113.7\r\n# The Divine Threshold will be sealed off\r\n100.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"BCC\" } window 100,0\r\n\r\n113.7 \"Stonefist\" Ability { id: \"3C89\", source: \"Lozatl\" } window 114,5\r\n121.0 \"Sun Toss\" Ability { id: \"3C8A\", source: \"Lozatl\" }\r\n127.2 \"Lozatl's Scorn\" Ability { id: \"3C8B\", source: \"Lozatl\" }\r\n137.5 \"Sun Toss\" Ability { id: \"3C8A\", source: \"Lozatl\" }\r\n137.5 \"Ronkan Light\" Ability { id: [\"3D6D\", \"3C8C\"], source: \"Lozatl\" }\r\n145.1 \"Heat Up\" Ability { id: \"3C8[DE]\", source: \"Lozatl\" }\r\n151.5 \"Lozatl's Fury\" Ability { id: [\"3C8F\", \"3C90\"], source: \"Lozatl\" }\r\n\r\n161.2 \"Stonefist\" Ability { id: \"3C89\", source: \"Lozatl\" }\r\n168.1 \"Heat Up\" Ability { id: \"3C8[DE]\", source: \"Lozatl\" }\r\n173.2 \"Lozatl's Scorn\" Ability { id: \"3C8B\", source: \"Lozatl\" }\r\n182.7 \"Lozatl's Fury\" Ability { id: [\"3C8F\", \"3C90\"], source: \"Lozatl\" }\r\n183.4 \"Ronkan Light\" Ability { id: [\"3D6D\", \"3C8C\"], source: \"Lozatl\" }\r\n191.4 \"Sun Toss\" #Ability { id: \"3C8A\", source: \"Lozatl\" }\r\n196.7 \"Sun Toss\" #Ability { id: \"3C8A\", source: \"Lozatl\" }\r\n\r\n207.9 \"Stonefist\" Ability { id: \"3C89\", source: \"Lozatl\" }\r\n222.9 \"Heat Up\" Ability { id: \"3C8[DE]\", source: \"Lozatl\" }\r\n228.1 \"Lozatl's Scorn\" Ability { id: \"3C8B\", source: \"Lozatl\" }\r\n237.4 \"Lozatl's Fury\" Ability { id: [\"3C8F\", \"3C90\"], source: \"Lozatl\" }\r\n238.5 \"Ronkan Light\" Ability { id: [\"3D6D\", \"3C8C\"], source: \"Lozatl\" }\r\n246.2 \"Sun Toss\" #Ability { id: \"3C8A\", source: \"Lozatl\" }\r\n251.5 \"Sun Toss\" #Ability { id: \"3C8A\", source: \"Lozatl\" }\r\n\r\n262.9 \"Stonefist\" Ability { id: \"3C89\", source: \"Lozatl\" } window 50,50 jump 207.9\r\n277.9 \"Heat Up\"\r\n283.1 \"Lozatl's Scorn\"\r\n292.4 \"Lozatl's Fury\"\r\n293.5 \"Ronkan Light\"\r\n301.2 \"Sun Toss\"\r\n306.5 \"Sun Toss\"\r\n\r\n\r\n### Batsquatch\r\n# -ii 3C94 3C96 3C97 3C95 -p 3C91:514.5\r\n# Shadowed Hollow will be sealed off\r\n500.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"BCF\" } window 500,0\r\n\r\n514.5 \"Ripper Fang\" Ability { id: \"3C91\", source: \"Batsquatch\" } window 515,5\r\n525.7 \"Soundwave\" Ability { id: \"3C92\", source: \"Batsquatch\" }\r\n542.2 \"Subsonics\" Ability { id: \"3C93\", source: \"Batsquatch\" } duration 6.1\r\n559.8 \"Soundwave\" Ability { id: \"3C92\", source: \"Batsquatch\" }\r\n563.6 \"Towerfall\" Ability { id: \"3C98\", source: \"Batsquatch\" }\r\n\r\n571.4 \"Ripper Fang\" Ability { id: \"3C91\", source: \"Batsquatch\" }\r\n588.0 \"Subsonics\" Ability { id: \"3C93\", source: \"Batsquatch\" } duration 6.1\r\n605.6 \"Soundwave\" Ability { id: \"3C92\", source: \"Batsquatch\" }\r\n609.4 \"Towerfall\" Ability { id: \"3C98\", source: \"Batsquatch\" }\r\n\r\n616.5 \"Ripper Fang\" Ability { id: \"3C91\", source: \"Batsquatch\" }\r\n636.9 \"Subsonics\" Ability { id: \"3C93\", source: \"Batsquatch\" } duration 6.1\r\n654.5 \"Soundwave\" Ability { id: \"3C92\", source: \"Batsquatch\" }\r\n658.3 \"Towerfall\" Ability { id: \"3C98\", source: \"Batsquatch\" }\r\n\r\n666.1 \"Ripper Fang\" Ability { id: \"3C91\", source: \"Batsquatch\" } window 20,20 jump 571.4\r\n682.7 \"Subsonics\"\r\n700.3 \"Soundwave\"\r\n704.1 \"Towerfall\"\r\n\r\n711.2 \"Ripper Fang\"\r\n731.6 \"Subsonics\"\r\n749.2 \"Soundwave\"\r\n753.0 \"Towerfall\"\r\n\r\n\r\n### Eros\r\n#\r\n# The Song of Ox'Gatorl will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"BD2\" } window 1000,0\r\n\r\n1015.0 \"Rend\" Ability { id: \"3C99\", source: \"Eros\" } window 1015,5\r\n1026.2 \"Hound Out Of Heaven\" Ability { id: \"3C9A\", source: \"Eros\" }\r\n1036.1 \"Glossolalia\" Ability { id: \"3C9B\", source: \"Eros\" }\r\n1048.3 \"Viper Poison\" Ability { id: \"3C9C\", source: \"Eros\" }\r\n1050.9 \"Jump\" Ability { id: \"3C9F\", source: \"Eros\" }\r\n1057.6 \"Inhale\" Ability { id: \"4310\", source: \"Eros\" }\r\n1063.2 \"Heaving Breath\" Ability { id: \"3CA0\", source: \"Eros\" }\r\n1075.9 \"Rend\" Ability { id: \"3C99\", source: \"Eros\" }\r\n1083.3 \"Jump\" Ability { id: \"3C9F\", source: \"Eros\" }\r\n1092.0 \"Confession Of Faith\" Ability { id: \"3CA[14]\", source: \"Eros\" }\r\n1107.8 \"Hound Out Of Heaven\" Ability { id: \"3C9A\", source: \"Eros\" }\r\n\r\n1122.6 \"Viper Poison\" Ability { id: \"3C9C\", source: \"Eros\" }\r\n1125.5 \"Jump\" Ability { id: \"3C9F\", source: \"Eros\" }\r\n1132.1 \"Inhale\" Ability { id: \"4310\", source: \"Eros\" }\r\n1137.7 \"Heaving Breath\" Ability { id: \"3CA0\", source: \"Eros\" }\r\n1150.5 \"Rend\" Ability { id: \"3C99\", source: \"Eros\" }\r\n1162.8 \"Hound Out Of Heaven\" Ability { id: \"3C9A\", source: \"Eros\" }\r\n1170.7 \"Jump\" Ability { id: \"3C9F\", source: \"Eros\" }\r\n1179.3 \"Confession Of Faith\" Ability { id: \"3CA[14]\", source: \"Eros\" }\r\n1193.1 \"Glossolalia\" Ability { id: \"3C9B\", source: \"Eros\" }\r\n1202.3 \"Glossolalia\" Ability { id: \"3C9B\", source: \"Eros\" }\r\n1213.5 \"Hound Out Of Heaven\" Ability { id: \"3C9A\", source: \"Eros\" }\r\n1224.4 \"Rend\" Ability { id: \"3C99\", source: \"Eros\" }\r\n\r\n1237.6 \"Viper Poison\" Ability { id: \"3C9C\", source: \"Eros\" } window 100,100 jump 1122.6\r\n1240.5 \"Jump\"\r\n1247.1 \"Inhale\"\r\n1252.7 \"Heaving Breath\"\r\n1265.5 \"Rend\"\r\n1277.8 \"Hound Out Of Heaven\"\r\n1285.7 \"Jump\"\r\n1294.3 \"Confession Of Faith\"\r\n1308.1 \"Glossolalia\"\r\n1317.3 \"Glossolalia\"\r\n1328.5 \"Hound Out Of Heaven\"\r\n1339.4 \"Rend\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/the_grand_cosmos.ts



const the_grand_cosmos_triggerSet = {
  id: 'TheGrandCosmos',
  zoneId: zone_id/* default.TheGrandCosmos */.Z.TheGrandCosmos,
  timelineFile: 'the_grand_cosmos.txt',
  triggers: [{
    id: 'Cosmos Shadowbolt',
    type: 'StartsUsing',
    netRegex: {
      id: '4769',
      source: 'Seeker Of Solitude'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Cosmos Dark Pulse',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn('info')
  }, {
    id: 'Cosmos Dark Well Far Winds',
    type: 'HeadMarker',
    netRegex: {
      id: '0060'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Cosmos Immortal Anathema',
    type: 'StartsUsing',
    netRegex: {
      id: '49A3',
      source: 'Seeker Of Solitude',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Cosmos Tribulation',
    type: 'StartsUsing',
    netRegex: {
      id: '476B',
      source: 'Seeker Of Solitude',
      capture: false
    },
    delaySeconds: 8,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Brooms',
        de: 'Besen ausweichen',
        fr: 'Évitez les balais',
        ja: 'ほうきを避ける',
        cn: '躲扫把',
        ko: '빗자루 피하기'
      }
    }
  }, {
    id: 'Cosmos Storm of Color',
    type: 'StartsUsing',
    netRegex: {
      id: '471B',
      source: 'Leannan Sith'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Cosmos Ode To Lost Love',
    type: 'StartsUsing',
    netRegex: {
      id: '471C',
      source: 'Leannan Sith',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Can't use added combatant here as all these adds exist.
    // So, just trigger on first auto.
    id: 'Cosmos Direct Seeding Mistake',
    type: 'Ability',
    netRegex: {
      id: '368',
      source: 'Lover\'s Ring',
      capture: false
    },
    suppressSeconds: 60,
    response: responses/* Responses.killExtraAdd */.n3.killExtraAdd()
  }, {
    id: 'Cosmos Gardener\'s Hymn',
    type: 'StartsUsing',
    netRegex: {
      id: '471E',
      source: 'Leannan Sith',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'put seeds on dirt',
        de: 'Samen auf den nicht bewachsenen Boden legen',
        fr: 'Mettez les graines sur la terre',
        ja: '種を土に置かないように',
        cn: '种子搬离AOE',
        ko: '씨앗 자라지 못하게 하기'
      }
    }
  }, {
    id: 'Cosmos Ronkan Cure II',
    type: 'StartsUsing',
    netRegex: {
      id: '4931',
      source: 'Ser Hamonth'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun('info')
  }, {
    id: 'Cosmos Captive Bolt',
    type: 'StartsUsing',
    netRegex: {
      id: '4764',
      source: 'Lugus'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Cosmos Culling Blade',
    type: 'StartsUsing',
    netRegex: {
      id: '4765',
      source: 'Lugus',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Cosmos Black Flame 1',
    type: 'HeadMarker',
    netRegex: {
      id: '0019'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Cosmos Black Flame 2',
    type: 'HeadMarker',
    netRegex: {
      id: '0019'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 4,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge Crosses',
        de: 'Den Kreuzen ausweichen',
        fr: 'Esquivez les croix',
        ja: '十字を避ける',
        cn: '躲避交叉',
        ko: '십자 장판 피하기'
      }
    }
  }, {
    id: 'Cosmos Mortal Flame 1',
    type: 'HeadMarker',
    netRegex: {
      id: '00C3'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Cosmos Mortal Flame 2',
    type: 'HeadMarker',
    netRegex: {
      id: '00C3'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 5.5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Touch Furniture',
        de: 'Einrichtung berühren',
        fr: 'Touchez un meuble',
        ja: '調度品に寄る',
        cn: '传火家具',
        ko: '가구에 불 옮기기'
      }
    }
  }, {
    id: 'Cosmos Scorching Left',
    type: 'StartsUsing',
    netRegex: {
      id: '4763',
      source: 'Lugus',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight('info')
  }, {
    id: 'Cosmos Scorching Right',
    type: 'StartsUsing',
    netRegex: {
      id: '4762',
      source: 'Lugus',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft('info')
  }, {
    id: 'Cosmos Fire\'s Domain',
    type: 'HeadMarker',
    netRegex: {
      id: '003[2345]'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: data => {
      data.firesDomain = (data.firesDomain ?? 0) + 1;
    },
    infoText: (data, _matches, output) => {
      if (data.firesDomain === 1) return output.pointTetherAwayFromFurniture();
      return output.tetherOnYou();
    },
    outputStrings: {
      pointTetherAwayFromFurniture: {
        en: 'Point Tether Away From Furniture',
        de: 'Verbindung weg von der Einrichtung zeigen',
        fr: 'Pointez le lien éloigné des meubles',
        ja: '調度品に当たらないように',
        cn: '连线不要打到家具',
        ko: '징: 장판이 가구에 닿지 않게 하기'
      },
      tetherOnYou: {
        en: 'Tether on YOU',
        de: 'Verbindung auf DIR',
        fr: 'Lien sur VOUS',
        ja: '線ついた',
        cn: '连线点名',
        ko: '징 대상자'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Ser Hamonth': 'Sir Hamonth',
      'Lover\'s Ring': 'Keim Des Geliebten',
      'Enslaved Love': 'versklavt(?:e|er|es|en) Liebhaber',
      'Leannan Sith': 'Leanan Sidhe',
      'Lugus': 'Lugus',
      'Seeker of Solitude': 'Einsiedler',
      'The Chamber of Celestial Song': 'Großen Vergnügungen',
      'The Font of Quintessence': 'Broderieparterre',
      'The Martial Court': 'Kleinen Stufenarkade'
    },
    'replaceText': {
      'Black Flame': 'Finsterer Flammenwind',
      'Captive Bolt': 'Schmetterklinge',
      'Culling Blade': 'Schockschnitt',
      'Dark Pulse': 'Dunkle Welle',
      'Dark Shock': 'Angriff aus dem Dunkeln',
      'Dark Well': 'Dunkles Bersten',
      'Direct Seeding': 'Bedecktbesamung',
      '(?<! )Far Wind': 'Heller Sturm',
      'Fire\'s Domain': 'Heißer Höllensturm',
      'Fire\'s Ire': 'Holistisches Höllenfeuer',
      'Gardener\'s Hymn': 'Wiegenlied der Sprösslinge',
      'Immortal Anathema': 'Ewiger Bannfluch',
      'Ireful Wind': 'Starke Bö',
      'Mortal Flame': 'Ewige Flammen',
      'Ode To Fallen Petals': 'Stimme des Blumensturms',
      'Ode To Far Winds': 'Stimme des hellen Sturms',
      'Ode To Lost Love': 'Unerwiderte Liebe',
      'Otherworldly Heat': 'Sengendes Seelenbrennen',
      'Plummet': 'Abfallen',
      'Scorching Left/Right': 'Linker/Rechter Höllenhieb',
      'Shadowbolt': 'Schattenramme',
      'Storm Of Color': 'Frühlingssturm',
      'Tribulation': 'Schwermütiges Zaudern'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ser Hamonth': 'Sire Hamonth',
      'Lover\'s Ring': 'Bague De L\'Amoureux',
      'Enslaved Love': 'Amour Asservi',
      'Leannan Sith': 'Leannan Sith',
      'Lugus': 'Lugus',
      'Seeker of Solitude': 'Ermite du Palais',
      'The Martial Court': 'La Cour martiale',
      'The Font of Quintessence': 'La Source de Quintessence',
      'The Chamber of Celestial Song': 'Chœur céleste'
    },
    'replaceText': {
      'Black Flame': 'Torrent fuligineux',
      'Captive Bolt': 'Lame pulvérisante',
      'Culling Blade': 'Lame percutante',
      'Dark Pulse': 'Déluge noir',
      'Dark Shock': 'Onde ténébreuse',
      'Dark Well': 'Déflagration ténébreuse',
      'Direct Seeding': 'Semis direct',
      '(?<! )Far Wind': 'Claire tempête',
      'Fire\'s Domain': 'Fournaise infernale',
      'Fire\'s Ire': 'Étincelle infernale',
      'Gardener\'s Hymn': 'Ballade du bourgeonnement',
      'Immortal Anathema': 'Anathème immortel',
      'Ireful Wind': 'Ouragan violent',
      'Mortal Flame': 'Flamme mortelle',
      'Ode To Fallen Petals': 'Mélodie florale',
      'Ode To Far Winds': 'Aria de tempête',
      'Ode To Lost Love': 'Rhapsodie de l\'amour fou',
      'Otherworldly Heat': 'Croix de feu',
      'Plummet': 'Chute',
      'Scorching Left/Right': 'Scrutement senestre/dextre',
      'Shadowbolt': 'Éclair ombreux',
      'Storm Of Color': 'Orage de printemps',
      'Tribulation': 'Tribulation'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ser Hamonth': '幻影騎士ハモンス',
      'Lover\'s Ring': 'ラヴァーズリング',
      'Enslaved Love': 'エンスレイブド・ラヴ',
      'Leannan Sith': 'リャナンシー',
      'Lugus': 'ルゴス',
      'Seeker of Solitude': '宮殿の隠者',
      'The Martial Court': '兵棋の間',
      'The Font of Quintessence': '春の泉',
      'The Chamber of Celestial Song': '演奏の間'
    },
    'replaceText': {
      'Black Flame': '黒炎流',
      'Captive Bolt': '破砕斬',
      'Culling Blade': '衝撃斬',
      'Dark Pulse': '黒の波動',
      'Dark Shock': '黒の衝撃',
      'Dark Well': '黒の爆砕',
      'Direct Seeding': 'ダイレクトシーディング',
      '(?<! )Far Wind': '晴嵐',
      'Fire\'s Domain': '炎獄殺',
      'Fire\'s Ire': '炎獄閃',
      'Gardener\'s Hymn': '萌芽への謡',
      'Immortal Anathema': 'イモータルアナテーマ ',
      'Ireful Wind': '強風',
      'Mortal Flame': '必滅の炎',
      'Ode To Fallen Petals': '花嵐の歌声',
      'Ode To Far Winds': '晴嵐の歌声',
      'Ode To Lost Love': '狂愛の歌声',
      'Otherworldly Heat': '鬼炎斬',
      'Plummet': '落下',
      'Scorching Left/Right': '左/右辺炎獄斬',
      'Shadowbolt': 'シャドウボルト',
      'Storm Of Color': '春嵐',
      'Tribulation': 'トリビュレーション'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ser Hamonth': '幻影骑士哈蒙斯',
      'Lover\'s Ring': '恋人之戒',
      'Enslaved Love': '被奴役的爱',
      'Leannan Sith': '凉南希',
      'Lugus': '卢格斯',
      'Seeker of Solitude': '宫殿的隐者',
      'The Chamber of Celestial Song': '演奏之间',
      'The Font of Quintessence': '春水涌泉',
      'The Martial Court': '兵棋之间'
    },
    'replaceText': {
      'Black Flame': '黑炎流',
      'Captive Bolt': '破碎斩',
      'Culling Blade': '冲击斩',
      'Dark Pulse': '黑暗波动',
      'Dark Shock': '黑暗冲击',
      'Dark Well': '黑暗爆碎',
      'Direct Seeding': '直接播种',
      '(?<! )Far Wind': '(?<! )远风',
      'Fire\'s Domain': '炎狱杀',
      'Fire\'s Ire': '炎狱闪',
      'Gardener\'s Hymn': '育芽之谣',
      'Immortal Anathema': '不朽的诅咒',
      'Ireful Wind': '强风',
      'Mortal Flame': '必灭之炎',
      'Ode To Fallen Petals': '花雨之歌',
      'Ode To Far Winds': '晴岚之歌',
      'Ode To Lost Love': '狂爱之歌',
      'Otherworldly Heat': '鬼炎斩',
      'Plummet': '掉落',
      'Scorching Left/Right': '左/右炎狱斩',
      'Shadowbolt': '暗影雷',
      'Storm Of Color': '春风',
      'Tribulation': '苦难'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ser Hamonth': '환영기사 하몬스',
      'Lover\'s Ring': '연인의 반지',
      'Enslaved Love': '예속된 사랑',
      'Leannan Sith': '랴난시',
      'Lugus': '루구스',
      'Seeker of Solitude': '궁전의 은자',
      'The Chamber of Celestial Song': '연주실',
      'The Font of Quintessence': '봄바람 샘',
      'The Martial Court': '전술실'
    },
    'replaceText': {
      'Black Flame': '흑염류',
      'Captive Bolt': '파쇄참',
      'Culling Blade': '충격참',
      'Dark Pulse': '검은 파동',
      'Dark Shock': '검은 충격',
      'Dark Well': '검은 폭쇄',
      'Direct Seeding': '곧뿌림',
      '(?<! )Far Wind': '산바람',
      'Fire\'s Domain': '염옥살',
      'Fire\'s Ire': '염옥섬',
      'Gardener\'s Hymn': '새싹을 위한 노래',
      'Immortal Anathema': '불멸 혐오',
      'Ireful Wind': '강풍',
      'Mortal Flame': '필멸의 불꽃',
      'Ode To Fallen Petals': '꽃바람의 노래',
      'Ode To Far Winds': '산바람의 노래',
      'Ode To Lost Love': '광적인 사랑 노래',
      'Otherworldly Heat': '귀염참',
      'Plummet': '낙하',
      'Scorching Left/Right': '염옥 좌측/우측베기',
      'Shadowbolt': '그림자 번개',
      'Storm Of Color': '봄바람',
      'Tribulation': '환난'
    }
  }]
};
/* harmony default export */ const the_grand_cosmos = (the_grand_cosmos_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/the_grand_cosmos.txt
const dungeon_the_grand_cosmos_namespaceObject = "### The Grand Cosmos\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Seeker of Solitude\r\n# -ii 4768 49A4 476C 476F 4771 4770 -p 4769:111.7\r\n# The Martial Court will be sealed off\r\n100.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"D2F\" } window 100,0\r\n111.7 \"Shadowbolt\" Ability { id: \"4769\", source: \"Seeker of Solitude\" } window 112,5\r\n119.4 \"Immortal Anathema\" Ability { id: \"49A3\", source: \"Seeker of Solitude\" }\r\n\r\n126.8 \"Tribulation\" Ability { id: \"476B\", source: \"Seeker of Solitude\" }\r\n135.5 \"Dark Shock\" Ability { id: \"476E\", source: \"Seeker of Solitude\" }\r\n155.4 \"Dark Pulse\" Ability { id: \"476A\", source: \"Seeker of Solitude\" }\r\n162.1 \"Dark Well\" Ability { id: \"476D\", source: \"Seeker of Solitude\" }\r\n172.9 \"Shadowbolt\" Ability { id: \"4769\", source: \"Seeker of Solitude\" }\r\n183.6 \"Immortal Anathema\" Ability { id: \"49A3\", source: \"Seeker of Solitude\" }\r\n\r\n190.5 \"Tribulation\" Ability { id: \"476B\", source: \"Seeker of Solitude\" }\r\n199.2 \"Dark Well\" Ability { id: \"476D\", source: \"Seeker of Solitude\" }\r\n214.0 \"Dark Shock\" Ability { id: \"476E\", source: \"Seeker of Solitude\" }\r\n224.6 \"Shadowbolt\" Ability { id: \"4769\", source: \"Seeker of Solitude\" }\r\n236.4 \"Dark Pulse\" Ability { id: \"476A\", source: \"Seeker of Solitude\" }\r\n243.1 \"Dark Well\" Ability { id: \"476D\", source: \"Seeker of Solitude\" }\r\n252.9 \"Immortal Anathema\" Ability { id: \"49A3\", source: \"Seeker of Solitude\" }\r\n\r\n# TODO: not 100% sure this is the loop\r\n262.7 \"Tribulation\" Ability { id: \"476B\", source: \"Seeker of Solitude\" } window 50,50 jump 190.5\r\n271.4 \"Dark Well\"\r\n286.2 \"Dark Shock\"\r\n296.8 \"Shadowbolt\"\r\n308.6 \"Dark Pulse\"\r\n315.3 \"Dark Well\"\r\n325.1 \"Immortal Anathema\"\r\n\r\n\r\n### Leannan Sith\r\n# -ii 4724 471F -p 471B:512\r\n# The Font of Quintessence will be sealed off\r\n500.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"D30\" } window 500,0\r\n512.0 \"Storm Of Color\" Ability { id: \"471B\", source: \"Leannan Sith\" } window 512,10\r\n522.3 \"Ode To Lost Love\" Ability { id: \"471C\", source: \"Leannan Sith\" }\r\n\r\n529.9 \"Direct Seeding\" Ability { id: \"471D\", source: \"Leannan Sith\" }\r\n546.4 \"Gardener's Hymn\" Ability { id: \"471E\", source: \"Leannan Sith\" }\r\n552.9 \"Storm Of Color\" Ability { id: \"471B\", source: \"Leannan Sith\" }\r\n562.1 \"Ode To Lost Love\" Ability { id: \"471C\", source: \"Leannan Sith\" }\r\n572.3 \"Ode To Far Winds\" Ability { id: \"4722\", source: \"Leannan Sith\" }\r\n577.4 \"Far Wind\" Ability { id: \"4723\", source: \"Leannan Sith\" }\r\n583.4 \"Ode To Fallen Petals\" Ability { id: \"4950\", source: \"Leannan Sith\" }\r\n594.5 \"Ode To Lost Love\" Ability { id: \"471C\", source: \"Leannan Sith\" }\r\n\r\n601.2 \"Direct Seeding\" Ability { id: \"471D\", source: \"Leannan Sith\" }\r\n616.7 \"Ireful Wind\" Ability { id: \"4721\", source: \"Enslaved Love\" }\r\n617.6 \"Gardener's Hymn\" Ability { id: \"471E\", source: \"Leannan Sith\" }\r\n623.1 \"Ode To Far Winds\" Ability { id: \"4722\", source: \"Leannan Sith\" }\r\n628.2 \"Far Wind\" Ability { id: \"4723\", source: \"Leannan Sith\" }\r\n634.1 \"Ode To Fallen Petals\" Ability { id: \"4950\", source: \"Leannan Sith\" }\r\n646.5 \"Storm Of Color\" Ability { id: \"471B\", source: \"Leannan Sith\" }\r\n653.7 \"Ode To Lost Love\" Ability { id: \"471C\", source: \"Leannan Sith\" }\r\n668.8 \"Ode To Far Winds\" Ability { id: \"4722\", source: \"Leannan Sith\" }\r\n673.9 \"Far Wind\" Ability { id: \"4723\", source: \"Leannan Sith\" }\r\n679.9 \"Ode To Fallen Petals\" Ability { id: \"4950\", source: \"Leannan Sith\" }\r\n691.1 \"Ode To Lost Love\" Ability { id: \"471C\", source: \"Leannan Sith\" }\r\n\r\n697.7 \"Direct Seeding\" Ability { id: \"471D\", source: \"Leannan Sith\" } window 50,50 jump 601.2\r\n713.2 \"Ireful Wind\"\r\n714.1 \"Gardener's Hymn\"\r\n719.6 \"Ode To Far Winds\"\r\n724.7 \"Far Wind\"\r\n730.6 \"Ode To Fallen Petals\"\r\n743.0 \"Storm Of Color\"\r\n750.2 \"Ode To Lost Love\"\r\n765.3 \"Ode To Far Winds\"\r\n770.4 \"Far Wind\"\r\n776.4 \"Ode To Fallen Petals\"\r\n787.6 \"Ode To Lost Love\"\r\n\r\n\r\n### Lugus\r\n# -ii 475B 4766 475A 475E -p 475D:1026.8\r\n# The Chamber of Celestial Song will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"D31\" } window 1000,0\r\n1015.3 \"Scorching Left/Right\" Ability { id: \"476[23]\", source: \"Lugus\" } window 1015.3,10\r\n1026.8 \"Black Flame\" Ability { id: \"475D\", source: \"Lugus\" }\r\n1030.3 \"Otherworldly Heat\" Ability { id: \"475C\", source: \"Lugus\" }\r\n1037.8 \"Captive Bolt\" Ability { id: \"4764\", source: \"Lugus\" }\r\n1048.2 \"Mortal Flame\" Ability { id: \"4759\", source: \"Lugus\" } window 30,0\r\n1077.1 \"Fire's Domain\" Ability { id: \"47(5F|60)\", source: \"Lugus\" }\r\n1080.2 \"Fire's Ire\" Ability { id: \"4761\", source: \"Lugus\" }\r\n1081.7 \"Fire's Domain\" Ability { id: \"47(5F|60)\", source: \"Lugus\" }\r\n1084.7 \"Fire's Ire\" Ability { id: \"4761\", source: \"Lugus\" }\r\n1086.2 \"Fire's Domain\" Ability { id: \"47(5F|60)\", source: \"Lugus\" }\r\n1089.2 \"Fire's Ire\" Ability { id: \"4761\", source: \"Lugus\" }\r\n1090.7 \"Fire's Domain\" Ability { id: \"47(5F|60)\", source: \"Lugus\" }\r\n1093.7 \"Fire's Ire\" Ability { id: \"4761\", source: \"Lugus\" }\r\n1106.4 \"Scorching Left/Right\" Ability { id: \"476[23]\", source: \"Lugus\" }\r\n\r\n1122.9 \"Culling Blade\" Ability { id: \"4765\", source: \"Lugus\" } window 25,20\r\n1126.2 \"Plummet\" Ability { id: \"4767\", source: \"Lugus\" }\r\n1133.3 \"Black Flame\" Ability { id: \"475D\", source: \"Lugus\" }\r\n1136.7 \"Otherworldly Heat\" Ability { id: \"475C\", source: \"Lugus\" }\r\n1142.4 \"Mortal Flame\" Ability { id: \"4759\", source: \"Lugus\" }\r\n1169.1 \"Scorching Left/Right\" Ability { id: \"476[23]\", source: \"Lugus\" }\r\n1181.8 \"Fire's Domain\" Ability { id: \"47(5F|60)\", source: \"Lugus\" }\r\n1184.9 \"Fire's Ire\" Ability { id: \"4761\", source: \"Lugus\" }\r\n1186.4 \"Fire's Domain\" Ability { id: \"47(5F|60)\", source: \"Lugus\" }\r\n1189.4 \"Fire's Ire\" Ability { id: \"4761\", source: \"Lugus\" }\r\n1190.9 \"Fire's Domain\" Ability { id: \"47(5F|60)\", source: \"Lugus\" }\r\n1193.9 \"Fire's Ire\" Ability { id: \"4761\", source: \"Lugus\" }\r\n1195.4 \"Fire's Domain\" Ability { id: \"47(5F|60)\", source: \"Lugus\" }\r\n1198.4 \"Fire's Ire\" Ability { id: \"4761\", source: \"Lugus\" }\r\n\r\n1205.9 \"Captive Bolt\" Ability { id: \"4764\", source: \"Lugus\" } window 20,20\r\n1215.0 \"Black Flame\" Ability { id: \"475D\", source: \"Lugus\" }\r\n1218.5 \"Otherworldly Heat\" Ability { id: \"475C\", source: \"Lugus\" }\r\n1226.1 \"Culling Blade\" Ability { id: \"4765\", source: \"Lugus\" }\r\n1238.9 \"Scorching Left/Right\" Ability { id: \"476[23]\", source: \"Lugus\" }\r\n1251.6 \"Fire's Domain\" Ability { id: \"47(5F|60)\", source: \"Lugus\" }\r\n1254.7 \"Fire's Ire\" Ability { id: \"4761\", source: \"Lugus\" }\r\n1256.2 \"Fire's Domain\" Ability { id: \"47(5F|60)\", source: \"Lugus\" }\r\n1259.2 \"Fire's Ire\" Ability { id: \"4761\", source: \"Lugus\" }\r\n1260.7 \"Fire's Domain\" Ability { id: \"47(5F|60)\", source: \"Lugus\" }\r\n1263.7 \"Fire's Ire\" Ability { id: \"4761\", source: \"Lugus\" }\r\n1265.0 \"Fire's Domain\" Ability { id: \"47(5F|60)\", source: \"Lugus\" }\r\n1268.2 \"Fire's Ire\" Ability { id: \"4761\", source: \"Lugus\" }\r\n\r\n1275.7 \"Captive Bolt\" Ability { id: \"4764\", source: \"Lugus\" } window 50,50 jump 1205.9\r\n1284.8 \"Black Flame\"\r\n1288.3 \"Otherworldly Heat\"\r\n1295.9 \"Culling Blade\"\r\n1308.7 \"Scorching Left/Right\"\r\n1321.4 \"Fire's Domain\"\r\n1324.5 \"Fire's Ire\"\r\n1326.0 \"Fire's Domain\"\r\n1329.0 \"Fire's Ire\"\r\n1330.5 \"Fire's Domain\"\r\n1333.5 \"Fire's Ire\"\r\n1334.8 \"Fire's Domain\"\r\n1338.0 \"Fire's Ire\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/twinning.ts



const twinning_triggerSet = {
  id: 'TheTwinning',
  zoneId: zone_id/* default.TheTwinning */.Z.TheTwinning,
  timelineFile: 'twinning.txt',
  triggers: [{
    id: 'Twinning Main Head',
    type: 'StartsUsing',
    netRegex: {
      id: '3DBC',
      source: 'Surplus Kaliya'
    },
    condition: data => data.CanStun() || data.CanSilence(),
    response: responses/* Responses.stun */.n3.stun()
  }, {
    id: 'Twinning Berserk',
    type: 'StartsUsing',
    netRegex: {
      id: '3DC0',
      source: 'Vitalized Reptoid'
    },
    condition: data => data.CanStun() || data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Twinning 128 Tonze Swing',
    type: 'StartsUsing',
    netRegex: {
      id: '3DBA',
      source: 'Servomechanical Minotaur'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    // The handling for these mechanics is similar enough it makes sense to combine the trigger
    id: 'Twinning Impact + Pounce',
    type: 'HeadMarker',
    netRegex: {
      id: ['003[2-5]', '005A'],
      capture: false
    },
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread (avoid cages)',
        de: 'Verteilen (Vermeide "Käfige")',
        fr: 'Dispersez-vous (évitez les cages)',
        ja: '散開 (檻に近づかない)',
        cn: '分散（躲避笼子）',
        ko: '산개 (몬스터 우리 피하기)'
      }
    }
  }, {
    id: 'Twinning Beastly Roar',
    type: 'StartsUsing',
    netRegex: {
      id: '3D64',
      source: 'Alpha Zaghnal',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Twinning Augurium',
    type: 'StartsUsing',
    netRegex: {
      id: '3D65',
      source: 'Alpha Zaghnal'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Twinning Charge Eradicated',
    type: 'HeadMarker',
    netRegex: {
      id: '005D'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Twinning Thunder Beam',
    type: 'StartsUsing',
    netRegex: {
      id: '3DED',
      source: 'Mithridates'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    // Alternatively, we could use 1B:\y{ObjectId}:(\y{Name}):....:....:00A0
    id: 'Twinning Allagan Thunder',
    type: 'StartsUsing',
    netRegex: {
      id: '3DEF',
      source: 'Mithridates'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Twinning Magitek Crossray',
    type: 'StartsUsing',
    netRegex: {
      id: '3DF8',
      source: 'The Tycoon',
      capture: false
    },
    suppressSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'cardinal lasers',
        de: 'Himmelrichtungs-Lasers',
        fr: 'Lasers cardinaux',
        ja: '十字レーザー',
        cn: '正点激光',
        ko: '십자 레이저'
      }
    }
  }, {
    id: 'Twinning Defensive Array',
    type: 'StartsUsing',
    netRegex: {
      id: '3DF2',
      source: 'The Tycoon',
      capture: false
    },
    suppressSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'outer lasers',
        de: 'Lasers am Rand',
        fr: 'Lasers extérieurs',
        ja: '外周レーザー',
        cn: '外侧激光',
        ko: '외곽 레이저'
      }
    }
  }, {
    id: 'Twinning Rail Cannon',
    type: 'StartsUsing',
    netRegex: {
      id: '3DFB',
      source: 'The Tycoon'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    // An alternative is 1B:\y{ObjectId}:\y{Name}:....:....:00A9
    id: 'Twinning Magicrystal',
    type: 'StartsUsing',
    netRegex: {
      id: '3E0C',
      source: 'The Tycoon',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'Twinning Discharger',
    type: 'StartsUsing',
    netRegex: {
      id: '3DFC',
      source: 'The Tycoon',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'vitalized reptoid': 'gestärkt(?:e|er|es|en) Reptoid',
      'The Tycoon': 'Tycoon',
      'surplus Kaliya': 'massengefertigt(?:e|er|es|en) Kaliya',
      'Alpha Zaghnal': 'Alpha-Zaghnal',
      '(?<! )Zaghnal': 'Zaghnal',
      'Servomechanical Minotaur': 'Servomechanisch(?:e|er|es|en) Minotaurus',
      'Mithridates': 'Mithridates',
      'Levinball': 'Donnerkugel',
      'The Cornice': 'Schnittstelle',
      'Aetherial Observation': 'Ätherobservationsdeck',
      'Repurposing': 'Umrüstanlage',
      'Cladoselache': 'Cladoselache'
    },
    'replaceText': {
      'Thunder Beam': 'Gewitterstrahl',
      'Temporal Paradox': 'Zeitparadox',
      'Temporal Flow': 'Zeitfluss',
      'Shock': 'Entladung',
      'Shattered Crystal': 'Berstender Kristall',
      'Rail Cannon': 'Magnetschienenkanone',
      'Pounce Errant': 'Tobende Tatze',
      'Magitek Ray': 'Magitek-Laser',
      'Magitek Crossray': 'Magitek-Kreuzlaser',
      'Magicrystal': 'Magitek-Kristall',
      'Laserblade': 'Laserklingen',
      'High-Tension Discharger': 'Hochspannungsentlader',
      'High Gravity': 'Hohe Gravitation',
      'Forlorn Impact': 'Einsamer Einschlag',
      'Electric Discharge': 'Elektrische Entladung',
      'Defensive Array': 'Magitek-Schutzlaser',
      'Charge Eradicated': 'Ausrottung',
      'Beastly Roar': 'Bestialisches Brüllen',
      'Beast Rampant': 'Ungezügelt',
      'Beast Passant': 'Stahlpranke',
      'Augurium': 'Schmetterbohrer',
      'Artificial Gravity': 'Künstliche Gravitation',
      'Allagan Thunder': 'Allagischer Blitzschlag',
      '(?<! )Gravity': 'Gravitation',
      '(?<! )Crossray': 'Kreuzlaser'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'vitalized reptoid': 'Reptoïde vitalisé',
      'The Tycoon': 'Le Magnat',
      'surplus Kaliya': 'Kaliya de surplus',
      'alpha zaghnal': 'Zaghnal alpha',
      'Servomechanical Minotaur': 'Minotaure Servomécanique',
      'Mithridates': 'Mithridate',
      'Levinball': 'boule foudroyante',
      'The Cornice': 'Cœur du propulseur dimensionnel',
      'Aetherial Observation': 'Observatoire des flux éthérés',
      'Repurposing': 'Atelier d\'opti-rénovation',
      'Cladoselache': 'Cladoselache'
    },
    'replaceText': {
      'Thunder Beam': 'Rayon de foudre',
      'Temporal Paradox': 'Paradoxe temporel',
      'Temporal Flow': 'Flux temporel',
      'Shock': 'Décharge électrostatique',
      'Shattered Crystal': 'Éclatement de cristal',
      'Rail Cannon': 'Canon électrique',
      'Pounce Errant': 'Attaque subite XXX',
      'Magitek Ray': 'Rayon magitek',
      'Magitek Crossray': 'Rayon croisé magitek',
      'Magicrystal': 'Cristal magitek',
      'Laserblade': 'Lame laser',
      'High-Tension Discharger': 'Déchargeur haute tension',
      'High Gravity': 'Haute gravité',
      '(?<! )Gravity/(?! )Crossray\\?\\?': 'Gravité/Rayon ??',
      'Forlorn Impact': 'Déflagration affligeante',
      'Electric Discharge': 'Décharge électrique',
      'Defensive Array': 'Rayon protecteur magitek',
      'Charge Eradicated': 'Éradicateur',
      'Beastly Roar': 'Rugissement bestial',
      'Beast Rampant': 'Rampant',
      'Beast Passant': 'Passant',
      'Augurium': 'Coup de tarière',
      'Artificial Gravity': 'Gravité artificielle',
      'Allagan Thunder': 'Foudre d\'Allag'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'vitalized reptoid': 'ヴァイタライズ・レプトイド',
      'The Tycoon': 'タイクーン',
      'surplus Kaliya': '量産型カーリア',
      'alpha zaghnal': 'アルファ・ザグナル',
      'Servomechanical Minotaur': 'サーヴォ・ミノタウロス',
      'Mithridates': 'ミトリダテス',
      'Levinball': '雷弾',
      'The Cornice': '次元潜行装置中枢',
      'Aetherial Observation': 'エーテル観測台',
      'Repurposing': '改装作業拠点',
      'Cladoselache': 'クラドセラケ'
    },
    'replaceText': {
      'Thunder Beam': 'サンダービーム',
      'Temporal Paradox': 'タイムパラドックス',
      'Temporal Flow': '時間解凍',
      'Shock': '放電',
      'Shattered Crystal': 'クリスタル破裂',
      'Rail Cannon': 'レールキャノン',
      'Pounce Errant': 'XXXパウンス',
      'Magitek Ray': '魔導レーザー',
      'Magitek Crossray': '魔導クロスレーザー',
      'Magicrystal': '魔導クリスタル',
      'Laserblade': 'レーザーブレード',
      'High-Tension Discharger': 'ハイテンション・ディスチャージャー',
      'High Gravity': '高重力',
      'Forlorn Impact': 'フォローンインパクト',
      'Electric Discharge': 'エレクトリック・ディスチャージ',
      'Defensive Array': '魔導プロテクティブレーザー',
      'Charge Eradicated': 'エラディケイター',
      'Beastly Roar': 'ビーストロア',
      'Beast Rampant': 'ランパント',
      'Beast Passant': 'パッサント',
      'Augurium': 'アウガースマッシュ',
      'Artificial Gravity': 'アーティフィシャル・グラビティ',
      'Allagan Thunder': 'アラガン・サンダー',
      '(?<! )Gravity': '(?<! )重力',
      '(?<! )Crossray': '(?<! )クロスレイ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'vitalized reptoid': '活力化爬虫半人马',
      'The Tycoon': '泰空',
      'surplus Kaliya': '量产型卡利亚',
      'alpha zaghnal': '扎戈斧龙一型',
      'Servomechanical Minotaur': '自控化弥诺陶洛斯',
      'Mithridates': '米特里达梯',
      'Levinball': '雷弹',
      'The Cornice': '时空潜行装置中枢',
      'Aetherial Observation': '以太观测台',
      'Repurposing': '改造据点',
      'Cladoselache': '裂口鲨'
    },
    'replaceText': {
      'Thunder Beam': '电光束',
      'Temporal Paradox': '时间悖论',
      'Temporal Flow': '时间解冻',
      'Shock': '放电',
      'Shattered Crystal': '水晶破裂',
      'Rail Cannon': '轨道炮',
      'Pounce Errant': 'XXX突袭',
      'Magitek Ray': '魔导激光',
      'Magitek Crossray': '魔导交叉激光',
      'Magicrystal': '魔导水晶',
      'Laserblade': '激光剑',
      'High-Tension Discharger': '高压排电',
      'High Gravity': '高重力',
      'Forlorn Impact': '绝望冲击',
      'Electric Discharge': '排电',
      'Defensive Array': '魔导防护激光',
      'Charge Eradicated': '歼灭弹',
      'Beastly Roar': '残虐咆哮',
      'Beast Rampant': '人立而起',
      'Beast Passant': '四足着地',
      'Augurium': '预兆',
      'Artificial Gravity': '人造重力',
      'Allagan Thunder': '亚拉戈闪雷',
      '(?<! )Gravity': '(?<! )重力',
      '(?<! )Crossray': '(?<! )交叉激光'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'vitalized reptoid': '활성된 파충류',
      'The Tycoon': '타이쿤',
      'surplus Kaliya': '양산형 칼리야',
      'alpha zaghnal': '알파 자그날',
      'Servomechanical Minotaur': '자동제어 미노타우로스',
      'Mithridates': '미트리다테스',
      'Levinball': '뇌탄',
      'Cladoselache': '클라도셀라케',
      'The Cornice': '차원 잠행 장치 중추',
      'Aetherial Observation': '에테르 관측대',
      'Repurposing': '개조 작업 거점'
    },
    'replaceText': {
      'Thunder Beam': '번개 광선',
      'Temporal Paradox': '시간 역설',
      'Temporal Flow': '시간 해동',
      'Shock': '방전',
      'Shattered Crystal': '크리스탈 파열',
      'Rail Cannon': '전자기포',
      'Pounce Errant': 'XXX 덮치기',
      'Magitek Ray': '마도 레이저',
      'Magitek Crossray': '마도 십자 레이저',
      'Magicrystal': '마도 크리스탈',
      'Laserblade': '레이저 칼날',
      'High-Tension Discharger': '고압 전류 방출',
      'High Gravity': '고중력',
      'Forlorn Impact': '쓸쓸한 충격',
      'Electric Discharge': '전류 방출',
      'Defensive Array': '마도 방어 레이저',
      'Charge Eradicated': '박멸',
      'Beastly Roar': '야수의 포효',
      'Beast Rampant': '두발걷기',
      'Beast Passant': '네발걷기',
      'Augurium': '공격 조짐',
      'Artificial Gravity': '인공 중력',
      'Allagan Thunder': '알라그 선더',
      '(?<! )Gravity': '그라비데',
      '(?<! )Crossray': '십자 레이저'
    }
  }]
};
/* harmony default export */ const twinning = (twinning_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/dungeon/twinning.txt
const dungeon_twinning_namespaceObject = "### Twinning\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Alpha Zaghnal\r\n# -p 3D65:108.5 -ii 3D66 3D67 3D68 3D69 3D6A 41CA 3D6C\r\n# Repurposing will be sealed off\r\n100.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"B9F\" } window 100,0\r\n108.5 \"Augurium\" Ability { id: \"3D65\", source: \"Alpha Zaghnal\" } window 109,9\r\n117.6 \"Beastly Roar\" Ability { id: \"3D64\", source: \"Alpha Zaghnal\" }\r\n122.9 \"Beast Rampant\" Ability { id: \"3D60\", source: \"Alpha Zaghnal\" }\r\n\r\n136.4 \"Forlorn Impact x4\" Ability { id: \"3D61\", source: \"Alpha Zaghnal\" } duration 4\r\n141.3 \"Beast Passant\" Ability { id: \"3D62\", source: \"Alpha Zaghnal\" }\r\n149.3 \"Beastly Roar\" Ability { id: \"3D64\", source: \"Alpha Zaghnal\" }\r\n158.3 \"Pounce Errant x4\" Ability { id: \"3D5F\", source: \"Alpha Zaghnal\" } duration 5.2\r\n# I've seen this Augurium skipped??\r\n170.5 \"Augurium\" Ability { id: \"3D65\", source: \"Alpha Zaghnal\" }\r\n178.8 \"Charge Eradicated\" Ability { id: \"3D63\", source: \"Alpha Zaghnal\" } window 50,5\r\n185.9 \"Charge Eradicated\" Ability { id: \"3D63\", source: \"Alpha Zaghnal\" }\r\n195.2 \"Beast Rampant\" Ability { id: \"3D60\", source: \"Alpha Zaghnal\" }\r\n\r\n208.6 \"Forlorn Impact x4\" Ability { id: \"3D61\", source: \"Alpha Zaghnal\" } duration 4 jump 136.4\r\n213.5 \"Beast Passant\"\r\n221.5 \"Beastly Roar\"\r\n230.5 \"Pounce Errant x4\"\r\n242.7 \"Augurium\"\r\n251.0 \"Charge Eradicated\"\r\n258.1 \"Charge Eradicated\"\r\n267.4 \"Beast Rampant\"\r\n\r\n\r\n### Mithridates\r\n# -p 3DED:512 -ii 3DEC 3DEF\r\n# Aetherial Observation will be sealed off\r\n500.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"BA0\" } window 500,0\r\n\r\n512.0 \"Thunder Beam\" Ability { id: \"3DED\", source: \"Mithridates\" } window 512,10\r\n522.2 \"Electric Discharge\" Ability { id: \"3DF0\", source: \"Mithridates\" }\r\n531.1 \"Shock\" Ability { id: \"3DF1\", source: \"Levinball\" }\r\n543.8 \"Laserblade\" Ability { id: \"3DEB\", source: \"Mithridates\" }\r\n555.9 \"Thunder Beam\" Ability { id: \"3DED\", source: \"Mithridates\" }\r\n569.5 \"Allagan Thunder\" Ability { id: \"3DEE\", source: \"Mithridates\" }\r\n\r\n582.1 \"Electric Discharge\" Ability { id: \"3DF0\", source: \"Mithridates\" }\r\n590.2 \"Laserblade\" Ability { id: \"3DEB\", source: \"Mithridates\" }\r\n591.0 \"Shock\" Ability { id: \"3DF1\", source: \"Levinball\" }\r\n602.4 \"Thunder Beam\" Ability { id: \"3DED\", source: \"Mithridates\" }\r\n\r\n617.5 \"Electric Discharge\" Ability { id: \"3DF0\", source: \"Mithridates\" } window 20,20 jump 582.1\r\n625.6 \"Laserblade\"\r\n626.4 \"Shock\"\r\n637.8 \"Thunder Beam\"\r\n\r\n652.9 \"Electric Discharge\"\r\n661.1 \"Laserblade\"\r\n661.8 \"Shock\"\r\n673.2 \"Thunder Beam\"\r\n\r\n\r\n### The Tycoon\r\n# -p 3DF8:1013.8 -ii 3DF6 3DFD\r\n\r\nhideall \"Temporal Paradox\"\r\nhideall \"Temporal Flow\"\r\n\r\n# The Cornice will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"BA2\" } window 1000,0\r\n\r\n1013.8 \"Magitek Crossray\" Ability { id: \"3DF8\", source: \"The Tycoon\" } window 1013.8,5\r\n1016.2 \"Temporal Paradox\" Ability { id: \"3DF7\", source: \"The Tycoon\" }\r\n1023.1 \"Temporal Flow\" Ability { id: \"3DF5\", source: \"The Tycoon\" }\r\n1024.4 \"Magitek Ray\" Ability { id: \"3DF3\", source: \"The Tycoon\" }\r\n\r\n1034.2 \"Defensive Array\" Ability { id: \"3DF2\", source: \"The Tycoon\" }\r\n1042.3 \"Temporal Flow\" Ability { id: \"3DF5\", source: \"The Tycoon\" }\r\n1043.4 \"Magitek Ray\" Ability { id: \"3DF3\", source: \"The Tycoon\" }\r\n1049.6 \"Artificial Gravity\" Ability { id: \"3DF9\", source: \"The Tycoon\" }\r\n1056.3 \"High Gravity\" Ability { id: \"3DFA\", source: \"The Tycoon\" }\r\n1065.9 \"Rail Cannon\" Ability { id: \"3DFB\", source: \"The Tycoon\" }\r\n\r\n1079.1 \"Defensive Array\" Ability { id: \"3DF2\", source: \"The Tycoon\" }\r\n1086.3 \"Magicrystal\" Ability { id: \"3E0C\", source: \"The Tycoon\" }\r\n1093.0 \"Shattered Crystal\" Ability { id: \"439A\", source: \"The Tycoon\" }\r\n1093.6 \"Temporal Flow\" Ability { id: \"3DF5\", source: \"The Tycoon\" }\r\n1094.9 \"Magitek Ray\" Ability { id: \"3DF3\", source: \"The Tycoon\" }\r\n\r\n1105.9 \"High-Tension Discharger\" Ability { id: \"3DFC\", source: \"The Tycoon\" }\r\n1119.2 \"Magitek Crossray\" Ability { id: \"3DF8\", source: \"The Tycoon\" }\r\n1129.3 \"Artificial Gravity\" Ability { id: \"3DF9\", source: \"The Tycoon\" }\r\n1135.5 \"Temporal Flow\" Ability { id: \"3DF5\", source: \"The Tycoon\" }\r\n1136.0 \"High Gravity\" Ability { id: \"3DFA\", source: \"The Tycoon\" }\r\n1136.6 \"Magitek Ray\" Ability { id: \"3DF3\", source: \"The Tycoon\" }\r\n1147.7 \"Rail Cannon\" Ability { id: \"3DFB\", source: \"The Tycoon\" }\r\n\r\n1161.2 \"Defensive Array\" Ability { id: \"3DF2\", source: \"The Tycoon\" }\r\n1167.3 \"Gravity/Crossray??\"\r\n# ???\r\n\r\n# TODO: It looks like from here, it can go:\r\n# A B\r\n# B B\r\n# B A\r\n# and then possibly another discharger??\r\n\r\n# Path A?\r\n#1161.2 \"Defensive Array\" Ability { id: \"3DF2\", source: \"The Tycoon\" }\r\n#1167.3 \"Artificial Gravity\" Ability { id: \"3DF9\", source: \"The Tycoon\" }\r\n#1170.5 \"Magicrystal\" Ability { id: \"3E0C\", source: \"The Tycoon\" }\r\n#1174.0 \"High Gravity\" Ability { id: \"3DFA\", source: \"The Tycoon\" }\r\n#1176.7 \"Temporal Flow\" Ability { id: \"3DF5\", source: \"The Tycoon\" }\r\n#1177.2 \"Shattered Crystal\" Ability { id: \"439A\", source: \"The Tycoon\" }\r\n#1178.0 \"Magitek Ray\" Ability { id: \"3DF3\", source: \"The Tycoon\" }\r\n\r\n# Path B?\r\n#1161.0 \"Defensive Array\" Ability { id: \"3DF2\", source: \"The Tycoon\" }\r\n#1172.2 \"Magitek Crossray\" Ability { id: \"3DF8\", source: \"The Tycoon\" }\r\n#1179.5 \"Magicrystal\" Ability { id: \"3E0C\", source: \"The Tycoon\" }\r\n#1186.2 \"Shattered Crystal\" Ability { id: \"439A\", source: \"The Tycoon\" }\r\n#1186.7 \"Temporal Flow\" Ability { id: \"3DF5\", source: \"The Tycoon\" }\r\n#1188.0 \"Magitek Ray\" Ability { id: \"3DF3\", source: \"The Tycoon\" }\r\n#1199.0 \"Rail Cannon\" Ability { id: \"3DFB\", source: \"The Tycoon\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/etc/the_diadem.ts


const the_diadem_triggerSet = {
  id: 'TheDiadem',
  zoneId: zone_id/* default.TheDiadem */.Z.TheDiadem,
  resetWhenOutOfCombat: false,
  triggers: [
  // https://xivapi.com/LogMessage/916
  // en: 7 minutes have elapsed since your last activity. [...]
  // There is no network packet for these log lines; so have to use GameLog.
  {
    id: 'Diadem Falling Asleep',
    type: 'GameLog',
    netRegex: {
      line: '7 minutes have elapsed since your last activity..*?',
      capture: false
    },
    response: responses/* Responses.wakeUp */.n3.wakeUp()
  },
  // There is presumably a network packet to, at a minimum, spawn the legendary node.
  // But currently no associated log line other than GameLog (code: 003B).
  {
    id: 'Diadem Found Gather Point',
    type: 'GameLog',
    netRegex: {
      line: 'You sense a grade .* clouded (?:mineral deposit|rocky outcrop|mature tree|lush vegetation patch).*?',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Found clouded gather point',
        de: 'Verhüllte Sammlerstelle gefunden',
        fr: 'Point de récolte évanescent détecté',
        ja: '幻の採集場探したよ！',
        cn: '梦幻采集点刷了！冲鸭！！',
        ko: '환상의 광맥/성목 발견'
      }
    }
  },
  // This one specifically uses player chat, so no replacement log line.
  {
    id: 'Diadem Flag Alert',
    type: 'GameLog',
    netRegex: {
      line: '.*\ue0bbThe Diadem *?',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Check coordinate on chat',
        de: 'Überprüfe die Koordinaten im Chat',
        fr: 'Vérifier les coordonnées sur le Tchat',
        ja: 'チャットに座標を確認',
        cn: '检查聊天栏中的坐标',
        ko: '디아뎀 좌표 채팅 올라옴'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'missingTranslations': true,
    'replaceSync': {
      '7 minutes have elapsed since your last activity..*?': 'Seit deiner letzten Aktivität sind 7 Minuten vergangen.',
      'The Diadem': 'Das Diadem'
    }
  }, {
    'locale': 'fr',
    'missingTranslations': true,
    'replaceSync': {
      '7 minutes have elapsed since your last activity.': 'Votre personnage est inactif depuis 7 minutes',
      'The Diadem': 'Le Diadème'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      '7 minutes have elapsed since your last activity.': '操作がない状態になってから7分が経過しました。',
      'The Diadem': 'ディアデム諸島'
    }
  }, {
    'locale': 'cn',
    'missingTranslations': true,
    'replaceSync': {
      '7 minutes have elapsed since your last activity..*?': '已经7分钟没有进行任何操作',
      'The Diadem': '云冠群岛'
    }
  }, {
    'locale': 'ko',
    'missingTranslations': true,
    'replaceSync': {
      '7 minutes have elapsed since your last activity..*?': '7분 동안 아무 조작을 하지 않았습니다',
      'The Diadem': '디아뎀 제도'
    }
  }]
};
/* harmony default export */ const the_diadem = (the_diadem_triggerSet);
// EXTERNAL MODULE: ./resources/regexes.ts
var regexes = __webpack_require__(402);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/eureka/bozjan_southern_front.ts





// List of events:
// https://github.com/xivapi/ffxiv-datamining/blob/master/csv/DynamicEvent.csv
//
// These ids are (unfortunately) gathered by hand and don't seem to correlate
// to any particular bits of data.  However, there's a game log message when you
// register for a CE and an 0x21 message with this id when you accept and
// teleport in.  This avoids having to translate all of these names and also
// guarantees that the player is actually in the CE for the purpose of
// filtering triggers.
const ceIds = {
  // Kill It with Fire
  kill: '1D4',
  // The Baying of the Hound(s)
  hounds: '1CC',
  // Vigil for the Lost
  vigil: '1D0',
  // Aces High
  aces: '1D2',
  // The Shadow of Death's Hand
  shadow: '1CD',
  // The Final Furlong
  furlong: '1D5',
  // The Hunt for Red Choctober
  choctober: '1CA',
  // Beast of Man
  beast: '1DB',
  // The Fires of War
  fires: '1D6',
  // Patriot Games
  patriot: '1D1',
  // Trampled under Hoof
  trampled: '1CE',
  // And the Flames Went Higher
  flames: '1D3',
  // Metal Fox Chaos
  metal: '1CB',
  // Rise of the Robots'
  robots: '1DF',
  // Where Strode the Behemoth
  behemoth: '1DC',
  // The Battle of Castrum Lacus Litore
  castrum: '1D7',
  // Albeleo
  albeleo: '1DA',
  // Adrammelech
  adrammelech: '1D8'
};

// 9443: torrid orb (fire)
// 9444: frozen orb (ice)
// 9445: aqueous orb (water)
// 9446: charged orb (thunder)
// 9447: vortical orb (wind)
// 9448: sabulous orb (stone)
const orbNpcNameIdToOutputString = {
  '9443': 'stop',
  '9444': 'move',
  '9445': 'knockback',
  '9446': 'out',
  '9447': 'in',
  '9448': 'rings'
};
const orbOutputStrings = {
  unknown: outputs/* default.unknown */.Z.unknown,
  knockback: outputs/* default.knockback */.Z.knockback,
  stop: {
    en: 'Stop',
    de: 'Stopp',
    fr: 'Arrêtez',
    ja: '動かない',
    cn: '停停停',
    ko: '멈추기'
  },
  // Special case.
  stopOutside: {
    en: 'Stop (Out)',
    de: 'Stop (Außen)',
    fr: 'Arrêtez (Extérieur)',
    ja: 'ストップ (外に)',
    cn: '停停停 (外面)',
    ko: '멈추기 (바깥에서)'
  },
  move: {
    en: 'Move',
    de: 'Bewegen',
    fr: 'Bougez',
    ja: '動け',
    cn: '动动动',
    ko: '움직이기'
  },
  in: outputs/* default.in */.Z["in"],
  out: {
    en: 'Out',
    de: 'Raus',
    fr: 'Exterieur',
    ja: '外へ',
    cn: '远离',
    ko: '밖으로'
  },
  rings: {
    en: 'Rings',
    de: 'Ringe',
    fr: 'Anneaux',
    ja: 'ドーナツ',
    cn: '月环',
    ko: '고리장판'
  }
};

// TODO: promote something like this to Conditions?
const tankBusterOnParty = ceName => (data, matches) => {
  if (ceName !== undefined && data.ce !== ceName) return false;
  if (matches.target === data.me) return true;
  if (data.role !== 'healer') return false;
  return data.party.inParty(matches.target);
};
const bozjan_southern_front_triggerSet = {
  id: 'TheBozjanSouthernFront',
  zoneId: zone_id/* default.TheBozjanSouthernFront */.Z.TheBozjanSouthernFront,
  timelineFile: 'bozjan_southern_front.txt',
  timeline: [data => {
    // The MRV missile is the first ability that hits the entire raid, but only the bottom raid.
    // Hopefully you have not died to the one ability before this.  We'll insert one line into
    // the timeline here that will see if the player by name was hit by a bottom raid aoe,
    // and then jump to the correct timeline.  There's no "autos without targets" shenanigans
    // that we can do here, like in BA.
    const regex = regexes/* default.ability */.Z.ability({
      id: '51FD',
      target: data.me
    });
    const line = `20036.9 "--helldiver--" sync /${regex.source}/ window 100,100 jump 30036.9`;
    return ['hideall "--helldiver--"', line];
  }],
  resetWhenOutOfCombat: false,
  timelineTriggers: [{
    id: 'Bozja South Castrum Lyon Winds\' Peak',
    regex: /Winds' Peak/,
    beforeSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  triggers: [
  // https://xivapi.com/LogMessage/916
  // en: 7 minutes have elapsed since your last activity. [...]
  // There is no network packet for these log lines; so have to use GameLog.
  {
    id: 'Bozja South Falling Asleep',
    type: 'GameLog',
    netRegex: {
      line: '7 minutes have elapsed since your last activity..*?',
      capture: false
    },
    response: responses/* Responses.wakeUp */.n3.wakeUp()
  }, {
    id: 'Bozja South Critical Engagement',
    type: 'ActorControl',
    netRegex: {
      command: '80000014'
    },
    run: (data, matches) => {
      // This fires when you win, lose, or teleport out.
      if (matches.data0 === '00') {
        if (data.ce !== undefined && data.options.Debug) console.log(`Stop CE: ${data.ce}`);
        // Stop any active timelines.
        data.StopCombat();
        // Prevent further triggers for any active CEs from firing.
        delete data.ce;
        return;
      }
      delete data.ce;
      const ceId = matches.data0.toUpperCase();
      for (const key in ceIds) {
        if (ceIds[key] === ceId) {
          if (data.options.Debug) console.log(`Start CE: ${key} (${ceId})`);
          data.ce = key;
          return;
        }
      }
      if (data.options.Debug) console.log(`Start CE: ??? (${ceId})`);
    }
  }, {
    id: 'Bozja South Choctober Choco Slash',
    type: 'StartsUsing',
    netRegex: {
      source: 'Red Comet',
      id: '506C'
    },
    condition: tankBusterOnParty('choctober'),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Bozja South Castrum Bottom Check',
    type: 'Ability',
    // TODO: netRegex could take (data) => {} here so we could do a target: data.me?
    netRegex: {
      source: '4th Legion Helldiver',
      id: '51FD'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.helldiver = true
  }, {
    id: 'Bozja South Castrum Helldiver MRV Missile',
    type: 'StartsUsing',
    netRegex: {
      source: '4th Legion Helldiver',
      id: '51FC',
      capture: false
    },
    // This won't play the first time, but that seems better than a false positive for the top.
    condition: data => data.helldiver,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Bozja South Castrum Helldiver Lateral Dive',
    type: 'StartsUsing',
    netRegex: {
      source: '4th Legion Helldiver',
      id: '51EA',
      capture: false
    },
    condition: data => data.helldiver,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in dive charge',
        de: 'Stehe im Ansturm',
        fr: 'Restez dans la charge',
        ja: '直線頭割りに入る',
        cn: '进入直线分摊',
        ko: '돌진 장판 위에 서기'
      }
    }
  }, {
    id: 'Bozja South Castrum Helldiver Magitek Missiles',
    type: 'StartsUsing',
    netRegex: {
      source: '4th Legion Helldiver',
      id: '51FF'
    },
    condition: tankBusterOnParty(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Bozja South Castrum Helldiver Infrared Blast',
    type: 'StartsUsing',
    netRegex: {
      source: '4th Legion Helldiver',
      id: '51EC',
      capture: false
    },
    condition: data => data.helldiver,
    delaySeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Take one tether',
        de: 'Nimm eine´Verbindung',
        fr: 'Prenez un lien',
        ja: '線を取る',
        cn: '接线',
        ko: '선 하나 낚아채기'
      }
    }
  }, {
    id: 'Bozja South Castrum Helldiver Joint Attack',
    type: 'StartsUsing',
    netRegex: {
      source: '4th Legion Helldiver',
      id: '51F2',
      capture: false
    },
    condition: data => data.helldiver,
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'Bozja South Castrum Brionac Electric Anvil',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brionac',
      id: '51DD'
    },
    condition: tankBusterOnParty(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Bozja South Castrum Brionac False Thunder Left',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brionac',
      id: '51CE',
      capture: false
    },
    condition: data => !data.helldiver,
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Bozja South Castrum Brionac False Thunder Right',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brionac',
      id: '51CF',
      capture: false
    },
    condition: data => !data.helldiver,
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Bozja South Castrum Brionac Anti-Warmachina Weaponry',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brionac',
      id: '51CD',
      capture: false
    },
    condition: data => !data.helldiver,
    delaySeconds: 6.5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Magitek Core',
        de: 'Besiege Magitek-Reaktor',
        fr: 'Tuez le Cœur magitek',
        ja: '魔導コアを撃破',
        cn: '击杀魔导核心',
        ko: '마도 핵 죽이기'
      }
    }
  }, {
    id: 'Bozja South Castrum Brionac Energy Generation',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brionac',
      id: '51D0',
      capture: false
    },
    condition: data => !data.helldiver,
    preRun: data => data.energyCount = (data.energyCount ?? 0) + 1,
    infoText: (data, _matches, output) => {
      if (data.energyCount === 1) return output.getUnderOrb();
      if (data.energyCount === 2) return output.goCorner();

      // TODO: triggers for energy generation.
      // It'd be nice to do this, but you barely see #3, let alone #5.
      // #1 is always get under orb
      // #2 is always get to corners
      // #3 has two spawn options (#1 or #2 callout), interorb tethers
      // #4 magentism to/from orb, but orbs don't have tethers
      // #5 magentism to/from orb, interorb tethers
      // https://docs.google.com/document/d/1gSHyYA4Qg_tEz-GK9N7ppAdbXQIL91MoYYWJ651lDMk/edit#
      // Energy generation is 51D0 is spawning orbs
      // Lightsphere is 9437, Darksphere is 9438.
      // Pos: (63,-222,249.4999) (94380000011982).
      // Pos: (80,-229,249.4999) (94380000011982).
      // Pos: (80,-215,249.4999) (94380000011982).
      // Pos: (97,-222,249.4999) (94380000011982).
    },

    outputStrings: {
      getUnderOrb: {
        en: 'Get Under Orb',
        de: 'Geh unter einem Orb',
        fr: 'Allez sous l\'Orbe',
        ja: '白玉に安置',
        cn: '靠近白球',
        ko: '구슬 아래로'
      },
      goCorner: {
        en: 'Go To Corner',
        de: 'Geh in die Ecken',
        fr: 'Allez dans un coin',
        ja: 'コーナーへ',
        cn: '去角落',
        ko: '구석으로'
      }
    }
  }, {
    id: 'Bozja South Castrum Albeleo Baleful Gaze',
    type: 'StartsUsing',
    netRegex: {
      source: 'Albeleo\'s Monstrosity',
      id: '5404',
      capture: false
    },
    suppressSeconds: 3,
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Bozja South Castrum Albeleo Abyssal Cry',
    type: 'StartsUsing',
    netRegex: {
      source: 'Albeleo\'s Hrodvitnir',
      id: '5406'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Bozja South Castrum Adrammelech Holy IV',
    type: 'StartsUsing',
    netRegex: {
      source: 'Adrammelech',
      id: '4F96',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Bozja South Castrum Adrammelech Flare',
    type: 'StartsUsing',
    netRegex: {
      source: 'Adrammelech',
      id: '4F95'
    },
    // TODO: this is probably magical.
    condition: tankBusterOnParty(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Bozja South Castrum Adrammelech Meteor',
    type: 'StartsUsing',
    netRegex: {
      source: 'Adrammelech',
      id: '4F92',
      capture: false
    },
    delaySeconds: 4.5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Meteors',
        de: 'Besiege die Meteore',
        fr: 'Tuez les météores',
        ja: 'メテオを撃破',
        cn: '击杀陨石',
        ko: '메테오 부수기'
      }
    }
  }, {
    id: 'Bozja South Castrum Adrammelech Orb Collector',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '944[3-8]'
    },
    run: (data, matches) => {
      data.orbs ??= {};
      data.orbs[matches.id.toUpperCase()] = matches.npcNameId;
    }
  }, {
    id: 'Bozja South Castrum Adrammelech Curse of the Fiend Orbs',
    type: 'StartsUsing',
    // TODO: We could probably move this right after the orbs appear?
    netRegex: {
      source: 'Adrammelech',
      id: '4F7B',
      capture: false
    },
    // Mini-timeline:
    //  0.0: Adrammelech starts using Curse Of The Fiend
    //  3.0: Adrammelech uses Curse Of The Fiend
    //  4.0: orbs appear
    //  6.2: Adrammelech starts using Accursed Becoming
    //  7.1: orb tethers appear
    // 10.1: Adrammelech uses Accursed Becoming
    // 17.3: Adrammelech uses orb ability #1.
    preRun: data => data.fiendCount = (data.fiendCount ?? 0) + 1,
    durationSeconds: data => Object.keys(data.orbs ?? {}).length === 4 ? 23 : 14,
    suppressSeconds: 20,
    infoText: (data, _matches, output) => {
      // Let your actor id memes be dreams!
      // Orbs go off from highest actor id to lowest actor id, in pairs of two.
      const sortedOrbs = Object.keys(data.orbs || {}).sort().reverse();
      const orbIdToNameId = data.orbs;
      delete data.orbs;
      if (!orbIdToNameId || sortedOrbs.length === 0) return output.unknown();
      const orbOutput = data.orbOutput = sortedOrbs.map(orbId => {
        const nameId = orbIdToNameId[orbId];
        if (nameId === undefined) return 'unknown';
        return orbNpcNameIdToOutputString[nameId] ?? 'unknown';
      });

      // If there is a pair of orbs, and they are the same type, then this is the mechanic
      // introduction and only one orb goes off.
      if (orbOutput.length === 2 && orbOutput[0] === orbOutput[1]) orbOutput.length = 1;

      // Special case, fire + earth = stop far outside.
      if (orbOutput.length >= 2) {
        if (orbOutput[0] === 'stop' && orbOutput[1] === 'rings') orbOutput[0] = 'stopOutside';
      }
      if (orbOutput.length === 4) {
        if (orbOutput[2] === 'stop' && orbOutput[3] === 'rings') orbOutput[2] = 'stopOutside';
      }

      // Don't bother outputting a single one, as it'll come up shortly.
      // This could get confusing saying "knockback" far enough ahead
      // that using knockback prevention would wear off before the mechanic.
      if (orbOutput.length > 1) return orbOutput.map(key => output[key]()).join(' => ');
    },
    outputStrings: orbOutputStrings
  }, {
    id: 'Bozja South Castrum Adrammelech Accursed Becoming Orb 1',
    type: 'Ability',
    // This ability happens once per pair of orbs (with the same timings).
    // So use these two triggers to handle the single, pair, and two pairs of orbs cases.
    netRegex: {
      source: 'Adrammelech',
      id: '4F7B',
      capture: false
    },
    // 5 seconds warning.
    delaySeconds: 7.2 - 5,
    durationSeconds: 4.5,
    alertText: (data, _matches, output) => {
      data.orbOutput ??= [];
      const orb = data.orbOutput.shift();
      if (orb === undefined) return;
      return output[orb]();
    },
    outputStrings: orbOutputStrings
  }, {
    id: 'Bozja South Castrum Adrammelech Accursed Becoming Orb 2',
    type: 'Ability',
    netRegex: {
      source: 'Adrammelech',
      id: '4F7B',
      capture: false
    },
    // 2.5 seconds warning, as it's weird if this shows up way before the first orb.
    delaySeconds: 9 - 2.5,
    alertText: (data, _matches, output) => {
      data.orbOutput ??= [];
      const orb = data.orbOutput.shift();
      if (orb === undefined) return;
      return output[orb]();
    },
    outputStrings: orbOutputStrings
  }, {
    id: 'Bozja South Castrum Adrammelech Electric Charge Collector',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '9449'
    },
    run: (data, matches) => {
      data.warped ??= {};
      data.warped[matches.id.toUpperCase()] = {
        x: parseFloat(matches.x),
        y: parseFloat(matches.y)
      };
    }
  }, {
    id: 'Bozja South Castrum Adrammelech Shock',
    type: 'Tether',
    // This is the first Electric Charge tether.
    netRegex: {
      source: 'Adrammelech',
      target: 'Electric Charge'
    },
    alertText: (data, matches, output) => {
      if (!data.warped) return output.unknown();
      const loc = data.warped[matches.targetId.toUpperCase()];
      delete data.warped;
      if (!loc) return output.unknown();

      // Four inner orb locations:
      // 85, -614.6 (NE)
      // 88.6, -601.1 (SE)
      // 75.1, -597.5 (SW)
      // 71.5, -611 (NW)

      const adrammelechCenterX = 80;
      const adrammelechCenterY = -605;

      // North is negative y.
      if (loc.x > adrammelechCenterX) {
        if (loc.y < adrammelechCenterY) return output.southwest();
        return output.northwest();
      }
      if (loc.y < adrammelechCenterY) return output.southeast();
      return output.northeast();
    },
    outputStrings: {
      unknown: {
        // "Follow Other People ;)"
        en: 'Go ???',
        de: 'Gehe nach ???',
        fr: 'Allez au ???',
        ja: '??? へ',
        cn: '去 ???',
        ko: '???쪽으로'
      },
      northeast: {
        en: 'Go northeast',
        de: 'Gehe nach Nordosten',
        fr: 'Allez au nord-est',
        ja: '北東へ',
        cn: '去右上(东北)',
        ko: '북동쪽으로'
      },
      southeast: {
        en: 'Go southeast',
        de: 'Gehe nach Südosten',
        fr: 'Allez au sud-est',
        ja: '南東へ',
        cn: '去右下(东南)',
        ko: '남동쪽으로'
      },
      southwest: {
        en: 'Go southwest',
        de: 'Gehe nach Südwesten',
        fr: 'Allez au sud-ouest',
        ja: '南西へ',
        cn: '去左下(西南)',
        ko: '남서쪽으로'
      },
      northwest: {
        en: 'Go northwest',
        de: 'Gehe nach Nordwesten',
        fr: 'Allez au nord-ouest',
        ja: '北西へ',
        cn: '去左上(西北)',
        ko: '북서쪽으로'
      }
    }
  }, {
    id: 'Bozja South Castrum Dawon Molting Plumage',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dawon',
      id: '517A',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Bozja South Castrum Dawon Molting Plumage Orbs',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dawon',
      id: '517A',
      capture: false
    },
    delaySeconds: 5,
    alertText: (data, _matches, output) => {
      // Only the first plumage orbs have no wind.
      // If we needed to this dynamically, look for Call Beast (5192) from Lyon before this.
      const text = data.haveSeenMoltingPlumage ? output.orbWithFlutter() : output.justOrb();
      data.haveSeenMoltingPlumage = true;
      return text;
    },
    outputStrings: {
      justOrb: {
        en: 'Get Under Light Orb',
        de: 'Unter einem Lichtorb stellen',
        fr: 'Allez sous un Orbe lumineux',
        ja: '白玉へ',
        cn: '靠近白球',
        ko: '하얀 구슬 안으로'
      },
      orbWithFlutter: {
        en: 'Get Under Blown Light Orb',
        de: 'Zu einem weggeschleuderten Lichtorb gehen',
        fr: 'Allez sous un Orbe lumineux soufflé',
        ja: '吹き飛ばされた白玉へ',
        cn: '靠近吹动后的白球',
        ko: '하얀 구슬이 이동할 위치로'
      }
    }
  }, {
    id: 'Bozja South Castrum Dawon Scratch',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dawon',
      id: '517B'
    },
    condition: tankBusterOnParty(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Bozja South Castrum Dawon Swooping Frenzy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dawon',
      id: '5175',
      capture: false
    },
    suppressSeconds: 9999,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Follow Boss',
        de: 'Folge dem Boss',
        fr: 'Suivez le Boss',
        ja: 'ボスの後ろに追う',
        cn: '跟紧在Boss身后',
        ko: '보스 따라가기'
      }
    }
  },
  // https://xivapi.com/LogMessage/9644
  // No 0x29 log line for this, so we have to use GameLog.
  // TODO: Check whether this could be ActorControlSelfExtra (category: 0x020F) when available.
  {
    id: 'Bozja South Castrum Lyon Passage',
    type: 'GameLog',
    netRegex: {
      line: 'Lyon the Beast King would do battle at Majesty\'s Place.*?',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Lyon Passage Open',
        de: 'Lyon Zugang offen',
        fr: 'Passage du Lyon ouvert',
        ja: '獣王ライオンフェイス開始',
        cn: '挑战兽王莱昂',
        ko: '라이언 포탈 개방'
      }
    }
  }, {
    id: 'Bozja South Castrum Lyon Twin Agonies',
    type: 'StartsUsing',
    netRegex: {
      source: 'Lyon The Beast King',
      id: '5174'
    },
    condition: tankBusterOnParty(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Bozja South Castrum Lyon King\'s Notice',
    type: 'StartsUsing',
    netRegex: {
      source: 'Lyon The Beast King',
      id: '516E',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Bozja South Castrum Lyon Taste of Blood',
    type: 'StartsUsing',
    netRegex: {
      source: 'Lyon The Beast King',
      id: '5173',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Lyon the Beast King would do battle at Majesty\'s Place': 'Der Bestienkönig will einen Kampf auf seinem Podest',
      'Red Comet': 'Rot(?:e|er|es|en) Meteor',
      'Albeleo\'s Monstrosity': 'Albeleos Biest',
      'Albeleo\'s Hrodvitnir': 'Hrodvitnir',
      'Electric Charge': 'Blitz',
      '7 minutes have elapsed since your last activity..*?': 'Seit deiner letzten Aktivität sind 7 Minuten vergangen.',
      '4Th Legion Helldiver': 'Höllentaucher der IV\\. Legion',
      'Adrammelech': 'Adrammelech',
      'Bladesmeet': 'Hauptplatz der Wachen',
      'Brionac': 'Brionac',
      'Dawon': 'Dawon',
      'Eaglesight': 'Platz des Kämpferischen Adlers',
      'Lightsphere': 'Lichtkugel',
      'Lyon The Beast King(?! would)': 'Lyon (?:der|die|das) Bestienkönig',
      'Majesty\'s Auspice': 'Halle des Bestienkönigs',
      'Shadowsphere': 'Schattensphäre',
      'The airship landing': 'Flugplatz',
      'The grand gates': 'Haupttor',
      'Verdant Plume': 'blau(?:e|er|es|en) Feder'
    },
    'replaceText': {
      '(?<!Command: )Chain Cannon': 'Kettenkanone',
      '(?<!Command: )Dive Formation': 'Simultanattacke',
      '(?<!Command: )Infrared Blast': 'Hitzestrahlung',
      '(?<!Command: )Lateral Dive': 'Frontalangriff',
      '--Lyon Passage--': '--Lyon Zugang--',
      'Accursed Becoming': 'Zaubersynthese',
      'Aero IV': 'Windka',
      'Anti-Warmachina Weaponry': 'Anti-Magitek-Attacke',
      'Blizzard IV': 'Eiska',
      'Burst II': 'Knall',
      'Call Beast': 'Ruppiges Rufen',
      'Command: Chain Cannon': 'Befehl: Kettenkanonensalve',
      'Command: Dive Formation': 'Befehl: Simultanattacke',
      'Command: Infrared Blast': 'Befehl: Hitzestrahlung',
      'Command: Joint Attack': 'Befehl: Antiobjektattacke',
      'Command: Lateral Dive': 'Befehl: Frontalangriff',
      'Command: Suppressive Formation': 'Antipersonenangriff',
      'Curse Of The Fiend': 'Zaubersiegel',
      'Electric Anvil': 'Elektroamboss',
      'Energy Generation': 'Energiegenerierung',
      'Explosion': 'Explosion',
      'False Thunder': 'Störsender',
      'Fervid Pulse': 'Flammenstoß',
      'Fire IV': 'Feuka',
      'Flare': 'Flare',
      'Frigid Pulse': 'Froststoß',
      'Frigid/': 'Frost/',
      'Heart Of Nature': 'Puls der Erde',
      'Holy IV': 'Giga-Sanctus',
      'Lightburst': 'Lichtstoß',
      'Lightning Shower': 'Blitzregen',
      'Magitek Magnetism': 'Magimagnetismus',
      'Magitek Missiles': 'Magitek-Rakete',
      'Magnetic Jolt': 'Magnetische Interferenz',
      'Meteor': 'Meteor',
      'Molting Plumage': 'Federsturm',
      'Mrv Missile': 'Multisprengkopf-Rakete',
      'Nature\'s Blood': 'Erdschneider',
      'Nature\'s Pulse': 'Erdrutsch',
      'Obey': 'Gehorchen',
      'Orb': 'Orb',
      'Pentagust': 'Pentagast',
      'Polar Magnetism': 'Konvertermagnet',
      'Pole Shift': 'Umpolung',
      'Raging Winds': 'Sturmflügel',
      'Ready': 'Bellendes Befehlen',
      'Scratch': 'Kräftiges Kratzen',
      'Shadow Burst': 'Schattenstoß',
      'Shock': 'Energetisierung',
      'Stone IV': 'Steinka',
      'Surface Missile': 'Antipersonenrakete',
      'Swooping Frenzy': 'Heftiges Schütteln',
      'Taste Of Blood': 'Blutiges Wehklagen',
      'The King\'s Notice': 'Herrschender Blick',
      'Thunder IV': 'Blitzka',
      'Tornado': 'Tornado',
      'Twin Agonies': 'Doppelter Tod',
      'Voltstream': 'Voltstrom',
      'Warped Light': 'Blitzartillerie',
      'Water IV': 'Giga-Aqua',
      'Winds\' Peak': 'Katastrophale Windstärke'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Lyon the Beast King would do battle at Majesty\'s Place': 'Lyon attend des adversaires à sa taille sur la tribune des Souverains',
      'Red Comet': 'Comète Rouge',
      'Albeleo\'s Monstrosity': 'Bête D\'Albeleo',
      'Albeleo\'s Hrodvitnir': 'Hródvitnir',
      'Electric Charge': 'Boule D\'Énergie',
      '7 minutes have elapsed since your last activity..*?': 'Votre personnage est inactif depuis 7 minutes',
      '4Th Legion Helldiver': 'plongeur infernal de la 4e légion',
      'Adrammelech': 'Adrammelech',
      'Bladesmeet': 'Hall des Lames',
      'Brionac': 'Brionac',
      'Dawon': 'Dawon',
      'Eaglesight': 'Perchoir des Aigles',
      'Lightsphere': 'sphère de lumière',
      'Lyon The Beast King(?! would)': 'Lyon le Roi bestial',
      'Majesty\'s Auspice': 'Auditorium',
      'Shadowsphere': 'sphère ombrale',
      'The airship landing': 'Aire d\'atterrissage',
      'The grand gates': 'Porte du castrum',
      'Verdant Plume': 'plume de sinople'
    },
    'replaceText': {
      '--Lyon Passage--': '--Passage du Lyon --',
      '(?<!Command: )Chain Cannon': 'Canon automatique',
      '(?<!Command: )Dive Formation': 'Attaque groupée',
      '(?<!Command: )Infrared Blast': 'Rayonnement thermique',
      '(?<!Command: )Lateral Dive': 'Attaque frontale',
      'Accursed Becoming': 'Combinaison de sortilège',
      'Aero IV': 'Giga Vent',
      'Anti-Warmachina Weaponry': 'Attaque antimagitek',
      'Blizzard IV': 'Giga Glace',
      'Burst II': 'Bouillonnement',
      'Call Beast': 'Appel familier',
      'Command: Chain Cannon': 'Directive : Salve de canons automatiques',
      'Command: Dive Formation': 'Nouvelle directive : Attaque groupée antimatériel',
      'Command: Infrared Blast': 'Nouvelle directive : Rayonnement thermique antimatériel',
      'Command: Joint Attack': 'Nouvelle directive : Attaque ciblée antimatériel',
      'Command: Lateral Dive': 'Nouvelle directive : Attaque frontale antimatériel',
      'Command: Suppressive Formation': 'Neutralisation',
      'Curse Of The Fiend': 'Sceau magique',
      'Electric Anvil': 'Enclume électrique',
      'Energy Generation': 'Condensateur d\'énergie',
      'Explosion': 'Explosion',
      'False Thunder': 'Foudre artificielle',
      '(?<!Frigid/)Fervid Pulse': 'Pulsation ardente',
      'Fire IV': 'Giga Feu',
      'Flare': 'Brasier',
      'Frigid/Fervid Pulse': 'Pulsation glacial/ardente',
      'Frigid Pulse': 'Pulsation glaciale',
      'Heart Of Nature': 'Pulsation sismique',
      'Holy IV': 'Giga Miracle',
      'Lightburst': 'Éclat de lumière',
      'Lightning Shower': 'Averse d\'éclairs',
      'Magitek Magnetism': 'Électroaimant magitek',
      'Magitek Missiles': 'Missiles magitek',
      'Magnetic Jolt': 'Interférences magnétiques',
      'Meteor': 'Météore',
      'Molting Plumage': 'Mue de plumage',
      'Mrv Missile': 'Missile à tête multiple',
      'Nature\'s Blood': 'Onde fracturante',
      'Nature\'s Pulse': 'Onde brise-terre',
      'Obey': 'À l\'écoute du maître',
      'Orb': 'Orbe',
      'Pentagust': 'Pentasouffle',
      'Polar Magnetism': 'Aimant à polarité inversée',
      'Pole Shift': 'Inversion des pôles',
      'Raging Winds': 'Rafales stagnantes',
      'Ready': 'Obéis !',
      'Scratch': 'Griffade',
      'Shadow Burst': 'Salve ténébreuse',
      'Shock': 'Décharge électrostatique',
      'Stone IV': 'Giga Terre',
      'Surface Missile': 'Missiles sol-sol',
      'Swooping Frenzy': 'Plongeon frénétique',
      'Taste Of Blood': 'Lamentation sanglante',
      'The King\'s Notice': 'Œil torve des conquérants',
      'Thunder IV': 'Giga Foudre',
      'Tornado': 'Tornade',
      'Twin Agonies': 'Double fracassage',
      'Voltstream': 'Flux voltaïque',
      'Warped Light': 'Artillerie éclair',
      'Water IV': 'Giga Eau',
      'Winds\' Peak': 'Rafales furieuses'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Lyon the Beast King would do battle at Majesty\'s Place': '獣王ライアンは、王者の円壇での戦いを望んでいるようだ',
      'Red Comet': 'レッドコメット',
      'Albeleo\'s Monstrosity': 'アルビレオズ・ビースト',
      'Albeleo\'s Hrodvitnir': 'アルビレオズ・フローズヴィトニル',
      'Electric Charge': '雷気',
      '7 minutes have elapsed since your last activity.': '操作がない状態になってから7分が経過しました。',
      '4Th Legion Helldiver': 'IVレギオン・ヘルダイバー',
      'Adrammelech': 'アドラメレク',
      'Bladesmeet': '剣たちの大広間',
      'Brionac': 'ブリューナク',
      'Dawon': 'ドゥン',
      'Eaglesight': '荒鷲の広場',
      'Lightsphere': 'ライトスフィア',
      'Lyon The Beast King(?! would)': '獣王ライアン',
      'Majesty\'s Auspice': '円壇の間',
      'Shadowsphere': 'シャドウスフィア',
      'The airship landing': '飛空戦艦発着場',
      'The grand gates': '城門',
      'Verdant Plume': '濃緑の羽根'
    },
    'replaceText': {
      '--Lyon Passage--': '--ライオンへ行きましょう--',
      '(?<!Command: )Chain Cannon': 'チェーンガン',
      '(?<!Command: )Dive Formation': '一斉突撃',
      '(?<!Command: )Infrared Blast': '熱線照射',
      '(?<!Command: )Lateral Dive': '突進攻撃',
      'Accursed Becoming': '魔法合成',
      'Aero IV': 'エアロジャ',
      'Anti-Warmachina Weaponry': '対魔導兵器攻撃',
      'Blizzard IV': 'ブリザジャ',
      'Burst II': 'バースト',
      'Call Beast': 'よびだす',
      'Command: Chain Cannon': '発令：チェーンガン斉射',
      'Command: Dive Formation': '発令：対物一斉突撃',
      'Command: Infrared Blast': '発令：対物熱線照射',
      'Command: Joint Attack': '発令：対物集中攻撃',
      'Command: Lateral Dive': '発令：対物突進攻撃',
      'Command: Suppressive Formation': '制圧突撃',
      'Curse Of The Fiend': '魔法印',
      'Electric Anvil': 'エレクトリックアンビル',
      'Energy Generation': 'エネルギー体生成',
      'Explosion': '爆散',
      'False Thunder': 'フォルスサンダー',
      '(?<!/)Fervid Pulse': 'ファーヴィッドパルス',
      'Fire IV': 'ファイジャ',
      'Flare': 'フレア',
      'Frigid Pulse': 'フリジッドパルス',
      'Frigid/Fervid Pulse': 'フリジッドパルス/ファーヴィッドパルス',
      'Heart Of Nature': '地霊脈',
      'Holy IV': 'ホーリジャ',
      'Lightburst': 'ライトバースト',
      'Lightning Shower': 'ライトニングシャワー',
      'Magitek Magnetism': '魔導マグネット',
      'Magitek Missiles': '魔導ミサイル',
      'Magnetic Jolt': '磁力干渉',
      'Meteor': 'メテオ',
      'Molting Plumage': 'モルトプルメイジ',
      'Mrv Missile': '多弾頭ミサイル',
      'Nature\'s Blood': '波導地霊斬',
      'Nature\'s Pulse': '波導地霊衝',
      'Obey': 'しじをきく',
      'Orb': '玉',
      'Pentagust': 'ペンタガスト',
      'Polar Magnetism': '転換マグネット',
      'Pole Shift': '磁場転換',
      'Raging Winds': '風烈飛翔流',
      'Ready': 'しじをさせろ',
      'Scratch': 'スクラッチ',
      'Shadow Burst': 'シャドウバースト',
      'Shock': '放電',
      'Stone IV': 'ストンジャ',
      'Surface Missile': '対地ミサイル',
      'Swooping Frenzy': 'スワープフレンジー',
      'Taste Of Blood': '鬼哭血散斬',
      'The King\'s Notice': '覇王邪視眼',
      'Thunder IV': 'サンダジャ',
      'Tornado': 'トルネド',
      'Twin Agonies': '双魔邪王斬',
      'Voltstream': 'ボルトストリーム',
      'Warped Light': '閃光砲',
      'Water IV': 'ウォタジャ',
      'Winds\' Peak': '超級烈風波'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Lyon the Beast King would do battle at Majesty\'s Place': '兽王莱昂似乎很期待在王者圆坛战斗！',
      'Red Comet': '红色彗星',
      'Albeleo\'s Monstrosity': '阿尔贝雷欧的巨兽',
      'Albeleo\'s Hrodvitnir': '阿尔贝雷欧的恶狼',
      'Electric Charge': '雷气',
      '7 minutes have elapsed since your last activity..*?': '已经7分钟没有进行任何操作',
      '4Th Legion Helldiver': '第四军团地狱潜者',
      'Adrammelech': '阿德拉梅里克',
      'Bladesmeet': '群刃大厅',
      'Brionac': '布里欧纳克',
      'Dawon': '达温',
      'Eaglesight': '苍鹰广场',
      'Lightsphere': '光耀晶球',
      'Lyon The Beast King(?! would)': '兽王 莱昂',
      'Majesty\'s Auspice': '圆坛之间',
      'Shadowsphere': '暗影晶球',
      'The airship landing': '飞空战舰着陆台',
      'The grand gates': '城门',
      'Verdant Plume': '浓绿之羽'
    },
    'replaceText': {
      '--Lyon Passage--': '--兽王通道开启--',
      '(?<!Command: )Chain Cannon': '链式机关炮',
      '(?<!Command: )Dive Formation': '一齐突击',
      '(?<!Command: )Infrared Blast': '热线照射',
      '(?<!Command: )Lateral Dive': '突进攻击',
      'Accursed Becoming': '魔法合成',
      'Aero IV': '飙风',
      'Anti-Warmachina Weaponry': '对魔导兵器攻击',
      'Blizzard IV': '冰澈',
      'Burst II': '磁暴',
      'Call Beast': '呼叫',
      'Command: Chain Cannon': '下令：链式机关炮齐射',
      'Command: Dive Formation': '下令：对物一齐突击',
      'Command: Infrared Blast': '下令：对物热线照射',
      'Command: Joint Attack': '下令：对物集中攻击',
      'Command: Lateral Dive': '下令：对物突进攻击',
      'Command: Suppressive Formation': '下令：对人压制突击',
      'Curse Of The Fiend': '魔法印',
      'Electric Anvil': '电砧',
      'Energy Generation': '生成能源体',
      'Explosion': '爆炸',
      'False Thunder': '伪雷',
      '(?<!/)Fervid Pulse': '炙热脉冲',
      'Fire IV': '炽炎',
      'Flare': '核爆',
      'Frigid Pulse': '寒冷脉冲',
      'Frigid/Fervid Pulse': '寒冷脉冲/炙热脉冲',
      'Heart Of Nature': '地灵脉',
      'Holy IV': '极圣',
      'Lightburst': '光爆破',
      'Lightning Shower': '雷光雨',
      'Magitek Magnetism': '魔导磁石',
      'Magitek Missiles': '魔导飞弹',
      'Magnetic Jolt': '磁力干涉',
      'Meteor': '陨石流星',
      'Molting Plumage': '换羽',
      'Mrv Missile': '多弹头飞弹',
      'Nature\'s Blood': '波导地灵斩',
      'Nature\'s Pulse': '波导地灵冲',
      'Obey': '服从',
      'Orb': '球',
      'Pentagust': '五向突风',
      'Polar Magnetism': '转换磁石',
      'Pole Shift': '磁场转换',
      'Raging Winds': '风烈飞翔流',
      'Ready': '准备',
      'Scratch': '抓击',
      'Shadow Burst': '暗影爆',
      'Shock': '放电',
      'Stone IV': '崩石',
      'Surface Missile': '对地导弹',
      'Swooping Frenzy': '狂乱猛冲',
      'Taste Of Blood': '鬼哭血散斩',
      'The King\'s Notice': '霸王邪视眼',
      'Thunder IV': '霹雷',
      'Tornado': '龙卷',
      'Twin Agonies': '双魔邪王斩',
      'Voltstream': '电压流',
      'Warped Light': '闪光炮',
      'Water IV': '骇水',
      'Winds\' Peak': '超级烈风波'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Lyon the Beast King would do battle at Majesty\'s Place': '마수왕 라이언이 왕의 단상에서 싸우려고 합니다!',
      'Red Comet': '붉은 혜성',
      'Albeleo\'s Monstrosity': '알비레오의 야수',
      'Albeleo\'s Hrodvitnir': '알비레오의 흐로드비트니르',
      'Electric Charge': '번개기운',
      '7 minutes have elapsed since your last activity..*?': '7분 동안 아무 조작을 하지 않았습니다',
      '4Th Legion Helldiver': 'IV군단 헬다이버',
      'Adrammelech': '아드람멜렉',
      'Bladesmeet': '검들의 대광장',
      'Brionac': '브류나크',
      'Dawon': '다우언',
      'Eaglesight': '독수리 광장',
      'Lightsphere': '빛 구체',
      'Lyon The Beast King(?! would)': '마수왕 라이언',
      'Majesty\'s Auspice': '단상',
      'Shadowsphere': '그림자 구체',
      'The airship landing': '골드 소서 비공정 승강장',
      'The grand gates': '성문',
      'Verdant Plume': '진녹색 날개'
    },
    'replaceText': {
      '--Lyon Passage--': '--라이언 포탈 개방--',
      '(?<!Command: )Chain Cannon': '기관총 일제 발사',
      '(?<!Command: )Dive Formation': '대물 일제 돌격',
      '(?<!Command: )Infrared Blast': '대물 열선',
      '(?<!Command: )Lateral Dive': '대물 돌진 공격',
      'Accursed Becoming': '마법 합성',
      'Aero IV': '에어로쟈',
      'Anti-Warmachina Weaponry': '마도 병기 대응 공격',
      'Blizzard IV': '블리자쟈',
      'Burst II': '버스트',
      'Call Beast': '부르기',
      'Command: Chain Cannon': '지령: 기관총 일제 발사',
      'Command: Dive Formation': '지령: 대물 일제 돌격',
      'Command: Infrared Blast': '지령: 대물 열선',
      'Command: Joint Attack': '지령: 대물 집중 공격',
      'Command: Lateral Dive': '지령: 대물 돌진 공격',
      'Command: Suppressive Formation': '대인 제압 돌격',
      'Curse Of The Fiend': '마법인',
      'Electric Anvil': '전기 모루',
      'Energy Generation': '에너지 구체 생성',
      'Explosion': '폭산',
      'False Thunder': '인공 번개',
      'Frigid(?! )': '냉랭한',
      'Fervid Pulse': '열렬한 고동',
      'Fire IV': '파이쟈',
      'Flare': '플레어',
      'Frigid Pulse': '냉랭한 고동',
      'Heart Of Nature': '지령맥',
      'Holy IV': '홀리쟈',
      'Lightburst': '빛 분출',
      'Lightning Shower': '번개 세례',
      'Magitek Magnetism': '마도 자석',
      'Magitek Missiles': '마도 미사일',
      'Magnetic Jolt': '자력 간섭',
      'Meteor': '메테오',
      'Molting Plumage': '털갈이',
      'Mrv Missile': '다탄두 미사일',
      'Nature\'s Blood': '파도지령참',
      'Nature\'s Pulse': '파도지령충',
      'Obey': '명령 따르기',
      'Orb': '구슬',
      'Pentagust': '다섯 갈래 돌풍',
      'Polar Magnetism': '자석 변환',
      'Pole Shift': '자기장 전환',
      'Raging Winds': '풍렬비상류',
      'Ready': '명령하기',
      'Scratch': '생채기',
      'Shadow Burst': '그림자 폭발',
      'Shock': '방전',
      'Stone IV': '스톤쟈',
      'Surface Missile': '대지 미사일',
      'Swooping Frenzy': '광란의 급강하',
      'Taste Of Blood': '귀곡혈산참',
      'The King\'s Notice': '패왕사시안',
      'Thunder IV': '선더쟈',
      'Tornado': '토네이도',
      'Twin Agonies': '쌍마사왕참',
      'Voltstream': '번개 급류',
      'Warped Light': '섬광포',
      'Water IV': '워터쟈',
      'Winds\' Peak': '초급렬풍파'
    }
  }]
};
/* harmony default export */ const bozjan_southern_front = (bozjan_southern_front_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/eureka/bozjan_southern_front.txt
const eureka_bozjan_southern_front_namespaceObject = "### The Bozjan Southern Front\r\n# https://docs.google.com/document/d/1zl-Z99fF1x8uhZwk9ewW4Q5UcR2dLLS_zzxQSRFWQNM/edit\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Use zone-unseal and 0x21 Reset lines\r\n# Trigger set contains 'resetWhenOutOfCombat: false'\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"80000014\", data0: \"00\" } window 0,100000 jump 0\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n# TODO: fill in CEs\r\n# The idea with each of them is that you have at most two minutes of standing\r\n# around, so start each timeline at +200 from the initial 0x21 sync line.\r\n# e.g. Kill It With Fire would start at 1200 with \"Start\" and then boss\r\n# abilities from there.\r\n\r\n### Kill It with Fire\r\n1000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1D4\" } window 100000,0\r\n\r\n### The Baying of the Hound(s)\r\n2000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1CC\" } window 100000,0\r\n\r\n### Vigil for the Lost\r\n3000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1D0\" } window 100000,0\r\n\r\n### Aces High\r\n4000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1D2\" } window 100000,0\r\n\r\n### The Shadow of Death's Hand\r\n5000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1CD\" } window 100000,0\r\n\r\n### The Final Furlong\r\n6000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1D5\" } window 100000,0\r\n\r\n### The Hunt for Red Choctober\r\n7000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1CA\" } window 100000,0\r\n\r\n### Beast of Man\r\n8000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1DB\" } window 100000,0\r\n\r\n### Fires of War\r\n9000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1D6\" } window 100000,0\r\n\r\n### Patriot Games\r\n10000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1D1\" } window 100000,0\r\n\r\n### Trampled under Hoof\r\n11000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1CE\" } window 100000,0\r\n\r\n### And the Flames Went Higher\r\n12000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1D3\" } window 100000,0\r\n\r\n### Metal Fox Chaos\r\n13000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1CB\" } window 100000,0\r\n\r\n### Rise of the Robots\r\n14000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1DF\" } window 100000,0\r\n\r\n### Where Strode the Behemoth\r\n15000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1DC\" } window 100000,0\r\n\r\n### The Battle of Castrum Lacus Litore\r\n#16000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"1D7\" } window 100000,0\r\n\r\n### Brionac / 4th Legion Helldiver\r\n# The Grand Gates will be sealed off\r\n20000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"DD9\" } window 100000,0\r\n# Eaglesight will be sealed off\r\n20000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"DD8\" } window 100000,0\r\n# JavaScript will insert a sync to jump to 4th Legion Helldiver if you are on the bottom.\r\n# Unfortunately, there is nothing in the log to differentiate otherwise.\r\n\r\n### Brionac\r\n# -ic \"Xeven The Vengeful\" \"Tunnel Armor\" \"4Th Legion Helldiver\"\r\n# -ii 51DD 5201 53C5 51DA 51D4 51D6 51D8\r\n#-p 51DC:20014.7\r\n#\r\n# 53C5 Lightning Shower is the first obvious \"you are on the top\" damage\r\n# Anti-Warchmachina Weaponry summons an add; once dead, the timeline resumes.\r\n20014.7 \"Electric Anvil\" Ability { id: \"51DC\", source: \"Brionac\" }\r\n20026.8 \"False Thunder\" Ability { id: \"51C[EF]\", source: \"Brionac\" }\r\n20035.0 \"Anti-Warmachina Weaponry\" Ability { id: \"51CD\", source: \"Brionac\" }\r\n20135.0 \"--sync--\" StartsUsing { id: \"53C4\", source: \"Brionac\" } window 100,50\r\n20139.0 \"Lightning Shower\" Ability { id: \"53C4\", source: \"Brionac\" }\r\n\r\n20146.1 \"Energy Generation\" Ability { id: \"51D0\", source: \"Brionac\" }\r\n20158.2 \"Lightburst\" Ability { id: \"51D1\", source: \"Lightsphere\" }\r\n\r\n20171.2 \"False Thunder\" Ability { id: \"51C[EF]\", source: \"Brionac\" }\r\n\r\n20177.3 \"Energy Generation\" Ability { id: \"51D0\", source: \"Brionac\" }\r\n20189.5 \"Shadow Burst\" Ability { id: \"51D2\", source: \"Shadowsphere\" }\r\n\r\n20203.5 \"Electric Anvil\" Ability { id: \"51DC\", source: \"Brionac\" }\r\n20218.8 \"Voltstream\" Ability { id: \"51DB\", source: \"Brionac\" }\r\n20222.8 \"Voltstream\" Ability { id: \"51DB\", source: \"Brionac\" }\r\n20226.9 \"Voltstream\" Ability { id: \"51DB\", source: \"Brionac\" }\r\n20230.9 \"Voltstream\" Ability { id: \"51DB\", source: \"Brionac\" }\r\n\r\n20238.8 \"Energy Generation\" Ability { id: \"51D0\", source: \"Brionac\" }\r\n20250.9 \"Pole Shift\" Ability { id: \"51D3\", source: \"Brionac\" }\r\n20254.9 \"Shadow Burst\" Ability { id: \"51D2\", source: \"Shadowsphere\" }\r\n20254.9 \"Lightburst\" Ability { id: \"51D1\", source: \"Lightsphere\" }\r\n\r\n20263.2 \"Anti-Warmachina Weaponry\" Ability { id: \"51CD\", source: \"Brionac\" }\r\n20363.2 \"--sync--\" StartsUsing { id: \"53C4\", source: \"Brionac\" } window 100,50\r\n20367.2 \"Lightning Shower\" Ability { id: \"53C4\", source: \"Brionac\" }\r\n20374.3 \"Energy Generation\" Ability { id: \"51D0\", source: \"Brionac\" }\r\n20384.4 \"Magitek Magnetism\" Ability { id: \"51D5\", source: \"Brionac\" }\r\n20388.6 \"Magnetic Jolt\" Ability { id: \"51D7\", source: \"Brionac\" }\r\n20389.4 \"Lightburst\" Ability { id: \"51D1\", source: \"Lightsphere\" }\r\n20389.4 \"Shadow Burst\" Ability { id: \"51D2\", source: \"Shadowsphere\" }\r\n20399.6 \"Voltstream\" Ability { id: \"51DB\", source: \"Brionac\" }\r\n20403.6 \"Voltstream\" Ability { id: \"51DB\", source: \"Brionac\" }\r\n20407.7 \"Voltstream\" Ability { id: \"51DB\", source: \"Brionac\" }\r\n20411.7 \"Voltstream\" Ability { id: \"51DB\", source: \"Brionac\" }\r\n20418.6 \"False Thunder\" Ability { id: \"51CF\", source: \"Brionac\" }\r\n20427.9 \"Anti-Warmachina Weaponry\" Ability { id: \"51CD\", source: \"Brionac\" }\r\n20527.9 \"--sync--\" StartsUsing { id: \"51DC\", source: \"Brionac\" } window 100,50\r\n20531.9 \"Electric Anvil\" Ability { id: \"51DC\", source: \"Brionac\" }\r\n\r\n20539.0 \"Energy Generation\" Ability { id: \"51D0\", source: \"Brionac\" }\r\n20549.1 \"Polar Magnetism\" Ability { id: \"51D9\", source: \"Brionac\" }\r\n20554.2 \"Shadow Burst\" Ability { id: \"51D2\", source: \"Shadowsphere\" }\r\n20554.2 \"Lightburst\" Ability { id: \"51D1\", source: \"Lightsphere\" }\r\n\r\n20565.4 \"Energy Generation\" Ability { id: \"51D0\", source: \"Brionac\" }\r\n20565.4 \"Voltstream\" Ability { id: \"51DB\", source: \"Brionac\" }\r\n\r\n# ???\r\n\r\n\r\n### 4th Legion Helldiver\r\n# -ic \"Xeven The Vengeful\" Brionac Lightsphere Shadowsphere\r\n# -ii 51FA 51FF 51ED 51FC 51F1 51F7 5200\r\n# -p 5200:30006.5\r\n#\r\n# 51FD MRV Missile is the first obvious \"you are on the bottom\"\r\n# Chain Cannon is not a trustworthy sync, even when it's on its own.\r\n\r\n# Uncomment this to more easily test this timeline.\r\n# Eaglesight will be sealed off\r\n# 30000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"DD8\" } window 100000,0\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# Fake intro, where you don't know if you're on the top or the bottom.\r\n# Don't sync because sometimes these bosses are +/- 3 seconds @_@\r\n20022.2 \"Chain Cannon\" duration 6.5 #Ability { id: \"51F9\", source: \"4Th Legion Helldiver\" }\r\n20036.9 \"Mrv Missile\" #Ability { id: \"51FD\", source: \"4Th Legion Helldiver\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n30022.2 \"Chain Cannon\" duration 6.5 #Ability { id: \"51F9\", source: \"4Th Legion Helldiver\" }\r\n30036.9 \"Mrv Missile\" Ability { id: \"51FD\", source: \"4Th Legion Helldiver\" } window 50,50\r\n30049.1 \"Command: Lateral Dive\" Ability { id: \"51EA\", source: \"4Th Legion Helldiver\" }\r\n30057.1 \"Lateral Dive\" Ability { id: \"51EB\", source: \"4Th Legion Helldiver\" }\r\n30065.3 \"Command: Suppressive Formation\" Ability { id: \"51F5\", source: \"4Th Legion Helldiver\" }\r\n30073.3 \"Command: Suppressive Formation\" Ability { id: \"51F6\", source: \"4Th Legion Helldiver\" }\r\n30082.6 \"Magitek Missiles\" Ability { id: \"51FE\", source: \"4Th Legion Helldiver\" }\r\n30097.8 \"Command: Infrared Blast\" Ability { id: \"51EC\", source: \"4Th Legion Helldiver\" }\r\n30102.4 \"Infrared Blast\" Ability { id: \"51EE\", source: \"4Th Legion Helldiver\" }\r\n30106.4 \"Infrared Blast\" Ability { id: \"51EE\", source: \"4Th Legion Helldiver\" }\r\n30110.4 \"Infrared Blast\" Ability { id: \"51EE\", source: \"4Th Legion Helldiver\" }\r\n30114.4 \"Infrared Blast\" Ability { id: \"51EE\", source: \"4Th Legion Helldiver\" }\r\n30134.1 \"Command: Chain Cannon\" Ability { id: \"51FB\", source: \"4Th Legion Helldiver\" }\r\n30138.9 \"Chain Cannon\" duration 6.5 #Ability { id: \"51F9\", source: \"4Th Legion Helldiver\" }\r\n30140.8 \"Chain Cannon\" duration 6.5 #Ability { id: \"51F9\", source: \"4Th Legion Helldiver\" }\r\n30142.9 \"Chain Cannon\" duration 6.5 #Ability { id: \"51F9\", source: \"4Th Legion Helldiver\" }\r\n30144.9 \"Chain Cannon\" duration 6.5 #Ability { id: \"51F9\", source: \"4Th Legion Helldiver\" }\r\n30153.4 \"Magitek Missiles\" Ability { id: \"51FE\", source: \"4Th Legion Helldiver\" } window 15,15\r\n30167.6 \"Command: Dive Formation\" Ability { id: \"51EF\", source: \"4Th Legion Helldiver\" }\r\n30179.6 \"Dive Formation\" Ability { id: \"51F0\", source: \"4Th Legion Helldiver\" }\r\n30183.6 \"Dive Formation\" Ability { id: \"51F0\", source: \"4Th Legion Helldiver\" }\r\n30187.6 \"Dive Formation\" Ability { id: \"51F0\", source: \"4Th Legion Helldiver\" }\r\n30197.8 \"Command: Lateral Dive\" Ability { id: \"51EA\", source: \"4Th Legion Helldiver\" }\r\n30203.9 \"Command: Suppressive Formation\" Ability { id: \"51F5\", source: \"4Th Legion Helldiver\" }\r\n30205.8 \"Lateral Dive\" Ability { id: \"51EB\", source: \"4Th Legion Helldiver\" }\r\n30209.8 \"Chain Cannon\" duration 6.5 #Ability { id: \"51F9\", source: \"4Th Legion Helldiver\" }\r\n30211.9 \"Command: Suppressive Formation\" Ability { id: \"51F6\", source: \"4Th Legion Helldiver\" }\r\n30232.6 \"Magitek Missiles\" Ability { id: \"51FE\", source: \"4Th Legion Helldiver\" }\r\n30246.8 \"Command: Joint Attack\" Ability { id: \"51F2\", source: \"4Th Legion Helldiver\" }\r\n30255.0 \"Command: Infrared Blast\" Ability { id: \"51EC\", source: \"4Th Legion Helldiver\" }\r\n30259.6 \"Infrared Blast\" Ability { id: \"51EE\", source: \"4Th Legion Helldiver\" }\r\n30263.6 \"Infrared Blast\" Ability { id: \"51EE\", source: \"4Th Legion Helldiver\" }\r\n30265.3 \"Surface Missile\" Ability { id: \"51F8\", source: \"4Th Legion Helldiver\" }\r\n30267.7 \"Infrared Blast\" Ability { id: \"51EE\", source: \"4Th Legion Helldiver\" }\r\n30270.4 \"Surface Missile\" Ability { id: \"51F8\", source: \"4Th Legion Helldiver\" }\r\n30271.6 \"Infrared Blast\" Ability { id: \"51EE\", source: \"4Th Legion Helldiver\" }\r\n30278.2 \"Command: Chain Cannon\" Ability { id: \"51FB\", source: \"4Th Legion Helldiver\" }\r\n30282.8 \"Chain Cannon\" duration 6.5 #Ability { id: \"51F9\", source: \"4Th Legion Helldiver\" }\r\n30284.3 \"Command: Suppressive Formation\" Ability { id: \"51F5\", source: \"4Th Legion Helldiver\" }\r\n30284.9 \"Chain Cannon\" duration 6.5 #Ability { id: \"51F9\", source: \"4Th Legion Helldiver\" }\r\n30286.8 \"Chain Cannon\" duration 6.5 #Ability { id: \"51F9\", source: \"4Th Legion Helldiver\" }\r\n30288.9 \"Chain Cannon\" duration 6.5 #Ability { id: \"51F9\", source: \"4Th Legion Helldiver\" }\r\n30292.3 \"Command: Suppressive Formation\" Ability { id: \"51F6\", source: \"4Th Legion Helldiver\" }\r\n# ???\r\n\r\n\r\n### Albeleo the Maleficent\r\n# Bladesmeet will be sealed off\r\n40000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"DD5\" } window 100000,0\r\n\r\n\r\n### Adrammelech\r\n# -p 4F96:50014.3\r\n# -ii 4F94 4F91 4F8D 504E 504F 5050 5051 5052 4F8B 4F7E 504C 545C 4F90 4F7C 4F84 4F88 4F89 4F82 4F83 4F93\r\n# note: accursed becoming IV casts have different ability ids the first time through.\r\n\r\n# The airship landing will be sealed off\r\n50000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"DDA\" } window 100000,0\r\n50014.3 \"Holy IV\" Ability { id: \"4F96\", source: \"Adrammelech\" }\r\n\r\n50021.8 \"Curse Of The Fiend\" Ability { id: \"4F7A\", source: \"Adrammelech\" }\r\n50028.9 \"Accursed Becoming\" Ability { id: \"4F7B\", source: \"Adrammelech\" }\r\n50036.1 \"Water IV\" Ability { id: \"53D8\", source: \"Adrammelech\" }\r\n\r\n50044.4 \"Curse Of The Fiend\" Ability { id: \"4F7A\", source: \"Adrammelech\" }\r\n50051.5 \"Accursed Becoming\" Ability { id: \"4F7B\", source: \"Adrammelech\" }\r\n50058.7 \"Fire IV/Blizzard IV\" Ability { id: \"545[AD]\", source: \"Adrammelech\" }\r\n\r\n50067.0 \"Curse Of The Fiend\" Ability { id: \"4F7A\", source: \"Adrammelech\" }\r\n50074.1 \"Accursed Becoming\" Ability { id: \"4F7B\", source: \"Adrammelech\" }\r\n50081.3 \"Stone IV/Aero IV/Thunder IV\" Ability { id: \"4F(7F|80|81)\", source: \"Adrammelech\" }\r\n\r\n50091.4 \"Burst II\" Ability { id: \"4F8A\", source: \"Adrammelech\" }\r\n50102.5 \"Warped Light\" Ability { id: \"4F8C\", source: \"Adrammelech\" }\r\n50105.5 \"Shock\" Ability { id: \"4F8E\", source: \"Adrammelech\" }\r\n\r\n50116.0 \"Curse Of The Fiend\" Ability { id: \"4F7A\", source: \"Adrammelech\" }\r\n50123.1 \"Accursed Becoming\" Ability { id: \"4F7B\", source: \"Adrammelech\" }\r\n50130.3 \"Orb 1\" #Ability { id: [\"504D\", \"504A\", \"4F7D\", \"4F8[5-7]\"], source: \"Adrammelech\" }\r\n50132.1 \"Orb 2\" #Ability { id: [\"504D\", \"504A\", \"4F7D\", \"4F8[5-7]\"], source: \"Adrammelech\" }\r\n\r\n50144.3 \"Tornado\" Ability { id: \"4F8F\", source: \"Adrammelech\" }\r\n50151.4 \"Flare\" Ability { id: \"4F95\", source: \"Adrammelech\" }\r\n50160.5 \"Holy IV\" Ability { id: \"4F96\", source: \"Adrammelech\" }\r\n50168.7 \"Meteor\" Ability { id: \"4F92\", source: \"Adrammelech\" } duration 20.7\r\n\r\n# HP push? I have seen Meteor and Tornado->Meteor all skipped.\r\n50194.3 \"--sync--\" StartsUsing { id: \"4F7A\", source: \"Adrammelech\" } window 70,20\r\n50197.3 \"Curse Of The Fiend\" Ability { id: \"4F7A\", source: \"Adrammelech\" }\r\n50204.4 \"Accursed Becoming\" Ability { id: \"4F7B\", source: \"Adrammelech\" }\r\n50211.6 \"Orb 1\" #Ability { id: [\"504D\", \"504A\", \"4F7D\", \"4F8[5-7]\"], source: \"Adrammelech\" }\r\n50213.4 \"Orb 2\" #Ability { id: [\"504D\", \"504A\", \"4F7D\", \"4F8[5-7]\"], source: \"Adrammelech\" }\r\n50213.5 \"Accursed Becoming\" Ability { id: \"4F7B\", source: \"Adrammelech\" }\r\n50220.7 \"Orb 3\" #Ability { id: [\"504D\", \"504A\", \"4F7D\", \"4F8[5-7]\"], source: \"Adrammelech\" }\r\n50222.5 \"Orb 4\" #Ability { id: [\"504D\", \"504A\", \"4F7D\", \"4F8[5-7]\"], source: \"Adrammelech\" }\r\n\r\n50230.7 \"Flare\" Ability { id: \"4F95\", source: \"Adrammelech\" }\r\n50237.8 \"Tornado\" Ability { id: \"4F8F\", source: \"Adrammelech\" }\r\n50244.9 \"Meteor\" Ability { id: \"4F92\", source: \"Adrammelech\" } duration 20.7\r\n50262.6 \"Burst II\" Ability { id: \"4F8A\", source: \"Adrammelech\" }\r\n50273.8 \"Warped Light\" Ability { id: \"4F8C\", source: \"Adrammelech\" }\r\n50276.8 \"Shock\" Ability { id: \"4F8E\", source: \"Adrammelech\" }\r\n50288.0 \"Holy IV\" Ability { id: \"4F96\", source: \"Adrammelech\" }\r\n50295.1 \"Holy IV\" Ability { id: \"4F96\", source: \"Adrammelech\" }\r\n50304.2 \"Flare\" Ability { id: \"4F95\", source: \"Adrammelech\" }\r\n\r\n50316.7 \"Curse Of The Fiend\" Ability { id: \"4F7A\", source: \"Adrammelech\" }\r\n50323.8 \"Accursed Becoming\" Ability { id: \"4F7B\", source: \"Adrammelech\" }\r\n50331.0 \"Orb 1\" #Ability { id: [\"504D\", \"504A\", \"4F7D\", \"4F8[5-7]\"], source: \"Adrammelech\" }\r\n50332.8 \"Orb 2\" #Ability { id: [\"504D\", \"504A\", \"4F7D\", \"4F8[5-7]\"], source: \"Adrammelech\" }\r\n50332.9 \"Accursed Becoming\" Ability { id: \"4F7B\", source: \"Adrammelech\" }\r\n50340.1 \"Orb 3\" #Ability { id: [\"504D\", \"504A\", \"4F7D\", \"4F8[5-7]\"], source: \"Adrammelech\" }\r\n50341.9 \"Orb 4\" #Ability { id: [\"504D\", \"504A\", \"4F7D\", \"4F8[5-7]\"], source: \"Adrammelech\" }\r\n\r\n# Loop\r\n# TODO: if anybody ever finds the enrage, we can unroll this.\r\n50350.1 \"Flare\" Ability { id: \"4F95\", source: \"Adrammelech\" }\r\n50357.2 \"Tornado\" Ability { id: \"4F8F\", source: \"Adrammelech\" } window 100,100 jump 50237.8\r\n50364.3 \"Meteor\"\r\n50382.0 \"Burst II\"\r\n50385.0 \"Meteor\"\r\n50393.2 \"Warped Light\"\r\n50396.2 \"Shock\"\r\n50407.4 \"Holy IV\"\r\n50414.5 \"Holy IV\"\r\n50423.6 \"Flare\"\r\n\r\n\r\n### Dawon / Lyon\r\n# -ic \"Tamed Coeurl\" \"Tamed Manticore\" \"Tamed Beetle\" \"Scarlet Plume\"\r\n# -p 517A:60014.3\r\n# -ii 5165 5177 51BB 5190 5170 5160\r\n\r\n# Phase 1\r\n# Majesty's Auspice will be sealed off\r\n60000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"DDB\" } window 100000,0\r\n60014.3 \"Molting Plumage\" Ability { id: \"517A\", source: \"Dawon\" }\r\n60025.9 \"Explosion\" Ability { id: \"5182\", source: \"Verdant Plume\" }\r\n60033.5 \"Scratch\" Ability { id: \"517B\", source: \"Dawon\" }\r\n60042.1 \"Fervid Pulse\" Ability { id: \"5179\", source: \"Dawon\" }\r\n60050.6 \"Swooping Frenzy\" Ability { id: \"5175\", source: \"Dawon\" }\r\n60058.4 \"Frigid Pulse\" Ability { id: \"5178\", source: \"Dawon\" }\r\n60067.9 \"Ready x3\" duration 4.1 #Ability { id: \"5191\", source: \"Lyon The Beast King\" }\r\n60074.9 \"Obey\" Ability { id: \"517C\", source: \"Dawon\" }\r\n60077.0 \"Swooping Frenzy\" Ability { id: \"517E\", source: \"Dawon\" }\r\n60079.8 \"Frigid Pulse/Fervid Pulse\" Ability { id: \"51(7F|80)\", source: \"Dawon\" }\r\n60082.2 \"Swooping Frenzy\" Ability { id: \"517E\", source: \"Dawon\" }\r\n60085.0 \"Frigid Pulse/Fervid Pulse\" Ability { id: \"51(7F|80)\", source: \"Dawon\" }\r\n60087.4 \"Swooping Frenzy\" Ability { id: \"517E\", source: \"Dawon\" }\r\n60090.2 \"Frigid Pulse/Fervid Pulse\" Ability { id: \"51(7F|80)\", source: \"Dawon\" }\r\n60101.6 \"Call Beast\" Ability { id: \"5192\", source: \"Lyon The Beast King\" }\r\n60107.6 \"Molting Plumage\" Ability { id: \"517A\", source: \"Dawon\" }\r\n60119.2 \"Explosion\" Ability { id: \"5182\", source: \"Verdant Plume\" }\r\n60128.9 \"Pentagust\" Ability { id: \"5176\", source: \"Dawon\" }\r\n60139.6 \"Scratch\" Ability { id: \"517B\", source: \"Dawon\" }\r\n\r\n# This only sometimes happens?? Is there a loop here?\r\n# 60158.4 \"Call Beast\" Ability { id: \"5192\", source: \"Lyon The Beast King\" }\r\n\r\n# Phase 2\r\n# Raging Winds starts and ends the phase, even if you win.\r\n# This starts when anybody goes up, so might be delayed\r\n# I've also seen this cast twice?? e.g. 173.3 Raging Winds, 177.5 Call Beast, 185.6 Raging Winds??\r\n# Regardless, everything seems to sync ok after that.\r\n# TODO: is there some way to isolate the top??\r\n60153.6 \"--Lyon Passage--\" # ??? double check this timing\r\n60166.5 \"Raging Winds\" Ability { id: \"5164\", source: \"Lyon The Beast King\" } window 100,20\r\n60172.6 \"Winds' Peak\" Ability { id: \"516F\", source: \"Lyon The Beast King\" }\r\n60183.8 \"Heart Of Nature\" Ability { id: \"515E\", source: \"Lyon The Beast King\" }\r\n60188.8 \"Nature's Pulse\" Ability { id: \"5161\", source: \"Lyon The Beast King\" }\r\n60190.3 \"Nature's Pulse\" Ability { id: \"5162\", source: \"Lyon The Beast King\" }\r\n60191.8 \"Nature's Pulse\" Ability { id: \"5163\", source: \"Lyon The Beast King\" }\r\n60198.0 \"Taste Of Blood\" Ability { id: \"5173\", source: \"Lyon The Beast King\" }\r\n60210.2 \"Heart Of Nature\" Ability { id: \"515E\", source: \"Lyon The Beast King\" } duration 6.6\r\n60218.2 \"Nature's Blood\" Ability { id: \"515F\", source: \"Lyon The Beast King\" }\r\n60218.3 \"Winds' Peak\" Ability { id: \"516F\", source: \"Lyon The Beast King\" }\r\n60228.4 \"Twin Agonies\" Ability { id: \"5174\", source: \"Lyon The Beast King\" }\r\n60241.6 \"Heart Of Nature\" Ability { id: \"515E\", source: \"Lyon The Beast King\" } duration 6.6\r\n60248.7 \"The King's Notice\" Ability { id: \"516E\", source: \"Lyon The Beast King\" }\r\n60249.6 \"Nature's Blood\" Ability { id: \"515F\", source: \"Lyon The Beast King\" }\r\n60256.6 \"Taste Of Blood\" Ability { id: \"5173\", source: \"Lyon The Beast King\" }\r\n60275.7 \"Raging Winds Enrage\" #Ability { id: \"5164\", source: \"Lyon The Beast King\" }\r\n\r\n# Phase 3\r\n61000.0 \"--sync--\" StartsUsing { id: \"517D\", source: \"Dawon\" } window 1000,0\r\n61002.0 \"Ready x4\" duration 6.1 #Ability { id: \"5191\", source: \"Lyon The Beast King\" }\r\n61012.0 \"Obey\" Ability { id: \"517D\", source: \"Dawon\" }\r\n61014.1 \"Swooping Frenzy\" Ability { id: \"517E\", source: \"Dawon\" }\r\n61016.9 \"Frigid/Fervid Pulse\" Ability { id: \"51(7F|80)\", source: \"Dawon\" }\r\n61019.3 \"Swooping Frenzy\" Ability { id: \"517E\", source: \"Dawon\" }\r\n61022.1 \"Frigid/Fervid Pulse\" Ability { id: \"51(7F|80)\", source: \"Dawon\" }\r\n61024.5 \"Swooping Frenzy\" Ability { id: \"517E\", source: \"Dawon\" }\r\n61027.3 \"Frigid/Fervid Pulse\" Ability { id: \"51(7F|80)\", source: \"Dawon\" }\r\n61029.7 \"Swooping Frenzy\" Ability { id: \"517E\", source: \"Dawon\" }\r\n61032.5 \"Frigid/Fervid Pulse\" Ability { id: \"51(7F|80)\", source: \"Dawon\" }\r\n\r\n61042.9 \"Call Beast\" Ability { id: \"5192\", source: \"Lyon The Beast King\" }\r\n61048.9 \"Molting Plumage\" Ability { id: \"517A\", source: \"Dawon\" }\r\n61060.5 \"Explosion\" Ability { id: \"5182\", source: \"Verdant Plume\" }\r\n\r\n61070.0 \"Swooping Frenzy\" Ability { id: \"5175\", source: \"Dawon\" }\r\n61075.8 \"Pentagust\" Ability { id: \"5176\", source: \"Dawon\" }\r\n61087.5 \"Scratch\" Ability { id: \"517B\", source: \"Dawon\" }\r\n\r\n# Loop!\r\n61100.7 \"Ready x4\" duration 6.1 #Ability { id: \"5191\", source: \"Lyon The Beast King\" }\r\n61110.7 \"Obey\" Ability { id: \"517D\", source: \"Dawon\" } window 90,90 jump 61012\r\n61112.8 \"Swooping Frenzy\"\r\n61115.6 \"Frigid/Fervid Pulse\"\r\n61118.0 \"Swooping Frenzy\"\r\n61120.8 \"Frigid/Fervid Pulse\"\r\n61123.2 \"Swooping Frenzy\"\r\n61126.0 \"Frigid/Fervid Pulse\"\r\n61128.4 \"Swooping Frenzy\"\r\n61131.2 \"Frigid/Fervid Pulse\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/eureka/delubrum_reginae.ts





// TODO: warnings for mines after bosses?

const seekerCenterX = -0.01531982;
const seekerCenterY = 277.9735;
const avowedCenterX = -272;
const avowedCenterY = -82;

// TODO: promote something like this to Conditions?
const delubrum_reginae_tankBusterOnParty = (data, matches) => {
  if (matches.target === data.me) return true;
  if (data.role !== 'healer') return false;
  return data.party.inParty(matches.target);
};
const delubrum_reginae_triggerSet = {
  id: 'DelubrumReginae',
  zoneId: zone_id/* default.DelubrumReginae */.Z.DelubrumReginae,
  timelineFile: 'delubrum_reginae.txt',
  triggers: [
  // *** Trinity Seeker ***
  {
    id: 'Delubrum Seeker Verdant Tempest',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Seeker',
      id: '5AB6',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Delubrum Seeker Sword Cleanup',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Seeker',
      id: '5B5D',
      capture: false
    },
    run: data => {
      delete data.calledSeekerSwords;
      delete data.seekerSwords;
    }
  }, {
    id: 'Delubrum Seeker Mercy Swords',
    type: 'GainsEffect',
    netRegex: {
      target: ['Trinity Seeker', 'Seeker Avatar'],
      effectId: '808'
    },
    durationSeconds: 10,
    alertText: (data, matches, output) => {
      if (data.calledSeekerSwords) return;
      data.seekerSwords ??= [];
      data.seekerSwords.push(matches.count.toUpperCase());
      if (data.seekerSwords.length <= 1) return;
      const cleaves = data.seekerSwords;

      // Seen two cleaves, is this enough information to call??
      // If no, we will wait until we have seen the third.
      if (data.seekerSwords.length === 2) {
        // Named constants for readability.
        const dir = {
          north: 0,
          east: 1,
          south: 2,
          west: 3
        };

        // Find boss-relative safe zones.
        const cleavetoSafeZones = {
          // Front right cleave.
          F7: [dir.south, dir.west],
          // Back right cleave.
          F8: [dir.west, dir.north],
          // Front left cleave.
          F9: [dir.east, dir.south],
          // Back left cleave.
          FA: [dir.north, dir.east]
        };
        const cleave0 = cleaves[0];
        const cleave1 = cleaves[1];
        if (cleave0 === undefined || cleave1 === undefined) throw new not_reached/* UnreachableCode */.$();
        const first = cleavetoSafeZones[cleave0];
        const second = cleavetoSafeZones[cleave1];
        if (first === undefined || second === undefined) throw new not_reached/* UnreachableCode */.$();
        const intersect = first.filter(safe => second.includes(safe));
        if (intersect.length === 2) {
          console.error(`Sword: weird intersect: ${JSON.stringify(data.seekerSwords)}`);
          return;
        }
        // This is a bad pattern.  Need to wait for three swords.
        if (intersect.length === 0) return;
        data.calledSeekerSwords = true;
        const cardinal = intersect[0];
        if (cardinal === dir.north) return output.double({
          dir1: output.north(),
          dir2: output.south()
        });
        if (cardinal === dir.east) return output.double({
          dir1: output.east(),
          dir2: output.west()
        });
        if (cardinal === dir.south) return output.double({
          dir1: output.south(),
          dir2: output.north()
        });
        if (cardinal === dir.west) return output.double({
          dir1: output.west(),
          dir2: output.east()
        });
        // Or not?
        data.calledSeekerSwords = false;
        return;
      }
      const cleaveToDirection = {
        // Front right cleave.
        F7: output.west(),
        // Back right cleave.
        F8: output.west(),
        // Front left cleave.
        F9: output.east(),
        // Back left cleave.
        FA: output.east()
      };

      // Seen three clones, which means we weren't able to call with two.
      // Try to call out something the best we can.
      // Find the cleave we're missing and add it to the list.
      const allCleaveKeys = Object.keys(cleaveToDirection);
      const finalCleaveList = allCleaveKeys.filter(id => !cleaves.includes(id));
      const finalCleave = finalCleaveList[0];
      if (finalCleave === undefined || finalCleaveList.length !== 1) {
        console.error(`Swords: bad intersection ${JSON.stringify(data.seekerSwords)}`);
        return;
      }
      cleaves.push(finalCleave);
      data.calledSeekerSwords = true;
      const dirs = cleaves.map(id => cleaveToDirection[id]);
      return output.quadruple({
        dir1: dirs[0],
        dir2: dirs[1],
        dir3: dirs[2],
        dir4: dirs[3]
      });
    },
    // Unlike savage mode, Trinity Seeker can be pretty much anywhere.
    // So, turn "absolute cardinal directions" into boss-relative strings.
    // The above function uses cardinal directions to be closer to the DRS code.
    outputStrings: {
      north: {
        en: 'Front',
        de: 'Vorne',
        fr: 'Devant',
        ja: '前',
        cn: '上',
        ko: '앞'
      },
      east: {
        en: 'Right',
        de: 'Rechts',
        fr: 'À droite',
        ja: '右',
        cn: '右',
        ko: '오른쪽'
      },
      south: {
        en: 'Back',
        de: 'Hinten',
        fr: 'Derrière',
        ja: '後ろ',
        cn: '下',
        ko: '뒤'
      },
      west: {
        en: 'Left',
        de: 'Links',
        fr: 'À gauche',
        ja: '左',
        cn: '左',
        ko: '왼쪽'
      },
      double: {
        en: '${dir1} > ${dir2}',
        de: '${dir1} > ${dir2}',
        fr: '${dir1} > ${dir2}',
        ja: '${dir1} > ${dir2}',
        cn: '${dir1} > ${dir2}',
        ko: '${dir1} > ${dir2}'
      },
      quadruple: {
        en: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        de: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        fr: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        ja: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        cn: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        ko: '${dir1} > ${dir2} > ${dir3} > ${dir4}'
      }
    }
  }, {
    id: 'Delubrum Seeker Baleful Swath',
    type: 'StartsUsing',
    // This is an early warning for casters for Baleful Swath on the Verdant Path cast.
    netRegex: {
      source: 'Trinity Seeker',
      id: '5A98',
      capture: false
    },
    response: responses/* Responses.goFrontBack */.n3.goFrontBack('info')
  }, {
    id: 'Delubrum Seeker Baleful Blade Out',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Seeker',
      id: '5AA1',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Out Behind Barricade',
        de: 'Geh raus, hinter die Barrikaden',
        fr: 'À l\'extérieur, derrière la barricade',
        ja: '柵の後ろに',
        cn: '栅栏后躲避',
        ko: '울타리 뒤에 숨기'
      }
    }
  }, {
    id: 'Delubrum Seeker Baleful Blade Knockback',
    type: 'StartsUsing',
    // We could call this on Phantom Edge 5AA0, but maybe that's too early?
    netRegex: {
      source: 'Trinity Seeker',
      id: '5AA2',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Knocked Into Barricade',
        de: 'Rückstoß in die Barrikaden',
        fr: 'Faites-vous pousser contre la barricade',
        ja: '柵に吹き飛ばされる',
        cn: '击退到栅栏上',
        ko: '울타리로 넉백당하기'
      }
    }
  }, {
    // There is no castbar for 5AB7, only this headmarker.
    id: 'Delubrum Seeker Merciful Arc',
    type: 'HeadMarker',
    netRegex: {
      id: '00F3'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Delubrum Seeker Iron Impact',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Seeker',
      id: '5ADB',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Stack',
        de: 'In einer Linie sammeln',
        fr: 'Package en ligne',
        ja: '直線頭割り',
        cn: '直线分摊',
        ko: '직선 쉐어'
      }
    }
  }, {
    id: 'Delubrum Seeker Iron Splitter',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Seeker',
      id: '5AA3'
    },
    promise: async (data, matches) => {
      const seekerData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.sourceId, 16)]
      });
      if (seekerData === null) {
        console.error(`Iron Splitter: null data`);
        return;
      }
      if (seekerData.combatants.length !== 1) {
        console.error(`Iron Splitter: expected 1, got ${seekerData.combatants.length}`);
        return;
      }
      const seeker = seekerData.combatants[0];
      if (!seeker) throw new not_reached/* UnreachableCode */.$();
      const x = seeker.PosX - seekerCenterX;
      const y = seeker.PosY - seekerCenterY;
      data.splitterDist = Math.hypot(x, y);
    },
    alertText: (data, _matches, output) => {
      if (data.splitterDist === undefined) return;

      // All 100 examples I've looked at only hit distance=10, or distance=~14
      // Guessing at the other distances, if they exist.
      //
      // blue inner = 0?
      // white inner = 6?
      // blue middle = 10
      // white middle = 14
      // blue outer = 18?
      // white outer = 22?

      const isWhite = Math.floor(data.splitterDist / 4) % 2;
      return isWhite ? output.goBlue() : output.goWhite();
    },
    outputStrings: {
      goBlue: {
        en: 'Blue Stone',
        de: 'Blauer Stein',
        fr: 'Pierre bleue',
        ja: '青い床へ',
        cn: '去蓝色',
        ko: '파랑 장판으로'
      },
      goWhite: {
        en: 'White Sand',
        de: 'Weißer Sand',
        fr: 'Sable blanc',
        ja: '白い床へ',
        cn: '去白色',
        ko: '모래 장판으로'
      }
    }
  }, {
    id: 'Delubrum Seeker Burning Chains',
    type: 'HeadMarker',
    netRegex: {
      id: '00EE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Chain on YOU',
        de: 'Kette auf DIR',
        fr: 'Chaîne sur VOUS',
        ja: '自分に鎖',
        cn: '锁链点名',
        ko: '사슬 대상자'
      }
    }
  }, {
    // TODO: the FFXIV parser plugin does not include this as a "gains effect" line.
    id: 'Delubrum Seeker Burning Chains Move',
    type: 'HeadMarker',
    netRegex: {
      id: '00EE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 4,
    response: responses/* Responses.breakChains */.n3.breakChains()
  }, {
    id: 'Delubrum Seeker Dead Iron',
    type: 'HeadMarker',
    netRegex: {
      id: '00ED'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.earthshaker */.n3.earthshaker()
  }, {
    id: 'Delubrum Seeker Merciful Moon',
    type: 'StartsUsing',
    // 3 second warning to match savage timings.
    netRegex: {
      source: 'Aetherial Orb',
      id: '5AAC',
      capture: false
    },
    delaySeconds: 1,
    alertText: (_data, _matches, output) => output.lookAway(),
    outputStrings: {
      lookAway: {
        en: 'Look Away From Orb',
        de: 'Schau weg vom Orb',
        fr: 'Ne regardez pas l\'orbe',
        ja: '玉に背を向ける',
        cn: '背对白球',
        ko: '구슬에게서 뒤돌기'
      }
    }
  }, {
    id: 'Delubrum Seeker Merciful Blooms',
    type: 'Ability',
    // Call this on the ability of Merciful Moon, it starts casting much earlier.
    netRegex: {
      source: 'Aetherial Orb',
      id: '5AAC',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.awayFromPurple(),
    outputStrings: {
      awayFromPurple: {
        en: 'Away From Purple',
        de: 'Schau weg von Lila',
        fr: 'Éloignez-vous du violet',
        ja: '花に避ける',
        cn: '远离紫花',
        ko: '꽃 장판에서 멀리 떨어지기'
      }
    }
  },
  // *** Dahu ***
  {
    id: 'Delubrum Dahu Shockwave',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dahu',
      id: ['5760', '5761', '5762', '5763']
    },
    // There's a 3s slow windup on the first, then a 1s opposite cast.
    suppressSeconds: 10,
    alertText: (_data, matches, output) => {
      if (matches.id === '5761' || matches.id === '5763') return output.leftThenRight();
      return output.rightThenLeft();
    },
    outputStrings: {
      leftThenRight: {
        en: 'Left, Then Right',
        de: 'Links, dann Rechts',
        fr: 'À gauche, puis à droite',
        ja: '左 => 右',
        cn: '左 => 右',
        ko: '왼쪽 => 오른쪽'
      },
      rightThenLeft: {
        en: 'Right, Then Left',
        de: 'Rechts, dann Links',
        fr: 'À droite, puis à gauche',
        ja: '右 => 左',
        cn: '右 => 左',
        ko: '오른쪽 => 왼쪽'
      }
    }
  }, {
    // TODO: is this true if you see a Feral Howl #4 and onward?
    id: 'Delubrum Dahu Feral Howl',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dahu',
      id: '5755',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.seenFeralHowl) return output.knockbackAvoid();
      return output.knockback();
    },
    run: data => data.seenFeralHowl = true,
    outputStrings: {
      knockback: {
        en: 'Unavoidable Knockback',
        de: 'Unvermeidbarer Rückstoß',
        fr: 'Poussée inévitable',
        ja: '避けないノックバック',
        cn: '击退 (防击退无效)',
        ko: '넉백 방지 불가'
      },
      knockbackAvoid: {
        // This is also unavoidable, but that's really wordy and hopefully
        // you figured that out the first time.
        en: 'Knockback (Avoid Adds)',
        de: 'Rückstoß (vermeide die Adds)',
        fr: 'Poussée (Évitez les adds)',
        ja: 'ノックバック (雑魚に触らない)',
        cn: '击退 (避开小怪)',
        ko: '넉백 (쫄 피하기)'
      }
    }
  }, {
    id: 'Delubrum Dahu Hot Charge',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dahu',
      id: '5764',
      capture: false
    },
    // This happens twice in a row
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Follow Second Charge',
        de: 'Folge dem 2. Ansturm',
        fr: 'Suivez la deuxième charge',
        ja: '2回目の突進に追う',
        cn: '紧跟第二次冲锋',
        ko: '두번째 돌진 따라가기'
      }
    }
  }, {
    id: 'Delubrum Dahu Heat Breath',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dahu',
      id: '5766'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Delubrum Dahu Ripper Claw',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dahu',
      id: '575D',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  },
  // *** Queen's Guard ***
  {
    id: 'Delubrum Guard Secrets Revealed',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Soldier',
      id: '5B6E',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.seenSecretsRevealed) return output.followUntethered();
      return output.awayFromTethered();
    },
    run: data => data.seenSecretsRevealed = true,
    outputStrings: {
      awayFromTethered: {
        en: 'Away from tethered adds',
        de: 'Weg von den verbundenen Adds',
        fr: 'Éloignez-vous des adds liés',
        ja: '線に繋がる雑魚から離れる',
        cn: '远离连线小怪',
        ko: '선 연결된 쫄에서 떨어지기'
      },
      followUntethered: {
        en: 'Follow untethered adds',
        de: 'Folge den nicht verbundenen Adds',
        fr: 'Suivez les adds non liés',
        ja: '線に繋がらない雑魚から離れる',
        cn: '靠近无连线小怪',
        ko: '선 연결되지 않은 쫄 따라가기'
      }
    }
  }, {
    id: 'Delubrum Guard Rapid Sever Soldier',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Soldier',
      id: '5809'
    },
    condition: delubrum_reginae_tankBusterOnParty,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Delubrum Guard Blood And Bone Soldier',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Soldier',
      id: '5808',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Delubrum Guard Shot In The Dark',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Gunner',
      id: '5811'
    },
    condition: delubrum_reginae_tankBusterOnParty,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Delubrum Guard Automatic Turret',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Gunner',
      id: '580B',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Laser Bounces',
        de: 'Weiche den abgelenken Lasern aus',
        fr: 'Évitez les rebonds de laser',
        ja: 'レーザーを避ける',
        cn: '躲避激光',
        ko: '레이저 피하기'
      }
    }
  }, {
    id: 'Delubrum Guard Queen\'s Shot',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Gunner',
      id: '5810',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Delubrum Guard Reversal Of Forces',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Warrior',
      id: '57FF',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.reversalOfForces = true,
    outputStrings: {
      text: {
        en: 'Stand On Small Bomb',
        de: 'Auf kleinen Bomben stehen',
        fr: 'Placez-vous sur une petite bombe',
        ja: '小さい爆弾を踏む',
        cn: '站在小炸弹上',
        ko: '작은 폭탄 위에 서기'
      }
    }
  }, {
    id: 'Delubrum Guard Above Board',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Warrior',
      id: '57FC',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.reversalOfForces) return;
      return output.text();
    },
    run: data => delete data.reversalOfForces,
    outputStrings: {
      text: {
        en: 'Stand On Large Bomb',
        de: 'Auf großen Bomben stehen',
        fr: 'Placez-vous sur une grosse bombe',
        ja: '大きい爆弾を踏む',
        cn: '站在大炸弹上',
        ko: '큰 폭탄 위에 서기'
      }
    }
  }, {
    id: 'Delubrum Guard Blood And Bone Warrior',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Warrior',
      id: '5800',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Delubrum Guard Shield Omen',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Knight',
      id: '57F1',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Delubrum Guard Sword Omen',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Knight',
      id: '57F0',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Delubrum Guard Rapid Sever Knight',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Knight',
      id: '57FB'
    },
    condition: delubrum_reginae_tankBusterOnParty,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Delubrum Guard Blood And Bone Knight',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Knight',
      id: '57FA',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  },
  // *** Bozjan Phantom
  {
    id: 'Delubrum Phantom Weave Miasma',
    type: 'StartsUsing',
    netRegex: {
      source: 'Bozjan Phantom',
      id: '57A3',
      capture: false
    },
    preRun: data => data.weaveMiasmaCount = (data.weaveMiasmaCount || 0) + 1,
    delaySeconds: 3,
    infoText: (data, _matches, output) => {
      if (data.weaveMiasmaCount && data.weaveMiasmaCount >= 3) return output.weaveWithKnockback();
      return output.weaveNoKnockback();
    },
    outputStrings: {
      weaveNoKnockback: {
        en: 'Go To North Circle',
        de: 'Geh zum Kreis im Norden',
        fr: 'Allez au cercle Nord',
        ja: '北のドーナツ範囲に入る',
        cn: '去上面(北面)月环',
        ko: '북쪽 원으로 이동'
      },
      weaveWithKnockback: {
        en: 'Get Knocked Back To Circle',
        de: 'Lass dich zum Kreis im Norden zurückstoßen',
        fr: 'Faites-vous pousser dans le cercle',
        ja: '北のドーナツ範囲へ吹き飛ばされる',
        cn: '击退到上面(北面)月环中',
        ko: '원으로 넉백 당하기'
      }
    }
  }, {
    id: 'Delubrum Phantom Malediction Of Agony',
    type: 'StartsUsing',
    netRegex: {
      source: 'Bozjan Phantom',
      id: '57AF',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Delubrum Phantom Undying Hatred',
    type: 'StartsUsing',
    // "57AB Summon" is used here to avoid an additional name to translate.
    // "57AC Undying Hatred" is from Stuffy Wraith.
    netRegex: {
      source: 'Bozjan Phantom',
      id: '57AB',
      capture: false
    },
    delaySeconds: 5,
    // This is covered by Weave Miasma after the first "learn how this works" action.
    suppressSeconds: 9999,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Unavoidable Knockback',
        de: 'Unvermeidbarer Rückstoß',
        fr: 'Poussée inévitable',
        ja: '避けないノックバック',
        cn: '击退 (防击退无效)',
        ko: '넉백 방지 불가'
      }
    }
  }, {
    id: 'Delubrum Phantom Excruciation',
    type: 'StartsUsing',
    netRegex: {
      source: 'Bozjan Phantom',
      id: '5809'
    },
    condition: delubrum_reginae_tankBusterOnParty,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  },
  // *** Trinity Avowed
  {
    id: 'Delubrum Avowed Wrath Of Bozja',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Avowed',
      id: '5975'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave('alert')
  }, {
    id: 'Delubrum Avowed Glory Of Bozja',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Avowed',
      id: '5976',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Delubrum Avowed Hot And Cold',
    type: 'GainsEffect',
    // 89D: Running Hot: +1
    // 8A4: Running Hot: +2
    // 8DC: Running Cold: -1
    // 8E2: Running Cold: -2
    netRegex: {
      effectId: ['89D', '8A4', '8DC', '8E2']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      const tempMap = {
        '89D': 1,
        '8A4': 2,
        '8DC': -1,
        '8E2': -2
      };
      data.avowedTemperature = tempMap[matches.effectId.toUpperCase()];
    }
  }, {
    id: 'Delubrum Avowed Freedom Of Bozja',
    type: 'StartsUsing',
    // Arguably, the Elemental Impact (meteor falling) has different ids depending on orb type,
    // e.g. 5960, 5962, 4F55, 4556, 4F99, 4F9A.
    // So we could give directions here, but probably that's just more confusing.
    netRegex: {
      source: 'Trinity Avowed',
      id: '597C',
      capture: false
    },
    delaySeconds: 10,
    alertText: (data, _matches, output) => {
      switch (data.avowedTemperature) {
        case 2:
          return output.minusTwo();
        case 1:
          return output.minusOne();
        case -1:
          return output.plusOne();
        case -2:
          return output.plusTwo();
        default:
          return output.unknownTemperature();
      }
    },
    outputStrings: {
      plusTwo: {
        en: 'Go to +2 Heat Meteor',
        de: 'Geh zum +2 Heiß Meteor',
        fr: 'Allez au météore de chaleur +2',
        ja: '炎属性+2を踏む',
        cn: '踩火+2',
        ko: '+2 불 운석쪽으로'
      },
      plusOne: {
        en: 'Go to +1 Heat Meteor',
        de: 'Geh zum +1 Heiß Meteor',
        fr: 'Allez au météore de chaleur +1',
        ja: '炎属性+1を踏む',
        cn: '踩火+1',
        ko: '+1 불 운석쪽으로'
      },
      minusOne: {
        en: 'Go to -1 Cold Meteor',
        de: 'Geh zum -1 Kalt Meteor',
        fr: 'Allez au météore de froid -1',
        ja: '氷属性-1を踏む',
        cn: '踩冰-1',
        ko: '-1 얼음 운석쪽으로'
      },
      minusTwo: {
        en: 'Go to -2 Cold Meteor',
        de: 'Geh zum -2 Kalt Meteor',
        fr: 'Allez au météore de froid -2',
        ja: '氷属性-2を踏む',
        cn: '踩冰-2',
        ko: '-2 얼음 운석쪽으로'
      },
      unknownTemperature: {
        en: 'Stand In Opposite Meteor',
        de: 'Steh im entgegengesetztem Meteor',
        fr: 'Placez-vous au météore de l\'élément opposé',
        ja: '体温と逆のメテオを受ける',
        cn: '接相反温度的陨石',
        ko: '반대속성 운석에 서기'
      }
    }
  }, {
    id: 'Delubrum Avowed Shimmering Shot',
    type: 'StartsUsing',
    // See comments on Freedom Of Bozja above.
    netRegex: {
      source: 'Trinity Avowed',
      id: '597F',
      capture: false
    },
    delaySeconds: 3,
    alertText: (data, _matches, output) => {
      switch (data.avowedTemperature) {
        case 2:
          return output.minusTwo();
        case 1:
          return output.minusOne();
        case -1:
          return output.plusOne();
        case -2:
          return output.plusTwo();
        default:
          return output.unknownTemperature();
      }
    },
    outputStrings: {
      plusTwo: {
        en: 'Follow +2 Heat Arrow',
        de: 'Folge dem +2 Heiß Pfeilen',
        fr: 'Suivez la flèche de chaleur +2',
        ja: '炎属性+2に従う',
        cn: '接火+2',
        ko: '+2 불 화살쪽으로'
      },
      plusOne: {
        en: 'Follow +1 Heat Arrow',
        de: 'Folge dem +1 Heiß Pfeilen',
        fr: 'Suivez la flèche de chaleur +1',
        ja: '炎属性+1に従う',
        cn: '接火+1',
        ko: '+1 불 화살쪽으로'
      },
      minusOne: {
        en: 'Follow -1 Cold Arrow',
        de: 'Folge dem -1 Kalt Pfeilen',
        fr: 'Suivez la flèche de froid -1',
        ja: '氷属性-1に従う',
        cn: '接冰-1',
        ko: '-1 얼음 화살쪽으로'
      },
      minusTwo: {
        en: 'Follow -2 Cold Arrow',
        de: 'Folge dem -2 Kalt Pfeilen',
        fr: 'Suivez la flèche de froid -2',
        ja: '氷属性-2に従う',
        cn: '接冰-2',
        ko: '-2 얼음 화살쪽으로'
      },
      unknownTemperature: {
        en: 'Follow Opposite Arrow',
        de: 'Gehe in die entgegengesetzten Pfeile',
        fr: 'Suivez la flèche de l\'élément opposé',
        ja: '体温と逆のあみだに従う',
        cn: '接相反温度的线',
        ko: '반대속성 화살 맞기'
      }
    }
  }, {
    // 5B65 = right cleave, heat+2
    // 5B66 = right cleave, cold+2
    // 5B67 = left cleave, heat+2
    // 5B68 = left cleave, cold+2
    // 596D = right cleave, heat+1
    // 596E = right cleave, cold+1
    // 596F = left cleave, heat+1
    // 5970 = left cleave, cold+1
    id: 'Delubrum Avowed Hot And Cold Cleaves',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Avowed',
      id: ['5B6[5-8]', '596[DEF]', '5970']
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        left: {
          en: 'Left',
          de: 'Links',
          fr: 'À gauche',
          ja: '左',
          cn: '左',
          ko: '왼쪽'
        },
        right: {
          en: 'Right',
          de: 'Rechts',
          fr: 'À droite',
          ja: '右',
          cn: '右',
          ko: '오른쪽'
        },
        plusTwo: {
          en: 'Be in ${side} Cleave (+2 Hot)',
          de: 'Sei im ${side} Cleave (+2 Heiß)',
          fr: 'Placez-vous ${side} du Cleave (+2 chaud)',
          ja: '${side}側へ (炎属性+2)',
          cn: '去${side}侧 (火+2)',
          ko: '${side} 광역기 맞기 (+2 불속성)'
        },
        plusOne: {
          en: 'Be in ${side} Cleave (+1 Hot)',
          de: 'Sei im ${side} Cleave (+1 Heiß)',
          fr: 'Placez-vous ${side} du Cleave (+1 chaud)',
          ja: '${side}側へ (炎属性+1)',
          cn: '去${side}侧 (火+1)',
          ko: '${side} 광역기 맞기 (+1 불속성)'
        },
        minusOne: {
          en: 'Be in ${side} Cleave (-1 Cold)',
          de: 'Sei im ${side} Cleave (-1 Kalt)',
          fr: 'Placez-vous ${side} du Cleave (-1 froid)',
          ja: '${side}側へ (氷属性-1)',
          cn: '去${side}侧 (冰-1)',
          ko: '${side} 광역기 맞기 (-1 얼음속성)'
        },
        minusTwo: {
          en: 'Be in ${side} Cleave (-2 Cold)',
          de: 'Sei im ${side} Cleave (-2 Kalt)',
          fr: 'Placez-vous ${side} du Cleave (-2 froid)',
          ja: '${side}側へ (氷属性-2)',
          cn: '去${side}侧 (冰-2)',
          ko: '${side} 광역기 맞기 (-2 얼음속성)'
        },
        avoid: {
          en: 'Go ${side} (avoid!)',
          de: 'Gehe nach ${side} (ausweichen!)',
          fr: 'Allez ${side} (évitez !)',
          ja: '${side}側へ (避ける！)',
          cn: '去${side}侧 (别吃顺劈！)',
          ko: '${side}으로 피하기!'
        }
      };
      const isLeft = ['5B67', '5B68', '596F', '5970'].includes(matches.id);
      const side = isLeft ? output.left() : output.right();
      const safeSide = isLeft ? output.right() : output.left();
      const avoidInfoText = {
        infoText: output.avoid({
          side: safeSide
        })
      };
      switch (matches.id) {
        case '5B66':
        case '5B68':
          if (data.avowedTemperature === 2) return {
            alertText: output.minusTwo({
              side: side
            })
          };
          return avoidInfoText;
        case '596E':
        case '5970':
          if (data.avowedTemperature === 1) return {
            alertText: output.minusOne({
              side: side
            })
          };
          return avoidInfoText;
        case '596D':
        case '596F':
          if (data.avowedTemperature === -1) return {
            alertText: output.plusOne({
              side: side
            })
          };
          return avoidInfoText;
        case '5B65':
        case '5B67':
          if (data.avowedTemperature === -2) return {
            alertText: output.plusTwo({
              side: side
            })
          };
          return avoidInfoText;
      }
    }
  }, {
    id: 'Delubrum Avowed Gleaming Arrow Collect',
    type: 'StartsUsing',
    netRegex: {
      source: 'Avowed Avatar',
      id: '5974'
    },
    run: (data, matches) => {
      data.unseenIds ??= [];
      data.unseenIds.push(parseInt(matches.sourceId, 16));
    }
  }, {
    id: 'Delubrum Avowed Gleaming Arrow',
    type: 'StartsUsing',
    netRegex: {
      source: 'Avowed Avatar',
      id: '5974',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 10,
    promise: async data => {
      const unseenIds = data.unseenIds;
      if (!unseenIds) return;
      const unseenData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: unseenIds
      });
      if (unseenData === null) {
        console.error(`Gleaming Arrow: null data`);
        return;
      }
      if (unseenData.combatants.length !== unseenIds.length) {
        console.error(`Gleaming Arrow: expected ${unseenIds.length}, got ${unseenData.combatants.length}`);
        return;
      }
      data.unseenBadRows = [];
      data.unseenBadCols = [];
      for (const avatar of unseenData.combatants) {
        const x = avatar.PosX - avowedCenterX;
        const y = avatar.PosY - avowedCenterY;

        // y=-107 = north side, x = -252, -262, -272, -282, -292
        // x=-247 = left side, y = -62, -72, -82, -92, -102
        // Thus, the possible deltas are -20, -10, 0, +10, +20.
        // The other coordinate is +/-25 from center.
        const maxDist = 22;
        if (Math.abs(x) < maxDist) {
          const col = Math.round((x + 20) / 10);
          data.unseenBadCols.push(col);
        }
        if (Math.abs(y) < maxDist) {
          const row = Math.round((y + 20) / 10);
          data.unseenBadRows.push(row);
        }
      }
      data.unseenBadRows.sort();
      data.unseenBadCols.sort();
    },
    alertText: (data, _matches, output) => {
      delete data.unseenIds;
      if (!data.unseenBadRows || !data.unseenBadCols) return;

      // consider asserting that badCols are 0, 2, 4 here.
      if (data.unseenBadRows.includes(2)) return output.bowLight();
      return output.bowDark();
    },
    outputStrings: {
      bowDark: {
        en: 'On Dark (E/W of center)',
        de: 'Auf Dunkel (O/W von der Mitte)',
        fr: 'Sur une foncée (E/O du centre)',
        ja: '闇へ (東西)',
        cn: '去黑色 (东西/左右)',
        ko: '어두운 타일 (맵 중앙의 왼/오른쪽)'
      },
      bowLight: {
        en: 'On Light (diagonal from center)',
        de: 'Auf Licht (Diagonal von der Mitte)',
        fr: 'Sur une claire (diagonale du centre)',
        ja: '光へ (斜め)',
        cn: '去白色 (对角)',
        ko: '밝은 타일 (맵 중앙의 대각선)'
      }
    }
  }, {
    id: 'Delubrum Avowed Fury Of Bozja',
    type: 'StartsUsing',
    // Allegiant Arsenal 5987 = staff (out), followed up with Fury of Bozja 5973
    netRegex: {
      source: 'Trinity Avowed',
      id: '5987',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Delubrum Avowed Flashvane',
    type: 'StartsUsing',
    // Allegiant Arsenal 5986 = bow (get behind), followed up by Flashvane 5972
    netRegex: {
      source: 'Trinity Avowed',
      id: '5986',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Delubrum Avowed Infernal Slash',
    type: 'StartsUsing',
    // Allegiant Arsenal 5985 = sword (get front), followed up by Infernal Slash 5971
    netRegex: {
      source: 'Trinity Avowed',
      id: '5985',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get In Front',
        de: 'Geh vor den Boss',
        fr: 'Passez devant',
        ja: 'ボスの正面へ',
        cn: '去正面',
        ko: '정면에 서기'
      }
    }
  },
  // *** The Queen
  {
    id: 'Delubrum Queen Empyrean Iniquity',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Queen',
      id: '59C8',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Delubrum Queen Cleansing Slash',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Queen',
      id: '59C5'
    },
    condition: delubrum_reginae_tankBusterOnParty,
    // Probably this is where you swap, but maybe that's not something you can
    // count on in an alliance raid, where there might not even be another tank.
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Delubrum Queen Cleansing Slash Bleed',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Queen',
      id: '59C5'
    },
    condition: data => data.CanCleanse(),
    delaySeconds: 5,
    infoText: (data, matches, output) => {
      return output.text({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Esuna ${player}',
        de: 'Medica ${player}',
        fr: 'Guérison sur ${player}',
        ja: 'エスナ: ${player}',
        cn: '解除死亡宣告: ${player}',
        ko: '${player} 에스나'
      }
    }
  }, {
    id: 'Delubrum Queen Northswain\'s Glow',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Queen',
      id: '59C3',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    // Technically, this is "away from where the moving lines intersect each other"
    // but "away from orbs" also will do the trick here.
    outputStrings: {
      text: {
        en: 'Away from Line Intersections',
        de: 'Geh weg von den Linienkreuzungen',
        fr: 'Éloignez-vous des intersections de ligne',
        ja: '十字から離れる',
        cn: '远离线的交点',
        ko: '선이 만나는 지점에서 떨어지기'
      }
    }
  }, {
    id: 'Delubrum Queen Automatic Turret',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Gunner',
      id: '59DE',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Laser Bounces',
        de: 'Weiche den abgelenken Lasern aus',
        fr: 'Évitez les rebonds de laser',
        ja: 'レーザーを避ける',
        cn: '躲避激光',
        ko: '레이저 피하기'
      }
    }
  }, {
    id: 'Delubrum Queen Reversal Of Forces',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Warrior',
      id: '59D4',
      capture: false
    },
    run: data => data.reversalOfForces = true
  }, {
    // Called during the knockback cast itself, not during the 59C6 Heaven's Wrath
    // where the knockback line appears.  This is mostly because we don't know about
    // reversal at that point.
    id: 'Delubrum Queen Heaven\'s Wrath',
    type: 'StartsUsing',
    // This is used sometimes by The Queen and sometimes by The Queen's Gunner (?!).
    // This could just be stale parser data though, as the name changes for the actual usage.
    netRegex: {
      id: '59C7',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (!data.seenHeavensWrath) return output.getKnockedTowardsMiddle();
      if (data.reversalOfForces) return output.getKnockedToSmallBomb();
      return output.getKnockedToLargeBomb();
    },
    run: data => {
      data.seenHeavensWrath = true;
      delete data.reversalOfForces;
    },
    outputStrings: {
      getKnockedTowardsMiddle: {
        en: 'Get Knocked Towards Middle',
        de: 'Zur Mitte zurückstoßen lassen',
        fr: 'Faites-vous pousser vers le milieu',
        ja: '中へ吹き飛ばされる',
        cn: '击退到中间',
        ko: '중앙에서 넉백 당하기'
      },
      getKnockedToSmallBomb: {
        en: 'Get Knocked To Small Bomb',
        de: 'Zu kleinen Bomben zurückstoßen lassen',
        fr: 'Faites-vous pousser sur une petite bombe',
        ja: '小さい爆弾へ吹き飛ばされる',
        cn: '击退到小炸弹',
        ko: '작은 폭탄으로 넉백당하기'
      },
      getKnockedToLargeBomb: {
        en: 'Get Knocked To Large Bomb',
        de: 'Zu großen Bomben zurückstoßen lassen',
        fr: 'Faites-vous pousser sur une grosse bombe',
        ja: '大きい爆弾へ吹き飛ばされる',
        cn: '击退到大炸弹',
        ko: '큰 폭탄으로 넉백당하기'
      }
    }
  }, {
    id: 'Delubrum Queen Judgment Blade Right',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Queen',
      id: '59C2',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Find Charge, Dodge Right',
        de: 'Halte nach dem Ansturm ausschau, weiche nach rechts aus',
        fr: 'Repérez la charge, esquivez à droite',
        ja: '右へ、突進を避ける',
        cn: '去右侧躲避冲锋',
        ko: '돌진 찾고, 오른쪽 피하기'
      }
    }
  }, {
    id: 'Delubrum Queen Judgment Blade Left',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Queen',
      id: '59C1',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Find Charge, Dodge Left',
        de: 'Halte nach dem Ansturm ausschau, weiche nach links aus',
        fr: 'Repérez la charge, esquivez à gauche',
        ja: '左へ、突進を避ける',
        cn: '去左侧躲避冲锋',
        ko: '돌진 찾고, 왼쪽 피하기'
      }
    }
  }, {
    id: 'Delubrum Queen Gods Save The Queen',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Queen',
      id: '59C9',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Delubrum Queen Secrets Revealed',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Soldier',
      id: '5B8A',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from tethered adds',
        de: 'Weg von verbundenen Adds',
        fr: 'Éloignez-vous des adds liés',
        ja: '線に繋がる雑魚から離れる',
        cn: '远离连线小怪',
        ko: '선 연결된 쫄 피하기'
      }
    }
  }, {
    id: 'Delubrum Queen Shield Omen',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Knight',
      id: '59CB',
      capture: false
    },
    delaySeconds: 2.5,
    response: responses/* Responses.getUnder */.n3.getUnder('alarm')
  }, {
    id: 'Delubrum Queen Sword Omen',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Knight',
      id: '59CA',
      capture: false
    },
    delaySeconds: 2.5,
    response: responses/* Responses.getOut */.n3.getOut()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Right-Sided Shockwave/Left-Sided Shockwave': 'Right/Left Shockwave',
      'Left-Sided Shockwave/Right-Sided Shockwave': 'Left/Right Shockwave',
      'Sword Omen/Shield Omen': 'Sword/Shield Omen',
      'Shield Omen/Sword Omen': 'Shield/Sword Omen'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Seeker Avatar': 'Spaltteil Der Sucher',
      'Aetherial Bolt': 'Magiegeschoss',
      'Aetherial Burst': 'Magiebombe',
      'Aetherial Orb': 'Magiekugel',
      'Aetherial Ward': 'Magiewall',
      'Automatic Turret': 'Selbstschuss-Gyrocopter',
      'Avowed Avatar': 'Spaltteil der Eingeschworenen',
      'Blazing Orb': 'Feuerball',
      'Bozjan Phantom': 'Bozja-Phantom',
      'Dahu': 'Dahu',
      'Frost Arrow': 'Frostpfeil',
      'Marchosias': 'Marchosias',
      'Pride of the Lion': 'Saal des Löwen',
      'Queen\'s Gunner': 'Schütze der Königin',
      'Queen\'s Knight': 'Ritter der Königin',
      'Queen\'s Soldier': 'Soldat der Königin',
      'Queen\'s Warrior': 'Kriegerin der Königin',
      'Queensheart': 'Saal der Dienerinnen',
      'Soldier Avatar': 'Spaltteil des Soldaten',
      'Stuffy Wraith': 'muffig(?:e|er|es|en) Schrecken',
      'Swirling Orb': 'Eisball',
      'Tempestuous Orb': 'groß(?:e|er|es|en) Eisball',
      'The Hall of Hieromancy': 'Halle des Orakels',
      'The Hall of Supplication': 'Große Gebetshalle',
      'The Queen': 'Kriegsgöttin',
      'The Theater of One': 'Einsame Arena',
      'The Vault of Singing Crystal': 'Ort des Klingenden Kristalls',
      'Trinity Avowed': 'Trinität der Eingeschworenen',
      'Trinity Seeker': 'Trinität der Sucher'
    },
    'replaceText': {
      '--explosion--': '--Explosion--',
      '--stunned--': '--betäubt--',
      '--unstunned--': '--nicht länger betäubt--',
      'Above Board': 'Über dem Feld',
      'Act Of Mercy': 'Schneller Stich des Dolches',
      'Allegiant Arsenal': 'Waffenwechsel',
      'Automatic Turret': 'Selbstschuss-Gyrocopter',
      'Baleful Blade': 'Stoß der Edelklinge',
      'Baleful Swathe': 'Schwarzer Wirbel der Edelklinge',
      'Beck And Call To Arms': 'Feuerbefehl',
      'Blade Of Entropy': 'Eisflammenklinge',
      'Blood And Bone': 'Wellenschlag',
      'Bombslinger': 'Bombenabwurf',
      'Cleansing Slash': 'Säubernder Schnitt',
      'Coat Of Arms': 'Trotz',
      'Creeping Miasma': 'Miasmahauch',
      'Dead Iron': 'Woge der Feuerfaust',
      'Double Gambit': 'Illusionsmagie',
      'Elemental Arrow': 'Element-Pfeil',
      'Elemental Blast': 'Element-Explosion',
      'Elemental Impact': 'Einschlag',
      'Empyrean Iniquity': 'Empyreische Interdiktion',
      'Excruciation': 'Fürchterlicher Schmerz',
      'Feral Howl': 'Wildes Heulen',
      'Firebreathe': 'Lava-Atem',
      'First Mercy': '1. Streich: Viererdolch-Haltung',
      'Flames Of Bozja': 'Bozianische Flamme',
      'Flashvane': 'Schockpfeile',
      'Fourth Mercy': '4. Streich: Viererdolch-Haltung',
      'Freedom Of Bozja': 'Bozianische Freiheit',
      'Fury Of Bozja': 'Bozianische Wut',
      'Gleaming Arrow': 'Funkelnder Pfeil',
      'Glory Of Bozja': 'Stolz von Bozja',
      'Gods Save The Queen': 'Wächtergott der Königin',
      'Head Down': 'Scharrende Hufe',
      'Heat Breath': 'Hitzeatem',
      'Heated Blast': 'Hitzekugel',
      'Heaven\'s Wrath': 'Heilige Perforation',
      'Hot And Cold': 'Heiß und kalt',
      'Hot Charge': 'Heiße Rage',
      'Hunter\'s Claw': 'Jägerklaue',
      'Infernal Slash': 'Yama-Schnitt',
      'Iron Impact': 'Kanon der Feuerfaust',
      'Iron Splitter': 'Furor der Feuerfaust',
      'Judgment Blade': 'Klinge des Urteils',
      'Left-Sided Shockwave': 'Linke Schockwelle',
      'Lots Cast': 'Magieexplosion',
      'Malediction Of Agony': 'Pochender Fluch',
      'Manipulate Miasma': 'Miasmakontrolle',
      'Merciful Arc': 'Fächertanz des Dolches',
      'Merciful Blooms': 'Kasha des Dolches',
      'Merciful Breeze': 'Yukikaze des Dolches',
      'Merciful Moon': 'Gekko des Dolches',
      'Mercy Fourfold': 'Viererdolch',
      'Northswain\'s Glow': 'Stella Polaris',
      'Optimal Play': 'Bestes Manöver',
      'Pawn Off': 'Kranzklinge',
      'Phantom Edge': 'Phantomklingen',
      'Queen\'s Edict': 'Hohes Edikt der Königin',
      'Queen\'s Justice': 'Hoheitliche Strafe',
      'Queen\'s Shot': 'Omnidirektionalschuss',
      'Queen\'s Will': 'Edikt der Königin',
      'Rapid Sever': 'Radikale Abtrennung',
      'Relentless Play': 'Koordinierter Angriff',
      'Reverberating Roar': 'Sturzimpuls',
      'Reversal Of Forces': 'Materieinversion',
      'Right-Sided Shockwave': 'Rechte Schockwelle',
      'Seasons Of Mercy': 'Setsugekka des Dolches',
      'Second Mercy': '2. Streich: Viererdolch-Haltung',
      'Secrets Revealed': 'Enthüllte Geheimnisse',
      'Shield Omen': 'Schildhaltung',
      'Shimmering Shot': 'Glitzerpfeil',
      'Shot In The Dark': 'Einhändiger Schuss',
      'Strongpoint Defense': 'Widerstand',
      'Summon': 'Beschwörung',
      'Swirling Miasma': 'Miasmawirbel',
      'Sword Omen': 'Schwerthaltung',
      'Tail Swing': 'Schwanzfeger',
      'The Ends': 'Kreuzschnitt',
      'The Means': 'Kreuzschlag',
      'Third Mercy': '3. Streich: Viererdolch-Haltung',
      'Transference': 'Transfer',
      'Turret\'s Tour': 'Querschlägerhagel',
      'Undying Hatred': 'Über-Psychokinese',
      'Unseen Eye': 'Geist des Blütensturms',
      'Verdant Path': 'Lehren des Grünen Pfades',
      'Verdant Tempest': 'Zauberwind des Grünen Pfades',
      'Vile Wave': 'Welle der Boshaftigkeit',
      'Weave Miasma': 'Miasmathese',
      'Wrath Of Bozja': 'Bozianischer Zorn'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Seeker Avatar': 'Clone De La Trinité Soudée',
      'Aetherial Bolt': 'petite bombe',
      'Aetherial Burst': 'énorme bombe',
      'Aetherial Orb': 'amas d\'éther élémentaire',
      'Aetherial Ward': 'Barrière magique',
      'Automatic Turret': 'Auto-tourelle',
      'Avowed Avatar': 'clone de la trinité féale',
      'Blazing Orb': 'boule de feu',
      'Bozjan Phantom': 'fantôme bozjien',
      'Dahu': 'dahu',
      'Frost Arrow': 'volée de flèches de glace',
      'Marchosias': 'marchosias',
      'Pride of the Lion': 'Hall du Lion',
      'Queen\'s Gunner': 'fusilier de la reine',
      'Queen\'s Knight': 'chevalier de la reine',
      'Queen\'s Soldier': 'soldat de la reine',
      'Queen\'s Warrior': 'guerrière de la reine',
      'Queensheart': 'Chambre des prêtresses',
      'Soldier Avatar': 'double de soldat',
      'Stuffy Wraith': 'spectre boursouflé',
      'Swirling Orb': 'boule de glace',
      'Tempestuous Orb': 'grande boule de glace',
      'The Hall of Hieromancy': 'Salle des oracles',
      'The Hall of Supplication': 'Grande salle des prières',
      'The Queen': 'Garde-la-Reine',
      'The Theater of One': 'Amphithéâtre en ruines',
      'The Vault of Singing Crystal': 'Chambre des cristaux chantants',
      'Trinity Avowed': 'trinité féale',
      'Trinity Seeker': 'trinité soudée'
    },
    'replaceText': {
      '\\?': ' ?',
      '--explosion--': '--explosion--',
      '--stunned--': '--étourdi(e)--',
      '--unstunned--': '--non étourdi(e)--',
      'Above Board': 'Aire de flottement',
      'Act Of Mercy': 'Fendreciel rédempteur',
      'Allegiant Arsenal': 'Changement d\'arme',
      'Automatic Turret': 'Auto-tourelle',
      'Baleful Blade': 'Assaut singulier',
      'Baleful Swathe': 'Flux de noirceur singulier',
      'Beck And Call To Arms': 'Ordre d\'attaquer',
      'Blade Of Entropy': 'Sabre du feu et de la glace',
      'Blood And Bone': 'Onde tranchante',
      'Bombslinger': 'Jet de bombe',
      'Cleansing Slash': 'Taillade purifiante',
      'Coat Of Arms': 'Bouclier directionnel',
      'Creeping Miasma': 'Coulée miasmatique',
      'Dead Iron': 'Vague des poings de feu',
      'Double Gambit': 'Manipulation des ombres',
      'Elemental Arrow': 'Flèche élémentaire',
      'Elemental Blast': 'Explosion élémentaire',
      'Elemental Impact': 'Impact',
      'Empyrean Iniquity': 'Injustice empyréenne',
      'Excruciation': 'Atroce douleur',
      'Feral Howl': 'Rugissement sauvage',
      'Firebreathe': 'Souffle de lave',
      'First Mercy': 'Première lame rédemptrice',
      'Flames Of Bozja': 'Flammes de Bozja',
      'Flashvane': 'Flèches fulgurantes',
      'Fourth Mercy': 'Quatrième lame rédemptrice',
      'Freedom Of Bozja': 'Liberté de Bozja',
      'Fury Of Bozja': 'Furie de Bozja',
      'Gleaming Arrow': 'Flèche miroitante',
      'Glory Of Bozja': 'Gloire de Bozja',
      'Gods Save The Queen': 'Que les Dieux gardent la Reine',
      'Head Down': 'Charge bestiale',
      'Heat Breath': 'Souffle brûlant',
      'Heated Blast': 'Déflagration de feu',
      'Heaven\'s Wrath': 'Ire céleste',
      'Hot And Cold': 'Chaud et froid',
      'Hot Charge': 'Charge brûlante',
      'Hunter\'s Claw': 'Griffes prédatrices',
      'Infernal Slash': 'Taillade de Yama',
      'Iron Impact': 'Canon d\'ardeur des poings de feu',
      'Iron Splitter': 'Fracas des poings de feu',
      'Judgment Blade': 'Lame du jugement',
      'Left-Sided Shockwave/Right-Sided Shockwave': 'Onde de choc gauche/droite',
      'Lots Cast': 'Bombe ensorcelée',
      'Malediction Of Agony': 'Malédiction lancinante',
      'Manipulate Miasma': 'Contrôle des miasmes',
      'Merciful Arc': 'Éventail rédempteur',
      'Merciful Blooms': 'Kasha rédempteur',
      'Merciful Breeze': 'Yukikaze rédempteur',
      'Merciful Moon': 'Gekkô rédempteur',
      'Mercy Fourfold': 'Quatuor de lames rédemptrices',
      'Northswain\'s Glow': 'Étoile du Nord',
      'Optimal Play': 'Technique de maître d\'armes',
      'Pawn Off': 'Sabre tournoyant',
      'Phantom Edge': 'Épées spectrales',
      'Queen\'s Edict': 'Injonction de Gunnhildr',
      'Queen\'s Justice': 'Châtiment royal',
      'Queen\'s Shot': 'Tir tous azimuts',
      'Queen\'s Will': 'Édit de Gunnhildr',
      'Rapid Sever': 'Tranchage rapide',
      'Relentless Play': 'Ordre d\'attaque coordonnée',
      'Reverberating Roar': 'Cri disloquant',
      'Reversal Of Forces': 'Inversion des masses',
      'Right-Sided Shockwave/Left-Sided Shockwave': 'Onde de choc droite/gauche',
      'Seasons Of Mercy': 'Setsugekka rédempteur',
      'Second Mercy': 'Deuxième lame rédemptrice',
      'Secrets Revealed': 'Corporification',
      'Shield Omen/Sword Omen': 'Posture du bouclier/épée',
      'Shimmering Shot': 'Flèches scintillantes',
      'Shot In The Dark': 'Tir à une main',
      'Strongpoint Defense': 'Défense absolue',
      'Summon': 'Invocation',
      'Swirling Miasma': 'Anneau miasmatique',
      'Sword Omen/Shield Omen': 'Posture de l\'épée/bouclier',
      'Tail Swing': 'Queue balayante',
      'The Ends': 'Croix lacérante',
      'The Means': 'Croix perforante',
      'Third Mercy': 'Troisième lame rédemptrice',
      'Transference': 'Transfert',
      'Turret\'s Tour': 'Ricochets frénétiques',
      'Undying Hatred': 'Psychokinèse',
      'Unseen Eye': 'Spectres de l\'ouragan de fleurs',
      'Verdant Path': 'École de la Voie verdoyante',
      'Verdant Tempest': 'Tempête de la Voie verdoyante',
      'Vile Wave': 'Vague de malveillance',
      'Weave Miasma': 'Miasmologie',
      'Wrath Of Bozja': 'Courroux de Bozja'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Seeker Avatar': 'シーカーの分体',
      'Aetherial Bolt': '魔弾',
      'Aetherial Burst': '大魔弾',
      'Aetherial Orb': '魔力塊',
      'Aetherial Ward': '魔法障壁',
      'Automatic Turret': 'オートタレット',
      'Avowed Avatar': 'アヴァウドの分体',
      'Blazing Orb': '炎球',
      'Bozjan Phantom': 'ボズヤ・ファントム',
      'Dahu': 'ダウー',
      'Frost Arrow': 'フロストアロー',
      'Marchosias': 'マルコシアス',
      'Pride of the Lion': '雄獅子の広間',
      'Queen\'s Gunner': 'クイーンズ・ガンナー',
      'Queen\'s Knight': 'クイーンズ・ナイト',
      'Queen\'s Soldier': 'クイーンズ・ソルジャー',
      'Queen\'s Warrior': 'クイーンズ・ウォリアー',
      'Queensheart': '巫女たちの広間',
      'Soldier Avatar': 'ソルジャーの分体',
      'Stuffy Wraith': 'スタフィー・レイス',
      'Swirling Orb': '氷球',
      'Tempestuous Orb': '大氷球',
      'The Hall of Hieromancy': '託宣所',
      'The Hall of Supplication': '大祈祷所',
      'The Queen': 'セイブ・ザ・クイーン',
      'The Theater of One': '円形劇場跡',
      'The Vault of Singing Crystal': '響き合う水晶の間',
      'Trinity Avowed': 'トリニティ・アヴァウド',
      'Trinity Seeker': 'トリニティ・シーカー'
    },
    'replaceText': {
      '--explosion--': '--爆発--',
      '--stunned--': '--スタンされる--',
      '--unstunned--': '--スタンされない--',
      'Above Board': '浮遊波',
      'Act Of Mercy': '破天鋭刃風',
      'Allegiant Arsenal': 'ウェポンチェンジ',
      'Automatic Turret': 'オートタレット',
      'Baleful Blade': '豪剣強襲撃',
      'Baleful Swathe': '豪剣黒流破',
      'Beck And Call To Arms': '攻撃命令',
      'Blade Of Entropy': '氷炎刃',
      'Blood And Bone': '波動斬',
      'Bombslinger': '爆弾投擲',
      'Cleansing Slash': '乱命割殺斬',
      'Coat Of Arms': '偏向防御',
      'Creeping Miasma': '瘴気流',
      'Dead Iron': '熱拳振動波',
      'Double Gambit': '幻影術',
      'Elemental Arrow': '熱/凍気矢',
      'Elemental Blast': '熱/凍気弾',
      'Elemental Impact': '着弾',
      'Empyrean Iniquity': '天魔鬼神爆',
      'Excruciation': '激痛',
      'Feral Howl': 'フェラルハウル',
      'Firebreathe': 'ラーヴァブレス',
      'First Mercy': '初手：鋭刃四刀の構え',
      'Flames Of Bozja': 'フレイム・オブ・ボズヤ',
      'Flashvane': 'フラッシュアロー',
      'Fourth Mercy': '四手：鋭刃四刀の構え',
      'Freedom Of Bozja': 'リバティ・オブ・ボズヤ',
      'Fury Of Bozja': 'フューリー・オブ・ボズヤ',
      'Gleaming Arrow': 'グリッターアロー',
      'Glory Of Bozja': 'グローリー・オブ・ボズヤ',
      'Gods Save The Queen': 'ゴッド・セイブ・ザ・クイーン',
      'Head Down': 'ビーストチャージ',
      'Heat Breath': '火炎の息',
      'Heated Blast': '熱気弾',
      'Heaven\'s Wrath': '聖光爆裂斬',
      'Hot And Cold': '氷炎乱流',
      'Hot Charge': 'ホットチャージ',
      'Hunter\'s Claw': 'ハンタークロウ',
      'Infernal Slash': 'ヤーマスラッシュ',
      'Iron Impact': '熱拳烈気砲',
      'Iron Splitter': '熱拳地脈爆',
      'Judgment Blade': '不動無明剣',
      'Left-Sided Shockwave': 'レフトサイド・ショックウェーブ',
      'Lots Cast': '魔爆発',
      'Malediction Of Agony': '苦悶の呪詛',
      'Manipulate Miasma': '瘴気操作',
      'Merciful Arc': '鋭刃舞踏扇',
      'Merciful Blooms': '鋭刃花車',
      'Merciful Breeze': '鋭刃雪風',
      'Merciful Moon': '鋭刃月光',
      'Mercy Fourfold': '鋭刃四刀流',
      'Northswain\'s Glow': '北斗骨砕斬',
      'Optimal Play': '武装戦技',
      'Pawn Off': '旋回刃',
      'Phantom Edge': '霊幻剣',
      'Queen\'s Edict': '女王の大勅令',
      'Queen\'s Justice': '処罰令',
      'Queen\'s Shot': '全方位射撃',
      'Queen\'s Will': '女王の勅令',
      'Rapid Sever': '滅多斬り',
      'Relentless Play': '連携命令',
      'Reverberating Roar': '崩落誘発',
      'Reversal Of Forces': '質量転換',
      'Right-Sided Shockwave': 'ライトサイド・ショックウェーブ',
      'Seasons Of Mercy': '鋭刃雪月花',
      'Second Mercy': '二手：鋭刃四刀の構え',
      'Secrets Revealed': '実体結像',
      'Shield Omen': '盾の型',
      'Shimmering Shot': 'トゥインクルアロー',
      'Shot In The Dark': '片手撃ち',
      'Strongpoint Defense': '絶対防御',
      'Summon': '召喚',
      'Swirling Miasma': '瘴気輪',
      'Sword Omen': '剣の型',
      'Tail Swing': 'テールスイング',
      'The Ends': '十字斬',
      'The Means': '十字撃',
      'Third Mercy': '三手：鋭刃四刀の構え',
      'Transference': '転移',
      'Turret\'s Tour': '跳弾乱舞',
      'Undying Hatred': '超ねんりき',
      'Unseen Eye': '花嵐の幻影',
      'Verdant Path': '翠流派',
      'Verdant Tempest': '翠流魔風塵',
      'Vile Wave': '悪意の波動',
      'Weave Miasma': '瘴気術',
      'Wrath Of Bozja': 'ラース・オブ・ボズヤ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Seeker Avatar': '求道之分身',
      'Aetherial Bolt': '魔弹',
      'Aetherial Burst': '大魔弹',
      'Aetherial Orb': '魔力块',
      'Aetherial Ward': '魔法障壁',
      'Automatic Turret': '自动炮塔',
      'Avowed Avatar': '誓约之分身',
      'Blazing Orb': '火球',
      'Bozjan Phantom': '博兹雅幻灵',
      'Dahu': '大兀',
      'Frost Arrow': '寒霜箭',
      'Marchosias': '马可西亚斯',
      'Pride of the Lion': '雄狮大厅',
      'Queen\'s Gunner': '女王枪手',
      'Queen\'s Knight': '女王骑士',
      'Queen\'s Soldier': '女王士兵',
      'Queen\'s Warrior': '女王战士',
      'Queensheart': '巫女大厅',
      'Soldier Avatar': '士兵的分身',
      'Stuffy Wraith': '沉闷幽灵',
      'Swirling Orb': '冰球',
      'Tempestuous Orb': '大冰球',
      'The Hall of Hieromancy': '神谕所',
      'The Hall of Supplication': '大祈祷所',
      'The Queen': '天佑女王',
      'The Theater of One': '圆形剧场遗迹',
      'The Vault of Singing Crystal': '和鸣水晶之间',
      'Trinity Avowed': '誓约之三位一体',
      'Trinity Seeker': '求道之三位一体'
    },
    'replaceText': {
      '--explosion--': '--爆炸--',
      '--stunned--': '--眩晕--',
      '--unstunned--': '--眩晕结束--',
      'Above Board': '浮游波',
      'Act Of Mercy': '破天慈刃风',
      'Allegiant Arsenal': '变换武器',
      'Automatic Turret': '自动炮塔',
      'Baleful Blade': '豪剑强袭击',
      'Baleful Swathe': '豪剑黑流破',
      'Beck And Call To Arms': '攻击命令',
      'Blade Of Entropy': '冰炎刃',
      'Blood And Bone': '波动斩',
      'Bombslinger': '投掷炸弹',
      'Cleansing Slash': '乱命割杀斩',
      'Coat Of Arms': '偏向防御',
      'Creeping Miasma': '瘴气流',
      'Dead Iron': '热拳振动波',
      'Double Gambit': '幻影术',
      'Elemental Arrow': '元素箭',
      'Elemental Blast': '元素爆破',
      'Elemental Impact': '中弹',
      'Empyrean Iniquity': '天魔鬼神爆',
      'Excruciation': '剧痛',
      'Feral Howl': '野性嚎叫',
      'Firebreathe': '岩浆吐息',
      'First Mercy': '慈悲四刀第一念',
      'Flames Of Bozja': '博兹雅火焰',
      'Flashvane': '闪光箭',
      'Fourth Mercy': '慈悲四刀第四念',
      'Freedom Of Bozja': '博兹雅之自由',
      'Fury Of Bozja': '博兹雅之怒',
      'Gleaming Arrow': '闪耀箭',
      'Glory Of Bozja': '博兹雅之荣',
      'Gods Save The Queen': '神佑女王',
      'Head Down': '兽性冲击',
      'Heat Breath': '灼热吐息',
      'Heated Blast': '热浪弹',
      'Heaven\'s Wrath': '圣光爆裂斩',
      'Hot And Cold': '冰炎乱流',
      'Hot Charge': '炽热冲锋',
      'Hunter\'s Claw': '狩猎者之爪',
      'Infernal Slash': '地狱斩',
      'Iron Impact': '热拳烈气炮',
      'Iron Splitter': '热拳地脉爆',
      'Judgment Blade': '不动无明剑',
      'Left-Sided Shockwave': '左侧震荡波',
      'Lots Cast': '魔爆炸',
      'Malediction Of Agony': '苦闷的诅咒',
      'Manipulate Miasma': '操作瘴气',
      'Merciful Arc': '慈悲舞动扇',
      'Merciful Blooms': '慈悲花车',
      'Merciful Breeze': '慈悲雪风',
      'Merciful Moon': '慈悲月光',
      'Mercy Fourfold': '慈悲四刀流',
      'Northswain\'s Glow': '北斗骨碎斩',
      'Optimal Play': '武装战技',
      'Pawn Off': '旋回刃',
      'Phantom Edge': '灵幻剑',
      'Queen\'s Edict': '女王的大敕令',
      'Queen\'s Justice': '处罚令',
      'Queen\'s Shot': '全方位射击',
      'Queen\'s Will': '女王的敕令',
      'Rapid Sever': '急促斩击',
      'Relentless Play': '协作指令',
      'Reverberating Roar': '引发崩塌',
      'Reversal Of Forces': '质量转换',
      'Right-Sided Shockwave': '右侧震荡波',
      'Seasons Of Mercy': '慈悲雪月花',
      'Second Mercy': '慈悲四刀第二念',
      'Secrets Revealed': '实体成像',
      'Shield Omen': '盾型',
      'Shimmering Shot': '闪烁箭',
      'Shot In The Dark': '单手射击',
      'Strongpoint Defense': '绝对防御',
      'Summon': '召唤',
      'Swirling Miasma': '瘴气圈',
      'Sword Omen': '剑型',
      'Tail Swing': '回旋尾',
      'The Ends': '十字斩',
      'The Means': '十字击',
      'Third Mercy': '慈悲四刀第三念',
      'Transference': '转移',
      'Turret\'s Tour': '跳弹乱舞',
      'Undying Hatred': '超念力',
      'Unseen Eye': '风花舞的幻影',
      'Verdant Path': '翠青流',
      'Verdant Tempest': '翠青魔风尘',
      'Vile Wave': '恶意的波动',
      'Weave Miasma': '瘴气术',
      'Wrath Of Bozja': '博兹雅之愤'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Seeker Avatar': '탐구의 분열체',
      'Aetherial Bolt': '마탄',
      'Aetherial Burst': '대마탄',
      'Aetherial Orb': '마력 덩어리',
      'Aetherial Ward': '마법 장벽',
      'Automatic Turret': '자동포탑',
      'Avowed Avatar': '맹세의 분열체',
      'Blazing Orb': '화염 구체',
      'Bozjan Phantom': '보즈야 유령',
      'Dahu': '다후',
      'Frost Arrow': '서리 화살',
      'Marchosias': '마르코시아스',
      'Pride of the Lion': '수사자의 방',
      'Queen\'s Gunner': '여왕의 총사',
      'Queen\'s Knight': '여왕의 기사',
      'Queen\'s Soldier': '여왕의 병사',
      'Queen\'s Warrior': '여왕의 전사',
      'Queensheart': '무녀들의 방',
      'Soldier Avatar': '병사 분열체',
      'Stuffy Wraith': '케케묵은 망령',
      'Swirling Orb': '얼음 구체',
      'Tempestuous Orb': '거대 얼음 구체',
      'The Hall of Hieromancy': '신탁소',
      'The Hall of Supplication': '대기도소',
      'The Queen': '세이브 더 퀸',
      'The Theater of One': '원형 극장 옛터',
      'The Vault of Singing Crystal': '공명하는 수정의 방',
      'Trinity Avowed': '맹세의 삼위일체',
      'Trinity Seeker': '탐구의 삼위일체'
    },
    'replaceText': {
      '--explosion--': '--폭발--',
      '--stunned--': '--기절--',
      '--unstunned--': '--기절풀림--',
      'Above Board': '부유파',
      'Act Of Mercy': '예리한 파천풍',
      'Allegiant Arsenal': '무기 변경',
      'Automatic Turret': '자동포탑',
      'Baleful Blade': '호검 강습 공격',
      'Baleful Swathe': '호검 흑류파',
      'Beck And Call To Arms': '공격 명령',
      'Blade Of Entropy': '얼음불 칼날',
      'Blood And Bone': '파동참',
      'Bombslinger': '폭탄 투척',
      'Cleansing Slash': '난명할살참',
      'Coat Of Arms': '편향 방어',
      'Creeping Miasma': '독기 흐름',
      'Dead Iron': '불주먹 진동파',
      'Double Gambit': '환영술',
      'Elemental Arrow': '속성 화살',
      'Elemental Blast': '속성 운석 폭발',
      'Elemental Impact': '착탄',
      'Empyrean Iniquity': '천마귀신폭',
      'Excruciation': '격통',
      'Feral Howl': '야성의 포효',
      'Firebreathe': '용암숨',
      'First Mercy': '예리한 첫 번째 검',
      'Flames Of Bozja': '보즈야 플레임',
      'Flashvane': '섬광 화살',
      'Fourth Mercy': '예리한 네 번째 검',
      'Freedom Of Bozja': '보즈야의 자유',
      'Fury Of Bozja': '보즈야의 분노',
      'Gleaming Arrow': '현란한 화살',
      'Glory Of Bozja': '보즈야의 영광',
      'Gods Save The Queen': '갓 세이브 더 퀸',
      'Head Down': '야수 돌격',
      'Heat Breath': '화염의 숨결',
      'Heated Blast': '열기탄',
      'Heaven\'s Wrath': '성광폭렬참',
      'Hot And Cold': '빙염난류',
      'Hot Charge': '맹렬한 돌진',
      'Hunter\'s Claw': '사냥꾼의 발톱',
      'Infernal Slash': '연옥 베기',
      'Iron Impact': '불주먹 열기포',
      'Iron Splitter': '불주먹 지맥 폭발',
      'Judgment Blade': '부동무명검',
      'Left-Sided Shockwave': '왼쪽 충격파',
      'Lots Cast': '마폭발',
      'Malediction Of Agony': '고통의 저주',
      'Manipulate Miasma': '독기 조작',
      'Merciful Arc': '예리한 부채검',
      'Merciful Blooms': '예리한 화차',
      'Merciful Breeze': '예리한 설풍',
      'Merciful Moon': '예리한 월광',
      'Mercy Fourfold': '예리한 사도류',
      'Northswain\'s Glow': '북두골쇄참',
      'Optimal Play': '무장 전술',
      'Pawn Off': '선회인',
      'Phantom Edge': '영환검',
      'Queen\'s Edict': '여왕의 대칙령',
      'Queen\'s Justice': '처벌령',
      'Queen\'s Shot': '전방위 사격',
      'Queen\'s Will': '여왕의 칙령',
      'Rapid Sever': '마구 베기',
      'Relentless Play': '연계 명령',
      'Reverberating Roar': '낙석 유발',
      'Reversal Of Forces': '질량 전환',
      'Right-Sided Shockwave': '오른쪽 충격파',
      'Seasons Of Mercy': '예리한 설월화',
      'Second Mercy': '예리한 두 번째 검',
      'Secrets Revealed': '실체 이루기',
      'Shield Omen': '방패 태세',
      'Shimmering Shot': '반짝반짝 화살',
      'Shot In The Dark': '한손 쏘기',
      'Strongpoint Defense': '절대 방어',
      'Summon': '소환',
      'Swirling Miasma': '독기 고리',
      'Sword Omen': '검 태세',
      'Tail Swing': '꼬리 휘두르기',
      'The Ends': '십자참',
      'The Means': '십자격',
      'Third Mercy': '예리한 세 번째 검',
      'Transference': '전이',
      'Turret\'s Tour': '도탄난무',
      'Undying Hatred': '초염력',
      'Unseen Eye': '꽃폭풍의 환영',
      'Verdant Path': '취일문 유파',
      'Verdant Tempest': '취일문 마풍진',
      'Vile Wave': '악의의 파동',
      'Weave Miasma': '독기술',
      'Wrath Of Bozja': '보즈야의 격노'
    }
  }]
};
/* harmony default export */ const delubrum_reginae = (delubrum_reginae_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/eureka/delubrum_reginae.txt
const eureka_delubrum_reginae_namespaceObject = "### Delubrum Reginae (Normal)\r\n# https://docs.google.com/document/d/1NGAF4qGKIIc0W99Ax3nUsYVB9qEVXRCKpWzHodpf338/edit\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Note: various \"Blast\" are renamed \"Elemental Blast\" and various \"Arrow\" are renamed\r\n# to be \"Elemental Arrow\" to avoid having too many skills on the timeline.\r\n\r\n### Trinity Seeker\r\n# -p 5AB6:1012.2\r\n# -ii 5AB4 5A9B 5A9C 5A9D 5A9E 5A9F 5AA4 5AA5 5AA6 5AA7 5AA8 5AA9 5B28 5B29 5AB5 5AB0 5AAE 38FC\r\n#\r\n# 5A97 Verdant Path -> gains the effect of Merciful Air (4x blades)\r\n# 5A98 Verdant Path -> gains the effect of Baleful Air (2x greatswords)\r\n# 5A99 Verdant Path -> gains the effect of Iron Air (fists)\r\n# Merciful -> Baleful -> Iron -> random non-repeating from [merciful v2, baleful v2, iron v2]\r\n\r\n# Initial Merciful Air\r\n# The Theater of One will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E1B\" } window 10000,0\r\n1012.2 \"Verdant Tempest\" Ability { id: \"5AB6\", source: \"Trinity Seeker\" }\r\n1019.4 \"First Mercy\" Ability { id: \"5B5D\", source: \"Trinity Seeker\" }\r\n1022.6 \"Second Mercy\" Ability { id: \"5B5E\", source: \"Trinity Seeker\" }\r\n1025.8 \"Third Mercy\" Ability { id: \"5B5F\", source: \"Trinity Seeker\" }\r\n1029.0 \"Fourth Mercy\" Ability { id: \"5B60\", source: \"Trinity Seeker\" }\r\n1031.4 \"Mercy Fourfold\" #Ability { id: \"5B34\", source: \"Trinity Seeker\" }\r\n1033.3 \"Mercy Fourfold\" #Ability { id: \"5B34\", source: \"Trinity Seeker\" }\r\n1035.2 \"Mercy Fourfold\" #Ability { id: \"5B34\", source: \"Trinity Seeker\" }\r\n1037.1 \"Mercy Fourfold\" #Ability { id: \"5B34\", source: \"Trinity Seeker\" }\r\n1047.4 \"Merciful Arc\" Ability { id: \"5AB7\", source: \"Trinity Seeker\" }\r\n\r\n# Initial Baleful Air\r\n1056.5 \"Verdant Path\" Ability { id: \"5A98\", source: \"Trinity Seeker\" } window 80,80\r\n1064.1 \"Baleful Swathe\" Ability { id: \"5AB3\", source: \"Trinity Seeker\" }\r\n1069.3 \"--middle--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n1078.4 \"Baleful Blade\" Ability { id: \"5AA1\", source: \"Trinity Seeker\" }\r\n1086.6 \"Phantom Edge\" Ability { id: \"5AA0\", source: \"Trinity Seeker\" }\r\n1096.7 \"Baleful Blade\" Ability { id: \"5AA2\", source: \"Trinity Seeker\" }\r\n1107.8 \"Verdant Tempest\" Ability { id: \"5AB6\", source: \"Trinity Seeker\" }\r\n\r\n# Initial Iron Air\r\n1117.0 \"Verdant Path\" Ability { id: \"5A99\", source: \"Trinity Seeker\" } window 80,80\r\n1126.6 \"Iron Impact\" Ability { id: \"5ADB\", source: \"Trinity Seeker\" }\r\n1131.6 \"--jump--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n1138.5 \"Iron Splitter\" Ability { id: \"5AA3\", source: \"Trinity Seeker\" }\r\n1141.7 \"--jump--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n1148.6 \"Iron Splitter\" Ability { id: \"5AA3\", source: \"Trinity Seeker\" }\r\n1159.7 \"Verdant Tempest\" Ability { id: \"5AB6\", source: \"Trinity Seeker\" }\r\n1168.9 \"Verdant Path\" # -> baleful / merciful jump\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# (Baleful jump?)\r\n1168.9 \"--sync--\" Ability { id: \"5A98\", source: \"Trinity Seeker\" } window 80,80 jump 1300\r\n1176.5 \"Baleful Swathe?\" #Ability { id: \"5AB3\", source: \"Trinity Seeker\" }\r\n1186.7 \"Phantom Edge?\" #Ability { id: \"5AA0\", source: \"Trinity Seeker\" }\r\n1188.9 \"--sync--\" #Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n1198.0 \"Baleful Blade?\" #Ability { id: \"5AA[12]\", source: \"Trinity Seeker\" }\r\n\r\n# (Merciful jump?)\r\n1168.9 \"--sync--\" Ability { id: \"5A97\", source: \"Trinity Seeker\" } window 80,80 jump 1500\r\n1176.5 \"Act Of Mercy?\" #Ability { id: \"5AB2\", source: \"Trinity Seeker\" }\r\n1183.7 \"First Mercy?\" #Ability { id: \"5B5D\", source: \"Trinity Seeker\" }\r\n1186.9 \"Second Mercy?\" #Ability { id: \"5B5E\", source: \"Trinity Seeker\" }\r\n1190.1 \"Third Mercy?\" #Ability { id: \"5B5F\", source: \"Trinity Seeker\" }\r\n1193.3 \"Fourth Mercy?\" #Ability { id: \"5B60\", source: \"Trinity Seeker\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Baleful Air v2 (randomized, with chains)\r\n1300.0 \"Verdant Path\" Ability { id: \"5A98\", source: \"Trinity Seeker\" }\r\n1307.6 \"Baleful Swathe\" Ability { id: \"5AB3\", source: \"Trinity Seeker\" }\r\n1317.8 \"Phantom Edge?\" Ability { id: \"5AA0\", source: \"Trinity Seeker\" }\r\n1320.0 \"--sync--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n1329.1 \"Baleful Blade\" Ability { id: \"5AA[12]\", source: \"Trinity Seeker\" }\r\n1339.3 \"Phantom Edge?\" Ability { id: \"5AA0\", source: \"Trinity Seeker\" }\r\n1341.5 \"--sync--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n1350.6 \"Baleful Blade\" Ability { id: \"5AA[12]\", source: \"Trinity Seeker\" }\r\n1361.7 \"Verdant Tempest\" Ability { id: \"5AB6\", source: \"Trinity Seeker\" }\r\n1370.9 \"Verdant Path\" # -> iron / merciful jump\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# (Iron jump?)\r\n1370.9 \"--sync--\" Ability { id: \"5A99\", source: \"Trinity Seeker\" } window 80,80 jump 1700\r\n1380.5 \"Iron Impact?\" #Ability { id: \"5ADB\", source: \"Trinity Seeker\" }\r\n1390.5 \"Dead Iron?\" #Ability { id: \"5AAF\", source: \"Trinity Seeker\" }\r\n1397.7 \"Dead Iron?\" #Ability { id: \"5B44\", source: \"Trinity Seeker\" }\r\n\r\n# (Merciful jump?)\r\n1370.9 \"--sync--\" Ability { id: \"5A97\", source: \"Trinity Seeker\" } window 80,80 jump 1500\r\n1378.5 \"Act Of Mercy?\" #Ability { id: \"5AB2\", source: \"Trinity Seeker\" }\r\n1385.7 \"First Mercy?\" #Ability { id: \"5B5D\", source: \"Trinity Seeker\" }\r\n1388.9 \"Second Mercy?\" #Ability { id: \"5B5E\", source: \"Trinity Seeker\" }\r\n1392.1 \"Third Mercy?\" #Ability { id: \"5B5F\", source: \"Trinity Seeker\" }\r\n1395.3 \"Fourth Mercy?\" #Ability { id: \"5B60\", source: \"Trinity Seeker\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Merciful Air v2 (with seasons of mercy))\r\n1500.0 \"Verdant Path\" Ability { id: \"5A97\", source: \"Trinity Seeker\" }\r\n1507.6 \"Act Of Mercy\" Ability { id: \"5AB2\", source: \"Trinity Seeker\" }\r\n1514.8 \"First Mercy\" Ability { id: \"5B5D\", source: \"Trinity Seeker\" }\r\n1518.0 \"Second Mercy\" Ability { id: \"5B5E\", source: \"Trinity Seeker\" }\r\n1521.2 \"Third Mercy\" Ability { id: \"5B5F\", source: \"Trinity Seeker\" }\r\n1524.4 \"Fourth Mercy\" Ability { id: \"5B60\", source: \"Trinity Seeker\" }\r\n1526.8 \"Mercy Fourfold\" #Ability { id: \"5B34\", source: \"Trinity Seeker\" }\r\n1528.7 \"Mercy Fourfold\" #Ability { id: \"5B34\", source: \"Trinity Seeker\" }\r\n1530.6 \"Mercy Fourfold\" #Ability { id: \"5B34\", source: \"Trinity Seeker\" }\r\n1532.5 \"Mercy Fourfold\" #Ability { id: \"5B34\", source: \"Trinity Seeker\" }\r\n1540.7 \"Seasons Of Mercy\" Ability { id: \"5AAA\", source: \"Trinity Seeker\" }\r\n1545.2 \"Merciful Breeze\" Ability { id: \"5AAB\", source: \"Trinity Seeker\" }\r\n1545.2 \"Merciful Breeze\" Ability { id: \"5AAB\", source: \"Trinity Seeker\" }\r\n1547.7 \"Merciful Moon\" Ability { id: \"5AAC\", source: \"Aetherial Orb\" }\r\n1549.3 \"Merciful Breeze\" Ability { id: \"5AAB\", source: \"Trinity Seeker\" }\r\n1549.3 \"Merciful Breeze\" Ability { id: \"5AAB\", source: \"Trinity Seeker\" }\r\n1552.7 \"Merciful Blooms\" Ability { id: \"5AAD\", source: \"Trinity Seeker\" }\r\n1559.9 \"Verdant Tempest\" Ability { id: \"5AB6\", source: \"Trinity Seeker\" }\r\n1569.1 \"Merciful Arc\" Ability { id: \"5AB7\", source: \"Trinity Seeker\" }\r\n1576.2 \"Verdant Path\" # -> baleful / iron jump\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# (Baleful jump?)\r\n1576.2 \"--sync--\" Ability { id: \"5A98\", source: \"Trinity Seeker\" } window 80,80 jump 1300\r\n1583.8 \"Baleful Swathe?\" #Ability { id: \"5AB3\", source: \"Trinity Seeker\" }\r\n1594.0 \"Phantom Edge?\" #Ability { id: \"5AA0\", source: \"Trinity Seeker\" }\r\n1596.2 \"--sync--\" #Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n1605.3 \"Baleful Blade?\" #Ability { id: \"5AA[12]\", source: \"Trinity Seeker\" }\r\n\r\n# (Iron jump?)\r\n1576.2 \"--sync--\" Ability { id: \"5A99\", source: \"Trinity Seeker\" } window 80,80 jump 1700\r\n1585.8 \"Iron Impact?\" #Ability { id: \"5ADB\", source: \"Trinity Seeker\" }\r\n1595.8 \"Dead Iron?\" #Ability { id: \"5AAF\", source: \"Trinity Seeker\" }\r\n1603.0 \"Dead Iron?\" #Ability { id: \"5B44\", source: \"Trinity Seeker\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Iron Air v2 (with iron impact / dead iron)\r\n1700.0 \"Verdant Path\" Ability { id: \"5A99\", source: \"Trinity Seeker\" }\r\n1709.6 \"Iron Impact\" Ability { id: \"5ADB\", source: \"Trinity Seeker\" }\r\n1719.6 \"Dead Iron\" Ability { id: \"5AAF\", source: \"Trinity Seeker\" }\r\n1726.8 \"Dead Iron\" Ability { id: \"5B44\", source: \"Trinity Seeker\" }\r\n1732.0 \"--sync--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n1738.7 \"Iron Splitter\" Ability { id: \"5AA3\", source: \"Trinity Seeker\" }\r\n1740.9 \"--sync--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n1747.0 \"Iron Splitter\" Ability { id: \"5AA3\", source: \"Trinity Seeker\" }\r\n1758.1 \"Verdant Tempest\" Ability { id: \"5AB6\", source: \"Trinity Seeker\" }\r\n1767.3 \"Verdant Path\" # -> baleful / merciful jump\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# (Baleful jump?)\r\n1767.3 \"--sync--\" Ability { id: \"5A98\", source: \"Trinity Seeker\" } window 80,80 jump 1300\r\n1774.9 \"Baleful Swathe?\" #Ability { id: \"5AB3\", source: \"Trinity Seeker\" }\r\n1785.1 \"Phantom Edge?\" #Ability { id: \"5AA0\", source: \"Trinity Seeker\" }\r\n1787.3 \"--sync--\" #Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n1796.4 \"Baleful Blade?\" #Ability { id: \"5AA[12]\", source: \"Trinity Seeker\" }\r\n\r\n# (Merciful jump?)\r\n1767.3 \"--sync--\" Ability { id: \"5A97\", source: \"Trinity Seeker\" } window 80,80 jump 1500\r\n1774.9 \"Act Of Mercy?\" #Ability { id: \"5AB2\", source: \"Trinity Seeker\" }\r\n1782.1 \"First Mercy?\" #Ability { id: \"5B5D\", source: \"Trinity Seeker\" }\r\n1785.3 \"Second Mercy?\" #Ability { id: \"5B5E\", source: \"Trinity Seeker\" }\r\n1788.5 \"Third Mercy?\" #Ability { id: \"5B5F\", source: \"Trinity Seeker\" }\r\n1791.7 \"Fourth Mercy?\" #Ability { id: \"5B60\", source: \"Trinity Seeker\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n### Dahu\r\n# -p 5755:2023\r\n# -ii 575A 575C\r\n# The Hall of Supplication will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E1D\" } window 10000,0\r\n2007.0 \"--sync--\" StartsUsing { id: \"576[12]\", source: \"Dahu\" } window 10,2\r\n2010.0 \"Right-Sided Shockwave/Left-Sided Shockwave\" #Ability { id: \"576[12]\", source: \"Dahu\" }\r\n2012.6 \"Left-Sided Shockwave/Right-Sided Shockwave\" #Ability { id: \"576[12]\", source: \"Dahu\" }\r\n2023.0 \"Feral Howl\" Ability { id: \"5755\", source: \"Dahu\" } window 30,10\r\n2033.4 \"Firebreathe\" Ability { id: \"5765\", source: \"Dahu\" }\r\n2045.7 \"--sync--\" Ability { id: \"5758\", source: \"Marchosias\" }\r\n2051.9 \"Head Down\" Ability { id: \"5756\", source: \"Marchosias\" }\r\n2058.8 \"Head Down\" Ability { id: \"5756\", source: \"Marchosias\" }\r\n2065.3 \"Feral Howl\" Ability { id: \"5755\", source: \"Dahu\" }\r\n2068.8 \"Hunter's Claw\" Ability { id: \"5757\", source: \"Marchosias\" }\r\n2075.5 \"Firebreathe x5\" Ability { id: \"5759\", source: \"Dahu\" } duration 8.7\r\n2091.5 \"Reverberating Roar\" Ability { id: \"575B\", source: \"Dahu\" }\r\n2105.0 \"Hot Charge\" Ability { id: \"5764\", source: \"Dahu\" }\r\n2109.8 \"Hot Charge\" Ability { id: \"5764\", source: \"Dahu\" }\r\n\r\n2116.6 \"Firebreathe\" Ability { id: \"5765\", source: \"Dahu\" }\r\n2129.8 \"--sync--\" Ability { id: \"5758\", source: \"Marchosias\" }\r\n2130.8 \"Reverberating Roar\" Ability { id: \"575B\", source: \"Dahu\" }\r\n2136.1 \"Head Down\" Ability { id: \"5756\", source: \"Marchosias\" }\r\n2142.8 \"Head Down\" Ability { id: \"5756\", source: \"Marchosias\" }\r\n2149.0 \"Right-Sided Shockwave/Left-Sided Shockwave\" #Ability { id: \"576[12]\", source: \"Dahu\" }\r\n2149.5 \"Head Down\" Ability { id: \"5756\", source: \"Marchosias\" }\r\n2151.5 \"Left-Sided Shockwave/Right-Sided Shockwave\" #Ability { id: \"576[12]\", source: \"Dahu\" }\r\n2156.2 \"Head Down\" Ability { id: \"5756\", source: \"Marchosias\" }\r\n2162.7 \"Feral Howl\" Ability { id: \"5755\", source: \"Dahu\" }\r\n2166.2 \"Hunter's Claw\" Ability { id: \"5757\", source: \"Marchosias\" }\r\n2172.9 \"Firebreathe x5\" Ability { id: \"5759\", source: \"Dahu\" }\r\n2195.1 \"Heat Breath\" Ability { id: \"5766\", source: \"Dahu\" }\r\n2205.7 \"Tail Swing\" Ability { id: \"575F\", source: \"Dahu\" }\r\n2217.9 \"Reverberating Roar\" Ability { id: \"575B\", source: \"Dahu\" }\r\n2231.8 \"Hot Charge\" Ability { id: \"5764\", source: \"Dahu\" }\r\n2236.7 \"Hot Charge\" Ability { id: \"5764\", source: \"Dahu\" }\r\n\r\n2243.6 \"Firebreathe\" Ability { id: \"5765\", source: \"Dahu\" } window 50,50 jump 2116.6\r\n2256.8 \"--sync--\" #Ability { id: \"5758\", source: \"Marchosias\" }\r\n2257.8 \"Reverberating Roar\" #Ability { id: \"575B\", source: \"Dahu\" }\r\n2263.1 \"Head Down\" #Ability { id: \"5756\", source: \"Marchosias\" }\r\n2269.8 \"Head Down\" #Ability { id: \"5756\", source: \"Marchosias\" }\r\n2276.0 \"Right-Sided Shockwave/Left-Sided Shockwave\" #Ability { id: \"576[12]\", source: \"Dahu\" }\r\n2276.5 \"Head Down\" #Ability { id: \"5756\", source: \"#Marchosias\" }\r\n2278.5 \"Left-Sided Shockwave/Right-Sided Shockwave\" #Ability { id: \"576[12]\", source: \"Dahu\" }\r\n2283.2 \"Head Down\" #Ability { id: \"5756\", source: \"Marchosias\" }\r\n2289.7 \"Feral Howl\" #Ability { id: \"5755\", source: \"Dahu\" }\r\n\r\n\r\n### Queen's Guard\r\n# (may need 57F0:3711.1, depending on which knight ability used first)\r\n# -p 5805:3111.1 580B:3311.1 5AFD:3511.1 57F1:3711.1 57F5:4005\r\n# -ii 5B70 5806 5838 5857 580D 580F 5B71 5A93 57F3 57F2 57F8 57F7\r\n# All four (just autos) -> randomly each individually -> final phase with aetherial wards\r\n\r\n# The Hall of Hieromancy will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E1E\" } window 10000,0\r\n# ranged auto should be reasonably timed\r\n3002.5 \"--sync--\" Ability { id: \"5857\", source: \"Queen's Gunner\" } window 3,1\r\n# can't sync this untargetable as the mobs will hop away sooner if they are damaged enough.\r\n3025.7 \"--untargetable--\"\r\n3028.7 \"--targetable--\"\r\n\r\n# Syncing on 22 targeting plate lines is a little bit fraught as fflogs\r\n# doesn't save these lines.  So, just to make this more testable,\r\n# make sure we jump on all of the ability starts of each phase.\r\n# We can't have huge syncs on these because many of these are used\r\n# multiple times.  So, 22 lines get huge syncs and ability lines\r\n# get more local windows here and in each block.\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n3036.8 \"--sync--\" StartsUsing { id: \"5805\", source: \"Queen's Soldier\" } window 50,50 jump 3108.1\r\n3039.8 \"Double Gambit?\" #Ability { id: \"5805\", source: \"Queen's Soldier\" }\r\n\r\n3036.8 \"--sync--\" StartsUsing { id: \"580B\", source: \"Queen's Gunner\" } window 50,50 jump 3308.1\r\n3039.8 \"Automatic Turret?\" #Ability { id: \"580B\", source: \"Queen's Gunner\" }\r\n\r\n3036.8 \"--sync--\" StartsUsing { id: \"5AFD\", source: \"Queen's Warrior\" } window 50,50 jump 3508.1\r\n3039.8 \"Bombslinger?\" #Ability { id: \"5AFD\", source: \"Queen's Warrior\" }\r\n\r\n3036.8 \"--sync--\" StartsUsing { id: \"57F[01]\", source: \"Queen's Knight\" } window 50,50 jump 3708.1\r\n3039.8 \"Shield Omen/Sword Omen?\" #Ability { id: \"57F[01]\", source: \"Queen's Knight\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Queen's Soldier\r\n# (local jumps to other blocks)\r\n3100.0 \"--sync--\" StartsUsing { id: \"580B\", source: \"Queen's Gunner\" } window 0,200 jump 3308.1\r\n3100.0 \"--sync--\" StartsUsing { id: \"5AFD\", source: \"Queen's Warrior\" } window 0,200 jump 3508.1\r\n3100.0 \"--sync--\" StartsUsing { id: \"57F[01]\", source: \"Queen's Knight\" } window 0,200 jump 3708.1\r\n\r\n3100.0 \"--targetable--\" NameToggle { name: \"Queen's Soldier\", toggle: \"01\" } window 500,500\r\n3108.1 \"--sync--\" StartsUsing { id: \"5805\", source: \"Queen's Soldier\" } window 10,10\r\n3111.1 \"Double Gambit\" Ability { id: \"5805\", source: \"Queen's Soldier\" }\r\n3119.3 \"Secrets Revealed\" Ability { id: \"5B6E\", source: \"Queen's Soldier\" }\r\n3130.6 \"Pawn Off\" Ability { id: \"5807\", source: \"Soldier Avatar\" }\r\n3142.4 \"Rapid Sever\" Ability { id: \"5809\", source: \"Queen's Soldier\" }\r\n\r\n3149.6 \"Double Gambit\" Ability { id: \"5805\", source: \"Queen's Soldier\" }\r\n3157.8 \"Secrets Revealed\" Ability { id: \"5B6E\", source: \"Queen's Soldier\" }\r\n3175.2 \"Pawn Off\" Ability { id: \"5807\", source: \"Soldier Avatar\" }\r\n3187.0 \"Blood And Bone\" Ability { id: \"5808\", source: \"Queen's Soldier\" }\r\n3197.2 \"Rapid Sever\" Ability { id: \"5809\", source: \"Queen's Soldier\" }\r\n\r\n# (probably a loop, as this has more jumping)\r\n3204.5 \"Double Gambit\" Ability { id: \"5805\", source: \"Queen's Soldier\" } window 30,30 jump 3149.6\r\n3212.7 \"Secrets Revealed\" #Ability { id: \"5B6E\", source: \"Queen's Soldier\" }\r\n3230.1 \"Pawn Off\" #Ability { id: \"5807\", source: \"Soldier Avatar\" }\r\n3241.9 \"Blood And Bone\" #Ability { id: \"5808\", source: \"Queen's Soldier\" }\r\n3252.1 \"Rapid Sever\" #Ability { id: \"5809\", source: \"Queen's Soldier\" }\r\n\r\n# Queen's Gunner\r\n# (local jumps to other blocks)\r\n3300.0 \"--sync--\" StartsUsing { id: \"5805\", source: \"Queen's Soldier\" } window 0,200 jump 3108.1\r\n3300.0 \"--sync--\" StartsUsing { id: \"5AFD\", source: \"Queen's Warrior\" } window 0,200 jump 3508.1\r\n3300.0 \"--sync--\" StartsUsing { id: \"57F[01]\", source: \"Queen's Knight\" } window 0,200 jump 3708.1\r\n\r\n3300.0 \"--targetable--\" NameToggle { name: \"Queen's Gunner\", toggle: \"01\" } window 500,500\r\n3308.1 \"--sync--\" StartsUsing { id: \"580B\", source: \"Queen's Gunner\" } window 10,10\r\n3311.1 \"Automatic Turret\" Ability { id: \"580B\", source: \"Queen's Gunner\" }\r\n3319.2 \"Turret's Tour\" Ability { id: \"580C\", source: \"Queen's Gunner\" }\r\n3319.8 \"Turret's Tour\" Ability { id: \"580E\", source: \"Automatic Turret\" }\r\n3320.3 \"Turret's Tour\" Ability { id: \"580F\", source: \"Automatic Turret\" }\r\n\r\n3329.3 \"Queen's Shot\" Ability { id: \"5810\", source: \"Queen's Gunner\" }\r\n3337.4 \"Automatic Turret\" Ability { id: \"580B\", source: \"Queen's Gunner\" }\r\n3345.6 \"Turret's Tour\" Ability { id: \"580C\", source: \"Queen's Gunner\" }\r\n3346.2 \"Turret's Tour\" Ability { id: \"580E\", source: \"Automatic Turret\" }\r\n3355.7 \"Shot In The Dark\" Ability { id: \"5811\", source: \"Queen's Gunner\" }\r\n\r\n# (probably a loop?)\r\n3364.9 \"Queen's Shot\" Ability { id: \"5810\", source: \"Queen's Gunner\" } window 20,20 jump 3329.3\r\n3373.0 \"Automatic Turret\" #Ability { id: \"580B\", source: \"Queen's Gunner\" }\r\n3381.2 \"Turret's Tour\" #Ability { id: \"580C\", source: \"Queen's Gunner\" }\r\n3381.8 \"Turret's Tour\" #Ability { id: \"580E\", source: \"Automatic Turret\" }\r\n3391.3 \"Shot In The Dark\" #Ability { id: \"5811\", source: \"Queen's Gunner\" }\r\n\r\n# Queen's Warrior\r\n# (local jumps to other blocks)\r\n3500.0 \"--sync--\" StartsUsing { id: \"5805\", source: \"Queen's Soldier\" } window 0,200 jump 3108.1\r\n3500.0 \"--sync--\" StartsUsing { id: \"580B\", source: \"Queen's Gunner\" } window 0,200 jump 3308.1\r\n3500.0 \"--sync--\" StartsUsing { id: \"57F[01]\", source: \"Queen's Knight\" } window 0,200 jump 3708.1\r\n\r\n3500.0 \"--targetable--\" NameToggle { name: \"Queen's Warrior\", toggle: \"01\" } window 500,500\r\n3508.1 \"--sync--\" StartsUsing { id: \"5AFD\", source: \"Queen's Warrior\" } window 10,10\r\n3511.1 \"Bombslinger\" Ability { id: \"5AFD\", source: \"Queen's Warrior\" }\r\n3520.2 \"Above Board\" Ability { id: \"57FC\", source: \"Queen's Warrior\" }\r\n3521.2 \"--stunned--\"\r\n3523.2 \"Lots Cast\" Ability { id: \"5B6B\", source: \"Aetherial Burst\" }\r\n3526.2 \"Lots Cast\" Ability { id: \"5B6A\", source: \"Aetherial Bolt\" }\r\n3527.9 \"--unstunned--\"\r\n\r\n3536.5 \"Bombslinger\" Ability { id: \"5AFD\", source: \"Queen's Warrior\" } window 10,10\r\n3543.6 \"Reversal Of Forces\" Ability { id: \"57FF\", source: \"Queen's Warrior\" }\r\n3552.7 \"Above Board\" Ability { id: \"57FC\", source: \"Queen's Warrior\" }\r\n3553.7 \"--stunned--\"\r\n3555.7 \"Lots Cast\" Ability { id: \"57FE\", source: \"Aetherial Bolt\" }\r\n3558.7 \"Lots Cast\" Ability { id: \"57FD\", source: \"Aetherial Burst\" }\r\n3559.4 \"--unstunned--\"\r\n3567.8 \"Blood And Bone\" Ability { id: \"5800\", source: \"Queen's Warrior\" }\r\n3578.0 \"Blood And Bone\" Ability { id: \"5800\", source: \"Queen's Warrior\" }\r\n\r\n# FIXME: is this a loop back to the beginning?\r\n# The Bombslinger/Above Board timings don't seem like there can fit\r\n# an optional Reversal Of Forces here, but not clear if this is random.\r\n3586.2 \"Bombslinger\" Ability { id: \"5AFD\", source: \"Queen's Warrior\" } window 30,30 jump 3511.1\r\n3595.3 \"Above Board\" #Ability { id: \"57FC\", source: \"Queen's Warrior\" }\r\n3596.3 \"--stunned--\"\r\n3598.3 \"Lots Cast\" #Ability { id: \"5B6B\", source: \"Aetherial Burst\" }\r\n3601.3 \"Lots Cast\" #Ability { id: \"5B6A\", source: \"Aetherial Bolt\" }\r\n3603.0 \"--unstunned--\"\r\n3614.6 \"Bombslinger\" #Ability { id: \"5AFD\", source: \"Queen's Warrior\" }\r\n3621.7 \"Reversal Of Forces\" #Ability { id: \"57FF\", source: \"Queen's Warrior\" }\r\n\r\n# Queen's Knight\r\n# (local jumps to other blocks)\r\n3700.0 \"--sync--\" StartsUsing { id: \"5805\", source: \"Queen's Soldier\" } window 0,200 jump 3108.1\r\n3700.0 \"--sync--\" StartsUsing { id: \"580B\", source: \"Queen's Gunner\" } window 0,200 jump 3308.1\r\n3700.0 \"--sync--\" StartsUsing { id: \"5AFD\", source: \"Queen's Warrior\" } window 0,200 jump 3508.1\r\n\r\n3700.0 \"--targetable--\" NameToggle { name: \"Queen's Knight\", toggle: \"01\" } window 500,500\r\n3708.1 \"--sync--\" StartsUsing { id: \"57F[01]\", source: \"Queen's Knight\" } window 10,10\r\n3711.1 \"Shield Omen/Sword Omen\" Ability { id: \"57F[01]\", source: \"Queen's Knight\" }\r\n3719.3 \"Optimal Play\" Ability { id: \"57F4\", source: \"Queen's Knight\" }\r\n3727.5 \"Sword Omen/Shield Omen\" Ability { id: \"57F[01]\", source: \"Queen's Knight\" }\r\n3735.7 \"Optimal Play\" Ability { id: \"57F4\", source: \"Queen's Knight\" }\r\n\r\n3746.9 \"Rapid Sever\" Ability { id: \"57FB\", source: \"Queen's Knight\" }\r\n3756.1 \"Blood And Bone\" Ability { id: \"57FA\", source: \"Queen's Knight\" }\r\n3764.3 \"Shield Omen/Sword Omen\" Ability { id: \"57F[01]\", source: \"Queen's Knight\" }\r\n3772.5 \"Optimal Play\" Ability { id: \"57F4\", source: \"Queen's Knight\" }\r\n3780.7 \"Sword Omen/Shield Omen\" Ability { id: \"57F[01]\", source: \"Queen's Knight\" }\r\n3788.9 \"Optimal Play\" Ability { id: \"57F4\", source: \"Queen's Knight\" }\r\n\r\n# (maybe a loop?)\r\n3800.1 \"Rapid Sever\" Ability { id: \"57FB\", source: \"Queen's Knight\" } window 30,30 jump 3746.9\r\n3809.3 \"Blood And Bone\" #Ability { id: \"57FA\", source: \"Queen's Knight\" }\r\n3817.5 \"Shield Omen/Sword Omen\" #Ability { id: \"57F[01]\", source: \"Queen's Knight\" }\r\n3825.7 \"Optimal Play\" #Ability { id: \"57F4\", source: \"Queen's Knight\" }\r\n3833.9 \"Sword Omen/Shield Omen\" #Ability { id: \"57F[01]\", source: \"Queen's Knight\" }\r\n3842.1 \"Optimal Play\" #Ability { id: \"57F4\", source: \"Queen's Knight\" }\r\n\r\n# Aetherial Warded Knights\r\n4000.0 \"--sync--\" StartsUsing { id: \"57F5\", source: \"Queen's Knight\" } window 1000,0\r\n4005.0 \"Strongpoint Defense\" Ability { id: \"57F5\", source: \"Queen's Knight\" }\r\n# 60s enrage cast of 5812, 580A, 5802, 57F9\r\n4008.0 \"Enrage Cast\" StartsUsing { id: \"5812\", source: \"Queen's Gunner\" } duration 60\r\n4018.8 \"Coat Of Arms\" Ability { id: \"57F6\", source: \"Aetherial Ward\" }\r\n4036.0 \"Coat Of Arms\" Ability { id: \"57F6\", source: \"Aetherial Ward\" }\r\n4053.1 \"Coat Of Arms\" Ability { id: \"57F6\", source: \"Aetherial Ward\" }\r\n4068.0 \"Enrage\"\r\n\r\n\r\n### Bozjan Phantom\r\n# -p 57A3:5011.3\r\n# (no -ii, a refreshingly direct timeline)\r\n# Pride of the Lion will be sealed off\r\n5000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E1F\" } window 10000,0\r\n\r\n# one circle, one square\r\n5008.3 \"--sync--\" StartsUsing { id: \"57A3\", source: \"Bozjan Phantom\" } window 10,10\r\n5011.3 \"Weave Miasma\" Ability { id: \"57A3\", source: \"Bozjan Phantom\" }\r\n5025.5 \"Manipulate Miasma\" Ability { id: \"57A4\", source: \"Bozjan Phantom\" }\r\n5026.5 \"Swirling Miasma 1\" Ability { id: \"57A9\", source: \"Bozjan Phantom\" }\r\n5028.1 \"Swirling Miasma 2\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5029.7 \"Swirling Miasma 3\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5030.5 \"Creeping Miasma\" Ability { id: \"57A5\", source: \"Bozjan Phantom\" }\r\n5031.3 \"Swirling Miasma 4\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5032.9 \"Swirling Miasma 5\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5034.5 \"Swirling Miasma 6\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5036.1 \"Swirling Miasma 7\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5037.7 \"Swirling Miasma 8\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n\r\n# two circles, two squares\r\n5038.6 \"Malediction Of Agony\" Ability { id: \"57AF\", source: \"Bozjan Phantom\" }\r\n5049.8 \"Weave Miasma\" Ability { id: \"57A3\", source: \"Bozjan Phantom\" }\r\n5064.0 \"Manipulate Miasma\" Ability { id: \"57A4\", source: \"Bozjan Phantom\" }\r\n5065.0 \"Swirling Miasma 1\" Ability { id: \"57A9\", source: \"Bozjan Phantom\" }\r\n5066.6 \"Swirling Miasma 2\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5068.2 \"Swirling Miasma 3\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5069.0 \"Creeping Miasma\" Ability { id: \"57A5\", source: \"Bozjan Phantom\" }\r\n5069.8 \"Swirling Miasma 4\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5071.4 \"Swirling Miasma 5\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5073.0 \"Swirling Miasma 6\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5074.6 \"Swirling Miasma 7\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5076.2 \"Swirling Miasma 8\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n\r\n# learn about knockbacks\r\n5083.1 \"Summon\" Ability { id: \"57AB\", source: \"Bozjan Phantom\" }\r\n5095.2 \"Undying Hatred\" Ability { id: \"57AC\", source: \"Stuffy Wraith\" }\r\n5096.3 \"Transference\" Ability { id: \"57AD\", source: \"Bozjan Phantom\" }\r\n5103.5 \"Vile Wave\" Ability { id: \"57B1\", source: \"Bozjan Phantom\" }\r\n\r\n# knockback into weave miasma\r\n5114.7 \"Weave Miasma\" Ability { id: \"57A3\", source: \"Bozjan Phantom\" }\r\n5120.8 \"Summon\" Ability { id: \"57AB\", source: \"Bozjan Phantom\" }\r\n5132.9 \"Undying Hatred\" Ability { id: \"57AC\", source: \"Stuffy Wraith\" }\r\n5137.0 \"Manipulate Miasma\" Ability { id: \"57A4\", source: \"Bozjan Phantom\" }\r\n5138.0 \"Swirling Miasma 1\" Ability { id: \"57A9\", source: \"Bozjan Phantom\" }\r\n5139.6 \"Swirling Miasma 2\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5141.2 \"Swirling Miasma 3\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5142.0 \"Creeping Miasma\" Ability { id: \"57A5\", source: \"Bozjan Phantom\" }\r\n5142.8 \"Swirling Miasma 4\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5144.4 \"Swirling Miasma 5\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5146.0 \"Swirling Miasma 6\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5147.1 \"Transference\" Ability { id: \"57AD\", source: \"Bozjan Phantom\" }\r\n5147.6 \"Swirling Miasma 7\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5149.2 \"Swirling Miasma 8\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5154.4 \"Vile Wave\" Ability { id: \"57B1\", source: \"Bozjan Phantom\" }\r\n\r\n5162.5 \"Malediction Of Agony\" Ability { id: \"57AF\", source: \"Bozjan Phantom\" }\r\n5175.7 \"Excruciation\" Ability { id: \"57B0\", source: \"Bozjan Phantom\" }\r\n5184.8 \"Malediction Of Agony\" Ability { id: \"57AF\", source: \"Bozjan Phantom\" }\r\n5191.9 \"Malediction Of Agony\" Ability { id: \"57AF\", source: \"Bozjan Phantom\" }\r\n\r\n# loop\r\n5205.1 \"Weave Miasma\" Ability { id: \"57A3\", source: \"Bozjan Phantom\" } window 50,50 jump 5114.7\r\n5211.2 \"Summon\" #Ability { id: \"57AB\", source: \"Bozjan Phantom\" }\r\n5223.3 \"Undying Hatred\" #Ability { id: \"57AC\", source: \"Stuffy Wraith\" }\r\n5227.4 \"Manipulate Miasma\" #Ability { id: \"57A4\", source: \"Bozjan Phantom\" }\r\n5228.4 \"Swirling Miasma 1\" #Ability { id: \"57A9\", source: \"Bozjan Phantom\" }\r\n5230.0 \"Swirling Miasma 2\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5231.6 \"Swirling Miasma 3\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5232.4 \"Creeping Miasma\" #Ability { id: \"57A5\", source: \"Bozjan Phantom\" }\r\n5233.2 \"Swirling Miasma 4\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5234.8 \"Swirling Miasma 5\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n5236.4 \"Swirling Miasma 6\" #Ability { id: \"57AA\", source: \"Bozjan Phantom\" }\r\n\r\n\r\n### Trinity Avowed\r\n# -p 5975:7013\r\n# -ii 5962 4F55 4F99 5B24 5968 4F56 4F9A 5964 5969 5965 5967 596A 596C\r\n# The Vault of Singing Crystal will be sealed off\r\n7000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E20\" } window 10000,0\r\n7008.0 \"--sync--\" StartsUsing { id: \"5975\", source: \"Trinity Avowed\" } window 10,10\r\n7013.0 \"Wrath Of Bozja\" Ability { id: \"5975\", source: \"Trinity Avowed\" }\r\n7021.1 \"Glory Of Bozja\" Ability { id: \"5976\", source: \"Trinity Avowed\" }\r\n7029.3 \"Allegiant Arsenal\" Ability { id: \"5987\", source: \"Trinity Avowed\" }\r\n7037.5 \"Fury Of Bozja\" Ability { id: \"5973\", source: \"Trinity Avowed\" }\r\n\r\n# meteors, 1 level of temperature\r\n7046.8 \"Hot And Cold\" Ability { id: \"597B\", source: \"Trinity Avowed\" }\r\n7053.9 \"Freedom Of Bozja\" Ability { id: \"597C\", source: \"Trinity Avowed\" }\r\n7061.1 \"Elemental Impact\" Ability { id: \"5960\", source: \"Swirling Orb\" }\r\n7070.1 \"Elemental Blast\" Ability { id: \"5966\", source: \"Blazing Orb\" }\r\n7077.0 \"--sync--\" Ability { id: \"5984\", source: \"Trinity Avowed\" }\r\n\r\n7087.5 \"Allegiant Arsenal\" Ability { id: \"5986\", source: \"Trinity Avowed\" }\r\n7095.7 \"Flashvane\" Ability { id: \"5972\", source: \"Trinity Avowed\" }\r\n\r\n# swords, 1 level of temperature\r\n7103.9 \"Flames Of Bozja\" Ability { id: \"597E\", source: \"Trinity Avowed\" } duration 8\r\n7112.0 \"--sync--\" Ability { id: \"5B39\", source: \"Trinity Avowed\" }\r\n7117.1 \"Hot And Cold\" Ability { id: \"5BB0\", source: \"Trinity Avowed\" }\r\n7124.9 \"Shimmering Shot\" Ability { id: \"597F\", source: \"Trinity Avowed\" }\r\n7139.2 \"Elemental Arrow\" Ability { id: \"596B\", source: \"Frost Arrow\" }\r\n7147.8 \"--sync--\" Ability { id: \"5983\", source: \"Trinity Avowed\" }\r\n\r\n7154.9 \"Glory Of Bozja\" Ability { id: \"5976\", source: \"Trinity Avowed\" }\r\n7168.1 \"Allegiant Arsenal\" Ability { id: \"5985\", source: \"Trinity Avowed\" }\r\n7176.3 \"Infernal Slash\" Ability { id: \"5971\", source: \"Trinity Avowed\" }\r\n\r\n# cleaves, 2 levels of temperature\r\n7182.5 \"Hot And Cold\" Ability { id: \"5BAF\", source: \"Trinity Avowed\" }\r\n7193.7 \"Blade Of Entropy\" Ability { id: [\"5B6[5-8]\", \"596[D-F]\", \"5970\"], source: \"Trinity Avowed\" }\r\n7201.9 \"Blade Of Entropy\" Ability { id: [\"5B6[5-8]\", \"596[D-F]\", \"5970\"], source: \"Trinity Avowed\" }\r\n7210.0 \"Blade Of Entropy\" Ability { id: [\"5B6[5-8]\", \"596[D-F]\", \"5970\"], source: \"Trinity Avowed\" }\r\n7218.2 \"Blade Of Entropy\" Ability { id: [\"5B6[5-8]\", \"596[D-F]\", \"5970\"], source: \"Trinity Avowed\" }\r\n\r\n7221.3 \"--sync--\" Ability { id: \"5982\", source: \"Trinity Avowed\" }\r\n7227.4 \"Unseen Eye\" Ability { id: \"5980\", source: \"Trinity Avowed\" }\r\n7238.7 \"Gleaming Arrow\" Ability { id: \"5974\", source: \"Avowed Avatar\" }\r\n\r\n7246.3 \"Wrath Of Bozja\" Ability { id: \"5975\", source: \"Trinity Avowed\" }\r\n7254.4 \"Glory Of Bozja\" Ability { id: \"5976\", source: \"Trinity Avowed\" }\r\n7264.8 \"Allegiant Arsenal\" Ability { id: \"5987\", source: \"Trinity Avowed\" }\r\n7273.0 \"Fury Of Bozja\" Ability { id: \"5973\", source: \"Trinity Avowed\" }\r\n\r\n# meteors, 2 levels of temperature\r\n7279.2 \"Hot And Cold\" Ability { id: \"597B\", source: \"Trinity Avowed\" }\r\n7286.3 \"Freedom Of Bozja\" Ability { id: \"597C\", source: \"Trinity Avowed\" }\r\n7293.5 \"Elemental Impact\" Ability { id: \"5960\", source: \"Tempestuous Orb\" }\r\n7302.5 \"Heated Blast\" Ability { id: \"5966\", source: \"Blazing Orb\" }\r\n\r\n7304.9 \"Unseen Eye\" Ability { id: \"5980\", source: \"Trinity Avowed\" }\r\n7316.2 \"Gleaming Arrow\" Ability { id: \"5974\", source: \"Avowed Avatar\" }\r\n7318.7 \"--sync--\" Ability { id: \"5984\", source: \"Trinity Avowed\" }\r\n7325.8 \"Glory Of Bozja\" Ability { id: \"5976\", source: \"Trinity Avowed\" }\r\n7334.2 \"Wrath Of Bozja\" Ability { id: \"5975\", source: \"Trinity Avowed\" }\r\n7345.1 \"Allegiant Arsenal\" Ability { id: \"5986\", source: \"Trinity Avowed\" }\r\n7353.3 \"Flashvane\" Ability { id: \"5972\", source: \"Trinity Avowed\" }\r\n7359.5 \"Unseen Eye\" Ability { id: \"5BB4\", source: \"Trinity Avowed\" }\r\n7370.8 \"Gleaming Arrow\" Ability { id: \"5974\", source: \"Avowed Avatar\" }\r\n7370.8 \"Flames Of Bozja\" Ability { id: \"597E\", source: \"Trinity Avowed\" } duration 8\r\n7379.0 \"--sync--\" Ability { id: \"5B39\", source: \"Trinity Avowed\" }\r\n\r\n# swords, 2 levels of temperature\r\n7383.8 \"Hot And Cold\" Ability { id: \"5BB0\", source: \"Trinity Avowed\" }\r\n7391.4 \"Shimmering Shot\" Ability { id: \"597F\", source: \"Trinity Avowed\" }\r\n7405.7 \"Elemental Arrow\" Ability { id: \"596B\", source: \"Frost Arrow\" }\r\n7411.0 \"--sync--\" Ability { id: \"5983\", source: \"Trinity Avowed\" }\r\n\r\n7418.1 \"Glory Of Bozja\" Ability { id: \"5976\", source: \"Trinity Avowed\" }\r\n7426.4 \"Wrath Of Bozja\" Ability { id: \"5975\", source: \"Trinity Avowed\" }\r\n7434.5 \"Glory Of Bozja\" Ability { id: \"5976\", source: \"Trinity Avowed\" }\r\n7449.7 \"Allegiant Arsenal\" Ability { id: \"5985\", source: \"Trinity Avowed\" }\r\n7457.8 \"Infernal Slash\" Ability { id: \"5971\", source: \"Trinity Avowed\" }\r\n\r\n# (probably a loop, back to cleaves, 2 levels of temperature)\r\n7463.9 \"Hot And Cold\" Ability { id: \"5BAF\", source: \"Trinity Avowed\" } window 100,100 jump 7182.5\r\n7475.1 \"Blade Of Entropy\" #Ability { id: [\"5B6[5-8]\", \"596[D-F]\", \"5970\"], source: \"Trinity Avowed\" }\r\n7483.3 \"Blade Of Entropy\" #Ability { id: [\"5B6[5-8]\", \"596[D-F]\", \"5970\"], source: \"Trinity Avowed\" }\r\n7491.4 \"Blade Of Entropy\" #Ability { id: [\"5B6[5-8]\", \"596[D-F]\", \"5970\"], source: \"Trinity Avowed\" }\r\n7499.6 \"Blade Of Entropy\" #Ability { id: [\"5B6[5-8]\", \"596[D-F]\", \"5970\"], source: \"Trinity Avowed\" }\r\n\r\n\r\n### The Queen\r\n# -it \"The Queen\"\r\n# -p 59C8:9015.5\r\n# -ii 5B83 5B82 59E0 59E2 59DA 59CC 5B40 59CD 5B8D\r\n# Queensheart will be sealed off\r\n9000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E23\" } window 10000,0\r\n9010.5 \"--sync--\" StartsUsing { id: \"59C8\", source: \"The Queen\" } window 15,15\r\n9015.5 \"Empyrean Iniquity\" Ability { id: \"59C8\", source: \"The Queen\" }\r\n9025.7 \"Cleansing Slash\" Ability { id: \"59C5\", source: \"The Queen\" }\r\n9036.0 \"--middle--\" Ability { id: \"5BCB\", source: \"The Queen\" }\r\n\r\n9044.2 \"Queen's Will\" Ability { id: \"59B9\", source: \"The Queen\" }\r\n9052.4 \"Beck And Call To Arms\" Ability { id: \"5B99\", source: \"The Queen\" }\r\n9056.7 \"The Means\" Ability { id: \"59B[BD]\", source: [\"Queen's Gunner\", \"Queen's Warrior\"] }\r\n9056.7 \"The Ends\" Ability { id: \"59B[AC]\", source: [\"Queen's Soldier\", \"Queen's Knight\"] }\r\n\r\n9066.6 \"Empyrean Iniquity\" Ability { id: \"59C8\", source: \"The Queen\" }\r\n9074.8 \"--middle--\" Ability { id: \"5BCB\", source: \"The Queen\" }\r\n9081.2 \"Northswain's Glow\" Ability { id: \"59C3\", source: \"The Queen\" }\r\n9092.0 \"--explosion--\" Ability { id: \"59C4\", source: \"The Queen\" }\r\n9094.4 \"Heaven's Wrath\" Ability { id: \"59C6\", source: \"The Queen\" }\r\n9102.2 \"--knockback--\" Ability { id: \"59C7\", source: \"The Queen\" }\r\n9112.6 \"Cleansing Slash\" Ability { id: \"59C5\", source: \"The Queen\" }\r\n9123.9 \"--middle--\" Ability { id: \"5BCB\", source: \"The Queen\" }\r\n\r\n9132.1 \"Queen's Will\" Ability { id: \"59B9\", source: \"The Queen\" }\r\n9140.2 \"Beck And Call To Arms\" Ability { id: \"5B99\", source: \"The Queen\" }\r\n9143.3 \"--untargetable--\"\r\n9144.5 \"The Means\" Ability { id: \"59B[BD]\", source: [\"Queen's Gunner\", \"Queen's Warrior\"] }\r\n9144.5 \"The Ends\" Ability { id: \"59B[AC]\", source: [\"Queen's Soldier\", \"Queen's Knight\"] }\r\n9151.5 \"Judgment Blade\" Ability { id: \"59C[12]\", source: \"The Queen\" }\r\n9156.2 \"--targetable--\"\r\n\r\n# HP% push here.\r\n9160.5 \"--middle--\" Ability { id: \"5BCB\", source: \"The Queen\" }\r\n9163.9 \"--sync--\" Ability { id: \"55A8\", source: \"The Queen\" } window 200,10\r\n9171.0 \"Gods Save The Queen\" Ability { id: \"59C9\", source: \"The Queen\" }\r\n9192.3 \"--middle--\" Ability { id: \"5BCB\", source: \"The Queen\" }\r\n9200.7 \"Queen's Edict\" Ability { id: \"59BE\", source: \"The Queen\" }\r\n9223.4 \"--stunned--\"\r\n9225.5 \"Queen's Justice\" Ability { id: \"59BF\", source: \"The Queen\" } # only on failure\r\n9229.3 \"--unstunned--\"\r\n9239.9 \"Cleansing Slash\" Ability { id: \"59C5\", source: \"The Queen\" }\r\n\r\n9253.1 \"Relentless Play\" Ability { id: \"59FC\", source: \"The Queen\" }\r\n9259.3 \"Automatic Turret\" Ability { id: \"59DE\", source: \"Queen's Gunner\" }\r\n9267.3 \"Bombslinger\" Ability { id: \"5B3E\", source: \"Queen's Warrior\" }\r\n9267.4 \"Turret's Tour\" Ability { id: \"59DF\", source: \"Queen's Gunner\" }\r\n9268.0 \"Turret's Tour\" Ability { id: \"59E1\", source: \"Automatic Turret\" }\r\n9271.2 \"Heaven's Wrath\" Ability { id: \"59C6\", source: \"The Queen\" }\r\n9274.3 \"Reversal Of Forces?\" Ability { id: \"59D4\", source: \"Queen's Warrior\" }\r\n9279.0 \"--knockback--\" Ability { id: \"59C7\", source: \"The Queen\" }\r\n9283.5 \"Above Board\" Ability { id: \"59D1\", source: \"Queen's Warrior\" }\r\n9284.5 \"--stunned--\"\r\n# Note: these can be in either order, so can't sync.\r\n9286.5 \"Lots Cast\" #Ability { id: [\"59D3\", \"5B86\"], source: \"Aetherial Bolt\" }\r\n9289.5 \"Lots Cast\" #Ability { id: [\"59D2\", \"5B87\"], source: \"Aetherial Burst\" }\r\n9291.2 \"--unstunned--\"\r\n\r\n9300.4 \"Empyrean Iniquity\" Ability { id: \"59C8\", source: \"The Queen\" }\r\n9308.6 \"--middle--\" Ability { id: \"5BCB\", source: \"The Queen\" }\r\n9316.8 \"Queen's Edict\" Ability { id: \"59BE\", source: \"The Queen\" }\r\n9338.0 \"Beck And Call To Arms\" Ability { id: \"5B99\", source: \"The Queen\" }\r\n9339.5 \"--stunned--\"\r\n9341.7 \"Queen's Justice\" Ability { id: \"59BF\", source: \"Queen's Warrior\" } # only on failure\r\n9342.4 \"The Means\" Ability { id: \"59B[BD]\", source: [\"Queen's Gunner\", \"Queen's Warrior\"] }\r\n9342.4 \"The Ends\" Ability { id: \"59B[AC]\", source: [\"Queen's Soldier\", \"Queen's Knight\"] }\r\n9345.4 \"--unstunned--\"\r\n9354.5 \"Cleansing Slash\" Ability { id: \"59C5\", source: \"The Queen\" }\r\n\r\n9367.7 \"Relentless Play\" Ability { id: \"59FC\", source: \"The Queen\" }\r\n9373.8 \"Double Gambit\" Ability { id: \"59D9\", source: \"Queen's Soldier\" }\r\n9382.0 \"Secrets Revealed\" Ability { id: \"5B8A\", source: \"Queen's Soldier\" }\r\n9382.1 \"--sync--\" Ability { id: \"5B8C\", source: \"Soldier Avatar\" }\r\n9388.9 \"--untargetable--\"\r\n9391.9 \"Pawn Off\" Ability { id: \"59DB\", source: \"Soldier Avatar\" }\r\n9397.1 \"Judgment Blade\" Ability { id: \"59C[12]\", source: \"The Queen\" }\r\n9397.9 \"Sword Omen/Shield Omen\" Ability { id: \"59C[AB]\", source: \"Queen's Knight\" }\r\n9401.9 \"--targetable--\"\r\n9406.1 \"Optimal Play\" Ability { id: \"59CE\", source: \"Queen's Knight\" }\r\n\r\n9415.0 \"Empyrean Iniquity\" Ability { id: \"59C8\", source: \"The Queen\" }\r\n9423.2 \"--sync--\" Ability { id: \"5BCB\", source: \"The Queen\" }\r\n9429.4 \"Northswain's Glow\" Ability { id: \"59C3\", source: \"The Queen\" }\r\n9437.6 \"Queen's Will\" Ability { id: \"59B9\", source: \"The Queen\" }\r\n9440.2 \"--explosion--\" Ability { id: \"59C4\", source: \"The Queen\" }\r\n9445.7 \"Beck And Call To Arms\" Ability { id: \"5B99\", source: \"The Queen\" }\r\n9450.0 \"The Means\" Ability { id: \"59B[BD]\", source: [\"Queen's Gunner\", \"Queen's Warrior\"] }\r\n9450.0 \"The Ends\" Ability { id: \"59B[AC]\", source: [\"Queen's Soldier\", \"Queen's Knight\"] }\r\n9459.9 \"Cleansing Slash\" Ability { id: \"59C5\", source: \"The Queen\" }\r\n\r\n9473.1 \"Relentless Play\" Ability { id: \"59FC\", source: \"The Queen\" } window 50,50 jump 9253.1\r\n9479.3 \"Automatic Turret\" #Ability { id: \"59DE\", source: \"Queen's Gunner\" }\r\n9487.3 \"Bombslinger\" #Ability { id: \"5B3E\", source: \"Queen's Warrior\" }\r\n9487.4 \"Turret's Tour\" #Ability { id: \"59DF\", source: \"Queen's Gunner\" }\r\n9488.0 \"Turret's Tour\" #Ability { id: \"59E1\", source: \"Automatic Turret\" }\r\n9491.2 \"Heaven's Wrath\" #Ability { id: \"59C6\", source: \"The Queen\" }\r\n9494.3 \"Reversal Of Forces?\" #Ability { id: \"59D4\", source: \"Queen's Warrior\" }\r\n9499.0 \"--knockback--\" #Ability { id: \"59C7\", source: \"The Queen\" }\r\n9503.5 \"Above Board\" #Ability { id: \"59D1\", source: \"Queen's Warrior\" }\r\n9504.5 \"--stunned--\"\r\n9506.5 \"Lots Cast\" #Ability { id: [\"59D3\", \"5B86\"], source: \"Aetherial Bolt\" }\r\n9509.5 \"Lots Cast\" #Ability { id: [\"59D2\", \"5B87\"], source: \"Aetherial Burst\" }\r\n9511.2 \"--unstunned--\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/eureka/delubrum_reginae_savage.ts






// TODO: warnings for mines after bosses?
// TODO: headmarkers of course have a random offset here eyeroll
const headmarker = {
  mercifulArc: '00F3',
  burningChains: '00EE',
  earthshaker: '00ED',
  spitFlame1: '004F',
  spitFlame2: '0050',
  spitFlame3: '0051',
  spitFlame4: '0052',
  flare: '0057',
  reversal: '00FF',
  // also tether 0087
  spiteSmite: '0017',
  wrath: '0100',
  foeSplitter: '00C6',
  thunder: '00A0',
  edictSuccess: '0088',
  edictFailure: '0089'
};
const delubrum_reginae_savage_seekerCenterX = -0.01531982;
const delubrum_reginae_savage_seekerCenterY = 277.9735;
const delubrum_reginae_savage_avowedCenterX = -272;
const delubrum_reginae_savage_avowedCenterY = -82;

// TODO: promote something like this to Conditions?
const delubrum_reginae_savage_tankBusterOnParty = (data, matches) => {
  if (matches.target === data.me) return true;
  if (data.role !== 'healer') return false;
  return data.party.inParty(matches.target);
};

// Due to changes introduced in patch 5.2, overhead markers now have a random offset
// added to their ID. This offset currently appears to be set per instance, so
// we can determine what it is from the first overhead marker we see.
const getHeadmarkerId = (data, matches) => {
  if (data.decOffset === undefined) {
    // If we don't know, return garbage to avoid accidentally running other triggers.
    if (data.firstUnknownHeadmarker === undefined) return '0000';
    data.decOffset = parseInt(matches.id, 16) - parseInt(data.firstUnknownHeadmarker, 16);
  }
  // The leading zeroes are stripped when converting back to string, so we re-add them here.
  const hexId = (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase();
  return `000${hexId}`.slice(-4);
};
const delubrum_reginae_savage_triggerSet = {
  id: 'DelubrumReginaeSavage',
  zoneId: zone_id/* default.DelubrumReginaeSavage */.Z.DelubrumReginaeSavage,
  timelineFile: 'delubrum_reginae_savage.txt',
  timelineTriggers: [{
    id: 'DelubrumSav Seeker Baleful Comet',
    regex: /Baleful Comet 1/,
    beforeSeconds: 8,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // Comets have impact damage when dropping, so warn to avoid this.
        en: 'Get in for comets',
        de: 'Geh rein für Kometen',
        fr: 'Entrez pour les comètes',
        ja: '中で避ける',
        cn: '中间躲避',
        ko: '중앙에서 운석 맞기'
      }
    }
  }, {
    id: 'DelubrumSav Avowed Glory Of Bozja',
    regex: /Glory Of Bozja(?! Enrage)/,
    // Cast itself is 5.5 seconds, add more warning
    beforeSeconds: 8,
    // Count the number of Glory of Bozja so that people alternating mitigation
    // can more easily assign themselves to even or odd glories.
    preRun: data => data.gloryOfBozjaCount = (data.gloryOfBozjaCount ?? 0) + 1,
    durationSeconds: 8,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => output.aoeNum({
      num: data.gloryOfBozjaCount
    }),
    outputStrings: {
      aoeNum: {
        en: 'Big AOE + Bleed (#${num})',
        de: 'Große AoE + Blutung (#${num})',
        fr: 'Grosse AoE + Saignement (#${num})',
        ja: '全体攻撃 + 継続ダメージ (#${num})',
        cn: '高伤AoE + DoT (#${num})',
        ko: '쌘 광역 + 도트딜 (#${num})'
      }
    }
  }, {
    id: 'DelubrumSav Lord Vicious Swipe',
    regex: /Vicious Swipe/,
    // There are different timings in the first and second phase.
    // Consistently use 5 seconds beforehand for both.
    beforeSeconds: 5,
    suppressSeconds: 1,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'DelubrumSav Lord Thunderous Discharge',
    regex: /Thunderous Discharge/,
    // Cast in the timeline is 5 seconds, but there is an additional .5 second cast before damage
    beforeSeconds: 7,
    suppressSeconds: 1,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'DelubrumSav Queen Empyrean Iniquity',
    regex: /Empyrean Iniquity/,
    // Cast itself is 5 seconds, add more warning
    beforeSeconds: 9,
    durationSeconds: 9,
    suppressSeconds: 1,
    response: responses/* Responses.bigAoe */.n3.bigAoe('alert')
  }, {
    id: 'DelubrumSav Queen Gods Save The Queen',
    regex: /Gods Save The Queen$/,
    // Cast in the timeline is 5 seconds, but there is an additional 1 second cast before damage
    beforeSeconds: 7,
    durationSeconds: 5,
    suppressSeconds: 1,
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  triggers: [{
    id: 'DelubrumSav Seeker Phase',
    type: 'StartsUsing',
    // Sets the phase when seeing the Verdant Tempest cast.
    netRegex: {
      source: 'Trinity Seeker',
      id: '5AD3',
      capture: false
    },
    // Note: this headmarker *could* be skipped, so we will change this later.
    run: data => data.firstUnknownHeadmarker = headmarker.mercifulArc
  }, {
    id: 'DelubrumSav Seeker Verdant Tempest',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Seeker',
      id: '5AD3',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'DelubrumSav Seeker Sword Cleanup',
    type: 'StartsUsing',
    // This is on First Mercy, which starts before the first ability.
    netRegex: {
      source: ['Trinity Seeker', 'Seeker Avatar'],
      id: '5B61',
      capture: false
    },
    run: data => {
      delete data.seekerSwords;
      delete data.calledSeekerSwords;
      delete data.seekerFirstMercy;
    }
  }, {
    id: 'DelubrumSav Seeker First Mercy',
    type: 'Ability',
    netRegex: {
      source: ['Trinity Seeker', 'Seeker Avatar'],
      id: '5B61'
    },
    run: (data, matches) => data.seekerFirstMercy = matches
  }, {
    id: 'DelubrumSav Seeker Mercy Swords',
    type: 'GainsEffect',
    netRegex: {
      target: ['Trinity Seeker', 'Seeker Avatar'],
      effectId: '808'
    },
    condition: data => !data.calledSeekerSwords,
    durationSeconds: 10,
    alertText: (data, matches, output) => {
      data.seekerSwords ??= [];
      data.seekerSwords.push(matches.count.toUpperCase());
      if (data.seekerSwords.length <= 1 || data.seekerSwords.length >= 4) return;
      if (!data.seekerFirstMercy) {
        console.error(`Swords: missing first mercy`);
        return;
      }
      const posX = parseFloat(data.seekerFirstMercy.x) - delubrum_reginae_savage_seekerCenterX;
      const posY = parseFloat(data.seekerFirstMercy.y) - delubrum_reginae_savage_seekerCenterY;
      const isClone = Math.hypot(posX, posY) > 10;
      // 0 = N, 1 = E, etc
      const pos = Math.round(2 - 2 * Math.atan2(posX, posY) / Math.PI) % 4;
      const heading = Math.round(2 - 2 * parseFloat(data.seekerFirstMercy.heading) / Math.PI) % 4;
      const cleaves = data.seekerSwords;

      // For boss, rotate so that front = cardinal north.
      // For clones, rotate so that front/north = out.
      const rotateDir = dir => (4 + dir - (isClone ? pos : 0) + heading) % 4;

      // Seen two cleaves, is this enough information to call??
      // If no, we will wait until we have seen the third.
      if (data.seekerSwords.length === 2) {
        // Named constants for readability.
        const dir = {
          north: 0,
          east: 1,
          south: 2,
          west: 3
        };

        // Find boss-relative safe zones.
        const cleavetoSafeZones = {
          // Front right cleave.
          F7: [dir.south, dir.west],
          // Back right cleave.
          F8: [dir.west, dir.north],
          // Front left cleave.
          F9: [dir.east, dir.south],
          // Back left cleave.
          FA: [dir.north, dir.east]
        };
        const cleave0 = cleaves[0];
        const cleave1 = cleaves[1];
        if (cleave0 === undefined || cleave1 === undefined) throw new not_reached/* UnreachableCode */.$();
        const first = cleavetoSafeZones[cleave0];
        const second = cleavetoSafeZones[cleave1];
        if (first === undefined || second === undefined) throw new not_reached/* UnreachableCode */.$();
        const intersect = first.filter(safe => second.includes(safe));
        if (intersect.length === 2) {
          console.error(`Sword: weird intersect: ${JSON.stringify(data.seekerSwords)}`);
          return;
        }
        // This is a bad pattern.  Need to wait for three swords.
        if (intersect.length === 0) return;
        const singleSafeZone = intersect[0];
        if (singleSafeZone === undefined) throw new not_reached/* UnreachableCode */.$();
        const cardinal = rotateDir(singleSafeZone);
        if (isClone) {
          // Trinity Seeker has a lot of limbs and people have a VERY hard time with
          // left vs right at the best of times.  Use "in and out" here on the clone
          // to make sure this doesn't get messed up.  This may mean that there is a
          // simpler left->right pattern that could be called, but we're ignoring it
          // for clarity of communication.
          if (cardinal === dir.north) {
            data.calledSeekerSwords = true;
            return output.double({
              dir1: output.out(),
              dir2: output.in()
            });
          } else if (cardinal === dir.south) {
            data.calledSeekerSwords = true;
            return output.double({
              dir1: output.in(),
              dir2: output.out()
            });
          }

          // We'll call it the hard way.
          return;
        }
        data.calledSeekerSwords = true;
        if (cardinal === dir.north) return output.double({
          dir1: output.north(),
          dir2: output.south()
        });
        if (cardinal === dir.east) return output.double({
          dir1: output.east(),
          dir2: output.west()
        });
        if (cardinal === dir.south) return output.double({
          dir1: output.south(),
          dir2: output.north()
        });
        if (cardinal === dir.west) return output.double({
          dir1: output.west(),
          dir2: output.east()
        });
        // Or not?
        data.calledSeekerSwords = false;
        return;
      }

      // Find the cleave we're missing and add it to the list.
      const finalCleaveList = ['F7', 'F8', 'F9', 'FA'].filter(id => !cleaves.includes(id));
      const finalCleave = finalCleaveList[0];
      if (finalCleave === undefined || finalCleaveList.length !== 1) {
        console.error(`Swords: bad intersection ${JSON.stringify(data.seekerSwords)}`);
        return;
      }
      cleaves.push(finalCleave);

      // Seen three clones, which means we weren't able to call with two.
      // Try to call out something the best we can.

      // "offset" here, being rotate 1/8 of a circle clockwise from 0=north, so 0=NE now.
      // This is the unsafe direction.  We convert to numbers so we can rotate them.
      const offsetDir = {
        frontRight: 0,
        backRight: 1,
        backLeft: 2,
        frontLeft: 3
      };
      const cleaveToOffsetDir = {
        F7: offsetDir.frontRight,
        F8: offsetDir.backRight,
        FA: offsetDir.backLeft,
        F9: offsetDir.frontLeft
      };
      const offsetCleaves = cleaves.map(id => rotateDir(cleaveToOffsetDir[id] ?? 0));

      // Front is rotated to out.
      const cloneOffsetCleaveToDirection = {
        [offsetDir.frontRight]: output.in(),
        [offsetDir.backRight]: output.out(),
        [offsetDir.backLeft]: output.out(),
        [offsetDir.frontLeft]: output.in()
      };

      // Front is rotated to north.
      const bossOffsetCleaveToDirection = {
        [offsetDir.frontRight]: output.dirSW(),
        [offsetDir.backRight]: output.dirNW(),
        [offsetDir.backLeft]: output.dirNE(),
        [offsetDir.frontLeft]: output.dirSE()
      };
      const offsetCleaveToDirection = isClone ? cloneOffsetCleaveToDirection : bossOffsetCleaveToDirection;
      data.calledSeekerSwords = true;
      const dirs = offsetCleaves.map(dir => offsetCleaveToDirection[dir]);
      return output.quadruple({
        dir1: dirs[0],
        dir2: dirs[1],
        dir3: dirs[2],
        dir4: dirs[3]
      });
    },
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      east: outputs/* default.east */.Z.east,
      south: outputs/* default.south */.Z.south,
      west: outputs/* default.west */.Z.west,
      in: outputs/* default.in */.Z["in"],
      out: outputs/* default.out */.Z.out,
      // Backup for bad patterns.
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirSW: outputs/* default.dirSW */.Z.dirSW,
      dirNW: outputs/* default.dirNW */.Z.dirNW,
      double: {
        en: '${dir1} > ${dir2}',
        de: '${dir1} > ${dir2}',
        fr: '${dir1} > ${dir2}',
        ja: '${dir1} > ${dir2}',
        cn: '${dir1} > ${dir2}',
        ko: '${dir1} > ${dir2}'
      },
      quadruple: {
        en: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        de: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        fr: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        ja: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        cn: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        ko: '${dir1} > ${dir2} > ${dir3} > ${dir4}'
      }
    }
  }, {
    id: 'DelubrumSav Seeker Baleful Swath',
    type: 'StartsUsing',
    // This is an early warning on the Verdant Path cast.
    netRegex: {
      source: 'Trinity Seeker',
      id: '5A98',
      capture: false
    },
    response: responses/* Responses.goFrontBack */.n3.goFrontBack('info'),
    // Merciful arc can be skipped, so if we get here, the next headmarker is burning chains.
    // If we have seen merciful arc, this is a noop.
    run: data => data.firstUnknownHeadmarker = headmarker.burningChains
  }, {
    id: 'DelubrumSav Seeker Act Of Mercy',
    type: 'StartsUsing',
    // This is an early warning on the Verdant Path cast.
    netRegex: {
      source: 'Trinity Seeker',
      id: '5A97',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // "Intercardinals" may confuse people between absolute and relative,
        // so add in the "of boss" just to be extra clear.
        en: 'Go Intercardinal of Boss',
        de: 'Geh in eine Intercardinale Himmelsrichtung vom Boss',
        fr: 'Allez en intercardinal du boss',
        ja: 'ボスの斜めへ',
        cn: '去Boss的对角线方向',
        ko: '보스의 대각선 방향으로 피하기'
      }
    }
  }, {
    id: 'DelubrumSav Seeker Iron Impact',
    type: 'StartsUsing',
    // This is an early warning on the Verdant Path cast.
    netRegex: {
      source: 'Trinity Seeker',
      id: '5A99',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Behind For Line Stack',
        de: 'Geh hinter den Boss für Linien-Stack',
        fr: 'Passez derrière pour le package en ligne',
        ja: '後ろに直線頭割りを準備',
        cn: '去后方，准备直线分摊',
        ko: '보스 뒤에서 직선 쉐어 맞기'
      }
    }
  }, {
    id: 'DelubrumSav Seeker Baleful Onslaught Buster',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Seeker',
      id: '5AD5',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        avoidTankCleave: outputs/* default.avoidTankCleave */.Z.avoidTankCleave,
        sharedTankBuster: {
          en: 'Shared Tank Buster',
          de: 'Geteilter Tank Buster',
          fr: 'Partagez le Tank buster',
          ja: '頭割りタンクバスター',
          cn: '分摊死刑',
          ko: '쉐어 탱버'
        }
      };
      if (data.role === 'tank' || data.role === 'healer') return {
        alertText: output.sharedTankBuster()
      };
      return {
        infoText: output.avoidTankCleave()
      };
    }
  }, {
    id: 'DelubrumSav Seeker Baleful Onslaught Solo',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Seeker',
      id: '5AD6',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Solo Tank Cleave',
        de: 'Solo Tank Cleave',
        fr: 'Tank cleave solo',
        ja: 'ソロタンクバスター',
        cn: '单吃死刑顺劈',
        ko: '광역 탱버 혼자맞기'
      }
    }
  }, {
    id: 'DelubrumSav Seeker Baleful Blade Out',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Seeker',
      id: '5ABE',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Barricade',
        de: 'Hinter den Barrikaden verstecken',
        fr: 'Cachez-vous derrière la barricade',
        ja: '柵の後ろに',
        cn: '躲在栅栏后',
        ko: '울타리 뒤에 숨기'
      }
    }
  }, {
    id: 'DelubrumSav Seeker Baleful Blade Knockback',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Seeker',
      id: '5ABF',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback Into Barricade',
        de: 'Rückstoß in die Barrikaden',
        fr: 'Poussée contre la barricade',
        ja: '柵に吹き飛ばされる',
        cn: '击退到栅栏上',
        ko: '울타리로 넉백당하기'
      }
    }
  }, {
    id: 'DelubrumSav Seeker Merciful Moon',
    type: 'StartsUsing',
    // No cast time on this in savage, but Merciful Blooms cast is a ~3s warning.
    netRegex: {
      source: 'Trinity Seeker',
      id: '5ACA',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look Away From Orb',
        de: 'Schau weg vom Orb',
        fr: 'Ne regardez pas l\'orbe',
        ja: '玉に背を向ける',
        cn: '背对白球',
        ko: '구슬에게서 뒤돌기'
      }
    }
  }, {
    id: 'DelubrumSav Seeker Merciful Blooms',
    type: 'Ability',
    // Call this on the ability of Merciful Moon, it starts casting much earlier.
    netRegex: {
      source: 'Aetherial Orb',
      id: '5AC9',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Purple',
        de: 'Schau weg von Lila',
        fr: 'Éloignez-vous du violet',
        ja: '花に避ける',
        cn: '远离紫花',
        ko: '꽃 장판에서 멀리 떨어지기'
      }
    }
  }, {
    id: 'DelubrumSav Seeker Dead Iron',
    type: 'Tether',
    // Headmarkers are randomized, so use the tether instead.
    netRegex: {
      target: 'Trinity Seeker',
      id: '01DB'
    },
    condition: (data, matches) => matches.source === data.me,
    alarmText: (_data, _matches, output) => output.earthshaker(),
    outputStrings: {
      earthshaker: {
        en: 'Earthshaker, away from boss',
        de: 'Erdstoß, weg vom Boss',
        fr: 'Secousse, éloignez-vous du boss',
        ja: 'アースシェイカー、ボスから離れる',
        cn: '大地摇动，远离Boss',
        ko: '어스징, 보스에게서 떨어지기'
      }
    }
  }, {
    id: 'DelubrumSav Seeker Iron Splitter',
    type: 'StartsUsing',
    netRegex: {
      source: ['Trinity Seeker', 'Seeker Avatar'],
      id: '5AC0'
    },
    promise: async (data, matches) => {
      const seekerData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.sourceId, 16)]
      });
      if (seekerData === null) {
        console.error(`Iron Splitter: null data`);
        return;
      }
      if (seekerData.combatants.length !== 1) {
        console.error(`Iron Splitter: expected 1, got ${seekerData.combatants.length}`);
        return;
      }
      const seeker = seekerData.combatants[0];
      if (!seeker) return;
      const x = seeker.PosX - delubrum_reginae_savage_seekerCenterX;
      const y = seeker.PosY - delubrum_reginae_savage_seekerCenterY;
      data.splitterDist = Math.hypot(x, y);
    },
    alertText: (data, _matches, output) => {
      if (data.splitterDist === undefined) return;

      // All 100 examples I've looked at only hit distance=10, or distance=~14
      // Guessing at the other distances, if they exist.
      //
      // blue inner = 0?
      // white inner = 6?
      // blue middle = 10
      // white middle = 14
      // blue outer = 18?
      // white outer = 22?

      const isWhite = Math.floor(data.splitterDist / 4) % 2;
      return isWhite ? output.goBlue() : output.goWhite();
    },
    outputStrings: {
      goBlue: {
        en: 'Blue Stone',
        de: 'Blauer Stein',
        fr: 'Pierre bleue',
        ja: '青い床へ',
        cn: '去蓝色',
        ko: '파랑 장판으로'
      },
      goWhite: {
        en: 'White Sand',
        de: 'Weißer Sand',
        fr: 'Sable blanc',
        ja: '白い床へ',
        cn: '去白色',
        ko: '모래 장판으로'
      }
    }
  }, {
    id: 'DelubrumSav Seeker Baleful Comet Direction',
    type: 'Ability',
    netRegex: {
      source: 'Seeker Avatar',
      id: '5AD7'
    },
    condition: (data, matches) => {
      data.seekerCometIds ??= [];
      data.seekerCometIds.push(parseInt(matches.sourceId, 16));
      return data.seekerCometIds.length === 2;
    },
    delaySeconds: 0.5,
    // In case this hits multiple people.
    // (Note: Suppressed status is checked before condition, but the field evaluated after.)
    suppressSeconds: 0.5,
    promise: async data => {
      // The avatars get moved right before the comets, and the position data
      // is stale in the combat log.  :C
      const cometData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: data.seekerCometIds?.slice(0, 2)
      });
      if (cometData === null) {
        console.error('Baleful Comet: null cometData');
        return;
      }
      if (!cometData.combatants.length) {
        console.error('Baleful Comet: empty combatants');
        return;
      }
      if (cometData.combatants.length !== 2) {
        console.error(`Baleful Comet: weird length: ${cometData.combatants.length}`);
        return;
      }
      data.seekerCometData = cometData.combatants;
    },
    infoText: (data, _matches, output) => {
      if (!data.seekerCometData) throw new not_reached/* UnreachableCode */.$();
      const cometIds = data.seekerCometIds;
      if (!cometIds) throw new not_reached/* UnreachableCode */.$();

      // The returned data does not come back in the same order.
      // Sort by the original order.
      data.seekerCometData.sort((a, b) => {
        return cometIds.indexOf(a.ID ?? 0) - cometIds.indexOf(b.ID ?? 0);
      });
      const [firstDir, secondDir] = data.seekerCometData.map(comet => {
        const x = comet.PosX - delubrum_reginae_savage_seekerCenterX;
        const y = comet.PosY - delubrum_reginae_savage_seekerCenterY;
        const dir = Math.round(4 - 4 * Math.atan2(x, y) / Math.PI) % 8;
        return dir;
      });
      if (firstDir === undefined || secondDir === undefined) throw new not_reached/* UnreachableCode */.$();
      let rotateStr = output.unknown();
      let safeDir;
      if (Math.abs(secondDir - firstDir) === 1) {
        rotateStr = secondDir > firstDir ? output.clockwise() : output.counterclockwise();
        safeDir = (secondDir > firstDir ? firstDir - 1 + 8 : firstDir + 1) % 8;
      } else {
        // edge case where one dir is 0 and the other is 7.
        rotateStr = firstDir === 7 ? output.clockwise() : output.counterclockwise();
        safeDir = firstDir === 7 ? safeDir = 6 : safeDir = 1;
      }
      const initialDir = ['north', 'northeast', 'east', 'southeast', 'south', 'southwest', 'west', 'northwest'][safeDir];
      if (initialDir === undefined) throw new not_reached/* UnreachableCode */.$();
      return output.text({
        dir: output[initialDir](),
        rotate: rotateStr
      });
    },
    outputStrings: {
      unknown: outputs/* default.unknown */.Z.unknown,
      north: outputs/* default.north */.Z.north,
      northeast: outputs/* default.northeast */.Z.northeast,
      east: outputs/* default.east */.Z.east,
      southeast: outputs/* default.southeast */.Z.southeast,
      south: outputs/* default.south */.Z.south,
      southwest: outputs/* default.southwest */.Z.southwest,
      west: outputs/* default.west */.Z.west,
      northwest: outputs/* default.northwest */.Z.northwest,
      clockwise: {
        en: 'Clockwise',
        de: 'Im Uhrzeigersinn',
        fr: 'Sens horaire',
        ja: '時針回り',
        cn: '顺时针',
        ko: '시계방향'
      },
      counterclockwise: {
        en: 'Counter-clock',
        de: 'Gegen den Uhrzeigersinn',
        fr: 'Anti-horaire',
        ja: '逆時針回り',
        cn: '逆时针',
        ko: '반시계방향'
      },
      text: {
        en: 'Go ${dir}, then ${rotate}',
        de: 'Geh nach ${dir}, danach ${rotate}',
        fr: 'Direction ${dir}, puis ${rotate}',
        ja: '${dir}へ、そして${rotate}',
        cn: '去${dir}，然后${rotate}旋转',
        ko: '${dir}으로 간 뒤, ${rotate}'
      }
    }
  }, {
    id: 'DelubrumSav Seeker Baleful Comet Cleanup',
    type: 'Ability',
    netRegex: {
      source: 'Seeker Avatar',
      id: '5AD7',
      capture: false
    },
    delaySeconds: 10,
    suppressSeconds: 10,
    run: data => delete data.seekerCometIds
  }, {
    id: 'DelubrumSav Seeker Burning Chains',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      if (data.me !== matches.target) return false;
      return getHeadmarkerId(data, matches) === headmarker.burningChains;
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Chain on YOU',
        de: 'Kette auf DIR',
        fr: 'Chaîne sur VOUS',
        ja: '自分に鎖',
        cn: '锁链点名',
        ko: '사슬 대상자'
      }
    }
  }, {
    id: 'DelubrumSav Seeker Burning Chains Move',
    type: 'GainsEffect',
    netRegex: {
      effectId: '301'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.breakChains */.n3.breakChains()
  }, {
    id: 'DelubrumSav Seeker Merciful Arc',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => getHeadmarkerId(data, matches) === headmarker.mercifulArc,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'DelubrumSav Dahu Shockwave',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dahu',
      id: ['5770', '576F']
    },
    // There's a 3s slow windup on the first, then a 1s opposite cast.
    suppressSeconds: 10,
    alertText: (_data, matches, output) => {
      if (matches.id === '5770') return output.leftThenRight();
      return output.rightThenLeft();
    },
    outputStrings: {
      leftThenRight: {
        en: 'Left, Then Right',
        de: 'Links, dann Rechts',
        fr: 'À gauche, puis à droite',
        ja: '左 => 右',
        cn: '左 => 右',
        ko: '왼쪽 => 오른쪽'
      },
      rightThenLeft: {
        en: 'Right, Then Left',
        de: 'Rechts, dann Links',
        fr: 'À droite, puis à gauche',
        ja: '右 => 左',
        cn: '右 => 左',
        ko: '오른쪽 => 왼쪽'
      }
    }
  }, {
    id: 'DelubrumSav Dahu Hot Charge',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dahu',
      id: '5773',
      capture: false
    },
    suppressSeconds: 10,
    alertText: (data, _matches, output) => {
      if (data.seenHotCharge) return output.oneOrTwoCharges();
      return output.followSecondCharge();
    },
    run: data => {
      data.seenHotCharge = true;
      data.firstUnknownHeadmarker = headmarker.spitFlame1;
    },
    outputStrings: {
      oneOrTwoCharges: {
        en: 'Follow One or Two Charges',
        de: 'Folge dem 1. oder 2. Ansturm',
        fr: 'Suivez 1 ou 2 charges',
        ja: '1回目や2回目の突進に追う',
        cn: '紧跟第一次或第二次冲锋',
        ko: '첫번째나 두번째 돌진 따라가기'
      },
      followSecondCharge: {
        en: 'Follow Second Charge',
        de: 'Folge dem 2. Ansturm',
        fr: 'Suivez la deuxième charge',
        ja: '2回目の突進に追う',
        cn: '紧跟第二次冲锋',
        ko: '두번째 돌진 따라가기'
      }
    }
  }, {
    id: 'DelubrumSav Dahu Spit Flame',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      if (data.me !== matches.target) return false;
      const id = getHeadmarkerId(data, matches);
      return id >= headmarker.spitFlame1 && id <= headmarker.spitFlame4;
    },
    durationSeconds: 7,
    alarmText: (data, matches, output) => {
      const id = getHeadmarkerId(data, matches);
      const num = parseInt(id, 16) - parseInt(headmarker.spitFlame1, 16) + 1;
      const outputMap = {
        1: output.one(),
        2: output.two(),
        3: output.three(),
        4: output.four()
      };
      return outputMap[num];
    },
    outputStrings: {
      one: outputs/* default.num1 */.Z.num1,
      two: outputs/* default.num2 */.Z.num2,
      three: outputs/* default.num3 */.Z.num3,
      four: outputs/* default.num4 */.Z.num4
    }
  }, {
    id: 'DelubrumSav Dahu Feral Howl',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dahu',
      id: '5767',
      capture: false
    },
    alertText: (_data, _matches, output) => output.knockback(),
    outputStrings: {
      knockback: {
        en: 'Knockback to safe spot',
        de: 'Rückstoß in den sicheren Bereich',
        fr: 'Poussée en zone safe',
        ja: '安置へノックバック',
        cn: '击退到安全点',
        ko: '안전한 곳으로 넉백되기'
      }
    }
  }, {
    id: 'DelubrumSav Dahu Flare',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      if (data.me !== matches.target) return false;
      const id = getHeadmarkerId(data, matches);
      return id === headmarker.flare;
    },
    run: data => data.hystericFlare = true
  }, {
    id: 'DelubrumSav Dahu Hysteric Assault',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dahu',
      id: '5778',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        knockbackNoFlare: {
          en: 'Knockback (no flare)',
          de: 'Rückstoß (keine Flare)',
          fr: 'Poussée (pas de brasier)',
          ja: 'ノックバック (フレアなし)',
          cn: '击退 (无核爆)',
          ko: '넉백 (플레어 없음)'
        },
        knockbackWithFlare: {
          en: 'Flare + Knockback (get away)',
          de: 'Flare + Rückstoß (geh weg)',
          fr: 'Brasier + poussée (éloignez-vous)',
          ja: 'フレア + ノックバック (離れる)',
          cn: '核爆 + 击退 (远离)',
          ko: '플레어 + 넉백 (멀리)'
        }
      };
      if (data.hystericFlare) return {
        alarmText: output.knockbackWithFlare()
      };
      return {
        alertText: output.knockbackNoFlare()
      };
    },
    run: data => delete data.hystericFlare
  }, {
    id: 'DelubrumSav Guard Blood And Bone Warrior and Knight',
    type: 'StartsUsing',
    // 5831 from Queen's Warrior
    // 5821 from Queen's Knight
    netRegex: {
      source: ['Queen\'s Warrior', 'Queen\'s Knight'],
      id: ['5831', '5821'],
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'DelubrumSav Guard Queen\'s Shot and Blood And Bone Soldier',
    type: 'StartsUsing',
    // 5854 from Queen's Gunner
    // 5841 from Queen's Soldier
    netRegex: {
      source: ['Queen\'s Gunner', 'Queen\'s Soldier'],
      id: ['5854', '5841'],
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'DelubrumSav Guard Optimal Offensive Sword',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Knight',
      id: '5819',
      capture: false
    },
    durationSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Take Outside Bombs',
        de: 'Nimm die äußeren Bomben',
        fr: 'Prenez les bombes extérieur',
        ja: '外の爆弾を取る',
        cn: '吃外面的炸弹',
        ko: '바깥쪽의 폭탄 사용하기'
      }
    }
  }, {
    id: 'DelubrumSav Guard Optimal Offensive Shield',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Knight',
      id: '581A',
      capture: false
    },
    durationSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback Away From Sphere',
        de: 'Rückstoß weg von der Sphere',
        fr: 'Poussée loin de la sphère',
        ja: 'ノックバック、玉から離れる',
        cn: '击退，远离球',
        ko: '구슬 쪽에서 넉백'
      }
    }
  }, {
    id: 'DelubrumSav Guard Optimal Play Sword',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Knight',
      id: '5816',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out, Avoid Cleaves',
        de: 'Raus, weiche den Cleaves aus',
        fr: 'À l\'extérieur, évitez les cleaves',
        ja: '外へ、範囲攻撃注意',
        cn: '远离，躲避顺劈',
        ko: '가시 피하면서 밖으로'
      }
    }
  }, {
    id: 'DelubrumSav Guard Optimal Play Shield',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Knight',
      id: '5817',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'In, Avoid Cleaves',
        de: 'Rein, weiche den Cleaves aus',
        fr: 'À l\'intérieur, évitez les cleaves',
        ja: '中へ、範囲攻撃注意',
        cn: '靠近，躲避顺劈',
        ko: '가시 피하면서 안으로'
      }
    }
  }, {
    id: 'DelubrumSav Guard Yellow Tether',
    type: 'Tether',
    netRegex: {
      source: 'Queen\'s Warrior',
      target: 'Queen\'s Knight',
      id: '0088',
      capture: false
    },
    // Yellow tether between Knight and Warrior gives them a Physical Vulnerability Down debuff.
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Remove yellow; apply purple',
        de: 'Entferne Gelb; nimm Lila',
        fr: 'Retirez le jaune; appliquez le violet',
        ja: 'スチールを切り、スペルを使用',
        cn: '点掉钢刺，使用铸魔',
        ko: '강철화살은 지우고, 마법연성 사용'
      }
    }
  }, {
    id: 'DelubrumSav Guard Purple Tether',
    type: 'Tether',
    netRegex: {
      source: 'Queen\'s Warrior',
      target: 'Queen\'s Knight',
      id: '0089',
      capture: false
    },
    // Yellow tether between Knight and Warrior gives them a Physical Vulnerability Down debuff.
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Remove purple; apply yellow',
        de: 'Entferne Lila; nimm Gelb',
        fr: 'Retirez le violet; appliquez le jaune',
        ja: 'スペルを切り、スチールを使用',
        cn: '点掉铸魔，使用钢刺',
        ko: '마법연성은 지우고, 강철화살 사용'
      }
    }
  }, {
    id: 'DelubrumSav Guard Boost',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Warrior',
      id: '582D',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dispel Warrior Boost',
        de: 'Reinige Kriegerin Buff',
        fr: 'Dissipez le boost du Guerrier',
        ja: 'ウォリアーにディスペル',
        cn: '驱魔 > 战士',
        ko: '여왕의 전사 디스펠'
      }
    }
  }, {
    id: 'DelubrumSav Guard Higher Power',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Gunner',
      id: '5853',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dispel Gun Turrets',
        de: 'Reinige Schützetürme',
        fr: 'Dissipez la Tourelle dirigée',
        ja: 'ガンナータレットにディスペル',
        cn: '驱魔 > 炮台',
        ko: '총포탑 디스펠'
      }
    }
  }, {
    id: 'DelubrumSav Guard/Queen Bombslinger',
    type: 'StartsUsing',
    // 5AFE = Bombslinger during Queen's Guard, 5B3F = Bombslinger during The Queen
    netRegex: {
      source: 'Queen\'s Warrior',
      id: ['5AFE', '5B3F'],
      capture: false
    },
    run: data => data.tetherIsBombslinger = true
  }, {
    id: 'DelubrumSav Guard/Queen Bomb Reversal',
    type: 'Tether',
    netRegex: {
      target: 'Queen\'s Warrior',
      id: '0010',
      capture: false
    },
    suppressSeconds: 1,
    run: data => data.tetherOnBomb = true
  }, {
    id: 'DelubrumSav Guard/Queen Personal Reversal',
    type: 'Tether',
    netRegex: {
      target: 'Queen\'s Warrior',
      id: '0087'
    },
    condition: (data, matches) => matches.source === data.me,
    run: data => data.tetherOnSelf = true
  }, {
    id: 'DelubrumSav Guard/Queen Reversal Of Forces',
    type: 'StartsUsing',
    // Tethers to self (and bombs, if bombslinger) come out just before this starts casting.
    // This is used in two places, both for Bombslinger and the Winds of Weight.
    // 5829 = Reversal Of Forces during Queen's Guard, 5A0E = Reversal Of Forces during The Queen
    // TODO: should we differentiate big/small/wind/lightning with alert vs info?
    netRegex: {
      source: 'Queen\'s Warrior',
      id: ['5829', '5A0E'],
      capture: false
    },
    durationSeconds: 11,
    alertText: (data, _matches, output) => {
      if (data.tetherIsBombslinger) {
        if (data.tetherOnBomb) return data.tetherOnSelf ? output.bigWithTether() : output.smallNoTether();
        return data.tetherOnSelf ? output.smallWithTether() : output.bigNoTether();
      }
      return data.tetherOnSelf ? output.windTether() : output.lightningNoTether();
    },
    run: data => {
      delete data.tetherIsBombslinger;
      delete data.tetherOnSelf;
      delete data.tetherOnBomb;
    },
    outputStrings: {
      windTether: {
        en: 'Wind (tethered)',
        de: 'Wind (Verbindung)',
        fr: 'Vent (lié)',
        ja: '風 (線)',
        cn: '风 (连线)',
        ko: '녹색 회오리 (선 연결)'
      },
      lightningNoTether: {
        en: 'Lightning (no tether)',
        de: 'Blitz (keine Verbindung)',
        fr: 'Lumière (non liée)',
        ja: '雷 (線なし)',
        cn: '雷 (无连线)',
        ko: '보라색 장판 (선 없음)'
      },
      bigNoTether: {
        en: 'Big Bomb (no tether)',
        de: 'Große Bombe (keine Verbindung)',
        fr: 'Grosse bombe (non liée)',
        ja: '大きい爆弾 (線なし)',
        cn: '大炸弹 (无连线)',
        ko: '큰 폭탄 (선 없음)'
      },
      bigWithTether: {
        en: 'Big Bomb (tethered)',
        de: 'Große Bombe (Verbindung)',
        fr: 'Grosse bombe (liée)',
        ja: '大きい爆弾 (線)',
        cn: '大炸弹 (连线)',
        ko: '큰 폭탄 (선 연결)'
      },
      smallNoTether: {
        en: 'Small Bomb (no tether)',
        de: 'Kleine Bombe (keine Verbindung)',
        fr: 'Petite bombe (non liée)',
        ja: '小さい爆弾 (線なし)',
        cn: '小炸弹 (无连线)',
        ko: '작은 폭탄 (선 없음)'
      },
      smallWithTether: {
        en: 'Small Bomb (tethered)',
        de: 'Kleine Bombe (Verbindung)',
        fr: 'Petite bombe (liée)',
        ja: '小さい爆弾 (線)',
        cn: '小炸弹 (连线)',
        ko: '작은 폭탄 (선 연결)'
      }
    }
  }, {
    id: 'DelubrumSav Guard Fiery Portent',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Soldier',
      id: '583F'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    durationSeconds: 5.5,
    response: responses/* Responses.stopEverything */.n3.stopEverything()
  }, {
    id: 'DelubrumSav Guard Icy Portent',
    type: 'StartsUsing',
    // Assuming you need to move for 3 seconds (duration of Pyretic from Fiery Portent)
    netRegex: {
      source: 'Queen\'s Soldier',
      id: '5840'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    durationSeconds: 5.5,
    response: responses/* Responses.moveAround */.n3.moveAround('alert')
  }, {
    id: 'DelubrumSav Guard Above Board Warning',
    type: 'StartsUsing',
    // 5826 in Guard fight, 5A0B in Queen fight.
    netRegex: {
      source: 'Queen\'s Warrior',
      id: ['5826', '5A0B'],
      capture: false
    },
    delaySeconds: 9.5,
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'DelubrumSav Guard Queen\'s Shot',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Gunner',
      id: '584C',
      capture: false
    },
    // This has a 7 second cast time.
    delaySeconds: 3.5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // Hard to say "point the opening in the circle around you at the gunner" succinctly.
        en: 'Point at the Gunner',
        de: 'Auf den Schützen zeigen',
        fr: 'Pointez sur le Fusiller',
        ja: '切り目をガンナーに向く',
        cn: '将缺口对准枪手',
        ko: '총사쪽으로 위치 맞추기'
      }
    }
  }, {
    id: 'DelubrumSav Queen Queen\'s Shot',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Gunner',
      id: '5A2D',
      capture: false
    },
    // This has a 7 second cast time.
    delaySeconds: 3.5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // This gunner is always in the northwest during Queen, vs in Guard where it is tankable.
        en: 'Point at the Gunner (in northwest)',
        de: 'Auf den Schützen zeigen (im Nord-Westen)',
        fr: 'Pointez sur le Fusiller (au nord-ouest)',
        ja: '切り目を (北西) ガンナーに向く',
        cn: '将缺口对准西北(左上)枪手',
        ko: '(북서쪽에 있는) 총사쪽으로 위치 맞추기'
      }
    }
  }, {
    id: 'DelubrumSav Guard Queen\'s Shot Followup',
    type: 'Ability',
    netRegex: {
      source: 'Queen\'s Gunner',
      id: ['584C', '5A2D'],
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Point at the Turret',
        de: 'Auf den Geschützturm zeigen',
        fr: 'Pointez sur la Tourelle',
        ja: '切り目をタレットに向く',
        cn: '将缺口对准炮台',
        ko: '포탑쪽으로 위치 맞추기'
      }
    }
  }, {
    id: 'DelubrumSav Guard Coat of Arms',
    type: 'StartsUsing',
    netRegex: {
      source: 'Aetherial Ward',
      id: '5820'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 2.5,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stop attacking',
        de: 'Angriffe stoppen',
        fr: 'Arrêtez d\'attaquer',
        ja: '攻撃禁止',
        cn: '停止攻击',
        ko: '공격 중지'
      }
    }
  }, {
    id: 'DelubrumSav Phantom Malediction Of Agony',
    type: 'StartsUsing',
    netRegex: {
      source: 'Bozjan Phantom',
      id: '57BD',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'DelubrumSav Phantom Weave Miasma',
    type: 'StartsUsing',
    netRegex: {
      source: 'Bozjan Phantom',
      id: '57B2',
      capture: false
    },
    infoText: (data, _matches, output) => {
      data.weaveCount = (data.weaveCount || 0) + 1;
      if (data.weaveCount === 1) return output.firstWeave();else if (data.weaveCount === 2) return output.secondWeave();
    },
    outputStrings: {
      firstWeave: {
        en: 'Go North (donut bottom/circle top)',
        de: 'Geh nach Norden (Donut unten/Kreise oben)',
        fr: 'Allez au nord (donut en bas/cercle en haut)',
        ja: '北へ (下にドーナツ/上に円)',
        cn: '去下环上圆列北侧',
        ko: '북쪽으로 (도넛이 아래, 원이 위인 곳)'
      },
      secondWeave: {
        en: 'Stay South (square bottom/circle top)',
        de: 'Geh nach Süden (Viereck unten/Kreise oben)',
        fr: 'Restez au sud (carré en bas/cercle en haut)',
        ja: '南へ（下に四角/上に円）',
        cn: '待在下方上圆列南侧',
        ko: '남쪽으로 (사각형이 아래, 원이 위인 곳)'
      }
    }
  }, {
    id: 'DelubrumSav Phantom Stuffy Wrath',
    type: 'AddedCombatant',
    // Spawns after 57BA Summon, either North (-403.5) or South (-344.5)
    // Casts 57C2 Undying Hatred
    netRegex: {
      npcNameId: '9756'
    },
    durationSeconds: 5,
    suppressSeconds: 1,
    response: (_data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        goSouth: {
          en: 'Go South; Knockback to Glowing Donut',
          de: 'Geh nach Süden; Rückstoß zum leuchtenden Donut',
          fr: 'Allez au sud; Poussée vers le donut embrasé',
          ja: '南へ、光ってるドーナツへノックバック',
          cn: '去发光环形列南侧',
          ko: '남쪽으로, 빛나는 도넛쪽으로 넉백'
        },
        goNorth: {
          en: 'Go North; Knockback from Glowing Circle',
          de: 'Geh nach Norden; Rückstoß zum leuchtenden Kreis',
          fr: 'Allez au nord; Poussée depuis le cercle verdâtre',
          ja: '北へ、光ってる円からノックバック',
          cn: '去发光圆形列北侧',
          ko: '북쪽으로, 빛나는 원에서 넉백'
        }
      };

      // The sum of the two possible spawn locations divided by two.
      if (parseFloat(matches.y) < -374) return {
        alertText: output.goNorth()
      };
      return {
        alertText: output.goSouth()
      };
    }
  }, {
    id: 'DelubrumSav Phantom Vile Wave',
    type: 'StartsUsing',
    netRegex: {
      source: 'Bozjan Phantom',
      id: '57BF',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'DelubrumSav Phantom Ice Spikes',
    type: 'StartsUsing',
    // Ice Spikes (effectId: '9E0') reflects damage, wait for Dispel
    // Buff expires about 16 seconds on first cast, ~8 seconds later casts)
    netRegex: {
      source: 'Bozjan Phantom',
      id: '57BC',
      capture: false
    },
    delaySeconds: 3,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stop Attacking, Dispel Ice Spikes',
        de: 'Angriffe stoppen, entferne Eisstachel',
        fr: 'Arrêtez d\'attaquer, dissipez les pics de glace',
        ja: '攻撃停止、ファントムにディスペル',
        cn: '停手，驱魔 > 幻灵',
        ko: '공격 중지, 보스 디스펠'
      }
    }
  }, {
    id: 'DelubrumSav Phantom Excruciation',
    type: 'StartsUsing',
    netRegex: {
      source: 'Bozjan Phantom',
      id: '57BE'
    },
    condition: delubrum_reginae_savage_tankBusterOnParty,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'DelubrumSav Avowed Wrath Of Bozja',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Avowed',
      id: '594E',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        avoidTankCleave: outputs/* default.avoidTankCleave */.Z.avoidTankCleave,
        sharedTankBuster: {
          en: 'Shared Tank Buster',
          de: 'Geteilter Tank Buster',
          fr: 'Partagez le Tank buster',
          ja: '頭割りタンクバスター',
          cn: '分摊死刑',
          ko: '쉐어 탱버'
        }
      };
      if (data.role === 'tank' || data.role === 'healer') return {
        alertText: output.sharedTankBuster()
      };
      return {
        infoText: output.avoidTankCleave()
      };
    }
  }, {
    id: 'DelubrumSav Avowed Fury Of Bozja',
    type: 'StartsUsing',
    // Allegiant Arsenal 5987 = staff (out), followed up with Fury of Bozja 594C
    netRegex: {
      source: 'Trinity Avowed',
      id: '5987',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut(),
    run: data => data.avowedPhase = 'staff'
  }, {
    id: 'DelubrumSav Avowed Flashvane',
    type: 'StartsUsing',
    // Allegiant Arsenal 5986 = bow (get behind), followed up by Flashvane 594B
    netRegex: {
      source: 'Trinity Avowed',
      id: '5986',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind(),
    run: data => data.avowedPhase = 'bow'
  }, {
    id: 'DelubrumSav Avowed Infernal Slash',
    type: 'StartsUsing',
    // Allegiant Arsenal 5985 = sword (get front), followed up by Infernal Slash 594A
    netRegex: {
      source: 'Trinity Avowed',
      id: '5985',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.avowedPhase = 'sword',
    outputStrings: {
      text: {
        en: 'Get In Front',
        de: 'Geh vor den Boss',
        fr: 'Passez devant',
        ja: 'ボスの正面へ',
        cn: '去Boss正面',
        ko: '보스 정면에 서기'
      }
    }
  }, {
    id: 'DelubrumSav Avowed Hot And Cold Cleanup',
    type: 'StartsUsing',
    // On Hot and Cold casts.  This will clean up any lingering forced march from bow phase 1.
    netRegex: {
      source: 'Trinity Avowed',
      id: ['5BB0', '5BAF', '597B'],
      capture: false
    },
    run: data => {
      delete data.currentTemperature;
      delete data.currentBrand;
      delete data.forcedMarch;
      delete data.blades;
    }
  }, {
    id: 'DelubrumSav Avowed Temperature Collect',
    type: 'GainsEffect',
    // These come from Environment, Trinity Avowed, Avowed Avatar, Swirling Orb
    // 89C Normal
    // 89D Running Hot: +1
    // 8DC Running Cold: -1
    // 8E2 Running Cold: -2
    // 8A4 Running Hot: +2
    netRegex: {
      effectId: ['89C', '89D', '8DC', '8E2', '8A4']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      const temperature = {
        '89C': 0,
        '89D': 1,
        '8DC': -1,
        '8E2': -2,
        '8A4': 2
      };
      data.currentTemperature = temperature[matches.effectId.toUpperCase()];
    }
  }, {
    id: 'DelubrumSav Avowed Brand Collect',
    type: 'GainsEffect',
    // These come from Environment, E0000000
    // 8E5 Hot Brand: +1
    // 8F3 Hot Brand: +2
    // 8F4 Cold Brand: +1
    // 8F8 Cold Brand: +2
    netRegex: {
      effectId: ['8E5', '8F3', '8F4', '8F8']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      const brand = {
        '8E5': 1,
        '8F3': 2,
        '8F4': -1,
        '8F8': -2
      };
      data.currentBrand = brand[matches.effectId.toUpperCase()];
    }
  }, {
    id: 'DelubrumSav Avowed March Collect',
    type: 'GainsEffect',
    // 50D Forward March
    // 50E About Face
    // 50F Left Face
    // 510 Right Face
    netRegex: {
      effectId: ['50D', '50E', '50F', '510']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => data.forcedMarch = matches.effectId.toUpperCase()
  }, {
    id: 'DelubrumSav Avowed Blade of Entropy Collect',
    type: 'StartsUsing',
    // Used to get whether left or right cleave is happening and temperature value
    // Trinity Avowed or Avowed Avatar cast these pairs
    // +1 Cleaves
    // 5942 = right cleave, heat (1) paired with 5944
    // 5943 = right cleave, cold (1) paired with 5945
    // 5944 = right cleave, heat (1) paired with 5942
    // 5945 = right cleave, cold (1) paired with 5943
    //
    // 5946 = left cleave, cold (1) paired with 5948
    // 5947 = left cleave, heat (1) paired with 5949
    // 5948 = left cleave, cold (1) paired with 5946
    // 5949 = left cleave, heat (1) paired with 5947
    //
    // +2 Cleaves
    // 5956 = right cleave, heat (2) paired with 5958
    // 5957 = right cleave, cold (2) paired with 5959
    // 5958 = right cleave, heat (2) paired with 5956
    // 5959 = right cleave, cold (2) paired with 5957
    //
    // 595A = left cleave heat (2) paired with 595C
    // 595B = left cleave cold (2) paired with 595D
    // 595C = left cleave heat (2) paired with 595A
    // 595D = left cleave cold (2) paired with 595B
    netRegex: {
      source: ['Trinity Avowed', 'Avowed Avatar'],
      id: ['5942', '5943', '5946', '5947', '5956', '5957', '595A', '595B']
    },
    run: (data, matches) => {
      data.blades ??= {};
      data.blades[parseInt(matches.sourceId, 16)] = matches.id.toUpperCase();
    }
  }, {
    id: 'DelubrumSav Avowed Hot And Cold Shimmering Shot',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Avowed',
      id: '597F',
      capture: false
    },
    durationSeconds: 5,
    alertText: (data, _matches, output) => {
      const currentBrand = data.currentBrand ?? 0;
      const currentTemperature = data.currentTemperature ?? 0;
      const effectiveTemperature = (currentTemperature + currentBrand).toString();
      const tempToOutput = {
        '-2': output.plusTwo(),
        '-1': output.plusOne(),
        '0': output.emptySpot(),
        '1': output.minusOne(),
        '2': output.minusTwo()
      };
      const arrowStr = effectiveTemperature in tempToOutput ? tempToOutput[effectiveTemperature] : output.unknownTemperature();
      const marchStrMap = {
        '50D': output.forwards(),
        '50E': output.backwards(),
        '50F': output.left(),
        '510': output.right()
      };
      if (data.forcedMarch !== undefined) {
        const marchStr = marchStrMap[data.forcedMarch];
        return output.marchToArrow({
          arrow: arrowStr,
          dir: marchStr
        });
      }
      return output.followArrow({
        arrow: arrowStr
      });
    },
    outputStrings: {
      plusTwo: {
        en: '+2 Heat Arrow',
        de: '+2 Heiß-Pfeile',
        fr: 'La flèche de chaleur +2',
        ja: '炎属性+2',
        cn: '火+2箭',
        ko: '+2 불 화살'
      },
      plusOne: {
        en: '+1 Heat Arrow',
        de: '+1 Heiß-Pfeile',
        fr: 'La flèche de chaleur +1',
        ja: '炎属性+1',
        cn: '火+1箭',
        ko: '+1 불 화살'
      },
      emptySpot: {
        en: 'Empty Spot',
        de: 'Leeres Feld',
        fr: 'L\'emplacement vide',
        ja: 'そのままにする',
        cn: '空白',
        ko: '빈 자리'
      },
      minusOne: {
        en: '-1 Cold Arrow',
        de: '-1 Kalt-Pfeile',
        fr: 'La flèche de froid -1',
        ja: '氷属性-1',
        cn: '冰-1箭',
        ko: '-1 얼음 화살'
      },
      minusTwo: {
        en: '-2 Cold Arrow',
        de: '-2 Kalt-Pfeile',
        fr: 'La flèche de froid -2',
        ja: '氷属性-2',
        cn: '冰-2箭',
        ko: '-2 얼음 화살'
      },
      unknownTemperature: {
        en: 'Opposite Arrow',
        de: 'Entgegengesetze Pfeile',
        fr: 'La flèche de l\'élément opposé',
        ja: '体温と逆のあみだ',
        cn: '相反温度的箭',
        ko: '반대속성 화살'
      },
      forwards: {
        en: 'forwards',
        de: 'Vorwärts',
        fr: 'vers l\'avant',
        ja: '前',
        cn: '前',
        ko: '앞'
      },
      backwards: {
        en: 'backwards',
        de: 'Rückwärts',
        fr: 'vers l\'arrière',
        ja: '後ろ',
        cn: '后',
        ko: '뒤'
      },
      left: {
        en: 'left',
        de: 'Links',
        fr: 'à gauche',
        ja: '左',
        cn: '左',
        ko: '왼쪽'
      },
      right: {
        en: 'right',
        de: 'Rechts',
        fr: 'à droite',
        ja: '右',
        cn: '右',
        ko: '오른쪽'
      },
      followArrow: {
        en: 'Follow ${arrow}',
        de: 'Folge ${arrow}',
        fr: 'Suivez ${arrow}',
        ja: '${arrow}に従う',
        cn: '接${arrow}',
        ko: '${arrow}쪽으로'
      },
      marchToArrow: {
        en: 'March ${dir} to ${arrow}',
        de: 'Marchiere ${dir} zum ${arrow}',
        fr: 'Marchez ${dir} de ${arrow}',
        ja: '強制移動: ${dir} > ${arrow}',
        cn: '强制移动：${dir} > ${arrow}',
        ko: '강제이동 ${dir} > ${arrow}'
      }
    }
  }, {
    id: 'DelubrumSav Avowed Hot And Cold Freedom Of Bozja',
    type: 'StartsUsing',
    netRegex: {
      source: 'Trinity Avowed',
      id: '597C',
      capture: false
    },
    delaySeconds: 7,
    durationSeconds: 5,
    alertText: (data, _matches, output) => {
      const currentBrand = data.currentBrand ? data.currentBrand : 0;
      const currentTemperature = data.currentTemperature ? data.currentTemperature : 0;
      const effectiveTemperature = (currentTemperature + currentBrand).toString();
      const tempToOutput = {
        '-2': output.plusTwo(),
        '-1': output.plusOne(),
        '1': output.minusOne(),
        '2': output.minusTwo()
      };
      const meteorStr = effectiveTemperature in tempToOutput ? tempToOutput[effectiveTemperature] : output.unknownTemperature();
      const marchStrMap = {
        '50D': output.forwards(),
        '50E': output.backwards(),
        '50F': output.left(),
        '510': output.right()
      };
      if (data.forcedMarch !== undefined) {
        const marchStr = marchStrMap[data.forcedMarch];
        return output.marchToMeteor({
          meteor: meteorStr,
          dir: marchStr
        });
      }
      return output.goToMeteor({
        meteor: meteorStr
      });
    },
    outputStrings: {
      plusTwo: {
        en: '+2 Heat Meteor',
        de: '+2 Heiß-Meteor',
        fr: 'Météore de chaleur +2',
        ja: '炎属性+2',
        cn: '火+2陨石',
        ko: '+2 불 운석'
      },
      plusOne: {
        en: '+1 Heat Meteor',
        de: '+1 Heiß-Meteor',
        fr: 'Météore de chaleur +1',
        ja: '炎属性+1',
        cn: '火+1陨石',
        ko: '+1 불 운석'
      },
      minusOne: {
        en: '-1 Cold Meteor',
        de: '-1 Kalt-Meteor',
        fr: 'Météore de froid -1',
        ja: '氷属性-1',
        cn: '冰-1陨石',
        ko: '-1 얼음 운석'
      },
      minusTwo: {
        en: '-2 Cold Meteor',
        de: '-2 Kalt-Meteor',
        fr: 'Météore de froid -2',
        ja: '氷属性-2',
        cn: '冰-2陨石',
        ko: '-2 얼음 운석'
      },
      unknownTemperature: {
        en: 'Opposite Meteor',
        de: 'Entgegengesetzer Meteor',
        fr: 'Météore de l\'élément opposé',
        ja: '体温と逆のメテオを受ける',
        cn: '去相反温度的陨石',
        ko: '반대속성 운석'
      },
      forwards: {
        en: 'forwards',
        de: 'Vorwärts',
        fr: 'vers l\'avant',
        ja: '前',
        cn: '前',
        ko: '앞'
      },
      backwards: {
        en: 'backwards',
        de: 'Rückwärts',
        fr: 'vers l\'arrière',
        ja: '後ろ',
        cn: '后',
        ko: '뒤'
      },
      left: {
        en: 'left',
        de: 'Links',
        fr: 'à gauche',
        ja: '左',
        cn: '左',
        ko: '왼쪽'
      },
      right: {
        en: 'right',
        de: 'Rechts',
        fr: 'à droite',
        ja: '右',
        cn: '右',
        ko: '오른쪽'
      },
      goToMeteor: {
        en: 'Go to ${meteor} (watch clones)',
        de: 'Gehe zum ${meteor} (beachte die Klone)',
        fr: 'Allez au ${meteor} (regardez les clones)',
        ja: '${meteor}へ (分体を見る)',
        cn: '去${meteor}，观察分身',
        ko: '${meteor}쪽으로 (분신 위치 확인)'
      },
      marchToMeteor: {
        en: 'March ${dir} to ${meteor}',
        de: 'Marchiere ${dir} zum ${meteor}',
        fr: 'Marchez ${dir} du ${meteor}',
        ja: '強制移動: ${dir} > ${meteor}',
        cn: '强制移动：${dir} > ${meteor}',
        ko: '강제이동 ${dir} > ${meteor}'
      }
    }
  }, {
    id: 'DelubrumSav Avowed Hot And Cold Unwavering Apparations',
    type: 'GainsEffect',
    // The buffs come out before the spell cast
    // Trinity Avowed and/or Avowed Avatar receive one of these buffs:
    // 8F9: Hot Blade: +1
    // 8FA: Hot Blade: +2
    // 8FB: Cold Blade: -1
    // 8FC: Cold Blade: -2
    // Positional data in statusEffectsParams is often not up to date, use promise
    //
    // Trigger delayed until after Blade Of Entropy happens about ~100ms after
    // to get left/right cleave info
    // Ignoring Trinity Avowed due to Environment 'randomly' refreshing its buff
    netRegex: {
      target: 'Avowed Avatar',
      effectId: ['8F9', '8FA', '8FB', '8FC'],
      capture: false
    },
    delaySeconds: 0.5,
    durationSeconds: 9.5,
    suppressSeconds: 1,
    promise: async (data, _matches, output) => {
      const trinityLocaleNames = {
        en: 'Trinity Avowed',
        de: 'Trinität Der Eingeschworenen',
        fr: 'Trinité féale',
        ja: 'トリニティ・アヴァウ',
        cn: '誓约之三位一体',
        ko: '맹세의 삼위일체'
      };
      const avatarLocaleNames = {
        en: 'Avowed Avatar',
        de: 'Spaltteil der Eingeschworenen',
        fr: 'Clone de la Trinité féale',
        ja: 'アヴァウドの分体',
        cn: '誓约之分身',
        ko: '맹세의 분열체'
      };

      // select the Trinity and Avatars
      let combatantNameBoss = null;
      let combatantNameAvatar = null;
      combatantNameBoss = trinityLocaleNames[data.parserLang];
      combatantNameAvatar = avatarLocaleNames[data.parserLang];
      let combatantDataBoss = null;
      let combatantDataAvatars = null;
      if (combatantNameBoss !== undefined) {
        combatantDataBoss = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
          call: 'getCombatants',
          names: [combatantNameBoss]
        });
      }
      if (combatantNameAvatar !== undefined) {
        combatantDataAvatars = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
          call: 'getCombatants',
          names: [combatantNameAvatar]
        });
      }

      // if we could not retrieve combatant data, the
      // trigger will not work, so just resume promise here
      if (combatantDataBoss === null) {
        console.error(`Trinity Avowed: null data`);
        delete data.safeZone;
        return;
      }
      if (combatantDataAvatars === null) {
        console.error(`Avowed Avatar: null data`);
        delete data.safeZone;
        return;
      }
      if (combatantDataAvatars.combatants.length < 3) {
        console.error(`Avowed Avatar: expected at least 3 combatants got ${combatantDataAvatars.combatants.length}`);
        delete data.safeZone;
        return;
      }
      if (!data.blades) {
        console.error(`Avowed Avatar: missing blades`);
        delete data.safeZone;
        return;
      }
      const getFacing = combatant => {
        // Snap heading to closest card.
        // N = 0, E = 1, S = 2, W = 3
        return (2 - Math.round(combatant.Heading * 4 / Math.PI) / 2) % 4;
      };
      const getUnwaveringPosition = combatant => {
        // Positions are moved downward 87 and left 277
        const y = combatant.PosY + 87;
        const x = combatant.PosX + 277;
        // N = 0, E = 1, S = 2, W = 3
        return Math.round(2 - 2 * Math.atan2(x, y) / Math.PI) % 4;
      };

      // we need to filter for the Trinity Avowed with the lowest ID
      // that one is always cleaving on one of the cardinals
      // Trinity Avowed is always East (-267, -87)
      const sortCombatants = (a, b) => (a.ID ?? 0) - (b.ID ?? 0);
      const eastCombatant = combatantDataBoss.combatants.sort(sortCombatants).shift();

      // we need to filter for the three Avowed Avatars with the lowest IDs
      // as they cast cleave at the different cardinals
      const [avatarOne, avatarTwo, avatarThree] = combatantDataAvatars.combatants.sort(sortCombatants);
      if (!avatarOne || !avatarTwo || !avatarThree) throw new not_reached/* UnreachableCode */.$();
      const combatantPositions = [];
      combatantPositions[getUnwaveringPosition(avatarOne)] = avatarOne;
      combatantPositions[getUnwaveringPosition(avatarTwo)] = avatarTwo;
      combatantPositions[getUnwaveringPosition(avatarThree)] = avatarThree;

      // Avowed Avatars can spawn in the other positions
      // Determine the location of Avowed Avatars
      // North Avowed Avatar (-277, -97)
      // South Avowed Avatar (-277, -77)
      // West Avowed Avatar (-277, -87)
      const [northCombatant,, southCombatant, westCombatant] = combatantPositions;
      if (!northCombatant || !southCombatant || !westCombatant) throw new not_reached/* UnreachableCode */.$();

      // Get facings
      const northCombatantFacing = getFacing(northCombatant);
      const southCombatantFacing = getFacing(southCombatant);

      // Get Blade of Entropy data
      const eastCombatantBlade = data.blades[eastCombatant?.ID ?? 0];
      const northCombatantBlade = data.blades[northCombatant?.ID ?? 0];
      const westCombatantBlade = data.blades[westCombatant?.ID ?? 0];
      const southCombatantBlade = data.blades[southCombatant?.ID ?? 0];
      if (eastCombatantBlade === undefined || northCombatantBlade === undefined || westCombatantBlade === undefined || southCombatantBlade === undefined) throw new not_reached/* UnreachableCode */.$();
      const bladeValues = {
        '5942': 1,
        '5943': -1,
        '5946': 1,
        '5947': -1,
        '5956': 2,
        '5957': -2,
        '595A': 2,
        '595B': -2
      };

      // 1 = Right
      // 0 = Left
      const bladeSides = {
        '5942': 1,
        '5943': 1,
        '5946': 0,
        '5947': 0,
        '5956': 1,
        '5957': 1,
        '595A': 0,
        '595B': 0
      };
      const eastCombatantBladeValue = bladeValues[eastCombatantBlade];
      const northCombatantBladeValue = bladeValues[northCombatantBlade];
      const westCombatantBladeValue = bladeValues[westCombatantBlade];
      const southCombatantBladeValue = bladeValues[southCombatantBlade];
      if (eastCombatantBladeValue === undefined || northCombatantBladeValue === undefined || westCombatantBladeValue === undefined || southCombatantBladeValue === undefined) throw new not_reached/* UnreachableCode */.$();

      // Create map to improve readability of safeZone conditions
      const dirNum = {
        north: 0,
        east: 1,
        south: 2,
        west: 3
      };

      // Only need to check cleaves from two parallel clones to determine safe spots
      // because if the clone is cleaving inside, then we know where other clones
      // are cleaving in order to make a '+' where the ends are each cleaved by one
      // clone and the middle square is safe
      let safeZone = null;
      let adjacentZones = {};
      if (northCombatantFacing === dirNum.north && bladeSides[northCombatantBlade] || northCombatantFacing === dirNum.south && !bladeSides[northCombatantBlade]) {
        // North clone cleaving inside east (and therefore east clone cleaving north).
        safeZone = output.southwest();
        adjacentZones = {
          [dirNum.north]: eastCombatantBladeValue,
          [dirNum.east]: northCombatantBladeValue,
          [dirNum.south]: southCombatantBladeValue,
          [dirNum.west]: westCombatantBladeValue
        };
      } else if (northCombatantFacing === dirNum.north && !bladeSides[northCombatantBlade] || northCombatantFacing === dirNum.south && bladeSides[northCombatantBlade]) {
        // North clone cleaving inside west (and therefore west clone cleaving north).
        safeZone = output.southeast();
        adjacentZones = {
          [dirNum.north]: westCombatantBladeValue,
          [dirNum.east]: eastCombatantBladeValue,
          [dirNum.south]: southCombatantBladeValue,
          [dirNum.west]: northCombatantBladeValue
        };
      } else if (southCombatantFacing === dirNum.south && bladeSides[southCombatantBlade] || southCombatantFacing === dirNum.north && !bladeSides[southCombatantBlade]) {
        // South clone cleaving inside west (and therefore west clone cleaving south).
        safeZone = output.northeast();
        adjacentZones = {
          [dirNum.north]: northCombatantBladeValue,
          [dirNum.east]: eastCombatantBladeValue,
          [dirNum.south]: westCombatantBladeValue,
          [dirNum.west]: southCombatantBladeValue
        };
      } else if (southCombatantFacing === dirNum.north && bladeSides[southCombatantBlade] || southCombatantFacing === dirNum.south && !bladeSides[southCombatantBlade]) {
        // South clone cleaving inside east (and therefore east clone cleaving south).
        safeZone = output.northwest();
        adjacentZones = {
          [dirNum.north]: northCombatantBladeValue,
          [dirNum.east]: southCombatantBladeValue,
          [dirNum.south]: eastCombatantBladeValue,
          [dirNum.west]: westCombatantBladeValue
        };
      } else {
        // facing did not evaluate properly
        console.error(`Avowed Avatar: facing error, ` + `${northCombatantFacing}, ${southCombatantFacing}, ` + `${JSON.stringify(bladeSides[northCombatantBlade])}, ` + `${JSON.stringify(bladeSides[southCombatantBlade])}`);
        data.safeZone = output.unknown();
        return;
      }
      const currentBrand = data.currentBrand ? data.currentBrand : 0;
      const currentTemperature = data.currentTemperature ? data.currentTemperature : 0;
      const effectiveTemperature = currentTemperature + currentBrand;

      // Calculate which adjacent zone to go to, if needed
      let adjacentZone = null;
      if (effectiveTemperature !== 0) {
        // Find the adjacent zone that gets closest to 0
        const calculatedZones = Object.values(adjacentZones).map(i => Math.abs(effectiveTemperature + i));

        // Use zone closest to zero as output
        const dirs = {
          [dirNum.north]: output.north(),
          [dirNum.east]: output.east(),
          [dirNum.south]: output.south(),
          [dirNum.west]: output.west()
        };
        const zoneClosestToZero = [...calculatedZones].sort((a, b) => b - a).pop();
        if (zoneClosestToZero === undefined) throw new not_reached/* UnreachableCode */.$();
        adjacentZone = dirs[calculatedZones.indexOf(zoneClosestToZero)];
        if (adjacentZone === undefined) throw new not_reached/* UnreachableCode */.$();
      }

      // Callout safe spot and get cleaved spot if both are known
      // Callout safe spot only if no need to be cleaved
      if (adjacentZone !== null) {
        data.safeZone = output.getCleaved({
          dir1: safeZone,
          dir2: adjacentZone
        });
      } else if (safeZone) {
        data.safeZone = output.safeSpot({
          dir: safeZone
        });
      } else {
        console.error(`Avowed Avatar: undefined zones`);
        data.safeZone = output.unknown();
      }
    },
    alertText: (data, _matches, output) => data.safeZone ?? output.unknown(),
    outputStrings: {
      getCleaved: {
        en: '${dir1} Safe Spot => ${dir2} for cleave',
        de: 'Sichere Stelle ${dir1} => ${dir2} für Cleave',
        fr: '${dir1} Zone safe => ${dir2} pour le cleave',
        ja: '${dir1}に安置 => ${dir2}範囲攻撃に',
        cn: '去${dir1}方安全点 => 去${dir2}吃顺劈',
        ko: '${dir1} 안전 지대 => ${dir2} 광역 맞기'
      },
      safeSpot: {
        en: '${dir} Safe Spot',
        de: 'Sichere Stelle ${dir}',
        fr: '${dir} Zone safe',
        ja: '${dir}に安置',
        cn: '去${dir}方安全点',
        ko: '${dir} 안전 지대'
      },
      unknown: outputs/* default.unknown */.Z.unknown,
      north: outputs/* default.north */.Z.north,
      northeast: outputs/* default.northeast */.Z.northeast,
      east: outputs/* default.east */.Z.east,
      southeast: outputs/* default.southeast */.Z.southeast,
      south: outputs/* default.south */.Z.south,
      southwest: outputs/* default.southwest */.Z.southwest,
      west: outputs/* default.west */.Z.west,
      northwest: outputs/* default.northwest */.Z.northwest
    }
  }, {
    id: 'DelubrumSav Avowed Gleaming Arrow Collect',
    type: 'StartsUsing',
    netRegex: {
      source: 'Avowed Avatar',
      id: '594D'
    },
    run: (data, matches) => {
      data.unseenIds ??= [];
      data.unseenIds.push(parseInt(matches.sourceId, 16));
    }
  }, {
    id: 'DelubrumSav Avowed Gleaming Arrow',
    type: 'StartsUsing',
    netRegex: {
      source: 'Avowed Avatar',
      id: '594D',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 10,
    promise: async data => {
      const unseenIds = data.unseenIds;
      if (!unseenIds) return;
      const unseenData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: unseenIds
      });
      if (unseenData === null) {
        console.error(`Gleaming Arrow: null data`);
        return;
      }
      if (unseenData.combatants.length !== unseenIds.length) {
        console.error(`Gleaming Arrow: expected ${unseenIds.length}, got ${unseenData.combatants.length}`);
        return;
      }
      data.unseenBadRows = [];
      data.unseenBadCols = [];
      for (const avatar of unseenData.combatants) {
        const x = avatar.PosX - delubrum_reginae_savage_avowedCenterX;
        const y = avatar.PosY - delubrum_reginae_savage_avowedCenterY;

        // y=-107 = north side, x = -252, -262, -272, -282, -292
        // x=-247 = left side, y = -62, -72, -82, -92, -102
        // Thus, the possible deltas are -20, -10, 0, +10, +20.
        // The other coordinate is +/-25 from center.
        const maxDist = 22;
        if (Math.abs(x) < maxDist) {
          const col = Math.round((x + 20) / 10);
          data.unseenBadCols.push(col);
        }
        if (Math.abs(y) < maxDist) {
          const row = Math.round((y + 20) / 10);
          data.unseenBadRows.push(row);
        }
      }
      data.unseenBadRows.sort();
      data.unseenBadCols.sort();
    },
    alertText: (data, _matches, output) => {
      delete data.unseenIds;
      const rows = data.unseenBadRows;
      const cols = data.unseenBadCols;
      if (!rows || !cols) return;
      if (data.avowedPhase === 'bow') {
        // consider asserting that badCols are 0, 2, 4 here.
        if (rows.includes(2)) return output.bowLight();
        return output.bowDark();
      }
      if (data.avowedPhase !== 'staff') return;
      if (cols.includes(1)) {
        if (rows.includes(1)) return output.staffOutsideCorner();
        return output.staffOutsideColInsideRow();
      }
      if (cols.includes(0)) {
        if (rows.includes(0)) return output.staffInsideCorner();
        return output.staffInsideColOutsideRow();
      }
    },
    outputStrings: {
      bowDark: {
        en: 'Dark (E/W of center)',
        de: 'Dunkel (O/W von der Mitte)',
        fr: 'Foncée (E/O du centre)',
        ja: 'ダーク床 (東/西)',
        cn: '内圈东西(左右)暗色地板',
        ko: '어두운 타일 (맵 중앙의 왼/오른쪽)'
      },
      bowLight: {
        en: 'Light (diagonal from center)',
        de: 'Licht (Diagonal von der Mitte)',
        fr: 'Claire (diagonale du centre)',
        ja: 'ライト床 (中の対角)',
        cn: '内圈四角亮色地板',
        ko: '밝은 타일 (맵 중앙의 대각선)'
      },
      staffOutsideCorner: {
        en: 'Outside Corner',
        de: 'Äußere Ecken',
        fr: 'Coin extérieur',
        ja: '外のコーナー',
        cn: '外圈四角亮色地板',
        ko: '맵 구석의 밝은 타일'
      },
      staffInsideCorner: {
        en: 'Inside Corner',
        de: 'Innere Ecken',
        fr: 'Coin intérieur',
        ja: '中のコーナー',
        cn: '内圈四角亮色地板',
        ko: '구석에서 한칸 안쪽 밝은 타일'
      },
      staffOutsideColInsideRow: {
        en: 'N/S of Corner',
        de: 'N/S von der Ecke',
        fr: 'N/S du coin',
        ja: '南北行のダーク床',
        cn: '外圈南北(上下)暗色地板',
        ko: '맵 구석에서 북/남쪽의 어두운 타일'
      },
      staffInsideColOutsideRow: {
        en: 'E/W of Corner',
        de: 'O/W von der Ecke',
        fr: 'E/O du coin',
        ja: '東西列のダーク床',
        cn: '外圈东西(左右)暗色地板',
        ko: '맵 구석에서 왼/오른쪽의 어두운 타일'
      }
    }
  }, {
    id: 'DelubrumSav Lord Foe Splitter',
    type: 'StartsUsing',
    netRegex: {
      source: 'Stygimoloch Lord',
      id: '57D7'
    },
    // THANKFULLY this starts using comes out immediately before the headmarker line.
    preRun: data => data.firstUnknownHeadmarker = headmarker.foeSplitter,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        cleaveOnYou: outputs/* default.tankCleaveOnYou */.Z.tankCleaveOnYou,
        cleaveNoTarget: outputs/* default.tankCleave */.Z.tankCleave,
        avoidCleave: outputs/* default.avoidTankCleave */.Z.avoidTankCleave,
        cleaveOn: {
          en: 'Tank Cleave on ${player}',
          de: 'Tank Cleave auf ${player}',
          fr: 'Tank Cleave sur ${player}',
          ja: '${player}に範囲攻撃',
          cn: '顺劈: ${player}',
          ko: '${player}에게 광역 탱버'
        }
      };
      if (matches.target === data.me) return {
        alarmText: output.cleaveOnYou()
      };
      if (delubrum_reginae_savage_tankBusterOnParty(data, matches)) return {
        alertText: output.cleaveOn({
          player: data.party.member(matches.target)
        })
      };
      return {
        infoText: output.avoidCleave()
      };
    }
  }, {
    id: 'DelubrumSav Lord Rapid Bolts',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      if (data.me !== matches.target) return false;
      return getHeadmarkerId(data, matches) === headmarker.thunder;
    },
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop thunder outside',
        de: 'Lege Blitz draußen ab',
        fr: 'Déposez la foudre à l\'extérieur',
        ja: '外に捨てる',
        cn: '外圈放雷',
        ko: '바깥에 번개장판 놓기'
      }
    }
  }, {
    id: 'DelubrumSav Lord Labyrinthine Fate Collect',
    type: 'GainsEffect',
    // 97E: Wanderer's Fate, Pushes outward on Fateful Word cast
    // 97F: Sacrifice's Fate, Pulls to middle on Fateful Word cast
    netRegex: {
      effectId: '97[EF]'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: (data, matches) => {
      data.labyrinthineFate = matches.effectId.toUpperCase();
    },
    // This effect is given repeatedly.
    suppressSeconds: 30,
    infoText: (data, _matches, output) => {
      // The first time this happens, there is ~2.5 seconds between debuff application
      // and the start of the cast to execute that debuff.  Be less noisy on the first.
      if (!data.seenLabyrinthineFate) return;
      if (data.labyrinthineFate === '97F') return output.getOutLater();
      if (data.labyrinthineFate === '97E') return output.getInLater();
    },
    run: data => data.seenLabyrinthineFate = true,
    outputStrings: {
      getOutLater: {
        en: '(sacrifice out, for later)',
        de: '(Heranziehen raus, für später)',
        fr: '(sacrifice à l\'extérieur, pour plus tard)',
        ja: '(外の切れ目に引き付ける)',
        cn: '(外缺口等待吸引)',
        ko: '(저주의 말 시전하면 바깥쪽에 서기)'
      },
      getInLater: {
        en: '(wanderer in, for later)',
        de: '(Zurückschleudern rein, für später)',
        fr: '(errant à l\'intérieur, pour plus tard)',
        ja: '(中の切れ目に吹き飛ばす)',
        cn: '(内缺口等待击退)',
        ko: '(저주의 말 시전하면 안쪽에 서기)'
      }
    }
  }, {
    id: 'DelubrumSav Lord Fateful Words',
    type: 'StartsUsing',
    netRegex: {
      source: 'Stygimoloch Lord',
      id: '57C9',
      capture: false
    },
    // 97E: Wanderer's Fate, Pushes outward on Fateful Word cast
    // 97F: Sacrifice's Fate, Pulls to middle on Fateful Word cast
    // Labyrinthine Fate is cast and 1 second later debuffs are applied
    // First set of debuffs go out 7.7 seconds before Fateful Word is cast
    // Remaining set of debuffs go out 24.3 seconds before Fateful Word is cast
    alertText: (data, _matches, output) => {
      if (data.labyrinthineFate === '97F') return output.getOut();
      if (data.labyrinthineFate === '97E') return output.getIn();
    },
    // In case you die and don't get next debuff, clean this up so it doesn't call again.
    run: data => delete data.labyrinthineFate,
    outputStrings: {
      getOut: outputs/* default.out */.Z.out,
      getIn: outputs/* default.in */.Z["in"]
    }
  }, {
    id: 'DelubrumSav Lord Devastating Bolt',
    type: 'StartsUsing',
    netRegex: {
      source: 'Stygimoloch Lord',
      id: '57C5',
      capture: false
    },
    durationSeconds: 4,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get In Nook',
        de: 'Geh in die Ecke',
        fr: 'Allez dans un recoin',
        ja: '切れ目に入る',
        cn: '进入缺口',
        ko: '틈새에 들어가기'
      }
    }
  }, {
    id: 'DelubrumSav Lord 1111-Tonze Swing',
    type: 'StartsUsing',
    netRegex: {
      source: 'Stygimoloch Lord',
      id: '57D8',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'DelubrumSav Queen Cleansing Slash',
    type: 'StartsUsing',
    // PLD and GNB tank invulnerabilities do not get Physical Vulnerability Up
    // Tank swap will be required between the two hits if not using a tank invulnerability
    // Tank swap required after second hit if not using PLD or GNB tank invulnerabilities
    // To avoid bad swaps between 11 other tanks, only mention swap to targetted tank
    netRegex: {
      source: 'The Queen',
      id: '59F5'
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankBusterAndSwap: {
          en: 'Tank Buster + Swap',
          de: 'Tankbuster + Wechsel',
          fr: 'Tank buster + Swap',
          ja: 'タンクバスター + スイッチ',
          cn: '死刑 + 换T',
          ko: '탱버 + 교대'
        },
        tankBusterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
        tankBusterOnPlayer: outputs/* default.tankBusterOnPlayer */.Z.tankBusterOnPlayer,
        tankInvuln: {
          en: 'Invuln Tank Buster',
          de: 'Unverwundbarkeit für Tank Buster benutzen',
          fr: 'Invincible sur le Tank buster',
          ja: 'タンクバスター (被ダメージ上昇付き)',
          cn: '易伤死刑',
          ko: '무적기로 탱버 처리'
        }
      };
      if (data.me === matches.target) {
        if (data.role === 'tank') {
          if (data.job === 'PLD' || data.job === 'GNB') return {
            alertText: output.tankInvuln()
          };
          return {
            alertText: output.tankBusterAndSwap()
          };
        }
        return {
          alarmText: output.tankBusterOnYou()
        };
      }
      const sev = data.role === 'healer' || data.role === 'tank' ? 'alertText' : 'infoText';
      return {
        [sev]: output.tankBusterOnPlayer({
          player: matches.target
        })
      };
    }
  }, {
    id: 'DelubrumSav Queen Cleansing Slash Doom',
    type: 'GainsEffect',
    // Each Cleansing Slash applies a cleansable Doom (38E), if damage is taken
    netRegex: {
      source: 'The Queen',
      effectId: '38E'
    },
    condition: data => data.CanCleanse(),
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.target)
    }),
    outputStrings: {
      text: {
        en: 'Esuna ${player}',
        de: 'Medica ${player}',
        fr: 'Guérison sur ${player}',
        ja: '${player} にエスナ',
        cn: '驱散: ${player}',
        ko: '${player} 에스나'
      }
    }
  }, {
    id: 'DelubrumSav Queen Dispel',
    type: 'GainsEffect',
    // Players with Dispel should Dispel all the buffs on The Queen.
    // Critical Strikes = 705 is the first one.
    netRegex: {
      target: 'The Queen',
      effectId: '705',
      capture: false
    },
    condition: data => {
      data.queenDispelCount = (data.queenDispelCount || 0) + 1;
      // The third time she gains this effect is the enrage, and there's no need to dispel.
      return data.queenDispelCount <= 2;
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dispel Queen',
        de: 'Kriegsgöttin reinigen',
        fr: 'Dissipez la Reine',
        ja: 'ボスにディスペル',
        cn: '驱魔 > 女王',
        ko: '보스 디스펠'
      }
    }
  }, {
    id: 'DelubrumSav Queen Ball Lightning',
    type: 'AddedCombatant',
    // Players with Reflect should destroy one for party to stand in the shield left behind
    netRegex: {
      npcNameId: '7974',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Reflect Orbs',
        de: 'Reflektiere Orbs',
        fr: 'Reflétez les orbes',
        ja: '雷玉にリフレク',
        cn: '反射雷球',
        ko: '리플렉트로 구슬 처리'
      }
    }
  }, {
    id: 'DelubrumSav Queen Ball Lightning Bubble',
    type: 'WasDefeated',
    netRegex: {
      target: 'Ball Lightning',
      capture: false
    },
    suppressSeconds: 20,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get in Bubble',
        de: 'Geh in die Blase',
        fr: 'Allez dans la bulle',
        ja: '泡に入る',
        cn: '进泡泡',
        ko: '보호막 안에 들어가기'
      }
    }
  }, {
    id: 'DelubrumSav Queen Fiery Portent',
    type: 'StartsUsing',
    netRegex: {
      source: 'Queen\'s Soldier',
      id: '5A21'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    durationSeconds: 5.5,
    response: responses/* Responses.stopEverything */.n3.stopEverything()
  }, {
    id: 'DelubrumSav Queen Icy Portent',
    type: 'StartsUsing',
    // Assuming you need to move for 3 seconds (duration of Pyretic from Fiery Portent)
    netRegex: {
      source: 'Queen\'s Soldier',
      id: '5A22'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    durationSeconds: 5.5,
    response: responses/* Responses.moveAround */.n3.moveAround('alert')
  }, {
    id: 'DelubrumSav Queen Judgment Blade Right',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Queen',
      id: '59F2',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Find Charge, Dodge Right',
        de: 'Halte nach dem Ansturm ausschau, weiche nach rechts aus',
        fr: 'Repérez la charge, esquivez à droite',
        ja: '右へ、突進を避ける',
        cn: '去右侧躲避冲锋',
        ko: '돌진 찾고, 오른쪽 피하기'
      }
    }
  }, {
    id: 'DelubrumSav Queen Judgment Blade Left',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Queen',
      id: '59F1',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Find Charge, Dodge Left',
        de: 'Halte nach dem Ansturm ausschau, weiche nach links aus',
        fr: 'Repérez la charge, esquivez à gauche',
        ja: '左へ、突進を避ける',
        cn: '去左侧躲避冲锋',
        ko: '돌진 찾고, 왼쪽 피하기'
      }
    }
  }, {
    id: 'DelubrumSav Queen Guard AoEs',
    type: 'StartsUsing',
    // 5A16 from Queen's Warrior
    // 5A08 from Queen's Knight
    // 5A35 from Queen's Gunner
    // 5A23 from Queen's Soldier
    // These happen in sets:
    // Set 1 Double AoE, 3 seconds later Double AoE
    // Set 2 5 seconds later, Double AoE, 3 seconds later Double AoE, 3 seconds later AoE + Bleed
    // Set 3 1.3 seconds later, Single AoEs every 3 seconds all while bleed from set 2 persists
    netRegex: {
      source: ['Queen\'s Warrior', 'Queen\'s Knight', 'Queen\'s Gunner', 'Queen\'s Soldier'],
      id: ['5A16', '5A08', '5A35', '5A23'],
      capture: false
    },
    // Only call out the beginning of a set of two casts
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Multiple AOEs',
        de: 'Mehrere AoEs',
        fr: 'Multiple AoEs',
        ja: '連続AoE',
        cn: '连续AoE',
        ko: '다중 광역공격'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Right-Sided Shockwave/Left-Sided Shockwave': 'Right/Left Shockwave',
      'Left-Sided Shockwave/Right-Sided Shockwave': 'Left/Right Shockwave',
      'Sword Omen/Shield Omen': 'Sword/Shield Omen',
      'Shield Omen/Sword Omen': 'Shield/Sword Omen',
      'Flashvane/Fury Of Bozja/Infernal Slash': 'Random Arsenal',
      'Icy Portent/Fiery Portent': 'Icy/Fiery Portent',
      'Fiery Portent/Icy Portent': 'Fiery/Icy Portent'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      '(?<!Crowned )Marchosias': 'Marchosias',
      'Aetherial Bolt': 'Magiegeschoss',
      'Aetherial Burst': 'Magiebombe',
      'Aetherial Orb': 'Magiekugel',
      'Aetherial Sphere': 'Ätherwind',
      'Aetherial Ward': 'Barriere',
      'Automatic Turret': 'Selbstschuss-Gyrocopter',
      'Avowed Avatar': 'Spaltteil der Eingeschworenen',
      'Ball Lightning': 'Elektrosphäre',
      'Ball Of Fire': 'Feuerball',
      'Bicolor Golem': 'zweifarbig(?:e|er|es|en) Golem',
      'Bozjan Phantom': 'Bozja-Phantom',
      'Bozjan Soldier': 'Bozja-Soldat',
      'Crowned Marchosias': 'Marchosias-Leittier',
      'Dahu': 'Dahu',
      'Dahu was defeated by': 'hat Dahu besiegt',
      'Grim Reaper': 'Grausamer Schlitzer',
      'Gun Turret': 'Geschützturm',
      'Immolating Flame': 'Flammensturm',
      'Pride of the Lion(?!ess)': 'Saal des Löwen',
      'Pride of the Lioness': 'Segen der Löwin',
      'Queen\'s Gunner': 'Schütze der Königin',
      'Queen\'s Knight': 'Ritter der Königin',
      'Queen\'s Soldier': 'Soldat der Königin',
      'Queen\'s Warrior': 'Kriegerin der Königin',
      'Queensheart': 'Saal der Dienerinnen',
      'Ruins Golem': 'Ruinengolem',
      'Sanguine Clot': 'schauerlich(?:e|er|es|en) Blutgerinsel',
      'Seeker Avatar': 'Spaltteil der Sucher',
      'Soldier Avatar': 'Spaltteil des Soldaten',
      'Spark Arrow': 'Feuerpfeil',
      'Spiritual Sphere': 'Seelenwind',
      'Stuffy Wraith': 'muffig(?:e|er|es|en) Schrecken',
      'Stygimoloch Lord': 'Anführer-Stygimoloch',
      'Stygimoloch Monk': 'Stygimoloch',
      'Stygimoloch Warrior': 'Krieger-Stygimoloch',
      'Tempestuous Orb': 'groß(?:e|er|es|en) Eisball',
      'The Hall of Hieromancy': 'Halle des Orakels',
      'The Hall of Supplication': 'Große Gebetshalle',
      'The Path of Divine Clarity': 'Sanktuarium des Lebens',
      'The Queen': 'Kriegsgöttin',
      'The Theater of One': 'Einsame Arena',
      'The Vault of Singing Crystal': 'Ort des Klingenden Kristalls',
      'Trinity Avowed': 'Trinität der Eingeschworenen',
      'Trinity Seeker': 'Trinität der Sucher',
      'Viscous Clot': 'zäh(?:e|er|es|en) Blutgerinsel',
      'Why\\.\\.\\.won\'t\\.\\.\\.you\\.\\.\\.': 'Neiiin! Wie ist das möglich'
    },
    'replaceText': {
      '(?<!C)Rush': 'Stürmen',
      '(?<!Inescapable )Entrapment': 'Fallenlegen',
      '--Spite Check--': '--Meditation Check--',
      '--adds--': '--Adds--',
      '--bleed--': '--Blutung--',
      '--chains--': '--Ketten--',
      '--stunned--': '--betäubt--',
      '--tethers--': '--Verbindungen--',
      '--unstunned--': '--nicht länger betäubt--',
      '1111-Tonze Swing': '1111-Tonzen-Schwung',
      'Above Board': 'Über dem Feld',
      'Act Of Mercy': 'Schneller Stich des Dolches',
      'Allegiant Arsenal': 'Waffenwechsel',
      'Aura Sphere': 'Kampfwind',
      'Automatic Turret': 'Selbstschuss-Gyrocopter',
      'Baleful Blade': 'Stoß der Edelklinge',
      'Baleful Comet': 'Flammenstapel der Edelklinge',
      'Baleful Firestorm': 'Ätherflamme der Edelklinge',
      'Baleful Onslaught': 'Wilder Schlitzer der Edelklinge',
      'Baleful Swathe': 'Schwarzer Wirbel der Edelklinge',
      'Beck And Call To Arms': 'Feuerbefehl',
      'Blade Of Entropy': 'Eisflammenklinge',
      'Blood And Bone': 'Wellenschlag',
      'Bloody Wraith': 'blutrünstiger Schrecken',
      'Bombslinger': 'Bombenabwurf',
      'Boost': 'Kräfte sammeln',
      'Bozjan Soldier': 'Bozja-Soldat',
      'Burn': 'Verbrennung',
      'Cleansing Slash': 'Säubernder Schnitt',
      'Coat Of Arms': 'Trotz',
      'Coerce': 'Zwang',
      'Core Combustion': 'Brennender Kern',
      'Crazed Rampage': 'Gereizter Wutlauf',
      'Creeping Miasma': 'Miasmahauch',
      'Crushing Hoof': 'Tödlicher Druck',
      'Dead Iron': 'Woge der Feuerfaust',
      'Death Scythe': 'Todessichel',
      'Devastating Bolt': 'Heftiger Donner',
      'Devour': 'Verschlingen',
      'Double Gambit': 'Illusionsmagie',
      'Elemental Arrow': 'Element-Pfeil',
      'Elemental Blast': 'Element-Explosion',
      'Elemental Brand': 'Eisflammenfluch',
      'Elemental Impact': 'Einschlag',
      'Empyrean Iniquity': 'Empyreische Interdiktion',
      'Excruciation': 'Fürchterlicher Schmerz',
      'Falling Rock': 'Steinschlag',
      'Fateful Words': 'Worte des Verderbens',
      'Feral Howl': 'Wildes Heulen',
      'Fiery Portent': 'Fieberhitze',
      'Firebreathe': 'Lava-Atem',
      'First Mercy': '1. Streich: Viererdolch-Haltung',
      'Flailing Strike': 'Wirbelnder Schlag',
      'Flames Of Bozja': 'Bozianische Flamme',
      'Flashvane': 'Schockpfeile',
      'Focused Tremor': 'Kontrolliertes Beben',
      'Foe Splitter': 'Tobender Teiler',
      'Fool\'s Gambit': 'Bezauberungsmagie',
      'Forceful Strike': 'Kraftvoller Schlag',
      'Fourth Mercy': '4. Streich: Viererdolch-Haltung',
      'Fracture': 'Sprengung',
      'Freedom Of Bozja': 'Bozianische Freiheit',
      'Fury Of Bozja': 'Bozianische Wut',
      'Gleaming Arrow': 'Funkelnder Pfeil',
      'Glory Of Bozja': 'Stolz von Bozja',
      'Gods Save The Queen': 'Wächtergott der Königin',
      'Great Ball Of Fire': 'Feuerball',
      'Gun Turret': 'Geschützturm',
      'Gunnhildr\'s Blades': 'Gunnhildrs Schwert',
      'Head Down': 'Scharrende Hufe',
      'Heaven\'s Wrath': 'Heilige Perforation',
      'Higher Power': 'Elektrische Ladung',
      'Hot And Cold': 'Heiß und kalt',
      'Hot Charge': 'Heiße Rage',
      'Hunter\'s Claw': 'Jägerklaue',
      'Hysteric Assault': 'Hysterischer Ansturm',
      'Ice Spikes': 'Eisstachel',
      'Icy Portent': 'Frostwinde',
      'Inescapable Entrapment': 'Extrem-Fallenlegen',
      'Infernal Slash': 'Yama-Schnitt',
      'Invert Miasma': 'Umgekehrte Miasmakontrolle',
      'Iron Impact': 'Kanon der Feuerfaust',
      'Iron Rose': 'Rose des Hasses der Feuerfaust',
      'Iron Splitter': 'Furor der Feuerfaust',
      'Judgment Blade': 'Klinge des Urteils',
      'Labyrinthine Fate': 'Fluch des Herren des Labyrinths',
      'Leaping Spark': 'Endloser Donner',
      'Left-Sided Shockwave': 'Linke Schockwelle',
      'Lethal Blow': 'Verheerender Schlag',
      'Lingering Miasma': 'Miasmawolke',
      'Lots Cast': 'Magieexplosion',
      'Maelstrom\'s Bolt': 'Heiligenlichter',
      'Malediction of Agony': 'Pochender Fluch',
      'Malediction of Ruin': 'Fluch des Verfalls',
      'Mana Flame': 'Manaflamme',
      'Manifest Avatar': 'Teilung des Selbsts',
      'Manipulate Miasma': 'Miasmakontrolle',
      'Memory of the Labyrinth': 'Edikt des Herren des Labyrinths',
      'Merciful Arc': 'Fächertanz des Dolches',
      'Merciful Blooms': 'Kasha des Dolches',
      'Merciful Breeze': 'Yukikaze des Dolches',
      'Merciful Moon': 'Gekko des Dolches',
      'Mercy Fourfold': 'Viererdolch',
      'Metamorphose': 'Materiewandel',
      'Misty Wraith': 'flüchtiger Schrecken',
      'Northswain\'s Glow': 'Stella Polaris',
      'Optimal Offensive': 'Beste Attacke',
      'Optimal Play': 'Bestes Manöver',
      'Pawn Off': 'Kranzklinge',
      'Phantom Edge': 'Phantomklingen',
      'Queen\'s Edict': 'Hohes Edikt der Königin',
      'Queen\'s Justice': 'Hoheitliche Strafe',
      'Queen\'s Shot': 'Omnidirektionalschuss',
      'Queen\'s Will': 'Edikt der Königin',
      'Quick March': 'Marschbefehl',
      'Rapid Bolts': 'Kettenblitz',
      'Rapid Sever': 'Radikale Abtrennung',
      'Reading': 'Demontage',
      'Relentless Battery': 'Koordiniertes Manöver',
      'Relentless Play': 'Koordinierter Angriff',
      'Rending Bolt': 'Fallender Donner',
      'Reverberating Roar': 'Einsturzgefahr',
      'Reversal Of Forces': 'Materieinversion',
      'Right-Sided Shockwave': 'Rechte Schockwelle',
      'Ruins Golem': 'Ruinengolem',
      'Sanguine Clot': 'schauerliches Blutgerinsel',
      'Seasons Of Mercy': 'Setsugekka des Dolches',
      'Second Mercy': '2. Streich: Viererdolch-Haltung',
      'Secrets Revealed': 'Enthüllte Geheimnisse',
      'Shield Omen': 'Schildhaltung',
      'Shimmering Shot': 'Glitzerpfeil',
      'Shot In The Dark': 'Einhändiger Schuss',
      'Sniper Shot': 'Fangschuss',
      'Spiritual Sphere': 'Seelenwind',
      'Spit Flame': 'Flammenspucke',
      'Spiteful Spirit': 'Meditation',
      'Strongpoint Defense': 'Absolutschild',
      'Summon Adds': 'Add-Beschwörung',
      'Summon(?! Adds)': 'Beschwörung',
      'Sun\'s Ire': 'Flammenschlag',
      'Surge of Vigor': 'Eifer',
      'Surging Flames': 'Feuerangriff',
      'Surging Flood': 'Wasserangriff',
      'Swirling Miasma': 'Miasmawirbel',
      'Sword Omen': 'Schwerthaltung',
      'The Ends': 'Kreuzschnitt',
      'The Means': 'Kreuzschlag',
      'Third Mercy': '3. Streich: Viererdolch-Haltung',
      'Thunderous Discharge': 'Blitznetz',
      'Turret\'s Tour': 'Querschlägerhagel',
      'Undying Hatred': 'Über-Psychokinese',
      'Unlucky Lot': 'Magiebombe',
      'Unrelenting Charge': 'Ungestümer Ansturm',
      'Unseen Eye': 'Geist des Blütensturms',
      'Unwavering Apparition': 'Geist des Schlächters',
      'Verdant Path': 'Lehren des Grünen Pfades',
      'Verdant Tempest': 'Zauberwind des Grünen Pfades',
      'Vicious Swipe': 'Frenetischer Feger',
      'Vile Wave': 'Welle der Boshaftigkeit',
      'Viscous Clot': 'zähes Blutgerinsel',
      'Weave Miasma': 'Miasmathese',
      'Weight Of Fortune': 'Erdrückende Kraft',
      'Whack': 'Wildes Schlagen',
      'Winds Of Fate': 'Sturm der Gewalt',
      'Winds Of Weight': 'Erdrückender Sturm',
      'Withering Curse': 'Wichtelfluch',
      'Wrath Of Bozja': 'Bozianischer Zorn'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '(?<!Crowned )Marchosias': 'marchosias',
      'Aetherial Bolt': 'petite bombe',
      'Aetherial Burst': 'énorme bombe',
      'Aetherial Orb': 'amas d\'éther élémentaire',
      'Aetherial Sphere': 'sphère d\'éther',
      'Aetherial Ward': 'Barrière magique',
      'Automatic Turret': 'Auto-tourelle',
      'Avowed Avatar': 'clone de la trinité féale',
      'Ball Lightning': 'Orbe de Foudre',
      'Ball Of Fire': 'Boule de flammes',
      'Bicolor Golem': 'golem bicolore',
      'Bozjan Phantom': 'fantôme bozjien',
      'Bozjan Soldier': 'soldat bozjien',
      'Crowned Marchosias': 'marchosias alpha',
      'Dahu': 'dahu',
      'Grim Reaper': 'Couperet funeste',
      'Gun Turret': 'Tourelle dirigée',
      'Immolating Flame': 'grande boule de feu tourbillonnante',
      'Pride of the Lion(?!ess)': 'Hall du Lion',
      'Pride of the Lioness': 'Bénédiction de la Lionne',
      'Queen\'s Gunner': 'fusilier de la reine',
      'Queen\'s Knight': 'chevalier de la reine',
      'Queen\'s Soldier': 'soldat de la reine',
      'Queen\'s Warrior': 'guerrière de la reine',
      'Queensheart': 'Chambre des prêtresses',
      'Ruins Golem': 'golem des ruines',
      'Sanguine Clot': 'caillot terrifiant',
      'Seeker Avatar': 'clone de la trinité soudée',
      'Soldier Avatar': 'double de soldat',
      'Spark Arrow': 'volée de flèches de feu',
      'Spiritual Sphere': 'sphère immatérielle',
      'Stuffy Wraith': 'spectre boursouflé',
      'Stygimoloch Lord': 'seigneur stygimoloch',
      'Stygimoloch Monk': 'stygimoloch',
      'Stygimoloch Warrior': 'guerrier stygimoloch',
      'Tempestuous Orb': 'grande boule de glace',
      'The Hall of Hieromancy': 'Salle des oracles',
      'The Hall of Supplication': 'Grande salle des prières',
      'The Path of Divine Clarity': 'Salle des sages',
      'The Queen': 'Garde-la-Reine',
      'The Theater of One': 'Amphithéâtre en ruines',
      'The Vault of Singing Crystal': 'Chambre des cristaux chantants',
      'Trinity Avowed': 'trinité féale',
      'Trinity Seeker': 'trinité soudée',
      'Viscous Clot': 'caillot visqueux',
      'Why\\.\\.\\.won\'t\\.\\.\\.you\\.\\.\\.': 'Grrroooargh.... Cette humaine... est forte...'
    },
    'replaceText': {
      '\\?': ' ?',
      '--Spite Check--': '--Vague de brutalité--',
      '--adds--': '--adds--',
      '--bleed--': '--saignement--',
      '--chains--': '--chaînes--',
      '--stunned--': '--étourdi(e)--',
      '--tethers--': '--liens--',
      '--unstunned--': '--non étourdi(e)--',
      '(?<!C)Rush': 'Ruée',
      '(?<!Inescapable )Entrapment': 'Pose de pièges',
      '1111-Tonze Swing': 'Swing de 1111 tonz',
      'Above Board': 'Aire de flottement',
      'Act Of Mercy': 'Fendreciel rédempteur',
      'Allegiant Arsenal': 'Changement d\'arme',
      'Aura Sphere': 'sphère de brutalité',
      'Automatic Turret': 'Auto-tourelle',
      'Baleful Blade': 'Assaut singulier',
      'Baleful Comet': 'Choc des flammes singulier',
      'Baleful Firestorm': 'Ruée de flammes singulière',
      'Baleful Onslaught': 'Fendoir singulier',
      'Baleful Swathe': 'Flux de noirceur singulier',
      'Beck And Call To Arms': 'Ordre d\'attaquer',
      'Blade Of Entropy': 'Sabre du feu et de la glace',
      'Blood And Bone': 'Onde tranchante',
      'Bloody Wraith': 'spectre sanglant',
      'Bombslinger': 'Jet de bombe',
      'Boost': 'Renforcement',
      'Bozjan Soldier': 'soldat bozjien',
      'Burn': 'Combustion',
      'Cleansing Slash': 'Taillade purifiante',
      'Coat Of Arms': 'Bouclier directionnel',
      'Coerce': 'Ordre irrefusable',
      'Core Combustion': 'Noyau brûlant',
      'Crazed Rampage': 'Tranchage final',
      'Creeping Miasma': 'Coulée miasmatique',
      'Crushing Hoof': 'Saut pesant',
      'Dead Iron': 'Vague des poings de feu',
      'Death Scythe': 'Faux de la mort',
      'Devastating Bolt': 'Cercle de foudre',
      'Devour': 'Dévoration',
      'Double Gambit': 'Manipulation des ombres',
      'Elemental Arrow': 'Flèche élémentaire',
      'Elemental Blast': 'Explosion élémentaire',
      'Elemental Brand': 'Malédiction du feu et de la glace',
      'Elemental Impact': 'Impact',
      'Empyrean Iniquity': 'Injustice empyréenne',
      'Excruciation': 'Atroce douleur',
      'Falling Rock': 'Chute de pierre',
      'Fateful Words': 'Mots de calamité',
      'Feral Howl': 'Rugissement sauvage',
      'Fiery Portent/Icy Portent': 'Rideau de flammes/givre',
      'Firebreathe': 'Souffle de lave',
      'First Mercy': 'Première lame rédemptrice',
      'Flailing Strike': 'Hachage rotatif',
      'Flames Of Bozja': 'Flammes de Bozja',
      'Flashvane(?!/)': 'Flèches fulgurantes',
      'Flashvane/Fury Of Bozja/Infernal Slash': 'Arsenal aléatoire',
      'Focused Tremor': 'Séisme localisé',
      'Foe Splitter': 'Fendoir horizontal',
      'Fool\'s Gambit': 'Manipulation des sens',
      'Forceful Strike': 'Hachage surpuissant',
      'Fourth Mercy': 'Quatrième lame rédemptrice',
      'Fracture': 'Fracture',
      'Freedom Of Bozja': 'Liberté de Bozja',
      '(?<!/)Fury Of Bozja(?!/)': 'Furie de Bozja',
      'Gleaming Arrow': 'Flèche miroitante',
      'Glory Of Bozja': 'Gloire de Bozja',
      'Gods Save The Queen': 'Que les Dieux gardent la Reine',
      'Great Ball Of Fire': 'Boule de feu tourbillonante',
      'Gun Turret': 'Tourelle dirigée',
      'Gunnhildr\'s Blades': 'Lame de Gunnhildr',
      'Head Down': 'Charge bestiale',
      'Heaven\'s Wrath': 'Ire céleste',
      'Higher Power': 'Charge électrique',
      'Hot And Cold': 'Chaud et froid',
      'Hot Charge': 'Charge brûlante',
      'Hunter\'s Claw': 'Griffes prédatrices',
      'Hysteric Assault': 'Assaut forcené',
      'Ice Spikes': 'Pointes de glace',
      'Icy Portent/Fiery Portent': 'Rideau de givre/flammes',
      'Inescapable Entrapment': 'Parterre de pièges',
      '(?<!/)Infernal Slash': 'Taillade de Yama',
      'Invert Miasma': 'Contrôle des miasmes inversé',
      'Iron Impact': 'Canon d\'ardeur des poings de feu',
      'Iron Rose': 'Canon de pugnacité des poings de feu',
      'Iron Splitter': 'Fracas des poings de feu',
      'Judgment Blade': 'Lame du jugement',
      'Labyrinthine Fate': 'Malédiction du seigneur du dédale',
      'Leaping Spark': 'Éclairs en série',
      'Left-Sided Shockwave/Right-Sided Shockwave': 'Onde de choc gauche/droite',
      'Lethal Blow': 'Charge ultime',
      'Lingering Miasma': 'Nuage miasmatique',
      'Lots Cast': 'Bombe ensorcelée',
      'Maelstrom\'s Bolt': 'Fulmination',
      'Malediction of Agony': 'Malédiction lancinante',
      'Malediction of Ruin': 'Malédiction dévastatrice',
      'Mana Flame': 'Flammes de mana',
      'Manifest Avatar': 'Clonage',
      'Manipulate Miasma': 'Contrôle des miasmes',
      'Memory of the Labyrinth': 'Appel du seigneur du dédale',
      'Merciful Arc': 'Éventail rédempteur',
      'Merciful Blooms': 'Kasha rédempteur',
      'Merciful Breeze': 'Yukikaze rédempteur',
      'Merciful Moon': 'Gekkô rédempteur',
      'Mercy Fourfold': 'Quatuor de lames rédemptrices',
      'Metamorphose': 'Nature changeante',
      'Misty Wraith': 'spectre vaporeux',
      'Northswain\'s Glow': 'Étoile du Nord',
      'Optimal Offensive': 'Charge de maître d\'armes',
      'Optimal Play': 'Technique de maître d\'armes',
      'Pawn Off': 'Sabre tournoyant',
      'Phantom Edge': 'Épées spectrales',
      'Queen\'s Edict': 'Injonction de Gunnhildr',
      'Queen\'s Justice': 'Châtiment royal',
      'Queen\'s Shot': 'Tir tous azimuts',
      'Queen\'s Will': 'Édit de Gunnhildr',
      'Quick March': 'Ordre de marche',
      'Rapid Bolts': 'Torrent d\'éclairs',
      'Rapid Sever': 'Tranchage rapide',
      'Reading': 'Analyse des faiblesses',
      'Relentless Battery': 'Attaque coordonnée',
      'Relentless Play': 'Ordre d\'attaque coordonnée',
      'Rending Bolt': 'Pluie de foudre',
      'Reverberating Roar': 'Cri disloquant',
      'Reversal Of Forces': 'Inversion des masses',
      'Right-Sided Shockwave/Left-Sided Shockwave': 'Onde de choc droite/gauche',
      'Ruins Golem': 'golem des ruines',
      'Sanguine Clot': 'caillot terrifiant',
      'Seasons Of Mercy': 'Setsugekka rédempteur',
      'Second Mercy': 'Deuxième lame rédemptrice',
      'Secrets Revealed': 'Corporification',
      'Shield Omen/Sword Omen': 'Posture du bouclier/épée',
      'Shimmering Shot': 'Flèches scintillantes',
      'Shot In The Dark': 'Tir à une main',
      'Sniper Shot': 'Entre les yeux',
      'Spiritual Sphere': 'sphère immatérielle',
      'Spit Flame': 'Crachat enflammé',
      'Spiteful Spirit': 'Sphère de brutalité',
      'Strongpoint Defense': 'Défense absolue',
      'Summon(?! Adds)': 'Invocation',
      'Summon Adds': 'Ajouts d\'invocation',
      'Sun\'s Ire': 'Ire ardente',
      'Surge of Vigor': 'Zèle',
      'Surging Flames': 'Déferlante de feu',
      'Surging Flood': 'Déferlante d\'eau',
      'Swirling Miasma': 'Anneau miasmatique',
      'Sword Omen/Shield Omen': 'Posture de l\'épée/bouclier',
      'The Ends': 'Croix lacérante',
      'The Means': 'Croix perforante',
      'Third Mercy': 'Troisième lame rédemptrice',
      'Thunderous Discharge': 'Déflagration de foudre',
      'Turret\'s Tour': 'Ricochets frénétiques',
      'Undying Hatred': 'Psychokinèse',
      'Unlucky Lot': 'Déflagration éthérée',
      'Unrelenting Charge': 'Charge frénétique',
      'Unseen Eye': 'Spectres de l\'ouragan de fleurs',
      'Unwavering Apparition': 'Spectres du chevalier implacable',
      'Verdant Path': 'École de la Voie verdoyante',
      'Verdant Tempest': 'Tempête de la Voie verdoyante',
      'Vicious Swipe': 'Vrille tranchante',
      'Vile Wave': 'Vague de malveillance',
      'Viscous Clot': 'caillot visqueux',
      'Weave Miasma': 'Miasmologie',
      'Weight Of Fortune': 'Pesanteur excessive',
      'Whack': 'Tannée',
      'Winds Of Fate': 'Tornade puissante',
      'Winds Of Weight': 'Pesanteur et légèreté',
      'Withering Curse': 'Malédiction de nanisme',
      'Wrath Of Bozja': 'Courroux de Bozja'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      '(?<!Crowned )Marchosias': 'マルコシアス',
      'Aetherial Bolt': '魔弾',
      'Aetherial Burst': '大魔弾',
      'Aetherial Orb': '魔力塊',
      'Aetherial Sphere': '魔気',
      'Aetherial Ward': '魔法障壁',
      'Automatic Turret': 'オートタレット',
      'Avowed Avatar': 'アヴァウドの分体',
      'Ball Lightning': '雷球',
      'Ball Of Fire': '火炎球',
      'Bicolor Golem': 'バイカラー・ゴーレム',
      'Bozjan Phantom': 'ボズヤ・ファントム',
      'Bozjan Soldier': 'ボズヤ・ソルジャー',
      'Crowned Marchosias': 'アルファ・マルコシアス',
      'Dahu': 'ダウー',
      'Grim Reaper': 'グリムクリーバー',
      'Gun Turret': 'ガンタレット',
      'Immolating Flame': '大火焔',
      'Pride of the Lion(?!ess)': '雄獅子の広間',
      'Pride of the Lioness': '雌獅子の加護',
      'Queen\'s Gunner': 'クイーンズ・ガンナー',
      'Queen\'s Knight': 'クイーンズ・ナイト',
      'Queen\'s Soldier': 'クイーンズ・ソルジャー',
      'Queen\'s Warrior': 'クイーンズ・ウォリアー',
      'Queensheart': '巫女たちの広間',
      'Ruins Golem': 'ルーイン・ゴーレム',
      'Sanguine Clot': 'オウガリッシュ・クロット',
      'Seeker Avatar': 'シーカーの分体',
      'Soldier Avatar': 'ソルジャーの分体',
      'Spark Arrow': 'ファイアアロー',
      'Spiritual Sphere': '霊気',
      'Stuffy Wraith': 'スタフィー・レイス',
      'Stygimoloch Lord': 'スティギモロク・ロード',
      'Stygimoloch Monk': 'スティギモロク',
      'Stygimoloch Warrior': 'スティギモロク・ウォリアー',
      'Tempestuous Orb': '大氷球',
      'The Hall of Hieromancy': '託宣所',
      'The Hall of Supplication': '大祈祷所',
      'The Path of Divine Clarity': '命の至聖所',
      'The Queen': 'セイブ・ザ・クイーン',
      'The Theater of One': '円形劇場跡',
      'The Vault of Singing Crystal': '響き合う水晶の間',
      'Trinity Avowed': 'トリニティ・アヴァウド',
      'Trinity Seeker': 'トリニティ・シーカー',
      'Viscous Clot': 'ヴィスカス・クロット',
      'Why\\.\\.\\.won\'t\\.\\.\\.you\\.\\.\\.': 'グオオオォォ…… 敗レル……ナンテ……'
    },
    'replaceText': {
      '(?<!C)Rush': '突進',
      '(?<!Inescapable )Entrapment': '掛罠',
      '--adds--': '--雑魚--',
      '--chains--': '--鎖--',
      '1111-Tonze Swing': '1111トンズ・スイング',
      'Above Board': '浮遊波',
      'Act Of Mercy': '破天鋭刃風',
      'Allegiant Arsenal': 'ウェポンチェンジ',
      'Aura Sphere': '闘気',
      'Automatic Turret': 'オートタレット',
      'Baleful Blade': '豪剣強襲撃',
      'Baleful Comet': '豪剣焔襲撃',
      'Baleful Firestorm': '豪剣魔炎旋',
      'Baleful Onslaught': '豪剣激烈斬',
      'Baleful Swathe': '豪剣黒流破',
      'Beck And Call To Arms': '攻撃命令',
      'Blade Of Entropy': '氷炎刃',
      'Blood And Bone': '波動斬',
      'Bloody Wraith': 'ブラッディ・レイス',
      'Bombslinger': '爆弾投擲',
      'Boost': 'ためる',
      'Bozjan Soldier': 'ボズヤ・ソルジャー',
      'Burn': '燃焼',
      'Cleansing Slash': '乱命割殺斬',
      'Coat Of Arms': '偏向防御',
      'Coerce': '強要',
      'Core Combustion': '心核熱',
      'Crazed Rampage': 'キリキリ舞い',
      'Creeping Miasma': '瘴気流',
      'Crushing Hoof': '重圧殺',
      'Dead Iron': '熱拳振動波',
      'Death Scythe': 'デスサイズ',
      'Devastating Bolt': '激雷',
      'Devour': '捕食',
      'Double Gambit': '幻影術',
      'Elemental Brand': '氷炎の呪印',
      'Elemental Impact': '着弾',
      'Empyrean Iniquity': '天魔鬼神爆',
      'Excruciation': '激痛',
      'Falling Rock': '落石',
      'Fateful Words': '呪いの言葉',
      'Feral Howl': 'フェラルハウル',
      'Fiery Portent': '熱気術',
      'Firebreathe': 'ラーヴァブレス',
      'First Mercy': '初手：鋭刃四刀の構え',
      'Flailing Strike': '回転乱打',
      'Flames Of Bozja': 'フレイム・オブ・ボズヤ',
      'Flashvane': 'フラッシュアロー',
      'Focused Tremor': '局所地震',
      'Foe Splitter': 'マキ割り',
      'Fool\'s Gambit': '幻惑術',
      'Forceful Strike': '剛力の一撃',
      'Fourth Mercy': '四手：鋭刃四刀の構え',
      'Fracture': '炸裂',
      'Freedom Of Bozja': 'リバティ・オブ・ボズヤ',
      'Fury Of Bozja': 'フューリー・オブ・ボズヤ',
      'Gleaming Arrow': 'グリッターアロー',
      'Glory Of Bozja': 'グローリー・オブ・ボズヤ',
      'Gods Save The Queen': 'ゴッド・セイブ・ザ・クイーン',
      'Great Ball Of Fire': '火球',
      'Gun Turret': 'ガンタレット',
      'Gunnhildr\'s Blades': 'グンヒルドの剣',
      'Head Down': 'ビーストチャージ',
      'Heaven\'s Wrath': '聖光爆裂斬',
      'Higher Power': '雷気充填',
      'Hot And Cold': '氷炎乱流',
      'Hot Charge': 'ホットチャージ',
      'Hunter\'s Claw': 'ハンタークロウ',
      'Hysteric Assault': 'ヒステリックアサルト',
      'Ice Spikes': 'アイススパイク',
      'Icy Portent': '冷気術',
      'Inescapable Entrapment': '掛罠祭り',
      'Infernal Slash': 'ヤーマスラッシュ',
      'Invert Miasma': '反転瘴気操作',
      'Iron Impact': '熱拳烈気砲',
      'Iron Rose': '熱拳闘気砲',
      'Iron Splitter': '熱拳地脈爆',
      'Judgment Blade': '不動無明剣',
      'Labyrinthine Fate': '迷宮王の呪い',
      'Leaping Spark': '連雷',
      'Left-Sided Shockwave': 'レフトサイド・ショックウェーブ',
      'Lethal Blow': '必殺の一撃',
      'Lingering Miasma': '瘴気雲',
      'Lots Cast': '魔爆発',
      'Maelstrom\'s Bolt': '天鼓雷音稲妻斬',
      'Malediction of Agony': '苦悶の呪詛',
      'Malediction of Ruin': '破滅の呪詛',
      'Mana Flame': 'マナフレイム',
      'Manifest Avatar': '分体生成',
      'Manipulate Miasma': '瘴気操作',
      'Memory of the Labyrinth': '迷宮王の大号令',
      'Merciful Arc': '鋭刃舞踏扇',
      'Merciful Blooms': '鋭刃花車',
      'Merciful Breeze': '鋭刃雪風',
      'Merciful Moon': '鋭刃月光',
      'Mercy Fourfold': '鋭刃四刀流',
      'Metamorphose': '性質変化',
      'Misty Wraith': 'ミスティ・レイス',
      'Northswain\'s Glow': '北斗骨砕斬',
      'Optimal Offensive': '武装突撃',
      'Optimal Play': '武装戦技',
      'Pawn Off': '旋回刃',
      'Phantom Edge': '霊幻剣',
      'Queen\'s Edict': '女王の大勅令',
      'Queen\'s Justice': '処罰令',
      'Queen\'s Shot': '全方位射撃',
      'Queen\'s Will': '女王の勅令',
      'Quick March': '行軍命令',
      'Rapid Bolts': '多重雷',
      'Rapid Sever': '滅多斬り',
      'Reading': '解析',
      'Relentless Battery': '連携戦技',
      'Relentless Play': '連携命令',
      'Rending Bolt': '雷鳴落',
      'Reverberating Roar': '崩落誘発',
      'Reversal Of Forces': '質量転換',
      'Right-Sided Shockwave': 'ライトサイド・ショックウェーブ',
      'Ruins Golem': 'ルーイン・ゴーレム',
      'Sanguine Clot': 'オウガリッシュ・クロット',
      'Seasons Of Mercy': '鋭刃雪月花',
      'Second Mercy': '二手：鋭刃四刀の構え',
      'Secrets Revealed': '実体結像',
      'Shield Omen': '盾の型',
      'Shimmering Shot': 'トゥインクルアロー',
      'Shot In The Dark': '片手撃ち',
      'Sniper Shot': '狙撃',
      'Spiritual Sphere': '霊気',
      'Spit Flame': 'フレイムスピット',
      'Spiteful Spirit': '闘気',
      'Strongpoint Defense': '絶対防御',
      'Summon Adds': '雑魚召喚',
      'Summon(?! Adds)': '召喚',
      'Sun\'s Ire': '焼討ち',
      'Surge of Vigor': '奮発',
      'Surging Flames': '火攻め',
      'Surging Flood': '水攻め',
      'Swirling Miasma': '瘴気輪',
      'Sword Omen': '剣の型',
      'The Ends': '十字斬',
      'The Means': '十字撃',
      'Third Mercy': '三手：鋭刃四刀の構え',
      'Thunderous Discharge': '雷気発散',
      'Turret\'s Tour': '跳弾乱舞',
      'Undying Hatred': '超ねんりき',
      'Unlucky Lot': '魔爆',
      'Unrelenting Charge': '爆進',
      'Unseen Eye': '花嵐の幻影',
      'Unwavering Apparition': '羅刹の幻影',
      'Verdant Path': '翠流派',
      'Verdant Tempest': '翠流魔風塵',
      'Vicious Swipe': 'キリ揉み',
      'Vile Wave': '悪意の波動',
      'Viscous Clot': 'ヴィスカス・クロット',
      'Weave Miasma': '瘴気術',
      'Weight Of Fortune': '過重力',
      'Whack': '乱打',
      'Winds Of Fate': '大烈風',
      'Winds Of Weight': '過重烈風',
      'Withering Curse': 'こびとの呪い',
      'Wrath Of Bozja': 'ラース・オブ・ボズヤ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '(?<!Crowned )Marchosias': '马可西亚斯',
      'Aetherial Bolt': '魔弹',
      'Aetherial Burst': '大魔弹',
      'Aetherial Orb': '魔力块',
      'Aetherial Sphere': '魔气',
      'Aetherial Ward': '魔法障壁',
      'Automatic Turret': '自动炮塔',
      'Avowed Avatar': '誓约之分身',
      'Ball Lightning': '雷球',
      'Ball Of Fire': '火球',
      'Bicolor Golem': '双色巨像',
      'Bozjan Phantom': '博兹雅幻灵',
      'Bozjan Soldier': '博兹雅士兵',
      'Crowned Marchosias': '首领马可西亚斯',
      'Dahu': '大兀',
      'Grim Reaper': '死亡收割者',
      'Gun Turret': '射击炮台',
      'Immolating Flame': '大火焰',
      'Pride of the Lion(?!ess)': '雄狮大厅',
      'Pride of the Lioness': '雌狮大厅',
      'Queen\'s Gunner': '女王枪手',
      'Queen\'s Knight': '女王骑士',
      'Queen\'s Soldier': '女王士兵',
      'Queen\'s Warrior': '女王战士',
      'Queensheart': '巫女大厅',
      'Ruins Golem': '毁灭巨像',
      'Sanguine Clot': '血色凝块',
      'Seeker Avatar': '求道之分身',
      'Soldier Avatar': '士兵的分身',
      'Spark Arrow': '火光箭',
      'Spiritual Sphere': '灵气',
      'Stuffy Wraith': '沉闷幽灵',
      'Stygimoloch Lord': '冥河之王',
      'Stygimoloch Monk': '冥河武僧',
      'Stygimoloch Warrior': '冥河战士',
      'Tempestuous Orb': '大冰球',
      'The Hall of Hieromancy': '神谕所',
      'The Hall of Supplication': '大祈祷所',
      'The Path of Divine Clarity': '生命至圣所',
      'The Queen': '天佑女王',
      'The Theater of One': '圆形剧场遗迹',
      'The Vault of Singing Crystal': '和鸣水晶之间',
      'Trinity Avowed': '誓约之三位一体',
      'Trinity Seeker': '求道之三位一体',
      'Viscous Clot': '粘液凝块',
      'Why\\.\\.\\.won\'t\\.\\.\\.you\\.\\.\\.': '呜哦哦哦哦…… 难道会……输掉吗……'
    },
    'replaceText': {
      '(?<!C)Rush': '突进',
      '(?<!Inescapable )Entrapment': '设置陷阱',
      '--Spite Check--': '--斗气波--',
      '--adds--': '--小怪--',
      '--bleed--': '--出血--',
      '--chains--': '--锁链--',
      '--stunned--': '--眩晕--',
      '--tethers--': '--连线--',
      '--unstunned--': '--眩晕结束--',
      '1111-Tonze Swing': '千百十一吨回转',
      'Above Board': '浮游波',
      'Act Of Mercy': '破天慈刃风',
      'Allegiant Arsenal': '变换武器',
      'Aura Sphere': '斗气',
      'Automatic Turret': '自动炮塔',
      'Baleful Blade': '豪剑强袭击',
      'Baleful Comet': '豪剑焰袭击',
      'Baleful Firestorm': '豪剑魔炎旋',
      'Baleful Onslaught': '豪剑激烈斩',
      'Baleful Swathe': '豪剑黑流破',
      'Beck And Call To Arms': '攻击命令',
      'Blade Of Entropy': '冰炎刃',
      'Blood And Bone': '波动斩',
      'Bloody Wraith': '血腥幽灵',
      'Bombslinger': '投掷炸弹',
      'Boost': '蓄力',
      'Bozjan Soldier': '博兹雅士兵',
      'Burn': '燃烧',
      'Cleansing Slash': '乱命割杀斩',
      'Coat Of Arms': '偏向防御',
      'Coerce': '强迫',
      'Core Combustion': '核心燃烧',
      'Crazed Rampage': '狂暴乱舞',
      'Creeping Miasma': '瘴气流',
      'Crushing Hoof': '重压杀',
      'Dead Iron': '热拳振动波',
      'Death Scythe': '死镰',
      'Devastating Bolt': '激雷',
      'Devour': '捕食',
      'Double Gambit': '幻影术',
      'Elemental Arrow': '元素箭',
      'Elemental Blast': '元素爆破',
      'Elemental Brand': '冰炎咒印',
      'Elemental Impact': '中弹',
      'Empyrean Iniquity': '天魔鬼神爆',
      'Excruciation': '剧痛',
      'Falling Rock': '落石',
      'Fateful Words': '诅咒的危言',
      'Feral Howl': '野性嚎叫',
      'Fiery Portent': '热浪术',
      'Firebreathe': '岩浆吐息',
      'First Mercy': '慈悲四刀第一念',
      'Flailing Strike': '回转乱打',
      'Flames Of Bozja': '博兹雅火焰',
      'Flashvane': '闪光箭',
      'Focused Tremor': '局部地震',
      'Foe Splitter': '劈裂',
      'Fool\'s Gambit': '幻惑术',
      'Forceful Strike': '刚力一击',
      'Fourth Mercy': '慈悲四刀第四念',
      'Fracture': '炸裂',
      'Freedom Of Bozja': '博兹雅之自由',
      'Fury Of Bozja': '博兹雅之怒',
      'Gleaming Arrow': '闪耀箭',
      'Glory Of Bozja': '博兹雅之荣',
      'Gods Save The Queen': '神佑女王',
      'Great Ball Of Fire': '火球',
      'Gun Turret': '射击炮台',
      'Gunnhildr\'s Blades': '女王之刃',
      'Head Down': '兽性冲击',
      'Heaven\'s Wrath': '圣光爆裂斩',
      'Higher Power': '雷气充填',
      'Hot And Cold': '冰炎乱流',
      'Hot Charge': '炽热冲锋',
      'Hunter\'s Claw': '狩猎者之爪',
      'Hysteric Assault': '癫狂突袭',
      'Ice Spikes': '冰棘屏障',
      'Icy Portent': '寒气术',
      'Inescapable Entrapment': '陷阱狂欢',
      'Infernal Slash': '地狱斩',
      'Invert Miasma': '瘴气反转',
      'Iron Impact': '热拳烈气炮',
      'Iron Rose': '热拳斗气炮',
      'Iron Splitter': '热拳地脉爆',
      'Judgment Blade': '不动无明剑',
      'Labyrinthine Fate': '迷宫王的诅咒',
      'Leaping Spark': '连雷',
      'Left-Sided Shockwave': '左侧震荡波',
      'Lethal Blow': '必杀一击',
      'Lingering Miasma': '瘴气云',
      'Lots Cast': '魔爆炸',
      'Maelstrom\'s Bolt': '天鼓雷音惊电斩',
      'Malediction of Agony': '苦闷的诅咒',
      'Malediction of Ruin': '破灭的诅咒',
      'Mana Flame': '魔力之炎',
      'Manifest Avatar': '生成分裂体',
      'Manipulate Miasma': '操作瘴气',
      'Memory of the Labyrinth': '迷宫王的大号令',
      'Merciful Arc': '慈悲舞动扇',
      'Merciful Blooms': '慈悲花车',
      'Merciful Breeze': '慈悲雪风',
      'Merciful Moon': '慈悲月光',
      'Mercy Fourfold': '慈悲四刀流',
      'Metamorphose': '变换属性',
      'Misty Wraith': '迷雾幽灵',
      'Northswain\'s Glow': '北斗骨碎斩',
      'Optimal Offensive': '武装突击',
      'Optimal Play': '武装战技',
      'Pawn Off': '旋回刃',
      'Phantom Edge': '灵幻剑',
      'Queen\'s Edict': '女王的大敕令',
      'Queen\'s Justice': '处罚令',
      'Queen\'s Shot': '全方位射击',
      'Queen\'s Will': '女王的敕令',
      'Quick March': '行军指令',
      'Rapid Bolts': '多重雷',
      'Rapid Sever': '急促斩击',
      'Reading': '解析',
      'Relentless Battery': '协作战技',
      'Relentless Play': '协作指令',
      'Rending Bolt': '雷鸣落',
      'Reverberating Roar': '引发崩塌',
      'Reversal Of Forces': '质量转换',
      'Right-Sided Shockwave': '右侧震荡波',
      'Ruins Golem': '毁灭巨像',
      'Sanguine Clot': '血色凝块',
      'Seasons Of Mercy': '慈悲雪月花',
      'Second Mercy': '慈悲四刀第二念',
      'Secrets Revealed': '实体成像',
      'Shield Omen': '盾型',
      'Shimmering Shot': '闪烁箭',
      'Shot In The Dark': '单手射击',
      'Sniper Shot': '狙击',
      'Spiritual Sphere': '灵气',
      'Spit Flame': '火涎',
      'Spiteful Spirit': '斗气',
      'Strongpoint Defense': '绝对防御',
      'Summon Adds': '召唤小怪',
      'Summon(?! Adds)': '召唤',
      'Sun\'s Ire': '太阳之怒',
      'Surge of Vigor': '奋发',
      'Surging Flames': '火攻',
      'Surging Flood': '水攻',
      'Swirling Miasma': '瘴气圈',
      'Sword Omen': '剑型',
      'The Ends': '十字斩',
      'The Means': '十字击',
      'Third Mercy': '慈悲四刀第三念',
      'Thunderous Discharge': '雷气散发',
      'Turret\'s Tour': '跳弹乱舞',
      'Undying Hatred': '超念力',
      'Unlucky Lot': '魔爆',
      'Unrelenting Charge': '高速冲锋',
      'Unseen Eye': '风花舞的幻影',
      'Unwavering Apparition': '罗刹的幻影',
      'Verdant Path': '翠青流',
      'Verdant Tempest': '翠青魔风尘',
      'Vicious Swipe': '狂暴回转',
      'Vile Wave': '恶意的波动',
      'Viscous Clot': '粘液凝块',
      'Weave Miasma': '瘴气术',
      'Weight Of Fortune': '过重力',
      'Whack': '乱打',
      'Winds Of Fate': '大烈风',
      'Winds Of Weight': '过重烈风',
      'Withering Curse': '小人诅咒',
      'Wrath Of Bozja': '博兹雅之愤'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '(?<!Crowned )Marchosias': '마르코시아스',
      'Aetherial Bolt': '마탄',
      'Aetherial Burst': '대마탄',
      'Aetherial Orb': '마력 덩어리',
      'Aetherial Sphere': '마기',
      'Aetherial Ward': '마법 장벽',
      'Automatic Turret': '자동포탑',
      'Avowed Avatar': '맹세의 분열체',
      'Ball Lightning': '뇌구',
      'Ball Of Fire': '화염구',
      'Bicolor Golem': '두 빛깔 골렘',
      'Bozjan Phantom': '보즈야 유령',
      'Bozjan Soldier': '보즈야 병사',
      'Crowned Marchosias': '우두머리 마르코시아스',
      'Dahu': '다후',
      'Grim Reaper': '음산한 난도자',
      'Gun Turret': '총포탑',
      'Immolating Flame': '대화염',
      'Pride of the Lion(?!ess)': '수사자의 방',
      'Pride of the Lioness': '암사자의 방',
      'Queen\'s Gunner': '여왕의 총사',
      'Queen\'s Knight': '여왕의 기사',
      'Queen\'s Soldier': '여왕의 병사',
      'Queen\'s Warrior': '여왕의 전사',
      'Queensheart': '무녀들의 방',
      'Ruins Golem': '유적 골렘',
      'Sanguine Clot': '핏빛 멍울',
      'Seeker Avatar': '탐구의 분열체',
      'Soldier Avatar': '병사 분열체',
      'Spark Arrow': '불꽃 화살',
      'Spiritual Sphere': '영기',
      'Stuffy Wraith': '케케묵은 망령',
      'Stygimoloch Lord': '스티키몰로크 군주',
      'Stygimoloch Monk': '스티키몰로크',
      'Stygimoloch Warrior': '스티기몰로크 전사',
      'Tempestuous Orb': '거대 얼음 구체',
      'The Hall of Hieromancy': '신탁소',
      'The Hall of Supplication': '대기도소',
      'The Path of Divine Clarity': '생명의 지성소',
      'The Queen': '세이브 더 퀸',
      'The Theater of One': '원형 극장 옛터',
      'The Vault of Singing Crystal': '공명하는 수정의 방',
      'Trinity Avowed': '맹세의 삼위일체',
      'Trinity Seeker': '탐구의 삼위일체',
      'Viscous Clot': '찐득한 멍울',
      'Why\\.\\.\\.won\'t\\.\\.\\.you\\.\\.\\.': '그어어어어…… 내가…… 지다니……'
    },
    'replaceText': {
      '(?<!C)Rush': '돌진',
      '(?<!Inescapable )Entrapment': '함정 놓기',
      '--Spite Check--': '--투기파--',
      '--adds--': '--쫄--',
      '--bleed--': '--고통--',
      '--chains--': '--사슬--',
      '--stunned--': '--기절--',
      '--tethers--': '--선 연결--',
      '--unstunned--': '--기절풀림--',
      '1111-Tonze Swing': '1111톤즈 휘두르기',
      'Above Board': '부유파',
      'Act Of Mercy': '예리한 파천풍',
      'Allegiant Arsenal': '무기 변경',
      'Aura Sphere': '투기',
      'Automatic Turret': '자동포탑',
      'Baleful Blade': '호검 강습 공격',
      'Baleful Comet': '호검 화염 습격',
      'Baleful Firestorm': '호검 마염선',
      'Baleful Onslaught': '호검 격렬참',
      'Baleful Swathe': '호검 흑류파',
      'Beck And Call To Arms': '공격 명령',
      'Blade Of Entropy': '얼음불 칼날',
      'Blood And Bone': '파동참',
      'Bloody Wraith': '핏빛 망령',
      'Bombslinger': '폭탄 투척',
      'Boost': '힘 모으기',
      'Bozjan Soldier': '보즈야 병사',
      'Burn': '연소',
      'Cleansing Slash': '난명할살참',
      'Coat Of Arms': '편향 방어',
      'Coerce': '강요',
      'Core Combustion': '심핵열',
      'Crazed Rampage': '나사 튕기기',
      'Creeping Miasma': '독기 흐름',
      'Crushing Hoof': '육중한 압살',
      'Dead Iron': '불주먹 진동파',
      'Death Scythe': '죽음의 낫',
      'Devastating Bolt': '격뢰',
      'Devour': '포식',
      'Double Gambit': '환영술',
      'Elemental Arrow': '속성 화살',
      'Elemental Blast': '속성 운석 폭발',
      'Elemental Brand': '얼음불 저주',
      'Elemental Impact': '착탄',
      'Empyrean Iniquity': '천마귀신폭',
      'Excruciation': '격통',
      'Falling Rock': '낙석',
      'Fateful Words': '저주의 말',
      'Feral Howl': '야성의 포효',
      'Fiery Portent': '열기술',
      'Firebreathe': '용암숨',
      'First Mercy': '예리한 첫 번째 검',
      'Flailing Strike': '회전 난타',
      'Flames Of Bozja': '보즈야 플레임',
      'Flashvane': '섬광 화살',
      'Focused Tremor': '국소 지진',
      'Foe Splitter': '장작 패기',
      'Fool\'s Gambit': '환혹술',
      'Forceful Strike': '강력한 일격',
      'Fourth Mercy': '예리한 네 번째 검',
      'Fracture': '작렬',
      'Freedom Of Bozja': '보즈야의 자유',
      'Fury Of Bozja': '보즈야의 분노',
      'Gleaming Arrow': '현란한 화살',
      'Glory Of Bozja': '보즈야의 영광',
      'Gods Save The Queen': '갓 세이브 더 퀸',
      'Great Ball Of Fire': '불덩이',
      'Gun Turret': '총포탑',
      'Gunnhildr\'s Blades': '군힐드의 검',
      'Head Down': '야수 돌격',
      'Heaven\'s Wrath': '성광폭렬참',
      'Higher Power': '화력 보강',
      'Hot And Cold': '빙염난류',
      'Hot Charge': '맹렬한 돌진',
      'Hunter\'s Claw': '사냥꾼의 발톱',
      'Hysteric Assault': '발작 습격',
      'Ice Spikes': '얼음 보호막',
      'Icy Portent': '냉기술',
      'Inescapable Entrapment': '함정 대잔치',
      'Infernal Slash': '연옥 베기',
      'Invert Miasma': '반전 독기 조작',
      'Iron Impact': '불주먹 열기포',
      'Iron Rose': '불주먹 투기포',
      'Iron Splitter': '불주먹 지맥 폭발',
      'Judgment Blade': '부동무명검',
      'Labyrinthine Fate': '미궁왕의 저주',
      'Leaping Spark': '연속 번개',
      'Left-Sided Shockwave': '왼쪽 충격파',
      'Lethal Blow': '필살의 일격',
      'Lingering Miasma': '독기 구름',
      'Lots Cast': '마폭발',
      'Maelstrom\'s Bolt': '천고뇌음 번개 베기',
      'Malediction of Agony': '고통의 저주',
      'Malediction of Ruin': '파멸의 저주',
      'Mana Flame': '마나 불꽃',
      'Manifest Avatar': '분열체 생성',
      'Manipulate Miasma': '독기 조작',
      'Memory of the Labyrinth': '미궁왕의 대호령',
      'Merciful Arc': '예리한 부채검',
      'Merciful Blooms': '예리한 화차',
      'Merciful Breeze': '예리한 설풍',
      'Merciful Moon': '예리한 월광',
      'Mercy Fourfold': '예리한 사도류',
      'Metamorphose': '성질 변화',
      'Misty Wraith': '안개 망령',
      'Northswain\'s Glow': '북두골쇄참',
      'Optimal Offensive': '무장 돌격',
      'Optimal Play': '무장 전술',
      'Pawn Off': '선회인',
      'Phantom Edge': '영환검',
      'Queen\'s Edict': '여왕의 대칙령',
      'Queen\'s Justice': '처벌령',
      'Queen\'s Shot': '전방위 사격',
      'Queen\'s Will': '여왕의 칙령',
      'Quick March': '행군 명령',
      'Rapid Bolts': '다중 번개',
      'Rapid Sever': '마구 베기',
      'Reading': '해석',
      'Relentless Battery': '연계 전술',
      'Relentless Play': '연계 명령',
      'Rending Bolt': '번개 떨구기',
      'Reverberating Roar': '낙석 유발',
      'Reversal Of Forces': '질량 전환',
      'Right-Sided Shockwave': '오른쪽 충격파',
      'Ruins Golem': '유적 골렘',
      'Sanguine Clot': '핏빛 멍울',
      'Seasons Of Mercy': '예리한 설월화',
      'Second Mercy': '예리한 두 번째 검',
      'Secrets Revealed': '실체 이루기',
      'Shield Omen': '방패 태세',
      'Shimmering Shot': '반짝반짝 화살',
      'Shot In The Dark': '한손 쏘기',
      'Sniper Shot': '저격',
      'Spiritual Sphere': '영기',
      'Spit Flame': '화염 뱉기',
      'Spiteful Spirit': '투기',
      'Strongpoint Defense': '절대 방어',
      'Summon Adds': '쫄 소환',
      'Summon(?! Adds)': '소환',
      'Sun\'s Ire': '태워 없애기',
      'Surge of Vigor': '발분',
      'Surging Flames': '불공격',
      'Surging Flood': '물공격',
      'Swirling Miasma': '독기 고리',
      'Sword Omen': '검 태세',
      'The Ends': '십자참',
      'The Means': '십자격',
      'Third Mercy': '예리한 세 번째 검',
      'Thunderous Discharge': '번개 발산',
      'Turret\'s Tour': '도탄난무',
      'Undying Hatred': '초염력',
      'Unlucky Lot': '마폭',
      'Unrelenting Charge': '폭주 돌진',
      'Unseen Eye': '꽃폭풍의 환영',
      'Unwavering Apparition': '나찰의 환영',
      'Verdant Path': '취일문 유파',
      'Verdant Tempest': '취일문 마풍진',
      'Vicious Swipe': '나사 돌리기',
      'Vile Wave': '악의의 파동',
      'Viscous Clot': '찐득한 멍울',
      'Weave Miasma': '독기술',
      'Weight Of Fortune': '무거운 무게',
      'Whack': '난타',
      'Winds Of Fate': '대열풍',
      'Winds Of Weight': '무거운 바람',
      'Withering Curse': '작아지는 저주',
      'Wrath Of Bozja': '보즈야의 격노'
    }
  }]
};
/* harmony default export */ const delubrum_reginae_savage = (delubrum_reginae_savage_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/eureka/delubrum_reginae_savage.txt
const eureka_delubrum_reginae_savage_namespaceObject = "### Delubrum Reginae (Savage)\r\n# https://docs.google.com/document/d/1gIVcGtFXgwd-7IwyVLP8ybGOXfbdz1jfgNCPW1G2hMM/edit\r\n# https://docs.google.com/document/d/e/2PACX-1vTatqkLm8ybALnifyPd8qKsqUDSNppLSjJsbexfLrZq3aMusnI1b_MeYO1FZMIP2ISAgMdO3WE3GS2n/pub\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Note: The various \"is no longer sealed\" messages are localized to each\r\n# boss, as the Stygimoloch Warrior and Dahu areas can be seen from one\r\n# another, and so a generic \"is no longer sealed\" from one would stop\r\n# any timeline running for those in the other.\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n\r\n### Slimes (The Barracks, left side)\r\n1000.0 \"--sync--\" AddedCombatant { name: \"Viscous Clot\" } window 1000,0\r\n1000.0 \"--Reset--\" AddedCombatant { name: \"Trinity Seeker\" } window 0,1000 jump 0\r\n1000.0 \"Viscous Clot x3\" AddedCombatant { name: \"Viscous Clot\" } window 1000,0\r\n1005.3 \"Sanguine Clot x4\" AddedCombatant { name: \"Sanguine Clot\" }\r\n1012.1 \"Viscous Clot x3\" AddedCombatant { name: \"Viscous Clot\" }\r\n1024.1 \"Viscous Clot x3\" AddedCombatant { name: \"Viscous Clot\" }\r\n1025.4 \"Sanguine Clot x4\" AddedCombatant { name: \"Sanguine Clot\" }\r\n1027.5 \"Bozjan Soldier x2\" AddedCombatant { name: \"Bozjan Soldier\" }\r\n1036.1 \"Viscous Clot x3\" AddedCombatant { name: \"Viscous Clot\" }\r\n1044.9 \"Sanguine Clot x4\" AddedCombatant { name: \"Sanguine Clot\" }\r\n1048.2 \"Viscous Clot x3\" AddedCombatant { name: \"Viscous Clot\" }\r\n1060.2 \"Viscous Clot x3\" AddedCombatant { name: \"Viscous Clot\" }\r\n1065.1 \"Sanguine Clot x4\" AddedCombatant { name: \"Sanguine Clot\" }\r\n1072.4 \"Viscous Clot x3\" AddedCombatant { name: \"Viscous Clot\" }\r\n1077.1 \"Bozjan Soldier x2\" AddedCombatant { name: \"Bozjan Soldier\" }\r\n1084.3 \"Viscous Clot x3\" AddedCombatant { name: \"Viscous Clot\" }\r\n1085.0 \"Sanguine Clot x4\" AddedCombatant { name: \"Sanguine Clot\" }\r\n1096.1 \"Viscous Clot x3\" AddedCombatant { name: \"Viscous Clot\" }\r\n1105.2 \"Sanguine Clot x3\" AddedCombatant { name: \"Sanguine Clot\" }\r\n1108.3 \"Viscous Clot x2\" AddedCombatant { name: \"Viscous Clot\" }\r\n1120.0 \"Viscous Clot x3\" AddedCombatant { name: \"Viscous Clot\" }\r\n1125.2 \"Sanguine Clot x4\" AddedCombatant { name: \"Sanguine Clot\" }\r\n1127.4 \"Bozjan Soldier x2\" AddedCombatant { name: \"Bozjan Soldier\" }\r\n1132.2 \"Viscous Clot\" AddedCombatant { name: \"Viscous Clot\" }\r\n1144.2 \"Viscous Clot x3\" AddedCombatant { name: \"Viscous Clot\" }\r\n1156.2 \"Viscous Clot x3\" AddedCombatant { name: \"Viscous Clot\" }\r\n1162.1 \"Viscous Clot\" AddedCombatant { name: \"Viscous Clot\" }\r\n1165.4 \"Sanguine Clot x2\" AddedCombatant { name: \"Sanguine Clot\" }\r\n1168.2 \"Viscous Clot x2\" AddedCombatant { name: \"Viscous Clot\" }\r\n1172.7 \"Sanguine Clot x4\" AddedCombatant { name: \"Sanguine Clot\" }\r\n1177.4 \"Bozjan Soldier x2\" AddedCombatant { name: \"Bozjan Soldier\" }\r\n1192.2 \"Viscous Clot\" AddedCombatant { name: \"Viscous Clot\" }\r\n1204.2 \"Viscous Clot x2\" AddedCombatant { name: \"Viscous Clot\" }\r\n1225.1 \"Sanguine Clot\" AddedCombatant { name: \"Sanguine Clot\" }\r\n1227.2 \"Bozjan Soldier x2\" AddedCombatant { name: \"Bozjan Soldier\" }\r\n1233.1 \"Sanguine Clot x4\" AddedCombatant { name: \"Sanguine Clot\" }\r\n1277.3 \"Bozjan Soldier x2\" AddedCombatant { name: \"Bozjan Soldier\" }\r\n1297.3 \"Grim Reaper Enrage\" AddedCombatant { name: \"Grim Reaper\" } window 300,10\r\n1302.3 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1305.3 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1308.3 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1311.3 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1314.4 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1317.4 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1320.4 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1323.5 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1326.5 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1327.3 \"Bozjan Soldier x2\" AddedCombatant { name: \"Bozjan Soldier\" }\r\n1329.5 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1332.6 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1335.6 \"Death Scythe\" Ability { id: \"5747\", source: \"Grim Reaper\" } window 5,10\r\n1338.6 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1341.7 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" } window 10,10\r\n1341.7 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1344.7 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1347.7 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1350.8 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1353.8 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1356.8 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n1359.8 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n\r\n\r\n### Golems (The Granary, right side)\r\n2000.0 \"--sync--\" NameToggle { name: \"Bicolor Golem\", toggle: \"01\" } window 2000,0\r\n2000.0 \"--Reset--\" AddedCombatant { name: \"Trinity Seeker\" } window 0,1000 jump 0\r\n2025.2 \"Core Combustion\" Ability { id: \"5745\", source: \"Bicolor Golem\" } window 2030,10\r\n2026.1 \"--bleed--\" # from blue golem\r\n2029.9 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2032.1 \"--sync--\" StartsUsing { id: \"5558\", source: \"Bicolor Golem\" } window 20,10\r\n2037.1 \"Metamorphose\" Ability { id: \"5558\", source: \"Bicolor Golem\" }\r\n2069.9 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2071.3 \"--sync--\" StartsUsing { id: \"5558\", source: \"Bicolor Golem\" } window 20,10\r\n2076.3 \"Metamorphose\" Ability { id: \"5558\", source: \"Bicolor Golem\" }\r\n2109.7 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2140.1 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2160.2 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2170.3 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2180.3 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2189.9 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2199.9 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2209.9 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2220.0 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2230.0 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2240.0 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2250.1 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2260.0 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2270.0 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2280.1 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2290.1 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2299.7 \"Grim Reaper Enrage\" AddedCombatant { name: \"Grim Reaper\" }\r\n2300.2 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2305.0 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n2308.0 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n2310.1 \"Ruins Golem x2\" AddedCombatant { name: \"Ruins Golem\" }\r\n2311.1 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n2314.1 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n2317.1 \"Death Scythe\" Ability { id: \"5747\", source: \"Grim Reaper\" } window 5,10\r\n2320.1 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n2323.1 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n2326.1 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n2329.1 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n2332.1 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n2335.1 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n2338.1 \"Death Scythe\" #Ability { id: \"5747\", source: \"Grim Reaper\" }\r\n\r\n\r\n### Trinity Seeker\r\n# -p 5AD3:4011.4 5A98:4079.5 5A99:4171.7 5A97:4265.8\r\n# -ii 1961 1963 5B33 5AB8 5AB9 5ABA 5ABB 5ABC 5AD1 5B2A 5B2B 5AC1 5AC2 5AC3 5AC4 5AC5 5AC6 5ACB 5BBC 5ACD\r\n# The Theater of One will be sealed off\r\n4000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E1B\" } window 20000,0\r\n# .*is no longer sealed\r\n4000.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,2000 jump 0\r\n\r\n# Note: it is likely that there are additional hp pushes on later Verdant Paths.\r\n# It is known that the first one is 80%, but I have seen 0-10 second variations\r\n# on when the other Verdant Paths occur.  This timeline has the slowest versions,\r\n# but with lots of extra syncs to future proof possible hp pushes.\r\n\r\n# Initial Merciful Air\r\n4006.4 \"--sync--\" StartsUsing { id: \"5AD3\", source: \"Trinity Seeker\" } window 20,20\r\n4011.4 \"Verdant Tempest\" Ability { id: \"5AD3\", source: \"Trinity Seeker\" }\r\n4015.6 \"--middle--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4020.0 \"Manifest Avatar\" Ability { id: \"5ADA\", source: \"Trinity Seeker\" }\r\n4028.2 \"First Mercy\" Ability { id: \"5B61\", source: \"Trinity Seeker\" }\r\n4031.4 \"Second Mercy\" Ability { id: \"5B62\", source: \"Trinity Seeker\" }\r\n4034.6 \"Third Mercy\" Ability { id: \"5B63\", source: \"Trinity Seeker\" }\r\n4037.8 \"Fourth Mercy\" Ability { id: \"5B64\", source: \"Trinity Seeker\" }\r\n4040.2 \"Mercy Fourfold 1\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4042.1 \"Mercy Fourfold 2\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4042.8 \"Seasons Of Mercy\" Ability { id: \"5AC7\", source: \"Seeker Avatar\" }\r\n4044.0 \"Mercy Fourfold 3\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4045.9 \"Mercy Fourfold 4\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4047.3 \"Merciful Breeze\" Ability { id: \"5AC8\", source: \"Trinity Seeker\" }\r\n4048.8 \"Merciful Moon\" Ability { id: \"5AC9\", source: \"Aetherial Orb\" }\r\n4051.3 \"Merciful Breeze\" Ability { id: \"5AC8\", source: \"Trinity Seeker\" }\r\n4054.7 \"Merciful Blooms\" Ability { id: \"5ACA\", source: \"Trinity Seeker\" }\r\n4062.0 \"Verdant Tempest\" Ability { id: \"5AD3\", source: \"Trinity Seeker\" }\r\n4074.2 \"Merciful Arc\" Ability { id: \"5AD4\", source: \"Trinity Seeker\" }\r\n\r\n# Initial Baleful Air (80% or time push)\r\n4076.5 \"--sync--\" StartsUsing { id: \"5A98\", source: \"Trinity Seeker\" } window 80,20\r\n4079.5 \"Verdant Path\" Ability { id: \"5A98\", source: \"Trinity Seeker\" }\r\n4084.1 \"Baleful Swathe\" Ability { id: \"5AD0\", source: \"Trinity Seeker\" }\r\n4092.2 \"Baleful Onslaught\" Ability { id: \"5AD5\", source: \"Trinity Seeker\" }\r\n4099.3 \"Phantom Edge\" Ability { id: \"5ABD\", source: \"Trinity Seeker\" }\r\n4105.5 \"Baleful Onslaught\" Ability { id: \"5AD6\", source: \"Trinity Seeker\" }\r\n4115.6 \"Phantom Edge?\" Ability { id: \"5ABD\", source: \"Trinity Seeker\" }\r\n4117.8 \"--middle--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4118.4 \"--chains--\" duration 3.1\r\n4126.9 \"Baleful Blade\" Ability { id: \"5AB[EF]\", source: \"Trinity Seeker\" }\r\n4132.1 \"Manifest Avatar\" Ability { id: \"5ADA\", source: \"Trinity Seeker\" }\r\n4138.8 \"Baleful Comet 1\" #Ability { id: \"5AD7\", source: \"Seeker Avatar\" }\r\n4139.8 \"Baleful Comet 2\" #Ability { id: \"5AD7\", source: \"Seeker Avatar\" }\r\n4140.8 \"Baleful Comet 3\" #Ability { id: \"5AD7\", source: \"Seeker Avatar\" }\r\n4141.8 \"Baleful Comet 4\" #Ability { id: \"5AD7\", source: \"Seeker Avatar\" }\r\n4142.2 \"Phantom Edge?\" Ability { id: \"5ABD\", source: \"Trinity Seeker\" }\r\n4144.4 \"--middle--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4146.4 \"Baleful Firestorm 1\" #Ability { id: \"5AD8\", source: \"Seeker Avatar\" }\r\n4148.4 \"Baleful Firestorm 2\" #Ability { id: \"5AD8\", source: \"Seeker Avatar\" }\r\n4150.4 \"Baleful Firestorm 3\" #Ability { id: \"5AD8\", source: \"Seeker Avatar\" }\r\n4152.4 \"Baleful Firestorm 4\" #Ability { id: \"5AD8\", source: \"Seeker Avatar\" }\r\n4153.5 \"Baleful Blade\" Ability { id: \"5AB[EF]\", source: \"Trinity Seeker\" }\r\n4162.6 \"Verdant Tempest\" Ability { id: \"5AD3\", source: \"Trinity Seeker\" }\r\n\r\n# Initial Iron Air\r\n4168.7 \"--sync--\" StartsUsing { id: \"5A99\", source: \"Trinity Seeker\" } window 200,20\r\n4171.7 \"Verdant Path\" Ability { id: \"5A99\", source: \"Trinity Seeker\" }\r\n4176.6 \"Iron Impact\" Ability { id: \"5AD2\", source: \"Trinity Seeker\" }\r\n4180.7 \"--middle--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4184.9 \"Manifest Avatar\" Ability { id: \"5ADA\", source: \"Trinity Seeker\" }\r\n4196.6 \"--jump--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4197.7 \"Iron Rose\" Ability { id: \"5AD9\", source: \"Seeker Avatar\" }\r\n4203.5 \"Iron Splitter\" Ability { id: \"5AC0\", source: \"Trinity Seeker\" }\r\n4207.7 \"--middle--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4211.9 \"Manifest Avatar\" Ability { id: \"5ADA\", source: \"Trinity Seeker\" }\r\n4216.1 \"--jump--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4223.0 \"Iron Splitter\" Ability { id: \"5AC0\", source: \"Trinity Seeker\" }\r\n4225.2 \"Dead Iron\" Ability { id: \"5ACC\", source: \"Seeker Avatar\" }\r\n4228.3 \"--jump--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4232.5 \"Dead Iron\" Ability { id: \"5B44\", source: \"Seeker Avatar\" }\r\n4235.1 \"Iron Splitter\" Ability { id: \"5AC0\", source: \"Trinity Seeker\" }\r\n4239.9 \"Iron Rose\" Ability { id: \"5AD9\", source: \"Seeker Avatar\" }\r\n4251.3 \"Verdant Tempest\" Ability { id: \"5AD3\", source: \"Trinity Seeker\" }\r\n\r\n# Merciful Air v2\r\n4262.8 \"--sync--\" StartsUsing { id: \"5A97\", source: \"Trinity Seeker\" } window 300,10\r\n4265.8 \"Verdant Path\" Ability { id: \"5A97\", source: \"Trinity Seeker\" }\r\n4270.4 \"Act Of Mercy\" Ability { id: \"5ACF\", source: \"Trinity Seeker\" }\r\n4276.5 \"--middle--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4280.8 \"Manifest Avatar\" Ability { id: \"5ADA\", source: \"Trinity Seeker\" }\r\n4286.9 \"Baleful Comet 1\" #Ability { id: \"5AD7\", source: \"Seeker Avatar\" }\r\n4287.9 \"Baleful Comet 2\" #Ability { id: \"5AD7\", source: \"Seeker Avatar\" }\r\n4288.9 \"Baleful Comet 3\" #Ability { id: \"5AD7\", source: \" Seeker Avatar\" }\r\n4289.9 \"Baleful Comet 4\" #Ability { id: \"5AD7\", source: \"Seeker Avatar\" }\r\n4290.9 \"--middle--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4294.5 \"Baleful Firestorm\" #Ability { id: \"5AD8\", source: \"Seeker Avatar\" }\r\n4295.1 \"First Mercy\" Ability { id: \"5B61\", source: \"Trinity Seeker\" }\r\n4296.5 \"Baleful Firestorm\" #Ability { id: \"5AD8\", source: \"Seeker Avatar\" }\r\n4298.3 \"Second Mercy\" Ability { id: \"5B62\", source: \"Trinity Seeker\" }\r\n4298.5 \"Baleful Firestorm\" #Ability { id: \"5AD8\", source: \"Seeker Avatar\" }\r\n4300.5 \"Baleful Firestorm\" #Ability { id: \"5AD8\", source: \"Seeker Avatar\" }\r\n4301.5 \"Third Mercy\" Ability { id: \"5B63\", source: \"Trinity Seeker\" }\r\n4304.7 \"Fourth Mercy\" Ability { id: \"5B64\", source: \"Trinity Seeker\" }\r\n4307.1 \"Mercy Fourfold 1\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4309.0 \"Mercy Fourfold 2\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4309.7 \"Seasons Of Mercy\" Ability { id: \"5AC7\", source: \"Seeker Avatar\" }\r\n4311.0 \"Mercy Fourfold 3\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4312.9 \"Mercy Fourfold 4\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4314.3 \"Merciful Breeze\" Ability { id: \"5AC8\", source: \"Trinity Seeker\" }\r\n4315.8 \"Merciful Moon\" Ability { id: \"5AC9\", source: \"Aetherial Orb\" }\r\n4318.4 \"Merciful Breeze\" Ability { id: \"5AC8\", source: \"Trinity Seeker\" }\r\n4321.8 \"Merciful Blooms\" Ability { id: \"5ACA\", source: \"Trinity Seeker\" }\r\n4325.1 \"--chains--\" duration 3.1\r\n4335.2 \"Verdant Tempest\" Ability { id: \"5AD3\", source: \"Trinity Seeker\" }\r\n4346.5 \"Merciful Arc\" Ability { id: \"5AD4\", source: \"Trinity Seeker\" }\r\n4349.7 \"--middle--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4354.0 \"Manifest Avatar\" Ability { id: \"5ADA\", source: \"Trinity Seeker\" }\r\n4361.2 \"First Mercy\" Ability { id: \"5B61\", source: \"Trinity Seeker\" }\r\n4364.4 \"Second Mercy\" Ability { id: \"5B62\", source: \"Trinity Seeker\" }\r\n4365.4 \"--jump--\" Ability { id: \"5A9A\", source: \"Seeker Avatar\" }\r\n4367.6 \"Third Mercy\" Ability { id: \"5B63\", source: \"Trinity Seeker\" }\r\n4370.8 \"Fourth Mercy\" Ability { id: \"5B64\", source: \"Trinity Seeker\" }\r\n4371.6 \"Iron Splitter\" Ability { id: \"5AC0\", source: \"Seeker Avatar\" }\r\n4373.2 \"Mercy Fourfold 1\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4375.1 \"Mercy Fourfold 2\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4377.0 \"Mercy Fourfold 3\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4378.9 \"Mercy Fourfold 4\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4380.6 \"Iron Splitter\" Ability { id: \"5AC0\", source: \"Seeker Avatar\" }\r\n4382.8 \"--jump--\" Ability { id: \"5A9A\", source: \"Seeker Avatar\" }\r\n4389.5 \"Iron Splitter\" Ability { id: \"5AC0\", source: \"Seeker Avatar\" }\r\n4390.3 \"Seasons Of Mercy\" Ability { id: \"5AC7\", source: \"Trinity Seeker\" }\r\n4394.8 \"Merciful Breeze\" Ability { id: \"5AC8\", source: \"Trinity Seeker\" }\r\n4396.3 \"Merciful Moon\" Ability { id: \"5AC9\", source: \"Aetherial Orb\" }\r\n4398.9 \"Merciful Breeze\" Ability { id: \"5AC8\", source: \"Trinity Seeker\" }\r\n4400.9 \"Iron Rose\" Ability { id: \"5AD9\", source: \"Seeker Avatar\" }\r\n4402.2 \"Merciful Blooms\" Ability { id: \"5ACA\", source: \"Trinity Seeker\" }\r\n4412.3 \"Verdant Tempest\" Ability { id: \"5AD3\", source: \"Trinity Seeker\" }\r\n\r\n# Baleful Air v2\r\n4422.5 \"--sync--\" StartsUsing { id: \"5A98\", source: \"Trinity Seeker\" } window 300,10\r\n4425.5 \"Verdant Path\" Ability { id: \"5A98\", source: \"Trinity Seeker\" }\r\n4430.2 \"Baleful Swathe\" Ability { id: \"5AD0\", source: \"Trinity Seeker\" }\r\n4433.4 \"--middle--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4437.8 \"Manifest Avatar\" Ability { id: \"5ADA\", source: \"Trinity Seeker\" }\r\n4448.0 \"Phantom Edge\" Ability { id: \"5ABD\", source: \"Trinity Seeker\" }\r\n4450.2 \"--middle--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4451.1 \"First Mercy\" Ability { id: \"5B61\", source: \"Seeker Avatar\" }\r\n4454.3 \"Second Mercy\" Ability { id: \"5B62\", source: \"Seeker Avatar\" }\r\n4457.5 \"Third Mercy\" Ability { id: \"5B63\", source: \"Seeker Avatar\" }\r\n4459.2 \"Baleful Blade\" Ability { id: \"5ABF\", source: \"Trinity Seeker\" }\r\n4460.7 \"Fourth Mercy\" Ability { id: \"5B64\", source: \"Seeker Avatar\" }\r\n4463.1 \"Mercy Fourfold 1\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4465.0 \"Mercy Fourfold 2\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4466.9 \"Mercy Fourfold 3\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4468.8 \"Mercy Fourfold 4\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4472.2 \"--chains--\" duration 3.1\r\n4482.4 \"Verdant Tempest\" Ability { id: \"5AD3\", source: \"Trinity Seeker\" }\r\n4484.6 \"--middle--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4488.8 \"Manifest Avatar\" Ability { id: \"5ADA\", source: \"Trinity Seeker\" }\r\n4498.4 \"Phantom Edge?\" Ability { id: \"5ABD\", source: \"Trinity Seeker\" }\r\n4500.1 \"--jump--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4504.9 \"Iron Splitter\" Ability { id: \"5AC0\", source: \"Seeker Avatar\" }\r\n4509.2 \"Baleful Blade\" Ability { id: \"5AB[EF]\", source: \"Trinity Seeker\" }\r\n4514.5 \"--middle--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4518.7 \"Manifest Avatar\" Ability { id: \"5ADA\", source: \"Trinity Seeker\" }\r\n4530.9 \"First Mercy\" Ability { id: \"5B61\", source: \"Seeker Avatar\" }\r\n4534.1 \"Second Mercy\" Ability { id: \"5B62\", source: \"Seeker Avatar\" }\r\n4534.7 \"--chains--\" duration 3.1\r\n4537.3 \"Third Mercy\" Ability { id: \"5B63\", source: \"Seeker Avatar\" }\r\n4540.5 \"Fourth Mercy\" Ability { id: \"5B64\", source: \"Seeker Avatar\" }\r\n4541.8 \"Phantom Edge?\" Ability { id: \"5ABD\", source: \"Trinity Seeker\" }\r\n4543.0 \"Mercy Fourfold 1\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4544.0 \"--middle--\" Ability { id: \"5A9A\", source: \"Trinity Seeker\" }\r\n4544.9 \"Mercy Fourfold 2\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4546.8 \"Mercy Fourfold 3\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4548.7 \"Mercy Fourfold 4\" #Ability { id: \"5B94\", source: \"Trinity Seeker\" }\r\n4553.1 \"Baleful Blade\" Ability { id: \"5AB[EF]\", source: \"Trinity Seeker\" }\r\n4562.3 \"Phantom Edge?\" Ability { id: \"5ABD\", source: \"Trinity Seeker\" }\r\n4568.4 \"Baleful Onslaught\" Ability { id: \"5AD[56]\", source: \"Trinity Seeker\" }\r\n\r\n# Enrage\r\n4580.9 \"--sync--\" StartsUsing { id: \"5BBA\", source: \"Trinity Seeker\" } window 1000,10\r\n4590.9 \"Verdant Tempest Enrage\" Ability { id: \"5BBA\", source: \"Trinity Seeker\" }\r\n4593.0 \"Verdant Tempest\" Ability { id: \"5BBB\", source: \"Trinity Seeker\" } window 10,10 # x infinity\r\n4595.0 \"Verdant Tempest\" Ability { id: \"5BBB\", source: \"Trinity Seeker\" }\r\n4597.0 \"Verdant Tempest\" Ability { id: \"5BBB\", source: \"Trinity Seeker\" }\r\n\r\n\r\n### Dahu\r\n# -p 576D:6008.4\r\n# -ii 576C 1961 576E\r\n# Can't use a \"is no longer sealed\" message here, as the Stygimoloch Warrior and Dahu can\r\n# see each other's zone sealing messages and 00:0044 messages, but not abilities.\r\n# Dahu will only start if you are not in the Duel, and if Dahu starts first, the Duel will\r\n# override it.  Dahu will only end when Dahu is killed, which can only be seen if you\r\n# are in the Dahu fight.\r\n# The Hall of Supplication will be sealed off\r\n6000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E1D\" } window 6000,0\r\n6000.0 \"--Reset--\" WasDefeated { target: \"Dahu\" } window 0,2000 jump 0\r\n6008.4 \"Reverberating Roar\" Ability { id: \"576D\", source: \"Dahu\" } window 10,2.5\r\n6014.5 \"Reverberating Roar\" Ability { id: \"576D\", source: \"Dahu\" }\r\n6022.7 \"Hot Charge 1\" Ability { id: \"5773\", source: \"Dahu\" }\r\n6027.5 \"Hot Charge 2\" Ability { id: \"5773\", source: \"Dahu\" }\r\n6034.3 \"Firebreathe\" Ability { id: \"5774\", source: \"Dahu\" }\r\n6046.5 \"--sync--\" Ability { id: \"576A\", source: \"Marchosias\" }\r\n6051.8 \"Head Down\" Ability { id: \"5768\", source: \"Marchosias\" }\r\n6057.5 \"Head Down\" Ability { id: \"5768\", source: \"Marchosias\" }\r\n\r\n6061.4 \"Spit Flame\" Ability { id: \"5776\", source: \"Dahu\" }\r\n6061.6 \"Spit Flame 1\" #Ability { id: \"5777\", source: \"Dahu\" }\r\n6062.7 \"Spit Flame 2\" #Ability { id: \"5777\", source: \"Dahu\" }\r\n6063.8 \"Spit Flame 3\" #Ability { id: \"5777\", source: \"Dahu\" }\r\n6065.0 \"Spit Flame 4\" #Ability { id: \"5777\", source: \"Dahu\" }\r\n6069.1 \"Head Down\" Ability { id: \"5768\", source: \"Marchosias\" }\r\n6071.1 \"Right-Sided Shockwave/Left-Sided Shockwave\" #Ability { id: \"57(70|6F)\", source: \"Dahu\" }\r\n6073.7 \"Left-Sided Shockwave/Right-Sided Shockwave\" #Ability { id: \"577[12]\", source: \"Dahu\" }\r\n6074.8 \"Head Down\" Ability { id: \"5768\", source: \"Marchosias\" }\r\n6081.4 \"Feral Howl\" Ability { id: \"5767\", source: \"Dahu\" }\r\n6083.5 \"--knockback--\" Ability { id: \"5B35\", source: \"Dahu\" }\r\n6084.9 \"Hunter's Claw\" Ability { id: \"5769\", source: \"Marchosias\" }\r\n6091.5 \"Firebreathe x5\" Ability { id: \"576B\", source: \"Dahu\" } duration 8.7\r\n6112.5 \"--sync--\" Ability { id: \"576A\", source: \"Crowned Marchosias\" }\r\n6117.5 \"--sync--\" Ability { id: \"576A\", source: \"Crowned Marchosias\" }\r\n6122.5 \"--sync--\" Ability { id: \"576A\", source: \"Crowned Marchosias\" }\r\n6142.5 \"--sync--\" Ability { id: \"576A\", source: \"Marchosias\" }\r\n6142.5 \"Reverberating Roar\" Ability { id: \"576D\", source: \"Dahu\" }\r\n6147.6 \"Falling Rock x6\" duration 10 #Ability { id: \"576E\", source: \"Dahu\" }\r\n6147.7 \"Head Down\" Ability { id: \"5768\", source: \"Marchosias\" }\r\n6151.6 \"Right-Sided Shockwave/Left-Sided Shockwave\" #Ability { id: \"57(70|6F)\", source: \"Dahu\" }\r\n6153.4 \"Head Down\" Ability { id: \"5768\", source: \"Marchosias\" }\r\n6154.1 \"Left-Sided Shockwave/Right-Sided Shockwave\" #Ability { id: \"577[12]\", source: \"Dahu\" }\r\n6159.1 \"Head Down\" Ability { id: \"5768\", source: \"Marchosias\" }\r\n\r\n6164.7 \"Spit Flame\" Ability { id: \"5776\", source: \"Dahu\" }\r\n6165.0 \"Spit Flame 1\" #Ability { id: \"5777\", source: \"Dahu\" }\r\n6166.1 \"Spit Flame 2\" #Ability { id: \"5777\", source: \"Dahu\" }\r\n6167.3 \"Spit Flame 3\" #Ability { id: \"5777\", source: \"Dahu\" }\r\n6168.4 \"Spit Flame 4\" #Ability { id: \"5777\", source: \"Dahu\" }\r\n6174.6 \"Hysteric Assault\" Ability { id: \"5778\", source: \"Dahu\" }\r\n6175.5 \"--knockback--\" Ability { id: \"5B43\", source: \"Dahu\" }\r\n6177.7 \"Burn x2\" Ability { id: \"5463\", source: \"Dahu\" }\r\n6178.1 \"Hunter's Claw\" Ability { id: \"5769\", source: \"Marchosias\" }\r\n6187.6 \"Head Down\" Ability { id: \"5768\", source: \"Marchosias\" }\r\n6188.9 \"Firebreathe x5\" Ability { id: \"576B\", source: \"Dahu\" } duration 8.7\r\n6209.9 \"Right-Sided Shockwave/Left-Sided Shockwave\" #Ability { id: \"57(70|6F)\", source: \"Dahu\" }\r\n6212.5 \"Left-Sided Shockwave/Right-Sided Shockwave\" #Ability { id: \"577[12]\", source: \"Dahu\" }\r\n\r\n# This is a single or a double hot charge.\r\n6221.4 \"Hot Charge 1\" Ability { id: \"5773\", source: \"Dahu\" }\r\n6226.2 \"Hot Charge 2?\" Ability { id: \"5773\", source: \"Dahu\" }\r\n6228.0 \"--sync--\" StartsUsing { id: \"5774\", source: \"Dahu\" } window 20,20\r\n6233.0 \"Firebreathe\" Ability { id: \"5774\", source: \"Dahu\" }\r\n6246.3 \"--sync--\" Ability { id: \"576A\", source: \"Crowned Marchosias\" }\r\n6251.3 \"--sync--\" Ability { id: \"576A\", source: \"Crowned Marchosias\" }\r\n6252.2 \"Reverberating Roar\" Ability { id: \"576D\", source: \"Dahu\" }\r\n6256.3 \"--sync--\" Ability { id: \"576A\", source: \"Crowned Marchosias\" }\r\n6261.3 \"Reverberating Roar\" Ability { id: \"576D\", source: \"Dahu\" }\r\n6289.5 \"Reverberating Roar\" Ability { id: \"576D\", source: \"Dahu\" }\r\n6289.5 \"--sync--\" Ability { id: \"576A\", source: \"Marchosias\" }\r\n6289.5 \"--sync--\" Ability { id: \"576A\", source: \"Marchosias\" }\r\n6294.7 \"Head Down\" Ability { id: \"5768\", source: \"Marchosias\" }\r\n6298.6 \"Right-Sided Shockwave/Left-Sided Shockwave\" #Ability { id: \"57(70|6F)\", source: \"Dahu\" }\r\n6300.4 \"Head Down\" Ability { id: \"5768\", source: \"Marchosias\" }\r\n6301.1 \"Left-Sided Shockwave/Right-Sided Shockwave\" #Ability { id: \"577[12]\", source: \"Dahu\" }\r\n6306.0 \"Head Down\" Ability { id: \"5768\", source: \"Marchosias\" }\r\n6306.0 \"Head Down\" Ability { id: \"5768\", source: \"Marchosias\" }\r\n\r\n6311.7 \"Spit Flame 1\" Ability { id: \"5776\", source: \"Dahu\" }\r\n6312.1 \"Spit Flame 2\" Ability { id: \"5777\", source: \"Dahu\" }\r\n6313.3 \"Spit Flame 3\" Ability { id: \"5777\", source: \"Dahu\" }\r\n6314.4 \"Spit Flame 4\" Ability { id: \"5777\", source: \"Dahu\" }\r\n6320.6 \"Hysteric Assault\" Ability { id: \"5778\", source: \"Dahu\" }\r\n6321.5 \"--knockback--\" Ability { id: \"5B43\", source: \"Dahu\" }\r\n6323.7 \"Burn x2\" Ability { id: \"5463\", source: \"Dahu\" }\r\n6324.1 \"Hunter's Claw\" Ability { id: \"5769\", source: \"Marchosias\" }\r\n6334.4 \"Head Down\" Ability { id: \"5768\", source: \"Marchosias\" }\r\n6335.2 \"Firebreathe\" Ability { id: \"576B\", source: \"Dahu\" }\r\n6356.2 \"Right-Sided Shockwave/Left-Sided Shockwave\" #Ability { id: \"57(70|6F)\", source: \"Dahu\" }\r\n6358.8 \"Left-Sided Shockwave/Right-Sided Shockwave\" #Ability { id: \"577[12]\", source: \"Dahu\" }\r\n\r\n# Probably a loop, but you shouldn't see this charge, let alone the previous one.\r\n6367.8 \"Hot Charge 1\" Ability { id: \"5773\", source: \"Dahu\" }\r\n6372.6 \"Hot Charge 2?\" Ability { id: \"5773\", source: \"Dahu\" }\r\n6374.4 \"--sync--\" StartsUsing { id: \"5774\", source: \"Dahu\" } window 100,100 jump 6228\r\n6379.4 \"Firebreathe\" Ability { id: \"5774\", source: \"Dahu\" }\r\n6398.6 \"Reverberating Roar\" #Ability { id: \"576D\", source: \"Dahu\" }\r\n6407.7 \"Reverberating Roar\" #Ability { id: \"576D\", source: \"Dahu\" }\r\n6435.9 \"Reverberating Roar\" #Ability { id: \"576D\", source: \"Dahu\" }\r\n\r\n\r\n### Stygimoloch Warrior\r\n# -p 5796:8012.1\r\n# -ii 579E 579A 5790 578B 5787 5788 5782 5786 5784 578D 5791 1961 57A0 57A1 579F 57AB 57AE\r\n# https://www.youtube.com/watch?v=5Q0m1F0MKQQ\r\n\r\n# This is the zone, but can't use this sync as it can be seen by Dahu.  Sync to autos instead.\r\n# Pride of the Lioness will be sealed off\r\n#8000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E1C\" } window 20000,0\r\n\r\n# https://xivapi.com/PublicContentTextData/2477\r\n# en: Why...won't...you...\r\n# TODO: Update to ActorControlExtra (category: 0x0834, param1: 0x9AD) when available.\r\n# See OverlayPlugin/cactbot#99 and OverlayPlugin/OverlayPlugin#329 for further info\r\n8000.0 \"--Reset--\" GameLog { code: \"0044\", name: \"Stygimoloch Warrior\", line: \"Why\\.\\.\\.won't\\.\\.\\.you\\.\\.\\..*?\" } window 0,2000 jump 0\r\n# TODO: is there a reset dialog line for losing?\r\n# Alternatively, we could always insert \" 19:${data.me} was defeated by\" from script.\r\n\r\n8002.1 \"--sync--\" Ability { id: \"1961\", source: \"Stygimoloch Warrior\" } window 20000,0\r\n8009.1 \"--sync--\" StartsUsing { id: \"5796\", source: \"Stygimoloch Warrior\" } window 20,20\r\n8012.1 \"Surge of Vigor\" Ability { id: \"5796\", source: \"Stygimoloch Warrior\" }\r\n8024.3 \"Unrelenting Charge x3\" Ability { id: \"5799\", source: \"Stygimoloch Warrior\" }\r\n8035.4 \"--north--\" Ability { id: \"577C\", source: \"Stygimoloch Warrior\" }\r\n8039.7 \"Entrapment\" Ability { id: \"577D\", source: \"Stygimoloch Warrior\" }\r\n8040.5 \"--knockback--\" Ability { id: \"577E\", source: \"Stygimoloch Warrior\" }\r\n8061.8 \"Lethal Blow\" Ability { id: \"577F\", source: \"Stygimoloch Warrior\" }\r\n8067.9 \"Vicious Swipe\" Ability { id: \"5797\", source: \"Stygimoloch Warrior\" }\r\n8069.9 \"--knockback--\"\r\n8069.9 \"Crazed Rampage\" Ability { id: \"5798\", source: \"Stygimoloch Warrior\" }\r\n8081.0 \"Focused Tremor\" Ability { id: \"578E\", source: \"Stygimoloch Warrior\" }\r\n8083.2 \"--corner--\" Ability { id: \"577C\", source: \"Stygimoloch Warrior\" }\r\n8089.8 \"Focused Tremor 1\" #Ability { id: \"578F\", source: \"Stygimoloch Warrior\" }\r\n8091.8 \"Focused Tremor 2\" #Ability { id: \"578F\", source: \"Stygimoloch Warrior\" }\r\n8093.8 \"Focused Tremor 3\" #Ability { id: \"578F\", source: \"Stygimoloch Warrior\" }\r\n8095.8 \"Focused Tremor 4\" #Ability { id: \"578F\", source: \"Stygimoloch Warrior\" }\r\n8099.4 \"Forceful Strike\" Ability { id: \"5792\", source: \"Stygimoloch Warrior\" }\r\n8109.5 \"--middle--\" Ability { id: \"577C\", source: \"Stygimoloch Warrior\" }\r\n8113.7 \"Inescapable Entrapment\" Ability { id: \"5780\", source: \"Stygimoloch Warrior\" }\r\n\r\n# Single Trap\r\n8120.8 \"--sync--\" StartsUsing { id: \"578[15]\", source: \"Stygimoloch Warrior\" } window 20,20\r\n8133.8 \"Surging Flames/Withering Curse?\" Ability { id: \"578[15]\", source: \"Stygimoloch Warrior\" }\r\n8133.8 \"--sync--\" Ability { id: \"5781\", source: \"Stygimoloch Warrior\" } jump 8137.3 # if Surging Flames, skip +3.5s ahead\r\n8136.4 \"Devour?\" Ability { id: \"5789\", source: \"Stygimoloch Warrior\" } # only if Withering Curse\r\n\r\n# Round 2\r\n8146.6 \"--sync--\" StartsUsing { id: \"5796\", source: \"Stygimoloch Warrior\" } window 20,20\r\n8149.6 \"Surge of Vigor\" Ability { id: \"5796\", source: \"Stygimoloch Warrior\" }\r\n8163.7 \"Focused Tremor x16\" Ability { id: \"578E\", source: \"Stygimoloch Warrior\" } duration 30.7\r\n8167.8 \"--middle--\" Ability { id: \"577C\", source: \"Stygimoloch Warrior\" }\r\n8178.2 \"Flailing Strike x7\" Ability { id: \"578C\", source: \"Stygimoloch Warrior\" } duration 8.7\r\n8191.7 \"Vicious Swipe\" Ability { id: \"5797\", source: \"Stygimoloch Warrior\" }\r\n8193.7 \"--knockback--\"\r\n8193.7 \"Crazed Rampage\" Ability { id: \"5798\", source: \"Stygimoloch Warrior\" }\r\n8202.9 \"--middle--\" Ability { id: \"577C\", source: \"Stygimoloch Warrior\" }\r\n8207.2 \"Inescapable Entrapment\" Ability { id: \"5780\", source: \"Stygimoloch Warrior\" }\r\n\r\n# Triple Trap\r\n8210.4 \"--sync--\" StartsUsing { id: \"578[15]\", source: \"Stygimoloch Warrior\" } window 20,20\r\n8223.4 \"Surging Flames/Withering Curse?\" Ability { id: \"578[15]\", source: \"Stygimoloch Warrior\" }\r\n8223.4 \"--sync--\" Ability { id: \"5781\", source: \"Stygimoloch Warrior\" } jump 8223.9 # if Surging Flames, skip +3.5s ahead\r\n8225.8 \"Devour?\" Ability { id: \"5789\", source: \"Stygimoloch Warrior\" } # only if Withering Curse\r\n8229.9 \"--sync--\" StartsUsing { id: \"5783\", source: \"Stygimoloch Warrior\" } window 20,20\r\n8239.9 \"Surging Flood\" Ability { id: \"5783\", source: \"Stygimoloch Warrior\" }\r\n8248.1 \"Leaping Spark x3\" Ability { id: \"578A\", source: \"Stygimoloch Warrior\" }\r\n\r\n# From here on is without log\r\n# Unsure which ID Coerce is: 5795, 5794, 5793\r\n8263.1 \"Coerce\" Ability { id: \"579[345]\", source: \"Stygimoloch Warrior\" } window 20,20\r\n\r\n# Round 3\r\n8269.1 \"Surge of Vigor\" Ability { id: \"5796\", source: \"Stygimoloch Warrior\" } window 20,20\r\n8284.0 \"Focused Tremor\" Ability { id: \"578E\", source: \"Stygimoloch Warrior\" }\r\n8286.3 \"--corner--\" Ability { id: \"577C\", source: \"Stygimoloch Warrior\" }\r\n8292.8 \"Focused Tremor 1\" Ability { id: \"578F\", source: \"Stygimoloch Warrior\" }\r\n8294.8 \"Focused Tremor 2\" #Ability { id: \"578F\", source: \"Stygimoloch Warrior\" }\r\n8296.8 \"Focused Tremor 3\" #Ability { id: \"578F\", source: \"Stygimoloch Warrior\" }\r\n8298.8 \"Focused Tremor 4\" #Ability { id: \"578F\", source: \"Stygimoloch Warrior\" }\r\n8302.4 \"Forceful Strike\" Ability { id: \"5792\", source: \"Stygimoloch Warrior\" }\r\n\r\n# Round 4\r\n8315.1 \"Surge of Vigor\" Ability { id: \"5796\", source: \"Stygimoloch Warrior\" } window 20,20\r\n8327.3 \"Unrelenting Charge x3\" Ability { id: \"5799\", source: \"Stygimoloch Warrior\" }\r\n8336.3 \"Vicious Swipe\" Ability { id: \"5797\", source: \"Stygimoloch Warrior\" }\r\n8338.3 \"--knockback--\"\r\n8338.3 \"Crazed Rampage\" Ability { id: \"5798\", source: \"Stygimoloch Warrior\" }\r\n8348.3 \"--middle--\" Ability { id: \"577C\", source: \"Stygimoloch Warrior\" }\r\n\r\n8359.1 \"Sun's Ire (Enrage)\" Ability { id: \"577A\", source: \"Stygimoloch Warrior\" } window 20,20\r\n\r\n\r\n### Queen's Guard\r\n# -p 5831:10016.6 5825:10056.1 5844:10617 581E:11005\r\n# -ii 1961 5858 4B33 4B34 4B35 4B36 5821 5854 5813 5834 584D 5718 581B 581C 5B72 5822 5A94 583E 5856 5851 5B70 5838 584D 583A 5847 5849 58F5 5830 581F 590A 590B 590C 59BE\r\n\r\n# Note: there are number of pairs of abilities that go together (but are both going off).\r\n# - 5831 (5821)\r\n# - 5841 (5854)\r\n# - 5825 (5813)\r\n# - 5844 (5834)\r\n# - 5832 (5822)\r\n# - 5843 (5856)\r\n# - 5B9F (5BA0)\r\n# - 5820 (581F)\r\n# - 5823 (59BE)\r\n\r\n# The Hall of Hieromancy will be sealed off\r\n10000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E1E\" } window 20000,0\r\n# .*is no longer sealed\r\n10000.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,2000 jump 0\r\n# ranged auto should be reasonably timed\r\n10002.5 \"--sync--\" Ability { id: \"5858\", source: \"Queen's Gunner\" } window 3,1\r\n\r\n# Phase 1: aoes (to 80%)\r\n10011.5 \"--sync--\" StartsUsing { id: \"5831\", source: \"Queen's Warrior\" } window 20,20\r\n10016.6 \"Blood And Bone\" Ability { id: \"5831\", source: \"Queen's Warrior\" }\r\n10025.6 \"Blood And Bone\" Ability { id: \"5841\", source: \"Queen's Soldier\" }\r\n10030.6 \"--untargetable--\"\r\n\r\n\r\n# Phase 2: Warrior + Knight section\r\n10033.9 \"--targetable--\" NameToggle { name: \"Queen's Knight\", toggle: \"01\" } window 25,0\r\n10051.1 \"--sync--\" StartsUsing { id: \"5825\", source: \"Queen's Warrior\" } window 60,20\r\n10056.1 \"Relentless Battery\" Ability { id: \"5825\", source: \"Queen's Warrior\" }\r\n10062.2 \"Shield Omen/Sword Omen\" Ability { id: \"581[45]\", source: \"Queen's Knight\" }\r\n\r\n10063.2 \"Bombslinger\" Ability { id: \"5AFE\", source: \"Queen's Warrior\" }\r\n10066.3 \"--tethers--\"\r\n10069.3 \"--untargetable--\" # knight\r\n10070.3 \"Reversal Of Forces\" Ability { id: \"5829\", source: \"Queen's Warrior\" }\r\n10070.3 \"--sync--\" Ability { id: \"5A94\", source: \"Queen's Warrior\" }\r\n10079.5 \"Optimal Offensive\" Ability { id: \"581[9A]\", source: \"Queen's Knight\" }\r\n10081.1 \"Unlucky Lot\" #Ability { id: \"581D\", source: \"Aetherial Sphere\" }\r\n10081.4 \"Above Board\" Ability { id: \"5826\", source: \"Queen's Warrior\" }\r\n10082.4 \"--stunned--\" # 3 or 7 second stun\r\n10084.5 \"Lots Cast\" #Ability { id: \"5828\", source: \"Aetherial Bolt\" }\r\n#10085.8 \"--targetable--\" # knight, everybody stunned, so not listed\r\n10087.5 \"Lots Cast\" #Ability { id: \"5827\", source: \"Aetherial Burst\" }\r\n10088.7 \"Lots Cast\" #Ability { id: \"5BB7\", source: \"Aetherial Burst\" }\r\n10089.4 \"--unstunned--\"\r\n\r\n10097.6 \"Boost\" Ability { id: \"582D\", source: \"Queen's Warrior\" }\r\n10105.8 \"Blood And Bone\" Ability { id: \"5831\", source: \"Queen's Warrior\" }\r\n10121.0 \"Relentless Battery\" Ability { id: \"5825\", source: \"Queen's Warrior\" }\r\n10124.1 \"--tethers--\"\r\n10128.1 \"Reversal Of Forces\" Ability { id: \"5829\", source: \"Queen's Warrior\" }\r\n10136.2 \"Shield Omen/Sword Omen\" Ability { id: \"581[45]\", source: \"Queen's Knight\" }\r\n10137.3 \"Winds Of Weight\" Ability { id: \"582A\", source: \"Queen's Warrior\" }\r\n10137.3 \"Winds Of Fate\" Ability { id: \"582C\", source: \"Queen's Warrior\" }\r\n10137.3 \"Weight Of Fortune\" Ability { id: \"582B\", source: \"Queen's Warrior\" }\r\n10144.4 \"Optimal Play\" Ability { id: \"581[67]\", source: \"Queen's Knight\" }\r\n10146.4 \"Boost\" Ability { id: \"582D\", source: \"Queen's Warrior\" }\r\n10154.6 \"Blood And Bone\" Ability { id: \"5831\", source: \"Queen's Warrior\" }\r\n10163.7 \"Rapid Sever\" Ability { id: \"5832\", source: \"Queen's Warrior\" }\r\n\r\n# loop, unrolled so there can be an explicit enrage\r\n10185.9 \"Relentless Battery\" Ability { id: \"5825\", source: \"Queen's Warrior\" }\r\n10192.1 \"Shield Omen/Sword Omen\" Ability { id: \"581[45]\", source: \"Queen's Knight\" }\r\n\r\n10193.0 \"Bombslinger\" Ability { id: \"5AFE\", source: \"Queen's Warrior\" }\r\n10196.1 \"--tethers--\"\r\n10199.1 \"--untargetable--\" # knight\r\n10200.1 \"Reversal Of Forces\" Ability { id: \"5829\", source: \"Queen's Warrior\" }\r\n10209.4 \"Optimal Offensive\" Ability { id: \"581[9A]\", source: \"Queen's Knight\" }\r\n10211.0 \"Unlucky Lot\" #Ability { id: \"581D\", source: \"Aetherial Sphere\" }\r\n10211.2 \"Above Board\" Ability { id: \"5826\", source: \"Queen's Warrior\" }\r\n10211.2 \"--sync--\" Ability { id: \"5B72\", source: \"Queen's Warrior\" }\r\n10212.2 \"--stunned--\" # 3 or 7 second stun\r\n10214.2 \"Lots Cast\" #Ability { id: \"5B6D\", source: \"Aetherial Burst\" }\r\n#10215.5 \"--targetable--\" # knight, everybody stunned, so not listed\r\n10217.2 \"Lots Cast\" #Ability { id: \"5B6C\", source: \"Aetherial Bolt\" }\r\n10218.4 \"Lots Cast\" #Ability { id: \"5BB7\", source: \"Aetherial Bolt\" }\r\n10219.2 \"--unstunned--\"\r\n\r\n10227.3 \"Boost\" Ability { id: \"582D\", source: \"Queen's Warrior\" }\r\n10235.5 \"Blood And Bone\" Ability { id: \"5831\", source: \"Queen's Warrior\" }\r\n10250.7 \"Relentless Battery\" Ability { id: \"5825\", source: \"Queen's Warrior\" }\r\n10253.8 \"--tethers--\"\r\n10257.8 \"Reversal Of Forces\" Ability { id: \"5829\", source: \"Queen's Warrior\" }\r\n10265.9 \"Shield Omen/Sword Omen\" Ability { id: \"581[45]\", source: \"Queen's Knight\" }\r\n10267.0 \"Winds Of Weight\" Ability { id: \"582A\", source: \"Queen's Warrior\" }\r\n10267.0 \"Winds Of Fate\" Ability { id: \"582C\", source: \"Queen's Warrior\" }\r\n10267.0 \"Winds Of Fate\" Ability { id: \"582C\", source: \"Queen's Warrior\" }\r\n10267.0 \"Weight Of Fortune\" Ability { id: \"582B\", source: \"Queen's Warrior\" }\r\n10274.1 \"Optimal Play\" Ability { id: \"581[67]\", source: \"Queen's Knight\" }\r\n10276.1 \"Boost\" Ability { id: \"582D\", source: \"Queen's Warrior\" }\r\n10284.3 \"Blood And Bone\" Ability { id: \"5831\", source: \"Queen's Warrior\" }\r\n10293.4 \"Rapid Sever\" Ability { id: \"5832\", source: \"Queen's Warrior\" }\r\n\r\n# If either die, they will start casting enrage.\r\n10302.9 \"--sync--\" StartsUsing { id: \"5823\", source: \"Queen's Knight\" } window 300,10\r\n10302.9 \"--sync--\" StartsUsing { id: \"5833\", source: \"Queen's Warrior\" } window 300,10\r\n10312.9 \"Blood and Bone Enrage\" Ability { id: \"5833\", source: \"Queen's Warrior\" }\r\n10316.0 \"Blood and Bone Enrage\" Ability { id: \"5B9D\", source: \"Queen's Knight\" } window 10,10 # x infinity\r\n10319.1 \"Blood and Bone Enrage\" Ability { id: \"5B9D\", source: \"Queen's Knight\" }\r\n10322.2 \"Blood and Bone Enrage\" Ability { id: \"5B9D\", source: \"Queen's Knight\" }\r\n\r\n# Phase 3: Soldier + Gunner section\r\n10600.0 \"--sync--\" NameToggle { name: \"Queen's Gunner\", toggle: \"01\" } window 600,0\r\n10612.0 \"--sync--\" StartsUsing { id: \"5844\", source: \"Queen's Gunner\" } window 600,0\r\n10617.0 \"Relentless Battery\" Ability { id: \"5844\", source: \"Queen's Gunner\" }\r\n10623.2 \"Great Ball Of Fire\" Ability { id: \"583B\", source: \"Queen's Soldier\" }\r\n10632.3 \"Fool's Gambit\" Ability { id: \"583C\", source: \"Queen's Soldier\" }\r\n10635.2 \"Automatic Turret\" Ability { id: \"584A\", source: \"Queen's Gunner\" }\r\n10641.3 \"Reading\" Ability { id: \"584B\", source: \"Queen's Gunner\" }\r\n10647.9 \"Burn\" Ability { id: \"583E\", source: \"Immolating Flame\" }\r\n10651.5 \"Queen's Shot\" Ability { id: \"584C\", source: \"Queen's Gunner\" }\r\n10655.0 \"Turret's Tour\" Ability { id: \"584E\", source: \"Automatic Turret\" }\r\n10665.6 \"Rapid Sever\" Ability { id: \"5842\", source: \"Queen's Soldier\" }\r\n10665.6 \"Shot In The Dark\" Ability { id: \"5855\", source: \"Queen's Gunner\" }\r\n10674.7 \"Blood And Bone\" Ability { id: \"5841\", source: \"Queen's Soldier\" }\r\n10689.9 \"Relentless Battery\" Ability { id: \"5844\", source: \"Queen's Gunner\" }\r\n10696.0 \"Gun Turret\" Ability { id: \"584F\", source: \"Queen's Gunner\" }\r\n10696.8 \"--targetable--\" # gun turret\r\n10703.1 \"Higher Power\" Ability { id: \"5853\", source: \"Queen's Gunner\" }\r\n10710.1 \"Sniper Shot\" Ability { id: \"5850\", source: \"Gun Turret\" }\r\n10715.0 \"Blood And Bone\" Ability { id: \"5841\", source: \"Queen's Soldier\" }\r\n10728.4 \"--gun turret enrage--\"\r\n10732.2 \"Icy Portent/Fiery Portent\" Ability { id: [\"583F\", \"5840\"], source: \"Queen's Soldier\" }\r\n10747.4 \"Relentless Battery\" Ability { id: \"5844\", source: \"Queen's Gunner\" }\r\n10753.5 \"Double Gambit\" Ability { id: \"5837\", source: \"Queen's Soldier\" }\r\n10761.5 \"Automatic Turret\" Ability { id: \"584A\", source: \"Queen's Gunner\" }\r\n10761.7 \"Secrets Revealed\" Ability { id: \"5B6F\", source: \"Queen's Soldier\" }\r\n10767.7 \"Reading\" Ability { id: \"584B\", source: \"Queen's Gunner\" }\r\n10777.9 \"Queen's Shot\" Ability { id: \"584C\", source: \"Queen's Gunner\" }\r\n10778.3 \"Pawn Off\" Ability { id: \"5839\", source: \"Soldier Avatar\" }\r\n10781.4 \"Turret's Tour\" Ability { id: \"584E\", source: \"Automatic Turret\" }\r\n10792.1 \"Blood And Bone\" Ability { id: \"5841\", source: \"Queen's Soldier\" }\r\n10801.3 \"Shot In The Dark\" Ability { id: \"5855\", source: \"Queen's Gunner\" }\r\n10801.3 \"Rapid Sever\" Ability { id: \"5842\", source: \"Queen's Soldier\" }\r\n10816.5 \"Relentless Battery\" Ability { id: \"5844\", source: \"Queen's Gunner\" }\r\n10822.6 \"Automatic Turret\" Ability { id: \"5845\", source: \"Queen's Gunner\" }\r\n10830.8 \"Turret's Tour 1\" Ability { id: \"5846\", source: \"Queen's Gunner\" }\r\n10831.4 \"Turret's Tour 2\" Ability { id: \"5848\", source: \"Automatic Turret\" }\r\n10837.6 \"Fiery Portent/Icy Portent\" Ability { id: [\"583F\", \"5840\"], source: \"Queen's Soldier\" }\r\n10847.8 \"Blood And Bone\" Ability { id: \"5841\", source: \"Queen's Soldier\" }\r\n10856.9 \"Rapid Sever\" Ability { id: \"5842\", source: \"Queen's Soldier\" }\r\n10856.9 \"Shot In The Dark\" Ability { id: \"5855\", source: \"Queen's Gunner\" }\r\n\r\n# If either die, they will start casting enrage.\r\n10865.7 \"--sync--\" StartsUsing { id: \"5843\", source: \"Queen's Soldier\" } window 300,10\r\n10865.7 \"--sync--\" StartsUsing { id: \"5856\", source: \"Queen's Gunner\" } window 300,10\r\n10875.7 \"Blood And Bone Enrage\" Ability { id: \"5843\", source: \"Queen's Soldier\" }\r\n10878.8 \"Blood And Bone Enrage\" Ability { id: \"5B9F\", source: \"Queen's Soldier\" } window 10,10 # x infinity\r\n10881.9 \"Blood And Bone Enrage\" Ability { id: \"5B9F\", source: \"Queen's Soldier\" }\r\n10885.0 \"Blood And Bone Enrage\" Ability { id: \"5B9F\", source: \"Queen's Soldier\" }\r\n10888.1 \"Blood And Bone Enrage\" Ability { id: \"5B9F\", source: \"Queen's Soldier\" }\r\n\r\n\r\n# Phase 4: Aetherial Wards\r\n11000.0 \"--sync--\" StartsUsing { id: \"581E\", source: \"Queen's Knight\" } window 1000,0\r\n11005.0 \"Strongpoint Defense\" Ability { id: \"581E\", source: \"Queen's Knight\" }\r\n11005.0 \"Spiteful Spirit\" Ability { id: \"582E\", source: \"Queen's Warrior\" }\r\n11006.0 \"--2x Aura Sphere--\"\r\n11007.9 \"--12x Spiritual Sphere--\"\r\n11014.8 \"Coat Of Arms\" Ability { id: \"5820\", source: \"Aetherial Ward\" }\r\n11016.0 \"Fracture 1\" Ability { id: \"5B95\", source: \"Spiritual Sphere\" }\r\n11020.0 \"Fracture 2\" Ability { id: \"5B95\", source: \"Spiritual Sphere\" }\r\n11020.0 \"--Spite Check--\"\r\n11032.0 \"Coat Of Arms\" Ability { id: \"5820\", source: \"Aetherial Ward\" }\r\n11037.9 \"--12x Spiritual Sphere--\"\r\n11039.9 \"--2x Aura Sphere--\"\r\n11046.0 \"Fracture 1\" Ability { id: \"5B95\", source: \"Spiritual Sphere\" }\r\n11049.0 \"Coat Of Arms\" Ability { id: \"5820\", source: \"Aetherial Ward\" }\r\n11050.0 \"Fracture 2\" Ability { id: \"5B95\", source: \"Spiritual Sphere\" }\r\n11054.1 \"--Spite Check--\"\r\n11066.1 \"Coat Of Arms\" Ability { id: \"5820\", source: \"Aetherial Ward\" }\r\n# 70s enrage cast, started 3 seconds after Strongpoint Defense.\r\n11078.0 \"Blood And Bone Enrage\" Ability { id: \"5909\", source: \"Queen's Knight\" }\r\n\r\n\r\n### Bozjan Phantom\r\n# -p 57BD:12011.1\r\n# -ii 5B36 1963 57C1\r\n#\r\n# 8:27 encounter https://www.fflogs.com/reports/zGbK1PZy8WLTk96V#fight=10\r\n# Swirling = Donut\r\n# Creeping = Long\r\n# Lingering = Circle\r\n#\r\n# Phases:\r\n# Manipulate -> Invert -> Adds -> then loop Manipulate+Buster OR Invert+Buster\r\n\r\n# Pride of the Lion will be sealed off\r\n12000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E1F\" } window 20000,0\r\n# .*is no longer sealed\r\n12000.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,2000 jump 0\r\n12007.1 \"--sync--\" StartsUsing { id: \"57BD\", source: \"Bozjan Phantom\" } window 20000,0\r\n12011.1 \"Malediction of Agony\" Ability { id: \"57BD\", source: \"Bozjan Phantom\" }\r\n12019.2 \"Weave Miasma\" Ability { id: \"57B2\", source: \"Bozjan Phantom\" }\r\n\r\n# Manipulate Miasma Phase (go Swirling -> Creeping lanes)\r\n12035.4 \"Manipulate Miasma\" Ability { id: \"57B3\", source: \"Bozjan Phantom\" }\r\n12036.4 \"Swirling Miasma 1\" Ability { id: \"57B8\", source: \"Bozjan Phantom\" }\r\n12038.0 \"Swirling Miasma 2\" #Ability { id: \"57B9\", source: \"Bozjan Phantom\" }\r\n12039.6 \"Swirling Miasma 3\" #Ability { id: \"57B9\", source: \"Bozjan Phantom\" }\r\n12041.2 \"Swirling Miasma 4\" #Ability { id: \"57B9\", source: \"Bozjan Phantom\" }\r\n12042.8 \"Swirling Miasma 5\" #Ability { id: \"57B9\", source: \"Bozjan Phantom\" }\r\n12044.4 \"Swirling Miasma 6\" #Ability { id: \"57B9\", source: \"Bozjan Phantom\" }\r\n12046.0 \"Swirling Miasma 7\" #Ability { id: \"57B9\", source: \"Bozjan Phantom\" }\r\n12046.4 \"Creeping Miasma 1\" Ability { id: \"57B4\", source: \"Bozjan Phantom\" }\r\n12047.6 \"Swirling Miasma 8\" #Ability { id: \"57B9\", source: \"Bozjan Phantom\" }\r\n12047.9 \"Creeping Miasma 2\" #Ability { id: \"57B5\", source: \"Bozjan Phantom\" }\r\n12049.5 \"Creeping Miasma 3\" #Ability { id: \"57B5\", source: \"Bozjan Phantom\" }\r\n12051.1 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12052.7 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12054.3 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12055.9 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12057.5 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12063.5 \"Weave Miasma\" Ability { id: \"57B2\", source: \"Bozjan Phantom\" }\r\n\r\n# Invert Miasma Phase (go Lingering -> Creeping -> Creeping lanes)\r\n12079.6 \"Invert Miasma\" Ability { id: \"59EE\", source: \"Bozjan Phantom\" }\r\n12080.6 \"Creeping Miasma 1\" Ability { id: \"57B4\", source: \"Bozjan Phantom\" }\r\n12082.2 \"Creeping Miasma 2\" #Ability { id: \"57B5\", source: \"Bozjan Phantom\" }\r\n12083.8 \"Creeping Miasma 3\" #Ability { id: \"57B5\", source: \"Bozjan Phantom\" }\r\n12085.4 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12087.0 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12088.6 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12090.2 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12090.6 \"Creeping Miasma 1\" Ability { id: \"57B4\", source: \"Bozjan Phantom\" }\r\n12091.8 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12092.0 \"Creeping Miasma 2\" #Ability { id: \"57B5\", source: \"Bozjan Phantom\" }\r\n12093.6 \"Creeping Miasma 3\" #Ability { id: \"57B5\", source: \"Bozjan Phantom\" }\r\n12095.2 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12096.8 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12098.4 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12100.0 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12100.7 \"--middle--\" Ability { id: \"57AD\", source: \"Bozjan Phantom\" }\r\n12101.6 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n\r\n# Add phase\r\n# TODO: unclear if these adds are on a timer (~3 logs were +/- 1 second) or if\r\n# they just pop when previous set is done.  Include here for clarity, but\r\n# don't bother syncing so that the enrage is correct, regardless.\r\n12105.1 \"Summon Adds\" Ability { id: \"57C0\", source: \"Bozjan Phantom\" }\r\n12105.8 \"1x Misty Wraith\"\r\n12105.8 \"2x Bloody Wraith\"\r\n12106.1 \"--untargetable--\"\r\n12115.8 \"2x Misty Wraith\"\r\n12115.8 \"2x Bloody Wraith\"\r\n12128.0 \"3x Misty Wraith\"\r\n12128.0 \"3x Bloody Wraith\"\r\n12155.2 \"Malediction of Ruin Enrage\" Ability { id: \"57C1\", source: \"Bozjan Phantom\" }\r\n12157.2 \"--targetable--\"\r\n\r\n# Start of loop block\r\n12162.3 \"--sync--\" StartsUsing { id: \"57B2\", source: \"Bozjan Phantom\" } window 100,50\r\n12165.3 \"Weave Miasma\" Ability { id: \"57B2\", source: \"Bozjan Phantom\" }\r\n12171.5 \"Summon\" Ability { id: \"57BA\", source: \"Bozjan Phantom\" }\r\n12187.6 \"Undying Hatred\" Ability { id: \"57C2\", source: \"Stuffy Wraith\" }\r\n\r\n12191.5 \"Manipulate Miasma?\" Ability { id: \"57B3\", source: \"Bozjan Phantom\" } jump 12300\r\n12191.5 \"Invert Miasma?\" Ability { id: \"59EE\", source: \"Bozjan Phantom\" } jump 12500\r\n\r\n# Manipulate Miasma Phase (go Swirling -> Creeping lanes)\r\n12300.0 \"Manipulate Miasma\" Ability { id: \"57B3\", source: \"Bozjan Phantom\" }\r\n12301.0 \"Swirling Miasma 1\" #Ability { id: \"57B8\", source: \"Bozjan Phantom\" }\r\n12302.7 \"Swirling Miasma 2\" #Ability { id: \"57B9\", source: \"Bozjan Phantom\" }\r\n12304.3 \"Swirling Miasma 3\" #Ability { id: \"57B9\", source: \"Bozjan Phantom\" }\r\n12305.9 \"Swirling Miasma 4\" #Ability { id: \"57B9\", source: \"Bozjan Phantom\" }\r\n12307.5 \"Swirling Miasma 5\" #Ability { id: \"57B9\", source: \"Bozjan Phantom\" }\r\n12309.1 \"Swirling Miasma 6\" #Ability { id: \"57B9\", source: \"Bozjan Phantom\" }\r\n12310.7 \"Swirling Miasma 7\" #Ability { id: \"57B9\", source: \"Bozjan Phantom\" }\r\n12311.0 \"Creeping Miasma 1\" Ability { id: \"57B4\", source: \"Bozjan Phantom\" }\r\n12312.2 \"Swirling Miasma 8\" #Ability { id: \"57B9\", source: \"Bozjan Phantom\" }\r\n12312.4 \"Creeping Miasma 2\" #Ability { id: \"57B5\", source: \"Bozjan Phantom\" }\r\n12314.0 \"Creeping Miasma 3\" #Ability { id: \"57B5\", source: \"Bozjan Phantom\" }\r\n12314.0 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12315.6 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12317.0 \"--middle--\" Ability { id: \"57AD\", source: \"Bozjan Phantom\" } # \"Transference\"\r\n12317.2 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12318.8 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12320.4 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12322.0 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n\r\n# Tank buster and AoE Intermediary Loop\r\n12324.3 \"Vile Wave\" Ability { id: \"57BF\", source: \"Bozjan Phantom\" }\r\n12340.4 \"Ice Spikes\" Ability { id: \"57BC\", source: \"Bozjan Phantom\" }\r\n12351.5 \"Excruciation\" Ability { id: \"57BE\", source: \"Bozjan Phantom\" }\r\n12357.6 \"Malediction of Agony\" Ability { id: \"57BD\", source: \"Bozjan Phantom\" }\r\n12368.9 \"Weave Miasma\" Ability { id: \"57B2\", source: \"Bozjan Phantom\" } window 100,100 jump 12165.3\r\n12375.0 \"Summon\" #Ability { id: \"57BA\", source: \"Bozjan Phantom\" }\r\n12391.1 \"Undying Hatred\" #Ability { id: \"57C2\", source: \"Stuffy Wraith\" }\r\n12395.0 \"Manipulate Miasma?\" #Ability { id: \"57B3\", source: \"Bozjan Phantom\" }\r\n12395.0 \"Invert Miasma?\" #Ability { id: \"59EE\", source: \"Bozjan Phantom\" }\r\n\r\n# Invert Miasma Phase (go Lingering -> Creeping -> Creeping lanes)\r\n12500.0 \"Invert Miasma\" Ability { id: \"59EE\", source: \"Bozjan Phantom\" }\r\n12501.0 \"Creeping Miasma 1\" Ability { id: \"57B4\", source: \"Bozjan Phantom\" }\r\n12502.6 \"Creeping Miasma 2\" #Ability { id: \"57B5\", source: \"Bozjan Phantom\" }\r\n12504.2 \"Creeping Miasma 3\" #Ability { id: \"57B5\", source: \"Bozjan Phantom\" }\r\n12505.8 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12507.4 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12509.0 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12510.6 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12511.0 \"Creeping Miasma 1\" Ability { id: \"57B4\", source: \"Bozjan Phantom\" }\r\n12512.5 \"Creeping Miasma 2\" #Ability { id: \"57B5\", source: \"Bozjan Phantom\" }\r\n12514.1 \"Creeping Miasma 3\" #Ability { id: \"57B5\", source: \"Bozjan Phantom\" }\r\n12515.7 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12517.1 \"--middle--\" Ability { id: \"57AD\", source: \"Bozjan Phantom\" } # \"Transference\"\r\n12517.3 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12518.9 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12520.5 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n12522.1 \"Lingering Miasma\" #Ability { id: \"57B7\", source: \"Bozjan Phantom\" }\r\n\r\n# Invert Miasma Loop\r\n12524.4 \"Vile Wave\" Ability { id: \"57BF\", source: \"Bozjan Phantom\" }\r\n12540.5 \"Ice Spikes\" Ability { id: \"57BC\", source: \"Bozjan Phantom\" }\r\n12551.6 \"Excruciation\" Ability { id: \"57BE\", source: \"Bozjan Phantom\" }\r\n12557.7 \"Malediction of Agony\" Ability { id: \"57BD\", source: \"Bozjan Phantom\" }\r\n12568.9 \"Weave Miasma\" Ability { id: \"57B2\", source: \"Bozjan Phantom\" } window 100,100 jump 12165.3\r\n12575.1 \"Summon\" #Ability { id: \"57BA\", source: \"Bozjan Phantom\" }\r\n12591.2 \"Undying Hatred\" #Ability { id: \"57C2\", source: \"Stuffy Wraith\" }\r\n12595.1 \"Manipulate Miasma?\" #Ability { id: \"57B3\", source: \"Bozjan Phantom\" }\r\n12595.1 \"Invert Miasma?\" #Ability { id: \"59EE\", source: \"Bozjan Phantom\" }\r\n\r\n\r\n### Trinity Avowed\r\n# -p 594E:14011.8\r\n# -ii 5B32 593B 593C 593D 593E 593F 5940 5941 4E5C 4F53 4F54 5929 592B 592D 592F 5930 5931 5932 5933 5934 5935 5936 5937 5938 5B3B 593C 5955 5B24\r\n# -it \"Trinity Avowed\"\r\n\r\n# This fight has three weapons (sword, bow staff) each of which has two different versions (v1, v2).\r\n# The phase are: initial -> (all v1s in any order) -> (all v2s in any order) -> enrage.\r\n# An example phase ordering:\r\n#    initial -> sword v1 -> staff v1 -> bow v1 -> staff v2 -> sword v2 -> bow v2 -> enrage\r\n# Unfortunately, the \"sword v1\" transition is the same as \"sword v2\" in terms of abilities, and so\r\n# if you are at the end of a \"bow v1\" block, it is unclear from pure ability ids whether :5985:\r\n# means \"sword v1\" or \"sword v2\".  Timelines don't have any state (yet?) so things get repeated.\r\n#\r\n# Thus, the example block above would go through the following blocks (ctrl+f names to see below):\r\n# - Initial Phase\r\n# - Sword v1 (initial)\r\n# - Staff v1 (seen sword)\r\n# - roll into Bow v1 (final), [the \"staff v1 (seen sword)\" block has \"Bow v1 (final)\" included]\r\n# - Staff v2\r\n# - Sword v2\r\n# - Bow v2\r\n# - Enrage\r\n#\r\n# The \"Staff v1 (seen sword)\" block can then know that any future sword abilities are \"Sword v2\",\r\n# at the cost of duplicating a lot of timelines and making this very hard to follow, sorry.\r\n\r\n# Note: it is possible to transition directly from bow v1 -> bow v2.\r\n\r\n# Note: various \"Blast\" are renamed \"Elemental Blast\" and various \"Arrow\" are renamed\r\n# to be \"Elemental Arrow\" to avoid having too many skills on the timeline.\r\n\r\n# Note: Blade of Entropy is `Ability { id: \"594[23456789]|595[6789ABCD]\", source: [\"Trinity Avowed\", \"Avowed Avatar\"] }``\r\n\r\n# The Vault of Singing Crystal will be sealed off\r\n14000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E20\" } window 20000,0\r\n# .*is no longer sealed\r\n14000.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,2000 jump 0\r\n14006.7 \"--sync--\" StartsUsing { id: \"594E\", source: \"Trinity Avowed\" } window 10,10\r\n14011.8 \"Wrath Of Bozja\" Ability { id: \"594E\", source: \"Trinity Avowed\" }\r\n14019.9 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n\r\n# Initial Phase\r\n14029.2 \"Allegiant Arsenal\" Ability { id: \"598[567]\", source: \"Trinity Avowed\" }\r\n14034.4 \"Flashvane/Fury Of Bozja/Infernal Slash\" Ability { id: [\"594B\", \"594C\", \"594A\"], source: \"Trinity Avowed\" }\r\n14037.5 \"--sync--\" Ability { id: \"5983\", source: \"Trinity Avowed\" }\r\n14042.6 \"Allegiant Arsenal\" Ability { id: \"598[567]\", source: \"Trinity Avowed\" }\r\n14047.8 \"Flashvane/Fury Of Bozja/Infernal Slash\" Ability { id: [\"594B\", \"594C\", \"594A\"], source: \"Trinity Avowed\" }\r\n14050.9 \"--sync--\" Ability { id: \"5984\", source: \"Trinity Avowed\" }\r\n14056.0 \"Allegiant Arsenal\" # -> random jump to initial weapon phase\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Sword v1 (initial)?\r\n14053.0 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" } window 10,10 jump 14100\r\n14061.2 \"Infernal Slash?\" #Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n# -> Bow v1 (initial)?\r\n14053.0 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" } window 10,10 jump 14700\r\n14061.2 \"Flashvane?\" #Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n# -> Staff v1 (initial)?\r\n14053.0 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" } window 10,10 jump 15300\r\n14061.2 \"Fury Of Bozja?\" #Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Sword v1 (initial)\r\n14100.0 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" }\r\n14103.0 \"Allegiant Arsenal\" Ability { id: \"5985\", source: \"Trinity Avowed\" }\r\n14108.2 \"Infernal Slash\" Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n14115.6 \"Hot And Cold\" Ability { id: \"5BAF\", source: \"Trinity Avowed\" }\r\n14122.7 \"Unwavering Apparition\" Ability { id: \"5B3A\", source: \"Trinity Avowed\" }\r\n14128.7 \"--untargetable--\"\r\n14138.8 \"Blade Of Entropy 1\" #Ability { id: \"5959\", source: \"Trinity Avowed\" }\r\n14152.5 \"Blade Of Entropy 2\" #Ability { id: \"5959\", source: \"Trinity Avowed\" }\r\n14155.6 \"--targetable--\"\r\n14160.3 \"--sync--\" Ability { id: \"5982\", source: \"Trinity Avowed\" }\r\n14167.4 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Bow v1 (seen sword)?\r\n14175.3 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" } window 70,10 jump 14900\r\n14183.5 \"Flashvane?\" #Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n# -> Staff v1 (seen sword)?\r\n14175.3 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" } window 70,10 jump 15500\r\n14183.5 \"Fury Of Bozja?\" #Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Sword v1 (seen bow)\r\n14300.0 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" }\r\n14303.0 \"Allegiant Arsenal\" Ability { id: \"5985\", source: \"Trinity Avowed\" }\r\n14308.2 \"Infernal Slash\" Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n14315.6 \"Hot And Cold\" Ability { id: \"5BAF\", source: \"Trinity Avowed\" }\r\n14322.7 \"Unwavering Apparition\" Ability { id: \"5B3A\", source: \"Trinity Avowed\" }\r\n14328.7 \"--untargetable--\"\r\n14338.8 \"Blade Of Entropy 1\" #Ability { id: \"5959\", source: \"Trinity Avowed\" }\r\n14352.5 \"Blade Of Entropy 2\" #Ability { id: \"5959\", source: \"Trinity Avowed\" }\r\n14355.6 \"--targetable--\"\r\n14360.3 \"--sync--\" Ability { id: \"5982\", source: \"Trinity Avowed\" }\r\n14367.4 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n# -> roll into Staff v1 (final)\r\n14375.3 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" } window 70,10\r\n14378.3 \"Allegiant Arsenal\" Ability { id: \"5987\", source: \"Trinity Avowed\" }\r\n14383.5 \"Fury Of Bozja\" Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n14389.6 \"Hot And Cold\" Ability { id: \"597B\", source: \"Trinity Avowed\" }\r\n14396.7 \"Quick March\" Ability { id: \"5981\", source: \"Trinity Avowed\" }\r\n14402.9 \"Freedom Of Bozja\" Ability { id: \"597C\", source: \"Trinity Avowed\" }\r\n14410.3 \"Elemental Impact\" Ability { id: \"4F52\", source: \"Tempestuous Orb\" }\r\n14420.1 \"Elemental Blast\" Ability { id: \"592E\", source: \"Tempestuous Orb\" }\r\n14425.9 \"--sync--\" Ability { id: \"5984\", source: \"Trinity Avowed\" }\r\n14433.0 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n14444.5 \"Allegiant Arsenal\"\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Sword v2?\r\n14441.5 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" } window 40,10 jump 15900\r\n14449.7 \"Infernal Slash?\" #Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n# -> Bow v2?\r\n14441.5 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" } window 40,10 jump 16100\r\n14449.7 \"Flashvane?\" #Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n# -> Staff v2?\r\n14441.5 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" } window 40,10 jump 16300\r\n14449.7 \"Fury Of Bozja?\" #Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Sword v1 (seen staff)\r\n14500.0 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" }\r\n14503.0 \"Allegiant Arsenal\" Ability { id: \"5985\", source: \"Trinity Avowed\" }\r\n14508.2 \"Infernal Slash\" Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n14515.6 \"Hot And Cold\" Ability { id: \"5BAF\", source: \"Trinity Avowed\" }\r\n14522.7 \"Unwavering Apparition\" Ability { id: \"5B3A\", source: \"Trinity Avowed\" }\r\n14528.7 \"--untargetable--\"\r\n14538.8 \"Blade Of Entropy 1\" #Ability { id: \"5959\", source: \"Trinity Avowed\" }\r\n14552.5 \"Blade Of Entropy 2\" #Ability { id: \"5959\", source: \"Trinity Avowed\" }\r\n14555.6 \"--targetable--\"\r\n14560.3 \"--sync--\" Ability { id: \"5982\", source: \"Trinity Avowed\" }\r\n14567.4 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n# -> roll into Bow v1 (final)\r\n14575.3 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" } window 70,10\r\n14578.3 \"Allegiant Arsenal\" Ability { id: \"5986\", source: \"Trinity Avowed\" }\r\n14583.5 \"Flashvane\" Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n14589.6 \"Quick March\" Ability { id: \"5BB3\", source: \"Trinity Avowed\" }\r\n14597.9 \"Wrath Of Bozja\" Ability { id: \"5BB5\", source: \"Trinity Avowed\" }\r\n14604.0 \"Flames Of Bozja\" Ability { id: \"597E\", source: \"Trinity Avowed\" }\r\n14614.1 \"--sync--\" Ability { id: \"5B3D\", source: \"Trinity Avowed\" }\r\n14614.1 \"Flames Of Bozja\" Ability { id: \"5939\", source: \"Trinity Avowed\" }\r\n14617.3 \"Hot And Cold\" Ability { id: \"5BB0\", source: \"Trinity Avowed\" }\r\n14625.1 \"Shimmering Shot\" Ability { id: \"597F\", source: \"Trinity Avowed\" }\r\n14641.4 \"Elemental Arrow\" Ability { id: \"593A\", source: \"Spark Arrow\" }\r\n14646.7 \"--sync--\" Ability { id: \"5983\", source: \"Trinity Avowed\" } window 10,10 # some variance here\r\n14653.8 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n14664.2 \"Allegiant Arsenal\"\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Sword v2?\r\n14661.2 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" } window 40,10 jump 15900\r\n14669.4 \"Infernal Slash?\" #Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n# -> Bow v2?\r\n14661.2 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" } window 40,10 jump 16100\r\n14669.4 \"Flashvane?\" #Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n# -> Staff v2?\r\n14661.2 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" } window 40,10 jump 16300\r\n14669.4 \"Fury Of Bozja?\" #Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Bow v1 (initial)\r\n14700.0 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" }\r\n14703.0 \"Allegiant Arsenal\" Ability { id: \"5986\", source: \"Trinity Avowed\" }\r\n14708.2 \"Flashvane\" Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n14714.3 \"Quick March\" Ability { id: \"5BB3\", source: \"Trinity Avowed\" }\r\n14722.6 \"Wrath Of Bozja\" Ability { id: \"5BB5\", source: \"Trinity Avowed\" }\r\n14728.7 \"Flames Of Bozja\" Ability { id: \"597E\", source: \"Trinity Avowed\" }\r\n14738.8 \"--sync--\" Ability { id: \"5B3D\", source: \"Trinity Avowed\" }\r\n14738.8 \"Flames Of Bozja\" Ability { id: \"5939\", source: \"Trinity Avowed\" }\r\n14742.0 \"Hot And Cold\" Ability { id: \"5BB0\", source: \"Trinity Avowed\" }\r\n14749.8 \"Shimmering Shot\" Ability { id: \"597F\", source: \"Trinity Avowed\" }\r\n14766.1 \"Elemental Arrow\" Ability { id: \"593A\", source: \"Spark Arrow\" }\r\n14771.4 \"--sync--\" Ability { id: \"5983\", source: \"Trinity Avowed\" } window 10,10 # some variance here\r\n14778.5 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n14788.9 \"Allegiant Arsenal\"\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Sword v1 (seen bow)?\r\n14785.9 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" } window 70,10 jump 14300\r\n14794.1 \"Infernal Slash?\" #Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n# -> Staff v1 (seen bow)?\r\n14785.9 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" } window 70,10 jump 15700\r\n14794.1 \"Fury Of Bozja?\" #Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Bow v1 (seen sword)\r\n14900.0 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" }\r\n14903.0 \"Allegiant Arsenal\" Ability { id: \"5986\", source: \"Trinity Avowed\" }\r\n14908.2 \"Flashvane\" Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n14914.3 \"Quick March\" Ability { id: \"5BB3\", source: \"Trinity Avowed\" }\r\n14922.6 \"Wrath Of Bozja\" Ability { id: \"5BB5\", source: \"Trinity Avowed\" }\r\n14928.7 \"Flames Of Bozja\" Ability { id: \"597E\", source: \"Trinity Avowed\" }\r\n14938.8 \"--sync--\" Ability { id: \"5B3D\", source: \"Trinity Avowed\" }\r\n14938.8 \"Flames Of Bozja\" Ability { id: \"5939\", source: \"Trinity Avowed\" }\r\n14942.0 \"Hot And Cold\" Ability { id: \"5BB0\", source: \"Trinity Avowed\" }\r\n14949.8 \"Shimmering Shot\" Ability { id: \"597F\", source: \"Trinity Avowed\" }\r\n14966.1 \"Elemental Arrow\" Ability { id: \"593A\", source: \"Spark Arrow\" }\r\n14971.4 \"--sync--\" Ability { id: \"5983\", source: \"Trinity Avowed\" } window 10,10 # some variance here\r\n14978.5 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n# -> roll into Staff v1 (final)\r\n14985.9 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" } window 70,10\r\n14988.9 \"Allegiant Arsenal\" Ability { id: \"5987\", source: \"Trinity Avowed\" }\r\n14994.1 \"Fury Of Bozja\" Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n15000.2 \"Hot And Cold\" Ability { id: \"597B\", source: \"Trinity Avowed\" }\r\n15007.3 \"Quick March\" Ability { id: \"5981\", source: \"Trinity Avowed\" }\r\n15013.5 \"Freedom Of Bozja\" Ability { id: \"597C\", source: \"Trinity Avowed\" }\r\n15020.9 \"Elemental Impact\" Ability { id: \"4F52\", source: \"Tempestuous Orb\" }\r\n15030.7 \"Elemental Blast\" Ability { id: \"592E\", source: \"Tempestuous Orb\" }\r\n15036.5 \"--sync--\" Ability { id: \"5984\", source: \"Trinity Avowed\" }\r\n15043.6 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n15055.1 \"Allegiant Arsenal\"\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Sword v2?\r\n15052.1 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" } window 40,10 jump 15900\r\n15060.3 \"Infernal Slash?\" #Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n# -> Bow v2?\r\n15052.1 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" } window 40,10 jump 16100\r\n15060.3 \"Flashvane?\" #Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n# -> Staff v2?\r\n15052.1 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" } window 40,10 jump 16300\r\n15060.3 \"Fury Of Bozja?\" #Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Bow v1 (seen staff)\r\n15100.0 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" }\r\n15103.0 \"Allegiant Arsenal\" Ability { id: \"5986\", source: \"Trinity Avowed\" }\r\n15108.2 \"Flashvane\" Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n15114.3 \"Quick March\" Ability { id: \"5BB3\", source: \"Trinity Avowed\" }\r\n15122.6 \"Wrath Of Bozja\" Ability { id: \"5BB5\", source: \"Trinity Avowed\" }\r\n15128.7 \"Flames Of Bozja\" Ability { id: \"597E\", source: \"Trinity Avowed\" }\r\n15138.8 \"--sync--\" Ability { id: \"5B3D\", source: \"Trinity Avowed\" }\r\n15138.8 \"Flames Of Bozja\" Ability { id: \"5939\", source: \"Trinity Avowed\" }\r\n15142.0 \"Hot And Cold\" Ability { id: \"5BB0\", source: \"Trinity Avowed\" }\r\n15149.8 \"Shimmering Shot\" Ability { id: \"597F\", source: \"Trinity Avowed\" }\r\n15166.1 \"Elemental Arrow\" Ability { id: \"593A\", source: \"Spark Arrow\" }\r\n15171.4 \"--sync--\" Ability { id: \"5983\", source: \"Trinity Avowed\" } window 10,10 # some variance here\r\n15178.5 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n# -> roll into Sword v1 (final)\r\n15185.9 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" } window 70,10\r\n15188.9 \"Allegiant Arsenal\" Ability { id: \"5985\", source: \"Trinity Avowed\" }\r\n15194.1 \"Infernal Slash\" Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n15201.5 \"Hot And Cold\" Ability { id: \"5BAF\", source: \"Trinity Avowed\" }\r\n15208.6 \"Unwavering Apparition\" Ability { id: \"5B3A\", source: \"Trinity Avowed\" }\r\n15214.6 \"--untargetable--\"\r\n15224.7 \"Blade Of Entropy 1\" #Ability { id: \"5959\", source: \"Trinity Avowed\" }\r\n15238.4 \"Blade Of Entropy 2\" #Ability { id: \"5959\", source: \"Trinity Avowed\" }\r\n15241.5 \"--targetable--\"\r\n15246.2 \"--sync--\" Ability { id: \"5982\", source: \"Trinity Avowed\" }\r\n15253.3 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Sword v2?\r\n15261.2 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" } window 40,10 jump 15900\r\n15269.4 \"Infernal Slash?\" #Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n# -> Bow v2?\r\n15261.2 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" } window 40,10 jump 16100\r\n15269.4 \"Flashvane?\" #Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n# -> Staff v2?\r\n15261.2 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" } window 40,10 jump 16300\r\n15269.4 \"Fury Of Bozja?\" #Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Staff v1 (initial)\r\n15300.0 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" }\r\n15303.0 \"Allegiant Arsenal\" Ability { id: \"5987\", source: \"Trinity Avowed\" }\r\n15308.2 \"Fury Of Bozja\" Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n15314.3 \"Hot And Cold\" Ability { id: \"597B\", source: \"Trinity Avowed\" }\r\n15321.4 \"Quick March\" Ability { id: \"5981\", source: \"Trinity Avowed\" }\r\n15327.6 \"Freedom Of Bozja\" Ability { id: \"597C\", source: \"Trinity Avowed\" }\r\n15335.0 \"Elemental Impact\" Ability { id: \"4F52\", source: \"Tempestuous Orb\" }\r\n15344.8 \"Elemental Blast\" Ability { id: \"592E\", source: \"Tempestuous Orb\" }\r\n15350.6 \"--sync--\" Ability { id: \"5984\", source: \"Trinity Avowed\" }\r\n15357.7 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n15369.2 \"Allegiant Arsenal\"\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Sword v1 (seen staff)\r\n15366.2 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" } window 70,10 jump 14500\r\n15374.4 \"Infernal Slash?\" #Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n# -> Bow v1 (seen staff)\r\n15366.2 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" } window 70,10 jump 15100\r\n15374.4 \"Flashvane?\" #Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Staff v1 (seen sword)\r\n15500.0 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" }\r\n15503.0 \"Allegiant Arsenal\" Ability { id: \"5987\", source: \"Trinity Avowed\" }\r\n15508.2 \"Fury Of Bozja\" Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n15514.3 \"Hot And Cold\" Ability { id: \"597B\", source: \"Trinity Avowed\" }\r\n15521.4 \"Quick March\" Ability { id: \"5981\", source: \"Trinity Avowed\" }\r\n15527.6 \"Freedom Of Bozja\" Ability { id: \"597C\", source: \"Trinity Avowed\" }\r\n15535.0 \"Elemental Impact\" Ability { id: \"4F52\", source: \"Tempestuous Orb\" }\r\n15544.8 \"Elemental Blast\" Ability { id: \"592E\", source: \"Tempestuous Orb\" }\r\n15550.6 \"--sync--\" Ability { id: \"5984\", source: \"Trinity Avowed\" }\r\n15557.7 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n# -> roll into Bow v1 (final)\r\n15566.2 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" } window 70,10\r\n15569.2 \"Allegiant Arsenal\" Ability { id: \"5986\", source: \"Trinity Avowed\" }\r\n15574.4 \"Flashvane\" Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n15580.5 \"Quick March\" Ability { id: \"5BB3\", source: \"Trinity Avowed\" }\r\n15588.8 \"Wrath Of Bozja\" Ability { id: \"5BB5\", source: \"Trinity Avowed\" }\r\n15594.9 \"Flames Of Bozja\" Ability { id: \"597E\", source: \"Trinity Avowed\" }\r\n15605.0 \"--sync--\" Ability { id: \"5B3D\", source: \"Trinity Avowed\" }\r\n15605.0 \"Flames Of Bozja\" Ability { id: \"5939\", source: \"Trinity Avowed\" }\r\n15608.2 \"Hot And Cold\" Ability { id: \"5BB0\", source: \"Trinity Avowed\" }\r\n15616.0 \"Shimmering Shot\" Ability { id: \"597F\", source: \"Trinity Avowed\" }\r\n15632.3 \"Elemental Arrow\" Ability { id: \"593A\", source: \"Spark Arrow\" }\r\n15637.6 \"--sync--\" Ability { id: \"5983\", source: \"Trinity Avowed\" } window 10,10 # some variance here\r\n15644.7 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n15655.1 \"Allegiant Arsenal\"\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Sword v2?\r\n15652.1 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" } window 40,10 jump 15900\r\n15660.3 \"Infernal Slash?\" #Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n# -> Bow v2?\r\n15652.1 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" } window 40,10 jump 16100\r\n15660.3 \"Flashvane?\" #Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n# -> Staff v2?\r\n15652.1 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" } window 40,10 jump 16300\r\n15660.3 \"Fury Of Bozja?\" #Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Staff v1 (seen bow)\r\n15700.0 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" }\r\n15703.0 \"Allegiant Arsenal\" Ability { id: \"5987\", source: \"Trinity Avowed\" }\r\n15708.2 \"Fury Of Bozja\" Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n15714.3 \"Hot And Cold\" Ability { id: \"597B\", source: \"Trinity Avowed\" }\r\n15721.4 \"Quick March\" Ability { id: \"5981\", source: \"Trinity Avowed\" }\r\n15727.6 \"Freedom Of Bozja\" Ability { id: \"597C\", source: \"Trinity Avowed\" }\r\n15735.0 \"Elemental Impact\" Ability { id: \"4F52\", source: \"Tempestuous Orb\" }\r\n15744.8 \"Elemental Blast\" Ability { id: \"592E\", source: \"Tempestuous Orb\" }\r\n15750.6 \"--sync--\" Ability { id: \"5984\", source: \"Trinity Avowed\" }\r\n15757.7 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n# -> roll into Sword v1 (final)\r\n15766.2 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" } window 70,10\r\n15769.2 \"Allegiant Arsenal\" Ability { id: \"5985\", source: \"Trinity Avowed\" }\r\n15774.4 \"Infernal Slash\" Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n15781.8 \"Hot And Cold\" Ability { id: \"5BAF\", source: \"Trinity Avowed\" }\r\n15788.9 \"Unwavering Apparition\" Ability { id: \"5B3A\", source: \"Trinity Avowed\" }\r\n15794.9 \"--untargetable--\"\r\n15805.0 \"Blade Of Entropy 1\" #Ability { id: \"5959\", source: \"Trinity Avowed\" }\r\n15818.7 \"Blade Of Entropy 2\" #Ability { id: \"5959\", source: \"Trinity Avowed\" }\r\n15821.8 \"--targetable--\"\r\n15826.5 \"--sync--\" Ability { id: \"5982\", source: \"Trinity Avowed\" }\r\n15833.6 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n15844.5 \"Allegiant Arsenal\"\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Sword v2?\r\n15841.5 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" } window 40,10 jump 15900\r\n15849.7 \"Infernal Slash?\" #Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n# -> Bow v2?\r\n15841.5 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" } window 40,10 jump 16100\r\n15849.7 \"Flashvane?\" #Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n# -> Staff v2?\r\n15841.5 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" } window 40,10 jump 16300\r\n15849.7 \"Fury Of Bozja?\" #Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Sword v2\r\n15900.0 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" }\r\n15903.0 \"Allegiant Arsenal\" Ability { id: \"5985\", source: \"Trinity Avowed\" }\r\n15908.2 \"Infernal Slash\" Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n15915.4 \"Hot And Cold\" Ability { id: \"5BAF\", source: \"Trinity Avowed\" }\r\n15922.5 \"Elemental Brand\" Ability { id: \"5BB1\", source: \"Trinity Avowed\" }\r\n15928.6 \"Unwavering Apparition\" Ability { id: \"5B3A\", source: \"Trinity Avowed\" }\r\n15934.6 \"--untargetable--\"\r\n15944.7 \"Blade Of Entropy 1\" #Ability { id: \"5959\", source: \"Trinity Avowed\" }\r\n15958.7 \"Blade Of Entropy 2\" #Ability { id: \"5959\", source: \"Trinity Avowed\" }\r\n15961.8 \"--targetable--\"\r\n15966.2 \"--sync--\" Ability { id: \"5982\", source: \"Trinity Avowed\" }\r\n15973.3 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n15984.6 \"Allegiant Arsenal\"\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Bow v2?\r\n15981.6 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" } window 70,10 jump 16100\r\n15989.8 \"Flashvane?\" #Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n# -> Staff v2?\r\n15981.6 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" } window 70,10 jump 16300\r\n15989.8 \"Fury Of Bozja?\" #Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Bow v2\r\n16100.0 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" }\r\n16103.0 \"Allegiant Arsenal\" Ability { id: \"5986\", source: \"Trinity Avowed\" }\r\n16108.2 \"Flashvane\" Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n16114.3 \"Unseen Eye\" Ability { id: \"5BB4\", source: \"Trinity Avowed\" }\r\n16120.5 \"Flames Of Bozja\" Ability { id: \"597E\", source: \"Trinity Avowed\" }\r\n16125.6 \"Gleaming Arrow\" Ability { id: \"594D\", source: \"Avowed Avatar\" }\r\n16130.6 \"--sync--\" Ability { id: \"5B3D\", source: \"Trinity Avowed\" }\r\n16130.6 \"Flames Of Bozja\" Ability { id: \"5939\", source: \"Trinity Avowed\" }\r\n16133.9 \"Hot And Cold\" Ability { id: \"5BB0\", source: \"Trinity Avowed\" }\r\n16141.0 \"Elemental Brand\" Ability { id: \"5BB2\", source: \"Trinity Avowed\" }\r\n16147.2 \"Quick March\" Ability { id: \"5BB3\", source: \"Trinity Avowed\" }\r\n16154.0 \"Shimmering Shot\" Ability { id: \"597F\", source: \"Trinity Avowed\" }\r\n16171.3 \"Elemental Arrow\" Ability { id: \"593A\", source: \"Spark Arrow\" }\r\n16176.7 \"--sync--\" Ability { id: \"5983\", source: \"Trinity Avowed\" } window 10,10 # some variance here\r\n16183.8 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n16192.3 \"Wrath Of Bozja\" Ability { id: \"594E\", source: \"Trinity Avowed\" }\r\n16203.0 \"Allegiant Arsenal\" Ability { id: \"5987\", source: \"Trinity Avowed\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Sword v2?\r\n16200.0 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" } window 70,10 jump 15900\r\n16208.2 \"Infernal Slash?\" #Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n# -> Staff v2?\r\n16200.0 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" } window 70,10 jump 16300\r\n16208.2 \"Fury Of Bozja?\" #Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n\r\n# Staff v2\r\n16300.0 \"--sync--\" StartsUsing { id: \"5987\", source: \"Trinity Avowed\" }\r\n16303.0 \"Allegiant Arsenal\" Ability { id: \"5987\", source: \"Trinity Avowed\" }\r\n16308.2 \"Fury Of Bozja\" Ability { id: \"594C\", source: \"Trinity Avowed\" }\r\n16314.3 \"Hot And Cold\" Ability { id: \"597B\", source: \"Trinity Avowed\" }\r\n16321.4 \"Elemental Brand\" Ability { id: \"597D\", source: \"Trinity Avowed\" }\r\n16327.6 \"Freedom Of Bozja\" Ability { id: \"597C\", source: \"Trinity Avowed\" }\r\n16333.7 \"Unseen Eye\" Ability { id: \"5980\", source: \"Trinity Avowed\" }\r\n16335.0 \"Elemental Impact\" Ability { id: \"4F52\", source: \"Tempestuous Orb\" }\r\n16344.8 \"Elemental Blast\" Ability { id: \"592E\", source: \"Tempestuous Orb\" }\r\n16345.0 \"Gleaming Arrow\" Ability { id: \"594D\", source: \"Avowed Avatar\" }\r\n16350.5 \"--sync--\" Ability { id: \"5984\", source: \"Trinity Avowed\" }\r\n16357.6 \"Glory Of Bozja\" Ability { id: \"594F\", source: \"Trinity Avowed\" }\r\n16369.4 \"Allegiant Arsenal\"\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Sword v2?\r\n16366.4 \"--sync--\" StartsUsing { id: \"5985\", source: \"Trinity Avowed\" } window 70,10 jump 15900\r\n16374.6 \"Infernal Slash?\" #Ability { id: \"594A\", source: \"Trinity Avowed\" }\r\n# -> Bow v2?\r\n16366.4 \"--sync--\" StartsUsing { id: \"5986\", source: \"Trinity Avowed\" } window 70,10 jump 16100\r\n16374.6 \"Flashvane?\" #Ability { id: \"594B\", source: \"Trinity Avowed\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Enrage\r\n# This happens ~10 seconds after when the allegiant arsenal would have cast.\r\n# We could...technically...break up phase 2 into the same blocks like phase 1, but no.\r\n# TODO: Alternatively we could add this in as \"Enrage?\" to each block?\r\n16500.0 \"--sync--\" StartsUsing { id: \"5954\", source: \"Trinity Avowed\" } window 2500,0\r\n16512.0 \"Glory Of Bozja Enrage\" Ability { id: \"5954\", source: \"Trinity Avowed\" }\r\n16512.0 \"--untargetable--\"\r\n\r\n\r\n### Stygimoloch Lord\r\n# -p 57D7:18015.3 57C3:18204.5 57D2:19013.2\r\n# -ii 1961 55A6 57D0 57CE 57DD 57DC 57C8 57CA 57C6 57CC 5B38 57D3 57D6 57E2 501B 57DF 501A\r\n# -it \"Stygimoloch Lord\"\r\n# The Path of Divine Clarity will be sealed off\r\n18000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E22\" } window 20000,0\r\n# .*is no longer sealed\r\n18000.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,2000 jump 0\r\n\r\n# Note: 57CF is the cast for Whack but 57D1 is the instant damage.\r\n# Similarly, 57C4 is the cast for Devastating Bolt, but 57C5/57C6 is the delayed damage.\r\n# Both of these casts are renamed as --sync-- to clean up the timeline.\r\n\r\n# Phase 1\r\n18008.3 \"--sync--\" StartsUsing { id: \"57D7\", source: \"Stygimoloch Lord\" } window 15,15\r\n18015.3 \"Foe Splitter\" Ability { id: \"57D7\", source: \"Stygimoloch Lord\" }\r\n18023.4 \"Vicious Swipe\" Ability { id: \"5552\", source: \"Stygimoloch Lord\" }\r\n18028.5 \"--sync--\" Ability { id: \"57CF\", source: \"Stygimoloch Lord\" }\r\n18028.5 \"Whack 1\" #Ability { id: \"57D1\", source: \"Stygimoloch Lord\" }\r\n18030.5 \"Whack 2\" #Ability { id: \"57D1\", source: \"Stygimoloch Lord\" }\r\n18032.5 \"Whack 3\" #Ability { id: \"57D1\", source: \"Stygimoloch Lord\" }\r\n18042.8 \"1111-Tonze Swing\" Ability { id: \"57D8\", source: \"Stygimoloch Lord\" }\r\n18056.0 \"Rapid Bolts\" Ability { id: \"57CD\", source: \"Stygimoloch Lord\" } duration 12.8\r\n18063.1 \"Rapid Bolts\" Ability { id: \"57CD\", source: \"Stygimoloch Lord\" } duration 12.8\r\n18070.4 \"Rush\" Ability { id: \"57D9\", source: \"Stygimoloch Lord\" }\r\n18074.7 \"Rush\" Ability { id: \"57D9\", source: \"Stygimoloch Lord\" }\r\n# ??? does this loop? is there a natural push here?\r\n\r\n# Phase 2: Adds (70%)\r\n# This phase is awkward to have a timeline for, as the Stygimoloch Lord repeats\r\n# in a loop, but the adds are on an 18s timer which doesn't line up with the\r\n# loop.  Therefore, we'll just unroll this loop a few times and drop the\r\n# Mana Flame after a while.  Most logs don't even see the 2nd Fateful Words.\r\n18200.0 \"--untargetable--\" Ability { id: \"57DA\", source: \"Stygimoloch Lord\" }\r\n18201.5 \"--sync--\" StartsUsing { id: \"57C3\", source: \"Stygimoloch Lord\" } window 210,0\r\n18204.5 \"Memory of the Labyrinth\" Ability { id: \"57C3\", source: \"Stygimoloch Lord\" }\r\n18205.1 \"--adds--\"\r\n18215.4 \"Mana Flame\" Ability { id: \"57DE\", source: \"Ball Of Fire\" }\r\n18223.2 \"Entrapment\" Ability { id: \"57DB\", source: \"Stygimoloch Monk\" }\r\n18232.8 \"Labyrinthine Fate\" Ability { id: \"57C7\", source: \"Stygimoloch Lord\" }\r\n18233.4 \"Mana Flame\" Ability { id: \"57DE\", source: \"Ball Of Fire\" }\r\n\r\n18241.1 \"Fateful Words\" Ability { id: \"57C9\", source: \"Stygimoloch Lord\" }\r\n18247.2 \"--sync--\" Ability { id: \"57C4\", source: \"Stygimoloch Lord\" }\r\n18251.3 \"Mana Flame\" Ability { id: \"57DE\", source: \"Ball Of Fire\" }\r\n18251.7 \"Devastating Bolt\" Ability { id: \"57C5\", source: \"Stygimoloch Lord\" }\r\n18257.5 \"Rending Bolt\" Ability { id: \"57CB\", source: \"Stygimoloch Lord\" }\r\n18269.3 \"Mana Flame\" Ability { id: \"57DE\", source: \"Ball Of Fire\" }\r\n18271.7 \"Labyrinthine Fate\" Ability { id: \"57C7\", source: \"Stygimoloch Lord\" }\r\n18277.9 \"--sync--\" Ability { id: \"57C4\", source: \"Stygimoloch Lord\" }\r\n18282.4 \"Devastating Bolt\" Ability { id: \"57C5\", source: \"Stygimoloch Lord\" }\r\n18287.2 \"Mana Flame\" Ability { id: \"57DE\", source: \"Ball Of Fire\" }\r\n18288.3 \"Rending Bolt\" Ability { id: \"57CB\", source: \"Stygimoloch Lord\" }\r\n18296.4 \"Mana Flame\" Ability { id: \"57DE\", source: \"Ball Of Fire\" }\r\n\r\n18296.6 \"Fateful Words\" Ability { id: \"57C9\", source: \"Stygimoloch Lord\" }\r\n18304.7 \"Rending Bolt\" Ability { id: \"57CB\", source: \"Stygimoloch Lord\" }\r\n18305.2 \"Mana Flame\" Ability { id: \"57DE\", source: \"Ball Of Fire\" }\r\n18309.1 \"--sync--\" Ability { id: \"57C4\", source: \"Stygimoloch Lord\" }\r\n18313.6 \"Devastating Bolt\" Ability { id: \"57C5\", source: \"Stygimoloch Lord\" }\r\n18323.3 \"Mana Flame\" Ability { id: \"57DE\", source: \"Ball Of Fire\" }\r\n18327.4 \"Labyrinthine Fate\" Ability { id: \"57C7\", source: \"Stygimoloch Lord\" }\r\n18333.7 \"--sync--\" Ability { id: \"57C4\", source: \"Stygimoloch Lord\" }\r\n18338.2 \"Devastating Bolt\" Ability { id: \"57C5\", source: \"Stygimoloch Lord\" }\r\n18341.3 \"Mana Flame\" Ability { id: \"57DE\", source: \"Ball Of Fire\" }\r\n18344.0 \"Rending Bolt\" Ability { id: \"57CB\", source: \"Stygimoloch Lord\" }\r\n\r\n18352.3 \"Fateful Words\" Ability { id: \"57C9\", source: \"Stygimoloch Lord\" }\r\n18359.3 \"Mana Flame\" Ability { id: \"57DE\", source: \"Ball Of Fire\" }\r\n18360.5 \"Rending Bolt\" Ability { id: \"57CB\", source: \"Stygimoloch Lord\" }\r\n18364.8 \"--sync--\" Ability { id: \"57C4\", source: \"Stygimoloch Lord\" }\r\n18369.3 \"Devastating Bolt\" Ability { id: \"57C5\", source: \"Stygimoloch Lord\" }\r\n18377.4 \"Mana Flame\" Ability { id: \"57DE\", source: \"Ball Of Fire\" }\r\n18383.1 \"Labyrinthine Fate\" Ability { id: \"57C7\", source: \"Stygimoloch Lord\" }\r\n18389.4 \"--sync--\" Ability { id: \"57C4\", source: \"Stygimoloch Lord\" }\r\n18393.9 \"Devastating Bolt\" Ability { id: \"57C5\", source: \"Stygimoloch Lord\" }\r\n18395.4 \"Mana Flame\" Ability { id: \"57DE\", source: \"Ball Of Fire\" }\r\n18399.7 \"Rending Bolt\" Ability { id: \"57CB\", source: \"Stygimoloch Lord\" }\r\n\r\n# Drop Mana Flame callouts in order to make a loop.\r\n18408.0 \"Fateful Words\" Ability { id: \"57C9\", source: \"Stygimoloch Lord\" }\r\n18416.2 \"Rending Bolt\" Ability { id: \"57CB\", source: \"Stygimoloch Lord\" }\r\n18420.5 \"--sync--\" Ability { id: \"57C4\", source: \"Stygimoloch Lord\" }\r\n18425.0 \"Devastating Bolt\" Ability { id: \"57C5\", source: \"Stygimoloch Lord\" }\r\n18438.8 \"Labyrinthine Fate\" Ability { id: \"57C7\", source: \"Stygimoloch Lord\" }\r\n18445.1 \"--sync--\" Ability { id: \"57C4\", source: \"Stygimoloch Lord\" }\r\n18449.6 \"Devastating Bolt\" Ability { id: \"57C5\", source: \"Stygimoloch Lord\" }\r\n18455.4 \"Rending Bolt\" Ability { id: \"57CB\", source: \"Stygimoloch Lord\" }\r\n\r\n18463.7 \"Fateful Words\" Ability { id: \"57C9\", source: \"Stygimoloch Lord\" } window 50,50 jump 18408\r\n18471.9 \"Rending Bolt\" #Ability { id: \"57CB\", source: \"Stygimoloch Lord\" }\r\n18476.2 \"--sync--\" #Ability { id: \"57C4\", source: \"Stygimoloch Lord\" }\r\n18480.7 \"Devastating Bolt\" #Ability { id: \"57C5\", source: \"Stygimoloch Lord\" }\r\n18494.5 \"Labyrinthine Fate\" #Ability { id: \"57C7\", source: \"Stygimoloch Lord\" }\r\n18500.8 \"--sync--\" #Ability { id: \"57C4\", source: \"Stygimoloch Lord\" }\r\n18505.3 \"Devastating Bolt\" #Ability { id: \"57C5\", source: \"Stygimoloch Lord\" }\r\n18511.1 \"Rending Bolt\" #Ability { id: \"57CB\", source: \"Stygimoloch Lord\" }\r\n\r\n\r\n# Phase 3: Victory Lap (once adds are dead)\r\n19000.0 \"--targetable--\" NameToggle { name: \"Stygimoloch Lord\", toggle: \"01\" } window 800,0\r\n19008.2 \"--sync--\" StartsUsing { id: \"57D2\", source: \"Stygimoloch Lord\" } window 1010,0\r\n19013.2 \"Thunderous Discharge\" Ability { id: \"57D2\", source: \"Stygimoloch Lord\" }\r\n19028.4 \"Rapid Bolts 1\" Ability { id: \"57CD\", source: \"Stygimoloch Lord\" } duration 12.8\r\n19040.5 \"1111-Tonze Swing\" Ability { id: \"57D8\", source: \"Stygimoloch Lord\" }\r\n19051.6 \"Rapid Bolts 2\" Ability { id: \"57CD\", source: \"Stygimoloch Lord\" } duration 12.8\r\n19058.7 \"Rapid Bolts 3\" Ability { id: \"57CD\", source: \"Stygimoloch Lord\" } duration 12.8\r\n19065.8 \"Crushing Hoof\" Ability { id: \"57D5\", source: \"Stygimoloch Lord\" }\r\n19072.0 \"--sync--\" Ability { id: \"57CF\", source: \"Stygimoloch Lord\" }\r\n19072.0 \"Whack 1\" #Ability { id: \"57D1\", source: \"Stygimoloch Lord\" }\r\n19074.0 \"Whack 2\" #Ability { id: \"57D1\", source: \"Stygimoloch Lord\" }\r\n19076.0 \"Whack 3\" #Ability { id: \"57D1\", source: \"Stygimoloch Lord\" }\r\n19092.5 \"Foe Splitter\" Ability { id: \"57D7\", source: \"Stygimoloch Lord\" }\r\n19097.7 \"Vicious Swipe\" Ability { id: \"5552\", source: \"Stygimoloch Lord\" }\r\n19102.8 \"--sync--\" Ability { id: \"57CF\", source: \"Stygimoloch Lord\" }\r\n19102.8 \"Whack 1\" #Ability { id: \"57D1\", source: \"Stygimoloch Lord\" }\r\n19104.8 \"Whack 2\" #Ability { id: \"57D1\", source: \"Stygimoloch Lord\" }\r\n19106.8 \"Whack 3\" #Ability { id: \"57D1\", source: \"Stygimoloch Lord\" }\r\n\r\n# loop block\r\n19121.3 \"Thunderous Discharge\" Ability { id: \"57D2\", source: \"Stygimoloch Lord\" } window 80,80 jump 19013.2\r\n19136.5 \"Rapid Bolts 1\" #Ability { id: \"57CD\", source: \"Stygimoloch Lord\" } duration 12.8\r\n19148.6 \"1111-Tonze Swing\" #Ability { id: \"57D8\", source: \"Stygimoloch Lord\" }\r\n19159.7 \"Rapid Bolts 2\" #Ability { id: \"57CD\", source: \"Stygimoloch Lord\" } duration 12.8\r\n19166.8 \"Rapid Bolts 3\" #Ability { id: \"57CD\", source: \"Stygimoloch Lord\" } duration 12.8\r\n\r\n\r\n### The Queen\r\n# -p 59F9:20015.3\r\n# -ii 5B77 5B22 59ED 53EE 53EF 5A2E 5A04 5A05 5B85 5B84 5A1E 5A01 5A28 5A2A 59F7 5B5B 5B5C 5B73 5B74 5B75 5B76 5B41\r\n# -it \"The Queen\"\r\n# TODO: what is 5BCB? (--middle--?)\r\n# TODO: what is 55A8?\r\n# Queensheart will be sealed off\r\n20000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E23\" } window 20000,0\r\n# .*is no longer sealed\r\n20000.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,2000 jump 0\r\n20010.3 \"--sync--\" StartsUsing { id: \"59F9\", source: \"The Queen\" } window 20,20\r\n20015.3 \"Empyrean Iniquity\" Ability { id: \"59F9\", source: \"The Queen\" }\r\n20025.5 \"--sync--\" Ability { id: \"5BCB\", source: \"The Queen\" }\r\n20033.9 \"Queen's Will\" Ability { id: \"59E6\", source: \"The Queen\" }\r\n20040.0 \"Northswain's Glow\" Ability { id: \"59F3\", source: \"The Queen\" }\r\n20048.2 \"Beck And Call To Arms\" Ability { id: \"5B99\", source: \"The Queen\" }\r\n20050.8 \"Northswain's Glow\" Ability { id: \"59F4\", source: \"The Queen\" }\r\n20052.5 \"The Means\" Ability { id: \"59E8\", source: \"Queen's Warrior\" }\r\n20052.5 \"The Ends\" Ability { id: \"59E7\", source: \"Queen's Knight\" }\r\n20056.3 \"Beck And Call To Arms\" Ability { id: \"5B9A\", source: \"The Queen\" }\r\n20060.6 \"The Means\" Ability { id: \"59EA\", source: \"Queen's Gunner\" }\r\n20060.6 \"The Ends\" Ability { id: \"59E9\", source: \"Queen's Soldier\" }\r\n20076.5 \"Cleansing Slash 1\" Ability { id: \"59F5\", source: \"The Queen\" }\r\n20079.7 \"Cleansing Slash 2\" Ability { id: \"5BB8\", source: \"The Queen\" }\r\n20088.8 \"Empyrean Iniquity\" Ability { id: \"59F9\", source: \"The Queen\" }\r\n20097.0 \"--sync--\" Ability { id: \"5BCB\", source: \"The Queen\" }\r\n20105.2 \"Queen's Edict\" Ability { id: \"59EC\", source: \"The Queen\" }\r\n20108.3 \"--untargetable--\"\r\n20124.7 \"Beck And Call To Arms\" Ability { id: \"5B9B\", source: \"The Queen\" }\r\n20129.0 \"The Means\" Ability { id: \"59E8\", source: \"Queen's Warrior\" }\r\n20129.0 \"The Ends\" Ability { id: \"59E7\", source: \"Queen's Knight\" }\r\n20136.5 \"Beck And Call To Arms\" Ability { id: \"5B9C\", source: \"The Queen\" }\r\n20140.8 \"The Means\" Ability { id: \"59EA\", source: \"Queen's Gunner\" }\r\n20140.8 \"The Ends\" Ability { id: \"59E9\", source: \"Queen's Soldier\" }\r\n\r\n20141.0 \"Queen's Justice\" Ability { id: \"59EB\", source: \"The Queen\" }\r\n20156.0 \"Queen's Justice\" Ability { id: \"59EB\", source: \"The Queen\" }\r\n20157.6 \"Gunnhildr's Blades\" Ability { id: \"5B21\", source: \"The Queen\" }\r\n20160.7 \"--targetable--\"\r\n20167.9 \"--sync--\" Ability { id: \"5BCB\", source: \"The Queen\" }\r\n20171.3 \"--sync--\" Ability { id: \"55A8\", source: \"The Queen\" }\r\n20178.4 \"Gods Save The Queen\" Ability { id: \"59FA\", source: \"The Queen\" }\r\n20194.7 \"--sync--\" Ability { id: \"5BCB\", source: \"The Queen\" }\r\n20198.1 \"--sync--\" Ability { id: \"55A8\", source: \"The Queen\" }\r\n20203.1 \"Unlucky Lot x5\" duration 8 #Ability { id: \"55B6\", source: \"Ball Lightning\" }\r\n20210.0 \"Maelstrom's Bolt\" Ability { id: \"59EF\", source: \"The Queen\" }\r\n\r\n20224.2 \"Relentless Play 1\" Ability { id: \"59FC\", source: \"The Queen\" } window 20,20\r\n20227.3 \"--tethers--\"\r\n20231.3 \"Reversal Of Forces\" Ability { id: \"5A0E\", source: \"Queen's Warrior\" }\r\n20231.3 \"Automatic Turret\" Ability { id: \"5A2B\", source: \"Queen's Gunner\" }\r\n20235.3 \"Northswain's Glow\" Ability { id: \"59F3\", source: \"The Queen\" }\r\n20237.4 \"Reading\" Ability { id: \"5A2C\", source: \"Queen's Gunner\" }\r\n20246.0 \"Northswain's Glow\" Ability { id: \"59F4\", source: \"The Queen\" }\r\n20246.3 \"Winds Of Weight\" Ability { id: \"5A0F\", source: \"Queen's Warrior\" }\r\n20246.3 \"Winds Of Fate\" Ability { id: \"5A11\", source: \"Queen's Warrior\" }\r\n20246.3 \"Weight Of Fortune\" Ability { id: \"5A10\", source: \"Queen's Warrior\" }\r\n20247.5 \"Queen's Shot\" Ability { id: \"5A2D\", source: \"Queen's Gunner\" }\r\n20251.0 \"Turret's Tour\" Ability { id: \"5A2F\", source: \"Automatic Turret\" }\r\n20260.4 \"Cleansing Slash 1\" Ability { id: \"59F5\", source: \"The Queen\" }\r\n20263.6 \"Cleansing Slash 2\" Ability { id: \"5BB8\", source: \"The Queen\" }\r\n\r\n20276.8 \"Relentless Play 2\" Ability { id: \"59FC\", source: \"The Queen\" } window 20,20\r\n20282.9 \"Sword Omen/Shield Omen\" Ability { id: \"59F[DE]\", source: \"Queen's Knight\" }\r\n20287.9 \"--untargetable--\"\r\n20292.5 \"Double Gambit\" Ability { id: \"5A1B\", source: \"Queen's Soldier\" }\r\n20296.3 \"Optimal Offensive\" Ability { id: \"5A0[23]\", source: \"Queen's Knight\" }\r\n20298.2 \"Judgment Blade\" Ability { id: \"59F[12]\", source: \"The Queen\" }\r\n20298.9 \"Unlucky Lot\" Ability { id: \"5A06\", source: \"Aetherial Sphere\" }\r\n20300.7 \"Secrets Revealed\" Ability { id: \"5B8B\", source: \"Queen's Soldier\" }\r\n20300.8 \"--sync--\" Ability { id: \"5B8C\", source: \"Soldier Avatar\" }\r\n20309.9 \"Judgment Blade\" Ability { id: \"59F[12]\", source: \"The Queen\" }\r\n20312.6 \"Pawn Off\" Ability { id: \"5A1D\", source: \"Soldier Avatar\" }\r\n\r\n20314.6 \"--targetable--\"\r\n20324.7 \"Empyrean Iniquity\" Ability { id: \"59F9\", source: \"The Queen\" }\r\n20332.9 \"--sync--\" Ability { id: \"5BCB\", source: \"The Queen\" }\r\n20341.3 \"Queen's Edict\" Ability { id: \"59EC\", source: \"The Queen\" }\r\n20344.4 \"--untargetable--\"\r\n20360.8 \"Beck And Call To Arms\" Ability { id: \"5B9B\", source: \"The Queen\" }\r\n20365.1 \"The Means\" Ability { id: \"59E8\", source: \"Queen's Warrior\" }\r\n20365.1 \"The Ends\" Ability { id: \"59E7\", source: \"Queen's Knight\" }\r\n20372.6 \"Beck And Call To Arms\" Ability { id: \"5B9C\", source: \"The Queen\" }\r\n20376.9 \"The Means\" Ability { id: \"59EA\", source: \"Queen's Gunner\" }\r\n20376.9 \"The Ends\" Ability { id: \"59E9\", source: \"Queen's Soldier\" }\r\n20377.1 \"Queen's Justice\" Ability { id: \"59EB\", source: \"The Queen\" }\r\n20392.1 \"Queen's Justice\" Ability { id: \"59EB\", source: \"The Queen\" }\r\n20393.8 \"Gunnhildr's Blades\" Ability { id: \"5B21\", source: \"The Queen\" }\r\n20396.9 \"--targetable--\"\r\n20404.1 \"Cleansing Slash 1\" Ability { id: \"59F5\", source: \"The Queen\" }\r\n20407.3 \"Cleansing Slash 2\" Ability { id: \"5BB8\", source: \"The Queen\" }\r\n\r\n20422.5 \"Relentless Play 3\" Ability { id: \"59FC\", source: \"The Queen\" } window 20,20\r\n20428.6 \"Sword Omen/Shield Omen\" Ability { id: \"59F[DE]\", source: \"Queen's Knight\" }\r\n20437.9 \"Automatic Turret\" Ability { id: \"5A26\", source: \"Queen's Gunner\" }\r\n20440.0 \"Optimal Play\" Ability { id: [\"5A00\", \"59FF\"], source: \"Queen's Knight\" }\r\n20446.0 \"Turret's Tour\" Ability { id: \"5A27\", source: \"Queen's Gunner\" }\r\n20446.6 \"--sync--\" Ability { id: \"5BCB\", source: \"The Queen\" }\r\n20446.6 \"Turret's Tour\" #Ability { id: \"5A29\", source: \"Automatic Turret\" }\r\n20447.6 \"Turret's Tour\" #Ability { id: \"5A29\", source: \"Automatic Turret\" }\r\n20449.9 \"--sync--\" Ability { id: \"55A8\", source: \"The Queen\" }\r\n20454.9 \"Unlucky Lot x5\" duration 8 #Ability { id: \"55B6\", source: \"Ball Lightning\" }\r\n20461.8 \"Maelstrom's Bolt\" Ability { id: \"59EF\", source: \"The Queen\" }\r\n20474.9 \"Empyrean Iniquity\" Ability { id: \"59F9\", source: \"The Queen\" }\r\n\r\n20488.1 \"Relentless Play 4\" Ability { id: \"59FC\", source: \"The Queen\" } window 20,20\r\n20494.2 \"Bombslinger\" Ability { id: \"5B3F\", source: \"Queen's Warrior\" }\r\n20497.3 \"--tethers--\"\r\n20501.3 \"Reversal Of Forces\" Ability { id: \"5A0E\", source: \"Queen's Warrior\" }\r\n20503.2 \"Heaven's Wrath\" Ability { id: \"59F6\", source: \"The Queen\" }\r\n20509.0 \"--knockback--\" Ability { id: \"59F8\", source: \"The Queen\" }\r\n20511.3 \"--untargetable--\"\r\n20512.2 \"Icy Portent/Fiery Portent\" Ability { id: \"5A2[12]\", source: \"Queen's Soldier\" }\r\n20515.5 \"Above Board\" Ability { id: \"5A0B\", source: \"Queen's Warrior\" }\r\n20515.5 \"--sync--\" Ability { id: \"5B8E\", source: \"Queen's Warrior\" }\r\n20516.5 \"--stunned--\" # 3 or 7 second stun\r\n# Aetherial Burst does 5B89 and Aetherial Bolt does 5A0D\r\n20518.5 \"Lots Cast\" Ability { id: [\"5B89\", \"5A0D\"], source: [\"Aetherial Burst\", \"Aetherial Bolt\"] }\r\n20521.5 \"Lots Cast\" #Ability { id: \"5B88\", source: \"Aetherial Bolt\" }\r\n20522.7 \"Lots Cast\" #Ability { id: \"5BB6\", source: \"Aetherial Bolt\" }\r\n20523.5 \"--unstunned--\"\r\n20525.6 \"--targetable--\"\r\n\r\n20530.7 \"Relentless Play 5\" Ability { id: \"59FC\", source: \"The Queen\" }\r\n20538.8 \"Blood And Bone\" Ability { id: \"5A08\", source: \"Queen's Knight\" }\r\n20538.8 \"Blood And Bone\" Ability { id: \"5A16\", source: \"Queen's Warrior\" }\r\n20541.8 \"Queen's Shot\" Ability { id: \"5A35\", source: \"Queen's Gunner\" }\r\n20541.8 \"Blood And Bone\" Ability { id: \"5A23\", source: \"Queen's Soldier\" }\r\n20546.9 \"Blood And Bone\" Ability { id: \"5A08\", source: \"Queen's Knight\" }\r\n20546.9 \"Blood And Bone\" Ability { id: \"5A16\", source: \"Queen's Warrior\" }\r\n20549.9 \"Queen's Shot\" Ability { id: \"5A35\", source: \"Queen's Gunner\" }\r\n20549.9 \"Blood And Bone\" Ability { id: \"5A23\", source: \"Queen's Soldier\" }\r\n20552.7 \"Empyrean Iniquity\" Ability { id: \"59F9\", source: \"The Queen\" }\r\n20558.9 \"Blood And Bone\" Ability { id: \"5A08\", source: \"Queen's Knight\" }\r\n20561.9 \"Blood And Bone\" Ability { id: \"5A16\", source: \"Queen's Warrior\" }\r\n20565.0 \"Blood And Bone\" Ability { id: \"5A23\", source: \"Queen's Soldier\" }\r\n20567.9 \"Queen's Shot\" Ability { id: \"5A35\", source: \"Queen's Gunner\" }\r\n20574.6 \"--sync--\" Ability { id: \"55A8\", source: \"The Queen\" }\r\n20586.7 \"Gods Save The Queen Enrage\" Ability { id: \"5B5A\", source: \"The Queen\" }\r\n20586.7 \"--untargetable--\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/eureka/zadnor.ts




// CE explainer: https://www.youtube.com/watch?v=L4lXAV_OD-0

// TODO: snake: everything
// TODO: blade: everything
// TODO: lyon: everything
// TODO: blood: Flight of the Malefic cleaves
// TODO: blood: gaze vs line attack from adds
// TODO: wolf: 6x Imaginifers cast thermal gust hitting east/west (only seen east at -828...-808)
// TODO: cavalry: early call for knockback direction?
// TODO: calalry: is Ride Down explainable??
// TODO: time: is it possible to find where slow clocks are?
// TODO: machines: can describe initial safe quadrant from first charges?
// TODO: machines: can describe "diagonal line bomb" safe spot
// TODO: machines: can determine rotating corner to go to
// TODO: alkonost: foreshadowing (both in CE and Dalraida)
// TODO: alkonost: :Tamed Alkonost:5F26:Stormcall: can be knockback to/away fast/slow orbs
// TODO: hallway: left/right lasers (check getCombatants???)
// TODO: saunion: are the mobile halo / crossray abilities corresponding to directions?
// TODO: diablo: diabolic gate directional callouts???
// TODO: diablo: improve timing on acceleration bomb

// List of events:
// https://github.com/xivapi/ffxiv-datamining/blob/master/csv/DynamicEvent.csv
//
// These ids are (unfortunately) gathered by hand and don't seem to correlate
// to any particular bits of data.  However, there's a game log message when you
// register for a CE and an 0x21 message with this id when you accept and
// teleport in.  This avoids having to translate all of these names and also
// guarantees that the player is actually in the CE for the purpose of
// filtering triggers.
const zadnor_ceIds = {
  // On Serpents' Wings
  serpents: '211',
  // Feeling the Burn
  feeling: '20E',
  // The Broken Blade
  blade: '21F',
  // From Beyond the Grave
  grave: '21B',
  // With Diremite and Main
  diremite: '221',
  // Here Comes the Cavalry
  cavalry: '21C',
  // Head of the Snake
  snake: '21E',
  // There Would Be Blood
  blood: '210',
  // Never Cry Wolf
  wolf: '20F',
  // Time To Burn
  time: '21D',
  // Lean, Mean, Magitek Machines
  machines: '218',
  // Worn to a Shadow
  shadow: '222',
  // A Familiar Face
  face: '212',
  // Looks to Die For
  looks: '207',
  // Taking the Lyon's Share
  lyon: '220',
  // The Dalriada
  dalriada: '213',
  dalriadaCuchulainn: '214',
  dalriadaHallway: '215',
  dalriadaSaunion: '216',
  dalriadaDiablo: '217'
};
const limitCutHeadmarkers = ['004F', '0050', '0051', '0052'];

// TODO: promote something like this to Conditions?
const zadnor_tankBusterOnParty = ceName => (data, matches) => {
  if (ceName !== undefined && data.ce !== ceName) return false;
  if (matches.target === data.me) return true;
  if (data.role !== 'healer') return false;
  return data.party.inParty(matches.target);
};
const zadnor_triggerSet = {
  id: 'Zadnor',
  zoneId: zone_id/* default.Zadnor */.Z.Zadnor,
  timelineFile: 'zadnor.txt',
  resetWhenOutOfCombat: false,
  triggers: [
  // https://xivapi.com/LogMessage/916
  // en: 7 minutes have elapsed since your last activity. [...]
  // There is no network packet for these log lines; so have to use GameLog.
  {
    id: 'Zadnor Falling Asleep',
    type: 'GameLog',
    netRegex: {
      line: '7 minutes have elapsed since your last activity..*?',
      capture: false
    },
    response: responses/* Responses.wakeUp */.n3.wakeUp()
  }, {
    id: 'Zadnor Critical Engagement',
    type: 'ActorControl',
    netRegex: {
      command: '80000014'
    },
    run: (data, matches) => {
      // This fires when you win, lose, or teleport out.
      if (matches.data0 === '00') {
        if (data.ce !== undefined && data.options.Debug) console.log(`Stop CE: ${data.ce}`);
        // Stop any active timelines.
        data.StopCombat();
        // Prevent further triggers for any active CEs from firing.
        delete data.ce;
        return;
      }
      delete data.ce;
      const ceId = matches.data0.toUpperCase();
      const anonCEs = zadnor_ceIds;
      for (const key in anonCEs) {
        if (anonCEs[key] === ceId) {
          if (data.options.Debug) console.log(`Start CE: ${key} (${ceId})`);
          data.ce = key;
          return;
        }
      }
      if (data.options.Debug) console.log(`Start CE: ??? (${ceId})`);
    }
  },
  // ***** On Serpents' Wings *****
  {
    id: 'Zadnor Serpents Turbine',
    type: 'StartsUsing',
    netRegex: {
      source: 'Stormborne Zirnitra',
      id: '5E54'
    },
    condition: data => data.ce === 'serpents',
    preRun: data => data.serpentsTurbineCount = (data.serpentsTurbineCount ?? 0) + 1,
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    alertText: (data, _matches, output) => {
      // TODO: how does this loop?
      if (data.serpentsTurbineCount === 1) return output.knockbackDonut();else if (data.serpentsTurbineCount === 2) return output.knockbackIntoCircle();else if (data.serpentsTurbineCount === 3) return output.knockbackExplosion();else if (data.serpentsTurbineCount === 4) return output.knockbackDonut();else if (data.serpentsTurbineCount === 5) return output.knockbackIntoSafe();
    },
    outputStrings: {
      knockbackDonut: {
        en: 'Knockback + Stack Donuts Middle',
        de: 'Rückstoß + Donuts mittig sammeln',
        fr: 'Poussée + Packez les donuts au milieu',
        cn: '击退 + 月环集合击退',
        ko: '넉백 + 도넛장판 피하기'
      },
      knockbackIntoCircle: {
        en: 'Knockback (towards first circles)',
        de: 'Rückstoß (zu den ersten Kreisen)',
        fr: 'Poussée (vers les premiers cercles)',
        cn: '向第一个圈圈击退',
        ko: '먼저 뜬 장판으로 넉백'
      },
      knockbackIntoSafe: {
        en: 'Knockback (towards open spots)',
        de: 'Rückstoß (zum offenen Bereich)',
        fr: 'Poussée (vers des endroits ouverts)',
        cn: '向空缺位置击退',
        ko: '안전지대로 넉백'
      },
      knockbackExplosion: {
        // Can't trust people to make a safe spot,
        // so using knockback prevention is probably the best advice.
        en: 'Knockback (prevent)',
        de: 'Rückstoß (verhindern)',
        fr: 'Poussée (empêchez-là)',
        cn: '防击退',
        ko: '넉백 (거리유지 추천)'
      }
    }
  },
  // ***** Feeling the Burn *****
  {
    id: 'Zadnor Feeling Suppressive Magitek Rays',
    type: 'StartsUsing',
    netRegex: {
      source: 'Blackburn',
      id: '5C40',
      capture: false
    },
    condition: data => data.ce === 'feeling',
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Feeling Chain Cannon You',
    type: 'HeadMarker',
    netRegex: {
      id: '00A4'
    },
    condition: (data, matches) => data.ce === 'feeling' && data.me === matches.target,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Chain Cannon on YOU',
        de: 'Kettenkanone auf DIR',
        fr: 'Canon en chaine sur VOUS',
        cn: '直线点名',
        ko: '기관총 대상자'
      }
    }
  }, {
    id: 'Zadnor Feeling Chain Cannon Not You',
    type: 'HeadMarker',
    netRegex: {
      id: '00A4',
      capture: false
    },
    condition: data => data.ce === 'feeling',
    delaySeconds: 3,
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stay Out of Lasers',
        de: 'Aus den Lasern gehen',
        fr: 'Restez à l\'écart des lasers',
        cn: '避开直线点名',
        ko: '레이저 피하기'
      }
    }
  }, {
    id: 'Zadnor Feeling Analysis',
    type: 'StartsUsing',
    netRegex: {
      source: 'Blackburn',
      id: '5C37',
      capture: false
    },
    condition: data => data.ce === 'feeling',
    run: data => data.feelingAnalysis = true
  }, {
    id: 'Zadnor Feeling Read Orders Coordinated Assault',
    type: 'StartsUsing',
    netRegex: {
      source: 'Blackburn',
      id: '5C34',
      capture: false
    },
    condition: data => data.ce === 'feeling',
    alertText: (data, _matches, output) => {
      return data.feelingAnalysis ? output.point() : output.dodge();
    },
    run: data => delete data.feelingAnalysis,
    outputStrings: {
      dodge: {
        en: 'Dodge 4 Charges',
        de: 'Weiche 4 Anstürmen aus',
        fr: 'Esquivez les 4 charges',
        cn: '躲避4次冲锋',
        ko: '4연속 돌진 뒤돌아서 맞기'
      },
      point: {
        en: 'Point at 4 Charges',
        de: 'Zeige auf dir 4 Anstürmen',
        fr: 'Pointez à 4 charges',
        cn: '瞄准4次冲锋',
        ko: '4연속 돌진 쳐다보며 맞기'
      }
    }
  },
  // ***** The Broken Blade *****
  // ***** From Beyond the Grave *****
  {
    id: 'Zadnor Grave Soul Purge',
    type: 'StartsUsing',
    // 5E23 = get out first
    // 5E25 = get in first
    netRegex: {
      source: '4th-Make Shemhazai',
      id: ['5E23', '5E25']
    },
    condition: data => data.ce === 'grave',
    suppressSeconds: 10,
    alertText: (_data, matches, output) => {
      return matches.id === '5E23' ? output.outThenIn() : output.inThenOut();
    },
    outputStrings: {
      outThenIn: outputs/* default.outThenIn */.Z.outThenIn,
      inThenOut: outputs/* default.inThenOut */.Z.inThenOut
    }
  }, {
    id: 'Zadnor Grave Soul Purge Second',
    type: 'StartsUsing',
    // 5E23 = get out first (so get in second)
    // 5E25 = get in first (so get out second)
    netRegex: {
      source: '4th-Make Shemhazai',
      id: ['5E23', '5E25']
    },
    condition: data => data.ce === 'grave',
    delaySeconds: 5,
    suppressSeconds: 10,
    alertText: (_data, matches, output) => {
      return matches.id === '5E23' ? output.in() : output.out();
    },
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      in: outputs/* default.in */.Z["in"]
    }
  }, {
    id: 'Zadnor Grave Devour Soul',
    type: 'StartsUsing',
    netRegex: {
      source: '4th-Make Shemhazai',
      id: '5E20'
    },
    condition: zadnor_tankBusterOnParty('grave'),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zadnor Grave Blight',
    type: 'StartsUsing',
    netRegex: {
      source: '4th-Make Shemhazai',
      id: '5E1E',
      capture: false
    },
    condition: data => data.ce === 'grave',
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Grave Crimson Blade',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '9934',
      capture: false
    },
    condition: data => data.ce === 'grave',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Behind Hernais',
        de: 'Geh hinter Hernais',
        fr: 'Passez derrière Hernais',
        cn: '去腐犬背后',
        ko: '에르네이스 뒤로'
      }
    }
  }, {
    id: 'Zadnor Grave War Wraith',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '9933',
      capture: false
    },
    condition: data => data.ce === 'grave',
    // They hang out on the outside for a bit and then become targetable.
    delaySeconds: 11.5,
    suppressSeconds: 10,
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'Zadnor Grave Aethertide',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dyunbu The Accursed',
      id: '5E2A'
    },
    condition: (data, matches) => data.ce === 'grave' && data.me === matches.target,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Zadnor Grave Forced March',
    type: 'GainsEffect',
    // 871 = Forward March
    // 872 = About Face
    // 873 = Left Face
    // 874 = Right Face
    netRegex: {
      source: '4th-Make Shemhazai',
      effectId: ['871', '872', '873', '874']
    },
    condition: (data, matches) => data.ce === 'grave' && data.me === matches.target,
    alertText: (_data, matches, output) => {
      const effectId = matches.effectId.toUpperCase();
      if (effectId === '871') return output.forward();
      if (effectId === '872') return output.backward();
      if (effectId === '873') return output.left();
      if (effectId === '874') return output.right();
    },
    outputStrings: {
      forward: {
        en: 'March Forward Into Middle',
        de: 'Marchiere Vorwärts in die Mitte',
        fr: 'Marche en avant vers le milieu',
        cn: '强制移动: 前，去中间',
        ko: '정신장악: 앞, 가운데로'
      },
      backward: {
        en: 'March Backward Into Middle',
        de: 'Marchiere Rückwärts in die Mitte',
        fr: 'Marche en arrière vers le milieu',
        cn: '强制移动: 后，去中间',
        ko: '정신장악: 뒤, 가운데로'
      },
      left: {
        en: 'March Left Into Middle',
        de: 'Marchiere Links in die Mitte',
        fr: 'Marche à gauche vers le milieu',
        cn: '强制移动: 左，去中间',
        ko: '정신장악: 왼쪽, 가운데로'
      },
      right: {
        en: 'March Right Into Middle',
        de: 'Marchiere Rechts in die Mitte',
        fr: 'Marche à droite vers le milieu',
        cn: '强制移动: 右，去中间',
        ko: '정신장악: 오른쪽, 가운데로'
      }
    }
  },
  // ***** With Diremite and Main *****
  {
    id: 'Zadnor Diremite Crystal Needle',
    type: 'StartsUsing',
    netRegex: {
      source: 'Hedetet',
      id: '5E15'
    },
    condition: zadnor_tankBusterOnParty('diremite'),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zadnor Diremite Shardstrike',
    type: 'StartsUsing',
    netRegex: {
      source: 'Hedetet',
      id: '5E17'
    },
    condition: (data, matches) => data.ce === 'diremite' && data.me === matches.target,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Zadnor Diremite Hailfire You',
    type: 'HeadMarker',
    netRegex: {
      id: limitCutHeadmarkers
    },
    condition: (data, matches) => data.ce === 'diremite' && data.me === matches.target,
    preRun: (data, matches) => {
      data.diremiteHailfire ??= [];
      data.diremiteHailfire.push(matches.target);
    },
    alertText: (_data, matches, output) => {
      const id = matches.id;
      const num = limitCutHeadmarkers.indexOf(id) + 1;
      if (num < 1) return;
      const numStr = output[`num${num}`]();
      return output.text({
        num: numStr
      });
    },
    outputStrings: {
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      text: {
        en: '${num} (spread for laser)',
        de: '${num} (verteile für Laser)',
        fr: '${num} (dispersion pour le laser)',
        cn: '${num} (激光分散)',
        ko: '${num} (레이저 대비 산개)'
      }
    }
  }, {
    id: 'Zadnor Diremite Hailfire Not You',
    type: 'HeadMarker',
    netRegex: {
      id: limitCutHeadmarkers,
      capture: false
    },
    condition: data => data.ce === 'diremite',
    delaySeconds: 0.5,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      if (data.diremiteHailfire && !data.diremiteHailfire.includes(data.me)) return output.text();
    },
    run: data => delete data.diremiteHailfire,
    outputStrings: {
      text: {
        en: 'Avoid Lasers',
        de: 'Laser ausweichen',
        fr: 'Évitez les lasers',
        ja: 'レーザーを避ける',
        cn: '躲避激光',
        ko: '레이저 피하기'
      }
    }
  }, {
    id: 'Zadnor Diremite Crystaline Stingers',
    type: 'StartsUsing',
    netRegex: {
      source: 'Hedetet',
      id: '5E0D',
      capture: false
    },
    condition: data => data.ce === 'diremite',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Silver Shard',
        de: 'Hinter Silber-Splitter verstecken',
        fr: 'Cachez-vous derrière l\'éclat argenté',
        cn: '躲在银色碎片后',
        ko: '흰색 기둥 뒤로'
      }
    }
  }, {
    id: 'Zadnor Diremite Aetherial Stingers',
    type: 'StartsUsing',
    netRegex: {
      source: 'Hedetet',
      id: '5E0E',
      capture: false
    },
    condition: data => data.ce === 'diremite',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Gold Shard',
        de: 'Hinter Gold-Splitter verstecken',
        fr: 'Cachez-vous derrière l\'éclat doré',
        cn: '躲在金色碎片后',
        ko: '노란 기둥 뒤로'
      }
    }
  }, {
    id: 'Zadnor Diremite Sand Sphere',
    type: 'StartsUsing',
    netRegex: {
      source: 'Hedetet',
      id: '5E0F',
      capture: false
    },
    condition: data => data.ce === 'diremite',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Orbs',
        de: 'Weg von den Orbs',
        fr: 'Éloignez-vous des orbes',
        cn: '远离球球',
        ko: '구체 피하기'
      }
    }
  },
  // ***** Here Comes the Cavalry *****
  {
    id: 'Zadnor Cavalry Gust Slash',
    type: 'StartsUsing',
    netRegex: {
      source: 'Clibanarius',
      id: '5D7D'
    },
    condition: data => data.ce === 'cavalry',
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Zadnor Cavalry Raw Steel',
    type: 'StartsUsing',
    netRegex: {
      source: 'Clibanarius',
      id: '5D87'
    },
    condition: data => data.ce === 'cavalry',
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        avoidCharge: {
          en: 'Avoid Charge',
          de: 'ausweichen',
          fr: 'Évitez les charges',
          ja: '突進避けて',
          cn: '躲避冲锋',
          ko: '돌진 피하기'
        },
        runAway: {
          en: 'Run Away From Boss',
          de: 'Renn weg vom Boss',
          fr: 'Courez loin du boss',
          ja: 'ボスから離れる',
          cn: '远离Boss',
          ko: '보스와 거리 벌리기'
        }
      };
      if (matches.target === data.me) return {
        alertText: output.runAway()
      };
      return {
        infoText: output.avoidCharge()
      };
    }
  }, {
    id: 'Zadnor Cavalry Call Raze',
    type: 'StartsUsing',
    netRegex: {
      source: 'Clibanarius',
      id: '5D8C',
      capture: false
    },
    condition: data => data.ce === 'cavalry',
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Cavalry Magitek Blaster',
    type: 'StartsUsing',
    netRegex: {
      source: 'Clibanarius',
      id: '5D90'
    },
    condition: data => data.ce === 'cavalry',
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  },
  // ***** Head of the Snake *****
  // ***** There Would Be Blood *****
  {
    id: 'Zadnor Blood Cloud Of Locusts',
    type: 'StartsUsing',
    netRegex: {
      source: 'Hanbi',
      id: '5C10',
      capture: false
    },
    condition: data => data.ce === 'blood',
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Zadnor Blood Plague Of Locusts',
    type: 'StartsUsing',
    netRegex: {
      source: 'Hanbi',
      id: '5C11',
      capture: false
    },
    condition: data => data.ce === 'blood',
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Zadnor Blood Dread Wind',
    type: 'StartsUsing',
    netRegex: {
      source: 'Hanbi',
      id: '5BAE',
      capture: false
    },
    condition: data => data.ce === 'blood',
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Blood Gale Cannon',
    type: 'StartsUsing',
    netRegex: {
      source: 'Hanbi',
      id: '53E3',
      capture: false
    },
    condition: data => data.ce === 'blood',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // TODO: should this be a response/output?
        en: 'Out of Front',
        de: 'Weg von Vorne',
        fr: 'À l\'extérieur du devant',
        cn: '避开正面',
        ko: '정면 피하기'
      }
    }
  }, {
    id: 'Zadnor Blood Camisado',
    type: 'StartsUsing',
    netRegex: {
      source: 'Hanbi',
      id: '5BAE'
    },
    condition: zadnor_tankBusterOnParty('blood'),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  },
  // ***** Never Cry Wolf *****
  {
    id: 'Zadnor Wolf Glaciation',
    type: 'StartsUsing',
    netRegex: {
      source: 'Hrodvitnir',
      id: '5C32',
      capture: false
    },
    condition: data => data.ce === 'wolf',
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Wolf Storm Without',
    type: 'StartsUsing',
    netRegex: {
      source: 'Hrodvitnir',
      id: '5C2A',
      capture: false
    },
    condition: data => data.ce === 'wolf',
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Zadnor Wolf Storm Within',
    type: 'StartsUsing',
    netRegex: {
      source: 'Hrodvitnir',
      id: '5C2C',
      capture: false
    },
    condition: data => data.ce === 'wolf',
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Zadnor Wolf Bracing Wind',
    type: 'StartsUsing',
    netRegex: {
      source: 'Ice Sprite',
      id: '5C22'
    },
    condition: data => data.ce === 'wolf',
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback (behind pillar)',
        de: 'Rückstoß (hinter dem Eissplitter)',
        fr: 'Poussée (derrière le pilier)',
        cn: '击退到柱子后',
        ko: '기둥 뒤로 넉백'
      }
    }
  }, {
    id: 'Zadnor Wolf Lunar Cry',
    type: 'StartsUsing',
    netRegex: {
      source: 'Hrodvitnir',
      id: '5C24',
      capture: false
    },
    condition: data => data.ce === 'wolf',
    // Call this out after Bracing Wind.
    delaySeconds: 9,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Pillar',
        de: 'Hinter dem Eissplitter verstecken',
        fr: 'Cachez-vous derrière le pilier',
        cn: '躲在柱子后',
        ko: '기둥 뒤에 숨기'
      }
    }
  },
  // ***** Time To Burn *****
  {
    id: 'Zadnor Time Fire IV',
    type: 'StartsUsing',
    netRegex: {
      source: '4th-Make Belias',
      id: '5D9A'
    },
    condition: data => data.ce === 'time',
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zadnor Time Fire',
    type: 'StartsUsing',
    netRegex: {
      source: '4th-Make Belias',
      id: '5D99'
    },
    condition: zadnor_tankBusterOnParty('time'),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zadnor Time Reproduce',
    type: 'StartsUsing',
    netRegex: {
      source: '4th-Make Belias',
      id: '60E9',
      capture: false
    },
    condition: data => data.ce === 'time',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Dashes',
        de: 'Sprint ausweichen',
        fr: 'Évitez les ruées',
        ja: 'ブレードを避ける',
        cn: '躲开冲锋',
        ko: '돌진 피하기'
      }
    }
  }, {
    id: 'Zadnor Time Time Bomb',
    type: 'StartsUsing',
    netRegex: {
      source: '4th-Make Belias',
      id: '5D95',
      capture: false
    },
    condition: data => data.ce === 'time',
    infoText: (data, _matches, output) => {
      data.timeBombCount = (data.timeBombCount ?? 0) + 1;
      // Belias alternates 2 and 3 Time Bombs, starting with 2.
      return data.timeBombCount % 2 ? output.twoClocks() : output.threeClocks();
    },
    outputStrings: {
      twoClocks: {
        en: 'Go Perpendicular To Clock Hands',
        de: 'Geh Senkrecht von den Uhrzeigern',
        fr: 'Aller perpendiculairement aux aiguilles de l\'horloge',
        cn: '垂直于时钟指针移动',
        ko: '시계바늘의 수직 방향으로 이동'
      },
      threeClocks: {
        // This is...not the best instruction.  The real instruction is "if all clock hands are
        // parallel then go perpendicular, HOWEVER if exactly one clock hand is perpendicular
        // to the other two, then go where it points", which is several novels too long for
        // trigger text.  However, given that we explain two clocks, it feels wrong to not
        // have a trigger for three clocks.  "Mechanics Are Happening <se.6>"
        en: 'Dodge Three Clocks',
        de: 'Weiche den 3 Uhren aus',
        fr: 'Esquivez 3 horloges',
        cn: '躲避3个时钟',
        ko: '시계 3개 피하기'
      }
    }
  },
  // ***** Lean, Mean, Magitek Machines *****
  {
    id: 'Zadnor Machines Magnetic Field',
    type: 'StartsUsing',
    netRegex: {
      source: 'Kampe',
      id: '5CFE',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Machines Fore-Hind Cannons',
    type: 'StartsUsing',
    netRegex: {
      source: 'Kampe',
      id: '5CFF',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  },
  // ***** Worn to a Shadow *****
  {
    id: 'Zadnor Shadow Bladed Beak',
    type: 'StartsUsing',
    // Not a cleave.
    netRegex: {
      source: 'Alkonost',
      id: '5E3B'
    },
    condition: zadnor_tankBusterOnParty('shadow'),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zadnor Shadow Nihility\'s Song',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alkonost',
      id: '5E3C',
      capture: false
    },
    condition: data => data.ce === 'shadow',
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Shadow Stormcall',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alkonost',
      id: '5E39',
      capture: false
    },
    condition: data => data.ce === 'shadow',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Follow Slow Orb',
        de: 'Folge dem langsamen Orb',
        fr: 'Suivez l\'orbe lente',
        cn: '跟随慢速球',
        ko: '느린 구체 따라가기'
      }
    }
  }, {
    id: 'Zadnor Shadow Stormcall Away',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alkonost',
      id: '5E39',
      capture: false
    },
    condition: data => data.ce === 'shadow',
    delaySeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Orb',
        de: 'Weg vom Orb',
        fr: 'Éloignez-vous de l\'orbe',
        cn: '远离球球',
        ko: '구체 피하기'
      }
    }
  },
  // ***** A Familiar Face *****
  {
    id: 'Zadnor Face Ancient Quake IV',
    type: 'StartsUsing',
    netRegex: {
      source: '4th-Make Hashmal',
      id: '5D14',
      capture: false
    },
    condition: data => data.ce === 'face',
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Face Rock Cutter',
    type: 'StartsUsing',
    netRegex: {
      source: '4th-Make Hashmal',
      id: '5D13'
    },
    condition: zadnor_tankBusterOnParty('face'),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zadnor Face Extreme Edge Left',
    type: 'StartsUsing',
    netRegex: {
      source: 'Phantom Hashmal',
      id: '5D0E',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Find Phantom; Dodge Left',
        de: 'Finde das Abbild; weiche Links aus',
        fr: 'Trouvez le Double : Esquivez à gauche',
        cn: '寻找幻影; 向左躲避',
        ko: '분신 찾고, 왼쪽으로 피하기'
      }
    }
  }, {
    id: 'Zadnor Face Extreme Edge Right',
    type: 'StartsUsing',
    netRegex: {
      source: 'Phantom Hashmal',
      id: '5D0D',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Find Phantom; Dodge Right',
        de: 'Finde das Abbild; weiche Rechts aus',
        fr: 'Trouvez le Double : Esquivez à droite',
        cn: '寻找幻影; 向右躲避',
        ko: '분신 찾고, 오른쪽으로 피하기'
      }
    }
  }, {
    id: 'Zadnor Face Hammer Round',
    type: 'Ability',
    netRegex: {
      source: '4th-Make Hashmal',
      id: '5D10',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Hammer; Rotate Outside',
        de: 'Weg vom Hammer; nach Außen rotieren',
        fr: 'Éloignez-vous du marteau; Tournez à l\'extérieur',
        cn: '远离锤子; 向外旋转',
        ko: '기둥에서 멀리 떨어지고, 바깥쪽 계속 돌기'
      }
    }
  },
  // ***** Looks to Die For *****
  {
    id: 'Zadnor Looks Forelash',
    type: 'StartsUsing',
    netRegex: {
      source: 'Ayida',
      id: '5DA9',
      capture: false
    },
    condition: data => data.ce === 'looks',
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Zadnor Looks Backlash',
    type: 'StartsUsing',
    netRegex: {
      source: 'Ayida',
      id: '5DAA',
      capture: false
    },
    condition: data => data.ce === 'looks',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // TODO: should this be a response/output?
        en: 'Get In Front',
        de: 'Geh vor den Boss',
        fr: 'Passez devant',
        ja: 'ボスの正面へ',
        cn: '去Boss正面',
        ko: '정면에 서기'
      }
    }
  }, {
    id: 'Zadnor Looks Twisting Winds',
    type: 'StartsUsing',
    netRegex: {
      source: 'Ayida',
      id: '5DA2',
      capture: false
    },
    condition: data => data.ce === 'looks',
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'Zadnor Looks Roar',
    type: 'StartsUsing',
    netRegex: {
      source: 'Ayida',
      id: '5DAD',
      capture: false
    },
    condition: data => data.ce === 'looks',
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Looks Serpent\'s Edge',
    type: 'StartsUsing',
    netRegex: {
      source: 'Ayida',
      id: '5DB1'
    },
    condition: zadnor_tankBusterOnParty('looks'),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zadnor Looks Levinbolt',
    type: 'StartsUsing',
    netRegex: {
      source: 'Ayida',
      id: '5DB0'
    },
    condition: (data, matches) => data.ce === 'looks' && data.me === matches.target,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Zadnor Looks Thundercall',
    type: 'StartsUsing',
    netRegex: {
      source: 'Ayida',
      id: '5D9C',
      capture: false
    },
    condition: data => data.ce === 'looks',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Orbs -> Under Orbs',
        de: 'Weiche Orbs aus -> Unter die Orbs',
        fr: 'Évitez les orbes -> En dessous les orbes',
        cn: '避开球 -> 去球下',
        ko: '구체 피하기 -> 구체 밑으로'
      }
    }
  }, {
    id: 'Zadnor Looks Flame',
    type: 'StartsUsing',
    netRegex: {
      source: 'Ayida',
      id: '5DA6',
      capture: false
    },
    condition: data => data.ce === 'looks',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // TODO: this is also an aoe, and this is a pretty poor description.
        en: 'Go to small orb',
        de: 'Geh zum kleinen Orb',
        fr: 'Allez à la petite orbe',
        cn: '去小球',
        ko: '작은 구체쪽으로'
      }
    }
  },
  // ***** Taking the Lyon's Share *****
  // ***** The Dalriada *****
  {
    id: 'Zadnor Sartauvoir Pyrokinesis',
    type: 'StartsUsing',
    netRegex: {
      source: 'Sartauvoir The Inferno',
      id: '5E7D',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Sartauvoir Time Eruption',
    type: 'StartsUsing',
    netRegex: {
      source: 'Sartauvoir The Inferno',
      id: ['5E6C', '5E83'],
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to Slow Clocks',
        de: 'Geh zu den langsamen Uhren',
        fr: 'Allez sur les horloges lentes',
        cn: '去慢时钟',
        ko: '느린 시계로'
      }
    }
  }, {
    id: 'Zadnor Sartauvoir Reverse Time Eruption',
    type: 'StartsUsing',
    netRegex: {
      source: 'Sartauvoir The Inferno',
      id: ['5E6D', '5E84'],
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to Fast Clocks',
        de: 'Geh zu den schnellen Uhren',
        fr: 'Allez sur les horloges rapides',
        cn: '去快时钟',
        ko: '빠른 시계로'
      }
    }
  }, {
    id: 'Zadnor Sartauvoir Phenex',
    type: 'StartsUsing',
    netRegex: {
      source: 'Sartauvoir The Inferno',
      id: ['5E72', '5E85'],
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bird Dashes',
        de: 'Vogel-Anstürme',
        fr: 'Plongeons des oiseaux',
        cn: '躲避红鸟',
        ko: '붉은새 피하기'
      }
    }
  }, {
    id: 'Zadnor Sartauvoir Hyperpyroplexy',
    type: 'Ability',
    netRegex: {
      source: 'Sartauvoir The Inferno',
      id: '5E76',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 하나씩 들어가기'
      }
    }
  }, {
    id: 'Zadnor Sartauvoir Burning Blade',
    type: 'StartsUsing',
    netRegex: {
      source: 'Sartauvoir The Inferno',
      id: '5E90'
    },
    condition: zadnor_tankBusterOnParty(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zadnor Sartauvoir Pyrocrisis',
    type: 'StartsUsing',
    netRegex: {
      source: 'Sartauvoir The Inferno',
      id: '5E8F'
    },
    preRun: (data, matches) => {
      data.sartauvoirPyrocrisis ??= [];
      data.sartauvoirPyrocrisis.push(matches.target);
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    outputStrings: {
      text: outputs/* default.spread */.Z.spread
    }
  }, {
    id: 'Zadnor Sartauvoir Pyrodoxy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Sartauvoir The Inferno',
      id: '5E8E'
    },
    delaySeconds: 0.5,
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.stackOnYou();
      if (data.sartauvoirPyrocrisis && !data.sartauvoirPyrocrisis.includes(data.me)) return output.stackOnTarget({
        player: data.party.member(matches.target)
      });
    },
    run: data => delete data.sartauvoirPyrocrisis,
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOnTarget: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'Zadnor Sartauvoir Mannatheihwon Flame Warning',
    type: 'Ability',
    // Triggered after Burning Blade.
    // TODO: does this ever happen again??
    netRegex: {
      source: 'Sartauvoir The Inferno',
      id: '5E90',
      capture: false
    },
    suppressSeconds: 999999,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack together to bait Ignis Est',
        de: 'Versammeln um Ignis Est zu ködern',
        fr: 'Packez-vous pour attirer l\'Ignis Est',
        cn: '集合诱导是为烈火',
        ko: '보스 앞으로 모이기'
      }
    }
  }, {
    id: 'Zadnor Sartauvoir Mannatheihwon Flame',
    type: 'StartsUsing',
    netRegex: {
      source: 'Sartauvoir The Inferno',
      id: '5E87',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Sartauvoir Mannatheihwon Flame Away',
    type: 'Ability',
    netRegex: {
      source: 'Sartauvoir The Inferno',
      id: '5E87',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get far away from X charges',
        de: 'Weit weg von den X Anstürmen',
        fr: 'Éloignez-vous des charges X',
        cn: '远离X冲锋',
        ko: 'X자에서 멀리 떨어지기'
      }
    }
  }, {
    id: 'Zadnor Sartauvoir Left Brand',
    type: 'StartsUsing',
    netRegex: {
      source: 'Sartauvoir The Inferno',
      id: '5E8C',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Zadnor Sartauvoir Right Brand',
    type: 'StartsUsing',
    netRegex: {
      source: 'Sartauvoir The Inferno',
      id: '5E8B',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Zadnor Blackburn Magitek Rays',
    type: 'StartsUsing',
    netRegex: {
      source: '4th Legion Blackburn',
      id: '5F12',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Blackburn Analysis',
    type: 'StartsUsing',
    netRegex: {
      source: '4th Legion Blackburn',
      id: '5F0F',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Opening Toward Undodgeable Line',
        de: 'Öffnen in Richtung der nicht ausweichbaren Linie',
        fr: 'Ouverture dans une ligne inesquivable',
        cn: '开口朝向无法躲避的线',
        ko: '피할 수 없는쪽으로 약점 방향 맞추기'
      }
    }
  }, {
    id: 'Zadnor Blackburn Augur Sanctified Quake III',
    type: 'StartsUsing',
    netRegex: {
      id: '5F20',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Augur Pyroplexy',
    type: 'Ability',
    netRegex: {
      source: '4th Legion Augur',
      id: '5F1B',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 하나씩 들어가기'
      }
    }
  }, {
    id: 'Zadnor Augur Turbine',
    type: 'StartsUsing',
    netRegex: {
      source: 'Flameborne Zirnitra',
      id: '5F14'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack + Knockback to Safe Spot',
        de: 'Sammeln + Rückstoß in den sicheren Bereich',
        fr: 'Package + Poussée vers un endroit safe',
        cn: '集合 + 向安全区击退',
        ko: '집합 + 안전장소로 넉백'
      }
    }
  }, {
    id: 'Zadnor Alkonost Wind',
    type: 'StartsUsing',
    // 5F21 = North Wind
    // 5F22 = South Wind
    netRegex: {
      source: 'Tamed Carrion Crow',
      id: ['5F21', '5F22']
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Zadnor Alkonost Stormcall Away',
    type: 'StartsUsing',
    netRegex: {
      source: 'Tamed Alkonost',
      id: '5F26',
      capture: false
    },
    delaySeconds: 18,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Orb',
        de: 'Weg vom Orb',
        fr: 'Éloignez-vous de l\'orbe',
        cn: '远离球球',
        ko: '구체 피하기'
      }
    }
  }, {
    id: 'Zadnor Alkonost Nihility\'s Song',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alkonost',
      id: '5F28',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Cuchulainn March',
    type: 'GainsEffect',
    // 871 = Forward March
    // 872 = About Face
    // 873 = Left Face
    // 874 = Right Face
    netRegex: {
      source: '4th-Make Cuchulainn',
      effectId: ['871', '872', '873', '874']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, matches, output) => {
      const effectId = matches.effectId.toUpperCase();
      if (effectId === '871') return output.forward();
      if (effectId === '872') return output.backward();
      if (effectId === '873') return output.left();
      if (effectId === '874') return output.right();
    },
    outputStrings: {
      forward: {
        en: 'March Forward (avoid puddles)',
        de: 'Marchiere Vorwärts (weiche den Flächen aus)',
        fr: 'Marche en avant (évitez les zones au sol)',
        cn: '强制移动: 前, 避开圈圈',
        ko: '정신장악: 앞, 장판 피하기'
      },
      backward: {
        en: 'March Backward (avoid puddles)',
        de: 'Marchiere Rückwärts (weiche den Flächen aus)',
        fr: 'Marche en arrière (évitez les zones au sol)',
        cn: '强制移动: 后, 避开圈圈',
        ko: '정신장악: 뒤, 장판 피하기'
      },
      left: {
        en: 'March Left (avoid puddles)',
        de: 'Marchiere Links (weiche den Flächen aus)',
        fr: 'Marche à gauche (évitez les zones au sol)',
        cn: '强制移动: 左, 避开圈圈',
        ko: '정신장악: 왼쪽, 장판 피하기'
      },
      right: {
        en: 'March Right (avoid puddles)',
        de: 'Marchiere Rechts (weiche den Flächen aus)',
        fr: 'Marche à droite (évitez les zones au sol)',
        cn: '强制移动: 右, 避开圈圈',
        ko: '정신장악: 오른쪽, 장판 피하기'
      }
    }
  }, {
    id: 'Zadnor Cuchulainn Might Of Malice',
    type: 'StartsUsing',
    netRegex: {
      source: '4th-Make Cuchulainn',
      id: '5C92'
    },
    condition: zadnor_tankBusterOnParty(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zadnor Cuchulainn Putrified Soul',
    type: 'StartsUsing',
    netRegex: {
      source: '4th-Make Cuchulainn',
      id: '5C8F',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Cuchulainn Fleshy Necromass',
    type: 'StartsUsing',
    netRegex: {
      source: '4th-Make Cuchulainn',
      id: '5C82',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get In Puddle',
        de: 'Geh in die Flächen',
        fr: 'Prenez une zone au sol',
        cn: '进入圈圈',
        ko: '장판 밟기'
      }
    }
  }, {
    id: 'Zadnor Cuchulainn Necrotic Billow',
    type: 'StartsUsing',
    netRegex: {
      source: '4th-Make Cuchulainn',
      id: '5C86',
      capture: false
    },
    // Normally wouldn't call out ground markers, but this can look a lot like Ambient Pulsation.
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Chasing AOEs',
        de: 'Weiche den verfolgenden AoEs aus',
        fr: 'Évitez les AoEs',
        cn: '躲避追踪AOE',
        ko: '따라오는 장판 피하기'
      }
    }
  }, {
    id: 'Zadnor Cuchulainn Ambient Pulsation',
    type: 'StartsUsing',
    netRegex: {
      source: '4th-Make Cuchulainn',
      id: '5C8E',
      capture: false
    },
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // TODO: this is "titan line bombs".  Is there a better wording here?
        en: 'Go to third line',
        de: 'Geh zur 3. Linie',
        fr: 'Allez à la troisième ligne',
        cn: '去第三行',
        ko: '세번째 장판으로'
      }
    }
  }, {
    id: 'Zadnor Cuchulainn Fell Flow',
    type: 'HeadMarker',
    netRegex: {
      id: '0028'
    },
    condition: (data, matches) => data.ce === 'dalriadaCuchulainn' && data.me === matches.target,
    response: responses/* Responses.earthshaker */.n3.earthshaker()
  }, {
    id: 'Zadnor Saunion High-Powered Magitek Ray',
    type: 'StartsUsing',
    netRegex: {
      source: 'Saunion',
      id: '5DC5'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Zadnor Saunion Magitek Halo',
    type: 'StartsUsing',
    netRegex: {
      source: 'Saunion',
      id: '5DB5',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Zadnor Saunion Magitek Crossray',
    type: 'StartsUsing',
    netRegex: {
      source: 'Saunion',
      id: '5DB7',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Intercardinals',
        de: 'Geh zu Interkardinalen Richtungen',
        fr: 'Allez en intercardinal',
        cn: '去四角',
        ko: '대각선으로'
      }
    }
  }, {
    id: 'Zadnor Saunion Mobile Halo',
    type: 'StartsUsing',
    netRegex: {
      source: 'Saunion',
      id: ['5DB9', '5DBA', '5DBB', '5DBC'],
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Under (towards charge)',
        de: 'Geh unter den Boss (zum Ansturm hin)',
        fr: 'Passez en dessous (vers la charge)',
        cn: '去下方 (朝向冲锋方向)',
        ko: '보스 밑으로 (화살표 따라가기)'
      }
    }
  }, {
    id: 'Zadnor Saunion Mobile Crossray',
    type: 'StartsUsing',
    netRegex: {
      source: 'Saunion',
      id: ['5DBD', '5DBE', '5DBF', '5DC0'],
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Intercards (away from charge)',
        de: 'Geh zu Interkardinalen Richtungen (weg vom Ansturm)',
        fr: 'Allez en intercardinal (éloignez-vous de la charge)',
        cn: '去四角 (躲避冲锋)',
        ko: '대각선으로 (화살표쪽 피하기)'
      }
    }
  }, {
    id: 'Zadnor Saunion Anti-Personnel Missile',
    type: 'StartsUsing',
    netRegex: {
      source: 'Saunion',
      id: '5DC2'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Zadnor Saunion Missile Salvo',
    type: 'StartsUsing',
    netRegex: {
      source: 'Saunion',
      id: '5DC3'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Zadnor Saunion Wildfire Winds',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dawon The Younger',
      id: '5DCD',
      capture: false
    },
    delaySeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // TODO: during spiral scourge could be "get under middle/outer light orb"?
        en: 'Get Under Light Orb',
        de: 'Unter einem Lichtorb stellen',
        fr: 'Allez sous un orbe lumineux',
        ja: '白玉へ',
        cn: '靠近白球',
        ko: '하얀 구슬 안으로'
      }
    }
  }, {
    id: 'Zadnor Saunion Tooth and Talon',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dawon The Younger',
      id: '5DD4'
    },
    condition: zadnor_tankBusterOnParty(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zadnor Saunion Swooping Frenzy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Dawon The Younger',
      id: '5DD0',
      capture: false
    },
    infoText: (data, _matches, output) => {
      // Every other Swooping Frenzy is followed by a Frigid Pulse, starting with the first.
      data.saunionSwoopingCount = (data.saunionSwoopingCount ?? 0) + 1;
      if (data.saunionSwoopingCount % 2) return output.text();
    },
    outputStrings: {
      text: {
        en: 'Follow Dawon',
        de: 'Folge Dawon',
        fr: 'Suivez Dawon',
        cn: '跟随小达温',
        ko: '다우언 따라가기'
      }
    }
  }, {
    id: 'Zadnor Diablo Advanced Death Ray',
    type: 'HeadMarker',
    netRegex: {
      id: '00E6'
    },
    condition: data => data.ce === 'dalriadaDiablo',
    // TODO: this is maybe worth promoting to responses?
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankLaserOnYou: {
          en: 'Tank Laser on YOU',
          de: 'Tank Laser auf DIR',
          fr: 'Tank laser sur VOUS',
          ja: '自分にタンクレーザー',
          cn: '坦克激光点名',
          ko: '탱 레이저 대상자'
        },
        avoidTankLaser: {
          en: 'Avoid Tank Laser',
          de: 'Weiche dem Tanklaser aus',
          fr: 'Évitez le tank laser',
          cn: '躲避坦克激光',
          ko: '탱 레이저 피하기'
        }
      };
      if (data.me === matches.target) return {
        alarmText: output.tankLaserOnYou()
      };
      return {
        infoText: output.avoidTankLaser()
      };
    }
  }, {
    id: 'Zadnor Diablo Aetheric Explosion',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diablo Armament',
      id: '5CC6',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Diablo Ultimate Psuedoterror',
    type: 'StartsUsing',
    // This is triggered on Diabolic Gate with a delay, so it gives an extra +4 seconds.
    netRegex: {
      source: 'The Diablo Armament',
      id: '5C9F',
      capture: false
    },
    delaySeconds: 37,
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Zadnor Diablo Advanced Death IV',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diablo Armament',
      id: '5CAF',
      capture: false
    },
    // Circles appear at the end of the cast.
    delaySeconds: 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Growing Circles',
        de: 'Weiche den wachsenden Kreisen aus',
        fr: 'Évitez les cercles grandissants',
        cn: '躲避变大圈圈',
        ko: '커지는 장판 피하기'
      }
    }
  }, {
    id: 'Zadnor Diablo Advanced Death IV Followup',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diablo Armament',
      id: '5CAF',
      capture: false
    },
    delaySeconds: 12,
    // TODO: or "Avoid Growing Circles (again lol)"?
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'Zadnor Diablo Aetheric Boom Raidwide',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diablo Armament',
      id: '5CB3',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zadnor Diablo Aetheric Boom Balloons',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diablo Armament',
      id: '5CB3',
      capture: false
    },
    // Don't warn people to preposition here, because they probably need
    // heals after the initial hit before popping these.
    delaySeconds: 5.5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pop Balloons',
        de: 'Orbs nehmen',
        fr: 'Apparition des boules',
        cn: '吃球',
        ko: '구체 부딪히기'
      }
    }
  }, {
    id: 'Zadnor Diablo Deadly Dealing',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diablo Armament',
      id: '5CC2'
    },
    // TODO: these feel really late with 5 seconds, should they call instantly at 7?
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    alertText: (data, _matches, output) => {
      data.diabloDealingCount = (data.diabloDealingCount ?? 0) + 1;
      return data.diabloDealingCount % 2 ? output.knockbackBits() : output.knockbackNox();
    },
    outputStrings: {
      knockbackBits: {
        en: 'Knockback (away from bits)',
        de: 'Rückstoß (Weg von den Magiteks)',
        fr: 'Poussée (éloignez-vous des drones)',
        cn: '击退 (避开浮游炮)',
        ko: '넉백 (비트 피하기)'
      },
      knockbackNox: {
        en: 'Knockback (into empty corner)',
        de: 'Rückstoß (in die leere Ecke)',
        fr: 'Poussée (dans un coin vide)',
        cn: '击退 (进入空角落)',
        ko: '안전지대로 넉백'
      }
    }
  }, {
    id: 'Zadnor Diablo Void Systems Overload',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diablo Armament',
      id: '5CB7',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'Zadnor Diablo Pillar Of Shamash Spread',
    type: 'HeadMarker',
    // 5CBC damage
    netRegex: {
      id: '0017'
    },
    condition: data => data.ce === 'dalriadaDiablo',
    preRun: (data, matches) => {
      data.diabloPillar ??= [];
      data.diabloPillar.push(matches.target);
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    outputStrings: {
      text: {
        en: 'Laser on YOU',
        de: 'Laser auf DIR',
        fr: 'Laser sur VOUS',
        cn: '激光点名',
        ko: '레이저 대상자'
      }
    }
  }, {
    id: 'Zadnor Diablo Pillar Of Shamash Stack',
    type: 'HeadMarker',
    // 5CBE damage (no headmarker???)
    netRegex: {
      id: '0017',
      capture: false
    },
    condition: data => data.ce === 'dalriadaDiablo',
    delaySeconds: 3,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (!data.diabloPillar || !data.diabloPillar.includes(data.me)) return output.text();
    },
    run: data => delete data.diabloPillar,
    outputStrings: {
      text: {
        en: 'Line Stack',
        de: 'In einer Linie sammeln',
        fr: 'Package en ligne',
        ja: '直線頭割り',
        cn: '直线分摊',
        ko: '직선 쉐어'
      }
    }
  }, {
    id: 'Zadnor Diablo Acceleration Bomb Dodge',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'A61'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: (_data, matches) => parseFloat(matches.duration) - 4,
    infoText: (_data, matches, output) => {
      // Durations are 7 and 12.
      const duration = parseFloat(matches.duration);
      return duration > 10 ? output.dodgeFirst() : output.dodgeSecond();
    },
    outputStrings: {
      dodgeFirst: {
        en: '(Dodge -> Stop)',
        de: '(Ausweichen -> Stop)',
        fr: '(Esquivez -> Arrêtez)',
        cn: '(躲避 -> 停停停)',
        ko: '(피하기 -> 멈추기)'
      },
      dodgeSecond: {
        en: '(Stop -> Dodge)',
        de: '(Stop -> Ausweichen)',
        fr: '(Arrêtez -> Esquivez)',
        cn: '(停停停 -> 躲避)',
        ko: '(멈추기 -> 피하기)'
      }
    }
  }, {
    id: 'Zadnor Diablo Acceleration Bomb Stop',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'A61'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // TODO: this could be better timed to be later for the dodge -> stop version and earlier
    // for the stop -> dodge.
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 3.5,
    response: responses/* Responses.stopEverything */.n3.stopEverything()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Left Brand/Right Brand': 'Left/Right Brand',
      'Time Eruption/Reverse Time Eruption': '(Reverse?) Time Eruption',
      'North Wind/South Wind': 'North/South Wind',
      'Magitek Halo/Magitek Crossray': 'Magitek Halo/Crossray',
      'Magitek Crossray/Magitek Halo': 'Magitek Crossray/Halo',
      'Mobile Halo/Mobile Crossray': 'Mobile Halo/Crossray',
      'Mobile Crossray/Mobile Halo': 'Mobile Crossray/Halo'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      '(?<!Tamed )Alkonost': 'Alkonost',
      'Ayida': 'Ayida',
      '4Th Legion Augur': 'Augur der IV\\. Legion',
      '4Th Legion Blackburn': 'Schwarzbrand der IV\\. Legion',
      '4th-Make Belias': 'Belias der IV\\. Legion',
      '4Th-Make Cuchulainn': 'Cuchulainn der IV\\. Legion',
      '4th-Make Hashmal': 'Hashmallim der IV\\. Legion',
      '4th-Make Shemhazai': 'Shemhazai der IV\\. Legion',
      '7 minutes have elapsed since your last activity.': 'Seit deiner letzten Aktivität sind 7 Minuten vergangen.',
      '(?<!4Th Legion )Blackburn': 'Schwarzbrand',
      'Clibanarius': 'Clibanarius',
      'Dawon The Younger': 'Dawon junior',
      'Diabolic Bit': 'Diablo-Drohne',
      'Dyunbu the Accursed': 'Dyunbu (?:der|die|das) Unlauter(?:e|er|es|en)',
      'Flameborne Zirnitra': 'Flammen-Zirnitra',
      'Hanbi': 'Hanbi',
      'Hedetet': 'Hedetet',
      'Hrodvitnir': 'Hrodvitnir',
      'Huma': 'Homa',
      'Ice Sprite': 'Eis-Exergon',
      'Ignis Est': 'Ignis Est',
      'Kampe': 'Kampe',
      'Magitek Development': 'Bereich Magitek-Forschung',
      'Phantom Hashmal': 'Hashmallims Abbild',
      'Sartauvoir The Inferno': 'Sartauvoir Eisenfeuer',
      'Saunion': 'Saunion',
      'Stormborne Zirnitra': 'Sturm-Zirnitra',
      'Tamed Alkonost(?!\'s Shadow)': 'gebändigt(?:e|er|es|en) Alkonost',
      'Tamed Alkonost\'s Shadow': 'gebändigt(?:e|er|es|en) Alkonost',
      'Tamed Carrion Crow': 'gebändigt(?:e|er|es|en) Aaskrähe',
      'The Diablo Armament': 'Diablo-Armament',
      'The fallen ring': 'Eingestürzte Grube',
      'The flagship landing': 'Kriegsschiff-Ankerplatz',
      'The greater hold': 'Großer Stauraum',
      'The loading dock': 'Ladebereich',
      'Vermilion Flame': 'feurig(?:e|er|es|en) Glut',
      'Vortical Orb': 'Magiewindkugel',
      'Waveborne Zirnitra': 'Wellen-Zirnitra'
    },
    'replaceText': {
      '--lasers--': '--Laser--',
      '--line stack--': '--In Linie sammeln--',
      '74 Degrees': 'Wassergeschoss',
      'Advanced Death IV': 'Super-Todka',
      'Advanced Death Ray': 'Super-Todesstrahl',
      'Advanced Nox': 'Super-Nox',
      'Aetheric Boom': 'Ätherknall',
      'Aetheric Explosion': 'Ätherische Explosion',
      'Aetherochemical Laser': 'Ätherochemischer Laser',
      'Ambient Pulsation': 'Ätherwulst',
      'Analysis': 'Analyse',
      'Anti-Personnel Missile': 'Antipersonenrakete',
      'Assault Cannon': 'Sturmkanone',
      'Ballistic Impact': 'Ballistischer Einschlag',
      'Broadside Barrage': 'Längssalve',
      'Burgeoning Dread': 'Welle der Angst',
      'Burn(?!ing)': 'Verbrennung',
      'Burning Blade': 'Brandklinge',
      'Deadly Dealing': 'Todeswatsche',
      'Diabolic Gate': 'Diabolisches Tor',
      'Double Cast': 'Doppelzauber',
      'Explosion': 'Explosion',
      'Fell Flow': 'Strom der Verdorbenheit',
      'Fire Brand': 'Majestätisches Kreuz',
      'Flamedive': 'Flammentaucher',
      'Flaming Cyclone': 'Flammenzyklon',
      'Fleshy Necromass': 'Todespresse',
      'Foreshadowing': 'Vorahnung',
      'Frigid Pulse': 'Froststoß',
      'Ghastly Aura': 'Verlustwelle',
      'Grand Crossflame': 'Große Kreuzflamme',
      'High-Powered Magitek Ray': 'Hochenergetischer Magitek-Laser',
      'Hyperpyroplexy': 'Hyper-Pyroplexie',
      'Ignis Est': 'Ignis Est',
      'Immolate': 'Opferung',
      'Left Brand': 'Feuerzeichen links',
      'Light Pseudopillar': 'Lichtsäule der Ätherochemie',
      'Magitek Bit': 'Magitek-Bit',
      'Magitek Crossray': 'Magitek-Kreuzlaser',
      'Magitek Halo': 'Magitek-Brennkreis',
      'Mannatheihwon Flame': 'Mannatheihwo-Flamme',
      'Might Of Malice': 'Trampelausbruch',
      'Missile Command': 'Raketenkommando',
      'Missile Salvo': 'Mehrfach-Rakete',
      'Mobile Crossray': 'Transfer-Kreuzlaser',
      'Mobile Halo': 'Transfer-Brennkreis',
      'Necrotic Billow': 'Fäulnisbrand',
      'Nihility\'s Song': 'Nihilismuslied',
      'North Wind': 'Nordwind',
      'Obey': 'Gehorchen',
      '(?<!Verd)Orb': 'Kugel',
      'Pain Storm': 'Schmerzsturm',
      'Painful Gust': 'Schmerzhafte Böe',
      'Pentagust': 'Pentagast',
      'Phenex': 'Phenex',
      'Pillar Of Shamash': 'Shams Säule',
      'Putrified Soul': 'Unreine Welle',
      'Pyrocrisis': 'Pyrokrise',
      'Pyrodoxy': 'Pyrodoxie',
      'Pyrokinesis': 'Pyrokinese',
      '(?<![-r])Pyroplexy': 'Pyroplexie',
      'Raw Heat': 'Flammende Welle',
      'Read Orders: Field Support': 'Befehl: Infanterieverstärkung',
      'Reverse Time Eruption': 'Umgekehrte Zeiteruption',
      'Right Brand': 'Feuerzeichen rechts',
      'Ruinous Pseudomen': 'Ruinöses Omen der Ätherochemie',
      'Sanctified Quake III': 'Gesegnetes Seisga',
      'South Wind': 'Südwind',
      'Spiral Scourge': 'Spiralspießer',
      'Stormborne Zirnitra': 'Flammen-Zirnitra',
      'Stormcall': 'Sturmruf',
      'Suppressive Magitek Rays': 'Omnidirektionaler Magitek-Laser',
      'Surface Missile': 'Raketenschlag',
      'Swooping Frenzy': 'Heftiges Schütteln',
      'Terminus Est': 'Terminus Est',
      'Thermal Gust': 'Thermalböe',
      '(?<!Reverse )Time Eruption': 'Zeiteruption',
      'Tooth And Talon': 'Krallen des Bestienkönigs',
      'Touchdown': 'Himmelssturz',
      'Turbine': 'Turbine',
      'Ultimate Pseudoterror': 'Ultimativer Terror der Ätherochemie',
      'Void Call': 'Helferlein',
      'Void Systems Overload': 'Modell-V-Amokfahrt',
      'Wildfire Winds': 'Majestätischer Windstoß'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '(?<!Tamed )Alkonost(?! dressé)': 'Alkonost',
      'Ayida': 'Ayida',
      '4Th Legion Augur': 'augure de la 4e légion',
      '4Th Legion Blackburn': 'Escarre de la 4e légion',
      '4th-Make Belias': 'Bélias de la 4e légion',
      '4Th-Make Cuchulainn': 'cúchulainn de la 4e légion',
      '4th-Make Hashmal': 'Hashmal de la 4e légion',
      '4th-Make Shemhazai': 'Shemhazai de la 4e légion',
      '7 minutes have elapsed since your last activity..*?': 'Votre personnage est inactif depuis 7 minutes',
      '(?<!4Th Legion )Blackburn': 'Escarre',
      'Clibanarius': 'Clibanarius',
      'Dawon The Younger': 'Dawon junior',
      'Diabolic Bit': 'drone de Diablo',
      'Dyunbu the Accursed': 'Dyunbu l\'impure',
      'Hanbi': 'Hanbi',
      'Hedetet': 'Hededèt',
      'Hrodvitnir': 'Hródvitnir',
      'Flameborne Zirnitra': 'zirnitra des flammes',
      'Huma': 'homa',
      'Ice Sprite': 'élémentaire de glace',
      'Ignis Est': 'Ignis Est',
      'Kampe': 'Campé',
      'Magitek Development': 'Section des recherches magitek',
      'Phantom Hashmal': 'double du Hashmal',
      'Sartauvoir The Inferno': 'Sartauvoir le fer rouge',
      'Saunion': 'Saunion',
      'Stormborne Zirnitra': 'zirnitra des tempêtes',
      'Tamed Alkonost(?!\'s Shadow)': 'alkonost dressé',
      'Tamed Alkonost\'s Shadow': 'ombre d\'Alkonost dressé',
      'Tamed Carrion Crow': 'corneille noire dressée',
      'The Diablo Armament': 'batterie d\'artillerie Diablo',
      'The fallen ring': 'Anneau effondré',
      'The flagship landing': 'Embarcadère du Dalriada',
      'The greater hold': 'Grande soute',
      'The loading dock': 'Aire de chargement',
      'Vermilion Flame': 'incandescence',
      'Vortical Orb': 'globe de vent maléfique',
      'Waveborne Zirnitra': 'zirnitra des torrents'
    },
    'replaceText': {
      '--lasers--': '--lasers',
      '--line stack': '--package en ligne--',
      '74 Degrees': 'Aqua-tir',
      'Advanced Death IV': 'Giga Mort renforcée',
      'Advanced Death Ray': 'Rayon de la mort renforcé',
      'Advanced Nox': 'Nox renforcée',
      'Aetheric Boom': 'Onde d\'éther',
      'Aetheric Explosion': 'Éther explosif',
      'Aetherochemical Laser': 'Laser magismologique',
      'Ambient Pulsation': 'Pulsation démoniaque',
      'Analysis': 'Analyse',
      'Anti-Personnel Missile': 'Pluie de missiles antipersonnel',
      'Assault Cannon': 'Canon d\'assaut',
      'Ballistic Impact': 'Impact de missile',
      'Broadside Barrage': 'Bourrasque latérale',
      'Burgeoning Dread': 'Vague de terreur',
      'Burn(?!ing)': 'Combustion',
      'Burning Blade': 'Lame calcinante',
      'Deadly Dealing': 'Fracas mortel',
      'Diabolic Gate': 'Porte d\'outre-monde',
      'Double Cast': 'Double incantation',
      'Explosion': 'Explosion',
      'Fell Flow': 'Torrent fangeux',
      'Fire Brand': 'Croix auguste',
      'Flamedive': 'Plongeon embrasé',
      'Flaming Cyclone': 'Cyclone de feu',
      'Fleshy Necromass': 'Écrasement malsain',
      'Foreshadowing': 'Préfiguration',
      'Frigid Pulse': 'Pulsation glaciale',
      'Ghastly Aura': 'Onde d\'amnésie',
      'Grand Crossflame': 'Croix suprême enflammée',
      'High-Powered Magitek Ray': 'Rayon magitek surpuissant',
      'Hyperpyroplexy': 'Hyperpyroplexie',
      'Ignis Est': 'Ignis Est',
      'Immolate': 'Immolation',
      'Left Brand/Right Brand': 'Marque au fer rouge gauche/droite',
      'Light Pseudopillar': 'Colonne lumineuse magismologique',
      'Magitek Bit': 'Éjection de drones',
      'Magitek Crossray/Magitek Halo': 'Rayon croisé/Cercle enflammé magitek',
      'Magitek Halo/Magitek Crossray': 'Cercle enflammé/Rayon croisé magitek',
      'Mannatheihwon Flame': 'Flamme de Mannatheihwo',
      'Might Of Malice': 'Coup de pied puissant',
      'Missile Command': 'Commande missile',
      'Missile Salvo': 'Salve de missiles',
      'Mobile Crossray/Mobile Halo': 'Rayon croisé/Cercle enflammé mobile',
      'Mobile Halo/Mobile Crossray': 'Cercle enflammé/Rayon croisé mobile',
      'Necrotic Billow': 'Immolation putréfiante',
      'Nihility\'s Song': 'Chant de la vacuité',
      'North Wind/South Wind': 'Vent de nord/sud',
      'Obey': 'À l\'écoute du maître',
      'Orb': 'Orbe',
      'Pain Storm': 'Tempête de douleur',
      'Painful Gust': 'Rafale suppliciante',
      'Pentagust': 'Pentasouffle',
      'Phenex': 'Phenex',
      'Pillar Of Shamash': 'Pilier de Shams',
      'Putrified Soul': 'Vague de souillure',
      'Pyrocrisis': 'Pyrocrisie',
      'Pyrodoxy': 'Pyrodoxie',
      'Pyrokinesis': 'Pyrokinésie',
      '(?<!r)Pyroplexy': 'Pyroplexie',
      'Raw Heat': 'Vague explosive',
      'Read Orders: Field Support': 'Ordre tactique : Infanterie de soutien',
      'Reverse Time Eruption( [0-9])': 'Éruption à devancement$1',
      'Ruinous Pseudomen': 'Mauvais présage magismologique',
      'Sanctified Quake III': 'Méga Séisme sanctifié',
      'Spiral Scourge': 'Spirale empalante',
      'Stormborne Zirnitra': 'zirnitra des flammes',
      'Stormcall': 'Appel des tempêtes',
      'Suppressive Magitek Rays': 'Rayon magitek tous azimuts',
      'Surface Missile': 'Missiles sol-sol',
      'Swooping Frenzy': 'Plongeon frénétique',
      'Terminus Est': 'Terminus Est',
      'Thermal Gust': 'Bourrasque incandescente',
      '(?<!Reverse )Time Eruption( [0-9])': 'Éruption à retardement$1',
      'Time Eruption/Reverse Time Eruption': 'Éruption à retardement/devancement',
      'Tooth And Talon': 'Lacération du Roi bestial',
      'Touchdown': 'Atterrissage',
      'Turbine': 'Turbine',
      'Ultimate Pseudoterror': 'Terreur ultime magismologique',
      'Void Call': 'Invocation',
      'Void Systems Overload': 'Surrégime du moteur \'V\'',
      'Wildfire Winds': 'Tempête de plumes auguste'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      '4Th Legion Augur': 'IVレギオン・アウグル',
      '4Th Legion Blackburn': 'IVレギオン・ブラックバーン',
      '4th-Make Belias': 'IVレギオン・ベリアス',
      '4Th-Make Cuchulainn': 'IVレギオン・キュクレイン',
      '4th-Make Hashmal': 'IVレギオン・ハシュマリム',
      '4th-Make Shemhazai': 'IVレギオン・シュミハザ',
      '(?<!4Th Legion )Blackburn': 'ブラックバーン',
      'Dawon The Younger': 'ドゥンJr\\.',
      'Diabolic Bit': 'ディアブロ・ビット',
      'Dyunbu the Accursed': '不浄のユンブ',
      'Flameborne Zirnitra': 'フレイム・ジルニトラ',
      'Huma': 'フマ',
      'Ice Sprite': 'アイススプライト',
      'Ignis Est': 'イグニス・エスト',
      'Magitek Development': '魔導研究区画',
      'Phantom Hashmal': 'ハシュマリムの幻影',
      'Sartauvoir The Inferno': '鉄火のサルトヴォアール',
      'Saunion': 'サウニオン',
      'Stormborne Zirnitra': 'ストーム・ジルニトラ',
      'Tamed Alkonost(?!\'s Shadow)': 'テイムド・アルコノスト',
      'Tamed Alkonost\'s Shadow': 'テイムド・アルコノストの影',
      'Tamed Carrion Crow': 'テイムド・キャリオンクロウ',
      'The Diablo Armament': 'ディアブロ・アーマメント',
      'The fallen ring': '崩落した試掘坑',
      'The flagship landing': '旗艦停泊地',
      'The greater hold': '大型格納区画',
      'The loading dock': '搬入出区画',
      'Vermilion Flame': '赤熱火',
      'Vortical Orb': '魔嵐球',
      'Waveborne Zirnitra': 'ウェイブ・ジルニトラ',
      '7 minutes have elapsed since your last activity..*?': '操作がない状態になってから7分が経過しました。',
      'Hedetet': 'ヘデテト',
      'Clibanarius': 'クリバナリウス',
      'Hanbi': 'ハンビ',
      'Hrodvitnir': 'フローズヴィトニル',
      'Kampe': 'カンペ',
      'Ayida': 'アイダ',
      '(?<!Tamed )Alkonost': 'アルコノスト'
    },
    'replaceText': {
      '74 Degrees': 'ウォーターショット',
      'Advanced Death IV': '強化デスジャ',
      'Advanced Death Ray': '強化デスレイ',
      'Advanced Nox': '強化ノックス',
      'Aetheric Boom': 'エーテル波動',
      'Aetheric Explosion': 'エーテリックエクスプロージョン',
      'Aetherochemical Laser': '魔科学レーザー',
      'Ambient Pulsation': '魔脈瘤',
      'Analysis': 'アナライズ',
      'Anti-Personnel Missile': '対人ミサイル乱射',
      'Assault Cannon': 'アサルトカノン',
      'Ballistic Impact': 'ミサイル着弾',
      'Broadside Barrage': 'ボロードサイドバラージ',
      'Burgeoning Dread': '恐怖の波動',
      'Burn(?!ing)': '燃焼',
      'Burning Blade': 'バーンブレイド',
      'Deadly Dealing': 'デッドリースマッシュ',
      'Diabolic Gate': '異界の扉',
      'Double Cast': 'ダブルキャスト',
      '(?<!Aetheric )Explosion': '爆発',
      'Fell Flow': '汚濁の奔流',
      'Fire Brand': '炎帝十文字',
      'Flamedive': 'フレイムダイブ',
      'Flaming Cyclone': 'フレイムサイクロン',
      'Fleshy Necromass': '不浄圧殺',
      'Foreshadowing': 'フォアシャドウィング',
      'Frigid Pulse': 'フリジッドパルス',
      'Ghastly Aura': '喪失の波動',
      'Grand Crossflame': 'グランドクロスフレイム',
      'High-Powered Magitek Ray': '高出力魔導レーザー',
      'Hyperpyroplexy': 'ハイパー・パイロプレクシー',
      'Ignis Est': 'イグニス・エスト',
      'Immolate': '大燃焼',
      'Left Brand': 'レフトブランド',
      'Light Pseudopillar': '魔科学式リヒト・ゾイレ',
      'Magitek Bit': 'ビット射出',
      'Magitek Crossray': '魔導クロスレーザー',
      'Magitek Halo': '魔導バーニングサークル',
      'Mannatheihwon Flame': 'マントヴァフレイム',
      'Might Of Malice': '重蹴撃',
      'Missile Command': 'ミサイル全弾発射',
      'Missile Salvo': '連装ミサイル',
      'Mobile Crossray': '転移式クロスレーザー',
      'Mobile Halo': '転移式バーニングサークル',
      'Necrotic Billow': '腐朽焼殺',
      'Nihility\'s Song': 'ニヒリティソング',
      'North Wind': '北風',
      'Obey': 'しじをきく',
      'Pain Storm': 'ペインストーム',
      'Painful Gust': 'ペインフルガスト',
      'Pentagust': 'ペンタガスト',
      'Phenex': 'フェネクス',
      'Pillar Of Shamash': 'シャムスの柱',
      'Putrified Soul': '汚染波',
      'Pyrocrisis': 'パイロクライシス',
      'Pyrodoxy': 'パイロドクシー',
      'Pyrokinesis': 'パイロキネシス',
      '(?<![-r])Pyroplexy': 'パイロプレクシー',
      'Raw Heat': '爆炎波',
      'Read Orders: Field Support': '作戦指示：歩兵支援',
      'Reverse Time Eruption': 'リバース・タイムエラプション',
      'Right Brand': 'ライトブランド',
      'Ruinous Pseudomen': '魔科学式ルイナスオーメン',
      'Sanctified Quake III': 'サンクティファイド・クエイガ',
      'South Wind': '南風',
      'Spiral Scourge': 'スパイラルスカージ',
      'Stormborne Zirnitra': 'フレイム・ジルニトラ',
      'Stormcall': 'ストームコール',
      'Suppressive Magitek Rays': '全方位魔導レーザー',
      'Surface Missile': '対地ミサイル',
      'Swooping Frenzy': 'スワープフレンジー',
      'Terminus Est': 'ターミナス・エスト',
      'Thermal Gust': 'サーマルガスト',
      '(?<!Reverse )Time Eruption': 'タイムエラプション',
      'Tooth And Talon': '獣王裂爪撃',
      'Touchdown': 'タッチダウン',
      'Turbine': 'タービン',
      'Ultimate Pseudoterror': '魔科学式アルティメットテラー',
      'Void Call': '使い魔召喚',
      'Void Systems Overload': 'V機関暴走',
      'Wildfire Winds': '炎帝嵐翼破'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '4Th Legion Augur': '第四军团先知',
      '4Th Legion Blackburn': '第四军团黑色燃焰',
      '4th-Make Belias': '第四军团贝利亚斯',
      '4Th-Make Cuchulainn': '第四军团丘库雷因',
      '4th-Make Hashmal': '第四军团哈修马利姆',
      '4th-Make Shemhazai': '第四军团谢米哈扎',
      '7 minutes have elapsed since your last activity.': '已经7分钟没有进行任何操作',
      '(?<!Tamed )Alkonost': '阿尔科诺斯特',
      'Ayida': '阿依达',
      '(?<!4Th Legion )Blackburn': '黑色燃焰',
      'Clibanarius': '铠甲重骑兵',
      'Dawon The Younger': '小达温',
      'Diabolic Bit': '迪亚布罗浮游炮',
      'Dyunbu the Accursed': '污身秽心 尤恩布',
      'Flameborne Zirnitra': '火焰札尼尔查妖蛇',
      'Hanbi': '汉比',
      'Hedetet': '赫德提特',
      'Hrodvitnir': '恶名苍狼',
      'Huma': '呼玛',
      'Ice Sprite': '冰元精',
      'Ignis Est': '是为烈火',
      'Kampe': '坎珀',
      'Magitek Development': '魔导研究区',
      'Phantom Hashmal': '哈修马利姆的幻影',
      'Sartauvoir The Inferno': '铁胆狱火 萨托瓦尔',
      'Saunion': '桑尼恩',
      'Stormborne Zirnitra': '暴风札尼尔查妖蛇',
      'Tamed Alkonost(?!\'s Shadow)': '驯服阿尔科诺斯特',
      'Tamed Alkonost\'s Shadow': '驯服阿尔科诺斯特之影',
      'Tamed Carrion Crow': '驯服食腐鸦',
      'The Diablo Armament': '迪亚布罗魔兵',
      'The fallen ring': '崩塌的试掘坑',
      'The flagship landing': '旗舰停泊地',
      'The greater hold': '大型兵器仓库',
      'The loading dock': '货物装卸区',
      'Vermilion Flame': '赤热火',
      'Vortical Orb': '魔风球',
      'Waveborne Zirnitra': '波涛札尼尔查妖蛇'
    },
    'replaceText': {
      '--lasers--': '--激光--',
      '--line stack--': '--直线分摊--',
      '74 Degrees': '射水',
      'Advanced Death IV': '强化极死',
      'Advanced Death Ray': '强化死亡射线',
      'Advanced Nox': '深夜',
      'Aetheric Boom': '以太波动',
      'Aetheric Explosion': '以太爆炸',
      'Aetherochemical Laser': '魔科学激光',
      'Ambient Pulsation': '魔脉瘤',
      'Analysis': '分析',
      'Anti-Personnel Missile': '对人导弹乱射',
      'Assault Cannon': '突击加农炮',
      'Ballistic Impact': '导弹命中',
      'Broadside Barrage': '侧翼火力',
      'Burgeoning Dread': '恐惧波动',
      'Burn(?!ing)': '燃烧',
      'Burning Blade': '燃烧之刃',
      'Deadly Dealing': '致命碎击',
      'Diabolic Gate': '异界之门',
      'Double Cast': '双重咏唱',
      '(?<!Aetheric )Explosion': '爆炸',
      'Fell Flow': '污浊奔流',
      'Fire Brand': '炎帝十文字',
      'Flamedive': '烈焰俯冲',
      'Flaming Cyclone': '烈焰旋风',
      'Fleshy Necromass': '不净压杀',
      'Foreshadowing': '预示',
      'Frigid Pulse': '寒冷脉冲',
      'Ghastly Aura': '丧失波动',
      'Grand Crossflame': '大十字火',
      'High-Powered Magitek Ray': '高功率魔导激光',
      'Hyperpyroplexy': '超火卒',
      'Ignis Est': '是为烈火',
      'Immolate': '大燃烧',
      'Left Brand': '左印',
      'Light Pseudopillar': '魔科学式光柱',
      'Magitek Bit': '浮游炮射出',
      'Magitek Crossray': '魔导交叉激光',
      'Magitek Halo': '魔导焰光环',
      'Mannatheihwon Flame': '曼托瓦之炎',
      'Might Of Malice': '重踢击',
      'Missile Command': '导弹齐发',
      'Missile Salvo': '连装导弹',
      'Mobile Crossray': '移动式交叉激光',
      'Mobile Halo': '移动式焰光环',
      'Necrotic Billow': '腐朽烧杀',
      'Nihility\'s Song': '虚无之歌',
      'North Wind': '北风',
      'Obey': '服从',
      '(?<!Verd)Orb': '球',
      'Pain Storm': '痛苦风暴',
      'Painful Gust': '极痛突风',
      'Pentagust': '五向突风',
      'Phenex': '菲尼克斯',
      'Pillar Of Shamash': '太阳之柱',
      'Putrified Soul': '污染波',
      'Pyrocrisis': '火危',
      'Pyrodoxy': '火念',
      'Pyrokinesis': '火动',
      '(?<![-r])Pyroplexy': '火卒',
      'Raw Heat': '爆炎破',
      'Read Orders: Field Support': '作战指示：步兵支援',
      'Reverse Time Eruption': '时空地火喷发·逆转',
      'Right Brand': '右印',
      'Ruinous Pseudomen': '魔科学式破灭预兆',
      'Sanctified Quake III': '圣化爆震',
      'South Wind': '南风',
      'Spiral Scourge': '螺旋灾变',
      'Stormborne Zirnitra': '火焰札尼尔查妖蛇',
      'Stormcall': '呼唤风暴',
      'Suppressive Magitek Rays': '全方位魔导激光',
      'Surface Missile': '对地导弹',
      'Swooping Frenzy': '狂乱猛冲',
      'Terminus Est': '恩惠终结',
      'Thermal Gust': '炙热风',
      '(?<!Reverse )Time Eruption': '时空地火喷发',
      'Tooth And Talon': '兽王裂爪击',
      'Touchdown': '空降',
      'Turbine': '涡轮',
      'Ultimate Pseudoterror': '魔科学式究极恐惧',
      'Void Call': '虚无召唤',
      'Void Systems Overload': '虚无系统失控',
      'Wildfire Winds': '炎帝风翼破'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '4Th Legion Augur': 'IV군단 점쟁이',
      '4Th Legion Blackburn': 'IV군단 블랙번',
      '4th-Make Belias': 'IV군단 벨리아스',
      '4Th-Make Cuchulainn': 'IV군단 쿠훌린',
      '4th-Make Hashmal': 'IV군단 하쉬말림',
      '4th-Make Shemhazai': 'IV군단 셰미하자',
      '7 minutes have elapsed since your last activity.': '7분 동안 아무 조작을 하지 않았습니다.',
      '(?<!Tamed )Alkonost': '알코노스트',
      'Ayida': '아이다',
      '(?<!4Th Legion )Blackburn': '블랙번',
      'Clibanarius': '클리바나리우스',
      'Dawon The Younger': '다우언 주니어',
      'Diabolic Bit': '디아블로 비트',
      'Dyunbu the Accursed': '부정한 윤부',
      'Flameborne Zirnitra': '불꽃 지르니트라',
      'Hanbi': '한비',
      'Hedetet': '헤데테트',
      'Hrodvitnir': '흐로드비트니르',
      'Huma': '후마',
      'Ice Sprite': '얼음 정령',
      'Ignis Est': '파멸의 화염',
      'Kampe': '캄페',
      'Magitek Development': '마도 연구 구획',
      'Phantom Hashmal': '하쉬말림의 환영',
      'Sartauvoir The Inferno': '쇳불의 사르토부아르',
      'Saunion': '사우니언',
      'Stormborne Zirnitra': '폭풍 지르니트라',
      'Tamed Alkonost(?!\'s Shadow)': '길들여진 알코노스트',
      'Tamed Alkonost\'s Shadow': '길들여진 알코노스트의 그림자',
      'Tamed Carrion Crow': '길들여진 송장까마귀',
      'The Diablo Armament': '디아블로 아머먼트',
      'The fallen ring': '붕괴된 시굴갱',
      'The flagship landing': '기함 정박지',
      'The greater hold': '대형 격납 구획',
      'The loading dock': '반출입 구획',
      'Vermilion Flame': '적열염',
      'Vortical Orb': '바람 마구',
      'Waveborne Zirnitra': '파도 지르니트라'
    },
    'replaceText': {
      '--lasers--': '--레이저--',
      '--line stack--': '--직선 쉐어--',
      '74 Degrees': '물 쏘기',
      'Advanced Death IV': '강화 데스쟈',
      'Advanced Death Ray': '강화 죽음의 광선',
      'Advanced Nox': '강화 암야',
      'Aetheric Boom': '에테르 파동',
      'Aetheric Explosion': '에테르 파열',
      'Aetherochemical Laser': '마과학 레이저',
      'Ambient Pulsation': '마맥류',
      'Analysis': '분석',
      'Anti-Personnel Missile': '대인 미사일 난사',
      'Assault Cannon': '맹공포',
      'Ballistic Impact': '미사일 착탄',
      'Broadside Barrage': '전면 파동',
      'Burgeoning Dread': '공포의 파동',
      'Burn(?!ing)': '연소',
      'Burning Blade': '불타는 검',
      'Deadly Dealing': '죽음의 타격',
      'Diabolic Gate': '이계의 문',
      'Double Cast': '이중 마술',
      '(?<!Aetheric )Explosion': '폭발',
      'Fell Flow': '혼탁한 급류',
      'Fire Brand': '염제 십자',
      'Flamedive': '화염 돌진',
      'Flaming Cyclone': '불꽃 회오리',
      'Fleshy Necromass': '부정 압살',
      'Foreshadowing': '그림자 날갯짓',
      'Frigid Pulse': '냉랭한 고동',
      'Ghastly Aura': '상실의 파동',
      'Grand Crossflame': '십자 불꽃',
      'High-Powered Magitek Ray': '고출력 마도 레이저',
      'Hyperpyroplexy': '극강 불꽃 분화',
      'Ignis Est': '파멸의 화염',
      'Immolate': '대연소',
      'Left Brand': '왼쪽 불꽃검',
      'Light Pseudopillar': '마과학식 빛 기둥',
      'Magitek Bit': '비트 사출',
      'Magitek Crossray': '마도 십자 레이저',
      'Magitek Halo': '마도 원형 레이저',
      'Mannatheihwon Flame': '만토바의 불꽃',
      'Might Of Malice': '육중한 발차기',
      'Missile Command': '미사일 전탄 발사',
      'Missile Salvo': '연발 미사일',
      'Mobile Crossray': '이동식 십자 레이저',
      'Mobile Halo': '이동식 원형 레이저',
      'Necrotic Billow': '부패 소살',
      'Nihility\'s Song': '허무의 노래',
      'North Wind': '북풍',
      'Obey': '명령 따르기',
      '(?<!Verd)Orb': '구슬',
      'Pain Storm': '고통의 폭풍',
      'Painful Gust': '고통의 돌풍',
      'Pentagust': '다섯 갈래 돌풍',
      'Phenex': '페넥스',
      'Pillar Of Shamash': '샤마쉬의 기둥',
      'Putrified Soul': '오염파',
      'Pyrocrisis': '불꽃 사태',
      'Pyrodoxy': '불꽃 이론',
      'Pyrokinesis': '불꽃 염동력',
      '(?<![-r])Pyroplexy': '불꽃 분화',
      'Raw Heat': '폭염파',
      'Read Orders: Field Support': '작전 지시: 보병 지원',
      'Reverse Time Eruption': '뒤바뀐 시간의 불기둥',
      'Right Brand': '오른쪽 불꽃검',
      'Ruinous Pseudomen': '마과학식 재앙의 전조',
      'Sanctified Quake III': '축성의 퀘이가',
      'South Wind': '남풍',
      'Spiral Scourge': '회전 채찍질',
      'Stormborne Zirnitra': '폭풍 지르니트라',
      'Stormcall': '폭풍 부르기',
      'Suppressive Magitek Rays': '전방위 마도 레이저',
      'Surface Missile': '대지 미사일',
      'Swooping Frenzy': '광란의 급강하',
      'Terminus Est': '파멸의 종착역',
      'Thermal Gust': '뜨거운 돌풍',
      '(?<!Reverse )Time Eruption': '시간의 불기둥',
      'Tooth And Talon': '마수왕 열조격',
      'Touchdown': '착지',
      'Turbine': '터빈',
      'Ultimate Pseudoterror': '마과학식 궁극의 공포',
      'Void Call': '사역마 소환',
      'Void Systems Overload': 'V기관 폭주',
      'Wildfire Winds': '염제 남익파'
    }
  }]
};
/* harmony default export */ const zadnor = (zadnor_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/eureka/zadnor.txt
const eureka_zadnor_namespaceObject = "### Zadnor\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n\r\n# Use zone-unseal and 0x21 Reset lines\r\n# Trigger set contains 'resetWhenOutOfCombat: false'\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"80000014\", data0: \"00\" } window 0,100000 jump 0\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n# TODO: fill in CEs\r\n# The idea with each of them is that you have at most two minutes of standing\r\n# around, so start each timeline at +200 from the initial 0x21 sync line.\r\n# e.g. On Serpents' Wings would start at 1200 with \"Start\" and then boss\r\n# abilities from there.\r\n\r\n### On Serpents' Wings\r\n1000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"211\" } window 100000,0\r\n\r\n### Feeling the Burn\r\n2000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"20E\" } window 100000,0\r\n\r\n### The Broken Blade\r\n3000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"21F\" } window 100000,0\r\n\r\n### From Beyond the Grave\r\n4000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"21B\" } window 100000,0\r\n\r\n### With Diremite and Main\r\n5000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"221\" } window 100000,0\r\n\r\n### Here Comes the Cavalry\r\n6000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"21C\" } window 100000,0\r\n\r\n### Head of the Snake\r\n7000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"21E\" } window 100000,0\r\n\r\n### There Would Be Blood\r\n8000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"210\" } window 100000,0\r\n\r\n### Never Cry Wolf\r\n9000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"20F\" } window 100000,0\r\n\r\n### Time To Burn\r\n10000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"21D\" } window 100000,0\r\n\r\n### Lean, Mean, Magitek Machines\r\n11000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"218\" } window 100000,0\r\n\r\n### Worn to a Shadow\r\n12000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"222\" } window 100000,0\r\n\r\n### A Familiar Face\r\n13000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"212\" } window 100000,0\r\n\r\n### Looks to Die For\r\n14000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"207\" } window 100000,0\r\n\r\n### Taking the Lyon's Share\r\n15000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"220\" } window 100000,0\r\n\r\n### The Dalriada\r\n#20000.0 \"--sync--\" ActorControl { command: \"80000014\", data0: \"213\" } window 100000,0\r\n\r\n### Sartauvoir (up)\r\n# Note: can't sync to the zone closing here, as you (of course) can see the\r\n# zone closing message (but nothing else) from both up and down locations.\r\n#\r\n# Note Named the second \"Mannatheihwon Flame\" as \"Ignis Est\" as that's the\r\n# add name, and it's similar to Varis Extreme.\r\n#\r\n# -p 5E7C:21016 5E7E:21300\r\n# -ii 61BE 5E7D 5E75 5E88 5E8A 5E79 5E7B\r\n# Loading Dock will be sealed off\r\n#21000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E5C\" } window 100000,0\r\n21016.0 \"Pyrokinesis\" Ability { id: \"5E7C\", source: \"Sartauvoir The Inferno\" } window 100000,0\r\n21028.2 \"--sync--\" Ability { id: \"5E6C\", source: \"Sartauvoir The Inferno\" }\r\n21034.3 \"Time Eruption 1\" Ability { id: \"5E6E\", source: \"Sartauvoir The Inferno\" }\r\n21036.3 \"Time Eruption 2\" Ability { id: \"5E6F\", source: \"Sartauvoir The Inferno\" }\r\n21045.4 \"Phenex\" Ability { id: \"5E72\", source: \"Sartauvoir The Inferno\" }\r\n21053.6 \"Thermal Gust\" Ability { id: \"5E74\", source: \"Sartauvoir The Inferno\" }\r\n21057.6 \"Flamedive\" Ability { id: \"5E73\", source: \"Huma\" }\r\n# This can push.\r\n21059.8 \"--sync--\" StartsUsing { id: \"5E6D\", source: \"Sartauvoir The Inferno\" } window 70,10\r\n21066.8 \"--sync--\" Ability { id: \"5E6D\", source: \"Sartauvoir The Inferno\" }\r\n21072.9 \"Reverse Time Eruption 1\" Ability { id: \"5E71\", source: \"Sartauvoir The Inferno\" }\r\n21074.9 \"Reverse Time Eruption 2\" Ability { id: \"5E70\", source: \"Sartauvoir The Inferno\" }\r\n# This too?\r\n21078.0 \"--sync--\" StartsUsing { id: \"5E7C\", source: \"Sartauvoir The Inferno\" } window 80,10\r\n21083.0 \"Pyrokinesis\" Ability { id: \"5E7C\", source: \"Sartauvoir The Inferno\" }\r\n21091.2 \"Hyperpyroplexy\" Ability { id: \"5E76\", source: \"Sartauvoir The Inferno\" }\r\n21101.4 \"Pyroplexy\" Ability { id: \"5E77\", source: \"Sartauvoir The Inferno\" }\r\n21106.7 \"Grand Crossflame\" Ability { id: \"5E7A\", source: \"Sartauvoir The Inferno\" }\r\n# ???\r\n\r\n# transformation (hp% push)\r\n21300.0 \"--sync--\" Ability { id: \"5E7E\", source: \"Sartauvoir The Inferno\" } window 300,0\r\n21306.1 \"Burn\" Ability { id: \"5E7F\", source: \"Sartauvoir The Inferno\" }\r\n21311.1 \"Burn\" Ability { id: \"5E7F\", source: \"Sartauvoir The Inferno\" }\r\n21316.1 \"Immolate\" Ability { id: \"5E80\", source: \"Sartauvoir The Inferno\" }\r\n21319.1 \"--sync--\" Ability { id: \"5E81\", source: \"Sartauvoir The Inferno\" }\r\n21334.6 \"Burning Blade\" Ability { id: \"5E90\", source: \"Sartauvoir The Inferno\" }\r\n21343.9 \"Mannatheihwon Flame\" Ability { id: \"5E87\", source: \"Sartauvoir The Inferno\" }\r\n21356.8 \"Ignis Est\" Ability { id: \"5E89\", source: \"Ignis Est\" }\r\n21366.2 \"Left Brand/Right Brand\" Ability { id: \"5E8[BC]\", source: \"Sartauvoir The Inferno\" }\r\n21374.5 \"Double Cast\" Ability { id: \"5E8D\", source: \"Sartauvoir The Inferno\" }\r\n21382.6 \"Pyrodoxy\" Ability { id: \"5E8E\", source: \"Sartauvoir The Inferno\" }\r\n21382.6 \"Pyrocrisis\" Ability { id: \"5E8F\", source: \"Sartauvoir The Inferno\" }\r\n21389.9 \"Left Brand/Right Brand\" Ability { id: \"5E8[BC]\", source: \"Sartauvoir The Inferno\" }\r\n21398.3 \"Phenex\" Ability { id: \"5E85\", source: \"Sartauvoir The Inferno\" }\r\n21408.6 \"Time Eruption/Reverse Time Eruption\" Ability { id: \"5E8[34]\", source: \"Sartauvoir The Inferno\" }\r\n21411.6 \"Flamedive\" Ability { id: \"5E73\", source: \"Huma\" }\r\n21415.9 \"Time Eruption 1\" Ability { id: [\"5E6E\", \"5E71\"], source: \"Sartauvoir The Inferno\" }\r\n21417.9 \"Time Eruption 2\" Ability { id: [\"5E6F\", \"5E70\"], source: \"Sartauvoir The Inferno\" }\r\n21425.9 \"Pyrokinesis\" Ability { id: \"5E82\", source: \"Sartauvoir The Inferno\" }\r\n21437.3 \"Hyperpyroplexy\" Ability { id: \"5E86\", source: \"Sartauvoir The Inferno\" }\r\n# ???\r\n\r\n\r\n### Blackburn / Augur / Alkonost / Carrion Crow (down)\r\n# -ic \"Fran\" \"Llofii The Forthright\" \"Meryall Of The Crimson Flame\" \"Tsubame Sunrise\" \"Oboro Moonrise\"\r\n# -p 5F12:22016 5F1F:22305 5F26:22512\r\n# -ii 6226 6227 6228 6229 5F13 5F1D 5F20 5F15 5F1C 5F29 5F31\r\n\r\n# Flagship Landing will be sealed off\r\n#22000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E5B\" } window 100000,0\r\n\r\n# Blackburn\r\n22011.0 \"--sync--\" StartsUsing { id: \"5F12\", source: \"4Th Legion Blackburn\" } window 100000,0\r\n22016.0 \"Suppressive Magitek Rays\" Ability { id: \"5F12\", source: \"4Th Legion Blackburn\" }\r\n22031.7 \"Anti-Personnel Missile\" Ability { id: \"5F0D\", source: \"4Th Legion Blackburn\" }\r\n22033.8 \"Ballistic Impact 1\" #Ability { id: \"5F0E\", source: \"4Th Legion Blackburn\" }\r\n22036.8 \"Ballistic Impact 2\" #Ability { id: \"5F0E\", source: \"4Th Legion Blackburn\" }\r\n22039.8 \"Ballistic Impact 3\" #Ability { id: \"5F0E\", source: \"4Th Legion Blackburn\" }\r\n22047.9 \"Read Orders: Field Support\" Ability { id: \"5F0C\", source: \"4Th Legion Blackburn\" }\r\n22054.6 \"Terminus Est\" #Ability { id: \"5F03\", source: \"4Th Legion Infantry\" }\r\n22057.6 \"Analysis\" Ability { id: \"5F0F\", source: \"4Th Legion Blackburn\" } window 10,10\r\n22064.7 \"Terminus Est\" #Ability { id: \"5F07\", source: \"Terminus Est\" }\r\n22073.2 \"Suppressive Magitek Rays\" Ability { id: \"5F12\", source: \"4Th Legion Blackburn\" }\r\n22083.4 \"Surface Missile\" Ability { id: \"5F10\", source: \"4Th Legion Blackburn\" }\r\n22089.5 \"Surface Missile\" Ability { id: \"5F11\", source: \"4Th Legion Blackburn\" }\r\n# ???\r\n\r\n# Augur\r\n# this cast starts almost immediately after the Augur apperas\r\n22300.0 \"--sync--\" StartsUsing { id: \"5F1F\", source: \"4Th Legion Augur\" } window 300,0\r\n22305.0 \"Sanctified Quake III\" Ability { id: \"5F1F\", source: \"4Th Legion Augur\" }\r\n22313.2 \"Void Call\" Ability { id: \"5F1E\", source: \"4Th Legion Augur\" }\r\n22325.5 \"Turbine\" Ability { id: \"5F14\", source: \"Flameborne Zirnitra\" }\r\n22328.0 \"Flaming Cyclone\" Ability { id: \"5F19\", source: \"Stormborne Zirnitra\" }\r\n22328.6 \"74 Degrees\" Ability { id: \"5F17\", source: \"Waveborne Zirnitra\" }\r\n22332.5 \"Pyroplexy\" Ability { id: \"5F1B\", source: \"4Th Legion Augur\" }\r\n22358.7 \"Sanctified Quake III\" Ability { id: \"5F1F\", source: \"4Th Legion Augur\" }\r\n# ???\r\n\r\n# Tamed Alkonost / Tamed Carrion Crow\r\n22500.0 \"--sync--\" AddedCombatant { name: \"Tamed Carrion Crow\" } window 600,0\r\n22507.0 \"--sync--\" StartsUsing { id: \"5F26\", source: \"Tamed Alkonost\" } window 600,10\r\n22512.0 \"Stormcall\" Ability { id: \"5F26\", source: \"Tamed Alkonost\" }\r\n22526.9 \"Orb 1\" Ability { id: \"5F27\", source: \"Vortical Orb\" }\r\n22526.9 \"North Wind/South Wind\" Ability { id: \"5F2[12]\", source: \"Tamed Carrion Crow\" }\r\n22527.0 \"--sync--\" Ability { id: \"5F23\", source: \"Tamed Carrion Crow\" }\r\n22527.6 \"--knockback--\" Ability { id: \"60E[EF]\", source: \"Tamed Carrion Crow\" }\r\n22534.0 \"Orb 2\" Ability { id: \"5F27\", source: \"Vortical Orb\" }\r\n22548.7 \"Painful Gust/Pain Storm\" Ability { id: \"5F2[BC]\", source: \"Tamed Alkonost\" }\r\n22557.8 \"Frigid Pulse\" Ability { id: \"5F2A\", source: \"Tamed Alkonost\" }\r\n22568.2 \"North Wind/South Wind\" Ability { id: \"5F2[12]\", source: \"Tamed Carrion Crow\" }\r\n22568.3 \"--sync--\" Ability { id: \"5F23\", source: \"Tamed Carrion Crow\" }\r\n22568.9 \"--knockback--\" Ability { id: \"60E[EF]\", source: \"Tamed Carrion Crow\" }\r\n22572.9 \"Foreshadowing\" Ability { id: \"5F30\", source: \"Tamed Alkonost\" }\r\n22572.9 \"Painful Gust/Pain Storm\" Ability { id: \"5F2[EF]\", source: \"Tamed Alkonost's Shadow\" }\r\n22572.9 \"Frigid Pulse\" Ability { id: \"5F2D\", source: \"Tamed Alkonost's Shadow\" }\r\n\r\n22586.1 \"Nihility's Song\" Ability { id: \"5F28\", source: \"Tamed Alkonost\" }\r\n22597.8 \"Broadside Barrage\" Ability { id: \"5F25\", source: \"Tamed Carrion Crow\" }\r\n22605.7 \"Painful Gust\" Ability { id: \"5F2C\", source: \"Tamed Alkonost\" }\r\n22612.8 \"Nihility's Song\" Ability { id: \"5F28\", source: \"Tamed Alkonost\" }\r\n22613.1 \"Broadside Barrage\" Ability { id: \"5F25\", source: \"Tamed Carrion Crow\" }\r\n22613.4 \"Nihility's Song\" Ability { id: \"5F29\", source: \"Tamed Alkonost\" }\r\n22629.0 \"Frigid Pulse\" Ability { id: \"5F2A\", source: \"Tamed Alkonost\" }\r\n22635.5 \"Broadside Barrage\" Ability { id: \"5F25\", source: \"Tamed Carrion Crow\" }\r\n# ???\r\n\r\n\r\n### Cuchulainn\r\n# -p 5C8F:23013.3\r\n# -ii 5C89 5C90 5C83 5C84 5C85 6179 614E 5C8C 5C87\r\n# Magitek Development will be sealed off\r\n23000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E5E\" } window 100000,0\r\n23013.3 \"Putrified Soul\" Ability { id: \"5C8F\", source: \"4Th-Make Cuchulainn\" }\r\n23022.4 \"Burgeoning Dread\" Ability { id: \"5C88\", source: \"4Th-Make Cuchulainn\" }\r\n23043.7 \"Putrified Soul\" Ability { id: \"5C8F\", source: \"4Th-Make Cuchulainn\" }\r\n23055.9 \"Fleshy Necromass\" Ability { id: \"5C82\", source: \"4Th-Make Cuchulainn\" } duration 8.7\r\n23082.7 \"Necrotic Billow\" Ability { id: \"5C86\", source: \"4Th-Make Cuchulainn\" } duration 8.7\r\n23099.9 \"--sync--\" Ability { id: \"5C8D\", source: \"4Th-Make Cuchulainn\" }\r\n23108.7 \"Ambient Pulsation 1\" #Ability { id: \"5C8E\", source: \"4Th-Make Cuchulainn\" }\r\n23110.2 \"Ambient Pulsation 2\" #Ability { id: \"5C8E\", source: \"4Th-Make Cuchulainn\" }\r\n23111.7 \"Ambient Pulsation 3\" #Ability { id: \"5C8E\", source: \"4Th-Make Cuchulainn\" }\r\n\r\n23126.1 \"Might Of Malice\" Ability { id: \"5C92\", source: \"4Th-Make Cuchulainn\" }\r\n23140.2 \"Necrotic Billow?\" Ability { id: \"5C86\", source: \"4Th-Make Cuchulainn\" }\r\n23143.3 \"Fleshy Necromass?\" Ability { id: \"5C82\", source: \"4Th-Make Cuchulainn\" }\r\n# this timing can be 8 seconds earlier if it's Billow instead of Necromass.\r\n23163.2 \"--sync--\" StartsUsing { id: \"5C88\", source: \"4Th-Make Cuchulainn\" } window 20,20\r\n23168.2 \"Burgeoning Dread\" Ability { id: \"5C88\", source: \"4Th-Make Cuchulainn\" }\r\n\r\n23179.3 \"--sync--\" Ability { id: \"5C8D\", source: \"4Th-Make Cuchulainn\" }\r\n23188.1 \"Ambient Pulsation 1\" #Ability { id: \"5C8E\", source: \"4Th-Make Cuchulainn\" }\r\n23189.6 \"Ambient Pulsation 2\" #Ability { id: \"5C8E\", source: \"4Th-Make Cuchulainn\" }\r\n23191.1 \"Ambient Pulsation 3\" #Ability { id: \"5C8E\", source: \"4Th-Make Cuchulainn\" }\r\n23195.5 \"Might Of Malice\" Ability { id: \"5C92\", source: \"4Th-Make Cuchulainn\" }\r\n23210.6 \"Putrified Soul\" Ability { id: \"5C8F\", source: \"4Th-Make Cuchulainn\" }\r\n\r\n23217.7 \"Ghastly Aura\" Ability { id: \"614D\", source: \"4Th-Make Cuchulainn\" }\r\n23226.8 \"Necrotic Billow?\" Ability { id: \"5C86\", source: \"4Th-Make Cuchulainn\" }\r\n23230.9 \"Fleshy Necromass?\" Ability { id: \"5C82\", source: \"4Th-Make Cuchulainn\" }\r\n# this timing can be 8 seconds earlier if it's Billow instead of Necromass.\r\n23249.1 \"--sync--\" StartsUsing { id: \"5C8B\", source: \"4Th-Make Cuchulainn\" } window 20,5\r\n23254.1 \"Fell Flow 1\" Ability { id: \"5C8B\", source: \"4Th-Make Cuchulainn\" }\r\n23261.4 \"Fell Flow 2\" Ability { id: \"5C8B\", source: \"4Th-Make Cuchulainn\" }\r\n23275.6 \"Burgeoning Dread\" Ability { id: \"5C88\", source: \"4Th-Make Cuchulainn\" }\r\n\r\n# TODO: is this a loop??? guessing it goes back to the previous burgeoning+ambient\r\n23286.7 \"--sync--\" Ability { id: \"5C8D\", source: \"4Th-Make Cuchulainn\" } window 30,30 jump 23179.3\r\n23295.5 \"Ambient Pulsation 1\" #Ability { id: \"5C8E\", source: \"4Th-Make Cuchulainn\" }\r\n23297.0 \"Ambient Pulsation 2\" #Ability { id: \"5C8E\", source: \"4Th-Make Cuchulainn\" }\r\n23298.5 \"Ambient Pulsation 3\" #Ability { id: \"5C8E\", source: \"4Th-Make Cuchulainn\" }\r\n23303.0 \"Might Of Malice\" Ability { id: \"5C92\", source: \"4Th-Make Cuchulainn\" }\r\n\r\n\r\n### Saunion & Dawon\r\n# -p 5DC5:24022.9 5DC6:24306\r\n# -it \"Saunion\"\r\n# -ii 5DB6 5DB8 6150 5DC7 60C4 5DCF 5DB3 5DD2 61E4 61E5\r\n# The Greater Hold will be sealed off\r\n24000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E60\" } window 100000,0\r\n24011.7 \"Magitek Halo/Magitek Crossray\" Ability { id: \"5DB[57]\", source: \"Saunion\" }\r\n24022.9 \"High-Powered Magitek Ray\" Ability { id: \"5DC5\", source: \"Saunion\" }\r\n24034.1 \"Magitek Crossray/Magitek Halo\" Ability { id: \"5DB[57]\", source: \"Saunion\" }\r\n24040.3 \"--sync--\" Ability { id: \"5DD7\", source: \"Saunion\" }\r\n24050.5 \"Mobile Halo/Mobile Crossray\" Ability { id: [\"5DB[9ABCDEF]\", \"5DC0\"], source: \"Saunion\" }\r\n24063.7 \"Missile Command\" Ability { id: \"5DC1\", source: \"Saunion\" }\r\n24069.9 \"Surface Missile\" Ability { id: \"5DC4\", source: \"Saunion\" }\r\n24069.9 \"Anti-Personnel Missile\" Ability { id: \"5DC2\", source: \"Saunion\" }\r\n24074.9 \"Missile Salvo\" Ability { id: \"5DC3\", source: \"Saunion\" }\r\n24078.9 \"--sync--\" Ability { id: \"5DD7\", source: \"Saunion\" }\r\n24089.0 \"Mobile Crossray/Mobile Halo\" Ability { id: [\"5DB[9ABCDEF]\", \"5DC0\"], source: \"Saunion\" }\r\n24099.8 \"--sync--\" Ability { id: \"5DD7\", source: \"Saunion\" }\r\n# ?\r\n\r\n24300.0 \"--sync--\" StartsUsing { id: \"5DC6\", source: \"Dawon The Younger\" } window 300,0\r\n24306.0 \"Touchdown\" Ability { id: \"5DC6\", source: \"Dawon The Younger\" }\r\n24323.3 \"--targetable--\"\r\n24342.5 \"--sync--\" Ability { id: \"5DD7\", source: \"Saunion\" }\r\n24348.5 \"Wildfire Winds\" Ability { id: \"5DCD\", source: \"Dawon The Younger\" }\r\n24352.5 \"Mobile Halo/Mobile Crossray\" Ability { id: [\"5DB[9ABCDEF]\", \"5DC0\"], source: \"Saunion\" }\r\n24361.2 \"Raw Heat\" Ability { id: \"5DCE\", source: \"Vermilion Flame\" }\r\n24362.7 \"Missile Command\" Ability { id: \"5DC1\", source: \"Saunion\" }\r\n24368.9 \"Surface Missile\" Ability { id: \"5DC4\", source: \"Saunion\" }\r\n24368.9 \"Anti-Personnel Missile\" Ability { id: \"5DC2\", source: \"Saunion\" }\r\n24372.1 \"Swooping Frenzy\" Ability { id: \"5DD0\", source: \"Dawon The Younger\" }\r\n24373.9 \"Missile Salvo\" Ability { id: \"5DC3\", source: \"Saunion\" }\r\n24380.2 \"Frigid Pulse\" Ability { id: \"607D\", source: \"Dawon The Younger\" }\r\n24402.5 \"--sync--\" Ability { id: \"5DD7\", source: \"Saunion\" }\r\n\r\n# spiral scourge + obey\r\n24412.1 \"Spiral Scourge\" Ability { id: \"5DB2\", source: \"Saunion\" } duration 20.5\r\n24412.1 \"--untargetable--\"\r\n24413.4 \"Obey\" Ability { id: \"5DC9\", source: \"Dawon The Younger\" }\r\n24415.5 \"Swooping Frenzy 1\" Ability { id: \"5DCA\", source: \"Dawon The Younger\" }\r\n24418.6 \"Frigid Pulse/Fire Brand\" Ability { id: \"5DC[BC]\", source: \"Dawon The Younger\" }\r\n24421.9 \"Swooping Frenzy 2\" Ability { id: \"5DCA\", source: \"Dawon The Younger\" }\r\n24425.0 \"Frigid Pulse/Fire Brand\" Ability { id: \"5DC[BC]\", source: \"Dawon The Younger\" }\r\n24428.4 \"Swooping Frenzy 3\" Ability { id: \"5DCA\", source: \"Dawon The Younger\" }\r\n24431.5 \"Frigid Pulse/Fire Brand\" Ability { id: \"5DC[BC]\", source: \"Dawon The Younger\" }\r\n24432.2 \"--sync--\" Ability { id: \"5DB4\", source: \"Saunion\" }\r\n24432.2 \"--targetable--\"\r\n24450.0 \"Swooping Frenzy\" Ability { id: \"5DD0\", source: \"Dawon The Younger\" }\r\n24452.2 \"Missile Command\" Ability { id: \"5DC1\", source: \"Saunion\" }\r\n24458.1 \"Pentagust\" Ability { id: \"5DD1\", source: \"Dawon The Younger\" }\r\n24458.4 \"Surface Missile\" Ability { id: \"5DC4\", source: \"Saunion\" }\r\n24458.4 \"Anti-Personnel Missile\" Ability { id: \"5DC2\", source: \"Saunion\" }\r\n24463.4 \"Missile Salvo\" Ability { id: \"5DC3\", source: \"Saunion\" }\r\n24479.9 \"Tooth And Talon\" Ability { id: \"5DD4\", source: \"Dawon The Younger\" }\r\n24479.9 \"High-Powered Magitek Ray\" Ability { id: \"5DC5\", source: \"Saunion\" }\r\n24500.4 \"--sync--\" Ability { id: \"5DD7\", source: \"Saunion\" }\r\n24501.3 \"Wildfire Winds 1\" Ability { id: \"5DCD\", source: \"Dawon The Younger\" }\r\n\r\n# spiral scourge + wildfire winds\r\n24510.1 \"Spiral Scourge\" Ability { id: \"5DB2\", source: \"Saunion\" } duration 20.5\r\n24510.1 \"--untargetable--\"\r\n24514.1 \"Raw Heat 1\" Ability { id: \"5DCE\", source: \"Vermilion Flame\" }\r\n24516.5 \"Wildfire Winds 2\" Ability { id: \"5DCD\", source: \"Dawon The Younger\" }\r\n24529.3 \"Raw Heat 2\" Ability { id: \"5DCE\", source: \"Vermilion Flame\" }\r\n24530.1 \"--sync--\" Ability { id: \"5DB4\", source: \"Saunion\" }\r\n24530.1 \"--targetable--\"\r\n24549.9 \"--sync--\" Ability { id: \"5DD7\", source: \"Saunion\" }\r\n24555.8 \"Wildfire Winds\" Ability { id: \"5DCD\", source: \"Dawon The Younger\" }\r\n24559.9 \"Mobile Crossray/Mobile Halo\" Ability { id: [\"5DB[9ABCDEF]\", \"5DC0\"], source: \"Saunion\" }\r\n24568.6 \"Raw Heat\" Ability { id: \"5DCE\", source: \"Vermilion Flame\" }\r\n24570.1 \"Missile Command\" Ability { id: \"5DC1\", source: \"Saunion\" }\r\n24576.3 \"Surface Missile\" Ability { id: \"5DC4\", source: \"Saunion\" }\r\n24576.3 \"Anti-Personnel Missile\" Ability { id: \"5DC2\", source: \"Saunion\" }\r\n24579.5 \"Swooping Frenzy\" Ability { id: \"5DD0\", source: \"Dawon The Younger\" }\r\n24581.3 \"Missile Salvo\" Ability { id: \"5DC3\", source: \"Saunion\" }\r\n24587.6 \"Frigid Pulse\" Ability { id: \"607D\", source: \"Dawon The Younger\" }\r\n24609.7 \"--sync--\" Ability { id: \"5DD7\", source: \"Saunion\" }\r\n\r\n# loop\r\n24619.2 \"Spiral Scourge\" Ability { id: \"5DB2\", source: \"Saunion\" } window 50,50 jump 24412.1\r\n24619.2 \"--untargetable--\"\r\n24620.5 \"Obey\" #Ability { id: \"5DC9\", source: \"Dawon The Younger\" }\r\n24622.6 \"Swooping Frenzy 1\" #Ability { id: \"5DCA\", source: \"Dawon The Younger\" }\r\n24625.7 \"Frigid Pulse/Fire Brand\" #Ability { id: \"5DC{BC]}\", source: \"Dawon The Younger\" }\r\n24629.0 \"Swooping Frenzy 2\" #Ability { id: \"5DCA\", source: \"Dawon The Younger\" }\r\n24632.1 \"Frigid Pulse/Fire Brand\" #Ability { id: \"5DC[BC]\", source: \"Dawon The Younger\" }\r\n24635.5 \"Swooping Frenzy 3\" #Ability { id: \"5DCA\", source: \"Dawon The Younger\" }\r\n24638.6 \"Frigid Pulse/Fire Brand\" #Ability { id: \"5DC[BC]\", source: \"Dawon The Younger\" }\r\n24639.3 \"--sync--\" #Ability { id: \"5DB4\", source: \"Saunion\" }\r\n24639.3 \"--targetable--\"\r\n\r\n# TODO: not enough data for what happens when one of them dies?\r\n# Saunion seems to go back to first phase halo/crossray? Not sure about Dawon.\r\n\r\n\r\n### The Diablo Armament\r\n# -p 5CC6:25013 5CB7:25805\r\n# -ii 6143 61A2 5CC7 61C4 5CB2 5CB8 5CC5 6092 6091 6093 5CC3 5CB4 5CB5 5CC1 5CAD 5CA1 5CA2\r\n# The Fallen Ring will be sealed off\r\n25000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E61\" } window 100000,0\r\n25013.0 \"Aetheric Explosion\" Ability { id: \"5CC6\", source: \"The Diablo Armament\" }\r\n25023.4 \"Aetherochemical Laser 1\" Ability { id: \"5CA[45]\", source: \"The Diablo Armament\" }\r\n25027.5 \"Aetherochemical Laser 2\" Ability { id: \"5CA[45]\", source: \"The Diablo Armament\" }\r\n25034.5 \"Explosion 1\" Ability { id: \"5CA[67]\", source: \"The Diablo Armament\" }\r\n25036.6 \"Explosion 2\" Ability { id: \"5CA[89]\", source: \"The Diablo Armament\" }\r\n25046.0 \"Advanced Death Ray\" Ability { id: \"5CC4\", source: \"The Diablo Armament\" }\r\n25057.3 \"Aetheric Explosion\" Ability { id: \"5CC6\", source: \"The Diablo Armament\" }\r\n\r\n# If you are in a cutscene and don't make it down in time, you miss the zone seal.\r\n# Add one extra \"really big\" sync a little bit in.\r\n25068.6 \"Diabolic Gate\" Ability { id: \"5C9F\", source: \"The Diablo Armament\" } window 100000,100\r\n25091.1 \"--sync--\" Ability { id: \"5CA0\", source: \"The Diablo Armament\" }\r\n25092.7 \"Ruinous Pseudomen 1\" Ability { id: \"61A3\", source: \"The Diablo Armament\" }\r\n25096.7 \"Ruinous Pseudomen 2\" #Ability { id: \"614C\", source: \"The Diablo Armament\" }\r\n25099.7 \"Ruinous Pseudomen 3\" #Ability { id: \"614C\", source: \"The Diablo Armament\" }\r\n25104.0 \"Ruinous Pseudomen 4\" Ability { id: \"614F\", source: \"The Diablo Armament\" }\r\n25111.0 \"Ultimate Pseudoterror\" Ability { id: \"5CA3\", source: \"The Diablo Armament\" }\r\n\r\n25125.4 \"Aetheric Explosion\" Ability { id: \"5CC6\", source: \"The Diablo Armament\" }\r\n25139.8 \"Advanced Death Ray\" Ability { id: \"5CC4\", source: \"The Diablo Armament\" }\r\n25147.0 \"Magitek Bit\" Ability { id: \"5CAC\", source: \"The Diablo Armament\" }\r\n25161.5 \"Assault Cannon\" Ability { id: \"5CAE\", source: \"Diabolic Bit\" }\r\n25163.4 \"Aetheric Explosion\" Ability { id: \"5CC6\", source: \"The Diablo Armament\" }\r\n25175.7 \"--sync--\" Ability { id: \"5CAF\", source: \"The Diablo Armament\" }\r\n25183.8 \"Advanced Death IV\" Ability { id: \"5CB0\", source: \"The Diablo Armament\" }\r\n25190.8 \"Advanced Death IV\" Ability { id: \"5CB0\", source: \"The Diablo Armament\" }\r\n25196.5 \"Light Pseudopillar\" Ability { id: \"5CB1\", source: \"The Diablo Armament\" } duration 2.5\r\n25203.6 \"Advanced Death Ray\" Ability { id: \"5CC4\", source: \"The Diablo Armament\" }\r\n25209.9 \"Aetherochemical Laser 1\" Ability { id: \"5CA[45]\", source: \"The Diablo Armament\" }\r\n25214.0 \"Aetherochemical Laser 2\" Ability { id: \"5CA[45]\", source: \"The Diablo Armament\" }\r\n25219.5 \"Aetherochemical Laser 3\" Ability { id: \"5CA[45]\", source: \"The Diablo Armament\" }\r\n25221.0 \"Explosion 1\" Ability { id: \"5CA[67]\", source: \"The Diablo Armament\" }\r\n25223.1 \"Explosion 2\" Ability { id: \"5CA[89]\", source: \"The Diablo Armament\" }\r\n25226.6 \"Explosion 3\" Ability { id: \"5CA[AB]\", source: \"The Diablo Armament\" }\r\n25242.2 \"Aetheric Boom\" Ability { id: \"5CB3\", source: \"The Diablo Armament\" }\r\n\r\n25265.0 \"Diabolic Gate\" Ability { id: \"5C9F\", source: \"The Diablo Armament\" } window 100,100\r\n25287.5 \"--sync--\" Ability { id: \"5CA0\", source: \"The Diablo Armament\" }\r\n25289.1 \"Ruinous Pseudomen 1\" Ability { id: \"61A3\", source: \"The Diablo Armament\" }\r\n25293.1 \"Ruinous Pseudomen 2\" #Ability { id: \"614C\", source: \"The Diablo Armament\" }\r\n25296.1 \"Ruinous Pseudomen 3\" #Ability { id: \"614C\", source: \"The Diablo Armament\" }\r\n25300.3 \"Ruinous Pseudomen 4\" Ability { id: \"614F\", source: \"The Diablo Armament\" }\r\n25307.4 \"Ultimate Pseudoterror\" Ability { id: \"5CA3\", source: \"The Diablo Armament\" }\r\n\r\n25321.8 \"Aetheric Explosion\" Ability { id: \"5CC6\", source: \"The Diablo Armament\" }\r\n25327.9 \"--sync--\" Ability { id: \"5CAF\", source: \"The Diablo Armament\" }\r\n25336.0 \"Advanced Death IV\" Ability { id: \"5CB0\", source: \"The Diablo Armament\" }\r\n25344.0 \"Advanced Death IV\" Ability { id: \"5CB0\", source: \"The Diablo Armament\" }\r\n25346.6 \"Magitek Bit\" Ability { id: \"5CAC\", source: \"The Diablo Armament\" }\r\n25353.8 \"Aetherochemical Laser 1\" Ability { id: \"5CA[45]\", source: \"The Diablo Armament\" }\r\n25357.9 \"Aetherochemical Laser 2\" Ability { id: \"5CA[45]\", source: \"The Diablo Armament\" }\r\n25361.3 \"Assault Cannon\" Ability { id: \"5CAE\", source: \"Diabolic Bit\" }\r\n25364.8 \"Explosion 1\" Ability { id: \"5CA[67]\", source: \"The Diablo Armament\" }\r\n25366.9 \"Explosion 2\" Ability { id: \"5CA[89]\", source: \"The Diablo Armament\" }\r\n25373.1 \"Assault Cannon\" Ability { id: \"5CAE\", source: \"Diabolic Bit\" }\r\n25380.4 \"Deadly Dealing\" Ability { id: \"5CC2\", source: \"The Diablo Armament\" }\r\n25384.6 \"Assault Cannon\" Ability { id: \"5CAE\", source: \"Diabolic Bit\" }\r\n25397.9 \"Aetheric Explosion\" Ability { id: \"5CC6\", source: \"The Diablo Armament\" }\r\n25404.1 \"Light Pseudopillar\" Ability { id: \"5CB1\", source: \"The Diablo Armament\" } duration 2.5\r\n\r\n25407.3 \"Aetherochemical Laser 1\" Ability { id: \"5CA[45]\", source: \"The Diablo Armament\" }\r\n25411.4 \"Aetherochemical Laser 2\" Ability { id: \"5CA[45]\", source: \"The Diablo Armament\" }\r\n25416.9 \"Aetherochemical Laser 3\" Ability { id: \"5CA[45]\", source: \"The Diablo Armament\" }\r\n25418.4 \"Explosion 1\" Ability { id: \"5CA[67]\", source: \"The Diablo Armament\" }\r\n25420.5 \"Explosion 2\" Ability { id: \"5CA[89]\", source: \"The Diablo Armament\" }\r\n25424.0 \"Explosion 3\" Ability { id: \"5CA[AB]\", source: \"The Diablo Armament\" }\r\n25426.0 \"Advanced Death Ray\" Ability { id: \"5CC4\", source: \"The Diablo Armament\" }\r\n25438.3 \"--sync--\" Ability { id: \"5CBF\", source: \"The Diablo Armament\" }\r\n25447.4 \"Deadly Dealing\" Ability { id: \"5CC2\", source: \"The Diablo Armament\" }\r\n25449.0 \"Advanced Nox\" Ability { id: \"5CC0\", source: \"The Diablo Armament\" } duration 4.5\r\n25461.7 \"Aetheric Boom\" Ability { id: \"5CB3\", source: \"The Diablo Armament\" }\r\n25463.8 \"Aetherochemical Laser 1\" Ability { id: \"5CA5\", source: \"The Diablo Armament\" }\r\n25467.9 \"Aetherochemical Laser 2\" Ability { id: \"5CA4\", source: \"The Diablo Armament\" }\r\n25474.9 \"Explosion 1\" Ability { id: \"5CA[67]\", source: \"The Diablo Armament\" }\r\n25477.0 \"Explosion 2\" Ability { id: \"5CA[89]\", source: \"The Diablo Armament\" }\r\n\r\n# TODO: this is probably a loop?? guessing it goes back to first gate???\r\n25489.6 \"Diabolic Gate\" Ability { id: \"5C9F\", source: \"The Diablo Armament\" } window 100,100 jump 25068.6\r\n25512.1 \"--sync--\" Ability { id: \"5CA0\", source: \"The Diablo Armament\" }\r\n25513.7 \"Ruinous Pseudomen 1\" Ability { id: \"61A3\", source: \"The Diablo Armament\" }\r\n25517.7 \"Ruinous Pseudomen 2\" #Ability { id: \"614C\", source: \"The Diablo Armament\" }\r\n25520.7 \"Ruinous Pseudomen 3\" #Ability { id: \"614C\", source: \"The Diablo Armament\" }\r\n25525.0 \"Ruinous Pseudomen 4\" Ability { id: \"614F\", source: \"The Diablo Armament\" }\r\n25532.0 \"Ultimate Pseudoterror\" Ability { id: \"5CA3\", source: \"The Diablo Armament\" }\r\n\r\n# final phase (hp%?)\r\n25800.0 \"--sync--\" StartsUsing { id: \"5CB7\", source: \"The Diablo Armament\" } window 1000,0\r\n25805.0 \"Void Systems Overload\" Ability { id: \"5CB7\", source: \"The Diablo Armament\" }\r\n25815.1 \"Pillar Of Shamash\" Ability { id: \"5CB9\", source: \"The Diablo Armament\" }\r\n25816.6 \"Pillar Of Shamash\" Ability { id: \"5CBA\", source: \"The Diablo Armament\" }\r\n25818.1 \"Pillar Of Shamash\" Ability { id: \"5CBB\", source: \"The Diablo Armament\" }\r\n25822.2 \"Pillar Of Shamash\" Ability { id: \"5CBD\", source: \"The Diablo Armament\" }\r\n25824.2 \"--lasers--\" Ability { id: \"5CBC\", source: \"The Diablo Armament\" }\r\n25828.2 \"--line stack--\" Ability { id: \"5CBE\", source: \"The Diablo Armament\" }\r\n\r\n25842.2 \"Void Systems Overload\" Ability { id: \"6314\", source: \"The Diablo Armament\" } window 100,100 jump 25805\r\n25852.3 \"Pillar Of Shamash\" Ability { id: \"5CB9\", source: \"The Diablo Armament\" }\r\n25853.8 \"Pillar Of Shamash\" Ability { id: \"5CBA\", source: \"The Diablo Armament\" }\r\n25855.3 \"Pillar Of Shamash\" Ability { id: \"5CBB\", source: \"The Diablo Armament\" }\r\n25859.4 \"Pillar Of Shamash\" Ability { id: \"5CBD\", source: \"The Diablo Armament\" }\r\n25861.4 \"--lasers--\" Ability { id: \"5CBC\", source: \"The Diablo Armament\" }\r\n25865.4 \"--line stack--\" Ability { id: \"5CBE\", source: \"The Diablo Armament\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/hunts/amh_araeng.ts


// TODO: Sugaar rotating Numbing Noise (46B4) Tail Snap (46B5) + draw-in

const amh_araeng_triggerSet = {
  id: 'AmhAraeng',
  zoneId: zone_id/* default.AmhAraeng */.Z.AmhAraeng,
  triggers: [{
    id: 'Hunt Mailktender Sabotendance',
    type: 'StartsUsing',
    netRegex: {
      id: '4663',
      source: 'Maliktender',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Mailktender 20,000 Needles',
    type: 'StartsUsing',
    netRegex: {
      id: '4666',
      source: 'Maliktender',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind('info')
  }, {
    id: 'Hunt Mailktender 990,000 Needles',
    type: 'StartsUsing',
    netRegex: {
      id: '4668',
      source: 'Maliktender',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Sugaar Numbing Noise',
    type: 'StartsUsing',
    netRegex: {
      id: '465F',
      source: 'Sugaar',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Sugaar Tail Snap',
    type: 'StartsUsing',
    netRegex: {
      id: '4660',
      source: 'Sugaar',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goFront */.n3.goFront()
  }, {
    id: 'Hunt Sugaar Body Slam',
    type: 'StartsUsing',
    netRegex: {
      id: '4662',
      source: 'Sugaar',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.outOfMelee */.n3.outOfMelee()
  }, {
    id: 'Hunt Tarchia Wild Horn',
    type: 'StartsUsing',
    netRegex: {
      id: '466A',
      source: 'Tarchia'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Hunt Tarchia Metamorphic Blast',
    type: 'StartsUsing',
    netRegex: {
      id: '466F',
      source: 'Tarchia',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Tarchia Trounce',
    type: 'StartsUsing',
    netRegex: {
      id: '466B',
      source: 'Tarchia',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind('info')
  }, {
    id: 'Hunt Tarchia Forest Fire',
    type: 'StartsUsing',
    netRegex: {
      id: '466E',
      source: 'Tarchia',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Tarchia Groundstorm',
    type: 'StartsUsing',
    netRegex: {
      id: '4667',
      source: 'Tarchia',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'Hunt Tarchia Mighty Spin',
    type: 'Ability',
    // Groundstorm is followed up by an untelegraphed/uncasted Mighty Spin.
    netRegex: {
      id: '4667',
      source: 'Tarchia',
      capture: false
    },
    condition: data => data.inCombat,
    suppressSeconds: 1,
    response: responses/* Responses.getOut */.n3.getOut()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Maliktender': 'Malikkaktor',
      'Sugaar': 'Sugaar',
      'Tarchia': 'Tarchia'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Maliktender': 'Malikpampa',
      'Sugaar': 'Sugaar',
      'Tarchia': 'Tarchia'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Maliktender': 'マリクテンダー',
      'Sugaar': 'シュガール',
      'Tarchia': 'タルキア'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Maliktender': '马利克巨人掌',
      'Sugaar': '休格尔',
      'Tarchia': '多智兽'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Maliktender': '말리크텐더',
      'Sugaar': '슈가르',
      'Tarchia': '타르키아'
    }
  }]
};
/* harmony default export */ const amh_araeng = (amh_araeng_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/hunts/il_mheg.ts


const il_mheg_triggerSet = {
  id: 'IlMheg',
  zoneId: zone_id/* default.IlMheg */.Z.IlMheg,
  triggers: [{
    id: 'Hunt Pauldia Rusting Claw',
    type: 'StartsUsing',
    netRegex: {
      id: '41BE',
      source: 'O Poorest Pauldia',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Pauldia Words of Woe',
    type: 'StartsUsing',
    netRegex: {
      id: '41C0',
      source: 'O Poorest Pauldia',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Pauldia Tail Drive',
    type: 'StartsUsing',
    netRegex: {
      id: '41BF',
      source: 'O Poorest Pauldia',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goFront */.n3.goFront()
  }, {
    id: 'Hunt Pauldia The Spin',
    type: 'StartsUsing',
    netRegex: {
      id: '41C1',
      source: 'O Poorest Pauldia',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Mudman Royal Flush',
    type: 'StartsUsing',
    netRegex: {
      id: '41BA',
      source: 'The Mudman',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Mudman Bog Bequest',
    type: 'StartsUsing',
    netRegex: {
      id: '41BB',
      source: 'The Mudman',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Hunt Mudman Gravity Force',
    type: 'StartsUsing',
    netRegex: {
      id: '41BD',
      source: 'The Mudman'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.interruptIfPossible */.n3.interruptIfPossible()
  }, {
    id: 'Hunt Aglaope Ancient Aero III',
    type: 'StartsUsing',
    netRegex: {
      id: '4688',
      source: 'Aglaope',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Hunt Aglaope Fourfold Suffering',
    type: 'StartsUsing',
    netRegex: {
      id: '41B3',
      source: 'Aglaope',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Hunt Aglaope Song of Torment',
    type: 'StartsUsing',
    netRegex: {
      id: '41B9',
      source: 'Aglaope'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.interruptIfPossible */.n3.interruptIfPossible()
  }, {
    id: 'Hunt Aglaope Seductive Sonata',
    type: 'StartsUsing',
    netRegex: {
      id: '41B8',
      source: 'Aglaope',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut('alarm')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aglaope': 'Aglaope',
      'O Poorest Pauldia': 'gepeinigt(?:e|er|es|en) Pauldia',
      'The Mudman': 'Matschklops'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aglaope': 'Aglaope',
      'O Poorest Pauldia': 'Pauldia',
      'The Mudman': 'tas de boue'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aglaope': 'アグラオペ',
      'O Poorest Pauldia': 'ポールディア',
      'The Mudman': '泥人'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aglaope': '阿格拉俄珀',
      'O Poorest Pauldia': '保尔迪雅',
      'The Mudman': '泥人'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aglaope': '아글라오페',
      'O Poorest Pauldia': '폴디아',
      'The Mudman': '진흙인간'
    }
  }]
};
/* harmony default export */ const il_mheg = (il_mheg_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/hunts/kholusia.ts



const kholusia_triggerSet = {
  id: 'Kholusia',
  zoneId: zone_id/* default.Kholusia */.Z.Kholusia,
  triggers: [{
    id: 'Hunt Lil Murderer Goblin Punch',
    type: 'StartsUsing',
    netRegex: {
      id: '4450',
      source: 'Li\'l Murderer'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Hunt Lil Murderer Gobthunder III',
    type: 'StartsUsing',
    netRegex: {
      id: '4455',
      source: 'Li\'l Murderer'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.interruptIfPossible */.n3.interruptIfPossible()
  }, {
    id: 'Hunt Lil Murderer Goblin Slash',
    type: 'Ability',
    // This is for Goblin Thunder II
    netRegex: {
      id: '4454',
      source: 'Li\'l Murderer',
      capture: false
    },
    suppressSeconds: 10,
    alertText: (data, _matches, output) => {
      // TODO: there is an uncasted/untelegraphed Goblin Slash "get out"
      // after some Gobthunder II (the self-targeted one?) but it's
      // unclear from logs which is which.  Since hunts die quickly,
      // just simplify and call this only after the first one until
      // somebody knows better.
      if (!data.inCombat || data.seenFirstThunder) return;
      return output.out();
    },
    run: data => data.seenFirstThunder = true,
    outputStrings: {
      out: outputs/* default.out */.Z.out
    }
  }, {
    id: 'Hunt Huracan Winter Rain',
    type: 'StartsUsing',
    netRegex: {
      id: '4459',
      source: 'Huracan',
      capture: false
    },
    condition: data => data.inCombat,
    // This is a targeted circle aoe followed by a line aoe through the middle.
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'Hunt Huracan Summer Heat',
    type: 'StartsUsing',
    netRegex: {
      id: '445B',
      source: 'Huracan',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Huracan Spring Breeze',
    type: 'StartsUsing',
    netRegex: {
      id: '4458',
      source: 'Huracan',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'Hunt Huracan Autumn Wreath',
    type: 'StartsUsing',
    netRegex: {
      id: '445A',
      source: 'Huracan',
      capture: false
    },
    condition: data => data.inCombat,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'In => Sides',
        de: 'Rein => Seiten',
        fr: 'Intérieur => Côtés',
        cn: '中间 => 两侧',
        ko: '안으로 => 옆으로'
      }
    }
  }, {
    id: 'Hunt Huracan Dawn\'s Edge',
    type: 'StartsUsing',
    netRegex: {
      id: '4457',
      source: 'Huracan',
      capture: false
    },
    condition: data => data.inCombat,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sides => Sides (again)',
        de: 'Seiten => Seiten (nochmal)',
        fr: 'Côtés => Côtés (encore)',
        cn: '两侧 => 两侧 (重复)',
        ko: '옆으로 => 옆으로 (반복)'
      }
    }
  }, {
    id: 'Hunt Pedantry Right Cheek',
    type: 'StartsUsing',
    netRegex: {
      id: '4428',
      source: 'Forgiven Pedantry',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goLeftThenRight */.n3.goLeftThenRight()
  }, {
    id: 'Hunt Pedantry Left Cheek',
    type: 'StartsUsing',
    netRegex: {
      id: '4426',
      source: 'Forgiven Pedantry',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goRightThenLeft */.n3.goRightThenLeft()
  }, {
    id: 'Hunt Pedantry Terrifying Glance',
    type: 'StartsUsing',
    netRegex: {
      id: '4623',
      source: 'Forgiven Pedantry',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Hunt Pedantry Cleansing Fire',
    type: 'StartsUsing',
    netRegex: {
      id: '4422',
      source: 'Forgiven Pedantry',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Pedantry The Stake',
    type: 'StartsUsing',
    netRegex: {
      id: '4423',
      source: 'Forgiven Pedantry',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Pedantry Fevered Flagellation',
    type: 'StartsUsing',
    netRegex: {
      id: '4420',
      source: 'Forgiven Pedantry'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Hunt Pedantry Second Circle',
    type: 'StartsUsing',
    netRegex: {
      id: '4421',
      source: 'Forgiven Pedantry',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Forgiven Pedantry': 'geläutert(?:e|er|es|en) Pedanterie',
      'Huracan': 'Huracan',
      'Li\'l Murderer': 'Klein(?:e|er|es|en) Mörder'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Forgiven Pedantry': 'pédanterie pardonnée',
      'Huracan': 'Huracan',
      'Li\'l Murderer': 'Traître'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Forgiven Pedantry': 'フォーギヴン・ペダントリー',
      'Huracan': 'フラカン',
      'Li\'l Murderer': 'リルマーダー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Forgiven Pedantry': '得到宽恕的炫学',
      'Huracan': '乌拉坎',
      'Li\'l Murderer': '小小杀手'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Forgiven Pedantry': '면죄된 현학',
      'Huracan': '후라칸',
      'Li\'l Murderer': '작은 살인자'
    }
  }]
};
/* harmony default export */ const kholusia = (kholusia_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/hunts/lakeland.ts



const lakeland_triggerSet = {
  id: 'Lakeland',
  zoneId: zone_id/* default.Lakeland */.Z.Lakeland,
  triggers: [{
    id: 'Hunt Nariphon Piercing Resistance Down II Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '59B'
    },
    condition: (data, matches) => matches.target === data.me,
    run: data => data.allergen = true
  }, {
    id: 'Hunt Nariphon Piercing Resistance Down II Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '59B'
    },
    condition: (data, matches) => matches.target === data.me,
    run: data => data.allergen = false
  }, {
    id: 'Hunt Nariphon Roots of Atopy',
    type: 'StartsUsing',
    netRegex: {
      id: '424B',
      source: 'Nariphon'
    },
    condition: data => data.inCombat,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        stackOnPlayer: outputs/* default.stackOnPlayer */.Z.stackOnPlayer,
        stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
        avoidStack: {
          en: 'Avoid Stack',
          de: 'Vermeide Sammeln',
          fr: 'Évitez le package',
          cn: '远离分摊',
          ko: '쉐어징 피하기'
        }
      };
      if (matches.target === data.me) return {
        alertText: output.stackOnYou()
      };
      if (data.allergen) return {
        alarmText: output.avoidStack()
      };
      return {
        infoText: output.stackOnPlayer({
          player: data.party.member(matches.target)
        })
      };
    }
  }, {
    id: 'Hunt Nariphon Odious Miasma',
    type: 'StartsUsing',
    netRegex: {
      id: '424A',
      source: 'Nariphon',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Nuckelavee Torpedo',
    type: 'StartsUsing',
    netRegex: {
      id: '4244',
      source: 'Nuckelavee'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Hunt Nuckelavee Bog Body',
    type: 'StartsUsing',
    netRegex: {
      id: '4245',
      source: 'Nuckelavee'
    },
    condition: (data, matches) => matches.target === data.me,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'GTFO with marker',
        de: 'Geh raus mit dem Marker',
        fr: 'Partez avec le marquage',
        ja: 'ボスから離れる',
        cn: '快躲开标记',
        ko: '나에게 징 멀리 빠지기'
      }
    }
  }, {
    id: 'Hunt Nuckelavee Gallop',
    type: 'StartsUsing',
    netRegex: {
      id: '4247',
      source: 'Nuckelavee',
      capture: false
    },
    condition: data => data.inCombat,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from Dash',
        de: 'Weg vom Anstrum',
        fr: 'Éloignez-vous du dash',
        cn: '躲避冲锋',
        ko: '돌진한 곳 피하기'
      }
    }
  }, {
    id: 'Hunt Tyger Dragon\'s Breath',
    type: 'StartsUsing',
    netRegex: {
      id: '423F',
      source: 'Tyger',
      capture: false
    },
    condition: data => data.inCombat,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Back/Right',
        de: 'Geh nach Hinten/Rechts',
        fr: 'Allez à l\'arrière/droite',
        cn: '去背后/右侧',
        ko: '뒤/오른쪽으로'
      }
    }
  }, {
    id: 'Hunt Tyger Lion\'s Breath',
    type: 'StartsUsing',
    netRegex: {
      id: '423D',
      source: 'Tyger',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind('info')
  }, {
    id: 'Hunt Tyger Ram\'s Breath',
    type: 'StartsUsing',
    netRegex: {
      id: '423E',
      source: 'Tyger',
      capture: false
    },
    condition: data => data.inCombat,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Back/Left',
        de: 'Geh nach Hinten/Links',
        fr: 'Allez à l\'arrière/gauche',
        cn: '去背后/左侧',
        ko: '뒤/왼쪽으로'
      }
    }
  }, {
    id: 'Hunt Tyger Dragon\'s Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '4243',
      source: 'Tyger'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.interruptIfPossible */.n3.interruptIfPossible('info')
  }, {
    id: 'Hunt Tyger Ram\'s Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '4242',
      source: 'Tyger'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.interruptIfPossible */.n3.interruptIfPossible('info')
  }, {
    id: 'Hunt Tyger Scorpion\'s Sting',
    type: 'StartsUsing',
    netRegex: {
      id: ['4242', '4243'],
      source: 'Tyger',
      capture: false
    },
    condition: data => data.inCombat,
    // Roughly 6.3s after Dragon's Voice or Ram's Voice is uncasted Scorpion's Sting.
    // Mention this slightly after.
    delaySeconds: 1.5,
    response: responses/* Responses.goFront */.n3.goFront()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Nariphon': 'Nariphon',
      'Nuckelavee': 'Nuckelavee',
      'Tyger': 'Tyger'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Nariphon': 'Nariphon',
      'Nuckelavee': 'Nuckelavee',
      'Tyger': 'Tygre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Nariphon': 'ナリーポン',
      'Nuckelavee': 'ナックラヴィー',
      'Tyger': 'ティガー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Nariphon': '纳里蓬',
      'Nuckelavee': '纳克拉维',
      'Tyger': '戾虫'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Nariphon': '나리폰',
      'Nuckelavee': '너클라비',
      'Tyger': '티거'
    }
  }]
};
/* harmony default export */ const lakeland = (lakeland_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/hunts/ss_rank.ts


const ss_rank_triggerSet = {
  id: 'HuntShBSS',
  zoneId: [zone_id/* default.AmhAraeng */.Z.AmhAraeng, zone_id/* default.IlMheg */.Z.IlMheg, zone_id/* default.Kholusia */.Z.Kholusia, zone_id/* default.Lakeland */.Z.Lakeland, zone_id/* default.TheRaktikaGreatwood */.Z.TheRaktikaGreatwood, zone_id/* default.TheTempest */.Z.TheTempest],
  zoneLabel: {
    en: 'SS Rank Hunts',
    de: 'SS Jagdziele',
    fr: 'Objectifs de chasse SS',
    cn: 'SS 级狩猎怪',
    ko: 'SS급 마물'
  },
  triggers: [{
    id: 'Hunt Rebellion Royal Decree',
    type: 'StartsUsing',
    netRegex: {
      id: '44BD',
      source: 'Forgiven Rebellion',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Rebellion Raging Fire',
    type: 'StartsUsing',
    netRegex: {
      id: '44C1',
      source: 'Forgiven Rebellion',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Hunt Rebellion Interference',
    type: 'StartsUsing',
    netRegex: {
      id: '44C2',
      source: 'Forgiven Rebellion',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Rebellion Sanctified Blizzard Chain',
    type: 'StartsUsing',
    netRegex: {
      id: '44DC',
      source: 'Forgiven Rebellion',
      capture: false
    },
    condition: data => data.inCombat
    // TODO: which way is this rotating
  }, {
    id: 'Hunt Rebellion Heavenly Cyclone',
    type: 'StartsUsing',
    netRegex: {
      id: '46CE',
      source: 'Forgiven Rebellion',
      capture: false
    },
    condition: data => data.inCombat
    // TODO: which way is this rotating
  }],

  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Forgiven Rebellion': 'geläutert(?:e|er|es|en) Rebellion'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Forgiven Rebellion': 'rébellion pardonnée'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Forgiven Rebellion': 'フォーギヴン・リベリオン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Forgiven Rebellion': '得到宽恕的叛乱'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Forgiven Rebellion': '면죄된 폭동'
    }
  }]
};
/* harmony default export */ const ss_rank = (ss_rank_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/hunts/the_raktika_greatwood.ts



const the_raktika_greatwood_triggerSet = {
  id: 'TheRaktikaGreatwood',
  zoneId: zone_id/* default.TheRaktikaGreatwood */.Z.TheRaktikaGreatwood,
  triggers: [{
    id: 'Hunt Grassman Chest Thump',
    type: 'StartsUsing',
    netRegex: {
      id: '45C3',
      source: 'Grassman',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Grassman Browbeat',
    type: 'StartsUsing',
    netRegex: {
      id: '45C4',
      source: 'Grassman'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'Hunt Grassman Streak',
    type: 'StartsUsing',
    netRegex: {
      id: '45C6',
      source: 'Grassman',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Supay Blasphemous Howl',
    type: 'StartsUsing',
    netRegex: {
      id: '45C2',
      source: 'Supay'
    },
    condition: (data, matches) => data.inCombat && matches.target === data.me,
    // TODO: not sure how to say "hey if you're gonna be hit
    // by this giant aoe that's not on you, you should look away too"
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'GTFO + Look Away',
        de: 'Schnell raus + weg schauen',
        fr: 'Allez vous-en et regardez ailleurs',
        cn: '快出去 + 看向其他方向',
        ko: '멀리 빠지기 + 뒤돌기'
      }
    }
  }, {
    id: 'Hunt Supay Petro Eyes',
    type: 'StartsUsing',
    netRegex: {
      id: '45C0',
      source: 'Supay',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.lookAway */.n3.lookAway('alarm')
  }, {
    id: 'Hunt Ixtab Tartarean Abyss',
    type: 'StartsUsing',
    netRegex: {
      id: '45B8',
      source: 'Ixtab'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Hunt Ixtab Tartarean Quake',
    type: 'StartsUsing',
    netRegex: {
      id: '45B9',
      source: 'Ixtab',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Ixtab Tartarean Meteor',
    type: 'StartsUsing',
    netRegex: {
      id: '45B4',
      source: 'Ixtab'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Hunt Ixtab Tartarean Twister',
    type: 'StartsUsing',
    netRegex: {
      id: '4698',
      source: 'Ixtab'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.interruptIfPossible */.n3.interruptIfPossible()
  }, {
    id: 'Hunt Ixtab Cryptcall',
    type: 'Ability',
    netRegex: {
      id: '45B7',
      source: 'Ixtab',
      capture: false
    },
    condition: data => data.inCombat && (data.role === 'healer' || data.job === 'BLU'),
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Heal to Full',
        de: 'Voll heilen',
        fr: 'Soignez au maximum',
        cn: '奶满全员',
        ko: '체력 풀피로'
      }
    }
  }, {
    id: 'Hunt Ixtab Archaic Dualcast',
    type: 'StartsUsing',
    netRegex: {
      id: '469D',
      source: 'Ixtab',
      capture: false
    },
    run: data => data.ixtabDualcast = true
  }, {
    id: 'Hunt Ixtab Tartarean Thunder',
    type: 'StartsUsing',
    netRegex: {
      id: '45B3',
      source: 'Ixtab',
      capture: false
    },
    condition: data => data.inCombat,
    alertText: (data, _matches, output) => {
      if (data.ixtabDualcast) return output.outThenIn();
      return output.out();
    },
    run: data => data.ixtabDualcast = false,
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      outThenIn: outputs/* default.outThenIn */.Z.outThenIn
    }
  }, {
    id: 'Hunt Ixtab Tartarean Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '464F',
      source: 'Ixtab',
      capture: false
    },
    condition: data => data.inCombat,
    alertText: (data, _matches, output) => {
      if (data.ixtabDualcast) return output.inThenOut();
      return output.in();
    },
    run: data => data.ixtabDualcast = false,
    outputStrings: {
      in: outputs/* default.in */.Z["in"],
      inThenOut: outputs/* default.inThenOut */.Z.inThenOut
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Grassman': 'Grasmann',
      'Ixtab': 'Ixtab',
      'Supay': 'Supay'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Grassman': 'Sasquatch arboricole',
      'Ixtab': 'Ixtab',
      'Supay': 'Supay'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Grassman': 'グラスマン',
      'Ixtab': 'イシュタム',
      'Supay': 'スペイ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Grassman': '格拉斯曼',
      'Ixtab': '伊休妲',
      'Supay': '苏帕伊'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Grassman': '숲원인',
      'Ixtab': '이슈타브',
      'Supay': '수파이'
    }
  }]
};
/* harmony default export */ const the_raktika_greatwood = (the_raktika_greatwood_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/hunts/the_tempest.ts




// TODO: should we call anything for The Deep Rends (43C7)?

const the_tempest_triggerSet = {
  id: 'TheTempest',
  zoneId: zone_id/* default.TheTempest */.Z.TheTempest,
  triggers: [{
    id: 'Hunt Baal Sewer Water Front',
    type: 'StartsUsing',
    netRegex: {
      id: '4624',
      source: 'Baal',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Baal Sewer Water Back',
    type: 'StartsUsing',
    netRegex: {
      id: '4625',
      source: 'Baal',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goFront */.n3.goFront()
  }, {
    id: 'Hunt Baal Sewage Wave Front',
    type: 'StartsUsing',
    netRegex: {
      id: '440F',
      source: 'Baal',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBackThenFront */.n3.getBackThenFront()
  }, {
    id: 'Hunt Baal Sewage Wave Back',
    type: 'StartsUsing',
    netRegex: {
      id: '4410',
      source: 'Baal',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getFrontThenBack */.n3.getFrontThenBack()
  }, {
    id: 'Hunt Rusalka Aetherial Pull',
    type: 'StartsUsing',
    netRegex: {
      id: '43D6',
      source: 'Rusalka',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.drawIn */.n3.drawIn()
  }, {
    id: 'Hunt Rusalka Flood',
    type: 'Ability',
    // Happens immediately after Aetherial Pull
    netRegex: {
      id: '43D6',
      source: 'Rusalka',
      capture: false
    },
    condition: data => data.inCombat,
    suppressSeconds: 1,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Gunitt The Deep Seeks',
    type: 'StartsUsing',
    netRegex: {
      id: '43CC',
      source: 'Gunitt'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Hunt Gunitt The Deep Reaches',
    type: 'StartsUsing',
    // Untelegraphed line aoe x3
    netRegex: {
      id: '43CD',
      source: 'Gunitt',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Gunitt The Deep Beckons',
    type: 'StartsUsing',
    netRegex: {
      id: '43CE',
      source: 'Gunitt',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Gunitt Swivel Gun',
    type: 'StartsUsing',
    netRegex: {
      id: '43D1',
      source: 'Gunitt'
    },
    condition: data => data.inCombat,
    alertText: (data, matches, output) => {
      if (data.swivelGunVuln) return output.avoidStack();
      if (data.me === matches.target) return output.stackOnYou();
      return output.stackMarker();
    },
    outputStrings: {
      stackMarker: outputs/* default.stackMarker */.Z.stackMarker,
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      avoidStack: {
        en: 'Avoid Stack',
        de: 'Vermeide Sammeln',
        fr: 'Ne vous packez pas',
        cn: '远离分摊',
        ko: '쉐어징 피하기'
      }
    }
  }, {
    id: 'Hunt Gunitt Swivel Gun Vuln Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '472'
    },
    condition: (data, matches) => data.me === matches.target,
    run: data => data.swivelGunVuln = true
  }, {
    id: 'Hunt Gunitt Swivel Gun Vuln Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '472'
    },
    condition: (data, matches) => data.me === matches.target,
    run: data => data.swivelGunVuln = false
  }, {
    id: 'Hunt Gunitt Coin Toss',
    type: 'StartsUsing',
    netRegex: {
      id: '43D0',
      source: 'Gunitt',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.lookAway */.n3.lookAway()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Baal': 'Baal',
      'Gunitt': 'Gunitt',
      'Rusalka': 'Rusalka'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Baal': 'Baal',
      'Gunitt': 'Gunitt',
      'Rusalka': 'Roussalka'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Baal': 'バール',
      'Gunitt': 'グニット',
      'Rusalka': 'ルサルカ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Baal': '巴力',
      'Gunitt': '顾尼图',
      'Rusalka': '卢莎卡'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Baal': '바알',
      'Gunitt': '구니트',
      'Rusalka': '루살카'
    }
  }]
};
/* harmony default export */ const the_tempest = (the_tempest_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/map/the_dungeons_of_lyhe_ghiah.ts

// TODO: confirm Fuath Trickster npcNameId
// TODO: confirm The Keeper of the Keys npcNameId
// TODO: Goliath (final chamber boss, golden Talos)
// TODO: Alichino (alternate final chamber boss, golden Calcabrina)
const lyheGhiahOutputStrings = {
  spawn: {
    en: '${name} spawned!',
    de: '${name} erscheint!',
    fr: '${name} vient d\'apparaitre !',
    cn: '已生成 ${name}!',
    ko: '${name} 등장!'
  }
};
const the_dungeons_of_lyhe_ghiah_triggerSet = {
  id: 'TheDungeonsOfLyheGhiah',
  zoneId: zone_id/* default.TheDungeonsOfLyheGhiah */.Z.TheDungeonsOfLyheGhiah,
  triggers: [
  // ---------------- random treasure mobs ----------------
  {
    id: 'Dungeons of Lyhe Ghiah Fuath Trickster Spawn',
    // 9774 = Fuath Trickster
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '9774'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: lyheGhiahOutputStrings.spawn
    }
  }, {
    id: 'Dungeons of Lyhe Ghiah The Keeper of the Keys Spawn',
    // 9773 = The Keeper of the Keys
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '9773'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: lyheGhiahOutputStrings.spawn
    }
  }, {
    id: 'Dungeons of Lyhe Ghiah Dungeon Crew Spawn',
    // 8684 = Dungeon Onion
    // 8685 = Dungeon Egg
    // 8686 = Dungeon Garlic
    // 8687 = Dungeon Tomato
    // 8688 = Dungeon Queen
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '868[4-8]',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dungeon Crew spawned, kill in order!',
        de: 'Verlies-Mandragora erscheinen, in Reihenfolge besiegen!',
        fr: 'Les mandragores apparaissent, tuez-les dans l\'ordre',
        cn: '已生成 宝库蔓德拉战队, 依次击杀!',
        ko: '만드라즈 등장, 순서대로 잡기!'
      }
    }
  }
  // ---------------- final chamber boss: Goliath ----------------
  // Mechanical Blow - tankbuster?
  // Accelerate - stack?
  // Wellbore - PBAoE, leaves ground effect?
  // Compress - plus-shaped AoE?
  // Goliath's Javelin - summoned adds, cast Compress - front line AoE?
  // ---------------- alternate final chamber boss: Alichino ----------------
  // Knockout - tankbuster?
  // Heat Gaze (first variant) - front cleave?
  // Heat Gaze (second variant) - donut AoE?
  // Maniacal Laughter - summons orbs that move toward players and detonate after some time?
  // Slapstick - roomwide AoE
  // Alich - summoned adds, cast Heat Gaze (front cleave variation)
  // Ino - summoned adds, cast Heat Gaze (donut AoE variation)
  ]
};

/* harmony default export */ const the_dungeons_of_lyhe_ghiah = (the_dungeons_of_lyhe_ghiah_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/map/the_shifting_oubliettes_of_lyhe_ghiah.ts


// TODO: Secret Pegasus (greater summon)
// TODO: Greedy Pixie (greater summon)
// TODO: Daen Ose The Avaricious (final summon)
// TODO: Daen Ose The Avaricious (Ultros form, alternate final summon)
const the_shifting_oubliettes_of_lyhe_ghiah_lyheGhiahOutputStrings = {
  spawn: {
    en: '${name} spawned!',
    de: '${name} erscheint!',
    fr: '${name} vient d\'apparaitre !',
    cn: '已生成 ${name}!',
    ko: '${name} 등장!'
  },
  adds: {
    en: 'Adds soon',
    de: 'Bald Adds',
    fr: 'Adds bientôt',
    cn: '小怪即将出现',
    ko: '곧 쫄 나옴'
  }
};
const the_shifting_oubliettes_of_lyhe_ghiah_triggerSet = {
  id: 'TheShiftingOubliettesOfLyheGhiah',
  zoneId: zone_id/* default.TheShiftingOubliettesOfLyheGhiah */.Z.TheShiftingOubliettesOfLyheGhiah,
  triggers: [
  // ---------------- random treasure mobs ----------------
  {
    id: 'Shifting Oubliettes of Lyhe Ghiah Fuath Trickster Spawn',
    // 9774 = Fuath Trickster
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '9774'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: the_shifting_oubliettes_of_lyhe_ghiah_lyheGhiahOutputStrings.spawn
    }
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah The Keeper of the Keys Spawn',
    // 9773 = The Keeper of the Keys
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '9773'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: the_shifting_oubliettes_of_lyhe_ghiah_lyheGhiahOutputStrings.spawn
    }
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Dungeon Crew Spawn',
    // 9801 = Secret Onion
    // 9802 = Secret Egg
    // 9803 = Secret Garlic
    // 9804 = Secret Tomato
    // 9805 = Secret Queen
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '980[1-5]',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dungeon Crew spawned, kill in order!',
        de: 'Verlies-Mandragora erscheinen, in Reihenfolge besiegen!',
        fr: 'L\'équipe du donjon vient d\'apparaitre, tuez les dans l\'ordre !',
        cn: '已生成 宝库蔓德拉战队, 依次击杀!',
        ko: '만드라즈 등장, 순서대로 잡기!'
      }
    }
  },
  // ---------------- lesser summons ----------------
  {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Swallow Electric Whorl',
    type: 'StartsUsing',
    netRegex: {
      id: '54D8',
      source: 'Secret Swallow',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Swallow Seventh Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '54D7',
      source: 'Secret Swallow',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Swallow Ceras',
    type: 'StartsUsing',
    netRegex: {
      id: '54D4',
      source: 'Secret Swallow'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Djinn Whirling Gaol',
    type: 'StartsUsing',
    netRegex: {
      id: '5496',
      source: 'Secret Djinn',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Djinn Whipwind',
    type: 'StartsUsing',
    netRegex: {
      id: '5498',
      source: 'Secret Djinn',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Undine Hydrotaph',
    // summons Flawless Bubble orbs (cast Hydrofan, large cone AoE)
    type: 'StartsUsing',
    netRegex: {
      id: '549D',
      source: 'Secret Undine',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Cladoselache Protolithic Puncture',
    type: 'StartsUsing',
    netRegex: {
      id: '54C7',
      source: 'Secret Cladoselache'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Worm Brine Breath',
    type: 'StartsUsing',
    netRegex: {
      id: '54CE',
      source: 'Secret Worm'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Serpent Fang\'s End',
    type: 'StartsUsing',
    netRegex: {
      id: '54C3',
      source: 'Secret Serpent'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  },
  // ---------------- greater summons ----------------
  {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Basket Pollen Corona',
    type: 'StartsUsing',
    netRegex: {
      id: '54DA',
      source: 'Secret Basket',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Basket Earth Crusher',
    type: 'StartsUsing',
    netRegex: {
      id: '54DF',
      source: 'Secret Basket',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Basket Earthquake',
    type: 'StartsUsing',
    netRegex: {
      id: '54E1',
      source: 'Secret Basket',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Basket Straight Punch',
    type: 'StartsUsing',
    netRegex: {
      id: '54D9',
      source: 'Secret Basket'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  },
  // Secret Pegasus: Burning Bright - front line AoE
  // Secret Pegasus: Nicker - PBAoE
  // Secret Pegasus: Cloud Call - summon Thunderhead adds (move around, cast Lightning Bolt PBAoE)*
  // Greedy Pixie: Wind Rune - front line AoE
  // Greedy Pixie: Song Rune - AoE on random player
  // Greedy Pixie: Storm Rune - roomwide AoE, summons adds? (Pixie Double, Secret Morpho)*
  // Greedy Pixie: Bush Bash - PBAoE?
  // Greedy Pixie: Nature Call - large front cone AoE
  // ---------------- elder summons ----------------
  {
    id: 'Shifting Oubliettes of Lyhe Ghiah Fuath Troublemaker Toy Hammer',
    type: 'StartsUsing',
    netRegex: {
      id: '54E6',
      source: 'Fuath Troublemaker'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Fuath Troublemaker Hydrocannon',
    type: 'StartsUsing',
    netRegex: {
      id: '54E9',
      source: 'Fuath Troublemaker'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Fuath Troublemaker Croaking Chorus',
    type: 'StartsUsing',
    netRegex: {
      id: '54EA',
      source: 'Fuath Troublemaker',
      capture: false
    },
    infoText: (_data, _matches, output) => output.adds(),
    outputStrings: {
      adds: the_shifting_oubliettes_of_lyhe_ghiah_lyheGhiahOutputStrings.adds
    }
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Korrigan Ram',
    type: 'StartsUsing',
    netRegex: {
      id: '54A9',
      source: 'Secret Korrigan'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Korrigan Hypnotize',
    type: 'StartsUsing',
    netRegex: {
      id: '54AA',
      source: 'Secret Korrigan',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Korrigan Saibai Mandragora',
    type: 'StartsUsing',
    netRegex: {
      id: '54AC',
      source: 'Secret Korrigan',
      capture: false
    },
    infoText: (_data, _matches, output) => output.adds(),
    outputStrings: {
      adds: the_shifting_oubliettes_of_lyhe_ghiah_lyheGhiahOutputStrings.adds
    }
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Secret Keeper Heavy Scrapline',
    type: 'StartsUsing',
    netRegex: {
      id: '54B1',
      source: 'Secret Keeper',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  },
  // ---------------- final summon: Daen Ose The Avaricious ----------------
  {
    id: 'Shifting Oubliettes of Lyhe Ghiah Daen Ose Petrifaction',
    type: 'StartsUsing',
    netRegex: {
      id: '5501',
      source: 'Daen Ose the Avaricious',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Daen Ose Abyssal Reaper',
    type: 'StartsUsing',
    netRegex: {
      id: '54FE',
      source: 'Daen Ose the Avaricious',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Daen Ose Petriburst',
    type: 'StartsUsing',
    netRegex: {
      id: '5500',
      source: 'Daen Ose the Avaricious'
    },
    alertText: (data, matches, output) => {
      return output.stackOnAndLookAway({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      stackOnAndLookAway: {
        en: 'Stack on ${player} and look away',
        de: 'Sammeln bei ${player} und wewg schauen',
        fr: 'Packez-vous sur ${player} et regardez ailleurs',
        ja: '${player}に頭割り、見ない',
        cn: '靠近并背对${player}分摊',
        ko: '${player} 쉐어, 바라보지않기'
      }
    }
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Daen Ose Sickle Strike',
    type: 'StartsUsing',
    netRegex: {
      id: '54FD',
      source: 'Daen Ose the Avaricious'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Oubliettes of Lyhe Ghiah Daen Ose Petrifaction Player',
    type: 'StartsUsing',
    netRegex: {
      id: '5502',
      source: 'Daen Ose the Avaricious'
    },
    response: responses/* Responses.lookAwayFromTarget */.n3.lookAwayFromTarget()
  }
  // ---------------- alternate final summon: Daen Ose The Avaricious (Ultros form) ----------------
  // Daen Ose The Avaricious (Ultros form): Megavolt - PBAoE
  // Daen Ose The Avaricious (Ultros form): Waterspout - AoE on random players
  // Daen Ose The Avaricious (Ultros form): Aqua Breath - front cone AoE
  // Daen Ose The Avaricious (Ultros form): Thunder III - tankbuster?*
  // Daen Ose The Avaricious (Ultros form): Wave of Turmoil - knockback from center with AoEs on outside*
  // Daen Ose The Avaricious (Ultros form): Falling Water - baited AoE on marked player
  ]
};

/* harmony default export */ const the_shifting_oubliettes_of_lyhe_ghiah = (the_shifting_oubliettes_of_lyhe_ghiah_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e10n.ts



const e10n_triggerSet = {
  id: 'EdensPromiseLitany',
  zoneId: zone_id/* default.EdensPromiseLitany */.Z.EdensPromiseLitany,
  timelineFile: 'e10n.txt',
  timelineTriggers: [{
    id: 'E10N Umbra Smash',
    regex: /Umbra Smash/,
    beforeSeconds: 5,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }],
  triggers: [{
    id: 'E10N Deepshadow Nova',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56E5',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E10N Forward Implosion',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56B4',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'E10N Backward Implosion',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56B7',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.goFront */.Z.goFront
    }
  }, {
    id: 'E10N Forward Shadow Implosion',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56B5',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Shadow Side',
        de: 'Schatten Seite',
        fr: 'Allez du côté de l\'ombre',
        ja: '影と同じ側へ',
        cn: '影子同侧',
        ko: '그림자 쪽으로'
      }
    }
  }, {
    id: 'E10N Backward Shadow Implosion',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56B8',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Opposite Shadow',
        de: 'Gegenüber des Schattens',
        fr: 'Allez du côté opposé à l\'ombre',
        ja: '影の反対側へ',
        cn: '影子异侧',
        ko: '그림자 반대쪽으로'
      }
    }
  }, {
    id: 'E10N Left Giga Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '56B1',
      source: 'Shadowkeeper',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'E10N Right Giga Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '56AE',
      source: 'Shadowkeeper',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'E10N Left Right Shadow Slash',
    type: 'StartsUsing',
    netRegex: {
      id: ['56AF', '56B2'],
      source: 'Shadowkeeper'
    },
    alertText: (_data, matches, output) => matches.id === '56AF' ? output.left() : output.right(),
    outputStrings: {
      left: {
        en: 'Go Left of Shadows',
        de: 'Geh links vom Schatten',
        fr: 'Allez à gauche des ombres',
        ja: '影の左へ',
        cn: '影子左侧',
        ko: '그림자 왼쪽'
      },
      right: {
        en: 'Go Right of Shadows',
        de: 'Geh rechts vom Schatten',
        fr: 'Allez à droite des ombres',
        ja: '影の右へ',
        cn: '影子右侧',
        ko: '그림자 오른쪽'
      }
    }
  }, {
    id: 'E10N Shadow\'s Edge',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5B0B'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'E10N Voidgate',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56DD',
      capture: false
    },
    delaySeconds: 10,
    // It's 17 seconds from the time Voidgate starts casting until towers.
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Puddles',
        de: 'Flächen nehmen',
        fr: 'Allez dans les zones au sol',
        ja: '踏む',
        cn: '踩圈',
        ko: '바닥 징 밟기'
      }
    }
  }, {
    id: 'E10N Shadow Warrior',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56E2',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand behind tethered dog',
        de: 'Achte auf den verbundenen Hund',
        fr: 'Allez derrière le chien lié',
        ja: '線で繋がった分身を注視',
        // FIXME
        cn: '站在连线狗后',
        ko: '연결된 쫄 뒤로가기'
      }
    }
  }, {
    id: 'E10N Cloak of Shadows ',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5B11',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // TODO: this could be better if we knew where the shadow was
        en: 'Away From Black Lines',
        de: 'Weg von den schwarzen Linien',
        fr: 'Éloignez-vous des lignes noires',
        ja: '黒い線から離れる',
        cn: '远离黑线',
        ko: '그림자 피하기'
      }
    }
  }, {
    // There is technically an AoE marker, but by the time it shows,
    // it's too late to get out if the player is inside the boss's hitbox.
    id: 'E10N Throne Of Shadow',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56C7',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    // There is technically a visual, but it comes up at precisely the same time as puddles.
    // Best to make sure the user is reminded.
    id: 'E10N Distant Scream',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56C6',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Shadowkeeper': 'Schattenkönig'
    },
    'replaceText': {
      'Backward Implosion': 'Hintere Implosion',
      'Backward Shadow Implosion': 'Hintere Schattenimplosion',
      'Barbs Of Agony': 'Stacheln der Todesqualen',
      'Cloak Of Shadows': 'Mantel des Schattens',
      'Deepshadow Nova': 'Dunkelschatten-Nova',
      'Distant Scream': 'Ferner Schrei',
      'Fade To Shadow': 'Schattenimmersion',
      'Forward Implosion': 'Vordere Implosion',
      'Forward Shadow Implosion': 'Vordere Schattenimplosion',
      'Front/Back Shadow Implosion': 'Vordere/Hintere Schattenimplosion',
      'Left': 'Linker',
      'Right Giga Slash': 'Rechter Giga-Schlag',
      'Right Shadow Slash': 'Rechter Schattenschlag',
      'Shadow Warrior': 'Schattenkrieger',
      'Shadow\'s Edge': 'Schattenhieb',
      'Shadowy Eruption': 'Schatteneruption',
      'Spawn Shadow': 'Schattenerscheinung',
      'Throne Of Shadow': 'Schattenthron',
      'Umbra Smash': 'Schattenschlag',
      'Void Pulse': 'Nichtspulsieren',
      'Voidgate': 'Nichtsportal'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Shadowkeeper': 'Roi De L\'Ombre'
    },
    'replaceText': {
      'Backward Implosion': 'Implosion dorsale',
      'Backward Shadow Implosion': 'Implosion ombrale dorsale',
      'Barbs Of Agony': 'Entrailles de l\'agonie',
      'Cloak Of Shadows': 'Cape de l\'Ombre',
      'Deepshadow Nova': 'Nova de la pleine-ombre',
      'Distant Scream': 'Hurlement de l\'Ombre',
      'Fade To Shadow': 'Immersion abyssale',
      'Forward Implosion': 'Implosion frontale',
      'Forward Shadow Implosion': 'Implosion ombrale frontale',
      'Front/Back Shadow Implosion': 'Implosion ombrale devant/derrière',
      'Left/Right Giga Slash': 'Giga taillade gauche/droite',
      'Left/Right Shadow Slash': 'Giga taillade ombrale gauche/droite',
      'Shadow Warrior': 'Ombre du roi',
      'Shadow\'s Edge': 'Taillade ombrale',
      'Shadowy Eruption': 'Éruption ombrale',
      'Spawn Shadow': 'Ombres croissantes',
      'Throne Of Shadow': 'Trône de l\'Ombre',
      'Umbra Smash': 'Fracas ombral',
      'Void Pulse': 'Pulsation du néant',
      'Voidgate': 'Porte du néant'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Shadowkeeper': '影の王'
    },
    'replaceText': {
      '(?<!/)Backward Implosion': 'バックワード・インプロージョン',
      'Backward Shadow Implosion': 'バックワード・シャドウインプロージョン',
      'Barbs Of Agony': 'バーブス・オブ・アゴニー',
      'Cloak Of Shadows': 'クローク・オブ・シャドウ',
      'Deepshadow Nova': 'ディープシャドウノヴァ',
      'Distant Scream': '影の遠吠え',
      'Fade To Shadow': '影潜り',
      'Forward Implosion': 'フォワード・インプロージョン',
      'Forward/Backward Implosion': 'フォワード／バックワード・インプロージョン',
      'Forward Shadow Implosion': 'フォワード・シャドウインプロージョン',
      'Front/Back Shadow Implosion': 'フォワード／バックワード・シャドウインプロージョン',
      'Left/Right Giga Slash': 'レフトサイド／ライトサイド・ギガスラッシュ',
      'Left/Right Shadow Slash': 'レフトサイド／ライトサイド・シャドウギガスラッシュ',
      'Shadow Warrior': '影武者',
      'Shadow\'s Edge': 'シャドウスラッシュ',
      'Shadowy Eruption': 'シャドウエラプション',
      'Spawn Shadow': 'スポーンシャドウ',
      'Throne Of Shadow': '影の王権',
      'Umbra Smash': 'アンブラスマッシュ',
      'Void Pulse': 'ヴォイドパルセーション',
      'Voidgate': 'ヴォイドゲート'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Shadowkeeper': '影之王'
    },
    'replaceText': {
      '(?<!/)Backward Implosion': '后向心聚爆',
      'Backward Shadow Implosion': '影·后向心聚爆',
      'Barbs Of Agony': '痛苦钩刺',
      'Cloak Of Shadows': '影之披风',
      'Deepshadow Nova': '深影新星',
      'Distant Scream': '影之狂吠',
      'Fade To Shadow': '潜影',
      'Forward Implosion': '前向心聚爆',
      'Forward/Backward Implosion': '前/后向心聚爆',
      'Forward Shadow Implosion': '影·前向心聚爆',
      'Front/Back Shadow Implosion': '影·前/后向心聚爆',
      'Left/Right Giga Slash': '左/右十亿斩击',
      'Left/Right Shadow Slash': '影·左/右十亿斩击',
      'Shadow Warrior': '影武者',
      'Shadow\'s Edge': '影之斩击',
      'Shadowy Eruption': '影之喷发',
      'Spawn Shadow': '影之增殖',
      'Throne Of Shadow': '影之王权',
      'Umbra Smash': '本影爆碎',
      'Void Pulse': '虚无悸动',
      'Voidgate': '虚无之门'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Shadowkeeper': '그림자의 왕'
    },
    'replaceText': {
      '(?<!/)Backward Implosion': '후방 내파',
      'Backward Shadow Implosion': '후방 그림자 내파',
      'Barbs Of Agony': '고뇌의 가시',
      'Cloak Of Shadows': '그림자 외투',
      'Deepshadow Nova': '암영 신성',
      'Distant Scream': '그림자의 울부짖음',
      'Fade To Shadow': '그림자 잠행',
      'Forward Implosion': '전방 내파',
      'Forward/Backward Implosion': '전방/후방 내파',
      'Forward Shadow Implosion': '전방 그림자 내파',
      'Front/Back Shadow Implosion': '전방/후방 그림자 내파',
      'Left/Right Giga Slash': '좌측/우측 기가 슬래시',
      'Left/Right Shadow Slash': '좌측/우측 그림자 기가 슬래시',
      'Shadow Warrior': '그림자 무사',
      'Shadow\'s Edge': '그림자 참격',
      'Shadowy Eruption': '그림자 분출',
      'Spawn Shadow': '그림자 생성',
      'Throne Of Shadow': '그림자의 왕권',
      'Umbra Smash': '그림자 타격',
      'Void Pulse': '보이드의 고동',
      'Voidgate': '보이드의 문'
    }
  }]
};
/* harmony default export */ const e10n = (e10n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e10n.txt
const raid_e10n_namespaceObject = "### Eden 10 (Normal)\r\n# Eden's Promise: Litany\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# -ii 56B0 56B6 56B9 56BA 56BB 56BD 56BE 56C0 56C1 56CC 56D4 56D5 56D8 56D9 56E1 56E7 5B09 5B0D 5B26\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n17.0 \"Forward Implosion\" Ability { id: \"56B4\", source: \"Shadowkeeper\" } window 17,5\r\n30.5 \"Forward Shadow Implosion\" Ability { id: \"56B5\", source: \"Shadowkeeper\" }\r\n41.8 \"Deepshadow Nova\" Ability { id: \"56E5\", source: \"Shadowkeeper\" }\r\n55.0 \"Backward Implosion\" Ability { id: \"56B7\", source: \"Shadowkeeper\" }\r\n68.5 \"Backward Shadow Implosion\" Ability { id: \"56B8\", source: \"Shadowkeeper\" }\r\n74.9 \"--center--\" Ability { id: \"5B08\", source: \"Shadowkeeper\" } window 74.9,10\r\n80.3 \"Spawn Shadow\" Ability { id: \"56D6\", source: \"Shadowkeeper\" }\r\n82.0 \"--sync--\" Ability { id: \"56D7\", source: \"Shadowkeeper\" }\r\n86.4 \"Shadow Warrior\" Ability { id: \"56E2\", source: \"Shadowkeeper\" }\r\n99.6 \"Barbs Of Agony\" Ability { id: \"5743\", source: \"Shadowkeeper\" }\r\n112.7 \"Deepshadow Nova\" Ability { id: \"56E5\", source: \"Shadowkeeper\" } window 30,30\r\n118.9 \"--center--\" Ability { id: \"5B08\", source: \"Shadowkeeper\" }\r\n124.3 \"Fade To Shadow\" Ability { id: \"56DA\", source: \"Shadowkeeper\" }\r\n135.4 \"--sync--\" Ability { id: \"56DB\", source: \"Shadowkeeper\" }\r\n137.9 \"Cloak Of Shadows\" Ability { id: \"5B11\", source: \"Shadowkeeper\" } window 50,50\r\n149.1 \"Throne Of Shadow\" Ability { id: \"56C7\", source: \"Shadowkeeper\" }\r\n157.7 \"Umbra Smash x4\" duration 5 # Ability { id: \"5BAB\", source: \"Shadowkeeper\" }\r\n169.2 \"Shadow's Edge\" Ability { id: \"5B0B\", source: \"Shadowkeeper\" }\r\n180.6 \"Left/Right Giga Slash\" Ability { id: \"56(AE|B1)\", source: \"Shadowkeeper\" }\r\n194.1 \"Left/Right Shadow Slash\" Ability { id: \"56(AF|B2)\", source: \"Shadowkeeper\" }\r\n205.5 \"Voidgate\" Ability { id: \"56DD\", source: \"Shadowkeeper\" } window 50,50\r\n219.6 \"Void Pulse\" Ability { id: \"56DE\", source: \"Shadowkeeper\" }\r\n230.8 \"Left/Right Shadow Slash\" Ability { id: \"56(AF|B2)\", source: \"Shadowkeeper\" }\r\n233.9 \"Left/Right Shadow Slash\" Ability { id: \"56(AF|B2)\", source: \"Shadowkeeper\" }\r\n246.6 \"Distant Scream\" Ability { id: \"56C6\", source: \"Shadowkeeper\" } window 246.6,10\r\n\r\n253.2 \"--center--\" Ability { id: \"5B08\", source: \"Shadowkeeper\" }\r\n258.6 \"Spawn Shadow\" Ability { id: \"56D6\", source: \"Shadowkeeper\" }\r\n260.3 \"--sync--\" Ability { id: \"56D7\", source: \"Shadowkeeper\" }\r\n264.7 \"Shadow Warrior\" Ability { id: \"56E2\", source: \"Shadowkeeper\" }\r\n276.9 \"Shadowy Eruption\" Ability { id: \"56(DF|E4)\", source: \"Shadowkeeper\" }\r\n278.0 \"Barbs Of Agony\" Ability { id: \"5743\", source: \"Shadowkeeper\" }\r\n295.1 \"Deepshadow Nova\" Ability { id: \"56E5\", source: \"Shadowkeeper\" }\r\n309.4 \"Front/Back Shadow Implosion\" Ability { id: \"56B[58]\", source: \"Shadowkeeper\" }\r\n312.5 \"Front/Back Shadow Implosion\" Ability { id: \"56B[58]\", source: \"Shadowkeeper\" }\r\n320.7 \"Deepshadow Nova\" Ability { id: \"56E5\", source: \"Shadowkeeper\" }\r\n328.9 \"--center--\" Ability { id: \"5B08\", source: \"Shadowkeeper\" }\r\n334.3 \"Fade To Shadow\" Ability { id: \"56DA\", source: \"Shadowkeeper\" }\r\n345.4 \"--sync--\" Ability { id: \"56DB\", source: \"Shadowkeeper\" }\r\n347.1 \"Forward/Backward Implosion\" Ability { id: \"56B[47]\", source: \"Shadowkeeper\" }\r\n347.9 \"Cloak Of Shadows\" Ability { id: \"5B11\", source: \"Shadowkeeper\" }\r\n359.0 \"Throne Of Shadow\" Ability { id: \"56C7\", source: \"Shadowkeeper\" }\r\n367.6 \"Voidgate\" Ability { id: \"56DD\", source: \"Shadowkeeper\" }\r\n381.7 \"Void Pulse\" Ability { id: \"56DE\", source: \"Shadowkeeper\" }\r\n384.8 \"Left/Right Giga Slash\" Ability { id: \"56(AE|B1)\", source: \"Shadowkeeper\" }\r\n395.2 \"Shadowy Eruption\" Ability { id: \"56(DF|E4)\", source: \"Shadowkeeper\" }\r\n404.4 \"Left/Right Shadow Slash\" Ability { id: \"56(AF|B2)\", source: \"Shadowkeeper\" }\r\n407.5 \"Left/Right Shadow Slash\" Ability { id: \"56(AF|B2)\", source: \"Shadowkeeper\" }\r\n418.6 \"Umbra Smash x4\" duration 5 # Ability { id: \"5BAB\", source: \"Shadowkeeper\" }\r\n430.0 \"Shadow's Edge\" Ability { id: \"5B0B\", source: \"Shadowkeeper\" }\r\n439.3 \"Shadowy Eruption x3\" # Ability { id: \"56E0\", source: \"Shadowkeeper\" }\r\n449.0 \"Distant Scream\" Ability { id: \"56C6\", source: \"Shadowkeeper\" } jump 246.6\r\n\r\n461.0 \"Spawn Shadow\"\r\n467.1 \"Shadow Warrior\"\r\n479.3 \"Shadowy Eruption\"\r\n480.4 \"Barbs Of Agony\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e10s.ts





// TODO: Fix headmarkers for groups running multiple of the same job ?
// Note: there's no headmarker ability line for cleaving shadows.
const directions = {
  north: outputs/* default.north */.Z.north,
  south: outputs/* default.south */.Z.south,
  east: outputs/* default.east */.Z.east,
  west: outputs/* default.west */.Z.west
};
const e10s_triggerSet = {
  id: 'EdensPromiseLitanySavage',
  zoneId: zone_id/* default.EdensPromiseLitanySavage */.Z.EdensPromiseLitanySavage,
  timelineFile: 'e10s.txt',
  triggers: [{
    id: 'E10S Deepshadow Nova',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '573E',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E10S Implosion Howl',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56F0',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Shadow Side',
        de: 'Schatten Seite',
        fr: 'Allez du côté de l\'ombre',
        ja: '影と同じ側へ',
        cn: '影子同侧',
        ko: '그림자 쪽으로'
      }
    }
  }, {
    id: 'E10S Implosion Tail',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56F3',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Opposite Shadow',
        de: 'Gegenüber des Schattens',
        fr: 'Allez du côté opposé à l\'ombre',
        ja: '影の反対側へ',
        cn: '影子异侧',
        ko: '그림자 반대쪽으로'
      }
    }
  }, {
    id: 'E10S Throne Of Shadow',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5717',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'E10S Giga Slash Shadow Single Left',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56EA',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Left of Shadow',
        de: 'Geh links vom Schatten',
        fr: 'Allez à gauche de l\'ombre',
        ja: '影の左へ',
        cn: '影子左侧',
        ko: '그림자 왼쪽으로'
      }
    }
  }, {
    id: 'E10S Giga Slash Shadow Single Right',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56ED',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Right of Shadow',
        de: 'Geh rechts vom Schatten',
        fr: 'Allez à droite de l\'ombre',
        ja: '影の右へ',
        cn: '影子右侧',
        ko: '그림자 오른쪽으로'
      }
    }
  }, {
    id: 'E10S Giga Slash Shadow Quadruple Left',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56F4',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Left of Shadows',
        de: 'Geh links vom Schatten',
        fr: 'Allez à gauche des ombres',
        ja: '影の左へ',
        cn: '影子左侧',
        ko: '그림자 왼쪽'
      }
    }
  }, {
    id: 'E10S Giga Slash Shadow Quadruple Right',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56F8',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Right of Shadows',
        de: 'Geh rechts vom Schatten',
        fr: 'Allez à droite des ombres',
        ja: '影の右へ',
        cn: '影子右侧',
        ko: '그림자 오른쪽'
      }
    }
  }, {
    id: 'E10S Umbra Smash',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5BAA'
    },
    // Although this is a swap, use `tankBuster` here to give the off tank a warning and a chance
    // to shield the main tank.  The offtank swap is delayed into the swap trigger below.
    response: responses/* Responses.tankBuster */.n3.tankBuster(),
    run: (data, matches) => data.umbraTarget = matches.target
  }, {
    id: 'E10S Umbra Smash Offtank Swap',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5BAA'
    },
    condition: (data, matches) => data.role === 'tank' && matches.target !== data.me,
    // This is a four hit tankbuster with a wind-up castbar.
    // If you provoke in between the four hits, you can end up taking a hit, so the offtank
    // needs to wait until all four hits have been applied (or something roughly there).
    // Therefore, need a delay that is a good balance of "warning ahead of time" and
    // "not so soon that the offtank steals the 4th hit".  For reference:
    //   * 3rd hit = 7.3 seconds after cast starts
    //   * 4th hit = 8.9 seconds after cast starts
    // TODO: verify that the 4th hit is locked in with this delay (or if it could be shorter)
    delaySeconds: 8.5,
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap('alert', 'alert'),
    run: (data, matches) => data.umbraTarget = matches.target
  }, {
    id: 'E10S Darkness Unleashed',
    type: 'StartsUsing',
    // Cast on self, with no player target.
    netRegex: {
      source: 'Shadowkeeper',
      id: '5B0E',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.me === data.umbraTarget) return output.avoidStack();
      return output.stack();
    },
    outputStrings: {
      avoidStack: {
        en: 'Avoid Stack!',
        de: 'Nicht Sammeln!',
        fr: 'Ne vous packez pas !',
        ja: '重ならない！',
        cn: '不要重合!',
        ko: '공격 피하기'
      },
      stack: outputs/* default.stackMarker */.Z.stackMarker
    }
  }, {
    id: 'E10S Shadow\'s Edge',
    type: 'StartsUsing',
    // Cast on self, with no player target.
    netRegex: {
      source: 'Shadowkeeper',
      id: '5B0C'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'E10S Giga Slash Shadow Drop Right',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5B2D',
      capture: false
    },
    durationSeconds: data => data.gigaSlashCleaveDebuffDuration,
    alertText: (data, _matches, output) => {
      let ret = '';
      switch (data.gigaSlashCleaveDebuffId) {
        case '973':
          ret = output.west();
          break;
        case '974':
          ret = output.east();
          break;
        case '975':
          ret = output.north();
          break;
        case '976':
          ret = output.south();
          break;
      }
      delete data.gigaSlashCleaveDebuffId;
      delete data.gigaSlashCleaveDebuffDuration;
      if (!ret) return;
      return output.dropShadow({
        dir: ret
      });
    },
    infoText: (_data, _matches, output) => output.leftCleave(),
    outputStrings: {
      dropShadow: {
        en: 'Drop Shadow ${dir}',
        de: 'Schatten im ${dir} ablegen',
        fr: 'Déposez l\'ombre du côté ${dir}',
        ja: '${dir}へ、影を捨てる',
        cn: '${dir}放影子',
        ko: '${dir}에 그림자 놓기'
      },
      leftCleave: {
        en: 'Left Cleave',
        de: 'Linker Cleave',
        fr: 'Cleave gauche',
        ja: '左半面へ攻撃',
        cn: '左侧顺劈',
        ko: '왼쪽 공격'
      },
      ...directions
    }
  }, {
    id: 'E10S Giga Slash Shadow Drop Left',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5B2C',
      capture: false
    },
    durationSeconds: data => data.gigaSlashCleaveDebuffDuration,
    alertText: (data, _matches, output) => {
      let ret = '';
      switch (data.gigaSlashCleaveDebuffId) {
        case '973':
          ret = output.east();
          break;
        case '974':
          ret = output.west();
          break;
        case '975':
          ret = output.south();
          break;
        case '976':
          ret = output.north();
          break;
      }
      delete data.gigaSlashCleaveDebuffId;
      delete data.gigaSlashCleaveDebuffDuration;
      if (!ret) return;
      return output.dropShadow({
        dir: ret
      });
    },
    infoText: (_data, _matches, output) => output.rightCleave(),
    outputStrings: {
      dropShadow: {
        en: 'Drop Shadow ${dir}',
        de: 'Schatten im ${dir} ablegen',
        fr: 'Déposez l\'ombre du côté ${dir}',
        ja: '${dir}へ、影を捨てる',
        cn: '${dir}放影子',
        ko: '${dir}에 그림자 놓기'
      },
      rightCleave: {
        en: 'Right Cleave',
        de: 'Rechter Cleave',
        fr: 'Cleave droit',
        ja: '右半面へ攻撃',
        cn: '右侧顺劈',
        ko: '오른쪽 공격'
      },
      ...directions
    }
  }, {
    id: 'E10S Shadow Servant Cleave Drop',
    type: 'GainsEffect',
    netRegex: {
      effectId: '97[3456]'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      data.gigaSlashCleaveDebuffId = matches.effectId;
      data.gigaSlashCleaveDebuffDuration = parseFloat(matches.duration);
    }
  }, {
    id: 'E10S Shadow Servant Get In',
    type: 'GainsEffect',
    netRegex: {
      effectId: '9D6',
      capture: false
    },
    // The effect lasts two seconds, use the difference of the two
    // instead of telling the bound people to get in instantly.
    delaySeconds: 1,
    suppressSeconds: 1,
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'E10S Shadow Cleave',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5718',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.clones = true,
    outputStrings: {
      text: {
        en: 'Drop Shadow Out',
        de: 'Schatten draußen ablegen',
        fr: 'Déposez l\'ombre à l\'extérieur',
        ja: '影を外周に捨てる',
        cn: '影子放到外圈',
        ko: '바깥쪽에 그림자 떨어뜨리기'
      }
    }
  }, {
    // This checks your shadow's job against your job, since your shadow has
    // the same job as you. If there's multiple of one job, or a shadow has
    // a job of 0 (player died), then return '?' for the affected players.
    id: 'E10S Shadow Of A Hero',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Shadow Of A Hero'
    },
    condition: data => data.clones,
    run: (data, matches) => {
      data.myClone ??= [];
      const clonesJob = parseInt(matches.job, 16);
      if (clonesJob === util/* default.jobToJobEnum */.Z.jobToJobEnum(data.job)) data.myClone.push(matches.id.toUpperCase());
    }
  }, {
    id: 'E10S Shadow Of A Hero Head Marker Map',
    type: 'HeadMarker',
    netRegex: {
      target: 'Shadow Of A Hero'
    },
    condition: data => !data.shadowMarkerMap,
    suppressSeconds: 1,
    run: (data, matches) => {
      data.shadowMarkerMap = {};
      const idPivot = parseInt(matches.id, 16);
      for (let i = 0; i < 3; ++i) {
        const hexPivot = (idPivot + i).toString(16).toUpperCase().padStart(4, '0');
        data.shadowMarkerMap[hexPivot] = i + 1;
      }
    }
  }, {
    id: 'E10S Shadow Of A Hero Head Marker',
    type: 'HeadMarker',
    netRegex: {
      target: 'Shadow Of A Hero'
    },
    condition: data => !data.headMarkerTriggered,
    durationSeconds: 7,
    alertText: (data, matches, output) => {
      if (!data.myClone || data.myClone.length !== 1) {
        data.headMarkerTriggered = true;
        return output.unknown();
      }
      if (matches.targetId === data.myClone[0]) {
        data.headMarkerTriggered = true;
        return output[data.shadowMarkerMap?.[matches.id] ?? 'unknown']();
      }
    },
    outputStrings: {
      '1': outputs/* default.num1 */.Z.num1,
      '2': outputs/* default.num2 */.Z.num2,
      '3': outputs/* default.num3 */.Z.num3,
      'unknown': outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'E10S Dualspell 1',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '573A',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '1 out, 2+3 in',
        de: '1 raus, 2+3 rein',
        fr: '1 extérieur, 2+3 intérieur',
        ja: '1番入らない、2/3番入る',
        cn: '麻将1出，2+3进',
        ko: '1 바깥, 2+3 안쪽'
      }
    }
  }, {
    id: 'E10S Dualspell 2',
    type: 'Ability',
    netRegex: {
      source: 'Shadowkeeper',
      id: '573A',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '2 out, 1+3 in',
        de: '2 raus, 1+3 rein',
        fr: '2 extérieur, 1+3 intérieur',
        ja: '2番入らない、1/3番入る',
        cn: '麻将2出，1+3进',
        ko: '2 바깥, 1+3 안쪽'
      }
    }
  }, {
    id: 'E10S Dualspell 3',
    type: 'Ability',
    netRegex: {
      source: 'Shadowkeeper',
      id: '573A',
      capture: false
    },
    delaySeconds: 3,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '3 out, 1+2 in',
        de: '3 raus, 1+2 rein',
        fr: '3 extérieur, 1+2 intérieur',
        ja: '3番入らない、1/2番入る',
        cn: '麻将3出，1+2进',
        ko: '3 바깥, 1+2 안쪽'
      }
    }
  }, {
    id: 'E10S Shadowkeeper 1',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5720',
      capture: false
    },
    suppressSeconds: 99999,
    alertText: (_data, _matches, output) => output.text(),
    run: data => delete data.clones,
    outputStrings: {
      text: {
        en: 'Drop Shadow Out',
        de: 'Schatten draußen ablegen',
        fr: 'Déposez l\'ombre à l\'extérieur',
        ja: '影を外周に捨てる',
        cn: '影子放到外圈',
        ko: '바깥쪽에 그림자 떨어뜨리기'
      }
    }
  }, {
    id: 'E10S Swath of Silence',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadow Of A Hero',
      id: '5BBF',
      capture: false
    },
    suppressSeconds: 3,
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'E10S Distant Scream',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5716',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'E10S Umbral Orbs',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5731',
      capture: false
    },
    // TODO: maybe 4?
    delaySeconds: 3.5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Orbs',
        de: 'Orbs',
        fr: 'Orbes',
        ja: '玉',
        cn: '球',
        ko: '구슬'
      }
    }
  }, {
    id: 'E10S Shadow Warrior',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5739',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Watch Tethered Dog',
        de: 'Achte auf den verbundenen Hund',
        fr: 'Regardez le chien lié',
        ja: '線で繋がった分身を注視',
        cn: '找连线的狗',
        ko: '연결된 쫄 지켜보기'
      }
    }
  }, {
    id: 'E10S Fade To Shadow',
    type: 'StartsUsing',
    // Fade To Shadow starts well before the Cloak of Shadows, so use that instead for initial.
    netRegex: {
      source: 'Shadowkeeper',
      id: '572B',
      capture: false
    },
    delaySeconds: 4,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // TODO: this could be better if we knew where the shadow was
        // TODO: this also happens twice, with tethers
        en: 'Be On Squiggles',
        de: 'Sei auf den geschwungenen Linien',
        fr: 'Allez sur l\'ombre tordue',
        ja: '曲線上待機',
        cn: '站到连线为曲线的一侧',
        ko: '구불구불한 선 쪽으로'
      }
    }
  }, {
    id: 'E10S Cloak Of Shadows',
    type: 'Ability',
    // 5B13/5B14 Cloak Of Shadows both start casting at the same time but go off separately.
    // So, use the initial 5B13 hit to time the move away trigger.
    netRegex: {
      source: 'Shadowkeeper',
      id: '5B13',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Squiggles',
        de: 'Weg von den geschwungenen Linien',
        fr: 'Éloignez-vous de l\'ombre tordue',
        ja: '安置へ',
        cn: '远离连线为曲线的一侧',
        ko: '곧은 선 쪽으로'
      }
    }
  }, {
    // TODO: I saw once a 5700 then 5702 for the second implosion at 452.7
    // TODO: are the double implosions always the same??
    id: 'E10S Quadruple Implosion Howl',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '56FC',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Shadow Side',
        de: 'Schatten Seite',
        fr: 'Allez du côté de l\'ombre',
        ja: '影と同じ側へ',
        cn: '影子同侧',
        ko: '그림자 쪽으로'
      }
    }
  }, {
    id: 'E10S Quadruple Implosion Tail',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5700',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Opposite Shadow',
        de: 'Gegenüber des Schattens',
        fr: 'Allez du côté opposé à l\'ombre',
        ja: '影の反対側へ',
        cn: '影子异侧',
        ko: '그림자 반대쪽'
      }
    }
  }, {
    id: 'E10S Voidgate',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5734',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleaves with towers',
        de: 'Cleaves mit Türmen',
        fr: 'Cleaves avec Tours',
        ja: '従僕 + 塔',
        cn: '影子+塔',
        ko: '기둥이랑 그림자 유도 동시에'
      }
    }
  }, {
    id: 'E10S Voidgate Second Tower',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5734',
      capture: false
    },
    delaySeconds: 23.3,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Towers first, then cleaves',
        de: 'Zuerst Türme, dann cleaves',
        fr: 'Tours en premier puis cleaves',
        ja: 'まずは塔、そして従僕',
        cn: '先塔后影子',
        ko: '기둥 먼저, 그다음 그림자 유도'
      }
    }
  }, {
    id: 'E10S Pitch Bog',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5721',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.seenPitchBog) return output.secondPitchBog();
      return output.firstPitchBog();
    },
    run: data => data.seenPitchBog = true,
    outputStrings: {
      firstPitchBog: {
        en: 'Puddles outside',
        de: 'Flächen nach draußen',
        fr: 'Zones au sol à l\'extérieur',
        ja: '外周に捨てる',
        cn: '点名放到外圈',
        ko: '장판 바깥쪽에 깔기'
      },
      secondPitchBog: {
        en: 'Final Puddle Positions',
        de: 'Flächen interkardinal ablegen',
        fr: 'Zones au sol en intercardinal',
        ja: '最後のスワンプ',
        cn: '最后一次点名放到外圈',
        ko: '각자 장판 위치로'
      }
    }
  }, {
    id: 'E10S Shackled Apart',
    type: 'Tether',
    netRegex: {
      id: '0082'
    },
    condition: (data, matches) => matches.source === data.me || matches.target === data.me,
    alertText: (data, matches, output) => {
      const partner = matches.source === data.me ? matches.target : matches.source;
      return output.text({
        player: data.party.member(partner)
      });
    },
    outputStrings: {
      text: outputs/* default.farTethersWithPlayer */.Z.farTethersWithPlayer
    }
  }, {
    id: 'E10S Shackled Together',
    type: 'Tether',
    netRegex: {
      id: '0081'
    },
    condition: (data, matches) => matches.source === data.me || matches.target === data.me,
    alertText: (data, matches, output) => {
      const partner = matches.source === data.me ? matches.target : matches.source;
      return output.text({
        player: data.party.member(partner)
      });
    },
    outputStrings: {
      text: outputs/* default.closeTethersWithPlayer */.Z.closeTethersWithPlayer
    }
  }, {
    // TODO: this mechanic needs a lot more love
    id: 'E10S Voidgate Amplifier',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shadowkeeper',
      id: '5BCF',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pick up Puddles',
        de: 'Fläche nehmen',
        fr: 'Prenez les zones au sol',
        ja: 'スワンプを踏む',
        cn: '踩放下的沼泽',
        ko: '장판 밟아서 그림자 선 가져오기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Shadowkeeper': 'Schattenkönig',
      'Shadow Of A Hero': 'Schatten eines Helden',
      'Shadefire': 'Schattenfeuer'
    },
    'replaceText': {
      'Deepshadow Nova': 'Dunkelschatten-Nova',
      'Implosion': 'Implosion',
      'Throne Of Shadow': 'Schattenthron',
      'Giga Slash': 'Giga-Schlag',
      'Umbra Smash': 'Schattenschlag',
      'Darkness Unleashed': 'Schattenentfesselung',
      'Shadow\'s Edge': 'Schattenhieb',
      'Shadow Cleave': 'Schattenpein',
      'Dualspell': 'Doppelzauber',
      'Blighting Blitz': 'Vernichtungsaktion',
      'Shadowkeeper': 'Schattenkönig',
      'Swath Of Silence': 'Schwade der Stille',
      'Shadow Servant': 'Schattendiener',
      'Distant Scream': 'Ferner Schrei',
      'Umbral Orbs': 'Schattenkugel',
      'Flameshadow': 'Schattenflamme',
      'Spawn Shadow': 'Schattenerscheinung',
      'Shadow Warrior': 'Schattenkrieger',
      'Fade To Shadow': 'Schattenimmersion',
      'Cloak Of Shadows': 'Mantel des Schattens',
      'Voidgate(?! Amplifier)': 'Nichtsportal',
      'Void Pulse': 'Nichtspulsieren',
      'Pitch Bog': 'Schattensumpf',
      'Shackled Apart': 'Kettenbruch',
      'Voidgate Amplifier': 'Verstärktes Nichtsportal',
      'Shadowy Eruption': 'Schatteneruption',
      'Shackled Together': 'Schattenfesseln',
      'Doom Arc': 'Verhängnisvoller Bogen'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Shadowkeeper': 'Roi De L\'Ombre',
      'Shadow Of A Hero': 'ombre de héros',
      'Shadefire': 'Feu ombral'
    },
    'replaceText': {
      'Deepshadow Nova': 'Nova de la pleine-ombre',
      'Implosion': 'Implosion',
      'Throne Of Shadow': 'Trône de l\'Ombre',
      'Giga Slash': 'Taillade tournoyante',
      'Umbra Smash': 'Fracas ombral',
      'Darkness Unleashed': 'Déchaînement ombral',
      'Shadow\'s Edge': 'Taillade ombrale',
      'Shadow Cleave': 'Fendoir ombral',
      'Dualspell': 'Double sort',
      'Blighting Blitz': 'Frappe putréfiante',
      'Shadowkeeper': 'Ordre royal',
      'Swath Of Silence': 'Fauchage silencieux',
      'Shadow Servant': 'Serviteur de l\'Ombre',
      'Distant Scream': 'Hurlement de l\'Ombre',
      'Umbral Orbs': 'Orbe ombrale',
      'Flameshadow': 'Flamme ombrale',
      'Spawn Shadow': 'Ombres croissantes',
      'Shadow Warrior': 'Ombre du roi',
      'Fade To Shadow': 'Immersion abyssale',
      'Cloak Of Shadows': 'Cape de l\'Ombre',
      'Voidgate(?! Amplifier)': 'Porte du néant',
      'Void Pulse': 'Pulsation du néant',
      'Pitch Bog': 'Marais ombral',
      'Shackled Apart': 'Chaînes de rupture',
      'Voidgate Amplifier': 'Porte du néant amplifiée',
      'Shadowy Eruption': 'Éruption ombrale',
      'Shackled Together': 'Chaînes d\'union',
      'Doom Arc': 'Arc fatal'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Shadowkeeper': '影の王',
      'Shadow Of A Hero': '英雄の影',
      'Shadefire': 'シャドウファイア'
    },
    'replaceText': {
      'Deepshadow Nova': 'ディープシャドウノヴァ',
      'Implosion': 'インプロージョン',
      'Throne Of Shadow': '影の王権',
      'Giga Slash': 'ギガスラッシュ',
      'Umbra Smash': 'アンブラスマッシュ',
      'Darkness Unleashed': 'シャドウアンリーシュ',
      'Shadow\'s Edge': 'シャドウスラッシュ',
      'Shadow Cleave': 'シャドウクリーヴ',
      'Dualspell': 'ダブルスペル',
      'Blighting Blitz': 'ブライティングブリッツ',
      'Shadowkeeper': '影の王命',
      'Swath Of Silence': 'サイレントスアス',
      'Shadow Servant': '影の従僕',
      'Distant Scream': '影の遠吠え',
      'Umbral Orbs': 'アンブラルオーブ',
      'Flameshadow': 'シャドウフレイム',
      'Spawn Shadow': 'スポーンシャドウ',
      'Shadow Warrior': '影武者',
      'Fade To Shadow': '影潜り',
      'Cloak Of Shadows': 'クローク・オブ・シャドウ',
      'Voidgate(?! Amplifier)': 'ヴォイドゲート',
      'Void Pulse': 'ヴォイドパルセーション',
      'Pitch Bog': 'シャドウスワンプ',
      'Shackled Apart': '離別の鎖',
      'Voidgate Amplifier': 'ヴォイドゲート・アンプリファイア',
      'Shadowy Eruption': 'シャドウエラプション',
      'Shackled Together': '束縛の鎖',
      'Doom Arc': 'ドゥームアーク'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Shadowkeeper': '影之王',
      'Shadow Of A Hero': '英雄之影',
      'Shadefire': '影火炎'
    },
    'replaceText': {
      'Deepshadow Nova': '深影新星',
      'Implosion': '向心聚爆',
      'Throne Of Shadow': '影之王权',
      'Giga Slash': '十亿斩击',
      'Umbra Smash': '本影爆碎',
      'Darkness Unleashed': '释影',
      'Shadow\'s Edge': '影之斩击',
      'Shadow Cleave': '影裂',
      'Dualspell': '双重咏唱',
      'Blighting Blitz': '凋零闪击',
      'Shadowkeeper': '影之王命',
      'Swath Of Silence': '寂静斩痕',
      'Shadow Servant': '影仆从',
      'Distant Scream': '影之狂吠',
      'Umbral Orbs': '本影球',
      'Flameshadow': '影烈火',
      'Spawn Shadow': '影之增殖',
      'Shadow Warrior': '影武者',
      'Fade To Shadow': '潜影',
      'Cloak Of Shadows': '影之披风',
      'Voidgate(?! Amplifier)': '虚无之门',
      'Void Pulse': '虚无悸动',
      'Pitch Bog': '影之沼泽',
      'Shackled Apart': '离别之锁',
      'Voidgate Amplifier': '扩大虚无之门',
      'Shadowy Eruption': '影之喷发',
      'Shackled Together': '束缚之锁',
      'Doom Arc': '毁灭之弧'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Shadowkeeper': '그림자의 왕',
      'Shadow Of A Hero': '영웅의 그림자',
      'Shadefire': '그림자 불씨'
    },
    'replaceText': {
      'Deepshadow Nova': '암영 신성',
      'Implosion': '내파',
      'Throne Of Shadow': '그림자의 왕권',
      'Giga Slash': '기가 슬래시',
      'Umbra Smash': '그림자 타격',
      'Darkness Unleashed': '그림자 촉발',
      'Shadow\'s Edge': '그림자 참격',
      'Shadow Cleave': '그림자 가르기',
      'Dualspell': '이중 시전',
      'Blighting Blitz': '황폐화 맹공',
      'Shadowkeeper': '그림자의 왕명',
      'Swath Of Silence': '침묵의 낫',
      'Shadow Servant': '그림자 하인',
      'Distant Scream': '그림자의 울부짖음',
      'Umbral Orbs': '그림자 구슬',
      'Flameshadow': '그림자 불꽃',
      'Spawn Shadow': '그림자 생성',
      'Shadow Warrior': '그림자 무사',
      'Fade To Shadow': '그림자 잠행',
      'Cloak Of Shadows': '그림자 외투',
      'Voidgate(?! Amplifier)': '보이드의 문',
      'Void Pulse': '보이드의 고동',
      'Pitch Bog': '그림자 늪',
      'Shackled Apart': '이별의 사슬',
      'Voidgate Amplifier': '확대된 보이드의 문',
      'Shadowy Eruption': '그림자 분출',
      'Shackled Together': '속박의 사슬',
      'Doom Arc': '멸망의 궤도'
    }
  }]
};
/* harmony default export */ const e10s = (e10s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e10s.txt
const raid_e10s_namespaceObject = "### Eden 10 (Savage)\r\n# Eden's Promise: Litany (Savage)\r\n# -ii 5B0A 5740 56EC 5726 5719 5725 5BD0 571C 5BA8 571B 517E 5709 570D 56E9 5722 571E 5732 573D 573C 5723 56EF\r\n# -p 573E:11.3\r\n\r\n# TODO: is 5B08 \"--middle--\"? or just \"--sync--\"?\r\n\r\n# Elided for brevity:\r\n# * \"Blighting Burst\" (573D) happens at the same time as \"Blighting Blitz\" (573B)\r\n# * \"Shadefire\" (5732) happens at the same time as \"Flameshadow\" (5733)\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11.3 \"Deepshadow Nova\" Ability { id: \"573E\", source: \"Shadowkeeper\" } window 12,10\r\n24.5 \"Implosion\" Ability { id: \"56F[03]\", source: \"Shadowkeeper\" }\r\n33.3 \"Throne Of Shadow\" Ability { id: \"5717\", source: \"Shadowkeeper\" }\r\n40.9 \"Giga Slash\" Ability { id: \"56E[AD]\", source: \"Shadowkeeper\" }\r\n53.2 \"Umbra Smash\" Ability { id: \"5BAA\", source: \"Shadowkeeper\" }\r\n54.8 \"Umbra Smash\" #Ability { id: \"5724\", source: \"Shadowkeeper\" }\r\n56.4 \"Umbra Smash\" #Ability { id: \"5724\", source: \"Shadowkeeper\" }\r\n58.0 \"Umbra Smash\" #Ability { id: \"5724\", source: \"Shadowkeeper\" }\r\n66.1 \"Darkness Unleashed / Shadow's Edge\" Ability { id: \"5B0[CE]\", source: \"Shadowkeeper\" }\r\n80.9 \"Shadow Cleave\" Ability { id: \"5718\", source: \"Shadowkeeper\" }\r\n94.0 \"Dualspell\" Ability { id: \"573A\", source: \"Shadowkeeper\" }\r\n94.0 \"Blighting Blitz\" Ability { id: \"573B\", source: \"Shadowkeeper\" }\r\n97.0 \"Blighting Blitz\" Ability { id: \"573B\", source: \"Shadowkeeper\" }\r\n100.0 \"Blighting Blitz\" Ability { id: \"573B\", source: \"Shadowkeeper\" }\r\n107.4 \"Shadowkeeper\" Ability { id: \"5720\", source: \"Shadowkeeper\" }\r\n110.5 \"Swath Of Silence\" Ability { id: \"5BBF\", source: \"Shadow Of A Hero\" }\r\n119.8 \"Umbra Smash\" Ability { id: \"5BAA\", source: \"Shadowkeeper\" }\r\n121.4 \"Umbra Smash\" #Ability { id: \"5724\", source: \"Shadowkeeper\" }\r\n123.0 \"Umbra Smash\" #Ability { id: \"5724\", source: \"Shadowkeeper\" }\r\n124.6 \"Umbra Smash\" #Ability { id: \"5724\", source: \"Shadowkeeper\" }\r\n132.7 \"Darkness Unleashed / Shadow's Edge\" Ability { id: \"5B0[CE]\", source: \"Shadowkeeper\" }\r\n144.3 \"Shadow Servant\" Ability { id: \"5704\", source: \"Shadowkeeper\" }\r\n159.4 \"Giga Slash\" Ability { id: \"5B2[CD]\", source: \"Shadowkeeper\" }\r\n177.5 \"Giga Slash\" Ability { id: \"5B2[CD]\", source: \"Shadowkeeper\" }\r\n191.2 \"Distant Scream\" Ability { id: \"5716\", source: \"Shadowkeeper\" }\r\n199.7 \"Umbral Orbs\" Ability { id: \"5730\", source: \"Shadowkeeper\" }\r\n209.5 \"Flameshadow\" Ability { id: \"5733\", source: \"Shadefire\" }\r\n211.9 \"--sync--\" Ability { id: \"5B08\", source: \"Shadowkeeper\" }\r\n217.3 \"Spawn Shadow\" Ability { id: \"5727\", source: \"Shadowkeeper\" }\r\n223.4 \"Shadow Warrior\" Ability { id: \"5739\", source: \"Shadowkeeper\" }\r\n229.5 \"Umbral Orbs\" Ability { id: \"5730\", source: \"Shadowkeeper\" }\r\n239.3 \"Flameshadow\" Ability { id: \"5733\", source: \"Shadefire\" }\r\n253.7 \"Deepshadow Nova\" Ability { id: \"573E\", source: \"Shadowkeeper\" }\r\n261.9 \"--sync--\" Ability { id: \"5B08\", source: \"Shadowkeeper\" }\r\n267.1 \"Fade To Shadow\" Ability { id: \"572B\", source: \"Shadowkeeper\" }\r\n279.4 \"Implosion\" Ability { id: \"56F[03]\", source: \"Shadowkeeper\" }\r\n280.7 \"Cloak Of Shadows\" Ability { id: \"5B13\", source: \"Shadowkeeper\" }\r\n285.7 \"Cloak Of Shadows\" Ability { id: \"5B14\", source: \"Shadowkeeper\" }\r\n290.7 \"Deepshadow Nova\" Ability { id: \"573E\", source: \"Shadowkeeper\" }\r\n306.0 \"Implosion\" Ability { id: [\"5700\", \"56FC\"], source: \"Shadowkeeper\" }\r\n309.1 \"Implosion\" Ability { id: [\"5701\", \"56FD\"], source: \"Shadowkeeper\" }\r\n312.2 \"Implosion\" Ability { id: [\"5701\", \"56FD\"], source: \"Shadowkeeper\" }\r\n315.3 \"Implosion\" Ability { id: [\"5702\", \"56FE\"], source: \"Shadowkeeper\" }\r\n323.4 \"Deepshadow Nova\" Ability { id: \"573E\", source: \"Shadowkeeper\" }\r\n335.1 \"Throne Of Shadow\" Ability { id: \"5717\", source: \"Shadowkeeper\" }\r\n341.6 \"Umbra Smash\" Ability { id: \"5BAA\", source: \"Shadowkeeper\" }\r\n343.2 \"Umbra Smash\" #Ability { id: \"5724\", source: \"Shadowkeeper\" }\r\n344.8 \"Umbra Smash\" #Ability { id: \"5724\", source: \"Shadowkeeper\" }\r\n346.4 \"Umbra Smash\" #Ability { id: \"5724\", source: \"Shadowkeeper\" }\r\n354.5 \"Darkness Unleashed / Shadow's Edge\" Ability { id: \"5B0[CE]\", source: \"Shadowkeeper\" }\r\n367.1 \"Voidgate\" Ability { id: \"5734\", source: \"Shadowkeeper\" }\r\n373.3 \"Shadow Servant\" Ability { id: \"5704\", source: \"Shadowkeeper\" }\r\n384.2 \"Void Pulse\" Ability { id: \"5735\", source: \"Shadowkeeper\" }\r\n388.4 \"Giga Slash\" Ability { id: \"5B2[CD]\", source: \"Shadowkeeper\" }\r\n401.9 \"Void Pulse\" Ability { id: \"5735\", source: \"Shadowkeeper\" }\r\n409.5 \"Giga Slash\" Ability { id: \"5B2[CD]\", source: \"Shadowkeeper\" }\r\n425.7 \"Pitch Bog\" Ability { id: \"5721\", source: \"Shadowkeeper\" }\r\n431.0 \"Umbral Orbs\" Ability { id: \"5731\", source: \"Shadowkeeper\" }\r\n438.9 \"Distant Scream\" Ability { id: \"5716\", source: \"Shadowkeeper\" }\r\n440.9 \"Flameshadow\" Ability { id: \"5733\", source: \"Shadefire\" }\r\n449.6 \"Implosion\" Ability { id: [\"5700\", \"56FC\"], source: \"Shadowkeeper\" }\r\n452.7 \"Implosion\" Ability { id: [\"5702\", \"5701\", \"56FE\"], source: \"Shadowkeeper\" }\r\n464.8 \"Deepshadow Nova\" Ability { id: \"573E\", source: \"Shadowkeeper\" }\r\n476.0 \"Shackled Apart\" Ability { id: \"5BAC\", source: \"Shadowkeeper\" }\r\n478.5 \"--sync--\" Ability { id: \"5B08\", source: \"Shadowkeeper\" }\r\n483.7 \"Fade To Shadow\" Ability { id: \"572B\", source: \"Shadowkeeper\" }\r\n491.9 \"Umbral Orbs\" Ability { id: \"5730\", source: \"Shadowkeeper\" }\r\n497.3 \"Cloak Of Shadows\" Ability { id: \"5B13\", source: \"Shadowkeeper\" }\r\n502.3 \"Cloak Of Shadows\" Ability { id: \"5B14\", source: \"Shadowkeeper\" }\r\n503.7 \"Flameshadow\" Ability { id: \"5733\", source: \"Shadefire\" }\r\n516.0 \"Deepshadow Nova\" Ability { id: \"573E\", source: \"Shadowkeeper\" }\r\n531.6 \"Throne Of Shadow\" Ability { id: \"5717\", source: \"Shadowkeeper\" }\r\n538.2 \"Pitch Bog\" Ability { id: \"5721\", source: \"Shadowkeeper\" }\r\n546.6 \"Giga Slash\" Ability { id: [\"56F8\", \"56F4\"], source: \"Shadowkeeper\" }\r\n549.7 \"Giga Slash\" Ability { id: [\"56F9\", \"56F5\"], source: \"Shadowkeeper\" }\r\n552.8 \"Giga Slash\" Ability { id: [\"56F9\", \"56F5\"], source: \"Shadowkeeper\" }\r\n555.9 \"Giga Slash\" Ability { id: [\"56FA\", \"56F6\"], source: \"Shadowkeeper\" }\r\n563.0 \"Voidgate Amplifier\" Ability { id: \"5BCF\", source: \"Shadowkeeper\" }\r\n570.1 \"Shadowkeeper\" Ability { id: \"5720\", source: \"Shadowkeeper\" }\r\n573.2 \"Swath Of Silence\" Ability { id: \"5BBF\", source: \"Shadow Of A Hero\" }\r\n577.6 \"Void Pulse\" Ability { id: \"5735\", source: \"Shadowkeeper\" }\r\n581.6 \"Shadowy Eruption\" Ability { id: \"5737\", source: \"Shadowkeeper\" }\r\n585.4 \"Shadowy Eruption\" Ability { id: \"5738\", source: \"Shadowkeeper\" }\r\n587.0 \"Shackled Together\" Ability { id: \"572E\", source: \"Shadowkeeper\" }\r\n592.8 \"Void Pulse\" Ability { id: \"5735\", source: \"Shadowkeeper\" }\r\n601.4 \"Umbra Smash\" #Ability { id: \"5BAA\", source: \"Shadowkeeper\" }\r\n603.0 \"Umbra Smash\" #Ability { id: \"5724\", source: \"Shadowkeeper\" }\r\n604.6 \"Umbra Smash\" #Ability { id: \"5724\", source: \"Shadowkeeper\" }\r\n606.2 \"Umbra Smash\" #Ability { id: \"5724\", source: \"Shadowkeeper\" }\r\n614.3 \"Darkness Unleashed / Shadow's Edge\" Ability { id: \"5B0[CE]\", source: \"Shadowkeeper\" }\r\n621.9 \"Umbral Orbs\" Ability { id: \"5731\", source: \"Shadowkeeper\" }\r\n629.8 \"Distant Scream\" Ability { id: \"5716\", source: \"Shadowkeeper\" }\r\n631.7 \"Flameshadow\" Ability { id: \"5733\", source: \"Shadefire\" }\r\n642.3 \"Deepshadow Nova\" Ability { id: \"573E\", source: \"Shadowkeeper\" }\r\n654.5 \"Deepshadow Nova\" Ability { id: \"573E\", source: \"Shadowkeeper\" }\r\n662.7 \"Deepshadow Nova\" Ability { id: \"573E\", source: \"Shadowkeeper\" }\r\n\r\n### TODO: is this enrage??\r\n675.8 \"Doom Arc\" Ability { id: \"5741\", source: \"Shadowkeeper\" }\r\n677.5 \"Doom Arc\" Ability { id: \"5742\", source: \"Shadowkeeper\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e11n.ts




// EDEN'S PROMISE: ANAMORPHOSIS
// E11 NORMAL

// TODO: Handle Bound of Faith
// TODO: Callouts for the intermission Burnt Strike
// TODO: See whether it's possible to math out the spawn locations for Blasting Zone

// sinsmite = lightning elemental break
// sinsmoke = fire elemental break
// sinsight = light elemental break
// blastburn = burnt strike fire knockback
// burnout = burnt strike lightning out
// shining blade = burnt strike light bait
const tetherIds = ['0002', '0005', '0006'];
const boundOfFaithFireTetherResponse = (data, _matches, output) => {
  // cactbot-builtin-response
  output.responseOutputStrings = {
    stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
    stackOnPlayer: outputs/* default.stackOnPlayer */.Z.stackOnPlayer,
    unknownTarget: outputs/* default.unknown */.Z.unknown
  };
  const targets = Object.keys(data.tethers || {});
  if (targets.includes(data.me)) return {
    alertText: output.stackOnYou()
  };
  if (targets.length === 0) return {
    alertText: output.stackOnPlayer({
      player: output.unknownTarget()
    })
  };
  return {
    alertText: output.stackOnPlayer({
      player: data.party.member(targets[0])
    })
  };
};
const boundOfFaithLightningTetherResponse = (data, _matches, output) => {
  // cactbot-builtin-response
  output.responseOutputStrings = {
    onYou: {
      en: 'Lightning on YOU',
      de: 'Blitz auf DIR',
      fr: 'Éclair sur VOUS',
      ja: '自分に感電',
      cn: '雷点名',
      ko: '번개징 대상자'
    },
    tetherInfo: {
      en: 'Lightning on ${player}',
      de: 'Blitz auf ${player}',
      fr: 'Éclair sur ${player}',
      ja: '${player}に感電',
      cn: '雷点${player}',
      ko: '"${player}" 번개징 대상자'
    },
    unknownTarget: outputs/* default.unknown */.Z.unknown
  };
  const targets = Object.keys(data.tethers || {});
  if (targets.includes(data.me)) return {
    alarmText: output.onYou()
  };
  const target = targets.length === 1 ? data.party.member(targets[0]) : output.unknownTarget();
  return {
    infoText: output.tetherInfo({
      player: target
    })
  };
};
const boundOfFaithHolyTetherResponse = (data, _matches, output) => {
  // cactbot-builtin-response
  output.responseOutputStrings = {
    awayFromGroup: outputs/* default.awayFromGroup */.Z.awayFromGroup,
    awayFromPlayer: outputs/* default.awayFromPlayer */.Z.awayFromPlayer,
    unknownTarget: outputs/* default.unknown */.Z.unknown
  };
  const targets = Object.keys(data.tethers || {});
  if (targets.includes(data.me)) return {
    alarmText: output.awayFromGroup()
  };
  if (targets.length === 0) return {
    infoText: output.awayFromPlayer({
      player: output.unknownTarget()
    })
  };
  return {
    infoText: output.awayFromPlayer({
      player: data.party.member(targets[0])
    })
  };
};
const e11n_triggerSet = {
  id: 'EdensPromiseAnamorphosis',
  zoneId: zone_id/* default.EdensPromiseAnamorphosis */.Z.EdensPromiseAnamorphosis,
  timelineFile: 'e11n.txt',
  triggers: [{
    id: 'E11N Burnished Glory',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5650',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E11N Powder Mark',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '564E'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E11N Powder Mark Explosion',
    type: 'GainsEffect',
    netRegex: {
      source: 'Fatebreaker',
      effectId: '993'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 4,
    alertText: (_data, _matches, output) => output.awayFromGroup(),
    outputStrings: {
      awayFromGroup: outputs/* default.awayFromGroup */.Z.awayFromGroup
    }
  }, {
    id: 'E11N Burnt Strike Fire',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '562C',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Cleave -> Knockback',
        de: 'Linien AoE -> Rückstoß',
        fr: 'AoE en ligne -> Poussée',
        ja: '直線AoE -> ノックバック',
        cn: '直线AoE -> 击退',
        ko: '직선 장판 -> 넉백'
      }
    }
  }, {
    id: 'E11N Burnt Strike Lightning',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '562E',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Cleave -> Out',
        de: 'Linien AoE -> Raus',
        fr: 'AoE en ligne -> Extérieur',
        ja: '直線AoE -> 離れる',
        cn: '直线AoE -> 远离',
        ko: '직선 장판 -> 바깥으로'
      }
    }
  }, {
    id: 'E11N Burnt Strike Holy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5630',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Cleave + Bait',
        de: 'Linien AoE -> Ködern',
        fr: 'AoE en ligne -> Déposez au sol',
        ja: '直線AoE -> 誘導',
        cn: '直线AoE+放置点名',
        ko: '직선 장판 + 장판 유도'
      }
    }
  }, {
    id: 'E11N Burnt Strike Lightning Clone',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker\'s Image',
      id: '5645',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge Lightning First -> Rotate For Fire',
        de: 'Weiche zuerst Blitz aus -> Rotiere für Feuer',
        fr: 'Évitez l\'éclair d\'abord -> Tournez pour le Feu',
        ja: '雷を避ける -> 炎 準備',
        cn: '躲雷 -> 火击退',
        ko: '번개 먼저 피하고 -> 회전해서 화염 피하기'
      }
    }
  }, {
    id: 'E11N Burnt Strike Fire Clone',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker\'s Image',
      id: '5643',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fire Knockback After Lightning',
        de: 'Feuer Rückstoß nach Blitz',
        fr: 'Poussée du Feu après l\'Éclair',
        ja: '雷 -> 炎ノックバック',
        cn: '雷 -> 火击退',
        ko: '번개 다음 화염 넉백'
      }
    }
  }, {
    id: 'E11N Bound Of Faith Tether Collector',
    type: 'Tether',
    netRegex: {
      id: tetherIds
    },
    run: (data, matches) => {
      data.tethers ??= {};
      data.tethers[matches.target] = matches.sourceId;
    }
  }, {
    id: 'E11N Bound Of Faith Tether Collector Cleanup',
    type: 'Tether',
    netRegex: {
      id: tetherIds,
      capture: false
    },
    delaySeconds: 20,
    run: data => delete data.tethers
  }, {
    id: 'E11N Bound Of Faith Fire',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '4B18',
      capture: false
    },
    response: boundOfFaithFireTetherResponse
  }, {
    id: 'E11N Bound Of Faith Lightning',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '4B19',
      capture: false
    },
    response: boundOfFaithLightningTetherResponse
  }, {
    id: 'E11N Bound Of Faith Holy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '4B1B',
      capture: false
    },
    response: boundOfFaithHolyTetherResponse
  }, {
    id: 'E11N Turn of the Heavens Fire',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5639',
      capture: false
    },
    durationSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fire: Go to Blue',
        de: 'Feuer: Geh zu Blau',
        fr: 'Feu : Allez sur le Bleu',
        ja: '炎: 雷側へ',
        cn: '火：去蓝门一侧',
        ko: '화염: 파랑으로'
      }
    }
  }, {
    id: 'E11N Turn of the Heavens Lightning',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '563A',
      capture: false
    },
    durationSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Lightning: Go to Red',
        de: 'Blitz: Geh zu Rot',
        fr: 'Éclair : Allez sur le Rouge',
        ja: '雷: 炎側へ',
        cn: '雷：去红门一侧',
        ko: '번개: 빨강으로'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Demi-Gukumatz': 'Demi-Gukumatz',
      'Fatebreaker(?!\'s Image)': 'fusioniert(?:e|er|es|en) Ascian',
      'Fatebreaker\'s Image': 'Abbild des fusionierten Ascians',
      'Halo Of Flame': 'Halo der Flamme'
    },
    'replaceText': {
      'Ageless Serpent': 'Alterslose Schlange',
      'Blastburn': 'Brandstoß',
      'Blasting Zone': 'Erda-Detonation',
      'Brightfire': 'Lichtflamme',
      '(?<!Mortal )Burn Mark': 'Brandmal',
      'Burnished Glory': 'Leuchtende Aureole',
      'Burnout': 'Brandentladung',
      'Burnt Strike': 'Brandschlag',
      'Floating Fetters': 'Schwebende Fesseln',
      'Mortal Burn Mark': 'Brandmal der Sterblichen',
      'Powder Mark': 'Pulvermal',
      'Prismatic Deception': 'Prismatische Unsichtbarkeit',
      'Resounding Crack': 'Gewaltiger Bruch',
      'Shifting Sky': 'Himmelsverschiebung',
      'Shining Blade': 'Leuchtende Klinge',
      'Sinsight': 'Sündenlicht',
      'Sinsmite': 'Sündenblitz',
      'Sinsmoke': 'Sündenflamme',
      'Solemn Charge': 'Wütende Durchbohrung',
      'Turn Of The Heavens': 'Kreislauf der Wiedergeburt'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Demi-Gukumatz': 'demi-Gukumatz',
      'Fatebreaker(?!\'s Image)': 'Sabreur de destins',
      'Fatebreaker\'s Image': 'double du Sabreur de destins',
      'Halo Of Flame': 'halo de feu'
    },
    'replaceText': {
      '\\?': ' ?',
      'Ageless Serpent': 'Serpent éternel',
      'Blastburn': 'Explosion brûlante',
      'Blasting Zone': 'Zone de destruction',
      'Brightfire': 'Flammes de Lumière',
      '(?<!Mortal )Burn Mark': 'Marque explosive',
      'Burnished Glory': 'Halo luminescent',
      'Burnout': 'Combustion totale',
      'Burnt Strike': 'Frappe brûlante',
      'Floating Fetters': 'Entraves flottantes',
      'Mortal Burn Mark': 'Marque de conflagration',
      'Powder Mark': 'Marquage fatal',
      'Prismatic Deception': 'Invisibilité prismatique',
      'Resounding Crack': 'Turbulence magique',
      'Shifting Sky': 'Percée céleste ultime',
      'Shining Blade': 'Lame étincelante',
      'Sinsight': 'Lumière du péché',
      'Sinsmite': 'Éclair du péché',
      'Sinsmoke': 'Flammes du péché',
      'Solemn Charge': 'Charge perçante',
      'Turn Of The Heavens': 'Cercles rituels'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Demi-Gukumatz': 'デミグクマッツ',
      'Fatebreaker(?!\'s Image)': 'フェイトブレイカー',
      'Fatebreaker\'s Image': 'フェイトブレイカーの幻影',
      'Halo Of Flame': '焔の光輪'
    },
    'replaceText': {
      'Ageless Serpent': '龍頭龍尾',
      'Blastburn': 'バーンブラスト',
      'Blasting Zone': 'ブラスティングゾーン',
      'Brightfire': '光炎',
      '(?<!Mortal )Burn Mark': '爆印',
      'Burnished Glory': '光焔光背',
      'Burnout': 'バーンアウト',
      'Burnt Strike': 'バーンストライク',
      'Floating Fetters': '浮遊拘束',
      'Mortal Burn Mark': '大爆印',
      'Powder Mark': '爆印刻',
      'Prismatic Deception': 'プリズマチックインビジブル',
      'Resounding Crack': '魔乱流',
      'Shifting Sky': '至天絶技',
      'Shining Blade': 'シャインブレード',
      'Sinsight': 'シンライト',
      'Sinsmite': 'シンボルト',
      'Sinsmoke': 'シンフレイム',
      'Solemn Charge': 'チャージスラスト',
      'Turn Of The Heavens': '転輪召'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Demi-Gukumatz': '亚灵羽蛇',
      'Fatebreaker(?!\'s Image)': '绝命战士',
      'Fatebreaker\'s Image': '绝命战士的幻影',
      'Halo Of Flame': '焰之光轮'
    },
    'replaceText': {
      'Ageless Serpent': '龙头龙尾',
      'Blastburn': '火燃爆',
      'Blasting Zone': '爆破领域',
      'Brightfire': '光炎',
      '(?<!Mortal )Burn Mark': '爆印',
      'Burnished Glory': '光焰圆光',
      'Burnout': '雷燃爆',
      'Burnt Strike': '燃烧击',
      'Floating Fetters': '浮游拘束',
      'Mortal Burn Mark': '大爆印',
      'Powder Mark': '爆印铭刻',
      'Prismatic Deception': '棱光幻影',
      'Resounding Crack': '魔乱流',
      'Shifting Sky': '至天绝技',
      'Shining Blade': '光明之刃',
      'Sinsight': '罪光',
      'Sinsmite': '罪雷',
      'Sinsmoke': '罪炎',
      'Solemn Charge': '急冲刺',
      'Turn Of The Heavens': '光轮召唤'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Demi-Gukumatz': '데미구쿠마츠',
      'Fatebreaker(?!\'s Image)': '페이트브레이커',
      'Fatebreaker\'s Image': '페이트브레이커의 환영',
      'Halo Of Flame': '화염 빛무리'
    },
    'replaceText': {
      'Ageless Serpent': '용두용미',
      'Blastburn': '연소 폭발',
      'Blasting Zone': '발파 지대',
      'Brightfire': '광염',
      '(?<!Mortal )Burn Mark': '폭인',
      'Burnished Glory': '광염광배',
      'Burnout': '완전 연소',
      'Burnt Strike': '연소 공격',
      'Floating Fetters': '부유 구속',
      'Mortal Burn Mark': '대폭인',
      'Powder Mark': '폭인각',
      'Prismatic Deception': '분광 은신',
      'Resounding Crack': '마난류',
      'Shifting Sky': '지천절기',
      'Shining Blade': '빛나는 칼날',
      'Sinsight': '죄의 빛',
      'Sinsmite': '죄의 번개',
      'Sinsmoke': '죄의 화염',
      'Solemn Charge': '돌진격',
      'Turn Of The Heavens': '빛무리 소환'
    }
  }]
};
/* harmony default export */ const e11n = (e11n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e11n.txt
const raid_e11n_namespaceObject = "### Eden 11 (Normal)\r\n# Eden's Promise: Anamorphosis\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# -ii 366 4B18 4B19 4B1B\r\n\r\n# Opening Block. Introduces Fire/Lightning in a random order.\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11.0 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" } window 11,5\r\n21.8 \"Burnt Strike\" Ability { id: \"562[CE]\", source: \"Fatebreaker\" }\r\n23.5 \"Blastburn/Burnout\" # Ability { id: \"562[DF]\", source: \"Fatebreaker\" }\r\n39.3 \"Floating Fetters\" Ability { id: \"58F4\", source: \"Fatebreaker\" }\r\n41.4 \"Solemn Charge\" Ability { id: \"563[24]\", source: \"Fatebreaker\" }\r\n42.7 \"Sinsmite/Sinsmoke\" Ability { id: \"563[35]\", source: \"Fatebreaker\" }\r\n54.5 \"Burnished Glory\" Ability { id: \"5650\", source: \"Fatebreaker\" } window 54.5,5\r\n65.0 \"Powder Mark\" Ability { id: \"564E\", source: \"Fatebreaker\" }\r\n67.5 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" } window 30,30\r\n78.7 \"Burnt Strike\" Ability { id: \"562[CE]\", source: \"Fatebreaker\" }\r\n78.9 \"Burn Mark\" Ability { id: \"564F\", source: \"Fatebreaker\" }\r\n80.4 \"Blastburn/Burnout\" # Ability { id: \"562[DF]\", source: \"Fatebreaker\" }\r\n88.8 \"Burnished Glory\" Ability { id: \"5650\", source: \"Fatebreaker\" }\r\n103.6 \"Floating Fetters\" Ability { id: \"58F4\", source: \"Fatebreaker\" }\r\n105.6 \"Solemn Charge\" Ability { id: \"563[24]\", source: \"Fatebreaker\" }\r\n106.9 \"Sinsmite/Sinsmoke\" Ability { id: \"563[35]\", source: \"Fatebreaker\" }\r\n\r\n# Turn of the Heavens introduced, random element.\r\n121.7 \"Turn Of The Heavens\" Ability { id: \"563[9A]\", source: \"Fatebreaker\" } window 121.7,5\r\n133.5 \"Brightfire\" # Ability { id: \"563[BC]\", source: \"Halo Of Flame\" }\r\n146.2 \"Burnished Glory\" Ability { id: \"5650\", source: \"Fatebreaker\" }\r\n159.7 \"Shifting Sky\" Ability { id: \"563F\", source: \"Fatebreaker\" } window 159.7,5\r\n162.1 \"--untargetable--\"\r\n\r\n# Single serpent intermission. Lightning Burnt Strike is always first.\r\n167.2 \"--sync--\" Ability { id: \"564B\", source: \"Demi-Gukumatz\" }\r\n167.3 \"Ageless Serpent\" Ability { id: \"564C\", source: \"Demi-Gukumatz\" } window 167.3,5\r\n174.7 \"Resounding Crack\" Ability { id: \"564D\", source: \"Demi-Gukumatz\" }\r\n183.9 \"Burnt Strike\" Ability { id: \"5645\", source: \"Fatebreaker's Image\" }\r\n185.6 \"Burnout\" Ability { id: \"5646\", source: \"Fatebreaker's Image\" }\r\n187.9 \"Burnt Strike\" Ability { id: \"5643\", source: \"Fatebreaker's Image\" }\r\n189.9 \"Blastburn\" Ability { id: \"5644\", source: \"Fatebreaker's Image\" }\r\n195.7 \"--targetable--\"\r\n\r\n# Holy introduction block.\r\n201.9 \"Burnished Glory\" Ability { id: \"5650\", source: \"Fatebreaker\" } window 40,5\r\n213.5 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n224.5 \"Burnt Strike\" Ability { id: \"5630\", source: \"Fatebreaker\" }\r\n229.5 \"Shining Blade\" Ability { id: \"5631\", source: \"Fatebreaker\" }\r\n236.6 \"Burnished Glory\" Ability { id: \"5650\", source: \"Fatebreaker\" }\r\n250.4 \"Floating Fetters\" Ability { id: \"58F4\", source: \"Fatebreaker\" } window 50,30\r\n252.4 \"Solemn Charge\" Ability { id: \"5636\", source: \"Fatebreaker\" }\r\n253.7 \"Sinsight\" Ability { id: \"5637\", source: \"Fatebreaker\" }\r\n259.3 \"Mortal Burn Mark\" Ability { id: \"5638\", source: \"Fatebreaker\" }\r\n260.5 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n269.1 \"Prismatic Deception\" Ability { id: \"563D\", source: \"Fatebreaker\" } window 269.1,5\r\n272.2 \"--untargetable--\"\r\n\r\n# Clone intermission.\r\n294.5 \"Blasting Zone\" Ability { id: \"563E\", source: \"Fatebreaker's Image\" }\r\n300.4 \"--targetable--\"\r\n\r\n# Multi-Strike rotation block\r\n306.5 \"Burnished Glory\" Ability { id: \"5650\", source: \"Fatebreaker\" }\r\n319.1 \"Powder Mark\" Ability { id: \"564E\", source: \"Fatebreaker\" }\r\n329.6 \"Turn Of The Heavens\" Ability { id: \"563[9A]\", source: \"Fatebreaker\" } window 30,30\r\n333.0 \"Burn Mark\" Ability { id: \"564F\", source: \"Fatebreaker\" }\r\n341.4 \"Brightfire\" # Ability { id: \"563[BC]\", source: \"Halo Of Flame\" }\r\n346.1 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n356.8 \"Burnt Strike\" Ability { id: \"56(2C|2E|30)\", source: \"Fatebreaker\" }\r\n358.5 \"Blastburn/Burnout\" # Ability { id: \"56(2D|2F|31)\", source: \"Fatebreaker\" }\r\n369.2 \"Burnt Strike\" Ability { id: \"56(2C|2E|30)\", source: \"Fatebreaker\" }\r\n370.9 \"Blastburn/Burnout\" # Ability { id: \"56(2D|2F|31)\", source: \"Fatebreaker\" }\r\n381.2 \"Burnished Glory\" Ability { id: \"5650\", source: \"Fatebreaker\" }\r\n\r\n# Fetters rotation block\r\n391.7 \"Burnished Glory\" Ability { id: \"5650\", source: \"Fatebreaker\" }\r\n404.2 \"Powder Mark\" Ability { id: \"564E\", source: \"Fatebreaker\" }\r\n414.7 \"Turn Of The Heavens\" Ability { id: \"563[9A]\", source: \"Fatebreaker\" } window 30,30\r\n418.1 \"Burn Mark\" Ability { id: \"564F\", source: \"Fatebreaker\" }\r\n426.5 \"Brightfire\" # Ability { id: \"563[BC]\", source: \"Halo Of Flame\" }\r\n431.2 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n442.1 \"Burnt Strike\" Ability { id: \"56(2C|2E|30)\", source: \"Fatebreaker\" }\r\n446.9 \"Shining Blade\" # Ability { id: \"5631\", source: \"Fatebreaker\" }\r\n454.2 \"Burnished Glory\" Ability { id: \"5650\", source: \"Fatebreaker\" }\r\n466.9 \"Floating Fetters\" Ability { id: \"58F4\", source: \"Fatebreaker\" }\r\n469.0 \"Solemn Charge\" Ability { id: \"563[246]\", source: \"Fatebreaker\" }\r\n470.3 \"Sinsmite/Sinsmoke/Sinsight\" Ability { id: \"563[357]\", source: \"Fatebreaker\" }\r\n475.9 \"Mortal Burn Mark?\" Ability { id: \"5638\", source: \"Fatebreaker\" }\r\n\r\n480.1 \"Burnished Glory\" Ability { id: \"5650\", source: \"Fatebreaker\" } jump 306.5\r\n492.7 \"Powder Mark\"\r\n503.2 \"Turn Of The Heavens\"\r\n506.6 \"Burn Mark\"\r\n515.0 \"Brightfire\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e11s.ts




// TODO: ageless serpent knockback
// TODO: add tank lightning cleave stuff
// TODO: tether during right of the heavens 2
// TODO: burnt strike callouts during shifting/sundered sky
// TODO: move callout for holy burnt strike bait

// Notes:
// sinsmite = lightning elemental break
// sinsmoke = fire elemental break
// sinsight = light elemental break
// blastburn = burnt strike fire knockback
// burnout = burnt strike lightning out
// shining blade = burnt strike light bait
const e11s_boundOfFaithFireTetherResponse = (data, _matches, output) => {
  // cactbot-builtin-response
  output.responseOutputStrings = {
    stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
    stackOnPlayer: outputs/* default.stackOnPlayer */.Z.stackOnPlayer,
    unknownTarget: outputs/* default.unknown */.Z.unknown
  };
  const targets = Object.keys(data.tethers || {});
  if (targets.includes(data.me)) return {
    alertText: output.stackOnYou()
  };
  if (targets.length === 0) return {
    alertText: output.stackOnPlayer({
      player: output.unknownTarget()
    })
  };
  return {
    alertText: output.stackOnPlayer({
      player: data.party.member(targets[0])
    })
  };
};
const e11s_boundOfFaithLightningTetherResponse = (data, _matches, output) => {
  // cactbot-builtin-response
  output.responseOutputStrings = {
    onYou: {
      en: 'Take Lightning To Tanks',
      de: 'Bring Blitz zu den Tanks',
      fr: 'Donnez l\'Éclair au tanks',
      ja: 'タンクに近づく',
      cn: '和T处理雷',
      ko: '번개징 탱커쪽으로'
    },
    tetherInfo: {
      en: 'Lightning on ${player}',
      de: 'Blitz auf ${player}',
      fr: 'Éclair sur ${player}',
      ja: '${player}に感電',
      cn: '雷点${player}',
      ko: '"${player}" 번개징 대상자'
    },
    unknownTarget: outputs/* default.unknown */.Z.unknown
  };
  const targets = Object.keys(data.tethers || {});
  if (targets.includes(data.me)) return {
    alarmText: output.onYou()
  };
  const target = targets.length === 1 ? data.party.member(targets[0]) : output.unknownTarget();
  return {
    infoText: output.tetherInfo({
      player: target
    })
  };
};
const e11s_boundOfFaithHolyTetherResponse = (data, _matches, output) => {
  // cactbot-builtin-response
  output.responseOutputStrings = {
    awayFromGroup: outputs/* default.awayFromGroup */.Z.awayFromGroup,
    awayFromPlayer: outputs/* default.awayFromPlayer */.Z.awayFromPlayer,
    unknownTarget: outputs/* default.unknown */.Z.unknown
  };
  const targets = Object.keys(data.tethers || {});
  if (targets.includes(data.me)) return {
    alarmText: output.awayFromGroup()
  };
  if (targets.length === 0) return {
    infoText: output.awayFromPlayer({
      player: output.unknownTarget()
    })
  };
  return {
    infoText: output.awayFromPlayer({
      player: data.party.member(targets[0])
    })
  };
};
const e11s_triggerSet = {
  id: 'EdensPromiseAnamorphosisSavage',
  zoneId: zone_id/* default.EdensPromiseAnamorphosisSavage */.Z.EdensPromiseAnamorphosisSavage,
  timelineFile: 'e11s.txt',
  triggers: [{
    id: 'E11S Elemental Break Fire',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5663',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Protean -> Partner Stacks',
        de: 'Himmelsrichtung -> Auf Partner sammeln',
        fr: 'Positions -> Packez-vous avec votre partenaire',
        ja: '8方向散開 -> ペア頭割り',
        cn: '八方 -> 分摊',
        ko: '8산개 -> 파트너 쉐어뎀'
      }
    }
  }, {
    id: 'E11S Elemental Break Lightning',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5666',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Protean -> Spread',
        de: 'Himmelsrichtung -> Verteilen',
        fr: 'Positions -> Dispersez-vous',
        ja: '8方向散開 -> 散開',
        cn: '八方 -> 分散',
        ko: '8산개 -> 산개'
      }
    }
  }, {
    id: 'E11S Elemental Break Holy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5668',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Protean -> Holy Groups',
        de: 'Himmelsrichtung -> Sanctus Gruppen',
        fr: 'Positions -> Groupes',
        ja: '8方向散開 -> 光3方向頭割り',
        cn: '八方 -> 光三向分摊',
        ko: '8산개 -> 홀리 그룹 쉐어'
      }
    }
  }, {
    id: 'E11S Burnt Strike Fire',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5652',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Cleave -> Knockback',
        de: 'Linien AoE -> Rückstoß',
        fr: 'AoE en ligne -> Poussée',
        ja: '直線範囲 -> ノックバック',
        cn: '直线 -> 击退',
        ko: '직선 장판 -> 넉백'
      }
    }
  }, {
    id: 'E11S Burnt Strike Lightning',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5654',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Cleave -> Out',
        de: 'Linien AoE -> Raus',
        fr: 'AoE en ligne -> Extérieur',
        ja: '直線範囲 -> 離れる',
        cn: '直线 -> 去外侧',
        ko: '직선 장판 -> 바깥으로'
      }
    }
  }, {
    id: 'E11S Burnt Strike Holy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5656',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Cleave + Bait',
        de: 'Linien AoE -> Ködern',
        fr: 'AoE en ligne -> Déposez au sol',
        ja: '直線範囲 -> AoE誘導',
        cn: '直线 -> 放光点名',
        ko: '직선 장판 + 장판 유도'
      }
    }
  }, {
    id: 'E11S Bound Of Faith Tether Collector',
    type: 'Tether',
    netRegex: {
      id: '0011'
    },
    run: (data, matches) => {
      data.tethers ??= {};
      data.tethers[matches.target] = matches.sourceId;
    }
  }, {
    id: 'E11S Bound Of Faith Tether Collector Cleanup',
    type: 'Tether',
    netRegex: {
      id: '0011',
      capture: false
    },
    delaySeconds: 20,
    run: data => delete data.tethers
  }, {
    id: 'E11S Bound Of Faith Fire',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5658',
      capture: false
    },
    response: e11s_boundOfFaithFireTetherResponse
  }, {
    id: 'E11S Bound Of Faith Lightning',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '565B',
      capture: false
    },
    response: e11s_boundOfFaithLightningTetherResponse
  }, {
    id: 'E11S Bound Of Faith Holy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '565F',
      capture: false
    },
    response: e11s_boundOfFaithHolyTetherResponse
  }, {
    id: 'E11S Bound Of Faith Shifting Sky',
    type: 'StartsUsing',
    // After Shifting Sky, there's a fire (567F) and lightning (5682) Bound Of Faith from Images.
    // After Sundered Sky, there's a fire (567F) and holy (5BC5) Bound Of Faith from Images.
    // These are the only time these Images appear and cast Bound Of Faith,
    // catch the first via 5682 and the second via 5BC5 and call two tethers with one trigger.
    netRegex: {
      source: 'Fatebreaker\'s Image',
      id: '5682'
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        fireTetherOnYou: {
          en: 'Stack With Fire Tether',
          de: 'Auf der Feuer-Verbindung sammeln',
          fr: 'Packez-vous avec le lien de Feu',
          ja: '炎の線を頭割り',
          cn: '和火连线分摊',
          ko: '화염 선 대상자, 쉐어뎀'
        },
        lightningTetherOnYou: {
          en: 'Take Lightning To Tanks',
          de: 'Bring Blitz zum Tank',
          fr: 'Donnez l\'Éclair aux tanks',
          ja: 'タンクに近づく',
          cn: '和T分摊雷',
          ko: '번개 탱커한테 넘기기'
        },
        tetherInfo: {
          en: 'Lightning on ${player1}, Fire on ${player2}',
          de: 'Blitz auf ${player1}, Feuer auf ${player2}',
          fr: 'Éclair sur ${player1}, Feu sur ${player2}',
          ja: '${player1} に雷, ${player2} に炎',
          cn: '雷点${player1}，火点${player2}',
          ko: '"${player1}" 번개, "${player2}" 화염'
        }
      };
      if (!data.tethers) return;
      const targets = Object.keys(data.tethers);
      const [firstTarget, secondTarget] = targets;
      if (firstTarget === undefined || secondTarget === undefined || targets.length !== 2) {
        console.error(`Unknown Sundered Sky tether targets: ${JSON.stringify(data.tethers)}`);
        return;
      }
      let fireTarget;
      let lightningTarget;
      if (data.tethers[firstTarget] === matches.sourceId) {
        lightningTarget = firstTarget;
        fireTarget = secondTarget;
      } else if (data.tethers[secondTarget] === matches.sourceId) {
        fireTarget = firstTarget;
        lightningTarget = secondTarget;
      } else {
        console.error(`Weird Shifting Sky tether targets: ${JSON.stringify(data.tethers)}` + `, ${JSON.stringify(matches)}`);
        return;
      }
      const tetherInfo = output.tetherInfo({
        player1: data.party.member(lightningTarget),
        player2: data.party.member(fireTarget)
      });
      const response = {
        infoText: tetherInfo
      };
      if (lightningTarget === data.me) Object.assign(response, {
        alarmText: output.lightningTetherOnYou()
      });
      if (fireTarget === data.me) Object.assign(response, {
        alertText: output.fireTetherOnYou()
      });
      return response;
    }
  }, {
    id: 'E11S Bound Of Faith Sundered Sky',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker\'s Image',
      id: '5BC5'
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        fireTetherOnYou: {
          en: 'Stack With Fire Tether',
          de: 'Auf der Feuer-Verbindung sammeln',
          fr: 'Packez-vous avec le lien de Feu',
          ja: '炎の線を頭割り',
          cn: '和火连线分摊',
          ko: '화염 선 대상자, 쉐어뎀'
        },
        holyTetherOnYou: outputs/* default.awayFromGroup */.Z.awayFromGroup,
        tetherInfo: {
          en: 'Holy on ${player1}, Fire on ${player2}',
          de: 'Sanctus auf ${player1}, Feuer auf ${player2}',
          fr: 'Sacre sur ${player1}, Feu sur ${player2}',
          ja: '${player1} に光, ${player2} に炎',
          cn: '光点${player1}，火点${player2}',
          ko: '"${player1}" 홀리, "${player2}" 화염'
        }
      };
      if (!data.tethers) return;
      const targets = Object.keys(data.tethers);
      const [firstTarget, secondTarget] = targets;
      if (firstTarget === undefined || secondTarget === undefined || targets.length !== 2) {
        console.error(`Unknown Sundered Sky tether targets: ${JSON.stringify(data.tethers)}`);
        return;
      }
      let fireTarget;
      let holyTarget;
      if (data.tethers[firstTarget] === matches.sourceId) {
        holyTarget = firstTarget;
        fireTarget = secondTarget;
      } else if (data.tethers[secondTarget] === matches.sourceId) {
        fireTarget = firstTarget;
        holyTarget = secondTarget;
      } else {
        console.error(`Weird Sundered Sky tether targets: ${JSON.stringify(data.tethers)}` + `, ${JSON.stringify(matches)}`);
        return;
      }
      const tetherInfo = output.tetherInfo({
        player1: data.party.member(holyTarget),
        player2: data.party.member(fireTarget)
      });
      const response = {
        infoText: tetherInfo
      };
      if (holyTarget === data.me) Object.assign(response, {
        alarmText: output.holyTetherOnYou()
      });
      if (fireTarget === data.me) Object.assign(response, {
        alertText: output.fireTetherOnYou()
      });
      return response;
    }
  }, {
    id: 'E11S Burnished Glory',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '56A4',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'E11S Powder Mark',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '56A2'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'E11S Powder Mark Explosion',
    type: 'GainsEffect',
    netRegex: {
      source: 'Fatebreaker',
      effectId: '993'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 4,
    alertText: (_data, _matches, output) => output.awayFromGroup(),
    outputStrings: {
      awayFromGroup: outputs/* default.awayFromGroup */.Z.awayFromGroup
    }
  }, {
    id: 'E11S Turn of the Heavens Fire',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '566A',
      capture: false
    },
    durationSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fire: Go to Blue',
        de: 'Feuer: Geh zu Blau',
        fr: 'Feu : Allez sur le Bleu',
        ja: '炎: 安置は青',
        cn: '火：去蓝门',
        ko: '화염: 파랑으로'
      }
    }
  }, {
    id: 'E11S Turn of the Heavens Lightning',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '566B',
      capture: false
    },
    durationSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Lightning: Go to Red',
        de: 'Blitz: Geh zu Rot',
        fr: 'Éclair : Allez sur le Rouge',
        ja: '雷: 安置は赤',
        cn: '雷：去红门',
        ko: '번개: 빨강으로'
      }
    }
  }, {
    id: 'E11S Shifting Sky Fire',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5675',
      capture: false
    },
    durationSeconds: 17,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fire: Go to Blue',
        de: 'Feuer: Geh zu Blau',
        fr: 'Feu : Allez sur le Bleu',
        ja: '炎: 安置は青',
        cn: '火：去蓝门',
        ko: '화염: 파랑으로'
      }
    }
  }, {
    id: 'E11S Shifting Sky Lightning',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5676',
      capture: false
    },
    durationSeconds: 17,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Lightning: Go to Red',
        de: 'Blitz: Geh zu Rot',
        fr: 'Éclair : Allez sur le Rouge',
        ja: '雷: 安置は赤',
        cn: '雷：去红门',
        ko: '번개: 빨강으로'
      }
    }
  }, {
    id: 'E11S Right Of The Heavens Fire',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '566E',
      capture: false
    },
    durationSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fire: Go to Blue',
        de: 'Feuer: Geh zu Blau',
        fr: 'Feu : Allez sur le Bleu',
        ja: '炎: 安置は青',
        cn: '火：去蓝门',
        ko: '화염: 파랑으로'
      }
    }
  }, {
    id: 'E11S Right Of The Heavens Lightning',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '566F',
      capture: false
    },
    durationSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Lightning: Go to Red',
        de: 'Blitz: Geh zu Rot',
        fr: 'Éclair : Allez sur le Rouge',
        ja: '雷: 安置は赤',
        cn: '雷：去红门',
        ko: '번개: 빨강으로'
      }
    }
  }, {
    id: 'E11S Sundered Sky Fire',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5677',
      capture: false
    },
    durationSeconds: 16,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fire: Knockback To Red -> Go Blue',
        de: 'Feuer: Rückstoß zu Rot -> Geh zu Blau',
        fr: 'Feu : Poussée sur le Rouge -> Allez sur le Bleu',
        ja: '炎: 赤にノックバック -> 青へ',
        cn: '火：向红门击退 -> 去蓝门',
        ko: '화염: 빨강으로 넉백 -> 파랑으로 이동'
      }
    }
  }, {
    id: 'E11S Sundered Sky Lightning',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5678',
      capture: false
    },
    durationSeconds: 16,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Lightning: Knockback To Blue -> Go Red',
        de: 'Blitz: Rückstoß zu Blau -> Geh zu Rot',
        fr: 'Éclair : Poussée sur le Bleu -> Allez sur le Rouge',
        ja: '雷: 青にノックバック -> 赤へ',
        cn: '雷：向蓝门击退 -> 去红门',
        ko: '번개: 파랑으로 넉백 -> 빨강으로 이동'
      }
    }
  }, {
    id: 'E11S Cycle of Faith Fire',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '568A',
      capture: false
    },
    durationSeconds: 12,
    infoText: (_data, _matches, output) => output.text(),
    tts: (_data, _matches, output) => output.ttsText(),
    outputStrings: {
      text: {
        en: 'Protean -> Partner Stacks -> Line Cleave -> Knockback -> Stack',
        de: 'Himmelsrichtung -> Auf Partner sammeln -> Linien AoE -> Rückstoß -> Sammeln',
        fr: 'Positions -> Packez-vous avec votre partenaire -> Aoe en ligne -> Poussée -> Package',
        ja: '8方向散開 -> 2人頭割り -> 直線範囲 -> ノックバック -> 頭割り',
        cn: '八方 -> 分摊 -> 直线 -> 击退 -> 集合',
        ko: '8산개 -> 파트너 쉐어뎀 -> 직선 장판 -> 넉백 -> 모이기'
      },
      ttsText: {
        en: 'Fire Cycle',
        de: 'Mehrfache Vergeltung: Feuer',
        fr: 'Multi-taillade : Feu',
        ja: '魔装連続剣：ファイア',
        cn: '火连续剑',
        ko: '연속검: 화염'
      }
    }
  }, {
    id: 'E11S Cycle of Faith Fire Tether',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '568A',
      capture: false
    },
    delaySeconds: 16.5,
    response: e11s_boundOfFaithFireTetherResponse
  }, {
    id: 'E11S Cycle of Faith Lightning',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5692',
      capture: false
    },
    durationSeconds: 12,
    infoText: (_data, _matches, output) => output.text(),
    tts: (_data, _matches, output) => output.ttsText(),
    outputStrings: {
      text: {
        en: 'Protean -> Spread -> Line Cleave -> Out -> Tank Cleaves',
        de: 'Himmelsrichtung -> Verteilen -> Linien AoE -> Raus -> Tank AoEs',
        fr: 'Positions -> Dispersez-vous -> AoE en ligne -> Extérieur -> Tank cleaves',
        ja: '8方向散開 -> 散開 -> 直線範囲 -> 離れる -> タンクに雷範囲',
        cn: '八方 -> 分散 -> 直线 -> 远离直线 -> T接雷',
        ko: '8산개 -> 산개 -> 직선 장판 -> 밖으로 -> 광역 탱버'
      },
      ttsText: {
        en: 'Lightning Cycle',
        de: 'Mehrfache Vergeltung : Blitz',
        fr: 'Multi-taillade: Foudre',
        ja: '魔装連続剣：いなずま',
        cn: '雷连续剑',
        ko: '연속검: 번개'
      }
    }
  }, {
    id: 'E11S Cycle of Faith Lightning Tether',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '5692',
      capture: false
    },
    delaySeconds: 16.5,
    response: e11s_boundOfFaithLightningTetherResponse
  }, {
    id: 'E11S Cycle of Faith Holy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '569A',
      capture: false
    },
    durationSeconds: 12,
    infoText: (_data, _matches, output) => output.text(),
    tts: (_data, _matches, output) => output.ttsText(),
    outputStrings: {
      text: {
        en: 'Protean -> Holy Groups -> Line Cleave -> Bait -> Away',
        de: 'Himmelsrichtung -> Sanctus Gruppen -> Linien AoE -> Ködern -> Weg',
        fr: 'Positions -> Groupes -> AoE en ligne -> Déposez au sol -> Éloignez-vous',
        ja: '8方向散開 -> 3方向頭割り -> 直線範囲 -> AoE誘導 -> 離れる',
        cn: '八方 -> 光三向分摊 -> 直线 -> 放光点名 -> 离开',
        ko: '8산개 -> 홀리 그룹 쉐어 -> 직선 장판 -> 장판 유도 -> 피하기'
      },
      ttsText: {
        en: 'Holy Cycle',
        de: 'Mehrfache Vergeltung: Sanctus',
        fr: 'Multi-taillade : Lumière',
        ja: '魔装連続剣：ホーリー',
        cn: '光连续剑',
        ko: '연속검: 홀리'
      }
    }
  }, {
    id: 'E11S Cycle of Faith Holy Tether',
    type: 'StartsUsing',
    netRegex: {
      source: 'Fatebreaker',
      id: '569A',
      capture: false
    },
    delaySeconds: 16.5,
    response: e11s_boundOfFaithHolyTetherResponse
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Demi-Gukumatz': 'Demi-Gukumatz',
      'Fatebreaker\'s image': 'Abbild des fusionierten Ascians',
      'Fatebreaker(?!\'s image)': 'fusioniert(?:e|er|es|en) Ascian',
      'Halo of Flame': 'Halo der Flamme'
    },
    'replaceText': {
      'Ageless Serpent': 'Alterslose Schlange',
      'Blastburn': 'Brandstoß',
      'Blasting Zone': 'Erda-Detonation',
      'Bound Of Faith': 'Sünden-Erdstoß',
      'Bow Shock': 'Schockpatrone',
      'Brightfire': 'Lichtflamme',
      '(?<!Mortal )Burn Mark': 'Brandmal',
      'Burnished Glory': 'Leuchtende Aureole',
      'Burnout': 'Brandentladung',
      'Burnt Strike': 'Brandschlag',
      'Cycle Of Faith': 'Mehrfache Vergeltung',
      'Elemental Break': 'Elementarbruch',
      'Floating Fetters': 'Schwebende Fesseln',
      'Mortal Burn Mark': 'Brandmal der Sterblichen',
      'Powder Mark': 'Pulvermal',
      'Prismatic Deception': 'Prismatische Unsichtbarkeit',
      'Resonant Winds': 'Resonante Winde',
      'Resounding Crack': 'Gewaltiger Bruch',
      'Right Of The Heavens': 'Vier Himmel',
      'Shifting Sky': 'Himmelsverschiebung',
      'Shining Blade': 'Leuchtende Klinge',
      'Sinsight': 'Sündenlicht',
      'Sinsmite': 'Sündenblitz',
      'Sinsmoke': 'Sündenflamme',
      'Solemn Charge': 'Wütende Durchbohrung',
      'Sundered Sky': 'Himmelstrennung',
      'Turn Of The Heavens': 'Kreislauf der Wiedergeburt'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Demi-Gukumatz': 'demi-Gukumatz',
      'Fatebreaker\'s image': 'double du Sabreur de destins',
      'Fatebreaker(?!\'s image)': 'Sabreur de destins',
      'Halo of Flame': 'halo de feu'
    },
    'replaceText': {
      '\\?': ' ?',
      'Ageless Serpent': 'Serpent éternel',
      'Blastburn': 'Explosion brûlante',
      'Blasting Zone': 'Zone de destruction',
      'Bound Of Faith': 'Percée illuminée',
      'Bow Shock': 'Arc de choc',
      'Brightfire': 'Flammes de Lumière',
      '(?<!Mortal )Burn Mark': 'Marque explosive',
      'Burnished Glory': 'Halo luminescent',
      'Burnout': 'Combustion totale',
      'Burnt Strike': 'Frappe brûlante',
      'Cycle Of Faith': 'Multi-taillade magique',
      'Elemental Break': 'Rupture élémentaire',
      'Floating Fetters': 'Entraves flottantes',
      'Mortal Burn Mark': 'Marque de conflagration',
      'Powder Mark': 'Marquage fatal',
      'Prismatic Deception': 'Invisibilité prismatique',
      'Resonant Winds': 'Tourbillon magique',
      'Resounding Crack': 'Turbulence magique',
      'Right Of The Heavens': 'Quatre portails',
      'Shifting Sky': 'Percée céleste ultime',
      'Shining Blade': 'Lame étincelante',
      'Sinsight': 'Lumière du péché',
      'Sinsmite': 'Éclair du péché',
      'Sinsmoke': 'Flammes du péché',
      'Solemn Charge': 'Charge perçante',
      'Sundered Sky': 'Percée infernale ultime',
      'Turn Of The Heavens': 'Cercles rituels'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Demi-Gukumatz': 'デミグクマッツ',
      'Fatebreaker\'s image': 'フェイトブレイカーの幻影',
      'Fatebreaker(?!\'s image)': 'フェイトブレイカー',
      'Halo of Flame': '焔の光輪'
    },
    'replaceText': {
      'Ageless Serpent': '龍頭龍尾',
      'Blastburn': 'バーンブラスト',
      'Blasting Zone': 'ブラスティングゾーン',
      'Bound Of Faith': 'シンソイルスラスト',
      'Bow Shock': 'バウショック',
      'Brightfire': '光炎',
      '(?<!Mortal )Burn Mark': '爆印',
      'Burnished Glory': '光焔光背',
      'Burnout': 'バーンアウト',
      'Burnt Strike': 'バーンストライク',
      'Cycle Of Faith': '魔装連続剣',
      'Elemental Break': 'エレメンタルブレイク',
      'Floating Fetters': '浮遊拘束',
      'Mortal Burn Mark': '大爆印',
      'Powder Mark': '爆印刻',
      'Prismatic Deception': 'プリズマチックインビジブル',
      'Resonant Winds': '魔旋風',
      'Resounding Crack': '魔乱流',
      'Right Of The Heavens': '四天召',
      'Shifting Sky': '至天絶技',
      'Shining Blade': 'シャインブレード',
      'Sinsight': 'シンライト',
      'Sinsmite': 'シンボルト',
      'Sinsmoke': 'シンフレイム',
      'Solemn Charge': 'チャージスラスト',
      'Sundered Sky': '堕獄絶技',
      'Turn Of The Heavens': '転輪召'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Demi-Gukumatz': '亚灵羽蛇',
      'Fatebreaker\'s image': '绝命战士的幻影',
      'Fatebreaker(?!\'s image)': '绝命战士',
      'Halo of Flame': '焰之光轮'
    },
    'replaceText': {
      'Ageless Serpent': '龙头龙尾',
      'Blastburn': '火燃爆',
      'Blasting Zone': '爆破领域',
      'Bound Of Faith': '罪壤刺',
      'Bow Shock': '弓形冲波',
      'Brightfire': '光炎',
      '(?<!Mortal )Burn Mark': '爆印',
      'Burnished Glory': '光焰圆光',
      'Burnout': '雷燃爆',
      'Burnt Strike': '燃烧击',
      'Cycle Of Faith': '魔装连续剑',
      'Elemental Break': '元素破',
      'Floating Fetters': '浮游拘束',
      'Mortal Burn Mark': '大爆印',
      'Powder Mark': '爆印铭刻',
      'Prismatic Deception': '棱光幻影',
      'Resonant Winds': '魔旋风',
      'Resounding Crack': '魔乱流',
      'Right Of The Heavens': '四天召唤',
      'Shifting Sky': '至天绝技',
      'Shining Blade': '光明之刃',
      'Sinsight': '罪光',
      'Sinsmite': '罪雷',
      'Sinsmoke': '罪炎',
      'Solemn Charge': '急冲刺',
      'Sundered Sky': '堕狱绝技',
      'Turn Of The Heavens': '光轮召唤'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Demi-Gukumatz': '데미구쿠마츠',
      'Fatebreaker\'s image': '페이트브레이커의 환영',
      'Fatebreaker(?!\'s image)': '페이트브레이커',
      'Halo of Flame': '화염 빛무리'
    },
    'replaceText': {
      'Ageless Serpent': '용두용미',
      'Blastburn': '연소 폭발',
      'Blasting Zone': '발파 지대',
      'Bound Of Faith': '죄의 소일 일격',
      'Bow Shock': '원형충격파',
      'Brightfire': '광염',
      '(?<!Mortal )Burn Mark': '폭인',
      'Burnished Glory': '광염광배',
      'Burnout': '완전 연소',
      'Burnt Strike': '연소 공격',
      'Cycle Of Faith': '마장 연속검',
      'Elemental Break': '원소 파괴',
      'Floating Fetters': '부유 구속',
      'Mortal Burn Mark': '대폭인',
      'Powder Mark': '폭인각',
      'Prismatic Deception': '분광 은신',
      'Resonant Winds': '마선풍',
      'Resounding Crack': '마난류',
      'Right Of The Heavens': '사천 소환',
      'Shifting Sky': '지천절기',
      'Shining Blade': '빛나는 칼날',
      'Sinsight': '죄의 빛',
      'Sinsmite': '죄의 번개',
      'Sinsmoke': '죄의 화염',
      'Solemn Charge': '돌진격',
      'Sundered Sky': '타옥절기',
      'Turn Of The Heavens': '빛무리 소환'
    }
  }]
};
/* harmony default export */ const e11s = (e11s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e11s.txt
const raid_e11s_namespaceObject = "### Eden 11 (Savage)\r\n# Eden's Promise: Anamorphosis (Savage)\r\n# -p 5666:17.4 5663:17.4\r\n# -it \"Fatebreaker\"\r\n# -ii 366 5664 5906 565C 5659 58F4 566C 5686 5682 567F 568C\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# example lightning bound of faith\r\n# 46.7 \"Bound Of Faith\" Ability { id: \"565[8B]\", source: \"Fatebreaker\" }\r\n# 46.8 \"Floating Fetters\" Ability { id: \"58F4\", source: \"Fatebreaker\" }\r\n# 48.8 \"Solemn Charge\" Ability { id: \"565C\", source: \"Fatebreaker\" }\r\n# 50.1 \"Sinsmite\" Ability { id: \"565D\", source: \"Fatebreaker\" }\r\n# 50.5 \"Bow Shock\" Ability { id: \"565E\", source: \"Fatebreaker\" }\r\n\r\n# example fire bound of faith\r\n# 46.6 \"Bound Of Faith\" Ability { id: \"5658\", source: \"Fatebreaker\" }\r\n# 46.9 \"Floating Fetters\" Ability { id: \"58F4\", source: \"Fatebreaker\" }\r\n# 49.0 \"Solemn Charge\" Ability { id: \"5659\", source: \"Fatebreaker\" }\r\n# 50.3 \"Sinsmoke\" Ability { id: \"565A\", source: \"Fatebreaker\" }\r\n\r\n# example holy bound of faith\r\n# 46.7 \"Bound Of Faith\" Ability { id: \"565F\", source: \"Fatebreaker\" }\r\n# 46.9 \"Floating Fetters\" Ability { id: \"58F4\", source: \"Fatebreaker\" }\r\n# 49.0 \"Solemn Charge\" Ability { id: \"5660\", source: \"Fatebreaker\" }\r\n# 50.3 \"Sinsight\" Ability { id: \"5661\", source: \"Fatebreaker\" }\r\n# 55.9 \"Mortal Burn Mark\" Ability { id: \"5662\", source: \"Fatebreaker\" }\r\n\r\n# Burnt Strike timings:\r\n# * Burnout, lightning, 5655, 1.7s delay\r\n# * Blastburn, fire, 5653, 2.0s delay\r\n# * Shining Blade, light, 5657, 5.0s delay\r\n# Time these to burnout where it's random, and comment out the sync.\r\n# If testing were smarter we could have an optional sync here, otherwise test_timeline.py will be weird.\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n# Phase 1\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n17.4 \"Elemental Break\" Ability { id: \"566[36]\", source: \"Fatebreaker\" } window 18,5\r\n19.9 \"Sinsmoke/Sinsmite\" Ability { id: \"566[57]\", source: \"Fatebreaker\" }\r\n23.9 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n33.0 \"Burnt Strike\" Ability { id: \"565[24]\", source: \"Fatebreaker\" }\r\n34.7 \"Burnout/Blastburn\" #Ability { id: \"565[35]\", source: \"Fatebreaker\" }\r\n46.7 \"Bound Of Faith\" Ability { id: \"565[8B]\", source: \"Fatebreaker\" }\r\n50.1 \"Sinsmoke/Sinsmite\" Ability { id: \"565[AD]\", source: \"Fatebreaker\" }\r\n\r\n59.9 \"Burnished Glory\" Ability { id: \"56A4\", source: \"Fatebreaker\" }\r\n70.4 \"Powder Mark\" Ability { id: \"56A2\", source: \"Fatebreaker\" }\r\n77.9 \"Turn Of The Heavens\" Ability { id: \"566A\", source: \"Fatebreaker\" }\r\n89.3 \"Burn Mark\" Ability { id: \"56A3\", source: \"Fatebreaker\" }\r\n89.7 \"Brightfire\" # Ability { id: \"566D\", source: \"Halo of Flame\" }\r\n\r\n94.4 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n103.9 \"Burnt Strike\" Ability { id: \"565[24]\", source: \"Fatebreaker\" }\r\n105.6 \"Burnout/Blastburn\" #Ability { id: \"565[35]\", source: \"Fatebreaker\" }\r\n117.6 \"Bound Of Faith\" Ability { id: \"565[8B]\", source: \"Fatebreaker\" }\r\n121.3 \"Sinsmoke/Sinsmite\" Ability { id: \"565[AD]\", source: \"Fatebreaker\" }\r\n\r\n# Dragon trio\r\n132.6 \"Elemental Break\" Ability { id: \"566[36]\", source: \"Fatebreaker\" }\r\n135.1 \"Sinsmite/Sinsmoke\" Ability { id: \"56(5A|57|65|67)\", source: \"Fatebreaker\" } window 10,10\r\n147.1 \"Shifting Sky\" Ability { id: \"567[56]\", source: \"Fatebreaker\" }\r\n149.5 \"--untargetable--\"\r\n154.7 \"Ageless Serpent\" Ability { id: \"5687\", source: \"Demi-Gukumatz\" }\r\n165.8 \"Resonant Winds\" Ability { id: \"5689\", source: \"Demi-Gukumatz\" }\r\n169.4 \"Sinsmoke\" Ability { id: \"5681\", source: \"Fatebreaker's Image\" }\r\n169.4 \"Sinsmite\" Ability { id: \"5684\", source: \"Fatebreaker's Image\" }\r\n169.8 \"Bow Shock\" Ability { id: \"5685\", source: \"Fatebreaker's Image\" }\r\n173.0 \"Burnt Strike \" Ability { id: \"567B\", source: \"Fatebreaker's Image\" }\r\n174.7 \"Burnout\" Ability { id: \"567C\", source: \"Fatebreaker's Image\" }\r\n176.0 \"Burnt Strike\" Ability { id: \"5679\", source: \"Fatebreaker's Image\" }\r\n178.0 \"Blastburn\" Ability { id: \"567A\", source: \"Fatebreaker's Image\" }\r\n180.7 \"--targetable--\"\r\n\r\n# Phase 2: light sparkles\r\n191.5 \"Elemental Break\" Ability { id: \"566[368]\", source: \"Fatebreaker\" }\r\n194.1 \"Sinsmite/Sinsmoke\" Ability { id: \"56(5A|57|65|67)\", source: \"Fatebreaker\" }\r\n204.0 \"Burnished Glory\" Ability { id: \"56A4\", source: \"Fatebreaker\" }\r\n\r\n221.1 \"Elemental Break\" Ability { id: \"5668\", source: \"Fatebreaker\" }\r\n223.6 \"Sinsight\" Ability { id: \"5669\", source: \"Fatebreaker\" }\r\n227.6 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n237.0 \"Burnt Strike\" Ability { id: \"5656\", source: \"Fatebreaker\" }\r\n242.0 \"Shining Blade\" Ability { id: \"5657\", source: \"Fatebreaker\" }\r\n250.7 \"Bound Of Faith\" Ability { id: \"565F\", source: \"Fatebreaker\" }\r\n254.3 \"Sinsight\" Ability { id: \"5661\", source: \"Fatebreaker\" }\r\n259.9 \"Mortal Burn Mark\" Ability { id: \"5662\", source: \"Fatebreaker\" }\r\n\r\n264.1 \"Burnished Glory\" Ability { id: \"56A4\", source: \"Fatebreaker\" }\r\n274.6 \"Powder Mark\" Ability { id: \"56A2\", source: \"Fatebreaker\" }\r\n282.1 \"Right Of The Heavens\" Ability { id: \"566[EF]\", source: \"Fatebreaker\" } window 50,50\r\n293.5 \"Burn Mark\" Ability { id: \"56A3\", source: \"Fatebreaker\" }\r\n\r\n298.6 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n308.2 \"Burnt Strike\" Ability { id: \"565[246]\", source: \"Fatebreaker\" }\r\n309.9 \"Burnout/Blastburn\" #Ability { id: \"565[35]\", source: \"Fatebreaker\" }\r\n321.9 \"Bound Of Faith\" Ability { id: \"565[8BF]\", source: \"Fatebreaker\" }\r\n325.6 \"Sinsmoke/Sinsmite/Sinsight\" Ability { id: \"56(5[AD]|6[159])\", source: \"Fatebreaker\" }\r\n331.2 \"Mortal Burn Mark?\" # Ability { id: \"5662\", source: \"Fatebreaker\" }\r\n336.9 \"Elemental Break\" Ability { id: \"566[368]\", source: \"Fatebreaker\" }\r\n339.4 \"Sinsmoke/Sinsmite/Sinsight\" Ability { id: \"56(5[AD]|6[1579])\", source: \"Fatebreaker\" }\r\n\r\n# dragon trio 2\r\n351.4 \"Sundered Sky\" Ability { id: \"567[78]\", source: \"Fatebreaker\" } window 50,50\r\n353.8 \"--untargetable--\"\r\n359.0 \"Ageless Serpent\" Ability { id: \"5687\", source: \"Demi-Gukumatz\" }\r\n370.5 \"Resounding Crack\" Ability { id: \"5688\", source: \"Demi-Gukumatz\" }\r\n372.5 \"Sinsmoke\" Ability { id: \"5681\", source: \"Fatebreaker's Image\" }\r\n372.6 \"Sinsight\" Ability { id: \"5BC7\", source: \"Fatebreaker's Image\" }\r\n376.5 \"Burnt Strike\" Ability { id: \"567D\", source: \"Fatebreaker's Image\" }\r\n378.2 \"Mortal Burn Mark\" Ability { id: \"5BC8\", source: \"Fatebreaker's Image\" }\r\n380.1 \"Burnt Strike \" Ability { id: \"567B\", source: \"Fatebreaker's Image\" }\r\n381.6 \"Shining Blade\" Ability { id: \"567E\", source: \"Fatebreaker's Image\" }\r\n381.8 \"Burnout\" Ability { id: \"567C\", source: \"Fatebreaker's Image\" }\r\n383.6 \"Burnt Strike\" Ability { id: \"5679\", source: \"Fatebreaker's Image\" }\r\n385.6 \"Blastburn\" Ability { id: \"567A\", source: \"Fatebreaker's Image\" }\r\n386.4 \"--targetable--\"\r\n\r\n397.1 \"Elemental Break\" Ability { id: \"566[368]\", source: \"Fatebreaker\" }\r\n399.6 \"Sinsight/Sinsmite\" Ability { id: \"566[579]\", source: \"Fatebreaker\" }\r\n409.6 \"Burnished Glory\" Ability { id: \"56A4\", source: \"Fatebreaker\" }\r\n\r\n427.1 \"Turn Of The Heavens\" Ability { id: \"566[AB]\", source: \"Fatebreaker\" } window 50,50\r\n429.6 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n438.6 \"Elemental Break\" Ability { id: \"566[368]\", source: \"Fatebreaker\" }\r\n441.1 \"Sinsmite/Sinsmoke\" Ability { id: \"56(5A|57|65|67)\", source: \"Fatebreaker\" }\r\n450.6 \"Powder Mark\" Ability { id: \"56A2\", source: \"Fatebreaker\" }\r\n458.1 \"Right Of The Heavens\" Ability { id: \"566[EF]\", source: \"Fatebreaker\" }\r\n460.6 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n469.5 \"Burn Mark\" Ability { id: \"56A3\", source: \"Fatebreaker\" }\r\n469.5 \"Bound Of Faith\" Ability { id: \"565[8F]\", source: \"Fatebreaker\" }\r\n471.6 \"Solemn Charge\" # Ability { id: \"56(59|60)\", source: \"Fatebreaker\" }\r\n472.9 \"Sinsight/Sinsmoke\" # Ability { id: \"56[56][159A]\", source: \"Fatebreaker\" }\r\n478.5 \"Mortal Burn Mark?\" # Ability { id: \"5662\", source: \"Fatebreaker\" }\r\n488.3 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n\r\n493.7 \"Prismatic Deception\" Ability { id: \"5672\", source: \"Fatebreaker\" } window 493.7,10\r\n496.8 \"--untargetable--\"\r\n513.9 \"Blasting Zone\" Ability { id: \"56A5\", source: \"Fatebreaker's Image\" }\r\n532.0 \"Blasting Zone\" Ability { id: \"56A5\", source: \"Fatebreaker's Image\" }\r\n537.9 \"--targetable--\"\r\n549.2 \"Burnished Glory\" Ability { id: \"56A4\", source: \"Fatebreaker\" } window 30,30\r\n\r\n\r\n561.7 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n570.7 \"Cycle Of Faith\" Ability { id: \"5692\", source: \"Fatebreaker\" } jump 700\r\n570.7 \"--sync--\" Ability { id: \"569A\", source: \"Fatebreaker\" } jump 800\r\n570.7 \"--sync--\" Ability { id: \"568B\", source: \"Fatebreaker\" } jump 900\r\n570.8 \"Elemental Break\"\r\n573.3 \"Sinsight/Sinsmite/Sinsmoke\"\r\n575.2 \"Burnt Strike\"\r\n575.5 \"Blastburn?\"\r\n580.2 \"Shining Blade?\"\r\n580.2 \"Floating Fetters\"\r\n\r\n\r\n\r\n# Lightning Cycle\r\n691.0 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n700.0 \"Cycle Of Faith\" Ability { id: \"5692\", source: \"Fatebreaker\" }\r\n700.1 \"Elemental Break\" Ability { id: \"5693\", source: \"Fatebreaker\" }\r\n702.7 \"Sinsmite\" Ability { id: \"5694\", source: \"Fatebreaker\" }\r\n704.5 \"Burnt Strike\" Ability { id: \"5695\", source: \"Fatebreaker\" }\r\n706.2 \"Burnout\" Ability { id: \"5696\", source: \"Fatebreaker\" }\r\n711.6 \"Solemn Charge\" Ability { id: \"5697\", source: \"Fatebreaker\" }\r\n713.1 \"Sinsmite\" Ability { id: \"5698\", source: \"Fatebreaker\" }\r\n713.2 \"--sync--\" Ability { id: \"5699\", source: \"Fatebreaker\" }\r\n725.7 \"Burnished Glory\" Ability { id: \"56A4\", source: \"Fatebreaker\" }\r\n\r\n728.2 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" } window 30,30\r\n737.2 \"Cycle Of Faith\" Ability { id: \"568A\", source: \"Fatebreaker\" } jump 900\r\n737.2 \"--sync--\" Ability { id: \"569A\", source: \"Fatebreaker\" } jump 800\r\n737.3 \"Elemental Break\"\r\n739.8 \"Sinsight/Sinsmite/Sinsmoke\"\r\n741.7 \"Burnt Strike\"\r\n742.0 \"Blastburn?\"\r\n746.7 \"Shining Blade?\"\r\n\r\n\r\n# Holy Cycle\r\n791.0 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n800.0 \"Cycle Of Faith\" Ability { id: \"569A\", source: \"Fatebreaker\" }\r\n800.1 \"Elemental Break\" Ability { id: \"56[89]B\", source: \"Fatebreaker\" }\r\n802.7 \"Sinsight\" Ability { id: \"569C\", source: \"Fatebreaker\" }\r\n804.5 \"Burnt Strike\" Ability { id: \"569D\", source: \"Fatebreaker\" }\r\n809.5 \"Shining Blade\" Ability { id: \"569E\", source: \"Fatebreaker\" }\r\n811.6 \"Solemn Charge\" Ability { id: \"569F\", source: \"Fatebreaker\" }\r\n813.1 \"Sinsight\" Ability { id: \"56A0\", source: \"Fatebreaker\" }\r\n818.7 \"Mortal Burn Mark\" Ability { id: \"56A1\", source: \"Fatebreaker\" }\r\n825.7 \"Burnished Glory\" Ability { id: \"56A4\", source: \"Fatebreaker\" }\r\n\r\n828.2 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" } window 30,30\r\n837.2 \"Cycle Of Faith\" Ability { id: \"5692\", source: \"Fatebreaker\" } jump 700\r\n837.2 \"--sync--\" Ability { id: \"568A\", source: \"Fatebreaker\" } jump 900\r\n837.3 \"Elemental Break\"\r\n839.8 \"Sinsight/Sinsmite/Sinsmoke\"\r\n841.7 \"Burnt Strike\"\r\n842.0 \"Blastburn?\"\r\n846.7 \"Shining Blade?\"\r\n\r\n# Fire Cycle\r\n891.0 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" }\r\n900.0 \"Cycle Of Faith\" Ability { id: \"568A\", source: \"Fatebreaker\" }\r\n900.1 \"Elemental Break\" Ability { id: \"568B\", source: \"Fatebreaker\" }\r\n902.7 \"Sinsmoke\" Ability { id: \"568D\", source: \"Fatebreaker\" }\r\n904.5 \"Burnt Strike\" Ability { id: \"568E\", source: \"Fatebreaker\" }\r\n906.5 \"Blastburn\" Ability { id: \"568F\", source: \"Fatebreaker\" }\r\n911.6 \"Solemn Charge\" Ability { id: \"5690\", source: \"Fatebreaker\" }\r\n913.1 \"Sinsmoke\" Ability { id: \"5691\", source: \"Fatebreaker\" }\r\n925.7 \"Burnished Glory\" Ability { id: \"56A4\", source: \"Fatebreaker\" }\r\n\r\n928.2 \"--center--\" Ability { id: \"5908\", source: \"Fatebreaker\" } window 30,30\r\n937.2 \"Cycle Of Faith\" Ability { id: \"5692\", source: \"Fatebreaker\" } jump 700\r\n937.2 \"--sync--\" Ability { id: \"569A\", source: \"Fatebreaker\" } jump 800\r\n937.3 \"Elemental Break\"\r\n939.8 \"Sinsight/Sinsmite/Sinsmoke\"\r\n941.7 \"Burnt Strike\"\r\n942.0 \"Blastburn?\"\r\n946.7 \"Shining Blade?\"\r\n\r\n\r\n992.3 \"Burnished Glory\" StartsUsing { id: \"5529\", source: \"Fatebreaker\" } window 1000,0\r\n1000.0 \"Burnished Glory Enrage\" Ability { id: \"5529\", source: \"Fatebreaker\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e12n.ts




// EDEN'S PROMISE: ETERNITY
// E12 NORMAL

// TODO: Handle the EarthShaker bait --> beam intercept mechanic during the intermission.
// TODO: Math the spawn position of the Titanic Bomb Boulders to call the safe direction like E4s.

// Each tether ID corresponds to a primal:
// 008E -- Leviathan
// 008F -- Ifrit
// 0090 -- Ramuh
// 0091 -- Garuda
// We can collect + store these for later use on Stock/Release.
const e12n_tetherIds = ['008E', '008F', '0090', '0091'];

// Keys here indicate SAFE directions!
const bombOutputStrings = {
  'north': {
    en: 'Between north bombs',
    de: 'Zwichen den Bomben im Norden',
    fr: 'Entre les bombes au Nord',
    ja: '北の岩へ',
    cn: '去北边岩石中间',
    ko: '북쪽 폭탄 사이'
  },
  'south': {
    en: 'Between south bombs',
    de: 'Zwichen den Bomben im Süden',
    fr: 'Entre les bombes au Sud',
    ja: '南の岩へ',
    cn: '去南边岩石中间',
    ko: '남쪽 폭탄 사이'
  },
  'east': {
    en: 'Between east bombs',
    de: 'Zwichen den Bomben im Osten',
    fr: 'Entre les bombes à l\'Est',
    ja: '東の岩へ',
    cn: '去东边岩石中间',
    ko: '동쪽 폭탄 사이'
  },
  'west': {
    en: 'Between west bombs',
    de: 'Zwichen den Bomben im Westen',
    fr: 'Entre les bombes à l\'Ouest',
    ja: '西の岩へ',
    cn: '去西边岩石中间',
    ko: '서쪽 폭탄 사이'
  }
};
const primalOutputStrings = {
  'combined': {
    en: '${safespot1} + ${safespot2}',
    de: '${safespot1} + ${safespot2}',
    fr: '${safespot1} + ${safespot2}',
    ja: '${safespot1} + ${safespot2}',
    cn: '${safespot1} + ${safespot2}',
    ko: '${safespot1} + ${safespot2}'
  },
  '008E': outputs/* default.middle */.Z.middle,
  '008F': outputs/* default.sides */.Z.sides,
  '0090': outputs/* default.out */.Z.out,
  '0091': {
    en: 'Intercards',
    de: 'Interkardinale Himmelsrichtungen',
    fr: 'Intercardinal',
    ja: '斜め',
    cn: '四角',
    ko: '대각'
  },
  '008E008F': {
    en: 'Under + Sides',
    de: 'Unter Ihm + Seiten',
    fr: 'En dessous + Côtés',
    ja: '真ん中 + 横へ',
    cn: '正中间两侧',
    ko: '보스 아래 + 양옆'
  },
  '008E0090': {
    en: 'North/South + Out',
    de: 'Norden/Süden + Raus',
    fr: 'Nord/Sud + Extérieur',
    ja: '北/南 + 外へ',
    cn: '南北远离',
    ko: '북/남 + 바깥'
  },
  '008E0091': {
    en: 'Under + Intercards',
    de: 'Unter Ihm + Interkardinale Himmelsrichtungen',
    fr: 'En dessous + Intercardinal',
    ja: '真ん中 + 斜め',
    cn: '正中间四角',
    ko: '보스 아래 + 대각'
  }
};
const e12n_triggerSet = {
  id: 'EdensPromiseEternity',
  zoneId: zone_id/* default.EdensPromiseEternity */.Z.EdensPromiseEternity,
  timelineFile: 'e12n.txt',
  triggers: [{
    id: 'E12N Intermission Completion',
    type: 'Ability',
    netRegex: {
      id: '4B48',
      source: 'Eden\'s Promise',
      capture: false
    },
    run: data => data.seenIntermission = true
  }, {
    id: 'E12N Maleficium',
    type: 'StartsUsing',
    netRegex: {
      id: '5872',
      source: 'Eden\'s Promise',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E12N Formless Judgment',
    type: 'StartsUsing',
    netRegex: {
      id: '5873',
      source: 'Eden\'s Promise'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    // Titanic Bombs spawn at two of four points:
    // SW X: -11.31371 Y: -63.68629
    // NW X: -11.31371 Y: -86.3137
    // SE X: 11.31371 Y: -63.68629
    // NE X: 11.31371 Y: -86.3137
    id: 'E12N Bomb Collect',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '9816'
    },
    run: (data, matches) => {
      const bomb = {
        north: parseFloat(matches.y) + 70 < 0,
        east: parseFloat(matches.x) > 0
      };
      data.bombs ??= [];
      data.bombs.push(bomb);
    }
  }, {
    id: 'E12N Boulders Impact',
    type: 'Ability',
    netRegex: {
      id: '586E',
      source: 'Titanic Bomb Boulder',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      // Whichever direction has two  Titanic Bombs, the safe spot is opposite.
      const [firstBomb, secondBomb] = data.bombs ?? [];
      if (!firstBomb || !secondBomb) return;
      let safe;
      if (firstBomb.north === secondBomb.north) safe = firstBomb.north ? 'south' : 'north';else safe = firstBomb.east ? 'west' : 'east';
      return output[safe]();
    },
    run: data => delete data.bombs,
    outputStrings: bombOutputStrings
  }, {
    id: 'E12N Boulders Explosion',
    type: 'Ability',
    netRegex: {
      id: '586F',
      source: 'Titanic Bomb Boulder',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move to last explosions',
        de: 'Zur letzten Explosion bewegen',
        fr: 'Allez sur la dernière explosion',
        ja: '最後に爆発した岩へ',
        cn: '去最后爆炸的岩石旁',
        ko: '마지막 폭발 위치로'
      }
    }
  }, {
    id: 'E12N Rapturous Reach Double',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    condition: data => !data.seenIntermission,
    preRun: (data, matches) => {
      data.stacks ??= [];
      data.stacks.push(matches.target);
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.stackOnYou();
    },
    infoText: (data, _matches, output) => {
      if (!data.stacks || data.stacks.length === 1) return;
      const names = data.stacks.map(x => data.party.member(x)).sort();
      return output.stacks({
        players: names
      });
    },
    outputStrings: {
      stacks: {
        en: 'Stack (${players})',
        de: 'Sammeln (${players})',
        fr: 'Package sur (${players})',
        ja: '頭割り (${players})',
        cn: '分摊 (${players})',
        ko: '모이기 (${players})'
      },
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou
    }
  }, {
    id: 'E12N Rapturous Reach Cleanup',
    type: 'HeadMarker',
    netRegex: {
      id: '003E',
      capture: false
    },
    delaySeconds: 10,
    run: data => delete data.stacks
  }, {
    id: 'E12N Rapturous Reach Single',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    condition: data => data.seenIntermission,
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'E12N Diamond Dust Mitigate',
    type: 'StartsUsing',
    netRegex: {
      id: '5864',
      source: 'Eden\'s Promise',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E12N Diamond Dust Stop',
    type: 'StartsUsing',
    netRegex: {
      id: '5864',
      source: 'Eden\'s Promise',
      capture: false
    },
    delaySeconds: 1,
    // Avoiding collision with the spread call
    response: responses/* Responses.stopMoving */.n3.stopMoving('alert')
  }, {
    id: 'E12N Frigid Stone',
    type: 'HeadMarker',
    netRegex: {
      id: '0060'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'E12N Tether Collect',
    type: 'Tether',
    netRegex: {
      id: e12n_tetherIds
    },
    run: (data, matches) => {
      data.tethers ??= [];
      data.tethers.push(matches.id);
    }
  }, {
    id: 'E12N Cast Release',
    type: 'StartsUsing',
    netRegex: {
      id: ['4E2C', '585B', '5861'],
      capture: false
    },
    preRun: data => data.tethers = data.tethers?.sort(),
    delaySeconds: 0.5,
    // Tethers should be first in the log, but let's be SURE
    alertText: (data, _matches, output) => {
      const [firstTether, secondTether] = data.tethers ?? [];
      if (firstTether === undefined || secondTether === undefined) return;
      // Leviathan's mechanics aren't easily described in a single word,
      // so we special-case them.

      const comboStr = firstTether + secondTether;
      if (comboStr in primalOutputStrings) return output[comboStr]();
      return output.combined({
        safespot1: output[firstTether](),
        safespot2: output[secondTether]()
      });
    },
    infoText: (data, _matches, output) => {
      const onlyTether = data.tethers?.[0];
      if (onlyTether === undefined || data.tethers?.length === 2) return;
      return output[onlyTether]();
    },
    outputStrings: primalOutputStrings
  }, {
    id: 'E12N Tether Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: ['4E2C', '585B', '5861'],
      capture: false
    },
    delaySeconds: 5,
    run: data => delete data.tethers
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      '(?<!Titanic )Bomb Boulder': 'Bomber-Brocken',
      'Chiseled Sculpture': 'Abbild eines Mannes',
      'Eden\'s Promise': 'Edens Verheißung',
      'Titanic Bomb Boulder': 'Mega-Bomber-Brocken'
    },
    'replaceText': {
      'Cast': 'Auswerfen',
      'Classical Sculpture': 'Klassische Skulptur',
      'Conflag Strike': 'Feuersbrunst',
      'Diamond Dust': 'Diamantenstaub',
      'Earth Shaker': 'Erdstoß',
      'Earthen Fury': 'Gaias Zorn',
      'Eternal Oblivion': 'Ewiges Vergessen',
      'Explosion': 'Explosion',
      'Ferostorm': 'Angststurm',
      'Formless Judgment': 'Formloses Urteil',
      'Frigid Stone': 'Eisstein',
      'Ice Floe': 'Eisfluss',
      'Impact': 'Impakt',
      'Initialize Recall': 'Rückholung initialisieren',
      'Judgment Jolt': 'Blitz des Urteils',
      'Junction Shiva': 'Verbindung: Shiva',
      'Junction Titan': 'Verbindung: Titan',
      'Laser Eye': 'Laserauge',
      'Maleficium': 'Maleficium',
      'Obliteration': 'Auslöschung',
      'Palm Of Temperance': 'Hand der Mäßigung',
      'Paradise Lost': 'Verlorenes Paradies',
      'Rapturous Reach': 'Stürmischer Griff',
      'Release': 'Freilassen',
      'Stock': 'Sammeln',
      'Temporary Current': 'Unstete Gezeiten',
      'Under The Weight': 'Wucht der Erde'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '(?<!Titanic )Bomb Boulder': 'bombo rocher',
      'Chiseled Sculpture': 'création masculine',
      'Eden\'s Promise': 'Promesse d\'Éden',
      'Titanic Bomb Boulder': 'méga bombo rocher'
    },
    'replaceText': {
      '\\?': ' ?',
      'Cast': 'Lancer',
      'Classical Sculpture': 'Serviteur colossal',
      'Conflag Strike': 'Ekpurosis',
      'Diamond Dust': 'Poussière de diamant',
      'Earth Shaker': 'Secousse',
      'Earthen Fury': 'Fureur tellurique',
      'Eternal Oblivion': 'Oubli éternel',
      'Explosion': 'Explosion',
      'Ferostorm': 'Tempête déchaînée',
      'Formless Judgment': 'Onde du châtiment',
      'Frigid Stone': 'Rocher de glace',
      'Ice Floe': 'Flux glacé',
      'Impact': 'Impact',
      'Initialize Recall': 'Remembrances',
      'Judgment Jolt': 'Front orageux du jugement',
      'Junction Shiva': 'Associer : Shiva',
      'Junction Titan': 'Associer : Titan',
      'Laser Eye': 'Faisceau maser',
      'Maleficium': 'Maleficium',
      'Obliteration': 'Oblitération',
      'Palm Of Temperance': 'Paume de tempérance',
      'Paradise Lost': 'Paradis perdu',
      'Rapturous Reach': 'Main voluptueuse',
      'Release': 'Relâcher',
      'Stock': 'Stocker',
      'Temporary Current': 'Courant évanescent',
      'Under The Weight': 'Pression tellurique'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '(?<!Titanic )Bomb Boulder': 'ボムボルダー',
      'Chiseled Sculpture': '創られた男',
      'Eden\'s Promise': 'プロミス・オブ・エデン',
      'Titanic Bomb Boulder': 'メガ・ボムボルダー'
    },
    'replaceText': {
      'Cast': 'はなつ',
      'Classical Sculpture': '巨兵創出',
      'Conflag Strike': 'コンフラグレーションストライク',
      'Diamond Dust': 'ダイアモンドダスト',
      'Earth Shaker': 'アースシェイカー',
      'Earthen Fury': '大地の怒り',
      'Eternal Oblivion': '永遠の忘却',
      'Explosion': '爆発',
      'Ferostorm': 'フィアスストーム',
      'Formless Judgment': '天罰の波動',
      'Frigid Stone': 'アイスストーン',
      'Ice Floe': 'アイスフロー',
      'Impact': 'インパクト',
      'Initialize Recall': '記憶想起',
      'Judgment Jolt': '裁きの界雷',
      'Junction Shiva': 'ジャンクション：シヴァ',
      'Junction Titan': 'ジャンクション：タイタン',
      'Laser Eye': 'メーザーアイ',
      'Maleficium': 'マレフィキウム',
      'Obliteration': 'オブリタレーション',
      'Palm Of Temperance': '拒絶の手',
      'Paradise Lost': 'パラダイスロスト',
      'Rapturous Reach': '悦楽の手',
      'Release': 'リリース',
      'Stock': 'ストック',
      'Temporary Current': 'テンポラリーカレント',
      'Under The Weight': '大地の重圧'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '(?<!Titanic )Bomb Boulder': '爆破岩石',
      'Chiseled Sculpture': '被创造的男性',
      'Eden\'s Promise': '伊甸之约',
      'Titanic Bomb Boulder': '巨型爆破岩石'
    },
    'replaceText': {
      'Cast': '释放',
      'Classical Sculpture': '创造巨兵',
      'Conflag Strike': '瞬燃强袭',
      'Diamond Dust': '钻石星尘',
      'Earth Shaker': '大地摇动',
      'Earthen Fury': '大地之怒',
      'Eternal Oblivion': '永恒忘却',
      'Explosion': '爆炸',
      'Ferostorm': '凶猛风暴',
      'Formless Judgment': '天罚波动',
      'Frigid Stone': '冰石',
      'Ice Floe': '浮冰',
      'Impact': '冲击',
      'Initialize Recall': '回想记忆',
      'Judgment Jolt': '制裁之界雷',
      'Junction Shiva': '融合：希瓦',
      'Junction Titan': '融合：泰坦',
      'Laser Eye': '激射眼',
      'Maleficium': '邪法',
      'Obliteration': '灭迹',
      'Palm Of Temperance': '拒绝之手',
      'Paradise Lost': '失乐园',
      'Rapturous Reach': '愉悦之手',
      'Release': '施放',
      'Stock': '储存',
      'Temporary Current': '临时洋流',
      'Under The Weight': '大地的重压'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '(?<!Titanic )Bomb Boulder': '바위폭탄',
      'Chiseled Sculpture': '창조된 남자',
      'Eden\'s Promise': '에덴의 약속',
      'Titanic Bomb Boulder': '거대 바위폭탄'
    },
    'replaceText': {
      'Cast': '발현',
      'Classical Sculpture': '거병 창조',
      'Conflag Strike': '대화재',
      'Diamond Dust': '다이아몬드 더스트',
      'Earth Shaker': '요동치는 대지',
      'Earthen Fury': '대지의 분노',
      'Eternal Oblivion': '영원한 망각',
      'Explosion': '폭산',
      'Ferostorm': '사나운 폭풍',
      'Formless Judgment': '천벌 파동',
      'Frigid Stone': '얼음돌',
      'Ice Floe': '유빙',
      'Impact': '충격',
      'Initialize Recall': '기억 상기',
      'Judgment Jolt': '심판의 계뢰',
      'Junction Shiva': '접속: 시바',
      'Junction Titan': '접속: 타이탄',
      'Laser Eye': '광선안',
      'Maleficium': '마녀의 사술',
      'Obliteration': '말소',
      'Palm Of Temperance': '거절의 손',
      'Paradise Lost': '실낙원',
      'Rapturous Reach': '열락의 손',
      'Release': '기억 방출',
      'Stock': '기억 보존',
      'Temporary Current': '순간 해류',
      'Under The Weight': '대지의 중압'
    }
  }]
};
/* harmony default export */ const e12n = (e12n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e12n.txt
const raid_e12n_namespaceObject = "### Eden 12 (Normal)\r\n# Eden's Promise: Eternity\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# -ii 4B47 4B1D 5865 585B 586B 5874 5875 5876 587E 587F 5882 5884 5889 588A 588B\r\n# -ic \"Lissom Sculpture\" \"Beastly Sculpture\"\r\n\r\n# Can use InCombat line to start timeline since the multiple phases do not\r\n# change the player's InCombat status.\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n14.9 \"Maleficium\" Ability { id: \"5872\", source: \"Eden's Promise\" } window 14.9,5\r\n22.1 \"--sync--\" Ability { id: \"5879\", source: \"Eden's Promise\" }\r\n25.3 \"Initialize Recall\" Ability { id: \"5859\", source: \"Eden's Promise\" }\r\n34.9 \"Judgment Jolt\" Ability { id: \"585F\", source: \"Eden's Promise\" }\r\n45.6 \"Temporary Current\" Ability { id: \"585C\", source: \"Eden's Promise\" }\r\n56.3 \"Judgment Jolt\" Ability { id: \"585F\", source: \"Eden's Promise\" }\r\n67.0 \"Temporary Current\" Ability { id: \"585C\", source: \"Eden's Promise\" }\r\n80.0 \"Formless Judgment\" Ability { id: \"5873\", source: \"Eden's Promise\" }\r\n87.3 \"--sync--\" Ability { id: \"5879\", source: \"Eden's Promise\" }\r\n96.7 \"Conflag Strike\" Ability { id: \"585D\", source: \"Eden's Promise\" }\r\n107.4 \"Ferostorm\" Ability { id: \"585E\", source: \"Eden's Promise\" }\r\n118.1 \"Conflag Strike\" Ability { id: \"585D\", source: \"Eden's Promise\" }\r\n128.7 \"Ferostorm\" Ability { id: \"585E\", source: \"Eden's Promise\" }\r\n140.1 \"Maleficium\" Ability { id: \"5872\", source: \"Eden's Promise\" }\r\n145.9 \"--sync--\" Ability { id: \"585A\", source: \"Eden's Promise\" } window 145.9,0\r\n148.4 \"--untargetable--\"\r\n\r\n# Intermission. Can be pushed, unknown threshold, maybe 70% HP?\r\n196.5 \"Eternal Oblivion\" Ability { id: \"587A\", source: \"Eden's Promise\" } window 200,10\r\n204.3 \"--sync--\" Ability { id: \"4B20\", source: \"Eden's Promise\" }\r\n232.9 \"Earth Shaker\" Ability { id: \"5885\", source: \"Eden's Promise\" }\r\n232.9 \"Obliteration\" Ability { id: \"4B43\", source: \"Eden's Promise\" }\r\n251.2 \"Eternal Oblivion\" Ability { id: \"587B\", source: \"Eden's Promise\" } window 20,20\r\n259.0 \"--sync--\" Ability { id: \"4B21\", source: \"Eden's Promise\" }\r\n267.3 \"Classical Sculpture\" Ability { id: \"5886\", source: \"Chiseled Sculpture\" }\r\n290.2 \"Rapturous Reach\" Ability { id: \"5889\", source: \"Eden's Promise\" }\r\n290.2 \"Palm Of Temperance\" Ability { id: \"4B44\", source: \"Eden's Promise\" }\r\n308.4 \"Eternal Oblivion\" Ability { id: \"587C\", source: \"Eden's Promise\" } window 20,20\r\n316.2 \"--sync--\" Ability { id: \"4B22\", source: \"Eden's Promise\" }\r\n337.5 \"Laser Eye\" Ability { id: \"4B47\", source: \"Eden's Promise\" }\r\n356.3 \"Eternal Oblivion\" Ability { id: \"587D\", source: \"Eden's Promise\" } window 20,20\r\n364.1 \"--sync--\" Ability { id: \"4B23\", source: \"Eden's Promise\" }\r\n\r\n\r\n# Post-intermission initial block.\r\n500.0 \"--sync--\" StartsUsing { id: \"4B48\", source: \"Eden's Promise\" } window 500,10\r\n504.9 \"Paradise Lost\" Ability { id: \"4B48\", source: \"Eden's Promise\" }\r\n511.9 \"--targetable--\"\r\n522.0 \"Initialize Recall\" Ability { id: \"5859\", source: \"Eden's Promise\" } window 30,30\r\n534.1 \"Stock\" Ability { id: \"5860\", source: \"Eden's Promise\" }\r\n542.8 \"Formless Judgment\" Ability { id: \"5873\", source: \"Eden's Promise\" } window 30,30\r\n545.6 \"--sync--\" Ability { id: \"5879\", source: \"Eden's Promise\" }\r\n555.7 \"Release\" Ability { id: \"5861\", source: \"Eden's Promise\" }\r\n\r\n\r\n568.6 \"Stock\" Ability { id: \"5860\", source: \"Eden's Promise\" } window 15,30\r\n578.3 \"Junction Shiva?\" Ability { id: \"5862\", source: \"Eden's Promise\" } jump 700\r\n578.3 \"Junction Titan?\" Ability { id: \"5863\", source: \"Eden's Promise\" } jump 800\r\n589.0 \"Diamond Dust?\"\r\n589.0 \"Earthen Fury?\"\r\n594.0 \"Impact 1?\"\r\n597.0 \"Impact 2?\"\r\n600.2 \"Frigid Stone?\"\r\n\r\n\r\n# Paths split here. Titan OR Shiva can be used first,\r\n# and then this first block, always ending in 5861 Release,\r\n# is followed by:\r\n\r\n# Unknown_5879 > Cast > Cast > Maleficium\r\n# The time between 5861 Release and Unknown 5879\r\n# is consistent at 9 seconds for both Shiva and Titan.\r\n\r\n# It will then continue to the other of Titan/Shiva,\r\n# which will in turn be followed by the other closing pattern:\r\n\r\n# Stock > Formless Judgment > Unknown_5879 > Release\r\n# The time between Release and Stock is consistent at 14 seconds.\r\n\r\n# Shiva Block\r\n690.4 \"Stock\" Ability { id: \"5860\", source: \"Eden's Promise\" }\r\n700.0 \"Junction Shiva\" Ability { id: \"5862\", source: \"Eden's Promise\" }\r\n710.7 \"Diamond Dust\" Ability { id: \"5864\", source: \"Eden's Promise\" } window 30,30\r\n716.8 \"--sync--\" Ability { id: \"5866\", source: \"Eden's Promise\" }\r\n721.9 \"Frigid Stone\" Ability { id: \"5867\", source: \"Eden's Promise\" }\r\n727.9 \"Ice Floe\" Ability { id: \"5868\", source: \"Eden's Promise\" }\r\n732.9 \"Rapturous Reach\" Ability { id: \"587[78]\", source: \"Eden's Promise\" } window 30,30\r\n735.4 \"Frigid Stone\" # Ability { id: \"5869\", source: \"Eden's Promise\" }\r\n735.6 \"--sync--\" Ability { id: \"5871\", source: \"Eden's Promise\" }\r\n738.2 \"--sync--\" Ability { id: \"5879\", source: \"Eden's Promise\" }\r\n747.6 \"Release\" Ability { id: \"5861\", source: \"Eden's Promise\" }\r\n\r\n756.6 \"--sync--\" Ability { id: \"5879\", source: \"Eden's Promise\" } jump 900\r\n761.5 \"Stock?\" Ability { id: \"5860\", source: \"Eden's Promise\" } jump 1000\r\n766.2 \"Cast?\"\r\n770.2 \"Formless Judgment?\"\r\n776.9 \"Cast?\"\r\n782.4 \"Release?\"\r\n784.6 \"Maleficium?\"\r\n\r\n\r\n# Titan Block\r\n790.3 \"Stock\" Ability { id: \"5860\", source: \"Eden's Promise\" }\r\n800.0 \"Junction Titan\" Ability { id: \"5863\", source: \"Eden's Promise\" }\r\n810.7 \"Earthen Fury\" Ability { id: \"586A\", source: \"Eden's Promise\" } window 30,30\r\n815.7 \"Impact 1\" Ability { id: \"586E\", source: \"Titanic Bomb Boulder\" }\r\n818.7 \"Impact 2\" # Ability { id: \"586C\", source: \"Bomb Boulder\" }\r\n822.7 \"Explosion 1\" Ability { id: \"586F\", source: \"Titanic Bomb Boulder\" }\r\n825.7 \"Explosion 2\" # Ability { id: \"586D\", source: \"Bomb Boulder\" }\r\n831.7 \"Rapturous Reach\" Ability { id: \"587[78]\", source: \"Eden's Promise\" } window 30,30\r\n834.2 \"Under The Weight\" Ability { id: \"5870\", source: \"Eden's Promise\" }\r\n834.3 \"--sync--\" Ability { id: \"5871\", source: \"Eden's Promise\" }\r\n836.9 \"--sync--\" Ability { id: \"5879\", source: \"Eden's Promise\" }\r\n846.3 \"Release\" Ability { id: \"5861\", source: \"Eden's Promise\" }\r\n\r\n855.3 \"--sync--\" Ability { id: \"5879\", source: \"Eden's Promise\" } jump 900\r\n860.2 \"Stock?\" Ability { id: \"5860\", source: \"Eden's Promise\" } jump 1000\r\n864.9 \"Cast?\"\r\n868.9 \"Formless Judgment?\"\r\n875.6 \"Cast?\"\r\n881.1 \"Release?\"\r\n883.3 \"Maleficium?\"\r\n\r\n# Maleficium Block\r\n900.0 \"--sync--\" Ability { id: \"5879\", source: \"Eden's Promise\" }\r\n909.6 \"Cast\" Ability { id: \"4E2C\", source: \"Eden's Promise\" }\r\n920.3 \"Cast\" Ability { id: \"4E2C\", source: \"Eden's Promise\" }\r\n928.0 \"Maleficium\" Ability { id: \"5872\", source: \"Eden's Promise\" } window 15,15\r\n\r\n940.9 \"Stock\" Ability { id: \"5860\", source: \"Eden's Promise\" }\r\n950.5 \"Junction Shiva?\" Ability { id: \"5862\", source: \"Eden's Promise\" } window 15,15 jump 700\r\n950.5 \"Junction Titan?\" Ability { id: \"5863\", source: \"Eden's Promise\" } window 15,15 jump 800\r\n961.2 \"Diamond Dust?\"\r\n961.2 \"Earthen Fury?\"\r\n966.2 \"Impact 1?\"\r\n969.2 \"Impact 2?\"\r\n972.4 \"Frigid Stone?\"\r\n973.2 \"Explosion 1?\"\r\n\r\n\r\n# Formless Judgment Block\r\n1000.0 \"Stock\" Ability { id: \"5860\", source: \"Eden's Promise\" }\r\n1008.7 \"Formless Judgment\" Ability { id: \"5873\", source: \"Eden's Promise\" } window 15,15\r\n1011.5 \"--sync--\" Ability { id: \"5879\", source: \"Eden's Promise\" }\r\n1020.9 \"Release\" Ability { id: \"5861\", source: \"Eden's Promise\" }\r\n\r\n1034.8 \"Stock\" Ability { id: \"5860\", source: \"Eden's Promise\" }\r\n1044.4 \"Junction Shiva?\" Ability { id: \"5862\", source: \"Eden's Promise\" } jump 700\r\n1044.4 \"Junction Titan?\" Ability { id: \"5863\", source: \"Eden's Promise\" } jump 800\r\n1055.1 \"Diamond Dust?\"\r\n1055.1 \"Earthen Fury?\"\r\n1060.1 \"Impact 1?\"\r\n1063.1 \"Impact 2?\"\r\n1066.3 \"Frigid Stone?\"\r\n1067.1 \"Explosion 1?\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e12s.ts






// TODO: double apoc clockwise vs counterclockwise call would be nice
// TODO: stack partners
// TODO: shadow eye people on blu need mit

// Each tether ID corresponds to a primal:
// 008C -- Shiva
// 008D -- Titan
// 008E -- Leviathan
// 008F -- Ifrit
// 0090 -- Ramuh
// 0091 -- Garuda
// We can collect + store these for later use on Stock/Release.
const shivaTetherId = '008C';
const titanTetherId = '008D';
const e12s_tetherIds = ['008E', '008F', '0090', '0091'];
const getTetherString = (tethers, output) => {
  // All tethers in E12S are double tethers, plus an optional junction (not in the tether list).
  const sorted = tethers?.sort();
  const [first, second] = sorted ?? [];
  if (first === undefined || second === undefined) return;
  const comboStr = first + second;
  if (comboStr in e12s_primalOutputStrings) return output[comboStr]();
  return output.combined({
    safespot1: output[first](),
    safespot2: output[second]()
  });
};

// TODO: also on the pre-statue cast, call south for any levi mechanics, west for any ifrit.
const e12s_primalOutputStrings = {
  // Tethers.
  '008E': outputs/* default.middle */.Z.middle,
  '008F': outputs/* default.sides */.Z.sides,
  '0090': outputs/* default.out */.Z.out,
  '0091': {
    en: 'Intercards',
    de: 'Interkardinale Himmelsrichtungen',
    fr: 'Intercardinal',
    ja: '斜め',
    cn: '四角',
    ko: '대각'
  },
  // Tether combos.
  '008E008F': {
    en: 'Under + Sides',
    de: 'Runter + Seiten',
    fr: 'En dessous + côtés',
    ja: '真ん中 + 横へ',
    cn: '正中间两侧',
    ko: '보스 안쪽 + 양옆'
  },
  '008E0090': {
    en: 'North/South + Out',
    de: 'Norden/Süden + Raus',
    fr: 'Nord/Sud + Extérieur',
    ja: '北/南 + 外へ',
    cn: '南北远离',
    ko: '남/북 + 바깥'
  },
  '008E0091': {
    en: 'Under + Intercards',
    de: 'Runter + Interkardinale Himmerlsrichtungen',
    fr: 'En dessous + Intercardinal',
    ja: '真ん中 + 斜め',
    cn: '正中间四角',
    ko: '보스 안쪽 + 대각'
  },
  // Text output.
  'combined': {
    en: '${safespot1} + ${safespot2}',
    de: '${safespot1} + ${safespot2}',
    fr: '${safespot1} + ${safespot2}',
    ja: '${safespot1} + ${safespot2}',
    cn: '${safespot1} + ${safespot2}',
    ko: '${safespot1} + ${safespot2}'
  },
  'stock': {
    en: 'Stock: ${text}',
    de: 'Sammeln: ${text}',
    fr: 'Stocker : ${text}',
    ja: 'ストック: ${text}',
    cn: '暂存: ${text}',
    ko: '저장: ${text}'
  },
  'junctionSuffix': {
    en: '${text} (${junction})',
    de: '${text} (${junction})',
    fr: '${text} (${junction})',
    ja: '${text} (${junction})',
    cn: '${text} (${junction})',
    ko: '${text} (${junction})'
  },
  // Junctions.
  'spread': {
    // Shiva spread.
    en: 'spread',
    de: 'verteilen',
    fr: 'dispersez-vous',
    ja: '散開',
    cn: '散开',
    ko: '산개'
  },
  'stacks': {
    // Titan healer stacks.
    en: 'stacks',
    de: 'sammeln',
    fr: 'packez-vous',
    ja: 'ヒラ頭割り',
    cn: '治疗分摊',
    ko: '그룹 쉐어'
  },
  'stack': {
    // Obliterate whole group laser stack.
    // This is deliberately "stack" singular (vs Titan "stacks").
    en: 'group stack',
    de: 'In Gruppen sammeln',
    fr: 'package en groupe',
    ja: '頭割り',
    cn: '集合',
    ko: '쉐어'
  }
};

// Due to changes introduced in patch 5.2, overhead markers now have a random offset
// added to their ID. This offset currently appears to be set per instance, so
// we can determine what it is from the first overhead marker we see.
// The first 1B marker in the encounter is the formless tankbuster, ID 004F.
const firstHeadmarker = parseInt('00DA', 16);
const e12s_getHeadmarkerId = (data, matches) => {
  // If we naively just check !data.decOffset and leave it, it breaks if the first marker is 00DA.
  // (This makes the offset 0, and !0 is true.)
  if (typeof data.decOffset === 'undefined') data.decOffset = parseInt(matches.id, 16) - firstHeadmarker;
  // The leading zeroes are stripped when converting back to string, so we re-add them here.
  // Fortunately, we don't have to worry about whether or not this is robust,
  // since we know all the IDs that will be present in the encounter.
  return (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase().padStart(4, '0');
};

// These keys map effect ids to `intermediateRelativityOutputStrings` keys.
const effectIdToOutputStringKey = {
  '690': 'flare',
  '996': 'stack',
  '998': 'shadoweye',
  '99C': 'eruption',
  '99E': 'blizzard',
  '99F': 'aero'
};

// These are currently used for both the informative x > y > z callout,
// but also the individual alerts.  These are kept short and snappy.
const intermediateRelativityOutputStringsRaw = {
  flare: {
    en: 'Flare',
    de: 'Flare',
    fr: 'Brasier',
    ja: 'フレア',
    cn: '核爆',
    ko: '플레어'
  },
  stack: {
    en: 'Stack',
    de: 'Sammeln',
    fr: 'Packez-vous',
    ja: '頭割り',
    cn: '分摊',
    ko: '쉐어'
  },
  shadoweye: {
    en: 'Gaze',
    de: 'Blick',
    fr: 'Regard',
    ja: 'シャドウアイ',
    cn: '暗黑眼',
    ko: '마안'
  },
  eruption: outputs/* default.spread */.Z.spread,
  blizzard: {
    en: 'Ice',
    de: 'Eis',
    fr: 'Glace',
    ja: 'ブリザガ',
    cn: '冰三',
    ko: '블리자가'
  },
  aero: {
    en: 'Aero',
    de: 'Wind',
    fr: 'Vent',
    ja: 'エアロガ',
    cn: '风三',
    ko: '에어로가'
  }
};
const intermediateRelativityOutputStrings = intermediateRelativityOutputStringsRaw;

// Returns integer value of x, y in matches based on cardinal or intercardinal
const matchedPositionToDir = matches => {
  // Positions are moved downward 75
  const y = parseFloat(matches.y) + 75;
  const x = parseFloat(matches.x);

  // In Basic Relativity, hourglass positions are the 8 cardinals + numerical
  // slop on a radius=20 circle.
  // N = (0, -95), E = (20, -75), S = (0, -55), W = (-20, -75)
  // NE = (14, -89), SE = (14, -61), SW = (-14, -61), NW = (-14, -89)
  //
  // In Advanced Relativity, hourglass positions are the 3 northern positions and
  // three southern positions, plus numerical slop on a radius=10 circle
  // NW = (-10, -80), N = (0, -86), NE = (10, -80)
  // SW = (-10, -69), S = (0, -64), SE = (10, -69)
  //
  // Starting with northwest to favor sorting between north and south for
  // Advanced Relativity party splits.
  // Map NW = 0, N = 1, ..., W = 7

  return Math.round(5 - 4 * Math.atan2(x, y) / Math.PI) % 8;
};

// Convert dir to Output
const dirToOutput = (dir, output) => {
  const dirs = {
    0: output.northwest(),
    1: output.north(),
    2: output.northeast(),
    3: output.east(),
    4: output.southeast(),
    5: output.south(),
    6: output.southwest(),
    7: output.west()
  };
  return dirs[dir];
};
const e12s_triggerSet = {
  id: 'EdensPromiseEternitySavage',
  zoneId: zone_id/* default.EdensPromiseEternitySavage */.Z.EdensPromiseEternitySavage,
  timelineFile: 'e12s.txt',
  initData: () => {
    return {
      statueStacks: [],
      waterStacks: [],
      basicDebuffs: [],
      basicEyes: [],
      intermediateDebuffs: {},
      intermediateDebuffsOutputKeys: [],
      advancedDebuffs: []
    };
  },
  triggers: [{
    // Headmarkers are randomized, so use a generic headMarker regex with no criteria.
    id: 'E12S Promise Formless Judgment You',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.isDoorBoss,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        formlessBusterAndSwap: {
          en: 'Tank Buster + Swap',
          de: 'Tankbuster + Wechsel',
          fr: 'Tank buster + Swap',
          ja: 'タンクバスター + スイッチ',
          cn: '死刑 + 换T',
          ko: '탱버 + 교대'
        },
        formlessBusterBLU: {
          en: 'Buster on YOU (w/${player})',
          de: 'Tankbuster auf DIR (mit ${player})',
          fr: 'Tankbuster sur VOUS (avec ${player})',
          cn: '死刑点名 (与${player})',
          ko: '탱버 대상자 (+${player})'
        },
        formlessBusterOnYOU: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou
      };
      const id = e12s_getHeadmarkerId(data, matches);

      // Track tankbuster targets, regardless if this is on you or not.
      // Use this to make more intelligent calls when the cast starts.
      if (id !== '00DA') return;
      data.formlessTargets ??= [];
      data.formlessTargets.push(matches.target);

      // From here on out, any response is for the current player.
      if (data.formlessTargets.length !== 2) return;
      if (!data.formlessTargets.includes(data.me)) return;

      // Formless double tankbuster mechanic.
      if (data.role === 'tank') return {
        alertText: output.formlessBusterAndSwap()
      };

      // BLU tends to avail here, so call out your friend.
      if (data.job === 'BLU') {
        const [otherPlayer] = data.formlessTargets.filter(x => x !== data.me);
        return {
          alertText: output.formlessBusterBLU({
            player: data.party.member(otherPlayer)
          })
        };
      }

      // Not that you personally can do anything about it, but maybe this
      // is your cue to yell on voice comms for cover.
      return {
        alarmText: output.formlessBusterOnYOU()
      };
    }
  }, {
    // Headmarkers are randomized, so use a generic headMarker regex with no criteria.
    id: 'E12S Promise Junction Titan Bombs',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.isDoorBoss,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        // The first round has only one blue.
        titanBlueSingular: {
          en: 'Blue Weight',
          de: 'Blau - Gewicht',
          fr: 'Poids bleu',
          ja: '青、重圧',
          cn: '蓝色重压',
          ko: '파랑'
        },
        // The second and two rounds of bombs have a partner.
        // The third is technically fixed by role with a standard party (one dps, one !dps),
        // but call out your partner anyway in case you've got 8 blus or something.
        titanBlueWithPartner: {
          en: 'Blue (with ${player})',
          de: 'Blau (mit ${player})',
          fr: 'Bleu (avec ${player})',
          ja: '青、重圧 (${player}と)',
          cn: '蓝色重压 (与${player})',
          ko: '파랑 (다른 대상자: ${player})'
        },
        titanOrangeStack: {
          en: 'Orange Stack',
          de: 'Orange - versammeln',
          fr: 'Orange, packez-vous',
          ja: '橙、頭割り',
          cn: '橙色分摊',
          ko: '주황: 집합'
        },
        titanYellowSpread: {
          en: 'Yellow Spread',
          de: 'Gelb - Verteilen',
          fr: 'Jaune, dispersez-vous',
          ja: '黄、散開',
          cn: '黄色散开',
          ko: '노랑: 산개'
        }
      };
      const id = e12s_getHeadmarkerId(data, matches);
      if (id === '00BB') {
        data.weightTargets ??= [];
        data.weightTargets.push(matches.target);

        // Handle double blue titan on 2nd and 3rd iterations.
        if (data.seenFirstBombs && data.weightTargets.length === 2) {
          if (data.weightTargets.includes(data.me)) {
            const partner = data.weightTargets[data.weightTargets[0] === data.me ? 1 : 0];
            return {
              alarmText: output.titanBlueWithPartner({
                player: data.party.member(partner)
              })
            };
          }
        }
      }

      // From here on out, any response is for the current player.
      if (matches.target !== data.me) return;

      // Titan Mechanics (double blue handled above)
      if (id === '00BB' && !data.seenFirstBombs) return {
        alarmText: output.titanBlueSingular()
      };
      if (id === '00B9') return {
        alertText: output.titanYellowSpread()
      };
      if (id === '00BA') return {
        infoText: output.titanOrangeStack()
      };
    }
  }, {
    id: 'E12S Promise Classical Sculpture',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      if (!data.isDoorBoss) return false;
      if (e12s_getHeadmarkerId(data, matches) !== '003E') return false;
      data.statueStacks.push(matches.target);
      return data.statueStacks.length === 2;
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        stackOnYou: {
          en: 'Stack on YOU (w/${player})',
          de: 'Auf DIR sammeln (mit ${player})',
          fr: 'Package sur VOUS (avec ${player})',
          cn: '分摊点名 (与${player})',
          ko: '쉐어 대상자 (+${player})'
        },
        stacks: {
          en: 'Stacks: ${players}',
          de: 'Sammeln: ${players}',
          fr: 'Package: ${players}',
          cn: '分摊: ${players}',
          ko: '쉐어: ${players}'
        }
      };
      if (!data.statueStacks.includes(data.me)) {
        const players = data.statueStacks.sort().map(x => data.party.member(x));
        return {
          infoText: output.stacks({
            players: players
          })
        };
      }
      const [otherPlayer] = data.statueStacks.filter(x => x !== data.me);
      return {
        alertText: output.stackOnYou({
          player: data.party.member(otherPlayer)
        })
      };
    }
  }, {
    // Headmarkers are randomized, so use a generic headMarker regex with no criteria.
    id: 'E12S Promise Chiseled Sculpture',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => data.isDoorBoss && matches.target === data.me,
    run: (data, matches) => {
      const id = e12s_getHeadmarkerId(data, matches);

      // Statue laser mechanic.
      const firstLaserMarker = '0091';
      const lastLaserMarker = '0098';
      if (id >= firstLaserMarker && id <= lastLaserMarker) {
        // ids are sequential: #1 square, #2 square, #3 square, #4 square, #1 triangle etc
        const decOffset = parseInt(id, 16) - parseInt(firstLaserMarker, 16);
        data.statueTetherNumber = decOffset % 4 + 1;
      }
    }
  }, {
    id: 'E12S Promise Chiseled Sculpture Collector',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '9818'
    },
    run: (data, matches) => {
      // Collect both sculptures up front, so when we find the tether on the
      // current player we can look up both of them immediately.
      data.statueIds ??= [];
      data.statueIds.push(parseInt(matches.id, 16));
    }
  }, {
    id: 'E12S Promise Chiseled Sculpture Tether',
    type: 'Tether',
    // This always directly follows the 1B: headmarker line.
    netRegex: {
      target: 'Chiseled Sculpture',
      id: '0011'
    },
    condition: (data, matches) => matches.source === data.me,
    durationSeconds: data => {
      // Handle laser #1 differently to not collide with the rapturous reach.
      if (data.statueTetherNumber === 0) return 3.5;
      if (data.statueTetherNumber) return data.statueTetherNumber * 3 + 4.5;
      return 8;
    },
    promise: async (data, matches) => {
      // Set an initial value here, just in case anything errors.
      data.statueDir = 'unknown';

      // Calculate distance to center to determine inner vs outer
      const statueData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: data.statueIds
      });
      if (statueData === null) {
        console.error(`sculpture: null statueData`);
        return;
      }
      if (statueData.combatants.length !== 2) {
        console.error(`sculpture: unexpected length: ${JSON.stringify(statueData)}`);
        return;
      }

      // Mark up statue objects with their distance to the center and
      // convert their decimal id to an 8 character hex id.
      const statues = [];
      for (const statue of statueData.combatants) {
        const centerX = 0;
        const centerY = -75;
        const x = statue.PosX - centerX;
        const y = statue.PosY - centerY;
        statues.push({
          dist: Math.hypot(x, y),
          hexId: `00000000${statue.ID?.toString(16) ?? ''}`.slice(-8).toUpperCase()
        });
      }

      // Sort so that closest statue (inner) is first
      statues.sort((a, b) => a.dist - b.dist);
      if (statues[0]?.hexId === matches.targetId) data.statueDir = 'inner';else if (statues[1]?.hexId === matches.targetId) data.statueDir = 'outer';else console.error(`sculpture: missing ${matches.targetId}, ${JSON.stringify(statues)}`);
    },
    infoText: (data, _matches, output) => {
      const numMap = {
        1: output.laser1(),
        2: output.laser2(),
        3: output.laser3(),
        4: output.laser4()
      };
      const numStr = numMap[data.statueTetherNumber ?? -1];
      if (numStr === undefined) {
        console.error(`sculpture: invalid tether number: ${data.statueTetherNumber ?? '???'}`);
        return;
      }
      if (data.statueDir === undefined) {
        console.error(`sculpture: missing statueDir`);
        return;
      }
      return output[data.statueDir]({
        num: numStr
      });
    },
    outputStrings: {
      laser1: outputs/* default.num1 */.Z.num1,
      laser2: outputs/* default.num2 */.Z.num2,
      laser3: outputs/* default.num3 */.Z.num3,
      laser4: outputs/* default.num4 */.Z.num4,
      inner: {
        en: '#${num} (Inner)',
        de: '#${num} (innen)',
        fr: '#${num} (Intérieur)',
        ja: '#${num} (中)',
        cn: '#${num} (内)',
        ko: '#${num} (안쪽)'
      },
      outer: {
        en: '#${num} (Outer)',
        de: '#${num} (außen)',
        fr: '#${num} (Extérieur)',
        ja: '#${num} (外)',
        cn: '#${num} (外)',
        ko: '#${num} (바깥쪽)'
      },
      unknown: {
        en: '#${num} (???)',
        de: '#${num} (???)',
        fr: '#${num} (???)',
        ja: '#${num} (???)',
        cn: '#${num} (???)',
        ko: '#${num} (???)'
      }
    }
  }, {
    id: 'E12S Promise Palm Of Temperance SE',
    type: 'StartsUsing',
    netRegex: {
      source: 'Guardian Of Eden',
      id: '58B4',
      capture: false
    },
    durationSeconds: 10,
    infoText: (_data, _matches, output) => output.knockback(),
    outputStrings: {
      knockback: {
        en: 'SE Knockback',
        de: 'SO Rückstoß',
        fr: 'SE Poussée',
        ja: '東南ノックバック',
        cn: '右下（东南）击退',
        ko: '남동쪽(5시)에서 넉백'
      }
    }
  }, {
    id: 'E12S Promise Palm Of Temperance SW',
    type: 'StartsUsing',
    netRegex: {
      source: 'Guardian Of Eden',
      id: '58B5',
      capture: false
    },
    durationSeconds: 10,
    infoText: (_data, _matches, output) => output.knockback(),
    outputStrings: {
      knockback: {
        en: 'SW Knockback',
        de: 'SW Rückstoß',
        fr: 'SO Poussée',
        ja: '西南ノックバック',
        cn: '左下（西南）击退',
        ko: '남서쪽(7시)에서 넉백'
      }
    }
  }, {
    id: 'E12S Promise Statue 2nd/3rd/4th Laser',
    type: 'Ability',
    netRegex: {
      source: 'Chiseled Sculpture',
      id: '58B3',
      capture: false
    },
    condition: data => !data.statueLaserCount || data.statueLaserCount < 4,
    durationSeconds: 3,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        laser1: outputs/* default.num1 */.Z.num1,
        laser2: outputs/* default.num2 */.Z.num2,
        laser3: outputs/* default.num3 */.Z.num3,
        laser4: outputs/* default.num4 */.Z.num4,
        baitInner: {
          en: 'Bait Inner #${num}',
          de: 'Köder innen #${num}',
          fr: 'Orientez vers l\'intérieur #${num}',
          ja: '中へ誘導 #${num}',
          cn: '向内诱导 #${num}',
          ko: '내부 유도 #${num}'
        },
        baitOuter: {
          en: 'Bait Outer #${num}',
          de: 'Köder außen #${num}',
          fr: 'Orientez vers l\'extérieur #${num}',
          ja: '外へ誘導 #${num}',
          cn: '向外诱导 #${num}',
          ko: '외부 유도 #${num}'
        },
        baitUnknown: {
          en: 'Bait #${num}',
          de: 'Köder #${num}',
          fr: 'Orientez #${num}',
          ja: '誘導 #${num}',
          cn: '诱导 #${num}',
          ko: '유도 #${num}'
        }
      };
      // Start one ahead, so that it calls out #2 after #1 has finished.
      data.statueLaserCount = (data.statueLaserCount ?? 1) + 1;
      const numMap = {
        1: output.laser1(),
        2: output.laser2(),
        3: output.laser3(),
        4: output.laser4()
      };
      const numStr = numMap[data.statueLaserCount];

      // The lasers are VERY noisy and flashy, so don't print anything when not you.
      // This also helps prevent confusion with the knockback direction trigger.
      if (data.statueLaserCount !== data.statueTetherNumber) return;
      if (data.statueDir === 'inner') return {
        alertText: output.baitInner({
          num: numStr
        })
      };else if (data.statueDir === 'outer') return {
        alertText: output.baitOuter({
          num: numStr
        })
      };
      return {
        alertText: output.baitUnknown({
          num: numStr
        })
      };
    },
    run: data => {
      if (data.statueLaserCount && data.statueLaserCount >= 4) {
        // Prevent future rapturous reach calls from thinking this is during lasers.
        delete data.statueTetherNumber;
        delete data.statueDir;
      }
    }
  }, {
    id: 'E12S Promise Weight Cleanup',
    type: 'StartsUsing',
    netRegex: {
      source: 'Eden\'s Promise',
      id: '58A5',
      capture: false
    },
    run: data => {
      delete data.weightTargets;
      data.seenFirstBombs = true;
    }
  }, {
    id: 'E12S Promise Formless Judgment',
    type: 'StartsUsing',
    netRegex: {
      source: 'Eden\'s Promise',
      id: '58A9',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        formlessBusterAndSwap: {
          en: 'Tank Buster + Swap',
          de: 'Tankbuster + Wechsel',
          fr: 'Tank buster + Swap',
          ja: 'タンクバスター + スイッチ',
          cn: '坦克死刑 + 换T',
          ko: '탱버 + 교대'
        },
        tankBusters: outputs/* default.tankBusters */.Z.tankBusters
      };

      // Already called out in the headmarker trigger.
      if (data.formlessTargets && data.formlessTargets.includes(data.me)) return;

      // TODO: should this call out who to cover if you are a paladin?
      if (data.role === 'tank') return {
        alertText: output.formlessBusterAndSwap()
      };
      if (data.role === 'healer') return {
        alertText: output.tankBusters()
      };

      // Be less noisy if this is just for feint.
      return {
        infoText: output.tankBusters()
      };
    },
    run: data => delete data.formlessTargets
  }, {
    id: 'E12S Promise Rapturous Reach Left',
    type: 'StartsUsing',
    netRegex: {
      source: 'Eden\'s Promise',
      id: '58AD',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        goLeft: outputs/* default.left */.Z.left,
        goLeftBaitInner: {
          en: 'Left + Bait Inner #1',
          de: 'Links + Köder innen #1',
          fr: 'À gauche + Orientez vers l\'intérieur #1',
          ja: '左 + 中へ誘導 #1',
          cn: '左 + 向内诱导 #1',
          ko: '왼쪽 + 내부 유도 #1'
        },
        goLeftBaitOuter: {
          en: 'Left + Bait Outer #1',
          de: 'Links + Köder außen #1',
          fr: 'À gauche + Orientez vers l\'extérieur #1',
          ja: '左 + 外へ誘導 #1',
          cn: '左 + 向外诱导 #1',
          ko: '왼쪽 + 외부 유도 #1'
        },
        goLeftBaitUnknown: {
          en: 'Left + Bait #1',
          de: 'Links + Köder #1',
          fr: 'À gauche + Orientez #1',
          ja: '左 + 誘導 #1',
          cn: '左 + 诱导 #1',
          ko: '왼쪽 + 유도 #1'
        }
      };
      if (data.statueTetherNumber !== 1) return {
        infoText: output.goLeft()
      };
      if (data.statueDir === 'inner') return {
        alarmText: output.goLeftBaitInner()
      };else if (data.statueDir === 'outer') return {
        alarmText: output.goLeftBaitOuter()
      };
      return {
        alarmText: output.goLeftBaitUnknown()
      };
    },
    run: data => data.isDoorBoss = true
  }, {
    id: 'E12S Promise Rapturous Reach Right',
    type: 'StartsUsing',
    netRegex: {
      source: 'Eden\'s Promise',
      id: '58AE',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        goRight: outputs/* default.right */.Z.right,
        goRightBaitInner: {
          en: 'Right + Bait Inner #1',
          de: 'Rechts + Köder innen #1',
          fr: 'À droite + Orientez vers l\'intérieur #1',
          ja: '右 + 中へ誘導 #1',
          cn: '右 + 向内诱导 #1',
          ko: '오른쪽 + 내부 유도 #1'
        },
        goRightBaitOuter: {
          en: 'Right + Bait Outer #1',
          de: 'Rechts + Köder außen #1',
          fr: 'À droite + Orientez vers l\'extérieur #1',
          ja: '右 + 外へ誘導 #1',
          cn: '右 + 向外诱导 #1',
          ko: '오른쪽 + 외부 유도 #1'
        },
        goRightBaitUnknown: {
          en: 'Right + Bait #1',
          de: 'Rechts + Köder #1',
          fr: 'À droite + Orientez #1',
          ja: '右 + 誘導 #1',
          cn: '右 + 诱导 #1',
          ko: '오른쪽 + 유도 #1'
        }
      };
      if (data.statueTetherNumber !== 1) return {
        infoText: output.goRight()
      };
      if (data.statueDir === 'inner') return {
        alarmText: output.goRightBaitInner()
      };else if (data.statueDir === 'outer') return {
        alarmText: output.goRightBaitOuter()
      };
      return {
        alarmText: output.goRightBaitUnknown()
      };
    },
    run: data => data.isDoorBoss = true
  }, {
    id: 'E12S Promise Maleficium',
    type: 'StartsUsing',
    netRegex: {
      source: 'Eden\'s Promise',
      id: '58A8',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E12S Promise Junction Shiva',
    type: 'Tether',
    netRegex: {
      id: shivaTetherId,
      capture: false
    },
    // Call out what the mechanic will be so that folks have time to move.
    preRun: data => {
      data.junctionSuffix = 'spread';
      data.junctionCount = (data.junctionCount ?? 0) + 1;
    },
    // Add in a slight delay for this big aoe so that trigger is < 10 seconds ahead.
    // Any further than 10 seconds and it's easy to miss reprisal or addle.
    delaySeconds: data => data.junctionCount === 2 ? 4 : 0,
    // For the junction with cast, keep the spread up for longer as a reminder.
    durationSeconds: data => data.junctionCount === 2 ? 4 : 13,
    alertText: (data, _matches, output) => {
      // The 2nd and 3rd junctions are different mechanics.
      if (data.junctionCount === 2) return output.diamondDust();
      return output.junctionWithCast();
    },
    outputStrings: {
      junctionWithCast: outputs/* default.spread */.Z.spread,
      diamondDust: {
        en: 'Big AOE, Get Middle',
        de: 'Große AoE, geh in die Mitte',
        fr: 'Grosse AoE, allez au milieu',
        ja: '大ダメージ、中へ',
        cn: '超大伤害，去中间',
        ko: '아픈 광뎀, 중앙으로'
      }
    }
  }, {
    id: 'E12S Promise Junction Titan',
    type: 'Tether',
    netRegex: {
      id: titanTetherId,
      capture: false
    },
    preRun: data => {
      data.junctionSuffix = 'stacks';
      data.junctionCount = (data.junctionCount ?? 0) + 1;
    },
    // Add in a slight delay for this big aoe so that trigger is < 10 seconds ahead.
    // Any further than 10 seconds and it's easy to miss reprisal or addle.
    // Note: Junction Titan is not the same distance away from the aoe as Junction Shiva.
    delaySeconds: data => data.junctionCount === 3 ? 5 : 0,
    // For the junction with cast, keep the stack up for longer as a reminder.
    durationSeconds: data => data.junctionCount === 3 ? 4 : 13,
    alertText: (data, _matches, output) => {
      // The 2nd and 3rd junctions are different mechanics.
      if (data.junctionCount === 3) return output.earthenFury();
      return output.junctionWithCast();
    },
    outputStrings: {
      junctionWithCast: {
        en: 'Healer Stacks',
        de: 'Heiler-Gruppen',
        fr: 'Packages sur les Heals',
        ja: 'ヒラ頭割り',
        cn: '治疗分摊',
        ko: '힐러 쉐어'
      },
      earthenFury: {
        en: 'Big AOE, Bombs Soon',
        de: 'Große AoE, bald Bomben',
        fr: 'Grosse AoE, Bombes bientôt',
        ja: '大ダメージ、まもなく岩落とし',
        cn: '超大伤害，即将落石',
        ko: '아픈 광뎀, 폭탄 떨어짐'
      }
    }
  }, {
    id: 'E12S Promise Tether Collect',
    type: 'Tether',
    netRegex: {
      id: e12s_tetherIds
    },
    run: (data, matches) => {
      data.tethers ??= [];
      data.tethers.push(matches.id);
    }
  }, {
    id: 'E12S Promise Stock',
    type: 'StartsUsing',
    netRegex: {
      source: 'Eden\'s Promise',
      id: '5892',
      capture: false
    },
    infoText: (data, _matches, output) => {
      data.stockedTethers = data.tethers;
      delete data.tethers;
      const text = getTetherString(data.stockedTethers, output);
      if (text === undefined) return;
      return output.stock({
        text: text
      });
    },
    outputStrings: e12s_primalOutputStrings
  }, {
    id: 'E12S Promise Cast Release',
    type: 'StartsUsing',
    netRegex: {
      source: 'Eden\'s Promise',
      id: ['4E43', '5893']
    },
    preRun: data => data.castCount = (data.castCount ?? 0) + 1,
    // The pattern is cast - cast - release - release - cast - release.
    // #4 (the 2nd release) starts casting just before the second lion fire breath.
    // Delay just a smidgen so that hypothetically you don't jump off your bait spot early.
    // This is a 7 second long cast bar, so you still have 5 seconds to make it in.
    delaySeconds: data => data.castCount === 4 ? 1.8 : 0,
    alertText: (data, matches, output) => {
      // The second cast comes with an obliteration group laser (and no junction).
      // The entire party should stack this one.
      if (data.castCount === 2) data.junctionSuffix = 'stack';

      // At the end of the fight, there is a stock -> cast -> release,
      // which means that we need to grab the original tethers during the first stock.
      const isRelease = matches.id === '5893';
      const text = getTetherString(isRelease ? data.stockedTethers : data.tethers, output);
      if (text === undefined) return;
      if (data.junctionSuffix === undefined) return text;
      return output.junctionSuffix({
        text: text,
        junction: output[data.junctionSuffix]()
      });
    },
    run: data => {
      delete data.tethers;
      delete data.junctionSuffix;
    },
    outputStrings: e12s_primalOutputStrings
  }, {
    id: 'E12S Promise Tether Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: ['4E43', '5892', '5893'],
      capture: false
    },
    delaySeconds: 10,
    run: data => delete data.tethers
  }, {
    id: 'E12S Promise Plunging Ice',
    type: 'StartsUsing',
    // This has a 9 second cast. :eyes:
    netRegex: {
      source: 'Eden\'s Promise',
      id: '589D',
      capture: false
    },
    delaySeconds: 4,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'E12S Promise Small Lion Spawn',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '9819'
    },
    run: (data, matches) => {
      data.smallLions ??= [];
      data.smallLions.push(matches);
    }
  }, {
    id: 'E12S Promise Small Lion Tether',
    type: 'Tether',
    netRegex: {
      source: 'Beastly Sculpture',
      id: '0011'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // Don't collide with reach left/right call.
    delaySeconds: 0.5,
    durationSeconds: 7,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        lionTetherOnYou: {
          en: 'Lion Tether on YOU',
          de: 'Löwen-Verbindung auf DIR',
          fr: 'Lien lion sur VOUS',
          ja: '自分にライオン線',
          cn: '狮子连线点名',
          ko: '작은 사자 대상자'
        },
        northEastLion: {
          en: 'NE Lion Tether',
          de: 'NO Löwen-Verbindung',
          fr: 'NE Lien lion',
          cn: '右上(东北)狮子连线',
          ko: '1시 사자 연결됨'
        },
        northWestLion: {
          en: 'NW Lion Tether',
          de: 'NW Löwen-Verbindung',
          fr: 'NO Lien lion',
          cn: '左上(西北)狮子连线',
          ko: '11시 사자 연결됨'
        },
        southEastLion: {
          en: 'SE Lion Tether',
          de: 'SO Löwen-Verbindung',
          fr: 'SE Lien lion',
          cn: '右下(东南)狮子连线',
          ko: '5시 사자 연결됨'
        },
        southWestLion: {
          en: 'SW Lion Tether',
          de: 'SW Löwen-Verbindung',
          fr: 'SO Lien lion',
          cn: '左下(西南)狮子连线',
          ko: '7시 사자 연결됨'
        }
      };
      if (!data.smallLions || data.smallLions.length === 0) return;
      const lion = data.smallLions?.find(l => l.id.toUpperCase() === matches.sourceId.toUpperCase());
      if (!lion) {
        console.error('Unable to locate a valid lion.');
        return {
          alertText: output.lionTetherOnYou()
        };
      }
      if (!lion.x || !lion.y) {
        console.error('Invalid Lion', lion);
        return {
          alertText: output.lionTetherOnYou()
        };
      }
      const centerY = -75;
      const x = parseFloat(lion.x);
      const y = parseFloat(lion.y);
      if (y < centerY) {
        if (x > 0) return {
          alertText: output.northEastLion()
        };
        return {
          alertText: output.northWestLion()
        };
      }
      if (x > 0) return {
        alertText: output.southEastLion()
      };
      return {
        alertText: output.southWestLion()
      };
    }
  }, {
    id: 'E12S Promise Laser Eye',
    type: 'StartsUsing',
    // This has a 14.5 second cast. :eyes:
    netRegex: {
      source: 'Eden\'s Promise',
      id: '58B8',
      capture: false
    },
    delaySeconds: 9.5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'E12S Oracle Shockwave Pulsar',
    type: 'StartsUsing',
    netRegex: {
      source: 'Oracle Of Darkness',
      id: '58F0',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E12S Relativity Phase',
    type: 'StartsUsing',
    netRegex: {
      source: 'Oracle Of Darkness',
      id: '58E[0-3]'
    },
    run: (data, matches) => {
      const phaseMap = {
        '58E0': 'basic',
        '58E1': 'intermediate',
        '58E2': 'advanced',
        '58E3': 'terminal'
      };
      data.phase = phaseMap[matches.id];
    }
  }, {
    id: 'E12S Oracle Basic Relativity',
    type: 'StartsUsing',
    netRegex: {
      source: 'Oracle Of Darkness',
      id: '58E0',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'E12S Oracle Intermediate Relativity',
    type: 'StartsUsing',
    netRegex: {
      source: 'Oracle Of Darkness',
      id: '58E1',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'E12S Oracle Advanced Relativity',
    type: 'StartsUsing',
    netRegex: {
      source: 'Oracle Of Darkness',
      id: '58E2',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'E12S Oracle Terminal Relativity',
    type: 'StartsUsing',
    netRegex: {
      source: 'Oracle Of Darkness',
      id: '58E3',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'E12S Oracle Darkest Dance',
    type: 'StartsUsing',
    // Darkest and Somber Dance both.
    netRegex: {
      source: 'Oracle Of Darkness',
      id: ['58BE', '58BD'],
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.role === 'tank') return output.tanksOutPartyIn();
      return output.partyInTanksOut();
    },
    outputStrings: {
      partyInTanksOut: {
        en: 'Party In (Tanks Out)',
        de: 'Gruppe Rein (Tanks Raus)',
        fr: 'Équipe à l\'intérieur (Tanks à l\'extérieur)',
        ja: 'ボスの足元へ (タンクは離れる)',
        cn: '小队进 (T出)',
        ko: '본대 안 (탱커 밖)'
      },
      tanksOutPartyIn: {
        en: 'Tanks Out (Party In)',
        de: 'Tanks Raus (Gruppe Rein)',
        fr: 'Tanks à l\'extérieur (Équipe à l\'intérieur',
        ja: 'ボスからはなれる (パーティーが内側)',
        cn: 'T出 (小队进)',
        ko: '탱커 밖 (본대 안)'
      }
    }
  }, {
    id: 'E12S Oracle Somber Dance',
    type: 'Ability',
    // Call for second hit of somber dance after first hit lands.
    netRegex: {
      source: 'Oracle Of Darkness',
      id: '58BD',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (data.role === 'tank') return output.tanksInPartyOut();
      return output.partyOutTanksIn();
    },
    outputStrings: {
      partyOutTanksIn: {
        en: 'Party Out (Tanks In)',
        de: 'Gruppe Raus (Tanks Rein)',
        fr: 'Équipe à l\'extérieur (Tanks à l\'intérieur)',
        ja: 'ボスから離れる (タンクが内側)',
        cn: '小队出 (T进)',
        ko: '본대 밖 (탱커 안)'
      },
      tanksInPartyOut: {
        en: 'Tanks In (Party Out)',
        de: 'Gruppe Rein (Tanks Raus)',
        fr: 'Tanks à l\'intérieur (Équipe à l\'extérieur',
        ja: 'ボスに足元へ (パーティーは離れる)',
        cn: 'T进 (小队出)',
        ko: '탱커 안 (본대 밖)'
      }
    }
  }, {
    id: 'E12S Oracle Cataclysm',
    type: 'StartsUsing',
    netRegex: {
      source: 'Oracle Of Darkness',
      id: '58C2'
    },
    delaySeconds: 0.5,
    promise: async (data, matches, output) => {
      // select the Oracle Of Darkness with same source id
      let oracleData = null;
      oracleData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.sourceId, 16)]
      });

      // if we could not retrieve combatant data, the
      // trigger will not work, so just resume promise here
      if (oracleData === null) {
        console.error(`Oracle Of Darkness: null data`);
        delete data.safeZone;
        return;
      }
      if (oracleData.combatants.length !== 1) {
        console.error(`Oracle Of Darkness: expected 1, got ${oracleData.combatants.length}`);
        delete data.safeZone;
        return;
      }
      const oracle = oracleData.combatants[0];
      if (!oracle) return;

      // Snap heading to closest card and add 2 for opposite direction
      // N = 0, E = 1, S = 2, W = 3
      const cardinal = (2 - Math.round(oracle.Heading * 4 / Math.PI) / 2 + 2) % 4;
      const dirs = {
        0: output.north(),
        1: output.east(),
        2: output.south(),
        3: output.west()
      };
      data.safeZone = dirs[cardinal];
    },
    infoText: (data, _matches, output) => data.safeZone ?? output.unknown(),
    outputStrings: {
      unknown: outputs/* default.unknown */.Z.unknown,
      north: outputs/* default.north */.Z.north,
      east: outputs/* default.east */.Z.east,
      south: outputs/* default.south */.Z.south,
      west: outputs/* default.west */.Z.west
    }
  }, {
    id: 'E12S Shell Crusher',
    type: 'StartsUsing',
    netRegex: {
      source: 'Oracle Of Darkness',
      id: '58C3',
      capture: false
    },
    response: responses/* Responses.getTogether */.n3.getTogether()
  }, {
    id: 'E12S Spirit Taker',
    type: 'Ability',
    // Spirit Taker always comes after Shell Crusher, so trigger on Shell Crusher damage
    // to warn people a second or two earlier than `starts using Spirit Taker` would occur.
    netRegex: {
      source: 'Oracle Of Darkness',
      id: '58C3',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'E12S Black Halo',
    type: 'StartsUsing',
    netRegex: {
      source: 'Oracle Of Darkness',
      id: '58C7'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E12S Dark Water Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: '99D'
    },
    run: (data, matches) => data.waterStacks.push(matches.target)
  }, {
    id: 'E12S Dark Water Cleanup',
    type: 'Ability',
    netRegex: {
      source: 'Oracle of Darkness',
      id: '58CA',
      capture: false
    },
    suppressSeconds: 5,
    run: data => data.waterStacks = []
  }, {
    id: 'E12S Basic Relativity Debuffs',
    type: 'GainsEffect',
    // 997 Spell-In-Waiting: Dark Fire III
    // 998 Spell-In-Waiting: Shadoweye
    // 99D Spell-In-Waiting: Dark Water III
    // 99E Spell-In-Waiting: Dark Blizzard III
    netRegex: {
      effectId: '99[78DE]'
    },
    condition: (data, matches) => {
      if (data.phase !== 'basic') return false;
      data.basicDebuffs.push(matches);
      return true;
    },
    delaySeconds: 0.5,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        shadoweye: {
          en: 'Eye (w/${player})',
          de: 'Auge (mit ${player})',
          fr: 'Œil (avec ${player})',
          ja: '自分に目 (w/${player})',
          // FIXME
          cn: '石化眼点名 (与${player})',
          ko: '시선징 (+${player})'
        },
        water: {
          en: 'Stack (w/${player})',
          de: 'Sammeln (mit ${player})',
          fr: 'Pack (avec ${player})',
          cn: '分摊 (与${player})',
          ko: '쉐어징 (+${player})'
        },
        longFire: {
          en: 'Long Fire (w/${player})',
          de: 'langes Feuer (w/${player})',
          fr: 'Feu long (avec ${player})',
          ja: 'ファイガ(遅い) (w/${player})',
          // FIXME
          cn: '长火 (与${player})',
          ko: '느린 파이가 (+${player})'
        },
        shortFire: {
          en: 'Short Fire (w/${player})',
          de: 'kurzes Feuer (w/${player})',
          fr: 'Feu court (avec ${player})',
          ja: 'ファイガ(早い) (w/${player})',
          // FIXME
          cn: '短火 (与${player})',
          ko: '빠른 파이가 (+${player})'
        },
        longIce: {
          en: 'Long Ice (w/${player})',
          de: 'langes Eis (w/${player})',
          fr: 'Glace longue (avec ${player})',
          ja: 'ブリザガ(遅い) (w/${player})',
          // FIXME
          cn: '长冰 (与${player})',
          ko: '느린 블리자가 (+${player})'
        },
        shortIce: {
          en: 'Short Ice (w/${player})',
          de: 'kurzes Eis (w/${player})',
          fr: 'Glace courte (avec ${player})',
          ja: 'ブリザガ(早い) (w/${player})',
          // FIXME
          cn: '短冰 (与${player})',
          ko: '빠른 블리자가 (+${player})'
        },
        unknown: outputs/* default.unknown */.Z.unknown
      };

      // Because this trigger is both collecting and calling, can't use suppress.
      // Use this set value to know if we've called anything out yet.
      if (data.myBasicDebuff !== undefined) return;
      const otherPlayer = names => {
        if (names.length !== 2) return output.unknown();
        const [name1, name2] = names;
        if (!names.includes(data.me) || name1 === undefined || name2 === undefined) return output.unknown();
        return data.party.member(name1 === data.me ? name2 : name1);
      };
      const eyes = data.basicDebuffs.filter(x => x.effectId === '998').map(x => x.target);
      data.basicEyes.push(...eyes);
      if (eyes.includes(data.me)) {
        data.myBasicDebuff = 'eye';
        return {
          infoText: output.shadoweye({
            player: otherPlayer(eyes)
          })
        };
      }
      const waters = data.basicDebuffs.filter(x => x.effectId === '99D').map(x => x.target);
      if (waters.includes(data.me)) {
        data.myBasicDebuff = 'water';
        return {
          infoText: output.water({
            player: otherPlayer(waters)
          })
        };
      }

      // Short fire/ice is 15 seconds, long fire/ice is 29 seconds.
      const longBuffs = data.basicDebuffs.filter(x => parseFloat(x.duration) > 20);
      const shortBuffs = data.basicDebuffs.filter(x => parseFloat(x.duration) < 20);
      const shortFires = shortBuffs.filter(x => x.effectId === '997').map(x => x.target);
      if (shortFires.includes(data.me)) {
        data.myBasicDebuff = 'shortFire';
        return {
          alertText: output.shortFire({
            player: otherPlayer(shortFires)
          })
        };
      }
      const longFires = longBuffs.filter(x => x.effectId === '997').map(x => x.target);
      if (longFires.includes(data.me)) {
        data.myBasicDebuff = 'longFire';
        return {
          infoText: output.longFire({
            player: otherPlayer(longFires)
          })
        };
      }
      const shortIces = shortBuffs.filter(x => x.effectId === '99E').map(x => x.target);
      if (shortIces.includes(data.me)) {
        data.myBasicDebuff = 'shortIce';
        return {
          alertText: output.shortIce({
            player: otherPlayer(shortIces)
          })
        };
      }
      const longIces = longBuffs.filter(x => x.effectId === '99E').map(x => x.target);
      if (longIces.includes(data.me)) {
        data.myBasicDebuff = 'longIce';
        return {
          alertText: output.longIce({
            player: otherPlayer(longIces)
          })
        };
      }
    }
  }, {
    id: 'E12S Intermediate Relativity Debuff Collector',
    type: 'GainsEffect',
    // 690 Spell-In-Waiting: Flare
    // 996 Spell-In-Waiting: Unholy Darkness
    // 998 Spell-In-Waiting: Shadoweye
    // 99C Spell-In-Waiting: Dark Eruption
    // 99E Spell-In-Waiting: Dark Blizzard III
    // 99F Spell-In-Waiting: Dark Aero III
    netRegex: {
      effectId: ['690', '99[68CEF]']
    },
    condition: (data, matches) => data.phase === 'intermediate' && matches.target === data.me,
    preRun: (data, matches) => {
      data.intermediateDebuffs[matches.effectId.toUpperCase()] = parseFloat(matches.duration);
    },
    durationSeconds: 20,
    infoText: (data, _matches, output) => {
      const unsortedIds = Object.keys(data.intermediateDebuffs);
      if (unsortedIds.length !== 3) return;

      // Sort effect ids descending by duration.
      const sortedIds = unsortedIds.sort((a, b) => (data.intermediateDebuffs?.[b] ?? 0) - (data.intermediateDebuffs?.[a] ?? 0));
      const keys = sortedIds.map(effectId => effectIdToOutputStringKey[effectId]);
      const [key0, key1, key2] = keys;
      if (key0 === undefined || key1 === undefined || key2 === undefined) throw new not_reached/* UnreachableCode */.$();

      // Stash outputstring keys to use later.
      data.intermediateDebuffsOutputKeys = [key1, key2];
      return output.comboText({
        effect1: output[key0](),
        effect2: output[key1](),
        effect3: output[key2]()
      });
    },
    outputStrings: {
      comboText: {
        en: '${effect1} > ${effect2} > ${effect3}',
        de: '${effect1} > ${effect2} > ${effect3}',
        fr: '${effect1} > ${effect2} > ${effect3}',
        ja: '${effect1} > ${effect2} > ${effect3}',
        cn: '${effect1} > ${effect2} > ${effect3}',
        ko: '${effect1} > ${effect2} > ${effect3}'
      },
      ...intermediateRelativityOutputStrings
    }
  }, {
    id: 'E12S Relativity Debuffs',
    type: 'GainsEffect',
    // Players originally get `Spell-in-Waiting: Return` or `Spell-in-Waiting: Return IV`.
    // When Spell-in-Waiting Return IV wears off, players get Return IV effect.
    // When Return IV effect wears off, players get Return effect.
    // When Return effect wears off, players go back to previous locations
    //
    // Return = 994
    // Return IV = 995
    netRegex: {
      effectId: '99[45]'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = Object.assign({
        moveAway: {
          en: 'Move!',
          de: 'Bewegen!',
          fr: 'Bougez !',
          ja: '避けて！',
          cn: '快移动！',
          ko: '이동하기!'
        }
      }, intermediateRelativityOutputStrings);
      if (data.phase !== 'intermediate') return {
        infoText: output.moveAway()
      };
      const key = data.intermediateDebuffsOutputKeys.shift();
      if (key === undefined) return {
        infoText: output.moveAway()
      };
      return {
        alertText: output[key]()
      };
    }
  }, {
    id: 'E12S Oracle Basic Relativity Shadow Eye Other',
    type: 'GainsEffect',
    netRegex: {
      effectId: '998'
    },
    condition: data => data.phase === 'basic',
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 3,
    suppressSeconds: 3,
    alertText: (data, _matches, output) => {
      const [player1, player2] = data.basicEyes;
      if (player1 !== data.me && player2 !== data.me) {
        // Call out both player names if you don't have eye
        return output.lookAwayFromPlayers({
          player1: data.party.member(player1),
          player2: data.party.member(player2)
        });
      } else if (player1 === data.me && player2 !== undefined) {
        // Call out second player name if exists and you have eye
        return output.lookAwayFromPlayer({
          player: data.party.member(player2)
        });
      } else if (player2 === data.me) {
        // Call out first player name if you have eye
        return output.lookAwayFromPlayer({
          player: data.party.member(player1)
        });
      }

      // Return empty when only you have eye
      return;
    },
    outputStrings: {
      lookAwayFromPlayers: {
        en: 'Look Away from ${player1} and ${player2}',
        de: 'Schau weg von ${player1} und ${player2}',
        fr: 'Ne regardez pas ${player1} et ${player2}',
        ja: '${player1}と${player2}を見ない',
        cn: '背对${player1}和${player2}',
        ko: '${player1}와 ${player2}에게서 뒤돌기'
      },
      lookAwayFromPlayer: outputs/* default.lookAwayFromPlayer */.Z.lookAwayFromPlayer
    }
  }, {
    // For intermediate and advanced, players should look outside during the final return effect.
    // For basic relativity, the shadoweye happens when the return puddle is dropped.
    id: 'E12S Relativity Look Outside',
    type: 'GainsEffect',
    netRegex: {
      effectId: '994'
    },
    condition: (data, matches) => data.phase !== 'basic' && matches.target === data.me,
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 2.5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look Outside',
        de: 'Nach draußen schauen',
        fr: 'Regardez vers l\'extérieur',
        ja: '外に向け',
        cn: '背对',
        ko: '바깥 보기'
      }
    }
  }, {
    id: 'E12S Basic Relativity Yellow Hourglass',
    type: 'AddedCombatant',
    // Orient where "Yellow" Anger's Hourglass spawns
    netRegex: {
      npcNameId: '9824'
    },
    durationSeconds: 10,
    infoText: (_data, matches, output) => {
      return output.hourglass({
        dir: dirToOutput(matchedPositionToDir(matches), output)
      });
    },
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      northeast: outputs/* default.northeast */.Z.northeast,
      east: outputs/* default.east */.Z.east,
      southeast: outputs/* default.southeast */.Z.southeast,
      south: outputs/* default.south */.Z.south,
      southwest: outputs/* default.southwest */.Z.southwest,
      west: outputs/* default.west */.Z.west,
      northwest: outputs/* default.northwest */.Z.northwest,
      hourglass: {
        en: 'Yellow: ${dir}',
        de: 'Gelb: ${dir}',
        fr: 'Jaune : ${dir}',
        ja: '黄色: ${dir}',
        cn: '黄色: ${dir}',
        ko: '노랑: ${dir}'
      }
    }
  }, {
    id: 'E12S Adv Relativity Hourglass Collect',
    type: 'AddedCombatant',
    // Collect Sorrow's Hourglass locations
    netRegex: {
      npcNameId: '9823'
    },
    run: (data, matches) => {
      const id = matches.id.toUpperCase();
      data.sorrows ??= {};
      data.sorrows[id] = matchedPositionToDir(matches);
    }
  }, {
    id: 'E12S Adv Relativity Hourglass Collect Yellow Tethers',
    type: 'Tether',
    // '0086' is the Yellow tether that buffs "Quicken"
    // '0085' is the Red tether that buffs "Slow"
    netRegex: {
      id: '0086'
    },
    condition: data => data.phase === 'advanced',
    durationSeconds: 4,
    suppressSeconds: 3,
    infoText: (data, matches, output) => {
      const sorrow1 = data.sorrows?.[matches.sourceId.toUpperCase()];
      if (sorrow1 === undefined) return;

      // Calculate opposite side
      const sorrow2 = (sorrow1 + 4) % 8;
      return output.hourglass({
        dir1: sorrow1 < sorrow2 ? dirToOutput(sorrow1, output) : dirToOutput(sorrow2, output),
        dir2: sorrow1 > sorrow2 ? dirToOutput(sorrow1, output) : dirToOutput(sorrow2, output)
      });
    },
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      northeast: outputs/* default.northeast */.Z.northeast,
      east: outputs/* default.east */.Z.east,
      southeast: outputs/* default.southeast */.Z.southeast,
      south: outputs/* default.south */.Z.south,
      southwest: outputs/* default.southwest */.Z.southwest,
      west: outputs/* default.west */.Z.west,
      northwest: outputs/* default.northwest */.Z.northwest,
      hourglass: {
        en: 'Yellow: ${dir1} / ${dir2}',
        de: 'Gelb: ${dir1} / ${dir2}',
        fr: 'Jaune : ${dir1} / ${dir2}',
        ja: '黄色: ${dir1} / ${dir2}',
        cn: '黄色: ${dir1} / ${dir2}',
        ko: '노랑: ${dir1} / ${dir2}'
      }
    }
  }, {
    id: 'E12S Initial Dark Water',
    type: 'GainsEffect',
    netRegex: {
      effectId: '99D',
      capture: false
    },
    condition: data => !data.phase,
    durationSeconds: 10,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      data.seenInitialStacks = true;
      if (data.waterStacks.length === 2) {
        const [player1, player2] = data.waterStacks.sort().map(x => data.party.member(x));
        if (data.seenInitialSpread) return output.knockbackIntoStacksOn({
          player1: player1,
          player2: player2
        });
        return output.stacksOn({
          player1: player1,
          player2: player2
        });
      }
      if (data.seenInitialSpread) return output.knockbackIntoStackGroups();
      return output.stackGroups();
    },
    outputStrings: {
      stackGroups: {
        en: 'Stack Groups',
        de: 'In Gruppen sammeln',
        fr: 'Packez-vous en groupe',
        ja: '頭割り',
        cn: '集合',
        ko: '쉐어'
      },
      stacksOn: {
        en: 'Stacks (${player1}, ${player2})',
        de: 'Sammeln (${player1}, ${player2})',
        fr: 'Packages (${player1}, ${player2})',
        cn: '分摊 (${player1}, ${player2})',
        ko: '쉐어 (${player1}, ${player2})'
      },
      knockbackIntoStackGroups: {
        en: 'Knockback Into Stack Groups',
        de: 'Rückstoß, dann in Gruppen sammeln',
        fr: 'Poussée puis packez-vous en groupe',
        ja: '頭割り位置に向かってノックバックを',
        cn: '击退分摊',
        ko: '넉백 후 쉐어'
      },
      knockbackIntoStacksOn: {
        en: 'Knockback => Stacks (${player1}, ${player2})',
        de: 'Rückstoß => Sammeln (${player1}, ${player2})',
        fr: 'Poussée => Package (${player1}, ${player2})',
        cn: '击退 => 分摊 (${player1}, ${player2})',
        ko: '넉백 => 쉐어 (${player1}, ${player2})'
      }
    }
  }, {
    id: 'E12S Initial Dark Eruption',
    type: 'GainsEffect',
    netRegex: {
      effectId: '99C'
    },
    condition: data => !data.phase,
    delaySeconds: (data, matches) => {
      const duration = parseFloat(matches.duration);
      return data.seenInitialSpread ? duration - 6 : duration - 8;
    },
    durationSeconds: 5,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      data.seenInitialSpread = true;
      if (data.seenInitialStacks) return output.knockbackIntoSpread();
      return output.spread();
    },
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread,
      knockbackIntoSpread: {
        en: 'Knockback Into Spread',
        de: 'Rückstoß dann verteilen',
        fr: 'Poussée puis dispersez-vous',
        ja: '散開のためノックバックを',
        cn: '分散击退',
        ko: '넉백 후 산개'
      }
    }
  }, {
    id: 'E12S Dark Water Stacks',
    type: 'GainsEffect',
    netRegex: {
      effectId: '99D'
    },
    // During Advanced Relativity, there is a very short Dark Water III stack (12s)
    // that applies when people position themselves for the initial Return placement.
    // Most strategies auto-handle this, and so this feels like noise.  HOWEVER,
    // using suppress here without this conditional will pick one of the short/long
    // Dark Water III buffs and suppress the other, so this is a load-bearing conditional.
    // Additionally, `data.phase` is checked here to avoid colliding with the special
    // case of the first dark water in `E12S Initial Dark Water`.
    condition: (data, matches) => data.phase !== undefined && parseFloat(matches.duration) > 13,
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 4,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      if (data.waterStacks.length === 2) {
        const [player1, player2] = data.waterStacks.sort().map(x => data.party.member(x));
        return output.stacksOn({
          player1: player1,
          player2: player2
        });
      }
      return output.stackGroups();
    },
    outputStrings: {
      stackGroups: {
        en: 'Stack Groups',
        de: 'In Gruppen sammeln',
        fr: 'Packez-vous en groupe',
        ja: '集合',
        cn: '集合',
        ko: '쉐어'
      },
      stacksOn: {
        en: 'Stacks (${player1}, ${player2})',
        de: 'Sammeln (${player1}, ${player2})',
        fr: 'Packages (${player1}, ${player2})',
        cn: '分摊 (${player1}, ${player2})',
        ko: '쉐어 (${player1}, ${player2})'
      }
    }
  }, {
    id: 'E12S Adv Relativity Buff Collector',
    type: 'GainsEffect',
    // 997 Spell-In-Waiting: Dark Fire III
    // 998 Spell-In-Waiting: Shadoweye
    // 99F Spell-In-Waiting: Dark Aero III
    netRegex: {
      effectId: '99[78F]'
    },
    condition: (data, matches) => {
      if (data.phase !== 'advanced') return false;
      data.advancedDebuffs.push(matches);
      return true;
    },
    delaySeconds: 0.5,
    durationSeconds: 15,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        shadoweye: {
          en: 'Eye (w/${player})',
          de: 'Auge (mit ${player})',
          fr: 'Œil(avec ${player})',
          ja: '自分に目 (w/${player})',
          // FIXME
          cn: '石化眼点名 (与${player})',
          ko: '시선징 (+${player})'
        },
        doubleAero: {
          en: 'Double Aero (w/${player})',
          de: 'Doppel Windga (mit ${player})',
          fr: 'Double Vent(avec ${player})',
          ja: '自分にエアロガ×2 (w/${player})',
          // FIXME
          cn: '双风点名 (与${player})',
          ko: '더블 에어로가 (+${player})'
        },
        spread: {
          en: 'Spread (w/${player1}, ${player2}, ${player3})',
          de: 'Verteilen (mit ${player1}, ${player2}, ${player3})',
          fr: 'Dispersion (avec ${player1}, ${player2}, ${player3})',
          ja: '自分に散開 (w/${player1}, ${player2}, ${player3})',
          // FIXME
          cn: '分散点名 (与${player1}, ${player2}, ${player3})',
          ko: '산개징 (+${player1}, ${player2}, ${player3})'
        },
        unknown: outputs/* default.unknown */.Z.unknown
      };
      if (data.advancedDebuffs.length === 0) return;
      const otherPlayer = names => {
        if (names.length !== 2) return output.unknown();
        const [name1, name2] = names;
        if (!names.includes(data.me) || name1 === undefined || name2 === undefined) return output.unknown();
        return data.party.member(name1 === data.me ? name2 : name1);
      };
      const aeros = data.advancedDebuffs.filter(x => {
        if (x.effectId !== '99F') return false;
        // The shadoweye and the double aero person gets aero, so only consider the final aero.
        return parseFloat(x.duration) > 28;
      }).map(x => x.target);
      if (aeros.includes(data.me)) return {
        alarmText: output.doubleAero({
          player: otherPlayer(aeros)
        })
      };
      const eyes = data.advancedDebuffs.filter(x => x.effectId === '998').map(x => x.target);
      if (eyes.includes(data.me)) return {
        alertText: output.shadoweye({
          player: otherPlayer(eyes)
        })
      };
      const spreads = data.advancedDebuffs.filter(x => x.effectId === '997').map(x => x.target);
      if (spreads.includes(data.me)) {
        const otherSpreads = spreads.filter(x => x !== data.me).sort().map(x => data.party.member(x));
        const [player1, player2, player3] = otherSpreads;
        return {
          infoText: output.spread({
            player1: player1,
            player2: player2,
            player3: player3
          })
        };
      }
    },
    run: data => data.advancedDebuffs = []
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Beastly Sculpture': 'Abbild eines Löwen',
      'Bomb Boulder': 'Bomber-Brocken',
      'Chiseled Sculpture': 'Abbild eines Mannes',
      'Eden\'s Promise': 'Edens Verheißung',
      'Guardian Of Eden': 'Wächter von Eden',
      'Ice Pillar': 'Eissäule',
      'Oracle Of Darkness': 'Orakel der Dunkelheit',
      'Sorrow\'s Hourglass': 'Sanduhr der Sorge'
    },
    'replaceText': {
      'Advanced Relativity': 'Fortgeschrittene Relativität',
      '(?<! )Apocalypse': 'Apokalypse',
      'Basic Relativity': 'Grundlegende Relativität',
      'Black Halo': 'Geschwärzter Schein',
      'Blade Of Flame': 'Flammenschwert',
      'Cast': 'Auswerfen',
      'Cataclysm': 'Kataklysmus',
      'Classical Sculpture': 'Klassische Skulptur',
      'Dark Aero III': 'Dunkel-Windga',
      'Dark Current': 'Dunkel-Strom',
      'Dark Eruption': 'Dunkle Eruption',
      'Dark Fire III': 'Dunkel-Feuga',
      'Dark Water III': 'Dunkel-Aquaga',
      'Darkest Dance': 'Finsterer Tanz',
      'Diamond Dust': 'Diamantenstaub',
      'Dual Apocalypse': 'Doppelte Apokalypse',
      'Earthen Fury': 'Gaias Zorn',
      'Empty Hate': 'Gähnender Abgrund',
      'Empty Rage': 'Lockende Leere',
      'Force Of The Land': 'Gaias Tosen',
      'Formless Judgment': 'Formloses Urteil',
      'Frigid Stone': 'Eisstein',
      'Hell\'s Judgment': 'Höllenurteil',
      'Ice Floe': 'Eisfluss',
      'Ice Pillar': 'Eissäule',
      'Impact': 'Impakt',
      'Initialize Recall': 'Rückholung initialisieren',
      'Intermediate Relativity': 'Intermediäre Relativität',
      'Junction Shiva': 'Verbindung: Shiva',
      'Junction Titan': 'Verbindung: Titan',
      'Laser Eye': 'Laserauge',
      'Lionsblaze': 'Löwenfeuer',
      'Maleficium': 'Maleficium',
      'Maelstrom': 'Mahlstrom',
      'Memory\'s End': 'Ende der Erinnerungen',
      'Obliteration Laser': 'Auslöschung',
      'Palm Of Temperance': 'Hand der Mäßigung',
      'Paradise Lost': 'Verlorenes Paradies',
      'Pillar Pierce': 'Säulendurchschlag',
      'Plunging Ice': 'Fallendes Eis',
      'Pulse Of The Land': 'Gaias Beben',
      'Quicken': 'Schnell',
      'Rapturous Reach': 'Stürmischer Griff',
      'Release': 'Freilassen',
      'Return(?! IV)': 'Rückführung',
      'Return IV': 'Giga-Rückführung',
      'Shadoweye': 'Schattenauge',
      'Shell Crusher': 'Hüllenbrecher',
      'Shockwave Pulsar': 'Schockwellenpulsar',
      'Singular Apocalypse': 'Einfache Apokalypse',
      'Slow': 'Langsam',
      'Somber Dance': 'Düsterer Tanz',
      'Speed': 'Geschwindigkeit',
      'Spell-In-Waiting': 'Verzögerung',
      'Spirit Taker': 'Geistesdieb',
      'Stock': 'Sammeln',
      'Terminal Relativity': 'Terminale Relativität',
      '(?<!Junction )Titan': 'Titan',
      'Triple Apocalypse': 'Dreifache Apokalypse',
      'Under The Weight': 'Wucht der Erde',
      'Weight Of The World': 'Schwere der Erde'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Beastly Sculpture': 'création léonine',
      'Bomb Boulder': 'bombo rocher',
      'Chiseled Sculpture': 'création masculine',
      'Eden\'s Promise': 'Promesse d\'Éden',
      'Guardian Of Eden': 'Gardien d\'Éden',
      'Ice Pillar': 'Pilier de glace',
      'Oracle Of Darkness': 'prêtresse des Ténèbres',
      'Sorrow\'s Hourglass': 'sablier de chagrin'
    },
    'replaceText': {
      'Advanced Relativity': 'Relativité avancée',
      '(?<! )Apocalypse': 'Apocalypse',
      'Basic Relativity': 'Relativité basique',
      'Black Halo': 'Halo de noirceur',
      'Blade Of Flame': 'Flammes de Lumière colossales',
      'Cast': 'Lancer',
      'Cataclysm': 'Cataclysme',
      'Classical Sculpture': 'Serviteur colossal',
      'Dark Aero III': 'Méga Vent ténébreux',
      'Dark Current': 'Flux sombre',
      'Dark Eruption': 'Éruption ténébreuse',
      'Dark Fire III': 'Méga Feu ténébreux',
      'Dark Water III': 'Méga Eau ténébreuse',
      'Darkest Dance': 'Danse de la nuit profonde',
      'Diamond Dust': 'Poussière de diamant',
      'Dual Apocalypse': 'Apocalypse double',
      'Earthen Fury': 'Fureur tellurique',
      'Empty Hate': 'Vaine malice',
      'Empty Rage': 'Vaine cruauté',
      'Force Of The Land': 'Grondement tellurique',
      'Formless Judgment': 'Onde du châtiment',
      'Frigid Stone': 'Rocher de glace',
      'Hell\'s Judgment': 'Jugement dernier',
      'Ice Floe': 'Flux glacé',
      'Ice Pillar': 'Pilier de glace',
      'Impact': 'Impact',
      'Initialize Recall': 'Remembrances',
      'Intermediate Relativity': 'Relativité intermédiaire',
      'Junction Shiva': 'Associer : Shiva',
      'Junction Titan': 'Associer : Titan',
      'Laser Eye': 'Faisceau maser',
      'Lionsblaze': 'Feu léonin',
      'Maleficium': 'Maleficium',
      'Maelstrom': 'Maelström',
      'Memory\'s End': 'Mort des souvenirs',
      'Obliteration Laser': 'Oblitération',
      'Palm Of Temperance': 'Paume de tempérance',
      'Paradise Lost': 'Paradis perdu',
      'Pillar Pierce': 'Frappe puissante',
      'Plunging Ice': 'Chute de glace',
      'Pulse Of The Land': 'Vibration tellurique',
      'Quicken': 'Accélération',
      'Rapturous Reach': 'Main voluptueuse',
      'Release': 'Relâcher',
      'Return(?! IV)': 'Retour',
      'Return IV': 'Giga Retour',
      'Shadoweye': 'Œil de l\'ombre',
      'Shell Crusher': 'Broyeur de carapace',
      'Shockwave Pulsar': 'Pulsar à onde de choc',
      'Singular Apocalypse': 'Apocalypse simple',
      'Slow': 'Lenteur',
      'Somber Dance': 'Danse du crépuscule',
      'Speed': 'Vitesse',
      'Spell-In-Waiting': 'Déphasage incantatoire',
      'Spirit Taker': 'Arracheur d\'esprit',
      'Stock': 'Stocker',
      'Terminal Relativity': 'Relativité terminale',
      '(?<!Junction )Titan': 'Titan',
      'Triple Apocalypse': 'Apocalypse triple',
      'Under The Weight': 'Pression tellurique',
      'Weight Of The World': 'Poids du monde'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Beastly Sculpture': '創られた獅子',
      'Bomb Boulder': 'ボムボルダー',
      'Chiseled Sculpture': '創られた男',
      'Eden\'s Promise': 'プロミス・オブ・エデン',
      'Guardian Of Eden': 'ガーディアン・オブ・エデン',
      'Ice Pillar': '氷柱',
      'Oracle Of Darkness': '闇の巫女',
      'Sorrow\'s Hourglass': '悲しみの砂時計'
    },
    'replaceText': {
      'Advanced Relativity': '時間圧縮・急',
      '(?<! )Apocalypse': 'アポカリプス',
      'Basic Relativity': '時間圧縮・序',
      'Black Halo': 'ブラックヘイロー',
      'Blade Of Flame': '巨兵の光炎',
      'Cast': 'はなつ',
      'Cataclysm': 'カタクリスム',
      'Classical Sculpture': '巨兵創出',
      'Dark Aero III': 'ダークエアロガ',
      'Dark Current': 'ダークストリーム',
      '(?<! )Dark Eruption(?! )': 'ダークエラプション',
      'Dark Eruption / Dark Water III': 'ダークエラプション/ダークウォタガ',
      'Dark Fire III': 'ダークファイガ',
      'Dark Water III / Dark Eruption': 'ダークウォタガ/ダークエラプション',
      '(?<! )Dark Water III(?! )': 'ダークウォタガ',
      'Darkest Dance': '暗夜の舞踏技',
      'Diamond Dust': 'ダイアモンドダスト',
      'Dual Apocalypse': 'アポカリプス・ダブル',
      'Earthen Fury': '大地の怒り',
      'Empty Hate': '虚ろなる悪意',
      'Empty Rage': '虚ろなる害意',
      'Force Of The Land': '大地の轟き',
      'Formless Judgment': '天罰の波動',
      'Frigid Stone': 'アイスストーン',
      'Hell\'s Judgment': 'ヘル・ジャッジメント',
      'Ice Floe': 'アイスフロー',
      'Ice Pillar': '氷柱',
      'Impact': '衝撃',
      'Initialize Recall': '記憶想起',
      'Intermediate Relativity': '時間圧縮・破',
      'Junction Shiva': 'ジャンクション：シヴァ',
      'Junction Titan': 'ジャンクション：タイタン',
      'Laser Eye': 'メーザーアイ',
      'Lionsblaze': '獅子の業火',
      'Maleficium': 'マレフィキウム',
      'Maelstrom': 'メイルシュトローム',
      'Memory\'s End': 'エンド・オブ・メモリーズ',
      'Obliteration Laser': 'マレフィキウム レーザー',
      'Palm Of Temperance': '拒絶の手',
      'Paradise Lost': 'パラダイスロスト',
      'Pillar Pierce': '激突',
      'Plunging Ice': '落氷衝撃',
      'Pulse Of The Land': '大地の響き',
      'Quicken': 'クイック',
      'Rapturous Reach': '悦楽の手',
      'Release': 'リリース',
      'Return(?! IV)': 'リターン',
      'Return IV': 'リタンジャ',
      'Shadoweye': 'シャドウアイ',
      'Shell Crusher': 'シェルクラッシャー',
      'Shockwave Pulsar': 'ショックウェーブ・パルサー',
      'Singular Apocalypse': 'アポカリプス・シングル',
      'Slow': 'スロウ',
      'Somber Dance': '宵闇の舞踏技',
      'Speed': 'スピード',
      'Spell-In-Waiting': 'ディレイスペル',
      'Spirit Taker': 'スピリットテイカー',
      'Stock': 'ストック',
      'Terminal Relativity': '時間圧縮・終',
      '(?<!Junction )Titan': 'タイタン',
      'Triple Apocalypse': 'アポカリプス・トリプル',
      'Under The Weight': '大地の重圧',
      'Weight Of The World': '大陸の重み'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Beastly Sculpture': '被创造的狮子',
      'Bomb Boulder': '爆破岩石',
      'Chiseled Sculpture': '被创造的男性',
      'Eden\'s Promise': '伊甸之约',
      'Guardian Of Eden': '伊甸守卫',
      'Ice Pillar': '冰柱',
      'Oracle Of Darkness': '暗之巫女',
      'Sorrow\'s Hourglass': '悲伤的沙漏'
    },
    'replaceText': {
      'Advanced Relativity': '时间压缩·转',
      '(?<! )Apocalypse': '启示',
      'Basic Relativity': '时间压缩·起',
      'Black Halo': '黑色光环',
      'Blade Of Flame': '巨兵光炎',
      'Cast': '释放',
      'Cataclysm': '大灾变',
      'Classical Sculpture': '创造巨兵',
      'Dark Aero III': '黑暗暴风',
      'Dark Current': '黑暗奔流',
      '(?<! )Dark Eruption(?! )': '暗炎喷发',
      'Dark Eruption / Dark Water III': '暗炎喷发/黑暗狂水',
      'Dark Fire III': '黑暗爆炎',
      'Dark Water III / Dark Eruption': '黑暗狂水/暗炎喷发',
      '(?<! )Dark Water III(?! )': '黑暗狂水',
      'Darkest Dance': '暗夜舞蹈',
      'Diamond Dust': '钻石星尘',
      'Dual Apocalypse': '双重启示',
      'Earthen Fury': '大地之怒',
      'Empty Hate': '空无的恶意',
      'Empty Rage': '空无的恶念',
      'Force Of The Land': '大地之轰',
      'Formless Judgment': '天罚波动',
      'Frigid Stone': '冰石',
      'Hell\'s Judgment': '地狱审判',
      'Ice Floe': '浮冰',
      'Ice Pillar': '冰柱',
      'Impact': '冲击',
      'Initialize Recall': '回想记忆',
      'Intermediate Relativity': '时间压缩·承',
      'Junction Shiva': '融合：希瓦',
      'Junction Titan': '融合：泰坦',
      'Laser Eye': '激射眼',
      'Lionsblaze': '狮子业火',
      'Maleficium': '邪法',
      'Maelstrom': '巨漩涡',
      'Memory\'s End': '记忆终结',
      'Obliteration Laser': '邪法激光',
      'Palm Of Temperance': '拒绝之手',
      'Paradise Lost': '失乐园',
      'Pillar Pierce': '激突',
      'Plunging Ice': '落冰冲击',
      'Pulse Of The Land': '大地之响',
      'Quicken': '神速',
      'Rapturous Reach': '愉悦之手',
      'Release': '施放',
      'Return(?! IV)': '回返',
      'Return IV': '强回返',
      'Shadoweye': '暗影之眼',
      'Shell Crusher': '破盾一击',
      'Shockwave Pulsar': '脉冲星震波',
      'Singular Apocalypse': '单一启示',
      'Slow': '减速',
      'Somber Dance': '真夜舞蹈',
      'Speed': '限速',
      'Spell-In-Waiting': '延迟咏唱',
      'Spirit Taker': '碎灵一击',
      'Stock': '储存',
      'Terminal Relativity': '时间压缩·合',
      '(?<!Junction )Titan': '泰坦',
      'Triple Apocalypse': '三重启示',
      'Under The Weight': '大地的重压',
      'Weight Of The World': '大陆之重'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Beastly Sculpture': '창조된 사자',
      'Bomb Boulder': '바위폭탄',
      'Chiseled Sculpture': '창조된 남자',
      'Eden\'s Promise': '에덴의 약속',
      'Guardian Of Eden': '에덴의 수호자',
      'Ice Pillar': '얼음기둥',
      'Oracle Of Darkness': '어둠의 무녀',
      'Sorrow\'s Hourglass': '슬픔의 모래시계'
    },
    'replaceText': {
      'Advanced Relativity': '시간 압축: 절정',
      '(?<! )Apocalypse': '대재앙',
      'Basic Relativity': '시간 압축: 발단',
      'Black Halo': '검은 빛무리',
      'Blade Of Flame': '거병의 광염',
      'Cast': '발현',
      'Cataclysm': '대격변',
      'Classical Sculpture': '거병 창조',
      'Dark Aero III': '다크 에어로가',
      'Dark Current': '어둠의 급류',
      '(?<! )Dark Eruption(?! )': '어둠의 불기둥',
      'Dark Eruption / Dark Water III': '어둠의 불기둥 / 다크 워터가',
      'Dark Fire III': '다크 파이가',
      'Dark Water III / Dark Eruption': '다크 워터가 / 어둠의 불기둥',
      '(?<! )Dark Water III(?! )': '다크 워터가',
      'Darkest Dance': '암야의 무도기',
      'Diamond Dust': '다이아몬드 더스트',
      'Dual Apocalypse': '대재앙 둘',
      'Earthen Fury': '대지의 분노',
      'Empty Hate': '공허한 악의',
      'Empty Rage': '공허한 적의',
      'Force Of The Land': '대지의 고동',
      'Formless Judgment': '천벌 파동',
      'Frigid Stone': '얼음돌',
      'Hell\'s Judgment': '황천의 심판',
      'Ice Floe': '유빙',
      'Ice Pillar': '고드름',
      'Impact': '충격',
      'Initialize Recall': '기억 상기',
      'Intermediate Relativity': '시간 압축: 전개',
      'Junction Shiva': '접속: 시바',
      'Junction Titan': '접속: 타이탄',
      'Laser Eye': '광선안',
      'Lionsblaze': '사자의 업화',
      'Maleficium': '마녀의 사술',
      'Maelstrom': '대격동',
      'Memory\'s End': '기억의 끝',
      'Obliteration Laser': '말소 레이저',
      'Palm Of Temperance': '거절의 손',
      'Paradise Lost': '실낙원',
      'Pillar Pierce': '고드름 격돌',
      'Plunging Ice': '낙수 충격',
      'Pulse Of The Land': '대지의 울림',
      'Quicken': '가속',
      'Rapturous Reach': '열락의 손',
      'Release': '기억 방출',
      'Return(?! IV)': '리턴',
      'Return IV': '리턴쟈',
      'Shadoweye': '그림자 시선',
      'Shell Crusher': '외피 파쇄',
      'Shockwave Pulsar': '맥동 충격파',
      'Singular Apocalypse': '대재앙 하나',
      'Slow': '감속',
      'Somber Dance': '어스름 무도기',
      'Speed': '속도 조절',
      'Spell-In-Waiting': '지연술',
      'Spirit Taker': '영혼 탈취',
      'Stock': '기억 보존',
      'Terminal Relativity': '시간 압축: 결말',
      '(?<!Junction )Titan': '타이탄',
      'Triple Apocalypse': '대재앙 셋',
      'Under The Weight': '대지의 중압',
      'Weight Of The World': '대륙의 무게'
    }
  }]
};
/* harmony default export */ const e12s = (e12s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e12s.txt
const raid_e12s_namespaceObject = "### Eden 12 (Savage) - Eden's Promise\r\n# Eden's Promise: Eternity (Savage)\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# -ii 4B1E 58AA 58AB 4E44 4E45 4E46 4E47 589B 4E5A 58A0 58B8 5897 58B0 58B4 4F9E 58BB 58BC\r\n# -p 58A8:16\r\n\r\n# Use autos/abilities instead of InCombat lines to start timelines for door & final boss\r\n# as timeline resets out of combat.\r\n\r\n0 \"Start\"\r\n0.8 \"--sync--\" Ability { id: \"4B1E\", source: \"Eden's Promise\" } window 1,0\r\n11.0 \"--sync--\" StartsUsing { id: \"58A8\", source: \"Eden's Promise\" } window 11,20\r\n16.0 \"Maleficium\" Ability { id: \"58A8\", source: \"Eden's Promise\" }\r\n23.2 \"--middle--\" Ability { id: \"58AF\", source: \"Eden's Promise\" }\r\n25.8 \"Initialize Recall\" Ability { id: \"588C\", source: \"Eden's Promise\" }\r\n32.4 \"Junction Shiva/Titan\" Ability { id: \"589[45]\", source: \"Eden's Promise\" }\r\n40.1 \"Rapturous Reach\" Ability { id: \"58A[DE]\", source: \"Eden's Promise\" }\r\n43.6 \"Frigid Stone/Under The Weight\" Ability { id: [\"589E\", \"58A6\"], source: \"Eden's Promise\" }\r\n53.3 \"Cast\" Ability { id: \"4E43\", source: \"Eden's Promise\" }\r\n56.8 \"Frigid Stone/Under The Weight\" Ability { id: [\"589E\", \"58A6\"], source: \"Eden's Promise\" }\r\n57.5 \"--sync--\" Ability { id: \"58A7\", source: \"Eden's Promise\" }\r\n68.7 \"Formless Judgment\" Ability { id: \"58A9\", source: \"Eden's Promise\" }\r\n#69.0 \"Formless Judgment\" Ability { id: \"58AC\", source: \"Eden's Promise\" }\r\n71.4 \"Formless Judgment\" #Ability { id: \"58AC\", source: \"Eden's Promise\" }\r\n81.9 \"Maleficium\" Ability { id: \"58A8\", source: \"Eden's Promise\" }\r\n90.2 \"--middle--\" Ability { id: \"58AF\", source: \"Eden's Promise\" }\r\n\r\n95.6 \"Junction Shiva\" Ability { id: \"5894\", source: \"Eden's Promise\" }\r\n106.5 \"Diamond Dust\" Ability { id: \"5896\", source: \"Eden's Promise\" }\r\n112.6 \"--sync--\" Ability { id: \"5898\", source: \"Eden's Promise\" }\r\n118.8 \"Ice Floe\" Ability { id: \"5899\", source: \"Eden's Promise\" }\r\n125.8 \"Ice Pillar\" Ability { id: \"589A\", source: \"Ice Pillar\" }\r\n137.8 \"Plunging Ice\" Ability { id: \"589D\", source: \"Eden's Promise\" }\r\n141.8 \"Pillar Pierce\" Ability { id: \"4B3F\", source: \"Ice Pillar\" }\r\n143.9 \"--sync--\" Ability { id: \"58A7\", source: \"Eden's Promise\" }\r\n155.0 \"Maleficium\" Ability { id: \"58A8\", source: \"Eden's Promise\" }\r\n\r\n163.3 \"--middle--\" Ability { id: \"58AF\", source: \"Eden's Promise\" }\r\n168.7 \"Junction Titan\" Ability { id: \"5895\", source: \"Eden's Promise\" }\r\n179.6 \"Earthen Fury\" Ability { id: \"589F\", source: \"Eden's Promise\" }\r\n\r\n184.6 \"Impact\" Ability { id: \"58A1\", source: \"Bomb Boulder\" }\r\n193.3 \"Pulse Of The Land\" Ability { id: \"58A3\", source: \"Eden's Promise\" }\r\n193.3 \"Force Of The Land\" Ability { id: \"58A4\", source: \"Eden's Promise\" }\r\n193.3 \"Weight Of The World\" Ability { id: \"58A5\", source: \"Eden's Promise\" }\r\n\r\n197.8 \"Impact\" Ability { id: \"58A1\", source: \"Bomb Boulder\" }\r\n206.4 \"Force Of The Land\" Ability { id: \"58A4\", source: \"Eden's Promise\" }\r\n206.4 \"Weight Of The World\" Ability { id: \"58A5\", source: \"Eden's Promise\" }\r\n\r\n210.9 \"Impact\" Ability { id: \"58A1\", source: \"Bomb Boulder\" }\r\n219.5 \"Pulse Of The Land\" Ability { id: \"58A3\", source: \"Eden's Promise\" }\r\n219.5 \"Force Of The Land\" Ability { id: \"58A4\", source: \"Eden's Promise\" }\r\n219.5 \"Weight Of The World\" Ability { id: \"58A5\", source: \"Eden's Promise\" }\r\n\r\n222.0 \"--sync--\" Ability { id: \"58A7\", source: \"Eden's Promise\" }\r\n239.2 \"Maleficium\" Ability { id: \"58A8\", source: \"Eden's Promise\" }\r\n248.4 \"--middle--\" Ability { id: \"58AF\", source: \"Eden's Promise\" }\r\n258.5 \"Cast\" Ability { id: \"4E43\", source: \"Eden's Promise\" }\r\n259.6 \"Obliteration Laser\" Ability { id: \"4E36\", source: \"Guardian Of Eden\" }\r\n269.8 \"Maleficium\" Ability { id: \"58A8\", source: \"Eden's Promise\" }\r\n\r\n283.0 \"Stock\" Ability { id: \"5892\", source: \"Eden's Promise\" }\r\n288.1 \"Classical Sculpture\" Ability { id: \"58B2\", source: \"Chiseled Sculpture\" }\r\n298.8 \"Blade Of Flame 1\" #Ability { id: \"58B3\", source: \"Chiseled Sculpture\" }\r\n299.2 \"Rapturous Reach\" Ability { id: \"58A[DE]\", source: \"Eden's Promise\" }\r\n301.9 \"Blade Of Flame 2\" #Ability { id: \"58B3\", source: \"Chiseled Sculpture\" }\r\n305.0 \"Blade Of Flame 3\" #Ability { id: \"58B3\", source: \"Chiseled Sculpture\" }\r\n307.1 \"--sync--\" Ability { id: \"58AF\", source: \"Eden's Promise\" }\r\n308.0 \"Blade Of Flame 4\" #Ability { id: \"58B3\", source: \"Chiseled Sculpture\" }\r\n310.2 \"Palm Of Temperance\" Ability { id: \"58B6\", source: \"Eden's Promise\" }\r\n316.5 \"Release\" Ability { id: \"5893\", source: \"Eden's Promise\" }\r\n327.7 \"Maleficium\" Ability { id: \"58A8\", source: \"Eden's Promise\" }\r\n\r\n335.4 \"Formless Judgment\" Ability { id: \"58A9\", source: \"Eden's Promise\" }\r\n#335.7 \"Formless Judgment\" Ability { id: \"58AC\", source: \"Eden's Promise\" }\r\n338.1 \"Formless Judgment\" #Ability { id: \"58AC\", source: \"Eden's Promise\" }\r\n\r\n352.1 \"Stock\" Ability { id: \"5892\", source: \"Eden's Promise\" }\r\n362.3 \"Rapturous Reach\" Ability { id: \"58A[DE]\", source: \"Eden's Promise\" }\r\n365.4 \"Lionsblaze 1\" Ability { id: \"58B9\", source: \"Beastly Sculpture\" }\r\n369.5 \"--sync--\" Ability { id: \"58AF\", source: \"Eden's Promise\" }\r\n370.3 \"Laser Eye\" Ability { id: \"58B7\", source: \"Guardian Of Eden\" }\r\n374.5 \"Lionsblaze 2\" Ability { id: \"58B9\", source: \"Beastly Sculpture\" }\r\n379.7 \"Release\" Ability { id: \"5893\", source: \"Eden's Promise\" }\r\n383.8 \"Lionsblaze 3\" Ability { id: \"58B9\", source: \"Beastly Sculpture\" }\r\n388.9 \"Rapturous Reach\" Ability { id: \"58A[DE]\", source: \"Eden's Promise\" }\r\n401.7 \"Maleficium\" Ability { id: \"58A8\", source: \"Eden's Promise\" }\r\n\r\n414.9 \"Stock\" Ability { id: \"5892\", source: \"Eden's Promise\" }\r\n418.2 \"--middle--\" Ability { id: \"58AF\", source: \"Eden's Promise\" }\r\n424.3 \"Junction Shiva/Titan\" Ability { id: \"589[45]\", source: \"Eden's Promise\" }\r\n434.0 \"Cast\" Ability { id: \"4E43\", source: \"Eden's Promise\" }\r\n437.5 \"Frigid Stone/Under The Weight\" Ability { id: [\"589E\", \"58A6\"], source: \"Eden's Promise\" }\r\n438.2 \"--sync--\" Ability { id: \"58A7\", source: \"Eden's Promise\" }\r\n445.8 \"Maleficium\" Ability { id: \"58A8\", source: \"Eden's Promise\" }\r\n\r\n453.0 \"Junction Shiva/Titan\" Ability { id: \"589[45]\", source: \"Eden's Promise\" }\r\n462.7 \"Release\" Ability { id: \"5893\", source: \"Eden's Promise\" }\r\n466.2 \"Frigid Stone/Under The Weight\" Ability { id: [\"589E\", \"58A6\"], source: \"Eden's Promise\" }\r\n466.9 \"--sync--\" Ability { id: \"58A7\", source: \"Eden's Promise\" }\r\n\r\n478.1 \"Formless Judgment\" Ability { id: \"58A9\", source: \"Eden's Promise\" }\r\n#478.4 \"Formless Judgment\" Ability { id: \"58AC\", source: \"Eden's Promise\" }\r\n480.9 \"Formless Judgment\" #Ability { id: \"58AC\", source: \"Eden's Promise\" }\r\n\r\n489.4 \"Maleficium\" Ability { id: \"58A8\", source: \"Eden's Promise\" }\r\n498.6 \"Maleficium\" Ability { id: \"58A8\", source: \"Eden's Promise\" }\r\n506.9 \"--untargetable--\"\r\n512.0 \"Paradise Lost\" Ability { id: \"58BA\", source: \"Eden's Promise\" }\r\n\r\n\r\n### Oracle of Darkness\r\n# -p 58EF:1015\r\n# -it \"Oracle Of Darkness\"\r\n# -ii 4B1F 58C5 58C6 58D7 58BF 58C9 58CB 58CC 58CE\r\n\r\n1000.0 \"Start\"\r\n1011.0 \"--sync--\" StartsUsing { id: \"58EF\", source: \"Oracle Of Darkness\" } window 1011,0\r\n1015.0 \"Hell's Judgment\" Ability { id: \"58EF\", source: \"Oracle Of Darkness\" }\r\n1023.2 \"Shockwave Pulsar\" Ability { id: \"58F0\", source: \"Oracle Of Darkness\" }\r\n\r\n1032.3 \"Spell-In-Waiting\" Ability { id: \"58C8\", source: \"Oracle Of Darkness\" }\r\n1045.6 \"Spell-In-Waiting\" Ability { id: \"58C8\", source: \"Oracle Of Darkness\" }\r\n1053.3 \"Dark Water III / Dark Eruption\" Ability { id: \"58C[AD]\", source: \"Oracle Of Darkness\" }\r\n1064.9 \"Darkest Dance\" Ability { id: \"58BE\", source: \"Oracle Of Darkness\" }\r\n1067.9 \"Darkest Dance\" Ability { id: \"58C1\", source: \"Oracle Of Darkness\" }\r\n1071.5 \"Dark Eruption / Dark Water III\" Ability { id: \"58C[AD]\", source: \"Oracle Of Darkness\" }\r\n1080.7 \"Shockwave Pulsar\" Ability { id: \"58F0\", source: \"Oracle Of Darkness\" }\r\n\r\n1101.9 \"Basic Relativity\" Ability { id: \"58E0\", source: \"Oracle Of Darkness\" } window 200,100\r\n1110.0 \"Speed\" Ability { id: \"58DD\", source: \"Oracle Of Darkness\" }\r\n1110.0 \"Slow\" Ability { id: \"58DF\", source: \"Oracle Of Darkness\" }\r\n1110.0 \"Quicken\" Ability { id: \"58DE\", source: \"Oracle Of Darkness\" }\r\n1117.0 \"Dark Current\" Ability { id: \"58D7\", source: \"Sorrow's Hourglass\" }\r\n1124.0 \"Dark Current\" Ability { id: \"58D7\", source: \"Sorrow's Hourglass\" }\r\n1124.8 \"Return\" Ability { id: \"58D6\", source: \"Oracle Of Darkness\" }\r\n1124.8 \"Shadoweye\" Ability { id: \"58D2\", source: \"Oracle Of Darkness\" }\r\n1131.0 \"Dark Current\" Ability { id: \"58D7\", source: \"Sorrow's Hourglass\" }\r\n1131.0 \"Empty Rage\" Ability { id: \"58DB\", source: \"Sorrow's Hourglass\" }\r\n1135.1 \"Empty Hate\" Ability { id: \"58DC\", source: \"Sorrow's Hourglass\" }\r\n1138.8 \"Dark Water III\" Ability { id: \"58CA\", source: \"Oracle Of Darkness\" }\r\n1148.1 \"Shockwave Pulsar\" Ability { id: \"58F0\", source: \"Oracle Of Darkness\" }\r\n\r\n1163.3 \"Singular Apocalypse\" Ability { id: \"58E5\", source: \"Oracle Of Darkness\" } window 200,100\r\n1172.7 \"Cataclysm\" Ability { id: \"58C2\", source: \"Oracle Of Darkness\" }\r\n1181.3 \"Black Halo\" Ability { id: \"58C7\", source: \"Oracle Of Darkness\" }\r\n1185.6 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1187.1 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1188.6 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1189.0 \"Shell Crusher\" Ability { id: \"58C3\", source: \"Oracle Of Darkness\" }\r\n1190.1 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1191.6 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1193.1 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1194.6 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1195.0 \"Spirit Taker\" Ability { id: \"58C4\", source: \"Oracle Of Darkness\" }\r\n1196.0 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1197.5 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1199.0 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1206.2 \"Shockwave Pulsar\" Ability { id: \"58F0\", source: \"Oracle Of Darkness\" }\r\n\r\n1224.4 \"Intermediate Relativity\" Ability { id: \"58E1\", source: \"Oracle Of Darkness\" } window 300,100\r\n# TODO: fill this in better with where the rewinds drop\r\n1237.3 \"Return IV\" Ability { id: \"4E59\", source: \"Oracle Of Darkness\" }\r\n1265.6 \"Shockwave Pulsar\" Ability { id: \"58F0\", source: \"Oracle Of Darkness\" }\r\n\r\n1280.8 \"Dual Apocalypse\" Ability { id: \"501C\", source: \"Oracle Of Darkness\" } window 300,100\r\n1290.2 \"Cataclysm\" Ability { id: \"58C2\", source: \"Oracle Of Darkness\" }\r\n1295.1 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1297.1 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1299.1 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1301.1 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1302.4 \"Somber Dance\" Ability { id: \"58BD\", source: \"Oracle Of Darkness\" }\r\n1303.1 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1305.1 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1305.9 \"Somber Dance\" Ability { id: \"58C0\", source: \"Oracle Of Darkness\" }\r\n1316.2 \"Shell Crusher\" Ability { id: \"58C3\", source: \"Oracle Of Darkness\" }\r\n1322.1 \"Spirit Taker\" Ability { id: \"58C4\", source: \"Oracle Of Darkness\" }\r\n1330.7 \"Shockwave Pulsar\" Ability { id: \"58F0\", source: \"Oracle Of Darkness\" }\r\n\r\n1349.9 \"Advanced Relativity\" Ability { id: \"58E2\", source: \"Oracle Of Darkness\" } window 400,100\r\n1353.9 \"--untargetable--\"\r\n1358.0 \"Speed\" Ability { id: \"58DD\", source: \"Oracle Of Darkness\" }\r\n1358.1 \"Slow\" Ability { id: \"58DF\", source: \"Oracle Of Darkness\" }\r\n1358.1 \"Quicken\" Ability { id: \"58DE\", source: \"Oracle Of Darkness\" }\r\n1362.8 \"Return IV\" Ability { id: \"4E59\", source: \"Oracle Of Darkness\" }\r\n1362.8 \"Dark Water III\" Ability { id: \"58CA\", source: \"Oracle Of Darkness\" }\r\n1373.1 \"Maelstrom\" Ability { id: \"58DA\", source: \"Sorrow's Hourglass\" }\r\n1373.9 \"Dark Fire III\" Ability { id: \"58CF\", source: \"Oracle Of Darkness\" }\r\n1373.9 \"Dark Aero III\" Ability { id: \"58D4\", source: \"Oracle Of Darkness\" }\r\n1377.1 \"Maelstrom\" Ability { id: \"58DA\", source: \"Sorrow's Hourglass\" }\r\n1377.9 \"Shadoweye\" Ability { id: \"58D2\", source: \"Oracle Of Darkness\" }\r\n1381.2 \"Maelstrom\" Ability { id: \"58DA\", source: \"Sorrow's Hourglass\" }\r\n1382.0 \"Dark Aero III\" Ability { id: \"58D4\", source: \"Oracle Of Darkness\" }\r\n1386.0 \"Dark Water III\" Ability { id: \"58CA\", source: \"Oracle Of Darkness\" }\r\n1387.2 \"--targetable--\"\r\n1395.4 \"Shockwave Pulsar\" Ability { id: \"58F0\", source: \"Oracle Of Darkness\" }\r\n\r\n1412.6 \"Triple Apocalypse\" Ability { id: \"501D\", source: \"Oracle Of Darkness\" } window 500,100\r\n1421.3 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1422.8 \"Darkest Dance\" Ability { id: \"58BE\", source: \"Oracle Of Darkness\" }\r\n1424.3 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1425.9 \"Darkest Dance\" Ability { id: \"58C1\", source: \"Oracle Of Darkness\" }\r\n1427.3 \"Apocalypse\" #Ability { id: \"58E6\", source: \"Oracle Of Darkness\" }\r\n1439.3 \"Shockwave Pulsar\" Ability { id: \"58F0\", source: \"Oracle Of Darkness\" }\r\n1447.9 \"Black Halo\" Ability { id: \"58C7\", source: \"Oracle Of Darkness\" }\r\n\r\n1471.1 \"Terminal Relativity\" Ability { id: \"58E3\", source: \"Oracle Of Darkness\" } window 500,100\r\n1477.9 \"--1--\" #Ability { id: \"501E\", source: \"Oracle Of Darkness\" }\r\n1481.0 \"--2--\" #Ability { id: \"501E\", source: \"Oracle Of Darkness\" }\r\n1484.0 \"--3--\" #Ability { id: \"501E\", source: \"Oracle Of Darkness\" }\r\n1486.2 \"Shockwave Pulsar 1\" Ability { id: \"58D5\", source: \"Oracle Of Darkness\" }\r\n1491.0 \"--1--\" #Ability { id: \"501E\", source: \"Oracle Of Darkness\" }\r\n1493.9 \"--2--\" #Ability { id: \"501E\", source: \"Oracle Of Darkness\" }\r\n1496.9 \"--3--\" #Ability { id: \"501E\", source: \"Oracle Of Darkness\" }\r\n1499.7 \"Shockwave Pulsar 2\" Ability { id: \"58D5\", source: \"Oracle Of Darkness\" }\r\n1503.9 \"--1--\" #Ability { id: \"501E\", source: \"Oracle Of Darkness\" }\r\n1506.9 \"--2--\" #Ability { id: \"501E\", source: \"Oracle Of Darkness\" }\r\n1509.9 \"--3--\" #Ability { id: \"501E\", source: \"Oracle Of Darkness\" }\r\n1513.2 \"Shockwave Pulsar 3\" Ability { id: \"58D5\", source: \"Oracle Of Darkness\" }\r\n\r\n1533.7 \"Memory's End\" Ability { id: \"58E4\", source: \"Oracle Of Darkness\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e1n.ts



const e1n_triggerSet = {
  id: 'EdensGateResurrection',
  zoneId: zone_id/* default.EdensGateResurrection */.Z.EdensGateResurrection,
  timelineFile: 'e1n.txt',
  triggers: [{
    id: 'E1N Eden\'s Gravity',
    type: 'StartsUsing',
    netRegex: {
      id: '3D94',
      source: 'Eden Prime',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E1N Fragor Maximus',
    type: 'StartsUsing',
    netRegex: {
      id: '3DA4',
      source: 'Eden Prime',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E1N Dimensional Shift',
    type: 'StartsUsing',
    netRegex: {
      id: '3D9C',
      source: 'Eden Prime',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E1N Eden\'s Flare',
    type: 'StartsUsing',
    netRegex: {
      id: '3D97',
      source: 'Eden Prime',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'E1N Vice of Vanity You',
    type: 'Tether',
    netRegex: {
      id: '0011',
      target: 'Eden Prime'
    },
    condition: (data, matches) => data.me === matches.source,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank Laser on YOU',
        de: 'Tank Laser auf DIR',
        fr: 'Tank laser sur VOUS',
        ja: '自分にタンクレーザー',
        cn: '坦克射线点名',
        ko: '탱 레이저 대상자'
      }
    }
  }, {
    id: 'E1N Spear Of Paradise',
    type: 'StartsUsing',
    netRegex: {
      id: '3DA1',
      source: 'Eden Prime'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E1N Vice of Apathy Mark',
    type: 'HeadMarker',
    netRegex: {
      id: '001C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Puddle, Run Middle',
        de: 'Flächen ablegen, danach in die Mitte',
        fr: 'Déposez les zones au sol, courez au milieu',
        ja: '捨て、そして中へ',
        cn: '放圈，回中央',
        ko: '장판 깔고 중앙으로'
      }
    }
  }, {
    // 10.5 second cast, maybe warn 6 seconds ahead so that folks bait outside.
    id: 'E1N Pure Light',
    type: 'StartsUsing',
    netRegex: {
      id: '3DA3',
      source: 'Eden Prime',
      capture: false
    },
    delaySeconds: 4.5,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Eden(?! )': 'Eden',
      'Eden Prime': 'Prim-Eden',
      'Guardian of Paradise': 'Hüter von Eden'
    },
    'replaceText': {
      'Delta Attack': 'Delta-Attacke',
      'Dimensional Shift': 'Dimensionsverschiebung',
      'Eden\'s Blizzard III': 'Eden-Eisga',
      'Eden\'s Fire III': 'Eden-Feuga',
      'Eden\'s Flare': 'Eden-Flare',
      'Eden\'s Gravity': 'Eden-Gravitas',
      'Eden\'s Thunder III': 'Eden-Blitzga',
      'Eternal Breath': 'Ewiger Atem',
      'Fragor Maximus': 'Fragor Maximus',
      'Heavensunder': 'Himmelsdonner',
      'Mana Burst': 'Manastoß',
      'Mana Slice': 'Manahieb',
      'Paradisal Dive': 'Paradiessturz',
      'Paradise Lost': 'Verlorenes Paradies',
      'Primeval Stasis': 'Urzeitliche Stase',
      'Pure Beam': 'Läuternder Strahl',
      'Pure Light': 'Läuterndes Licht',
      'Spear Of Paradise': 'Paradiesspeer',
      'Unto Dust': 'Sprengung',
      'Vice And Virtue': 'Laster und Tugend',
      'Vice Of Apathy': 'Laster der Apathie',
      'Vice Of Vanity': 'Laster der Eitelkeit'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Eden(?! )': 'Éden',
      'Eden Prime': 'Primo-Éden',
      'Guardian of Paradise': 'Gardien du jardin'
    },
    'replaceText': {
      'Delta Attack': 'Attaque Delta',
      'Dimensional Shift': 'Translation dimensionnelle',
      'Eden\'s Blizzard III': 'Méga Glace édénique',
      'Eden\'s Fire III': 'Méga Feu édénique',
      'Eden\'s Flare': 'Brasier édénique',
      'Eden\'s Gravity': 'Gravité édénique',
      'Eden\'s Thunder III': 'Méga Foudre édénique',
      'Eternal Breath': 'Souffle de l\'éternel',
      'Fragor Maximus': 'Fragor Maximus',
      'Heavensunder': 'Ravageur de paradis',
      'Mana Burst': 'Explosion de mana',
      'Mana Slice': 'Taillade de mana',
      'Paradisal Dive': 'Piqué du paradis',
      'Paradise Lost': 'Paradis perdu',
      'Primeval Stasis': 'Stase primordiale',
      'Pure Beam': 'Rayon purificateur',
      'Pure Light': 'Lumière purificatrice',
      'Spear of Paradise': 'Lance du paradis',
      'Unto Dust': 'Déflagration',
      'Vice and Virtue': 'Vice et vertue',
      'Vice of Apathy': 'Péché d\'apathie',
      'Vice of Vanity': 'Péché de vanité'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Eden(?! )': 'エデン',
      'Eden Prime': 'エデン・プライム',
      'Guardian of Paradise': 'エデン・ガーデナー'
    },
    'replaceText': {
      'Delta Attack': 'デルタアタック',
      'Dimensional Shift': 'ディメンションシフト',
      'Eden\'s Blizzard III': 'エデン・ブリザガ',
      'Eden\'s Fire III': 'エデン・ファイガ',
      'Eden\'s Flare': 'エデン・フレア',
      'Eden\'s Gravity': 'エデン・グラビデ',
      'Eden\'s Thunder III': 'エデン・サンダガ',
      'Eternal Breath': 'エターナル・ブレス',
      'Fragor Maximus': 'フラゴルマクシマス',
      'Heavensunder': 'ヘヴンサンダー',
      'Mana Burst': 'マナバースト',
      'Mana Slice': 'マナスラッシュ',
      'Paradisal Dive': 'パラダイスダイブ',
      'Paradise Lost': 'パラダイスロスト',
      'Primeval Stasis': 'プライムイーバルステーシス',
      'Pure Beam': 'ピュアレイ',
      'Pure Light': 'ピュアライト',
      'Unto Dust': '爆裂',
      'Spear of Paradise': 'スピア・オブ・パラダイス',
      'Vice and Virtue': 'ヴァイス・アンド・ヴァーチュー',
      'Vice of Apathy': 'ヴァイス・オブ・アパシー',
      'Vice of Vanity': 'ヴァイス・オブ・ヴァニティー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Eden(?! )': '伊甸',
      'Eden Prime': '至尊伊甸',
      'Guardian of Paradise': '伊甸守护者'
    },
    'replaceText': {
      'Delta Attack': '三角攻击',
      'Dimensional Shift': '空间转换',
      'Eden\'s Blizzard III': '伊甸冰封',
      'Eden\'s Fire III': '伊甸爆炎',
      'Eden\'s Flare': '伊甸核爆',
      'Eden\'s Gravity': '伊甸重力',
      'Eden\'s Thunder III': '伊甸暴雷',
      'Eternal Breath': '永恒吐息',
      'Fragor Maximus': '极大爆炸',
      'Heavensunder': '天国分断',
      'Mana Burst': '魔力爆发',
      'Mana Slice': '魔力斩击',
      'Paradisal Dive': '乐园冲',
      'Paradise Lost': '失乐园',
      'Primeval Stasis': '原初停滞',
      'Pure Beam': '净土射线',
      'Pure Light': '净土之光',
      'Spear of Paradise': '乐园之枪',
      'Unto Dust': '归于尘土',
      'Vice and Virtue': '恶习与美德',
      'Vice of Apathy': '冷漠之恶',
      'Vice of Vanity': '虚荣之恶'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Eden(?! )': '에덴',
      'Eden Prime': '에덴 프라임',
      'Guardian of Paradise': '에덴 정원사'
    },
    'replaceText': {
      'Delta Attack': '델타 공격',
      'Dimensional Shift': '차원 전환',
      'Eden\'s Blizzard III': '에덴 블리자가',
      'Eden\'s Fire III': '에덴 파이가',
      'Eden\'s Flare': '에덴 플레어',
      'Eden\'s Gravity': '에덴 그라비데',
      'Eden\'s Thunder III': '에덴 선더가',
      'Eternal Breath': '영원의 숨결',
      'Fragor Maximus': '우주 탄생',
      'Heavensunder': '천국의 낙뢰',
      'Mana Burst': '마나 폭발',
      'Mana Slice': '마나 베기',
      'Paradisal Dive': '낙원 강하',
      'Paradise Lost': '실낙원',
      'Primeval Stasis': '태초의 안정',
      'Pure Beam': '완전한 광선',
      'Pure Light': '완전한 빛',
      'Spear of Paradise': '낙원의 창',
      'Unto Dust': '폭렬',
      'Vice and Virtue': '선과 악',
      'Vice of Apathy': '냉담의 악덕',
      'Vice of Vanity': '허영의 악덕'
    }
  }]
};
/* harmony default export */ const e1n = (e1n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e1n.txt
const raid_e1n_namespaceObject = "### Eden 1 (Normal)\r\n# Eden's Gate: Resurrection\r\n# -p 3DA1:12 3E3A:300 -ii 3D9E 3DA0 44FF\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Vice And Virtue\"\r\n\r\n### Phase 1\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n12.0 \"Spear Of Paradise\" Ability { id: \"3DA1\", source: \"Eden Prime\" } window 12,5\r\n13.5 \"Heavensunder\" Ability { id: \"3DA2\", source: \"Eden Prime\" }\r\n22.5 \"Eden's Gravity\" Ability { id: \"3D94\", source: \"Eden Prime\" }\r\n34.1 \"Vice And Virtue\" Ability { id: \"44E5\", source: \"Eden Prime\" }\r\n34.1 \"Vice Of Apathy\" Ability { id: \"44E8\", source: \"Eden Prime\" }\r\n40.5 \"Eden's Flare\" Ability { id: \"3D97\", source: \"Eden Prime\" }\r\n56.1 \"Vice And Virtue\" Ability { id: \"44E4\", source: \"Eden Prime\" }\r\n56.9 \"Vice Of Vanity\" Ability { id: \"44E7\", source: \"Eden Prime\" }\r\n66.7 \"Spear Of Paradise\" Ability { id: \"3DA1\", source: \"Eden Prime\" }\r\n68.2 \"Heavensunder\" Ability { id: \"3DA2\", source: \"Eden Prime\" }\r\n73.2 \"--corner--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n86.5 \"Pure Light\" Ability { id: \"3DA3\", source: \"Eden Prime\" }\r\n92.4 \"--center--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n101.6 \"Delta Attack\" Ability { id: \"44EA\", source: \"Eden Prime\" }\r\n102.2 \"Eden's Thunder III\" Ability { id: \"44ED\", source: \"Eden Prime\" }\r\n102.2 \"Eden's Blizzard III\" Ability { id: \"44EC\", source: \"Eden Prime\" }\r\n102.2 \"Eden's Fire III\" Ability { id: \"44EB\", source: \"Eden Prime\" }\r\n108.3 \"--sync--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n114.8 \"Dimensional Shift\" Ability { id: \"3D9C\", source: \"Eden Prime\" }\r\n123.3 \"Pure Beam x6\" Ability { id: \"3D9D\", source: \"Eden Prime\" } duration 17.3\r\n128.7 \"Paradise Lost x3\" Ability { id: \"3D9F\", source: \"Eden Prime\" } duration 11.2\r\n131.2 \"--corner--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n144.5 \"Pure Light\" Ability { id: \"3DA3\", source: \"Eden Prime\" }\r\n147.3 \"--center--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n153.9 \"Dimensional Shift\" Ability { id: \"3D9C\", source: \"Eden Prime\" }\r\n\r\n\r\n### Phase 2: cleavy adds\r\n166.5 \"--untargetable--\"\r\n166.5 \"Fragor Maximus\" Ability { id: \"3DA4\", source: \"Eden Prime\" } window 200,5\r\n182.7 \"--targetable--\"\r\n182.7 \"Paradisal Dive\" Ability { id: \"3DA9\", source: \"Guardian of Paradise\" }\r\n193.8 \"Mana Slice\" Ability { id: \"3DA6\", source: \"Guardian of Paradise\" }\r\n203.0 \"Mana Burst\" Ability { id: \"3DA7\", source: \"Guardian of Paradise\" }\r\n209.1 \"Mana Slice\" Ability { id: \"3DA6\", source: \"Guardian of Paradise\" }\r\n218.3 \"Mana Burst\" Ability { id: \"3DA7\", source: \"Guardian of Paradise\" }\r\n223.5 \"Mana Slice\" Ability { id: \"3DA6\", source: \"Guardian of Paradise\" }\r\n228.7 \"Mana Slice\" Ability { id: \"3DA6\", source: \"Guardian of Paradise\" }\r\n242.7 \"Unto Dust Enrage\" Ability { id: \"3DA8\", source: \"Guardian of Paradise\" }\r\n\r\n\r\n### Phase 3: more of the same\r\n300.0 \"Primeval Stasis\" Ability { id: \"3E3A\", source: \"Eden\" } window 300,0\r\n343.6 \"Eternal Breath\" Ability { id: \"3DA5\", source: \"Eden Prime\" }\r\n\r\n354.0 \"--targetable--\"\r\n360.0 \"Vice And Virtue\" Ability { id: \"44E4\", source: \"Eden Prime\" }\r\n360.8 \"Vice Of Vanity\" Ability { id: \"44E7\", source: \"Eden Prime\" }\r\n370.6 \"Spear Of Paradise\" Ability { id: \"3DA1\", source: \"Eden Prime\" }\r\n372.1 \"Heavensunder\" Ability { id: \"3DA2\", source: \"Eden Prime\" }\r\n377.0 \"--corner--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n390.3 \"Pure Light\" Ability { id: \"3DA3\", source: \"Eden Prime\" }\r\n396.2 \"--center--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n405.5 \"Delta Attack\" Ability { id: \"44EA\", source: \"Eden Prime\" }\r\n406.1 \"Eden's Thunder III\" Ability { id: \"44ED\", source: \"Eden Prime\" }\r\n406.1 \"Eden's Blizzard III\" Ability { id: \"44EC\", source: \"Eden Prime\" }\r\n406.1 \"Eden's Fire III\" Ability { id: \"44EB\", source: \"Eden Prime\" }\r\n412.1 \"--sync--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n418.7 \"Dimensional Shift\" Ability { id: \"3D9C\", source: \"Eden Prime\" }\r\n427.1 \"Pure Beam x6\" Ability { id: \"3D9D\", source: \"Eden Prime\" } duration 17.3\r\n432.6 \"Paradise Lost x3\" Ability { id: \"3D9F\", source: \"Eden Prime\" } duration 11.2\r\n435.1 \"--corner--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n448.4 \"Pure Light\" Ability { id: \"3DA3\", source: \"Eden Prime\" }\r\n451.2 \"--center--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n457.8 \"Dimensional Shift\" Ability { id: \"3D9C\", source: \"Eden Prime\" }\r\n470.3 \"Vice And Virtue\" Ability { id: \"44E5\", source: \"Eden Prime\" }\r\n470.4 \"Vice Of Apathy\" Ability { id: \"44E8\", source: \"Eden Prime\" }\r\n476.9 \"Eden's Flare\" Ability { id: \"3D97\", source: \"Eden Prime\" }\r\n488.4 \"Eden's Gravity\" Ability { id: \"3D94\", source: \"Eden Prime\" }\r\n\r\n502.0 \"Vice And Virtue\" Ability { id: \"44E4\", source: \"Eden Prime\" } window 100,100 jump 360\r\n502.7 \"Vice Of Vanity\"\r\n512.5 \"Spear Of Paradise\"\r\n514.0 \"Heavensunder\"\r\n519.0 \"--corner--\"\r\n532.3 \"Pure Light\"\r\n538.2 \"--center--\"\r\n547.4 \"Delta Attack\"\r\n547.9 \"Eden's Thunder III\"\r\n547.9 \"Eden's Blizzard III\"\r\n547.9 \"Eden's Fire III\"\r\n554.1 \"--sync--\"\r\n560.7 \"Dimensional Shift\"\r\n569.2 \"Pure Beam\"\r\n574.6 \"Paradise Lost\"\r\n577.1 \"--corner--\"\r\n590.4 \"Pure Light\"\r\n593.2 \"--center--\"\r\n599.7 \"Dimensional Shift\"\r\n612.3 \"Vice And Virtue\"\r\n612.3 \"Vice Of Apathy\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e1s.ts



const e1s_triggerSet = {
  id: 'EdensGateResurrectionSavage',
  zoneId: zone_id/* default.EdensGateResurrectionSavage */.Z.EdensGateResurrectionSavage,
  timelineFile: 'e1s.txt',
  timeline: [data => {
    const chance = 0.4;
    const time = '275';
    if (Math.random() >= chance) return;
    const goofsByLang = {
      en: ['brb', ':zzz:', 'LA HEE', 'Quick Powernap', 'brb making coffee', 'Eden\'s Snoozefest', 'rip enochian'],
      de: ['brb', ':zzz:', 'LA HEE', 'Kurzer Powernap', 'brb Kafee machen', 'Eden\'s Schlaffest', 'tschüss Henochisch'],
      fr: ['Brb', ':zzz:', 'LA HEE', 'Courte sieste', 'brb faire du café', 'Eden\'s Dormez bien', 'Rip énochien'],
      ja: ['ちょっと待ってください', '眠い :zzz:', 'LAHEE~', '居眠りでもしましょうか', 'コーヒー飲むにいこう', 'ほらエデンも眠った', 'エノキアンにRIP'],
      cn: ['马上回来', '困了睡会儿', 'LAHEE~', '冲杯咖啡', '圣诞快乐', '我柜子动了等下再玩', 'CG'],
      ko: ['잠수', ':zzz:', '라희', '저 물좀 떠올게요']
    };
    const goofs = goofsByLang[data.displayLang];
    if (!goofs) return;
    const goof = goofs[Math.floor(Math.random() * goofs.length)];
    if (goof !== undefined) return `${time} "${goof}"`;
  }],
  triggers: [{
    id: 'E1S Initial',
    type: 'StartsUsing',
    netRegex: {
      id: '3D70',
      source: 'Eden Prime',
      capture: false
    },
    run: data => {
      if (!data.viceCount) {
        data.viceCount = 1;
        data.vice = 'dps';
      }
    }
  }, {
    id: 'E1S Paradise Regained',
    type: 'GainsEffect',
    netRegex: {
      target: 'Eden Prime',
      effectId: '7B6',
      capture: false
    },
    run: data => data.paradise = true
  }, {
    id: 'E1S Paradise Regained But Lost',
    type: 'LosesEffect',
    netRegex: {
      target: 'Eden Prime',
      effectId: '7B6',
      capture: false
    },
    run: data => data.paradise = false
  }, {
    id: 'E1S Eden\'s Gravity',
    type: 'StartsUsing',
    netRegex: {
      id: '3D70',
      source: 'Eden Prime',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E1S Fragor Maximus',
    type: 'StartsUsing',
    netRegex: {
      id: '3D8B',
      source: 'Eden Prime',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E1S Dimensional Shift',
    type: 'StartsUsing',
    netRegex: {
      id: '3D7F',
      source: 'Eden Prime',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E1S Spear Of Paradise',
    type: 'StartsUsing',
    netRegex: {
      id: '3D88',
      source: 'Eden Prime'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'E1S Eden\'s Flare',
    type: 'StartsUsing',
    netRegex: {
      id: '3D73',
      source: 'Eden Prime',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'E1S Delta Attack 1',
    type: 'StartsUsing',
    netRegex: {
      id: '44F4',
      source: 'Eden Prime',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cross Spread',
        de: 'Verteilen',
        fr: 'Dispersez-vous en croix',
        ja: '散開',
        cn: '四角躲避',
        ko: '산개'
      }
    }
  }, {
    id: 'E1S Delta Attack 2',
    type: 'StartsUsing',
    netRegex: {
      id: '44F8',
      source: 'Eden Prime',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.role === 'tank') return output.getInSpread();
      return output.inStackBehind();
    },
    outputStrings: {
      getInSpread: {
        en: 'Get In, Spread',
        de: 'Rein gehen, verteilen',
        fr: 'À l\'intérieur, dispersez-vous',
        ja: '中で散開',
        cn: '中间散开',
        ko: '보스 가까이 탱 약산개'
      },
      inStackBehind: {
        en: 'In, Stack Behind',
        de: 'Rein, hinten stacken',
        fr: 'À l\'intérieur, packez derrière',
        ja: '背面集合',
        cn: '背面集合',
        ko: '보스 가까이, 뒤에서 쉐어'
      }
    }
  }, {
    // 44EF: dps1
    // 3D7A: dps2
    // 44EE: tank1
    // 3D78: tank2
    // 44F0: healer1
    // 3D7D: healer2
    id: 'E1S Vice and Virtue Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: ['44EF', '3D7A', '44EE', '3D78', '44F0', '3D7D'],
      source: 'Eden Prime',
      capture: false
    },
    run: data => {
      // Note: this happens *after* the marks, so is setting up vice for the next marks.
      data.viceCount = (data.viceCount ?? 0) + 1;
      const viceMap = {
        1: 'dps',
        2: 'tank',
        3: 'healer',
        4: 'tank',
        5: 'dps',
        6: 'healer',
        7: 'tank',
        8: 'dps',
        9: 'healer',
        // theoretically??
        10: 'tank',
        11: 'dps',
        12: 'healer'
      };
      data.vice = viceMap[data.viceCount];
    }
  }, {
    id: 'E1S Vice and Virtue DPS 2 Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: '3D7A',
      source: 'Eden Prime',
      capture: false
    },
    run: data => data.vice = 'dps'
  }, {
    id: 'E1S Vice and Virtue Tank 1',
    type: 'StartsUsing',
    netRegex: {
      id: '44EE',
      source: 'Eden Prime',
      capture: false
    },
    run: data => data.vice = 'healer'
  }, {
    id: 'E1S Vice and Virtue Tank 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3D78',
      source: 'Eden Prime',
      capture: false
    },
    run: data => data.vice = 'dps'
  }, {
    id: 'E1S Vice and Virtue Healer 1',
    type: 'StartsUsing',
    netRegex: {
      id: '44F0',
      source: 'Eden Prime',
      capture: false
    },
    run: data => data.vice = 'tank'
  }, {
    id: 'E1S Vice and Virtue Healer 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3D7D',
      source: 'Eden Prime',
      capture: false
    },
    run: data => data.vice = 'tank'
  }, {
    id: 'E1S Vice and Virtue DPS 1',
    type: 'HeadMarker',
    netRegex: {
      id: '00AE'
    },
    condition: (data, matches) => !data.paradise && data.vice === 'dps' && data.me === matches.target,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Puddle Spread',
        de: 'Flächen verteilen',
        fr: 'Dispersez les zones au sol',
        ja: '離れて散開',
        cn: '分散放圈',
        ko: '장판 유도 산개'
      }
    }
  }, {
    id: 'E1S Vice and Virtue DPS 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3D7A',
      source: 'Eden Prime',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack With Partner',
        de: 'Mit Partner stacken',
        fr: 'Packez-vous avec votre partenaire',
        ja: '相方とスタック',
        cn: '与搭档集合',
        ko: '쉐어뎀 파트너랑 모이기'
      }
    }
  }, {
    id: 'E1S Vice and Virtue Tank Mark',
    type: 'HeadMarker',
    netRegex: {
      id: '00AE'
    },
    condition: (data, matches) => data.vice === 'tank' && data.me === matches.target,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank Laser on YOU',
        de: 'Tank Laser auf DIR',
        fr: 'Tank laser sur VOUS',
        ja: '自分にレーザー',
        cn: '坦克射线',
        ko: '탱 레이저 대상자'
      }
    }
  }, {
    id: 'E1S Vice and Virtue Tank Stack',
    type: 'StartsUsing',
    netRegex: {
      id: '3D78',
      source: 'Eden Prime',
      capture: false
    },
    condition: data => data.role !== 'tank',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack in front of tank',
        de: 'Vorne mit dem Tank stacken',
        fr: 'Packez-vous devant le tank',
        ja: '左右に分かれて内側へ',
        cn: 'T前集合',
        ko: '좌우 탱커 앞 산개'
      }
    }
  }, {
    id: 'E1S Vice and Virtue Healer Mark YOU',
    type: 'GainsEffect',
    netRegex: {
      effectId: '840'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (data, _matches, output) => {
      if (data.paradise) return output.passPreyToDps();
      return output.passPreyToTank();
    },
    outputStrings: {
      passPreyToDps: {
        en: 'Pass Prey to DPS',
        de: 'Marker einem DPS geben',
        fr: 'Passez la marque à un DPS',
        ja: 'DPSに移して',
        cn: '传毒DPS',
        ko: '딜러한테 표식 넘기기'
      },
      passPreyToTank: {
        en: 'Pass Prey to Tank',
        de: 'Marker einem Tank geben',
        fr: 'Passez la marque à un Tank',
        ja: 'タンクに移して',
        cn: '传毒坦克',
        ko: '탱커한테 표식 넘기기'
      }
    }
  }, {
    id: 'E1S Vice and Virtue Healer Mark Not You',
    type: 'GainsEffect',
    netRegex: {
      effectId: '840',
      capture: false
    },
    condition: data => {
      if (data.role === 'dps') return data.paradise;
      if (data.role === 'tank') return !data.paradise;
      return false;
    },
    suppressSeconds: 20,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Take prey from healer',
        de: 'Marker vom Heiler nehmen',
        fr: 'Prenez la marque du healer',
        ja: 'ヒーラーからマーカー取って',
        cn: '从奶妈拿毒',
        ko: '힐러한테서 표식 받기'
      }
    }
  }, {
    id: 'E1S Mana Boost',
    type: 'StartsUsing',
    netRegex: {
      id: '3D8D',
      source: 'Guardian Of Paradise'
    },
    condition: data => data.CanSilence(),
    suppressSeconds: 1,
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'E1S Pure Light',
    type: 'StartsUsing',
    netRegex: {
      id: '3D8A',
      source: 'Eden Prime',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'E1S Pure Beam 1',
    type: 'StartsUsing',
    netRegex: {
      id: '3D80',
      source: 'Eden Prime',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Outside Your Orb',
        de: 'Geh zu deinem Orb',
        fr: 'À l\'extérieur de votre orbe',
        ja: 'ピュアレイを外へ誘導',
        cn: '球外站位',
        ko: '본인 레이저 바깥으로 유도'
      }
    }
  }, {
    id: 'E1S Pure Beam 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3D82',
      source: 'Eden Prime',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Orb Lasers Outside',
        de: 'Laser nach drausen ködern',
        fr: 'Orientez les lasers vers l\'extérieur',
        ja: 'レーザーを外に誘導',
        cn: '外侧吃激光',
        ko: '원/힐 레이저 바깥으로 유도'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Eden Prime': 'Prim-Eden',
      'Guardian of Paradise': 'Hüter von Eden'
    },
    'replaceText': {
      'Delta Attack': 'Delta-Attacke',
      'Dimensional Shift': 'Dimensionsverschiebung',
      'Eden\'s Flare': 'Eden-Flare',
      'Eden\'s Gravity': 'Eden-Gravitas',
      'Eternal Breath': 'Ewiger Atem',
      'Fragor Maximus': 'Fragor Maximus',
      'Heavensunder': 'Himmelsdonner',
      'Mana Burst': 'Mana-Knall',
      'Mana Slice': 'Mana-Hieb',
      'Paradisal Dive': 'Paradiessturz',
      'Paradise Lost': 'Verlorenes Paradies',
      'Paradise Regained': 'Wiedergewonnenes Paradies',
      'Pure Beam': 'Läuternder Strahl',
      'Pure Light': 'Läuterndes Licht',
      'Spear Of Paradise': 'Paradiesspeer',
      'Vice And Virtue': 'Laster und Tugend'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Eden Prime': 'Primo-Éden',
      'Guardian of Paradise': 'Gardien du jardin'
    },
    'replaceText': {
      '\\!': ' !',
      'Delta Attack': 'Attaque Delta',
      'Dimensional Shift': 'Translation dimensionnelle',
      'Eden\'s Flare': 'Brasier édénique',
      'Eden\'s Gravity': 'Gravité édénique',
      'Eternal Breath': 'Souffle de l\'éternel',
      'Fragor Maximus': 'Fragor Maximus',
      'Heavensunder': 'Ravageur de paradis',
      'Mana Burst': 'Explosion de mana',
      'Mana Slice': 'Taillade de mana',
      'Paradisal Dive': 'Piqué du paradis',
      'Paradise Lost': 'Paradis perdu',
      'Paradise Regained': 'Paradis retrouvé',
      'Pure Beam': 'Rayon purificateur',
      'Pure Light': 'Lumière purificatrice',
      'Spear of Paradise': 'Lance du paradis',
      'Vice And Virtue': 'Vice et vertu'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Eden Prime': 'エデン・プライム',
      'Guardian of Paradise': 'エデン・ガーデナー'
    },
    'replaceText': {
      'Delta Attack': 'デルタアタック',
      'Dimensional Shift': 'ディメンションシフト',
      'Eden\'s Flare': 'エデン・フレア',
      'Eden\'s Gravity': 'エデン・グラビデ',
      'Eternal Breath': 'エターナル・ブレス',
      'Fragor Maximus': 'フラゴルマクシマス',
      'Heavensunder': 'ヘヴンサンダー',
      'Mana Burst': 'マナバースト',
      'Mana Slice': 'マナスラッシュ',
      'Paradisal Dive': 'パラダイスダイブ',
      'Paradise Lost': 'パラダイスロスト',
      'Paradise Regained': 'パラダイスリゲイン',
      'Pure Beam': 'ピュアレイ',
      'Pure Light': 'ピュアライト',
      'Spear of Paradise': 'スピア・オブ・パラダイス',
      'Vice and Virtue': 'ヴァイス・アンド・ヴァーチュー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Eden Prime': '至尊伊甸',
      'Guardian of Paradise': '伊甸守护者'
    },
    'replaceText': {
      'Delta Attack': '三角攻击',
      'Dimensional Shift': '空间转换',
      'Eden\'s Flare': '伊甸核爆',
      'Eden\'s Gravity': '伊甸重力',
      'Eternal Breath': '永恒吐息',
      'Fragor Maximus': '极大爆炸',
      'Heavensunder': '天国分断',
      'Mana Burst': '魔力爆发',
      'Mana Slice': '魔力斩击',
      'Paradisal Dive': '乐园冲',
      'Paradise Lost': '失乐园',
      'Paradise Regained': '复乐园',
      'Pure Beam': '净土射线',
      'Pure Light': '净土之光',
      'Spear of Paradise': '乐园之枪',
      'Vice and Virtue': '恶习与美德'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Eden Prime': '에덴 프라임',
      'Guardian of Paradise': '에덴의 수호자'
    },
    'replaceText': {
      'Cross': '십자',
      'Delta Attack': '델타 공격',
      'Dimensional Shift': '차원 전환',
      'Donut': '중앙',
      'Eden\'s Flare': '에덴 플레어',
      'Eden\'s Gravity': '에덴 그라비데',
      'Eternal Breath': '영원의 숨결',
      'Fragor Maximus': '우주 탄생',
      'Heavensunder': '천국의 낙뢰',
      'Mana Burst': '마나 폭발',
      'Mana Slice': '마나 베기',
      'Paradisal Dive': '낙원 강하',
      'Paradise Lost': '실낙원',
      'Paradise Regained': '복낙원',
      'Pure Beam': '완전한 광선',
      'Pure Light': '완전한 빛',
      'Spear of Paradise': '낙원의 창',
      'Vice and Virtue': '선과 악'
    }
  }]
};
/* harmony default export */ const e1s = (e1s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e1s.txt
const raid_e1s_namespaceObject = "### Eden 1 (Savage)\r\n# Eden's Gate: Resurrection (Savage)\r\n# -ii 3D87 3D81 367 44F6 44F5 44F7 44F2 44F1 3D79 3D7C 44FB 44FA 44F9 3D7E 3D83 3D84 44F3 -p 3D70:12 3D8C:500\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n12.0 \"Eden's Gravity\" Ability { id: \"3D70\", source: \"Eden Prime\" } window 12,5\r\n25.6 \"Vice And Virtue (D)\" Ability { id: \"44EF\", source: \"Eden Prime\" }\r\n32.0 \"Eden's Flare\" Ability { id: \"3D73\", source: \"Eden Prime\" }\r\n50.5 \"Vice And Virtue (T)\" Ability { id: \"44EE\", source: \"Eden Prime\" }\r\n58.0 \"Spear Of Paradise\" Ability { id: \"3D88\", source: \"Eden Prime\" }\r\n59.5 \"Heavensunder\" Ability { id: \"3D89\", source: \"Eden Prime\" }\r\n69.4 \"Vice And Virtue (H)\" Ability { id: \"44F0\", source: \"Eden Prime\" }\r\n71.7 \"--corner--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n80.4 \"Pure Light\" Ability { id: \"3D8A\", source: \"Eden Prime\" }\r\n83.2 \"--center--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n93.3 \"Delta Attack (Cross)\" Ability { id: \"44F4\", source: \"Eden Prime\" }\r\n98.9 \"--sync--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n105.5 \"Dimensional Shift\" Ability { id: \"3D7F\", source: \"Eden Prime\" }\r\n112.0 \"Paradise Lost\" Ability { id: \"3D86\", source: \"Eden Prime\" } duration 9\r\n122.5 \"Pure Beam\" Ability { id: \"3D80\", source: \"Eden Prime\" }\r\n125.0 \"--corner--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n133.7 \"Pure Light\" Ability { id: \"3D8A\", source: \"Eden Prime\" }\r\n136.5 \"--center--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n143.1 \"Dimensional Shift\" Ability { id: \"3D7F\", source: \"Eden Prime\" }\r\n153.7 \"Fragor Maximus\" Ability { id: \"3D8B\", source: \"Eden Prime\" } window 200,0\r\n154.3 \"--untargetable--\"\r\n\r\n### Phase 2 - Adds\r\n169.9 \"--targetable--\"\r\n169.9 \"Paradisal Dive\" Ability { id: \"3D91\", source: \"Guardian of Paradise\" }\r\n185.2 \"Mana Slice\" Ability { id: \"3D8E\", source: \"Guardian of Paradise\" }\r\n194.3 \"Mana Burst\" Ability { id: \"3D8F\", source: \"Guardian of Paradise\" }\r\n199.4 \"Mana Slice\" Ability { id: \"3D8E\", source: \"Guardian of Paradise\" }\r\n208.6 \"Mana Burst\" Ability { id: \"3D8F\", source: \"Guardian of Paradise\" }\r\n213.7 \"Mana Slice\" Ability { id: \"3D8E\", source: \"Guardian of Paradise\" }\r\n\r\n### Phase 3\r\n500.0 \"Eternal Breath\" Ability { id: \"3D8C\", source: \"Eden Prime\" } window 500,0\r\n510.0 \"--targetable--\"\r\n518.4 \"Paradise Regained\" Ability { id: \"44FC\", source: \"Eden Prime\" }\r\n528.8 \"Vice And Virtue! (T)\" Ability { id: \"3D78\", source: \"Eden Prime\" }\r\n542.5 \"Vice And Virtue! (D)\" Ability { id: \"3D7A\", source: \"Eden Prime\" }\r\n544.9 \"--sync--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n555.0 \"Delta Attack (Donut)\" Ability { id: \"44F8\", source: \"Eden Prime\" }\r\n568.8 \"Vice And Virtue! (H)\" Ability { id: \"3D7D\", source: \"Eden Prime\" }\r\n576.1 \"Spear Of Paradise\" Ability { id: \"3D88\", source: \"Eden Prime\" }\r\n577.7 \"Heavensunder\" Ability { id: \"3D89\", source: \"Eden Prime\" }\r\n582.5 \"--sync--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n589.1 \"Dimensional Shift\" Ability { id: \"3D7F\", source: \"Eden Prime\" }\r\n599.5 \"Pure Beam!\" Ability { id: \"3D82\", source: \"Eden Prime\" }\r\n611.2 \"--corner--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n619.9 \"Pure Light\" Ability { id: \"3D8A\", source: \"Eden Prime\" } duration 11.7\r\n622.8 \"--center--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n629.3 \"Dimensional Shift\" Ability { id: \"3D7F\", source: \"Eden Prime\" }\r\n642.1 \"Eden's Gravity\" Ability { id: \"3D70\", source: \"Eden Prime\" }\r\n653.6 \"Eden's Flare\" Ability { id: \"3D73\", source: \"Eden Prime\" }\r\n669.2 \"Vice And Virtue (T)\" Ability { id: \"44EE\", source: \"Eden Prime\" }\r\n676.8 \"Spear Of Paradise\" Ability { id: \"3D88\", source: \"Eden Prime\" }\r\n678.3 \"Heavensunder\" Ability { id: \"3D89\", source: \"Eden Prime\" }\r\n688.0 \"Vice And Virtue (D)\" Ability { id: \"44EF\", source: \"Eden Prime\" }\r\n690.5 \"--sync--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n700.6 \"Delta Attack (Cross)\" Ability { id: \"44F4\", source: \"Eden Prime\" }\r\n714.1 \"Vice And Virtue (H)\" Ability { id: \"44F0\", source: \"Eden Prime\" }\r\n719.8 \"--sync--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n726.4 \"Dimensional Shift\" Ability { id: \"3D7F\", source: \"Eden Prime\" }\r\n736.9 \"Pure Beam!\" Ability { id: \"3D82\", source: \"Eden Prime\" } duration 11.7\r\n748.3 \"--corner--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n757.1 \"Pure Light\" Ability { id: \"3D8A\", source: \"Eden Prime\" }\r\n760.0 \"--center--\" Ability { id: \"4683\", source: \"Eden Prime\" }\r\n766.5 \"Dimensional Shift\" Ability { id: \"3D7F\", source: \"Eden Prime\" }\r\n779.2 \"Eden's Gravity\" Ability { id: \"3D70\", source: \"Eden Prime\" }\r\n790.7 \"Eden's Flare\" Ability { id: \"3D73\", source: \"Eden Prime\" }\r\n\r\n801.2 \"Paradise Regained\" Ability { id: \"44FC\", source: \"Eden Prime\" } window 200,200 jump 518.4\r\n811.6 \"Vice And Virtue! (T)\"\r\n825.3 \"Vice And Virtue! (D)\"\r\n827.7 \"--sync--\"\r\n837.8 \"Delta Attack (Donut)\"\r\n851.6 \"Vice And Virtue! (H)\"\r\n858.9 \"Spear Of Paradise\"\r\n860.5 \"Heavensunder\"\r\n\r\n\r\n### Enrage\r\n900.0 \"Fragor Maximus (Enrage)\" StartsUsing { id: \"45E4\", source: \"Eden Prime\" } duration 10 window 500,0\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e2n.ts




const e2n_triggerSet = {
  id: 'EdensGateDescent',
  zoneId: zone_id/* default.EdensGateDescent */.Z.EdensGateDescent,
  timelineFile: 'e2n.txt',
  timelineTriggers: [{
    id: 'E2N Punishing Ray',
    regex: /Punishing Ray/,
    beforeSeconds: 9,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Puddles',
        de: 'Flächen nehmen',
        fr: 'Allez dans les zones au sol',
        ja: '踏む',
        cn: '踩圈',
        ko: '장판 밟기'
      }
    }
  }],
  triggers: [{
    id: 'E2N Shadowflame Tank',
    type: 'StartsUsing',
    netRegex: {
      id: '3E4D',
      source: 'Voidwalker'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E2N Shadowflame Healer',
    type: 'StartsUsing',
    netRegex: {
      id: '3E4D',
      source: 'Voidwalker',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.tankBusters */.Z.tankBusters
    }
  }, {
    id: 'E2N Entropy',
    type: 'StartsUsing',
    netRegex: {
      id: '3E6D',
      source: 'Voidwalker',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E2N Doomvoid Slicer',
    type: 'StartsUsing',
    netRegex: {
      id: '3E3C',
      source: 'Voidwalker',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'E2N Empty Hate',
    type: 'StartsUsing',
    netRegex: {
      id: '3E46',
      source: 'The Hand Of Erebos',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback('info')
  }, {
    id: 'E2N Darkfire Counter',
    type: 'StartsUsing',
    netRegex: {
      id: '3E42',
      source: 'Voidwalker',
      capture: false
    },
    run: data => data.fireCount = (data.fireCount ?? 0) + 1
  }, {
    id: 'E2N Dark Fire No Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '004C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'E2N Unholy Darkness No Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'E2N Shadoweye No Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '00B3'
    },
    response: responses/* Responses.lookAwayFromTarget */.n3.lookAwayFromTarget()
  }, {
    id: 'E2N Dark Fire Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '00B5'
    },
    run: (data, matches) => {
      data.spell ??= {};
      data.spell[matches.target] = 'fire';
    }
  }, {
    id: 'E2N Dark Fire Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '00B5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Delayed Fire',
        de: 'Verzögertes Feuer',
        fr: 'Feu retardé',
        ja: '遅延ファイア',
        cn: '延迟火',
        ko: '지연술 파이가'
      }
    }
  }, {
    id: 'E2N Countdown Marker Fire',
    type: 'HeadMarker',
    netRegex: {
      id: '00B8'
    },
    condition: (data, matches) => data.me === matches.target && data.spell?.[data.me] === 'fire',
    alertText: (data, _matches, output) => {
      if (data.fireCount === 3) return output.spreadDontStack();
      return output.spread();
    },
    outputStrings: {
      spreadDontStack: {
        en: 'Spread (don\'t stack!)',
        de: 'Verteilen (nicht zusammen stehen)',
        fr: 'Dispersez-vous (ne vous packez pas)',
        ja: '散開 (重ならない)',
        cn: '分散',
        ko: '산개 (쉐어 맞으면 안됨)'
      },
      spread: outputs/* default.spread */.Z.spread
    }
  }, {
    id: 'E2N Unholy Darkness Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '00B4'
    },
    run: (data, matches) => {
      data.spell ??= {};
      data.spell[matches.target] = 'stack';
    }
  }, {
    id: 'E2N Unholy Darkness Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '00B4'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Delayed Stack',
        de: 'Verzögertes sammeln',
        fr: 'Package retardé',
        ja: '遅延頭割り',
        cn: '延迟集合',
        ko: '지연술 쉐어징'
      }
    }
  }, {
    id: 'E2N Countdown Marker Unholy Darkness',
    type: 'HeadMarker',
    netRegex: {
      id: '00B8'
    },
    condition: (data, matches) => {
      // The third fire coincides with stack.
      // These people should avoid.
      if (data.spell?.[data.me] === 'fire' && data.fireCount === 3) return false;
      return data.spell?.[matches.target] === 'stack';
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'E2N Shadoweye Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '00B7'
    },
    run: (data, matches) => {
      data.spell ??= {};
      data.spell[matches.target] = 'eye';
    }
  }, {
    id: 'E2N Shadoweye Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '00B7'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Delayed Shadoweye',
        de: 'Verzögertes Schattenauge',
        fr: 'Œil de l\'ombre retardé',
        ja: '遅延シャドウアイ',
        cn: '延迟石化眼',
        ko: '지연술 그림자시선'
      }
    }
  }, {
    id: 'E2N Countdown Marker Shadoweye',
    type: 'HeadMarker',
    netRegex: {
      id: '00B8'
    },
    condition: (data, matches) => data.spell?.[matches.target] === 'eye',
    delaySeconds: 2,
    response: responses/* Responses.lookAwayFromTarget */.n3.lookAwayFromTarget('alarm')
  }, {
    id: 'E2N Countdown Marker Shadoweye You',
    type: 'HeadMarker',
    netRegex: {
      id: '00B8'
    },
    condition: (data, matches) => {
      return data.me === matches.target && data.spell?.[matches.target] === 'eye';
    },
    delaySeconds: 2,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Eye on YOU',
        de: 'Auge auf DIR',
        fr: 'Œil de l\'ombre sur VOUS',
        ja: '自分にシャドウアイ',
        cn: '石化眼点名',
        ko: '시선징 대상자'
      }
    }
  }, {
    id: 'E2N Countdown Marker Cleanup',
    type: 'HeadMarker',
    netRegex: {
      id: '00B8'
    },
    delaySeconds: 10,
    run: (data, matches) => delete data.spell?.[matches.target]
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'The Hand of Erebos': 'Arm des Erebos',
      'Voidwalker': 'Nichtswandler'
    },
    'replaceText': {
      'Dark Fire III': 'Dunkel-Feuga',
      'Doomvoid Guillotine': 'Nichtsmarter-Fallbeil',
      'Doomvoid Slicer': 'Nichtsmarter-Sense',
      'Empty Hate': 'Gähnender Abgrund',
      'Entropy': 'Entropie',
      'Punishing Ray': 'Strafender Strahl',
      'Shadoweye': 'Schattenauge',
      'Shadowflame': 'Schattenflamme',
      'Spell-In-Waiting': 'Verzögerung',
      'Unholy Darkness': 'Unheiliges Dunkel'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'The Hand of Erebos': 'Bras d\'Érèbe',
      'Voidwalker': 'Marcheuse du néant'
    },
    'replaceText': {
      'Dark Fire III': 'Méga Feu ténébreux',
      'Doomvoid Guillotine': 'Guillotine du néant ravageur',
      'Doomvoid Slicer': 'Entaille du néant ravageur',
      'Empty Hate': 'Vaine malice',
      'Entropy': 'Entropie',
      'Punishing Ray': 'Rayon punitif',
      'Shadoweye': 'Œil de l\'ombre',
      'Shadowflame': 'Flamme d\'ombre',
      'Spell-in-Waiting': 'Déphasage incantatoire',
      'Unholy Darkness': 'Miracle sombre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'The Hand of Erebos': 'エレボスの巨腕',
      'Voidwalker': 'ヴォイドウォーカー'
    },
    'replaceText': {
      'Dark Fire III': 'ダークファイガ',
      'Doomvoid Guillotine': 'ドゥームヴォイド・ギロチン',
      'Doomvoid Slicer': 'ドゥームヴォイド・スライサー',
      'Empty Hate': '虚ろなる悪意',
      'Entropy': 'エントロピー',
      'Punishing Ray': 'パニッシュレイ',
      'Shadoweye': 'シャドウアイ',
      'Shadowflame': 'シャドーフレイム',
      'Spell-in-Waiting': 'ディレイスペル',
      'Unholy Darkness': 'ダークホーリー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'The Hand of Erebos': '厄瑞玻斯的巨腕',
      'Voidwalker': '虚无行者'
    },
    'replaceText': {
      'Dark Fire III': '黑暗爆炎',
      'Doomvoid Guillotine': '末日虚无断',
      'Doomvoid Slicer': '末日虚无切',
      'Empty Hate': '空无的恶意',
      'Entropy': '熵',
      'Punishing Ray': '惩戒之光',
      'Shadoweye': '暗影之眼',
      'Shadowflame': '暗影炎',
      'Spell-in-Waiting': '延迟咏唱',
      'Unholy Darkness': '黑暗神圣'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'The Hand of Erebos': '에레보스의 팔',
      'Voidwalker': '보이드워커'
    },
    'replaceText': {
      'Dark Fire III': '다크 파이가',
      'Doomvoid Guillotine': '파멸의 보이드 절단',
      'Doomvoid Slicer': '파멸의 보이드 베기',
      'Empty Hate': '공허한 악의',
      'Entropy': '엔트로피',
      'Punishing Ray': '응징의 빛줄기',
      'Shadoweye': '그림자 시선',
      'Shadowflame': '그림자 불꽃',
      'Spell-in-Waiting': '지연술',
      'Unholy Darkness': '다크 홀리'
    }
  }]
};
/* harmony default export */ const e2n = (e2n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e2n.txt
const raid_e2n_namespaceObject = "### Eden 2 (Normal)\r\n# Eden's Gate: Descent\r\n# -ii 3E4C 3E4E 3E44 3E41 3E3F 3E42 3E45 3E6D 40B8 40B6\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Spell-In-Waiting\"\r\n\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n10.7 \"Doomvoid Guillotine\" Ability { id: \"3E3B\", source: \"Voidwalker\" } window 11,5\r\n27.7 \"Doomvoid Slicer\" Ability { id: \"3E3C\", source: \"Voidwalker\" }\r\n46.7 \"Shadowflame\" Ability { id: \"3E4D\", source: \"Voidwalker\" }\r\n59.4 \"Dark Fire III\" Ability { id: \"3E43\", source: \"Voidwalker\" } window 60,5\r\n67.4 \"Unholy Darkness\" Ability { id: \"3E40\", source: \"Voidwalker\" }\r\n72.7 \"Spell-In-Waiting\" Ability { id: \"3E3E\", source: \"Voidwalker\" }\r\n91.2 \"Dark Fire III\" Ability { id: \"3E43\", source: \"Voidwalker\" }\r\n92.9 \"Spell-In-Waiting\" Ability { id: \"3E3E\", source: \"Voidwalker\" }\r\n111.4 \"Unholy Darkness\" Ability { id: \"3E40\", source: \"Voidwalker\" }\r\n113.3 \"Spell-In-Waiting\" Ability { id: \"3E3E\", source: \"Voidwalker\" }\r\n127.3 \"Spell-In-Waiting\" Ability { id: \"3E3E\", source: \"Voidwalker\" }\r\n146.4 \"Dark Fire III\" Ability { id: \"3E43\", source: \"Voidwalker\" }\r\n146.4 \"Unholy Darkness\" Ability { id: \"3E40\", source: \"Voidwalker\" }\r\n\r\n156.8 \"Entropy\" Ability { id: \"3E6E\", source: \"Voidwalker\" } window 200,5\r\n167.3 \"Empty Hate\" Ability { id: \"3E46\", source: \"The Hand of Erebos\" }\r\n174.3 \"Doomvoid Guillotine\" Ability { id: \"3E3B\", source: \"Voidwalker\" }\r\n184.3 \"Empty Hate\" Ability { id: \"3E46\", source: \"The Hand of Erebos\" }\r\n191.3 \"Doomvoid Slicer\" Ability { id: \"3E3C\", source: \"Voidwalker\" }\r\n206.3 \"Shadowflame\" Ability { id: \"3E4D\", source: \"Voidwalker\" }\r\n\r\n216.8 \"Entropy\" Ability { id: \"3E6E\", source: \"Voidwalker\" } window 50,5\r\n223.3 \"Spell-In-Waiting\" Ability { id: \"3E3E\", source: \"Voidwalker\" }\r\n230.3 \"Punishing Ray\" Ability { id: \"3E47\", source: \"Voidwalker\" }\r\n241.3 \"Spell-In-Waiting\" Ability { id: \"3E3E\", source: \"Voidwalker\" }\r\n252.4 \"Unholy Darkness\" Ability { id: \"3E40\", source: \"Voidwalker\" }\r\n259.4 \"Dark Fire III\" Ability { id: \"3E43\", source: \"Voidwalker\" }\r\n270.3 \"Empty Hate\" Ability { id: \"3E46\", source: \"The Hand of Erebos\" }\r\n277.3 \"Punishing Ray\" Ability { id: \"3E47\", source: \"Voidwalker\" }\r\n\r\n286.8 \"Entropy\" Ability { id: \"3E6E\", source: \"Voidwalker\" }\r\n296.0 \"Shadoweye\" Ability { id: \"40B7\", source: \"Voidwalker\" }\r\n301.3 \"Spell-In-Waiting\" Ability { id: \"3E3E\", source: \"Voidwalker\" }\r\n316.3 \"Doomvoid Guillotine\" Ability { id: \"3E3B\", source: \"Voidwalker\" }\r\n331.3 \"Doomvoid Slicer\" Ability { id: \"3E3C\", source: \"Voidwalker\" }\r\n331.4 \"Shadoweye\" Ability { id: \"40B7\", source: \"Voidwalker\" }\r\n\r\n351.8 \"Entropy\" Ability { id: \"3E6E\", source: \"Voidwalker\" }\r\n360.3 \"Spell-In-Waiting\" Ability { id: \"3E3E\", source: \"Voidwalker\" }\r\n366.3 \"Empty Hate\" Ability { id: \"3E46\", source: \"The Hand of Erebos\" }\r\n374.3 \"Punishing Ray\" Ability { id: \"3E47\", source: \"Voidwalker\" }\r\n383.3 \"Spell-In-Waiting\" Ability { id: \"3E3E\", source: \"Voidwalker\" }\r\n394.5 \"Unholy Darkness\" Ability { id: \"3E40\", source: \"Voidwalker\" }\r\n401.5 \"Dark Fire III\" Ability { id: \"3E43\", source: \"Voidwalker\" }\r\n408.4 \"Shadowflame\" Ability { id: \"3E4D\", source: \"Voidwalker\" }\r\n416.4 \"Doomvoid Guillotine\" Ability { id: \"3E3B\", source: \"Voidwalker\" }\r\n426.4 \"Empty Hate\" Ability { id: \"3E46\", source: \"The Hand of Erebos\" }\r\n431.4 \"Doomvoid Slicer\" Ability { id: \"3E3C\", source: \"Voidwalker\" }\r\n441.1 \"Shadoweye\" Ability { id: \"40B7\", source: \"Voidwalker\" }\r\n450.4 \"Shadowflame\" Ability { id: \"3E4D\", source: \"Voidwalker\" }\r\n\r\n461.8 \"Entropy\" Ability { id: \"3E6E\", source: \"Voidwalker\" } window 50,50 jump 351.8\r\n470.3 \"Spell-In-Waiting\"\r\n476.3 \"Empty Hate\"\r\n484.3 \"Punishing Ray\"\r\n493.3 \"Spell-In-Waiting\"\r\n504.5 \"Unholy Darkness\"\r\n511.5 \"Dark Fire III\"\r\n518.4 \"Shadowflame\"\r\n526.4 \"Doomvoid Guillotine\"\r\n536.4 \"Empty Hate\"\r\n541.4 \"Doomvoid Slicer\"\r\n551.1 \"Shadoweye\"\r\n560.4 \"Shadowflame\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e2s.ts




// TODO
// better callouts for cycle
// tank provoke messages when cotank has flare
const e2s_triggerSet = {
  id: 'EdensGateDescentSavage',
  zoneId: zone_id/* default.EdensGateDescentSavage */.Z.EdensGateDescentSavage,
  timelineFile: 'e2s.txt',
  timelineTriggers: [{
    id: 'E2S Punishing Ray',
    regex: /Punishing Ray/,
    beforeSeconds: 9,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Puddles',
        de: 'Flächen nehmen',
        fr: 'Allez dans les zones au sol',
        ja: '踏む',
        cn: '踩圈',
        ko: '바닥 징 밟기'
      }
    }
  }, {
    id: 'E2S Buddy Circles',
    regex: /Light\/Dark Circles/,
    beforeSeconds: 5,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack With Partner',
        de: 'Mit Partner stacken',
        fr: 'Packez-vous avec votre partenaire',
        ja: '白黒合わせて',
        cn: '黑白配',
        ko: '흑백 파트너랑 모이기'
      }
    }
  }],
  triggers: [{
    id: 'E2S Spell In Waiting Gain',
    type: 'GainsEffect',
    netRegex: {
      target: 'Voidwalker',
      effectId: '710',
      capture: false
    },
    run: data => data.waiting = true
  }, {
    id: 'E2S Spell In Waiting Lose',
    type: 'LosesEffect',
    netRegex: {
      target: 'Voidwalker',
      effectId: '710',
      capture: false
    },
    run: data => data.waiting = false
  }, {
    id: 'E2S Entropy',
    type: 'StartsUsing',
    netRegex: {
      id: '3E6F',
      source: 'Voidwalker',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E2S Quietus',
    type: 'StartsUsing',
    netRegex: {
      id: '3E71',
      source: 'Voidwalker',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E2S Shadowflame Tank',
    type: 'StartsUsing',
    netRegex: {
      id: '3E6[12]',
      source: 'Voidwalker'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E2S Shadowflame Healer',
    type: 'StartsUsing',
    netRegex: {
      id: '3E61',
      source: 'Voidwalker',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.tankBusters */.Z.tankBusters
    }
  }, {
    id: 'E2S Doomvoid Cleaver',
    type: 'StartsUsing',
    netRegex: {
      id: '3E63',
      source: 'Voidwalker',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Protean',
        de: 'Himmelsrichtungen',
        fr: 'Positions',
        ja: '散開',
        cn: '分散站位',
        ko: '정해진 위치로 산개'
      }
    }
  }, {
    id: 'E2S Doomvoid Guillotine',
    type: 'StartsUsing',
    netRegex: {
      id: '3E4F',
      source: 'Voidwalker',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'E2S Doomvoid Slicer',
    type: 'StartsUsing',
    netRegex: {
      id: '3E50',
      source: 'Voidwalker',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'E2S Empty Hate',
    type: 'StartsUsing',
    netRegex: {
      id: '3E59',
      source: 'The Hand Of Erebos',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback('info')
  }, {
    id: 'E2S Empty Rage',
    type: 'StartsUsing',
    netRegex: {
      id: '3E6B',
      source: 'The Hand Of Erebos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Hand',
        de: 'Weg von der Hand',
        fr: 'Éloignez-vous de la main',
        ja: '手から離れ',
        cn: '远离手',
        ko: '팔에서 멀어지기'
      }
    }
  }, {
    id: 'E2S Unholy Darkness No Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    condition: data => !data.waiting,
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'E2S Unholy Darkness Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    condition: data => data.waiting,
    run: (data, matches) => {
      data.spell ??= {};
      data.spell[matches.target] = 'stack';
    }
  }, {
    id: 'E2S Unholy Darkness Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    condition: (data, matches) => data.waiting && data.me === matches.target,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Delayed Stack',
        de: 'Verzögertes stacken',
        fr: 'Package retardé',
        ja: 'スタック(ディレイ)',
        cn: '延迟集合',
        ko: '지연술 쉐어징'
      }
    }
  }, {
    id: 'E2S Countdown Marker Unholy Darkness',
    type: 'HeadMarker',
    netRegex: {
      id: '00B8'
    },
    condition: (data, matches) => !data.hellWind && data.spell?.[matches.target] === 'stack',
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'E2S Dark Fire No Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '004C'
    },
    condition: (data, matches) => !data.waiting && data.me === matches.target,
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'E2S Dark Fire Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '004C'
    },
    condition: data => data.waiting,
    run: (data, matches) => {
      data.spell ??= {};
      data.spell[matches.target] = 'fire';
    }
  }, {
    id: 'E2S Dark Fire Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '004C'
    },
    condition: (data, matches) => data.waiting && data.me === matches.target,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Delayed Fire',
        de: 'Verzögertes Feuer',
        fr: 'Feu retardé',
        ja: 'マーカーついた(ディレイ)',
        cn: '延迟火',
        ko: '지연술 파이가'
      }
    }
  }, {
    id: 'E2S Countdown Marker Fire',
    type: 'HeadMarker',
    netRegex: {
      id: '00B8'
    },
    condition: (data, matches) => data.me === matches.target && data.spell?.[data.me] === 'fire',
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'E2S Shadoweye No Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '00B3'
    },
    condition: data => !data.waiting,
    response: responses/* Responses.lookAwayFromTarget */.n3.lookAwayFromTarget()
  }, {
    id: 'E2S Shadoweye No Waiting You',
    type: 'HeadMarker',
    netRegex: {
      id: '00B3'
    },
    condition: (data, matches) => !data.waiting && data.me === matches.target,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Eye on YOU',
        de: 'Auge auf DIR',
        fr: 'Œil de l\'ombre sur VOUS',
        ja: '自分に目',
        cn: '石化眼点名',
        ko: '시선징 대상자'
      }
    }
  }, {
    id: 'E2S Shadoweye Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '00B3'
    },
    condition: data => data.waiting,
    run: (data, matches) => {
      data.spell ??= {};
      data.spell[matches.target] = 'eye';
    }
  }, {
    id: 'E2S Shadoweye Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '00B3'
    },
    condition: (data, matches) => data.waiting && data.me === matches.target,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Delayed Shadoweye',
        de: 'Verzögertes Schattenauge',
        fr: 'Œil de l\'ombre retardé',
        ja: 'シャドウアイ(ディレイ)',
        cn: '延迟石化眼',
        ko: '지연술 시선징'
      }
    }
  }, {
    id: 'E2S Countdown Marker Shadoweye Me',
    type: 'HeadMarker',
    netRegex: {
      id: '00B8'
    },
    condition: (data, matches) => data.spell?.[matches.target] === 'eye' && matches.target === data.me,
    delaySeconds: 2,
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Eye on YOU',
        de: 'Auge auf DIR',
        fr: 'Œil sur VOUS',
        ja: '自分に目',
        cn: '石化眼点名',
        ko: '시선징 대상자'
      }
    }
  }, {
    id: 'E2S Countdown Marker Shadoweye Other',
    type: 'HeadMarker',
    netRegex: {
      id: '00B8'
    },
    condition: (data, matches) => data.spell?.[matches.target] === 'eye' && data.spell?.[data.me] !== 'eye',
    delaySeconds: 2,
    suppressSeconds: 10,
    // Let's just assume these people are stacked.
    // We could call out both names, but it's probably unnecessary.
    response: responses/* Responses.lookAwayFromTarget */.n3.lookAwayFromTarget()
  }, {
    id: 'E2S Flare No Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: (data, matches) => !data.waiting && data.me === matches.target,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Flare',
        de: 'Flare',
        fr: 'Brasier',
        ja: 'フレア捨てて',
        cn: '核爆',
        ko: '플레어'
      }
    }
  }, {
    id: 'E2S Flare Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: data => data.waiting,
    run: (data, matches) => {
      data.spell ??= {};
      data.spell[matches.target] = 'flare';
    }
  }, {
    id: 'E2S Flare Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: (data, matches) => data.waiting && data.me === matches.target,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Delayed Flare',
        de: 'Verzögerte Flare',
        fr: 'Brasier retardé',
        ja: 'フレア(ディレイ)',
        cn: '延迟核爆',
        ko: '지연술 플레어'
      }
    }
  }, {
    id: 'E2S Countdown Marker Flare',
    type: 'HeadMarker',
    netRegex: {
      id: '00B8'
    },
    condition: (data, matches) => data.me === matches.target && data.spell?.[data.me] === 'flare',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Flare',
        de: 'Flare',
        fr: 'Brasier',
        ja: 'フレア捨てて',
        cn: '核爆',
        ko: '플레어'
      }
    }
  }, {
    id: 'E2S Countdown Marker Flare Healer',
    type: 'HeadMarker',
    netRegex: {
      id: '00B8'
    },
    condition: (data, matches) => {
      if (data.role !== 'healer') return;
      return data.spell?.[matches.target] === 'flare' && data.spell?.[data.me] !== 'flare';
    },
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Flare aoes',
        de: 'Flare aoes',
        fr: 'Brasiers AoE',
        ja: 'フレア AoE',
        cn: '核爆AOE',
        ko: '플레어 터짐'
      }
    }
  }, {
    id: 'E2S Hell Wind No Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    condition: (data, matches) => !data.waiting && data.me === matches.target,
    // The "no waiting" version comes paired with a stack.
    alarmText: (_data, _matches, output) => output.text(),
    run: data => data.hellWind = true,
    outputStrings: {
      text: {
        en: 'Hell Wind: Get Out',
        de: 'Höllenwind: Raus gehen',
        fr: 'Vent infernal : À l\'extérieur',
        ja: 'ヘルウィンド: HP1になるよ',
        cn: '地狱之风：远离',
        ko: '홍옥징 대상자'
      }
    }
  }, {
    id: 'E2S Hell Wind Cleanup',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    condition: (data, matches) => !data.waiting && data.me === matches.target,
    delaySeconds: 15,
    run: data => delete data.hellWind
  }, {
    id: 'E2S Hell Wind Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    condition: data => data.waiting,
    run: (data, matches) => {
      data.spell ??= {};
      data.spell[matches.target] = 'wind';
    }
  }, {
    id: 'E2S Hell Wind Waiting',
    type: 'HeadMarker',
    netRegex: {
      id: '001E'
    },
    condition: (data, matches) => data.waiting && data.me === matches.target,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Delayed Hell Wind',
        de: 'Verzögerte Höllenwind',
        fr: 'Vent infernal retardé',
        ja: 'ヘルウィンド(ディレイ)',
        cn: '延迟地狱之风',
        ko: '지연술 홍옥징'
      }
    }
  }, {
    id: 'E2S Countdown Marker Hell Wind',
    type: 'HeadMarker',
    netRegex: {
      id: '00B8'
    },
    condition: (data, matches) => {
      if (data.role === 'healer') return false;
      return data.me === matches.target && data.spell?.[data.me] === 'wind';
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hell Wind: wait for heals',
        de: 'Höllenwind: Warte auf Heilung',
        fr: 'Vent infernal : attendez pour soigner',
        ja: 'ヘルウィンド: HP戻ってから',
        cn: '地狱之风：等奶',
        ko: '힐 받고 들어가기'
      }
    }
  }, {
    id: 'E2S Countdown Marker Hell Wind Healer',
    type: 'HeadMarker',
    netRegex: {
      id: '00B8'
    },
    condition: (data, matches) => {
      if (data.role !== 'healer') return;
      return data.spell?.[matches.target] === 'wind';
    },
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Heal Hell Wind Targets',
        de: 'Heile Höllenwind Ziele',
        fr: 'Soignez les cibles de Vent infernal',
        ja: 'HP戻して',
        cn: '奶地狱之风目标',
        ko: '홍옥징 대상자 힐'
      }
    }
  }, {
    id: 'E2S Countdown Marker Cleanup',
    type: 'HeadMarker',
    netRegex: {
      id: '00B8'
    },
    delaySeconds: 10,
    run: (data, matches) => delete data.spell?.[matches.target]
  }, {
    // TODO: add callouts for each of these
    id: 'E2S Cycle of Retribution',
    type: 'StartsUsing',
    netRegex: {
      id: '4659',
      source: 'Voidwalker',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'In, Protean, Sides',
        de: 'Rein, Himmelsrichtungen, Seiten',
        fr: 'Intérieur, Positions, Côtés',
        ja: '中 => 散開 => 横',
        cn: '脚下 => 站位 => 两侧',
        ko: '중앙 => 산개 => 측면'
      }
    }
  }, {
    id: 'E2S Cycle of Chaos',
    type: 'StartsUsing',
    netRegex: {
      id: '40B9',
      source: 'Voidwalker',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sides, In, Protean',
        de: 'Seiten, Rein, Himmelsrichtungen',
        fr: 'Côtés, Intérieur, Positions',
        ja: '横 => 中 => 散開',
        cn: '两侧 => 脚下 => 站位',
        ko: '측면 => 중앙 => 산개'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'The Hand Of Erebos': 'Arm Des Erebos',
      'Voidwalker': 'Nichtswandler'
    },
    'replaceText': {
      'Cleaver/Slicer': 'Schlachter/Sense',
      'Cycle Of ?': '? Chaos',
      'Dark Fire III': 'Dunkel-Feuga',
      'Doomvoid Cleaver': 'Nichtsmarter-Schlachter',
      'Doomvoid Guillotine': 'Nichtsmarter-Fallbeil',
      'Doomvoid Slicer': 'Nichtsmarter-Sense',
      'Empty Hate(?!/)': 'Gähnender Abgrund',
      'Empty Hate/Rage': 'Lockende Leere/Gähnender Abgrund',
      'Empty Rage': 'Lockende Leere',
      'Entropy': 'Entropie',
      'Flare': 'Flare',
      'Guillotine/Cleaver': 'Fallbeil/Schlachter',
      'Hell Wind': 'Höllenwind',
      'Light/Dark Circles': 'Licht/Dunkelheit Kreis',
      'Punishing Ray': 'Strafender Strahl',
      'Quietus': 'Quietus',
      'Shadoweye': 'Schattenauge',
      'Shadowflame': 'Schattenflamme',
      'Slicer/Guillotine': 'Sense/Fallbeil',
      'Spell-In-Waiting': 'Verzögerung',
      'Unholy Darkness': 'Unheiliges Dunkel'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'The Hand Of Erebos': 'Bras D\'Érèbe',
      'Voidwalker': 'Marcheuse Du Néant'
    },
    'replaceText': {
      '\\?': ' ?',
      'Cleaver/Slicer': 'Couperet/Entaille',
      'Cycle Of ?': 'Multi-taillade',
      'Dark Fire III': 'Méga Feu ténébreux',
      'Doomvoid Cleaver': 'Couperet du néant ravageur',
      'Doomvoid Guillotine': 'Guillotine du néant ravageur',
      'Doomvoid Slicer': 'Entaille du néant ravageur',
      'Empty Hate(?!/)': 'Vaine malice',
      'Empty Hate/Rage': 'Vaine malice/cruauté',
      'Empty Rage': 'Vaine cruauté',
      'Entropy': 'Entropie',
      'Flare': 'Brasier',
      'Guillotine/Cleaver': 'Guillotine/Couperet',
      'Hell Wind': 'Vent infernal',
      'Light/Dark Circles': 'Cercle Lumière/Ténèbres',
      'Punishing Ray': 'Rayon punitif',
      'Quietus': 'Quietus',
      'Shadoweye': 'Œil de l\'ombre',
      'Shadowflame': 'Flamme d\'ombre',
      'Slicer/Guillotine': 'Entaille/Guillotine',
      'Spell-In-Waiting': 'Déphasage incantatoire',
      'Unholy Darkness': 'Miracle sombre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'The Hand Of Erebos': 'エレボスの巨腕',
      'Voidwalker': 'ヴォイドウォーカー'
    },
    'replaceText': {
      '\\?': ' ?',
      'Cleaver/Slicer': 'クリーバー/スライサー',
      'Cycle Of ?': '？の連続剣',
      'Dark Fire III': 'ダークファイガ',
      'Doomvoid Cleaver': 'ドゥームヴォイド・クリーバー',
      'Doomvoid Guillotine': 'ドゥームヴォイド・ギロチン',
      'Doomvoid Slicer': 'ドゥームヴォイド・スライサー',
      'Empty Hate(?!/)': '虚ろなる悪意',
      'Empty Hate/Rage': '虚ろなる害意/悪意',
      'Empty Rage': '虚ろなる害意',
      'Entropy': 'エントロピー',
      'Flare': 'フレア',
      'Guillotine/Cleaver': 'ギロチン/クリーバー',
      'Hell Wind': 'ヘルウィンド',
      'Light/Dark Circles': '白い/黒いマーカー',
      'Punishing Ray': 'パニッシュレイ',
      'Quietus': 'クワイタス',
      'Shadoweye': 'シャドウアイ',
      'Shadowflame': 'シャドーフレイム',
      'Slicer/Guillotine': 'スライサー/ギロチン',
      'Spell-In-Waiting': 'ディレイスペル',
      'Unholy Darkness': 'ダークホーリー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'The Hand Of Erebos': '厄瑞玻斯的巨腕',
      'Voidwalker': '虚无行者'
    },
    'replaceText': {
      'Cleaver/Slicer?': '虚无劈/虚无切?',
      'Cycle Of ?': '??连续剑',
      'Dark Fire III': '黑暗爆炎',
      'Doomvoid Cleaver': '末日虚无劈',
      'Doomvoid Guillotine': '末日虚无断',
      'Doomvoid Slicer': '末日虚无切',
      'Empty Hate(?!/)': '空无的恶意',
      'Empty Hate/Rage': '空无的恶意/恶念',
      'Empty Rage': '空无的恶念',
      'Entropy': '熵',
      'Flare': '核爆',
      'Guillotine/Cleaver?': '虚无断/虚无劈?',
      'Hell Wind': '地狱之风',
      'Light/Dark Circles': '黑白圈',
      'Punishing Ray': '惩戒之光',
      'Quietus': '寂灭',
      'Shadoweye': '暗影之眼',
      'Shadowflame': '暗影炎',
      'Slicer/Guillotine': '虚无切/虚无断',
      'Spell-In-Waiting': '延迟咏唱',
      'Unholy Darkness': '黑暗神圣'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'The Hand Of Erebos': '에레보스의 팔',
      'Voidwalker': '보이드워커'
    },
    'replaceText': {
      'Cleaver/Slicer': '살육/베기',
      'Cycle Of ?': '? 연속검',
      'Dark Fire III': '다크 파이가',
      'Doomvoid Cleaver': '파멸의 보이드 살육',
      'Doomvoid Guillotine': '파멸의 보이드 절단',
      'Doomvoid Slicer': '파멸의 보이드 베기',
      'Empty Hate(?!/)': '공허한 악의',
      'Empty Hate/Rage': '공허한 악의/적의',
      'Empty Rage': '공허한 적의',
      'Entropy': '엔트로피',
      'Flare': '플레어',
      'Guillotine/Cleaver': '절단/살육',
      'Hell Wind': '황천의 바람',
      'Light/Dark Circles': '빛/어둠 징',
      'Punishing Ray': '응징의 빛줄기',
      'Quietus': '종지부',
      'Shadoweye': '그림자 시선',
      'Shadowflame': '그림자 불꽃',
      'Slicer/Guillotine': '베기/절단',
      'Spell-In-Waiting': '지연술',
      'Unholy Darkness': '다크 홀리'
    }
  }]
};
/* harmony default export */ const e2s = (e2s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e2s.txt
const raid_e2s_namespaceObject = "### Eden 2 (Savage)\r\n# Eden's Gate: Descent (Savage)\r\n# -p 3E64:11.2 -ii 3E60 3E62 3E51 3E53 3E55 3E56 3E58 3E68 3E6A 3E6F 4684 4686 3E72 3E65 3E67 3E63\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Spell-In-Waiting\"\r\n\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n10.5 \"--sync--\" Ability { id: \"3E63\", source: \"Voidwalker\" } window 11,5\r\n11.2 \"Doomvoid Cleaver\" Ability { id: \"3E64\", source: \"Voidwalker\" }\r\n25.4 \"Unholy Darkness\" Ability { id: \"3E54\", source: \"Voidwalker\" }\r\n31.8 \"Slicer/Guillotine\" Ability { id: [\"3E4F\", \"3E50\"], source: \"Voidwalker\" }\r\n43.8 \"Dark Fire III\" Ability { id: \"3E57\", source: \"Voidwalker\" }\r\n59.2 \"Spell-In-Waiting\" Ability { id: \"3E52\", source: \"Voidwalker\" }\r\n69.3 \"Punishing Ray\" Ability { id: \"3E5B\", source: \"Voidwalker\" }\r\n72.7 \"Spell-In-Waiting\" Ability { id: \"3E52\", source: \"Voidwalker\" }\r\n86.1 \"Spell-In-Waiting\" Ability { id: \"3E52\", source: \"Voidwalker\" }\r\n95.3 \"Dark Fire III\" Ability { id: \"3E57\", source: \"Voidwalker\" }\r\n105.3 \"Hell Wind\" Ability { id: \"3E66\", source: \"Voidwalker\" }\r\n106.8 \"Shadoweye\" Ability { id: \"3E69\", source: \"Voidwalker\" }\r\n106.8 \"Unholy Darkness\" Ability { id: \"3E54\", source: \"Voidwalker\" }\r\n121.9 \"Shadowflame\" Ability { id: \"3E61\", source: \"Voidwalker\" }\r\n134.1 \"Entropy\" Ability { id: \"3E70\", source: \"Voidwalker\" }\r\n143.8 \"Empty Rage\" Ability { id: \"3E6C\", source: \"Voidwalker\" }\r\n148.7 \"Doomvoid Guillotine\" Ability { id: \"3E4F\", source: \"Voidwalker\" }\r\n156.9 \"Doomvoid Slicer\" Ability { id: \"3E50\", source: \"Voidwalker\" }\r\n164.9 \"Empty Hate\" Ability { id: \"3E5A\", source: \"Voidwalker\" }\r\n175.8 \"Doomvoid Cleaver\" Ability { id: \"3E64\", source: \"Voidwalker\" }\r\n191.2 \"Shadowflame\" Ability { id: \"3E61\", source: \"Voidwalker\" }\r\n203.4 \"Entropy\" Ability { id: \"3E70\", source: \"Voidwalker\" }\r\n208.0 \"Spell-In-Waiting\" Ability { id: \"3E52\", source: \"Voidwalker\" }\r\n224.9 \"Flare\" Ability { id: \"4685\", source: \"Voidwalker\" }\r\n229.3 \"Spell-In-Waiting\" Ability { id: \"3E52\", source: \"Voidwalker\" }\r\n242.5 \"Hell Wind\" Ability { id: \"3E66\", source: \"Voidwalker\" }\r\n248.5 \"Punishing Ray\" Ability { id: \"3E5B\", source: \"Voidwalker\" }\r\n248.9 \"Shadoweye\" Ability { id: \"3E69\", source: \"Voidwalker\" }\r\n260.7 \"Shadowflame\" Ability { id: \"3E61\", source: \"Voidwalker\" }\r\n272.9 \"Entropy\" Ability { id: \"3E70\", source: \"Voidwalker\" }\r\n282.9 \"Light/Dark Circles\" # ???\r\n286.4 \"Doomvoid Cleaver\" Ability { id: \"3E64\", source: \"Voidwalker\" }\r\n295.7 \"Unholy Darkness\" Ability { id: \"3E54\", source: \"Voidwalker\" }\r\n304.1 \"Slicer/Guillotine\" Ability { id: [\"3E4F\", \"3E50\"], source: \"Voidwalker\" }\r\n330.3 \"Shadowflame\" Ability { id: \"3E61\", source: \"Voidwalker\" }\r\n342.5 \"Entropy\" Ability { id: \"3E70\", source: \"Voidwalker\" }\r\n348.1 \"Spell-In-Waiting\" Ability { id: \"3E52\", source: \"Voidwalker\" }\r\n358.2 \"Empty Hate/Rage\" Ability { id: [\"3E5A\", \"3E6C\"], source: \"Voidwalker\" }\r\n361.4 \"Spell-In-Waiting\" Ability { id: \"3E52\", source: \"Voidwalker\" }\r\n374.7 \"Spell-In-Waiting\" Ability { id: \"3E52\", source: \"Voidwalker\" }\r\n381.6 \"Flare\" Ability { id: \"4685\", source: \"Voidwalker\" }\r\n386.9 \"Unholy Darkness\" Ability { id: \"3E54\", source: \"Voidwalker\" }\r\n399.9 \"Shadowflame\" Ability { id: \"3E61\", source: \"Voidwalker\" }\r\n408.5 \"Spell-In-Waiting\" Ability { id: \"3E52\", source: \"Voidwalker\" }\r\n421.8 \"Spell-In-Waiting\" Ability { id: \"3E52\", source: \"Voidwalker\" }\r\n430.0 \"Shadoweye\" Ability { id: \"3E69\", source: \"Voidwalker\" }\r\n430.0 \"Flare\" Ability { id: \"4685\", source: \"Voidwalker\" }\r\n437.4 \"Dark Fire III\" Ability { id: \"3E57\", source: \"Voidwalker\" }\r\n445.4 \"Light/Dark Circles\" # ???\r\n450.2 \"Punishing Ray\" Ability { id: \"3E5B\", source: \"Voidwalker\" }\r\n455.0 \"Doomvoid Cleaver\" Ability { id: \"3E64\", source: \"Voidwalker\" }\r\n469.4 \"Shadowflame\" Ability { id: \"3E61\", source: \"Voidwalker\" }\r\n\r\n# FIXME: I've seen this push ~6s earlier once\r\n# but is pretty consistent otherwise?\r\n499.2 \"Quietus\" Ability { id: \"3E71\", source: \"Voidwalker\" } window 500,20\r\n507.4 \"Cycle Of ?\" Ability { id: [\"40B9\", \"4659\"], source: \"Voidwalker\" }\r\n510.5 \"Slicer/Guillotine?\" Ability { id: \"465A\", source: \"Voidwalker\" }\r\n511.2 \"Cleaver/Slicer?\" Ability { id: \"3E64\", source: \"Voidwalker\" }\r\n513.6 \"Guillotine/Cleaver?\" Ability { id: \"465B\", source: \"Voidwalker\" }\r\n\r\n531.8 \"Cycle Of ?\" Ability { id: [\"40B9\", \"4659\"], source: \"Voidwalker\" }\r\n534.9 \"Slicer/Guillotine?\" Ability { id: \"40BA\", source: \"Voidwalker\" }\r\n538.0 \"Cleaver/Slicer?\" Ability { id: \"40BB\", source: \"Voidwalker\" }\r\n538.7 \"Guillotine/Cleaver?\" Ability { id: \"3E64\", source: \"Voidwalker\" }\r\n\r\n558.2 \"Quietus\" Ability { id: \"3E71\", source: \"Voidwalker\" }\r\n568.2 \"Cycle Of ?\" Ability { id: [\"40B9\", \"4659\"], source: \"Voidwalker\" }\r\n571.3 \"Slicer/Guillotine?\" Ability { id: [\"40BA\", \"465A\"], source: \"Voidwalker\" }\r\n574.4 \"Cleaver/Slicer?\" #Ability { id: [\"40BB\", \"3E64\"], source: \"Voidwalker\" }\r\n575.1 \"Guillotine/Cleaver?\" #Ability { id: [\"3E64\", \"465B\"], source: \"Voidwalker\" }\r\n593.2 \"Quietus\" Ability { id: \"3E71\", source: \"Voidwalker\" }\r\n602.5 \"Quietus\" Ability { id: \"3E71\", source: \"Voidwalker\" }\r\n611.8 \"Quietus\" Ability { id: \"3E71\", source: \"Voidwalker\" }\r\n624.8 \"--sync--\" StartsUsing { id: \"3E73\", source: \"Voidwalker\" } window 700,5\r\n629.8 \"Quietus Enrage\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e3n.ts



const e3n_triggerSet = {
  id: 'EdensGateInundation',
  zoneId: zone_id/* default.EdensGateInundation */.Z.EdensGateInundation,
  timelineFile: 'e3n.txt',
  triggers: [{
    id: 'E3N Tidal Roar',
    type: 'StartsUsing',
    netRegex: {
      id: '3FC4',
      source: 'Leviathan',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E3N Rip Current',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E3N Tidal Wave Look',
    type: 'StartsUsing',
    netRegex: {
      id: '3FD2',
      source: 'Leviathan',
      capture: false
    },
    delaySeconds: 3,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look for Wave',
        de: 'Nach der Welle schauen',
        fr: 'Repérez la vague',
        ja: 'つなみ来るよ',
        cn: '看浪',
        ko: '해일 위치 확인'
      }
    }
  }, {
    id: 'E3N Tidal Wave Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '3FD2',
      source: 'Leviathan',
      capture: false
    },
    // 3 seconds of cast, 10 seconds of delay.
    // This gives a warning within 5 seconds, so you can hit arm's length.
    delaySeconds: 8,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'E3N Undersea Quake Outside',
    type: 'StartsUsing',
    netRegex: {
      id: '3FD0',
      source: 'Leviathan',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Middle',
        de: 'In die Mitte gehen',
        fr: 'Allez au milieu',
        ja: '中心へ',
        cn: '中间',
        ko: '중앙으로'
      }
    }
  }, {
    id: 'E3N Undersea Quake Inside',
    type: 'StartsUsing',
    netRegex: {
      id: '3FCF',
      source: 'Leviathan',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides('alarm')
  }, {
    id: 'E3N Maelstrom',
    type: 'StartsUsing',
    netRegex: {
      id: '3FD8',
      source: 'Leviathan',
      capture: false
    },
    delaySeconds: 8,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Puddles and Dives',
        de: 'Flächen und Leviathan ausweichen',
        fr: 'Évitez les zones au sol et les piqués',
        ja: '円範囲から離れる',
        cn: '躲圈闪避',
        ko: '돌진이랑 장판 피하기'
      }
    }
  }, {
    id: 'E3N Drenching Pulse Spread',
    type: 'HeadMarker',
    netRegex: {
      id: '00A9'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'E3N Tsunami',
    type: 'StartsUsing',
    netRegex: {
      id: '3FD4',
      source: 'Leviathan',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Crashing Pulse and Smothering Waters
    id: 'E3N Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'E3N Surging Waters Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '00AD'
    },
    response: responses/* Responses.knockbackOn */.n3.knockbackOn()
  }, {
    id: 'E3N Splashing Waters Spread',
    type: 'HeadMarker',
    netRegex: {
      id: '0082'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'E3N Swirling Waters Donut',
    type: 'HeadMarker',
    netRegex: {
      id: '0099'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Donut on YOU',
        de: 'Donut auf DIR',
        fr: 'Donut sur VOUS',
        ja: '自分にドーナツ範囲',
        cn: '月环点名',
        ko: '도넛장판 대상자'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Leviathan': 'Leviathan'
    },
    'replaceText': {
      'Crashing Pulse': 'Stürmische Wogen',
      'Drenching Pulse': 'Tosende Wogen',
      'Freak Wave': 'Gigantische Welle',
      'Killer Wave': 'Tödliche Welle',
      'Maelstrom': 'Mahlstrom',
      'Monster Wave': 'Monsterwelle',
      'Rip Current': 'Brandungsrückstrom',
      'Smothering Tsunami': 'Ertränkende Sturzflut',
      'Spinning Dive': 'Drehsprung',
      'Splashing Tsunami': 'Stürmende Sturzflut',
      'Surging Tsunami': 'Erdrückende Sturzflut',
      'Swirling Tsunami': 'Wirbelnde Sturzflut',
      'Temporary Current': 'Unstete Gezeiten',
      'Tidal Roar': 'Schrei der Gezeiten',
      'Tidal Wave': 'Flutwelle',
      '(?<! )Tsunami': 'Sturzflut',
      'Undersea Quake': 'Unterwasserbeben'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Leviathan': 'Léviathan'
    },
    'replaceText': {
      'Crashing Pulse': 'Pulsation déchaînée',
      'Drenching Pulse': 'Pulsation sauvage',
      'Freak Wave': 'Vague gigantesque',
      'Killer Wave': 'Vague meutrière',
      'Maelstrom': 'Maelström',
      'Monster Wave': 'Vague monstrueuse',
      'Rip Current': 'Courant d\'arrachement',
      'Smothering Tsunami': 'Tsunami submergeant',
      'Spinning Dive': 'Piqué tournant',
      'Splashing Tsunami': 'Tsunami déferlant',
      'Surging Tsunami': 'Tsunami écrasant',
      'Swirling Tsunami': 'Tsunami tournoyant',
      'Temporary Current': 'Courant évanescent',
      'Tidal Roar': 'Vague rugissante',
      'Tidal Wave': 'Raz-de-marée',
      '(?<! )Tsunami': 'Tsunami',
      'Undersea Quake': 'Séisme sous-marin'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Leviathan': 'リヴァイアサン'
    },
    'replaceText': {
      'Crashing Pulse': '激烈なる波動',
      'Drenching Pulse': '猛烈なる波動',
      'Freak Wave': 'フリークウェイブ',
      'Killer Wave': 'キラーウェイブ',
      'Maelstrom': 'メイルシュトローム',
      'Monster Wave': 'モンスターウェイブ',
      'Rip Current': 'リップカレント',
      'Smothering Tsunami': '溺没の大海嘯',
      'Spinning Dive': 'スピニングダイブ',
      'Splashing Tsunami': '強風の大海嘯',
      'Surging Tsunami': '強圧の大海嘯',
      'Swirling Tsunami': '渦動の大海嘯',
      'Temporary Current': 'テンポラリーカレント',
      'Tidal Roar': 'タイダルロア',
      'Tidal Wave': 'タイダルウェイブ',
      '(?<! )Tsunami': '大海嘯',
      'Undersea Quake': 'アンダーシークエイク'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Leviathan': '利维亚桑'
    },
    'replaceText': {
      'Crashing Pulse': '激烈波动',
      'Drenching Pulse': '猛烈波动',
      'Freak Wave': '畸形波',
      'Killer Wave': '杀人浪',
      'Maelstrom': '巨漩涡',
      'Monster Wave': '疯狗浪',
      'Rip Current': '裂流',
      'Smothering Tsunami': '溺没大海啸',
      'Spinning Dive': '旋转下潜',
      'Splashing Tsunami': '强风大海啸',
      'Surging Tsunami': '强压大海啸',
      'Swirling Tsunami': '涡动大海啸',
      'Temporary Current': '临时洋流',
      'Tidal Roar': '怒潮咆哮',
      'Tidal Wave': '巨浪',
      '(?<! )Tsunami': '大海啸',
      'Undersea Quake': '海底地震'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Leviathan': '리바이어선'
    },
    'replaceText': {
      'Crashing Pulse': '격렬한 파동',
      'Drenching Pulse': '맹렬한 파동',
      'Freak Wave': '기괴한 물결',
      'Killer Wave': '치명적인 물결',
      'Maelstrom': '대격동',
      'Monster Wave': '마물의 물결',
      'Rip Current': '이안류',
      'Smothering Tsunami': '익몰의 대해일',
      'Spinning Dive': '고속 돌진',
      'Splashing Tsunami': '강풍의 대해일',
      'Surging Tsunami': '강압의 대해일',
      'Swirling Tsunami': '와동의 대해일',
      'Temporary Current': '순간 해류',
      'Tidal Roar': '바다의 포효',
      'Tidal Wave': '해일',
      '(?<! )Tsunami': '대해일',
      'Undersea Quake': '해저 지진'
    }
  }]
};
/* harmony default export */ const e3n = (e3n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e3n.txt
const raid_e3n_namespaceObject = "### Eden 3 (Normal)\r\n# Eden's Gate: Inundation\r\n# -ii 42D8 3FC5 3FC7 3FD1 3FD9 3FD2 4010 3FD4 -p 3FC4:12.5\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n12.5 \"Tidal Roar\" Ability { id: \"3FC4\", source: \"Leviathan\" } window 13,5\r\n23.5 \"Rip Current\" Ability { id: \"3FC6\", source: \"Leviathan\" }\r\n37.7 \"Temporary Current\" Ability { id: \"3FC[DE]\", source: \"Leviathan\" }\r\n47.0 \"Drenching Pulse\" Ability { id: \"3FC8\", source: \"Leviathan\" }\r\n51.1 \"Monster Wave\" Ability { id: \"3FCA\", source: \"Leviathan\" }\r\n55.1 \"Freak Wave\" Ability { id: \"3FCB\", source: \"Leviathan\" }\r\n60.2 \"Temporary Current\" Ability { id: \"3FC[DE]\", source: \"Leviathan\" }\r\n70.4 \"Tidal Roar\" Ability { id: \"3FC4\", source: \"Leviathan\" } window 30,30\r\n77.4 \"Rip Current\" Ability { id: \"3FC6\", source: \"Leviathan\" }\r\n98.7 \"Tidal Wave\" Ability { id: \"3FD3\", source: \"Leviathan\" }\r\n\r\n105.6 \"Undersea Quake\" Ability { id: \"3FD0\", source: \"Leviathan\" } window 105.6,10\r\n114.8 \"Crashing Pulse\" Ability { id: \"3FC9\", source: \"Leviathan\" }\r\n118.9 \"Monster Wave\" Ability { id: \"3FCA\", source: \"Leviathan\" }\r\n122.9 \"Killer Wave\" Ability { id: \"3FCC\", source: \"Leviathan\" }\r\n128.9 \"Tidal Roar\" Ability { id: \"3FC4\", source: \"Leviathan\" }\r\n140.0 \"Temporary Current\" Ability { id: \"3FC[DE]\", source: \"Leviathan\" } window 30,30\r\n162.3 \"Tsunami\" Ability { id: \"441B\", source: \"Leviathan\" }\r\n171.9 \"Surging Tsunami\" Ability { id: \"4011\", source: \"Leviathan\" }\r\n178.9 \"Smothering Tsunami\" Ability { id: \"3FD7\", source: \"Leviathan\" }\r\n184.9 \"Splashing Tsunami\" Ability { id: \"3FD6\", source: \"Leviathan\" }\r\n185.8 \"Swirling Tsunami\" Ability { id: \"3FD5\", source: \"Leviathan\" }\r\n192.8 \"Surging Tsunami\" Ability { id: \"4011\", source: \"Leviathan\" }\r\n203.5 \"Tidal Roar\" Ability { id: \"3FC4\", source: \"Leviathan\" } window 20,20\r\n\r\n216.7 \"Maelstrom\" Ability { id: \"3FD8\", source: \"Leviathan\" } duration 30 window 216.7,2.5\r\n218.7 \"--untargetable--\"\r\n222.0 \"--sync--\" Ability { id: \"3F7E\", source: \"Leviathan\" }\r\n226.9 \"Spinning Dive 1\" Ability { id: \"3FDB\", source: \"Leviathan\" }\r\n229.1 \"--sync--\" Ability { id: \"3F7E\", source: \"Leviathan\" }\r\n234.0 \"Spinning Dive 2\" Ability { id: \"3FDB\", source: \"Leviathan\" }\r\n240.4 \"--targetable--\"\r\n248.4 \"Tidal Roar\" Ability { id: \"3FC4\", source: \"Leviathan\" }\r\n255.4 \"Rip Current\" Ability { id: \"3FC6\", source: \"Leviathan\" } window 30,30\r\n276.8 \"Tidal Wave\" Ability { id: \"3FD3\", source: \"Leviathan\" }\r\n\r\n283.8 \"Undersea Quake\" Ability { id: \"3FCF\", source: \"Leviathan\" } window 300,100\r\n293.0 \"Drenching Pulse\" Ability { id: \"3FC8\", source: \"Leviathan\" }\r\n297.1 \"Monster Wave\" Ability { id: \"3FCA\", source: \"Leviathan\" }\r\n301.1 \"Freak Wave\" Ability { id: \"3FCB\", source: \"Leviathan\" }\r\n308.2 \"Temporary Current 1\" Ability { id: \"3FC[DE]\", source: \"Leviathan\" }\r\n317.3 \"Temporary Current 2\" Ability { id: \"3FC[DE]\", source: \"Leviathan\" }\r\n332.5 \"Tidal Roar\" Ability { id: \"3FC4\", source: \"Leviathan\" }\r\n338.6 \"Tidal Roar\" Ability { id: \"3FC4\", source: \"Leviathan\" }\r\n348.8 \"Rip Current\" Ability { id: \"3FC6\", source: \"Leviathan\" } window 30,30\r\n360.0 \"Drenching Pulse\" Ability { id: \"3FC8\", source: \"Leviathan\" }\r\n364.1 \"Monster Wave\" Ability { id: \"3FCA\", source: \"Leviathan\" }\r\n368.1 \"Freak Wave\" Ability { id: \"3FCB\", source: \"Leviathan\" }\r\n\r\n372.1 \"Undersea Quake\" Ability { id: \"3FD0\", source: \"Leviathan\" } window 30,30\r\n386.3 \"Tsunami\" Ability { id: \"441B\", source: \"Leviathan\" }\r\n395.9 \"Surging Tsunami\" Ability { id: \"4011\", source: \"Leviathan\" }\r\n402.9 \"Smothering Tsunami\" Ability { id: \"3FD7\", source: \"Leviathan\" }\r\n408.8 \"Splashing Tsunami\" Ability { id: \"3FD6\", source: \"Leviathan\" }\r\n409.8 \"Swirling Tsunami\" Ability { id: \"3FD5\", source: \"Leviathan\" }\r\n416.8 \"Surging Tsunami\" Ability { id: \"4011\", source: \"Leviathan\" }\r\n429.4 \"Temporary Current 1\" Ability { id: \"3FC[DE]\", source: \"Leviathan\" }\r\n438.4 \"Temporary Current 2\" Ability { id: \"3FC[DE]\", source: \"Leviathan\" }\r\n449.4 \"Rip Current\" Ability { id: \"3FC6\", source: \"Leviathan\" } window 30,30\r\n455.4 \"Tidal Roar\" Ability { id: \"3FC4\", source: \"Leviathan\" }\r\n461.4 \"Tidal Roar\" Ability { id: \"3FC4\", source: \"Leviathan\" }\r\n\r\n476.4 \"Maelstrom\" Ability { id: \"3FD8\", source: \"Leviathan\" } duration 30\r\n478.4 \"--untargetable--\"\r\n481.4 \"--sync--\" Ability { id: \"3F7E\", source: \"Leviathan\" }\r\n486.4 \"Spinning Dive 1\" Ability { id: \"3FDB\", source: \"Leviathan\" }\r\n488.4 \"--sync--\" Ability { id: \"3F7E\", source: \"Leviathan\" }\r\n493.4 \"Spinning Dive 2\" Ability { id: \"3FDB\", source: \"Leviathan\" }\r\n499.9 \"--targetable--\"\r\n507.9 \"Tidal Roar\" Ability { id: \"3FC4\", source: \"Leviathan\" }\r\n515.0 \"Rip Current\" Ability { id: \"3FC6\", source: \"Leviathan\" } window 30,30\r\n536.4 \"Tidal Wave\" Ability { id: \"3FD3\", source: \"Leviathan\" }\r\n\r\n543.4 \"Undersea Quake\" Ability { id: \"3FCF\", source: \"Leviathan\" } window 100,100 jump 283.8\r\n552.6 \"Drenching Pulse\"\r\n556.7 \"Monster Wave\"\r\n560.7 \"Freak Wave\"\r\n567.8 \"Temporary Current\"\r\n576.9 \"Temporary Current\"\r\n592.1 \"Tidal Roar\"\r\n598.2 \"Tidal Roar\"\r\n608.4 \"Rip Current\"\r\n619.6 \"Drenching Pulse\"\r\n623.7 \"Monster Wave\"\r\n627.7 \"Freak Wave\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e3s.ts




const e3s_triggerSet = {
  id: 'EdensGateInundationSavage',
  zoneId: zone_id/* default.EdensGateInundationSavage */.Z.EdensGateInundationSavage,
  timelineFile: 'e3s.txt',
  timelineTriggers: [{
    id: 'E3S Plunging Wave',
    regex: /Plunging Wave/,
    beforeSeconds: 2,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Stack',
        de: 'In einer Linie sammeln',
        fr: 'Packez-vous en ligne',
        ja: '直線スタック',
        cn: '直线分摊',
        ko: '쉐어징 모이기'
      }
    }
  }, {
    id: 'E3S Spilling Wave',
    regex: /Spilling Wave/,
    beforeSeconds: 3,
    condition: data => data.role === 'tank',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank Cleaves, Move Front',
        de: 'Tank Cleaves, nach vorne bewegen',
        fr: 'Tank cleave, allez devant',
        ja: '拡散くるよ',
        cn: '坦克放陨石，向前集合',
        ko: '탱버, 앞으로 이동'
      }
    }
  }],
  triggers: [{
    id: 'E3S Tidal Roar',
    type: 'StartsUsing',
    netRegex: {
      id: '3FDC',
      source: 'Leviathan',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E3S Tidal Rage',
    type: 'StartsUsing',
    netRegex: {
      id: '3FDE',
      source: 'Leviathan',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E3S Tidal Wave Look',
    type: 'StartsUsing',
    netRegex: {
      id: '3FF1',
      source: 'Leviathan',
      capture: false
    },
    delaySeconds: 3,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look for Wave',
        de: 'Nach Welle ausschau halten',
        fr: 'Repérez la vague',
        ja: 'タイダルウェーブくるよ',
        cn: '看浪',
        ko: '해일 위치 확인'
      }
    }
  }, {
    id: 'E3S Tidal Wave Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '3FF1',
      source: 'Leviathan',
      capture: false
    },
    // 3 seconds of cast, 10 seconds of delay.
    // This gives a warning within 5 seconds, so you can hit arm's length.
    delaySeconds: 8,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'E3S Rip Current',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    suppressSeconds: 10,
    alarmText: (data, matches, output) => {
      if (matches.target !== data.me && data.role === 'tank') return output.tankSwap();
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.tankBusterOnYou();
      if (data.role === 'healer') return output.tankBusters();
    },
    outputStrings: {
      tankBusterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
      tankBusters: outputs/* default.tankBusters */.Z.tankBusters,
      tankSwap: outputs/* default.tankSwap */.Z.tankSwap
    }
  }, {
    id: 'E3S Undersea Quake Outside',
    type: 'StartsUsing',
    netRegex: {
      id: '3FEF',
      source: 'Leviathan',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Middle',
        de: 'Geh in die Mitte',
        fr: 'Allez au milieu',
        ja: '外壊れるよ',
        cn: '中间',
        ko: '가운데로'
      }
    }
  }, {
    id: 'E3S Undersea Quake Inside',
    type: 'StartsUsing',
    netRegex: {
      id: '3FEE',
      source: 'Leviathan',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides('alarm')
  }, {
    id: 'E3S Flare',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Flare on YOU',
        de: 'Flare auf DIR',
        fr: 'Brasier sur VOUS',
        ja: '自分にフレア',
        cn: '核爆点名',
        ko: '플레어 대상자'
      }
    }
  }, {
    id: 'E3S Drenching Pulse',
    type: 'StartsUsing',
    netRegex: {
      id: '3FE2',
      source: 'Leviathan',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack, Bait Puddles',
        de: 'Sammeln, Flächen ködern',
        fr: 'Packez-vous, attirez les zones au sol',
        ja: '集合',
        cn: '集合',
        ko: '모이기'
      }
    }
  }, {
    id: 'E3S Drenching Pulse Puddles',
    type: 'StartsUsing',
    netRegex: {
      id: '3FE2',
      source: 'Leviathan',
      capture: false
    },
    delaySeconds: 2.9,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Puddles Outside',
        de: 'Flächen drausen ablegen',
        fr: 'Déposez les zones au sol à l\'extérieur',
        ja: '散開',
        cn: '散开',
        ko: '바깥쪽에 장판 놓기'
      }
    }
  }, {
    id: 'E3S Roiling Pulse',
    type: 'StartsUsing',
    netRegex: {
      id: '3FE4',
      source: 'Leviathan',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack, Bait Puddles',
        de: 'Sammeln, Flächen ködern',
        fr: 'Packez-vous, évitez les zones au sol',
        ja: '集合',
        cn: '集合',
        ko: '모이기'
      }
    }
  }, {
    id: 'E3S Roiling Pulse Abilities',
    type: 'StartsUsing',
    netRegex: {
      id: '3FE4',
      source: 'Leviathan',
      capture: false
    },
    delaySeconds: 2.9,
    infoText: (data, _matches, output) => {
      if (data.role === 'tank') return output.flareToOutsideCorner();
      return output.stackOutsideAvoidFlares();
    },
    outputStrings: {
      flareToOutsideCorner: {
        en: 'Flare To Outside Corner',
        de: 'Flare in die äuseren Ecken',
        fr: 'Brasier dans un coin extérieur',
        ja: '隅にフレア',
        cn: '外侧角落放核爆',
        ko: '플레어 양옆 뒤로 유도'
      },
      stackOutsideAvoidFlares: {
        en: 'Stack Outside, Avoid Flares',
        de: 'Auserhalb sammeln, Flares vermeiden',
        fr: 'Packez-vous à l\'extérieur, évitez les brasiers',
        ja: '前で集合',
        cn: '外侧集合躲避核爆',
        ko: '양옆 앞으로 모이고, 플레어 피하기'
      }
    }
  }, {
    id: 'E3S Stormy Horizon',
    type: 'StartsUsing',
    netRegex: {
      id: '3FFE',
      source: 'Leviathan',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Panto Puddles x5',
        de: 'Panto Flächen x5',
        fr: 'Panto Zones au sol x5',
        ja: 'パント5回',
        cn: '处理水圈 x5',
        ko: '발밑장판 5회'
      }
    }
  }, {
    id: 'E3S Hydrothermal Vent Tether',
    type: 'Tether',
    netRegex: {
      id: '005A',
      target: 'Leviathan'
    },
    condition: (data, matches) => data.me === matches.source,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Puddle Tether on YOU',
        de: 'Black Smoker Verbindung auf DIR',
        fr: 'Lien de zones au sol sur VOUS',
        ja: '線ついた',
        cn: '水圈连线',
        ko: '나에게 선연결'
      }
    }
  }, {
    id: 'E3S Hydrothermal Vent Collect',
    type: 'Tether',
    netRegex: {
      id: '005A',
      target: 'Leviathan'
    },
    run: (data, matches) => {
      data.vent ??= [];
      data.vent.push(matches.source);
    }
  }, {
    id: 'E3S Hydrothermal Vent',
    type: 'Tether',
    netRegex: {
      id: '005A',
      target: 'Leviathan',
      capture: false
    },
    condition: data => data.vent && data.vent.length === 2 && !data.vent.includes(data.me) && data.role !== 'tank',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pop alternating bubbles',
        de: 'Flächen abwechselnd nehmen',
        fr: 'Apparition des bulles en alternance',
        ja: '水出た',
        cn: '交替踩圈',
        ko: '물장판 밟기'
      }
    }
  }, {
    id: 'E3S Surging Waters',
    type: 'GainsEffect',
    netRegex: {
      effectId: '73A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Initial knockback on YOU',
        de: 'Initialer Knockback auf DIR',
        fr: 'Poussée initiale sur VOUS',
        ja: '最初のノックバック',
        cn: '初始击退点名',
        ko: '첫 넉백 대상자'
      }
    }
  }, {
    // TODO probably need to call out knockbacks later
    // TODO maybe tell other people about stacking for knockbacks
    id: 'E3S Sundering Waters',
    type: 'GainsEffect',
    netRegex: {
      effectId: '73E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, matches, output) => {
      const seconds = parseFloat(matches.duration);
      if (seconds <= 8) return output.knockbackOnYou();
    },
    infoText: (_data, matches, output) => {
      const seconds = parseFloat(matches.duration);
      if (seconds <= 8) return;
      if (seconds <= 21) return output.lateFirstKnockback();
      return output.lateSecondKnockback();
    },
    outputStrings: {
      lateFirstKnockback: {
        en: 'Late First Knockback',
        de: 'Erster reinigender Knockback',
        fr: 'Poussée tardive 1',
        ja: '遅ノックバック1',
        cn: '迟击退点名 #1',
        ko: '늦은 넉백 대상자 1'
      },
      lateSecondKnockback: {
        en: 'Late Second Knockback',
        de: 'Zweiter reinigender Knockback',
        fr: 'Poussée tardive 2',
        ja: '遅ノックバック2',
        cn: '迟击退点名 #2',
        ko: '늦은 넉백 대상자 2'
      },
      knockbackOnYou: outputs/* default.knockbackOnYou */.Z.knockbackOnYou
    }
  }, {
    // 29 seconds
    id: 'E3S Scouring Waters Defamation',
    type: 'GainsEffect',
    netRegex: {
      effectId: '765'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Defamation',
        de: 'Defamation',
        fr: 'Médisance',
        ja: '暴風',
        cn: '暴风',
        ko: '폭풍 대상자'
      }
    }
  }, {
    id: 'E3S Scouring Waters Avoid Knockback',
    type: 'GainsEffect',
    netRegex: {
      effectId: '765'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 22,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Knockback, Move to Back',
        de: 'Vermeide Knockback, dann nach hinten bewegen',
        fr: 'Évitez la poussée, allez à l\'arrière',
        ja: '後ろへ',
        cn: '后方放大圈',
        ko: '넉백 피해서 뒤로 이동'
      }
    }
  }, {
    id: 'E3S Smothering Waters',
    type: 'GainsEffect',
    netRegex: {
      effectId: '73D'
    },
    condition: (data, matches) => {
      // first tsunami stack is 25 seconds
      // second tsunami stack is 13 seconds
      // Everybody is in first stack, but tanks not in the second.
      return parseFloat(matches.duration) > 15 || data.role !== 'tank';
    },
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 3,
    suppressSeconds: 1,
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }, {
    id: 'E3S Scouring Waters',
    type: 'GainsEffect',
    netRegex: {
      effectId: '765'
    },
    condition: conditions/* default.targetIsNotYou */.Z.targetIsNotYou(),
    delaySeconds: 25,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move In, Avoid Defamation',
        de: 'Rein gehen, vermeide Defamation',
        fr: 'À l\'intérieur, évitez Médisance',
        ja: '前にノックバック',
        cn: '靠近躲避',
        ko: '안으로 이동, 폭풍 피하기'
      }
    }
  }, {
    id: 'E3S Sweeping Waters Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '73F'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank Cone',
        de: 'Tank Kegel',
        fr: 'Cône tank',
        ja: '断絶',
        cn: '坦克三角',
        ko: '확산의 징조 대상자'
      }
    }
  }, {
    id: 'E3S Sweeping Waters',
    type: 'GainsEffect',
    netRegex: {
      effectId: '73F'
    },
    condition: (data, matches) => data.me === matches.target || data.role === 'tank',
    delaySeconds: 13,
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank Cone',
        de: 'Tank Kegel',
        fr: 'Cône tank',
        ja: '断絶',
        cn: '坦克三角',
        ko: '확산: 탱 멀리 / 대상자 앞으로'
      }
    }
  }, {
    id: 'E3S Refreshed',
    type: 'StartsUsing',
    netRegex: {
      id: '400F',
      source: 'Leviathan',
      capture: false
    },
    run: data => data.refreshed = true
  }, {
    id: 'E3S Front Left Temporary Current',
    type: 'StartsUsing',
    netRegex: {
      id: '3FEB',
      source: 'Leviathan',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Front left / Back right',
        de: 'Vorne Links / Hinten Rechts',
        fr: 'Devant à gauche / Derrière à droite',
        ja: '左前 / 右後ろ',
        cn: '前左 / 后右',
        ko: '↖ 앞 왼쪽 / 뒤 오른쪽 ↘'
      }
    }
  }, {
    id: 'E3S Front Right Temporary Current',
    type: 'StartsUsing',
    netRegex: {
      id: '3FEA',
      source: 'Leviathan',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Front right / Back left',
        de: 'Vorne Rechts / Hinten Links',
        fr: 'Devant à droite / Derrière à gauche',
        ja: '右前 / 左後ろ',
        cn: '前右 / 后左',
        ko: '↗ 앞 오른쪽 / 뒤 왼쪽 ↙'
      }
    }
  }, {
    // Note: there are different abilities for the followup
    // temporary current, but there's only a 1 second cast time.
    // The original has a 6 second cast time and 4 seconds before
    // the next one.
    id: 'E3S Front Left Temporary Current 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3FEA',
      source: 'Leviathan',
      capture: false
    },
    condition: data => data.refreshed,
    delaySeconds: 6.2,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Front left / Back right',
        de: 'Vorne Links / Hinten Rechts',
        fr: 'Devant à gauche / Derrière à droite',
        ja: '左前 / 右後ろ',
        cn: '前左 / 后右',
        ko: '↖ 앞 왼쪽 / 뒤 오른쪽 ↘'
      }
    }
  }, {
    id: 'E3S Front Right Temporary Current 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3FEB',
      source: 'Leviathan',
      capture: false
    },
    condition: data => data.refreshed,
    delaySeconds: 6.2,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Front right / Back left',
        de: 'Vorne Rechts / Hinten Links',
        fr: 'Devant à droite / Derrière à gauche',
        ja: '右前 / 左後ろ',
        cn: '前右 / 后左',
        ko: '↗ 앞 오른쪽 / 뒤 왼쪽 ↙'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Leviathan': 'Leviathan'
    },
    'replaceText': {
      'Backbreaking Wave': 'Verwüstende Welle',
      'Black Smokers': 'Schwarzer Raucher',
      '(?<!\\w)Breaking Wave': 'Schmetternde Welle',
      'Drenching Pulse': 'Tosende Wogen',
      'Freak Wave': 'Gigantische Welle',
      'Hot Water': 'Heißes Wasser',
      'Hydrothermal Vent': 'Hydrothermale Quelle',
      'Killer Wave': 'Tödliche Welle',
      'Maelstrom': 'Mahlstrom',
      'Monster Wave': 'Monsterwelle',
      'Plunging Wave': 'Donnernde Welle',
      'Refreshing Shower': 'Erwachen der Tiefen',
      'Rip Current': 'Brandungsrückstrom',
      'Roiling Pulse': 'Wüstende Wogen',
      'Scouring Tsunami': 'Böige Sturzflut',
      'Smothering Tsunami': 'Ertränkende Sturzflut',
      'Spilling Wave': 'Schäumende Welle',
      'Spinning Dive': 'Drehsprung',
      'Stormy Horizon': 'Stürmische See',
      'Sundering Tsunami': 'Zerstörende Sturzflut',
      'Surging Tsunami': 'Erdrückende Sturzflut',
      'Sweeping Tsunami': 'Auflösende Sturzflut',
      'Swirling Tsunami': 'Wirbelnde Sturzflut',
      'Temporary Current': 'Unstete Gezeiten',
      'The Calm': 'Versenkende Flut',
      'The Storm': 'Durch den Mahlstrom',
      'Tidal Rage': 'Wütende Flut',
      'Tidal Roar': 'Schrei der Gezeiten',
      'Tidal Wave': 'Flutwelle',
      '(?<! )Tsunami': 'Sturzflut',
      'Undersea Quake': 'Unterwasserbeben'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Leviathan': 'Léviathan'
    },
    'replaceText': {
      'Backbreaking Wave': 'Vague dévastatrice',
      'Black Smokers': 'Fumeurs noirs',
      '(?<!\\w)Breaking Wave': 'Vague brisante',
      'Drenching Pulse': 'Pulsation sauvage',
      'Freak Wave': 'Vague gigantesque',
      'Hot Water': 'Eau bouillante',
      'Hydrothermal Vent': 'Cheminées hydrothermales',
      'Killer Wave': 'Vague meurtrière',
      'Maelstrom': 'Maelström',
      'Monster Wave': 'Vague monstrueuse',
      'Plunging Wave': 'Vague plongeante',
      'Refreshing Shower': 'Éveil de l\'eau',
      'Rip Current': 'Courant d\'arrachement',
      'Roiling Pulse': 'Pulsation ravageuse',
      'Scouring Tsunami': 'Tsunami dévastateur',
      'Smothering Tsunami': 'Tsunami submergeant',
      'Spilling Wave': 'Vague déversante',
      'Spinning Dive': 'Piqué tournant',
      'Stormy Horizon': 'Mer déchaînée',
      'Sundering Tsunami': 'Tsunami fracturant',
      'Surging Tsunami': 'Tsunami écrasant',
      'Sweeping Tsunami': 'Tsunami pulvérisant',
      'Swirling Tsunami': 'Tsunami tournoyant',
      'Temporary Current': 'Courant évanescent',
      'The Calm': 'Onde naufrageuse',
      'The Storm': 'Spirale du chaos',
      'Tidal Rage': 'Furie des marées',
      'Tidal Roar': 'Vague rugissante',
      'Tidal Wave': 'Raz-de-marée',
      '(?<! )Tsunami': 'Tsunami',
      'Undersea Quake': 'Séisme sous-marin'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Leviathan': 'リヴァイアサン'
    },
    'replaceText': {
      'Backbreaking Wave': 'バックブレーキングウェイブ',
      'Black Smokers': 'ブラックスモーカー',
      '(?<!\\w)Breaking Wave': 'ブレーキングウェイブ',
      'Drenching Pulse': '猛烈なる波動',
      'Freak Wave': 'フリークウェイブ',
      'Hot Water': '熱水',
      'Hydrothermal Vent': 'ハイドロサーマルベント',
      'Killer Wave': 'キラーウェイブ',
      'Maelstrom': 'メイルシュトローム',
      'Monster Wave': 'モンスターウェイブ',
      'Plunging Wave': 'プランジングウェイブ',
      'Refreshing Shower': '水の覚醒',
      'Rip Current': 'リップカレント',
      'Roiling Pulse': '苛烈なる波動',
      'Scouring Tsunami': '暴風の大海嘯',
      'Smothering Tsunami': '溺没の大海嘯',
      'Spilling Wave': 'スピリングウェイブ',
      'Spinning Dive': 'スピニングダイブ',
      'Stormy Horizon': '大時化',
      'Sundering Tsunami': '断絶の大海嘯',
      'Surging Tsunami': '強圧の大海嘯',
      'Sweeping Tsunami': '拡散の大海嘯',
      'Swirling Tsunami': '渦動の大海嘯',
      'Temporary Current': 'テンポラリーカレント',
      'The Calm': '沈溺の波動',
      'The Storm': '混沌の渦動',
      'Tidal Rage': 'タイダルレイジ',
      'Tidal Roar': 'タイダルロア',
      'Tidal Wave': 'タイダルウェイブ',
      '(?<! )Tsunami': '大海嘯',
      'Undersea Quake': 'アンダーシークエイク'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Leviathan': '利维亚桑'
    },
    'replaceText': {
      'Backbreaking Wave': '返破碎波',
      'Black Smokers': '黑色烟柱',
      '(?<!\\w)Breaking Wave': '破碎波',
      'Drenching Pulse': '猛烈波动',
      'Freak Wave': '畸形波',
      'Hot Water': '热水',
      'Hydrothermal Vent': '海底热泉',
      'Killer Wave': '杀人浪',
      'Maelstrom': '巨漩涡',
      'Monster Wave': '疯狗浪',
      'Plunging Wave': '卷跃波',
      'Refreshing Shower': '水之觉醒',
      'Rip Current': '裂流',
      'Roiling Pulse': '剧烈波动',
      'Scouring Tsunami': '暴风大海啸',
      'Smothering Tsunami': '溺没大海啸',
      'Spilling Wave': '崩碎波',
      'Spinning Dive': '旋转下潜',
      'Stormy Horizon': '大暴风雨',
      'Sundering Tsunami': '断绝大海啸',
      'Surging Tsunami': '强压大海啸',
      'Sweeping Tsunami': '扩散大海啸',
      'Swirling Tsunami': '涡动大海啸',
      'Temporary Current': '临时洋流',
      'The Calm': '沉溺波动',
      'The Storm': '雷切',
      'Tidal Rage': '怒潮肆虐',
      'Tidal Roar': '怒潮咆哮',
      'Tidal Wave': '巨浪',
      '(?<! )Tsunami': '大海啸',
      'Undersea Quake': '海底地震'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Leviathan': '리바이어선'
    },
    'replaceText': {
      'Backbreaking Wave': '험난한 물결',
      'Black Smokers': '해저 간헐천',
      '(?<!\\w)Breaking Wave': '파괴의 물결',
      'Drenching Pulse': '맹렬한 파동',
      'Freak Wave': '기괴한 물결',
      'Hot Water': '열수',
      'Hydrothermal Vent': '열수 분출구',
      'Killer Wave': '치명적인 물결',
      'Maelstrom': '대격동',
      'Monster Wave': '마물의 물결',
      'Plunging Wave': '저돌적인 물결',
      'Refreshing Shower': '물의 각성',
      'Rip Current': '이안류',
      'Roiling Pulse': '가열찬 파동',
      'Scouring Tsunami': '폭풍의 대해일',
      'Smothering Tsunami': '익몰의 대해일',
      'Spilling Wave': '붕괴파',
      'Spinning Dive': '고속 돌진',
      'Stormy Horizon': '풍랑',
      'Sundering Tsunami': '단절의 대해일',
      'Surging Tsunami': '강압의 대해일',
      'Sweeping Tsunami': '확산의 대해일',
      'Swirling Tsunami': '와동의 대해일',
      'Temporary Current': '순간 해류',
      'The Calm': '익몰의 파동',
      'The Storm': '전멸기 / 혼돈의 파동',
      'Tidal Rage': '바다의 분노',
      'Tidal Roar': '바다의 포효',
      'Tidal Wave': '해일',
      '(?<! )Tsunami': '대해일',
      'Undersea Quake': '해저 지진'
    }
  }]
};
/* harmony default export */ const e3s = (e3s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e3s.txt
const raid_e3s_namespaceObject = "### Eden 3 (Savage)\r\n# Eden's Gate: Inundation (Savage)\r\n# -p 3FDC:12.8 -ii 42D9 3FDD 3FE1 3FF0 3FF1 3FFB 40E3 3FDF 400A 400C 4000 4002 3FFF 4008 4004 4005\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n12.8 \"Tidal Roar\" Ability { id: \"3FDC\", source: \"Leviathan\" } window 13,10\r\n23.9 \"Rip Current\" Ability { id: \"3FE0\", source: \"Leviathan\" }\r\n43.3 \"Undersea Quake\" Ability { id: \"3FEF\", source: \"Leviathan\" }\r\n46.1 \"Tidal Wave\" Ability { id: \"3FF2\", source: \"Leviathan\" }\r\n52.4 \"Temporary Current\" Ability { id: [\"3FEB\", \"3FEA\"], source: \"Leviathan\" }\r\n61.6 \"Drenching Pulse\" Ability { id: \"3FE2\", source: \"Leviathan\" }\r\n65.7 \"Monster Wave\" Ability { id: \"3FE5\", source: \"Leviathan\" }\r\n69.7 \"Freak Wave\" Ability { id: \"3FE6\", source: \"Leviathan\" }\r\n73.7 \"Temporary Current\" Ability { id: [\"3FEB\", \"3FEA\"], source: \"Leviathan\" }\r\n87.9 \"Maelstrom\" Ability { id: \"3FFA\", source: \"Leviathan\" }\r\n90.0 \"--untargetable--\"\r\n99.3 \"Spinning Dive 1\" #Ability { id: \"3FFD\", source: \"Leviathan\" }\r\n101.3 \"Spinning Dive 2\" #Ability { id: \"3FFD\", source: \"Leviathan\" }\r\n106.0 \"--targetable--\"\r\n111.5 \"Tidal Roar\" Ability { id: \"3FDC\", source: \"Leviathan\" }\r\n127.8 \"Tsunami\" Ability { id: \"3FF3\", source: \"Leviathan\" }\r\n132.8 \"Tsunami\" Ability { id: \"441C\", source: \"Leviathan\" }\r\n141.4 \"Sundering Tsunami\" Ability { id: \"3FF6\", source: \"Leviathan\" }\r\n146.1 \"Undersea Quake\" Ability { id: \"3FEE\", source: \"Leviathan\" }\r\n158.4 \"Temporary Current\" Ability { id: [\"3FEB\", \"3FEA\"], source: \"Leviathan\" }\r\n158.4 \"Smothering Tsunami\" Ability { id: \"3FF7\", source: \"Leviathan\" }\r\n158.4 \"Swirling Tsunami\" Ability { id: \"3FF4\", source: \"Leviathan\" }\r\n168.7 \"Tidal Roar\" Ability { id: \"3FDC\", source: \"Leviathan\" }\r\n175.9 \"Rip Current\" Ability { id: \"3FE0\", source: \"Leviathan\" }\r\n186.1 \"Temporary Current\" Ability { id: [\"3FEB\", \"3FEA\"], source: \"Leviathan\" }\r\n197.3 \"Tidal Roar\" Ability { id: \"3FDC\", source: \"Leviathan\" }\r\n210.4 \"Refreshing Shower\" Ability { id: \"400F\", source: \"Leviathan\" }\r\n223.6 \"Tidal Rage\" Ability { id: \"3FDE\", source: \"Leviathan\" }\r\n235.9 \"Undersea Quake\" Ability { id: \"3FEF\", source: \"Leviathan\" }\r\n238.9 \"Tidal Wave\" Ability { id: \"3FF2\", source: \"Leviathan\" }\r\n246.0 \"Temporary Current\" Ability { id: [\"3FEB\", \"3FEA\"], source: \"Leviathan\" }\r\n250.1 \"Temporary Current\" Ability { id: [\"3FEC\", \"3FED\"], source: \"Leviathan\" }\r\n256.2 \"Drenching Pulse\" Ability { id: \"3FE2\", source: \"Leviathan\" }\r\n260.3 \"Monster Wave\" Ability { id: \"3FE9\", source: \"Leviathan\" }\r\n264.3 \"Freak Wave\" Ability { id: \"3FE6\", source: \"Leviathan\" }\r\n269.4 \"Temporary Current\" Ability { id: [\"3FEB\", \"3FEA\"], source: \"Leviathan\" }\r\n273.5 \"Temporary Current\" Ability { id: [\"3FEC\", \"3FED\"], source: \"Leviathan\" }\r\n287.8 \"Maelstrom\" Ability { id: \"3FFA\", source: \"Leviathan\" }\r\n290.0 \"--untargetable--\"\r\n301.2 \"Spinning Dive 1\" #Ability { id: \"3FFD\", source: \"Leviathan\" }\r\n303.1 \"Spinning Dive 2\" #Ability { id: \"3FFD\", source: \"Leviathan\" }\r\n305.1 \"Spinning Dive 3\" #Ability { id: \"3FFD\", source: \"Leviathan\" }\r\n310.0 \"--targetable--\"\r\n316.4 \"Tidal Rage\" Ability { id: \"3FDE\", source: \"Leviathan\" }\r\n323.5 \"Rip Current\" Ability { id: \"3FE0\", source: \"Leviathan\" }\r\n339.7 \"Stormy Horizon\" Ability { id: \"3FFE\", source: \"Leviathan\" }\r\n346.8 \"Monster Wave x4\" duration 6 #Ability { id: \"3FE9\", source: \"Leviathan\" }\r\n352.8 \"Backbreaking Wave\" Ability { id: \"4001\", source: \"Leviathan\" }\r\n353.9 \"Temporary Current\" Ability { id: [\"3FEB\", \"3FEA\"], source: \"Leviathan\" }\r\n358.1 \"Temporary Current\" Ability { id: [\"3FEC\", \"3FED\"], source: \"Leviathan\" }\r\n363.0 \"Plunging Wave x5\" duration 4.4 #Ability { id: \"4003\", source: \"Leviathan\" }\r\n373.2 \"Tidal Rage\" Ability { id: \"3FDE\", source: \"Leviathan\" }\r\n383.5 \"Tidal Rage\" Ability { id: \"3FDE\", source: \"Leviathan\" }\r\n402.3 \"Drenching Pulse\" Ability { id: \"3FE2\", source: \"Leviathan\" }\r\n406.4 \"Monster Wave\" Ability { id: \"3FE9\", source: \"Leviathan\" }\r\n410.4 \"Freak Wave\" Ability { id: \"3FE6\", source: \"Leviathan\" }\r\n413.4 \"Undersea Quake\" Ability { id: \"3FEF\", source: \"Leviathan\" }\r\n422.6 \"Tsunami\" Ability { id: \"3FF3\", source: \"Leviathan\" }\r\n427.6 \"Tsunami\" Ability { id: \"441C\", source: \"Leviathan\" }\r\n436.1 \"Surging Tsunami\" Ability { id: \"3FF8\", source: \"Leviathan\" }\r\n441.1 \"Smothering Tsunami\" Ability { id: \"3FF7\", source: \"Leviathan\" }\r\n443.1 \"Sweeping Tsunami\" Ability { id: \"3FF5\", source: \"Leviathan\" }\r\n449.2 \"Sundering Tsunami\" #Ability { id: \"3FF6\", source: \"Leviathan\" }\r\n453.2 \"Sundering Tsunami\" #Ability { id: \"3FF6\", source: \"Leviathan\" }\r\n457.1 \"Scouring Tsunami\" Ability { id: \"3CE0\", source: \"Leviathan\" }\r\n466.8 \"Temporary Current\" Ability { id: [\"3FEB\", \"3FEA\"], source: \"Leviathan\" }\r\n470.9 \"Temporary Current\" Ability { id: [\"3FEC\", \"3FED\"], source: \"Leviathan\" }\r\n483.1 \"Tidal Rage\" Ability { id: \"3FDE\", source: \"Leviathan\" }\r\n493.2 \"Tidal Rage\" Ability { id: \"3FDE\", source: \"Leviathan\" }\r\n500.3 \"Rip Current\" Ability { id: \"3FE0\", source: \"Leviathan\" }\r\n516.5 \"Roiling Pulse\" Ability { id: \"3FE4\", source: \"Leviathan\" }\r\n520.6 \"Monster Wave\" Ability { id: \"3FE9\", source: \"Leviathan\" }\r\n524.6 \"Breaking Wave\" Ability { id: \"3FE8\", source: \"Leviathan\" }\r\n524.6 \"Killer Wave\" Ability { id: \"3FE7\", source: \"Leviathan\" }\r\n525.7 \"Undersea Quake\" Ability { id: \"3FEE\", source: \"Leviathan\" }\r\n534.9 \"Black Smokers\" Ability { id: \"4007\", source: \"Leviathan\" }\r\n536.9 \"Spilling Wave x12\" duration 15 #Ability { id: \"4008\", source: \"Leviathan\" }\r\n540.9 \"Hydrothermal Vent x4\" duration 9 #Ability { id: \"4004\", source: \"Leviathan\" }\r\n544.4 \"Hot Water x5\" duration 9 #Ability { id: \"4005\", source: \"Leviathan\" }\r\n561.9 \"Temporary Current\" Ability { id: [\"3FEB\", \"3FEA\"], source: \"Leviathan\" }\r\n565.9 \"Temporary Current\" Ability { id: [\"3FEC\", \"3FED\"], source: \"Leviathan\" }\r\n576.9 \"Tidal Rage\" Ability { id: \"3FDE\", source: \"Leviathan\" }\r\n587.9 \"Tidal Rage\" Ability { id: \"3FDE\", source: \"Leviathan\" }\r\n604.9 \"The Calm\" Ability { id: \"4009\", source: \"Leviathan\" }\r\n617.9 \"Tidal Rage\" Ability { id: \"400B\", source: \"Leviathan\" }\r\n625.9 \"Tidal Rage\" Ability { id: \"400B\", source: \"Leviathan\" }\r\n633.9 \"Tidal Rage\" Ability { id: \"400B\", source: \"Leviathan\" }\r\n654.9 \"The Storm\" Ability { id: \"400D\", source: \"Leviathan\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e4n.ts


const e4n_triggerSet = {
  id: 'EdensGateSepulture',
  zoneId: zone_id/* default.EdensGateSepulture */.Z.EdensGateSepulture,
  timelineFile: 'e4n.txt',
  triggers: [{
    id: 'E4N Voice of the Land',
    type: 'StartsUsing',
    netRegex: {
      id: '40F7',
      source: 'Titan',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E4N Earthen Fury',
    type: 'StartsUsing',
    netRegex: {
      id: '40F8',
      source: 'Titan',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'E4N Stonecrusher',
    type: 'StartsUsing',
    netRegex: {
      id: '40F9',
      source: 'Titan'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E4N Massive Landslide',
    type: 'StartsUsing',
    netRegex: {
      id: '40FA',
      source: 'Titan',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand In Front',
        de: 'Vor ihm stehen',
        fr: 'Placez-vous devant',
        ja: 'Bossの前に',
        cn: '面前躲避',
        ko: '정면이 안전'
      }
    }
  }, {
    id: 'E4N Seismic Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '40F2',
      source: 'Massive Boulder',
      capture: false
    },
    delaySeconds: 6,
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Boulder',
        de: 'Hinter Felsen verstecken',
        fr: 'Cachez-vous derrière le rocher',
        ja: 'ボルダーの後ろに',
        cn: '躲在石头后',
        ko: '돌 뒤에 숨기'
      }
    }
  }, {
    id: 'E4N Geocrush',
    type: 'StartsUsing',
    netRegex: {
      id: '40F6',
      source: 'Titan',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback('info')
  }, {
    id: 'E4N Fault Zone',
    type: 'StartsUsing',
    netRegex: {
      id: '4102',
      source: 'Titan',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand On Flank',
        de: 'Auf seiner Flanke stehen',
        fr: 'Placez-vous sur le flanc',
        ja: '横へ',
        cn: '两侧躲避',
        ko: '넓은쪽 옆면이 안전'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bomb Boulder': 'Bomber-Brocken',
      'Massive Boulder': 'Riesig(?:e|er|es|en) Felsen',
      'Titan': 'Titan'
    },
    'replaceText': {
      'Bomb Boulders': 'Tumulus',
      'Bury': 'Begraben',
      'Cobalt Bomb': 'Kobaltbombe',
      'Crumbling Down': 'Felsfall',
      'Earthen Armor': 'Basaltpanzer',
      'Earthen Fury': 'Gaias Zorn',
      'Earthen Gauntlets': 'Gaia-Armberge',
      'Earthen Wheels': 'Gaia-Räder',
      'Evil Earth': 'Grimm der Erde',
      'Explosion': 'Explosion',
      'Fault Zone': 'Bruchzone',
      'Geocrush': 'Kraterschlag',
      'Left/Right Landslide': 'Linker/Rechter Bergsturz',
      'Magnitude 5.0': 'Magnitude 5.0',
      'Massive Landslide': 'Gigantischer Bergsturz',
      'Seismic Wave': 'Seismische Welle',
      'Stonecrusher': 'Felsbrecher',
      'Voice Of The Land': 'Aufschrei der Erde',
      'Weight Of The Land': 'Gaias Gewicht'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bomb Boulder': 'Bombo Rocher',
      'Massive Boulder': 'Monolithe géant',
      'Titan': 'Titan'
    },
    'replaceText': {
      '\\?': ' ?',
      'Bomb Boulders': 'Bombo rocher',
      'Bury': 'Ensevelissement',
      'Cobalt Bomb': 'Bombo de cobalt',
      'Crumbling Down': 'Chute de monolithes',
      'Earthen Armor': 'Armure tellurique',
      'Earthen Fury': 'Fureur tellurique',
      'Earthen Gauntlets': 'Poing tellurique',
      'Earthen Wheels': 'Pas tellurique',
      'Evil Earth': 'Terre maléfique',
      'Explosion': 'Explosion',
      'Fault Zone': 'Faille tectonique',
      'Geocrush': 'Broie-terre',
      'Left/Right Landslide': 'Glissement senestre/dextre',
      'Magnitude 5.0': 'Magnitude 5',
      'Massive Landslide': 'Glissement apocalyptique',
      'Seismic Wave': 'Ondes sismiques',
      'Stonecrusher': 'Éruption tellurique',
      'Voice of the Land': 'Hurlement tellurique',
      'Weight of the Land': 'Poids de la terre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bomb Boulder': 'ボムボルダー',
      'Massive Boulder': 'ジャイアントボルダー',
      'Titan': 'タイタン'
    },
    'replaceText': {
      'Bomb Boulders': 'ボムボルダー',
      'Bury': '衝撃',
      'Cobalt Bomb': 'コバルトボム',
      'Crumbling Down': '岩盤崩落',
      'Earthen Armor': '大地の鎧',
      'Earthen Fury': '大地の怒り',
      'Earthen Gauntlets': '大地の手甲',
      'Earthen Wheels': '大地の車輪',
      'Evil Earth': 'イビルアース',
      'Explosion': '爆散',
      'Fault Zone': 'フォールトゾーン',
      'Geocrush': 'ジオクラッシュ',
      'Left/Right Landslide': 'レフト/ライト・ランドスライド',
      'Magnitude 5.0': 'マグニチュード5.0',
      'Massive Landslide': 'メガ・ランドスライド',
      'Seismic Wave': 'サイズミックウェーブ',
      'Stonecrusher': 'ロッククラッシュ',
      'Voice of the Land': '大地の叫び',
      'Weight of the Land': '大地の重み'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bomb Boulder': '爆破岩石',
      'Massive Boulder': '巨大岩石',
      'Titan': '泰坦'
    },
    'replaceText': {
      'Bomb Boulders': '爆破岩石',
      'Bury': '塌方',
      'Cobalt Bomb': '钴弹',
      'Crumbling Down': '岩层崩落',
      'Earthen Armor': '大地之铠',
      'Earthen Fury': '大地之怒',
      'Earthen Gauntlets': '大地之手甲',
      'Earthen Wheels': '大地之车轮',
      'Evil Earth': '邪土',
      'Explosion': '爆炸',
      'Fault Zone': '断裂带',
      'Geocrush': '大地粉碎',
      'Left/Right Landslide': '左/右侧地裂',
      'Magnitude 5.0': '震级5.0',
      'Massive Landslide': '百万地裂',
      'Seismic Wave': '地震波',
      'Stonecrusher': '崩岩',
      'Voice of the Land': '大地之号',
      'Weight of the Land': '大地之重'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bomb Boulder': '바위폭탄',
      'Massive Boulder': '거대 바위',
      'Titan': '타이탄'
    },
    'replaceText': {
      'Bomb Boulders': '바위폭탄',
      'Bury': '충격',
      'Cobalt Bomb': '코발트 폭탄',
      'Crumbling Down': '암반 낙하',
      'Earthen Armor': '대지의 갑옷',
      'Earthen Fury': '대지의 분노',
      'Earthen Gauntlets': '대지의 완갑',
      'Earthen Wheels': '대지의 바퀴',
      'Evil Earth': '사악한 대지',
      'Explosion': '폭산',
      'Fault Zone': '단층대',
      'Geocrush': '대지 붕괴',
      'Left/Right Landslide': '좌/우측 산사태',
      'Magnitude 5.0': '진도 5.0',
      'Massive Landslide': '대규모 산사태',
      'Seismic Wave': '지진파',
      'Stonecrusher': '암석 붕괴',
      'Voice of the Land': '대지의 외침',
      'Weight of the Land': '대지의 무게'
    }
  }]
};
/* harmony default export */ const e4n = (e4n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e4n.txt
const raid_e4n_namespaceObject = "### Eden 4 (Normal)\r\n# Eden's Gate: Sepulture\r\n# -p 40F7:13 -ii 413D 40EF 41B4 40FC 40FB 40ED 40F0 43E6 40EB 40FE 4101 4103 40F1 40FD\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Earthen Armor\"\r\nhideall \"Earthen Gauntlets\"\r\nhideall \"Earthen Wheels\"\r\n\r\n# Phase chart\r\n# 1->2->3->\r\n#    4A->5A->6A->3A->loop to 4A\r\n#    6B->5B->4B->3B->loop to 6B\r\n# Numbered phases are the same, A and B are the different paths.\r\n\r\n### Phase 1\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n13.0 \"Voice Of The Land\" Ability { id: \"40F7\", source: \"Titan\" } window 13,8\r\n21.3 \"Evil Earth\" Ability { id: \"40EE\", source: \"Titan\" }\r\n30.5 \"Weight Of The Land\" Ability { id: \"40EA\", source: \"Titan\" }\r\n41.6 \"Stonecrusher\" Ability { id: \"40F9\", source: \"Titan\" } window 30,30\r\n54.0 \"Crumbling Down\" Ability { id: \"40F2\", source: \"Massive Boulder\" }\r\n66.0 \"Seismic Wave\" Ability { id: \"40F3\", source: \"Titan\" }\r\n79.3 \"Geocrush\" Ability { id: \"40F6\", source: \"Titan\" }\r\n83.2 \"Earthen Gauntlets\" Ability { id: \"40E6\", source: \"Titan\" }\r\n91.3 \"Massive Landslide\" Ability { id: \"40FA\", source: \"Titan\" }\r\n97.1 \"Earthen Armor\" Ability { id: \"40E7\", source: \"Titan\" }\r\n\r\n\r\n### Phase 2\r\n109.1 \"Stonecrusher\" Ability { id: \"40F9\", source: \"Titan\" } window 30,30\r\n115.2 \"Bomb Boulders\" Ability { id: \"40EC\", source: \"Titan\" }\r\n116.2 \"Bury\" #Ability { id: \"4141\", source: \"Bomb Boulder\" }\r\n122.1 \"Cobalt Bomb\" Ability { id: \"40F4\", source: \"Titan\" }\r\n129.3 \"Explosion\" Ability { id: \"40F5\", source: \"Bomb Boulder\" }\r\n137.3 \"Voice Of The Land\" Ability { id: \"40F7\", source: \"Titan\" }\r\n149.7 \"Geocrush\" Ability { id: \"40F6\", source: \"Titan\" }\r\n153.6 \"Earthen Wheels\" Ability { id: \"40E8\", source: \"Titan\" }\r\n161.7 \"Fault Zone\" Ability { id: \"4102\", source: \"Titan\" }\r\n163.9 \"Earthen Armor\" Ability { id: \"40E9\", source: \"Titan\" }\r\n\r\n\r\n### Phase 3\r\n182.0 \"Earthen Fury\" Ability { id: \"40F8\", source: \"Titan\" }\r\n197.2 \"Stonecrusher\" Ability { id: \"40F9\", source: \"Titan\" } window 30,30\r\n203.4 \"Bomb Boulders\" Ability { id: \"40EC\", source: \"Titan\" }\r\n204.5 \"Bury\" #Ability { id: \"4141\", source: \"Bomb Boulder\" }\r\n206.5 \"Bury\" #Ability { id: \"4141\", source: \"Bomb Boulder\" }\r\n208.5 \"Bury\" #Ability { id: \"4141\", source: \"Bomb Boulder\" }\r\n209.9 \"Cobalt Bomb\" Ability { id: \"40F4\", source: \"Titan\" }\r\n217.4 \"Explosion\" Ability { id: \"40F5\", source: \"Bomb Boulder\" }\r\n221.2 \"Weight Of The Land\" Ability { id: \"40EA\", source: \"Titan\" }\r\n231.3 \"Voice Of The Land\" Ability { id: \"40F7\", source: \"Titan\" }\r\n244.6 \"Crumbling Down\" Ability { id: \"40F2\", source: \"Massive Boulder\" }\r\n245.7 \"Evil Earth\" Ability { id: \"40EE\", source: \"Titan\" }\r\n256.8 \"Seismic Wave\" Ability { id: \"40F3\", source: \"Titan\" }\r\n\r\n\r\n### Phase 4A or Phase 6B?\r\n267.0 \"Stonecrusher\" Ability { id: \"40F9\", source: \"Titan\" } window 30,30\r\n274.3 \"Geocrush\" Ability { id: \"40F6\", source: \"Titan\" }\r\n\r\n278.1 \"Earthen Gauntlets\" Ability { id: \"40E6\", source: \"Titan\" } window 30,30 jump 1278.1\r\n278.1 \"Earthen Wheels\" Ability { id: \"40E8\", source: \"Titan\" } window 30,30 jump 2278.1\r\n\r\n286.2 \"Massive Landslide?\"\r\n288.2 \"Fault Zone?\"\r\n295.8 \"Fault Zone?\"\r\n300.8 \"Left/Right Landslide?\"\r\n303.4 \"Fault Zone?\"\r\n311.4 \"Magnitude 5.0?\"\r\n314.6 \"Earthen Armor?\"\r\n315.4 \"Left/Right Landslide?\"\r\n327.7 \"Earthen Fury?\"\r\n\r\n\r\n### Phase 4A\r\n1267.0 \"Stonecrusher\" Ability { id: \"40F9\", source: \"Titan\" } window 30,30\r\n1274.3 \"Geocrush\" Ability { id: \"40F6\", source: \"Titan\" }\r\n1278.1 \"Earthen Gauntlets\" Ability { id: \"40E6\", source: \"Titan\" }\r\n1286.2 \"Massive Landslide\" Ability { id: \"40FA\", source: \"Titan\" }\r\n1300.8 \"Left/Right Landslide\" Ability { id: [\"40FF\", \"4100\"], source: \"Titan\" }\r\n1315.4 \"Left/Right Landslide\" Ability { id: [\"40FF\", \"4100\"], source: \"Titan\" }\r\n1324.1 \"Earthen Armor\" Ability { id: \"40E7\", source: \"Titan\" }\r\n\r\n\r\n### Phase 5A\r\n1339.3 \"Stonecrusher\" Ability { id: \"40F9\", source: \"Titan\" } window 30,30\r\n1345.5 \"Bomb Boulders\" Ability { id: \"40EC\", source: \"Titan\" }\r\n1346.5 \"Bury\" #Ability { id: \"4141\", source: \"Bomb Boulder\" }\r\n1350.6 \"Bury\" #Ability { id: \"4141\", source: \"Bomb Boulder\" }\r\n1361.9 \"Evil Earth\" Ability { id: \"40EE\", source: \"Titan\" }\r\n1373.0 \"Voice Of The Land\" Ability { id: \"40F7\", source: \"Titan\" }\r\n1382.3 \"Evil Earth\" Ability { id: \"40EE\", source: \"Titan\" }\r\n1392.5 \"Weight Of The Land\" Ability { id: \"40EA\", source: \"Titan\" }\r\n\r\n\r\n### Phase 6A\r\n1402.6 \"Stonecrusher\" Ability { id: \"40F9\", source: \"Titan\" } window 30,30\r\n1411.9 \"Geocrush\" Ability { id: \"40F6\", source: \"Titan\" }\r\n1415.6 \"Earthen Wheels\" Ability { id: \"40E8\", source: \"Titan\" }\r\n1423.8 \"Fault Zone\" Ability { id: \"4102\", source: \"Titan\" }\r\n1431.4 \"Fault Zone\" Ability { id: \"4102\", source: \"Titan\" }\r\n1439.0 \"Fault Zone\" Ability { id: \"4102\", source: \"Titan\" }\r\n1447.0 \"Magnitude 5.0\" Ability { id: \"4104\", source: \"Titan\" }\r\n1450.2 \"Earthen Armor\" Ability { id: \"40E9\", source: \"Titan\" }\r\n\r\n\r\n### Phase 3A Redux\r\n1463.3 \"Earthen Fury\" Ability { id: \"40F8\", source: \"Titan\" }\r\n1478.4 \"Stonecrusher\" Ability { id: \"40F9\", source: \"Titan\" } window 30,30\r\n1484.6 \"Bomb Boulders\" Ability { id: \"40EC\", source: \"Titan\" }\r\n1485.5 \"Bury\" #Ability { id: \"4141\", source: \"Bomb Boulder\" }\r\n1487.5 \"Bury\" #Ability { id: \"4141\", source: \"Bomb Boulder\" }\r\n1489.5 \"Bury\" #Ability { id: \"4141\", source: \"Bomb Boulder\" }\r\n1491.0 \"Cobalt Bomb\" Ability { id: \"40F4\", source: \"Titan\" }\r\n1498.6 \"Explosion\" Ability { id: \"40F5\", source: \"Bomb Boulder\" }\r\n1502.2 \"Weight Of The Land\" Ability { id: \"40EA\", source: \"Titan\" }\r\n1512.3 \"Voice Of The Land\" Ability { id: \"40F7\", source: \"Titan\" }\r\n1525.6 \"Crumbling Down\" Ability { id: \"40F2\", source: \"Massive Boulder\" }\r\n1526.8 \"Evil Earth\" Ability { id: \"40EE\", source: \"Titan\" }\r\n1537.9 \"Seismic Wave\" Ability { id: \"40F3\", source: \"Titan\" }\r\n\r\n\r\n### Phase 4A loop\r\n1548.0 \"Stonecrusher\" Ability { id: \"40F9\", source: \"Titan\" } window 50,50 jump 1267\r\n1555.2 \"Geocrush\"\r\n1559.0 \"Earthen Gauntlets\"\r\n1567.2 \"Massive Landslide\"\r\n1581.5 \"Left/Right Landslide\"\r\n1595.9 \"Left/Right Landslide\"\r\n1604.6 \"Earthen Armor\"\r\n\r\n\r\n\r\n\r\n### Phase 6B\r\n2267.0 \"Stonecrusher\" Ability { id: \"40F9\", source: \"Titan\" } window 30,30\r\n2274.3 \"Geocrush\" Ability { id: \"40F6\", source: \"Titan\" }\r\n2278.1 \"Earthen Wheels\" Ability { id: \"40E8\", source: \"Titan\" }\r\n2286.2 \"Fault Zone\" Ability { id: \"4102\", source: \"Titan\" }\r\n2293.8 \"Fault Zone\" Ability { id: \"4102\", source: \"Titan\" }\r\n2301.4 \"Fault Zone\" Ability { id: \"4102\", source: \"Titan\" }\r\n2309.4 \"Magnitude 5.0\" Ability { id: \"4104\", source: \"Titan\" }\r\n2312.6 \"Earthen Armor\" Ability { id: \"40E9\", source: \"Titan\" }\r\n\r\n\r\n### Phase 5B\r\n2329.4 \"Stonecrusher\" Ability { id: \"40F9\", source: \"Titan\" } window 30,30\r\n2335.4 \"Bomb Boulders\" Ability { id: \"40EC\", source: \"Titan\" }\r\n2336.4 \"Bury\" #Ability { id: \"4141\", source: \"Bomb Boulder\" }\r\n2340.4 \"Bury\" #Ability { id: \"4141\", source: \"Bomb Boulder\" }\r\n2351.5 \"Evil Earth\" Ability { id: \"40EE\", source: \"Titan\" }\r\n2362.4 \"Voice Of The Land\" Ability { id: \"40F7\", source: \"Titan\" }\r\n2371.5 \"Evil Earth\" Ability { id: \"40EE\", source: \"Titan\" }\r\n2381.5 \"Weight Of The Land\" Ability { id: \"40EA\", source: \"Titan\" }\r\n\r\n\r\n### Phase 4B\r\n2391.4 \"Stonecrusher\" Ability { id: \"40F9\", source: \"Titan\" } window 30,30\r\n2400.4 \"Geocrush\" Ability { id: \"40F6\", source: \"Titan\" }\r\n2404.2 \"Earthen Gauntlets\" Ability { id: \"40E6\", source: \"Titan\" }\r\n2412.3 \"Massive Landslide\" Ability { id: \"40FA\", source: \"Titan\" }\r\n2426.9 \"Left/Right Landslide\" Ability { id: [\"40FF\", \"4100\"], source: \"Titan\" }\r\n2441.5 \"Left/Right Landslide\" Ability { id: [\"40FF\", \"4100\"], source: \"Titan\" }\r\n2450.1 \"Earthen Armor\" Ability { id: \"40E7\", source: \"Titan\" }\r\n\r\n\r\n### Phase 3B Redux\r\n2461.2 \"Earthen Fury\" Ability { id: \"40F8\", source: \"Titan\" }\r\n2476.2 \"Stonecrusher\" Ability { id: \"40F9\", source: \"Titan\" } window 30,30\r\n2482.8 \"Bomb Boulders\" Ability { id: \"40EC\", source: \"Titan\" }\r\n2483.8 \"Bury\" #Ability { id: \"4141\", source: \"Bomb Boulder\" }\r\n2485.8 \"Bury\" #Ability { id: \"4141\", source: \"Bomb Boulder\" }\r\n2487.8 \"Bury\" #Ability { id: \"4141\", source: \"Bomb Boulder\" }\r\n2489.4 \"Cobalt Bomb\" Ability { id: \"40F4\", source: \"Titan\" }\r\n2496.8 \"Explosion\" Ability { id: \"40F5\", source: \"Bomb Boulder\" }\r\n2500.6 \"Weight Of The Land\" Ability { id: \"40EA\", source: \"Titan\" }\r\n2510.5 \"Voice Of The Land\" Ability { id: \"40F7\", source: \"Titan\" }\r\n2523.5 \"Crumbling Down\" Ability { id: \"40F2\", source: \"Massive Boulder\" }\r\n2524.6 \"Evil Earth\" Ability { id: \"40EE\", source: \"Titan\" }\r\n2535.5 \"Seismic Wave\" Ability { id: \"40F3\", source: \"Titan\" }\r\n\r\n\r\n### Phase 6B Loop\r\n2545.5 \"Stonecrusher\" Ability { id: \"40F9\", source: \"Titan\" } window 50,50 jump 2267\r\n2554.8 \"Geocrush\"\r\n2558.5 \"Earthen Wheels\"\r\n2566.7 \"Fault Zone\"\r\n2574.3 \"Fault Zone\"\r\n2581.9 \"Fault Zone\"\r\n2589.9 \"Magnitude 5.0\"\r\n2593.1 \"Earthen Armor\"\r\n2606.2 \"Earthen Fury\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e4s.ts





// TODO: who the tank charge is on?

const e4s_triggerSet = {
  id: 'EdensGateSepultureSavage',
  zoneId: zone_id/* default.EdensGateSepultureSavage */.Z.EdensGateSepultureSavage,
  timelineFile: 'e4s.txt',
  initData: () => {
    return {
      plateFracture: [],
      gaolPlayers: [],
      gaolPlayerCount: 0
    };
  },
  timelineTriggers: [{
    id: 'E4S Earthen Anguish',
    regex: /Earthen Anguish/,
    beforeSeconds: 3,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.tankBusters */.Z.tankBusters
    }
  }],
  triggers: [{
    id: 'E4S Earthen Gauntlets',
    type: 'Ability',
    netRegex: {
      id: '40E6',
      source: 'Titan',
      capture: false
    },
    run: data => {
      data.phase = 'landslide';
      delete data.printedBury;
    }
  }, {
    id: 'E4S Earthen Armor',
    type: 'Ability',
    netRegex: {
      id: ['40E7', '40E9'],
      source: 'Titan',
      capture: false
    },
    run: data => {
      data.phase = 'armor';
      delete data.printedBury;
    }
  }, {
    id: 'E4S Stonecrusher',
    type: 'StartsUsing',
    netRegex: {
      id: '4116',
      source: 'Titan'
    },
    // As this seems to usually seems to be invulned,
    // don't make a big deal out of it.
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'E4S Pulse of the Land',
    type: 'HeadMarker',
    netRegex: {
      id: '00B9'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Yellow Spread',
        de: 'Gelb Verteilen',
        fr: 'Dispersion des jaunes',
        cn: '黄标分散',
        ko: '노란색 산개'
      }
    }
  }, {
    id: 'E4S Evil Earth',
    type: 'StartsUsing',
    netRegex: {
      id: '410C',
      source: 'Titan',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look for Evil Earth Marker',
        de: 'Schau nach den Grimm der Erde Marker',
        fr: 'Repérez une marque de Terre maléfique',
        ja: '範囲見て',
        cn: '观察地板',
        ko: '사악한 대지 패턴 확인'
      }
    }
  }, {
    id: 'E4S Force of the Land',
    type: 'HeadMarker',
    netRegex: {
      id: '00BA'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Orange Stack',
        de: 'Orange Sammeln',
        fr: 'Package des oranges',
        cn: '橙标分摊',
        ko: '주황색 쉐어'
      }
    }
  }, {
    id: 'E4S Voice of the Land',
    type: 'StartsUsing',
    netRegex: {
      id: '4114',
      source: 'Titan',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E4S Geocrush',
    type: 'StartsUsing',
    netRegex: {
      id: '4113',
      source: 'Titan',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'E4S Massive Landslide - Front',
    type: 'Ability',
    netRegex: {
      id: '40E6',
      source: 'Titan',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Landslide: In Front',
        de: 'Armberge: Vor ihm',
        fr: 'Glissement : Devant',
        ja: 'ランスラ: 正面へ',
        cn: '面前躲避',
        ko: '완갑: 정면'
      }
    }
  }, {
    id: 'E4S Massive Landslide - Sides',
    type: 'Ability',
    netRegex: {
      id: '4117',
      source: 'Titan',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides('info')
  }, {
    id: 'E4S Landslide',
    type: 'StartsUsing',
    netRegex: {
      id: '411A',
      source: 'Titan',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Back Corners',
        de: 'Hintere Ecken',
        fr: 'Coins arrière',
        ja: 'ランスラくるよ',
        cn: '后方角落',
        ko: '뒤쪽 구석으로'
      }
    }
  }, {
    id: 'E4S Crumbling Down',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bomb on YOU',
        de: 'Bombe auf DIR',
        fr: 'Bombe sur VOUS',
        ja: 'マーカーついた',
        cn: '炸弹点名',
        ko: '거리감쇠 징 대상자'
      }
    }
  }, {
    // Bomb positions are all x = (86 west, 100 mid, 114 east), y = (86, 100, 114).
    // Note: as these may hit multiple people, there may be multiple lines for the same bomb.
    id: 'E4S Bury Directions',
    type: 'Ability',
    netRegex: {
      id: '4142',
      source: 'Bomb Boulder'
    },
    condition: data => !data.printedBury,
    durationSeconds: 7,
    alertText: (data, matches, output) => {
      const x = parseFloat(matches.x);
      const y = parseFloat(matches.y);
      if (data.phase === 'armor') {
        // Three line bombs (middle, e/w, w/e), with seismic wave.
        if (x < 95) {
          data.printedBury = true;
          return output.hideBehindEast();
        } else if (x > 105) {
          data.printedBury = true;
          return output.hideBehindWest();
        }
      } else if (data.phase === 'landslide') {
        // Landslide cardinals/corners + middle, followed by remaining 4.
        const xMiddle = x < 105 && x > 95;
        const yMiddle = y < 105 && y > 95;
        // Ignore middle point, which may come first.
        if (xMiddle && yMiddle) return;
        data.printedBury = true;
        if (!xMiddle && !yMiddle) {
          // Corners dropped first.  Cardinals safe.
          return output.goCardinalsFirst();
        }
        // Cardinals dropped first.  Corners safe.
        return output.goCornersFirst();
      }
    },
    outputStrings: {
      hideBehindEast: {
        en: 'Hide Behind East',
        de: 'Im Osten vestecken',
        fr: 'Cachez-vous derrière à l\'est',
        ja: '東',
        cn: '右边躲避',
        ko: '동쪽으로'
      },
      hideBehindWest: {
        en: 'Hide Behind West',
        de: 'Im Westen vestecken',
        fr: 'Cachez-vous derrière à l\'ouest',
        ja: '西',
        cn: '左边躲避',
        ko: '서쪽으로'
      },
      goCardinalsFirst: {
        en: 'Go Cardinals First',
        de: 'Zuerst zu den Seiten gehen',
        fr: 'Allez aux cardinaux en premier',
        ja: 'まずは十字',
        cn: '十字',
        ko: '먼저 측면으로 이동'
      },
      goCornersFirst: {
        en: 'Go Corners First',
        de: 'Zuerst in die Ecken gehen',
        fr: 'Allez dans les coins en premier',
        ja: 'まずはコーナー',
        cn: '先去角落',
        ko: '먼저 구석으로 이동'
      }
    }
  }, {
    id: 'E4S Fault Line - Sides',
    type: 'Ability',
    netRegex: {
      id: '40E8',
      source: 'Titan',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Wheels: On Sides',
        de: 'Räder: Zur Seite',
        fr: 'Roues : Sur les côtés',
        ja: '車輪: 横へ',
        cn: '车轮：两侧',
        ko: '바퀴: 옆으로'
      }
    }
  }, {
    id: 'E4S Fault Line - Front',
    type: 'Ability',
    netRegex: {
      id: '411F',
      source: 'Titan',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank Charge',
        de: 'Tank wird angefahren',
        fr: 'Charge tank',
        ja: 'タンクに突進',
        cn: '坦克冲锋',
        ko: '탱커를 향해 돌진'
      }
    }
  }, {
    id: 'E4S Magnitude 5.0',
    type: 'StartsUsing',
    netRegex: {
      id: '4121',
      source: 'Titan',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'E4S Earthen Fury',
    type: 'StartsUsing',
    netRegex: {
      id: '4124',
      source: 'Titan Maximum',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe(),
    run: data => data.plateFracture = []
  }, {
    id: 'E4S Earthen Fury with Bleed',
    // applies 5C2 Filthy
    type: 'StartsUsing',
    netRegex: {
      id: '413A',
      source: 'Titan Maximum',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'E4S Earthen Fist - Left/Right',
    type: 'StartsUsing',
    netRegex: {
      id: '412F',
      source: 'Titan Maximum',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.leftThenRight */.Z.leftThenRight
    }
  }, {
    id: 'E4S Earthen Fist - Right/Left',
    type: 'StartsUsing',
    netRegex: {
      id: '4130',
      source: 'Titan Maximum',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.rightThenLeft */.Z.rightThenLeft
    }
  }, {
    id: 'E4S Earthen Fist - 2x Left',
    type: 'StartsUsing',
    netRegex: {
      id: '4131',
      source: 'Titan Maximum',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Left => Stay Left',
        de: 'Links, Links bleiben',
        fr: 'À gauche, puis restez',
        ja: 'ずっと左',
        cn: '一直在左',
        ko: '왼쪽 => 왼쪽'
      }
    }
  }, {
    id: 'E4S Earthen Fist - 2x Right',
    type: 'StartsUsing',
    netRegex: {
      id: '4132',
      source: 'Titan Maximum',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Right => Stay Right',
        de: 'Rechts, Rechts bleiben',
        fr: 'À droite, puis restez',
        ja: 'ずっと右',
        cn: '一直在右',
        ko: '오른쪽 => 오른쪽'
      }
    }
  }, {
    id: 'E4S Dual Earthen Fists',
    type: 'StartsUsing',
    netRegex: {
      id: '4135',
      source: 'Titan Maximum',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback('info')
  }, {
    id: 'E4S Weight of the World',
    type: 'HeadMarker',
    netRegex: {
      id: '00BB'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Blue Weight',
        de: 'Blau Gewicht',
        fr: 'Poids bleu',
        cn: '蓝标大陆之重',
        ko: '파란징 대륙의 무게'
      }
    }
  }, {
    id: 'E4S Megalith',
    type: 'HeadMarker',
    netRegex: {
      id: '005D'
    },
    alertText: (data, matches, output) => {
      if (data.role !== 'tank') return output.awayFromTanks();
      if (matches.target === data.me) return output.stackOnYou();
      return output.stackOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      awayFromTanks: {
        en: 'Away from Tanks',
        de: 'Weg von den Tanks',
        fr: 'Éloignez-vous des tanks',
        ja: 'タンクから離れ',
        cn: '远离坦克',
        ko: '탱커에서 멀어지기'
      },
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'E4S Granite Gaol Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '00BF'
    },
    run: (data, matches) => data.gaolPlayers.push(matches.target)
  }, {
    id: 'E4S Granite Gaol',
    type: 'HeadMarker',
    netRegex: {
      id: '00BF',
      capture: false
    },
    condition: data => data.gaolPlayers.length === 2 && data.gaolPlayers.includes(data.me),
    alarmText: (data, _matches, output) => {
      const [first, second] = data.gaolPlayers;
      const other = first === data.me ? second : first;
      return output.text({
        player: data.party.member(other)
      });
    },
    outputStrings: {
      text: {
        en: 'Gaol on YOU (w/${player})',
        de: 'Gefängnis auf DIR (mit ${player})',
        fr: 'Geôle sur VOUS (avec ${player})',
        cn: '石牢点名 (与${player})',
        ko: '돌감옥 대상자 (+${player})'
      }
    }
  }, {
    id: 'E4S Plate Fracture - Front Right',
    type: 'StartsUsing',
    netRegex: {
      id: '4125',
      source: 'Titan Maximum',
      capture: false
    },
    durationSeconds: 6,
    infoText: (data, _matches, output) => {
      const last = data.plateFracture[data.plateFracture.length - 1];
      if (data.plateFracture.length === 2 || last === 'backRight') return output.left();
      if (data.plateFracture.length === 1 || last === 'frontLeft') return output.back();
      return output.leftOrBack();
    },
    run: data => data.plateFracture.push('frontRight'),
    outputStrings: {
      leftOrBack: {
        en: 'Left (or Back)',
        de: 'Links (oder Hinten)',
        fr: 'Gauche (ou Arrière)',
        ja: '右前壊れるよ',
        // FIXME
        cn: '左 (或 后)',
        ko: '왼쪽 (또는 뒤)'
      },
      left: outputs/* default.left */.Z.left,
      back: outputs/* default.back */.Z.back
    }
  }, {
    id: 'E4S Plate Fracture - Back Right',
    type: 'StartsUsing',
    netRegex: {
      id: '4126',
      source: 'Titan Maximum',
      capture: false
    },
    durationSeconds: 6,
    infoText: (data, _matches, output) => {
      const last = data.plateFracture[data.plateFracture.length - 1];
      if (data.plateFracture.length === 2 || last === 'frontRight') return output.left();
      if (data.plateFracture.length === 1 || last === 'backLeft') return output.front();
      return output.leftOrFront();
    },
    run: data => data.plateFracture.push('backRight'),
    outputStrings: {
      leftOrFront: {
        en: 'Left (or Front)',
        de: 'Links (oder Vorne)',
        fr: 'Gauche (ou Devant)',
        ja: '右後ろ壊れるよ',
        // FIXME
        cn: '左 (或 前)',
        ko: '왼쪽 (또는 앞)'
      },
      left: outputs/* default.left */.Z.left,
      front: outputs/* default.front */.Z.front
    }
  }, {
    id: 'E4S Plate Fracture - Back Left',
    type: 'StartsUsing',
    netRegex: {
      id: '4127',
      source: 'Titan Maximum',
      capture: false
    },
    durationSeconds: 6,
    infoText: (data, _matches, output) => {
      const last = data.plateFracture[data.plateFracture.length - 1];
      if (data.plateFracture.length === 2 || last === 'frontLeft') return output.right();
      if (data.plateFracture.length === 1 || last === 'backRight') return output.front();
      return output.frontOrRight();
    },
    run: data => data.plateFracture.push('backLeft'),
    outputStrings: {
      frontOrRight: {
        en: 'Right (or Front)',
        de: 'Rechts (oder Vorne)',
        fr: 'Droite (ou Devant)',
        ja: '左後ろ壊れるよ',
        // FIXME
        cn: '右 (或 前)',
        ko: '오른쪽 (또는 앞)'
      },
      right: outputs/* default.right */.Z.right,
      front: outputs/* default.front */.Z.front
    }
  }, {
    id: 'E4S Plate Fracture - Front Left',
    type: 'StartsUsing',
    netRegex: {
      id: '4128',
      source: 'Titan Maximum',
      capture: false
    },
    durationSeconds: 6,
    infoText: (data, _matches, output) => {
      const last = data.plateFracture[data.plateFracture.length - 1];
      if (data.plateFracture.length === 2 || last === 'backLeft') return output.right();
      if (data.plateFracture.length === 1 || last === 'frontRight') return output.back();
      return output.backOrRight();
    },
    run: data => data.plateFracture.push('frontLeft'),
    outputStrings: {
      backOrRight: {
        en: 'Right (or Back)',
        de: 'Rechts (oder Hinten)',
        fr: 'Droite (ou Arrière)',
        ja: '左前壊れるよ',
        // FIXME
        cn: '右 (或 后)',
        ko: '오른쪽 (또는 뒤)'
      },
      right: outputs/* default.right */.Z.right,
      back: outputs/* default.back */.Z.back
    }
  }, {
    id: 'E4S Tumult',
    type: 'StartsUsing',
    netRegex: {
      id: '412A',
      source: 'Titan Maximum',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bomb Boulder': 'Bomber-Brocken',
      '(?<!Gigan)Titan': 'Titan',
      'Titan Maximum': 'Gigantitan'
    },
    'replaceText': {
      'Bomb Boulders': 'Tumulus',
      'Crumbling Down': 'Felsfall',
      'Dual Earthen Fists': 'Gaias Hammerfaust',
      'Earthen Anguish': 'Gaias Pein',
      'Earthen Armor': 'Basaltpanzer',
      '(?<! )Earthen Fist': 'Gaias Faust',
      'Earthen Fury': 'Gaias Zorn',
      'Earthen Gauntlets': 'Gaia-Armberge',
      'Earthen Wheels(?!/)': 'Gaia-Räder',
      'Earthen Wheels/Gauntlets': 'Gaia-Räder/Armberge',
      'Evil Earth': 'Grimm der Erde',
      'Force of the Land': 'Gaias Tosen',
      'Geocrush': 'Kraterschlag',
      '(?<! )Landslide': 'Bergsturz',
      'Magnitude 5.0': 'Magnitude 5.0',
      'Megalith': 'Megalithenbrecher',
      'Orogenesis': 'Orogenese',
      'Plate Fracture': 'Felsberster',
      'Pulse of the Land': 'Gaias Beben',
      'Right/Left Landslide': 'Rechter/Linker Bergsturz',
      'Rock Throw': 'Granitgefängnis',
      'Seismic Wave': 'Seismische Welle',
      'Stonecrusher': 'Felsbrecher',
      'Tectonic Uplift': 'Tektonische Hebung',
      'Tumult': 'Katastrophales Beben',
      'Voice of the Land': 'Aufschrei der Erde',
      'Weight of the Land': 'Gaias Gewicht',
      'Weight of the World': 'Schwere der Erde'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bomb Boulder': 'Bombo Rocher',
      'Titan(?! )': 'Titan',
      'Titan Maximum': 'Maxi Titan'
    },
    'replaceText': {
      '\\?': ' ?',
      'Bomb Boulders': 'Bombo rocher',
      'Crumbling Down': 'Chute de monolithes',
      'Dual Earthen Fists': 'Frappe de la terre',
      'Earthen Anguish': 'Peine de la terre',
      'Earthen Armor': 'Armure tellurique',
      '(?<! )Earthen Fist': 'Poing de la terre',
      'Earthen Fury': 'Fureur tellurique',
      'Earthen Gauntlets': 'Poing tellurique',
      'Earthen Wheels(?!/)': 'Pas tellurique',
      'Earthen Wheels/Gauntlets': 'Pas/Poing tellurique',
      'Evil Earth': 'Terre maléfique',
      'Force of the Land': 'Grondement tellurique',
      'Geocrush': 'Broie-terre',
      '(?<! )Landslide': 'Glissement de terrain',
      'Magnitude 5.0': 'Magnitude 5',
      'Megalith': 'Écrasement mégalithique',
      'Orogenesis': 'Orogenèse',
      'Plate Fracture': 'Fracture rocheuse',
      'Pulse of the Land': 'Vibration tellurique',
      'Right/Left Landslide': 'Glissement dextre/senestre',
      'Rock Throw': 'Jeté de rocs',
      'Seismic Wave': 'Ondes sismiques',
      'Stonecrusher': 'Éruption tellurique',
      'Tectonic Uplift': 'Soulèvement tectonique',
      'Tumult': 'Tumulte',
      'Voice of the Land': 'Hurlement tellurique',
      'Weight of the Land': 'Poids de la terre',
      'Weight of the World': 'Poids du monde'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bomb Boulder': 'ボムボルダー',
      'Titan(?! )': 'タイタン',
      'Titan Maximum': 'マキシタイタン'
    },
    'replaceText': {
      '\\?': '?',
      'Bomb Boulders': 'ボムボルダー',
      'Crumbling Down': '岩盤崩落',
      'Dual Earthen Fists': '大地の両拳',
      'Earthen Anguish': '大地の痛み',
      'Earthen Armor': '大地の鎧',
      '(?<! )Earthen Fist': '大地の拳',
      'Earthen Fury': '大地の怒り',
      'Earthen Gauntlets': '大地の手甲',
      'Earthen Wheels(?!/)': '大地の車輪',
      'Earthen Wheels/Gauntlets': '大地の車輪/手甲',
      'Evil Earth': 'イビルアース',
      'Force of the Land': '大地の轟き',
      'Geocrush': 'ジオクラッシュ',
      '(?<! )Landslide': 'ランドスライド',
      'Magnitude 5.0': 'マグニチュード5.0',
      'Megalith': 'メガリスクラッシュ',
      'Orogenesis': 'オーロジェニー',
      'Plate Fracture': 'ロックフラクチャー',
      'Pulse of the Land': '大地の響き',
      'Right/Left Landslide': 'レフト/ライト・ランドスライド',
      'Rock Throw': 'グラナイト・ジェイル',
      'Seismic Wave': 'サイズミックウェーブ',
      'Stonecrusher': 'ロッククラッシュ',
      'Tectonic Uplift': 'クラスタルアップリフト',
      'Tumult': '激震',
      'Voice of the Land': '大地の叫び',
      'Weight of the Land': '大地の重み',
      'Weight of the World': '大陸の重み'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bomb Boulder': '爆破岩石',
      'Titan(?! )': '泰坦',
      'Titan Maximum': '极大泰坦'
    },
    'replaceText': {
      'Bomb Boulders': '爆破岩石',
      'Crumbling Down': '岩层崩落',
      'Dual Earthen Fists': '大地之双拳',
      'Earthen Anguish': '大地之痛',
      'Earthen Armor': '大地之铠',
      '(?<! )Earthen Fist': '大地之拳',
      'Earthen Fury': '大地之怒',
      'Earthen Gauntlets': '大地之手甲',
      'Earthen Wheels(?!/)': '大地之车轮',
      'Earthen Wheels/Gauntlets': '大地之车轮/手甲',
      'Evil Earth': '邪土',
      'Force of the Land': '大地之轰',
      'Geocrush': '大地粉碎',
      '(?<! )Landslide': '地裂',
      'Magnitude 5.0': '震级5.0',
      'Megalith': '巨石',
      'Orogenesis': '造山',
      'Plate Fracture': '岩盘粉碎',
      'Pulse of the Land': '大地之响',
      'Right/Left Landslide': '右/左地裂',
      'Rock Throw': '花岗岩牢狱',
      'Seismic Wave': '地震波',
      'Stonecrusher': '崩岩',
      'Tectonic Uplift': '地壳上升',
      'Tumult': '怒震',
      'Voice of the Land': '大地之号',
      'Weight of the Land': '大地之重',
      'Weight of the World': '铁球'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bomb Boulder': '바위폭탄',
      'Titan(?! )': '타이탄',
      'Titan Maximum': '거대 타이탄'
    },
    'replaceText': {
      'Bomb Boulders': '바위폭탄',
      'Crumbling Down': '암반 낙하',
      'Dual Earthen Fists': '대지의 두 주먹',
      'Earthen Anguish': '대지의 고통',
      'Earthen Armor': '대지의 갑옷',
      '(?<! )Earthen Fist': '대지의 주먹',
      'Earthen Fury': '대지의 분노',
      'Earthen Gauntlets': '대지의 완갑',
      'Earthen Wheels(?!/)': '대지의 바퀴',
      'Earthen Wheels/Gauntlets': '대지의 바퀴/완갑',
      'Evil Earth': '사악한 대지',
      'Force of the Land': '대지의 고동',
      'Geocrush': '대지 붕괴',
      '(?<! )Landslide': '산사태',
      'Magnitude 5.0': '진도 5.0',
      'Megalith': '거석 붕괴',
      'Orogenesis': '조산 운동',
      'Plate Fracture': '지각판 파쇄',
      'Pulse of the Land': '대지의 울림',
      'Right/Left Landslide': '좌/우측 산사태',
      'Rock Throw': '화강암 감옥',
      'Seismic Wave': '지진파',
      'Stonecrusher': '암석 붕괴',
      'Tectonic Uplift': '지각 융기',
      'Tumult': '격진',
      'Voice of the Land': '대지의 외침',
      'Weight of the Land': '대지의 무게',
      'Weight of the World': '대륙의 무게'
    }
  }]
};
/* harmony default export */ const e4s = (e4s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e4s.txt
const raid_e4s_namespaceObject = "### Eden 4 (Savage)\r\n# Eden's Gate: Sepulture (Savage)\r\n# -p 4371:1000 4116:16 -ii 413C 413D 413E 4105 41B5 410C 411E 410A 4120 411F 410D 410F 4142 4117 4118 4119 411B 43E8 4136 4687 43CA 4134 4123 4129 4125 4127 4128 412B 412C 43C9 4133 46A4 46C6 44D0 4139 43E9 413B 413F 442E 427D\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Earthen Armor\"\r\nhideall \"Earthen Gauntlets\"\r\nhideall \"Earthen Wheels\"\r\n\r\n### Warmup\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11.0 \"--sync--\" StartsUsing { id: \"4116\", source: \"Titan\" } window 11,5\r\n16.0 \"Stonecrusher 1\" Ability { id: \"4116\", source: \"Titan\" }\r\n19.1 \"Stonecrusher 2\" #Ability { id: \"4143\", source: \"Titan\" }\r\n22.1 \"Stonecrusher 3\" #Ability { id: \"4143\", source: \"Titan\" }\r\n34.2 \"Weight of the Land\" Ability { id: \"4108\", source: \"Titan\" }\r\n37.2 \"Pulse of the Land\" Ability { id: \"4106\", source: \"Titan\" }\r\n39.5 \"Evil Earth\" Ability { id: \"410B\", source: \"Titan\" }\r\n48.4 \"Force of the Land\" Ability { id: \"4107\", source: \"Titan\" }\r\n54.6 \"Voice of the Land\" Ability { id: \"4114\", source: \"Titan\" }\r\n66.8 \"Geocrush\" Ability { id: \"4113\", source: \"Titan\" }\r\n\r\n70.5 \"Earthen Wheels/Gauntlets?\"\r\n70.5 \"--sync--\" Ability { id: \"40E8\", source: \"Titan\" } window 100,100 jump 270.5\r\n70.5 \"--sync--\" Ability { id: \"40E6\", source: \"Titan\" } window 100,100 jump 570.5\r\n\r\n### Wheels Path\r\n270.5 \"Earthen Wheels\" Ability { id: \"40E8\", source: \"Titan\" }\r\n277.7 \"Pulse of the Land\" Ability { id: \"4106\", source: \"Titan\" }\r\n277.7 \"Force of the Land\" Ability { id: \"4107\", source: \"Titan\" }\r\n286.0 \"Magnitude 5.0\" Ability { id: \"4121\", source: \"Titan\" } window 10,10\r\n289.1 \"Earthen Armor\" Ability { id: \"40E9\", source: \"Titan\" }\r\n291.0 \"Pulse of the Land\" Ability { id: \"4106\", source: \"Titan\" }\r\n307.2 \"Crumbling Down\" Ability { id: \"410E\", source: \"Titan\" }\r\n315.3 \"Bomb Boulders\" Ability { id: \"4109\", source: \"Titan\" }\r\n327.4 \"Seismic Wave\" Ability { id: \"4110\", source: \"Titan\" }\r\n340.7 \"Voice of the Land\" Ability { id: \"4114\", source: \"Titan\" }\r\n350.0 \"Stonecrusher 1\" Ability { id: \"4116\", source: \"Titan\" }\r\n353.1 \"Stonecrusher 2\" #Ability { id: \"4143\", source: \"Titan\" }\r\n356.1 \"Stonecrusher 3\" #Ability { id: \"4143\", source: \"Titan\" }\r\n372.4 \"Geocrush\" Ability { id: \"4113\", source: \"Titan\" }\r\n376.2 \"Earthen Gauntlets\" Ability { id: \"40E6\", source: \"Titan\" }\r\n382.6 \"Pulse of the Land\" Ability { id: \"4106\", source: \"Titan\" }\r\n382.6 \"Force of the Land\" Ability { id: \"4107\", source: \"Titan\" }\r\n396.7 \"Voice of the Land\" Ability { id: \"4114\", source: \"Titan\" }\r\n407.5 \"Landslide\" Ability { id: \"411A\", source: \"Titan\" }\r\n413.5 \"Right/Left Landslide\" Ability { id: \"411[CD]\", source: \"Titan\" }\r\n420.7 \"Earthen Armor\" Ability { id: \"40E7\", source: \"Titan\" }\r\n425.7 \"--untargetable--\"\r\n431.1 \"Orogenesis\" #Ability { id: \"4371\", source: \"Titan\" }\r\n\r\n\r\n### Gauntlets path\r\n570.5 \"Earthen Gauntlets\" Ability { id: \"40E6\", source: \"Titan\" }\r\n576.8 \"Force of the Land\" Ability { id: \"4107\", source: \"Titan\" }\r\n576.8 \"Pulse of the Land\" Ability { id: \"4106\", source: \"Titan\" }\r\n590.8 \"Voice of the Land\" Ability { id: \"4114\", source: \"Titan\" }\r\n601.5 \"Landslide\" Ability { id: \"411A\", source: \"Titan\" }\r\n607.5 \"Right/Left Landslide\" Ability { id: \"411[CD]\", source: \"Titan\" }\r\n614.7 \"Earthen Armor\" Ability { id: \"40E7\", source: \"Titan\" }\r\n632.9 \"Crumbling Down\" Ability { id: \"410E\", source: \"Titan\" }\r\n641.1 \"Bomb Boulders\" Ability { id: \"4109\", source: \"Titan\" }\r\n653.1 \"Seismic Wave\" Ability { id: \"4110\", source: \"Titan\" }\r\n666.4 \"Voice of the Land\" Ability { id: \"4114\", source: \"Titan\" }\r\n675.6 \"Stonecrusher 1\" Ability { id: \"4116\", source: \"Titan\" }\r\n678.7 \"Stonecrusher 2\" #Ability { id: \"4143\", source: \"Titan\" }\r\n681.8 \"Stonecrusher 3\" #Ability { id: \"4143\", source: \"Titan\" }\r\n698.1 \"Geocrush\" Ability { id: \"4113\", source: \"Titan\" }\r\n702.0 \"Earthen Wheels\" Ability { id: \"40E8\", source: \"Titan\" }\r\n709.0 \"Pulse of the Land\" Ability { id: \"4106\", source: \"Titan\" }\r\n709.0 \"Force of the Land\" Ability { id: \"4107\", source: \"Titan\" }\r\n717.6 \"Magnitude 5.0\" Ability { id: \"4121\", source: \"Titan\" } window 10,10\r\n720.7 \"Earthen Armor\" Ability { id: \"40E9\", source: \"Titan\" }\r\n722.6 \"Pulse of the Land\" Ability { id: \"4106\", source: \"Titan\" }\r\n725.8 \"--untargetable--\"\r\n730.5 \"Orogenesis\" #Ability { id: \"4371\", source: \"Titan\" }\r\n\r\n\r\n### Transition\r\n1000.0 \"Orogenesis\" Ability { id: \"4371\", source: \"Titan\" } window 1000,0\r\n1026.3 \"--targetable--\"\r\n1033.1 \"Earthen Fury\" Ability { id: \"4124\", source: \"Titan Maximum\" }\r\n1048.3 \"Earthen Fist\" Ability { id: [\"4130\", \"4131\", \"4132\", \"412F\"], source: \"Titan Maximum\" }\r\n1053.2 \"Weight of the Land\" Ability { id: \"4108\", source: \"Titan\" }\r\n1061.9 \"Dual Earthen Fists\" Ability { id: \"4135\", source: \"Titan Maximum\" }\r\n1065.9 \"Earthen Anguish\" Ability { id: \"4137\", source: \"Titan\" }\r\n1071.8 \"Megalith\" Ability { id: \"4138\", source: \"Titan Maximum\" }\r\n1088.0 \"Tectonic Uplift\" Ability { id: \"4122\", source: \"Titan Maximum\" } window 20,20\r\n1100.1 \"Force of the Land\" Ability { id: \"4107\", source: \"Titan\" }\r\n1100.1 \"Pulse of the Land\" Ability { id: \"4106\", source: \"Titan\" }\r\n1108.2 \"Earthen Fury\" Ability { id: \"4124\", source: \"Titan Maximum\" }\r\n1122.3 \"Rock Throw\" Ability { id: \"412D\", source: \"Titan Maximum\" }\r\n1135.1 \"Plate Fracture 1\" Ability { id: \"43EA\", source: \"Titan\" }\r\n1149.2 \"Plate Fracture 2\" Ability { id: \"43EA\", source: \"Titan\" }\r\n1162.4 \"Plate Fracture 3\" Ability { id: \"43EA\", source: \"Titan\" }\r\n1171.9 \"Earthen Fury\" Ability { id: \"4124\", source: \"Titan Maximum\" }\r\n1180.7 \"Tumult x5\" Ability { id: \"412A\", source: \"Titan Maximum\" } duration 6\r\n1197.4 \"Dual Earthen Fists\" Ability { id: \"4135\", source: \"Titan Maximum\" }\r\n1201.4 \"Earthen Anguish\" Ability { id: \"4137\", source: \"Titan\" }\r\n1208.3 \"Earthen Fist\" Ability { id: [\"4130\", \"4131\", \"4132\", \"412F\"], source: \"Titan Maximum\" }\r\n1225.7 \"Tectonic Uplift\" Ability { id: \"4122\", source: \"Titan Maximum\" }\r\n1226.6 \"Force of the Land\" Ability { id: \"4107\", source: \"Titan\" }\r\n1249.0 \"Pulse of the Land\" Ability { id: \"4106\", source: \"Titan\" }\r\n1263.2 \"Weight of the World\" Ability { id: \"442B\", source: \"Titan Maximum\" }\r\n1275.1 \"Force of the Land\" Ability { id: \"4107\", source: \"Titan\" }\r\n1283.4 \"Earthen Fury\" Ability { id: \"4124\", source: \"Titan Maximum\" }\r\n1292.2 \"Tumult x5\" Ability { id: \"412A\", source: \"Titan Maximum\" } duration 6\r\n1314.4 \"Plate Fracture 1\" Ability { id: \"43EA\", source: \"Titan\" }\r\n1324.0 \"Megalith\" Ability { id: \"4138\", source: \"Titan Maximum\" }\r\n1337.7 \"Plate Fracture 2\" Ability { id: \"43EA\", source: \"Titan\" }\r\n1340.7 \"Pulse of the Land\" Ability { id: \"4106\", source: \"Titan\" }\r\n1340.7 \"Force of the Land\" Ability { id: \"4107\", source: \"Titan\" }\r\n1349.1 \"Earthen Fury\" Ability { id: \"4124\", source: \"Titan Maximum\" }\r\n1359.3 \"--untargetable--\"\r\n\r\n1359.3 \"Orogenesis\" Ability { id: \"4372\", source: \"Titan Maximum\" } window 1500,1500\r\n1364.3 \"--targetable--\"\r\n1373.3 \"Earthen Fury\" Ability { id: \"413A\", source: \"Titan Maximum\" }\r\n1392.6 \"Force of the Land\" Ability { id: \"4107\", source: \"Titan\" }\r\n1392.6 \"Pulse of the Land\" Ability { id: \"4106\", source: \"Titan\" }\r\n1401.9 \"Dual Earthen Fists\" Ability { id: \"4135\", source: \"Titan Maximum\" }\r\n1406.0 \"Earthen Anguish\" Ability { id: \"4137\", source: \"Titan\" }\r\n1414.6 \"Voice of the Land\" Ability { id: \"4114\", source: \"Titan\" }\r\n1417.4 \"Tumult x5\" Ability { id: \"412A\", source: \"Titan Maximum\" } duration 6\r\n1426.9 \"Voice of the Land\" Ability { id: \"4114\", source: \"Titan\" }\r\n1438.1 \"Earthen Fury\" Ability { id: \"413A\", source: \"Titan Maximum\" }\r\n1457.3 \"Pulse of the Land\" Ability { id: \"4106\", source: \"Titan\" }\r\n1457.3 \"Force of the Land\" Ability { id: \"4107\", source: \"Titan\" }\r\n1468.4 \"Earthen Fist\" Ability { id: [\"4130\", \"4131\", \"4132\", \"412F\"], source: \"Titan Maximum\" }\r\n1479.5 \"Stonecrusher 1\" Ability { id: \"4116\", source: \"Titan\" }\r\n1482.6 \"Stonecrusher 2\" #Ability { id: \"4143\", source: \"Titan\" }\r\n1485.7 \"Stonecrusher 3\" #Ability { id: \"4143\", source: \"Titan\" }\r\n1491.8 \"Megalith\" Ability { id: \"4138\", source: \"Titan Maximum\" }\r\n1504.1 \"Earthen Fury\" Ability { id: \"413A\", source: \"Titan Maximum\" }\r\n1523.4 \"Pulse of the Land\" Ability { id: \"4106\", source: \"Titan\" }\r\n1523.4 \"Force of the Land\" Ability { id: \"4107\", source: \"Titan\" }\r\n1534.3 \"Earthen Fist\" Ability { id: [\"4130\", \"4131\", \"4132\", \"412F\"], source: \"Titan Maximum\" }\r\n1543.4 \"Voice of the Land\" Ability { id: \"4114\", source: \"Titan\" }\r\n1546.2 \"Tumult x5\" Ability { id: \"412A\", source: \"Titan Maximum\" } duration 6\r\n1555.6 \"Voice of the Land\" Ability { id: \"4114\", source: \"Titan\" }\r\n1558.4 \"Tumult x5\" Ability { id: \"412A\", source: \"Titan Maximum\" } duration 6\r\n1567.9 \"Voice of the Land\" Ability { id: \"4114\", source: \"Titan\" }\r\n1581.1 \"Earthen Fury Enrage\" Ability { id: \"4140\", source: \"Titan Maximum\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e5n.ts



const e5n_triggerSet = {
  id: 'EdensVerseFulmination',
  zoneId: zone_id/* default.EdensVerseFulmination */.Z.EdensVerseFulmination,
  timelineFile: 'e5n.txt',
  triggers: [{
    id: 'E5N Surge Protection Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8B4'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.surgeProtection = true
  }, {
    id: 'E5N Surge Protection Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '8B4'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.surgeProtection = false
  }, {
    id: 'E5N Crippling Blow',
    type: 'StartsUsing',
    netRegex: {
      id: '4BA3',
      source: 'Ramuh'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E5N Stratospear Summons',
    type: 'Ability',
    netRegex: {
      id: '4B8D',
      source: 'Ramuh',
      capture: false
    },
    delaySeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look for small spear',
        de: 'Halt nach kleinem Speer ausschau',
        fr: 'Allez sur la petite lance',
        ja: '低い杖を探す',
        cn: '找短矛',
        ko: '작은 지팡이 확인'
      }
    }
  }, {
    id: 'E5N Tribunal Summons',
    type: 'StartsUsing',
    netRegex: {
      id: '4B91',
      source: 'Ramuh',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look for adds',
        de: 'Halt nach dem Add ausschau',
        fr: 'Cherchez les adds',
        ja: '雑魚に注意',
        cn: '注意小怪',
        ko: '쫄 위치 확인'
      }
    }
  }, {
    id: 'E5N Fury\'s Bolt',
    type: 'StartsUsing',
    netRegex: {
      id: '4B90',
      source: 'Ramuh',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fury\'s Bolt',
        de: 'Wütender Blitz',
        fr: 'Boule de foudre',
        ja: 'チャージボルト',
        cn: '蓄雷',
        ko: '라무 강화'
      }
    }
  }, {
    id: 'E5N Judgment Volts',
    type: 'StartsUsing',
    netRegex: {
      id: ['4B98', '4B9A'],
      source: 'Ramuh',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E5N Divine Judgment Volts',
    type: 'StartsUsing',
    netRegex: {
      id: '4B9A',
      source: 'Ramuh',
      capture: false
    },
    condition: data => !data.surgeProtection,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Grab an orb',
        de: 'Einen Orb nehmen',
        fr: 'Prenez un orbe',
        ja: '雷玉を取る',
        cn: '吃球',
        ko: '구슬 줍기'
      }
    }
  }, {
    id: 'E5N Stormcloud',
    type: 'HeadMarker',
    netRegex: {
      id: '006E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop cloud outside',
        de: 'Wolken draußen ablegen',
        fr: 'Déposez le nuage à l\'extérieur',
        ja: '外に雷雲を捨てる',
        cn: '外侧放雷云',
        ko: '바깥으로 구름 유도'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Ramuh': 'Ramuh',
      'Will Of Ramuh': 'Ramuh-Spiegelung',
      'Will Of Ixion': 'Ixion-Spiegelung'
    },
    'replaceText': {
      'Volt Strike': 'Voltschlag',
      'Tribunal Summons': 'Gedankenentstehung',
      'Thunderstorm': 'Gewitter',
      'Stratospear Summons': 'Stromgenerierung',
      'Stormcloud Summons': 'Elektrizitätsgenerierung',
      '(?<! )Judgment Volts': 'Gewitter des Urteils',
      'Judgment Jolt': 'Blitz des Urteils',
      'Impact': 'Impakt',
      'Gallop': 'Galopp',
      'Fury\'s Bolt': 'Wütender Blitz',
      'Divine Judgment Volts': 'Göttliches Gewitter des Urteils',
      'Deadly Discharge': 'Tödliche Entladung',
      'Crippling Blow': 'Verkrüppelnder Schlag'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ramuh': 'Ramuh',
      'Will Of Ramuh': 'Réplique de Ramuh',
      'Will Of Ixion': 'Réplique d\'Ixion'
    },
    'replaceText': {
      'Volt Strike': 'Frappe d\'éclair',
      'Tribunal Summons': 'Manifestations de l\'esprit',
      'Thunderstorm': 'Tempête de foudre',
      'Stratospear Summons': 'Conjuration de dards',
      'Stormcloud Summons': 'Nuage d\'orage',
      '(?<! )Judgment Volts': 'Éclair de chaleur du jugement',
      'Judgment Jolt': 'Front orageux du jugement',
      'Impact': 'Impact',
      'Gallop': 'Galop',
      'Fury\'s Bolt': 'Boules de foudre',
      'Divine Judgment Volts': 'Éclair de chaleur du jugement impérial',
      'Deadly Discharge': 'Décharge mortelle',
      'Crippling Blow': 'Coup handicapant'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '(?<! )Ramuh': 'ラムウ',
      'Will Of Ramuh': 'ラムウ・ミラージュ',
      'Will Of Ixion': 'イクシオン・ミラージュ'
    },
    'replaceText': {
      'Volt Strike': 'ボルトストライク',
      'Tribunal Summons': '思念体生成',
      'Thunderstorm': 'サンダーストーム',
      'Stratospear Summons': '武具生成',
      'Stormcloud Summons': '雷雲生成',
      '(?<! )Judgment Volts': '裁きの熱雷',
      'Judgment Jolt': '裁きの界雷',
      'Impact': '衝撃',
      'Gallop': 'ギャロップ',
      'Fury\'s Bolt': 'チャージボルト',
      'Divine Judgment Volts': '裁きの熱雷・天帝',
      'Deadly Discharge': 'デッドリーディスチャージ',
      'Crippling Blow': '痛打'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '(?<! )Ramuh': '拉姆',
      'Will Of Ramuh': '拉姆幻影',
      'Will Of Ixion': '伊克西翁幻影'
    },
    'replaceText': {
      'Crippling Blow': '痛击',
      'Stratospear Summons': '生成武具',
      'Impact': '冲击',
      'Judgment Jolt': '制裁之界雷',
      'Stormcloud Summons': '生成雷暴云',
      '(?<! )Judgment Volts': '制裁之热雷',
      'Fury\'s Bolt': '蓄雷',
      'Divine Judgment Volts': '制裁之热雷·天帝',
      'Tribunal Summons': '生成幻影',
      'Deadly Discharge': '死亡冲锋',
      'Gallop': '飞驰',
      'Thunderstorm': '雷暴',
      'Volt Strike': '雷电强袭'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '(?<! )Ramuh': '라무',
      'Will Of Ramuh': '라무의 환영',
      'Will Of Ixion': '익시온의 환영'
    },
    'replaceText': {
      'Crippling Blow': '통타',
      'Stratospear Summons': '무기 생성',
      'Impact': '충격',
      'Judgment Jolt': '심판의 계뢰',
      'Stormcloud Summons': '번개구름 생성',
      '(?<! )Judgment Volts': '심판의 열뢰',
      'Fury\'s Bolt': '번개 충전',
      'Divine Judgment Volts': '천제의 심판의 열뢰',
      'Tribunal Summons': '사념체 생성',
      'Deadly Discharge': '죽음의 방전',
      'Gallop': '습보',
      'Thunderstorm': '번개 폭풍',
      'Volt Strike': '전기 충격'
    }
  }]
};
/* harmony default export */ const e5n = (e5n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e5n.txt
const raid_e5n_namespaceObject = "### Eden 5 (Normal)\r\n# Eden's Verse: Fulmination\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# ic \"Stormcloud\" -ii 4B8F 4B93 4B97 4B99 4B9A 4BA1 4BA2\r\n\r\n# Opening block\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n13.6 \"Crippling Blow\" Ability { id: \"4BA3\", source: \"Ramuh\" } window 15,15\r\n20.9 \"--sync--\" Ability { id: \"4BCB\", source: \"Ramuh\" }\r\n26.8 \"Stratospear Summons\" Ability { id: \"4B8D\", source: \"Ramuh\" } window 30,30\r\n31.7 \"Impact\" Ability { id: \"4E3A\", source: \"Ramuh\" }\r\n38.7 \"Judgment Jolt\" Ability { id: \"4B8E\", source: \"Ramuh\" }\r\n47.8 \"Stormcloud Summons\" Ability { id: \"4B9B\", source: \"Ramuh\" }\r\n63.3 \"Judgment Volts\" Ability { id: \"4B98\", source: \"Ramuh\" }\r\n75.5 \"Crippling Blow\" Ability { id: \"4BA3\", source: \"Ramuh\" } window 30,30\r\n84.8 \"Fury's Bolt\" Ability { id: \"4B90\", source: \"Ramuh\" }\r\n93.9 \"Divine Judgment Volts\" Ability { id: \"4E62\", source: \"Ramuh\" }\r\n107.1 \"Tribunal Summons\" Ability { id: \"4B91\", source: \"Ramuh\" }\r\n114.6 \"Deadly Discharge\" Ability { id: \"4B92\", source: \"Will Of Ramuh\" }\r\n123.7 \"Tribunal Summons\" Ability { id: \"4B91\", source: \"Ramuh\" }\r\n131.2 \"Gallop\" Ability { id: \"4B96\", source: \"Will Of Ixion\" }\r\n\r\n#Training block\r\n137.3 \"--sync--\" Ability { id: \"4BCB\", source: \"Ramuh\" }\r\n143.3 \"Stratospear Summons\" Ability { id: \"4B8D\", source: \"Ramuh\" }\r\n148.2 \"Impact\" Ability { id: \"4E3A\", source: \"Ramuh\" }\r\n155.2 \"Judgment Jolt\" Ability { id: \"4B8E\", source: \"Ramuh\" } window 30,30\r\n164.4 \"Fury's Bolt\" Ability { id: \"4B90\", source: \"Ramuh\" }\r\n173.5 \"Divine Judgment Volts\" Ability { id: \"4E62\", source: \"Ramuh\" }\r\n181.7 \"Thunderstorm\" Ability { id: \"4BA0\", source: \"Ramuh\" } window 30,30\r\n192.1 \"Volt Strike\" Ability { id: \"4CF2\", source: \"Ramuh\" }\r\n199.1 \"Volt Strike\" Ability { id: \"4CF2\", source: \"Ramuh\" }\r\n211.1 \"Stormcloud Summons\" Ability { id: \"4B9B\", source: \"Ramuh\" } window 30,30\r\n221.6 \"Tribunal Summons\" Ability { id: \"4B91\", source: \"Ramuh\" }\r\n229.0 \"Deadly Discharge\" Ability { id: \"4B92\", source: \"Will Of Ramuh\" }\r\n244.1 \"Thunderstorm\" Ability { id: \"4BA0\", source: \"Ramuh\" } window 30,30\r\n251.5 \"Tribunal Summons\" Ability { id: \"4B91\", source: \"Ramuh\" }\r\n254.5 \"Volt Strike\" Ability { id: \"4CF2\", source: \"Ramuh\" }\r\n261.0 \"Gallop\" Ability { id: \"4B96\", source: \"Will Of Ixion\" }\r\n261.6 \"Volt Strike\" Ability { id: \"4CF2\", source: \"Ramuh\" }\r\n272.0 \"Crippling Blow\" Ability { id: \"4BA3\", source: \"Ramuh\" } window 30,30\r\n\r\n#Rotation block\r\n279.3 \"--sync--\" Ability { id: \"4BCB\", source: \"Ramuh\" } window 30,30\r\n285.2 \"Stratospear Summons\" Ability { id: \"4B8D\", source: \"Ramuh\" }\r\n290.1 \"Impact\" Ability { id: \"4E3A\", source: \"Ramuh\" }\r\n293.6 \"Stormcloud Summons\" Ability { id: \"4B9B\", source: \"Ramuh\" }\r\n303.1 \"Judgment Jolt\" Ability { id: \"4B8E\", source: \"Ramuh\" }\r\n311.3 \"Fury's Bolt\" Ability { id: \"4B90\", source: \"Ramuh\" }\r\n320.4 \"Divine Judgment Volts\" Ability { id: \"4E62\", source: \"Ramuh\" }\r\n331.6 \"Tribunal Summons\" Ability { id: \"4B91\", source: \"Ramuh\" } window 30,30\r\n339.1 \"Gallop\" Ability { id: \"4B96\", source: \"Will Of Ixion\" }\r\n339.1 \"Deadly Discharge\" Ability { id: \"4B92\", source: \"Will Of Ramuh\" }\r\n350.1 \"Crippling Blow\" Ability { id: \"4BA3\", source: \"Ramuh\" }\r\n362.4 \"Judgment Volts\" Ability { id: \"4B98\", source: \"Ramuh\" }\r\n371.6 \"Thunderstorm\" Ability { id: \"4BA0\", source: \"Ramuh\" } window 30,30\r\n379.0 \"Tribunal Summons\" Ability { id: \"4B91\", source: \"Ramuh\" }\r\n382.0 \"Volt Strike\" Ability { id: \"4CF2\", source: \"Ramuh\" }\r\n388.5 \"Gallop\" Ability { id: \"4B96\", source: \"Will Of Ixion\" }\r\n389.1 \"Volt Strike\" Ability { id: \"4CF2\", source: \"Ramuh\" }\r\n399.5 \"Crippling Blow\" Ability { id: \"4BA3\", source: \"Ramuh\" } window 30,30 jump 272\r\n\r\n412.7 \"Stratospear Summons\"\r\n417.6 \"Impact\"\r\n421.1 \"Stormcloud Summons\"\r\n430.6 \"Judgment Jolt\"\r\n438.8 \"Fury's Bolt\"\r\n447.9 \"Divine Judgment Volts\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e5s.ts



const e5s_triggerSet = {
  id: 'EdensVerseFulminationSavage',
  zoneId: zone_id/* default.EdensVerseFulminationSavage */.Z.EdensVerseFulminationSavage,
  timelineFile: 'e5s.txt',
  timelineTriggers: [{
    id: 'E5S Stepped Leader Next',
    regex: /^Stepped Leader$/,
    beforeSeconds: 15,
    run: data => data.steppedLeaderNext = true
  }],
  triggers: [{
    id: 'E5S Surge Protection Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8B4'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.surgeProtection = true
  }, {
    id: 'E5S Surge Protection Loss',
    type: 'LosesEffect',
    netRegex: {
      effectId: '8B4'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.surgeProtection = false
  }, {
    id: 'E5S Stratospear Summons',
    type: 'Ability',
    netRegex: {
      id: '4BA5',
      source: 'Ramuh',
      capture: false
    },
    condition: data => !data.seenFirstSpear,
    delaySeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.seenFirstSpear = true,
    outputStrings: {
      text: {
        en: 'Look for small spear',
        de: 'Halt nach kleinem Speer ausschau',
        fr: 'Allez sur la petite lance',
        ja: '低い杖を探す',
        cn: '找短矛',
        ko: '작은 지팡이 확인'
      }
    }
  }, {
    id: 'E5S Tribunal Summons',
    type: 'StartsUsing',
    netRegex: {
      id: '4BAC',
      source: 'Ramuh',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.seenFirstAdd) return output.lookForAdds();
      if (data.furysBoltActive) return output.bigKnockback();
      return output.shortKnockback();
    },
    run: data => data.seenFirstAdd = true,
    outputStrings: {
      lookForAdds: {
        en: 'Look for adds',
        de: 'Halt nach dem Add ausschau',
        fr: 'Cherchez les adds',
        ja: '雑魚に注意',
        cn: '冲锋',
        ko: '쫄 위치 확인'
      },
      bigKnockback: {
        en: 'Big Knockback',
        de: 'Weiter Rückstoß',
        fr: 'Forte poussée',
        ja: '遠いノックバック',
        cn: '长击退',
        ko: '긴 넉백'
      },
      shortKnockback: {
        en: 'Short Knockback',
        de: 'Kurzer Rückstoß',
        fr: 'Faible poussée',
        ja: '短いノックバック',
        cn: '短击退',
        ko: '짧은 넉백'
      }
    }
  }, {
    id: 'E5S Fury\'s Bolt',
    type: 'StartsUsing',
    netRegex: {
      id: '4BAA',
      source: 'Ramuh',
      capture: false
    },
    alertText: (data, _matches, output) => {
      // Fury's Bolt + Stepped Leader doesn't require an orb
      if (!data.surgeProtection && !data.steppedLeaderNext) return output.text();
    },
    outputStrings: {
      text: {
        en: 'Grab an orb',
        de: 'Einen Orb nehmen',
        fr: 'Prenez un orbe',
        ja: '雷玉を取る',
        cn: '吃球',
        ko: '구슬 줍기'
      }
    }
  }, {
    id: 'E5S Fury\'s Bolt Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8B7',
      capture: false
    },
    run: data => data.furysBoltActive = true
  }, {
    id: 'E5S Fury\'s Bolt Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '8B7',
      capture: false
    },
    run: data => data.furysBoltActive = false
  }, {
    id: 'E5S Fury\'s Fourteen',
    type: 'StartsUsing',
    netRegex: {
      id: '4BAB',
      source: 'Ramuh',
      capture: false
    },
    condition: data => !data.furysFourteenCounter || data.furysFourteenCounter < 2,
    alertText: (data, _matches, output) => {
      if (!data.surgeProtection) return output.text();
    },
    run: data => data.furysFourteenCounter = (data.furysFourteenCounter ?? 0) + 1,
    outputStrings: {
      text: {
        en: 'Grab an orb',
        de: 'Einen Orb nehmen',
        fr: 'Prenez un orbe',
        ja: '雷玉を取る',
        cn: '吃球',
        ko: '구슬 줍기'
      }
    }
  }, {
    id: 'E5S Judgment Volts',
    type: 'StartsUsing',
    netRegex: {
      id: '4BB5',
      source: 'Ramuh',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E5S Stepped Leader',
    type: 'StartsUsing',
    netRegex: {
      id: '4BC6',
      source: 'Ramuh',
      capture: false
    },
    alertText: (data, _matches, output) => {
      // Fury's Bolt + Stepped Leader is a donut AoE instead
      if (!data.furysBoltActive) return output.readySpread();
      return output.donutAoe();
    },
    outputStrings: {
      readySpread: {
        en: 'Ready Spread',
        de: 'Bereitmachen zum Verteilen',
        fr: 'Dispersion bientôt',
        ja: '散開準備',
        cn: '准备分散',
        ko: '산개 준비'
      },
      donutAoe: {
        en: 'donut AoE',
        de: 'Donut AoE',
        fr: 'AoE en donut',
        ja: 'ドーナツ範囲',
        cn: '环形AOE',
        ko: '도넛 장판'
      }
    }
  }, {
    id: 'E5S Stepped Leader Spread',
    type: 'StartsUsing',
    netRegex: {
      id: '4BC6',
      source: 'Ramuh',
      capture: false
    },
    condition: data => !data.furysBoltActive,
    delaySeconds: 3,
    response: responses/* Responses.moveAway */.n3.moveAway('alarm')
  }, {
    id: 'E5S Stepped Leader Cast',
    type: 'Ability',
    netRegex: {
      id: '4BC6',
      source: 'Ramuh',
      capture: false
    },
    run: data => data.steppedLeaderNext = false
  }, {
    id: 'E5S Crippling Blow',
    type: 'StartsUsing',
    netRegex: {
      id: '4BCA',
      source: 'Ramuh'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E5S Stormcloud Summons',
    type: 'StartsUsing',
    netRegex: {
      id: '4BB8',
      source: 'Ramuh',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Position for Stormcloud',
        de: 'Position für die Wolke',
        fr: 'Positions pour les nuages',
        ja: '雷雲散開',
        cn: '雷云站位',
        ko: '번개 구름 위치 잡기'
      }
    }
  }, {
    // Hated of Levin debuff
    id: 'E5S Stormcloud Cleanse',
    type: 'HeadMarker',
    netRegex: {
      id: '00D2'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse In Cloud',
        de: 'In der Wolke reinigen',
        fr: 'Purifiez-vous dans le nuage',
        ja: '麻痺をエスナ',
        cn: '雷云清Debuff',
        ko: '디버프 제거하기'
      }
    }
  }, {
    id: 'E5S Stormcloud Drop',
    type: 'HeadMarker',
    netRegex: {
      id: '006E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Cloud Away',
        de: 'Wolke drausen ablegen',
        fr: 'Déposez le nuage à l\'extérieur',
        ja: '外に雷雲を捨てる',
        cn: '远离放雷云',
        ko: '번개 구름 소환자'
      }
    }
  }, {
    id: 'E5S Centaur\'s Charge',
    type: 'StartsUsing',
    netRegex: {
      id: '4BAD',
      source: 'Ramuh',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Be in your position',
        de: 'Befinde dich auf deiner Position!',
        fr: 'Placez-vous à votre position',
        ja: '突進、自分の位置へ',
        cn: '冲锋站位',
        ko: '자기 위치에 있기'
      }
    }
  }, {
    id: 'E5S Chain Lightning',
    type: 'StartsUsing',
    netRegex: {
      id: '4BC4',
      source: 'Ramuh',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Ready for Chain',
        de: 'Bereit für Kettenblitz',
        fr: 'Préparez-vous pour la chaine',
        ja: 'チェインライトニング準備',
        cn: '雷光链',
        ko: '체인 라이트닝 준비'
      }
    }
  }, {
    id: 'E5S Levinforce',
    type: 'StartsUsing',
    netRegex: {
      id: '4BCC',
      source: 'Ramuh',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Stormcloud': 'Cumulonimbus-Wolke',
      'Ramuh': 'Ramuh',
      'Raiden': 'Raiden',
      'Will Of Ixion': 'Ixion-Spiegelung'
    },
    'replaceText': {
      'Volt Strike': 'Voltschlag',
      'Tribunal Summons': 'Gedankenentstehung',
      'Thunderstorm': 'Gewitter',
      'Stratospear Summons': 'Stromgenerierung',
      'Stormcloud Summons': 'Elektrizitätsgenerierung',
      'Stepped Leader': 'Leuchtspur',
      'Shock Blast': 'Schockstoß',
      'Lightning Bolt': 'Blitzschlag',
      'Levinforce': 'Blitzkraft',
      'Judgment Volts': 'Gewitter des Urteils',
      'Judgment Jolt': 'Blitz des Urteils',
      'Impact': 'Impakt',
      'Gallop': 'Galopp',
      'Fury\'s Fourteen': 'Wütende Vierzehn',
      'Fury\'s Bolt': 'Wütender Blitz',
      'Executor Summons': 'Wächtergenerierung',
      'Crippling Blow': 'Verkrüppelnder Schlag',
      'Chaos Strike': 'Chaosschlag',
      'Chain Lightning': 'Kettenblitz',
      'Centaur\'s Charge': 'Zentaurenansturm'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'stormcloud': 'Cumulonimbus',
      'Ramuh': 'Ramuh',
      'Raiden': 'Raiden',
      'Will Of Ixion': 'Réplique d\'Ixion'
    },
    'replaceText': {
      '\\?': ' ?',
      'Volt Strike': 'Frappe d\'éclair',
      'Tribunal Summons': 'Manifestations de l\'esprit',
      'Thunderstorm': 'Tempête de foudre',
      'Stratospear Summons': 'Conjuration de dards',
      'Stormcloud Summons': 'Nuage d\'orage',
      'Stepped Leader': 'Traceur',
      'Shock Blast': 'Impact foudroyant',
      'Lightning Bolt': 'Éclair de foudre',
      'Levinforce': 'Déflagration fulgurante',
      'Judgment Volts': 'Éclair de chaleur du jugement',
      'Judgment Jolt': 'Front orageux du jugement',
      'Impact': 'Impact',
      'Gallop': 'Galop',
      'Fury\'s Fourteen': 'Boules de foudre - Quattordecim',
      'Fury\'s Bolt': 'Boules de foudre',
      'Executor Summons': 'Disjonction corporelle',
      'Crippling Blow': 'Coup handicapant',
      'Chaos Strike': 'Frappe chaotique',
      'Chain Lightning': 'Chaîne d\'éclairs',
      'Centaur\'s Charge': 'Charge centaure'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'stormcloud': '積乱雲',
      'Ramuh': 'ラムウ',
      'Raiden': 'ライディーン',
      'Will Of Ixion': 'イクシオン・ミラージュ'
    },
    'replaceText': {
      'Volt Strike': 'ボルトストライク',
      'Tribunal Summons': '思念体生成',
      'Thunderstorm': 'サンダーストーム',
      'Stratospear Summons': '武具生成',
      'Stormcloud Summons': '雷雲生成',
      'Stepped Leader': 'ステップトリーダー',
      'Shock Blast': 'ショックブラスト',
      'Lightning Bolt': '落雷',
      'Levinforce': 'ライトニングフォース',
      'Judgment Volts': '裁きの熱雷',
      'Judgment Jolt': '裁きの界雷',
      'Impact': '衝撃',
      'Gallop': 'ギャロップ',
      'Fury\'s Fourteen': 'フォーティーン・チャージボルト',
      'Fury\'s Bolt': 'チャージボルト',
      'Executor Summons': '分離体生成',
      'Crippling Blow': '痛打',
      'Chaos Strike': 'カオスストライク',
      'Chain Lightning': 'チェインライトニング',
      'Centaur\'s Charge': 'セントールチャージ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'stormcloud': '雷暴云',
      '(?<! )Ramuh': '拉姆',
      'Will Of Ramuh': '拉姆幻影',
      'Raiden': '莱丁',
      'Will Of Ixion': '伊克西翁幻影'
    },
    'replaceText': {
      'Volt Strike': '雷电强袭',
      'Tribunal Summons': '生成幻影',
      'Thunderstorm': '雷暴',
      'Stratospear Summons': '生成武具',
      'Stormcloud Summons': '生成雷暴云',
      'Stepped Leader': '梯级先导',
      'Shock Strike': '轰雷',
      'Shock Blast': '震荡爆雷',
      'Shock(?! )': '放电',
      'Lightning Bolt': '落雷',
      'Levinforce': '雷霆之力',
      'Judgment Volts': '制裁之热雷',
      'Judgment Jolt': '制裁之界雷',
      'Impact': '冲击',
      'Gallop': '飞驰',
      'Fury\'s Fourteen': '十四重蓄雷',
      'Fury\'s Bolt': '蓄雷',
      'Executor Summons': '生成仆从',
      'Deadly Discharge': '死亡冲锋',
      'Crippling Blow': '痛击',
      'Chaos Strike': '混乱冲击',
      'Chain Lightning': '雷光链',
      'Centaur\'s Charge': '人马冲锋'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'stormcloud': '적란운',
      '(?<! )Ramuh': '라무',
      'Will Of Ramuh': '라무의 환영',
      'Raiden': '뇌전',
      'Will Of Ixion': '익시온의 환영'
    },
    'replaceText': {
      'Volt Strike': '전기 충격',
      'Tribunal Summons': '사념체 생성',
      'Thunderstorm': '번개 폭풍',
      'Stratospear Summons': '무기 생성',
      'Stormcloud Summons': '번개구름 생성',
      'Stepped Leader': '계단형 선도',
      'Shock Strike': '번개 충격',
      'Shock Blast': '번개 충격파',
      'Shock(?! )': '방전',
      'Lightning Bolt': '낙뢰',
      'Levinforce': '천둥의 기세',
      'Judgment Volts': '심판의 열뢰',
      'Judgment Jolt': '심판의 계뢰',
      'Impact': '충격',
      'Gallop': '습보',
      'Fury\'s Fourteen': '14연속 번개 충전',
      'Fury\'s Bolt': '번개 충전',
      'Executor Summons': '분리체 생성',
      'Deadly Discharge': '죽음의 방전',
      'Crippling Blow': '통타',
      'Chaos Strike': '혼돈의 일격',
      'Chain Lightning': '번개 사슬',
      'Centaur\'s Charge': '켄타우로스 돌진'
    }
  }]
};
/* harmony default export */ const e5s = (e5s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e5s.txt
const raid_e5s_namespaceObject = "### Eden 5 (Savage)\r\n# Eden's Verse: Fulmination\r\n# -p 4BB5:12 -ii 4BC9 4BB4 4BB6 4BA7 4E61 4BB7 4BB9 4BB2 4BC1 4BC6 4BAE 4E4E 4D54 4E3D 4BB1\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n12.0 \"Judgment Volts\" Ability { id: \"4BB5\", source: \"Ramuh\" } window 12,20\r\n22.2 \"Stratospear Summons\" Ability { id: \"4BA5\", source: \"Ramuh\" }\r\n27.1 \"Impact\" Ability { id: \"4E3B\", source: \"Ramuh\" }\r\n35.6 \"Judgment Jolt\" Ability { id: \"4BA6\", source: \"Ramuh\" }\r\n42.7 \"Executor Summons\" Ability { id: \"4BBC\", source: \"Ramuh\" }\r\n52.2 \"Fury's Bolt\" Ability { id: \"4BAA\", source: \"Ramuh\" }\r\n63.3 \"Judgment Volts\" Ability { id: \"4BB5\", source: \"Ramuh\" }\r\n69.5 \"Shock Blast\" Ability { id: \"4BBE\", source: \"Raiden\" }\r\n73.4 \"Crippling Blow\" Ability { id: \"4BCA\", source: \"Ramuh\" }\r\n79.7 \"Stormcloud Summons\" Ability { id: \"4BB8\", source: \"Ramuh\" }\r\n84.8 \"Chaos Strike\" Ability { id: \"4BBB\", source: \"Ramuh\" }\r\n89.2 \"--sync--\" Ability { id: \"4BCB\", source: \"Ramuh\" }\r\n89.9 \"Lightning Bolt\" duration 24.5 # Ability { id: \"4BB9\", source: \"Stormcloud\" }\r\n96.2 \"Levinforce\" Ability { id: \"4BCC\", source: \"Ramuh\" }\r\n\r\n110.6 \"Fury's Bolt?\" Ability { id: \"4BAA\", source: \"Ramuh\" }\r\n117.7 \"Tribunal Summons\" Ability { id: \"4BAC\", source: \"Ramuh\" }\r\n128.6 \"Gallop\" Ability { id: \"4BB3\", source: \"Will Of Ixion\" }\r\n138.1 \"Crippling Blow\" Ability { id: \"4BCA\", source: \"Ramuh\" }\r\n148.3 \"Judgment Volts\" Ability { id: \"4BB5\", source: \"Ramuh\" }\r\n155.5 \"Fury's Bolt\" Ability { id: \"4BAA\", source: \"Ramuh\" }\r\n163.6 \"Thunderstorm\" Ability { id: \"4BBF\", source: \"Ramuh\" }\r\n174.5 \"Volt Strike\" Ability { id: \"4BC3\", source: \"Ramuh\" }\r\n182.6 \"Volt Strike\" Ability { id: \"4BC3\", source: \"Ramuh\" }\r\n189.1 \"Executor Summons\" Ability { id: \"4BBC\", source: \"Ramuh\" }\r\n198.5 \"Crippling Blow\" Ability { id: \"4BCA\", source: \"Ramuh\" }\r\n210.1 \"Stepped Leader\" Ability { id: \"4BC7\", source: \"Ramuh\" }\r\n215.9 \"Shock Blast\" Ability { id: \"4BBE\", source: \"Raiden\" }\r\n221.2 \"Judgment Volts\" Ability { id: \"4BB5\", source: \"Ramuh\" }\r\n\r\n230.5 \"Fury's Fourteen\" Ability { id: \"4BAB\", source: \"Ramuh\" }\r\n244.6 \"Stratospear Summons\" Ability { id: \"4BA5\", source: \"Ramuh\" }\r\n249.5 \"Impact\" Ability { id: \"4E3B\", source: \"Ramuh\" }\r\n253.0 \"Tribunal Summons\" Ability { id: \"4BAC\", source: \"Ramuh\" }\r\n255.4 \"--sync--\" Ability { id: \"4BCB\", source: \"Ramuh\" }\r\n262.3 \"Centaur's Charge\" Ability { id: \"4BAD\", source: \"Ramuh\" }\r\n267.3 \"Gallop\" Ability { id: \"4BB3\", source: \"Will Of Ixion\" }\r\n\r\n267.5 \"Judgment Jolt\" Ability { id: \"4BA9\", source: \"Will Of Ramuh\" }\r\n279.1 \"Fury's Bolt\" Ability { id: \"4BAA\", source: \"Ramuh\" }\r\n287.9 \"Stepped Leader\" Ability { id: \"4BC8\", source: \"Ramuh\" }\r\n297.8 \"Chain Lightning\" Ability { id: \"4BC4\", source: \"Ramuh\" }\r\n301.6 \"Chain Lightning 1\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n305.2 \"Crippling Blow\" Ability { id: \"4BCA\", source: \"Ramuh\" }\r\n305.3 \"Chain Lightning 2\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n309.0 \"Chain Lightning 3\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n312.7 \"Chain Lightning 4\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n316.4 \"Chain Lightning 5\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n317.4 \"Judgment Volts\" Ability { id: \"4BB5\", source: \"Ramuh\" }\r\n320.1 \"Chain Lightning 6\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n323.8 \"Chain Lightning 7\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n327.5 \"Chain Lightning 8\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n\r\n329.6 \"Executor Summons\" Ability { id: \"4BBC\", source: \"Ramuh\" }\r\n337.0 \"Fury's Bolt\" Ability { id: \"4BAA\", source: \"Ramuh\" }\r\n346.2 \"Thunderstorm\" Ability { id: \"4BBF\", source: \"Ramuh\" }\r\n356.4 \"Shock Blast\" Ability { id: \"4BBE\", source: \"Raiden\" }\r\n357.1 \"Volt Strike\" Ability { id: \"4BC3\", source: \"Ramuh\" }\r\n365.2 \"Volt Strike\" Ability { id: \"4BC3\", source: \"Ramuh\" }\r\n368.0 \"Stepped Leader\" Ability { id: \"4BC7\", source: \"Ramuh\" }\r\n380.1 \"Crippling Blow\" Ability { id: \"4BCA\", source: \"Ramuh\" }\r\n388.3 \"Judgment Volts\" Ability { id: \"4BB5\", source: \"Ramuh\" }\r\n\r\n395.6 \"Fury's Fourteen\" Ability { id: \"4BAB\", source: \"Ramuh\" }\r\n411.7 \"Stratospear Summons\" Ability { id: \"4BA5\", source: \"Ramuh\" }\r\n416.6 \"Impact\" Ability { id: \"4E3B\", source: \"Ramuh\" }\r\n420.1 \"Tribunal Summons\" Ability { id: \"4BAC\", source: \"Ramuh\" }\r\n422.5 \"--sync--\" Ability { id: \"4BCB\", source: \"Ramuh\" }\r\n429.4 \"Centaur's Charge\" Ability { id: \"4BAD\", source: \"Ramuh\" }\r\n434.4 \"Gallop\" Ability { id: \"4BB3\", source: \"Will Of Ixion\" }\r\n\r\n434.6 \"Judgment Jolt\" Ability { id: \"4BA9\", source: \"Will Of Ramuh\" }\r\n440.2 \"Fury's Bolt\" Ability { id: \"4BAA\", source: \"Ramuh\" }\r\n450.4 \"Judgment Volts\" Ability { id: \"4BB5\", source: \"Ramuh\" }\r\n460.5 \"Stormcloud Summons\" Ability { id: \"4BB8\", source: \"Ramuh\" }\r\n465.6 \"Chaos Strike\" Ability { id: \"4BBB\", source: \"Ramuh\" }\r\n470.0 \"--sync--\" Ability { id: \"4BCB\", source: \"Ramuh\" }\r\n470.7 \"Lightning Bolt\" duration 24.5 # Ability { id: \"4BB9\", source: \"Stormcloud\" }\r\n477.0 \"Levinforce\" Ability { id: \"4BCC\", source: \"Ramuh\" }\r\n487.4 \"Judgment Volts\" Ability { id: \"4BB5\", source: \"Ramuh\" }\r\n502.6 \"Chain Lightning\" Ability { id: \"4BC4\", source: \"Ramuh\" }\r\n506.4 \"Chain Lightning 1\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n510.0 \"Crippling Blow\" Ability { id: \"4BCA\", source: \"Ramuh\" }\r\n510.1 \"Chain Lightning 2\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n513.8 \"Chain Lightning 3\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n517.5 \"Chain Lightning 4\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n521.2 \"Chain Lightning 5\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n523.2 \"Judgment Volts\" Ability { id: \"4BB5\", source: \"Ramuh\" }\r\n524.8 \"Chain Lightning 6\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n528.5 \"Chain Lightning 7\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n532.2 \"Chain Lightning 8\" #Ability { id: \"4BC5\", source: \"Ramuh\" }\r\n\r\n539.7 \"Stepped Leader\" Ability { id: \"4BC7\", source: \"Ramuh\" }\r\n545.8 \"Fury's Bolt\" Ability { id: \"4BAA\", source: \"Ramuh\" }\r\n554.9 \"Judgment Volts\" Ability { id: \"4BB5\", source: \"Ramuh\" }\r\n566.0 \"Judgment Volts\" Ability { id: \"4BB5\", source: \"Ramuh\" }\r\n574.1 \"Fury's Bolt\" Ability { id: \"4BAA\", source: \"Ramuh\" }\r\n583.2 \"Judgment Volts\" Ability { id: \"4BB5\", source: \"Ramuh\" }\r\n594.3 \"Judgment Volts\" Ability { id: \"4BB5\", source: \"Ramuh\" }\r\n605.4 \"Judgment Volts\" Ability { id: \"4BB5\", source: \"Ramuh\" }\r\n\r\n612.3 \"Fury's Fourteen\" Ability { id: \"4BAB\", source: \"Ramuh\" }\r\n628.4 \"Stratospear Summons\" Ability { id: \"4BA5\", source: \"Ramuh\" }\r\n\r\n#??? \"Judgment Volts Enrage\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e6n.ts




const e6n_triggerSet = {
  id: 'EdensVerseFuror',
  zoneId: zone_id/* default.EdensVerseFuror */.Z.EdensVerseFuror,
  timelineFile: 'e6n.txt',
  timelineTriggers: [{
    // We warn the user here because the startsUsing warning gives only 3.5s or so.
    id: 'E6N Downburst',
    regex: /Downburst/,
    beforeSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback('info')
  }],
  triggers: [{
    id: 'E6N Superstorm',
    type: 'StartsUsing',
    netRegex: {
      source: 'Garuda',
      id: '4BD7',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E6N Ferostorm',
    type: 'StartsUsing',
    netRegex: {
      source: ['Garuda', 'Raktapaksa'],
      id: ['4BD[DEF]', '4BE[345]'],
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid green nails',
        de: 'Weiche den grünen Nägeln aus',
        fr: 'Évitez les griffes',
        ja: '緑の爪を避ける',
        cn: '躲避风牙',
        ko: '초록 발톱 피하기'
      }
    }
  }, {
    id: 'E6N Air Bump',
    type: 'HeadMarker',
    netRegex: {
      id: '00D3'
    },
    suppressSeconds: 1,
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.enumerationOnYou();
      return output.enumeration();
    },
    outputStrings: {
      enumerationOnYou: {
        en: 'Enumeration on YOU',
        de: 'Enumeration aud DIR',
        fr: 'Énumération sur VOUS',
        ja: '自分にエアーバンプ',
        cn: '蓝圈分摊点名',
        ko: '2인 장판 대상자'
      },
      enumeration: {
        en: 'Enumeration',
        de: 'Enumeration',
        fr: 'Énumération',
        ja: 'エアーバンプ',
        cn: '蓝圈分摊',
        ko: '2인 장판'
      }
    }
  }, {
    id: 'E6N Inferno Howl',
    type: 'StartsUsing',
    netRegex: {
      source: ['Ifrit', 'Raktapaksa'],
      id: '4BF1',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Save ability state since the generic tether used has multiple uses in this fight
    id: 'E6N Hands of Flame Start',
    type: 'StartsUsing',
    netRegex: {
      source: ['Ifrit', 'Raktapaksa'],
      id: '4CFE',
      capture: false
    },
    preRun: data => data.handsOfFlame = true
  }, {
    // Tank swap if you're not the target
    // Break tether if you're the target during Ifrit+Garuda phase
    id: 'E6N Hands of Flame Tether',
    type: 'Tether',
    netRegex: {
      id: '0068'
    },
    condition: data => data.handsOfFlame,
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.chargeOnYou();
      if (data.role !== 'tank' || data.phase === 'both') return;
      return output.tankSwap();
    },
    outputStrings: {
      chargeOnYou: {
        en: 'Charge on YOU',
        de: 'Ansturm auf DIR',
        fr: 'Charge sur VOUS',
        ja: '自分に突進',
        cn: '冲锋点名',
        ko: '돌진 대상자'
      },
      tankSwap: outputs/* default.tankSwap */.Z.tankSwap
    }
  }, {
    id: 'E6N Hands of Flame Cast',
    type: 'Ability',
    netRegex: {
      source: ['Ifrit', 'Raktapaksa'],
      id: '4BE9',
      capture: false
    },
    preRun: data => data.handsOfFlame = false,
    suppressSeconds: 1
  }, {
    id: 'E6N Instant Incineration',
    type: 'StartsUsing',
    netRegex: {
      source: ['Ifrit', 'Raktapaksa'],
      id: '4BED'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E6N Hands of Hell',
    type: 'HeadMarker',
    netRegex: {
      id: '0016'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tether Marker on YOU',
        de: 'Verbindung auf DIR',
        fr: 'Marque de lien sur VOUS',
        ja: '自分に線マーカー',
        cn: '连线点名',
        ko: '징 대상자'
      }
    }
  }, {
    id: 'E6N Strike Spark',
    type: 'Ability',
    netRegex: {
      source: 'Ifrit',
      id: '4F98',
      capture: false
    },
    // Run only once, because Ifrit's other jumps are not important.
    condition: data => !data.seenSpark,
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.seenSpark = true,
    outputStrings: {
      text: {
        en: 'Move to Ifrit',
        de: 'Zu Ifrit bewegen',
        fr: 'Allez sur Ifrit',
        ja: 'イフリートところへ',
        cn: '踢球 集合待机',
        ko: '이프리트로 이동'
      }
    }
  }, {
    id: 'E6N Storm Of Fury',
    type: 'StartsUsing',
    // Garuda uses this ability without eruptions alongside, so she needs no warnings.
    netRegex: {
      source: 'Raktapaksa',
      id: '4BE6',
      capture: false
    },
    response: responses/* Responses.stackThenSpread */.n3.stackThenSpread()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Raktapaksa': 'Raktapaksa',
      'Ifrit': 'Ifrit',
      'Garuda': 'Garuda'
    },
    'replaceText': {
      'Vacuum Slice': 'Vakuumschnitt',
      'Touchdown': 'Himmelssturz',
      'Thorns': 'Dornen',
      'Superstorm': 'Sturm der Zerstörung',
      'Strike Spark': 'Feuerfunken',
      'Storm Of Fury': 'Wütender Sturm',
      'Radiant Plume': 'Scheiterhaufen',
      'Occluded Front': 'Okklusion',
      'Irresistible Pull': 'Saugkraft',
      'Instant Incineration': 'Explosive Flamme',
      'Inferno Howl': 'Glühendes Gebrüll',
      'Hot Foot': 'Fliegendes Feuer',
      'Heat Burst': 'Hitzewelle',
      'Hands Of Hell': 'Faust des Schicksals',
      'Hands Of Flame': 'Flammenfaust',
      'Firestorm': 'Feuersturm',
      'Ferostorm': 'Angststurm',
      'Eruption': 'Eruption',
      'Downburst': 'Fallböe',
      'Conflag Strike': 'Feuersbrunst',
      'Air Bump': 'Aufsteigende Böe'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Raktapaksa': 'Raktapaksa',
      'Ifrit': 'Ifrit',
      'Garuda': 'Garuda'
    },
    'replaceText': {
      'Vacuum Slice': 'Lacération du vide',
      'Touchdown': 'Atterrissage',
      'Thorns': 'Lardoir',
      'Superstorm': 'Tempête dévastatrice',
      'Strike Spark': 'Ignescences',
      'Storm Of Fury': 'Tempête déchaînée',
      'Radiant Plume': 'Panache radiant',
      'Occluded Front': 'Front occlus',
      'Irresistible Pull': 'Force d\'aspiration',
      'Instant Incineration': 'Uppercut enflammé',
      'Inferno Howl': 'Rugissement ardent',
      'Hot Foot': 'Jet d\'ignescence',
      'Heat Burst': 'Vague de chaleur',
      'Hands Of Hell': 'Frappe purgatrice',
      'Hands Of Flame': 'Frappe enflammée',
      'Firestorm': 'Tempête de feu',
      'Ferostorm': 'Tempête déchaînée',
      'Eruption': 'Éruption',
      'Downburst': 'Rafale descendante',
      'Conflag Strike': 'Ekpurosis',
      'Air Bump': 'Rafale ascendante'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Raktapaksa': 'ラクタパクシャ',
      'Ifrit': 'イフリート',
      'Garuda': 'ガルーダ'
    },
    'replaceText': {
      'Vacuum Slice': 'バキュームスラッシュ',
      'Touchdown': 'タッチダウン',
      'Thorns': '早贄',
      'Superstorm': 'スーパーストーム',
      'Strike Spark': 'ファイアスパーク',
      'Storm Of Fury': 'フューリアスストーム',
      'Radiant Plume': '光輝の炎柱',
      'Occluded Front': 'オクルーデッドフロント',
      'Irresistible Pull': '吸引力',
      'Instant Incineration': '爆裂炎',
      'Inferno Howl': '灼熱の咆哮',
      'Hot Foot': '飛び火',
      'Heat Burst': '熱波',
      'Hands Of Hell': '業炎拳',
      'Hands Of Flame': '火炎拳',
      'Firestorm': 'ファイアストーム',
      'Ferostorm': 'フィアスストーム',
      'Eruption': 'エラプション',
      'Downburst': 'ダウンバースト',
      'Conflag Strike': 'コンフラグレーションストライク',
      'Air Bump': 'エアーバンプ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Garuda': '迦楼罗',
      'Ifrit': '伊弗利特',
      'Raktapaksa': '赤翼罗羯坨博叉'
    },
    'replaceText': {
      'Ferostorm': '凶猛风暴',
      'Superstorm': '超级风暴',
      'Air Bump': '空气弹垫',
      'Thorns': '血祭',
      'Downburst': '下行突风',
      'Storm Of Fury': '暴怒风暴',
      'Vacuum Slice': '真空斩',
      'Occluded Front': '锢囚锋',
      'Irresistible Pull': '吸引力',
      'Touchdown': '空降',
      'Hands Of Flame': '火焰拳',
      'Hands Of Hell': '业火拳',
      'Instant Incineration': '爆裂炎',
      'Eruption': '地火喷发',
      'Strike Spark': '火花爆',
      'Hot Foot': '飞火',
      'Inferno Howl': '灼热的咆哮',
      'Firestorm': '火焰流',
      'Radiant Plume': '光辉炎柱',
      'Heat Burst': '热波',
      'Conflag Strike': '瞬燃强袭'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Garuda': '가루다',
      'Ifrit': '이프리트',
      'Raktapaksa': '락타팍샤'
    },
    'replaceText': {
      'Ferostorm': '사나운 폭풍',
      'Superstorm': '초폭풍',
      'Air Bump': '상향 기류',
      'Thorns': '생꼬치',
      'Downburst': '하강 기류',
      'Storm Of Fury': '분노의 폭풍',
      'Vacuum Slice': '진공베기',
      'Occluded Front': '폐색 전선',
      'Irresistible Pull': '흡인력',
      'Touchdown': '착지',
      'Hands Of Flame': '화염권',
      'Hands Of Hell': '업염권',
      'Instant Incineration': '폭렬염',
      'Eruption': '용암 분출',
      'Strike Spark': '불놀이',
      'Hot Foot': '불똥',
      'Inferno Howl': '작열의 포효',
      'Firestorm': '불보라',
      'Radiant Plume': '광휘의 불기둥',
      'Heat Burst': '열파',
      'Conflag Strike': '대화재'
    }
  }]
};
/* harmony default export */ const e6n = (e6n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e6n.txt
const raid_e6n_namespaceObject = "### Eden 6 (Normal)\r\n# Eden's Verse: Furor\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# -ii 4BDD 4BE1 4BEB 4BEA 4BE5 4BE9 4BEC 4BD9 4BE7 4E39 4C1D 4C20 4F98\r\n# -ic \"Tumultuous Nexus\" \"Great Ball Of Fire\"\r\n\r\n# Garuda solo\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n13.5 \"Ferostorm\" # Ability { id: \"4BD[DEF]\", source: \"Garuda\" }\r\n20.6 \"Superstorm\" Ability { id: \"4BD7\", source: \"Garuda\" } window 21,30\r\n31.4 \"Air Bump\" Ability { id: \"4BD1\", source: \"Garuda\" }\r\n36.8 \"Thorns\" Ability { id: \"4BDA\", source: \"Garuda\" }\r\n48.0 \"Downburst\" Ability { id: \"4BDB\", source: \"Garuda\" } window 30,30\r\n54.6 \"Air Bump\" Ability { id: \"4BD1\", source: \"Garuda\" }\r\n60.0 \"Thorns\" Ability { id: \"4BDA\", source: \"Garuda\" }\r\n72.2 \"Storm Of Fury\" Ability { id: \"4BE0\", source: \"Garuda\" }\r\n75.4 \"--sync--\" Ability { id: \"4BD0\", source: \"Garuda\" }\r\n81.7 \"Vacuum Slice\" Ability { id: \"4BD5\", source: \"Garuda\" }\r\n88.8 \"Occluded Front\" Ability { id: \"4BD2\", source: \"Garuda\" } window 30,30\r\n98.3 \"Irresistible Pull\" Ability { id: \"4BD6\", source: \"Garuda\" }\r\n111.0 \"--untargetable--\"\r\n\r\n# Ifrit solo\r\n114.1 \"Touchdown\" Ability { id: \"4BE8\", source: \"Ifrit\" } window 30,30\r\n115.5 \"--targetable--\"\r\n129.2 \"Hands Of Flame\" Ability { id: \"4CFE\", source: \"Ifrit\" }\r\n143.6 \"Hands Of Hell\" Ability { id: \"4CFF\", source: \"Ifrit\" }\r\n152.3 \"Instant Incineration\" Ability { id: \"4BED\", source: \"Ifrit\" } window 30,30\r\n156.9 \"Eruption\" Ability { id: \"4BF3\", source: \"Ifrit\" }\r\n166.1 \"Strike Spark\" Ability { id: \"4BD3\", source: \"Ifrit\" }\r\n177.5 \"Hot Foot\" Ability { id: \"4BEF\", source: \"Ifrit\" }\r\n188.2 \"Inferno Howl\" Ability { id: \"4BF1\", source: \"Ifrit\" } window 30,30\r\n196.3 \"--untargetable--\"\r\n\r\n\r\n# Garuda and Ifrit\r\n200.6 \"--targetable--\"\r\n207.2 \"Vacuum Slice\" Ability { id: \"4BD5\", source: \"Garuda\" } window 30,30\r\n209.9 \"Eruption\" Ability { id: \"4BF3\", source: \"Ifrit\" }\r\n209.9 \"Eruption\" Ability { id: \"4BF4\", source: \"Ifrit\" }\r\n213.1 \"--sync--\" Ability { id: \"4F98\", source: \"Ifrit\" }\r\n214.3 \"Occluded Front\" Ability { id: \"4BD2\", source: \"Garuda\" }\r\n221.2 \"Hot Foot\" Ability { id: \"4BEF\", source: \"Ifrit\" }\r\n223.8 \"Irresistible Pull\" Ability { id: \"4BD6\", source: \"Garuda\" } window 30,30\r\n228.0 \"Air Bump\" Ability { id: \"4BD1\", source: \"Garuda\" }\r\n233.3 \"Thorns\" Ability { id: \"4BDA\", source: \"Garuda\" }\r\n237.9 \"Hands Of Hell\" Ability { id: \"4CFF\", source: \"Ifrit\" }\r\n245.5 \"Ferostorm\" # Ability { id: \"4BD[DEF]\", source: \"Garuda\" }\r\n250.2 \"--untargetable--\"\r\n\r\n\r\n# Raktapaksa initial block\r\n267.9 \"Firestorm\" Ability { id: \"4BD8\", source: \"Raktapaksa\" } window 30,30\r\n272.1 \"--targetable--\"\r\n283.2 \"Radiant Plume\" Ability { id: \"4BF2\", source: \"Raktapaksa\" }\r\n286.2 \"Ferostorm\" # Ability { id: \"4BE[345]\", source: \"Raktapaksa\" }\r\n297.3 \"Hands Of Flame\" Ability { id: \"4CFE\", source: \"Raktapaksa\" } window 30,30\r\n301.1 \"Heat Burst\" Ability { id: \"4C1E\", source: \"Raktapaksa\" }\r\n311.2 \"Eruption\" Ability { id: \"4BF4\", source: \"Raktapaksa\" }\r\n312.6 \"Thorns\" Ability { id: \"4BDA\", source: \"Raktapaksa\" }\r\n313.7 \"Hands Of Hell\" Ability { id: \"4CFF\", source: \"Raktapaksa\" }\r\n317.6 \"Heat Burst\" Ability { id: \"4C1E\", source: \"Raktapaksa\" }\r\n325.2 \"--untargetable--\"\r\n325.2 \"Downburst\" Ability { id: \"4BDC\", source: \"Raktapaksa\" } window 30,30\r\n329.5 \"--targetable--\"\r\n336.6 \"Radiant Plume\" Ability { id: \"4BF2\", source: \"Raktapaksa\" }\r\n341.6 \"Eruption\" Ability { id: \"4BF4\", source: \"Raktapaksa\" }\r\n348.1 \"Radiant Plume\" Ability { id: \"4BF2\", source: \"Raktapaksa\" }\r\n353.1 \"Eruption\" Ability { id: \"4BF4\", source: \"Raktapaksa\" }\r\n360.4 \"Conflag Strike\" Ability { id: \"4BEE\", source: \"Raktapaksa\" } window 30,30\r\n\r\n# Raktapaksa rotation block\r\n375.6 \"Ferostorm\" # Ability { id: \"4BE[345]\", source: \"Raktapaksa\" }\r\n377.6 \"Air Bump\" Ability { id: \"4BD4\", source: \"Raktapaksa\" }\r\n382.5 \"Thorns\" Ability { id: \"4BDA\", source: \"Raktapaksa\" } window 30,30\r\n390.7 \"Storm Of Fury\" Ability { id: \"4BE6\", source: \"Raktapaksa\" }\r\n391.7 \"Eruption\" Ability { id: \"4BF4\", source: \"Raktapaksa\" }\r\n401.4 \"Inferno Howl\" Ability { id: \"4BF1\", source: \"Raktapaksa\" }\r\n415.6 \"Eruption\" Ability { id: \"4BF4\", source: \"Raktapaksa\" }\r\n416.6 \"Hands Of Hell\" Ability { id: \"4CFF\", source: \"Raktapaksa\" } window 30,30\r\n420.5 \"Heat Burst\" Ability { id: \"4C1E\", source: \"Raktapaksa\" }\r\n427.2 \"Instant Incineration\" Ability { id: \"4BED\", source: \"Raktapaksa\" }\r\n433.4 \"Radiant Plume\" Ability { id: \"4BF2\", source: \"Raktapaksa\" }\r\n439.4 \"Inferno Howl\" Ability { id: \"4BF1\", source: \"Raktapaksa\" } window 30,30\r\n\r\n454.6 \"Ferostorm\" # Ability { id: \"4BE[345]\", source: \"Raktapaksa\" }\r\n456.6 \"Air Bump\" Ability { id: \"4BD4\", source: \"Raktapaksa\" }\r\n461.5 \"Thorns\" Ability { id: \"4BDA\", source: \"Raktapaksa\" } window 30,30\r\n469.7 \"Storm Of Fury\" Ability { id: \"4BE6\", source: \"Raktapaksa\" }\r\n470.7 \"Eruption\" Ability { id: \"4BF4\", source: \"Raktapaksa\" }\r\n480.4 \"Inferno Howl\" Ability { id: \"4BF1\", source: \"Raktapaksa\" }\r\n494.6 \"Eruption\" Ability { id: \"4BF4\", source: \"Raktapaksa\" }\r\n495.6 \"Hands Of Hell\" Ability { id: \"4CFF\", source: \"Raktapaksa\" } window 30,30\r\n499.5 \"Heat Burst\" Ability { id: \"4C1E\", source: \"Raktapaksa\" }\r\n506.2 \"Instant Incineration\" Ability { id: \"4BED\", source: \"Raktapaksa\" }\r\n512.4 \"Radiant Plume\" Ability { id: \"4BF2\", source: \"Raktapaksa\" }\r\n518.4 \"Inferno Howl\" Ability { id: \"4BF1\", source: \"Raktapaksa\" } window 30,30 jump 439.4\r\n\r\n533.6 \"Ferostorm\"\r\n535.6 \"Air Bump\"\r\n540.5 \"Thorns\"\r\n548.7 \"Storm Of Fury\"\r\n549.7 \"Eruption\"\r\n559.4 \"Inferno Howl\"\r\n573.6 \"Eruption\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e6s.ts






const e6s_triggerSet = {
  id: 'EdensVerseFurorSavage',
  zoneId: zone_id/* default.EdensVerseFurorSavage */.Z.EdensVerseFurorSavage,
  timelineFile: 'e6s.txt',
  triggers: [{
    id: 'E6S Strike Spark',
    type: 'StartsUsing',
    netRegex: {
      source: ['Ifrit', 'Raktapaksa'],
      id: '4BD3',
      capture: false
    },
    delaySeconds: 11,
    promise: async (data, _matches, output) => {
      const ifritLocaleNames = {
        en: 'Ifrit',
        de: 'Ifrit',
        fr: 'Ifrit',
        ja: 'イフリート',
        cn: '伊弗利特',
        ko: '이프리트'
      };
      const raktapaksaLocaleNames = {
        en: 'Raktapaksa',
        de: 'Raktapaksa',
        fr: 'Raktapaksa',
        ja: 'ラクタパクシャ',
        cn: '赤翼罗羯坨博叉',
        ko: '락타팍샤'
      };

      // select the 4 most recent Ifrit or Raktapaksa's depending on phase
      let combatantName = null;
      if (data.phase === 'ifrit') combatantName = ifritLocaleNames[data.parserLang];else combatantName = raktapaksaLocaleNames[data.parserLang];
      let combatantData = null;
      if (combatantName) {
        combatantData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
          call: 'getCombatants',
          names: [combatantName]
        });
      }

      // if we could not retrieve combatant data, the
      // trigger will not work, so just resume promise here.
      if (!(combatantData !== null && combatantData.combatants.length)) {
        delete data.safeZone;
        return;
      }

      // we need to filter for the Ifrit with the highest ID
      // since that one is always the safe spot.
      const currentHighestCombatant = combatantData.combatants.sort((a, b) => (a.ID ?? 0) - (b.ID ?? 0)).pop();

      // all variation ranges for all the 9 ball positions for the kicking actors
      // north      x: 96-104   y: 85-93
      // northeast  x: 107-115  y: 85-93
      // northwest  x: 85-93    y: 85-93
      // east       x: 107-115  y: 96-104
      // west       x: 85-93    y: 96-104
      // south      x: 96-104   y: 107-115
      // southeast  x: 107-115  y: 107-115
      // southwest  x: 85-93    y: 107-115
      let safeZone1;
      let safeZone2;
      if (!currentHighestCombatant) throw new not_reached/* UnreachableCode */.$();

      // don't need to go through all the posibilities,
      // only those 4 ifs do reflect the above positions
      if (currentHighestCombatant.PosY > 84 && currentHighestCombatant.PosY < 94) safeZone1 = output.north();else if (currentHighestCombatant.PosY > 106 && currentHighestCombatant.PosY < 116) safeZone1 = output.south();
      if (currentHighestCombatant.PosX > 84 && currentHighestCombatant.PosX < 94) safeZone2 = output.west();else if (currentHighestCombatant.PosX > 106 && currentHighestCombatant.PosX < 116) safeZone2 = output.east();
      if (safeZone1 !== undefined && safeZone2 !== undefined) data.safeZone = output.twoDirs({
        dir1: safeZone1,
        dir2: safeZone2
      });else if (safeZone1 !== undefined) data.safeZone = output.oneDir({
        dir: safeZone1
      });else if (safeZone2 !== undefined) data.safeZone = output.oneDir({
        dir: safeZone2
      });else data.safeZone = undefined;
    },
    infoText: (data, _matches, output) => data.safeZone ?? output.unknown(),
    outputStrings: {
      oneDir: {
        en: '${dir}',
        de: '${dir}',
        fr: '${dir}',
        ja: '${dir}へ',
        cn: '去${dir}',
        ko: '${dir}으로'
      },
      twoDirs: {
        en: '${dir1}${dir2}',
        de: '${dir1}${dir2}',
        fr: '${dir1} ${dir2}',
        ja: '${dir1}${dir2}へ',
        cn: '去${dir2}${dir1}',
        ko: '${dir1}${dir2}으로'
      },
      unknown: outputs/* default.unknown */.Z.unknown,
      north: outputs/* default.north */.Z.north,
      south: outputs/* default.south */.Z.south,
      west: outputs/* default.west */.Z.west,
      east: outputs/* default.east */.Z.east
    }
  }, {
    id: 'E6S Superstorm',
    type: 'StartsUsing',
    netRegex: {
      source: 'Garuda',
      id: '4BF7',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe(),
    run: data => data.phase = 'garuda'
  }, {
    id: 'E6S Ferostorm',
    type: 'StartsUsing',
    netRegex: {
      source: ['Garuda', 'Raktapaksa'],
      id: ['4BF[EF]', '4C0[45]'],
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid green nails',
        de: 'Weiche den grünen Nägeln aus',
        fr: 'Évitez les griffes',
        ja: '緑の杭に避け',
        cn: '躲避风刃',
        ko: '초록 발톱 피하기'
      }
    }
  }, {
    id: 'E6S Air Bump',
    type: 'HeadMarker',
    netRegex: {
      id: '00D3'
    },
    suppressSeconds: 1,
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.enumerationOnYou();
      return output.enumeration();
    },
    outputStrings: {
      enumerationOnYou: {
        en: 'Enumeration on YOU',
        de: 'Enumeration aud DIR',
        fr: 'Énumération sur VOUS',
        ja: '自分にエアーバンプ',
        cn: '蓝圈分摊点名',
        ko: '2인 장판 대상자'
      },
      enumeration: {
        en: 'Enumeration',
        de: 'Enumeration',
        fr: 'Énumération',
        ja: 'エアーバンプ',
        cn: '蓝圈分摊',
        ko: '2인 장판'
      }
    }
  }, {
    id: 'E6S Touchdown',
    type: 'StartsUsing',
    netRegex: {
      source: 'Ifrit',
      id: '4C09',
      capture: false
    },
    run: data => data.phase = 'ifrit'
  }, {
    id: 'E6S Inferno Howl',
    type: 'StartsUsing',
    netRegex: {
      source: ['Ifrit', 'Raktapaksa'],
      id: '4C14',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Save ability state since the generic tether used has multiple uses in this fight
    id: 'E6S Hands of Flame Start',
    type: 'StartsUsing',
    netRegex: {
      source: ['Ifrit', 'Raktapaksa'],
      id: '4D00',
      capture: false
    },
    preRun: data => data.handsOfFlame = true
  }, {
    // Tank swap if you're not the target
    // Break tether if you're the target during Ifrit+Garuda phase
    id: 'E6S Hands of Flame Tether',
    type: 'Tether',
    netRegex: {
      id: '0068'
    },
    condition: data => data.handsOfFlame,
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.chargeOnYou();
      if (data.role !== 'tank' || data.phase === 'both') return;
      return output.tankSwap();
    },
    outputStrings: {
      chargeOnYou: {
        en: 'Charge on YOU',
        de: 'Ansturm auf DIR',
        fr: 'Charge sur VOUS',
        ja: '自分に突進',
        cn: '冲锋点名',
        ko: '나에게 보스 돌진'
      },
      tankSwap: outputs/* default.tankSwap */.Z.tankSwap
    }
  }, {
    id: 'E6S Hands of Flame Cast',
    type: 'Ability',
    netRegex: {
      source: ['Ifrit', 'Raktapaksa'],
      id: '4D00',
      capture: false
    },
    preRun: data => data.handsOfFlame = false,
    suppressSeconds: 1
  }, {
    id: 'E6S Instant Incineration',
    type: 'StartsUsing',
    netRegex: {
      source: ['Ifrit', 'Raktapaksa'],
      id: '4C0E'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E6S Meteor Strike',
    type: 'StartsUsing',
    netRegex: {
      source: ['Ifrit', 'Raktapaksa'],
      id: '4C0F',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'E6S Hands of Hell',
    type: 'HeadMarker',
    netRegex: {
      id: '0016'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tether Marker on YOU',
        de: 'Verbindung auf DIR',
        fr: 'Marque de lien sur VOUS',
        ja: '自分に線マーカー',
        cn: '连线点名',
        ko: '선 징 대상자'
      }
    }
  }, {
    id: 'E6S Hated of the Vortex',
    type: 'StartsUsing',
    netRegex: {
      source: 'Garuda',
      id: '4F9F',
      capture: false
    },
    run: data => data.phase = 'both'
  }, {
    id: 'E6S Hated of the Vortex Effect',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8BB'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Attack Garuda',
        de: 'Greife Garuda an',
        fr: 'Attaquez Garuda',
        ja: 'ガルーダに攻撃',
        cn: '打风神',
        ko: '가루다 공격하기'
      }
    }
  }, {
    id: 'E6S Hated of the Embers Effect',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8BC'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Attack Ifrit',
        de: 'Greife Ifrit an',
        fr: 'Attaquez Ifrit',
        ja: 'イフリートに攻撃',
        cn: '打火神',
        ko: '이프리트 공격하기'
      }
    }
  }, {
    id: 'E6S Raktapaksa Spawn',
    type: 'Ability',
    netRegex: {
      source: 'Raktapaksa',
      id: '4D55',
      capture: false
    },
    run: data => data.phase = 'raktapaksa'
  }, {
    id: 'E6S Downburst Knockback 1',
    type: 'StartsUsing',
    netRegex: {
      source: 'Garuda',
      id: '4BFB',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'E6S Downburst Knockback 2',
    type: 'StartsUsing',
    netRegex: {
      source: 'Raktapaksa',
      id: '4BFC',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'E6S Conflag Strike',
    type: 'StartsUsing',
    netRegex: {
      source: 'Raktapaksa',
      id: '4C10',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'go to spots for chains',
        de: 'Gehe zu den Stellen für die Kette',
        fr: 'Positions pour les chaines',
        ja: '安置へ、鎖が繋がれる',
        cn: '连线站位',
        ko: '대화재 준비'
      }
    }
  }, {
    id: 'E6S Irons Of Purgatory',
    type: 'Tether',
    netRegex: {
      id: '006C'
    },
    condition: (data, matches) => data.me === matches.target || data.me === matches.source,
    alertText: (data, matches, output) => {
      if (data.me === matches.source) return output.tetheredToPlayer({
        player: data.party.member(matches.target)
      });
      return output.tetheredToPlayer({
        player: data.party.member(matches.source)
      });
    },
    outputStrings: {
      tetheredToPlayer: {
        en: 'Tethered to ${player}',
        de: 'Verbunden mit ${player}',
        fr: 'Lié à ${player}',
        ja: '${player}と繋がった',
        cn: '和${player}连线',
        ko: '선 연결 짝: ${player}'
      }
    }
  }, {
    id: 'E6S Conflag Strike Behind',
    type: 'StartsUsing',
    netRegex: {
      source: 'Raktapaksa',
      id: '4C10',
      capture: false
    },
    delaySeconds: 31,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Twisting Blaze': 'Feuersturm',
      'Tumultuous Nexus': 'Orkankugel',
      'Raktapaksa': 'Raktapaksa',
      'Ifrit': 'Ifrit',
      'Garuda': 'Garuda'
    },
    'replaceText': {
      'Wind Cutter': 'Schneidender Wind',
      'Vacuum Slice': 'Vakuumschnitt',
      'Touchdown': 'Himmelssturz',
      'Superstorm': 'Sturm der Zerstörung',
      'Strike Spark': 'Feuerfunken',
      'Storm Of Fury': 'Wütender Sturm',
      'Spread Of Fire': 'Ausbreitung des Feuers',
      'Radiant Plume': 'Scheiterhaufen',
      'Occluded Front': 'Okklusion',
      'Meteor Strike': 'Meteorit',
      'Irresistible Pull': 'Saugkraft',
      'Instant Incineration': 'Explosive Flamme',
      'Inferno Howl': 'Glühendes Gebrüll',
      'Hot Foot': 'Fliegendes Feuer',
      'Heat Burst': 'Hitzewelle',
      'Hated Of Embers': 'Fluch der Flammen',
      'Hands Of Hell': 'Faust des Schicksals',
      'Hands Of Flame': 'Flammenfaust',
      'Firestorm': 'Feuersturm',
      'Ferostorm': 'Angststurm',
      'Explosion': 'Explosion',
      'Eruption': 'Eruption',
      'Downburst': 'Fallböe',
      'Conflag Strike': 'Feuersbrunst',
      'Call Of The Inferno': 'Flimmernde Hitze',
      'Blaze': 'Flamme',
      'Air Bump': 'Aufsteigende Böe'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'twisting blaze': 'Vortex enflammé',
      'tumultuous nexus': 'Rafale',
      'Raktapaksa': 'Raktapaksa',
      'Ifrit': 'Ifrit',
      'Garuda': 'Garuda'
    },
    'replaceText': {
      'Wind Cutter': 'Trancheur de vent',
      'Vacuum Slice': 'Lacération du vide',
      'Touchdown': 'Atterrissage',
      'Superstorm': 'Tempête dévastatrice',
      'Strike Spark': 'Ignescences',
      'Storm Of Fury': 'Tempête déchaînée',
      'Spread Of Fire': 'Océan de feu',
      'Radiant Plume': 'Panache radiant',
      'Occluded Front': 'Front occlus',
      'Meteor Strike': 'Frappe de météore',
      'Irresistible Pull': 'Force d\'aspiration',
      'Instant Incineration': 'Uppercut enflammé',
      'Inferno Howl': 'Rugissement ardent',
      'Hot Foot': 'Jet d\'ignescence',
      'Heat Burst': 'Vague de chaleur',
      'Hated Of Embers/Vortex': 'Malédiction des flammes/de rafales',
      'Hands Of Hell': 'Frappe purgatrice',
      'Hands Of Flame': 'Frappe enflammée',
      'Firestorm': 'Tempête de feu',
      'Ferostorm': 'Tempête déchaînée',
      'Explosion': 'Explosion',
      'Eruption': 'Éruption',
      'Downburst': 'Rafale descendante',
      'Conflag Strike': 'Ekpurosis',
      'Call Of The Inferno': 'Mirage de chaleur',
      'Blaze': 'Fournaise',
      'Air Bump': 'Rafale ascendante'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'twisting blaze': '火炎旋風',
      'tumultuous nexus': '暴風球',
      'Raktapaksa': 'ラクタパクシャ',
      'Ifrit': 'イフリート',
      'Garuda': 'ガルーダ'
    },
    'replaceText': {
      'Wind Cutter': 'ウィンドカッター',
      'Vacuum Slice': 'バキュームスラッシュ',
      'Touchdown': 'タッチダウン',
      'Superstorm': 'スーパーストーム',
      'Strike Spark': 'ファイアスパーク',
      'Storm Of Fury': 'フューリアスストーム',
      'Spread Of Fire': 'スプレッド・オブ・ファイア',
      'Radiant Plume': '光輝の炎柱',
      'Occluded Front': 'オクルーデッドフロント',
      'Meteor Strike': 'メテオストライク',
      'Irresistible Pull': '吸引力',
      'Instant Incineration': '爆裂炎',
      'Inferno Howl': '灼熱の咆哮',
      'Hot Foot': '飛び火',
      'Heat Burst': '熱波',
      'Hated Of Embers': '焔神の呪い',
      'Hands Of Hell': '業炎拳',
      'Hands Of Flame': '火炎拳',
      'Firestorm': 'ファイアストーム',
      'Ferostorm': 'フィアスストーム',
      'Explosion': '爆散',
      'Eruption': 'エラプション',
      'Downburst': 'ダウンバースト',
      'Conflag Strike': 'コンフラグレーションストライク',
      'Call Of The Inferno': '陽炎召喚',
      'Blaze': '火炎',
      'Air Bump': 'エアーバンプ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Garuda': '迦楼罗',
      'Tumultuous Nexus': '暴风球',
      'Ifrit': '伊弗利特',
      'Raktapaksa': '赤翼罗羯坨博叉',
      'Twisting Blaze': '火焰旋风'
    },
    'replaceText': {
      'Superstorm': '超级风暴',
      'Occluded Front': '锢囚锋',
      'Wind Cutter': '风刃',
      'Storm Of Fury': '暴怒风暴',
      'Air Bump': '空气弹垫',
      'Ferostorm': '凶猛风暴',
      'Downburst': '下行突风',
      'Vacuum Slice': '真空斩',
      'Irresistible Pull': '吸引力',
      'Explosions?': '爆炸',
      'Touchdown': '空降',
      'Hands Of Flame': '火焰拳',
      'Eruption': '地火喷发',
      'Instant Incineration': '爆裂炎',
      'Meteor Strike': '流星强击',
      'Inferno Howl': '灼热的咆哮',
      'Hands Of Hell': '业火拳',
      'Strike Spark': '火花爆',
      'Call Of The Inferno': '幻影召唤',
      'Hot Foot': '飞火',
      'Hated Of Embers/Vortex': '火/风神的诅咒',
      'Firestorm': '火焰流',
      'Heat Burst': '热波',
      'Radiant Plume': '光辉炎柱',
      'Spread Of Fire': '火势蔓延',
      'Conflag Strike': '瞬燃强袭',
      'Blaze': '炎爆'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Garuda': '가루다',
      'Tumultuous Nexus': '폭풍구',
      'Ifrit': '이프리트',
      'Raktapaksa': '락타팍샤',
      'Twisting Blaze': '화염 선풍'
    },
    'replaceText': {
      'Superstorm': '초폭풍',
      'Occluded Front': '폐색 전선',
      'Wind Cutter': '바람 칼날',
      'Storm Of Fury': '분노의 폭풍',
      'Air Bump': '상향 기류',
      'Ferostorm': '사나운 폭풍',
      'Downburst': '하강 기류',
      'Vacuum Slice': '진공베기',
      'Irresistible Pull': '흡인력',
      'Explosion': '폭산',
      'Touchdown': '착지',
      'Hands Of Flame': '화염권',
      'Eruption': '용암 분출',
      'Instant Incineration': '폭렬염',
      'Meteor Strike': '메테오 스트라이크',
      'Inferno Howl': '작열의 포효',
      'Hands Of Hell': '업염권',
      'Strike Spark': '불놀이',
      'Call Of The Inferno': '아지랑이 소환',
      'Hot Foot': '불똥',
      'Hated Of Embers/Vortex': '화염신/바람신의 저주',
      'Firestorm': '불보라',
      'Heat Burst': '열파',
      'Radiant Plume': '광휘의 불기둥',
      'Spread Of Fire': '불꽃 확산',
      'Conflag Strike': '대화재',
      'Blaze': '화염'
    }
  }]
};
/* harmony default export */ const e6s = (e6s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e6s.txt
const raid_e6s_namespaceObject = "### Eden 6 (Savage)\r\n# Eden's Verse: Furor\r\n# -p 4BF7:18 4C09:122 4FA0:248.4 4BF8:320.4\r\n# -ii 4C00 4BFA 4BD1 4BFE 4C20 4BD0 4E39 4D00 4C0B 4C0C 4C1F 4C1D 4C13 4C16 4C07 4C05 4C04\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1: Garuda\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n18.0 \"Superstorm\" Ability { id: \"4BF7\", source: \"Garuda\" } window 18,20\r\n27.1 \"Occluded Front\" Ability { id: \"4BD2\", source: \"Garuda\" }\r\n36.2 \"Wind Cutter\" Ability { id: \"4C02\", source: \"Tumultuous Nexus\" }\r\n39.2 \"Storm Of Fury\" Ability { id: \"4C01\", source: \"Garuda\" }\r\n46.8 \"Air Bump\" Ability { id: \"4BF9\", source: \"Garuda\" }\r\n64.0 \"Ferostorm\" Ability { id: \"4BFD\", source: \"Garuda\" }\r\n73.6 \"Downburst\" Ability { id: \"4BFB\", source: \"Garuda\" }\r\n76.1 \"Air Bump\" Ability { id: \"4BF9\", source: \"Garuda\" }\r\n88.0 \"Vacuum Slice\" Ability { id: \"4BF5\", source: \"Garuda\" }\r\n95.2 \"Occluded Front\" Ability { id: \"4BD2\", source: \"Garuda\" }\r\n103.3 \"Storm Of Fury\" Ability { id: \"4C01\", source: \"Garuda\" }\r\n104.7 \"Irresistible Pull\" Ability { id: \"4BF6\", source: \"Garuda\" }\r\n105.5 \"Explosions\" #Ability { id: \"4C03\", source: \"Tumultuous Nexus\" }\r\n110.8 \"Ferostorm\" Ability { id: \"4BFD\", source: \"Garuda\" }\r\n119.0 \"--untargetable--\"\r\n\r\n### Phase 2: Ifrit\r\n122.0 \"Touchdown\" Ability { id: \"4C09\", source: \"Ifrit\" }\r\n135.3 \"Hands Of Flame\" Ability { id: \"4C0A\", source: \"Ifrit\" }\r\n139.6 \"Eruption\" Ability { id: \"4C17\", source: \"Ifrit\" }\r\n143.5 \"Instant Incineration\" Ability { id: \"4C0E\", source: \"Ifrit\" }\r\n147.1 \"Meteor Strike\" Ability { id: \"4C0F\", source: \"Ifrit\" }\r\n159.2 \"Inferno Howl\" Ability { id: \"4C14\", source: \"Ifrit\" }\r\n172.3 \"Hands Of Hell\" Ability { id: \"4D01\", source: \"Ifrit\" }\r\n176.9 \"Eruption\" Ability { id: \"4C17\", source: \"Ifrit\" }\r\n184.7 \"Strike Spark\" Ability { id: \"4BD3\", source: \"Ifrit\" }\r\n187.9 \"Call Of The Inferno\" Ability { id: \"4C12\", source: \"Ifrit\" }\r\n197.1 \"Hot Foot\" Ability { id: \"4C11\", source: \"Ifrit\" }\r\n198.5 \"Eruption\" Ability { id: \"4C17\", source: \"Ifrit\" }\r\n215.1 \"Hands Of Hell\" Ability { id: \"4D01\", source: \"Ifrit\" }\r\n219.8 \"Eruption\" Ability { id: \"4C17\", source: \"Ifrit\" }\r\n223.9 \"Hands Of Flame\" Ability { id: \"4C0A\", source: \"Ifrit\" }\r\n228.2 \"Eruption\" Ability { id: \"4C17\", source: \"Ifrit\" }\r\n232.1 \"Instant Incineration\" Ability { id: \"4C0E\", source: \"Ifrit\" }\r\n235.7 \"Meteor Strike\" Ability { id: \"4C0F\", source: \"Ifrit\" }\r\n241.1 \"--untargetable--\"\r\n\r\n### Phase 3: Garuda and Ifrit\r\n245.4 \"--targetable--\"\r\n248.4 \"Hated Of Embers/Vortex\" Ability { id: \"4FA0\", source: \"Ifrit\" }\r\n253.6 \"Occluded Front\" Ability { id: \"4BD2\", source: \"Garuda\" }\r\n262.7 \"Wind Cutter\" Ability { id: \"4C02\", source: \"Tumultuous Nexus\" }\r\n265.1 \"Hands Of Flame\" Ability { id: \"4C0A\", source: \"Ifrit\" }\r\n269.4 \"Eruption\" Ability { id: \"4C17\", source: \"Ifrit\" }\r\n273.3 \"Instant Incineration\" Ability { id: \"4C0E\", source: \"Ifrit\" }\r\n276.9 \"Meteor Strike\" Ability { id: \"4C0F\", source: \"Ifrit\" }\r\n277.0 \"Vacuum Slice\" Ability { id: \"4BF5\", source: \"Garuda\" }\r\n280.1 \"Call Of The Inferno\" Ability { id: \"4C12\", source: \"Ifrit\" }\r\n284.2 \"Occluded Front\" Ability { id: \"4BD2\", source: \"Garuda\" }\r\n291.8 \"Hot Foot\" Ability { id: \"4C11\", source: \"Ifrit\" }\r\n293.7 \"Irresistible Pull\" Ability { id: \"4BF6\", source: \"Garuda\" }\r\n293.7 \"Eruption\" Ability { id: \"4C17\", source: \"Ifrit\" }\r\n294.5 \"Explosion\" Ability { id: \"4C03\", source: \"Tumultuous Nexus\" }\r\n294.5 \"Explosion\" Ability { id: \"4C03\", source: \"Tumultuous Nexus\" }\r\n294.5 \"Explosion\" Ability { id: \"4C03\", source: \"Tumultuous Nexus\" }\r\n294.5 \"Explosion\" Ability { id: \"4C03\", source: \"Tumultuous Nexus\" }\r\n298.6 \"Ferostorm\" Ability { id: \"4BFD\", source: \"Garuda\" }\r\n303.2 \"--untargetable--\"\r\n\r\n### Phase 4: Raktapaksa\r\n309.6 \"--sync--\" Ability { id: \"4D55\", source: \"Raktapaksa\" }\r\n320.4 \"Firestorm\" Ability { id: \"4BF8\", source: \"Raktapaksa\" } window 350,5\r\n324.5 \"--targetable--\"\r\n343.8 \"Hands Of Hell\" Ability { id: \"4D01\", source: \"Raktapaksa\" }\r\n348.1 \"Heat Burst\" Ability { id: \"4C0D\", source: \"Raktapaksa\" }\r\n348.3 \"Eruption\" Ability { id: \"4C17\", source: \"Raktapaksa\" }\r\n361.1 \"Hands Of Hell\" Ability { id: \"4D01\", source: \"Raktapaksa\" }\r\n365.5 \"Heat Burst\" Ability { id: \"4C0D\", source: \"Raktapaksa\" }\r\n365.7 \"Eruption\" Ability { id: \"4C17\", source: \"Raktapaksa\" }\r\n376.5 \"Inferno Howl\" Ability { id: \"4C14\", source: \"Raktapaksa\" }\r\n384.1 \"Air Bump\" Ability { id: \"4BF9\", source: \"Raktapaksa\" }\r\n387.1 \"Ferostorm\" Ability { id: \"4C06\", source: \"Raktapaksa\" }\r\n\r\n394.8 \"Strike Spark\" Ability { id: \"4BD3\", source: \"Raktapaksa\" }\r\n398.0 \"Call Of The Inferno\" Ability { id: \"4C12\", source: \"Raktapaksa\" }\r\n407.2 \"Hot Foot\" Ability { id: \"4C11\", source: \"Raktapaksa\" }\r\n408.6 \"Eruption\" Ability { id: \"4C17\", source: \"Raktapaksa\" }\r\n411.0 \"Hands Of Flame\" Ability { id: \"4C0A\", source: \"Raktapaksa\" }\r\n415.0 \"Heat Burst\" Ability { id: \"4C0D\", source: \"Raktapaksa\" }\r\n415.3 \"Eruption\" Ability { id: \"4C17\", source: \"Raktapaksa\" }\r\n419.2 \"Instant Incineration\" Ability { id: \"4C0E\", source: \"Raktapaksa\" }\r\n423.0 \"Meteor Strike\" Ability { id: \"4C0F\", source: \"Raktapaksa\" }\r\n436.7 \"Downburst\" Ability { id: \"4BFC\", source: \"Raktapaksa\" }\r\n436.7 \"--untargetable--\"\r\n\r\n441.0 \"--targetable--\"\r\n445.2 \"--sync--\" Ability { id: \"4C19\", source: \"Raktapaksa\" }\r\n449.2 \"Radiant Plume\" Ability { id: \"4C15\", source: \"Raktapaksa\" }\r\n457.3 \"Blaze 1\" #Ability { id: \"4C1B\", source: \"Twisting Blaze\" }\r\n459.4 \"Blaze 2\" #Ability { id: \"4C1B\", source: \"Twisting Blaze\" }\r\n459.8 \"Wind Cutter\" #Ability { id: \"4C02\", source: \"Tumultuous Nexus\" }\r\n461.5 \"Blaze 3\" #Ability { id: \"4C1B\", source: \"Twisting Blaze\" }\r\n462.8 \"Wind Cutter\" #Ability { id: \"4C02\", source: \"Tumultuous Nexus\" }\r\n463.6 \"Blaze 4\" #Ability { id: \"4C1B\", source: \"Twisting Blaze\" }\r\n465.7 \"Blaze 5\" #Ability { id: \"4C1B\", source: \"Twisting Blaze\" }\r\n465.8 \"Wind Cutter\" #Ability { id: \"4C02\", source: \"Tumultuous Nexus\" }\r\n472.3 \"Spread Of Fire\" Ability { id: \"4C18\", source: \"Raktapaksa\" }\r\n472.8 \"Air Bump\" Ability { id: \"4BF9\", source: \"Raktapaksa\" }\r\n476.0 \"Conflag Strike\" Ability { id: \"4C10\", source: \"Raktapaksa\" }\r\n\r\n490.2 \"Occluded Front\" Ability { id: \"4E4C\", source: \"Raktapaksa\" }\r\n494.7 \"Air Bump\" Ability { id: \"4BF9\", source: \"Raktapaksa\" }\r\n499.2 \"Wind Cutter\" Ability { id: \"4C02\", source: \"Tumultuous Nexus\" }\r\n502.2 \"Storm Of Fury\" Ability { id: \"4C08\", source: \"Raktapaksa\" }\r\n509.4 \"Inferno Howl\" Ability { id: \"4C14\", source: \"Raktapaksa\" }\r\n520.5 \"Occluded Front\" Ability { id: \"4E4C\", source: \"Raktapaksa\" }\r\n529.6 \"Wind Cutter\" Ability { id: \"4C02\", source: \"Tumultuous Nexus\" }\r\n\r\n530.6 \"Hands Of Hell\" Ability { id: \"4D01\", source: \"Raktapaksa\" }\r\n535.0 \"Heat Burst\" Ability { id: \"4C0D\", source: \"Raktapaksa\" }\r\n535.2 \"Eruption\" Ability { id: \"4C17\", source: \"Raktapaksa\" }\r\n546.6 \"Air Bump\" Ability { id: \"4BF9\", source: \"Raktapaksa\" }\r\n\r\n548.1 \"Hands Of Hell\" Ability { id: \"4D01\", source: \"Raktapaksa\" }\r\n552.4 \"Heat Burst\" Ability { id: \"4C0D\", source: \"Raktapaksa\" }\r\n552.6 \"Eruption\" Ability { id: \"4C17\", source: \"Raktapaksa\" }\r\n556.7 \"Hands Of Flame\" Ability { id: \"4C0A\", source: \"Raktapaksa\" }\r\n560.7 \"Heat Burst\" Ability { id: \"4C0D\", source: \"Raktapaksa\" }\r\n561.0 \"Eruption\" Ability { id: \"4C17\", source: \"Raktapaksa\" }\r\n565.0 \"Instant Incineration\" Ability { id: \"4C0E\", source: \"Raktapaksa\" }\r\n568.7 \"Meteor Strike\" Ability { id: \"4C0F\", source: \"Raktapaksa\" }\r\n586.4 \"Ferostorm\" Ability { id: \"4C06\", source: \"Raktapaksa\" }\r\n594.5 \"Ferostorm\" Ability { id: \"4C06\", source: \"Raktapaksa\" }\r\n\r\n603.3 \"Downburst\" Ability { id: \"4BFC\", source: \"Raktapaksa\" }\r\n603.3 \"--untargetable--\"\r\n607.6 \"--targetable--\"\r\n619.6 \"Conflag Strike Enrage\" Ability { id: \"4C1C\", source: \"Raktapaksa\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e7n.ts



const e7n_triggerSet = {
  id: 'EdensVerseIconoclasm',
  zoneId: zone_id/* default.EdensVerseIconoclasm */.Z.EdensVerseIconoclasm,
  timelineFile: 'e7n.txt',
  triggers: [{
    id: 'E7N Empty Wave',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Idol Of Darkness',
      id: '4C52',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E7N Unshadowed Stake',
    type: 'Tether',
    netRegex: {
      source: 'The Idol Of Darkness',
      id: '0025'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E7N Left With Thee',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8C2'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Teleporting Left',
        de: 'Nach Links teleportieren',
        fr: 'Téléportation à gauche',
        ja: '左にテレポ',
        cn: '向左传送',
        ko: '왼쪽으로 순간이동'
      }
    }
  }, {
    id: 'E7N Right With Thee',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8C3'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Teleporting Right',
        de: 'Nach Rechts teleportieren',
        fr: 'Téléportation à droite',
        ja: '右にテレポ',
        cn: '向右传送',
        ko: '오른쪽으로 순간이동'
      }
    }
  }, {
    id: 'E7N Forward With Thee',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8C0'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Teleporting Forward',
        de: 'Teleportation Vorwärts',
        fr: 'Téléportation devant',
        ja: '前にテレポ',
        cn: '向前传送',
        ko: '앞으로 순간이동'
      }
    }
  }, {
    id: 'E7N Back With Thee',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8C1'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Teleporting Back',
        de: 'Teleportation Rückwärts',
        fr: 'Téléportation derrière',
        ja: '後ろにテレポ',
        cn: '向后传送',
        ko: '뒤로 순간이동'
      }
    }
  }, {
    id: 'E7N Strength In Numbers Donut',
    type: 'StartsUsing',
    netRegex: {
      source: 'Idolatry',
      id: '4C4C',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Teleport into donut',
        de: 'In den Donut teleportieren',
        fr: 'Téléportez vous dans le donut',
        ja: 'ドーナツにテレポ',
        cn: '传送进月环',
        ko: '도넛 장판 안으로 순간이동하기'
      }
    }
  }, {
    // Ordinarily we might not warn on ground AoE markers. However, there are player-dropped
    // markers just before this, so it might be difficult to see.
    id: 'E7N Strength In Numbers Circle',
    type: 'StartsUsing',
    netRegex: {
      source: 'Idolatry',
      id: '4C4D',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    // For this and the following trigger, we warn the user only if they
    // will be struck by a color before their debuff expires.
    id: 'E7N Astral Effect',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8BE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 3,
    infoText: (data, _matches, output) => {
      data.colorCount = (data.colorCount ?? 0) + 1;
      if (data.colorCount === 3) {
        delete data.colorCount;
        return;
      }
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'Get hit by dark',
        de: 'Vom Dunklen treffen lassen',
        fr: 'Encaissez le noir',
        ja: '黒色を受ける',
        cn: '吃黑色',
        ko: '어둠 맞기'
      }
    }
  }, {
    id: 'E7N Umbral Effect',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8BF'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 3,
    infoText: (data, _matches, output) => {
      data.colorCount = (data.colorCount ?? 0) + 1;
      if (data.colorCount === 3) {
        delete data.colorCount;
        return;
      }
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'Get hit by light',
        de: 'Vom Hellen treffen lassen',
        fr: 'Encaissez le blanc',
        ja: '白色を受ける',
        cn: '吃白色',
        ko: '빛 맞기'
      }
    }
  }, {
    // Safety in case the user dies during Dark/Light Course.
    id: 'E7N Away With Thee Color Cleanup',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Idol Of Darkness',
      id: '4C39',
      capture: false
    },
    run: data => delete data.colorCount
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Unforgiven Idolatry': 'ungeläuterte Götzenverehrung',
      'The Idol Of Darkness': 'Götzenbild der Dunkelheit',
      '(?<! )Idolatry': 'Idolatrie'
    },
    'replaceText': {
      'Words of Night': 'Kommando: Nächtlicher Angriff',
      'Words of Motion': 'Kommando: Wellen',
      'Unshadowed Stake': 'Dunkler Nagel',
      'Unjoined Aspect': 'Attributswechsel',
      'Stygian Sword': 'Schwarzes Schwert',
      'Strength in Numbers': 'Angriffsmanöver',
      'Silver Sledge': 'Weißer Lichthammer',
      'Silver Shot': 'Weißer Lichtpfeil',
      'Light\'s Course': 'Weißer Strom des Lichts',
      'False Twilight': 'Dämmerungsmanöver',
      'Explosion': 'Explosion',
      'Empty Wave': 'Welle der Leere',
      'Empty Flood': 'Flut der Leere',
      'Dark\'s Course': 'Schwarzer Strom der Finsternis',
      'Black Smoke': 'Schwarzes Feuer',
      'Betwixt Worlds': 'Dimensionsloch',
      'Away with Thee': 'Zwangsumwandlung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'unforgiven idolatry': 'Nuée D\'idolâtries Impardonnables',
      'the Idol of Darkness': 'Idole des Ténèbres',
      '(?<! )idolatry': 'Vol D\'idolâtries Impardonnables'
    },
    'replaceText': {
      'Words of Night': 'Ordre d\'attaque-surprise',
      'Words of Motion': 'Ordre de déferlement',
      'Unshadowed Stake': 'Poinçon clair-obscur',
      'Unjoined Aspect': 'Transition élémentaire',
      'Stygian Sword': 'Épée ténébreuse',
      'Strength in Numbers': 'Murmuration offensive',
      'Silver Sledge': 'Pilon immaculé',
      'Silver Shot': 'Trait immaculé',
      'Light\'s Course': 'Déferlement immaculé',
      'False Twilight': 'Murmuration du crépuscule',
      'Explosion': 'Explosion',
      'Empty Wave': 'Onde de néant',
      'Empty Flood': 'Déluge de néant',
      'Dark\'s Course': 'Déferlement ténébreux',
      'Black Smoke': 'Brûlure ténébreuse',
      'Betwixt Worlds': 'Brèche dimensionnelle',
      'Away with Thee': 'Translation forcée'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'unforgiven idolatry': 'アンフォーギヴン・アイドラトリー',
      'the Idol of Darkness': 'ダークアイドル',
      '(?<! )idolatry': 'アイドラトリー'
    },
    'replaceText': {
      'Words of Night': '夜襲の号令',
      'Words of Motion': '波状の号令',
      'Unshadowed Stake': '闇光の釘',
      'Unjoined Aspect': '属性変動',
      'Stygian Sword': '黒闇の剣',
      'Strength in Numbers': '攻撃機動',
      'Silver Sledge': '白光の槌',
      'Silver Shot': '白光の矢',
      'Light\'s Course': '白光の奔流',
      'False Twilight': '薄暮の機動',
      'Explosion': '爆散',
      'Empty Wave': '虚無の波動',
      'Empty Flood': '虚無の氾濫',
      'Dark\'s Course': '黒闇の奔流',
      'Black Smoke': '黒闇の火',
      'Betwixt Worlds': '次元孔',
      'Away with Thee': '強制転移'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'The Idol Of Darkness': '暗黑心象',
      'Unforgiven Idolatry': '未被宽恕的盲崇',
      '(?<! )Idolatry': '盲崇'
    },
    'replaceText': {
      'Empty Wave': '虚无波动',
      'Unshadowed Stake': '暗光钉',
      'Words of Motion': '波状号令',
      'Light\'s Course': '白光奔流',
      'Dark\'s Course': '黑暗奔流',
      'Betwixt Worlds': '次元孔',
      'Away with Thee': '强制传送',
      'False Twilight': '薄暮机动',
      'Stygian Sword': '黑暗之剑',
      'Silver Sledge': '白光之锤',
      'Unjoined Aspect': '属性变动',
      'Words of Night': '夜袭号令',
      'Strength in Numbers': '攻击机动',
      'Silver Shot': '白光之矢',
      'Explosion': '爆炸',
      'Empty Flood': '虚无泛滥',
      'Black Smoke': '黑暗之火'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'The Idol Of Darkness': '어둠의 우상',
      'Unforgiven Idolatry': '면죄되지 않은 숭배',
      '(?<! )Idolatry': '숭배'
    },
    'replaceText': {
      'Empty Wave': '허무의 파동',
      'Unshadowed Stake': '암광의 못',
      'Words of Motion': '파상의 호령',
      'Light\'s Course': '백광의 급류',
      'Dark\'s Course': '흑암의 급류',
      'Betwixt Worlds': '차원 구멍',
      'Away with Thee': '강제 전송',
      'False Twilight': '황혼 기동',
      'Stygian Sword': '흑암의 검',
      'Silver Sledge': '백광의 망치',
      'Unjoined Aspect': '속성 변동',
      'Words of Night': '야습의 호령',
      'Strength in Numbers': '공격 기동',
      'Silver Shot': '백광의 화살',
      'Explosion': '폭산',
      'Empty Flood': '허무의 범람',
      'Black Smoke': '흑암의 불'
    }
  }]
};
/* harmony default export */ const e7n = (e7n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e7n.txt
const raid_e7n_namespaceObject = "### Eden 7 (Normal)\r\n# Eden's Verse: Iconoclasm\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# -ii 4C30 4C32 4C33 4C36 4C3A 4C49 4D0A 4D0B\r\n\r\n# Opening block\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n12.8 \"Empty Wave\" Ability { id: \"4C52\", source: \"The Idol Of Darkness\" } window 12.8,30\r\n25.0 \"Unshadowed Stake\" Ability { id: \"4C51\", source: \"The Idol Of Darkness\" }\r\n37.8 \"Words of Motion\" Ability { id: \"4C2B\", source: \"The Idol Of Darkness\" } window 30,30\r\n49.6 \"Light's Course\" # Ability { id: \"4C3C\", source: \"Unforgiven Idolatry\" }\r\n52.6 \"Light's Course\" # Ability { id: \"4C3C\", source: \"Unforgiven Idolatry\" }\r\n55.5 \"Betwixt Worlds\" Ability { id: \"4CF8\", source: \"The Idol Of Darkness\" } window 20,20\r\n72.7 \"Light's Course\" # Ability { id: [\"4E63\", \"4C3C\"], source: \"Unforgiven Idolatry\" }\r\n75.7 \"Light's Course\" # Ability { id: [\"4E63\", \"4C3C\"], source: \"Unforgiven Idolatry\" }\r\n78.7 \"Light's Course\" # Ability { id: \"4C40\", source: \"Unforgiven Idolatry\" }\r\n81.7 \"Light's Course\" # Ability { id: \"4C40\", source: \"Unforgiven Idolatry\" }\r\n88.7 \"Betwixt Worlds\" Ability { id: \"4CF8\", source: \"The Idol Of Darkness\" }\r\n104.9 \"Light's Course\" # Ability { id: [\"4E63\", \"4C3C\"], source: \"Unforgiven Idolatry\" }\r\n107.9 \"Light's Course\" # Ability { id: [\"4E63\", \"4C3C\"], source: \"Unforgiven Idolatry\" }\r\n110.8 \"Light's Course\" # Ability { id: \"4C40\", source: \"Unforgiven Idolatry\" }\r\n113.8 \"Light's Course\" # Ability { id: \"4C40\", source: \"Unforgiven Idolatry\" }\r\n124.6 \"Away with Thee\" Ability { id: \"4C39\", source: \"The Idol Of Darkness\" } window 30,30\r\n141.8 \"False Twilight\" Ability { id: \"4C59\", source: \"The Idol Of Darkness\" }\r\n145.9 \"Stygian Sword\" Ability { id: \"4C55\", source: \"The Idol Of Darkness\" }\r\n150.9 \"Silver Sledge\" Ability { id: \"4C54\", source: \"The Idol Of Darkness\" }\r\n157.9 \"Empty Wave\" Ability { id: \"4C52\", source: \"The Idol Of Darkness\" }\r\n165.5 \"Unshadowed Stake\" Ability { id: \"4C51\", source: \"The Idol Of Darkness\" }\r\n175.7 \"Unjoined Aspect\" Ability { id: \"4C3B\", source: \"The Idol Of Darkness\" } window 30,30\r\n184.4 \"Words of Night\" Ability { id: \"4C2C\", source: \"The Idol Of Darkness\" }\r\n196.2 \"Dark's Course/Light's Course\" # Ability { id: \"4C3[CD]\", source: \"Unforgiven Idolatry\" }\r\n203.3 \"Dark's Course/Light's Course\" # Ability { id: \"4C2[23]\", source: \"Unforgiven Idolatry\" }\r\n210.3 \"Dark's Course/Light's Course\" # Ability { id: \"4C2[23]\", source: \"Unforgiven Idolatry\" }\r\n219.1 \"--untargetable--\"\r\n\r\n\r\n# Intermission block\r\n226.3 \"--targetable--\"\r\n236.8 \"Away with Thee\" Ability { id: [\"4C39\", \"4E7E\"], source: \"The Idol Of Darkness\" } window 30,30\r\n251.7 \"Strength in Numbers\" Ability { id: \"4C4[CD]\", source: \"Idolatry\" } window 251.7,5\r\n262.3 \"Silver Shot\" Ability { id: \"4E7[CD]\", source: \"The Idol Of Darkness\" }\r\n270.3 \"Silver Shot\" Ability { id: \"4E7[CD]\", source: \"The Idol Of Darkness\" }\r\n271.7 \"Strength in Numbers\" Ability { id: \"4C4[CD]\", source: \"Idolatry\" }\r\n281.7 \"Explosion enrage?\"\r\n\r\n\r\n# Rotation block. 135.6 seconds\r\n393.3 \"--sync--\" StartsUsing { id: [\"4E5[46]\", \"4C53\"], source: \"The Idol Of Darkness\" } window 400,20\r\n400.0 \"Empty Flood\" Ability { id: [\"4E5[46]\", \"4C53\"], source: \"The Idol Of Darkness\" } window 400,20\r\n410.3 \"--targetable--\"\r\n414.4 \"Unjoined Aspect\" Ability { id: \"4C3B\", source: \"The Idol Of Darkness\" }\r\n419.6 \"Betwixt Worlds\" Ability { id: \"4CF8\", source: \"The Idol Of Darkness\" }\r\n424.6 \"Words of Night\" Ability { id: \"4C2C\", source: \"The Idol Of Darkness\" } window 30,30\r\n436.8 \"Dark's Course/Light's Course\" # Ability { id: \"4C(3[CDE]|4[013])\", source: \"Unforgiven Idolatry\" }\r\n439.8 \"Dark's Course/Light's Course\" # Ability { id: \"4C(3[CDE]|4[013])\", source: \"Unforgiven Idolatry\" }\r\n449.9 \"Dark's Course/Light's Course\" # Ability { id: \"4C2[23]\", source: \"Unforgiven Idolatry\" }\r\n460.8 \"Away with Thee\" Ability { id: \"4C39\", source: \"The Idol Of Darkness\" } window 30,30\r\n475.9 \"Black Smoke\" Ability { id: \"4C56\", source: \"The Idol Of Darkness\" }\r\n485.1 \"Empty Wave\" Ability { id: \"4C52\", source: \"The Idol Of Darkness\" }\r\n492.7 \"Unshadowed Stake\" Ability { id: \"4C51\", source: \"The Idol Of Darkness\" }\r\n501.4 \"Words of Motion\" Ability { id: \"4C2B\", source: \"The Idol Of Darkness\" }\r\n505.6 \"Betwixt Worlds\" Ability { id: \"4CF8\", source: \"The Idol Of Darkness\" } window 30,30\r\n522.8 \"Light's Course\" # Ability { id: \"4C3[CE]\", source: \"Unforgiven Idolatry\" }\r\n525.8 \"Light's Course\" # Ability { id: \"4C3[CE]\", source: \"Unforgiven Idolatry\" }\r\n528.9 \"Light's Course\" # Ability { id: \"4C40\", source: \"Unforgiven Idolatry\" }\r\n532.0 \"False Twilight\" Ability { id: \"4C59\", source: \"The Idol Of Darkness\" }\r\n532.1 \"Light's Course\" # Ability { id: \"4C40\", source: \"Unforgiven Idolatry\" }\r\n536.0 \"Stygian Sword\" Ability { id: \"4C55\", source: \"The Idol Of Darkness\" } window 30,30\r\n541.0 \"Silver Sledge\" Ability { id: \"4C54\", source: \"The Idol Of Darkness\" }\r\n\r\n550.0 \"Unjoined Aspect\" Ability { id: \"4C3B\", source: \"The Idol Of Darkness\" }\r\n555.2 \"Betwixt Worlds\" Ability { id: \"4CF8\", source: \"The Idol Of Darkness\" }\r\n560.2 \"Words of Night\" Ability { id: \"4C2C\", source: \"The Idol Of Darkness\" } window 30,30\r\n572.4 \"Dark's Course/Light's Course\" # Ability { id: \"4C(3[CDE]|4[013])\", source: \"Unforgiven Idolatry\" }\r\n575.4 \"Dark's Course/Light's Course\" # Ability { id: \"4C(3[CDE]|4[013])\", source: \"Unforgiven Idolatry\" }\r\n585.5 \"Dark's Course/Light's Course\" # Ability { id: \"4C2[23]\", source: \"Unforgiven Idolatry\" }\r\n596.4 \"Away with Thee\" Ability { id: \"4C39\", source: \"The Idol Of Darkness\" } window 30,30\r\n611.5 \"Black Smoke\" Ability { id: \"4C56\", source: \"The Idol Of Darkness\" }\r\n620.7 \"Empty Wave\" Ability { id: \"4C52\", source: \"The Idol Of Darkness\" }\r\n628.3 \"Unshadowed Stake\" Ability { id: \"4C51\", source: \"The Idol Of Darkness\" }\r\n637.0 \"Words of Motion\" Ability { id: \"4C2B\", source: \"The Idol Of Darkness\" }\r\n641.2 \"Betwixt Worlds\" Ability { id: \"4CF8\", source: \"The Idol Of Darkness\" } window 30,30\r\n658.4 \"Light's Course\" # Ability { id: \"4C3[CE]\", source: \"Unforgiven Idolatry\" }\r\n661.4 \"Light's Course\" # Ability { id: \"4C3[CE]\", source: \"Unforgiven Idolatry\" }\r\n664.5 \"Light's Course\" # Ability { id: \"4C40\", source: \"Unforgiven Idolatry\" }\r\n667.6 \"False Twilight\" Ability { id: \"4C59\", source: \"The Idol Of Darkness\" }\r\n667.7 \"Light's Course\" # Ability { id: \"4C40\", source: \"Unforgiven Idolatry\" }\r\n671.6 \"Stygian Sword\" Ability { id: \"4C55\", source: \"The Idol Of Darkness\" } window 30,30\r\n676.6 \"Silver Sledge\" Ability { id: \"4C54\", source: \"The Idol Of Darkness\" } jump 541\r\n\r\n685.6 \"Unjoined Aspect\"\r\n690.8 \"Betwixt Worlds\"\r\n695.8 \"Words of Night\"\r\n708.0 \"Dark's Course/Light's Course\"\r\n711.0 \"Dark's Course/Light's Course\"\r\n721.1 \"Dark's Course/Light's Course\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e7s.ts




const colorMap = {
  light: {
    en: 'Dark',
    de: 'Dunkel',
    fr: 'Noir',
    ja: '黒',
    cn: '黑色',
    ko: '어둠'
  },
  dark: {
    en: 'Light',
    de: 'Licht',
    fr: 'Blanc',
    ja: '白',
    cn: '白色',
    ko: '빛'
  }
};
const e7s_triggerSet = {
  id: 'EdensVerseIconoclasmSavage',
  zoneId: zone_id/* default.EdensVerseIconoclasmSavage */.Z.EdensVerseIconoclasmSavage,
  timelineFile: 'e7s.txt',
  triggers: [{
    id: 'E7S Empty Wave',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Idol Of Darkness',
      id: '4C8A',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E7S Unshadowed Stake',
    type: 'Tether',
    netRegex: {
      source: 'The Idol Of Darkness',
      id: '0025'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E7S Betwixt Worlds',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Idol Of Darkness',
      id: '4CFD',
      capture: false
    },
    run: data => data.phase = 'betwixtWorlds'
  }, {
    id: 'E7S Betwixt Worlds Tether',
    type: 'Tether',
    netRegex: {
      source: 'The Idol Of Darkness',
      id: '0011'
    },
    condition: data => data.phase === 'betwixtWorlds',
    preRun: (data, matches) => {
      data.betwixtWorldsTethers ??= [];
      data.betwixtWorldsTethers.push(matches.target);
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    outputStrings: {
      text: {
        en: 'Tether on YOU',
        de: 'Verbindung auf DIR',
        fr: 'Lien sur VOUS',
        ja: '自分に線',
        cn: '连线点名',
        ko: '선 대상자'
      }
    }
  }, {
    id: 'E7S Betwixt Worlds Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '0064'
    },
    condition: data => data.phase === 'betwixtWorlds',
    preRun: (data, matches) => {
      data.betwixtWorldsStack ??= [];
      data.betwixtWorldsStack.push(matches.target);
    },
    alertText: (data, matches, output) => {
      data.betwixtWorldsTethers ??= [];
      if (data.betwixtWorldsTethers.includes(data.me)) return;
      if (data.me === matches.target) return output.stackOnYou();
      if (!data.betwixtWorldsStack || data.betwixtWorldsStack.length === 1) return;
      const names = data.betwixtWorldsStack.map(x => data.party.member(x)).sort();
      return output.stackOn({
        players: names
      });
    },
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOn: {
        en: 'Stack (${players})',
        de: 'Sammeln (${players})',
        fr: 'Package sur (${players})',
        ja: '頭割り (${players})',
        cn: '分摊 (${players})',
        ko: '모이기 (${players})'
      }
    }
  }, {
    id: 'E7S Left With Thee',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8C2'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Teleporting Left',
        de: 'Teleportation Links',
        fr: 'Téléportation à gauche',
        ja: '左にテレポ',
        cn: '向左传送',
        ko: '왼쪽으로 순간이동'
      }
    }
  }, {
    id: 'E7S Right With Thee',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8C3'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Teleporting Right',
        de: 'Teleportation Rechts',
        fr: 'Téléportation à droite',
        ja: '右にテレポ',
        cn: '向右传送',
        ko: '오른쪽으로 순간이동'
      }
    }
  }, {
    id: 'E7S Forward With Thee',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8C0'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Teleporting Forward',
        de: 'Teleportation Vorwärts',
        fr: 'Téléportation devant',
        ja: '前にテレポ',
        cn: '向前传送',
        ko: '앞으로 순간이동'
      }
    }
  }, {
    id: 'E7S Back With Thee',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8C1'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Teleporting Back',
        de: 'Teleportation Rückwärts',
        fr: 'Téléportation derrière',
        ja: '後ろにテレポ',
        cn: '向后传送',
        ko: '뒤로 순간이동'
      }
    }
  }, {
    id: 'E7S False Midnight',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Idol Of Darkness',
      id: '4C99',
      capture: false
    },
    run: data => data.phase = 'falseMidnight'
  }, {
    id: 'E7S Silver Shot',
    type: 'HeadMarker',
    netRegex: {
      id: '0065'
    },
    condition: data => data.phase === 'falseMidnight',
    preRun: (data, matches) => {
      data.falseMidnightSpread ??= [];
      data.falseMidnightSpread.push(matches.target);
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    outputStrings: {
      text: outputs/* default.spread */.Z.spread
    }
  }, {
    id: 'E7S Silver Sledge',
    type: 'HeadMarker',
    netRegex: {
      id: '0064'
    },
    condition: data => data.phase === 'falseMidnight',
    // The stack marker is in the middle of spreads,
    // so delay a tiny bit to call out stack so that
    // it is not called out on spreads.
    delaySeconds: 0.5,
    alertText: (data, matches, output) => {
      data.falseMidnightSpread ??= [];
      if (data.falseMidnightSpread.includes(data.me)) return;
      if (data.me === matches.target) return output.stackOnYou();
      return output.stackOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'E7S Adds',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Blasphemy',
      capture: false
    },
    suppressSeconds: 1,
    run: data => data.phase = 'adds'
  }, {
    id: 'E7S Advent Of Light',
    type: 'StartsUsing',
    netRegex: {
      source: 'Idolatry',
      id: '4C6E'
    },
    condition: data => data.CanSilence(),
    suppressSeconds: 1,
    response: responses/* Responses.interrupt */.n3.interrupt('alarm')
  }, {
    id: 'E7S Insatiable Light Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '0064'
    },
    condition: data => data.phase === 'adds',
    preRun: (data, matches) => {
      data.insatiableLightStack ??= [];
      data.insatiableLightStack.push(matches.target);
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.stackOnYou();
      if (!data.insatiableLightStack || data.insatiableLightStack.length === 1) return;
      const names = data.insatiableLightStack.map(x => data.party.member(x)).sort();
      return output.stackPlayers({
        players: names
      });
    },
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackPlayers: {
        en: 'Stack (${players})',
        de: 'Sammeln (${players})',
        fr: 'Packez-vous (${players})',
        ja: '頭割り (${players})',
        cn: '分摊 (${players})',
        ko: '모이기 (${players})'
      }
    }
  }, {
    id: 'E7S Insatiable Light',
    type: 'Ability',
    netRegex: {
      source: 'Idolatry',
      id: '4C6D',
      capture: false
    },
    run: data => data.insatiableLightStack = []
  }, {
    id: 'E7S Strength in Numbers',
    type: 'StartsUsing',
    netRegex: {
      source: 'Idolatry',
      id: '4C70',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get under vertical add',
        de: 'Unter das vertikale Add gehen',
        fr: 'Allez sous l\'add vertical',
        ja: '縦回転をする雑魚へ',
        cn: '去竖转小怪脚下',
        ko: '세로로 도는 쫄 아래로'
      }
    }
  }, {
    id: 'E7S Unearned Envy',
    type: 'Ability',
    netRegex: {
      source: 'Blasphemy',
      id: '4C74',
      capture: false
    },
    durationSeconds: 7,
    suppressSeconds: 15,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E7S Empty Flood',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Idol Of Darkness',
      id: '(?:4C8[BC]|4E5[56])',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E7S Astral Effect',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8BE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.color = 'light'
  }, {
    id: 'E7S Umbral Effect',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8BF'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.color = 'dark'
  }, {
    id: 'E7S Boundless Tracker',
    type: 'StartsUsing',
    netRegex: {
      source: 'Unforgiven Idolatry',
      id: '4C5[CD]'
    },
    run: (data, matches) => {
      data.boundless ??= {};
      const oppositeColor = matches.id === '4C5C' ? 'dark' : 'light';
      data.boundless[oppositeColor] = matches.target;
    }
  }, {
    id: 'E7S Boundless Light Dark Stack',
    type: 'StartsUsing',
    netRegex: {
      source: 'Unforgiven Idolatry',
      id: '4C5[CD]'
    },
    condition: (data, matches) => {
      if (Object.keys(data.boundless ?? {}).length !== 2) return false;
      const oppositeColor = matches.id === '4C5C' ? 'dark' : 'light';
      return data.color === oppositeColor;
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        text: {
          en: 'Avoid ${player}',
          de: 'Vermeide ${player}',
          fr: 'Évitez ${player}',
          ja: '${player} に避け',
          cn: '躲开 ${player}',
          ko: '${player}피하기'
        }
      };
      if (!data.boundless) return;

      // If somebody is taking both, definitely don't stack with them!
      if (data.boundless.light === data.boundless.dark) {
        if (matches.target === data.me) return;
        return {
          infoText: output.text({
            player: data.party.member(matches.target)
          })
        };
      }
      return responses/* Responses.stackMarkerOn */.n3.stackMarkerOn();
    }
  }, {
    id: 'E7S Boundless Cleanup',
    type: 'StartsUsing',
    netRegex: {
      source: 'Unforgiven Idolatry',
      id: '4C5[CD]',
      capture: false
    },
    delaySeconds: 20,
    run: data => delete data.boundless
  }, {
    id: 'E7S Words of Night',
    type: 'StartsUsing',
    netRegex: {
      source: 'Unforgiven Idolatry',
      id: '(?:4C2C|4C65)',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (!data.color) return;
      const colorTrans = colorMap[data.color];
      const color = colorTrans[data.displayLang];
      if (!color) return;
      return output.text({
        color: color
      });
    },
    outputStrings: {
      text: {
        en: 'Get hit by ${color}',
        de: 'Lass dich treffen von ${color}',
        fr: 'Encaissez le ${color}',
        ja: '${color}を受ける',
        cn: '撞${color}',
        ko: '${color} 맞기'
      }
    }
  }, {
    id: 'E7S False Dawn',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Idol Of Darkness',
      id: '4C9A',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Puddles',
        de: 'Flächen ködern',
        fr: 'Placez les zones au sol',
        ja: '誘導',
        cn: '放圈',
        ko: '장판 버리기'
      }
    }
  }, {
    id: 'E7S Crusade',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Idol Of Darkness',
      id: '4C76',
      capture: false
    },
    // Can't use knockback prevention for this, so say where to get knocked back.
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Knocked Into Corner',
        de: 'Lass dich in die Ecke zurückstoßen',
        fr: 'Faites-vous pousser dans les coins',
        ja: 'コーナーへノックバック',
        cn: '击退到角落',
        ko: '구석으로 넉백'
      }
    }
  }, {
    id: 'E7S Unjoined Aspect P3',
    type: 'Ability',
    netRegex: {
      source: 'The Idol Of Darkness',
      id: '4C7A',
      capture: false
    },
    // Color buffs go out immediately after the cast
    delaySeconds: 0.1,
    infoText: (data, _matches, output) => {
      if (data.role === 'tank') return output.goSouth();
      if (data.color === 'light') return output.goNorthwest();
      return output.goNortheast();
    },
    outputStrings: {
      goSouth: {
        en: 'Go South',
        de: 'Geh nach Süden',
        fr: 'Allez au Sud',
        ja: '南へ',
        cn: '前往南侧',
        ko: '남쪽'
      },
      goNorthwest: {
        en: 'Go Northwest',
        de: 'Geh nach Nordwesten',
        fr: 'Allez au Nord-Ouest',
        ja: '北西へ',
        cn: '前往西北',
        ko: '북서쪽'
      },
      goNortheast: {
        en: 'Go Northeast',
        de: 'Geh nach Nordosten',
        fr: 'Allez au Nord-Est',
        ja: '北東へ',
        cn: '前往东北',
        ko: '북동쪽'
      }
    }
  }, {
    id: 'E7S Threefold Grace',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Idol Of Darkness',
      id: '4C7E',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (!data.color) return;
      const colorTrans = colorMap[data.color];
      const color = colorTrans[data.displayLang];
      if (!color) return;
      return output.text({
        color: color
      });
    },
    outputStrings: {
      text: {
        en: 'Stand in ${color}',
        de: 'Stehe in ${color}',
        fr: 'Restez sur ${color}',
        ja: '${color}に踏む',
        cn: '站进${color}',
        ko: '${color}에 서기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Unforgiven Idolatry': 'ungeläutert(?:e|er|es|en) Götzenverehrung',
      'The Idol Of Darkness': 'Götzenbild der Dunkelheit',
      '(?<! )Idolatry': 'Idolatrie',
      'Blasphemy': 'Blasphemie'
    },
    'replaceText': {
      'Words Of Unity': 'Kommando: Stürmischer Angriff',
      'Words Of Spite': 'Kommando: Anvisieren',
      'Words Of Night': 'Kommando: Nächtlicher Angriff',
      'Words Of Motion': 'Kommando: Wellen',
      'Words Of Fervor': 'Kommando: Wilder Tanz',
      'Words Of Entrapment': 'Kommando: Einkesselung',
      'Unshadowed Stake': 'Dunkler Nagel',
      'Unjoined Aspect': 'Attributswechsel',
      'Unearned Envy': 'Verteidigungsinstinkt',
      'Threefold Grace': 'Dreifache Korona',
      'Stygian Sword': 'Schwarzes Schwert',
      'Stygian Spear': 'Schwarzer Speer',
      'Strength In Numbers': 'Angriffsmanöver',
      'Silver Sword': 'Weißes Lichtschwert',
      'Silver Stake': 'Heller Nagel',
      'Silver Spear': 'Weißer Lichtspeer',
      'Silver Sledge': 'Weißer Lichthammer',
      'Silver Shot': 'Weißer Lichtpfeil',
      'Silver Scourge': 'Peitschendes Licht',
      'Shockwave': 'Schockwelle',
      'Overwhelming Force': 'Vernichtende Schlammflut',
      'Light\'s Course': 'Weißer Strom des Lichts',
      'Insatiable Light': 'Licht des Verderbens',
      'Fate\'s Course': 'Reißender Strom',
      'False Moonlight': 'Manöver der Nacht',
      'False Midnight': 'Manöver der Polarnacht',
      'False Dawn': 'Manöver des Morgengrauens',
      'Empty Wave': 'Welle der Leere',
      'Empty Flood': 'Flut der Leere',
      'Dark\'s Course': 'Weißer Strom des Lichts',
      'Crusade': 'Ansturm',
      'Boundless Light': 'Weißer Lichtstrom',
      'Black Smoke': 'Schwarzes Feuer',
      'Betwixt Worlds': 'Dimensionsloch',
      'Away With Thee': 'Zwangsumwandlung',
      'Advent Of Light': 'Lichtsaturation'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Unforgiven Idolatry': 'Nuée D\'idolâtries Impardonnables',
      'The Idol Of Darkness': 'Idole des Ténèbres',
      '(?<! )Idolatry': 'Vol D\'idolâtries Impardonnables',
      'Blasphemy': 'Vol D\'idolâtries Impardonnables'
    },
    'replaceText': {
      'Words Of Unity': 'Ordre d\'assaut',
      'Words Of Spite': 'Ordre de visée',
      'Words Of Night': 'Ordre d\'attaque-surprise',
      'Words Of Motion': 'Ordre de déferlement',
      'Words Of Fervor': 'Ordre de virevolte',
      'Words Of Entrapment': 'Ordre d\'encerclement',
      'White/Black Smoke': 'Brûlure immaculée/ténébreuse',
      'Unshadowed Stake': 'Poinçon clair-obscur',
      'Unjoined Aspect': 'Transition élémentaire',
      'Unearned Envy': 'Mécanisme de défense',
      'Threefold Grace': 'Couronne triple',
      'Stygian Sword': 'Épée ténébreuse',
      'Stygian Spear': 'Lance ténébreuse',
      'Strength In Numbers': 'Murmuration offensive',
      'Silver Sword': 'Épée immaculée',
      'Silver Stake': 'Poinçon immaculé',
      'Silver Spear': 'Lance immaculée',
      'Silver Sledge': 'Pilon immaculé',
      'Silver Shot': 'Trait immaculé',
      'Silver Scourge': 'Lumière fustigeante',
      'Shockwave': 'Onde de choc',
      'Overwhelming Force': 'Remous destructeurs',
      'Light\'s Course': 'Déferlement immaculé',
      'Insatiable Light': 'Lumière destructrice',
      'Fate\'s Course': 'Flot d\'énergie',
      'False Moonlight': 'Murmuration du jour polaire',
      'False Midnight': 'Murmuration de la nuit polaire',
      'False Dawn': 'Murmuration de l\'aube',
      'Empty Wave': 'Onde de néant',
      'Empty Flood': 'Déluge de néant',
      'Dark\'s Course': 'Déferlement ténébreux',
      'Crusade': 'Plongeon de la nuée',
      'Boundless Light': 'Flot immaculé',
      'Betwixt Worlds': 'Brèche dimensionnelle',
      'Away With Thee': 'Translation forcée',
      'Advent Of Light': 'Plénitude lumineuse'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'unforgiven idolatry': 'アンフォーギヴン・アイドラトリー',
      'the Idol of Darkness': 'ダークアイドル',
      '(?<! )idolatry': 'アイドラトリー',
      'blasphemy': 'ブラスヒーム'
    },
    'replaceText': {
      'Words of Unity': '強襲の号令',
      'Words of Spite': '照準の号令',
      'Words of Night': '夜襲の号令',
      'Words of Motion': '波状の号令',
      'Words of Fervor': '乱舞の号令',
      'Words of Entrapment': '包囲の号令',
      'Unshadowed Stake': '闇光の釘',
      'Unjoined Aspect': '属性変動',
      'Unearned Envy': '防衛本能',
      'Threefold Grace': '三重光環',
      'Stygian Sword': '黒闇の剣',
      'Stygian Spear': '黒闇の槍',
      'Strength in Numbers': '攻撃機動',
      'Silver Sword': '白光の剣',
      'Silver Stake': '白光の釘',
      'Silver Spear': '白光の槍',
      'Silver Sledge': '白光の槌',
      'Silver Shot': '白光の矢',
      'Silver Scourge': '白光の鞭',
      'Shockwave': '衝撃波',
      'Overwhelming Force': '破滅の濁流',
      'Light\'s Course': '白光の奔流',
      'Insatiable Light': '破滅の光',
      'Fate\'s Course': '奔流',
      'False Moonlight': '白夜の機動',
      'False Midnight': '極夜の機動',
      'False Dawn': '黎明の機動',
      'Empty Wave': '虚無の波動',
      'Empty Flood': '虚無の氾濫',
      'Dark\'s Course': '白光の奔流',
      'Crusade': '群体突進',
      'Boundless Light': '白光の激流',
      'Black Smoke': '黒闇の火',
      'Betwixt Worlds': '次元孔',
      'Away with Thee': '強制転移',
      'Advent of Light': '光の飽和'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'The Idol Of Darkness': '暗黑心象',
      'Unforgiven Idolatry': '未被宽恕的盲崇',
      'Blasphemy': '亵渎',
      '(?<! )Idolatry': '盲崇'
    },
    'replaceText': {
      'Empty Wave': '虚无波动',
      'Unshadowed Stake': '暗光钉',
      'Silver Stake': '白光之钉',
      'Words Of Motion': '波状号令',
      'Betwixt Worlds': '次元孔',
      'Light\'s Course': '白光奔流',
      'Shockwave': '冲击波',
      'Words Of Spite': '瞄准号令',
      'Away With Thee': '强制传送',
      'Silver Sledge': '白光之锤',
      'Fate\'s Course': '奔流',
      'False Moonlight': '白夜机动',
      'Silver Sword': '白光之剑',
      'Dark\'s Course': '黑暗奔流',
      'Silver Scourge': '白光之鞭',
      'False Midnight': '极夜机动',
      'Silver Shot': '白光之矢',
      'Overwhelming Force': '破灭浊流',
      'Insatiable Light': '破灭之光',
      'Advent Of Light': '极限光',
      'Strength In Numbers': '攻击机动',
      'Unearned Envy': '防御本能',
      'Empty Flood': '虚无泛滥',
      'Unjoined Aspect': '属性变动',
      'Words Of Unity': '强袭号令',
      'Words Of Entrapment': '包围号令',
      'White/Black Smoke': '白光/黑暗之火',
      'Boundless Light': '白光激流',
      'Words Of Night': '夜袭号令',
      'False Dawn': '黎明机动',
      'Stygian Sword': '黑暗之剑',
      'Stygian Spear': '黑暗之枪',
      'Silver Spear': '白光之枪',
      'Crusade': '群体突进',
      'Words Of Fervor': '乱舞号令',
      'Threefold Grace': '三重光环'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'The Idol Of Darkness': '어둠의 우상',
      'Unforgiven Idolatry': '면죄되지 않은 숭배',
      'Blasphemy': '신성 모독',
      '(?<! )Idolatry': '숭배'
    },
    'replaceText': {
      'Empty Wave': '허무의 파동',
      'Unshadowed Stake': '암광의 못',
      'Silver Stake': '백광의 못',
      'Words Of Motion': '파상의 호령',
      'Betwixt Worlds': '차원 구멍',
      'Light\'s Course': '백광의 급류',
      'Shockwave': '충격파',
      'Words Of Spite': '조준의 호령',
      'Away With Thee': '강제 전송',
      'Silver Sledge': '백광의 망치',
      'Fate\'s Course': '급류',
      'False Moonlight': '백야 기동',
      'Silver Sword': '백광의 검',
      'Dark\'s Course': '흑암의 급류',
      'Silver Scourge': '백광의 채찍',
      'False Midnight': '극야 기동',
      'Silver Shot': '백광의 화살',
      'Overwhelming Force': '파멸의 탁류',
      'Insatiable Light': '파멸의 빛',
      'Advent Of Light': '빛의 포화',
      'Strength In Numbers': '공격 기동',
      'Unearned Envy': '방어 본능',
      'Empty Flood': '허무의 범람',
      'Unjoined Aspect': '속성 변동',
      'Words Of Unity': '강습의 호령',
      'Words Of Entrapment': '포위의 호령',
      'White/Black Smoke': '백광/흑암의 불',
      'Boundless Light': '백광의 격류',
      'Words Of Night': '야습의 호령',
      'False Dawn': '여명 기동',
      'Stygian Sword': '흑암의 검',
      'Stygian Spear': '흑암의 창',
      'Silver Spear': '백광의 창',
      'Crusade': '무리 돌진',
      'Words Of Fervor': '난무의 호령',
      'Threefold Grace': '삼중 빛고리'
    }
  }]
};
/* harmony default export */ const e7s = (e7s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e7s.txt
const raid_e7s_namespaceObject = "### Eden 7 (Savage)\r\n# Eden's Verse: Iconoclasm\r\n# -p 4C8A:13 4C8B:500 -ii 4C77 4C80 4C81 4C7D 4C34 3CC3 4CFD 4C28 4C72 4E7E 4C71 4D14 4D15 4C8E 4E55 4E56 4C36 4C75 4C76 4C7C 4C83 4C84 4C82 4C7F 4C37 4C38 4CAF\r\n\r\n# TODO: add interrupt ability\r\n# TODO: add explosions\r\n# TODO: final add enrage\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n13.0 \"Empty Wave\" Ability { id: \"4C8A\", source: \"The Idol Of Darkness\" } window 13,20\r\n25.2 \"Unshadowed Stake\" Ability { id: \"4C88\", source: \"The Idol Of Darkness\" }\r\n27.8 \"Silver Stake\" Ability { id: \"4C89\", source: \"The Idol Of Darkness\" }\r\n40.4 \"Words Of Motion\" Ability { id: \"4C2B\", source: \"The Idol Of Darkness\" }\r\n44.6 \"Betwixt Worlds\" Ability { id: \"4CF9\", source: \"The Idol Of Darkness\" }\r\n51.7 \"--sync--\" Ability { id: \"4C37\", source: \"Unforgiven Idolatry\" }\r\n54.7 \"--sync--\" Ability { id: \"4C37\", source: \"Unforgiven Idolatry\" }\r\n59.7 \"Light's Course\" #Ability { id: \"4C62\", source: \"Unforgiven Idolatry\" }\r\n62.7 \"Light's Course\" #Ability { id: \"4C62\", source: \"Unforgiven Idolatry\" }\r\n71.3 \"Light's Course\" #Ability { id: \"4C63\", source: \"Unforgiven Idolatry\" }\r\n74.3 \"Light's Course\" #Ability { id: \"4C63\", source: \"Unforgiven Idolatry\" }\r\n81.9 \"Light's Course\" #Ability { id: \"4C63\", source: \"Unforgiven Idolatry\" }\r\n84.9 \"Light's Course\" #Ability { id: \"4C63\", source: \"Unforgiven Idolatry\" }\r\n92.5 \"Light's Course\" #Ability { id: \"4C63\", source: \"Unforgiven Idolatry\" }\r\n95.5 \"Light's Course\" #Ability { id: \"4C64\", source: \"Unforgiven Idolatry\" }\r\n\r\n96.5 \"--sync--\" Ability { id: \"4C30\", source: \"The Idol Of Darkness\" }\r\n105.4 \"Betwixt Worlds\" Ability { id: \"4C6B\", source: \"The Idol Of Darkness\" }\r\n108.5 \"Shockwave\" Ability { id: \"4C6C\", source: \"The Idol Of Darkness\" }\r\n111.0 \"Words Of Spite\" Ability { id: \"4C2F\", source: \"The Idol Of Darkness\" }\r\n113.7 \"--sync--\" Ability { id: \"4C37\", source: \"Unforgiven Idolatry\" }\r\n116.7 \"Away With Thee\" Ability { id: \"4C39\", source: \"The Idol Of Darkness\" }\r\n122.9 \"Silver Sledge\" Ability { id: \"4C26\", source: \"The Idol Of Darkness\" }\r\n130.9 \"Fate's Course\" Ability { id: \"4C61\", source: \"Unforgiven Idolatry\" }\r\n131.0 \"Silver Sledge\" Ability { id: \"4C27\", source: \"The Idol Of Darkness\" }\r\n\r\n132.1 \"--sync--\" Ability { id: \"4C30\", source: \"The Idol Of Darkness\" }\r\n139.9 \"Empty Wave\" Ability { id: \"4C8A\", source: \"The Idol Of Darkness\" }\r\n147.5 \"Unshadowed Stake\" Ability { id: \"4C88\", source: \"The Idol Of Darkness\" }\r\n150.1 \"Silver Stake\" Ability { id: \"4C89\", source: \"The Idol Of Darkness\" }\r\n159.1 \"Words Of Motion\" Ability { id: \"4C2B\", source: \"The Idol Of Darkness\" }\r\n162.3 \"--sync--\" Ability { id: \"4C37\", source: \"Unforgiven Idolatry\" }\r\n163.3 \"False Moonlight\" Ability { id: \"4C98\", source: \"The Idol Of Darkness\" }\r\n166.5 \"--sync--\" Ability { id: \"4C37\", source: \"Unforgiven Idolatry\" }\r\n167.4 \"Silver Sword\" Ability { id: \"4C8E\", source: \"The Idol Of Darkness\" }\r\n170.4 \"Dark's Course\" Ability { id: \"4C5A\", source: \"Unforgiven Idolatry\" }\r\n170.4 \"Silver Scourge\" Ability { id: \"4C93\", source: \"The Idol Of Darkness\" }\r\n174.5 \"Dark's Course\" Ability { id: \"4C5A\", source: \"Unforgiven Idolatry\" }\r\n177.5 \"Away With Thee\" Ability { id: \"4C39\", source: \"The Idol Of Darkness\" }\r\n\r\n179.5 \"--sync--\" Ability { id: \"4C37\", source: \"Unforgiven Idolatry\" }\r\n183.7 \"False Midnight\" Ability { id: \"4C99\", source: \"The Idol Of Darkness\" }\r\n183.7 \"--sync--\" Ability { id: \"4C37\", source: \"Unforgiven Idolatry\" }\r\n187.5 \"Dark's Course\" Ability { id: \"4C5A\", source: \"Unforgiven Idolatry\" }\r\n191.7 \"Silver Sledge\" Ability { id: \"4C8D\", source: \"The Idol Of Darkness\" }\r\n191.7 \"Silver Shot\" Ability { id: \"4C92\", source: \"The Idol Of Darkness\" }\r\n191.7 \"Dark's Course\" Ability { id: \"4C5A\", source: \"Unforgiven Idolatry\" }\r\n191.7 \"--sync--\" Ability { id: \"4C30\", source: \"The Idol Of Darkness\" }\r\n198.5 \"--untargetable--\"\r\n198.6 \"--sync--\" Ability { id: \"4D0A\", source: \"The Idol Of Darkness\" }\r\n\r\n202.7 \"--sync--\" Ability { id: \"4C32\", source: \"The Idol Of Darkness\" } window 210,10\r\n203.6 \"--sync--\" Ability { id: \"4C3A\", source: \"Idolatry\" }\r\n205.6 \"--targetable--\"\r\n224.9 \"Overwhelming Force\" Ability { id: \"4C73\", source: \"Blasphemy\" }\r\n231.8 \"Insatiable Light\" Ability { id: \"4C6D\", source: \"Idolatry\" }\r\n239.5 \"Advent Of Light\" StartsUsing { id: \"4C6E\", source: \"Idolatry\" } # use start of cast for this interrupt\r\n243.6 \"Overwhelming Force\" Ability { id: \"4C73\", source: \"Blasphemy\" }\r\n253.7 \"Overwhelming Force\" Ability { id: \"4C73\", source: \"Blasphemy\" }\r\n254.5 \"Insatiable Light\" Ability { id: \"4C6D\", source: \"Idolatry\" }\r\n264.3 \"Away With Thee\" Ability { id: \"4C39\", source: \"The Idol Of Darkness\" }\r\n268.1 \"Strength In Numbers\" Ability { id: \"4C70\", source: \"Idolatry\" }\r\n278.2 \"Insatiable Light\" Ability { id: \"4C6D\", source: \"Idolatry\" }\r\n290.9 \"Overwhelming Force\" Ability { id: \"4C73\", source: \"Blasphemy\" }\r\n291.8 \"Strength In Numbers\" Ability { id: \"4C7[01]\", source: \"Idolatry\" }\r\n302.0 \"Insatiable Light\" Ability { id: \"4C6D\", source: \"Idolatry\" }\r\n# TODO: fix this sync up\r\n323.4 \"Unearned Envy\" Ability { id: \"4C74\", source: \"Blasphemy\" }\r\n325.5 \"Unearned Envy\" #Ability { id: \"4C74\", source: \"Blasphemy\" }\r\n327.6 \"Unearned Envy\" #Ability { id: \"4C74\", source: \"Blasphemy\" }\r\n329.7 \"Unearned Envy\" #Ability { id: \"4C74\", source: \"Blasphemy\" }\r\n331.8 \"Unearned Envy\" #Ability { id: \"4C74\", source: \"Blasphemy\" }\r\n333.9 \"Unearned Envy\" #Ability { id: \"4C74\", source: \"Blasphemy\" }\r\n# TODO: explosion?\r\n\r\n500.0 \"Empty Flood\" Ability { id: \"4C8B\", source: \"The Idol Of Darkness\" } window 500,10\r\n503.2 \"--sync--\" Ability { id: \"4D0B\", source: \"The Idol Of Darkness\" }\r\n507.3 \"--sync--\" Ability { id: \"4C32\", source: \"The Idol Of Darkness\" }\r\n\r\n510.3 \"--targetable--\"\r\n514.4 \"Unjoined Aspect\" Ability { id: \"4C3B\", source: \"The Idol Of Darkness\" }\r\n519.4 \"Words Of Unity\" Ability { id: \"4C2D\", source: \"The Idol Of Darkness\" }\r\n524.0 \"--sync--\" Ability { id: \"4C5E\", source: \"The Idol Of Darkness\" }\r\n529.0 \"Light's Course\" #Ability { id: \"4C5B\", source: \"Unforgiven Idolatry\" }\r\n529.5 \"--sync--\" Ability { id: \"4C30\", source: \"The Idol Of Darkness\" }\r\n534.8 \"Words Of Entrapment\" Ability { id: \"4C2E\", source: \"The Idol Of Darkness\" }\r\n550.5 \"Light's Course\" #Ability { id: \"4C5F\", source: \"Unforgiven Idolatry\" }\r\n550.5 \"--sync--\" Ability { id: \"4C30\", source: \"The Idol Of Darkness\" }\r\n550.5 \"White/Black Smoke\" Ability { id: \"4C9[46]\", source: \"The Idol Of Darkness\" }\r\n555.7 \"Words Of Unity\" Ability { id: \"4C2D\", source: \"The Idol Of Darkness\" }\r\n560.4 \"--sync--\" Ability { id: \"4C5E\", source: \"The Idol Of Darkness\" }\r\n565.4 \"Light's Course\" #Ability { id: \"4C5B\", source: \"Unforgiven Idolatry\" }\r\n565.5 \"Boundless Light\" Ability { id: \"4C5C\", source: \"Unforgiven Idolatry\" }\r\n565.9 \"--sync--\" Ability { id: \"4C30\", source: \"The Idol Of Darkness\" }\r\n\r\n578.8 \"Unjoined Aspect\" Ability { id: \"4C3B\", source: \"The Idol Of Darkness\" }\r\n582.0 \"Betwixt Worlds\" Ability { id: \"4CF9\", source: \"The Idol Of Darkness\" }\r\n587.0 \"Words Of Night\" Ability { id: \"4C2C\", source: \"The Idol Of Darkness\" }\r\n596.6 \"Light's Course\" #Ability { id: \"4C62\", source: \"Unforgiven Idolatry\" }\r\n605.2 \"Light's Course\" #Ability { id: \"4C63\", source: \"Unforgiven Idolatry\" }\r\n610.2 \"False Dawn\" Ability { id: \"4C9A\", source: \"The Idol Of Darkness\" }\r\n614.3 \"Stygian Sword\" Ability { id: \"4C8F\", source: \"The Idol Of Darkness\" }\r\n614.4 \"Light's Course\" #Ability { id: \"4C63\", source: \"Unforgiven Idolatry\" }\r\n617.3 \"Stygian Spear\" Ability { id: \"4C91\", source: \"The Idol Of Darkness\" }\r\n617.3 \"Silver Spear\" Ability { id: \"4C90\", source: \"The Idol Of Darkness\" }\r\n622.4 \"Light's Course\" #Ability { id: \"4C63\", source: \"Unforgiven Idolatry\" }\r\n\r\n625.4 \"--sync--\" Ability { id: \"4C30\", source: \"The Idol Of Darkness\" }\r\n636.2 \"Empty Wave\" Ability { id: \"4C8A\", source: \"The Idol Of Darkness\" }\r\n643.8 \"Unshadowed Stake\" Ability { id: \"4C88\", source: \"The Idol Of Darkness\" }\r\n646.4 \"Silver Stake\" Ability { id: \"4C89\", source: \"The Idol Of Darkness\" }\r\n658.8 \"--untargetable--\"\r\n658.9 \"--sync--\" Ability { id: \"4C31\", source: \"The Idol Of Darkness\" }\r\n\r\n668.5 \"Crusade\" Ability { id: \"4C58\", source: \"The Idol Of Darkness\" } window 700,10\r\n673.5 \"--targetable--\"\r\n677.6 \"Unjoined Aspect\" Ability { id: \"4C7A\", source: \"The Idol Of Darkness\" }\r\n683.7 \"Words Of Fervor\" Ability { id: \"4C7B\", source: \"The Idol Of Darkness\" }\r\n716.9 \"Threefold Grace\" Ability { id: \"4C7E\", source: \"The Idol Of Darkness\" }\r\n722.6 \"Threefold Grace\" Ability { id: \"4C7E\", source: \"The Idol Of Darkness\" }\r\n728.3 \"Threefold Grace\" Ability { id: \"4C7E\", source: \"The Idol Of Darkness\" }\r\n736.6 \"Empty Wave\" Ability { id: \"4CB0\", source: \"The Idol Of Darkness\" }\r\n746.2 \"Empty Wave\" Ability { id: \"4CB0\", source: \"The Idol Of Darkness\" }\r\n\r\n755.7 \"Unjoined Aspect\" Ability { id: \"4C7A\", source: \"The Idol Of Darkness\" }\r\n761.9 \"Words Of Fervor\" Ability { id: \"4C7B\", source: \"The Idol Of Darkness\" }\r\n795.1 \"Threefold Grace\" Ability { id: \"4C7E\", source: \"The Idol Of Darkness\" }\r\n800.8 \"Threefold Grace\" Ability { id: \"4C7E\", source: \"The Idol Of Darkness\" }\r\n806.5 \"Threefold Grace\" Ability { id: \"4C7E\", source: \"The Idol Of Darkness\" }\r\n814.8 \"Empty Wave\" Ability { id: \"4CB0\", source: \"The Idol Of Darkness\" }\r\n824.3 \"Empty Wave\" Ability { id: \"4CB0\", source: \"The Idol Of Darkness\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e8n.ts



const e8n_triggerSet = {
  id: 'EdensVerseRefulgence',
  zoneId: zone_id/* default.EdensVerseRefulgence */.Z.EdensVerseRefulgence,
  timelineFile: 'e8n.txt',
  timelineTriggers: [{
    id: 'E8N Shining Armor',
    regex: /Shining Armor/,
    beforeSeconds: 2,
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }],
  triggers: [{
    id: 'E8N Mirrors Active',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DD4',
      capture: false
    },
    run: data => data.mirrorsActive = true
  }, {
    id: 'E8N Biting Frost',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DDB',
      capture: false
    },
    condition: data => !data.mirrorsActive,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'E8N Driving Frost',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DDC',
      capture: false
    },
    condition: data => !data.mirrorsActive,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Front / Sides',
        de: 'Gehe nach Vorne/ zu den Seiten',
        fr: 'Allez devant / sur les côtés',
        ja: '前 / 横　へ',
        cn: '来 前方 / 两侧',
        ko: '앞 / 양옆으로'
      }
    }
  }, {
    id: 'E8N Axe Kick',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DE2',
      capture: false
    },
    condition: data => !data.mirrorsActive,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'E8N Scythe Kick',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DE3',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'E8N Biting Frost With Mirror',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DDB',
      capture: false
    },
    condition: data => data.mirrorsActive,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get behind, then South',
        de: 'Gehe nach Hinten, danach in den Süden',
        fr: 'Passez derrière, puis au Sud',
        ja: '後ろに、そして南へ',
        cn: '背面 => 南方',
        ko: '보스 뒤로 => 남쪽으로'
      }
    }
  }, {
    id: 'E8N Driving Frost With Mirror',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DDC',
      capture: false
    },
    condition: data => data.mirrorsActive,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Front / Sides, then North',
        de: 'Gehe nach Vorne, danach in den Norden',
        fr: 'Allez devant / sur les côtés, puis au Nord',
        ja: '前 / 横、そして北へ',
        cn: '前/侧面 => 北方',
        ko: '앞/양옆으로 => 북쪽으로'
      }
    }
  }, {
    id: 'E8N Axe Kick With Mirror',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DE2',
      capture: false
    },
    condition: data => data.mirrorsActive,
    response: responses/* Responses.getOutThenIn */.n3.getOutThenIn()
  }, {
    id: 'E8N Reflected Scythe Kick',
    type: 'StartsUsing',
    netRegex: {
      source: 'Frozen Mirror',
      id: '4E01',
      capture: false
    },
    suppressSeconds: 3,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Close to mirrors',
        de: 'Nahe zu den Spiegeln',
        fr: 'Près des mirroirs',
        ja: '鏡に近づく',
        cn: '靠近镜子',
        ko: '거울 밑으로'
      }
    }
  }, {
    id: 'E8N Mirror Cleanup',
    type: 'StartsUsing',
    netRegex: {
      source: 'Frozen Mirror',
      id: ['4DFE', '4DFF', '4E00', '4E01'],
      capture: false
    },
    // Maybe not necessary to delay here, but just to be safe.
    delaySeconds: 5,
    run: data => data.mirrorsActive = false
  }, {
    id: 'E8N Absolute Zero',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DD7',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E8N Double Slap',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DDA'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E8N Diamond Frost',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DE1',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E8N Frigid Water',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Flare on YOU',
        de: 'Flare auf DIR',
        fr: 'Brasier sur VOUS',
        ja: '自分にフレア',
        cn: '核爆点名',
        ko: '플레어 대상자'
      }
    }
  }, {
    id: 'E8N Icicle Impact',
    type: 'HeadMarker',
    netRegex: {
      id: '0060'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'E8N Puddle Chase',
    type: 'HeadMarker',
    netRegex: {
      id: '00C5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '3x puddles on YOU',
        de: '3x Fläche auf DIR',
        fr: '3x Zones au sol sur vous',
        ja: '自分に３回円範囲',
        cn: '三次放圈点名',
        ko: '따라오는 장판 피하기'
      }
    }
  }, {
    id: 'E8N Holy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DEC',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut('info')
  }, {
    id: 'E8N Holy Divided',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DED',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'E8N Light Rampant Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    run: (data, matches) => {
      data.rampant ??= {};
      data.rampant[matches.target] = matches.id;
    }
  }, {
    id: 'E8N Light Rampant',
    type: 'HeadMarker',
    netRegex: {
      id: '0017',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 2,
    alertText: (data, _matches, output) => {
      if (data.rampant?.[data.me] !== undefined) return output.coneOnYouAvoidTowers();
      return output.standInATower();
    },
    outputStrings: {
      coneOnYouAvoidTowers: {
        en: 'Cone on YOU -- avoid towers',
        de: 'Kegel AoE auf DIR -- Turm vermeiden',
        fr: 'Cône sur Vous -- évitez les tours',
        ja: '自分に範囲攻撃 (塔に当たらないように)',
        cn: '三角点名 -- 躲开塔',
        ko: '부채꼴 대상자 - 장판 피하기'
      },
      standInATower: {
        en: 'Stand in a tower',
        de: 'Im Turm stehen',
        fr: 'Placez-vous dans une tour',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 들어가기'
      }
    }
  }, {
    id: 'E8N Light Rampant Cleanup',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: '4E0B',
      capture: false
    },
    run: data => delete data.rampant
  }, {
    id: 'E8N Heavenly Strike',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DD8',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'E8N Twin Stillness',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DDD',
      capture: false
    },
    response: responses/* Responses.getBackThenFront */.n3.getBackThenFront('alert')
  }, {
    id: 'E8N Twin Silence',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DDE',
      capture: false
    },
    response: responses/* Responses.getFrontThenBack */.n3.getFrontThenBack('alert')
  }, {
    id: 'E8N Spiteful Dance',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DE4',
      capture: false
    },
    response: responses/* Responses.getOutThenIn */.n3.getOutThenIn()
  }, {
    id: 'E8N Embittered Dance',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DE5',
      capture: false
    },
    response: responses/* Responses.getInThenOut */.n3.getInThenOut()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Luminous Aether': 'Lichtäther',
      'Frozen Mirror': 'Eisspiegel',
      'Electric Aether': 'Blitzäther',
      'Earthen Aether': 'Erdäther',
      'Shiva': 'Shiva',
      'Mothercrystal': 'Urkristall'
    },
    'replaceText': {
      'The Path of Light': 'Pfad des Lichts',
      'Twin Stillness/Twin Silence': 'Zwillingsschwerter der Stille/Ruhe',
      'Stoneskin': 'Steinhaut',
      'Spiteful Dance': 'Kalter Tanz',
      'Skyfall': 'Vernichtung der Welt',
      'Shock Spikes': 'Schockstachel',
      'Shining Armor': 'Funkelnde Rüstung',
      'Shattered World': 'Zersplitterte Welt',
      'Scythe Kick': 'Abwehrtritt',
      'Rush': 'Sturm',
      'Redress': 'Beseitigung',
      'Mirror, Mirror': 'Spiegelland',
      'Light Rampant': 'Überflutendes Licht',
      'Icicle Impact': 'Eiszapfen-Schlag',
      'Holy': 'Sanctus',
      'Heavenly Strike': 'Elysischer Schlag',
      'Heart Asunder': 'Herzensbrecher',
      'Embittered Dance': 'Strenger Tanz',
      'Frost Armor(?! )': 'Frostrüstung',
      'Frigid Water': 'Eisfrost',
      'Frigid Stone': 'Eisstein',
      'Frigid Eruption': 'Eiseruption',
      'Driving Frost': 'Froststoß',
      'Double Slap': 'Doppelschlag',
      'Diamond Frost': 'Diamantstaub',
      'Bright Hunger': 'Erosionslicht',
      'Biting Frost': 'Frosthieb',
      'Axe Kick': 'Axttritt',
      'Absolute Zero': 'Absoluter Nullpunkt',
      'Reflected Kick/Frost': 'Spiegelung Tritt/Frost',
      'Reflected Frost': 'Spiegelung Frost',
      '(?<! )Kick/Frost': 'Tritt/Frost'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'luminous aether': 'éther de lumière',
      'frozen mirror': 'miroir de glace',
      'electric aether': 'éther de foudre',
      'earthen aether': 'éther de terre',
      'Shiva': 'Shiva',
      'Mothercrystal': 'Cristal-mère'
    },
    'replaceText': {
      'The Path of Light': 'Voie de lumière',
      'Twin Stillness': 'Entaille de la quiétude',
      'Twin Silence': 'Entaille de la tranquilité',
      'Stoneskin': 'Cuirasse',
      'Spiteful Dance': 'Danse de la froideur',
      'Skyfall': 'Anéantissement',
      'Shock Spikes': 'Pointes de foudre',
      'Shining Armor': 'Armure scintillante',
      'Shattered World': 'Monde fracassé',
      'Scythe Kick': 'Jambe faucheuse',
      'Rush': 'Jaillissement',
      'Reflected Kick/Frost': 'Jambe/Givre Réverbéré',
      'Reflected Frost': 'Givre Réverbéré',
      'Redress': 'Parure',
      'Mirror, Mirror': 'Monde des miroirs',
      '(?<! )Kick/Frost': 'Jambe/Givre',
      'Light Rampant': 'Débordement de Lumière',
      'Icicle Impact': 'Impact de stalactite',
      'Holy': 'Miracle',
      'Heavenly Strike': 'Frappe céleste',
      'Heart Asunder': 'Cœur déchiré',
      'Frost Armor': 'Armure de givre',
      'Frigid Water': 'Cataracte gelée',
      'Frigid Stone': 'Rocher de glace',
      'Frigid Eruption': 'Éruption de glace',
      'Embittered Dance': 'Danse de la sévérité',
      'Driving Frost': 'Percée de givre',
      'Double Slap': 'Gifle redoublée',
      'Diamond Frost': 'Poussière de diamant',
      'Bright Hunger': 'Lumière dévorante',
      'Biting Frost': 'Taillade de givre',
      'Axe Kick': 'Jambe pourfendeuse',
      'Absolute Zero': 'Zéro absolu'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'luminous aether': 'ライト・エーテル',
      'frozen mirror': '氷面鏡',
      'electric aether': 'ライトニング・エーテル',
      'earthen aether': 'アース・エーテル',
      'Shiva': 'シヴァ',
      'Mothercrystal': 'マザークリスタル'
    },
    'replaceText': {
      'The Path of Light': '光の波動',
      'Twin Stillness': '静寂の双剣技',
      'Stoneskin': 'ストンスキン',
      'Spiteful Dance': '冷厳の舞踏技',
      'Skyfall': '世界消滅',
      'Shock Spikes': 'ショックスパイク',
      'Shining Armor': 'ブライトアーマー',
      'Shattered World': 'シャッタード・ワールド',
      'Scythe Kick': 'サイスキック',
      'Rush': 'ラッシュ',
      'Reflected Kick/Frost': 'ミラーリング・アクスキック/フロストスラッシュ',
      'Reflected Frost': 'ミラーリング・フロストスラッシュ',
      'Redress': 'ドレスアップ',
      'Mirror, Mirror': '鏡の国',
      '(?<! )Kick/Frost': 'アクスキック/フロストスラッシュ',
      'Light Rampant': '光の暴走',
      'Icicle Impact': 'アイシクルインパクト',
      'Holy': 'ホーリー',
      'Heavenly Strike': 'ヘヴンリーストライク',
      'Heart Asunder': 'ハートアサンダー',
      'Frost Armor(?! )': 'フロストアーマー',
      'Frigid Water': 'アイスフロスト',
      'Frigid Stone': 'アイスストーン',
      'Frigid Eruption': 'アイスエラプション',
      'Driving Frost': 'フロストスラスト',
      'Double Slap': 'ダブルスラップ',
      'Diamond Frost': 'ダイヤモンドダスト',
      'Bright Hunger': '浸食光',
      'Biting Frost': 'フロストスラッシュ',
      'Axe Kick': 'アクスキック',
      'Absolute Zero': '絶対零度'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Shiva': '希瓦',
      'Frozen Mirror': '冰面镜',
      'Mothercrystal': '母水晶',
      'Earthen Aether': '土以太',
      'Electric Aether': '雷以太',
      'Luminous Aether': '光以太'
    },
    'replaceText': {
      'Absolute Zero': '绝对零度',
      'Redress': '换装',
      'Shining Armor': '闪光护甲',
      'Axe Kick/Scythe Kick': '阔斧/镰形回旋踢',
      'Frost Armor': '冰霜护甲',
      'Biting Frost/Driving Frost': '冰霜斩/刺',
      'Double Slap': '双剑斩',
      'Diamond Frost': '钻石星尘',
      'Frigid Water/Frigid Stone': '冰霜/冰石',
      'Icicle Impact': '冰柱冲击',
      'Frigid Eruption': '极冰喷发',
      'Heavenly Strike': '天降一击',
      'Mirror, Mirror': '镜中奇遇',
      'Driving Frost/Biting Frost': '冰霜刺/斩',
      'Reflected Frost': '连锁反射',
      'Shattered World': '世界分断',
      'Heart Asunder': '心碎',
      'Stoneskin': '石肤',
      'Shock Spikes': '电棘屏障',
      'Rush': '蓄势冲撞',
      'Skyfall': '世界消亡',
      'Holy': '神圣',
      'Light Rampant': '光之失控',
      'The Path of Light': '光之波动',
      'Bright Hunger': '侵蚀光',
      '(?<! )Kick/Frost': '阔斧/镰形',
      'Reflected Kick/Frost': '反射阔斧/镰形',
      'Twin Stillness/Twin Silence': '静寂/闲寂的双剑技',
      'Embittered Dance/Spiteful Dance': '严峻之舞/冷峻之舞',
      'Spiteful Dance/Embittered Dance': '冷峻之舞/严峻之舞'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Shiva': '시바',
      'Frozen Mirror': '얼음 거울',
      'Mothercrystal': '어머니 크리스탈',
      'Earthen Aether': '땅 에테르',
      'Electric Aether': '번개 에테르',
      'Luminous Aether': '빛 에테르'
    },
    'replaceText': {
      'Absolute Zero': '절대영도',
      'Redress': '환복',
      'Shining Armor': '빛의 갑옷',
      'Axe Kick/Scythe Kick': '도끼차기/낫차기',
      'Frost Armor': '서리 갑옷',
      'Biting Frost/Driving Frost': '서리 참격/일격',
      'Double Slap': '이중 타격',
      'Diamond Frost': '다이아몬드 더스트',
      'Frigid Water/Frigid Stone': '얼음서리/얼음돌',
      'Icicle Impact': '고드름 낙하',
      'Frigid Eruption': '얼음 분출',
      'Heavenly Strike': '천상의 일격',
      'Mirror, Mirror': '거울 나라',
      'Driving Frost/Biting Frost': '서리 일격/참격',
      'Reflected Frost': '반사된 서리 갑옷',
      'Shattered World': '분단된 세계',
      'Heart Asunder': '조각난 마음',
      'Stoneskin': '스톤스킨',
      'Shock Spikes': '번개 보호막',
      'Rush': '부딪기',
      'Skyfall': '세계 소멸',
      'Holy': '홀리',
      'Light Rampant': '빛의 폭주',
      'The Path of Light': '빛의 파동',
      'Bright Hunger': '침식광',
      '(?<! )Kick/Frost': '~차기/서리 참격',
      'Reflected Kick/Frost': '반사된 ~차기/서리 참격',
      'Twin Stillness/Twin Silence': '정적/고요의 쌍검기',
      'Embittered Dance/Spiteful Dance': '준엄/냉엄의 무도기',
      'Spiteful Dance/Embittered Dance': '냉엄/준엄의 무도기'
    }
  }]
};
/* harmony default export */ const e8n = (e8n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e8n.txt
const raid_e8n_namespaceObject = "### Eden 8 (Normal)\r\n# Eden's Verse: Refulgence\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# -ii 4D58 4DD3 4DDF 4DE0 4DF3 4DF5 4E0B 4E0D 4E10 4E11 4E18 4FC9 4FCA\r\n\r\n# Can use InCombat line to start timeline since the multiple phases do not\r\n# change the player's InCombat status.\r\n\r\n# Opening block\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n10.1 \"--sync--\" Ability { id: \"4DD7\", source: \"Shiva\" } window 15,5\r\n15.1 \"Absolute Zero\" Ability { id: \"4DD7\", source: \"Shiva\" }\r\n27.2 \"Redress\" Ability { id: \"4F4F\", source: \"Shiva\" }\r\n32.4 \"Shining Armor\" Ability { id: \"4DF1\", source: \"Shiva\" } window 32.4,5\r\n40.4 \"Axe Kick/Scythe Kick\" Ability { id: \"4DE[23]\", source: \"Shiva\" }\r\n52.5 \"Redress\" Ability { id: \"4F4E\", source: \"Shiva\" }\r\n57.6 \"Frost Armor\" Ability { id: \"4DF0\", source: \"Shiva\" }\r\n65.6 \"Biting Frost/Driving Frost\" Ability { id: \"4DD[BC]\", source: \"Shiva\" }\r\n78.8 \"Double Slap\" Ability { id: \"4DDA\", source: \"Shiva\" }\r\n92.0 \"Diamond Frost\" Ability { id: \"4DE1\", source: \"Shiva\" }\r\n100.2 \"Frigid Water/Frigid Stone\" # Ability { id: \"4E(08|66)\", source: \"Shiva\" }\r\n103.1 \"Icicle Impact\" Ability { id: \"4E0A\", source: \"Shiva\" }\r\n110.2 \"Frigid Eruption\" # Ability { id: \"4E09\", source: \"Shiva\" }\r\n111.2 \"Icicle Impact\" Ability { id: \"4E0A\", source: \"Shiva\" }\r\n112.3 \"Frigid Eruption\" # Ability { id: \"4E09\", source: \"Shiva\" }\r\n114.3 \"Frigid Eruption\" # Ability { id: \"4E09\", source: \"Shiva\" }\r\n120.1 \"Heavenly Strike\" Ability { id: \"4DD8\", source: \"Shiva\" } window 120,10\r\n131.2 \"Mirror, Mirror\" Ability { id: \"4DD4\", source: \"Shiva\" }\r\n143.4 \"Driving Frost/Biting Frost\" Ability { id: \"4DD[BC]\", source: \"Shiva\" }\r\n148.5 \"Reflected Frost\" Ability { id: \"4DF[EF]\", source: \"Frozen Mirror\" }\r\n160.6 \"Redress\" Ability { id: \"4F4F\", source: \"Shiva\" }\r\n165.7 \"Shining Armor\" Ability { id: \"4DF1\", source: \"Shiva\" }\r\n173.7 \"Axe Kick/Scythe Kick\" Ability { id: \"4DE[23]\", source: \"Shiva\" }\r\n181.9 \"--Untargetable--\"\r\n193.2 \"Shattered World\" Ability { id: \"4DE9\", source: \"Shiva\" } window 193.2,15\r\n\r\n# Intermission. Fixed length.\r\n209.4 \"Heart Asunder\" Ability { id: \"4E12\", source: \"Mothercrystal\" }\r\n218.1 \"Stoneskin\" # Ability { id: \"4DEF\", source: \"Earthen Aether\" }\r\n223.5 \"Heart Asunder\" Ability { id: \"4E12\", source: \"Mothercrystal\" }\r\n228.2 \"Shock Spikes\" Ability { id: \"4DEE\", source: \"Electric Aether\" }\r\n233.2 \"Rush\" Ability { id: \"4FC8\", source: \"Luminous Aether\" }\r\n237.5 \"Heart Asunder\" Ability { id: \"4E12\", source: \"Mothercrystal\" }\r\n251.5 \"Heart Asunder\" Ability { id: \"4E12\", source: \"Mothercrystal\" }\r\n256.2 \"Shock Spikes\" Ability { id: \"4DEE\", source: \"Electric Aether\" }\r\n260.2 \"Stoneskin\" # Ability { id: \"4DEF\", source: \"Earthen Aether\" }\r\n261.2 \"Rush\" Ability { id: \"4FC8\", source: \"Luminous Aether\" }\r\n\r\n# Post-intermission block\r\n272.6 \"Skyfall\" Ability { id: \"4E13\", source: \"Shiva\" } window 272.6,20\r\n287.9 \"--targetable--\"\r\n306.9 \"Holy\" Ability { id: \"4DE[CD]\", source: \"Shiva\" }\r\n321.4 \"Light Rampant\" Ability { id: \"4DE8\", source: \"Shiva\" }\r\n329.6 \"The Path of Light\" Ability { id: \"4DD9\", source: \"Shiva\" }\r\n332.6 \"Bright Hunger\" Ability { id: \"4E0C\", source: \"Shiva\" }\r\n337.7 \"The Path of Light\" Ability { id: \"4DD9\", source: \"Shiva\" }\r\n340.6 \"Bright Hunger\" Ability { id: \"4E0C\", source: \"Shiva\" }\r\n345.9 \"The Path of Light\" Ability { id: \"4DD9\", source: \"Shiva\" }\r\n348.6 \"Bright Hunger\" Ability { id: \"4E0C\", source: \"Shiva\" }\r\n356.0 \"Mirror, Mirror\" Ability { id: \"4DD4\", source: \"Shiva\" }\r\n368.1 \"Kick/Frost\" Ability { id: \"4D(D[BC]|E[23])\", source: \"Shiva\" }\r\n373.2 \"Reflected Kick/Frost\" Ability { id: [\"4DF[EF]\", \"4E0[01]\"], source: \"Frozen Mirror\" }\r\n\r\n# Rotation block\r\n385.3 \"Redress\" Ability { id: \"4F4E\", source: \"Shiva\" }\r\n390.4 \"Frost Armor\" Ability { id: \"4DF0\", source: \"Shiva\" }\r\n398.4 \"Twin Stillness/Twin Silence\" Ability { id: \"4DD[DE]\", source: \"Shiva\" }\r\n413.7 \"Double Slap\" Ability { id: \"4DDA\", source: \"Shiva\" }\r\n424.8 \"Mirror, Mirror\" Ability { id: \"4DD4\", source: \"Shiva\" }\r\n437.0 \"Kick/Frost\" Ability { id: \"4D(D[BC]|E[23])\", source: \"Shiva\" }\r\n442.1 \"Reflected Kick/Frost\" Ability { id: [\"4DF[EF]\", \"4E0[01]\"], source: \"Frozen Mirror\" }\r\n455.2 \"Absolute Zero\" Ability { id: \"4DD7\", source: \"Shiva\" }\r\n467.4 \"Redress\" Ability { id: \"4F4F\", source: \"Shiva\" }\r\n472.6 \"Shining Armor\" Ability { id: \"4DF1\", source: \"Shiva\" }\r\n480.6 \"Embittered Dance/Spiteful Dance\" Ability { id: \"4DE[4567]\", source: \"Shiva\" }\r\n484.7 \"Spiteful Dance/Embittered Dance\" Ability { id: \"4DE[4567]\", source: \"Shiva\" }\r\n500.8 \"Holy\" Ability { id: \"4DE[CD]\", source: \"Shiva\" }\r\n513.9 \"Absolute Zero\" Ability { id: \"4DD7\", source: \"Shiva\" }\r\n\r\n526.1 \"Redress\" Ability { id: \"4F4E\", source: \"Shiva\" }\r\n531.2 \"Frost Armor\" Ability { id: \"4DF0\", source: \"Shiva\" }\r\n539.2 \"Twin Stillness/Twin Silence\" Ability { id: \"4DD[DE]\", source: \"Shiva\" }\r\n554.5 \"Double Slap\" Ability { id: \"4DDA\", source: \"Shiva\" }\r\n565.6 \"Mirror, Mirror\" Ability { id: \"4DD4\", source: \"Shiva\" }\r\n577.8 \"Kick/Frost\" Ability { id: \"4D(D[BC]|E[23])\", source: \"Shiva\" }\r\n582.9 \"Reflected Kick/Frost\" Ability { id: [\"4DF[EF]\", \"4E0[01]\"], source: \"Frozen Mirror\" }\r\n596.0 \"Absolute Zero\" Ability { id: \"4DD7\", source: \"Shiva\" }\r\n608.2 \"Redress\" Ability { id: \"4F4F\", source: \"Shiva\" }\r\n613.4 \"Shining Armor\" Ability { id: \"4DF1\", source: \"Shiva\" }\r\n621.4 \"Embittered Dance/Spiteful Dance\" Ability { id: \"4DE[4567]\", source: \"Shiva\" }\r\n625.5 \"Spiteful Dance/Embittered Dance\" Ability { id: \"4DE[4567]\", source: \"Shiva\" }\r\n641.6 \"Holy\" Ability { id: \"4DE[CD]\", source: \"Shiva\" }\r\n654.7 \"Absolute Zero\" Ability { id: \"4DD7\", source: \"Shiva\" } jump 513.9\r\n\r\n666.9 \"Redress\"\r\n672.0 \"Frost Armor\"\r\n680.0 \"Twin Stillness/Twin Silence\"\r\n695.3 \"Double Slap\"\r\n706.4 \"Mirror, Mirror\"\r\n\r\n# There's an Absolute Zero spam sequence before this, but\r\n# it's indistinguishable from the standard usage.\r\n1000.0 \"--sync--\" Ability { id: \"4E29\", source: \"Shiva\" } window 1000,0\r\n1066.2 \"--targetable--\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e8s.ts







// TODO: Mirror Mirror 5
// TODO: Icelit Dragonsong callouts
// TODO: Wyrm's Lament 2, maybe print who your partner is for BLU

// Note: for BLU, there's not much you can do for Diamond Frost.
// The people who get flares are not necessarily the people with the Freezing debuff.
// The people who drop puddles can be anybody. For non-BLU, we could call out
// who has puddles or not or who is going to get flares, but not for BLU.
const mirrorFlags = {
  '00020001': 'blue',
  '00200010': 'green',
  '02000100': 'red'
};
const mirrorLocs = {
  // Mirror Mirror 1 + 2
  '03': 'dirN',
  '05': 'dirE',
  '07': 'dirS',
  '09': 'dirW',
  // unsure on these
  '04': 'dirNE',
  '06': 'dirSE',
  '08': 'dirSW',
  '0A': 'dirNW',
  // Mirror Mirror 3 + 4
  '0B': 'dirN',
  '0D': 'dirE',
  '0F': 'dirS',
  '11': 'dirW',
  // unsure on these
  '0C': 'dirNE',
  '0E': 'dirSE',
  '10': 'dirSW',
  '12': 'dirNW'
};
const e8s_triggerSet = {
  id: 'EdensVerseRefulgenceSavage',
  zoneId: zone_id/* default.EdensVerseRefulgenceSavage */.Z.EdensVerseRefulgenceSavage,
  config: [{
    id: 'uptimeKnockbackStrat',
    name: {
      en: 'Enable uptime knockback strat',
      de: 'Aktiviere Uptime Rückstoß Strategie',
      fr: 'Activer la strat Poussée-Uptime',
      ja: 'エデン零式共鳴編４層：cactbot「ヘヴンリーストライク (ノックバック)」ギミック',
      // FIXME
      cn: '启用 cactbot 精确计时防击退策略',
      ko: '정확한 타이밍 넉백방지 공략 사용'
    },
    comment: {
      en: `If you want cactbot to callout Mirror Mirror 4's double knockback, enable this option.
             Callout happens during/after boss turns and requires <1.4s reaction time
             to avoid both Green and Red Mirror knockbacks.
             Example: https://clips.twitch.tv/CreativeDreamyAsparagusKlappa
             Group splits into two groups behind boss after the jump.
             Tanks adjust to where the Red and Green Mirror are located.
             One tank must be inbetween the party, the other closest to Greem Mirror.
             Once Green Mirror goes off, the tanks adjust for Red Mirror.`,
      de: `Wenn du möchten, dass Cactbot den doppelten Knockback von Spiegelland 4 auslöst, aktivieren Sie diese Option.
             Die Anzeige erfolgt während/nach den Drehungen des Bosses und erfordert <1,4s Reaktionszeit
             um sowohl den grünen als auch den roten Spiegel-Rückstoß zu vermeiden.
             Beispiel: https://clips.twitch.tv/CreativeDreamyAsparagusKlappa
             Die Gruppe teilt sich nach dem Sprung hinter dem Boss in zwei Gruppen auf.
             Die Tanks passen sich danach an, wo sich der rote und der grüne Spiegel befinden.
             Ein Tank muss sich in der Mitte der Gruppe befinden, der andere in der Nähe des grünen Spiegels.
             Sobald der grüne Spiegel ausgelöst wird, passen sich die Tanks auf den roten Spiegel an.`,
      fr: `Si vous voulez que cactbot signale le double knockback de Mirror Mirror 4, activez cette option.
             L'annonce se fait pendant/après les tours du boss et nécessite un temps de réaction < à 1.4s
             pour éviter les deux poussées du miroir vert et du miroir rouge.
             Exemple : https://clips.twitch.tv/CreativeDreamyAsparagusKlappa
             Le groupe se divise en deux groupes derrière le boss après le saut.
             Les tanks s'adaptent à l'emplacement des miroirs rouge et vert.
             Un tank doit être entre les deux groupes, l'autre doit être le plus proche du miroir vert.
             Une fois que le miroir vert s'éteint, les tanks s'ajustent au miroir rouge.`,
      cn: `此选项可让 cactbot 提示第四次镜中奇遇的双击退。
             会在 BOSS 转身期间或之后播报提示, 需要小于 1.4 秒
             的反应时间来同时躲避绿镜和红镜击退。
             示例: https://clips.twitch.tv/CreativeDreamyAsparagusKlappa
             人群在 BOSS 瞬移后分成两组, 分别站在 BOSS 身后。
             坦克根据红镜和绿镜的位置进行调整。
             一个坦克必须在分组中间，另一个坦克最靠近绿镜。
             绿镜熄灭后，坦克调整到红镜位置。`,
      ko: `캑트봇이 거울 나라 4의 이중 넉백을 호출하게 하려면 이 옵션을 활성화하세요.
             알람은 보스의 시전 중간이나 이후에 발생하며
             녹색 및 빨강 거울의 넉백을 모두 피하려면 반응 시간이 1.4초 미만이어야 합니다.
             예시: https://clips.twitch.tv/CreativeDreamyAsparagusKlappa
             점프 후 보스 뒤에서 파티가 두 그룹으로 나뉩니다.
             탱커 빨강 및 초록 거울이 있는 위치에 맞춰 조정합니다.
             탱커 한 명은 파티 사이에, 다른 한 명은 초록 거울에 가장 가까운 곳에 위치해야 합니다.
             초록 거울이 발동하면 탱커는 빨강 거울에 맞춰 위치를 조정합니다.`
    },
    type: 'checkbox',
    default: options => {
      const oldSetting = options['cactbote8sUptimeKnockbackStrat'];
      return typeof oldSetting === 'boolean' ? oldSetting : false;
    }
  }],
  timelineFile: 'e8s.txt',
  initData: () => {
    return {
      combatantData: [],
      lightsteepedCount: {},
      mirrorMirrorCount: 0,
      mirrors: [],
      mirrorMap: {},
      diamondFrostFreezeTargets: [],
      diamondFrostStars: [],
      pathOfLightCounter: 0,
      bonusLightSteeped: {},
      asunderCount: 0,
      rushCount: 0,
      akhMornTargets: [],
      wyrmsLament: 0,
      wyrmsLamentMirrorCount: 0,
      mirrorThreeDirs: []
    };
  },
  timelineTriggers: [{
    id: 'E8S Shining Armor',
    regex: /(?<!Reflected )Shining Armor/,
    beforeSeconds: 2,
    suppressSeconds: 15,
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'E8S Reflected Armor',
    regex: /Reflected Armor/,
    beforeSeconds: 2,
    suppressSeconds: 15,
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'E8S Frost Armor',
    // Not the reflected one, as we want the "move" call there
    // which will happen naturally from `Reflected Drachen Armor`.
    regex: /^Frost Armor$/,
    beforeSeconds: 2,
    suppressSeconds: 15,
    response: responses/* Responses.stopMoving */.n3.stopMoving('alert')
  }, {
    id: 'E8S Rush',
    regex: /Rush \d/,
    beforeSeconds: 5,
    suppressSeconds: 15,
    infoText: (data, _matches, output) => {
      data.rushCount = data.rushCount + 1;
      return output.text({
        num: data.rushCount
      });
    },
    outputStrings: {
      text: {
        en: 'Tether ${num}',
        de: 'Verbindung ${num}',
        fr: 'Lien ${num}',
        ja: '線 ${num}',
        cn: '和${num}连线',
        ko: '선: ${num}'
      }
    }
  }],
  triggers: [{
    id: 'E8S Lightsteeped Gain Tracker',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8D1'
    },
    run: (data, matches) => data.lightsteepedCount[matches.target] = parseInt(matches.count)
  }, {
    id: 'E8S Lightsteeped Lose Tracker',
    type: 'LosesEffect',
    netRegex: {
      effectId: '8D1'
    },
    run: (data, matches) => data.lightsteepedCount[matches.target] = 0
  }, {
    id: 'E8S Absolute Zero',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4DCC',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E8S Mirror Mirror',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D5A',
      capture: false
    },
    infoText: (data, _matches, output) => {
      data.mirrorMirrorCount++;
      data.mirrors = [];
      data.mirrorMap = {};
      if (data.mirrorMirrorCount === 2) {
        if (data.firstKick === 'axe') return output.scytheNext();
        if (data.firstKick === 'scythe') return output.axeNext();
      }
    },
    outputStrings: {
      scytheNext: {
        en: '(under boss => under mirrors soon)',
        de: '(unter den Boss => gleich unter den Spiegel)',
        fr: '(sous le boss => sous les miroirs bientôt',
        cn: '(BOSS 下方 => 即将去镜子下方)',
        ko: '(보스 밑 => 이후 거울 밑)'
      },
      axeNext: {
        en: '(out => middle soon)',
        de: '(raus => gleich Mitte)',
        fr: '(extérieur => milieu bientôt)',
        cn: '(外 => 即将去中间)',
        ko: '(밖 => 이후 중앙)'
      }
    }
  }, {
    id: 'E8S Mirror Collect',
    type: 'MapEffect',
    netRegex: {
      flags: Object.keys(mirrorFlags),
      location: Object.keys(mirrorLocs)
    },
    run: (data, matches) => {
      const color = mirrorFlags[matches.flags];
      const location = mirrorLocs[matches.location];
      if (color === undefined || location === undefined) return;
      data.mirrors.push({
        color,
        location
      });
      data.mirrorMap[location] = color;
    }
  }, {
    id: 'E8S Biting Frost First Mirror',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D66',
      capture: false
    },
    condition: data => data.firstFrost === undefined,
    alertText: (data, _matches, output) => {
      if (data.mirrorMap['dirW'] === 'red') return output.redMirrorWest();
      if (data.mirrorMap['dirE'] === 'red') return output.redMirrorEast();
      return output.getBehind();
    },
    outputStrings: {
      redMirrorWest: {
        en: 'Behind => SW',
        de: 'Hinten => SW',
        fr: 'Derrière => SO',
        cn: '后 => 左下 (西南)',
        ko: '뒤 => 남서'
      },
      redMirrorEast: {
        en: 'Behind => SE',
        de: 'Hinten => SO',
        fr: 'Derrière => SE',
        cn: '后 => 右下 (东南)',
        ko: '뒤 => 남동'
      },
      getBehind: outputs/* default.getBehind */.Z.getBehind
    }
  }, {
    id: 'E8S Driving Frost First Mirror',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D67',
      capture: false
    },
    condition: data => data.firstFrost === undefined,
    alertText: (data, _matches, output) => {
      if (data.mirrorMap['dirE'] === 'red') return output.redMirrorEast();
      if (data.mirrorMap['dirW'] === 'red') return output.redMirrorWest();
      return output.goFront();
    },
    outputStrings: {
      redMirrorEast: {
        en: 'Front => NW',
        de: 'Vorne => NW',
        fr: 'Devant => NO',
        cn: '前 => 左上 (西北)',
        ko: '앞 => 북서'
      },
      redMirrorWest: {
        en: 'Front => NE',
        de: 'Vorne => NO',
        fr: 'Devant => NE',
        cn: '前 => 右上 (东北)',
        ko: '앞 => 북동'
      },
      goFront: outputs/* default.goFront */.Z.goFront
    }
  }, {
    id: 'E8S Reflected Frost 1',
    type: 'Ability',
    netRegex: {
      source: 'Frozen Mirror',
      id: '4DB[78]',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Swap Sides',
        de: 'Seiten wechseln',
        fr: 'Changez de côté',
        ja: '反対側へ',
        cn: '换边',
        ko: '반대로 이동'
      }
    }
  }, {
    id: 'E8S Biting Frost',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D66',
      capture: false
    },
    alertText: (data, _matches, output) => {
      // The first one is part of Mirror Mirror 1.
      if (data.firstFrost !== undefined) return output.getBehind();
    },
    run: data => data.firstFrost ??= 'biting',
    outputStrings: {
      getBehind: outputs/* default.getBehind */.Z.getBehind
    }
  }, {
    id: 'E8S Driving Frost',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D67',
      capture: false
    },
    alertText: (data, _matches, output) => {
      // The first one is part of Mirror Mirror 1.
      if (data.firstFrost !== undefined) return output.goFront();
    },
    run: data => data.firstFrost ??= 'driving',
    outputStrings: {
      goFront: outputs/* default.goFront */.Z.goFront
    }
  }, {
    id: 'E8S Forgetful Tank Second Frost',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D6[67]',
      capture: false
    },
    condition: data => data.role === 'tank' || data.job === 'BLU',
    delaySeconds: 43,
    suppressSeconds: 80,
    infoText: (data, _matches, output) => {
      if (data.firstFrost === 'driving') return output.bitingFrostNext();
      return output.drivingFrostNext();
    },
    outputStrings: {
      bitingFrostNext: {
        en: 'Biting Next (face outward)',
        de: 'Frosthieb als nächstes (nach außen drehen)',
        fr: 'Taillade de givre (pointez vers l\'extérieur)',
        ja: '次はフロストスラッシュ',
        // FIXME
        cn: '冰霜斩 (去背后)',
        ko: '서리 참격 (뒤로)'
      },
      drivingFrostNext: {
        en: 'Driving Next (face inward)',
        de: 'Froststoß als nächstes (nach innen drehen)',
        fr: 'Percée de givre (pointez vers l\'intérieur)',
        ja: '次はフロストスラスト',
        // FIXME
        cn: '冰霜刺 (去前面)',
        ko: '서리 일격 (앞으로)'
      }
    }
  }, {
    id: 'E8S Diamond Frost',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D6C',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E8S Diamond Frost Freezing',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8CB'
    },
    condition: (data, matches) => {
      // Ignore Icelit Dragonsong.
      if (data.mirrorMirrorCount !== 1) return false;
      data.diamondFrostFreezeTargets.push(matches.target);
      return data.diamondFrostFreezeTargets.length === 2;
    },
    infoText: (data, _matches, output) => {
      if (!util/* default.canCleanse */.Z.canCleanse(data.job)) return;
      const players = data.diamondFrostFreezeTargets.sort().map(x => data.party.member(x));
      return output.cleanse({
        players: players
      });
    },
    outputStrings: {
      cleanse: {
        en: 'Cleanse: ${players}',
        de: 'Reinige: ${players}',
        fr: 'Guérison : ${players}',
        cn: '驱散: ${players}',
        ko: '에스나: ${players}'
      }
    }
  }, {
    id: 'E8S Diamond Frost Frigid Needle Star',
    type: 'HeadMarker',
    netRegex: {
      id: '0060'
    },
    condition: (data, matches) => data.mirrorMirrorCount === 1 && matches.target === data.me,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Star on YOU',
        de: 'Stern auf DIR',
        fr: 'Étoile sur VOUS',
        cn: '冰针点名',
        ko: '별 징 대상자'
      }
    }
  }, {
    id: 'E8S Icicle Impact',
    type: 'StartsUsingExtra',
    netRegex: {
      id: '4DA0'
    },
    condition: data => !data.calledIcicleImpact,
    durationSeconds: 6,
    suppressSeconds: 20,
    infoText: (_data, matches, output) => {
      const x = parseFloat(matches.x);
      if (x >= 99 && x <= 101) return output.northSouth();
      return output.eastWest();
    },
    run: data => data.calledIcicleImpact = true,
    outputStrings: {
      northSouth: {
        en: 'North / South',
        de: 'Norden / Süden',
        fr: 'Nord / Sud',
        ja: '南 / 北',
        cn: '南北站位',
        ko: '남 / 북'
      },
      eastWest: {
        en: 'East / West',
        de: 'Osten / Westen',
        fr: 'Est / Ouest',
        ja: '東 / 西',
        cn: '东西站位',
        ko: '동 / 서'
      }
    }
  }, {
    id: 'E8S Icicle Impact Backup',
    type: 'Ability',
    // In case the OP 263/0x107 lines are missing, here's a late backup based on
    // when the first circles go off.
    netRegex: {
      source: 'Shiva',
      id: '4DA0'
    },
    condition: data => !data.calledIcicleImpact,
    suppressSeconds: 20,
    infoText: (_data, matches, output) => {
      const x = parseFloat(matches.x);
      if (x >= 99 && x <= 101) return output.northSouth();
      return output.eastWest();
    },
    run: data => data.calledIcicleImpact = true,
    outputStrings: {
      northSouth: {
        en: 'North / South',
        de: 'Norden / Süden',
        fr: 'Nord / Sud',
        ja: '南 / 北',
        cn: '南北站位',
        ko: '남 / 북'
      },
      eastWest: {
        en: 'East / West',
        de: 'Osten / Westen',
        fr: 'Est / Ouest',
        ja: '東 / 西',
        cn: '东西站位',
        ko: '동 / 서'
      }
    }
  }, {
    id: 'E8S Double Slap',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D65'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'E8S Axe Kick',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D6D',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.firstKick !== undefined) {
        return output.outThenMiddle();
      }
      data.firstKick = 'axe';
      return output.out();
    },
    outputStrings: {
      outThenMiddle: {
        en: 'Out => Middle',
        de: 'Raus => Mitte',
        fr: 'Extérieur => Milieu',
        cn: '远离 => 中间',
        ko: '밖 => 중앙'
      },
      out: outputs/* default.out */.Z.out
    }
  }, {
    id: 'E8S Scythe Kick',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D6E',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.firstKick !== undefined) {
        if (data.mirrorMap['dirN'] === 'green') return output.getUnderCards();
        if (data.mirrorMap['dirNE'] === 'green') return output.getUnderIntercards();
        return output.getUnderUnknown();
      }
      data.firstKick = 'scythe';
      return output.getUnder();
    },
    outputStrings: {
      getUnderCards: {
        en: 'Under => Under Cardinal Mirrors',
        de: 'Unter den Boss => Unter Kardinal-Spiegel',
        fr: 'Dessous => Sous les miroirs cardinaux',
        cn: '下方 => 正点镜下方',
        ko: '보스 밑 => 십자 방향 거울 밑'
      },
      getUnderIntercards: {
        en: 'Under => Under Intercard Mirrors',
        de: 'Unter den Boss => Unter Interkardinal-Spiegel',
        fr: 'Dessous => Sous les miroirs intercardinaux',
        cn: '下方 => 斜点镜下方',
        ko: '보스 밑 => 대각선 방향 거울 밑'
      },
      getUnderUnknown: {
        en: 'Under Boss => Under Mirrors',
        de: 'Unter den Boss => Unter Spiegel',
        fr: 'Sous le boss => Sous les miroirs',
        cn: 'BOSS 下方 => 镜下方',
        ko: '보스 밑 => 거울 밑'
      },
      getUnder: outputs/* default.getUnder */.Z.getUnder
    }
  }, {
    id: 'E8S Light Rampant',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D73',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E8S Refulgent Chain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8CD'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Chain on YOU',
        de: 'Kette auf DIR',
        fr: 'Chaîne sur VOUS',
        ja: '自分に鎖',
        cn: '连线点名',
        ko: '사슬 대상자'
      }
    }
  }, {
    id: 'E8S Holy Light',
    type: 'Tether',
    netRegex: {
      id: '0002'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Orb on YOU',
        de: 'Orb auf DIR',
        fr: 'Orbe sur VOUS',
        ja: '自分に玉',
        cn: '拉球点名',
        ko: '구슬 대상자'
      }
    }
  }, {
    id: 'E8S Path of Light Counter',
    type: 'Ability',
    // 4D63 = self-targeted path of light ability
    netRegex: {
      source: 'Shiva',
      id: '4D63',
      capture: false
    },
    run: data => data.pathOfLightCounter++
  }, {
    id: 'E8S Light Rampant Final Tower',
    type: 'GainsEffect',
    // Wait until lightsteeped has been collected after the final path of light.
    netRegex: {
      effectId: '8D1',
      capture: false
    },
    condition: data => data.pathOfLightCounter === 2,
    delaySeconds: 0.5,
    suppressSeconds: 9999999,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        getFinalTower: {
          en: 'Get Final Tower',
          de: 'Nimm letzten Turm',
          fr: 'Prenez la tour finale',
          cn: '踩最后塔',
          ko: '마지막 기둥 들어가기'
        },
        avoidFinalTower: {
          en: 'Avoid Final Tower',
          de: 'Vermeide letzten Turm',
          fr: 'Évitez la tour finale',
          cn: '躲最后塔',
          ko: '마지막 기둥 피하기'
        }
      };
      const light = data.lightsteepedCount[data.me];
      if (light !== undefined && light >= 4) return {
        infoText: output.avoidFinalTower()
      };
      return {
        alertText: output.getFinalTower()
      };
    }
  }, {
    id: 'E8S Banish III',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D80',
      capture: false
    },
    response: responses/* Responses.stackMarker */.n3.stackMarker('info')
  }, {
    id: 'E8S Banish III Divided',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D81',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'E8S Heart Asunder Side Tracker',
    type: 'Ability',
    netRegex: {
      id: '4DAC',
      source: 'MotherCrystal'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 999999,
    run: (data, matches) => {
      // The two sides are at roughly x=~70 and x=~130.
      const x = parseFloat(matches.x);
      data.asunderSide ??= x > 100 ? 'east' : 'west';
    }
  }, {
    id: 'E8S Aqueous Aether',
    type: 'Ability',
    // On 4DAC Heart Asunder; both sides have Aqueuous on 1 + 3
    netRegex: {
      id: '4DAC',
      source: 'MotherCrystal',
      capture: false
    },
    preRun: data => data.asunderCount++,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      if (!util/* default.canStun */.Z.canStun(data.job)) return;
      if (data.asunderCount === 1 || data.asunderCount === 3) return output.text();
    },
    outputStrings: {
      text: {
        en: 'Stun Aqueous Aether',
        de: 'Wasseräther unterbrechen',
        fr: 'Étourdissez l\'ether aqueux',
        cn: '眩晕水以太',
        ko: '물 에테르 기절'
      }
    }
  }, {
    id: 'E8S Earthen Aether Stoneskin',
    type: 'StartsUsing',
    netRegex: {
      source: 'Earthen Aether',
      id: '4D85'
    },
    condition: (data, matches) => {
      if (!util/* default.canSilence */.Z.canSilence(data.job)) return false;
      const x = parseFloat(matches.x);
      const side = x > 100 ? 'east' : 'west';
      return side === data.asunderSide;
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'E8S Akh Morn',
    type: 'StartsUsing',
    netRegex: {
      source: ['Shiva', 'Great Wyrm'],
      id: ['4D98', '4D79']
    },
    preRun: (data, matches) => {
      data.akhMornTargets.push(matches.target);
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        akhMornOnYou: {
          en: 'Akh Morn on YOU',
          de: 'Akh Morn auf DIR',
          fr: 'Akh Morn sur VOUS',
          ja: '自分にアク・モーン',
          cn: '死亡轮回点名',
          ko: '아크몬 대상자'
        },
        akhMornOn: {
          en: 'Akh Morn: ${players}',
          de: 'Akh Morn: ${players}',
          fr: 'Akh Morn : ${players}',
          ja: 'アク・モーン: ${players}',
          cn: '死亡轮回: ${players}',
          ko: '아크몬 : ${players}'
        }
      };
      if (data.me === matches.target) {
        // It'd be nice to have this be an alert, but it mixes with a lot of
        // other alerts (akh rhai "move" and worm's lament numbers).
        return {
          [data.role === 'tank' ? 'infoText' : 'alarmText']: output.akhMornOnYou()
        };
      }
      if (data.akhMornTargets.length !== 2) return;
      if (data.akhMornTargets.includes(data.me)) return;
      const players = data.akhMornTargets.map(x => data.party.member(x));
      return {
        infoText: output.akhMornOn({
          players: players
        })
      };
    }
  }, {
    id: 'E8S Akh Morn Cleanup',
    type: 'StartsUsing',
    netRegex: {
      source: ['Shiva', 'Great Wyrm'],
      id: ['4D98', '4D79'],
      capture: false
    },
    delaySeconds: 15,
    run: data => data.akhMornTargets = []
  }, {
    id: 'E8S Morn Afah',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D7B'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.mornAfahOnYou();
      return output.mornAfahOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      mornAfahOnYou: {
        en: 'Morn Afah on YOU',
        de: 'Morn Afah auf DIR',
        fr: 'Morn Afah sur VOUS',
        ja: '自分にモーン・アファー',
        cn: '无尽顿悟点名',
        ko: '몬아파 대상자'
      },
      mornAfahOn: {
        en: 'Morn Afah on ${player}',
        de: 'Morn Afah auf ${player}',
        fr: 'Morn Afah sur ${player}',
        ja: '${player}にモーン・アファー',
        cn: '无尽顿悟点 ${player}',
        ko: '"${player}" 몬 아파'
      }
    }
  }, {
    id: 'E8S Mirror Mirror 3 Directions',
    comment: {
      en: `Fast means you can go from the 1st to the 3rd safe spot directly.
             Slow means you need to go 1 => 2 => 3 without skipping 2.
             This is for casters who may not want to move as much.`,
      de: `Schnell bedeutet, dass man direkt vom 1. zum 3. sicheren Punkt gehen kann.
             Langsam bedeutet, dass man 1 => 2 => 3 gehen muss, ohne 2 zu überspringen.
             Dies ist für Magier, die sich vielleicht nicht so viel bewegen wollen.`,
      fr: `Rapide signifie que vous pouvez passer directement du premier au troisième point sûr.
             Lent signifie que vous devez aller de 1 => 2 => 3 sans omettre 2.
             C'est pour les lanceurs de sorts qui ne veulent pas se déplacer autant.`,
      cn: `快指你可以从第 1 个安全点直接到达第 3 个安全点。
             慢指你需要走 1 => 2 => 3 ,不跳过 2。
             适用于不想移动太多的读条职业。`,
      ko: `빠름은 첫 번째 안전 지점에서 세 번째 안전 지점으로 바로 이동할 수 있음을 의미합니다.
             느림은 2번을 건너뛰지 않고 1번 => 2번 => 3번으로 이동해야 한다는 뜻입니다.
             많이 움직이고 싶지 않은 캐스터를 위한 옵션입니다.`
    },
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: ['4D75', '4D76']
    },
    condition: data => data.wyrmsLament === 0,
    // She teleports to face north, then turns when she starts the cast.
    delaySeconds: 0.5,
    durationSeconds: 10,
    suppressSeconds: 15,
    promise: async (data, matches) => {
      data.combatantData = [];
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.sourceId, 16)]
      })).combatants;
    },
    // sound: '',
    infoText: (data, matches, output) => {
      const isLeftCleave = matches.id === '4D75';
      const [shiva] = data.combatantData;
      if (shiva === undefined || data.combatantData.length !== 1) return;

      // north = pi or -pi, and anywhere else consider her turned/turning south
      const isFacingNorth = Math.abs(shiva.Heading) > 3;

      // There are three mirrors. Green is north. Blue/Red are east/west.
      // The order the mirrors go off is Shiva Cleave 1 + Blue -> Green -> Shiva Cleave 2 + Red.
      // If the Blue mirror is west, we are rotating clockwise.
      const isClockwise = data.mirrorMap['dirW'] === 'blue';
      const isFirstSafeWest = isFacingNorth && !isLeftCleave || !isFacingNorth && isLeftCleave;
      const isFirstSafeNorth = isClockwise && !isLeftCleave || !isClockwise && isLeftCleave;
      const dirClock = ['dirNW', 'dirNE', 'dirSE', 'dirSW'];
      const dir1 = isFirstSafeNorth ? isFirstSafeWest ? 'dirNW' : 'dirNE' : isFirstSafeWest ? 'dirSW' : 'dirSE';

      // Find next two directions by rotating.
      const rotAdjust = isClockwise ? 1 : -1;
      const idx1 = dirClock.indexOf(dir1);
      const idx2 = (idx1 + rotAdjust + 4) % 4;
      const idx3 = (idx2 + rotAdjust + 4) % 4;
      const dir2 = dirClock[idx2];
      const dir3 = dirClock[idx3];
      if (dir2 === undefined || dir3 === undefined) return;
      data.mirrorThreeDirs = [dir1, dir2, dir3];
      const isFast = dir1 === 'dirNW' && isClockwise || dir1 === 'dirNE' && !isClockwise || dir1 === 'dirSE' && isClockwise || dir1 === 'dirSW' && !isClockwise;
      const params = {
        dir1: output[dir1](),
        dir2: output[dir2](),
        dir3: output[dir3]()
      };
      return isFast ? output.fastText(params) : output.slowText(params);
    },
    outputStrings: {
      slowText: {
        en: '${dir1} => ${dir2} => ${dir3} (slow)',
        de: '${dir1} => ${dir2} => ${dir3} (langsam)',
        fr: '${dir1} => ${dir2} => ${dir3} (lent)',
        cn: '${dir1} => ${dir2} => ${dir3} (慢)',
        ko: '${dir1} => ${dir2} => ${dir3} (느림)'
      },
      fastText: {
        en: '${dir1} => ${dir2} => ${dir3} (fast)',
        de: '${dir1} => ${dir2} => ${dir3} (schnell)',
        fr: '${dir1} => ${dir2} => ${dir3} (rapide)',
        cn: '${dir1} => ${dir2} => ${dir3} (快)',
        ko: '${dir1} => ${dir2} => ${dir3} (빠름)'
      },
      dirNW: outputs/* default.dirNW */.Z.dirNW,
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirSW: outputs/* default.dirSW */.Z.dirSW
    }
  }, {
    id: 'E8S Mirror Mirror 3 Dir 1',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: ['4D75', '4D76']
    },
    condition: data => data.wyrmsLament === 0,
    // TODO: this is maybe one case where having one trigger cause two outputs would be helpful
    // as this can't be a response as you want different durations on the initial alert and
    // the infotext that stays up.
    delaySeconds: 0.6,
    suppressSeconds: 15,
    alertText: (data, matches, output) => {
      const dir = data.mirrorThreeDirs.shift();
      if (dir === undefined) {
        const isLeftCleave = matches.id === '4D75';
        return isLeftCleave ? output.right() : output.left();
      }
      return output[dir]();
    },
    outputStrings: {
      dirNW: outputs/* default.dirNW */.Z.dirNW,
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirSW: outputs/* default.dirSW */.Z.dirSW,
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'E8S Mirror Mirror 3 Dir 2',
    type: 'Ability',
    netRegex: {
      source: 'Frozen Mirror',
      id: ['4D90', '4D91'],
      capture: false
    },
    condition: data => data.wyrmsLament === 0,
    alertText: (data, _matches, output) => {
      const dir = data.mirrorThreeDirs.shift();
      if (dir === undefined) return;
      return output[dir]();
    },
    outputStrings: {
      dirNW: outputs/* default.dirNW */.Z.dirNW,
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirSW: outputs/* default.dirSW */.Z.dirSW
    }
  }, {
    id: 'E8S Mirror Mirror 3 Dir 3',
    type: 'Ability',
    netRegex: {
      source: 'Frozen Mirror',
      id: ['4DBB', '4DBC'],
      capture: false
    },
    condition: data => data.wyrmsLament === 0,
    alertText: (data, _matches, output) => {
      const dir = data.mirrorThreeDirs.shift();
      if (dir === undefined) return;
      return output[dir]();
    },
    outputStrings: {
      dirNW: outputs/* default.dirNW */.Z.dirNW,
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirSW: outputs/* default.dirSW */.Z.dirSW
    }
  }, {
    id: 'E8S Hallowed Wings Knockback',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D77',
      capture: false
    },
    condition: data => data.triggerSetConfig.uptimeKnockbackStrat === true,
    // This gives a warning within 1.4 seconds, so you can hit arm's length.
    delaySeconds: 8.6,
    durationSeconds: 1.4,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'E8S Wyrm\'s Lament',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D7C',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E8S Wyrm\'s Lament Counter',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D7C',
      capture: false
    },
    run: data => data.wyrmsLament++
  }, {
    id: 'E8S Wyrm\'s Lament Mirror',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: ['4D75', '4D76']
    },
    condition: data => data.wyrmsLament === 1,
    infoText: (_data, matches, output) => {
      const isLeftCleave = matches.id === '4D75';
      return isLeftCleave ? output.right() : output.left();
    },
    outputStrings: {
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'E8S Wyrmclaw',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8D2'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: (data, matches) => {
      if (data.wyrmsLament === 1) {
        const clawNumber = {
          '14': 1,
          '22': 2,
          '30': 3,
          '38': 4
        };
        data.wyrmclawNumber = clawNumber[Math.ceil(parseFloat(matches.duration))];
      } else {
        const clawNumber = {
          '22': 1,
          '38': 2
        };
        data.wyrmclawNumber = clawNumber[Math.ceil(parseFloat(matches.duration))];
      }
    },
    durationSeconds: (_data, matches) => parseFloat(matches.duration),
    alertText: (data, _matches, output) => output.text({
      num: data.wyrmclawNumber
    }),
    outputStrings: {
      text: {
        en: 'Red #${num}',
        de: 'Rot #${num}',
        fr: 'Rouge #${num}',
        ja: '赤 #${num}',
        cn: '红色 #${num}',
        ko: '빨강 ${num}번'
      }
    }
  }, {
    id: 'E8S Wyrmfang',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8D3'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: (data, matches) => {
      if (data.wyrmsLament === 1) {
        const fangNumber = {
          '20': 1,
          '28': 2,
          '36': 3,
          '44': 4
        };
        data.wyrmfangNumber = fangNumber[Math.ceil(parseFloat(matches.duration))];
      } else {
        const fangNumber = {
          '28': 1,
          '44': 2
        };
        data.wyrmfangNumber = fangNumber[Math.ceil(parseFloat(matches.duration))];
      }
    },
    durationSeconds: (_data, matches) => parseFloat(matches.duration),
    alertText: (data, _matches, output) => output.text({
      num: data.wyrmfangNumber
    }),
    outputStrings: {
      text: {
        en: 'Blue #${num}',
        de: 'Blau #${num}',
        fr: 'Bleu #${num}',
        ja: '青 #${num}',
        cn: '蓝色 #${num}',
        ko: '파랑 ${num}번'
      }
    }
  }, {
    id: 'E8S Wyrm\'s Lament Buff Reminder',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: ['4D75', '4D76'],
      targetIndex: '0',
      capture: false
    },
    condition: data => data.wyrmsLament === 1,
    preRun: data => data.wyrmsLamentMirrorCount++,
    alertText: (data, _matches, output) => {
      console.log(data.wyrmsLamentMirrorCount);
      if (data.wyrmclawNumber === data.wyrmsLamentMirrorCount + 1) return output.redDragonHead({
        num: data.wyrmclawNumber
      });
      if (data.wyrmfangNumber === data.wyrmsLamentMirrorCount) return output.bluePuddle({
        num: data.wyrmfangNumber
      });
    },
    outputStrings: {
      redDragonHead: {
        en: 'Pop Head #${num}',
        de: 'Nimm Kopf #${num}',
        fr: 'Tête #${num}',
        cn: '撞头 #${num}',
        ko: '${num}번 머리 부딪히기'
      },
      bluePuddle: {
        en: 'Get Puddle #${num}',
        de: 'Nimm Fläche #${num}',
        fr: 'Prenez le puddle #${num}',
        cn: '踩圈 #${num}',
        ko: '${num}번 장판 밟기'
      }
    }
  }, {
    id: 'E8S Drachen Armor',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: '4DD2',
      capture: false
    },
    response: responses/* Responses.moveAway */.n3.moveAway('alert')
  }, {
    id: 'E8S Reflected Drachen Armor',
    type: 'Ability',
    netRegex: {
      source: 'Frozen Mirror',
      id: '4DC2',
      capture: false
    },
    response: responses/* Responses.moveAway */.n3.moveAway('alert')
  }, {
    id: 'E8S Holy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D82',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'E8S Holy Divided',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D83',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'E8S Twin Stillness',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D68',
      capture: false
    },
    response: responses/* Responses.getBackThenFront */.n3.getBackThenFront('alert')
  }, {
    id: 'E8S Twin Silence',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D69',
      capture: false
    },
    response: responses/* Responses.getFrontThenBack */.n3.getFrontThenBack('alert')
  }, {
    id: 'E8S Spiteful Dance',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D6F',
      capture: false
    },
    response: responses/* Responses.getOutThenIn */.n3.getOutThenIn()
  }, {
    id: 'E8S Embittered Dance',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D70',
      capture: false
    },
    response: responses/* Responses.getInThenOut */.n3.getInThenOut()
  }, {
    id: 'E8S Icelit Dragonsong Cleanse',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: '4D7D',
      capture: false
    },
    condition: data => util/* default.canCleanse */.Z.canCleanse(data.job),
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      if (data.job === 'BLU') return output.bluCleanse();
      return output.cleanseOnlyDPS();
    },
    outputStrings: {
      cleanseOnlyDPS: {
        en: 'Cleanse DPS Only',
        de: 'Nur DPS reinigen',
        fr: 'Guérison => DPS seulement',
        ja: 'エスナ (DPSのみ)',
        cn: '驱散DPS',
        ko: '딜러만 에스나'
      },
      bluCleanse: {
        en: 'Exuviation',
        de: 'Exuviation',
        fr: 'Exuviation',
        cn: '蜕皮',
        ko: '허물 벗기'
      }
    }
  }, {
    id: 'E8S Banish',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D7E',
      capture: false
    },
    condition: data => data.role === 'tank',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank Stack in Tower',
        de: 'Auf Tank im Turm sammeln',
        fr: 'Package tanks dans la tour',
        ja: 'タンクは塔に頭割り',
        cn: '坦克塔内分摊',
        ko: '탱커 쉐어'
      }
    }
  }, {
    id: 'E8S Banish Divided',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D7F',
      capture: false
    },
    condition: data => data.role === 'tank',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank Spread in Tower',
        de: 'Tank im Turm verteilen',
        fr: 'Dispersion tanks dans la tour',
        ja: 'タンクは塔に散開',
        cn: '坦克塔内分散',
        ko: '탱커 산개'
      }
    }
  }, {
    id: 'E8S The House of Light',
    type: 'StartsUsing',
    netRegex: {
      source: 'Shiva',
      id: '4D64',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const light = data.lightsteepedCount[data.me];
      if (light !== undefined && light >= 4) return output.proteanAvoidFinalTower();
      return output.proteanGetFinalTower();
    },
    outputStrings: {
      proteanGetFinalTower: {
        en: 'Protean => Get Final Tower',
        de: 'Himmelsrichtung => Nimm letzten Turm',
        fr: 'Positions => Prenez la tour finale',
        cn: '八方分散 => 踩最后塔',
        ko: '8방향 산개 => 마지막 기둥 들어가기'
      },
      proteanAvoidFinalTower: {
        en: 'Protean => Avoid Final Tower',
        de: 'Himmelsrichtung => Vermeide letzten Turm',
        fr: 'Position => Évitez la tour finale',
        cn: '八方分散 => 躲最后塔',
        ko: '8방향 산개 => 마지막 기둥 피하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Earthen Aether': 'Erdäther',
      'Frozen Mirror': 'Eisspiegel',
      'great wyrm': 'Körper des heiligen Drachen',
      'Luminous Aether': 'Lichtäther',
      'Mothercrystal': 'Urkristall',
      'Shiva': 'Shiva'
    },
    'replaceText': {
      'Absolute Zero': 'Absoluter Nullpunkt',
      'Akh Morn': 'Akh Morn',
      'Akh Rhai': 'Akh Rhai',
      'Axe/Scythe Kick': 'Axttritt/Abwehrtritt',
      'Banish(?! )': 'Verbannen',
      'Banish III': 'Verbannga',
      'Biting/Driving Frost': 'Frostshieb/Froststoß',
      'Bright Hunger': 'Erosionslicht',
      'Diamond Frost': 'Diamantstaub',
      'Double Slap': 'Doppelschlag',
      'Drachen Armor': 'Drachenrüstung',
      'Draconic Strike': 'Drakonischer Schlag',
      'Driving/Biting Frost': 'Froststoß/Frostshieb',
      'Embittered/Spiteful Dance': 'Strenger/Kalter Tanz',
      'Frigid Eruption': 'Eiseruption',
      'Frigid Needle': 'Eisnadel',
      'Frigid Stone': 'Eisstein',
      'Frigid Water': 'Eisfrost',
      'Frost Armor(?! )': 'Frostrüstung',
      'Hallowed Wings': 'Heilige Schwingen',
      'Heart Asunder': 'Herzensbrecher',
      'Heavenly Strike': 'Elysischer Schlag',
      'Holy': 'Sanctus',
      'Icelit Dragonsong': 'Lied von Eis und Licht',
      'Icicle Impact': 'Eiszapfen-Schlag',
      'Inescapable Illumination': 'Expositionslicht',
      'Light Rampant': 'Überflutendes Licht',
      'Mirror, Mirror': 'Spiegelland',
      'Morn Afah': 'Morn Afah',
      'Reflected Armor \\(B\\)': 'Spiegelung Rüstung (B)',
      'Reflected Armor \\(G\\)': 'Spiegelung Rüstung (G)',
      'Reflected Armor \\(R\\)': 'Spiegelung Rüstung (R)',
      'Reflected Drachen': 'Spiegelung Drachen',
      'Reflected Frost \\(G\\)': 'Spiegelung Frost (G)',
      'Reflected Frost \\(R\\)': 'Spiegelung Frost (R)',
      'Reflected Frost Armor': 'Spiegelung: Frostrüstung',
      'Reflected Kick \\(G\\)': 'Spiegelung Tritt (G)',
      'Reflected Wings \\(B\\)': 'Spiegelung Schwingen (B)',
      'Reflected Wings \\(G\\)': 'Spiegelung Schwingen (G)',
      'Reflected Wings \\(R\\)': 'Spiegelung Schwingen (R)',
      'Rush': 'Sturm',
      'Scythe/Axe Kick': 'Abwehrtritt/Axttritt',
      'Shattered World': 'Zersplitterte Welt',
      'Shining Armor': 'Funkelnde Rüstung',
      'Skyfall': 'Vernichtung der Welt',
      'Spiteful/Embittered Dance': 'Kalter/Strenger Tanz',
      'The Path Of Light': 'Pfad des Lichts',
      'The House Of Light': 'Tsunami des Lichts',
      'Twin Silence/Stillness': 'Zwillingsschwerter der Ruhe/Stille',
      'Twin Stillness/Silence': 'Zwillingsschwerter der Stille/Ruhe',
      'Wyrm\'s Lament': 'Brüllen des heiligen Drachen'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Earthen Aether': 'éther de terre',
      'frozen mirror': 'Miroir de glace',
      'great wyrm': 'Dragon divin',
      'luminous Aether': 'Éther de lumière',
      'Mothercrystal': 'Cristal-mère',
      'Shiva': 'Shiva'
    },
    'replaceText': {
      '\\?': ' ?',
      'Absolute Zero': 'Zéro absolu',
      'Akh Morn': 'Akh Morn',
      'Akh Rhai': 'Akh Rhai',
      'Axe/Scythe Kick': 'Jambe pourfendeuse/faucheuse',
      'Banish(?! )': 'Bannissement',
      'Banish III': 'Méga Bannissement',
      'Biting/Driving Frost': 'Taillade/Percée de givre',
      'Bright Hunger': 'Lumière dévorante',
      'Diamond Frost': 'Poussière de diamant',
      'Double Slap': 'Gifle redoublée',
      'Drachen Armor': 'Armure des dragons',
      'Draconic Strike': 'Frappe draconique',
      'Driving/Biting Frost': 'Percée/taillade de givre',
      'Embittered/Spiteful Dance': 'Danse de la sévérité/froideur',
      'Frigid Eruption': 'Éruption de glace',
      'Frigid Needle': 'Dards de glace',
      'Frigid Stone': 'Rocher de glace',
      'Frigid Water': 'Cataracte gelée',
      'Frost Armor(?! )': 'Armure de givre',
      'Hallowed Wings': 'Aile sacrée',
      'Heart Asunder': 'Cœur déchiré',
      'Icelit Dragonsong': 'Chant de Glace et de Lumière',
      'Icicle Impact': 'Impact de stalactite',
      'Inescapable Illumination': 'Lumière révélatrice',
      'Heavenly Strike': 'Frappe céleste',
      'Holy': 'Miracle',
      'Light Rampant': 'Débordement de Lumière',
      'Mirror, Mirror': 'Monde des miroirs',
      'Morn Afah': 'Morn Afah',
      'Reflected Armor \\(B\\)': 'Armure réverbérée (B)',
      'Reflected Armor \\(G\\)': 'Armure réverbérée (V)',
      'Reflected Armor \\(R\\)': 'Armure réverbérée (R)',
      'Reflected Drachen': 'Dragon réverbéré',
      'Reflected Frost \\(G\\)': 'Givre réverbéré (V)',
      'Reflected Frost \\(R\\)': 'Givre réverbéré (R)',
      'Reflected Frost Armor': 'Réverbération : Armure de givre',
      'Reflected Kick \\(G\\)': 'Jambe réverbérée (V)',
      'Reflected Wings \\(B\\)': 'Aile réverbérée (B)',
      'Reflected Wings \\(G\\)': 'Aile réverbérée (V)',
      'Reflected Wings \\(R\\)': 'Aile réverbérée (R)',
      'Rush': 'Jaillissement',
      'Scythe/Axe Kick': 'Jambe faucheuse/pourfendeuse',
      'Shattered World': 'Monde fracassé',
      'Shining Armor': 'Armure scintillante',
      'Skyfall': 'Anéantissement',
      'Spiteful/Embittered Dance': 'Danse de la froideur/sévérité',
      'The Path Of Light': 'Voie de lumière',
      'The House Of Light': 'Raz-de-lumière',
      'Twin Silence/Stillness': 'Entaille de la tranquilité/quiétude',
      'Twin Stillness/Silence': 'Entaille de la quiétude/tranquilité',
      'Wyrm\'s Lament': 'Rugissement du Dragon divin'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Earthen Aether': 'アース・エーテル',
      'frozen mirror': '氷面鏡',
      'great wyrm': '聖竜',
      'luminous Aether': 'ライト・エーテル',
      'Mothercrystal': 'マザークリスタル',
      'Shiva': 'シヴァ'
    },
    'replaceText': {
      'Absolute Zero': '絶対零度',
      'Akh Morn': 'アク・モーン',
      'Akh Rhai': 'アク・ラーイ',
      'Axe/Scythe Kick': 'アクスキック/サイスキック',
      'Banish(?! )': 'バニシュ',
      'Banish III': 'バニシュガ',
      'Biting/Driving Frost': 'フロストスラッシュ/フロストスラスト',
      'Bright Hunger': '浸食光',
      'Diamond Frost': 'ダイヤモンドダスト',
      'Double Slap': 'ダブルスラップ',
      'Drachen Armor': 'ドラゴンアーマー',
      'Draconic Strike': 'ドラコニックストライク',
      'Driving/Biting Frost': 'フロストスラスト/フロストスラッシュ',
      'Embittered/Spiteful Dance': '峻厳の舞踏技 / 冷厳の舞踏技',
      'Frigid Eruption': 'アイスエラプション',
      'Frigid Needle': 'アイスニードル',
      'Frigid Stone': 'アイスストーン',
      'Frigid Water': 'アイスフロスト',
      'Frost Armor(?! )': 'フロストアーマー',
      'Hallowed Wings': 'ホーリーウィング',
      'Heart Asunder': 'ハートアサンダー',
      'Heavenly Strike': 'ヘヴンリーストライク',
      'Holy': 'ホーリー',
      'Icelit Dragonsong': '氷と光の竜詩',
      'Icicle Impact': 'アイシクルインパクト',
      'Inescapable Illumination': '曝露光',
      'Light Rampant': '光の暴走',
      'Mirror, Mirror': '鏡の国',
      'Morn Afah': 'モーン・アファー',
      'Reflected Armor \\(B\\)': '反射アーマー（青）',
      'Reflected Armor \\(G\\)': '反射アーマー（緑）',
      'Reflected Armor \\(R\\)': '反射アーマー（赤）',
      'Reflected Drachen': '反射ドラゴンアーマー',
      'Reflected Frost \\(G\\)': '反射フロスト（緑）',
      'Reflected Frost \\(R\\)': '反射フロスト（赤）',
      'Reflected Frost Armor': 'ミラーリング・フロストアーマー',
      'Reflected Kick \\(G\\)': '反射キック',
      'Reflected Wings \\(B\\)': '反射ホーリーウィング（青)',
      'Reflected Wings \\(G\\)': '反射ホーリーウィング（緑）',
      'Reflected Wings \\(R\\)': '反射ホーリーウィング（赤）',
      'Rush': 'ラッシュ',
      'Scythe/Axe Kick': 'サイスキック/アクスキック',
      'Shattered World': 'シャッタード・ワールド',
      'Shining Armor': 'ブライトアーマー',
      'Skyfall': '世界消滅',
      'Spiteful/Embittered Dance': '冷厳の舞踏技 / 峻厳の舞踏技',
      'the Path of Light': '光の波動',
      'the House of Light': '光の津波',
      'Twin Silence/Stillness': '閑寂の双剣技／静寂の双剣技',
      'Twin Stillness/Silence': '静寂の双剣技／閑寂の双剣技',
      'Wyrm\'s Lament': '聖竜の咆哮'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Earthen Aether': '土以太',
      'Frozen Mirror': '冰面镜',
      'great wyrm': '圣龙',
      'Luminous Aether': '光以太',
      'Mothercrystal': '母水晶',
      'Shiva': '希瓦'
    },
    'replaceText': {
      'Absolute Zero': '绝对零度',
      'Mirror, Mirror': '镜中奇遇',
      'Biting/Driving Frost': '冰霜斩/刺',
      'Reflected Frost \\(G\\)': '连锁反斩(绿)',
      'Reflected Frost \\(R\\)': '连锁反斩(红)',
      'Diamond Frost': '钻石星尘',
      'Frigid Stone': '冰石',
      'Icicle Impact': '冰柱冲击',
      'Heavenly Strike': '天降一击',
      'Frigid Needle': '冰针',
      'Frigid Water': '冰霜',
      'Frigid Eruption': '极冰喷发',
      'Driving/Biting Frost': '冰霜刺/斩',
      'Double Slap': '双剑斩',
      'Shining Armor': '闪光护甲',
      'Axe/Scythe Kick': '阔斧/镰形回旋踢',
      'Light Rampant': '光之失控',
      'Bright Hunger': '侵蚀光',
      'The Path Of Light': '光之波动',
      'Scythe/Axe Kick': '镰形/阔斧回旋踢',
      'Reflected Kick \\(G\\)': '连锁反踢(绿)',
      'Banish III': '强放逐',
      'Shattered World': '世界分断',
      'Heart Asunder': '心碎',
      'Rush': '蓄势冲撞',
      'Skyfall': '世界消亡',
      'Akh Morn': '死亡轮回',
      'Morn Afah': '无尽顿悟',
      'Hallowed Wings': '神圣之翼',
      'Reflected Wings \\(B\\)': '连锁反翼(蓝)',
      'Reflected Wings \\(G\\)': '连锁反翼(绿)',
      'Reflected Wings \\(R\\)': '连锁反翼(红)',
      'Wyrm\'s Lament': '圣龙咆哮',
      '(?<! )Frost Armor': '冰霜护甲',
      'Twin Silence/Stillness': '闲寂/静寂的双剑技',
      'Twin Stillness/Silence': '静寂/闲寂的双剑技',
      'Drachen Armor': '圣龙护甲',
      'Akh Rhai': '天光轮回',
      'Reflected Armor \\(B\\)': '连锁反甲(蓝)',
      'Reflected Armor \\(G\\)': '连锁反甲(绿)',
      'Reflected Armor \\(R\\)': '连锁反甲(红)',
      'Holy': '神圣',
      'Embittered/Spiteful Dance': '严峻/冷峻之舞',
      'Spiteful/Embittered Dance': '冷峻/严峻之舞',
      'Reflected Drachen': '连锁反射：圣龙护甲',
      'Icelit Dragonsong': '冰与光的龙诗',
      'Draconic Strike': '圣龙一击',
      'Banish(?! )': '放逐',
      'Inescapable Illumination': '曝露光',
      'The House Of Light': '光之海啸',
      'Reflected Frost Armor \\(R\\)': '连锁反冰甲(红)'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Earthen Aether': '땅 에테르',
      'Shiva': '시바',
      'Frozen Mirror': '얼음 거울',
      'Mothercrystal': '어머니 크리스탈',
      'Luminous Aether': '빛 에테르',
      'great wyrm': '성룡'
    },
    'replaceText': {
      'Absolute Zero': '절대영도',
      'Mirror, Mirror': '거울 나라',
      'Biting/Driving Frost': '서리 참격/일격',
      'Reflected Frost \\(G\\)': '반사된 참격/일격 (초록)',
      'Reflected Frost \\(R\\)': '반사된 참격/일격 (빨강)',
      'Diamond Frost': '다이아몬드 더스트',
      'Frigid Stone': '얼음돌',
      'Icicle Impact': '고드름 낙하',
      'Heavenly Strike': '천상의 일격',
      'Frigid Needle': '얼음바늘',
      'Frigid Water': '얼음서리',
      'Frigid Eruption': '얼음 분출',
      'Driving/Biting Frost': '서리 일격/참격',
      'Double Slap': '이중 타격',
      'Shining Armor': '빛의 갑옷',
      'Axe/Scythe Kick': '도끼차기/낫차기',
      'Light Rampant': '빛의 폭주',
      'Bright Hunger': '침식광',
      'The Path Of Light': '빛의 파동',
      'Scythe/Axe Kick': '낫차기/도끼차기',
      'Reflected Kick \\(G\\)': '반사된 낫/도끼차기 (초록)',
      'Banish III': '배니시가',
      'Shattered World': '분단된 세계',
      'Heart Asunder': '조각난 마음',
      'Rush': '부딪기',
      'Skyfall': '세계 소멸',
      'Akh Morn': '아크 몬',
      'Morn Afah': '몬 아파',
      'Hallowed Wings': '신성한 날개',
      'Reflected Wings \\(B\\)': '반사된 신성한 날개 (파랑)',
      'Reflected Wings \\(G\\)': '반사된 신성한 날개 (초록)',
      'Reflected Wings \\(R\\)': '반사된 신성한 날개 (빨강)',
      'Wyrm\'s Lament': '성룡의 포효',
      '(?<! )Frost Armor': '서리 갑옷',
      'Twin Silence/Stillness': '고요/정적의 쌍검기',
      'Twin Stillness/Silence': '정적/고요의 쌍검기',
      'Drachen Armor': '용의 갑옷',
      'Akh Rhai': '아크 라이',
      'Reflected Armor \\(B\\)': '반사된 빛의 갑옷 (파랑)',
      'Reflected Armor \\(G\\)': '반사된 빛의 갑옷 (초록)',
      'Reflected Armor \\(R\\)': '반사된 빛의 갑옷 (빨강)',
      'Holy': '홀리',
      'Embittered/Spiteful Dance': '준엄/냉엄의 무도기',
      'Spiteful/Embittered Dance': '냉엄/준엄의 무도기',
      'Reflected Drachen': '반사된 용의 갑옷',
      'Icelit Dragonsong': '얼음과 빛의 용시',
      'Draconic Strike': '용의 일격',
      'Banish(?! )': '배니시',
      'Inescapable Illumination': '폭로광',
      'The House Of Light': '빛의 해일',
      'Reflected Frost Armor \\(R\\)': '반사된 서리 갑옷 (빨강)'
    }
  }]
};
/* harmony default export */ const e8s = (e8s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e8s.txt
const raid_e8s_namespaceObject = "### Eden 8 (Savage)\r\n# Eden's Verse: Refulgence\r\n#  -p 4DCC:16 4D74:213 4D79:368.6 -ii 4DA8 4D9C 4D95 4D9A 4DA9 4DA8 4DCD 4DAB 4D84 4E19 4D98 4E3C 4D7A 4DCF 4DAF 4D91 4DA7 4D88 4FD8\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Can use InCombat line to start timeline since the multiple phases do not\r\n# change the player's InCombat status.\r\n\r\n# TODO: is there a missing bright hunger in icelit? (4DA3?)\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n16.0 \"Absolute Zero\" Ability { id: \"4DCC\", source: \"Shiva\" } window 17,20\r\n27.2 \"Mirror, Mirror\" Ability { id: \"4D5A\", source: \"Shiva\" }\r\n39.3 \"Biting/Driving Frost\" Ability { id: \"4D6[67]\", source: \"Shiva\" }\r\n44.4 \"Reflected Frost (G)\" Ability { id: \"4DB[78]\", source: \"Frozen Mirror\" }\r\n49.4 \"Reflected Frost (R)\" Ability { id: \"4DC[34]\", source: \"Frozen Mirror\" }\r\n\r\n### Diamond Frost\r\n57.5 \"--middle--\" Ability { id: \"4D58\", source: \"Shiva\" }\r\n63.7 \"Diamond Frost\" Ability { id: \"4D6C\", source: \"Shiva\" }\r\n71.9 \"Frigid Stone\" Ability { id: \"4D9B\", source: \"Shiva\" }\r\n74.9 \"Icicle Impact\" Ability { id: \"4DA0\", source: \"Shiva\" }\r\n76.9 \"Heavenly Strike\" Ability { id: \"4D61\", source: \"Shiva\" }\r\n78.9 \"Icicle Impact\" Ability { id: \"4DA0\", source: \"Shiva\" }\r\n80.9 \"Frigid Needle\" Ability { id: \"4D9D\", source: \"Shiva\" }\r\n80.9 \"Frigid Water\" Ability { id: \"4D9E\", source: \"Shiva\" }\r\n82.9 \"Icicle Impact\" Ability { id: \"4DA0\", source: \"Shiva\" }\r\n83.9 \"Frigid Eruption 1\" #Ability { id: \"4D9F\", source: \"Shiva\" }\r\n85.9 \"Frigid Eruption 2\" #Ability { id: \"4D9F\", source: \"Shiva\" }\r\n87.9 \"Frigid Eruption 3\" #Ability { id: \"4D9F\", source: \"Shiva\" }\r\n92.9 \"Driving/Biting Frost\" Ability { id: \"4D6[67]\", source: \"Shiva\" }\r\n101.7 \"Double Slap\" Ability { id: \"4D65\", source: \"Shiva\" }\r\n115.0 \"Shining Armor\" Ability { id: \"4DD1\", source: \"Shiva\" }\r\n123.0 \"Axe/Scythe Kick\" Ability { id: \"4D6[DE]\", source: \"Shiva\" }\r\n\r\n### Light Rampant\r\n131.2 \"--middle--\" Ability { id: \"4D58\", source: \"Shiva\" }\r\n137.4 \"Light Rampant\" Ability { id: \"4D73\", source: \"Shiva\" } window 150,10\r\n148.6 \"Bright Hunger 4x1\" Ability { id: \"4DA2\", source: \"Shiva\" }\r\n148.6 \"The Path Of Light 1\" Ability { id: \"4D63\", source: \"Shiva\" }\r\n156.6 \"Bright Hunger 2x2\" Ability { id: \"4DA2\", source: \"Shiva\" }\r\n159.8 \"The Path Of Light 2\" Ability { id: \"4D63\", source: \"Shiva\" }\r\n164.7 \"Bright Hunger 1x4\" Ability { id: \"4DA2\", source: \"Shiva\" }\r\n\r\n173.0 \"Mirror, Mirror\" Ability { id: \"4D5A\", source: \"Shiva\" }\r\n185.2 \"Scythe/Axe Kick\" Ability { id: \"4D6[DE]\", source: \"Shiva\" }\r\n190.2 \"Reflected Kick (G)\" Ability { id: \"4DB[9A]\", source: \"Frozen Mirror\" }\r\n193.3 \"Banish III\" Ability { id: \"4D8[01]\", source: \"Shiva\" }\r\n\r\n### Adds Phase\r\n201.5 \"--untargetable--\"\r\n201.7 \"--sync--\" Ability { id: \"4D58\", source: \"Shiva\" }\r\n213.0 \"Shattered World\" Ability { id: \"4D74\", source: \"Shiva\" } window 220,20\r\n229.2 \"Heart Asunder\" Ability { id: \"4DAC\", source: \"Mothercrystal\" }\r\n238.9 \"Rush 1\" Ability { id: \"4D86\", source: \"Luminous Aether\" }\r\n243.3 \"Heart Asunder\" Ability { id: \"4DAC\", source: \"Mothercrystal\" }\r\n253.0 \"Rush 2\" Ability { id: \"4D86\", source: \"Luminous Aether\" }\r\n257.4 \"Heart Asunder\" Ability { id: \"4DAC\", source: \"Mothercrystal\" }\r\n267.1 \"Rush 3\" Ability { id: \"4D86\", source: \"Luminous Aether\" }\r\n271.5 \"Heart Asunder\" Ability { id: \"4DAC\", source: \"Mothercrystal\" }\r\n281.2 \"Rush 4\" Ability { id: \"4D86\", source: \"Luminous Aether\" }\r\n292.6 \"Skyfall\" Ability { id: \"4DAD\", source: \"Shiva\" } window 100,100\r\n\r\n### Dragon Fanfic\r\n# :eyes:\r\n\r\n### Wing Mirrors\r\n350.5 \"--targetable--\"\r\n364.2 \"--sync--\" StartsUsing { id: \"4D79\", source: \"Shiva\" } window 370,10\r\n368.6 \"Akh Morn x3\" Ability { id: \"4D79\", source: \"Shiva\" } duration 3.1\r\n378.0 \"Morn Afah\" Ability { id: \"4D7B\", source: \"Shiva\" }\r\n389.4 \"Mirror, Mirror\" Ability { id: \"4D5A\", source: \"Shiva\" }\r\n396.9 \"--sync--\" Ability { id: \"4D58\", source: \"Shiva\" }\r\n403.2 \"Hallowed Wings 1\" Ability { id: \"4D7[56]\", source: \"Shiva\" }\r\n403.2 \"Reflected Wings (B)\" Ability { id: \"4D9[01]\", source: \"Frozen Mirror\" }\r\n408.2 \"Reflected Wings (G)\" Ability { id: \"4DB[BC]\", source: \"Frozen Mirror\" }\r\n413.2 \"Hallowed Wings 2\" Ability { id: \"4D7[56]\", source: \"Shiva\" }\r\n413.2 \"Reflected Wings (R)\" Ability { id: \"4DC[78]\", source: \"Frozen Mirror\" }\r\n\r\n### Wyrm's Lament\r\n421.7 \"--middle--\" Ability { id: \"4D58\", source: \"Shiva\" }\r\n427.9 \"Wyrm's Lament\" Ability { id: \"4D7C\", source: \"Shiva\" }\r\n441.0 \"Hallowed Wings 1\" Ability { id: \"4D7[56]\", source: \"Shiva\" }\r\n449.1 \"Hallowed Wings 2\" Ability { id: \"4D7[56]\", source: \"Shiva\" }\r\n457.2 \"Hallowed Wings 3\" Ability { id: \"4D7[56]\", source: \"Shiva\" }\r\n465.3 \"Hallowed Wings 4\" Ability { id: \"4D7[56]\", source: \"Shiva\" }\r\n473.5 \"Frost Armor\" Ability { id: \"4DD0\", source: \"Shiva\" }\r\n481.4 \"Twin Silence/Stillness\" Ability { id: \"4D6[89]\", source: \"Shiva\" }\r\n483.5 \"Twin Stillness/Silence\" Ability { id: \"4D6[AB]\", source: \"Shiva\" }\r\n491.6 \"Double Slap\" Ability { id: \"4D65\", source: \"Shiva\" }\r\n504.8 \"Drachen Armor\" Ability { id: \"4DD2\", source: \"Shiva\" }\r\n507.3 \"Akh Rhai\" Ability { id: \"4D99\", source: \"Shiva\" }\r\n\r\n### Stack Mirrors\r\n516.1 \"Mirror, Mirror\" Ability { id: \"4D5A\", source: \"Shiva\" }\r\n523.6 \"--teleport--\" Ability { id: \"4D58\", source: \"Shiva\" }\r\n530.0 \"Hallowed Wings\" Ability { id: \"4D77\", source: \"Shiva\" }\r\n535.1 \"Reflected Wings (G)\" Ability { id: \"4DBD\", source: \"Frozen Mirror\" }\r\n540.1 \"Reflected Wings (R)\" Ability { id: \"4DC9\", source: \"Frozen Mirror\" }\r\n\r\n### Lookaway Mirrors\r\n554.1 \"Mirror, Mirror\" Ability { id: \"4D5A\", source: \"Shiva\" }\r\n566.6 \"Shining Armor\" Ability { id: \"4DD1\", source: \"Shiva\" }\r\n566.6 \"Reflected Armor (B)\" Ability { id: \"4D8A\", source: \"Frozen Mirror\" }\r\n571.7 \"Reflected Armor (G)\" Ability { id: \"4DB5\", source: \"Frozen Mirror\" }\r\n576.7 \"Reflected Armor (R)\" Ability { id: \"4DC1\", source: \"Frozen Mirror\" }\r\n577.6 \"Holy\" Ability { id: \"4D8[23]\", source: \"Shiva\" }\r\n585.7 \"Embittered/Spiteful Dance\" Ability { id: \"4D(6F|70)\", source: \"Shiva\" }\r\n589.8 \"Spiteful/Embittered Dance\" Ability { id: \"4D7[12]\", source: \"Shiva\" }\r\n\r\n### Akh Rhai Mirrors\r\n600.9 \"Mirror, Mirror\" Ability { id: \"4D5A\", source: \"Shiva\" }\r\n608.1 \"Drachen Armor\" Ability { id: \"4DD2\", source: \"Shiva\" }\r\n610.6 \"Akh Rhai\" Ability { id: \"4D99\", source: \"Shiva\" }\r\n618.2 \"Reflected Drachen\" Ability { id: \"4DC2\", source: \"Frozen Mirror\" }\r\n620.4 \"Akh Morn x4\" Ability { id: \"4D79\", source: \"Shiva\" } duration 4.2\r\n620.7 \"Akh Rhai\" Ability { id: \"4D99\", source: \"Shiva\" }\r\n630.8 \"Morn Afah\" Ability { id: \"4D7B\", source: \"Shiva\" }\r\n\r\n### Icelit Dragonsong\r\n648.8 \"--middle--\" Ability { id: \"4D58\", source: \"Shiva\" }\r\n655.4 \"Icelit Dragonsong\" Ability { id: \"4D7D\", source: \"Shiva\" }\r\n663.6 \"Frigid Stone\" Ability { id: \"4D9B\", source: \"Shiva\" }\r\n666.6 \"Bright Hunger 4x1\" Ability { id: \"4DA2\", source: \"Shiva\" }\r\n668.6 \"Draconic Strike\" Ability { id: \"4D62\", source: \"Shiva\" }\r\n669.3 \"--knockback--\"\r\n672.7 \"Frigid Needle\" Ability { id: \"4D9D\", source: \"Shiva\" }\r\n674.7 \"Bright Hunger 3x1\" Ability { id: \"4DA2\", source: \"Shiva\" }\r\n676.7 \"Frigid Eruption 1\" #Ability { id: \"4D9F\", source: \"Shiva\" }\r\n676.8 \"Banish\" Ability { id: \"4D7[EF]\", source: \"Shiva\" }\r\n678.7 \"Frigid Eruption 2\" #Ability { id: \"4D9F\", source: \"Shiva\" }\r\n680.8 \"Frigid Eruption 3\" #Ability { id: \"4D9F\", source: \"Shiva\" }\r\n682.7 \"Inescapable Illumination\" Ability { id: \"4DA3\", source: \"Shiva\" }\r\n688.0 \"The House Of Light\" Ability { id: \"4D64\", source: \"Shiva\" }\r\n688.9 \"The Path Of Light\" Ability { id: \"4DA1\", source: \"Shiva\" }\r\n\r\n### Ice Mirror\r\n699.6 \"Mirror, Mirror\" Ability { id: \"4D5A\", source: \"Shiva\" }\r\n709.9 \"Frost Armor\" Ability { id: \"4DD0\", source: \"Shiva\" }\r\n719.9 \"Reflected Frost Armor (R)\" Ability { id: \"4DC0\", source: \"Frozen Mirror\" }\r\n720.4 \"Drachen Armor\" Ability { id: \"4DD2\", source: \"Shiva\" }\r\n722.9 \"Akh Rhai\" Ability { id: \"4D99\", source: \"Shiva\" }\r\n\r\n### Wyrm's Lament Take 2\r\n732.1 \"--middle--\" Ability { id: \"4D58\", source: \"Shiva\" }\r\n738.3 \"Wyrm's Lament\" Ability { id: \"4D7C\", source: \"Shiva\" }\r\n745.5 \"Akh Morn x5\" Ability { id: \"4D79\", source: \"Shiva\" } duration 5.3\r\n757.1 \"Morn Afah\" Ability { id: \"4D7B\", source: \"Shiva\" }\r\n764.3 \"Akh Morn x6\" Ability { id: \"4D79\", source: \"Shiva\" } duration 6.4\r\n777.0 \"Morn Afah\" Ability { id: \"4D7B\", source: \"Shiva\" }\r\n784.3 \"Akh Morn x7\" Ability { id: \"4D79\", source: \"Shiva\" } duration 7.5\r\n798.1 \"Morn Afah\" Ability { id: \"4D7B\", source: \"Shiva\" }\r\n\r\n### Enrage Mirrors\r\n817.1 \"Mirror, Mirror\" Ability { id: \"4D5A\", source: \"Shiva\" }\r\n819.2 \"--teleport--\" Ability { id: \"4D58\", source: \"Shiva\" }\r\n830.6 \"Hallowed Wings\" Ability { id: \"4D78\", source: \"Shiva\" }\r\n840.8 \"Enrage\" Ability { id: \"4DC[AB]\", source: \"Frozen Mirror\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e9n.ts



const e9n_triggerSet = {
  id: 'EdensPromiseUmbra',
  zoneId: zone_id/* default.EdensPromiseUmbra */.Z.EdensPromiseUmbra,
  timelineFile: 'e9n.txt',
  triggers: [{
    id: 'E9N Ground-Razing Particle Beam',
    type: 'StartsUsing',
    netRegex: {
      id: '55ED',
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E9N The Art Of Darkness Right',
    type: 'StartsUsing',
    netRegex: {
      id: '5223',
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 4,
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'E9N The Art Of Darkness Left',
    type: 'StartsUsing',
    netRegex: {
      id: '5224',
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 4,
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'E9N Wide-Angle Particle Beam',
    type: 'StartsUsing',
    netRegex: {
      id: '5AFF',
      source: 'Cloud Of Darkness',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront('info')
  }, {
    id: 'E9N Zero-Form Particle Beam',
    type: 'StartsUsing',
    netRegex: {
      id: '55EB',
      source: 'Cloud Of Darkness'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'E9N Empty Plane',
    type: 'StartsUsing',
    netRegex: {
      id: '4FC6',
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E9N Obscure Woods',
    type: 'StartsUsing',
    netRegex: {
      id: '4FA2',
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E9N Waste Away',
    type: 'StartsUsing',
    netRegex: {
      id: '55DE',
      source: 'Cloud Of Darkness',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback('info')
  }, {
    id: 'E9N Stygian Tether',
    type: 'HeadMarker',
    netRegex: {
      id: '000C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Wait Near Bramble',
        de: 'Warte in der Nähe des Dornenstrauch',
        fr: 'Attendez près des ronces',
        ja: '闇の茨へ、蔦を切るまで待つ',
        cn: '靠近荆棘等待',
        ko: '장판 근처에서 대기'
      }
    }
  }, {
    id: 'E9N Stygian Break Tether',
    type: 'Tether',
    netRegex: {
      id: '0012'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.breakChains */.n3.breakChains()
  }, {
    id: 'E9N Wide-Angle Phaser',
    type: 'StartsUsing',
    netRegex: {
      id: ['55DF', '55E[01]'],
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 5,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Sides At Tethered Wall',
        de: 'Geh seitlich der verundenen Wände',
        fr: 'Allez vers les côtés du mur lié',
        ja: '線が繋がった外周の横へ',
        cn: '去连线的墙壁两边',
        ko: '선 연결된 쪽으로 이동'
      }
    }
  }, {
    id: 'E9N Rejuvenating Balm',
    type: 'StartsUsing',
    netRegex: {
      id: '55E2',
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Tethered Walls',
        de: 'Weg von den verbundenen Wänden',
        fr: 'Éloignez-vous des murs liés',
        ja: '線が繋がった外周から離れる',
        cn: '远离连线的墙壁',
        ko: '보스 선 연결된 방향 피하기'
      }
    }
  }, {
    id: 'E9N Deluge Of Darkness',
    type: 'StartsUsing',
    netRegex: {
      id: '5155',
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E9N Particle Concentration',
    type: 'StartsUsing',
    netRegex: {
      id: '55E8',
      source: 'Cloud Of Darkness',
      capture: false
    },
    delaySeconds: 4,
    durationSeconds: 4,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 들어가기'
      }
    }
  }, {
    id: 'E9N Hypercharged Condensation',
    type: 'StartsUsing',
    netRegex: {
      id: '532E',
      source: 'Cloud Of Darkness',
      capture: false
    },
    delaySeconds: 2,
    durationSeconds: 5,
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'E9N Anti-Air Particle Beam',
    type: 'StartsUsing',
    netRegex: {
      id: '55DC',
      source: 'Cloud Of Darkness',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut('info')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Cloud Of Darkness': 'Wolke der Dunkelheit',
      'Stygian Arbor': 'stygisch(?:e|er|es|en) Dorn'
    },
    'replaceText': {
      'Anti-air Particle Beam': 'Flugabwehr-Partikelstrahl',
      'Bad Vibrations': 'Starke Vibration',
      'Deluge of Darkness': 'Sintflut der Dunkelheit',
      'Earth-shattering Particle Beam': 'Erderschütternder Partikelstrahl',
      'Empty Plane': 'Düsterer Himmel',
      'Evil Seed': 'Saatkugel',
      'Flood of Emptiness': 'Dunkle Flut: Düsterer Himmel',
      'Flood of Obscurity': 'Flut der Finsternis',
      'Ground-razing Particle Beam': 'Radialer Partikelstrahl',
      'Hypercharged Condensation': 'Elektrisierte Kondensation',
      'Mire of Despair': 'Sumpf der Dunkelheit',
      'Obscure Woods': 'Finsterer Wald',
      '(?<! )Particle Beam': 'Partikelstrahl',
      'Particle Concentration': 'Wellenkugel',
      'Rejuvenating Balm': 'Aktivierte Kugel',
      'Summon': 'Rufen',
      'the Art of Darkness': 'Dunkle Taktik',
      'Waste Away': 'Verdorren',
      'Wide-angle Particle Beam': 'Weitwinkel-Partikelstrahl',
      'Wide-angle Phaser': 'Weitwinkel-Phaser',
      'Zero-form Particle Beam': 'Nullform-Partikelstrahl'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Cloud Of Darkness': 'Nuage de Ténèbres',
      'Stygian Arbor': 'arbre ténébreux'
    },
    'replaceText': {
      'Anti-air Particle Beam': 'Faisceau de particules antiaérien',
      'Bad Vibrations': 'Vibration intense',
      'Deluge of Darkness': 'Grand déluge de Ténèbres',
      'Earth-shattering Particle Beam': 'Faisceau de particules fracassant',
      'Empty Plane': 'Cieux obscurs',
      'Evil Seed': 'Tir semant',
      'Flood of Emptiness': 'Déluge de Ténèbres : Cieux obscurs',
      'Flood of Obscurity': 'Déluge de Ténèbres : Forêt obscure',
      'Ground-razing Particle Beam': 'Faisceau de particules radiant',
      'Hypercharged Condensation': 'Aspiration particulaire',
      'Mire of Despair': 'Marais de Ténèbres',
      'Obscure Woods': 'Forêt obscure',
      '(?<! )Particle Beam': 'Rayon explosif',
      'Particle Concentration': 'Rayon sphérique',
      'Rejuvenating Balm': 'Tir vivifiant',
      'Summon': 'Invocation',
      'the Art of Darkness': 'Arts ténébreux',
      'Waste Away': 'Dépérissement',
      'Wide-angle Particle Beam': 'Faisceau de particules élargi',
      'Wide-angle Phaser': 'Faisceau de particules bondissant élargi',
      'Zero-form Particle Beam': 'Faisceau de particules zéro absolu'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Cloud Of Darkness': '暗闇の雲',
      'Stygian Arbor': '闇の大樹'
    },
    'replaceText': {
      'Anti-air Particle Beam': '高射式 波動砲',
      'Bad Vibrations': '強振動',
      'Deluge of Darkness': '闇の大氾濫',
      'Earth-shattering Particle Beam': '貫地式 波動砲',
      'Empty Plane': '暗黒天空',
      'Evil Seed': '種子弾',
      'Flood of Emptiness': '闇の氾濫：暗黒天空',
      'Flood of Obscurity': '闇の氾濫：暗黒森林',
      'Ground-razing Particle Beam': '放射式 波動砲',
      'Hypercharged Condensation': '波動雲吸引',
      'Mire of Despair': '闇の沼',
      'Obscure Woods': '暗黒森林',
      '(?<! )Particle Beam': '波動爆発',
      'Particle Concentration': '波動球',
      'Rejuvenating Balm': '活性弾',
      'Summon': '召喚',
      'the Art of Darkness': '闇の戦技',
      'Waste Away': '立ち枯れ',
      'Wide-angle Particle Beam': '広角式 波動砲',
      'Wide-angle Phaser': '広角式 跳躍波動砲',
      'Zero-form Particle Beam': '零式 波動砲'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Cloud Of Darkness': '暗黑之云',
      'Stygian Arbor': '暗之大树'
    },
    'replaceText': {
      'Anti-air Particle Beam': '高射式波动炮',
      'Bad Vibrations': '强震动',
      'Deluge of Darkness': '暗之大泛滥',
      'Earth-shattering Particle Beam': '贯地式波动炮',
      'Empty Plane': '暗黑天空',
      'Evil Seed': '种子弹',
      'Flood of Emptiness': '暗之泛滥：暗黑天空',
      'Flood of Obscurity': '暗之泛滥：暗黑森林',
      'Ground-razing Particle Beam': '放射式波动炮',
      'Hypercharged Condensation': '吸引波动云',
      'Mire of Despair': '暗之沼',
      'Obscure Woods': '暗黑森林',
      '(?<! )Particle Beam': '波动爆炸',
      'Particle Concentration': '波动球',
      'Rejuvenating Balm': '活性弹',
      'Summon': '召唤',
      'the Art of Darkness': '暗之战技',
      'Waste Away': '枯萎',
      'Wide-angle Particle Beam': '广角式波动炮',
      'Wide-angle Phaser': '广角式跳跃波动炮',
      'Zero-form Particle Beam': '零式波动炮'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Cloud Of Darkness': '어둠의 구름',
      'Stygian Arbor': '어둠의 나무'
    },
    'replaceText': {
      'Anti-air Particle Beam': '고공식 파동포',
      'Bad Vibrations': '강력한 진동',
      'Deluge of Darkness': '어둠의 대범람',
      'Earth-shattering Particle Beam': '붕괴식 파동포',
      'Empty Plane': '암흑의 하늘',
      'Evil Seed': '씨앗탄',
      'Flood of Emptiness': '어둠의 범람: 암흑의 하늘',
      'Flood of Obscurity': '어둠의 범람: 암흑의 숲',
      'Ground-razing Particle Beam': '방사식 파동포',
      'Hypercharged Condensation': '파동운 흡인',
      'Mire of Despair': '어둠의 늪',
      'Obscure Woods': '암흑의 숲',
      '(?<! )Particle Beam': '파동 폭발',
      'Particle Concentration': '파동구',
      'Rejuvenating Balm': '활성탄',
      'Summon': '소환',
      'the Art of Darkness': '어둠의 전투술',
      'Waste Away': '메마름',
      'Wide-angle Particle Beam': '광각식 파동포',
      'Wide-angle Phaser': '광각식 도약파동포',
      'Zero-form Particle Beam': '0식 파동포'
    }
  }]
};
/* harmony default export */ const e9n = (e9n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e9n.txt
const raid_e9n_namespaceObject = "### Eden 9 (Normal)\r\n# Eden's Promise: Umbra\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# -ii 5626 5B18 55E1 55E3 5159 532F 55DB 55E5\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n10.4 \"--sync--\" StartsUsing { id: \"55ED\", source: \"Cloud Of Darkness\" } window 10.4,5\r\n15.1 \"Ground-Razing Particle Beam\" Ability { id: \"55ED\", source: \"Cloud Of Darkness\" }\r\n25.3 \"The Art Of Darkness\" Ability { id: \"522[34]\", source: \"Cloud Of Darkness\" }\r\n34.8 \"Wide-Angle Particle Beam\" Ability { id: \"5AFF\", source: \"Cloud Of Darkness\" }\r\n45.2 \"Zero-Form Particle Beam\" Ability { id: \"55EB\", source: \"Cloud Of Darkness\" }\r\n56.7 \"Empty Plane\" Ability { id: \"4FC6\", source: \"Cloud Of Darkness\" } window 56.7,10\r\n70.9 \"Flood Of Emptiness\" Ability { id: \"5132\", source: \"Cloud Of Darkness\" }\r\n71.3 \"Mire Of Despair\" Ability { id: \"5B07\", source: \"Cloud Of Darkness\" }\r\n71.3 \"Earth-Shattering Particle Beam\" Ability { id: \"5225\", source: \"Cloud Of Darkness\" }\r\n88.0 \"Ground-Razing Particle Beam\" Ability { id: \"55ED\", source: \"Cloud Of Darkness\" }\r\n99.2 \"The Art Of Darkness\" Ability { id: \"522[34]\", source: \"Cloud Of Darkness\" }\r\n\r\n111.5 \"Obscure Woods\" Ability { id: \"4FA2\", source: \"Cloud Of Darkness\" } window 111.5,10\r\n124.7 \"Flood Of Obscurity\" Ability { id: \"58F1\", source: \"Cloud Of Darkness\" }\r\n124.9 \"Waste Away\" Ability { id: \"55DE\", source: \"Cloud Of Darkness\" }\r\n127.2 \"Evil Seed\" Ability { id: \"55E7\", source: \"Cloud Of Darkness\" }\r\n145.3 \"The Art Of Darkness\" Ability { id: \"522[34]\", source: \"Cloud Of Darkness\" }\r\n157.3 \"Wide-Angle Phaser\" Ability { id: \"55E0\", source: \"Cloud Of Darkness\" }\r\n171.1 \"Rejuvenating Balm\" Ability { id: \"55E2\", source: \"Cloud Of Darkness\" }\r\n181.3 \"Bad Vibrations\" Ability { id: \"55E6\", source: \"Stygian Arbor\" } window 30,30\r\n192.3 \"Deluge Of Darkness\" Ability { id: \"5155\", source: \"Cloud Of Darkness\" }\r\n205.7 \"Zero-Form Particle Beam\" Ability { id: \"55EB\", source: \"Cloud Of Darkness\" }\r\n211.9 \"Particle Concentration\" Ability { id: \"55E8\", source: \"Cloud Of Darkness\" }\r\n222.9 \"Particle Beam\" Ability { id: \"55E9\", source: \"Cloud Of Darkness\" }\r\n226.6 \"The Art Of Darkness\" Ability { id: \"522[34]\", source: \"Cloud Of Darkness\" }\r\n\r\n239.2 \"Empty Plane\" Ability { id: \"4FC6\", source: \"Cloud Of Darkness\" } window 30,30\r\n253.4 \"Flood Of Emptiness\" Ability { id: \"5132\", source: \"Cloud Of Darkness\" }\r\n253.8 \"Mire Of Despair\" Ability { id: \"5B07\", source: \"Cloud Of Darkness\" }\r\n253.8 \"Earth-Shattering Particle Beam\" Ability { id: \"5225\", source: \"Cloud Of Darkness\" }\r\n259.5 \"Hypercharged Condensation\" Ability { id: \"532E\", source: \"Cloud Of Darkness\" }\r\n281.7 \"Summon\" Ability { id: \"5330\", source: \"Cloud Of Darkness\" } window 30,30\r\n289.8 \"Anti-Air Particle Beam\" Ability { id: \"55DC\", source: \"Cloud Of Darkness\" }\r\n301.0 \"The Art Of Darkness\" Ability { id: \"522[34]\", source: \"Cloud Of Darkness\" }\r\n313.2 \"Ground-Razing Particle Beam\" Ability { id: \"55ED\", source: \"Cloud Of Darkness\" }\r\n\r\n327.7 \"Obscure Woods\" Ability { id: \"4FA2\", source: \"Cloud Of Darkness\" } window 30,30\r\n339.9 \"Flood Of Obscurity\" Ability { id: \"58F1\", source: \"Cloud Of Darkness\" }\r\n340.1 \"Waste Away\" Ability { id: \"55DE\", source: \"Cloud Of Darkness\" }\r\n342.4 \"Evil Seed\" Ability { id: \"55E7\", source: \"Cloud Of Darkness\" }\r\n361.7 \"Wide-Angle Phaser\" Ability { id: \"55E0\", source: \"Cloud Of Darkness\" }\r\n376.8 \"Rejuvenating Balm\" Ability { id: \"55E2\", source: \"Cloud Of Darkness\" }\r\n384.2 \"The Art Of Darkness\" Ability { id: \"522[34]\", source: \"Cloud Of Darkness\" }\r\n386.6 \"Bad Vibrations\" Ability { id: \"55E6\", source: \"Stygian Arbor\" } window 30,30\r\n399.2 \"Deluge Of Darkness\" Ability { id: \"5155\", source: \"Cloud Of Darkness\" }\r\n414.3 \"The Art Of Darkness\" Ability { id: \"522[34]\", source: \"Cloud Of Darkness\" }\r\n426.5 \"Ground-Razing Particle Beam\" Ability { id: \"55ED\", source: \"Cloud Of Darkness\" }\r\n434.9 \"Zero-Form Particle Beam\" Ability { id: \"55EB\", source: \"Cloud Of Darkness\" }\r\n\r\n449.6 \"Empty Plane\" Ability { id: \"4FC6\", source: \"Cloud Of Darkness\" } window 30,30 jump 239.2\r\n463.8 \"Flood Of Emptiness\"\r\n464.2 \"Mire Of Despair\"\r\n464.2 \"Earth-Shattering Particle Beam\"\r\n469.9 \"Hypercharged Condensation\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e9s.ts






// TODO: Add N/S E/W callout to Rejuvenating Balm

const phaserOutputStrings = {
  sides: outputs/* default.sides */.Z.sides,
  out: outputs/* default.out */.Z.out,
  healerStacks: {
    en: 'Healer Stacks',
    de: 'Bei den Heilern sammeln',
    fr: 'Packages sur les heals',
    ja: 'ヒーラーに集合',
    cn: '治疗集合',
    ko: '힐러 모이기'
  },
  tankSpread: {
    en: 'Tank Spread',
    de: 'Tanks verteilen',
    fr: 'Tanks, dispersez-vous',
    ja: 'タンクは外に',
    cn: '坦克散开',
    ko: '탱 산개'
  },
  tankLaser: {
    en: 'Laser on YOU',
    de: 'Laser auf DIR',
    fr: 'Laser sur VOUS',
    ja: '自分にレーザー',
    cn: '激光点名',
    ko: '레이저 대상자'
  }
};
const artOfDarknessOutputStrings = {
  goRight: outputs/* default.right */.Z.right,
  goLeft: outputs/* default.left */.Z.left,
  stackWithPartner: {
    en: 'Stack With Partner',
    de: 'Mit Partner stacken',
    fr: 'Packez-vous avec votre partenaire',
    ja: '相方とスタック',
    cn: '与搭档集合',
    ko: '쉐어뎀 파트너랑 모이기'
  },
  protean: {
    en: 'Protean',
    de: 'Himmelsrichtungen',
    fr: 'Positions',
    ja: '散開',
    cn: '散开',
    ko: '산개'
  },
  unknown: outputs/* default.unknown */.Z.unknown
};
const summonDirectionOutputStrings = {
  NNE: outputs/* default.dirNNE */.Z.dirNNE,
  ENE: outputs/* default.dirENE */.Z.dirENE,
  ESE: outputs/* default.dirESE */.Z.dirESE,
  SSE: outputs/* default.dirSSE */.Z.dirSSE,
  SSW: outputs/* default.dirSSW */.Z.dirSSW,
  WSW: outputs/* default.dirWSW */.Z.dirWSW,
  WNW: outputs/* default.dirWNW */.Z.dirWNW,
  NNW: outputs/* default.dirNNW */.Z.dirNNW,
  unknown: outputs/* default.unknown */.Z.unknown
};
const convertBossHeadingToClonePosition = boss => {
  // Snap heading to closest card/intercard (aka PI/4).  N = PI, E = PI/2.
  const closestRad = Math.round(boss.Heading * 4 / Math.PI) / 4 * Math.PI;
  // Find position opposite of the boss facing, centered on 100,100.
  return {
    ...boss,
    PosX: 100 - 20 * Math.round(Math.sin(closestRad)),
    PosY: 100 - 20 * Math.round(Math.cos(closestRad))
  };
};
const calculateSummonSafeZone = (boss, clone1, clone2, abilityId) => {
  // Convert coordinates to 8 cardinal / intercardinal positions:
  // N at 0, NE at 1, ... NW at 7
  const b = Math.round(4 - 4 * Math.atan2(boss.PosX - 100, boss.PosY - 100) / Math.PI);
  const c1 = Math.round(4 - 4 * Math.atan2(clone1.PosX - 100, clone1.PosY - 100) / Math.PI);
  const c2 = Math.round(4 - 4 * Math.atan2(clone2.PosX - 100, clone2.PosY - 100) / Math.PI);
  const directions = {
    '0': 'NNE',
    '1': 'ENE',
    '2': 'ESE',
    '3': 'SSE',
    '4': 'SSW',
    '5': 'WSW',
    '6': 'WNW',
    '7': 'NNW'
  };
  const badZones = [];
  for (const position of [b, c1, c2]) {
    for (let i = 0; i < 4; ++i) {
      let newPosition;
      // Swiping her right
      if (abilityId === '561E') {
        // Off by 1 here, since N is 0 for the Clone but NNE for the safe spot
        newPosition = (position - i % 8 + 7) % 8;
      } else {
        newPosition = (position + i) % 8;
      }
      if (!badZones.includes(newPosition)) badZones.push(newPosition);
    }
  }
  const safeZones = [0, 1, 2, 3, 4, 5, 6, 7].filter(pos => !badZones.includes(pos)).map(pos => directions[pos]);
  const safeZone = safeZones[0];
  if (safeZone === undefined || safeZones.length !== 1) return 'unknown';
  return safeZone;
};
const e9s_triggerSet = {
  id: 'EdensPromiseUmbraSavage',
  zoneId: zone_id/* default.EdensPromiseUmbraSavage */.Z.EdensPromiseUmbraSavage,
  timelineFile: 'e9s.txt',
  triggers: [{
    id: 'E9S Ground-Razing Particle Beam',
    type: 'StartsUsing',
    netRegex: {
      id: '5625',
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E9S The Art Of Darkness Protean',
    type: 'StartsUsing',
    netRegex: {
      id: ['5B45', '55FB'],
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: data => data.phase === 'empty' ? 8 : 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: artOfDarknessOutputStrings.protean
    }
  }, {
    id: 'E9S The Art Of Darkness Partner Stacks',
    type: 'StartsUsing',
    netRegex: {
      id: ['5B46', '55FE'],
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: data => data.phase === 'empty' ? 8 : 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: artOfDarknessOutputStrings.stackWithPartner
    }
  }, {
    id: 'E9S Zero-Form Devouring Dark',
    type: 'StartsUsing',
    netRegex: {
      id: '5623',
      source: 'Cloud Of Darkness'
    },
    durationSeconds: 4,
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.tankBusterOnYou();
      if (data.role === 'tank') return output.tankSwap();
      if (data.role === 'healer') return output.tankBusters({
        player: data.party.member(matches.target)
      });
    },
    infoText: (data, _matches, output) => {
      if (data.role !== 'tank' && data.role !== 'healer') return output.avoidLaser();
    },
    outputStrings: {
      tankBusterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
      tankBusters: outputs/* default.tankBusters */.Z.tankBusters,
      tankSwap: outputs/* default.tankSwap */.Z.tankSwap,
      avoidLaser: {
        en: 'Avoid Laser',
        de: 'Laser ausweichen',
        fr: 'Évitez le laser',
        ja: 'レーザー注意',
        cn: '躲避死刑激光',
        ko: '레이저 피하기'
      }
    }
  }, {
    id: 'E9S Obscure Woods',
    type: 'StartsUsing',
    netRegex: {
      id: '55EE',
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'E9S Flood Of Obscurity',
    type: 'StartsUsing',
    netRegex: {
      id: '5907',
      source: 'Cloud Of Darkness',
      capture: false
    },
    delaySeconds: 3,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Place Bramble',
        de: 'Dornenstrauch plazieren',
        fr: 'Placez les ronces',
        ja: '苗木を捨てる',
        cn: '击退放置树苗',
        ko: '장판 유도하기'
      }
    }
  }, {
    id: 'E9S Waste Away',
    type: 'StartsUsing',
    netRegex: {
      id: '5617',
      source: 'Cloud Of Darkness',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'E9S Rejuvenating Balm',
    type: 'StartsUsing',
    netRegex: {
      id: '5618',
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Tethered Walls',
        de: 'Weg von den verbundenen Wänden',
        fr: 'Éloignez-vous des murs liés',
        ja: '線が繋がれなかった方へ',
        cn: '远离连线的墙壁',
        ko: '보스 선 연결된 방향 피하기'
      }
    }
  }, {
    id: 'E9S Stygian Break Tether',
    type: 'Tether',
    netRegex: {
      id: '0012'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 1,
    response: responses/* Responses.breakChains */.n3.breakChains()
  }, {
    id: 'E9S Anti-Air Phaser Unlimited List',
    type: 'StartsUsing',
    netRegex: {
      id: '561[23]',
      source: 'Cloud Of Darkness',
      capture: false
    },
    preRun: data => {
      if (data.role === 'tank') data.phaserOutputs = ['out', 'tankSpread', 'sides'];else data.phaserOutputs = ['out', 'healerStacks', 'sides'];
    },
    durationSeconds: 15,
    infoText: (data, _matches, output) => data.phaserOutputs?.map(key => output[key]()).join(' -> '),
    run: data => data.phaserOutputs?.shift(),
    outputStrings: phaserOutputStrings
  }, {
    id: 'E9S Anti-Air Phaser Unlimited 2',
    type: 'StartsUsing',
    netRegex: {
      id: '561[23]',
      source: 'Cloud Of Darkness',
      capture: false
    },
    delaySeconds: 7,
    alertText: (data, _matches, output) => {
      const key = data.phaserOutputs?.shift();
      if (key !== undefined) return output[key]();
    },
    outputStrings: phaserOutputStrings
  }, {
    id: 'E9S Anti-Air Phaser Unlimited 3',
    type: 'StartsUsing',
    netRegex: {
      id: '561[23]',
      source: 'Cloud Of Darkness',
      capture: false
    },
    delaySeconds: 12,
    alertText: (data, _matches, output) => {
      const key = data.phaserOutputs?.shift();
      if (key !== undefined) return output[key]();
    },
    outputStrings: phaserOutputStrings
  }, {
    id: 'E9S Wide-Angle Phaser Unlimited List',
    type: 'StartsUsing',
    netRegex: {
      id: '560[DE]',
      source: 'Cloud Of Darkness',
      capture: false
    },
    preRun: data => {
      if (data.role === 'tank') data.phaserOutputs = ['sides', 'tankLaser', 'out'];else data.phaserOutputs = ['sides', 'healerStacks', 'out'];
    },
    durationSeconds: 15,
    infoText: (data, _matches, output) => data.phaserOutputs?.map(key => output[key]()).join(' -> '),
    run: data => data.phaserOutputs?.shift(),
    outputStrings: phaserOutputStrings
  }, {
    id: 'E9S Wide-Angle Phaser Unlimited 2',
    type: 'StartsUsing',
    netRegex: {
      id: '560[DE]',
      source: 'Cloud Of Darkness',
      capture: false
    },
    delaySeconds: 8,
    alertText: (data, _matches, output) => {
      const key = data.phaserOutputs?.shift();
      if (key !== undefined) return output[key]();
    },
    outputStrings: phaserOutputStrings
  }, {
    id: 'E9S Wide-Angle Phaser Unlimited 3',
    type: 'StartsUsing',
    netRegex: {
      id: '560[DE]',
      source: 'Cloud Of Darkness',
      capture: false
    },
    delaySeconds: 12,
    alertText: (data, _matches, output) => {
      const key = data.phaserOutputs?.shift();
      if (key !== undefined) return output[key]();
    },
    outputStrings: phaserOutputStrings
  }, {
    id: 'E9S The Second Art Of Darkness Right',
    type: 'StartsUsing',
    netRegex: {
      id: '5601',
      source: 'Cloud Of Darkness',
      capture: false
    },
    // The fight goes Second Art -> Third Art -> Second Art, so we want
    // to have this cleaned up before the second Second Art Of Darkness
    preRun: data => delete data.finalArtOfDarkness,
    infoText: (_data, _matches, output) => output.text(),
    run: data => {
      data.artOfDarkness = [];
      if (!data.artOfDarknessIdMap) data.artOfDarknessExpected = 'right';
    },
    outputStrings: {
      text: {
        en: 'Start Left',
        de: 'Starte Links',
        fr: 'Commencez à gauche',
        ja: '左から',
        cn: '左侧开始',
        ko: '왼쪽에서 시작'
      }
    }
  }, {
    id: 'E9S The Second Art Of Darkness Left',
    type: 'StartsUsing',
    netRegex: {
      id: '5602',
      source: 'Cloud Of Darkness',
      capture: false
    },
    // The fight goes Second Art -> Third Art -> Second Art, so we want
    // to have this cleaned up before the second Second Art Of Darkness
    preRun: data => delete data.finalArtOfDarkness,
    infoText: (_data, _matches, output) => output.text(),
    run: data => {
      data.artOfDarkness = [];
      if (!data.artOfDarknessIdMap) data.artOfDarknessExpected = 'left';
    },
    outputStrings: {
      text: {
        en: 'Start Right',
        de: 'Starte Rechts',
        fr: 'Commencez à droite',
        ja: '右から',
        cn: '右侧开始',
        ko: '오른쪽에서 시작'
      }
    }
  }, {
    // The Art Of Darkness uses head markers with randomized offsets.  The first
    // charge is always left or right, and we can solve the rest from there.
    id: 'E9S The Second / Third Art Of Darkness Charge Solver',
    type: 'HeadMarker',
    netRegex: {
      target: 'Cloud Of Darkness'
    },
    condition: data => !data.artOfDarknessIdMap,
    run: (data, matches) => {
      data.artOfDarknessIdMap = {};
      let idPivot;
      if (data.artOfDarknessExpected === 'left') idPivot = parseInt(matches.id, 16);else if (data.artOfDarknessExpected === 'right') idPivot = parseInt(matches.id, 16) - 1;else throw new not_reached/* UnreachableCode */.$();
      delete data.artOfDarknessExpected;

      // The left swipe is the lowest head marker, and the rest are sequential.
      const artOfDarknessOutputKeys = ['goRight', 'goLeft', 'stackWithPartner', 'protean'];
      for (let i = 0; i < 4; ++i) {
        const hexPivot = (idPivot + i).toString(16).toUpperCase().padStart(4, '0');
        const outputKey = artOfDarknessOutputKeys[i];
        if (outputKey === undefined) throw new not_reached/* UnreachableCode */.$();
        data.artOfDarknessIdMap[hexPivot] = outputKey;
      }
    }
  }, {
    id: 'E9S The Second / Third Art Of Darkness Left / Right Charge',
    type: 'HeadMarker',
    netRegex: {
      target: 'Cloud Of Darkness'
    },
    condition: (data, matches) => {
      if (!data.artOfDarkness || !data.artOfDarknessIdMap) return false;
      const output = data.artOfDarknessIdMap[matches.id];
      return output === 'goRight' || output === 'goLeft';
    },
    run: (data, matches) => data.artOfDarkness?.push(data.artOfDarknessIdMap?.[matches.id] ?? 'unknown')
  }, {
    // Fire the trigger on stack or protean since we want the callout as soon as possible.
    id: 'E9S The Second / Third Art Of Darkness Callout',
    type: 'HeadMarker',
    netRegex: {
      target: 'Cloud Of Darkness'
    },
    condition: (data, matches) => {
      if (!data.artOfDarkness || !data.artOfDarknessIdMap) return false;
      const output = data.artOfDarknessIdMap[matches.id];
      return output === 'stackWithPartner' || output === 'protean';
    },
    preRun: (data, matches) => data.artOfDarkness?.push(data.artOfDarknessIdMap?.[matches.id] ?? 'unknown'),
    durationSeconds: data => data.finalArtOfDarkness ? 16 : 9,
    alertText: (data, _matches, output) => {
      // Perform the callout now, regardless if it's The Second or Third Art Of Darkness
      const callout = data.artOfDarkness?.slice();
      if (data.finalArtOfDarkness) callout?.push(data.finalArtOfDarkness);
      return callout?.map(key => output[key]()).join(' -> ');
    },
    run: data => delete data.artOfDarkness,
    outputStrings: artOfDarknessOutputStrings
  }, {
    id: 'E9S Empty Plane',
    type: 'StartsUsing',
    netRegex: {
      id: '55EF',
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe(),
    run: data => data.phase = 'empty'
  }, {
    id: 'E9S Flood Of Emptiness',
    type: 'StartsUsing',
    netRegex: {
      id: '55F0',
      source: 'Cloud Of Darkness',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tile Positions',
        de: 'Kachel Positionen',
        fr: 'Positions',
        ja: '定めたパネルに待機',
        cn: '上自己的方块',
        ko: '바닥 자리잡기'
      }
    }
  }, {
    id: 'E9S Curse Of Darkness',
    type: 'GainsEffect',
    netRegex: {
      effectId: '953'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 3,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Face Laser Out',
        de: 'Laser nach draußen richten',
        fr: 'Orientez le laser vers l\'extérieur',
        ja: 'レーザーを外に向ける',
        cn: '向外引导激光',
        ko: '바깥 바라보기 (레이저 유도)'
      }
    }
  }, {
    id: 'E9S Hypercharged Condensation',
    type: 'StartsUsing',
    netRegex: {
      id: '560C',
      source: 'Cloud Of Darkness',
      capture: false
    },
    delaySeconds: 2,
    durationSeconds: 5,
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'E9S The Art Of Darkness Right',
    type: 'StartsUsing',
    netRegex: {
      id: '5A95',
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 8,
    alertText: (data, _matches, output) => {
      if (!data.summon) return output.text();
    },
    infoText: (data, _matches, output) => {
      if (data.summon) return output.text();
    },
    outputStrings: {
      text: artOfDarknessOutputStrings.goLeft
    }
  }, {
    id: 'E9S The Art Of Darkness Left',
    type: 'StartsUsing',
    netRegex: {
      id: '5A96',
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 8,
    alertText: (data, _matches, output) => {
      if (!data.summon) return output.text();
    },
    infoText: (data, _matches, output) => {
      if (data.summon) return output.text();
    },
    outputStrings: {
      text: artOfDarknessOutputStrings.goRight
    }
  }, {
    id: 'E9S Full-Perimeter Particle Beam',
    type: 'StartsUsing',
    netRegex: {
      id: '5629',
      source: 'Cloud Of Darkness',
      capture: false
    },
    // Let Curse of Darkness trigger resolve first
    delaySeconds: 2,
    durationSeconds: 5,
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'E9S Deluge Of Darkness',
    type: 'StartsUsing',
    netRegex: {
      id: '55F1',
      source: 'Cloud Of Darkness',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.bigAoe */.n3.bigAoe('alert'),
    run: data => delete data.phase
  }, {
    id: 'E9S The Third Art Of Darkness Right',
    type: 'StartsUsing',
    netRegex: {
      id: '5603',
      source: 'Cloud Of Darkness',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    run: data => {
      data.artOfDarkness = [];
      // Add this once we've seen the second charge to call out sooner.
      data.finalArtOfDarkness = 'goRight';
    },
    outputStrings: {
      text: {
        en: 'Start Left',
        de: 'Starte Links',
        fr: 'Commencez à gauche',
        ja: '左から',
        cn: '左侧开始',
        ko: '왼쪽에서 시작'
      }
    }
  }, {
    id: 'E9S The Third Art Of Darkness Left',
    type: 'StartsUsing',
    netRegex: {
      id: '5604',
      source: 'Cloud Of Darkness',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    run: data => {
      data.artOfDarkness = [];
      // Add this once we've seen the second charge to call out sooner.
      data.finalArtOfDarkness = 'goLeft';
    },
    outputStrings: {
      text: {
        en: 'Start Right',
        de: 'Starte Rechts',
        fr: 'Commencez à droite',
        ja: '右から',
        cn: '右侧开始',
        ko: '오른쪽에서 시작'
      }
    }
  }, {
    id: 'E9S Particle Concentration',
    type: 'StartsUsing',
    netRegex: {
      id: '5620',
      source: 'Cloud Of Darkness',
      capture: false
    },
    delaySeconds: 6,
    durationSeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '기둥 들어가기'
      }
    }
  }, {
    id: 'E9S Summon',
    type: 'Ability',
    netRegex: {
      id: '5019',
      source: 'Cloud Of Darkness',
      capture: false
    },
    run: data => data.summon = true
  }, {
    id: 'E9S Clone The Art Of Darkness',
    type: 'StartsUsing',
    netRegex: {
      id: '561[EF]',
      source: 'Clone Of Darkness'
    },
    suppressSeconds: 1,
    promise: async data => {
      const cloudOfDarknessLocaleNames = {
        en: 'Cloud Of Darkness',
        de: 'Wolke Der Dunkelheit',
        fr: 'Nuage De Ténèbres',
        ja: '暗闇の雲',
        cn: '暗黑之云',
        ko: '어둠의 구름'
      };
      const bossData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        names: [cloudOfDarknessLocaleNames[data.parserLang]]
      });
      if (!bossData?.combatants.length) return;

      // All of the fake bosses have a BNpcID of 9020, 12379 is the real one.
      const boss = bossData.combatants.filter(boss => boss.BNpcID === 12379)[0];
      if (!boss) return;
      data.boss = convertBossHeadingToClonePosition(boss);
      const cloneOfDarknessLocaleNames = {
        en: 'Clone Of Darkness',
        de: 'Klon Der Dunkelheit',
        fr: 'Nuée de Ténèbres',
        ja: '幻影の雲',
        cn: '幻影之云',
        ko: '환영의 구름'
      };
      const cloneData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        names: [cloneOfDarknessLocaleNames[data.parserLang]]
      });
      if (!cloneData?.combatants.length) return;
      data.clones = cloneData.combatants;
    },
    alertText: (data, matches, output) => {
      if (!data.boss || !data.clones) return;
      const [clone1, clone2] = data.clones;
      if (!clone1 || !clone2) return;
      return output[calculateSummonSafeZone(data.boss, clone1, clone2, matches.id)]();
    },
    run: data => delete data.summon,
    outputStrings: summonDirectionOutputStrings
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'The Art Of Darkness(?! \\\\())': 'Art Of Dark (Clock/Stacks)'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Clone Of Darkness': 'Klon der Dunkelheit',
      'Cloud Of Darkness': 'Wolke der Dunkelheit'
    },
    'replaceText': {
      'The Third Art Of Darkness': 'Dunkle Taktik: Dreifach',
      'The Second Art Of Darkness': 'Dunkle Taktik: Doppelt',
      'The Art Of Darkness': 'Dunkle Taktik',
      'Summon': 'Rufen',
      'Rejuvenating Balm': 'Aktivierte Kugel',
      'Particle Concentration': 'Wellenkugel',
      'Obscure Woods': 'Finsterer Wald',
      'Hypercharged Condensation': 'Elektrisierte Kondensation',
      'Ground-Razing Particle Beam': 'Radialer Partikelstrahl',
      'Full-Perimeter Particle Beam': 'Partikelstrahl-Beschuss',
      'Flood Of Obscurity': 'Flut der Finsternis',
      'Flood Of Emptiness': 'Dunkle Flut: Düsterer Himmel',
      'Empty Plane': 'Düsterer Himmel',
      'Devouring Dark': 'Erosion der Dunkelheit',
      'Deluge Of Darkness': 'Sintflut der Dunkelheit',
      'Phaser Unlimited': 'Phaser: Nullform',
      '\\(P\\/S\\)': '(Uhrzeiger/Partner)'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Clone Of Darkness': 'Nuée de Ténèbres',
      'Cloud Of Darkness': 'Nuage de Ténèbres'
    },
    'replaceText': {
      '\\(L/R\\)': '(G/D)',
      'The Third Art Of Darkness': 'Arts ténébreux triple',
      'The Second Art Of Darkness': 'Arts ténébreux double',
      'The Art Of Darkness(?! \\\\())': 'Arts ténébreux (Positions/Packages)',
      'Summon': 'Invocation',
      'Rejuvenating Balm': 'Tir vivifiant',
      'Particle Concentration': 'Rayon sphérique',
      'Phaser Unlimited': 'Faisceau de particules bondissant',
      'Obscure Woods': 'Forêt obscure',
      'Hypercharged Condensation': 'Aspiration particulaire',
      'Ground-Razing Particle Beam': 'Faisceau de particules radiant',
      'Full-Perimeter Particle Beam': 'Faisceau de particules balayant',
      'Flood Of Obscurity': 'Déluge de Ténèbres : Forêt obscure',
      'Flood Of Emptiness': 'Déluge de Ténèbres : Cieux obscurs',
      'Empty Plane': 'Cieux obscurs',
      'Devouring Dark': 'Érosion de Ténèbres',
      'Deluge Of Darkness': 'Grand déluge de Ténèbres'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Clone Of Darkness': '幻影の雲',
      'Cloud Of Darkness': '暗闇の雲'
    },
    'replaceText': {
      'The Third Art Of Darkness': '闇の戦技：三重',
      'The Second Art Of Darkness': '闇の戦技：二重',
      'The Art Of Darkness': '闇の戦技',
      'Summon': '召喚',
      'Rejuvenating Balm': '活性弾',
      'Phaser Unlimited': '跳躍波動砲',
      'Particle Concentration': '波動球',
      'Obscure Woods': '暗黒森林',
      'Hypercharged Condensation': '波動雲吸引',
      'Ground-Razing Particle Beam': '放射式 波動砲',
      'Full-Perimeter Particle Beam': '掃射式 波動砲',
      'Flood Of Obscurity': '闇の氾濫：暗黒森林',
      'Flood Of Emptiness': '闇の氾濫：暗黒天空',
      'Empty Plane': '暗黒天空',
      'Devouring Dark': '闇の浸食',
      'Deluge Of Darkness': '闇の大氾濫',
      'Dark-Energy Particle Beam': '呪詛式 波動砲',
      'Condensed Wide-Angle Particle Beam': '広角式 高出力波動砲',
      'Condensed Anti-Air Particle Beam': '高射式 高出力波動砲',
      'Bad Vibrations': '強振動',
      'Anti-Air Phaser Unlimited': '高射式 跳躍波動砲：零式',
      'Anti-Air Particle Beam': '高射式 波動砲',
      'Aetherosynthesis': '生気吸収',
      '\\(L/R\\)': '(左/右)'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Clone Of Darkness': '幻影之云',
      'Cloud Of Darkness': '暗黑之云'
    },
    'replaceText': {
      'The Third Art Of Darkness': '三重暗之战技',
      'The Second Art Of Darkness': '二重暗之战技',
      'The Art Of Darkness': '暗之战技',
      'Summon': '召唤',
      'Rejuvenating Balm': '活性弹',
      'Phaser Unlimited': '跳跃波动炮',
      'Particle Concentration': '波动球',
      'Obscure Woods': '暗黑森林',
      'Hypercharged Condensation': '吸引波动云',
      'Ground-Razing Particle Beam': '放射式波动炮',
      'Full-Perimeter Particle Beam': '扫射式波动炮',
      'Flood Of Obscurity': '暗之泛滥：暗黑森林',
      'Flood Of Emptiness': '暗之泛滥：暗黑天空',
      'Empty Plane': '暗黑天空',
      'Devouring Dark': '暗黑侵蚀',
      'Deluge Of Darkness': '暗之大泛滥',
      'Dark-Energy Particle Beam': '诅咒式波动炮',
      'Condensed Wide-Angle Particle Beam': '广角式高输出波动炮',
      'Condensed Anti-Air Particle Beam': '高射式高输出波动炮',
      'Bad Vibrations': '强震动',
      'Anti-Air Phaser Unlimited': '零式高射式跳跃波动炮',
      'Anti-Air Particle Beam': '高射式波动炮',
      'Aetherosynthesis': '吸收生命',
      '\\(L/R\\)': '(左/右)'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Clone Of Darkness': '환영의 구름',
      'Cloud Of Darkness': '어둠의 구름'
    },
    'replaceText': {
      'The Third Art Of Darkness': '어둠의 전투술: 삼중',
      'The Second Art Of Darkness': '어둠의 전투술: 이중',
      'The Art Of Darkness': '어둠의 전투술',
      'Summon': '소환',
      'Rejuvenating Balm': '활성탄',
      'Phaser Unlimited': '도약파동포 0식',
      'Particle Concentration': '파동구',
      'Obscure Woods': '암흑의 숲',
      'Hypercharged Condensation': '파동운 흡인',
      'Ground-Razing Particle Beam': '방사식 파동포',
      'Full-Perimeter Particle Beam': '소사식 파동포',
      'Flood Of Obscurity': '어둠의 범람: 암흑의 숲',
      'Flood Of Emptiness': '어둠의 범람: 암흑의 하늘',
      'Empty Plane': '암흑의 하늘',
      'Devouring Dark': '어둠의 침식',
      'Deluge Of Darkness': '어둠의 대범람',
      'Dark-Energy Particle Beam': '저주식 파동포',
      'Condensed Wide-Angle Particle Beam': '광각식 고출력 파동포',
      'Condensed Anti-Air Particle Beam': '고공식 고출력 파동포',
      'Bad Vibrations': '강력한 진동',
      'Anti-Air Phaser Unlimited': '고공식 도약파동포 0식',
      'Anti-Air Particle Beam': '고공식 파동포',
      'Aetherosynthesis': '생기 흡수',
      '\\(L/R\\)': '(좌/우)'
    }
  }]
};
/* harmony default export */ const e9s = (e9s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/raid/e9s.txt
const raid_e9s_namespaceObject = "### Eden 9 (Savage)\r\n# Eden's Promise: Umbra (Savage)\r\n# -ii 5B19 5609 5627 560F 5619 5621 55FA 5A95 561E 5614 55FF 561B 5600 5B01 55FC 5606 55FF 55FD 5616 5615 5B00 5611 5610 510E 5B01 561C 5B07 560A 5624 5617 562B 5019 561D 560B\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n16.9 \"Ground-Razing Particle Beam\" Ability { id: \"5625\", source: \"Cloud Of Darkness\" } window 17,10\r\n27.1 \"The Art Of Darkness\" Ability { id: \"5B4[56]\", source: \"Cloud Of Darkness\" }\r\n36.8 \"The Art Of Darkness\" Ability { id: \"5B4[56]\", source: \"Cloud Of Darkness\" }\r\n47.5 \"Devouring Dark\" Ability { id: \"5623\", source: \"Cloud Of Darkness\" }\r\n\r\n## Woods\r\n63.1 \"Obscure Woods\" Ability { id: \"55EE\", source: \"Cloud Of Darkness\" }\r\n74.3 \"Flood Of Obscurity\" Ability { id: \"5907\", source: \"Cloud Of Darkness\" }\r\n81.8 \"Rejuvenating Balm\" Ability { id: \"5618\", source: \"Cloud Of Darkness\" }\r\n101.6 \"Phaser Unlimited 1\" Ability { id: \"56(1[23]|0[DE])\", source: \"Cloud Of Darkness\" } window 4,4\r\n103.7 \"--1--\" Ability { id: \"56(14|0F)\", source: \"Cloud Of Darkness\" }\r\n105.7 \"--2--\" Ability { id: \"561[05]\", source: \"Cloud Of Darkness\" }\r\n109.0 \"--3--\" Ability { id: \"5B0[01]\", source: \"Cloud Of Darkness\" }\r\n126.2 \"Ground-Razing Particle Beam\" Ability { id: \"5625\", source: \"Cloud Of Darkness\" }\r\n144.4 \"The Second Art Of Darkness\" Ability { id: \"560[12]\", source: \"Cloud Of Darkness\" }\r\n159.5 \"Phaser Unlimited 2\" Ability { id: \"56(1[23]|0[DE])\", source: \"Cloud Of Darkness\" } window 4,4\r\n161.6 \"--1--\" Ability { id: \"56(14|0F)\", source: \"Cloud Of Darkness\" }\r\n163.6 \"--2--\" Ability { id: \"561[05]\", source: \"Cloud Of Darkness\" }\r\n166.9 \"--3--\" Ability { id: \"5B0[01]\", source: \"Cloud Of Darkness\" }\r\n182.1 \"Devouring Dark\" Ability { id: \"5623\", source: \"Cloud Of Darkness\" }\r\n\r\n## Tiles\r\n197.7 \"Empty Plane\" Ability { id: \"55EF\", source: \"Cloud Of Darkness\" }\r\n208.9 \"Flood Of Emptiness\" Ability { id: \"55F0\", source: \"Cloud Of Darkness\" }\r\n216.0 \"Hypercharged Condensation\" Ability { id: \"560C\", source: \"Cloud Of Darkness\" }\r\n231.2 \"Full-Perimeter Particle Beam\" Ability { id: \"5629\", source: \"Cloud Of Darkness\" }\r\n248.5 \"The Art Of Darkness (L/R)\" Ability { id: \"5A9[56]\", source: \"Cloud Of Darkness\" }\r\n264.3 \"The Art Of Darkness\" Ability { id: \"55F[BE]\", source: \"Cloud Of Darkness\" }\r\n279.0 \"Deluge Of Darkness\" Ability { id: \"55F1\", source: \"Cloud Of Darkness\" }\r\n\r\n## Default\r\n285.9 \"Summon\" Ability { id: \"5019\", source: \"Cloud Of Darkness\" }\r\n301.2 \"The Art Of Darkness (L/R)\" Ability { id: \"5A9[56]\", source: \"Cloud Of Darkness\" }\r\n314.8 \"Devouring Dark\" Ability { id: \"5623\", source: \"Cloud Of Darkness\" }\r\n337.4 \"The Third Art Of Darkness\" Ability { id: \"560[34]\", source: \"Cloud Of Darkness\" }\r\n\r\n## Woods\r\n358.0 \"Obscure Woods\" Ability { id: \"55EE\", source: \"Cloud Of Darkness\" }\r\n369.2 \"Flood Of Obscurity\" Ability { id: \"5907\", source: \"Cloud Of Darkness\" }\r\n377.3 \"Particle Concentration\" Ability { id: \"5620\", source: \"Cloud Of Darkness\" }\r\n397.3 \"Phaser Unlimited 3\" Ability { id: \"56(1[23]|0[DE])\", source: \"Cloud Of Darkness\" } window 4,4\r\n399.4 \"--1--\" Ability { id: \"56(14|0F)\", source: \"Cloud Of Darkness\" }\r\n401.4 \"--2--\" Ability { id: \"561[05]\", source: \"Cloud Of Darkness\" }\r\n404.7 \"--3--\" Ability { id: \"5B0[01]\", source: \"Cloud Of Darkness\" }\r\n418.9 \"Ground-Razing Particle Beam\" Ability { id: \"5625\", source: \"Cloud Of Darkness\" }\r\n433.0 \"Rejuvenating Balm\" Ability { id: \"5618\", source: \"Cloud Of Darkness\" }\r\n444.6 \"The Second Art Of Darkness\" Ability { id: \"560[12]\", source: \"Cloud Of Darkness\" }\r\n461.3 \"Devouring Dark\" Ability { id: \"5623\", source: \"Cloud Of Darkness\" }\r\n\r\n## Tiles\r\n476.7 \"Empty Plane\" Ability { id: \"55EF\", source: \"Cloud Of Darkness\" }\r\n487.9 \"Flood Of Emptiness\" Ability { id: \"55F0\", source: \"Cloud Of Darkness\" }\r\n495.0 \"Hypercharged Condensation\" Ability { id: \"560C\", source: \"Cloud Of Darkness\" }\r\n510.2 \"Full-Perimeter Particle Beam\" Ability { id: \"5629\", source: \"Cloud Of Darkness\" }\r\n527.5 \"The Art Of Darkness (L/R)\" Ability { id: \"5A9[56]\", source: \"Cloud Of Darkness\" }\r\n543.3 \"The Art Of Darkness\" Ability { id: \"55F[BE]\", source: \"Cloud Of Darkness\" }\r\n564.2 \"The Art Of Darkness (L/R)\" Ability { id: \"5A9[56]\", source: \"Cloud Of Darkness\" }\r\n580.0 \"The Art Of Darkness\" Ability { id: \"55F[BE]\", source: \"Cloud Of Darkness\" }\r\n597.1 \"Enrage\" Ability { id: \"562A\", source: \"Cloud Of Darkness\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/diamond_weapon-ex.ts




// TODO: Auri Arts can now be done with MapEffect lines if somebody wanted.

// Due to changes introduced in patch 5.2, overhead markers now have a random offset
// added to their ID. This offset currently appears to be set per instance, so
// we can determine what it is from the first overhead marker we see.
// The first 1B markers in the encounter are flares, ID 0057.
// The lowest 1B marker in the encounter is LC #1, ID 004F.
// P2 buster is 00F3
// P3 Shrapnal tracking AoE is 00C5
const diamond_weapon_ex_firstHeadmarker = parseInt('0057', 16);
const diamond_weapon_ex_getHeadmarkerId = (data, matches) => {
  // If we naively just check !data.decOffset and leave it, it breaks if the first marker is 0057.
  // (This makes the offset 0, and !0 is true.)
  if (typeof data.decOffset === 'undefined') data.decOffset = parseInt(matches.id, 16) - diamond_weapon_ex_firstHeadmarker;
  // The leading zeroes are stripped when converting back to string, so we re-add them here.
  // Fortunately, we don't have to worry about whether or not this is robust,
  // since we know all the IDs that will be present in the encounter.
  return (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase().padStart(4, '0');
};
const diamond_weapon_ex_triggerSet = {
  id: 'TheCloudDeckExtreme',
  zoneId: zone_id/* default.TheCloudDeckExtreme */.Z.TheCloudDeckExtreme,
  timelineFile: 'diamond_weapon-ex.txt',
  triggers: [
  // Phase 1&3
  {
    id: 'DiamondEx Diamond Rain',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FA7',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe(),
    run: data => data.phase = data.phase ?? 1
  },
  // @TODO: There's probably a better callout for these mechanics, e.g.
  // `jump -> stay -> aoe`
  // `stay -> jump -> aoe`
  // `jump -> stack -> stay`
  // `stay -> stack -> jump`
  // `jump -> spread -> stay`
  // `stay -> spread -> jump`
  // but need to figure out what side player is on
  {
    id: 'DiamondEx Adamant Purge West Diamond Rain',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5F9B',
      capture: false
    },
    durationSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'go east -> aoe',
        de: 'Geh nach Osten -> AoE',
        fr: 'Allez à l\'est -> AoE',
        ja: '東へ -> AoE',
        cn: '去右边(东边) -> AoE',
        ko: '동쪽 -> 광역기'
      }
    }
  }, {
    id: 'DiamondEx Adamant Purge East Diamond Rain',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5F9A',
      capture: false
    },
    durationSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'go west -> aoe',
        de: 'Geh nach Westen -> AoE',
        fr: 'Allez à l\'ouest -> AoE',
        ja: '西へ -> AoE',
        cn: '去左边(西边) -> AoE',
        ko: '서쪽 -> 광역기'
      }
    }
  }, {
    id: 'DiamondEx Adamant Purge West Diamond Flash',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FA5',
      capture: false
    },
    durationSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'go east -> stack',
        de: 'Geh nach Osten -> Sammeln',
        fr: 'Allez à l\'est -> Packez-vous',
        ja: '東へ -> 頭割り',
        cn: '去右边(东边) -> 集合',
        ko: '동쪽 -> 쉐어'
      }
    }
  }, {
    id: 'DiamondEx Adamant Purge East Diamond Flash',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FA4',
      capture: false
    },
    durationSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'go west -> stack',
        de: 'Geh nach Westen -> Sammeln',
        fr: 'Allez à l\'ouest -> Packez-vous',
        ja: '西へ -> 頭割り',
        cn: '去左边(西边) -> 集合',
        ko: '서쪽  -> 쉐어'
      }
    }
  }, {
    id: 'DiamondEx Adamant Purge West Homing Laser',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FA3',
      capture: false
    },
    durationSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'go east -> spread',
        de: 'Geh nach Osten -> Verteilen',
        fr: 'Allez à l\'est -> Dispersez-vous',
        ja: '東へ -> 散開',
        cn: '去右边(东边) -> 分散',
        ko: '동쪽 -> 산개'
      }
    }
  }, {
    id: 'DiamondEx Adamant Purge East Homing Laser',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FA2',
      capture: false
    },
    durationSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'go west -> spread',
        de: 'Geh nach Westen -> Verteilen',
        fr: 'Allez à l\'ouest -> Dispersez-vous',
        ja: '西へ -> 散開',
        cn: '去左边(西边) -> 分散',
        ko: '서쪽 -> 산개'
      }
    }
  },
  // @TODO: Make this a collector with with flare/away from flare
  {
    id: 'DiamondEx Photon Burst',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FA8',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Flare',
        de: 'Flare',
        fr: 'Brasier',
        ja: 'フレア',
        cn: '核爆',
        ko: '플레어'
      }
    }
  },
  // @TODO: Phase transition tethers and KB
  {
    id: 'DiamondEx Code Chi-Xi-Stigma',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FAD',
      capture: false
    },
    run: data => data.phase = 2
  },
  // Phase 2
  {
    id: 'DiamondEx Outrage',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FBC',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'DiamondEx Auri Doomstead',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FBD'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  },
  // @TODO: Get boss facing and bits position, call out adjust?
  {
    id: 'DiamondEx P2 Zig-Zag',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FAF',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge Zig-Zag',
        de: 'Zig-Zag ausweichen',
        fr: 'Esquivez le Zig-Zag',
        ja: 'ジグザグに避ける',
        cn: '躲避Z字型突进',
        ko: '지그재그 피하기'
      }
    }
  },
  // @TODO: Get boss facing and orb position, call out safe side?
  {
    id: 'DiamondEx P2 Zig-Zag Jump',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FB2',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge East/West',
        de: 'Orb vom Osten/Westen ausweichen',
        fr: 'Esquivez Est/Ouest',
        ja: '東/西へ',
        cn: '左右(东西)躲避',
        ko: '동/서쪽 피하기'
      }
    }
  },
  // @TODO: Get boss facing and orb count, call out towards/away?
  {
    id: 'DiamondEx P2 North/South Jump',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FB5',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge Towards/Away',
        de: 'Hin oder weg ausweichen',
        fr: 'Rapprochez-vous/Éloignez-vous',
        ja: '前/後ろへ',
        cn: '前后躲避',
        ko: '가까이/멀리 이동하기'
      }
    }
  },
  // @TODO: Get bit locations, call out north/south diagonal KB?
  {
    id: 'DiamondEx P2 Vertical Cleave',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FB7',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Diagonal Knockback',
        de: 'Diagonaler Rückstoß',
        fr: 'Poussée en diagonale',
        ja: '斜めにノックバック',
        cn: '对角击退',
        ko: '대각으로 넉백'
      }
    }
  }, {
    id: 'DiamondEx P2 Articulated Bits',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FC1',
      capture: false
    },
    durationSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge Bits',
        de: 'Satelliten ausweichen',
        fr: 'Esquivez les bras',
        ja: 'ビームを避ける',
        cn: '躲避浮游炮激光',
        ko: '비트 피하기'
      }
    }
  }, {
    id: 'DiamondEx Headmarker',
    type: 'HeadMarker',
    netRegex: {},
    durationSeconds: 25,
    infoText: (data, matches, output) => {
      // Always get the headmarker ID, so that decOffset can be defined properly
      const idHex = diamond_weapon_ex_getHeadmarkerId(data, matches);
      if (matches.target !== data.me) return;
      const id = parseInt(idHex, 16);
      const firstLCMarker = parseInt('004F', 16);
      const lastLCMarker = parseInt('0056', 16);
      if (id >= firstLCMarker && id <= lastLCMarker) {
        const decOffset = id - firstLCMarker;
        return output[decOffset + 1]();
      }
    },
    outputStrings: {
      1: outputs/* default.num1 */.Z.num1,
      2: outputs/* default.num2 */.Z.num2,
      3: outputs/* default.num3 */.Z.num3,
      4: outputs/* default.num4 */.Z.num4,
      5: outputs/* default.num5 */.Z.num5,
      6: outputs/* default.num6 */.Z.num6,
      7: outputs/* default.num7 */.Z.num7,
      8: outputs/* default.num8 */.Z.num8
    }
  },
  // Phase 3
  {
    id: 'DiamondEx P3 Articulated Bits',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FA9',
      capture: false
    },
    durationSeconds: 20,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge Bits',
        de: 'Satelliten ausweichen',
        fr: 'Esquivez les bras',
        ja: 'ビームを避ける',
        cn: '躲避浮游炮激光',
        ko: '비트 피하기'
      }
    }
  }, {
    id: 'DiamondEx Diamond Shrapnel',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FAC',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Puddles',
        de: 'Flächen ködern',
        fr: 'Placez les zones au sol',
        ja: 'AoEを誘導',
        cn: '诱导AoE',
        ko: '장판 피하기'
      }
    }
  }, {
    id: 'DiamondEx Burst',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FAC',
      capture: false
    },
    delaySeconds: 15,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Towers',
        de: 'Türme',
        fr: 'Tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 들어가기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Articulated Bit': 'Satellitenarm',
      'The Diamond Weapon': 'Diamant-Waffe'
    },
    'replaceText': {
      '\\(Jump\\)': '(Sprung)',
      'Adamant Purge': 'Diamantpanzer',
      'Aetherial Bullet': 'Ätherreigen',
      'Articulated Bits': 'Satellitenarme',
      'Auri Arts': 'Aurische Kunst',
      'Auri Cyclone': 'Aurischer Zyklon',
      'Auri Doomstead': 'Aurisches Verderben',
      '(?<!Photon )Burst': 'Einschlag',
      'Claw Swipe': 'Klauensturm',
      'Code Chi-Xi-Stigma': 'Code 666',
      'Diamond Flash': 'Diamantblitz',
      'Diamond Rain': 'Dominanz der Diamanten',
      'Diamond Shot': 'Diamantschuss',
      'Diamond Shrapnel': 'Diamantschub',
      'Flood Ray': 'Flutstrahl',
      'Homing Laser': 'Leitlaser',
      'Outrage': 'Diamantwut',
      'Photon Burst': 'Photonenknall',
      'Vertical Cleave': 'Vertikalspalter'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Articulated Bit': 'bras autonome',
      'The Diamond Weapon': 'Arme Diamant'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(Jump\\)': '(Saut)',
      'Adamant Purge': 'Armure adaptative',
      'Aetherial Bullet': 'Rayon éthéré',
      'Articulated Bits': 'Bras autonome',
      'Auri Arts': 'Art martial aoran',
      'Auri Cyclone': 'Tornade aoranne',
      'Auri Doomstead': 'Calamité aoranne',
      '(?<!Photon )Burst': 'Explosion',
      'Claw Swipe': 'Ruée de griffes',
      'Code Chi-Xi-Stigma': 'Code Chi-Xi-Stigma',
      'Diamond Flash': 'Éclair de diamant',
      'Diamond Rain': 'Bombardement adamantin',
      'Diamond Shot': 'Tir diamantaire',
      'Diamond Shrapnel': 'Salve adamantine',
      'Flood Ray': 'Déluge de rayons',
      'Homing Laser': 'Laser auto-guidé',
      'Outrage': 'Indignation',
      'Photon Burst': 'Salve photonique',
      'Vertical Cleave': 'Fente verticale'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Articulated Bit': 'アームビット',
      'The Diamond Weapon': 'ダイヤウェポン'
    },
    'replaceText': {
      'Adamant Purge': '装甲展開',
      'Aetherial Bullet': 'エーテルバレット',
      'Articulated Bits': 'アームビット',
      'Auri Arts': 'アウリアーツ',
      'Auri Cyclone': 'アウリサイクロン',
      'Auri Doomstead': 'アウリドゥーム',
      '(?<!Photon )Burst': '大爆発',
      'Claw Swipe': 'クロースラッシュ',
      'Code Chi-Xi-Stigma': 'コード666',
      'Diamond Flash': 'ダイヤフラッシュ',
      'Diamond Rain': 'ダイヤレイン',
      'Diamond Shot': 'ダイヤショット',
      'Diamond Shrapnel': 'ダイヤバースト',
      'Flood Ray': 'フラッドレイ',
      'Homing Laser': 'ホーミングレーザー',
      'Outrage': 'アウトレイジ',
      'Photon Burst': 'フォトンバースト',
      'Vertical Cleave': 'バーチカルクリーヴ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Articulated Bit': '飞手浮游炮',
      'The Diamond Weapon': '钻石神兵'
    },
    'replaceText': {
      '\\(Jump\\)': '(跳)',
      '\\(Cleave\\)': '(冲锋)',
      'Adamant Purge': '装甲展开',
      'Aetherial Bullet': '以太炮',
      'Articulated Bits': '飞手浮游炮',
      'Auri Arts': '敖龙技巧',
      'Auri Cyclone': '敖龙旋风',
      'Auri Doomstead': '敖龙厄运',
      '(?<!Photon )Burst': '大爆炸',
      'Claw Swipe': '利爪突进',
      'Code Chi-Xi-Stigma': '代号666',
      'Diamond Flash': '钻石闪光',
      'Diamond Rain': '钻石雨',
      'Diamond Shot': '钻石射击',
      'Diamond Shrapnel': '钻石爆发',
      'Flood Ray': '泛光射线',
      'Homing Laser': '自控导弹',
      'Outrage': '震怒',
      'Photon Burst': '光子爆发',
      'Vertical Cleave': '纵劈'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Articulated Bit': '암 비트',
      'The Diamond Weapon': '다이아몬드 웨폰'
    },
    'replaceText': {
      '\\(Jump\\)': '(점프)',
      '\\(Cleave\\)': '(광역 탱버)',
      'Adamant Purge': '장갑 전개',
      'Aetherial Bullet': '에테르 탄환',
      'Articulated Bits': '암 비트',
      'Auri Arts': '아우라의 무예',
      'Auri Cyclone': '아우라의 선풍',
      'Auri Doomstead': '아우라의 파멸',
      '(?<!Photon )Burst': '대폭발',
      'Claw Swipe': '발톱 휘두르기',
      'Code Chi-Xi-Stigma': '코드 666',
      'Diamond Flash': '다이아몬드 섬광',
      'Diamond Rain': '다이아몬드 비',
      'Diamond Shot': '다이아몬드 발사',
      'Diamond Shrapnel': '다이아몬드 유산탄',
      'Flood Ray': '침수광',
      'Homing Laser': '추적 레이저',
      'Outrage': '격노',
      'Photon Burst': '광자 폭발',
      'Vertical Cleave': '수직 쪼개기'
    }
  }]
};
/* harmony default export */ const diamond_weapon_ex = (diamond_weapon_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/diamond_weapon-ex.txt
const trial_diamond_weapon_ex_namespaceObject = "### Diamond Weapon Ex\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# -it \"The Diamond Weapon\"\r\n# -ii 5FEB 5FBE 5FAA 5FEC 5FBA 5FFD 5FBB 6055 6159 5FF9 5FCD 5FFA 5FF9 612E 5FB3 5FCE 5FD2 5FFE 5FD3 5FB4 5FB6 5FB1 5FB0 5FBF 5FAE 5FA6 5FC3 5FC9 5FCA 5FC4\r\n# -p 5FA7:21.3\r\n\r\n### Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n16.3 \"--sync--\" StartsUsing { id: \"5FA7\", source: \"The Diamond Weapon\" } window 17,10\r\n21.3 \"Diamond Rain\" Ability { id: \"5FA7\", source: \"The Diamond Weapon\" } window 25,10\r\n\r\n# 5FA2 = Spread (Homing Laser, 5FA0)\r\n# 5F9B = \"nothing\" (Diamond Rain, 5FA7)\r\n# 5FA5 = Stack (Diamond Flash, 5FA1)\r\n36.5 \"Adamant Purge\" Ability { id: \"5FA[2345]\", source: \"The Diamond Weapon\" } window 20,5\r\n46.7 \"Claw Swipe\" Ability { id: \"5F9[EF]\", source: \"The Diamond Weapon\" }\r\n49.9 \"Homing Laser/Diamond Flash\" Ability { id: \"5FA[01]\", source: \"The Diamond Weapon\" }\r\n67.1 \"Photon Burst\" Ability { id: \"5FA8\", source: \"The Diamond Weapon\" }\r\n83.4 \"Adamant Purge\" Ability { id: \"5F9[8AB]\", source: \"The Diamond Weapon\" }\r\n93.6 \"Claw Swipe\" Ability { id: \"5F9[EF]\", source: \"The Diamond Weapon\" }\r\n104.8 \"Diamond Rain\" Ability { id: \"5FA7\", source: \"The Diamond Weapon\" }\r\n120.0 \"Adamant Purge\" Ability { id: \"5FA[2345]\", source: \"The Diamond Weapon\" }\r\n130.2 \"Claw Swipe\" Ability { id: \"5F9[EF]\", source: \"The Diamond Weapon\" }\r\n133.7 \"Homing Laser/Diamond Flash\" Ability { id: \"5FA[01]\", source: \"The Diamond Weapon\" }\r\n151.4 \"Photon Burst\" Ability { id: \"5FA8\", source: \"The Diamond Weapon\" }\r\n\r\n# Phase transition\r\n167.7 \"Code Chi-Xi-Stigma\" Ability { id: \"5FAD\", source: \"The Diamond Weapon\" }\r\n168.0 \"--untargetable--\"\r\n183.3 \"Auri Cyclone\" Ability { id: \"5FB9\", source: \"The Diamond Weapon\" }\r\n188.0 \"Diamond Shot\" Ability { id: \"5FC0\", source: \"Articulated Bit\" }\r\n\r\n### Phase 2\r\n197.8 \"--targetable--\"\r\n210.0 \"Outrage\" Ability { id: \"5FBC\", source: \"The Diamond Weapon\" }\r\n218.2 \"Outrage\" Ability { id: \"5FBC\", source: \"The Diamond Weapon\" }\r\n229.6 \"Auri Arts (Z)\" Ability { id: [\"5FAF\", \"5FF8\"], source: \"The Diamond Weapon\" }\r\n229.6 \"--untargetable--\"\r\n236.4 \"Auri Arts (Jump)\" Ability { id: \"5FB2\", source: \"The Diamond Weapon\" }\r\n241.0 \"--targetable--\"\r\n250.4 \"Outrage\" Ability { id: \"5FBC\", source: \"The Diamond Weapon\" }\r\n257.6 \"Auri Doomstead\" Ability { id: \"5FBD\", source: \"The Diamond Weapon\" }\r\n265.5 \"--untargetable--\"\r\n271.8 \"Auri Arts (Cleave)?\" Ability { id: \"5FB5\", source: \"The Diamond Weapon\" }\r\n272.8 \"Auri Arts (Jump)\" Ability { id: \"5FCF\", source: \"The Diamond Weapon\" }\r\n272.8 \"--targetable--\"\r\n278.7 \"Vertical Cleave\" Ability { id: \"5FD0\", source: \"The Diamond Weapon\" }\r\n291.1 \"Outrage\" Ability { id: \"5FBC\", source: \"The Diamond Weapon\" }\r\n301.3 \"Articulated Bits\" Ability { id: \"5FC1\", source: \"The Diamond Weapon\" }\r\n312.4 \"Aetherial Bullet\" Ability { id: \"5FAB\", source: \"Articulated Bit\" }\r\n312.9 \"Auri Arts (Z)\" Ability { id: [\"5FAF\", \"5FF8\"], source: \"The Diamond Weapon\" }\r\n312.9 \"--untargetable--\"\r\n319.7 \"Auri Arts (Jump)\" Ability { id: \"5FB2\", source: \"The Diamond Weapon\" }\r\n320.4 \"Aetherial Bullet\" Ability { id: \"5FAB\", source: \"Articulated Bit\" }\r\n324.2 \"--targetable--\"\r\n333.7 \"Outrage\" Ability { id: \"5FBC\", source: \"The Diamond Weapon\" }\r\n340.9 \"Auri Doomstead\" Ability { id: \"5FBD\", source: \"The Diamond Weapon\" }\r\n353.1 \"Articulated Bits\" Ability { id: \"5FC1\", source: \"The Diamond Weapon\" }\r\n355.7 \"--untargetable--\"\r\n360.7 \"Aetherial Bullet\" Ability { id: \"5FAB\", source: \"Articulated Bit\" }\r\n362.2 \"Auri Arts (Cleave)?\" Ability { id: \"5FB5\", source: \"The Diamond Weapon\" }\r\n364.0 \"--targetable--\"\r\n364.0 \"Auri Arts (Jump)\" Ability { id: \"5FCF\", source: \"The Diamond Weapon\" }\r\n369.9 \"Vertical Cleave\" Ability { id: \"5FD0\", source: \"The Diamond Weapon\" }\r\n370.7 \"Aetherial Bullet\" Ability { id: \"5FAB\", source: \"Articulated Bit\" }\r\n382.4 \"Outrage\" Ability { id: \"5FBC\", source: \"The Diamond Weapon\" }\r\n388.0 \"--untargetable--\"\r\n\r\n### Phase 3\r\n397.9 \"--targetable--\"\r\n422.1 \"--sync--\" Ability { id: \"5FA6\", source: \"The Diamond Weapon\" }\r\n422.7 \"Flood Ray 1\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n424.2 \"Flood Ray 2\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n425.7 \"Flood Ray 3\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n427.2 \"Flood Ray 4\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n428.7 \"Flood Ray 5\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n430.2 \"Flood Ray 6\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n431.7 \"Flood Ray 7\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n433.2 \"Flood Ray 8\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n450.7 \"Photon Burst\" Ability { id: \"5FA8\", source: \"The Diamond Weapon\" }\r\n470.0 \"Articulated Bits\" Ability { id: \"5FA9\", source: \"The Diamond Weapon\" }\r\n477.1 \"Adamant Purge\" Ability { id: \"5FA[2345]\", source: \"The Diamond Weapon\" }\r\n481.6 \"Aetherial Bullet\" Ability { id: \"5FAB\", source: \"Articulated Bit\" }\r\n486.2 \"Claw Swipe\" Ability { id: \"5F9[EF]\", source: \"The Diamond Weapon\" }\r\n489.7 \"Homing Laser/Diamond Flash\" Ability { id: \"5FA[01]\", source: \"The Diamond Weapon\" }\r\n490.6 \"Aetherial Bullet\" Ability { id: \"5FAB\", source: \"Articulated Bit\" }\r\n501.3 \"Diamond Rain\" Ability { id: \"5FA7\", source: \"The Diamond Weapon\" }\r\n516.5 \"Articulated Bits\" Ability { id: \"5FA9\", source: \"The Diamond Weapon\" }\r\n523.6 \"Diamond Shrapnel\" Ability { id: \"5FAC\", source: \"The Diamond Weapon\" }\r\n528.1 \"Aetherial Bullet\" Ability { id: \"5FAB\", source: \"Articulated Bit\" }\r\n537.1 \"Aetherial Bullet\" Ability { id: \"5FAB\", source: \"Articulated Bit\" }\r\n541.5 \"Burst\" Ability { id: \"5FC[56]\", source: \"The Diamond Weapon\" }\r\n546.8 \"Photon Burst\" Ability { id: \"5FA8\", source: \"The Diamond Weapon\" }\r\n566.1 \"Articulated Bits\" Ability { id: \"5FA9\", source: \"The Diamond Weapon\" }\r\n# This Purge seems to be able to be at least 5FA3, 5FA4, 5FA5, so including every possiblility\r\n573.2 \"Adamant Purge\" Ability { id: \"5F(9[ABCD]|A[2345])\", source: \"The Diamond Weapon\" }\r\n577.7 \"Aetherial Bullet\" Ability { id: \"5FAB\", source: \"Articulated Bit\" }\r\n583.4 \"Claw Swipe\" Ability { id: \"5F9[EF]\", source: \"The Diamond Weapon\" }\r\n586.8 \"Aetherial Bullet\" Ability { id: \"5FAB\", source: \"Articulated Bit\" }\r\n597.8 \"Diamond Rain\" Ability { id: \"5FA7\", source: \"The Diamond Weapon\" }\r\n621.0 \"--sync--\" Ability { id: \"5FA6\", source: \"The Diamond Weapon\" }\r\n621.1 \"Flood Ray 1\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n622.6 \"Flood Ray 2\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n624.1 \"Flood Ray 3\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n625.6 \"Flood Ray 4\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n627.1 \"Flood Ray 5\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n628.6 \"Flood Ray 6\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n630.1 \"Flood Ray 7\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n631.6 \"Flood Ray 8\" #Ability { id: \"5FC7\", source: \"The Diamond Weapon\" }\r\n649.2 \"Photon Burst\" Ability { id: \"5FA8\", source: \"The Diamond Weapon\" }\r\n668.5 \"Articulated Bits\" Ability { id: \"5FA9\", source: \"The Diamond Weapon\" }\r\n675.6 \"Adamant Purge\" Ability { id: \"5FA[2345]\", source: \"The Diamond Weapon\" }\r\n680.1 \"Aetherial Bullet\" Ability { id: \"5FAB\", source: \"Articulated Bit\" }\r\n685.8 \"Claw Swipe\" Ability { id: \"5F9[EF]\", source: \"The Diamond Weapon\" }\r\n689.0 \"Homing Laser/Diamond Flash\" Ability { id: \"5FA[01]\", source: \"The Diamond Weapon\" }\r\n689.2 \"Aetherial Bullet\" Ability { id: \"5FAB\", source: \"Articulated Bit\" }\r\n700.2 \"Diamond Rain\" Ability { id: \"5FA7\", source: \"The Diamond Weapon\" }\r\n\r\n# Enrage\r\n718.6 \"Flood Ray (Enrage)\" Ability { id: \"5FEE\", source: \"The Diamond Weapon\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/diamond_weapon.ts



const sharedOutputStrings = {
  teleportEast: {
    en: 'Teleport to east platform',
    de: 'Teleport zur östlichen plattform',
    fr: 'Téléportez-vous vers la plateforme est',
    ja: '東の足場へテレポ',
    cn: '传送到右边(东边)平台',
    ko: '동쪽으로 이동'
  },
  teleportWest: {
    en: 'Teleport to west platform',
    de: 'Teleport zur westlichen plattform',
    fr: 'Téléportez-vous vers la plateforme ouest',
    ja: '西の足場へテレポ',
    cn: '传送到左边(西边)平台',
    ko: '서쪽으로 이동'
  }
};
const diamond_weapon_triggerSet = {
  id: 'TheCloudDeck',
  zoneId: zone_id/* default.TheCloudDeck */.Z.TheCloudDeck,
  timelineFile: 'diamond_weapon.txt',
  triggers: [{
    id: 'Diamond Diamond Rain',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FA7',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Diamond Claw Swipe East',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5F9A',
      capture: false
    },
    durationSeconds: 10,
    alertText: (_data, _matches, output) => output.teleportWest(),
    outputStrings: sharedOutputStrings
  }, {
    id: 'Diamond Claw Swipe West',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5F9B',
      capture: false
    },
    durationSeconds: 10,
    alertText: (_data, _matches, output) => output.teleportEast(),
    outputStrings: sharedOutputStrings
  }, {
    id: 'Diamond Photon Burst',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Flare on YOU',
        de: 'Flare auf DIR',
        fr: 'Brasier sur VOUS',
        ja: '自分にフレア',
        cn: '核爆点名',
        ko: '플레어 대상자'
      }
    }
  }, {
    // There is no head marker for this mechanic, instead Unknown_5779 creates the indicator
    id: 'Diamond Diamond Flash',
    type: 'Ability',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5779'
    },
    durationSeconds: 5,
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Diamond Auri Cyclone',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FE6',
      capture: false
    },
    delaySeconds: 0.5,
    durationSeconds: 6,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Diamond Outrage',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FD7',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Diamond Auri Doomstead',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FD8'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Diamond Vertical Cleave',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FE5',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Diamond Diamond Shrapnel',
    type: 'HeadMarker',
    netRegex: {
      id: '00C5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Diamond Shrapnel on YOU',
        de: 'Diamantschub auf DIR',
        fr: 'Salve adamantine sur VOUS',
        ja: '自分にダイヤバースト',
        cn: '钻石爆发点名',
        ko: '장판 대상자'
      }
    }
  }, {
    id: 'Diamond Articulated Bits',
    type: 'Ability',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5FA9',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Bits',
        de: 'Weiche den Satelliten aus',
        fr: 'Évitez les bras',
        ja: 'ビームを避ける',
        cn: '躲避浮游炮激光',
        ko: '비트 피하기'
      }
    }
  }, {
    id: 'Diamond Adamant Sphere',
    type: 'Ability',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '6144',
      capture: false
    },
    durationSeconds: 8,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 하나씩 들어가기'
      }
    }
  }, {
    // Diamond Weapon starts using this Adamant Purge ~10 seconds before the head markers
    id: 'Diamond Homing Laser',
    type: 'Ability',
    netRegex: {
      source: 'The Diamond Weapon',
      id: '5F9C',
      capture: false
    },
    delaySeconds: 3,
    durationSeconds: 7,
    response: responses/* Responses.spread */.n3.spread()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Articulated Bit': 'Satellitenarm',
      'The Diamond Weapon': 'Diamant-Waffe'
    },
    'replaceText': {
      '\\(Jump\\)': '(Sprung)',
      'Adamant Purge': 'Diamantpanzer',
      'Adamant Sphere': 'Diamantsphäre',
      'Aetherial Bullet': 'Ätherreigen',
      'Airship\'s Bane': 'Luftschiffschmerz',
      'Articulated Bits': 'Satellitenarme',
      'Auri Arts': 'Aurische Kunst',
      'Auri Cyclone': 'Aurischer Zyklon',
      'Auri Doomstead': 'Aurisches Verderben',
      '(?<!Photon )Burst': 'Explosion',
      'Claw Swipe': 'Klauensturm',
      'Code Chi-Xi-Stigma': 'Code 666',
      'Diamond Flash': 'Diamantblitz',
      'Diamond Rain': 'Dominanz der Diamanten',
      'Diamond Shrapnel': 'Diamantschub',
      'Homing Laser': 'Leitlaser',
      'Outrage': 'Diamantwut',
      'Photon Burst': 'Photonenknall',
      'Vertical Cleave': 'Vertikalspalter'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Articulated Bit': 'bras autonome',
      'The Diamond Weapon': 'Arme Diamant'
    },
    'replaceText': {
      '\\(Jump\\)': '(Saut)',
      'Adamant Purge': 'Armure adaptative',
      'Adamant Sphere': 'Sphère de diamant',
      'Aetherial Bullet': 'Rayon éthéré',
      'Airship\'s Bane': 'Fléau aérien',
      'Articulated Bits': 'Bras autonome',
      'Auri Arts': 'Art martial aoran',
      'Auri Cyclone': 'Tornade aoranne',
      'Auri Doomstead': 'Calamité aoranne',
      '(?<!Photon )Burst': 'Explosion',
      'Claw Swipe': 'Ruée de griffes',
      'Code Chi-Xi-Stigma': 'Code Chi-Xi-Stigma',
      'Diamond Flash': 'Éclair de diamant',
      'Diamond Rain': 'Bombardement adamantin',
      'Diamond Shrapnel': 'Salve adamantine',
      'Homing Laser': 'Laser auto-guidé',
      'Outrage': 'Indignation',
      'Photon Burst': 'Salve photonique',
      'Vertical Cleave': 'Fente verticale'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Articulated Bit': 'アームビット',
      'The Diamond Weapon': 'ダイヤウェポン'
    },
    'replaceText': {
      'Adamant Purge': '装甲展開',
      'Adamant Sphere': 'ダイヤスフィア',
      'Aetherial Bullet': 'エーテルバレット',
      'Airship\'s Bane': 'エアシップベイン',
      'Articulated Bits': 'アームビット',
      'Auri Arts': 'アウリアーツ',
      'Auri Cyclone': 'アウリサイクロン',
      'Auri Doomstead': 'アウリドゥーム',
      '(?<!Photon )Burst': '爆発',
      'Claw Swipe': 'クロースラッシュ',
      'Code Chi-Xi-Stigma': 'コード666',
      'Diamond Flash': 'ダイヤフラッシュ',
      'Diamond Rain': 'ダイヤレイン',
      'Diamond Shrapnel': 'ダイヤバースト',
      'Homing Laser': 'ホーミングレーザー',
      'Outrage': 'アウトレイジ',
      'Photon Burst': 'フォトンバースト',
      'Vertical Cleave': 'バーチカルクリーヴ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Articulated Bit': '飞手浮游炮',
      'The Diamond Weapon': '钻石神兵'
    },
    'replaceText': {
      '\\(Jump\\)': '(跳)',
      '\\(Cleave\\)': '(冲锋)',
      'Adamant Purge': '装甲展开',
      'Adamant Sphere': '钻石球',
      'Aetherial Bullet': '以太炮',
      'Airship\'s Bane': '坠机',
      'Articulated Bits': '飞手浮游炮',
      'Auri Arts': '敖龙技巧',
      'Auri Cyclone': '敖龙旋风',
      'Auri Doomstead': '敖龙厄运',
      '(?<!Photon )Burst': '爆炸',
      'Claw Swipe': '利爪突进',
      'Code Chi-Xi-Stigma': '代号666',
      'Diamond Flash': '钻石闪光',
      'Diamond Rain': '钻石雨',
      'Diamond Shrapnel': '钻石爆发',
      'Homing Laser': '自控导弹',
      'Outrage': '震怒',
      'Photon Burst': '光子爆发',
      'Vertical Cleave': '纵劈'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Articulated Bit': '암 비트',
      'The Diamond Weapon': '다이아몬드 웨폰'
    },
    'replaceText': {
      '\\(Jump\\)': '(점프)',
      '\\(Cleave\\)': '(광역 탱버)',
      'Adamant Purge': '장갑 전개',
      'Adamant Sphere': '다이아몬드 구체',
      'Aetherial Bullet': '에테르 탄환',
      'Airship\'s Bane': '비공정 격파',
      'Articulated Bits': '암 비트',
      'Auri Arts': '아우라의 무예',
      'Auri Cyclone': '아우라의 선풍',
      'Auri Doomstead': '아우라의 파멸',
      '(?<!Photon )Burst': '대폭발',
      'Claw Swipe': '발톱 휘두르기',
      'Code Chi-Xi-Stigma': '코드 666',
      'Diamond Flash': '다이아몬드 섬광',
      'Diamond Rain': '다이아몬드 비',
      'Diamond Shrapnel': '다이아몬드 유산탄',
      'Homing Laser': '추적 레이저',
      'Outrage': '격노',
      'Photon Burst': '광자 폭발',
      'Vertical Cleave': '수직 쪼개기'
    }
  }]
};
/* harmony default export */ const diamond_weapon = (diamond_weapon_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/diamond_weapon.txt
const trial_diamond_weapon_namespaceObject = "### Diamond Weapon\r\n# -p 5FA7:11\r\n# -ii 5FDF 5FD9 5FDA 5FE8 5FBA 5FB8 615A 5FFA 5FE3 5FF9 612F 5FB3 5FB2 5FB4 5FB0 5FB6 5FE0 5FE1 5FE2 5FEC 5FAA 5FFD 5779 5FDB\r\n# -it \"The Diamond Weapon\"\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n6.0 \"--sync--\" StartsUsing { id: \"5FA7\", source: \"The Diamond Weapon\" } window 10,10\r\n11.0 \"Diamond Rain\" Ability { id: \"5FA7\", source: \"The Diamond Weapon\" }\r\n40.3 \"Adamant Purge\" Ability { id: \"5F9B\", source: \"The Diamond Weapon\" }\r\n50.5 \"Claw Swipe\" Ability { id: \"5F9F\", source: \"The Diamond Weapon\" }\r\n63.7 \"Adamant Purge\" Ability { id: \"5F9A\", source: \"The Diamond Weapon\" }\r\n73.9 \"Claw Swipe\" Ability { id: \"5F9E\", source: \"The Diamond Weapon\" }\r\n91.2 \"Diamond Rain\" Ability { id: \"5FA7\", source: \"The Diamond Weapon\" }\r\n102.4 \"Photon Burst\" Ability { id: \"5FA8\", source: \"The Diamond Weapon\" }\r\n115.6 \"Adamant Purge\" Ability { id: \"5F9D\", source: \"The Diamond Weapon\" }\r\n118.8 \"--sync--\" Ability { id: \"5779\", source: \"The Diamond Weapon\" }\r\n127.2 \"Diamond Flash\" Ability { id: \"5FD4\", source: \"The Diamond Weapon\" }\r\n144.1 \"Code Chi-Xi-Stigma\" Ability { id: \"5FAD\", source: \"The Diamond Weapon\" }\r\n\r\n# Intermission\r\n144.1 \"--untargetable--\"\r\n147.1 \"--sync--\" Ability { id: \"5FEB\", source: \"The Diamond Weapon\" }\r\n149.0 \"--sync--\" Ability { id: \"5FBE\", source: \"The Diamond Weapon\" }\r\n159.6 \"--sync--\" Ability { id: \"5FB9\", source: \"The Diamond Weapon\" } # Auri Cyclone castbar\r\n160.6 \"Auri Cyclone 1\" Ability { id: \"5FE6\", source: \"The Diamond Weapon\" }\r\n162.1 \"Auri Cyclone 2\" Ability { id: \"5FE7\", source: \"The Diamond Weapon\" }\r\n169.1 \"Airship's Bane\" Ability { id: \"5FFE\", source: \"The Diamond Weapon\" }\r\n169.9 \"--sync--\" Ability { id: \"5FBB\", source: \"The Diamond Weapon\" }\r\n\r\n# Phase 2\r\n174.1 \"--targetable--\"\r\n186.3 \"Outrage\" Ability { id: \"5FD7\", source: \"The Diamond Weapon\" }\r\n193.5 \"--sync--\" Ability { id: \"6055\", source: \"The Diamond Weapon\" }\r\n201.5 \"--sync--\" Ability { id: \"61A0\", source: \"The Diamond Weapon\" }\r\n\r\n201.9 \"Auri Arts (Z)\" Ability { id: \"5FF8\", source: \"The Diamond Weapon\" }\r\n201.9 \"--untargetable--\"\r\n210.2 \"Auri Arts (Jump)\" Ability { id: \"5FE4\", source: \"The Diamond Weapon\" }\r\n213.6 \"--targetable--\"\r\n\r\n220.7 \"Auri Doomstead\" Ability { id: \"5FD8\", source: \"The Diamond Weapon\" }\r\n\r\n226.8 \"--untargetable--\"\r\n232.9 \"Auri Arts (Cleave)\" Ability { id: \"6151\", source: \"The Diamond Weapon\" }\r\n234.6 \"--targetable--\"\r\n234.9 \"Auri Arts (Jump)\" Ability { id: \"6152\", source: \"The Diamond Weapon\" }\r\n\r\n245.0 \"Outrage\" Ability { id: \"5FD7\", source: \"The Diamond Weapon\" }\r\n255.2 \"--sync--\" Ability { id: \"5FD6\", source: \"The Diamond Weapon\" } # Vertical Cleave castbar\r\n256.9 \"Vertical Cleave\" Ability { id: \"5FE5\", source: \"The Diamond Weapon\" }\r\n266.4 \"Auri Doomstead\" Ability { id: \"5FD8\", source: \"The Diamond Weapon\" }\r\n\r\n269.6 \"--sync--\" Ability { id: \"6055\", source: \"The Diamond Weapon\" }\r\n277.6 \"--sync--\" Ability { id: \"61A0\", source: \"The Diamond Weapon\" }\r\n278.0 \"Auri Arts (Z)\" Ability { id: \"5FF8\", source: \"The Diamond Weapon\" }\r\n278.0 \"--untargetable--\"\r\n281.8 \"--sync--\" Ability { id: \"6130\", source: \"The Diamond Weapon\" }\r\n286.3 \"Auri Arts (Jump)\" Ability { id: \"5FE4\", source: \"The Diamond Weapon\" }\r\n289.7 \"--targetable--\"\r\n\r\n# Intermission\r\n299.8 \"--untargetable--\"\r\n302.2 \"--sync--\" Ability { id: \"5FBF\", source: \"The Diamond Weapon\" }\r\n303.0 \"--sync--\" Ability { id: \"5FEB\", source: \"The Diamond Weapon\" }\r\n304.6 \"--sync--\" Ability { id: \"5FAE\", source: \"The Diamond Weapon\" }\r\n309.7 \"--targetable--\"\r\n\r\n# Phase 3\r\n335.0 \"Diamond Shrapnel\" Ability { id: \"5FAC\", source: \"The Diamond Weapon\" } duration 8\r\n342.1 \"Adamant Purge\" Ability { id: \"5F9B\", source: \"The Diamond Weapon\" }\r\n352.3 \"Claw Swipe\" Ability { id: \"5F9[EF]\", source: \"The Diamond Weapon\" }\r\n368.6 \"Articulated Bits\" Ability { id: \"5FA9\", source: \"The Diamond Weapon\" }\r\n375.7 \"Adamant Purge\" Ability { id: \"5F9A\", source: \"The Diamond Weapon\" }\r\n376.2 \"Aetherial Bullet\" Ability { id: \"5FD5\", source: \"Articulated Bit\" }\r\n385.9 \"Claw Swipe\" Ability { id: \"5F9[EF]\", source: \"The Diamond Weapon\" }\r\n387.8 \"Aetherial Bullet\" Ability { id: \"5FD5\", source: \"Articulated Bit\" }\r\n\r\n400.2 \"Photon Burst\" Ability { id: \"5FA8\", source: \"The Diamond Weapon\" }\r\n410.4 \"Adamant Sphere\" Ability { id: \"6144\", source: \"The Diamond Weapon\" }\r\n420.5 \"Adamant Purge\" Ability { id: \"5F9D\", source: \"The Diamond Weapon\" }\r\n421.2 \"Burst\" Ability { id: \"5FDC\", source: \"The Diamond Weapon\" }\r\n\r\n432.1 \"Diamond Flash\" Ability { id: \"5FD4\", source: \"The Diamond Weapon\" }\r\n446.8 \"Diamond Rain\" Ability { id: \"5FA7\", source: \"The Diamond Weapon\" }\r\n460.0 \"Adamant Purge\" Ability { id: \"5F9C\", source: \"The Diamond Weapon\" }\r\n470.2 \"Homing Laser\" Ability { id: \"5FA0\", source: \"The Diamond Weapon\" }\r\n484.4 \"Photon Burst\" Ability { id: \"5FA8\", source: \"The Diamond Weapon\" }\r\n\r\n# loop\r\n497.6 \"Diamond Shrapnel\" Ability { id: \"5FAC\", source: \"The Diamond Weapon\" } window 100,100 jump 335\r\n504.7 \"Adamant Purge\" #Ability { id: \"5F9B\", source: \"The Diamond Weapon\" }\r\n514.9 \"Claw Swipe\" #Ability { id: \"5F9[EF]\", source: \"The Diamond Weapon\" }\r\n531.2 \"Articulated Bits\" #Ability { id: \"5FA9\", source: \"The Diamond Weapon\" }\r\n538.3 \"Adamant Purge\" #Ability { id: \"5F9A\", source: \"The Diamond Weapon\" }\r\n538.8 \"Aetherial Bullet\" #Ability { id: \"5FD5\", source: \"Articulated Bit\" }\r\n548.5 \"Claw Swipe\" #Ability { id: \"5F9[EF]\", source: \"The Diamond Weapon\" }\r\n550.4 \"Aetherial Bullet\" #Ability { id: \"5FD5\", source: \"Articulated Bit\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/emerald_weapon-ex.ts






// TODO: is there a way to know if a Tertius Terminus Est sword is X or +?
// 55CD has no heading.
// 55CE has a heading of 45 degrees, but that's too late to know.
// https://jp.finalfantasyxiv.com/lodestone/character/28705669/blog/4618012/

// TODO: handle mechanized maneuver with GetCombatnats?
// TODO: handle divebombs during mechanized maneuver with GetCombatants?
const emerald_weapon_ex_centerX = 100;
const emerald_weapon_ex_centerY = 100;
const emerald_weapon_ex_sharedOutputStrings = {
  sharedTankStack: {
    en: 'Tank stack',
    de: 'Tanks sammeln',
    fr: 'Package tanks',
    ja: 'タンク頭割り',
    cn: '坦克分摊',
    ko: '탱끼리 모이기'
  }
};
const emerald_weapon_ex_triggerSet = {
  id: 'CastrumMarinumExtreme',
  zoneId: zone_id/* default.CastrumMarinumExtreme */.Z.CastrumMarinumExtreme,
  timelineFile: 'emerald_weapon-ex.txt',
  timelineTriggers: [{
    id: 'EmeraldEx Bit Storm',
    regex: /Bit Storm/,
    beforeSeconds: 4,
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'EmeraldEx Photon Ring',
    regex: /Photon Ring/,
    beforeSeconds: 4,
    response: responses/* Responses.getOut */.n3.getOut()
  }],
  triggers: [{
    id: 'EmeraldEx Emerald Shot',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: '55B0'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'EmeraldEx Optimized Ultima',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: ['55B1', '5B10'],
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'EmeraldEx Aetheroplasm Production',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: '55AA',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get orbs',
        de: 'Orbs nehmen',
        fr: 'Prenez les orbes',
        ja: '玉を処理',
        cn: '撞球',
        ko: '구슬 부딪히기'
      }
    }
  }, {
    id: 'EmeraldEx Aetheroplasm Rotate',
    type: 'AddedCombatant',
    // 9705 = Ceruleum Sphere, 9706 = Nitrosphere
    netRegex: {
      npcNameId: '9706'
    },
    condition: (data, matches) => {
      (data.orbs ??= []).push(matches);
      return data.orbs.length === 4;
    },
    alertText: (data, _matches, output) => {
      if (!data.orbs) return;
      const isNitro = [false, false, false, false, false, false, false, false];
      for (const orb of data.orbs) {
        const x = parseFloat(orb.x) - emerald_weapon_ex_centerX;
        const y = parseFloat(orb.y) - emerald_weapon_ex_centerY;

        // Positions: N = (100, 78), E = (122, 100), S = (100, 122), W = (78, 100)
        // Dirs: N = 0, NE = 1, ..., NW = 7
        const dir = Math.round(4 - 4 * Math.atan2(x, y) / Math.PI) % 8;
        if (isNitro[dir]) {
          console.error('Aetheroplasm collision');
          return;
        }
        isNitro[dir] = true;
      }

      // Check if west must rotate clockwise to avoid taking two in a row.
      // There are only two patterns here, so it's sufficient to check west.
      if (isNitro[6] === isNitro[7]) return output.counterclock();
      return output.clockwise();
    },
    outputStrings: {
      clockwise: {
        en: 'Rotate Clockwise',
        de: 'Im Uhrzeigersinn rotieren',
        fr: 'Tournez dans le sens horaire',
        cn: '顺时针转',
        ko: '시계방향'
      },
      counterclock: {
        en: 'Rotate Counterclockwise',
        de: 'Gegen den Uhrzeigersinn rotieren',
        fr: 'Tournez dans le sens anti-horaire',
        cn: '逆时针转',
        ko: '반시계방향'
      }
    }
  }, {
    id: 'EmeraldEx Aire Tam Storm',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: ['558F', '55D0'],
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Red Circle',
        de: 'Weg vom roten Kreis',
        fr: 'Éloignez-vous du cercle rouge',
        cn: '远离红圈',
        ko: '빨간 장판에서 멀리 떨어지기'
      }
    }
  }, {
    id: 'EmeraldEx Magitek Magnetism',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: '5594',
      capture: false
    },
    delaySeconds: 9,
    durationSeconds: 6,
    alertText: (data, _matches, output) => {
      // Suppress first magnetism call for tanks, who are handling flares.
      if (!data.seenMines && data.role === 'tank') return;
      return output.text();
    },
    run: data => data.seenMines = true,
    outputStrings: {
      text: {
        en: 'Get Near Same Polarity Mines',
        de: 'Nahe den Bomben mit gleicher Polarisierung',
        fr: 'Allez vers les mines de même polarité',
        ja: '同じ極性の爆雷に近づく',
        cn: '靠近同级地雷',
        ko: '같은 극성 폭탄쪽으로'
      }
    }
  }, {
    id: 'EmeraldEx Divide Et Impera P1',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: '5537',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.role === 'tank') return output.sharedTankStack();
      return output.spread();
    },
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread,
      ...emerald_weapon_ex_sharedOutputStrings
    }
  }, {
    id: 'EmeraldEx Magitek Magnetism Flare',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Flare on YOU',
        de: 'Flare auf DIR',
        fr: 'Brasier sur VOUS',
        ja: '自分にフレア',
        cn: '核爆点名',
        ko: '플레어 대상자'
      }
    }
  }, {
    id: 'EmeraldEx Magitek Magnetism Bait',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Lines Away From Safe Spot',
        de: 'Linien weg vom Safespot ködern',
        fr: 'Orientez les lignes hors de la zone safe',
        ja: '線を安置に被らないように捨てる',
        cn: '诱导直线，不要覆盖安全点',
        ko: '안전지대 밖으로 장판 유도'
      }
    }
  }, {
    id: 'EmeraldEx Expire',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: '55[D9]1',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EmeraldEx Divide Et Impera P2',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: '555B',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.role === 'tank') return output.sharedTankStack();
      return output.protean();
    },
    outputStrings: {
      protean: {
        en: 'Protean',
        de: 'Himmelsrichtungen',
        fr: 'Positions',
        ja: '8方向散開',
        cn: '分散站位',
        ko: '정해진 위치로 산개'
      },
      ...emerald_weapon_ex_sharedOutputStrings
    }
  }, {
    id: 'EmeraldEx Primus Terminus Est',
    type: 'HeadMarker',
    netRegex: {
      id: '00F[9ABC]'
    },
    condition: (data, matches) => {
      (data.primusPlayers ??= []).push(matches.target);
      return data.me === matches.target;
    },
    alertText: (_data, matches, output) => {
      const id = matches.id.toUpperCase();
      if (id === '00F9') return output.text({
        dir: output.south()
      });
      if (id === '00FA') return output.text({
        dir: output.west()
      });
      if (id === '00FB') return output.text({
        dir: output.north()
      });
      if (id === '00FC') return output.text({
        dir: output.east()
      });
    },
    outputStrings: {
      text: {
        en: 'Go ${dir}, Aim Across',
        de: 'Geh nach ${dir}, schau Gegenüber',
        fr: 'Allez direction ${dir}, visez en face',
        cn: '去${dir}, 看好对面',
        ko: '${dir}으로 이동, 반대쪽 확인'
      },
      north: outputs/* default.north */.Z.north,
      east: outputs/* default.east */.Z.east,
      south: outputs/* default.south */.Z.south,
      west: outputs/* default.west */.Z.west
    }
  }, {
    id: 'EmeraldEx Primus Terminus Est Dodge',
    type: 'HeadMarker',
    netRegex: {
      id: '00F[9ABC]',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      if (!data.primusPlayers?.includes(data.me)) return output.text();
    },
    run: data => delete data.primusPlayers,
    outputStrings: {
      text: {
        en: 'Dodge Arrow Lines',
        de: 'Weiche den Pfeillinien aus',
        fr: 'Esquivez les lignes fléchées',
        cn: '避开箭头路径',
        ko: '화살표 방향 피하기'
      }
    }
  }, {
    id: 'EmeraldEx Tertius Terminus Cleanup',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: '55CC',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    run: data => delete data.tertius,
    outputStrings: {
      text: {
        en: 'Watch for Swords',
        de: 'Schau nach den Schwertern',
        fr: 'Repérez les épées',
        cn: '观察剑',
        ko: '칼 떨어지는 위치 보기'
      }
    }
  }, {
    id: 'EmeraldEx Tertius Terminus Est',
    // StartsUsing has positions but is inconsistent when entities are newly moved.
    // We provide more time by using logic to predict where the last two
    // swords will drop.
    type: 'Ability',
    netRegex: {
      source: 'BitBlade',
      id: '55CD'
    },
    durationSeconds: 9,
    alertText: (data, matches, output) => {
      (data.tertius ??= []).push(matches);
      if (data.tertius.length !== 4) return;
      const [s0, s1, s2, s3] = data.tertius.map(sword => {
        const x = parseFloat(sword.x) - emerald_weapon_ex_centerX;
        const y = parseFloat(sword.y) - emerald_weapon_ex_centerY;
        if (Math.abs(x) < 10 && Math.abs(y) < 10) return output.middle();
        if (x < 0) return y < 0 ? output.dirNW() : output.dirSW();
        return y < 0 ? output.dirNE() : output.dirSE();
      });

      // We know that the swords will land in all 4 corners plus twice in
      // the center areas. Predict the last two swords by removing the
      // ones we've already gotten.
      const spawns = [output.dirNE(), output.dirNW(), output.dirSE(), output.dirSW(), output.middle(), output.middle()];
      const [s4, s5] = spawns.filter(x => ![s0, s1, s2, s3].includes(x));
      if (s0 === undefined || s1 === undefined || s2 === undefined || s3 === undefined || s4 === undefined || s5 === undefined) throw new not_reached/* UnreachableCode */.$();
      // A pair of swords s0/s1, s2/s3, s4/s5 is either two intercard corners or two middle.
      // The second pair (s2/s3) is never the middle pair of swords.
      // Therefore, if the first two are not the same, they are not the middle
      // and so the first safe is the middle set of swords (s4, s5).
      const firstSafeIsMiddle = s0 !== s1;
      if (firstSafeIsMiddle) return output.middleFirst({
        middle: s4,
        dir1: s0,
        dir2: s1
      });
      return output.middleLast({
        middle: s0,
        dir1: s4,
        dir2: s5
      });
    },
    outputStrings: {
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirSW: outputs/* default.dirSW */.Z.dirSW,
      dirNW: outputs/* default.dirNW */.Z.dirNW,
      middle: outputs/* default.middle */.Z.middle,
      middleFirst: {
        en: '${middle} -> ${dir1} / ${dir2}',
        de: '${middle} -> ${dir1} / ${dir2}',
        fr: '${middle} -> ${dir1} / ${dir2}',
        cn: '${middle} -> ${dir1} / ${dir2}',
        ko: '${middle} -> ${dir1} / ${dir2}'
      },
      middleLast: {
        en: '${dir1} / ${dir2} -> ${middle}',
        de: '${dir1} / ${dir2} -> ${middle}',
        fr: '${dir1} / ${dir2} -> ${middle}',
        cn: '${dir1} / ${dir2} -> ${middle}',
        ko: '${dir1} / ${dir2} -> ${middle}'
      }
    }
  }, {
    id: 'EmeraldEx Sidescathe Left',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: '55D5',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'EmeraldEx Sidescathe Right',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: '55D4',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'EmeraldEx Emerald Crusher',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: '55D6',
      capture: false
    },
    // Don't collide with Tertius Terminus Est alert, and this is important.
    response: responses/* Responses.knockback */.n3.knockback('alarm')
  }, {
    id: 'EmeraldEx Secundus Terminus Est Plus',
    type: 'HeadMarker',
    netRegex: {
      id: '00FD'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Intercard + Out (Plus)',
        de: 'Interkardinal + Raus (Plus)',
        fr: 'Intercardinal + Extérieur (Plus)',
        cn: '去场边角落 (十字)',
        ko: '대각선 밖으로 (십자)'
      }
    }
  }, {
    id: 'EmeraldEx Secundus Terminus Est Cross',
    type: 'HeadMarker',
    netRegex: {
      id: '00FE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cardinal + Out (Cross)',
        de: 'Kardinal + Raus (Kreuz)',
        fr: 'Cardinal + Extérieur (Croix)',
        cn: '去场边中点 (X字)',
        ko: '동서남북 밖으로 (X자)'
      }
    }
  }, {
    id: 'EmeraldEx Magitek Cannon',
    type: 'StartsUsing',
    netRegex: {
      source: 'Reaper Image',
      id: '55BE',
      capture: false
    },
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'EmeraldEx Full Rank',
    type: 'StartsUsing',
    netRegex: {
      source: 'Black Wolf\'s Image',
      id: '55C0',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go North; Dodge Soldiers/Divebombs',
        de: 'Geh nach Norden; Achte auf die Lücken zwischen den Soldaten',
        fr: 'Allez au Nord, esquivez les soldats et les bombes plongeantes',
        ja: '飛行部隊と射撃部隊を見覚える',
        // FIXME
        cn: '去北边；躲避士兵射击/飞机轰炸',
        ko: '북쪽으로 이동, 엑사플레어, 병사 사격 확인'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Emerald Crusher / Aire Tam Storm': 'Crusher / Aire Tam',
      'Aire Tam Storm / Emerald Crusher': 'Aire Tam / Crusher'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'bitblade': 'Revolverklingen-Arm',
      'Black Wolf\'s Image': 'Gaius-Projektion',
      'Imperial Image': 'garleisch(?:e|er|es|en) Soldat',
      'Reaper Image': 'Schnitter-Projektion',
      'The Emerald Weapon': 'Smaragd-Waffe'
    },
    'replaceText': {
      '--cutscene--': '--Zwischensequence--',
      'Aetheroplasm Production': 'Blitzgenerator',
      'Aire Tam Storm': 'Smaragdfeuersturm',
      'Bit Storm': 'Satellitenarme: Zirkelangriff',
      'Divide Et Impera': 'Divide et Impera',
      'Emerald Beam': 'Smaragdstrahl',
      'Emerald Shot': 'Smaragdschuss',
      'Expire': 'Exspirieren',
      'Heirsbane': 'Erbenbann',
      'Legio Phantasmatis': 'Legio Phantasmatis',
      'Magitek Cannon': 'Magitek-Kanone',
      'Magitek Magnetism': 'Magimagnetismus',
      'Optimized Ultima': 'Ultima-System',
      'Photon Ring': 'Photonenkreis',
      'Primus Terminus Est': 'Terminus Est: Unus',
      'Secundus Terminus Est': 'Terminus Est: Duo',
      'Shots Fired': 'Synchron-Salve',
      'Sidescathe': 'Flankenbeschuss',
      'Split': 'Segregation',
      'Tertius Terminus Est': 'Terminus Est: Tres',
      'Mechanized Maneuver': 'Bewegungsmanöver',
      'Bombs Away': 'Bombardierungsbefehl',
      'Emerald Crusher': 'Smaragdspalter',
      'Full Rank': 'Truppenappell',
      'Final Formation': 'Schlachtreihe',
      'Fatal Fire': 'Feuergefecht'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'bitblade': 'pistolame volante',
      'Black Wolf\'s Image': 'spectre de Gaius',
      'Imperial Image': 'spectre de soldat impérial',
      'Reaper Image': 'spectre de faucheuse',
      'The Emerald Weapon': 'Arme Émeraude'
    },
    'replaceText': {
      '--cutscene--': '--cinématique--',
      'Aetheroplasm Production': 'Condensation d\'éthéroplasma',
      'Aire Tam Storm(?! /)': 'Aire Tam Storm',
      'Aire Tam Storm / Emerald Crusher': 'Aire Tam / Écraseur',
      'Bit Storm': 'Salve circulaire',
      'Divide Et Impera': 'Divide Et Impera',
      'Emerald Beam': 'Rayon émeraude',
      'Emerald Crusher / Aire Tam Storm': 'Écraseur / Aire Tam',
      'Emerald Shot': 'Tir émeraude',
      'Expire': 'Jet de plasma',
      'Heirsbane': 'Fléau de l\'héritier',
      'Legio Phantasmatis': 'Legio Phantasmatis',
      'Magitek Cannon': 'Canon magitek',
      'Magitek Magnetism': 'Électroaimant magitek',
      'Optimized Ultima': 'Ultima magitek',
      'Photon Ring': 'Cercle photonique',
      'Primus Terminus Est': 'Terminus Est : Unus',
      'Secundus Terminus Est': 'Terminus Est : Duo',
      'Shots Fired': 'Fusillade',
      'Sidescathe': 'Salve latérale',
      'Split': 'Séparation',
      'Tertius Terminus Est': 'Terminus Est : Tres',
      'Mechanized Maneuver': 'Murmuration stratégique',
      'Bombs Away': 'Ordre de bombardement',
      'Full Rank': 'Regroupement de toutes les unités',
      'Final Formation': 'Alignement de toutes les unités',
      'Fatal Fire': 'Attaque groupée'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'bitblade': 'ガンブレードビット',
      'Black Wolf\'s Image': 'ガイウスの幻影',
      'Imperial Image': '帝国兵の幻影',
      'Reaper Image': 'リーパーの幻影',
      'The Emerald Weapon': 'エメラルドウェポン'
    },
    'replaceText': {
      '--cutscene--': '--カットシーン--',
      'Aetheroplasm Production': '爆雷生成',
      'Aire Tam Storm': 'エメラルドビッグバン',
      'Bit Storm': 'アームビット：円形射撃',
      'Divide Et Impera': 'ディヴィデ・エト・インペラ',
      'Emerald Beam': 'エメラルドビーム',
      'Emerald Shot': 'エメラルドショット',
      'Expire': '噴射',
      'Heirsbane': 'No.IX',
      'Legio Phantasmatis': 'レギオ・ファンタズマティス',
      'Magitek Cannon': '魔導カノン',
      'Magitek Magnetism': '魔導マグネット',
      'Optimized Ultima': '魔導アルテマ',
      'Photon Ring': 'フォトンサークル',
      'Primus Terminus Est': 'ターミナス・エスト：ウーヌス',
      'Secundus Terminus Est': 'ターミナス・エスト：ドゥオ',
      'Shots Fired': '一斉掃射',
      'Sidescathe': '側面掃射',
      'Split': '分離',
      'Tertius Terminus Est': 'ターミナス・エスト：トレース',
      'Mechanized Maneuver': '機動戦術',
      'Bombs Away': '空爆命令',
      'Emerald Crusher': 'エメラルドクラッシャー',
      'Full Rank': '全軍集結',
      'Final Formation': '全軍整列',
      'Fatal Fire': '全軍攻撃'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'bitblade': '枪刃浮游炮',
      'Black Wolf\'s Image': '盖乌斯的幻影',
      'Imperial Image': '帝国兵的幻影',
      'Reaper Image': '魔导死神的幻影',
      'The Emerald Weapon': '绿宝石神兵'
    },
    'replaceText': {
      '--cutscene--': '--过场动画--',
      'Aetheroplasm Production': '生成炸弹',
      'Aire Tam Storm': '绿宝石大爆炸',
      'Bit Storm': '浮游炮：圆形射击',
      'Divide Et Impera': '分而治之',
      'Emerald Beam': '绿宝石光束',
      'Emerald Shot': '绿宝石射击',
      'Expire': '喷射',
      'Heirsbane': '遗祸',
      'Legio Phantasmatis': '幻影军团',
      'Magitek Cannon': '魔导加农炮',
      'Magitek Magnetism': '魔导磁石',
      'Optimized Ultima': '魔导究极',
      'Photon Ring': '光子环',
      'Primus Terminus Est': '恩惠终结：壹',
      'Secundus Terminus Est': '恩惠终结：贰',
      'Shots Fired': '一齐扫射',
      'Sidescathe': '侧面扫射',
      'Split': '分离',
      'Tertius Terminus Est': '恩惠终结：叁',
      'Mechanized Maneuver': '机动战术',
      'Bombs Away': '轰炸命令',
      'Emerald Crusher': '绿宝石碎击',
      'Full Rank': '全军集合',
      'Final Formation': '全军列队',
      'Fatal Fire': '全军攻击'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'bitblade': '건블레이드 비트',
      'Black Wolf\'s Image': '가이우스의 환영',
      'Imperial Image': '제국 병사의 환영',
      'Reaper Image': '리퍼의 환영',
      'The Emerald Weapon': '에메랄드 웨폰'
    },
    'replaceText': {
      '--cutscene--': '--컷신--',
      'Aetheroplasm Production': '폭뢰 생성',
      'Aire Tam Storm': '에메랄드 대폭발',
      'Bit Storm': '암 비트: 원형 사격',
      'Divide Et Impera': '분할 통치',
      'Emerald Beam': '에메랄드 광선',
      'Emerald Shot': '에메랄드 발사',
      'Expire': '분사',
      'Heirsbane': '제IX호',
      'Legio Phantasmatis': '환영 군단',
      'Magitek Cannon': '마도포',
      'Magitek Magnetism': '마도 자석',
      'Optimized Ultima': '마도 알테마',
      'Photon Ring': '광자 고리',
      'Primus Terminus Est': '파멸의 종착역 I',
      'Secundus Terminus Est': '파멸의 종착역 II',
      'Shots Fired': '일제 소사',
      'Sidescathe': '측면 소사',
      'Split': '분리',
      'Tertius Terminus Est': '파멸의 종착역 III',
      'Mechanized Maneuver': '기동 전술',
      'Bombs Away': '공중 폭격 명령',
      'Emerald Crusher': '에메랄드 분쇄',
      'Full Rank': '전군 집결',
      'Final Formation': '전군 정렬',
      'Fatal Fire': '전군 공격'
    }
  }]
};
/* harmony default export */ const emerald_weapon_ex = (emerald_weapon_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/emerald_weapon-ex.txt
const trial_emerald_weapon_ex_namespaceObject = "### Emerald Weapon Ex\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1\r\n# -p 55B0:17.1\r\n# -ii 55AF 55AE 557B 58D3 557D 557F 5BA6 5BA7 5596 557A 5579 5BD3 5017 559E 55A0 5597 5018 55A4 5BA3 554B 554C 5593 559A 5B03 5598 5B1A\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n1.1 \"--sync--\" Ability { id: \"5B1A\", source: \"The Emerald Weapon\" } window 1.1,0\r\n12.1 \"--sync--\" StartsUsing { id: \"55B0\", source: \"The Emerald Weapon\" } window 20,20\r\n17.1 \"Emerald Shot\" Ability { id: \"55B0\", source: \"The Emerald Weapon\" }\r\n28.2 \"Optimized Ultima\" Ability { id: \"55B1\", source: \"The Emerald Weapon\" }\r\n39.4 \"Aetheroplasm Production\" Ability { id: \"55AA\", source: \"The Emerald Weapon\" }\r\n65.6 \"Emerald Beam\" Ability { id: \"557[13]\", source: \"The Emerald Weapon\" }\r\n92.8 \"Magitek Magnetism\" Ability { id: \"5594\", source: \"The Emerald Weapon\" }\r\n118.0 \"Magitek Magnetism\" Ability { id: \"5594\", source: \"The Emerald Weapon\" }\r\n138.1 \"Emerald Beam\" Ability { id: \"557[57]\", source: \"The Emerald Weapon\" }\r\n160.3 \"Optimized Ultima\" Ability { id: \"55B1\", source: \"The Emerald Weapon\" }\r\n171.4 \"Bit Storm\" Ability { id: \"55A2\", source: \"The Emerald Weapon\" }\r\n178.5 \"Divide Et Impera\" Ability { id: \"5537\", source: \"The Emerald Weapon\" }\r\n198.6 \"Expire\" Ability { id: \"5591\", source: \"The Emerald Weapon\" }\r\n208.6 \"Aire Tam Storm\" Ability { id: \"558F\", source: \"The Emerald Weapon\" }\r\n231.7 \"Photon Ring\" Ability { id: \"55A9\", source: \"The Emerald Weapon\" }\r\n243.9 \"Magitek Magnetism\" Ability { id: \"5594\", source: \"The Emerald Weapon\" }\r\n278.1 \"Optimized Ultima\" Ability { id: \"55B1\", source: \"The Emerald Weapon\" }\r\n291.1 \"Bit Storm\" Ability { id: \"55A2\", source: \"The Emerald Weapon\" }\r\n298.2 \"Divide Et Impera\" Ability { id: \"5537\", source: \"The Emerald Weapon\" }\r\n312.5 \"Optimized Ultima\" Ability { id: \"55B2\", source: \"The Emerald Weapon\" }\r\n339.6 \"Enrage\" Ability { id: \"5B16\", source: \"The Emerald Weapon\" }\r\n\r\n\r\n### Cutscene\r\n800.0 \"--cutscene--\" Ability { id: \"5B02\", source: \"The Emerald Weapon\" } duration 58.5 window 800,0\r\n858.5 \"--targetable--\"\r\n\r\n\r\n### Phase 2\r\n# -p 555B:1015\r\n# -it \"The Emerald Weapon\"\r\n# -it \"Black Wolf's Image\"\r\n# -ii 5B1C 55DA 55D9 55C4 55C5 55C6 55C7 55BC 55BD 55CD 55D2 5585 55CA 55C9 55CB\r\n\r\n1000.0 \"Start\"\r\n1001.0 \"--sync--\" Ability { id: \"5B1C\", source: \"The Emerald Weapon\" } window 1001,0\r\n1010.0 \"--sync--\" StartsUsing { id: \"555B\", source: \"The Emerald Weapon\" } window 1015,20\r\n1015.0 \"Divide Et Impera\" Ability { id: \"555B\", source: \"The Emerald Weapon\" }\r\n1021.3 \"--sync--\" Ability { id: \"5B1F\", source: \"The Emerald Weapon\" }\r\n1031.3 \"Primus Terminus Est\" Ability { id: \"55C3\", source: \"The Emerald Weapon\" }\r\n1046.4 \"Tertius Terminus Est\" Ability { id: \"55CC\", source: \"The Emerald Weapon\" }\r\n1056.4 \"Tertius Terminus Est 1\" #Ability { id: \"55CE\", source: \"The Emerald Weapon\" }\r\n1057.6 \"Tertius Terminus Est 2\" #Ability { id: \"55CE\", source: \"The Emerald Weapon\" }\r\n1058.8 \"Tertius Terminus Est 3\" #Ability { id: \"55CE\", source: \"The Emerald Weapon\" }\r\n\r\n1075.6 \"Legio Phantasmatis\" Ability { id: \"55B4\", source: \"The Emerald Weapon\" } window 20,20\r\n1077.7 \"--untargetable--\"\r\n1080.8 \"--targetable--\"\r\n1084.7 \"Mechanized Maneuver\" Ability { id: \"55BA\", source: \"Black Wolf's Image\" }\r\n1096.2 \"Heirsbane\" Ability { id: \"55B9\", source: \"Black Wolf's Image\" }\r\n1099.4 \"Bombs Away\" Ability { id: \"55BB\", source: \"Black Wolf's Image\" }\r\n1104.6 \"--untargetable--\"\r\n1117.6 \"Magitek Cannon\" Ability { id: \"55BE\", source: \"Reaper Image\" } window 20,20\r\n1127.3 \"--targetable--\"\r\n\r\n1135.4 \"Optimized Ultima\" Ability { id: \"5B10\", source: \"The Emerald Weapon\" }\r\n1148.6 \"Divide Et Impera\" Ability { id: \"555B\", source: \"The Emerald Weapon\" }\r\n1155.4 \"--sync--\" Ability { id: \"5B1F\", source: \"The Emerald Weapon\" }\r\n1162.4 \"Tertius Terminus Est\" Ability { id: \"55CC\", source: \"The Emerald Weapon\" }\r\n1168.1 \"Split\" Ability { id: \"55(CF|D3)\", source: \"The Emerald Weapon\" }\r\n1174.3 \"Expire / Sidescathe\" Ability { id: \"55D[145]\", source: \"The Emerald Weapon\" }\r\n1183.3 \"Aire Tam Storm / Emerald Crusher\" Ability { id: [\"55D0\", \"5585\"], source: \"The Emerald Weapon\" }\r\n1186.7 \"Tertius Terminus Est 1\" #Ability { id: \"55CE\", source: \"The Emerald Weapon\" }\r\n1187.9 \"Tertius Terminus Est 2\" #Ability { id: \"55CE\", source: \"The Emerald Weapon\" }\r\n1189.0 \"Tertius Terminus Est 3\" #Ability { id: \"55CE\", source: \"The Emerald Weapon\" }\r\n\r\n1205.5 \"Legio Phantasmatis\" Ability { id: \"55B4\", source: \"The Emerald Weapon\" } window 20,20\r\n1207.5 \"--untargetable--\"\r\n1210.7 \"--targetable--\"\r\n1214.9 \"Full Rank\" Ability { id: \"55C0\", source: \"Black Wolf's Image\" }\r\n1226.2 \"Final Formation\" Ability { id: \"55C1\", source: \"Black Wolf's Image\" }\r\n1232.4 \"Fatal Fire\" Ability { id: \"55C2\", source: \"Black Wolf's Image\" }\r\n1234.6 \"--untargetable--\"\r\n1238.4 \"Shots Fired 1\" #Ability { id: \"55B7\", source: \"Imperial Image\" }\r\n1240.4 \"Shots Fired 2\" #Ability { id: \"55B7\", source: \"Imperial Image\" }\r\n1242.4 \"Shots Fired 3\" #Ability { id: \"55B7\", source: \"Imperial Image\" }\r\n1247.5 \"Magitek Cannon\" Ability { id: \"55BE\", source: \"Reaper Image\" } window 20,20\r\n1257.2 \"--targetable--\"\r\n\r\n1269.4 \"Secundus Terminus Est\" Ability { id: \"55C8\", source: \"The Emerald Weapon\" }\r\n1286.5 \"Tertius Terminus Est\" Ability { id: \"55CC\", source: \"The Emerald Weapon\" }\r\n1292.7 \"Split\" Ability { id: \"55(CF|D3)\", source: \"The Emerald Weapon\" }\r\n1298.5 \"Sidescathe / Expire\" Ability { id: \"55D[145]\", source: \"The Emerald Weapon\" }\r\n1307.5 \"Emerald Crusher / Aire Tam Storm\" Ability { id: [\"55D0\", \"5585\"], source: \"The Emerald Weapon\" }\r\n1310.4 \"Tertius Terminus Est 1\" #Ability { id: \"55CE\", source: \"The Emerald Weapon\" }\r\n1311.6 \"Tertius Terminus Est 2\" #Ability { id: \"55CE\", source: \"The Emerald Weapon\" }\r\n1312.8 \"Tertius Terminus Est 3\" #Ability { id: \"55CE\", source: \"The Emerald Weapon\" }\r\n1326.5 \"Primus Terminus Est\" Ability { id: \"55C3\", source: \"The Emerald Weapon\" }\r\n1343.2 \"Divide Et Impera\" Ability { id: \"555B\", source: \"The Emerald Weapon\" }\r\n1374.5 \"Enrage\" Ability { id: \"5B17\", source: \"The Emerald Weapon\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/emerald_weapon.ts



const emerald_weapon_triggerSet = {
  id: 'CastrumMarinum',
  zoneId: zone_id/* default.CastrumMarinum */.Z.CastrumMarinum,
  timelineFile: 'emerald_weapon.txt',
  triggers: [{
    id: 'Emerald Emerald Shot',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: '5554'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Emerald Optimized Ultima',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: ['5555', '5556', '5B0F'],
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Emerald Magitek Magnetism',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: '5B0[56]',
      capture: false
    },
    condition: data => data.seenMines || data.role !== 'tank',
    delaySeconds: 9,
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.seenMines = true,
    outputStrings: {
      text: {
        en: 'Get Near Tethered Mines',
        de: 'Nahe den Bomben mit gleicher Polarisierung',
        fr: 'Allez vers les mines de même polarité',
        ja: '同じ極性の爆雷に近づく',
        cn: '靠近同级地雷',
        ko: '같은 극성 폭탄쪽으로'
      }
    }
  }, {
    id: 'Emerald Sidescathe Left',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: ['553F', '5540'],
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Emerald Sidescathe Right',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: ['5541', '5542'],
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Emerald Emerald Crusher',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Emerald Weapon',
      id: ['553C', '553D'],
      capture: false
    },
    // ~7s cast time.
    delaySeconds: 2,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Emerald Divide Et Impera Tankbuster',
    type: 'HeadMarker',
    netRegex: {
      id: '00DA'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Emerald Primus Terminus Est',
    type: 'HeadMarker',
    netRegex: {
      id: '00F5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback Arrow on YOU',
        de: 'Rückstoß-Pfeil auf DIR',
        fr: 'Flèche-Poussée sur VOUS',
        ja: '自分に吹き飛ばし矢印',
        cn: '击退箭头点名',
        ko: '넉백 화살표 대상자'
      }
    }
  }, {
    id: 'Emerald Secundus Terminus Est X',
    type: 'HeadMarker',
    netRegex: {
      id: '00FE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Cardinal With Sword',
        de: 'Geh mit dem Schwert zu Kardinalen',
        fr: 'Allez au cardinal avec l\'épée',
        ja: '辺の中心に捨てる',
        cn: '四边放刀',
        ko: '동서남북으로 이동'
      }
    }
  }, {
    id: 'Emerald Secundus Terminus Est Plus',
    type: 'HeadMarker',
    netRegex: {
      id: '00FD'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Intercardinal With Sword',
        de: 'Geh mit dem Schwert zu Interkardinalen',
        fr: 'Allez à l\'intercardinal avec l\'épée',
        ja: '四隅に捨てる',
        cn: '四角放刀',
        ko: '대각위치로 이동'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Black Wolf\'s Image': 'Gaius-Projektion',
      'Claw Bit': 'Satellitenarm',
      'Magnetic Mine': 'Magnetmine',
      'The Emerald Weapon': 'Smaragd-Waffe'
    },
    'replaceText': {
      'Bit Plasma': 'Satellitenarm: Blitznova',
      'Bit Storm': 'Satellitenarme: Zirkelangriff',
      'Disruption Field': 'Gedankenobstruktor',
      'Divide Et Impera': 'Divide et Impera',
      'Emerald Beam': 'Smaragdstrahl',
      'Emerald Crusher': 'Smaragdspalter',
      'Emerald Shot': 'Smaragdschuss',
      'Explosion': 'Explosion',
      'Fire Away': 'Salvenbefehl',
      'Heat Ray': 'Hitzestrahl',
      'Heirsbane': 'Erbenbann',
      'Legio Phantasmatis': 'Legio Phantasmatis',
      'Magitek Magnetism': 'Magimagnetismus',
      'Optimized Ultima': 'Ultima-System',
      'Photon Laser': 'Photonenlaser',
      'Primus Terminus Est': 'Terminus Est: Unus',
      'Pulse Laser': 'Impulslaser',
      'Rank And File': 'Appell',
      'Secundus Terminus Est': 'Terminus Est: Duo',
      'Shots Fired': 'Synchron-Salve',
      'Sidescathe': 'Flankenbeschuss',
      'Split': 'Segregation',
      'Tertius Terminus Est': 'Terminus Est: Tres',
      'Threefold Formation': 'Gefechtslinie'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Black Wolf\'s Image': 'spectre de Gaius',
      'Claw Bit': 'main volante',
      'Magnetic Mine': 'mine magnétique',
      'The Emerald Weapon': 'Arme Émeraude'
    },
    'replaceText': {
      'Bit Plasma': 'Vague éthéroplasmique',
      'Bit Storm': 'Salve circulaire',
      'Disruption Field': 'Obstruction mentale',
      'Divide Et Impera': 'Divide Et Impera',
      'Emerald Beam': 'Rayon émeraude',
      'Emerald Crusher': 'Écraseur émeraude',
      'Emerald Shot': 'Tir émeraude',
      'Explosion': 'Explosion',
      'Fire Away': 'Peloton d\'exécution',
      'Heat Ray': 'Rayon ardent',
      'Heirsbane': 'Fléau de l\'héritier',
      'Legio Phantasmatis': 'Legio Phantasmatis',
      'Magitek Magnetism': 'Électroaimant magitek',
      'Optimized Ultima': 'Ultima magitek',
      'Photon Laser': 'Laser à photons',
      'Primus Terminus Est': 'Terminus Est : Unus',
      'Pulse Laser': 'Pulsation laser',
      'Rank And File': 'Regroupement',
      'Secundus Terminus Est': 'Terminus Est : Duo',
      'Shots Fired': 'Fusillade',
      'Sidescathe': 'Salve latérale',
      'Split': 'Séparation',
      'Tertius Terminus Est': 'Terminus Est : Tres',
      'Threefold Formation': 'Alignement'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Black Wolf\'s Image': 'ガイウスの幻影',
      'Claw Bit': 'ハンドビット',
      'Magnetic Mine': 'マグネットマイン',
      'The Emerald Weapon': 'エメラルドウェポン'
    },
    'replaceText': {
      'Bit Plasma': 'アームビット：爆雷射出',
      'Bit Storm': 'アームビット：円形射撃',
      'Disruption Field': '妨害思念',
      'Divide Et Impera': 'ディヴィデ・エト・インペラ',
      'Emerald Beam': 'エメラルドビーム',
      'Emerald Crusher': 'エメラルドクラッシャー',
      'Emerald Shot': 'エメラルドショット',
      'Explosion': '爆発',
      'Fire Away': '掃射命令',
      'Heat Ray': 'ヒートレイ',
      'Heirsbane': 'No.IX',
      'Legio Phantasmatis': 'レギオ・ファンタズマティス',
      'Magitek Magnetism': '魔導マグネット',
      'Optimized Ultima': '魔導アルテマ',
      'Photon Laser': 'フォトンレーザー',
      'Primus Terminus Est': 'ターミナス・エスト：ウーヌス',
      'Pulse Laser': '波動レーザー',
      'Rank And File': '歩兵集結',
      'Secundus Terminus Est': 'ターミナス・エスト：ドゥオ',
      'Shots Fired': '一斉掃射',
      'Sidescathe': '側面掃射',
      'Split': '分離',
      'Tertius Terminus Est': 'ターミナス・エスト：トレース',
      'Threefold Formation': '歩兵整列'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Black Wolf\'s Image': '盖乌斯的幻影',
      'Claw Bit': '手型浮游炮',
      'Magnetic Mine': '电磁炸雷',
      'The Emerald Weapon': '绿宝石神兵'
    },
    'replaceText': {
      'Bit Plasma': '浮游炮：射出炸弹',
      'Bit Storm': '浮游炮：圆形射击',
      'Disruption Field': '妨碍思念',
      'Divide Et Impera': '分而治之',
      'Emerald Beam': '绿宝石光束',
      'Emerald Crusher': '绿宝石碎击',
      'Emerald Shot': '绿宝石射击',
      'Explosion': '爆炸',
      'Fire Away': '扫射命令',
      'Heat Ray': '炽热射线',
      'Heirsbane': '遗祸',
      'Legio Phantasmatis': '幻影军团',
      'Magitek Magnetism': '魔导磁石',
      'Optimized Ultima': '魔导究极',
      'Photon Laser': '光子射线',
      'Primus Terminus Est': '恩惠终结：壹',
      'Pulse Laser': '波动射线',
      'Rank And File': '步兵集合',
      'Secundus Terminus Est': '恩惠终结：贰',
      'Shots Fired': '一齐扫射',
      'Sidescathe': '侧面扫射',
      'Split': '分离',
      'Tertius Terminus Est': '恩惠终结：叁',
      'Threefold Formation': '步兵列队'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Black Wolf\'s Image': '가이우스의 환영',
      'Claw Bit': '핸드 비트',
      'Magnetic Mine': '자석 지뢰',
      'The Emerald Weapon': '에메랄드 웨폰'
    },
    'replaceText': {
      'Bit Plasma': '암 비트: 폭뢰 사출',
      'Bit Storm': '암 비트: 원형 사격',
      'Disruption Field': '방해 사념',
      'Divide Et Impera': '분할 통치',
      'Emerald Beam': '에메랄드 광선',
      'Emerald Crusher': '에메랄드 분쇄',
      'Emerald Shot': '에메랄드 발사',
      'Explosion': '폭발',
      'Fire Away': '소사 명령',
      'Heat Ray': '열광선',
      'Heirsbane': '제IX호',
      'Legio Phantasmatis': '환영 군단',
      'Magitek Magnetism': '마도 자석',
      'Optimized Ultima': '마도 알테마',
      'Photon Laser': '광자 레이저',
      'Primus Terminus Est': '파멸의 종착역 I',
      'Pulse Laser': '파동 레이저',
      'Rank And File': '보병 집결',
      'Secundus Terminus Est': '파멸의 종착역 II',
      'Shots Fired': '일제 소사',
      'Sidescathe': '측면 소사',
      'Split': '분리',
      'Tertius Terminus Est': '파멸의 종착역 III',
      'Threefold Formation': '보병 정렬'
    }
  }]
};
/* harmony default export */ const emerald_weapon = (emerald_weapon_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/emerald_weapon.txt
const trial_emerald_weapon_namespaceObject = "### Emerald Weapon\r\n# -p 5554:13.4 5539:1011.2\r\n# -it \"The Emerald Weapon\"\r\n# -ii 5B1A 5B1C 5532 5533 5BA4 5BA5 553C 554E 5BA2 5551 553D 5B03 556F 5570 5563 4B3E 5568 5569 556A 5560\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Use autos/unique syncs instead of InCombat lines to start timelines for each phase\r\n# as timeline resets out of combat.\r\n\r\n### Phase 1\r\n0 \"Start\"\r\n0.5 \"--sync--\" Ability { id: \"5B1A\", source: \"The Emerald Weapon\" } window 1,0.5\r\n8.4 \"--sync--\" StartsUsing { id: \"5554\", source: \"The Emerald Weapon\" } window 10,5\r\n13.4 \"Emerald Shot\" Ability { id: \"5554\", source: \"The Emerald Weapon\" }\r\n\r\n26.6 \"Emerald Beam\" Ability { id: \"552A\", source: \"The Emerald Weapon\" }\r\n26.6 \"Heat Ray\" Ability { id: \"4F9D\", source: \"The Emerald Weapon\" } duration 9.7\r\n26.6 \"Photon Laser\" Ability { id: \"5534\", source: \"The Emerald Weapon\" }\r\n28.6 \"Photon Laser\" Ability { id: \"5536\", source: \"The Emerald Weapon\" }\r\n30.6 \"Photon Laser\" Ability { id: \"5538\", source: \"The Emerald Weapon\" }\r\n32.4 \"Photon Laser\" Ability { id: \"5534\", source: \"The Emerald Weapon\" }\r\n34.4 \"Photon Laser\" Ability { id: \"5536\", source: \"The Emerald Weapon\" }\r\n36.4 \"Photon Laser\" Ability { id: \"5538\", source: \"The Emerald Weapon\" }\r\n39.4 \"--sync--\" Ability { id: \"5017\", source: \"The Emerald Weapon\" }\r\n\r\n50.7 \"Magitek Magnetism\" Ability { id: \"5B05\", source: \"The Emerald Weapon\" }\r\n64.3 \"--sync--\" Ability { id: \"5545\", source: \"The Emerald Weapon\" }\r\n65.2 \"Explosion\" Ability { id: \"5B04\", source: \"Magnetic Mine\" }\r\n\r\n73.9 \"Optimized Ultima\" Ability { id: \"5555\", source: \"The Emerald Weapon\" }\r\n79.1 \"Split\" Ability { id: \"553A\", source: \"The Emerald Weapon\" }\r\n85.2 \"Sidescathe\" Ability { id: [\"553F\", \"5541\"], source: \"The Emerald Weapon\" }\r\n95.0 \"Emerald Crusher\" Ability { id: \"553E\", source: \"The Emerald Weapon\" }\r\n\r\n99.2 \"--sync--\" Ability { id: \"5543\", source: \"The Emerald Weapon\" }\r\n108.6 \"Emerald Beam\" Ability { id: \"5530\", source: \"The Emerald Weapon\" }\r\n\r\n108.6 \"Heat Ray\" Ability { id: \"4F9D\", source: \"The Emerald Weapon\" } duration 9.7\r\n108.6 \"Photon Laser\" Ability { id: \"5534\", source: \"The Emerald Weapon\" }\r\n110.6 \"Photon Laser\" Ability { id: \"5536\", source: \"The Emerald Weapon\" }\r\n112.6 \"Photon Laser\" Ability { id: \"5538\", source: \"The Emerald Weapon\" }\r\n114.4 \"Photon Laser\" Ability { id: \"5534\", source: \"The Emerald Weapon\" }\r\n116.4 \"Photon Laser\" Ability { id: \"5536\", source: \"The Emerald Weapon\" }\r\n118.4 \"Photon Laser\" Ability { id: \"5538\", source: \"The Emerald Weapon\" }\r\n121.5 \"--sync--\" Ability { id: \"5018\", source: \"The Emerald Weapon\" }\r\n\r\n134.8 \"Bit Storm\" Ability { id: \"554A\", source: \"The Emerald Weapon\" }\r\n134.8 \"--sync--\" Ability { id: \"4F9C\", source: \"The Emerald Weapon\" }\r\n149.9 \"Divide Et Impera\" Ability { id: \"5535\", source: \"The Emerald Weapon\" }\r\n162.2 \"Magitek Magnetism\" Ability { id: \"5B06\", source: \"The Emerald Weapon\" }\r\n175.8 \"--sync--\" Ability { id: \"5545\", source: \"The Emerald Weapon\" }\r\n176.6 \"Explosion\" Ability { id: \"5B04\", source: \"Magnetic Mine\" }\r\n\r\n180.2 \"Pulse Laser\" Ability { id: \"5547\", source: \"The Emerald Weapon\" }\r\n180.4 \"Pulse Laser\" Ability { id: \"5548\", source: \"The Emerald Weapon\" }\r\n184.5 \"Pulse Laser\" Ability { id: \"5547\", source: \"The Emerald Weapon\" }\r\n184.7 \"Pulse Laser\" Ability { id: \"5548\", source: \"The Emerald Weapon\" }\r\n188.8 \"Pulse Laser\" Ability { id: \"5547\", source: \"The Emerald Weapon\" }\r\n189.0 \"Pulse Laser\" Ability { id: \"5548\", source: \"The Emerald Weapon\" }\r\n195.5 \"--sync--\" Ability { id: \"5B1D\", source: \"The Emerald Weapon\" }\r\n\r\n200.6 \"Split\" Ability { id: \"553B\", source: \"The Emerald Weapon\" }\r\n211.7 \"Bit Plasma\" Ability { id: \"554F\", source: \"Claw Bit\" }\r\n211.7 \"Sidescathe\" Ability { id: [\"5540\", \"5542\"], source: \"The Emerald Weapon\" }\r\n219.2 \"Bit Plasma\" Ability { id: \"554F\", source: \"Claw Bit\" }\r\n226.7 \"Bit Plasma\" Ability { id: \"554F\", source: \"Claw Bit\" }\r\n\r\n240.5 \"Emerald Crusher\" Ability { id: \"553E\", source: \"The Emerald Weapon\" }\r\n244.8 \"--sync--\" Ability { id: \"5544\", source: \"The Emerald Weapon\" }\r\n247.9 \"--sync--\" Ability { id: \"5B1E\", source: \"The Emerald Weapon\" }\r\n260.1 \"Magitek Magnetism\" Ability { id: \"5B06\", source: \"The Emerald Weapon\" }\r\n273.6 \"--sync--\" Ability { id: \"5545\", source: \"The Emerald Weapon\" }\r\n274.4 \"Explosion\" Ability { id: \"5B04\", source: \"Magnetic Mine\" }\r\n284.2 \"Optimized Ultima\" Ability { id: \"5556\", source: \"The Emerald Weapon\" }\r\n296.4 \"Emerald Shot\" Ability { id: \"5554\", source: \"The Emerald Weapon\" }\r\n308.7 \"Optimized Ultima\" Ability { id: \"5556\", source: \"The Emerald Weapon\" }\r\n315.9 \"--sync--\" Ability { id: \"5B1D\", source: \"The Emerald Weapon\" }\r\n\r\n# TODO: loop???\r\n# TODO: there's sometimes a 5544/5B1E ability here?\r\n321.0 \"Split\" Ability { id: \"553B\", source: \"The Emerald Weapon\" } window 100,100 jump 200.6\r\n332.1 \"Bit Plasma\" #Ability { id: \"554F\", source: \"Claw Bit\" }\r\n332.1 \"Sidescathe\" #Ability { id: [\"5541\", \"5542\"], source: \"The Emerald Weapon\" }\r\n339.6 \"Bit Plasma\" #Ability { id: \"554F\", source: \"Claw Bit\" }\r\n347.1 \"Bit Plasma\" #Ability { id: \"554F\", source: \"Claw Bit\" }\r\n\r\n\r\n### Intermission\r\n936.6 \"--untargetable--\"\r\n936.7 \"--sync--\" StartsUsing { id: \"5B02\", source: \"The Emerald Weapon\" } window 1000,10\r\n940.7 \"Disruption Field\" Ability { id: \"5B02\", source: \"The Emerald Weapon\" }\r\n1000.0 \"--targetable--\"\r\n\r\n\r\n### Phase 2 (checkpoint)\r\n1006.2 \"--sync--\" StartsUsing { id: \"5539\", source: \"The Emerald Weapon\" } window 1200,10\r\n1011.2 \"Divide Et Impera\" Ability { id: \"5539\", source: \"The Emerald Weapon\" }\r\n1016.5 \"--sync--\" Ability { id: \"5B1F\", source: \"The Emerald Weapon\" }\r\n1025.6 \"Primus Terminus Est\" Ability { id: \"5562\", source: \"The Emerald Weapon\" }\r\n1037.7 \"Secundus Terminus Est\" Ability { id: \"5567\", source: \"The Emerald Weapon\" }\r\n\r\n# Swords\r\n1053.9 \"Tertius Terminus Est\" Ability { id: \"556B\", source: \"The Emerald Weapon\" }\r\n1055.9 \"Tertius Terminus Est 1\" #Ability { id: \"556C\", source: \"Bitblade\" }\r\n1057.4 \"Tertius Terminus Est 2\" #Ability { id: \"556C\", source: \"Bitblade\" }\r\n1058.9 \"Tertius Terminus Est 3\" #Ability { id: \"556C\", source: \"Bitblade\" }\r\n1063.9 \"Tertius Terminus Est 1\" #Ability { id: \"556D\", source: \"The Emerald Weapon\" }\r\n1065.4 \"Tertius Terminus Est 2\" #Ability { id: \"556D\", source: \"The Emerald Weapon\" }\r\n1066.9 \"Tertius Terminus Est 3\" #Ability { id: \"556D\", source: \"The Emerald Weapon\" }\r\n\r\n# Soldier phase\r\n1070.1 \"--sync--\" Ability { id: \"5B20\", source: \"The Emerald Weapon\" }\r\n1082.3 \"Legio Phantasmatis\" Ability { id: \"5559\", source: \"The Emerald Weapon\" }\r\n1084.3 \"--untargetable--\"\r\n1091.6 \"Rank And File\" Ability { id: \"555A\", source: \"Black Wolf's Image\" }\r\n\r\n1096.9 \"Threefold Formation\" Ability { id: \"555D\", source: \"Black Wolf's Image\" }\r\n1104.8 \"Fire Away\" Ability { id: \"555E\", source: \"Black Wolf's Image\" }\r\n1107.9 \"Shots Fired 1\" #Ability { id: \"555F\", source: \"Imperial Image\" }\r\n1109.9 \"Shots Fired 2\" #Ability { id: \"555F\", source: \"Imperial Image\" }\r\n1111.9 \"Shots Fired 3\" #Ability { id: \"555F\", source: \"Imperial Image\" }\r\n1114.6 \"Heirsbane\" Ability { id: \"5561\", source: \"Black Wolf's Image\" }\r\n\r\n1117.8 \"Threefold Formation\" Ability { id: \"555D\", source: \"Black Wolf's Image\" }\r\n1125.4 \"Fire Away\" Ability { id: \"555E\", source: \"Black Wolf's Image\" }\r\n1128.5 \"Shots Fired 1\" #Ability { id: \"555F\", source: \"Imperial Image\" }\r\n1130.5 \"Shots Fired 2\" #Ability { id: \"555F\", source: \"Imperial Image\" }\r\n1132.5 \"Shots Fired 3\" #Ability { id: \"555F\", source: \"Imperial Image\" }\r\n1135.1 \"Heirsbane\" Ability { id: \"5561\", source: \"Black Wolf's Image\" }\r\n1146.8 \"--targetable--\"\r\n\r\n1157.9 \"Optimized Ultima\" Ability { id: \"5B0F\", source: \"The Emerald Weapon\" }\r\n1166.1 \"--sync--\" Ability { id: \"5B1F\", source: \"The Emerald Weapon\" }\r\n\r\n# Swords\r\n1173.2 \"Tertius Terminus Est\" Ability { id: \"556B\", source: \"The Emerald Weapon\" }\r\n1175.2 \"Tertius Terminus Est 1\" #Ability { id: \"556C\", source: \"Bitblade\" }\r\n1176.7 \"Tertius Terminus Est 2\" #Ability { id: \"556C\", source: \"Bitblade\" }\r\n1178.2 \"Tertius Terminus Est 3\" #Ability { id: \"556C\", source: \"Bitblade\" }\r\n1183.2 \"Tertius Terminus Est 1\" #Ability { id: \"556D\", source: \"The Emerald Weapon\" }\r\n1184.7 \"Tertius Terminus Est 2\" #Ability { id: \"556D\", source: \"The Emerald Weapon\" }\r\n1186.2 \"Tertius Terminus Est 3\" #Ability { id: \"556D\", source: \"The Emerald Weapon\" }\r\n1189.4 \"--sync--\" Ability { id: \"5B20\", source: \"The Emerald Weapon\" }\r\n\r\n# loop?\r\n1196.5 \"Divide Et Impera\" Ability { id: \"5539\", source: \"The Emerald Weapon\" } window 100,100 jump 1011.2\r\n1201.8 \"--sync--\" #Ability { id: \"5B1F\", source: \"The Emerald Weapon\" }\r\n1210.9 \"Primus Terminus Est\" #Ability { id: \"5562\", source: \"The Emerald Weapon\" }\r\n1223.0 \"Secundus Terminus Est\" #Ability { id: \"5567\", source: \"The Emerald Weapon\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/hades-ex.ts




// Hades Extreme

// TODO: call out direction for safe spot
// TODO: fire/ice tethers (0060|0061)
const hades_ex_triggerSet = {
  id: 'TheMinstrelsBalladHadessElegy',
  zoneId: zone_id/* default.TheMinstrelsBalladHadessElegy */.Z.TheMinstrelsBalladHadessElegy,
  timelineFile: 'hades-ex.txt',
  timelineTriggers: [{
    id: 'HadesEx Comet',
    regex: /Comet 1/,
    beforeSeconds: 5,
    condition: data => data.role === 'tank' || data.job === 'BLU',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Comet Towers',
        de: 'Türme',
        fr: 'Tours de comète',
        ja: 'コメットを処理',
        cn: '踩塔',
        ko: '혜성 기둥'
      }
    }
  }],
  triggers: [{
    id: 'HadesEx Shadow Spread 1',
    type: 'StartsUsing',
    netRegex: {
      id: '47A8',
      source: 'Hades',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Protean',
        de: 'Himmelsrichtungen',
        fr: 'Positions',
        ja: '散開',
        cn: '散开',
        ko: '위치 산개'
      }
    }
  }, {
    id: 'HadesEx Shadow Spread 2',
    type: 'StartsUsing',
    netRegex: {
      id: '47A8',
      source: 'Hades',
      capture: false
    },
    delaySeconds: 5.5,
    response: responses/* Responses.moveAway */.n3.moveAway('alert')
  }, {
    id: 'HadesEx Ravenous Assault',
    type: 'StartsUsing',
    netRegex: {
      id: '47A6',
      source: 'Hades'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'HadesEx Bad Faith Left 1',
    type: 'StartsUsing',
    netRegex: {
      id: '47AB',
      source: 'Hades',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft('info')
  }, {
    id: 'HadesEx Bad Faith Left 2',
    type: 'StartsUsing',
    netRegex: {
      id: '47AB',
      source: 'Hades',
      capture: false
    },
    delaySeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Then Right',
        de: 'Dann Rechts',
        fr: 'À Droite',
        ja: 'そして右へ',
        cn: '然后右',
        ko: '다음 오른쪽'
      }
    }
  }, {
    id: 'HadesEx Bad Faith Right 1',
    type: 'StartsUsing',
    netRegex: {
      id: '47AC',
      source: 'Hades',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight('info')
  }, {
    id: 'HadesEx Bad Faith Right 2',
    type: 'StartsUsing',
    netRegex: {
      id: '47AC',
      source: 'Hades',
      capture: false
    },
    delaySeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Then Left',
        de: 'Dann Links',
        fr: 'À Gauche',
        ja: 'そして左へ',
        cn: '然后左',
        ko: '다음 왼쪽'
      }
    }
  }, {
    id: 'HadesEx Arcane Control Orbs',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Arcane Globe',
      capture: false
    },
    durationSeconds: 6,
    suppressSeconds: 2,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to Safe Spot',
        de: 'Geh zur sicheren Stelle',
        fr: 'Allez dans la zone safe',
        ja: '安全の場所へ移動',
        cn: '前往安全区域',
        ko: '안전 지대로 이동'
      }
    }
  }, {
    id: 'HadesEx Arcane Control Doors',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Arcane Font',
      capture: false
    },
    durationSeconds: 6,
    suppressSeconds: 2,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Door',
        de: 'Hinter der Tür verstecken',
        fr: 'Cachez-vous derrière le mirroir',
        ja: '鏡の後ろに',
        cn: '镜子后躲避',
        ko: '문 없는 곳 반대쪽으로'
      }
    }
  }, {
    id: 'HadesEx Quake III',
    type: 'StartsUsing',
    netRegex: {
      id: '47B8',
      source: 'Nabriales\'s Shade',
      capture: false
    },
    delaySeconds: 25,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'HadesEx Dark II Tether',
    type: 'Tether',
    netRegex: {
      id: '0011',
      source: 'Shadow Of The Ancients'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Point Tether Out',
        de: 'Verbindung nach draußen richten',
        fr: 'Pointez le lien vers l\'extérieur',
        ja: '線を外に引く',
        cn: '连线',
        ko: '선 연결 바깥으로 빼기'
      }
    }
  }, {
    id: 'HadesEx Ancient Water 3',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.waterDarkMarker = true,
    outputStrings: {
      text: {
        en: 'Healer Stacks',
        de: 'Bei dem Heiler sammeln',
        fr: 'Packages sur les heals',
        ja: 'ヒーラーに集合',
        cn: '治疗集合',
        ko: '힐러 모이기'
      }
    }
  }, {
    id: 'HadesEx Ancient Darkness',
    type: 'HeadMarker',
    netRegex: {
      id: '0060'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.waterDarkMarker = true,
    outputStrings: {
      text: {
        en: 'Tank Spread',
        de: 'Tanks verteilen',
        fr: 'Tanks, dispersez-vous',
        ja: 'タンクは外に',
        cn: '坦克散开',
        ko: '탱 산개'
      }
    }
  }, {
    id: 'HadesEx Ancient Water Unmarked',
    type: 'HeadMarker',
    netRegex: {
      id: ['0030', '0060'],
      capture: false
    },
    condition: data => !data.waterDarkMarker,
    delaySeconds: 0.5,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Healer Stacks',
        de: 'Bei den Heilern sammeln',
        fr: 'Packages sur les heals',
        ja: 'ヒーラーに集合',
        cn: '治疗集合',
        ko: '힐러 모이기'
      }
    }
  }, {
    id: 'HadesEx Shades Too Close',
    type: 'Tether',
    netRegex: {
      id: '000E',
      source: ['Igeyorhm\'s Shade', 'Lahabrea\'s Shade'],
      target: ['Igeyorhm\'s Shade', 'Lahabrea\'s Shade'],
      capture: false
    },
    condition: data => data.role === 'tank' || data.job === 'BLU',
    suppressSeconds: 10,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move Shades Apart',
        de: 'Schatten auseinander ziehen',
        fr: 'Écartez les spectres',
        ja: 'アシエンを引き離す',
        cn: '拉开无影',
        ko: '분신 서로 떨어뜨리기'
      }
    }
  }, {
    id: 'HadesEx Spheres',
    type: 'StartsUsing',
    netRegex: {
      id: '47BD',
      source: 'Igeyorhm\'s Shade',
      capture: false
    },
    condition: data => data.role === 'tank' || data.job === 'BLU',
    infoText: (data, _matches, output) => {
      if (!data.sphereCount) return;
      return output.text();
    },
    run: data => {
      data.sphereCount = (data.sphereCount ?? 0) + 1;
    },
    outputStrings: {
      text: {
        en: 'tank swap soon',
        de: 'Gleich: Tank swap',
        fr: 'Tank swap bientôt',
        ja: 'まもなく、タンクスイッチ',
        cn: '坦克即将换T',
        ko: '곧 탱교대'
      }
    }
  }, {
    id: 'HadesEx Annihilation',
    type: 'StartsUsing',
    netRegex: {
      id: '47BF',
      source: 'Lahabrea\'s And Igeyorhm\'s Shades',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'HadesEx Burning Brand',
    type: 'GainsEffect',
    netRegex: {
      effectId: '850'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.brand = 'fire',
    outputStrings: {
      text: {
        en: 'Attack Igeyorhm',
        de: 'Igeyorhm angreifen',
        fr: 'Attaquez Igeyorhm',
        ja: 'イゲオルムを攻撃',
        cn: '攻击以格约姆',
        ko: '이게요름 공격'
      }
    }
  }, {
    id: 'HadesEx Freezing Brand',
    type: 'GainsEffect',
    netRegex: {
      effectId: '851'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.brand = 'ice',
    outputStrings: {
      text: {
        en: 'Attack Lahabrea',
        de: 'Lahabrea angreifen',
        fr: 'Attaquez Lahabrea',
        ja: 'ラハブレアを攻撃',
        cn: '攻击拉哈布雷亚',
        ko: '라하브레아 공격'
      }
    }
  }, {
    id: 'HadesEx Blizzard IV',
    type: 'StartsUsing',
    netRegex: {
      id: '47C3',
      source: 'Igeyorhm\'s Shade'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'HadesEx Fire IV',
    type: 'StartsUsing',
    netRegex: {
      id: '47C2',
      source: 'Lahabrea\'s Shade'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'HadesEx Healers Blizzard/Fire IV',
    type: 'StartsUsing',
    netRegex: {
      id: ['47C3', '47C2'],
      source: ['Igeyorhm\'s Shade', 'Lahabrea\'s Shade'],
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.tankBusters */.Z.tankBusters
    }
  }, {
    id: 'HadesEx Doom',
    type: 'GainsEffect',
    netRegex: {
      effectId: '6E9',
      capture: false
    },
    condition: data => data.role === 'healer' || data.job === 'BLU',
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Heal T/H to Full',
        de: 'Heile T/H voll',
        fr: 'Soignez T/H complétement',
        ja: 'タンク／ヒーラーのHPを満タンに',
        cn: '奶满T奶',
        ko: '탱/힐 풀피로 만들기'
      }
    }
  }, {
    id: 'HadesEx Shriek',
    type: 'GainsEffect',
    netRegex: {
      effectId: '1C4'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 2,
    suppressSeconds: 2,
    response: responses/* Responses.lookAway */.n3.lookAway('alarm')
  }, {
    id: 'HadesEx Beyond Death',
    type: 'GainsEffect',
    netRegex: {
      effectId: '566'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 8,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Killed',
        de: 'Stirb',
        fr: 'Mourrez',
        ja: '自殺',
        cn: '自杀',
        ko: '죽을 정도로 맞기'
      }
    }
  }, {
    id: 'HadesEx Ancient Circle',
    type: 'GainsEffect',
    netRegex: {
      effectId: '83E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Donut on YOU',
        de: 'Donut auf DIR',
        fr: 'Donut sur VOUS',
        ja: '自分にエンシェントリング',
        cn: '月环点名',
        ko: '도넛 징 대상자'
      }
    }
  }, {
    id: 'HadesEx Forked Lightning',
    type: 'GainsEffect',
    netRegex: {
      effectId: '24B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 2,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stay Out',
        de: 'Draußen stehen',
        fr: 'Restez éloigné',
        ja: 'ライトニングを外に安置',
        cn: '外侧放雷',
        ko: '바깥에 있기'
      }
    }
  }, {
    id: 'HadesEx Blight',
    type: 'StartsUsing',
    netRegex: {
      id: '47CC',
      source: 'Ascian Prime\'s Shade',
      capture: false
    },
    delaySeconds: 12,
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'HadesEx Height Of Chaos',
    type: 'StartsUsing',
    netRegex: {
      id: '47D1',
      source: 'Ascian Prime\'s Shade'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.tankBusterOnYou();
      if (data.role === 'healer') return output.busterOn({
        player: data.party.member(matches.target)
      });
      return output.awayFromPlayer({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      tankBusterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
      busterOn: outputs/* default.tankBusterOnPlayer */.Z.tankBusterOnPlayer,
      awayFromPlayer: {
        en: 'Away from ${player}',
        de: 'Weg von ${player}',
        fr: 'Éloignez-vous de ${player}',
        ja: '${player}から離れ',
        cn: '远离 ${player}',
        ko: '"${player}" 탱버'
      }
    }
  }, {
    id: 'HadesEx Megiddo Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '47CD',
      source: 'Ascian Prime\'s Shade',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Healer Stacks',
        de: 'Bei den Heilern sammeln',
        fr: 'Packages sur les heals',
        ja: 'ヒーラーに集合',
        cn: '治疗集合',
        ko: '힐러 모이기'
      }
    }
  }, {
    id: 'HadesEx Shadow Flare',
    type: 'StartsUsing',
    netRegex: {
      id: '47D0',
      source: 'Ascian Prime\'s Shade',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'HadesEx Captivity',
    type: 'HeadMarker',
    netRegex: {
      id: '0078'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.getOut */.n3.getOut('alarm')
  }, {
    id: 'HadesEx Aetherial Gaol',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Aetherial Gaol',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Break Aetherial Gaol',
        de: 'Zerstöre Ätherkerker',
        fr: 'Détruisez la Geôle éthérée',
        ja: 'エーテリアル・ジェイルを打ち破す',
        cn: '打破牢狱',
        ko: '에테르 감옥 부수기'
      }
    }
  }, {
    id: 'HadesEx Dark Flame',
    type: 'HeadMarker',
    netRegex: {
      id: '0064'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.flame = true,
    outputStrings: {
      text: {
        en: 'Knockback + Stack on YOU',
        de: 'Rückstoß + sammeln beim DIR',
        fr: 'Poussée + package sur VOUS',
        ja: 'ノックバック + 頭割り',
        cn: '击退 + 集合 点名',
        ko: '넉백 + 쉐어징 대상자'
      }
    }
  }, {
    id: 'HadesEx Dark Freeze',
    type: 'HeadMarker',
    netRegex: {
      id: '00C1'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.freeze = true,
    outputStrings: {
      text: {
        en: 'Knockback + Ice on YOU',
        de: 'Rückstoß + Eis auf DIR',
        fr: 'Poussée + Glace sur VOUS',
        ja: '自分に ノックバック + 氷',
        cn: '击退 + 冰 点名',
        ko: '넉백 + 얼음징 대상자'
      }
    }
  }, {
    id: 'HadesEx Wail Of The Lost',
    type: 'StartsUsing',
    netRegex: {
      id: '47E1',
      source: 'Hades',
      capture: false
    },
    condition: data => !data.flame && !data.freeze,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback + Stack With Partner',
        de: 'Rückstoß + sammeln beim Partner',
        fr: 'Poussée + packez-vous avec votre partenaire',
        ja: 'パートナーと ノックバック + 頭割り',
        cn: '与伙伴 击退 + 集合',
        ko: '넉백 + 파트너랑 모이기'
      }
    }
  }, {
    id: 'HadesEx Nether Blast',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.netherBlast = true,
    outputStrings: {
      text: {
        en: 'Puddles on YOU',
        de: 'Fläche auf YOU',
        fr: 'Zone au sol sur VOUS',
        ja: 'AoEを外に捨て',
        cn: '水圈点名',
        ko: '징 대상자'
      }
    }
  }, {
    id: 'HadesEx Bident',
    type: 'StartsUsing',
    netRegex: {
      id: '47E3',
      source: 'Hades',
      capture: false
    },
    condition: data => !data.netherBlast,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Healer Stacks',
        de: 'Bei dem Heiler sammeln',
        fr: 'Packages sur les heals',
        ja: 'ヒーラーに集合',
        cn: '治疗集合',
        ko: '힐러 모이기'
      }
    }
  }, {
    id: 'HadesEx Shadow Stream',
    type: 'StartsUsing',
    netRegex: {
      id: '47EA',
      source: 'Hades',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'HadesEx Polydegmon\'s Purgation',
    type: 'StartsUsing',
    netRegex: {
      id: '47EB',
      source: 'Hades',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Front and Center',
        de: 'Vorne und Mitte',
        fr: 'Devant et au centre',
        ja: '中央',
        cn: '中间前方',
        ko: '앞 중앙으로'
      }
    }
  }, {
    id: 'HadesEx Dark Current',
    type: 'StartsUsing',
    netRegex: {
      id: '47F1',
      source: 'Hades',
      capture: false
    },
    durationSeconds: 12,
    suppressSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Exoflares',
        de: 'Exa-Flares',
        fr: 'Exabrasiers',
        ja: 'ダークストリーム',
        cn: '地火',
        ko: '엑사플레어'
      }
    }
  }, {
    id: 'HadesEx Gigantomachy',
    type: 'StartsUsing',
    netRegex: {
      id: '47F3',
      source: 'Hades',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'HadesEx Quadrastrike 1',
    type: 'StartsUsing',
    netRegex: {
      id: '47F4',
      source: 'Hades',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'HadesEx Quadrastrike 2',
    type: 'StartsUsing',
    netRegex: {
      id: '47F6',
      source: 'Hades',
      capture: false
    },
    condition: data => data.role === 'tank' || data.role === 'healer' || data.job === 'BLU',
    suppressSeconds: 2,
    alarmText: (data, _matches, output) => {
      if (data.role === 'tank' || data.job === 'BLU') return output.getTowers();
    },
    infoText: (data, _matches, output) => {
      if (data.role === 'healer') return output.tankBusters();
    },
    outputStrings: {
      tankBusters: outputs/* default.tankBusters */.Z.tankBusters,
      getTowers: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Allez dans les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '기둥 들어가기'
      }
    }
  }, {
    id: 'HadesEx Quadrastrike 3',
    type: 'Ability',
    netRegex: {
      id: '47F6',
      source: 'Hades',
      capture: false
    },
    // After tanks take tower damage
    delaySeconds: 2,
    suppressSeconds: 2,
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'HadesEx Enrage Gigantomachy',
    type: 'StartsUsing',
    netRegex: {
      id: '47F9',
      source: 'Hades',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Enrage',
        de: 'Finalangriff',
        fr: 'Enrage',
        ja: '時間切れ',
        cn: '狂暴',
        ko: '전멸기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aetherial Gaol': 'Ätherkerker',
      'Arcane Font': 'Arkan(?:e|er|es|en) Körper',
      'Arcane Globe': 'Arkan(?:e|er|es|en) Kugel',
      'Ascian Prime\'s Shade': 'Schatten des Prim-Ascian',
      '(?<!\\w)Hades': 'Hades',
      '(?<! )Igeyorhm\'s Shade': 'Igeyorhms Schatten',
      'Lahabrea\'s Shade': 'Lahabreas Schatten',
      'Lahabrea\'s and Igeyorhm\'s Shades': 'Lahabrea und Igeyorhm',
      'Nabriales\'s Shade': 'Nabriales\' Schatten',
      'Shadow of the Ancients': 'Schatten der Alten'
    },
    'replaceText': {
      'Again The Abyssal Celebrant': 'Erinnerung an den Abgrund',
      'Again The Majestic': 'Erinnerung an den Erhabenen',
      'Again The Martyr': 'Erinnerung an die Märtyrer',
      'Ancient Circle': 'Orbis Antiquus',
      'Ancient Dark IV': 'Neka der Alten',
      'Ancient Darkness': 'Dunkelung der Alten',
      'Ancient Double': 'Doppelung der Alten',
      'Ancient Eruption': 'Antike Eruption',
      'Ancient Water III': 'Aquaga der Alten',
      'Annihilation': 'Annihilation',
      'Arcane Control': 'Beleben des Kreises',
      'Arcane Utterance': 'Zeichnen des Kreises',
      'Bad Faith': 'Maske des Grolls',
      'Blight': 'Pesthauch',
      'Blizzard IV': 'Eiska',
      'Blizzard Sphere': 'Eissphäre',
      'Broken Faith': 'Maske der Trauer',
      '(?<! )Captivity': 'Gefangenschaft',
      'Dark Current': 'Dunkel-Strom',
      'Dark Flame': 'Dunkel-Flamme',
      'Dark Freeze': 'Dunkel-Einfrieren',
      'Dark II': 'Negra',
      'Dark Seal': 'Dunkles Siegel',
      'Death Shriek': 'Todesschrei',
      'Fire IV': 'Feuka',
      'Fire Sphere': 'Feuersphäre',
      'Forked Lightning': 'Gabelblitz',
      'Gigantomachy': 'Gigantomachie',
      'Height Of Chaos': 'Klimax des Chaos',
      'Megiddo Flame': 'Megiddoflamme',
      'Nether Blast': 'Schattenausbruch',
      'Purgation': 'Schlag des Polydegmon',
      'Quake III': 'Seisga',
      'Ravenous Assault': 'Fegefeuer der Helden',
      'Shadow Flare': 'Schattenflamme',
      'Shadow Spread': 'Dunkle Schatten',
      'Stream': 'Schattenstrom',
      'Titanomachy': 'Titanomachie',
      'Universal Manipulation': 'Umwertung aller Werte',
      'Wail Of The Lost': 'Wehklagen der Verlorenen',
      'Comet': 'Komet',
      'Quadrastrike(?! [^0-9])': 'Quadraschlag',
      'Magic Chakram/Spear': 'Magisches Chakram/Speer',
      'Magic Spear/Chakram': 'Magischer Speer/Chakram',
      'Life In Captivity': 'Leben in Gefangenschaft',
      'Quadrastrike Tower': 'Quadraschlag Turm',
      'Quadrastrike Bleed': 'Quadraschlag Blutung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aetherial Gaol': 'Geôle Éthérée',
      'Arcane Font': 'Solide Arcanique',
      'Arcane Globe': 'Globe Arcanique',
      'Ascian Prime\'s Shade': 'Spectre de Primo-Ascien',
      '(?<!\\w)Hades': 'Hadès',
      '(?<! )Igeyorhm\'s Shade': 'Spectre d\'Igeyorhm',
      'Lahabrea\'s Shade': 'Spectre de Lahabrea',
      'Lahabrea\'s and Igeyorhm\'s Shades': 'Duo d\'Asciens',
      'Nabriales\'s Shade': 'Spectre de Nabriales',
      'Shadow of the Ancients': 'Spectre d\'Ascien'
    },
    'replaceText': {
      'Again The Abyssal Celebrant': 'Mémoire d\'un contemplateur de l\'abysse',
      'Again The Majestic': 'Mémoire d\'un souverain',
      'Again The Martyr': 'Mémoire d\'un martyre',
      'Ancient Circle': 'Cercle ancien',
      'Ancient Dark IV': 'Giga Ténèbres anciennes',
      'Ancient Darkness': 'Ténèbres anciennes',
      'Ancient Double': 'Double ancien',
      'Ancient Eruption': 'Éruption ancienne',
      'Ancient Water III': 'Méga Eau ancienne',
      'Annihilation': 'Annihilation',
      'Arcane Control': 'Activation arcanique',
      'Arcane Utterance': 'Énoncé arcanique',
      'Bad Faith': 'Mauvaise foi',
      'Blight': 'Supplice',
      'Blizzard IV': 'Giga Glace',
      'Blizzard Sphere': 'Sphère de glace',
      'Broken Faith': 'Foi brisée',
      '(?<! )Captivity': 'Captivité',
      'Dark Current': 'Flux sombre',
      'Dark Flame': 'Flamme ténébreuse',
      'Dark Freeze': 'Gel ténébreux',
      'Dark II': 'Extra Ténèbres',
      'Dark Seal': 'Sceau ténébreux',
      'Death Shriek': 'Hurlement fatal',
      'Fire IV': 'Giga Feu',
      'Fire Sphere': 'Sphère de feu',
      'Forked Lightning': 'Éclair ramifié',
      'Gigantomachy': 'Gigantomachie',
      'Height Of Chaos': 'Apogée du chaos',
      'Life In Captivity': 'Vie de captivité',
      'Magic Chakram/Spear': 'Chakram/Lance magique',
      'Magic Spear/Chakram': 'Lance/Chakram magique',
      'Megiddo Flame': 'Flamme de Megiddo',
      'Nether Blast': 'Détonation infernale',
      'Purgation': 'Assaut du Polydegmon',
      'Quake III': 'Méga Séisme',
      'Ravenous Assault': 'Assaut acharné',
      'Shadow Flare': 'Éruption ténébreuse',
      'Shadow Spread': 'Diffusion d\'ombre',
      'Stream': 'Flux de Ténèbres',
      'Titanomachy': 'Titanomachie',
      'Universal Manipulation': 'Manipulation universelle',
      'Wail Of The Lost': 'Lamentation des disparus',
      'Comet': 'Comète',
      'Quadrastrike(?! [^0-9])': 'Frappe quadruplée',
      'Quadrastrike Bleed': 'Frappe quadruplée Saignement',
      'Quadrastrike Tower': 'Frappe quadruplée Tour'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Arcane Font': '立体魔法陣',
      'Arcane Globe': '球体魔法陣',
      'Ascian Prime\'s Shade': 'アシエン・プライムの影',
      '(?<!\\w)Hades': 'ハーデス',
      '(?<! )Igeyorhm\'s Shade': 'イゲオルムの影',
      'Lahabrea\'s Shade': 'ラハブレアの影',
      'Lahabrea\'s and Igeyorhm\'s Shades': 'ラハブレアとイゲオルム',
      'Nabriales\'s Shade': 'ナプリアレスの影',
      'Shadow of the Ancients': '古代人の影',
      'Aetherial Gaol': 'エーテリアル・ジェイル'
    },
    'replaceText': {
      'Again The Abyssal Celebrant': '深淵の記憶',
      'Again The Majestic': '尊厳王の記憶',
      'Again The Martyr': '殉教者の記憶',
      'Ancient Circle': 'エンシェントリング',
      'Ancient Dark IV': 'エンシェントダージャ',
      'Ancient Darkness': 'エンシェントダーク',
      'Ancient Double': 'エンシェントダブル',
      'Ancient Eruption': 'エンシェントエラプション',
      'Ancient Water III': 'エンシェントウォタガ',
      'Annihilation': 'アナイアレイション',
      'Arcane Control': '魔法陣起動',
      'Arcane Utterance': '魔法陣記述',
      'Bad Faith': 'バッドフェイス',
      'Blight': 'クラウダ',
      'Blizzard IV': 'ブリザジャ',
      'Blizzard Sphere': 'ブリザードスフィア',
      'Broken Faith': 'ブロークンフェイス',
      '(?<! )Captivity': 'キャプティビティ',
      'Dark Current': 'ダークストリーム',
      'Dark Flame': 'ダークフレイム',
      'Dark Freeze': 'ダークフリーズ',
      'Dark II': 'ダーラ',
      'Dark Seal': 'ダークシール',
      'Death Shriek': 'デスシュリーク',
      'Fire IV': 'ファイジャ',
      'Fire Sphere': 'ファイアスフィア',
      'Forked Lightning': 'フォークライトニング',
      'Gigantomachy': 'ギガントマキア',
      'Height Of Chaos': 'ハイト・オブ・カオス',
      'Life In Captivity': 'ライフ・オブ・キャプティビティ',
      'Magic Chakram/Spear': 'マジックチャクラム／マジックスピア',
      'Magic Spear/Chakram': 'マジックスピア／マジックチャクラム',
      'Megiddo Flame': 'メギドフレイム',
      'Nether Blast': 'ネザーブラスト',
      'Purgation': 'ポリデグモンストライク',
      'Quake III': 'クエイガ',
      'Ravenous Assault': 'ラヴェナスアサルト',
      'Shadow Flare': 'シャドウフレア',
      'Shadow Spread': 'シャドウスプレッド',
      'Stream': 'シャドウストリーム',
      'Titanomachy': 'ティタノマキア',
      'Universal Manipulation': '法則改変',
      'Wail Of The Lost': 'ウエイル・オブ・ザ・ロスト',
      'Comet': 'コメット',
      'Quadrastrike(?! [^0-9])': 'クアドラストライク',
      'Quadrastrike Tower': 'クアドラストライク：塔',
      'Quadrastrike Bleed': 'クアドラストライク：ペイン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aetherial Gaol': '以太牢狱',
      'Arcane Font': '立体魔法阵',
      'Arcane Globe': '球体魔法阵',
      'Ascian Prime\'s Shade': '至尊无影之影',
      '(?<!\\w)Hades': '哈迪斯',
      '(?<! )Igeyorhm\'s Shade': '以格约姆之影',
      'Lahabrea\'s Shade': '拉哈布雷亚之影',
      'Lahabrea\'s and Igeyorhm\'s Shades': '拉哈布雷亚与以格约姆之影',
      'Nabriales\'s Shade': '那布里亚勒斯之影',
      'Shadow of the Ancients': '古代人之影'
    },
    'replaceText': {
      'Again The Abyssal Celebrant': '深渊祭司的记忆',
      'Again The Majestic': '尊严王的记忆',
      'Again The Martyr': '殉教者的记忆',
      'Ancient Circle': '古代圆环',
      'Ancient Dark IV': '古代冥暗',
      'Ancient Darkness': '古代黑暗',
      'Ancient Double': '古代双重',
      'Ancient Eruption': '古火喷发',
      'Ancient Water III': '古代狂水',
      'Annihilation': '湮灭',
      'Arcane Control': '魔法阵启动',
      'Arcane Utterance': '魔法阵记述',
      'Bad Faith': '失信',
      'Blight': '毒雾',
      'Blizzard IV': '冰澈柱',
      'Blizzard Sphere': '冰结球',
      'Broken Faith': '背信',
      'Life In Captivity': '囚禁生命',
      '(?<! )Captivity': '囚禁',
      'Dark Current': '黑暗奔流',
      'Dark Flame': '暗黑之炎',
      'Dark Freeze': '黑暗玄冰',
      'Dark II': '昏暗',
      'Dark Seal': '黑暗咒印',
      'Death Shriek': '死亡尖叫',
      'Fire IV': '炽炎',
      'Fire Sphere': '火炎球',
      'Forked Lightning': '叉形闪电',
      'Gigantomachy': '巨人之战',
      'Height Of Chaos': '混沌之巅',
      'Magic Chakram/Spear': '魔法轮/矛',
      'Magic Spear/Chakram': '魔法矛/轮',
      'Megiddo Flame': '米吉多烈焰',
      'Nether Blast': '幽冥冲击',
      'Purgation': '冥王净化',
      'Quake III': '爆震',
      'Ravenous Assault': '贪婪突袭',
      'Shadow Flare': '暗影核爆',
      'Shadow Spread': '暗影扩散',
      'Stream': '暗影流',
      'Titanomachy': '诸神之战',
      'Universal Manipulation': '法则变更',
      'Wail Of The Lost': '逝者的哀嚎',
      'Comet': '彗星',
      'Quadrastrike Tower': '四重强袭 塔',
      'Quadrastrike Bleed': '四重强袭 流血',
      'Quadrastrike(?! [^0-9])': '四重强袭'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aetherial Gaol': '에테르 감옥',
      'Arcane Font': '입체 마법진',
      'Arcane Globe': '구체 마법진',
      'Ascian Prime\'s Shade': '아씨엔 프라임의 그림자',
      '(?<!\\w)Hades': '하데스',
      '(?<! )Igeyorhm\'s Shade': '이게요름의 그림자',
      'Lahabrea\'s Shade': '라하브레아의 그림자',
      'Lahabrea\'s and Igeyorhm\'s Shades': '라하브레아와 이게요름',
      'Nabriales\'s Shade': '나브리알레스의 그림자',
      'Shadow of the Ancients': '고대인의 그림자'
    },
    'replaceText': {
      'Again The Abyssal Celebrant': '심연의 기억',
      'Again The Majestic': '존엄왕의 기억',
      'Again The Martyr': '순교자의 기억',
      'Ancient Circle': '고대의 고리',
      'Ancient Dark IV': '에인션트 다쟈',
      'Ancient Darkness': '에인션트 다크',
      'Ancient Double': '고대의 이중 공격',
      'Ancient Eruption': '고대의 불기둥',
      'Ancient Water III': '에인션트 워터가',
      'Annihilation': '멸절',
      'Arcane Control': '마법진 기동',
      'Arcane Utterance': '마법진 전개',
      'Bad Faith': '불신',
      'Blight': '좀먹힌 우울',
      'Blizzard IV': '블리자쟈',
      'Blizzard Sphere': '눈보라 구체',
      'Broken Faith': '배신',
      '(?<! )Captivity': '감금',
      'Dark Current': '어둠의 급류',
      'Dark Flame': '다크 플레임',
      'Dark Freeze': '다크 프리즈',
      'Dark II': '다라',
      'Dark Seal': '어둠의 봉인',
      'Death Shriek': '죽음의 비명',
      'Fire IV': '파이쟈',
      'Fire Sphere': '불의 구체',
      'Forked Lightning': '갈래 번개',
      'Gigantomachy': '기간토마키아',
      'Height Of Chaos': '혼돈의 정점',
      'Life In Captivity': '감금된 삶',
      'Magic Chakram/Spear': '마법 차크람/창',
      'Magic Spear/Chakram': '마법 창/차크람',
      'Megiddo Flame': '메기도 플레임',
      'Nether Blast': '지옥 강풍',
      'Purgation': '폴리데그몬',
      'Quake III': '퀘이가',
      'Ravenous Assault': '탐욕스러운 공격',
      'Shadow Flare': '섀도우 플레어',
      'Shadow Spread': '그림자 확산',
      'Stream': '그림자 급류',
      'Titanomachy': '티타노마키아',
      'Universal Manipulation': '법칙 변조',
      'Wail Of The Lost': '상실의 통곡',
      'Comet': '혜성',
      'Quadrastrike Tower': '사분격 기둥',
      'Quadrastrike Bleed': '사분격 출혈',
      'Quadrastrike(?! [^0-9])': '사분격'
    }
  }]
};
/* harmony default export */ const hades_ex = (hades_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/hades-ex.txt
const trial_hades_ex_namespaceObject = "### Hades Ex\r\n# https://clees.me/guides/hades-ex/\r\n# -p 47A5:10.7 4951:238 47C8:510 47D5:804 4948:1204 -ii 47AC 47AB 47B2 47FA 47FB 47A8 481D 47CF 47F1 47EE 47D3 47F2 47EC 47ED 417C 47D7 47E6 47D9 47D8 47DA 47E7 47DC 494B 47CE 474B 47E3\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n6.6 \"--sync--\" StartsUsing { id: \"47A5\", source: \"Hades\" } window 10,10\r\n9.6 \"Ancient Double\" Ability { id: \"47A5\", source: \"Hades\" }\r\n18.7 \"Shadow Spread 1\" Ability { id: \"47A9\", source: \"Hades\" }\r\n21.7 \"Shadow Spread 2\" Ability { id: \"47AA\", source: \"Hades\" }\r\n29.6 \"Bad Faith 1\" Ability { id: [\"47AE\", \"47AD\"], source: \"Hades\" }\r\n32.7 \"Bad Faith 2\" Ability { id: [\"47AF\", \"47B0\"], source: \"Hades\" }\r\n40.9 \"Ravenous Assault 1\" Ability { id: \"47A6\", source: \"Hades\" }\r\n44.1 \"Ravenous Assault 2\" Ability { id: \"47A7\", source: \"Hades\" }\r\n50.2 \"Arcane Utterance\" Ability { id: \"47B3\", source: \"Hades\" }\r\n58.3 \"Arcane Control\" Ability { id: \"47B4\", source: \"Hades\" }\r\n59.2 \"Magic Chakram/Spear\" #Ability { id: \"47B5\", source: \"Arcane Globe\" }\r\n67.4 \"Broken Faith\" Ability { id: \"47B1\", source: \"Hades\" } duration 35.3\r\n106.7 \"Arcane Utterance\" Ability { id: \"47B3\", source: \"Hades\" }\r\n114.8 \"Arcane Control\" Ability { id: \"47B4\", source: \"Hades\" }\r\n115.7 \"Magic Spear/Chakram\" #Ability { id: \"47B6\", source: \"Arcane Font\" }\r\n128.9 \"Shadow Spread 1\" Ability { id: \"47A9\", source: \"Hades\" }\r\n131.9 \"Shadow Spread 2\" Ability { id: \"47AA\", source: \"Hades\" }\r\n139.8 \"Bad Faith 1\" Ability { id: [\"47AE\", \"47AD\"], source: \"Hades\" }\r\n142.9 \"Bad Faith 2\" Ability { id: [\"47AF\", \"47B0\"], source: \"Hades\" }\r\n151.1 \"Ravenous Assault 1\" Ability { id: \"47A6\", source: \"Hades\" }\r\n154.3 \"Ravenous Assault 2\" Ability { id: \"47A7\", source: \"Hades\" }\r\n168.6 \"Ancient Dark IV\" Ability { id: \"47B7\", source: \"Hades\" }\r\n\r\n\r\n### Phase 2\r\n200.0 \"--sync--\" NameToggle { name: \"Hades\", toggle: \"00\" } window 200,0\r\n# 00:0044:Hades:Pitiful, malformed, wretched creatures!\r\n# 00:0044:Hades:Your call for aid beyond this world will avail you naught!\r\n# 00:0044:Hades:My brethren are legion!\r\n# 00:0044:Hades:Let shadows form from my will alone!\r\n# 00:0044:Hades:Come, Nabriales!\r\n# 00:0044:Hades:Tremble and fall to the ground before me!\r\n227.9 \"--targetable--\"\r\n232.0 \"--sync--\" StartsUsing { id: \"47B8\", source: \"Nabriales's Shade\" } window 232,0\r\n238.0 \"Comet 1\" #Ability { id: \"4951\", source: \"Nabriales's Shade\" }\r\n241.0 \"Comet 2\" #Ability { id: \"4951\", source: \"Nabriales's Shade\" }\r\n241.2 \"Dark II\" Ability { id: \"47BA\", source: \"Shadow of the Ancients\" }\r\n243.9 \"Comet 3\" #Ability { id: \"4951\", source: \"Nabriales's Shade\" }\r\n246.9 \"Comet 4\" #Ability { id: \"4951\", source: \"Nabriales's Shade\" }\r\n254.2 \"Ancient Water III\" Ability { id: \"47BC\", source: \"Shadow of the Ancients\" }\r\n254.2 \"Ancient Darkness\" Ability { id: \"47BB\", source: \"Shadow of the Ancients\" }\r\n259.7 \"Quake III\" Ability { id: \"47B8\", source: \"Nabriales's Shade\" }\r\n# 00:0044:Hades:Emerge, Lahabrea! Rise, Igeyorhm!\r\n272.3 \"--targetable--\"\r\n277.5 \"Annihilation\" Ability { id: \"47BF\", source: \"Lahabrea's and Igeyorhm's Shades\" } window 50,10\r\n277.5 \"Fire Sphere\" #Ability { id: \"47BE\", source: \"Lahabrea's Shade\" }\r\n277.5 \"Blizzard Sphere\" #Ability { id: \"47BD\", source: \"Igeyorhm's Shade\" }\r\n295.6 \"Fire IV\" Ability { id: \"47C2\", source: \"Lahabrea's Shade\" }\r\n295.6 \"Blizzard IV\" #Ability { id: \"47C3\", source: \"Igeyorhm's Shade\" }\r\n299.5 \"Dark Flame\" Ability { id: \"47C6\", source: \"Shadow of the Ancients\" }\r\n299.5 \"Dark Freeze\" #Ability { id: \"47C4\", source: \"Shadow of the Ancients\" }\r\n307.6 \"Annihilation\" Ability { id: \"47BF\", source: \"Lahabrea's and Igeyorhm's Shades\" }\r\n307.6 \"Fire Sphere\" #Ability { id: \"47BE\", source: \"Lahabrea's Shade\" }\r\n307.6 \"Blizzard Sphere\" #Ability { id: \"47BD\", source: \"Igeyorhm's Shade\" }\r\n320.8 \"Fire IV\" Ability { id: \"47C2\", source: \"Lahabrea's Shade\" }\r\n320.8 \"Blizzard IV\" Ability { id: \"47C3\", source: \"Igeyorhm's Shade\" }\r\n336.6 \"Fire IV\" Ability { id: \"47C2\", source: \"Lahabrea's Shade\" }\r\n336.6 \"Blizzard IV\" Ability { id: \"47C3\", source: \"Igeyorhm's Shade\" }\r\n355.2 \"Shadow Flare\" #Ability { id: \"47FD\", source: \"Lahabrea's Shade\" }\r\n\r\n\r\n### Phase 3\r\n# https://xivapi.com/InstanceContentTextData/23311\r\n# en: Our plea transcends the very boundaries of the soul!\r\n493.0 \"--sync--\" BattleTalk2 { instanceContentTextId: \"5B0F\" } window 500,0\r\n# 00:0044:Hades:At last, you are one!\r\n499.9 \"--targetable--\"\r\n500.0 \"--sync--\" StartsUsing { id: \"47C8\", source: \"Ascian Prime's Shade\" } window 500,0\r\n510.0 \"Universal Manipulation\" Ability { id: \"47C8\", source: \"Ascian Prime's Shade\" }\r\n520.2 \"Ancient Circle\" Ability { id: \"47CA\", source: \"Ascian Prime's Shade\" }\r\n522.2 \"Death Shriek\" Ability { id: \"47CB\", source: \"Ascian Prime's Shade\" }\r\n524.2 \"Forked Lightning\" Ability { id: \"47C9\", source: \"Ascian Prime's Shade\" }\r\n531.2 \"Blight\" Ability { id: \"47CC\", source: \"Ascian Prime's Shade\" }\r\n542.6 \"Height Of Chaos\" Ability { id: \"47D1\", source: \"Ascian Prime's Shade\" }\r\n552.8 \"Megiddo Flame\" Ability { id: \"47CD\", source: \"Ascian Prime's Shade\" }\r\n561.9 \"Shadow Flare\" Ability { id: \"47D0\", source: \"Ascian Prime's Shade\" }\r\n569.4 \"Ancient Eruption\" Ability { id: \"47D2\", source: \"Ascian Prime's Shade\" }\r\n580.8 \"Shadow Flare\" Ability { id: \"47D0\", source: \"Ascian Prime's Shade\" }\r\n609.3 \"Shadow Flare Enrage\" Ability { id: \"47D4\", source: \"Ascian Prime's Shade\" }\r\n\r\n\r\n### Phase 4\r\n750.2 \"--sync--\" NameToggle { name: \"Ascian Prime's Shade\", toggle: \"00\" } window 800,0\r\n799.9 \"--targetable--\"\r\n800.0 \"--sync--\" StartsUsing { id: \"47D5\", source: \"Hades\" } window 800,0\r\n804.0 \"Again The Majestic\" Ability { id: \"47D5\", source: \"Hades\" }\r\n810.6 \"Comet 1\" Ability { id: \"4952\", source: \"Hades\" }\r\n812.2 \"Captivity\" Ability { id: \"47D[67]\", source: \"Hades\" }\r\n816.6 \"Comet 2\" Ability { id: \"4952\", source: \"Hades\" }\r\n822.6 \"Comet 3\" Ability { id: \"4952\", source: \"Hades\" }\r\n828.6 \"Comet 4\" Ability { id: \"4952\", source: \"Hades\" }\r\n837.2 \"Again The Martyr\" Ability { id: \"47DE\", source: \"Hades\" }\r\n846.3 \"Wail Of The Lost\" Ability { id: \"47E1\", source: \"Hades\" }\r\n848.4 \"Dark Flame\" Ability { id: \"47E0\", source: \"Hades\" }\r\n848.4 \"Dark Freeze\" Ability { id: \"47DF\", source: \"Hades\" }\r\n856.5 \"Again The Abyssal Celebrant\" Ability { id: \"47E2\", source: \"Hades\" }\r\n864.6 \"Shadow Spread x3\" #Ability { id: \"47E4\", source: \"Hades\" }\r\n865.6 \"Megiddo Flame x3\" #Ability { id: \"47E8\", source: \"Hades\" }\r\n865.6 \"Nether Blast x3\" #Ability { id: \"47E6\", source: \"Hades\" }\r\n876.7 \"Dark Seal\" Ability { id: \"47E9\", source: \"Hades\" }\r\n884.8 \"Purgation/Stream\" Ability { id: \"47E[AB]\", source: \"Hades\" }\r\n892.9 \"Stream/Purgation\" Ability { id: \"47E[AB]\", source: \"Hades\" }\r\n904.1 \"Dark Seal\" Ability { id: \"47E9\", source: \"Hades\" }\r\n912.2 \"Purgation/Stream\" Ability { id: \"47E[AB]\", source: \"Hades\" }\r\n918.3 \"Stream/Purgation\" Ability { id: \"47E[AB]\", source: \"Hades\" }\r\n950.2 \"Titanomachy Enrage\" Ability { id: \"47EF\", source: \"Hades\" }\r\n\r\n\r\n### Phase 5\r\n1200.0 \"--sync--\" StartsUsing { id: \"4948\", source: \"Hades\" } window 1200,0\r\n1204.0 \"Life In Captivity\" Ability { id: \"4948\", source: \"Hades\" }\r\n1207.2 \"--sync--\" Ability { id: \"47D9\", source: \"Hades\" }\r\n1210.2 \"--sync--\" Ability { id: \"4949\", source: \"Hades\" }\r\n1242.3 \"--sync--\" Ability { id: \"494A\", source: \"Hades\" }\r\n1282.4 \"--targetable--\"\r\n1286.6 \"Dark Current\" Ability { id: \"47F0\", source: \"Hades\" }\r\n1311.2 \"Gigantomachy\" Ability { id: \"47F3\", source: \"Hades\" }\r\n1318.4 \"--sync--\" Ability { id: \"47F4\", source: \"Hades\" }\r\n1318.8 \"Quadrastrike 1\" #Ability { id: \"47F5\", source: \"Hades\" }\r\n1320.2 \"Quadrastrike 2\" #Ability { id: \"47F5\", source: \"Hades\" }\r\n1323.8 \"Quadrastrike Tower\" Ability { id: \"47F6\", source: \"Hades\" }\r\n1330.6 \"Quadrastrike Bleed\" Ability { id: \"47F8\", source: \"Hades\" }\r\n1344.5 \"Dark Current\" Ability { id: \"47F0\", source: \"Hades\" }\r\n1369.0 \"Gigantomachy\" Ability { id: \"47F3\", source: \"Hades\" }\r\n1376.2 \"--sync--\" Ability { id: \"47F4\", source: \"Hades\" }\r\n1376.6 \"Quadrastrike 1\" #Ability { id: \"47F5\", source: \"Hades\" }\r\n1378.0 \"Quadrastrike 2\" #Ability { id: \"47F5\", source: \"Hades\" }\r\n1381.7 \"Quadrastrike Tower\" Ability { id: \"47F6\", source: \"Hades\" }\r\n1388.5 \"Quadrastrike Bleed\" Ability { id: \"47F8\", source: \"Hades\" }\r\n1426.5 \"Gigantomachy Enrage\" Ability { id: \"47F9\", source: \"Hades\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/hades.ts




const hades_triggerSet = {
  id: 'TheDyingGasp',
  zoneId: zone_id/* default.TheDyingGasp */.Z.TheDyingGasp,
  timelineFile: 'hades.txt',
  triggers: [{
    id: 'Hades Phase Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: '4180',
      source: 'Hades',
      capture: false
    },
    run: data => data.neoHades = true
  }, {
    id: 'Hades Ravenous Assault',
    type: 'StartsUsing',
    netRegex: {
      id: '4158',
      source: 'Hades'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.tankBusterOnYou();
      if (data.role === 'healer') return output.busterOn({
        player: data.party.member(matches.target)
      });
    },
    infoText: (data, matches, output) => {
      if (matches.target === data.me) return;
      return output.awayFromPlayer({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      awayFromPlayer: {
        en: 'Away From ${player}',
        de: 'Weg von ${player}',
        fr: 'Éloignez-vous de ${player}',
        ja: '${player} から離れる',
        cn: '远离 ${player}',
        ko: '${player} 한테서 피하세요'
      },
      tankBusterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
      busterOn: outputs/* default.tankBusterOnPlayer */.Z.tankBusterOnPlayer
    }
  }, {
    id: 'Hades Bad Faith Left',
    type: 'StartsUsing',
    netRegex: {
      id: '4149',
      source: 'Hades',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft('info')
  }, {
    id: 'Hades Bad Faith Right',
    type: 'StartsUsing',
    netRegex: {
      id: '414A',
      source: 'Hades',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight('info')
  }, {
    id: 'Hades Broken Faith',
    type: 'StartsUsing',
    netRegex: {
      id: '414D',
      source: 'Hades',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge Giant Circles',
        de: 'Weiche dem großen Kreis aus',
        fr: 'Esquivez les cercles géants',
        ja: '降ったサークルを避ける',
        cn: '躲避大圈',
        ko: '대형장판피하기'
      }
    }
  }, {
    id: 'Hades Echo Right',
    type: 'StartsUsing',
    netRegex: {
      id: '4164',
      source: 'Hades',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight('info')
  }, {
    id: 'Hades Echo Left',
    type: 'StartsUsing',
    netRegex: {
      id: '4163',
      source: 'Hades',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft('info')
  }, {
    id: 'Hades Titanomachy',
    type: 'StartsUsing',
    netRegex: {
      id: '4180',
      source: 'Hades',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hades Shadow Stream',
    type: 'StartsUsing',
    netRegex: {
      id: '415C',
      source: 'Hades',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'Hades Purgation',
    type: 'StartsUsing',
    netRegex: {
      id: '4170',
      source: 'Hades',
      capture: false
    },
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'Hades Doom',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D2'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse Doom In Circle',
        de: 'Entferne Verhängnis mit den Kreisen',
        fr: 'Purifiez-vous du Glas dans le cercle',
        ja: '光った輪を踏む、死の宣告を消す',
        cn: '踩光圈',
        ko: '모든 장판을 밟으세요'
      }
    }
  }, {
    id: 'Hades Wail of the Lost Right',
    type: 'StartsUsing',
    netRegex: {
      id: '4166',
      source: 'Hades',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Right Knockback',
        de: 'Rechter Knockback',
        fr: 'Poussée à droite',
        ja: '東／右からノックバック',
        cn: '右侧击退',
        ko: '오른쪽 넉백'
      }
    }
  }, {
    id: 'Hades Wail of the Lost Left',
    type: 'StartsUsing',
    netRegex: {
      id: '4165',
      source: 'Hades',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Left Knockback',
        de: 'Linker Knockback',
        fr: 'Poussée à gauche',
        ja: '西／左からノックバック',
        cn: '左侧击退',
        ko: '왼쪽 넉백'
      }
    }
  }, {
    id: 'Hades Dual Strike Healer',
    type: 'StartsUsing',
    netRegex: {
      id: '4161',
      source: 'Hades',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.tankBusters */.Z.tankBusters
    }
  }, {
    id: 'Hades Dual Strike',
    type: 'HeadMarker',
    netRegex: {
      id: '0060'
    },
    condition: (data, matches) => data.neoHades && data.me === matches.target,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank Buster Spread',
        de: 'Tank Buster verteilen',
        fr: 'Tank buster, dispersez-vous',
        ja: 'タンクバスター、散開',
        cn: '坦克死刑分散',
        ko: '탱버 산개'
      }
    }
  }, {
    id: 'Hades Hellborn Yawp',
    type: 'HeadMarker',
    netRegex: {
      id: '0028'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Marker Outside',
        de: 'Marker außen ablegen',
        fr: 'Déposez la marque à l\'extérieur',
        ja: '外周に安置',
        cn: '外侧放点名',
        ko: '외곽으로'
      }
    }
  }, {
    id: 'Hades Fetters',
    type: 'HeadMarker',
    netRegex: {
      id: '0078'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fetters on YOU',
        de: 'Fessel auf DIR',
        fr: 'Entraves sur VOUS',
        ja: '自分に拘束',
        cn: '锁链点名',
        ko: '선 대상자'
      }
    }
  }, {
    id: 'Hades Life In Captivity',
    type: 'Ability',
    netRegex: {
      id: '4175',
      source: 'Hades',
      capture: false
    },
    run: data => data.seenLifeInCaptivity = true
  }, {
    id: 'Hades Gaol',
    type: 'Ability',
    netRegex: {
      id: '417F',
      source: 'Hades',
      capture: false
    },
    condition: data => {
      // There can be multiple gaols (if the phase loops), but ability also
      // gets used during the finall phase transition.  Ignore that one.
      return !data.seenLifeInCaptivity;
    },
    delaySeconds: 2,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Jail',
        de: 'Gefängniss zerstören',
        fr: 'Détruisez la prison',
        ja: 'ジェイルに攻撃',
        cn: '攻击牢狱',
        ko: '감옥'
      }
    }
  }, {
    id: 'Hades Nether Blast / Dark Eruption',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'Hades Ancient Darkness',
    type: 'HeadMarker',
    netRegex: {
      id: '0060'
    },
    condition: (data, matches) => !data.neoHades && data.me === matches.target,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread (Don\'t Stack!)',
        de: 'Verteilen (Ohne stacken)',
        fr: 'Dispersez-vous (Pas de package !)',
        ja: '散開（重ならないように）',
        cn: '分散（不要重合!）',
        ko: '산개（모이지마세요!）'
      }
    }
  }, {
    id: 'Hades Ancient Water III',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Hades Ancient Collect',
    type: 'HeadMarker',
    netRegex: {
      id: ['0060', '003E']
    },
    condition: data => !data.neoHades,
    run: (data, matches) => {
      data.ancient ??= {};
      data.ancient[matches.target] = matches.id;
    }
  }, {
    id: 'Hades Ancient No Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '003E',
      capture: false
    },
    delaySeconds: 0.5,
    infoText: (data, _matches, output) => {
      if (!data.ancient || data.ancient[data.me] === undefined) return;
      const name = Object.keys(data.ancient).find(key => data.ancient?.[key] === '003E');
      return output.text({
        player: data.party.member(name)
      });
    },
    outputStrings: {
      text: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'Hades Ancient Cleanup',
    type: 'HeadMarker',
    netRegex: {
      id: '003E',
      capture: false
    },
    delaySeconds: 10,
    run: data => delete data.ancient
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Hades': 'Hades',
      'Shadow .f .he Ancients': 'Schatten der Alten'
    },
    'replaceText': {
      'Adds': 'Adds',
      'Gaol Add': 'Gefängniss Add',
      'Ancient Aero': 'Wind der Alten',
      'Ancient Dark IV': 'Neka der Alten',
      'Ancient Darkness': 'Dunkelung der Alten',
      'Ancient Water III': 'Aquaga der Alten',
      'Bad Faith': 'Maske des Grolls',
      'Black Cauldron': 'Schwarzer Kessel',
      'Broken Faith': 'Maske der Trauer',
      '(?<! )Captivity': 'Gefangenschaft',
      'Chorus Of The Lost': 'Chor der Verlorenen',
      'Dark Eruption': 'Dunkle Eruption',
      'Doom': 'Verhängnis',
      'Double': 'Doppel',
      'Dual Strike': 'Doppelschlag',
      'Echo Of The Lost': 'Echo der Verlorenen',
      'Hellborn Yawp': 'Höllenschrei',
      'Life In Captivity': 'Leben in Gefangenschaft',
      'Nether Blast': 'Schattenausbruch',
      'Polydegmon\'s Purgation': 'Schlag des Polydegmon',
      'Ravenous Assault': 'Fegefeuer der Helden',
      'Shadow Spread': 'Dunkle Schatten',
      'Shadow Stream': 'Schattenstrom',
      'Stream/Purgation?': 'Schattenstrom/Schlag des Polydegmon',
      'The Dark Devours': 'Fressende Finsternis',
      'Titanomachy': 'Titanomachie',
      '--fetters--': '--fesseln--',
      'Wail Of The Lost': 'Wehklagen der Verlorenen'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Hades': 'Hadès',
      'Shadow .f .he Ancients': 'Spectre d\'Ascien'
    },
    'replaceText': {
      '--fetters--': '--entraves--',
      'Adds': 'Adds',
      'Ancient Aero': 'Vent ancien',
      'Ancient Dark IV': 'Giga Ténèbres anciennes',
      'Ancient Darkness': 'Ténèbres anciennes',
      'Ancient Water III': 'Méga Eau ancienne',
      'Bad Faith': 'Mauvaise foi',
      'Black Cauldron': 'Chaudron noir',
      'Broken Faith': 'Foi brisée',
      '(?<! )Captivity': 'Captivité',
      'Chorus Of The Lost': 'Refrain des disparus',
      'Dark Eruption': 'Éruption ténébreuse',
      'Doom': 'Glas',
      'Double': 'Double',
      'Dual Strike': 'Frappe redoublée',
      'Echo Of The Lost': 'Écho des disparus',
      'Gaol Add': 'Add Geôle',
      'Hellborn Yawp': 'Braillement infernal',
      'Life In Captivity': 'Vie de captivité',
      'Nether Blast': 'Détonation infernale',
      'Polydegmon\'s Purgation': 'Assaut du Polydegmon',
      'Ravenous Assault': 'Assaut acharné',
      'Shadow Spread': 'Diffusion d\'ombre',
      'Shadow Stream': 'Flux de Ténèbres',
      'Stream/Purgation\\?': 'Flux/Assaut ?',
      'The Dark Devours': 'Ténèbres rongeuses',
      'Titanomachy': 'Titanomachie',
      'Wail Of The Lost': 'Lamentation des disparus'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Hades': 'ハーデス',
      'Shadow .f .he Ancients': '古代人の影'
    },
    'replaceText': {
      'Adds': '雑魚',
      'Gaol Add': 'エーテリアル・ジェイル',
      'Ancient Aero': 'エンシェントエアロ',
      'Ancient Dark IV': 'エンシェントダージャ',
      'Ancient Darkness': 'エンシェントダーク',
      'Ancient Water III': 'エンシェントウォタガ',
      'Bad Faith': 'バッドフェイス',
      'Black Cauldron': 'ブラック・コルドロン',
      'Broken Faith': 'ブロークンフェイス',
      '(?<! )Captivity': 'キャプティビティ',
      'Chorus Of The Lost': 'コーラス・オブ・ザ・ロスト',
      'Dark Eruption': 'ダークエラプション',
      'Doom': '死の宣告',
      'Double': 'ダブル',
      'Dual Strike': 'デュアルストライク',
      'Echo Of The Lost': 'エコー・オブ・ザ・ロスト',
      'Hellborn Yawp': 'ヘルボーンヨープ',
      'Life In Captivity': 'ライフ・オブ・キャプティビティ',
      'Nether Blast': 'ネザーブラスト',
      'Polydegmon\'s Purgation': 'ポリデグモンストライク',
      'Ravenous Assault': 'ラヴェナスアサルト',
      'Shadow Spread': 'シャドウスプレッド',
      'Shadow Stream': 'シャドウストリーム',
      'Stream/Purgation?': 'シャドウストリーム／ポリデグモンストライク？',
      'The Dark Devours': '闇の侵食',
      'Titanomachy': 'ティタノマキア',
      '--fetters--': '--拘束--',
      'Wail Of The Lost': 'ウエイル・オブ・ザ・ロスト'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Hades': '哈迪斯',
      'Shadow .f .he Ancients': '古代人之影'
    },
    'replaceText': {
      'Adds': '小怪',
      'Gaol Add': '监狱',
      'Ancient Aero': '古代疾风',
      'Ancient Dark IV': '古代冥暗',
      'Ancient Darkness': '古代黑暗',
      'Ancient Water III': '古代狂水',
      'Bad Faith': '失信',
      'Black Cauldron': '暗黑之釜',
      'Broken Faith': '背信',
      '(?<! )Captivity': '囚禁',
      'Chorus Of The Lost': '逝者的合唱',
      'Dark Eruption': '暗炎喷发',
      'Doom': '死亡宣告',
      'Double': '双重',
      'Dual Strike': '双重强袭',
      'Echo Of The Lost': '逝者的回声',
      'Hellborn Yawp': '地狱之声',
      'Life In Captivity': '囚禁生命',
      'Nether Blast': '幽冥冲击',
      'Polydegmon\'s Purgation': '冥王净化',
      'Ravenous Assault': '贪婪突袭',
      'Shadow Spread': '暗影扩散',
      'Shadow Stream': '暗影流',
      'Stream/Purgation?': '暗影流/冥王净化',
      'The Dark Devours': '黑暗侵蚀',
      'Titanomachy': '诸神之战',
      '--fetters--': '--锁链--',
      'Wail Of The Lost': '逝者的哀嚎'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Hades': '하데스',
      'Shadow .f .he Ancients': '고대인의 그림자'
    },
    'replaceText': {
      'Adds': '쫄',
      'Gaol Add': '감옥',
      'Ancient Aero': '에인션트 에어로',
      'Ancient Dark IV': '에인션트 다쟈',
      'Ancient Darkness': '에인션트 다크',
      'Ancient Water III': '에인션트 워터가',
      'Bad Faith': '불신',
      'Black Cauldron': '검은 도가니',
      'Broken Faith': '배신',
      '(?<! )Captivity': '감금',
      'Chorus Of The Lost': '상실의 합창',
      'Dark Eruption': '황천의 불기둥',
      'Doom': '죽음의 선고',
      'Double': '이중 공격',
      'Dual Strike': '이중 타격',
      'Echo Of The Lost': '상실의 메아리',
      'Hellborn Yawp': '지옥의 아우성',
      'Life In Captivity': '감금된 삶',
      'Nether Blast': '지옥 강풍',
      'Polydegmon\'s Purgation': '폴리데그몬',
      'Ravenous Assault': '탐욕스러운 공격',
      'Shadow Spread': '그림자 전개',
      'Shadow Stream': '그림자 급류',
      'Stream/Purgation?': '그림자 급류/전개',
      'The Dark Devours': '어둠의 침식',
      'Titanomachy': '티타노마키아',
      '--fetters--': '--줄--',
      'Wail Of The Lost': '상실의 통곡'
    }
  }]
};
/* harmony default export */ const hades = (hades_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/hades.txt
const trial_hades_namespaceObject = "### Hades Normal\r\n# -p 4158:15.5 4599:300 4593:405 4594:405 4595:505 4597:605 4180:680.8 4168:900 4175:1304 -ii 414B 4151 4152 4153 414E 4596 414C 4162 415E 4171 4172 4155 4156 417C 4179 417A 4169 416F 4598 416B 416A\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Double\"\r\n\r\n# Phase 1: Everybody Murdered By Circles\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n1.5 \"--sync--\" Ability { id: \"368\", source: \"Hades\" } window 2,0\r\n15.5 \"Ravenous Assault\" Ability { id: \"4158\", source: \"Hades\" } window 16,5\r\n25.9 \"Bad Faith\" Ability { id: \"414[9A]\", source: \"Hades\" }\r\n32.9 \"Double\" Ability { id: \"414F\", source: \"Hades\" }\r\n38.9 \"Dark Eruption\" Ability { id: \"4150\", source: \"Hades\" }\r\n47.9 \"Broken Faith\" Ability { id: \"414D\", source: \"Hades\" } duration 22.5\r\n72.9 \"Double\" Ability { id: \"414F\", source: \"Hades\" }\r\n78.9 \"Shadow Spread\" Ability { id: \"4154\", source: \"Hades\" }\r\n84.9 \"Shadow Spread\" Ability { id: \"4157\", source: \"Hades\" }\r\n90.9 \"Ravenous Assault\" Ability { id: \"4158\", source: \"Hades\" }\r\n\r\n104.4 \"Bad Faith\" Ability { id: \"414[9A]\", source: \"Hades\" }\r\n114.4 \"Ravenous Assault\" Ability { id: \"4158\", source: \"Hades\" }\r\n122.4 \"Double\" Ability { id: \"414F\", source: \"Hades\" }\r\n128.4 \"Dark Eruption\" Ability { id: \"4150\", source: \"Hades\" }\r\n139.4 \"Broken Faith\" Ability { id: \"414D\", source: \"Hades\" } duration 22.5\r\n156.4 \"Double\" Ability { id: \"414F\", source: \"Hades\" }\r\n162.4 \"Shadow Spread\" Ability { id: \"4154\", source: \"Hades\" }\r\n168.4 \"Shadow Spread\" Ability { id: \"4157\", source: \"Hades\" }\r\n175.4 \"Ravenous Assault\" Ability { id: \"4158\", source: \"Hades\" }\r\n\r\n190.2 \"Bad Faith\" Ability { id: \"414[9A]\", source: \"Hades\" } window 80,80 jump 104.4\r\n200.2 \"Ravenous Assault\"\r\n208.2 \"Double\"\r\n214.2 \"Dark Eruption\"\r\n225.2 \"Broken Faith\"\r\n242.2 \"Double\"\r\n248.2 \"Shadow Spread\"\r\n254.2 \"Shadow Spread\"\r\n261.2 \"Ravenous Assault\"\r\n\r\n\r\n# Phase 2: Push at 10%\r\n# (untargetable happens 2 seconds before :4599:, so no warning, sorry)\r\n300.0 \"--sync--\" Ability { id: \"4599\", source: \"Hades\" } window 300,0\r\n# Give voice to your anguish, my brethren!\r\n304.5 \"Adds (E/W)\"\r\n\r\n400.0 \"--sync--\" StartsUsing { id: \"4593\", source: \"Shadow .f .he Ancients\" } window 500,0\r\n405.0 \"Ancient Darkness\" Ability { id: \"4593\", source: \"Shadow .f .he Ancients\" }\r\n405.0 \"Ancient Water III\" Ability { id: \"4594\", source: \"Shadow .f .he Ancients\" }\r\n# Give substance to our hopes, our dreams, our prayers...\r\n408.0 \"Adds (NE/SW)\"\r\n\r\n500.0 \"--sync--\" StartsUsing { id: \"4595\", source: \"Shadow .f .he Ancients\" } window 600,0\r\n505.0 \"Ancient Aero\" Ability { id: \"4595\", source: \"Shadow .f .he Ancients\" }\r\n508.0 \"Ancient Water III\" Ability { id: \"4594\", source: \"Shadow .f .he Ancients\" }\r\n508.0 \"Ancient Darkness\" Ability { id: \"4593\", source: \"Shadow .f .he Ancients\" }\r\n# And by their undeniable grace, may our perfect world rise anew!\r\n510.0 \"Adds (N/S)\"\r\n\r\n# Yawn wide, the ever-hungering void!\r\n600.0 \"--sync--\" StartsUsing { id: \"4597\", source: \"Hades\" } window 600,0\r\n605.0 \"Ancient Dark IV\" Ability { id: \"4597\", source: \"Hades\" }\r\n\r\n\r\n# Phase 3: neo hades\r\n666.8 \"--targetable--\"\r\n666.8 \"--sync--\" Ability { id: \"417C\", source: \"Hades\" } window 680,0\r\n680.8 \"Titanomachy\" Ability { id: \"4180\", source: \"Hades\" } window 80,5\r\n689.8 \"Shadow Stream\" Ability { id: \"415C\", source: \"Hades\" }\r\n696.8 \"Dual Strike\" Ability { id: \"4161\", source: \"Hades\" }\r\n711.8 \"Echo Of The Lost\" Ability { id: \"416[34]\", source: \"Hades\" }\r\n720.8 \"Polydegmon's Purgation\" Ability { id: \"4170\", source: \"Hades\" }\r\n729.8 \"Titanomachy\" Ability { id: \"4180\", source: \"Hades\" }\r\n739.8 \"Hellborn Yawp\" Ability { id: \"416E\", source: \"Hades\" }\r\n\r\n780.1 \"Titanomachy\" Ability { id: \"4180\", source: \"Hades\" } window 40,40 jump 680.8\r\n789.1 \"Shadow Stream\"\r\n796.1 \"Dual Strike\"\r\n811.1 \"Echo Of The Lost\"\r\n820.1 \"Polydegmon's Purgation\"\r\n829.1 \"Titanomachy\"\r\n839.1 \"Hellborn Yawp\"\r\n\r\n# There can be a push here, maybe 70%?\r\n# There is technically an echo of the lost before this captivity\r\n# but impossible to properly sync that given that the previous phase\r\n# also uses that ability.\r\n895.0 \"--sync--\" StartsUsing { id: \"4168\", source: \"Hades\" } window 300,0\r\n900.0 \"Captivity\" Ability { id: \"4168\", source: \"Hades\" }\r\n900.8 \"--fetters--\"\r\n903.0 \"--sync--\" Ability { id: \"417F\", source: \"Hades\" }\r\n905.0 \"Gaol Add\"\r\n906.5 \"--sync--\" StartsUsing { id: \"416C\", source: \"Hades\" }\r\n936.2 \"Chorus Of The Lost\" Ability { id: \"416C\", source: \"Hades\" }\r\n# FIXME: I've never seen this go off, so unclear how far 416D is from 416C.\r\n# Chorus of the lost does seem likely to be 30 seconds.\r\n939.0 \"--sync--\" Ability { id: \"416D\", source: \"Hades\" } window 100,0\r\n\r\n952.0 \"Dual Strike\" Ability { id: \"4161\", source: \"Hades\" } window 50,5\r\n953.0 \"Nether Blast x6\" duration 5 #Ability { id: \"4173\", source: \"Hades\" }\r\n962.3 \"Doom\"\r\n\r\n985.0 \"Wail Of The Lost\" Ability { id: \"416[56]\", source: \"Hades\" }\r\n993.0 \"Stream/Purgation?\" Ability { id: [\"415C\", \"4170\"], source: \"Hades\" }\r\n1002.0 \"Titanomachy\" Ability { id: \"4180\", source: \"Hades\" }\r\n1011.0 \"Hellborn Yawp\" Ability { id: \"416E\", source: \"Hades\" }\r\n1021.0 \"Echo Of The Lost\" Ability { id: \"416[34]\", source: \"Hades\" }\r\n1031.0 \"Dual Strike\" Ability { id: \"4161\", source: \"Hades\" }\r\n1039.0 \"Titanomachy\" Ability { id: \"4180\", source: \"Hades\" }\r\n1046.0 \"Shadow Spread\" Ability { id: \"415D\", source: \"Hades\" }\r\n1051.0 \"Nether Blast x6\" duration 5 #Ability { id: \"4173\", source: \"Hades\" }\r\n\r\n1062.0 \"Captivity\" Ability { id: \"4168\", source: \"Hades\" } window 150,10\r\n1062.8 \"--fetters--\"\r\n1065.0 \"--sync--\" Ability { id: \"417F\", source: \"Hades\" }\r\n1066.0 \"Doom\"\r\n1067.0 \"Gaol Add\"\r\n1068.5 \"--sync--\" StartsUsing { id: \"416C\", source: \"Hades\" }\r\n1098.2 \"Chorus Of The Lost\" Ability { id: \"416C\", source: \"Hades\" }\r\n1101.0 \"--sync--\" Ability { id: \"416D\", source: \"Hades\" } window 100,0\r\n\r\n1114.0 \"Wail Of The Lost\" Ability { id: \"416[56]\", source: \"Hades\" } window 50,5 jump 985\r\n1122.0 \"Stream/Purgation?\"\r\n1131.0 \"Titanomachy\"\r\n1140.0 \"Hellborn Yawp\"\r\n1150.0 \"Echo Of The Lost\"\r\n1160.0 \"Dual Strike\"\r\n1168.0 \"Titanomachy\"\r\n1175.0 \"Shadow Spread\"\r\n\r\n\r\n# Cutscene: Push at 30%?\r\n1300.0 \"--sync--\" StartsUsing { id: \"4175\", source: \"Hades\" } window 1300,0\r\n1304.0 \"--untargetable--\"\r\n1304.0 \"Life In Captivity\" Ability { id: \"4175\", source: \"Hades\" }\r\n1307.0 \"--sync--\" Ability { id: \"417F\", source: \"Hades\" }\r\n1307.0 \"--sync--\" Ability { id: \"442C\", source: \"Hades\" }\r\n1310.0 \"--sync--\" Ability { id: \"4176\", source: \"Hades\" }\r\n1342.0 \"Black Cauldron\" Ability { id: \"415A\", source: \"Hades\" }\r\n\r\n# Final dps race\r\n1354.0 \"--targetable--\"\r\n1361.0 \"The Dark Devours x5\" Ability { id: \"4177\", source: \"Hades\" } duration 9\r\n1376.0 \"The Dark Devours x5\" Ability { id: \"4177\", source: \"Hades\" } duration 9\r\n1391.0 \"The Dark Devours x5\" Ability { id: \"4177\", source: \"Hades\" } duration 9\r\n1403.0 \"--sync--\" Ability { id: \"4159\", source: \"Hades\" }\r\n\r\n# Gratuitous 45 second enrage.\r\n1412.7 \"--sync--\" StartsUsing { id: \"417B\", source: \"Hades\" } window 100,100\r\n1457.7 \"Enrage\" Ability { id: \"417B\", source: \"Hades\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/innocence-ex.ts




// Innocence Extreme
const innocence_ex_triggerSet = {
  id: 'TheCrownOfTheImmaculateExtreme',
  zoneId: zone_id/* default.TheCrownOfTheImmaculateExtreme */.Z.TheCrownOfTheImmaculateExtreme,
  timelineFile: 'innocence-ex.txt',
  triggers: [{
    id: 'InnoEx Starbirth Count',
    type: 'StartsUsing',
    netRegex: {
      id: '3EEF',
      source: 'Innocence',
      capture: false
    },
    run: data => {
      data.starbirthCount = (data.starbirthCount ?? 0) + 1;
      data.starbirthActive = true;
    }
  }, {
    id: 'InnoEx Reprobation Swords 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3EDC',
      source: 'Innocence',
      capture: false
    },
    // 3 seconds cast time + 7 seconds until next sword.
    delaySeconds: 7,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Swords!',
        de: 'Schwerter!',
        fr: 'Épées !',
        ja: '剣くるよ',
        cn: '剑!',
        ko: '검 돌아옴!'
      }
    }
  }, {
    id: 'InnoEx Starbirth Warning',
    type: 'StartsUsing',
    netRegex: {
      id: '3EEF',
      source: 'Innocence',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.starbirthCount === 1) return output.starbirthCorner();else if (data.starbirthCount === 2 || data.starbirthCount === 5) return output.starbirthAvoidCharge();else if (data.starbirthCount === 3) return output.starbirthExplode();else if (data.starbirthCount === 4) return output.starbirthCharge();else if (data.starbirthCount === 6) return output.starbirthEnrage();

      // No text for the second enrage one.
    },

    outputStrings: {
      starbirthCorner: {
        en: 'Starbirth: Corner',
        de: 'Sternengeburt: Ecken',
        fr: 'Accouchement Stellaire : Coin',
        ja: 'スターバース: 角へ',
        cn: '创星：角落躲避',
        ko: '별생성: 구석으로'
      },
      starbirthAvoidCharge: {
        en: 'Starbirth: Avoid + Charge',
        de: 'Sternengeburt: Ausweichen + Charge',
        fr: 'Accouchement Stellaire : Évitez + Charge',
        ja: 'スターバース: 玉のない隅へ',
        cn: '创星：躲避 + 冲锋',
        ko: '별 생성: 별 피해서 징 맞기 + 돌진'
      },
      starbirthExplode: {
        en: 'Starbirth: Explode',
        de: 'Sternengeburt: Explosion',
        fr: 'Accouchement Stellaire : Explosion',
        ja: 'スターバース: 爆発',
        cn: '创星：爆炸',
        ko: '별 생성: 별 터뜨리기'
      },
      starbirthCharge: {
        en: 'Starbirth: Charge',
        de: 'Sternengeburt: Charge',
        fr: 'Accouchement Stellaire : Charge',
        ja: 'スターバース: 突進',
        cn: '创星：冲锋',
        ko: '별 생성: 돌진'
      },
      starbirthEnrage: {
        en: 'Starbirth: Enrage',
        de: 'Sternengeburt: Finalangriff',
        fr: 'Accouchement Stellaire : Enrage',
        ja: 'スターバース: 時間切れ',
        cn: '创星：狂暴',
        ko: '별 생성: 전멸기'
      }
    }
  }, {
    id: 'InnoEx Shadowreaver',
    type: 'StartsUsing',
    netRegex: {
      id: '3EEA',
      source: 'Innocence',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'InnoEx Righteous Bolt',
    type: 'StartsUsing',
    netRegex: {
      id: '3ECD',
      source: 'Innocence'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'InnoEx Holy Sword Healer',
    type: 'StartsUsing',
    netRegex: {
      id: '3EC9',
      source: 'Forgiven Venery',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.tankBusters */.Z.tankBusters
    }
  }, {
    id: 'InnoEx Holy Sword Me',
    type: 'StartsUsing',
    netRegex: {
      id: '3EC9',
      source: 'Forgiven Venery'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'InnoEx Charge',
    type: 'StartsUsing',
    netRegex: {
      id: '3EEE',
      source: 'Innocence',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.starbirthActive) return output.avoidChargeAndOrbs();
      return output.avoidCharge();
    },
    outputStrings: {
      avoidChargeAndOrbs: {
        en: 'Avoid Charge and Orbs',
        de: 'Charge und Orbs ausweichen',
        fr: 'Évitez les charges et les orbes',
        ja: '玉と突進避けて',
        cn: '躲避冲锋与晶石',
        ko: '돌진이랑 구슬 폭발을 피하세요'
      },
      avoidCharge: {
        en: 'Avoid Charge',
        de: 'Charge ausweichen',
        fr: 'Évitez les charges',
        ja: '突進避けて',
        cn: '躲避冲锋',
        ko: '돌진을 피하세요'
      }
    }
  }, {
    id: 'InnoEx Starbirth Avoid',
    type: 'StartsUsing',
    netRegex: {
      id: '3EEF',
      source: 'Innocence',
      capture: false
    },
    condition: data => data.starbirthCount === 1,
    delaySeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get to Safe Corner',
        de: 'Geh in die sichere Ecke',
        fr: 'Allez au coin safe',
        ja: '安置へ',
        cn: '去安全角落',
        ko: '안전한 구석으로 이동'
      }
    }
  }, {
    id: 'InnoEx Adds',
    type: 'Ability',
    netRegex: {
      id: '42B0',
      source: 'Innocence',
      capture: false
    },
    condition: data => data.role === 'tank' || data.job === 'BLU',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Grab East/West Venery Adds',
        de: 'Nehme östliches/westliches Wollust Add',
        fr: 'Attrapez les adds en Est/Ouest',
        ja: '雑魚のタゲ取って',
        cn: '接小怪仇恨',
        ko: '동/서 쫄 잡으세요'
      }
    }
  }, {
    id: 'InnoEx Light Pillar',
    type: 'Ability',
    netRegex: {
      id: '38FC',
      source: 'Innocence'
    },
    preRun: data => data.lightPillar = (data.lightPillar ?? 0) + 1,
    alarmText: (data, matches, output) => {
      if (matches.target !== data.me) return;
      if (data.lightPillar === 3) return output.aimLineAtBackOrb();
      return output.avoidOrbsWithLine();
    },
    infoText: (data, matches, output) => {
      if (matches.target === data.me) return;
      return output.lineStack();
    },
    outputStrings: {
      lineStack: {
        en: 'Line Stack',
        de: 'Sammeln in einer Linie',
        fr: 'Packez-vous en ligne',
        ja: 'シェア',
        cn: '直线分摊',
        ko: '쉐어징 모이세요'
      },
      aimLineAtBackOrb: {
        en: 'Aim Line At Back Orb',
        de: 'Ziehle mit der Linie auf den entferntesten Orb',
        fr: 'Visez avec la ligne à l\'arrière de l\'orbe',
        ja: '後ろの玉に当てて',
        cn: '分摊瞄准后方晶石',
        ko: '멀리 있는 구슬 하나 맞추세요'
      },
      avoidOrbsWithLine: {
        en: 'Avoid Orbs With Line',
        de: 'Ziehle nicht auf einen Orb',
        fr: 'Évitez l\'orbe avec la ligne',
        ja: '玉に当てるな',
        cn: '躲开晶石与直线',
        ko: '쉐어징이 구슬에 맞지 않게 하세요'
      }
    }
  }, {
    id: 'InnoEx Starbirth Explode',
    type: 'StartsUsing',
    netRegex: {
      id: '3F3E',
      source: 'Innocence',
      capture: false
    },
    condition: data => data.lightPillar === 3,
    delaySeconds: 6.5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get to Safe Corner',
        de: 'Geh in die sichere Ecke',
        fr: 'Allez au coin safe',
        ja: '安置へ',
        cn: '去安全角落',
        ko: '안전한 구석으로 이동하세요'
      }
    }
  }, {
    id: 'InnoEx Winged Reprobation Tether',
    type: 'HeadMarker',
    netRegex: {
      id: '00AC'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tether on YOU',
        de: 'Verbindung auf DIR',
        fr: 'Lien sur VOUS',
        ja: '線ついた',
        cn: '连线点名',
        ko: '선 대상자 지정됨'
      }
    }
  }, {
    id: 'InnoEx Winged Drop Of Light',
    type: 'HeadMarker',
    netRegex: {
      id: '008A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (data, _matches, output) => {
      if (data.starbirthActive) return output.circleAvoidOrbs();
      return output.circleOnYou();
    },
    outputStrings: {
      circleAvoidOrbs: {
        en: 'Circle, Avoid Orbs',
        de: 'Kreis, vermeide Orbs',
        fr: 'Cercle, Évitez les orbes',
        ja: 'オーブに当てないで',
        cn: '圆圈点名，远离晶石',
        ko: '원형 징, 구슬 피하세요'
      },
      circleOnYou: {
        en: 'Circle on YOU',
        de: 'Kreis auf DIR',
        fr: 'Cercle sur vous',
        ja: 'サークルついた',
        cn: '圆圈点名',
        ko: '원형 징 대상자 지정됨'
      }
    }
  }, {
    id: 'InnoEx God Ray',
    type: 'StartsUsing',
    netRegex: {
      id: '3EE[456]',
      source: 'Innocence',
      capture: false
    },
    suppressSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Swords then Ray',
        de: 'Weiche den Schwertern aus, danach Strahl',
        fr: 'Évitez l\'épée puis le rayon',
        ja: '剣避けてからピザカット',
        cn: '躲避剑与激光',
        ko: '칼 먼저 피하고 장판 피하세요'
      }
    }
  }, {
    id: 'InnoEx Starbirth End 1',
    type: 'StartsUsing',
    netRegex: {
      id: '3EEA',
      source: 'Innocence',
      capture: false
    },
    run: data => delete data.starbirthActive
  }, {
    id: 'InnoEx Starbirth End 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3EEE',
      source: 'Innocence',
      capture: false
    },
    run: data => delete data.starbirthActive
  }, {
    id: 'InnoEx Soul And Body Left',
    type: 'StartsUsing',
    netRegex: {
      id: '3ED7',
      source: 'Innocence',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Rotate Left',
        de: 'Links rum rotieren',
        fr: 'Tournez vers la gauche',
        ja: '時針回り',
        cn: '向左旋转',
        ko: '왼쪽으로 도세요'
      }
    }
  }, {
    id: 'InnoEx Soul And Body Right',
    type: 'StartsUsing',
    netRegex: {
      id: '3ED9',
      source: 'Innocence',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Rotate Right',
        de: 'Rechts rum rotieren',
        fr: 'Tournez vers la droite',
        ja: '逆時針回り',
        cn: '向右旋转',
        ko: '오른쪽으로 도세요'
      }
    }
  }, {
    id: 'InnoEx Rood Left',
    type: 'StartsUsing',
    netRegex: {
      id: '3ED3',
      source: 'Innocence',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Rotate Left',
        de: 'Links rum rotieren',
        fr: 'Tournez vers la gauche',
        ja: '時針回り',
        cn: '向左旋转',
        ko: '왼쪽으로 도세요'
      }
    }
  }, {
    id: 'InnoEx Rood Right',
    type: 'StartsUsing',
    netRegex: {
      id: '3ED5',
      source: 'Innocence',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Rotate Right',
        de: 'Rechts rum rotieren',
        fr: 'Tournez vers la droite',
        ja: '逆時針回り',
        cn: '向右旋转',
        ko: '오른쪽으로 도세요'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Innocence': 'Innozenz',
      'Nail of Condemnation': 'Nagel des Urteils',
      'Sword of Condemnation': 'Schwert des Urteils',
      'Forgiven Venery': 'Geläutert(?:e|er|es|en) Wollust',
      'Forgiven Shame': 'Geläuterte Schande'
    },
    'replaceText': {
      'Tethers': 'Verbindungen',
      'Rotate': 'Rotieren',
      'Trident': 'Dreizack',
      'Charge': 'Ansturm',
      'Corner': 'Ecke',
      'Explode': 'Explosion',
      'Avoid': 'ausweichen',
      'Final(?!angriff)': ' Finale',
      'Soul And Body': 'Seele und Körper',
      'Shadowreaver': 'Schattenplünderer',
      'Scold\'s Bridle': 'Schandmal',
      'Rightful Reprobation': 'Rechtmäßige Verurteilung',
      'Righteous Bolt': 'Blitz der Gerechtigkeit',
      '(?<! )Reprobation': 'Verurteilung',
      'Light Pillar': 'Lichtsäule',
      'Holy Trinity': 'Heilige Dreifaltigkeit',
      'Holy Sword': 'Heiliges Schwert',
      'Guiding Light': 'Leitendes Licht',
      'God Ray': 'Göttlicher Strahl',
      'Explosion': 'Explosion',
      'Duel Descent': 'Doppelter Sinkflug',
      'Beatific Vision': 'Seligmachende Schau',
      'Forgiven venery': 'Geläuterte Wollust',
      'Drop Of Light': 'Lichtabfall',
      'Winged Rep': 'Schwinge des Urteils',
      'Starbirth': 'Sternengeburt'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Sword of Condemnation': 'Épée De Condamnation',
      'Nail of Condemnation': 'Clou De Condamnation',
      'Forgiven Venery': 'Débauche Pardonnée',
      'Forgiven Shame': 'Déshonneur Pardonné',
      'Innocence': 'Innocence'
    },
    'replaceText': {
      'Winged Rep Trident': 'Trident ailée',
      'Winged Rep Tethers': 'Liens ailée',
      'Winged Rep Rotate': 'Rotation ailée',
      'Starbirth Final': 'Accouchement stellaire final',
      'Starbirth Explode': 'Accouchement stellaire explose',
      'Starbirth Corner': 'Accouchement stellaire au coin',
      'Starbirth Charge': 'Accouchement stellaire charge',
      'Starbirth Avoid': 'Accouchement stellaire à éviter',
      'Soul And Body': 'Âme et corps',
      'Shadowreaver': 'Pilleur d\'ombre',
      'Scold\'s Bridle': 'Bride-bavarde',
      'Rightful Reprobation': 'Réprobation légitime',
      'Righteous Bolt': 'Éclair vertueux',
      '(?<! )Reprobation': 'Réprobation',
      'Light Pillar': 'Pilier de lumière',
      'Holy Trinity': 'Sainte Trinité',
      'Holy Sword': 'Épée sacrée',
      'Guiding Light': 'Lumière directrice',
      'God Ray': 'Rayon divin',
      'Explosion': 'Explosion',
      'Duel Descent': 'Double plongeon',
      'Drop Of Light': 'Goutte de lumière',
      'Beatific Vision': 'Vision béatifique',
      'Forgiven venery': 'débauche pardonnée'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Sword of Condemnation': '断罪の剣',
      'Innocence': 'イノセンス',
      'Nail of Condemnation': '断罪の杭',
      'Forgiven Shame': 'フォーギヴン・シェイム',
      'Forgiven Venery': 'フォーギヴン・ヴェナリー'
    },
    'replaceText': {
      'Winged Rep Tethers': '断罪の飛翔：線',
      'Winged Rep Rotate': '断罪の飛翔：回転',
      'Winged Rep Trident': '断罪の飛翔：AoE',
      'Starbirth Corner': 'スターバース: 角へ',
      'Starbirth Avoid': 'スターバース: 玉のない隅へ',
      'Starbirth Charge': 'スターバース: 突進',
      'Starbirth Explode': 'スターバース: 爆発',
      'Starbirth Final': 'スターバース: 時間切れ',
      'Soul And Body': 'ソウル・アンド・ボディー',
      'Shadowreaver': 'シャドウリーヴァー',
      'Scold\'s Bridle': 'スコルドブライダル',
      'Rightful Reprobation': '断罪の旋回',
      'Righteous Bolt': 'ジャッジボルト',
      '(?<! )Reprobation': '断罪',
      'Light Pillar': 'ライトピラー',
      'Holy Trinity': 'ホーリートリニティー',
      'Holy Sword': 'ホーリーソード',
      'Guiding Light': 'ガイディングライト',
      'God Ray': 'ゴッドレイ',
      'Explosion': '爆散',
      'Duel Descent': 'デュアルディセント',
      'Drop Of Light': 'ドロップ・オブ・ライト',
      'Beatific Vision': 'ビーティフィックビジョン',
      'Forgiven venery': 'フォーギヴン・ヴェナリー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Sword of Condemnation': '断罪之剑',
      'Innocence': '无瑕灵君',
      'Nail of Condemnation': '断罪之桩',
      'Forgiven Shame': '得到宽恕的耻辱',
      'Forgiven Venery': '得到宽恕的情欲'
    },
    'replaceText': {
      'Winged Rep Trident': '扇形断罪飞翔',
      'Winged Rep Rotate': '风车断罪飞翔',
      'Winged Rep Tethers': '连线断罪飞翔',
      'Starbirth Corner': '创星角落',
      'Starbirth Avoid': '创星躲避',
      'Starbirth Charge': '创星突进',
      'Starbirth Explode': '创星爆炸',
      'Starbirth Final': '创星狂暴',
      'Soul And Body': '身心',
      'Shadowreaver': '夺影',
      'Scold\'s Bridle': '毒舌钩',
      'Rightful Reprobation': '断罪回旋',
      'Righteous Bolt': '裁决之雷',
      '(?<! )Reprobation': '断罪',
      'Light Pillar': '光明柱',
      'Holy Trinity': '圣三一',
      'Holy Sword': '神圣剑',
      'Guiding Light': '指明灯',
      'God Ray': '神光',
      'Explosion': '爆炸',
      'Duel Descent': '斗争降临',
      'Drop Of Light': '落光',
      'Beatific Vision': '荣福直观',
      'Forgiven venery': '得到宽恕的情欲'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Innocence': '이노센스',
      'Nail of Condemnation': '단죄의 말뚝',
      'Sword of Condemnation': '단죄의 검',
      'Forgiven Venery': '면죄된 정욕',
      'Forgiven Shame': '면죄된 수치'
    },
    'replaceText': {
      'Winged Rep Trident': '단죄의 비상 직선장판',
      'Winged Rep Rotate': '단죄의 비상 회전',
      'Winged Rep Tethers': '단죄의 비상 줄연결',
      'Starbirth': '별 생성',
      'Soul And Body': '영혼과 육신',
      'Shadowreaver': '그림자 강탈',
      'Scold\'s Bridle': '입막음 굴레',
      'Rightful Reprobation': '단죄의 선회',
      'Righteous Bolt': '심판자의 번개',
      '(?<! )Reprobation': '선회',
      'Light Pillar': '빛의 기둥',
      'Holy Trinity': '성 삼위일체',
      'Holy Sword': '성스러운 검',
      'Guiding Light': '인도하는 빛',
      'God Ray': '신의 광선',
      'Explosion': '폭산',
      'Duel Descent': '이단 낙하',
      'Drop Of Light': '빛내림',
      'Beatific Vision': '지복직관',
      'Forgiven venery': '면죄된 정욕',
      ' Avoid': ' (피하기)',
      ' Explode': ' (터뜨리기)',
      ' Charge': ' (돌진)',
      ' Final': ' (마지막)'
    }
  }]
};
/* harmony default export */ const innocence_ex = (innocence_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/innocence-ex.txt
const trial_innocence_ex_namespaceObject = "### Innocence Ex\r\n# -ii 3ED5 3ED4 3ED3 3ED2 3EE7 3EE8 3EE4 3EE5 3EFD 3EFE 3EEB 3F3E 3EFF 3F00 3ED8 3F01 3F02 3EFB 3EFC 3ED6 3EDE 3EDF 38FC 3EE0 3EF0 -p 3EE9:300\r\n# https://thebalanceffxiv.com/guide/innocence/\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Holy Trinity\"\r\nhideall \"Soul And Body\"\r\n\r\n### Phase 1\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n17.0 \"Shadowreaver\" Ability { id: \"3EEA\", source: \"Innocence\" } window 20,5\r\n28.0 \"Winged Rep Tethers\" Ability { id: \"40BD\", source: \"Innocence\" }\r\n37.0 \"Duel Descent\" Ability { id: \"3EA9\", source: \"Nail of Condemnation\" }\r\n47.0 \"Righteous Bolt\" Ability { id: \"3ECD\", source: \"Innocence\" }\r\n58.0 \"Winged Rep Tethers\" Ability { id: \"40BD\", source: \"Innocence\" }\r\n61.0 \"--sync--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n65.2 \"Rightful Reprobation\" Ability { id: \"3EDC\", source: \"Innocence\" }\r\n67.0 \"Duel Descent\" Ability { id: \"3EA9\", source: \"Nail of Condemnation\" }\r\n72.1 \"Reprobation\" Ability { id: \"3ECC\", source: \"Innocence\" }\r\n81.2 \"Winged Rep Rotate\" Ability { id: \"40BD\", source: \"Innocence\" }\r\n95.2 \"Drop Of Light\" Ability { id: \"3EEC\", source: \"Innocence\" }\r\n107.8 \"Righteous Bolt\" Ability { id: \"3ECD\", source: \"Innocence\" }\r\n118.8 \"Winged Rep Trident\" Ability { id: \"40BD\", source: \"Innocence\" }\r\n121.8 \"--sync--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n124.8 \"Holy Trinity\" #Ability { id: \"3EDB\", source: \"Innocence\" }\r\n125.8 \"Rightful Reprobation\" Ability { id: \"3EDD\", source: \"Innocence\" }\r\n129.3 \"Holy Trinity\" #Ability { id: \"3EDB\", source: \"Innocence\" }\r\n132.6 \"Reprobation\" Ability { id: \"3ECC\", source: \"Innocence\" }\r\n133.7 \"Holy Trinity\" #Ability { id: \"3EDB\", source: \"Innocence\" }\r\n137.0 \"Light Pillar\" Ability { id: \"3EED\", source: \"Innocence\" }\r\n144.0 \"Shadowreaver\" Ability { id: \"3EEA\", source: \"Innocence\" }\r\n# technically Tethers + Rotate\r\n155.0 \"Winged Rep Tethers\" Ability { id: \"40BD\", source: \"Innocence\" }\r\n161.0 \"Soul And Body\" Ability { id: \"3ED7\", source: \"Innocence\" }\r\n161.0 \"Duel Descent\" Ability { id: \"3EA9\", source: \"Nail of Condemnation\" }\r\n\r\n\r\n### Phase 2: Adds\r\n178.0 \"--untargetable--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n180.3 \"--targetable--\" Ability { id: \"42B0\", source: \"Innocence\" } window 200,200\r\n183.3 \"--sync--\" Ability { id: \"42B1\", source: \"Sword of Condemnation\" }\r\n190.3 \"Scold's Bridle\" Ability { id: \"3EC8\", source: \"Forgiven Shame\" }\r\n195.3 \"Holy Sword\" Ability { id: \"3EC9\", source: \"Forgiven Venery\" }\r\n197.3 \"Guiding Light\" Ability { id: \"3F46\", source: \"Innocence\" }\r\n211.3 \"Holy Sword\" Ability { id: \"3EC9\", source: \"Forgiven Venery\" }\r\n213.3 \"Guiding Light\" Ability { id: \"3F46\", source: \"Innocence\" }\r\n227.3 \"Holy Sword\" Ability { id: \"3EC9\", source: \"Forgiven Venery\" }\r\n230.3 \"Enrage\"\r\n\r\n\r\n### Phase 3: Starbirth\r\n300.0 \"--sync--\" Ability { id: \"3EE9\", source: \"Sword of Condemnation\" } window 300,0\r\n314.0 \"--targetable--\"\r\n323.0 \"Starbirth Corner\" Ability { id: \"3EEF\", source: \"Innocence\" }\r\n336.0 \"Shadowreaver\" Ability { id: \"3EEA\", source: \"Innocence\" }\r\n337.0 \"Explosion\" Ability { id: \"3EF0\", source: \"Innocence\" }\r\n347.0 \"Winged Rep Rotate\" Ability { id: \"40BD\", source: \"Innocence\" }\r\n353.0 \"Soul And Body\" Ability { id: \"3ED9\", source: \"Innocence\" }\r\n359.0 \"--sync--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n363.0 \"Rightful Reprobation\" Ability { id: \"3EDD\", source: \"Innocence\" }\r\n367.0 \"--jump--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n369.8 \"Reprobation\" Ability { id: \"3ECC\", source: \"Innocence\" }\r\n373.7 \"Beatific Vision\" Ability { id: \"3EEE\", source: \"Innocence\" }\r\n389.7 \"Righteous Bolt\" Ability { id: \"3ECD\", source: \"Innocence\" }\r\n\r\n400.7 \"Starbirth Avoid\" Ability { id: \"3EEF\", source: \"Innocence\" }\r\n407.7 \"Drop Of Light 1\" #Ability { id: \"3EEC\", source: \"Innocence\" }\r\n412.8 \"Drop Of Light 2\" #Ability { id: \"3EEC\", source: \"Innocence\" }\r\n419.7 \"Light Pillar\" Ability { id: \"3EED\", source: \"Innocence\" }\r\n421.7 \"--jump--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n428.3 \"Beatific Vision\" Ability { id: \"3EEE\", source: \"Innocence\" }\r\n441.3 \"--sync--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n445.4 \"Rightful Reprobation\" Ability { id: \"3EDC\", source: \"Innocence\" }\r\n452.3 \"Reprobation\" Ability { id: \"3ECC\", source: \"Innocence\" }\r\n452.9 \"God Ray x3\" Ability { id: \"3EE6\", source: \"Innocence\" } duration 10 window 5,1\r\n469.9 \"Shadowreaver\" Ability { id: \"3EEA\", source: \"Innocence\" }\r\n480.9 \"Righteous Bolt\" Ability { id: \"3ECD\", source: \"Innocence\" }\r\n\r\n489.9 \"Starbirth Explode\" Ability { id: \"3EEF\", source: \"Innocence\" }\r\n494.9 \"Winged Rep Trident\" Ability { id: \"40BD\", source: \"Innocence\" }\r\n500.9 \"Holy Trinity\" #Ability { id: \"3EDB\", source: \"Innocence\" }\r\n505.4 \"Holy Trinity\" #Ability { id: \"3EDB\", source: \"Innocence\" }\r\n509.9 \"Holy Trinity\" #Ability { id: \"3EDB\", source: \"Innocence\" }\r\n514.2 \"Light Pillar\" Ability { id: \"3EED\", source: \"Innocence\" }\r\n523.2 \"Shadowreaver\" Ability { id: \"3EEA\", source: \"Innocence\" }\r\n538.3 \"Righteous Bolt\" Ability { id: \"3ECD\", source: \"Innocence\" }\r\n# technical tethers + trident\r\n547.3 \"Winged Rep Tethers\" Ability { id: \"40BD\", source: \"Innocence\" }\r\n553.3 \"Holy Trinity\" #Ability { id: \"3EDB\", source: \"Innocence\" }\r\n553.3 \"Duel Descent\" Ability { id: \"3EA9\", source: \"Nail of Condemnation\" }\r\n557.8 \"Holy Trinity\" #Ability { id: \"3EDB\", source: \"Innocence\" }\r\n# technically trident + rotate\r\n561.3 \"Winged Rep Trident\" Ability { id: \"40BD\", source: \"Innocence\" }\r\n562.3 \"Holy Trinity\" #Ability { id: \"3EDB\", source: \"Innocence\" }\r\n562.3 \"Holy Trinity\" #Ability { id: \"3EDB\", source: \"Innocence\" }\r\n\r\n570.3 \"Starbirth Charge\" Ability { id: \"3EEF\", source: \"Innocence\" }\r\n573.3 \"--jump--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n579.9 \"Beatific Vision\" Ability { id: \"3EEE\", source: \"Innocence\" }\r\n592.9 \"--sync--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n597.1 \"Rightful Reprobation\" Ability { id: \"3EDC\", source: \"Innocence\" }\r\n598.9 \"Drop Of Light 1\" #Ability { id: \"3EEC\", source: \"Innocence\" }\r\n604.0 \"Reprobation\" Ability { id: \"3ECC\", source: \"Innocence\" }\r\n604.8 \"Drop Of Light 2\" #Ability { id: \"3EEC\", source: \"Innocence\" }\r\n613.4 \"Winged Rep Tethers\" Ability { id: \"40BD\", source: \"Innocence\" }\r\n622.4 \"Duel Descent\" Ability { id: \"3EA9\", source: \"Nail of Condemnation\" }\r\n623.4 \"Righteous Bolt\" Ability { id: \"3ECD\", source: \"Innocence\" }\r\n\r\n634.4 \"Starbirth Avoid\" Ability { id: \"3EEF\", source: \"Innocence\" }\r\n641.4 \"Drop Of Light 1\" #Ability { id: \"3EEC\", source: \"Innocence\" }\r\n646.5 \"Drop Of Light 2\" #Ability { id: \"3EEC\", source: \"Innocence\" }\r\n653.4 \"Light Pillar\" Ability { id: \"3EED\", source: \"Innocence\" }\r\n655.4 \"--jump--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n662.1 \"Beatific Vision\" Ability { id: \"3EEE\", source: \"Innocence\" }\r\n675.2 \"--sync--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n679.4 \"Rightful Reprobation\" Ability { id: \"3EDC\", source: \"Innocence\" }\r\n686.3 \"Reprobation\" Ability { id: \"3ECC\", source: \"Innocence\" }\r\n686.9 \"God Ray x3\" Ability { id: \"3EE6\", source: \"Innocence\" } duration 10 window 5,1\r\n703.9 \"Shadowreaver\" Ability { id: \"3EEA\", source: \"Innocence\" }\r\n714.9 \"Righteous Bolt\" Ability { id: \"3ECD\", source: \"Innocence\" }\r\n\r\n723.9 \"Starbirth Final\" Ability { id: \"3EEF\", source: \"Innocence\" }\r\n728.9 \"Winged Rep Trident\" Ability { id: \"40BD\", source: \"Innocence\" }\r\n734.9 \"Holy Trinity\" #Ability { id: \"3EDB\", source: \"Innocence\" }\r\n739.4 \"Holy Trinity\" #Ability { id: \"3EDB\", source: \"Innocence\" }\r\n740.4 \"--sync--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n741.7 \"--sync--\" StartsUsing { id: \"3EEF\", source: \"Innocence\" } window 10,10\r\n743.9 \"Holy Trinity\" #Ability { id: \"3EDB\", source: \"Innocence\" }\r\n\r\n744.7 \"Starbirth Final\" Ability { id: \"3EEF\", source: \"Innocence\" }\r\n764.7 \"Beatific Vision\" Ability { id: \"3EF1\", source: \"Innocence\" }\r\n765.6 \"Explosion Enrage\" Ability { id: \"3EF0\", source: \"Innocence\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/innocence.ts



// Innocence Normal
const innocence_triggerSet = {
  id: 'TheCrownOfTheImmaculate',
  zoneId: zone_id/* default.TheCrownOfTheImmaculate */.Z.TheCrownOfTheImmaculate,
  timelineFile: 'innocence.txt',
  triggers: [{
    id: 'Inno Realmrazer',
    type: 'StartsUsing',
    netRegex: {
      id: '3E9A',
      source: 'Innocence',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Inno Enthrall',
    type: 'StartsUsing',
    netRegex: {
      id: '3E99',
      source: 'Innocence',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look Away, Get Towers',
        de: 'Weg schauen, Türme nehmen',
        fr: 'Regardez ailleurs, prenez une tour',
        ja: '背中を向けて、塔を踏む',
        cn: '背对BOSS，踩塔',
        ko: '뒤돌고 장판 들어가기'
      }
    }
  }, {
    id: 'Inno Reprobation Swords 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3EDC',
      source: 'Innocence',
      capture: false
    },
    // 3 seconds cast time + 9.5 seconds until next sword.
    delaySeconds: 9.5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Swords!',
        de: 'Schwerter!',
        fr: 'Épées !',
        ja: '剣くるよ',
        cn: '剑!',
        ko: '검 돌아옴!'
      }
    }
  }, {
    id: 'Inno Shadowreaver',
    type: 'StartsUsing',
    netRegex: {
      id: '3EEA',
      source: 'Innocence',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Inno Righteous Bolt',
    type: 'StartsUsing',
    netRegex: {
      id: '3EA3',
      source: 'Innocence'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Inno Charge',
    type: 'StartsUsing',
    netRegex: {
      id: '3EC7',
      source: 'Innocence',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Charge',
        de: 'ausweichen',
        fr: 'Évitez les charges',
        ja: '突進避けて',
        cn: '躲避冲锋',
        ko: '돌진 피하기'
      }
    }
  }, {
    id: 'Inno Light Pillar',
    type: 'Ability',
    netRegex: {
      id: '38FC',
      source: 'Innocence',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Stack',
        de: 'In einer Linie sammeln',
        fr: 'Packez-vous en ligne',
        ja: 'シェア',
        cn: '直线分摊',
        ko: '직선 쉐어'
      }
    }
  }, {
    id: 'Inno Winged Drop Of Light',
    type: 'HeadMarker',
    netRegex: {
      id: '008A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Circle on YOU',
        de: 'Kreis auf DIR',
        fr: 'Cercle sur vous',
        ja: 'サークルついた',
        cn: '圈圈点名',
        ko: '원형징 대상자'
      }
    }
  }, {
    // TODO: is there a left, or do all normal modes rotate right??
    id: 'Inno Soul And Body Right',
    type: 'StartsUsing',
    netRegex: {
      id: '3EB1',
      source: 'Innocence',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Rotate Right',
        de: 'Rechts rum rotieren',
        fr: 'Tournez vers la droite',
        ja: '時針回り',
        cn: '向右旋转',
        ko: '오른쪽으로 도세요'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Sword of Condemnation': 'Schwert des Urteils',
      'Innocence': 'Innozenz'
    },
    'replaceText': {
      'Winged Reprobation': 'Schwinge des Urteils',
      'Soul And Body': 'Seele und Körper',
      'Sinsphere': 'Sündensphäre',
      'Shadowreaver': 'Schattenplünderer',
      'Rightful Reprobation': 'Rechtmäßige Verurteilung',
      'Righteous Bolt': 'Blitz der Gerechtigkeit',
      '(?<! )Reprobation': 'Verurteilung',
      'Light Pillar': 'Lichtsäule',
      'Holy Trinity': 'Heilige Dreifaltigkeit',
      'Guiding Light': 'Leitendes Licht',
      'God Ray': 'Göttlicher Strahl',
      'Flaming Sword': 'Flammenschwert',
      'Drop Of Light': 'Lichtabfall',
      'Beatific Vision': 'Seligmachende Schau',
      'Realmrazer': 'Weltenzerstörer',
      'Heavenly Host': 'Machtwort',
      'Daybreak': 'Morgengrauen',
      'Enthrall': 'Bezaubern',
      'Exalted Wing': 'Exaltierte Schwinge',
      'Exalted Plumes': 'Exaltierte Schwaden',
      '--add Phase--': '--Add Phase--'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Sword of Condemnation': 'Épée De Condamnation',
      'Innocence': 'Innocence'
    },
    'replaceText': {
      'Winged Reprobation': 'Réprobation ailée',
      'Soul And Body': 'Âme et corps',
      'Sinsphere': 'Sphère de péchés',
      'Shadowreaver': 'Pilleur d\'ombre',
      'Rightful Reprobation': 'Réprobation légitime',
      'Righteous Bolt': 'Éclair vertueux',
      '(?<! )Reprobation': 'Réprobation',
      'Realmrazer': 'Raye-royaume',
      'Light Pillar': 'Pilier de lumière',
      'Holy Trinity': 'Sainte Trinité',
      'Heavenly Host': 'Milicien céleste',
      'Guiding Light': 'Lumière directrice',
      'God Ray': 'Rayon divin',
      'Flaming Sword': 'Épée du feu des cieux',
      'Exalted Wing': 'Aile exaltée',
      'Exalted Plumes': 'Plumes exaltées',
      'Enthrall': 'Œil captivant',
      'Drop Of Light': 'Goutte de lumière',
      'Daybreak': 'Point du jour',
      'Beatific Vision': 'Vision béatifique',
      '--add Phase--': '--phase d\'add--'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Innocence': 'イノセンス',
      'Sword of Condemnation': '断罪の剣'
    },
    'replaceText': {
      'Winged Reprobation': '断罪の飛翔',
      'Soul And Body': 'ソウル・アンド・ボディー',
      'Sinsphere': 'シンスフィア',
      'Shadowreaver': 'シャドウリーヴァー',
      'Rightful Reprobation': '断罪の旋回',
      'Righteous Bolt': 'ジャッジボルト',
      '(?<! )Reprobation': '断罪',
      'Light Pillar': 'ライトピラー',
      'Holy Trinity': 'ホーリートリニティー',
      'Guiding Light': 'ガイディングライト',
      'God Ray': 'ゴッドレイ',
      'Flaming Sword': '回転せし炎の剣',
      'Drop Of Light': 'ドロップ・オブ・ライト',
      'Beatific Vision': 'ビーティフィックビジョン',
      'Realmrazer': 'レルムレイザー',
      'Heavenly Host': '鶴の一声',
      'Daybreak': 'デイブレイク',
      'Enthrall': 'インスロール・アイ',
      'Exalted Wing': 'エクザルテッドウィング',
      'Exalted Plumes': 'エクロージョン',
      '--add Phase--': '--雑魚フェイス--'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Sword of Condemnation': '断罪之剑',
      'Innocence': '无瑕灵君'
    },
    'replaceText': {
      'Winged Reprobation': '断罪飞翔',
      'Soul And Body': '身心',
      'Sinsphere': '罪恶晶球',
      'Shadowreaver': '夺影',
      'Rightful Reprobation': '断罪回旋',
      'Righteous Bolt': '裁决之雷',
      '(?<! )Reprobation': '(?<! )断罪飞翔',
      'Light Pillar': '光明柱',
      'Holy Trinity': '圣三一',
      'Guiding Light': '指明灯',
      'God Ray': '神光',
      'Flaming Sword': '回转火焰剑',
      'Beatific Vision': '荣福直观',
      'Realmrazer': '灭境',
      'Heavenly Host': '天堂君威',
      'Daybreak': '破晓',
      'Enthrall': '迷魂之眼',
      'Exalted Wing': '高贵之翼',
      'Exalted Plumes': '羽化',
      'Drop Of Light': '落光',
      '--add Phase--': '--小怪--'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Sword of Condemnation': '단죄의 검',
      'Innocence': '이노센스'
    },
    'replaceText': {
      'Winged Reprobation': '단죄의 비상',
      'Soul And Body': '영혼과 육신',
      'Sinsphere': '죄의 구체',
      'Shadowreaver': '그림자 강탈',
      'Rightful Reprobation': '단죄의 선회',
      'Righteous Bolt': '심판자의 번개',
      '(?<! )Reprobation': '선회',
      'Light Pillar': '빛의 기둥',
      'Holy Trinity': '성 삼위일체',
      'Guiding Light': '인도하는 빛',
      'God Ray': '신의 광선',
      'Flaming Sword': '회전 화염검',
      'Beatific Vision': '지복직관',
      'Realmrazer': '영토 지배자',
      'Heavenly Host': '권력자의 한마디',
      'Daybreak': '여명',
      'Enthrall': '매혹의 눈',
      'Exalted Wing': '고귀한 날개',
      'Exalted Plumes': '탈피',
      'Drop Of Light': '빛내림',
      '--add Phase--': '--쫄 페이즈--'
    }
  }]
};
/* harmony default export */ const innocence = (innocence_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/innocence.txt
const trial_innocence_namespaceObject = "### Innocence Normal\r\n# -p 3E9A:15 3E9A:15 3E92:205.5 4144:300 3EBE:605.7 3EC1:579.8 -ii 3E90 3EA0 3E9B 3E9E 3E9F 4317 3E9C 3F45 3EB2 3EFA 3EF9 3EBC 3EBF 3EC0 3EBD 3EC6 3EC5 3EB7 3EB8 3EB6 4690 3EA9 4690 4692 4691 42B1\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n15.0 \"Realmrazer\" Ability { id: \"3E9A\", source: \"Innocence\" } window 15,5\r\n28.2 \"Heavenly Host\" Ability { id: \"3E95\", source: \"Innocence\" }\r\n54.9 \"Daybreak\" Ability { id: \"3E9D\", source: \"Innocence\" }\r\n69.1 \"Enthrall\" Ability { id: \"3E99\", source: \"Innocence\" }\r\n71.1 \"Sinsphere\" Ability { id: \"3E97\", source: \"Innocence\" }\r\n80.3 \"Heavenly Host\" Ability { id: \"3E95\", source: \"Innocence\" }\r\n82.4 \"--center--\" Ability { id: \"3E91\", source: \"Innocence\" }\r\n86.7 \"Guiding Light\" Ability { id: \"3E96\", source: \"Innocence\" }\r\n100.4 \"Daybreak\" Ability { id: \"3E9D\", source: \"Innocence\" }\r\n111.5 \"Realmrazer\" Ability { id: \"3E9A\", source: \"Innocence\" }\r\n123.6 \"Enthrall\" Ability { id: \"3E99\", source: \"Innocence\" }\r\n125.8 \"Sinsphere\" Ability { id: \"3E97\", source: \"Innocence\" }\r\n\r\n# aoe spam until low\r\n200.0 \"--north--\" Ability { id: \"3E91\", source: \"Innocence\" } window 100,0\r\n205.5 \"--sync--\" Ability { id: \"3E92\", source: \"Innocence\" } window 200,0\r\n209.2 \"Exalted Wing\" #Ability { id: \"3E93\", source: \"Innocence\" }\r\n215.6 \"Exalted Wing\" Ability { id: \"3E93\", source: \"Innocence\" } window 0,30\r\n220.6 \"Exalted Wing\" #Ability { id: \"3E93\", source: \"Innocence\" }\r\n225.6 \"Exalted Wing\" #Ability { id: \"3E93\", source: \"Innocence\" }\r\n230.6 \"Exalted Wing\" #Ability { id: \"3E93\", source: \"Innocence\" }\r\n235.6 \"Exalted Wing\" #Ability { id: \"3E93\", source: \"Innocence\" }\r\n240.6 \"Exalted Wing\" #Ability { id: \"3E93\", source: \"Innocence\" }\r\n245.6 \"Exalted Wing\" #Ability { id: \"3E93\", source: \"Innocence\" }\r\n250.6 \"Exalted Wing\" #Ability { id: \"3E93\", source: \"Innocence\" }\r\n\r\n# ye olde cutscene\r\n300.0 \"--sync--\" Ability { id: \"4144\", source: \"Innocence\" } window 300,0\r\n302.5 \"Exalted Plumes\" Ability { id: \"3EF2\", source: \"Innocence\" }\r\n306.6 \"--sync--\" Ability { id: \"3EA1\", source: \"Innocence\" }\r\n306.6 \"--sync--\" Ability { id: \"3E94\", source: \"Innocence\" }\r\n363.2 \"Righteous Bolt\" Ability { id: \"3EA3\", source: \"Innocence\" }\r\n372.4 \"Winged Reprobation\" Ability { id: \"40BC\", source: \"Innocence\" }\r\n378.5 \"Holy Trinity\" #Ability { id: \"3EB3\", source: \"Innocence\" }\r\n383.6 \"Holy Trinity\" #Ability { id: \"3EB3\", source: \"Innocence\" }\r\n388.7 \"Holy Trinity\" #Ability { id: \"3EB3\", source: \"Innocence\" }\r\n397.6 \"Winged Reprobation\" Ability { id: \"40BC\", source: \"Innocence\" }\r\n403.8 \"Soul And Body\" Ability { id: \"3EB1\", source: \"Innocence\" }\r\n416.7 \"--sync--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n420.9 \"Rightful Reprobation\" Ability { id: \"3EB5\", source: \"Innocence\" }\r\n428.2 \"Righteous Bolt\" Ability { id: \"3EA3\", source: \"Innocence\" }\r\n430.7 \"Reprobation\" Ability { id: \"3ECB\", source: \"Innocence\" }\r\n439.3 \"Shadowreaver\" Ability { id: \"3EEA\", source: \"Innocence\" }\r\n\r\n# add phase with manacles\r\n449.5 \"--add Phase--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n451.9 \"--untargetable--\" Ability { id: \"42B0\", source: \"Innocence\" }\r\n\r\n# looping final phase\r\n579.8 \"Flaming Sword\" Ability { id: \"3EC1\", source: \"Sword of Condemnation\" } window 600,0\r\n588.6 \"Flaming Sword\" Ability { id: \"4708\", source: \"Innocence\" }\r\n600.0 \"--targetable--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n605.7 \"God Ray\" #Ability { id: \"3EBE\", source: \"Innocence\" }\r\n610.8 \"God Ray\" #Ability { id: \"3EBE\", source: \"Innocence\" }\r\n615.9 \"God Ray\" #Ability { id: \"3EBE\", source: \"Innocence\" }\r\n618.1 \"--sync--\" Ability { id: \"38FC\", source: \"Innocence\" }\r\n623.1 \"Light Pillar\" Ability { id: \"3F3E\", source: \"Innocence\" }\r\n632.6 \"Winged Reprobation\" Ability { id: \"40BC\", source: \"Innocence\" }\r\n638.6 \"Holy Trinity\" #Ability { id: \"3EB3\", source: \"Innocence\" }\r\n638.6 \"Soul And Body\" Ability { id: \"3EB1\", source: \"Innocence\" }\r\n643.7 \"Holy Trinity\" #Ability { id: \"3EB3\", source: \"Innocence\" }\r\n644.6 \"Righteous Bolt\" Ability { id: \"3EA3\", source: \"Innocence\" }\r\n648.8 \"Holy Trinity\" #Ability { id: \"3EB3\", source: \"Innocence\" }\r\n651.8 \"--jump--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n658.5 \"Beatific Vision\" Ability { id: \"3EC7\", source: \"Innocence\" }\r\n676.8 \"Shadowreaver\" Ability { id: \"3EEA\", source: \"Innocence\" }\r\n685.0 \"--sync--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n689.2 \"Rightful Reprobation\" Ability { id: \"3EB5\", source: \"Innocence\" }\r\n695.8 \"Drop Of Light\" Ability { id: \"3EC4\", source: \"Innocence\" }\r\n697.9 \"--sync--\" Ability { id: \"38FC\", source: \"Innocence\" }\r\n699.1 \"Reprobation\" Ability { id: \"3ECB\", source: \"Innocence\" }\r\n702.9 \"Light Pillar\" Ability { id: \"3F3E\", source: \"Innocence\" }\r\n707.4 \"--jump--\" Ability { id: \"3EA2\", source: \"Innocence\" }\r\n714.2 \"Beatific Vision\" Ability { id: \"3EC7\", source: \"Innocence\" }\r\n730.4 \"Righteous Bolt\" Ability { id: \"3EA3\", source: \"Innocence\" }\r\n\r\n738.5 \"--targetable--\" Ability { id: \"3EA2\", source: \"Innocence\" } window 10,10 jump 600\r\n744.2 \"God Ray\"\r\n749.3 \"God Ray\"\r\n754.4 \"God Ray\"\r\n756.6 \"--sync--\"\r\n761.6 \"Light Pillar\"\r\n771.1 \"Winged Reprobation\"\r\n777.1 \"Holy Trinity\"\r\n777.1 \"Soul And Body\"\r\n782.2 \"Holy Trinity\"\r\n783.1 \"Righteous Bolt\"\r\n787.3 \"Holy Trinity\"\r\n790.3 \"--jump--\"\r\n797.0 \"Beatific Vision\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/levi-un.ts




// TODO: we could consider a timeline trigger for the Tidal Roar raidwide,
// but it barely does 25% health, has no startsUsing, and the timeline for
// this fight is not reliable enough to use.

// TODO: it'd be nice to call out the dives too, but there is no log line
// or combatant in the right place until ~4.5s after the nameplate toggles.
// This is about 1-2s after the splash appears, and so feels really late.
// Unfortunately the dives also have multiple combatants in plausible
// positions (+/-7, +/-20) and so more work would need to be done to tell
// them apart.
const levi_un_triggerSet = {
  id: 'TheWhorleaterUnreal',
  zoneId: zone_id/* default.TheWhorleaterUnreal */.Z.TheWhorleaterUnreal,
  timelineFile: 'levi-un.txt',
  triggers: [{
    id: 'LeviUn Dive Counter Tidal Wave Reset',
    type: 'Ability',
    netRegex: {
      source: 'Leviathan',
      id: '5CDE',
      capture: false
    },
    run: data => {
      // There's always a slam after Tidal Wave.
      data.diveCounter = 1;
      // If you are running this unsynced and don't hit the button,
      // then prevent "Hit the Button" calls on future dives.
      data.converter = false;
    }
  }, {
    id: 'LeviUn Dive Counter Body Slam Reset',
    type: 'Ability',
    netRegex: {
      source: 'Leviathan',
      id: '5CD2',
      capture: false
    },
    // Redundant, but this will keep things on track if anything goes awry.
    run: data => data.diveCounter = 1
  }, {
    id: 'LeviUn Dive Counter Wave Spume Adjust',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Wave Spume',
      capture: false
    },
    suppressSeconds: 5,
    // Usually the pattern is slam / dive / dive / slam, but after wave spumes appear,
    // there is a single dive then a slam.  Adjust for this one-off case here.
    run: data => data.diveCounter = 2
  }, {
    id: 'LeviUn Slam Location',
    type: 'NameToggle',
    netRegex: {
      name: 'Leviathan',
      toggle: '00',
      capture: false
    },
    condition: data => {
      data.diveCounter = (data.diveCounter || 0) + 1;
      return data.diveCounter % 3 === 1;
    },
    // Actor moves between 4.6s and 4.7s; add a tiny bit of time for certainty.
    delaySeconds: 5,
    promise: async data => {
      const callData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants'
      });
      if (!callData.combatants.length) {
        console.error('Dive: failed to get combatants: ${JSON.stringify(callData)}');
        return;
      }
      // This is the real levi, according to hp.
      console.log(JSON.stringify(callData));
      data.slamLevis = callData.combatants.filter(c => c.BNpcID === 12669);
    },
    alertText: (data, _matches, output) => {
      // Slams happen at +/-~14.6 +/-~13.
      const filtered = data.slamLevis?.filter(c => {
        const offsetX = Math.abs(Math.abs(c.PosX) - 14.6);
        const offsetY = Math.abs(Math.abs(c.PosY) - 13);
        return offsetX < 1 && offsetY < 1;
      }) ?? [];
      const levi = filtered[0];
      if (!levi || filtered.length !== 1) return;
      if (levi.PosY > 0) return output.north();
      return output.south();
    },
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      south: outputs/* default.south */.Z.south
    }
  }, {
    id: 'LeviUn Veil of the Whorl',
    type: 'Ability',
    netRegex: {
      source: 'Leviathan',
      id: '5CE5',
      capture: false
    },
    condition: data => util/* default.isCasterDpsJob */.Z.isCasterDpsJob(data.job) || util/* default.isHealerJob */.Z.isHealerJob(data.job),
    suppressSeconds: 9999,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Attack Head Only',
        de: 'Nur den Kopf angreifen',
        fr: 'Attaquez seulement la tête',
        ja: '頭だけに攻撃',
        cn: '攻击头部',
        ko: '머리만 공격하기'
      }
    }
  }, {
    id: 'LeviUn Mantle of the Whorl',
    type: 'Ability',
    netRegex: {
      source: 'Leviathan\'s Tail',
      id: '5CE4',
      capture: false
    },
    condition: data => util/* default.isRangedDpsJob */.Z.isRangedDpsJob(data.job),
    suppressSeconds: 9999,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Attack Tail Only',
        de: 'Nur den Schwanz angreifen',
        fr: 'Attaquez seulement la queue',
        ja: 'テールだけに攻撃',
        cn: '攻击尾巴',
        ko: '꼬리만 공격하기'
      }
    }
  }, {
    id: 'LeviUn Wavespine Sahagin Add',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Wavespine Sahagin',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.killAdds */.Z.killAdds
    }
  }, {
    id: 'LeviUn Wavetooth Sahagin Add',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Wavetooth Sahagin',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Wavetooth Add',
        de: 'Besiege Wellenzahn Add',
        fr: 'Tuez l\'add Dent-du-ressac',
        ja: 'ウェイブトゥース・サハギンに攻撃',
        cn: '优先击杀波齿鱼人',
        ko: '물결이빨 사하긴 처치'
      }
    }
  }, {
    id: 'LeviUn Wavetooth Sahagin Stun',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Wavetooth Sahagin'
    },
    condition: data => data.CanStun(),
    delaySeconds: 5,
    alertText: (_data, matches, output) => output.text({
      name: matches.name
    }),
    outputStrings: {
      text: outputs/* default.stunTarget */.Z.stunTarget
    }
  }, {
    id: 'LeviUn Gyre Spume',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Gyre Spume',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Gyre Spumes',
        de: 'Besiege Gischtblase',
        fr: 'Tuez les écumes concentriques',
        ja: 'ジャイヤ・スピュームに攻撃',
        cn: '打黄泡泡',
        ko: '노랑 물거품 처치'
      }
    }
  }, {
    id: 'LeviUn Wave Spume',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Wave Spume',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Wave Spume Adds',
        de: 'Gischtwelle Adds',
        fr: 'Adds Écumes ondulantes',
        ja: 'ウェイブ・スピューム出現',
        cn: '蓝泡泡出现',
        ko: '파랑 물거품 출현'
      }
    }
  }, {
    id: 'LeviUn Wave Spume Explosion',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Wave Spume',
      capture: false
    },
    // ~35.2 seconds from added combatant until :Aqua Burst:888: explosion.
    // Tell everybody because not much else going on in this fight,
    // and other people need to get away.
    delaySeconds: 30,
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Burst Soon',
        de: 'Gischtwelle platzen gleich',
        fr: 'Burst bientôt',
        ja: 'まもなく爆発',
        cn: '黄泡泡即将爆炸',
        ko: '물거품 폭발'
      }
    }
  }, {
    id: 'LeviUn Elemental Converter',
    type: 'NameToggle',
    netRegex: {
      name: 'Elemental Converter'
    },
    run: (data, matches) => data.converter = !!parseInt(matches.toggle)
  }, {
    id: 'LeviUn Hit The Button',
    type: 'NameToggle',
    netRegex: {
      name: 'Leviathan',
      toggle: '00',
      capture: false
    },
    // The best way to know if it's time to hit the button is if the converter is ready.
    // I think this is not true for hard mode, but is true (fingers crossed) for extreme.
    condition: data => data.converter,
    // Some delay for safety, as the button can be hit too early.
    delaySeconds: 3.5,
    suppressSeconds: 30,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hit The Button!',
        de: 'Mit Elementarumwandler interagieren!',
        fr: 'Activez la barrière !',
        ja: '魔法障壁を発動',
        cn: '打开开关！',
        ko: '장벽 발동!'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Elemental Converter': 'Elementarumwandler',
      'Leviathan(?!\'s)': 'Leviathan',
      'Leviathan\'s Tail': 'Leviathans Schwanz',
      'Gyre Spume': 'Gischtblase',
      'Wave Spume': 'Gischtwelle',
      'Wavetooth Sahagin': 'Wellenzahn-Sahagin',
      'Wavespine Sahagin': 'Wellendorn-Sahagin'
    },
    'replaceText': {
      'Aqua Breath': 'Aqua-Atem',
      'Aqua Burst': 'Aquatischer Knall',
      'Body Slam': 'Bugwelle',
      'Briny Veil': 'Wasserspiegelung',
      'Dread Tide': 'Hydrophobie',
      'Grand Fall': 'Wasserfall',
      'Gyre Spume': 'Gischtblase',
      'Mantle Of The Whorl': 'Wogenmantel',
      'Spinning Dive': 'Drehsprung',
      'Tail Whip': 'Schwanzpeitsche',
      'Tidal Roar': 'Schrei der Gezeiten',
      'Tidal Wave': 'Flutwelle',
      'Veil Of The Whorl': 'Wogenschleier',
      'Waterspout': 'Wasserhose',
      'Wave Spume': 'Gischtwelle',
      'Wavespine Sahagin': 'Wellendorn-Sahagin',
      'Wavetooth Sahagin': 'Wellenzahn-Sahagin'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Elemental Converter': 'activateur de la barrière',
      'Leviathan(?!\'s)': 'Léviathan',
      'Leviathan\'s Tail': 'queue de Léviathan',
      'Gyre Spume': 'écume concentrique',
      'Wave Spume': 'écume ondulante',
      'Wavetooth Sahagin': 'Sahuagin dent-du-ressac',
      'Wavespine Sahagin': 'Sahuagin épine-du-ressac'
    },
    'replaceText': {
      '\\(NW\\)': '(NO)',
      'Aqua Breath': 'Aquasouffle',
      'Aqua Burst': 'Explosion aquatique',
      'Body Slam': 'Charge physique',
      'Briny Veil': 'Miroir d\'eau',
      'Dread Tide': 'Onde terrifiante',
      'Grand Fall': 'Chute grandiose',
      'Gyre Spume': 'écume concentrique',
      'Mantle Of The Whorl': 'Manteau du Déchaîneur',
      'Spinning Dive': 'Piqué tournant',
      'Tail Whip': 'Coup caudal',
      'Tidal Roar': 'Vague rugissante',
      'Tidal Wave': 'Raz-de-marée',
      'Veil Of The Whorl': 'Voile du Déchaîneur',
      'Waterspout': 'Inondation',
      'Wave Spume': 'écume ondulante',
      'Wavespine Sahagin': 'Sahuagin épine-du-ressac',
      'Wavetooth Sahagin': 'Sahuagin dent-du-ressac'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Elemental Converter': '魔法障壁発動器',
      'Leviathan(?!\'s)': 'リヴァイアサン',
      'Leviathan\'s Tail': 'リヴァイアサン・テール',
      'Gyre Spume': 'ジャイヤ・スピューム',
      'Wave Spume': 'ウェイブ・スピューム',
      'Wavetooth Sahagin': 'ウェイブトゥース・サハギン',
      'Wavespine Sahagin': 'ウェイブスパイン・サハギン'
    },
    'replaceText': {
      'Aqua Breath': 'アクアブレス',
      'Aqua Burst': 'アクアバースト',
      'Body Slam': 'ボディスラム',
      'Briny Veil': 'ウォーターミラー',
      'Dread Tide': 'ドレッドウォーター',
      'Grand Fall': 'グランドフォール',
      'Gyre Spume': 'ジャイヤ・スピューム',
      'Mantle Of The Whorl': '水神のマント',
      'Spinning Dive': 'スピニングダイブ',
      'Tail Whip': 'テールウィップ',
      'Tidal Roar': 'タイダルロア',
      'Tidal Wave': 'タイダルウェイブ',
      'Veil Of The Whorl': '水神のヴェール',
      'Waterspout': 'オーバーフラッド',
      'Wave Spume': 'ウェイブ・スピューム',
      'Wavespine Sahagin': 'ウェイブスパイン・サハギン',
      'Wavetooth Sahagin': 'ウェイブトゥース・サハギン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Elemental Converter': '魔法障壁发动器',
      'Leviathan(?!\'s)': '利维亚桑',
      'Leviathan\'s Tail': '利维亚桑的尾巴',
      'Gyre Spume': '游涡泡沫',
      'Wave Spume': '巨浪泡沫',
      'Wavetooth Sahagin': '波齿鱼人',
      'Wavespine Sahagin': '波棘鱼人'
    },
    'replaceText': {
      'Aqua Breath': '水流吐息',
      'Aqua Burst': '流水爆发',
      'Body Slam': '猛撞',
      'Briny Veil': '海水镜面',
      'Dread Tide': '恐慌潮水',
      'Grand Fall': '九天落水',
      'Gyre Spume': '游涡泡沫',
      'Mantle Of The Whorl': '水神的披风',
      'Spinning Dive': '旋转下潜',
      'Tail Whip': '扫尾',
      'Tidal Roar': '怒潮咆哮',
      'Tidal Wave': '巨浪',
      'Veil Of The Whorl': '水神的面纱',
      'Waterspout': '海龙卷',
      'Wave Spume': '巨浪泡沫',
      'Wavespine Sahagin': '波棘鱼人',
      'Wavetooth Sahagin': '波齿鱼人'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Elemental Converter': '마법 장벽 발동기',
      'Leviathan(?!\'s)': '리바이어선',
      'Leviathan\'s Tail': '리바이어선 꼬리',
      'Gyre Spume': '소용돌이치는 물거품',
      'Wave Spume': '파도치는 물거품',
      'Wavetooth Sahagin': '물결이빨 사하긴',
      'Wavespine Sahagin': '물결등뼈 사하긴'
    },
    'replaceText': {
      'Aqua Breath': '물의 숨결',
      'Aqua Burst': '물방울 폭발',
      'Body Slam': '몸통 박기',
      'Briny Veil': '물의 거울',
      'Dread Tide': '공포의 물결',
      'Grand Fall': '강우',
      'Gyre Spume': '소용돌이치는 물거품',
      'Mantle Of The Whorl': '수신의 망토',
      'Spinning Dive': '고속 돌진',
      'Tail Whip': '꼬리 채찍',
      'Tidal Roar': '바다의 포효',
      'Tidal Wave': '해일',
      'Veil Of The Whorl': '수신의 장막',
      'Waterspout': '물폭풍',
      'Wave Spume': '파도치는 물거품',
      'Wavespine Sahagin': '물결등뼈 사하긴',
      'Wavetooth Sahagin': '물결이빨 사하긴'
    }
  }]
};
/* harmony default export */ const levi_un = (levi_un_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/levi-un.txt
const trial_levi_un_namespaceObject = "### Leviathan Unreal\r\n# -p 5CD2:33.1 5CDE:286.5\r\n# -ii 5CCF 5CCA 5CCB 5CCC 5CD1 5CEB 5CD8 5CDC 5CE8 5CD7 5CD6 5CDD 5CE8 5CE3 5CE9 5CE1 5CE7 5CE6 5CD5 5CD6 5CE2 5CD4 5CD3 5CD9\r\n# -it \"Leviathan\"\r\n\r\n# Note: Briny Veil (5CE1) is applied initially after the first jumps and then\r\n# whenever it falls off the person tanking the tail.  It is ignored after the\r\n# first time in the rest of the timeline because any jump will desync it.\r\n\r\n# Note: Some pushes in this fight are relative to boss hp and others are\r\n# related to Gyre Spume hp.  For instance, if Levi is pushed to 50% very\r\n# quickly the Spumes will spawn (but the Sahagin will keep spawning).\r\n# However, the fight is also relative to spume hp.  Even if Levi is at\r\n# 100%, if the spumes are killed very very quickly then Levi will skip\r\n# the 2x Spinning Dive + Body Slam section and go immediately into\r\n# 1x Spinning Dive + Tidal Wave.\r\n\r\n# Worse, the spumes appear both on a timer and on an hp push (so you can't sync)\r\n# and behavior seems different once the spumes appear.\r\n\r\n# Levi *ALSO* has multiple pushes, possibly every 10%.  For instance,\r\n# if you push to 80% in the initial phase with a strong hit, he will\r\n# go directly into the Briny Veil.\r\n\r\n# This timeline mostly just throws up its hands and tries to do its best\r\n# for the \"slow\" case where you're not doing any pushes whatsoever.\r\n# It's tough to sync and know the difference between 228.9 untargetable\r\n# and 275.2 untargetable (a tidal roar before? extra grand falls?),\r\n# but that's not something that can be done with timeline syncs.\r\n\r\n# All of this wordiness is to say that it's tough to sync this timeline properly,\r\n# sorry.\r\n\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1: Literally Just Autos (100% -> 90%)\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n25.8 \"--untargetable--\" NameToggle { name: \"Leviathan\", toggle: \"00\" } window 30,10\r\n\r\n### Phase 2: One Set of Orbs (90% -> 50%?)\r\n33.0 \"--targetable--\"\r\n33.1 \"Body Slam\" Ability { id: \"5CD2\", source: \"Leviathan\" } window 40,10\r\n38.3 \"Veil Of The Whorl\" Ability { id: \"5CE5\", source: \"Leviathan\" } window 40,10\r\n43.3 \"Mantle Of The Whorl\" Ability { id: \"5CE4\", source: \"Leviathan's Tail\" }\r\n45.6 \"--2x Wavespine Sahagin (N)--\"\r\n53.2 \"Aqua Breath\" Ability { id: \"5CCD\", source: \"Leviathan\" }\r\n59.3 \"Tail Whip\" Ability { id: \"5CCE\", source: \"Leviathan's Tail\" }\r\n60.4 \"Waterspout\" Ability { id: \"5CD0\", source: \"Leviathan\" }\r\n73.8 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n77.9 \"Tidal Roar\" Ability { id: \"5CDA\", source: \"Leviathan\" }\r\n\r\n85.2 \"--untargetable--\"\r\n88.3 \"Grand Fall\" Ability { id: \"5CDF\", source: \"Leviathan\" }\r\n90.8 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n94.3 \"Grand Fall\" Ability { id: \"5CDF\", source: \"Leviathan\" }\r\n95.8 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n101.5 \"--targetable--\"\r\n\r\n101.6 \"Body Slam\" Ability { id: \"5CD2\", source: \"Leviathan\" } window 30,30\r\n106.0 \"Briny Veil\" Ability { id: \"5CE1\", source: \"Leviathan\" }\r\n110.7 \"--Wavetooth Sahagin (E)--\"\r\n121.0 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n125.1 \"Aqua Breath\" Ability { id: \"5CCD\", source: \"Leviathan\" }\r\n126.0 \"Tail Whip\" Ability { id: \"5CCE\", source: \"Leviathan's Tail\" }\r\n132.3 \"Waterspout\" Ability { id: \"5CD0\", source: \"Leviathan\" }\r\n145.7 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n149.8 \"Tidal Roar\" Ability { id: \"5CDA\", source: \"Leviathan\" }\r\n\r\n154.9 \"--untargetable--\"\r\n158.0 \"Grand Fall x3\" #Ability { id: \"5CDF\", source: \"Leviathan\" }\r\n160.5 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n165.4 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n171.1 \"--targetable--\"\r\n\r\n171.2 \"Body Slam\" Ability { id: \"5CD2\", source: \"Leviathan\" } window 30,30\r\n180.8 \"--4x Gyre Spume--\"\r\n192.7 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n196.3 \"Tail Whip\" #Ability { id: \"5CCE\", source: \"Leviathan's Tail\" }\r\n196.8 \"Aqua Breath\" Ability { id: \"5CCD\", source: \"Leviathan\" }\r\n204.0 \"Waterspout\" Ability { id: \"5CD0\", source: \"Leviathan\" }\r\n217.3 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n221.4 \"Tidal Roar\" Ability { id: \"5CDA\", source: \"Leviathan\" }\r\n\r\n228.9 \"--untargetable--\"\r\n232.0 \"Grand Fall x3\" #Ability { id: \"5CDF\", source: \"Leviathan\" }\r\n234.5 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n239.4 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n245.1 \"--targetable--\"\r\n\r\n245.2 \"Body Slam\" Ability { id: \"5CD2\", source: \"Leviathan\" } window 30,30\r\n267.5 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n\r\n275.2 \"--untargetable--\"\r\n278.3 \"Grand Fall\" Ability { id: \"5CDF\", source: \"Leviathan\" }\r\n280.8 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n280.8 \"--untargetable--\"\r\n286.5 \"Tidal Wave\" Ability { id: \"5CDE\", source: \"Leviathan\" } window 300,100\r\n\r\n\r\n### Phase 3: Two Sets of Orbs (50% -> 20%?)\r\n299.2 \"--targetable--\"\r\n299.3 \"Body Slam\" Ability { id: \"5CD2\", source: \"Leviathan\" } window 30,30\r\n301.3 \"--2x Wavespine Sahagin (S)--\"\r\n318.6 \"Aqua Breath\" Ability { id: \"5CCD\", source: \"Leviathan\" }\r\n318.6 \"Tail Whip\" #Ability { id: \"5CCE\", source: \"Leviathan's Tail\" }\r\n322.7 \"Waterspout\" Ability { id: \"5CD0\", source: \"Leviathan\" }\r\n329.9 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n338.1 \"Tidal Roar\" Ability { id: \"5CDA\", source: \"Leviathan\" }\r\n\r\n347.3 \"--untargetable--\"\r\n350.4 \"Grand Fall\" Ability { id: \"5CDF\", source: \"Leviathan\" }\r\n352.9 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n357.8 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n\r\n363.5 \"--targetable--\"\r\n363.6 \"Body Slam\" Ability { id: \"5CD2\", source: \"Leviathan\" } window 30,30\r\n364.9 \"--4x Gyre Spume--\"\r\n382.9 \"Aqua Breath\" Ability { id: \"5CCD\", source: \"Leviathan\" }\r\n385.0 \"Tail Whip\" #Ability { id: \"5CCE\", source: \"Leviathan's Tail\" }\r\n387.1 \"Waterspout\" Ability { id: \"5CD0\", source: \"Leviathan\" }\r\n394.3 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n402.4 \"--4x Wave Spume--\"\r\n402.5 \"Tidal Roar\" Ability { id: \"5CDA\", source: \"Leviathan\" }\r\n\r\n413.8 \"--untargetable--\"\r\n416.9 \"Grand Fall x3\" #Ability { id: \"5CDF\", source: \"Leviathan\" }\r\n419.4 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n\r\n\r\n425.1 \"--targetable--\"\r\n425.2 \"Body Slam\" Ability { id: \"5CD2\", source: \"Leviathan\" }\r\n435.3 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n439.6 \"Aqua Burst\" Ability { id: \"888\", source: \"Wave Spume\" }\r\n442.5 \"Aqua Breath\" Ability { id: \"5CCD\", source: \"Leviathan\" }\r\n446.6 \"Waterspout\" Ability { id: \"5CD0\", source: \"Leviathan\" }\r\n455.8 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n462.5 \"--untargetable--\"\r\n465.6 \"Grand Fall x3\" #Ability { id: \"5CDF\", source: \"Leviathan\" }\r\n468.1 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n468.1 \"--untargetable--\"\r\n473.9 \"Tidal Wave\" Ability { id: \"5CDE\", source: \"Leviathan\" } window 150,100\r\n\r\n\r\n### Phase 4: more adds, enrage\r\n486.6 \"--targetable--\"\r\n486.7 \"Body Slam\" Ability { id: \"5CD2\", source: \"Leviathan\" } window 30,30\r\n488.2 \"--Wavetooth Sahagin (NW)--\"\r\n500.3 \"Tidal Roar\" Ability { id: \"5CDA\", source: \"Leviathan\" }\r\n508.5 \"Aqua Breath\" Ability { id: \"5CCD\", source: \"Leviathan\" }\r\n512.6 \"Waterspout\" Ability { id: \"5CD0\", source: \"Leviathan\" }\r\n512.6 \"Tail Whip\" #Ability { id: \"5CCE\", source: \"Leviathan's Tail\" }\r\n519.8 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n523.9 \"Tidal Roar\" Ability { id: \"5CDA\", source: \"Leviathan\" }\r\n\r\n532.1 \"--untargetable--\"\r\n535.2 \"Grand Fall x3\" #Ability { id: \"5CDF\", source: \"Leviathan\" }\r\n537.7 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n542.6 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n\r\n548.3 \"--targetable--\"\r\n548.4 \"Body Slam\" Ability { id: \"5CD2\", source: \"Leviathan\" } window 30,30\r\n563.6 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n567.7 \"Tidal Roar\" Ability { id: \"5CDA\", source: \"Leviathan\" }\r\n581.1 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n587.3 \"Tidal Roar\" Ability { id: \"5CDA\", source: \"Leviathan\" }\r\n600.9 \"--2x Wavespine Sahagin--\" # ? not sure where\r\n601.6 \"Tidal Roar\" Ability { id: \"5CDA\", source: \"Leviathan\" }\r\n609.8 \"Aqua Breath\" Ability { id: \"5CCD\", source: \"Leviathan\" }\r\n613.9 \"Waterspout\" Ability { id: \"5CD0\", source: \"Leviathan\" }\r\n614.8 \"Tail Whip\" #Ability { id: \"5CCE\", source: \"Leviathan's Tail\" }\r\n621.1 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n625.2 \"Tidal Roar\" Ability { id: \"5CDA\", source: \"Leviathan\" }\r\n\r\n634.1 \"--untargetable--\"\r\n637.2 \"Grand Fall x3\" Ability { id: \"5CDF\", source: \"Leviathan\" }\r\n639.7 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n644.6 \"Spinning Dive\" Ability { id: \"5CDB\", source: \"Leviathan\" }\r\n\r\n650.3 \"--targetable--\"\r\n650.4 \"Body Slam\" Ability { id: \"5CD2\", source: \"Leviathan\" } window 30,30\r\n665.6 \"Dread Tide\" Ability { id: \"5CC9\", source: \"Leviathan\" }\r\n\r\n669.6 \"--untargetable--\"\r\n676.9 \"Tidal Wave Enrage\" Ability { id: \"5CDE\", source: \"Leviathan\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/ruby_weapon-ex.ts





// TODO: ravensflight calls would be nice

const ruby_weapon_ex_triggerSet = {
  id: 'CinderDriftExtreme',
  zoneId: zone_id/* default.CinderDriftExtreme */.Z.CinderDriftExtreme,
  timelineFile: 'ruby_weapon-ex.txt',
  timelineTriggers: [{
    id: 'RubyEx Magitek Meteor Behind',
    regex: /Magitek Meteor/,
    beforeSeconds: 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Meteor',
        de: 'Hinter dem Meteor verstecken',
        fr: 'Cachez-vous derrière le météore',
        ja: 'メテオの後ろに',
        cn: '躲在陨石后',
        ko: '운석 뒤에 숨기'
      }
    }
  }, {
    id: 'RubyEx Magitek Meteor Away',
    regex: /Magitek Meteor/,
    beforeSeconds: 0,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Meteor',
        de: 'Weg vom Meteor',
        fr: 'Éloignez-vous du météore',
        ja: 'メテオから離れる',
        cn: '远离陨石',
        ko: '운석에게서 멀어지기'
      }
    }
  }],
  triggers: [{
    id: 'RubyEx Optimized Ultima',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4ABE',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'RubyEx Stamp',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4B03'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'RubyEx Ravensclaw',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4ACC',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Line Ends',
        de: 'Weg von den Linienenden',
        fr: 'Éloignez-vous des fins de lignes',
        ja: '線の端から避ける',
        cn: '远离线末端',
        ko: '선 끝나는 곳 피하기'
      }
    }
  }, {
    id: 'RubyEx Undermine',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AD0',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from Lines',
        de: 'Weg von den Linien',
        fr: 'Éloignez-vous des sillons',
        ja: '線から離れる',
        cn: '远离线',
        ko: '선 피하기'
      }
    }
  }, {
    id: 'RubyEx Liquefaction',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4ACF',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get On Lines',
        de: 'Auf die Linien gehen',
        fr: 'Allez sur les sillons',
        ja: '線を踏む',
        cn: '靠近线',
        ko: '선 위로 올라가기'
      }
    }
  }, {
    id: 'RubyEx Liquefaction Ravensflight',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AEC',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.seenFlight) return output.outOfMiddle();
      return output.getMiddle();
    },
    run: data => data.seenFlight = true,
    outputStrings: {
      getMiddle: outputs/* default.goIntoMiddle */.Z.goIntoMiddle,
      outOfMiddle: {
        en: 'Out Of Middle',
        de: 'Raus aus der Mitte',
        fr: 'Sortez du milieu',
        ja: '横へ',
        cn: '远离中间',
        ko: '가운데 피하기'
      }
    }
  }, {
    id: 'RubyEx Ruby Ray',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4B02',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'RubyEx Cut And Run',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4B05',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'RubyEx High-Powered Homing Lasers',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AD8',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }, {
    // Enrage can start casting before Ruby Weapon has finished their rotation
    // Give a friendly reminder to pop LB3 if you haven't already
    id: 'RubyEx Optimized Ultima Enrage',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4B2D',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Enrage!',
        de: 'Finalangriff!',
        fr: 'Enrage !',
        ja: '時間切れ!',
        cn: '狂暴',
        ko: '전멸기!'
      }
    }
  }, {
    id: 'RubyEx Raven\'s Image',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Raven\'s Image'
    },
    run: (data, matches) => {
      // 112,108 (east)
      // 88,108 (west)
      // TODO: it's impossible to do anything with this now,
      // as there's no actor id in the startsUsing line.  T_T
      data.ravens ??= {};
      if (parseFloat(matches.x) < 100) data.ravens.red = matches.id;else data.ravens.blue = matches.id;
    }
  }, {
    id: 'RubyEx Pall of Rage',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8A2'
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    run: (data, matches) => {
      // data.colors is the color of the add you are attacking (this debuff is red).
      data.colors ??= {};
      data.colors[matches.target] = 'blue';
    },
    outputStrings: {
      text: {
        en: 'Attack Blue (East)',
        de: 'Greife Blau an (Osten)',
        fr: 'Attaquez le bleu (Est)',
        ja: '青色に攻撃 (東)',
        cn: '攻击蓝色(东)',
        ko: '파란색 공격 (오른쪽)'
      }
    }
  }, {
    id: 'RubyEx Pall of Grief',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8A3'
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    run: (data, matches) => {
      // data.colors is the color of the add you are attacking (this debuff is blue).
      data.colors ??= {};
      data.colors[matches.target] = 'red';
    },
    outputStrings: {
      text: {
        en: 'Attack Red (West)',
        de: 'Greife Rot an (Westen)',
        fr: 'Attaquez le rouge (Ouest)',
        ja: '赤色に攻撃 (西)',
        cn: '攻击红色(西)',
        ko: '빨간색 공격 (왼쪽)'
      }
    }
  }, {
    id: 'RubyEx Meteor Stream',
    type: 'HeadMarker',
    netRegex: {
      id: '00E0'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'RubyEx Ruby Claw',
    type: 'StartsUsing',
    netRegex: {
      source: 'Raven\'s Image',
      id: '4AFF'
    },
    condition: (data, matches) => {
      if (data.role === 'dps' && data.job !== 'BLU') return false;
      const myColor = data.colors?.[data.me];
      if (myColor !== undefined && myColor === data.colors?.[matches.target]) return true;
      return data.me === matches.target;
    },
    suppressSeconds: 1,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'RubyEx Raven Death',
    type: 'LosesEffect',
    netRegex: {
      effectId: '8A3',
      capture: false
    },
    suppressSeconds: 10,
    run: data => {
      // This effect persists through death, and is removed off of everybody
      // about two seconds before the 19: defeated log line.
      // TODO: it'd be nice to say to attack the other add, if you knew which one was dead.
      data.ravenDead = true;
    }
  }, {
    id: 'RubyEx Image Colors',
    type: 'GainsEffect',
    // Blind to Rage: 8A0
    // Blind to Grief: 8A1
    netRegex: {
      effectId: ['8A0', '8A1']
    },
    run: (data, matches) => {
      const isBlue = matches.effectId.toUpperCase() === '8A1';
      data.colorToImageId ??= {};
      data.colorToImageId[isBlue ? 'blue' : 'red'] = matches.targetId;
    }
  }, {
    id: 'RubyEx Image Chariot Dynamo Collect',
    type: 'StartsUsing',
    // Lunar Dynamo = 4EB0
    // Iron Chariot = 4EB1
    netRegex: {
      source: 'Raven\'s Image',
      id: ['4EB0', '4EB1']
    },
    run: (data, matches) => {
      data.imageIdToAction ??= {};
      data.imageIdToAction[matches.sourceId] = matches.id;
    }
  }, {
    id: 'RubyEx Image Chariot Dynamo',
    type: 'StartsUsing',
    // Lunar Dynamo = 4EB0
    // Iron Chariot = 4EB1
    netRegex: {
      source: 'Raven\'s Image',
      id: ['4EB0', '4EB1'],
      capture: false
    },
    delaySeconds: 0.1,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        text: {
          en: '${dir} (${suffix})',
          de: '${dir} (${suffix})',
          fr: '${dir} (${suffix})',
          ja: '${dir} (${suffix})',
          cn: '${dir} (${suffix})',
          ko: '${dir} (${suffix})'
        },
        out: outputs/* default.out */.Z.out,
        in: outputs/* default.in */.Z["in"],
        blueSuffix: {
          en: 'blue',
          de: 'Blau',
          fr: 'Bleu',
          ja: '青',
          cn: '蓝',
          ko: '파랑'
        },
        redSuffix: {
          en: 'red',
          de: 'Rot',
          fr: 'Rouge',
          ja: '赤',
          cn: '红',
          ko: '빨강'
        },
        bothSuffix: {
          en: 'both',
          de: 'Beides',
          fr: 'Les deux',
          ja: '両方',
          cn: '全部',
          ko: '둘 다'
        }
      };
      if (!data.colorToImageId || !data.imageIdToAction) return;
      const myColor = data.colors && data.colors[data.me];
      const colorToAction = {};
      for (const color of ['blue', 'red']) {
        const id = data.colorToImageId[color];
        if (id === undefined) continue;
        const action = data.imageIdToAction[id];
        if (action === undefined) continue;
        colorToAction[color] = action;
      }
      const numAdds = Object.keys(colorToAction).length;
      let suffix;
      let actionId;
      if (numAdds === 2 && colorToAction['blue'] === colorToAction['red']) {
        actionId = colorToAction['blue'];
        suffix = output.bothSuffix();
      } else if (numAdds === 1) {
        const color = Object.keys(colorToAction)[0];
        if (color === undefined) throw new not_reached/* UnreachableCode */.$();
        suffix = color === 'blue' ? output.blueSuffix() : output.redSuffix();
        actionId = colorToAction[color];
      } else if (myColor !== undefined && colorToAction[myColor] !== undefined) {
        suffix = myColor === 'blue' ? output.blueSuffix() : output.redSuffix();
        actionId = colorToAction[myColor];
      } else {
        // Two adds doing different things but somehow you died and don't have a color.
        // Don't call anything out, because it'd be confusing.
        return;
      }
      if (actionId === undefined) return;
      const isDynamo = actionId === '4EB0';
      const text = isDynamo ? 'alertText' : 'alarmText';
      const actionStr = isDynamo ? output.in() : output.out();
      return {
        [text]: output.text({
          dir: actionStr,
          suffix: suffix
        })
      };
    },
    run: data => delete data.imageIdToAction
  }, {
    id: 'RubyEx Change of Heart',
    type: 'Ability',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AFC',
      capture: false
    },
    preRun: data => {
      data.ravens ??= {};
      const tmp = data.ravens.red;
      data.ravens.red = data.ravens.blue;
      data.ravens.blue = tmp;
    },
    // This gets cast twice (maybe once for each add)?
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      // TODO: it'd be nice to call out which raven was alive?
      if (data.ravenDead) return;
      const color = data.colors?.[data.me];
      if (color === undefined) return;
      if (color === 'red') return output.attackRedEast();
      return output.attackBlueWest();
    },
    outputStrings: {
      attackRedEast: {
        en: 'Attack Red (East)',
        de: 'Greife Rot an (Osten)',
        fr: 'Attaquez le rouge (Est)',
        ja: '赤色に攻撃 (東)',
        cn: '攻击红色(东)',
        ko: '빨간색 공격 (오른쪽)'
      },
      attackBlueWest: {
        en: 'Attack Blue (West)',
        de: 'Greife Blau an (Westen)',
        fr: 'Attaquez le bleu (Ouest)',
        ja: '青色に攻撃 (西)',
        cn: '攻击蓝色(西)',
        ko: '파란색 공격 (왼쪽)'
      }
    }
  }, {
    id: 'RubyEx White Agony Tether',
    type: 'Tether',
    // White Agony is the blue head.
    // This trigger doesn't run for the initial tether because the add
    // spawns with the tether, but will run if somebody dies.
    netRegex: {
      source: 'White Agony',
      id: '0011'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        text: {
          en: 'Blue Head (Go East)',
          de: 'Blauer Kopf (Geh nach Osten)',
          fr: 'Tête bleu (Allez à l\'est)',
          ja: '青いヘッド (東へ)',
          cn: '蓝头 (去东边)',
          ko: '파란색 (동쪽)'
        }
      };

      // Use alarm if you have to go to the opposite color of the one you would be attacking.
      const textType = data.colors && data.colors[data.me] === 'blue' ? 'alarmText' : 'alertText';
      return {
        [textType]: output.text()
      };
    }
  }, {
    id: 'RubyEx White Fury Tether',
    type: 'Tether',
    // White Fury is the red head.
    // This trigger doesn't run for the initial tether because the add
    // spawns with the tether, but will run if somebody dies.
    netRegex: {
      source: 'White Fury',
      id: '0011'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        text: {
          en: 'Red Head (Go West)',
          de: 'Roter Kopf (Geh nach Westen)',
          fr: 'Tête rouge (Allez à l\'ouest)',
          ja: '赤いヘッド (西へ)',
          cn: '红头 (去西边)',
          ko: '빨간색 (서쪽)'
        }
      };

      // Use alarm if you have to go to the opposite color of the one you would be attacking.
      const textType = data.colors && data.colors[data.me] === 'red' ? 'alarmText' : 'alertText';
      return {
        [textType]: output.text()
      };
    }
  }, {
    id: 'RubyEx Negative Aura',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AFE',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'RubyEx Meteor',
    type: 'HeadMarker',
    netRegex: {
      id: '00(?:C[A-F]|D0|D1)'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, matches, output) => output.text({
      num: parseInt(matches.id, 16) - parseInt('00CA', 16) + 1
    }),
    outputStrings: {
      text: {
        en: '${num}',
        de: '${num}',
        fr: '${num}',
        ja: '${num}',
        cn: '${num}',
        ko: '${num}'
      }
    }
  }, {
    id: 'RubyEx Screech',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AEE',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'RubyEx Magitek Meteor Burst',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AF0',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from Meteor!',
        de: 'Weg vom Meteor!',
        fr: 'Éloignez-vous du météore !',
        ja: 'メテオから離れる',
        cn: '远离陨石',
        ko: '운석에게서 멀어지기'
      }
    }
  }, {
    id: 'RubyEx Mark II Magitek Comet Tank',
    type: 'Ability',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AB6',
      capture: false
    },
    condition: data => data.role === 'tank' || data.job === 'BLU',
    delaySeconds: 11.5,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in Meteor Tankbuster',
        de: 'Stehe im Meteor - Tankbuster',
        fr: 'Tank buster, Restez dans la comète',
        ja: 'タンクバスター、メテオへ',
        cn: '接刀',
        ko: '운석 막기'
      }
    }
  }, {
    id: 'RubyEx Mark II Magitek Comet Other',
    type: 'Ability',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AB6',
      capture: false
    },
    condition: data => data.role !== 'tank',
    delaySeconds: 13,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Meteor Adds',
        de: 'Besiege die Meteor Adds',
        fr: 'Tuez les comètes',
        ja: 'メテオを処理',
        cn: '击杀陨石',
        ko: '운석 부수기'
      }
    }
  }, {
    id: 'RubyEx Bradamante',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid tanks with laser',
        de: 'Tanks nicht mit dem Laser treffen',
        fr: 'Évitez les tanks avec votre laser',
        ja: 'タンクレーザーを避け',
        cn: '躲开坦克激光',
        ko: '레이저 대상자 - 탱커 피하기'
      }
    }
  }, {
    id: 'RubyEx Mark II Magitek Comet Directions',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Comet'
    },
    infoText: (_data, matches, output) => {
      // Possible positions:
      // 85.16,100.131 and 115.16,100.131
      // 100.16,85.13102 and 100.16,115.131
      if (parseFloat(matches.y) < 90) return output.cometsNorthSouth();else if (parseFloat(matches.x) < 90) return output.cometsEastWest();
    },
    outputStrings: {
      cometsNorthSouth: {
        en: 'Comets N/S',
        de: 'Meteor N/S',
        fr: 'Comètes N/S',
        ja: 'コメット 北/南',
        cn: '彗星 北/南',
        ko: '남/북 운석 낙하'
      },
      cometsEastWest: {
        en: 'Comets E/W',
        de: 'Meteor O/W',
        fr: 'Comètes E/O',
        ja: 'コメット 東/西',
        cn: '彗星 东/西',
        ko: '동/서 운석낙하'
      }
    }
  }, {
    id: 'RubyEx Outrage',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4B04',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'The Ruby Weapon': 'Rubin-Waffe',
      'Ruby Bit': 'Rubin-Drohne',
      'Raven\'s Image': 'Naels Trugbild',
      'Meteor': 'Meteor',
      'Comet': 'Komet',
      'White Agony': 'Naels Trauer',
      'White Fury': 'Naels Zorn'
    },
    'replaceText': {
      'Undermine': 'Untergraben',
      'Stamp': 'Zerstampfen',
      'Spike Of Flame': 'Flammenstachel',
      'Ruby Sphere': 'Rubin-Sphäre',
      'Ruby Ray': 'Rubin-Strahl',
      'Ruby Dynamics': 'Rubin-Dynamo',
      'Ravensflight': 'Flug des Raben',
      'Ravensclaw': 'Rabenklauen',
      'Optimized Ultima': 'Ultima-System',
      'Magitek Ray': 'Magitek-Laser',
      'Magitek Charge': 'Magitek-Sprengladung',
      'Magitek Bit': 'Magitek-Bit',
      'Liquefaction': 'Verflüssigen',
      '(?<! )Homing Lasers': 'Leitlaser',
      'Helicoclaw': 'Spiralklauen',
      'Flexiclaw': 'Flex-Klauen',
      'Bradamante': 'Bradamante',
      'Burst': 'Explosion',
      'Chariot/Dynamo': 'Streitwagen/Dynamo',
      'Dalamud Impact': 'Dalamud-Sturz',
      'Landing': 'Einschlag',
      'Change Of Heart': 'Sinneswandel',
      'Cut And Run': 'Klauensturm',
      'Greater Memory': 'Tiefe Erinnerung',
      'High-Powered Homing Lasers': 'Hochenergie-Leitlaser',
      'Magitek Meteor': 'Magitek-Meteor',
      'Mark II Magitek Comet': 'Magitek-Komet Stufe II',
      'Meteor Mine': 'Meteorsprengung',
      'Meteor Project': 'Projekt Meteor',
      'Meteor Stream': 'Meteorflug',
      'Negative Affect': 'Affectus Negativa',
      'Negative Aura': 'Aura Negativa',
      'Negative Personae': 'Persona Negativa',
      'Outrage': 'Empörung',
      'Ruby Claw': 'Rubin-Klauen',
      'Screech': 'Kreischen',
      'Tank Comets': 'Tank Meteore',
      '--cutscene--': '--Zwischensequenz--'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Comet': 'Comète',
      'Meteor': 'Météore',
      'Ruby Bit': 'Drones rubis',
      'Raven\'s Image': 'Spectre De Nael',
      'The Ruby Weapon': 'Arme Rubis',
      'White Agony': 'Angoisse De Nael',
      'White Fury': 'Fureur De Nael'
    },
    'replaceText': {
      '\\?': ' ?',
      '--cutscene--': '--cinématique--',
      'Undermine': 'Griffe souterraine',
      'Tank Comets': 'Comètes Tank',
      'Stamp': 'Piétinement sévère',
      'Spike Of Flame': 'Explosion de feu',
      'Screech': 'Éclat de voix',
      'Ruby Sphere': 'Sphère rubis',
      'Ruby Ray': 'Rayon rubis',
      'Ruby Dynamics': 'Générateur rubis',
      'Ruby Claw': 'Griffe rubis',
      'Ravensflight': 'Vol du rapace',
      'Ravensclaw': 'Griffes du rapace',
      'Outrage': 'Indignation',
      'Optimized Ultima': 'Ultima magitek',
      'Negative Personae': 'Ipséité négative',
      'Negative Aura': 'Aura négative',
      'Negative Affect': 'Affect négatif',
      'Meteor Stream': 'Rayon météore',
      'Meteor Project': 'Projet Météore',
      'Meteor Mine': 'Météore explosif',
      'Mark II Magitek Comet': 'Comète magitek II',
      'Magitek Ray': 'Laser magitek',
      'Magitek Meteor': 'Météore magitek',
      'Magitek Charge': 'Éthéroplasma magitek',
      'Magitek Bit': 'Éjection de drones',
      'Landing': 'Atterrissage rapide',
      'Liquefaction': 'Sables mouvants',
      '(?<! )Homing Lasers': 'Lasers autoguidés',
      'High-Powered Homing Lasers': 'Lasers autoguidés surpuissants',
      'Helicoclaw': 'Héliogriffes',
      'Greater Memory': 'Expansion mémorielle',
      'Flexiclaw': 'Flexigriffes',
      'Dalamud Impact': 'Impact de Dalamud',
      'Cut And Run': 'Ruée de griffes',
      'Chariot/Dynamo': 'Char/Dynamo',
      'Change Of Heart': 'Changement émotionnel',
      'Burst': 'Explosion',
      'Bradamante': 'Bradamante'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Comet': 'コメット',
      'Meteor': 'メテオ',
      'Ruby Bit': 'ルビービット',
      'Raven\'s Image': 'ネールの幻影',
      'The Ruby Weapon': 'ルビーウェポン',
      'White Agony': 'ネールの悲嘆',
      'White Fury': 'ネールの憤怒'
    },
    'replaceText': {
      '\\?': ' ?',
      '--cutscene--': '--カットシン--',
      'Undermine': 'クローマイン',
      'Tank Comets': 'タンクコメット',
      'Stamp': 'ストンピング',
      'Spike of Flame': '爆炎',
      'Screech': '叫声',
      'Ruby Sphere': 'ルビースフィア',
      'Ruby Ray': 'ルビーレイ',
      'Ruby Dynamics': 'ルビーダイナモ',
      'Ruby Claw': 'ルビークロー',
      'Ravensflight': 'レイヴェンダイブ',
      'Ravensclaw': 'レイヴェンクロー',
      'Outrage': 'アウトレイジ',
      'Optimized Ultima': '魔導アルテマ',
      'Negative Personae': 'ネガティブペルソナ',
      'Negative Aura': 'ネガティブオーラ',
      'Negative Affect': 'ネガティブアフェクト',
      'Meteor Stream': 'メテオストリーム',
      'Meteor Project': 'メテオ計劃',
      'Meteor Mine': 'メテオマイン',
      'Mark II Magitek Comet': '魔導コメットII',
      'Magitek Ray': '魔導レーザー',
      'Magitek Meteor': '魔導メテオ',
      'Magitek Charge': '魔導爆雷',
      'Magitek Bit': 'ビット射出',
      'Landing': '落着',
      'Liquefaction': 'リクェファクション',
      '(?<! )Homing Lasers': '誘導レーザー',
      'High-powered Homing Lasers': '高出力誘導レーザー',
      'Helicoclaw': 'スパイラルクロー',
      'Greater Memory': '記憶増幅',
      'Flexiclaw': 'フレキシブルクロー',
      'Dalamud Impact': 'ダラガブインパクト',
      'Cut and Run': 'クロースラッシュ',
      'Chariot/Dynamo': 'チャリオット/ダイナモ',
      'Change Of Heart': '感情変化',
      'Burst': '大爆発',
      'Bradamante': 'ブラダマンテ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'The Ruby Weapon': '红宝石神兵',
      'Ruby Bit': '红宝石浮游炮',
      'Raven\'s Image': '奈尔的幻影',
      'Meteor': '陨石',
      'Comet': '彗星',
      'White Agony': '奈尔的悲叹',
      'White Fury': '奈尔的愤怒'
    },
    'replaceText': {
      '--cutscene--': '--过场动画--',
      'Optimized Ultima': '魔导究极',
      'Magitek Bit': '浮游炮射出',
      'Flexiclaw': '潜地爪',
      'Magitek Ray': '魔导射线',
      'Helicoclaw': '螺旋爪',
      'Spike Of Flame': '爆炎柱',
      'Stamp': '重踏',
      'Ruby Sphere': '红宝石能量球',
      'Ravensclaw': '凶鸟爪',
      'Undermine': '掘地雷',
      'Ruby Ray': '红宝石射线',
      'Liquefaction': '地面液化',
      'Ravensflight': '凶鸟冲',
      'Ruby Dynamics': '红宝石电圈',
      'High-Powered Homing Lasers': '高功率诱导射线',
      'Cut And Run': '利爪突进',
      '(?<! )Homing Lasers': '诱导射线',
      'Magitek Charge': '魔导炸弹',
      'Meteor Project': '陨石计划',
      'Negative Personae': '消极人格',
      'Meteor Stream': '陨石流',
      'Greater Memory': '记忆增幅',
      'Chariot': '月流电圈',
      'Dynamo': '钢铁战车',
      'Negative Affect': '消极情感',
      'Ruby Claw x5': '红宝石之爪',
      'Change Of Heart': '感情变化',
      'Negative Aura': '消极视线',
      'Dalamud Impact': '卫月冲击',
      'Meteor Mine': '陨石雷',
      'Landing x8': '落地',
      'Screech': '嘶嚎',
      'Burst x8': '爆炸',
      'Magitek Meteor': '魔导陨石',
      'Mark II Magitek Comet': '魔导彗星II',
      'Tank Comets': '坦克彗星',
      'Bradamante': '布拉达曼特',
      'Outrage': '震怒'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'The Ruby Weapon': '루비 웨폰',
      'Ruby Bit': '루비 비트',
      'Raven\'s Image': '넬의 환영',
      'Meteor': '메테오',
      'Comet': '혜성',
      'White Agony': '넬의 비탄',
      'White Fury': '넬의 분노'
    },
    'replaceText': {
      '--cutscene--': '--컷신--',
      'Optimized Ultima': '마도 알테마',
      'Magitek Bit': '비트 사출',
      'Flexiclaw': '가변 발톱',
      'Magitek Ray': '마도 레이저',
      'Helicoclaw': '나선 발톱',
      'Spike Of Flame': '폭염',
      'Stamp': '발구름',
      'Ruby Sphere': '루비 구체',
      'Ravensclaw': '흉조 발톱',
      'Undermine': '발톱 지뢰',
      'Ruby Ray': '루비 광선',
      'Liquefaction': '융해',
      'Ravensflight': '흉조 돌진',
      'Ruby Dynamics': '루비의 원동력',
      'High-Powered Homing Lasers': '고출력 유도 레이저',
      'Cut And Run': '발톱 휘두르기',
      '(?<! )Homing Lasers': '유도 레이저',
      'Magitek Charge': '마도 폭뢰',
      'Meteor Project': '메테오 계획',
      'Negative Personae': '부정적 페르소나',
      'Meteor Stream': '유성 폭풍',
      'Greater Memory': '기억 증폭',
      'Chariot': '강철 전차',
      'Dynamo': '달의 원동력',
      'Negative Affect': '부정적 작용',
      'Ruby Claw': '루비 발톱',
      'Change Of Heart': '감정 변화',
      'Negative Aura': '부정적 오라',
      'Dalamud Impact': '달라가브 낙하',
      'Meteor Mine': '운석 지뢰',
      'Landing': '경착륙',
      'Screech': '부르짖음',
      'Burst': '폭발',
      'Magitek Meteor': '마도 메테오',
      'Mark II Magitek Comet': '마도 혜성 2',
      'Tank Comets': '탱커 혜성 처리',
      'Bradamante': '브라다만테',
      'Outrage': '격노'
    }
  }]
};
/* harmony default export */ const ruby_weapon_ex = (ruby_weapon_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/ruby_weapon-ex.txt
const trial_ruby_weapon_ex_namespaceObject = "### Ruby Weapon Ex\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1\r\n# -p 4ABE:14.5\r\n# -ii 4B2F 4D05 4ACD 4ACE 4ADA 4E6C 4AE9 4AE8 4E6B 4AEA 4AE8 4A6E 4ADE 4E6E 4AE2 4A98 4AE6 4E70 4B06 4B07 4B08 4B0D 4D0D 4AD9 4AE0 4AE4 4D04 4D57 4ADC 4E79 4BCF 4E77 4AD7 4AE7 4ADD 4E6D  4E6F 4AE5 4AE1\r\n\r\n# Use autos instead of InCombat lines to start timelines for each phase\r\n# as timeline resets out of combat.\r\n\r\n0 \"Start\"\r\n2.0 \"--sync--\" Ability { id: \"368\", source: \"The Ruby Weapon\" } window 3,0\r\n14.5 \"Optimized Ultima\" Ability { id: \"4ABE\", source: \"The Ruby Weapon\" } window 15,5\r\n28.7 \"Magitek Bit\" Ability { id: \"4AD1\", source: \"The Ruby Weapon\" }\r\n30.8 \"--middle--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n36.0 \"Flexiclaw\" Ability { id: \"4A92\", source: \"The Ruby Weapon\" }\r\n38.9 \"Magitek Ray\" Ability { id: \"4AD2\", source: \"Ruby Bit\" }\r\n44.6 \"Helicoclaw\" Ability { id: \"4A99\", source: \"The Ruby Weapon\" }\r\n45.3 \"Spike Of Flame\" Ability { id: [\"4D04\", \"4AD3\"], source: \"The Ruby Weapon\" }\r\n46.7 \"Magitek Ray\" Ability { id: \"4AD2\", source: \"Ruby Bit\" }\r\n52.7 \"Helicoclaw\" Ability { id: \"4A99\", source: \"The Ruby Weapon\" }\r\n53.4 \"Spike Of Flame\" Ability { id: [\"4D04\", \"4AD3\"], source: \"The Ruby Weapon\" }\r\n54.5 \"Magitek Ray\" Ability { id: \"4AD2\", source: \"Ruby Bit\" }\r\n62.4 \"Magitek Ray\" Ability { id: \"4AD2\", source: \"Ruby Bit\" }\r\n72.6 \"Stamp\" Ability { id: \"4B03\", source: \"The Ruby Weapon\" }\r\n77.8 \"--middle--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n80.2 \"Ruby Sphere\" Ability { id: \"4AC9\", source: \"The Ruby Weapon\" }\r\n86.3 \"Flexiclaw\" Ability { id: \"4A92\", source: \"The Ruby Weapon\" }\r\n95.9 \"Ravensclaw\" Ability { id: \"4ACC\", source: \"The Ruby Weapon\" }\r\n102.0 \"Liquefaction?/Undermine?\" Ability { id: [\"4ACF\", \"4AD0\"], source: \"The Ruby Weapon\" }\r\n105.2 \"Ruby Sphere 1\" #Ability { id: \"4ACA\", source: \"The Ruby Weapon\" }\r\n108.2 \"Ruby Sphere 2\" #Ability { id: \"4ACA\", source: \"The Ruby Weapon\" }\r\n111.2 \"Ruby Sphere 3\" #Ability { id: \"4ACA\", source: \"The Ruby Weapon\" }\r\n# can be slightly delayed\r\n122.6 \"--sync--\" StartsUsing { id: \"4B02\", source: \"The Ruby Weapon\" } window 10,10\r\n127.6 \"Ruby Ray\" Ability { id: \"4B02\", source: \"The Ruby Weapon\" }\r\n134.7 \"Optimized Ultima\" Ability { id: \"4ABE\", source: \"The Ruby Weapon\" }\r\n145.4 \"Flexiclaw\" Ability { id: \"4A92\", source: \"The Ruby Weapon\" }\r\n151.1 \"Liquefaction\" Ability { id: \"4AEC\", source: \"The Ruby Weapon\" }\r\n157.6 \"--north--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n168.0 \"--untargetable--\"\r\n168.0 \"Ravensflight\" Ability { id: \"4AA1\", source: \"The Ruby Weapon\" }\r\n181.8 \"--targetable--\"\r\n196.9 \"Optimized Ultima\" Ability { id: \"4ABE\", source: \"The Ruby Weapon\" }\r\n205.2 \"Stamp\" Ability { id: \"4B03\", source: \"The Ruby Weapon\" }\r\n212.4 \"--teleport--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n220.3 \"Ruby Dynamics\" Ability { id: \"4B09\", source: \"The Ruby Weapon\" }\r\n221.4 \"High-Powered Homing Lasers\" Ability { id: \"4AD8\", source: \"The Ruby Weapon\" }\r\n229.5 \"Cut And Run\" Ability { id: \"4B05\", source: \"The Ruby Weapon\" } duration 2.5\r\n231.1 \"Homing Lasers\" Ability { id: \"4AD6\", source: \"The Ruby Weapon\" }\r\n237.1 \"Magitek Charge\" Ability { id: \"4AD4\", source: \"The Ruby Weapon\" }\r\n246.2 \"Ruby Ray\" Ability { id: \"4B02\", source: \"The Ruby Weapon\" }\r\n253.3 \"Optimized Ultima\" Ability { id: \"4ABE\", source: \"The Ruby Weapon\" }\r\n259.5 \"--middle--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n261.8 \"Ruby Sphere\" Ability { id: \"4AC9\", source: \"The Ruby Weapon\" }\r\n267.9 \"Flexiclaw\" Ability { id: \"4A92\", source: \"The Ruby Weapon\" }\r\n277.5 \"Ravensclaw\" Ability { id: \"4ACC\", source: \"The Ruby Weapon\" }\r\n283.6 \"Undermine?/Liquefaction?\" Ability { id: [\"4ACF\", \"4AD0\"], source: \"The Ruby Weapon\" }\r\n286.9 \"Ruby Sphere 1\" #Ability { id: \"4ACA\", source: \"The Ruby Weapon\" }\r\n289.9 \"Ruby Sphere 2\" #Ability { id: \"4ACA\", source: \"The Ruby Weapon\" }\r\n292.9 \"Ruby Sphere 3\" #Ability { id: \"4ACA\", source: \"The Ruby Weapon\" }\r\n307.2 \"Ruby Ray\" Ability { id: \"4B02\", source: \"The Ruby Weapon\" }\r\n314.3 \"Optimized Ultima\" Ability { id: \"4ABE\", source: \"The Ruby Weapon\" }\r\n325.0 \"Flexiclaw\" Ability { id: \"4A92\", source: \"The Ruby Weapon\" }\r\n330.7 \"Liquefaction\" Ability { id: \"4AEC\", source: \"The Ruby Weapon\" }\r\n337.2 \"--north--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n347.6 \"--untargetable--\"\r\n347.6 \"Ravensflight\" Ability { id: \"4AA1\", source: \"The Ruby Weapon\" }\r\n360.4 \"--targetable--\"\r\n375.5 \"Optimized Ultima\" Ability { id: \"4ABE\", source: \"The Ruby Weapon\" }\r\n383.8 \"Stamp\" Ability { id: \"4B03\", source: \"The Ruby Weapon\" }\r\n391.0 \"--teleport--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n398.8 \"Ruby Dynamics\" Ability { id: \"4B09\", source: \"The Ruby Weapon\" }\r\n399.9 \"High-Powered Homing Lasers\" Ability { id: \"4AD8\", source: \"The Ruby Weapon\" }\r\n407.9 \"Cut And Run\" Ability { id: \"4B05\", source: \"The Ruby Weapon\" }\r\n409.5 \"Homing Lasers\" Ability { id: \"4AD6\", source: \"The Ruby Weapon\" }\r\n414.9 \"--sync--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n415.4 \"Magitek Charge\" Ability { id: \"4AD4\", source: \"The Ruby Weapon\" }\r\n424.5 \"Ruby Ray\" Ability { id: \"4B02\", source: \"The Ruby Weapon\" }\r\n431.7 \"Optimized Ultima\" Ability { id: \"4ABE\", source: \"The Ruby Weapon\" }\r\n437.9 \"--sync--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n### Enrage (both time and hp% pushes)\r\n440.2 \"--sync--\" StartsUsing { id: \"4B2D\", source: \"The Ruby Weapon\" } window 600,0\r\n455.2 \"Enrage\" Ability { id: \"4B2D\", source: \"The Ruby Weapon\" }\r\n\r\n### Cutscene\r\n800.0 \"--cutscene--\" Ability { id: \"4E1C\", source: \"The Ruby Weapon\" } duration 65.5 window 800,0\r\n865.5 \"--targetable--\"\r\n\r\n### Phase 2\r\n# -p 4AAA:1007\r\n# -ii 4CF7 4E68 4B00 4E20 4AF3 4AF4 4AF1 4AF2 4B30 4E31 4AB1\r\n\r\n1000.0 \"Start\"\r\n1000.5 \"--sync--\" Ability { id: \"4CF7\", source: \"The Ruby Weapon\" } window 1001,0\r\n1007.0 \"Meteor Project\" Ability { id: \"4AAA\", source: \"The Ruby Weapon\" } window 1007,5\r\n1013.2 \"Negative Personae\" Ability { id: \"4ABD\", source: \"The Ruby Weapon\" }\r\n1023.9 \"Meteor Stream\" Ability { id: \"4E72\", source: \"The Ruby Weapon\" }\r\n1029.3 \"Greater Memory\" Ability { id: \"4AFD\", source: \"Raven's Image\" }\r\n1035.4 \"Chariot/Dynamo\" Ability { id: \"4EB[01]\", source: \"Raven's Image\" }\r\n1035.5 \"Negative Affect\" Ability { id: \"4AF8\", source: \"The Ruby Weapon\" }\r\n1043.7 \"Meteor Stream\" Ability { id: \"4E72\", source: \"The Ruby Weapon\" }\r\n1052.0 \"Ruby Claw x5\" Ability { id: \"4AFF\", source: \"Raven's Image\" } duration 2.5\r\n1061.8 \"Change Of Heart\" Ability { id: \"4AFC\", source: \"The Ruby Weapon\" }\r\n1063.4 \"Greater Memory\" Ability { id: \"4AFD\", source: \"Raven's Image\" }\r\n1071.0 \"Meteor Stream\" Ability { id: \"4E72\", source: \"The Ruby Weapon\" }\r\n1075.6 \"Chariot/Dynamo\" Ability { id: \"4EB[01]\", source: \"Raven's Image\" }\r\n1092.2 \"Negative Aura\" Ability { id: \"4AFE\", source: \"The Ruby Weapon\" }\r\n1106.0 \"Dalamud Impact\" Ability { id: \"4B0B\", source: \"The Ruby Weapon\" }\r\n1120.4 \"Meteor Project\" Ability { id: \"4AAA\", source: \"The Ruby Weapon\" }\r\n1126.6 \"Meteor Mine\" Ability { id: \"4E89\", source: \"The Ruby Weapon\" }\r\n1143.8 \"Landing x8\" duration 7 #Ability { id: \"4AF1\", source: \"Meteor\" }\r\n1156.0 \"Screech\" Ability { id: \"4AEE\", source: \"The Ruby Weapon\" }\r\n1157.0 \"Burst x8\" duration 7 #Ability { id: \"4AF2\", source: \"Meteor\" }\r\n1159.7 \"Magitek Meteor\" Ability { id: \"4AF0\", source: \"The Ruby Weapon\" }\r\n1167.2 \"Mark II Magitek Comet\" Ability { id: \"4AB6\", source: \"The Ruby Weapon\" }\r\n1178.8 \"Tank Comets\"\r\n1190.4 \"--sync--\" Ability { id: \"4E38\", source: \"The Ruby Weapon\" }\r\n1190.5 \"Bradamante\" Ability { id: \"4AF7\", source: \"The Ruby Weapon\" }\r\n1199.6 \"--sync--\" Ability { id: \"4E38\", source: \"The Ruby Weapon\" }\r\n1199.7 \"Bradamante\" Ability { id: \"4AF7\", source: \"The Ruby Weapon\" }\r\n1208.6 \"Dalamud Impact\" Ability { id: \"4E52\", source: \"The Ruby Weapon\" }\r\n1221.9 \"Meteor Project\" Ability { id: \"4AAC\", source: \"The Ruby Weapon\" }\r\n1235.1 \"Outrage\" Ability { id: \"4B04\", source: \"The Ruby Weapon\" }\r\n1245.2 \"Outrage\" Ability { id: \"4B04\", source: \"The Ruby Weapon\" }\r\n1254.3 \"Meteor Stream\" Ability { id: \"4E72\", source: \"The Ruby Weapon\" }\r\n1262.1 \"Meteor Stream\" Ability { id: \"4E72\", source: \"The Ruby Weapon\" }\r\n# Enrage ???\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/ruby_weapon.ts



const ruby_weapon_triggerSet = {
  id: 'CinderDrift',
  zoneId: zone_id/* default.CinderDrift */.Z.CinderDrift,
  timelineFile: 'ruby_weapon.txt',
  timelineTriggers: [{
    id: 'Ruby Magitek Meteor Behind',
    regex: /Magitek Meteor/,
    beforeSeconds: 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Meteor',
        de: 'Hinter Meteor verstecken',
        fr: 'Cachez-vous derrière le météore',
        ja: 'コメットの後ろへ',
        cn: '躲在陨石后',
        ko: '운석 뒤에 숨기'
      }
    }
  }, {
    id: 'Ruby Magitek Meteor Away',
    regex: /Burst/,
    beforeSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Meteor',
        de: 'Weg vom Meteor',
        fr: 'Éloignez-vous du météore',
        ja: 'コメットから離れる',
        cn: '远离陨石',
        ko: '운석에게서 멀어지기'
      }
    }
  }],
  triggers: [{
    id: 'Ruby Optimized Ultima',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AA8',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Ruby Stamp',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AC7'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ruby Undermine',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4A97',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from Lines',
        de: 'Weg von den Linien',
        fr: 'Éloignez-vous des sillons',
        ja: '線から離れる',
        cn: '远离线',
        ko: '선 피하기'
      }
    }
  }, {
    id: 'Ruby Liquefaction',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4A96',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get On Lines',
        de: 'Auf die Linien gehen',
        fr: 'Allez sur les sillons',
        ja: '線の上へ',
        cn: '靠近线',
        ko: '선 위로 올라가기'
      }
    }
  }, {
    id: 'Ruby Ruby Ray',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AC6',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Ruby High-Powered Homing Lasers You',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AC5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Ruby High-Powered Homing Lasers',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AC5'
    },
    condition: conditions/* default.targetIsNotYou */.Z.targetIsNotYou(),
    suppressSeconds: 1,
    response: responses/* Responses.stackMarker */.n3.stackMarker('info')
  }, {
    id: 'Ruby Dynamics',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AA0',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Ruby Homing Laser',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    // Enrage can start casting before Ruby Weapon has finished their rotation
    // Give a friendly reminder to pop LB3 if you haven't already
    id: 'Ruby Optimized Ultima Enrage',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AA9',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Enrage!',
        de: 'Finalangriff!',
        fr: 'Enrage !',
        ja: '時間切れ！',
        cn: '狂暴',
        ko: '전멸기!'
      }
    }
  }, {
    id: 'Ruby Meteor Stream',
    type: 'HeadMarker',
    netRegex: {
      id: '00E0'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Ruby Ruby Claw',
    type: 'StartsUsing',
    netRegex: {
      source: 'Raven\'s Image',
      id: '4ABF'
    },
    condition: (data, matches) => {
      if (data.role === 'dps' && data.job !== 'BLU') return false;
      const myColor = data.colors?.[data.me];
      return myColor !== undefined && myColor === data.colors?.[matches.target];
    },
    suppressSeconds: 1,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ruby Bradamante',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid meteors with laser',
        de: 'Meteore mit Laser vermeiden',
        fr: 'Évitez les météores avec votre laser',
        ja: 'レザーを避ける',
        cn: '躲开激光点名',
        ko: '레이저 대상자 - 탱커 피하기'
      }
    }
  }, {
    id: 'Ruby Outrage',
    type: 'StartsUsing',
    netRegex: {
      source: 'The Ruby Weapon',
      id: '4AC8',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'The Ruby Weapon': 'Rubin-Waffe',
      'Raven\'s Image': 'Naels Trugbild',
      'Comet': 'Komet'
    },
    'replaceText': {
      'Undermine': 'Untergraben',
      'Stamp': 'Zerstampfen',
      'Spike Of Flame': 'Flammenstachel',
      'Ruby Ray': 'Rubin-Strahl',
      'Ruby Dynamics': 'Rubin-Dynamo',
      'Ravensflight': 'Flug des Raben',
      'Ravensclaw': 'Rabenklauen',
      'Optimized Ultima': 'Ultima-System',
      'Mark II Magitek Comet': 'Magitek-Komet Stufe II',
      'Magitek Meteor': 'Magitek-Meteor',
      '(?<! )Magitek Comet': 'Magitek-Komet',
      'Liquefaction': 'Verflüssigen',
      '(?<! )Homing Lasers': 'Leitlaser',
      'High-Powered Homing Lasers': 'Hochenergie-Leitlaser',
      'Helicoclaw': 'Spiralklauen',
      'Flexiclaw': 'Flex-Klauen',
      'Meteor Project': 'Projekt Meteor',
      'Negative Personae': 'Persona Negativa',
      'Meteor Stream': 'Meteorflug',
      'Ruby Claw': 'Rubin-Klauen',
      'Dalamud Impact': 'Dalamud-Sturz',
      'Outrage': 'Empörung',
      'Landing': 'Einschlag',
      'Burst': 'Explosion',
      'Bradamante': 'Bradamante',
      '--cutscene--': '--Zwischensequenz--'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Comet': 'Comète',
      'Raven\'s Image': 'Spectre De Nael',
      'The Ruby Weapon': 'Arme Rubis'
    },
    'replaceText': {
      '\\?': ' ?',
      '--cutscene--': '--cinématique--',
      'Undermine': 'Griffe souterraine',
      'Stamp': 'Piétinement sévère',
      'Spike Of Flame': 'Explosion de feu',
      'Ruby Ray': 'Rayon rubis',
      'Ruby Dynamics': 'Générateur rubis',
      'Ruby Claw': 'Griffe rubis',
      'Ravensflight': 'Vol du rapace',
      'Ravensclaw': 'Griffes du rapace',
      'Outrage': 'Indignation',
      'Optimized Ultima': 'Ultima magitek',
      'Negative Personae': 'Ipséité négative',
      'Meteor Stream': 'Rayon météore',
      'Meteor Project': 'Projet Météore',
      'Mark II Magitek Comet': 'Comète magitek II',
      'Magitek Meteor': 'Météore magitek',
      '(?<! )Magitek Comet': 'Comète magitek',
      'Landing': 'Chute de Météore',
      'Liquefaction': 'Sables mouvants',
      '(?<! )Homing Lasers': 'Lasers autoguidés',
      'High-Powered Homing Lasers': 'Lasers autoguidés surpuissants',
      'Helicoclaw': 'Héliogriffes',
      'Flexiclaw': 'Flexigriffes',
      'Dalamud Impact': 'Impact de Dalamud',
      'Burst': 'Éclats cosmique',
      'Bradamante': 'Bradamante'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'The Ruby Weapon': 'ルビーウェポン',
      'Raven\'s Image': 'ネールの幻影',
      'Comet': 'コメット'
    },
    'replaceText': {
      '--cutscene--': '--カットシン--',
      'Undermine': 'クローマイン',
      'Stamp': 'ストンピング',
      'Spike Of Flame': '爆炎',
      'Ruby Ray': 'ルビーレイ',
      'Ruby Dynamics': 'ルビーダイナモ',
      'Ravensflight': 'レイヴェンダイブ',
      'Ravensclaw': 'レイヴェンクロー',
      'Optimized Ultima': '魔導アルテマ',
      'Liquefaction': 'リクェファクション',
      '(?<! )Homing Lasers': '誘導レーザー',
      'High-Powered Homing Lasers': '高出力誘導レーザー',
      'Helicoclaw': 'スパイラルクロー',
      'Flexiclaw': 'フレキシブルクロー',
      'Meteor Project': 'メテオ計劃',
      'Negative Personae': 'ネガティブペルソナ',
      'Meteor Stream': 'メテオストリーム',
      'Ruby Claw': 'ルビークロー',
      'Dalamud Impact': 'ダラガブインパクト',
      'Magitek Comet': '魔導コメット',
      'Landing': '落着',
      'Magitek Meteor': '魔導メテオ',
      'Burst': '飛散',
      'Bradamante': 'ブラダマンテ',
      'Outrage': 'アウトレイジ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'The Ruby Weapon': '红宝石神兵',
      'Raven\'s Image': '奈尔的幻影',
      'Comet': '彗星'
    },
    'replaceText': {
      '--cutscene--': '--过场动画--',
      'Stamp': '重踏',
      'Optimized Ultima': '魔导究极',
      'Flexiclaw': '潜地爪',
      'Ravensclaw': '凶鸟爪',
      'Spike Of Flame': '爆炎柱',
      'Liqu[ei]faction': '地面液化',
      'Ruby Ray': '红宝石射线',
      'Helicoclaw': '螺旋爪',
      'High-Powered Homing Lasers': '高功率诱导射线',
      'Ravensflight': '凶鸟冲',
      '(?<! )Homing Lasers': '诱导射线',
      'Ruby Dynamics': '红宝石电圈',
      'Undermine': '掘地雷',
      'Meteor Project': '陨石计划',
      'Negative Personae': '消极人格',
      'Meteor Stream': '陨石流',
      'Ruby Claw': '红宝石之爪',
      'Dalamud Impact': '卫月冲击',
      '(?<! )Magitek Comet': '魔导彗星',
      'Landing': '落地',
      'Magitek Meteor': '魔导陨石',
      'Burst': '飞散',
      'Mark II Magitek Comet': '魔导彗星II',
      'Bradamante': '布拉达曼特',
      'Outrage': '震怒'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'The Ruby Weapon': '루비 웨폰',
      'Raven\'s Image': '넬의 환영',
      'Comet': '혜성'
    },
    'replaceText': {
      '--cutscene--': '--컷신--',
      'Stamp': '발구름',
      'Optimized Ultima': '마도 알테마',
      'Flexiclaw': '가변 발톱',
      'Ravensclaw': '흉조 발톱',
      'Spike Of Flame': '폭염',
      'Liqu[ei]faction': '융해',
      'Ruby Ray': '루비 광선',
      'Helicoclaw': '나선 발톱',
      'High-Powered Homing Lasers': '고출력 유도 레이저',
      'Ravensflight': '흉조 돌진',
      '(?<! )Homing Lasers': '유도 레이저',
      'Ruby Dynamics': '루비의 원동력',
      'Undermine': '발톱 지뢰',
      'Meteor Project': '메테오 계획',
      'Negative Personae': '부정적 페르소나',
      'Meteor Stream': '유성 폭풍',
      'Ruby Claw': '루비 발톱',
      'Dalamud Impact': '달라가브 낙하',
      '(?<! )Magitek Comet': '마도 혜성',
      'Landing': '경착륙',
      'Magitek Meteor': '마도 메테오',
      'Burst': '산산조각',
      'Mark II Magitek Comet': '마도 혜성 2',
      'Bradamante': '브라다만테',
      'Outrage': '격노'
    }
  }]
};
/* harmony default export */ const ruby_weapon = (ruby_weapon_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/ruby_weapon.txt
const trial_ruby_weapon_namespaceObject = "### Ruby Weapon Normal\r\n\r\n# TODO: is the liquifaction/undermine order random in normal mode?\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Use autos/unique syncs instead of InCombat lines to start timelines for each phase\r\n# as timeline resets out of combat.\r\n\r\n### Phase 1\r\n# -p 4AC7:16\r\n# -ii 4AA7 4E6A 4AA3 4E69 4AA5 4B2E 4D03 4C21 4AA4 4C2A 4AA2 4AA6 4A95 4AC4 4A98\r\n\r\n0 \"Start\"\r\n2.0 \"--sync--\" Ability { id: \"368\", source: \"The Ruby Weapon\" } window 3,0\r\n16.0 \"Stamp\" Ability { id: \"4AC7\", source: \"The Ruby Weapon\" } window 17,0\r\n24.1 \"Optimized Ultima\" Ability { id: \"4AA8\", source: \"The Ruby Weapon\" }\r\n31.3 \"--sync--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n36.7 \"Flexiclaw\" Ability { id: \"4A92\", source: \"The Ruby Weapon\" }\r\n46.4 \"Ravensclaw\" Ability { id: \"4A93\", source: \"The Ruby Weapon\" }\r\n47.0 \"Spike Of Flame\" Ability { id: \"4A94\", source: \"The Ruby Weapon\" }\r\n53.6 \"Liquefaction?/Undermine?\" Ability { id: \"4A9[67]\", source: \"The Ruby Weapon\" }\r\n70.6 \"Ruby Ray\" Ability { id: \"4AC6\", source: \"The Ruby Weapon\" }\r\n79.7 \"Optimized Ultima\" Ability { id: \"4AA8\", source: \"The Ruby Weapon\" }\r\n84.9 \"--sync--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n90.1 \"Flexiclaw\" Ability { id: \"4A92\", source: \"The Ruby Weapon\" }\r\n98.7 \"Helicoclaw\" Ability { id: \"4A99\", source: \"The Ruby Weapon\" }\r\n99.4 \"Spike Of Flame\" Ability { id: [\"4A9A\", \"4D02\"], source: \"The Ruby Weapon\" }\r\n113.8 \"High-Powered Homing Lasers\" Ability { id: \"4AC5\", source: \"The Ruby Weapon\" }\r\n120.5 \"--sync--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n130.8 \"Ravensflight\" Ability { id: \"4AA1\", source: \"The Ruby Weapon\" }\r\n138.0 \"--sync--\" Ability { id: \"4BCD\", source: \"The Ruby Weapon\" }\r\n154.3 \"Stamp\" Ability { id: \"4AC7\", source: \"The Ruby Weapon\" }\r\n161.4 \"Homing Lasers\" Ability { id: \"4AC2\", source: \"The Ruby Weapon\" }\r\n164.0 \"--sync--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n171.7 \"Ruby Dynamics\" Ability { id: \"4AA0\", source: \"The Ruby Weapon\" }\r\n178.4 \"Homing Lasers\" Ability { id: \"4AC3\", source: \"The Ruby Weapon\" }\r\n186.0 \"Optimized Ultima\" Ability { id: \"4AA8\", source: \"The Ruby Weapon\" }\r\n191.2 \"--sync--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n196.4 \"Flexiclaw\" Ability { id: \"4A92\", source: \"The Ruby Weapon\" }\r\n206.0 \"Ravensclaw\" Ability { id: \"4A93\", source: \"The Ruby Weapon\" }\r\n206.6 \"Spike Of Flame\" Ability { id: \"4A94\", source: \"The Ruby Weapon\" }\r\n213.1 \"Undermine?/Liquifaction?\" Ability { id: \"4A9[67]\", source: \"The Ruby Weapon\" }\r\n224.8 \"Ruby Ray\" Ability { id: \"4AC6\", source: \"The Ruby Weapon\" }\r\n233.9 \"Optimized Ultima\" Ability { id: \"4AA8\", source: \"The Ruby Weapon\" }\r\n239.1 \"--sync--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n244.4 \"Flexiclaw\" Ability { id: \"4A92\", source: \"The Ruby Weapon\" }\r\n253.0 \"Helicoclaw\" Ability { id: \"4A99\", source: \"The Ruby Weapon\" }\r\n253.7 \"Spike Of Flame\" Ability { id: [\"4A9A\", \"4D02\"], source: \"The Ruby Weapon\" }\r\n268.2 \"High-Powered Homing Lasers\" Ability { id: \"4AC5\", source: \"The Ruby Weapon\" }\r\n274.9 \"--sync--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n285.2 \"Ravensflight\" Ability { id: \"4AA1\", source: \"The Ruby Weapon\" }\r\n292.4 \"--sync--\" Ability { id: \"4BCD\", source: \"The Ruby Weapon\" }\r\n308.7 \"Stamp\" Ability { id: \"4AC7\", source: \"The Ruby Weapon\" }\r\n311.8 \"--sync--\" Ability { id: \"4A9B\", source: \"The Ruby Weapon\" }\r\n\r\n# FIXME: does this push at a percent like extreme?\r\n314.0 \"--sync--\" StartsUsing { id: \"4AA9\", source: \"The Ruby Weapon\" } window 500,500\r\n329.0 \"Optimized Ultima Enrage\" Ability { id: \"4AA9\", source: \"The Ruby Weapon\" }\r\n\r\n### Cutscene\r\n# FIXME: this duration differs from the extreme version??? is that true??\r\n500.0 \"--cutscene--\" Ability { id: \"4E1C\", source: \"The Ruby Weapon\" } duration 61.5 window 500,0\r\n561.5 \"--targetable--\"\r\n\r\n### Phase 2\r\n# -p 4AAA:1007\r\n# -ii 4CF6 4AC0 4AB8 4AB7 4E31 4E67 4ABB 4AB1\r\n\r\n1000.0 \"Start\"\r\n1000.5 \"--sync--\" Ability { id: \"4CF6\", source: \"The Ruby Weapon\" } window 1001,0\r\n1007.0 \"Meteor Project\" Ability { id: \"4AAA\", source: \"The Ruby Weapon\" } window 1007,5\r\n1014.2 \"Negative Personae\" Ability { id: \"4ABD\", source: \"The Ruby Weapon\" }\r\n1023.3 \"Meteor Stream\" Ability { id: \"4E71\", source: \"The Ruby Weapon\" }\r\n1031.8 \"Ruby Claw\" Ability { id: \"4ABF\", source: \"Raven's Image\" } duration 2.5\r\n1039.5 \"Meteor Stream\" Ability { id: \"4E71\", source: \"The Ruby Weapon\" }\r\n1052.0 \"Ruby Claw\" Ability { id: \"4ABF\", source: \"Raven's Image\" } duration 2.5\r\n1057.7 \"Meteor Stream\" Ability { id: \"4E71\", source: \"The Ruby Weapon\" }\r\n1069.0 \"Dalamud Impact\" Ability { id: \"4AAE\", source: \"The Ruby Weapon\" }\r\n1080.9 \"Meteor Project\" Ability { id: \"4AAA\", source: \"The Ruby Weapon\" }\r\n1094.2 \"Magitek Comet\" Ability { id: \"4AB0\", source: \"The Ruby Weapon\" }\r\n1104.3 \"Landing\" Ability { id: \"4E2B\", source: \"Comet\" }\r\n1114.9 \"Magitek Meteor\" Ability { id: \"4AB2\", source: \"The Ruby Weapon\" }\r\n1115.9 \"Burst\" Ability { id: \"4AB4\", source: \"Comet\" }\r\n1122.4 \"Mark II Magitek Comet\" Ability { id: \"4AB6\", source: \"The Ruby Weapon\" }\r\n1150.5 \"Bradamante\" Ability { id: \"4ABC\", source: \"The Ruby Weapon\" }\r\n1159.7 \"Dalamud Impact\" Ability { id: \"4E51\", source: \"The Ruby Weapon\" }\r\n1171.7 \"Meteor Project\" Ability { id: \"4AAC\", source: \"The Ruby Weapon\" }\r\n1181.9 \"Outrage\" Ability { id: \"4AC8\", source: \"The Ruby Weapon\" }\r\n1192.0 \"Outrage\" Ability { id: \"4AC8\", source: \"The Ruby Weapon\" }\r\n1202.1 \"Outrage\" Ability { id: \"4AC8\", source: \"The Ruby Weapon\" }\r\n1212.2 \"Meteor Stream\" Ability { id: \"4E71\", source: \"The Ruby Weapon\" }\r\n1220.5 \"Meteor Stream\" Ability { id: \"4E71\", source: \"The Ruby Weapon\" }\r\n1230.7 \"Outrage\" Ability { id: \"4AC8\", source: \"The Ruby Weapon\" }\r\n### ???\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/shiva-un.ts



// TODO: some sort of warning about extra tank damage during bow phase?
// TODO: should the post-staff "spread" happen unconditionally prior to marker?
const shiva_un_triggerSet = {
  id: 'TheAkhAfahAmphitheatreUnreal',
  zoneId: zone_id/* default.TheAkhAfahAmphitheatreUnreal */.Z.TheAkhAfahAmphitheatreUnreal,
  timelineFile: 'shiva-un.txt',
  timelineTriggers: [{
    id: 'ShivaUn Absolute Zero',
    regex: /Absolute Zero/,
    beforeSeconds: 5,
    // These are usually doubled, so avoid spamming.
    suppressSeconds: 10,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'ShivaUn Icebrand',
    regex: /Icebrand/,
    beforeSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Party Share Tankbuster',
        de: 'Tankbuster mit der Gruppe Teilen',
        fr: 'Partagez le Tank buster avec le groupe',
        ja: '頭割りタンクバスター',
        cn: '团队分摊死刑',
        ko: '파티 쉐어 탱버'
      }
    }
  }, {
    // Heavenly Strike is knockback only when unshielded, so use "info" here.
    id: 'ShivaUn Heavenly Strike',
    regex: /Heavenly Strike/,
    beforeSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback('info')
  }],
  triggers: [{
    id: 'ShivaUn Staff Phase',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: '5367',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        staffTankSwap: {
          en: 'Staff (Tank Swap)',
          de: 'Stab (Tankwechsel)',
          fr: 'Bâton (Tank Swap)',
          ja: '杖 (スイッチ)',
          cn: '权杖（换T）',
          ko: '지팡이 (탱커 교대)'
        },
        staff: {
          en: 'Staff',
          de: 'Stab',
          fr: 'Bâton',
          ja: '杖',
          cn: '权杖',
          ko: '지팡이'
        }
      };
      if (data.role === 'tank') {
        if (data.currentTank !== undefined && data.blunt && data.blunt[data.currentTank]) return {
          alertText: output.staffTankSwap()
        };
      }
      return {
        infoText: output.staff()
      };
    },
    run: data => data.soonAfterWeaponChange = true
  }, {
    id: 'ShivaUn Sword Phase',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: '5366',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        swordTankSwap: {
          en: 'Sword (Tank Swap)',
          de: 'Schwert (Tankwechsel)',
          fr: 'Épée (Tank Swap)',
          ja: '剣 (スイッチ)',
          cn: '剑（换T）',
          ko: '검 (탱커 교대)'
        },
        sword: {
          en: 'Sword',
          de: 'Schwert',
          fr: 'Épée',
          ja: '剣',
          cn: '剑',
          ko: '검'
        }
      };
      if (data.role === 'tank') {
        if (data.currentTank !== undefined && data.slashing && data.slashing[data.currentTank]) return {
          alertText: output.swordTankSwap()
        };
      }
      return {
        infoText: output.sword()
      };
    },
    run: data => data.soonAfterWeaponChange = true
  }, {
    id: 'ShivaUn Weapon Change Delayed',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: ['5366', '5367'],
      capture: false
    },
    delaySeconds: 30,
    run: data => data.soonAfterWeaponChange = false
  }, {
    id: 'ShivaUn Slashing Resistance Down Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '23C'
    },
    run: (data, matches) => {
      data.slashing ??= {};
      data.slashing[matches.target] = true;
    }
  }, {
    id: 'ShivaUn Slashing Resistance Down Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '23C'
    },
    run: (data, matches) => {
      data.slashing ??= {};
      data.slashing[matches.target] = false;
    }
  }, {
    id: 'ShivaUn Blunt Resistance Down Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: '23D'
    },
    run: (data, matches) => {
      data.blunt ??= {};
      data.blunt[matches.target] = true;
    }
  }, {
    id: 'ShivaUn Blunt Resistance Down Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: '23D'
    },
    run: (data, matches) => {
      data.blunt ??= {};
      data.blunt[matches.target] = false;
    }
  }, {
    id: 'ShivaUn Current Tank',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: '5365'
    },
    run: (data, matches) => data.currentTank = matches.target
  }, {
    id: 'ShivaUn Hailstorm Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '001D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'ShivaUn Glacier Bash',
    type: 'StartsUsing',
    netRegex: {
      id: '5375',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind('info')
  }, {
    id: 'ShivaUn Whiteout',
    type: 'StartsUsing',
    netRegex: {
      id: '5376',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'ShivaUn Diamond Dust',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: '536C',
      capture: false
    },
    run: data => data.seenDiamondDust = true
  }, {
    id: 'ShivaUn Frost Bow',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: '5368',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind('alarm'),
    run: data => {
      // Just in case ACT has crashed or something, make sure this state is correct.
      data.seenDiamondDust = true;
    }
  }, {
    id: 'ShivaUn Avalanche Marker Me',
    type: 'HeadMarker',
    netRegex: {
      id: '001A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // Responses.knockback does not quite give the 'laser cleave' aspect here.
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback Laser on YOU',
        de: 'Rückstoß-Laser auf DIR',
        fr: 'Poussée-Laser sur VOUS',
        ja: '自分にノックバックレーザー',
        cn: '击退激光点名',
        ko: '넉백 레이저 대상자'
      }
    }
  }, {
    id: 'ShivaUn Avalanche Marker Other',
    type: 'HeadMarker',
    netRegex: {
      id: '001A'
    },
    condition: conditions/* default.targetIsNotYou */.Z.targetIsNotYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Laser',
        de: 'Laser ausweichen',
        fr: 'Évitez le laser',
        ja: 'ノックバックレーザーを避ける',
        cn: '躲避击退激光',
        ko: '레이저 피하기'
      }
    }
  }, {
    id: 'ShivaUn Shiva Circles',
    type: 'Ability',
    netRegex: {
      source: 'Shiva',
      id: '537B'
    },
    condition: (data, matches) => {
      // Ignore other middle circles and try to only target the Icicle Impact x9.
      if (!data.seenDiamondDust || data.soonAfterWeaponChange) return false;
      const x = parseFloat(matches.x);
      const y = parseFloat(matches.y);
      return Math.abs(x) < 0.1 && Math.abs(y) < 0.1;
    },
    // This can hit multiple people.
    suppressSeconds: 10,
    response: responses/* Responses.goMiddle */.n3.goMiddle('info')
  }, {
    id: 'ShivaUn Permafrost',
    type: 'StartsUsing',
    netRegex: {
      id: '5369',
      capture: false
    },
    response: responses/* Responses.stopMoving */.n3.stopMoving('alert')
  }, {
    id: 'ShivaUn Ice Boulder',
    type: 'Ability',
    netRegex: {
      id: '537A'
    },
    condition: conditions/* default.targetIsNotYou */.Z.targetIsNotYou(),
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.target)
    }),
    outputStrings: {
      text: {
        en: 'Free ${player}',
        de: 'Befreie ${player}',
        fr: 'Libérez ${player}',
        ja: '${player}を救って',
        cn: '解救${player}',
        ko: '${player}감옥 해제'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Ice Soldier': 'Eissoldat',
      'Shiva': 'Shiva'
    },
    'replaceText': {
      '\\(circle\\)': '(Kreis)',
      '\\(cross\\)': '(Kreuz)',
      'Absolute Zero': 'Absoluter Nullpunkt',
      'Avalanche': 'Lawine',
      'Diamond Dust': 'Diamantenstaub',
      'Dreams Of Ice': 'Eisige Träume',
      'Frost Blade': 'Frostklinge',
      'Frost Bow': 'Frostbogen',
      'Frost Staff': 'Froststab',
      'Glacier Bash': 'Gletscherlauf',
      'Glass Dance': 'Gläserner Tanz',
      'Hailstorm': 'Hagelsturm',
      'Heavenly Strike': 'Himmelszorn',
      'Icebrand': 'Eisbrand',
      'Icicle Impact': 'Eiszapfen-Schlag',
      'Melt': 'Schmelzen',
      'Permafrost': 'Permafrost',
      'Whiteout': 'Schneeblindheit'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ice Soldier': 'soldat de glace',
      'Shiva': 'Shiva'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(circle\\)': '(cercle)',
      '\\(cross\\)': '(croix)',
      'Absolute Zero': 'Zéro absolu',
      'Avalanche': 'Avalanche',
      'Diamond Dust': 'Poussière de diamant',
      'Dreams Of Ice': 'Illusions glacées',
      'Frost Blade': 'Lame glaciale',
      'Frost Bow': 'Arc glacial',
      'Frost Staff': 'Bâton glacial',
      'Glacier Bash': 'Effondrement de glacier',
      'Glass Dance': 'Danse de glace',
      'Hailstorm': 'Averse de grêle',
      'Heavenly Strike': 'Frappe céleste',
      'Icebrand': 'Épée de glace',
      'Icicle Impact': 'Impact de stalactite',
      'Melt': 'Fonte',
      'Permafrost': 'Permafrost',
      'Whiteout': 'Fusion Glaciation'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ice Soldier': 'アイスソルジャー',
      'Shiva': 'シヴァ'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(circle\\)': '(輪)',
      '\\(cross\\)': '(十字)',
      'Absolute Zero': '絶対零度',
      'Avalanche': 'アバランチ',
      'Diamond Dust': 'ダイアモンドダスト',
      'Dreams Of Ice': '氷結の幻想',
      'Frost Blade': '凍てつく剣',
      'Frost Bow': '凍てつく弓',
      'Frost Staff': '凍てつく杖',
      'Glacier Bash': 'グレイシャーバッシュ',
      'Glass Dance': '氷雪乱舞',
      'Hailstorm': 'ヘイルストーム',
      'Heavenly Strike': 'ヘヴンリーストライク',
      'Icebrand': 'アイスブランド',
      'Icicle Impact': 'アイシクルインパクト',
      'Melt': 'ウェポンメルト',
      'Permafrost': 'パーマフロスト',
      'Whiteout': 'ホワイトアウト'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ice Soldier': '寒冰士兵',
      'Shiva': '希瓦'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(circle\\)': '(圆)',
      '\\(cross\\)': '(十字)',
      'Absolute Zero': '绝对零度',
      'Avalanche': '雪崩',
      'Diamond Dust': '钻石星尘',
      'Dreams Of Ice': '寒冰的幻想',
      'Frost Blade': '冰霜之剑',
      'Frost Bow': '冰霜之弓',
      'Frost Staff': '冰霜之杖',
      'Glacier Bash': '冰河怒击',
      'Glass Dance': '冰雪乱舞',
      'Hailstorm': '冰雹',
      'Heavenly Strike': '天降一击',
      'Icebrand': '冰印剑',
      'Icicle Impact': '冰柱冲击',
      'Melt': '武器融化',
      'Permafrost': '永久冻土',
      'Whiteout': '白化视界'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ice Soldier': '얼음 병사',
      'Shiva': '시바'
    },
    'replaceText': {
      '\\(circle\\)': '(원형)',
      '\\(cross\\)': '(십자)',
      'Absolute Zero': '절대영도',
      'Avalanche': '눈사태',
      'Diamond Dust': '다이아몬드 더스트',
      'Dreams Of Ice': '빙결의 환상',
      'Frost Blade': '얼어붙은 검',
      'Frost Bow': '얼어붙은 활',
      'Frost Staff': '얼어붙은 지팡이',
      'Glacier Bash': '빙하 강타',
      'Glass Dance': '빙설난무',
      'Hailstorm': '우박 폭풍',
      'Heavenly Strike': '천상의 일격',
      'Icebrand': '얼음의 낙인',
      'Icicle Impact': '고드름 낙하',
      'Melt': '무기 용해',
      'Permafrost': '영구동토',
      'Whiteout': '폭설'
    }
  }]
};
/* harmony default export */ const shiva_un = (shiva_un_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/shiva-un.txt
const trial_shiva_un_namespaceObject = "### Shiva Unreal\r\n#\r\n# -ii 536F 537A 536B -it Shiva\r\n# staff first: -p 5365:100 53AE:200 5372:800\r\n# blade first: -p 5366:400 5372:600 53AE:800\r\n# post-cutscene: -p 53AC:866.7\r\n#\r\n# Phase Flowchart:\r\n# HP:100%       95%          90%            80%        50% (if adds dead)\r\n#\r\n#           +-> 2a(staff) -> 3a(sword) -+\r\n# 1(autos) -+                           +-> 4(adds) -> cutscene ->\r\n#           +-> 2b(sword) -> 3b(staff) -+\r\n#\r\n#\r\n#\r\n#                        +-> 7a(staff) -+\r\n# -> 5(staff) -> 6(bow) -+              + -> 6(bow) -> etc\r\n#                        +-> 7b(sword) -+\r\n#\r\n#\r\n# Notes:\r\n# See Shiva Extreme for more details.\r\n# This is a perfect copy of the extreme fight, with switched out ability ids.\r\n\r\nhideall \"--sync--\"\r\nhideall \"--Reset--\"\r\n\r\n# Phase 1: Literally Just Autos (100% -> 95%)\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n2.0 \"--sync--\" Ability { id: \"5365\", source: \"Shiva\" } window 10,10\r\n\r\n# jump to staff\r\n10.0 \"--sync--\" Ability { id: \"5367\", source: \"Shiva\" } window 10,100 jump 100\r\n# jump to sword\r\n10.0 \"--sync--\" Ability { id: \"5366\", source: \"Shiva\" } window 10,100 jump 400\r\n\r\n# Phase 2a: Staff (95% -> 90%)\r\n100.0 \"Frost Staff\" Ability { id: \"5367\", source: \"Shiva\" }\r\n108.1 \"Hailstorm\" Ability { id: \"536E\", source: \"Shiva\" }\r\n\r\n117.6 \"Absolute Zero\" Ability { id: \"5370\", source: \"Shiva\" }\r\n127.0 \"Absolute Zero\" Ability { id: \"5370\", source: \"Shiva\" }\r\n\r\n140.5 \"Absolute Zero\" Ability { id: \"5370\", source: \"Shiva\" } window 8,8 jump 117.6\r\n149.9 \"Absolute Zero\" #Ability { id: \"5370\", source: \"Shiva\" }\r\n\r\n163.4 \"Absolute Zero\" #Ability { id: \"5370\", source: \"Shiva\" }\r\n173.8 \"Absolute Zero\" #Ability { id: \"5370\", source: \"Shiva\" }\r\n\r\n\r\n# Phase 3a: Sword (90% -> 80%)\r\n200.0 \"Melt\" Ability { id: \"53AE\", source: \"Shiva\" } window 100,0\r\n# This rolls out x4 over 1.5 seconds, so don't sync\r\n207.2 \"Icicle Impact\" #Ability { id: \"537B\", source: \"Shiva\" }\r\n212.3 \"Dreams Of Ice\" Ability { id: \"536A\", source: \"Shiva\" }\r\n\r\n225.0 \"Frost Blade\" Ability { id: \"5366\", source: \"Shiva\" }\r\n230.1 \"Icebrand\" Ability { id: \"5373\", source: \"Shiva\" }\r\n\r\n235.4 \"Heavenly Strike\" Ability { id: \"5374\", source: \"Shiva\" }\r\n245.0 \"Glacier Bash\" Ability { id: \"5375\", source: \"Shiva\" }\r\n255.4 \"Whiteout\" Ability { id: \"5376\", source: \"Shiva\" }\r\n\r\n263.9 \"Heavenly Strike\" Ability { id: \"5374\", source: \"Shiva\" }\r\n273.5 \"Glacier Bash\" Ability { id: \"5375\", source: \"Shiva\" }\r\n284.5 \"Whiteout\" Ability { id: \"5376\", source: \"Shiva\" }\r\n\r\n292.8 \"Heavenly Strike\" Ability { id: \"5374\", source: \"Shiva\" } window 20,20 jump 235.4\r\n302.4 \"Glacier Bash\" #Ability { id: \"5375\", source: \"Shiva\" }\r\n312.8 \"Whiteout\" #Ability { id: \"5376\", source: \"Shiva\" }\r\n\r\n321.3 \"Heavenly Strike\" #Ability { id: \"5374\", source: \"Shiva\" }\r\n330.9 \"Glacier Bash\" #Ability { id: \"5375\", source: \"Shiva\" }\r\n341.9 \"Whiteout\" #Ability { id: \"5376\", source: \"Shiva\" }\r\n\r\n\r\n# Jump to adds phase from 1a/2a\r\n350.0 \"--sync--\" Ability { id: \"5372\", source: \"Shiva\" } window 350,0 jump 800\r\n\r\n\r\n# Phase 2b: Sword (95% -> 90%)\r\n400.0 \"Frost Blade\" Ability { id: \"5366\", source: \"Shiva\" }\r\n405.1 \"Icebrand\" Ability { id: \"5373\", source: \"Shiva\" }\r\n\r\n410.3 \"Heavenly Strike\" Ability { id: \"5374\", source: \"Shiva\" }\r\n419.9 \"Glacier Bash\" Ability { id: \"5375\", source: \"Shiva\" }\r\n430.3 \"Whiteout\" Ability { id: \"5376\", source: \"Shiva\" }\r\n\r\n438.8 \"Heavenly Strike\" Ability { id: \"5374\", source: \"Shiva\" }\r\n448.4 \"Glacier Bash\" Ability { id: \"5375\", source: \"Shiva\" }\r\n458.8 \"Whiteout\" Ability { id: \"5376\", source: \"Shiva\" }\r\n\r\n467.2 \"Heavenly Strike\" Ability { id: \"5374\", source: \"Shiva\" } window 20,20 jump 410.3\r\n477.3 \"Glacier Bash\" #Ability { id: \"5375\", source: \"Shiva\" }\r\n487.7 \"Whiteout\" #Ability { id: \"5376\", source: \"Shiva\" }\r\n\r\n496.2 \"Heavenly Strike\" #Ability { id: \"5374\", source: \"Shiva\" }\r\n505.8 \"Glacier Bash\" #Ability { id: \"5375\", source: \"Shiva\" }\r\n516.8 \"Whiteout\" #Ability { id: \"5376\", source: \"Shiva\" }\r\n\r\n\r\n# Phase 3b: Staff (90% -> 80%)\r\n600.0 \"Melt\" Ability { id: \"5372\", source: \"Shiva\" } window 200,0\r\n# This rolls out x4 over 1.5 seconds, so don't sync\r\n607.2 \"Icicle Impact\" #Ability { id: \"537B\", source: \"Shiva\" }\r\n612.3 \"Dreams Of Ice\" Ability { id: \"536A\", source: \"Shiva\" }\r\n\r\n625.0 \"Frost Staff\" Ability { id: \"5367\", source: \"Shiva\" }\r\n633.1 \"Hailstorm\" Ability { id: \"536E\", source: \"Shiva\" }\r\n\r\n642.6 \"Absolute Zero\" Ability { id: \"5370\", source: \"Shiva\" }\r\n652.0 \"Absolute Zero\" Ability { id: \"5370\", source: \"Shiva\" }\r\n\r\n665.5 \"Absolute Zero\" Ability { id: \"5370\", source: \"Shiva\" } window 8,8 jump 642.6\r\n674.9 \"Absolute Zero\" #Ability { id: \"5370\", source: \"Shiva\" }\r\n\r\n688.4 \"Absolute Zero\" #Ability { id: \"5370\", source: \"Shiva\" }\r\n698.8 \"Absolute Zero\" #Ability { id: \"5370\", source: \"Shiva\" }\r\n\r\n\r\n# Jump to adds phase from 1b/2b\r\n750.0 \"--sync--\" Ability { id: \"53AE\", source: \"Shiva\" } window 350,0 jump 801\r\n\r\n\r\n# Phase 4: Adds\r\n800.0 \"--sync--\" #Ability { id: \"5372\", source: \"Shiva\" }\r\n801.0 \"--sync--\" #Ability { id: \"53AE\", source: \"Shiva\" }\r\n# If you push *really* fast and skip a 3a/3b weapon phase, you'll miss the melt jump.\r\n# So, fix that up with a combatant sync here.\r\n806.6 \"--adds targetable--\" AddedCombatant { name: \"Ice Soldier\" } window 807,10\r\n807.6 \"Dreams Of Ice\" Ability { id: \"536A\", source: \"Shiva\" }\r\n813.2 \"Frost Blade\" Ability { id: \"5366\", source: \"Shiva\" }\r\n818.5 \"Icebrand\" Ability { id: \"5373\", source: \"Shiva\" }\r\n828.0 \"Glacier Bash\" Ability { id: \"5375\", source: \"Shiva\" }\r\n837.5 \"Heavenly Strike\" Ability { id: \"5374\", source: \"Shiva\" }\r\n\r\n\r\n# Diamond Dust Cutscene\r\n854.4 \"Melt\" Ability { id: \"5372\", source: \"Shiva\" } window 60,10\r\n855.5 \"--untargetable--\"\r\n866.7 \"--frozen--\" Ability { id: \"53AC\", source: \"Shiva\" } window 900,50\r\n871.6 \"Diamond Dust\" Ability { id: \"536C\", source: \"Shiva\" }\r\n878.7 \"--targetable--\"\r\n878.9 \"Dreams Of Ice\" Ability { id: \"536A\", source: \"Shiva\" }\r\n\r\n\r\n# Phase 5: Post-Cutscene Staff\r\n# Unlike phase 7a staff, this one can only have a single optional Permafrost.\r\n885.8 \"Frost Staff\" Ability { id: \"5367\", source: \"Shiva\" }\r\n888.1 \"Icicle Impact (cross)\" #Ability { id: \"537B\", source: \"Shiva\" }\r\n893.9 \"Hailstorm\" Ability { id: \"536E\", source: \"Shiva\" }\r\n896.0 \"Icicle Impact (cross)\" #Ability { id: \"537B\", source: \"Shiva\" }\r\n908.6 \"Absolute Zero\" Ability { id: \"5370\", source: \"Shiva\" }\r\n920.2 \"Absolute Zero\" Ability { id: \"5370\", source: \"Shiva\" }\r\n925.4 \"Melt\" Ability { id: \"53AE\", source: \"Shiva\" }\r\n932.6 \"Icicle Impact (circle)\" duration 4 #Ability { id: \"537B\", source: \"Shiva\" }\r\n935.5 \"Permafrost?\" Ability { id: \"5369\", source: \"Shiva\" }\r\n939.7 \"Dreams Of Ice\" Ability { id: \"536A\", source: \"Shiva\" } window 20,10\r\n\r\n\r\n# Phase 6: Bow\r\n942.8 \"Frost Bow\" Ability { id: \"5368\", source: \"Shiva\" }\r\n947.9 \"Glass Dance\" Ability { id: \"5378\", source: \"Shiva\" }\r\n970.5 \"Avalanche\" Ability { id: \"5379\", source: \"Shiva\" }\r\n974.6 \"Permafrost?\" Ability { id: \"5369\", source: \"Shiva\" }\r\n986.1 \"Melt\" Ability { id: \"53AD\", source: \"Shiva\" } window 20,20\r\n988.3 \"Dreams Of Ice\" Ability { id: \"536A\", source: \"Shiva\" }\r\n\r\n996.2 \"Frost Staff?\" Ability { id: \"5367\", source: \"Shiva\" } window 100,50 jump 1096.2\r\n996.2 \"Frost Blade?\" Ability { id: \"5366\", source: \"Shiva\" } window 100,50 jump 1296.2\r\n\r\n\r\n# Phase 7a: Staff\r\n1096.2 \"Frost Staff\" Ability { id: \"5367\", source: \"Shiva\" }\r\n1098.1 \"Icicle Impact (cross)\" #Ability { id: \"537B\", source: \"Shiva\" }\r\n1104.3 \"Hailstorm\" Ability { id: \"536E\", source: \"Shiva\" }\r\n1106.1 \"Icicle Impact (cross)\" #Ability { id: \"537B\", source: \"Shiva\" }\r\n1109.0 \"Permafrost?\" Ability { id: \"5369\", source: \"Shiva\" }\r\n1117.8 \"Absolute Zero\" Ability { id: \"5370\", source: \"Shiva\" } window 20,2.5\r\n1125.6 \"Absolute Zero\" Ability { id: \"5370\", source: \"Shiva\" }\r\n1133.0 \"Absolute Zero\" Ability { id: \"5370\", source: \"Shiva\" }\r\n# Note: this last absolute zero can either happen at 1135.8 or 1140.4 depending on\r\n# where the permafrost shows up.  So, don't sync it.\r\n1138.0 \"Absolute Zero\" #Ability { id: \"5370\", source: \"Shiva\" }\r\n1140.0 \"Permafrost?\" Ability { id: \"5369\", source: \"Shiva\" }\r\n1149.4 \"Melt\" Ability { id: \"53AE\", source: \"Shiva\" } window 20,20\r\n1156.6 \"Icicle Impact (circle)\" duration 4 #Ability { id: \"537B\", source: \"Shiva\" }\r\n1159.5 \"Permafrost?\" Ability { id: \"5369\", source: \"Shiva\" }\r\n1163.7 \"Dreams Of Ice\" Ability { id: \"536A\", source: \"Shiva\" } window 20,20\r\n\r\n1166.9 \"Frost Bow\" Ability { id: \"5368\", source: \"Shiva\" } window 100,20 jump 942.8\r\n1172.0 \"Glass Dance\" #Ability { id: \"5378\", source: \"Shiva\" }\r\n1194.6 \"Avalanche\" #Ability { id: \"5379\", source: \"Shiva\" }\r\n1198.7 \"Permafrost?\" #Ability { id: \"5369\", source: \"Shiva\" }\r\n1210.2 \"Melt\" #Ability { id: \"53AD\", source: \"Shiva\" } window 20,20\r\n1212.4 \"Dreams Of Ice\" #Ability { id: \"536A\", source: \"Shiva\" }\r\n\r\n\r\n\r\n\r\n# Phase 7b: Sword\r\n1296.2 \"Frost Blade\" Ability { id: \"5366\", source: \"Shiva\" }\r\n1298.5 \"Icicle Impact (cross)\" #Ability { id: \"537B\", source: \"Shiva\" }\r\n1302.3 \"Icebrand\" Ability { id: \"5373\", source: \"Shiva\" }\r\n1306.4 \"Icicle Impact (cross)\" #Ability { id: \"537B\", source: \"Shiva\" }\r\n1306.4 \"Permafrost?\" Ability { id: \"5369\", source: \"Shiva\" }\r\n1316.8 \"--sync--\" StartsUsing { id: \"5375\", source: \"Shiva\" } window 10,10\r\n1319.0 \"Glacier Bash\" Ability { id: \"5375\", source: \"Shiva\" }\r\n1329.4 \"Whiteout\" Ability { id: \"5376\", source: \"Shiva\" }\r\n1334.7 \"Heavenly Strike\" Ability { id: \"5374\", source: \"Shiva\" }\r\n1338.8 \"Permafrost?\" Ability { id: \"5369\", source: \"Shiva\" }\r\n1350.7 \"Melt\" Ability { id: \"5372\", source: \"Shiva\" } window 20,10\r\n1357.9 \"Icicle Impact (circle)\" duration 4 #Ability { id: \"537B\", source: \"Shiva\" }\r\n1360.8 \"Permafrost?\" Ability { id: \"5369\", source: \"Shiva\" }\r\n1365.0 \"Dreams Of Ice\" Ability { id: \"536A\", source: \"Shiva\" } window 20,20\r\n\r\n1368.2 \"Frost Bow\" Ability { id: \"5368\", source: \"Shiva\" } window 100,20 jump 942.8\r\n1373.3 \"Glass Dance\" #Ability { id: \"5378\", source: \"Shiva\" }\r\n1395.9 \"Avalanche\" #Ability { id: \"5379\", source: \"Shiva\" }\r\n1400.0 \"Permafrost?\" #Ability { id: \"5369\", source: \"Shiva\" }\r\n1411.5 \"Melt\" #Ability { id: \"53AD\", source: \"Shiva\" } window 20,20\r\n1413.7 \"Dreams Of Ice\" #Ability { id: \"536A\", source: \"Shiva\" }\r\n\r\n\r\n\r\n# Enrage\r\n#1165.6 \"--untargetable--\"\r\n#1176.7 \"--sync--\" Ability { id: \"53AC\", source: \"Shiva\" }\r\n#1176.7 \"Diamond Dust\" Ability { id: \"536B\", source: \"Shiva\" }\r\n#1181.6 \"Diamond Dust\" Ability { id: \"536C\", source: \"Shiva\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/titan-un.ts


const titan_un_triggerSet = {
  id: 'TheNavelUnreal',
  zoneId: zone_id/* default.TheNavelUnreal */.Z.TheNavelUnreal,
  timelineFile: 'titan-un.txt',
  timelineTriggers: [{
    id: 'TitanUn Mountain Buster',
    regex: /Mountain Buster/,
    beforeSeconds: 7,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'TitanUn Mountain Buster Avoid',
    regex: /Mountain Buster/,
    beforeSeconds: 7,
    condition: data => data.role !== 'healer' && data.role !== 'tank',
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'TitanUn Tumult',
    regex: /Tumult/,
    beforeSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'TitanUn Gaoler Adds',
    regex: /Gaoler Adds/,
    beforeSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Gaoler Adds',
        de: 'graniten Kerkermeister Adds',
        fr: 'Adds Geôlier',
        ja: '雑魚: 子タイタン',
        cn: '小土豆出现',
        ko: '화강암 감옥 쫄'
      }
    }
  }, {
    id: 'TitanUn Double Weight',
    regex: /Weight Of The Land 1/,
    beforeSeconds: 4,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Double Weight',
        de: 'Doppeltes Gaias Gewicht',
        fr: 'Double poids',
        ja: '大地の重み2連',
        cn: '二连流沙',
        ko: '2연속 대지의 무게'
      }
    }
  }],
  triggers: [{
    // Doesn't seem like this happens twice, but let's be safe.
    id: 'TitanUn Rock Throw',
    type: 'Tether',
    netRegex: {
      id: '0007'
    },
    suppressSeconds: 1,
    alertText: (data, matches, output) => {
      if (matches.source === data.me || matches.target === data.me) return output.jailOnYou();
    },
    infoText: (data, matches, output) => {
      if (matches.source !== data.me && matches.target !== data.me) return output.jails();
    },
    outputStrings: {
      jailOnYou: {
        en: 'Jail on YOU',
        de: 'Gefängnis auf DIR',
        fr: 'Geôle sur VOUS',
        ja: '自分にジェイル',
        cn: '石牢点名',
        ko: '돌감옥 대상자'
      },
      jails: {
        en: 'Jails',
        de: 'Gefängnis',
        fr: 'Geôles',
        ja: 'ジェイル',
        cn: '石牢',
        ko: '돌감옥'
      }
    }
  }, {
    id: 'TitanUn Upheaval',
    type: 'StartsUsing',
    // Five second cast time.
    netRegex: {
      source: 'Titan',
      id: '58F9',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback('info')
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bomb Boulder': 'Bomber-Brocken',
      'Granite Gaoler': 'graniten(?:e|er|es|en) Kerkermeister',
      'Titan': 'Titan'
    },
    'replaceText': {
      '\\(all\\)': '(alle)',
      '\\(clock\\)': '(Uhrzeiger)',
      '\\(one side\\)': '(eine Seite)',
      '\\(row 1\\)': '(Reihe 1)',
      '\\(row 2\\)': '(Reihe 2)',
      '\\(row 3\\)': '(Reihe 3)',
      'Burst': 'Einschlag',
      'Bury': 'Begraben',
      'Earthen Fury': 'Gaias Zorn',
      'Gaoler Adds': 'Kerkermeister Adds',
      'Gaoler Landslide': 'Kerkermeister Bergsturz',
      'Gaoler Tumult': 'Kerkermeister Urerschütterung ',
      'Geocrush': 'Geo-Stoß',
      '(?<! )Landslide': 'Bergsturz',
      'Mountain Buster': 'Bergsprenger',
      'Rock Buster': 'Steinsprenger',
      'Rock Throw': 'Granitgefängnis',
      '(?<! )Tumult': 'Urerschütterung',
      'Upheaval': 'Urtrauma',
      'Weight Of The Land': 'Gaias Gewicht'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bomb Boulder': 'Bombo Rocher',
      'Granite Gaoler': 'Geôlier De Granite',
      'Titan': 'Titan'
    },
    'replaceText': {
      '\\(all\\)': '(tous)',
      '\\(clock\\)': '(sens horaire)',
      '\\(one side\\)': '(un côté)',
      '\\(row (\\\d)\\)': '(rangée $1)',
      'Burst': 'Explosion',
      'Bury': 'Ensevelissement',
      'Earthen Fury': 'Fureur tellurique',
      'Gaoler Adds': 'Adds geôlier',
      'Gaoler Landslide\\?': 'Geôlier glissement ?',
      'Gaoler Tumult': 'Geôlier tumulte',
      'Geocrush': 'Broie-terre',
      '(?<! )Landslide': 'Glissement de terrain',
      'Mountain Buster': 'Casse-montagnes',
      'Rock Buster': 'Casse-roc',
      'Rock Throw': 'Jeté de rocs',
      '(?<! )Tumult': 'Tumulte',
      'Upheaval': 'Bouleversement',
      'Weight Of The Land': 'Poids de la terre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bomb Boulder': 'ボムボルダー',
      'Granite Gaoler': 'グラナイト・ジェイラー',
      'Titan': 'タイタン'
    },
    'replaceText': {
      '\\(all\\)': '(全て)',
      '\\(clock\\)': '(時針回り)',
      '\\(one side\\)': '(一側)',
      '\\(row 1\\)': '(1列)',
      '\\(row 2\\)': '(2列)',
      '\\(row 3\\)': '(3列)',
      'Burst': '大爆発',
      'Bury': '衝撃',
      'Earthen Fury': '大地の怒り',
      'Gaoler Adds': '雑魚: 子タイタン',
      'Gaoler Landslide\\?': '子タイタン: ランドスライド?',
      'Gaoler Tumult': '子タイタン: 激震',
      'Geocrush': 'ジオクラッシュ',
      '(?<! )Landslide': 'ランドスライド',
      'Mountain Buster': 'マウンテンバスター',
      'Rock Buster': 'ロックバスター',
      'Rock Throw': 'グラナイト・ジェイル',
      '(?<! )Tumult': '激震',
      'Upheaval': '大激震',
      'Weight Of The Land': '大地の重み'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bomb Boulder': '爆破岩石',
      'Granite Gaoler': '花岗石卫',
      'Titan': '泰坦'
    },
    'replaceText': {
      '\\(all\\)': '(全部)',
      '\\(clock\\)': '(顺时针)',
      '\\(one side\\)': '(一侧)',
      '\\(row 1\\)': '(第1列)',
      '\\(row 2\\)': '(第2列)',
      '\\(row 3\\)': '(第3列)',
      'Burst': '爆炸',
      'Bury': '塌方',
      'Earthen Fury': '大地之怒',
      'Gaoler Adds': '花岗石卫出现',
      'Gaoler Landslide': '花岗石卫地裂',
      'Gaoler Tumult': '花岗石卫怒震',
      'Geocrush': '大地粉碎',
      '(?<! )Landslide': '地裂',
      'Mountain Buster': '山崩',
      'Rock Buster': '碎岩',
      'Rock Throw': '花岗岩牢狱',
      '(?<! )Tumult': '怒震',
      'Upheaval': '大怒震',
      'Weight Of The Land': '大地之重'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bomb Boulder': '바위폭탄',
      'Granite Gaoler': '화강암 감옥',
      'Titan': '타이탄'
    },
    'replaceText': {
      '\\(all\\)': '(모두)',
      '\\(clock\\)': '(시계 방향)',
      '\\(one side\\)': '(한 방향)',
      '\\(row 1\\)': '(1열)',
      '\\(row 2\\)': '(2열)',
      '\\(row 3\\)': '(3열)',
      'Burst': '대폭발',
      'Bury': '충격',
      'Earthen Fury': '대지의 분노',
      'Gaoler': '화강암 감옥',
      'Adds': '쫄 추가',
      'Geocrush': '대지 붕괴',
      'Landslide': '산사태',
      'Mountain Buster': '산 쪼개기',
      'Rock Buster': '바위 쪼개기',
      'Rock Throw': '화강암 감옥',
      'Tumult': '격진',
      'Upheaval': '대격진',
      'Weight Of The Land': '대지의 무게'
    }
  }]
};
/* harmony default export */ const titan_un = (titan_un_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/titan-un.txt
const trial_titan_un_namespaceObject = "# Titan Extreme\r\n# -p 58FF:203 5900:700 -ii 368 5BD 5BC 673\r\n\r\n# Note: Landslides during upheavals only happen if there is a targetable\r\n# player outside the two jails.  If solo/duo-ing, then everything moves\r\n# up ~6 seconds or so, which is why there's large windows after Upheaval.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1: 100->85%\r\n0.0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n\r\n10.0 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" } window 10,10\r\n18.7 \"Weight Of The Land\" Ability { id: \"58FE\", source: \"Titan\" } window 20,5\r\n22.3 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" }\r\n27.5 \"Tumult x4\" duration 3.5 #Ability { id: \"58F8\", source: \"Titan\" }\r\n37.3 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" }\r\n41.4 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" }\r\n48.0 \"Weight Of The Land\" Ability { id: \"58FE\", source: \"Titan\" }\r\n55.7 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" }\r\n\r\n62.0 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" } window 15,15 jump 10\r\n70.2 \"Weight Of The Land\"\r\n74.3 \"Mountain Buster\"\r\n79.5 \"Tumult x4\" duration 3.5 #Ability { id: \"58F8\", source: \"Titan\" }\r\n89.3 \"Landslide\"\r\n93.4 \"Mountain Buster\"\r\n99.5 \"Weight Of The Land\"\r\n107.7 \"Mountain Buster\"\r\n\r\n\r\n# Phase 2: 85%->55%\r\n200.0 \"--sync--\" StartsUsing { id: \"58FF\", source: \"Titan\" } window 200,0\r\n203.0 \"Geocrush\" Ability { id: \"58FF\", source: \"Titan\" }\r\n\r\n212.6 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" }\r\n216.7 \"Rock Throw\" Ability { id: \"5ADD\", source: \"Titan\" } duration 21.5\r\n220.8 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" }\r\n229.8 \"Upheaval\" Ability { id: \"58F9\", source: \"Titan\" }\r\n234.8 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" }\r\n242.0 \"Tumult x4\" duration 3.5 # Ability { id: \"58F8\", source: \"Titan\" }\r\n251.0 \"Weight Of The Land\" Ability { id: \"58FE\", source: \"Titan\" } window 15,15\r\n254.6 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" }\r\n262.0 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" }\r\n271.7 \"Weight Of The Land\" Ability { id: \"58FE\", source: \"Titan\" }\r\n276.8 \"Bury (one side)\" Ability { id: \"5AFB\", source: \"Bomb Boulder\" }\r\n278.0 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" }\r\n287.4 \"Burst\" Ability { id: \"5ADF\", source: \"Bomb Boulder\" }\r\n\r\n288.1 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" }\r\n292.2 \"Rock Throw\" Ability { id: \"5ADD\", source: \"Titan\" } duration 21.5\r\n296.3 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" }\r\n305.4 \"Upheaval\" Ability { id: \"58F9\", source: \"Titan\" }\r\n310.4 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" }\r\n317.5 \"Tumult x4\" duration 3.5 #Ability { id: \"58F8\", source: \"Titan\" }\r\n326.5 \"Weight Of The Land\" Ability { id: \"58FE\", source: \"Titan\" } window 15,15\r\n330.1 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" }\r\n337.3 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" }\r\n347.0 \"Weight Of The Land\" Ability { id: \"58FE\", source: \"Titan\" }\r\n351.7 \"Bury (clock)\" duration 4.2 #Ability { id: \"5AFB\", source: \"Bomb Boulder\" }\r\n353.6 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" }\r\n360.9 \"Burst\" duration 4.2 #Ability { id: \"5ADF\", source: \"Bomb Boulder\" }\r\n\r\n363.9 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" } window 20,20 jump 212.6\r\n368.0 \"Rock Throw\"\r\n372.1 \"Mountain Buster\"\r\n381.1 \"Upheaval\"\r\n387.3 \"Tumult x4\"\r\n395.8 \"Weight Of The Land\"\r\n399.9 \"Mountain Buster\"\r\n407.3 \"Landslide\"\r\n416.5 \"Weight Of The Land\"\r\n422.1 \"Bury (one side)\"\r\n423.3 \"Mountain Buster\"\r\n432.7 \"Burst\"\r\n\r\n\r\n### Phase 3: Heart Phase (at 55%)\r\n500.0 \"--sync--\" StartsUsing { id: \"58FF\", source: \"Titan\" } window 299,0\r\n503.0 \"Geocrush\" Ability { id: \"58FF\", source: \"Titan\" }\r\n515.6 \"Weight Of The Land\" Ability { id: \"58FE\", source: \"Titan\" }\r\n521.2 \"Rock Throw\" Ability { id: \"5ADD\", source: \"Titan\" } duration 21.5\r\n526.0 \"Rock Buster\" Ability { id: \"58F6\", source: \"Titan\" }\r\n533.0 \"Upheaval\" Ability { id: \"58F9\", source: \"Titan\" }\r\n538.0 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" }\r\n544.0 \"Tumult x4\" duration 3.5 #Ability { id: \"58F8\", source: \"Titan\" }\r\n553.1 \"Weight Of The Land\" Ability { id: \"58FE\", source: \"Titan\" } window 15,15\r\n561.8 \"Rock Buster\" Ability { id: \"58F6\", source: \"Titan\" }\r\n563.8 \"Bury (clock)\" duration 3 # Ability { id: \"5AFB\", source: \"Bomb Boulder\" }\r\n570.8 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" }\r\n572.9 \"Burst\" duration 3 # Ability { id: \"5ADF\", source: \"Bomb Boulder\" }\r\n574.9 \"Tumult x4\" duration 3.5 #Ability { id: \"58F8\", source: \"Titan\" }\r\n583.0 \"Weight Of The Land\" Ability { id: \"58FE\", source: \"Titan\" }\r\n593.0 \"--untargetable--\"\r\n\r\n\r\n### Phase 4\r\n700.0 \"Earthen Fury\" Ability { id: \"5900\", source: \"Titan\" } window 700,0\r\n713.1 \"Gaoler Adds (E/W)\"\r\n715.8 \"Gaoler Tumult\" #Ability { id: \"5903\", source: \"Granite Gaoler\" }\r\n716.3 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" }\r\n\r\n723.3 \"Bury x4\" #Ability { id: \"5AFB\", source: \"Bomb Boulder\" }\r\n725.8 \"Bury x4\" #Ability { id: \"5AFB\", source: \"Bomb Boulder\" }\r\n730.2 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" }\r\n732.5 \"Burst x4\" #Ability { id: \"5ADF\", source: \"Bomb Boulder\" }\r\n734.9 \"Burst x4\" #Ability { id: \"5ADF\", source: \"Bomb Boulder\" }\r\n735.4 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" }\r\n739.8 \"Gaoler Landslide?\" #Ability { id: \"5902\", source: \"Granite Gaoler\" }\r\n744.0 \"Weight Of The Land\" Ability { id: \"58FE\", source: \"Titan\" }\r\n\r\n749.7 \"Rock Throw\" Ability { id: \"5ADD\", source: \"Titan\" } duration 21.5\r\n753.9 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" }\r\n762.9 \"Upheaval\" Ability { id: \"58F9\", source: \"Titan\" }\r\n767.9 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" }\r\n779.0 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" } window 15,15\r\n783.2 \"Tumult x4\" duration 3.5 #Ability { id: \"58F8\", source: \"Titan\" }\r\n792.2 \"Weight Of The Land 1\" #Ability { id: \"58FE\", source: \"Titan\" }\r\n794.7 \"Weight Of The Land 2\" #Ability { id: \"58FE\", source: \"Titan\" }\r\n799.9 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" }\r\n\r\n804.1 \"Bury (row 1)\" #Ability { id: \"5AFB\", source: \"Bomb Boulder\" }\r\n805.0 \"Bury (row 2)\" #Ability { id: \"5AFB\", source: \"Bomb Boulder\" }\r\n806.1 \"Bury (row 3)\" #Ability { id: \"5AFB\", source: \"Bomb Boulder\" }\r\n811.0 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" }\r\n813.1 \"Burst 1\" #Ability { id: \"5ADF\", source: \"Bomb Boulder\" }\r\n814.6 \"Burst 2\" #Ability { id: \"5ADF\", source: \"Bomb Boulder\" }\r\n816.1 \"Burst 3\" #Ability { id: \"5ADF\", source: \"Bomb Boulder\" }\r\n819.2 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" }\r\n\r\n832.7 \"Bury (all)\" Ability { id: \"5AFB\", source: \"Bomb Boulder\" }\r\n837.0 \"Tumult x4\" duration 3.5 #Ability { id: \"58F8\", source: \"Titan\" }\r\n845.9 \"Weight Of The Land\" Ability { id: \"58FE\", source: \"Titan\" }\r\n852.5 \"--untargetable--\"\r\n855.1 \"Burst\" Ability { id: \"5ADF\", source: \"Bomb Boulder\" }\r\n856.7 \"Geocrush\" Ability { id: \"58FF\", source: \"Titan\" }\r\n857.1 \"--targetable--\"\r\n862.4 \"Landslide\" Ability { id: \"58FA\", source: \"Titan\" }\r\n\r\n# loop\r\n874.0 \"Gaoler Adds (E/W)\"\r\n876.7 \"Gaoler Tumult\" #Ability { id: \"5903\", source: \"Granite Gaoler\" }\r\n877.2 \"Mountain Buster\" Ability { id: \"58F7\", source: \"Titan\" } window 40,40 jump 716.3\r\n\r\n884.2 \"Bury x4\"\r\n886.7 \"Bury x4\"\r\n891.1 \"Landslide\"\r\n893.4 \"Burst x4\"\r\n895.8 \"Burst x4\"\r\n896.3 \"Mountain Buster\"\r\n900.7 \"Gaoler Landslide?\"\r\n904.4 \"Weight Of The Land\"\r\n\r\n\r\n### Enrage\r\n1000.0 \"--sync--\" StartsUsing { id: \"5901\", source: \"Titan\" } window 1000,1000\r\n1010.0 \"Upheaval Enrage\" #Ability { id: \"5901\", source: \"Titan\" }\r\n1022.0 \"Upheaval Enrage\" #Ability { id: \"5901\", source: \"Titan\" }\r\n1034.0 \"Upheaval Enrage\" #Ability { id: \"5901\", source: \"Titan\" }\r\n1046.0 \"Upheaval Enrage\" #Ability { id: \"5901\", source: \"Titan\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/titania-ex.ts




// Titania Extreme
const titania_ex_triggerSet = {
  id: 'TheDancingPlagueExtreme',
  zoneId: zone_id/* default.TheDancingPlagueExtreme */.Z.TheDancingPlagueExtreme,
  timelineFile: 'titania-ex.txt',
  triggers: [{
    id: 'TitaniaEx Bright Sabbath',
    type: 'StartsUsing',
    netRegex: {
      id: '3D4B',
      source: 'Titania',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'TitaniaEx Phantom Out',
    type: 'StartsUsing',
    netRegex: {
      id: '3D4C',
      source: 'Titania',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'TitaniaEx Phantom In',
    type: 'StartsUsing',
    netRegex: {
      id: '3D4D',
      source: 'Titania',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'TitaniaEx Mist Failure',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Spirit Of Dew',
      capture: false
    },
    response: responses/* Responses.killExtraAdd */.n3.killExtraAdd()
  }, {
    id: 'TitaniaEx Mist',
    type: 'StartsUsing',
    netRegex: {
      id: '3D45',
      source: 'Titania',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.seenMistRune) return output.inOutThenWaterPositions();
      return output.waterPositions();
    },
    run: data => data.seenMistRune = true,
    outputStrings: {
      inOutThenWaterPositions: {
        en: 'In/Out, then Water Positions',
        de: 'Rein/Raus, danach Wasser Positionen',
        fr: 'Intérieur/Extérieur, puis positions pour l\'eau',
        ja: '中/外避けてポジションへ',
        cn: '靠近/远离, 水圈站位',
        ko: '안/밖 -> 물 장판 위치'
      },
      waterPositions: {
        en: 'Water Positions',
        de: 'Wasser Positionen',
        fr: 'Positions pour l\'eau',
        ja: 'ポジションへ',
        cn: '水圈站位',
        ko: '물 장판'
      }
    }
  }, {
    id: 'TitaniaEx Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '3D47',
      source: 'Titania',
      capture: false
    },
    // You have 16.5 seconds until the first stack damage.
    delaySeconds: 8.5,
    alertText: (data, _matches, output) => {
      if (data.seenFlameRune) return output.stackMaybeRotate();
      return output.stackPositions();
    },
    run: data => data.seenFlameRune = true,
    outputStrings: {
      stackMaybeRotate: {
        en: 'Stack (maybe rotate?)',
        de: 'Sammeln (evtl rotieren?)',
        fr: 'Packez-vous (rotation ?)',
        ja: '集合 (多分時計回り?)',
        cn: '左右集合 (可能旋转?)',
        ko: '쉐어징 모이기'
      },
      stackPositions: {
        en: 'Stack Positions',
        de: 'Sammel-Positionen',
        fr: 'Packez-vous, positions',
        ja: '頭割り集合',
        cn: '左右集合',
        ko: '쉐어징 모이기'
      }
    }
  }, {
    id: 'TitaniaEx Divination',
    type: 'StartsUsing',
    netRegex: {
      id: '3D4A',
      source: 'Titania'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'TitaniaEx Bramble 1',
    type: 'StartsUsing',
    netRegex: {
      id: '42D7',
      source: 'Titania',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Wait For Tethers In Center',
        de: 'Auf die Verbindung in der Mitte warten',
        fr: 'Attendez les liens au centre',
        ja: '中央で待機',
        cn: '中间集合等待荆棘',
        ko: '가시 연결되기 전에 중앙으로'
      }
    }
  }, {
    id: 'TitaniaEx Bramble 2',
    type: 'Tether',
    netRegex: {
      id: '0012'
    },
    alertText: (data, matches, output) => {
      const partner = matches.target === data.me ? matches.source : matches.target;
      return output.breakTether({
        player: data.party.member(partner)
      });
    },
    outputStrings: {
      breakTether: {
        en: 'Break Tether (w/${player})',
        de: 'Verbindungen brechen (mit ${player})',
        fr: 'Cassez les liens (avec ${player})',
        cn: '拉断连线 (与${player})',
        ko: '선 끊기 (+${player})'
      }
    }
  }, {
    id: 'TitaniaEx Bramble Knockback',
    type: 'Ability',
    netRegex: {
      id: '3D42',
      source: 'Puck',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Diagonal Knockback Soon',
        de: 'diagonaler Knockback bald',
        fr: 'Poussée en diagonale bientôt',
        ja: '対角に飛ぶ',
        cn: '对角击退准备',
        ko: '곧 대각선 넉백'
      }
    }
  }, {
    id: 'TitaniaEx Fae Light',
    type: 'StartsUsing',
    netRegex: {
      id: '3D2C',
      source: 'Titania'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'TitaniaEx Fae Light Cleave',
    type: 'StartsUsing',
    netRegex: {
      id: '3D2C',
      source: 'Titania'
    },
    condition: data => data.role !== 'tank' && data.role !== 'healer',
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'TitaniaEx Frost Rune 1',
    type: 'StartsUsing',
    netRegex: {
      id: '3D2A',
      source: 'Titania',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Middle, Shiva Circles',
        de: 'In die Mitte, Shiva Kreise',
        fr: 'Allez au milieu, cercles de Shiva',
        ja: 'シヴァの輪っか',
        cn: '中间集合, 九连环',
        ko: '시바 얼음 장판'
      }
    }
  }, {
    id: 'TitaniaEx Frost Rune 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3D2A',
      source: 'Titania',
      capture: false
    },
    delaySeconds: 6.5,
    response: responses/* Responses.getOut */.n3.getOut('info')
  }, {
    id: 'TitaniaEx Frost Rune 3',
    type: 'Ability',
    netRegex: {
      id: '3D2B',
      source: 'Titania',
      capture: false
    },
    suppressSeconds: 60,
    response: responses/* Responses.getIn */.n3.getIn('info')
  }, {
    id: 'TitaniaEx Growth Rune',
    type: 'StartsUsing',
    netRegex: {
      id: '3D2E',
      source: 'Titania',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Roots',
        de: 'Ranken',
        fr: 'Racines',
        ja: '根のルーン',
        cn: '根系生长',
        ko: '뿌리 나옴'
      }
    }
  }, {
    id: 'TitaniaEx Uplift Markers',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'TitaniaEx Hard Swipe',
    type: 'StartsUsing',
    netRegex: {
      id: '3D36',
      source: 'Peaseblossom'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'TitaniaEx Pummel',
    type: 'StartsUsing',
    netRegex: {
      id: '3D37',
      source: 'Puck',
      capture: false
    },
    condition: data => data.role === 'tank' || data.job === 'BLU',
    preRun: data => {
      data.pummelCount ??= 0;
      data.pummelCount++;
    },
    infoText: (data, _matches, output) => output.text({
      num: data.pummelCount
    }),
    outputStrings: {
      text: {
        en: 'Pummel ${num}',
        de: 'Deftige Dachtel ${num}',
        fr: 'Torgnole ${num}',
        ja: '殴打 ${num}',
        cn: '殴打 ${num}',
        ko: '구타 ${num}'
      }
    }
  }, {
    id: 'TitaniaEx Peasebomb',
    type: 'HeadMarker',
    netRegex: {
      id: '008D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread(),
    run: data => {
      data.bomb ??= {};
      data.bomb[data.me] = true;
    }
  }, {
    id: 'TitaniaEx Peasebomb Use',
    type: 'Ability',
    netRegex: {
      id: '3D3F',
      source: 'Peaseblossom',
      capture: false
    },
    run: data => delete data.bomb
  }, {
    id: 'TitaniaEx Adds Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '00A1'
    },
    delaySeconds: 0.25,
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.stackOnYou();
      if (data.bomb && data.bomb[data.me]) return;
      return output.stackOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'TitaniaEx Thunder Tether',
    type: 'Tether',
    netRegex: {
      id: '0054',
      source: 'Titania',
      capture: false
    },
    suppressSeconds: 60,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Initial Thunder Tether',
        de: 'initiale Blitz Verbindung',
        fr: 'Lien de foudre initial',
        ja: '線一人目',
        cn: '初始雷连线',
        ko: '첫 번개 징 대상자'
      }
    }
  }, {
    id: 'TitaniaEx Thunder Rune',
    type: 'Ability',
    netRegex: {
      id: '3D29',
      source: 'Titania',
      capture: false
    },
    preRun: data => data.thunderCount = (data.thunderCount ?? 0) + 1,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => output.text({
      num: data.thunderCount
    }),
    outputStrings: {
      text: {
        en: 'Thunder ${num}',
        de: 'Blitz ${num}',
        fr: 'Foudre ${num}',
        ja: '線${num}人目',
        cn: '雷连线 #${num}',
        ko: '${num}번째 번개'
      }
    }
  }, {
    id: 'TitaniaEx Thunder Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '3D32',
      source: 'Titania',
      capture: false
    },
    run: data => delete data.thunderCount
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Spirit of Flame': 'Feuerfee',
      'Spirit of Wood': 'Holzfee',
      'Spirit Of Dew': 'Wasserfee',
      'Titania': 'Titania',
      'Puck': 'Puck',
      'Peaseblossom': 'Bohnenblüte',
      'Mustardseed': 'Senfsamen'
    },
    'replaceText': {
      'Whispering Wind': 'Flüsternde Winde',
      'Wallop': 'Eindreschen',
      'Uplift': 'Feenring',
      'Thunder Rune': 'Donnerrune',
      'Pummel': 'Deftige Dachtel',
      'Puck\'s Rebuke': 'Pucks Tadel',
      'Puck\'s Caprice': 'Pucks Laune',
      'Puck\'s Breath': 'Pucks Atem',
      'Phantom Rune(?! )': 'Phantomrune',
      'Peasebomb': 'Bohnenbombe',
      '(?<! )Pease(?!\\w)': 'Bohne',
      'Mist Rune': 'Nebelrune',
      'Midsummer Night\'s Dream': 'Mittsommernachtstraum',
      'Leafstorm': 'Blättersturm',
      'Hard Swipe': 'Harter Hieb',
      'Growth Rune': 'Wachstumsrune',
      'Gentle Breeze': 'Sanfte Brise',
      'Frost Rune': 'Frostrune',
      'Flame Rune': 'Flammenrune',
      'Flame Hammer': 'Flammenhammer',
      'Fae Light': 'Feenlicht',
      'Divination Rune': 'Prophezeiungsrune',
      'Chain Of Brambles': 'Dornenfessel',
      'Bright Sabbath': 'Leuchtender Sabbat',
      'Being Mortal': 'Sterblichkeit',
      'Love-In-Idleness': 'Liebevoller Müßiggang',
      'War And Pease': 'Bohnenkrieg',
      'Phantom Rune In': 'Phantomrune Rein',
      'Phantom Rune Out': 'Phantomrune Raus'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Spirit Of Dew': 'Esprit Des Rosées',
      'spirit of flame': 'Esprit Des Flammes',
      'Spirit of Wood': 'Esprit Des Bois',
      'Titania': 'Titania',
      'Puck': 'Puck',
      'Peaseblossom': 'Fleur-de-pois',
      'Mustardseed': 'Pousse-de-moutarde'
    },
    'replaceText': {
      'Whispering Wind': 'Vent susurrant',
      'War And Pease': 'La fin des haricots',
      'Wallop': 'Rossée',
      'Uplift': 'Exhaussement',
      'Thunder Rune': 'Rune de foudre',
      'Pummel': 'Torgnole',
      'Puck\'s Rebuke': 'Réprimande de Puck',
      'Puck\'s Caprice': 'Toquade de Puck',
      'Puck\'s Breath': 'Haleine de Puck',
      'Phantom Rune(?! )': 'Rune d\'illusion',
      'Phantom Rune In': 'Rune d\'illusion intérieur',
      'Phantom Rune Out': 'Rune d\'illusion extérieur',
      'Peasebomb': 'Haricot explosif',
      '(?<! )Pease(?!\\w)': 'Explosion de haricot',
      'Mist Rune': 'Rune d\'eau',
      'Midsummer Night\'s Dream': 'Songe d\'une nuit d\'été',
      'Love-In-Idleness': 'Pensées sauvages',
      'Leafstorm': 'Tempête de feuilles',
      'Hard Swipe': 'Fauchage brutal',
      'Growth Rune': 'Rune de racine',
      'Gentle Breeze': 'Douce brise',
      'Frost Rune(?! )': 'Rune de gel',
      'Frost Rune Middle': 'Rune de gel au milieu',
      'Flame Rune': 'Rune de feu',
      'Flame Hammer': 'Marteau de feu',
      'Fae Light': 'Lueur féérique',
      'Divination Rune': 'Rune de malice',
      'Chain Of Brambles': 'Chaînes de ronces',
      'Bright Sabbath': 'Sabbat en plein jour',
      'Being Mortal': 'Deuil des vivants'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Spirit Of Dew': '水の精',
      'Spirit of Flame': '火の精',
      'Spirit of Wood': '木の精',
      'Titania': 'ティターニア',
      'Puck': 'パック',
      'Peaseblossom': 'ピーズブロッサム',
      'Mustardseed': 'マスタードシード'
    },
    'replaceText': {
      'Whispering Wind': 'ウィスパリング・ウィンド',
      'War And Pease': '大豆爆発',
      'Wallop': '叩きつけ',
      'Uplift': '隆起',
      'Thunder Rune': '雷のルーン',
      'Pummel': '殴打',
      'Puck\'s Rebuke': 'パックレビューク',
      'Puck\'s Caprice': 'パック・カプリース',
      'Puck\'s Breath': 'パック・ブレス',
      'Phantom Rune In': '幻のルーン（中央）',
      'Phantom Rune Out': '幻のルーン（外）',
      'Phantom Rune(?! )': '幻のルーン',
      'Peasebomb': 'ビーズボム',
      '(?<! )Pease(?!\\w)': '豆爆発',
      'Mist Rune': '水のルーン',
      'Midsummer Night\'s Dream': 'ミッドサマー・ナイツドリーム',
      'Love-In-Idleness': 'ラブ・イン・アイドルネス',
      'Leafstorm': 'リーフストーム',
      'Hard Swipe': 'ハードスワイプ',
      'Growth Rune': '根のルーン',
      'Gentle Breeze': '上風',
      'Frost Rune': '氷のルーン',
      'Flame Rune': '火のルーン',
      'Flame Hammer': 'フレイムハンマー',
      'Fae Light': '妖精光',
      'Divination Rune': '魔のルーン',
      'Chain Of Brambles': 'ブランブルチェーン',
      'Bright Sabbath': 'ブライトサバト',
      'Being Mortal': '死すべき定め'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Spirit Of Dew': '水精',
      'Spirit of Flame': '炎精',
      'Spirit of Wood': '木精',
      'Titania': '缇坦妮雅',
      'Puck': '帕克',
      'Peaseblossom': '豌豆花',
      'Mustardseed': '芥子'
    },
    'replaceText': {
      'Whispering Wind': '细语微风',
      'War And Pease': '豌豆大爆炸',
      'Wallop': '敲击',
      'Uplift': '隆起',
      'Thunder Rune': '雷之符文',
      'Pummel': '殴打',
      'Puck\'s Rebuke': '帕克的指责',
      'Puck\'s Caprice': '帕克的随想',
      'Puck\'s Breath': '帕克的吐息',
      'Phantom Rune In': '幻之符文靠近',
      'Phantom Rune Out': '幻之符文远离',
      'Phantom Rune(?! )': '幻之符文',
      'Peasebomb': '豌豆炸弹',
      '(?<! )Pease(?!\\w)': '豌豆爆炸',
      'Mist Rune': '水之符文',
      'Midsummer Night\'s Dream': '仲夏夜之梦',
      'Love-In-Idleness': '爱懒花',
      'Leafstorm': '绿叶风暴',
      'Hard Swipe': '强烈重击',
      'Growth Rune': '根之符文',
      'Gentle Breeze': '青翠柔风',
      'Frost Rune': '冰之符文',
      'Flame Rune': '火之符文',
      'Flame Hammer': '烈火锤',
      'Fae Light': '妖灵光',
      'Divination Rune': '魔之符文',
      'Chain Of Brambles': '荆棘链',
      'Bright Sabbath': '欢快的安息日',
      'Being Mortal': '终有一死'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Spirit Of Dew': '물의 정령',
      'Spirit of Flame': '불의 정령',
      'Spirit of Wood': '나무의 정령',
      'Titania': '티타니아',
      'Puck': '요정의 권속',
      'Peaseblossom': '콩나무',
      'Mustardseed': '겨자씨'
    },
    'replaceText': {
      'Whispering Wind': '속삭이는 바람',
      'War And Pease': '큰콩 폭발',
      'Wallop': '매질',
      'Uplift': '융기',
      'Thunder Rune': '번개의 룬',
      'Pummel': '구타',
      'Puck\'s Rebuke': '요정의 꾸지람',
      'Puck\'s Caprice': '요정의 변덕',
      'Puck\'s Breath': '요정의 숨결',
      'Phantom Rune(?! )': '환상의 룬',
      'Phantom Rune In': '환상의 룬 안으로',
      'Phantom Rune Out': '환상의 룬 밖으로',
      'Peasebomb': '콩폭탄',
      '(?<! )Pease(?!\\w)': '콩 폭발',
      'Mist Rune': '물의 룬',
      'Midsummer Night\'s Dream': '한여름 밤의 꿈',
      'Love-In-Idleness': '삼색제비꽃',
      'Leafstorm': '잎사귀 폭풍',
      'Hard Swipe': '강력한 후려치기',
      'Growth Rune': '뿌리의 룬',
      'Gentle Breeze': '윗바람',
      'Frost Rune': '얼음의 룬',
      'Flame Rune': '불의 룬',
      'Flame Hammer': '불꽃 망치',
      'Fae Light': '요정광',
      'Divination Rune': '마법의 룬',
      'Chain Of Brambles': '나무딸기 사슬',
      'Bright Sabbath': '빛나는 안식',
      'Being Mortal': '죽어야 할 운명',
      ' Middle': ' (중앙)'
    }
  }]
};
/* harmony default export */ const titania_ex = (titania_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/titania-ex.txt
const trial_titania_ex_namespaceObject = "### Titania Ex\r\n# -ii 429E 3D2F 468B 468A 3D49 3D39 3D42 3D43 -p 3D4B:12 3D3D:500 3D32:800 3DAE:1510\r\n# https://thebalanceffxiv.com/guide/titania/\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1: single mechanics\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n8.0 \"--sync--\" StartsUsing { id: \"3D4B\", source: \"Titania\" } window 20,20\r\n12.0 \"Bright Sabbath\" Ability { id: \"3D4B\", source: \"Titania\" }\r\n26.0 \"Phantom Rune Out\" Ability { id: \"3D4C\", source: \"Titania\" }\r\n37.0 \"Mist Rune\" Ability { id: \"3D45\", source: \"Titania\" }\r\n55.5 \"Flame Rune\" Ability { id: \"3D47\", source: \"Titania\" }\r\n69.7 \"Flame Hammer 1\" #Ability { id: \"3D48\", source: \"Spirit of Flame\" }\r\n72.0 \"Flame Hammer 2\" #Ability { id: \"3D48\", source: \"Spirit of Flame\" }\r\n78.6 \"Divination Rune\" Ability { id: \"3D4A\", source: \"Titania\" }\r\n87.6 \"Chain Of Brambles\" Ability { id: \"42D7\", source: \"Titania\" }\r\n103.9 \"Phantom Rune In\" Ability { id: \"3D4D\", source: \"Titania\" }\r\n\r\n# Mini-phase skip here at least from Divination Rune to here\r\n110.9 \"--sync--\" StartsUsing { id: \"3D30\", source: \"Titania\" } window 200,10\r\n114.9 \"Midsummer Night's Dream\" Ability { id: \"3D30\", source: \"Titania\" }\r\n128.2 \"--center--\" Ability { id: \"3D28\", source: \"Titania\" }\r\n133.8 \"Thunder Rune 1\" Ability { id: \"3D29\", source: \"Titania\" } window 5,1\r\n139.3 \"Thunder Rune 2\" #Ability { id: \"3D29\", source: \"Titania\" }\r\n144.8 \"Thunder Rune 3\" #Ability { id: \"3D29\", source: \"Titania\" }\r\n150.3 \"Thunder Rune 4\" #Ability { id: \"3D29\", source: \"Titania\" }\r\n155.8 \"Thunder Rune 5\" #Ability { id: \"3D29\", source: \"Titania\" }\r\n161.4 \"Thunder Rune 6\" Ability { id: \"3F2A\", source: \"Titania\" } window 15,15\r\n172.4 \"Fae Light\" Ability { id: \"3D2C\", source: \"Titania\" }\r\n175.4 \"Fae Light 1\" #Ability { id: \"3D2D\", source: \"Titania\" }\r\n177.4 \"Fae Light 2\" #Ability { id: \"3D2D\", source: \"Titania\" }\r\n179.6 \"Fae Light 3\" #Ability { id: \"3D2D\", source: \"Titania\" }\r\n188.6 \"Growth Rune\" Ability { id: \"3D2E\", source: \"Titania\" }\r\n194.6 \"Chain Of Brambles\" Ability { id: \"42D7\", source: \"Titania\" }\r\n213.8 \"Divination Rune\" Ability { id: \"3D4A\", source: \"Titania\" }\r\n222.8 \"Frost Rune\" Ability { id: \"3D2A\", source: \"Titania\" }\r\n230.8 \"Frost Rune Middle\" #Ability { id: \"3D2B\", source: \"Titania\" }\r\n239.8 \"Uplift\" Ability { id: \"421E\", source: \"Titania\" }\r\n246.8 \"Phantom Rune In\" Ability { id: \"3D4D\", source: \"Titania\" }\r\n\r\n\r\n### Phase 2a: smol adds\r\n# Note: this can skip part of the prior phase with enough dps.\r\n256.4 \"--untargetable--\" Ability { id: \"3D31\", source: \"Titania\" } window 300,0\r\n258.8 \"--targetable--\"\r\n271.0 \"Leafstorm\" Ability { id: \"3D38\", source: \"Mustardseed\" }\r\n271.1 \"Gentle Breeze\" Ability { id: \"3F82\", source: \"Puck\" }\r\n273.4 \"Pease\" Ability { id: \"3D35\", source: \"Peaseblossom\" }\r\n273.4 \"Peasebomb\" Ability { id: \"3D34\", source: \"Peaseblossom\" }\r\n277.1 \"Leafstorm\" Ability { id: \"3D38\", source: \"Mustardseed\" }\r\n281.2 \"Pummel\" Ability { id: \"3D37\", source: \"Puck\" }\r\n284.4 \"Hard Swipe\" Ability { id: \"3D36\", source: \"Peaseblossom\" }\r\n293.2 \"Pummel\" Ability { id: \"3D37\", source: \"Puck\" }\r\n296.9 \"Pease\" Ability { id: \"3D35\", source: \"Peaseblossom\" }\r\n296.9 \"Peasebomb\" Ability { id: \"3D34\", source: \"Peaseblossom\" }\r\n307.9 \"Hard Swipe\" Ability { id: \"3D36\", source: \"Peaseblossom\" }\r\n### ???\r\n\r\n\r\n### Phase 2b: bigger is better\r\n500.0 \"Love-In-Idleness\" Ability { id: \"3D3D\", source: \"Titania\" } window 500,0\r\n518.2 \"--targetable--\"\r\n528.5 \"Leafstorm\" Ability { id: \"3D3E\", source: \"Mustardseed\" }\r\n529.0 \"War And Pease\" Ability { id: \"3D40\", source: \"Peaseblossom\" }\r\n529.0 \"Peasebomb\" Ability { id: \"3D3F\", source: \"Peaseblossom\" }\r\n536.0 \"Puck's Breath\" Ability { id: \"3D41\", source: \"Puck\" }\r\n545.0 \"Whispering Wind\" Ability { id: \"40E2\", source: \"Mustardseed\" }\r\n555.0 \"Puck's Rebuke\" Ability { id: \"3D44\", source: \"Puck\" }\r\n557.0 \"Wallop\" Ability { id: \"3D3B\", source: \"Spirit of Wood\" }\r\n559.5 \"Leafstorm\" Ability { id: \"3D3E\", source: \"Mustardseed\" }\r\n568.0 \"War And Pease\" Ability { id: \"3D40\", source: \"Peaseblossom\" }\r\n568.0 \"Puck's Breath\" Ability { id: \"3D41\", source: \"Puck\" }\r\n568.0 \"Peasebomb\" Ability { id: \"3D3F\", source: \"Peaseblossom\" }\r\n577.0 \"Puck's Caprice\" Ability { id: \"3D3A\", source: \"Puck\" }\r\n\r\n\r\n### Phase 3: double mechanics\r\n800.0 \"Being Mortal\" Ability { id: \"3D32\", source: \"Titania\" } window 800,0\r\n808.5 \"Being Mortal\" Ability { id: \"3D33\", source: \"Titania\" }\r\n814.0 \"--targetable--\"\r\n825.3 \"Mist Rune\" Ability { id: \"3D45\", source: \"Titania\" }\r\n833.3 \"Phantom Rune\" Ability { id: \"3D4[CD]\", source: \"Titania\" }\r\n846.3 \"Flame Rune\" Ability { id: \"3D47\", source: \"Titania\" }\r\n852.3 \"Growth Rune\" Ability { id: \"3D2E\", source: \"Titania\" }\r\n860.4 \"Flame Hammer 1\" #Ability { id: \"3D48\", source: \"Spirit of Flame\" }\r\n862.6 \"Flame Hammer 2\" #Ability { id: \"3D48\", source: \"Spirit of Flame\" }\r\n880.2 \"Phantom Rune\" Ability { id: \"3D4[CD]\", source: \"Titania\" }\r\n891.2 \"Bright Sabbath\" Ability { id: \"3D4B\", source: \"Titania\" }\r\n903.2 \"Fae Light\" Ability { id: \"3D2C\", source: \"Titania\" }\r\n906.2 \"Fae Light 1\" #Ability { id: \"3D2D\", source: \"Titania\" }\r\n908.2 \"Fae Light 2\" #Ability { id: \"3D2D\", source: \"Titania\" }\r\n910.2 \"Fae Light 3\" #Ability { id: \"3D2D\", source: \"Titania\" }\r\n919.2 \"Frost Rune\" Ability { id: \"3D2A\", source: \"Titania\" }\r\n927.2 \"Frost Rune Middle\" #Ability { id: \"3D2B\", source: \"Titania\" }\r\n934.2 \"Uplift\" Ability { id: \"421E\", source: \"Titania\" }\r\n942.2 \"Bright Sabbath\" Ability { id: \"3D4B\", source: \"Titania\" }\r\n950.6 \"--center--\" Ability { id: \"3D28\", source: \"Titania\" }\r\n956.2 \"Thunder Rune 1\" Ability { id: \"3D29\", source: \"Titania\" } window 5,1\r\n961.7 \"Thunder Rune 2\" #Ability { id: \"3D29\", source: \"Titania\" }\r\n967.2 \"Thunder Rune 3\" #Ability { id: \"3D29\", source: \"Titania\" }\r\n972.7 \"Thunder Rune 4\" #Ability { id: \"3D29\", source: \"Titania\" }\r\n978.2 \"Thunder Rune 5\" #Ability { id: \"3D29\", source: \"Titania\" }\r\n983.7 \"Thunder Rune 6\" Ability { id: \"3F2A\", source: \"Titania\" } window 15,15\r\n994.7 \"Growth Rune\" Ability { id: \"3D2E\", source: \"Titania\" }\r\n1000.7 \"Chain Of Brambles\" Ability { id: \"42D7\", source: \"Titania\" }\r\n1023.7 \"Phantom Rune\" Ability { id: \"3D4[CD]\", source: \"Titania\" }\r\n1031.7 \"Phantom Rune\" Ability { id: \"3D4[CD]\", source: \"Titania\" }\r\n1043.7 \"Bright Sabbath\" Ability { id: \"3D4B\", source: \"Titania\" }\r\n1050.7 \"Divination Rune\" Ability { id: \"3D4A\", source: \"Titania\" }\r\n1065.6 \"Mist Rune\" Ability { id: \"3D45\", source: \"Titania\" }\r\n# ???\r\n\r\n\r\n### Phase 4: too slow\r\n1500.0 \"--sync--\" StartsUsing { id: \"3DAE\", source: \"Titania\" } window 1500,0\r\n1510.0 \"Bright Sabbath Enrage\" Ability { id: \"3DAE\", source: \"Titania\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/titania.ts



// Titania Normal Mode
const titania_triggerSet = {
  id: 'TheDancingPlague',
  zoneId: zone_id/* default.TheDancingPlague */.Z.TheDancingPlague,
  timelineFile: 'titania.txt',
  triggers: [{
    id: 'Titania Bright Sabbath',
    type: 'StartsUsing',
    netRegex: {
      id: '3D5C',
      source: 'Titania',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Titania Phantom Out',
    type: 'StartsUsing',
    netRegex: {
      id: '3D5D',
      source: 'Titania',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Titania Phantom In',
    type: 'StartsUsing',
    netRegex: {
      id: '3D5E',
      source: 'Titania',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Titania Mist Failure',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Spirit Of Dew',
      capture: false
    },
    response: responses/* Responses.killExtraAdd */.n3.killExtraAdd()
  }, {
    id: 'Titania Mist',
    type: 'StartsUsing',
    netRegex: {
      id: '3D45',
      source: 'Titania',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Water Positions',
        de: 'Wasser Positionen',
        fr: 'Positions pour l\'eau',
        ja: 'ポジションへ',
        cn: '水毒',
        ko: '물 장판 위치'
      }
    }
  }, {
    id: 'Titania Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '3D47',
      source: 'Titania',
      capture: false
    },
    delaySeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack In Puddles',
        de: 'In einer Fläche sammeln',
        fr: 'Packez-vous dans les Flaques d\'eau',
        ja: '水の輪に集合',
        cn: '水圈集合',
        ko: '장판에 모이기'
      }
    }
  }, {
    id: 'Titania Divination',
    type: 'StartsUsing',
    netRegex: {
      id: '3D5B',
      source: 'Titania'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Titania Frost Rune 1',
    type: 'StartsUsing',
    netRegex: {
      id: '3D2A',
      source: 'Titania',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Middle, Shiva Circles',
        de: 'In die Mitte, Shiva Kreise',
        fr: 'Allez au milieu, cercles de Shiva',
        ja: 'シヴァの輪っか',
        cn: '中间集合, 九连环',
        ko: '시바 얼음 장판'
      }
    }
  }, {
    id: 'Titania Frost Rune 2',
    type: 'StartsUsing',
    netRegex: {
      id: '3D2A',
      source: 'Titania',
      capture: false
    },
    delaySeconds: 6.5,
    response: responses/* Responses.getOut */.n3.getOut('info')
  }, {
    id: 'Titania Frost Rune 3',
    type: 'Ability',
    netRegex: {
      id: '3D4E',
      source: 'Titania',
      capture: false
    },
    suppressSeconds: 60,
    response: responses/* Responses.getIn */.n3.getIn('info')
  }, {
    id: 'Titania Growth Rune',
    type: 'StartsUsing',
    netRegex: {
      id: '3D2E',
      source: 'Titania',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Roots',
        de: 'Ranken vermeiden',
        fr: 'Évitez les Racines',
        ja: '根っこを避ける',
        cn: '躲避树根',
        ko: '뿌리 피하기'
      }
    }
  }, {
    id: 'Titania Uplift Markers',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Titania Peasebomb Markers',
    type: 'HeadMarker',
    netRegex: {
      id: '00BD'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Titania Pucks Breath Markers',
    type: 'HeadMarker',
    netRegex: {
      id: '00A1'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Titania Puck\'s Rebuke Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '3D59',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Titania Mini Add Phase',
    type: 'Ability',
    netRegex: {
      id: '3D31',
      source: 'Titania',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.role === 'tank' || data.job === 'BLU') return output.groupAddsEastOnMustardseed();
      return output.killMustardseedEast();
    },
    outputStrings: {
      groupAddsEastOnMustardseed: {
        en: 'Group Adds East (on Mustardseed)',
        de: 'Adds im Osten sammeln (bei Senfsamen)',
        fr: 'Groupe sur l\'Add Est (Pousse-de-moutarde)',
        ja: '東の雑魚 (マスタードシード)',
        cn: '东边小怪 (芥子)',
        ko: '쫄 모으기 (겨자씨 쪽)'
      },
      killMustardseedEast: {
        en: 'Kill Mustardseed (East)',
        de: 'Senfsamen angreifen (Osten)',
        fr: 'Tuez Pousse-de-moutarde (Est)',
        ja: '雑魚マスタードシードを倒す (東)',
        cn: '击杀芥子 (东)',
        ko: '겨자씨 잡기(동쪽)'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Titania': 'Titania',
      'Puck': 'Puck',
      'Spirit Of Dew': 'Wasserfee',
      'Spirit of Flame': 'Feuerfee',
      'Peaseblossom': 'Bohnenblüte',
      'Mustardseed': 'Senfsamen'
    },
    'replaceText': {
      'Being Mortal': 'Sterblichkeit',
      'Bright Sabbath': 'Leuchtender Sabbat',
      'Divination Rune': 'Prophezeiungsrune',
      'Flame Hammer': 'Flammenhammer',
      'Flame Rune': 'Flammenrune',
      'Frost Rune(?! )': 'Frostrune',
      'Frost Rune Middle': 'Frostrune Mitte',
      'Gentle Breeze': 'Sanfte Brise',
      'Growth Rune': 'Wachstumsrune',
      'Hard Swipe': 'Harter Hieb',
      'Leafstorm': 'Blättersturm',
      'Love-In-Idleness': 'Liebevoller Müßiggang',
      'Midsummer Night\'s Dream': 'Mittsommernachtstraum',
      'Mist Rune': 'Nebelrune',
      '(?<! )Pease(?!\\w)': 'Bohne',
      'Peasebomb': 'Bohnenbombe',
      'Phantom Rune': 'Phantomrune',
      'Puck\'s Breath': 'Pucks Atem',
      'Puck\'s Caprice': 'Pucks Laune',
      'Puck\'s Rebuke': 'Pucks Tadel',
      'Pummel': 'Deftige Dachtel',
      'Uplift': 'Feenring',
      'War And Pease': 'Böhnchen und Tönchen'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Titania': 'Titania',
      'Puck': 'Puck',
      'Spirit Of Dew': 'Esprit Des Rosées',
      'Spirit of Flame': 'Esprit Des Flammes',
      'Peaseblossom': 'Fleur-de-pois',
      'Mustardseed': 'Pousse-de-moutarde'
    },
    'replaceText': {
      'Being Mortal': 'Deuil des vivants',
      'Bright Sabbath': 'Sabbat en plein jour',
      'Divination Rune': 'Rune de malice',
      'Flame Hammer': 'Marteau de feu',
      'Flame Rune': 'Rune de feu',
      'Frost Rune(?! )': 'Rune de gel',
      'Frost Rune Middle': 'Rune de gel milieu',
      'Gentle Breeze': 'Douce Brise',
      'Growth Rune': 'Rune de racine',
      'Hard Swipe': 'Fauchage brutal',
      'Leafstorm': 'Tempête de feuilles',
      'Love-In-Idleness': 'Pensées sauvages',
      'Midsummer Night\'s Dream': 'Songe d\'une nuit d\'été',
      'Mist Rune': 'Rune d\'eau',
      '(?<! )Pease(?!\\w)': 'Explosion de haricot',
      'Peasebomb': 'Haricot explosif',
      'Phantom Rune': 'Rune d\'illusion',
      'Puck\'s Breath': 'Haleine de Puck',
      'Puck\'s Caprice': 'Toquade de Puck',
      'Puck\'s Rebuke': 'Réprimande de Puck',
      'Pummel': 'Torgnole',
      'Uplift': 'Exhaussement',
      'War And Pease': 'La fin des haricots'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Titania': 'ティターニア',
      'Puck': 'パック',
      'Spirit Of Dew': '水の精',
      'Spirit of Flame': '火の精',
      'Peaseblossom': 'ピーズブロッサム',
      'Mustardseed': 'マスタードシード'
    },
    'replaceText': {
      'Being Mortal': '死すべき定め',
      'Bright Sabbath': 'ブライトサバト',
      'Divination Rune': '魔のルーン',
      'Flame Hammer': 'フレイムハンマー',
      'Flame Rune': '火のルーン',
      'Frost Rune(?! )': '氷のルーン',
      'Frost Rune Middle': '氷のルーン（中央）',
      'Gentle Breeze': '上風',
      'Growth Rune': '根のルーン',
      'Hard Swipe': 'ハードスワイプ',
      'Leafstorm': 'リーフストーム',
      'Love-In-Idleness': 'ラブ・イン・アイドルネス',
      'Midsummer Night\'s Dream': 'ミッドサマー・ナイツドリーム',
      'Mist Rune': '水のルーン',
      '(?<! )Pease(?!\\w)': '豆爆発',
      'Peasebomb': 'ビーズボム',
      'Phantom Rune': '幻のルーン',
      'Puck\'s Breath': 'パック・ブレス',
      'Puck\'s Caprice': 'パック・カプリース',
      'Puck\'s Rebuke': 'パックレビューク',
      'Pummel': '殴打',
      'Uplift': '隆起',
      'War And Pease': '大豆爆発'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Titania': '缇坦妮雅',
      'Puck': '帕克',
      'Spirit Of Dew': '水精',
      'Spirit of Flame': '炎精',
      'Peaseblossom': '豌豆花',
      'Mustardseed': '芥子'
    },
    'replaceText': {
      'Being Mortal': '终有一死',
      'Bright Sabbath': '欢快的安息日',
      'Divination Rune': '魔之符文',
      'Flame Hammer': '烈火锤',
      'Flame Rune': '火之符文',
      'Frost Rune(?! )': '冰之符文(?! )',
      'Frost Rune Middle': '冰之符文 中间',
      'Gentle Breeze': '青翠柔风',
      'Growth Rune': '根之符文',
      'Hard Swipe': '强烈重击',
      'Leafstorm': '绿叶风暴',
      'Love-In-Idleness': '爱懒花',
      'Midsummer Night\'s Dream': '仲夏夜之梦',
      'Mist Rune': '水之符文',
      '(?<! )Pease(?!\\w)': '(?<! )爆炸(?!\\w)',
      'Peasebomb': '豌豆炸弹',
      'Phantom Rune': '幻之符文',
      'Puck\'s Breath': '帕克的吐息',
      'Puck\'s Caprice': '帕克的随想',
      'Puck\'s Rebuke': '帕克的指责',
      'Pummel': '殴打',
      'Uplift': '隆起',
      'War And Pease': '豌豆大爆炸'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Titania': '티타니아',
      'Puck': '요정의 권속',
      'Spirit Of Dew': '물의 정령',
      'Spirit of Flame': '불의 정령',
      'Peaseblossom': '콩나무',
      'Mustardseed': '겨자씨'
    },
    'replaceText': {
      'Being Mortal': '죽어야 할 운명',
      'Bright Sabbath': '빛나는 안식',
      'Divination Rune': '마법의 룬',
      'Flame Hammer': '불꽃 망치',
      'Flame Rune': '불의 룬',
      'Frost Rune(?! )': '얼음의 룬',
      'Frost Rune Middle': '얼음의 룬 가운데',
      'Gentle Breeze': '윗바람',
      'Growth Rune': '뿌리의 룬',
      'Hard Swipe': '강력한 후려치기',
      'Leafstorm': '잎사귀 폭풍',
      'Love-In-Idleness': '삼색제비꽃',
      'Midsummer Night\'s Dream': '한여름 밤의 꿈',
      'Mist Rune': '물의 룬',
      '(?<! )Pease(?!\\w)': '콩 폭발',
      'Peasebomb': '콩폭탄',
      'Phantom Rune': '환상의 룬',
      'Puck\'s Breath': '요정의 숨결',
      'Puck\'s Caprice': '요정의 변덕',
      'Puck\'s Rebuke': '요정의 꾸지람',
      'Pummel': '구타',
      'Uplift': '융기',
      'War And Pease': '큰콩 폭발'
    }
  }]
};
/* harmony default export */ const titania = (titania_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/titania.txt
const trial_titania_namespaceObject = "### Titania Ex\r\n# -ii 468A 468B 3D50 3D55 3E03 3D58 -p 3D32:800 3D3D:500\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n8.5 \"--sync--\" StartsUsing { id: \"3D5C\", source: \"Titania\" } window 13,5\r\n12.5 \"Bright Sabbath\" Ability { id: \"3D5C\", source: \"Titania\" }\r\n26.7 \"Phantom Rune\" Ability { id: \"3D5[DE]\", source: \"Titania\" }\r\n37.9 \"Divination Rune\" Ability { id: \"3D5B\", source: \"Titania\" }\r\n47.1 \"Mist Rune\" Ability { id: \"3D45\", source: \"Titania\" }\r\n67.3 \"Flame Rune\" Ability { id: \"3D47\", source: \"Titania\" }\r\n81.4 \"Flame Hammer\" Ability { id: \"4373\", source: \"Spirit of Flame\" }\r\n91.4 \"Phantom Rune\" Ability { id: \"3D5[DE]\", source: \"Titania\" }\r\n\r\n103.7 \"Midsummer Night's Dream\" Ability { id: \"3D30\", source: \"Titania\" } window 150,0\r\n116.8 \"Growth Rune\" Ability { id: \"3D2E\", source: \"Titania\" }\r\n144.0 \"Phantom Rune\" Ability { id: \"3D5[DE]\", source: \"Titania\" }\r\n151.1 \"Bright Sabbath\" Ability { id: \"3D5C\", source: \"Titania\" }\r\n161.4 \"Frost Rune\" Ability { id: \"3D2A\", source: \"Titania\" }\r\n170.4 \"Frost Rune Middle\" #Ability { id: \"3D4E\", source: \"Titania\" }\r\n176.7 \"Uplift\" Ability { id: \"421F\", source: \"Titania\" }\r\n182.8 \"Phantom Rune\" Ability { id: \"3D5[DE]\", source: \"Titania\" }\r\n\r\n### Phase 2a\r\n193.5 \"--untargetable--\" Ability { id: \"3D31\", source: \"Titania\" } window 200,0\r\n196.0 \"--targetable--\"\r\n208.5 \"Gentle Breeze\" Ability { id: \"3F83\", source: \"Puck\" }\r\n208.5 \"Leafstorm\" Ability { id: \"3D38\", source: \"Mustardseed\" }\r\n210.8 \"Peasebomb\" Ability { id: \"3D34\", source: \"Peaseblossom\" }\r\n210.8 \"Pease\" Ability { id: \"3D52\", source: \"Peaseblossom\" }\r\n219.7 \"Pummel\" Ability { id: \"3D54\", source: \"Puck\" }\r\n220.9 \"Leafstorm\" Ability { id: \"3D38\", source: \"Mustardseed\" }\r\n222.1 \"Hard Swipe\" Ability { id: \"3D53\", source: \"Peaseblossom\" }\r\n238.5 \"Gentle Breeze\" Ability { id: \"3F83\", source: \"Puck\" }\r\n238.6 \"Peasebomb\" Ability { id: \"3D34\", source: \"Peaseblossom\" }\r\n238.6 \"Pease\" Ability { id: \"3D52\", source: \"Peaseblossom\" }\r\n249.8 \"Pummel\" Ability { id: \"3D54\", source: \"Puck\" }\r\n250.7 \"Hard Swipe\" Ability { id: \"3D53\", source: \"Peaseblossom\" }\r\n\r\n### Phase 2b: bigger is better\r\n500.0 \"Love-In-Idleness\" Ability { id: \"3D3D\", source: \"Titania\" }\r\n518.1 \"--targetable--\"\r\n528.5 \"Leafstorm\" Ability { id: \"3D3E\", source: \"Mustardseed\" }\r\n529.0 \"Peasebomb\" Ability { id: \"3D3F\", source: \"Peaseblossom\" }\r\n529.0 \"War And Pease\" Ability { id: \"3DAD\", source: \"Peaseblossom\" }\r\n536.0 \"Puck's Breath\" Ability { id: \"3D57\", source: \"Puck\" }\r\n541.0 \"--sync--\" Ability { id: \"3D42\", source: \"Puck\" }\r\n546.0 \"Puck's Rebuke\" Ability { id: \"3D59\", source: \"Puck\" }\r\n\r\n551.5 \"Leafstorm\" Ability { id: \"3D3E\", source: \"Mustardseed\" }\r\n560.0 \"Peasebomb\" Ability { id: \"3D3F\", source: \"Peaseblossom\" }\r\n560.0 \"War And Pease\" Ability { id: \"3DAD\", source: \"Peaseblossom\" }\r\n567.0 \"Puck's Caprice\" Ability { id: \"3D56\", source: \"Puck\" }\r\n\r\n583.5 \"Leafstorm\" Ability { id: \"3D3E\", source: \"Mustardseed\" } window 15,15 jump 528.5\r\n584.0 \"Peasebomb\"\r\n584.0 \"War And Pease\"\r\n591.0 \"Puck's Breath\"\r\n596.0 \"--sync--\"\r\n601.0 \"Puck's Rebuke\"\r\n\r\n### Phase 3\r\n800.0 \"Being Mortal\" Ability { id: \"3D32\", source: \"Titania\" } window 800,0\r\n808.5 \"Being Mortal\" Ability { id: \"3D51\", source: \"Titania\" }\r\n814.0 \"--targetable--\"\r\n825.0 \"Mist Rune\" Ability { id: \"3D45\", source: \"Titania\" }\r\n833.0 \"Uplift\" Ability { id: \"421F\", source: \"Titania\" }\r\n\r\n838.3 \"Flame Rune\" Ability { id: \"3D47\", source: \"Titania\" }\r\n846.3 \"Phantom Rune\" Ability { id: \"3D5E\", source: \"Titania\" }\r\n852.4 \"Flame Hammer\" Ability { id: \"4373\", source: \"Spirit of Flame\" }\r\n856.3 \"Growth Rune\" Ability { id: \"3D2E\", source: \"Titania\" }\r\n864.3 \"Phantom Rune\" Ability { id: \"3D5D\", source: \"Titania\" }\r\n878.3 \"Divination Rune\" Ability { id: \"3D5B\", source: \"Titania\" }\r\n887.3 \"Frost Rune\" Ability { id: \"3D2A\", source: \"Titania\" }\r\n896.3 \"Frost Rune Middle\" #Ability { id: \"3D4E\", source: \"Titania\" }\r\n903.3 \"Bright Sabbath\" Ability { id: \"3D5C\", source: \"Titania\" }\r\n915.3 \"Phantom Rune\" Ability { id: \"3D5E\", source: \"Titania\" }\r\n923.3 \"Phantom Rune\" Ability { id: \"3D5D\", source: \"Titania\" }\r\n937.3 \"Divination Rune\" Ability { id: \"3D5B\", source: \"Titania\" }\r\n949.3 \"Bright Sabbath\" Ability { id: \"3D5C\", source: \"Titania\" }\r\n956.3 \"Bright Sabbath\" Ability { id: \"3D5C\", source: \"Titania\" }\r\n970.3 \"Mist Rune\" Ability { id: \"3D45\", source: \"Titania\" }\r\n978.3 \"Uplift\" Ability { id: \"421F\", source: \"Titania\" }\r\n\r\n985.3 \"Flame Rune\" Ability { id: \"3D47\", source: \"Titania\" } window 100,100 jump 838.3\r\n993.3 \"Phantom Rune\"\r\n999.4 \"Flame Hammer\"\r\n1003.3 \"Growth Rune\"\r\n1011.3 \"Phantom Rune\"\r\n1025.3 \"Divination Rune\"\r\n1034.3 \"Frost Rune\"\r\n1043.3 \"Frost Rune Middle\"\r\n1050.3 \"Bright Sabbath\"\r\n1062.3 \"Phantom Rune\"\r\n1070.3 \"Phantom Rune\"\r\n1084.3 \"Divination Rune\"\r\n1096.3 \"Bright Sabbath\"\r\n1103.3 \"Bright Sabbath\"\r\n1117.3 \"Mist Rune\"\r\n1125.3 \"Uplift\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/varis-ex.ts



const varis_ex_triggerSet = {
  id: 'MemoriaMiseraExtreme',
  zoneId: zone_id/* default.MemoriaMiseraExtreme */.Z.MemoriaMiseraExtreme,
  timelineFile: 'varis-ex.txt',
  timelineTriggers: [{
    id: 'VarisEx Ignis Est',
    // 4CB5: Varis starts using
    // 4CB6, 4CC5: Ignis Est starts using
    regex: /^Ignis Est$/,
    // Many alerts are 5 seconds ahead (stack, knockback), so differentiate.
    beforeSeconds: 7,
    durationSeconds: 7,
    // In and Out both use severity info here so that it doesn't conflict with the
    // spread/knockback/stack alert callouts.  These are always static, so it isn't
    // as important to differentiate with noise.
    //
    // Also, these are timeline triggers because there is a varying time between when
    // the initial cast (by Varis) happens and when other things happen.
    // Making them timeline triggers interleaves callouts a little bit more nicely
    // without having to hardcode a lot of delays.
    //
    // Also, 7 seconds interleaves properly where the order of callouts is the order
    // of things happening, i.e. "out => knockback", in first phase.
    response: responses/* Responses.getOut */.n3.getOut('info')
  }, {
    id: 'VarisEx Ventus Est',
    // 4CC6: Varis starts using
    // 4CC7, 4CC8: Ventus Est starts using
    regex: /^Ventus Est$/,
    beforeSeconds: 7,
    durationSeconds: 7,
    response: responses/* Responses.getIn */.n3.getIn('info')
  }, {
    id: 'VarisEx Festina Lente',
    // This is headMarker({id: '00A1'}), but is a timeline trigger both
    // for more warning, and to precede the "dodge clones" call.
    regex: /^Festina Lente$/,
    beforeSeconds: 6,
    durationSeconds: 6,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        dodgeClonesAndStack: {
          en: 'Dodge Clones + Stack',
          de: 'Klonen ausweichen und Sammeln',
          fr: 'Esquivez les Clones + packez-vous',
          ja: 'ターミナス・エストを避ける／頭割り集合',
          cn: '躲避剑气 + 集合分摊',
          ko: '분신 피하기 + 집합'
        },
        stackMarker: outputs/* default.stackMarker */.Z.stackMarker
      };

      // In any case where you need to position stacks in the right lane,
      // use this special call, no matter how far ahead in time it is.
      if (data.clonesActive) {
        // Sometimes in the fight, dodge clones + stack happen right next to each other.
        // In these cases, don't also call out "dodge clones", by setting this variable.
        // For cases where they are far apart, this gets cleared in the cleanup trigger.
        data.suppressDodgeCloneCall = true;
        return {
          alertText: output.dodgeClonesAndStack()
        };
      }
      return {
        alertText: output.stackMarker()
      };
    }
  }, {
    id: 'VarisEx Magitek Burst',
    regex: /^Magitek Burst$/,
    beforeSeconds: 15,
    durationSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread Soon',
        de: 'Bald verteilen',
        fr: 'Dispersez-vous bientôt',
        ja: 'まもなく散開',
        cn: '即将散开',
        ko: '잠시후 산개'
      }
    }
  }],
  triggers: [{
    id: 'VarisEx Phase 2',
    type: 'Ability',
    // 4CCC: Vivere Militare Est
    netRegex: {
      source: 'Varis Yae Galvus',
      id: '4CCC',
      capture: false
    },
    run: data => data.phase = 2
  }, {
    id: 'VarisEx Phase 5',
    type: 'Ability',
    netRegex: {
      source: 'Varis Yae Galvus',
      id: '4CE2',
      capture: false
    },
    run: data => data.phase = 5
  }, {
    id: 'VarisEx Clones',
    type: 'Ability',
    netRegex: {
      source: 'Phantom Varis',
      id: '4CB3',
      capture: false
    },
    run: data => data.clonesActive = true
  }, {
    id: 'VarisEx Altius',
    type: 'StartsUsing',
    netRegex: {
      source: 'Varis Yae Galvus',
      id: '4CCA',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Slashes',
        de: 'Schnitte ködern',
        fr: 'Attirez les taillades',
        ja: '縦へ、アルティウスを誘導',
        cn: 'Boss身后诱导剑气方向',
        ko: '슬래시 유도'
      }
    }
  }, {
    id: 'VarisEx Citius',
    type: 'StartsUsing',
    netRegex: {
      source: 'Varis Yae Galvus',
      id: '4CF0'
    },
    alertText: (data, matches, output) => {
      const target = matches.target;
      if (data.me === target) return output.tankBusterOnYou();
      if (data.role === 'dps' && data.job !== 'BLU') return output.avoidTankCleave();
      return output.tankBusterOn({
        player: data.party.member(target)
      });
    },
    outputStrings: {
      tankBusterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
      avoidTankCleave: outputs/* default.avoidTankCleave */.Z.avoidTankCleave,
      tankBusterOn: outputs/* default.tankBusterOnPlayer */.Z.tankBusterOnPlayer
    }
  }, {
    id: 'VarisEx Alea Iacta Est',
    type: 'StartsUsing',
    netRegex: {
      source: 'Varis Yae Galvus',
      id: '4CD2',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    // This trigger match the fourth Alea Iacta Est that Varis used.
    // The player should go front to avoid the fifth one, which hits back.
    id: 'VarisEx Alea Iacta Est Front',
    type: 'Ability',
    netRegex: {
      source: 'Varis Yae Galvus',
      id: '4CD5',
      capture: false
    },
    // Multiple people getting hit by this can cause double triggers.
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Front',
        de: 'Nach Vorne gehen',
        fr: 'Allez devant',
        ja: '前へ',
        cn: '到正面',
        ko: '앞으로'
      }
    }
  }, {
    id: 'VarisEx Electrified Gunshield',
    type: 'Ability',
    netRegex: {
      source: 'Varis Yae Galvus',
      id: '4CD7',
      capture: false
    },
    delaySeconds: 21.5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'VarisEx Reinforced Gunshield',
    type: 'Ability',
    netRegex: {
      source: 'Varis Yae Galvus',
      id: '4CD9',
      capture: false
    },
    delaySeconds: data => data.phase === 2 ? 20 : 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stop attacking',
        de: 'Angriffe stoppen',
        fr: 'Arrêtez d\'attaquer',
        ja: 'ブロックしない側に攻撃',
        cn: '攻击未格挡的方向',
        ko: '공격 중지'
      }
    }
  }, {
    id: 'VarisEx Reinforced Gunshield Sides',
    type: 'Ability',
    netRegex: {
      source: 'Varis Yae Galvus',
      id: '4CDC',
      capture: false
    },
    response: responses/* Responses.goFrontBack */.n3.goFrontBack('info')
  }, {
    id: 'VarisEx Reinforced Gunshield Front',
    type: 'Ability',
    netRegex: {
      source: 'Varis Yae Galvus',
      id: '4CDB',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides('info')
  }, {
    id: 'VarisEx Loaded Gunshield Final Warning',
    type: 'Ability',
    // This ability id occurs ~3 seconds before the Magitek Burst spread damage.
    netRegex: {
      source: 'Varis Yae Galvus',
      id: '4CDE',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        text: outputs/* default.spread */.Z.spread
      };
      // This is easily forgetable after dodging and seems to get people killed.
      // This also differentiates spread from the spread => stack in the last phase.
      return {
        [data.phase === 5 ? 'alarmText' : 'alertText']: output.text()
      };
    }
  }, {
    id: 'VarisEx Reinforcements',
    type: 'Ability',
    netRegex: {
      source: 'Varis Yae Galvus',
      id: '4CEA',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.role === 'tank') return output.grabTethers();
      return output.killAdds();
    },
    outputStrings: {
      grabTethers: {
        en: 'Grab Tethers',
        de: 'Verbindung nehmen',
        fr: 'Prenez les liens',
        ja: '線を取る',
        cn: '接线',
        ko: '선 가로채기'
      },
      killAdds: {
        en: 'Kill adds',
        de: 'Adds besiegen',
        fr: 'Tuez les adds',
        ja: '雑魚を処理',
        cn: '击杀小怪',
        ko: '쫄 잡기'
      }
    }
  }, {
    // The warning is taken care of above with a timeline trigger.  See notes.
    id: 'VarisEx Festina Lente Cleanup',
    type: 'Ability',
    netRegex: {
      source: 'Varis Yae Galvus',
      id: '4CC9',
      capture: false
    },
    delaySeconds: 10,
    run: data => delete data.suppressDodgeCloneCall
  }, {
    id: 'VarisEx Terminus Est Clones',
    type: 'StartsUsing',
    netRegex: {
      source: 'Terminus Est',
      id: '4CB4',
      capture: false
    },
    condition: data => data.clonesActive,
    infoText: (data, _matches, output) => {
      // Sometimes this is called out with the stack mechanic.
      if (data.suppressDodgeCloneCall) return;
      return output.text();
    },
    run: data => {
      delete data.suppressDodgeCloneCall;
      delete data.clonesActive;
    },
    outputStrings: {
      text: {
        en: 'Dodge Clones',
        de: 'Klonen ausweichen',
        fr: 'Esquivez les Clones',
        ja: 'ターミナス・エストを避ける',
        cn: '躲避剑气',
        ko: '클론 피하기'
      }
    }
  }, {
    id: 'VarisEx Magitek Torch',
    type: 'StartsUsing',
    netRegex: {
      source: 'Gunshield',
      id: '4E4F',
      capture: false
    },
    response: responses/* Responses.stackMarker */.n3.stackMarker('info')
  }, {
    id: 'VarisEx Magitek Spark',
    type: 'StartsUsing',
    netRegex: {
      source: 'Gunshield',
      id: '4E50',
      capture: false
    },
    // TODO: This is technicallly a spread, but it's more like "protean" spread?
    // Not sure how to make this more clear.
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'VarisEx Fortius',
    type: 'StartsUsing',
    netRegex: {
      source: 'Varis Yae Galvus',
      id: '4CE[56]',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Puddles Out',
        de: 'Flächen nach draußen ködern',
        fr: 'Attirez les zones au sol à l\'extérieur',
        ja: '外周に安置',
        cn: '外圈放黑泥',
        ko: '장판 바깥쪽으로 유도'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bladesblood': 'Bastardramme',
      'Gunshield': 'Gewehrschild',
      'Ignis Est': 'Ignis Est',
      'Magitek Turret II': 'Magitek-Geschütz II',
      'Phantom Varis': 'Varis-Doppelgänger',
      'Terminus Est': 'Terminus Est',
      'Varis Yae Galvus': 'Varis yae Galvus',
      'Ventus Est': 'Ventus Est'
    },
    'replaceText': {
      '--clones appear\\?--': '--klone erscheinen?--',
      'Aetherochemical Grenado': 'Magitek-Granate',
      'Alea Iacta Est': 'Alea Iacta Est',
      'Altius': 'Altius',
      'Blade\'s Pulse': 'Klingenpuls',
      'Citius': 'Citius',
      'Electrified Gunshield': 'Gewehrschild: Magitek-Schock',
      'Festina Lente': 'Festina Lente',
      'Fortius': 'Fortius',
      '(?<! )Gunshield': 'Gewehrschild',
      'Ignis Est': 'Ignis Est',
      'Loaded Gunshield': 'Gewehrschild: Magitek-Knall',
      'Magitek Burst': 'Magitek-Knall',
      'Magitek Shielding': 'Magitek-Konter',
      'Magitek Shock': 'Magitek-Schock',
      'Magitek Spark/Torch': 'Magitek-Funke/Flamme ',
      'Magitek Torch/Spark': 'Magitek Flamme/Funke',
      'Reinforced Gunshield': 'Gewehrschild: Magitek-Konter',
      'Reinforcements': 'Unterstützungsbefehl',
      'Shockwave': 'Schockwelle',
      'Terminus Est': 'Terminus Est',
      'Ventus Est': 'Ventus Est',
      'Vivere Militare Est': 'Vivere Militare Est'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bladesblood': 'Onde De Choc',
      'Gunshield': 'Bouclier-Canon',
      'Ignis Est': 'Ignis Est',
      'Magitek Turret II': 'Tourelle Magitek TM-II',
      'Phantom Varis': 'Double De Varis',
      'Terminus Est': 'Terminus Est',
      'Varis Yae Galvus': 'Varis yae Galvus',
      'Ventus Est': 'Ventus Est'
    },
    'replaceText': {
      '(?<! )\\?(?!--)': ' ?',
      '--clones appear\\?--': 'apparition des clones ?',
      'Aetherochemical Grenado': 'Grenade Magitek',
      'Alea Iacta Est': 'Alea Jacta Est',
      'Altius': 'Altius',
      'Blade\'s Pulse': 'Duel d\'armes',
      'Citius': 'Citius',
      'Electrified Gunshield': 'Bouclier-canon : Choc magitek',
      'Ignis Est': 'Ignis Est',
      'Festina Lente': 'Festina Lente',
      'Fortius': 'Fortius',
      '(?<! )Gunshield': 'bouclier-canon',
      'Loaded Gunshield': 'Bouclier-canon : Explosion magitek',
      'Magitek Burst': 'Explosion magitek',
      'Magitek Shielding': 'Contre magitek',
      'Magitek Shock': 'Choc magitek',
      'Magitek Spark/Torch': 'Étincelle/Flammes magitek',
      'Magitek Torch/Spark': 'Flammes/Étincelle magitek',
      'Reinforcements': 'Demande de renforts',
      'Reinforced Gunshield': 'Bouclier-canon : Contre magitek',
      'Shockwave': 'Onde de choc',
      'Terminus Est': 'Terminus Est',
      'Ventus Est': 'Ventus Est',
      'Vivere Militare Est': 'Vivere Militare Est'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bladesblood': '剣気',
      'Gunshield': 'ガンシールド',
      'Ignis Est': 'イグニス・エスト',
      'Magitek Turret II': '魔導タレットII',
      'Phantom Varis': 'ヴァリスの幻影',
      'Terminus Est': 'ターミナス・エスト',
      'Varis Yae Galvus': 'ヴァリス・イェー・ガルヴァス',
      'Ventus Est': 'ウェントゥス・エスト'
    },
    'replaceText': {
      '--clones appear\\?--': '--幻影出現?--',
      'Aetherochemical Grenado': '魔導榴弾',
      'Alea Iacta Est': 'アーレア・ヤクタ・エスト',
      'Altius': 'アルティウス',
      'Blade\'s Pulse': '攻撃を受け止める',
      'Citius': 'キティウス',
      'Electrified Gunshield': 'ガンシールド：魔導ショック',
      'Festina Lente': 'フェスティナ・レンテ',
      'Fortius': 'フォルティウス',
      '(?<! )Gunshield': 'ガンシールド',
      'Ignis Est': 'イグニス・エスト',
      'Loaded Gunshield': 'ガンシールド：魔導バースト',
      'Magitek Burst': '魔導バースト',
      'Magitek Shielding': '魔導カウンター',
      'Magitek Shock': '魔導ショック',
      'Magitek Spark/Torch': '魔導スパーク／魔導フレーム',
      'Magitek Torch/Spark': '魔導フレーム／魔導スパーク',
      'Reinforced Gunshield': 'ガンシールド：魔導カウンター',
      'Reinforcements': '支援命令',
      'Shockwave': '衝撃波',
      'Terminus Est': 'ターミナス・エスト',
      'Ventus Est': 'ウェントゥス・エスト',
      'Vivere Militare Est': 'ウィーウェレ・ミーリターレ・エスト'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bladesblood': '剑气',
      'Gunshield': '枪盾',
      'Ignis Est': '是为烈火',
      'Magitek Turret II': '魔导炮塔II',
      'Phantom Varis': '瓦厉斯的幻影',
      'Terminus Est': '恩惠终结',
      'Varis Yae Galvus': '瓦厉斯·耶·加尔乌斯',
      'Ventus Est': '是为疾风'
    },
    'replaceText': {
      '--clones appear\\?--': '--幻影出现?--',
      'Aetherochemical Grenado': '魔导榴弹',
      'Alea Iacta Est': '大局已定',
      'Altius': '更高',
      'Blade\'s Pulse': '双T接刀',
      'Citius': '更快',
      'Electrified Gunshield': '枪盾：魔导冲击',
      'Festina Lente': '从容不迫',
      'Fortius': '更强',
      '(?<! )Gunshield': '枪盾',
      'Ignis Est': '是为烈火',
      'Loaded Gunshield': '枪盾：魔导爆发',
      'Magitek Burst': '魔导爆发',
      'Magitek Shielding': '魔导反击',
      'Magitek Shock': '魔导冲击',
      'Magitek Spark/Torch': '魔导光刃／魔导火焰',
      'Magitek Torch/Spark': '魔导火焰／魔导光刃',
      'Reinforced Gunshield': '枪盾：魔导反击',
      'Reinforcements': '支援命令',
      'Shockwave': '冲击波',
      'Terminus Est': '恩惠终结',
      'Ventus Est': '是为疾风',
      'Vivere Militare Est': '生者战也'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bladesblood': '검기',
      'Gunshield': '건실드',
      'Ignis Est': '파멸의 화염',
      'Magitek Turret II': '마도 포탑 II',
      'Phantom Varis': '바리스의 환영',
      'Terminus Est': '파멸의 종착역',
      'Varis Yae Galvus': '바리스 예 갈부스',
      'Ventus Est': '파멸의 바람'
    },
    'replaceText': {
      '--clones appear\\?--': '--분신 생성?--',
      'Aetherochemical Grenado': '마도 유탄',
      'Alea Iacta Est': '알레아 이악타 에스트',
      'Altius': '알티우스',
      'Blade\'s Pulse': '공격 막아내기',
      'Citius': '키티우스',
      'Electrified Gunshield': '건실드: 마도 쇼크',
      'Festina Lente': '페스티나 렌테',
      'Fortius': '포르티우스',
      '(?<! )Gunshield': '건실드',
      'Ignis Est': '파멸의 화염',
      'Loaded Gunshield': '건실드: 마도 버스트',
      'Magitek Burst': '마도 버스트',
      'Magitek Shielding': '마도 카운터',
      'Magitek Shock': '마도 쇼크',
      'Magitek Spark/Torch': '마도 스파크/플레임',
      'Magitek Torch/Spark': '마도 플레임/스파크',
      'Reinforced Gunshield': '건실드: 마도 카운터',
      'Reinforcements': '지원 명령',
      'Shockwave': '충격 파동',
      'Terminus Est': '파멸의 종착역',
      'Ventus Est': '파멸의 바람',
      'Vivere Militare Est': '위웨레 밀리타레 에스트'
    }
  }]
};
/* harmony default export */ const varis_ex = (varis_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/varis-ex.txt
const trial_varis_ex_namespaceObject = "# Memoria Misera Extreme\r\n# -p 4CCA:19 4CCC:177.1 4CCF:260.1 4CE0:1200 4CE2:1300\r\n# -ii 4CF1 4CDD 4CEE 4CEF 4CC5 4CCE 4E88 4E8B 4CC8 4CE8 4CE9\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n### Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n19.0 \"Altius\" Ability { id: \"4CCA\", source: \"Varis Yae Galvus\" } window 19,5\r\n28.5 \"Alea Iacta Est\" Ability { id: \"4CD2\", source: \"Varis Yae Galvus\" }\r\n29.7 \"--sync--\" Ability { id: \"4CD3\", source: \"Varis Yae Galvus\" }\r\n30.1 \"--sync--\" Ability { id: \"4CD4\", source: \"Varis Yae Galvus\" }\r\n30.5 \"--sync--\" Ability { id: \"4CD5\", source: \"Varis Yae Galvus\" }\r\n33.2 \"--sync--\" Ability { id: \"4CD6\", source: \"Varis Yae Galvus\" }\r\n34.1 \"Terminus Est\" Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n45.1 \"Citius\" Ability { id: \"4CF0\", source: \"Varis Yae Galvus\" }\r\n56.0 \"--sync--\" Ability { id: \"4CB5\", source: \"Varis Yae Galvus\" }\r\n64.2 \"Ignis Est\" Ability { id: \"4CB6\", source: \"Ignis Est\" }\r\n64.2 \"Festina Lente\" Ability { id: \"4CC9\", source: \"Varis Yae Galvus\" }\r\n82.4 \"Electrified Gunshield\" Ability { id: \"4CD7\", source: \"Varis Yae Galvus\" }\r\n91.5 \"Altius\" Ability { id: \"4CCA\", source: \"Varis Yae Galvus\" }\r\n100.4 \"--sync--\" Ability { id: \"4CB5\", source: \"Varis Yae Galvus\" }\r\n101.6 \"Terminus Est\" Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n108.5 \"Ignis Est\" Ability { id: \"4CB6\", source: \"Ignis Est\" }\r\n109.6 \"Magitek Shock\" Ability { id: \"4CDA\", source: \"Varis Yae Galvus\" }\r\n120.7 \"Reinforced Gunshield\" Ability { id: \"4CD9\", source: \"Varis Yae Galvus\" }\r\n128.9 \"Citius\" Ability { id: \"4CF0\", source: \"Varis Yae Galvus\" }\r\n132.0 \"Magitek Shielding\" Ability { id: \"4CD[BC]\", source: \"Varis Yae Galvus\" }\r\n147.2 \"Loaded Gunshield\" Ability { id: \"4CD8\", source: \"Varis Yae Galvus\" }\r\n156.0 \"--sync--\" Ability { id: \"4CC6\", source: \"Varis Yae Galvus\" }\r\n163.6 \"--sync--\" Ability { id: \"4CDE\", source: \"Varis Yae Galvus\" }\r\n164.2 \"Ventus Est\" Ability { id: \"4CC7\", source: \"Ventus Est\" }\r\n166.7 \"Magitek Burst\" Ability { id: \"4CDF\", source: \"Varis Yae Galvus\" }\r\n177.1 \"--untargetable--\"\r\n\r\n\r\n### Phase 2: Susano Remix\r\n177.1 \"Vivere Militare Est\" Ability { id: \"4CCC\", source: \"Varis Yae Galvus\" } window 180,50\r\n192.3 \"Blade's Pulse x2\"\r\n200.1 \"--targetable--\"\r\n203.1 \"Shockwave\" #Ability { id: \"4CCE\", source: \"Bladesblood\" }\r\n# shockwaves continue every 2 seconds\r\n260.1 \"Vivere Militare Est\" Ability { id: \"4CCF\", source: \"Bladesblood\" } window 261,50\r\n\r\n\r\n### Phase 3: Random Groups\r\n# Note: all three of these blocks occur, but can occur in any order\r\n269.1 \"--targetable--\"\r\n274.3 \"--sync--\" StartsUsing { id: \"4CD8\", source: \"Varis Yae Galvus\" } window 100,100 jump 500\r\n274.3 \"--sync--\" StartsUsing { id: \"4CD9\", source: \"Varis Yae Galvus\" } window 100,100 jump 700\r\n274.3 \"--sync--\" StartsUsing { id: \"4CD7\", source: \"Varis Yae Galvus\" } window 100,100 jump 900\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# loaded lookahead window\r\n279.3 \"Loaded Gunshield?\" #Ability { id: \"4CD8\", source: \"Varis Yae Galvus\" }\r\n288.2 \"--sync--\" #Ability { id: \"4CB5\", source: \"Varis Yae Galvus\" }\r\n292.5 \"--sync--\" #Ability { id: \"4CDE\", source: \"Varis Yae Galvus\" }\r\n294.0 \"--clones appear?--\" #Ability { id: \"4CB3\", source: \"Phantom Varis\" }\r\n295.6 \"Magitek Burst?\" #Ability { id: \"4CDF\", source: \"Varis Yae Galvus\" }\r\n296.3 \"Ignis Est?\" #Ability { id: \"4CB6\", source: \"Ignis Est\" }\r\n303.6 \"Terminus Est?\" #Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n303.8 \"Festina Lente?\" #Ability { id: \"4CC9\", source: \"Varis Yae Galvus\" }\r\n315.0 \"Citius?\" #Ability { id: \"4CF0\", source: \"Varis Yae Galvus\" }\r\n\r\n# reinforced lookahead window\r\n279.3 \"Reinforced Gunshield?\" #Ability { id: \"4CD9\", source: \"Varis Yae Galvus\" }\r\n288.4 \"Altius?\" #Ability { id: \"4CCA\", source: \"Varis Yae Galvus\" }\r\n297.3 \"--sync--\" #Ability { id: \"4CC6\", source: \"Varis Yae Galvus\" }\r\n298.5 \"Terminus Est\" #Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n300.6 \"Magitek Shielding\" #Ability { id: \"4CDB\", source: \"Varis Yae Galvus\" }\r\n305.4 \"Ventus Est\" #Ability { id: \"4CC7\", source: \"Ventus Est\" }\r\n315.8 \"Citius\" #Ability { id: \"4CF0\", source: \"Varis Yae Galvus\" }\r\n\r\n# electrified lookahead window\r\n279.3 \"Electrified Gunshield?\" #Ability { id: \"4CD7\", source: \"Varis Yae Galvus\" }\r\n284.4 \"Reinforcements?\" #Ability { id: \"4CEA\", source: \"Varis Yae Galvus\" }\r\n290.3 \"--clones appear?--\" #Ability { id: \"4CB3\", source: \"Phantom Varis\" }\r\n293.5 \"Aetherochemical Grenado?\" #Ability { id: \"4CED\", source: \"Magitek Turret II\" }\r\n303.2 \"Terminus Est?\" #Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n305.9 \"Magitek Shock?\" #Ability { id: \"4CDA\", source: \"Varis Yae Galvus\" }\r\n316.8 \"Alea Iacta Est?\" #Ability { id: \"4CD2\", source: \"Varis Yae Galvus\" }\r\n318.0 \"--sync--\" #Ability { id: \"4CD3\", source: \"Varis Yae Galvus\" }\r\n318.4 \"--sync--\" #Ability { id: \"4CD4\", source: \"Varis Yae Galvus\" }\r\n318.8 \"--sync--\" #Ability { id: \"4CD5\", source: \"Varis Yae Galvus\" }\r\n321.5 \"--sync--\" #Ability { id: \"4CD6\", source: \"Varis Yae Galvus\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n## Phase 3: Loaded Gunshield, Spread\r\n500.0 \"--sync--\" StartsUsing { id: \"4CD8\", source: \"Varis Yae Galvus\" }\r\n505.0 \"Loaded Gunshield\" Ability { id: \"4CD8\", source: \"Varis Yae Galvus\" }\r\n513.9 \"--sync--\" Ability { id: \"4CB5\", source: \"Varis Yae Galvus\" }\r\n518.2 \"--sync--\" Ability { id: \"4CDE\", source: \"Varis Yae Galvus\" }\r\n519.7 \"--clones appear--\" Ability { id: \"4CB3\", source: \"Phantom Varis\" }\r\n521.3 \"Magitek Burst\" Ability { id: \"4CDF\", source: \"Varis Yae Galvus\" }\r\n522.0 \"Ignis Est\" Ability { id: \"4CB6\", source: \"Ignis Est\" }\r\n529.3 \"Terminus Est\" Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n529.5 \"Festina Lente\" Ability { id: \"4CC9\", source: \"Varis Yae Galvus\" }\r\n540.7 \"Citius\" Ability { id: \"4CF0\", source: \"Varis Yae Galvus\" }\r\n\r\n554.3 \"--sync--\" StartsUsing { id: \"4CD9\", source: \"Varis Yae Galvus\" } window 10,10 jump 700\r\n554.3 \"--sync--\" StartsUsing { id: \"4CD7\", source: \"Varis Yae Galvus\" } window 10,10 jump 900\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# reinforced lookahead window\r\n559.3 \"Reinforced Gunshield?\" #Ability { id: \"4CD9\", source: \"Varis Yae Galvus\" }\r\n568.4 \"Altius?\" #Ability { id: \"4CCA\", source: \"Varis Yae Galvus\" }\r\n577.3 \"--sync--\" #Ability { id: \"4CC6\", source: \"Varis Yae Galvus\" }\r\n578.5 \"Terminus Est\" #Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n580.6 \"Magitek Shielding\" #Ability { id: \"4CDB\", source: \"Varis Yae Galvus\" }\r\n585.4 \"Ventus Est\" #Ability { id: \"4CC7\", source: \"Ventus Est\" }\r\n595.8 \"Citius\" #Ability { id: \"4CF0\", source: \"Varis Yae Galvus\" }\r\n\r\n# electrified lookahead window\r\n559.3 \"Electrified Gunshield?\" #Ability { id: \"4CD7\", source: \"Varis Yae Galvus\" }\r\n564.4 \"Reinforcements?\" #Ability { id: \"4CEA\", source: \"Varis Yae Galvus\" }\r\n570.3 \"--clones appear?--\" #Ability { id: \"4CB3\", source: \"Phantom Varis\" }\r\n573.5 \"Aetherochemical Grenado?\" #Ability { id: \"4CED\", source: \"Magitek Turret II\" }\r\n583.2 \"Terminus Est?\" #Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n585.9 \"Magitek Shock?\" #Ability { id: \"4CDA\", source: \"Varis Yae Galvus\" }\r\n596.8 \"Alea Iacta Est?\" #Ability { id: \"4CD2\", source: \"Varis Yae Galvus\" }\r\n598.0 \"--sync--\" #Ability { id: \"4CD3\", source: \"Varis Yae Galvus\" }\r\n598.4 \"--sync--\" #Ability { id: \"4CD4\", source: \"Varis Yae Galvus\" }\r\n598.8 \"--sync--\" #Ability { id: \"4CD5\", source: \"Varis Yae Galvus\" }\r\n601.5 \"--sync--\" #Ability { id: \"4CD6\", source: \"Varis Yae Galvus\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n\r\n## Phase 3: Reinforced Gunshield, Block\r\n700.0 \"--sync--\" StartsUsing { id: \"4CD9\", source: \"Varis Yae Galvus\" }\r\n705.0 \"Reinforced Gunshield\" Ability { id: \"4CD9\", source: \"Varis Yae Galvus\" }\r\n714.1 \"Altius\" Ability { id: \"4CCA\", source: \"Varis Yae Galvus\" }\r\n723.0 \"--sync--\" Ability { id: \"4CC6\", source: \"Varis Yae Galvus\" }\r\n724.2 \"Terminus Est\" Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n726.3 \"Magitek Shielding\" Ability { id: \"4CD[BC]\", source: \"Varis Yae Galvus\" }\r\n731.1 \"Ventus Est\" Ability { id: \"4CC7\", source: \"Ventus Est\" }\r\n741.5 \"Citius\" Ability { id: \"4CF0\", source: \"Varis Yae Galvus\" }\r\n\r\n752.8 \"--sync--\" StartsUsing { id: \"4CD8\", source: \"Varis Yae Galvus\" } window 10,10 jump 500\r\n752.8 \"--sync--\" StartsUsing { id: \"4CD7\", source: \"Varis Yae Galvus\" } window 10,10 jump 900\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# loaded lookahead window\r\n757.8 \"Loaded Gunshield?\" #Ability { id: \"4CD8\", source: \"Varis Yae Galvus\" }\r\n766.7 \"--sync--\" #Ability { id: \"4CB5\", source: \"Varis Yae Galvus\" }\r\n771.0 \"--sync--\" #Ability { id: \"4CDE\", source: \"Varis Yae Galvus\" }\r\n772.5 \"--clones appear?--\" #Ability { id: \"4CB3\", source: \"Phantom Varis\" }\r\n774.1 \"Magitek Burst?\" #Ability { id: \"4CDF\", source: \"Varis Yae Galvus\" }\r\n774.8 \"Ignis Est?\" #Ability { id: \"4CB6\", source: \"Ignis Est\" }\r\n782.1 \"Terminus Est?\" #Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n782.3 \"Festina Lente?\" #Ability { id: \"4CC9\", source: \"Varis Yae Galvus\" }\r\n793.5 \"Citius?\" #Ability { id: \"4CF0\", source: \"Varis Yae Galvus\" }\r\n\r\n# electrified lookahead window\r\n757.8 \"Electrified Gunshield?\" #Ability { id: \"4CD7\", source: \"Varis Yae Galvus\" }\r\n762.9 \"Reinforcements?\" #Ability { id: \"4CEA\", source: \"Varis Yae Galvus\" }\r\n768.8 \"--clones appear?--\" #Ability { id: \"4CB3\", source: \"Phantom Varis\" }\r\n772.0 \"Aetherochemical Grenado?\" #Ability { id: \"4CED\", source: \"Magitek Turret II\" }\r\n781.7 \"Terminus Est?\" #Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n784.4 \"Magitek Shock?\" #Ability { id: \"4CDA\", source: \"Varis Yae Galvus\" }\r\n795.3 \"Alea Iacta Est?\" #Ability { id: \"4CD2\", source: \"Varis Yae Galvus\" }\r\n796.5 \"--sync--\" #Ability { id: \"4CD3\", source: \"Varis Yae Galvus\" }\r\n796.9 \"--sync--\" #Ability { id: \"4CD4\", source: \"Varis Yae Galvus\" }\r\n797.3 \"--sync--\" #Ability { id: \"4CD5\", source: \"Varis Yae Galvus\" }\r\n800.0 \"--sync--\" #Ability { id: \"4CD6\", source: \"Varis Yae Galvus\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n\r\n## Phase 3: Electrified Gunshield, Knockback\r\n900.0 \"--sync--\" StartsUsing { id: \"4CD7\", source: \"Varis Yae Galvus\" }\r\n905.0 \"Electrified Gunshield\" Ability { id: \"4CD7\", source: \"Varis Yae Galvus\" }\r\n910.1 \"Reinforcements\" Ability { id: \"4CEA\", source: \"Varis Yae Galvus\" }\r\n916.0 \"--clones appear--\" Ability { id: \"4CB3\", source: \"Phantom Varis\" }\r\n919.2 \"Aetherochemical Grenado\" Ability { id: \"4CED\", source: \"Magitek Turret II\" }\r\n928.9 \"Terminus Est\" Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n931.6 \"Magitek Shock\" Ability { id: \"4CDA\", source: \"Varis Yae Galvus\" }\r\n942.5 \"Alea Iacta Est\" Ability { id: \"4CD2\", source: \"Varis Yae Galvus\" }\r\n943.7 \"--sync--\" Ability { id: \"4CD3\", source: \"Varis Yae Galvus\" }\r\n944.1 \"--sync--\" Ability { id: \"4CD4\", source: \"Varis Yae Galvus\" }\r\n944.5 \"--sync--\" Ability { id: \"4CD5\", source: \"Varis Yae Galvus\" }\r\n947.2 \"--sync--\" Ability { id: \"4CD6\", source: \"Varis Yae Galvus\" }\r\n\r\n958.7 \"--sync--\" StartsUsing { id: \"4CD8\", source: \"Varis Yae Galvus\" } window 10,10 jump 500\r\n958.7 \"--sync--\" StartsUsing { id: \"4CD9\", source: \"Varis Yae Galvus\" } window 10,10 jump 700\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# loaded lookahead window\r\n963.7 \"Loaded Gunshield?\" #Ability { id: \"4CD8\", source: \"Varis Yae Galvus\" }\r\n972.6 \"--sync--\" #Ability { id: \"4CB5\", source: \"Varis Yae Galvus\" }\r\n976.9 \"--sync--\" #Ability { id: \"4CDE\", source: \"Varis Yae Galvus\" }\r\n978.4 \"--clones appear?--\" #Ability { id: \"4CB3\", source: \"Phantom Varis\" }\r\n980.0 \"Magitek Burst?\" #Ability { id: \"4CDF\", source: \"Varis Yae Galvus\" }\r\n980.7 \"Ignis Est?\" #Ability { id: \"4CB6\", source: \"Ignis Est\" }\r\n988.0 \"Terminus Est?\" #Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n988.2 \"Festina Lente?\" #Ability { id: \"4CC9\", source: \"Varis Yae Galvus\" }\r\n999.4 \"Citius?\" #Ability { id: \"4CF0\", source: \"Varis Yae Galvus\" }\r\n\r\n# reinforced lookahead window\r\n963.7 \"Reinforced Gunshield?\" #Ability { id: \"4CD9\", source: \"Varis Yae Galvus\" }\r\n972.8 \"Altius?\" #Ability { id: \"4CCA\", source: \"Varis Yae Galvus\" }\r\n981.7 \"--sync--\" #Ability { id: \"4CC6\", source: \"Varis Yae Galvus\" }\r\n982.9 \"Terminus Est\" #Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n985.0 \"Magitek Shielding\" #Ability { id: \"4CDB\", source: \"Varis Yae Galvus\" }\r\n989.8 \"Ventus Est\" #Ability { id: \"4CC7\", source: \"Ventus Est\" }\r\n1000.2 \"Citius\" #Ability { id: \"4CF0\", source: \"Varis Yae Galvus\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n### Phase 4: Stack Spread Shield\r\n1200.0 \"--untargetable--\"\r\n1200.0 \"--sync--\" Ability { id: \"4CE0\", source: \"Varis Yae Galvus\" } window 1200,0\r\n1200.1 \"Gunshield\"\r\n1210.4 \"Magitek Spark/Torch\" Ability { id: [\"4CE4\", \"4CE3\"], source: \"Gunshield\" } window 10,5\r\n1219.1 \"Magitek Torch/Spark\" Ability { id: [\"4CE4\", \"4CE3\"], source: \"Gunshield\" } window 5,5\r\n# 52 second cast\r\n1254.0 \"Altius Enrage\" Ability { id: \"4CE1\", source: \"Varis Yae Galvus\" }\r\n\r\n\r\n### Phase 5: Fortius\r\n1300.0 \"--sync--\" Ability { id: \"4CE2\", source: \"Varis Yae Galvus\" } window 1300,0\r\n1303.0 \"--targetable--\"\r\n1313.3 \"Loaded Gunshield\" Ability { id: \"4CD8\", source: \"Varis Yae Galvus\" }\r\n# note: two different abilities for clockwise vs counter-clockwise\r\n1322.5 \"--sync--\" Ability { id: \"4CE[56]\", source: \"Varis Yae Galvus\" }\r\n1323.3 \"Fortius\" Ability { id: \"4CE7\", source: \"Varis Yae Galvus\" }\r\n1335.0 \"--sync--\" Ability { id: \"4CDE\", source: \"Varis Yae Galvus\" }\r\n1338.0 \"Magitek Burst\" Ability { id: \"4CDF\", source: \"Varis Yae Galvus\" }\r\n1343.3 \"Festina Lente\" Ability { id: \"4CC9\", source: \"Varis Yae Galvus\" }\r\n1354.4 \"Citius\" Ability { id: \"4CF0\", source: \"Varis Yae Galvus\" }\r\n\r\n1363.3 \"--clones appear--\" Ability { id: \"4CB3\", source: \"Phantom Varis\" }\r\n1368.0 \"Electrified Gunshield\" Ability { id: \"4CD7\", source: \"Varis Yae Galvus\" }\r\n1377.2 \"--sync--\" Ability { id: \"4CE[56]\", source: \"Varis Yae Galvus\" }\r\n1378.0 \"Fortius\" Ability { id: \"4CE7\", source: \"Varis Yae Galvus\" }\r\n1392.2 \"Terminus Est\" Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n1394.6 \"Magitek Shock\" Ability { id: \"4CDA\", source: \"Varis Yae Galvus\" }\r\n1408.5 \"--clones appear--\" Ability { id: \"4CB3\", source: \"Phantom Varis\" }\r\n1412.9 \"Altius\" Ability { id: \"4CCA\", source: \"Varis Yae Galvus\" }\r\n1421.2 \"Festina Lente\" Ability { id: \"4CC9\", source: \"Varis Yae Galvus\" }\r\n1427.7 \"--sync--\" Ability { id: \"4CC6\", source: \"Varis Yae Galvus\" }\r\n1435.1 \"Alea Iacta Est\" Ability { id: \"4CD2\", source: \"Varis Yae Galvus\" }\r\n1436.3 \"--sync--\" Ability { id: \"4CD3\", source: \"Varis Yae Galvus\" }\r\n1436.7 \"--sync--\" Ability { id: \"4CD4\", source: \"Varis Yae Galvus\" }\r\n1437.1 \"--sync--\" Ability { id: \"4CD5\", source: \"Varis Yae Galvus\" }\r\n1439.8 \"--sync--\" Ability { id: \"4CD6\", source: \"Varis Yae Galvus\" }\r\n1440.9 \"Terminus Est\" Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n1440.9 \"Ventus Est\" Ability { id: \"4CC7\", source: \"Ventus Est\" }\r\n1451.5 \"Citius\" Ability { id: \"4CF0\", source: \"Varis Yae Galvus\" }\r\n\r\n1461.0 \"--sync--\" Ability { id: \"4CB5\", source: \"Varis Yae Galvus\" }\r\n1468.8 \"Alea Iacta Est\" Ability { id: \"4CD2\", source: \"Varis Yae Galvus\" }\r\n1470.0 \"--sync--\" Ability { id: \"4CD3\", source: \"Varis Yae Galvus\" }\r\n1470.4 \"--sync--\" Ability { id: \"4CD4\", source: \"Varis Yae Galvus\" }\r\n1470.8 \"--sync--\" Ability { id: \"4CD5\", source: \"Varis Yae Galvus\" }\r\n1473.5 \"--sync--\" Ability { id: \"4CD6\", source: \"Varis Yae Galvus\" }\r\n1474.2 \"Ignis Est\" Ability { id: \"4CB6\", source: \"Ignis Est\" }\r\n\r\n1492.4 \"Loaded Gunshield\" Ability { id: \"4CD8\", source: \"Varis Yae Galvus\" }\r\n1501.6 \"--sync--\" Ability { id: \"4CE[56]\", source: \"Varis Yae Galvus\" }\r\n1502.4 \"Fortius\" Ability { id: \"4CE7\", source: \"Varis Yae Galvus\" }\r\n1514.1 \"--sync--\" Ability { id: \"4CDE\", source: \"Varis Yae Galvus\" }\r\n1517.2 \"Magitek Burst\" Ability { id: \"4CDF\", source: \"Varis Yae Galvus\" }\r\n\r\n1522.4 \"Festina Lente\" Ability { id: \"4CC9\", source: \"Varis Yae Galvus\" }\r\n1533.7 \"Citius\" Ability { id: \"4CF0\", source: \"Varis Yae Galvus\" }\r\n1542.5 \"--clones appear--\" Ability { id: \"4CB3\", source: \"Phantom Varis\" }\r\n1547.0 \"Electrified Gunshield\" Ability { id: \"4CD7\", source: \"Varis Yae Galvus\" }\r\n1556.3 \"--sync--\" Ability { id: \"4CE[56]\", source: \"Varis Yae Galvus\" }\r\n1557.1 \"Fortius\" Ability { id: \"4CE7\", source: \"Varis Yae Galvus\" }\r\n1571.3 \"Terminus Est\" Ability { id: \"4CB4\", source: \"Terminus Est\" }\r\n1573.6 \"Magitek Shock\" Ability { id: \"4CDA\", source: \"Varis Yae Galvus\" }\r\n\r\n1579.7 \"--sync--\" StartsUsing { id: \"4CA9\", source: \"Varis Yae Galvus\" } window 30,30\r\n1589.7 \"Altius Enrage\" Ability { id: \"4CA9\", source: \"Varis Yae Galvus\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/wol-ex.ts




// Shared between imbued and quintuplecast.
const wol_ex_sharedOutputStrings = {
  fire: {
    en: 'Stop',
    de: 'Stopp',
    fr: 'Stop',
    ja: '動かない',
    cn: '停停停',
    ko: '멈추기'
  },
  blizzard: {
    en: 'Move',
    de: 'Bewegen',
    fr: 'Bougez',
    ja: '動け',
    cn: '动动动',
    ko: '움직이기'
  },
  holy: {
    en: 'Stack',
    de: 'Stacken',
    fr: 'Packez-vous',
    ja: 'スタック',
    cn: '集合',
    ko: '쉐어'
  },
  stone: {
    en: 'Protean',
    de: 'Himmelsrichtungen',
    fr: 'Positions',
    ja: '散開',
    cn: '散开',
    ko: '위치 산개'
  }
};

// Only for imbued.
const imbuedOutputStrings = {
  ...wol_ex_sharedOutputStrings,
  swordIn: outputs/* default.in */.Z["in"],
  swordOut: {
    en: 'Out',
    de: 'Raus',
    fr: 'Exterieur',
    ja: '外へ',
    cn: '钢铁',
    ko: '밖으로'
  }
};

// Only for quintuplecast.
const quintupleOutputStrings = {
  ...wol_ex_sharedOutputStrings,
  flash: {
    en: 'Look Away',
    de: 'Wegschauen',
    fr: 'Regardez ailleurs',
    ja: '見ない',
    cn: '背对',
    ko: '뒤돌기'
  }
};
const wol_ex_triggerSet = {
  id: 'TheSeatOfSacrificeExtreme',
  zoneId: zone_id/* default.TheSeatOfSacrificeExtreme */.Z.TheSeatOfSacrificeExtreme,
  timelineFile: 'wol-ex.txt',
  timelineTriggers: [{
    id: 'WOLEx Limit Break',
    regex: /Limit Break/,
    // 2 extra seconds over the cast.
    beforeSeconds: 8,
    alertText: (data, _matches, output) => {
      const num = data.limitBreak;
      delete data.limitBreak;
      switch (num) {
        case 1:
          return output.limitBreak1();
        case 2:
          return output.limitBreak2();
        case 3:
          return output.limitBreak3();
      }
    },
    outputStrings: {
      limitBreak1: {
        en: 'role positions',
        de: 'Rollenposition',
        fr: 'Positions par rôle',
        ja: 'ロール特定位置へ',
        cn: '去指定位置',
        ko: '직업군별 위치로'
      },
      limitBreak2: {
        en: 'healer stacks',
        de: 'Heiler stacks',
        fr: 'Packages sur les healers',
        ja: 'ヒーラーと集合',
        cn: '与治疗集合',
        ko: '좌우 산개'
      },
      limitBreak3: {
        en: 'meteor',
        de: 'Meteor',
        fr: 'Météore',
        ja: 'メテオ',
        cn: '陨石',
        ko: '메테오'
      }
    }
  }],
  triggers: [{
    id: 'WOLEx Terror Unleashed',
    type: 'Ability',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F09',
      capture: false
    },
    condition: data => data.role === 'healer' || data.job === 'BLU',
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Heal All to Full',
        de: 'Alle vollheilen',
        fr: 'Soignez tout le monde complètement',
        ja: '全員のHPを満タンに！',
        cn: '奶满全队',
        ko: '전원 체력 풀피로'
      }
    }
  }, {
    id: 'WOLEx Bait Confiteor',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F43',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Confiteor',
        de: 'Confiteor ködern',
        fr: 'Attirez les zones au sol',
        ja: 'ソーレムコンフィテオル',
        cn: '诱导庄严悔罪',
        ko: '장판 유도하기'
      }
    }
  }, {
    id: 'WOLEx To The Limit',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F3[456]'
    },
    run: (data, matches) => {
      if (matches.id === '4F34') data.limitBreak = 1;
      if (matches.id === '4F35') data.limitBreak = 2;
      if (matches.id === '4F36') data.limitBreak = 3;
    }
  }, {
    id: 'WOLEx Absolute Stone III',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F2C',
      capture: false
    },
    infoText: (_data, _matches, output) => output.stone(),
    outputStrings: {
      stone: imbuedOutputStrings.stone
    }
  }, {
    id: 'WOLEx Imbued Absolute Fire III',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4EF3',
      capture: false
    },
    run: data => {
      data.imbued ??= [];
      data.imbued.push('fire');
    }
  }, {
    id: 'WOLEx Imbued Absolute Blizzard III',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4EF4',
      capture: false
    },
    run: data => {
      data.imbued ??= [];
      data.imbued.push('blizzard');
    }
  }, {
    id: 'WOLEx Imbued Absolute Holy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4EF5',
      capture: false
    },
    run: data => {
      data.imbued ??= [];
      data.imbued.push('holy');
    }
  }, {
    id: 'WOLEx Imbued Absolute Stone III',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4EF6',
      capture: false
    },
    run: data => {
      data.imbued ??= [];
      data.imbued.push('stone');
    }
  }, {
    id: 'WOLEx Imbued Coruscance In',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F4A',
      capture: false
    },
    preRun: data => {
      data.imbued ??= [];
      data.imbued.push('swordIn');
    },
    alertText: (data, _matches, output) => {
      const strings = data.imbued?.map(key => output[key]());
      const msg = strings?.join(' + ');
      delete data.imbued;
      return msg;
    },
    outputStrings: imbuedOutputStrings
  }, {
    id: 'WOLEx Imbued Coruscance Out',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F49',
      capture: false
    },
    preRun: data => {
      data.imbued ??= [];
      data.imbued.push('swordOut');
    },
    alertText: (data, _matches, output) => {
      const strings = data.imbued?.map(key => output[key]());
      const msg = strings?.join(' + ');
      delete data.imbued;
      return msg;
    },
    outputStrings: imbuedOutputStrings
  }, {
    id: 'WOLEx The Bitter End',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F0A'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'WOLEx Summon Wyrm',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F41',
      capture: false
    },
    delaySeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Wyrm Dash',
        de: 'Wyrm-Ansturm ausweichen',
        fr: 'Évitez la charge du Wyrm',
        ja: '竜を避ける',
        cn: '躲避巴哈冲锋',
        ko: '용 돌진 피하기'
      }
    }
  }, {
    id: 'WOLEx Absolute Flash',
    type: 'HeadMarker',
    netRegex: {
      id: '00B3'
    },
    suppressSeconds: 5,
    response: responses/* Responses.lookAwayFromTarget */.n3.lookAwayFromTarget()
  }, {
    id: 'WOLEx Elddragon Dive',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F0B',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'WOLEx Add Phase',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '5151',
      capture: false
    },
    run: data => data.isAddPhase = true
  }, {
    id: 'WOLEx Fatal Cleave / Blade Of Shadow',
    type: 'StartsUsing',
    // Either tank buster, but don't be too noisy
    netRegex: {
      source: ['Spectral Warrior', 'Spectral Dark Knight'],
      id: '515[47]',
      capture: false
    },
    suppressSeconds: 2,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.tankBusters */.Z.tankBusters
    }
  }, {
    id: 'WOLEx Berserk / Deep Darkside',
    type: 'StartsUsing',
    netRegex: {
      source: ['Spectral Warrior', 'Spectral Dark Knight'],
      id: '515[68]',
      capture: false
    },
    condition: data => data.CanSilence(),
    suppressSeconds: 2,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Interrupt',
        de: 'Unterbreche',
        fr: 'Interrompez',
        ja: '沈黙',
        cn: '插言',
        ko: '기술 시전 끊기'
      }
    }
  }, {
    id: 'WOLEx Adds Deluge of Death Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: (data, matches) => !data.ultimateSeen && data.me === matches.target,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Flare on YOU',
        de: 'Flare auf DIR',
        fr: 'Brasier sur VOUS',
        ja: '自分にフレア',
        cn: '核爆点名',
        ko: '플레어 대상자'
      }
    }
  }, {
    id: 'WOLEx Spectral Egi Flare Breath',
    type: 'Tether',
    netRegex: {
      source: 'Spectral Egi',
      id: '0054'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 4,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Point Tether Out',
        de: 'Verbindung nach draußen richten',
        fr: 'Pointez le lien vers l\'extérieur',
        ja: '線を外に引く',
        cn: '连线拉向场外',
        ko: '선 연결 바깥으로 빼기'
      }
    }
  }, {
    id: 'WOLEx Ultimate Crossover',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '5152',
      capture: false
    },
    // This is still 1 second before this cast goes off, giving ~7 seconds before LB is needed.
    delaySeconds: 4,
    alarmText: (data, _matches, output) => {
      if (data.role === 'tank' || data.job === 'BLU') return output.text();
    },
    run: data => {
      data.isAddPhase = false;
      data.ultimateSeen = true;
    },
    outputStrings: {
      text: {
        en: 'TANK LB!!',
        de: 'TANK LB!!',
        fr: 'LB TANK !!',
        ja: 'タンクLB!!',
        cn: '坦克LB！！',
        ko: '탱리밋!!'
      }
    }
  }, {
    id: 'WOLEx Spectral Black Mage / White Mage',
    type: 'StartsUsing',
    // Specter of Light before To The Limit tell.
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F37',
      capture: false
    },
    condition: data => data.ultimateSeen && !data.calledSpectral,
    preRun: data => data.calledSpectral = true,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Black Mage + White Mage',
        de: 'Schwarzmagier + Weißmagier',
        fr: 'Mage noir + Mage blanc',
        ja: '黒魔導士 + 白魔導士',
        cn: '黑魔法师 + 白魔法师',
        ko: '흑마도사 + 백마도사'
      }
    }
  }, {
    id: 'WOLEx Summoner / Warrior',
    type: 'StartsUsing',
    // Imbued Fire/Ice tell.
    netRegex: {
      source: 'Warrior Of Light',
      id: '4EF[34]',
      capture: false
    },
    condition: data => data.ultimateSeen && !data.calledSpectral,
    preRun: data => data.calledSpectral = true,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Summoner + Warrior',
        de: 'Beschwörer + Krieger',
        fr: 'Invocateur + Guerrier',
        ja: '召喚師 + 戦士',
        cn: '召唤师 + 战士',
        ko: '소환사 + 전사'
      }
    }
  }, {
    id: 'WOLEx Spectral Bard / Dark Knight',
    type: 'StartsUsing',
    // To The Limit before Specter Of Light tell.
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F3[456]',
      capture: false
    },
    condition: data => data.ultimateSeen && !data.calledSpectral,
    preRun: data => data.calledSpectral = true,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dark Knight + Bard',
        de: 'Dunkelritter + Barde',
        fr: 'Chevalier noir + Barde',
        ja: '暗黒騎士 + 吟遊詩人',
        cn: '暗黑骑士 + 吟游诗人',
        ko: '암흑기사 + 음유시인'
      }
    }
  }, {
    id: 'WOLEx Spectral Ninja',
    type: 'StartsUsing',
    // Imbued Stone/Holy tell.
    netRegex: {
      source: 'Warrior Of Light',
      id: '4EF[56]',
      capture: false
    },
    condition: data => data.ultimateSeen && !data.calledSpectral,
    preRun: data => data.calledSpectral = true,
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.ninja = true,
    outputStrings: {
      text: {
        en: 'Ninja',
        de: 'Ninja',
        fr: 'Ninja',
        ja: '忍者',
        cn: '忍者',
        ko: '닌자'
      }
    }
  }, {
    id: 'WOLEx Spectral Tell Cleanup',
    type: 'Ability',
    // This is the "go back to the middle" sync that happens after all tells.
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F45',
      capture: false
    },
    run: data => data.calledSpectral = false
  }, {
    // Katon: San and Absolute Holy share markers
    id: 'WOLEx Spectral Ninja Cleanup',
    type: 'StartsUsing',
    netRegex: {
      source: ['Warrior Of Light', 'Spectral Ninja'],
      id: '4EFD',
      capture: false
    },
    delaySeconds: 30,
    run: data => delete data.ninja
  }, {
    id: 'WOLEx Suiton: San',
    type: 'StartsUsing',
    // It's possible for this cast to originate from the Warrior of Light instead.
    // Allow for either so the callout isn't missed.
    netRegex: {
      source: ['Warrior Of Light', 'Spectral Ninja'],
      id: '4EFD',
      capture: false
    },
    delaySeconds: 7,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'WOLEx Katon: San',
    type: 'HeadMarker',
    netRegex: {
      id: '00A1',
      capture: false
    },
    condition: data => data.ultimateSeen && data.ninja || data.isAddPhase,
    suppressSeconds: 2,
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }, {
    id: 'WOLEx Perfect Decimation',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Warrior Cleave on YOU',
        de: 'Krieger Cleave auf DIR',
        fr: 'Cleave du Guerrier sur VOUS',
        ja: '自分に戦士の範囲攻撃',
        cn: '战士顺劈点名',
        ko: '전사 범위 공격 대상자'
      }
    }
  }, {
    id: 'WOLEx Brimstone Earth',
    type: 'HeadMarker',
    netRegex: {
      id: '0067'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Puddle on YOU',
        de: 'Fläche auf DIR',
        fr: 'Zone au sol sur VOUS',
        ja: '自分に水溜り',
        cn: '扩散AOE点名',
        ko: '장판 대상자'
      }
    }
  }, {
    id: 'WOLEx Deluge of Death Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: (data, matches) => data.ultimateSeen && data.me === matches.target,
    alarmText: (_data, _matches, output) => output.text(),
    run: data => data.deluge = true,
    outputStrings: {
      text: {
        en: 'Flare on YOU',
        de: 'Flare auf DIR',
        fr: 'Brasier sur VOUS',
        ja: '自分にフレア',
        cn: '核爆点名',
        ko: '플레어 대상자'
      }
    }
  }, {
    id: 'WOLEx Absolute Holy',
    type: 'HeadMarker',
    netRegex: {
      id: '00A1'
    },
    condition: data => !data.ninja && !data.isAddPhase,
    // This stack marker comes before the deluge markers.
    delaySeconds: (data, matches) => matches.target !== data.me ? 0.4 : 0,
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.stackOnYou?.();
      if (!data.deluge) return output.stackOnTarget?.({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOnTarget: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'WOLEx Coruscant Saber Out',
    type: 'StartsUsing',
    // TODO: This once was out + stack ?
    netRegex: {
      source: 'Warrior Of Light',
      id: '4EF1',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'WOLEx Coruscant Saber In',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4EF2',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'WOLEx Quintuplecast',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4EEF',
      capture: false
    },
    run: data => {
      data.quintuplecasting = true;
      data.quintuplecasts = [];
    }
  }, {
    id: 'WOLEx Quintuplecast List',
    type: 'Ability',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4EEF',
      capture: false
    },
    durationSeconds: 18.5,
    infoText: (data, _matches, output) => {
      const strings = data.quintuplecasts?.map(key => output[key]());
      const msg = strings?.join(' > ');
      return msg;
    },
    tts: null,
    outputStrings: quintupleOutputStrings
  }, {
    id: 'WOLEx Quintuplecast Individual',
    type: 'Ability',
    netRegex: {
      source: 'Warrior Of Light',
      id: ['4EEF', '4EF0'],
      capture: false
    },
    durationSeconds: 3,
    alertText: (data, _matches, output) => {
      const next = data.quintuplecasts?.shift();
      // The last cast of 4EF0 will not have a next mechanic to call.
      if (next !== undefined) return output[next]();
    },
    outputStrings: quintupleOutputStrings
  }, {
    id: 'WOLEx Quintuplecast Blizzard',
    type: 'HeadMarker',
    netRegex: {
      id: '00E2',
      capture: false
    },
    condition: data => data.quintuplecasting,
    durationSeconds: 2,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => `(${output.blizzard().toLowerCase()})`,
    run: data => data.quintuplecasts?.push('blizzard'),
    outputStrings: {
      blizzard: quintupleOutputStrings.blizzard
    }
  }, {
    id: 'WOLEx Quintuplecast Holy',
    type: 'HeadMarker',
    netRegex: {
      id: '00DD',
      capture: false
    },
    condition: data => data.quintuplecasting,
    durationSeconds: 2,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => `(${output.holy().toLowerCase()})`,
    run: data => data.quintuplecasts?.push('holy'),
    outputStrings: {
      holy: quintupleOutputStrings.holy
    }
  }, {
    id: 'WOLEx Quintuplecast Stone',
    type: 'HeadMarker',
    netRegex: {
      id: '00DE',
      capture: false
    },
    condition: data => data.quintuplecasting,
    durationSeconds: 2,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => `(${output.stone().toLowerCase()})`,
    run: data => data.quintuplecasts?.push('stone'),
    outputStrings: {
      stone: quintupleOutputStrings.stone
    }
  }, {
    id: 'WOLEx Quintuplecast Fire',
    type: 'HeadMarker',
    netRegex: {
      id: '00E4',
      capture: false
    },
    condition: data => data.quintuplecasting,
    durationSeconds: 2,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => `(${output.fire().toLowerCase()})`,
    run: data => data.quintuplecasts?.push('fire'),
    outputStrings: {
      fire: quintupleOutputStrings.fire
    }
  }, {
    id: 'WOLEx Quintuplecast Flash',
    type: 'HeadMarker',
    netRegex: {
      id: '00DF',
      capture: false
    },
    condition: data => data.quintuplecasting,
    durationSeconds: 2,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => `(${output.flash().toLowerCase()})`,
    run: data => data.quintuplecasts?.push('flash'),
    outputStrings: {
      flash: quintupleOutputStrings.flash
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Spectral Ninja': 'Phantom-Ninja',
      'Warrior Of Light': 'Krieger des Lichts',
      'Spectral Dark Knight': 'Phantom-Dunkelritter',
      'Spectral Warrior': 'Phantom-Berserker',
      'Spectral Black Mage': 'Phantom-Schwarzmagier',
      'Spectral Summoner': 'Phantom-Beschwörer',
      'Spectral Egi': 'Phantom-Primae',
      'Wyrm Of Light': 'Wyrm des Lichts',
      'Spectral Bard': 'Phantom-Barde',
      'Spectral White Mage': 'Phantom-Weißmagier'
    },
    'replaceText': {
      'Absolute Flash': 'Absolutes Blitzlicht',
      'Absolute Holy': 'Absolutes Sanctus',
      'Absolute Stone III': 'Absolutes Steinga',
      'Berserk': 'Tollwut',
      'Blade Of Shadow': 'Magische Schattenklinge',
      'Brimstone Earth': 'Schwefelerde',
      '(?<!\\w)Cast': 'Zauber',
      'Cauterize': 'Kauterisieren',
      'Coruscant Saber': 'Gleißender Säbel',
      'Deep Darkside': 'Totale Finsternis',
      'Deluge Of Death': 'Tödlicher Sturzregen',
      'Elddragon Dive': 'Altdrachensturz',
      'Fatal Cleave': 'Fatales Niedermähen',
      'Fire': 'Feuga',
      'Flare Breath': 'Flare-Atem',
      '(?<!Absolute )Holy': 'Sanctus',
      'Ice': 'Eisga',
      'Imbued Coruscance': 'Magieklingentechnik: Gleißender Säbel',
      'Imbued(?! Coruscance)': 'Magieklinge des absoluten',
      'Katon\\: San': 'Katon: San',
      'Limit(?! Break)': 'Limit',
      'Limit Break': 'Limitrausch',
      'Meteor Impact': 'Meteoreinschlag',
      'Perfect Decimation': 'Perfektes Dezimieren',
      'Quintuplecast': 'Fünffachzauber',
      'Radiant Braver': 'Gleißende Gerechtigkeit',
      'Radiant Desperado': 'Gleißender Desperado',
      'Radiant Meteor': 'Gleißender Meteor',
      'Shining Wave': 'Leuchtwelle',
      'Solemn Confiteor': 'Feierlicher Confiteor',
      'Specter Of Light': 'Heldenruf',
      'Specter -> BLM/WHM': 'Heldenruf -> SMA/WMA',
      '(?<!Absolute )Stone(?! Earth)': 'Steinga',
      'Suiton\\: San': 'Suiton: San',
      'Summon(?! Wyrm)': 'Beschwörung',
      'Summon Wyrm': 'Drachenbeschwörung',
      'Sword Of Light': 'Schwert des Lichts',
      'Terror Unleashed': 'Entfesselter Terror',
      'The Bitter End': 'Schwertschimmer',
      'To The Limit': 'Bis ans Limit',
      'Twincast': 'Dualzauber',
      'Ultimate Crossover': 'Ultimative Kreuzigung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Spectral Ninja': 'ninja spectral',
      'Warrior Of Light': 'Guerrier de la Lumière primordial',
      'Spectral Dark Knight': 'chevalier noir spectral',
      'Spectral Warrior': 'berserker spectral',
      'Spectral Black Mage': 'mage noir spectral',
      'Spectral Summoner': 'invocatrice spectrale',
      'Spectral Egi': 'Egi spectral',
      'Wyrm Of Light': 'wyrm de Lumière',
      'Spectral Bard': 'barde spectral',
      'Spectral White Mage': 'mage blanc spectral'
    },
    'replaceText': {
      'Absolute Flash': 'Magilame Flash',
      'Absolute Holy': 'Miracle absolu',
      'Absolute Stone III': 'Méga Terre absolue',
      'Berserk': 'Furie',
      'Blade Of Shadow': 'Tranchant maléfique d\'ombre',
      'Brimstone Earth': 'Terre de soufre',
      '(?<!\\w)Cast': 'Incantation',
      'Cauterize': 'Cautérisation',
      'Coruscant Saber': 'Fureur flamboyante',
      'Deep Darkside': 'Ténèbres intérieures absolues',
      'Deluge Of Death': 'Averse mortelle',
      'Elddragon Dive': 'Piqué du dragon ancien',
      'Fatal Cleave': 'Fendoir fatal',
      'Flare Breath': 'Souffle brasier',
      'Fire/Ice -> SMN/WAR': 'Feu/Glace -> INV/GUE',
      '(?<!\\w )Holy': 'Mirace absolu',
      'Imbued Coruscance': 'Magilame Fureur flamboyante',
      'Imbued Holy': 'Magilame Miracle',
      'Imbued Stone': 'Magilame Méga Terre',
      'Imbued Fire/Blizzard': 'Magilame Méga Feu/Glace',
      'Imbued Fire/Ice': 'Magilame Méga Feu/Glace',
      'Imbued Ice/Fire': 'Magilame Méga Glace/Feu',
      'Katon\\: San': 'Katon : San',
      'Limit Break': 'Transcendance',
      'Limit -> DRK/BRD': 'Transcendance -> CHN/BRD',
      'Meteor Impact': 'Impact de météore',
      'Perfect Decimation': 'Décimation parfaite',
      'Quintuplecast': 'Quintuple sort',
      'Radiant Braver': 'Âme brave flamboyante',
      'Radiant Desperado': 'Desperado flamboyant',
      'Radiant Meteor': 'Météore flamboyant',
      'Shining Wave': 'Épée flamboyante',
      'Solemn Confiteor': 'Confiteor solennel',
      'Specter -> BLM/WHM': 'Spectres -> MNO/MBL',
      'Specter Of Light': 'Sommation des braves',
      '(?<!\\w )Stone(?! Earth)': 'Méga Terre',
      'Suiton\\: San': 'Suiton : San',
      'Summon(?! Wyrm)': 'Invocation',
      'Summon Wyrm': 'Invocation de wyrm',
      'Sword Of Light': 'Lame de Lumière',
      'Terror Unleashed': 'Déchaînement de la terreur',
      'The Bitter End': 'Éradication',
      'To The Limit': 'Pas vers la transcendance',
      'Twincast': 'Tandem',
      'Ultimate Crossover': 'Taillade croisée ultime'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Spectral Ninja': '幻光の忍者',
      'Warrior Of Light': 'ウォーリア・オブ・ライト',
      'Spectral Dark Knight': '幻光の暗黒騎士',
      'Spectral Warrior': '幻光の狂戦士',
      'Spectral Black Mage': '幻光の黒魔道士',
      'Spectral Summoner': '幻光の召喚士',
      'Spectral Egi': '幻光の召喚獣',
      'Wyrm Of Light': 'ウィルム・オブ・ライト',
      'Spectral Bard': '幻光の吟遊詩人',
      'Spectral White Mage': '幻光の白魔道士'
    },
    'replaceText': {
      'Absolute Flash': 'アブソリュートフラッシュ',
      'Absolute Holy': 'アブソリュートホーリー',
      'Absolute Stone III': 'アブソリュートストンガ',
      'Berserk': 'ベルセルク',
      'Blade Of Shadow': '漆黒の魔剣',
      'BLM/WHM': '黒魔／白魔',
      'Brimstone Earth': 'ブリムストーンアース',
      '(?<!\\w)Cast(?= )': '五連魔',
      'Cauterize': 'カータライズ',
      'Coruscant Saber': 'ブライトセイバー',
      'Deep Darkside': '真暗黒',
      'Deluge Of Death': 'ヘビーレイン・オブ・デス',
      'DRK/BRD': '暗黒／詩人',
      'Elddragon Dive': 'エンシェントドラゴンダイブ',
      'Fatal Cleave': 'フェイタルクリーヴ',
      '(?<!Imbued )Fire/Ice': '魔法剣 (火／氷)',
      'Flare Breath': 'フレアブレス',
      'Imbued Coruscance': '魔法剣技：ブライトセイバー',
      'Imbued Fire/Ice': '魔法剣 (火／氷)',
      'Imbued Holy': '魔法剣 (光)',
      'Imbued Ice/Fire': '魔法剣 (氷／火)',
      'Imbued Stone(?!/)': '魔法剣 (土)',
      'Imbued Stone/Holy': '魔法剣 (土/光)',
      'Katon\\: San': '火遁の術：参',
      '(?<! )Limit(?! Break)': 'リミットチャージ',
      'Limit Break': 'リミットブレイク',
      'Meteor Impact': 'メテオインパクト',
      '(?<= )NIN': '忍者',
      'Perfect Decimation': 'パーフェクトデシメート',
      'Quintuplecast': '五連魔',
      'Radiant Braver': 'ブライトブレイバー',
      'Radiant Desperado': 'ブライトデスペラード',
      'Radiant Meteor': 'ブライトメテオ',
      'Shining Wave': 'シャイニングウェーブ',
      'SMN/WAR': '召喚／戦士',
      'Solemn Confiteor': 'ソーレムコンフィテオル',
      'Specter Of Light': '幻光召喚',
      '(?<!Imbued )Stone/Holy': '魔法剣 (土/光)',
      'Suiton\\: San': '水遁の術：参',
      'Summon(?! Wyrm)': '召喚',
      'Summon Wyrm': 'サモン・ウィルム',
      'Sword Of Light': 'ソード・オブ・ライト',
      'Terror Unleashed': 'アンリーシュ・テラー',
      'The Bitter End': 'エンドオール',
      'To The Limit': 'リミットチャージ',
      'Twincast': 'ふたりがけ',
      'Ultimate Crossover': 'アルティメット・クロスオーバー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Spectral Ninja': '幻光忍者',
      'Warrior Of Light': '光之战士',
      'Spectral Dark Knight': '幻光暗黑骑士',
      'Spectral Warrior': '幻光狂战士',
      'Spectral Black Mage': '幻光黑魔法师',
      'Spectral Summoner': '幻光召唤师',
      'Spectral Egi': '幻光召唤兽',
      'Wyrm Of Light': '光之真龙',
      'Spectral Bard': '幻光吟游诗人',
      'Spectral White Mage': '幻光白魔法师'
    },
    'replaceText': {
      'Absolute Flash': '绝对闪光',
      'Absolute Holy': '绝对神圣',
      'Absolute Stone III': '绝对垒石',
      'Berserk': '狂暴',
      'Blade Of Shadow': '漆黑魔剑',
      'BLM/WHM': '黒魔／白魔',
      'Brimstone Earth': '狱火大地',
      '(?<!\\w)Cast(?= )': '五连',
      'Cauterize': '灼热俯冲',
      'Coruscant Saber': '光明利剑',
      'Deep Darkside': '深度暗黑',
      'Deluge Of Death': '死亡暴雨',
      'DRK/BRD': '黑骑／诗人',
      'Elddragon Dive': '远古龙炎冲',
      'Fatal Cleave': '夺命飞环',
      '(?<! )Fire/Ice': '火/冰',
      'Flare Breath': '核爆吐息',
      '(?<! )Holy': '神圣',
      'Imbued Coruscance': '魔法剑技·光明利剑',
      'Imbued Fire/Ice': '魔法剑(火／冰)',
      'Imbued Holy': '魔法剣 (光)',
      'Imbued Ice/Fire': '魔法剣 (冰／火)',
      'Imbued Stone': '魔法剣  (土)',
      'Katon\\: San': '叁式火遁之术',
      '(?<! )Limit(?! Break)': '极限技',
      'Limit Break': '极限技',
      'Meteor Impact': '陨石冲击',
      '(?<= )NIN': '忍者',
      'Perfect Decimation': '完美地毁人亡',
      'Quintuplecast': '五连咏唱',
      'Radiant Braver': '光之勇猛烈斩',
      'Radiant Desperado': '光之亡命暴徒',
      'Radiant Meteor': '光之陨石流星',
      'Shining Wave': '光芒波动',
      'SMN/WAR': '召唤／战士',
      'Solemn Confiteor': '庄严悔罪',
      'Specter Of Light': '幻光召唤',
      '(?<! )Stone(?! Earth)': '飞石',
      'Suiton\\: San': '叁式水遁之术',
      'Summon(?! Wyrm)': '召唤',
      'Summon Wyrm': '真龙召唤',
      'Sword Of Light': '光之剑',
      'Terror Unleashed': '恐惧释放',
      'The Bitter End': '尽灭',
      'To The Limit': '突破极限',
      'Twincast': '合力咏唱',
      'Ultimate Crossover': '究极·交汇'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Warrior Of Light': '빛의 전사',
      'Spectral Bard': '환상빛의 음유시인',
      'Spectral Black Mage': '환상빛의 흑마도사',
      'Spectral Dark Knight': '환상빛의 암흑기사',
      'Spectral Egi': '환상빛의 소환수',
      'Spectral Ninja': '환상빛의 닌자',
      'Spectral Summoner': '환상빛의 소환사',
      'Spectral Warrior': '환상빛의 전사',
      'Spectral White Mage': '환상빛의 백마도사',
      'Wyrm Of Light': '빛의 비룡'
    },
    'replaceText': {
      'Absolute Flash': '앱솔루트 플래시',
      'Absolute Holy': '앱솔루트 홀리',
      'Absolute Stone III': '앱솔루트 스톤가',
      'Berserk': '광폭화',
      'Blade Of Shadow': '칠흑의 마검',
      'BLM/WHM': '흑마／백마',
      'Brimstone Earth': '유황 지대',
      '(?<!\\w)Cast(?= )': '시전',
      'Cauterize': '인두질',
      'Coruscant Saber': '빛나는 도검',
      'Deep Darkside': '진 암흑',
      'Deluge Of Death': '죽음의 화살 폭우',
      'DRK/BRD': '암기／음유',
      'Elddragon Dive': '고룡 강타',
      'Fatal Cleave': '치명적인 참수',
      '(?<! )Fire/Ice': '파이가/블리자가',
      'Flare Breath': '타오르는 숨결',
      '(?<! )Holy': '홀리',
      'Imbued Coruscance': '마법검: 빛나는 도검',
      'Imbued Fire/Ice': '마법검 파이가/블리자가',
      'Imbued Holy': '마법검 홀리',
      'Imbued Ice/Fire': '마법검 블리자가/파이가',
      'Imbued Stone': '마법검 스톤',
      'Katon\\: San': '화둔술 3',
      '(?<! )Limit(?! Break)': '리미트',
      'Limit Break': '리미트 브레이크',
      'Meteor Impact': '운석 낙하',
      '(?<= )NIN': '닌자',
      'Perfect Decimation': '완전 섬멸',
      'Quintuplecast': '오연속 마법',
      'Radiant Braver': '빛나는 브레이버',
      'Radiant Desperado': '빛나는 무법자',
      'Radiant Meteor': '빛나는 메테오',
      'Shining Wave': '찬란한 파동',
      'SMN/WAR': '소환사／전사',
      'Solemn Confiteor': '엄숙한 기도',
      'Specter Of Light': '환상빛 소환',
      '(?<! )Stone(?! Earth)': '스톤',
      'Suiton\\: San': '수둔술 3',
      'Summon(?! Wyrm)': '소환',
      'Summon Wyrm': '비룡 소환',
      'Sword Of Light': '빛의 검',
      'Terror Unleashed': '공포 촉발',
      'The Bitter End': '파국',
      'To The Limit': '리미트 축적',
      'Twincast': '합동 시전',
      'Ultimate Crossover': '궁극의 협력기'
    }
  }]
};
/* harmony default export */ const wol_ex = (wol_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/wol-ex.txt
const trial_wol_ex_namespaceObject = "### Warrior of Light (Extreme)\r\n# https://docs.google.com/document/d/1UeDHZGa1_p2gytoZwQWt6rdr6eeDQdvwS6sdRlOt07Y/edit\r\n# https://saltedxiv.com/guides/the-seat-of-sacrifice-extreme-guide\r\n#\r\n# -p 4F09:9.7 5151:226 5152:500 -it \"Warrior Of Light\"\r\n# -ii 5459 4F43 4EEB 4EF8 4EEE 4F3C 4F06 4EFF 4F00 4EEA 4EED 4EEC 4F44 4F3E 4F01\r\n\r\n# Phase diagram:\r\n# 1 -> 2 -> 3a summon + quintuplecast -> 3b summon -> 3b\r\n\r\n# Notes:\r\n# 4F43 is the solemn confiteor windup, skipped above, but useful for phase syncing\r\n# 4F05 perfect decimation damage is sometimes missed\r\n# 4F03 is tower correctly done, 4F04 is failed\r\n# Have seen LB1+2+3 go to DRK.  Have only seen 2+3 go to WHM/BLM, but assuming LB1 could too.\r\n\r\n# TODO: More work needs to be done on the phase jump block\r\n# The ultimate -> block transition is fine.\r\n# It's not clear whether quintuplecast -> block has a different timing than block -> block.\r\n# Or worse, whether block1 -> block2 times different than block1 -> block3 relative to 4F45.\r\n# It's usually within 1s, although I've seen as much as 6s off.  It'll still sync at least.\r\n# TODO: we could also remove the jumps from a block to itself.\r\n\r\nhideall \"--sync--\"\r\nhideall \"--Reset--\"\r\nhideall \"Limit Break\"\r\n\r\n### Phase 1: Warmup\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n9.7 \"Terror Unleashed\" Ability { id: \"4F09\", source: \"Warrior Of Light\" } window 20,20\r\n15.8 \"To The Limit 3\" Ability { id: \"4F36\", source: \"Warrior Of Light\" }\r\n27.6 \"Solemn Confiteor\" Ability { id: \"4F0C\", source: \"Warrior Of Light\" }\r\n32.1 \"Absolute Stone III\" Ability { id: \"4F2C\", source: \"Warrior Of Light\" }\r\n41.2 \"Limit Break\" Ability { id: \"4EFB\", source: \"Warrior Of Light\" }\r\n41.3 \"Radiant Meteor\" Ability { id: \"4EFC\", source: \"Warrior Of Light\" }\r\n49.4 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n54.6 \"Imbued Stone\" Ability { id: \"4EF6\", source: \"Warrior Of Light\" }\r\n63.7 \"Imbued Fire/Ice\" Ability { id: \"4EF[34]\", source: \"Warrior Of Light\" }\r\n76.8 \"Imbued Coruscance\" Ability { id: \"4F4[9A]\", source: \"Warrior Of Light\" }\r\n84.0 \"To The Limit 2\" Ability { id: \"4F35\", source: \"Warrior Of Light\" }\r\n92.1 \"Sword Of Light\" Ability { id: \"4F42\", source: \"Warrior Of Light\" }\r\n109.4 \"Absolute Holy\" Ability { id: \"4F2B\", source: \"Warrior Of Light\" }\r\n110.4 \"Shining Wave\" Ability { id: \"4F08\", source: \"Warrior Of Light\" }\r\n118.6 \"Limit Break\" Ability { id: \"53CB\", source: \"Warrior Of Light\" }\r\n119.0 \"Radiant Desperado 1\" Ability { id: \"4EF9\", source: \"Warrior Of Light\" }\r\n123.3 \"Radiant Desperado 2\" Ability { id: \"4EFA\", source: \"Warrior Of Light\" }\r\n127.4 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n132.7 \"To The Limit 1\" Ability { id: \"4F34\", source: \"Warrior Of Light\" }\r\n140.8 \"Imbued Holy\" Ability { id: \"4EF5\", source: \"Warrior Of Light\" }\r\n149.9 \"Imbued Ice/Fire\" Ability { id: \"4EF[34]\", source: \"Warrior Of Light\" }\r\n163.0 \"Imbued Coruscance\" Ability { id: \"4F4[9A]\", source: \"Warrior Of Light\" }\r\n173.1 \"Limit Break\" Ability { id: \"515C\", source: \"Warrior Of Light\" }\r\n173.4 \"Radiant Braver\" Ability { id: \"4EF7\", source: \"Warrior Of Light\" }\r\n186.5 \"The Bitter End\" Ability { id: \"4F0A\", source: \"Warrior Of Light\" }\r\n192.7 \"Summon Wyrm\" Ability { id: \"4F41\", source: \"Warrior Of Light\" }\r\n198.8 \"Solemn Confiteor\" Ability { id: \"4F0C\", source: \"Warrior Of Light\" }\r\n200.8 \"Absolute Flash\" Ability { id: \"4F2F\", source: \"Warrior Of Light\" }\r\n202.9 \"Cauterize\" Ability { id: \"4F07\", source: \"Wyrm Of Light\" }\r\n209.0 \"Elddragon Dive\" Ability { id: \"4F0B\", source: \"Warrior Of Light\" }\r\n\r\n### Phase 2: Adds\r\n217.4 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n222.8 \"Specter Of Light\" Ability { id: \"4F37\", source: \"Warrior Of Light\" } window 300,10\r\n225.9 \"--untargetable--\"\r\n226.0 \"--sync--\" Ability { id: \"5151\", source: \"Warrior Of Light\" }\r\n\r\n231.2 \"--adds targetable--\"\r\n239.3 \"Deluge Of Death\" Ability { id: \"4F3B\", source: \"Spectral Bard\" }\r\n241.3 \"Twincast\" Ability { id: \"4F3D\", source: \"Spectral Black Mage\" }\r\n243.3 \"--sync--\" Ability { id: \"4F39\", source: \"Spectral Ninja\" }\r\n244.0 \"--sync--\" Ability { id: \"531E\", source: \"Spectral White Mage\" }\r\n245.4 \"Fatal Cleave\" Ability { id: \"5154\", source: \"Spectral Warrior\" }\r\n245.4 \"Blade Of Shadow\" Ability { id: \"5157\", source: \"Spectral Dark Knight\" }\r\n246.3 \"Summon\" Ability { id: \"4F3F\", source: \"Spectral Summoner\" }\r\n247.4 \"Deluge Of Death\" Ability { id: \"4F02\", source: \"Spectral Bard\" }\r\n251.0 \"--sync--\" Ability { id: \"531E\", source: \"Spectral Bard\" }\r\n251.4 \"Katon: San\" Ability { id: \"4EFE\", source: \"Spectral Ninja\" }\r\n253.4 \"Meteor Impact\" Ability { id: \"5098\", source: \"Spectral Black Mage\" }\r\n255.1 \"--sync--\" Ability { id: \"531E\", source: \"Spectral Ninja\" }\r\n258.4 \"Berserk\" #Ability { id: \"5156\", source: \"Spectral Warrior\" }\r\n258.4 \"Deep Darkside\" #Ability { id: \"5158\", source: \"Spectral Dark Knight\" }\r\n260.4 \"Flare Breath\" Ability { id: \"4F40\", source: \"Spectral Summoner\" }\r\n266.2 \"--sync--\" Ability { id: \"531E\", source: \"Spectral Summoner\" }\r\n\r\n272.6 \"Fatal Cleave\" Ability { id: \"5154\", source: \"Spectral Warrior\" }\r\n272.6 \"Blade Of Shadow\" Ability { id: \"5157\", source: \"Spectral Dark Knight\" }\r\n\r\n288.8 \"Fatal Cleave\" Ability { id: \"5154\", source: \"Spectral Warrior\" }\r\n288.8 \"Blade Of Shadow\" Ability { id: \"5157\", source: \"Spectral Dark Knight\" }\r\n\r\n305.4 \"Fatal Cleave\" Ability { id: \"5154\", source: \"Spectral Warrior\" }\r\n305.4 \"Blade Of Shadow\" Ability { id: \"5157\", source: \"Spectral Dark Knight\" }\r\n# ??? enrage\r\n\r\n\r\n### Phase 3: Random Summons\r\n500.0 \"--sync--\" Ability { id: \"5152\", source: \"Warrior Of Light\" } window 500,0\r\n506.1 \"Ultimate Crossover\" Ability { id: \"5153\", source: \"Warrior Of Light\" }\r\n513.1 \"--targetable--\"\r\n517.3 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# BLM/WHM\r\n519.6 \"--sync--\" StartsUsing { id: \"4F73\", source: \"Warrior Of Light\" } window 5,5 jump 1519.5\r\n522.6 \"Specter -> BLM/WHM\" #Ability { id: \"4F73\", source: \"Warrior Of Light\" }\r\n527.8 \"--sync--\" StartsUsing { id: \"4F3D\", source: \"Spectral Black Mage\" } window 40,40 jump 1527.8\r\n\r\n# DRK/BRD\r\n519.6 \"--sync--\" StartsUsing { id: \"4F3[456]\", source: \"Warrior Of Light\" } window 5,5 jump 2519.6\r\n522.6 \"Limit -> DRK/BRD\" #Ability { id: \"4F3[456]\", source: \"Warrior Of Light\" }\r\n534.0 \"--sync--\" StartsUsing { id: \"4F43\", source: \"Warrior Of Light\" } window 40,40 jump 2534\r\n\r\n# NIN\r\n519.6 \"--sync--\" StartsUsing { id: \"4EF[56]\", source: \"Warrior Of Light\" } window 40,40 jump 3519.6\r\n522.6 \"Stone/Holy -> NIN\" #Ability { id: \"4EF[56]\", source: \"Warrior Of Light\" }\r\n\r\n# SMN/WAR\r\n519.6 \"--sync--\" StartsUsing { id: \"4EF[34]\", source: \"Warrior Of Light\" } window 40,40 jump 4519.7\r\n522.6 \"Fire/Ice -> SMN/WAR\" #Ability { id: \"4EF[34]\", source: \"Warrior Of Light\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n### Phase 3a: BLM/WHM\r\n1517.3 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n1519.5 \"--sync--\" StartsUsing { id: \"4F37\", source: \"Warrior Of Light\" }\r\n1522.5 \"Specter Of Light\" Ability { id: \"4F37\", source: \"Warrior Of Light\" }\r\n1525.6 \"--sync--\" StartsUsing { id: \"4F3[56]\", source: \"Warrior Of Light\" }\r\n1527.8 \"--sync--\" StartsUsing { id: \"4F3D\", source: \"Spectral Black Mage\" }\r\n1528.6 \"To The Limit\" Ability { id: \"4F3[456]\", source: \"Warrior Of Light\" }\r\n1530.8 \"Twincast\" Ability { id: \"4F3D\", source: \"Spectral Black Mage\" }\r\n1533.2 \"--sync--\" Ability { id: \"531E\", source: \"Spectral White Mage\" }\r\n1533.2 \"--sync--\" Ability { id: \"531E\", source: \"Spectral Black Mage\" }\r\n1545.3 \"Meteor Impact 1\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n1547.3 \"Meteor Impact 2\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n1549.4 \"Meteor Impact 3\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n1551.4 \"Meteor Impact 4\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n1553.4 \"Meteor Impact 5\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n1555.4 \"Meteor Impact 6\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n1557.4 \"Meteor Impact 7\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n1557.8 \"Summon Wyrm\" Ability { id: \"4F41\", source: \"Warrior Of Light\" }\r\n1559.4 \"Meteor Impact 8\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n1567.9 \"Coruscant Saber\" Ability { id: \"4EF[12]\", source: \"Warrior Of Light\" }\r\n1568.0 \"Cauterize\" Ability { id: \"4F07\", source: \"Wyrm Of Light\" }\r\n1580.2 \"Limit Break\" Ability { id: [\"4EFB\", \"53CB\", \"515C\"], source: \"Warrior Of Light\" }\r\n### TODO: bitter end gets moved up 0.5s if it's meteor???\r\n1593.1 \"--sync--\" StartsUsing { id: \"4F0A\", source: \"Warrior Of Light\" } window 10,10\r\n1598.1 \"The Bitter End\" Ability { id: \"4F0A\", source: \"Warrior Of Light\" }\r\n\r\n1605.4 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n1619.6 \"Quintuplecast\" Ability { id: \"4EEF\", source: \"Warrior Of Light\" }\r\n1622.8 \"Cast 1\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n1625.9 \"Cast 2\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n1629.0 \"Cast 3\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n1632.1 \"Cast 4\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n1635.2 \"Cast 5\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n1650.2 \"Shining Wave\" Ability { id: \"4F08\", source: \"Warrior Of Light\" }\r\n1651.4 \"Elddragon Dive\" Ability { id: \"4F0B\", source: \"Warrior Of Light\" }\r\n1661.7 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# DRK/BRD\r\n1664.0 \"--sync--\" StartsUsing { id: \"4F3[456]\", source: \"Warrior Of Light\" } window 5,5 jump 7002.2\r\n1667.0 \"Limit -> DRK/BRD\" #Ability { id: \"4F3[456]\", source: \"Warrior Of Light\" }\r\n1678.3 \"--sync--\" StartsUsing { id: \"4F43\", source: \"Warrior Of Light\" } window 40,40 jump 7016.6\r\n\r\n# NIN\r\n1664.0 \"--sync--\" StartsUsing { id: \"4EF[56]\", source: \"Warrior Of Light\" } window 40,40 jump 8002.3\r\n1667.0 \"Stone/Holy -> NIN\" #Ability { id: \"4EF[56]\", source: \"Warrior Of Light\" }\r\n\r\n# SMN/WAR\r\n1664.0 \"--sync--\" StartsUsing { id: \"4EF[34]\", source: \"Warrior Of Light\" } window 40,40 jump 9002.3\r\n1667.0 \"Fire/Ice -> SMN/WAR\" #Ability { id: \"4EF[34]\", source: \"Warrior Of Light\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n\r\n### Phase 3a: DRK/BRD\r\n2517.3 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n2519.6 \"--sync--\" StartsUsing { id: \"4F3[46]\", source: \"Warrior Of Light\" }\r\n2522.6 \"To The Limit\" Ability { id: \"4F3[456]\", source: \"Warrior Of Light\" }\r\n2530.8 \"Specter Of Light\" Ability { id: \"4F37\", source: \"Warrior Of Light\" }\r\n2534.0 \"--sync--\" StartsUsing { id: \"4F43\", source: \"Warrior Of Light\" }\r\n2537.0 \"--sync--\" Ability { id: \"4F43\", source: \"Warrior Of Light\" }\r\n2540.6 \"Solemn Confiteor\" Ability { id: \"4F0C\", source: \"Warrior Of Light\" }\r\n2544.1 \"Brimstone Earth\" Ability { id: \"4F3A\", source: \"Spectral Dark Knight\" }\r\n2547.4 \"--sync--\" Ability { id: \"531E\", source: \"Spectral Dark Knight\" }\r\n2548.4 \"Deluge Of Death\" Ability { id: \"4F3B\", source: \"Spectral Bard\" }\r\n2552.0 \"--sync--\" Ability { id: \"531E\", source: \"Spectral Bard\" }\r\n2556.6 \"Absolute Holy\" Ability { id: \"4F2B\", source: \"Warrior Of Light\" }\r\n2556.6 \"Deluge Of Death\" Ability { id: \"4F02\", source: \"Spectral Bard\" }\r\n2563.6 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n2571.8 \"Limit Break\" Ability { id: [\"4EFB\", \"53CB\", \"515C\"], source: \"Warrior Of Light\" }\r\n2584.1 \"--sync--\" StartsUsing { id: \"4F0A\", source: \"Warrior Of Light\" } window 10,10\r\n2589.1 \"The Bitter End\" Ability { id: \"4F0A\", source: \"Warrior Of Light\" }\r\n\r\n2596.4 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n2610.6 \"Quintuplecast\" Ability { id: \"4EEF\", source: \"Warrior Of Light\" }\r\n2613.8 \"Cast 1\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n2616.9 \"Cast 2\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n2620.0 \"Cast 3\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n2623.1 \"Cast 4\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n2626.2 \"Cast 5\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n2641.2 \"Shining Wave\" Ability { id: \"4F08\", source: \"Warrior Of Light\" }\r\n2642.4 \"Elddragon Dive\" Ability { id: \"4F0B\", source: \"Warrior Of Light\" }\r\n2652.7 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# BLM/WHM\r\n2655.0 \"--sync--\" StartsUsing { id: \"4F73\", source: \"Warrior Of Light\" } window 5,5 jump 6002.4\r\n2658.0 \"Specter -> BLM/WHM\" #Ability { id: \"4F73\", source: \"Warrior Of Light\" }\r\n2663.4 \"--sync--\" StartsUsing { id: \"4F3D\", source: \"Spectral Black Mage\" } window 40,40 jump 6010.7\r\n\r\n# NIN\r\n2655.0 \"--sync--\" StartsUsing { id: \"4EF[56]\", source: \"Warrior Of Light\" } window 40,40 jump 8002.3\r\n2658.0 \"Stone/Holy -> NIN\" #Ability { id: \"4EF[56]\", source: \"Warrior Of Light\" }\r\n\r\n# SMN/WAR\r\n2655.0 \"--sync--\" StartsUsing { id: \"4EF[34]\", source: \"Warrior Of Light\" } window 40,40 jump 9002.3\r\n2658.0 \"Fire/Ice -> SMN/WAR\" #Ability { id: \"4EF[34]\", source: \"Warrior Of Light\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n\r\n### Phase 3a: NIN\r\n3517.3 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n3519.6 \"--sync--\" StartsUsing { id: \"4EF[56]\", source: \"Warrior Of Light\" }\r\n3522.6 \"Imbued Stone/Holy\" Ability { id: \"4EF[56]\", source: \"Warrior Of Light\" }\r\n3531.7 \"Specter Of Light\" Ability { id: \"4F37\", source: \"Warrior Of Light\" }\r\n3540.0 \"--sync--\" Ability { id: \"4F38\", source: \"Spectral Ninja\" }\r\n3547.1 \"--sync--\" Ability { id: \"4F39\", source: \"Spectral Ninja\" }\r\n3550.5 \"Solemn Confiteor\" Ability { id: \"4F0C\", source: \"Warrior Of Light\" }\r\n3554.1 \"Suiton: San\" Ability { id: \"4EFD\", source: \"Spectral Ninja\" }\r\n3557.2 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n3557.2 \"Katon: San\" Ability { id: \"4EFE\", source: \"Spectral Ninja\" }\r\n3558.0 \"--sync--\" Ability { id: \"531E\", source: \"Spectral Ninja\" }\r\n3566.6 \"Imbued Coruscance\" Ability { id: \"4F4[9A]\", source: \"Warrior Of Light\" }\r\n3575.7 \"Elddragon Dive\" Ability { id: \"4F0B\", source: \"Warrior Of Light\" }\r\n3589.0 \"The Bitter End\" Ability { id: \"4F0A\", source: \"Warrior Of Light\" }\r\n\r\n3596.3 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n3610.5 \"Quintuplecast\" Ability { id: \"4EEF\", source: \"Warrior Of Light\" }\r\n3613.7 \"Cast 1\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n3616.8 \"Cast 2\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n3619.9 \"Cast 3\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n3623.0 \"Cast 4\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n3626.1 \"Cast 5\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n3641.1 \"Shining Wave\" Ability { id: \"4F08\", source: \"Warrior Of Light\" }\r\n3642.3 \"Elddragon Dive\" Ability { id: \"4F0B\", source: \"Warrior Of Light\" }\r\n3652.6 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# BLM/WHM\r\n3654.9 \"--sync--\" StartsUsing { id: \"4F73\", source: \"Warrior Of Light\" } window 5,5 jump 6002.4\r\n3657.9 \"Specter -> BLM/WHM\" #Ability { id: \"4F73\", source: \"Warrior Of Light\" }\r\n3663.3 \"--sync--\" StartsUsing { id: \"4F3D\", source: \"Spectral Black Mage\" } window 40,40 jump 6010.7\r\n\r\n# DRK/BRD\r\n3654.9 \"--sync--\" StartsUsing { id: \"4F3[456]\", source: \"Warrior Of Light\" } window 5,5 jump 7002.2\r\n3657.9 \"Limit -> DRK/BRD\" #Ability { id: \"4F3[456]\", source: \"Warrior Of Light\" }\r\n3669.2 \"--sync--\" StartsUsing { id: \"4F43\", source: \"Warrior Of Light\" } window 40,40 jump 7016.6\r\n\r\n# SMN/WAR\r\n3654.9 \"--sync--\" StartsUsing { id: \"4EF[34]\", source: \"Warrior Of Light\" } window 40,40 jump 9002.3\r\n3657.9 \"Fire/Ice -> SMN/WAR\" #Ability { id: \"4EF[34]\", source: \"Warrior Of Light\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n### Phase 3a: SMN/WAR\r\n4517.4 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n4519.7 \"--sync--\" StartsUsing { id: \"4EF[34]\", source: \"Warrior Of Light\" }\r\n4522.7 \"Imbued Fire/Ice\" Ability { id: \"4EF[34]\", source: \"Warrior Of Light\" }\r\n4531.9 \"Specter Of Light\" Ability { id: \"4F37\", source: \"Warrior Of Light\" }\r\n4540.2 \"Summon\" Ability { id: \"4F3F\", source: \"Spectral Summoner\" }\r\n4554.4 \"Flare Breath\" Ability { id: \"4F40\", source: \"Spectral Summoner\" }\r\n4554.7 \"Perfect Decimation\" Ability { id: \"4F05\", source: [\"Spectral Warrior\", \"Warrior Of Light\"] }\r\n4554.9 \"Solemn Confiteor\" Ability { id: \"4F0C\", source: \"Warrior Of Light\" }\r\n4566.1 \"Solemn Confiteor\" Ability { id: \"4F0C\", source: \"Warrior Of Light\" }\r\n4566.5 \"Flare Breath\" Ability { id: \"4F40\", source: \"Spectral Summoner\" }\r\n4566.9 \"Perfect Decimation\" Ability { id: \"4F05\", source: [\"Spectral Warrior\", \"Warrior Of Light\"] }\r\n4568.2 \"--sync--\" Ability { id: \"531E\", source: \"Spectral Warrior\" }\r\n4572.4 \"--sync--\" Ability { id: \"531E\", source: \"Spectral Summoner\" }\r\n4572.8 \"Summon Wyrm\" Ability { id: \"4F41\", source: \"Warrior Of Light\" }\r\n4576.0 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n4583.1 \"Cauterize\" Ability { id: \"4F07\", source: \"Wyrm Of Light\" }\r\n4585.2 \"Imbued Coruscance\" Ability { id: \"4F4[9A]\", source: \"Warrior Of Light\" }\r\n4594.3 \"Elddragon Dive\" Ability { id: \"4F0B\", source: \"Warrior Of Light\" }\r\n4607.6 \"The Bitter End\" Ability { id: \"4F0A\", source: \"Warrior Of Light\" }\r\n\r\n4614.9 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n4629.1 \"Quintuplecast\" Ability { id: \"4EEF\", source: \"Warrior Of Light\" }\r\n4632.3 \"Cast 1\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n4635.4 \"Cast 2\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n4638.5 \"Cast 3\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n4641.6 \"Cast 4\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n4644.7 \"Cast 5\" Ability { id: \"4EF0\", source: \"Warrior Of Light\" }\r\n4659.7 \"Shining Wave\" Ability { id: \"4F08\", source: \"Warrior Of Light\" }\r\n4660.9 \"Elddragon Dive\" Ability { id: \"4F0B\", source: \"Warrior Of Light\" }\r\n4671.2 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# BLM/WHM\r\n4673.5 \"--sync--\" StartsUsing { id: \"4F73\", source: \"Warrior Of Light\" } window 5,5 jump 6002.4\r\n4676.5 \"Specter -> BLM/WHM\" #Ability { id: \"4F73\", source: \"Warrior Of Light\" }\r\n4681.9 \"--sync--\" StartsUsing { id: \"4F3D\", source: \"Spectral Black Mage\" } window 40,40 jump 6010.7\r\n\r\n# DRK/BRD\r\n4673.5 \"--sync--\" StartsUsing { id: \"4F3[456]\", source: \"Warrior Of Light\" } window 5,5 jump 7002.2\r\n4676.5 \"Limit -> DRK/BRD\" #Ability { id: \"4F3[456]\", source: \"Warrior Of Light\" }\r\n4687.8 \"--sync--\" StartsUsing { id: \"4F43\", source: \"Warrior Of Light\" } window 40,40 jump 7016.6\r\n\r\n# NIN\r\n4673.5 \"--sync--\" StartsUsing { id: \"4EF[56]\", source: \"Warrior Of Light\" } window 40,40 jump 8002.3\r\n4676.5 \"Stone/Holy -> NIN\" #Ability { id: \"4EF[56]\", source: \"Warrior Of Light\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n\r\n### Phase 3b: BLM/WHM\r\n6000.0 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n6002.4 \"--sync--\" StartsUsing { id: \"4F37\", source: \"Warrior Of Light\" }\r\n6005.4 \"Specter Of Light\" Ability { id: \"4F37\", source: \"Warrior Of Light\" }\r\n6008.6 \"--sync--\" StartsUsing { id: \"4F3[56]\", source: \"Warrior Of Light\" }\r\n6010.7 \"--sync--\" StartsUsing { id: \"4F3D\", source: \"Spectral Black Mage\" }\r\n6011.6 \"To The Limit\" Ability { id: \"4F3[456]\", source: \"Warrior Of Light\" }\r\n6013.7 \"Twincast\" Ability { id: \"4F3D\", source: \"Spectral Black Mage\" }\r\n6016.2 \"--sync--\" Ability { id: \"531E\", source: \"Spectral White Mage\" }\r\n6028.3 \"Meteor Impact 1\" #Ability { id: \"4F03\", source: \"Warrior Of Light\" }\r\n6030.3 \"Meteor Impact 2\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n6032.3 \"Meteor Impact 3\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n6034.3 \"Meteor Impact 4\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n6036.3 \"Meteor Impact 5\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n6038.3 \"Meteor Impact 6\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n6040.3 \"Meteor Impact 7\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n6040.8 \"Summon Wyrm\" Ability { id: \"4F41\", source: \"Warrior Of Light\" }\r\n6042.3 \"Meteor Impact 8\" #Ability { id: \"4F03\", source: \"Spectral Black Mage\" }\r\n6050.9 \"Coruscant Saber\" Ability { id: \"4EF[12]\", source: \"Warrior Of Light\" }\r\n6051.0 \"Cauterize\" Ability { id: \"4F07\", source: \"Wyrm Of Light\" }\r\n### TODO: This is random (note: bitter end gets moved up 0.5s if it's meteor)\r\n6063.1 \"Limit Break\" Ability { id: [\"4EFB\", \"53CB\", \"515C\"], source: \"Warrior Of Light\" }\r\n6075.9 \"--sync--\" StartsUsing { id: \"4F0A\", source: \"Warrior Of Light\" } window 10,10\r\n6080.9 \"The Bitter End\" Ability { id: \"4F0A\", source: \"Warrior Of Light\" }\r\n6084.1 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# DRK/BRD\r\n6086.4 \"--sync--\" StartsUsing { id: \"4F3[456]\", source: \"Warrior Of Light\" } window 5,5 jump 7002.2\r\n6089.4 \"Limit -> DRK/BRD\" #Ability { id: \"4F3[456]\", source: \"Warrior Of Light\" }\r\n6100.7 \"--sync--\" StartsUsing { id: \"4F43\", source: \"Warrior Of Light\" } window 40,40 jump 7016.6\r\n\r\n# NIN\r\n6086.4 \"--sync--\" StartsUsing { id: \"4EF[56]\", source: \"Warrior Of Light\" } window 40,40 jump 8002.3\r\n6089.4 \"Stone/Holy -> NIN\" #Ability { id: \"4EF[56]\", source: \"Warrior Of Light\" }\r\n\r\n# SMN/WAR\r\n6086.4 \"--sync--\" StartsUsing { id: \"4EF[34]\", source: \"Warrior Of Light\" } window 40,40 jump 9002.3\r\n6089.4 \"Fire/Ice -> SMN/WAR\" #Ability { id: \"4EF[34]\", source: \"Warrior Of Light\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n\r\n### Phase 3b: DRK/BRD\r\n7000.0 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n7002.2 \"--sync--\" StartsUsing { id: \"4F3[46]\", source: \"Warrior Of Light\" }\r\n7005.2 \"To The Limit\" Ability { id: \"4F3[456]\", source: \"Warrior Of Light\" }\r\n7013.4 \"Specter Of Light\" Ability { id: \"4F37\", source: \"Warrior Of Light\" }\r\n7016.6 \"--sync--\" StartsUsing { id: \"4F43\", source: \"Warrior Of Light\" }\r\n7019.6 \"--sync--\" Ability { id: \"4F43\", source: \"Warrior Of Light\" }\r\n7023.2 \"Solemn Confiteor\" Ability { id: \"4F0C\", source: \"Warrior Of Light\" }\r\n7026.8 \"Brimstone Earth\" Ability { id: \"4F3A\", source: \"Spectral Dark Knight\" }\r\n7030.1 \"--sync--\" Ability { id: \"531E\", source: \"Spectral Dark Knight\" }\r\n7031.1 \"Deluge Of Death\" Ability { id: \"4F3B\", source: \"Spectral Bard\" }\r\n7034.7 \"--sync--\" Ability { id: \"531E\", source: \"Spectral Bard\" }\r\n7039.3 \"Deluge Of Death\" Ability { id: \"4F02\", source: \"Spectral Bard\" }\r\n7039.3 \"Absolute Holy\" Ability { id: \"4F2B\", source: \"Warrior Of Light\" }\r\n7046.3 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n7054.6 \"Limit Break\" Ability { id: [\"4EFB\", \"53CB\", \"515C\"], source: \"Warrior Of Light\" }\r\n# TODO: guessing here\r\n7066.8 \"--sync--\" StartsUsing { id: \"4F0A\", source: \"Warrior Of Light\" } window 10,10\r\n7071.8 \"The Bitter End\" Ability { id: \"4F0A\", source: \"Warrior Of Light\" }\r\n7079.1 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# BLM/WHM\r\n7081.4 \"--sync--\" StartsUsing { id: \"4F73\", source: \"Warrior Of Light\" } window 5,5 jump 6002.4\r\n7084.4 \"Specter -> BLM/WHM\" #Ability { id: \"4F73\", source: \"Warrior Of Light\" }\r\n7089.8 \"--sync--\" StartsUsing { id: \"4F3D\", source: \"Spectral Black Mage\" } window 40,40 jump 6010.7\r\n\r\n# NIN\r\n7081.4 \"--sync--\" StartsUsing { id: \"4EF[56]\", source: \"Warrior Of Light\" } window 40,40 jump 8002.3\r\n7084.4 \"Stone/Holy -> NIN\" #Ability { id: \"4EF[56]\", source: \"Warrior Of Light\" }\r\n\r\n# SMN/WAR\r\n7081.4 \"--sync--\" StartsUsing { id: \"4EF[34]\", source: \"Warrior Of Light\" } window 40,40 jump 9002.3\r\n7084.4 \"Fire/Ice -> SMN/WAR\" #Ability { id: \"4EF[34]\", source: \"Warrior Of Light\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n### Phase 3b: NIN\r\n8000.0 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n8002.3 \"--sync--\" StartsUsing { id: \"4EF[56]\", source: \"Warrior Of Light\" }\r\n8005.3 \"Imbued Stone/Holy\" Ability { id: \"4EF[56]\", source: \"Warrior Of Light\" }\r\n8014.4 \"Specter Of Light\" Ability { id: \"4F37\", source: \"Warrior Of Light\" }\r\n8022.7 \"--sync--\" Ability { id: \"4F38\", source: \"Spectral Ninja\" }\r\n8029.8 \"--sync--\" Ability { id: \"4F39\", source: \"Spectral Ninja\" }\r\n8033.2 \"Solemn Confiteor\" Ability { id: \"4F0C\", source: \"Warrior Of Light\" }\r\n8036.8 \"Suiton: San \" Ability { id: \"4EFD\", source: \"Spectral Ninja\" }\r\n8039.8 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n8039.9 \"Katon: San \" Ability { id: \"4EFE\", source: \"Spectral Ninja\" }\r\n8040.7 \"--sync--\" Ability { id: \"531E\", source: \"Spectral Ninja\" }\r\n8049.1 \"Imbued Coruscance\" Ability { id: \"4F4[9A]\", source: \"Warrior Of Light\" }\r\n8058.2 \"Elddragon Dive\" Ability { id: \"4F0B\", source: \"Warrior Of Light\" }\r\n8071.5 \"The Bitter End\" Ability { id: \"4F0A\", source: \"Warrior Of Light\" }\r\n8074.7 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# BLM/WHM\r\n8077.0 \"--sync--\" StartsUsing { id: \"4F73\", source: \"Warrior Of Light\" } window 5,5 jump 6002.4\r\n8080.0 \"Specter -> BLM/WHM\" #Ability { id: \"4F73\", source: \"Warrior Of Light\" }\r\n8085.4 \"--sync--\" StartsUsing { id: \"4F3D\", source: \"Spectral Black Mage\" } window 40,40 jump 6010.7\r\n\r\n# DRK/BRD\r\n8077.0 \"--sync--\" StartsUsing { id: \"4F3[456]\", source: \"Warrior Of Light\" } window 5,5 jump 7002.2\r\n8080.0 \"Limit -> DRK/BRD\" #Ability { id: \"4F3[456]\", source: \"Warrior Of Light\" }\r\n8091.3 \"--sync--\" StartsUsing { id: \"4F43\", source: \"Warrior Of Light\" } window 40,40 jump 7016.6\r\n\r\n# SMN/WAR\r\n8077.0 \"--sync--\" StartsUsing { id: \"4EF[34]\", source: \"Warrior Of Light\" } window 40,40 jump 9002.3\r\n8080.0 \"Fire/Ice -> SMN/WAR\" #Ability { id: \"4EF[34]\", source: \"Warrior Of Light\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n\r\n### Phase 3b: SMN/WAR\r\n9000.0 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n9002.3 \"--sync--\" StartsUsing { id: \"4EF[34]\", source: \"Warrior Of Light\" }\r\n9005.3 \"Imbued Fire/Ice\" Ability { id: \"4EF[34]\", source: \"Warrior Of Light\" }\r\n9014.3 \"Specter Of Light\" Ability { id: \"4F37\", source: \"Warrior Of Light\" }\r\n9022.6 \"Summon\" Ability { id: \"4F3F\", source: \"Spectral Summoner\" }\r\n9036.7 \"Flare Breath\" Ability { id: \"4F40\", source: \"Spectral Summoner\" }\r\n9037.0 \"Perfect Decimation\" Ability { id: \"4F05\", source: [\"Spectral Warrior\", \"Warrior Of Light\"] }\r\n9037.2 \"Solemn Confiteor\" Ability { id: \"4F0C\", source: \"Warrior Of Light\" }\r\n9048.5 \"Solemn Confiteor\" Ability { id: \"4F0C\", source: \"Warrior Of Light\" }\r\n9048.8 \"Flare Breath\" Ability { id: \"4F40\", source: \"Spectral Summoner\" }\r\n9049.2 \"Perfect Decimation\" Ability { id: \"4F05\", source: [\"Spectral Warrior\", \"Warrior Of Light\"] }\r\n9050.8 \"--sync--\" Ability { id: \"531E\", source: \"Spectral Warrior\" }\r\n9054.8 \"--sync--\" Ability { id: \"531E\", source: \"Spectral Summoner\" }\r\n9055.2 \"Summon Wyrm\" Ability { id: \"4F41\", source: \"Warrior Of Light\" }\r\n9058.4 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n9065.5 \"Cauterize\" Ability { id: \"4F07\", source: \"Wyrm Of Light\" }\r\n9067.8 \"Imbued Coruscance\" Ability { id: \"4F4[9A]\", source: \"Warrior Of Light\" }\r\n9076.9 \"Elddragon Dive\" Ability { id: \"4F0B\", source: \"Warrior Of Light\" }\r\n9090.2 \"The Bitter End\" Ability { id: \"4F0A\", source: \"Warrior Of Light\" }\r\n9093.4 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# BLM/WHM\r\n9095.7 \"--sync--\" StartsUsing { id: \"4F73\", source: \"Warrior Of Light\" } window 5,5 jump 6002.4\r\n9098.7 \"Specter -> BLM/WHM\" #Ability { id: \"4F73\", source: \"Warrior Of Light\" }\r\n9104.1 \"--sync--\" StartsUsing { id: \"4F3D\", source: \"Spectral Black Mage\" } window 40,40 jump 6010.7\r\n\r\n# DRK/BRD\r\n9095.7 \"--sync--\" StartsUsing { id: \"4F3[456]\", source: \"Warrior Of Light\" } window 5,5 jump 7002.2\r\n9098.7 \"Limit -> DRK/BRD\" #Ability { id: \"4F3[456]\", source: \"Warrior Of Light\" }\r\n9110.0 \"--sync--\" StartsUsing { id: \"4F43\", source: \"Warrior Of Light\" } window 40,40 jump 7016.6\r\n\r\n# NIN\r\n9095.7 \"--sync--\" StartsUsing { id: \"4EF[56]\", source: \"Warrior Of Light\" } window 40,40 jump 8002.3\r\n9098.7 \"Stone/Holy -> NIN\" #Ability { id: \"4EF[56]\", source: \"Warrior Of Light\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/wol.ts



const wol_triggerSet = {
  id: 'TheSeatOfSacrifice',
  zoneId: zone_id/* default.TheSeatOfSacrifice */.Z.TheSeatOfSacrifice,
  timelineFile: 'wol.txt',
  timelineTriggers: [{
    id: 'WOL Ultimate Crossover',
    regex: /Ultimate Crossover/,
    beforeSeconds: 8,
    condition: data => data.role === 'tank' || data.job === 'BLU',
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Limit break now!',
        de: 'Limit break jetzt!',
        fr: 'Transcendance maintenant !',
        ja: 'タンクLBを！',
        cn: '坦克LB！',
        ko: '리미트 브레이크!'
      }
    }
  }, {
    id: 'WOL Twincast Towers',
    regex: /Meteor Impact 1/,
    beforeSeconds: 10,
    durationSeconds: 8,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '장판 들어가기'
      }
    }
  }],
  triggers: [{
    id: 'WOL Terror Unleashed',
    type: 'Ability',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F27',
      capture: false
    },
    condition: data => data.role === 'healer' || data.job === 'BLU',
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Full Heal Everyone',
        de: 'Alle voll heilen',
        fr: 'Soignez tout le monde complètement',
        ja: 'HPを満タンに！',
        cn: '奶满全队',
        ko: '전원 체력 풀피로'
      }
    }
  }, {
    id: 'WOL Coruscant Saber In',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F11',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'WOL Coruscant Saber Out',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F10',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut('info')
  }, {
    id: 'WOL Absolute Blizzard III',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F2D',
      capture: false
    },
    response: responses/* Responses.moveAround */.n3.moveAround('alert')
  }, {
    id: 'WOL Absolute Fire III',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F2E',
      capture: false
    },
    // I mean, stop if you want, I guess?
    response: responses/* Responses.stopEverything */.n3.stopEverything('info')
  }, {
    id: 'WOL Imbued Absolute Blizzard III',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F13',
      capture: false
    },
    run: data => data.imbued = 'blizzard'
  }, {
    id: 'WOL Imbued Absolute Fire III',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F12',
      capture: false
    },
    run: data => data.imbued = 'fire'
  }, {
    id: 'WOL Imbued Coruscance Out',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F4B',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.imbued === 'blizzard') return output.outMove();else if (data.imbued === 'fire') return output.outStop();
      return output.out();
    },
    outputStrings: {
      outMove: {
        en: 'Out => Move',
        de: 'Raus => Bewegen',
        fr: 'Extérieur => Bougez',
        ja: '外 => 動け',
        cn: '钢铁 => 动动动',
        ko: '밖으로 => 움직이기'
      },
      outStop: {
        en: 'Out => Stop',
        de: 'Raus => Nichts machen',
        fr: 'Extérieur => Stoppez tout',
        ja: '外 => 動かない',
        cn: '钢铁 => 停停停',
        ko: '밖으로 => 멈추기'
      },
      out: {
        en: 'Out => ???',
        de: 'Raus => ???',
        fr: 'Extérieur => ???',
        ja: '外 => ???',
        cn: '钢铁 => ？？？',
        ko: '밖으로 => ???'
      }
    }
  }, {
    id: 'WOL Imbued Coruscance In',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F4C',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.imbued === 'blizzard') return output.underMove();else if (data.imbued === 'fire') return output.underStop();
      return output.under();
    },
    outputStrings: {
      underMove: {
        en: 'Under => Move',
        de: 'Runter => Bewegen',
        fr: 'Intérieur => Bougez',
        ja: '中 => 動け',
        cn: '月环 => 动动动',
        ko: '안으로 => 움직이기'
      },
      underStop: {
        en: 'Under => Stop',
        de: 'Runter => Nichts machen',
        fr: 'Intérieur => Stoppez tout',
        ja: '中 => 動かない',
        cn: '月环 => 停停停',
        ko: '안으로 => 멈추기'
      },
      under: {
        en: 'Under => ???',
        de: 'Runter => ???',
        fr: 'Intérieur => ???',
        ja: '中 => ???',
        cn: '月环 => ？？？',
        ko: '안으로 => ???'
      }
    }
  }, {
    id: 'WOL Sword Of Light',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F42',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out of Triangle',
        de: 'Raus aus den Dreiecken',
        fr: 'Sortez du triangle',
        ja: '三角の外へ',
        cn: '站在三角外面',
        ko: '삼각형 밖으로'
      }
    }
  }, {
    id: 'WOL Summon Wyrm',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F41',
      capture: false
    },
    delaySeconds: 6,
    // This applies to both phases.  We could say something like "go side without wyrm" and
    // "go to corner without wyrm", but "avoid wyrm dash" covers both.  Hopefully it's obvious
    // not to stand in the giant black circle.
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Wyrm Dash',
        de: 'Wyrm-Ansturm ausweichen',
        fr: 'Évitez la charge du Wyrm',
        ja: '竜を避ける',
        cn: '躲避巴哈冲锋',
        ko: '용 돌진 피하기'
      }
    }
  }, {
    id: 'WOL Bitter End',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F28'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'WOL Elddragon Dive',
    type: 'StartsUsing',
    netRegex: {
      source: 'Warrior Of Light',
      id: '4F29',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'WOL Deluge of Death Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '0057'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    run: (data, matches) => data.deluge = matches.target,
    outputStrings: {
      text: {
        en: 'GTFO',
        de: 'GTFO',
        fr: 'Éloignez-vous',
        ja: '出ていく！',
        cn: '快出去！',
        ko: '진영 벗어나기!'
      }
    }
  }, {
    id: 'WOL Deluge of Death Cleanup',
    type: 'HeadMarker',
    netRegex: {
      id: '0057',
      capture: false
    },
    delaySeconds: 10,
    run: data => {
      // Clean this up so it doesn't apply during Katon San.
      delete data.deluge;
    }
  }, {
    // Both for Absolute Holy and Katon San
    id: 'WOL Absolute Holy Katon San',
    type: 'HeadMarker',
    netRegex: {
      id: '00A1'
    },
    condition: data => data.deluge !== data.me,
    delaySeconds: 0.5,
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'WOL Radiant Braver',
    type: 'HeadMarker',
    netRegex: {
      id: '00EA'
    },
    response: responses/* Responses.earthshaker */.n3.earthshaker()
  }, {
    id: 'WOL Radiant Desperado',
    type: 'StartsUsing',
    // There are two single target 4F46 lines to indicate who the stacks
    // are on, that come slightly after this starts casting.
    netRegex: {
      source: 'Warrior Of Light',
      id: '515D',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack Groups',
        de: 'Gruppen stacken',
        fr: 'Packages de groupes',
        ja: '集合',
        cn: '集合',
        ko: '쉐어징 모이기'
      }
    }
  }, {
    id: 'WOL Radiant Meteor',
    type: 'HeadMarker',
    netRegex: {
      id: '00E9'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to Corner',
        de: 'In die Ecken gehenr',
        fr: 'Allez dans un coin',
        ja: 'コーナーへ',
        cn: '去角落',
        ko: '구석으로'
      }
    }
  }, {
    id: 'WOL Suiton San',
    type: 'Ability',
    netRegex: {
      source: 'Spectral Ninja',
      id: '4F38',
      capture: false
    },
    delaySeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'WOL Spectral Egi Flare Breath',
    type: 'Tether',
    netRegex: {
      source: 'Spectral Egi',
      id: '0011'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Point tether outside',
        de: 'Verbindungen nach Außen zeigen',
        fr: 'Pointez le lien vers l\'extérieur',
        ja: '線を外に引く',
        cn: '把线拉向场外',
        ko: '선 연결 바깥으로 빼기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Spectral Bard': 'Phantom-Barde',
      'Spectral Black Mage': 'Phantom-Schwarzmagier',
      'Spectral Dark Knight': 'Phantom-Dunkelritter',
      'Spectral Egi': 'Phantom-Primae',
      'Spectral Ninja': 'Phantom-Ninja',
      'Spectral Summoner': 'Phantom-Beschwörer',
      'Spectral Warrior': 'Phantom-Berserker',
      'Warrior Of Light': 'Krieger des Lichts',
      'Wyrm Of Light': 'Wyrm des Lichts'
    },
    'replaceText': {
      '--active time event--': '--Aktives Zeitevent--',
      'Absolute Blizzard III': 'Absolutes Eisga',
      'Absolute Fire III': 'Absolutes Feuga',
      'Absolute Fire/Blizzard': 'Absolutes Feuga/Eisga',
      'Absolute Holy': 'Absolutes Sanctus',
      'Absolute Teleport': 'Absoluter Teleport',
      'Ascendance': 'Himmelstanz',
      'Brimstone Earth': 'Schwefelerde',
      'Cauterize': 'Kauterisieren',
      'Coruscant Saber': 'Gleißender Säbel',
      'Deluge Of Death': 'Tödlicher Sturzregen',
      'Elddragon Dive': 'Drachensturz',
      'Flare Breath': 'Flare-Atem',
      'Imbued Coruscance': 'Magieklingentechnik: Gleißender Säbel',
      'Imbued Fire/Blizzard': 'Magieklinge Feuga/Eisga',
      'Katon: San': 'Katon: San',
      'Meteor Impact': 'Meteoreinschlag',
      'Perfect Decimation': 'Perfektes Dezimieren',
      'Radiant Braver': 'Gleißende Gerechtigkeit',
      'Radiant Desperado': 'Gleißender Desperado',
      'Radiant Meteor': 'Gleißender Meteor',
      'Shining Wave': 'Leuchtwelle',
      'Solemn Confiteor': 'Feierlicher Confiteor',
      'Specter Of Light': 'Heldenruf',
      'Suiton: San': 'Suiton: San',
      'Summon(?! Wyrm)': 'Beschwörung',
      'Summon Wyrm': 'Drachenbeschwörung',
      'Sword Of Light': 'Schwert des Lichts',
      'Terror Unleashed': 'Entfesselter Terror',
      'The Bitter End': 'Schwertschimmer',
      'To The Limit': 'Bis ans Limit',
      'Twincast': 'Dualzauber',
      'Ultimate Crossover': 'Ultimative Kreuzigung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Spectral Bard': 'barde spectral',
      'Spectral Black Mage': 'mage noir spectral',
      'Spectral Dark Knight': 'chevalier noir spectral',
      'Spectral Egi': 'Egi spectral',
      'Spectral Ninja': 'ninja spectral',
      'Spectral Summoner': 'invocatrice spectrale',
      'Spectral Warrior': 'berserker spectral',
      'Warrior Of Light': 'Guerrier de la Lumière primordial',
      'Wyrm Of Light': 'wyrm de Lumière'
    },
    'replaceText': {
      '--active time event--': '--temps d\'évènement actif--',
      'Absolute Blizzard III': 'Méga Glace absolue',
      'Absolute Fire/Blizzard': 'Méga Feu/Glace absolue',
      'Absolute Fire III': 'Méga Feu absolu',
      'Absolute Holy': 'Miracle absolu',
      'Absolute Teleport': 'Téléportation absolue',
      'Ascendance': 'Ascendance',
      'Brimstone Earth': 'Terre de soufre',
      'Cauterize': 'Cautérisation',
      'Coruscant Saber': 'Fureur flamboyante',
      'Deluge Of Death': 'Averse mortelle',
      'Elddragon Dive': 'Piqué du dragon ancien',
      'Flare Breath': 'Souffle brasier',
      'Imbued Coruscance': 'Magilame Fureur flamboyante',
      'Imbued Fire/Blizzard': 'Magilame Méga Feu/Glace',
      'Katon: San': 'Katon : San',
      'Meteor Impact': 'Impact de météore',
      'Perfect Decimation': 'Décimation parfaite',
      'Radiant Braver': 'Âme brave flamboyante',
      'Radiant Desperado': 'Desperado flamboyant',
      'Radiant Meteor': 'Météore flamboyant',
      'Shining Wave': 'Épée flamboyante',
      'Solemn Confiteor': 'Confiteor solennel',
      'Specter Of Light': 'Sommation des braves',
      'Suiton: San': 'Suiton : San',
      'Summon(?! Wyrm)': 'Invocation',
      'Summon Wyrm': 'Invocation de wyrm',
      'Sword Of Light': 'Lame de Lumière',
      'Terror Unleashed': 'Déchaînement de la terreur',
      'The Bitter End': 'Éradication',
      'To The Limit': 'Pas vers la transcendance',
      'Twincast': 'Tandem',
      'Ultimate Crossover': 'Taillade croisée ultime'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Spectral Bard': '幻光の吟遊詩人',
      'Spectral Black Mage': '幻光の黒魔道士',
      'Spectral Dark Knight': '幻光の暗黒騎士',
      'Spectral Egi': '幻光の召喚獣',
      'Spectral Ninja': '幻光の忍者',
      'Spectral Summoner': '幻光の召喚士',
      'Spectral Warrior': '幻光の狂戦士',
      'Warrior Of Light': 'ウォーリア・オブ・ライト',
      'Wyrm Of Light': 'ウィルム・オブ・ライト'
    },
    'replaceText': {
      '--active time event--': '--QTE--',
      'Absolute Blizzard III': 'アブソリュートブリザガ',
      'Absolute Fire III': 'アブソリュートファイガ',
      'Absolute Fire/Blizzard': 'アブソリュート ファイガ／ブリザガ',
      'Absolute Holy': 'アブソリュートホーリー',
      'Absolute Teleport': 'アブソリュートテレポ',
      'Ascendance': 'アセンダンス',
      'Brimstone Earth': 'ブリムストーンアース',
      'Cauterize': 'カータライズ',
      'Coruscant Saber': 'ブライトセイバー',
      'Deluge Of Death': 'ヘビーレイン・オブ・デス',
      'Elddragon Dive': 'エンシェントドラゴンダイブ',
      'Flare Breath': 'フレアブレス',
      'Imbued Coruscance': '魔法剣技：ブライトセイバー',
      'Imbued Fire/Blizzard': '魔法剣アブソリュート ファイガ／ブリザガ',
      'Katon: San': '火遁の術：参',
      'Meteor Impact': 'メテオインパクト',
      'Perfect Decimation': 'パーフェクトデシメート',
      'Radiant Braver': 'ブライトブレイバー',
      'Radiant Desperado': 'ブライトデスペラード',
      'Radiant Meteor': 'ブライトメテオ',
      'Shining Wave': 'シャイニングウェーブ',
      'Solemn Confiteor': 'ソーレムコンフィテオル',
      'Specter Of Light': '幻光召喚',
      'Suiton: San': '水遁の術：参',
      'Summon(?! Wyrm)': '召喚',
      'Summon Wyrm': 'サモン・ウィルム',
      'Sword Of Light': 'ソード・オブ・ライト',
      'Terror Unleashed': 'アンリーシュ・テラー',
      'The Bitter End': 'エンドオール',
      'To The Limit': 'リミットチャージ',
      'Twincast': 'ふたりがけ',
      'Ultimate Crossover': 'アルティメット・クロスオーバー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Spectral Bard': '幻光吟游诗人',
      'Spectral Black Mage': '幻光黑魔法师',
      'Spectral Dark Knight': '幻光暗黑骑士',
      'Spectral Egi': '幻光召唤兽',
      'Spectral Ninja': '幻光忍者',
      'Spectral Summoner': '幻光召唤师',
      'Spectral Warrior': '幻光狂战士',
      'Warrior Of Light': '光之战士',
      'Wyrm Of Light': '光之真龙'
    },
    'replaceText': {
      '--active time event--': '--XJB按--',
      'Absolute Blizzard III': '绝对冰封',
      'Absolute Fire III': '绝对爆炎',
      'Absolute Fire/Blizzard': '绝对爆炎/绝对冰封',
      'Absolute Holy': '绝对神圣',
      'Absolute Teleport': '绝对传送',
      'Ascendance': '生辰星位',
      'Brimstone Earth': '狱火大地',
      'Cauterize': '灼热俯冲',
      'Coruscant Saber': '光明利剑',
      'Deluge Of Death': '死亡暴雨',
      'Elddragon Dive': '远古龙炎冲',
      'Flare Breath': '核爆吐息',
      'Imbued Coruscance': '魔法剑技·光明利剑',
      'Imbued Fire/Blizzard': '魔法剑·绝对爆炎/绝对冰封',
      'Katon: San': '叁式火遁之术',
      'Meteor Impact': '陨石冲击',
      'Perfect Decimation': '完美地毁人亡',
      'Radiant Braver': '光之勇猛烈斩',
      'Radiant Desperado': '光之亡命暴徒',
      'Radiant Meteor': '光之陨石流星',
      'Shining Wave': '光芒波动',
      'Solemn Confiteor': '庄严悔罪',
      'Specter Of Light': '幻光召唤',
      'Suiton: San': '叁式水遁之术',
      'Summon(?! Wyrm)': '召唤',
      'Summon Wyrm': '真龙召唤',
      'Sword Of Light': '光之剑',
      'Terror Unleashed': '恐惧释放',
      'The Bitter End': '尽灭',
      'To The Limit': '突破极限',
      'Twincast': '合力咏唱',
      'Ultimate Crossover': '究极·交汇'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Warrior Of Light': '빛의 전사',
      'Spectral Bard': '환상빛의 음유시인',
      'Spectral Black Mage': '환상빛의 흑마도사',
      'Spectral Dark Knight': '환상빛의 암흑기사',
      'Spectral Egi': '환상빛의 소환수',
      'Spectral Ninja': '환상빛의 닌자',
      'Spectral Summoner': '환상빛의 소환사',
      'Spectral Warrior': '환상빛의 전사',
      'Wyrm Of Light': '빛의 비룡'
    },
    'replaceText': {
      '--active time event--': '--긴급 조작--',
      'Summon(?! Wyrm)': '소환',
      'Absolute Blizzard III': '앱솔루트 블리자가',
      'Absolute Fire III': '앱솔루트 파이가',
      'Absolute Holy': '앱솔루트 홀리',
      'Absolute Teleport': '앱솔루트 텔레포',
      'Ascendance': '상승세',
      'Brimstone Earth': '유황 지대',
      'Cauterize': '인두질',
      'Coruscant Saber': '빛나는 도검',
      'Deluge Of Death': '죽음의 화살 폭우',
      'Elddragon Dive': '고룡 강타',
      'Flare Breath': '타오르는 숨결',
      'Imbued Coruscance': '마법검: 빛나는 도검',
      'Imbued Fire/Blizzard': '마법검 파이가/블리자가',
      'Absolute Fire/Blizzard': '앱솔루트 파이가/블리자가',
      'Katon: San': '화둔술 3',
      'Meteor Impact': '운석 낙하',
      'Perfect Decimation': '완전 섬멸',
      'Radiant Braver': '빛나는 브레이버',
      'Radiant Desperado': '빛나는 무법자',
      'Radiant Meteor': '빛나는 메테오',
      'Shining Wave': '찬란한 파동',
      'Solemn Confiteor': '엄숙한 기도',
      'Specter Of Light': '환상빛 소환',
      'Suiton: San': '수둔술 3',
      'Summon Wyrm': '비룡 소환',
      'Sword Of Light': '빛의 검',
      'Terror Unleashed': '공포 촉발',
      'The Bitter End': '파국',
      'To The Limit': '리미트 축적',
      'Twincast': '합동 시전',
      'Ultimate Crossover': '궁극의 협력기'
    }
  }]
};
/* harmony default export */ const wol = (wol_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/trial/wol.txt
const trial_wol_namespaceObject = "### Warrior of Light (normal)\r\n#\r\n# -ii 4F43 4F0E 4F0F 4F3C 531E 4F3A 4F1F 4F0D 4F16 4F17 4F18 4F19 4F1B 4F48 5251 4F23 5417\r\n# -p 4F27:9.3 547C:306.8 -it \"Warrior Of Light\"\r\n\r\nhideall \"--sync--\"\r\nhideall \"--Reset--\"\r\n\r\n### Phase 1: 100%->50%\r\n# Note: Don't sync on engage or auto here because there's a checkpoint.\r\n\r\n0.0 \"Start\"\r\n5.2 \"--sync--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" } window 20,20 jump 475.4\r\n6.3 \"--sync--\" StartsUsing { id: \"4F27\", source: \"Warrior Of Light\" } window 10,10\r\n9.3 \"Terror Unleashed\" Ability { id: \"4F27\", source: \"Warrior Of Light\" }\r\n25.1 \"Solemn Confiteor\" Ability { id: \"4F2A\", source: \"Warrior Of Light\" }\r\n31.6 \"Coruscant Saber (In)\" Ability { id: \"4F11\", source: \"Warrior Of Light\" }\r\n42.7 \"Coruscant Saber (Out)\" Ability { id: \"4F10\", source: \"Warrior Of Light\" }\r\n51.9 \"Absolute Fire III\" Ability { id: \"4F2E\", source: \"Warrior Of Light\" }\r\n65.2 \"Absolute Blizzard III\" Ability { id: \"4F2D\", source: \"Warrior Of Light\" }\r\n\r\n76.5 \"Imbued Fire/Blizzard\" Ability { id: \"4F1[23]\", source: \"Warrior Of Light\" }\r\n89.6 \"Imbued Coruscance\" Ability { id: \"4F4[BC]\", source: \"Warrior Of Light\" }\r\n\r\n101.9 \"Sword Of Light\" Ability { id: \"4F42\", source: \"Warrior Of Light\" }\r\n115.2 \"Summon Wyrm\" Ability { id: \"4F41\", source: \"Warrior Of Light\" }\r\n120.1 \"Shining Wave\" Ability { id: \"4F26\", source: \"Warrior Of Light\" }\r\n125.4 \"Cauterize\" Ability { id: \"4F25\", source: \"Wyrm Of Light\" }\r\n131.4 \"The Bitter End\" Ability { id: \"4F28\", source: \"Warrior Of Light\" }\r\n139.5 \"Elddragon Dive\" Ability { id: \"4F29\", source: \"Warrior Of Light\" }\r\n153.1 \"Imbued Fire/Blizzard\" Ability { id: \"4F1[23]\", source: \"Warrior Of Light\" }\r\n# FIXME: guessing here on timing\r\n166.2 \"Imbued Coruscance\" Ability { id: \"4F4[BC]\", source: \"Warrior Of Light\" }\r\n# FIXME: missing an elddragon dive too??\r\n# FIXME: need a natural push\r\n\r\n### Cutscene: 50%\r\n300.0 \"--sync--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n302.3 \"--sync--\" StartsUsing { id: \"5331\", source: \"Warrior Of Light\" } window 400,100\r\n308.3 \"Ascendance\" Ability { id: \"5331\", source: \"Warrior Of Light\" }\r\n311.4 \"--untargetable--\"\r\n311.5 \"--sync--\" Ability { id: \"5071\", source: \"Warrior Of Light\" }\r\n319.6 \"Absolute Teleport\" Ability { id: \"5332\", source: \"Warrior Of Light\" }\r\n324.3 \"--sync--\" Ability { id: \"5083\", source: \"Warrior Of Light\" }\r\n346.0 \"--active time event--\" duration 15\r\n447.1 \"--sync--\" Ability { id: \"5383\", source: \"Warrior Of Light\" }\r\n457.1 \"--sync--\" Ability { id: \"547B\", source: \"Warrior Of Light\" }\r\n463.2 \"Ultimate Crossover\" Ability { id: \"547C\", source: \"Warrior Of Light\" }\r\n\r\n### Phase 2: Checkpoint, 50%->0%\r\n# Can't sync any of these things back to t=0 because they all appear in phase 1.\r\n# Phase 1 includes a jump to the middle line to sync.\r\n470.2 \"--targetable--\"\r\n475.4 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n480.8 \"Imbued Fire/Blizzard\" Ability { id: \"4F1[23]\", source: \"Warrior Of Light\" }\r\n\r\n490.0 \"Specter Of Light\" Ability { id: \"4F37\", source: \"Warrior Of Light\" } window 491,10\r\n500.4 \"Twincast\" Ability { id: \"4F3D\", source: \"Spectral Black Mage\" }\r\n515.0 \"Meteor Impact 1\" #Ability { id: \"4F21\", source: \"Spectral Black Mage\" }\r\n518.0 \"Meteor Impact 2\" #Ability { id: \"4F21\", source: \"Spectral Black Mage\" }\r\n521.0 \"Meteor Impact 3\" #Ability { id: \"4F21\", source: \"Spectral Black Mage\" }\r\n524.0 \"Meteor Impact 4\" #Ability { id: \"4F21\", source: \"Spectral Black Mage\" }\r\n528.2 \"Imbued Coruscance\" Ability { id: \"4F4[BC]\", source: \"Warrior Of Light\" }\r\n\r\n537.3 \"Elddragon Dive\" Ability { id: \"4F29\", source: \"Warrior Of Light\" }\r\n547.6 \"Summon Wyrm\" Ability { id: \"4F41\", source: \"Warrior Of Light\" }\r\n551.7 \"Brimstone Earth\" Ability { id: \"4F1E\", source: \"Spectral Dark Knight\" }\r\n555.9 \"Deluge Of Death\" Ability { id: \"4F3B\", source: \"Spectral Bard\" }\r\n557.8 \"Cauterize\" Ability { id: \"4F25\", source: \"Wyrm Of Light\" }\r\n566.0 \"Deluge Of Death\" Ability { id: \"4F20\", source: \"Spectral Bard\" }\r\n566.0 \"Absolute Holy\" Ability { id: \"4F2B\", source: \"Warrior Of Light\" }\r\n575.9 \"The Bitter End\" Ability { id: \"4F28\", source: \"Warrior Of Light\" }\r\n582.2 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n\r\n587.5 \"To The Limit 1\" Ability { id: \"4F34\", source: \"Warrior Of Light\" }\r\n598.7 \"Radiant Braver\" Ability { id: \"5254\", source: \"Warrior Of Light\" }\r\n\r\n605.1 \"To The Limit 2\" Ability { id: \"4F35\", source: \"Warrior Of Light\" }\r\n610.4 \"--sync--\" Ability { id: \"4F46\", source: \"Warrior Of Light\" }\r\n616.3 \"Radiant Desperado\" Ability { id: \"515D\", source: \"Warrior Of Light\" }\r\n\r\n628.0 \"To The Limit 3\" Ability { id: \"4F36\", source: \"Warrior Of Light\" }\r\n639.1 \"Radiant Meteor\" Ability { id: \"4F1A\", source: \"Warrior Of Light\" }\r\n\r\n650.4 \"Sword Of Light\" Ability { id: \"4F42\", source: \"Warrior Of Light\" }\r\n668.6 \"Shining Wave\" Ability { id: \"4F26\", source: \"Warrior Of Light\" }\r\n\r\n670.7 \"Absolute Fire/Blizzard\" Ability { id: \"4F2[DE]\", source: \"Warrior Of Light\" }\r\n678.9 \"Elddragon Dive\" Ability { id: \"4F29\", source: \"Warrior Of Light\" }\r\n683.1 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n688.3 \"Imbued Fire/Blizzard\" Ability { id: \"4F1[23]\", source: \"Warrior Of Light\" }\r\n\r\n697.5 \"Specter Of Light\" Ability { id: \"4F37\", source: \"Warrior Of Light\" }\r\n706.9 \"--sync--\" Ability { id: \"4F38\", source: \"Spectral Ninja\" }\r\n714.0 \"--sync--\" Ability { id: \"4F39\", source: \"Spectral Ninja\" }\r\n717.0 \"Suiton: San\" Ability { id: \"4F1C\", source: \"Spectral Ninja\" }\r\n718.8 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" }\r\n722.1 \"Katon: San\" Ability { id: \"4F1D\", source: \"Spectral Ninja\" }\r\n\r\n727.0 \"Summon\" Ability { id: \"4F3F\", source: \"Spectral Summoner\" }\r\n727.9 \"Imbued Coruscance\" Ability { id: \"4F4[BC]\", source: \"Warrior Of Light\" }\r\n\r\n738.6 \"Solemn Confiteor\" Ability { id: \"4F2A\", source: \"Warrior Of Light\" }\r\n743.3 \"Flare Breath\" Ability { id: \"4F24\", source: \"Spectral Egi\" }\r\n752.4 \"The Bitter End\" Ability { id: \"4F28\", source: \"Warrior Of Light\" }\r\n756.1 \"Perfect Decimation\" Ability { id: \"4F3E\", source: \"Spectral Warrior\" }\r\n\r\n760.6 \"Absolute Fire/Blizzard\" Ability { id: \"4F2[DE]\", source: \"Warrior Of Light\" }\r\n761.0 \"Perfect Decimation\" Ability { id: \"4F23\", source: \"Spectral Warrior\" }\r\n772.8 \"Elddragon Dive\" Ability { id: \"4F29\", source: \"Warrior Of Light\" }\r\n\r\n786.2 \"--middle--\" Ability { id: \"4F45\", source: \"Warrior Of Light\" } window 50,50 jump 475.4\r\n791.6 \"Imbued Fire/Blizzard\" #Ability { id: \"4F1[23]\", source: \"Warrior Of Light\" }\r\n\r\n800.8 \"Specter Of Light\" #Ability { id: \"4F37\", source: \"Warrior Of Light\" }\r\n811.2 \"Twincast\" #Ability { id: \"4F3D\", source: \"Spectral Black Mage\" }\r\n825.8 \"Meteor Impact 1\" #Ability { id: \"4F21\", source: \"Spectral Black Mage\" }\r\n828.8 \"Meteor Impact 2\" #Ability { id: \"4F21\", source: \"Spectral Black Mage\" }\r\n831.8 \"Meteor Impact 3\" #Ability { id: \"4F21\", source: \"Spectral Black Mage\" }\r\n834.8 \"Meteor Impact 4\" #Ability { id: \"4F21\", source: \"Spectral Black Mage\" }\r\n839.0 \"Imbued Coruscance\" #Ability { id: \"4F4[BC]\", source: \"Warrior Of Light\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/ultimate/the_epic_of_alexander.ts




// TODO: Future network data mining opportunities.
// These don't show up in the log (yet??):
// * inception orb tethers (likely some "new combatant" flag, like suzex birbs?)
// * escape/contact regulator/prohibition headmarkers

// Due to changes introduced in patch 5.2, overhead markers now have a random offset
// added to their ID. This offset currently appears to be set per instance, so
// we can determine what it is from the first overhead marker we see.
const the_epic_of_alexander_getHeadmarkerId = (data, matches) => {
  // If we naively just check !data.decOffset and leave it, it breaks if the first marker is 004F.
  // (This makes the offset 0, and !0 is true.)
  if (typeof data.decOffset === 'undefined') {
    // The first 1B marker in the encounter is Limit Cut 1, ID 004F.
    data.decOffset = parseInt(matches.id, 16) - 79;
  }
  // The leading zeroes are stripped when converting back to string, so we re-add them here.
  // Fortunately, we don't have to worry about whether or not this is robust,
  // since we know all the IDs that will be present in the encounter.
  return `00${(parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase()}`;
};
const kDecreeNisi = ['8AE', '8AF', '859', '85A'];
const kFinalJudgementNisi = ['8B0', '8B1', '85B', '85C'];
const nisiToString = (nisiNum, output) => {
  // nisiNum is 0-3
  // assume output is using nisiTypes.
  switch (nisiNum) {
    case 0:
      return output.blueAlpha();
    case 1:
      return output.orangeBeta();
    case 2:
      return output.purpleGamma();
    case 3:
      return output.greenDelta();
  }
};
const resetState = data => {
  data.enumerations = [];
  data.buffMap = {};
  data.tetherBois = {};
  data.vuln = {};
  delete data.limitCutNumber;
  delete data.limitCutDelay;
};
const ordainedOutputStrings = {
  combined: {
    en: '${action1}, ${action2}',
    de: '${action1}, ${action2}',
    fr: '${action1}, ${action2}',
    ja: '${action1}, ${action2}',
    cn: '${action1}, ${action2}',
    ko: '${action1}, ${action2}'
  },
  motionFirst: {
    en: 'Motion first',
    de: 'Bewegungsbefehl zuerst',
    fr: 'Mouvement en premier',
    ja: '最初は動く',
    cn: '首先移动',
    ko: '우선 움직이기'
  },
  stillnessFirst: {
    en: 'Stillness first',
    de: 'Stillstandsbefehl zuerst',
    fr: 'Immobilité en premier',
    ja: '最初は止まる',
    cn: '首先静止',
    ko: '우선 멈추기'
  },
  motionSecond: {
    en: 'Motion second',
    de: 'Bewegungsbefehl als Zweites',
    fr: 'Mouvement en deuxième',
    ja: '最後は動く',
    cn: '最后移动',
    ko: '마지막엔 움직이기'
  },
  stillnessSecond: {
    en: 'Stillness second',
    de: 'Stillstandsbefehl als Zweites',
    fr: 'Immobilité en deuxième',
    ja: '最後は止まる',
    cn: '最后静止',
    ko: '마지막엔 멈추기'
  },
  unknown: outputs/* default.unknown */.Z.unknown
};
const radiantOutputStrings = {
  north: {
    en: 'Sacrament North',
    de: 'Sacrement Norden',
    fr: 'Sacrement Nord',
    ja: '拝火は北',
    cn: '月环上（北）',
    ko: '성례: 북'
  },
  east: {
    en: 'Sacrament East',
    de: 'Sacrement Osten',
    fr: 'Sacrement Est',
    ja: '拝火は東',
    cn: '月环右（东）',
    ko: '성례: 동'
  },
  south: {
    en: 'Sacrament South',
    de: 'Sacrement Süden',
    fr: 'Sacrement Sud',
    ja: '拝火は南',
    cn: '月环下（南）',
    ko: '성례: 남'
  },
  west: {
    en: 'Sacrament West',
    de: 'Sacrement Westen',
    fr: 'Sacrement Ouest',
    ja: '拝火は西',
    cn: '月环左（西）',
    ko: '성례: 서'
  },
  unknown: outputs/* default.unknown */.Z.unknown
};
const nisiTypes = {
  blueAlpha: {
    en: 'Blue α',
    de: 'Blau α',
    fr: 'Bleu α',
    ja: '青 α',
    cn: '蓝 α',
    ko: '파랑 α'
  },
  orangeBeta: {
    en: 'Orange β',
    de: 'Orange β',
    fr: 'Orange β',
    ja: 'オレンジ β',
    cn: '橙 β',
    ko: '노랑 β'
  },
  purpleGamma: {
    en: 'Purple γ',
    de: 'Lila γ',
    fr: 'Violet γ',
    ja: '紫 γ',
    cn: '紫 γ',
    ko: '보라 γ'
  },
  greenDelta: {
    en: 'Green δ',
    de: 'Grün δ',
    fr: 'Vert δ',
    ja: '緑 δ',
    cn: '绿 δ',
    ko: '녹색 δ'
  }
};
const nisiPassOutputStrings = {
  ...nisiTypes,
  unknown: {
    en: 'Get Final Nisi (?)',
    de: 'Nehme letzten Nisi (?)',
    fr: 'Prenez Peine finale (?)',
    ja: '最後のナイサイを取得 (?)',
    cn: '取得最后审判 (?)',
    ko: '마지막 나이사이 받기 (?)'
  },
  passNisi: {
    en: 'Pass ${type} Nisi',
    de: 'Gebe ${type} Nisi',
    fr: 'Passez ${type} Peine',
    ja: '${type} を渡す',
    cn: '传递 ${type}审判',
    ko: '나이사이 건네기: ${type}'
  },
  passNisiTo: {
    en: 'Pass ${type} to ${players}',
    de: 'Gebe ${type} zu ${players}',
    fr: 'Passez ${type} à ${players}',
    ja: '${type} を ${players} に渡す',
    cn: '将 ${type} 传给 ${players}',
    ko: '나이사이 건네기: ${type} → ${players}'
  },
  getNisi: {
    en: 'Get ${type}',
    de: 'Nimm ${type}',
    fr: 'Prenez ${type}',
    ja: '${type} を取る',
    cn: '获得 ${type}',
    ko: '나이사이 가져오기: ${type}'
  },
  getNisiFrom: {
    en: 'Get ${type} from ${player}',
    de: 'Nimm ${type} von ${player}',
    fr: 'Prenez ${type} de ${player}',
    ja: '${player} から ${type} を取る',
    cn: '从 ${player}获得${type}',
    ko: '나이사이 가져오기: ${type} ← ${player}'
  }
};

// Convenience function called for third and fourth nisi passes.
const namedNisiPass = (data, output) => {
  const finalNisiMap = data.finalNisiMap;
  const nisiMap = data.nisiMap;
  if (!finalNisiMap || !nisiMap) return output.unknown();
  if (!(data.me in finalNisiMap)) return output.unknown();
  if (data.me in nisiMap) {
    // If you have nisi, you need to pass it to the person who has that final
    // and who doesn't have nisi.
    const myNisi = nisiMap[data.me];
    if (myNisi === undefined) return output.unknown();
    let names = Object.keys(finalNisiMap);
    names = names.filter(x => finalNisiMap[x] === myNisi && x !== data.me);
    let namesWithoutNisi = names.filter(x => !(x in nisiMap));

    // If somehow it's the case that you've had SUCH a late pass that there
    // isn't anybody without without nisi, at least use the names of folks who
    // have the final debuff.
    if (namesWithoutNisi.length === 0) namesWithoutNisi = names;

    // If somehow still there's nobody, give a message so that it's not silent
    // but you're probably in trouble.
    if (namesWithoutNisi.length === 0) return output.passNisi({
      type: nisiToString(myNisi, output)
    });

    // The common case.  Hopefully there's only one person in the names list,
    // but you never know.
    const players = namesWithoutNisi.map(x => data.party.member(x));
    return output.passNisiTo({
      type: nisiToString(myNisi, output),
      players: players
    });
  }

  // If you don't have nisi, then you need to go get it from a person who does.
  const myNisi = finalNisiMap[data.me];
  if (myNisi === undefined) return output.unknown();
  let names = Object.keys(nisiMap);
  names = names.filter(x => nisiMap[x] === myNisi);
  if (names.length === 0) return output.getNisi({
    type: nisiToString(myNisi, output)
  });
  return output.getNisiFrom({
    type: nisiToString(myNisi, output),
    player: data.party.member(names[0])
  });
};
const betaInstructions = (idx, output) => {
  if (typeof idx !== 'number') {
    console.error(`TEA Beta Instructions Callout: non-number idx: ${idx ?? 'undefined'}`);
    return output.unknown();
  }
  const strings = {
    '-1': output.unknown(),
    '0': output.purpleBait(),
    '1': output.orangeBait(),
    '2': output.purpleNoTether(),
    '3': output.orangeNoTether(),
    '4': output.purpleCloseTether(),
    '5': output.orangeCloseTether(),
    '6': output.purpleFarTether(),
    '7': output.orangeFarTether()
  };
  if (idx in strings) return strings[idx];
  console.error(`TEA Beta Instructions Callout: missing idx: ${idx}`);
  return output.unknown();
};
const the_epic_of_alexander_triggerSet = {
  id: 'TheEpicOfAlexanderUltimate',
  zoneId: zone_id/* default.TheEpicOfAlexanderUltimate */.Z.TheEpicOfAlexanderUltimate,
  config: [{
    // This is more or less the TPS wormhole strat, with
    // some modifications to require less brain.
    //
    // Original TPS strat: https://www.youtube.com/watch?v=ScBsC5sZRwU
    //
    // Changes:
    // There's no "CC" side or "BJ" side, only left side and right side.
    // Start middle, face north, away from alexander.
    // Odds go left, evens go right.  1+4 go to robots, 2+3 go back, 5+6+7+8 go side of robot.
    // From there, do the same thing you normally would for your number in the TPS strat.
    // This means that sometimes 2 is baiting BJ and sometimes 3, so both need to leave room.
    // All cleaves go through the middle (easy to know where to face for evens if you don't surecast).
    // East/West cardinals always safe after chakrams.
    //
    // Diagram: https://ff14.toolboxgaming.space/?id=17050133675751&preview=1
    id: 'cactbotWormholeStrat',
    name: {
      en: 'Enable cactbot Wormhole strat: https://ff14.toolboxgaming.space/?id=17050133675751&preview=1',
      de: 'Aktiviere Cactbot Wormhole Strategie: https://ff14.toolboxgaming.space/?id=17050133675751&preview=1',
      fr: 'Activer cactbot pour la strat Wormhole : https://ff14.toolboxgaming.space/?id=17050133675751&preview=1',
      ja: '絶アレキサンダー討滅戦：cactbot「次元断絶のマーチ」ギミック',
      // FIXME
      cn: '启用 cactbot 灵泉策略: https://ff14.toolboxgaming.space/?id=17050133675751&preview=1',
      ko: 'cactbot 웜홀 공략방식 사용: https://ff14.toolboxgaming.space/?id=17050133675751&preview=1'
    },
    type: 'checkbox',
    default: options => {
      const oldSetting = options['cactbotWormholeStrat'];
      return typeof oldSetting === 'boolean' ? oldSetting : false;
    }
  }],
  timelineFile: 'the_epic_of_alexander.txt',
  timelineTriggers: [{
    id: 'TEA Fluid Swing',
    regex: /Fluid Swing/,
    beforeSeconds: 5,
    // TODO: this is likely calling out twice sometimes because
    // the timeline resyncs and it becomes 5 seconds before again.
    // This is probably a problem for all timeline triggers (whoops)
    // and needs to be fixed more generally rather than adding a
    // suppression.
    preRun: data => data.swingCount = (data.swingCount || 0) + 1,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      const multipleSwings = data.swingCount === 2 || data.swingCount === 3;
      if (data.role === 'healer') {
        if (multipleSwings) return output.tankBusters();
        if (data.liquidTank !== undefined) return output.tankBusterOn({
          player: data.party.member(data.liquidTank)
        });
        return output.tankBuster();
      }
      if (data.role === 'tank') {
        if (data.me === data.handTank && multipleSwings || data.me === data.liquidTank) return output.tankBusterOnYou();
      }
    },
    infoText: (data, _matches, output) => {
      const multipleSwings = data.swingCount === 2 || data.swingCount === 3;
      if (data.role === 'healer') return;
      if (data.me === data.handTank && multipleSwings || data.me === data.liquidTank) return;
      return output.tankCleave();
    },
    outputStrings: {
      tankCleave: outputs/* default.tankCleave */.Z.tankCleave,
      tankBusters: outputs/* default.tankBusters */.Z.tankBusters,
      tankBusterOn: outputs/* default.tankBusterOnPlayer */.Z.tankBusterOnPlayer,
      tankBuster: outputs/* default.tankBuster */.Z.tankBuster,
      tankBusterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou
    }
  }, {
    // Note: there's nothing in the log for when the hand turns into an
    // open palm or a fist, so this just warns when to move and not
    // where to go based on time.
    id: 'TEA Hand of Stuff',
    regex: /Hand of Prayer\/Parting/,
    beforeSeconds: 5,
    condition: data => data.role === 'tank',
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move Bosses',
        de: 'Bosse bewegen',
        fr: 'Déplacez les Boss',
        ja: 'ボス動かして',
        cn: '移动Boss',
        ko: '보스 이동 주차'
      }
    }
  }, {
    id: 'TEA J Kick',
    regex: /J Kick/,
    beforeSeconds: 5,
    suppressSeconds: 1,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'TEA Water and Thunder',
    regex: /Water and Thunder/,
    beforeSeconds: 3,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Water/Thunder in 3',
        de: 'Wasser/Blitz in 3',
        fr: 'Eau/Foudre dans 3s',
        ja: '水/雷まで3秒',
        cn: '3秒后水/雷',
        ko: '물/번개까지 3초'
      }
    }
  }, {
    id: 'TEA Flarethrower',
    regex: /Flarethrower/,
    beforeSeconds: 8,
    condition: data => data.me === data.bruteTank && data.phase === 'brute',
    suppressSeconds: 300,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Face Brute Towards Water',
        de: 'Drehe Brute zum Wasser',
        fr: 'Tournez Justicier vers l\'eau',
        ja: 'ジャスを竜巻に向ける',
        cn: '残暴正义号拉向水龙卷',
        ko: '심판자가 물을 바라보게 유도'
      }
    }
  }, {
    id: 'TEA Propeller Wind',
    regex: /Propeller Wind/,
    beforeSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Ice',
        de: 'Hinter dem Eis verstecken',
        fr: 'Cachez-vous derrière la glace',
        ja: '氷の後ろへ',
        cn: '冰块后躲避',
        ko: '얼음 뒤로 피하기'
      }
    }
  }, {
    id: 'TEA Final Nisi Pass',
    regex: /Propeller Wind/,
    beforeSeconds: 15,
    durationSeconds: 14,
    alertText: (data, _matches, output) => namedNisiPass(data, output),
    outputStrings: nisiPassOutputStrings
  }, {
    id: 'TEA Wormhole Puddle',
    regex: /Repentance ([1-3])/,
    beforeSeconds: 4,
    alertText: (data, matches, output) => {
      // data.puddle is set by 'TEA Wormhole TPS Strat' (or by some user trigger).
      // If that's disabled, this will still just call out puddle counts.
      if (matches[1] !== undefined && parseInt(matches[1]) === data.puddle) return output.soakThisPuddle({
        num: matches[1]
      });
    },
    infoText: (data, matches, output) => {
      if (matches[1] !== undefined && parseInt(matches[1]) === data.puddle) return;
      return output.puddle({
        num: matches[1]
      });
    },
    tts: (data, matches, output) => {
      if (matches[1] !== undefined && parseInt(matches[1]) === data.puddle) return output.soakThisPuddleTTS();
    },
    outputStrings: {
      puddle: {
        en: 'Puddle #${num}',
        de: 'Fläche #${num}',
        fr: 'Zone au sol #${num}',
        ja: '懺悔 #${num}',
        cn: '水圈 #${num}',
        ko: '참회 #${num}'
      },
      soakThisPuddle: {
        en: 'Soak This Puddle (#${num})',
        de: 'Fläche nehmen (#${num})',
        fr: 'Absorbez cette zone au sol (#${num})',
        ja: '懺悔踏む (#${num})',
        cn: '踩水圈 (#${num})',
        ko: '참회 밟기 (#${num})'
      },
      soakThisPuddleTTS: {
        en: 'Soak This Puddle',
        de: 'Fläche nehmen',
        fr: 'Absorbez cette zone au sol',
        ja: '沼踏んで',
        cn: '踩水圈',
        ko: '웅덩이 밟기'
      }
    }
  }, {
    // Shared magic tankbuster windup to non-capital Ordained Punishment.
    // Do this from timeline as you can have more than three seconds
    // to move and stack the tanks.
    id: 'TEA Ordained Capital Punishment',
    regex: /^Ordained Capital Punishment$/,
    beforeSeconds: 6,
    condition: data => data.role === 'tank' || data.role === 'healer',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Shared Tankbuster',
        de: 'geteilter Tankbuster',
        fr: 'Partagez le Tank buster',
        ja: 'タンクシェア',
        cn: '分摊死刑',
        ko: '쉐어 탱크버스터'
      }
    }
  }],
  triggers: [{
    id: 'TEA Brute Phase',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brute Justice',
      id: '483E',
      capture: false
    },
    run: data => {
      data.phase = 'brute';
      resetState(data);
    }
  }, {
    id: 'TEA Inception Phase',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alexander Prime',
      id: '486F',
      capture: false
    },
    run: data => {
      data.phase = 'inception';
      resetState(data);
    }
  }, {
    id: 'TEA Wormhole Phase',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alexander Prime',
      id: '486E',
      capture: false
    },
    run: data => {
      data.phase = 'wormhole';
      resetState(data);
    }
  }, {
    id: 'TEA Fate Alpha Phase',
    type: 'StartsUsing',
    netRegex: {
      source: 'Perfect Alexander',
      id: '487B',
      capture: false
    },
    run: data => {
      data.phase = 'alpha';
      resetState(data);
    }
  }, {
    id: 'TEA Fate Beta Phase',
    type: 'StartsUsing',
    netRegex: {
      source: 'Perfect Alexander',
      id: '4B13',
      capture: false
    },
    run: data => {
      data.phase = 'beta';
      resetState(data);
    }
  }, {
    id: 'TEA Liquid Tank',
    type: 'Ability',
    netRegex: {
      source: 'Living Liquid',
      id: '4978'
    },
    run: (data, matches) => data.liquidTank = matches.target
  }, {
    id: 'TEA Hand Tank',
    type: 'Ability',
    netRegex: {
      source: 'Liquid Hand',
      id: '4979'
    },
    run: (data, matches) => data.handTank = matches.target
  }, {
    id: 'TEA Cruise Chaser Tank',
    type: 'Ability',
    netRegex: {
      source: 'Cruise Chaser',
      id: '497A'
    },
    run: (data, matches) => data.cruiseTank = matches.target
  }, {
    id: 'TEA Brute Tank',
    type: 'Ability',
    netRegex: {
      source: 'Brute Justice',
      id: '497B'
    },
    run: (data, matches) => data.bruteTank = matches.target
  }, {
    id: 'TEA Cascade',
    type: 'StartsUsing',
    netRegex: {
      source: 'Living Liquid',
      id: '4826',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'TEA Protean Wave',
    type: 'StartsUsing',
    netRegex: {
      source: 'Living Liquid',
      id: '4822',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Protean Wave',
        de: 'Proteische Welle',
        fr: 'Vague inconstante',
        ja: 'プロティアン',
        cn: '万变水波',
        ko: '변화의 물결'
      }
    }
  }, {
    id: 'TEA Drainage Tether',
    type: 'Tether',
    netRegex: {
      source: 'Liquid Rage',
      id: '0003'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // Even if folks have the right tethers, this happens repeatedly.
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drainage tether on YOU',
        de: 'Entwässerungsverbindung auf DIR',
        fr: 'Lien Drainage sur VOUS',
        ja: '自分にドレナージ',
        cn: '连线点名',
        ko: '나에게 물줄기'
      }
    }
  }, {
    id: 'TEA Hand of Pain 5',
    type: 'StartsUsing',
    netRegex: {
      source: 'Liquid Hand',
      id: '482D',
      capture: false
    },
    preRun: data => {
      data.handOfPainCount = (data.handOfPainCount || 0) + 1;
    },
    infoText: (data, _matches, output) => {
      if (data.handOfPainCount === 5) return output.text();
    },
    outputStrings: {
      text: {
        en: 'Focus Living Liquid',
        de: 'belebtes Wasser fokussieren',
        fr: 'Focus sur Membre liquide',
        ja: 'リビングリキッドを攻撃',
        cn: '攻击水基佬',
        ko: '인간형 집중 공격'
      }
    }
  }, {
    id: 'TEA Throttle',
    type: 'GainsEffect',
    netRegex: {
      effectId: '2BC',
      capture: false
    },
    condition: data => data.CanCleanse(),
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cleanse Throttle',
        de: 'Erstickung entfernen',
        fr: 'Purifiez Suffocation',
        ja: '窒息',
        cn: '窒息',
        ko: '질식'
      }
    }
  }, {
    // Applies to both limit cuts.
    id: 'TEA Limit Cut Numbers',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      // Here and elsewhere, it's probably best to check for whether the user is the target first,
      // as that should short-circuit more often.
      return data.me === matches.target && /00(?:4F|5[0-6])/.test(the_epic_of_alexander_getHeadmarkerId(data, matches));
    },
    preRun: (data, matches) => {
      const correctedMatch = the_epic_of_alexander_getHeadmarkerId(data, matches);
      const limitCutNumberMap = {
        '004F': 1,
        '0050': 2,
        '0051': 3,
        '0052': 4,
        '0053': 5,
        '0054': 6,
        '0055': 7,
        '0056': 8
      };
      data.limitCutNumber = limitCutNumberMap[correctedMatch];
      const limitCutDelayMap = data.phase === 'wormhole' ? {
        '004F': 9.2,
        '0050': 10.7,
        '0051': 13.4,
        '0052': 15.0,
        '0053': 17.7,
        '0054': 19.2,
        '0055': 22.0,
        '0056': 23.4
      } : {
        '004F': 9.5,
        '0050': 11,
        '0051': 14.1,
        '0052': 15.5,
        '0053': 18.6,
        '0054': 20,
        '0055': 23.2,
        '0056': 24.6
      };
      data.limitCutDelay = limitCutDelayMap[correctedMatch];
    },
    durationSeconds: data => {
      // Because people are very forgetful,
      // show the number until you are done.
      return data.limitCutDelay;
    },
    alertText: (data, _matches, output) => output.text({
      num: data.limitCutNumber
    }),
    outputStrings: {
      text: {
        en: '#${num}',
        de: '#${num}',
        fr: '#${num}',
        ja: '${num}番',
        cn: '#${num}',
        ko: '${num}번째'
      }
    }
  }, {
    // Applies to both limit cuts.
    id: 'TEA Limit Cut Knockback',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => data.me === matches.target && /00(?:4F|5[0-6])/.test(the_epic_of_alexander_getHeadmarkerId(data, matches)),
    // This gives a warning within 5 seconds, so you can hit arm's length.
    delaySeconds: data => data.limitCutDelay !== undefined ? data.limitCutDelay - 5 : 0,
    alertText: (data, matches, output) => {
      const headMarkerInt = parseInt(the_epic_of_alexander_getHeadmarkerId(data, matches), 16);
      const isOddNumber = (headMarkerInt & 1) === 1;
      if (data.phase === 'wormhole') {
        if (isOddNumber) return output.knockbackCleaveFaceOutside();
        return output.knockbackChargeFaceMiddle();
      }
      if (isOddNumber) return output.knockbackCleaveOnYou();
      return output.knockback();
    },
    outputStrings: {
      knockbackCleaveFaceOutside: {
        en: 'Knockback Cleave; Face Outside',
        de: 'Rückstoß Cleave; nach Außen schauen',
        fr: 'Poussée Cleave; Regardez à l\'extérieur',
        ja: 'ノックバック ソード; 外向く',
        cn: '击退顺劈; 面向外侧',
        ko: '넉백 소드; 바깥쪽 바라보기'
      },
      knockbackChargeFaceMiddle: {
        en: 'Knockback Charge; Face Middle',
        de: 'Rückstoß Charge; zur Mitte schauen',
        fr: 'Poussée Charge; Regardez à l\'intérieur',
        ja: 'ノックバック チャージ; 中央向く',
        cn: '击退冲锋; 面向中间',
        ko: '넉백 차지; 안쪽 바라보기'
      },
      knockbackCleaveOnYou: {
        en: 'Knockback Cleave on YOU',
        de: 'Rückstoß Cleave auf DIR',
        fr: 'Poussée Cleave sur VOUS',
        ja: '自分にクリーブ',
        cn: '击退顺劈点名',
        ko: '나에게 넉백 공격'
      },
      knockback: outputs/* default.knockback */.Z.knockback
    }
  }, {
    id: 'TEA Chakrams Out',
    type: 'Ability',
    // Link Up
    netRegex: {
      source: 'Brute Justice',
      id: '483F',
      capture: false
    },
    condition: data => data.phase === 'brute',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out, Dodge Chakrams',
        de: 'Raus, Chakrams ausweichen',
        fr: 'À l\'extérieur, évitez les Chakrams',
        ja: '外へ',
        cn: '远离，躲避轮轮',
        ko: '바깥으로 차크람 피하기'
      }
    }
  }, {
    id: 'TEA Chakrams In',
    type: 'Ability',
    // Optical Sight
    netRegex: {
      source: 'Cruise Chaser',
      id: '482F',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Run In',
        de: 'Rein',
        fr: 'Courez à l\'intérieur',
        ja: '中へ',
        cn: '靠近',
        ko: '가운데로'
      }
    }
  }, {
    id: 'TEA Whirlwind',
    type: 'StartsUsing',
    netRegex: {
      source: 'Cruise Chaser',
      id: '49C2',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'TEA Spin Crusher',
    type: 'StartsUsing',
    netRegex: {
      source: 'Cruise Chaser',
      id: '4A72',
      capture: false
    },
    // Nobody should be in front of cruise chaser but the tank, and this is close to
    // water thunder handling, so only tell the tank.
    condition: data => data.me === data.cruiseTank,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge Spin Crusher',
        de: 'Rotorbrecher ausweichen',
        fr: 'Esquivez Écrasement tournoyant',
        ja: 'スピンクラッシャー避けて',
        cn: '躲避回旋碎踢',
        ko: '회전 분쇄 피하기'
      }
    }
  }, {
    id: 'TEA Ice Marker',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => data.me === matches.target && the_epic_of_alexander_getHeadmarkerId(data, matches) === '0043',
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Freeze Tornado',
        de: 'Tornado einfrieren',
        fr: 'Gèlez la tornade',
        ja: '竜巻凍らせる',
        cn: '冰冻龙卷风',
        ko: '물 회오리 얼리기'
      }
    }
  }, {
    id: 'TEA Hidden Minefield',
    type: 'Ability',
    netRegex: {
      source: 'Brute Justice',
      id: '4851',
      capture: false
    },
    condition: data => data.role === 'tank',
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mines',
        de: 'Minen',
        fr: 'Mines',
        ja: '地雷',
        cn: '地雷',
        ko: '지뢰'
      }
    }
  }, {
    id: 'TEA Enumeration YOU',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => data.me === matches.target && the_epic_of_alexander_getHeadmarkerId(data, matches) === '0041',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Enumeration on YOU',
        de: 'Enumeration auf DIR',
        fr: 'Énumeration sur VOUS',
        ja: '自分にカウント',
        cn: '计数点名',
        ko: '나에게 인원수'
      }
    }
  }, {
    id: 'TEA Enumeration Everyone',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => the_epic_of_alexander_getHeadmarkerId(data, matches) === '0041',
    preRun: (data, matches) => {
      data.enumerations ??= [];
      data.enumerations.push(matches.target);
    },
    infoText: (data, _matches, output) => {
      if (data.enumerations?.length !== 2) return;
      const names = data.enumerations.sort();
      return output.text({
        players: names.map(x => data.party.member(x))
      });
    },
    outputStrings: {
      text: {
        en: 'Enumeration: ${players}',
        de: 'Enumeration: ${players}',
        fr: 'Énumeration: ${players}',
        ja: 'カウント: ${players}',
        cn: '计数${players}',
        ko: '인원수 대상: ${players}'
      }
    }
  }, {
    id: 'TEA Limit Cut Shield',
    type: 'Ability',
    netRegex: {
      source: 'Cruise Chaser',
      id: '4833',
      capture: false
    },
    delaySeconds: 2,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Break Shield From Front',
        de: 'Schild von Vorne zerstören',
        fr: 'Brisez le bouclier par devant',
        ja: '正面からシールド壊して',
        cn: '从前面击破盾牌',
        ko: '정면에서 실드를 부수기'
      }
    }
  }, {
    id: 'TEA Compressed Water Initial',
    type: 'GainsEffect',
    netRegex: {
      effectId: '85E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Water on YOU',
        de: 'Wasser auf DIR',
        fr: 'Eau sur VOUS',
        ja: '自分に水',
        cn: '水点名',
        ko: '나에게 물'
      }
    }
  }, {
    id: 'TEA Compressed Water Explode',
    type: 'GainsEffect',
    netRegex: {
      effectId: '85E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 5,
    alertText: (data, _matches, output) => {
      if (data.seenGavel) return;
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'Drop Water Soon',
        de: 'Gleich Wasser ablegen',
        fr: 'Déposez l\'eau bientôt',
        ja: '水来るよ',
        cn: '马上放水',
        ko: '물이 곧 옵니다'
      }
    }
  }, {
    id: 'TEA Compressed Lightning Initial',
    type: 'GainsEffect',
    netRegex: {
      effectId: '85F'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Lightning on YOU',
        de: 'Blitz auf DIR',
        fr: 'Foudre sur VOUS',
        ja: '自分に雷',
        cn: '雷点名',
        ko: '나에게 번개'
      }
    }
  }, {
    id: 'TEA Compressed Lightning Explode',
    type: 'GainsEffect',
    netRegex: {
      effectId: '85F'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 5,
    alertText: (data, _matches, output) => {
      if (data.seenGavel) return;
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'Drop Lightning Soon',
        de: 'Gleich Blitz ablegen',
        fr: 'Déposez la foudre bientôt',
        ja: '雷来るよ',
        cn: '马上放雷',
        ko: '번개가 곧 옵니다'
      }
    }
  }, {
    id: 'TEA Pass Nisi 1',
    type: 'StartsUsing',
    // 4 seconds after Photon cast starts.
    netRegex: {
      source: 'Cruise Chaser',
      id: '4836',
      capture: false
    },
    delaySeconds: 4,
    suppressSeconds: 10000,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pass Nisi',
        de: 'Nisi weitergeben',
        fr: 'Passez la Peine',
        ja: 'ナイサイ渡して',
        cn: '传递审判',
        ko: '나이사이 건네기'
      }
    }
  }, {
    id: 'TEA Pass Nisi 2',
    type: 'Ability',
    // 1 second after enumeration.
    // TODO: find a startsUsing instead of matching an action.
    netRegex: {
      source: 'Brute Justice',
      id: '4850',
      capture: false
    },
    // Ignore enumerations later in the fight.
    condition: data => data.phase === 'brute',
    delaySeconds: 1,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pass Nisi',
        de: 'Nisi weitergeben',
        fr: 'Passez la Peine',
        ja: 'ナイサイ渡して',
        cn: '传递审判',
        ko: '나이사이 건네기'
      }
    }
  }, {
    id: 'TEA Pass Nisi 3',
    type: 'StartsUsing',
    // 8 seconds after Flarethrower cast starts.
    netRegex: {
      source: 'Brute Justice',
      id: '4845',
      capture: false
    },
    delaySeconds: 8,
    durationSeconds: 9,
    alertText: (data, _matches, output) => namedNisiPass(data, output),
    outputStrings: nisiPassOutputStrings
  }, {
    id: 'TEA Decree Nisi Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: kDecreeNisi
    },
    run: (data, matches) => {
      const num = kDecreeNisi.indexOf(matches.effectId.toUpperCase());
      data.nisiMap ??= {};
      data.nisiMap[matches.target] = num;
    }
  }, {
    id: 'TEA Decree Nisi Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: kDecreeNisi
    },
    run: (data, matches) => {
      data.nisiMap ??= {};
      delete data.nisiMap[matches.target];
    }
  }, {
    id: 'TEA Final Judgment Nisi Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: kFinalJudgementNisi
    },
    run: (data, matches) => {
      const num = kFinalJudgementNisi.indexOf(matches.effectId.toUpperCase());
      data.finalNisiMap ??= {};
      data.finalNisiMap[matches.target] = num;
    }
  }, {
    id: 'TEA Final Judgment Nisi Verdict',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['8B0', '8B1', '85B', '85C']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // This keeps refreshing forever, so only alert once.
    suppressSeconds: 10000,
    infoText: (_data, matches, output) => {
      const num = kFinalJudgementNisi.indexOf(matches.effectId.toUpperCase());
      return output.verdict({
        type: nisiToString(num, output)
      });
    },
    outputStrings: {
      ...nisiTypes,
      verdict: {
        en: 'Verdict: ${type} Nisi',
        de: 'Prozesseröffnung: ${type} Nisi',
        fr: 'Ouverture de procès: ${type} Nisi',
        ja: '最終: ${type}',
        cn: '最终: ${type}',
        ko: '최종: ${type}'
      }
    }
  }, {
    id: 'TEA Gavel',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brute Justice',
      id: '483C',
      capture: false
    },
    run: data => data.seenGavel = true
  }, {
    id: 'TEA Double Rocket Punch',
    type: 'StartsUsing',
    netRegex: {
      source: 'Brute Justice',
      id: '4847'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.sharedTankbusterOnYou();
      if (data.role === 'tank' || data.role === 'healer') return output.sharedTankbusterOn({
        player: data.party.member(matches.target)
      });
    },
    infoText: (data, _matches, output) => {
      if (data.role === 'tank' || data.role === 'healer') return;
      return output.baitSuperJump();
    },
    outputStrings: {
      baitSuperJump: {
        en: 'Bait Super Jump?',
        de: 'Supersprung anlocken?',
        fr: 'Attirez le Super saut ?',
        ja: 'スパジャン誘導',
        cn: '引导超级跳跃',
        ko: '슈퍼 점프 유도'
      },
      sharedTankbusterOnYou: {
        en: 'Shared Tankbuster on YOU',
        de: 'geteilter Tankbuster auf DIR',
        fr: 'Tank buster à partager sur VOUS',
        ja: '自分にタンクシェア',
        cn: '分摊死刑点名',
        ko: '나에게 쉐어 탱크버스터'
      },
      sharedTankbusterOn: {
        en: 'Shared Tankbuster on ${player}',
        de: 'geteilter Tankbuster on ${player}',
        fr: 'Tank buster à partager sur ${player}',
        ja: '${player} にタンクシェア',
        cn: '分摊死刑点 ${player}',
        ko: '쉐어 탱크버스터 대상: ${player}'
      }
    }
  }, {
    id: 'TEA Brute Ray',
    type: 'Ability',
    netRegex: {
      source: 'Brute Justice',
      id: '484A',
      capture: false
    },
    condition: data => data.phase === 'brute',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'avoid ray',
        de: 'Strahl ausweichen',
        fr: 'Évitez le rayon',
        ja: 'アポカリ避けて',
        cn: '躲避激光',
        ko: '파멸 계시 피하기'
      }
    }
  }, {
    id: 'TEA Buff Collection',
    type: 'GainsEffect',
    // Aggravated Assault, Shared Sentence, House Arrest, Restraining Order.
    netRegex: {
      effectId: '46[1234]'
    },
    run: (data, matches) => {
      data.buffMap ??= {};
      // The values are for debugging; the logic is just about presence in the map.
      data.buffMap[matches.target] = matches.effect;
    }
  }, {
    id: 'TEA Temporal Stasis No Buff',
    type: 'GainsEffect',
    // This id is "restraining order".
    netRegex: {
      effectId: '464',
      capture: false
    },
    condition: data => {
      // NOTE: due to timings the "temporal" phase does not start until after debuffs are out.
      // So consider the "temporal" no debuff to be "brute" no debuff here.
      return data.phase === 'brute' || data.phase === 'inception';
    },
    delaySeconds: 0.5,
    durationSeconds: 10,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      if (data.buffMap?.[data.me] !== undefined) return;
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'No Debuff',
        de: 'Kein Debuff',
        fr: 'Pas de Debuff',
        ja: 'デバフ無し',
        cn: '无 Debuff',
        ko: '디버프 없음'
      }
    }
  }, {
    id: 'TEA Restraining Order',
    type: 'GainsEffect',
    netRegex: {
      effectId: '464'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Far Tethers',
        de: 'Entfernte Verbindungen',
        fr: 'Liens éloignés',
        ja: 'ファー',
        cn: '远离连线',
        ko: '접근금지: 상대와 떨어지기'
      }
    }
  }, {
    id: 'TEA House Arrest',
    type: 'GainsEffect',
    netRegex: {
      effectId: '463'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Close Tethers',
        de: 'Nahe Verbindungen',
        fr: 'Liens proches',
        ja: 'ニアー',
        cn: '靠近连线',
        ko: '강제접근: 상대와 가까이 붙기'
      }
    }
  }, {
    id: 'TEA Shared Sentence',
    type: 'GainsEffect',
    netRegex: {
      effectId: '462'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Shared Sentence',
        de: 'Urteil: Kollektivstrafe',
        fr: 'Peine collective',
        ja: '集団罰',
        cn: '集团罪',
        ko: '단체형: 무징과 함께 맞기'
      }
    }
  }, {
    id: 'TEA Shared Sentence Inception',
    type: 'GainsEffect',
    netRegex: {
      effectId: '462'
    },
    condition: data => data.phase === 'inception',
    delaySeconds: 3,
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.target)
    }),
    outputStrings: {
      text: {
        en: 'Shared Sentence on ${player}',
        de: 'Urteil: Kollektivstrafe auf ${player}',
        fr: 'Peine collective sur ${player}',
        ja: '${player} に集団罰',
        cn: '集团罪 点${player}',
        ko: '${player} 에게 단체형'
      }
    }
  }, {
    id: 'TEA Aggravated Assault',
    type: 'GainsEffect',
    netRegex: {
      effectId: '461'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 10,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Thunder',
        de: 'Blitz',
        fr: 'Peine Sévère',
        ja: '加重罰',
        cn: '加重罪',
        ko: '가중형: 가중형끼리 모이기'
      }
    }
  }, {
    id: 'TEA Chastening Heat',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alexander Prime',
      id: '4A80'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.tankBusterOnYou();
      if (data.role === 'healer') return output.busterOn({
        player: data.party.member(matches.target)
      });
    },
    // As this seems to usually seems to be invulned,
    // don't make a big deal out of it.
    infoText: (data, matches, output) => {
      if (matches.target === data.me) return;
      if (data.role !== 'tank') return;
      return output.busterOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      busterOn: outputs/* default.tankBusterOnPlayer */.Z.tankBusterOnPlayer,
      tankBusterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou
    }
  }, {
    id: 'TEA Judgment Crystal',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => data.me === matches.target && the_epic_of_alexander_getHeadmarkerId(data, matches) === '0060',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Crystal on YOU',
        de: 'Kristall auf DIR',
        fr: 'Cristal sur VOUS',
        ja: '自分に結晶',
        cn: '结晶点名',
        ko: '나에게 결정체'
      }
    }
  }, {
    id: 'TEA Judgment Crystal Placement',
    type: 'Ability',
    netRegex: {
      source: 'Alexander Prime',
      id: '485C',
      capture: false
    },
    suppressSeconds: 100,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Away From Crystals',
        de: 'Geh weg vom Kristall',
        fr: 'Éloignez-vous des Cristaux',
        ja: '結晶から離れ',
        cn: '远离结晶',
        ko: '결정체로부터 멀어질 것'
      }
    }
  }, {
    id: 'TEA Terashatter Flarethrower',
    type: 'Ability',
    netRegex: {
      source: 'Judgment Crystal',
      id: '4A88',
      capture: false
    },
    delaySeconds: 1,
    suppressSeconds: 100,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Brute\'s Flarethrower',
        de: 'Locke Brute\'s Großflammenwerfer',
        fr: 'Attirez le Lance-brasiers de Justicier',
        ja: '火炎放射を誘導',
        cn: '引导火炎放射',
        ko: '화염 방사 유도'
      }
    }
  }, {
    id: 'TEA Inception Vuln Collection',
    type: 'GainsEffect',
    netRegex: {
      effectId: '2B7'
    },
    condition: data => data.phase === 'inception',
    run: (data, matches) => {
      data.vuln ??= {};
      data.vuln[matches.target] = true;
    }
  }, {
    id: 'TEA Inception Alpha Sword',
    type: 'Ability',
    // Sacrament cast.
    netRegex: {
      source: 'Alexander Prime',
      id: '485F',
      capture: false
    },
    condition: data => data.phase === 'inception',
    alarmText: (data, _matches, output) => {
      data.vuln ??= {};
      const numVulns = Object.keys(data.vuln).length;
      if (data.role === 'tank' && data.vuln[data.me] && numVulns >= 5) {
        // If you're stacking three people in the shared sentence,
        // then probably the tank wants to handle jump with cooldowns.
        // TODO: we could probably determine where this is.
        return output.baitJumpWithCooldowns();
      }
    },
    alertText: (data, _matches, output) => {
      data.vuln ??= {};
      if (data.vuln[data.me]) return;
      const numVulns = Object.keys(data.vuln).length;
      if (numVulns >= 5) {
        // In this case, jump was handled above for tanks.
        return output.baitSword();
      }

      // Otherwise everybody without a vuln can do anything.
      return output.baitSwordOrJump();
    },
    infoText: (data, _matches, output) => {
      data.vuln ??= {};
      if (data.vuln[data.me]) {
        // Tanks covered in the alarmText case above.
        const numVulns = Object.keys(data.vuln).length;
        if (data.role === 'tank' && numVulns >= 5) return;
        return output.vulnAvoidCleavesAndJump();
      }
    },
    outputStrings: {
      vulnAvoidCleavesAndJump: {
        en: 'Vuln: Avoid cleaves and jump',
        de: 'Vuln: Cleaves und Sprung ausweichen',
        fr: 'Vuln: évitez les cleaves et saut',
        ja: '被ダメ増加',
        cn: '易伤：躲避顺劈和跳',
        ko: '받는 데미지 증가: 공격과 점프 피할것'
      },
      baitSword: {
        en: 'Bait Sword',
        de: 'Locke Chaser-Mecha Schwert',
        fr: 'Attirez l\'Épée',
        ja: 'ソード誘導',
        cn: '引导剑',
        ko: '검 유도'
      },
      baitSwordOrJump: {
        en: 'Bait Sword or Jump?',
        de: 'Köder Schwert oder Sprung?',
        fr: 'Attirez l\'Épée ou le Saut ?',
        ja: 'ソードかジャンプ誘導?',
        cn: '引导剑或跳?',
        ko: '검 또는 슈퍼 점프 유도?'
      },
      baitJumpWithCooldowns: {
        en: 'Bait Jump With Cooldowns',
        de: 'Köder Sprung mit Cooldowns',
        fr: 'Attirez le Saut avec des Cooldowns',
        ja: 'スパジャン誘導',
        cn: '减伤引导跳跃',
        ko: '슈퍼 점프 유도'
      }
    }
  }, {
    id: 'TEA Wormhole',
    type: 'Ability',
    netRegex: {
      source: 'Alexander Prime',
      id: '486E',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.triggerSetConfig.cactbotWormholeStrat === true) return output.baitChakramsWormholeStrat();
      return output.baitChakrams();
    },
    outputStrings: {
      baitChakramsWormholeStrat: {
        en: 'Bait Chakrams mid; Look opposite Alex',
        de: 'Locke Chakrams mittig; schau weg von Alex',
        fr: 'Attirez les Chakrams au milieu; Regardez à l\'opposé d\'Alex',
        ja: '中央にチャクラム誘導; アレキの反対見て',
        cn: '中间引导轮轮，背对亚历山大',
        ko: '가운데로 차크람 유도; 알렉 반대쪽이 북쪽'
      },
      baitChakrams: {
        en: 'Bait Chakrams',
        de: 'Köder Chakrams',
        fr: 'Attirez les Chakrams',
        ja: 'チャクラム誘導',
        cn: '引导轮轮',
        ko: '차크람 유도'
      }
    }
  }, {
    id: 'TEA Cactbot Wormhole Strat',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      if (data.triggerSetConfig.cactbotWormholeStrat !== true) return false;
      if (!/00(?:4F|5[0-6])/.test(the_epic_of_alexander_getHeadmarkerId(data, matches))) return false;
      return data.phase === 'wormhole' && data.me === matches.target;
    },
    preRun: (data, matches) => {
      const puddleMap = {
        '004F': 3,
        '0050': 3,
        '0051': 0,
        '0052': 0,
        '0053': 1,
        '0054': 1,
        '0055': 2,
        '0056': 2
      };
      data.puddle = puddleMap[the_epic_of_alexander_getHeadmarkerId(data, matches)];
    },
    durationSeconds: 10,
    infoText: (data, matches, output) => {
      // Initial directions.
      // TODO: we could figure out which robot was left and right based
      // on chakrams, and call that out here too instead of just saying "Robot".
      const outputMap = {
        '004F': output.marker1(),
        '0050': output.marker2(),
        '0051': output.marker3(),
        '0052': output.marker4(),
        '0053': output.marker5(),
        '0054': output.marker6(),
        '0055': output.marker7(),
        '0056': output.marker8()
      };
      return outputMap[the_epic_of_alexander_getHeadmarkerId(data, matches)];
    },
    outputStrings: {
      marker1: {
        en: 'Left To Robot; Look Outside; 3rd Puddle',
        de: 'Links vom Robot; Nach Außen schauen; 3. Fläche',
        fr: 'À gauche du Robot; Regardez à l\'extérieur; 3rd zone au sol',
        ja: '右上 外向き 懺悔3回目',
        cn: '左-->机器人; 面向外侧; 水圈#3',
        ko: '왼쪽 위 / 참회 #3'
      },
      marker2: {
        en: 'Back Right Opposite Robot; Look Middle; 3rd Puddle',
        de: 'Hinten Rechts gegenüber vom Robot; zur Mitte schauen; 3. Fläche',
        fr: 'Revenez à l\'opposé droite du Robot; Regardez au milieu; 3rd zone au sol',
        ja: '左下 内向き 懺悔3回目',
        cn: '右后<--机器人; 面向中间; 水圈#3',
        ko: '오른쪽 위 / 참회 #3'
      },
      marker3: {
        en: 'Back Left Opposite Robot; No Puddle',
        de: 'Hinten Links gegenüber vom Robot; keine Fläche',
        fr: 'Revenez à l\'opposé gauche du Robot; Pas de zone au sol',
        ja: '左上',
        cn: '左后<--机器人; 无水圈',
        ko: '왼쪽 아래'
      },
      marker4: {
        en: 'Right To Robot; No puddle',
        de: 'Rechts vom Robot; keine Fläche',
        fr: 'À droite du Robot; Pas de zone au sol',
        ja: '右下',
        cn: '右-->机器人; 无水圈',
        ko: '오른쪽 아래'
      },
      marker5: {
        en: 'Left Robot Side -> 1st Puddle',
        de: 'Linke Robot Seite -> 1. Fläche',
        fr: 'Côté gauche du Robot-> 1st zone au sol',
        ja: '右ちょい上 懺悔1回目',
        cn: '机器人左侧 --> 水圈#1',
        ko: '왼쪽 / 참회 #1'
      },
      marker6: {
        en: 'Right Robot Side -> 1st Puddle',
        de: 'Rechte Robot Seite -> 1. Fläche',
        fr: 'Côté droit du Robot-> 1st zone au sol',
        ja: '左ちょい上 懺悔1回目',
        cn: '机器人右侧 --> 水圈#1',
        ko: '오른쪽 / 참회 #1'
      },
      marker7: {
        en: 'Left Robot Side -> cardinal; 2nd Puddle',
        de: 'Linke Robot Seite -> cardinal; 2. Fläche',
        fr: 'Côté gauche du Robot -> cardinal; 2nd zone au sol',
        ja: '右ちょい上 懺悔2回目',
        cn: '机器人左侧 --> 边; 水圈#2',
        ko: '왼쪽 / 참회 #2'
      },
      marker8: {
        en: 'Right Robot Side -> cardinal; 2nd Puddle',
        de: 'Rechte Robot Seite -> cardinal; 2. Fläche',
        fr: 'Côté droit du Robot -> cardinal; 2nd zone au sol',
        ja: '左ちょい上 懺悔2回目',
        cn: '机器人右侧 --> 边; 水圈#2',
        ko: '오른쪽 / 참회 #2'
      }
    }
  }, {
    id: 'TEA Cactbot Wormhole 4 Super Jump',
    type: 'Ability',
    netRegex: {
      source: 'Brute Justice',
      id: '484A',
      capture: false
    },
    condition: data => {
      if (data.triggerSetConfig.cactbotWormholeStrat !== true) return false;
      if (data.phase !== 'wormhole') return;
      return data.limitCutNumber === 2 || data.limitCutNumber === 3;
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move Behind Brute Justice?',
        de: 'Geh hinter Brutalus?',
        fr: 'Déplacez-vous derière Justicier ?',
        ja: 'ジャスティスの背面へ',
        cn: '残暴正义号背后躲避?',
        ko: '심판자 등 뒤로 이동?'
      }
    }
  }, {
    id: 'TEA Incinerating Heat',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => the_epic_of_alexander_getHeadmarkerId(data, matches) === '005D',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack Middle',
        de: 'mittig sammeln',
        fr: 'Packez-vous au milieu',
        ja: '中央へ',
        cn: '中间集合',
        ko: '가운데로 모이기'
      }
    }
  }, {
    id: 'TEA Mega Holy',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alexander Prime',
      id: '4A83',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'big aoe',
        de: 'große AoE',
        fr: 'Grosse AoE',
        ja: '大ダメージAoE',
        cn: '高伤AOE',
        ko: '거대 전체 공격'
      }
    }
  }, {
    id: 'TEA Summon Alexander',
    type: 'StartsUsing',
    netRegex: {
      source: 'Alexander Prime',
      id: '4A55',
      capture: false
    },
    delaySeconds: 10.4,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Cruise Chaser First',
        de: 'Chaser-Mecha zuerst besiegen',
        fr: 'Tuez Croiseur-chasseur en premier',
        ja: 'チェイサーから倒す',
        cn: '先杀巡航驱逐者',
        ko: '순항추격기부터 처치하기'
      }
    }
  }, {
    id: 'TEA Divine Judgment',
    type: 'Ability',
    netRegex: {
      source: 'Alexander Prime',
      id: '4879',
      capture: false
    },
    condition: data => data.role === 'tank',
    delaySeconds: 6,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'TANK LB!!',
        de: 'TANK LB!!',
        fr: 'LB TANK !!',
        ja: 'タンクLB!!',
        cn: '坦克LB!!',
        ko: '탱리밋!!'
      }
    }
  }, {
    id: 'TEA Perfect Optical Sight Spread',
    type: 'StartsUsing',
    netRegex: {
      source: 'Perfect Alexander',
      id: '488A',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.spread */.Z.spread
    }
  }, {
    id: 'TEA Perfect Optical Sight Stack',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => the_epic_of_alexander_getHeadmarkerId(data, matches) === '003E',
    preRun: (data, matches) => {
      data.opticalStack ??= [];
      data.opticalStack.push(matches.target);
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.stackOnYou();
    },
    infoText: (data, _matches, output) => {
      data.opticalStack ??= [];
      if (data.opticalStack.length === 1) return;
      const names = data.opticalStack.map(x => data.party.member(x)).sort();
      return output.opticalStackPlayers({
        players: names
      });
    },
    outputStrings: {
      opticalStackPlayers: {
        en: 'Optical Stack (${players})',
        de: 'Optischer Stack (${players})',
        fr: 'Package optique (${players})',
        ja: 'シェア (${players})',
        cn: '照准集合 (${players})',
        ko: '조준 대상: ${players}'
      },
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou
    }
  }, {
    id: 'TEA Ordained Motion',
    type: 'StartsUsing',
    netRegex: {
      source: 'Perfect Alexander',
      id: '487E',
      capture: false
    },
    durationSeconds: 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Keep Moving',
        de: 'weiter bewegen',
        fr: 'Continuez à bouger',
        ja: '動く',
        cn: '保持移动',
        ko: '움직여!!!'
      }
    }
  }, {
    id: 'TEA Ordained Stillness',
    type: 'StartsUsing',
    netRegex: {
      source: 'Perfect Alexander',
      id: '487F',
      capture: false
    },
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'STOP LITERALLY EVERYTHING',
        de: 'STOP WIRKLICH ALLES',
        fr: 'ARRÊTEZ TOUT',
        ja: '止まる',
        cn: '停止一切动作',
        ko: '멈춰!!!'
      }
    }
  }, {
    id: 'TEA Contact Prohibition',
    type: 'GainsEffect',
    netRegex: {
      effectId: '868'
    },
    condition: (data, matches) => data.me === matches.target,
    infoText: (_data, _matches, output) => output.text(),
    tts: {
      en: 'Orange',
      de: 'Orange',
      fr: 'Orange',
      ja: '接触禁止',
      cn: '小光',
      ko: '접촉금지'
    },
    outputStrings: {
      text: {
        en: 'Orange (Attract)',
        de: 'Orange (Anziehen)',
        fr: 'Orange (Attraction)',
        ja: '接触禁止',
        cn: '小光',
        ko: '노랑/접촉금지'
      }
    }
  }, {
    id: 'TEA Contact Regulation',
    type: 'GainsEffect',
    netRegex: {
      effectId: '869'
    },
    condition: (data, matches) => data.me === matches.target,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Orange Bait: Get Away',
        de: 'Orange locken: Geh Weg',
        fr: 'Attirez l\'orange : Éloignez-vous',
        ja: '接触保護',
        cn: '大光: 远离人群',
        ko: '노랑/접촉보호; 유도역할/혼자 멀리 있기'
      }
    }
  }, {
    id: 'TEA Escape Prohibition',
    type: 'GainsEffect',
    netRegex: {
      effectId: '86A'
    },
    condition: (data, matches) => data.me === matches.target,
    infoText: (_data, _matches, output) => output.text(),
    tts: {
      en: 'Purple',
      de: 'Lila',
      fr: 'Violet',
      ja: '逃亡禁止',
      cn: '小暗',
      ko: '도망금지'
    },
    outputStrings: {
      text: {
        en: 'Purple (Repel)',
        de: 'Lila (Abstoßen)',
        fr: 'Violet (Répulsion)',
        ja: '逃亡禁止',
        cn: '小暗',
        ko: '보라/도망금지'
      }
    }
  }, {
    id: 'TEA Escape Detection',
    type: 'GainsEffect',
    netRegex: {
      effectId: '86B'
    },
    condition: (data, matches) => data.me === matches.target,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Purple Bait: Be In Back Of Group',
        de: 'Lila locken: Hinter der Gruppe sein',
        fr: 'Attirez le violet : Placez-vous derrière le groupe',
        ja: '逃亡監察',
        cn: '大暗: 去人群后面',
        ko: '보라/도망감찰; 유도역할/사람들 뒤에 있기'
      }
    }
  }, {
    id: 'TEA Fate Tether Bois',
    type: 'Tether',
    netRegex: {
      id: '0062'
    },
    run: (data, matches) => {
      data.tetherBois ??= {};
      data.tetherBois[matches.targetId] = matches.source;
    }
  }, {
    id: 'TEA Alpha Instructions',
    type: 'Tether',
    netRegex: {
      id: '0062',
      capture: false
    },
    condition: data => data.phase === 'alpha',
    delaySeconds: 1,
    suppressSeconds: 10,
    run: data => {
      const tetherBois = data.tetherBois ??= {};

      // Let your actor id memes be dreams.
      // If you sort the actor ids of the clones, this will tell you what you have.
      // If anybody is dead, they will fill in from the lowest.
      const sortedIds = Object.keys(tetherBois).sort().reverse();
      const sortedNames = sortedIds.map(x => tetherBois[x]);
      data.alphaSolidarity = sortedNames[0];
      data.alphaDefamation = sortedNames[1];
      data.alphaSeverity = [sortedNames[2], sortedNames[3], sortedNames[4]];
      data.alphaNoDebuff = [sortedNames[5], sortedNames[6], sortedNames[7]];
    }
  }, {
    id: 'TEA Alpha Instructions Callout',
    type: 'Tether',
    netRegex: {
      id: '0062',
      capture: false
    },
    condition: data => data.phase === 'alpha',
    delaySeconds: 2,
    durationSeconds: 28,
    suppressSeconds: 10,
    // TODO: this would probably be cleaner as a single response,
    // rather than a giant pile of conditionals in each function.
    alarmText: (data, _matches, output) => {
      // Defamation will wipe the group, so gets an alarm.
      if (data.me === data.alphaDefamation) return output.defamation();
    },
    alertText: (data, _matches, output) => {
      // Folks who need to not stack, get an alert.
      if (data.me === data.alphaSolidarity) return output.solidarity();
      if (data.alphaSeverity?.includes(data.me)) return output.severity();
    },
    infoText: (data, _matches, output) => {
      // The other 4 people in the stack group just get info.
      if (data.me === data.alphaDefamation) return;
      if (data.me === data.alphaSolidarity) return;
      if (data.alphaSeverity?.includes(data.me)) return;
      if (data.alphaNoDebuff?.includes(data.me)) return output.noDebuff();

      // If enough people are alive, unknowns are probably no debuff stack.
      if (Object.keys(data.tetherBois ?? {}).length >= 5) return output.unknownMaybeStack();
      // Otherwise, gg.
      return output.unknown();
    },
    outputStrings: {
      unknownMaybeStack: {
        en: 'No clone: probably stack?',
        de: 'keine Klone: warscheinlich kein debuff + stack?',
        fr: 'Pas de clone : package ?',
        ja: 'クローン無し: 多分シェア?',
        cn: '没有分身: 或许要集合?',
        ko: '분신 없음: 아마도 오른쪽/함께 맞기?'
      },
      unknown: {
        en: 'No clone: ???',
        de: 'keine Klone: ???',
        fr: 'Pas de clone : ???',
        ja: 'クローン無し: ???',
        cn: '没有分身: ¿¿¿',
        ko: '분신 없음: ???'
      },
      defamation: {
        en: 'Defamation on YOU',
        de: 'Ehrenstrafe aud DIR',
        fr: 'Diffamation sur VOUS',
        ja: '名誉罰',
        cn: '大圈点名',
        ko: '명예형: 큰 광역공격'
      },
      solidarity: {
        en: 'Shared Sentence: stack',
        de: 'Urteil Kollektivstrafe: stack',
        fr: 'Peine collective : packez-vous',
        ja: '集団罰: ',
        cn: '分摊点名',
        ko: '집단형: 오른쪽/함께 맞기'
      },
      severity: {
        en: 'Severity: avoid shared stack',
        de: 'Erschwertes: geteilter stack ausweichen',
        fr: 'Sévérité : éloignez-vous du package',
        ja: '加重罰',
        cn: '电点名：远离分摊',
        ko: '가중형; 왼쪽/가중형끼리 모이기'
      },
      noDebuff: {
        en: 'No debuff: shared stack',
        de: 'Kein debuff: geteilter stack',
        fr: 'Pas de debuff : package partagé',
        ja: 'デバフ無し',
        cn: '无Debuff：分组分摊',
        ko: '디버프 없음; 오른쪽/함께 맞기'
      }
    }
  }, {
    id: 'TEA Alpha Ordained Motion 1',
    type: 'Ability',
    netRegex: {
      source: 'Perfect Alexander',
      id: '4B0D',
      capture: false
    },
    durationSeconds: 8,
    suppressSeconds: 20,
    infoText: (_data, _matches, output) => output.motionFirst(),
    run: data => data.firstAlphaOrdainedText = 'motionFirst',
    outputStrings: {
      motionFirst: ordainedOutputStrings.motionFirst
    }
  }, {
    id: 'TEA Alpha Ordained Stillness 1',
    type: 'Ability',
    netRegex: {
      source: 'Perfect Alexander',
      id: '4B0E',
      capture: false
    },
    durationSeconds: 8,
    suppressSeconds: 20,
    infoText: (_data, _matches, output) => output.stillnessFirst(),
    run: data => {
      data.firstAlphaOrdainedText = 'stillnessFirst';
    },
    outputStrings: {
      stillnessFirst: ordainedOutputStrings.stillnessFirst
    }
  }, {
    id: 'TEA Alpha Ordained Motion 2',
    type: 'Ability',
    netRegex: {
      source: 'Perfect Alexander',
      id: '4899',
      capture: false
    },
    durationSeconds: 15,
    suppressSeconds: 20,
    infoText: (data, _matches, output) => {
      data.secondAlphaOrdainedText = 'motionSecond';
      return output.combined({
        action1: output[data.firstAlphaOrdainedText ?? 'unknown'](),
        action2: output[data.secondAlphaOrdainedText]()
      });
    },
    tts: (data, _matches, output) => output[data.secondAlphaOrdainedText ?? 'unknown'](),
    outputStrings: ordainedOutputStrings
  }, {
    id: 'TEA Alpha Ordained Stillness 2',
    type: 'Ability',
    netRegex: {
      source: 'Perfect Alexander',
      id: '489A',
      capture: false
    },
    durationSeconds: 15,
    suppressSeconds: 20,
    infoText: (data, _matches, output) => {
      data.secondAlphaOrdainedText = 'stillnessSecond';
      return output.combined({
        action1: output[data.firstAlphaOrdainedText ?? 'unknown'](),
        action2: output[data.secondAlphaOrdainedText]()
      });
    },
    tts: (data, _matches, output) => output[data.secondAlphaOrdainedText ?? 'unknown'](),
    outputStrings: ordainedOutputStrings
  }, {
    id: 'TEA Alpha Safe Spot',
    type: 'Ability',
    // The non-safe alexanders use 489F.
    netRegex: {
      source: 'Perfect Alexander',
      id: '49AA'
    },
    durationSeconds: 10,
    infoText: (data, matches, output) => {
      // TODO: this is overly complicated.
      // Alexanders always appear in the same spots and it's always
      // the second or third Alexander that is the safe spot.

      // Alexanders from left to right are:
      // 0: 78.28883, 91.00694 (~-67 degrees from north)
      // 1: 91.00694, 78.28883 (~-22 degrees from north)
      // 2: 108.9931, 78.28883 (~+22 degrees from north)
      // 3: 121.7112, 91.00694 (~+67 degrees from north)
      // center: 100, 100 (with +x = east and +y = south)

      // If they are all rotated equally, then:
      // rotation = idx * scale + rot0
      const rot0 = Math.atan2(78.28883 - 100, 100 - 91.00694);
      const rot1 = Math.atan2(91.00694 - 100, 100 - 78.28883);
      const scale = rot1 - rot0; // == Math.PI / 4

      const x = parseFloat(matches.x) - 100;
      const y = 100 - parseFloat(matches.y);
      // idx is in [0, 1, 2, 3]
      const idx = Math.round((Math.atan2(x, y) - rot0) / scale);

      // Store in case anybody wants to mark this.
      data.safeAlphaIdx = idx;
      data.safeAlphaPos = [matches.x, matches.y];

      // Unknown idx?
      if (idx !== 1 && idx !== 2) return;
      if (data.me === data.alphaDefamation) {
        if (idx === 1) return output.defamationFrontLeft();
        return output.defamationFrontRight();
      }
      if (idx === 1) return output.partyBackRight();
      return output.partyBackLeft();
    },
    outputStrings: {
      defamationFrontLeft: {
        en: 'Defamation: front left',
        de: 'Ehrenstrafe: vorne links',
        fr: 'Diffamation : devant à gauche',
        ja: '名誉: 左前',
        cn: '名誉罪: 左前',
        ko: '명예: 왼쪽 앞!!!'
      },
      defamationFrontRight: {
        en: 'Defamation: front right',
        de: 'Ehrenstrafe: vorne rechts',
        fr: 'Diffamation : devant à droite',
        ja: '名誉: 右前',
        cn: '名誉罪: 右前',
        ko: '명예: 오른쪽 앞!!!'
      },
      partyBackRight: {
        en: 'Party: back right',
        de: 'Gruppe: hinten rechts',
        fr: 'Groupe : derrière à droite',
        ja: '右後ろ',
        cn: '右后',
        ko: '오른쪽 뒤!!!'
      },
      partyBackLeft: {
        en: 'Party: back left',
        de: 'Gruppe: hinten links',
        fr: 'Groupe : derrière à gauche',
        ja: '左後ろ',
        cn: '左后',
        ko: '왼쪽 뒤!!!'
      }
    }
  }, {
    id: 'TEA Alpha Resolve First Motion',
    type: 'Ability',
    netRegex: {
      source: 'Perfect Alexander',
      id: '487C',
      capture: false
    },
    // 5 seconds until mechanic
    delaySeconds: 2.2,
    alertText: (data, _matches, output) => {
      if (data.firstAlphaOrdainedText === 'motionFirst') return output.moveFirst();
      return output.stillnessFirst();
    },
    outputStrings: {
      moveFirst: {
        en: 'Move First',
        de: 'Zuerst bewegen',
        fr: 'Bougez en premier',
        ja: '最初は動く',
        cn: '首先移动',
        ko: '우선 움직이기'
      },
      stillnessFirst: {
        en: 'Stillness First',
        de: 'Zuerst Stillstehen',
        fr: 'Restez immobile en premier',
        ja: '最初は止まる',
        cn: '首先静止',
        ko: '우선 멈추기'
      }
    }
  }, {
    id: 'TEA Alpha Resolve Second Motion',
    type: 'Ability',
    netRegex: {
      source: 'Perfect Alexander',
      id: '487C',
      capture: false
    },
    // ~4 seconds until mechanic (to avoid overlapping with first)
    delaySeconds: 7.2,
    alertText: (data, _matches, output) => {
      if (data.secondAlphaOrdainedText === 'motionSecond') return output.keepMoving();
      return output.stopEverything();
    },
    outputStrings: {
      keepMoving: {
        en: 'Keep Moving',
        de: 'weiter bewegen',
        fr: 'Continuez à bouger',
        ja: '最後は動く',
        cn: '保持移动',
        ko: '마지막엔 움직이기'
      },
      stopEverything: {
        en: 'Stop Everything',
        de: 'Alles stoppen',
        fr: 'Arrêtez tout',
        ja: '最後は止まる',
        cn: '保持静止',
        ko: '마지막엔 멈추기'
      }
    }
  }, {
    id: 'TEA Beta Instructions',
    type: 'Tether',
    netRegex: {
      id: '0062',
      capture: false
    },
    condition: data => data.phase === 'beta',
    delaySeconds: 1,
    suppressSeconds: 10,
    run: data => {
      const tetherBois = data.tetherBois ??= {};
      // See notes in TEA Alpha Instructions about what's going on here.
      const sortedIds = Object.keys(tetherBois).sort().reverse();
      const sortedNames = sortedIds.map(x => tetherBois[x]);
      data.betaBait = [sortedNames[0], sortedNames[1]];
      data.betaJumps = [sortedNames[0], sortedNames[2], sortedNames[6]];
      data.betaIndex = sortedNames.indexOf(data.me);
    }
  }, {
    id: 'TEA Beta Instructions Callout',
    type: 'Tether',
    netRegex: {
      id: '0062',
      capture: false
    },
    condition: data => data.phase === 'beta',
    delaySeconds: 2,
    durationSeconds: 35,
    suppressSeconds: 10,
    // TODO: switch this all to a response.
    alarmText: (data, _matches, output) => {
      // Baiters get an alarm text.
      if (data.betaBait?.includes(data.me)) return betaInstructions(data.betaIndex, output);
    },
    alertText: (data, _matches, output) => {
      // The west and south jump get an alert text.
      if (data.betaBait?.includes(data.me)) return;
      if (data.betaJumps?.includes(data.me)) return betaInstructions(data.betaIndex, output);
    },
    infoText: (data, _matches, output) => {
      // The rest of the group (going north) gets info.
      if (data.betaBait?.includes(data.me)) return;
      if (data.betaJumps?.includes(data.me)) return;
      return betaInstructions(data.betaIndex, output);
    },
    outputStrings: {
      unknown: {
        // If you don't know, it's probably best for you to pretend like
        // you're running E->S so that there's a jump there and you
        // don't kill your friends stacking north.
        en: 'No Clone: maybe purple E->S ???',
        de: 'Keine Klone: vielleicht Lila O->S ???',
        fr: 'Pas de Clone : peut-être E->S ???',
        ja: 'クローン無し: 多分東から南???',
        cn: '没有分身: 可能紫色 东->南 ???',
        ko: '분신 없음: 아마도 동→남 ???'
      },
      purpleBait: {
        en: 'Purple Bait: bait E',
        de: 'Lila Köder: locke O',
        fr: 'Attirez le Violet : attirez à l\'E',
        ja: '逃亡監察: 東へ',
        cn: '大暗: 东',
        ko: '보라/도망감찰: 유도역할/동쪽'
      },
      orangeBait: {
        en: 'Orange Bait: bait N',
        de: 'Orange Köder: locke N',
        fr: 'Attirez l\'Orange : attirez au N',
        ja: '接触保護: 北へ',
        cn: '大光: 北',
        ko: '노랑/접촉보호: 유도역할/북쪽'
      },
      purpleNoTether: {
        en: 'Purple, no tether: E->W',
        de: 'Lila, keine Verbindung: O->W',
        fr: 'Violet, pas de lien : E->O',
        ja: '逃亡禁止, 線無し: 東から西へ',
        cn: '小暗, 无连线: 东->西',
        ko: '보라/접촉금지/선없음: 동→서'
      },
      orangeNoTether: {
        // This person also has the shared sentence.
        en: 'Orange, no tether: E->N',
        de: 'Orange, keine Verbindung: O->N',
        fr: 'Orange, pas de lien : E->N',
        ja: '接触禁止, 線無し: 東から北へ',
        cn: '小光, 无连线: 东->北',
        ko: '노랑/접촉금지/선없음: 동→북'
      },
      purpleCloseTether: {
        en: 'Purple, close tether: E->N',
        de: 'Lila, nahe Verbindungr: O->N',
        fr: 'Violet, lien rapproché : E->N',
        ja: '逃亡禁止, 接近強制: 東から北へ',
        cn: '小暗, 接近连线: 东->北',
        ko: '보라/도망금지/강제접근: 동→북'
      },
      orangeCloseTether: {
        en: 'Orange, close tether: E->N',
        de: 'Orange, nahe Verbindung: O->N',
        fr: 'Orange, lien rapproché : E->N',
        ja: '接触禁止, 接近強制: 東から北へ',
        cn: '小光, 接近连线: 东->北',
        ko: '노랑/접촉금지/강제접근: 동→북'
      },
      purpleFarTether: {
        en: 'Purple, far tether: E->S',
        de: 'Lila, entfernte Verbindung: O->S',
        fr: 'Violet, lien éloigné : E->S',
        ja: '逃亡禁止, 接近禁止: 東から南へ',
        cn: '小暗, 远离连线: 东->南',
        ko: '보라/도망금지/접근금지: 동→남'
      },
      orangeFarTether: {
        en: 'Orange, far tether: E->N',
        de: 'Orange, entfernte Verbindung: O->N',
        fr: 'Orange, lien éloigné : E->N',
        ja: '接触禁止, 接近禁止: 東から北へ',
        cn: '小光, 远离连线: 东->北',
        ko: '노랑/접촉금지/접근금지: 동→북'
      }
    }
  }, {
    id: 'TEA Beta Radiant',
    type: 'Ability',
    netRegex: {
      source: 'Perfect Alexander',
      id: '489E'
    },
    infoText: (data, matches, output) => {
      // Track which perfect alexander clone did this.
      data.radiantSourceId = matches.sourceId;

      // Round location to nearest cardinal.
      const x = parseFloat(matches.x) - 100;
      const y = 100 - parseFloat(matches.y);
      // 0 = N, 1 = E, 2 = S, 3 = W
      const idx = Math.round(Math.atan2(x, y) / Math.PI * 2 + 4) % 4;
      const outputMap = {
        // North shouldn't be possible.
        // But, leaving this here in case my math is wrong.
        0: 'north',
        1: 'east',
        2: 'south',
        3: 'west'
      };
      data.radiantOutputStringKey = outputMap[idx];
      if (data.radiantOutputStringKey !== undefined) return output[data.radiantOutputStringKey]();
    },
    outputStrings: radiantOutputStrings
  }, {
    // For reference:
    // Spread (on Alexander) is 48A0.
    // Stack (on Alexander) is 48A1.
    // Spread (per person) is 48A2.
    // Stack (two people) is 48A3.
    id: 'TEA Beta Optical Spread',
    type: 'Ability',
    netRegex: {
      source: 'Perfect Alexander',
      id: '48A0',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.betaIsOpticalStack = false,
    outputStrings: {
      text: {
        en: 'Optical Spread',
        de: 'Visier verteilen',
        fr: 'Dispersion optique',
        ja: '散開',
        cn: '分散',
        ko: '옵티컬: 산개'
      }
    }
  }, {
    id: 'TEA Beta Optical Stack',
    type: 'Ability',
    netRegex: {
      source: 'Perfect Alexander',
      id: '48A1',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.betaIsOpticalStack = true,
    outputStrings: {
      text: {
        en: 'Optical Stack',
        de: 'Visier sammeln',
        fr: 'Package optique',
        ja: 'シェア',
        cn: '分摊',
        ko: '옵티컬: 모이기'
      }
    }
  }, {
    id: 'TEA Beta Optical Final',
    type: 'Ability',
    netRegex: {
      source: 'Perfect Alexander',
      id: '4B14',
      capture: false
    },
    delaySeconds: 12.2,
    alertText: (data, _matches, output) => {
      if (!data.betaIsOpticalStack) return output.opticalSpread();
      if (data.betaBait?.includes(data.me)) return output.opticalStackOnYou();
    },
    infoText: (data, _matches, output) => {
      if (!data.betaIsOpticalStack) return;

      // Error?
      if (!data.betaBait || data.betaBait.length === 0) return output.opticalStack();
      const names = data.betaBait.map(x => x !== undefined ? data.party.member(x) : output.unknown()).sort();
      return output.opticalStackPlayers({
        players: names
      });
    },
    outputStrings: {
      unknown: outputs/* default.unknown */.Z.unknown,
      opticalStack: {
        en: 'Optical Stack',
        de: 'Visier sammeln',
        fr: 'Package optique',
        ja: 'オプチカル 集合',
        cn: '集合',
        ko: '옵티컬: 모이기'
      },
      opticalStackPlayers: {
        en: 'Optical Stack (${players})',
        de: 'Visier sammeln (${players})',
        fr: 'Package optique (${players})',
        ja: 'オプチカル 集合 (${players})',
        cn: '集合 (${players})',
        ko: '옵티컬: 모이기 (${players})'
      },
      opticalSpread: {
        en: 'Optical Spread',
        de: 'Visier verteilen',
        fr: 'Dispersion optique',
        ja: '散開',
        cn: '分散',
        ko: '옵티컬: 산개'
      },
      opticalStackOnYou: {
        en: 'Optical Stack on YOU',
        de: 'Visier sammeln auf DIR',
        fr: 'Package optique sur VOUS',
        ja: '自分にシェア',
        cn: '集合点名',
        ko: '옵티컬: 나에게 모이기'
      }
    }
  }, {
    id: 'TEA Beta Radiant Final',
    type: 'Ability',
    netRegex: {
      source: 'Perfect Alexander',
      id: '4B14',
      capture: false
    },
    condition: data => data.radiantOutputStringKey !== undefined,
    delaySeconds: 16,
    alertText: (data, _matches, output) => output[data.radiantOutputStringKey ?? 'unknown'](),
    outputStrings: radiantOutputStrings
  }, {
    id: 'TEA Ordained Punishment',
    type: 'StartsUsing',
    netRegex: {
      source: 'Perfect Alexander',
      id: '4891'
    },
    // Because this is two in a row, make this second one info.
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap('info', 'alarm')
  }, {
    id: 'TEA Trine Get Middle',
    type: 'Ability',
    netRegex: {
      source: 'Perfect Alexander',
      id: '488E',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack Middle for Trine',
        de: 'Mittig sammeln für Trine',
        fr: 'Packez-vous au milieu pour Trine',
        ja: '大審判来るよ',
        cn: '大审判 中间集合',
        ko: '대심판이 옵니다, 가운데로'
      }
    }
  }, {
    id: 'TEA Trine Initial',
    type: 'Ability',
    netRegex: {
      source: 'Perfect Alexander',
      id: '488F'
    },
    alertText: (data, matches, output) => {
      // Looking for (100, 92), (100, 100), or (100, 108).
      const x = Math.round(parseFloat(matches.x));
      const y = Math.round(parseFloat(matches.y));
      if (x !== 100) return;
      data.trine ??= [];
      // See: https://imgur.com/a/l1n9MhS
      const trineMap = {
        92: 'r',
        100: 'g',
        108: 'y'
      };
      const thisTrine = trineMap[y];
      if (thisTrine === undefined) return;
      data.trine.push(thisTrine);

      // Call out after two, because that's when the mechanic is fully known.
      data.trine ??= [];
      if (data.trine.length !== 2) return;

      // Find the third one based on the first two.
      const threeArr = ['r', 'g', 'y'].filter(x => !data.trine?.includes(x));
      const [three] = threeArr;
      const [one] = data.trine;
      if (one === undefined || three === undefined) return;

      // Start on the third trine, then move to the first.
      const threeOne = three + one;

      // For parks and other forestry solutions.
      const locations = {
        r: [92, 100],
        g: [100, 100],
        y: [108, 100]
      };
      data.trineLocations = [locations[three], locations[one]];

      // Here's the cactbot strategy.  We'll call this the Zed strategy,
      // as all the movement is along these five squares that form a Z.
      // If these are the circles from https://imgur.com/a/l1n9MhS
      // r = red, g = green, y = yellow, capital = part of the Z
      //
      //   g r y r g
      //
      //   y Y-R g r
      //       |
      //   r g G g y
      //       |
      //   y g Y-R r
      //
      //   g y r y g
      //
      // Goals:
      // * Start in an obvious place (i.e. the middle of the room).
      // * Players will only have to move in cardinal directions (no diagonals).
      // * Players will only have to make two moves.
      // * The only motion will be along the 5 capital letters connected with lines.
      //
      // Algorithm.
      // (1) Start mid, look north.
      // (2) Watch the three trines in the Z from the middle column.
      //     This is the centered vertical R-G-Y in the diagram.
      // (3) Observe which one is #3.
      // (3) Choose one of (Wait Mid, Move North, Move South) to move to the #3 trine.
      // (4) From #3, only picking from circles in the Z, there is exactly
      //     one adjacent #1 (and exactly one adjacent #2).
      // (5) Move to the #1 circle once #3 explodes.
      // (6) Good work, team.
      //
      // Example:
      // Trines come down with r=1, g=2, y=3 (or north to south 1 2 3 in the middle box).
      // You'd move south to end up on the #3 trine.  Since you know #2 is in the middle
      // the second motion is to go east on the Z.

      // Each three to one has a different set of movements.
      // Call both out to start, then a separate trigger
      // once the first has happened.

      switch (threeOne) {
        case 'gr':
          data.secondTrineResponse = 'north';
          return output.waitMiddleDodgeNorth();
        case 'rg':
          data.secondTrineResponse = 'south';
          return output.goNorthDodgeSouth();
        case 'ry':
          data.secondTrineResponse = 'west';
          return output.goNorthDodgeWest();
        case 'yr':
          data.secondTrineResponse = 'east';
          return output.goSouthDodgeEast();
        case 'gy':
          data.secondTrineResponse = 'south';
          return output.waitMiddleDodgeSouth();
        case 'yg':
          data.secondTrineResponse = 'north';
          return output.goSouthDodgeNorth();
      }
    },
    outputStrings: {
      waitMiddleDodgeNorth: {
        en: 'Wait Middle, Dodge North',
        de: 'Warte in der Mitte, ausweichen nach Norden',
        fr: 'Attendez au milieu, esquivez au Nord',
        ja: '中央から北へ',
        cn: '中间 -> 北',
        ko: '가운데서 북쪽으로'
      },
      goNorthDodgeSouth: {
        en: 'Go 1 North, Dodge South',
        de: 'Geh nach Norden, ausweichen nach Süden',
        fr: 'Allez 1 au Nord, esquivez au Sud',
        ja: '北から中央へ',
        cn: '北 -> 中间',
        ko: '북쪽에서 가운데로'
      },
      goNorthDodgeWest: {
        en: 'Go 1 North, Dodge West',
        de: 'Geh nach Norden, ausweichen nach Westen',
        fr: 'Allez 1 au Nord, esquivez à l\'Ouest',
        ja: '北から西へ',
        cn: '北 -> 西',
        ko: '북쪽에서 서쪽으로'
      },
      goSouthDodgeEast: {
        en: 'Go 1 South, Dodge East',
        de: 'Geh nach Süden, ausweichen nach Osten',
        fr: 'Allez 1 au Sud, esquivez à l\'Est',
        ja: '南から東へ',
        cn: '南 -> 东',
        ko: '남쪽에서 동쪽으로'
      },
      waitMiddleDodgeSouth: {
        en: 'Wait Middle, Dodge South',
        de: 'Warte in der Mitte, ausweichen nach Süden',
        fr: 'Attendez au milieu, esquivez au Sud',
        ja: '中央から南へ',
        cn: '中间 -> 南',
        ko: '가운데서 남쪽으로'
      },
      goSouthDodgeNorth: {
        en: 'Go 1 South, Dodge North',
        de: 'Geh nach Süden, ausweichen nach Norden',
        fr: 'Allez 1 au Sud, esquivez au Nord',
        ja: '南から北へ',
        cn: '南 -> 北',
        ko: '남쪽에서 북쪽으로'
      }
    }
  }, {
    id: 'TEA Trine Second',
    type: 'Ability',
    netRegex: {
      source: 'Perfect Alexander',
      id: '4890',
      capture: false
    },
    suppressSeconds: 15,
    alertText: (data, _matches, output) => output[data.secondTrineResponse ?? 'unknown'](),
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      east: outputs/* default.east */.Z.east,
      south: {
        // It is a bit different in JA/CN that players should go middle instead of south,
        // so leave it alone.
        en: 'South',
        de: 'Süden',
        fr: 'Sud',
        ja: '中央へ',
        cn: '中间',
        ko: '가운데로'
      },
      west: outputs/* default.west */.Z.west
    }
  }, {
    id: 'TEA Irresistible Grace',
    type: 'StartsUsing',
    netRegex: {
      source: 'Perfect Alexander',
      id: '4894'
    },
    // Don't collide with trine.
    delaySeconds: 2,
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn('info'),
    run: data => {
      delete data.trine;
      delete data.secondTrineResponse;
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      '(?<! )Alexander(?! )': 'Alexander',
      'Alexander Prime': 'Prim-Alexander',
      'Brute Justice': 'Brutalus',
      'Cruise Chaser': 'Chaser-Mecha',
      'Jagd Doll': 'Jagdpuppe',
      'Judgment Crystal': 'Urteilskristall',
      'Liquid Hand': 'belebte Hand',
      'Living Liquid': 'belebtes Wasser',
      'Liquid Rage': 'levitierte Rage',
      'Perfect Alexander': 'Perfekter Alexander',
      'Steam Chakram': 'Dampf-Chakram'
    },
    'replaceText': {
      '--Cruise Chaser Invincible--': '--Chaser-Mecha unverwundbar--',
      '--alex untargetable--': '--alex nich anvisierbar--',
      'Almighty Judgment': 'Göttliches Letzturteil',
      'Alpha Sword': 'Alpha-Schwert',
      'Apocalyptic Ray': 'Apokalyptischer Strahl ',
      'Cascade': 'Kaskade',
      'Chakrams': 'Chakrams',
      'Chastening Heat': 'Brennende Verdammung',
      'Collective Reprobation': 'Kollektivstrafe',
      'Divine Judgment': 'Göttliches Urteil',
      'Divine Spear': 'Heiliger Speer',
      'Double Rocket Punch': 'Doppelraketenschlag',
      'Down for the Count': 'Am Boden',
      'Drainage': 'Entwässerung',
      'Earth Missile': 'Erd-Geschoss',
      'Embolus': 'Pfropfen',
      'Enumeration': 'Enumeration',
      'Eternal Darkness': 'Ewiges Dunkel',
      'Exhaust': 'Abgase',
      'Fate Calibration': 'Zukunftswahl',
      'Fate Projection': 'Zukunftsberechnung',
      'Final Sentence': 'Todesstrafe',
      'Flarethrower': 'Flammenwerfer',
      'Fluid Strike': 'Flüssiger Schlag',
      'Fluid Swing': 'Flüssiger Schwung',
      'Gavel': 'Prozessende',
      'Hand of Pain': 'Qualhand',
      'Hand of Prayer(?!/)': 'Betende Hand',
      'Hand of Prayer/Parting': 'Scheidende/Betende Hand',
      'Hawk Blaster': 'Jagdfalke',
      'Hidden Minefield': 'Getarntes Minenfeld',
      'Inception(?! )': 'Raumzeit-Eingriff',
      'Inception Formation': 'Raumzeit-Eingriffsformation',
      'Incinerating Heat': 'Sengende Hitze',
      'Irresistible Grace': 'Sammelurteil',
      'J Jump': 'Gewissenssprung',
      'J Kick': 'Gewissenstritt',
      'J Storm': 'Gerechter Sturm',
      'Judgment Crystal': 'Urteilskristall',
      'Judgment Nisi': 'Vorläufige Vollstreckung',
      'Limit Cut': 'Grenzwertüberschreitung',
      'Link-Up': 'Zusammenschluss',
      'Mega Holy': 'Super-Sanctus',
      'Middle Blaster': 'Mitte - Blaster',
      'Missile Command': 'Raketenkommando',
      'Obloquy': 'Ehre',
      'Optical Sight': 'Visier',
      'Ordained Capital Punishment': 'Gnadenlose Ahndung',
      'Ordained Motion(?!/)': 'Bewegungsbefehl',
      'Ordained Motion/Stillness': 'Bewegungs/Stillstands-befehl',
      'Ordained Punishment': 'Ahndung',
      'Photon': 'Photon',
      'Players Remaining': 'Spieler übrig',
      'Propeller Wind': 'Luftschraube',
      'Protean Wave': 'Proteische Welle',
      '(?<! )Repentance': 'Reue',
      'Rage Wave': 'Rage - Welle',
      'Sacrament': 'Sakrament',
      'Severity': 'Erschwertes',
      'Sluice': 'Schleusenöffnung',
      'Solidarity': 'Kollektiv',
      'Spin Crusher': 'Rotorbrecher',
      'Splash': 'Schwall',
      'Summon Alexander': 'Alexanders Beschwörung',
      'Super Blassty Charge': 'Super-Blassty-Ladung',
      'Super Jump': 'Supersprung',
      'Surety': 'Ortsbindung',
      'Temporal Interference': 'Raumzeit-Manipulation',
      'Temporal Prison': 'Zeitzelle',
      'Temporal Stasis': 'Zeitstillstand',
      'The Final Word': 'Strafzumessung',
      'Throttles': 'Erstickungen',
      'True Heart': 'Reines Herz',
      'Void Of Repentance': 'Kammer der Buße',
      'Water and Thunder': 'Wasser und Blitz',
      'Waves': 'Wellen',
      'Whirlwind': 'Wirbelwind',
      'Wormhole Formation': 'Dimensionsspaltungsformation'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '(?<! )Alexander(?! )': 'Alexander',
      'Alexander Prime': 'Primo-Alexander',
      'Brute Justice': 'Justicier',
      'Cruise Chaser': 'Croiseur-chasseur',
      'Jagd Doll': 'poupée jagd',
      'Judgment Crystal': 'Cristal du jugement',
      'Liquid Hand': 'membre liquide',
      'Liquid Rage': 'furie liquide',
      'Living Liquid': 'liquide vivant',
      'Perfect Alexander': 'Alexander parfait',
      'Steam Chakram': 'chakram de vapeur'
    },
    'replaceText': {
      '--alex untargetable--': '--alex non ciblable--',
      '--Cruise Chaser Invincible--': '--Croiseur-chasseur Invincible--',
      'Almighty Judgment': 'Sentence divine',
      'Alpha Sword': 'Épée alpha',
      'Apocalyptic Ray': 'Rayon apocalyptique',
      'Cascade': 'Cascade',
      'Chakrams': 'Chakrams',
      'Chastening Heat': 'Chaleur de l\'ordalie',
      'Divine Judgment': 'Jugement divin',
      'Divine Spear': 'Épieu divin',
      'Double Rocket Punch': 'Double coup de roquette',
      'Down for the Count': 'Au tapis',
      'Drainage': 'Drainage',
      'Earth Missile': 'Missile de terre',
      'Embolus': 'Caillot',
      'Enumeration': 'Compte',
      'Eternal Darkness': 'Ténèbres éternelles',
      'Exhaust': 'Échappement',
      'Fate:': 'Sorts :',
      'Fate Calibration': 'Bilan futurologique',
      'Fate Projection': 'Étude futurologique',
      'Final Sentence': 'Peine capitale',
      'Flarethrower': 'Lance-brasiers',
      'Fluid Strike': 'Frappe fluide',
      'Fluid Swing': 'Coup fluide',
      'Gavel': 'Conclusion de procès',
      'Hand of Pain': 'Main de douleur',
      'Hand of Prayer/Parting': 'Main de prière/séparation',
      'Hawk Blaster': 'Canon faucon',
      'Hidden Minefield': 'Champ de mines caché',
      'Inception(?! )': 'Commencement',
      'Inception Formation': 'Marche du commencement',
      'Incinerating Heat': 'Chaleur purifiante',
      'Individual/Collective Reprobation': 'Réprobation individuelle/collective',
      'Irresistible Grace': 'Peines interdépendantes',
      'J Jump': 'Bond justicier',
      'J Kick': 'Pied justicier',
      'J Storm \\+ Waves': 'Tempête justicière + Vagues',
      'Judgment Crystal': 'Cristal du jugement',
      'Judgment Nisi': 'Jugement conditionnel',
      'Limit Cut': 'Dépassement de limites',
      'Link-Up': 'Effort collectif',
      'Mega Holy': 'Méga Miracle',
      'Middle Blaster': 'Canon au milieu',
      'Missile Command': 'Commande missile',
      'Obloquy, Solidarity and 3x Severity': 'Infamie, Solidarité et 3x Sévérité',
      'Optical Sight': 'Visée optique',
      'Ordained Capital Punishment': 'Châtiment exemplaire',
      'Ordained Motion/Stillness': 'Défense de s\'arrêter/de bouger',
      'Ordained Punishment': 'Châtiment',
      'Photon': 'Photon',
      'Players Remaining': 'Joueurs restants',
      'Propeller Wind': 'Vent turbine',
      'Protean Wave': 'Vague inconstante',
      'Rage Wave': 'Vague inconstante',
      '(?<! )Repentance': 'Repentir',
      'Sacrament': 'Sacrement',
      'Surety and Severity': 'Serment et Sévérité',
      'Surety and Solidarity': 'Serment et Solidarité',
      'Surety, Solidarity and Severity': 'Serment, Solidarité et Sévérité',
      'Sluice': 'Éclusage',
      'Spin Crusher': 'Écrasement tournoyant',
      'Splash': 'Éclaboussement',
      'Summon Alexander': 'Invocation d\'Alexander',
      'Super Blassty Charge': 'Super charge Blassty',
      'Super Jump': 'Super saut',
      'Temporal Interference': 'Interférences spatio-temporelles',
      'Temporal Prison': 'Geôle temporelle',
      'Temporal Stasis': 'Stase temporelle',
      'The Final Word': 'Prononcé du jugement',
      'Throttle': 'Cadence Améliorée',
      'True Heart': 'Affection féline',
      'Void Of Repentance': 'Vide du repentir',
      'Water and Thunder': 'Eau et Foudre',
      'Whirlwind': 'Tornade',
      'Wormhole Formation': 'Marche de la fracture dimensionnelle'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '(?<! )Alexander(?! )': 'アレキサンダー',
      'Alexander Prime': 'アレキサンダー・プライム',
      'Brute Justice': 'ブルートジャスティス',
      'Cruise Chaser': 'クルーズチェイサー',
      'Jagd Doll': 'ヤークトドール',
      'Liquid Hand': 'リキッドハンド',
      'Liquid Rage': 'リキッドレイジ',
      'Living Liquid': 'リビングリキッド',
      'Perfect Alexander': 'パーフェクト・アレキサンダー',
      'Steam Chakram': 'スチームチャクラム',
      'Judgment Crystal': '審判の結晶'
    },
    'replaceText': {
      '--alex untargetable--': '--アレキサンダー タゲ不可--',
      '--Cruise Chaser Invincible--': '--クルーズチェイサー インビン--',
      'Almighty Judgment(?! Reveal)': '聖なる大審判',
      'Almighty Judgment Reveal': '聖なる大審判 出現',
      'Alpha Sword': 'アルファソード',
      'Apocalyptic Ray': 'アポカリプティクレイ',
      'Cascade': 'カスケード',
      'Chakrams': 'ビームチャクラム',
      'Chastening Heat': '神罰の熱線',
      'Divine Judgment': '聖なる審判',
      'Divine Spear': '聖なる炎',
      'Double Rocket Punch': 'ダブルロケットパンチ',
      'Down for the Count': 'ノックダウン',
      'Drainage': 'ドレナージ',
      'Earth Missile': 'アースミサイル',
      'Embolus': 'エンボラス',
      'Enumeration': 'カウント',
      'Eternal Darkness': '暗黒の運命',
      'Exhaust': '汚染蒸気',
      'Fate:': '未来観測:',
      'Fate Calibration': '未来確定',
      'Fate Projection': '未来観測',
      'Final Sentence': '死刑判決',
      'Flarethrower': '大火炎放射',
      'Fluid Strike': 'フルイドストライク',
      'Fluid Swing': 'フルイドスイング',
      'Gavel': '最後の審判：結審',
      'Hand of Pain': 'ハンド・オブ・ペイン',
      'Hand of Prayer': 'ハンド・オブ・プレイヤー',
      'Hawk Blaster': 'ホークブラスター',
      'Hidden Minefield': 'ステルス地雷散布',
      'Inception(?! )': '時空潜行',
      'Inception Formation': '時空潜行のマーチ',
      'Incinerating Heat': '浄化の熱線',
      'Individual/Collective Reprobation': '個の断罪/群の断罪',
      'Irresistible Grace': '連帯刑',
      'J Jump': 'ジャスティスジャンプ',
      'J Kick': 'ジャスティスキック',
      'J Storm': 'ジャスティスストーム',
      'Judgment Crystal': '審判の結晶',
      'Judgment Nisi': 'ジャッジメントナイサイ',
      'Limit Cut': 'リミッターカット',
      'Link-Up': 'システムリンク',
      'Mega Holy': 'メガホーリー',
      'Middle Blaster': '中央のブラスター',
      'Missile Command': 'ミサイル全弾発射',
      'Obloquy, Solidarity and 3x Severity': '汚名 + 連帯 + 3x 重罰の神判',
      'Optical Sight': '照準',
      'Ordained Capital Punishment': '加重誅罰',
      'Ordained Motion/Stillness': '行動命令/静止命令',
      'Ordained Punishment': '誅罰',
      'Photon': 'フォトン',
      'Players Remaining': 'プレーヤー残り',
      'Propeller Wind': 'プロペラウィンド',
      'Protean Wave': 'プロティアンウェイブ',
      'Radiant Sacrament': '拝火の秘蹟',
      'Rage Wave': 'リキッドレイジ ウェイブ',
      '(?<! )Repentance': '罪の意識',
      '(?<!Radiant )Sacrament': '十字の秘蹟',
      'Surety and Severity': '誓約 + 重罰の神判',
      'Surety and Solidarity': '誓約 + 連帯の神判',
      'Surety, Solidarity and Severity': '誓約 + 連帯 + 重罰の神判',
      'Sluice': 'スルース',
      'Spin Crusher': 'スピンクラッシャー',
      'Splash': 'スプラッシュ',
      'Summon Alexander': 'アレキサンダー召喚',
      'Super Blassty Charge': 'スーパーブラスティ・チャージ',
      'Super Jump': 'スーパージャンプ',
      'Temporal Interference': '時空干渉',
      'Temporal Prison': '時の牢獄',
      'Temporal Stasis': '時間停止',
      'The Final Word': '確定判決',
      'Throttles': '窒息',
      'Void Of Repentance': '懺悔の間',
      'Water and Thunder': 'クラッシュサンダー',
      'Whirlwind': '竜巻',
      'Wormhole Formation': '次元断絶のマーチ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '(?<! )Alexander(?! )': '亚历山大',
      'Alexander Prime': '至尊亚历山大',
      'Brute Justice': '残暴正义号',
      'Cruise Chaser': '巡航驱逐者',
      'Jagd Doll': '狩猎人偶',
      'Judgment Crystal': '审判结晶',
      'Liquid Hand': '活水之手',
      'Liquid Rage': '活水之怒',
      'Living Liquid': '有生命活水',
      'Perfect Alexander': '完美亚历山大',
      'Steam Chakram': '蒸汽战轮'
    },
    'replaceText': {
      '--Cruise Chaser Invincible--': '--巡航驱逐者无敌--',
      '--alex untargetable--': '--亚历山大无法选中--',
      'True Heart': '真心',
      'Waves': '水波',
      '/Parting': '/离别之手',
      '/Stillness': '/静止命令',
      'Individual/': '单体/',
      'Reveal': '生效',
      ' and': '',
      'Fate: ': '未来: ',
      'Almighty Judgment': '神圣大审判',
      'Alpha Sword': '阿尔法之剑',
      'Apocalyptic Ray': '末世宣言',
      'Cascade': '倾泻',
      'Chakrams': '轮轮',
      'Chastening Heat': '神罚射线',
      'Collective Reprobation': '群体断罪',
      'Divine Judgment': '神圣审判',
      'Divine Spear': '圣炎',
      'Double Rocket Punch': '双重火箭飞拳',
      'Down for the Count': '击倒',
      'Drainage': '排水',
      'Earth Missile': '寒冰导弹',
      'Embolus': '栓塞',
      'Enumeration': '计数',
      'Eternal Darkness': '黑暗命运',
      'Exhaust': '污染蒸汽',
      'Fate Calibration': '未来确定',
      'Fate Projection': '未来观测',
      'Final Sentence': '死刑判决',
      'Flarethrower': '大火炎放射',
      'Fluid Strike': '流体强袭',
      'Fluid Swing': '流体摆动',
      'Gavel': '终审闭庭',
      'Hand of Pain': '苦痛之手',
      'Hand of Prayer': '祈祷之手',
      'Hawk Blaster': '鹰式破坏炮',
      'Hidden Minefield': '隐形地雷散布',
      'Inception(?! )': '时空潜行',
      'Inception Formation': '时空潜行阵列',
      'Incinerating Heat': '净化射线',
      'Irresistible Grace': '株连',
      'J Jump': '正义之跃',
      'J Kick': '正义飞踢',
      'J Storm': '正义旋风',
      'Judgment Crystal': '审判结晶',
      'Judgment Nisi': '非最终审判',
      'Limit Cut': '限制器减档',
      'Link-Up': '系统连接',
      'Mega Holy': '百万神圣',
      'Middle Blaster': '中间冲击波',
      'Missile Command': '导弹齐发',
      'Obloquy': '污名神判',
      'Optical Sight': '制导',
      'Ordained Capital Punishment': '加重诛罚',
      'Ordained Motion': '行动命令',
      'Ordained Punishment': '诛罚',
      'Photon': '光子炮',
      'Players Remaining': '剩余玩家',
      'Propeller Wind': '螺旋桨强风',
      'Protean Wave': '万变水波',
      'Rage Wave': '活水之怒',
      '(?<! )Repentance': '罪恶感',
      'Radiant ': '拜火',
      'Sacrament': '圣礼',
      'Severity': '重罚神判',
      'Sluice': '冲洗',
      'Solidarity': '连带神判',
      'Spin Crusher': '回旋碎踢',
      'Splash': '溅开',
      'Summon Alexander': '召唤亚历山大',
      'Super Blassty Charge': '超级摧毁者冲击',
      'Super Jump': '超级跳跃',
      'Surety': '誓约神判',
      'Temporal Interference': '时空干涉',
      'Temporal Prison': '时间牢狱',
      'Temporal Stasis': '时间停止',
      'The Final Word': '终审判決',
      'Throttles': '窒息',
      'Void Of Repentance': '忏悔区',
      'Water': '水',
      'Thunder': '雷',
      'Whirlwind': '龙卷风',
      'Wormhole Formation': '次元断绝阵列'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '(?<! )Alexander(?! )': '알렉산더',
      'Alexander Prime': '알렉산더 프라임',
      'Brute Justice': '포악한 심판자',
      'Cruise Chaser': '순항추격기',
      'Jagd Doll': '인형 수렵병',
      'Judgment Crystal': '심판의 결정체',
      'Liquid Hand': '액체 손',
      'Liquid Rage': '분노한 액체',
      'Living Liquid': '살아있는 액체',
      'Perfect Alexander': '완전체 알렉산더',
      'Steam Chakram': '증기 차크람'
    },
    'replaceText': {
      '--Cruise Chaser Invincible--': '--순항추격기 무적--',
      '--alex untargetable--': '--알렉산더 타겟 불가능--',
      'True Heart': '진심',
      'Reveal': '예고',
      'Almighty Judgment': '성스러운 대심판',
      'Alpha Sword': '알파검',
      'Apocalyptic Ray': '파멸 계시',
      'Cascade': '폭포수',
      'Chakrams': '차크람',
      'Chastening Heat': '신벌의 열선',
      'Collective Reprobation': '무리 단죄',
      'Divine Judgment': '신성한 심판',
      'Divine Spear': '신성한 불꽃',
      'Double Rocket Punch': '양손 로켓 주먹',
      'Down for the Count': '넉다운',
      'Drainage': '하수로',
      'Earth Missile': '대지 미사일',
      'Embolus': '응고체',
      'Enumeration': '계산',
      'Eternal Darkness': '암흑의 운명',
      'Exhaust': '오염 증기',
      '/Stillness': '정지 명령',
      'Fate: ': '미래: ',
      'Fate Calibration': '미래 확정',
      'Fate Projection': '미래 관측',
      'Final Sentence': '사형 판결',
      'Flarethrower': '대화염방사',
      'Fluid Strike': '유체 강타',
      'Fluid Swing': '유체 타격',
      'Gavel': '최후의 심판: 폐정',
      'Hand of Pain': '고통의 손길',
      'Hand of Prayer/Parting': '기도/작별의 손길',
      'Hawk Blaster': '호크 블래스터',
      'Hidden Minefield': '은폐 지뢰 살포',
      'Inception(?! )': '시공 잠행',
      'Inception Formation': '시공 잠행 대형',
      'Incinerating Heat': '정화의 열선',
      'Individual/': '개체/',
      'Irresistible Grace': '연대 형벌',
      'J Jump': '정의의 점프',
      'J Kick': '정의의 발차기',
      'J Storm': '정의의 폭풍',
      'Waves': '충격파',
      'Judgment Crystal': '심판의 결정체',
      'Judgment Nisi': '임시처분',
      'Limit Cut': '리미터 해제',
      'Link-Up': '시스템 연결',
      'Mega Holy': '메가 홀리',
      'Middle Blaster': '중앙 블래스터',
      // CHECKME
      'Missile Command': '미사일 전탄 발사',
      'Optical Sight': '조준',
      'Ordained Capital Punishment': '가중 처벌',
      'Ordained Motion': '행동 명령',
      'Ordained Punishment': '처벌',
      'Photon': '광자',
      ' Players Remaining': '명 남음',
      'Propeller Wind': '추진 돌풍',
      'Protean Wave': '변화의 물결',
      'Radiant Sacrament': '원형 성례',
      'Rage Wave': '물기둥 물결',
      '(?<! )Repentance': '참회의 방',
      '(?<! )Sacrament': '십자 성례',
      'Sacrament x3': '십자 성례 x3',
      'Surety and Severity': '서약/중벌의 심판',
      'Surety, Solidarity and Severity': '서약/중벌/연대의 심판',
      'Obloquy, Solidarity and 3x Severity': '오명/연대/중벌의 심판',
      'Surety and Solidarity': '서약/연대의 심판',
      'Sluice': '봇물',
      'Spin Crusher': '회전 분쇄',
      'Splash': '물장구',
      'Summon Alexander': '알렉산더 소환',
      'Super Blassty Charge': '슈퍼 블래스티 돌진',
      'Super Jump': '슈퍼 점프',
      'Temporal Interference': '시공 간섭',
      'Temporal Prison': '시간의 감옥',
      'Temporal Stasis': '시간 정지',
      'The Final Word': '확정 판결',
      'Throttles': '질식',
      // CHECKME
      'Void Of Repentance': '참회의 방',
      'Water and Thunder': '물+번개 징',
      'Whirlwind': '회오리바람',
      'Wormhole Formation': '차원 단절 대형'
    }
  }]
};
/* harmony default export */ const the_epic_of_alexander = (the_epic_of_alexander_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/05-shb/ultimate/the_epic_of_alexander.txt
const ultimate_the_epic_of_alexander_namespaceObject = "# The Epic of Alexander (Ultimate)\r\n# https://clees.me/guides/tea/\r\n# -p 49B0:11.4 4830:200 -ii 4978 4979 497B 497A 481E 4B4E 4820\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n### Phase 1: Living Liquid\r\n0 \"Start\"\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11.4 \"Fluid Swing\" Ability { id: \"49B0\", source: \"Living Liquid\" } window 10,2.5\r\n19.5 \"Cascade\" Ability { id: \"4826\", source: \"Living Liquid\" }\r\n35.8 \"Hand of Prayer/Parting\" Ability { id: \"482[BC]\", source: \"Liquid Hand\" }\r\n36.7 \"Rage Wave 1\" Ability { id: \"49B5\", source: \"Liquid Rage\" }\r\n37.7 \"Fluid Swing\" Ability { id: \"49B0\", source: \"Living Liquid\" }\r\n37.7 \"Fluid Strike\" #Ability { id: \"49B7\", source: \"Liquid Hand\" }\r\n38.7 \"Rage Wave 2\" Ability { id: \"49B6\", source: \"Liquid Rage\" }\r\n39.7 \"Exhaust\" Ability { id: \"481E\", source: \"Jagd Doll\" }\r\n41.6 \"Embolus\" Ability { id: \"4829\", source: \"Liquid Rage\" }\r\n42.8 \"Hand of Pain\" Ability { id: \"482D\", source: \"Liquid Hand\" }\r\n50.3 \"Exhaust\" Ability { id: \"481E\", source: \"Jagd Doll\" }\r\n56.7 \"Fluid Swing\" Ability { id: \"49B0\", source: \"Living Liquid\" }\r\n56.7 \"Fluid Strike\" #Ability { id: \"49B7\", source: \"Liquid Hand\" }\r\n69.8 \"Protean Wave 1\" Ability { id: \"4822\", source: \"Living Liquid\" }\r\n70.0 \"Hand of Pain\" Ability { id: \"482D\", source: \"Liquid Hand\" }\r\n71.9 \"Protean Wave 2\" Ability { id: \"4823\", source: \"Living Liquid\" }\r\n74.9 \"Sluice\" Ability { id: \"49B1\", source: \"Living Liquid\" }\r\n75.0 \"Protean Wave 3\" Ability { id: \"4823\", source: \"Living Liquid\" }\r\n81.1 \"Splash x6\" duration 5.6\r\n86.6 \"Drainage\" Ability { id: \"4827\", source: \"Liquid Rage\" }\r\n89.1 \"Hand of Pain\" Ability { id: \"482D\", source: \"Liquid Hand\" }\r\n91.7 \"Cascade\" Ability { id: \"4826\", source: \"Living Liquid\" }\r\n95.9 \"Throttles\" Ability { id: \"4828\", source: \"Liquid Rage\" }\r\n107.0 \"Protean Wave 1\" Ability { id: \"4822\", source: \"Living Liquid\" }\r\n109.0 \"Hand of Pain\" Ability { id: \"482D\", source: \"Liquid Hand\" }\r\n109.1 \"Protean Wave 2\" Ability { id: \"4823\", source: \"Living Liquid\" }\r\n112.0 \"Sluice\" Ability { id: \"49B1\", source: \"Living Liquid\" }\r\n112.1 \"Protean Wave 3\" Ability { id: \"4823\", source: \"Living Liquid\" }\r\n113.0 \"Rage Wave 1\" Ability { id: \"49B5\", source: \"Liquid Rage \" }\r\n115.1 \"Rage Wave 2\" Ability { id: \"49B6\", source: \"Liquid Rage\" }\r\n119.1 \"Embolus\" Ability { id: \"4829\", source: \"Liquid Rage\" }\r\n124.2 \"Hand of Prayer/Parting\" Ability { id: \"482[BC]\", source: \"Liquid Hand\" }\r\n127.4 \"Splash x6\" duration 5.6\r\n129.3 \"Hand of Pain\" Ability { id: \"482D\", source: \"Liquid Hand\" }\r\n134.1 \"Fluid Swing\" Ability { id: \"49B0\", source: \"Living Liquid\" }\r\n142.1 \"Cascade Enrage\" Ability { id: \"49B3\", source: \"Living Liquid\" }\r\n\r\n### Transition 1: Cruise Chaser\r\n196.0 \"--sync--\" RemovedCombatant { name: \"Liquid Hand\" } window 50,0\r\n200.0 \"Hawk Blaster 1\" Ability { id: \"4830\", source: \"Cruise Chaser\" } window 200,0\r\n202.2 \"Hawk Blaster 2\"\r\n204.4 \"Hawk Blaster 3\"\r\n206.6 \"Hawk Blaster 4\"\r\n207.4 \"#1 Alpha Sword\" Ability { id: \"4834\", source: \"Cruise Chaser\" }\r\n208.8 \"Middle Blaster\"\r\n208.9 \"#2 Super Blassty Charge\" Ability { id: \"4B4F\", source: \"Cruise Chaser\" }\r\n211.0 \"Hawk Blaster 1\"\r\n212.1 \"#3 Alpha Sword\" Ability { id: \"4834\", source: \"Cruise Chaser\" }\r\n213.2 \"Hawk Blaster 2\"\r\n213.6 \"#4 Super Blassty Charge\" Ability { id: \"4B4F\", source: \"Cruise Chaser\" }\r\n215.5 \"Hawk Blaster 3\"\r\n216.8 \"#5 Alpha Sword\" Ability { id: \"4834\", source: \"Cruise Chaser\" }\r\n217.7 \"Hawk Blaster 4\"\r\n218.3 \"#6 Super Blassty Charge\" Ability { id: \"4B4F\", source: \"Cruise Chaser\" }\r\n219.9 \"Middle Blaster\"\r\n221.4 \"#7 Alpha Sword\" Ability { id: \"4834\", source: \"Cruise Chaser\" }\r\n222.9 \"#8 Super Blassty Charge\" Ability { id: \"4B4F\", source: \"Cruise Chaser\" }\r\n\r\n### Phase 2: Cruise Chaser and Brute Justice\r\n226.1 \"J Kick\" Ability { id: \"4854\", source: \"Brute Justice\" } window 250,5\r\n229.1 \"--targetable--\"\r\n238.3 \"Whirlwind\" Ability { id: \"49C2\", source: \"Cruise Chaser\" }\r\n241.3 \"Judgment Nisi\" Ability { id: \"483E\", source: \"Brute Justice\" }\r\n247.4 \"Link-Up\" Ability { id: \"483F\", source: \"Brute Justice\" }\r\n255.4 \"Optical Sight\" Ability { id: \"482F\", source: \"Cruise Chaser\" }\r\n256.2 \"Chakrams\" Ability { id: \"4855\", source: \"Steam Chakram\" }\r\n260.6 \"Hawk Blaster\" Ability { id: \"4831\", source: \"Cruise Chaser\" }\r\n262.5 \"Photon\" Ability { id: \"4836\", source: \"Cruise Chaser\" }\r\n272.7 \"Spin Crusher\" Ability { id: \"4A72\", source: \"Cruise Chaser\" }\r\n277.3 \"Water and Thunder\" Ability { id: \"4841\", source: \"Brute Justice\" }\r\n288.6 \"Earth Missile\" Ability { id: \"484E\", source: \"Brute Justice\" }\r\n290.6 \"Hidden Minefield\" Ability { id: \"4851\", source: \"Brute Justice\" }\r\n292.7 \"Enumeration\" Ability { id: \"4850\", source: \"Brute Justice\" }\r\n306.7 \"Water and Thunder\" Ability { id: \"4841\", source: \"Brute Justice\" }\r\n313.5 \"Limit Cut\" Ability { id: \"4833\", source: \"Cruise Chaser\" }\r\n314.1 \"--Cruise Chaser Invincible--\" duration 6.3\r\n315.5 \"Flarethrower\" Ability { id: \"4845\", source: \"Brute Justice\" }\r\n327.6 \"Whirlwind\" Ability { id: \"49C2\", source: \"Cruise Chaser\" }\r\n336.2 \"Water and Thunder\" Ability { id: \"4841\", source: \"Brute Justice\" }\r\n354.5 \"Propeller Wind\" Ability { id: \"4832\", source: \"Cruise Chaser\" }\r\n356.5 \"Gavel\" Ability { id: \"483C\", source: \"Brute Justice\" }\r\n366.8 \"Photon\" Ability { id: \"4836\", source: \"Cruise Chaser\" }\r\n374.8 \"Double Rocket Punch\" Ability { id: \"4847\", source: \"Brute Justice\" }\r\n382.1 \"Super Jump\" Ability { id: \"484A\", source: \"Brute Justice\" }\r\n384.4 \"Apocalyptic Ray x5\" duration 4.4\r\n395.0 \"Whirlwind\" Ability { id: \"49C2\", source: \"Cruise Chaser\" }\r\n403.1 \"Whirlwind\" Ability { id: \"49C2\", source: \"Cruise Chaser\" }\r\n413.7 \"Final Sentence\" Ability { id: \"4856\", source: \"Brute Justice\" }\r\n423.7 \"Eternal Darkness Enrage\" Ability { id: \"483A\", source: \"Cruise Chaser\" }\r\n\r\n### Transition 2: Cruise Chaser, Brute Justice and Alexander Prime\r\n492.0 \"--sync--\" StartsUsing { id: \"485A\", source: \"Alexander Prime\" } window 500,0\r\n500.0 \"Temporal Stasis\" Ability { id: \"485A\", source: \"Alexander Prime\" }\r\n503.1 \"Surety and Severity\" Ability { id: \"4861\", source: \"Alexander Prime\" }\r\n505.1 \"Alpha Sword\" #Ability { id: \"486B\", source: \"Cruise Chaser\" }\r\n505.2 \"Flarethrower 1\" #Ability { id: \"486C\", source: \"Brute Justice\" }\r\n506.1 \"Alpha Sword\" #Ability { id: \"486B\", source: \"Cruise Chaser\" }\r\n507.2 \"Alpha Sword\" #Ability { id: \"486B\", source: \"Cruise Chaser\" }\r\n507.4 \"Flarethrower 2\" #Ability { id: \"486C\", source: \"Brute Justice\" }\r\n511.4 \"--targetable--\"\r\n521.5 \"Chastening Heat\" Ability { id: \"4A80\", source: \"Alexander Prime\" }\r\n524.6 \"Divine Spear 1\" #Ability { id: \"4A82\", source: \"Alexander Prime\" }\r\n526.7 \"Divine Spear 2\" #Ability { id: \"4A82\", source: \"Alexander Prime\" }\r\n528.8 \"Divine Spear 3\" #Ability { id: \"4A82\", source: \"Alexander Prime\" }\r\n\r\n### Phase 3 Part 1 - Inception Formation\r\n537.9 \"Inception Formation\" Ability { id: \"486F\", source: \"Alexander Prime\" }\r\n541.0 \"--untargetable--\"\r\n552.4 \"Judgment Crystal\" Ability { id: \"485B\", source: \"Alexander Prime\" }\r\n558.2 \"Judgment Crystal + True Heart\" Ability { id: \"485C\", source: \"Alexander Prime\" }\r\n569.5 \"Flarethrower 1\" #Ability { id: \"486C\", source: \"Brute Justice\" }\r\n571.7 \"Flarethrower 2\" #Ability { id: \"486C\", source: \"Brute Justice\" }\r\n573.8 \"Flarethrower 3\" #Ability { id: \"486C\", source: \"Brute Justice\" }\r\n581.0 \"Inception\" Ability { id: \"485E\", source: \"Alexander Prime\" }\r\n589.1 \"Surety, Solidarity and Severity\" Ability { id: \"4861\", source: \"Alexander Prime\" }\r\n589.4 \"Sacrament\" Ability { id: \"485F\", source: \"Alexander Prime\" }\r\n595.3 \"Alpha Sword\" #Ability { id: \"486B\", source: \"Cruise Chaser\" }\r\n596.4 \"Alpha Sword\" #Ability { id: \"486B\", source: \"Cruise Chaser\" }\r\n597.5 \"Alpha Sword\" #Ability { id: \"486B\", source: \"Cruise Chaser\" }\r\n598.3 \"Super Jump\" Ability { id: \"484A\", source: \"Brute Justice\" }\r\n600.3 \"--targetable--\"\r\n610.9 \"Chastening Heat\" Ability { id: \"4A80\", source: \"Alexander Prime\" }\r\n616.0 \"Divine Spear 1\" #Ability { id: \"4A82\", source: \"Alexander Prime\" }\r\n618.1 \"Divine Spear 2\" #Ability { id: \"4A82\", source: \"Alexander Prime\" }\r\n620.2 \"Divine Spear 3\" #Ability { id: \"4A82\", source: \"Alexander Prime\" }\r\n\r\n### Phase 3 Part 2 - Wormhole Formation\r\n629.3 \"Wormhole Formation\" Ability { id: \"486E\", source: \"Alexander Prime\" }\r\n632.3 \"--untargetable--\"\r\n637.7 \"Limit Cut\" Ability { id: \"4B0F\", source: \"Cruise Chaser\" }\r\n640.7 \"Link-Up\" Ability { id: \"483F\", source: \"Brute Justice\" }\r\n643.7 \"Void Of Repentance\" Ability { id: \"4866\", source: \"Alexander Prime\" }\r\n649.5 \"Chakrams\" #Ability { id: \"4855\", source: \"Steam Chakram\" }\r\n650.9 \"Super Jump\" Ability { id: \"484A\", source: \"Brute Justice\" }\r\n650.9 \"#1 Alpha Sword\" #Ability { id: \"4834\", source: \"Cruise Chaser\" }\r\n652.4 \"#2 Super Blassty Charge\" Ability { id: \"49C3\", source: \"Cruise Chaser\" }\r\n653.3 \"Apocalyptic Ray x5\" duration 5\r\n655.2 \"#3 Alpha Sword\" #Ability { id: \"4834\", source: \"Cruise Chaser\" }\r\n655.6 \"Repentance 1\" Ability { id: \"4869\", source: \"Alexander Prime\" }\r\n656.7 \"#4 Super Blassty Charge\" Ability { id: \"49C3\", source: \"Cruise Chaser\" }\r\n657.9 \"Sacrament\" Ability { id: \"4857\", source: \"Alexander Prime\" }\r\n659.5 \"#5 Alpha Sword\" #Ability { id: \"4834\", source: \"Cruise Chaser\" }\r\n659.7 \"Repentance 2\" Ability { id: \"4868\", source: \"Alexander Prime\" }\r\n660.8 \"#6 Super Blassty Charge\" Ability { id: \"49C3\", source: \"Cruise Chaser\" }\r\n663.6 \"#7 Alpha Sword\" #Ability { id: \"4834\", source: \"Cruise Chaser\" }\r\n664.0 \"Repentance 3\" Ability { id: \"4867\", source: \"Alexander Prime\" }\r\n665.1 \"#8 Super Blassty Charge\" Ability { id: \"49C3\", source: \"Cruise Chaser\" }\r\n666.4 \"Missile Command\" Ability { id: \"484D\", source: \"Brute Justice\" }\r\n670.0 \"Incinerating Heat\" Ability { id: \"4A51\", source: \"Alexander Prime\" }\r\n674.2 \"--targetable--\"\r\n674.6 \"Enumeration\" Ability { id: \"4850\", source: \"Brute Justice\" }\r\n682.9 \"Mega Holy\" Ability { id: \"4A83\", source: \"Alexander Prime\" }\r\n690.0 \"Mega Holy\" Ability { id: \"4A83\", source: \"Alexander Prime\" }\r\n\r\n### Transition 3: DPS Checks\r\n699.4 \"Summon Alexander\" Ability { id: \"4A55\", source: \"Alexander Prime\" }\r\n705.6 \"--alex untargetable--\"\r\n705.7 \"J Storm + Waves x16\" Ability { id: \"4876\", source: \"Brute Justice\" } duration 50\r\n706.8 \"--adds targetable--\"\r\n731.7 \"Eternal Darkness Enrage\" Ability { id: \"4875\", source: \"Cruise Chaser\" }\r\n771.9 \"Divine Judgment Enrage\" Ability { id: \"4879\", source: \"Alexander Prime\" } window 67,5\r\n787.3 \"Divine Judgment\" Ability { id: \"487A\", source: \"Alexander\" }\r\n787.4 \"Down for the Count\" duration 57\r\n\r\n### Phase 4: Perfect Alexander Part 1 - Fate Projection α\r\n845.4 \"--targetable--\"\r\n900.0 \"--sync--\" Ability { id: \"4A8B\", source: \"Perfect Alexander\" } window 900,0\r\n909.1 \"The Final Word\" Ability { id: \"487D\", source: \"Perfect Alexander\" }\r\n916.1 \"Ordained Motion/Stillness\" Ability { id: \"487[EF]\", source: \"Perfect Alexander\" }\r\n926.3 \"Ordained Motion/Stillness\" Ability { id: \"487[EF]\", source: \"Perfect Alexander\" }\r\n936.5 \"Optical Sight 1\" Ability { id: \"488[AB]\", source: \"Perfect Alexander\" }\r\n938.6 \"Individual/Collective Reprobation\" Ability { id: \"488[CD]\", source: \"Perfect Alexander\" }\r\n942.7 \"Optical Sight 2\" Ability { id: \"488[AB]\", source: \"Perfect Alexander\" }\r\n944.7 \"Individual/Collective Reprobation\" Ability { id: \"488[CD]\", source: \"Perfect Alexander\" }\r\n957.6 \"Fate Projection α\" Ability { id: \"487B\", source: \"Perfect Alexander\" }\r\n### Enigma Codex Revealed Events\r\n966.8 \"Fate: Ordained Motion/Stillness\" Ability { id: \"4B0[DE]\", source: \"Perfect Alexander\" }\r\n972.7 \"Fate: Obloquy, Solidarity and 3x Severity\" Ability { id: \"48A4\", source: \"Perfect Alexander\" }\r\n974.9 \"Fate: Ordained Motion/Stillness\" Ability { id: \"489[9A]\", source: \"Perfect Alexander\" }\r\n975.9 \"Fate: Sacrament x3\" duration 1.5\r\n982.6 \"Fate Calibration α\" Ability { id: \"487C\", source: \"Perfect Alexander\" }\r\n985.6 \"--untargetable--\"\r\n989.8 \"Ordained Motion/Stillness\" Ability { id: \"49A[BC]\", source: \"Perfect Alexander\" }\r\n992.8 \"Obloquy, Solidarity and 3x Severity\" Ability { id: \"4861\", source: \"Perfect Alexander\" }\r\n993.8 \"Ordained Motion/Stillness\" Ability { id: \"49A[BC]\", source: \"Perfect Alexander\" }\r\n993.8 \"Sacrament x3\" duration 1.5\r\n998.8 \"--targetable--\"\r\n\r\n### Phase 4 Part 2 - Fate Projection β\r\n1008.0 \"Ordained Capital Punishment\" Ability { id: \"4892\", source: \"Perfect Alexander\" }\r\n1011.1 \"Ordained Capital Punishment 1\" #Ability { id: \"4893\", source: \"Perfect Alexander\" }\r\n1012.2 \"Ordained Capital Punishment 2\" #Ability { id: \"4893\", source: \"Perfect Alexander\" }\r\n1013.3 \"Ordained Capital Punishment 3\" #Ability { id: \"4893\", source: \"Perfect Alexander\" }\r\n1017.2 \"Ordained Punishment\" Ability { id: \"4891\", source: \"Perfect Alexander\" }\r\n1032.3 \"Fate Projection β\" Ability { id: \"4B13\", source: \"Perfect Alexander\" }\r\n### Enigma Codex Revealed Events\r\n1047.7 \"Fate: Surety and Solidarity\" #Ability { id: \"489C\", source: \"Perfect Alexander\" }\r\n1050.5 \"Fate: J Jump\" Ability { id: \"489D\", source: \"Perfect Alexander\" }\r\n1056.0 \"Fate: Optical Sight\" Ability { id: \"48A[01]\", source: \"Perfect Alexander\" }\r\n1058.1 \"Fate: Individual/Collective Reprobation\" Ability { id: \"48A[23]\", source: \"Perfect Alexander\" }\r\n1061.5 \"Fate: Radiant Sacrament\" Ability { id: \"489E\", source: \"Perfect Alexander\" }\r\n1070.3 \"Fate Calibration β\" Ability { id: \"4B14\", source: \"Perfect Alexander\" }\r\n1073.3 \"--untargetable--\"\r\n1081.5 \"Surety and Solidarity\" Ability { id: \"4863\", source: \"Perfect Alexander\" }\r\n1082.5 \"J Jump\" Ability { id: \"4885\", source: \"Perfect Alexander\" }\r\n1086.5 \"Optical Sight 1\" Ability { id: \"49A[ED]\", source: \"Perfect Alexander\" }\r\n1088.6 \"Individual/Collective Reprobation\" Ability { id: \"488[CD]\", source: \"Perfect Alexander\" }\r\n1093.5 \"Radiant Sacrament\" Ability { id: \"4886\", source: \"Perfect Alexander\" }\r\n1098.5 \"--targetable--\"\r\n1106.8 \"Ordained Capital Punishment\" Ability { id: \"4892\", source: \"Perfect Alexander\" }\r\n1109.9 \"Ordained Capital Punishment 1\" #Ability { id: \"4893\", source: \"Perfect Alexander\" }\r\n1111.0 \"Ordained Capital Punishment 2\" #Ability { id: \"4893\", source: \"Perfect Alexander\" }\r\n1112.1 \"Ordained Capital Punishment 3\" #Ability { id: \"4893\", source: \"Perfect Alexander\" }\r\n1116.0 \"Ordained Punishment\" Ability { id: \"4891\", source: \"Perfect Alexander\" }\r\n\r\n### Phase 4 Part 3 - Almighty Judgments and Burn\r\n1126.2 \"Almighty Judgment\" Ability { id: \"488E\", source: \"Perfect Alexander\" }\r\n1130.8 \"Almighty Judgment Reveal x3\" duration 6\r\n1137.4 \"Almighty Judgment 1\" #Ability { id: \"4890\", source: \"Perfect Alexander\" }\r\n1139.4 \"Almighty Judgment 2\" #Ability { id: \"4890\", source: \"Perfect Alexander\" }\r\n1141.4 \"Almighty Judgment 3\" #Ability { id: \"4890\", source: \"Perfect Alexander\" }\r\n1142.5 \"Irresistible Grace\" Ability { id: \"4894\", source: \"Perfect Alexander\" }\r\n1152.6 \"Ordained Capital Punishment\" Ability { id: \"4892\", source: \"Perfect Alexander\" }\r\n1155.7 \"Ordained Capital Punishment 1\" #Ability { id: \"4893\", source: \"Perfect Alexander\" }\r\n1156.8 \"Ordained Capital Punishment 2\" #Ability { id: \"4893\", source: \"Perfect Alexander\" }\r\n1157.9 \"Ordained Capital Punishment 3\" #Ability { id: \"4893\", source: \"Perfect Alexander\" }\r\n1161.8 \"Ordained Punishment\" Ability { id: \"4891\", source: \"Perfect Alexander\" }\r\n1171.7 \"Almighty Judgment\" Ability { id: \"488E\", source: \"Perfect Alexander\" }\r\n1176.3 \"Almighty Judgment Reveal x3\" duration 6\r\n1182.9 \"Almighty Judgment 1\" #Ability { id: \"4890\", source: \"Perfect Alexander\" }\r\n1184.9 \"Almighty Judgment 2\" #Ability { id: \"4890\", source: \"Perfect Alexander\" }\r\n1186.9 \"Almighty Judgment 3\" #Ability { id: \"4890\", source: \"Perfect Alexander\" }\r\n1187.9 \"Irresistible Grace\" Ability { id: \"4894\", source: \"Perfect Alexander\" }\r\n1202.8 \"Temporal Interference\" Ability { id: \"4896\", source: \"Perfect Alexander\" }\r\n1216.4 \"7 Players Remaining\"\r\n1221.4 \"6 Players Remaining\"\r\n1226.4 \"5 Players Remaining\"\r\n1231.5 \"4 Players Remaining\"\r\n1236.5 \"3 Players Remaining\"\r\n1241.6 \"2 Players Remaining\"\r\n1246.6 \"1 Players Remaining\"\r\n1247.6 \"Temporal Prison Enrage\" Ability { id: \"4897\", source: \"Perfect Alexander\" } duration 9\r\n1249.8 \"0 Players Remaining\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/alliance/aglaia.ts





// TODO: Byregot Levinforge
// TODO: Byregot Spire
// TODO: Emissary Destructive Charge quadrants
// TODO: figure out Rhalgr portal sides so we can call left/right/NW/NE
// TODO: are there missing rhalgr portal ability ids?
// TODO: Lions 180 cleaves (is there a call there?)
// TODO: Azeyma Solar Wings, does it need a watch rotation warning?
// TODO: Azeyma Solar Flare warning
// TODO: Azeyma count Radiant Rhythms and call safe direction (or is it fixed?)
// TODO: Azeyma haute air safe quadrant(s)
// TODO: Azeyma Wildfire Ward triangle triggers
// TODO: Nald'Thal Fired Up I/II/III
const aglaia_triggerSet = {
  id: 'Aglaia',
  zoneId: zone_id/* default.Aglaia */.Z.Aglaia,
  timelineFile: 'aglaia.txt',
  initData: () => {
    return {
      tankbusters: [],
      naldSmeltingSpread: [],
      naldArrowMarker: []
    };
  },
  triggers: [{
    id: 'Aglaia Byregot Ordeal of Thunder',
    type: 'StartsUsing',
    netRegex: {
      id: '7176',
      source: 'Byregot',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aglaia Byregot Byregot\'s Strike',
    type: 'StartsUsing',
    netRegex: {
      id: '725A',
      source: 'Byregot',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback('info')
  }, {
    id: 'Aglaia Byregot Byregot\'s Strike Lightning',
    type: 'StartsUsing',
    netRegex: {
      id: '7167',
      source: 'Byregot',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback (with lightning)',
        de: 'Rückstoß (mit Blitzen)',
        fr: 'Poussée (avec éclair)',
        ja: 'ノックバック (雷)',
        cn: '击退 (带闪电)',
        ko: '넉백 (번개 장판)'
      }
    }
  }, {
    id: 'Aglaia Byregot Byregot\'s Ward',
    type: 'StartsUsing',
    netRegex: {
      id: '7175',
      source: 'Byregot'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Aglaia Byregot Reproduce',
    type: 'StartsUsing',
    netRegex: {
      id: '716B',
      source: 'Byregot',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge normal -> glowing row',
        de: 'Normal ausweichen -> leuchtende Reihe',
        fr: 'Évitez normal -> ligne brillante',
        ja: '安置 -> ひかり',
        cn: '去安全区 -> 发光行',
        ko: '안전 지대 -> 빛나는 열로 피하기'
      }
    }
  }, {
    id: 'Aglaia Rhalgr\'s Emissary Destructive Static',
    type: 'StartsUsing',
    netRegex: {
      id: '70E0',
      source: 'Rhalgr\'s Emissary',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Aglaia Rhalgr\'s Emissary Bolts from the Blue',
    type: 'StartsUsing',
    netRegex: {
      id: '70E3',
      source: 'Rhalgr\'s Emissary',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aglaia Rhalgr\'s Emissary Destructive Strike',
    type: 'StartsUsing',
    netRegex: {
      id: '70D9',
      source: 'Rhalgr\'s Emissary'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Aglaia Rhalgr Lightning Reign',
    type: 'StartsUsing',
    netRegex: {
      id: '70A5',
      source: 'Rhalgr',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aglaia Rhalgr Destructive Bolt Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '70B4',
      source: 'Rhalgr'
    },
    run: (data, matches) => data.tankbusters.push(matches.target)
  }, {
    id: 'Aglaia Rhalgr Destructive Bolt',
    type: 'StartsUsing',
    netRegex: {
      id: '70B4',
      source: 'Rhalgr',
      capture: false
    },
    delaySeconds: 0.3,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankCleaveOnYou: outputs/* default.tankCleaveOnYou */.Z.tankCleaveOnYou,
        tankCleaves: {
          en: 'Avoid Tank Cleaves',
          de: 'Weiche Tank-Cleaves aus',
          fr: 'Évitez le cleave sur le tank',
          ja: 'タンク範囲攻撃回避',
          cn: '躲避坦克顺劈',
          ko: '광역 탱버 피하기'
        }
      };
      if (data.tankbusters.includes(data.me)) return {
        alertText: output.tankCleaveOnYou()
      };
      return {
        infoText: output.tankCleaves()
      };
    },
    run: data => data.tankbusters = []
  }, {
    id: 'Aglaia Rhalgr Rhalgr\'s Beacon',
    type: 'StartsUsing',
    netRegex: {
      id: '70B8',
      source: 'Rhalgr',
      capture: false
    },
    // 10 second cast.
    delaySeconds: 5,
    alertText: (data, _matches, output) => {
      return data.rhalgrSeenBeacon ? output.knockbackOrbs() : output.knockback();
    },
    run: data => data.rhalgrSeenBeacon = true,
    outputStrings: {
      knockback: outputs/* default.knockback */.Z.knockback,
      knockbackOrbs: {
        en: 'Knockback (avoid orbs)',
        de: 'Rückstoßs (weiche den Orbs aus)',
        fr: 'Poussée (évitez les orbes)',
        ja: 'ノックバック (玉回避)',
        cn: '击退 (避开球)',
        ko: '넉백 (구슬 피하기)'
      }
    }
  }, {
    id: 'Aglaia Rhalgr Lightning Storm',
    type: 'StartsUsing',
    netRegex: {
      id: '70BA',
      source: 'Rhalgr'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Aglaia Rhalgr Broken World',
    type: 'StartsUsing',
    netRegex: {
      id: '70A6',
      source: 'Rhalgr',
      capture: false
    },
    run: data => data.rhalgrBrokenWorldActive = true
  }, {
    id: 'Aglaia Rhalgr Broken World Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '70A6',
      source: 'Rhalgr',
      capture: false
    },
    delaySeconds: 20,
    run: data => data.rhalgrBrokenWorldActive = false
  }, {
    id: 'Aglaia Rhalgr Hand of the Destroyer Blue',
    type: 'StartsUsing',
    netRegex: {
      id: '70A9',
      source: 'Rhalgr',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.rhalgrBrokenWorldActive) return output.redSideAway();
      return output.redSide();
    },
    outputStrings: {
      redSide: {
        en: 'Be on red half',
        de: 'Geh zur roten Seite',
        fr: 'Placez-vous sur la moitié rouge',
        ja: '赤い安置',
        cn: '站红色半场',
        ko: '빨간색 쪽으로'
      },
      redSideAway: {
        en: 'Be on red half (away from portal)',
        de: 'Geh zur roten Seite (weg vom Portal)',
        fr: 'Placez-vous sur la moitié rouge (loin du portail)',
        ja: '赤い安置 (ポータルから離れる)',
        cn: '站红色半场 (远离传送门)',
        ko: '빨간색 쪽, 포탈에서 멀리 떨어지기'
      }
    }
  }, {
    id: 'Aglaia Rhalgr Hand of the Destroyer Red Initial',
    type: 'StartsUsing',
    netRegex: {
      id: '70A8',
      source: 'Rhalgr',
      capture: false
    },
    alertText: (_data, _matches, output) => output.blueSide(),
    outputStrings: {
      blueSide: {
        en: 'Be on blue half',
        de: 'Geh zur blauen Seite',
        fr: 'Placez-vous sur la moitié bleue',
        ja: '青い安置',
        cn: '站蓝色半场',
        ko: '파란색 쪽으로'
      }
    }
  }, {
    id: 'Aglaia Rhalgr Hand of the Destroyer Red',
    type: 'StartsUsing',
    netRegex: {
      id: '70AC',
      source: 'Rhalgr',
      capture: false
    },
    alertText: (_data, _matches, output) => output.nearRed(),
    outputStrings: {
      nearRed: {
        en: 'Go near red portal',
        de: 'Geh zum roten Portal',
        fr: 'Allez sur le portail rouge',
        ja: '赤いポータルへ',
        cn: '靠近红色传送门',
        ko: '빨간 포탈 근처로'
      }
    }
  }, {
    id: 'Aglaia Lions Double Immolation',
    type: 'StartsUsing',
    netRegex: {
      id: '7177',
      source: ['Lion of Aglaia', 'Lioness of Aglaia'],
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aglaia Lions Slash and Burn Lioness First',
    type: 'StartsUsing',
    netRegex: {
      id: '71D2',
      source: 'Lioness of Aglaia',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Under Lioness => Out',
        de: 'Unter Löwin => Raus',
        fr: 'Sous la Lionne => Extérieur',
        ja: 'ライオンの下 => 外へ',
        cn: '去雌狮 => 外面',
        ko: '보스 밑 => 바깥으로'
      }
    }
  }, {
    id: 'Aglaia Lions Slash and Burn Lion First',
    type: 'StartsUsing',
    netRegex: {
      id: '71D0',
      source: 'Lion of Aglaia',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out => Under Lioness',
        de: 'Raus => Unter Löwin',
        fr: 'Extérieur => Sous la lionne',
        ja: '外 => ライオンの下へ',
        cn: '外面 => 去雌狮',
        ko: '바깥 => 보스 밑으로'
      }
    }
  }, {
    id: 'Aglaia Azeyma Warden\'s Prominence',
    type: 'StartsUsing',
    netRegex: {
      id: '70A0',
      source: 'Azeyma',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aglaia Azeyma Solar Wings',
    type: 'StartsUsing',
    netRegex: {
      id: '7081',
      source: 'Azeyma',
      capture: false
    },
    response: responses/* Responses.goFrontBack */.n3.goFrontBack()
  }, {
    id: 'Aglaia Azeyma Warden\'s Warmth Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '709F',
      source: 'Azeyma'
    },
    run: (data, matches) => data.tankbusters.push(matches.target)
  }, {
    id: 'Aglaia Azeyma Warden\'s Warmth',
    type: 'StartsUsing',
    netRegex: {
      id: '709F',
      source: 'Azeyma',
      capture: false
    },
    delaySeconds: 0.3,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankCleaveOnYou: outputs/* default.tankCleaveOnYou */.Z.tankCleaveOnYou,
        tankCleaves: {
          en: 'Avoid Tank Cleaves',
          de: 'Weiche Tank-Cleaves aus',
          fr: 'Évitez les cleaves sur le tank',
          ja: 'タンク範囲攻撃回避',
          cn: '躲避坦克顺劈',
          ko: '광역 탱버 피하기'
        }
      };
      if (data.tankbusters.includes(data.me)) return {
        alertText: output.tankCleaveOnYou()
      };
      return {
        infoText: output.tankCleaves()
      };
    },
    run: data => data.tankbusters = []
  }, {
    id: 'Aglaia Azeyma Fleeting Spark',
    type: 'StartsUsing',
    netRegex: {
      id: '709C',
      source: 'Azeyma',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Aglaia Azeyma Sublime Sunset',
    type: 'StartsUsing',
    netRegex: {
      id: '7098',
      source: 'Azeyma',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from Orb',
        de: 'Weg vom Orb',
        fr: 'Éloignez-vous de l\'orbe',
        ja: '玉から離れる',
        cn: '远离球',
        ko: '구체와 멀리 떨어지기'
      }
    }
  }, {
    id: 'Aglaia Nald\'thal As Above, So Below',
    type: 'StartsUsing',
    netRegex: {
      id: ['70E8', '70E9'],
      source: 'Nald\'thal',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aglaia Nald\'thal Heat Above, Flames Below Orange Swap',
    type: 'StartsUsing',
    netRegex: {
      id: '73A4',
      source: 'Nald\'thal',
      capture: false
    },
    durationSeconds: 6,
    response: responses/* Responses.getOut */.n3.getOut(),
    run: data => data.naldLastColor = 'orange'
  }, {
    id: 'Aglaia Nald\'thal Heat Above, Flames Below Blue',
    type: 'StartsUsing',
    netRegex: {
      id: '73A5',
      source: 'Nald\'thal',
      capture: false
    },
    durationSeconds: 6,
    response: responses/* Responses.getUnder */.n3.getUnder(),
    run: data => data.naldLastColor = 'blue'
  }, {
    id: 'Aglaia Nald\'thal Smelting',
    type: 'HeadMarker',
    netRegex: {
      id: '00ED'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    run: (data, matches) => data.naldSmeltingSpread.push(matches.target),
    outputStrings: {
      text: {
        en: 'Protean Spread on YOU',
        de: 'Protean verteilen auf DIR',
        fr: 'Position sur VOUS',
        ja: '自分に散会マーカー',
        cn: '万变水波点名',
        ko: '산개징 대상자'
      }
    }
  }, {
    id: 'Aglaia Nald\'thal Heavens\' Trial',
    type: 'StartsUsing',
    netRegex: {
      id: '711F',
      source: ['Thal', 'Nald\'thal']
    },
    alertText: (data, matches, output) => {
      if (data.naldSmeltingSpread.includes(data.me)) return;
      return output.stackOnPlayer({
        player: data.party.member(matches.target)
      });
    },
    run: data => data.naldSmeltingSpread = [],
    outputStrings: {
      stackOnPlayer: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'Aglaia Nald\'thal Golden Tenet',
    type: 'StartsUsing',
    netRegex: {
      id: '711B',
      source: 'Nald\'thal'
    },
    response: responses/* Responses.sharedTankBuster */.n3.sharedTankBuster()
  }, {
    // The order of events is either:
    // Deepest Pit headmarker (always) -> Far Above cast -> 73AC ability (always)
    // Deepest Pit headmarker (always) -> 73AC ability (always) -> Far Above cast
    // The 73AC and Far Above cast come from different actors and can be ordered differently.
    // As a hack, 73AC gets a slight delay.  The Deepest Pit and 73AC lines always
    // happen even if they are fake (because it is orange or blue, respectively).
    id: 'Aglaia Nald\'thal Deepest Pit Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '0154'
    },
    run: (data, matches) => data.naldArrowMarker.push(matches.target)
  }, {
    id: 'Aglaia Nald\'thal Far Above, Deep Below Blue',
    type: 'StartsUsing',
    netRegex: {
      id: '73AA',
      source: 'Nald\'thal',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        dropMarkerOutside: {
          en: 'Drop marker outside',
          de: 'Marker draußen ablegen',
          fr: 'Déposez les marqueurs à l\'extérieur',
          ja: '外側で捨てる',
          cn: '人群外放置标记',
          ko: '밖에서 징 처리'
        },
        ignoreLineStack: {
          en: 'Ignore fake stack',
          de: 'Falsches Sammeln ignorieren',
          fr: 'Ignorez le faux marqueur de package',
          ja: '偽頭割り無視',
          cn: '忽略假点名',
          ko: '가짜 쉐어 무시'
        }
      };

      // People with arrow markers should not get a stack callout.
      if (data.naldArrowMarker.includes(data.me)) return {
        alertText: output.dropMarkerOutside()
      };
      return {
        infoText: output.ignoreLineStack()
      };
    },
    run: data => {
      data.naldLastColor = 'blue';
      data.naldArrowMarker = [];
    }
  }, {
    id: 'Aglaia Nald\'thal Far Above, Deep Below Orange',
    type: 'StartsUsing',
    netRegex: {
      id: '73AB',
      source: 'Nald\'thal',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.naldArrowMarker.includes(data.me)) return output.ignoreArrow();
    },
    run: data => {
      data.naldLastColor = 'orange';
      data.naldArrowMarker = [];
    },
    outputStrings: {
      ignoreArrow: {
        en: 'Ignore fake arrow',
        de: 'Falschen Pfeil ignorieren',
        fr: 'Ignorez la fausse flèche',
        ja: '矢印は偽物',
        cn: '忽略假箭头',
        ko: '가짜 화살표징 무시'
      }
    }
  }, {
    id: 'Aglaia Nald\'thal Far-flung Fire',
    type: 'Ability',
    netRegex: {
      id: '73AC',
      source: 'Nald'
    },
    // 73AC sometimes comes before the Far Above, Deep Below cast.
    // It has the exact same network log time, but is just sometimes ordered wrong.
    // Add a slight delay here so the calls end up being correct.
    delaySeconds: 0.5,
    alertText: (data, matches, output) => {
      if (data.naldLastColor === 'orange') return output.lineStackOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      lineStackOn: {
        en: 'Line stack on ${player}',
        de: 'In einer Linie auf ${player} sammeln',
        fr: 'Packez-vous en ligne sur ${player}',
        ja: '${player}に直線頭割り',
        cn: '${player} 直线分摊',
        ko: '${player} 직선 쉐어'
      }
    }
  }, {
    id: 'Aglaia Nald\'thal Once Above, Ever Below Orange',
    type: 'StartsUsing',
    // 73BF = starts blue, swaps orange
    // 741D = starts orange, stays orange
    netRegex: {
      id: ['73BF', '741D'],
      source: 'Nald\'thal',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.naldLastColor = 'orange',
    outputStrings: {
      text: {
        en: 'Go to Blue Quadrant',
        de: 'Geh zum blauen Quadrant',
        fr: 'Allez sur le quart bleu',
        ja: '青い安置',
        cn: '前往蓝色区域',
        ko: '파랑 장판으로'
      }
    }
  }, {
    id: 'Aglaia Nald\'thal Once Above, Ever Below Blue',
    type: 'StartsUsing',
    // 73C0 = starts blue, stays blue
    // 741C = starts orange, swaps blue
    netRegex: {
      id: ['73C0', '741C'],
      source: 'Nald\'thal',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.naldLastColor = 'blue',
    outputStrings: {
      text: {
        en: 'Go to Orange Quadrant',
        de: 'Geh zum orangenen Quadrant',
        fr: 'Allez sur le quart orange',
        ja: '赤い安置',
        cn: '前往橙色区域',
        ko: '주황 장판으로'
      }
    }
  }, {
    id: 'Aglaia Nald\'thal Hell of Fire Front',
    type: 'StartsUsing',
    netRegex: {
      id: '72B7',
      source: 'Nald\'thal',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Aglaia Nald\'thal Hell of Fire Back',
    type: 'StartsUsing',
    netRegex: {
      id: '72B9',
      source: 'Nald\'thal',
      capture: false
    },
    alertText: (_data, _matches, output) => output.goFront(),
    outputStrings: {
      goFront: outputs/* default.goFront */.Z.goFront
    }
  }, {
    id: 'Aglaia Nald\'thal Soul Vessel Magmatic Spell',
    type: 'StartsUsing',
    netRegex: {
      id: '712D',
      source: 'Soul Vessel',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack groups',
        de: 'Sammel Gruppen',
        fr: 'Package en groupe',
        ja: 'グループで頭割り',
        cn: '分组分摊',
        ko: '그룹별 쉐어'
      }
    }
  }, {
    id: 'Aglaia Nald\'thal Stygian Tenet Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '711D',
      source: 'Nald\'thal'
    },
    run: (data, matches) => data.tankbusters.push(matches.target)
  }, {
    id: 'Aglaia Nald\'thal Stygian Tenet',
    type: 'StartsUsing',
    netRegex: {
      id: '711D',
      source: 'Nald\'thal',
      capture: false
    },
    delaySeconds: 0.3,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankCleaveOnYou: outputs/* default.tankCleaveOnYou */.Z.tankCleaveOnYou,
        tankCleaves: {
          en: 'Avoid Tank Cleaves',
          de: 'Weiche den Tank-Cleaves aus',
          fr: 'Évitez les cleaves sur le tank',
          ja: 'タンク範囲攻撃回避',
          cn: '躲避坦克顺劈',
          ko: '광역 탱버 피하기'
        }
      };
      if (data.tankbusters.includes(data.me)) return {
        alertText: output.tankCleaveOnYou()
      };
      return {
        infoText: output.tankCleaves()
      };
    },
    run: data => data.tankbusters = []
  }, {
    id: 'Aglaia Nald\'thal Hearth Above, Flight Below Blue',
    type: 'StartsUsing',
    // 73CA = start blue, stay blue
    // 73CC = start orange, swap blue
    netRegex: {
      id: ['73CA', '73CC'],
      source: 'Nald\'thal',
      capture: false
    },
    durationSeconds: 6,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        dropMarkerOutside: {
          en: 'Under => Drop marker outside',
          de: 'Unter ihn => Marker drausen ablegen',
          fr: 'Dessous => Déposez le marqueur à l\'extérieur',
          ja: 'ボスの下 => 外側で捨てる',
          cn: 'BOSS身下 => 人群外放置标记',
          ko: '보스 밑 => 밖에서 화살표징 처리'
        },
        ignoreLineStack: {
          en: 'Under (ignore fake stack)',
          de: 'Unter ihn (falsches Sammeln ignorieren)',
          fr: 'Dessous (ignorez le faux package)',
          ja: 'ボスの下 (頭割りは偽物)',
          cn: 'BOSS身下 (忽略假分摊)',
          ko: '보스 밑 (가짜 쉐어 무시)'
        }
      };

      // People with arrow markers should not get a stack callout.
      if (data.naldArrowMarker.includes(data.me)) return {
        alertText: output.dropMarkerOutside()
      };
      return {
        infoText: output.ignoreLineStack()
      };
    },
    run: data => {
      data.naldLastColor = 'blue';
      data.naldArrowMarker = [];
    }
  }, {
    id: 'Aglaia Nald\'thal Hearth Above, Flight Below Orange',
    type: 'StartsUsing',
    // 73CB = orange, unknown if swap
    // 741B = orange, unknown if swap
    netRegex: {
      id: ['73CB', '741B'],
      source: 'Nald\'thal',
      capture: false
    },
    durationSeconds: 6,
    // Use info here to not conflict with the 73AC line stack trigger.
    infoText: (data, _matches, output) => {
      if (data.naldArrowMarker.includes(data.me)) return output.ignoreArrow();
      return output.out();
    },
    run: data => data.naldLastColor = 'orange',
    outputStrings: {
      ignoreArrow: {
        en: 'Out (ignore fake arrow)',
        de: 'Raus (falschen Pfeil ignorieren)',
        fr: 'Extérieur (ignorez la fausse flèche)',
        ja: '外側へ (矢印は偽物)',
        cn: '去外面 (忽略假箭头)',
        ko: '밖으로 (가짜 화살표징 무시)'
      },
      out: outputs/* default.out */.Z.out
    }
  }, {
    id: 'Aglaia Nald\'thal Hells\' Trial',
    type: 'StartsUsing',
    netRegex: {
      id: '7121',
      source: 'Nald\'thal',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Azeyma': 'Azeyma',
      'Azeyma\'s Heat': 'Azeymas Spiegelung',
      'Byregot': 'Byregot',
      'Byregot\'s Avatar': 'Byregots Abbild',
      'Ingenuity\'s Foothold': 'Schrein des Handwerks',
      'Lightning Orb': 'Blitzkugel',
      'Lion of Aglaia': 'Aglaia-Löwe',
      'Lioness of Aglaia': 'Aglaia-Löwin',
      'Nald': 'Nald',
      'Nald\'thal': 'Nald\'Thal',
      'Prodigal Sun': 'Schemensonne',
      'Rhalgr': 'Rhalgr',
      'Rhalgr\'s Emissary': 'Rhalgrs Abgesandt(?:e|er|es|en)',
      'Soul Vessel': 'Seelengefäß',
      'Sunstorm': 'Azeymas Aura',
      'Thal': 'Thal',
      'The Circle Of Inquiry': 'Schrein des Urteils',
      'The Endless City': 'Stadt der Herrlichkeit',
      'The Monument To Destruction': 'Schrein des Kometen',
      'The Path': 'Pfad der Führung',
      'The Twin Halls': 'Schrein der Zwei'
    },
    'replaceText': {
      '--hammer--': '--Hammer--',
      '\(fake\)': 'falsch',
      '\(proximity\)': 'Distanz',
      '\(summon\)': 'Beschwörung',
      'Advent of the Eighth': 'Lehre des Kometen',
      'As Above, So Below': 'Flamme von Leben und Tod',
      'Balance': 'Seelenabrechnung',
      'Bolts from the Blue': 'Himmlischer Blitz',
      'Boltloop': 'Rundblitz',
      'Bronze Lightning': 'Donner',
      'Bronze Work': 'Donnerstab',
      'Broken World': 'Komet der Zerstörung',
      'Builder\'s Build': 'Byregots Erbauung',
      'Byregot\'s Spire': 'Byregots Turm',
      'Byregot\'s Strike': 'Byregots Schlag',
      'Byregot\'s Ward': 'Byregots Schutz',
      'Cloud to Ground': 'Sturmkonzentration',
      'Dancing Flame': 'Tanzende Flamme',
      'Deepest Pit': 'Feierlicher Todeshauch',
      'Destructive Bolt': 'Zerstörerischer Blitzschlag',
      'Destructive Charge': 'Zerstörerschock',
      'Destructive Static': 'Zerstörerhieb',
      'Destructive Strike': 'Zerstörerhieb',
      'Double Immolation': 'Lehre der Zwillingsflamme',
      'Equal Weight': 'Seelenplus',
      'Fan Flames': 'Fächerflammen',
      'Far Above, Deep Below': 'Leben und Tod: Entfesselung',
      'Far-flung Fire': 'Befreite Lebensflamme',
      'Fired Up I(?!I)': '1. Substanz des Feuers',
      'Fired Up II(?!I)': '2. Substanz des Feuers',
      'Fired Up III': '3. Substanz des Feuers',
      'Fleeting Spark': 'Feurige Falle',
      'Fortune\'s Flux': 'Quelle des Feuers',
      'Golden Tenet': 'Nald-Feuer',
      'Hand of the Destroyer': 'Vernichtungsschlag des Zerstörers',
      'Haute Air': 'Heiße Luft',
      'Hearth Above, Flight Below': 'Leben und Tod: Lohenbogen',
      'Heat Above, Flames Below': 'Leben und Tod: Ringfeuer',
      'Heavens\' Trial': 'Würde des Flammenhimmels',
      'Hell of Fire': 'Infernowelle',
      'Hell of Lightning': 'Donnerkugel',
      'Hells\' Trial': 'Würde der Flammenhölle',
      'Illuminating Glimpse': 'Flimmern der Flammen',
      'Levinforge': 'Gewitterschein',
      'Lightning Bolt': 'Blitzschlag',
      'Lightning Reign': 'Göttliches Donnertosen',
      'Lightning Storm': 'Blitzsturm',
      'Magmatic Spell': 'Erschaffener Fels',
      'Noble Dawn': 'Urteil der Sonne',
      'Once Above, Ever Below': 'Leben und Tod: Raubfeuer',
      'Ordeal of Thunder': 'Prüfender Donner',
      'Peal of the Hammer': 'Byregots Hammer',
      'Radiant Finish': 'Letzter Fächertanz',
      'Radiant Rhythm': 'Fächertanz',
      'Rejuvenating Spark': 'Feuer des Lebens',
      'Reproduce': 'Teilung des Selbsts',
      'Rhalgr\'s Beacon': 'Fallender Stern',
      'Roaring Blaze': 'Lehre der Tosenden Flamme',
      'Seventh Passage': 'Kreis des Flammenhimmels',
      'Shock': 'Entladung',
      'Slash and Burn': 'Feuerkralle',
      'Smelting': 'Erschütterungswelle',
      'Solar Fans': 'Fächerschneide',
      'Solar Flair': 'Sonnenstaub',
      'Solar Fold': 'Sonnenschlag',
      'Solar Wings': 'Sonnenflügel',
      'Soul\'s Measure': 'Urteil der Waage',
      'Spinning Slash': 'Wirbeltatze',
      'Striking Meteor': 'Sternschnuppe',
      'Stygian Tenet': 'Thal-Feuer',
      'Sublime Sunset': 'Göttliches Abendrot',
      'Sun\'s Shine': 'Trugbild der Hitze',
      'Sunbeam': 'Sonnenstrahl',
      '(?<! )Sunset': 'Abendrot',
      'The Builder\'s Forge': 'Byregots Schöpfung',
      'Tipped Scales': 'Göttliche Rechenschaft',
      'Trial by Fire': 'Lehre des Brausenden Feuers',
      'Twingaze': 'Hitzewallung',
      'Warden\'s Prominence': 'Wunder der Aufseherin',
      'Warden\'s Warmth': 'Götterfeuer',
      'Wayward Soul': 'Leid der Toten',
      'Wildfire Ward': 'Lauffeuer'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '--hammer--': '--Marteau--',
      'Azeyma': 'Azeyma',
      'Azeyma\'s Heat': 'mirage d\'Azeyma',
      'Byregot': 'Byregot',
      'Byregot\'s Avatar': 'double de Byregot',
      'Ingenuity\'s Foothold': 'Gloire de l\'ingéniosité',
      'Lightning Orb': 'orbe de foudre',
      'Lion of Aglaia': 'lion d\'Aglaé',
      'Lioness of Aglaia': 'lionne d\'Aglaé',
      'Nald': 'Nald',
      'Nald\'thal': 'Nald\'Thal',
      'Prodigal Sun': 'soleil illusoire',
      'Rhalgr': 'Rhalgr',
      'Rhalgr\'s Emissary': 'émissaire de Rhalgr',
      'Soul Vessel': 'réceptacle d\'âme',
      'Sunstorm': 'aura solaire',
      'Thal': 'Thal',
      'The Circle Of Inquiry': 'Cercle de la justice',
      'The Endless City': 'Cité des splendeurs',
      'The Monument To Destruction': 'Monument à la destruction',
      'The Path': 'Corridor céleste',
      'The Twin Halls': 'Palais jumeau'
    },
    'replaceText': {
      '--hammer--': '--Marteau--',
      '\(fake\)': 'Faux',
      '\(proximity\)': 'Proche',
      '\(summon\)': 'Invocation',
      'Advent of the Eighth': 'Anneaux astraux',
      'As Above, So Below': 'Flamme de vie, flamme de mort',
      '(?<! )Balance': 'Jugement pananimique',
      'Bolts from the Blue': 'Éclairs célestes',
      'Boltloop': 'Anneaux électriques',
      'Bronze Lightning': 'Saillie survoltée',
      'Bronze Work': 'Bâton grondant',
      'Broken World': 'Comète de Rhalgr',
      'Builder\'s Build': 'Besogne de Byregot',
      'Byregot\'s Spire': 'Tour de Byregot',
      'Byregot\'s Strike': 'Foreuse de Byregot',
      'Byregot\'s Ward': 'Aire de l\'Artisan',
      'Cloud to Ground': 'Attaque fulminante',
      'Dancing Flame': 'Flamme dansante',
      'Deepest Pit': 'Explosion étendue de mort',
      'Destructive Bolt': 'Foudre destructrice',
      'Destructive Charge': 'Charges destructrices',
      'Destructive Static': 'Taillade destructrice',
      'Destructive Strike': 'Taillade destructrice',
      'Double Immolation': 'Immolation double',
      'Equal Weight': 'Supplément d\'âme',
      'Fan Flames': 'Flammes d\'éventail',
      'Far Above, Deep Below': 'Vie ou mort : déchaînement',
      'Far-flung Fire': 'Déflagration distante de vie',
      'Fired Up I(?!I)': 'Accumulation d\'avoirs I',
      'Fired Up II(?!I)': 'Accumulation d\'avoirs II',
      'Fired Up III': 'Accumulation d\'avoirs III',
      'Fleeting Spark': 'Retourné rayonnant',
      'Fortune\'s Flux': 'Flux de la fortune',
      'Golden Tenet': 'Dogme doré',
      'Hand of the Destroyer': 'Main du Destructeur',
      'Haute Air': 'Éventement éminent',
      'Hearth Above, Flight Below': 'Vie ou mort : arc ardent',
      'Heat Above, Flames Below': 'Vie ou mort : cercle de feu',
      'Heavens\' Trial': 'Jugement céleste',
      'Hell of Fire': 'Enfer de feu',
      'Hell of Lightning': 'Enfer électrique',
      'Hells\' Trial': 'Jugement infernal',
      'Illuminating Glimpse': 'Scintillement incandescent',
      'Levinforge': 'Fulguration funeste',
      'Lightning Bolt': 'Éclair de foudre',
      'Lightning Reign': 'Règne foudroyant',
      'Lightning Storm': 'Pluie d\'éclairs',
      'Magmatic Spell': 'Fracas magmatique',
      'Noble Dawn': 'Aurore altière',
      'Once Above, Ever Below': 'Vie ou mort : calcination',
      'Ordeal of Thunder': 'Épreuve électrique',
      'Peal of the Hammer': 'Marteau divin',
      'Radiant Finish': 'Final enflammé',
      'Radiant Rhythm': 'Rythme enflammé',
      'Rejuvenating Spark': 'Étincelle de vie',
      'Reproduce': 'Reproduction',
      'Rhalgr\'s Beacon': 'Comète d\'annihilation',
      'Roaring Blaze': 'Brasier rugissant',
      'Seventh Passage': 'Ciel de feu',
      'Shock': 'Décharge électrostatique',
      'Slash and Burn': 'Griffes torrides',
      'Smelting': 'Secousse déferlante',
      'Solar Fans': 'Éventails solaires',
      'Solar Flair': 'Poussière solaire',
      'Solar Fold': 'Repli solaire',
      'Solar Wings': 'Ailes solaires',
      'Soul\'s Measure': 'Épreuve de la balance',
      'Spinning Slash': 'Griffes tourbillonnantes',
      'Striking Meteor': 'Météore minutieux',
      'Stygian Tenet': 'Dogme destructif',
      'Sublime Sunset': 'Crépuscule cérémoniel',
      'Sun\'s Shine': 'Mirages de chaleur',
      'Sunbeam': 'Rayon de soleil',
      '(?<! )Sunset': 'Crépuscule',
      'The Builder\'s Forge': 'Grand œuvre de l\'Artisan',
      'Tipped Scales': 'Verdict suprême',
      'Trial by Fire': 'Épreuve du feu écarlate',
      'Twingaze': 'Œillade odieuse',
      'Warden\'s Prominence': 'Grandeur de la Gardienne',
      'Warden\'s Warmth': 'Étreinte effervescente',
      'Wayward Soul': 'Anéantissement animique',
      'Wildfire Ward': 'Enclave embrasée'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Azeyma(?!\')': 'アーゼマ',
      'Azeyma\'s Heat': 'アーゼマの蜃気楼',
      'Byregot(?!\')': 'ビエルゴ',
      'Byregot\'s Avatar': 'ビエルゴの分体',
      'Ingenuity\'s Foothold': '技巧宮',
      'Lightning Orb': '雷球',
      'Lion of Aglaia': 'アグライア・ライオン',
      'Lioness of Aglaia': 'アグライア・ライオネス',
      'Nald(?!\')': 'ナル神',
      'Nald\'thal': 'ナルザル',
      'Prodigal Sun': '幻太陽',
      'Rhalgr(?!\')': 'ラールガー',
      'Rhalgr\'s Emissary': 'ラールガーズ・エミッサリー',
      'Soul Vessel': '魂の器',
      'Sunstorm': '陽霊気',
      '(?<!\')Thal': 'ザル神',
      'The Circle Of Inquiry': '審理宮',
      'The Endless City': '壮麗なる都',
      'The Monument To Destruction': '彗星宮',
      'The Path': '導きの歩廊',
      'The Twin Halls': '二面宮'
    },
    'replaceText': {
      '--hammer--': '--ハンマー--',
      'Advent of the Eighth': '彗星輪',
      'As Above, So Below': '死生択一の炎',
      'Balance': '魂の清算',
      'Bolts from the Blue': '天雷',
      'Boltloop': '円雷',
      'Bronze Lightning': '轟雷',
      'Bronze Work': '轟雷の杖',
      'Broken World': '破壊の彗星',
      'Builder\'s Build': 'ビエルゴズ・ビルドアップ',
      'Byregot\'s Spire': 'ビエルゴズ・スパイア',
      'Byregot\'s Strike': 'ビエルゴズ・ストライク',
      'Byregot\'s Ward': 'ビエルゴズ・ウォード',
      'Cloud to Ground': '襲雷',
      'Dancing Flame': '煽火',
      'Deepest Pit': '死爆華',
      'Destructive Bolt': '壊雷撃',
      'Destructive Charge': '壊雷球',
      'Destructive Static': '壊雷斬',
      'Destructive Strike': '壊神斬',
      'Double Immolation': '双炎法',
      'Equal Weight': '魂の加算',
      'Fan Flames': '焔扇灯火',
      'Far Above, Deep Below': '死生択一：砲華',
      'Far-flung Fire': '生火砲',
      'Fired Up I(?!I)': '連火の財・壱',
      'Fired Up II(?!I)': '連火の財・弐',
      'Fired Up III': '連火の財・参',
      'Fleeting Spark': '烈火旋脚',
      'Fortune\'s Flux': '連火発揚',
      'Golden Tenet': 'ナルの神火',
      'Hand of the Destroyer': '壊神創幻撃',
      'Haute Air': '焔扇煽火',
      'Hearth Above, Flight Below': '死生択一：閃弧',
      'Heat Above, Flames Below': '死生択一：環火',
      'Heavens\' Trial': '炎天の浄火',
      'Hell of Fire': '炎獄破',
      'Hell of Lightning': '雷獄球',
      'Hells\' Trial': '炎獄の浄火',
      'Illuminating Glimpse': '烈火一閃',
      'Levinforge': '雷光',
      'Lightning Bolt': '落雷',
      'Lightning Reign': '神雷轟天',
      'Lightning Storm': '百雷',
      'Magmatic Spell': '魔成岩',
      'Noble Dawn': '審理の太陽',
      'Once Above, Ever Below': '死生択一：襲火',
      'Ordeal of Thunder': 'オーディアルサンダー',
      'Peal of the Hammer': 'ビエルゴズ・ハンマー',
      'Radiant Finish': '焔扇流舞・終炎',
      'Radiant Rhythm': '焔扇流舞',
      'Rejuvenating Spark': '命の火',
      'Reproduce': '分体生成',
      'Rhalgr\'s Beacon': '破軍の流星',
      'Roaring Blaze': '轟炎法',
      'Seventh Passage': '炎天輪',
      'Shock': '放電',
      'Slash and Burn': '火焔旋爪',
      'Smelting': '震動波',
      'Solar Fans': '紅炎扇刃',
      'Solar Flair': '紅炎爆塵',
      'Solar Fold': '紅炎斬',
      'Solar Wings': '両翼紅炎風',
      'Soul\'s Measure': '天秤の試練',
      'Spinning Slash': '円弧旋爪',
      'Striking Meteor': '小流星',
      'Stygian Tenet': 'ザルの神火',
      'Sublime Sunset': '神技・落陽',
      'Sun\'s Shine': '陽炎',
      'Sunbeam': '太陽光',
      '(?<! )Sunset': '落陽',
      'The Builder\'s Forge': 'ビエルゴズ・クリエイション',
      'Tipped Scales': '算命魂葬',
      'Trial by Fire': '火焔法',
      'Twingaze': '熱閃',
      'Warden\'s Prominence': '神火天陽',
      'Warden\'s Warmth': '神炎',
      'Wayward Soul': '死魂爆',
      'Wildfire Ward': '燎原の炎'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Azeyma(?!\')': '阿泽玛',
      'Azeyma\'s Heat': '阿泽玛的幻象',
      'Byregot(?!\')': '比尔格',
      'Byregot\'s Avatar': '比尔格的分身',
      'Ingenuity\'s Foothold': '技巧宫',
      'Lightning Orb': '雷狱球',
      'Lion of Aglaia': '阿格莱亚雄狮',
      'Lioness of Aglaia': '阿格莱亚雌狮',
      'Nald(?!\')': '纳尔神',
      'Nald\'thal': '纳尔札尔',
      'Prodigal Sun': '幻阳',
      'Rhalgr(?!\')': '拉尔戈',
      'Rhalgr\'s Emissary': '拉尔戈神使',
      'Soul Vessel': '魂器',
      'Sunstorm': '阳灵气',
      '(?<!\')Thal': '札尔神',
      'The Circle Of Inquiry': '审理宫',
      'The Endless City': '壮丽都城',
      'The Monument To Destruction': '彗星宫',
      'The Path': '引导步廊',
      'The Twin Halls': '双面宫'
    },
    'replaceText': {
      '--hammer--': '--锤子--',
      '\(fake\)': '假',
      '\(proximity\)': '近',
      '\(summon\)': '召唤',
      'Advent of the Eighth': '彗星环',
      'As Above, So Below': '生死抉择之炎',
      'Balance': '灵魂的清算',
      'Bolts from the Blue': '天雷',
      'Boltloop': '雷圈',
      'Bronze Lightning': '轰雷',
      'Bronze Work': '轰雷之杖',
      'Broken World': '破坏之彗星',
      'Builder\'s Build': '工艺神造',
      'Byregot\'s Spire': '比尔格之塔',
      'Byregot\'s Strike': '工艺神击',
      'Byregot\'s Ward': '工艺神护',
      'Cloud to Ground': '袭雷',
      'Dancing Flame': '煽火',
      'Deepest Pit': '死之散爆',
      'Destructive Bolt': '坏灭雷击',
      'Destructive Charge': '坏灭雷球',
      'Destructive Static': '坏灭雷斩',
      'Destructive Strike': '破坏神斩',
      'Double Immolation': '双炎法',
      'Equal Weight': '灵魂的加算',
      'Fan Flames': '炎扇灯火',
      'Far Above, Deep Below': '生轰死爆之择',
      'Far-flung Fire': '生之聚轰',
      'Fired Up I(?!I)': '烈火之财·壹',
      'Fired Up II(?!I)': '烈火之财·贰',
      'Fired Up III': '烈火之财：叁',
      'Fleeting Spark': '烈火旋扫',
      'Fortune\'s Flux': '命运变迁',
      'Golden Tenet': '纳尔神火',
      'Hand of the Destroyer': '幻天破坏拳',
      'Haute Air': '炎扇煽火',
      'Hearth Above, Flight Below': '生死混一之择',
      'Heat Above, Flames Below': '生浪死环之择',
      'Heavens\' Trial': '炎天净火',
      'Hell of Fire': '炎狱破',
      'Hell of Lightning': '雷狱球',
      'Hells\' Trial': '炎狱净火',
      'Illuminating Glimpse': '烈火一闪',
      'Levinforge': '雷光',
      'Lightning Bolt': '落雷',
      'Lightning Reign': '神雷轰天',
      'Lightning Storm': '百雷',
      'Magmatic Spell': '魔成岩',
      'Noble Dawn': '审理的太阳',
      'Once Above, Ever Below': '生死袭火之择',
      'Ordeal of Thunder': '天雷神裁',
      'Peal of the Hammer': '比尔格之锤',
      'Radiant Finish': '炎扇流舞·终炎',
      'Radiant Rhythm': '炎扇流舞',
      'Rejuvenating Spark': '生命之火',
      'Reproduce': '生成分裂体',
      'Rhalgr\'s Beacon': '破军之流星',
      'Roaring Blaze': '轰炎法',
      'Seventh Passage': '炎天环',
      'Shock': '放电',
      'Slash and Burn': '火焰旋爪',
      'Smelting': '震动波',
      'Solar Fans': '红炎扇刃',
      'Solar Flair': '红炎爆尘',
      'Solar Fold': '红炎斩',
      'Solar Wings': '两翼红炎风',
      'Soul\'s Measure': '天平的试炼',
      'Spinning Slash': '圆弧旋爪',
      'Striking Meteor': '小流星',
      'Stygian Tenet': '札尔神火',
      'Sublime Sunset': '神技·落日',
      'Sun\'s Shine': '蜃景',
      'Sunbeam': '太阳光',
      '(?<! )Sunset': '落日',
      'The Builder\'s Forge': '工艺神创',
      'Tipped Scales': '算命魂葬',
      'Trial by Fire': '火焰法',
      'Twingaze': '热闪',
      'Warden\'s Prominence': '神火天阳',
      'Warden\'s Warmth': '神炎',
      'Wayward Soul': '死魂爆',
      'Wildfire Ward': '燎原之炎'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Azeyma(?!\')': '아제마',
      'Azeyma\'s Heat': '아제마의 신기루',
      'Byregot(?!\')': '비레고',
      'Byregot\'s Avatar': '비레고의 분신',
      'Ingenuity\'s Foothold': '기교궁',
      'Lightning Orb': '번개 구체',
      'Lion of Aglaia': '아글라이아 수사자',
      'Lioness of Aglaia': '아글라이아 암사자',
      'Nald(?!\')': '날 신',
      'Nald\'thal': '날달',
      'Prodigal Sun': '환영 태양',
      'Rhalgr(?!\')': '랄거',
      'Rhalgr\'s Emissary': '랄거의 특사',
      'Soul Vessel': '혼의 그릇',
      'Sunstorm': '태양 영기',
      '(?<!\')Thal': '달 신',
      'The Circle Of Inquiry': '심판궁',
      'The Endless City': '웅장한 도시',
      'The Monument To Destruction': '혜성궁',
      'The Path': '인도의 회랑',
      'The Twin Halls': '이면궁'
    },
    'replaceText': {
      '--hammer--': '--망치--',
      '\(fake\)': '가짜',
      '\(proximity\)': '거리감쇠',
      '\(summon\)': '소환',
      'Advent of the Eighth': '혜성륜',
      'As Above, So Below': '생사택일의 화염',
      'Balance': '혼 청산',
      'Bolts from the Blue': '천뢰',
      'Boltloop': '고리번개',
      'Bronze Lightning': '굉뢰',
      'Bronze Work': '굉뢰의 지팡이',
      'Broken World': '파괴의 혜성',
      'Builder\'s Build': '비레고의 증강',
      'Byregot\'s Spire': '비레고의 첨탑',
      'Byregot\'s Strike': '비레고의 강타',
      'Byregot\'s Ward': '비레고의 비호',
      'Cloud to Ground': '습뢰',
      'Dancing Flame': '줄불',
      'Deepest Pit': '죽음의 폭격',
      'Destructive Bolt': '파괴번개 일격',
      'Destructive Charge': '파괴번개 구체',
      'Destructive Static': '파괴번개 베기',
      'Destructive Strike': '파괴신 베기',
      'Double Immolation': '쌍염법',
      'Equal Weight': '혼 가산',
      'Fan Flames': '불부채 점화',
      'Far Above, Deep Below': '생사택일: 포화',
      'Far-flung Fire': '삶의 화포',
      'Fired Up I(?!I)': '연화의 재물 하나',
      'Fired Up II(?!I)': '연화의 재물 둘',
      'Fired Up III': '연화의 재물 셋',
      'Fleeting Spark': '열화의 돌려차기',
      'Fortune\'s Flux': '연화 발양',
      'Golden Tenet': '날 신의 불',
      'Hand of the Destroyer': '파괴신 창환격',
      'Haute Air': '부채질',
      'Hearth Above, Flight Below': '생사택일: 섬호',
      'Heat Above, Flames Below': '생사택일: 환화',
      'Heavens\' Trial': '염천의 신성한 불',
      'Hell of Fire': '염옥파',
      'Hell of Lightning': '번개지옥 구체',
      'Hells\' Trial': '염옥의 신성한 불',
      'Illuminating Glimpse': '열화일섬',
      'Levinforge': '뇌광',
      'Lightning Bolt': '낙뢰',
      'Lightning Reign': '신뢰굉천',
      'Lightning Storm': '백뢰',
      'Magmatic Spell': '마성암',
      'Noble Dawn': '심판의 태양',
      'Once Above, Ever Below': '생사택일: 습화',
      'Ordeal of Thunder': '번개의 시련',
      'Peal of the Hammer': '비레고의 망치',
      'Radiant Finish': '불부채춤 마무리',
      'Radiant Rhythm': '불부채춤',
      'Rejuvenating Spark': '생명의 불',
      'Reproduce': '분열체 생성',
      'Rhalgr\'s Beacon': '파군의 유성',
      'Roaring Blaze': '굉염법',
      'Seventh Passage': '염천 충격',
      'Shock': '방전',
      'Slash and Burn': '화염 발톱',
      'Smelting': '진동파',
      'Solar Fans': '홍염 부채칼',
      'Solar Flair': '홍염 폭발',
      'Solar Fold': '홍염 베기',
      'Solar Wings': '양익 홍염풍',
      'Soul\'s Measure': '천칭의 시련',
      'Spinning Slash': '원호 발톱',
      'Striking Meteor': '소유성',
      'Stygian Tenet': '달 신의 불',
      'Sublime Sunset': '신의 기술: 떨어지는 해',
      'Sun\'s Shine': '아지랑이',
      'Sunbeam': '태양광',
      '(?<! )Sunset': '떨어지는 해',
      'The Builder\'s Forge': '비레고의 창조',
      'Tipped Scales': '산명혼장',
      'Trial by Fire': '화염법',
      'Twingaze': '열섬',
      'Warden\'s Prominence': '신불 태양',
      'Warden\'s Warmth': '신의 불꽃',
      'Wayward Soul': '사혼 폭발',
      'Wildfire Ward': '요원의 불길'
    }
  }]
};
/* harmony default export */ const aglaia = (aglaia_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/alliance/aglaia.txt
const alliance_aglaia_namespaceObject = "# Aglaia\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Fan Flames\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~#\r\n# BYREGOT #\r\n#~~~~~~~~~#\r\n\r\n# -p 7176:1010.5\r\n# -ii 7165 7168 704D 704E 716D 716E\r\n\r\n# TODO: is the Builder's Build consistent in the loop? I've seen it missed at 1337.5, but not after that\r\n\r\n# Note: 7171 Peal of the Hammer is when the Levinforge hammer drops, and is marked as \"--sync--\"\" instead.\r\n# Note: \"--hammer--\" lines are done visually, as there seem to be no log line for them.\r\n\r\n# Ingenuity's Foothold will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"104D\" } window 10000,0\r\n1005.5 \"--sync--\" StartsUsing { id: \"7176\", source: \"Byregot\" } window 10,10\r\n1010.5 \"Ordeal of Thunder\" Ability { id: \"7176\", source: \"Byregot\" }\r\n1022.4 \"Byregot's Strike\" Ability { id: \"725A\", source: \"Byregot\" }\r\n1036.7 \"Byregot's Ward\" Ability { id: \"7175\", source: \"Byregot\" }\r\n1044.8 \"Builder's Build\" Ability { id: \"72F9\", source: \"Byregot\" }\r\n1053.2 \"Byregot's Strike\" Ability { id: \"7167\", source: \"Byregot\" }\r\n\r\n1060.4 \"--middle--\" Ability { id: \"7169\", source: \"Byregot\" }\r\n1062.9 \"The Builder's Forge\" Ability { id: \"716A\", source: \"Byregot\" }\r\n1069.4 \"--sync--\" Ability { id: \"7174\", source: \"Byregot\" }\r\n1083.3 \"Peal of the Hammer\" Ability { id: \"716F\", source: \"Byregot\" }\r\n1108.3 \"--sync--\" Ability { id: \"7171\", source: \"Byregot\" }\r\n1110.1 \"--hammer--\"\r\n1110.4 \"Peal of the Hammer\" Ability { id: \"716F\", source: \"Byregot\" }\r\n1127.2 \"--hammer--\"\r\n1127.6 \"Levinforge\" Ability { id: \"7172\", source: \"Byregot\" }\r\n1129.1 \"Peal of the Hammer\" Ability { id: \"716F\", source: \"Byregot\" }\r\n1135.3 \"--north--\" Ability { id: \"7169\", source: \"Byregot\" }\r\n1145.9 \"--hammer--\"\r\n1148.1 \"Byregot's Spire\" Ability { id: \"7170\", source: \"Byregot\" }\r\n\r\n# If Byregot uses Builder's Build, then Strike has lightning and is pushed\r\n# back ~5.6seconds.  The real time for Builder's Build is 1176.6.  This\r\n# sync adjusts the timeline backwards in time to adjust for this.\r\n1151.2 \"--middle--\" Ability { id: \"7169\", source: \"Byregot\" }\r\n1153.4 \"The Builder's Forge\" Ability { id: \"716A\", source: \"Byregot\" }\r\n1168.0 \"--sync--\" StartsUsing { id: \"72F9\", source: \"Byregot\" } window 10,10\r\n1171.0 \"Builder's Build?\" Ability { id: \"72F9\", source: \"Byregot\" }\r\n1173.7 \"--sync--\" StartsUsing { id: [\"725A\", \"7167\"], source: \"Byregot\" } window 10,10\r\n1179.7 \"Byregot's Strike\" Ability { id: [\"725A\", \"7167\"], source: \"Byregot\" }\r\n1187.8 \"Ordeal of Thunder\" Ability { id: \"7176\", source: \"Byregot\" }\r\n1196.9 \"Reproduce\" Ability { id: \"716B\", source: \"Byregot\" }\r\n1199.8 \"Builder's Build\" Ability { id: \"72FA\", source: \"Byregot's Avatar\" }\r\n1207.8 \"Cloud to Ground\" Ability { id: \"716C\", source: \"Byregot's Avatar\" } duration 7.6\r\n1223.0 \"Byregot's Ward\" Ability { id: \"7175\", source: \"Byregot\" }\r\n\r\n1225.1 \"--middle--\" Ability { id: \"7169\", source: \"Byregot\" }\r\n1227.4 \"The Builder's Forge\" Ability { id: \"716A\", source: \"Byregot\" }\r\n1234.1 \"--sync--\" Ability { id: \"7174\", source: \"Byregot\" }\r\n1247.7 \"--sync--\" Ability { id: \"7171\", source: \"Byregot\" }\r\n1249.8 \"Peal of the Hammer\" Ability { id: \"716F\", source: \"Byregot\" }\r\n1266.6 \"--hammer--\"\r\n1267.0 \"Levinforge\" Ability { id: \"7172\", source: \"Byregot\" }\r\n1274.8 \"--sync--\" Ability { id: \"7171\", source: \"Byregot\" }\r\n1276.9 \"Peal of the Hammer\" Ability { id: \"716F\", source: \"Byregot\" }\r\n1293.7 \"--hammer--\"\r\n1294.1 \"Levinforge\" Ability { id: \"7172\", source: \"Byregot\" }\r\n1295.6 \"Peal of the Hammer\" Ability { id: \"716F\", source: \"Byregot\" }\r\n1301.8 \"--north--\" Ability { id: \"7169\", source: \"Byregot\" }\r\n1312.4 \"--hammer--\"\r\n1314.6 \"Byregot's Spire\" Ability { id: \"7170\", source: \"Byregot\" }\r\n\r\n1317.7 \"--middle--\" Ability { id: \"7169\", source: \"Byregot\" }\r\n1319.9 \"The Builder's Forge\" Ability { id: \"716A\", source: \"Byregot\" }\r\n1334.5 \"--sync--\" StartsUsing { id: \"72F9\", source: \"Byregot\" } window 10,10\r\n1337.5 \"Builder's Build?\" Ability { id: \"72F9\", source: \"Byregot\" }\r\n1340.2 \"--sync--\" StartsUsing { id: [\"725A\", \"7167\"], source: \"Byregot\" } window 10,10\r\n1346.2 \"Byregot's Strike\" Ability { id: [\"725A\", \"7167\"], source: \"Byregot\" }\r\n1354.3 \"Ordeal of Thunder\" Ability { id: \"7176\", source: \"Byregot\" }\r\n1366.5 \"Byregot's Ward\" Ability { id: \"7175\", source: \"Byregot\" }\r\n1374.6 \"Reproduce\" Ability { id: \"716B\", source: \"Byregot\" }\r\n1377.5 \"Builder's Build\" Ability { id: \"72FA\", source: \"Byregot's Avatar\" }\r\n1385.5 \"Cloud to Ground\" Ability { id: \"716C\", source: \"Byregot's Avatar\" } duration 7.6\r\n\r\n# LOOP\r\n1395.7 \"--middle--\" Ability { id: \"7169\", source: \"Byregot\" }\r\n1398.1 \"The Builder's Forge\" Ability { id: \"716A\", source: \"Byregot\" } window 50,50 jump 1227.4\r\n1404.7 \"--sync--\" #Ability { id: \"7174\", source: \"Byregot\" }\r\n1418.4 \"--sync--\" #Ability { id: \"7171\", source: \"Byregot\" }\r\n1420.5 \"Peal of the Hammer\" #Ability { id: \"716F\", source: \"Byregot\" }\r\n1437.3 \"--hammer--\"\r\n1437.7 \"Levinforge\" #Ability { id: \"7172\", source: \"Byregot\" }\r\n1445.4 \"--sync--\" #Ability { id: \"7171\", source: \"Byregot\" }\r\n1447.5 \"Peal of the Hammer\" #Ability { id: \"716F\", source: \"Byregot\" }\r\n1464.3 \"--hammer--\"\r\n1464.7 \"Levinforge\" #Ability { id: \"7172\", source: \"Byregot\" }\r\n1466.2 \"Peal of the Hammer\" #Ability { id: \"716F\", source: \"Byregot\" }\r\n1472.4 \"--north--\" #Ability { id: \"7169\", source: \"Byregot\" }\r\n1483.0 \"--hammer--\"\r\n1485.2 \"Byregot's Spire\" #Ability { id: \"7170\", source: \"Byregot\" }\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~#\r\n# RHALGR'S EMISSARY #\r\n#~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 70E0:2012.8\r\n# -ii 70D8 70E2 70E4 70DC\r\n\r\n# The Path will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"104E\" } window 10000,0\r\n2004.8 \"--sync--\" StartsUsing { id: \"70E0\", source: \"Rhalgr's Emissary\" } window 10,10\r\n2012.8 \"Destructive Static\" Ability { id: \"70E0\", source: \"Rhalgr's Emissary\" }\r\n2019.8 \"Destructive Charge\" Ability { id: \"70DA\", source: \"Rhalgr's Emissary\" } duration 17\r\n2036.9 \"--sync--\" Ability { id: \"70DB\", source: \"Rhalgr's Emissary\" }\r\n2037.5 \"Lightning Bolt x3\" Ability { id: \"70E1\", source: \"Rhalgr's Emissary\" } duration 8\r\n2052.7 \"Bolts from the Blue\" Ability { id: \"70E3\", source: \"Rhalgr's Emissary\" }\r\n2058.1 \"Destructive Charge\" Ability { id: \"70DA\", source: \"Rhalgr's Emissary\" } duration 17\r\n2075.2 \"--sync--\" Ability { id: \"70DB\", source: \"Rhalgr's Emissary\" }\r\n2078.1 \"Destructive Static\" Ability { id: \"70E0\", source: \"Rhalgr's Emissary\" }\r\n2087.4 \"Boltloop 1\" Ability { id: \"70DD\", source: \"Rhalgr's Emissary\" }\r\n2089.4 \"Boltloop 2\" Ability { id: \"70DE\", source: \"Rhalgr's Emissary\" }\r\n2091.4 \"Boltloop 3\" Ability { id: \"70DF\", source: \"Rhalgr's Emissary\" }\r\n2100.6 \"Destructive Strike\" Ability { id: \"70D9\", source: \"Rhalgr's Emissary\" }\r\n2111.7 \"Bolts from the Blue\" Ability { id: \"70E3\", source: \"Rhalgr's Emissary\" }\r\n2118.1 \"Destructive Charge\" Ability { id: \"70DA\", source: \"Rhalgr's Emissary\" } duration 17\r\n2135.2 \"--sync--\" Ability { id: \"70DB\", source: \"Rhalgr's Emissary\" }\r\n2135.7 \"Lightning Bolt x3\" Ability { id: \"70E1\", source: \"Rhalgr's Emissary\" } duration 8\r\n# TODO: is this a loop back to  2037.5??\r\n\r\n\r\n#~~~~~~~~#\r\n# RHALGR #\r\n#~~~~~~~-#\r\n\r\n# -p 70A5:3012.5\r\n# -ii 70A3 70B0 70B8 7314 70AF 70B4 70B1 71DC 72A3 72A4 72A5 70B7 71E0 71DB\r\n\r\n# TODO: is the ordering of fake vs real Broken World correct? Every log has been this.\r\n\r\n# Monument to Destruction will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"104F\" } window 10000,0\r\n3007.5 \"--sync--\" StartsUsing { id: \"70A5\", source: \"Rhalgr\" } window 10,10\r\n3012.5 \"Lightning Reign\" Ability { id: \"70A5\", source: \"Rhalgr\" }\r\n3023.6 \"Advent of the Eighth\" Ability { id: \"70A7\", source: \"Rhalgr\" }\r\n3038.7 \"Hand of the Destroyer\" Ability { id: \"70A[89]\", source: \"Rhalgr\" }\r\n3054.6 \"Broken World (summon)\" Ability { id: \"70A6\", source: \"Rhalgr\" }\r\n3067.3 \"Broken World (proximity)\" Ability { id: \"70B6\", source: \"Rhalgr\" }\r\n3078.1 \"Rhalgr's Beacon\" Ability { id: \"70AA\", source: \"Rhalgr\" }\r\n3094.3 \"Advent of the Eighth\" Ability { id: \"70A7\", source: \"Rhalgr\" }\r\n3109.5 \"Hand of the Destroyer\" Ability { id: \"70A[89]\", source: \"Rhalgr\" }\r\n3125.3 \"Destructive Bolt\" Ability { id: \"70A4\", source: \"Rhalgr\" }\r\n3136.5 \"Advent of the Eighth\" Ability { id: \"70A7\", source: \"Rhalgr\" }\r\n3142.6 \"--jump--\" Ability { id: \"70AE\", source: \"Rhalgr\" }\r\n3147.0 \"Broken World (summon)\" Ability { id: \"70A6\", source: \"Rhalgr\" }\r\n3158.1 \"Hand of the Destroyer\" Ability { id: \"70AC\", source: \"Rhalgr\" }\r\n3163.9 \"Broken World (fake)\" Ability { id: \"71DD\", source: \"Rhalgr\" }\r\n3180.2 \"Advent of the Eighth\" Ability { id: \"70A7\", source: \"Rhalgr\" }\r\n3189.3 \"Broken World (summon)\" Ability { id: \"70A6\", source: \"Rhalgr\" }\r\n3200.4 \"Hand of the Destroyer\" Ability { id: \"70AC\", source: \"Rhalgr\" }\r\n3206.2 \"Broken World (fake)\" Ability { id: \"71DD\", source: \"Rhalgr\" }\r\n\r\n3214.6 \"--middle--\" Ability { id: \"70AE\", source: \"Rhalgr\" }\r\n3222.5 \"Bronze Work\" Ability { id: \"70AB\", source: \"Rhalgr\" }\r\n3223.0 \"Bronze Lightning 1\" Ability { id: \"70B9\", source: \"Rhalgr\" } window 1,1\r\n3225.0 \"Striking Meteor 1\" Ability { id: \"70BB\", source: \"Rhalgr\" } window 1,1\r\n3225.0 \"Bronze Lightning 2\" Ability { id: \"70B9\", source: \"Rhalgr\" } window 1,1\r\n3227.0 \"Striking Meteor 2\" Ability { id: \"70BB\", source: \"Rhalgr\" } window 1,1\r\n3230.6 \"Destructive Bolt\" Ability { id: \"70A4\", source: \"Rhalgr\" }\r\n\r\n3236.7 \"Advent of the Eighth\" Ability { id: \"70A7\", source: \"Rhalgr\" }\r\n3245.8 \"Broken World (summon)\" Ability { id: \"70A6\", source: \"Rhalgr\" }\r\n3256.9 \"Hand of the Destroyer\" Ability { id: \"70A9\", source: \"Rhalgr\" }\r\n3258.5 \"Broken World (proximity)\" Ability { id: \"70B6\", source: \"Rhalgr\" }\r\n3265.9 \"Lightning Storm\" Ability { id: \"70BA\", source: \"Rhalgr\" }\r\n\r\n3274.7 \"Hell of Lightning\" Ability { id: \"70AD\", source: \"Rhalgr\" }\r\n3286.1 \"Rhalgr's Beacon\" Ability { id: \"70AA\", source: \"Rhalgr\" }\r\n3289.8 \"Shock\" Ability { id: \"70B3\", source: \"Lightning Orb\" }\r\n\r\n3302.2 \"Advent of the Eighth\" Ability { id: \"70A7\", source: \"Rhalgr\" }\r\n3311.3 \"Broken World (summon)\" Ability { id: \"70A6\", source: \"Rhalgr\" }\r\n3322.4 \"Hand of the Destroyer\" Ability { id: \"70A[C9]\", source: \"Rhalgr\" }\r\n3328.3 \"Broken World (fake)\" Ability { id: \"71DD\", source: \"Rhalgr\" }\r\n3337.6 \"Lightning Reign\" Ability { id: \"70A5\", source: \"Rhalgr\" }\r\n\r\n3347.8 \"--middle--\" Ability { id: \"70AE\", source: \"Rhalgr\" }\r\n3355.5 \"Bronze Work\" Ability { id: \"70AB\", source: \"Rhalgr\" }\r\n3356.0 \"Bronze Lightning 1\" Ability { id: \"70B9\", source: \"Rhalgr\" } window 1,1\r\n3358.0 \"Striking Meteor 1\" Ability { id: \"70BB\", source: \"Rhalgr\" } window 1,1\r\n3358.0 \"Bronze Lightning 2\" Ability { id: \"70B9\", source: \"Rhalgr\" } window 1,1\r\n3360.0 \"Striking Meteor 2\" Ability { id: \"70BB\", source: \"Rhalgr\" } window 1,1\r\n3363.6 \"Destructive Bolt\" Ability { id: \"70A4\", source: \"Rhalgr\" }\r\n\r\n# Loop\r\n3369.7 \"Advent of the Eighth\" Ability { id: \"70A7\", source: \"Rhalgr\" } window 30,30 jump 3236.7\r\n3378.8 \"Broken World (summon)\" #Ability { id: \"70A6\", source: \"Rhalgr\" }\r\n3389.9 \"Hand of the Destroyer\" #Ability { id: \"70A9\", source: \"Rhalgr\" }\r\n3391.5 \"Broken World (proximity)\" #Ability { id: \"70B6\", source: \"Rhalgr\" }\r\n3398.9 \"Lightning Storm\" #Ability { id: \"70BA\", source: \"Rhalgr\" }\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~#\r\n# LIONS OF AGLAIA #\r\n#~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 71D7:4012\r\n# -ii 71D8 71D1 71D3 71D4\r\n\r\n# TODO: These do \"Rejuvenating Spark\" (71D9) to rebalance health.  Does that adjust timings?\r\n\r\n# Endless City will be sealed off\r\n4000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1050\" } window 10000,0\r\n4007.0 \"--sync--\" StartsUsing { id: \"71D7\", source: \"Lioness of Aglaia\" } window 10,10\r\n4012.0 \"Double Immolation\" Ability { id: \"71D7\", source: \"Lioness of Aglaia\" }\r\n4019.8 \"--sync--\" Ability { id: \"71CD\", source: \"Lioness of Aglaia\" } window 10,10\r\n4028.1 \"Slash and Burn\" Ability { id: [\"71D0\", \"71D2\"], source: [\"Lion of Aglaia\", \"Lioness of Aglaia\"] }\r\n4031.3 \"Slash and Burn\" Ability { id: [\"71D6\", \"71D5\"], source: [\"Lioness of Aglaia\", \"Lion of Aglaia\"] }\r\n4036.1 \"--sync--\" Ability { id: \"71CD\", source: \"Lioness of Aglaia\" } window 10,10\r\n4044.7 \"Slash and Burn\" Ability { id: [\"71D0\", \"71D2\"], source: [\"Lion of Aglaia\", \"Lioness of Aglaia\"] }\r\n4047.9 \"Slash and Burn\" Ability { id: [\"71D6\", \"71D5\"], source: [\"Lioness of Aglaia\", \"Lion of Aglaia\"] }\r\n4056.7 \"--sync--\" Ability { id: \"71CD\", source: \"Lioness of Aglaia\" } window 10,10\r\n4063.8 \"Roaring Blaze\" Ability { id: \"71CE\", source: \"Lioness of Aglaia\" }\r\n4066.8 \"Roaring Blaze\" Ability { id: \"71CF\", source: \"Lion of Aglaia\" }\r\n4072.4 \"--sync--\" Ability { id: \"71CD\", source: \"Lioness of Aglaia\" } window 10,10\r\n4079.5 \"Roaring Blaze\" Ability { id: \"71CE\", source: \"Lion of Aglaia\" }\r\n4082.5 \"Roaring Blaze\" Ability { id: \"71CF\", source: \"Lioness of Aglaia\" }\r\n4085.1 \"Rejuvenating Spark\" Ability { id: \"71D9\", source: [\"Lion of Aglaia\", \"Lioness of Aglaia\"] }\r\n4093.4 \"--sync--\" Ability { id: \"71CD\", source: \"Lioness of Aglaia\" } window 10,10\r\n4101.7 \"Slash and Burn\" Ability { id: \"71D2\", source: \"Lioness of Aglaia\" }\r\n# ??? (is this a loop?)\r\n\r\n\r\n# Lioness dead branch\r\n4500.0 \"--sync--\" StartsUsing { id: \"72C0\", source: \"Lion of Aglaia\" } window 500,100\r\n4504.0 \"Trial by Fire\" Ability { id: \"72C0\", source: \"Lion of Aglaia\" }\r\n4515.5 \"Roaring Blaze\" Ability { id: \"72BF\", source: \"Lion of Aglaia\" }\r\n\r\n4526.9 \"Trial by Fire\" #Ability { id: \"72C0\", source: \"Lion of Aglaia\" }\r\n4538.4 \"Roaring Blaze\" #Ability { id: \"72BF\", source: \"Lion of Aglaia\" }\r\n\r\n# guessing at these two and the loop\r\n4549.8 \"Trial by Fire\" #Ability { id: \"72C0\", source: \"Lion of Aglaia\" }\r\n4561.3 \"Roaring Blaze\" #Ability { id: \"72BF\", source: \"Lion of Aglaia\" }\r\n\r\n\r\n# Lion dead branch\r\n4800.0 \"--sync--\" StartsUsing { id: \"72C1\", source: \"Lioness of Aglaia\" } window 800,100\r\n4804.0 \"Spinning Slash\" Ability { id: \"72C1\", source: \"Lioness of Aglaia\" }\r\n4815.5 \"Roaring Blaze\" Ability { id: \"72BF\", source: \"Lioness of Aglaia\" }\r\n\r\n4826.9 \"Spinning Slash\" #Ability { id: \"72C1\", source: \"Lioness of Aglaia\" }\r\n4838.4 \"Roaring Blaze\" #Ability { id: \"72BF\", source: \"Lioness of Aglaia\" }\r\n\r\n4849.8 \"Spinning Slash\" #Ability { id: \"72C1\", source: \"Lioness of Aglaia\" }\r\n4861.3 \"Roaring Blaze\" #Ability { id: \"72BF\", source: \"Lioness of Aglaia\" }\r\n\r\n\r\n#~~~~~~~~#\r\n# AZEYMA #\r\n#~~~~~~~~#\r\n\r\n# -p 70A0:5012.2\r\n# -ii 70A1 7082 7083 709F 708E 72BE 7093 7094 71EE 7089 731C 708C 7092 7087\r\n\r\n# Circle of Inquiry will be sealed off\r\n5000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1051\" } window 10000,0\r\n5006.2 \"--sync--\" StartsUsing { id: \"70A0\", source: \"Azeyma\" } window 10,10\r\n5012.2 \"Warden's Prominence\" Ability { id: \"70A0\", source: \"Azeyma\" }\r\n\r\n5018.3 \"--middle--\" Ability { id: \"70A2\", source: \"Azeyma\" }\r\n5019.9 \"Fan Flames\" Ability { id: \"7080\", source: \"Azeyma\" }\r\n5030.2 \"Solar Wings\" Ability { id: \"7081\", source: \"Azeyma\" }\r\n5037.9 \"Solar Flair\" Ability { id: \"7084\", source: \"Sunstorm\" }\r\n5050.6 \"Warden's Warmth\" Ability { id: \"709E\", source: \"Azeyma\" }\r\n\r\n5056.7 \"--middle--\" Ability { id: \"70A2\", source: \"Azeyma\" }\r\n5058.3 \"Fan Flames\" Ability { id: \"7080\", source: \"Azeyma\" }\r\n5065.2 \"Solar Wings\" Ability { id: \"7081\", source: \"Azeyma\" }\r\n5070.6 \"Sun's Shine\" Ability { id: \"7085\", source: \"Azeyma\" }\r\n5073.5 \"--sync--\" Ability { id: \"7315\", source: \"Azeyma's Heat\" }\r\n5081.4 \"Haute Air\" Ability { id: \"7086\", source: \"Azeyma's Heat\" }\r\n5084.0 \"Solar Flair\" Ability { id: \"7084\", source: \"Sunstorm\" }\r\n\r\n5084.7 \"--middle--\" Ability { id: \"70A2\", source: \"Azeyma\" }\r\n5086.3 \"Fan Flames\" Ability { id: \"7080\", source: \"Azeyma\" }\r\n5093.1 \"Solar Fans\" Ability { id: \"708D\", source: \"Azeyma\" }\r\n5101.3 \"Radiant Rhythm\" Ability { id: \"708F\", source: \"Azeyma\" }\r\n5102.7 \"Radiant Rhythm\" #Ability { id: \"7090\", source: \"Azeyma\" }\r\n5104.1 \"Radiant Rhythm\" #Ability { id: \"7090\", source: \"Azeyma\" }\r\n5105.5 \"Radiant Rhythm\" #Ability { id: \"7090\", source: \"Azeyma\" }\r\n5109.9 \"Radiant Finish\" Ability { id: \"7091\", source: \"Azeyma\" }\r\n5116.0 \"--sync--\" Ability { id: \"72B0\", source: \"Azeyma\" }\r\n5126.1 \"Warden's Warmth\" Ability { id: \"709E\", source: \"Azeyma\" }\r\n5137.9 \"Fleeting Spark\" Ability { id: \"709C\", source: \"Azeyma\" }\r\n\r\n5143.3 \"--middle--\" Ability { id: \"70A2\", source: \"Azeyma\" }\r\n5144.9 \"Fan Flames\" Ability { id: \"7080\", source: \"Azeyma\" }\r\n5152.0 \"Solar Fold\" Ability { id: \"7088\", source: \"Azeyma\" }\r\n5152.0 \"Solar Fold\" Ability { id: \"71EE\", source: \"Azeyma\" }\r\n5157.1 \"Sun's Shine\" Ability { id: \"7085\", source: \"Azeyma\" }\r\n5160.0 \"--sync--\" Ability { id: \"7315\", source: \"Azeyma's Heat\" }\r\n5174.9 \"Haute Air\" Ability { id: \"708A\", source: \"Azeyma's Heat\" }\r\n5176.0 \"Dancing Flame\" Ability { id: \"708B\", source: \"Azeyma\" }\r\n5184.2 \"Warden's Prominence\" Ability { id: \"70A0\", source: \"Azeyma\" }\r\n\r\n5188.4 \"--middle--\" Ability { id: \"70A2\", source: \"Azeyma\" }\r\n5195.0 \"Wildfire Ward\" Ability { id: \"709A\", source: \"Azeyma\" }\r\n5211.2 \"Illuminating Glimpse 1\" Ability { id: \"709B\", source: \"Azeyma's Heat\" }\r\n5215.3 \"Illuminating Glimpse 2\" Ability { id: \"709B\", source: \"Azeyma's Heat\" }\r\n5219.3 \"Illuminating Glimpse 3\" Ability { id: \"709B\", source: \"Azeyma's Heat\" }\r\n\r\n5225.2 \"--jump--\" Ability { id: \"70A2\", source: \"Azeyma\" }\r\n5230.8 \"Noble Dawn\" Ability { id: \"7095\", source: \"Azeyma\" }\r\n5234.6 \"Sunbeam 1\" #Ability { id: \"7096\", source: \"Prodigal Sun\" }\r\n5236.6 \"Sunbeam 2\" #Ability { id: \"7096\", source: \"Prodigal Sun\" }\r\n5238.6 \"Sunbeam 3\" #Ability { id: \"7096\", source: \"Prodigal Sun\" }\r\n5241.6 \"Sunbeam 1\" #Ability { id: \"7097\", source: \"Prodigal Sun\" }\r\n5243.6 \"Sunbeam 2\" #Ability { id: \"7097\", source: \"Prodigal Sun\" }\r\n5245.6 \"Sunbeam 3\" #Ability { id: \"7097\", source: \"Prodigal Sun\" }\r\n\r\n5248.8 \"--jump--\" Ability { id: \"70A2\", source: \"Azeyma\" }\r\n5259.7 \"Sublime Sunset\" Ability { id: \"7098\", source: \"Azeyma\" }\r\n5260.3 \"Sunset\" Ability { id: \"7099\", source: \"Prodigal Sun\" }\r\n\r\n5268.9 \"--middle--\" Ability { id: \"70A2\", source: \"Azeyma\" }\r\n5270.5 \"Fan Flames\" Ability { id: \"7080\", source: \"Azeyma\" }\r\n5277.4 \"Solar Fans\" Ability { id: \"708D\", source: \"Azeyma\" }\r\n5285.6 \"Radiant Rhythm\" Ability { id: \"708F\", source: \"Azeyma\" }\r\n5287.0 \"Radiant Rhythm\" #Ability { id: \"7090\", source: \"Azeyma\" }\r\n5288.4 \"Radiant Rhythm\" #Ability { id: \"7090\", source: \"Azeyma\" }\r\n5289.8 \"Radiant Rhythm\" #Ability { id: \"7090\", source: \"Azeyma\" }\r\n5291.2 \"Radiant Rhythm\" #Ability { id: \"7090\", source: \"Azeyma\" }\r\n5295.6 \"Radiant Finish\" Ability { id: \"7091\", source: \"Azeyma\" }\r\n5306.1 \"Fleeting Spark\" Ability { id: \"709C\", source: \"Azeyma\" }\r\n\r\n5309.8 \"--sync--\" Ability { id: \"72B0\", source: \"Azeyma\" }\r\n5317.0 \"--middle--\" Ability { id: \"70A2\", source: \"Azeyma\" }\r\n5318.6 \"Fan Flames\" Ability { id: \"7080\", source: \"Azeyma\" }\r\n5325.8 \"Solar Wings\" Ability { id: \"7081\", source: \"Azeyma\" }\r\n5331.2 \"Sun's Shine\" Ability { id: \"7085\", source: \"Azeyma\" }\r\n5334.1 \"--sync--\" Ability { id: \"7315\", source: \"Azeyma's Heat\" }\r\n5342.0 \"Haute Air\" Ability { id: \"7086\", source: \"Azeyma's Heat\" }\r\n5344.7 \"Solar Flair\" Ability { id: \"7084\", source: \"Sunstorm\" }\r\n5352.4 \"Warden's Warmth\" Ability { id: \"709E\", source: \"Azeyma\" }\r\n\r\n5357.6 \"--middle--\" Ability { id: \"70A2\", source: \"Azeyma\" }\r\n5359.2 \"Fan Flames\" Ability { id: \"7080\", source: \"Azeyma\" }\r\n5366.4 \"Solar Fold\" Ability { id: \"7088\", source: \"Azeyma\" }\r\n5371.5 \"Sun's Shine\" Ability { id: \"7085\", source: \"Azeyma\" }\r\n5374.4 \"--sync--\" Ability { id: \"7315\", source: \"Azeyma's Heat\" }\r\n5389.3 \"Haute Air\" Ability { id: \"708A\", source: \"Azeyma's Heat\" }\r\n5390.4 \"Dancing Flame\" Ability { id: \"708B\", source: \"Azeyma\" }\r\n\r\n5396.6 \"Warden's Prominence\" Ability { id: \"70A0\", source: \"Azeyma\" }\r\n5402.7 \"--sync--\" Ability { id: \"70A2\", source: \"Azeyma\" }\r\n5408.3 \"Noble Dawn\" Ability { id: \"7095\", source: \"Azeyma\" }\r\n5412.1 \"Sunbeam 1\" #Ability { id: \"7096\", source: \"Prodigal Sun\" }\r\n5414.1 \"Sunbeam 2\" #Ability { id: \"7096\", source: \"Prodigal Sun\" }\r\n5416.1 \"Sunbeam 3\" #Ability { id: \"7096\", source: \"Prodigal Sun\" }\r\n5419.1 \"Sunbeam 1\" #Ability { id: \"7097\", source: \"Prodigal Sun\" }\r\n5421.1 \"Sunbeam 2\" #Ability { id: \"7097\", source: \"Prodigal Sun\" }\r\n5423.1 \"Sunbeam 3\" #Ability { id: \"7097\", source: \"Prodigal Sun\" }\r\n5431.0 \"Fleeting Spark\" Ability { id: \"709C\", source: \"Azeyma\" }\r\n5433.4 \"--sync--\" Ability { id: \"70A2\", source: \"Azeyma\" }\r\n5444.7 \"Sublime Sunset\" Ability { id: \"7098\", source: \"Azeyma\" }\r\n5445.2 \"Sunset\" Ability { id: \"7099\", source: \"Prodigal Sun\" }\r\n5453.8 \"Warden's Warmth\" Ability { id: \"709E\", source: \"Azeyma\" }\r\n\r\n# Loop? (this is a guess), 5516.7 is the furthest seen in a log.\r\n5460.0 \"--middle--\" Ability { id: \"70A2\", source: \"Azeyma\" }\r\n5461.6 \"Fan Flames\" Ability { id: \"7080\", source: \"Azeyma\" } window 50,50 jump 5270.5\r\n5468.5 \"Solar Fans\" #Ability { id: \"708D\", source: \"Azeyma\" }\r\n5476.7 \"Radiant Rhythm\" #Ability { id: \"708F\", source: \"Azeyma\" }\r\n5478.1 \"Radiant Rhythm\" #Ability { id: \"7090\", source: \"Azeyma\" }\r\n5479.5 \"Radiant Rhythm\" #Ability { id: \"7090\", source: \"Azeyma\" }\r\n5480.9 \"Radiant Rhythm\" #Ability { id: \"7090\", source: \"Azeyma\" }\r\n5482.3 \"Radiant Rhythm\" #Ability { id: \"7090\", source: \"Azeyma\" }\r\n5486.7 \"Radiant Finish\" #Ability { id: \"7091\", source: \"Azeyma\" }\r\n5497.2 \"Fleeting Spark\" #Ability { id: \"709C\", source: \"Azeyma\" }\r\n\r\n\r\n#~~~~~~~~~~~#\r\n# NALD'THAL #\r\n#~~~~~~~~~~~#\r\n\r\n# -p 70E9:6013.2 7125:7012.5\r\n# -it \"Nald'thal\"\r\n# -ii 738B 738C 711F 711B 73C4 73C5 73C6 72B8 7110 72BA 6FD5 712C 7379 737A 73C1 73C2 73C3 711D 73A6 73A7 73A8 73A9 73C8 742F 73AC 7116 7117 7114 7432 7115 73B0 7433 7435\r\n\r\n# TODO: Is Fired Up I/II always knockback -> out and I/II/III is out -> knockback -> knockback or out?\r\n\r\n# The Twin Halls will be sealed off\r\n6000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1052\" } window 10000,0\r\n6008.2 \"--sync--\" StartsUsing { id: \"70E9\", source: \"Nald'thal\" } window 10,10\r\n6013.2 \"As Above, So Below\" Ability { id: [\"70E8\", \"70E9\"], source: \"Nald'thal\" }\r\n6027.4 \"Heat Above, Flames Below\" Ability { id: \"73A5\", source: \"Nald'thal\" }\r\n6036.5 \"As Above, So Below\" Ability { id: [\"70E8\", \"70E9\"], source: \"Nald'thal\" }\r\n6049.7 \"Heat Above, Flames Below\" Ability { id: \"73A4\", source: \"Nald'thal\" }\r\n6056.8 \"--sync--\" Ability { id: \"73CD\", source: \"Nald'thal\" }\r\n6061.8 \"Heavens' Trial\" Ability { id: \"711E\", source: \"Nald'thal\" }\r\n6062.7 \"Smelting\" Ability { id: \"7120\", source: \"Nald'thal\" }\r\n6070.0 \"Golden Tenet\" Ability { id: \"711A\", source: \"Nald'thal\" }\r\n6081.6 \"As Above, So Below\" Ability { id: \"70E8\", source: \"Nald'thal\" }\r\n\r\n6095.8 \"Far Above, Deep Below\" Ability { id: \"73A[AB]\", source: \"Nald'thal\" }\r\n6096.7 \"Far-flung Fire?\" Ability { id: \"73AD\", source: \"Nald\" }\r\n6102.0 \"--sync--\" StartsUsing { id: \"70E[89]\", source: \"Nald'thal\" } window 10,10 # Possible ~1s delay here\r\n6102.1 \"Deepest Pit?\" Ability { id: \"73C7\", source: \"Thal\" } duration 4\r\n6107.0 \"As Above, So Below\" Ability { id: \"70E[89]\", source: \"Nald'thal\" }\r\n6121.2 \"Once Above, Ever Below\" Ability { id: [\"73BF\", \"73C0\", \"741C\", \"741D\"], source: \"Nald'thal\" }\r\n\r\n# Possible ~5s delay here\r\n6132.6 \"--sync--\" StartsUsing { id: \"72B[79]\", source: \"Nald'thal\" } window 10,10\r\n6140.6 \"Hell of Fire\" Ability { id: \"72B[79]\", source: \"Nald'thal\" }\r\n6147.2 \"--sync--\" Ability { id: \"710D\", source: \"Nald'thal\" }\r\n6152.3 \"Wayward Soul\" Ability { id: \"710E\", source: \"Nald'thal\" } duration 20\r\n6175.3 \"Wayward Soul\" Ability { id: \"710E\", source: \"Nald'thal\" } duration 20\r\n6193.5 \"--sync--\" Ability { id: \"710F\", source: \"Nald'thal\" }\r\n\r\n6199.2 \"--sync--\" StartsUsing { id: \"72B[79]\", source: \"Nald'thal\" } window 10,10\r\n6207.2 \"Hell of Fire\" Ability { id: \"72B[79]\", source: \"Nald'thal\" }\r\n6224.1 \"Fired Up I\" Ability { id: \"7111\", source: \"Nald'thal\" }\r\n6230.2 \"Fired Up II\" Ability { id: \"738A\", source: \"Nald'thal\" }\r\n6240.3 \"Fortune's Flux\" Ability { id: \"7113\", source: \"Nald'thal\" }\r\n6242.8 \"--sync--\" Ability { id: \"7430\", source: \"Thal\" }\r\n6242.8 \"Seventh Passage\" Ability { id: \"73AF\", source: [\"Thal\", \"Nald'thal\"] }\r\n6244.5 \"Seventh Passage\" Ability { id: \"7118\", source: \"Nald'thal\" }\r\n6244.8 \"--sync--\" Ability { id: \"7431\", source: \"Thal\" }\r\n6250.9 \"Fired Up I\" Ability { id: \"7112\", source: \"Nald'thal\" }\r\n6257.0 \"Fired Up II\" Ability { id: \"7389\", source: \"Nald'thal\" }\r\n6263.1 \"Fired Up III\" Ability { id: \"741[9A]\", source: \"Nald'thal\" }\r\n6273.2 \"Fortune's Flux\" Ability { id: \"7113\", source: \"Nald'thal\" }\r\n6275.1 \"Seventh Passage 1\" Ability { id: \"7119\", source: \"Nald'thal\" }\r\n6277.8 \"Seventh Passage 2\" #Ability { id: \"73AF\", source: \"Thal\" }\r\n6279.2 \"Seventh Passage 3\" #Ability { id: [\"73AF\", \"7118\"], source: \"Thal\" }\r\n6289.7 \"Soul's Measure\" Ability { id: \"7122\", source: \"Nald'thal\" }\r\n6290.8 \"--untargetable--\"\r\n\r\n# Add phase\r\n6300.0 \"--sync--\" Ability { id: \"7123\", source: \"Nald'thal\" } window 300,10\r\n6311.0 \"Equal Weight\" Ability { id: \"7124\", source: \"Soul Vessel\" }\r\n6311.2 \"--sync--\" Ability { id: \"7386\", source: \"Nald'thal\" }\r\n6322.6 \"Twingaze\" Ability { id: \"712A\", source: \"Soul Vessel\" }\r\n6339.5 \"Magmatic Spell\" Ability { id: \"712D\", source: \"Soul Vessel\" }\r\n6346.0 \"Twingaze\" Ability { id: \"712A\", source: \"Soul Vessel\" }\r\n# ???\r\n\r\n# Loop block intro\r\n7000.0 \"--sync--\" StartsUsing { id: \"7125\", source: \"Nald'thal\" } window 1000,0\r\n7012.5 \"Balance\" Ability { id: \"7125\", source: \"Nald'thal\" }\r\n7014.6 \"Tipped Scales\" Ability { id: \"7388\", source: \"Nald'thal\" }\r\n7058.7 \"--targetable--\"\r\n\r\n7070.2 \"As Above, So Below\" Ability { id: [\"70E8\", \"70E9\"], source: \"Nald'thal\" }\r\n7084.4 \"Once Above, Ever Below\" Ability { id: [\"73BF\", \"73C0\", \"741C\", \"741D\"], source: \"Nald'thal\" }\r\n\r\n7091.6 \"--sync--\" Ability { id: \"73CD\", source: \"Nald'thal\" }\r\n7095.5 \"Stygian Tenet?\" Ability { id: \"711C\", source: \"Nald'thal\" }\r\n7096.6 \"Heavens' Trial?\" Ability { id: \"711E\", source: \"Nald'thal\" }\r\n7097.5 \"Smelting?\" Ability { id: \"7120\", source: \"Nald\" }\r\n\r\n7105.7 \"As Above, So Below\" Ability { id: [\"70E8\", \"70E9\"], source: \"Nald'thal\" }\r\n7119.9 \"Hearth Above, Flight Below\" Ability { id: [\"741B\", \"73CA\", \"73CB\", \"73CC\"], source: \"Nald'thal\" }\r\n7121.1 \"Far-flung Fire?\" Ability { id: \"73AD\", source: \"Nald\" }\r\n7125.7 \"Deepest Pit?\" Ability { id: \"73C7\", source: \"Thal\" } duration 4\r\n7131.1 \"Golden Tenet/Hells' Trial\" Ability { id: [\"7121\", \"711A\"], source: \"Nald'thal\" }\r\n7147.6 \"Hell of Fire\" Ability { id: \"72B[79]\", source: \"Nald'thal\" }\r\n\r\n# Branch to Wayward Soul / Fired Up.\r\n#\r\n# Have seen these patterns in logs:\r\n# * Fired Up -> Wayward Soul -> Fired Up -> Wayward Soul -> ?\r\n#   https://www.fflogs.com/reports/6Mabf9r4jwt37KYP#fight=last\r\n# * Wayward Soul -> Fired Up -> Wayward Soul -> Fired Up -> ?\r\n#   https://www.fflogs.com/reports/cxqYG1L3mFMrpZdQ#fight=last\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> initial Wayward Soul block\r\n7156.0 \"--sync--\" Ability { id: \"710D\", source: \"Nald'thal\" } window 100,100 jump 7998.3\r\n7161.1 \"Wayward Soul?\" #Ability { id: \"710E\", source: \"Nald'thal\" }\r\n\r\n# -> main loop block, starting with Fired Up\r\n7159.5 \"--sync--\" StartsUsing { id: \"7112\", source: \"Nald'thal\" } window 100,100 jump 8159.5\r\n7163.5 \"Fired Up I?\" #Ability { id: \"7112\", source: \"Nald'thal\" }\r\n7169.6 \"Fired Up II?\" #Ability { id: \"7389\", source: \"Nald'thal\" }\r\n7175.7 \"Fired Up III?\" #Ability { id: \"7419\", source: \"Nald'thal\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Initial Wayward Soul block, fall into Main loop block\r\n# This has slightly different timings here (+5/-5 on some abilities) than the loop.\r\n7998.3 \"--sync--\" Ability { id: \"710D\", source: \"Nald'thal\" }\r\n8003.4 \"Wayward Soul\" Ability { id: \"710E\", source: \"Nald'thal\" }\r\n8023.6 \"--sync--\" Ability { id: \"710F\", source: \"Nald'thal\" }\r\n8034.3 \"Hell of Fire\" Ability { id: \"72B7\", source: \"Nald'thal\" }\r\n8044.5 \"Stygian Tenet\" Ability { id: \"711C\", source: \"Nald'thal\" }\r\n8059.6 \"Hells' Trial\" Ability { id: \"7121\", source: \"Nald'thal\" }\r\n\r\n\r\n# Main loop, repeating the loop block intro, but with no more branching\r\n8070.2 \"As Above, So Below\" Ability { id: [\"70E8\", \"70E9\"], source: \"Nald'thal\" }\r\n8084.4 \"Once Above, Ever Below\" Ability { id: [\"73BF\", \"73C0\", \"741C\", \"741D\"], source: \"Nald'thal\" }\r\n\r\n8091.6 \"--sync--\" Ability { id: \"73CD\", source: \"Nald'thal\" }\r\n8095.5 \"Stygian Tenet?\" Ability { id: \"711C\", source: \"Nald'thal\" }\r\n8096.6 \"Heavens' Trial?\" Ability { id: \"711E\", source: \"Nald'thal\" }\r\n8097.5 \"Smelting?\" Ability { id: \"7120\", source: \"Nald\" }\r\n\r\n8105.7 \"As Above, So Below\" Ability { id: [\"70E8\", \"70E9\"], source: \"Nald'thal\" }\r\n8119.9 \"Hearth Above, Flight Below\" Ability { id: [\"741B\", \"73CA\", \"73CB\", \"73CC\"], source: \"Nald'thal\" }\r\n8121.1 \"Far-flung Fire?\" Ability { id: \"73AD\", source: \"Nald\" }\r\n8125.7 \"Deepest Pit?\" Ability { id: \"73C7\", source: \"Thal\" } duration 4\r\n8131.1 \"Golden Tenet/Hells' Trial\" Ability { id: [\"7121\", \"711A\"], source: \"Nald'thal\" }\r\n8147.6 \"Hell of Fire\" Ability { id: \"72B[79]\", source: \"Nald'thal\" }\r\n\r\n8159.5 \"--sync--\" StartsUsing { id: \"7112\", source: \"Nald'thal\" } window 20,20\r\n8163.5 \"Fired Up I\" Ability { id: \"7112\", source: \"Nald'thal\" }\r\n8169.6 \"Fired Up II\" Ability { id: \"7389\", source: \"Nald'thal\" }\r\n8175.7 \"Fired Up III\" Ability { id: \"7419\", source: \"Nald'thal\" }\r\n8185.8 \"Fortune's Flux\" Ability { id: \"7113\", source: \"Nald'thal\" }\r\n8187.7 \"Seventh Passage 1\" Ability { id: \"7119\", source: \"Nald'thal\" }\r\n8190.4 \"Seventh Passage 2\" #Ability { id: \"73AF\", source: \"Thal\" }\r\n8191.7 \"Seventh Passage 3\" #Ability { id: [\"73AF\", \"7118\"], source: \"Thal\" }\r\n\r\n8197.1 \"--sync--\" Ability { id: \"73CD\", source: \"Nald'thal\" }\r\n8202.1 \"Heavens' Trial\" Ability { id: \"711E\", source: \"Nald'thal\" }\r\n8203.0 \"Smelting\" Ability { id: \"7120\", source: \"Nald'thal\" }\r\n8212.3 \"Golden Tenet\" Ability { id: \"711A\", source: \"Nald'thal\" }\r\n8227.5 \"Hells' Trial\" Ability { id: \"7121\", source: \"Nald'thal\" }\r\n\r\n8238.5 \"As Above, So Below\" Ability { id: [\"70E8\", \"70E9\"], source: \"Nald'thal\" }\r\n8252.7 \"Once Above, Ever Below\" Ability { id: \"73C0\", source: \"Nald'thal\" }\r\n8263.8 \"Stygian Tenet?\" Ability { id: \"711C\", source: \"Nald'thal\" }\r\n8264.9 \"Heavens' Trial?\" Ability { id: \"711E\", source: \"Nald'thal\" }\r\n8265.8 \"Smelting?\" Ability { id: \"7120\", source: \"Nald\" }\r\n\r\n8274.0 \"As Above, So Below\" Ability { id: [\"70E8\", \"70E9\"], source: \"Nald'thal\" }\r\n8288.2 \"Hearth Above, Flight Below\" Ability { id: [\"741B\", \"73CA\", \"73CB\", \"73CC\"], source: \"Nald'thal\" }\r\n8289.4 \"Far-flung Fire?\" Ability { id: \"73AD\", source: \"Nald\" }\r\n8294.0 \"Deepest Pit?\" Ability { id: \"73C7\", source: \"Thal\" } duration 4\r\n8299.4 \"Golden Tenet/Hells' Trial\" Ability { id: [\"7121\", \"711A\"], source: \"Nald'thal\" }\r\n8315.9 \"Hell of Fire\" Ability { id: \"72B[79]\", source: \"Nald'thal\" }\r\n\r\n8324.1 \"--sync--\" Ability { id: \"710D\", source: \"Nald'thal\" } window 20,20\r\n8329.2 \"Wayward Soul\" Ability { id: \"710E\", source: \"Nald'thal\" }\r\n8344.4 \"--sync--\" Ability { id: \"710F\", source: \"Nald'thal\" }\r\n\r\n# Possibly ~5s delay here as well?\r\n8347.1 \"--sync--\" StartsUsing { id: \"72B[79]\", source: \"Nald'thal\" } window 10,10\r\n8355.1 \"Hell of Fire\" Ability { id: \"72B[79]\", source: \"Nald'thal\" }\r\n8375.3 \"Stygian Tenet\" Ability { id: \"711C\", source: \"Nald'thal\" }\r\n8390.5 \"Hells' Trial\" Ability { id: \"7121\", source: \"Nald'thal\" }\r\n\r\n# Loop back to beginning of loop block\r\n8401.1 \"As Above, So Below\" Ability { id: [\"70E8\", \"70E9\"], source: \"Nald'thal\" } window 50,50 jump 8070.2\r\n8415.3 \"Once Above, Ever Below\" #Ability { id: [\"73BF\", \"73C0\", \"741C\", \"741D\"], source: \"Nald'thal\" }\r\n\r\n8422.5 \"--sync--\" #Ability { id: \"73CD\", source: \"Nald'thal\" }\r\n8426.4 \"Stygian Tenet?\" #Ability { id: \"711C\", source: \"Nald'thal\" }\r\n8427.5 \"Heavens' Trial?\" #Ability { id: \"711E\", source: \"Nald'thal\" }\r\n8428.4 \"Smelting?\" #Ability { id: \"7120\", source: \"Nald\" }\r\n\r\n8436.6 \"As Above, So Below\" #Ability { id: \"70E9\", source: \"Nald'thal\" }\r\n8450.8 \"Hearth Above, Flight Below\" #Ability { id: [\"741B\", \"73CA\", \"73CB\", \"73CC\"], source: \"Nald'thal\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/alliance/euphrosyne.ts






// TODO: Nophica Blueblossoms/Giltblossoms; they get 018E/018F/0190/0191/0192/0193 markers, but how to know colors?
//       No map effects, and getCombatants has the combatants, but OverlayPlugin info all the same.
// TODO: Halone Cheimon counter-clock is 7D6B, is clock 7D6A??
// TODO: Halone Lochos positions
// TODO: Menphina could use map effects for Love's Light + Full Bright 4x moon locations

// TODO: Menphina Midnight Frost + Waxing Claw + Playful Orbit
// 7BCB Midnight Frost = front cleave (7BCD damage) [first phase only]
// 7BCC Midnight Frost = back cleave (7BCE damage) [first phase only]
// 7BCF Midnight Frost = ??? (7BD1 damage)
// 7BD0 Midnight Frost = back cleave (7BD2 damage) [dog attached, during 4x Love's Light, facing west]
// 7BD7 Midnight Frost = front cleave (7BDD damage) [dog attached, facing southeast or north?]
// 7BD8 Midnight Frost = front cleave (7BDD damage) [dog attached, facing south or northwest?]
// 7BD9 Midnight Frost = back cleave (7BDE damage) [dog attached, facing south]
// 7BDA Midnight Frost = back cleave (7BDE damage) [dog attached, facing southeast or north?]
// 7BE4 Midnight Frost = front cleave (7BDA damage) [dog uunattached, facing north]
// 7BE5 Midnight Frost = ??? (7BDA damage)
// 7BE6 Midnight Frost = back cleave (7BDB damage) [dog unattached, facing north]
// 7BE7 Midnight Frost = back cleave (7BDB damage) [dog unattached, facing north]
// 7F0A Midnight Frost = front cleave (7BDA damage) [dog unattached, facing north]
// 7F0B Midnight Frost = front cleave (7BDA damage) [dog unattached, facing south]
// 7F0C Midnight Frost = back cleave (7BDB damage) [dog unattached, facing south]
// 7F0D Midnight Frost = back cleave (7BDB damage) [dog unattached, facing south]
// 7BE0 Waxing Claw = right claw [both attached and unattached]
// 7BE1 Waxing Claw = left claw [both attached and unattached]
// 7BE2 Playful Orbit = jump NE
// 7BE3 Playful Orbit = jump NW / jump SE
const tetraMap = {
  '7D46': 'out',
  '7D47': 'in',
  '7D48': 'left',
  '7D49': 'right'
};
const euphrosyne_triggerSet = {
  id: 'Euphrosyne',
  zoneId: zone_id/* default.Euphrosyne */.Z.Euphrosyne,
  timelineFile: 'euphrosyne.txt',
  initData: () => {
    return {
      combatantData: [],
      nophicaHeavensEarthTargets: [],
      nymeiaHydrostasis: [],
      haloneTetrapagos: [],
      haloneSpearsThreeTargets: [],
      haloneIceDartTargets: [],
      menphinaLunarKissTargets: []
    };
  },
  triggers: [{
    id: 'Euphrosyne Nophica Abundance',
    type: 'StartsUsing',
    netRegex: {
      id: '7C24',
      source: 'Nophica',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Euphrosyne Nophica The Giving Land Spring Flowers',
    type: 'StartsUsing',
    netRegex: {
      id: '801A',
      source: 'Nophica',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.nophicaMarch === undefined) return output.out();
      return {
        'front': output.outWithForwards(),
        'back': output.outWithBackwards(),
        'left': output.outWithLeft(),
        'right': output.outWithRight()
      }[data.nophicaMarch];
    },
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      outWithForwards: {
        en: 'Forwards March Out',
        de: 'Geisterlenkung Vorwärts Raus',
        fr: 'Marche forcée avant vers l\'extérieur',
        ja: '強制移動 : 前 => 外へ',
        cn: '向前强制移动到钢铁外',
        ko: '강제이동: 앞, 밖으로'
      },
      outWithBackwards: {
        en: 'Backwards March Out',
        de: 'Geisterlenkung Rückwärts Raus',
        fr: 'Marche forcée arrière vers l\'extérieur',
        ja: '強制移動 : 後ろ => 外へ',
        cn: '向后强制移动到钢铁外',
        ko: '강제이동: 뒤, 밖으로'
      },
      outWithLeft: {
        en: 'Left March Out',
        de: 'Geisterlenkung Links Raus',
        fr: 'Marche forcée gauche vers l\'extérieur',
        ja: '強制移動 : 左 => 外へ',
        cn: '向左强制移动到钢铁外',
        ko: '강제이동: 왼쪽, 밖으로'
      },
      outWithRight: {
        en: 'Right March Out',
        de: 'Geisterlenkung Rechts Raus',
        fr: 'Marche forcée droite vers l\'extérieur',
        ja: '強制移動 : 右 => 外へ',
        cn: '向右强制移动到钢铁外',
        ko: '강제이동: 오른쪽, 밖으로'
      }
    }
  }, {
    id: 'Euphrosyne Nophica The Giving Land Summer Shade',
    type: 'StartsUsing',
    netRegex: {
      id: '8018',
      source: 'Nophica',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.nophicaMarch === undefined) return output.in();
      return {
        'front': output.inWithForwards(),
        'back': output.inWithBackwards(),
        'left': output.inWithLeft(),
        'right': output.inWithRight()
      }[data.nophicaMarch];
    },
    outputStrings: {
      in: outputs/* default.in */.Z["in"],
      inWithForwards: {
        en: 'Forwards March In',
        de: 'Geisterlenkung Vorwärts Rein',
        fr: 'Marche forcée avant vers l\'intérieur',
        ja: '強制移動 : 前 => 中へ',
        cn: '向前强制移动到月环内',
        ko: '강제이동: 앞, 안으로'
      },
      inWithBackwards: {
        en: 'Backwards March In',
        de: 'Geisterlenkung Rückwärts Rein',
        fr: 'Marche forcée arrière vers l\'intérieur',
        ja: '強制移動 : 後ろ => 中へ',
        cn: '向后强制移动到月环内',
        ko: '강제이동: 뒤, 안으로'
      },
      inWithLeft: {
        en: 'Left March In',
        de: 'Geisterlenkung Links Rein',
        fr: 'Marche forcée gauche vers l\'intérieur',
        ja: '強制移動 : 左 => 中へ',
        cn: '向左强制移动到月环内',
        ko: '강제이동: 왼쪽, 안으로'
      },
      inWithRight: {
        en: 'Right March In',
        de: 'Geisterlenkung Rechts Rein',
        fr: 'Marche forcée droite vers l\'intérieur',
        ja: '強制移動 : 右 => 中へ',
        cn: '向右强制移动到月环内',
        ko: '강제이동: 오른쪽, 안으로'
      }
    }
  }, {
    id: 'Euphrosyne Nophica Matron\'s Harvest',
    type: 'StartsUsing',
    netRegex: {
      id: '7C1[DE]',
      source: 'Nophica',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Euphrosyne Nophica Floral Haze Debuffs',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'DD[2-5]'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // Initial Floral Haze is 16s.  The next Floral Haze is 18 or 35s.
    // Add a delay so that this only applies when it is "close" so that
    // it will only add to the Giving Land callout it needs to.
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 10,
    run: (data, matches) => {
      const faceMap = {
        DD2: 'front',
        DD3: 'back',
        DD4: 'left',
        DD5: 'right'
      };
      data.nophicaMarch = faceMap[matches.effectId];
    }
  }, {
    id: 'Euphrosyne Nophica Floral Haze Cleanup',
    type: 'LosesEffect',
    netRegex: {
      effectId: 'DD[2-5]',
      capture: false
    },
    suppressSeconds: 5,
    run: data => delete data.nophicaMarch
  }, {
    id: 'Euphrosyne Nophica Landwaker',
    type: 'StartsUsing',
    netRegex: {
      id: '7C19',
      source: 'Nophica',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Euphrosyne Nophica Furrow',
    type: 'StartsUsing',
    netRegex: {
      id: '7C16',
      source: 'Nophica'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Euphrosyne Nophica Heavens\' Earth',
    type: 'StartsUsing',
    netRegex: {
      id: '7C23',
      source: 'Nophica'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.tankBusterOnYou();
    },
    run: (data, matches) => data.nophicaHeavensEarthTargets.push(matches.target),
    outputStrings: {
      tankBusterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou
    }
  }, {
    id: 'Euphrosyne Nophica Heavens\' Earth Not You',
    type: 'StartsUsing',
    netRegex: {
      id: '7C23',
      source: 'Nophica',
      capture: false
    },
    delaySeconds: 0.3,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (data.nophicaHeavensEarthTargets.includes(data.me)) return;
      return output.tankBusters();
    },
    run: data => data.nophicaHeavensEarthTargets = [],
    outputStrings: {
      tankBusters: outputs/* default.tankBusters */.Z.tankBusters
    }
  }, {
    id: 'Euphrosyne Ktenos Roaring Rumble',
    type: 'StartsUsing',
    netRegex: {
      id: '7D3B',
      source: 'Euphrosynos Ktenos',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Euphrosyne Ktenos Sweeping Gouge',
    type: 'StartsUsing',
    netRegex: {
      id: '7D39',
      source: 'Euphrosynos Ktenos'
    },
    // This is trash and so three tankbuster callouts might be noisy here?
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Euphrosyne Behemoth Localized Maelstrom',
    type: 'StartsUsing',
    netRegex: {
      id: '7D37',
      source: 'Euphrosynos Behemoth'
    },
    response: responses/* Responses.sharedTankBuster */.n3.sharedTankBuster()
  }, {
    id: 'Euphrosyne Behemoth Trounce',
    type: 'StartsUsing',
    netRegex: {
      id: '7D38',
      source: 'Euphrosynos Behemoth',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Euphrosyne Nymeia Spinner\'s Wheel Initial',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['D39', 'D3A', 'D3B', 'D3C']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // Reapplied with Time and Tide.
    suppressSeconds: 20,
    sound: '',
    infoText: (_data, matches, output) => {
      return {
        // Arcane Attraction
        'D39': output.lookAway(),
        // Attraction Reversed
        'D3A': output.lookTowards(),
        // Arcane Fever
        'D3B': output.pyretic(),
        // Fever Reversed
        'D3C': output.freeze()
      }[matches.effectId];
    },
    outputStrings: {
      lookAway: {
        en: '(look away soon)',
        de: '(bald wegschauen)',
        fr: '(regardez ailleurs bientôt)',
        ja: '(見ない)',
        cn: '(稍后背对)',
        ko: '(곧 뒤돌기)'
      },
      lookTowards: {
        en: '(look towards soon)',
        de: '(bald hinschauen)',
        fr: '(regardez devant bientôt)',
        ja: '(ボスを見て)',
        cn: '(稍后看向)',
        ko: '(곧 쳐다보기)'
      },
      pyretic: {
        en: '(pyretic soon)',
        de: '(bald Pyretisch)',
        fr: '(feu bientôt)',
        ja: '(止まれ)',
        cn: '(稍后热病)',
        ko: '(곧 멈추기)'
      },
      freeze: {
        en: '(freeze soon)',
        de: '(bald Kühlung)',
        fr: '(gel bientôt)',
        ja: '(動く)',
        cn: '(稍后冻结)',
        ko: '(곧 움직이기)'
      }
    }
  }, {
    id: 'Euphrosyne Nymeia Spinner\'s Wheel',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['D39', 'D3A', 'D3B', 'D3C']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: (data, matches, output) => {
      // This is somewhat unusual, but to avoid duplicating output strings,
      // we are going to store the output here, but it may get called via
      //
      data.nymeiaSpinnerOutput = {
        // Arcane Attraction
        'D39': output.lookAway(),
        // Attraction Reversed
        'D3A': output.lookTowards(),
        // Arcane Fever
        'D3B': output.stopEverything(),
        // Fever Reversed
        'D3C': output.keepMoving()
      }[matches.effectId];
    },
    // 10 seconds first time, 20 seconds other times, possibly sped up (for ~13.4 s)
    // The Spinner Wheel Tether trigger will take care of speed ups.
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 2,
    // Reapplied with Time and Tide.
    suppressSeconds: 5,
    // This will be cleared if called earlier.
    alertText: data => data.nymeiaSpinnerOutput,
    run: data => delete data.nymeiaSpinnerOutput,
    outputStrings: {
      lookAway: {
        en: 'Look Away from Nymeia',
        de: 'Schau weg von Nymeia',
        fr: 'Ne regardez pas Nymeia',
        ja: 'ニメーヤさま見ない',
        cn: '背对妮美雅',
        ko: '니메이아에게서 뒤돌기'
      },
      lookTowards: {
        en: 'Look Towards Nymeia',
        de: 'Schau zu Nymeia',
        fr: 'Regardez Nymeia',
        ja: 'ニメーヤさまを見る',
        cn: '看向妮美雅',
        ko: '니메이아 쳐다보기'
      },
      stopEverything: outputs/* default.stopEverything */.Z.stopEverything,
      keepMoving: outputs/* default.moveAround */.Z.moveAround
    }
  }, {
    id: 'Euphrosyne Nymeia Spinner\'s Wheel Tether',
    type: 'Tether',
    netRegex: {
      id: '00DF',
      target: 'Althyk'
    },
    condition: (data, matches) => data.me === matches.source,
    delaySeconds: 11.5,
    alertText: data => data.nymeiaSpinnerOutput,
    run: data => delete data.nymeiaSpinnerOutput,
    // For simplicity, this trigger uses the stored output from the Spinner's Wheel trigger.
    // If it calls it early, it will clear it so that the other trigger doesn't use it.
    outputStrings: {}
  }, {
    id: 'Euphrosyne Althyk Axioma',
    type: 'StartsUsing',
    netRegex: {
      id: '7A47',
      source: 'Althyk',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Euphrosyne Nymeia Hydroptosis',
    type: 'StartsUsing',
    // Technically there's a 7A45 cast on everybody, and 7A44 is self-casted.
    netRegex: {
      id: '7A44',
      source: 'Nymeia',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread (avoid purple)',
        de: 'Verteilen (vermeide den lilanen Riss)',
        fr: 'Écartez-vous (évitez les fissures violettes)',
        ja: '散会 (紫回避)',
        cn: '分散 (远离紫色区域)',
        ko: '산개 (보라색 바닥 피하기)'
      }
    }
  }, {
    id: 'Euphrosyne Althyk Inexorable Pull',
    type: 'StartsUsing',
    netRegex: {
      id: '7A42',
      source: 'Althyk',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in purple fissure',
        de: 'Im lilanen Riss stehen',
        fr: 'Restez sur une fissure violette',
        ja: '紫踏み',
        cn: '站进紫色区域',
        ko: '보라색 바닥 위로'
      }
    }
  }, {
    id: 'Euphrosyne Althyk Petrai',
    type: 'StartsUsing',
    // With 7A49 damage
    netRegex: {
      id: '7A48',
      source: 'Althyk'
    },
    response: responses/* Responses.sharedTankBuster */.n3.sharedTankBuster()
  }, {
    id: 'Euphrosyne Nymeia Hydrostasis Collect',
    type: 'StartsUsing',
    netRegex: {
      id: ['7A3B', '7A3C', '7A3D', '7A3E'],
      source: 'Nymeia'
    },
    run: (data, matches) => data.nymeiaHydrostasis.push(matches)
  }, {
    id: 'Euphrosyne Nymeia Hydrostasis',
    type: 'StartsUsing',
    // TODO: this only appears to have valid positions the first time around (sometimes).
    // TODO: try using getCombatantants.
    netRegex: {
      id: ['7A3B', '7A3C', '7A3D', '7A3E'],
      source: 'Nymeia',
      capture: false
    },
    // First time around is BCD all simultaneous, with 16,19,22s cast times.
    // Other times are BC instantly and then E ~11s later with a 2s cast time.
    delaySeconds: 1.5,
    durationSeconds: 18,
    suppressSeconds: 20,
    promise: async data => {
      data.combatantData = [];
      const ids = data.nymeiaHydrostasis.map(line => parseInt(line.sourceId, 16));
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: ids
      })).combatants;
    },
    infoText: (data, _matches, output) => {
      // Sort combatants by cast id.
      // Note: it's also possible that reverse actor id sort would work.
      const decIdToCast = {};
      for (const line of data.nymeiaHydrostasis) decIdToCast[parseInt(line.sourceId, 16)] = line.id;
      const combatants = data.combatantData.sort((a, b) => {
        const aCast = decIdToCast[a.ID ?? 0] ?? '';
        const bCast = decIdToCast[b.ID ?? 0] ?? '';
        return aCast.localeCompare(bCast);
      });
      const dirs = combatants.map(c => {
        const centerX = 50;
        const centerY = -741;
        if (c.PosY < centerY) return 'N';
        return c.PosX < centerX ? 'SW' : 'SE';
      });
      const [first, second, third] = dirs;
      if (first === undefined || second === undefined) return;
      if (third === undefined) {
        const dirSet = new Set(['N', 'SW', 'SE']);
        dirSet.delete(first);
        dirSet.delete(second);
        if (dirSet.size !== 1) return;
        for (const dir of dirSet.keys()) dirs.unshift(dir);
      }
      const [dir1, dir2, dir3] = dirs.map(x => {
        return {
          N: output.dirN(),
          SW: output.dirSW(),
          SE: output.dirSE()
        }[x] ?? output.unknown();
      });

      // Safety, in case something went awry.
      if (dir1 === dir2 || dir2 === dir3) return;
      return output.knockback({
        dir1: dir1,
        dir2: dir2,
        dir3: dir3
      });
    },
    run: data => data.nymeiaHydrostasis = [],
    outputStrings: {
      knockback: {
        en: 'Knockback ${dir1} => ${dir2} => ${dir3}',
        de: 'Rückstoß ${dir1} => ${dir2} => ${dir3}',
        fr: 'Poussée ${dir1} => ${dir2} => ${dir3}',
        ja: 'ノックバック ${dir1} => ${dir2} => ${dir3}',
        cn: '击退 ${dir1} => ${dir2} => ${dir3}',
        ko: '넉백 ${dir1} => ${dir2} => ${dir3}'
      },
      dirSW: outputs/* default.dirSW */.Z.dirSW,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirN: outputs/* default.dirN */.Z.dirN,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'Euphrosyne Colossus Rapid Sever',
    type: 'StartsUsing',
    netRegex: {
      id: '7D3C',
      source: 'Euphrosynos Ktenos'
    },
    // This is trash and so three tankbuster callouts might be noisy here?
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // These three also tend to cast at the same time, so could be on one person.
    suppressSeconds: 5,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Euphrosyne Halone Rain of Spears',
    type: 'StartsUsing',
    netRegex: {
      id: '7D79',
      source: 'Halone',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Euphrosyne Halone Tetrapagos Cleanup',
    type: 'StartsUsing',
    // This should be unnecessary, but for safety reset the data each round.
    netRegex: {
      id: ['7D45', '7D59'],
      source: 'Halone',
      capture: false
    },
    run: data => data.haloneTetrapagos = []
  }, {
    id: 'Euphrosyne Halone Tetrapagos Summary',
    type: 'StartsUsing',
    netRegex: {
      id: ['7D46', '7D47', '7D48', '7D49'],
      source: 'Halone'
    },
    preRun: (data, matches) => {
      const tetra = tetraMap[matches.id];
      data.haloneTetrapagos.push(tetra ?? 'unknown');
    },
    durationSeconds: 7.5,
    sound: '',
    alertText: (data, _matches, output) => {
      if (data.haloneTetrapagos.length !== 4) return;
      const [dir1, dir2, dir3, dir4] = data.haloneTetrapagos.map(x => output[x ?? 'unknown']());
      return output.text({
        dir1: dir1,
        dir2: dir2,
        dir3: dir3,
        dir4: dir4
      });
    },
    outputStrings: {
      text: {
        en: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        de: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        fr: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        ja: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        cn: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        ko: '${dir1} > ${dir2} > ${dir3} > ${dir4}'
      },
      out: outputs/* default.out */.Z.out,
      in: outputs/* default.in */.Z["in"],
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'Euphrosyne Halone Tetrapagos Initial',
    type: 'StartsUsing',
    netRegex: {
      id: ['7D46', '7D47', '7D48', '7D49'],
      source: 'Halone'
    },
    durationSeconds: 7,
    suppressSeconds: 20,
    infoText: (_data, matches, output) => output[tetraMap[matches.id] ?? 'unknown'](),
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      in: outputs/* default.in */.Z["in"],
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'Euphrosyne Halone Tetrapagos Followup',
    type: 'Ability',
    // Self-targeted abilities:
    // 7D4A = donut
    // 7D4B = circle
    // 7D4C = right cleave
    // 7D4D = left cleave
    netRegex: {
      id: ['7D4A', '7D4B', '7D4C', '7D4D'],
      source: 'Halone',
      capture: false
    },
    durationSeconds: 1.5,
    infoText: (data, _matches, output) => {
      if (data.haloneTetrapagos.length === 4) data.haloneTetrapagos.shift();
      const dir = data.haloneTetrapagos.shift();
      if (dir === undefined) return;
      return output[dir]();
    },
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      in: outputs/* default.in */.Z["in"],
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'Euphrosyne Halone Doom Spear',
    type: 'StartsUsing',
    netRegex: {
      id: '80AD',
      source: 'Halone',
      capture: false
    },
    infoText: (_data, _matches, output) => output.getTowers(),
    outputStrings: {
      getTowers: {
        en: 'Get Towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔踏み',
        cn: '踩塔',
        ko: '기둥 들어가기'
      }
    }
  }, {
    id: 'Euphrosyne Halone Spears Three',
    type: 'StartsUsing',
    netRegex: {
      id: '7D78',
      source: 'Halone'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.tankBusterOnYou();
    },
    run: (data, matches) => data.haloneSpearsThreeTargets.push(matches.target),
    outputStrings: {
      tankBusterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou
    }
  }, {
    id: 'Euphrosyne Halone Spears Three Not You',
    type: 'StartsUsing',
    netRegex: {
      id: '7D78',
      source: 'Halone',
      capture: false
    },
    delaySeconds: 0.3,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (data.haloneSpearsThreeTargets.includes(data.me)) return;
      return output.tankBusters();
    },
    run: data => data.haloneSpearsThreeTargets = [],
    outputStrings: {
      tankBusters: outputs/* default.tankBusters */.Z.tankBusters
    }
  }, {
    id: 'Euphrosyne Halone Thousandfold Thruust',
    type: 'HeadMarker',
    netRegex: {
      id: ['0182', '0183', '0184', '0185'],
      target: 'Halone'
    },
    alertText: (_data, matches, output) => {
      return {
        '0182': output.back(),
        '0183': output.front(),
        '0184': output.left(),
        '0185': output.right()
      }[matches.id];
    },
    outputStrings: {
      front: outputs/* default.front */.Z.front,
      back: outputs/* default.back */.Z.back,
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'Euphrosyne Halone Wrath of Halone',
    type: 'StartsUsing',
    netRegex: {
      id: '7D63',
      source: 'Halone',
      capture: false
    },
    alertText: (_data, _matches, output) => output.out(),
    outputStrings: {
      out: {
        en: 'Get Out (avoid ring)',
        de: 'Geh raus (vermeide den Ring)',
        fr: 'Sortez (évitez l\'anneau)',
        ja: '外へ (ドーナツ回避)',
        cn: '远离 (躲避圆环)',
        ko: '밖으로 (고리 장판 피하기)'
      }
    }
  }, {
    id: 'Euphrosyne Halone Ice Dart',
    type: 'StartsUsing',
    netRegex: {
      id: '7D66',
      source: 'Halone'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.spread();
    },
    run: (data, matches) => data.haloneIceDartTargets.push(matches.target),
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread
    }
  }, {
    id: 'Euphrosyne Halone Ice Dart Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '7D66',
      source: 'Halone',
      capture: false
    },
    delaySeconds: 10,
    suppressSeconds: 5,
    run: data => data.haloneIceDartTargets = []
  }, {
    id: 'Euphrosyne Halone Ice Rondel',
    type: 'StartsUsing',
    netRegex: {
      id: '7D67',
      source: 'Halone'
    },
    condition: data => !data.haloneIceDartTargets.includes(data.me),
    delaySeconds: 0.5,
    alertText: (data, matches, output) => {
      if (data.haloneIceDartTargets.includes(data.me)) return;
      return output.text({
        player: matches.target
      });
    },
    outputStrings: {
      text: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'Euphrosyne Menphina Blue Moon',
    type: 'StartsUsing',
    netRegex: {
      id: ['7BFA', '7BFB'],
      source: 'Menphina',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Euphrosyne Menphina Love\'s Light Single Moon',
    type: 'Ability',
    netRegex: {
      id: ['7BB8', '7BC2'],
      source: 'Menphina',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sides of Moon',
        de: 'Geh seitlich des Mondes',
        fr: 'Côtés de la lune',
        ja: '月の横',
        cn: '去月亮两侧',
        ko: '달 옆쪽으로'
      }
    }
  }, {
    id: 'Euphrosyne Menphina Love\'s Light Quadruple Moon',
    type: 'Ability',
    netRegex: {
      id: ['7BB9', '7BC3'],
      source: 'Menphina',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to dark moon',
        de: 'Geh zum dunklen Mond',
        fr: 'Allez sur une lune noire',
        ja: '暗い月へ',
        cn: '去暗月亮',
        ko: '어두운 달 쪽으로'
      }
    }
  }, {
    id: 'Euphrosyne Menphina Midnight Frost Back No Claw',
    type: 'StartsUsing',
    // 7BCC Midnight Frost = back cleave (7BCE damage) [no dog, first phase only]
    // 7BD0 Midnight Frost = back cleave (7BD2 damage) [dog attached, during 4x Love's Light]
    netRegex: {
      id: ['7BCC', '7BD0'],
      source: 'Menphina',
      capture: false
    },
    response: responses/* Responses.goFront */.n3.goFront()
  }, {
    id: 'Euphrosyne Menphina Midnight Frost Front No Claw',
    type: 'StartsUsing',
    // 7BCB Midnight Frost = front cleave (7BCD damage) [no dog, first phase only]
    // 7BCF Midnight Frost = front cleave (7BD1 damage) [dog attached, during 4x Love's Light]
    netRegex: {
      id: ['7BCB', '7BCF'],
      source: 'Menphina',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Euphrosyne Menphina Waxing Claw',
    type: 'StartsUsing',
    netRegex: {
      id: ['7BE0', '7BE1'],
      source: 'Menphina'
    },
    run: (data, matches) => {
      // This is true regardless of whether the dog is attached or not.
      if (matches.id === '7BE0') data.menphinaWaxingClaw = 'right';else if (matches.id === '7BE1') data.menphinaWaxingClaw = 'left';
      data.menphinaDogId = matches.sourceId;
    }
  }, {
    id: 'Euphrosyne Menphina Waxing Claw Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: ['7BE0', '7BE1'],
      source: 'Menphina',
      capture: false
    },
    delaySeconds: 10,
    run: data => delete data.menphinaWaxingClaw
  }, {
    id: 'Euphrosyne Menphina Midnight Frost Attached',
    type: 'StartsUsing',
    // 7BD7 Midnight Frost = front cleave (7BDD damage) [dog attached]
    // 7BD8 Midnight Frost = front cleave (7BDD damage) [dog attached]
    // 7BD9 Midnight Frost = back cleave (7BDE damage) [dog attached]
    // 7BDA Midnight Frost = back cleave (7BDE damage) [dog attached]
    // This ability seems possibly player targeted for initial facing, so use relative dirs.
    netRegex: {
      id: ['7BD7', '7BD8', '7BD9', '7BDA'],
      source: 'Menphina'
    },
    // These two abilities come out at the same time.  It seems that Waxing Claw always comes
    // after, but trying not to make assumptions here.
    delaySeconds: 0.3,
    alertText: (data, matches, output) => {
      // If claw is somehow undefined, don't print anything.
      const claw = data.menphinaWaxingClaw;
      const isFrontCleave = matches.id === '7BD7' || matches.id === '7BD8';
      if (isFrontCleave && claw === 'right') return output.backLeft();
      if (isFrontCleave && claw === 'left') return output.backRight();
      if (!isFrontCleave && claw === 'right') return output.frontLeft();
      if (!isFrontCleave && claw === 'left') return output.frontRight();
    },
    outputStrings: {
      frontLeft: {
        en: 'Front Left',
        de: 'Vorne Links',
        fr: 'Avant Gauche',
        ja: '前左',
        cn: '左前',
        ko: '앞 왼쪽'
      },
      frontRight: {
        en: 'Front Right',
        de: 'Vorne Rechts',
        fr: 'Avant Droit',
        ja: '前右',
        cn: '右前',
        ko: '앞 오른쪽'
      },
      backLeft: {
        en: 'Back Left',
        de: 'Hinten Links',
        fr: 'Arrière Gauche',
        ja: '後左',
        cn: '左后',
        ko: '뒤 왼쪽'
      },
      backRight: {
        en: 'Back Right',
        de: 'Hinten Rechts',
        fr: 'Arrière Droit',
        ja: '後ろ右',
        cn: '右后',
        ko: '뒤 오른쪽'
      }
    }
  }, {
    id: 'Euphrosyne Menphina Lunar Kiss',
    type: 'HeadMarker',
    netRegex: {
      id: '019C'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.tankLaserOnYou();
    },
    run: (data, matches) => data.menphinaLunarKissTargets.push(matches.target),
    outputStrings: {
      tankLaserOnYou: {
        en: 'Tank Laser on YOU',
        de: 'Tank Laser auf DIR',
        fr: 'Tank laser sur VOUS',
        ja: '自分にタンクレーザー',
        cn: '坦克激光点名',
        ko: '탱 레이저 대상자'
      }
    }
  }, {
    id: 'Euphrosyne Menphina Lunar Kiss Not You',
    type: 'HeadMarker',
    netRegex: {
      id: '019C',
      capture: false
    },
    delaySeconds: 0.3,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (data.menphinaLunarKissTargets.includes(data.me)) return;
      return output.avoidTankLaser();
    },
    run: data => data.menphinaLunarKissTargets = [],
    outputStrings: {
      avoidTankLaser: {
        en: 'Avoid Tank Laser',
        de: 'Weiche dem Tanklaser aus',
        fr: 'Évitez le tank laser',
        ja: 'タンクレーザー回避',
        cn: '躲避坦克激光',
        ko: '탱 레이저 피하기'
      }
    }
  }, {
    id: 'Euphrosyne Menphina Winter Halo',
    type: 'StartsUsing',
    // 7BC6 = no dog (7BC7 damage)
    // 7BDB = dog cleaving right attached (7BDF damage)
    // 7BDC = ? (probably dog cleaving left attached?)
    // 7BE8 = dog cleaving right unattached (7BEC damage)
    // 7BE9 = dog cleaving left unattached (7BEC damage)
    // 7F0E = ? (probably dog cleaving right unattached?)
    // 7F0F = dog cleaving left unattached (7BEC damage)
    netRegex: {
      id: ['7BC6', '7BE8', '7BE9', '7F0E', '7F0F', '7BDB', '7BDC'],
      source: 'Menphina',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Euphrosyne Menphina Keen Moonbeam',
    type: 'StartsUsing',
    netRegex: {
      id: '7BF4',
      source: 'Menphina'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Euphrosyne Menphina Moonset Rays',
    type: 'StartsUsing',
    netRegex: {
      id: '80FA',
      source: 'Menphina'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Blueblossoms/Giltblossoms': 'Blossoms'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Althyk(?! &)': 'Althyk',
      'Althyk & Nymeia': 'Althyk & Nymeia',
      'Euphrosynos Behemoth': 'Euphrosyne-Behemoth',
      'Euphrosynos Ktenos': 'Euphrosyne-Ktenos',
      'Glacial Spear': 'Eis-Speer',
      'Halone': 'Halone',
      'Menphina': 'Menphina',
      '(?<!& )Nophica': 'Nophica',
      'Nymeia': 'Nymeia',
      'The Barbs': 'Domäne der Furie',
      'The Bole': 'Eiche',
      'The Chamber Of Revolutions': 'Kammer der Zwillingsmonde',
      'The Fertile Plains': 'Land der Fruchtbarkeit'
    },
    'replaceText': {
      'Abundance': 'Blütensturm',
      'Ancient Blizzard': 'Antikes Eis',
      'Axioma': 'Axioma',
      'Blue Moon': 'Blauer Mond',
      'Blueblossoms': 'Blaublüten',
      'Chalaza': 'Khalaza',
      'Cheimon': 'Cheimon',
      'Cratering Chill': 'Frostkrater',
      'Doom Spear': 'Schicksalsspeer',
      'First Blush': 'Lunarer Schuss',
      'Floral Haze': 'Florale Faszination',
      'Full Bright': 'Voller Glanz',
      'Furrow': 'Sommerfurche',
      'Fury\'s Aegis': 'Aegis der Furie',
      'Giltblossoms': 'Goldblüten',
      'Heavens\' Earth': 'Himmlische Erde',
      'Hydroptosis': 'Hydroptosis',
      'Hydrorythmos': 'Hydrorhythmus',
      'Hydrostasis': 'Hydrostase',
      'Ice Dart': 'Eispfeil',
      'Ice Rondel': 'Eisrondell',
      'Inexorable Pull': 'Unerbittliche Gravitation',
      'Keen Moonbeam': 'Heftiger Mondstrahl',
      'Landwaker': 'Erwachen der göttlichen Erde',
      'Lochos': 'Lochos',
      'Love\'s Light': 'Licht der Liebe',
      'Lovers\' Bridge': 'Brücke der Liebenden',
      'Lunar Kiss': 'Mondkuss',
      'Matron\'s Breath': 'Nophicas Atem',
      'Matron\'s Harvest': 'Nophicas Ernte',
      'Matron\'s Plenty': 'Nophicas Überfluss',
      'Midnight Frost': 'Mitternachtsfrost',
      'Moonset(?! Rays)': 'Monduntergang',
      'Moonset Rays': 'Dämmerungsstrahl',
      'Mythril Greataxe': 'Mithril-Großaxt',
      'Neikos': 'Neikos',
      'Niphas': 'Niphas',
      'Petrai': 'Petrai',
      'Philotes': 'Philotes',
      'Playful Orbit': 'Verspielter Orbit',
      'Rain of Spears': 'Speerregen',
      'Reaper\'s Gale': 'Todessturm',
      'Rise of the Twin Moons': 'Aufgang der Zwillingsmonde',
      'Season\'s Passing': 'Lauf der Jahreszeiten',
      'Selenain Mysteria': 'Zeremonie der Zwillingsmonde',
      'Shockwave': 'Schockwelle',
      'Silver Mirror': 'Silberner Spiegel',
      'Sowing Circle': 'Sommer-Aussaat',
      'Spears Three': 'Drei Speere',
      'Spinner\'s Wheel': 'Spinnrad',
      'Spring Flowers': 'Frühlingssturm',
      'Tetrapagos': 'Tetrapagos',
      'The Giving Land': 'Geschenk der Erde',
      'Thousandfold Thrust': 'Tausendfacher Stoß',
      'Time and Tide': 'Zeit und Gezeiten',
      'Waxing Claw': 'Wachsende Klaue',
      'Will of the Fury': 'Wille von Halone',
      'Winter Halo': 'Silberner Spiegel',
      'Winter Solstice': 'Wintersonnenwende',
      'Wrath of Halone': 'Wille von Halone'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Althyk(?! &)': 'Althyk',
      'Althyk & Nymeia': 'duo Althyk et Nymeia',
      'Euphrosynos Behemoth': 'béhémoth d\'Euphrosyne',
      'Euphrosynos Ktenos': 'kténos d\'Euphrosyne',
      'Glacial Spear': 'lance de glace',
      'Halone': 'Halone',
      'Menphina': 'Menphina',
      'Nophica': 'Nophica',
      '(?<!& )Nymeia': 'Nymeia',
      'The Barbs': 'Quartiers de la Conquérante',
      'The Bole': 'Le Tronc',
      'The Chamber Of Revolutions': 'Chambre des lunes jumelles',
      'The Fertile Plains': 'Terre d\'abondance'
    },
    'replaceText': {
      'Abundance': 'Profusion de pétales',
      'Ancient Blizzard': 'Glace ancienne',
      'Axioma': 'Axiome',
      'Blue Moon': 'Lune bleue',
      'Blueblossoms': 'Pétales d\'azur',
      'Chalaza': 'Khalaza',
      'Cheimon': 'Cheimon',
      'Cratering Chill': 'Frisson cratérisant',
      'Doom Spear': 'Lance du destin',
      'First Blush': 'Scintillement sélénien',
      'Floral Haze': 'Fascination florale',
      'Full Bright': 'Nuit de pleine lune',
      'Furrow': 'Sillon sidérant',
      'Fury\'s Aegis': 'Égide de la Conquérante',
      'Giltblossoms': 'Pétales dorés',
      'Heavens\' Earth': 'Terre des cieux',
      'Hydroptosis': 'Hydroptôse',
      'Hydrorythmos': 'Hydrorythme',
      'Hydrostasis': 'Hydrostase',
      'Ice Dart': 'Dard glacé',
      'Ice Rondel': 'Rondelle glacée',
      'Inexorable Pull': 'Manipulation gravitationnelle',
      'Keen Moonbeam': 'Sillon sélénite',
      'Landwaker': 'Éveil de la terre divine',
      'Lochos': 'Lochos',
      'Love\'s Light': 'Brillance de l\'amour',
      'Lovers\' Bridge': 'Lueur lunaire',
      'Lunar Kiss': 'Scintillement glaçant',
      'Matron\'s Breath': 'Souffle de la Mère',
      'Matron\'s Harvest': 'Fête des récoltes',
      'Matron\'s Plenty': 'Abondance maternelle',
      'Midnight Frost': 'Gibbosités givrées',
      'Moonset(?! Rays)': 'Coucher de lune',
      'Moonset Rays': 'Rayon crépusculaire',
      'Mythril Greataxe': 'Grande hache de mythril',
      'Neikos': 'Neikos',
      'Niphas': 'Niphas',
      'Petrai': 'Pétra',
      'Philotes': 'Philotès',
      'Playful Orbit': 'Commando complice',
      'Rain of Spears': 'Déluge de lances',
      'Reaper\'s Gale': 'Fauche rafale',
      'Rise of the Twin Moons': 'Lever des lunes jumelles',
      'Season\'s Passing': 'Cycle des saisons',
      'Selenain Mysteria': 'Mystères séléniens',
      'Shockwave': 'Onde de choc',
      'Silver Mirror': 'Reflet glacé',
      'Sowing Circle': 'Cercles des semences',
      'Spears Three': 'Trinité de lances',
      'Spinner\'s Wheel': 'Rouet du destin',
      'Spring Flowers': 'Épanouissement printanier',
      'Tetrapagos': 'Tetrapagos',
      'The Giving Land': 'Bénédiction de la nature',
      'Thousandfold Thrust': 'Transpercement millénaire',
      'Time and Tide': 'Manipulation temporelle',
      'Waxing Claw': 'Griffes gardiennes',
      'Will of the Fury': 'Volonté de Halone',
      'Winter Halo': 'Halo hivernal',
      'Winter Solstice': 'Solstice d\'hiver',
      'Wrath of Halone': 'Courroux de la Conquérante'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Althyk(?! &)': 'アルジク',
      'Althyk & Nymeia': 'アルジク＆ニメーヤ',
      'Euphrosynos Behemoth': 'エウプロシュネ・ベヒーモス',
      'Euphrosynos Ktenos': 'エウプロシュネ・クティノス',
      'Glacial Spear': '氷の数槍',
      'Halone': 'ハルオーネ',
      'Menphina': 'メネフィナ',
      'Nophica': 'ノフィカ',
      '(?<!& )Nymeia': 'ニメーヤ',
      'The Barbs': '戦神の間',
      'The Bole': '世界樹の幹',
      'The Chamber Of Revolutions': '双月の間',
      'The Fertile Plains': '豊穣の地'
    },
    'replaceText': {
      'Abundance': '神力の花嵐',
      'Ancient Blizzard': 'エンシェントブリザド',
      'Axioma': 'アクシオマー',
      'Blue Moon': '月神光',
      'Blueblossoms': '青花散',
      'Chalaza': 'ハラーザ',
      'Cheimon': 'ヘイモン',
      'Cratering Chill': '月氷撃',
      'Doom Spear': 'ドゥームスピアー',
      'First Blush': '月閃',
      'Floral Haze': '惑いの葉花',
      'Full Bright': '月夜の巡り',
      'Furrow': '地突き',
      'Fury\'s Aegis': 'イージス・オブ・ハルオーネ',
      'Giltblossoms': '黄花散',
      'Heavens\' Earth': '神界石',
      'Hydroptosis': 'ヒュドルピトシス',
      'Hydrorythmos': 'ヒュドルリュトモス',
      'Hydrostasis': 'ヒュドルスタシス',
      'Ice Dart': '氷塊',
      'Ice Rondel': '大氷塊',
      'Inexorable Pull': '重力操作',
      'Keen Moonbeam': '月光槍',
      'Landwaker': '神地の目覚め',
      'Lochos': 'ロコス',
      'Love\'s Light': '慈愛の月',
      'Lovers\' Bridge': '月輝',
      'Lunar Kiss': '冷月閃',
      'Matron\'s Breath': '豊穣の息吹',
      'Matron\'s Harvest': '収穫の祭典',
      'Matron\'s Plenty': '豊穣の神光',
      'Midnight Frost': '月地氷霜',
      'Moonset(?! Rays)': '落月蹴',
      'Moonset Rays': '月の階',
      'Mythril Greataxe': '霊銀の大斧',
      'Neikos': 'ネイコス',
      'Niphas': 'ニファス',
      'Petrai': 'ペトゥライ',
      'Philotes': 'フィロテス',
      'Playful Orbit': '遊撃機動',
      'Rain of Spears': 'レイン・オブ・スピアーズ',
      'Reaper\'s Gale': '鎌風',
      'Rise of the Twin Moons': '双月の導き',
      'Season\'s Passing': '春夏の移ろい',
      'Selenain Mysteria': '双月の儀',
      'Shockwave': '衝撃波',
      'Silver Mirror': '月霜',
      'Sowing Circle': '耕起輪転',
      'Spears Three': 'スリースピアーズ',
      'Spinner\'s Wheel': '運命の紡車',
      'Spring Flowers': '春の花茨',
      'Tetrapagos': 'テトラパゴス',
      'The Giving Land': '大地の恵み',
      'Thousandfold Thrust': 'サウザンスラスト',
      'Time and Tide': '時間操作',
      'Waxing Claw': '番犬の爪',
      'Will of the Fury': 'ウィル・オブ・ハルオーネ',
      'Winter Halo': '月暈',
      'Winter Solstice': '寒月',
      'Wrath of Halone': 'ラース・オブ・ハルオーネ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Althyk(?! &)': '光阴神阿尔基克',
      'Althyk & Nymeia': '阿尔基克和妮美雅',
      'Euphrosynos Behemoth': '欧芙洛绪涅贝希摩斯',
      'Euphrosynos Ktenos': '欧芙洛绪涅牲兽',
      'Glacial Spear': '寒冰长枪',
      'Halone': '哈罗妮',
      'Menphina': '梅茵菲娜',
      '(?<!& )Nophica': '诺菲卡',
      'Nymeia': '妮美雅',
      'The Barbs': '战争神之间',
      'The Bole': '世界树',
      'The Chamber Of Revolutions': '双月之间',
      'The Fertile Plains': '丰饶之地'
    },
    'replaceText': {
      'Abundance': '神力花雨',
      'Ancient Blizzard': '古代冰结',
      'Axioma': '公理',
      'Blue Moon': '月神光',
      'Blueblossoms': '蓝花飞散',
      'Chalaza': '冰雹',
      'Cheimon': '寒冬',
      'Cratering Chill': '月冰击',
      'Doom Spear': '厄运枪',
      'First Blush': '月闪',
      'Floral Haze': '魅惑的叶花',
      'Full Bright': '月夜巡游',
      'Furrow': '锄地',
      'Fury\'s Aegis': '战女神之圣盾',
      'Giltblossoms': '黄花飞散',
      'Heavens\' Earth': '神界石',
      'Hydroptosis': '水之倾泻',
      'Hydrorythmos': '水之流动',
      'Hydrostasis': '水之停滞',
      'Ice Dart': '冰块',
      'Ice Rondel': '大冰块',
      'Inexorable Pull': '重力操纵',
      'Keen Moonbeam': '月光枪',
      'Landwaker': '大地复苏',
      'Lochos': '伏枪',
      'Love\'s Light': '慈爱的月亮',
      'Lovers\' Bridge': '月辉',
      'Lunar Kiss': '冷月闪',
      'Matron\'s Breath': '丰饶的吐息',
      'Matron\'s Harvest': '丰收的庆典',
      'Matron\'s Plenty': '丰饶的神光',
      'Midnight Frost': '月地冰霜',
      'Moonset(?! Rays)': '落月踢',
      'Moonset Rays': '明月流光',
      'Mythril Greataxe': '秘银大斧',
      'Neikos': '冲突',
      'Niphas': '尘雪',
      'Petrai': '群岩',
      'Philotes': '爱',
      'Playful Orbit': '游击机动',
      'Rain of Spears': '冰枪之雨',
      'Reaper\'s Gale': '镰风',
      'Rise of the Twin Moons': '双月的指引',
      'Season\'s Passing': '春夏交替',
      'Selenain Mysteria': '双月之仪',
      'Shockwave': '冲击波',
      'Silver Mirror': '月霜',
      'Sowing Circle': '耕作轮转',
      'Spears Three': '战争神尖枪',
      'Spinner\'s Wheel': '命运的纺车',
      'Spring Flowers': '春之蔷薇',
      'Tetrapagos': '寒枪四连',
      'The Giving Land': '大地的恩惠',
      'Thousandfold Thrust': '千枪连刺',
      'Time and Tide': '时间操纵',
      'Waxing Claw': '猎犬利爪',
      'Will of the Fury': '战女神之意',
      'Winter Halo': '月晕',
      'Winter Solstice': '寒月',
      'Wrath of Halone': '战女神之愤'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Althyk(?! &)': '알디크',
      'Althyk & Nymeia': '알디크와 니메이아',
      'Euphrosynos Behemoth': '에우프로시네 베히모스',
      'Euphrosynos Ktenos': '에우프로시네 뿔짐승',
      'Glacial Spear': '얼음창',
      'Halone': '할로네',
      'Menphina': '메느피나',
      '(?<!& )Nophica': '노피카',
      'Nymeia': '니메이아',
      'The Barbs': '전쟁신의 방',
      'The Bole': '세계수',
      'The Chamber Of Revolutions': '두 달의 방',
      'The Fertile Plains': '풍요의 땅'
    },
    'replaceText': {
      'Abundance': '신력의 꽃폭풍',
      'Ancient Blizzard': '에인션트 블리자드',
      'Axioma': '공리',
      'Blue Moon': '달의 신의 빛',
      'Blueblossoms': '푸른꽃 만발',
      'Chalaza': '우박 생성',
      'Cheimon': '한겨울',
      'Cratering Chill': '달얼음 공격',
      'Doom Spear': '파멸의 창',
      'First Blush': '달의 섬광',
      'Floral Haze': '미혹의 꽃잎',
      'Full Bright': '환한 달밤',
      'Furrow': '써레질',
      'Fury\'s Aegis': '할로네의 방패',
      'Giltblossoms': '노란꽃 만발',
      'Heavens\' Earth': '신계의 돌',
      'Hydroptosis': '쏟아지는 물',
      'Hydrorythmos': '율동하는 물',
      'Hydrostasis': '우뚝 선 물',
      'Ice Dart': '얼음 덩어리',
      'Ice Rondel': '큰 얼음 덩어리',
      'Inexorable Pull': '중력 조작',
      'Keen Moonbeam': '달빛 창',
      'Landwaker': '신의 땅 각성',
      'Lochos': '매복창',
      'Love\'s Light': '자애로운 달',
      'Lovers\' Bridge': '달의 광휘',
      'Lunar Kiss': '서늘한 달의 섬광',
      'Matron\'s Breath': '풍요의 숨결',
      'Matron\'s Harvest': '수확의 제전',
      'Matron\'s Plenty': '풍요신의 빛',
      'Midnight Frost': '월면 결빙',
      'Moonset(?! Rays)': '달넘이',
      'Moonset Rays': '달의 섬돌',
      'Mythril Greataxe': '미스릴 도끼',
      'Neikos': '네이코스',
      'Niphas': '설한풍',
      'Petrai': '바위들',
      'Philotes': '필로테스',
      'Playful Orbit': '유격 기동',
      'Rain of Spears': '창 세례',
      'Reaper\'s Gale': '낫바람',
      'Rise of the Twin Moons': '두 달의 인도',
      'Season\'s Passing': '늦봄 초여름',
      'Selenain Mysteria': '두 달의 의식',
      'Shockwave': '충격파',
      'Silver Mirror': '달서리',
      'Sowing Circle': '논밭갈이',
      'Spears Three': '세 개의 창',
      'Spinner\'s Wheel': '운명의 물레',
      'Spring Flowers': '봄의 가시꽃',
      'Tetrapagos': '사연속 빙창',
      'The Giving Land': '대지의 은혜',
      'Thousandfold Thrust': '천 갈래 찌르기',
      'Time and Tide': '시간 조작',
      'Waxing Claw': '수호견의 발톱',
      'Will of the Fury': '할로네의 의지',
      'Winter Halo': '시린 달무리',
      'Winter Solstice': '차가운 달',
      'Wrath of Halone': '할로네의 분노'
    }
  }]
};
/* harmony default export */ const euphrosyne = (euphrosyne_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/alliance/euphrosyne.txt
const alliance_euphrosyne_namespaceObject = "# Euphrosyne\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Season's Passing\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~#\r\n# NOPHICA #\r\n#~~~~~~~~~#\r\n\r\n# -p 7C24:1012\r\n# -ii 7C26 7C09 7C10 7C0F 7C14 7C15 7C23\r\n\r\n# Fertile Plains will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10A9\" } window 10000,0\r\n1007.0 \"--sync--\" StartsUsing { id: \"7C24\", source: \"Nophica\" } window 20,20\r\n1012.0 \"Abundance\" Ability { id: \"7C24\", source: \"Nophica\" }\r\n1020.7 \"Matron's Plenty\" Ability { id: \"7C08\", source: \"Nophica\" }\r\n1031.8 \"The Giving Land\" Ability { id: \"801A\", source: \"Nophica\" }\r\n1032.0 \"Spring Flowers\" Ability { id: \"7C10\", source: \"Nophica\" }\r\n1034.9 \"Season's Passing\" Ability { id: \"7C0A\", source: \"Nophica\" }\r\n1043.0 \"The Giving Land\" Ability { id: \"8018\", source: \"Nophica\" }\r\n\r\n1056.1 \"Matron's Harvest\" Ability { id: \"7C1D\", source: \"Nophica\" }\r\n1068.2 \"--sync--\" Ability { id: \"7C0B\", source: \"Nophica\" }\r\n1068.8 \"Reaper's Gale 1\" #Ability { id: \"7C0E\", source: \"Nophica\" }\r\n1071.2 \"Reaper's Gale 2\" #Ability { id: \"7C0E\", source: \"Nophica\" }\r\n\r\n1075.9 \"Matron's Plenty\" Ability { id: \"7C08\", source: \"Nophica\" }\r\n1084.0 \"Floral Haze\" Ability { id: \"7DEB\", source: \"Nophica\" }\r\n1092.1 \"The Giving Land\" Ability { id: \"8018\", source: \"Nophica\" }\r\n1094.2 \"Season's Passing\" Ability { id: \"7C0A\", source: \"Nophica\" }\r\n1102.3 \"The Giving Land\" Ability { id: \"801A\", source: \"Nophica\" }\r\n\r\n1115.5 \"Matron's Harvest\" Ability { id: \"7C1E\", source: \"Nophica\" }\r\n1123.7 \"--middle--\" Ability { id: \"7C25\", source: \"Nophica\" }\r\n1143.8 \"Blueblossoms/Giltblossoms 1\" Ability { id: [\"7C20\", \"7C21\"], source: \"Nophica\" }\r\n1149.8 \"Blueblossoms/Giltblossoms 2\" Ability { id: [\"7C20\", \"7C21\"], source: \"Nophica\" }\r\n1155.8 \"Blueblossoms/Giltblossoms 3\" Ability { id: [\"7C20\", \"7C21\"], source: \"Nophica\" }\r\n1161.5 \"Abundance\" Ability { id: \"7C24\", source: \"Nophica\" }\r\n\r\n1170.3 \"Matron's Plenty\" Ability { id: \"7C08\", source: \"Nophica\" }\r\n1179.4 \"Floral Haze\" Ability { id: \"7DEB\", source: \"Nophica\" }\r\n1185.5 \"Landwaker\" Ability { id: \"7C19\", source: \"Nophica\" }\r\n1192.6 \"--sync--\" Ability { id: \"7C0C\", source: \"Nophica\" }\r\n1193.2 \"Reaper's Gale 1\" #Ability { id: \"7C0E\", source: \"Nophica\" }\r\n1195.5 \"Landwaker\" Ability { id: \"7C1C\", source: \"Nophica\" }\r\n1195.6 \"Reaper's Gale 2\" #Ability { id: \"7C0E\", source: \"Nophica\" }\r\n1199.6 \"The Giving Land\" Ability { id: \"8018\", source: \"Nophica\" }\r\n1206.7 \"Sowing Circle\" Ability { id: \"7C11\", source: \"Nophica\" } duration 14.3\r\n1208.8 \"Season's Passing\" Ability { id: \"7C0A\", source: \"Nophica\" }\r\n1215.8 \"The Giving Land\" Ability { id: \"801A\", source: \"Nophica\" }\r\n\r\n1227.9 \"Matron's Harvest\" Ability { id: \"7C1E\", source: \"Nophica\" }\r\n1236.1 \"--sync--\" Ability { id: \"7C25\", source: \"Nophica\" }\r\n1240.5 \"Matron's Breath\" Ability { id: \"7C1F\", source: \"Nophica\" }\r\n1256.1 \"Blueblossoms/Giltblossoms 1\" Ability { id: [\"7C20\", \"7C21\"], source: \"Nophica\" }\r\n1259.7 \"Blueblossoms/Giltblossoms 2\" Ability { id: [\"7C20\", \"7C21\"], source: \"Nophica\" }\r\n1263.3 \"Blueblossoms/Giltblossoms 3\" Ability { id: [\"7C20\", \"7C21\"], source: \"Nophica\" }\r\n1266.9 \"Blueblossoms/Giltblossoms 4\" Ability { id: [\"7C20\", \"7C21\"], source: \"Nophica\" }\r\n1270.5 \"Blueblossoms/Giltblossoms 5\" Ability { id: [\"7C20\", \"7C21\"], source: \"Nophica\" }\r\n1274.1 \"Blueblossoms/Giltblossoms 6\" Ability { id: [\"7C20\", \"7C21\"], source: \"Nophica\" }\r\n1280.1 \"Furrow\" Ability { id: \"7C16\", source: \"Nophica\" }\r\n1288.2 \"Heavens' Earth\" Ability { id: \"7C22\", source: \"Nophica\" }\r\n1299.4 \"Abundance\" Ability { id: \"7C24\", source: \"Nophica\" }\r\n1308.5 \"Abundance\" Ability { id: \"7C24\", source: \"Nophica\" }\r\n\r\n# loop block\r\n1322.3 \"Matron's Plenty\" Ability { id: \"7C08\", source: \"Nophica\" } window 50,50 jump 1170.3\r\n1331.4 \"Floral Haze\" #Ability { id: \"7DEB\", source: \"Nophica\" }\r\n1337.5 \"Landwaker\" #Ability { id: \"7C19\", source: \"Nophica\" }\r\n1344.6 \"--sync--\" #Ability { id: \"7C0C\", source: \"Nophica\" }\r\n1345.2 \"Reaper's Gale 1\" #Ability { id: \"7C0E\", source: \"Nophica\" }\r\n1347.5 \"Landwaker\" #Ability { id: \"7C1C\", source: \"Nophica\" }\r\n1347.6 \"Reaper's Gale 2\" #Ability { id: \"7C0E\", source: \"Nophica\" }\r\n1351.6 \"The Giving Land\" #Ability { id: \"8018\", source: \"Nophica\" }\r\n1358.7 \"Sowing Circle\" #Ability { id: \"7C11\", source: \"Nophica\" } duration 14.3\r\n1360.8 \"Season's Passing\" #Ability { id: \"7C0A\", source: \"Nophica\" }\r\n1367.8 \"The Giving Land\" #Ability { id: \"801A\", source: \"Nophica\" }\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~#\r\n# NYMEIA & ALTHYK #\r\n#~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 7A38:2013.5\r\n# -ii 803E 803F 7A35 7A45 7A43 7A40 7A41 7A49 7A54 7A55\r\n\r\n# 7A4A = Althyk teleporting mid, 7A4B = Nymeia teleporting south; hard to label both\r\n# This is overall an awkward timeline.  The two bosses can definitely desync by ~1-2s.\r\n\r\n# The Bole will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10AB\" } window 10000,0\r\n2009.0 \"--sync--\" StartsUsing { id: \"7A38\", source: \"Nymeia\" } window 10,10\r\n2013.5 \"Spinner's Wheel\" Ability { id: \"7A38\", source: \"Nymeia\" }\r\n2019.2 \"--sync--\" StartsUsing { id: \"7A46\", source: \"Althyk\" } window 10,10\r\n2026.2 \"Mythril Greataxe\" Ability { id: \"7A46\", source: \"Althyk\" }\r\n2041.1 \"Spinner's Wheel\" Ability { id: \"7A38\", source: \"Nymeia\" } window 10,10\r\n2052.7 \"Time and Tide\" Ability { id: \"7A39\", source: \"Althyk\" }\r\n\r\n2073.9 \"--sync--\" StartsUsing { id: \"7A47\", source: \"Althyk\" } window 10,10\r\n2078.9 \"Axioma\" Ability { id: \"7A47\", source: \"Althyk\" }\r\n2087.2 \"Hydroptosis\" Ability { id: \"7A44\", source: \"Nymeia\" }\r\n2099.2 \"Inexorable Pull\" Ability { id: \"7A42\", source: \"Althyk\" }\r\n2113.9 \"Hydrorythmos\" Ability { id: \"7A3F\", source: \"Nymeia\" } duration 8\r\n2125.6 \"Mythril Greataxe\" Ability { id: \"7A46\", source: \"Althyk\" }\r\n\r\n2137.8 \"--middle--\" Ability { id: \"7A4A\", source: \"Althyk\" }\r\n2144.1 \"Hydrostasis\" Ability { id: \"7A3A\", source: \"Nymeia\" }\r\n2145.1 \"Petrai\" Ability { id: \"7A48\", source: \"Althyk\" }\r\n2161.2 \"Hydrostasis 1\" Ability { id: \"7A3B\", source: \"Nymeia\" }\r\n2164.2 \"Hydrostasis 2\" Ability { id: \"7A3C\", source: \"Nymeia\" }\r\n2167.2 \"Hydrostasis 3\" Ability { id: \"7A3D\", source: \"Nymeia\" }\r\n\r\n2185.1 \"Spinner's Wheel\" Ability { id: \"7A38\", source: \"Nymeia\" } window 20,20\r\n2214.0 \"Mythril Greataxe\" Ability { id: \"7A46\", source: \"Althyk\" }\r\n2218.4 \"Hydroptosis\" Ability { id: \"7A44\", source: \"Nymeia\" }\r\n2235.2 \"Petrai\" Ability { id: \"7A48\", source: \"Althyk\" }\r\n\r\n2240.2 \"--middle--\" Ability { id: \"7A4A\", source: \"Althyk\" }\r\n2243.9 \"Philotes\" Ability { id: [\"7A35\", \"7A36\"], source: \"Althyk\" }\r\n2247.7 \"Hydrostasis\" Ability { id: \"7A3A\", source: \"Nymeia\" } window 20,20\r\n2261.0 \"Time and Tide\" Ability { id: \"7A39\", source: \"Althyk\" }\r\n2261.8 \"Hydrostasis 1\" Ability { id: \"7A3E\", source: \"Nymeia\" }\r\n2264.8 \"Hydrostasis 2\" Ability { id: \"7A3B\", source: \"Nymeia\" }\r\n2267.8 \"Hydrostasis 3\" Ability { id: \"7A3C\", source: \"Nymeia\" }\r\n\r\n2284.5 \"--sync--\" StartsUsing { id: \"7A47\", source: \"Althyk\" } window 20,20\r\n2289.5 \"Axioma\" Ability { id: \"7A47\", source: \"Althyk\" }\r\n2302.3 \"Spinner's Wheel\" Ability { id: \"7A38\", source: \"Nymeia\" }\r\n2309.4 \"Hydrorythmos\" Ability { id: \"7A3F\", source: \"Nymeia\" }\r\n2313.8 \"Time and Tide\" Ability { id: \"7A39\", source: \"Althyk\" }\r\n2322.1 \"Philotes\" Ability { id: \"7A36\", source: \"Althyk\" }\r\n2339.2 \"Hydroptosis\" Ability { id: \"7A44\", source: \"Nymeia\" }\r\n2343.2 \"Inexorable Pull\" Ability { id: \"7A42\", source: \"Althyk\" }\r\n2356.4 \"Petrai\" Ability { id: \"7A48\", source: \"Althyk\" }\r\n2372.4 \"Axioma\" Ability { id: \"7A47\", source: \"Althyk\" }\r\n2385.1 \"Spinner's Wheel\" Ability { id: \"7A38\", source: \"Nymeia\" }\r\n2387.9 \"Mythril Greataxe\" Ability { id: \"7A46\", source: \"Althyk\" }\r\n\r\n2390.1 \"--middle--\" Ability { id: \"7A4A\", source: \"Althyk\" }\r\n2393.5 \"Philotes\" Ability { id: \"7A36\", source: \"Althyk\" }\r\n2401.6 \"Hydrostasis\" Ability { id: \"7A3A\", source: \"Nymeia\" } window 20,20\r\n2413.6 \"Time and Tide\" Ability { id: \"7A39\", source: \"Althyk\" }\r\n2415.6 \"Hydrostasis 1\" Ability { id: \"7A3E\", source: \"Nymeia\" }\r\n2418.6 \"Hydrostasis 2\" Ability { id: \"7A3B\", source: \"Nymeia\" }\r\n2421.6 \"Hydrostasis 3\" Ability { id: \"7A3C\", source: \"Nymeia\" }\r\n\r\n2441.9 \"Axioma\" Ability { id: \"7A47\", source: \"Althyk\" }\r\n2447.2 \"Philotes\" Ability { id: \"7A36\", source: \"Althyk\" }\r\n2455.9 \"Spinner's Wheel\" Ability { id: \"7A38\", source: \"Nymeia\" } window 20,20\r\n2463.0 \"Hydrorythmos\" Ability { id: \"7A3F\", source: \"Nymeia\" }\r\n2467.4 \"Time and Tide\" Ability { id: \"7A39\", source: \"Althyk\" }\r\n2475.7 \"Philotes\" Ability { id: \"7A36\", source: \"Althyk\" }\r\n2488.8 \"Hydroptosis\" Ability { id: \"7A44\", source: \"Nymeia\" }\r\n2492.8 \"Inexorable Pull\" Ability { id: \"7A42\", source: \"Althyk\" }\r\n\r\n2496.9 \"--sync--\" Ability { id: \"7A4A\", source: \"Althyk\" }\r\n2509.3 \"--sync--\" StartsUsing { id: \"7A4C\", source: \"Althyk\" } window 200,200\r\n2519.3 \"Neikos Enrage\" Ability { id: \"7A4C\", source: \"Althyk\" }\r\n#2520.5 \"Neikos\" Ability { id: \"7A4D\", source: \"Nymeia\" }\r\n#2520.5 \"Neikos\" Ability { id: \"7A4E\", source: \"Althyk & Nymeia\" }\r\n\r\n#2522.5 \"--sync--\" Ability { id: \"801C\", source: \"Althyk & Nymeia\" }\r\n#2537.6 \"Neikos\" Ability { id: \"7D99\", source: \"Nymeia\" }\r\n#2537.6 \"Neikos\" Ability { id: \"7D98\", source: \"Althyk\" }\r\n#2537.6 \"Neikos\" Ability { id: \"7A4E\", source: \"Althyk & Nymeia\" }\r\n\r\n\r\n#~~~~~~~~#\r\n# HALONE #\r\n#~~~~~~~~#\r\n\r\n# -p 7D79:3013 7D6E:3500\r\n# -ii 7D7A 7D7B 7D4E 7D4F 7D50 7D51 7D46 7D47 7D48 7D49 80AE 7D78 7D56 801F 8020 8021 7D52 7D53 7D54 7D55 7D58 7D64 7D5C\r\n# -it \"Halone\"\r\n# -it \"Glacial Spear\"\r\n\r\n# The Barbs will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10AD\" } window 10000,0\r\n3009.0 \"--sync--\" StartsUsing { id: \"7D79\", source: \"Halone\" }\r\n3013.0 \"Rain of Spears x3\" Ability { id: \"7D79\", source: \"Halone\" }\r\n\r\n3024.6 \"--sync--\" StartsUsing { id: \"7D45\", source: \"Halone\" }\r\n3037.9 \"--sync--\" Ability { id: \"7D45\", source: \"Halone\" }\r\n3038.1 \"Tetrapagos 1\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3040.1 \"Tetrapagos 2\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3042.1 \"Tetrapagos 3\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3044.1 \"Tetrapagos 4\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n\r\n3049.2 \"--sync--\" StartsUsing { id: \"7D45\", source: \"Halone\" }\r\n3062.2 \"--sync--\" Ability { id: \"7D45\", source: \"Halone\" }\r\n3062.4 \"Tetrapagos 1\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3064.4 \"Tetrapagos 2\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3066.4 \"Tetrapagos 3\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3068.4 \"Tetrapagos 4\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n\r\n3077.4 \"--sync--\" Ability { id: \"80AD\", source: \"Halone\" }\r\n3078.4 \"Doom Spear 1\" Ability { id: \"80AF\", source: \"Halone\" }\r\n3080.4 \"Doom Spear 2\" Ability { id: \"80B0\", source: \"Halone\" }\r\n3082.4 \"Doom Spear 3\" Ability { id: \"80B1\", source: \"Halone\" }\r\n3087.8 \"Spears Three\" Ability { id: \"7D77\", source: \"Halone\" }\r\n\r\n3095.0 \"--middle--\" Ability { id: \"7D7C\", source: \"Halone\" }\r\n3102.9 \"Thousandfold Thrust\" Ability { id: \"7D57\", source: \"Halone\" } duration 4\r\n\r\n3111.7 \"--middle--\" Ability { id: \"7D7C\", source: \"Halone\" }\r\n3119.8 \"Thousandfold Thrust\" Ability { id: \"7D57\", source: \"Halone\" } duration 4\r\n\r\n3129.9 \"--middle--\" Ability { id: \"7D7C\", source: \"Halone\" }\r\n3136.3 \"--sync--\" Ability { id: \"7D5A\", source: \"Halone\" }\r\n3142.2 \"Lochos\" Ability { id: \"7D5B\", source: \"Halone\" } duration 4\r\n\r\n3149.3 \"--middle--\" Ability { id: \"7D7C\", source: \"Halone\" }\r\n3153.7 \"Will of the Fury\" Ability { id: \"7D5D\", source: \"Halone\" }\r\n3159.6 \"--sync--\" Ability { id: \"7D5E\", source: \"Halone\" }\r\n3161.6 \"--sync--\" Ability { id: \"7D5F\", source: \"Halone\" }\r\n3163.6 \"--sync--\" Ability { id: \"7D60\", source: \"Halone\" }\r\n3165.6 \"--sync--\" Ability { id: \"7D61\", source: \"Halone\" }\r\n3165.9 \"Wrath of Halone\" Ability { id: \"7D63\", source: \"Halone\" }\r\n3180.3 \"--north--\" Ability { id: \"7D7C\", source: \"Halone\" }\r\n3182.0 \"--sync--\" Ability { id: \"7D68\", source: \"Halone\" }\r\n3185.0 \"--untargetable--\"\r\n\r\n# Add phase\r\n3187.8 \"--adds targetable--\"\r\n3205.0 \"Niphas\" Ability { id: \"7D69\", source: \"Glacial Spear\" }\r\n3205.0 \"Ice Dart\" Ability { id: \"7D66\", source: \"Halone\" }\r\n3223.0 \"Cheimon\" Ability { id: \"7D6A\", source: \"Glacial Spear\" }\r\n3239.0 \"Ice Dart\" Ability { id: \"7D66\", source: \"Halone\" }\r\n# ???\r\n\r\n\r\n3500.0 \"Fury's Aegis\" Ability { id: \"7D6E\", source: \"Halone\" } window 500,0\r\n3501.0 \"Shockwave\" Ability { id: \"7D6F\", source: \"Halone\" }\r\n3508.9 \"Fury's Aegis\" Ability { id: \"7D70\", source: \"Halone\" } duration 8.5\r\n3509.5 \"--sync--\" Ability { id: \"7D71\", source: \"Halone\" }\r\n3509.9 \"--sync--\" Ability { id: \"7D72\", source: \"Halone\" }\r\n3510.5 \"--sync--\" Ability { id: \"7D73\", source: \"Halone\" }\r\n3511.1 \"--sync--\" Ability { id: \"7D74\", source: \"Halone\" }\r\n3517.4 \"--sync--\" Ability { id: \"7D75\", source: \"Halone\" }\r\n3525.4 \"--sync--\" Ability { id: \"7D7C\", source: \"Halone\" }\r\n3525.4 \"--targetable--\"\r\n\r\n3531.8 \"--middle--\" Ability { id: \"7D7C\", source: \"Halone\" }\r\n3538.2 \"--sync--\" Ability { id: \"7D5A\", source: \"Halone\" }\r\n3547.7 \"Thousandfold Thrust\" Ability { id: \"7D57\", source: \"Halone\" } duration 4\r\n3547.9 \"Lochos\" Ability { id: \"7D5B\", source: \"Halone\" } duration 4\r\n\r\n3556.9 \"Ice Dart\" Ability { id: \"7D66\", source: \"Halone\" }\r\n3561.6 \"Will of the Fury\" Ability { id: \"7D5D\", source: \"Halone\" }\r\n3567.5 \"--sync--\" Ability { id: \"7D5E\", source: \"Halone\" }\r\n3569.5 \"--sync--\" Ability { id: \"7D5F\", source: \"Halone\" }\r\n3571.5 \"--sync--\" Ability { id: \"7D60\", source: \"Halone\" }\r\n3573.5 \"--sync--\" Ability { id: \"7D61\", source: \"Halone\" }\r\n3573.8 \"Wrath of Halone\" Ability { id: \"7D63\", source: \"Halone\" }\r\n3575.5 \"--sync--\" Ability { id: \"7D62\", source: \"Halone\" }\r\n\r\n3578.1 \"--sync--\" Ability { id: \"7D7C\", source: \"Halone\" }\r\n3592.5 \"--sync--\" Ability { id: \"7D59\", source: \"Halone\" }\r\n3592.7 \"Tetrapagos 1\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3594.7 \"Tetrapagos 2\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3596.7 \"Tetrapagos 3\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3598.7 \"Tetrapagos 4\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3602.8 \"Thousandfold Thrust\" Ability { id: \"7D57\", source: \"Halone\" } duration 4\r\n\r\n3615.2 \"--middle--\" Ability { id: \"80AD\", source: \"Halone\" }\r\n3616.2 \"Doom Spear 1\" Ability { id: \"80AF\", source: \"Halone\" }\r\n3618.2 \"Doom Spear 2\" Ability { id: \"80B0\", source: \"Halone\" }\r\n3620.2 \"Doom Spear 3\" Ability { id: \"80B1\", source: \"Halone\" }\r\n3625.6 \"Rain of Spears x3\" Ability { id: \"7D79\", source: \"Halone\" }\r\n\r\n3638.8 \"--middle--\" Ability { id: \"7D7C\", source: \"Halone\" }\r\n3643.5 \"Chalaza\" Ability { id: \"7D65\", source: \"Halone\" }\r\n3650.4 \"Ice Rondel\" Ability { id: \"7D67\", source: \"Halone\" }\r\n3650.4 \"Ice Dart\" Ability { id: \"7D66\", source: \"Halone\" }\r\n\r\n3661.7 \"--sync--\" Ability { id: \"7D45\", source: \"Halone\" }\r\n3661.9 \"Tetrapagos 1\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3663.9 \"Tetrapagos 2\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3665.9 \"Tetrapagos 3\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3667.9 \"Tetrapagos 4\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3674.2 \"Spears Three\" Ability { id: \"7D77\", source: \"Halone\" }\r\n\r\n3680.3 \"--middle--\" Ability { id: \"7D7C\", source: \"Halone\" }\r\n3686.7 \"--sync--\" Ability { id: \"7D5A\", source: \"Halone\" }\r\n3696.6 \"Thousandfold Thrust\" Ability { id: \"7D57\", source: \"Halone\" } duration 4\r\n3696.6 \"Lochos\" Ability { id: \"7D5B\", source: \"Halone\" } duration 4\r\n3705.7 \"Ice Dart\" Ability { id: \"7D66\", source: \"Halone\" }\r\n3710.4 \"Will of the Fury\" Ability { id: \"7D5D\", source: \"Halone\" }\r\n3716.3 \"--sync--\" Ability { id: \"7D5E\", source: \"Halone\" }\r\n3718.3 \"--sync--\" Ability { id: \"7D5F\", source: \"Halone\" }\r\n3720.3 \"--sync--\" Ability { id: \"7D60\", source: \"Halone\" }\r\n3722.3 \"--sync--\" Ability { id: \"7D61\", source: \"Halone\" }\r\n3722.6 \"Wrath of Halone\" Ability { id: \"7D63\", source: \"Halone\" }\r\n3724.3 \"--sync--\" Ability { id: \"7D62\", source: \"Halone\" }\r\n3731.1 \"Rain of Spears\" Ability { id: \"7D79\", source: \"Halone\" }\r\n\r\n# loop\r\n3742.2 \"--middle--\" Ability { id: \"7D7C\", source: \"Halone\" } window 50,50 jump 3578.1\r\n3756.6 \"--sync--\" #Ability { id: \"7D59\", source: \"Halone\" }\r\n3756.8 \"Tetrapagos 1\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3758.8 \"Tetrapagos 2\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3760.8 \"Tetrapagos 3\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3762.8 \"Tetrapagos 4\" #Ability { id: \"7D4[ABCD]\", source: \"Halone\" }\r\n3766.9 \"Thousandfold Thrust\" #Ability { id: \"7D57\", source: \"Halone\" } duration 4\r\n\r\n\r\n#~~~~~~~~~~#\r\n# MENPHINA #\r\n#~~~~~~~~~~#\r\n\r\n# -p 7BFA:4013.1 8064:4510\r\n# -ii 7C04 7BFC 7BF9 7BC9 7BC7 7D35 7BEC 80FA 7BCD 7BCE 7BD1 7BD2 7BDD 7BDE 7BEA 7BEB\r\n# -it \"Menphina\"\r\n# -it \"Ceremonial Pillar\"\r\n\r\n# The Chamber of Revolutions will be sealed off\r\n4000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10BC\" } window 10000,0\r\n4013.1 \"Blue Moon\" Ability { id: \"7BFA\", source: \"Menphina\" }\r\n4020.9 \"Love's Light\" Ability { id: \"7BB8\", source: \"Menphina\" }\r\n4026.6 \"Full Bright\" Ability { id: \"7BBB\", source: \"Menphina\" }\r\n4038.0 \"First Blush\" Ability { id: \"7BBC\", source: \"Menphina\" }\r\n\r\n4040.3 \"--middle--\" Ability { id: \"7BD3\", source: \"Menphina\" }\r\n4048.6 \"Midnight Frost\" Ability { id: [\"7BCB\", \"7BCC\"], source: \"Menphina\" }\r\n4061.2 \"Lunar Kiss\" Ability { id: \"7BF7\", source: \"Menphina\" }\r\n\r\n4070.0 \"--sync--\" Ability { id: \"7BF5\", source: \"Menphina\" }\r\n4070.0 \"Silver Mirror 1\" #Ability { id: \"7BF6\", source: \"Menphina\" }\r\n4072.0 \"Silver Mirror 2\" #Ability { id: \"7BF6\", source: \"Menphina\" }\r\n4074.0 \"Silver Mirror 3\" #Ability { id: \"7BF6\", source: \"Menphina\" }\r\n\r\n4076.7 \"--sync--\" Ability { id: \"7BC8\", source: \"Menphina\" }\r\n4077.7 \"Moonset 1\" #Ability { id: \"7BCA\", source: \"Menphina\" }\r\n4079.9 \"Moonset 2\" #Ability { id: \"7BCA\", source: \"Menphina\" }\r\n4082.1 \"Moonset 3\" #Ability { id: \"7BCA\", source: \"Menphina\" }\r\n4088.5 \"Winter Halo\" Ability { id: \"7BC6\", source: \"Menphina\" }\r\n\r\n4097.2 \"Love's Light\" Ability { id: \"7BB9\", source: \"Menphina\" }\r\n4102.9 \"Full Bright\" Ability { id: \"7BBB\", source: \"Menphina\" }\r\n4109.9 \"Lovers' Bridge 1\" Ability { id: \"7BBD\", source: \"Menphina\" }\r\n4112.8 \"--middle--\" Ability { id: \"7BD3\", source: \"Menphina\" }\r\n4116.0 \"Lovers' Bridge 2\" Ability { id: \"7BBE\", source: \"Menphina\" }\r\n4121.0 \"Midnight Frost\" Ability { id: [\"7BCB\", \"7BCC\"], source: \"Menphina\" }\r\n\r\n# add phase\r\n4125.8 \"--sync--\" Ability { id: \"7BD3\", source: \"Menphina\" }\r\n4131.5 \"Selenain Mysteria\" Ability { id: \"7ABC\", source: \"Menphina\" }\r\n4131.5 \"--untargetable--\"\r\n4135.8 \"--adds targetable--\"\r\n4145.4 \"Ancient Blizzard\" #Ability { id: \"8066\", source: \"Ice Sprite\" }\r\n4148.3 \"Keen Moonbeam\" Ability { id: \"7BF4\", source: \"Menphina\" }\r\n4155.2 \"Ancient Blizzard\" #Ability { id: \"8066\", source: \"Ice Sprite\" }\r\n4162.9 \"Keen Moonbeam\" Ability { id: \"7BF4\", source: \"Menphina\" }\r\n4169.8 \"Ancient Blizzard\" #Ability { id: \"8066\", source: \"Ice Sprite\" }\r\n# ???\r\n\r\n4500.0 \"--sync--\" StartsUsing { id: \"8064\", source: \"Menphina\" } window 500,0\r\n4510.0 \"Rise of the Twin Moons\" Ability { id: \"8064\", source: \"Menphina\" }\r\n4513.2 \"--targetable--\"\r\n4526.6 \"Midnight Frost\" Ability { id: [\"7BD7\", \"7BD8\", \"7BD9\", \"7BDA\"], source: \"Menphina\" }\r\n4526.8 \"Waxing Claw\" Ability { id: [\"7BE0\", \"7BE1\"], source: \"Menphina\" }\r\n\r\n4535.5 \"Playful Orbit\" Ability { id: [\"7BE2\", \"7BE3\"], source: \"Menphina\" }\r\n4545.7 \"Midnight Frost\" Ability { id: [\"7BE4\", \"7BE5\", \"7BE6\", \"7BE7\", \"7F0A\", \"7F0B\", \"7F0C\", \"7F0D\"], source: \"Menphina\" }\r\n4545.8 \"Waxing Claw\" Ability { id: [\"7BE0\", \"7BE1\"], source: \"Menphina\" }\r\n\r\n4548.8 \"--sync--\" Ability { id: [\"7C06\", \"7C07\"], source: \"Menphina\" }\r\n4558.9 \"Blue Moon\" Ability { id: \"7BFB\", source: \"Menphina\" }\r\n4566.7 \"--sync--\" Ability { id: \"7BF3\", source: \"Menphina\" }\r\n4573.3 \"Keen Moonbeam\" Ability { id: \"7BF4\", source: \"Menphina\" }\r\n4579.3 \"Midnight Frost\" Ability { id: [\"7BD7\", \"7BD8\", \"7BD9\", \"7BDA\"], source: \"Menphina\" }\r\n4579.4 \"Waxing Claw\" Ability { id: [\"7BE0\", \"7BE1\"], source: \"Menphina\" }\r\n\r\n4586.4 \"Cratering Chill\" Ability { id: \"7BEE\", source: \"Menphina\" }\r\n4593.5 \"Winter Solstice\" Ability { id: \"7BED\", source: \"Menphina\" }\r\n4593.8 \"--sync--\" Ability { id: \"7BEF\", source: \"Menphina\" }\r\n4597.9 \"Playful Orbit\" Ability { id: [\"7BE2\", \"7BE3\"], source: \"Menphina\" }\r\n4608.1 \"Winter Halo\" Ability { id: [\"7BE8\", \"7BE9\", \"7F0E\", \"7F0F\", \"7BDB\", \"7BDC\"], source: \"Menphina\" }\r\n4608.2 \"Waxing Claw\" Ability { id: [\"7BE0\", \"7BE1\"], source: \"Menphina\" }\r\n\r\n4611.2 \"--sync--\" Ability { id: [\"7C06\", \"7C07\"], source: \"Menphina\" }\r\n4619.3 \"Moonset Rays\" Ability { id: \"80F9\", source: \"Menphina\" }\r\n4628.0 \"Love's Light\" Ability { id: \"7BC3\", source: \"Menphina\" }\r\n4632.7 \"Full Bright\" Ability { id: \"7BC5\", source: \"Menphina\" }\r\n4639.5 \"--sync--\" Ability { id: \"7BBD\", source: \"Menphina\" }\r\n4645.5 \"Lovers' Bridge 1\" #Ability { id: \"7BBE\", source: \"Menphina\" }\r\n4645.5 \"Lovers' Bridge 2\" #Ability { id: \"7BBE\", source: \"Menphina\" }\r\n\r\n4651.6 \"--sync--\" Ability { id: \"7AAA\", source: \"Menphina\" }\r\n4651.6 \"Silver Mirror 1\" #Ability { id: \"7BF6\", source: \"Menphina\" }\r\n4653.6 \"Silver Mirror 2\" #Ability { id: \"7BF6\", source: \"Menphina\" }\r\n4655.6 \"Silver Mirror 3\" #Ability { id: \"7BF6\", source: \"Menphina\" }\r\n4661.3 \"Midnight Frost/Winter Halo\" Ability { id: [\"7BD7\", \"7BD8\", \"7BD9\", \"7BDA\", \"7BE8\", \"7BE9\", \"7F0E\", \"7F0F\", \"7BDB\", \"7BDC\"], source: \"Menphina\" }\r\n4661.5 \"Waxing Claw\" Ability { id: [\"7BE0\", \"7BE1\"], source: \"Menphina\" }\r\n\r\n4671.5 \"Love's Light\" Ability { id: \"7BC2\", source: \"Menphina\" }\r\n4676.2 \"Full Bright\" Ability { id: \"7BC5\", source: \"Menphina\" }\r\n4681.4 \"Playful Orbit\" Ability { id: [\"7BE2\", \"7BE3\"], source: \"Menphina\" }\r\n4687.4 \"First Blush\" Ability { id: \"7BBC\", source: \"Menphina\" }\r\n4691.5 \"Midnight Frost\" Ability { id: [\"7BE4\", \"7BE5\", \"7BE6\", \"7BE7\", \"7F0A\", \"7F0B\", \"7F0C\", \"7F0D\"], source: \"Menphina\" }\r\n4691.7 \"Waxing Claw\" Ability { id: [\"7BE0\", \"7BE1\"], source: \"Menphina\" }\r\n\r\n4694.6 \"--sync--\" Ability { id: [\"7C06\", \"7C07\"], source: \"Menphina\" }\r\n4702.7 \"Moonset Rays\" Ability { id: \"80F9\", source: \"Menphina\" }\r\n\r\n4717.4 \"Lunar Kiss\" Ability { id: \"7BF8\", source: \"Menphina\" }\r\n4725.2 \"Love's Light\" Ability { id: \"7BC3\", source: \"Menphina\" }\r\n4729.9 \"Full Bright\" Ability { id: \"7BC5\", source: \"Menphina\" }\r\n4736.7 \"Lovers' Bridge 1\" Ability { id: \"7BBD\", source: \"Menphina\" }\r\n# This regex could probably be shorter, but need more info.\r\n4739.7 \"Midnight Frost\" Ability { id: [\"7BCF\", \"7BD0\", \"7BD[789A]\", \"7BE[4567]\", \"7F0[ABCD]\"], source: \"Menphina\" }\r\n4742.7 \"Lovers' Bridge 2\" Ability { id: \"7BBE\", source: \"Menphina\" }\r\n\r\n4748.5 \"Blue Moon\" Ability { id: \"7BFB\", source: \"Menphina\" }\r\n4759.2 \"Lunar Kiss\" Ability { id: \"7BF8\", source: \"Menphina\" }\r\n4765.9 \"--sync--\" Ability { id: \"7BF3\", source: \"Menphina\" }\r\n4772.5 \"Keen Moonbeam\" Ability { id: \"7BF4\", source: \"Menphina\" }\r\n4778.2 \"Midnight Frost\" Ability { id: [\"7BD7\", \"7BD8\", \"7BD9\", \"7BDA\"], source: \"Menphina\" }\r\n4778.4 \"Waxing Claw\" Ability { id: [\"7BE0\", \"7BE1\"], source: \"Menphina\" }\r\n\r\n# loop, probably\r\n4785.4 \"Cratering Chill\" Ability { id: \"7BEE\", source: \"Menphina\" } window 50,50 jump 4586.4\r\n4792.5 \"Winter Solstice\" #Ability { id: \"7BED\", source: \"Menphina\" }\r\n4792.8 \"--sync--\" #Ability { id: \"7BEF\", source: \"Menphina\" }\r\n4796.9 \"Playful Orbit\" Ability { id: [\"7BE2\", \"7BE3\"], source: \"Menphina\" }\r\n4807.1 \"Winter Halo\" #Ability { id: [\"7BE8\", \"7BE9\", \"7F0E\", \"7F0F\", \"7BDB\", \"7BDC\"], source: \"Menphina\" }\r\n4807.2 \"Waxing Claw\" Ability { id: [\"7BE0\", \"7BE1\"], source: \"Menphina\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/alliance/thaleia.ts





// TODO: Thaliak Rheognosis: is knockback always from east? can we determine where to go?
// TODO: Thaliak Rheognosis Petrine: determine where rocks are somehow and call them
// TODO: Thaliak Tetraktys: use map effect lines to give safe spots for falling walls
// TODO: Thaliak Heiroglyphika: use map effect lines to call safe spots for rotating green squares
// TODO: Llymlaen Dire Straits: use 8CCD/8CCE to call out left => right sort of thing
// TODO: Llymlaen Serpents' Tide: use 8826/887/8828/8829 line 264 cast locations to call safe spots
// TODO: Llymlaen Navigator's Trident knockback: call where to be knocked back to with Serpents' Tide combo
// TODO: Llymlaen Torrential Tridents: use 881B Landing to call where to start and rotation direction
// TODO: Oschon Trek Shot/Swinging Draw: use 264 cast locations to call safe spots
// TODO: Eulogia Love's Light: use map effect lines to call where to start and which way to rotate
// TODO: Eulogia Heiroglyphika: use map effect lines to call safe spots for rotating green squares
// TODO: Eulogia Solar Fans: do they always jump 4 times, so front/back is safe?
// TODO: Eulogia Climbing Shot: should tell you to knockback to red or blue
const eulogiaFormMap = {
  // first
  '8A0A': 'left',
  '8A0D': 'right',
  '8A10': 'inside',
  // second
  '8A0B': 'left',
  '8A0E': 'right',
  '8A11': 'inside',
  // third
  '8A0C': 'left',
  '8A0F': 'right',
  '8A12': 'inside'
};
const thaleia_triggerSet = {
  id: 'Thaleia',
  zoneId: zone_id/* default.Thaleia */.Z.Thaleia,
  timelineFile: 'thaleia.txt',
  initData: () => {
    return {
      busterTargets: [],
      soaringMinuet: false,
      eulogiaForms: []
    };
  },
  timelineTriggers: [{
    id: 'Thaleia Thaliak Rheognosis Knockback',
    regex: /^Rheognosis$/,
    beforeSeconds: 5,
    suppressSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  triggers: [{
    id: 'Thaleia Thaliak Katarraktes',
    type: 'StartsUsing',
    netRegex: {
      id: '88D1',
      source: 'Thaliak',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'Thaleia Thaliak Thlipsis',
    type: 'StartsUsing',
    netRegex: {
      id: '88D8',
      source: 'Thaliak'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Thaleia Thaliak Left Bank',
    type: 'StartsUsing',
    netRegex: {
      id: '88D2',
      source: 'Thaliak',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Thaleia Thaliak Right Bank',
    type: 'StartsUsing',
    netRegex: {
      id: '88D3',
      source: 'Thaliak',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Thaleia Thaliak Left Bank Hieroglyphika',
    type: 'StartsUsing',
    netRegex: {
      id: '8C2C',
      source: 'Thaliak',
      capture: false
    },
    delaySeconds: 12,
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Thaleia Thaliak Right Bank Hieroglyphika',
    type: 'StartsUsing',
    netRegex: {
      id: '8C2D',
      source: 'Thaliak',
      capture: false
    },
    delaySeconds: 12,
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Thaleia Thaliak Hydroptosis',
    type: 'StartsUsing',
    netRegex: {
      id: '88D5',
      source: 'Thaliak'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Thaleia Thaliak Rhyton',
    type: 'HeadMarker',
    netRegex: {
      id: '01D7'
    },
    delaySeconds: (data, matches) => {
      data.busterTargets.push(matches.target);
      return data.busterTargets.length === 3 ? 0 : 0.5;
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankCleaveOnYou: outputs/* default.tankCleaveOnYou */.Z.tankCleaveOnYou,
        tankCleaves: outputs/* default.tankBusterCleaves */.Z.tankBusterCleaves
      };
      if (data.busterTargets.length === 0) return;
      if (!data.busterTargets.includes(data.me)) return {
        infoText: output.tankCleaves()
      };
      if (data.role !== 'tank' && data.job !== 'BLU') return {
        alarmText: output.tankCleaveOnYou()
      };
      return {
        alertText: output.tankCleaveOnYou()
      };
    },
    run: data => data.busterTargets = []
  }, {
    id: 'Thaleia Thaliak Rheognosis',
    type: 'StartsUsing',
    netRegex: {
      id: '88C4',
      source: 'Thaliak',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look for knockback position',
        de: 'Nach Rückstoß Position schauen',
        fr: 'Repérez la zone de poussée',
        ja: 'ノックバック位置へ',
        cn: '寻找击退位置',
        ko: '넉백 위치 찾기'
      }
    }
  }, {
    id: 'Thaleia Thaliak Rheognosis Petrine',
    type: 'StartsUsing',
    netRegex: {
      id: '88C5',
      source: 'Thaliak',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback + Rolling stones',
        de: 'Rückstoß + rollende Steine',
        fr: 'Poussée + Rocher',
        ja: 'ノックバック + 石AOE',
        cn: '击退 + 滚石直线AoE',
        ko: '넉백 + 돌 피하기'
      }
    }
  }, {
    id: 'Thaleia Thaliak Hieroglyphika',
    type: 'StartsUsing',
    netRegex: {
      id: '88CF',
      source: 'Thaliak',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to rotated safe zone',
        de: 'Geh zum rotierten sicheren Feld',
        fr: 'Allez dans une zone sûre après rotation',
        ja: '安置へ移動',
        // FIXME
        cn: '去旋转后的安全区',
        ko: '회전한 뒤의 안전 지대로 가기'
      }
    }
  }, {
    id: 'Thaleia Llymlaen Tempest',
    type: 'StartsUsing',
    netRegex: {
      id: '880B',
      source: 'Llymlaen',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Thaleia Llymlaen Seafoam Spiral',
    type: 'StartsUsing',
    netRegex: {
      id: '880D',
      source: 'Llymlaen',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Thaleia Llymlaen Wind Rose',
    type: 'StartsUsing',
    netRegex: {
      id: '880C',
      source: 'Llymlaen',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Thaleia Llymlaen Navigator\'s Trident Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '8811',
      source: 'Llymlaen',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback',
        de: 'Rückstoß',
        fr: 'Poussée',
        ja: 'まもなくノックバック',
        cn: '击退',
        ko: '넉백'
      }
    }
  }, {
    id: 'Thaleia Llymlaen Surging Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '8812',
      source: 'Llymlaen',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Far knockback',
        de: 'Weiter Rückstoß',
        fr: 'Poussée au loin',
        ja: '遠くノックバック',
        cn: '长距离击退',
        ko: '멀리 넉백'
      }
    }
  }, {
    id: 'Thaleia Llymlaen Left Strait',
    type: 'StartsUsing',
    netRegex: {
      id: '8851',
      source: 'Llymlaen',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Thaleia Llymlaen Right Strait',
    type: 'StartsUsing',
    netRegex: {
      id: '8852',
      source: 'Llymlaen',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Thaleia Llymlaen Deep Dive',
    type: 'StartsUsing',
    netRegex: {
      id: ['8819', '8834'],
      source: 'Llymlaen'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Thaleia Llymlaen Stormwinds',
    type: 'StartsUsing',
    netRegex: {
      id: '881F',
      source: 'Llymlaen'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Thaleia Llymlaen Torrential Tridents',
    type: 'StartsUsing',
    netRegex: {
      id: '881A',
      source: 'Llymlaen',
      capture: false
    },
    durationSeconds: 12,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Last trident => 1st trident',
        de: 'Letzer Dreizack => erster Dreizack',
        fr: 'Dernier trident -> 1er trident',
        ja: '最後の槍 => 1番目の槍へ',
        cn: '最后一个三叉戟 => 第一个三叉戟',
        ko: '마지막 창 => 1번째 창으로'
      }
    }
  }, {
    id: 'Thaleia Llymlaen Godsbane',
    type: 'StartsUsing',
    netRegex: {
      id: '8824',
      source: 'Llymlaen',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'Thaleia Oschon Sudden Downpour',
    type: 'StartsUsing',
    netRegex: {
      id: ['8999', '899A'],
      source: 'Oschon',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Thaleia Oschon Trek Shot',
    type: 'StartsUsing',
    netRegex: {
      id: '898E',
      source: 'Oschon',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to side of the arrow (Boss doesn\'t move)',
        de: 'Geh seitlich des Pfeils (Boss bewegt sich nicht)',
        fr: 'Allez sur les côtés de la flèche (le boss ne bouge pas)',
        ja: '矢印の横へ (ボスは動かない)',
        cn: '去箭头两侧 (Boss不会移动)',
        ko: '화살표 옆으로 (보스는 움직이지 않음)'
      }
    }
  }, {
    id: 'Thaleia Oschon Reproduce',
    type: 'StartsUsing',
    netRegex: {
      id: '8989',
      source: 'Oschon',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (!data.soaringMinuet) return output.one();
      return output.two();
    },
    outputStrings: {
      one: {
        en: 'Go to side of the arrow',
        de: 'Geh seitlich des Pfeils',
        fr: 'Allez sur les côtés de la flèche',
        ja: '矢印の横へ',
        cn: '去箭头两侧',
        ko: '화살표 옆으로'
      },
      two: {
        en: 'Corner between two arrows',
        de: 'Ecke zwichen 2 Pfeilen',
        fr: 'Coin entre les 2 flèches',
        ja: '2つの矢印の隅',
        cn: '去两箭头间角落',
        ko: '두 화살표 사이로'
      }
    }
  }, {
    id: 'Thaleia Oschon Flinted Foehn',
    type: 'HeadMarker',
    netRegex: {
      id: '013C'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.stackMarkerOnYou();
      return output.stackMarkerOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      stackMarkerOn: {
        en: '6x Stack on ${player}',
        de: '6x Sammeln auf ${player}',
        fr: 'Package x6 sur ${player}',
        cn: '6x 分摊点 ${player}',
        ko: '6x 쉐어: ${player}'
      },
      stackMarkerOnYou: {
        en: '6x Stack on You',
        de: '6x Sammeln auf Dir',
        fr: 'Package x6 sur Vous',
        cn: '6x 分摊点名',
        ko: '6x 쉐어 대상자'
      }
    }
  }, {
    id: 'Thaleia Oschon Soaring Minuet',
    type: 'StartsUsing',
    netRegex: {
      id: ['8D0E', '8994'],
      source: 'Oschon',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind(),
    run: data => data.soaringMinuet = true
  }, {
    id: 'Thaleia Oschon The Arrow / Eulogia Sunbeam',
    // 0158 = The Arrow (small)
    // 0158 = Eulogia Sunbeam
    // 01F4 = The Arrow (big)
    type: 'HeadMarker',
    netRegex: {
      id: ['0158', '01F4']
    },
    delaySeconds: (data, matches) => {
      data.busterTargets.push(matches.target);
      return data.busterTargets.length === 3 ? 0 : 0.5;
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankCleaveOnYou: outputs/* default.tankCleaveOnYou */.Z.tankCleaveOnYou,
        tankCleaves: outputs/* default.tankBusterCleaves */.Z.tankBusterCleaves
      };
      if (data.busterTargets.length === 0) return;
      if (!data.busterTargets.includes(data.me)) return {
        infoText: output.tankCleaves()
      };
      if (data.role !== 'tank' && data.job !== 'BLU') return {
        alarmText: output.tankCleaveOnYou()
      };
      return {
        alertText: output.tankCleaveOnYou()
      };
    },
    run: data => data.busterTargets = []
  }, {
    id: 'Thaleia Oschon Climbing Shot',
    type: 'StartsUsing',
    netRegex: {
      id: ['8990', '8991', '8992', '8993'],
      source: 'Oschon',
      capture: false
    },
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback to safe corner',
        de: 'Rückstoß in die sichere Ecke',
        fr: 'Poussée vers un coin sûr',
        ja: 'AOEがないどころへ + ノックバック',
        cn: '击退到安全角落',
        ko: '안전한 구석으로 넉백되기'
      }
    }
  }, {
    id: 'Thaleia Oschon Lofty Peaks',
    type: 'StartsUsing',
    netRegex: {
      id: '89A7',
      source: 'Oschon',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '(second phase)',
        de: 'Oschon zweite Phase',
        fr: 'Oshon : deuxième phase',
        ja: 'すぐ大きくなる',
        cn: '(二阶段)',
        ko: '(2페이즈)'
      }
    }
  }, {
    id: 'Thaleia Oschon Piton Pull NE/SW',
    type: 'StartsUsing',
    netRegex: {
      id: '89A9',
      source: 'Oschon',
      capture: false
    },
    alertText: (_data, _matches, output) => {
      return output.text({
        front: output.dirNE(),
        back: output.dirSW()
      });
    },
    outputStrings: {
      text: {
        en: '${front} / ${back}',
        de: '${front} / ${back}',
        fr: '${front} / ${back}',
        cn: '${front} / ${back}',
        ko: '${front} / ${back}'
      },
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirSW: outputs/* default.dirSW */.Z.dirSW
    }
  }, {
    id: 'Thaleia Oschon Piton Pull NW/SE',
    type: 'StartsUsing',
    netRegex: {
      id: '89AA',
      source: 'Oschon',
      capture: false
    },
    alertText: (_data, _matches, output) => {
      return output.text({
        front: output.dirNW(),
        back: output.dirSE()
      });
    },
    outputStrings: {
      text: {
        en: '${front} / ${back}',
        de: '${front} / ${back}',
        fr: '${front} / ${back}',
        cn: '${front} / ${back}',
        ko: '${front} / ${back}'
      },
      dirNW: outputs/* default.dirNW */.Z.dirNW,
      dirSE: outputs/* default.dirSE */.Z.dirSE
    }
  }, {
    id: 'Thaleia Oschon Altitude',
    type: 'StartsUsing',
    netRegex: {
      id: '89AF',
      source: 'Oschon',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to safe zone',
        de: 'Geh in den sicheren Bereich',
        fr: 'Allez dans une zone sûre',
        ja: '安置で待機',
        cn: '去安全区',
        ko: '안전지대로'
      }
    }
  }, {
    id: 'Thaleia Oschon Wandering Shot North',
    type: 'StartsUsing',
    netRegex: {
      id: '8CF6',
      source: 'Oschon',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'South (away from orb)',
        de: 'Süden (weg vom Orb)',
        fr: 'Sud (loin de l\'orbe)',
        cn: '下(南) (远离球)',
        ko: '남쪽 (구슬에서 멀리)'
      }
    }
  }, {
    id: 'Thaleia Oschon Wandering Shot South',
    type: 'StartsUsing',
    netRegex: {
      id: '8CF7',
      source: 'Oschon',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'North (away from orb)',
        de: 'Norden (weg vom Orb)',
        fr: 'Nord (loin de l\'orbe)',
        cn: '上(北) (远离球)',
        ko: '북쪽 (구슬에서 멀리)'
      }
    }
  }, {
    id: 'Thaleia Oschon Wandering Volley North',
    type: 'StartsUsing',
    netRegex: {
      id: '89AC',
      source: 'Oschon',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback to south safe spot',
        de: 'Rückstoß zum südlichen sicheren Zone',
        fr: 'Poussée vers la zone sûre au Sud',
        cn: '击退到 下(南) 安全区',
        ko: '남쪽 안전지대로 넉백되기'
      }
    }
  }, {
    id: 'Thaleia Oschon Wandering Volley South',
    type: 'StartsUsing',
    netRegex: {
      id: '89AD',
      source: 'Oschon',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback to north safe spot',
        de: 'Rückstoß zum nördliche sicheren Zone',
        fr: 'Poussée vers la zone sûre au Nord',
        cn: '击退到 上(北) 安全区',
        ko: '북쪽 안전지대로 넉백되기'
      }
    }
  }, {
    id: 'Thaleia Eulogia Dawn of Time',
    type: 'StartsUsing',
    netRegex: {
      id: '8A03',
      source: 'Eulogia',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Thaleia Eulogia Forms',
    type: 'StartsUsing',
    netRegex: {
      id: Object.keys(eulogiaFormMap),
      source: 'Eulogia'
    },
    durationSeconds: data => data.eulogiaForms.length < 2 ? 4 : 19,
    infoText: (data, matches, output) => {
      const form = eulogiaFormMap[matches.id.toUpperCase()] ?? 'unknown';
      data.eulogiaForms.push(form);
      if (data.eulogiaForms.length === 3) {
        const [form1, form2, form3] = data.eulogiaForms.map(x => output[x]());
        data.eulogiaForms = [];
        return output.text({
          form1: form1,
          form2: form2,
          form3: form3
        });
      }
      return output[form]();
    },
    outputStrings: {
      text: {
        en: '${form1} => ${form2} => ${form3}',
        de: '${form1} => ${form2} => ${form3}',
        fr: '${form1} => ${form2} => ${form3}',
        ja: '${form1} => ${form2} => ${form3}',
        cn: '${form1} => ${form2} => ${form3}',
        ko: '${form1} => ${form2} => ${form3}'
      },
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      inside: outputs/* default.in */.Z["in"],
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'Thaleia Eulogia the Whorl',
    type: 'StartsUsing',
    netRegex: {
      id: '8A2F',
      source: 'Eulogia',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'Thaleia Eulogia Love\'s Light',
    type: 'StartsUsing',
    netRegex: {
      id: '8A30',
      source: 'Eulogia',
      capture: false
    },
    durationSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Start from the bright moon',
        de: 'Starte vom hellen Mond',
        fr: 'Commencez depuis la lune pleine',
        ja: '明るい月から',
        cn: '从亮月亮开始',
        ko: '밝은 달부터 시작'
      }
    }
  }, {
    id: 'Thaleia Eulogia Hydrostasis',
    type: 'StartsUsing',
    netRegex: {
      id: '8A37',
      source: 'Eulogia',
      capture: false
    },
    durationSeconds: 13,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '3 => 1 => 2',
        de: '3 => 1 => 2',
        fr: '3 -> 1 -> 2',
        ja: '3 => 1 => 2',
        cn: '3 => 1 => 2',
        ko: '3 => 1 => 2'
      }
    }
  }, {
    id: 'Thaleia Eulogia Hieroglyphika',
    type: 'StartsUsing',
    netRegex: {
      id: '8A43',
      source: 'Eulogia',
      capture: false
    },
    durationSeconds: 20,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to rotated safe zone',
        de: 'Geh in den sicheren Bereich',
        fr: 'Allez dans une zone sûre après rotation',
        ja: '安置へ移動',
        // FIXME
        cn: '去旋转后的安全区',
        ko: '회전한 뒤의 안전 지대로 가기'
      }
    }
  }, {
    id: 'Thaleia Eulogia Hand of the Destroyer Red',
    type: 'StartsUsing',
    netRegex: {
      id: '8A47',
      source: 'Eulogia',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Be on blue half',
        de: 'Geh zur blauen Seite',
        fr: 'Placez-vous sur la moitié bleue',
        ja: '青い安置',
        cn: '站蓝色半场',
        ko: '파란색 쪽으로'
      }
    }
  }, {
    id: 'Thaleia Eulogia Hand of the Destroyer Blue',
    type: 'StartsUsing',
    netRegex: {
      id: '8A48',
      source: 'Eulogia',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Be on red half',
        de: 'Geh zur roten Seite',
        fr: 'Placez-vous sur la moitié rouge',
        ja: '赤い安置',
        cn: '站红色半场',
        ko: '빨간색 쪽으로'
      }
    }
  }, {
    id: 'Thaleia Eulogia Torrential Tridents',
    type: 'StartsUsing',
    netRegex: {
      id: '8A4E',
      source: 'Eulogia',
      capture: false
    },
    durationSeconds: 8,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Last trident => 1st trident',
        de: 'Letzer Dreizack => erster Dreizack',
        fr: 'Dernier trident -> 1er trident',
        ja: '最後の槍 => 1番目の槍へ',
        cn: '最后一个三叉戟 => 第一个三叉戟',
        ko: '마지막 창 => 1번째 창으로'
      }
    }
  }, {
    id: 'Thaleia Eulogia Destructive Bolt',
    type: 'StartsUsing',
    netRegex: {
      id: '8CFD',
      source: 'Eulogia'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Thaleia Eulogia Byregot\'s Strike',
    type: 'StartsUsing',
    netRegex: {
      id: '8A52',
      source: 'Eulogia',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback (with lightning)',
        de: 'Rückstoß (mit Blitzen)',
        fr: 'Poussée (avec éclair)',
        ja: 'ノックバック (雷)',
        cn: '击退 (带闪电)',
        ko: '넉백 (번개 장판)'
      }
    }
  }, {
    id: 'Thaleia Eulogia Thousandfold Thrust',
    type: 'HeadMarker',
    netRegex: {
      id: ['0182', '0183', '0184', '0185'],
      target: 'Eulogia'
    },
    alertText: (_data, matches, output) => {
      return {
        '0182': output.back(),
        '0183': output.front(),
        '0184': output.left(),
        '0185': output.right()
      }[matches.id];
    },
    outputStrings: {
      front: outputs/* default.front */.Z.front,
      back: outputs/* default.back */.Z.back,
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'Thaleia Eulogia As Above So Below',
    type: 'StartsUsing',
    netRegex: {
      id: ['8A5B', '8A5C'],
      source: 'Eulogia'
    },
    infoText: (_data, matches, output) => {
      if (matches.id === '8A5B') return output.red();
      return output.blue();
    },
    outputStrings: {
      red: {
        en: 'Blue is safe',
        de: 'Blau ist sicher',
        fr: 'Le bleu est sûr',
        ja: '青安置',
        cn: '蓝色安全',
        ko: '파랑이 안전'
      },
      blue: {
        en: 'Red is safe',
        de: 'Rot ist sicher',
        fr: 'Le rouge est sûr',
        ja: '赤安置',
        cn: '橙色安全',
        ko: '빨강이 안전'
      }
    }
  }, {
    id: 'Thaleia Eulogia Climbing Shot',
    type: 'StartsUsing',
    netRegex: {
      id: '8D0B',
      source: 'Eulogia',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Thaleia Eulogia Soaring Minuet',
    type: 'StartsUsing',
    netRegex: {
      id: '8A69',
      source: 'Eulogia',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Thaleia Eulogia Eudaimon Eorzea',
    type: 'StartsUsing',
    netRegex: {
      id: '8A2C',
      source: 'Eulogia',
      capture: false
    },
    durationSeconds: 18,
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Blueblossoms/Giltblossoms': 'Blue/Giltblossoms',
      'Left Bank/Right Bank': 'Left/Right Bank',
      'Left Strait/Right Strait': 'Left/Right Strait',
      'Right Bank/Left Bank': 'Right/Left Bank'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Eulogia': 'Eulogia',
      'Llymlaen(?!\')': 'Llymlaen',
      'Oschon(?!\')': 'Oschon',
      'Oschon\'s Avatar': 'Oschons Abbild',
      'Perykos': 'Perykos',
      'Thalaos': 'Thalaos',
      'Thaliak(?!\')': 'Thaliak'
    },
    'replaceText': {
      'Altitude': 'Höhenlage',
      'Arrow Trail': 'Pfeilschweif',
      'As Above, So Below': 'Flamme von Leben und Tod',
      'Blueblossoms': 'Blaublüten',
      'Byregot\'s Strike': 'Byregots Schlag',
      'Climbing Shot': 'Aufsteigender Schuss',
      'Dawn of Time': 'Himmlischer Blitz',
      'Deep Dive': 'Tiefes Eintauchen',
      'Denizens of the Deep': 'Bewohner der Tiefe',
      'Destructive Bolt': 'Zerstörerischer Blitzschlag',
      'Dire Straits': 'Beidseitige Säuberung',
      'Downhill': 'Regenguss',
      'Eudaimon Eorzea': 'Eudaimon Eorzea',
      'First Blush': 'Lunarer Schuss',
      'First Form': 'Primärhaltung',
      'Flinted Foehn': 'Föhnpfeil',
      'Full Bright': 'Voller Glanz',
      'Giltblossoms': 'Goldblüten',
      'Godsbane': 'Göttliche Geißel',
      'Great Whirlwind': 'Windhose',
      'Hand of the Destroyer': 'Vernichtungsschlag des Zerstörers',
      'Hard Water': 'Reißendes Wasser',
      'Hieroglyphika': 'Hieroglyphen',
      'Hydroptosis': 'Hydroptose',
      'Hydrostasis': 'Hydrostase',
      'Katarraktes': 'Katarakt',
      'Landing': 'Schnelle Landung',
      'Left Bank': 'Linkes Ufer',
      'Left Strait': 'Linkes Fahrwasser',
      'Lightning Bolt': 'Keraunisches Feld',
      'Lofty Peaks': 'Orogenese',
      'Love\'s Light': 'Licht der Liebe',
      'Maelstrom': 'Mahlstrom',
      'Matron\'s Breath': 'Nophicas Atem',
      'Moving Mountains': 'Tektonisches Beben',
      'Navigator\'s Trident': 'Llymlaens Dreizack',
      'Peak Peril': 'Tektonische Turbulenz',
      'Piton Pull': 'Hakengriff',
      'Quintessence': 'Kriegerischer Übermut',
      'Radiant Finish': 'Letzter Fächertanz',
      'Radiant Rhythm': 'Fächertanz',
      'Reproduce': 'Teilung des Selbsts',
      'Rheognosis(?! Petrine)': 'Rheognose',
      'Rheognosis Petrine': 'Rheognose Petros',
      'Rhyton': 'Rhyton',
      'Right Bank': 'Rechtes Ufer',
      'Right Strait': 'Rechtes Fahrwasser',
      'Seafoam Spiral': 'Kreisförmige Welle',
      'Second Form': 'Sekundärhaltung',
      'Serpents\' Tide': 'Schlangenflut',
      'Shockwave': 'Schockwelle',
      'Soaring Minuet': 'Pfeil des Wanderers',
      'Solar Fans': 'Fächerschneide',
      'Stormwhorl': 'Meerestornado',
      'Stormwinds': 'Meerestornado',
      'Stormy Seas': 'Stürmische See',
      'Sudden Downpour': 'Platzregen',
      'Sunbeam': 'Sonnenstrahl',
      'Surging Wave': 'Wellenstoß',
      'Swinging Draw': 'Schweifender Pfeil',
      'Tempest': 'Schwerer Sturm',
      'Tetraktuos Kosmos': 'Tetraktuos Kosmos',
      'Tetraktys': 'Tetraktuos',
      'The Arrow': 'Oschons Pfeil',
      'The Builder\'s Art': 'Byregots göttliche Macht',
      'The Destroyer\'s Might': 'Rhalghrs göttliche Macht',
      'The Fury\'s Ambition': 'Halones göttliche Macht',
      'The Keeper\'s Gravity': 'Althyks göttliche Macht',
      'The Lover\'s Devotion': 'Menphinas göttliche Macht',
      'The Matron\'s Plenty': 'Nophicas göttliche Macht',
      'The Navigator\'s Command': 'Llymlaens göttliche Macht',
      'The Scholar\'s Wisdom': 'Thaliaks göttliche Macht',
      'The Spinner\'s Cunning': 'Nymeias göttliche Macht',
      'The Traders\' Equity': 'Nald\'thals göttliche Macht',
      'The Wanderer\'s Whimsy': 'Oschons göttliche Macht',
      'The Warden\'s Radiance': 'Azeymas göttliche Macht',
      'The Whorl': 'Göttlicher Schöpfungswirbel',
      'Third Form': 'Tertiärhaltung',
      'Thlipsis': 'Drangsal',
      'Thousandfold Thrust': 'Tausendfacher Stoß',
      'Time and Tide': 'Zeit und Gezeiten',
      'To the Last': 'Endlose Wellen',
      'Torrential Tridents': 'Himmlische Harpunen',
      'Trek Shot': 'Langsamer Pfeil',
      'Wandering Shot': 'Umherschweifender Schuss',
      'Wandering Volley': 'Streifschüsse',
      'Wind Rose': 'Kreisförmiger Wirbel'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Eulogia': 'Eulogie',
      'Llymlaen(?!\')': 'Llymlaen',
      'Oschon(?!\')': 'Oschon',
      'Oschon\'s Avatar': 'double d\'Oschon',
      'Perykos': 'Pérykos',
      'Thalaos': 'Thalaos',
      'Thaliak(?!\')': 'Thaliak'
    },
    'replaceText': {
      'Altitude': 'Altitude',
      'Arrow Trail': 'Traînées de flèches',
      'As Above, So Below': 'Flamme de vie, flamme de mort',
      'Blueblossoms': 'Pétales d\'azur',
      'Byregot\'s Strike': 'Foreuse de Byregot',
      'Climbing Shot': 'Tir ascendant',
      'Dawn of Time': 'Éclair céleste',
      'Deep Dive': 'Noyade abyssale',
      'Denizens of the Deep': 'Appel des serpents marins',
      'Destructive Bolt': 'Foudre destructrice',
      'Dire Straits': 'Éradication totale',
      'Downhill': 'Averse pénétrante',
      'Eudaimon Eorzea': 'Eudémon éorzéen',
      'First Blush': 'Scintillement sélénien',
      'First Form': 'Posture primaire',
      'Flinted Foehn': 'Flèches de foehn',
      'Full Bright': 'Nuit de pleine lune',
      'Giltblossoms': 'Pétales dorés',
      'Godsbane': 'Fléau divin',
      'Great Whirlwind': 'Grand tourbillon',
      'Hand of the Destroyer': 'Main du Destructeur',
      'Hard Water': 'Oppression aqueuse',
      'Hieroglyphika': 'Hiéroglyphe',
      'Hydroptosis': 'Hydroptôse',
      'Hydrostasis': 'Hydrostase',
      'Katarraktes': 'Cataracte',
      'Landing': 'Atterrissage rapide',
      'Left Bank': 'Débordement rive gauche',
      'Left Strait': 'Éradication à bâbord',
      'Lightning Bolt': 'Éclair de foudre',
      'Lofty Peaks': 'Orogenèse',
      'Love\'s Light': 'Brillance de l\'amour',
      'Maelstrom': 'Maelström',
      'Matron\'s Breath': 'Souffle de la Mère',
      'Moving Mountains': 'Secousse tectonique',
      'Navigator\'s Trident': 'Trident de Llymlaen',
      'Peak Peril': 'Turbulence tectonique',
      'Piton Pull': 'Arrachement de pitons',
      'Quintessence': 'Exaltation guerrière',
      'Radiant Finish': 'Final enflammé',
      'Radiant Rhythm': 'Rythme enflammé',
      'Reproduce': 'Clonage',
      'Rheognosis(?! Petrine)': 'Leonosis',
      'Rheognosis Petrine': 'Leonosis petros',
      'Rhyton': 'Rhyton',
      'Right Bank': 'Débordement rive droite',
      'Right Strait': 'Éradication à tribord',
      'Seafoam Spiral': 'Vague circulaire',
      'Second Form': 'Posture secondaire',
      'Serpents\' Tide': 'Ruée serpentine',
      'Shockwave': 'Onde de choc',
      'Soaring Minuet': 'Flèche du menuet',
      'Solar Fans': 'Éventails solaires',
      'Stormwhorl': 'Tornade marine',
      'Stormwinds': 'Brise marine',
      'Stormy Seas': 'Déchaînement marin',
      'Sudden Downpour': 'Déluge dru',
      'Sunbeam': 'Rayon de soleil',
      'Surging Wave': 'Transperce-vague',
      'Swinging Draw': 'Tir oscillant',
      'Tempest': 'Grande tempête',
      'Tetraktuos Kosmos': 'Tetractys cosmos',
      'Tetraktys': 'Tetractys',
      'The Arrow': 'Flèche d\'Oschon',
      'The Builder\'s Art': 'Pouvoir divin de Byregot',
      'The Destroyer\'s Might': 'Pouvoir divin de Rhalgr',
      'The Fury\'s Ambition': 'Pouvoir divin de Halone',
      'The Keeper\'s Gravity': 'Pouvoir divin d\'Althyk',
      'The Lover\'s Devotion': 'Pouvoir divin de Menphina',
      'The Matron\'s Plenty': 'Pouvoir divin de Nophica',
      'The Navigator\'s Command': 'Pouvoir divin de Llymlaen',
      'The Scholar\'s Wisdom': 'Pouvoir divin de Thaliak',
      'The Spinner\'s Cunning': 'Pouvoir divin de Nymeia',
      'The Traders\' Equity': 'Pouvoir divin de Nald\'thal',
      'The Wanderer\'s Whimsy': 'Pouvoir divin d\'Oschon',
      'The Warden\'s Radiance': 'Pouvoir divin d\'Azeyma',
      'The Whorl': 'Vortex génésiaque',
      'Third Form': 'Posture tertiaire',
      'Thlipsis': 'Tribulation',
      'Thousandfold Thrust': 'Transpercement millénaire',
      'Time and Tide': 'Manipulation temporelle',
      'To the Last': 'Vagues infinies',
      'Torrential Tridents': 'Pluie de tridents',
      'Trek Shot': 'Flèches languissantes',
      'Wandering Shot': 'Tir errant',
      'Wandering Volley': 'Tir de barrage errant',
      'Wind Rose': 'Bourrasque circulaire'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Eulogia': 'エウロギア',
      'Llymlaen(?!\')': 'リムレーン',
      'Oschon(?!\')': 'オシュオン',
      'Oschon\'s Avatar': 'オシュオンの分体',
      'Perykos': 'ペリュコス',
      'Thalaos': 'サラオス',
      'Thaliak(?!\')': 'サリャク'
    },
    'replaceText': {
      'Altitude': 'アルティチュード',
      'Arrow Trail': 'アロートレイル',
      'As Above, So Below': '死生択一の炎',
      'Blueblossoms': '青花散',
      'Byregot\'s Strike': 'ビエルゴズ・ストライク',
      'Climbing Shot': 'クライムシュート',
      'Dawn of Time': '星天極光',
      'Deep Dive': '海淵落とし',
      'Denizens of the Deep': '海蛇招来',
      'Destructive Bolt': '壊雷撃',
      'Dire Straits': '両舷掃討',
      'Downhill': 'ダウンヒル',
      'Eudaimon Eorzea': 'エウダイモン・エオルゼア',
      'First Blush': '月閃',
      'First Form': '壱の構え',
      'Flinted Foehn': 'フェーンアロー',
      'Full Bright': '月夜の巡り',
      'Giltblossoms': '黄花散',
      'Godsbane': 'ゴッズベーン',
      'Great Whirlwind': '大旋風',
      'Hand of the Destroyer': '壊神創幻撃',
      'Hard Water': '重水塊',
      'Hieroglyphika': 'ヒエログリュフィカ',
      'Hydroptosis': 'ヒュドルピトシス',
      'Hydrostasis': 'ヒュドルスタシス',
      'Katarraktes': 'カタラクティス',
      'Landing': '落着',
      'Left Bank': '左岸氾濫',
      'Left Strait': '左舷掃討',
      'Lightning Bolt': '落雷',
      'Lofty Peaks': '風天の霊峰',
      'Love\'s Light': '慈愛の月',
      'Maelstrom': 'メイルシュトローム',
      'Matron\'s Breath': '豊穣の息吹',
      'Moving Mountains': '造山振動',
      'Navigator\'s Trident': 'リムレーンズトライデント',
      'Peak Peril': '造山乱流',
      'Piton Pull': 'ハーケンブリング',
      'Quintessence': '武気発揚',
      'Radiant Finish': '焔扇流舞・終炎',
      'Radiant Rhythm': '焔扇流舞',
      'Reproduce': '分体生成',
      'Rheognosis(?! Petrine)': 'レーオノシス',
      'Rheognosis Petrine': 'レーオノシス・ペトゥロス',
      'Rhyton': 'リュトン',
      'Right Bank': '右岸氾濫',
      'Right Strait': '右舷掃討',
      'Seafoam Spiral': '輪の波浪',
      'Second Form': '弐の構え',
      'Serpents\' Tide': '海蛇の進撃',
      'Shockwave': '衝撃波',
      'Soaring Minuet': 'メヌエットアロー',
      'Solar Fans': '紅炎扇刃',
      'Stormwhorl': '時化の渦風',
      'Stormwinds': '時化の潮風',
      'Stormy Seas': '大時化起こし',
      'Sudden Downpour': 'ダウンポール',
      'Sunbeam': '太陽光',
      'Surging Wave': '波穿ち',
      'Swinging Draw': 'スイングアロー',
      'Tempest': '大海嵐',
      'Tetraktuos Kosmos': 'テトラクテュス・コスモス',
      'Tetraktys': 'テトラクテュス',
      'The Arrow': 'オシュオンの矢',
      'The Builder\'s Art': 'ビエルゴの神力',
      'The Destroyer\'s Might': 'ラールガーの神力',
      'The Fury\'s Ambition': 'ハルオーネの神力',
      'The Keeper\'s Gravity': 'アルジクの神力',
      'The Lover\'s Devotion': 'メネフィナの神力',
      'The Matron\'s Plenty': 'ノフィカの神力',
      'The Navigator\'s Command': 'リムレーンの神力',
      'The Scholar\'s Wisdom': 'サリャクの神力',
      'The Spinner\'s Cunning': 'ニメーヤの神力',
      'The Traders\' Equity': 'ナルザルの神力',
      'The Wanderer\'s Whimsy': 'オシュオンの神力',
      'The Warden\'s Radiance': 'アーゼマの神力',
      'The Whorl': '創世の神渦',
      'Third Form': '参の構え',
      'Thlipsis': 'スリプシス',
      'Thousandfold Thrust': 'サウザンスラスト',
      'Time and Tide': '時間操作',
      'To the Last': '千波万波',
      'Torrential Tridents': '銛の雨',
      'Trek Shot': 'トレックアロー',
      'Wandering Shot': 'ワンダリングショット',
      'Wandering Volley': 'ワンダリングバラージ',
      'Wind Rose': '円の旋風'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Eulogia': '欧罗基亚',
      'Llymlaen(?!\')': '利姆莱茵',
      'Oschon(?!\')': '奥修昂',
      'Oschon\'s Avatar': '奥修昂的分身',
      'Perykos': '珀琉喀斯',
      'Thalaos': '撒拉奥斯',
      'Thaliak(?!\')': '沙利亚克'
    },
    'replaceText': {
      'Altitude': '高空箭雨',
      'Arrow Trail': '箭踪',
      'As Above, So Below': '生死抉择之炎',
      'Blueblossoms': '蓝花飞散',
      'Byregot\'s Strike': '工艺神击',
      'Climbing Shot': '攀跃射击',
      'Dawn of Time': '星天极光',
      'Deep Dive': '坠海渊',
      'Denizens of the Deep': '召唤海蛇',
      'Destructive Bolt': '坏灭雷击',
      'Dire Straits': '两舷横扫',
      'Downhill': '落山箭',
      'Eudaimon Eorzea': '福润艾欧泽亚',
      'First Blush': '月闪',
      'First Form': '壹之体势',
      'Flinted Foehn': '焚风箭',
      'Full Bright': '月夜巡游',
      'Giltblossoms': '黄花飞散',
      'Godsbane': '神祸',
      'Great Whirlwind': '大龙卷风',
      'Hand of the Destroyer': '幻天破坏拳',
      'Hard Water': '重水块',
      'Hieroglyphika': '圣书体',
      'Hydroptosis': '水之倾泻',
      'Hydrostasis': '水之停滞',
      'Katarraktes': '飞瀑',
      'Landing': '落地',
      'Left Bank': '左岸泛滥',
      'Left Strait': '左舷横扫',
      'Lightning Bolt': '落雷',
      'Lofty Peaks': '风天灵峰',
      'Love\'s Light': '慈爱的月亮',
      'Maelstrom': '巨旋涡',
      'Matron\'s Breath': '丰饶的吐息',
      'Moving Mountains': '造山震动',
      'Navigator\'s Trident': '海洋女神的尖枪',
      'Peak Peril': '造山乱流',
      'Piton Pull': '拔拽绳钩',
      'Quintessence': '武意高昂',
      'Radiant Finish': '炎扇流舞·终炎',
      'Radiant Rhythm': '炎扇流舞',
      'Reproduce': '生成分裂体',
      'Rheognosis(?! Petrine)': '知识的激流',
      'Rheognosis Petrine': '知识的激流·滚岩',
      'Rhyton': '流动',
      'Right Bank': '右岸泛滥',
      'Right Strait': '右舷横扫',
      'Seafoam Spiral': '海浪回环',
      'Second Form': '贰之体势',
      'Serpents\' Tide': '海蛇突进',
      'Shockwave': '冲击波',
      'Soaring Minuet': '小步舞箭',
      'Solar Fans': '红炎扇刃',
      'Stormwhorl': '暴雨涡风',
      'Stormwinds': '暴雨潮风',
      'Stormy Seas': '召唤大暴风雨',
      'Sudden Downpour': '暴雨箭',
      'Sunbeam': '太阳光',
      'Surging Wave': '破浪',
      'Swinging Draw': '摇荡射击',
      'Tempest': '大暴风',
      'Tetraktuos Kosmos': '圣十结构·秩序',
      'Tetraktys': '圣十结构',
      'The Arrow': '放浪神之箭',
      'The Builder\'s Art': '比尔格之技艺',
      'The Destroyer\'s Might': '拉尔戈之威能',
      'The Fury\'s Ambition': '哈罗妮之壮志',
      'The Keeper\'s Gravity': '阿尔基克之重力',
      'The Lover\'s Devotion': '梅茵菲娜之慈爱',
      'The Matron\'s Plenty': '诺菲卡之丰饶',
      'The Navigator\'s Command': '莉姆莱茵之敕令',
      'The Scholar\'s Wisdom': '沙利亚克之灵慧',
      'The Spinner\'s Cunning': '妮美雅之精巧',
      'The Traders\' Equity': '纳尔札尔之公正',
      'The Wanderer\'s Whimsy': '奥修昂之离奇',
      'The Warden\'s Radiance': '阿泽玛之光辉',
      'The Whorl': '创世神涡',
      'Third Form': '叁之体势',
      'Thlipsis': '磨难',
      'Thousandfold Thrust': '千枪连刺',
      'Time and Tide': '时间操纵',
      'To the Last': '怒涛滚滚',
      'Torrential Tridents': '尖枪雨',
      'Trek Shot': '撤步射击',
      'Wandering Shot': '放浪射击',
      'Wandering Volley': '放浪群射',
      'Wind Rose': '狂风旋圆'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Eulogia': '에울로기아',
      'Llymlaen(?!\')': '리믈렌',
      'Oschon(?!\')': '오쉬온',
      'Oschon\'s Avatar': '오쉬온의 분신',
      'Perykos': '페뤼코스',
      'Thalaos': '살라오스의 유해',
      'Thaliak(?!\')': '살리아크'
    },
    'replaceText': {
      'Altitude': '해발고도',
      'Arrow Trail': '화살 둘레길',
      'As Above, So Below': '생사택일의 화염',
      'Blueblossoms': '푸른꽃 만발',
      'Byregot\'s Strike': '비레고의 강타',
      'Climbing Shot': '등반 사격',
      'Dawn of Time': '성천극광',
      'Deep Dive': '해연 강하',
      'Denizens of the Deep': '바다뱀 소환',
      'Destructive Bolt': '파괴번개 일격',
      'Dire Straits': '양현 소탕',
      'Downhill': '내리막',
      'Eudaimon Eorzea': '에우다이몬 에오르제아',
      'First Blush': '달의 섬광',
      'First Form': '첫 번째 태세',
      'Flinted Foehn': '높새바람 화살',
      'Full Bright': '환한 달밤',
      'Giltblossoms': '노란꽃 만발',
      'Godsbane': '신의 재앙',
      'Great Whirlwind': '대선풍',
      'Hand of the Destroyer': '파괴신 창환격',
      'Hard Water': '무거운 물덩어리',
      'Hieroglyphika': '신성문자',
      'Hydroptosis': '쏟아지는 물',
      'Hydrostasis': '우뚝 선 물',
      'Katarraktes': '홍수',
      'Landing': '발착장',
      'Left Bank': '좌측 범람',
      'Left Strait': '좌현 소탕',
      'Lightning Bolt': '낙뢰',
      'Lofty Peaks': '풍천의 영봉',
      'Love\'s Light': '자애로운 달',
      'Maelstrom': '흑와 투기장',
      'Matron\'s Breath': '풍요의 숨결',
      'Moving Mountains': '조산 진동',
      'Navigator\'s Trident': '리믈렌의 삼지창',
      'Peak Peril': '조산 난류',
      'Piton Pull': '갈고리 당기기',
      'Quintessence': '투기 발양',
      'Radiant Finish': '불부채춤 마무리',
      'Radiant Rhythm': '불부채춤',
      'Reproduce': '분신 생성',
      'Rheognosis(?! Petrine)': '지식의 격류',
      'Rheognosis Petrine': '지식의 격류: 물바위',
      'Rhyton': '유동',
      'Right Bank': '우측 범람',
      'Right Strait': '우현 소탕',
      'Seafoam Spiral': '외곽 물너울',
      'Second Form': '두 번째 태세',
      'Serpents\' Tide': '바다뱀 진격',
      'Shockwave': '충격파',
      'Soaring Minuet': '무곡 화살',
      'Solar Fans': '홍염 부채칼',
      'Stormwhorl': '풍파의 회오리바람',
      'Stormwinds': '풍파의 바닷바람',
      'Stormy Seas': '대풍파 일으키기',
      'Sudden Downpour': '화살 폭우',
      'Sunbeam': '태양광',
      'Surging Wave': '파도 꿰뚫기',
      'Swinging Draw': '순회 화살',
      'Tempest': '대해풍',
      'Tetraktuos Kosmos': '테트락티스 코스모스',
      'Tetraktys': '테트락티스',
      'The Arrow': '오쉬온의 화살',
      'The Builder\'s Art': '비레고의 신력',
      'The Destroyer\'s Might': '랄거의 신력',
      'The Fury\'s Ambition': '할로네의 신력',
      'The Keeper\'s Gravity': '알디크의 신력',
      'The Lover\'s Devotion': '메느피나의 신력',
      'The Matron\'s Plenty': '노피카의 신력',
      'The Navigator\'s Command': '리믈렌의 신력',
      'The Scholar\'s Wisdom': '살리아크의 신력',
      'The Spinner\'s Cunning': '니메이아의 신력',
      'The Traders\' Equity': '날달의 신력',
      'The Wanderer\'s Whimsy': '오쉬온의 신력',
      'The Warden\'s Radiance': '아제마의 신력',
      'The Whorl': '창세의 소용돌이',
      'Third Form': '세 번째 태세',
      'Thlipsis': '고난',
      'Thousandfold Thrust': '천 갈래 찌르기',
      'Time and Tide': '시간 조작',
      'To the Last': '천파만파',
      'Torrential Tridents': '작살비',
      'Trek Shot': '유람 화살',
      'Wandering Shot': '방랑 사격',
      'Wandering Volley': '방랑 일제 사격',
      'Wind Rose': '내곽 회오리'
    }
  }]
};
/* harmony default export */ const thaleia = (thaleia_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/alliance/thaleia.txt
const alliance_thaleia_namespaceObject = "# Thaleia\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~#\r\n# Thaliak #\r\n#~~~~~~~~~#\r\n\r\n# -p 88D1:1010\r\n# -ii 88DA 88D9 88D5 88D7 88CE 88C8\r\n# Long pull: https://www.fflogs.com/reports/a:ZBxnrKWpPfdt2gCV#fight=11&type=damage-done\r\n\r\n# The River of Knowledge will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1169\" } window 10000,0\r\n1005.0 \"--sync--\" StartsUsing { id: \"88D1\", source: \"Thaliak\" } window 10,10\r\n1010.0 \"Katarraktes\" Ability { id: \"88D1\", source: \"Thaliak\" }\r\n\r\n1016.1 \"--middle--\" Ability { id: \"88DB\", source: \"Thaliak\" }\r\n1023.4 \"Rheognosis (cast)\" Ability { id: \"88C4\", source: \"Thaliak\" }\r\n1029.5 \"--sync--\" Ability { id: \"88C6\", source: \"Thaliak\" }\r\n1043.6 \"Rheognosis\" Ability { id: \"88C7\", source: \"Thaliak\" }\r\n\r\n1051.6 \"Thlipsis\" Ability { id: \"88D8\", source: \"Thaliak\" }\r\n\r\n1059.7 \"--middle--\" Ability { id: \"88DB\", source: \"Thaliak\" }\r\n1067.0 \"Left Bank/Right Bank\" Ability { id: [\"88D2\", \"88D3\"], source: \"Thaliak\" }\r\n1074.1 \"Right Bank/Left Bank\" Ability { id: [\"88D3\", \"88D2\"], source: \"Thaliak\" }\r\n\r\n1080.2 \"Hydroptosis\" Ability { id: \"88D4\", source: \"Thaliak\" }\r\n\r\n1092.3 \"Rhyton\" Ability { id: \"88D6\", source: \"Thaliak\" }\r\n\r\n1099.5 \"--middle--\" Ability { id: \"88DB\", source: \"Thaliak\" }\r\n1107.8 \"Tetraktys (cast)\" Ability { id: \"88C9\", source: \"Thaliak\" }\r\n1115.8 \"Tetraktys 1\" Ability { id: \"88CA\", source: \"Thaliak\" }\r\n1118.4 \"Tetraktys 2\" #Ability { id: \"88CA\", source: \"Thaliak\" }\r\n1120.8 \"Tetraktys 3\" #Ability { id: \"88CA\", source: \"Thaliak\" }\r\n1123.2 \"Tetraktys 4\" #Ability { id: \"88CB\", source: \"Thaliak\" }\r\n1125.6 \"Tetraktys 5 \" #Ability { id: \"88CB\", source: \"Thaliak\" }\r\n1128.0 \"Tetraktys 6\" #Ability { id: \"88CB\", source: \"Thaliak\" }\r\n1133.9 \"Tetraktuos Kosmos 1 (cast)\" Ability { id: \"88CC\", source: \"Thaliak\" }\r\n1142.8 \"Tetraktuos Kosmos 1\" Ability { id: \"88CD\", source: \"Thaliak\" }\r\n1145.1 \"Tetraktuos Kosmos 2 (cast)\" Ability { id: \"88CC\", source: \"Thaliak\" }\r\n1154.0 \"Tetraktuos Kosmos 2\" Ability { id: \"88CD\", source: \"Thaliak\" }\r\n\r\n1164.3 \"--middle--\" Ability { id: \"88DB\", source: \"Thaliak\" }\r\n1171.5 \"Rheognosis Petrine\" Ability { id: \"88C5\", source: \"Thaliak\" }\r\n1177.6 \"--sync--\" Ability { id: \"88C6\", source: \"Thaliak\" }\r\n1191.7 \"Rheognosis\" Ability { id: \"88C7\", source: \"Thaliak\" }\r\n\r\n1197.7 \"--middle--\" Ability { id: \"88DB\", source: \"Thaliak\" }\r\n1205.1 \"Hieroglyphika 1\" Ability { id: \"88CF\", source: \"Thaliak\" }\r\n1225.1 \"--sync--\" Ability { id: \"88D0\", source: \"Thaliak\" }\r\n1234.5 \"Hieroglyphika 2\" Ability { id: \"88CF\", source: \"Thaliak\" }\r\n1254.5 \"--sync--\" Ability { id: \"88D0\", source: \"Thaliak\" }\r\n1258.6 \"Left Bank/Right Bank\" Ability { id: [\"8C2C\", \"8C2D\"], source: \"Thaliak\" }\r\n\r\n1264.7 \"--middle--\" Ability { id: \"88DB\", source: \"Thaliak\" }\r\n1272.9 label \"thaliak-loop\"\r\n1272.9 \"Tetraktys (cast)\" Ability { id: \"88C9\", source: \"Thaliak\" }\r\n1280.9 \"Tetraktys 1\" Ability { id: \"88CA\", source: \"Thaliak\" }\r\n1283.5 \"Tetraktys 2\" #Ability { id: \"88CA\", source: \"Thaliak\" }\r\n1285.9 \"Tetraktys 3\" #Ability { id: \"88CA\", source: \"Thaliak\" }\r\n1288.3 \"Tetraktys 4\" #Ability { id: \"88CB\", source: \"Thaliak\" }\r\n1290.7 \"Tetraktys 5\" #Ability { id: \"88CB\", source: \"Thaliak\" }\r\n1293.1 \"Tetraktys 6\" #Ability { id: \"88CB\", source: \"Thaliak\" }\r\n\r\n1297.1 \"Tetraktuos Kosmos 1 (cast)\" Ability { id: \"88CC\", source: \"Thaliak\" }\r\n1306.0 \"Tetraktuos Kosmos 1\" Ability { id: \"88CD\", source: \"Thaliak\" }\r\n1308.3 \"Tetraktuos Kosmos 2 (cast)\" Ability { id: \"88CC\", source: \"Thaliak\" }\r\n1317.2 \"Tetraktuos Kosmos 2\" Ability { id: \"88CD\", source: \"Thaliak\" }\r\n\r\n1331.6 \"Rhyton\" Ability { id: \"88D6\", source: \"Thaliak\" }\r\n\r\n1337.7 \"--middle--\" Ability { id: \"88DB\", source: \"Thaliak\" }\r\n1344.9 \"Rheognosis Petrine\" Ability { id: \"88C5\", source: \"Thaliak\" }\r\n1351.0 \"--sync--\" Ability { id: \"88C6\", source: \"Thaliak\" }\r\n1365.1 \"Rheognosis\" Ability { id: \"88C7\", source: \"Thaliak\" }\r\n\r\n1373.1 \"Thlipsis\" Ability { id: \"88D8\", source: \"Thaliak\" }\r\n\r\n1379.2 \"--middle--\" Ability { id: \"88DB\", source: \"Thaliak\" }\r\n1386.5 \"Hieroglyphika\" Ability { id: \"88CF\", source: \"Thaliak\" }\r\n1406.5 \"--sync--\" Ability { id: \"88D0\", source: \"Thaliak\" }\r\n1410.5 \"Left Bank/Right Bank\" Ability { id: [\"8C2C\", \"8C2D\"], source: \"Thaliak\" }\r\n\r\n1416.6 \"Hydroptosis\" Ability { id: \"88D4\", source: \"Thaliak\" }\r\n1427.7 \"Katarraktes\" Ability { id: \"88D1\", source: \"Thaliak\" }\r\n\r\n1433.9 \"--middle--\" Ability { id: \"88DB\", source: \"Thaliak\" }\r\n1442.1 \"Tetraktys (cast)\" Ability { id: \"88C9\", source: \"Thaliak\" } window 40,40 forcejump \"thaliak-loop\"\r\n\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 88C4 Rheognosis self-targeted cast to summon clone for knockback\r\n# 88C5 Rheognosis Petrine self-targeted cast to summon clone for knockback\r\n# 88C6 --sync-- clone repositioning\r\n# 88C7 Rheognosis cast and knockback from clone\r\n# 88C8 Crash damage on players from failing Rheognosis Petrine knockback\r\n# 88C9 Tetraktys self-targeted cast to bring people to the pyramid dimension\r\n# 88CA Tetraktys fast cast and damage from small blue triangle\r\n# 88CB Tetraktys fast cast and damage from large green triangle\r\n# 88CC Tetraktuos Kosmos self-targeted cast to summon triangle with falling walls\r\n# 88CD Tetraktuos Kosmos cast and damage for being hit by the falling walls\r\n# 88CE Tetraktuos Kosmos cast and damage for standing in the initial triangle with falling walls\r\n# 88CF Hieroglyphika self-targeted cast to summon rotating green squares\r\n# 88D0 Hieroglyphika cast and damage for rotated green squares\r\n# 88D1 Katarraktes self-targeted cast for raidwide bleed\r\n# 88D2 Left Bank cast and damage for 180 left cleave\r\n# 88D3 Right Bank cast and damage for 180 right cleave\r\n# 88D4 Hydroptosis self-targeted cast for spread\r\n# 88D5 Hydroptosis targeted cast and damage for spread\r\n# 88D6 Rhyton self-targeted cast for triple tankbuster lasers\r\n# 88D7 Rhyton damage for triple tankbuster lasers\r\n# 88D8 Thlipsis self-targeted cast for stack\r\n# 88D9 Thlipsis targeted cast and damage for stack\r\n# 88DA Katarraktes cast and damage for raidwide bleed\r\n# 88DB --sync-- repositioning\r\n# 88DC attack auto damage\r\n# 8C2C Left Bank cast and damage for 180 left cleave during Hieroglyphika\r\n# 8C2D Right Bank cast and damage for 180 right cleave during Hieroglyphika\r\n\r\n\r\n#~~~~~~~~~~#\r\n# Llymlaen #\r\n#~~~~~~~~~~#\r\n\r\n# -p 880B:2012.1\r\n# -ii 8CCB 8CD0 882D 880A 8813 8825 8826 8827 8822 8823 8C6C 8816 8CCD 8CCE\r\n# Long pull: https://www.fflogs.com/reports/qW8TMthAcD1JbmNk#fight=21&type=damage-done\r\n\r\n# The Briny Deep will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"116A\" } window 10000,0\r\n2007.1 \"--sync--\" StartsUsing { id: \"880B\", source: \"Llymlaen\" } window 10,10\r\n2012.1 \"Tempest\" Ability { id: \"880B\", source: \"Llymlaen\" }\r\n2023.2 \"Seafoam Spiral/Wind Rose\" Ability { id: [\"880D\", \"880C\"], source: \"Llymlaen\" }\r\n2032.3 \"Wind Rose/Seafoam Spiral\" Ability { id: [\"880C\", \"880D\"], source: \"Llymlaen\" }\r\n\r\n2041.6 \"--middle--\" Ability { id: \"8809\", source: \"Llymlaen\" }\r\n2049.4 \"Navigator's Trident\" Ability { id: \"880E\", source: \"Llymlaen\" }\r\n2050.5 \"Dire Straits 1\" #Ability { id: [\"880F\", \"8810\"], source: \"Llymlaen\" }\r\n2052.3 \"Dire Straits 2\" #Ability { id: [\"880F\", \"8810\"], source: \"Llymlaen\" }\r\n\r\n2052.7 \"--jump--\" Ability { id: \"8CCF\", source: \"Llymlaen\" }\r\n2060.9 \"Navigator's Trident\" Ability { id: \"8811\", source: \"Llymlaen\" }\r\n\r\n2064.0 \"--middle--\" Ability { id: \"8809\", source: \"Llymlaen\" }\r\n2073.0 \"Seafoam Spiral/Wind Rose\" Ability { id: [\"880D\", \"880C\"], source: \"Llymlaen\" }\r\n\r\n2084.0 \"Surging Wave\" Ability { id: \"8812\", source: \"Llymlaen\" }\r\n2085.2 \"Shockwave\" Ability { id: \"8814\", source: \"Llymlaen\" }\r\n\r\n2105.2 \"Left Strait/Right Strait\" Ability { id: [\"8851\", \"8852\"], source: \"Llymlaen\" }\r\n2113.4 \"Deep Dive\" Ability { id: \"8819\", source: \"Llymlaen\" }\r\n\r\n2122.6 \"--sync--\" StartsUsing { id: \"881A\", source: \"Llymlaen\" } window 20,20\r\n2126.6 \"Torrential Tridents\" Ability { id: \"881A\", source: \"Llymlaen\" }\r\n2129.4 \"Landing 1\" #Ability { id: \"881B\", source: \"Trident\" }\r\n2130.4 \"Landing 2\" #Ability { id: \"881B\", source: \"Trident\" }\r\n2131.4 \"Landing 3\" #Ability { id: \"881B\", source: \"Trident\" }\r\n2132.4 \"Landing 4\" #Ability { id: \"881B\", source: \"Trident\" }\r\n2133.4 \"Landing 5\" #Ability { id: \"881B\", source: \"Trident\" }\r\n2134.4 \"Landing 6\" #Ability { id: \"881B\", source: \"Trident\" }\r\n\r\n2142.4 \"Landing 1\" #Ability { id: \"881C\", source: \"Trident\" }\r\n2143.4 \"Landing 2\" #Ability { id: \"881C\", source: \"Trident\" }\r\n2144.4 \"Landing 3\" #Ability { id: \"881C\", source: \"Trident\" }\r\n2145.4 \"Landing 4\" #Ability { id: \"881C\", source: \"Trident\" }\r\n2146.4 \"Landing 5\" #Ability { id: \"881C\", source: \"Trident\" }\r\n2147.4 \"Landing 6\" #Ability { id: \"881C\", source: \"Trident\" }\r\n\r\n2147.8 \"Stormy Seas\" Ability { id: \"881D\", source: \"Llymlaen\" }\r\n2152.6 \"Stormwhorl 1\" #Ability { id: \"881E\", source: \"Llymlaen\" }\r\n2154.6 \"Stormwhorl 2\" #Ability { id: \"881E\", source: \"Llymlaen\" }\r\n2156.6 \"Stormwhorl 3\" #Ability { id: \"881E\", source: \"Llymlaen\" }\r\n2157.6 \"Stormwinds\" Ability { id: \"881F\", source: \"Llymlaen\" }\r\n\r\n2166.0 \"--jump--\" Ability { id: \"8809\", source: \"Llymlaen\" }\r\n2171.3 \"Denizens of the Deep\" Ability { id: \"8820\", source: \"Llymlaen\" }\r\n2178.2 \"--middle--\" Ability { id: \"8809\", source: \"Llymlaen\" }\r\n2185.3 \"Wind Rose\" Ability { id: \"880C\", source: \"Llymlaen\" }\r\n\r\n2185.4 \"Serpents' Tide 1\" Ability { id: [\"8828\", \"8829\"], source: \"Thalaos\" }\r\n2196.5 \"Serpents' Tide 2\" Ability { id: [\"8828\", \"8829\"], source: \"Thalaos\" }\r\n2201.3 \"  /Right Strait\" Ability { id: [\"8851\", \"8852\"], source: \"Llymlaen\" }\r\n2207.4 \"Serpents' Tide 3\" Ability { id: [\"8828\", \"8829\"], source: \"Thalaos\" }\r\n2212.0 \"Maelstrom\" Ability { id: \"882A\", source: \"Llymlaen\" }\r\n\r\n2213.3 \"--middle--\" Ability { id: \"8809\", source: \"Llymlaen\" }\r\n2217.3 \"--sync--\" Ability { id: \"8824\", source: \"Llymlaen\" }\r\n2220.3 \"Godsbane\" Ability { id: \"8821\", source: \"Llymlaen\" }\r\n\r\n2230.5 \"--middle--\" Ability { id: \"8809\", source: \"Llymlaen\" }\r\n2238.3 label \"llymlaen-loop\"\r\n2238.3 \"Navigator's Trident\" Ability { id: \"880E\", source: \"Llymlaen\" }\r\n2239.3 \"Dire Straits 1\" #Ability { id: [\"880F\", \"8810\"], source: \"Llymlaen\" }\r\n2241.1 \"Dire Straits 2\" #Ability { id: [\"880F\", \"8810\"], source: \"Llymlaen\" }\r\n\r\n# TODO: can this be 882B instead of 8CCF?\r\n2241.5 \"--jump--\" Ability { id: \"8CCF\", source: \"Llymlaen\" }\r\n2249.7 \"Navigator's Trident\" Ability { id: \"8811\", source: \"Llymlaen\" }\r\n2250.8 \"Serpents' Tide\" Ability { id: [\"8828\", \"8829\"], source: \"Thalaos\" }\r\n\r\n2252.8 \"--middle--\" Ability { id: \"8809\", source: \"Llymlaen\" }\r\n2261.8 \"Seafoam Spiral/Wind Rose\" Ability { id: [\"880D\", \"880C\"], source: \"Llymlaen\" }\r\n2272.8 \"Surging Wave\" Ability { id: \"8812\", source: \"Llymlaen\" }\r\n2274.0 \"Shockwave\" Ability { id: \"8814\", source: \"Llymlaen\" }\r\n2281.9 \"--sync--\" Ability { id: \"8815\", source: \"Llymlaen\" }\r\n2282.1 \"To the Last 1\" #Ability { id: \"8817\", source: \"Llymlaen\" }\r\n2284.1 \"To the Last 2\" #Ability { id: \"8817\", source: \"Llymlaen\" }\r\n2286.2 \"To the Last 3\" #Ability { id: \"8817\", source: \"Llymlaen\" }\r\n2294.3 \"Left Strait/Right Strait\" Ability { id: [\"8851\", \"8852\"], source: \"Llymlaen\" }\r\n\r\n2297.4 \"--middle--\" Ability { id: \"8809\", source: \"Llymlaen\" }\r\n2304.6 \"Hard Water 1\" Ability { id: \"8835\", source: \"Perykos\" }\r\n2306.6 \"Hard Water 2\" Ability { id: \"8836\", source: \"Thalaos\" }\r\n2308.5 \"Deep Dive 3\" Ability { id: \"8834\", source: \"Llymlaen\" }\r\n\r\n2314.7 \"--sync--\" StartsUsing { id: \"881A\", source: \"Llymlaen\" } window 20,20\r\n2318.7 \"Torrential Tridents\" Ability { id: \"881A\", source: \"Llymlaen\" }\r\n2321.5 \"Landing 1\" #Ability { id: \"881B\", source: \"Trident\" }\r\n2322.5 \"Landing 2\" #Ability { id: \"881B\", source: \"Trident\" }\r\n2323.5 \"Landing 3\" #Ability { id: \"881B\", source: \"Trident\" }\r\n2324.5 \"Landing 4\" #Ability { id: \"881B\", source: \"Trident\" }\r\n2325.5 \"Landing 5\" #Ability { id: \"881B\", source: \"Trident\" }\r\n2326.5 \"Landing 6\" #Ability { id: \"881B\", source: \"Trident\" }\r\n2336.5 \"Landing 1\" #Ability { id: \"881C\", source: \"Trident\" }\r\n2337.5 \"Landing 2\" #Ability { id: \"881C\", source: \"Trident\" }\r\n2338.5 \"Landing 3\" #Ability { id: \"881C\", source: \"Trident\" }\r\n2339.5 \"Landing 4\" #Ability { id: \"881C\", source: \"Trident\" }\r\n2340.5 \"Landing 5\" #Ability { id: \"881C\", source: \"Trident\" }\r\n2340.9 \"Stormy Seas\" Ability { id: \"881D\", source: \"Llymlaen\" }\r\n2341.3 \"Landing 6\" #Ability { id: \"881C\", source: \"Trident\" }\r\n2345.5 \"Stormwhorl 1\" #Ability { id: \"881E\", source: \"Llymlaen\" }\r\n2347.5 \"Stormwhorl 2\" #Ability { id: \"881E\", source: \"Llymlaen\" }\r\n2349.5 \"Stormwhorl 3\" #Ability { id: \"881E\", source: \"Llymlaen\" }\r\n2350.7 \"Stormwinds\" Ability { id: \"881F\", source: \"Llymlaen\" }\r\n\r\n2355.0 \"Serpents' Tide\" Ability { id: \"8829\", source: \"Thalaos\" }\r\n2359.6 \"Maelstrom\" Ability { id: \"882A\", source: \"Llymlaen\" }\r\n2363.9 \"Seafoam Spiral/Wind Rose\" Ability { id: [\"880D\", \"880C\"], source: \"Llymlaen\" }\r\n\r\n2366.0 \"--middle--\" Ability { id: \"8809\", source: \"Llymlaen\" }\r\n2370.0 \"--sync--\" Ability { id: \"8824\", source: \"Llymlaen\" }\r\n2373.0 \"Godsbane\" Ability { id: \"8821\", source: \"Llymlaen\" }\r\n\r\n2392.2 \"Seafoam Spiral/Wind Rose\" Ability { id: [\"880D\", \"880C\"], source: \"Llymlaen\" }\r\n2394.3 \"Stormy Seas\" Ability { id: \"881D\", source: \"Llymlaen\" }\r\n2399.1 \"Stormwhorl 1\" #Ability { id: \"881E\", source: \"Llymlaen\" }\r\n2401.1 \"Stormwhorl 2\" #Ability { id: \"881E\", source: \"Llymlaen\" }\r\n2403.1 \"Stormwhorl 3\" #Ability { id: \"881E\", source: \"Llymlaen\" }\r\n2404.1 \"Stormwinds\" #Ability { id: \"881F\", source: \"Llymlaen\" }\r\n\r\n2410.4 \"Left Strait/Right Strait\" Ability { id: [\"8851\", \"8852\"], source: \"Llymlaen\" }\r\n2421.5 \"Tempest\" Ability { id: \"880B\", source: \"Llymlaen\" }\r\n\r\n2431.8 \"--middle--\" Ability { id: \"8809\", source: \"Llymlaen\" }\r\n2439.6 \"Navigator's Trident\" Ability { id: \"880E\", source: \"Llymlaen\" } window 40,40 forcejump \"llymlaen-loop\"\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 367 attack auto damage\r\n# 8809 --sync-- repositioning\r\n# 880A Frothing Sea damage from the water afer Shockwave knockback\r\n# 880B Tempest cast and raidwide damage\r\n# 880C Wind Rose cast and \"get out\" damage\r\n# 880D Seafoam Spiral cast and \"get under\" damage\r\n# 880E Navigator's Trident self-targeted cast before Dire Straits 880F/8810 cleaves\r\n# 880F Dire Straits damage from Navigator's Trident left 180 cleave\r\n# 8810 Dire Straits damage from Navigator's Trident right 180 cleave\r\n# 8811 Navigator's Trident cast and red line knockback damage\r\n# 8812 Surging Wave cast and damage from purple puck along with Shockwave knockback\r\n# 8813 Surging Wave cast and damage from purple puck along with Shockwave knockback\r\n# 8814 Shockwave cast and knockback damage from Surging Wave\r\n# 8815 To the Last self-targeted castbar for To the Last left/right cleaves after Shockwave\r\n# 8816 --sync-- self-targeted preview ability for To the Last cleaves (no indication on which side)\r\n# 8817 To the Last self-targeted ability for 8818 left/right cleave after Shockwave\r\n# 8818 To the Last damage for left/right cleaves after Shockwave (both sides)\r\n# 8819 Deep Dive cast and jump stack damage\r\n# 881A Torrential Tridents self-targeted cast to summon tridents for Landing 881B => 881C\r\n# 881B Landing small damage from tridents landing\r\n# 881C Landing damage from large trident circles\r\n# 881D Stormy Seas self-targeted cast before Stormwhorl puddles and Stormwinds spread\r\n# 881E Stormwhorl cast and damage from ground puddle during 881F Stormwinds spread\r\n# 881F Stormwinds cast and spread damage during 881E Stormwhorl\r\n# 8820 Denizens of the Deep self-targeted cast to summon Thalaos and Perykos\r\n# 8821 Godsbane self-targeted castbar from Llymlaen for raidwide bleed\r\n# 8822 Godsbane self-targeted castbar from Perykos for raidwide bleed\r\n# 8823 Godsbane self-targeted castbar from Thalaos for raidwide bleed\r\n# 8824 Godsbane unknown self-targeted shorter(!) cast started at the same time as other Godsbane casts\r\n# 8825 --sync-- self-targeted castbar ability prior to Serpents' Tide dash\r\n# 8826 Serpents' Tide damage from vertical Perykos serpent dash\r\n# 8827 Serpents' Tide damage from horizontal Perykos serpent dash\r\n# 8828 Serpents' Tide damage from vertical Thalaos serpent dash\r\n# 8829 Serpents' Tide damage from horizontal Thalaos serpent dash\r\n# 882A Maelstrom cast and damage from three puddles on the ground after Serpents' Tide\r\n# 882B --sync-- unknown ability possibly used in place of 8CCF\r\n# 882D Sphere Shatter hitting one of the Sea-foam bubbles after Shockwave knockback\r\n# 8834 Deep Dive cast and damage for hit 3 of triple stack damage from Llymlaen\r\n# 8835 Hard Water cast and damage for hit 1 of triple stack damage from Perykos\r\n# 8836 Hard Water cast and damage for hit 2 of triple stack damage from Thalaos\r\n# 8851 Left Strait cast and damage for 180 left cleave\r\n# 8852 Right Strait cast and damage for 180 right cleave\r\n# 8C6C Godsbane cast and damage for raidwide bleed\r\n# 8CCB Dire Straits self-targeted ability before Dire Straits 880F/8810 cleaves\r\n# 8CCD --sync-- Navigator's Trident left preview\r\n# 8CCE --sync-- Navigator's Trident right preview\r\n# 8CCF --sync-- reposition east before 8CD0/8811 Navigator's Trident knockback\r\n# 8CD0 Navigator's Trident self-targeted ability before 8811 knockback\r\n\r\n\r\n#~~~~~~~~#\r\n# Oschon #\r\n#~~~~~~~~#\r\n\r\n# -p 8999:3014 89A7:3505\r\n# -ii 8C42 8CBA 899D 8C43 89B0 89B1 89A5 899E 89B3 89B4 89A6 89AB 899E 8CBB\r\n# -it Oschon\r\n# Long pull: https://www.fflogs.com/reports/GzjrkH97xXWFZvAM#fight=4&type=damage-done\r\n\r\n# The Windward Pass will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"116B\" } window 10000,0\r\n\r\n# Phase 1\r\n3010.0 \"--sync--\" Ability { id: \"8999\", source: \"Oschon\" } window 10,10\r\n3014.0 \"Sudden Downpour\" Ability { id: \"8999\", source: \"Oschon\" }\r\n\r\n3018.1 \"--middle--\" Ability { id: \"8998\", source: \"Oschon\" }\r\n3019.3 \"--sync--\" Ability { id: \"882F\", source: \"Oschon\" }\r\n3025.3 \"--sync--\" Ability { id: \"898E\", source: \"Oschon\" }\r\n3028.9 \"Trek Shot\" Ability { id: \"8C44\", source: \"Oschon\" }\r\n\r\n3033.6 \"--middle--\" Ability { id: \"8998\", source: \"Oschon\" }\r\n3037.7 \"Reproduce\" Ability { id: \"8989\", source: \"Oschon\" }\r\n3040.7 \"--sync--\" Ability { id: [\"8830\", \"8831\"], source: \"Oschon\" }\r\n3047.7 \"--sync--\" Ability { id: [\"898A\", \"898B\"], source: \"Oschon's Avatar\" }\r\n3053.8 \"Swinging Draw\" Ability { id: \"898C\", source: \"Oschon's Avatar\" }\r\n\r\n3054.9 \"--middle--\" Ability { id: \"8998\", source: \"Oschon\" }\r\n3059.2 \"Reproduce\" Ability { id: \"8989\", source: \"Oschon\" }\r\n3062.2 \"--sync--\" Ability { id: [\"8830\", \"8831\"], source: \"Oschon\" }\r\n3069.2 \"--sync--\" Ability { id: [\"898A\", \"898B\"], source: \"Oschon's Avatar\" }\r\n3075.3 \"Swinging Draw x2\" Ability { id: \"898C\", source: \"Oschon's Avatar\" }\r\n\r\n3076.4 \"--middle--\" Ability { id: \"8998\", source: \"Oschon\" }\r\n3082.0 \"Flinted Foehn x6\" Ability { id: \"89A3\", source: \"Oschon\" } duration 5.6\r\n\r\n3094.2 \"Soaring Minuet\" Ability { id: \"8D0E\", source: \"Oschon\" }\r\n3101.3 \"The Arrow\" Ability { id: \"899B\", source: \"Oschon\" }\r\n\r\n3109.4 label \"oschon-p1-loop\"\r\n3109.4 \"Reproduce\" Ability { id: \"8989\", source: \"Oschon\" }\r\n3112.4 \"--sync--\" Ability { id: [\"8830\", \"8831\"], source: \"Oschon\" }\r\n3119.4 \"--sync--\" Ability { id: [\"898A\", \"898B\"], source: \"Oschon's Avatar\" }\r\n3125.5 \"Swinging Draw x2\" Ability { id: \"898C\", source: \"Oschon's Avatar\" }\r\n\r\n3129.5 \"Sudden Downpour\" Ability { id: \"8999\", source: \"Oschon\" }\r\n\r\n3133.6 \"--middle--\" Ability { id: \"8998\", source: \"Oschon\" }\r\n3137.9 \"Downhill (cast)\" Ability { id: \"899F\", source: \"Oschon\" }\r\n3145.0 \"Climbing Shot\" Ability { id: [\"8990\", \"8991\", \"8992\", \"8993\"], source: \"Oschon\" }\r\n3146.8 \"Downhill\" Ability { id: \"89A1\", source: \"Oschon\" }\r\n\r\n3153.1 \"Soaring Minuet\" Ability { id: \"8994\", source: \"Oschon\" }\r\n3160.8 \"Flinted Foehn x6\" Ability { id: \"89A3\", source: \"Oschon\" } duration 5.6\r\n\r\n3168.1 \"--sync--\" Ability { id: [\"882E\", \"882F\"], source: \"Oschon\" }\r\n3174.1 \"--sync--\" Ability { id: [\"898D\", \"898E\"], source: \"Oschon\" }\r\n3177.7 \"Trek Shot\" Ability { id: [\"898F\", \"8C44\"], source: \"Oschon\" }\r\n\r\n3184.4 \"Sudden Downpour 1\" Ability { id: \"8999\", source: \"Oschon\" }\r\n3190.5 \"Sudden Downpour 2\" Ability { id: \"8999\", source: \"Oschon\" }\r\n\r\n3197.7 \"--middle--\" Ability { id: \"8998\", source: \"Oschon\" }\r\n3202.0 \"Reproduce\" Ability { id: \"8989\", source: \"Oschon\" } window 40,40 forcejump \"oschon-p1-loop\"\r\n\r\n\r\n# Intermission\r\n3493.6 \"--middle--\" Ability { id: \"8998\", source: \"Oschon\" }\r\n3500.0 \"--sync--\" StartsUsing { id: \"89A7\", source: \"Oschon\" } window 500,0\r\n3505.0 \"Lofty Peaks\" Ability { id: \"89A7\", source: \"Oschon\" }\r\n3505.0 \"--untargetable--\"\r\n3506.0 \"Moving Mountains 1\" #Ability { id: \"8CE3\", source: \"Oschon\" }\r\n3507.6 \"Moving Mountains 2\" #Ability { id: \"8CE3\", source: \"Oschon\" }\r\n3509.2 \"Moving Mountains 3\" #Ability { id: \"8CE3\", source: \"Oschon\" }\r\n3513.1 \"Peak Peril\" Ability { id: \"8CE4\", source: \"Oschon\" }\r\n3528.9 \"Shockwave\" Ability { id: \"89A8\", source: \"Oschon\" }\r\n3530.9 \"--targetable--\"\r\n\r\n\r\n# Phase 2\r\n3544.0 \"Piton Pull 1\" Ability { id: [\"89A9\", \"89AA\"], source: \"Oschon\" }\r\n3556.1 \"Piton Pull 2\" Ability { id: [\"89A9\", \"89AA\"], source: \"Oschon\" }\r\n3568.2 \"Altitude\" Ability { id: \"89AF\", source: \"Oschon\" }\r\n3578.9 \"Flinted Foehn x6\" Ability { id: \"89A4\", source: \"Oschon\" } duration 5.6\r\n\r\n3595.1 \"Wandering Shot 1\" Ability { id: [\"8CF6\", \"8CF7\"], source: \"Oschon\" }\r\n3598.8 \"Great Whirlwind 1\" Ability { id: \"89AE\", source: \"Oschon\" }\r\n3609.4 \"Wandering Shot 2\" Ability { id: [\"8CF6\", \"8CF7\"], source: \"Oschon\" }\r\n3613.1 \"Great Whirlwind 2\" Ability { id: \"89AE\", source: \"Oschon\" }\r\n\r\n3622.5 \"The Arrow\" Ability { id: \"899C\", source: \"Oschon\" }\r\n\r\n3631.7 label \"oschon-p2-loop\"\r\n3631.7 \"Arrow Trail\" Ability { id: \"89B2\", source: \"Oschon\" } duration 18\r\n3642.9 \"Downhill 1\" Ability { id: \"8C45\", source: \"Oschon\" }\r\n3646.9 \"Downhill 2\" Ability { id: \"8C45\", source: \"Oschon\" }\r\n3650.9 \"Downhill 3\" Ability { id: \"8C45\", source: \"Oschon\" }\r\n3657.9 \"Piton Pull\" Ability { id: [\"89A9\", \"89AA\"], source: \"Oschon\" }\r\n\r\n3668.1 \"Downhill (cast)\" Ability { id: \"89A0\", source: \"Oschon\" }\r\n3681.2 \"Wandering Volley\" Ability { id: [\"89AC\", \"89AD\"], source: \"Oschon\" }\r\n3682.4 \"Downhill\" Ability { id: \"89A2\", source: \"Oschon\" }\r\n3684.7 \"Great Whirlwind\" Ability { id: \"89AE\", source: \"Oschon\" }\r\n\r\n3692.1 \"Piton Pull\" Ability { id: [\"89A9\", \"89AA\"], source: \"Oschon\" }\r\n\r\n3702.6 \"Flinted Foehn x6\" Ability { id: \"89A4\", source: \"Oschon\" } duration 5.6\r\n\r\n3715.6 \"The Arrow\" Ability { id: \"899C\", source: \"Oschon\" }\r\n3724.7 \"Altitude\" Ability { id: \"89AF\", source: \"Oschon\" }\r\n\r\n3736.8 \"Sudden Downpour 1\" Ability { id: \"899A\", source: \"Oschon\" }\r\n3746.9 \"Sudden Downpour 2\" Ability { id: \"899A\", source: \"Oschon\" }\r\n\r\n3758.1 \"Arrow Trail\" Ability { id: \"89B2\", source: \"Oschon\" } window 40,40 forcejump \"oschon-p2-loop\"\r\n\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 882E --sync-- unknown ability before 898D Trek Shot\r\n# 8830 --sync-- unknown ability before 898A Swinging Draw\r\n# 882F --sync-- unknown ability before 898E Trek Shot\r\n# 8831 --sync-- unknown ability before 898B Swinging Draw\r\n# 8989 Reproduce self-targeted cast to make 1-2 clones\r\n# 898A Swinging Draw self-targeted clone cast for move before Swinging Draw\r\n# 898B Swinging Draw self-targeted clone cast for move before Swinging Draw\r\n# 898C Swinging Draw cast and damage for clone moving arrow conal\r\n# 898D Trek Shot self-targeted cast for move before Trek Shot with 898F\r\n# 898E Trek Shot self-targeted cast for move before Trek Shot with 8C44\r\n# 898F Trek Shot cast and damage for moving arrow conal from 898D\r\n# 8990 Climbing Shot cast and knockback damage along with 89A1 Downhill puddles\r\n# 8991 Climbing Shot cast and knockback damage along with 89A1 Downhill puddles\r\n# 8992 Climbing Shot cast and knockback damage along with 89A1 Downhill puddles\r\n# 8993 Climbing Shot cast and knockback damage along with 89A1 Downhill puddles\r\n# 8994 Soaring Minuet cast and damage for back safe 270 cleave (2nd one)\r\n# 8998 --sync-- repositioning\r\n# 8999 Sudden Downpour self-targeted cast for raidwide along with 8CBA (small version)\r\n# 899A Sudden Downpour self-targeted cast for raidwide along with 8CBB (big version)\r\n# 899B The Arrow self-targeted cast for 3x tankbusters (small version)\r\n# 899C The Arrow self-targeted cast for 3x tankbusters (big version)\r\n# 899D The Arrow damage from 899B 3x tankbusters (small version)\r\n# 899E The Arrow damage from 899B 3x tankbusters (big version)\r\n# 899F Downhill self-targeted cast to summon 89A1 orange Downhill puddles (small version)\r\n# 89A0 Downhill self-targeted cast to sumon 89A2 large red Downhill puddles (big version)\r\n# 89A1 Downhill cast and damage for orange puddles during Climbing Shot knockback (small version)\r\n# 89A2 Downhill cast and damage for red puddles during Wandering Volley knockback (big version)\r\n# 89A3 Flinted Foehn self-targeted cast for 6x hit stack (small version)\r\n# 89A4 Flinted Foehn self-targeted cast for 6x hit stack (big version)\r\n# 89A5 Flinted Foehn damage from 6x hit stack (small version)\r\n# 89A6 Flinted Foehn damage from 6x hit stack (big version)\r\n# 89A7 Lofty Peaks self-targeted cast before throwing players in air\r\n# 89A8 Shockwave cast and raidwide damage to grow big\r\n# 89A9 Piton Pull self-targeted cast for NE/SW safe large circles\r\n# 89AA Piton Pull self-targeted cast for NW/SE safe large circles\r\n# 89AB Piton Pull cast and damage from Piton Pull large circles\r\n# 89AC Wandering Volley cast and zero damage knockback from line with Great Whirlwind orb\r\n# 89AD Wandering Volley cast and zero damage knockback from line with Great Whirlwind orb\r\n# 89AE Great Whirlwind cast and damage for Wandering Shot/Volley orb explosion\r\n# 89AF Altitude untargeted cast before 89B1 Altitude circles\r\n# 89B0 --sync-- preview ability for Altitude\r\n# 89B1 Altitude cast and damage for previewed green circles\r\n# 89B2 Arrow Trail self-targeted cast before multi-line arrow attacks\r\n# 89B3 --sync-- self-targeted cast for 89B4 Arrow Trail preview\r\n# 89B4 Arrow Trail damage for line of arrows after 89B3 preview\r\n# 8C42 --sync-- auto damage (small version)\r\n# 8C43 --sync-- auto damage (big version)\r\n# 8C44 Trek Shot cast and damage for moving arrow conal from 898E\r\n# 8C45 Downhill puddle damage during 89B2 Arrow Trail\r\n# 8CBA Sudden Downpour cast and raidwide damage (small verison)\r\n# 8CBB Sudden Downpour cast and raidwide damage (big version)\r\n# 8CE3 Moving Mountains small raidwide damage before Peak Peril\r\n# 8CE4 Peak Peril damage from being thrown in the air after Lofty Peaks\r\n# 8CF6 Wandering Shot self-targeted cast for looping arrows with Great Whirlwind orb\r\n# 8CF7 Wandering Shot self-targeted cast for looping arrows with Great Whirlwind orb\r\n# 8D0E Soaring Minuet cast and damage for back safe 270 cleave (1st one)\r\n\r\n\r\n#~~~~~~~~~#\r\n# Eulogia #\r\n#~~~~~~~~~#\r\n\r\n# -p 8A03:4014.6\r\n# -ii 8A1D 8A1E 8A1F 8A20 8A21 8A01 8A3C 8A3E 8A3F 8A41 8CFD 8A45 8A46 8A49 8A4A 8A53 8A54 8A59 8A5A 8A65 8A66 8A67 8A68 8CFF 8D00 8D02 8A09 8CE2 8CFB 8A1A 8A1B 8A1C 8CE5 8CE6 8CE7 8CE8 8CE9 8CEA 8CFE 8D01 8D03\r\n\r\n# Long pull: https://www.fflogs.com/reports/RDdMfG1PwBKAj69b#fight=137&type=damage-done\r\n# Long pull: https://www.fflogs.com/reports/cMwXWVBChmR9Gja3#fight=11&type=damage-done\r\n# Long pull: https://www.fflogs.com/reports/wRA1yPgGx8McNjnf#fight=7&type=damage-done\r\n\r\n# The Twelve's Embrace will be sealed off\r\n4000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"116D\" } window 10000,0\r\n4009.6 \"--sync--\" StartsUsing { id: \"8A03\", source: \"Eulogia\" } window 10,10\r\n4014.6 \"Dawn of Time\" Ability { id: \"8A03\", source: \"Eulogia\" }\r\n\r\n4019.9 \"--sync--\" Ability { id: \"8A02\", source: \"Eulogia\" }\r\n4022.0 \"--sync--\" Ability { id: \"8A08\", source: \"Eulogia\" }\r\n4031.4 \"First Form\" Ability { id: [\"8A0A\", \"8A0D\", \"8A10\"], source: \"Eulogia\" }\r\n4038.5 \"Second Form\" Ability { id: [\"8A0B\", \"8A0E\", \"8A11\"], source: \"Eulogia\" }\r\n4045.6 \"Third Form\" Ability { id: [\"8A0C\", \"8A0F\", \"8A12\"], source: \"Eulogia\" }\r\n4049.7 \"--sync--\" Ability { id: \"8A16\", source: \"Eulogia\" }\r\n4049.9 \"Quintessence 1\" Ability { id: [\"8A17\", \"8A18\", \"8A19\"], source: \"Eulogia\" }\r\n4053.6 \"Quintessence 2\" Ability { id: [\"8A17\", \"8A18\", \"8A19\"], source: \"Eulogia\" }\r\n4057.2 \"Quintessence 3\" Ability { id: [\"8A17\", \"8A18\", \"8A19\"], source: \"Eulogia\" }\r\n\r\n4071.5 \"--sync--\" Ability { id: \"8A02\", source: \"Eulogia\" }\r\n4073.7 \"--sync--\" Ability { id: \"8A08\", source: \"Eulogia\" }\r\n\r\n4083.1 \"First Form\" Ability { id: [\"8A0A\", \"8A0D\", \"8A10\"], source: \"Eulogia\" }\r\n4090.3 \"Second Form\" Ability { id: [\"8A0B\", \"8A0E\", \"8A11\"], source: \"Eulogia\" }\r\n4097.4 \"Third Form\" Ability { id: [\"8A0C\", \"8A0F\", \"8A12\"], source: \"Eulogia\" }\r\n4101.5 \"--sync--\" Ability { id: \"8A16\", source: \"Eulogia\" }\r\n4101.7 \"Quintessence 1\" Ability { id: [\"8A17\", \"8A18\", \"8A19\"], source: \"Eulogia\" }\r\n4105.4 \"Quintessence 2\" Ability { id: [\"8A17\", \"8A18\", \"8A19\"], source: \"Eulogia\" }\r\n4109.0 \"Quintessence 3\" Ability { id: [\"8A17\", \"8A18\", \"8A19\"], source: \"Eulogia\" }\r\n\r\n4122.0 \"Sunbeam\" Ability { id: \"8A00\", source: \"Eulogia\" }\r\n\r\n4128.2 \"--middle--\" Ability { id: \"8A02\", source: \"Eulogia\" }\r\n4137.4 \"The Whorl\" Ability { id: \"8A2F\", source: \"Eulogia\" }\r\n4144.5 \"Love's Light\" Ability { id: \"8A30\", source: \"Eulogia\" }\r\n\r\n4152.6 \"Full Bright\" Ability { id: \"8A31\", source: \"Eulogia\" }\r\n4163.7 \"First Blush 1\" Ability { id: \"8A33\", source: \"Eulogia\" }\r\n4165.7 \"First Blush 2\" Ability { id: \"8A34\", source: \"Eulogia\" }\r\n4167.7 \"First Blush 3\" Ability { id: \"8A35\", source: \"Eulogia\" }\r\n4169.7 \"First Blush 4\" Ability { id: \"8A36\", source: \"Eulogia\" }\r\n\r\n4172.7 \"Solar Fans\" Ability { id: \"8A3B\", source: \"Eulogia\" }\r\n4175.8 \"Radiant Rhythm 1\" #Ability { id: \"8A3D\", source: \"Eulogia\" }\r\n4177.9 \"Radiant Rhythm 2\" #Ability { id: \"8A3D\", source: \"Eulogia\" }\r\n4180.0 \"Radiant Rhythm 3\" #Ability { id: \"8A3D\", source: \"Eulogia\" }\r\n4182.1 \"Radiant Rhythm 4\" #Ability { id: \"8A3D\", source: \"Eulogia\" }\r\n4187.6 \"Radiant Finish\" Ability { id: \"8A40\", source: \"Eulogia\" }\r\n\r\n4193.7 \"Hydrostasis (cast)\" Ability { id: \"8A37\", source: \"Eulogia\" }\r\n4201.7 \"Time and Tide\" Ability { id: \"8A32\", source: \"Eulogia\" }\r\n4204.6 \"Hydrostasis 3\" Ability { id: \"8A38\", source: \"Eulogia\" }\r\n4207.6 \"Hydrostasis 1\" Ability { id: \"8A39\", source: \"Eulogia\" }\r\n4210.6 \"Hydrostasis 2\" Ability { id: \"8A3A\", source: \"Eulogia\" }\r\n4218.9 \"Destructive Bolt\" Ability { id: \"8CEC\", source: \"Eulogia\" }\r\n\r\n4223.0 \"--middle--\" Ability { id: \"8A02\", source: \"Eulogia\" }\r\n4230.3 \"Hieroglyphika\" Ability { id: \"8A43\", source: \"Eulogia\" }\r\n4247.4 \"--sync--\" Ability { id: \"8A44\", source: \"Eulogia\" }\r\n4252.2 \"Hand of the Destroyer\" Ability { id: [\"8A47\", \"8A48\"], source: \"Eulogia\" }\r\n\r\n4256.3 \"--middle--\" Ability { id: \"8A02\", source: \"Eulogia\" }\r\n4261.4 \"Matron's Breath\" Ability { id: \"8A4B\", source: \"Eulogia\" }\r\n4276.5 \"Blueblossoms/Giltblossoms 1\" Ability { id: [\"8A4C\", \"8A4D\"], source: \"Eulogia\" }\r\n4280.1 \"Blueblossoms/Giltblossoms 2\" Ability { id: [\"8A4C\", \"8A4D\"], source: \"Eulogia\" }\r\n4283.7 \"Blueblossoms/Giltblossoms 3\" Ability { id: [\"8A4C\", \"8A4D\"], source: \"Eulogia\" }\r\n4287.3 \"Blueblossoms/Giltblossoms 4\" Ability { id: [\"8A4C\", \"8A4D\"], source: \"Eulogia\" }\r\n\r\n4290.7 \"Torrential Tridents\" Ability { id: \"8A4E\", source: \"Eulogia\" }\r\n4291.6 \"Landing 1\" #Ability { id: \"8A4F\", source: \"Trident\" }\r\n4292.7 \"Landing 2\" #Ability { id: \"8A4F\", source: \"Trident\" }\r\n4293.8 \"Landing 3\" #Ability { id: \"8A4F\", source: \"Trident\" }\r\n4294.9 \"Landing 4\" #Ability { id: \"8A4F\", source: \"Trident\" }\r\n4295.9 \"Landing 5\" #Ability { id: \"8A4F\", source: \"Trident\" }\r\n4297.0 \"Landing 6\" #Ability { id: \"8A4F\", source: \"Trident\" }\r\n4305.1 \"Lightning Bolt 1\" #Ability { id: \"8A50\", source: \"Trident\" }\r\n4306.1 \"Lightning Bolt 2\" #Ability { id: \"8A50\", source: \"Trident\" }\r\n4307.1 \"Lightning Bolt 3\" #Ability { id: \"8A50\", source: \"Trident\" }\r\n4308.1 \"Lightning Bolt 4\" #Ability { id: \"8A50\", source: \"Trident\" }\r\n4309.1 \"Lightning Bolt 5\" #Ability { id: \"8A50\", source: \"Trident\" }\r\n4310.1 \"Lightning Bolt 6\" #Ability { id: \"8A50\", source: \"Trident\" }\r\n4316.7 \"Destructive Bolt\" Ability { id: \"8CEC\", source: \"Eulogia\" }\r\n\r\n4327.1 \"Byregot's Strike\" Ability { id: \"8A52\", source: \"Eulogia\" }\r\n4334.0 \"Thousandfold Thrust\" Ability { id: [\"8A57\", \"8A58\"], source: \"Eulogia\" } duration 5.4\r\n\r\n4343.0 \"--middle--\" Ability { id: \"8A02\", source: \"Eulogia\" }\r\n4350.2 \"As Above, So Below\" Ability { id: [\"8A5B\", \"8A5C\"], source: \"Eulogia\" }\r\n4362.3 \"Climbing Shot\" Ability { id: [\"8D0A\", \"8D0B\"], source: \"Eulogia\" }\r\n4372.8 \"Soaring Minuet\" Ability { id: \"8A69\", source: \"Eulogia\" }\r\n\r\n4377.1 \"--middle--\" Ability { id: \"8A08\", source: \"Eulogia\" }\r\n4382.9 \"The Builder's Art\" Ability { id: \"8A22\", source: \"Eulogia\" }\r\n4384.5 \"The Destroyer's Might\" Ability { id: \"8A23\", source: \"Eulogia\" }\r\n4386.1 \"The Warden's Radiance\" Ability { id: \"8A24\", source: \"Eulogia\" }\r\n4387.5 \"The Traders' Equity\" Ability { id: \"8A25\", source: \"Eulogia\" }\r\n4389.1 \"The Matron's Plenty\" Ability { id: \"8A26\", source: \"Eulogia\" }\r\n4390.7 \"The Keeper's Gravity\" Ability { id: \"8A27\", source: \"Eulogia\" }\r\n4392.1 \"The Fury's Ambition\" Ability { id: \"8A28\", source: \"Eulogia\" }\r\n4393.7 \"The Lover's Devotion\" Ability { id: \"8A29\", source: \"Eulogia\" }\r\n4395.3 \"The Scholar's Wisdom\" Ability { id: \"8A2A\", source: \"Eulogia\" }\r\n4396.7 \"The Spinner's Cunning\" Ability { id: \"8A2B\", source: \"Eulogia\" }\r\n4398.3 \"The Navigator's Command\" Ability { id: \"8A2D\", source: \"Eulogia\" }\r\n4399.9 \"The Wanderer's Whimsy\" Ability { id: \"8A2E\", source: \"Eulogia\" }\r\n4402.2 \"Eudaimon Eorzea\" Ability { id: \"8A2C\", source: \"Eulogia\" }\r\n\r\n4418.0 \"--sync--\" Ability { id: \"8A02\", source: \"Eulogia\" }\r\n4420.3 label \"Quintessence\"\r\n4420.3 \"--sync--\" Ability { id: \"8A08\", source: \"Eulogia\" }\r\n4429.7 \"First Form\" Ability { id: [\"8A0A\", \"8A0D\", \"8A10\"], source: \"Eulogia\" }\r\n4436.9 \"Second Form\" Ability { id: [\"8A0B\", \"8A0E\", \"8A11\"], source: \"Eulogia\" }\r\n4444.1 \"Third Form\" Ability { id: [\"8A0C\", \"8A0F\", \"8A12\"], source: \"Eulogia\" }\r\n4448.2 \"--sync--\" Ability { id: \"8A16\", source: \"Eulogia\" }\r\n4448.4 \"Quintessence 1\" Ability { id: [\"8A17\", \"8A18\", \"8A19\"], source: \"Eulogia\" }\r\n4452.1 \"Quintessence 2\" Ability { id: [\"8A17\", \"8A18\", \"8A19\"], source: \"Eulogia\" }\r\n4455.7 \"Quintessence 3\" Ability { id: [\"8A17\", \"8A18\", \"8A19\"], source: \"Eulogia\" }\r\n4468.5 \"Sunbeam\" Ability { id: \"8A00\", source: \"Eulogia\" }\r\n\r\n4476.9 \"--middle--\" Ability { id: \"8A02\", source: \"Eulogia\" }\r\n4486.2 \"The Whorl\" Ability { id: \"8A2F\", source: \"Eulogia\" }\r\n\r\n# Mechanics get a bit random here. There seem to be blocks that it executes all of in\r\n# some order before returning to Quintessence. There might be some order to it\r\n# as only some of them have Destructive Bolt stacks attached to them (although\r\n# it doesn't execute if it is the final mechanic prior to jumping back to Quintessence).\r\n# This is probably Good Enough (TM).\r\n#cactbot-timeline-lint-disable-sync-order\r\n4400.0 \"--sync--\" StartsUsing { id: \"8A3B\", source: \"Eulogia\" } window 0,10000 jump \"Solar Fans\"\r\n4400.0 \"--sync--\" StartsUsing { id: \"8A4B\", source: \"Eulogia\" } window 0,10000 jump \"Matron's Breath\"\r\n4400.0 \"--sync--\" StartsUsing { id: [\"8A5B\", \"8A5C\"], source: \"Eulogia\" } window 0,10000 jump \"As Above, So Below\"\r\n4400.0 \"--sync--\" StartsUsing { id: \"8A4E\", source: \"Eulogia\" } window 0,10000 jump \"Torrential Tridents\"\r\n4400.0 \"--sync--\" StartsUsing { id: \"8A30\", source: \"Eulogia\" } window 0,10000 jump \"Love's Light\"\r\n4400.0 \"--sync--\" StartsUsing { id: \"8A43\", source: \"Eulogia\" } window 0,10000 jump \"Hieroglyphika\"\r\n4400.0 \"--sync--\" StartsUsing { id: \"8A37\", source: \"Eulogia\" } window 0,10000 jump \"Hydrostasis\"\r\n4400.0 \"--sync--\" StartsUsing { id: \"8A52\", source: \"Eulogia\" } window 0,10000 jump \"Byregot's Strike\"\r\n4400.0 \"--sync--\" Ability { id: \"8A08\", source: \"Eulogia\" } window 0,10000 jump \"Quintessence\"\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n5000.0 label \"Solar Fans\"\r\n5000.0 \"--sync--\" StartsUsing { id: \"8A3B\", source: \"Eulogia\" }\r\n5003.0 \"Solar Fans\" Ability { id: \"8A3B\", source: \"Eulogia\" }\r\n5006.1 \"Radiant Rhythm 1\" #Ability { id: \"8A3D\", source: \"Eulogia\" }\r\n5008.2 \"Radiant Rhythm 2\" #Ability { id: \"8A3D\", source: \"Eulogia\" }\r\n5010.3 \"Radiant Rhythm 3\" #Ability { id: \"8A3D\", source: \"Eulogia\" }\r\n5012.4 \"Radiant Rhythm 4\" #Ability { id: \"8A3D\", source: \"Eulogia\" }\r\n5017.8 \"Radiant Finish\" Ability { id: \"8A40\", source: \"Eulogia\" }\r\n\r\n5100.0 label \"Matron's Breath\"\r\n5100.0 \"--sync--\"StartsUsing { id: \"8A4B\", source: \"Eulogia\" }\r\n5103.0 \"Matron's Breath\" Ability { id: \"8A4B\", source: \"Eulogia\" }\r\n5118.1 \"Blueblossoms/Giltblossoms 1\" Ability { id: [\"8A4C\", \"8A4D\"], source: \"Eulogia\" }\r\n5121.7 \"Blueblossoms/Giltblossoms 2\" Ability { id: [\"8A4C\", \"8A4D\"], source: \"Eulogia\" }\r\n5125.3 \"Blueblossoms/Giltblossoms 3\" Ability { id: [\"8A4C\", \"8A4D\"], source: \"Eulogia\" }\r\n5128.9 \"Blueblossoms/Giltblossoms 4\" Ability { id: [\"8A4C\", \"8A4D\"], source: \"Eulogia\" }\r\n\r\n5200.0 label \"As Above, So Below\"\r\n5200.0 \"--sync--\" StartsUsing { id: [\"8A5B\", \"8A5C\"], source: \"Eulogia\" }\r\n5205.0 \"As Above, So Below\" Ability { id: [\"8A5B\", \"8A5C\"], source: \"Eulogia\" }\r\n5217.1 \"Climbing Shot\" Ability { id: [\"8D0A\", \"8D0B\"], source: \"Eulogia\" }\r\n5227.4 \"Soaring Minuet\" Ability { id: \"8A69\", source: \"Eulogia\" }\r\n5237.6 \"Destructive Bolt\" Ability { id: \"8CEC\", source: \"Eulogia\" }\r\n\r\n5300.0 label \"Torrential Tridents\"\r\n5300.0 \"--sync--\" StartsUsing { id: \"8A4E\", source: \"Eulogia\" }\r\n5302.0 \"Torrential Tridents\" Ability { id: \"8A4E\", source: \"Eulogia\" }\r\n5302.9 \"Landing 1\" #Ability { id: \"8A4F\", source: \"Trident\" }\r\n5304.0 \"Landing 2\" #Ability { id: \"8A4F\", source: \"Trident\" }\r\n5305.1 \"Landing 3\" #Ability { id: \"8A4F\", source: \"Trident\" }\r\n5306.2 \"Landing 4\" #Ability { id: \"8A4F\", source: \"Trident\" }\r\n5307.2 \"Landing 5\" #Ability { id: \"8A4F\", source: \"Trident\" }\r\n5308.3 \"Landing 6\" #Ability { id: \"8A4F\", source: \"Trident\" }\r\n5316.4 \"Lightning Bolt 1\" #Ability { id: \"8A50\", source: \"Trident\" }\r\n5317.4 \"Lightning Bolt 2\" #Ability { id: \"8A50\", source: \"Trident\" }\r\n5318.4 \"Lightning Bolt 3\" #Ability { id: \"8A50\", source: \"Trident\" }\r\n5319.4 \"Lightning Bolt 4\" #Ability { id: \"8A50\", source: \"Trident\" }\r\n5320.4 \"Lightning Bolt 5\" #Ability { id: \"8A50\", source: \"Trident\" }\r\n5321.4 \"Lightning Bolt 6\" #Ability { id: \"8A50\", source: \"Trident\" }\r\n\r\n5400.0 label \"Love's Light\"\r\n5400.0 \"--sync--\" StartsUsing { id: \"8A30\", source: \"Eulogia\" }\r\n5404.0 \"Love's Light\" Ability { id: \"8A30\", source: \"Eulogia\" }\r\n5412.1 \"Full Bright\" Ability { id: \"8A31\", source: \"Eulogia\" }\r\n5423.2 \"First Blush 1\" Ability { id: \"8A33\", source: \"Eulogia\" }\r\n5425.2 \"First Blush 2\" Ability { id: \"8A34\", source: \"Eulogia\" }\r\n5427.2 \"First Blush 3\" Ability { id: \"8A35\", source: \"Eulogia\" }\r\n5429.2 \"First Blush 4\" Ability { id: \"8A36\", source: \"Eulogia\" }\r\n\r\n5500.0 label \"Hieroglyphika\"\r\n5500.0 \"--sync--\" StartsUsing { id: \"8A43\", source: \"Eulogia\" }\r\n5505.0 \"Hieroglyphika\" Ability { id: \"8A43\", source: \"Eulogia\" }\r\n5522.1 \"--sync--\" Ability { id: \"8A44\", source: \"Eulogia\" }\r\n5526.8 \"Hand of the Destroyer\" Ability { id: [\"8A47\", \"8A48\"], source: \"Eulogia\" }\r\n5537.9 \"Destructive Bolt\" Ability { id: \"8CEC\", source: \"Eulogia\" }\r\n\r\n5600.0 label \"Hydrostasis\"\r\n5600.0 \"--sync--\" Ability { id: \"8A37\", source: \"Eulogia\" }\r\n5604.0 \"Hydrostasis\" Ability { id: \"8A37\", source: \"Eulogia\" }\r\n5612.0 \"Time and Tide\" Ability { id: \"8A32\", source: \"Eulogia\" }\r\n5614.9 \"Hydrostasis 3\" Ability { id: \"8A38\", source: \"Eulogia\" }\r\n5617.9 \"Hydrostasis 1\" Ability { id: \"8A39\", source: \"Eulogia\" }\r\n5620.9 \"Hydrostasis 2\" Ability { id: \"8A3A\", source: \"Eulogia\" }\r\n\r\n5700.0 label \"Byregot's Strike\"\r\n5700.0 \"--sync--\" Ability { id: \"8A52\", source: \"Eulogia\" }\r\n5706.0 \"Byregot's Strike\" Ability { id: \"8A52\", source: \"Eulogia\" }\r\n5712.9 \"Thousandfold Thrust\" Ability { id: [\"8A57\", \"8A58\"], source: \"Eulogia\" } duration 5.4\r\n5727.1 \"Destructive Bolt\" Ability { id: \"8CEC\", source: \"Eulogia\" }\r\n\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 89FE attack self-targeted ability prior to 89FF auto damage\r\n# 89FF attack auto damage on all tanks with aggro\r\n# 8A00 Sunbeam self-targeted cast for 3x tankbuster\r\n# 8A01 Sunbeam tank-targeted cast and damage for 3x tankbuster\r\n# 8A02 --sync-- repositioning 1\r\n# 8A03 Dawn of Time cast and damage for raidwide\r\n# 8A08 --sync-- repositioning 2\r\n# 8A09 --sync-- unknown self-targeted ability before Forms\r\n# 8A0A First Form self-targeted cast for #1 right cleave preview\r\n# 8A0B Second Form self-targeted cast for #2 right cleave preview\r\n# 8A0C Third Form self-targeted cast for #3 right cleave preview\r\n# 8A0D First Form self-targeted cast for #1 left cleave preview\r\n# 8A0E Second Form self-targeted cast for #2 left cleave preview\r\n# 8A0F Third Form self-targeted cast for #3 left cleave preview\r\n# 8A10 First Form self-targeted cast for #1 under preview\r\n# 8A11 Second Form self-targeted cast for #2 under preview\r\n# 8A12 Third Form self-targeted cast for #3 under preview\r\n# 8A16 Quintessence self-targeted castbar for Form attacks\r\n# 8A17 Quintessence untargeted ability for Form movement (right cleave)\r\n# 8A18 Quintessence untargeted ability for Form movement (left cleave)\r\n# 8A19 Quintessence untargeted ability for Form movement (under)\r\n# 8A1A Quintessence damage for First Form movement (right cleave)\r\n# 8A1B Quintessence damage for First Form movement (left cleave)\r\n# 8A1C Quintessence damage for First Form movement (under)\r\n# 8A1D --sync-- unknown self-targeted Eulogia's Avatar ability during Form attacks\r\n# 8A1E --sync-- unknown self-targeted Eulogia's Avatar ability during Form attacks\r\n# 8A1F --sync-- unknown self-targeted Eulogia's Avatar ability during Form attacks\r\n# 8A20 --sync-- unknown self-targeted Eulogia's Avatar ability during Form attacks\r\n# 8A21 --sync-- unknown self-targeted Eulogia's Avatar ability during Form attacks\r\n# 8A22 The Builder's Art raidwide damage\r\n# 8A23 The Destroyer's Might raidwide damage\r\n# 8A24 The Warden's Radiance raidwide damage\r\n# 8A25 The Traders' Equity raidwide damage\r\n# 8A26 The Matron's Plenty raidwide damage\r\n# 8A27 The Keeper's Gravity raidwide damage\r\n# 8A28 The Fury's Ambition raidwide damage\r\n# 8A29 The Lover's Devotion raidwide damage\r\n# 8A2A The Scholar's Wisdom raidwide damage\r\n# 8A2B The Spinner's Cunning raidwide damage\r\n# 8A2C Eudaimon Eorzea self-targeted castbar for multi-hit captain planet raidwide\r\n# 8A2D The Navigator's Command raidwide damage\r\n# 8A2E The Wanderer's Whimsy raidwide damage\r\n# 8A2F The Whorl cast and damage for large raidwide\r\n# 8A30 Love's Light self-targeted cast to summon moons for First Blush\r\n# 8A31 Full Bright self-targeted cast to make moons wax for First Blush\r\n# 8A32 Time and Tide self-targeted castbar to tether the 3rd diamond knockback\r\n# 8A33 First Blush cast and damage for Love's Light moon #1 line\r\n# 8A34 First Blush cast and damage for Love's Light moon #2 line\r\n# 8A35 First Blush cast and damage for Love's Light moon #3 line\r\n# 8A36 First Blush cast and damage for Love's Light moon #4 line\r\n# 8A37 Hydrostasis self-targeted castbar to summon 1/2/3 diamond knockbacks\r\n# 8A38 Hydrostasis cast and knockback damage for 3rd (tethered) diamond knockback\r\n# 8A39 Hydrostasis cast and knockback damage for 1st diamond knockback\r\n# 8A3A Hydrostasis cast and knockback damage for 2nd diamond knockback\r\n# 8A3B Solar Fans self-targeted cast to summon rotating Warden's Flame fans\r\n# 8A3C Solar Fans cast and damage for initial Warden's Flame fan lines\r\n# 8A3D Radiant Rhythm self-targeted ability for Warden's Flame fans prior to Radiant Flight movement\r\n# 8A3E --sync-- unknown self-targeted ability for Warden's Flame fans when moving with Radiant Flight\r\n# 8A3F Radiant Flight cast and damage for Warden's Flame fans when moving with Radiant Flight\r\n# 8A40 Radiant Finish self-targeted castbar for Radiant Flourish\r\n# 8A41 Radiant Flourish cast and damage for Warden's Flame fan large circles during Radiant Finish\r\n# 8A43 Hieroglyphika self-targeted cast to summon rotating green squares\r\n# 8A44 Hieroglyphika cast and damage for rotated green squares\r\n# 8A45 --sync-- self-targeted ability from red Fist of Wrath before Hand of the Destroyer\r\n# 8A46 --sync-- self-targeted ability from blue Fist of Judgment before Hand of the Destroyer\r\n# 8A47 Hand of the Destroyer self-targeted cast for red fist punch\r\n# 8A48 Hand of the Destroyer self-targeted castbar for blue fist punch\r\n# 8A49 Hand of the Destroyer cast and damage from red half room cleave fist punch\r\n# 8A4A Hand of the Destroyer cast and damage from blue half room cleave fist punch\r\n# 8A4B Matron's Breath self-targeted castbar to summon blue/yellow flowers\r\n# 8A4C Blueblossoms damage from blue flower explosion (light damage if in matching flower circle)\r\n# 8A4D Giltblossoms damage from yellow flower explosion (light damage if in matching flower circle)\r\n# 8A4E Torrential Tridents self-targeted cast to summon tridents for Landing 8A4F => Lightning Bolt 8A50\r\n# 8A4F Landing small damage from tridents landing\r\n# 8A50 Lightning Bolt damage from large trident circles (not called Landing here like in the earlier fight)\r\n# 8A52 Byregot's Strike casted damage from blue puck that knocks back\r\n# 8A53 Byregot's Strike casted knockback from blue puck with lightning\r\n# 8A54 Byregot's Strike casted damage from lightning bolt\r\n# 8A57 Thousandfold Thrust self-targeted castbar for 180 red shield cleave\r\n# 8A58 Thousandfold Thrust self-targeted castbar for 180 red shield cleave\r\n# 8A59 Thousandfold Thrust cast and damage for initial hit of 180 red shield cleave\r\n# 8A5A Thousandfold Thrust damage for ongoing hits of 180 red shield cleave\r\n# 8A5B As Above, So Below casted damage for raidwide and then glowing orange\r\n# 8A5C As Above, So Below casted damage for raidwide and then glowing blue\r\n# 8A65 Climbing Shot light knockback damage during As Above, So Below\r\n# 8A66 Climbing Shot light knockback damage during As Above, So Below\r\n# 8A67 Climbing Shot light knockback damage during As Above, So Below\r\n# 8A68 Climbing Shot light knockback damage during As Above, So Below\r\n# 8A69 Soaring Minuet cast and damage for back safe 270 cleave\r\n# 8CE2 --sync-- unknown self-targeted ability before Forms\r\n# 8CE5 Quintessence cast and damage for Second Form movement (right cleave)\r\n# 8CE6 Quintessence cast and damage for Second Form movement (left cleave)\r\n# 8CE7 Quintessence cast and damage for Second Form movement (under)\r\n# 8CE8 Quintessence cast and damage for Third Form movement (right cleave)\r\n# 8CE9 Quintessence cast and damage for Third Form movement (left cleave)\r\n# 8CEA Quintessence cast and damage for Third Form movement (under)\r\n# 8CEC Destructive Bolt self-targeted castbar for stack marker\r\n# 8CFB Eudaimon Eorzea casted raidwide damage after captain planet small raidwides\r\n# 8CFD Destructive Bolt player-targeted stack damage\r\n# 8CFE Once Burned casted ability for initial zero damage orange puddles when glowing blue\r\n# 8CFF Everfire casted ability for initial zero damage blue puddles when glowing orange\r\n# 8D00 Once Burned casted damage for initial orange puddles\r\n# 8D01 Everfire casted damage for initial blue puddles\r\n# 8D02 Once Burned damage for moving orange puddles\r\n# 8D03 Everfire casted damage moving blue puddles\r\n# 8D0A Climbing Shot self-targeted castbar for knockback during As Above, So Below\r\n# 8D0B Climbing Shot self-targeted castbar for knockback during As Above, So Below\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/deepdungeon/eureka_orthos_floors_01-10.ts




// Eureka Orthos Floors 01-10

const eureka_orthos_floors_01_10_triggerSet = {
  id: 'EurekaOrthosFloors1_10',
  zoneId: zone_id/* default.EurekaOrthosFloors1_10 */.Z.EurekaOrthosFloors1_10,
  triggers: [
  // ---------------- Floor 01-09 Mobs ----------------
  {
    id: 'EO 01-10 Orthos Grenade Big Burst',
    type: 'StartsUsing',
    netRegex: {
      id: '7E7D',
      source: 'Orthos Grenade',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 01-10 Orthos Behemoth Wild Horn',
    type: 'StartsUsing',
    netRegex: {
      id: '7E7C',
      source: 'Orthos Behemoth'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'EO 01-10 Orthos Fachan Dread Gaze',
    type: 'StartsUsing',
    netRegex: {
      id: '7E82',
      source: 'Orthos Fachan',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  },
  // ---------------- Floor 10 Boss: Gancanagh ----------------
  {
    id: 'EO 01-10 Gancanagh Mandrastorm',
    type: 'StartsUsing',
    netRegex: {
      id: '7AF7',
      source: 'Gancanagh',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Gancanagh': 'Gancanagh',
      'Orthos Behemoth': 'Orthos-Behemoth',
      'Orthos Fachan': 'Orthos-Fachan',
      'Orthos Grenade': 'Orthos-Granate'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Gancanagh': 'Gancanagh',
      'Orthos Behemoth': 'béhémoth Orthos',
      'Orthos Fachan': 'fachan Orthos',
      'Orthos Grenade': 'grenado Orthos'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Gancanagh': 'ガンカナグー',
      'Orthos Behemoth': 'オルト・ベヒーモス',
      'Orthos Fachan': 'オルト・ファハン',
      'Orthos Grenade': 'オルト・グレネード'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Gancanagh': '蜜言妖',
      'Orthos Behemoth': '正统贝希摩斯',
      'Orthos Fachan': '正统幽鬼之眼',
      'Orthos Grenade': '正统榴弹怪'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Gancanagh': '간카나',
      'Orthos Behemoth': '오르토스 베히모스',
      'Orthos Fachan': '오르토스 파한',
      'Orthos Grenade': '오르토스 그레네이드'
    }
  }]
};
/* harmony default export */ const eureka_orthos_floors_01_10 = (eureka_orthos_floors_01_10_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/deepdungeon/eureka_orthos_floors_11-20.ts



// Eureka Orthos Floors 11-20
// TODO: Cloning Node cone AoE safe-spots?
const eureka_orthos_floors_11_20_triggerSet = {
  id: 'EurekaOrthosFloors11_20',
  zoneId: zone_id/* default.EurekaOrthosFloors11_20 */.Z.EurekaOrthosFloors11_20,
  triggers: [
  // ---------------- Floor 11-19 Mobs ----------------
  {
    id: 'EO 11-20 Orthos Sawtooth Mean Thrash',
    type: 'StartsUsing',
    netRegex: {
      id: '7E93',
      source: 'Orthos Sawtooth',
      capture: false
    },
    response: responses/* Responses.goFront */.n3.goFront()
  }
  // ---------------- Floor 20 Boss: Cloning Node ----------------
  // intentionally blank
  ],

  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Orthos Sawtooth': 'Orthos-Sägezahn'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Orthos Sawtooth': 'dentata Orthos'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Orthos Sawtooth': 'オルト・ソウトゥース'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Orthos Sawtooth': '正统锯齿花'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Orthos Sawtooth': '오르토스 톱날이빨'
    }
  }]
};
/* harmony default export */ const eureka_orthos_floors_11_20 = (eureka_orthos_floors_11_20_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/deepdungeon/eureka_orthos_floors_21-30.ts




// Eureka Orthos Floors 21-30

const eureka_orthos_floors_21_30_triggerSet = {
  id: 'EurekaOrthosFloors21_30',
  zoneId: zone_id/* default.EurekaOrthosFloors21_30 */.Z.EurekaOrthosFloors21_30,
  triggers: [
  // ---------------- Floor 21-29 Mobs ----------------
  {
    id: 'EO 21-30 Lesser Orthos Dragon Swinge',
    type: 'StartsUsing',
    netRegex: {
      id: '7EA5',
      source: 'Lesser Orthos Dragon',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'EO 21-30 Orthoknight Electromagnetism',
    type: 'StartsUsing',
    netRegex: {
      id: '7E9D',
      source: 'Orthoknight',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 21-30 Orthos Vanara Scythe Tail',
    type: 'StartsUsing',
    netRegex: {
      id: '7EAC',
      source: 'Orthos Vanara',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 21-30 Orthoshelled Dragon Diamondback',
    type: 'StartsUsing',
    netRegex: {
      id: '7EAF',
      source: 'Orthoshelled Dragon'
    },
    response: responses/* Responses.interruptIfPossible */.n3.interruptIfPossible()
  }, {
    id: 'EO 21-30 Orthos Brobinyak Cold Gaze',
    type: 'StartsUsing',
    netRegex: {
      id: '7EAB',
      source: 'Orthos Brobinyak',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  },
  // ---------------- Floor 30 Boss: Tiamat Clone ----------------
  {
    id: 'EO 21-30 Tiamat Clone Dark Wyrmwing',
    type: 'StartsUsing',
    netRegex: {
      id: '7C65',
      source: 'Tiamat\'s Clone',
      capture: false
    },
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'EO 21-30 Tiamat Clone Dark Wyrmtail',
    type: 'StartsUsing',
    netRegex: {
      id: '7C63',
      source: 'Tiamat\'s Clone',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'EO 21-30 Tiamat Clone Whei Morn',
    type: 'HeadMarker',
    netRegex: {
      id: '00C5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, outputs) => outputs.text(),
    outputStrings: {
      text: {
        en: '5x chasing puddles on you!',
        de: '5x verfolgende Flächen auf dir!',
        fr: '5x zones au sol chainées sur vous !',
        ja: '5連続AOE回避',
        cn: '5连追踪AOE点名!',
        ko: '따라오는 5연속 장판 피하기!'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Lesser Orthos Dragon': 'nieder(?:e|er|es|en) Orthos-Drache',
      'Orthoknight': 'Orthoritter',
      'Orthos Brobinyak': 'Orthos-Brobinyak',
      'Orthos Vanara': 'Orthos-Vanara',
      'Orthoshelled Dragon': 'Orthos-Panzerdrache',
      'Tiamat\'s Clone': 'Tiamat-Klon'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Lesser Orthos Dragon': 'maître aérien mineur Orthos',
      'Orthoknight': 'chevalier Orthos',
      'Orthos Brobinyak': 'brobinyak Orthos',
      'Orthos Vanara': 'vanara Orthos',
      'Orthoshelled Dragon': 'dragon Orthos à carapace',
      'Tiamat\'s Clone': 'clone de Tiamat'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Lesser Orthos Dragon': 'オルト・レッサードラゴン',
      'Orthoknight': 'オルト・ナイト',
      'Orthos Brobinyak': 'オルト・ブロビニャク',
      'Orthos Vanara': 'オルト・ヴァナラ',
      'Orthoshelled Dragon': 'オルト・カラペスドラゴン',
      'Tiamat\'s Clone': 'ティアマット・クローン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Lesser Orthos Dragon': '正统小龙',
      'Orthoknight': '正统骑士',
      'Orthos Brobinyak': '正统布罗宾雅克',
      'Orthos Vanara': '正统婆那罗',
      'Orthoshelled Dragon': '正统龟甲龙',
      'Tiamat\'s Clone': '提亚马特复制体'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Lesser Orthos Dragon': '오르토스 하급 드래곤',
      'Orthoknight': '오르토스 기사',
      'Orthos Brobinyak': '오르토스 브로비냐크',
      'Orthos Vanara': '오르토스 바나라',
      'Orthoshelled Dragon': '오르토스 장갑드래곤',
      'Tiamat\'s Clone': '티아마트 클론'
    }
  }]
};
/* harmony default export */ const eureka_orthos_floors_21_30 = (eureka_orthos_floors_21_30_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/deepdungeon/eureka_orthos_floors_31-40.ts




// Eureka Orthos Floors 31-40

const eureka_orthos_floors_31_40_triggerSet = {
  id: 'EurekaOrthosFloors31_40',
  zoneId: zone_id/* default.EurekaOrthosFloors31_40 */.Z.EurekaOrthosFloors31_40,
  triggers: [
  // ---------------- Floor 31-39 Mobs ----------------
  {
    id: 'EO 31-40 Orthos Mirrorknight Double Hex Eye',
    type: 'StartsUsing',
    netRegex: {
      id: '7EB5',
      source: 'Orthos Mirrorknight',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'EO 31-40 Orthospider Particle Collision',
    type: 'StartsUsing',
    netRegex: {
      id: '7F25',
      source: 'Orthospider',
      capture: false
    },
    response: responses/* Responses.outOfMelee */.n3.outOfMelee('alert')
  }, {
    id: 'EO 31-40 Orthonaga Cursed Gaze',
    type: 'StartsUsing',
    netRegex: {
      id: '7EC0',
      source: 'Orthonaga',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'EO 31-40 Orthotaur 111-tonze Swing',
    type: 'StartsUsing',
    netRegex: {
      id: '7EB8',
      source: 'Orthotaur',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 31-40 Orthotaur 11-tonze Swipe',
    type: 'StartsUsing',
    netRegex: {
      id: '7EB7',
      source: 'Orthotaur',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'EO 31-40 Phantom Orthoray Forearming',
    type: 'StartsUsing',
    netRegex: {
      id: '8193',
      source: 'Phantom Orthoray',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'EO 31-40 Phantom Orthoray Atmospheric Displacement',
    type: 'StartsUsing',
    netRegex: {
      id: '7EB4',
      source: 'Phantom Orthoray',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 31-40 Orthochimera the Ram\'s Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '7EBB',
      source: 'Orthochimera',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 31-40 Orthochimera the Dragon\'s Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '7EBC',
      source: 'Orthochimera',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'EO 31-40 Orthoempuse Kneeling Snath',
    type: 'StartsUsing',
    netRegex: {
      id: '7EC1',
      source: 'Orthoempuse'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.knockback */.n3.knockback()
  },
  // ---------------- Floor 40 Boss: Twintania Clone ----------------
  {
    id: 'EO 31-40 Twintania Clone Twister',
    type: 'StartsUsing',
    netRegex: {
      id: '7AEC',
      source: 'Twintania\'s Clone'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Twisters',
        de: 'Wirbelstürme',
        fr: 'Tornades',
        ja: '大竜巻',
        cn: '旋风',
        ko: '회오리'
      }
    }
  }, {
    id: 'EO 31-40 Twintania Clone Twisting Dive Divebomb',
    type: 'StartsUsing',
    netRegex: {
      id: '7AEF',
      source: 'Twintania\'s Clone',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'DIVEBOMB',
        de: 'STURZBOMBE',
        fr: 'BOMBE PLONGEANTE',
        ja: 'ダイブボム',
        cn: '俯冲',
        ko: '급강하'
      }
    }
  }, {
    id: 'EO 31-40 Twintania Clone Twisting Dive Twisters',
    type: 'Ability',
    netRegex: {
      id: '7AEF',
      source: 'Twintania\'s Clone',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Twisters',
        de: 'Wirbelstürme',
        fr: 'Tornades',
        ja: 'ツイスター',
        cn: '旋风',
        ko: '회오리'
      }
    }
  }, {
    id: 'EO 31-40 Twintania Clone Turbine',
    type: 'StartsUsing',
    netRegex: {
      id: '7AEB',
      source: 'Twintania\'s Clone',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Orthochimera': 'Orthochimära',
      'Orthoempuse': 'Orthos-Empusa',
      'Orthonaga': 'Orthos-Naga',
      'Orthos Mirrorknight': 'Orthos-Speglidae',
      'Orthospider': 'Orthos-Spinne',
      'Orthotaur': 'Orthotaurus',
      'Phantom Orthoray': 'Orthos-Phantomschimmer',
      'Twintania\'s Clone': 'Twintania-Klon'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Orthochimera': 'chimère Orthos',
      'Orthoempuse': 'empousa Orthos',
      'Orthonaga': 'naga Orthos',
      'Orthos Mirrorknight': 'chevalier miroir Orthos',
      'Orthospider': 'araignée Orthos',
      'Orthotaur': 'minotaure Orthos',
      'Phantom Orthoray': 'rayon fantomatique Orthos',
      'Twintania\'s Clone': 'clone de Gémellia'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Orthochimera': 'オルト・キマイラ',
      'Orthoempuse': 'オルト・エンプーサ',
      'Orthonaga': 'オルト・ナーガ',
      'Orthos Mirrorknight': 'オルト・ミラーナイト',
      'Orthospider': 'オルト・スパイダー',
      'Orthotaur': 'オルト・ミノタウロス',
      'Phantom Orthoray': 'オルト・ファントムレイ',
      'Twintania\'s Clone': 'ツインタニア・クローン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Orthochimera': '正统奇美拉',
      'Orthoempuse': '正统疫虫',
      'Orthonaga': '正统那迦',
      'Orthos Mirrorknight': '正统镜骑士',
      'Orthospider': '正统蜘蛛',
      'Orthotaur': '正统弥诺陶洛斯',
      'Phantom Orthoray': '正统幻影光',
      'Twintania\'s Clone': '双塔尼亚复制体'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Orthochimera': '오르토스 키마이라',
      'Orthoempuse': '오르토스 엠푸사',
      'Orthonaga': '오르토스 나가',
      'Orthos Mirrorknight': '오르토스 거울기사',
      'Orthospider': '오르토스 거미',
      'Orthotaur': '오르토스 미노타우로스',
      'Phantom Orthoray': '오르토스 환영 광선',
      'Twintania\'s Clone': '트윈타니아 클론'
    }
  }]
};
/* harmony default export */ const eureka_orthos_floors_31_40 = (eureka_orthos_floors_31_40_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/deepdungeon/eureka_orthos_floors_41-50.ts





// Eureka Orthos Floors 41-50

const eureka_orthos_floors_41_50_triggerSet = {
  id: 'EurekaOrthosFloors41_50',
  zoneId: zone_id/* default.EurekaOrthosFloors41_50 */.Z.EurekaOrthosFloors41_50,
  triggers: [
  // ---------------- Floor 41-49 Mobs ----------------
  {
    id: 'EO 41-50 Orthos Bergthurs Elbow Drop',
    type: 'StartsUsing',
    netRegex: {
      id: '8198',
      source: 'Orthos Bergthurs',
      capture: false
    },
    response: responses/* Responses.goFront */.n3.goFront()
  }, {
    id: 'EO 41-50 Orthos Acheron Quake',
    type: 'StartsUsing',
    netRegex: {
      id: '7ED6',
      source: 'Orthos Acheron'
    },
    alertText: (data, matches, output) => {
      if (data.CanSilence()) return output.interruptOrOut({
        name: matches.source
      });
      return output.out();
    },
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      interruptOrOut: {
        en: 'Out or interrupt ${name}',
        de: 'Raus oder unterbreche ${name}',
        fr: 'Extérieur ou interrompez ${name}',
        ja: '沈黙: ${name}',
        cn: '出去或打断 ${name}',
        ko: '밖으로 또는 ${name} 시전 끊기'
      }
    }
  }, {
    id: 'EO 41-50 Orthos Kelpie Bloody Puddle',
    type: 'StartsUsing',
    netRegex: {
      id: '7ECC',
      source: 'Orthos Kelpie',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 41-50 Orthos Goobbue Sickly Sneeze',
    // Inhale (819A) draws in, Sickly Sneeze (7ED9) is quick front cone after
    type: 'StartsUsing',
    netRegex: {
      id: '7ED9',
      source: 'Orthos Goobbue',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'EO 41-50 Orthos Gelato Explosion',
    type: 'StartsUsing',
    netRegex: {
      id: '7EC4',
      source: 'Orthos Gelato',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 41-50 Orthos Hoarhound Abyssal Cry',
    // roomwide stun AoE with follow-up one-shot attack on stunned players; can break line-of-sight to avoid
    type: 'StartsUsing',
    netRegex: {
      id: '7ED3',
      source: 'Orthos Hoarhound'
    },
    alertText: (_data, matches, output) => output.text({
      name: matches.source
    }),
    outputStrings: {
      text: {
        en: 'Break line-of-sight to ${name}',
        de: 'Unterbreche Sichtlinie zu ${name}',
        fr: 'Masquez le champ de vision vers ${name}',
        ja: '${name}の視線から隠れる',
        cn: '利用掩体卡 ${name} 的视线',
        ko: '${name}의 시야 밖으로 숨기'
      }
    }
  },
  // ---------------- Floor 50 Boss: Servomechanical Chimera 14X ----------------
  {
    id: 'EO 41-50 Servomechanical Chimera 14X Leftbreathed Thunder',
    type: 'StartsUsing',
    netRegex: {
      id: '7C75',
      source: 'Servomechanical Chimera 14X',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'EO 41-50 Servomechanical Chimera 14X Rightbreathed Cold',
    type: 'StartsUsing',
    netRegex: {
      id: '7C77',
      source: 'Servomechanical Chimera 14X',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'EO 41-50 Servomechanical Chimera 14X Songs of Ice and Thunder',
    type: 'StartsUsing',
    netRegex: {
      id: '7C6B',
      source: 'Servomechanical Chimera 14X',
      capture: false
    },
    response: responses/* Responses.getOutThenIn */.n3.getOutThenIn('alert')
  }, {
    id: 'EO 41-50 Servomechanical Chimera 14X Songs of Thunder and Ice',
    type: 'StartsUsing',
    netRegex: {
      id: '7C6C',
      source: 'Servomechanical Chimera 14X',
      capture: false
    },
    response: responses/* Responses.getInThenOut */.n3.getInThenOut('alert')
  }, {
    id: 'EO 41-50 Servomechanical Chimera 14X Tether',
    type: 'Tether',
    netRegex: {
      id: '0039',
      source: 'Servomechanical Chimera 14X'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Run Away From Boss',
        de: 'Renn weg vom Boss',
        fr: 'Éloignez-vous du boss',
        ja: 'ボスから離れる',
        cn: '远离Boss',
        ko: '보스와 거리 벌리기'
      }
    }
  }, {
    id: 'EO 41-50 Servomechanical Chimera 14X Cold Thunder',
    type: 'StartsUsing',
    netRegex: {
      id: '7C6F',
      source: 'Servomechanical Chimera 14X',
      capture: false
    },
    delaySeconds: 2,
    response: responses/* Responses.getOutThenIn */.n3.getOutThenIn('alert')
  }, {
    id: 'EO 41-50 Servomechanical Chimera 14X Thunderous Cold',
    type: 'StartsUsing',
    netRegex: {
      id: '7C70',
      source: 'Servomechanical Chimera 14X',
      capture: false
    },
    delaySeconds: 2,
    response: responses/* Responses.getInThenOut */.n3.getInThenOut('alert')
  }, {
    id: 'EO 41-50 Servomechanical Chimera 14X Cacophony',
    type: 'Tether',
    netRegex: {
      source: 'Cacophony',
      id: '0011'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Orb on YOU',
        de: 'Orb auf DIR',
        fr: 'Orbe sur VOUS',
        ja: '自分に玉',
        cn: '球点名',
        ko: '구슬 대상자'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Cacophony': 'Kakophonie',
      'Orthos Acheron': 'Orthos-Acheron',
      'Orthos Bergthurs': 'Orthos-Jötunn',
      'Orthos Gelato': 'Orthos-Gelato',
      'Orthos Goobbue': 'Orthos-Goobbue',
      'Orthos Hoarhound': 'Orthos-Höllenhund',
      'Orthos Kelpie': 'Orthos-Kelpie',
      'Servomechanical Chimera 14X': 'servomechanisch(?:e|er|es|en) Chimäre 14X'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Cacophony': 'cacophonie',
      'Orthos Acheron': 'achéron Orthos',
      'Orthos Bergthurs': 'bergthurs Orthos',
      'Orthos Gelato': 'gelato Orthos',
      'Orthos Goobbue': 'goobbue Orthos',
      'Orthos Hoarhound': 'ballote Orthos',
      'Orthos Kelpie': 'kelpie Orthos',
      'Servomechanical Chimera 14X': 'chimère servomécanique 14X'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Cacophony': 'カカフォニー',
      'Orthos Acheron': 'オルト・アケローン',
      'Orthos Bergthurs': 'オルト・ベルグスルス',
      'Orthos Gelato': 'オルト・ジェラート',
      'Orthos Goobbue': 'オルト・グゥーブー',
      'Orthos Hoarhound': 'オルト・ホアハウンド',
      'Orthos Kelpie': 'オルト・ケルピー',
      'Servomechanical Chimera 14X': 'サーヴォ・キマイラ14X'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Cacophony': '嘈杂的噪音',
      'Orthos Acheron': '正统阿刻戎',
      'Orthos Bergthurs': '正统山巨魔',
      'Orthos Gelato': '正统明胶怪',
      'Orthos Goobbue': '正统古菩猩猩',
      'Orthos Hoarhound': '正统霜狼',
      'Orthos Kelpie': '正统凯尔派',
      'Servomechanical Chimera 14X': '自控化奇美拉14X'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Cacophony': '불협화음',
      'Orthos Acheron': '오르토스 아케론',
      'Orthos Bergthurs': '오르토스 베르그투르스',
      'Orthos Gelato': '오르토스 젤라토',
      'Orthos Goobbue': '오르토스 구부',
      'Orthos Hoarhound': '오르토스 호어하운드',
      'Orthos Kelpie': '오르토스 켈피',
      'Servomechanical Chimera 14X': '자동제어 키마이라 14X'
    }
  }]
};
/* harmony default export */ const eureka_orthos_floors_41_50 = (eureka_orthos_floors_41_50_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/deepdungeon/eureka_orthos_floors_51-60.ts





// Eureka Orthos Floors 51-60

const eureka_orthos_floors_51_60_triggerSet = {
  id: 'EurekaOrthosFloors51_60',
  zoneId: zone_id/* default.EurekaOrthosFloors51_60 */.Z.EurekaOrthosFloors51_60,
  triggers: [
  // ---------------- Floor 51-59 Mobs ----------------
  {
    id: 'EO 51-60 Orthos Ice Sprite Hypothermal Combustion',
    // explodes in a letal PBAoE after death
    type: 'StartsUsing',
    netRegex: {
      id: '7EF0',
      source: 'Orthos Ice Sprite',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 51-60 Orthos Ymir Gelid Charge',
    // gains Ice Spikes (C6), lethal counterattack when hit with physical damage
    type: 'StartsUsing',
    netRegex: {
      id: '819C',
      source: 'Orthos Ymir'
    },
    response: responses/* Responses.stunIfPossible */.n3.stunIfPossible()
  }, {
    id: 'EO 51-60 Orthos Ymir Ice Spikes Gain',
    // C6 = Ice Spikes, lethal counterattack damage when hit with physical damage
    type: 'GainsEffect',
    netRegex: {
      effectId: 'C6',
      target: 'Orthos Ymir'
    },
    alertText: (_data, matches, output) => output.text({
      target: matches.target
    }),
    outputStrings: {
      text: {
        en: 'Stop attacking ${target}',
        de: 'Stoppe Angriffe auf ${target}',
        fr: 'Arrêtez d\'attaquer ${target}',
        ja: '攻撃禁止: ${target}',
        cn: '停止攻击 ${target}',
        ko: '${target} 공격 중지'
      }
    }
  }, {
    id: 'EO 51-60 Orthos Rockfin Aqua Spear',
    // lethal line charge AoE; can break line-of-sight to avoid
    type: 'StartsUsing',
    netRegex: {
      id: '7EF4',
      source: 'Orthos Rockfin'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, matches, output) => output.text({
      name: matches.source
    }),
    outputStrings: {
      text: {
        en: 'Break line-of-sight to ${name}',
        de: 'Unterbreche Sichtlinie zu ${name}',
        fr: 'Masquez le champ de vision vers ${name}',
        ja: '${name}の視線から隠れる',
        cn: '利用掩体卡 ${name} 的视线',
        ko: '${name}의 시야 밖으로 숨기'
      }
    }
  }, {
    id: 'EO 51-60 Orthos Big Claw Crab Dribble',
    type: 'StartsUsing',
    netRegex: {
      id: '7EE5',
      source: 'Orthos Big Claw',
      capture: false
    },
    response: responses/* Responses.goFront */.n3.goFront()
  }, {
    id: 'EO 51-60 Orthos Zaratan Sewer Water Back First',
    type: 'StartsUsing',
    netRegex: {
      id: '7EEB',
      source: 'Orthos Zaratan',
      capture: false
    },
    response: responses/* Responses.getBackThenFront */.n3.getBackThenFront('alert')
  }, {
    id: 'EO 51-60 Orthos Zaratan Sewer Water Front First',
    type: 'StartsUsing',
    netRegex: {
      id: '7EEC',
      source: 'Orthos Zaratan',
      capture: false
    },
    response: responses/* Responses.getFrontThenBack */.n3.getFrontThenBack('alert')
  }, {
    id: 'EO 51-60 Orthos Stingray Expulsion',
    type: 'StartsUsing',
    netRegex: {
      id: '81A1',
      source: 'Orthos Stingray',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 51-60 Orthos Stingray Electric Whorl',
    type: 'StartsUsing',
    netRegex: {
      id: '81A2',
      source: 'Orthos Stingray',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  },
  // ---------------- Floor 60 Boss: Servomechanical Minotaur 16 ----------------
  {
    id: 'EO 51-60 Servomechanical Minotaur 16 Bullish Swipe',
    type: 'StartsUsing',
    netRegex: {
      id: '801B',
      source: 'Servomechanical Minotaur 16',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'EO 51-60 Servomechanical Minotaur 16 Bullish Swing',
    type: 'StartsUsing',
    netRegex: {
      id: '7C83',
      source: 'Servomechanical Minotaur 16',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 51-60 Servomechanical Minotaur 16 Disorienting Groan',
    // knockback, will push all the way into damage wall if not under boss
    type: 'StartsUsing',
    netRegex: {
      id: '7C84',
      source: 'Servomechanical Minotaur 16',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'EO 51-60 Servomechanical Minotaur 16 Octuple Swipe Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '7C80',
      source: 'Servomechanical Minotaur 16',
      capture: false
    },
    run: data => {
      delete data.octupleSwipes;
      delete data.calledOctupleSwipes;
    }
  }, {
    id: 'EO 51-60 Servomechanical Minotaur 16 Octuple Swipe',
    type: 'Ability',
    netRegex: {
      id: '7C7B',
      source: 'Servomechanical Minotaur 16'
    },
    condition: data => !data.calledOctupleSwipes,
    durationSeconds: 10,
    alertText: (data, matches, output) => {
      // convert the heading into 0=N, 1=E, 2=S, 3=W
      const heading = Math.round(2 - 2 * parseFloat(matches.heading) / Math.PI) % 4;
      data.octupleSwipes ??= [];
      data.octupleSwipes.push(heading);
      if (data.octupleSwipes.length <= 4) return;
      data.calledOctupleSwipes = true;
      if (data.octupleSwipes[0] === data.octupleSwipes[4])
        // swipe order is Front > Back > Right > Left > Front > Back > Right > Left
        return output.text({
          dir1: output.left(),
          dir2: output.front(),
          dir3: output.left(),
          dir4: output.front()
        });
      if (data.octupleSwipes[3] === data.octupleSwipes[4])
        // swipe order is Front > Back > Right > Left > Left > Right > Back > Front
        return output.text({
          dir1: output.left(),
          dir2: output.front(),
          dir3: output.front(),
          dir4: output.left()
        });

      // something went wrong
      data.calledOctupleSwipes = false;
      return;
    },
    outputStrings: {
      front: outputs/* default.front */.Z.front,
      left: outputs/* default.left */.Z.left,
      text: {
        en: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        de: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        fr: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        ja: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        cn: '${dir1} > ${dir2} > ${dir3} > ${dir4}',
        ko: '${dir1} > ${dir2} > ${dir3} > ${dir4}'
      }
    }
  }, {
    id: 'EO 51-60 Servomechanical Minotaur 16 Thundercall',
    type: 'StartsUsing',
    netRegex: {
      id: '7C81',
      source: 'Servomechanical Minotaur 16',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Orthos Big Claw': 'Orthos-Mörderkrabbe',
      'Orthos Ice Sprite': 'Orthos-Eis-Exergon',
      'Orthos Rockfin': 'Orthos-Felsenflosse',
      'Orthos Stingray': 'Orthos-Manta',
      'Orthos Ymir': 'Orthos-Ymir',
      'Orthos Zaratan': 'Orthos-Zaratan',
      'Servomechanical Minotaur 16': 'servomechanisch(?:e|er|es|en) Minotaurus 16'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Orthos Big Claw': 'grosse pince Orthos',
      'Orthos Ice Sprite': 'élémentaire de glace Orthos',
      'Orthos Rockfin': 'rocquin Orthos',
      'Orthos Stingray': 'raie Orthos',
      'Orthos Ymir': 'bulot Orthos',
      'Orthos Zaratan': 'zaratan Orthos',
      'Servomechanical Minotaur 16': 'minotaure servomécanique 16'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Orthos Big Claw': 'オルト・ビッグクロウ',
      'Orthos Ice Sprite': 'オルト・アイススプライト',
      'Orthos Rockfin': 'オルト・ロックフィン',
      'Orthos Stingray': 'オルト・スティングレイ',
      'Orthos Ymir': 'オルト・ユミール',
      'Orthos Zaratan': 'オルト・ザラタン',
      'Servomechanical Minotaur 16': 'サーヴォ・ミノタウロス16'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Orthos Big Claw': '正统大螯陆蟹',
      'Orthos Ice Sprite': '正统冰元精',
      'Orthos Rockfin': '正统石鳍鲨',
      'Orthos Stingray': '正统刺魟',
      'Orthos Ymir': '正统尤弥尔',
      'Orthos Zaratan': '正统扎拉坦',
      'Servomechanical Minotaur 16': '自控化弥诺陶洛斯16'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Orthos Big Claw': '오르토스 왕집게',
      'Orthos Ice Sprite': '오르토스 얼음 정령',
      'Orthos Rockfin': '오르토스 바위지느러미',
      'Orthos Stingray': '오르토스 창가오리',
      'Orthos Ymir': '오르토스 위미르',
      'Orthos Zaratan': '오르토스 자라탄',
      'Servomechanical Minotaur 16': '자동제어 미노타우로스 16'
    }
  }]
};
/* harmony default export */ const eureka_orthos_floors_51_60 = (eureka_orthos_floors_51_60_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/deepdungeon/eureka_orthos_floors_61-70.ts




// Eureka Orthos Floors 61-70

const eureka_orthos_floors_61_70_triggerSet = {
  id: 'EurekaOrthosFloors61_70',
  zoneId: zone_id/* default.EurekaOrthosFloors61_70 */.Z.EurekaOrthosFloors61_70,
  triggers: [
  // ---------------- Floor 61-69 Mobs ----------------
  {
    id: 'EO 61-70 Orthos Cobra Whip Back',
    type: 'StartsUsing',
    netRegex: {
      id: '80BA',
      source: 'Orthos Cobra',
      capture: false
    },
    response: responses/* Responses.goFront */.n3.goFront()
  }, {
    id: 'EO 61-70 Orthos Palleon Body Press',
    type: 'StartsUsing',
    netRegex: {
      id: '80CF',
      source: 'Orthos Palleon',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 61-70 Orthos Gowrow Ripper Claw',
    type: 'StartsUsing',
    netRegex: {
      id: '80D7',
      source: 'Orthos Gowrow',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'EO 61-70 Orthos Gowrow Tail Smash',
    type: 'StartsUsing',
    netRegex: {
      id: '80DA',
      source: 'Orthos Gowrow',
      capture: false
    },
    response: responses/* Responses.goFront */.n3.goFront()
  }, {
    id: 'EO 61-70 Orthos Drake Smoldering Scales',
    // gains Blaze Spikes (C5), lethal counterattack when hit with physical damage
    type: 'StartsUsing',
    netRegex: {
      id: '80B8',
      source: 'Orthos Drake'
    },
    response: responses/* Responses.stunIfPossible */.n3.stunIfPossible()
  }, {
    id: 'EO 61-70 Orthos Drake Blaze Spikes Gain',
    // C5 = Blaze Spikes, lethal counterattack damage when hit with physical damage
    type: 'GainsEffect',
    netRegex: {
      effectId: 'C5',
      target: 'Orthos Drake'
    },
    alertText: (_data, matches, output) => output.text({
      target: matches.target
    }),
    outputStrings: {
      text: {
        en: 'Stop attacking ${target}',
        de: 'Stoppe Angriffe auf ${target}',
        fr: 'Arrêtez d\'attaquer ${target}',
        ja: '攻撃禁止: ${target}',
        cn: '停止攻击 ${target}',
        ko: '${target} 공격 중지'
      }
    }
  }, {
    id: 'EO 61-70 Orthos Falak Electric Cachexia',
    type: 'StartsUsing',
    netRegex: {
      id: '80D3',
      source: 'Orthos Falak',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'EO 61-70 Orthos Basilisk Stone Gaze',
    type: 'StartsUsing',
    netRegex: {
      id: '80C7',
      source: 'Orthos Basilisk',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  },
  // ---------------- Floor 70 Boss: Aeturna ----------------
  {
    id: 'EO 61-70 Aeturna Steel Claw',
    type: 'StartsUsing',
    netRegex: {
      id: '7AD5',
      source: 'Aeturna'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'EO 61-70 Aeturna Ferocity',
    type: 'Tether',
    netRegex: {
      id: '0039',
      source: 'Aeturna'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Run Away From Boss',
        de: 'Renn weg vom Boss',
        fr: 'Courez loin du boss',
        ja: 'ボスから離れる',
        cn: '远离Boss',
        ko: '보스와 거리 벌리기'
      }
    }
  }, {
    id: 'EO 61-70 Aeturna Preternatural Turn In',
    type: 'StartsUsing',
    netRegex: {
      id: '7ACD',
      source: 'Aeturna',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'EO 61-70 Aeturna Preternatural Turn Out',
    type: 'StartsUsing',
    netRegex: {
      id: '7ACC',
      source: 'Aeturna',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 61-70 Aeturna Roar',
    type: 'StartsUsing',
    netRegex: {
      id: '7ACB',
      source: 'Aeturna',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aeturna': 'Aeturna',
      'Orthos Basilisk': 'Orthos-Basilisk',
      'Orthos Cobra': 'Orthos-Kobra',
      'Orthos Drake': 'Orthos-Drakon',
      'Orthos Falak': 'Orthos-Falak',
      'Orthos Gowrow': 'Orthos-Gowrow',
      'Orthos Palleon': 'Orthos-Palleon'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aeturna': 'Aeturna',
      'Orthos Basilisk': 'basilic Orthos',
      'Orthos Cobra': 'cobra Orthos',
      'Orthos Drake': 'draconide Orthos',
      'Orthos Falak': 'falak Orthos',
      'Orthos Gowrow': 'gowrow Orthos',
      'Orthos Palleon': 'palléon Orthos'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aeturna': 'アエテルナエ',
      'Orthos Basilisk': 'オルト・バジリスク',
      'Orthos Cobra': 'オルト・コブラ',
      'Orthos Drake': 'オルト・ドレイク',
      'Orthos Falak': 'オルト・ファラク',
      'Orthos Gowrow': 'オルト・ガウロウ',
      'Orthos Palleon': 'オルト・パレオン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aeturna': '永恒',
      'Orthos Basilisk': '正统石蜥蜴',
      'Orthos Cobra': '正统眼镜蛇',
      'Orthos Drake': '正统烈阳火蛟',
      'Orthos Falak': '正统法拉克',
      'Orthos Gowrow': '正统高牢怪龙',
      'Orthos Palleon': '正统侏儒避役'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aeturna': '아이테르나',
      'Orthos Basilisk': '오르토스 바실리스크',
      'Orthos Cobra': '오르토스 코브라',
      'Orthos Drake': '오르토스 도마뱀',
      'Orthos Falak': '오르토스 팔라크',
      'Orthos Gowrow': '오르토스 가우로우',
      'Orthos Palleon': '오르토스 팔레온'
    }
  }]
};
/* harmony default export */ const eureka_orthos_floors_61_70 = (eureka_orthos_floors_61_70_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/deepdungeon/eureka_orthos_floors_71-80.ts




// Eureka Orthos Floors 71-80

const eureka_orthos_floors_71_80_triggerSet = {
  id: 'EurekaOrthosFloors71_80',
  zoneId: zone_id/* default.EurekaOrthosFloors71_80 */.Z.EurekaOrthosFloors71_80,
  triggers: [
  // ---------------- Floor 71-79 Mobs ----------------
  {
    id: 'EO 71-80 Orthos Toco Toco Slowcall',
    type: 'StartsUsing',
    netRegex: {
      id: '7F7B',
      source: 'Orthos Toco Toco',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'EO 71-80 Orthos Primelephas Rear',
    type: 'StartsUsing',
    netRegex: {
      id: '81A8',
      source: 'Orthos Primelephas',
      capture: false
    },
    response: responses/* Responses.outOfMelee */.n3.outOfMelee('alert')
  }, {
    id: 'EO 71-80 Orthos Coeurl Wide Blaster',
    type: 'StartsUsing',
    netRegex: {
      id: '81A6',
      source: 'Orthos Coeurl',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'EO 71-80 Orthos Coeurl Tail Swing',
    type: 'StartsUsing',
    netRegex: {
      id: '7F87',
      source: 'Orthos Coeurl',
      capture: false
    },
    response: responses/* Responses.goFrontOrSides */.n3.goFrontOrSides()
  }, {
    id: 'EO 71-80 Orthos Thunderbeast Scythe Tail',
    type: 'StartsUsing',
    netRegex: {
      id: '7F90',
      source: 'Orthos Thunderbeast',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 71-80 Orthos Thunderbeast Spark',
    type: 'StartsUsing',
    netRegex: {
      id: '7F94',
      source: 'Orthos Thunderbeast',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'EO 71-80 Orthos Gulo Gulo the Killing Paw',
    type: 'StartsUsing',
    netRegex: {
      id: '81A9',
      source: 'Orthos Gulo Gulo',
      capture: false
    },
    durationSeconds: 5,
    alertText: (_data, _matches, output) => output.getBehind(),
    outputStrings: {
      getBehind: {
        // Telegraphed Killing Paw swipe (81A9) followed by untelegraphed Savage Swipe (7F8E).
        en: 'Get Behind (Stay Behind)',
        de: 'Geh nach hinten (und bleib hinten)',
        fr: 'Allez derrière (Restez derrière)',
        ja: '背面へ (そのまま背面)',
        cn: '去背后 (待在背后)',
        ko: '뒤로 이동 (뒤에 머물기)'
      }
    }
  }, {
    id: 'EO 71-80 Orthos Skatene Chirp',
    // untelegraphed PBAoE sleep; follow-up lethal PBAoE
    type: 'StartsUsing',
    netRegex: {
      id: '7F7D',
      source: 'Orthos Skatene',
      capture: false
    },
    response: responses/* Responses.outOfMelee */.n3.outOfMelee('alert')
  }, {
    id: 'EO 71-80 Orthos Flamebeast Blistering Roar',
    // lethal, large, wide line AoE that goes through walls
    type: 'StartsUsing',
    netRegex: {
      id: '81AF',
      source: 'Orthos Flamebeast',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'EO 71-80 Bird of Orthos Eye of the Fierce',
    // gaze, inflicts Confused (0B) if hit; follows up with lethal AoE on Confused target
    type: 'StartsUsing',
    netRegex: {
      id: '7F9B',
      source: 'Bird of Orthos',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'EO 71-80 Bird of Orthos Revelation',
    // lethal AoE, cast on any targets Confused by Eye of the Fierce
    type: 'StartsUsing',
    netRegex: {
      id: '7F9A',
      source: 'Bird of Orthos'
    },
    response: responses/* Responses.awayFrom */.n3.awayFrom()
  }, {
    id: 'EO 71-80 Orthos Kargas Winds of Winter',
    // lethal large AoE; can stun or break line-of-sight to avoid
    type: 'StartsUsing',
    netRegex: {
      id: '81AA',
      source: 'Orthos Kargas'
    },
    alertText: (data, matches, output) => {
      if (data.CanStun()) return output.stunOrBreakLOS({
        name: matches.source
      });
      return output.breakLOS({
        name: matches.source
      });
    },
    outputStrings: {
      stunOrBreakLOS: {
        en: 'Stun or Break line-of-sight to ${name}',
        de: 'Unterbrechen oder unterbreche die Sichtlinie zu ${name}',
        fr: 'Étourdissez ou masquez le champ de vision vers ${name}',
        ja: 'スタンまたは視線から隠れる: ${name}',
        cn: '眩晕或利用掩体卡 ${name} 的视线',
        ko: '기절 또는 ${name}의 시야 밖으로 숨기'
      },
      breakLOS: {
        en: 'Break line-of-sight to ${name}',
        de: 'Unterbreche Sichtlinie zu ${name}',
        fr: 'Masquez le champ de vision vers ${name}',
        ja: '${name}の視線から隠れる',
        cn: '利用掩体卡 ${name} 的视线',
        ko: '${name}의 시야 밖으로 숨기'
      }
    }
  }, {
    id: 'EO 71-80 Orthos Sasquatch Ripe Banana',
    type: 'StartsUsing',
    // Sasquatch casts Ripe Banana (81AB) for 2s, then ~3s later casts Chest Thump (7FA8) for 0.1s.
    // These can be hard to spot, so this gives a ~5s warning to hide even if you can't see it.
    netRegex: {
      id: '81AB',
      source: 'Orthos Sasquatch'
    },
    alertText: (_data, matches, output) => output.breakLOS({
      name: matches.source
    }),
    outputStrings: {
      breakLOS: {
        en: 'Break line-of-sight to ${name}',
        de: 'Unterbreche Sichtlinie zu ${name}',
        fr: 'Masquez le champ de vision vers ${name}',
        ja: '${name}の視線から隠れる',
        cn: '利用掩体卡 ${name} 的视线',
        ko: '${name}의 시야 밖으로 숨기'
      }
    }
  },
  // ---------------- Floor 80 Boss: Proto-Kaliya ----------------
  {
    id: 'EO 71-80 Proto-Kaliya Resonance',
    type: 'StartsUsing',
    netRegex: {
      id: '7ABE',
      source: 'Proto-Kaliya'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'EO 71-80 Proto-Kaliya Centralized Nerve Gas',
    type: 'StartsUsing',
    netRegex: {
      id: '7ABF',
      source: 'Proto-Kaliya',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'EO 71-80 Proto-Kaliya Leftward Nerve Gas',
    // 180° cleave from front-left to back-right
    type: 'StartsUsing',
    netRegex: {
      id: '7AC0',
      source: 'Proto-Kaliya',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'EO 71-80 Proto-Kaliya Rightward Nerve Gas',
    // 180° cleave from front-right to back-left
    type: 'StartsUsing',
    netRegex: {
      id: '7AC1',
      source: 'Proto-Kaliya',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'EO 71-80 Proto-Kaliya Nerve Gas Ring Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '7AC5',
      source: 'Proto-Kaliya',
      capture: false
    },
    run: data => {
      delete data.charge;
      delete data.droneCharges;
      delete data.pushPull;
    }
  }, {
    id: 'EO 71-80 Proto-Kaliya Nanospore Jet Player Charge Collect',
    // D5A = Positive Charge
    // D5B = Negative Charge
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D5[AB]'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      data.charge = matches.effectId.toUpperCase() === 'D5A';
    }
  }, {
    id: 'EO 71-80 Proto-Kaliya Nanospore Jet Drone Charge Collect',
    // D58 = Positive Charge
    // D59 = Negative Charge
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D5[89]',
      target: 'Weapons Drone'
    },
    run: (data, matches) => {
      data.droneCharges ??= {};
      data.droneCharges[parseInt(matches.targetId, 16)] = matches.effectId.toUpperCase() === 'D58';
    }
  }, {
    id: 'EO 71-80 Proto-Kaliya Nanospore Jet Tether Collect',
    type: 'Tether',
    netRegex: {
      id: '0026',
      source: 'Weapons Drone'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      if (data.charge === undefined) {
        console.error(`Proto-Kaliya Nanospore Jet: missing player charge`);
        return;
      }
      if (!data.droneCharges) {
        console.error(`Proto-Kaliya Nanospore Jet: missing drone charges`);
        return;
      }
      data.pushPull = data.charge === data.droneCharges[parseInt(matches.sourceId, 16)];
    }
  }, {
    id: 'EO 71-80 Proto-Kaliya Nerve Gas Ring',
    type: 'StartsUsing',
    netRegex: {
      id: '7AC2',
      source: 'Proto-Kaliya',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.pushPull === undefined) {
        console.error(`Proto-Kaliya Nerve Gas Ring: missing pushPull`);
        return;
      }
      if (data.pushPull) return output.push();
      return output.pull();
    },
    outputStrings: {
      push: {
        en: 'Get pushed into safe spot',
        de: 'Rückstoß in den sicheren Bereich',
        fr: 'Faites vous pousser dans une zone sûre',
        ja: '安置へノックバック',
        cn: '被击退到安全区',
        ko: '안전지대로 밀려나기'
      },
      pull: {
        en: 'Get pulled into safe spot',
        de: 'Werde in den sicheren Bereich gezogen',
        fr: 'Faites vous attirer dans une zone sûre',
        ja: '安置へ引っ張られる',
        cn: '被吸引到安全区',
        ko: '안전지대로 당겨지기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Bird of Orthos': 'Orthos-Vogel',
      'Orthos Coeurl': 'Orthos-Coeurl',
      'Orthos Flamebeast': 'Orthos-Flammenbestie',
      'Orthos Gulo Gulo': 'Orthos-Gulo Gulo',
      'Orthos Kargas': 'Orthos-Kargas',
      'Orthos Primelephas': 'Orthos-Primelephas',
      'Orthos Sasquatch': 'Orthos-Sasquatch',
      'Orthos Skatene': 'Orthos-Skatene',
      'Orthos Thunderbeast': 'Orthos-Donnerbestie',
      'Orthos Toco Toco': 'Orthos-Tokotoko',
      'Proto-Kaliya': 'Proto-Kaliya',
      'Weapons Drone': 'Artilleriedrohne'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Bird of Orthos': 'oiseau d\'Eurêka Orthos',
      'Orthos Coeurl': 'coeurl Orthos',
      'Orthos Flamebeast': 'bête de feu Orthos',
      'Orthos Gulo Gulo': 'gulo gulo Orthos',
      'Orthos Kargas': 'kargas Orthos',
      'Orthos Primelephas': 'primelephas Orthos',
      'Orthos Sasquatch': 'sasquatch Orthos',
      'Orthos Skatene': 'skate\'ne Orthos',
      'Orthos Thunderbeast': 'bête de foudre Orthos',
      'Orthos Toco Toco': 'toco toco Orthos',
      'Proto-Kaliya': 'proto-Kaliya',
      'Weapons Drone': 'drone armé'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Bird of Orthos': 'バード・オブ・オルト',
      'Orthos Coeurl': 'オルト・クァール',
      'Orthos Flamebeast': 'オルト・フレイムビースト',
      'Orthos Gulo Gulo': 'オルト・グログロ',
      'Orthos Kargas': 'オルト・カルガス',
      'Orthos Primelephas': 'オルト・プリメレファス',
      'Orthos Sasquatch': 'オルト・サスカッチ',
      'Orthos Skatene': 'オルト・スカネテ',
      'Orthos Thunderbeast': 'オルト・サンダービースト',
      'Orthos Toco Toco': 'オルト・トコトコ',
      'Proto-Kaliya': 'プロトカーリア',
      'Weapons Drone': '砲撃ドローン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Bird of Orthos': '正统妖鸟',
      'Orthos Coeurl': '正统长须豹',
      'Orthos Flamebeast': '正统焰兽',
      'Orthos Gulo Gulo': '正统狼獾',
      'Orthos Kargas': '正统卡尔加斯',
      'Orthos Primelephas': '正统曙象',
      'Orthos Sasquatch': '正统大脚巨猿',
      'Orthos Skatene': '正统斯卡尼特',
      'Orthos Thunderbeast': '正统雷兽',
      'Orthos Toco Toco': '正统巨嘴鸟',
      'Proto-Kaliya': '原型卡利亚',
      'Weapons Drone': '炮击无人机'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Bird of Orthos': '오르토스 새',
      'Orthos Coeurl': '오르토스 커얼',
      'Orthos Flamebeast': '오르토스 불꽃 야수',
      'Orthos Gulo Gulo': '오르토스 굴로굴로',
      'Orthos Kargas': '오르토스 카르가스',
      'Orthos Primelephas': '오르토스 프리멜레파스',
      'Orthos Sasquatch': '오르토스 사스콰치',
      'Orthos Skatene': '오르토스 스카네테',
      'Orthos Thunderbeast': '오르토스 번개 야수',
      'Orthos Toco Toco': '오르토스 총총새',
      'Proto-Kaliya': '프로토 칼리야',
      'Weapons Drone': '무인 포격기'
    }
  }]
};
/* harmony default export */ const eureka_orthos_floors_71_80 = (eureka_orthos_floors_71_80_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/deepdungeon/eureka_orthos_floors_81-90.ts




// Eureka Orthos Floors 81-90

const eureka_orthos_floors_81_90_firstHeadmarker = parseInt('0186', 16);
const interceptionOutputStrings = {
  egg: {
    en: 'egg',
    de: 'Ei',
    fr: 'Œuf',
    ja: 'たまご',
    cn: '蛋',
    ko: '알'
  },
  cube: {
    en: 'cubes',
    de: 'Würfel',
    fr: 'Cube',
    ja: '四角',
    cn: '方块',
    ko: '큐브'
  },
  ball: {
    en: 'ball',
    de: 'Ball',
    fr: 'Balle',
    ja: '円',
    // 〇
    cn: '球',
    ko: '공'
  }
};
const eureka_orthos_floors_81_90_triggerSet = {
  id: 'EurekaOrthosFloors81_90',
  zoneId: zone_id/* default.EurekaOrthosFloors81_90 */.Z.EurekaOrthosFloors81_90,
  triggers: [
  // ---------------- Floor 81-89 Mobs ----------------
  {
    id: 'EO 81-90 Orthoiron Corse Glass Punch',
    type: 'StartsUsing',
    netRegex: {
      id: '7FF7',
      source: 'Orthoiron Corse',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'EO 81-90 Orthos Gourmand Moldy Sneeze',
    type: 'StartsUsing',
    netRegex: {
      id: '7FED',
      source: 'Orthos Gourmand',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'EO 81-90 Orthos Catoblepas Demon Eye',
    // roomwide AoE, gives 20s stun
    // 7FFA is the same attack, used out-of-combat
    type: 'StartsUsing',
    netRegex: {
      id: '7FF9',
      source: 'Orthos Catoblepas',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'EO 81-90 Orthos Hecteyes Hex Eye',
    type: 'StartsUsing',
    netRegex: {
      id: '7FDB',
      source: 'Orthos Hecteyes',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'EO 81-90 Orthos Deepeye Hypnotize',
    type: 'StartsUsing',
    netRegex: {
      id: '7FE1',
      source: 'Orthos Deepeye',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'EO 81-90 Orthos Spartoi Triple Trial',
    type: 'StartsUsing',
    netRegex: {
      id: '7FE4',
      source: 'Orthos Spartoi',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'EO 81-90 Orthos Specter Left Sweep',
    type: 'StartsUsing',
    netRegex: {
      id: '8008',
      source: 'Orthos Specter',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'EO 81-90 Orthos Specter Right Sweep',
    type: 'StartsUsing',
    netRegex: {
      id: '8009',
      source: 'Orthos Specter',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'EO 81-90 Orthos Specter Ringing Burst',
    type: 'StartsUsing',
    netRegex: {
      id: '8007',
      source: 'Orthos Specter',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'EO 81-90 Orthos Specter Surrounding Burst',
    type: 'StartsUsing',
    netRegex: {
      id: '8006',
      source: 'Orthos Specter',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 81-90 Orthos Wraith Scream',
    type: 'StartsUsing',
    netRegex: {
      id: '8004',
      source: 'Orthos Wraith',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 81-90 Orthos Ahriman Blustering Blink',
    type: 'StartsUsing',
    netRegex: {
      id: '7FF4',
      source: 'Orthos Ahriman',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'EO 81-90 Orthos Pegasus Nicker',
    type: 'StartsUsing',
    netRegex: {
      id: '8000',
      source: 'Orthos Pegasus',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  },
  // ---------------- Floor 90 Boss: Administrator ----------------
  {
    id: 'EO 81-90 Administrator Peripheral Lasers',
    type: 'StartsUsing',
    netRegex: {
      id: '7AD7',
      source: 'Administrator',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'EO 81-90 Administrator Cross Lasers',
    type: 'StartsUsing',
    netRegex: {
      id: '7AD8',
      source: 'Administrator',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // "Intercardinals" may confuse people between absolute and relative,
        // so add in the "of boss" just to be extra clear.
        en: 'Go Intercardinal of Boss',
        de: 'Geh in eine Intercardinale Himmelsrichtung vom Boss',
        fr: 'Allez en intercardinal du boss',
        ja: 'ボスの斜めへ',
        cn: '去Boss的对角线方向',
        ko: '보스의 대각선 방향으로 피하기'
      }
    }
  }, {
    id: 'EO 81-90 Administrator Laserstream',
    type: 'StartsUsing',
    netRegex: {
      id: '7AE0',
      source: 'Administrator',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'EO 81-90 Administrator Support Systems Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '7AD9',
      source: 'Administrator',
      capture: false
    },
    run: data => {
      delete data.interception;
      delete data.interceptionSequence;
      delete data.salvo;
      delete data.salvoEggs;
      delete data.near;
      delete data.far;
    }
  }, {
    id: 'EO 81-90 Administrator Interception Sequence Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '7ADA',
      source: 'Administrator',
      capture: false
    },
    run: data => {
      data.interception = true;
    }
  }, {
    id: 'EO 81-90 Administrator Interception Sequence Interceptor α Collect',
    // HeadMarker ids do not appear to have random offsets in Eureka Orthos
    // 0186 = first
    // 0187 = second
    // 0188 = third
    type: 'HeadMarker',
    netRegex: {
      id: '018[6-8]',
      target: 'Interceptor α'
    },
    run: (data, matches, output) => {
      const num = parseInt(matches.id, 16) - eureka_orthos_floors_81_90_firstHeadmarker;
      data.interceptionSequence ??= [];
      data.interceptionSequence[num] = output.egg();
    },
    outputStrings: interceptionOutputStrings
  }, {
    id: 'EO 81-90 Administrator Interception Sequence Interceptor β Collect',
    // HeadMarker ids do not appear to have random offsets in Eureka Orthos
    // 0186 = first
    // 0187 = second
    // 0188 = third
    type: 'HeadMarker',
    netRegex: {
      id: '018[6-8]',
      target: 'Interceptor β'
    },
    suppressSeconds: 1,
    run: (data, matches, output) => {
      const num = parseInt(matches.id, 16) - eureka_orthos_floors_81_90_firstHeadmarker;
      data.interceptionSequence ??= [];
      data.interceptionSequence[num] = output.cube();
    },
    outputStrings: interceptionOutputStrings
  }, {
    id: 'EO 81-90 Administrator Interception Sequence Interceptor γ Collect',
    // HeadMarker ids do not appear to have random offsets in Eureka Orthos
    // 0186 = first
    // 0187 = second
    // 0188 = third
    type: 'HeadMarker',
    netRegex: {
      id: '018[6-8]',
      target: 'Interceptor γ'
    },
    run: (data, matches, output) => {
      const num = parseInt(matches.id, 16) - eureka_orthos_floors_81_90_firstHeadmarker;
      data.interceptionSequence ??= [];
      data.interceptionSequence[num] = output.ball();
    },
    outputStrings: interceptionOutputStrings
  }, {
    id: 'EO 81-90 Administrator Interception Sequence',
    // 7ADB = Interceptor α (egg) large cone AoE
    // 7ADC = Interceptor β (cube) line AoE
    // 7ADD = Interceptor γ (ball) donut AoE
    type: 'StartsUsing',
    netRegex: {
      id: '7AD[B-D]',
      capture: false
    },
    condition: data => data.interception,
    durationSeconds: 12,
    suppressSeconds: 8,
    infoText: (data, _matches, output) => {
      if (data.interceptionSequence === undefined || data.interceptionSequence.length < 3) {
        console.error(`Administrator Interception Sequence: array error`);
        return;
      }
      return output.text({
        first: data.interceptionSequence[0],
        second: data.interceptionSequence[1],
        third: data.interceptionSequence[2]
      });
    },
    outputStrings: {
      text: {
        en: '${first} => ${second} => ${third}',
        de: '${first} => ${second} => ${third}',
        fr: '${first} => ${second} => ${third}',
        ja: '${first} => ${second} => ${third}',
        cn: '${first} => ${second} => ${third}',
        ko: '${first} => ${second} => ${third}'
      }
    }
  }, {
    id: 'EO 81-90 Administrator Salvo Script Start Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '7ADF',
      source: 'Administrator',
      capture: false
    },
    run: data => {
      data.salvo = true;
    }
  }, {
    id: 'EO 81-90 Administrator Salvo Script',
    type: 'StartsUsing',
    netRegex: {
      id: '8040',
      source: 'Interceptor α'
    },
    condition: data => data.salvo,
    durationSeconds: 8,
    infoText: (data, matches, output) => {
      // convert heading into 0=N, 1=E, 2=S, 3=W
      const heading = Math.round(2 - 2 * parseFloat(matches.heading) / Math.PI) % 4;

      // convert (x,y) location into 0=N, 1=E, 2=S, 3=W
      // center is (-300,-300)
      const x = parseFloat(matches.x) + 300;
      const y = parseFloat(matches.y) + 300;
      const location = Math.round(2 - 2 * Math.atan2(x, y) / Math.PI) % 4;
      data.salvoEggs ??= [];
      data.salvoEggs.push({
        'location': location,
        'heading': heading
      });
      if (data.salvoEggs.length < 2) return;
      const egg1 = data.salvoEggs.pop();
      const egg2 = data.salvoEggs.pop();
      if (egg1 === undefined || egg2 === undefined) {
        console.error(`Administrator Salvo Script: eggs undefined`);
        return;
      }
      if (Math.abs(egg1.location - egg1.heading) === 2 && Math.abs(egg2.location - egg2.heading) === 2) {
        // both eggs are facing towards the center; safespot is the corner between the eggs
        // 0=N, 1=NE, 2=E, 3=SE, 4=S, 5=SW, 6=W, 7=NW
        const safeSpot = Math.abs(egg1.location - egg2.location) === 3 ? 7 : egg1.location + egg2.location;
        const safeMap = {
          1: output.between({
            safe: output.northEast()
          }),
          3: output.between({
            safe: output.southEast()
          }),
          5: output.between({
            safe: output.southWest()
          }),
          7: output.between({
            safe: output.northWest()
          })
        };
        return safeMap[safeSpot];
      }
      if (Math.abs(egg1.heading - egg2.heading) === 2) {
        // both eggs are facing each other; safespot is the corner perpendicular to the heading of the eggs
        if (Math.abs(egg1.location - egg1.heading) === 2) {
          // egg1 is adjacent to the safespot, egg2 is opposite the safespot
          data.near = egg1.location;
          data.far = (egg2.location + 2) % 4;
        } else {
          // egg1 is opposite the safespot, egg2 is adjacent to the safespot
          data.near = egg2.location;
          data.far = (egg1.location + 2) % 4;
        }
        const safeSpot = Math.abs(data.near - data.far) === 3 ? 7 : data.near + data.far;
        const safeMap = {
          1: output.safe({
            safe: output.northEast()
          }),
          3: output.safe({
            safe: output.southEast()
          }),
          5: output.safe({
            safe: output.southWest()
          }),
          7: output.safe({
            safe: output.northWest()
          })
        };
        return safeMap[safeSpot];
      }
    },
    outputStrings: {
      between: {
        en: '${safe}, between eggs',
        de: '${safe}, zwichen den Eiern',
        fr: '${safe}, entre les œufs',
        ja: '${safe}, たまごの間',
        cn: '${safe}, 蛋中间',
        ko: '${safe}, 알 사이'
      },
      safe: {
        en: '${safe}',
        de: '${safe}',
        fr: '${safe}',
        ja: '${safe}',
        cn: '${safe}',
        ko: '${safe}'
      },
      northEast: outputs/* default.northeast */.Z.northeast,
      southEast: outputs/* default.southeast */.Z.southeast,
      southWest: outputs/* default.southwest */.Z.southwest,
      northWest: outputs/* default.northwest */.Z.northwest
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Administrator': 'Administrator',
      'Interceptor α': 'Hilfssystem α',
      'Interceptor β': 'Hilfssystem β',
      'Interceptor γ': 'Hilfssystem γ',
      'Orthoiron Corse': 'Orthos-Eisenleichnam',
      'Orthos Ahriman': 'Orthos-Ahriman',
      'Orthos Catoblepas': 'Orthos-Catblepus',
      'Orthos Deepeye': 'Orthos-Glotzauge',
      'Orthos Gourmand': 'Orthos-Gourmet',
      'Orthos Hecteyes': 'Orthos-Hektokulus',
      'Orthos Pegasus': 'schwarz(?:e|er|es|en) Orthos-Pegasus',
      'Orthos Spartoi': 'Orthos-Spartoi',
      'Orthos Specter': 'Orthos-Schemen',
      'Orthos Wraith': 'Orthos-Geist'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Administrator': 'Administrateur',
      'Interceptor α': 'intercepteur α',
      'Interceptor β': 'intercepteur β',
      'Interceptor γ': 'intercepteur γ',
      'Orthoiron Corse': 'cors de fer Orthos',
      'Orthos Ahriman': 'ahriman Orthos',
      'Orthos Catoblepas': 'catoblépas Orthos',
      'Orthos Deepeye': 'oculus Orthos',
      'Orthos Gourmand': 'gourmand Orthos',
      'Orthos Hecteyes': 'hectoculus Orthos',
      'Orthos Pegasus': 'pégase sombre Orthos',
      'Orthos Spartoi': 'spartoi Orthos',
      'Orthos Specter': 'spector Orthos',
      'Orthos Wraith': 'spectre Orthos'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Administrator': 'アドミニストレーター',
      'Interceptor α': '要撃システムα',
      'Interceptor β': '要撃システムβ',
      'Interceptor γ': '要撃システムγ',
      'Orthoiron Corse': 'オルト・アイアンコース',
      'Orthos Ahriman': 'オルト・アーリマン',
      'Orthos Catoblepas': 'オルト・カトブレパス',
      'Orthos Deepeye': 'オルト・ディープアイ',
      'Orthos Gourmand': 'オルト・グルマン',
      'Orthos Hecteyes': 'オルト・ヘクトアイズ',
      'Orthos Pegasus': 'オルト・ブラックペガサス',
      'Orthos Spartoi': 'オルト・スパルトイ',
      'Orthos Specter': 'オルト・スペクター',
      'Orthos Wraith': 'オルト・レイス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Administrator': '管理者',
      'Interceptor α': '截击系统α',
      'Interceptor β': '截击系统β',
      'Interceptor γ': '截击系统γ',
      'Orthoiron Corse': '正统铁面腐尸',
      'Orthos Ahriman': '正统冥鬼之眼',
      'Orthos Catoblepas': '正统卡托布莱帕斯',
      'Orthos Deepeye': '正统深瞳',
      'Orthos Gourmand': '正统贪吃鬼',
      'Orthos Hecteyes': '正统百目妖',
      'Orthos Pegasus': '正统黑天马',
      'Orthos Spartoi': '正统地生人',
      'Orthos Specter': '正统妖影',
      'Orthos Wraith': '正统幽灵'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Administrator': '관리자',
      'Interceptor α': '요격 시스템 α',
      'Interceptor β': '요격 시스템 β',
      'Interceptor γ': '요격 시스템 γ',
      'Orthoiron Corse': '오르토스 강철송장',
      'Orthos Ahriman': '오르토스 아리만',
      'Orthos Catoblepas': '오르토스 카토블레파스',
      'Orthos Deepeye': '오르토스 볼록눈',
      'Orthos Gourmand': '오르토스 대식가',
      'Orthos Hecteyes': '오르토스 백눈깔이',
      'Orthos Pegasus': '오르토스 검은 페가수스',
      'Orthos Spartoi': '오르토스 스파르토이',
      'Orthos Specter': '오르토스 그림자요괴',
      'Orthos Wraith': '오르토스 망령'
    }
  }]
};
/* harmony default export */ const eureka_orthos_floors_81_90 = (eureka_orthos_floors_81_90_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/deepdungeon/eureka_orthos_floors_91-100.ts





// Eureka Orthos Floors 91-100
// TODO: Excalibur Exglacialis safe spots
const eureka_orthos_floors_91_100_triggerSet = {
  id: 'EurekaOrthosFloors91_100',
  zoneId: zone_id/* default.EurekaOrthosFloors91_100 */.Z.EurekaOrthosFloors91_100,
  triggers: [
  // ---------------- Floor 91-98 Mobs ----------------
  {
    id: 'EO 91-100 Orthos Mining Drone Aetherochemical Cannon',
    type: 'StartsUsing',
    netRegex: {
      id: '81B0',
      source: 'Orthos Mining Drone',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'EO 91-100 Orthosystem γ High Voltage',
    type: 'StartsUsing',
    netRegex: {
      id: '806E',
      source: 'Orthosystem γ'
    },
    alertText: (data, matches, output) => {
      if (data.CanSilence()) return output.interruptOrOut({
        name: matches.source
      });
      return output.out();
    },
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      interruptOrOut: {
        en: 'Out or interrupt ${name}',
        de: 'Raus oder unterbreche ${name}',
        fr: 'Extérieur ou interrompez ${name}',
        ja: '沈黙: ${name}',
        cn: '出去或打断 ${name}',
        ko: '밖으로 또는 ${name} 시전 끊기'
      }
    }
  }, {
    id: 'EO 91-100 Orthosystem γ Repelling Cannons',
    type: 'StartsUsing',
    netRegex: {
      id: '806D',
      source: 'Orthosystem γ',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 91-100 Orthosystem γ Ring Cannon',
    type: 'StartsUsing',
    netRegex: {
      id: '806C',
      source: 'Orthosystem γ',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'EO 91-100 Orthosystem α Aetherochemical Laser α',
    type: 'StartsUsing',
    netRegex: {
      id: '8074',
      source: 'Orthosystem α',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'EO 91-100 Orthodrone Self-detonate',
    // explodes in lethal PBAoE after death
    type: 'StartsUsing',
    netRegex: {
      id: '806A',
      source: 'Orthodrone',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 91-100 Orthos Motherbit Citadel Buster',
    type: 'StartsUsing',
    netRegex: {
      id: '8084',
      source: 'Orthos Motherbit',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'EO 91-100 Servomechanical Orthotaur 32-tonze Swipe',
    type: 'StartsUsing',
    netRegex: {
      id: '8099',
      source: 'Servomechanical Orthotaur',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'EO 91-100 Servomechanical Orthotaur 128-tonze Swing',
    type: 'StartsUsing',
    netRegex: {
      id: '809A',
      source: 'Servomechanical Orthotaur',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 91-100 Servomechanical Orthochimera Engulfing Ice',
    // AoE cleave to front and right
    type: 'StartsUsing',
    netRegex: {
      id: '808A',
      source: 'Servomechanical Orthochimera',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'EO 91-100 Servomechanical Orthochimera The Dragon\'s Breath',
    // AoE cleave to front and left
    type: 'StartsUsing',
    netRegex: {
      id: '808B',
      source: 'Servomechanical Orthochimera',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'EO 91-100 Servomechanical Orthochimera the Scorpion\'s Sting',
    // AoE cleave behind
    type: 'StartsUsing',
    netRegex: {
      id: '808C',
      source: 'Servomechanical Orthochimera',
      capture: false
    },
    response: responses/* Responses.goFront */.n3.goFront()
  }, {
    id: 'EO 91-100 Servomechanical Orthochimera the Ram\'s Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '808D',
      source: 'Servomechanical Orthochimera',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 91-100 Servomechanical Orthochimera the Dragon\'s Voice',
    type: 'StartsUsing',
    netRegex: {
      id: '808E',
      source: 'Servomechanical Orthochimera',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'EO 91-100 Orthos Mithridates Laserblade',
    // 270° front cleave
    type: 'StartsUsing',
    netRegex: {
      id: '8070',
      source: 'Orthos Mithridates',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'EO 91-100 Orthos Sphinx Naked Soul',
    type: 'StartsUsing',
    netRegex: {
      id: '8093',
      source: 'Orthos Sphinx',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'EO 91-100 Orthos Sphinx Swinge',
    type: 'StartsUsing',
    netRegex: {
      id: '8091',
      source: 'Orthos Sphinx',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'EO 91-100 Orthonaught Rotoswipe',
    type: 'StartsUsing',
    netRegex: {
      id: '807D',
      source: 'Orthonaught',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'EO 91-100 Orthos Zaghnal Pounce Errant',
    // leap on target player, knocks back other players if hit
    type: 'StartsUsing',
    netRegex: {
      id: '8078',
      source: 'Orthos Zaghnal'
    },
    response: responses/* Responses.awayFrom */.n3.awayFrom()
  }, {
    id: 'EO 91-100 Orthos Fitter Allagan Fear',
    type: 'StartsUsing',
    netRegex: {
      id: '8080',
      source: 'Orthos Fitter',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  },
  // ---------------- Floor 99 Boss: Excalibur ----------------
  {
    id: 'EO 91-100 Excalibur Empty Souls\' Caliber',
    type: 'StartsUsing',
    netRegex: {
      id: '7A60',
      source: 'Excalibur',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'EO 91-100 Excalibur Solid Souls\' Caliber',
    type: 'StartsUsing',
    netRegex: {
      id: '7A5F',
      source: 'Excalibur',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'EO 91-100 Excalibur Caliburni',
    type: 'StartsUsing',
    netRegex: {
      id: '7A65',
      source: 'Excalibur',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'EO 91-100 Excalibur Paradoxum',
    type: 'StartsUsing',
    netRegex: {
      id: '7A79',
      source: 'Excalibur',
      capture: false
    },
    preRun: data => {
      delete data.temperature;
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'EO 91-100 Excalibur Paradoxum Collect',
    // D52 = Soul of Fire
    // D53 - Soul of Ice
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D5[23]'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      data.temperature = matches.effectId.toUpperCase();
    }
  }, {
    id: 'EO 91-100 Excalibur Thermal Divide',
    // TODO: different ids are probably indicating which side is ice/fire
    type: 'StartsUsing',
    netRegex: {
      id: '7A7[56]',
      source: 'Excalibur',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.temperature === undefined) {
        console.error(`Excalibur Thermal Divide: missing temperature`);
        return;
      }
      if (data.temperature === 'D52') return output.ice();
      return output.fire();
    },
    outputStrings: {
      ice: {
        en: 'Get hit by Ice',
        de: 'Lass dich von Eis treffen',
        fr: 'Faites-vous toucher par la glace',
        ja: '氷へ',
        cn: '被冰打',
        ko: '얼음 맞기'
      },
      fire: {
        en: 'Get hit by Fire',
        de: 'Lass dich von Feuer treffen',
        fr: 'Faites-vous toucher par le feu',
        ja: '炎へ',
        cn: '被火打',
        ko: '불 맞기'
      }
    }
  }, {
    id: 'EO 91-100 Excalibur Flameforge',
    type: 'StartsUsing',
    netRegex: {
      id: '7A61',
      source: 'Excalibur',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.temperature === undefined) {
        console.error(`Excalibur Flameforge: missing temperature`);
      }
      if (data.temperature === 'D52') return output.ice();
      return output.avoid();
    },
    outputStrings: {
      ice: {
        en: 'Get hit by Ice',
        de: 'Lass dich von Eis treffen',
        fr: 'Faites-vous toucher par la glace',
        ja: '氷へ',
        cn: '被冰打',
        ko: '얼음 맞기'
      },
      avoid: {
        en: 'Avoid line AoEs',
        de: 'Vermeide Linien-AoEs',
        fr: 'Évitez les AoEs en ligne',
        ja: '剣AOE回避',
        cn: '躲避直线AOE',
        ko: '칼 피하기'
      }
    }
  }, {
    id: 'EO 91-100 Excalibur Frostforge',
    type: 'StartsUsing',
    netRegex: {
      id: '7A62',
      source: 'Excalibur',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.temperature === undefined) {
        console.error(`Excalibur Frostforge: missing temperature`);
      }
      if (data.temperature === 'D53') return output.fire();
      return output.avoid();
    },
    outputStrings: {
      fire: {
        en: 'Get hit by Fire',
        de: 'Lass dich von Feuer treffen',
        fr: 'Faites-vous toucher par le feu',
        ja: '炎へ',
        cn: '被火打',
        ko: '불 맞기'
      },
      avoid: {
        en: 'Avoid line AoEs',
        de: 'Vermeide Linien-AoEs',
        fr: 'Évitez les AoEs en ligne',
        ja: '剣AOE回避',
        cn: '躲避直线AOE',
        ko: '칼 피하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Excalibur': 'Excalibur',
      'Orthodrone': 'Orthodrohne',
      'Orthonaught': 'Orthonaut',
      'Orthos Fitter': 'Orthos-Schlosser',
      'Orthos Mining Drone': 'Orthos-Minendrohne',
      'Orthos Mithridates': 'Orthos-Mithridates',
      'Orthos Motherbit': 'Orthos-Mutterdrohne',
      'Orthos Sphinx': 'Orthosphinx',
      'Orthos Zaghnal': 'Orthos-Zaghnal',
      'Orthosystem α': 'Orthosystem α',
      'Orthosystem γ': 'Orthosystem γ',
      'Servomechanical Orthochimera': 'servomechanisch(?:e|er|es|en) Orthochimära',
      'Servomechanical Orthotaur': 'servomechanisch(?:e|er|es|en) Orthotaurus'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Excalibur': 'Excalibur',
      'Orthodrone': 'drone Orthos',
      'Orthonaught': 'cuirassé Dreadnaught Orthos',
      'Orthos Fitter': 'installateur Orthos',
      'Orthos Mining Drone': 'drone des mines Orthos',
      'Orthos Mithridates': 'mithridate Orthos',
      'Orthos Motherbit': 'drone mère Orthos',
      'Orthos Sphinx': 'sphinx Orthos',
      'Orthos Zaghnal': 'zaghnal Orthos',
      'Orthosystem α': 'système α Orthos',
      'Orthosystem γ': 'système γ Orthos',
      'Servomechanical Orthochimera': 'chimère servomécanique Orthos',
      'Servomechanical Orthotaur': 'minotaure servomécanique Orthos'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Excalibur': '闘神エクスカリバー',
      'Orthodrone': 'オルト・ドローン',
      'Orthonaught': 'オルト・ドレッドノート',
      'Orthos Fitter': 'オルト・フィッター',
      'Orthos Mining Drone': 'オルト・マイニングドローン',
      'Orthos Mithridates': 'オルト・ミトリダテス',
      'Orthos Motherbit': 'オルト・マザービット',
      'Orthos Sphinx': 'オルト・スフィンクス',
      'Orthos Zaghnal': 'オルト・ザグナル',
      'Orthosystem α': 'オルト・システムα',
      'Orthosystem γ': 'オルト・システムγ',
      'Servomechanical Orthochimera': 'オルト・サーヴォキマイラ',
      'Servomechanical Orthotaur': 'オルト・サーヴォミノタウロス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Excalibur': '斗神 王者之剑',
      'Orthodrone': '正统无人机',
      'Orthonaught': '正统恐慌装甲',
      'Orthos Fitter': '正统整备工',
      'Orthos Mining Drone': '正统采掘无人机',
      'Orthos Mithridates': '正统米特里达梯',
      'Orthos Motherbit': '正统浮游炮主板',
      'Orthos Sphinx': '正统斯芬克斯',
      'Orthos Zaghnal': '正统扎戈斧龙',
      'Orthosystem α': '正统系统α',
      'Orthosystem γ': '正统系统γ',
      'Servomechanical Orthochimera': '正统自控化奇美拉',
      'Servomechanical Orthotaur': '正统自控化弥诺陶洛斯'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Excalibur': '투신 엑스칼리버',
      'Orthodrone': '오르토스 무인기',
      'Orthonaught': '오르토스 드레드노트',
      'Orthos Fitter': '오르토스 정비공',
      'Orthos Mining Drone': '오르토스 무인 채굴기',
      'Orthos Mithridates': '오르토스 미트리다테스',
      'Orthos Motherbit': '오르토스 마더 비트',
      'Orthos Sphinx': '오르토스 스핑크스',
      'Orthos Zaghnal': '오르토스 자그날',
      'Orthosystem α': '오르토스 시스템 α',
      'Orthosystem γ': '오르토스 시스템 γ',
      'Servomechanical Orthochimera': '오르토스 자동제어 키마이라',
      'Servomechanical Orthotaur': '오르토스 자동제어 미노타우로스'
    }
  }]
};
/* harmony default export */ const eureka_orthos_floors_91_100 = (eureka_orthos_floors_91_100_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/deepdungeon/eureka_orthos_general.ts



// Triggers applicable to all Eureka Orthos floors.

const eureka_orthos_general_triggerSet = {
  id: 'EurekaOrthosGeneral',
  zoneId: [zone_id/* default.EurekaOrthosFloors1_10 */.Z.EurekaOrthosFloors1_10, zone_id/* default.EurekaOrthosFloors11_20 */.Z.EurekaOrthosFloors11_20, zone_id/* default.EurekaOrthosFloors21_30 */.Z.EurekaOrthosFloors21_30, zone_id/* default.EurekaOrthosFloors31_40 */.Z.EurekaOrthosFloors31_40, zone_id/* default.EurekaOrthosFloors41_50 */.Z.EurekaOrthosFloors41_50, zone_id/* default.EurekaOrthosFloors51_60 */.Z.EurekaOrthosFloors51_60, zone_id/* default.EurekaOrthosFloors61_70 */.Z.EurekaOrthosFloors61_70, zone_id/* default.EurekaOrthosFloors71_80 */.Z.EurekaOrthosFloors71_80, zone_id/* default.EurekaOrthosFloors81_90 */.Z.EurekaOrthosFloors81_90, zone_id/* default.EurekaOrthosFloors91_100 */.Z.EurekaOrthosFloors91_100],
  zoneLabel: {
    en: 'Eureka Orthos (All Floors)',
    de: 'Eureka Orthos (Alle Ebenen)',
    fr: 'Eureka Orthos (Tout les étages)',
    ja: 'オルト・エウレカ (全層)',
    cn: '正统优雷卡 (全楼层)',
    ko: '에우레카 오르토스 (전체 층)'
  },
  triggers: [
  // ---------------- Mimics ----------------
  {
    id: 'EO General Mimic Spawn',
    // 2566 = Mimic (appears to be same npcNameId all floors)
    // floor 1-30 bronze chests, can stun or interrupt
    // floor 31-60 silver chests, can stun or interrupt
    // floor 61+ gold chests, can interrupt, immune to stun
    // TODO: some Mimics may spawn after transference between floors and get called early before being found
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '2566',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mimic spawned!',
        de: 'Mimik ist erschienen!',
        fr: 'Un mimic apparait !',
        ja: 'ミミック！',
        cn: '已生成 拟态怪!',
        ko: '미믹 등장!'
      }
    }
  }, {
    id: 'EO General Mimic Infatuation',
    // inflicts Accursed Pox (43F) if not interrupted
    type: 'StartsUsing',
    netRegex: {
      id: '801E',
      source: 'Mimic'
    },
    response: responses/* Responses.interruptIfPossible */.n3.interruptIfPossible()
  },
  // ---------------- Protomanders and Demiclones ----------------
  {
    id: 'EO General Protomander Duplicate',
    // duplicate item message: https://xivapi.com/LogMessage/7222?pretty=true
    // en: You return the protomander of ${protomander} to the coffer. You cannot carry any more of that item.
    type: 'SystemLogMessage',
    netRegex: {
      id: '1C36'
    },
    infoText: (_data, matches, output) => {
      switch (parseInt(matches.param1, 16)) {
        case 20:
          return output.duplicate({
            protomander: output.lethargy()
          });
        case 21:
          return output.duplicate({
            protomander: output.storms()
          });
        case 22:
          return output.duplicate({
            protomander: output.dread()
          });
        case 23:
          return output.duplicate({
            protomander: output.safety()
          });
        case 24:
          return output.duplicate({
            protomander: output.sight()
          });
        case 25:
          return output.duplicate({
            protomander: output.strength()
          });
        case 26:
          return output.duplicate({
            protomander: output.steel()
          });
        case 27:
          return output.duplicate({
            protomander: output.affluence()
          });
        case 28:
          return output.duplicate({
            protomander: output.flight()
          });
        case 29:
          return output.duplicate({
            protomander: output.alteration()
          });
        case 30:
          return output.duplicate({
            protomander: output.purity()
          });
        case 31:
          return output.duplicate({
            protomander: output.fortune()
          });
        case 32:
          return output.duplicate({
            protomander: output.witching()
          });
        case 33:
          return output.duplicate({
            protomander: output.serenity()
          });
        case 34:
          return output.duplicate({
            protomander: output.intuition()
          });
        case 35:
          return output.duplicate({
            protomander: output.raising()
          });
      }
    },
    outputStrings: {
      duplicate: {
        en: '${protomander} duplicate',
        de: 'Doppelter ${protomander}',
        fr: '${protomander} dupliqué(e)',
        ja: 'もっています: ${protomander}',
        cn: '${protomander} 重复',
        ko: '${protomander} 중복'
      },
      // protomanders: https://xivapi.com/deepdungeonItem?pretty=true
      lethargy: {
        en: 'Lethargy',
        de: 'Trägheit',
        fr: 'Ralentissement',
        ja: 'スロウガ',
        cn: '缓速',
        ko: '슬로우가'
      },
      storms: {
        en: 'Storms',
        de: 'Schwäche',
        fr: 'Charybde',
        ja: 'ミールストーム',
        cn: '大漩涡',
        ko: '대소용돌이'
      },
      dread: {
        en: 'Dread',
        de: 'Macht',
        fr: 'Cuirassé Dreadnaught',
        ja: 'ドレッドノート化',
        cn: '恐慌装甲化',
        ko: '드레드노트 변신'
      },
      safety: {
        en: 'Safety',
        de: 'Siegelbruchs',
        fr: 'Désamorçage',
        ja: '呪印解除',
        cn: '咒印解除',
        ko: '함정 해제'
      },
      sight: {
        en: 'Sight',
        de: 'Sicht',
        fr: 'Localisation',
        ja: 'サイトロ',
        cn: '全景',
        ko: '사이트로'
      },
      strength: {
        en: 'Strength',
        de: 'Stärkung',
        fr: 'Puissance',
        ja: '自己強化',
        cn: '强化自身',
        ko: '자기 강화'
      },
      steel: {
        en: 'Steel',
        de: 'Abwehr',
        fr: 'Protection',
        ja: '防御強化',
        cn: '强化防御',
        ko: '방어 강화'
      },
      affluence: {
        en: 'Affluence',
        de: 'Schätze',
        fr: 'Décèlement',
        ja: '宝箱増加',
        cn: '宝箱增加',
        ko: '보물상자 증가'
      },
      flight: {
        en: 'Flight',
        de: 'Feindtods',
        fr: 'Sécurisation',
        ja: '敵排除',
        cn: '减少敌人',
        ko: '적 감소'
      },
      alteration: {
        en: 'Alteration',
        de: 'Feindwandlung',
        fr: 'Affaiblissement',
        ja: '敵変化',
        cn: '改变敌人',
        ko: '적 대체'
      },
      purity: {
        en: 'Purity',
        de: 'Entzauberung',
        fr: 'Anti-maléfice',
        ja: '解呪',
        cn: '解咒',
        ko: '저주 해제'
      },
      fortune: {
        en: 'Fortune',
        de: 'Glücks',
        fr: 'Chance',
        ja: '運気上昇',
        cn: '运气上升',
        ko: '운 상승'
      },
      witching: {
        en: 'Witching',
        de: 'Wandlung',
        fr: 'Mutation',
        ja: '形態変化',
        cn: '形态变化',
        ko: '적 변형'
      },
      serenity: {
        en: 'Serenity',
        de: 'Enthexung',
        fr: 'Dissipation',
        ja: '魔法効果解除',
        cn: '魔法效果解除',
        ko: '마법 효과 해제'
      },
      intuition: {
        en: 'Intuition',
        de: 'Finders',
        fr: 'Intuition',
        ja: '財宝感知',
        cn: '感知宝藏',
        ko: '보물 탐지'
      },
      raising: {
        en: 'Raising',
        de: 'Lebens',
        fr: 'Résurrection',
        ja: 'リレイズ',
        cn: '重生',
        ko: '리레이즈'
      }
    }
  }, {
    id: 'EO General Demiclone Duplicate',
    // duplicate item message: https://xivapi.com/LogMessage/10287?pretty=true
    // en: You return the ${demiclone} demiclone to the coffer. You cannot carry any more of that item.
    type: 'SystemLogMessage',
    netRegex: {
      id: '282F'
    },
    infoText: (_data, matches, output) => {
      switch (parseInt(matches.param1, 16)) {
        case 1:
          return output.duplicate({
            demiclone: output.unei()
          });
        case 2:
          return output.duplicate({
            demiclone: output.doga()
          });
        case 3:
          return output.duplicate({
            demiclone: output.onion()
          });
      }
    },
    outputStrings: {
      duplicate: {
        en: '${demiclone} duplicate',
        de: 'Doppelter ${demiclone}',
        fr: '${demiclone} dupliqué(e)',
        ja: '${demiclone} 被り',
        cn: '${demiclone} 重复',
        ko: '${demiclone} 중복'
      },
      // demiclones: https://xivapi.com/DeepDungeonDemiclone?pretty=true
      unei: {
        en: 'Unei',
        de: 'Unei',
        fr: 'Unéi',
        ja: 'ウネ',
        cn: '乌内',
        ko: '우네'
      },
      doga: {
        en: 'Doga',
        de: 'Doga',
        fr: 'Doga',
        ja: 'ドーガ',
        cn: '多加',
        ko: '도가'
      },
      onion: {
        en: 'Onion Knight',
        de: 'Zwiebelritter',
        fr: 'Chevalier Oignon',
        ja: 'オニオンナイト',
        cn: '洋葱剑士',
        ko: '양파 기사'
      }
    }
  },
  // ---------------- Floor Notifications ----------------
  {
    id: 'EO General Pylon of Passage',
    // portal to transfer between floors
    // Pylon of Passage activation message: https://xivapi.com/LogMessage/7245?pretty=true
    // en: The Pylon of Passage is activated!
    type: 'SystemLogMessage',
    netRegex: {
      id: '1C4D',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pylon of Passage activated',
        de: 'Translokator aktiviert',
        fr: 'Pylone de téléportation activé',
        ja: '転移が出来ます',
        cn: '传送装置已启动',
        ko: '전송장치 활성화'
      }
    }
  },
  // ---------------- Dread Beasts ----------------
  // 12322 = Lamia Queen
  // 12323 = Meracydian Clone
  // 12324 = Demi-Cochma
  {
    id: 'EO General Lamia Queen Petrifaction',
    // gaze, inflicts Stone Curse (1B5)
    type: 'StartsUsing',
    netRegex: {
      id: '7FD1',
      source: 'Lamia Queen',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'EO General Meracydian Clone Berserk',
    // gains Damage Up (1BB)
    type: 'StartsUsing',
    netRegex: {
      id: '7FCB',
      source: 'Meracydian Clone'
    },
    response: responses/* Responses.interruptIfPossible */.n3.interruptIfPossible()
  }, {
    id: 'EO General Meracydian Clone Allagan Meteor',
    // gaze, inflicts Stone Curse (1B5)
    type: 'StartsUsing',
    netRegex: {
      id: '7FCE',
      source: 'Meracydian Clone',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Lamia Queen': 'Lamia-Königin',
      'Meracydian Clone': 'meracydisch(?:e|er|es|en) Klon',
      'Mimic': 'Mimik'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Lamia Queen': 'Reine lamia',
      'Meracydian Clone': 'Clone de Méracydien',
      'Mimic': 'Mimic'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Lamia Queen': 'ラミアクィーン',
      'Meracydian Clone': 'メラシディアン・クローン',
      'Mimic': 'ミミック'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Lamia Queen': '拉米亚女王',
      'Meracydian Clone': '美拉西迪亚复制体',
      'Mimic': '拟态怪'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Lamia Queen': '라미아 여왕',
      'Meracydian Clone': '메라시디안 클론',
      'Mimic': '미믹'
    }
  }]
};
/* harmony default export */ const eureka_orthos_general = (eureka_orthos_general_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/aetherfont.ts




// TODO: Lyngbakr map effects for safe spots for small/large explosions
// TODO: Octomammoth safe tentacle platform sides?
// TODO: Octomammoth map effects for telekenesis safe spots
// TODO: Octomammoth Breathstroke could say "left/right" specifically instead of get behind
const aetherfont_triggerSet = {
  id: 'TheAetherfont',
  zoneId: zone_id/* default.TheAetherfont */.Z.TheAetherfont,
  timelineFile: 'aetherfont.txt',
  triggers: [{
    id: 'Aetherfont Lyngbakr Upsweep',
    type: 'StartsUsing',
    netRegex: {
      id: '823A',
      source: 'Lyngbakr',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aetherfont Lyngbakr Bodyslam',
    type: 'StartsUsing',
    netRegex: {
      id: '8237',
      source: 'Lyngbakr',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aetherfont Lyngbakr Tidal Breath',
    type: 'StartsUsing',
    netRegex: {
      id: '8240',
      source: 'Lyngbakr',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Aetherfont Lyngbakr Floodstide',
    type: 'StartsUsing',
    netRegex: {
      id: '823D',
      source: 'Lyngbakr',
      capture: false
    },
    // 00600 spread headmarkers come out after cast ends
    durationSeconds: 8,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Aetherfont Lyngbakr Tidalspout',
    type: 'StartsUsing',
    netRegex: {
      id: '823F',
      source: 'Lyngbakr'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Aetherfont Lyngbakr Sonic Bloop',
    type: 'StartsUsing',
    netRegex: {
      id: '8241',
      source: 'Lyngbakr'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    // Initial battle cry is just aoe, the later ones create a ring.
    id: 'Aetherfont Arkas Battle Cry Initial',
    type: 'StartsUsing',
    netRegex: {
      id: '872D',
      source: 'Arkas',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // aoe + ring
    id: 'Aetherfont Arkas Battle Cry',
    type: 'StartsUsing',
    netRegex: {
      id: '8254',
      source: 'Arkas',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'aoe + Get Middle',
        de: 'AoE + Geh in die Mitte',
        fr: 'AoE + Allez au milieu',
        ja: '全体攻撃 + 真ん中',
        cn: 'AoE + 去场中',
        ko: '전체공격 + 중앙으로'
      }
    }
  }, {
    id: 'Aetherfont Arkas Ripper Claw',
    type: 'StartsUsing',
    netRegex: {
      id: '8258',
      source: 'Arkas'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Aetherfont Arkas Lightning Claw',
    type: 'StartsUsing',
    netRegex: {
      id: '8798',
      source: 'Arkas'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Aetherfont Arkas Electrify',
    type: 'Ability',
    // 8256 is the damage ability for Lightning Claw, which is followed by a centered aoe.
    netRegex: {
      id: '8256',
      source: 'Arkas',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Aetherfont Octomammoth Tidal Roar',
    type: 'StartsUsing',
    netRegex: {
      id: '824C',
      source: 'Octomammoth',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // aoe + ring
    id: 'Aetherfont Octomammoth Saline Spit',
    type: 'StartsUsing',
    netRegex: {
      id: '8248',
      source: 'Octomammoth',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand Between Platforms',
        de: 'Steh zwischen den Platformen',
        fr: 'Restez entre les plateformes',
        ja: '通路へ',
        cn: '站在平台间',
        ko: '플랫폼 사이로'
      }
    }
  }, {
    id: 'Aetherfont Octomamoth Water Drop',
    type: 'StartsUsing',
    netRegex: {
      id: '8684',
      source: 'Octomammoth'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Aetherfont Octomammoth Tidal Breath',
    type: 'StartsUsing',
    netRegex: {
      id: '824A',
      source: 'Octomammoth',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Aetherfont Octomammoth Breathstroke',
    type: 'StartsUsing',
    netRegex: {
      id: '86F7',
      source: 'Octomammoth',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Behind (Avoid Tentacles)',
        de: 'Geh nach Hinten (Vermeide Tentakel)',
        fr: 'Allez derrière (évitez les tentacules)',
        ja: 'ボスの後ろへ (テンタクル回避)',
        cn: '去背后（躲避触手）',
        ko: '보스 뒤로 (촉수 피하기)'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Arkas': 'Arkas',
      'Cyancap Cavern': 'Zyanspitze',
      'Lyngbakr': 'Lyngbakr',
      'Mammoth Tentacle': 'Oktomammut-Tentakel',
      'Octomammoth': 'Oktomammut',
      'The Deep Below': 'Ätherpfuhl',
      'The Landfast Floe': 'Raureif-Rondell'
    },
    'replaceText': {
      '\\(big\\)': '(groß)',
      '\\(small\\)': '(klein)',
      '\\(explosion\\)': '(Explosion)',
      '\\(tether\\)': '(Verbindung)',
      'Battle Cry': 'Kampfesschrei',
      'Body Slam': 'Bodenwelle',
      'Breathstroke': 'Hauchiger Hieb',
      'Clearout': 'Kreisfeger',
      'Electric Eruption': 'Blitzeruption',
      'Electrify': 'Elektrisieren',
      'Explosive Frequency': 'Explosivfrequenz',
      'Floodstide': 'Flutzeit',
      'Forked Fissures': 'Funkenstrom',
      'Lightning Claw': 'Funkenklaue',
      'Lightning Leap': 'Funkensprung',
      'Lightning Rampage': 'Funkensturm',
      'Octostroke': 'Oktoschlag',
      'Resonant Frequency': 'Resonanzfrequenz',
      'Ripper Claw': 'Fetzklaue',
      'Saline Spit': 'Spuckstrahl',
      'Shock': 'Entladung',
      'Sonic Bloop': 'Ruf aus der Tiefe',
      'Spinning Claw': 'Wirbelklaue',
      'Spun Lightning': 'Blitzgespinst',
      'Tidal Breath': 'Hauch der Gezeiten',
      'Tidal Roar': 'Schrei der Gezeiten',
      'Tidalspout': 'Wassersturm',
      'Upsweep': 'Aufbrecher',
      'Vivid Eyes': 'Wilde Augen',
      'Water Drop': 'Rauschendes Wasser',
      'Waterspout': 'Wasserhose'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Arkas': 'Arkas',
      'Cyancap Cavern': 'Caverne de Cap-cyan',
      'Lyngbakr': 'Lyngbakr',
      'Mammoth Tentacle': 'Bras d\'octomammouth',
      'Octomammoth': 'Octomammouth',
      'The Deep Below': 'Bassin éthéré',
      'The Landfast Floe': 'Cirque glacé'
    },
    'replaceText': {
      '\\(big\\)': '(Gros)',
      '\\(small\\)': '(Petit)',
      '\\(explosion\\)': '(Explosion)',
      '\\(tether\\)': '(Lien)',
      'Battle Cry': 'Cri de guerre',
      'Body Slam': 'Charge physique',
      'Breathstroke': 'Souffle et fauche',
      'Clearout': 'Fauchage',
      'Electric Eruption': 'Éruption d\'éclairs',
      'Electrify': 'Électrisation',
      'Explosive Frequency': 'Grande explosion résonante',
      'Floodstide': 'Marée montante',
      'Forked Fissures': 'Flux foudroyant',
      'Lightning Claw': 'Griffe survoltée',
      'Lightning Leap': 'Bond électrique',
      'Lightning Rampage': 'Ravage tonitruant',
      'Octostroke': 'Octofauche',
      'Resonant Frequency': 'Explosion résonante',
      'Ripper Claw': 'Griffe éventreuse',
      'Saline Spit': 'Crachat aqueux',
      'Shock': 'Décharge électrostatique',
      'Sonic Bloop': 'Bloup sonique',
      'Spinning Claw': 'Griffe tournoyante',
      'Spun Lightning': 'Rayon fulgurant',
      'Tidal Breath': 'Souffle supratidal',
      'Tidal Roar': 'Vague rugissante',
      'Tidalspout': 'Déferlement soudain',
      'Upsweep': 'Écho sinistre',
      'Vivid Eyes': 'Regard transperçant',
      'Water Drop': 'Boule d\'eau',
      'Waterspout': 'Inondation'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Arkas': 'アルカス',
      'Cyancap Cavern': 'シアンキャップ中継地',
      'Lyngbakr': 'リングバーク',
      'Mammoth Tentacle': 'オクトマンモスの腕',
      'Octomammoth': 'オクトマンモス',
      'The Deep Below': 'エーテリックポンド',
      'The Landfast Floe': '流氷の円庭'
    },
    'replaceText': {
      '\\(big\\)': '(大)',
      '\\(small\\)': '(小)',
      '\\(explosion\\)': '(爆発)',
      '\\(tether\\)': '(線)',
      'Battle Cry': 'バトルクライ',
      'Body Slam': 'ボディスラム',
      'Breathstroke': 'ブレス&スワイプ',
      'Clearout': 'なぎ払い',
      'Electric Eruption': 'ライトニングエラプション',
      'Electrify': '大放電',
      'Explosive Frequency': '共振大炸裂',
      'Floodstide': 'フラッドタイド',
      'Forked Fissures': 'ライトニングカレント',
      'Lightning Claw': 'ライトニングクロウ',
      'Lightning Leap': 'ライトニングリープ',
      'Lightning Rampage': 'ライトニングランページ',
      'Octostroke': 'オクトスワイプ',
      'Resonant Frequency': '共振炸裂',
      'Ripper Claw': 'リッパークロウ',
      'Saline Spit': 'スピットウォーター',
      'Shock': '放電',
      'Sonic Bloop': 'ソニックブループ',
      'Spinning Claw': 'スピニングクロウ',
      'Spun Lightning': 'スパンライトニング',
      'Telekinesis': 'テレキネシス',
      'Tidal Breath': 'タイダルブレス',
      'Tidal Roar': 'タイダルロア',
      'Tidalspout': 'バーストフラッド',
      'Upsweep': 'アプスウィープ',
      'Vivid Eyes': 'ビビッドアイズ',
      'Water Drop': '水塊',
      'Waterspout': 'オーバーフラッド'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Arkas': '阿尔卡斯',
      'Cyancap Cavern': '蓝檐洞中转点',
      'Lyngbakr': '林巴克尔',
      'Mammoth Tentacle': '八足巨妖的触手',
      'Octomammoth': '八足巨妖',
      'The Deep Below': '以太池',
      'The Landfast Floe': '流冰圆庭'
    },
    'replaceText': {
      '\\(big\\)': '(大)',
      '\\(small\\)': '(小)',
      '\\(explosion\\)': '(爆炸)',
      '\\(tether\\)': '(连线)',
      'Battle Cry': '战斗怒嚎',
      'Body Slam': '躯体震击',
      'Breathstroke': '吐息重击',
      'Clearout': '横扫',
      'Electric Eruption': '惊电喷发',
      'Electrify': '大放电',
      'Explosive Frequency': '共振大炸裂',
      'Floodstide': '潮水涌动',
      'Forked Fissures': '惊电裂隙',
      'Lightning Claw': '惊电爪',
      'Lightning Leap': '惊电跳跃',
      'Lightning Rampage': '惊电狂怒',
      'Octostroke': '八足重击',
      'Resonant Frequency': '共振炸裂',
      'Ripper Claw': '撕裂利爪',
      'Saline Spit': '吐水',
      'Shock': '放电',
      'Sonic Bloop': '杂音波',
      'Spinning Claw': '回旋雷爪',
      'Spun Lightning': '旋转闪电',
      'Telekinesis': '念力',
      'Tidal Breath': '怒潮吐息',
      'Tidal Roar': '怒潮咆哮',
      'Tidalspout': '潮水喷涌',
      'Upsweep': '海洋怪声',
      'Vivid Eyes': '灵动之眼',
      'Water Drop': '水块',
      'Waterspout': '海龙卷'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Arkas': '아르카스',
      'Cyancap Cavern': '푸른챙 중계지',
      'Lyngbakr': '링기바크',
      'Mammoth Tentacle': '옥토매머드 촉수',
      'Octomammoth': '옥토매머드',
      'The Deep Below': '에테르 연못',
      'The Landfast Floe': '둥근 유빙'
    },
    'replaceText': {
      '\\(big\\)': '(큰)',
      '\\(small\\)': '(작은)',
      '\\(explosion\\)': '(폭발)',
      '\\(tether\\)': '(선)',
      'Battle Cry': '호전적 포효',
      'Body Slam': '몸통 박기',
      'Breathstroke': '해일 숨결 후려치기',
      'Clearout': '휩쓸기',
      'Electric Eruption': '번개 분출',
      'Electrify': '대방전',
      'Explosive Frequency': '공진 대작렬',
      'Floodstide': '큰물의 흐름',
      'Forked Fissures': '번개 전류',
      'Lightning Claw': '번개 발톱',
      'Lightning Leap': '번개 도약',
      'Lightning Rampage': '번개 난동',
      'Octostroke': '촉수 후려치기',
      'Resonant Frequency': '공진 작렬',
      'Ripper Claw': '발톱 난도질',
      'Saline Spit': '물 뱉기',
      'Shock': '방전',
      'Sonic Bloop': '잡음파',
      'Spinning Claw': '회전 발톱',
      'Spun Lightning': '방사된 번개',
      'Telekinesis': '염동력',
      'Tidal Breath': '해일 숨결',
      'Tidal Roar': '바다의 포효',
      'Tidalspout': '큰물 폭탄',
      'Upsweep': '심해음',
      'Vivid Eyes': '또렷한 눈동자',
      'Water Drop': '물덩어리',
      'Waterspout': '용오름'
    }
  }]
};
/* harmony default export */ const aetherfont = (aetherfont_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/aetherfont.txt
const dungeon_aetherfont_namespaceObject = "### The Aetherfont\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# TODO: verify loops with longer logs?\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~~~~~#\r\n# Lyngbakr :U #\r\n#~~~~~~~~~~~~~#\r\n\r\n# -ii 86D5\r\n# -p 823A:111.3\r\n\r\n# Landfast Floe will be sealed off\r\n100.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10CD\" } window 100000,0\r\n106.3 \"--sync--\" StartsUsing { id: \"823A\", source: \"Lyngbakr\" } window 10,10\r\n111.3 \"Upsweep\" Ability { id: \"823A\", source: \"Lyngbakr\" }\r\n121.7 \"Tidal Breath\" Ability { id: \"8240\", source: \"Lyngbakr\" }\r\n131.8 \"Body Slam\" Ability { id: \"8237\", source: \"Lyngbakr\" }\r\n140.5 \"Upsweep\" Ability { id: \"823A\", source: \"Lyngbakr\" }\r\n146.6 \"Resonant Frequency (small)\" Ability { id: \"823B\", source: \"Lyngbakr\" }\r\n\r\n154.8 \"Body Slam\" Ability { id: \"8237\", source: \"Lyngbakr\" }\r\n163.5 \"Upsweep\" Ability { id: \"823A\", source: \"Lyngbakr\" }\r\n174.5 \"Explosive Frequency (big)\" Ability { id: \"823C\", source: \"Lyngbakr\" }\r\n174.5 \"Floodstide\" Ability { id: \"823D\", source: \"Lyngbakr\" }\r\n180.5 \"Waterspout\" Ability { id: \"823E\", source: \"Lyngbakr\" }\r\n186.5 \"Tidalspout\" Ability { id: \"823F\", source: \"Lyngbakr\" }\r\n192.6 \"Tidal Breath\" Ability { id: \"8240\", source: \"Lyngbakr\" }\r\n203.2 \"Body Slam\" Ability { id: \"8237\", source: \"Lyngbakr\" }\r\n211.9 \"Upsweep\" Ability { id: \"823A\", source: \"Lyngbakr\" }\r\n218.0 \"Resonant Frequency (small)\" Ability { id: \"823B\", source: \"Lyngbakr\" }\r\n223.0 \"Explosive Frequency (big)\" Ability { id: \"823C\", source: \"Lyngbakr\" }\r\n229.0 \"Tidal Breath\" Ability { id: \"8240\", source: \"Lyngbakr\" }\r\n237.2 \"Sonic Bloop\" Ability { id: \"8241\", source: \"Lyngbakr\" }\r\n245.3 \"Upsweep\" Ability { id: \"823A\", source: \"Lyngbakr\" }\r\n252.4 \"Upsweep\" Ability { id: \"823A\", source: \"Lyngbakr\" }\r\n\r\n# Probably a loop, at least up until 223.0/332.3 Explosive Frequency\r\n264.5 \"Body Slam\" Ability { id: \"8237\", source: \"Lyngbakr\" } window 30,30 jump 154.8\r\n273.2 \"Upsweep\" #Ability { id: \"823A\", source: \"Lyngbakr\" }\r\n284.2 \"Explosive Frequency (big)\" #Ability { id: \"823C\", source: \"Lyngbakr\" }\r\n284.2 \"Floodstide\" #Ability { id: \"823D\", source: \"Lyngbakr\" }\r\n290.2 \"Waterspout\" #Ability { id: \"823E\", source: \"Lyngbakr\" }\r\n296.2 \"Tidalspout\" #Ability { id: \"823F\", source: \"Lyngbakr\" }\r\n\r\n\r\n#~~~~~~~#\r\n# Arkas #\r\n#~~~~~~~#\r\n\r\n# -ii 8256\r\n# -p 872D:510\r\n\r\n# Cyancap Cavern will be sealed off\r\n500.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10CE\" } window 100000,0\r\n505.0 \"--sync--\" StartsUsing { id: \"872D\", source: \"Arkas\" } window 10,10\r\n510.0 \"Battle Cry\" Ability { id: \"872D\", source: \"Arkas\" }\r\n521.3 \"Lightning Leap\" Ability { id: \"824E\", source: \"Arkas\" }\r\n522.3 \"--sync--\" Ability { id: \"8799\", source: \"Arkas\" }\r\n528.4 \"Forked Fissures\" Ability { id: \"8251\", source: \"Arkas\" }\r\n531.4 \"Lightning Leap\" Ability { id: \"824F\", source: \"Arkas\" }\r\n532.4 \"--sync--\" Ability { id: \"8250\", source: \"Arkas\" }\r\n538.5 \"Forked Fissures\" Ability { id: \"8251\", source: \"Arkas\" }\r\n548.1 \"Ripper Claw\" Ability { id: \"8258\", source: \"Arkas\" }\r\n558.1 \"Spinning Claw\" Ability { id: \"8252\", source: \"Arkas\" }\r\n563.7 \"Spun Lightning\" Ability { id: \"8253\", source: \"Arkas\" }\r\n\r\n572.3 \"Battle Cry\" Ability { id: \"8254\", source: \"Arkas\" }\r\n583.4 \"Lightning Rampage 1\" Ability { id: \"860E\", source: \"Arkas\" }\r\n584.4 \"--sync--\" Ability { id: \"879A\", source: \"Arkas\" }\r\n588.4 \"Lightning Rampage 2\" Ability { id: \"860F\", source: \"Arkas\" }\r\n589.4 \"--sync--\" Ability { id: \"8611\", source: \"Arkas\" }\r\n590.4 \"Forked Fissures\" Ability { id: \"8251\", source: \"Arkas\" }\r\n594.4 \"Lightning Rampage 3\" Ability { id: \"860F\", source: \"Arkas\" }\r\n595.3 \"--sync--\" Ability { id: \"8611\", source: \"Arkas\" }\r\n595.4 \"Forked Fissures\" Ability { id: \"8251\", source: \"Arkas\" }\r\n600.4 \"Lightning Rampage 4\" Ability { id: \"8610\", source: \"Arkas\" }\r\n601.3 \"--sync--\" Ability { id: \"8611\", source: \"Arkas\" }\r\n601.5 \"Forked Fissures\" Ability { id: \"8251\", source: \"Arkas\" }\r\n607.5 \"Forked Fissures\" Ability { id: \"8251\", source: \"Arkas\" }\r\n\r\n613.2 \"Lightning Claw\" Ability { id: \"8798\", source: \"Arkas\" }\r\n621.0 \"Electrify\" Ability { id: \"8257\", source: \"Arkas\" }\r\n629.2 \"Ripper Claw\" Ability { id: \"8258\", source: \"Arkas\" }\r\n641.8 \"Electric Eruption\" Ability { id: \"834F\", source: \"Arkas\" }\r\n646.4 \"Shock\" Ability { id: \"8255\", source: \"Arkas\" }\r\n651.8 \"Spinning Claw\" Ability { id: \"8252\", source: \"Arkas\" }\r\n657.4 \"Spun Lightning\" Ability { id: \"8253\", source: \"Arkas\" }\r\n\r\n# Probably a loop, at least up until 629.2/722.1 Ripper Claw\r\n665.0 \"Battle Cry\" Ability { id: \"8254\", source: \"Arkas\" } window 30,30 jump 572.3\r\n676.1 \"Lightning Rampage 1\" #Ability { id: \"860E\", source: \"Arkas\" }\r\n677.1 \"--sync--\" #Ability { id: \"879A\", source: \"Arkas\" }\r\n681.1 \"Lightning Rampage 2\" #Ability { id: \"860F\", source: \"Arkas\" }\r\n682.1 \"--sync--\" #Ability { id: \"8611\", source: \"Arkas\" }\r\n683.1 \"Forked Fissures\" #Ability { id: \"8251\", source: \"Arkas\" }\r\n687.1 \"Lightning Rampage 3\" #Ability { id: \"860F\", source: \"Arkas\" }\r\n688.0 \"--sync--\" #Ability { id: \"8611\", source: \"Arkas\" }\r\n688.1 \"Forked Fissures\" #Ability { id: \"8251\", source: \"Arkas\" }\r\n693.1 \"Lightning Rampage 4\" #Ability { id: \"8610\", source: \"Arkas\" }\r\n694.0 \"--sync--\" #Ability { id: \"8611\", source: \"Arkas\" }\r\n694.2 \"Forked Fissures\" #Ability { id: \"8251\", source: \"Arkas\" }\r\n700.2 \"Forked Fissures\" #Ability { id: \"8251\", source: \"Arkas\" }\r\n\r\n\r\n#~~~~~~~~~~~~~#\r\n# Octomammoth #\r\n#~~~~~~~~~~~~~#\r\n\r\n# -ii 8242 8249\r\n# -p 824C:1009.6\r\n\r\n# The Deep Below will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10CF\" } window 100000,0\r\n1004.6 \"--sync--\" StartsUsing { id: \"824C\", source: \"Octomammoth\" } window 10,10\r\n1009.6 \"Tidal Roar\" Ability { id: \"824C\", source: \"Octomammoth\" }\r\n1032.7 \"Octostroke\" Ability { id: \"8243\", source: \"Octomammoth\" }\r\n1033.0 \"Clearout\" Ability { id: \"8244\", source: \"Mammoth Tentacle\" }\r\n1045.0 \"Vivid Eyes\" Ability { id: \"824B\", source: \"Octomammoth\" }\r\n1053.1 \"Saline Spit\" Ability { id: \"8248\", source: \"Octomammoth\" }\r\n1071.5 \"Tidal Breath\" Ability { id: \"824A\", source: \"Octomammoth\" }\r\n1078.8 \"Tidal Roar\" Ability { id: \"824C\", source: \"Octomammoth\" }\r\n1091.0 \"Telekinesis (tether)\" Ability { id: \"8245\", source: \"Octomammoth\" }\r\n1101.8 \"Telekinesis (explosion)\" Ability { id: \"8247\", source: \"Octomammoth\" }\r\n1103.9 \"--sync--\" Ability { id: \"8246\", source: \"Octomammoth\" }\r\n1130.8 \"Clearout\" Ability { id: \"8244\", source: \"Mammoth Tentacle\" }\r\n1130.8 \"Breathstroke\" Ability { id: \"86F7\", source: \"Octomammoth\" }\r\n1136.1 \"Saline Spit\" Ability { id: \"8248\", source: \"Octomammoth\" }\r\n1143.2 \"Vivid Eyes\" Ability { id: \"824B\", source: \"Octomammoth\" }\r\n1144.2 \"Water Drop\" Ability { id: \"8684\", source: \"Octomammoth\" }\r\n1156.5 \"Telekinesis (tether)\" Ability { id: \"8245\", source: \"Octomammoth\" }\r\n1167.3 \"Telekinesis (explosion)\" Ability { id: \"8247\", source: \"Octomammoth\" }\r\n1169.4 \"--sync--\" Ability { id: \"8246\", source: \"Octomammoth\" }\r\n1178.4 \"Tidal Roar\" Ability { id: \"824C\", source: \"Octomammoth\" }\r\n\r\n1208.3 \"Clearout\" Ability { id: \"8244\", source: \"Mammoth Tentacle\" }\r\n1208.3 \"Breathstroke\" Ability { id: \"86F7\", source: \"Octomammoth\" }\r\n1213.6 \"Saline Spit\" Ability { id: \"8248\", source: \"Octomammoth\" }\r\n1220.7 \"Vivid Eyes\" Ability { id: \"824B\", source: \"Octomammoth\" }\r\n1221.7 \"Water Drop\" Ability { id: \"8684\", source: \"Octomammoth\" }\r\n1232.8 \"Tidal Roar\" Ability { id: \"824C\", source: \"Octomammoth\" }\r\n\r\n# It seems unlikely that this is a loop as it's very short.\r\n# However, the longest log I've seen is ~5m.\r\n# I've seen up to the Tidal Roar at 1232.8/1291.1.\r\n1266.6 \"Clearout\" Ability { id: \"8244\", source: \"Mammoth Tentacle\" } window 30,30 jump 1208.3\r\n1266.6 \"Breathstroke\" #Ability { id: \"86F7\", source: \"Octomammoth\" }\r\n1271.9 \"Saline Spit\" #Ability { id: \"8248\", source: \"Octomammoth\" }\r\n1279.0 \"Vivid Eyes\" #Ability { id: \"824B\", source: \"Octomammoth\" }\r\n1280.0 \"Water Drop\" #Ability { id: \"8684\", source: \"Octomammoth\" }\r\n1291.1 \"Tidal Roar\" #Ability { id: \"824C\", source: \"Octomammoth\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/aloalo_island.ts




const ArcaneBlightMap = {
  '886F': 'right',
  '8870': 'left',
  '8871': 'back',
  '8872': 'front'
};
const aloalo_island_triggerSet = {
  id: 'AloaloIsland',
  zoneId: zone_id/* default.AloaloIsland */.Z.AloaloIsland,
  timelineFile: 'aloalo_island.txt',
  initData: () => {
    return {
      quaArmamentsCount: 0,
      reloadCount: 0,
      reloadFailed: []
    };
  },
  triggers: [
  // ----------------------------------------- Trash
  {
    id: 'Aloalo Ahool Soundwave',
    type: 'StartsUsing',
    netRegex: {
      id: '8869',
      source: 'Aloalo Ahool',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  },
  // ----------------------------------------- Quaqua
  {
    id: 'Aloalo Quaqua Made Magic',
    type: 'StartsUsing',
    netRegex: {
      id: '8B94',
      source: 'Quaqua',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aloalo Quaqua Arcane Armaments',
    type: 'StartsUsing',
    netRegex: {
      id: '8B88',
      source: 'Quaqua',
      capture: false
    },
    infoText: (data, _matches, output) => {
      data.quaArmamentsCount++;
      if (data.quaArmamentsCount === 1) return output.first();
      if (data.quaArmamentsCount === 2) return output.second();
      return output.third();
    },
    outputStrings: {
      first: {
        en: 'Away from Orbs',
        de: 'Außen zwichen den Orbs',
        fr: 'Éloignez-vous des orbes',
        ja: 'ハンマー、玉の間の外側へ',
        cn: '钢铁，远离落点球',
        ko: '구슬에서 멀리 떨어지기'
      },
      second: {
        en: 'Under Orbs',
        de: 'Unter einen Orbs',
        fr: 'Sous les orbes',
        ja: 'ドーナツ、玉の下へ',
        cn: '月环，站在落点球下',
        ko: '구슬 밑으로'
      },
      third: {
        en: 'Under Donut Far From Axe',
        de: 'Unter Donut und weit weg von der Axt',
        fr: 'Sous le donut loin de l\'Axe',
        ja: '玉に気を付けて',
        cn: '站在远离钢铁的球下',
        ko: '도끼에서 먼 도넛 밑으로'
      }
    }
  }, {
    id: 'Aloalo Quaqua Arcane Armaments Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '8B8C',
      source: 'Quaqua',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '3x Knockback',
        de: '3x Rückstoß',
        fr: 'Poussée x3',
        ja: '3x ノックバック',
        cn: '3x 击退',
        ko: '3x 넉백'
      }
    }
  }, {
    id: 'Aloalo Quaqua Arcane Armaments Rout',
    type: 'StartsUsing',
    netRegex: {
      id: '8B90',
      source: 'Quaqua',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '4x Charge',
        de: '4x Ansturm',
        fr: 'Ruée x4',
        ja: '4x 突進',
        cn: '4x 突进',
        ko: '4x 돌진'
      }
    }
  }, {
    id: 'Aloalo Quaqua Arcane Armaments Water Spear',
    type: 'StartsUsing',
    netRegex: {
      id: '8B9F',
      source: 'Quaqua',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from spears',
        de: 'Außen zwichen den Dreizack',
        fr: 'Éloignez-vous des lances',
        ja: '槍の間の外側へ',
        cn: '远离枪的落点',
        ko: '창에서 멀리 떨어지기'
      }
    }
  }, {
    id: 'Aloalo Quaqua Arcane Armaments Poison Spear',
    type: 'StartsUsing',
    netRegex: {
      id: '8BA3',
      source: 'Quaqua',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid spreading spear puddles',
        de: 'Weiche den größer werdenen Speerflächen aus',
        fr: 'Évitez d\'éloigner les flaques des lances',
        cn: '远离扩散毒',
        ko: '커지는 창 장판 피하기'
      }
    }
  }, {
    id: 'Aloalo Quaqua Violet Storm',
    type: 'StartsUsing',
    netRegex: {
      id: '8B95',
      source: 'Quaqua',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Aloalo Quaqua Arcane Intervention',
    type: 'StartsUsing',
    netRegex: {
      id: '8BAE',
      source: 'Quaqua',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look Away from Rings',
        de: 'Schau von den Ringen weg',
        fr: 'Ne regardez pas l\'anneau',
        ja: '輪から視線回避',
        cn: '视线避开圆环',
        ko: '고리 모양 눈 시선 피하기'
      }
    }
  },
  // ----------------------------------------- Ketuduke
  {
    id: 'Aloalo Ketuduke Tidal Roar',
    type: 'StartsUsing',
    netRegex: {
      id: '8AA5',
      source: 'Ketuduke',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe(),
    run: data => data.isKetuFight = true
  }, {
    id: 'Aloalo Ketuduke Encroaching Twintides',
    type: 'StartsUsing',
    netRegex: {
      id: '8A9F',
      source: 'Ketuduke',
      capture: false
    },
    response: responses/* Responses.getInThenOut */.n3.getInThenOut()
  }, {
    id: 'Aloalo Ketuduke Receding Twintides',
    type: 'StartsUsing',
    netRegex: {
      id: '8A9D',
      source: 'Ketuduke',
      capture: false
    },
    response: responses/* Responses.getOutThenIn */.n3.getOutThenIn()
  }, {
    id: 'Aloalo Ketuduke Fluke Typhoon',
    type: 'StartsUsing',
    netRegex: {
      id: '8A84',
      source: 'Ketuduke',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bubbles Move 2 Tiles',
        de: 'Blasen 2 Flächen Rückstoß',
        fr: 'Bulles Déplacement de 2 carreaux',
        ja: '泡のみ2マスのノックバック',
        cn: '被球包裹移动2行',
        ko: '거품은 2칸 이동함'
      }
    }
  }, {
    // Path 01
    id: 'Aloalo Ketuduke Water III',
    type: 'Tether',
    netRegex: {
      id: '0001',
      source: 'Summoned Apa'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stretch Tether',
        de: 'Verbindung langziehen',
        fr: 'Étirez les liens',
        cn: '拉断连线',
        ko: '선 늘이기'
      }
    }
  }, {
    // Path 02
    id: 'Aloalo Ketuduke Tidal Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '8D12',
      source: 'Ketuduke',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback => Get in Bubble',
        de: 'Rückstoß => Geh in eine Blase',
        fr: 'Poussée => Allez dans la bulle',
        cn: '击退 => 进入泡泡',
        ko: '넉백 => 거품 안으로'
      }
    }
  }, {
    // Path 03
    id: 'Aloalo Ketuduke Zaratan Add',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '12539',
      npcBaseId: '16538',
      capture: false
    },
    condition: data => data.isKetuFight,
    delaySeconds: 16,
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get behind non-bubbled Zaratan',
        de: 'Geh hinter einen Zaratan ohne Blase',
        fr: 'Allez derrière le Zaratan sans bulle',
        cn: '躲到没有泡泡包裹的后面',
        ko: '거품 밖에 있는 쫄 뒤로'
      }
    }
  }, {
    // Path 04
    id: 'Aloalo Ketuduke Ogrebon Add',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '12540',
      capture: false
    },
    condition: data => data.isKetuFight,
    delaySeconds: 18,
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get in Bubble',
        de: 'Geh in eine Blase',
        fr: 'Allez dans la bulle',
        cn: '进入泡泡',
        ko: '거품 안으로'
      }
    }
  }, {
    id: 'Aloalo Ketuduke Hydroblast',
    type: 'StartsUsing',
    netRegex: {
      id: '8AA3',
      source: 'Ketuduke'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  },
  // ----------------------------------------- Lala
  {
    id: 'Aloalo Lala Lala Rotation',
    type: 'HeadMarker',
    netRegex: {
      id: ['01E4', '01E5'],
      target: 'Lala'
    },
    run: (data, matches) => data.lalaRotate = matches.id === '01E4' ? 'cw' : 'ccw'
  }, {
    id: 'Aloalo Lala Player Rotation',
    type: 'HeadMarker',
    netRegex: {
      id: ['01ED', '01EE']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => data.lalaRotate = matches.id === '01ED' ? 'cw' : 'ccw'
  }, {
    id: 'Aloalo Lala Inferno Theorem',
    type: 'StartsUsing',
    netRegex: {
      id: '887F',
      source: 'Lala',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aloalo LaLa Arcane Blight Open',
    type: 'StartsUsing',
    netRegex: {
      id: Object.keys(ArcaneBlightMap),
      source: 'Lala'
    },
    run: (data, matches) => data.lalaArcaneBlight = ArcaneBlightMap[matches.id.toUpperCase()]
  }, {
    id: 'Aloalo Lala Arcane Blight',
    type: 'StartsUsing',
    netRegex: {
      id: '8873',
      source: 'Lala',
      capture: false
    },
    delaySeconds: 1,
    alertText: (data, _matches, output) => {
      if (data.lalaArcaneBlight === undefined) return output.text();
      if (data.lalaRotate === undefined) return output[data.lalaArcaneBlight]();
      if (data.lalaRotate === 'cw') {
        return {
          'front': output.right(),
          'back': output.left(),
          'left': output.front(),
          'right': output.back()
        }[data.lalaArcaneBlight];
      }
      return {
        'front': output.left(),
        'back': output.right(),
        'left': output.back(),
        'right': output.front()
      }[data.lalaArcaneBlight];
    },
    run: data => {
      delete data.lalaArcaneBlight;
      delete data.lalaRotate;
    },
    outputStrings: {
      text: {
        en: 'Go to safe zone',
        de: 'Geh in den sicheren Bereich',
        fr: 'Allez dans une zone sûre',
        ja: '安置へ移動',
        cn: '前往安全区',
        ko: '안전지대로'
      },
      front: outputs/* default.front */.Z.front,
      back: outputs/* default.back */.Z.back,
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'Aloalo Lala Analysis Direction',
    type: 'GainsEffect',
    // E8E Front Unseen
    // E8F Back Unseen
    // E90 Right Unseen
    // E91 Left Unseen
    netRegex: {
      effectId: ['E8E', 'E8F', 'E90', 'E91'],
      source: 'Lala'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 0.5,
    durationSeconds: 8,
    suppressSeconds: 12,
    // Once again if failed. Suppress them
    alertText: (data, matches, output) => {
      const map = {
        'E8E': 'front',
        'E8F': 'back',
        'E90': 'right',
        'E91': 'left'
      }[matches.effectId];
      if (map === undefined) return;
      if (data.lalaRotate === undefined) return output[map]();
      if (data.lalaRotate === 'ccw') return {
        'front': output.left(),
        'back': output.right(),
        'left': output.back(),
        'right': output.front()
      }[map];
      return {
        'front': output.right(),
        'back': output.left(),
        'left': output.front(),
        'right': output.back()
      }[map];
    },
    run: data => delete data.lalaRotate,
    outputStrings: {
      front: {
        en: 'Face Towards Lala',
        de: 'Schau Lala an',
        fr: 'Regardez Lala',
        cn: '面向拉拉',
        ko: '보스 쳐다보기'
      },
      back: {
        en: 'Look Away from Lala',
        de: 'Schau von Lala weg',
        fr: 'Ne regardez pas Lala',
        cn: '背对拉拉',
        ko: '뒤돌기'
      },
      left: {
        en: 'Left Flank towards Lala',
        de: 'Linke Seite zu Lala drehen',
        fr: 'Flanc gauche vers Lala',
        cn: '左侧朝向拉拉',
        ko: '왼쪽 측면을 보스쪽으로'
      },
      right: {
        en: 'Right Flank towards Lala',
        de: 'Rechte Seite zu Lala drehen',
        fr: 'Flanc droit vers Lala',
        cn: '右侧朝向拉拉',
        ko: '오른쪽 측면을 보스쪽으로'
      }
    }
  }, {
    id: 'Aloalo Lala Floral Figure',
    type: 'StartsUsing',
    netRegex: {
      id: '8880',
      source: 'Lala',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Seed adds => Donut AOEs',
        de: 'Samen Adds => Donut AoEs',
        fr: 'Adds graine => AoEs Donut',
        ja: '種 => ドーナツAOE',
        cn: '种子 => 距离衰减AoE',
        ko: '씨앗 등장 => 도넛 장판'
      }
    }
  }, {
    id: 'Aloalo Lala Faunal Figure',
    type: 'StartsUsing',
    netRegex: {
      id: '8882',
      source: 'Lala',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Armadillo adds => Big AOEs',
        de: 'Fledermaus Adds => Große AoEs',
        fr: 'Adds tatou => Grosses AoEs',
        ja: 'コウモリ => ゆかAOE',
        cn: '场边小怪 => 大AoE',
        ko: '아르마딜로 등장 => 거리비례 장판'
      }
    }
  }, {
    id: 'Aloalo Lala Constructive Figure',
    type: 'StartsUsing',
    netRegex: {
      id: '8884',
      source: 'Lala',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tree adds => Line AOEs',
        de: 'Baum Adds => Linien AoEs',
        fr: 'Adds Arbre => AoEs en ligne',
        ja: '木 => 直線AOE',
        cn: '树木 => 直线 AoE',
        ko: '나무 등장 => 직선 장판'
      }
    }
  }, {
    id: 'Aloalo Lala Strategic Strike',
    type: 'StartsUsing',
    netRegex: {
      id: '887E',
      source: 'Lala'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Aloalo Lala Calculated Trajectory',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E83', 'E84', 'E85', 'E86']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 3,
    durationSeconds: 7,
    alertText: (data, matches, output) => {
      const map = {
        'E83': 'front',
        'E84': 'back',
        'E85': 'left',
        'E86': 'right'
      }[matches.effectId];
      if (map === undefined) return;
      if (data.lalaRotate === undefined) return output[map]();
      if (data.lalaRotate === 'cw') {
        return {
          'front': output.right(),
          'back': output.left(),
          'left': output.front(),
          'right': output.back()
        }[map];
      }
      return {
        'front': output.left(),
        'back': output.right(),
        'left': output.back(),
        'right': output.front()
      }[map];
    },
    run: data => delete data.lalaRotate,
    outputStrings: {
      front: {
        en: 'Forward March (1 square)',
        de: 'Geistlenkung: Vorwärts',
        fr: 'Vers l\'avant (1 carreau)',
        ja: '強制移動 : 前',
        // FIXME
        cn: '强制移动 : 前',
        ko: '강제이동: 앞 (1칸)'
      },
      back: {
        en: 'Backwards March (1 square)',
        de: 'Geistlenkung: Rückwärts',
        fr: 'Vers l\'arrière (1 carreau)',
        ja: '強制移動 : 後ろ',
        // FIXME
        cn: '强制移动 : 后',
        ko: '강제이동: 뒤 (1칸)'
      },
      left: {
        en: 'Left March (1 square)',
        de: 'Geistlenkung: Links',
        fr: 'Vers la gauche (1 carreau)',
        ja: '強制移動 : 左',
        // FIXME
        cn: '强制移动 : 左',
        ko: '강제이동: 왼쪽 (1칸)'
      },
      right: {
        en: 'Right March (1 square)',
        de: 'Geistlenkung: Rechts',
        fr: 'Vers la droite (1 carreau)',
        ja: '強制移動 : 右',
        // FIXME
        cn: '强制移动 : 右',
        ko: '강제이동: 오른쪽 (1칸)'
      }
    }
  },
  // ----------------------------------------- Statice
  {
    id: 'Aloalo Statice Pop',
    type: 'StartsUsing',
    netRegex: {
      id: '892F',
      source: 'Statice',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Aloalo Statice Trick Reload',
    type: 'StartsUsing',
    netRegex: {
      id: '892A',
      source: 'Statice',
      capture: false
    },
    run: data => {
      data.reloadCount = 0;
      data.reloadFailed = [];
    }
  }, {
    id: 'Aloalo Statice Locked and Loaded',
    type: 'Ability',
    netRegex: {
      id: '8925',
      source: 'Statice',
      capture: false
    },
    run: data => data.reloadCount++
  }, {
    id: 'Aloalo Statice Misload',
    type: 'Ability',
    netRegex: {
      id: '8926',
      source: 'Statice',
      capture: false
    },
    run: data => {
      data.reloadCount++;
      data.reloadFailed.push(data.reloadCount);
    }
  }, {
    id: 'Aloalo Statice Trigger Happy',
    type: 'StartsUsing',
    netRegex: {
      id: '892B',
      source: 'Statice',
      capture: false
    },
    infoText: (data, _matches, output) => {
      return output.text({
        safe: data.reloadFailed
      });
    },
    outputStrings: {
      text: {
        en: 'Safe: ${safe}',
        de: 'Sicher: ${safe}',
        fr: 'Sûr : ${safe}',
        ja: '安置: ${safe}',
        cn: '${safe} 边安全',
        ko: '안전: ${safe}'
      }
    }
  }, {
    id: 'Aloalo Statice Aero IV',
    type: 'StartsUsing',
    netRegex: {
      id: '8929',
      source: 'Statice',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aloalo Statice Shocking Abandon',
    type: 'StartsUsing',
    netRegex: {
      id: '8928',
      source: 'Statice'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Aloalo Statice Fair Flight',
    type: 'StartsUsing',
    netRegex: {
      id: '8946',
      source: 'Statice',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand on cushion',
        de: 'Auf einem Kissen stehen',
        fr: 'Restez sur le coussin',
        cn: '站在垫子上',
        ko: '발판 위에 있기'
      }
    }
  },
  // ----------------------------------------- Loquloqui
  {
    id: 'Aloalo Loquloqui Long-lost Light',
    type: 'StartsUsing',
    netRegex: {
      id: '87BC',
      source: 'Loquloqui',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aloalo Loquloqui O Life, Flourish',
    type: 'StartsUsing',
    netRegex: {
      id: '87C4',
      source: 'Loquloqui',
      capture: false
    },
    durationSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Glowing adds get larger',
        de: 'Weiche leuchtenden Adds aus',
        fr: 'Les adds brillants deviennent plus large',
        ja: '光ってる物に注意',
        cn: '注意发光小怪变大',
        ko: '빛나는 쫄 장판은 커짐'
      }
    }
  }, {
    id: 'Aloalo Loquloqui Protective Will',
    type: 'StartsUsing',
    netRegex: {
      id: '87BE',
      source: 'Loquloqui'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Aloalo Loquloqui O Petals, Unfurl',
    type: 'StartsUsing',
    netRegex: {
      id: '87C5',
      source: 'Loquloqui',
      capture: false
    },
    durationSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from tether ends',
        de: 'Weiche Verbindungen aus',
        fr: 'Loin de l\'extrémité du lien',
        ja: '縮む線を回避',
        cn: '远离连线末端',
        ko: '선 끝부분 멀리 피하기'
      }
    }
  }, {
    id: 'Aloalo Loquloqui Land Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '87BD',
      source: 'Loquloqui',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Aloalo Loquloqui O Isle, Bloom',
    type: 'StartsUsing',
    netRegex: {
      id: '87C7',
      source: 'Loquloqui',
      capture: false
    },
    durationSeconds: 10,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Last bloom => Walk into Safe',
        de: 'Letzte Blüte => Geh zum sicheren Bereich',
        fr: 'Dernière fleur => Allez dans une zone sûre',
        ja: '最後の花畑 => 安置へ移動',
        cn: '最后的花丛 => 前往安全区',
        ko: '마지막 꽃 => 안전지대로'
      }
    }
  }, {
    id: 'Aloalo Loquloqui Sanctuary',
    type: 'StartsUsing',
    netRegex: {
      id: '87CA',
      source: 'Loquloqui',
      capture: false
    },
    durationSeconds: 4.5,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Aloalo Loquloqui Stirring of Spirits',
    type: 'StartsUsing',
    netRegex: {
      id: '87CB',
      source: 'Loquloqui',
      capture: false
    },
    durationSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '5x Knockback',
        de: '5x Rückstoß',
        fr: 'Poussée x5',
        ja: '5x ノックバック',
        cn: '5x 击退',
        ko: '5x 넉백'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Far Tide/Near Tide': 'Far/Near Tide',
      'Meteor/Sledgemagic/Hunks of Junk/Happy Surprise': '--dartboard result--',
      'Receding Twintides/Encroaching Twintides': 'Receding/Encroaching Twintides'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Aetheric Charge': 'magisch(?:e|er|es|en) Sphäre',
      'Aloalo Ahool': 'Aloalo-Ahool',
      'Aloalo Golem': 'Aloalo-Holzgolem',
      'Aloalo Ogrebon': 'Aloalo-Ogerbon',
      'Aloalo Zaratan': 'Aloalo-Zaratan',
      'Anala Familiar': 'Anala-Familiar',
      'Drake Familiar': 'Drakon-Familiar',
      'Kairimai Loquloqai': 'Kairimai Loquloqai',
      'Kapokapo': 'Kapokapo',
      'Ketuduke': 'Ketuduke',
      'Ketulu Cove': 'Ketulu-Bucht',
      'Lala': 'Lala',
      'Loquloqui': 'Loquloqui',
      'Needle': 'Nadel',
      'Quaqua': 'Quaqua',
      'Repuruba Loqua': 'Repuruba Loqua',
      'Rodiaki': 'Rodiaki',
      'Seasong\'s Rest': 'Ruh der Seesänger',
      'Spring Crystal': 'Wasserquell-Kristall',
      'Statice': 'Statice',
      'Summoned Anila': 'Anila-Beschwörung',
      'Summoned Apa': 'Apa-Beschwörung',
      'Surprising Staff': 'Überraschungsstab',
      'The Elder Stump': 'Altenstumpf',
      'The Origin Spring': 'Urquell',
      'The Slumbering Canopy': 'Schlafende Krone',
      'The ancient forum': 'Altes Forum',
      'Treasure Box': 'Schatzkiste',
      'Uolosapa Loqua': 'Uolosapa Loqua',
      'Zeal-blind Zozone': 'Zozone vom Feuereifer'
    },
    'replaceText': {
      '--cleanse--': '--reinigen--',
      '4-tonze Weight': ' 4 Tonzen',
      'Aero II': 'Windra',
      'Aero IV': 'Windka',
      'Analysis': 'Analyse',
      'Arcane Armaments': 'Arkane Armierung',
      'Arcane Blight': 'Arkane Fäule',
      'Arcane Intervention': 'Strenger Blick',
      'Arcane Plot': 'Arkane Flur',
      'Arcane Pursuit': 'Arkane Verfolgung',
      'Blowing Bubbles': 'Pusteblasen',
      'Brilliant Blossoms': 'Erblühter Grund',
      'Bubble Net': 'Blasennetz',
      'Burst': 'Explosion',
      'Calculated Trajectory': 'Marschbefehl',
      'Cloud to Ground': 'Sturmkonzentration',
      'Constructive Figure': 'Ruf der Schöpfer',
      'Dartboard': 'Dartspielchen',
      'Elemental Impact': 'Einschlag',
      'Encroaching Twintides': 'Ring der Zwiegezeiten',
      'Faerie Ring': 'Feenring',
      'Faerie Road': 'Feenpfad',
      'Fair Flight': 'Feenflug',
      'Far Tide': 'Ring der Gezeiten',
      'Faunal Figure': 'Ruf der Fauna',
      'Fire Spread': 'Brandstiftung',
      'Flail Smash': 'Dresche',
      'Floral Figure': 'Ruf der Flora',
      'Flowing Lance': 'Fließende Lanze',
      'Fluke Typhoon': 'Flossentaifun',
      'Hammer Landing': 'Hammersprung',
      'Happy Surprise': 'Fröhliche Überraschung',
      'Hidden Mine': 'Minenfalle',
      'Howl': 'Geheul',
      'Hundred Lashings': 'Auspeitschung',
      'Hunks of Junk': 'Metallschrott',
      'Hydroblast': 'Hydro-Schlag',
      'Hydrobomb': 'Hydro-Bombe',
      'Hydrosurge': 'Hydro-Wallung',
      'Inferno Theorem': 'Infernales Theorem',
      'Islebloom Light': 'Lebende Erde',
      'Jack-in-the-box': 'Springteufel',
      'Land Wave': 'Landwelle',
      'Long-lost Light': 'Verlorenes Licht',
      'Made Magic': 'Magiefeuer',
      'Meteor': 'Meteor',
      'Near Tide': 'Kreis der Gezeiten',
      'O Isle, Bloom': 'O Insel, erblühe!',
      'O Life, Flourish': 'O Leben, gedeihe!',
      'O Petals, Unfurl': 'O Blüten, erwachet!',
      'O Sky, Be Mine': 'O Himmel, werde mein!',
      'Pinwheel': 'Feuerrad',
      'Pliant Petals': 'Erwachte Blüte',
      'Pop': 'Platzen',
      'Present Box': 'Geschenkschachtel',
      'Protective Will': 'Schützender Wille',
      'Ravaging Axe': 'Verheerende Axt',
      'Receding Twintides': 'Kreis der Zwiegezeiten',
      'Ringing Quoits': 'Klingende Ringe',
      '(?<! )Roar': 'Brüllen',
      'Rolling Spout': 'Ringguss',
      'Rout': 'Kolossgalopp',
      'Rush': 'Stürmen',
      'Sanctuary': 'Zuflucht',
      'Saturate': 'Wasserfontäne',
      'Scalding Waves': 'Siedende Wogen',
      'Shock(?!\\w)': 'Entladung',
      'Shocking Abandon': 'Schockende Hingabe',
      'Shockwave': 'Schockwelle',
      'Sledgemagic': 'Vorschlagmagie',
      'Sphere Shatter': 'Sphärensplitterung',
      'Spring Crystals': 'Quellkristalle',
      'Stirring of Spirits': 'Erwachen der Geister',
      'Strategic Strike': 'Schwere Attacke',
      'Strewn Bubbles': 'Streublasen',
      'Summon(?!\\w)': 'Familiar',
      'Summoning Rite': 'Beschwörung',
      'Surprise Balloon': 'Überraschungsballon',
      'Surprise Needle': 'Überraschungsnadel',
      'Targeted Light': 'Gezieltes Licht',
      'Thunderstorm': 'Gewitter',
      'Tidal Roar': 'Schrei der Gezeiten',
      'Tidal Wave': 'Flutwelle',
      'Trick Reload': 'Trickladung',
      'Trigger Happy': 'Schießwut',
      'Turnabout': 'Umdrehung',
      'Updraft': 'Aufwind',
      'Violet Storm': 'Fliederblitz',
      'Volcanic Coordinates': 'Infernaler Durchstoß',
      'Water III': 'Aquaga',
      'Wavefoam': 'Blasenwelle',
      'Whoopee Cushion': 'Pupskissen'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aetheric Charge': 'globe magique',
      'Aloalo Ahool': 'ahool d\'Aloalo',
      'Aloalo Golem': 'golem sylvestre d\'Aloalo',
      'Aloalo Ogrebon': 'ogrebon d\'Aloalo',
      'Aloalo Zaratan': 'zaratan d\'Aloalo',
      'Anala Familiar': 'anala apprivoisé',
      'Drake Familiar': 'draconide apprivoisé',
      'Kairimai Loquloqai': 'Kairimai Loquloqai',
      'Kapokapo': 'Kapokapo',
      'Ketuduke': 'Ketuduke',
      'Ketulu Cove': 'Baie de Ketulu',
      'Lala': 'Lala',
      'Loquloqui': 'Loquloqui',
      'Needle': 'aiguille',
      'Quaqua': 'Quaqua',
      'Repuruba Loqua': 'repuruba loqua',
      'Rodiaki': 'Rodiaki',
      'Seasong\'s Rest': 'Repos du Chant marin',
      'Spring Crystal': 'cristal de source',
      'Statice': 'Statice',
      'Summoned Anila': 'anila d\'Aloalo',
      'Summoned Apa': 'apa d\'Aloalo',
      'Surprising Staff': 'sceptre surprise',
      'The Elder Stump': 'Souche du Doyen',
      'The Origin Spring': 'Fontaine de l\'Origine',
      'The Slumbering Canopy': 'Voûte apaisée',
      'The ancient forum': 'Ancienne grand-place',
      'Treasure Box': 'coffre au trésor mécanique',
      'Uolosapa Loqua': 'uolosapa loqua',
      'Zeal-blind Zozone': 'Zozone le téméraire'
    },
    'replaceText': {
      '--cleanse--': '--Guérison--',
      '4-tonze Weight': 'Poids de 4 tonz',
      'Aero II': 'Extra Vent',
      'Aero IV': 'Giga Vent',
      'Analysis': 'Analyse',
      'Arcane Armaments': 'Armes arcaniques',
      'Arcane Blight': 'Canon arcanique',
      'Arcane Intervention': 'Œil sévère',
      'Arcane Plot': 'Modulateur arcanique',
      'Arcane Pursuit': 'Chaîne arcanique',
      'Blowing Bubbles': 'Bulles soufflées',
      'Brilliant Blossoms': 'Tempête de pétales',
      'Bubble Net': 'Filet de bulles',
      'Burst': 'Explosion',
      'Calculated Trajectory': 'Déplacement forcé',
      'Cloud to Ground': 'Attaque fulminante',
      'Constructive Figure': 'Icône articulée',
      'Dartboard': 'Jeu de fléchettes',
      'Elemental Impact': 'Impact de canon',
      'Encroaching Twintides': 'Double marée débordante',
      'Faerie Ring': 'Cercle féérique',
      'Faerie Road': 'Route féérique',
      'Fair Flight': 'Projection féérique',
      'Far Tide': 'Marée lointaine',
      'Faunal Figure': 'Icône bestiale',
      'Fire Spread': 'Nappe de feu',
      'Flail Smash': 'Fléau fracassant',
      'Floral Figure': 'Icône florale',
      'Flowing Lance': 'Lance hydrique',
      'Fluke Typhoon': 'Typhon hasardeux',
      'Hammer Landing': 'Bondissement martelé',
      'Happy Surprise': 'Heureuse surprise',
      'Hidden Mine': 'Explosion de mine',
      'Howl': 'Hurlement',
      'Hundred Lashings': 'Cent coups de fouet',
      'Hunks of Junk': 'Débris de métal',
      'Hydroblast': 'Souffle hydrique',
      'Hydrobomb': 'Hydrobombe',
      'Hydrosurge': 'Déferlante hydrique',
      'Inferno Theorem': 'Théorème infernal',
      'Islebloom Light': 'Lueur ascendante',
      'Jack-in-the-box': 'Coffres au trésor',
      'Land Wave': 'Vague tellurique',
      'Long-lost Light': 'Lumière perdue',
      'Made Magic': 'Déferlante magique',
      'Meteor': 'Météore',
      'Near Tide': 'Marée proche',
      'O Isle, Bloom': 'Prière de fertilité',
      'O Life, Flourish': 'Prière de renaissance',
      'O Petals, Unfurl': 'Prière d\'éclosion',
      'O Sky, Be Mine': 'Prière d\'expansion',
      'Pinwheel': 'Moulinette',
      'Pliant Petals': 'Cercle de floraison',
      'Pop': 'Rupture',
      'Present Box': 'Boîtes cadeaux',
      'Protective Will': 'Esprit protecteur',
      'Ravaging Axe': 'Hache dévastatrice',
      'Receding Twintides': 'Double marée fuyante',
      'Ringing Quoits': 'Anneaux tintants',
      '(?<! )Roar': 'Rugissement',
      'Rolling Spout': 'Jaillissement annulaire',
      'Rout(?!\\w)': 'Charge pachydermique',
      'Rush': 'Ruée',
      'Sanctuary': 'Éclat de l\'apaisement divin',
      'Saturate': 'Jet d\'eau',
      'Scalding Waves': 'Ondes enflammées',
      'Shock(?!\\w)': 'Décharge électrostatique',
      'Shocking Abandon': 'Choc renonciateur',
      'Shockwave': 'Onde de choc',
      'Sledgemagic': 'Masse magique',
      'Sphere Shatter': 'Rupture',
      'Spring Crystals': 'Cristaux de source',
      'Stirring of Spirits': 'Écrasement de l\'apaisement divin',
      'Strategic Strike': 'Coup violent',
      'Strewn Bubbles': 'Bulles éparpillées',
      'Summon(?!\\w)': 'Invocation',
      'Summoning Rite': 'Invocation rituelle',
      'Surprise Balloon': 'Ballon surprise',
      'Surprise Needle': 'Aiguille surprise',
      'Targeted Light': 'Rayon ciblé',
      'Thunderstorm': 'Tempête de foudre',
      'Tidal Roar': 'Vague rugissante',
      'Tidal Wave': 'Raz-de-marée',
      'Trick Reload': 'Rechargement habile',
      'Trigger Happy': 'Gâchette impulsive',
      'Turnabout': 'Rotation',
      'Updraft': 'Courants ascendants',
      'Violet Storm': 'Tempête pourpre',
      'Volcanic Coordinates': 'Théorème combustible',
      'Water III': 'Méga Eau',
      'Wavefoam': 'Vague de bulles',
      'Whoopee Cushion': 'Coussins péteurs'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Aetheric Charge': '魔力球',
      'Aloalo Ahool': 'アロアロ・アフール',
      'Aloalo Golem': 'アロアロ・ウッドゴーレム',
      'Aloalo Ogrebon': 'アロアロ・オーガボン',
      'Aloalo Zaratan': 'アロアロ・ザラタン',
      'Anala Familiar': 'アナラ・ファミリア',
      'Drake Familiar': 'ドレイク・ファミリア',
      'Kairimai Loquloqai': '神子の祭壇',
      'Kapokapo': 'カポカポ',
      'Ketuduke': 'ケトゥドゥケ',
      'Ketulu Cove': 'ケトゥルの江湾',
      'Lala': 'ララ',
      'Loquloqui': 'ロクロクイ',
      'Needle': 'ニードル',
      'Quaqua': 'クアクア',
      'Repuruba Loqua': 'レプルバ・ロクア',
      'Rodiaki': 'ロディアキ',
      'Seasong\'s Rest': '鯨の還る地',
      'Spring Crystal': '湧水のクリスタル',
      'Statice': 'スターチス',
      'Summoned Anila': 'サモン・アニラ',
      'Summoned Apa': 'サモン・アーパス',
      'Surprising Staff': 'サプライズ・ロッド',
      'The Elder Stump': '老樹の切り株',
      'The Origin Spring': '大樹の命泉',
      'The Slumbering Canopy': '昏き微睡の間',
      'The ancient forum': '古き広場',
      'Treasure Box': 'トレジャーボックス',
      'Uolosapa Loqua': 'オーロサパ・ロクア',
      'Zeal-blind Zozone': '粗忽のゾゾネ'
    },
    'replaceText': {
      '4-tonze Weight': '4トンズ',
      'Aero II': 'エアロラ',
      'Aero IV': 'エアロジャ',
      'Analysis': 'アナライズ',
      'Arcane Armaments': '魔力成形',
      'Arcane Blight': '魔紋砲',
      'Arcane Intervention': '魔眼',
      'Arcane Plot': '変光魔紋',
      'Arcane Pursuit': '魔力の呪鎖',
      'Blowing Bubbles': 'バブルブロワー',
      'Brilliant Blossoms': '地に満つる風花',
      'Bubble Net': 'バブルネットフィーディング',
      'Burst': '爆発',
      'Calculated Trajectory': '強制移動',
      'Cloud to Ground': '襲雷',
      'Constructive Figure': '人形召喚',
      'Dartboard': 'ダーツチャレンジ',
      'Elemental Impact': '着弾',
      'Encroaching Twintides': 'リング・ダブルタイド',
      'Faerie Ring': 'フェアリーリング',
      'Faerie Road': 'フェアリーロード',
      'Fair Flight': 'フェアリーノックアップ',
      'Far Tide': 'リングタイド',
      'Faunal Figure': '動物召喚',
      'Fire Spread': '放火',
      'Flail Smash': 'フレイルスマッシュ',
      'Floral Figure': '植物召喚',
      'Flowing Lance': '水槍',
      'Fluke Typhoon': 'フリッパータイフーン',
      'Hammer Landing': '衝槌撃',
      'Happy Surprise': 'サプライズハッピー',
      'Hidden Mine': '地雷爆発',
      'Howl': '遠吠え',
      'Hundred Lashings': 'めった打ち',
      'Hunks of Junk': 'メタルジャンク',
      'Hydroblast': 'ハイドロブラスト',
      'Hydrobomb': 'ハイドロボム',
      'Hydrosurge': 'ハイドロサージ',
      'Inferno Theorem': '散火法',
      'Islebloom Light': '地より昇る光',
      'Jack-in-the-box': 'ジャック・イン・ザ・ボックス',
      'Land Wave': '地霊波',
      'Long-lost Light': '忘れられた光',
      'Made Magic': '魔力放出',
      'Meteor': 'メテオ',
      'Near Tide': 'ラウンドタイド',
      'O Isle, Bloom': '祈願：地に満ちよ',
      'O Life, Flourish': '祈願：生い育て',
      'O Petals, Unfurl': '祈願：咲き誇れ',
      'O Sky, Be Mine': '祈願：伸び育て',
      'Pinwheel': 'ピンウィール',
      'Pliant Petals': '咲き誇る大輪',
      'Pop': '破裂',
      'Present Box': 'プレゼントボックス',
      'Protective Will': '霊衝',
      'Ravaging Axe': '戦斧の一撃',
      'Receding Twintides': 'ラウンド・ダブルタイド',
      'Ringing Quoits': '戦輪の旋撃',
      '(?<! )Roar': '咆哮',
      'Rolling Spout': 'リングスパウト',
      'Rout': '猛進',
      'Rush': '突進',
      'Sanctuary': '地鎮の輝き',
      'Saturate': '放水',
      'Scalding Waves': '炎波',
      'Shock(?!\\w)': '放電',
      'Shocking Abandon': 'アバンドンショック',
      'Shockwave': '衝撃波',
      'Sledgemagic': 'マジック・スレッジハンマー',
      'Sphere Shatter': '破裂',
      'Spring Crystals': '湧水のクリスタル',
      'Stirring of Spirits': '地鎮の足踏み',
      'Strategic Strike': '強撃',
      'Strewn Bubbles': 'バブルストゥルー',
      'Summon(?!\\w)': 'サモン',
      'Summoning Rite': '招来',
      'Surprise Balloon': 'サプライズバルーン',
      'Surprise Needle': 'サプライズニードル',
      'Targeted Light': '高精度光弾',
      'Thunderstorm': 'サンダーストーム',
      'Tidal Roar': 'タイダルロア',
      'Tidal Wave': 'タイダルウェイブ',
      'Trick Reload': 'トリックリロード',
      'Trigger Happy': 'トリガーハッピー',
      'Turnabout': '旋回',
      'Updraft': '上昇気流',
      'Violet Storm': '紫雷波',
      'Volcanic Coordinates': '点火法',
      'Water III': 'ウォタガ',
      'Wavefoam': 'バブルウェイブ',
      'Whoopee Cushion': 'ウーピークッション'
    }
  }]
};
/* harmony default export */ const aloalo_island = (aloalo_island_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/aloalo_island.txt
const dungeon_aloalo_island_namespaceObject = "### ALOALO ISLAND\r\n# ZoneId: 498\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~~~~~~~~~~~~#\r\n# Quaqua (left path) #\r\n#~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 8B94:1012.4\r\n# -ii 8B89 8B98 8B9C 8B9D 8B93\r\n\r\n# Ketulu Cove will be sealed off\r\n#1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1128\" } window 10000,0\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1128\" } window 10000,0\r\n1006.1 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1007.4 \"--sync--\" StartsUsing { id: \"8B94\", source: \"Quaqua\" } window 10,10\r\n1012.4 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" }\r\n1022.5 \"Arcane Armaments\" Ability { id: \"8B88\", source: \"Quaqua\" }\r\n1024.7 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1027.5 \"Ravaging Axe\" Ability { id: \"8B8A\", source: \"Aetheric Charge\" }\r\n\r\n1031.2 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" }\r\n1041.3 \"Arcane Armaments\" Ability { id: \"8B88\", source: \"Quaqua\" }\r\n1046.2 \"Ringing Quoits\" Ability { id: \"8B8B\", source: \"Aetheric Charge\" }\r\n\r\n1051.5 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1052.6 \"--sync--\" StartsUsing { id: \"8B8C\", source: \"Quaqua\" } window 40,40 jump \"quaqua-left-sunny\"\r\n1052.6 \"--sync--\" StartsUsing { id: \"8B90\", source: \"Quaqua\" } window 40,40 jump \"quaqua-left-rainy\"\r\n1057.6 \"Arcane Armaments\"\r\n\r\n1252.6 label \"quaqua-left-sunny\"\r\n1252.6 \"--sync--\" StartsUsing { id: \"8B8C\", source: \"Quaqua\" }\r\n1257.6 \"Arcane Armaments\" Ability { id: \"8B8C\", source: \"Quaqua\" }\r\n1267.7 \"Hammer Landing 1\" Ability { id: \"8B8D\", source: \"Quaqua\" }\r\n1269.7 \"Hammer Landing 2\" #Ability { id: \"8B8E\", source: \"Quaqua\" }\r\n1271.7 \"Hammer Landing 3\" #Ability { id: \"8B8E\", source: \"Quaqua\" }\r\n\r\n1279.8 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1286.5 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n1292.6 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1297.8 \"Howl\" Ability { id: \"8B96\", source: \"Quaqua\" }\r\n1308.7 \"Scalding Waves\" Ability { id: \"8B97\", source: \"Anala Familiar\" } duration 15\r\n\r\n1317.0 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1323.7 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n1330.9 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1337.1 label \"quaqua-left-sunny-loop\"\r\n1337.1 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" }\r\n1347.2 \"Arcane Armaments\" Ability { id: \"8B88\", source: \"Quaqua\" }\r\n1352.1 \"Ravaging Axe\" Ability { id: \"8B8A\", source: \"Aetheric Charge\" }\r\n1352.1 \"Ringing Quoits\" Ability { id: \"8B8B\", source: \"Aetheric Charge\" }\r\n\r\n1361.4 \"Howl\" Ability { id: \"8B96\", source: \"Quaqua\" }\r\n1372.3 \"Scalding Waves\" Ability { id: \"8B97\", source: \"Anala Familiar\" } duration 15\r\n\r\n1386.4 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1392.9 \"Arcane Armaments\" Ability { id: \"8B8C\", source: \"Quaqua\" }\r\n1403.0 \"Hammer Landing 1\" Ability { id: \"8B8D\", source: \"Quaqua\" }\r\n1405.0 \"Hammer Landing 2\" #Ability { id: \"8B8E\", source: \"Quaqua\" }\r\n1407.0 \"Hammer Landing 3\" #Ability { id: \"8B8E\", source: \"Quaqua\" }\r\n\r\n1416.1 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1422.9 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n1429.1 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1435.3 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" } window 40,40 forcejump \"quaqua-left-sunny-loop\"\r\n\r\n\r\n1652.6 label \"quaqua-left-rainy\"\r\n1652.6 \"--sync--\" StartsUsing { id: \"8B90\", source: \"Quaqua\" }\r\n1657.6 \"Arcane Armaments\" Ability { id: \"8B90\", source: \"Quaqua\" }\r\n\r\n1659.7 \"--jump--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1666.6 \"Rout 1\" Ability { id: \"8B91\", source: \"Quaqua\" }\r\n1668.4 \"Rout 2\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n1670.0 \"Rout 3\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n1671.6 \"Rout 4\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n\r\n1678.7 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1685.5 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n1691.6 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1696.9 \"Howl\" Ability { id: \"8B96\", source: \"Quaqua\" }\r\n\r\n1706.8 \"Cloud to Ground\" Ability { id: \"8B9B\", source: \"Drake Familiar\" } duration 18.6\r\n#1110.8 \"Cloud to Ground 2\" Ability { id: \"8B9B\", source: \"Drake Familiar\" }\r\n\r\n1732.2 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1738.4 label \"quaqua-left-rainy-loop\"\r\n1738.4 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" }\r\n1748.5 \"Arcane Armaments\" Ability { id: \"8B88\", source: \"Quaqua\" }\r\n1753.4 \"Ravaging Axe\" Ability { id: \"8B8A\", source: \"Aetheric Charge\" }\r\n1753.4 \"Ringing Quoits\" Ability { id: \"8B8B\", source: \"Aetheric Charge\" }\r\n\r\n1762.7 \"Howl\" Ability { id: \"8B96\", source: \"Quaqua\" }\r\n1772.6 \"Cloud to Ground\" Ability { id: \"8B9B\", source: \"Drake Familiar\" } duration 18.6\r\n#1176.6 \"Cloud to Ground\" Ability { id: \"8B9B\", source: \"Drake Familiar\" }\r\n\r\n1787.9 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1794.1 \"Arcane Armaments\" Ability { id: \"8B90\", source: \"Quaqua\" }\r\n\r\n1796.1 \"--jump--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1802.8 \"Rout 1\" Ability { id: \"8B91\", source: \"Quaqua\" }\r\n1804.5 \"Rout 2\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n1806.1 \"Rout 3\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n1807.9 \"Rout 4\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n\r\n1814.0 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1820.8 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n1826.9 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n1833.1 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" } forcejump \"quaqua-left-rainy-loop\"\r\n\r\n\r\n# ALL ENCOUNTER ABILITIES (all paths)\r\n# 1961 attack auto damage from Quaqua\r\n# 8B88 Arcane Armaments self-targeted cast before axe/ring Arcane Armaments\r\n# 8B89 --sync-- self-targeted ability for orb transforming into armament\r\n# 8B8A Ravaging Axe fast cast and circle damage from Arcane Armaments axe\r\n# 8B8B Ringing Quoits fast cast and donut damage from Arcane Armaments ring\r\n# 8B8C Arcane Armaments self-targeted cast before hammer Arcane Armaments\r\n# 8B8D Hammer Landing cast and light knockback damage from initial Arcane Armaments hammer jump\r\n# 8B8E Hammer Landing light knockback damage from followup Arcane Armaments hammer jumps\r\n# 8B8F --sync-- repositioning\r\n# 8B90 Arcane Armaments self-targeted cast before 4x Rout charge Arcane Armaments\r\n# 8B91 Rout cast and damage for initial charge\r\n# 8B92 Rout damage for followup 3 charges\r\n# 8B93 --sync-- self-targeted preview casts of Rout\r\n# 8B94 Made Magic cast and raidwide damage that summons orbs\r\n# 8B95 Violet Storm cast and damage for large late telegraph front conal\r\n\r\n# ALL ENCOUNTER ABILITIES (left path only)\r\n# 8B96 Howl self-targeted cast to summon Anala Familiar or Drake Familiar\r\n# 8B97 Scalding Waves cast and damage for initial fire lines\r\n# 8B98 Scalding Waves damage for bouncing fire lines\r\n# 8B9B Cloud to Ground self-targeted cast for Drake exaflares\r\n# 8B9C Cloud to Ground cast and damage for initial hit of Drake exaflares\r\n# 8B9D Cloud to Ground cast and damage for followup hits of Drake exaflares\r\n\r\n\r\n#~~~~~~~~~~#\r\n# Ketuduke #\r\n#~~~~~~~~~~#\r\n\r\n# -p 8AA5:2014\r\n# -ii 8A78 8AA6 8A7A 8A7B 8A81 8D1D 8AA4 8A89 8A8A 8A82 8A83 8A8C 8D10 8A94 8A98 8A99 8A96\r\n\r\n# Seasong's Rest will be sealed off\r\n#2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"112B\" } window 10000,0\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"112B\" } window 10000,0\r\n2009.0 \"--sync--\" StartsUsing { id: \"8AA5\", source: \"Ketuduke\" }\r\n2014.0 \"Tidal Roar\" Ability { id: \"8AA5\", source: \"Ketuduke\" }\r\n\r\n2023.0 \"Spring Crystals\" Ability { id: \"8A79\", source: \"Ketuduke\" }\r\n2038.0 \"Saturate\" Ability { id: \"8A7C\", source: \"Spring Crystal\" }\r\n\r\n2044.2 \"Spring Crystals\" Ability { id: \"8A79\", source: \"Ketuduke\" }\r\n2059.2 \"Saturate\" Ability { id: \"8A7E\", source: \"Spring Crystal\" }\r\n\r\n2066.4 \"Spring Crystals\" Ability { id: \"8A79\", source: \"Ketuduke\" }\r\n2075.5 \"Bubble Net\" Ability { id: \"8A80\", source: \"Ketuduke\" }\r\n\r\n2087.6 \"Fluke Typhoon (cast)\" Ability { id: \"8A84\", source: \"Ketuduke\" }\r\n2093.6 \"Fluke Typhoon\" Ability { id: \"8A85\", source: \"Ketuduke\" }\r\n2096.7 \"Saturate\" Ability { id: \"8A7F\", source: \"Spring Crystal\" }\r\n\r\n2107.5 \"Strewn Bubbles\" Ability { id: \"8A86\", source: \"Ketuduke\" }\r\n2114.5 \"Sphere Shatter\" Ability { id: \"8A87\", source: \"Ketuduke\" }\r\n\r\n2123.5 \"Receding Twintides/Encroaching Twintides\" Ability { id: [\"8A9D\", \"8A9F\"], source: \"Ketuduke\" }\r\n2127.5 \"Far Tide/Near Tide\" Ability { id: [\"8AA0\", \"8A9E\"], source: \"Ketuduke\" }\r\n\r\n2134.2 \"--middle--\" Ability { id: \"8A77\", source: \"Ketuduke\" }\r\n2137.0 \"--sync--\" StartsUsing { id: \"8D11\", source: \"Ketuduke\" } jump \"ketuduke-02\"\r\n2137.0 \"--sync--\" StartsUsing { id: \"8A92\", source: \"Ketuduke\" } jump \"ketuduke-0304\"\r\n2146.4 \"--sync--\" StartsUsing { id: \"8A79\", source: \"Ketuduke\" } jump \"ketuduke-01\"\r\n\r\n# path 01\r\n2234.2 \"--middle--\" Ability { id: \"8A77\", source: \"Ketuduke\" }\r\n2246.4 label \"ketuduke-01\"\r\n2246.4 \"--sync--\" StartsUsing { id: \"8A79\", source: \"Ketuduke\" }\r\n2248.6 \"Spring Crystals\" Ability { id: \"8A79\", source: \"Ketuduke\" }\r\n2254.3 \"Summon\" Ability { id: \"8A8E\", source: \"Zeal-blind Zozone\" }\r\n2258.7 \"Bubble Net\" Ability { id: \"8A80\", source: \"Ketuduke\" }\r\n2264.7 \"Fluke Typhoon (cast)\" Ability { id: \"8A84\", source: \"Ketuduke\" }\r\n2270.7 \"Fluke Typhoon\" Ability { id: \"8A85\", source: \"Ketuduke\" }\r\n2273.4 \"Water III\" Ability { id: \"8D14\", source: \"Summoned Apa\" }\r\n2273.8 \"Saturate\" Ability { id: \"8A7F\", source: \"Spring Crystal\" }\r\n2291.0 \"Spring Crystals\" Ability { id: \"8A79\", source: \"Ketuduke\" } window 40,40 forcejump \"ketuduke-loop\"\r\n\r\n# path 02\r\n2334.2 \"--sync--\" Ability { id: \"8A77\", source: \"Ketuduke\" }\r\n2337.0 label \"ketuduke-02\"\r\n2337.0 \"--sync--\" StartsUsing { id: \"8D11\", source: \"Ketuduke\" }\r\n2339.2 \"Tidal Wave (cast)\" Ability { id: \"8D11\", source: \"Ketuduke\" }\r\n2346.2 \"Tidal Wave\" Ability { id: \"8D12\", source: \"Ketuduke\" }\r\n2347.3 \"Hydrosurge\" Ability { id: \"8A8B\", source: \"Ketuduke\" }\r\n2363.1 \"Spring Crystals\" Ability { id: \"8A79\", source: \"Ketuduke\" }\r\n2370.1 \"Summon\" Ability { id: \"8A8E\", source: \"Zeal-blind Zozone\" }\r\n2377.2 \"Wavefoam\" Ability { id: \"8D13\", source: \"Summoned Apa\" }\r\n2390.2 \"Fluke Typhoon\" Ability { id: \"8A8F\", source: \"Summoned Anila\" }\r\n2392.0 \"Saturate\" Ability { id: \"8A7F\", source: \"Spring Crystal\" }\r\n2408.2 \"Spring Crystals\" Ability { id: \"8A79\", source: \"Ketuduke\" } window 40,40 forcejump \"ketuduke-loop\"\r\n\r\n# path 03 / path 04\r\n2434.2 \"--sync--\" Ability { id: \"8A77\", source: \"Ketuduke\" }\r\n2437.0 label \"ketuduke-0304\"\r\n2437.0 \"--sync--\" StartsUsing { id: \"8A92\", source: \"Ketuduke\" }\r\n2442.0 \"Roar\" Ability { id: \"8A92\", source: \"Ketuduke\" }\r\n# 2142.7 \"--sync--\" AddedCombatant { name: \"Aloalo Zaratan\" } # path 03\r\n# 2142.7 \"--sync--\" AddedCombatant { name: \"Aloalo Ogrebon\" } # path 04\r\n2454.8 \"Bubble Net\" Ability { id: \"8A93\", source: \"Ketuduke\" }\r\n2465.4 \"Updraft\" Ability { id: \"8D0F\", source: \"Ketuduke\" }\r\n2467.6 \"Hundred Lashings?\" Ability { id: \"8A97\", source: \"Aloalo Zaratan\" } # path 03\r\n2470.5 \"Shock?\" Ability { id: \"8A9A\", source: \"Aloalo Ogrebon\" } # path 04\r\n# this cast is ~+1.5s in path04, but the paths are close enough that we'll just combine them\r\n2476.4 \"Spring Crystals\" Ability { id: \"8A79\", source: \"Ketuduke\" } window 40,40 forcejump \"ketuduke-loop\"\r\n\r\n# final loop (all paths)\r\n2800.0 label \"ketuduke-loop\"\r\n2800.0 \"Spring Crystals\" Ability { id: \"8A79\", source: \"Ketuduke\" }\r\n2810.0 \"Bubble Net\" Ability { id: \"8A80\", source: \"Ketuduke\" }\r\n2816.0 \"Fluke Typhoon (cast)\" Ability { id: \"8A84\", source: \"Ketuduke\" }\r\n2822.0 \"Fluke Typhoon\" Ability { id: \"8A85\", source: \"Ketuduke\" }\r\n2822.8 \"Hydrobomb (cast)\" Ability { id: \"8AA1\", source: \"Ketuduke\" }\r\n#2216.0 \"Saturate\" Ability { id: \"8A7F\", source: \"Spring Crystal\" }\r\n2825.0 \"Saturate\" Ability { id: \"8A7D\", source: \"Spring Crystal\" }\r\n2827.9 \"Hydrobomb 1\" #Ability { id: \"8AA2\", source: \"Ketuduke\" }\r\n2829.9 \"Hydrobomb 2\" #Ability { id: \"8AAffff2\", source: \"Ketuduke\" }\r\n2831.9 \"Hydrobomb 3\" #Ability { id: \"8AA2\", source: \"Ketuduke\" }\r\n\r\n2837.9 \"Blowing Bubbles\" Ability { id: \"8A88\", source: \"Ketuduke\" }\r\n2843.9 \"--middle--\" Ability { id: \"8A77\", source: \"Ketuduke\" }\r\n2851.8 \"Receding Twintides/Encroaching Twintides\" Ability { id: [\"8A9D\", \"8A9F\"], source: \"Ketuduke\" }\r\n2855.8 \"Far Tide/Near Tide\" Ability { id: [\"8AA0\", \"8A9E\"], source: \"Ketuduke\" }\r\n2867.5 \"Tidal Roar\" Ability { id: \"8AA5\", source: \"Ketuduke\" }\r\n\r\n2874.3 \"--middle--\" Ability { id: \"8A77\", source: \"Ketuduke\" }\r\n2879.4 \"Strewn Bubbles\" Ability { id: \"8A86\", source: \"Ketuduke\" }\r\n2886.4 \"Sphere Shatter\" Ability { id: \"8A87\", source: \"Ketuduke\" }\r\n2887.4 \"Receding Twintides/Encroaching Twintides\" Ability { id: [\"8A9D\", \"8A9F\"], source: \"Ketuduke\" }\r\n2891.4 \"Far Tide/Near Tide\" Ability { id: [\"8AA0\", \"8A9E\"], source: \"Ketuduke\" }\r\n2903.1 \"Hydroblast\" Ability { id: \"8AA3\", source: \"Ketuduke\" }\r\n2914.8 \"Tidal Roar\" Ability { id: \"8AA5\", source: \"Ketuduke\" }\r\n\r\n2923.8 \"Spring Crystals\" Ability { id: \"8A79\", source: \"Ketuduke\" } window 40,40 forcejump \"ketuduke-loop\"\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 8A77 --sync-- repositioning\r\n# 8A78 --sync-- auto damage\r\n# 8A79 Spring Crystals self-targeted cast to summon Spring Crystals\r\n# 8A7A 衝撃 self-targeted ability from Spring Crystal orbs\r\n# 8A7B 衝撃 self-targeted ability from Spring Crystal rupees\r\n# 8A7C Saturate cast and damage from Spring Crystal orb circle (no bubbles)\r\n# 8A7D Saturate cast and damage from Spring Crystal orb circle (w/Bubble Net)\r\n# 8A7E Saturate cast and damage from Spring Crystal rupee line laser (no bubbles)\r\n# 8A7F Saturate cast and damage from Spring Crystal rupee line laser (w/Bubble Net)\r\n# 8A80 Bubble Net self-targeted cast before Bubbles along with 8A81\r\n# 8A81 Bubble Net cast and ability on players that adds Bubbles debuffs\r\n# 8A82 Riptide ability on players from Wavefoam/Updraft Airy Bubble when you step in one\r\n# 8A83 Fetters ability on players from Wavefoam/Updraft Airy Bubble when you step in one after 8A82 Riptide\r\n# 8A84 Fluke Typhoon self-targeted cast before 8A85 knockback\r\n# 8A85 Fluke Typhoon cast and knockback ability on Spring Crystal and players\r\n# 8A86 Strewn Bubbles self-targeted cast before 8A87 Sphere Shatter moving arches\r\n# 8A87 Sphere Shatter damage from moving arches\r\n# 8A88 Blowing Bubbles self-targeted cast that adds Airy Bubble Adds\r\n# 8A89 Riptide ability on players from Blowing Bubbles Airy Bubble when you step in one\r\n# 8A8A Fetters ability on players from Blowing Bubbles Airy Bubble when you step in one after 8A89 Riptide\r\n# 8A8B Hydrosurge self-targeted cast to make blue dividing line\r\n# 8A8C Hydrosurge self-targeted cast to make blue divindg line\r\n# 8A8E Summon self-targeted cast from Zeal-blind Zozone to summon Summoned Apa\r\n# 8A8F Fluke Typhoon self-targeted cast from Suummoned Anila to move bubbles across divide\r\n# 8A92 Roar self-targeted cast to summon Zaratan adds to do Hundred Lashings\r\n# 8A93 Bubble Net self-targeted cast before Updraft (either version)\r\n# 8A94 Bubble Net cast and raidwide damage paired with 8A93\r\n# 8A95 Updraft self-targeted cast during Ogrebon Shock\r\n# 8A96 Updraft ability on players during Ogrebon Shock to move them in air if in bubbles\r\n# 8A97 Hundred Lashings cast and damage for Zaratan 180 cleave\r\n# 8A98 Hundred Lashings self-targeted cast for Zaratan 180 cleave\r\n# 8A99 Hundred Lashings self-targeted cast for Zaratan 180 cleave\r\n# 8A9A Shock cast and damage from Ogrebon if not in bubble\r\n# 8A9D Receding Twintides cast and damage for initial out during out->in\r\n# 8A9E Near Tide fast cast and damage for second out during in->out with 8A9F Encroaching Twintides\r\n# 8A9F Encroaching Twintides cast and damage for initial in during in->out\r\n# 8AA0 Far Tide fast cast and damage for second in during out->in with 8A9D Receding Twintides\r\n# 8AA1 Hydrobomb self-targeted cast for 8AA2 puddles\r\n# 8AA2 Hydrobomb cast and damage for 3x puddles\r\n# 8AA3 Hydroblast cast and tankbuster on player (but no damage)\r\n# 8AA4 Hydroblast tankbuster damage\r\n# 8AA5 Tidal Roar self-targeted cast for 8AA6 raidwide\r\n# 8AA6 Tidal Roar raidwide damage\r\n# 8D0F Updraft self-targeted cast to move bubbled Zaratan add into the air (paired with 8D10)\r\n# 8D10 Updraft self-targeted cast to move bubbled Zaratan add into the air (paired with 8D0F)\r\n# 8D11 Tidal Wave self-targeted cast to summon knockback on (non-bubbled) player\r\n# 8D12 Tidal Wave cast and light damage to knockbac player before Hydrosurge\r\n# 8D13 Wavefoam self-targeted cast from Summoned Apa to create bubbles\r\n# 8D14 Water III self-targeted cast for tether from Summoned Apa along with 8D1D\r\n# 8D1D Water III damage from Summoned Apa tether\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~~~~#\r\n# Quaqua (middle path) #\r\n#~~~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 8B94:3013.4\r\n# -ii 8B89 8BA2 8CD1 8B93\r\n\r\n# Elder Stump will be sealed off\r\n#3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1129\" } window 10000,0\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1129\" } window 10000,0\r\n\r\n3007.0 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3008.4 \"--sync--\" StartsUsing { id: \"8B94\", source: \"Quaqua\" } window 10,10\r\n3013.4 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" }\r\n3023.5 \"Arcane Armaments\" Ability { id: \"8B88\", source: \"Quaqua\" }\r\n3025.6 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3028.4 \"Ravaging Axe\" Ability { id: \"8B8A\", source: \"Aetheric Charge\" }\r\n\r\n3032.0 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" }\r\n3042.1 \"Arcane Armaments\" Ability { id: \"8B88\", source: \"Quaqua\" }\r\n3047.0 \"Ringing Quoits\" Ability { id: \"8B8B\", source: \"Aetheric Charge\" }\r\n\r\n3052.3 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3058.4 \"Arcane Armaments\"\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n3053.4 \"--sync--\" StartsUsing { id: \"8B8C\", source: \"Quaqua\" } window 40,40 jump \"quaqua-middle-water\"\r\n3053.4 \"--sync--\" StartsUsing { id: \"8B90\", source: \"Quaqua\" } window 40,40 jump \"quaqua-middle-poison\"\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n3153.4 label \"quaqua-middle-water\"\r\n3153.4 \"--sync--\" StartsUsing { id: \"8B8C\", source: \"Quaqua\" }\r\n3158.4 \"Arcane Armaments\" Ability { id: \"8B8C\", source: \"Quaqua\" }\r\n3168.7 \"Hammer Landing 1\" Ability { id: \"8B8D\", source: \"Quaqua\" }\r\n3170.7 \"Hammer Landing 2\" #Ability { id: \"8B8E\", source: \"Quaqua\" }\r\n3172.7 \"Hammer Landing 3\" #Ability { id: \"8B8E\", source: \"Quaqua\" }\r\n\r\n3180.7 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3187.5 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n3193.6 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3203.0 \"Arcane Armaments\" Ability { id: \"8B9F\", source: \"Quaqua\" }\r\n3210.2 \"Elemental Impact\" Ability { id: \"8BA0\", source: \"Quaqua\" }\r\n3224.3 \"Flowing Lance\" Ability { id: \"8BA1\", source: \"Quaqua\" } duration 12\r\n\r\n3253.1 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3259.2 label \"quaqua-middle-water-loop\"\r\n3259.2 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" }\r\n3269.2 \"Arcane Armaments\" Ability { id: \"8B88\", source: \"Quaqua\" }\r\n3274.1 \"Ringing Quoits\" Ability { id: \"8B8B\", source: \"Aetheric Charge\" }\r\n3274.1 \"Ravaging Axe\" Ability { id: \"8B8A\", source: \"Aetheric Charge\" }\r\n\r\n3279.4 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3288.7 \"Arcane Armaments\" Ability { id: \"8B9F\", source: \"Quaqua\" }\r\n3295.9 \"Elemental Impact\" Ability { id: \"8BA0\", source: \"Quaqua\" }\r\n3310.0 \"Flowing Lance\" Ability { id: \"8BA1\", source: \"Quaqua\" } duration 12\r\n\r\n3329.8 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3336.1 \"Arcane Armaments\" Ability { id: \"8B8C\", source: \"Quaqua\" }\r\n3346.2 \"Hammer Landing 1\" Ability { id: \"8B8D\", source: \"Quaqua\" }\r\n3348.2 \"Hammer Landing 2\" #Ability { id: \"8B8E\", source: \"Quaqua\" }\r\n3350.2 \"Hammer Landing 3\" #Ability { id: \"8B8E\", source: \"Quaqua\" }\r\n\r\n3358.3 \"--sync--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3365.1 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n3371.2 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3377.4 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" } window 40,40 forcejump \"quaqua-middle-water-loop\"\r\n\r\n\r\n3453.4 label \"quaqua-middle-poison\"\r\n3453.4 \"--sync--\" StartsUsing { id: \"8B90\", source: \"Quaqua\" }\r\n3458.4 \"Arcane Armaments\" Ability { id: \"8B90\", source: \"Quaqua\" }\r\n3460.4 \"--jump--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3467.3 \"Rout 1\" Ability { id: \"8B91\", source: \"Quaqua\" }\r\n3469.1 \"Rout 2\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n3470.7 \"Rout 3\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n3472.3 \"Rout 4\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n\r\n3479.5 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3486.3 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n3492.4 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3501.5 \"Arcane Armaments\" Ability { id: \"8BA3\", source: \"Quaqua\" }\r\n\r\n3525.6 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3532.4 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n3538.6 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3544.7 label \"quaqua-middle-poison-loop\"\r\n3544.7 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" }\r\n3554.8 \"Arcane Armaments\" Ability { id: \"8B88\", source: \"Quaqua\" }\r\n3559.7 \"Ringing Quoits\" Ability { id: \"8B8B\", source: \"Aetheric Charge\" }\r\n3559.7 \"Ravaging Axe\" Ability { id: \"8B8A\", source: \"Aetheric Charge\" }\r\n\r\n3565.0 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3574.2 \"Arcane Armaments\" Ability { id: \"8BA3\", source: \"Quaqua\" }\r\n\r\n3590.3 \"--sync--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3596.6 \"Arcane Armaments\" Ability { id: \"8B90\", source: \"Quaqua\" }\r\n3598.6 \"--jump--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3605.4 \"Rout 1\" Ability { id: \"8B91\", source: \"Quaqua\" }\r\n3607.2 \"Rout 2\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n3608.8 \"Rout 3\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n3610.5 \"Rout 4\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n\r\n3617.7 \"--sync--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3624.4 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n3630.6 \"--sync--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n3636.7 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" } window 40,40 forcejump \"quaqua-middle-poison-loop\"\r\n\r\n# ALL ENCOUNTER ABILITIES (middle path only)\r\n# 8B9F Arcane Armaments self-targeted cast before water spear Arcane Armaments\r\n# 8BA0 Elemental Impact cast and damage for initial water spear circles\r\n# 8BA1 Flowing Lance cast and damage for initial water spear cross\r\n# 8BA2 Flowing Lance cast and damage for initial water spear cross\r\n# 8CD1 Flowing Lance short cast and damage for followup rotating water spear crosses\r\n# 8BA3 Arcane Armaments self-targeted cast before poison spear Arcane Armaments\r\n\r\n\r\n#~~~~~~#\r\n# Lala #\r\n#~~~~~~#\r\n\r\n# -p 887F:4016.2\r\n# -ii 8878 8879 8873 8CDD\r\n\r\n# The Origin Spring will be sealed off\r\n#4000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"112C\" } window 10000,0\r\n4000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"112C\" } window 10000,0\r\n4011.2 \"--sync--\" StartsUsing { id: \"887F\", source: \"Lala\" } window 10,10\r\n4016.2 \"Inferno Theorem\" Ability { id: \"887F\", source: \"Lala\" }\r\n\r\n4019.3 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n4027.4 \"Arcane Blight\" Ability { id: [\"886F\", \"8870\", \"8871\", \"8872\"], source: \"Lala\" }\r\n4040.5 \"Arcane Plot\" Ability { id: \"8875\", source: \"Lala\" }\r\n4062.6 \"Inferno Theorem\" Ability { id: \"887F\", source: \"Lala\" }\r\n\r\n4069.7 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n4077.8 \"Arcane Blight\" Ability { id: [\"886F\", \"8870\", \"8871\", \"8872\"], source: \"Lala\" }\r\n4088.9 \"Analysis\" Ability { id: \"887B\", source: \"Lala\" }\r\n4102.7 \"Targeted Light\" Ability { id: \"8CDC\", source: \"Lala\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n4111.0 \"--sync--\" StartsUsing { id: \"8882\", source: \"Lala\" } window 40,40 jump \"lala-05\"\r\n4114.0 \"Faunal Figure?\" #Ability { id: \"8882\", source: \"Lala\" }\r\n\r\n4111.0 \"--sync--\" StartsUsing { id: \"8880\", source: \"Lala\" } window 40,40 jump \"lala-06\"\r\n4114.0 \"Floral Figure?\" #Ability { id: \"8880\", source: \"Lala\" }\r\n\r\n4111.0 \"--sync--\" StartsUsing { id: \"8884\", source: \"Lala\" } window 40,40 jump \"lala-07\"\r\n4114.0 \"Constructive Figure?\" #Ability { id: \"8884\", source: \"Lala\" }\r\n\r\n4111.0 \"--sync--\" StartsUsing { id: \"8D2C\", source: \"Lala\" } window 40,40 jump \"lala-08\"\r\n4114.0 \"Volcanic Coordinates (cast)?\" #Ability { id: \"8D2C\", source: \"Lala\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n4211.0 label \"lala-05\"\r\n4211.0 \"--sync--\" StartsUsing { id: \"8882\", source: \"Lala\" }\r\n4214.0 \"Faunal Figure\" Ability { id: \"8882\", source: \"Lala\" }\r\n4227.3 \"Flail Smash\" Ability { id: \"8883\", source: \"Rodiaki\" }\r\n4235.2 \"Strategic Strike\" Ability { id: \"887E\", source: \"Lala\" }\r\n\r\n4243.4 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n4251.7 label \"lala-05-loop\"\r\n4251.7 \"Arcane Blight\" Ability { id: [\"886F\", \"8870\", \"8871\", \"8872\"], source: \"Lala\" }\r\n4260.8 \"Analysis\" Ability { id: \"887B\", source: \"Lala\" }\r\n4272.5 \"Targeted Light\" Ability { id: \"8CDC\", source: \"Lala\" }\r\n\r\n4283.6 \"Arcane Plot\" Ability { id: \"8876\", source: \"Lala\" }\r\n4299.7 \"Calculated Trajectory\" Ability { id: \"887D\", source: \"Lala\" }\r\n4314.8 \"Inferno Theorem\" Ability { id: \"887F\", source: \"Lala\" }\r\n4324.9 \"Faunal Figure\" Ability { id: \"8882\", source: \"Lala\" }\r\n4332.0 \"Arcane Plot\" Ability { id: \"8875\", source: \"Lala\" }\r\n4350.7 \"Flail Smash\" Ability { id: \"8A6C\", source: \"Rodiaki\" }\r\n4353.1 \"Inferno Theorem\" Ability { id: \"887F\", source: \"Lala\" }\r\n4363.2 \"Strategic Strike\" Ability { id: \"887E\", source: \"Lala\" }\r\n\r\n4371.4 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n4379.7 \"Arcane Blight\" Ability { id: [\"886F\", \"8870\", \"8871\", \"8872\"], source: \"Lala\" } window 40,40 forcejump \"lala-05-loop\"\r\n\r\n\r\n4411.0 label \"lala-06\"\r\n4411.0 \"--sync--\" StartsUsing { id: \"8880\", source: \"Lala\" }\r\n4414.0 \"Floral Figure\" Ability { id: \"8880\", source: \"Lala\" }\r\n4427.8 \"Rolling Spout\" Ability { id: \"8881\", source: \"Kapokapo\" }\r\n4435.2 \"Strategic Strike\" Ability { id: \"887E\", source: \"Lala\" }\r\n\r\n4443.4 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n4451.7 label \"lala-06-loop\"\r\n4451.7 \"Arcane Blight\" Ability { id: [\"886F\", \"8870\", \"8871\", \"8872\"], source: \"Lala\" }\r\n4460.8 \"Analysis\" Ability { id: \"887B\", source: \"Lala\" }\r\n4472.5 \"Targeted Light\" Ability { id: \"8CDC\", source: \"Lala\" }\r\n\r\n4483.6 \"Arcane Plot\" Ability { id: \"8876\", source: \"Lala\" }\r\n4499.7 \"Calculated Trajectory\" Ability { id: \"887D\", source: \"Lala\" }\r\n4514.8 \"Inferno Theorem\" Ability { id: \"887F\", source: \"Lala\" }\r\n4525.0 \"Floral Figure\" Ability { id: \"8880\", source: \"Lala\" }\r\n4532.1 \"Arcane Plot\" Ability { id: \"8875\", source: \"Lala\" }\r\n4553.8 \"Rolling Spout\" Ability { id: \"8A6B\", source: \"Kapokapo\" }\r\n4558.4 \"Inferno Theorem\" Ability { id: \"887F\", source: \"Lala\" }\r\n4568.5 \"Strategic Strike\" Ability { id: \"887E\", source: \"Lala\" }\r\n\r\n4576.7 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n4584.9 \"Arcane Blight\" Ability { id: [\"886F\", \"8870\", \"8871\", \"8872\"], source: \"Lala\" } window 40,40 forcejump \"lala-06-loop\"\r\n\r\n\r\n4611.0 label \"lala-07\"\r\n4611.0 \"--sync--\" StartsUsing { id: \"8884\", source: \"Lala\" }\r\n4614.0 \"Constructive Figure\" Ability { id: \"8884\", source: \"Lala\" }\r\n4629.1 \"Aero II\" Ability { id: \"8885\", source: \"Aloalo Golem\" }\r\n4634.9 \"Strategic Strike\" Ability { id: \"887E\", source: \"Lala\" }\r\n\r\n4643.1 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n4651.3 label \"lala-07-loop\"\r\n4651.3 \"Arcane Blight\" Ability { id: [\"886F\", \"8870\", \"8871\", \"8872\"], source: \"Lala\" }\r\n4660.4 \"Analysis\" Ability { id: \"887B\", source: \"Lala\" }\r\n4672.1 \"Targeted Light\" Ability { id: \"8CDC\", source: \"Lala\" }\r\n\r\n4683.2 \"Arcane Plot\" Ability { id: \"8876\", source: \"Lala\" }\r\n4699.3 \"Calculated Trajectory\" Ability { id: \"887D\", source: \"Lala\" }\r\n4714.4 \"Inferno Theorem\" Ability { id: \"887F\", source: \"Lala\" }\r\n4724.6 \"Constructive Figure\" Ability { id: \"8884\", source: \"Lala\" }\r\n4731.5 \"Arcane Plot\" Ability { id: \"8875\", source: \"Lala\" }\r\n4750.5 \"Aero II\" Ability { id: \"8A6D\", source: \"Aloalo Golem\" }\r\n4752.6 \"Inferno Theorem\" Ability { id: \"887F\", source: \"Lala\" }\r\n4762.7 \"Strategic Strike\" Ability { id: \"887E\", source: \"Lala\" }\r\n\r\n4770.9 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n4779.1 \"Arcane Blight\" Ability { id: [\"886F\", \"8870\", \"8871\", \"8872\"], source: \"Lala\" } window 40,40 forcejump \"lala-07-loop\"\r\n\r\n\r\n4811.0 label \"lala-08\"\r\n4811.0 \"--sync--\" StartsUsing { id: \"8D2C\", source: \"Lala\" }\r\n4814.0 \"Volcanic Coordinates (cast)\" Ability { id: \"8D2C\", source: \"Lala\" }\r\n4824.1 \"Volcanic Coordinates 1\" Ability { id: \"8D2D\", source: \"Lala\" }\r\n4831.1 \"Volcanic Coordinates 2\" Ability { id: \"8D2D\", source: \"Lala\" }\r\n4836.1 \"Strategic Strike\" Ability { id: \"887E\", source: \"Lala\" }\r\n\r\n4844.3 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n4852.4 label \"lala-08-loop\"\r\n4852.4 \"Arcane Blight\" Ability { id: [\"886F\", \"8870\", \"8871\", \"8872\"], source: \"Lala\" }\r\n4861.5 \"Analysis\" Ability { id: \"887B\", source: \"Lala\" }\r\n4873.2 \"Targeted Light\" Ability { id: \"8CDC\", source: \"Lala\" }\r\n\r\n4884.3 \"Arcane Plot\" Ability { id: \"8876\", source: \"Lala\" }\r\n4900.4 \"Calculated Trajectory\" Ability { id: \"887D\", source: \"Lala\" }\r\n4915.5 \"Inferno Theorem\" Ability { id: \"887F\", source: \"Lala\" }\r\n4925.6 \"Volcanic Coordinates (cast)\" Ability { id: \"8D2C\", source: \"Lala\" }\r\n4933.7 \"Arcane Plot\" Ability { id: \"8875\", source: \"Lala\" }\r\n4935.7 \"Volcanic Coordinates 1\" Ability { id: \"8D2D\", source: \"Lala\" }\r\n4942.7 \"Volcanic Coordinates 2\" Ability { id: \"8D2D\", source: \"Lala\" }\r\n4954.9 \"Inferno Theorem\" Ability { id: \"887F\", source: \"Lala\" }\r\n4967.0 \"Strategic Strike\" Ability { id: \"887E\", source: \"Lala\" }\r\n\r\n4975.2 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n4983.5 \"Arcane Blight\" Ability { id: [\"886F\", \"8870\", \"8871\", \"8872\"], source: \"Lala\" } window 40,40 forcejump \"lala-08-loop\"\r\n\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 368 attack auto damage\r\n# 886F Arcane Blight self-targeted cast for right-safe 270 degree cleave\r\n# 8870 Arcane Blight self-targeted cast for left-safe 270 degree cleave\r\n# 8871 Arcane Blight self-targeted cast for back-safe 270 degree cleave\r\n# 8872 Arcane Blight self-targeted cast for front-safe 270 degree cleave\r\n# 8873 Arcane Blight cast and damage for 270 degree cleave\r\n# 8874 --sync-- repositioning\r\n# 8875 Arcane Plot self-targeted cast for \"disconnected safe squares\" blue squares\r\n# 8876 Arcane Plot self-targeted cast for \"one row safe\" blue squares\r\n# 8878 Bright Pulse initial blue square\r\n# 8879 Bright Pulse followup blue square\r\n# 887B Analysis self-targeted cast before giving players unseen debuffs\r\n# 887D Calculated Trajectory self-targeted cast to give players forced march\r\n# 887E Strategic Strike cast and tankbuster damage\r\n# 887F Inferno Theorem cast and raidwide damage\r\n# 8880 Floral Figure self-targeted cast to summon Kapokapo seeds to Rolling Spout\r\n# 8881 Rolling Spout cast and damage for initial Kapokapo donut\r\n# 8882 Faunal Figure self-targeted cast to summon Rodiaki armadillos to Flail Smash\r\n# 8883 Flail Smash cast and proximity damage for Rodiaki center attack\r\n# 8884 Constructive Figure self-targeted cast to summon Golems to cast Aero II\r\n# 8885 Aero II cast and damage for Golem line\r\n# 8A6B Rolling Spout cast and damage for Kapokapo donut during Arcane Plot\r\n# 8A6C Flail Smash cast and proximity damage for Rodiaki side attack during Arcane Plot\r\n# 8A6D Aero II cast and damage for Golem line during Arcane Plot\r\n# 8CDC Targeted Light self-targeted cast for weak spot boss tether\r\n# 8CDD Targeted Light cast and damage on players for 8CDC\r\n# 8D2C Volcanic Coordinates self-targeted cast before 2x 82D2 puddles\r\n# 8D2D Volcanic Coordinates cast and damage for targeted circle puddle\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~~~#\r\n# Quaqua (right path) #\r\n#~~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 8B94:5014.1\r\n# -ii 8B89 8B93\r\n\r\n# Ancient Forum will be sealed off\r\n#5000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"112A\" } window 10000,0\r\n5000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"112A\" } window 10000,0\r\n5007.8 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5009.1 \"--sync--\" StartsUsing { id: \"8B94\", source: \"Quaqua\" } window 10,10\r\n5014.1 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" }\r\n5024.2 \"Arcane Armaments\" Ability { id: \"8B88\", source: \"Quaqua\" }\r\n5026.3 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5029.0 \"Ravaging Axe\" Ability { id: \"8B8A\", source: \"Aetheric Charge\" }\r\n\r\n5032.8 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" }\r\n5042.9 \"Arcane Armaments\" Ability { id: \"8B88\", source: \"Quaqua\" }\r\n5047.8 \"Ringing Quoits\" Ability { id: \"8B8B\", source: \"Aetheric Charge\" }\r\n\r\n5053.1 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5059.3 \"Arcane Armaments\"\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n5054.3 \"--sync--\" StartsUsing { id: \"8B8C\", source: \"Quaqua\" } window 40,40 jump \"quaqua-right-fixed\"\r\n5054.3 \"--sync--\" StartsUsing { id: \"8B90\", source: \"Quaqua\" } window 40,40 jump \"quaqua-right-untouched\"\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n5154.3 label \"quaqua-right-fixed\"\r\n5154.3 \"--sync--\" StartsUsing { id: \"8B8C\", source: \"Quaqua\" }\r\n5159.3 \"Arcane Armaments\" Ability { id: \"8B8C\", source: \"Quaqua\" }\r\n5169.4 \"Hammer Landing 1\" Ability { id: \"8B8D\", source: \"Quaqua\" }\r\n5171.4 \"Hammer Landing 2\" #Ability { id: \"8B8E\", source: \"Quaqua\" }\r\n5173.4 \"Hammer Landing 3\" #Ability { id: \"8B8E\", source: \"Quaqua\" }\r\n\r\n5181.5 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5188.3 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n5194.4 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5200.8 \"Arcane Pursuit\" Ability { id: \"8BA4\", source: \"Quaqua\" }\r\n5214.1 \"--cleanse--\" Ability { id: \"8BAD\" }\r\n5214.9 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5216.8 \"--cleanse--\" Ability { id: \"8BAD\" }\r\n\r\n5221.1 \"Arcane Pursuit\" Ability { id: \"8BA4\", source: \"Quaqua\" }\r\n5237.1 \"--cleanse--\" Ability { id: \"8BA6\" }\r\n5244.1 \"--cleanse--\" Ability { id: \"8BA6\" }\r\n\r\n5248.2 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5254.6 label \"quaqua-right-fixed-loop\"\r\n5254.6 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" }\r\n5264.7 \"Arcane Armaments\" Ability { id: \"8B88\", source: \"Quaqua\" }\r\n5269.6 \"Ringing Quoits\" Ability { id: \"8B8B\", source: \"Aetheric Charge\" }\r\n5269.6 \"Ravaging Axe\" Ability { id: \"8B8A\", source: \"Aetheric Charge\" }\r\n\r\n5274.9 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5281.1 \"Arcane Pursuit\" Ability { id: \"8BA4\", source: \"Quaqua\" }\r\n5297.1 \"--cleanse--\" Ability { id: \"8BA6\" }\r\n5297.2 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5303.3 \"Arcane Armaments\" Ability { id: \"8B8C\", source: \"Quaqua\" }\r\n5304.1 \"--cleanse--\" Ability { id: \"8BA6\" }\r\n\r\n5313.6 \"Hammer Landing 1\" Ability { id: \"8B8D\", source: \"Quaqua\" }\r\n5315.7 \"Hammer Landing 2\" #Ability { id: \"8B8E\", source: \"Quaqua\" }\r\n5317.7 \"Hammer Landing 3\" #Ability { id: \"8B8E\", source: \"Quaqua\" }\r\n\r\n5325.8 \"--sync--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5332.6 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n5338.7 \"--sync--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5345.0 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" } window 40,40 forcejump \"quaqua-right-fixed-loop\"\r\n\r\n\r\n5454.3 label \"quaqua-right-untouched\"\r\n5454.3 \"--sync--\" StartsUsing { id: \"8B90\", source: \"Quaqua\" }\r\n5459.3 \"Arcane Armaments\" Ability { id: \"8B90\", source: \"Quaqua\" }\r\n5461.3 \"--jump--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5468.0 \"Rout 1\" Ability { id: \"8B91\", source: \"Quaqua\" }\r\n5469.7 \"Rout 2\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n5471.3 \"Rout 3\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n5473.1 \"Rout 4\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n\r\n5480.2 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5487.0 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n5504.2 \"Arcane Intervention 1\" Ability { id: \"8BAE\", source: \"Quaqua\" }\r\n5513.2 \"Arcane Intervention 2\" Ability { id: \"8BAE\", source: \"Quaqua\" }\r\n5522.2 \"Arcane Intervention 3\" Ability { id: \"8BAE\", source: \"Quaqua\" }\r\n5525.2 \"Arcane Intervention 4\" Ability { id: \"8BAE\", source: \"Quaqua\" }\r\n\r\n5529.2 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5535.9 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n5542.1 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5548.3 label \"quaqua-right-untouched-loop\"\r\n5548.3 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" }\r\n5558.4 \"Arcane Armaments\" Ability { id: \"8B88\", source: \"Quaqua\" }\r\n5563.3 \"Ringing Quoits\" Ability { id: \"8B8B\", source: \"Aetheric Charge\" }\r\n5563.3 \"Ravaging Axe\" Ability { id: \"8B8A\", source: \"Aetheric Charge\" }\r\n\r\n5575.6 \"Arcane Intervention 1\" Ability { id: \"8BAE\", source: \"Quaqua\" }\r\n5584.6 \"Arcane Intervention 2\" Ability { id: \"8BAE\", source: \"Quaqua\" }\r\n5593.6 \"Arcane Intervention 3\" Ability { id: \"8BAE\", source: \"Quaqua\" }\r\n5596.6 \"Arcane Intervention 4\" Ability { id: \"8BAE\", source: \"Quaqua\" }\r\n\r\n5596.6 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5602.8 \"Arcane Armaments\" Ability { id: \"8B90\", source: \"Quaqua\" }\r\n5604.9 \"--jump--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5611.7 \"Rout 1\" Ability { id: \"8B91\", source: \"Quaqua\" }\r\n5613.5 \"Rout 2\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n5615.1 \"Rout 3\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n5616.7 \"Rout 4\" #Ability { id: \"8B92\", source: \"Quaqua\" }\r\n\r\n5619.8 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5626.5 \"Violet Storm\" Ability { id: \"8B95\", source: \"Quaqua\" }\r\n\r\n5633.6 \"--middle--\" Ability { id: \"8B8F\", source: \"Quaqua\" }\r\n5639.7 \"Made Magic\" Ability { id: \"8B94\", source: \"Quaqua\" } window 40,40 forcejump \"quaqua-right-untouched-loop\"\r\n\r\n# ALL ENCOUNTER ABILITIES (right path only)\r\n# 8BA4 Arcane Pursuit self-targeted cast to summon Aetheric Charge purple orb(s)\r\n# 8BA5 Fell Forces damage from being too close to Aetheric Charge purple orb\r\n# 8BA6 --sync-- cast and ability on Aetheric Charge purple orbs for followup player tethered sets\r\n# 8BAD --sync-- cast and ability on Aetheric Charge purple orbs for initial untethered set\r\n# 8BAE Arcane Intervention cast and lookaway damage (non-zero if failed)\r\n# 8D17 Fell Confluence Aetheric Charge purple orb enrage damage from not cleansing it\r\n\r\n\r\n#~~~~~~~~~#\r\n# Statice #\r\n#~~~~~~~~~#\r\n\r\n# -p 892E:6026.6\r\n# -ii 8A04 8932 892C 8986 8925 8926 8981 8935 89F6 89F7 8CEB 89FB 8941 8942 8943\r\n\r\n# Slumbering Canopy will be sealed off\r\n#6000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"112D\" } window 10000,0\r\n6000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"112D\" } window 10000,0\r\n# Can be triggered by players earlier\r\n6004.0 \"Hidden Mine\" #Ability { id: \"892D\", source: \"Mine\" }\r\n\r\n6022.6 \"--sync--\" StartsUsing { id: \"892E\", source: \"Statice\" } window 30,30\r\n6026.6 \"Surprise Balloon\" Ability { id: \"892E\", source: \"Statice\" }\r\n6034.7 \"Surprise Needle\" Ability { id: \"8930\", source: \"Needle\" }\r\n6035.6 \"Pop\" Ability { id: \"892F\", source: \"Statice\" }\r\n6036.7 \"4-tonze Weight\" Ability { id: \"8931\", source: \"Statice\" }\r\n\r\n6043.9 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n6049.6 \"Trick Reload\" Ability { id: \"892A\", source: \"Statice\" }\r\n6063.5 \"Trigger Happy\" Ability { id: \"892B\", source: \"Statice\" }\r\n6072.6 \"Trick Reload\" Ability { id: \"892A\", source: \"Statice\" }\r\n6086.5 \"Trigger Happy\" Ability { id: \"892B\", source: \"Statice\" }\r\n\r\n6095.6 \"Pinwheel\" Ability { id: \"8933\", source: \"Statice\" }\r\n6107.3 \"Fire Spread\" Ability { id: \"8934\", source: \"Statice\" } duration 10\r\n6116.9 \"Aero IV\" Ability { id: \"8929\", source: \"Statice\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n6124.1 \"--sync--\" StartsUsing { id: \"8945\", source: \"Statice\" } window 40,40 jump \"statice-09\"\r\n6128.1 \"Whoopee Cushion?\" #Ability { id: \"8945\", source: \"Statice\" }\r\n\r\n6124.1 \"--sync--\" StartsUsing { id: \"893E\", source: \"Statice\" } window 40,40 jump \"statice-10\"\r\n6128.1 \"Present Box?\" #Ability { id: \"893E\", source: \"Statice\" }\r\n\r\n6124.1 \"--sync--\" StartsUsing { id: \"8936\", source: \"Statice\" } window 40,40 jump \"statice-11\"\r\n6128.1 \"Jack-in-the-box?\" #Ability { id: \"8936\", source: \"Statice\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n6224.1 label \"statice-09\"\r\n6224.1 \"--sync--\" StartsUsing { id: \"8945\", source: \"Statice\" }\r\n6228.1 \"Whoopee Cushion\" Ability { id: \"8945\", source: \"Statice\" }\r\n6246.2 \"Fair Flight\" Ability { id: \"8946\", source: \"Statice\" }\r\n\r\n6262.5 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n6267.1 \"Dartboard\" Ability { id: \"8938\", source: \"Statice\" }\r\n6275.2 \"Thunderstorm 1\" Ability { id: \"8939\", source: \"Statice\" }\r\n6279.2 \"Thunderstorm 2\" Ability { id: \"8939\", source: \"Statice\" }\r\n6283.2 \"Thunderstorm 3\" Ability { id: \"8939\", source: \"Statice\" }\r\n6300.4 \"Meteor/Sledgemagic/Hunks of Junk/Happy Surprise\" Ability { id: [\"893A\", \"893B\", \"893C\", \"893D\"], source: \"Statice\" }\r\n\r\n6310.5 label \"statice-09-loop\"\r\n6310.5 \"Pinwheel\" Ability { id: \"8933\", source: \"Statice\" }\r\n6313.6 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n6319.2 \"Trick Reload\" Ability { id: \"892A\", source: \"Statice\" }\r\n6330.1 \"Fire Spread\" Ability { id: \"8934\", source: \"Statice\" } duration 10\r\n6333.1 \"Trigger Happy\" Ability { id: \"892B\", source: \"Statice\" }\r\n6343.2 \"Aero IV\" Ability { id: \"8929\", source: \"Statice\" }\r\n\r\n6350.4 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n6355.8 \"Surprise Balloon\" Ability { id: \"892E\", source: \"Statice\" }\r\n6362.9 \"Trick Reload\" Ability { id: \"892A\", source: \"Statice\" }\r\n6374.5 \"Surprise Needle\" Ability { id: \"8930\", source: \"Needle\" }\r\n6375.4 \"Pop\" Ability { id: \"892F\", source: \"Statice\" }\r\n6377.0 \"Trigger Happy\" Ability { id: \"892B\", source: \"Statice\" }\r\n\r\n6388.2 \"Whoopee Cushion\" Ability { id: \"8945\", source: \"Statice\" }\r\n6395.2 \"Shocking Abandon\" Ability { id: \"8928\", source: \"Statice\" }\r\n6406.3 \"Fair Flight\" Ability { id: \"8946\", source: \"Statice\" }\r\n\r\n6419.6 \"Pinwheel\" Ability { id: \"8933\", source: \"Statice\" } window 40,40 forcejump \"statice-09-loop\"\r\n\r\n\r\n6424.1 label \"statice-10\"\r\n6424.1 \"--sync--\" StartsUsing { id: \"893E\", source: \"Statice\" }\r\n6428.1 \"Present Box\" Ability { id: \"893E\", source: \"Statice\" }\r\n6436.8 \"Faerie Ring 1\" Ability { id: \"893F\", source: \"Surprising Staff\" }\r\n6437.4 \"Faerie Road 1\" #Ability { id: \"8940\", source: \"Surprising Staff\" }\r\n6442.5 \"Faerie Ring 2\" Ability { id: \"893F\", source: \"Surprising Staff\" }\r\n6442.9 \"Faerie Road 2\" #Ability { id: \"8940\", source: \"Surprising Staff\" }\r\n6447.9 \"Faerie Ring 3\" Ability { id: \"893F\", source: \"Surprising Staff\" }\r\n6448.1 \"Faerie Road 3\" #Ability { id: \"8940\", source: \"Surprising Staff\" }\r\n\r\n6457.1 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n6461.7 \"Dartboard\" Ability { id: \"8938\", source: \"Statice\" }\r\n6469.8 \"Thunderstorm 1\" Ability { id: \"8939\", source: \"Statice\" }\r\n6473.8 \"Thunderstorm 2\" Ability { id: \"8939\", source: \"Statice\" }\r\n6477.8 \"Thunderstorm 3\" Ability { id: \"8939\", source: \"Statice\" }\r\n6495.0 \"Meteor/Sledgemagic/Hunks of Junk/Happy Surprise\" Ability { id: [\"893A\", \"893B\", \"893C\", \"893D\"], source: \"Statice\" }\r\n\r\n6508.1 label \"statice-10-loop\"\r\n6508.1 \"Pinwheel\" Ability { id: \"8933\", source: \"Statice\" }\r\n6511.2 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n6516.5 \"Trick Reload\" Ability { id: \"892A\", source: \"Statice\" }\r\n6527.5 \"Fire Spread\" Ability { id: \"8934\", source: \"Statice\" }\r\n6530.4 \"Trigger Happy\" Ability { id: \"892B\", source: \"Statice\" }\r\n6540.5 \"Aero IV\" Ability { id: \"8929\", source: \"Statice\" }\r\n\r\n6547.7 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n6553.4 \"Surprise Balloon\" Ability { id: \"892E\", source: \"Statice\" }\r\n6560.5 \"Trick Reload\" Ability { id: \"892A\", source: \"Statice\" }\r\n6572.1 \"Surprise Needle\" Ability { id: \"8930\", source: \"Needle\" }\r\n6573.0 \"Pop\" Ability { id: \"892F\", source: \"Statice\" }\r\n6574.4 \"Trigger Happy\" Ability { id: \"892B\", source: \"Statice\" }\r\n\r\n6585.5 \"Present Box\" Ability { id: \"893E\", source: \"Statice\" }\r\n6594.2 \"Faerie Ring 1\" Ability { id: \"893F\", source: \"Surprising Staff\" }\r\n6594.8 \"Faerie Road 1\" #Ability { id: \"8940\", source: \"Surprising Staff\" }\r\n6599.9 \"Faerie Ring 2\" Ability { id: \"893F\", source: \"Surprising Staff\" }\r\n6600.4 \"Faerie Road 2\" #Ability { id: \"8940\", source: \"Surprising Staff\" }\r\n6601.5 \"Shocking Abandon\" Ability { id: \"8928\", source: \"Statice\" }\r\n6605.5 \"Faerie Ring 3\" Ability { id: \"893F\", source: \"Surprising Staff\" }\r\n6606.0 \"Faerie Road 3\" #Ability { id: \"8940\", source: \"Surprising Staff\" }\r\n\r\n6613.7 \"Pinwheel\" Ability { id: \"8933\", source: \"Statice\" } window 40,40 forcejump \"statice-10-loop\"\r\n\r\n\r\n6624.1 label \"statice-11\"\r\n6624.1 \"--sync--\" StartsUsing { id: \"8936\", source: \"Statice\" }\r\n6628.1 \"Jack-in-the-box\" Ability { id: \"8936\", source: \"Statice\" }\r\n6647.2 \"Burst\" Ability { id: \"8937\", source: \"Treasure Box\" }\r\n\r\n6659.6 \"--sync--\" Ability { id: \"8927\", source: \"Statice\" }\r\n6664.0 \"Dartboard\" Ability { id: \"8938\", source: \"Statice\" }\r\n6672.1 \"Thunderstorm 1\" Ability { id: \"8939\", source: \"Statice\" }\r\n6676.1 \"Thunderstorm 2\" Ability { id: \"8939\", source: \"Statice\" }\r\n6680.1 \"Thunderstorm 3\" Ability { id: \"8939\", source: \"Statice\" }\r\n6697.2 \"Meteor/Sledgemagic/Hunks of Junk/Happy Surprise\" Ability { id: [\"893A\", \"893B\", \"893C\", \"893D\"], source: \"Statice\" }\r\n\r\n6707.3 label \"statice-11-loop\"\r\n6707.3 \"Pinwheel\" Ability { id: \"8933\", source: \"Statice\" }\r\n6710.4 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n6715.7 \"Trick Reload\" Ability { id: \"892A\", source: \"Statice\" }\r\n6726.7 \"Fire Spread\" Ability { id: \"8934\", source: \"Statice\" }\r\n6729.6 \"Trigger Happy\" Ability { id: \"892B\", source: \"Statice\" }\r\n6739.7 \"Aero IV\" Ability { id: \"8929\", source: \"Statice\" }\r\n\r\n6746.9 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n6752.3 \"Surprise Balloon\" Ability { id: \"892E\", source: \"Statice\" }\r\n6759.4 \"Trick Reload\" Ability { id: \"892A\", source: \"Statice\" }\r\n6771.0 \"Surprise Needle\" Ability { id: \"8930\", source: \"Needle\" }\r\n6771.9 \"Pop\" Ability { id: \"892F\", source: \"Statice\" }\r\n6773.5 \"Trigger Happy\" Ability { id: \"892B\", source: \"Statice\" }\r\n\r\n6784.6 \"Jack-in-the-box\" Ability { id: \"8936\", source: \"Statice\" }\r\n6793.7 \"Shocking Abandon\" Ability { id: \"8928\", source: \"Statice\" }\r\n6801.8 \"Burst\" Ability { id: \"8937\", source: \"Treasure Box\" }\r\n\r\n6817.1 \"Pinwheel\" Ability { id: \"8933\", source: \"Statice\" } window 40,40 forcejump \"statice-11-loop\"\r\n\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 8925 Locked and Loaded ability during 892A Trick Reload when a bullet is in the gun\r\n# 8926 Misload ability during 892A Trick Reload when a bullet missed the gun oops\r\n# 8927 --sync-- reposition\r\n# 8928 Shocking Abandon cast and tankbuster damage\r\n# 8929 Aero IV cast and raidwide damage\r\n# 892A Trick Reload self-targeted cast to load gun with 8925/8926\r\n# 892B Trigger Happy self-targeted cast for limit cut dart board\r\n# 892C Trigger Happy cast and damage for limit cut dart board (filled pie slice)\r\n# 892D Hidden Mine damage from stepping on the hidden mine\r\n# 892E Surprise Balloon self-targeted cast to summon Balloon\r\n# 892F Pop knockback from Surprise Balloon being popped\r\n# 8930 Surprise Needle short cast and ability blue line aoe from needle adds that pop balloons\r\n# 8931 4-tonze Weight self-targeted cast for outside circles during Balloon knockback\r\n# 8932 4-tonze Weight cast and damage from Heavy Weight circles during Balloon knockback\r\n# 8933 Pinwheel self-targeted cast to summon Ball of Fire rotating fire bars\r\n# 8934 Fire Spread cast and damage for initial fire bars\r\n# 8935 Fire Spread cast and damage for initial fire bars\r\n# 8936 Jack-in-the-box self-targeted cast to generate 4x Treasure Box\r\n# 8937 Burst fake Treasure Box explosion\r\n# 8938 Dartboard self-targeted cast for colored dartboard\r\n# 8939 Thunderstorm cast and damage from circles during Pinwheel\r\n# 893A Meteor damage and knockback from red Pinwheel slice\r\n# 893B Sledgemagic damage from yellow Pinwheel slice\r\n# 893C Hunks of Junk damage from blue Pinwheel slice\r\n# 893D Happy Surprise full heal from green Pinwheel slice\r\n# 893E Present Box self-targeted cast to summon Surprising Weapon/Staff/Missile\r\n# 893F Faerie Ring cast and damage from Surprising Staff donut attack\r\n# 8940 Faerie Road cast and damage from Surprising Staff line attack\r\n# 8941 Burst damage on players from hitting Present Box's Surprising Missile\r\n# 8942 --sync-- knockback ability on players from Surprising Weapon golem\r\n# 8943 --sync-- knockback ability on players from Surprising Weapon mage\r\n# 8945 Whoopee Cushion self-targeted cast to summon cushions for Fair Flight\r\n# 8946 Fair Flight cast and non-zero damage on players to throw them in the air (89F5 is the damage)\r\n# 8981 Fire Spread self-targeted cast on Ball of Fire for initial fire bars\r\n# 8986 Trigger Happy cast and zero damage for limit cut dart board (empty pie slice)\r\n# 89F5 --sync-- damage from failing Fair Flight\r\n# 89F6 Fire Spread damage for rotating fire bars\r\n# 89F7 Fire Spread damage for rotating fire bars\r\n# 8A04 --sync-- auto damage\r\n# 8CEB Barbed Lightning unknown ability prior to Thunderstorm\r\n\r\n\r\n#~~~~~~~~~~~#\r\n# Loquloqui #\r\n#~~~~~~~~~~~#\r\n\r\n# -p 87BC:7011.8\r\n# -ii 87C1 87C3 8C34 8C35 8D38 8E47\r\n\r\n# Kairimai Loquloqai will be sealed off\r\n#7000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"112E\" } window 10000,0\r\n7000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"11DE\" } window 10000,0\r\n7006.8 \"--sync--\" StartsUsing { id: \"87BC\", source: \"Loquloqui\" } window 10,10\r\n7011.8 \"Long-lost Light\" Ability { id: \"87BC\", source: \"Loquloqui\" }\r\n\r\n7018.0 \"--middle--\" Ability { id: \"87BB\", source: \"Loquloqui\" }\r\n7025.4 \"Summoning Rite\" Ability { id: \"87BF\", source: \"Loquloqui\" }\r\n7033.5 \"O Life, Flourish\" Ability { id: \"87C4\", source: \"Loquloqui\" }\r\n7042.1 \"Rush\" Ability { id: \"87C0\", source: \"Uolosapa Loqua\" }\r\n\r\n7043.7 \"--middle--\" Ability { id: \"87BB\", source: \"Loquloqui\" }\r\n7050.8 \"Summoning Rite\" Ability { id: \"87BF\", source: \"Loquloqui\" }\r\n7058.9 \"O Life, Flourish\" Ability { id: \"87C4\", source: \"Loquloqui\" }\r\n7067.6 \"Turnabout\" Ability { id: \"87C2\", source: \"Repuruba Loqua\" }\r\n7075.2 \"Protective Will\" Ability { id: \"87BE\", source: \"Loquloqui\" }\r\n\r\n7081.3 \"--middle--\" Ability { id: \"87BB\", source: \"Loquloqui\" }\r\n7089.5 \"O Petals, Unfurl\" Ability { id: \"87C5\", source: \"Loquloqui\" }\r\n7108.8 \"--middle--\" Ability { id: \"87BB\", source: \"Loquloqui\" }\r\n7109.9 \"Pliant Petals\" Ability { id: \"87C6\", source: \"Loquloqui\" }\r\n7118.3 \"Land Wave\" Ability { id: \"87BD\", source: \"Loquloqui\" }\r\n\r\n7124.5 \"--middle--\" Ability { id: \"87BB\", source: \"Loquloqui\" }\r\n7132.6 \"O Isle, Bloom\" Ability { id: \"87C7\", source: \"Loquloqui\" }\r\n7144.0 \"Brilliant Blossoms x12\" duration 5 #Ability { id: \"87C8\", source: \"Loquloqui\" }\r\n7156.7 \"Long-lost Light\" Ability { id: \"87BC\", source: \"Loquloqui\" }\r\n\r\n7162.9 \"--middle--\" Ability { id: \"87BB\", source: \"Loquloqui\" }\r\n7171.1 \"O Sky, Be Mine\" Ability { id: \"87C9\", source: \"Loquloqui\" }\r\n7181.2 \"Sanctuary\" Ability { id: \"87CA\", source: \"Loquloqui\" }\r\n\r\n7189.3 \"Stirring of Spirits 1\" Ability { id: \"87CB\", source: \"Loquloqui\" }\r\n7191.7 \"Islebloom Light\" Ability { id: \"87CD\", source: \"Loquloqui\" }\r\n7192.1 \"Shockwave 2\" Ability { id: \"87CC\", source: \"Loquloqui\" }\r\n7194.9 \"Shockwave 3\" Ability { id: \"87CC\", source: \"Loquloqui\" }\r\n7197.2 \"Islebloom Light\" Ability { id: \"87CD\", source: \"Loquloqui\" }\r\n7197.6 \"Shockwave 4\" Ability { id: \"87CC\", source: \"Loquloqui\" }\r\n7200.4 \"Shockwave 5\" Ability { id: \"87CC\", source: \"Loquloqui\" }\r\n7202.6 \"Islebloom Light\" Ability { id: \"87CD\", source: \"Loquloqui\" }\r\n\r\n7206.3 \"--middle--\" Ability { id: \"87BB\", source: \"Loquloqui\" }\r\n7213.5 label \"loquloqui-loop\"\r\n7213.5 \"Summoning Rite\" Ability { id: \"87BF\", source: \"Loquloqui\" }\r\n7221.6 \"O Life, Flourish\" Ability { id: \"87C4\", source: \"Loquloqui\" }\r\n7230.2 \"Turnabout\" Ability { id: \"87C2\", source: \"Repuruba Loqua\" }\r\n7230.2 \"Rush\" Ability { id: \"87C0\", source: \"Uolosapa Loqua\" }\r\n7235.9 \"Protective Will\" Ability { id: \"87BE\", source: \"Loquloqui\" }\r\n\r\n7242.0 \"--middle--\" Ability { id: \"87BB\", source: \"Loquloqui\" }\r\n7250.1 \"O Petals, Unfurl\" Ability { id: \"87C5\", source: \"Loquloqui\" }\r\n7264.5 \"Pliant Petals 1\" Ability { id: \"87C6\", source: \"Loquloqui\" }\r\n7270.4 \"Pliant Petals 2\" Ability { id: \"87C6\", source: \"Loquloqui\" }\r\n7276.3 \"Long-lost Light\" Ability { id: \"87BC\", source: \"Loquloqui\" }\r\n\r\n7282.5 \"--middle--\" Ability { id: \"87BB\", source: \"Loquloqui\" }\r\n7290.8 \"O Isle, Bloom\" Ability { id: \"87C7\", source: \"Loquloqui\" }\r\n7302.2 \"Brilliant Blossoms x12\" duration 5 #Ability { id: \"87C8\", source: \"Loquloqui\" }\r\n7309.2 \"Land Wave\" Ability { id: \"87BD\", source: \"Loquloqui\" }\r\n\r\n7315.3 \"--middle--\" Ability { id: \"87BB\", source: \"Loquloqui\" }\r\n7322.4 \"Summoning Rite\" Ability { id: \"87BF\", source: \"Loquloqui\" } window 40,40 forcejump \"loquloqui-loop\"\r\n\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 1963 attack auto damage\r\n# 87BB --sync-- repositioning\r\n# 87BC Long-lost Light cast and raidwide damage\r\n# 87BD Land Wave cast and 180 cleave damage\r\n# 87BE Protective Will cast and tankbuster damage\r\n# 87BF Summoning Rite self-targeted cast to summon Uolosapa Loqua / Repuruba Loqua\r\n# 87C0 Rush cast and damage from normal bird narrow line\r\n# 87C1 Rush cast and damage from glowing bird wide line\r\n# 87C2 Turnabout cast and damage from normal lizard small circle\r\n# 87C3 Turnabout cast and damage from glowing lizard large circle\r\n# 87C4 O Life, Flourish self-targeted cast to make summoned adds glow and do larger aoes\r\n# 87C5 O Petals, Unfurl self-targeted cast to summon plant tether timebombs\r\n# 87C6 Pliant Petals short cast and damage from 87C5 plant tethers\r\n# 87C7 O Isle, Bloom self-targeted cast to generate twelve flower squares\r\n# 87C8 Brilliant Blossoms damage from flower square exploding\r\n# 87C9 O Sky, Be Mine self-targeted cast to grow\r\n# 87CA Sanctuary unknown cast and zero damage for proximity attack along with 8D38\r\n# 87CB Stirring of Spirits cast and initial knockback damage\r\n# 87CC Shockwave followup 4x knockback damage to 87CB\r\n# 87CD Islebloom Light cast and damage for ground puddles during 87CB\r\n# 8C34 --sync-- unknown self-targeted cast for 87C5 plant tether\r\n# 8C35 --sync-- unknown self-targeted cast for 87C5 plant tether\r\n# 8D38 Sanctuary cast and proximity damage\r\n# 8E47 --sync-- unknown ability when fight ends\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/alzadaals_legacy.ts




const tentacleFlags = ['00080004', '00200004', '00800004', '02000004'];

// flags are reused between both tentacles, but the final spot where the tentacle lands
// is different for the cyan & scarlet tentacles
const cyanTentacleLocations = {
  '00080004': 'S',
  '00200004': 'W',
  '00800004': 'N',
  '02000004': 'E'
};
const scarletTentacleLocations = {
  '00080004': 'NW',
  '00200004': 'NE',
  '00800004': 'SE',
  '02000004': 'SW'
};
const alzadaals_legacy_triggerSet = {
  id: 'AlzadaalsLegacy',
  zoneId: zone_id/* default.AlzadaalsLegacy */.Z.AlzadaalsLegacy,
  timelineFile: 'alzadaals_legacy.txt',
  initData: () => {
    return {
      tentacleEffects: []
    };
  },
  triggers: [{
    id: 'Alzadaal Big Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '6F60',
      source: 'Ambujam',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'Alzadaal Tentacle Dig Collect',
    type: 'MapEffect',
    netRegex: {
      flags: tentacleFlags
    },
    run: (data, matches) => data.tentacleEffects.push(matches)
  }, {
    id: 'Alzadaal Tentacle Dig Single',
    type: 'Ability',
    netRegex: {
      id: '6F55',
      source: 'Ambujam',
      capture: false
    },
    delaySeconds: 2.3,
    infoText: (data, _matches, output) => {
      // only one tentacle (scarlet) for the first use of Tentacle Dig
      if (data.tentacleEffects.length !== 1) return output.default();
      const safeMap = {
        NW: 'SE',
        NE: 'SW',
        SE: 'NW',
        SW: 'NE'
      };
      const tentacleFlag = data.tentacleEffects[0]?.flags;
      if (tentacleFlag === undefined) return output.default();
      const tentacleLocation = scarletTentacleLocations[tentacleFlag];
      if (tentacleLocation === undefined) return output.default();
      const safeDir = safeMap[tentacleLocation];
      if (safeDir === undefined) return output.default();
      return output.safe({
        dir1: output[safeDir]()
      });
    },
    run: data => data.tentacleEffects = [],
    outputStrings: {
      NW: outputs/* default.dirNW */.Z.dirNW,
      NE: outputs/* default.dirNE */.Z.dirNE,
      SE: outputs/* default.dirSE */.Z.dirSE,
      SW: outputs/* default.dirSW */.Z.dirSW,
      safe: {
        en: 'Go ${dir1}',
        de: 'Geh nach ${dir1}',
        fr: 'Allez ${dir1}',
        ja: '${dir1}へ',
        cn: '去 ${dir1}',
        ko: '${dir1}쪽으로'
      },
      default: {
        en: 'Avoid tentacle explosions',
        de: 'Weiche Tentakel-Explosion aus',
        fr: 'Évitez les explostions des tentacules',
        ja: '触手の爆発から離れる',
        cn: '躲避触手爆炸',
        ko: '문어다리가 멈춘 곳 멀리 피하기'
      }
    }
  }, {
    id: 'Alzadaal Tentacle Dig Multiple',
    type: 'Ability',
    netRegex: {
      id: '6F59',
      source: 'Ambujam',
      capture: false
    },
    delaySeconds: 2.3,
    infoText: (data, _matches, output) => {
      // both tentacles for 2nd and all subsequent uses of Tentacle Dig
      if (data.tentacleEffects.length !== 2) return output.default();

      // cyan tentacle ends on cardinal, and scarlet tentacle ends on intercard opposite cyan
      // safe wedge runs from the cardinal adjacent to through the unoccupied intercard opposite of the cyan tentacle
      const safeMap = {
        // Cyan location: {possible Scarlet locations: [safe dirs]}
        N: {
          SE: ['W', 'SW'],
          SW: ['E', 'SE']
        },
        E: {
          NW: ['S', 'SW'],
          SW: ['N', 'NW']
        },
        S: {
          NW: ['E', 'NE'],
          NE: ['W', 'NW']
        },
        W: {
          NE: ['S', 'SE'],
          SE: ['N', 'NE']
        }
      };
      let cyanLoc = undefined;
      let scarletLoc = undefined;
      // location 10 = cyan tentacle path, location 11 = scarlet tentacle path
      for (const tentacle of data.tentacleEffects) {
        if (tentacle.location === '10') {
          if (cyanTentacleLocations[tentacle.flags] !== undefined) cyanLoc = cyanTentacleLocations[tentacle.flags];
        } else if (tentacle.location === '11') {
          if (scarletTentacleLocations[tentacle.flags] !== undefined) scarletLoc = scarletTentacleLocations[tentacle.flags];
        }
      }
      if (cyanLoc === undefined || scarletLoc === undefined) return output.default();
      const safeArray = safeMap[cyanLoc][scarletLoc];
      if (safeArray === undefined) return output.default();
      const [safe0, safe1] = safeArray;
      return output.safe({
        dir1: output[safe0](),
        dir2: output[safe1]()
      });
    },
    run: data => data.tentacleEffects = [],
    outputStrings: {
      N: outputs/* default.dirN */.Z.dirN,
      E: outputs/* default.dirE */.Z.dirE,
      S: outputs/* default.dirS */.Z.dirS,
      W: outputs/* default.dirW */.Z.dirW,
      NW: outputs/* default.dirNW */.Z.dirNW,
      NE: outputs/* default.dirNE */.Z.dirNE,
      SE: outputs/* default.dirSE */.Z.dirSE,
      SW: outputs/* default.dirSW */.Z.dirSW,
      safe: {
        en: 'Go ${dir1} / ${dir2}',
        de: 'Geh nach ${dir1} / ${dir2}',
        fr: 'Allez ${dir1} / ${dir2}',
        ja: '${dir1}/${dir2}へ',
        cn: '去 ${dir1} / ${dir2}',
        ko: '${dir1}/${dir2}쪽으로'
      },
      default: {
        en: 'Avoid tentacle explosions',
        de: 'Weiche Tentakel-Explosion aus',
        fr: 'Évitez les explostions des tentacules',
        ja: '触手の爆発から離れる',
        cn: '躲避触手爆炸',
        ko: '문어다리가 멈춘 곳 멀리 피하기'
      }
    }
  }, {
    id: 'Alzadaal Fountain',
    type: 'StartsUsing',
    netRegex: {
      id: '731A',
      source: 'Ambujam',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge 3 to 1',
        de: 'Weiche von 3 auf 1 aus',
        fr: 'Esquivez de 3 vers 1',
        ja: '3から1へ',
        cn: '3穿1躲避',
        ko: '3번째에서 1번째로'
      }
    }
  }, {
    id: 'Alzadaal Diffusion Ray',
    type: 'StartsUsing',
    netRegex: {
      id: '6F1E',
      source: 'Armored Chariot',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Alzadaal Rail Cannon',
    type: 'StartsUsing',
    netRegex: {
      id: '6F1F',
      source: 'Armored Chariot'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Alzadaal Articulated Bits',
    type: 'StartsUsing',
    netRegex: {
      id: '6F19',
      source: 'Armored Chariot',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid bit lasers',
        de: 'Weiche Drohnen-Laser aus',
        fr: 'Évitez les lasers',
        ja: 'レーザー回避',
        cn: '躲避浮游炮激光',
        ko: '비트가 쏘는 레이저 피하기'
      }
    }
  }, {
    id: 'Alzadaal Graviton Cannon',
    type: 'StartsUsing',
    netRegex: {
      id: '7373',
      source: 'Armored Chariot'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 4,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Alzadaal Billowing Bolts',
    type: 'StartsUsing',
    netRegex: {
      id: '6F70',
      source: 'Kapikulu',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Alzadaal Spin Out',
    type: 'StartsUsing',
    netRegex: {
      id: '6F63',
      source: 'Kapikulu',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Steer away from spikes',
        de: 'Weg von den Stacheln lenken',
        fr: 'Ne tournez pas dans les pics',
        ja: 'スパイクのないマスへ移動',
        cn: '躲避针刺',
        ko: '가시 피하기'
      }
    }
  }, {
    id: 'Alzadaal Power Serge',
    type: 'StartsUsing',
    netRegex: {
      id: '6F6A',
      source: 'Kapikulu',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid tethered color',
        de: 'Weiche der verbundenen Farbe aus',
        fr: 'Allez sous la couleur non liée',
        ja: '逆の色へ',
        cn: '躲避连线颜色',
        ko: '보스가 연결한 색의 기둥 피하기'
      }
    }
  }, {
    id: 'Alzadaal Magnitude Opus',
    type: 'HeadMarker',
    netRegex: {
      id: '00A1'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Alzadaal Rotary Gale',
    type: 'HeadMarker',
    netRegex: {
      id: '0060'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Alzadaal Crewel Slice',
    type: 'StartsUsing',
    netRegex: {
      id: '6F72',
      source: 'Kapikulu'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceSync': {
      'Corrosive Venom/Toxic Shower': 'Venom/Shower',
      'Corrosive Fountain/Toxic Fountain': 'Fountain',
      'Magnitude Opus/Rotary Gale': 'Opus/Gale'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Ambujam': 'Ambujam',
      'Armored Chariot': 'gepanzert(?:e|er|es|en) Chariot',
      'Armored Drudge': 'gepanzert(?:e|er|es|en) Sklave',
      'Kapikulu': 'Kapikulu',
      'Scarlet Tentacle': 'Scharlachtentakel',
      'The Threshold Of Bounty': 'Schwelle zum Reichtum',
      'The Undersea Entrance': 'Versunkene Pforte',
      'Weaver\'S Warding': 'Webers Wehr'
    },
    'replaceText': {
      'Articulated Bits': 'Satellitenarme',
      'Assail': 'Anstürmen',
      'Assault Cannon': 'Sturmkanone',
      'Basting Blade': 'Kaschmirklinge',
      'Big Wave': 'Gigantische Welle',
      'Billowing Bolts': 'Bauschende Ballen',
      'Corrosive Fountain': 'Ätzender Geysir',
      'Corrosive Venom': 'Ätzendes Gift',
      'Crewel Slice': 'Seidenschnitt',
      'Diffusion Ray': 'Diffusionsstrahl',
      'Graviton Cannon': 'Gravitonkanone',
      'Magnitude Opus': 'Magnitude Opus',
      'Mana Explosion': 'Mana-Explosion',
      'Power Serge': 'Vervliesung',
      'Rail Cannon': 'Magnetschienenkanone',
      'Rotary Gale': 'Spinnsturm',
      'Spin Out': 'Spinner',
      'Tentacle Dig': 'Tentakelgraber',
      'Toxin Shower': 'Giftsprüher',
      'Wild Weave': 'Wildes Weben'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ambujam': 'Ambujam',
      'Armored Chariot': 'char cuirassé',
      'Armored Drudge': 'esclave cuirassé',
      'Kapikulu': 'Kapikulu',
      'Scarlet Tentacle': 'tentacule pourpre',
      'The Threshold Of Bounty': 'Chambre de l\'Abondance',
      'The Undersea Entrance': 'Hall dévasté',
      'Weaver\'S Warding': 'Chambre scellée du tisserand'
    },
    'replaceText': {
      'Articulated Bits': 'Main autonome',
      'Assail': 'Ordre de couverture',
      'Assault Cannon': 'Canon d\'assaut',
      'Basting Blade': 'Lame rayonnante',
      'Big Wave': 'Lame de fond',
      'Billowing Bolts': 'Diffraction textile',
      'Corrosive Fountain': 'Jet d\'acide',
      'Corrosive Venom': 'Acidochorie',
      'Crewel Slice': 'Lame dansante',
      'Diffusion Ray': 'Rayon diffuseur',
      'Graviton Cannon': 'Canon gravitationnel',
      'Magnitude Opus': 'Craquement terrestre',
      'Mana Explosion': 'Explosion de mana',
      'Power Serge': 'Étoffes chargées',
      'Rail Cannon': 'Canon électrique',
      'Rotary Gale': 'Bourrasque tranchante',
      'Spin Out': 'Toupie mortelle',
      'Tentacle Dig': 'Tentacule enfoui',
      'Toxin Shower': 'Vénénochorie',
      'Wild Weave': 'Étoffes virevoltantes'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ambujam': 'アムブジャ',
      'Armored Chariot': 'アーマード・チャリオット',
      'Armored Drudge': 'アーマード・スレイヴ',
      'Kapikulu': 'カプクル',
      'Scarlet Tentacle': '紅の触手',
      'The Threshold Of Bounty': '豊穣の間',
      'The Undersea Entrance': '崩れかけた広間',
      'Weaver\'S Warding': '封宝の間'
    },
    'replaceText': {
      'Articulated Bits': 'ハンドビット',
      'Assail': '攻撃指示',
      'Assault Cannon': 'アサルトカノン',
      'Basting Blade': '人形剣閃',
      'Big Wave': 'ビッグウェーブ',
      'Billowing Bolts': '魔布法陣',
      'Corrosive Fountain': '酸液噴出',
      'Corrosive Venom': '酸液散布',
      'Crewel Slice': '人形剣技',
      'Diffusion Ray': 'ディフュージョンレイ',
      'Graviton Cannon': 'グラビトンキャノン',
      'Magnitude Opus': '崩土',
      'Mana Explosion': '魔力爆発',
      'Power Serge': '魔布入精',
      'Rail Cannon': 'レールキャノン',
      'Rotary Gale': '刻風',
      'Spin Out': '四方八方帯回し',
      'Tentacle Dig': '触手潜行',
      'Toxin Shower': '毒液散布',
      'Wild Weave': '魔布散開'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ambujam': '阿卜迦',
      'Armored Chariot': '装甲战车',
      'Armored Drudge': '装甲仆从',
      'Kapikulu': '门奴',
      'Scarlet Tentacle': '猩红触手',
      'The Threshold Of Bounty': '丰饶之间',
      'The Undersea Entrance': '塌陷的大厅',
      'Weaver\'S Warding': '封宝之间'
    },
    'replaceText': {
      'Articulated Bits': '手型浮游炮',
      'Assail': '攻击指示',
      'Assault Cannon': '突击加农炮',
      'Basting Blade': '人偶剑闪',
      'Big Wave': '大水波',
      'Billowing Bolts': '魔布法阵',
      'Corrosive Fountain': '喷出酸液',
      'Corrosive Venom': '泼洒酸液',
      'Crewel Slice': '人偶剑技',
      'Diffusion Ray': '扩散射线',
      'Graviton Cannon': '重力加农炮',
      'Magnitude Opus': '崩土',
      'Mana Explosion': '魔力爆炸',
      'Power Serge': '魔布附魔',
      'Rail Cannon': '轨道炮',
      'Rotary Gale': '刻风',
      'Spin Out': '缠绕抽转',
      'Tentacle Dig': '触手潜行',
      'Toxin Shower': '泼洒毒液',
      'Wild Weave': '魔布散开'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ambujam': '암부잠',
      'Armored Chariot': '무장 전차',
      'Armored Drudge': '무장 노예',
      'Kapikulu': '카프쿨루',
      'Scarlet Tentacle': '붉은 촉수',
      'The Threshold Of Bounty': '풍요의 방',
      'The Undersea Entrance': '무너진 방',
      'Weaver\'S Warding': '봉인된 보물의 방'
    },
    'replaceText': {
      'Articulated Bits': '핸드 비트',
      'Assail': '공격 지시',
      'Assault Cannon': '맹공포',
      'Basting Blade': '인형 대검',
      'Big Wave': '큰 파도',
      'Billowing Bolts': '마력천 법진',
      'Corrosive Fountain': '산액 분출',
      'Corrosive Venom': '산성액 뿌리기',
      'Crewel Slice': '인형 검기',
      'Diffusion Ray': '확산 광선',
      'Graviton Cannon': '중력자포',
      'Magnitude Opus': '붕토',
      'Mana Explosion': '마력 폭발',
      'Power Serge': '마력천 주입',
      'Rail Cannon': '전자기포',
      'Rotary Gale': '각풍',
      'Spin Out': '사방팔방 팽이돌리기',
      'Tentacle Dig': '촉수 잠행',
      'Toxin Shower': '독액 뿌리기',
      'Toxic Fountain': '독액 분출',
      'Wild Weave': '마력천 산개'
    }
  }]
};
/* harmony default export */ const alzadaals_legacy = (alzadaals_legacy_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/alzadaals_legacy.txt
const dungeon_alzadaals_legacy_namespaceObject = "# Alzadaal's Legacy\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~#\r\n# ABUJAM #\r\n#~~~~~~~~#\r\n\r\n# -ii 71E5\r\n\r\n# Undersea Entrance will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"103E\" } window 0,1\r\n11.0 \"Big Wave\" Ability { id: \"6F60\", source: \"Ambujam\" } window 11,5\r\n20.8 \"Tentacle Dig\" Ability { id: \"6F55\", source: \"Ambujam\" } window 20.8,10\r\n33.0 \"--sync--\" Ability { id: \"6F5B\", source: \"Scarlet Tentacle\" }\r\n33.4 \"Toxin Shower\" Ability { id: \"6F5C\", source: \"Ambujam\" }\r\n39.2 \"--sync--\" Ability { id: \"6F56\", source: \"Ambujam\" } window 39.2,10\r\n\r\n47.6 \"Tentacle Dig\" Ability { id: \"6F59\", source: \"Ambujam\" }\r\n59.8 \"--sync--\" Ability { id: \"6F5B\", source: \"Scarlet Tentacle\" }\r\n60.2 \"Corrosive Venom/Toxin Shower\" Ability { id: [\"6F5C\", \"71E6\"], source: \"Ambujam\" }\r\n66.0 \"--sync--\" Ability { id: \"6F5A\", source: \"Ambujam\" } window 66,20\r\n76.3 \"Corrosive Fountain/Toxic Fountain 1\" Ability { id: [\"731A\", \"731B\", \"7374\"], source: \"Ambujam\" }\r\n79.3 \"Corrosive Fountain/Toxic Fountain 2\" Ability { id: [\"731A\", \"731B\", \"7374\"], source: \"Ambujam\" }\r\n80.6 \"Corrosive Fountain/Toxic Fountain 3\" Ability { id: [\"731A\", \"731B\", \"7374\"], source: \"Ambujam\" }\r\n104.4 \"Big Wave\" Ability { id: \"6F60\", source: \"Ambujam\" }\r\n\r\n113.8 \"Tentacle Dig\" Ability { id: \"6F59\", source: \"Ambujam\" } window 30,30 jump 47.6\r\n126.4 \"Corrosive Venom/Toxin Shower\"\r\n142.5 \"Corrosive Fountain/Toxic Fountain 1\"\r\n145.5 \"Corrosive Fountain/Toxic Fountain 2\"\r\n146.8 \"Corrosive Fountain/Toxic Fountain 3\"\r\n170.6 \"Big Wave\"\r\n\r\n\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~#\r\n# ARMORED CHARIOT #\r\n#~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 71CC 6F1A 6F1C 6F1D 6F26 6F27\r\n\r\n# The Threshold of Bounty will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"103F\" } window 1000,1\r\n1011.0 \"Articulated Bits\" Ability { id: \"6F19\", source: \"Armored Chariot\" } window 1011,0\r\n1013.2 \"Assail\" Ability { id: \"6F29\", source: \"Armored Chariot\" }\r\n1015.3 \"--sync--\" Ability { id: [\"6F20\", \"6F21\"], source: \"Armored Chariot\" }\r\n1021.9 \"Assault Cannon\" Ability { id: \"6F1B\", source: \"Armored Drudge\" } duration 5\r\n1026.4 \"--sync--\" Ability { id: \"6F22\", source: \"Armored Chariot\" }\r\n1030.0 \"Assault Cannon\" Ability { id: \"6F1B\", source: \"Armored Drudge\" } duration 5\r\n\r\n# No Rail Cannon first time through the block.\r\n1036.3 \"--sync--\" Ability { id: [\"6F24\", \"6F25\"], source: \"Armored Chariot\" }\r\n1047.4 \"Diffusion Ray\" Ability { id: \"6F1E\", source: \"Armored Chariot\" }\r\n1056.6 \"Articulated Bits\" Ability { id: \"6F19\", source: \"Armored Chariot\" }\r\n1058.8 \"Assail\" Ability { id: \"6F28\", source: \"Armored Chariot\" }\r\n1060.9 \"--sync--\" Ability { id: [\"6F20\", \"6F21\"], source: \"Armored Chariot\" }\r\n1067.5 \"Assault Cannon\" Ability { id: \"6F1B\", source: \"Armored Drudge\" } duration 5\r\n1073.9 \"--sync--\" Ability { id: [\"6F24\", \"6F25\"], source: \"Armored Chariot\" }\r\n1083.2 \"Articulated Bits\" Ability { id: \"6F19\", source: \"Armored Chariot\" }\r\n1085.4 \"Assail\" Ability { id: \"6F29\", source: \"Armored Chariot\" }\r\n1087.5 \"--sync--\" Ability { id: [\"6F20\", \"6F21\"], source: \"Armored Chariot\" }\r\n1094.1 \"Assault Cannon\" Ability { id: \"6F1B\", source: \"Armored Drudge\" } duration 5\r\n1098.7 \"--sync--\" Ability { id: \"6F23\", source: \"Armored Chariot\" }\r\n1102.3 \"Assault Cannon\" Ability { id: \"6F1B\", source: \"Armored Drudge\" } duration 5\r\n1104.8 \"Graviton Cannon\" Ability { id: \"7373\", source: \"Armored Chariot\" }\r\n1108.6 \"--sync--\" Ability { id: [\"6F24\", \"6F25\"], source: \"Armored Chariot\" }\r\n1117.8 \"Articulated Bits\" Ability { id: \"6F19\", source: \"Armored Chariot\" }\r\n1120.0 \"Assail\" Ability { id: \"6F28\", source: \"Armored Chariot\" }\r\n1122.1 \"--sync--\" Ability { id: [\"6F20\", \"6F21\"], source: \"Armored Chariot\" }\r\n1128.7 \"Assault Cannon\" Ability { id: \"6F1B\", source: \"Armored Drudge\" } duration 5\r\n\r\n1135.0 \"--sync--\" Ability { id: [\"6F24\", \"6F25\"], source: \"Armored Chariot\" }\r\n1145.1 \"Diffusion Ray\" Ability { id: \"6F1E\", source: \"Armored Chariot\" }\r\n1155.2 \"Rail Cannon\" Ability { id: \"6F1F\", source: \"Armored Chariot\" }\r\n1168.4 \"Articulated Bits\" Ability { id: \"6F19\", source: \"Armored Chariot\" }\r\n1170.6 \"Assail\" Ability { id: \"6F28\", source: \"Armored Chariot\" }\r\n1172.7 \"--sync--\" Ability { id: [\"6F20\", \"6F21\"], source: \"Armored Chariot\" }\r\n1179.4 \"Assault Cannon\" Ability { id: \"6F1B\", source: \"Armored Drudge\" } duration 5\r\n1185.7 \"--sync--\" Ability { id: [\"6F24\", \"6F25\"], source: \"Armored Chariot\" }\r\n1194.9 \"Articulated Bits\" Ability { id: \"6F19\", source: \"Armored Chariot\" }\r\n1197.1 \"Assail\" Ability { id: \"6F29\", source: \"Armored Chariot\" }\r\n1199.2 \"--sync--\" Ability { id: [\"6F20\", \"6F21\"], source: \"Armored Chariot\" }\r\n1205.8 \"Assault Cannon\" Ability { id: \"6F1B\", source: \"Armored Drudge\" } duration 5\r\n1210.4 \"--sync--\" Ability { id: \"6F22\", source: \"Armored Chariot\" }\r\n1213.9 \"Assault Cannon\" Ability { id: \"6F1B\", source: \"Armored Drudge\" } duration 5\r\n1216.6 \"Graviton Cannon\" Ability { id: \"7373\", source: \"Armored Chariot\" }\r\n1220.1 \"--sync--\" Ability { id: [\"6F24\", \"6F25\"], source: \"Armored Chariot\" }\r\n1229.3 \"Articulated Bits\" Ability { id: \"6F19\", source: \"Armored Chariot\" }\r\n1231.5 \"Assail\" Ability { id: \"6F28\", source: \"Armored Chariot\" }\r\n1233.6 \"--sync--\" Ability { id: [\"6F20\", \"6F21\"], source: \"Armored Chariot\" }\r\n1240.2 \"Assault Cannon\" Ability { id: \"6F1B\", source: \"Armored Drudge\" } duration 5\r\n\r\n1246.5 \"--sync--\" Ability { id: [\"6F24\", \"6F25\"], source: \"Armored Chariot\" } window 10,10 jump 2135\r\n1256.6 \"Diffusion Ray\" Ability { id: \"6F1E\", source: \"Armored Chariot\" }\r\n1266.7 \"Rail Cannon\" Ability { id: \"6F1F\", source: \"Armored Chariot\" }\r\n1280.0 \"Articulated Bits\" Ability { id: \"6F19\", source: \"Armored Chariot\" }\r\n1282.2 \"Assail\" Ability { id: \"6F28\", source: \"Armored Chariot\" }\r\n1284.3 \"--sync--\" Ability { id: [\"6F20\", \"6F21\"], source: \"Armored Chariot\" }\r\n\r\n#~~~~~~~~~~#\r\n# KAPIKULU #\r\n#~~~~~~~~~~#\r\n\r\n# -ii 6F71 6F64 6F65 6F66 6F67 6F6D 6F6F\r\n\r\n# Weaver's Warding will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1040\" } window 2000,1\r\n2015.2 \"Billowing Bolts\" Ability { id: \"6F70\", source: \"Kapikulu\" } window 2016,5\r\n2023.4 \"--sync--\" Ability { id: \"6F62\", source: \"Kapikulu\" }\r\n2027.8 \"Spin Out\" Ability { id: \"6F63\", source: \"Kapikulu\" }\r\n2044.1 \"--sync--\" Ability { id: \"6F62\", source: \"Kapikulu\" }\r\n2054.3 \"Crewel Slice\" Ability { id: \"6F72\", source: \"Kapikulu\" }\r\n2061.4 \"Billowing Bolts\" Ability { id: \"6F70\", source: \"Kapikulu\" }\r\n2069.6 \"--sync--\" Ability { id: \"6F62\", source: \"Kapikulu\" }\r\n2074.7 \"Wild Weave\" Ability { id: \"6F69\", source: \"Kapikulu\" }\r\n2084.5 \"Power Serge\" Ability { id: \"6F6A\", source: \"Kapikulu\" }\r\n2088.8 \"Mana Explosion\" Ability { id: \"6F6B\", source: \"Kapikulu\" }\r\n2099.6 \"Magnitude Opus/Rotary Gale\" Ability { id: [\"6F6C\", \"6F6E\"], source: \"Kapikulu\" }\r\n2108.8 \"--sync--\" Ability { id: \"6F62\", source: \"Kapikulu\" }\r\n2112.8 \"Spin Out\" Ability { id: \"6F63\", source: \"Kapikulu\" }\r\n2120.5 \"--sync--\" Ability { id: \"6F62\", source: \"Kapikulu\" }\r\n2127.9 \"Basting Blade\" Ability { id: \"6F68\", source: \"Kapikulu\" }\r\n2131.5 \"--sync--\" Ability { id: \"6F62\", source: \"Kapikulu\" }\r\n2138.8 \"Basting Blade\" Ability { id: \"6F68\", source: \"Kapikulu\" }\r\n2140.9 \"--sync--\" Ability { id: \"6F62\", source: \"Kapikulu\" }\r\n\r\n2151.1 \"Crewel Slice\" Ability { id: \"6F72\", source: \"Kapikulu\" }\r\n2158.2 \"Billowing Bolts\" Ability { id: \"6F70\", source: \"Kapikulu\" }\r\n2166.4 \"--sync--\" Ability { id: \"6F62\", source: \"Kapikulu\" }\r\n2171.5 \"Wild Weave\" Ability { id: \"6F69\", source: \"Kapikulu\" }\r\n2181.1 \"Power Serge\" Ability { id: \"6F6A\", source: \"Kapikulu\" }\r\n2185.4 \"Mana Explosion\" Ability { id: \"6F6B\", source: \"Kapikulu\" }\r\n2188.2 \"Magnitude Opus/Rotary Gale\" Ability { id: [\"6F6C\", \"6F6E\"], source: \"Kapikulu\" }\r\n\r\n2199.4 \"Crewel Slice\" Ability { id: \"6F72\", source: \"Kapikulu\" } jump 2151.1\r\n2206.5 \"Billowing Bolts\" Ability { id: \"6F70\", source: \"Kapikulu\" }\r\n2216.7 \"--sync--\" Ability { id: \"6F62\", source: \"Kapikulu\" }\r\n2221.8 \"Wild Weave\" Ability { id: \"6F69\", source: \"Kapikulu\" }\r\n2231.7 \"Power Serge\" Ability { id: \"6F6A\", source: \"Kapikulu\" }\r\n2236.0 \"Mana Explosion\" Ability { id: \"6F6B\", source: \"Kapikulu\" }\r\n2238.8 \"Magnitude Opus/Rotary Gale\" Ability { id: [\"6F6C\", \"6F6E\"], source: \"Kapikulu\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/another_aloalo_island-savage.ts
// This file was autogenerated from running npm run sync-files.
// DO NOT EDIT THIS FILE DIRECTLY.
// Edit the source file below and then run `npm run sync-files`
// Source: ui/raidboss/data/06-ew/dungeon/another_aloalo_island.ts






// TODO: add callout for Monk Hydroshot target
// TODO: sc3 should say which bubble to take to the other side (for everyone)
// TODO: figure out directions for Lala for Radiance orbs
// TODO: map effects for Lala
// TODO: Lala Planar Tactics could add config strats and tell you who to stack with
// TODO: Statice colors could add config strats for role-based colors + melee flex
// Horizontal crystals have a heading of 0, vertical crystals are -pi/2.
const isHorizontalCrystal = line => {
  const epsilon = 0.1;
  return Math.abs(parseFloat(line.heading)) < epsilon;
};
const headmarkerIds = {
  tethers: '0061',
  enumeration: '015B'
};

// TODO: this maybe should be a method on party?
const isStandardLightParty = data => {
  const supports = [...data.party.healerNames, ...data.party.tankNames];
  const dps = data.party.dpsNames;
  return supports.length === 2 && dps.length === 2;
};
const another_aloalo_island_savage_triggerSet = {
  id: 'AnotherAloaloIslandSavage',
  zoneId: zone_id/* default.AnotherAloaloIslandSavage */.Z.AnotherAloaloIslandSavage,
  timelineFile: 'another_aloalo_island-savage.txt',
  initData: () => {
    return {
      combatantData: [],
      ketuSpringCrystalCount: 0,
      ketuCrystalAdd: [],
      ketuHydroBuffCount: 0,
      ketuBuffCollect: [],
      ketuStackTargets: [],
      lalaSubAlpha: [],
      staticeBullet: [],
      staticeTrapshooting: [],
      staticeDart: [],
      staticePresentBoxCount: 0,
      staticeMissileCollect: [],
      staticeMissileIdToDir: {},
      staticeMissileTether: [],
      staticeClawTether: [],
      staticeDartboardTether: []
    };
  },
  timelineTriggers: [{
    id: 'AAIS Lala Radiance',
    regex: /^Radiance \d/,
    beforeSeconds: 4,
    alertText: (data, _matches, output) => {
      // TODO: could figure out directions here and say "Point left at NW Orb"
      const dir = data.lalaUnseen;
      if (dir === undefined) return output.orbGeneral();
      return {
        front: output.orbDirFront(),
        back: output.orbDirBack(),
        left: output.orbDirLeft(),
        right: output.orbDirRight()
      }[dir];
    },
    outputStrings: {
      orbDirFront: {
        en: 'Face Towards Orb',
        de: 'Den Orb anschauen',
        fr: 'Pointez l\'orbe',
        cn: '面向球',
        ko: '구슬쪽 보기'
      },
      orbDirBack: {
        en: 'Face Away from Orb',
        de: 'Weg vom Orb schauen',
        fr: 'Ne pointez pas l\'orbe',
        cn: '背对球',
        ko: '뒷면을 구슬쪽으로'
      },
      orbDirLeft: {
        en: 'Point Left at Orb',
        de: 'Zeige links auf den Orb',
        fr: 'Pointez à gauche de l\'orbe',
        cn: '左侧看向球',
        ko: '왼쪽면을 구슬쪽으로'
      },
      orbDirRight: {
        en: 'Point Right at Orb',
        de: 'Zeige Rechts auf den Orb',
        fr: 'Pointez à droite de l\'orbe',
        cn: '右侧看向球',
        ko: '오른쪽면을 구슬쪽으로'
      },
      orbGeneral: {
        en: 'Point opening at Orb',
        de: 'Zeige die Öffnung auf den Orb',
        fr: 'Pointez l\'orbe',
        cn: '开口侧看向球',
        ko: '열린면을 수슬쪽으로'
      }
    }
  }],
  triggers: [
  // ---------------- first trash ----------------
  {
    id: 'AAIS Kiwakin Lead Hook',
    type: 'StartsUsing',
    netRegex: {
      id: '8BC7',
      source: 'Aloalo Kiwakin'
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankBusterOnYou: {
          en: '3x Tankbuster on YOU',
          de: '3x Tankbuster auf DIR',
          fr: 'Tankbuster x3 sur VOUS',
          cn: '3x 坦克死刑点名',
          ko: '3x 탱버 대상자'
        },
        tankBusterOnPlayer: {
          en: '3x Tankbuster on ${player}',
          de: '3x Tankbuster auf ${player}',
          fr: 'Tankbuster x3 sur ${player}',
          cn: '3x 坦克死刑点 ${player}',
          ko: '3x 탱버 ${player}'
        }
      };
      if (matches.target === data.me) return {
        alertText: output.tankBusterOnYou()
      };
      const target = data.party.member(matches.target);
      return {
        infoText: output.tankBusterOnPlayer({
          player: target
        })
      };
    }
  }, {
    id: 'AAIS Kiwakin Sharp Strike',
    type: 'StartsUsing',
    netRegex: {
      id: '8BC8',
      source: 'Aloalo Kiwakin'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AAIS Kiwakin Tail Screw',
    type: 'StartsUsing',
    // This is a baited targeted circle.
    netRegex: {
      id: '8BC9',
      source: 'Aloalo Kiwakin',
      capture: false
    },
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'AAIS Snipper Water III',
    type: 'StartsUsing',
    netRegex: {
      id: '8BCC',
      source: 'Aloalo Snipper'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'AAIS Snipper Bubble Shower',
    type: 'StartsUsing',
    netRegex: {
      id: '8BCA',
      source: 'Aloalo Snipper',
      capture: false
    },
    response: responses/* Responses.getBackThenFront */.n3.getBackThenFront()
  }, {
    id: 'AAIS Snipper Crab Dribble',
    type: 'Ability',
    // Crab Dribble 8BCB has a fast cast, so trigger on Bubble Shower ability
    netRegex: {
      id: '8BCA',
      source: 'Aloalo Snipper',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.goFront */.n3.goFront('info')
  }, {
    id: 'AAIS Ray Hydrocannon',
    type: 'StartsUsing',
    netRegex: {
      id: '8C4B',
      source: 'Aloalo Ray',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'AAIS Ray Expulsion',
    type: 'StartsUsing',
    netRegex: {
      id: '8BCE',
      source: 'Aloalo Ray',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'AAIS Ray Electric Whorl',
    type: 'StartsUsing',
    netRegex: {
      id: '8BCD',
      source: 'Aloalo Ray',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'AAIS Monk Hydroshot',
    type: 'StartsUsing',
    netRegex: {
      id: '8BD1',
      source: 'Aloalo Monk'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.knockbackOn */.n3.knockbackOn()
  }, {
    id: 'AAIS Monk Cross Attack',
    type: 'StartsUsing',
    netRegex: {
      id: '8C4F',
      source: 'Aloalo Monk'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  },
  // ---------------- Ketuduke ----------------
  {
    id: 'AAIS Ketuduke Tidal Roar',
    type: 'StartsUsing',
    netRegex: {
      id: '8AD4',
      source: 'Ketuduke',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'AAIS Ketuduke Spring Crystals',
    type: 'StartsUsing',
    netRegex: {
      id: '8AA8',
      source: 'Ketuduke',
      capture: false
    },
    run: data => {
      data.ketuSpringCrystalCount++;
      // Note: cannot clear `data.ketuCrystalAdd` here as there has been at least one case
      // where AddCombatant (coming from memory, so racy) is partially before this cast.
    }
  }, {
    id: 'AAIS Ketuduke Spring Crystals Saturate Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: ['8ADB', '8ADC'],
      capture: false
    },
    run: data => data.ketuCrystalAdd = []
  }, {
    id: 'AAIS Ketuduke Spring Crystal Collect',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '12607'
    },
    run: (data, matches) => data.ketuCrystalAdd.push(matches)
  }, {
    id: 'AAIS Ketuduke Bubble Net',
    type: 'StartsUsing',
    netRegex: {
      id: ['8AC5', '8AAD'],
      source: 'Ketuduke',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'AAIS Ketuduke Foamy Fetters Bubble Weave',
    type: 'GainsEffect',
    // ECC = Foamy Fetters
    // E9F = Bubble Weave
    netRegex: {
      effectId: ['ECC', 'E9F']
    },
    delaySeconds: (data, matches) => {
      data.ketuBuffCollect.push(matches);
      return data.ketuBuffCollect.length === 4 ? 0 : 0.5;
    },
    alertText: (data, _matches, output) => {
      if (data.ketuBuffCollect.length === 0) return;
      const myBuff = data.ketuBuffCollect.find(x => x.target === data.me)?.effectId;
      if (myBuff === undefined) return;
      data.ketuBuff = myBuff === 'ECC' ? 'fetters' : 'bubble';
      data.ketuBuffPartner = data.ketuBuffCollect.find(x => {
        return x.target !== data.me && x.effectId === myBuff;
      })?.target;
      const player = data.party.member(data.ketuBuffPartner);

      // To avoid too many calls, we'll call this out later for the Fluke Gale
      // versions of this.
      if (data.ketuSpringCrystalCount === 1 || data.ketuSpringCrystalCount === 4) return;
      if (data.ketuBuff === 'fetters') return output.fetters({
        player: player
      });
      return output.bubble({
        player: player
      });
    },
    run: data => data.ketuBuffCollect = [],
    outputStrings: {
      fetters: {
        en: 'Fetters (w/${player})',
        de: 'Fesseln (mit ${player})',
        fr: 'Entraves (avec ${player})',
        cn: '止步 (和 ${player})',
        ko: '속박 (+ ${player})'
      },
      bubble: {
        en: 'Bubble (w/${player})',
        de: 'Blase (mit ${player})',
        fr: 'Bulles (avec ${player})',
        cn: '泡泡 (和 ${player})',
        ko: '거품 (+ ${player})'
      }
    }
  }, {
    id: 'AAIS Ketuduke Hydro Buff Counter',
    type: 'StartsUsing',
    // 8AB8 = Hydrobullet (spread)
    // 8AB4 = Hydrofall (stack)
    netRegex: {
      id: ['8AB8', '8AB4'],
      source: 'Ketuduke',
      capture: false
    },
    run: data => {
      data.ketuHydroBuffCount++;
      delete data.ketuHydroBuffIsSpreadFirst;
      delete data.ketuHydroBuffIsRoleStacks;
    }
  }, {
    id: 'AAIS Ketuduke Hydro Buff 1',
    comment: {
      en: `These directions assume that you always pick a square in the same
             quadrant as the crystal specified.
             For brevity, "next to" always means horizontal east/west of something.
             See trigger source for diagrams in comments.`,
      de: `Diese Anweisungen gehen davon aus, dass Sie immer ein Quadrat im gleichen
             Quadranten wie der angegebene Kristall liegt.
             Der Einfachheit halber bedeutet "neben" immer horizontal östlich/westlich von etwas.
             Siehe Triggerquelle für Diagramme in den Kommentaren.`,
      fr: `Ces instructions supposent que vous choisissez toujours une case dans le même
             quadrant que le cristal spécifié.
             Par souci de concision, "à côté de" signifie toujours horizontal
             à l'est ou à l'ouest de quelque chose.
             Voir le déclencheur source pour les diagrammes dans les commentaires.`,
      cn: `这些方向假设你一直选的是同一面向的四块地板方格上的水晶。
             简洁起见，"相邻" 指的是左右水平相邻的某一个水晶。
             请参阅触发器源代码注释中的图表。`,
      ko: `이곳의 방향 지시는 항상 지정된 수정과 같은 사분면에 있는 정사각형을 선택한다고 가정합니다.
             간결성을 위해, '옆'은 항상 무언가의 동쪽/서쪽을 의미합니다.
             트리거 소스코드에 주석으로 작성된 다이어그램을 참고하세요.`
    },
    type: 'StartsUsing',
    netRegex: {
      id: ['8AB8', '8AB4'],
      source: 'Ketuduke'
    },
    condition: data => data.ketuHydroBuffCount === 1 || data.ketuHydroBuffCount === 6,
    durationSeconds: 10,
    alertText: (data, matches, output) => {
      if (data.ketuBuff === undefined) return;
      const isPlayerDPS = data.party.isDPS(data.me);
      const isPartnerDPS = data.ketuBuffPartner !== undefined ? data.party.isDPS(data.ketuBuffPartner) : undefined;
      const isBubbleNetPartnerSameRole = isPlayerDPS === isPartnerDPS && isStandardLightParty(data);

      // Simplify callout in vast majority of cases where there's a normal light party setup
      // and you and the two dps and two supports get the same debuff, so no need to list
      // your partner.
      //
      // Otherwise, if you're doing this nonstandard for some reason or somebody is dead
      // you can know if you need to flex.
      const isSpread = matches.id === '8AB8';
      const bubbleStr = data.ketuBuff === 'bubble' ? output.bubbleBuff() : output.fettersBuff();
      // We don't know about role stacks at this point, as this is just the initial cast bar.
      const stackStr = isSpread ? output.spread() : output.stacks();
      if (isBubbleNetPartnerSameRole || data.ketuBuffPartner === undefined) return output.bubbleNetMech({
        fettersBubble: bubbleStr,
        spreadStack: stackStr
      });
      return output.bubbleNetMechPartner({
        fettersBubble: bubbleStr,
        spreadStack: stackStr,
        player: data.party.member(data.ketuBuffPartner)
      });
    },
    infoText: (data, matches, output) => {
      // If somebody died and missed a debuff, good luck.
      if (data.ketuBuff === undefined) return;

      // Bubble always does the same thing.
      if (data.ketuBuff === 'bubble') return output.bubbleAnything();

      // Two layouts, one with each crystal in its own column ("split")
      // and one with two columns that have an H and a V in that same column ("columns").
      // Wind doesn't matter, as "1" will always be on the horizontal crystals.
      // These can be flipped somewhat, but the solution is always the same.
      // Horizontal crystals are always in lc1 wind, and vertical crystals are always
      // in lc2 wind. Players with bubbles always go either (1) adjacent to a horizontal
      // crystal OR (2) diagonal of a vertical crystal. Either one works, but it
      // depends on how you split your priorities / wind which one you'd take.
      //
      // Legend: V = vertical crystal, H = horizontal crystal
      //         1 = limit cut wind 1, 2 = limit cut wind 2
      //         f = fetters, b = bubble (if placed in lc1)
      //
      // STACK FETTERS COLUMNS (kitty to horizontal)
      //     2                   2
      //   + - - - - +         + - - - - +
      //   | V     f | 1       |     H f | 1
      //   |     H b |    =>   |     V   |
      //   | H b     |         | V       |
      // 1 |   f V   |       1 | H f     |
      //   + - - - - +         + - - - - +
      //           2                   2
      //
      // STACK FETTERS SPLIT (on horizontal)
      //           2                   2
      //   + - - - - +         + - - - - +
      // 1 |     V   |       1 |   V     |
      //   | H b     |    =>   | f H     |
      //   |   V     |         |     V   |
      //   |     b H | 1       |     H f | 1
      //   + - - - - +         + - - - - +
      //     2                   2
      //
      // SPREAD FETTERS COLUMNS (adjacent to vertical)
      //     2                   2
      //   + - - - - +         + - - - - +
      //   | V f     | 1       |   f H b | 1
      //   |     H b |    =>   |     V   |
      //   | H b     |         | V       |
      // 1 |     V f |       1 | H b   f |
      //   + - - - - +         + - - - - +
      //           2                   2
      //
      // SPREAD FETTERS SPLIT (kitty to vertical)
      //     2                   2
      //   + - - - - +         + - - - - +
      //   |   V     | 1       |     V   | 1
      //   | f   b H |    =>   | f   H b |
      //   |     V   |         |   V     |
      // 1 | H b   f |       1 | b H   f |
      //   + - - - - +         + - - - - +
      //           2                   2

      const isSpread = matches.id === '8AB8';
      const horizontal = data.ketuCrystalAdd.filter(x => isHorizontalCrystal(x));
      const vertical = data.ketuCrystalAdd.filter(x => !isHorizontalCrystal(x));
      const [firstHorizontal] = horizontal;
      if (horizontal.length !== 2 || vertical.length !== 2 || firstHorizontal === undefined) return;
      const firstHorizX = parseFloat(firstHorizontal.x);
      // It's split if no vertical is in the same column as either horizontal.
      const isSplitLayout = vertical.find(line => Math.abs(parseFloat(line.x) - firstHorizX) < 1) === undefined;
      if (isSpread) return isSplitLayout ? output.fettersSpreadSplit() : output.fettersSpreadColumn();
      return isSplitLayout ? output.fettersStackSplit() : output.fettersStackColumn();
    },
    outputStrings: {
      bubbleNetMech: {
        en: '${fettersBubble} + ${spreadStack}',
        de: '${fettersBubble} + ${spreadStack}',
        fr: '${fettersBubble} + ${spreadStack}',
        cn: '${fettersBubble} + ${spreadStack}',
        ko: '${fettersBubble} + ${spreadStack}'
      },
      bubbleNetMechPartner: {
        en: '${fettersBubble} + ${spreadStack} (w/${player})',
        de: '${fettersBubble} + ${spreadStack} (mit ${player})',
        fr: '${fettersBubble} + ${spreadStack} (avec ${player})',
        cn: '${fettersBubble} + ${spreadStack} (和 ${player})',
        ko: '${fettersBubble} + ${spreadStack} (+ ${player})'
      },
      bubbleBuff: {
        en: 'Bubble',
        de: 'Blase',
        fr: 'Bulle',
        cn: '泡泡',
        ko: '거품'
      },
      fettersBuff: {
        en: 'Fetters',
        de: 'Ketten',
        fr: 'Entraves',
        cn: '止步',
        ko: '속박'
      },
      spread: outputs/* default.spread */.Z.spread,
      stacks: {
        en: 'Stacks',
        de: 'Sammeln',
        fr: 'Package',
        cn: '分摊',
        ko: '쉐어'
      },
      bubbleAnything: {
        en: 'Diagonal of Vertical / Next to Horizontal ',
        de: 'Diagonale der Vertikalen / Neben Horizontal',
        fr: 'Diagonale de la verticale / À côté de l\'horizontale',
        cn: '竖水晶对角线 / 左右相邻的横水晶',
        ko: '세로 수정의 대각선 / 가로 수정의 옆'
      },
      fettersSpreadSplit: {
        en: 'Diagonal of Vertical',
        de: 'Diagonale der Vertikalen',
        fr: 'Diagonale de la verticale',
        cn: '竖水晶对角线',
        ko: '세로 수정의 대각선'
      },
      fettersSpreadColumn: {
        en: 'Next to Vertical',
        de: 'Neben Vertikal',
        fr: 'À côté de la verticale',
        cn: '左右相邻的竖水晶',
        ko: '가로 수정의 옆'
      },
      fettersStackSplit: {
        en: 'On Horizontal',
        de: 'Auf Horizontal',
        fr: 'Sur l\'horizontale',
        cn: '横水晶上',
        ko: '가로 수정이 있는 곳'
      },
      fettersStackColumn: {
        en: 'Diagonal of Horizontal',
        de: 'Diagonale der Horizontalen',
        fr: 'Diagonale de l\'horizontale',
        cn: '横水晶对角线',
        ko: '가로 수정의 대각선'
      }
    }
  }, {
    id: 'AAIS Ketuduke Hydro Buff Double',
    type: 'StartsUsing',
    netRegex: {
      id: ['8AB8', '8AB4'],
      source: 'Ketuduke'
    },
    condition: data => data.ketuHydroBuffCount === 2 || data.ketuHydroBuffCount === 5,
    alertText: (data, matches, output) => {
      data.ketuHydroBuffIsSpreadFirst = matches.id === '8AB8';
      return data.ketuHydroBuffIsSpreadFirst ? output.spread() : output.stacks();
    },
    outputStrings: {
      spread: {
        en: 'Spread => Stacks',
        de: 'Verteilen => Sammeln',
        fr: 'Écarté => Package',
        cn: '分散 => 分摊',
        ko: '산개 => 쉐어'
      },
      stacks: {
        en: 'Stacks => Spread',
        de: 'Sammeln => Verteilen',
        fr: 'Package => Écarté',
        cn: '分摊 => 分散',
        ko: '쉐어 => 산개'
      }
    }
  }, {
    id: 'AAIS Ketuduke Hydro Buff Double Followup',
    type: 'Ability',
    netRegex: {
      id: ['8ADF', '8ADE'],
      source: 'Ketuduke'
    },
    suppressSeconds: 10,
    infoText: (data, matches, output) => {
      const wasSpread = matches.id === '8ADF';
      if (wasSpread && data.ketuHydroBuffIsSpreadFirst === true) {
        if (data.ketuHydroBuffIsRoleStacks) return output.roleStacks();
        return output.stacks();
      } else if (!wasSpread && data.ketuHydroBuffIsSpreadFirst === false) {
        return output.spread();
      }
    },
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread,
      stacks: {
        en: 'Stacks',
        de: 'Sammeln',
        fr: 'Package',
        cn: '分摊',
        ko: '쉐어'
      },
      roleStacks: {
        en: 'Role Stacks',
        de: 'Rollengruppe sammeln',
        fr: 'Package par rôle',
        cn: '职能分摊',
        ko: '역할별 쉐어'
      }
    }
  }, {
    id: 'AAIS Ketuduke Hydrofall Role Stack Warning',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'EA3'
    },
    delaySeconds: (data, matches) => {
      data.ketuStackTargets.push(matches.target);
      return data.ketuStackTargets.length === 2 ? 0 : 0.5;
    },
    alarmText: (data, _matches, output) => {
      const [stack1, stack2] = data.ketuStackTargets;
      if (data.ketuStackTargets.length !== 2 || stack1 === undefined || stack2 === undefined) return;

      // Sorry, non-standard light party comps.
      if (!isStandardLightParty(data)) return;
      const isStack1DPS = data.party.isDPS(stack1);
      const isStack2DPS = data.party.isDPS(stack2);

      // If both stacks are on dps or neither stack is on a dps, then you have
      // standard "partner" stacks of one support and one dps. If one is on a dps
      // and one is on a support (which can happen if somebody dies), then
      // you (probably) need to have role stacks.
      if (isStack1DPS === isStack2DPS) return;
      data.ketuHydroBuffIsRoleStacks = true;

      // Handle Blowing Bubbles/Angry Seas spread+stack combo.
      if (data.ketuHydroBuffIsSpreadFirst === true) return output.spreadThenRoleStacks();else if (data.ketuHydroBuffIsSpreadFirst === false) return output.roleStacksThenSpread();
      return output.roleStacks();
    },
    run: data => data.ketuStackTargets = [],
    outputStrings: {
      roleStacks: {
        en: 'Role Stacks',
        de: 'Rollengruppe sammeln',
        fr: 'Package par rôle',
        cn: '职能分摊',
        ko: '역할별 쉐어'
      },
      spreadThenRoleStacks: {
        en: 'Spread => Role Stacks',
        de: 'Verteilen => Rollengruppe sammeln',
        fr: 'Écarté => Package par rôle',
        cn: '分散 => 职能分摊',
        ko: '산개 => 역할별 쉐어'
      },
      roleStacksThenSpread: {
        en: 'Role Stacks => Spread',
        de: 'Rollengruppe sammeln => Verteilen',
        fr: 'Package par rôle => Écarté',
        cn: '职能分摊 => 分散',
        ko: '역할별 쉐어 => 산개'
      }
    }
  }, {
    id: 'AAIS Ketuduke Receding Twintides',
    type: 'StartsUsing',
    netRegex: {
      id: '8AE7',
      source: 'Ketuduke',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.ketuHydroBuffIsRoleStacks) return output.outInRoleStacks();
      return output.outInStacks();
    },
    run: data => data.ketuTwintidesNext = 'in',
    outputStrings: {
      outInStacks: {
        en: 'Out => In + Stacks',
        de: 'Raus => Rein + sammeln',
        fr: 'Extérieur => Intérieur + Package',
        cn: '远离 => 靠近 + 分摊',
        ko: '밖 => 안 + 쉐어'
      },
      outInRoleStacks: {
        en: 'Out => In + Role Stacks',
        de: 'Raus => Rein + Rollengruppe sammeln',
        fr: 'Extérieur => Intérieur + Package par rôle',
        cn: '远离 => 靠近 + 职能分摊',
        ko: '밖 => 안 + 역할별 쉐어'
      }
    }
  }, {
    id: 'AAIS Ketuduke Encroaching Twintides',
    type: 'StartsUsing',
    netRegex: {
      id: '8AE9',
      source: 'Ketuduke',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.ketuHydroBuffIsRoleStacks) return output.inOutRoleStacks();
      return output.inOutStacks();
    },
    run: data => data.ketuTwintidesNext = 'out',
    outputStrings: {
      inOutStacks: {
        en: 'In => Out + Stacks',
        de: 'Rein => Raus + sammeln',
        fr: 'Intérieur => Extérieur + Package',
        cn: '靠近 => 远离 + 分摊',
        ko: '안 => 밖 + 쉐어'
      },
      inOutRoleStacks: {
        en: 'In => Out + Role Stacks',
        de: 'Rein => Raus + Rollengruppe sammeln',
        fr: 'Intérieur => Extérieur + Package par rôle',
        cn: '靠近 => 远离 + 职能分摊',
        ko: '안 => 밖 + 역할별 쉐어'
      }
    }
  }, {
    id: 'AAIS Ketuduke Twintides Followup',
    type: 'Ability',
    // 8AE0 = Sphere Shatter, which happens slightly after the Twintides hit.
    // You can technically start moving along the safe Sphere Shatter side 0.5s earlier
    // after the initial out/in, but this is hard to explain.
    netRegex: {
      id: '8AE0',
      source: 'Ketuduke',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      const mech = data.ketuTwintidesNext;
      if (mech === undefined) return;
      const mechStr = output[mech]();
      const stackStr = data.ketuHydroBuffIsRoleStacks ? output.roleStacks() : output.stack();
      return output.text({
        inOut: mechStr,
        stack: stackStr
      });
    },
    run: data => delete data.ketuTwintidesNext,
    outputStrings: {
      text: {
        en: '${inOut} + ${stack}',
        de: '${inOut} + ${stack}',
        fr: '${inOut} + ${stack}',
        cn: '${inOut} + ${stack}',
        ko: '${inOut} + ${stack}'
      },
      in: outputs/* default.in */.Z["in"],
      out: outputs/* default.out */.Z.out,
      stack: {
        en: 'Stacks',
        de: 'Sammeln',
        fr: 'Package',
        cn: '分摊',
        ko: '쉐어'
      },
      roleStacks: {
        en: 'Role Stacks',
        de: 'Rollengruppe sammeln',
        fr: 'Package par rôle',
        cn: '职能分摊',
        ko: '역할별 쉐어'
      }
    }
  }, {
    id: 'AAIS Ketuduke Spring Crystals 2',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '12607',
      capture: false
    },
    condition: data => data.ketuSpringCrystalCount === 2 && data.ketuCrystalAdd.length === 4,
    // We could call this absurdly early, but knowing this doesn't help with anything
    // until you know what your debuff is, so move it later both so it is less absurd
    // futuresight and so you don't have to remember it as long.
    delaySeconds: 5,
    alertText: (data, _matches, output) => {
      const horizontal = data.ketuCrystalAdd.filter(x => isHorizontalCrystal(x));
      const vertical = data.ketuCrystalAdd.filter(x => !isHorizontalCrystal(x));
      if (horizontal.length !== 2 || vertical.length !== 2) return;

      // Crystal positions are always -15, -5, 5, 15.

      // Check if any verticals are on the outer vertical edges.
      for (const line of vertical) {
        const y = parseFloat(line.y);
        if (y < -10 || y > 10) return output.eastWestSafe();
      }

      // Check if any horizontals are on the outer horizontal edges.
      for (const line of horizontal) {
        const x = parseFloat(line.x);
        if (x < -10 || x > 10) return output.northSouthSafe();
      }
      return output.cornersSafe();
    },
    outputStrings: {
      northSouthSafe: {
        en: 'North/South',
        de: 'Norden/Süden',
        fr: 'Nord/Sud',
        cn: '上(北)/下(南)',
        ko: '북/남'
      },
      eastWestSafe: {
        en: 'East/West',
        de: 'Osten/Westen',
        fr: 'Est/Ouest',
        cn: '左(西)/右(东)',
        ko: '동/서'
      },
      cornersSafe: {
        en: 'Corners',
        de: 'Ecken',
        fr: 'Coins',
        cn: '四角',
        ko: '구석'
      }
    }
  }, {
    id: 'AAIS Ketuduke Angry Seas',
    type: 'StartsUsing',
    netRegex: {
      id: '8AE1',
      source: 'Ketuduke',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.ketuHydroBuffIsSpreadFirst) return output.knockbackSpread();
      if (data.ketuHydroBuffIsRoleStacks) return output.knockbackRoleStacks();
      return output.knockbackStacks();
    },
    outputStrings: {
      knockbackSpread: {
        en: 'Knockback => Spread',
        de: 'Rückstoß => verteilen',
        fr: 'Pousée => Écartez-vous',
        cn: '击退 => 分散',
        ko: '넉백 => 산개'
      },
      knockbackStacks: {
        en: 'Knockback => Stacks',
        de: 'Rückstoß => sammeln',
        fr: 'Poussée => Package',
        cn: '击退 => 分摊',
        ko: '넉백 => 쉐어'
      },
      knockbackRoleStacks: {
        en: 'Knockback => Role Stacks',
        de: 'Rückstoß => Rollengruppe sammeln',
        fr: 'Poussée => Package par rôle',
        cn: '击退 => 职能分摊',
        ko: '넉백 => 역할별 쉐어'
      }
    }
  },
  // ---------------- second trash ----------------
  {
    id: 'AAIS Wood Golem Ancient Aero III',
    type: 'StartsUsing',
    netRegex: {
      id: '8BD2',
      source: 'Aloalo Wood Golem'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt('alarm')
  }, {
    id: 'AAIS Wood Golem Tornado',
    type: 'StartsUsing',
    netRegex: {
      id: '8BD3',
      source: 'Aloalo Wood Golem'
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tornadoOn: {
          en: 'Away from ${player}',
          de: 'Weg von ${player}',
          fr: 'Loin de ${player}',
          cn: '远离 ${player}',
          ko: '${player}에게서 떨어지기'
        },
        tornadoOnYou: {
          en: 'Tornado on YOU',
          de: 'Tornado auf DIR',
          fr: 'Tornade sur VOUS',
          cn: '龙卷风点名',
          ko: '토네이도 대상자'
        }
      };
      if (data.me === matches.target) return {
        alertText: output.tornadoOnYou()
      };
      return {
        infoText: output.tornadoOn({
          player: data.party.member(matches.target)
        })
      };
    }
  }, {
    id: 'AAIS Wood Golem Tornado Bind',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'EC0'
    },
    condition: data => data.CanCleanse(),
    infoText: (data, matches, output) => {
      return output.text({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Cleanse ${player}',
        de: 'Reinige ${player}',
        fr: 'Guérissez ${player}',
        cn: '康复 ${player}',
        ko: '${player} 디버프 해제'
      }
    }
  }, {
    id: 'AAIS Wood Golem Ovation',
    type: 'StartsUsing',
    netRegex: {
      id: '8BD4',
      source: 'Aloalo Wood Golem',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind('info')
  }, {
    id: 'AAIS Islekeeper Gravity Force',
    type: 'StartsUsing',
    netRegex: {
      id: '8C3A',
      source: 'Aloalo Islekeeper'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'AAIS Islekeeper Isle Drop',
    type: 'StartsUsing',
    netRegex: {
      id: '8C3C',
      source: 'Aloalo Islekeeper',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Behind + Out',
        de: 'Geh nach Hinten + Raus',
        fr: 'Derrière + Extérieur',
        cn: '去背后 + 远离',
        ko: '뒤로 + 밖으로'
      }
    }
  }, {
    id: 'AAIS Islekeeper Ancient Quaga',
    type: 'StartsUsing',
    netRegex: {
      id: '8C39',
      source: 'Aloalo Islekeeper',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'AAIS Islekeeper Ancient Quaga Enrage',
    type: 'StartsUsing',
    netRegex: {
      id: 'TODO',
      source: 'Aloalo Islekeeper',
      capture: false
    },
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Islekeeper!',
        de: 'Wächter besiegen!',
        fr: 'Tuez le gardien !',
        cn: '击杀 Islekeeper' // FIXME: correct name
      }
    }
  },
  // ---------------- Lala ----------------
  {
    id: 'AAIS Lala Inferno Theorem',
    type: 'StartsUsing',
    netRegex: {
      id: '8C05',
      source: 'Lala',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'AAIS Lala Rotation Tracker',
    type: 'HeadMarker',
    netRegex: {
      id: ['01E4', '01E5'],
      target: 'Lala'
    },
    run: (data, matches) => data.lalaBossRotation = matches.id === '01E4' ? 'clock' : 'counter'
  }, {
    id: 'AAIS Lala Angular Addition Tracker',
    type: 'Ability',
    netRegex: {
      id: ['8BE0', '8D2F'],
      source: 'Lala'
    },
    run: (data, matches) => data.lalaBossTimes = matches.id === '8BE0' ? 3 : 5
  }, {
    id: 'AAIS Lala Arcane Blight',
    type: 'StartsUsing',
    netRegex: {
      id: ['8BE2', '8BE3', '8BE4', '8BE5'],
      source: 'Lala'
    },
    alertText: (data, matches, output) => {
      const initialDir = {
        '8BE2': 2,
        // initial back safe
        '8BE3': 0,
        // initial front safe
        '8BE4': 1,
        // initial right safe
        '8BE5': 3 // initial left safe
      }[matches.id];
      if (initialDir === undefined) return;
      if (data.lalaBossTimes === undefined) return;
      if (data.lalaBossRotation === undefined) return;
      const rotationFactor = data.lalaBossRotation === 'clock' ? 1 : -1;
      const finalDir = (initialDir + rotationFactor * data.lalaBossTimes + 8) % 4;
      const diff = (finalDir - initialDir + 4) % 4;
      if (diff !== 1 && diff !== 3) return;
      return {
        0: output.front(),
        1: output.right(),
        2: output.back(),
        3: output.left()
      }[finalDir];
    },
    run: data => {
      delete data.lalaBossTimes;
      delete data.lalaBossRotation;
    },
    outputStrings: {
      front: outputs/* default.front */.Z.front,
      back: outputs/* default.back */.Z.back,
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'AAIS Lala Analysis Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E8E', 'E8F', 'E90', 'E91']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      const effectMap = {
        'E8E': 'front',
        'E8F': 'back',
        'E90': 'right',
        'E91': 'left'
      };
      data.lalaUnseen = effectMap[matches.effectId];
    }
  }, {
    id: 'AAIS Lala Times Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E89', 'ECE']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      const effectMap = {
        'E89': 3,
        'ECE': 5
      };
      data.lalaPlayerTimes = effectMap[matches.effectId];
    }
  }, {
    id: 'AAIS Lala Player Rotation Collect',
    type: 'HeadMarker',
    netRegex: {
      id: ['01ED', '01EE']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      const idMap = {
        '01ED': 'counter',
        '01EE': 'clock'
      };
      data.lalaPlayerRotation = idMap[matches.id];
    }
  }, {
    id: 'AAIS Lala Targeted Light',
    type: 'StartsUsing',
    netRegex: {
      id: '8CE0',
      source: 'Lala',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const initialUnseen = data.lalaUnseen;
      if (initialUnseen === undefined) return;
      const initialDir = {
        front: 0,
        right: 1,
        back: 2,
        left: 3
      }[initialUnseen];
      const rotation = data.lalaPlayerRotation;
      if (rotation === undefined) return;
      const times = data.lalaPlayerTimes;
      if (times === undefined) return;

      // The safe spot rotates, so the player counter-rotates.
      const rotationFactor = rotation === 'clock' ? -1 : 1;
      const finalDir = (initialDir + rotationFactor * times + 8) % 4;
      return {
        0: output.front(),
        1: output.right(),
        2: output.back(),
        3: output.left()
      }[finalDir];
    },
    run: data => {
      delete data.lalaUnseen;
      delete data.lalaPlayerTimes;
    },
    outputStrings: {
      front: {
        en: 'Face Towards Lala',
        de: 'Lala anschauen',
        fr: 'Regardez Lala',
        cn: '面向拉拉',
        ko: '라라 쳐다보기'
      },
      back: {
        en: 'Look Away from Lala',
        de: 'Von Lala weg schauen',
        fr: 'Ne regardez pas Lala',
        cn: '背对拉拉',
        ko: '라라에게서 뒤돌기'
      },
      left: {
        en: 'Left Flank towards Lala',
        de: 'Linke Seite zu Lala zeigen',
        fr: 'Flanc gauche vers Lala',
        cn: '左侧朝向拉拉',
        ko: '왼쪽면을 라라쪽으로'
      },
      right: {
        en: 'Right Flank towards Lala',
        de: 'Rechte Seite zu Lala zeigen',
        fr: 'Flanc droit vers Lala',
        cn: '右侧朝向拉拉',
        ko: '오른쪽면을 라라쪽으로'
      }
    }
  }, {
    id: 'AAIS Lala Strategic Strike',
    type: 'StartsUsing',
    netRegex: {
      id: '8C04',
      source: 'Lala'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AAIS Lala Planar Tactics',
    type: 'GainsEffect',
    // E8B = Surge Vector
    // E8C = Subtractive Suppressor Alpha
    netRegex: {
      effectId: ['E8C', 'E8B']
    },
    condition: (data, matches) => {
      data.lalaSubAlpha.push(matches);
      return data.lalaSubAlpha.length === 6;
    },
    durationSeconds: 7,
    // Only run once, as Surge Vector is used again.
    suppressSeconds: 9999999,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        one: {
          en: 'One',
          de: 'Eins',
          fr: 'Un',
          cn: '1',
          ko: '1'
        },
        bigTwo: {
          en: 'Two (stack with three)',
          de: 'Zwei (sammeln mit Drei)',
          fr: 'Deux (Pack avec Trois)',
          cn: '2 (和3分摊)',
          ko: '2 (3과 쉐어)'
        },
        smallTwo: {
          en: 'Two (stack with one)',
          de: 'Zwei (sammeln mit Eins)',
          fr: 'Deux (Pack avec Un',
          cn: '2 (和1分摊)',
          ko: '2 (1과 쉐어)'
        },
        eitherTwo: {
          en: 'Either Two (w/${player})',
          de: 'Eine Zwei (mit ${player})',
          fr: 'Un des deux (avec ${player})',
          cn: '2 (和 ${player})',
          ko: '2 (+ ${player})'
        },
        three: {
          en: 'Three',
          de: 'Drei',
          fr: 'Trois',
          cn: '3',
          ko: '3'
        },
        // This is just a raidcall so you can direct your friends.
        smallTwoOn: {
          en: '(Two with one: ${players})',
          de: '(Zwei mit Eins: ${players})',
          fr: '(Deux avec Un : ${players})',
          cn: '(2和1: ${players})',
          ko: '(2+1: ${players})'
        },
        unknownNum: {
          en: '${num}',
          de: '${num}',
          fr: '${num}',
          cn: '${num}',
          ko: '${num}'
        },
        num1: outputs/* default.num1 */.Z.num1,
        num2: outputs/* default.num2 */.Z.num2,
        num3: outputs/* default.num3 */.Z.num3,
        num4: outputs/* default.num4 */.Z.num4
      };

      // For brevity, this code calls "small two" the two that stacks with one
      // and the "big two" the two that stacks with three.
      const stacks = data.lalaSubAlpha.filter(x => x.effectId === 'E8B').map(x => x.target);
      const nums = data.lalaSubAlpha.filter(x => x.effectId === 'E8C');
      const myNumberStr = nums.find(x => x.target === data.me)?.count;
      if (myNumberStr === undefined) return;
      const myNumber = parseInt(myNumberStr);
      if (myNumber < 1 || myNumber > 4) return;
      const defaultOutput = {
        alertText: output.unknownNum({
          num: output[`num${myNumber}`]()
        })
      };
      if (stacks.length !== 2 || nums.length !== 4) return defaultOutput;
      const one = nums.find(x => parseInt(x.count) === 1)?.target;
      if (one === undefined) return defaultOutput;
      const isOneStack = stacks.includes(one);
      const twos = nums.filter(x => parseInt(x.count) === 2).map(x => x.target);
      const smallTwos = [];
      for (const thisTwo of twos) {
        // can this two stack with the one?
        const isThisTwoStack = stacks.includes(thisTwo);
        if (isThisTwoStack && !isOneStack || !isThisTwoStack && isOneStack) smallTwos.push(thisTwo);
      }
      const [smallTwo1, smallTwo2] = smallTwos;
      if (smallTwos.length === 0 || smallTwo1 === undefined) return defaultOutput;
      const isPlayerSmallTwo = smallTwos.includes(data.me);

      // Worst case adjust
      if (isPlayerSmallTwo && smallTwo2 !== undefined) {
        const otherPlayer = smallTwo1 === data.me ? smallTwo2 : smallTwo1;
        return {
          alarmText: output.eitherTwo({
            player: data.party.member(otherPlayer)
          })
        };
      }
      let playerRole;
      if (one === data.me) {
        playerRole = output.one();
      } else if (twos.includes(data.me)) {
        playerRole = isPlayerSmallTwo ? output.smallTwo() : output.bigTwo();
      } else {
        playerRole = output.three();
      }
      if (isPlayerSmallTwo) return {
        alertText: playerRole
      };
      return {
        alertText: playerRole,
        infoText: output.smallTwoOn({
          players: smallTwos.map(x => data.party.member(x))
        })
      };
    }
  }, {
    id: 'AAIS Lala Forward March',
    type: 'GainsEffect',
    // E83 = Forward March
    netRegex: {
      effectId: 'E83'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 8,
    durationSeconds: 4,
    alertText: (data, _matches, output) => {
      const rotation = data.lalaPlayerRotation;
      if (rotation === undefined) return;
      const times = data.lalaPlayerTimes;
      if (times === undefined) return;
      const rotationFactor = rotation === 'clock' ? 1 : -1;
      const finalDir = (rotationFactor * times + 8) % 4;
      if (finalDir === 1) return output.left();
      if (finalDir === 3) return output.right();
    },
    run: data => {
      delete data.lalaPlayerRotation;
      delete data.lalaPlayerTimes;
    },
    outputStrings: {
      left: {
        en: 'Leftward March',
        de: 'Linker March',
        fr: 'Marche à gauche',
        cn: '强制移动: 左',
        ko: '강제이동: 왼쪽'
      },
      right: {
        en: 'Rightward March',
        de: 'Rechter March',
        fr: 'Marche à droite',
        cn: '强制移动: 右',
        ko: '강제이동: 오른쪽'
      }
    }
  }, {
    id: 'AAIS Lala Spatial Tactics',
    type: 'GainsEffect',
    // E8D = Subtractive Suppressor Beta
    netRegex: {
      effectId: 'E8D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 999999,
    alertText: (_data, matches, output) => {
      const num = parseInt(matches.count);
      if (num < 1 || num > 4) return;
      return output[`num${num}`]();
    },
    outputStrings: {
      num1: {
        en: 'One (avoid all)',
        de: 'Eins (alles ausweichen)',
        fr: 'Un (Évitez tout)',
        cn: '1 (远离全部)',
        ko: '1 (전부 피하기)'
      },
      num2: {
        en: 'Two (stay middle)',
        de: 'Zwei (steh in der Mitte)',
        fr: 'Deux (Restez au centre)',
        cn: '2 (待在中间)',
        ko: '2 (중앙에 머물기)'
      },
      num3: {
        en: 'Three (adjacent to middle)',
        de: 'Drei (steh neben der Mitte)',
        fr: 'Trois (adjacent au centre)',
        cn: '3 (中间相邻)',
        ko: '3 (중앙에서 옆 칸)'
      },
      num4: {
        en: 'Four',
        de: 'Vier',
        fr: 'Quatre',
        cn: '4'
      }
    }
  },
  // ---------------- Statice ----------------
  {
    id: 'AAIS Statice Aero IV',
    type: 'StartsUsing',
    netRegex: {
      id: '8966',
      source: 'Statice',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'AAIS Statice Trick Reload',
    type: 'Ability',
    // 8925 = Locked and Loaded
    // 8926 = Misload
    netRegex: {
      id: ['8925', '8926'],
      source: 'Statice'
    },
    preRun: (data, matches) => data.staticeBullet.push(matches),
    alertText: (data, _matches, output) => {
      // Statice loads 8 bullets, two are duds.
      // The first and the last are always opposite, and one of them is a dud.
      // The first/ last bullets are for Trapshooting and the middle six are for Trigger Happy.
      const [bullet] = data.staticeBullet;
      if (data.staticeBullet.length !== 1 || bullet === undefined) return;
      const isStack = bullet.id === '8926';
      data.staticeTrapshooting = isStack ? ['stack', 'spread'] : ['spread', 'stack'];
      return isStack ? output.stackThenSpread() : output.spreadThenStack();
    },
    infoText: (data, _matches, output) => {
      const lastBullet = data.staticeBullet[data.staticeBullet.length - 1];
      if (data.staticeBullet.length < 2 || data.staticeBullet.length > 7) return;
      if (lastBullet?.id !== '8926') return;
      data.staticeTriggerHappy = data.staticeBullet.length - 1;
      return output.numSafeLater({
        num: output[`num${data.staticeTriggerHappy}`]()
      });
    },
    run: data => {
      if (data.staticeBullet.length === 8) data.staticeBullet = [];
    },
    outputStrings: {
      stackThenSpread: outputs/* default.stackThenSpread */.Z.stackThenSpread,
      spreadThenStack: outputs/* default.spreadThenStack */.Z.spreadThenStack,
      numSafeLater: {
        en: '(${num} safe later)',
        de: '(${num} später sicher)',
        fr: '(${num} sûr ensuite)',
        cn: '(稍后 ${num} 安全)',
        ko: '(나중에 ${num} 안전)'
      },
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      num5: outputs/* default.num5 */.Z.num5,
      num6: outputs/* default.num6 */.Z.num6
    }
  }, {
    id: 'AAIS Statice Trapshooting',
    type: 'StartsUsing',
    netRegex: {
      id: ['8D1C', '8976'],
      source: 'Statice',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const mech = data.staticeTrapshooting.shift();
      if (mech === undefined) return;
      return output[mech]();
    },
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread,
      stack: outputs/* default.stackMarker */.Z.stackMarker
    }
  }, {
    id: 'AAIS Statice Trigger Happy',
    type: 'StartsUsing',
    netRegex: {
      id: '8968',
      source: 'Statice',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const num = data.staticeTriggerHappy;
      if (num === undefined) return;
      return output[`num${num}`]();
    },
    run: data => delete data.staticeTriggerHappy,
    outputStrings: {
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      num5: outputs/* default.num5 */.Z.num5,
      num6: outputs/* default.num6 */.Z.num6
    }
  }, {
    id: 'AAIS Statice Bull\'s-eye',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'E9E'
    },
    delaySeconds: (data, matches) => {
      // Note: this collects for the pinwheeling dartboard version too.
      data.staticeDart.push(matches);
      return data.staticeDart.length === 3 ? 0 : 0.5;
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        dartOnYou: {
          en: 'Dart on YOU',
          de: 'Dart auf DIR',
          fr: 'Dard sur VOUS',
          cn: '飞镖点名',
          ko: '다트 대상자'
        },
        noDartOnYou: {
          en: 'No Dart',
          de: 'Kein Dart',
          fr: 'Pas de Dard',
          cn: '无飞镖',
          ko: '다트 없음'
        },
        flexCall: {
          en: '(${player} unmarked)',
          de: '(${player} unmarkiert)',
          fr: '(${player} non-marqué)',
          cn: '(${player} 无标记)',
          ko: '(${player} 다트 없음)'
        }
      };
      if (data.staticeIsPinwheelingDartboard) return;
      if (data.staticeDart.length === 0) return;
      const dartTargets = data.staticeDart.map(x => x.target);
      if (!dartTargets.includes(data.me)) return {
        alertText: output.noDartOnYou()
      };
      const partyNames = data.party.partyNames;
      const flexers = partyNames.filter(x => !dartTargets.includes(x));
      const [flex] = flexers;
      const flexPlayer = flexers.length === 1 ? data.party.member(flex) : undefined;
      return {
        alertText: output.dartOnYou(),
        infoText: output.flexCall({
          player: flexPlayer
        })
      };
    },
    run: data => data.staticeDart = []
  }, {
    id: 'AAIS Statice Surprise Balloon Reminder',
    // This is an early reminder for the following Trigger Happy with knockback.
    // However, because there's a tight window to immuune both knockbacks,
    // call this ~15s early (in case anybody forgot).
    type: 'StartsUsing',
    netRegex: {
      id: '8927',
      source: 'Statice',
      capture: false
    },
    infoText: (data, _matches, output) => {
      const num = data.staticeTriggerHappy;
      if (num === undefined) return;
      // We'll re-call this out with the knockback warning.
      // However, also clear `data.staticeTriggerHappy` to avoid double callouts.
      data.staticePopTriggerHappyNum = num;
      return output.numSafeSoon({
        num: output[`num${num}`]()
      });
    },
    run: data => delete data.staticeTriggerHappy,
    outputStrings: {
      numSafeSoon: {
        en: '(${num} safe soon)',
        de: '(${num} gleich sicher)',
        fr: '(${num} bientôt sûr',
        cn: '(很快 ${num} 安全)',
        ko: '(나중에 ${num} 안전)'
      },
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      num5: outputs/* default.num5 */.Z.num5,
      num6: outputs/* default.num6 */.Z.num6
    }
  }, {
    id: 'AAIS Statice Pop',
    type: 'StartsUsing',
    // TODO: this might need a slight delay
    netRegex: {
      id: '896B',
      source: 'Statice',
      capture: false
    },
    suppressSeconds: 20,
    alertText: (data, _matches, output) => {
      const num = data.staticePopTriggerHappyNum;
      if (num === undefined) return output.knockback();
      const numStr = output[`num${num}`]();
      return output.knockbackToNum({
        num: numStr
      });
    },
    run: data => delete data.staticePopTriggerHappyNum,
    outputStrings: {
      knockbackToNum: {
        en: 'Knockback => ${num}',
        de: 'Rückstoß => ${num}',
        fr: 'Poussée => ${num}',
        cn: '击退 => ${num}',
        ko: '넉백 => ${num}'
      },
      knockback: outputs/* default.knockback */.Z.knockback,
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      num5: outputs/* default.num5 */.Z.num5,
      num6: outputs/* default.num6 */.Z.num6
    }
  }, {
    id: 'AAIS Statice Face',
    type: 'GainsEffect',
    // DD2 = Forward March
    // DD3 = About Face
    // DD4 = Left Face
    // DD5 = Right Face
    netRegex: {
      effectId: ['DD2', 'DD3', 'DD4', 'DD5']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 7,
    durationSeconds: 5,
    alertText: (data, matches, output) => {
      let mech = output.unknown();
      const num = data.staticeTriggerHappy;
      if (num !== undefined) {
        mech = output[`num${num}`]();
        delete data.staticeTriggerHappy;
      } else {
        const mechName = data.staticeTrapshooting.shift();
        mech = mechName === undefined ? output.unknown() : output[mechName]();
      }
      return {
        'DD2': output.forward({
          mech: mech
        }),
        'DD3': output.backward({
          mech: mech
        }),
        'DD4': output.left({
          mech: mech
        }),
        'DD5': output.right({
          mech: mech
        })
      }[matches.effectId];
    },
    outputStrings: {
      forward: {
        en: 'Forward March => ${mech}',
        de: 'Vorwärtsmarsch => ${mech}',
        fr: 'Marche en avant => ${mech}',
        cn: '强制移动：前 => ${mech}',
        ko: '강제이동: 앞 => ${mech}'
      },
      backward: {
        en: 'Backward March => ${mech}',
        de: 'Rückwärtsmarsch => ${mech}',
        fr: 'Marche en arrière => ${mech}',
        cn: '强制移动：后 => ${mech}',
        ko: '강제이동: 뒤 => ${mech}'
      },
      left: {
        en: 'Left March => ${mech}',
        de: 'Marsch Links => ${mech}',
        fr: 'Marche à gauche => ${mech}',
        cn: '强制移动：左 => ${mech}',
        ko: '강제이동: 왼쪽 => ${mech}'
      },
      right: {
        en: 'Right March => ${mech}',
        de: 'Marsch Rechts => ${mech}',
        fr: 'Marche à droite => ${mech}',
        cn: '强制移动：右 => ${mech}',
        ko: '강제이동: 오른쪽 => ${mech}'
      },
      spread: outputs/* default.spread */.Z.spread,
      stack: outputs/* default.stackMarker */.Z.stackMarker,
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      num5: outputs/* default.num5 */.Z.num5,
      num6: outputs/* default.num6 */.Z.num6,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'AAIS Statice Present Box Counter',
    // This happens ~1s prior to ActorControlExtra on bomb.
    type: 'StartsUsing',
    netRegex: {
      id: '8972',
      source: 'Statice',
      capture: false
    },
    run: data => data.staticePresentBoxCount++
  }, {
    id: 'AAIS Statice Present Box Missile',
    type: 'Tether',
    netRegex: {
      source: 'Surprising Missile',
      id: '0011'
    },
    delaySeconds: (data, matches) => {
      data.staticeMissileTether.push(matches);
      return data.staticeMissileTether.length === 2 ? 0 : 0.5;
    },
    durationSeconds: 7,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        missileOnYou: {
          en: 'Bait Tethers => Missile Spread',
          de: 'Verbindungen ködern => Verteilen mit Raketen',
          fr: 'Attirez les liens => Écartez les missiles',
          cn: '引导拉线 => 导弹分散',
          ko: '사슬 유도 => 미사일 산개'
        }
      };
      if (data.staticeMissileTether.length !== 2) return;
      const missileTether = data.staticeMissileTether.find(x => x.target === data.me);
      if (missileTether === undefined) return;
      return {
        alertText: output.missileOnYou()
      };
    },
    run: data => data.staticeMissileTether = []
  }, {
    id: 'AAIS Statice Present Box Claw',
    type: 'Tether',
    netRegex: {
      source: 'Surprising Claw',
      id: '0011'
    },
    delaySeconds: (data, matches) => {
      data.staticeClawTether.push(matches);
      return data.staticeClawTether.length === 2 ? 0 : 0.5;
    },
    durationSeconds: 7,
    alertText: (data, _matches, output) => {
      if (data.staticeClawTether.length !== 2) return;
      if (!data.staticeClawTether.map(x => x.target).includes(data.me)) return;
      return output.stack();
    },
    run: data => data.staticeClawTether = [],
    outputStrings: {
      stack: {
        en: 'Juke Claw => Stack',
        de: 'Zieh Klaue => Sammeln',
        fr: 'Griffe => Package',
        cn: '爪子连线 => 分摊',
        ko: '손아귀 => 쉐어'
      }
    }
  }, {
    id: 'AAIS Statice Burning Chains',
    type: 'GainsEffect',
    netRegex: {
      effectId: '301'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // TODO: add a strategy for dart colors and say where to go here
    // for the Pinwheeling Dartboard if you have a dart.
    response: responses/* Responses.breakChains */.n3.breakChains()
  }, {
    id: 'AAIS Statice Shocking Abandon',
    type: 'StartsUsing',
    netRegex: {
      id: '8965',
      source: 'Statice'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AAIS Statice Pinwheeling Dartboard Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: '8CBF',
      source: 'Statice',
      capture: false
    },
    run: data => data.staticeIsPinwheelingDartboard = true
  }, {
    id: 'AAIS Statice Pinwheeling Dartboard Color',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '12507'
    },
    durationSeconds: 6,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        dartOnYou: {
          en: 'Dart (w/${player})',
          de: 'Dart (mit ${player})',
          fr: 'Dard (avec ${player})',
          cn: '飞镖 (和 ${player})',
          ko: '다트 (+ ${player})'
        },
        noDartOnYou: {
          en: 'No Dart',
          de: 'Kein Dart',
          fr: 'Pas de dard',
          cn: '无飞镖',
          ko: '다트 없음'
        },
        blue: {
          en: 'Avoid Blue',
          de: 'Vermeide Blau',
          fr: 'Évitez le bleu',
          cn: '躲避蓝色',
          ko: '파란색 피하기'
        },
        red: {
          en: 'Avoid Red',
          de: 'Vermeide Rot',
          fr: 'Évitez le rouge',
          cn: '躲避红色',
          ko: '빨간색 피하기'
        },
        yellow: {
          en: 'Avoid Yellow',
          de: 'Vermeide Gelb',
          fr: 'Évitez le jaune',
          cn: '躲避黄色',
          ko: '노란색 피하기'
        }
      };
      let infoText;
      const centerX = -200;
      const centerY = 0;
      const x = parseFloat(matches.x) - centerX;
      const y = parseFloat(matches.y) - centerY;

      // 12 pie slices, the edge of the first one is directly north.
      // It goes in B R Y order repeating 4 times.
      // The 0.5 subtraction (12 - 0.5 = 11.5) is because the Homing Pattern
      // lands directly in the middle of a slice.
      const dir12 = Math.round(6 - 6 * Math.atan2(x, y) / Math.PI + 11.5) % 12;
      const colorOffset = dir12 % 3;
      const colorMap = {
        0: 'blue',
        1: 'red',
        2: 'yellow'
      };
      data.staticeHomingColor = colorMap[colorOffset];
      if (data.staticeHomingColor !== undefined) infoText = output[data.staticeHomingColor]();
      if (data.staticeDart.length !== 2) return {
        infoText
      };
      const dartTargets = data.staticeDart.map(x => x.target);
      if (!dartTargets.includes(data.me)) return {
        alertText: output.noDartOnYou(),
        infoText: infoText
      };
      const [target1, target2] = dartTargets;
      if (target1 === undefined || target2 === undefined) return {
        infoText
      };
      const otherTarget = data.party.member(target1 === data.me ? target2 : target1);
      return {
        alertText: output.dartOnYou({
          player: otherTarget
        }),
        infoText: infoText
      };
    }
  }, {
    id: 'AAIS Statice Pinwheeling Dartboard Mech',
    type: 'HeadMarker',
    netRegex: {
      id: headmarkerIds.tethers
    },
    condition: data => data.staticeIsPinwheelingDartboard,
    delaySeconds: (data, matches) => {
      data.staticeDartboardTether.push(matches);
      return data.staticeDartboardTether.length === 2 ? 0 : 0.5;
    },
    alertText: (data, _matches, output) => {
      if (data.staticeDartboardTether.length !== 2) return;
      const tethers = data.staticeDartboardTether.map(x => x.target);
      if (tethers.includes(data.me)) {
        const [tether1, tether2] = tethers;
        const other = data.party.member(tether1 === data.me ? tether2 : tether1);
        return output.tether({
          player: other
        });
      }
      const partyNames = data.party.partyNames;
      const nonTethers = partyNames.filter(x => !tethers.includes(x));
      const [stack1, stack2] = nonTethers;
      const other = data.party.member(stack1 === data.me ? stack2 : stack1);
      return output.stack({
        player: other
      });
    },
    run: data => data.staticeDartboardTether = [],
    outputStrings: {
      // TODO: maybe this should remind you of dart color
      tether: {
        en: 'Tether w/${player}',
        de: 'Verbindung mit ${player}',
        fr: 'Lien avec ${player}',
        cn: '连线 和 ${player}',
        ko: '사슬 +${player}'
      },
      stack: {
        en: 'Stack w/${player}',
        de: 'Sammeln mit ${player}',
        fr: 'Package avec ${player}',
        cn: '分摊 和 ${player}',
        ko: '쉐어 +${player}'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Far Tide/Near Tide': 'Far/Near Tide',
      'Hydrobullet/Hydrofall': 'Hydrobullet/fall',
      'Hydrofall/Hydrobullet': 'Hydrofall/bullet',
      'Receding Twintides/Encroaching Twintides': 'Receding/Encroaching Twintides'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Aloalo Golem': 'Aloalo-Holzgolem',
      'Aloalo Islekeeper': 'Aloalo-Wächter',
      'Aloalo Kiwakin': 'Aloalo-Kiwakin',
      'Aloalo Monk': 'Aloalo-Mönch',
      'Aloalo Ray': 'Aloalo-Rochen',
      'Aloalo Snipper': 'Aloalo-Schnippler',
      'Aloalo Wood Golem': 'Aloalo-Holzgolem',
      'Aloalo Zaratan': 'Aloalo-Zaratan',
      'Arcane Font': 'arkan(?:e|er|es|en) Körper',
      'Arcane Globe': 'arkan(?:e|er|es|en) Kugel',
      'Ball of Fire': 'Feuerkugel',
      'Bomb': 'Bombe',
      'Ketuduke': 'Ketuduke',
      'Lala': 'Lala',
      'Needle': 'Nadel',
      'Spring Crystal': 'Wasserquell-Kristall',
      'Statice': 'Statice',
      'Surprising Claw': 'Überraschungsklaue',
      'Surprising Missile': 'Überraschungsrakete',
      'Surprising Staff': 'Überraschungsstab',
      'The Dawn Trial': 'Morgenrot-Probe',
      'The Dusk Trial': 'Abendrot-Probe',
      'The Midnight Trial': 'Vollmond-Probe'
    },
    'replaceText': {
      '\\(buff\\)': '(Statusveränderung)',
      '\\(cast\\)': '(wirken)',
      'Aero II': 'Windra',
      'Aero IV': 'Windka',
      'Analysis': 'Analyse',
      'Angry Seas': 'Zornige Fluten',
      'Angular Addition': 'Winkeladdition',
      'Arcane Array': 'Arkanes Spektrum',
      'Arcane Blight': 'Arkane Fäule',
      'Arcane Mine': 'Arkane Mine',
      'Arcane Plot': 'Arkane Flur',
      'Arcane Point': 'Arkane Stätte',
      'Beguiling Glitter': 'Irrleuchten',
      'Blowing Bubbles': 'Pusteblasen',
      'Bright Pulse': 'Glühen',
      'Bubble Net': 'Blasennetz',
      'Burning Chains': 'Brennende Ketten',
      'Burst': 'Explosion',
      'Constructive Figure': 'Ruf der Schöpfer',
      'Dartboard of Dancing Explosives': 'Darts und Drehung',
      'Encroaching Twintides': 'Ring der Zwiegezeiten',
      'Explosive Theorem': 'Arkane Fäule',
      'Faerie Ring': 'Feenring',
      'Far Tide': 'Ring der Gezeiten',
      'Fire Spread': 'Brandstiftung',
      'Fireworks': 'Feuerwerk',
      'Fluke Gale': 'Flossensturm',
      'Fluke Typhoon': 'Flossentaifun',
      'Hundred Lashings': 'Auspeitschung',
      'Hydrobomb': 'Hydro-Bombe',
      'Hydrobullet': 'Hydro-Kugel',
      'Hydrofall': 'Hydro-Sturz',
      'Inferno Divide': 'Infernale Teilung',
      'Inferno Theorem': 'Infernales Theorem',
      'Locked and Loaded': 'Geladen und entsichert',
      'Misload': 'Fehlladung',
      'Near Tide': 'Kreis der Gezeiten',
      'Pinwheeling Dartboard': 'Darts und Rad',
      'Planar Tactics': 'Flächentaktiken',
      'Pop': 'Platzen',
      'Powerful Light': 'Entladenes Licht',
      'Present Box': 'Geschenkschachtel',
      'Radiance': 'Radiation',
      'Receding Twintides': 'Kreis der Zwiegezeiten',
      'Ring a Ring o\' Explosions': 'Ringel-Ringel-Bombe',
      '(?<! )Roar': 'Brüllen',
      'Saturate': 'Wasserfontäne',
      'Shocking Abandon': 'Schockende Hingabe',
      'Spatial Tactics': 'Raumtaktiken',
      'Sphere Shatter': 'Sphärensplitterung',
      'Spring Crystals': 'Quellkristalle',
      'Strategic Strike': 'Schwere Attacke',
      'Strewn Bubbles': 'Streublasen',
      'Surprise Balloon': 'Überraschungsballon',
      'Surprise Needle': 'Überraschungsnadel',
      'Symmetric Surge': 'Symmetrischer Schub',
      'Targeted Light': 'Gezieltes Licht',
      'Telluric Theorem': 'Tellurisches Theorem',
      'Tidal Roar': 'Schrei der Gezeiten',
      'Trapshooting': 'Tontaubenschuss',
      'Trick Reload': 'Trickladung',
      'Trigger Happy': 'Schießwut',
      'Uncommon Ground': 'Voll ins Schwarze',
      'Updraft': 'Aufwind'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aloalo Golem': 'golem sylvestre d\'Aloalo',
      'Aloalo Islekeeper': 'gardien d\'Aloalo',
      'Aloalo Kiwakin': 'kiwakin d\'Aloalo',
      'Aloalo Monk': 'moine d\'Aloalo',
      'Aloalo Ray': 'raie rayée d\'Aloalo',
      'Aloalo Snipper': 'cisailleur d\'Aloalo',
      'Aloalo Wood Golem': 'golem sylvestre d\'Aloalo',
      'Aloalo Zaratan': 'zaratan d\'Aloalo',
      'Arcane Font': 'sphère arcanique',
      'Arcane Globe': 'globe arcanique',
      'Ball of Fire': 'orbe de feu',
      'Bomb': 'bombe',
      'Ketuduke': 'Ketuduke',
      'Lala': 'Lala',
      'Needle': 'aiguille',
      'Spring Crystal': 'cristal de source',
      'Statice': 'Statice',
      'Surprising Claw': 'griffe surprise',
      'Surprising Missile': 'missile surprise',
      'Surprising Staff': 'sceptre surprise',
      'The Dawn Trial': 'Épreuve de Dilumu',
      'The Dusk Trial': 'Épreuve de Qurupe',
      'The Midnight Trial': 'Épreuve de Nokosero'
    },
    'replaceText': {
      '\\(buff\\)': '(Buff)',
      '\\(cast\\)': '(Incantation)',
      'Aero II': 'Extra Vent',
      'Aero IV': 'Giga Vent',
      'Analysis': 'Analyse',
      'Angry Seas': 'Mer agitée',
      'Angular Addition': 'Calcul angulaire',
      'Arcane Array': 'Assemblement arcanique',
      'Arcane Blight': 'Canon arcanique',
      'Arcane Mine': 'Mine arcanique',
      'Arcane Plot': 'Modulateur arcanique',
      'Arcane Point': 'Pointe arcanique',
      'Beguiling Glitter': 'Paillettes aveuglantes',
      'Blowing Bubbles': 'Bulles soufflées',
      'Bright Pulse': 'Éclat',
      'Bubble Net': 'Filet de bulles',
      'Burning Chains': 'Chaînes brûlantes',
      'Burst': 'Explosion',
      'Constructive Figure': 'Icône articulée',
      'Dartboard of Dancing Explosives': 'Duo fléchettes-tourbillon',
      'Encroaching Twintides': 'Double marée débordante',
      'Explosive Theorem': 'Théorème explosif',
      'Faerie Ring': 'Cercle féérique',
      'Far Tide': 'Marée lointaine',
      'Fire Spread': 'Nappe de feu',
      'Fireworks': 'Feu d\'artifice',
      'Fluke Gale': 'Bourrasque hasardeuse',
      'Fluke Typhoon': 'Typhon hasardeux',
      'Hundred Lashings': 'Cent coups de fouet',
      'Hydrobomb': 'Hydrobombe',
      'Hydrobullet': 'Barillet hydrique',
      'Hydrofall': 'Pilonnage hydrique',
      'Inferno Divide': 'Division infernale',
      'Inferno Theorem': 'Théorème infernal',
      'Locked and Loaded': 'Rechargement réussi',
      'Misload': 'Rechargement raté',
      'Near Tide': 'Marée proche',
      'Pinwheeling Dartboard': 'Duo fléchettes-moulinette',
      'Planar Tactics': 'Tactique planaire',
      'Pop': 'Rupture',
      'Powerful Light': 'Explosion sacrée',
      'Present Box': 'Boîtes cadeaux',
      'Radiance': 'Irradiation',
      'Receding Twintides': 'Double marée fuyante',
      'Ring a Ring o\' Explosions': 'Tempérament explosif',
      '(?<! )Roar': 'Rugissement',
      'Saturate': 'Jet d\'eau',
      'Shocking Abandon': 'Choc renonciateur',
      'Spatial Tactics': 'Tactique spatiale',
      'Sphere Shatter': 'Rupture glacée',
      'Spring Crystals': 'Cristaux de source',
      'Strategic Strike': 'Coup violent',
      'Strewn Bubbles': 'Bulles éparpillées',
      'Surprise Balloon': 'Ballons surprises',
      'Surprise Needle': 'Aiguille surprise',
      'Symmetric Surge': 'Déferlement symétrique',
      'Targeted Light': 'Rayon ciblé',
      'Telluric Theorem': 'Théorème tellurique',
      'Tidal Roar': 'Vague rugissante',
      'Trapshooting': 'Tir au pigeon',
      'Trick Reload': 'Rechargement habile',
      'Trigger Happy': 'Gâchette impulsive',
      'Uncommon Ground': 'Terrain de mésentente',
      'Updraft': 'Courants ascendants'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aloalo Golem': 'アロアロ・ウッドゴーレム',
      'Aloalo Islekeeper': 'アロアロ・キーパー',
      'Aloalo Kiwakin': 'アロアロ・キワキン',
      'Aloalo Monk': 'アロアロ・モンク',
      'Aloalo Ray': 'アロアロ・ストライプレイ',
      'Aloalo Snipper': 'アロアロ・スニッパー',
      'Aloalo Wood Golem': 'アロアロ・ウッドゴーレム',
      'Aloalo Zaratan': 'アロアロ・ザラタン',
      'Arcane Font': '立体魔法陣',
      'Arcane Globe': '球体魔法陣',
      'Ball of Fire': '火球',
      'Bomb': '爆弾',
      'Ketuduke': 'ケトゥドゥケ',
      'Lala': 'ララ',
      'Needle': 'ニードル',
      'Spring Crystal': '湧水のクリスタル',
      'Statice': 'スターチス',
      'Surprising Claw': 'サプライズ・クロー',
      'Surprising Missile': 'サプライズ・ミサイル',
      'Surprising Staff': 'サプライズ・ロッド',
      'The Dawn Trial': 'ディルムの試練',
      'The Dusk Trial': 'クルペの試練',
      'The Midnight Trial': 'ノコセロの試練'
    },
    'replaceText': {
      'Aero II': 'エアロラ',
      'Aero IV': 'エアロジャ',
      'Analysis': 'アナライズ',
      'Angry Seas': 'アングリーシーズ',
      'Angular Addition': '回転角乗算',
      'Arcane Array': '複合魔紋',
      'Arcane Blight': '魔紋砲',
      'Arcane Mine': '地雷魔紋',
      'Arcane Plot': '変光魔紋',
      'Arcane Point': '変光起爆',
      'Beguiling Glitter': '惑わしの光',
      'Blowing Bubbles': 'バブルブロワー',
      'Bright Pulse': '閃光',
      'Bubble Net': 'バブルネットフィーディング',
      'Burning Chains': '炎の鎖',
      'Burst': '爆発',
      'Constructive Figure': '人形召喚',
      'Dartboard of Dancing Explosives': 'ダーツ＆ローテーション',
      'Encroaching Twintides': 'リング・ダブルタイド',
      'Explosive Theorem': '魔爆法',
      'Faerie Ring': 'フェアリーリング',
      'Far Tide': 'リングタイド',
      'Fire Spread': '放火',
      'Fireworks': 'ファイアワークフェスティバル',
      'Fluke Gale': 'フリッパーゲイル',
      'Fluke Typhoon': 'フリッパータイフーン',
      'Hundred Lashings': 'めった打ち',
      'Hydrobomb': 'ハイドロボム',
      'Hydrobullet': 'ハイドロバレット',
      'Hydrofall': 'ハイドロフォール',
      'Inferno Divide': '十火法',
      'Inferno Theorem': '散火法',
      'Locked and Loaded': 'リロード成功',
      'Misload': 'リロード失敗',
      'Near Tide': 'ラウンドタイド',
      'Pinwheeling Dartboard': 'ダーツ＆ウィール',
      'Planar Tactics': '爆雷戦術：面',
      'Pop': '破裂',
      'Powerful Light': '光爆',
      'Present Box': 'プレゼントボックス',
      'Radiance': '光球爆散',
      'Receding Twintides': 'ラウンド・ダブルタイド',
      'Ring a Ring o\' Explosions': 'リンクリンクボム',
      '(?<! )Roar': '咆哮',
      'Saturate': '放水',
      'Shocking Abandon': 'アバンドンショック',
      'Spatial Tactics': '爆雷戦術：立体',
      'Sphere Shatter': '破裂',
      'Spring Crystals': '湧水のクリスタル',
      'Strategic Strike': '強撃',
      'Strewn Bubbles': 'バブルストゥルー',
      'Surprise Balloon': 'サプライズバルーン',
      'Surprise Needle': 'サプライズニードル',
      'Symmetric Surge': '双数爆撃',
      'Targeted Light': '高精度光弾',
      'Telluric Theorem': '地隆法',
      'Tidal Roar': 'タイダルロア',
      'Trapshooting': 'トラップシューティング',
      'Trick Reload': 'トリックリロード',
      'Trigger Happy': 'トリガーハッピー',
      'Uncommon Ground': 'グラウンドシアー',
      'Updraft': '上昇気流'
    }
  }]
};
/* harmony default export */ const another_aloalo_island_savage = (another_aloalo_island_savage_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/another_aloalo_island-savage.txt
const dungeon_another_aloalo_island_savage_namespaceObject = "# This file was autogenerated from running npm run sync-files.\r\n# DO NOT EDIT THIS FILE DIRECTLY.\r\n# Edit the source file below and then run `npm run sync-files`\r\n# Source: ui/raidboss/data/06-ew/dungeon/another_aloalo_island.txt\r\n\r\n### ANOTHER ALOALO ISLAND\r\n# ZoneId: 49B\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~~#\r\n# KETUDUKE #\r\n#~~~~~~~~~~#\r\n\r\n# -p 8AD4:1015.2\r\n# -ii 8AA7 8AED 8ADD 8AB9 8AB6 8AEB 8ABE 8ABF 8AE5 8AE6 8AC0 8ADA 8AD9 8AE4 8AC8 8AE3 8A82 8A83\r\n\r\n# The Dawn Trial will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1146\" } window 10000,0\r\n1010.2 \"--sync--\" StartsUsing { id: \"8AD4\", source: \"Ketuduke\" } window 20,20\r\n1015.2 \"Tidal Roar\" Ability { id: \"8AD4\", source: \"Ketuduke\" }\r\n\r\n1022.0 \"--middle--\" Ability { id: \"8A77\", source: \"Ketuduke\" }\r\n1027.0 \"Spring Crystals 1\" Ability { id: \"8AA8\", source: \"Ketuduke\" }\r\n1034.0 \"Bubble Net\" Ability { id: \"8AAD\", source: \"Ketuduke\" }\r\n1041.0 \"Hydrobullet/Hydrofall (buff)\" Ability { id: [\"8AB8\", \"8AB4\"], source: \"Ketuduke\" }\r\n1050.0 \"Fluke Gale (cast)\" Ability { id: \"8AB1\", source: \"Ketuduke\" }\r\n1060.0 \"Fluke Gale 1\" Ability { id: \"8AB2\", source: \"Ketuduke\" }\r\n1062.0 \"Fluke Gale 2\" Ability { id: \"8AB3\", source: \"Ketuduke\" }\r\n1065.0 \"Saturate\" Ability { id: \"8ADC\", source: \"Spring Crystal\" }\r\n1065.1 \"Hydrobullet/Hydrofall\" Ability { id: [\"8ADF\", \"8ADE\"], source: \"Ketuduke\" }\r\n\r\n1074.0 \"Hydrofall/Hydrobullet (buff)\" Ability { id: [\"8AB4\", \"8AB8\"], source: \"Ketuduke\" }\r\n1077.1 \"Hydrobullet/Hydrofall (buff)\" Ability { id: [\"8C6D\", \"8AB5\"], source: \"Ketuduke\" }\r\n1084.3 \"Blowing Bubbles\" Ability { id: \"8ABD\", source: \"Ketuduke\" }\r\n1091.4 \"Hydrobomb x3\" Ability { id: \"8AD0\", source: \"Ketuduke\" }\r\n1096.3 \"Hydrofall/Hydrobullet\" Ability { id: [\"8ADE\", \"8ADF\"], source: \"Ketuduke\" }\r\n1099.6 \"Hydrobomb x3\" Ability { id: \"8AD0\", source: \"Ketuduke\" }\r\n1102.5 \"Hydrobullet/Hydrobullet\" Ability { id: [\"8ADF\", \"8ADE\"], source: \"Ketuduke\" }\r\n\r\n1113.6 \"Hydrofall (buff)\" Ability { id: \"8AB4\", source: \"Ketuduke\" }\r\n1118.9 \"Strewn Bubbles\" Ability { id: \"8ABB\", source: \"Ketuduke\" }\r\n1130.3 \"Receding Twintides/Encroaching Twintides\" Ability { id: [\"8AE7\", \"8AE9\"], source: \"Ketuduke\" }\r\n1130.9 \"Sphere Shatter 1\" Ability { id: \"8AE0\", source: \"Ketuduke\" }\r\n1133.4 \"Far Tide/Near Tide\" Ability { id: [\"8AEA\", \"8AE8\"], source: \"Ketuduke\" }\r\n1134.0 \"Sphere Shatter 2\" Ability { id: \"8AE0\", source: \"Ketuduke\" }\r\n1134.0 \"Hydrofall\" Ability { id: \"8ADE\", source: \"Ketuduke\" }\r\n\r\n1143.7 \"Hydrobullet (buff)\" Ability { id: \"8AB8\", source: \"Ketuduke\" }\r\n1149.7 \"Roar\" Ability { id: \"8AC4\", source: \"Ketuduke\" }\r\n1154.6 \"Spring Crystals 2\" Ability { id: \"8AA8\", source: \"Ketuduke\" }\r\n1164.6 \"Bubble Net\" Ability { id: \"8AC5\", source: \"Ketuduke\" }\r\n1177.0 \"Hydrobullet\" Ability { id: \"8ADF\", source: \"Ketuduke\" }\r\n1177.6 \"Saturate\" Ability { id: \"8ADC\", source: \"Spring Crystal\" }\r\n1182.7 \"Updraft\" Ability { id: \"8AC7\", source: \"Ketuduke\" }\r\n1184.1 \"Hundred Lashings\" Ability { id: \"8ACA\", source: \"Aloalo Zaratan\" }\r\n\r\n1190.7 \"--middle--\" Ability { id: \"8A77\", source: \"Ketuduke\" }\r\n1199.4 \"Hydrofall/Hydrobullet (buff)\" Ability { id: [\"8AB4\", \"8AB8\"], source: \"Ketuduke\" }\r\n1202.4 \"Hydrobullet/Hydrofall (buff)\" Ability { id: [\"8C6D\", \"8AB5\"], source: \"Ketuduke\" }\r\n1210.4 \"Angry Seas\" Ability { id: \"8AE1\", source: \"Ketuduke\" }\r\n1211.6 \"Hydrofall/Hydrobullet\" Ability { id: [\"8ADE\", \"8ADF\"], source: \"Ketuduke\" }\r\n1212.2 \"Hydrobullet/Hydrobullet\" Ability { id: [\"8ADF\", \"8ADE\"] } # this sometimes has the wrong source\r\n1214.8 \"Spring Crystals 3\" Ability { id: \"8AA8\", source: \"Ketuduke\" }\r\n1216.8 \"Hydrobullet\" Ability { id: \"8ADF\", source: \"Ketuduke\" }\r\n1221.8 \"Bubble Net\" Ability { id: \"8AAD\", source: \"Ketuduke\" }\r\n1227.8 \"Fluke Typhoon (cast)\" Ability { id: \"8AAF\", source: \"Ketuduke\" }\r\n1233.8 \"Fluke Typhoon\" Ability { id: \"8AB0\", source: \"Ketuduke\" }\r\n1236.4 \"Saturate\" Ability { id: \"8ADB\", source: \"Spring Crystal\" }\r\n1238.8 \"Burst x4\" Ability { id: \"8AE2\", source: \"Ketuduke\" }\r\n\r\n1246.7 \"Spring Crystals 4\" Ability { id: \"8AA8\", source: \"Ketuduke\" }\r\n1253.7 \"Bubble Net\" Ability { id: \"8AAD\", source: \"Ketuduke\" }\r\n1260.7 \"Hydrobullet/Hydrofall (buff)\" Ability { id: [\"8AB8\", \"8AB4\"], source: \"Ketuduke\" }\r\n1269.8 \"Fluke Gale (cast)\" Ability { id: \"8AB1\", source: \"Ketuduke\" }\r\n1279.9 \"Fluke Gale 1\" Ability { id: \"8AB2\", source: \"Ketuduke\" }\r\n1281.9 \"Fluke Gale 2\" Ability { id: \"8AB3\", source: \"Ketuduke\" }\r\n1284.9 \"Saturate\" Ability { id: \"8ADC\", source: \"Spring Crystal\" }\r\n1285.0 \"Hydrobullet/Hydrofall\" Ability { id: [\"8ADF\", \"8ADE\"], source: \"Ketuduke\" }\r\n\r\n1293.9 \"Hydrofall (buff)\" Ability { id: \"8AB4\", source: \"Ketuduke\" }\r\n1299.2 \"Strewn Bubbles\" Ability { id: \"8ABB\", source: \"Ketuduke\" }\r\n1310.6 \"Receding Twintides/Encroaching Twintides\" Ability { id: [\"8AE7\", \"8AE9\"], source: \"Ketuduke\" }\r\n1311.2 \"Sphere Shatter 1\" Ability { id: \"8AE0\", source: \"Ketuduke\" }\r\n1313.7 \"Far Tide/Near Tide\" Ability { id: [\"8AEA\", \"8AE8\"], source: \"Ketuduke\" }\r\n1314.3 \"Sphere Shatter 2\" Ability { id: \"8AE0\", source: \"Ketuduke\" }\r\n1314.3 \"Hydrofall\" Ability { id: \"8ADE\", source: \"Ketuduke\" }\r\n1325.0 \"Tidal Roar\" Ability { id: \"8AD4\", source: \"Ketuduke\" }\r\n\r\n1331.8 \"--sync--\" StartsUsing { id: \"TODO\", source: \"Ketuduke\" }\r\n1341.8 \"Tidal Roar Enrage\" Ability { id: \"TODO\", source: \"Ketuduke\" }\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 8A77 --sync-- Ketuduke repositioning\r\n# 8A82 Riptide ability on players from Angry Seas Airy Bubble when you step in one\r\n# 8A83 Fetters ability on players from Angry Seas Airy Bubble when you step in one after 8A82 Riptide\r\n# 8AA7 --sync-- auto damage from Ketuduke\r\n# 8AA8 Spring Crystals cast and ability to summon Spring Crystal adds (all flavors)\r\n# 8AD9 衝撃 self-targeted ability from Spring Crystal orbs\r\n# 8ADA 衝撃 self-targeted ability from Spring Crystal rupees\r\n# 8ADB Saturate cast and damage from Spring Crystal orb circle\r\n# 8ADC Saturate cast and damage from Spring Crystal rupee line laser\r\n# 8AAD Bubble Net self-targeted cast before Bubbles along with 8ADD during Spring Crystals 1\r\n# 8ADD Bubble Net cast and ability on players that adds Bubbles/Fetters debuffs during Spring Crystals 1\r\n# 8AAF Fluke Typhoon self-targeted cast before 8AB0 knockback during Spring Crystals 3\r\n# 8AB0 Fluke Typhoon cast and knockback ability on Spring Crystal and players during Spring Crystals 3\r\n# 8AB1 Fluke Gale self-targeted cast that adds limit cut winds\r\n# 8AB2 Fluke Gale cast and ability for limit cut 1 wind\r\n# 8AB3 Fluke Gale cast and ability for limit cut 2 wind\r\n# 8AB4 Hydrofall self-targeted cast that adds stack markers\r\n# 8AB5 Hydrofall self-targeted \"stack second\" ability before Blowing Bubbles\r\n# 8AB6 Hydrofall ability on players that adds stack debuffs\r\n# 8ADE Hydrofall damage from stack debuffs\r\n# 8AB8 Hydrobullet self-targeted cast that adds stack markers\r\n# 8AB9 Hydrobullet ability on players that adds spread debuffs\r\n# 8ADF Hydrobullet damage from spread debuffs\r\n# 8ABB Strewn Bubbles self-targeted cast before 8AE0 Sphere Shatter moving arches\r\n# 8AE0 Sphere Shatter damage from moving arches\r\n# 8ABD Blowing Bubbles self-targeted cast that adds Airy Bubble Adds\r\n# 8ABE Riptide ability on players from Blowing Bubbles Airy Bubble when you step in one\r\n# 8ABF Fetters ability on players from Blowing Bubbles Airy Bubble when you step in one after 8ABE Riptide\r\n# 8AC0 Angry Seas self-targeted cast for 8AE1 red line knockback\r\n# 8AE1 Angry Seas cast and knockback damage from red line\r\n# 8AE2 Burst tower damage\r\n# 8AE3 Big Burst tower failure damage\r\n# 8AC4 Roar self-targeted cast that summons Zaratan adds\r\n# 8AC5 Bubble Net self-targeted cast before Bubbles along with 8AE4 during Spring Crystals 2\r\n# 8AE4 Bubble Net cast and ability on players that adds Bubbles/Fetters debuffs during Spring Crystals 2\r\n# 8AC7 Updraft self-targeted cast to boost adds and players into the air\r\n# 8AC8 Updraft ability on players for 8AC7 Updraft\r\n# 8AE5 Hundred Lashings cast and damage for non-bubbled Zaratan 180 cleave (no damage on bubbled players)\r\n# 8ACA Hundred Lashings self-targeted cast for bubbled Zaratan adds\r\n# 8AE6 Hundred Lashings cast and damage for bubbled Zaratan 180 cleave (no damage on non-bubbled players)\r\n# 8AE7 Receding Twintides cast and damage for initial out during out->in\r\n# 8AE8 Near Tide fast cast and damage for second out during in->out with 8AE9 Encroaching Twintides\r\n# 8AE9 Encroaching Twintides cast and damage for initial in during in->out\r\n# 8AEA Far Tide fast cast and damage for second in during out->in with 8AE7 Receding Twintides\r\n# 8AD0 Hydrobomb self-targeted cast for 8AEB puddles\r\n# 8AEB Hydrobomb cast and damage for 3x puddles duruing 8ABD Blowing Bubbles\r\n# 8AD4 Tidal Roar self-targeted cast for raidwide aoe\r\n# 8AED Tidal Roar damage from 8AD4\r\n# TODO Tidal Roar cast and enrage damage\r\n# 8C6D Hydrobullet self-targeted \"spread second\" ability before Blowing Bubbles\r\n\r\n\r\n#~~~~~~#\r\n# LALA #\r\n#~~~~~~#\r\n\r\n# -p 8C05:2011.1\r\n# -ii 8BE6 8BE9 8CE1 8BF1 8BF2 8BFF 8BF3 8BF4\r\n\r\n# The Dusk Trial will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1147\" } window 10000,0\r\n2006.1 \"--sync--\" StartsUsing { id: \"8C05\", source: \"Lala\" } window 20,20\r\n2011.1 \"Inferno Theorem\" Ability { id: \"8C05\", source: \"Lala\" }\r\n\r\n2013.2 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n2018.3 \"Angular Addition\" Ability { id: [\"8BE0\", \"8D2F\"], source: \"Lala\" }\r\n2026.4 \"Arcane Blight\" Ability { id: [\"8BE2\", \"8BE3\", \"8BE4\", \"8BE5\"], source: \"Lala\" }\r\n\r\n2029.6 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n2034.7 \"Analysis\" Ability { id: \"8BEC\", source: \"Lala\" }\r\n2039.8 \"Arcane Array 1\" Ability { id: \"8BE7\", source: \"Lala\" }\r\n2044.9 \"Angular Addition\" Ability { id: [\"8BE0\", \"8D2F\"], source: \"Lala\" }\r\n2045.6 \"Bright Pulse\" Ability { id: \"8BE8\", source: \"Lala\" }\r\n2046.9 \"Radiance 1\" Ability { id: \"8BEB\", source: \"Arcane Globe\" }\r\n2053.0 \"Arcane Blight\" Ability { id: [\"8BE2\", \"8BE3\", \"8BE4\", \"8BE5\"], source: \"Lala\" }\r\n# This can be +1.2s if it's on the final square instead of penultimate.\r\n2054.1 \"Radiance 2\" #Ability { id: \"8BEB\", source: \"Arcane Globe\" }\r\n2061.2 \"Targeted Light\" Ability { id: \"8CE0\", source: \"Lala\" }\r\n\r\n2072.5 \"Strategic Strike\" Ability { id: \"8C04\", source: \"Lala\" }\r\n\r\n2085.6 \"Planar Tactics\" Ability { id: \"8BEF\", source: \"Lala\" }\r\n2100.7 \"Arcane Mine\" Ability { id: \"8BF0\", source: \"Lala\" }\r\n2108.6 \"Symmetric Surge x2\" Ability { id: \"8BF5\", source: \"Lala\" }\r\n\r\n2112.8 \"Inferno Theorem\" Ability { id: \"8C05\", source: \"Lala\" }\r\n2122.9 \"Strategic Strike\" Ability { id: \"8C04\", source: \"Lala\" }\r\n\r\n2131.1 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n2138.3 \"Spatial Tactics\" Ability { id: \"8BF7\", source: \"Lala\" }\r\n2143.4 \"Arcane Array 2\" Ability { id: \"8BF6\", source: \"Lala\" }\r\n2149.2 \"Bright Pulse\" Ability { id: \"8BE8\", source: \"Lala\" }\r\n2150.5 \"Inferno Divide 1\" Ability { id: \"8BEA\", source: \"Arcane Font\" } window 1,1\r\n2150.5 \"Radiance\" Ability { id: \"8D20\", source: \"Arcane Globe\" }\r\n2152.9 \"Inferno Divide 2\" Ability { id: \"8BEA\", source: \"Arcane Font\" } window 1,1\r\n2156.6 \"Inferno Divide 3\" Ability { id: \"8BEA\", source: \"Arcane Font\" } window 1,1\r\n2157.6 \"Angular Addition\" Ability { id: [\"8BE0\", \"8D2F\"], source: \"Lala\" }\r\n2157.8 \"Inferno Divide 4\" Ability { id: \"8BEA\", source: \"Arcane Font\" } window 1,1\r\n2160.2 \"Inferno Divide 5\" Ability { id: \"8BEA\", source: \"Arcane Font\" } window 1,1\r\n2165.6 \"Arcane Blight\" Ability { id: [\"8BE2\", \"8BE3\", \"8BE4\", \"8BE5\"], source: \"Lala\" }\r\n\r\n2173.7 \"Inferno Theorem\" Ability { id: \"8C05\", source: \"Lala\" }\r\n2184.8 \"Inferno Theorem\" Ability { id: \"8C05\", source: \"Lala\" }\r\n\r\n2196.9 \"Symmetric Surge\" Ability { id: \"8BF8\", source: \"Lala\" }\r\n2202.0 \"Constructive Figure\" Ability { id: \"8BFA\", source: \"Lala\" }\r\n2207.1 \"Arcane Plot\" Ability { id: \"8BF9\", source: \"Lala\" }\r\n2212.9 \"Bright Pulse\" Ability { id: \"8BE8\", source: \"Lala\" }\r\n2221.2 \"Arcane Point\" Ability { id: \"8BFC\", source: \"Lala\" }\r\n2221.8 \"Aero II\" Ability { id: \"8BFB\", source: \"Aloalo Golem\" }\r\n2222.0 \"Powerful Light\" Ability { id: \"8BFD\", source: \"Lala\" }\r\n2230.3 \"Explosive Theorem\" Ability { id: \"8BFE\", source: \"Lala\" }\r\n2234.7 \"Symmetric Surge x2\" Ability { id: \"8BF5\", source: \"Lala\" }\r\n2235.4 \"Telluric Theorem\" Ability { id: \"8C00\", source: \"Lala\" }\r\n\r\n2248.4 \"Strategic Strike\" Ability { id: \"8C04\", source: \"Lala\" }\r\n2256.5 \"Inferno Theorem\" Ability { id: \"8C05\", source: \"Lala\" }\r\n\r\n2263.6 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n2269.0 \"Analysis\" Ability { id: \"8BEC\", source: \"Lala\" }\r\n2274.1 \"Arcane Array 3\" Ability { id: \"8BE7\", source: \"Lala\" }\r\n2279.2 \"Angular Addition\" Ability { id: [\"8BE0\", \"8D2F\"], source: \"Lala\" }\r\n2279.9 \"Bright Pulse\" Ability { id: \"8BE8\", source: \"Lala\" }\r\n2281.2 \"Radiance 1\" Ability { id: \"8BEB\", source: \"Arcane Globe\" }\r\n2287.3 \"Arcane Blight\" Ability { id: [\"8BE2\", \"8BE3\", \"8BE4\", \"8BE5\"], source: \"Lala\" }\r\n2290.9 \"Radiance 2\" Ability { id: \"8BEB\", source: \"Arcane Globe\" }\r\n2295.6 \"Targeted Light\" Ability { id: \"8CE0\", source: \"Lala\" }\r\n2306.7 \"Strategic Strike\" Ability { id: \"8C04\", source: \"Lala\" }\r\n\r\n2316.8 \"Inferno Theorem\" Ability { id: \"8C05\", source: \"Lala\" }\r\n\r\n2319.9 \"--sync--\" StartsUsing { id: \"TODO\", source: \"Lala\" } window 20,20\r\n2329.9 \"Inferno Theorem Enrage\" Ability { id: \"TODO\", source: \"Lala\" }\r\n\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 368 attack auto damage from Lala\r\n# 8874 --sync-- repositioning for Lala\r\n# 8BE0 Angular Addition self-targeted ability to give boss III\r\n# 8BE2 Arcane Blight self-targeted cast for initial back-safe 270 degree rotating cleave\r\n# 8BE3 Arcane Blight self-targeted cast for initial front-safe 270 degree rotating cleave\r\n# 8BE4 Arcane Blight self-targeted cast for initial east-safe 270 degree rotating cleave\r\n# 8BE5 Arcane Blight self-targeted cast for initial west-safe 270 degree rotating cleave\r\n# 8BE6 Arcane Blight cast and damage from 270 degree rotating cleave\r\n# 8BE7 Arcane Array self-targeted cast to summon moving blue squares (#1)\r\n# 8BE8 Bright Pulse cast and damage for initial blue square\r\n# 8BE9 Bright Pulse damage from moving blue square\r\n# 8BEA Inferno Divide orange square cross explosion damage during Spatial Tactics\r\n# 8BEB Radiance damage from Arcane Globe being hit by a blue square (Arcane Array #1, #3)\r\n# 8BEC Analysis self-targeted cast before giving players\r\n# 8BEF Planar Tactics self-targeted cast before Arcane Mines\r\n# 8BF0 Arcane Mine self-targeted cast to create 8 Arcane Mine squares\r\n# 8BF1 Arcane Mine cast and damage for initial Arcane Mine squares\r\n# 8BF2 Arcane Combustion damage from walking over an Arcane Mine\r\n# 8BF3 Massive Explosion damage from failing to resolve Subractive Suppressor Alpha\r\n# 8BF4 Massive Explosion damage from failing to resolve Subractive Suppressor Beta\r\n# 8BF5 Symmetric Surge damage from two person stack that gives magic vuln up\r\n# 8BF6 Arcane Array self-targeted cast to summon moving blue squares (#2)\r\n# 8BF7 Spatial Tactics self-targeted cast prior to Arcane Array 2\r\n# 8BF8 Symmetric Surge self-targeted cast before this mechanic\r\n# 8BF9 Arcane Plot self-targeted cast to summon blue squares for Symmetric Surge\r\n# 8BFA Constructive Figure self-targeted cast that summons Aloalo Golem on edge\r\n# 8BFB Aero II cast and line damage from Aloalo Golem during Symmetric Surge\r\n# 8BFC Arcane Point self-targeted cast that gives players 8BFD Powerful Light spreads\r\n# 8BFD Powerful Light spread damage on players that turn the squares they are on blue\r\n# 8BFE Explosive Theorem self-targeted cast for very large spreads\r\n# 8BFF Explosive Theorem cast and damage on players for spreads with Telluric Theorem puddles\r\n# 8C00 Telluric Theorem cast and damage for large puddles from Explosive Theorem\r\n# 8C04 Strategic Strike cast and damage for non-cleaving 3x tankbuster\r\n# 8C05 Inferno Theorem cast and raidwide damage\r\n# TODO Inferno Theorem cast and enrage damage\r\n# 8CE0 Targeted Light self-targeted cast for weak spot boss tether\r\n# 8CE1 Targeted Light cast and damage on players for 8CE0\r\n# 8D20 Radiance damage from Arcane Globe being hit by a blue square (Arcane Array #2)\r\n# 8D2F Angular Addition self-targeted ability to give boss V\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~~#\r\n# STATICE WITH A GUN #\r\n#~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 8966:3013.8\r\n# -ii 8964 8925 8926 8977 8978 8969 8988 8A6A 897C 897D 8CC3 896F 8CC1 89FB TODO 8974 8975\r\n# -it Statice\r\n\r\n# Midnight Trial will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1148\" } window 10000,0\r\n3008.8 \"--sync--\" StartsUsing { id: \"8966\", source: \"Statice\" } window 20,20\r\n3013.8 \"Aero IV\" Ability { id: \"8966\", source: \"Statice\" }\r\n\r\n3018.0 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n3023.4 \"Trick Reload\" Ability { id: \"8967\", source: \"Statice\" }\r\n3038.2 \"Trapshooting 1\" Ability { id: \"8D1C\", source: \"Statice\" }\r\n3048.6 \"Trigger Happy\" Ability { id: \"8968\", source: \"Statice\" }\r\n3056.5 \"Ring a Ring o' Explosions\" Ability { id: \"8979\", source: \"Statice\" }\r\n3070.6 \"Trapshooting 2\" Ability { id: \"8976\", source: \"Statice\" }\r\n3074.6 \"Burst\" Ability { id: \"897A\", source: \"Bomb\" }\r\n\r\n3081.8 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n3087.4 \"Trick Reload\" Ability { id: \"8967\", source: \"Statice\" }\r\n3101.2 \"Ring a Ring o' Explosions\" Ability { id: \"8979\", source: \"Statice\" }\r\n3106.3 \"Dartboard of Dancing Explosives \" Ability { id: \"8CC0\", source: \"Statice\" }\r\n3120.1 \"Trapshooting 1\" Ability { id: \"8976\", source: \"Statice\" }\r\n3122.0 \"Burst\" Ability { id: \"897A\", source: \"Bomb\" }\r\n3125.3 \"Uncommon Ground\" Ability { id: \"8971\", source: \"Statice\" }\r\n\r\n3132.3 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n3137.7 \"Surprise Balloon\" Ability { id: \"8927\", source: \"Statice\" }\r\n3144.8 \"Beguiling Glitter\" Ability { id: \"8980\", source: \"Statice\" }\r\n3149.8 \"Surprise Needle 1\" #Ability { id: \"896C\", source: \"Needle\" }\r\n3150.7 \"Pop 1\" Ability { id: \"896B\", source: \"Statice\" }\r\n3151.5 \"Surprise Needle 2\" #Ability { id: \"896C\", source: \"Needle\" }\r\n3152.4 \"Trigger Happy\" Ability { id: \"8968\", source: \"Statice\" }\r\n3153.2 \"Surprise Needle 3\" #Ability { id: \"896C\", source: \"Needle\" }\r\n3154.9 \"Surprise Needle 4\" #Ability { id: \"896C\", source: \"Needle\" }\r\n3155.6 \"Pop 2\" Ability { id: \"896B\", source: \"Statice\" }\r\n3160.4 \"Trapshooting 2\" Ability { id: \"8976\", source: \"Statice\" }\r\n3172.5 \"Aero IV\" Ability { id: \"8966\", source: \"Statice\" }\r\n\r\n3179.7 \"--untargetable--\"\r\n3179.7 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n3184.1 \"Ring a Ring o' Explosions\" Ability { id: \"8979\", source: \"Statice\" }\r\n3189.2 \"Present Box 1\" Ability { id: \"8972\", source: \"Statice\" }\r\n3194.3 \"Fireworks (cast)\" Ability { id: \"897B\", source: \"Statice\" }\r\n3204.0 \"Fireworks\" Ability { id: \"897C\", source: \"Statice\" }\r\n3204.2 \"Burst\" Ability { id: \"897A\", source: \"Bomb\" }\r\n3204.3 \"Faerie Ring\" Ability { id: \"8973\", source: \"Surprising Staff\" }\r\n\r\n3206.3 \"--targetable--\"\r\n3212.5 \"Shocking Abandon\" Ability { id: \"8965\", source: \"Statice\" }\r\n\r\n3222.7 \"Pinwheeling Dartboard\" Ability { id: \"8CBF\", source: \"Statice\" }\r\n3231.4 \"Fireworks (cast)\" Ability { id: \"897B\", source: \"Statice\" }\r\n3233.4 \"Fire Spread\" Ability { id: \"8952\", source: \"Statice\" } duration 11\r\n3241.3 \"Fireworks\" Ability { id: \"897C\", source: \"Statice\" }\r\n3241.6 \"Uncommon Ground\" Ability { id: \"8971\", source: \"Statice\" }\r\n3253.6 \"Aero IV\" Ability { id: \"8966\", source: \"Statice\" }\r\n\r\n3260.8 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n3266.5 \"Beguiling Glitter\" Ability { id: \"8980\", source: \"Statice\" }\r\n3273.6 \"Trick Reload\" Ability { id: \"8967\", source: \"Statice\" }\r\n3288.4 \"Trapshooting 1\" Ability { id: \"8D1C\", source: \"Statice\" }\r\n3295.5 \"Present Box 2\" Ability { id: \"8972\", source: \"Statice\" }\r\n3302.2 \"Ring a Ring o' Explosions\" Ability { id: \"8979\", source: \"Statice\" }\r\n3309.6 \"Trigger Happy\" Ability { id: \"8968\", source: \"Statice\" }\r\n3310.2 \"Faerie Ring\" Ability { id: \"8973\", source: \"Surprising Staff\" }\r\n3316.5 \"Trapshooting 2\" Ability { id: \"8976\", source: \"Statice\" }\r\n3320.4 \"Burst\" Ability { id: \"897A\", source: \"Bomb\" }\r\n\r\n3327.6 \"Aero IV\" Ability { id: \"8966\", source: \"Statice\" }\r\n3335.7 \"Aero IV\" Ability { id: \"8966\", source: \"Statice\" }\r\n\r\n3338.8 \"--sync--\" StartsUsing { id: \"TODO\", source: \"Statice\" }\r\n3348.8 \"Aero IV Enrage\" Ability { id: \"TODO\", source: \"Statice\" }\r\n\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 8925 Locked and Loaded ability during 8967 Trick Reload when a bullet is in the gun\r\n# 8926 Misload ability during 8967 Trick Reload when a bullet missed the gun oops\r\n# 8927 --sync-- repositioning from Statice\r\n# 8964 --sync-- auto damage from Statice\r\n# 8965 Shocking Abandon cast and tankbuster damage\r\n# 8966 Aero IV cast and raidwide damage\r\n# 8967 Trick Reload self-targeted cast to load gun with 8925/8926\r\n# 8968 Trigger Happy self-targeted cast for limit cut dart board\r\n# 8969 Trigger Happy cast and damage for limit cut dart board (filled pie slice)\r\n# 8927 Surprise Balloon self-targeted cast\r\n# 896B Pop knockback from Surprise Balloon being popped\r\n# 896C Surprise Needle short cast and ability blue line aoe from needle adds that pop balloons\r\n# 8971 Uncommon Ground light damage on people who are not on a dartboard color with Bull's-eye\r\n# 8972 Present Box self-targeted cast for bombs/donuts/missiles/hands\r\n# 8973 Faerie Ring cast and damage for donut rings during Present Box\r\n# 8974 Burst high damage from running into Surprising Missile tethered add\r\n# 8975 Death by Claw high damage from running into Surprising Claw tethered add\r\n# 8976 Trapshooting self-targeted cast after Trick Reload (some instances are 8D1C)\r\n# 8977 Trapshooting stack damage from Trick Reload\r\n# 8978 Trapshooting spread damage from Trick Reload\r\n# 8979 Ring a Ring o' Explosions self-targeted cast for rotating bombs\r\n# 897A Burst cast and damage from bomb explosion\r\n# 897B Fireworks self-targeted cast\r\n# 897C Fireworks two person stack damage during Present Box / Pinwheeling Dartboard\r\n# 897D Fireworks spread damage during Present Box / Pinwheeling Dartboard\r\n# 8980 Beguiling Glitter self-targeted cast to give players Face debuffs\r\n# 896F Fire Spread self-targeted damage for initial rotating fire (from Ball of Fire)\r\n# 8988 Trigger Happy cast and zero damage for limit cut dart board (empty pie slice)\r\n# 89FB Fire Spread ongoing rotating fire damage (from Statice)\r\n# 8A6A --sync-- ability on Bomb when rotating\r\n# TODO Aero IV cast and enrage damage\r\n# TODO Aero IV post-enrage follow-up damage just in case\r\n# 8CBF Pinwheeling Dartboard self-targeted cast to summon dartboard with rotating fire\r\n# 8CC0 Dartboard of Dancing Explosives self-targeted cast for colored dartboard\r\n# 8CC1 Burning Chains damage from not breaking chains\r\n# 8CC3 Uncommon Ground heavy damage on people who are on the same dartboard color with Bull's-eye\r\n# 8D1C Trapshooting self-targeted cast after Trick Reload (some instances are 8976)\r\n\r\n\r\n#~~~~~~~~~#\r\n# TRASH 1 #\r\n#~~~~~~~~~#\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 7A56 --sync-- various auto damage (trash 1)\r\n# 8BCF --sync-- damage from Twister tornados\r\n# 8BC7 Lead Hook casted damage from Kiwakin 3x tankbuster\r\n# 8BC6 Lead Hook damage from hit 2\r\n# 8BC4 Lead Hook damage from hit 3\r\n# 8BCC Water III casted damage from Snipper stack marker\r\n# 8BC8 Sharp Strike casted damage from Kiwakin tank buster with a concussion dot\r\n# 8BC9 Tail Screw casted damage from Kiwakin baited circle\r\n# 8BCA Bubble Shower casted damage from Snipper front conal\r\n# 8BCB Crab Dribble fast casted damage from Snipper back conal after Bubble Shower 8BCA\r\n# 8C4B Hydrocannon casted damage from Ray front line\r\n# 8BCE Expulsion casted damage from Ray \"get out\"\r\n# 8BCD Electric Whorl casted damage from Ray \"get in\"\r\n# 8BD1 Hydroshot casted damage from Monk knockback line with a dot\r\n# 8C4F Cross Attack casted damage from Monk tankbuster\r\n\r\n#~~~~~~~~~#\r\n# TRASH 2 #\r\n#~~~~~~~~~#\r\n\r\n# TODO: does Wood Golem have an enrage??\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 7A58 --sync-- various auto damage (trash 2)\r\n# 8BD4 Ovation cast and damage from Wood Golem front line aoe\r\n# 8C3A Gravity Force cast and stack damage from Islekeeper\r\n# TODO Ancient Quaga cast and damage for Islekeeper raidwide enrage\r\n# 8BD2 Ancient Aero III interruptable cast and damage for Wood Golem raidwide\r\n# 8BD3 Tornado cast and damage from Wood Golem that binds the initial target and heavies all targets\r\n# 8C39 Ancient Quaga cast and damage for Islekeeper raidwide\r\n# 8C3C Isle Drop cast and damage for Islekeeper front circle\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/another_aloalo_island.ts





// TODO: add callout for Monk Hydroshot target
// TODO: sc3 should say which bubble to take to the other side (for everyone)
// TODO: figure out directions for Lala for Radiance orbs
// TODO: map effects for Lala
// TODO: Lala Planar Tactics could add config strats and tell you who to stack with
// TODO: Statice colors could add config strats for role-based colors + melee flex
// Horizontal crystals have a heading of 0, vertical crystals are -pi/2.
const another_aloalo_island_isHorizontalCrystal = line => {
  const epsilon = 0.1;
  return Math.abs(parseFloat(line.heading)) < epsilon;
};
const another_aloalo_island_headmarkerIds = {
  tethers: '0061',
  enumeration: '015B'
};

// TODO: this maybe should be a method on party?
const another_aloalo_island_isStandardLightParty = data => {
  const supports = [...data.party.healerNames, ...data.party.tankNames];
  const dps = data.party.dpsNames;
  return supports.length === 2 && dps.length === 2;
};
const another_aloalo_island_triggerSet = {
  id: 'AnotherAloaloIsland',
  zoneId: zone_id/* default.AnotherAloaloIsland */.Z.AnotherAloaloIsland,
  timelineFile: 'another_aloalo_island.txt',
  initData: () => {
    return {
      combatantData: [],
      ketuSpringCrystalCount: 0,
      ketuCrystalAdd: [],
      ketuHydroBuffCount: 0,
      ketuBuffCollect: [],
      ketuStackTargets: [],
      lalaSubAlpha: [],
      staticeBullet: [],
      staticeTrapshooting: [],
      staticeDart: [],
      staticePresentBoxCount: 0,
      staticeMissileCollect: [],
      staticeMissileIdToDir: {},
      staticeMissileTether: [],
      staticeClawTether: [],
      staticeDartboardTether: []
    };
  },
  timelineTriggers: [{
    id: 'AAI Lala Radiance',
    regex: /^Radiance \d/,
    beforeSeconds: 4,
    alertText: (data, _matches, output) => {
      // TODO: could figure out directions here and say "Point left at NW Orb"
      const dir = data.lalaUnseen;
      if (dir === undefined) return output.orbGeneral();
      return {
        front: output.orbDirFront(),
        back: output.orbDirBack(),
        left: output.orbDirLeft(),
        right: output.orbDirRight()
      }[dir];
    },
    outputStrings: {
      orbDirFront: {
        en: 'Face Towards Orb',
        de: 'Den Orb anschauen',
        fr: 'Pointez l\'orbe',
        cn: '面向球',
        ko: '구슬쪽 보기'
      },
      orbDirBack: {
        en: 'Face Away from Orb',
        de: 'Weg vom Orb schauen',
        fr: 'Ne pointez pas l\'orbe',
        cn: '背对球',
        ko: '뒷면을 구슬쪽으로'
      },
      orbDirLeft: {
        en: 'Point Left at Orb',
        de: 'Zeige links auf den Orb',
        fr: 'Pointez à gauche de l\'orbe',
        cn: '左侧看向球',
        ko: '왼쪽면을 구슬쪽으로'
      },
      orbDirRight: {
        en: 'Point Right at Orb',
        de: 'Zeige Rechts auf den Orb',
        fr: 'Pointez à droite de l\'orbe',
        cn: '右侧看向球',
        ko: '오른쪽면을 구슬쪽으로'
      },
      orbGeneral: {
        en: 'Point opening at Orb',
        de: 'Zeige die Öffnung auf den Orb',
        fr: 'Pointez l\'orbe',
        cn: '开口侧看向球',
        ko: '열린면을 수슬쪽으로'
      }
    }
  }],
  triggers: [
  // ---------------- first trash ----------------
  {
    id: 'AAI Kiwakin Lead Hook',
    type: 'StartsUsing',
    netRegex: {
      id: '8C6E',
      source: 'Aloalo Kiwakin'
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankBusterOnYou: {
          en: '3x Tankbuster on YOU',
          de: '3x Tankbuster auf DIR',
          fr: 'Tankbuster x3 sur VOUS',
          cn: '3x 坦克死刑点名',
          ko: '3x 탱버 대상자'
        },
        tankBusterOnPlayer: {
          en: '3x Tankbuster on ${player}',
          de: '3x Tankbuster auf ${player}',
          fr: 'Tankbuster x3 sur ${player}',
          cn: '3x 坦克死刑点 ${player}',
          ko: '3x 탱버 ${player}'
        }
      };
      if (matches.target === data.me) return {
        alertText: output.tankBusterOnYou()
      };
      const target = data.party.member(matches.target);
      return {
        infoText: output.tankBusterOnPlayer({
          player: target
        })
      };
    }
  }, {
    id: 'AAI Kiwakin Sharp Strike',
    type: 'StartsUsing',
    netRegex: {
      id: '8C63',
      source: 'Aloalo Kiwakin'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AAI Kiwakin Tail Screw',
    type: 'StartsUsing',
    // This is a baited targeted circle.
    netRegex: {
      id: '8BB8',
      source: 'Aloalo Kiwakin',
      capture: false
    },
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'AAI Snipper Water III',
    type: 'StartsUsing',
    netRegex: {
      id: '8C64',
      source: 'Aloalo Snipper'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'AAI Snipper Bubble Shower',
    type: 'StartsUsing',
    netRegex: {
      id: '8BB9',
      source: 'Aloalo Snipper',
      capture: false
    },
    response: responses/* Responses.getBackThenFront */.n3.getBackThenFront()
  }, {
    id: 'AAI Snipper Crab Dribble',
    type: 'Ability',
    // Crab Dribble 8BBA has a fast cast, so trigger on Bubble Shower ability
    netRegex: {
      id: '8BB9',
      source: 'Aloalo Snipper',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.goFront */.n3.goFront('info')
  }, {
    id: 'AAI Ray Hydrocannon',
    type: 'StartsUsing',
    netRegex: {
      id: '8BBD',
      source: 'Aloalo Ray',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'AAI Ray Expulsion',
    type: 'StartsUsing',
    netRegex: {
      id: '8BBF',
      source: 'Aloalo Ray',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'AAI Ray Electric Whorl',
    type: 'StartsUsing',
    netRegex: {
      id: '8BBE',
      source: 'Aloalo Ray',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'AAI Monk Hydroshot',
    type: 'StartsUsing',
    netRegex: {
      id: '8C65',
      source: 'Aloalo Monk'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.knockbackOn */.n3.knockbackOn()
  }, {
    id: 'AAI Monk Cross Attack',
    type: 'StartsUsing',
    netRegex: {
      id: '8BBB',
      source: 'Aloalo Monk'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  },
  // ---------------- Ketuduke ----------------
  {
    id: 'AAI Ketuduke Tidal Roar',
    type: 'StartsUsing',
    netRegex: {
      id: '8AD4',
      source: 'Ketuduke',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'AAI Ketuduke Spring Crystals',
    type: 'StartsUsing',
    netRegex: {
      id: '8AA8',
      source: 'Ketuduke',
      capture: false
    },
    run: data => {
      data.ketuSpringCrystalCount++;
      // Note: cannot clear `data.ketuCrystalAdd` here as there has been at least one case
      // where AddCombatant (coming from memory, so racy) is partially before this cast.
    }
  }, {
    id: 'AAI Ketuduke Spring Crystals Saturate Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: ['8AAB', '8AAC'],
      capture: false
    },
    run: data => data.ketuCrystalAdd = []
  }, {
    id: 'AAI Ketuduke Spring Crystal Collect',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '12607'
    },
    run: (data, matches) => data.ketuCrystalAdd.push(matches)
  }, {
    id: 'AAI Ketuduke Bubble Net',
    type: 'StartsUsing',
    netRegex: {
      id: ['8AC5', '8AAD'],
      source: 'Ketuduke',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'AAI Ketuduke Foamy Fetters Bubble Weave',
    type: 'GainsEffect',
    // ECC = Foamy Fetters
    // E9F = Bubble Weave
    netRegex: {
      effectId: ['ECC', 'E9F']
    },
    delaySeconds: (data, matches) => {
      data.ketuBuffCollect.push(matches);
      return data.ketuBuffCollect.length === 4 ? 0 : 0.5;
    },
    alertText: (data, _matches, output) => {
      if (data.ketuBuffCollect.length === 0) return;
      const myBuff = data.ketuBuffCollect.find(x => x.target === data.me)?.effectId;
      if (myBuff === undefined) return;
      data.ketuBuff = myBuff === 'ECC' ? 'fetters' : 'bubble';
      data.ketuBuffPartner = data.ketuBuffCollect.find(x => {
        return x.target !== data.me && x.effectId === myBuff;
      })?.target;
      const player = data.party.member(data.ketuBuffPartner);

      // To avoid too many calls, we'll call this out later for the Fluke Gale
      // versions of this.
      if (data.ketuSpringCrystalCount === 1 || data.ketuSpringCrystalCount === 4) return;
      if (data.ketuBuff === 'fetters') return output.fetters({
        player: player
      });
      return output.bubble({
        player: player
      });
    },
    run: data => data.ketuBuffCollect = [],
    outputStrings: {
      fetters: {
        en: 'Fetters (w/${player})',
        de: 'Fesseln (mit ${player})',
        fr: 'Entraves (avec ${player})',
        cn: '止步 (和 ${player})',
        ko: '속박 (+ ${player})'
      },
      bubble: {
        en: 'Bubble (w/${player})',
        de: 'Blase (mit ${player})',
        fr: 'Bulles (avec ${player})',
        cn: '泡泡 (和 ${player})',
        ko: '거품 (+ ${player})'
      }
    }
  }, {
    id: 'AAI Ketuduke Hydro Buff Counter',
    type: 'StartsUsing',
    // 8AB8 = Hydrobullet (spread)
    // 8AB4 = Hydrofall (stack)
    netRegex: {
      id: ['8AB8', '8AB4'],
      source: 'Ketuduke',
      capture: false
    },
    run: data => {
      data.ketuHydroBuffCount++;
      delete data.ketuHydroBuffIsSpreadFirst;
      delete data.ketuHydroBuffIsRoleStacks;
    }
  }, {
    id: 'AAI Ketuduke Hydro Buff 1',
    comment: {
      en: `These directions assume that you always pick a square in the same
             quadrant as the crystal specified.
             For brevity, "next to" always means horizontal east/west of something.
             See trigger source for diagrams in comments.`,
      de: `Diese Anweisungen gehen davon aus, dass Sie immer ein Quadrat im gleichen
             Quadranten wie der angegebene Kristall liegt.
             Der Einfachheit halber bedeutet "neben" immer horizontal östlich/westlich von etwas.
             Siehe Triggerquelle für Diagramme in den Kommentaren.`,
      fr: `Ces instructions supposent que vous choisissez toujours une case dans le même
             quadrant que le cristal spécifié.
             Par souci de concision, "à côté de" signifie toujours horizontal
             à l'est ou à l'ouest de quelque chose.
             Voir le déclencheur source pour les diagrammes dans les commentaires.`,
      cn: `这些方向假设你一直选的是同一面向的四块地板方格上的水晶。
             简洁起见，"相邻" 指的是左右水平相邻的某一个水晶。
             请参阅触发器源代码注释中的图表。`,
      ko: `이곳의 방향 지시는 항상 지정된 수정과 같은 사분면에 있는 정사각형을 선택한다고 가정합니다.
             간결성을 위해, '옆'은 항상 무언가의 동쪽/서쪽을 의미합니다.
             트리거 소스코드에 주석으로 작성된 다이어그램을 참고하세요.`
    },
    type: 'StartsUsing',
    netRegex: {
      id: ['8AB8', '8AB4'],
      source: 'Ketuduke'
    },
    condition: data => data.ketuHydroBuffCount === 1 || data.ketuHydroBuffCount === 6,
    durationSeconds: 10,
    alertText: (data, matches, output) => {
      if (data.ketuBuff === undefined) return;
      const isPlayerDPS = data.party.isDPS(data.me);
      const isPartnerDPS = data.ketuBuffPartner !== undefined ? data.party.isDPS(data.ketuBuffPartner) : undefined;
      const isBubbleNetPartnerSameRole = isPlayerDPS === isPartnerDPS && another_aloalo_island_isStandardLightParty(data);

      // Simplify callout in vast majority of cases where there's a normal light party setup
      // and you and the two dps and two supports get the same debuff, so no need to list
      // your partner.
      //
      // Otherwise, if you're doing this nonstandard for some reason or somebody is dead
      // you can know if you need to flex.
      const isSpread = matches.id === '8AB8';
      const bubbleStr = data.ketuBuff === 'bubble' ? output.bubbleBuff() : output.fettersBuff();
      // We don't know about role stacks at this point, as this is just the initial cast bar.
      const stackStr = isSpread ? output.spread() : output.stacks();
      if (isBubbleNetPartnerSameRole || data.ketuBuffPartner === undefined) return output.bubbleNetMech({
        fettersBubble: bubbleStr,
        spreadStack: stackStr
      });
      return output.bubbleNetMechPartner({
        fettersBubble: bubbleStr,
        spreadStack: stackStr,
        player: data.party.member(data.ketuBuffPartner)
      });
    },
    infoText: (data, matches, output) => {
      // If somebody died and missed a debuff, good luck.
      if (data.ketuBuff === undefined) return;

      // Bubble always does the same thing.
      if (data.ketuBuff === 'bubble') return output.bubbleAnything();

      // Two layouts, one with each crystal in its own column ("split")
      // and one with two columns that have an H and a V in that same column ("columns").
      // Wind doesn't matter, as "1" will always be on the horizontal crystals.
      // These can be flipped somewhat, but the solution is always the same.
      // Horizontal crystals are always in lc1 wind, and vertical crystals are always
      // in lc2 wind. Players with bubbles always go either (1) adjacent to a horizontal
      // crystal OR (2) diagonal of a vertical crystal. Either one works, but it
      // depends on how you split your priorities / wind which one you'd take.
      //
      // Legend: V = vertical crystal, H = horizontal crystal
      //         1 = limit cut wind 1, 2 = limit cut wind 2
      //         f = fetters, b = bubble (if placed in lc1)
      //
      // STACK FETTERS COLUMNS (kitty to horizontal)
      //     2                   2
      //   + - - - - +         + - - - - +
      //   | V     f | 1       |     H f | 1
      //   |     H b |    =>   |     V   |
      //   | H b     |         | V       |
      // 1 |   f V   |       1 | H f     |
      //   + - - - - +         + - - - - +
      //           2                   2
      //
      // STACK FETTERS SPLIT (on horizontal)
      //           2                   2
      //   + - - - - +         + - - - - +
      // 1 |     V   |       1 |   V     |
      //   | H b     |    =>   | f H     |
      //   |   V     |         |     V   |
      //   |     b H | 1       |     H f | 1
      //   + - - - - +         + - - - - +
      //     2                   2
      //
      // SPREAD FETTERS COLUMNS (adjacent to vertical)
      //     2                   2
      //   + - - - - +         + - - - - +
      //   | V f     | 1       |   f H b | 1
      //   |     H b |    =>   |     V   |
      //   | H b     |         | V       |
      // 1 |     V f |       1 | H b   f |
      //   + - - - - +         + - - - - +
      //           2                   2
      //
      // SPREAD FETTERS SPLIT (kitty to vertical)
      //     2                   2
      //   + - - - - +         + - - - - +
      //   |   V     | 1       |     V   | 1
      //   | f   b H |    =>   | f   H b |
      //   |     V   |         |   V     |
      // 1 | H b   f |       1 | b H   f |
      //   + - - - - +         + - - - - +
      //           2                   2

      const isSpread = matches.id === '8AB8';
      const horizontal = data.ketuCrystalAdd.filter(x => another_aloalo_island_isHorizontalCrystal(x));
      const vertical = data.ketuCrystalAdd.filter(x => !another_aloalo_island_isHorizontalCrystal(x));
      const [firstHorizontal] = horizontal;
      if (horizontal.length !== 2 || vertical.length !== 2 || firstHorizontal === undefined) return;
      const firstHorizX = parseFloat(firstHorizontal.x);
      // It's split if no vertical is in the same column as either horizontal.
      const isSplitLayout = vertical.find(line => Math.abs(parseFloat(line.x) - firstHorizX) < 1) === undefined;
      if (isSpread) return isSplitLayout ? output.fettersSpreadSplit() : output.fettersSpreadColumn();
      return isSplitLayout ? output.fettersStackSplit() : output.fettersStackColumn();
    },
    outputStrings: {
      bubbleNetMech: {
        en: '${fettersBubble} + ${spreadStack}',
        de: '${fettersBubble} + ${spreadStack}',
        fr: '${fettersBubble} + ${spreadStack}',
        cn: '${fettersBubble} + ${spreadStack}',
        ko: '${fettersBubble} + ${spreadStack}'
      },
      bubbleNetMechPartner: {
        en: '${fettersBubble} + ${spreadStack} (w/${player})',
        de: '${fettersBubble} + ${spreadStack} (mit ${player})',
        fr: '${fettersBubble} + ${spreadStack} (avec ${player})',
        cn: '${fettersBubble} + ${spreadStack} (和 ${player})',
        ko: '${fettersBubble} + ${spreadStack} (+ ${player})'
      },
      bubbleBuff: {
        en: 'Bubble',
        de: 'Blase',
        fr: 'Bulle',
        cn: '泡泡',
        ko: '거품'
      },
      fettersBuff: {
        en: 'Fetters',
        de: 'Ketten',
        fr: 'Entraves',
        cn: '止步',
        ko: '속박'
      },
      spread: outputs/* default.spread */.Z.spread,
      stacks: {
        en: 'Stacks',
        de: 'Sammeln',
        fr: 'Package',
        cn: '分摊',
        ko: '쉐어'
      },
      bubbleAnything: {
        en: 'Diagonal of Vertical / Next to Horizontal ',
        de: 'Diagonale der Vertikalen / Neben Horizontal',
        fr: 'Diagonale de la verticale / À côté de l\'horizontale',
        cn: '竖水晶对角线 / 左右相邻的横水晶',
        ko: '세로 수정의 대각선 / 가로 수정의 옆'
      },
      fettersSpreadSplit: {
        en: 'Diagonal of Vertical',
        de: 'Diagonale der Vertikalen',
        fr: 'Diagonale de la verticale',
        cn: '竖水晶对角线',
        ko: '세로 수정의 대각선'
      },
      fettersSpreadColumn: {
        en: 'Next to Vertical',
        de: 'Neben Vertikal',
        fr: 'À côté de la verticale',
        cn: '左右相邻的竖水晶',
        ko: '가로 수정의 옆'
      },
      fettersStackSplit: {
        en: 'On Horizontal',
        de: 'Auf Horizontal',
        fr: 'Sur l\'horizontale',
        cn: '横水晶上',
        ko: '가로 수정이 있는 곳'
      },
      fettersStackColumn: {
        en: 'Diagonal of Horizontal',
        de: 'Diagonale der Horizontalen',
        fr: 'Diagonale de l\'horizontale',
        cn: '横水晶对角线',
        ko: '가로 수정의 대각선'
      }
    }
  }, {
    id: 'AAI Ketuduke Hydro Buff Double',
    type: 'StartsUsing',
    netRegex: {
      id: ['8AB8', '8AB4'],
      source: 'Ketuduke'
    },
    condition: data => data.ketuHydroBuffCount === 2 || data.ketuHydroBuffCount === 5,
    alertText: (data, matches, output) => {
      data.ketuHydroBuffIsSpreadFirst = matches.id === '8AB8';
      return data.ketuHydroBuffIsSpreadFirst ? output.spread() : output.stacks();
    },
    outputStrings: {
      spread: {
        en: 'Spread => Stacks',
        de: 'Verteilen => Sammeln',
        fr: 'Écarté => Package',
        cn: '分散 => 分摊',
        ko: '산개 => 쉐어'
      },
      stacks: {
        en: 'Stacks => Spread',
        de: 'Sammeln => Verteilen',
        fr: 'Package => Écarté',
        cn: '分摊 => 分散',
        ko: '쉐어 => 산개'
      }
    }
  }, {
    id: 'AAI Ketuduke Hydro Buff Double Followup',
    type: 'Ability',
    netRegex: {
      id: ['8ABA', '8AB7'],
      source: 'Ketuduke'
    },
    suppressSeconds: 10,
    infoText: (data, matches, output) => {
      const wasSpread = matches.id === '8ABA';
      if (wasSpread && data.ketuHydroBuffIsSpreadFirst === true) {
        if (data.ketuHydroBuffIsRoleStacks) return output.roleStacks();
        return output.stacks();
      } else if (!wasSpread && data.ketuHydroBuffIsSpreadFirst === false) {
        return output.spread();
      }
    },
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread,
      stacks: {
        en: 'Stacks',
        de: 'Sammeln',
        fr: 'Package',
        cn: '分摊',
        ko: '쉐어'
      },
      roleStacks: {
        en: 'Role Stacks',
        de: 'Rollengruppe sammeln',
        fr: 'Package par rôle',
        cn: '职能分摊',
        ko: '역할별 쉐어'
      }
    }
  }, {
    id: 'AAI Ketuduke Hydrofall Role Stack Warning',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'EA3'
    },
    delaySeconds: (data, matches) => {
      data.ketuStackTargets.push(matches.target);
      return data.ketuStackTargets.length === 2 ? 0 : 0.5;
    },
    alarmText: (data, _matches, output) => {
      const [stack1, stack2] = data.ketuStackTargets;
      if (data.ketuStackTargets.length !== 2 || stack1 === undefined || stack2 === undefined) return;

      // Sorry, non-standard light party comps.
      if (!another_aloalo_island_isStandardLightParty(data)) return;
      const isStack1DPS = data.party.isDPS(stack1);
      const isStack2DPS = data.party.isDPS(stack2);

      // If both stacks are on dps or neither stack is on a dps, then you have
      // standard "partner" stacks of one support and one dps. If one is on a dps
      // and one is on a support (which can happen if somebody dies), then
      // you (probably) need to have role stacks.
      if (isStack1DPS === isStack2DPS) return;
      data.ketuHydroBuffIsRoleStacks = true;

      // Handle Blowing Bubbles/Angry Seas spread+stack combo.
      if (data.ketuHydroBuffIsSpreadFirst === true) return output.spreadThenRoleStacks();else if (data.ketuHydroBuffIsSpreadFirst === false) return output.roleStacksThenSpread();
      return output.roleStacks();
    },
    run: data => data.ketuStackTargets = [],
    outputStrings: {
      roleStacks: {
        en: 'Role Stacks',
        de: 'Rollengruppe sammeln',
        fr: 'Package par rôle',
        cn: '职能分摊',
        ko: '역할별 쉐어'
      },
      spreadThenRoleStacks: {
        en: 'Spread => Role Stacks',
        de: 'Verteilen => Rollengruppe sammeln',
        fr: 'Écarté => Package par rôle',
        cn: '分散 => 职能分摊',
        ko: '산개 => 역할별 쉐어'
      },
      roleStacksThenSpread: {
        en: 'Role Stacks => Spread',
        de: 'Rollengruppe sammeln => Verteilen',
        fr: 'Package par rôle => Écarté',
        cn: '职能分摊 => 分散',
        ko: '역할별 쉐어 => 산개'
      }
    }
  }, {
    id: 'AAI Ketuduke Receding Twintides',
    type: 'StartsUsing',
    netRegex: {
      id: '8ACC',
      source: 'Ketuduke',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.ketuHydroBuffIsRoleStacks) return output.outInRoleStacks();
      return output.outInStacks();
    },
    run: data => data.ketuTwintidesNext = 'in',
    outputStrings: {
      outInStacks: {
        en: 'Out => In + Stacks',
        de: 'Raus => Rein + sammeln',
        fr: 'Extérieur => Intérieur + Package',
        cn: '远离 => 靠近 + 分摊',
        ko: '밖 => 안 + 쉐어'
      },
      outInRoleStacks: {
        en: 'Out => In + Role Stacks',
        de: 'Raus => Rein + Rollengruppe sammeln',
        fr: 'Extérieur => Intérieur + Package par rôle',
        cn: '远离 => 靠近 + 职能分摊',
        ko: '밖 => 안 + 역할별 쉐어'
      }
    }
  }, {
    id: 'AAI Ketuduke Encroaching Twintides',
    type: 'StartsUsing',
    netRegex: {
      id: '8ACE',
      source: 'Ketuduke',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.ketuHydroBuffIsRoleStacks) return output.inOutRoleStacks();
      return output.inOutStacks();
    },
    run: data => data.ketuTwintidesNext = 'out',
    outputStrings: {
      inOutStacks: {
        en: 'In => Out + Stacks',
        de: 'Rein => Raus + sammeln',
        fr: 'Intérieur => Extérieur + Package',
        cn: '靠近 => 远离 + 分摊',
        ko: '안 => 밖 + 쉐어'
      },
      inOutRoleStacks: {
        en: 'In => Out + Role Stacks',
        de: 'Rein => Raus + Rollengruppe sammeln',
        fr: 'Intérieur => Extérieur + Package par rôle',
        cn: '靠近 => 远离 + 职能分摊',
        ko: '안 => 밖 + 역할별 쉐어'
      }
    }
  }, {
    id: 'AAI Ketuduke Twintides Followup',
    type: 'Ability',
    // 8ABC = Sphere Shatter, which happens slightly after the Twintides hit.
    // You can technically start moving along the safe Sphere Shatter side 0.5s earlier
    // after the initial out/in, but this is hard to explain.
    netRegex: {
      id: '8ABC',
      source: 'Ketuduke',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      const mech = data.ketuTwintidesNext;
      if (mech === undefined) return;
      const mechStr = output[mech]();
      const stackStr = data.ketuHydroBuffIsRoleStacks ? output.roleStacks() : output.stack();
      return output.text({
        inOut: mechStr,
        stack: stackStr
      });
    },
    run: data => delete data.ketuTwintidesNext,
    outputStrings: {
      text: {
        en: '${inOut} + ${stack}',
        de: '${inOut} + ${stack}',
        fr: '${inOut} + ${stack}',
        cn: '${inOut} + ${stack}',
        ko: '${inOut} + ${stack}'
      },
      in: outputs/* default.in */.Z["in"],
      out: outputs/* default.out */.Z.out,
      stack: {
        en: 'Stacks',
        de: 'Sammeln',
        fr: 'Package',
        cn: '分摊',
        ko: '쉐어'
      },
      roleStacks: {
        en: 'Role Stacks',
        de: 'Rollengruppe sammeln',
        fr: 'Package par rôle',
        cn: '职能分摊',
        ko: '역할별 쉐어'
      }
    }
  }, {
    id: 'AAI Ketuduke Spring Crystals 2',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '12607',
      capture: false
    },
    condition: data => data.ketuSpringCrystalCount === 2 && data.ketuCrystalAdd.length === 4,
    // We could call this absurdly early, but knowing this doesn't help with anything
    // until you know what your debuff is, so move it later both so it is less absurd
    // futuresight and so you don't have to remember it as long.
    delaySeconds: 5,
    alertText: (data, _matches, output) => {
      const horizontal = data.ketuCrystalAdd.filter(x => another_aloalo_island_isHorizontalCrystal(x));
      const vertical = data.ketuCrystalAdd.filter(x => !another_aloalo_island_isHorizontalCrystal(x));
      if (horizontal.length !== 2 || vertical.length !== 2) return;

      // Crystal positions are always -15, -5, 5, 15.

      // Check if any verticals are on the outer vertical edges.
      for (const line of vertical) {
        const y = parseFloat(line.y);
        if (y < -10 || y > 10) return output.eastWestSafe();
      }

      // Check if any horizontals are on the outer horizontal edges.
      for (const line of horizontal) {
        const x = parseFloat(line.x);
        if (x < -10 || x > 10) return output.northSouthSafe();
      }
      return output.cornersSafe();
    },
    outputStrings: {
      northSouthSafe: {
        en: 'North/South',
        de: 'Norden/Süden',
        fr: 'Nord/Sud',
        cn: '上(北)/下(南)',
        ko: '북/남'
      },
      eastWestSafe: {
        en: 'East/West',
        de: 'Osten/Westen',
        fr: 'Est/Ouest',
        cn: '左(西)/右(东)',
        ko: '동/서'
      },
      cornersSafe: {
        en: 'Corners',
        de: 'Ecken',
        fr: 'Coins',
        cn: '四角',
        ko: '구석'
      }
    }
  }, {
    id: 'AAI Ketuduke Angry Seas',
    type: 'StartsUsing',
    netRegex: {
      id: '8AC1',
      source: 'Ketuduke',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.ketuHydroBuffIsSpreadFirst) return output.knockbackSpread();
      if (data.ketuHydroBuffIsRoleStacks) return output.knockbackRoleStacks();
      return output.knockbackStacks();
    },
    outputStrings: {
      knockbackSpread: {
        en: 'Knockback => Spread',
        de: 'Rückstoß => verteilen',
        fr: 'Pousée => Écartez-vous',
        cn: '击退 => 分散',
        ko: '넉백 => 산개'
      },
      knockbackStacks: {
        en: 'Knockback => Stacks',
        de: 'Rückstoß => sammeln',
        fr: 'Poussée => Package',
        cn: '击退 => 分摊',
        ko: '넉백 => 쉐어'
      },
      knockbackRoleStacks: {
        en: 'Knockback => Role Stacks',
        de: 'Rückstoß => Rollengruppe sammeln',
        fr: 'Poussée => Package par rôle',
        cn: '击退 => 职能分摊',
        ko: '넉백 => 역할별 쉐어'
      }
    }
  },
  // ---------------- second trash ----------------
  {
    id: 'AAI Wood Golem Ancient Aero III',
    type: 'StartsUsing',
    netRegex: {
      id: '8C4C',
      source: 'Aloalo Wood Golem'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt('alarm')
  }, {
    id: 'AAI Wood Golem Tornado',
    type: 'StartsUsing',
    netRegex: {
      id: '8C4D',
      source: 'Aloalo Wood Golem'
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tornadoOn: {
          en: 'Away from ${player}',
          de: 'Weg von ${player}',
          fr: 'Loin de ${player}',
          cn: '远离 ${player}',
          ko: '${player}에게서 떨어지기'
        },
        tornadoOnYou: {
          en: 'Tornado on YOU',
          de: 'Tornado auf DIR',
          fr: 'Tornade sur VOUS',
          cn: '龙卷风点名',
          ko: '토네이도 대상자'
        }
      };
      if (data.me === matches.target) return {
        alertText: output.tornadoOnYou()
      };
      return {
        infoText: output.tornadoOn({
          player: data.party.member(matches.target)
        })
      };
    }
  }, {
    id: 'AAI Wood Golem Tornado Bind',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'EC0'
    },
    condition: data => data.CanCleanse(),
    infoText: (data, matches, output) => {
      return output.text({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Cleanse ${player}',
        de: 'Reinige ${player}',
        fr: 'Guérissez ${player}',
        cn: '康复 ${player}',
        ko: '${player} 디버프 해제'
      }
    }
  }, {
    id: 'AAI Wood Golem Ovation',
    type: 'StartsUsing',
    netRegex: {
      id: '8BC1',
      source: 'Aloalo Wood Golem',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind('info')
  }, {
    id: 'AAI Islekeeper Gravity Force',
    type: 'StartsUsing',
    netRegex: {
      id: '8BC5',
      source: 'Aloalo Islekeeper'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'AAI Islekeeper Isle Drop',
    type: 'StartsUsing',
    netRegex: {
      id: '8C6F',
      source: 'Aloalo Islekeeper',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Behind + Out',
        de: 'Geh nach Hinten + Raus',
        fr: 'Derrière + Extérieur',
        cn: '去背后 + 远离',
        ko: '뒤로 + 밖으로'
      }
    }
  }, {
    id: 'AAI Islekeeper Ancient Quaga',
    type: 'StartsUsing',
    netRegex: {
      id: '8C4E',
      source: 'Aloalo Islekeeper',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'AAI Islekeeper Ancient Quaga Enrage',
    type: 'StartsUsing',
    netRegex: {
      id: '8C2F',
      source: 'Aloalo Islekeeper',
      capture: false
    },
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Islekeeper!',
        de: 'Wächter besiegen!',
        fr: 'Tuez le gardien !',
        cn: '击杀 Islekeeper' // FIXME: correct name
      }
    }
  },
  // ---------------- Lala ----------------
  {
    id: 'AAI Lala Inferno Theorem',
    type: 'StartsUsing',
    netRegex: {
      id: '88AE',
      source: 'Lala',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'AAI Lala Rotation Tracker',
    type: 'HeadMarker',
    netRegex: {
      id: ['01E4', '01E5'],
      target: 'Lala'
    },
    run: (data, matches) => data.lalaBossRotation = matches.id === '01E4' ? 'clock' : 'counter'
  }, {
    id: 'AAI Lala Angular Addition Tracker',
    type: 'Ability',
    netRegex: {
      id: ['8889', '8D2E'],
      source: 'Lala'
    },
    run: (data, matches) => data.lalaBossTimes = matches.id === '8889' ? 3 : 5
  }, {
    id: 'AAI Lala Arcane Blight',
    type: 'StartsUsing',
    netRegex: {
      id: ['888B', '888C', '888D', '888E'],
      source: 'Lala'
    },
    alertText: (data, matches, output) => {
      const initialDir = {
        '888B': 2,
        // initial back safe
        '888C': 0,
        // initial front safe
        '888D': 1,
        // initial right safe
        '888E': 3 // initial left safe
      }[matches.id];
      if (initialDir === undefined) return;
      if (data.lalaBossTimes === undefined) return;
      if (data.lalaBossRotation === undefined) return;
      const rotationFactor = data.lalaBossRotation === 'clock' ? 1 : -1;
      const finalDir = (initialDir + rotationFactor * data.lalaBossTimes + 8) % 4;
      const diff = (finalDir - initialDir + 4) % 4;
      if (diff !== 1 && diff !== 3) return;
      return {
        0: output.front(),
        1: output.right(),
        2: output.back(),
        3: output.left()
      }[finalDir];
    },
    run: data => {
      delete data.lalaBossTimes;
      delete data.lalaBossRotation;
    },
    outputStrings: {
      front: outputs/* default.front */.Z.front,
      back: outputs/* default.back */.Z.back,
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'AAI Lala Analysis Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E8E', 'E8F', 'E90', 'E91']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      const effectMap = {
        'E8E': 'front',
        'E8F': 'back',
        'E90': 'right',
        'E91': 'left'
      };
      data.lalaUnseen = effectMap[matches.effectId];
    }
  }, {
    id: 'AAI Lala Times Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E89', 'ECE']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      const effectMap = {
        'E89': 3,
        'ECE': 5
      };
      data.lalaPlayerTimes = effectMap[matches.effectId];
    }
  }, {
    id: 'AAI Lala Player Rotation Collect',
    type: 'HeadMarker',
    netRegex: {
      id: ['01ED', '01EE']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      const idMap = {
        '01ED': 'counter',
        '01EE': 'clock'
      };
      data.lalaPlayerRotation = idMap[matches.id];
    }
  }, {
    id: 'AAI Lala Targeted Light',
    type: 'StartsUsing',
    netRegex: {
      id: '8CDE',
      source: 'Lala',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const initialUnseen = data.lalaUnseen;
      if (initialUnseen === undefined) return;
      const initialDir = {
        front: 0,
        right: 1,
        back: 2,
        left: 3
      }[initialUnseen];
      const rotation = data.lalaPlayerRotation;
      if (rotation === undefined) return;
      const times = data.lalaPlayerTimes;
      if (times === undefined) return;

      // The safe spot rotates, so the player counter-rotates.
      const rotationFactor = rotation === 'clock' ? -1 : 1;
      const finalDir = (initialDir + rotationFactor * times + 8) % 4;
      return {
        0: output.front(),
        1: output.right(),
        2: output.back(),
        3: output.left()
      }[finalDir];
    },
    run: data => {
      delete data.lalaUnseen;
      delete data.lalaPlayerTimes;
    },
    outputStrings: {
      front: {
        en: 'Face Towards Lala',
        de: 'Lala anschauen',
        fr: 'Regardez Lala',
        cn: '面向拉拉',
        ko: '라라 쳐다보기'
      },
      back: {
        en: 'Look Away from Lala',
        de: 'Von Lala weg schauen',
        fr: 'Ne regardez pas Lala',
        cn: '背对拉拉',
        ko: '라라에게서 뒤돌기'
      },
      left: {
        en: 'Left Flank towards Lala',
        de: 'Linke Seite zu Lala zeigen',
        fr: 'Flanc gauche vers Lala',
        cn: '左侧朝向拉拉',
        ko: '왼쪽면을 라라쪽으로'
      },
      right: {
        en: 'Right Flank towards Lala',
        de: 'Rechte Seite zu Lala zeigen',
        fr: 'Flanc droit vers Lala',
        cn: '右侧朝向拉拉',
        ko: '오른쪽면을 라라쪽으로'
      }
    }
  }, {
    id: 'AAI Lala Strategic Strike',
    type: 'StartsUsing',
    netRegex: {
      id: '88AD',
      source: 'Lala'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AAI Lala Planar Tactics',
    type: 'GainsEffect',
    // E8B = Surge Vector
    // E8C = Subtractive Suppressor Alpha
    netRegex: {
      effectId: ['E8C', 'E8B']
    },
    condition: (data, matches) => {
      data.lalaSubAlpha.push(matches);
      return data.lalaSubAlpha.length === 6;
    },
    durationSeconds: 7,
    // Only run once, as Surge Vector is used again.
    suppressSeconds: 9999999,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        one: {
          en: 'One',
          de: 'Eins',
          fr: 'Un',
          cn: '1',
          ko: '1'
        },
        bigTwo: {
          en: 'Two (stack with three)',
          de: 'Zwei (sammeln mit Drei)',
          fr: 'Deux (Pack avec Trois)',
          cn: '2 (和3分摊)',
          ko: '2 (3과 쉐어)'
        },
        smallTwo: {
          en: 'Two (stack with one)',
          de: 'Zwei (sammeln mit Eins)',
          fr: 'Deux (Pack avec Un',
          cn: '2 (和1分摊)',
          ko: '2 (1과 쉐어)'
        },
        eitherTwo: {
          en: 'Either Two (w/${player})',
          de: 'Eine Zwei (mit ${player})',
          fr: 'Un des deux (avec ${player})',
          cn: '2 (和 ${player})',
          ko: '2 (+ ${player})'
        },
        three: {
          en: 'Three',
          de: 'Drei',
          fr: 'Trois',
          cn: '3',
          ko: '3'
        },
        // This is just a raidcall so you can direct your friends.
        smallTwoOn: {
          en: '(Two with one: ${players})',
          de: '(Zwei mit Eins: ${players})',
          fr: '(Deux avec Un : ${players})',
          cn: '(2和1: ${players})',
          ko: '(2+1: ${players})'
        },
        unknownNum: {
          en: '${num}',
          de: '${num}',
          fr: '${num}',
          cn: '${num}',
          ko: '${num}'
        },
        num1: outputs/* default.num1 */.Z.num1,
        num2: outputs/* default.num2 */.Z.num2,
        num3: outputs/* default.num3 */.Z.num3,
        num4: outputs/* default.num4 */.Z.num4
      };

      // For brevity, this code calls "small two" the two that stacks with one
      // and the "big two" the two that stacks with three.
      const stacks = data.lalaSubAlpha.filter(x => x.effectId === 'E8B').map(x => x.target);
      const nums = data.lalaSubAlpha.filter(x => x.effectId === 'E8C');
      const myNumberStr = nums.find(x => x.target === data.me)?.count;
      if (myNumberStr === undefined) return;
      const myNumber = parseInt(myNumberStr);
      if (myNumber < 1 || myNumber > 4) return;
      const defaultOutput = {
        alertText: output.unknownNum({
          num: output[`num${myNumber}`]()
        })
      };
      if (stacks.length !== 2 || nums.length !== 4) return defaultOutput;
      const one = nums.find(x => parseInt(x.count) === 1)?.target;
      if (one === undefined) return defaultOutput;
      const isOneStack = stacks.includes(one);
      const twos = nums.filter(x => parseInt(x.count) === 2).map(x => x.target);
      const smallTwos = [];
      for (const thisTwo of twos) {
        // can this two stack with the one?
        const isThisTwoStack = stacks.includes(thisTwo);
        if (isThisTwoStack && !isOneStack || !isThisTwoStack && isOneStack) smallTwos.push(thisTwo);
      }
      const [smallTwo1, smallTwo2] = smallTwos;
      if (smallTwos.length === 0 || smallTwo1 === undefined) return defaultOutput;
      const isPlayerSmallTwo = smallTwos.includes(data.me);

      // Worst case adjust
      if (isPlayerSmallTwo && smallTwo2 !== undefined) {
        const otherPlayer = smallTwo1 === data.me ? smallTwo2 : smallTwo1;
        return {
          alarmText: output.eitherTwo({
            player: data.party.member(otherPlayer)
          })
        };
      }
      let playerRole;
      if (one === data.me) {
        playerRole = output.one();
      } else if (twos.includes(data.me)) {
        playerRole = isPlayerSmallTwo ? output.smallTwo() : output.bigTwo();
      } else {
        playerRole = output.three();
      }
      if (isPlayerSmallTwo) return {
        alertText: playerRole
      };
      return {
        alertText: playerRole,
        infoText: output.smallTwoOn({
          players: smallTwos.map(x => data.party.member(x))
        })
      };
    }
  }, {
    id: 'AAI Lala Forward March',
    type: 'GainsEffect',
    // E83 = Forward March
    netRegex: {
      effectId: 'E83'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 8,
    durationSeconds: 4,
    alertText: (data, _matches, output) => {
      const rotation = data.lalaPlayerRotation;
      if (rotation === undefined) return;
      const times = data.lalaPlayerTimes;
      if (times === undefined) return;
      const rotationFactor = rotation === 'clock' ? 1 : -1;
      const finalDir = (rotationFactor * times + 8) % 4;
      if (finalDir === 1) return output.left();
      if (finalDir === 3) return output.right();
    },
    run: data => {
      delete data.lalaPlayerRotation;
      delete data.lalaPlayerTimes;
    },
    outputStrings: {
      left: {
        en: 'Leftward March',
        de: 'Linker March',
        fr: 'Marche à gauche',
        cn: '强制移动: 左',
        ko: '강제이동: 왼쪽'
      },
      right: {
        en: 'Rightward March',
        de: 'Rechter March',
        fr: 'Marche à droite',
        cn: '强制移动: 右',
        ko: '강제이동: 오른쪽'
      }
    }
  }, {
    id: 'AAI Lala Spatial Tactics',
    type: 'GainsEffect',
    // E8D = Subtractive Suppressor Beta
    netRegex: {
      effectId: 'E8D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 999999,
    alertText: (_data, matches, output) => {
      const num = parseInt(matches.count);
      if (num < 1 || num > 4) return;
      return output[`num${num}`]();
    },
    outputStrings: {
      num1: {
        en: 'One (avoid all)',
        de: 'Eins (alles ausweichen)',
        fr: 'Un (Évitez tout)',
        cn: '1 (远离全部)',
        ko: '1 (전부 피하기)'
      },
      num2: {
        en: 'Two (stay middle)',
        de: 'Zwei (steh in der Mitte)',
        fr: 'Deux (Restez au centre)',
        cn: '2 (待在中间)',
        ko: '2 (중앙에 머물기)'
      },
      num3: {
        en: 'Three (adjacent to middle)',
        de: 'Drei (steh neben der Mitte)',
        fr: 'Trois (adjacent au centre)',
        cn: '3 (中间相邻)',
        ko: '3 (중앙에서 옆 칸)'
      },
      num4: {
        en: 'Four',
        de: 'Vier',
        fr: 'Quatre',
        cn: '4'
      }
    }
  },
  // ---------------- Statice ----------------
  {
    id: 'AAI Statice Aero IV',
    type: 'StartsUsing',
    netRegex: {
      id: '8949',
      source: 'Statice',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'AAI Statice Trick Reload',
    type: 'Ability',
    // 8925 = Locked and Loaded
    // 8926 = Misload
    netRegex: {
      id: ['8925', '8926'],
      source: 'Statice'
    },
    preRun: (data, matches) => data.staticeBullet.push(matches),
    alertText: (data, _matches, output) => {
      // Statice loads 8 bullets, two are duds.
      // The first and the last are always opposite, and one of them is a dud.
      // The first/ last bullets are for Trapshooting and the middle six are for Trigger Happy.
      const [bullet] = data.staticeBullet;
      if (data.staticeBullet.length !== 1 || bullet === undefined) return;
      const isStack = bullet.id === '8926';
      data.staticeTrapshooting = isStack ? ['stack', 'spread'] : ['spread', 'stack'];
      return isStack ? output.stackThenSpread() : output.spreadThenStack();
    },
    infoText: (data, _matches, output) => {
      const lastBullet = data.staticeBullet[data.staticeBullet.length - 1];
      if (data.staticeBullet.length < 2 || data.staticeBullet.length > 7) return;
      if (lastBullet?.id !== '8926') return;
      data.staticeTriggerHappy = data.staticeBullet.length - 1;
      return output.numSafeLater({
        num: output[`num${data.staticeTriggerHappy}`]()
      });
    },
    run: data => {
      if (data.staticeBullet.length === 8) data.staticeBullet = [];
    },
    outputStrings: {
      stackThenSpread: outputs/* default.stackThenSpread */.Z.stackThenSpread,
      spreadThenStack: outputs/* default.spreadThenStack */.Z.spreadThenStack,
      numSafeLater: {
        en: '(${num} safe later)',
        de: '(${num} später sicher)',
        fr: '(${num} sûr ensuite)',
        cn: '(稍后 ${num} 安全)',
        ko: '(나중에 ${num} 안전)'
      },
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      num5: outputs/* default.num5 */.Z.num5,
      num6: outputs/* default.num6 */.Z.num6
    }
  }, {
    id: 'AAI Statice Trapshooting',
    type: 'StartsUsing',
    netRegex: {
      id: ['8D1A', '8959'],
      source: 'Statice',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const mech = data.staticeTrapshooting.shift();
      if (mech === undefined) return;
      return output[mech]();
    },
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread,
      stack: outputs/* default.stackMarker */.Z.stackMarker
    }
  }, {
    id: 'AAI Statice Trigger Happy',
    type: 'StartsUsing',
    netRegex: {
      id: '894B',
      source: 'Statice',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const num = data.staticeTriggerHappy;
      if (num === undefined) return;
      return output[`num${num}`]();
    },
    run: data => delete data.staticeTriggerHappy,
    outputStrings: {
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      num5: outputs/* default.num5 */.Z.num5,
      num6: outputs/* default.num6 */.Z.num6
    }
  }, {
    id: 'AAI Statice Bull\'s-eye',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'E9E'
    },
    delaySeconds: (data, matches) => {
      // Note: this collects for the pinwheeling dartboard version too.
      data.staticeDart.push(matches);
      return data.staticeDart.length === 3 ? 0 : 0.5;
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        dartOnYou: {
          en: 'Dart on YOU',
          de: 'Dart auf DIR',
          fr: 'Dard sur VOUS',
          cn: '飞镖点名',
          ko: '다트 대상자'
        },
        noDartOnYou: {
          en: 'No Dart',
          de: 'Kein Dart',
          fr: 'Pas de Dard',
          cn: '无飞镖',
          ko: '다트 없음'
        },
        flexCall: {
          en: '(${player} unmarked)',
          de: '(${player} unmarkiert)',
          fr: '(${player} non-marqué)',
          cn: '(${player} 无标记)',
          ko: '(${player} 다트 없음)'
        }
      };
      if (data.staticeIsPinwheelingDartboard) return;
      if (data.staticeDart.length === 0) return;
      const dartTargets = data.staticeDart.map(x => x.target);
      if (!dartTargets.includes(data.me)) return {
        alertText: output.noDartOnYou()
      };
      const partyNames = data.party.partyNames;
      const flexers = partyNames.filter(x => !dartTargets.includes(x));
      const [flex] = flexers;
      const flexPlayer = flexers.length === 1 ? data.party.member(flex) : undefined;
      return {
        alertText: output.dartOnYou(),
        infoText: output.flexCall({
          player: flexPlayer
        })
      };
    },
    run: data => data.staticeDart = []
  }, {
    id: 'AAI Statice Surprise Balloon Reminder',
    // This is an early reminder for the following Trigger Happy with knockback.
    // However, because there's a tight window to immuune both knockbacks,
    // call this ~15s early (in case anybody forgot).
    type: 'StartsUsing',
    netRegex: {
      id: '894D',
      source: 'Statice',
      capture: false
    },
    infoText: (data, _matches, output) => {
      const num = data.staticeTriggerHappy;
      if (num === undefined) return;
      // We'll re-call this out with the knockback warning.
      // However, also clear `data.staticeTriggerHappy` to avoid double callouts.
      data.staticePopTriggerHappyNum = num;
      return output.numSafeSoon({
        num: output[`num${num}`]()
      });
    },
    run: data => delete data.staticeTriggerHappy,
    outputStrings: {
      numSafeSoon: {
        en: '(${num} safe soon)',
        de: '(${num} gleich sicher)',
        fr: '(${num} bientôt sûr',
        cn: '(很快 ${num} 安全)',
        ko: '(나중에 ${num} 안전)'
      },
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      num5: outputs/* default.num5 */.Z.num5,
      num6: outputs/* default.num6 */.Z.num6
    }
  }, {
    id: 'AAI Statice Pop',
    type: 'StartsUsing',
    // TODO: this might need a slight delay
    netRegex: {
      id: '894E',
      source: 'Statice',
      capture: false
    },
    suppressSeconds: 20,
    alertText: (data, _matches, output) => {
      const num = data.staticePopTriggerHappyNum;
      if (num === undefined) return output.knockback();
      const numStr = output[`num${num}`]();
      return output.knockbackToNum({
        num: numStr
      });
    },
    run: data => delete data.staticePopTriggerHappyNum,
    outputStrings: {
      knockbackToNum: {
        en: 'Knockback => ${num}',
        de: 'Rückstoß => ${num}',
        fr: 'Poussée => ${num}',
        cn: '击退 => ${num}',
        ko: '넉백 => ${num}'
      },
      knockback: outputs/* default.knockback */.Z.knockback,
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      num5: outputs/* default.num5 */.Z.num5,
      num6: outputs/* default.num6 */.Z.num6
    }
  }, {
    id: 'AAI Statice Face',
    type: 'GainsEffect',
    // DD2 = Forward March
    // DD3 = About Face
    // DD4 = Left Face
    // DD5 = Right Face
    netRegex: {
      effectId: ['DD2', 'DD3', 'DD4', 'DD5']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 7,
    durationSeconds: 5,
    alertText: (data, matches, output) => {
      let mech = output.unknown();
      const num = data.staticeTriggerHappy;
      if (num !== undefined) {
        mech = output[`num${num}`]();
        delete data.staticeTriggerHappy;
      } else {
        const mechName = data.staticeTrapshooting.shift();
        mech = mechName === undefined ? output.unknown() : output[mechName]();
      }
      return {
        'DD2': output.forward({
          mech: mech
        }),
        'DD3': output.backward({
          mech: mech
        }),
        'DD4': output.left({
          mech: mech
        }),
        'DD5': output.right({
          mech: mech
        })
      }[matches.effectId];
    },
    outputStrings: {
      forward: {
        en: 'Forward March => ${mech}',
        de: 'Vorwärtsmarsch => ${mech}',
        fr: 'Marche en avant => ${mech}',
        cn: '强制移动：前 => ${mech}',
        ko: '강제이동: 앞 => ${mech}'
      },
      backward: {
        en: 'Backward March => ${mech}',
        de: 'Rückwärtsmarsch => ${mech}',
        fr: 'Marche en arrière => ${mech}',
        cn: '强制移动：后 => ${mech}',
        ko: '강제이동: 뒤 => ${mech}'
      },
      left: {
        en: 'Left March => ${mech}',
        de: 'Marsch Links => ${mech}',
        fr: 'Marche à gauche => ${mech}',
        cn: '强制移动：左 => ${mech}',
        ko: '강제이동: 왼쪽 => ${mech}'
      },
      right: {
        en: 'Right March => ${mech}',
        de: 'Marsch Rechts => ${mech}',
        fr: 'Marche à droite => ${mech}',
        cn: '强制移动：右 => ${mech}',
        ko: '강제이동: 오른쪽 => ${mech}'
      },
      spread: outputs/* default.spread */.Z.spread,
      stack: outputs/* default.stackMarker */.Z.stackMarker,
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      num5: outputs/* default.num5 */.Z.num5,
      num6: outputs/* default.num6 */.Z.num6,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'AAI Statice Present Box Counter',
    // This happens ~1s prior to ActorControlExtra on bomb.
    type: 'StartsUsing',
    netRegex: {
      id: '8955',
      source: 'Statice',
      capture: false
    },
    run: data => data.staticePresentBoxCount++
  }, {
    id: 'AAI Statice Present Box Missile',
    type: 'Tether',
    netRegex: {
      source: 'Surprising Missile',
      id: '0011'
    },
    delaySeconds: (data, matches) => {
      data.staticeMissileTether.push(matches);
      return data.staticeMissileTether.length === 2 ? 0 : 0.5;
    },
    durationSeconds: 7,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        missileOnYou: {
          en: 'Bait Tethers => Missile Spread',
          de: 'Verbindungen ködern => Verteilen mit Raketen',
          fr: 'Attirez les liens => Écartez les missiles',
          cn: '引导拉线 => 导弹分散',
          ko: '사슬 유도 => 미사일 산개'
        }
      };
      if (data.staticeMissileTether.length !== 2) return;
      const missileTether = data.staticeMissileTether.find(x => x.target === data.me);
      if (missileTether === undefined) return;
      return {
        alertText: output.missileOnYou()
      };
    },
    run: data => data.staticeMissileTether = []
  }, {
    id: 'AAI Statice Present Box Claw',
    type: 'Tether',
    netRegex: {
      source: 'Surprising Claw',
      id: '0011'
    },
    delaySeconds: (data, matches) => {
      data.staticeClawTether.push(matches);
      return data.staticeClawTether.length === 2 ? 0 : 0.5;
    },
    durationSeconds: 7,
    alertText: (data, _matches, output) => {
      if (data.staticeClawTether.length !== 2) return;
      if (!data.staticeClawTether.map(x => x.target).includes(data.me)) return;
      return output.stack();
    },
    run: data => data.staticeClawTether = [],
    outputStrings: {
      stack: {
        en: 'Juke Claw => Stack',
        de: 'Zieh Klaue => Sammeln',
        fr: 'Griffe => Package',
        cn: '爪子连线 => 分摊',
        ko: '손아귀 => 쉐어'
      }
    }
  }, {
    id: 'AAI Statice Burning Chains',
    type: 'GainsEffect',
    netRegex: {
      effectId: '301'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // TODO: add a strategy for dart colors and say where to go here
    // for the Pinwheeling Dartboard if you have a dart.
    response: responses/* Responses.breakChains */.n3.breakChains()
  }, {
    id: 'AAI Statice Shocking Abandon',
    type: 'StartsUsing',
    netRegex: {
      id: '8948',
      source: 'Statice'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AAI Statice Pinwheeling Dartboard Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: '8CBC',
      source: 'Statice',
      capture: false
    },
    run: data => data.staticeIsPinwheelingDartboard = true
  }, {
    id: 'AAI Statice Pinwheeling Dartboard Color',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '12507'
    },
    durationSeconds: 6,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        dartOnYou: {
          en: 'Dart (w/${player})',
          de: 'Dart (mit ${player})',
          fr: 'Dard (avec ${player})',
          cn: '飞镖 (和 ${player})',
          ko: '다트 (+ ${player})'
        },
        noDartOnYou: {
          en: 'No Dart',
          de: 'Kein Dart',
          fr: 'Pas de dard',
          cn: '无飞镖',
          ko: '다트 없음'
        },
        blue: {
          en: 'Avoid Blue',
          de: 'Vermeide Blau',
          fr: 'Évitez le bleu',
          cn: '躲避蓝色',
          ko: '파란색 피하기'
        },
        red: {
          en: 'Avoid Red',
          de: 'Vermeide Rot',
          fr: 'Évitez le rouge',
          cn: '躲避红色',
          ko: '빨간색 피하기'
        },
        yellow: {
          en: 'Avoid Yellow',
          de: 'Vermeide Gelb',
          fr: 'Évitez le jaune',
          cn: '躲避黄色',
          ko: '노란색 피하기'
        }
      };
      let infoText;
      const centerX = -200;
      const centerY = 0;
      const x = parseFloat(matches.x) - centerX;
      const y = parseFloat(matches.y) - centerY;

      // 12 pie slices, the edge of the first one is directly north.
      // It goes in B R Y order repeating 4 times.
      // The 0.5 subtraction (12 - 0.5 = 11.5) is because the Homing Pattern
      // lands directly in the middle of a slice.
      const dir12 = Math.round(6 - 6 * Math.atan2(x, y) / Math.PI + 11.5) % 12;
      const colorOffset = dir12 % 3;
      const colorMap = {
        0: 'blue',
        1: 'red',
        2: 'yellow'
      };
      data.staticeHomingColor = colorMap[colorOffset];
      if (data.staticeHomingColor !== undefined) infoText = output[data.staticeHomingColor]();
      if (data.staticeDart.length !== 2) return {
        infoText
      };
      const dartTargets = data.staticeDart.map(x => x.target);
      if (!dartTargets.includes(data.me)) return {
        alertText: output.noDartOnYou(),
        infoText: infoText
      };
      const [target1, target2] = dartTargets;
      if (target1 === undefined || target2 === undefined) return {
        infoText
      };
      const otherTarget = data.party.member(target1 === data.me ? target2 : target1);
      return {
        alertText: output.dartOnYou({
          player: otherTarget
        }),
        infoText: infoText
      };
    }
  }, {
    id: 'AAI Statice Pinwheeling Dartboard Mech',
    type: 'HeadMarker',
    netRegex: {
      id: another_aloalo_island_headmarkerIds.tethers
    },
    condition: data => data.staticeIsPinwheelingDartboard,
    delaySeconds: (data, matches) => {
      data.staticeDartboardTether.push(matches);
      return data.staticeDartboardTether.length === 2 ? 0 : 0.5;
    },
    alertText: (data, _matches, output) => {
      if (data.staticeDartboardTether.length !== 2) return;
      const tethers = data.staticeDartboardTether.map(x => x.target);
      if (tethers.includes(data.me)) {
        const [tether1, tether2] = tethers;
        const other = data.party.member(tether1 === data.me ? tether2 : tether1);
        return output.tether({
          player: other
        });
      }
      const partyNames = data.party.partyNames;
      const nonTethers = partyNames.filter(x => !tethers.includes(x));
      const [stack1, stack2] = nonTethers;
      const other = data.party.member(stack1 === data.me ? stack2 : stack1);
      return output.stack({
        player: other
      });
    },
    run: data => data.staticeDartboardTether = [],
    outputStrings: {
      // TODO: maybe this should remind you of dart color
      tether: {
        en: 'Tether w/${player}',
        de: 'Verbindung mit ${player}',
        fr: 'Lien avec ${player}',
        cn: '连线 和 ${player}',
        ko: '사슬 +${player}'
      },
      stack: {
        en: 'Stack w/${player}',
        de: 'Sammeln mit ${player}',
        fr: 'Package avec ${player}',
        cn: '分摊 和 ${player}',
        ko: '쉐어 +${player}'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Far Tide/Near Tide': 'Far/Near Tide',
      'Hydrobullet/Hydrofall': 'Hydrobullet/fall',
      'Hydrofall/Hydrobullet': 'Hydrofall/bullet',
      'Receding Twintides/Encroaching Twintides': 'Receding/Encroaching Twintides'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Aloalo Golem': 'Aloalo-Holzgolem',
      'Aloalo Islekeeper': 'Aloalo-Wächter',
      'Aloalo Kiwakin': 'Aloalo-Kiwakin',
      'Aloalo Monk': 'Aloalo-Mönch',
      'Aloalo Ray': 'Aloalo-Rochen',
      'Aloalo Snipper': 'Aloalo-Schnippler',
      'Aloalo Wood Golem': 'Aloalo-Holzgolem',
      'Aloalo Zaratan': 'Aloalo-Zaratan',
      'Arcane Font': 'arkan(?:e|er|es|en) Körper',
      'Arcane Globe': 'arkan(?:e|er|es|en) Kugel',
      'Ball of Fire': 'Feuerkugel',
      'Bomb': 'Bombe',
      'Ketuduke': 'Ketuduke',
      'Lala': 'Lala',
      'Needle': 'Nadel',
      'Spring Crystal': 'Wasserquell-Kristall',
      'Statice': 'Statice',
      'Surprising Claw': 'Überraschungsklaue',
      'Surprising Missile': 'Überraschungsrakete',
      'Surprising Staff': 'Überraschungsstab',
      'The Dawn Trial': 'Morgenrot-Probe',
      'The Dusk Trial': 'Abendrot-Probe',
      'The Midnight Trial': 'Vollmond-Probe'
    },
    'replaceText': {
      '\\(buff\\)': '(Statusveränderung)',
      '\\(cast\\)': '(wirken)',
      'Aero II': 'Windra',
      'Aero IV': 'Windka',
      'Analysis': 'Analyse',
      'Angry Seas': 'Zornige Fluten',
      'Angular Addition': 'Winkeladdition',
      'Arcane Array': 'Arkanes Spektrum',
      'Arcane Blight': 'Arkane Fäule',
      'Arcane Mine': 'Arkane Mine',
      'Arcane Plot': 'Arkane Flur',
      'Arcane Point': 'Arkane Stätte',
      'Beguiling Glitter': 'Irrleuchten',
      'Blowing Bubbles': 'Pusteblasen',
      'Bright Pulse': 'Glühen',
      'Bubble Net': 'Blasennetz',
      'Burning Chains': 'Brennende Ketten',
      'Burst': 'Explosion',
      'Constructive Figure': 'Ruf der Schöpfer',
      'Dartboard of Dancing Explosives': 'Darts und Drehung',
      'Encroaching Twintides': 'Ring der Zwiegezeiten',
      'Explosive Theorem': 'Arkane Fäule',
      'Faerie Ring': 'Feenring',
      'Far Tide': 'Ring der Gezeiten',
      'Fire Spread': 'Brandstiftung',
      'Fireworks': 'Feuerwerk',
      'Fluke Gale': 'Flossensturm',
      'Fluke Typhoon': 'Flossentaifun',
      'Hundred Lashings': 'Auspeitschung',
      'Hydrobomb': 'Hydro-Bombe',
      'Hydrobullet': 'Hydro-Kugel',
      'Hydrofall': 'Hydro-Sturz',
      'Inferno Divide': 'Infernale Teilung',
      'Inferno Theorem': 'Infernales Theorem',
      'Locked and Loaded': 'Geladen und entsichert',
      'Misload': 'Fehlladung',
      'Near Tide': 'Kreis der Gezeiten',
      'Pinwheeling Dartboard': 'Darts und Rad',
      'Planar Tactics': 'Flächentaktiken',
      'Pop': 'Platzen',
      'Powerful Light': 'Entladenes Licht',
      'Present Box': 'Geschenkschachtel',
      'Radiance': 'Radiation',
      'Receding Twintides': 'Kreis der Zwiegezeiten',
      'Ring a Ring o\' Explosions': 'Ringel-Ringel-Bombe',
      '(?<! )Roar': 'Brüllen',
      'Saturate': 'Wasserfontäne',
      'Shocking Abandon': 'Schockende Hingabe',
      'Spatial Tactics': 'Raumtaktiken',
      'Sphere Shatter': 'Sphärensplitterung',
      'Spring Crystals': 'Quellkristalle',
      'Strategic Strike': 'Schwere Attacke',
      'Strewn Bubbles': 'Streublasen',
      'Surprise Balloon': 'Überraschungsballon',
      'Surprise Needle': 'Überraschungsnadel',
      'Symmetric Surge': 'Symmetrischer Schub',
      'Targeted Light': 'Gezieltes Licht',
      'Telluric Theorem': 'Tellurisches Theorem',
      'Tidal Roar': 'Schrei der Gezeiten',
      'Trapshooting': 'Tontaubenschuss',
      'Trick Reload': 'Trickladung',
      'Trigger Happy': 'Schießwut',
      'Uncommon Ground': 'Voll ins Schwarze',
      'Updraft': 'Aufwind'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aloalo Golem': 'golem sylvestre d\'Aloalo',
      'Aloalo Islekeeper': 'gardien d\'Aloalo',
      'Aloalo Kiwakin': 'kiwakin d\'Aloalo',
      'Aloalo Monk': 'moine d\'Aloalo',
      'Aloalo Ray': 'raie rayée d\'Aloalo',
      'Aloalo Snipper': 'cisailleur d\'Aloalo',
      'Aloalo Wood Golem': 'golem sylvestre d\'Aloalo',
      'Aloalo Zaratan': 'zaratan d\'Aloalo',
      'Arcane Font': 'sphère arcanique',
      'Arcane Globe': 'globe arcanique',
      'Ball of Fire': 'orbe de feu',
      'Bomb': 'bombe',
      'Ketuduke': 'Ketuduke',
      'Lala': 'Lala',
      'Needle': 'aiguille',
      'Spring Crystal': 'cristal de source',
      'Statice': 'Statice',
      'Surprising Claw': 'griffe surprise',
      'Surprising Missile': 'missile surprise',
      'Surprising Staff': 'sceptre surprise',
      'The Dawn Trial': 'Épreuve de Dilumu',
      'The Dusk Trial': 'Épreuve de Qurupe',
      'The Midnight Trial': 'Épreuve de Nokosero'
    },
    'replaceText': {
      '\\(buff\\)': '(Buff)',
      '\\(cast\\)': '(Incantation)',
      'Aero II': 'Extra Vent',
      'Aero IV': 'Giga Vent',
      'Analysis': 'Analyse',
      'Angry Seas': 'Mer agitée',
      'Angular Addition': 'Calcul angulaire',
      'Arcane Array': 'Assemblement arcanique',
      'Arcane Blight': 'Canon arcanique',
      'Arcane Mine': 'Mine arcanique',
      'Arcane Plot': 'Modulateur arcanique',
      'Arcane Point': 'Pointe arcanique',
      'Beguiling Glitter': 'Paillettes aveuglantes',
      'Blowing Bubbles': 'Bulles soufflées',
      'Bright Pulse': 'Éclat',
      'Bubble Net': 'Filet de bulles',
      'Burning Chains': 'Chaînes brûlantes',
      'Burst': 'Explosion',
      'Constructive Figure': 'Icône articulée',
      'Dartboard of Dancing Explosives': 'Duo fléchettes-tourbillon',
      'Encroaching Twintides': 'Double marée débordante',
      'Explosive Theorem': 'Théorème explosif',
      'Faerie Ring': 'Cercle féérique',
      'Far Tide': 'Marée lointaine',
      'Fire Spread': 'Nappe de feu',
      'Fireworks': 'Feu d\'artifice',
      'Fluke Gale': 'Bourrasque hasardeuse',
      'Fluke Typhoon': 'Typhon hasardeux',
      'Hundred Lashings': 'Cent coups de fouet',
      'Hydrobomb': 'Hydrobombe',
      'Hydrobullet': 'Barillet hydrique',
      'Hydrofall': 'Pilonnage hydrique',
      'Inferno Divide': 'Division infernale',
      'Inferno Theorem': 'Théorème infernal',
      'Locked and Loaded': 'Rechargement réussi',
      'Misload': 'Rechargement raté',
      'Near Tide': 'Marée proche',
      'Pinwheeling Dartboard': 'Duo fléchettes-moulinette',
      'Planar Tactics': 'Tactique planaire',
      'Pop': 'Rupture',
      'Powerful Light': 'Explosion sacrée',
      'Present Box': 'Boîtes cadeaux',
      'Radiance': 'Irradiation',
      'Receding Twintides': 'Double marée fuyante',
      'Ring a Ring o\' Explosions': 'Tempérament explosif',
      '(?<! )Roar': 'Rugissement',
      'Saturate': 'Jet d\'eau',
      'Shocking Abandon': 'Choc renonciateur',
      'Spatial Tactics': 'Tactique spatiale',
      'Sphere Shatter': 'Rupture glacée',
      'Spring Crystals': 'Cristaux de source',
      'Strategic Strike': 'Coup violent',
      'Strewn Bubbles': 'Bulles éparpillées',
      'Surprise Balloon': 'Ballons surprises',
      'Surprise Needle': 'Aiguille surprise',
      'Symmetric Surge': 'Déferlement symétrique',
      'Targeted Light': 'Rayon ciblé',
      'Telluric Theorem': 'Théorème tellurique',
      'Tidal Roar': 'Vague rugissante',
      'Trapshooting': 'Tir au pigeon',
      'Trick Reload': 'Rechargement habile',
      'Trigger Happy': 'Gâchette impulsive',
      'Uncommon Ground': 'Terrain de mésentente',
      'Updraft': 'Courants ascendants'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aloalo Golem': 'アロアロ・ウッドゴーレム',
      'Aloalo Islekeeper': 'アロアロ・キーパー',
      'Aloalo Kiwakin': 'アロアロ・キワキン',
      'Aloalo Monk': 'アロアロ・モンク',
      'Aloalo Ray': 'アロアロ・ストライプレイ',
      'Aloalo Snipper': 'アロアロ・スニッパー',
      'Aloalo Wood Golem': 'アロアロ・ウッドゴーレム',
      'Aloalo Zaratan': 'アロアロ・ザラタン',
      'Arcane Font': '立体魔法陣',
      'Arcane Globe': '球体魔法陣',
      'Ball of Fire': '火球',
      'Bomb': '爆弾',
      'Ketuduke': 'ケトゥドゥケ',
      'Lala': 'ララ',
      'Needle': 'ニードル',
      'Spring Crystal': '湧水のクリスタル',
      'Statice': 'スターチス',
      'Surprising Claw': 'サプライズ・クロー',
      'Surprising Missile': 'サプライズ・ミサイル',
      'Surprising Staff': 'サプライズ・ロッド',
      'The Dawn Trial': 'ディルムの試練',
      'The Dusk Trial': 'クルペの試練',
      'The Midnight Trial': 'ノコセロの試練'
    },
    'replaceText': {
      'Aero II': 'エアロラ',
      'Aero IV': 'エアロジャ',
      'Analysis': 'アナライズ',
      'Angry Seas': 'アングリーシーズ',
      'Angular Addition': '回転角乗算',
      'Arcane Array': '複合魔紋',
      'Arcane Blight': '魔紋砲',
      'Arcane Mine': '地雷魔紋',
      'Arcane Plot': '変光魔紋',
      'Arcane Point': '変光起爆',
      'Beguiling Glitter': '惑わしの光',
      'Blowing Bubbles': 'バブルブロワー',
      'Bright Pulse': '閃光',
      'Bubble Net': 'バブルネットフィーディング',
      'Burning Chains': '炎の鎖',
      'Burst': '爆発',
      'Constructive Figure': '人形召喚',
      'Dartboard of Dancing Explosives': 'ダーツ＆ローテーション',
      'Encroaching Twintides': 'リング・ダブルタイド',
      'Explosive Theorem': '魔爆法',
      'Faerie Ring': 'フェアリーリング',
      'Far Tide': 'リングタイド',
      'Fire Spread': '放火',
      'Fireworks': 'ファイアワークフェスティバル',
      'Fluke Gale': 'フリッパーゲイル',
      'Fluke Typhoon': 'フリッパータイフーン',
      'Hundred Lashings': 'めった打ち',
      'Hydrobomb': 'ハイドロボム',
      'Hydrobullet': 'ハイドロバレット',
      'Hydrofall': 'ハイドロフォール',
      'Inferno Divide': '十火法',
      'Inferno Theorem': '散火法',
      'Locked and Loaded': 'リロード成功',
      'Misload': 'リロード失敗',
      'Near Tide': 'ラウンドタイド',
      'Pinwheeling Dartboard': 'ダーツ＆ウィール',
      'Planar Tactics': '爆雷戦術：面',
      'Pop': '破裂',
      'Powerful Light': '光爆',
      'Present Box': 'プレゼントボックス',
      'Radiance': '光球爆散',
      'Receding Twintides': 'ラウンド・ダブルタイド',
      'Ring a Ring o\' Explosions': 'リンクリンクボム',
      '(?<! )Roar': '咆哮',
      'Saturate': '放水',
      'Shocking Abandon': 'アバンドンショック',
      'Spatial Tactics': '爆雷戦術：立体',
      'Sphere Shatter': '破裂',
      'Spring Crystals': '湧水のクリスタル',
      'Strategic Strike': '強撃',
      'Strewn Bubbles': 'バブルストゥルー',
      'Surprise Balloon': 'サプライズバルーン',
      'Surprise Needle': 'サプライズニードル',
      'Symmetric Surge': '双数爆撃',
      'Targeted Light': '高精度光弾',
      'Telluric Theorem': '地隆法',
      'Tidal Roar': 'タイダルロア',
      'Trapshooting': 'トラップシューティング',
      'Trick Reload': 'トリックリロード',
      'Trigger Happy': 'トリガーハッピー',
      'Uncommon Ground': 'グラウンドシアー',
      'Updraft': '上昇気流'
    }
  }]
};
/* harmony default export */ const another_aloalo_island = (another_aloalo_island_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/another_aloalo_island.txt
const dungeon_another_aloalo_island_namespaceObject = "### ANOTHER ALOALO ISLAND\r\n# ZoneId: 49B\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~~#\r\n# KETUDUKE #\r\n#~~~~~~~~~~#\r\n\r\n# -p 8AD4:1015.2\r\n# -ii 8AA7 8AD5 8AAE 8AB9 8AB6 8AD1 8ABE 8ABF 8AC9 8ACB 8AC0 8AAA 8AA9 8AC6 8AC8 8AC3 8A82 8A83\r\n\r\n# The Dawn Trial will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1146\" } window 10000,0\r\n1010.2 \"--sync--\" StartsUsing { id: \"8AD4\", source: \"Ketuduke\" } window 20,20\r\n1015.2 \"Tidal Roar\" Ability { id: \"8AD4\", source: \"Ketuduke\" }\r\n\r\n1022.0 \"--middle--\" Ability { id: \"8A77\", source: \"Ketuduke\" }\r\n1027.0 \"Spring Crystals 1\" Ability { id: \"8AA8\", source: \"Ketuduke\" }\r\n1034.0 \"Bubble Net\" Ability { id: \"8AAD\", source: \"Ketuduke\" }\r\n1041.0 \"Hydrobullet/Hydrofall (buff)\" Ability { id: [\"8AB8\", \"8AB4\"], source: \"Ketuduke\" }\r\n1050.0 \"Fluke Gale (cast)\" Ability { id: \"8AB1\", source: \"Ketuduke\" }\r\n1060.0 \"Fluke Gale 1\" Ability { id: \"8AB2\", source: \"Ketuduke\" }\r\n1062.0 \"Fluke Gale 2\" Ability { id: \"8AB3\", source: \"Ketuduke\" }\r\n1065.0 \"Saturate\" Ability { id: \"8AAC\", source: \"Spring Crystal\" }\r\n1065.1 \"Hydrobullet/Hydrofall\" Ability { id: [\"8ABA\", \"8AB7\"], source: \"Ketuduke\" }\r\n\r\n1074.0 \"Hydrofall/Hydrobullet (buff)\" Ability { id: [\"8AB4\", \"8AB8\"], source: \"Ketuduke\" }\r\n1077.1 \"Hydrobullet/Hydrofall (buff)\" Ability { id: [\"8C6D\", \"8AB5\"], source: \"Ketuduke\" }\r\n1084.3 \"Blowing Bubbles\" Ability { id: \"8ABD\", source: \"Ketuduke\" }\r\n1091.4 \"Hydrobomb x3\" Ability { id: \"8AD0\", source: \"Ketuduke\" }\r\n1096.3 \"Hydrofall/Hydrobullet\" Ability { id: [\"8AB7\", \"8ABA\"], source: \"Ketuduke\" }\r\n1099.6 \"Hydrobomb x3\" Ability { id: \"8AD0\", source: \"Ketuduke\" }\r\n1102.5 \"Hydrobullet/Hydrobullet\" Ability { id: [\"8ABA\", \"8AB7\"], source: \"Ketuduke\" }\r\n\r\n1113.6 \"Hydrofall (buff)\" Ability { id: \"8AB4\", source: \"Ketuduke\" }\r\n1118.9 \"Strewn Bubbles\" Ability { id: \"8ABB\", source: \"Ketuduke\" }\r\n1130.3 \"Receding Twintides/Encroaching Twintides\" Ability { id: [\"8ACC\", \"8ACE\"], source: \"Ketuduke\" }\r\n1130.9 \"Sphere Shatter 1\" Ability { id: \"8ABC\", source: \"Ketuduke\" }\r\n1133.4 \"Far Tide/Near Tide\" Ability { id: [\"8ACF\", \"8ACD\"], source: \"Ketuduke\" }\r\n1134.0 \"Sphere Shatter 2\" Ability { id: \"8ABC\", source: \"Ketuduke\" }\r\n1134.0 \"Hydrofall\" Ability { id: \"8AB7\", source: \"Ketuduke\" }\r\n\r\n1143.7 \"Hydrobullet (buff)\" Ability { id: \"8AB8\", source: \"Ketuduke\" }\r\n1149.7 \"Roar\" Ability { id: \"8AC4\", source: \"Ketuduke\" }\r\n1154.6 \"Spring Crystals 2\" Ability { id: \"8AA8\", source: \"Ketuduke\" }\r\n1164.6 \"Bubble Net\" Ability { id: \"8AC5\", source: \"Ketuduke\" }\r\n1177.0 \"Hydrobullet\" Ability { id: \"8ABA\", source: \"Ketuduke\" }\r\n1177.6 \"Saturate\" Ability { id: \"8AAC\", source: \"Spring Crystal\" }\r\n1182.7 \"Updraft\" Ability { id: \"8AC7\", source: \"Ketuduke\" }\r\n1184.1 \"Hundred Lashings\" Ability { id: \"8ACA\", source: \"Aloalo Zaratan\" }\r\n\r\n1190.7 \"--middle--\" Ability { id: \"8A77\", source: \"Ketuduke\" }\r\n1199.4 \"Hydrofall/Hydrobullet (buff)\" Ability { id: [\"8AB4\", \"8AB8\"], source: \"Ketuduke\" }\r\n1202.4 \"Hydrobullet/Hydrofall (buff)\" Ability { id: [\"8C6D\", \"8AB5\"], source: \"Ketuduke\" }\r\n1210.4 \"Angry Seas\" Ability { id: \"8AC1\", source: \"Ketuduke\" }\r\n1211.6 \"Hydrofall/Hydrobullet\" Ability { id: [\"8AB7\", \"8ABA\"], source: \"Ketuduke\" }\r\n1212.2 \"Hydrobullet/Hydrobullet\" Ability { id: [\"8ABA\", \"8AB7\"] } # this sometimes has the wrong source\r\n1214.8 \"Spring Crystals 3\" Ability { id: \"8AA8\", source: \"Ketuduke\" }\r\n1216.8 \"Hydrobullet\" Ability { id: \"8ABA\", source: \"Ketuduke\" }\r\n1221.8 \"Bubble Net\" Ability { id: \"8AAD\", source: \"Ketuduke\" }\r\n1227.8 \"Fluke Typhoon (cast)\" Ability { id: \"8AAF\", source: \"Ketuduke\" }\r\n1233.8 \"Fluke Typhoon\" Ability { id: \"8AB0\", source: \"Ketuduke\" }\r\n1236.4 \"Saturate\" Ability { id: \"8AAB\", source: \"Spring Crystal\" }\r\n1238.8 \"Burst x4\" Ability { id: \"8AC2\", source: \"Ketuduke\" }\r\n\r\n1246.7 \"Spring Crystals 4\" Ability { id: \"8AA8\", source: \"Ketuduke\" }\r\n1253.7 \"Bubble Net\" Ability { id: \"8AAD\", source: \"Ketuduke\" }\r\n1260.7 \"Hydrobullet/Hydrofall (buff)\" Ability { id: [\"8AB8\", \"8AB4\"], source: \"Ketuduke\" }\r\n1269.8 \"Fluke Gale (cast)\" Ability { id: \"8AB1\", source: \"Ketuduke\" }\r\n1279.9 \"Fluke Gale 1\" Ability { id: \"8AB2\", source: \"Ketuduke\" }\r\n1281.9 \"Fluke Gale 2\" Ability { id: \"8AB3\", source: \"Ketuduke\" }\r\n1284.9 \"Saturate\" Ability { id: \"8AAC\", source: \"Spring Crystal\" }\r\n1285.0 \"Hydrobullet/Hydrofall\" Ability { id: [\"8ABA\", \"8AB7\"], source: \"Ketuduke\" }\r\n\r\n1293.9 \"Hydrofall (buff)\" Ability { id: \"8AB4\", source: \"Ketuduke\" }\r\n1299.2 \"Strewn Bubbles\" Ability { id: \"8ABB\", source: \"Ketuduke\" }\r\n1310.6 \"Receding Twintides/Encroaching Twintides\" Ability { id: [\"8ACC\", \"8ACE\"], source: \"Ketuduke\" }\r\n1311.2 \"Sphere Shatter 1\" Ability { id: \"8ABC\", source: \"Ketuduke\" }\r\n1313.7 \"Far Tide/Near Tide\" Ability { id: [\"8ACF\", \"8ACD\"], source: \"Ketuduke\" }\r\n1314.3 \"Sphere Shatter 2\" Ability { id: \"8ABC\", source: \"Ketuduke\" }\r\n1314.3 \"Hydrofall\" Ability { id: \"8AB7\", source: \"Ketuduke\" }\r\n1325.0 \"Tidal Roar\" Ability { id: \"8AD4\", source: \"Ketuduke\" }\r\n\r\n1331.8 \"--sync--\" StartsUsing { id: \"8AD6\", source: \"Ketuduke\" }\r\n1341.8 \"Tidal Roar Enrage\" Ability { id: \"8AD6\", source: \"Ketuduke\" }\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 8A77 --sync-- Ketuduke repositioning\r\n# 8A82 Riptide ability on players from Angry Seas Airy Bubble when you step in one\r\n# 8A83 Fetters ability on players from Angry Seas Airy Bubble when you step in one after 8A82 Riptide\r\n# 8AA7 --sync-- auto damage from Ketuduke\r\n# 8AA8 Spring Crystals cast and ability to summon Spring Crystal adds (all flavors)\r\n# 8AA9 衝撃 self-targeted ability from Spring Crystal orbs\r\n# 8AAA 衝撃 self-targeted ability from Spring Crystal rupees\r\n# 8AAB Saturate cast and damage from Spring Crystal orb circle\r\n# 8AAC Saturate cast and damage from Spring Crystal rupee line laser\r\n# 8AAD Bubble Net self-targeted cast before Bubbles along with 8AAE during Spring Crystals 1\r\n# 8AAE Bubble Net cast and ability on players that adds Bubbles/Fetters debuffs during Spring Crystals 1\r\n# 8AAF Fluke Typhoon self-targeted cast before 8AB0 knockback during Spring Crystals 3\r\n# 8AB0 Fluke Typhoon cast and knockback ability on Spring Crystal and players during Spring Crystals 3\r\n# 8AB1 Fluke Gale self-targeted cast that adds limit cut winds\r\n# 8AB2 Fluke Gale cast and ability for limit cut 1 wind\r\n# 8AB3 Fluke Gale cast and ability for limit cut 2 wind\r\n# 8AB4 Hydrofall self-targeted cast that adds stack markers\r\n# 8AB5 Hydrofall self-targeted \"stack second\" ability before Blowing Bubbles\r\n# 8AB6 Hydrofall ability on players that adds stack debuffs\r\n# 8AB7 Hydrofall damage from stack debuffs\r\n# 8AB8 Hydrobullet self-targeted cast that adds stack markers\r\n# 8AB9 Hydrobullet ability on players that adds spread debuffs\r\n# 8ABA Hydrobullet damage from spread debuffs\r\n# 8ABB Strewn Bubbles self-targeted cast before 8ABC Sphere Shatter moving arches\r\n# 8ABC Sphere Shatter damage from moving arches\r\n# 8ABD Blowing Bubbles self-targeted cast that adds Airy Bubble Adds\r\n# 8ABE Riptide ability on players from Blowing Bubbles Airy Bubble when you step in one\r\n# 8ABF Fetters ability on players from Blowing Bubbles Airy Bubble when you step in one after 8ABE Riptide\r\n# 8AC0 Angry Seas self-targeted cast for 8AC1 red line knockback\r\n# 8AC1 Angry Seas cast and knockback damage from red line\r\n# 8AC2 Burst tower damage\r\n# 8AC3 Big Burst tower failure damage\r\n# 8AC4 Roar self-targeted cast that summons Zaratan adds\r\n# 8AC5 Bubble Net self-targeted cast before Bubbles along with 8AC6 during Spring Crystals 2\r\n# 8AC6 Bubble Net cast and ability on players that adds Bubbles/Fetters debuffs during Spring Crystals 2\r\n# 8AC7 Updraft self-targeted cast to boost adds and players into the air\r\n# 8AC8 Updraft ability on players for 8AC7 Updraft\r\n# 8AC9 Hundred Lashings cast and damage for non-bubbled Zaratan 180 cleave (no damage on bubbled players)\r\n# 8ACA Hundred Lashings self-targeted cast for bubbled Zaratan adds\r\n# 8ACB Hundred Lashings cast and damage for bubbled Zaratan 180 cleave (no damage on non-bubbled players)\r\n# 8ACC Receding Twintides cast and damage for initial out during out->in\r\n# 8ACD Near Tide fast cast and damage for second out during in->out with 8ACE Encroaching Twintides\r\n# 8ACE Encroaching Twintides cast and damage for initial in during in->out\r\n# 8ACF Far Tide fast cast and damage for second in during out->in with 8ACC Receding Twintides\r\n# 8AD0 Hydrobomb self-targeted cast for 8AD1 puddles\r\n# 8AD1 Hydrobomb cast and damage for 3x puddles duruing 8ABD Blowing Bubbles\r\n# 8AD4 Tidal Roar self-targeted cast for raidwide aoe\r\n# 8AD5 Tidal Roar damage from 8AD4\r\n# 8AD6 Tidal Roar cast and enrage damage\r\n# 8C6D Hydrobullet self-targeted \"spread second\" ability before Blowing Bubbles\r\n\r\n\r\n#~~~~~~#\r\n# LALA #\r\n#~~~~~~#\r\n\r\n# -p 88AE:2011.1\r\n# -ii 888F 8892 8CDF 889A 889B 88A8 889C 889D\r\n\r\n# The Dusk Trial will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1147\" } window 10000,0\r\n2006.1 \"--sync--\" StartsUsing { id: \"88AE\", source: \"Lala\" } window 20,20\r\n2011.1 \"Inferno Theorem\" Ability { id: \"88AE\", source: \"Lala\" }\r\n\r\n2013.2 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n2018.3 \"Angular Addition\" Ability { id: [\"8889\", \"8D2E\"], source: \"Lala\" }\r\n2026.4 \"Arcane Blight\" Ability { id: [\"888B\", \"888C\", \"888D\", \"888E\"], source: \"Lala\" }\r\n\r\n2029.6 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n2034.7 \"Analysis\" Ability { id: \"8895\", source: \"Lala\" }\r\n2039.8 \"Arcane Array 1\" Ability { id: \"8890\", source: \"Lala\" }\r\n2044.9 \"Angular Addition\" Ability { id: [\"8889\", \"8D2E\"], source: \"Lala\" }\r\n2045.6 \"Bright Pulse\" Ability { id: \"8891\", source: \"Lala\" }\r\n2046.9 \"Radiance 1\" Ability { id: \"8894\", source: \"Arcane Globe\" }\r\n2053.0 \"Arcane Blight\" Ability { id: [\"888B\", \"888C\", \"888D\", \"888E\"], source: \"Lala\" }\r\n# This can be +1.2s if it's on the final square instead of penultimate.\r\n2054.1 \"Radiance 2\" #Ability { id: \"8894\", source: \"Arcane Globe\" }\r\n2061.2 \"Targeted Light\" Ability { id: \"8CDE\", source: \"Lala\" }\r\n\r\n2072.5 \"Strategic Strike\" Ability { id: \"88AD\", source: \"Lala\" }\r\n\r\n2085.6 \"Planar Tactics\" Ability { id: \"8898\", source: \"Lala\" }\r\n2100.7 \"Arcane Mine\" Ability { id: \"8899\", source: \"Lala\" }\r\n2108.6 \"Symmetric Surge x2\" Ability { id: \"889E\", source: \"Lala\" }\r\n\r\n2112.8 \"Inferno Theorem\" Ability { id: \"88AE\", source: \"Lala\" }\r\n2122.9 \"Strategic Strike\" Ability { id: \"88AD\", source: \"Lala\" }\r\n\r\n2131.1 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n2138.3 \"Spatial Tactics\" Ability { id: \"88A0\", source: \"Lala\" }\r\n2143.4 \"Arcane Array 2\" Ability { id: \"889F\", source: \"Lala\" }\r\n2149.2 \"Bright Pulse\" Ability { id: \"8891\", source: \"Lala\" }\r\n2150.5 \"Inferno Divide 1\" Ability { id: \"8893\", source: \"Arcane Font\" } window 1,1\r\n2150.5 \"Radiance\" Ability { id: \"8D1F\", source: \"Arcane Globe\" }\r\n2152.9 \"Inferno Divide 2\" Ability { id: \"8893\", source: \"Arcane Font\" } window 1,1\r\n2156.6 \"Inferno Divide 3\" Ability { id: \"8893\", source: \"Arcane Font\" } window 1,1\r\n2157.6 \"Angular Addition\" Ability { id: [\"8889\", \"8D2E\"], source: \"Lala\" }\r\n2157.8 \"Inferno Divide 4\" Ability { id: \"8893\", source: \"Arcane Font\" } window 1,1\r\n2160.2 \"Inferno Divide 5\" Ability { id: \"8893\", source: \"Arcane Font\" } window 1,1\r\n2165.6 \"Arcane Blight\" Ability { id: [\"888B\", \"888C\", \"888D\", \"888E\"], source: \"Lala\" }\r\n\r\n2173.7 \"Inferno Theorem\" Ability { id: \"88AE\", source: \"Lala\" }\r\n2184.8 \"Inferno Theorem\" Ability { id: \"88AE\", source: \"Lala\" }\r\n\r\n2196.9 \"Symmetric Surge\" Ability { id: \"88A1\", source: \"Lala\" }\r\n2202.0 \"Constructive Figure\" Ability { id: \"88A3\", source: \"Lala\" }\r\n2207.1 \"Arcane Plot\" Ability { id: \"88A2\", source: \"Lala\" }\r\n2212.9 \"Bright Pulse\" Ability { id: \"8891\", source: \"Lala\" }\r\n2221.2 \"Arcane Point\" Ability { id: \"88A5\", source: \"Lala\" }\r\n2221.8 \"Aero II\" Ability { id: \"88A4\", source: \"Aloalo Golem\" }\r\n2222.0 \"Powerful Light\" Ability { id: \"88A6\", source: \"Lala\" }\r\n2230.3 \"Explosive Theorem\" Ability { id: \"88A7\", source: \"Lala\" }\r\n2234.7 \"Symmetric Surge x2\" Ability { id: \"889E\", source: \"Lala\" }\r\n2235.4 \"Telluric Theorem\" Ability { id: \"88A9\", source: \"Lala\" }\r\n\r\n2248.4 \"Strategic Strike\" Ability { id: \"88AD\", source: \"Lala\" }\r\n2256.5 \"Inferno Theorem\" Ability { id: \"88AE\", source: \"Lala\" }\r\n\r\n2263.6 \"--middle--\" Ability { id: \"8874\", source: \"Lala\" }\r\n2269.0 \"Analysis\" Ability { id: \"8895\", source: \"Lala\" }\r\n2274.1 \"Arcane Array 3\" Ability { id: \"8890\", source: \"Lala\" }\r\n2279.2 \"Angular Addition\" Ability { id: [\"8889\", \"8D2E\"], source: \"Lala\" }\r\n2279.9 \"Bright Pulse\" Ability { id: \"8891\", source: \"Lala\" }\r\n2281.2 \"Radiance 1\" Ability { id: \"8894\", source: \"Arcane Globe\" }\r\n2287.3 \"Arcane Blight\" Ability { id: [\"888B\", \"888C\", \"888D\", \"888E\"], source: \"Lala\" }\r\n2290.9 \"Radiance 2\" Ability { id: \"8894\", source: \"Arcane Globe\" }\r\n2295.6 \"Targeted Light\" Ability { id: \"8CDE\", source: \"Lala\" }\r\n2306.7 \"Strategic Strike\" Ability { id: \"88AD\", source: \"Lala\" }\r\n\r\n2316.8 \"Inferno Theorem\" Ability { id: \"88AE\", source: \"Lala\" }\r\n\r\n2319.9 \"--sync--\" StartsUsing { id: \"8C25\", source: \"Lala\" } window 20,20\r\n2329.9 \"Inferno Theorem Enrage\" Ability { id: \"8C25\", source: \"Lala\" }\r\n\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 368 attack auto damage from Lala\r\n# 8874 --sync-- repositioning for Lala\r\n# 8889 Angular Addition self-targeted ability to give boss III\r\n# 888B Arcane Blight self-targeted cast for initial back-safe 270 degree rotating cleave\r\n# 888C Arcane Blight self-targeted cast for initial front-safe 270 degree rotating cleave\r\n# 888D Arcane Blight self-targeted cast for initial east-safe 270 degree rotating cleave\r\n# 888E Arcane Blight self-targeted cast for initial west-safe 270 degree rotating cleave\r\n# 888F Arcane Blight cast and damage from 270 degree rotating cleave\r\n# 8890 Arcane Array self-targeted cast to summon moving blue squares (#1)\r\n# 8891 Bright Pulse cast and damage for initial blue square\r\n# 8892 Bright Pulse damage from moving blue square\r\n# 8893 Inferno Divide orange square cross explosion damage during Spatial Tactics\r\n# 8894 Radiance damage from Arcane Globe being hit by a blue square (Arcane Array #1, #3)\r\n# 8895 Analysis self-targeted cast before giving players\r\n# 8898 Planar Tactics self-targeted cast before Arcane Mines\r\n# 8899 Arcane Mine self-targeted cast to create 8 Arcane Mine squares\r\n# 889A Arcane Mine cast and damage for initial Arcane Mine squares\r\n# 889B Arcane Combustion damage from walking over an Arcane Mine\r\n# 889C Massive Explosion damage from failing to resolve Subractive Suppressor Alpha\r\n# 889D Massive Explosion damage from failing to resolve Subractive Suppressor Beta\r\n# 889E Symmetric Surge damage from two person stack that gives magic vuln up\r\n# 889F Arcane Array self-targeted cast to summon moving blue squares (#2)\r\n# 88A0 Spatial Tactics self-targeted cast prior to Arcane Array 2\r\n# 88A1 Symmetric Surge self-targeted cast before this mechanic\r\n# 88A2 Arcane Plot self-targeted cast to summon blue squares for Symmetric Surge\r\n# 88A3 Constructive Figure self-targeted cast that summons Aloalo Golem on edge\r\n# 88A4 Aero II cast and line damage from Aloalo Golem during Symmetric Surge\r\n# 88A5 Arcane Point self-targeted cast that gives players 88A6 Powerful Light spreads\r\n# 88A6 Powerful Light spread damage on players that turn the squares they are on blue\r\n# 88A7 Explosive Theorem self-targeted cast for very large spreads\r\n# 88A8 Explosive Theorem cast and damage on players for spreads with Telluric Theorem puddles\r\n# 88A9 Telluric Theorem cast and damage for large puddles from Explosive Theorem\r\n# 88AD Strategic Strike cast and damage for non-cleaving 3x tankbuster\r\n# 88AE Inferno Theorem cast and raidwide damage\r\n# 8C25 Inferno Theorem cast and enrage damage\r\n# 8CDE Targeted Light self-targeted cast for weak spot boss tether\r\n# 8CDF Targeted Light cast and damage on players for 8CDE\r\n# 8D1F Radiance damage from Arcane Globe being hit by a blue square (Arcane Array #2)\r\n# 8D2E Angular Addition self-targeted ability to give boss V\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~~#\r\n# STATICE WITH A GUN #\r\n#~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 8949:3013.8\r\n# -ii 8947 8925 8926 895A 895B 894C 8987 8A6A 895F 8960 8CC2 8982 8CBE 89F9 8C24 8957 8958\r\n# -it Statice\r\n\r\n# Midnight Trial will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1148\" } window 10000,0\r\n3008.8 \"--sync--\" StartsUsing { id: \"8949\", source: \"Statice\" } window 20,20\r\n3013.8 \"Aero IV\" Ability { id: \"8949\", source: \"Statice\" }\r\n\r\n3018.0 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n3023.4 \"Trick Reload\" Ability { id: \"894A\", source: \"Statice\" }\r\n3038.2 \"Trapshooting 1\" Ability { id: \"8D1A\", source: \"Statice\" }\r\n3048.6 \"Trigger Happy\" Ability { id: \"894B\", source: \"Statice\" }\r\n3056.5 \"Ring a Ring o' Explosions\" Ability { id: \"895C\", source: \"Statice\" }\r\n3070.6 \"Trapshooting 2\" Ability { id: \"8959\", source: \"Statice\" }\r\n3074.6 \"Burst\" Ability { id: \"895D\", source: \"Bomb\" }\r\n\r\n3081.8 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n3087.4 \"Trick Reload\" Ability { id: \"894A\", source: \"Statice\" }\r\n3101.2 \"Ring a Ring o' Explosions\" Ability { id: \"895C\", source: \"Statice\" }\r\n3106.3 \"Dartboard of Dancing Explosives \" Ability { id: \"8CBD\", source: \"Statice\" }\r\n3120.1 \"Trapshooting 1\" Ability { id: \"8959\", source: \"Statice\" }\r\n3122.0 \"Burst\" Ability { id: \"895D\", source: \"Bomb\" }\r\n3125.3 \"Uncommon Ground\" Ability { id: \"8954\", source: \"Statice\" }\r\n\r\n3132.3 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n3137.7 \"Surprise Balloon\" Ability { id: \"894D\", source: \"Statice\" }\r\n3144.8 \"Beguiling Glitter\" Ability { id: \"8963\", source: \"Statice\" }\r\n3149.8 \"Surprise Needle 1\" #Ability { id: \"894F\", source: \"Needle\" }\r\n3150.7 \"Pop 1\" Ability { id: \"894E\", source: \"Statice\" }\r\n3151.5 \"Surprise Needle 2\" #Ability { id: \"894F\", source: \"Needle\" }\r\n3152.4 \"Trigger Happy\" Ability { id: \"894B\", source: \"Statice\" }\r\n3153.2 \"Surprise Needle 3\" #Ability { id: \"894F\", source: \"Needle\" }\r\n3154.9 \"Surprise Needle 4\" #Ability { id: \"894F\", source: \"Needle\" }\r\n3155.6 \"Pop 2\" Ability { id: \"894E\", source: \"Statice\" }\r\n3160.4 \"Trapshooting 2\" Ability { id: \"8959\", source: \"Statice\" }\r\n3172.5 \"Aero IV\" Ability { id: \"8949\", source: \"Statice\" }\r\n\r\n3179.7 \"--untargetable--\"\r\n3179.7 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n3184.1 \"Ring a Ring o' Explosions\" Ability { id: \"895C\", source: \"Statice\" }\r\n3189.2 \"Present Box 1\" Ability { id: \"8955\", source: \"Statice\" }\r\n3194.3 \"Fireworks (cast)\" Ability { id: \"895E\", source: \"Statice\" }\r\n3204.0 \"Fireworks\" Ability { id: \"895F\", source: \"Statice\" }\r\n3204.2 \"Burst\" Ability { id: \"895D\", source: \"Bomb\" }\r\n3204.3 \"Faerie Ring\" Ability { id: \"8956\", source: \"Surprising Staff\" }\r\n\r\n3206.3 \"--targetable--\"\r\n3212.5 \"Shocking Abandon\" Ability { id: \"8948\", source: \"Statice\" }\r\n\r\n3222.7 \"Pinwheeling Dartboard\" Ability { id: \"8CBC\", source: \"Statice\" }\r\n3231.4 \"Fireworks (cast)\" Ability { id: \"895E\", source: \"Statice\" }\r\n3233.4 \"Fire Spread\" Ability { id: \"8952\", source: \"Statice\" } duration 11\r\n3241.3 \"Fireworks\" Ability { id: \"895F\", source: \"Statice\" }\r\n3241.6 \"Uncommon Ground\" Ability { id: \"8954\", source: \"Statice\" }\r\n3253.6 \"Aero IV\" Ability { id: \"8949\", source: \"Statice\" }\r\n\r\n3260.8 \"--middle--\" Ability { id: \"8927\", source: \"Statice\" }\r\n3266.5 \"Beguiling Glitter\" Ability { id: \"8963\", source: \"Statice\" }\r\n3273.6 \"Trick Reload\" Ability { id: \"894A\", source: \"Statice\" }\r\n3288.4 \"Trapshooting 1\" Ability { id: \"8D1A\", source: \"Statice\" }\r\n3295.5 \"Present Box 2\" Ability { id: \"8955\", source: \"Statice\" }\r\n3302.2 \"Ring a Ring o' Explosions\" Ability { id: \"895C\", source: \"Statice\" }\r\n3309.6 \"Trigger Happy\" Ability { id: \"894B\", source: \"Statice\" }\r\n3310.2 \"Faerie Ring\" Ability { id: \"8956\", source: \"Surprising Staff\" }\r\n3316.5 \"Trapshooting 2\" Ability { id: \"8959\", source: \"Statice\" }\r\n3320.4 \"Burst\" Ability { id: \"895D\", source: \"Bomb\" }\r\n\r\n3327.6 \"Aero IV\" Ability { id: \"8949\", source: \"Statice\" }\r\n3335.7 \"Aero IV\" Ability { id: \"8949\", source: \"Statice\" }\r\n\r\n3338.8 \"--sync--\" StartsUsing { id: \"8C23\", source: \"Statice\" }\r\n3348.8 \"Aero IV Enrage\" Ability { id: \"8C23\", source: \"Statice\" }\r\n\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 8925 Locked and Loaded ability during 894A Trick Reload when a bullet is in the gun\r\n# 8926 Misload ability during 894A Trick Reload when a bullet missed the gun oops\r\n# 8927 --sync-- repositioning from Statice\r\n# 8947 --sync-- auto damage from Statice\r\n# 8948 Shocking Abandon cast and tankbuster damage\r\n# 8949 Aero IV cast and raidwide damage\r\n# 894A Trick Reload self-targeted cast to load gun with 8925/8926\r\n# 894B Trigger Happy self-targeted cast for limit cut dart board\r\n# 894C Trigger Happy cast and damage for limit cut dart board (filled pie slice)\r\n# 894D Surprise Balloon self-targeted cast\r\n# 894E Pop knockback from Surprise Balloon being popped\r\n# 894F Surprise Needle short cast and ability blue line aoe from needle adds that pop balloons\r\n# 8954 Uncommon Ground light damage on people who are not on a dartboard color with Bull's-eye\r\n# 8955 Present Box self-targeted cast for bombs/donuts/missiles/hands\r\n# 8956 Faerie Ring cast and damage for donut rings during Present Box\r\n# 8957 Burst high damage from running into Surprising Missile tethered add\r\n# 8958 Death by Claw high damage from running into Surprising Claw tethered add\r\n# 8959 Trapshooting self-targeted cast after Trick Reload (some instances are 8D1A)\r\n# 895A Trapshooting stack damage from Trick Reload\r\n# 895B Trapshooting spread damage from Trick Reload\r\n# 895C Ring a Ring o' Explosions self-targeted cast for rotating bombs\r\n# 895D Burst cast and damage from bomb explosion\r\n# 895E Fireworks self-targeted cast\r\n# 895F Fireworks two person stack damage during Present Box / Pinwheeling Dartboard\r\n# 8960 Fireworks spread damage during Present Box / Pinwheeling Dartboard\r\n# 8963 Beguiling Glitter self-targeted cast to give players Face debuffs\r\n# 8982 Fire Spread self-targeted damage for initial rotating fire (from Ball of Fire)\r\n# 8987 Trigger Happy cast and zero damage for limit cut dart board (empty pie slice)\r\n# 89F9 Fire Spread ongoing rotating fire damage (from Statice)\r\n# 8A6A --sync-- ability on Bomb when rotating\r\n# 8C23 Aero IV cast and enrage damage\r\n# 8C24 Aero IV post-enrage follow-up damage just in case\r\n# 8CBC Pinwheeling Dartboard self-targeted cast to summon dartboard with rotating fire\r\n# 8CBD Dartboard of Dancing Explosives self-targeted cast for colored dartboard\r\n# 8CBE Burning Chains damage from not breaking chains\r\n# 8CC2 Uncommon Ground heavy damage on people who are on the same dartboard color with Bull's-eye\r\n# 8D1A Trapshooting self-targeted cast after Trick Reload (some instances are 8959)\r\n\r\n\r\n#~~~~~~~~~#\r\n# TRASH 1 #\r\n#~~~~~~~~~#\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 7A56 --sync-- various auto damage (trash 1)\r\n# 8BC0 --sync-- damage from Twister tornados\r\n# 8C6E Lead Hook casted damage from Kiwakin 3x tankbuster\r\n# 8C62 Lead Hook damage from hit 2\r\n# 8C53 Lead Hook damage from hit 3\r\n# 8C64 Water III casted damage from Snipper stack marker\r\n# 8C63 Sharp Strike casted damage from Kiwakin tank buster with a concussion dot\r\n# 8BB8 Tail Screw casted damage from Kiwakin baited circle\r\n# 8BB9 Bubble Shower casted damage from Snipper front conal\r\n# 8BBA Crab Dribble fast casted damage from Snipper back conal after Bubble Shower 8BB9\r\n# 8BBD Hydrocannon casted damage from Ray front line\r\n# 8BBF Expulsion casted damage from Ray \"get out\"\r\n# 8BBE Electric Whorl casted damage from Ray \"get in\"\r\n# 8C65 Hydroshot casted damage from Monk knockback line with a dot\r\n# 8BBB Cross Attack casted damage from Monk tankbuster\r\n\r\n#~~~~~~~~~#\r\n# TRASH 2 #\r\n#~~~~~~~~~#\r\n\r\n# TODO: does Wood Golem have an enrage??\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 7A58 --sync-- various auto damage (trash 2)\r\n# 8BC1 Ovation cast and damage from Wood Golem front line aoe\r\n# 8BC5 Gravity Force cast and stack damage from Islekeeper\r\n# 8C2F Ancient Quaga cast and damage for Islekeeper raidwide enrage\r\n# 8C4C Ancient Aero III interruptable cast and damage for Wood Golem raidwide\r\n# 8C4D Tornado cast and damage from Wood Golem that binds the initial target and heavies all targets\r\n# 8C4E Ancient Quaga cast and damage for Islekeeper raidwide\r\n# 8C6F Isle Drop cast and damage for Islekeeper front circle\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/another_mount_rokkon-savage.ts
// This file was autogenerated from running npm run sync-files.
// DO NOT EDIT THIS FILE DIRECTLY.
// Edit the source file below and then run `npm run sync-files`
// Source: ui/raidboss/data/06-ew/dungeon/another_mount_rokkon.ts







const headmarkers = {
  // vfx/lockon/eff/sph_lockon2_num01_s8p.avfx (through sph_lockon2_num04_s8p)
  limitCut1: '0150',
  limitCut2: '0151',
  limitCut3: '0152',
  limitCut4: '0153'
};
const mokoVfxMap = {
  '24C': 'backRed',
  '24D': 'leftRed',
  '24E': 'frontRed',
  '24F': 'rightRed',
  '250': 'backBlue',
  '251': 'leftBlue',
  '252': 'frontBlue',
  '253': 'rightBlue'
};
const looseMokoVfxMap = mokoVfxMap;
const shadowVfxMap = {
  '248': 'back',
  '249': 'left',
  '24A': 'front',
  '24B': 'right'
};
const looseShadowVfxMap = shadowVfxMap;
const limitCutIds = Object.values(headmarkers);
const mokoCenterX = -200;
const mokoCenterY = 0;
const tripleKasumiFirstOutputStrings = {
  backRedFirst: {
    en: 'Back + Out',
    de: 'Hinten + Raus',
    fr: 'Arrière + Extérieur',
    ja: '後ろ + 外',
    cn: '后 + 远离',
    ko: '뒤 + 밖'
  },
  leftRedFirst: {
    en: 'Left + Out',
    de: 'Links + Raus',
    fr: 'Gauche + Extérieur',
    ja: '左 + 外',
    cn: '左 + 远离',
    ko: '왼쪽 + 밖'
  },
  frontRedFirst: {
    en: 'Front + Out',
    de: 'Vorne + Raus',
    fr: 'Devant + Extérieur',
    ja: '前 + 外',
    cn: '前 + 远离',
    ko: '앞 + 밖'
  },
  rightRedFirst: {
    en: 'Right + Out',
    de: 'Rechts + Raus',
    fr: 'Droite + Extérieur',
    ja: '右 + 外',
    cn: '右 + 远离',
    ko: '오른쪽 + 밖'
  },
  backBlueFirst: {
    en: 'Back + In',
    de: 'Hinten + Rein',
    fr: 'Arrière + Intérieur',
    ja: '後ろ + 中',
    cn: '后 + 靠近',
    ko: '뒤 + 안'
  },
  leftBlueFirst: {
    en: 'Left + In',
    de: 'Links + Rein',
    fr: 'Gauche + Intérieur',
    ja: '左 + 中',
    cn: '左 + 靠近',
    ko: '왼쪽 + 안'
  },
  frontBlueFirst: {
    en: 'Front + In',
    de: 'Vorne + Rein',
    fr: 'Devant + Intérieur',
    ja: '前 + 中',
    cn: '前 + 靠近',
    ko: '앞 + 안'
  },
  rightBlueFirst: {
    en: 'Right + In',
    de: 'Rechts + Rein',
    fr: 'Droite + Intérieur',
    ja: '右 + 中',
    cn: '右 + 靠近',
    ko: '오른쪽 + 안'
  }
};

// It might be more accurate to say "rotate right" here than "right" (implying right flank)
// but that's very long. This is one of those "you need to know the mechanic" situations.
const tripleKasumiFollowupOutputStrings = {
  backRed: {
    en: 'Stay + Out',
    de: 'bleib Stehen + Raus',
    fr: 'Restez + Extérieur',
    ja: 'そのまま + 外',
    cn: '停 + 远离',
    ko: '그대로 + 밖'
  },
  leftRed: {
    en: 'Left + Out',
    de: 'Links + Raus',
    fr: 'Gauche + Extérieur',
    ja: '左 + 外',
    cn: '左左左 + 远离',
    ko: '왼쪽 + 밖'
  },
  frontRed: {
    en: 'Through + Out',
    de: 'Durch + Raus',
    fr: 'À travers + Extérieur',
    ja: 'またいで + 外',
    cn: '穿 + 远离',
    ko: '가로지르기 + 밖'
  },
  rightRed: {
    en: 'Right + Out',
    de: 'Rechts + Raus',
    fr: 'Droite + Extérieur',
    ja: '右 + 外',
    cn: '右右右 + 远离',
    ko: '오른쪽 + 밖'
  },
  backBlue: {
    en: 'Stay + In',
    de: 'bleib Stehen + Rein',
    fr: 'Restez + Intérieur',
    ja: 'そのまま + 中',
    cn: '停 + 靠近',
    ko: '그대로 + 안'
  },
  leftBlue: {
    en: 'Left + In',
    de: 'Links + Rein',
    fr: 'Gauche + Intérieur',
    ja: '左 + 中',
    cn: '左左左 + 靠近',
    ko: '왼쪽 + 밖'
  },
  frontBlue: {
    en: 'Through + In',
    de: 'Durch + Rein',
    fr: 'À travers + Intérieur',
    ja: 'またいで + 中',
    cn: '穿 + 靠近',
    ko: '가로지르기 + 안'
  },
  rightBlue: {
    en: 'Right + In',
    de: 'Rechts + Rein',
    fr: 'Droite + Intérieur',
    ja: '右 + 中',
    cn: '右右右 + 靠近',
    ko: '오른쪽 + 안'
  }
};
const basicStackSpreadOutputStrings = {
  spread: outputs/* default.spread */.Z.spread,
  melee: {
    en: 'Melees Stack',
    de: 'Nahkämpfer sammeln',
    fr: 'Package mêlées',
    ja: '近接ペア',
    cn: '近战分摊',
    ko: '근딜 쉐어'
  },
  role: {
    en: 'Role Stacks',
    de: 'Rollengruppe sammeln',
    fr: 'Package par role',
    ja: 'ロールペア',
    cn: '职能分摊',
    ko: '역할별 쉐어'
  },
  partner: {
    en: 'Partner Stacks',
    de: 'Partner sammeln',
    fr: 'Package partenaire',
    ja: 'ペア',
    cn: '和搭档分摊',
    ko: '파트너 쉐어'
  },
  unknown: {
    en: 'Stacks',
    de: 'Sammeln',
    fr: 'Package',
    ja: '頭割り',
    cn: '分摊',
    ko: '쉐어'
  }
};
const tripleKasumiAbilityIds = ['85E4',
// back red first
'85E5',
// left red first
'85E6',
// front red first
'85E7',
// right red first
'85E8',
// back red followup
'85E9',
// left red followup
'85EA',
// front red followup
'85EB',
// right red followup
'85EE',
// back blue first
'85EF',
// left blue first
'85F0',
// front blue first
'85F1',
// right blue first
'85F2',
// back blue followup
'85F3',
// left blue followup
'85F4',
// front blue followup
'85F5' // right blue followup
];

const countJob = (job1, job2, func) => {
  return (func(job1) ? 1 : 0) + (func(job2) ? 1 : 0);
};

// For a given criteria func, if there's exactly one person who matches in the stack group
// and exactly one person who matches in the unmarked group, then they can stack together.
// This also filters out weird party comps naturally.
const couldStackLooseFunc = (stackJob1, stackJob2, unmarkedJob1, unmarkedJob2, func) => {
  const stackCount = countJob(stackJob1, stackJob2, func);
  const unmarkedCount = countJob(unmarkedJob1, unmarkedJob2, func);
  return stackCount === 1 && unmarkedCount === 1;
};
const isMeleeOrTank = x => util/* default.isMeleeDpsJob */.Z.isMeleeDpsJob(x) || util/* default.isTankJob */.Z.isTankJob(x);
const isSupport = x => util/* default.isHealerJob */.Z.isHealerJob(x) || util/* default.isTankJob */.Z.isTankJob(x);
const findStackPartners = (data, stack1, stack2, stackOrderOverride) => {
  const party = data.party;
  if (stack1 === undefined || stack2 === undefined) return 'unknown';
  const stacks = [stack1, stack2];
  const unmarked = party.partyNames.filter(x => !stacks.includes(x));
  if (unmarked.length !== 2 || party.partyNames.length !== 4) return 'unknown';
  const [stackJob1, stackJob2] = stacks.map(x => party.jobName(x));
  if (stackJob1 === undefined || stackJob2 === undefined) return 'unknown';
  const [unmarkedJob1, unmarkedJob2] = unmarked.map(x => party.jobName(x));
  if (unmarkedJob1 === undefined || unmarkedJob2 === undefined) return 'unknown';
  const couldStack = func => {
    return couldStackLooseFunc(stackJob1, stackJob2, unmarkedJob1, unmarkedJob2, func);
  };
  const stackOrder = stackOrderOverride ?? data.triggerSetConfig.stackOrder;
  if (stackOrder === 'meleeRolesPartners' && couldStack(isMeleeOrTank)) return 'melee';
  if (couldStack(isSupport)) return 'role';

  // if we get here, then you have a not normal light party comp, e.g. two ranged
  // or you have set the config option to be "rolesPartners" to not prefer melee.
  // For a tank/healer/ranged/ranged comp, this condition below will always be true
  // but make it anyway in case the party comp is something else entirely.
  const stackCount = countJob(stackJob1, stackJob2, isSupport);
  const unmarkedCount = countJob(unmarkedJob1, unmarkedJob2, isSupport);
  if (stackCount === 2 && unmarkedCount === 0 || stackCount === 0 && unmarkedCount === 2) return 'partner';

  // if something has gone incredibly awry, then just return the default
  return 'unknown';
};
const stackSpreadResponse = (data, output, collect, stackId, spreadId, hideStackList) => {
  // cactbot-builtin-response
  output.responseOutputStrings = {
    // In a 4 person party with two randomly assigned stacks,
    // there are a couple of different "kinds of pairs" that make sense to call.
    //
    // You can have two melees together and two ranged together,
    // or you can have two supports together and two dps together (role stacks)
    // or you have no melee in your comp, and you could have mixed support and range.
    // Arguably things like "tank+ranged, melee+healer" are possible but are harder to call.
    //
    // Prefer "melee/ranged" stacks here and elsewhere because it keeps
    // the tank and melee together for uptime.
    spreadThenMeleeStack: {
      en: 'Spread => Melees Stack',
      de: 'Verteilen => Nahkämpfer sammeln',
      fr: 'Écartez-vous => Package mêlées',
      ja: '散会 => 近接ペア',
      cn: '分散 => 近战分摊',
      ko: '산개 => 근딜 쉐어'
    },
    spreadThenRoleStack: {
      en: 'Spread => Role Stacks',
      de: 'Verteilen => Rollengruppe sammeln',
      fr: 'Écartez-vous => Package par rôle',
      ja: '散会 => ロールペア',
      cn: '分散 => 职能分摊',
      ko: '산개 => 역할별 쉐어'
    },
    spreadThenPartnerStack: {
      en: 'Spread => Partner Stacks',
      de: 'Verteilen => Partner sammeln',
      fr: 'Écartez-vous => Package partenaire',
      ja: '散会 => ペア',
      cn: '分散 => 和搭档分摊',
      ko: '산개 => 파트너 쉐어'
    },
    meleeStackThenSpread: {
      en: 'Melees Stack => Spread',
      de: 'Nahkämpfer sammeln => Verteilen',
      fr: 'Package mêlées => Écartez-vous',
      ja: '近接ペア => 散会',
      cn: '近战分摊 => 分散',
      ko: '근딜 쉐어 => 산개'
    },
    roleStackThenSpread: {
      en: 'Role Stacks => Spread',
      de: 'Rollengruppe sammeln => Verteilen',
      fr: 'Package par rôle => Écartez-vous',
      ja: 'ロールペア => 散会',
      cn: '职能分摊 => 分散',
      ko: '역할별 쉐어 => 산개'
    },
    partnerStackThenSpread: {
      en: 'Partner Stacks => Spread',
      de: 'Partner sammeln => Verteilen',
      fr: 'Package partenaire => Écartez-vous',
      ja: 'ペア => 散会',
      cn: '和搭档分摊 => 分散',
      ko: '파트너 쉐어 => 산개'
    },
    spreadThenStack: outputs/* default.spreadThenStack */.Z.spreadThenStack,
    stackThenSpread: outputs/* default.stackThenSpread */.Z.stackThenSpread,
    stacks: {
      en: 'Stacks: ${player1}, ${player2}',
      de: 'Sammeln: ${player1}, ${player2}',
      fr: 'Package : ${player1}, ${player2}',
      ja: '頭割り: ${player1}, ${player2}',
      cn: '分摊点: ${player1}, ${player2}',
      ko: '쉐어: ${player1}, ${player2}'
    }
  };
  const [stack1, stack2] = collect.filter(x => x.effectId === stackId);
  const spread = collect.find(x => x.effectId === spreadId);
  if (stack1 === undefined || stack2 === undefined || spread === undefined) return;
  const stackTime = parseFloat(stack1.duration);
  const spreadTime = parseFloat(spread.duration);
  const isStackFirst = stackTime < spreadTime;
  const stackType = findStackPartners(data, stack1.target, stack2.target);
  const stacks = [stack1, stack2].map(x => x.target).sort();
  const [player1, player2] = stacks.map(x => data.party.member(x));
  const stackInfo = hideStackList ? {} : {
    infoText: output.stacks({
      player1: player1,
      player2: player2
    })
  };
  data.stackSpreadFirstMechanic = isStackFirst ? stackType : 'spread';
  data.stackSpreadSecondMechanic = isStackFirst ? 'spread' : stackType;
  if (stackType === 'melee') {
    if (isStackFirst) return {
      alertText: output.meleeStackThenSpread(),
      ...stackInfo
    };
    return {
      alertText: output.spreadThenMeleeStack(),
      ...stackInfo
    };
  } else if (stackType === 'role') {
    if (isStackFirst) return {
      alertText: output.roleStackThenSpread(),
      ...stackInfo
    };
    return {
      alertText: output.spreadThenRoleStack(),
      ...stackInfo
    };
  } else if (stackType === 'partner') {
    if (isStackFirst) return {
      alertText: output.partnerStackThenSpread(),
      ...stackInfo
    };
    return {
      alertText: output.spreadThenPartnerStack(),
      ...stackInfo
    };
  }

  // 'unknown' catch-all
  if (isStackFirst) return {
    alertText: output.stackThenSpread(),
    ...stackInfo
  };
  return {
    alertText: output.spreadThenStack(),
    ...stackInfo
  };
};
const towerResponse = (data, output) => {
  // cactbot-builtin-response
  output.responseOutputStrings = {
    tetherThenBlueTower: {
      en: 'Tether ${num1} => Blue Tower ${num2}',
      de: 'Verbindung ${num1} => Blauer Turm ${num2}',
      fr: 'Lien ${num1} => Tour bleue ${num2}',
      ja: '線${num1} => 青塔${num2}',
      cn: '连线 ${num1} => 蓝塔 ${num2}',
      ko: '선 ${num1} => 파랑 기둥 ${num2}'
    },
    tetherThenOrangeTower: {
      en: 'Tether ${num1} => Orange Tower ${num2}',
      de: 'Verbindung ${num1} => Orangener Turm ${num2}',
      fr: 'Lien ${num1} => Tour orange ${num2}',
      ja: '線${num1} => 赤塔${num2}',
      cn: '连线 ${num1} => 橙塔 ${num2}',
      ko: '선 ${num1} => 주황 기둥 ${num2}'
    },
    tether: {
      en: 'Tether ${num}',
      de: 'Verbindung ${num}',
      fr: 'Lien ${num}',
      ja: '線${num}',
      cn: '连线 ${num}',
      ko: '선 ${num}'
    },
    blueTower: {
      en: 'Blue Tower ${num}',
      de: 'Blauer Turm ${num}',
      fr: 'Tour bleue ${num}',
      ja: '青塔${num}',
      cn: '蓝塔 ${num}',
      ko: '파랑 기둥 ${num}'
    },
    orangeTower: {
      en: 'Orange Tower ${num}',
      de: 'Orangener Turm ${num}',
      fr: 'Tour orange ${num}',
      ja: '赤塔${num}',
      cn: '橙塔 ${num}',
      ko: '주황 기둥 ${num}'
    },
    num1: outputs/* default.num1 */.Z.num1,
    num2: outputs/* default.num2 */.Z.num2,
    num3: outputs/* default.num3 */.Z.num3,
    num4: outputs/* default.num4 */.Z.num4
  };

  // data.rousingTowerCount is 0-indexed
  // towerNum for display is 1-indexed
  const theseTowers = data.rousingCollect[data.rousingTowerCount];
  const towerNum = data.rousingTowerCount + 1;
  data.rousingTowerCount++;
  if (theseTowers === undefined) return;
  const numMap = {
    1: output.num1(),
    2: output.num2(),
    3: output.num3(),
    4: output.num4()
  };
  const numStr = numMap[towerNum];
  if (numStr === undefined) return;
  if (data.me === theseTowers.blue) return {
    alertText: output.blueTower({
      num: numStr
    })
  };
  if (data.me === theseTowers.orange) return {
    alertText: output.orangeTower({
      num: numStr
    })
  };
  const nextTowers = data.rousingCollect[towerNum + 1];
  const nextNumStr = numMap[towerNum + 1];
  if (towerNum === 4 || nextTowers === undefined || nextNumStr === undefined) return {
    infoText: output.tether({
      num: numStr
    })
  };
  if (data.me === nextTowers.blue) return {
    infoText: output.tetherThenBlueTower({
      num1: numStr,
      num2: nextNumStr
    })
  };
  if (data.me === nextTowers.orange) return {
    infoText: output.tetherThenOrangeTower({
      num1: numStr,
      num2: nextNumStr
    })
  };

  // Just in case...
  return {
    infoText: output.tether({
      num: numStr
    })
  };
};
const another_mount_rokkon_savage_triggerSet = {
  id: 'AnotherMountRokkonSavage',
  zoneId: zone_id/* default.AnotherMountRokkonSavage */.Z.AnotherMountRokkonSavage,
  config: [{
    id: 'stackOrder',
    comment: {
      en: `For any two person stacks, this specifies the priority order for picking people to stack together.
           If you want your melee and tank to stick together if possible, pick the option with melees in it.
           Melees stack means melee+tank and healer+ranged. Role stacks means tank+healer and dps+dps.
           Partner stacks mean support+dps and support+dps (any combination works).
           If you have two ranged dps or two melee dps, it will never call "melees" regardless of this config option.
           There is no support for party comps that are not two support and two dps.`,
      de: `Für jeden Zwei-Personen-Stack gibt dies die Prioritätsreihenfolge für die Auswahl der Personen an, die sich sammeln.
           Wenn ihr wollt, dass Nahkämpfer und Tank nach Möglichkeit zusammenbleiben, wählt die Option mit den Nahkämpfern aus.
           Nahkampf-Stack bedeutet Nahkampf+Tank und Heiler+Ranger. Rollen-Stack bedeutet Tank+Heiler und Dps+Dps.
           Partner-Stack bedeuten Supporter+Dps und Supporter+Dps (jede Kombination ist möglich).
           Wenn du zwei Fernkampf-DPS oder zwei Nahkampf-DPS hast, wird es nie "Nahkämpfer" nennen, unabhängig von dieser Konfigurationsoption.
           Es gibt keine Unterstützung für Gruppenkombinationen, die nicht aus zwei Supportern und zwei DPS bestehen.`,
      fr: `Pour n'importe quel package à deux, ceci spécifie l'ordre de priorité pour choisir la personne avec qui se packer.
          Si vous voulez votre mêlée et tank ensemble, choisissez l'option contenant mêlée.
          Package mêlée signifie mêlée+tank et healer+distant. Package par rôle signifie tank+healer et dps+dps.
          Package partenaire signifie support+dps (n'importe quelle combinaison fonctionne).
          Si votre groupe est composée de deux distants ou deux mêlées, "mêlées" ne sera jamais annoncé quelque soit l'option choisie.
          Les groupes ne contenant pas deux supports et deux dps ne peuvent pas être annoncés.`,
      ja: `2人ペアで一緒にペアを作り優先順位を決めます。近接とタンクを組む場合は近接オプションを選んでください。
          近接ペアは近接+タンクとヒーラ+遠隔を意味します。ロールはタンク+ヒーラ、近接+遠隔を意味します。
          遠隔まだは近接が2人の場合は、ここの設定を無視して近接呼び出しはありません。
          および、タンク+ヒーラ+DPS2人じゃないパティは志願しません。`,
      cn: `对于所有双人分摊，该选项指定了选择谁与谁分摊的优先级。
           如果你想让近战和坦克分摊 (假设分摊没有同时点这两个人), 选择含有“近战 (melee)”的选项。
           近战 (melee) 分摊指的是 近战+坦克 和 治疗+远程。职能分摊指的是 坦克 + 治疗 和 DPS + DPS。
           搭档分摊指的是 支援 + DPS 和 支援 + DPS (任何组合都有可能，支援位是坦克和治疗)。
           如果队伍中有两名远程 DPS 或近战 DPS, 无论此配置选项如何, 它都不会报“近战 (melees)”。
           没有考虑对非标准阵容队伍 (非 2 支援 + 2DPS) 构成的支持。`,
      ko: `2인 쉐어에서, 함께 쉐어를 맞을 사람의 우선 순위를 지정합니다. 근딜과 탱커를 함께 배치하고 싶다면 근딜이 포함된 옵션을 선택하세요.
           근딜 쉐어는 근딜+탱커와 힐러+원딜을 의미합니다. 역할별 쉐어는 탱커+힐러와 딜러+딜러를 의미합니다.
           파트너 쉐어는 탱힐+딜러와 탱힐+딜러를 의미합니다(어떤 조합도 가능).
           원딜이 두 명 또는 근딜이 두 명일 경우, 이 설정 옵션과 상관없이 "근딜"을 호출하지 않습니다.
           탱힐 둘, 딜러 둘이 아닌 파티 구성은 지원되지 않습니다.`
    },
    name: {
      en: 'Stack Selection Order',
      de: 'Sammel-Reihenfolge',
      fr: 'Ordre de sélection des packages',
      ja: 'ペア優先順位',
      cn: '选择分摊次序',
      ko: '쉐어 우선순위'
    },
    type: 'select',
    options: {
      en: {
        'Melees > Roles > Partners': 'meleeRolesPartners',
        'Roles > Partners': 'rolesPartners'
      },
      de: {
        'Nahkämpfer > Rollen > Partner': 'meleeRolesPartners',
        'Rollen > Partner': 'rolesPartners'
      },
      fr: {
        'Mêlées > Rôles > Partenaires': 'meleeRolesPartners',
        'Rôles > Partenaires': 'rolesPartners'
      },
      ja: {
        '近接 > ロール > ペア': 'meleeRolesPartners',
        'ロール > ペア': 'rolesPartners'
      },
      cn: {
        '近战 > 职能 > 搭档': 'meleeRolesPartners',
        '职能 > 搭档': 'rolesPartners'
      },
      ko: {
        '근딜 > 역할군 > 파트너': 'meleeRolesPartners',
        '역할군 > 파트너': 'rolesPartners'
      }
    },
    default: 'meleeRolesPartners'
  }],
  timelineFile: 'another_mount_rokkon-savage.txt',
  initData: () => {
    return {
      combatantData: [],
      smokeaterCount: 0,
      rairinCollect: [],
      wailingCollect: [],
      wailCount: 0,
      devilishThrallCollect: [],
      reishoCount: 0,
      ghostHeadmarkers: [],
      sparksCollect: [],
      sparksCount: 0,
      rousingCollect: [{}, {}, {}, {}],
      rousingTowerCount: 0,
      malformedCollect: [],
      myMalformedEffects: [],
      malformedTowerCount: 0,
      tripleKasumiCollect: [],
      explosionLineCollect: [],
      shadowKasumiCollect: {},
      shadowKasumiTether: {},
      invocationCollect: [],
      iaigiriTether: [],
      iaigiriPurple: [],
      iaigiriCasts: [],
      oniClawCollect: []
    };
  },
  triggers: [
  // ---------------- first trash ----------------
  {
    id: 'AMRS Shishu Raiko Disciples of Levin',
    type: 'StartsUsing',
    netRegex: {
      id: '8668',
      source: 'Shishu Raiko',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'AMRS Shishu Raiko Barreling Smash',
    type: 'StartsUsing',
    netRegex: {
      id: '8665',
      source: 'Shishu Raiko'
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        chargeOnYou: {
          en: 'Charge on YOU',
          de: 'Ansturm auf DIR',
          fr: 'Ruée sur VOUS',
          ja: '自分に突進',
          cn: '冲锋点名',
          ko: '돌진 대상자'
        },
        chargeOn: {
          en: 'Charge on ${player}',
          de: 'Ansturm auf ${player}',
          fr: 'Ruée sur ${player}',
          ja: '突進: ${player}',
          cn: '冲锋点 ${player}',
          ko: '돌진 ${player}'
        }
      };
      if (matches.target === data.me) return {
        alarmText: output.chargeOnYou()
      };
      return {
        alertText: output.chargeOn({
          player: data.party.member(matches.target)
        })
      };
    }
  }, {
    id: 'AMRS Shishu Raiko Howl',
    type: 'StartsUsing',
    netRegex: {
      id: '8666',
      source: 'Shishu Raiko',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'AMRS Shishu Raiko Master of Levin',
    type: 'StartsUsing',
    netRegex: {
      id: '8667',
      source: 'Shishu Raiko',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'AMRS Shishu Fuko Scythe Tail',
    type: 'StartsUsing',
    netRegex: {
      id: '866C',
      source: 'Shishu Fuko',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'AMRS Shishu Fuko Twister',
    type: 'StartsUsing',
    netRegex: {
      id: '866A',
      source: 'Shishu Fuko'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'AMRS Shishu Fuko Crosswind',
    type: 'StartsUsing',
    netRegex: {
      id: '866B',
      source: 'Shishu Fuko',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'AMRS Shishu Yuki Auto Tracker',
    type: 'Ability',
    netRegex: {
      id: '7A58',
      source: 'Shishu Yuki',
      capture: false
    },
    // Before being pulled (aka seeing an auto), Shishu Yuki faces south when doing
    // right/left cleaves. Make these absolute directions for clarity.
    // Shishu Yuki does have a buff that prevents pulling it, but there's no line
    // for this buff loss.
    run: data => data.seenShishuYukiAuto = true
  }, {
    id: 'AMRS Shishu Yuki Right Swipe',
    type: 'StartsUsing',
    netRegex: {
      id: '8688',
      source: 'Shishu Yuki',
      capture: false
    },
    alertText: (data, _matches, output) => {
      return data.seenShishuYukiAuto ? output.left() : output.east();
    },
    outputStrings: {
      east: outputs/* default.east */.Z.east,
      left: outputs/* default.left */.Z.left
    }
  }, {
    id: 'AMRS Shishu Yuki Left Swipe',
    type: 'StartsUsing',
    netRegex: {
      id: '8689',
      source: 'Shishu Yuki',
      capture: false
    },
    alertText: (data, _matches, output) => {
      return data.seenShishuYukiAuto ? output.right() : output.west();
    },
    outputStrings: {
      west: outputs/* default.west */.Z.west,
      right: outputs/* default.right */.Z.right
    }
  },
  // ---------------- Shishio ----------------
  {
    id: 'AMRS Shishio Enkyo',
    type: 'StartsUsing',
    netRegex: {
      id: '8441',
      source: 'Shishio',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'AMRS Shishio Smokeater Count',
    type: 'Ability',
    // 8420 is the initial Smokeater, and 8421 is the followup optional two.
    netRegex: {
      id: ['8420', '8421'],
      source: 'Shishio'
    },
    sound: '',
    infoText: (data, matches, output) => {
      if (matches.id === '8420') {
        data.smokeaterCount = 1;
        return output.num1();
      }
      data.smokeaterCount++;
      if (data.smokeaterCount === 2) return output.num2();
      return output.num3();
    },
    outputStrings: {
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3
    }
  }, {
    id: 'AMRS Shishio Splitting Cry',
    type: 'StartsUsing',
    netRegex: {
      id: '8442',
      source: 'Shishio'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AMRS Shishio Splitter',
    type: 'Ability',
    // This comes out ~4s after Splitting Cry.
    netRegex: {
      id: '8442',
      source: 'Shishio',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.goFrontOrSides */.n3.goFrontOrSides('info')
  }, {
    id: 'AMRS Rairin Collect',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '12430'
    },
    run: (data, matches) => data.rairinCollect.push(matches)
  }, {
    id: 'AMRS Noble Pursuit',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '12430',
      capture: false
    },
    condition: data => data.rairinCollect.length === 4,
    alertText: (data, _matches, output) => {
      const [one, two, three, four] = data.rairinCollect;
      if (one === undefined || two === undefined || three === undefined || four === undefined) return;

      // one is always north (0, -115)
      // two is always south (0, -85)
      // three is left or right (+/-15, -80)
      // four is either diagonal (7.5, -92.5) / (-6, -94) or back north (+/-20, -95)

      // We always end up on the opposite side as the third charge.
      const isThreeEast = parseFloat(three.x) > 0;
      // If four is diagonal, you go south otherwise north.
      const isFourDiagonal = Math.abs(parseFloat(four.x)) < 18;
      if (isFourDiagonal) return isThreeEast ? output.southwest() : output.southeast();
      return isThreeEast ? output.northwest() : output.northeast();
    },
    outputStrings: {
      northeast: outputs/* default.northeast */.Z.northeast,
      southeast: outputs/* default.southeast */.Z.southeast,
      southwest: outputs/* default.southwest */.Z.southwest,
      northwest: outputs/* default.northwest */.Z.northwest
    }
  }, {
    id: 'AMRS Shishio Unnatural Wail Count',
    type: 'StartsUsing',
    netRegex: {
      id: '843E',
      source: 'Shishio',
      capture: false
    },
    run: data => {
      data.wailCount++;
      data.wailingCollect = [];
    }
  }, {
    id: 'AMRS Shishio Wailing Collect',
    type: 'GainsEffect',
    // DEB = Scattered Wailing (spread)
    // DEC = Intensified Wailing (stack)
    netRegex: {
      effectId: ['DEB', 'DEC'],
      source: 'Shishio'
    },
    run: (data, matches) => data.wailingCollect.push(matches)
  }, {
    id: 'AMRS Shishio Unnatural Wailing 1',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['DEB', 'DEC'],
      source: 'Shishio',
      capture: false
    },
    condition: data => data.wailCount === 1,
    delaySeconds: 0.5,
    suppressSeconds: 999999,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      return stackSpreadResponse(data, output, data.wailingCollect, 'DEC', 'DEB');
    }
  }, {
    id: 'AMRS Shishio Vortex of the Thunder Eye',
    type: 'StartsUsing',
    // 843A = Eye of the Thunder Vortex (out)
    // 843C = Vortex of the Thnder Eye (in)
    netRegex: {
      id: ['843A', '843C'],
      source: 'Shishio'
    },
    durationSeconds: 7,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        out: outputs/* default.out */.Z.out,
        in: outputs/* default.in */.Z["in"],
        spreadThenMeleeStack: {
          en: '${inOut} + Spread => ${outIn} + Melees Stack',
          de: '${inOut} + Verteilen => ${outIn} + Nahkämpfer sammeln',
          fr: '${inOut} + Écartement => ${outIn} + Package mêlées',
          ja: '${inOut} + 散会 => ${outIn} + 近接ペア',
          cn: '${inOut} + 分散 => ${outIn} + 近战分摊',
          ko: '${inOut} + 산개 => ${outIn} + 근딜 쉐어'
        },
        spreadThenRoleStack: {
          en: '${inOut} + Spread => ${outIn} + Role Stacks',
          de: '${inOut} + Verteilen => ${outIn} + Rollengruppe sammeln',
          fr: '${inOut} + Écartement => ${outIn} + Package par rôle',
          ja: '${inOut} + 散会 => ${outIn} + ロールペア',
          cn: '${inOut} + 分散 => ${outIn} + 职能分摊',
          ko: '${inOut} + 산개 => ${outIn} + 역할별 쉐어'
        },
        spreadThenPartnerStack: {
          en: '${inOut} + Spread => ${outIn} + Partner Stacks',
          de: '${inOut} + Verteilen => ${outIn} + Partner sammeln',
          fr: '${inOut} + Écartement => ${outIn} + Package partenaire',
          ja: '${inOut} + 散会 => ${outIn} + ペア',
          cn: '${inOut} + 分散 => ${outIn} + 和搭档分摊',
          ko: '${inOut} + 산개 => ${outIn} + 파트너 쉐어'
        },
        meleeStackThenSpread: {
          en: '${inOut} + Melees Stack => ${outIn} + Spread',
          de: '${inOut} + Nahkämpfer sammeln => ${outIn} + Verteilen',
          fr: '${inOut} + Package mêlées => ${outIn} + Écartement',
          ja: '${inOut} + 近接ペア => ${outIn} + 散会',
          cn: '${inOut} + 近战分摊 => ${outIn} + 分散',
          ko: '${inOut} + 근딜 쉐어 => ${outIn} + 산개'
        },
        roleStackThenSpread: {
          en: '${inOut} + Role Stacks => ${outIn} + Spread',
          de: '${inOut} + Rollengruppe sammeln => ${outIn} + Verteilen',
          fr: '${inOut} + Package par rôle => ${outIn} + Écartement',
          ja: '${inOut} + ロールペア => ${outIn} + 散会',
          cn: '${inOut} + 职能分摊 => ${outIn} + 分散',
          ko: '${inOut} + 역할별 쉐어 => ${outIn} + 산개'
        },
        partnerStackThenSpread: {
          en: '${inOut} + Partner Stacks => ${outIn} + Spread',
          de: '${inOut} + Partner sammeln => ${outIn} + Verteilen',
          fr: '${inOut} + Package partenaire  => ${outIn} + Écartement',
          ja: '${inOut} + ペア => ${outIn} + 散会',
          cn: '${inOut} + 和搭档分摊 => ${outIn} + 分散',
          ko: '${inOut} + 파트너 쉐어 => ${outIn} + 산개'
        },
        spreadThenStack: {
          en: '${inOut} + Spread => ${outIn} + Stack',
          de: '${inOut} + Verteilen => ${outIn} + Sammeln',
          fr: '${inOut} + Écartement => ${outIn} + Package',
          ja: '${inOut} + 散会 => ${outIn} + ペア',
          cn: '${inOut} + 分散 => ${outIn} + 分摊',
          ko: '${inOut} + 산개 => ${outIn} + 쉐어'
        },
        stackThenSpread: {
          en: '${inOut} + Stack => ${outIn} + Spread',
          de: '${inOut} + Sammeln => ${outIn} + Verteilen',
          fr: '${inOut} + Package => ${outIn} + Écartement',
          ja: '${inOut} + ペア => ${outIn} + 散会',
          cn: '${inOut} + 分摊 => ${outIn} + 分散',
          ko: '${inOut} + 쉐어 => ${outIn} + 산개'
        },
        stacks: {
          en: 'Stacks: ${player1}, ${player2}',
          de: 'Sammeln: ${player1}, ${player2}',
          fr: 'Package : ${player1}, ${player2}',
          ja: '頭割り: ${player1}, ${player2}',
          cn: '分摊点: ${player1}, ${player2}',
          ko: '쉐어: ${player1}, ${player2}'
        }
      };
      const [stack1, stack2] = data.wailingCollect.filter(x => x.effectId === 'DEC');
      const spread = data.wailingCollect.find(x => x.effectId === 'DEB');
      if (stack1 === undefined || stack2 === undefined || spread === undefined) return;
      const stackTime = parseFloat(stack1.duration);
      const spreadTime = parseFloat(spread.duration);
      const isStackFirst = stackTime < spreadTime;
      const stackType = findStackPartners(data, stack1.target, stack2.target);
      const isInFirst = matches.id === '843C';
      const inOut = isInFirst ? output.in() : output.out();
      const outIn = isInFirst ? output.out() : output.in();
      const args = {
        inOut: inOut,
        outIn: outIn
      };
      const stacks = [stack1, stack2].map(x => x.target).sort();
      const [player1, player2] = stacks.map(x => data.party.member(x));
      const stackInfo = {
        infoText: output.stacks({
          player1: player1,
          player2: player2
        })
      };
      data.vortexSecondMechanic = isInFirst ? 'out' : 'in';
      data.stackSpreadFirstMechanic = isStackFirst ? stackType : 'spread';
      data.stackSpreadSecondMechanic = isStackFirst ? 'spread' : stackType;
      if (stackType === 'melee') {
        if (isStackFirst) return {
          alertText: output.meleeStackThenSpread(args),
          ...stackInfo
        };
        return {
          alertText: output.spreadThenMeleeStack(args),
          ...stackInfo
        };
      } else if (stackType === 'role') {
        if (isStackFirst) return {
          alertText: output.roleStackThenSpread(args),
          ...stackInfo
        };
        return {
          alertText: output.spreadThenRoleStack(args),
          ...stackInfo
        };
      } else if (stackType === 'partner') {
        if (isStackFirst) return {
          alertText: output.partnerStackThenSpread(args),
          ...stackInfo
        };
        return {
          alertText: output.spreadThenPartnerStack(args),
          ...stackInfo
        };
      }

      // 'unknown' catch-all
      if (isStackFirst) return {
        alertText: output.stackThenSpread(args),
        ...stackInfo
      };
      return {
        alertText: output.spreadThenStack(args),
        ...stackInfo
      };
    }
  }, {
    id: 'AMRS Shishio Vortex of the Thunder Eye Followup',
    type: 'Ability',
    // 843F = Unnatural Ailment
    // 8440 = Unnatural Force
    netRegex: {
      id: ['843F', '8440'],
      capture: false
    },
    condition: data => data.wailCount !== 1,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      const mech = data.stackSpreadSecondMechanic;
      if (mech === undefined) return;
      delete data.stackSpreadFirstMechanic;
      delete data.stackSpreadSecondMechanic;
      const mechanicStr = output[mech]();
      const inOut = data.vortexSecondMechanic;
      if (inOut === undefined) return;
      delete data.vortexSecondMechanic;
      const inOutStr = output[inOut]();
      return output.text({
        inOut: inOutStr,
        mechanic: mechanicStr
      });
    },
    outputStrings: {
      text: {
        en: '${inOut} + ${mechanic}',
        de: '${inOut} + ${mechanic}',
        fr: '${inOut} + ${mechanic}',
        ja: '${inOut} + ${mechanic}',
        cn: '${inOut} + ${mechanic}',
        ko: '${inOut} + ${mechanic}'
      },
      out: outputs/* default.out */.Z.out,
      in: outputs/* default.in */.Z["in"],
      ...basicStackSpreadOutputStrings
    }
  }, {
    id: 'AMRS Shishio Thunder Vortex',
    type: 'StartsUsing',
    netRegex: {
      id: '8439',
      source: 'Shishio',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'AMRS Shishio Devilish Thrall Collect',
    type: 'StartsUsing',
    // 8432 = Right Swipe
    // 8433 = Left Swipe
    netRegex: {
      id: ['8432', '8433'],
      source: 'Devilish Thrall'
    },
    run: (data, matches) => data.devilishThrallCollect.push(matches)
  }, {
    id: 'AMRS Shishio Devilish Thrall Safe Spot',
    type: 'StartsUsing',
    // Note: the second call of this comes out before the first one happens,
    // but it's important to know where you're going.
    netRegex: {
      id: ['8432', '8433'],
      source: 'Devilish Thrall',
      capture: false
    },
    delaySeconds: 0.5,
    durationSeconds: 6,
    suppressSeconds: 1,
    promise: async data => {
      data.combatantData = [];
      const ids = data.devilishThrallCollect.map(x => parseInt(x.sourceId, 16));
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: ids
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      if (data.combatantData.length !== 4) return;
      const centerX = 0;
      const centerY = -100;

      // Intercard thralls:
      //   x = 0 +/- 10
      //   y = -100 +/- 10
      //   heading = intercards (pi/4 + pi/2 * n)
      // Cardinal thralls:
      //   x = 0 +/- 12
      //   y = -100 +/- 12
      //   heading = cardinals (pi/2 * n)

      // One is a set of four on cardinals, the others a set of 4 on intercards.
      // There seems to be only one pattern of thralls, rotated.
      // Two are pointed inward (direct opposite to their position)
      // and two are pointed outward (perpendicular to their position).
      // Because of this, no need to check left/right cleave as position and directions tell all.
      const states = data.combatantData.map(combatant => {
        return {
          dir: util/* Directions.combatantStatePosTo8Dir */.N.combatantStatePosTo8Dir(combatant, centerX, centerY),
          heading: util/* Directions.combatantStateHdgTo8Dir */.N.combatantStateHdgTo8Dir(combatant)
        };
      });
      const outwardStates = states.filter(state => state.dir !== (state.heading + 4) % 8);
      const [pos1, pos2] = outwardStates.map(x => x.dir).sort();
      if (pos1 === undefined || pos2 === undefined || outwardStates.length !== 2) return;
      const mech = data.stackSpreadFirstMechanic ?? data.stackSpreadSecondMechanic;
      const mechanicStr = mech !== undefined ? output[mech]() : output.unknownMech();
      if (data.stackSpreadFirstMechanic) delete data.stackSpreadFirstMechanic;else if (data.stackSpreadSecondMechanic) delete data.stackSpreadSecondMechanic;

      // 0/6 (average 7) and 1/7 (average 0) are the two cases where the difference is 6 and not 2.
      const averagePos = Math.floor((pos2 + pos1 + (pos2 - pos1 === 6 ? 8 : 0)) / 2) % 8;
      const params = {
        mechanic: mechanicStr
      };
      return {
        0: output.north(params),
        1: output.northeast(params),
        2: output.east(params),
        3: output.southeast(params),
        4: output.south(params),
        5: output.southwest(params),
        6: output.west(params),
        7: output.northwest(params)
      }[averagePos];
    },
    run: data => data.devilishThrallCollect = [],
    outputStrings: {
      north: {
        en: 'North Diamond + ${mechanic}',
        de: 'nördlicher Diamant + ${mechanic}',
        fr: 'Diamant Nord + ${mechanic}',
        ja: '北 + ${mechanic}',
        cn: '上 (北) 菱形 + ${mechanic}',
        ko: '북쪽 + ${mechanic}'
      },
      east: {
        en: 'East Diamond + ${mechanic}',
        de: 'östlicher Diamant + ${mechanic}',
        fr: 'Diamant Est + ${mechanic}',
        ja: '東 + ${mechanic}',
        cn: '右 (东) 菱形 + ${mechanic}',
        ko: '동쪽 + ${mechanic}'
      },
      south: {
        en: 'South Diamond + ${mechanic}',
        de: 'südlicher Diamant + ${mechanic}',
        fr: 'Diamant Sud + ${mechanic}',
        ja: '南 + ${mechanic}',
        cn: '下 (南) 菱形 + ${mechanic}',
        ko: '남쪽 + ${mechanic}'
      },
      west: {
        en: 'West Diamond + ${mechanic}',
        de: 'westlicher Diamant + ${mechanic}',
        fr: 'Diamant Ouest + ${mechanic}',
        ja: '西 + ${mechanic}',
        cn: '左 (西) 菱形 + ${mechanic}',
        ko: '서쪽 + ${mechanic}'
      },
      northeast: {
        en: 'Northeast Square + ${mechanic}',
        de: 'nordöstliches Viereck + ${mechanic}',
        fr: 'Carré Nord-Est + ${mechanic}',
        ja: '北東 + ${mechanic}',
        cn: '右上 (东北) 正方形 + ${mechanic}',
        ko: '북동쪽 + ${mechanic}'
      },
      southeast: {
        en: 'Southeast Square + ${mechanic}',
        de: 'südöstliches Viereck + ${mechanic}',
        fr: 'Carré Sud-Est + ${mechanic}',
        ja: '南東 + ${mechanic}',
        cn: '右下 (东南) 正方形 + ${mechanic}',
        ko: '남동쪽 + ${mechanic}'
      },
      southwest: {
        en: 'Southwest Square + ${mechanic}',
        de: 'südwestliches Viereck + ${mechanic}',
        fr: 'Carré Sud-Ouest + ${mechanic}',
        ja: '南西 + ${mechanic}',
        cn: '左下 (西南) 正方形 + ${mechanic}',
        ko: '남서쪽 + ${mechanic}'
      },
      northwest: {
        en: 'Northwest Square + ${mechanic}',
        de: 'nordwestliches Viereck + ${mechanic}',
        fr: 'Carré Nord-Ouest + ${mechanic}',
        ja: '北西 + ${mechanic}',
        cn: '左上 (西北) 正方形 + ${mechanic}',
        ko: '북서쪽 + ${mechanic}'
      },
      ...basicStackSpreadOutputStrings,
      unknownMech: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'AMRS Shishio Haunting Thrall Reisho Count',
    type: 'Ability',
    // Sometimes these adds have not changed their name from Shishio to Haunting Thrall.
    netRegex: {
      id: '8434',
      capture: false
    },
    preRun: data => data.reishoCount++,
    durationSeconds: 1.5,
    // There are 8 pulses, 2 seconds apart.
    suppressSeconds: 0.5,
    // Play an alarm on the 8th one, but don't play noises for each count.
    sound: data => data.ghostMechanic === 'tower' && data.reishoCount === 8 ? undefined : '',
    alarmText: (data, _matches, output) => {
      if (data.ghostMechanic === 'tower' && data.reishoCount === 8) return output.tower();
    },
    infoText: (data, _matches, output) => output[`num${data.reishoCount}`](),
    outputStrings: {
      tower: {
        en: 'Tower',
        de: 'Türme',
        fr: 'Tour',
        ja: '塔',
        cn: '塔',
        ko: '기둥'
      },
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      num5: outputs/* default.num5 */.Z.num5,
      num6: outputs/* default.num6 */.Z.num6,
      num7: outputs/* default.num7 */.Z.num7,
      num8: outputs/* default.num8 */.Z.num8
    }
  }, {
    id: 'AMRS Shishio Haunting Thrall Headmarker',
    type: 'HeadMarker',
    netRegex: {
      id: '01D8'
    },
    condition: (data, matches) => {
      data.ghostHeadmarkers.push(matches);
      return data.ghostHeadmarkers.length === 2;
    },
    alertText: (data, _matches, output) => {
      const spread = data.ghostHeadmarkers.map(x => x.target);
      const towers = data.party.partyNames.filter(x => !spread.includes(x));
      if (spread.includes(data.me)) {
        data.ghostMechanic = 'spread';
        const otherPlayer = spread.find(x => x !== data.me) ?? output.unknown();
        return output.spread({
          player: data.party.member(otherPlayer)
        });
      }
      data.ghostMechanic = 'tower';
      const otherPlayer = towers.find(x => x !== data.me) ?? output.unknown();
      return output.tower({
        player: data.party.member(otherPlayer)
      });
    },
    outputStrings: {
      tower: {
        en: 'Get Tower (w/${player})',
        de: 'Nimm Turm mit (w/${player})',
        fr: 'Prenez une tour (avec ${player})',
        ja: '塔踏み (${player})',
        cn: '踩塔 (与${player})',
        ko: '기둥 들어가기 (+${player})'
      },
      spread: {
        en: 'Spread (w/${player})',
        de: 'Verteilen (w/${player})',
        fr: 'Écartez-vous (avec ${player})',
        ja: '散会 (${player})',
        cn: '分散 (与${player})',
        ko: '산개 들어가기 (+${player})'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  },
  // ---------------- second trash ----------------
  {
    id: 'AMRS Shishu Kotengu Backward Blows',
    type: 'StartsUsing',
    netRegex: {
      id: '866E',
      source: 'Shishu Kotengu',
      capture: false
    },
    durationSeconds: 5.7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sides (Stay Sides)',
        de: 'Seiten (Seitlich bleiben)',
        fr: 'Côtés (Restez sur les côtes',
        ja: '横へ (そのまま横)',
        cn: '两侧 (待在两侧)',
        ko: '양 옆 (양 옆에 있기)'
      }
    }
  }, {
    id: 'AMRS Shishu Kotengu Leftward Blows',
    type: 'StartsUsing',
    netRegex: {
      id: '866F',
      source: 'Shishu Kotengu',
      capture: false
    },
    durationSeconds: 5.7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Right + Behind',
        de: 'Rechts + Hinten',
        fr: 'Droite + Derrière',
        ja: '右 + 後ろ',
        cn: '右右右 + 去背后',
        ko: '오른쪽 + 뒤'
      }
    }
  }, {
    id: 'AMRS Shishu Kotengu Rightward Blows',
    type: 'StartsUsing',
    netRegex: {
      id: '8670',
      source: 'Shishu Kotengu',
      capture: false
    },
    durationSeconds: 5.7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Left + Behind',
        de: 'Links + Hinten',
        fr: 'Gauche + Derrière',
        ja: '左 + 後ろ',
        cn: '左左左 + 去背后',
        ko: '왼쪽 + 뒤'
      }
    }
  }, {
    id: 'AMRS Shishu Kotengu Wrath of the Tengu',
    type: 'StartsUsing',
    netRegex: {
      id: '8672',
      source: 'Shishu Kotengu',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'AMRS Shishu Kotengu Gaze of the Tengu',
    type: 'StartsUsing',
    netRegex: {
      id: '8673',
      source: 'Shishu Kotengu',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'AMRS Shishu Onmitsugashira Juji Shuriken',
    type: 'StartsUsing',
    netRegex: {
      id: '8676',
      source: 'Shishu Onmitsugashira',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'AMRS Shishu Onmitsugashira Issen',
    type: 'StartsUsing',
    netRegex: {
      id: '8674',
      source: 'Shishu Onmitsugashira'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AMRS Shishu Onmitsugashira Huton',
    type: 'StartsUsing',
    netRegex: {
      id: '8675',
      source: 'Shishu Onmitsugashira',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge 4x Shuriken',
        de: 'Weiche 4x Shuriken aus',
        fr: 'Évitez le shuriken x4',
        ja: '4x 手裏剣',
        cn: '躲避 4 次手里剑',
        ko: '수리검 4개 피하기'
      }
    }
  },
  // ---------------- Gorai the Uncaged ----------------
  {
    id: 'AMRS Gorai Unenlightenment',
    type: 'StartsUsing',
    netRegex: {
      id: '8534',
      source: 'Gorai the Uncaged',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe('info')
  }, {
    id: 'AMRS Gorai Brazen Ballad Purple',
    type: 'StartsUsing',
    netRegex: {
      id: '8509',
      source: 'Gorai the Uncaged',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Expanding Lines',
        de: 'Weiche den größer werdenden Linien aus',
        fr: 'Évitez les lignes en expansion',
        ja: 'AOE回避',
        cn: '远离扩大连线',
        ko: '커지는 장판들 피하기'
      }
    }
  }, {
    id: 'AMRS Gorai Brazen Ballad Blue',
    type: 'StartsUsing',
    netRegex: {
      id: '850A',
      source: 'Gorai the Uncaged',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Under Rock + Lines',
        de: 'Unter dem Stein + Linien',
        fr: 'Sous le rocher + lignes',
        ja: '石の下へ + 直線AOE',
        cn: '站在石头和线下',
        ko: '바위 밑으로 + 직선장판'
      }
    }
  }, {
    id: 'AMRS Gorai Sparks Count',
    type: 'StartsUsing',
    netRegex: {
      id: '8503',
      source: 'Gorai the Uncaged',
      capture: false
    },
    run: data => {
      data.sparksCount++;
      data.sparksCollect = [];
    }
  }, {
    id: 'AMRS Gorai Sparks Collect',
    type: 'GainsEffect',
    // E17 = Live Brazier (stack)
    // E18 = Live Candle (spread)
    netRegex: {
      effectId: ['E17', 'E18']
    },
    run: (data, matches) => data.sparksCollect.push(matches)
  }, {
    id: 'AMRS Gorai Seal of Scurrying Sparks Flame and Sulphur',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E17', 'E18'],
      capture: false
    },
    condition: data => data.sparksCount !== 2,
    delaySeconds: 0.5,
    suppressSeconds: 10,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        meleeStack: basicStackSpreadOutputStrings.melee,
        roleStack: basicStackSpreadOutputStrings.role,
        partnerStack: basicStackSpreadOutputStrings.partner,
        stacks: {
          en: 'Stacks: ${player1}, ${player2}',
          de: 'Sammeln: ${player1}, ${player2}',
          fr: 'Package : ${player1}, ${player2}',
          ja: '頭割り: ${player1}, ${player2}',
          cn: '分摊点: ${player1}, ${player2}',
          ko: '쉐어: ${player1}, ${player2}'
        }
      };
      const [stack1, stack2] = data.sparksCollect.filter(x => x.effectId === 'E17');
      if (stack1 === undefined || stack2 === undefined) return;
      const stackType = findStackPartners(data, stack1.target, stack2.target);
      const stacks = [stack1, stack2].map(x => x.target).sort();
      const [player1, player2] = stacks.map(x => data.party.member(x));
      const stackInfo = {
        infoText: output.stacks({
          player1: player1,
          player2: player2
        })
      };
      if (stackType === 'melee') {
        return {
          alertText: output.meleeStack(),
          ...stackInfo
        };
      } else if (stackType === 'role') {
        return {
          alertText: output.roleStack(),
          ...stackInfo
        };
      } else if (stackType === 'partner') {
        return {
          alertText: output.partnerStack(),
          ...stackInfo
        };
      }

      // 'unknown' catch-all
      return stackInfo;
    }
  }, {
    id: 'AMRS Gorai Seal of Scurrying Sparks Cloud to Ground',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E17', 'E18'],
      capture: false
    },
    condition: data => data.sparksCount === 2,
    delaySeconds: 0.5,
    suppressSeconds: 10,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      return stackSpreadResponse(data, output, data.sparksCollect, 'E17', 'E18');
    }
  }, {
    id: 'AMRS Gorai Seal of Scurrying Sparks Cloud to Ground Followup',
    type: 'Ability',
    // 8539 = Greater Ball of Fire
    // 8605 = Great Ball of Fire
    netRegex: {
      id: ['8539', '853A'],
      capture: false
    },
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      const mech = data.stackSpreadSecondMechanic;
      if (mech === undefined) return;
      delete data.stackSpreadFirstMechanic;
      delete data.stackSpreadSecondMechanic;
      return output[mech]();
    },
    outputStrings: basicStackSpreadOutputStrings
  }, {
    id: 'AMRS Gorai Torching Torment',
    type: 'StartsUsing',
    netRegex: {
      id: '8532',
      source: 'Gorai the Uncaged'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AMRS Gorai Impure Purgation First Hit',
    type: 'StartsUsing',
    netRegex: {
      id: '852F',
      source: 'Gorai the Uncaged',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Protean',
        de: 'Um den Boss verteilen',
        fr: 'Position autour du boss',
        ja: 'ボス基準て散開',
        cn: '四方分散',
        ko: '산개'
      }
    }
  }, {
    id: 'AMRS Gorai Impure Purgation Second Hit',
    type: 'StartsUsing',
    netRegex: {
      id: '8553',
      source: 'Gorai the Uncaged',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'AMRS Gorai Humble Hammer',
    type: 'StartsUsing',
    netRegex: {
      id: '854B',
      source: 'Gorai the Uncaged'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Shrink Lone Orb',
        de: 'Einzel-Orb verkleinern',
        fr: 'Réduire l\'orbe isolé',
        ja: '玉の処理',
        cn: '缩小单独的球',
        ko: '혼자 있는 구슬 작아지게 만들기'
      }
    }
  }, {
    id: 'AMRS Gorai Flintlock',
    type: 'StartsUsing',
    // Trigger this on the Humble Hammer damage; however this should hit
    // both one player (although possibly more) and one Ball of Levin (although possibly none)
    // so use `StartsUsing` with a delay to get the proper cast target here.
    netRegex: {
      id: '854B',
      source: 'Gorai the Uncaged'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime),
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.beBehindTank();
      if (data.role === 'tank') return output.blockLaser({
        player: data.party.member(matches.target)
      });
      return output.avoidLaser();
    },
    outputStrings: {
      beBehindTank: {
        en: 'Stay Behind Tank',
        de: 'Hinter dem Tank stehen',
        fr: 'Restez derrière le tank',
        ja: 'タンクの後ろ',
        cn: '站坦克后面',
        ko: '탱커 뒤에 서기'
      },
      blockLaser: {
        en: 'Block Laser on ${player}',
        de: 'Blockiere Laser auf ${player}',
        fr: 'Bloquer le laser sur ${player}',
        ja: '${player}の前でカバー',
        cn: '挡枪 ${player}',
        ko: '${player} 대상 레이저 앞에서 맞기'
      },
      avoidLaser: {
        en: 'Avoid Laser',
        de: 'Laser vermeiden',
        fr: 'Évitez le laser',
        ja: 'レイザー回避',
        cn: '躲避激光',
        ko: '레이저 피하기'
      }
    }
  }, {
    id: 'AMRS Gorai Rousing Reincarnation Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E0D', 'E0E', 'E0F', 'E10', 'E11', 'E12', 'E13', 'E14']
    },
    condition: data => data.rousingTowerCount === 0,
    run: (data, matches) => {
      // Odder Incarnation = blue towers
      // Rodential Rebirth = orange towers
      // durations: I = 20s, II = 26s, III = 32s, IV = 38s
      const id = matches.effectId;
      if (id === 'E11') data.rousingCollect[0].blue = matches.target;else if (id === 'E0D') data.rousingCollect[0].orange = matches.target;else if (id === 'E12') data.rousingCollect[1].blue = matches.target;else if (id === 'E0E') data.rousingCollect[1].orange = matches.target;else if (id === 'E13') data.rousingCollect[2].blue = matches.target;else if (id === 'E0F') data.rousingCollect[2].orange = matches.target;else if (id === 'E14') data.rousingCollect[3].blue = matches.target;else if (id === 'E10') data.rousingCollect[3].orange = matches.target;
    }
  }, {
    id: 'AMRS Gorai Rousing Reincarnation First Tower',
    type: 'StartsUsing',
    // Malformed Prayer cast
    netRegex: {
      id: '8518',
      source: 'Gorai the Uncaged',
      capture: false
    },
    durationSeconds: 15,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      return towerResponse(data, output);
    }
  }, {
    id: 'AMRS Gorai Rousing Reincarnation Other Towers',
    type: 'Ability',
    // Technically 8548 Pointed Purgation protean happens ~0.2s beforehand,
    // but wait on the tower burst to call things out.
    // 8546 = Burst (blue tower)
    // 8544 = Burst (orange tower)
    // 8547 = Dramatic Burst (missed tower)
    netRegex: {
      id: '8546',
      source: 'Gorai the Uncaged',
      capture: false
    },
    durationSeconds: 4,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      return towerResponse(data, output);
    }
  }, {
    id: 'AMRS Gorai Fighting Spirits',
    type: 'StartsUsing',
    netRegex: {
      id: '852B',
      source: 'Gorai the Uncaged',
      capture: false
    },
    // this is also a light aoe but knockback is more important
    response: responses/* Responses.knockback */.n3.knockback('info')
  }, {
    id: 'AMRS Gorai Fighting Spirits Limit Cut',
    type: 'HeadMarker',
    netRegex: {
      id: limitCutIds
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 6,
    alertText: (_data, matches, output) => {
      if (matches.id === headmarkers.limitCut1) return output.num1();
      if (matches.id === headmarkers.limitCut2) return output.num2();
      if (matches.id === headmarkers.limitCut3) return output.num3();
      if (matches.id === headmarkers.limitCut4) return output.num4();
    },
    outputStrings: {
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4
    }
  }, {
    id: 'AMRS Gorai Malformed Reincarnation Collect',
    type: 'GainsEffect',
    // E0D = Rodential Rebirth 1 (first orange tower)
    // E0E = Rodential Rebirth 2 (second orange tower)
    // E0F = Rodential Rebirth 3 (third orange tower)
    // E10 = Rodential Rebirth 4 (fourth orange tower)
    // E11 = Odder Incarnation 1 (first blue tower)
    // E12 = Odder Incarnation 2 (second blue tower)
    // E13 = Odder Incarnation 3 (third blue tower)
    // E14 = Odder Incarnation 4 (fourth blue tower)
    // E15 = Squirrelly Prayer (place orange tower)
    // E16 = Odder Prayer (place blue tower)
    netRegex: {
      effectId: ['E0D', 'E0E', 'E0F', 'E11', 'E12', 'E13']
    },
    condition: data => data.rousingTowerCount !== 0,
    run: (data, matches) => {
      data.malformedCollect.push(matches);
      if (matches.target === data.me) data.myMalformedEffects.push(matches.effectId);
    }
  }, {
    id: 'AMRS Gorai Malformed Reincarnation',
    // TODO: we could add more config options for this if needed, as there are many strats.
    // However, this given trigger should give enough info for most strats.
    // (1) player flex, always go mixed sides, people with all one color go to specific spots.
    //     See: https://www.youtube.com/watch?v=TzoNEWbMpQ0#t=7m53s
    // (2) no player flexing, go to opposite side, run THROUGH, possible swap sides for tower
    //     See: https://ff14.toolboxgaming.space/?id=938195953989861&preview=1
    // (3) different strats for half mixed / full mixed, flex only on full mixed
    //     See: https://raidplan.io/plan/9tVR4vj9kPjgF3PM
    comment: {
      en: `Full mixed means everybody has both colors (two of one, one of the other).
             Half mixed means two people have both colors and two people have all the same color.`,
      de: `Voll gemischt bedeutet, dass jeder beide Farben hat (zwei von der einen, eine von der anderen).
             Halb gemischt bedeutet, dass zwei Personen beide Farben haben und zwei Personen nur eine Farbe haben`,
      fr: `Complètement mixé signifie que tout le monde à les deux couleurs (deux de l'une et un de l'autre).
           Mixé à moitié signifie que deux personnes ont les deux couleurs et deux ont la même couleur.`,
      cn: `全异色 指的是所有人的 3 个 buff 中有 2 个同色 buff (2 个是一种颜色, 剩下 1 个是另一种)。
             半异色 指的是 2 个人有 2 个同色buff, 其余 2 人拥有 3 个同色buff。`,
      ko: `완전 혼합은 모든 사람이 두 가지 색을 가지고 있음을 의미합니다 (한 가지 색 두 개, 다른 색 하나).
             반혼합은 두 사람이 두 가지 종류를 가지고 있고, 다른 두 사람은 모두 같은 색을 가지고 있음을 의미합니다.`
    },
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E0D', 'E0E', 'E0F', 'E11', 'E12', 'E13'],
      capture: false
    },
    condition: data => data.rousingTowerCount !== 0,
    delaySeconds: 0.5,
    durationSeconds: 10,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        alertText: {
          en: '${color1} -> ${color2} -> ${color3} (${mixedType})',
          de: '${color1} -> ${color2} -> ${color3} (${mixedType})',
          fr: '${color1} -> ${color2} -> ${color3} (${mixedType})',
          ja: '${color1} -> ${color2} -> ${color3} (${mixedType})',
          cn: '${color1} -> ${color2} -> ${color3} (${mixedType})',
          ko: '${color1} -> ${color2} -> ${color3} (${mixedType})'
        },
        infoText: {
          en: '(first ${color} w/${player})',
          de: '(zuerst ${color} mit ${player})',
          fr: '(premier ${color} avec ${player})',
          ja: '1番 ${color} +${player}',
          cn: '(第一个 ${color} 和 ${player})',
          ko: '1번 ${color} +${player}'
        },
        orange: {
          en: 'Orange',
          de: 'Orange',
          fr: 'Orange',
          ja: '赤',
          cn: '橙色',
          ko: '주황'
        },
        blue: {
          en: 'Blue',
          de: 'Blau',
          fr: 'Bleu',
          ja: '青',
          cn: '蓝色',
          ko: '파랑'
        },
        mixedTypeFull: {
          en: 'full mixed',
          de: 'Voll gemischt',
          fr: 'Complètement mixé',
          ja: '全混合',
          cn: '全异色',
          ko: '완전 혼합'
        },
        mixedTypeHalf: {
          en: 'half mixed',
          de: 'Halb gemischt',
          fr: 'Mixé à moitié',
          ja: '半分混合',
          cn: '半异色',
          ko: '반혼합'
        },
        unknown: outputs/* default.unknown */.Z.unknown
      };
      let playerCount = 0;
      let mixedCount = 0;
      const firstColor = {};
      const myColors = [];
      for (const line of data.malformedCollect) {
        const isOrange = line.effectId === 'E0D' || line.effectId === 'E0E' || line.effectId === 'E0F';
        const color = isOrange ? 'orange' : 'blue';
        if (line.target === data.me) myColors.push(color);
        const lastColor = firstColor[line.target];
        if (lastColor === undefined) {
          playerCount++;
          firstColor[line.target] = color;
          continue;
        }
        if (lastColor === color) continue;
        mixedCount++;
      }
      const [color1, color2, color3] = myColors;
      if (color1 === undefined || color2 === undefined || color3 === undefined) return;

      // Try to handle dead players who don't have debuffs here.
      const isAllMixed = playerCount === mixedCount;
      const mixedType = isAllMixed ? output.mixedTypeFull() : output.mixedTypeHalf();
      let partner = output.unknown();
      for (const [name, color] of Object.entries(firstColor)) {
        if (name !== data.me && color === color1) {
          partner = data.party.member(name);
          break;
        }
      }
      const alertText = output.alertText({
        color1: output[color1](),
        color2: output[color2](),
        color3: output[color3](),
        mixedType: mixedType
      });
      const infoText = output.infoText({
        color: output[color1](),
        player: partner
      });
      return {
        alertText,
        infoText
      };
    }
  }, {
    id: 'AMRS Gorai Malformed First Tower',
    type: 'LosesEffect',
    // E15 = Squirrelly Prayer (place orange tower)
    // E16 = Odder Prayer (place blue tower)
    netRegex: {
      effectId: ['E15', 'E16']
    },
    condition: (data, matches) => data.me === matches.target,
    durationSeconds: 4,
    alertText: (data, _matches, output) => {
      const effectId = data.myMalformedEffects.shift();
      if (effectId === 'E0D') return output.orangeTower1();
      if (effectId === 'E11') return output.blueTower1();
    },
    outputStrings: {
      blueTower1: {
        en: 'Inside Blue Tower 1',
        de: 'Innerhalb blauer Turm 1',
        fr: 'À l\'intérieur de la tour bleue 1',
        ja: '内側の青塔1',
        cn: '内侧 蓝塔 1',
        ko: '안쪽 파랑 기둥1'
      },
      orangeTower1: {
        en: 'Inside Orange Tower 1',
        de: 'Innerhalb orangener Turm 1',
        fr: 'À l\'intérieur de la tour orange 1',
        ja: '内側の赤塔1',
        cn: '内侧 橙塔 1',
        ko: '안쪽 주황 기둥1'
      }
    }
  }, {
    id: 'AMRS Gorai Malformed Other Towers',
    type: 'Ability',
    netRegex: {
      id: '8546',
      source: 'Gorai the Uncaged',
      capture: false
    },
    condition: data => data.myMalformedEffects.length > 0,
    durationSeconds: 2,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      const effectId = data.myMalformedEffects.shift();
      if (effectId === 'E0E') return output.orangeTower2();
      if (effectId === 'E0F') return output.orangeTower3();
      if (effectId === 'E12') return output.blueTower2();
      if (effectId === 'E13') return output.blueTower3();
    },
    outputStrings: {
      blueTower1: {
        en: 'Inside Blue Tower 1',
        de: 'Mittig blauer Turm 1',
        fr: 'À l\'intérieur de la tour bleue 1',
        ja: '内側の青塔1',
        cn: '内侧 蓝塔 1',
        ko: '안쪽 파랑 기둥 1'
      },
      orangeTower1: {
        en: 'Inside Orange Tower 1',
        de: 'Mittig orangener Turm 1',
        fr: 'À l\'intérieur de la tour orange 1',
        ja: '内側の赤塔1',
        cn: '内侧 橙塔 1',
        ko: '안쪽 주황 기둥 1'
      },
      blueTower2: {
        en: 'Corner Blue Tower 2',
        de: 'Ecke blauer Turm 2',
        fr: 'Tour bleu 2 dans le coin',
        ja: '隅の青塔2',
        cn: '角落 蓝塔 2',
        ko: '구석 파랑 기둥 2'
      },
      orangeTower2: {
        en: 'Corner Orange Tower 2',
        de: 'Ecke orangener Turm 2',
        fr: 'Tour orange 2 dans le coin',
        ja: '隅の赤塔2',
        cn: '角落 橙塔 2',
        ko: '구석 주황 기둥 2'
      },
      blueTower3: {
        en: 'Placed Blue Tower 3',
        de: 'Platzierter blauer Turm 3',
        fr: 'Tour bleue placée 3',
        ja: '設置した青塔3',
        cn: '放置 蓝塔 3',
        ko: '설치한 파랑 기둥 3'
      },
      orangeTower3: {
        en: 'Placed Orange Tower 3',
        de: 'Platzierter orangener Turm 3',
        fr: 'Tour orange placée 3',
        ja: '設置した赤塔3',
        cn: '放置 橙塔 3',
        ko: '설치한 주황 기둥 3'
      }
    }
  }, {
    id: 'AMRS Gorai Fire Spread',
    type: 'Ability',
    netRegex: {
      id: '8541',
      source: 'Gorai the Uncaged',
      capture: false
    },
    suppressSeconds: 30,
    response: responses/* Responses.moveAway */.n3.moveAway()
  },
  // ---------------- Moko the Restless ----------------
  {
    id: 'AMRS Moko Kenki Release',
    type: 'StartsUsing',
    netRegex: {
      id: '860C',
      source: 'Moko the Restless',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'AMRS Moko Triple Kasumi-giri Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(mokoVfxMap)
    },
    run: (data, matches) => {
      const thisAbility = looseMokoVfxMap[matches.count];
      if (thisAbility === undefined) return;
      data.tripleKasumiCollect.push(thisAbility);
    }
  }, {
    id: 'AMRS Moko Triple Kasumi-giri 1',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(mokoVfxMap),
      capture: false
    },
    condition: data => data.tripleKasumiCollect.length === 1,
    durationSeconds: 10,
    alertText: (data, _matches, output) => {
      const [ability] = data.tripleKasumiCollect;
      if (ability === undefined) return;
      return output[`${ability}First`]();
    },
    outputStrings: tripleKasumiFirstOutputStrings
  }, {
    id: 'AMRS Moko Triple Kasumi-giri 2',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(mokoVfxMap),
      capture: false
    },
    condition: data => data.tripleKasumiCollect.length === 2,
    infoText: (data, _matches, output) => {
      const ability = data.tripleKasumiCollect[1];
      if (ability === undefined) return;
      const text = output[ability]();
      return output.text({
        text: text
      });
    },
    outputStrings: {
      text: {
        en: '(${text})',
        de: '(${text})',
        fr: '(${text})',
        ja: '(${text})',
        cn: '(${text})',
        ko: '(${text})'
      },
      ...tripleKasumiFollowupOutputStrings
    }
  }, {
    id: 'AMRS Moko Triple Kasumi-giri 3',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(mokoVfxMap),
      capture: false
    },
    condition: data => data.tripleKasumiCollect.length === 3,
    durationSeconds: 10,
    infoText: (data, _matches, output) => {
      const [ability1, ability2, ability3] = data.tripleKasumiCollect;
      if (ability1 === undefined || ability2 === undefined || ability3 === undefined) return;
      const text1 = output[`${ability1}First`]();
      const text2 = output[ability2]();
      const text3 = output[ability3]();
      return output.text({
        text1: text1,
        text2: text2,
        text3: text3
      });
    },
    outputStrings: {
      text: {
        en: '${text1} => ${text2} => ${text3}',
        de: '${text1} => ${text2} => ${text3}',
        fr: '${text1} => ${text2} => ${text3}',
        ja: '${text1} => ${text2} => ${text3}',
        cn: '${text1} => ${text2} => ${text3}',
        ko: '${text1} => ${text2} => ${text3}'
      },
      ...tripleKasumiFirstOutputStrings,
      ...tripleKasumiFollowupOutputStrings
    }
  }, {
    id: 'AMRS Moko Triple Kasumi-giri Followup',
    type: 'Ability',
    netRegex: {
      id: tripleKasumiAbilityIds,
      source: 'Moko the Restless',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      // First one has already been called, so ignore it.
      if (data.tripleKasumiCollect.length === 3) data.tripleKasumiCollect.shift();
      const ability = data.tripleKasumiCollect.shift();
      if (ability === undefined) return;
      return output[ability]();
    },
    outputStrings: tripleKasumiFollowupOutputStrings
  }, {
    id: 'AMRS Moko Lateral Slice',
    type: 'StartsUsing',
    netRegex: {
      id: '860D',
      source: 'Moko the Restless'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AMRS Moko Scarlet Auspice',
    type: 'StartsUsing',
    netRegex: {
      id: '8600',
      source: 'Moko the Restless',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sides + Out => Stay Out',
        de: 'Seiten + Raus => Bleib drausen',
        fr: 'Côtés + Extérieur => Restez à l\'extérieur',
        ja: '横へ + 外 => そのまま外',
        cn: '两侧 + 远离 => 待在外面',
        ko: '양 옆 + 밖 => 밖에 있기'
      }
    }
  }, {
    id: 'AMRS Moko Azure Auspice',
    type: 'StartsUsing',
    netRegex: {
      id: '8603',
      source: 'Moko the Restless',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Under => Sides + Out',
        de: 'Unter ihn => Seiten + Geh Raus',
        fr: 'Dessous => Côtés + Extérieur',
        ja: 'ボスの下へ => 横へ + 外',
        cn: '去脚下 => 两侧 + 出去',
        ko: '안 => 양 옆 + 밖'
      }
    }
  }, {
    id: 'AMRS Moko Azure Auspice Followup',
    type: 'Ability',
    netRegex: {
      id: '8603',
      source: 'Moko the Restless',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sides + Out',
        de: 'Seiten + Raus',
        fr: 'Côtés + Extérieur',
        ja: '横へ + 外',
        cn: '两侧 + 出去',
        ko: '양 옆 + 밖'
      }
    }
  }, {
    id: 'AMRS Moko Fire Line Collect',
    type: 'MapEffect',
    // flags:
    //   00010001 = make lines appear (both blue and red)
    //   00100020 = make lines glow (both blue and red)
    // locations:
    //   2C = N (fire)
    //   2D = NW<->SE (fire)
    //   2E = NE<->SW (fire)
    //   2F = S (fire)
    //   30-33 = blue lines, some order
    netRegex: {
      flags: '00100020',
      location: '2[CDEF]'
    },
    condition: (data, matches) => {
      data.explosionLineCollect.push(matches);
      return data.explosionLineCollect.length === 2;
    },
    durationSeconds: 5,
    alertText: (data, _matches, output) => {
      const isNorth = data.explosionLineCollect.find(x => x.location === '2F') !== undefined;
      const isSWOrNE = data.explosionLineCollect.find(x => x.location === '2D') !== undefined;
      if (isNorth) return isSWOrNE ? output.dirNE() : output.dirNW();
      return isSWOrNE ? output.dirSW() : output.dirSE();
    },
    outputStrings: {
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirSW: outputs/* default.dirSW */.Z.dirSW,
      dirNW: outputs/* default.dirNW */.Z.dirNW,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'AMRS Moko Invocation Collect',
    type: 'GainsEffect',
    // E1A = Vengeful Flame (spread)
    // E1B = Vengeful Pyre (stack)
    netRegex: {
      effectId: ['E1A', 'E1B']
    },
    run: (data, matches) => data.invocationCollect.push(matches)
  }, {
    id: 'AMRS Moko Invocation of Vengeance',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E1A', 'E1B'],
      capture: false
    },
    delaySeconds: 0.5,
    durationSeconds: 5,
    suppressSeconds: 999999,
    response: (data, _matches, output) => {
      // cactbot-builtin-response

      // TODO: the timing of this is a little bit tough to condense:
      //   t=0.0 these effects
      //   t=2.3 tether appears
      //   t=2.7 explosion lines start glowing
      // Right now we just call everything separately to call it as soon as possible.
      // A more complicated alternative to be to call this here, and then slightly later
      // figure out who should stack with the tether where, since you know if it's a melee stack
      // and the melee has a tether you could tell people "Stack with Tether SE" kind of thing.
      //
      // However, because there's so many calls, we'll drop the "stacks on" part of this.
      return stackSpreadResponse(data, output, data.invocationCollect, 'E1B', 'E1A', true);
    }
  }, {
    id: 'AMRS Moko Invocation of Vengeance Followup',
    type: 'Ability',
    // 8608 = Vengeful Flame
    // 8609 = Vengeful Pyre
    netRegex: {
      id: ['8608', '8609'],
      capture: false
    },
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      const mech = data.stackSpreadSecondMechanic;
      if (mech === undefined) return;
      delete data.stackSpreadFirstMechanic;
      delete data.stackSpreadSecondMechanic;
      return output[mech]();
    },
    outputStrings: basicStackSpreadOutputStrings
  }, {
    id: 'AMRS Moko Iai-giri Cleanup',
    type: 'StartsUsing',
    // 85C2 = Fleeting Iai-giri (from Moko the Restless)
    // 85C8 = Double Iai-giri (from Moko's Shadow)
    netRegex: {
      id: ['85C2', '85C8'],
      capture: false
    },
    // Clean up once so we can collect casts.
    suppressSeconds: 5,
    run: data => {
      data.iaigiriTether = [];
      data.iaigiriPurple = [];
      data.iaigiriCasts = [];
      delete data.myAccursedEdge;
      delete data.myIaigiriTether;
      delete data.oniClaw;
    }
  }, {
    id: 'AMRS Moko Iai-giri Tether Collect',
    type: 'Tether',
    netRegex: {
      id: '0011'
    },
    run: (data, matches) => {
      data.iaigiriTether.push(matches);
      if (matches.target === data.me) data.myIaigiriTether = matches;
    }
  }, {
    id: 'AMRS Moko Iai-giri Purple Marker Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(shadowVfxMap)
    },
    run: (data, matches) => data.iaigiriPurple.push(matches)
  }, {
    id: 'AMRS Moko Iai-giri Double Iai-giri Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '85C8',
      source: 'Moko\'s Shadow'
    },
    run: (data, matches) => data.iaigiriCasts.push(matches)
  }, {
    id: 'AMRS Moko Iai-giri Accursed Edge Collect',
    type: 'Ability',
    netRegex: {
      id: '8607'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // You could (but shouldn't) be hit by multiple of these, so just take the last.
    run: (data, matches) => data.myAccursedEdge = matches
  }, {
    id: 'AMRS Moko Fleeting Iai-giri',
    type: 'Tether',
    netRegex: {
      id: '0011',
      capture: false
    },
    delaySeconds: 0.5,
    durationSeconds: 7,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        backOnYou: {
          en: 'Back Tether on YOU',
          de: 'Zurück-Verbindung auf DIR',
          fr: 'Lien arrière sur VOUS',
          ja: '自分の後ろに線',
          cn: '后方连线点名!',
          ko: '선-뒤쪽 대상자'
        },
        leftOnYou: {
          en: 'Left Tether on YOU',
          de: 'Links-Verbindung auf DIR',
          fr: 'Lien à gauche sur VOUS',
          ja: '自分の左に線',
          cn: '左侧连线点名!',
          ko: '선-왼쪽 대상자'
        },
        frontOnYou: {
          en: 'Front Tether on YOU',
          de: 'Vorne-Verbindung auf DIR',
          fr: 'Lien avant sur VOUS',
          ja: '自分の前に線',
          cn: '前方连线点名!',
          ko: '선-앞쪽 대상자'
        },
        rightOnYou: {
          en: 'Right Tether on YOU',
          de: 'Rechts-Verbindung auf DIR',
          fr: 'Lien à droite sur VOUS',
          ja: '自分の右に線',
          cn: '右侧连线点名!',
          ko: '선-오른쪽 대상자'
        },
        backOnPlayer: {
          en: 'Back Tether on ${player}',
          de: 'Zurück-Verbindung auf ${player}',
          fr: 'Lien arrière sur ${player}',
          ja: '後ろの線: ${player}',
          cn: '后方连线点 ${player}',
          ko: '선-뒤쪽 ${player}'
        },
        leftOnPlayer: {
          en: 'Left Tether on ${player}',
          de: 'Links-Verbindung auf ${player}',
          fr: 'Lien à gauche sur ${player}',
          ja: '左の線: ${player}',
          cn: '左侧连线点 ${player}',
          ko: '선-왼쪽 ${player}'
        },
        frontOnPlayer: {
          en: 'Front Tether on ${player}',
          de: 'Vorne-Verbindung auf ${player}',
          fr: 'Lien avant sur ${player}',
          ja: '前の線: ${player}',
          cn: '前方连线点 ${player}',
          ko: '선-앞쪽 ${player}'
        },
        rightOnPlayer: {
          en: 'Right Tether on ${player}',
          de: 'Rechts-Verbindung auf ${player}',
          fr: 'Lien à droite sur ${player}',
          ja: '右の線: ${player}',
          cn: '右侧连线点 ${player}',
          ko: '선-오른쪽 ${player}'
        }
      };
      if (data.iaigiriTether.length !== 1 || data.iaigiriPurple.length !== 1) return;
      const [tether] = data.iaigiriTether;
      const [marker] = data.iaigiriPurple;
      if (tether === undefined || marker === undefined) return;
      const thisAbility = looseShadowVfxMap[marker.count];
      if (thisAbility === undefined) return;
      const player = tether.target;
      if (player === data.me) {
        const outputKey = `${thisAbility}OnYou`;
        return {
          alarmText: output[outputKey]()
        };
      }
      const outputKey = `${thisAbility}OnPlayer`;
      return {
        infoText: output[outputKey]({
          player: data.party.member(player)
        })
      };
    }
  }, {
    id: 'AMRS Moko Double Shadow Kasumi-giri Initial',
    type: 'Tether',
    netRegex: {
      id: '0011',
      capture: false
    },
    condition: data => !data.seenSoldiersOfDeath,
    delaySeconds: 0.5,
    durationSeconds: 4,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        backOnYou: {
          en: 'Back Tether (${partners})',
          de: 'Zurück-Verbindung (${partners}))',
          fr: 'Lien arrière (${partners})',
          ja: '後ろの線 (${partners})',
          cn: '后方连线 (和 ${partners})',
          ko: '선-뒤쪽 (${partners})'
        },
        // These are probably impossible.
        leftOnYou: {
          en: 'Left Tether (${partners})',
          de: 'Links-Verbindung (${partners})',
          fr: 'Lien à gauche (${partners})',
          ja: '左の線 (${partners})',
          cn: '左侧连线 (和 ${partners})',
          ko: '선-왼쪽 (${partners})'
        },
        frontOnYou: {
          en: 'Front Tether (${partners})',
          de: 'Vorne-Verbindung (${partners})',
          fr: 'Lien avant (${partners})',
          ja: '前の線 (${partners})',
          cn: '前方连线 (和 ${partners})',
          ko: '선-앞쪽 (${partners})'
        },
        rightOnYou: {
          en: 'Right Tether (${partners})',
          de: 'Rechts-Verbindung (${partners})',
          fr: 'Lien à droite (${partners})',
          ja: '右の線 (${partners})',
          cn: '右侧连线 (和 ${partners})',
          ko: '선-오른쪽 (${partners})'
        },
        unmarked: {
          en: 'Unmarked (${partners})',
          de: 'Unmarkiert (${partners})',
          fr: 'Non-marqué (${partners})',
          ja: '線なし (${partners})',
          cn: '无点名 (和 ${partners})',
          ko: '무징 (${partners})'
        },
        melee: {
          en: 'melees together',
          de: 'Nahkämpfer zusammen',
          fr: 'Mêlées ensemble',
          ja: '近接ペア',
          cn: '近战同组',
          ko: '근딜끼리'
        },
        role: {
          en: 'roles together',
          de: 'Rollen zusammen',
          fr: 'Rôles ensemble',
          ja: 'ロールペア',
          cn: '职能分组',
          ko: '역할군끼리'
        },
        partner: {
          en: 'partners together',
          de: 'Partner zusammen',
          fr: 'Partenaires ensemble',
          ja: 'ペア',
          cn: '搭档分组',
          ko: '파트너끼리'
        },
        unknown: outputs/* default.unknown */.Z.unknown
      };
      if (data.iaigiriTether.length !== 2 || data.iaigiriPurple.length !== 2) return;
      const [tether1, tether2] = data.iaigiriTether;
      const [marker1, marker2] = data.iaigiriPurple;
      if (tether1 === undefined || tether2 === undefined || marker1 === undefined || marker2 === undefined) return;
      const player1 = tether1.target;
      const player2 = tether2.target;
      const stackType = findStackPartners(data, player1, player2);
      const stackStr = output[stackType]();
      if (data.myIaigiriTether === undefined) return {
        alertText: output.unmarked({
          partners: stackStr
        })
      };
      const myMarker = marker1.sourceId === data.myIaigiriTether.sourceId ? marker1 : marker2;
      const thisAbility = looseShadowVfxMap[myMarker.count];
      if (thisAbility === undefined) return;
      const outputKey = `${thisAbility}OnYou`;
      return {
        alarmText: output[outputKey]({
          partners: stackStr
        })
      };
    }
  }, {
    id: 'AMRS Moko Oni Claw',
    type: 'GainsEffect',
    // This happens ~2.3 seconds prior to the Clearout/Far Edge/Near Edge cast starting,
    // and is the first time these adds appear in the log other than 261 change lines
    // which reposition these adds immediately prior to them gaining this effect.
    netRegex: {
      effectId: '808',
      count: '257'
    },
    suppressSeconds: 1,
    promise: async (data, matches) => {
      data.combatantData = [];
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.targetId, 16)]
      })).combatants;
    },
    // This is infoText to not conflict with the Unmarked/Tether calls.
    // We could combine this with the Near Far Edge call, but it seemed better to say it sooner.
    infoText: (data, _matches, output) => {
      const [combatant] = data.combatantData;
      if (combatant === undefined || data.combatantData.length !== 1) return;
      const dir = util/* Directions.xyTo4DirNum */.N.xyTo4DirNum(combatant.PosX, combatant.PosY, mokoCenterX, mokoCenterY);
      data.oniClaw = dir === 1 || dir === 3 ? 'northSouth' : 'eastWest';
      if (data.oniClaw === 'northSouth') return output.northSouth();
      return output.eastWest();
    },
    outputStrings: {
      northSouth: {
        en: 'North/South',
        de: 'Norden/Süden',
        fr: 'Nord/Sud',
        ja: '北・南',
        cn: '上 (北)/下 (南)',
        ko: '북쪽/남쪽'
      },
      eastWest: {
        en: 'East/West',
        de: 'Osten/Westen',
        fr: 'Est/Ouest',
        ja: '東・西',
        cn: '左 (西)/右 (东)',
        ko: '동쪽/서쪽'
      }
    }
  }, {
    id: 'AMRS Moko Near Far Edge',
    type: 'StartsUsing',
    // 85D8 = Far Edge
    // 85D9 = Near Edge
    netRegex: {
      id: ['85D8', '85D9'],
      source: 'Moko the Restless'
    },
    alertText: (data, matches, output) => {
      const isFarEdge = matches.id === '85D8';
      if (data.myIaigiriTether === undefined) return isFarEdge ? output.baitFar() : output.baitNear();
      return isFarEdge ? output.tetherNear() : output.tetherFar();
    },
    outputStrings: {
      baitNear: {
        en: 'Bait Near (Tether Far)',
        de: 'Nah ködern (Verbindung Fern)',
        fr: 'Attirez proche (Lien éloigné)',
        ja: 'ニア (線ファー)',
        cn: '靠近引导 (连线远离)',
        ko: '유도 가까이 (선 멀리)'
      },
      baitFar: {
        en: 'Bait Far (Tether Near)',
        de: 'Fern ködern (Verbindung Nah)',
        fr: 'Attirez loin (Lien proche)',
        ja: 'ファー (線ニア)',
        cn: '远离引导 (连线靠近)',
        ko: '멀리 유도 (선 가까이)'
      },
      tetherNear: {
        en: 'Tether Near (Bait Far)',
        de: 'Verbindung Nahe (Fern ködern)',
        fr: 'Lien proche (Attirez loin)',
        ja: '線ニア (誘導ファー)',
        cn: '靠近拉线 (引导远离)',
        ko: '선 가까이 (유도 가까이)'
      },
      tetherFar: {
        en: 'Tether Far (Bait Near)',
        de: 'Verbindung Fern (Nahe ködern)',
        fr: 'Lien éloigné (Attirez proche)',
        ja: '線ファー (誘導ニア)',
        cn: '远离拉线 (引导靠近)',
        ko: '선 멀리 (유도 멀리)'
      }
    }
  }, {
    id: 'AMRS Moko Double Shadow Kasumi-giri Second Mark',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(shadowVfxMap)
    },
    condition: (data, matches) => {
      if (data.seenSoldiersOfDeath) return false;

      // Ignore the first set of marks, which get called with the tether.
      if (data.iaigiriPurple.length <= 2) return false;

      // For the first two Double-Iaigiris before Soldiers of Death,
      // if this is the 4th mark (i.e. the 2nd in the 2nd set) and they are both the same,
      // then we can call that mark for everyone because it doesn't matter where they are.
      const third = data.iaigiriPurple[2]?.count;
      const fourth = data.iaigiriPurple[3]?.count;
      if (third === fourth && third !== undefined && !data.seenSoldiersOfDeath) return true;

      // See if the current player is attached to a tether that
      // is attached to the mob gaining this effect.
      // Since we aren't sure where the baiters are we can't really tell them anything.
      return data.myIaigiriTether?.sourceId === matches.targetId;
    },
    // Don't collide with Near Far Edge, which is more important.
    delaySeconds: 3,
    durationSeconds: 5.5,
    suppressSeconds: 5,
    infoText: (data, matches, output) => {
      const third = data.iaigiriPurple[2]?.count;
      const fourth = data.iaigiriPurple[3]?.count;
      if (third === fourth && third !== undefined && !data.seenSoldiersOfDeath) {
        const thisAbility = looseShadowVfxMap[third];
        if (thisAbility === undefined) return;
        return output[thisAbility]();
      }
      const thisAbility = looseShadowVfxMap[matches.count];
      if (thisAbility === undefined) return;
      return output[thisAbility]();
    },
    outputStrings: {
      // This is probably not possible.
      back: {
        en: '(then stay)',
        de: '(bleib stehen)',
        fr: '(puis restez)',
        ja: '(後はそのまま)',
        cn: '(稍后 停)',
        ko: '(이후 그대로)'
      },
      left: {
        en: '(then left)',
        de: '(dann links)',
        fr: '(puis à gauche)',
        ja: '(後は左)',
        cn: '(稍后 去左侧)',
        ko: '(이후 왼쪽)'
      },
      front: {
        en: '(then through)',
        de: '(dann durchgehen)',
        fr: '(puis devant)',
        ja: '(後はまたいで移動)',
        cn: '(稍后 穿)',
        ko: '(이후 가로지르기)'
      },
      right: {
        en: '(then right)',
        de: '(dann rechts)',
        fr: '(puis à droite)',
        ja: '(後は右)',
        cn: '(稍后 去右侧)',
        ko: '(이후 오른쪽)'
      }
    }
  }, {
    id: 'AMRS Moko Shadow Kasumi-giri Back Tether',
    type: 'Ability',
    netRegex: {
      id: '85C9',
      source: 'Moko\'s Shadow'
    },
    condition: (data, matches) => data.myIaigiriTether?.sourceId === matches.sourceId,
    durationSeconds: 2,
    // Maybe you have two tethers, although it probably won't go well.
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.back(),
    outputStrings: {
      // This is a reminder to make sure to move after the clone jumps to you.
      // TODO: should see this say Back => Right or something?
      back: outputs/* default.back */.Z.back
    }
  }, {
    id: 'AMRS Moko Shadow Kasumi-giri Followup',
    type: 'Ability',
    netRegex: {
      id: '85F9',
      source: 'Moko\'s Shadow'
    },
    condition: (data, matches) => {
      // Reject anybody not tethered by this add or not on the same side.
      if (data.myIaigiriTether === undefined) {
        if (data.oniClaw === 'northSouth') {
          const myYStr = data.myAccursedEdge?.targetY;
          if (myYStr === undefined) return false;
          const thisY = parseFloat(matches.y);
          const myY = parseFloat(myYStr);
          if (myY < mokoCenterY && thisY > mokoCenterY || myY > mokoCenterY && thisY < mokoCenterY) return false;
        } else if (data.oniClaw === 'eastWest') {
          const myXStr = data.myAccursedEdge?.targetX;
          if (myXStr === undefined) return false;
          const thisX = parseFloat(matches.x);
          const myX = parseFloat(myXStr);
          if (myX < mokoCenterX && thisX > mokoCenterX || myX > mokoCenterX && thisX < mokoCenterX) return false;
        } else if (data.oniClaw === undefined) {
          // missing data.oniClaw somehow??
          return false;
        }
      } else if (matches.sourceId !== data.myIaigiriTether.sourceId) {
        return false;
      }
      return true;
    },
    suppressSeconds: 1,
    alertText: (data, matches, output) => {
      // Find the second marker for this add.
      const marker = [...data.iaigiriPurple].reverse().find(x => {
        return x.targetId === matches.sourceId;
      });
      if (marker === undefined) return;
      const thisAbility = looseShadowVfxMap[marker.count];
      if (thisAbility === undefined) return;
      return output[thisAbility]();
    },
    outputStrings: {
      // This probably can't happen.
      back: {
        en: 'Stay',
        de: 'Bleib stehen',
        fr: 'Restez',
        ja: 'そのまま',
        cn: '停',
        ko: '그대로'
      },
      left: outputs/* default.left */.Z.left,
      front: {
        en: 'Through',
        de: 'Lauf durch',
        fr: 'À travers',
        ja: 'またいで',
        cn: '穿',
        ko: '가로지르기'
      },
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'AMRS Moko Soldiers of Death',
    type: 'StartsUsing',
    netRegex: {
      id: '8593',
      source: 'Moko the Restless',
      capture: false
    },
    run: (data, _matches) => data.seenSoldiersOfDeath = true
  }, {
    id: 'AMRS Moko Soldiers of Death Blue Add',
    type: 'GainsEffect',
    // The red soldiers get 1E8 effects, and the blue add gets 5E.
    netRegex: {
      effectId: '808',
      count: '5E'
    },
    promise: async (data, matches) => {
      data.combatantData = [];
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.targetId, 16)]
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      const [combatant] = data.combatantData;
      if (combatant === undefined || data.combatantData.length !== 1) return;
      const x = combatant.PosX - mokoCenterX;
      const y = combatant.PosY - mokoCenterY;

      // This add is off the edge (far) and then along that edge (less far).
      // We need to look at the "less far" direction and go opposite.
      // Additionally, if the add is north/south it will shoot "short"
      // and if it is east/west then it will shoot "long".
      const isShootingLongFromEastWest = Math.abs(x) > Math.abs(y);
      const isEast = x > 0;
      const isNorth = y < 0;
      if (isShootingLongFromEastWest) {
        if (isNorth) return isEast ? output.dirSE() : output.dirSW();
        return isEast ? output.dirNE() : output.dirNW();
      }
      if (isEast) return isNorth ? output.dirSW() : output.dirNW();
      return isNorth ? output.dirSE() : output.dirNE();
    },
    outputStrings: {
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirSW: outputs/* default.dirSW */.Z.dirSW,
      dirNW: outputs/* default.dirNW */.Z.dirNW
    }
  }, {
    id: 'AMRS Moko Soldiers of Death Shadow Kasumi-giri Tether',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(shadowVfxMap),
      capture: false
    },
    // Ignore the first set of marks, which get called with the tether.
    condition: data => data.iaigiriPurple.length > 4,
    // Wait to collect or call immediately if we have everything.
    delaySeconds: data => data.iaigiriPurple.length === 8 ? 0 : 0.5,
    durationSeconds: 5,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      const myTether = data.myIaigiriTether;
      if (myTether === undefined) return;

      // Find the second marker for this add.
      const marker = [...data.iaigiriPurple].reverse().find(x => {
        return x.targetId === myTether.sourceId;
      });
      if (marker === undefined) return;
      const thisAbility = looseShadowVfxMap[marker.count];
      if (thisAbility !== 'left' && thisAbility !== 'right') return;

      // Find the matching marker for your marker.
      const matchingMarkers = data.iaigiriPurple.filter(x => {
        return x.count === marker.count && x.targetId !== marker.targetId;
      });
      // Make sure there's only one matching symbol, just in case.
      const [partnerMarker] = matchingMarkers;
      if (partnerMarker === undefined || matchingMarkers.length !== 1) return;

      // Find the matching tether for this matching marker.
      const partnerTether = data.iaigiriTether.find(x => {
        return x.sourceId === partnerMarker.targetId;
      });
      if (partnerTether === undefined) return;

      // It's better uptime for melee if the melee stick together if they can,
      // however it should always be safe to stick roles together here and so
      // for consistency, ignore the "melee first" option.
      const flexPartner = partnerTether.target;
      const stackType = findStackPartners(data, data.me, flexPartner, 'rolesPartners');
      const stackStr = output[stackType]();
      if (thisAbility === 'left') return output.left({
        partners: stackStr
      });
      return output.right({
        partners: stackStr
      });
    },
    outputStrings: {
      left: {
        en: 'Left Tether (${partners})',
        de: 'Linke Verbindung (${partners})',
        fr: 'Lien à gauche (${partners})',
        ja: '左線 (${partners})',
        cn: '左侧连线 (${partners})',
        ko: '왼쪽 선 (${partners})'
      },
      right: {
        en: 'Right Tether (${partners})',
        de: 'Rechte Verbindung (${partners})',
        fr: 'Lien à droite (${partners})',
        ja: '右線 (${partners})',
        cn: '右侧连线 (${partners})',
        ko: '오른쪽 선 (${partners})'
      },
      role: {
        en: 'roles together',
        de: 'Rollen zusammen',
        fr: 'Rôles ensemble',
        ja: 'ロールペア',
        cn: '职能集合',
        ko: '역할군끼리'
      },
      partner: {
        en: 'partners together',
        de: 'Partner zusammen',
        fr: 'Partenaires ensemble',
        ja: 'ペア',
        cn: '和搭档集合',
        ko: '파트너끼리'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Eye of the Thunder Vortex/Vortex of the Thunder Eye': 'Thunder Eye/Vortex',
      'Far Edge/Near Edge': 'Far/Near Edge',
      'Great Ball of Fire/Greater Ball of Fire': 'Greater/Great Ball of Fire',
      'Greater Ball of Fire/Great Ball of Fire': 'Great/Greater Ball of Fire',
      'Near Edge/Far Edge': 'Near/Far Edge',
      'Unnatural Ailment/Unnatural Force': 'Unnatural Ailment/Force',
      'Unnatural Force/Unnatural Ailment': 'Unnatural Force/Ailment',
      'Vengeful Flame/Vengeful Pyre': 'Vengeful Flame/Pyre',
      'Vortex of the Thunder Eye/Eye of the Thunder Vortex': 'Thunder Vortex/Eye'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Ashigaru Kyuhei': 'Ashigaru Kyuhei',
      'Ball of Levin': 'Elektrosphäre',
      'Devilish Thrall': 'hörig(?:e|er|es|en) Shiki',
      'Gorai the Uncaged': 'Gorai (?:der|die|das) Entfesselt(?:e|er|es|en)',
      'Moko the Restless': 'Moko (?:der|die|das) Rastlos(?:e|er|es|en)',
      'Moko\'s Shadow': 'Phantom-Moko',
      'Oni\'s Claw': 'Oni-Klaue',
      'Shishio': 'Shishio',
      'Shishu Fuko': 'Shishu-Fuko',
      'Shishu Furutsubaki': 'Shishu-Furutsubaki',
      'Shishu Kotengu': 'Shishu-Kotengu',
      'Shishu Onmitsugashira': 'Shishu-Onmitsugarashi',
      'Shishu Raiko': 'Shishu-Raiko',
      'Shishu Yuki': 'Shishu-Yuki',
      'The Trial Of Benevolence': 'Probe der Güte',
      'The Trial Of Responsibility': 'Probe der Pflicht',
      'The Trial Of Wisdom': 'Probe der Weisheit'
    },
    'replaceText': {
      '\\(circles\\)': '(Kreise)',
      '\\(lines\\)': '(Linien)',
      'Azure Auspice': 'Azurblauer Kenki-Fokus',
      'Boundless Azure': 'Grenzenloses Azurblau',
      'Boundless Scarlet': 'Grenzenloses Scharlachrot',
      'Brazen Ballad': 'Biwa-Weise',
      '(?<!Levin)Burst': 'Explosion',
      'Clearout': 'Ausräumung',
      'Cloud to Ground': 'Sturmkonzentration',
      'Double Iai-giri': 'Doppeltes Iai-giri',
      'Enkyo': 'Enkyo',
      'Explosion': 'Explosion',
      'Eye of the Thunder Vortex': 'Auge des Sturmwirbels',
      'Falling Rock': 'Steinschlag',
      'Far Edge': 'Fernschneidung',
      'Fighting Spirits': 'Kräftigender Schluck',
      'Fire Spread': 'Brandstiftung',
      'Flame and Sulphur': 'Flamme und Schwefel',
      'Fleeting Iai-giri': 'Leichtfüßiges Iai-giri',
      'Flickering Flame': 'Flackernde Flamme',
      'Flintlock': 'Steinschloss',
      'Great Ball of Fire': 'Großer Feuerball',
      'Greater Ball of Fire': 'Größerer Feuerball',
      'Haunting Cry': 'Klagender Schrei',
      'Humble Hammer': 'Entehrender Hammer',
      'Impure Purgation': 'Flammenwind',
      'Invocation of Vengeance': 'Ruf nach Vergeltung',
      'Iron Rain': 'Eisenregen',
      'Iron Storm': 'Eisensturm',
      'Kenki Release': 'Kenki-Entfesselung',
      'Lateral Slice': 'Lateralschlitzer',
      'Left Swipe': 'Linker Feger',
      'Levinburst': 'Blitzgang',
      'Malformed Prayer': 'Unheil des Perlenkranzes',
      'Malformed Reincarnation': 'Unheilvolle Verwandlung',
      'Moonless Night': 'Mondlose Nacht',
      'Near Edge': 'Nahschneidung',
      'Noble Pursuit': 'Reißzahn des Löwen',
      'Pointed Purgation': 'Gerichteter Flammenwind',
      'Right Swipe': 'Rechter Feger',
      'Rousing Reincarnation': 'Fluch der Verwandlung',
      'Scarlet Auspice': 'Scharlachroter Kenki-Fokus',
      'Seal of Scurrying Sparks': 'Siegel des Funkenflugs',
      'Shadow Kasumi-giri': 'Obskures Kasumi-giri',
      'Shadow-twin': 'Schattenzwilling',
      'Shock': 'Entladung',
      'Slither': 'Schlängeln',
      'Smokeater': 'Dunstfresser',
      'Soldiers of Death': 'Soldaten des Todes',
      'Splitting Cry': 'Schrecklicher Schrei',
      'Stormcloud Summons': 'Elektrizitätsgenerierung',
      'Stygian Aura': 'Schwarze Aura',
      '(?<!Eye of the )Thunder Vortex': 'Sturmwirbel',
      'Thundercall': 'Donnerruf',
      'Torching Torment': 'Höllische Hitze',
      'Triple Kasumi-giri': 'Dreifaches Kasumi-giri',
      'Unenlightenment': 'Glühende Geißel',
      'Unnatural Ailment': 'Unnatürliches Leiden',
      'Unnatural Force': 'Unnatürliche Macht',
      'Unnatural Wail': 'Unnatürliches Heulen',
      'Upwell': 'Strömung',
      'Vengeful Flame': 'Vergeltende Flamme',
      'Vengeful Pyre': 'Vergeltendes Feuer',
      'Vengeful Souls': 'Rachsüchtige Seelen',
      'Vermilion Aura': 'Rote Aura',
      'Vortex of the Thunder Eye': 'Wirbel des Sturmauges',
      'Worldly Pursuit': 'Schmerzschlag der Springmaus'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ashigaru Kyuhei': 'ashigaru kyûhei',
      'Ball of Levin': 'orbe de foudre',
      'Devilish Thrall': 'ilote malicieux',
      'Gorai the Uncaged': 'Gôrai le fureteur',
      'Moko the Restless': 'Môko le tourmenté',
      'Moko\'s Shadow': 'spectre de Môko',
      'Oni\'s Claw': 'griffe d\'oni',
      'Shishio': 'Shishiô',
      'Shishu Fuko': 'fûkô de Shishû',
      'Shishu Furutsubaki': 'furutsubaki de Shishû',
      'Shishu Kotengu': 'kotengu de Shishû',
      'Shishu Onmitsugashira': 'onmitsugashira de Shishû',
      'Shishu Raiko': 'raikô de Shishû',
      'Shishu Yuki': 'yûki de Shishû',
      'The Trial Of Benevolence': 'Épreuve de la Prospérité',
      'The Trial Of Responsibility': 'Épreuve de la Longévité',
      'The Trial Of Wisdom': 'Épreuve de la Connaissance'
    },
    'replaceText': {
      '\\(circles\\)': '(Cercles)',
      '\\(lines\\)': '(Lignes)',
      'Azure Auspice': 'Auspice azuré',
      'Boundless Azure': 'Lueur azurée',
      'Boundless Scarlet': 'Lueur écarlate',
      'Brazen Ballad': 'Ballade cuivrée',
      '(?<!Levin)Burst': 'Explosion',
      'Clearout': 'Fauchage',
      'Cloud to Ground': 'Attaque fulminante',
      'Double Iai-giri': 'Iai-giri double',
      'Enkyo': 'Enkyô',
      'Explosion': 'Explosion',
      'Eye of the Thunder Vortex': 'Œil du vortex de foudre',
      'Falling Rock': 'Chute de pierre',
      'Far Edge': 'Visée lointaine',
      'Fighting Spirits': 'Esprits spiritueux',
      'Fire Spread': 'Nappe de feu',
      'Flame and Sulphur': 'Soufre enflammé',
      'Fleeting Iai-giri': 'Iai-giri fugace',
      'Flickering Flame': 'Flamme vacillante',
      'Flintlock': 'Tir d\'artillerie',
      'Great Ball of Fire': 'Grande boule de feu',
      'Greater Ball of Fire': 'Grande sphère de feu',
      'Haunting Cry': 'Cri de tourmente',
      'Humble Hammer': 'Marteau d\'humilité',
      'Impure Purgation': 'Purgation impure',
      'Invocation of Vengeance': 'Invocation vengeresse',
      'Iron Rain': 'Pluie de fer',
      'Iron Storm': 'Orage de fer',
      'Kenki Release': 'Décharge Kenki',
      'Lateral Slice': 'Taillade latérale',
      'Left Swipe': 'Tranchage gauche',
      'Levinburst': 'Éclat de foudre',
      'Malformed Prayer': 'Prière difforme',
      'Malformed Reincarnation': 'Sceau de réincarnation difforme',
      'Moonless Night': 'Nuit noire',
      'Near Edge': 'Visée proche',
      'Noble Pursuit': 'Noble ambition',
      'Pointed Purgation': 'Purgation pointée',
      'Right Swipe': 'Tranchage droit',
      'Rousing Reincarnation': 'Réincarnation vibrante',
      'Scarlet Auspice': 'Auspice écarlate',
      'Seal of Scurrying Sparks': 'Sceau des feux follets',
      'Shadow Kasumi-giri': 'Kasumi-giri spectral',
      'Shadow-twin': 'Ombre jumelle',
      'Shock': 'Décharge électrostatique',
      'Slither': 'Serpentin',
      'Smokeater': 'Dévoreur de brouillard',
      'Soldiers of Death': 'Guerriers de la mort',
      'Splitting Cry': 'Cri d\'horreur',
      'Stormcloud Summons': 'Nuage d\'orage',
      'Stygian Aura': 'Aura stygienne',
      '(?<!Eye of the )Thunder Vortex': 'Spirale de foudre',
      'Thundercall': 'Drain fulminant',
      'Torching Torment': 'Brasier de tourments',
      'Triple Kasumi-giri': 'Kasumi-giri triple',
      'Unenlightenment': 'Sommeil spirituel',
      'Unnatural Ailment': 'Affection contre nature',
      'Unnatural Force': 'Force contre nature',
      'Unnatural Wail': 'Hurlement contre nature',
      'Upwell': 'Torrent violent',
      'Vengeful Flame': 'Flamme vengeresse',
      'Vengeful Pyre': 'Bûcher vengeur',
      'Vengeful Souls': 'Âmes vengeresses',
      'Vermilion Aura': 'Aura vermillon',
      'Vortex of the Thunder Eye': 'Vortex de l\'œil de foudre',
      'Worldly Pursuit': 'Matérialisme'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ashigaru Kyuhei': '足軽弓兵',
      'Ball of Levin': '雷球',
      'Devilish Thrall': '惑わされた屍鬼',
      'Gorai the Uncaged': '鉄鼠ゴウライ',
      'Moko the Restless': '怨霊モウコ',
      'Moko\'s Shadow': 'モウコの幻影',
      'Oni\'s Claw': '鬼腕',
      'Shishio': '獅子王',
      'Shishu Fuko': 'シシュウ・フウコウ',
      'Shishu Furutsubaki': 'シシュウ・フルツバキ',
      'Shishu Kotengu': 'シシュウ・コテング',
      'Shishu Onmitsugashira': 'シシュウ・オンミツガシラ',
      'Shishu Raiko': 'シシュウ・ライコウ',
      'Shishu Yuki': 'シシュウ・ユウキ',
      'The Trial Of Benevolence': '福徳の試練',
      'The Trial Of Responsibility': '寿徳の試練',
      'The Trial Of Wisdom': '智徳の試練'
    },
    'replaceText': {
      'Azure Auspice': '青帝剣気',
      'Boundless Azure': '青帝空閃刃',
      'Boundless Scarlet': '赤帝空閃刃',
      'Brazen Ballad': '琵琶の旋律',
      '(?<!Levin)Burst': '爆発',
      'Clearout': 'なぎ払い',
      'Cloud to Ground': '襲雷',
      'Double Iai-giri': '俊足居合二段',
      'Enkyo': '猿叫',
      'Explosion': '爆発',
      'Eye of the Thunder Vortex': '渦雷の連舞：円輪',
      'Falling Rock': '落石',
      'Far Edge': '遠間当て',
      'Fighting Spirits': '般若湯',
      'Fire Spread': '放火',
      'Flame and Sulphur': '岩火招来',
      'Fleeting Iai-giri': '俊足居合斬り',
      'Flickering Flame': '怪火招来',
      'Flintlock': '火砲',
      'Great Ball of Fire': '火球',
      'Greater Ball of Fire': '重火球',
      'Haunting Cry': '不気味な鳴声',
      'Humble Hammer': '打ち出の小槌',
      'Impure Purgation': '炎流',
      'Invocation of Vengeance': '怨呪の祈請',
      'Iron Rain': '矢の雨',
      'Iron Storm': '矢の嵐',
      'Kenki Release': '剣気解放',
      'Lateral Slice': '胴薙ぎ',
      'Left Swipe': '左爪薙ぎ払い',
      'Levinburst': '発雷',
      'Malformed Prayer': '呪珠印',
      'Malformed Reincarnation': '変現呪珠の印',
      'Moonless Night': '闇夜斬り',
      'Near Edge': '近間当て',
      'Noble Pursuit': '獅子王牙',
      'Pointed Purgation': '指向炎流',
      'Right Swipe': '右爪薙ぎ払い',
      'Rousing Reincarnation': '変現の呪い',
      'Scarlet Auspice': '赤帝剣気',
      'Seal of Scurrying Sparks': '乱火の印',
      'Shadow Kasumi-giri': '幻影霞斬り',
      'Shadow-twin': '幻影呼び',
      'Shock': '放電',
      'Slither': '蛇尾薙ぎ',
      'Smokeater': '霞喰い',
      'Soldiers of Death': '屍兵呼び',
      'Splitting Cry': '霊鳴砲',
      'Stormcloud Summons': '雷雲生成',
      'Stygian Aura': '黒妖弾',
      '(?<!Eye of the )Thunder Vortex': '輪転渦雷',
      'Thundercall': '招雷',
      'Torching Torment': '煩熱',
      'Triple Kasumi-giri': '霞三段',
      'Unenlightenment': '煩悩熾盛',
      'Unnatural Ailment': '妖撃',
      'Unnatural Force': '重妖撃',
      'Unnatural Wail': '不気味な呪声',
      'Upwell': '水流',
      'Vengeful Flame': '怨呪の火',
      'Vengeful Pyre': '怨呪の重火',
      'Vengeful Souls': '黒赤招魂',
      'Vermilion Aura': '赤妖弾',
      'Vortex of the Thunder Eye': '渦雷の連舞：輪円',
      'Worldly Pursuit': '跳鼠痛撃'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ashigaru Kyuhei': '足轻弓兵',
      'Ball of Levin': '闪电球',
      'Devilish Thrall': '被迷惑的尸鬼',
      'Gorai the Uncaged': '铁鼠豪雷',
      'Moko the Restless': '怨灵猛虎',
      'Moko\'s Shadow': '猛虎的幻影',
      'Oni\'s Claw': '鬼腕',
      'Shishio': '狮子王',
      'Shishu Fuko': '紫州风犼',
      'Shishu Furutsubaki': '紫州古椿精',
      'Shishu Kotengu': '紫州小天狗',
      'Shishu Onmitsugashira': '紫州隐密头领',
      'Shishu Raiko': '紫州雷犼',
      'Shishu Yuki': '紫州幽鬼',
      'The Trial Of Benevolence': '福德的试炼',
      'The Trial Of Responsibility': '寿德的试炼',
      'The Trial Of Wisdom': '智德的试炼'
    },
    'replaceText': {
      '\\(circles\\)': '(圆圈)',
      '\\(lines\\)': '(直线)',
      'Azure Auspice': '青帝剑气',
      'Boundless Azure': '青帝空闪刃',
      'Boundless Scarlet': '赤帝空闪刃',
      'Brazen Ballad': '琵琶的旋律',
      '(?<!Levin)Burst': '爆炸',
      'Clearout': '横扫',
      'Cloud to Ground': '袭雷',
      'Double Iai-giri': '二段迅步居合斩',
      'Enkyo': '猿啼',
      'Explosion': '爆炸',
      'Eye of the Thunder Vortex': '涡雷连舞之圆环',
      'Falling Rock': '落石',
      'Far Edge': '远刃击',
      'Fighting Spirits': '般若汤',
      'Fire Spread': '喷火',
      'Flame and Sulphur': '岩火招来',
      'Fleeting Iai-giri': '迅步居合斩',
      'Flickering Flame': '怪火招来',
      'Flintlock': '火炮',
      'Great Ball of Fire': '火球',
      'Greater Ball of Fire': '重火球',
      'Haunting Cry': '诡异的叫声',
      'Humble Hammer': '万宝槌',
      'Impure Purgation': '炎流',
      'Invocation of Vengeance': '怨咒的祈请',
      'Iron Rain': '钢铁箭雨',
      'Iron Storm': '箭雨风暴',
      'Kenki Release': '剑气解放',
      'Lateral Slice': '横斩中段',
      'Left Swipe': '左爪横扫',
      'Levinburst': '放雷',
      'Malformed Prayer': '咒珠印',
      'Malformed Reincarnation': '变见咒珠之印',
      'Moonless Night': '暗夜斩',
      'Near Edge': '近刃击',
      'Noble Pursuit': '狮子王牙',
      'Pointed Purgation': '指向炎流',
      'Right Swipe': '右爪横扫',
      'Rousing Reincarnation': '变见的诅咒',
      'Scarlet Auspice': '赤帝剑气',
      'Seal of Scurrying Sparks': '乱火之印',
      'Shadow Kasumi-giri': '幻影霞斩',
      'Shadow-twin': '召唤幻影',
      'Shock': '放电',
      'Slither': '蛇尾抽击',
      'Smokeater': '噬霞',
      'Soldiers of Death': '召唤阴兵',
      'Splitting Cry': '灵鸣炮',
      'Stormcloud Summons': '生成雷暴云',
      'Stygian Aura': '黑妖弹',
      '(?<!Eye of the )Thunder Vortex': '回环涡雷',
      'Thundercall': '招雷',
      'Torching Torment': '烦热',
      'Triple Kasumi-giri': '三段霞斩',
      'Unenlightenment': '烦恼炽盛',
      'Unnatural Ailment': '妖击',
      'Unnatural Force': '重妖击',
      'Unnatural Wail': '诡异的咒声',
      'Upwell': '水流',
      'Vengeful Flame': '怨咒之火',
      'Vengeful Pyre': '怨咒之重火',
      'Vengeful Souls': '黑赤招魂',
      'Vermilion Aura': '赤妖弹',
      'Vortex of the Thunder Eye': '涡雷连舞之环圆',
      'Worldly Pursuit': '跳鼠痛击'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ashigaru Kyuhei': '하급 궁병',
      'Ball of Levin': '번개 구체',
      'Devilish Thrall': '현혹된 시체귀신',
      'Gorai the Uncaged': '무쇠쥐 고우라이',
      'Moko the Restless': '원령 모우코',
      'Moko\'s Shadow': '모우코의 환영',
      'Oni\'s Claw': '악귀의 팔',
      'Shishio': '사자왕',
      'Shishu Fuko': '시슈 폭풍신',
      'Shishu Furutsubaki': '시슈 동백요괴',
      'Shishu Kotengu': '시슈 작은 텐구',
      'Shishu Onmitsugashira': '시슈 밀정 두목',
      'Shishu Raiko': '시슈 천둥신',
      'Shishu Yuki': '시슈 그림자요괴',
      'The Trial Of Benevolence': '복덕의 시련',
      'The Trial Of Responsibility': '수덕의 시련',
      'The Trial Of Wisdom': '지덕의 시련'
    },
    'replaceText': {
      '\\(circles\\)': '(원)',
      '\\(lines\\)': '(직선)',
      'Azure Auspice': '청제 검기',
      'Boundless Azure': '청제 공섬도',
      'Boundless Scarlet': '적제 공섬도',
      'Brazen Ballad': '비파의 선율',
      '(?<!Levin)Burst': '폭발',
      'Clearout': '휩쓸기',
      'Cloud to Ground': '습뢰',
      'Double Iai-giri': '이단 거합 준족베기',
      'Enkyo': '원숭이 포효',
      'Explosion': '폭발',
      'Eye of the Thunder Vortex': '와뢰 연무: 내외측',
      'Falling Rock': '낙석',
      'Far Edge': '원거리 찌르기',
      'Fighting Spirits': '반야탕',
      'Fire Spread': '방화',
      'Flame and Sulphur': '바위불 소환',
      'Fleeting Iai-giri': '거합 준족베기',
      'Flickering Flame': '귀신불 소환',
      'Flintlock': '화포',
      'Great Ball of Fire': '화염구',
      'Greater Ball of Fire': '겹불덩이',
      'Haunting Cry': '섬뜩한 괴성',
      'Humble Hammer': '요술 망치',
      'Impure Purgation': '염류',
      'Invocation of Vengeance': '원한의 기도',
      'Iron Rain': '화살비',
      'Iron Storm': '화살폭풍',
      'Kenki Release': '검기 해방',
      'Lateral Slice': '몸통 가로베기',
      'Left Swipe': '좌측 할퀴기',
      'Levinburst': '번개 발산',
      'Living Hell': '삼계화택',
      'Malformed Prayer': '염주 각인',
      'Malformed Reincarnation': '변신 염주 각인',
      'Moonless Night': '암야 베기',
      'Near Edge': '근거리 찌르기',
      'Noble Pursuit': '사자왕의 송곳니',
      'Pointed Purgation': '조준 염류',
      'Right Swipe': '우측 할퀴기',
      'Rousing Reincarnation': '변신 저주',
      'Scarlet Auspice': '적제 검기',
      'Seal of Scurrying Sparks': '불씨 뿌리기',
      'Shadow Kasumi-giri': '환영 안개베기',
      'Shadow-twin': '환영 부르기',
      'Shock': '방전',
      'Slither': '뱀꼬리 후리기',
      'Smokeater': '안개 흡입',
      'Soldiers of Death': '시체병 부르기',
      'Splitting Cry': '영명포',
      'Stormcloud Summons': '번개구름 생성',
      'Stygian Aura': '흑요탄',
      '(?<!Eye of the )Thunder Vortex': '외측 와뢰',
      'Thundercall': '초뢰',
      'Torching Torment': '번열',
      'Triple Kasumi-giri': '삼단 안개베기',
      'Unenlightenment': '번뇌치성',
      'Unnatural Ailment': '섬뜩한 폭발',
      'Unnatural Force': '섬뜩한 강력 폭발',
      'Unnatural Wail': '섬뜩한 저주',
      'Upwell': '물길',
      'Vengeful Flame': '원한의 불',
      'Vengeful Pyre': '원한의 겹불',
      'Vengeful Souls': '요탄 소환',
      'Vermilion Aura': '적요탄',
      'Vortex of the Thunder Eye': '와뢰 연무: 외내측',
      'Worldly Pursuit': '쥐 도약격'
    }
  }]
};
/* harmony default export */ const another_mount_rokkon_savage = (another_mount_rokkon_savage_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/another_mount_rokkon-savage.txt
const dungeon_another_mount_rokkon_savage_namespaceObject = "# This file was autogenerated from running npm run sync-files.\r\n# DO NOT EDIT THIS FILE DIRECTLY.\r\n# Edit the source file below and then run `npm run sync-files`\r\n# Source: ui/raidboss/data/06-ew/dungeon/another_mount_rokkon.txt\r\n\r\n### ANOTHER MOUNT ROKKON\r\n# ZoneId: 483\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~#\r\n# SHISHIO #\r\n#~~~~~~~~~#\r\n\r\n# -p 8441:1012\r\n# -ii 86E0 8422 8423 8424 8425 8426 8427 8428 8434 8429 842A 842B 824C 824D\r\n\r\n# Note: for Stormcloud Summons, differing amounts of Smokeater create different timings\r\n# and ability ids for both the \"circles\" and \"lines\" patterns. The timelines match up\r\n# after that, and the timings from a timeline are not that useful, so these are mostly\r\n# skipped. Triggers will probably do a better job for the \"circles\" case, while \"lines\"\r\n# is just a dodge check.\r\n\r\n# Trial of Benevolence will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10F8\" } window 10000,0\r\n1007.0 \"--sync--\" StartsUsing { id: \"8441\", source: \"Shishio\" } window 10000,0\r\n1012.0 \"Enkyo\" Ability { id: \"8441\", source: \"Shishio\" }\r\n\r\n1014.1 \"--middle--\" Ability { id: \"8444\", source: \"Shishio\" }\r\n1019.4 \"Stormcloud Summons (circles)\" Ability { id: \"841F\", source: \"Shishio\" }\r\n1024.1 \"Smokeater 1\" Ability { id: \"8420\", source: \"Shishio\" }\r\n1026.2 \"Smokeater 2?\" #Ability { id: \"8421\", source: \"Shishio\" }\r\n1028.3 \"Smokeater 3?\" #Ability { id: \"8421\", source: \"Shishio\" }\r\n\r\n1046.5 \"--sync--\" StartsUsing { id: \"8442\", source: \"Shishio\" } window 10,10\r\n1051.5 \"Splitting Cry\" Ability { id: \"8442\", source: \"Shishio\" }\r\n1055.5 \"Slither\" Ability { id: \"8443\", source: \"Shishio\" }\r\n\r\n1060.7 \"--north--\" Ability { id: \"8444\", source: \"Shishio\" }\r\n1071.0 \"Noble Pursuit 1\" Ability { id: \"842E\", source: \"Shishio\" }\r\n1071.8 \"Levinburst 1\" #Ability { id: \"8430\", source: \"Rairin\" }\r\n1072.5 \"Noble Pursuit 2\" #Ability { id: \"842F\", source: \"Shishio\" }\r\n1073.3 \"Levinburst 2\" #Ability { id: \"8430\", source: \"Rairin\" }\r\n1074.0 \"Noble Pursuit 3\" #Ability { id: \"842F\", source: \"Shishio\" }\r\n1074.8 \"Levinburst 3\" #Ability { id: \"8430\", source: \"Rairin\" }\r\n1075.5 \"Noble Pursuit 4\" #Ability { id: \"842F\", source: \"Shishio\" }\r\n1076.3 \"Levinburst 4\" #Ability { id: \"8430\", source: \"Rairin\" }\r\n1081.7 \"Enkyo\" Ability { id: \"8441\", source: \"Shishio\" }\r\n\r\n1083.8 \"--middle--\" Ability { id: \"8444\", source: \"Shishio\" }\r\n1088.8 \"Unnatural Wail\" Ability { id: \"843E\", source: \"Shishio\" }\r\n1093.9 \"Haunting Cry\" Ability { id: \"8431\", source: \"Shishio\" }\r\n1105.9 \"Right Swipe\" Ability { id: \"8432\", source: \"Devilish Thrall\" }\r\n1105.9 \"Left Swipe\" Ability { id: \"8433\", source: \"Devilish Thrall\" }\r\n1106.8 \"Unnatural Ailment/Unnatural Force 1\" Ability { id: [\"843F\", \"8440\"], source: \"Shishio\" }\r\n1112.9 \"Right Swipe\" Ability { id: \"8432\", source: \"Devilish Thrall\" }\r\n1112.9 \"Left Swipe\" Ability { id: \"8433\", source: \"Devilish Thrall\" }\r\n1113.8 \"Unnatural Force/Unnatural Ailment 2\" Ability { id: [\"8440\", \"843F\"], source: \"Shishio\" }\r\n\r\n1118.1 \"--middle--\" Ability { id: \"8444\", source: \"Shishio\" }\r\n1123.4 \"Stormcloud Summons (lines)\" Ability { id: \"841F\", source: \"Shishio\" }\r\n1128.1 \"Smokeater 1\" Ability { id: \"8420\", source: \"Shishio\" }\r\n1130.2 \"Smokeater 2?\" #Ability { id: \"8421\", source: \"Shishio\" }\r\n1132.2 \"Smokeater 3?\" #Ability { id: \"8421\", source: \"Shishio\" }\r\n\r\n1155.7 \"--middle--\" Ability { id: \"8444\", source: \"Shishio\" } window 10,10\r\n1160.8 \"Unnatural Wail\" Ability { id: \"843E\", source: \"Shishio\" }\r\n1168.1 \"Eye of the Thunder Vortex/Vortex of the Thunder Eye\" Ability { id: [\"843A\", \"843C\"], source: \"Shishio\" }\r\n1168.8 \"Unnatural Ailment/Unnatural Force 1\" Ability { id: [\"843F\", \"8440\"], source: \"Shishio\" }\r\n# Technically, the in/out and out/in for each pair are named the same thing.\r\n# But in a timeline, switching them makes it obvious it's the other.\r\n1172.1 \"Vortex of the Thunder Eye/Eye of the Thunder Vortex\" Ability { id: [\"843B\", \"843D\"], source: \"Shishio\" }\r\n1172.8 \"Unnatural Force/Unnatural Ailment 2\" Ability { id: [\"8440\", \"843F\"], source: \"Shishio\" }\r\n1181.4 \"Enkyo\" Ability { id: \"8441\", source: \"Shishio\" }\r\n\r\n1189.5 \"Haunting Cry\" Ability { id: \"8431\", source: \"Shishio\" }\r\n1194.6 \"--sync--\" Ability { id: \"8444\", source: \"Shishio\" }\r\n1211.9 \"Vengeful Souls\" Ability { id: \"8435\", source: \"Shishio\" }\r\n1211.9 \"Stygian Aura\" Ability { id: \"8437\", source: \"Shishio\" }\r\n1211.9 \"Vermilion Aura\" Ability { id: \"8436\", source: \"Shishio\" }\r\n\r\n1219.0 \"Thunder Vortex\" Ability { id: \"8439\", source: \"Shishio\" }\r\n1226.3 \"Splitting Cry\" Ability { id: \"8442\", source: \"Shishio\" }\r\n1230.3 \"Slither\" Ability { id: \"8443\", source: \"Shishio\" }\r\n\r\n1235.5 \"--middle--\" Ability { id: \"8444\", source: \"Shishio\" }\r\n1240.8 \"Stormcloud Summons (circles)\" Ability { id: \"841F\", source: \"Shishio\" }\r\n1245.5 \"Smokeater 1\" Ability { id: \"8420\", source: \"Shishio\" }\r\n1247.6 \"Smokeater 2?\" #Ability { id: \"8421\", source: \"Shishio\" }\r\n1249.7 \"Smokeater 3?\" #Ability { id: \"8421\", source: \"Shishio\" }\r\n\r\n1267.1 \"--middle--\" Ability { id: \"8444\", source: \"Shishio\" }\r\n1272.2 \"Stormcloud Summons (lines)\" Ability { id: \"841F\", source: \"Shishio\" }\r\n1276.9 \"Smokeater 1\" Ability { id: \"8420\", source: \"Shishio\" }\r\n1279.0 \"Smokeater 2?\" #Ability { id: \"8421\", source: \"Shishio\" }\r\n1281.0 \"Smokeater 3?\" #Ability { id: \"8421\", source: \"Shishio\" }\r\n\r\n1307.4 \"--middle--\" Ability { id: \"8444\", source: \"Shishio\" }\r\n1312.5 \"Unnatural Wail\" Ability { id: \"843E\", source: \"Shishio\" }\r\n1319.8 \"Eye of the Thunder Vortex/Vortex of the Thunder Eye\" Ability { id: [\"843A\", \"843C\"], source: \"Shishio\" }\r\n1320.4 \"Unnatural Ailment/Unnatural Force 1\" Ability { id: [\"843F\", \"8440\"], source: \"Shishio\" }\r\n1323.8 \"Vortex of the Thunder Eye/Eye of the Thunder Vortex\" Ability { id: [\"843B\", \"843D\"], source: \"Shishio\" }\r\n1324.4 \"Unnatural Force/Unnatural Ailment 2\" Ability { id: [\"8440\", \"843F\"], source: \"Shishio\" }\r\n\r\n1329.4 \"--sync--\" StartsUsing { id: \"841E\", source: \"Shishio\" } window 20,20\r\n1339.4 \"Enkyo Enrage\" Ability { id: \"841E\", source: \"Shishio\" }\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 841F Stormcloud Summons cast and self-targeted ability\r\n# 8420 Smokeater cast and self-targeted ability for first inhale\r\n# 8421 Smokeater self-targeted ability for optional second and third inhales\r\n# 8422 --sync-- ability from Raiun cloud on Shishio after being inhaled\r\n# 8423 Rokujo Revel cast and self-targeted ability for first Smokeater line\r\n# 8424 Rokujo Revel cast and self-targeted ability for followup Smokeater lines\r\n# 8425 Rokujo Revel cast and damage for Smokeater lines\r\n# 8426 Leaping Levin cast and damage from Raiun cloud adds for 1x Smokeater small circles\r\n# 8427 Leaping Levin cast and damage from Raiun cloud adds for 2x Smokeater medium circles\r\n# 8428 Leaping Levin cast and damage from Raiun cloud adds for 3x Smokeater large circles\r\n# 8429 Lightning Bolt cast and self-targeted ability\r\n# 842A Lightning Bolt cast and damage for initial cloud circles\r\n# 842B Cloud to Cloud cast and damage for 1x Smokeater small lines\r\n# 824C Cloud to Cloud cast and damage for 2x Smokeater medium lines\r\n# 824D Cloud to Cloud cast and damage for 3x Smokeater large lines\r\n# 842E Noble Pursuit cast and damage for initial charge\r\n# 842F Noble Pursuit damage for followup changes\r\n# 8430 Levinburst line damage for going through rings during Noble Pursuit\r\n# 8431 Haunting Cry cast and self-targeted ability to summon Devilish Thrall ghosts\r\n# 8432 Right Swipe cast and damage for Devilish Thrall cleave during first Unnatural Wail\r\n# 8433 Left Swipe cast and damage for Devilish Thrall cleave during first Unnatural Wail\r\n# 8434 Reisho damage from Haunting Thrall untelegraphed aoes\r\n# 8435 Vengeful Souls self-targeted ability at the same time as Vermillion/Stygian Aura\r\n# 8436 Vermilion Aura damage from taking a tower at the same time as Stygian Aura\r\n# 8437 Stygian Aura spread marker damage at the same time as Vermillion Aura\r\n# 8438 Unmitigated Explosion damage from not taking towers\r\n# 8439 Thunder Vortex cast and damage for untelegraphed donut\r\n# 843A Eye of the Thunder Vortex cast and damage for first \"out\" circle\r\n# 843B Eye of the Thunder Vortex damage for second \"in\" donut\r\n# 843C Vortex of the Thunder Eye cast and damage for first \"in\" donut\r\n# 843D Vortex of the Thunder Eye damage for second \"out\" circle\r\n# 843E Unnatural Wail cast and self-targeted ability\r\n# 843F Unnatural Ailment damage for Unnatural Wail \"spread\"\r\n# 8440 Unnatural Force damage for Unnatural Wail \"stack\"\r\n# 8441 Enkyo cast and damage for raidwide\r\n# 8442 Splitting Cry cast and damage for tankbuster\r\n# 8443 Slither fast cast and damage for back conal\r\n# 8444 --sync-- repositioning ability\r\n# 841E Enkyo cast and damage for enrage\r\n# 86E0 --sync-- auto damage\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~#\r\n# GORAI THE UNCAGED #\r\n#~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 8534:2014.3\r\n# -ii 8502 8504 8555 8504 8545 851D 851E 8584 8585 852F 854B 8257 8549 8554 8628 8544 854E 853E 852B 854C 854A\r\n\r\n# Trial of Wisdom will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10F9\" } window 10000,0\r\n2009.3 \"--sync--\" StartsUsing { id: \"8534\", source: \"Gorai the Uncaged\" } window 10000,0\r\n2014.3 \"Unenlightenment\" Ability { id: \"8534\", source: \"Gorai the Uncaged\" }\r\n\r\n2021.7 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n2028.0 \"Seal of Scurrying Sparks\" Ability { id: \"8503\", source: \"Gorai the Uncaged\" }\r\n2033.3 \"Flame and Sulphur\" Ability { id: \"8508\", source: \"Gorai the Uncaged\" }\r\n2044.6 \"Brazen Ballad\" Ability { id: [\"8509\", \"850A\"], source: \"Gorai the Uncaged\" }\r\n2047.7 \"Falling Rock\" Ability { id: [\"853F\", \"8540\"], source: \"Gorai the Uncaged\" }\r\n2047.7 \"Fire Spread\" Ability { id: [\"853C\", \"853D\"], source: \"Gorai the Uncaged\" }\r\n2048.0 \"Greater Ball of Fire\" Ability { id: \"8539\", source: \"Gorai the Uncaged\" }\r\n2055.6 \"Impure Purgation 1\" Ability { id: \"8552\", source: \"Gorai the Uncaged\" }\r\n2057.6 \"Impure Purgation 2\" Ability { id: \"8553\", source: \"Gorai the Uncaged\" }\r\n\r\n2063.5 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n2068.7 \"Thundercall\" Ability { id: \"8520\", source: \"Gorai the Uncaged\" }\r\n2079.6 \"Humble Hammer\" Ability { id: \"8502\", source: \"Gorai the Uncaged\" }\r\n2083.2 \"Flintlock\" Ability { id: \"8526\", source: \"Gorai the Uncaged\" }\r\n2083.6 \"Shock\" Ability { id: \"8521\", source: \"Ball of Levin\" }\r\n2094.5 \"Torching Torment\" Ability { id: \"8532\", source: \"Gorai the Uncaged\" }\r\n\r\n2100.9 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n2108.0 \"Rousing Reincarnation\" Ability { id: \"8512\", source: \"Gorai the Uncaged\" }\r\n2114.3 \"Malformed Prayer\" Ability { id: \"8518\", source: \"Gorai the Uncaged\" }\r\n2126.3 \"Pointed Purgation 1\" Ability { id: \"8548\", source: \"Gorai the Uncaged\" }\r\n2126.4 \"Burst 1\" Ability { id: \"8546\", source: \"Gorai the Uncaged\" }\r\n2132.4 \"Pointed Purgation 2\" Ability { id: \"8548\", source: \"Gorai the Uncaged\" }\r\n2132.4 \"Burst 2\" Ability { id: \"8546\", source: \"Gorai the Uncaged\" }\r\n2138.4 \"Pointed Purgation 3\" Ability { id: \"8548\", source: \"Gorai the Uncaged\" }\r\n2138.4 \"Burst 3\" Ability { id: \"8546\", source: \"Gorai the Uncaged\" }\r\n2144.4 \"Pointed Purgation 4\" Ability { id: \"8548\", source: \"Gorai the Uncaged\" }\r\n2144.4 \"Burst 4\" Ability { id: \"8546\", source: \"Gorai the Uncaged\" }\r\n2155.7 \"Unenlightenment\" Ability { id: \"8534\", source: \"Gorai the Uncaged\" }\r\n\r\n2163.1 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n2169.2 \"Seal of Scurrying Sparks\" Ability { id: \"8503\", source: \"Gorai the Uncaged\" }\r\n2178.5 \"Cloud to Ground\" Ability { id: \"854D\", source: \"Gorai the Uncaged\" } duration 6.3\r\n2180.5 \"Greater Ball of Fire/Great Ball of Fire\" Ability { id: [\"8539\", \"853A\"], source: \"Gorai the Uncaged\" } window 1,1\r\n2183.5 \"Great Ball of Fire/Greater Ball of Fire\" Ability { id: [\"853A\", \"8539\"], source: \"Gorai the Uncaged\" } window 1,1\r\n\r\n2193.5 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n2202.2 \"Fighting Spirits\" Ability { id: \"854F\", source: \"Gorai the Uncaged\" }\r\n2205.5 \"Worldly Pursuit 1\" Ability { id: \"8550\", source: \"Gorai the Uncaged\" }\r\n2208.6 \"Worldly Pursuit 2\" Ability { id: \"8550\", source: \"Gorai the Uncaged\" }\r\n2211.6 \"Worldly Pursuit 3\" Ability { id: \"8550\", source: \"Gorai the Uncaged\" }\r\n2214.6 \"Worldly Pursuit 4\" Ability { id: \"8550\", source: \"Gorai the Uncaged\" }\r\n2217.6 \"Worldly Pursuit 5\" Ability { id: \"8550\", source: \"Gorai the Uncaged\" }\r\n2232.2 \"Torching Torment\" Ability { id: \"8532\", source: \"Gorai the Uncaged\" }\r\n\r\n2238.6 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n2245.8 \"Malformed Reincarnation\" Ability { id: \"8514\", source: \"Gorai the Uncaged\" }\r\n2252.2 \"Malformed Prayer\" Ability { id: \"8518\", source: \"Gorai the Uncaged\" }\r\n2265.3 \"Flickering Flame\" Ability { id: \"8510\", source: \"Gorai the Uncaged\" }\r\n2267.3 \"Burst 1\" #Ability { id: \"8546\", source: \"Gorai the Uncaged\" }\r\n2269.9 \"Burst 2\" #Ability { id: \"8546\", source: \"Gorai the Uncaged\" }\r\n2271.9 \"Burst 3\" #Ability { id: \"8546\", source: \"Gorai the Uncaged\" }\r\n2272.6 \"Fire Spread 1\" #Ability { id: \"8541\", source: \"Gorai the Uncaged\" }\r\n2274.6 \"Fire Spread 2\" #Ability { id: \"8541\", source: \"Gorai the Uncaged\" }\r\n\r\n2282.9 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n2289.0 \"Seal of Scurrying Sparks\" Ability { id: \"8503\", source: \"Gorai the Uncaged\" }\r\n2294.3 \"Flame and Sulphur\" Ability { id: \"8508\", source: \"Gorai the Uncaged\" }\r\n2305.6 \"Brazen Ballad\" Ability { id: \"850A\", source: \"Gorai the Uncaged\" }\r\n2308.7 \"Falling Rock\" Ability { id: \"8540\", source: \"Gorai the Uncaged\" }\r\n2308.7 \"Fire Spread\" Ability { id: \"853D\", source: \"Gorai the Uncaged\" }\r\n2309.1 \"Greater Ball of Fire\" Ability { id: \"8539\", source: \"Gorai the Uncaged\" }\r\n2318.3 \"Unenlightenment\" Ability { id: \"8534\", source: \"Gorai the Uncaged\" }\r\n\r\n2325.4 \"--sync--\" StartsUsing { id: \"8536\", source: \"Gorai the Uncaged\" }\r\n2335.4 \"Living Hell Enrage\" Ability { id: \"8536\", source: \"Gorai the Uncaged\" }\r\n#2336.0 \"Living Hell\" #Ability { id: \"8538\", source: \"Gorai the Uncaged\" }\r\n#2337.8 \"Living Hell\" #Ability { id: \"8537\", source: \"Gorai the Uncaged\" }\r\n#2338.4 \"Living Hell\" #Ability { id: \"8538\", source: \"Gorai the Uncaged\" }\r\n#2340.2 \"Living Hell\" #Ability { id: \"8537\", source: \"Gorai the Uncaged\" }\r\n#2340.8 \"Living Hell\" #Ability { id: \"8538\", source: \"Gorai the Uncaged\" }\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 84D3 --sync-- repositioning\r\n# 8502 --sync-- auto damage\r\n# 8503 Seal of Scurrying Sparks cast and self-targeted ability\r\n# 8504 Seal of Scurrying Sparks ability on players that gives Live Brazier/Live Candle debuffs\r\n# 8539 Greater Ball of Fire pair stack damage from Live Brazier debuff\r\n# 853A Great Ball of Fire spread damage from Live Candle debuff\r\n# 8508 Flame and Sulphur cast and self-targeted summoning rocks and lines\r\n# 8509 Brazen Ballad cast and self-targeted purple effect that expands everything\r\n# 850A Brazen Ballad cast and self-targeted blue effect that donutifies everything\r\n# 853C Fire Spread expanded line damage after Brazen Ballad 8509\r\n# 853D Fire Spread split line damage after Brazen Ballad 850A\r\n# 8550 Worldly Pursuit cast and damage from cross jumps\r\n# 853F Falling Rock expanded rock damage after Brazen Ballad 8509\r\n# 8540 Falling Rock donutified rock damage after Brazen Ballad 850A\r\n# 8510 Flickering Flame cast and ability (summoning blue flames for 8541)\r\n# 8541 Fire Spread cast and damage for waffle lines during second towers\r\n# 8512 Rousing Reincarnation cast and self-targeted ability\r\n# 8584 Rousing Reincarnation ability on player that gives Odder Incarnation and Rodential Rebirth\r\n# 8514 Malformed Reincarnation cast and self-targeted ability\r\n# 8585 Malformed Reincarnation ability on player like Rousing Reincarnation, but also gives Odder/Squirrelly Prayer\r\n# 8518 Malformed Prayer cast and self-targeted ability that starts the tower sequences\r\n# 8544 Burst orange tower damage\r\n# 8545 Dramatic Burst missed tower damage (second set? or an orange color?)\r\n# 8546 Burst blue tower damage\r\n# 8547 Dramatic Burst missed tower damage (first set? or a blue color?)\r\n# 851D Pointed Purgation cast and self-targeted ability before first 8548 protean cleave\r\n# 851E Pointed Purgation self-targeted ability before 2/3/4 8548 protean cleaves\r\n# 8548 Pointed Purgation damage for protean cleave from tether\r\n# 8520 Thundercall cast and self-targeted ability that summons Ball of Levin\r\n# 8521 Shock cast and self-targeted ability by Ball of Levin\r\n# 8549 Shock small ground circle damage from Ball of Levin hit by Humble Hammer\r\n# 854A Shock large ground circle damage from Ball of Levin\r\n# 8502 Humble Hammer cast and self-targeted ability\r\n# 854B Humble Hammer cast and damage headmarker on healer that gives mini debuff\r\n# 8526 Flintlock self-targeted ability\r\n# 854C Flintlock damage for line stack after Humble Hammer\r\n# 8628 Cloud to Ground cast and self-targeted ability\r\n# 854D Cloud to Ground cloud exaflare damage initial hit\r\n# 854E Cloud to Ground cloud exaflare damage ongoing hits\r\n# 852B Fighting Spirits cast and self-targeted\r\n# 854F Fighting Spirits cast and damage for knockback\r\n# 853E Worldly Pursuit untargeted ability jump before 8550 cross cast and damage\r\n# 852F Impure Purgation cast and self-targeted ability\r\n# 8552 Impure Purgation initial protean damage\r\n# 8553 Impure Purgation cast and damage for follow-up protean\r\n# 8532 Torching Torment cast and ability on tank that give burns debuff\r\n# 8554 Torching Torment cast and damage on tank for tankbuster\r\n# 8534 Unenlightenment cast and self-targeted ability\r\n# 8555 Unenlightenment damage for raidwide bleed\r\n# 8536 Living Hell cast and self-targeted enrage\r\n# 8537 Living Hell self-targeted ability for follow-up enrage if 8536 failed\r\n# 8538 Living Hell damage for 8536/8537 enrage abilities\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~#\r\n# MOKO THE RESTLESS #\r\n#~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 860C:3016.4\r\n# -ii 8507 85EC 85ED 8601 860B 8C28 8607 85FD 8604 8606 8537 8538\r\n\r\n# Trial of Responsibility will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10FA\" } window 10000,0\r\n3011.4 \"--sync--\" StartsUsing { id: \"860C\", source: \"Moko the Restless\" } window 10000,10\r\n3016.4 \"Kenki Release\" Ability { id: \"860C\", source: \"Moko the Restless\" }\r\n\r\n3035.6 \"Triple Kasumi-giri 1\" Ability { id: [\"85E4\", \"85E5\", \"85E6\", \"85E7\", \"85EE\", \"85EF\", \"85F0\", \"85F1\"], source: \"Moko the Restless\" }\r\n3038.6 \"Triple Kasumi-giri 2\" Ability { id: [\"85E8\", \"85E9\", \"85EA\", \"85EB\", \"85F2\", \"85F3\", \"85F4\", \"85F5\"], source: \"Moko the Restless\" }\r\n3041.6 \"Triple Kasumi-giri 3\" Ability { id: [\"85E8\", \"85E9\", \"85EA\", \"85EB\", \"85F2\", \"85F3\", \"85F4\", \"85F5\"], source: \"Moko the Restless\" }\r\n3055.7 \"Triple Kasumi-giri 1\" Ability { id: [\"85E4\", \"85E5\", \"85E6\", \"85E7\", \"85EE\", \"85EF\", \"85F0\", \"85F1\"], source: \"Moko the Restless\" }\r\n3058.7 \"Triple Kasumi-giri 2\" Ability { id: [\"85E8\", \"85E9\", \"85EA\", \"85EB\", \"85F2\", \"85F3\", \"85F4\", \"85F5\"], source: \"Moko the Restless\" }\r\n3061.7 \"Triple Kasumi-giri 3\" Ability { id: [\"85E8\", \"85E9\", \"85EA\", \"85EB\", \"85F2\", \"85F3\", \"85F4\", \"85F5\"], source: \"Moko the Restless\" }\r\n\r\n3063.8 \"--sync--\" Ability { id: [\"871F\", \"8720\"], source: \"Moko the Restless\" }\r\n3071.1 \"Lateral Slice\" Ability { id: \"860D\", source: \"Moko the Restless\" }\r\n\r\n3077.2 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3083.3 \"Scarlet Auspice\" Ability { id: \"8600\", source: \"Moko the Restless\" }\r\n3088.9 \"Boundless Scarlet\" Ability { id: \"8599\", source: \"Moko the Restless\" }\r\n3096.0 \"Invocation of Vengeance\" Ability { id: \"85BD\", source: \"Moko the Restless\" }\r\n3108.1 \"Fleeting Iai-giri (cast)\" Ability { id: \"85C2\", source: \"Moko the Restless\" }\r\n3108.3 \"--jump--\" Ability { id: \"85C3\", source: \"Moko the Restless\" }\r\n3110.6 \"Fleeting Iai-giri\" Ability { id: [\"85F6\", \"85F7\", \"85F8\"], source: \"Moko the Restless\" }\r\n3111.7 \"Explosion 1\" Ability { id: \"8602\", source: \"Moko the Restless\" }\r\n3111.8 \"Vengeful Flame/Vengeful Pyre\" Ability { id: [\"8608\", \"8609\"], source: \"Moko the Restless\" }\r\n3118.6 \"Explosion 2\" Ability { id: \"8602\", source: \"Moko the Restless\" }\r\n3119.7 \"Vengeful Pyre/Vengeful Flame\" Ability { id: [\"8609\", \"8608\"], source: \"Moko the Restless\" }\r\n\r\n3127.6 \"Kenki Release\" Ability { id: \"860C\", source: \"Moko the Restless\" }\r\n\r\n3134.8 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3139.0 \"Shadow-twin\" Ability { id: \"85C7\", source: \"Moko the Restless\" }\r\n\r\n3145.1 \"Moonless Night\" Ability { id: \"860A\", source: \"Moko the Restless\" }\r\n3154.2 \"Near Edge/Far Edge 1\" Ability { id: [\"85D9\", \"85D8\"], source: \"Moko the Restless\" }\r\n3154.2 \"Double Iai-giri x2\" Ability { id: \"85C8\", source: \"Moko's Shadow\" }\r\n3154.2 \"Clearout x3\" Ability { id: \"8C22\", source: \"Oni's Claw\" }\r\n3154.2 \"--jump--\" Ability { id: \"85C9\", source: \"Moko's Shadow\" }\r\n3156.9 \"Shadow Kasumi-giri 1\" Ability { id: \"85F9\", source: \"Moko's Shadow\" }\r\n3160.0 \"Shadow Kasumi-giri 2\" Ability { id: [\"86CC\", \"86CD\", \"86CE\"], source: \"Moko's Shadow\" }\r\n\r\n3165.4 \"Moonless Night\" Ability { id: \"860A\", source: \"Moko the Restless\" }\r\n3174.5 \"Far Edge/Near Edge 2\" Ability { id: [\"85D8\", \"85D9\"], source: \"Moko the Restless\" }\r\n3174.5 \"Double Iai-giri x2\" Ability { id: \"85C8\", source: \"Moko's Shadow\" }\r\n3174.5 \"Clearout x3\" Ability { id: \"8C22\", source: \"Oni's Claw\" }\r\n3174.7 \"--jump--\" Ability { id: \"85C9\", source: \"Moko's Shadow\" }\r\n3176.8 \"Shadow Kasumi-giri 1\" Ability { id: \"85F9\", source: \"Moko's Shadow\" }\r\n3179.8 \"Shadow Kasumi-giri 2\" Ability { id: [\"86CC\", \"86CD\", \"86CE\"], source: \"Moko's Shadow\" }\r\n\r\n3187.1 \"Kenki Release\" Ability { id: \"860C\", source: \"Moko the Restless\" }\r\n\r\n3195.3 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3201.4 \"Azure Auspice\" Ability { id: \"8603\", source: \"Moko the Restless\" }\r\n3207.0 \"Boundless Azure\" Ability { id: \"859D\", source: \"Moko the Restless\" }\r\n3218.8 \"Upwell 1\" Ability { id: \"8605\", source: \"Moko the Restless\" }\r\n3221.8 \"Upwell 2\" Ability { id: \"8605\", source: \"Moko the Restless\" }\r\n3224.8 \"Upwell 3\" Ability { id: \"8605\", source: \"Moko the Restless\" }\r\n3225.2 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3227.8 \"Upwell 4\" Ability { id: \"8605\", source: \"Moko the Restless\" }\r\n3238.7 \"Triple Kasumi-giri 1\" Ability { id: [\"85E4\", \"85E5\", \"85E6\", \"85E7\", \"85EE\", \"85EF\", \"85F0\", \"85F1\"], source: \"Moko the Restless\" }\r\n3241.7 \"Triple Kasumi-giri 2\" Ability { id: [\"85E8\", \"85E9\", \"85EA\", \"85EB\", \"85F2\", \"85F3\", \"85F4\", \"85F5\"], source: \"Moko the Restless\" }\r\n3244.7 \"Triple Kasumi-giri 3\" Ability { id: [\"85E8\", \"85E9\", \"85EA\", \"85EB\", \"85F2\", \"85F3\", \"85F4\", \"85F5\"], source: \"Moko the Restless\" }\r\n\r\n3251.8 \"Kenki Release\" Ability { id: \"860C\", source: \"Moko the Restless\" }\r\n3254.9 \"--sync--\" Ability { id: [\"871F\", \"8720\"], source: \"Moko the Restless\" }\r\n3260.0 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3264.1 \"Soldiers of Death\" Ability { id: \"8593\", source: \"Moko the Restless\" }\r\n3270.2 \"Shadow-twin\" Ability { id: \"85C7\", source: \"Moko the Restless\" }\r\n3285.4 \"Double Iai-giri x4\" Ability { id: \"85C8\", source: \"Moko's Shadow\" }\r\n3285.6 \"--jump--\" Ability { id: \"85C9\", source: \"Moko's Shadow\" }\r\n3285.9 \"Iron Storm\" Ability { id: \"85FF\", source: \"Ashigaru Kyuhei\" }\r\n3285.9 \"Iron Rain\" Ability { id: \"85FE\", source: \"Ashigaru Kyuhei\" }\r\n3288.3 \"Shadow Kasumi-giri 1\" Ability { id: \"85F9\", source: \"Moko's Shadow\" }\r\n3291.3 \"Shadow Kasumi-giri 2\" Ability { id: [\"86CC\", \"86CE\"], source: \"Moko's Shadow\" }\r\n3291.7 \"Iron Storm\" Ability { id: \"87AA\", source: \"Ashigaru Kyuhei\" }\r\n3291.7 \"Iron Rain\" Ability { id: \"87A9\", source: \"Ashigaru Kyuhei\" }\r\n\r\n3291.8 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3305.1 \"Triple Kasumi-giri 1\" Ability { id: [\"85E4\", \"85E5\", \"85E6\", \"85E7\", \"85EE\", \"85EF\", \"85F0\", \"85F1\"], source: \"Moko the Restless\" }\r\n3308.2 \"Triple Kasumi-giri 2\" Ability { id: [\"85E8\", \"85E9\", \"85EA\", \"85EB\", \"85F2\", \"85F3\", \"85F4\", \"85F5\"], source: \"Moko the Restless\" }\r\n3311.3 \"Triple Kasumi-giri 3\" Ability { id: [\"85E8\", \"85E9\", \"85EA\", \"85EB\", \"85F2\", \"85F3\", \"85F4\", \"85F5\"], source: \"Moko the Restless\" }\r\n3318.3 \"Kenki Release\" Ability { id: \"860C\", source: \"Moko the Restless\" }\r\n3321.4 \"--sync--\" Ability { id: [\"871F\", \"8720\"], source: \"Moko the Restless\" }\r\n3328.8 \"Lateral Slice\" Ability { id: \"860D\", source: \"Moko the Restless\" }\r\n3336.8 \"Kenki Release\" Ability { id: \"860C\", source: \"Moko the Restless\" }\r\n\r\n3342.0 \"--sync--\" StartsUsing { id: \"85E2\", source: \"Moko the Restless\" } window 10,10\r\n3352.0 \"Kenki Release Enrage\" Ability { id: \"85E2\", source: \"Moko the Restless\" }\r\n\r\n\r\n# TODO: are any of these possible??? I think no\r\n# TODO: Fleeting Iai-giri front safe\r\n# TODO: Shadow Kasumi-giri left safe initial\r\n# TODO: Shadow Kasumi-giri right safe initial\r\n# TODO: Shadow Kasumi-giri front safe initial\r\n# TODO: Shadow Kasumi-giri back safe followup\r\n\r\n# 8507 --sync-- auto damage\r\n# 8593 Soldiers of Death cast and self-targeted ability to summon Ashigaru Kyuhei adds\r\n# 8599 Boundless Scarlet cast and self-targeted ability to summon red lines\r\n# 859D Boundless Azure cast and self-targeted ability to summon blue lines\r\n# 85AF --sync-- repositioning\r\n# 85E4 Triple Kasumi-giri long cast and damage for back red first\r\n# 85E5 Triple Kasumi-giri long cast and damage for left red first\r\n# 85E6 Triple Kasumi-giri long cast and damage for front red first\r\n# 85E7 Triple Kasumi-giri long cast and damage for right red first\r\n# 85E8 Triple Kasumi-giri short cast and damage for back red followup\r\n# 85E9 Triple Kasumi-giri short cast and damage for left red followup\r\n# 85EA Triple Kasumi-giri short cast and damage for front red followup\r\n# 85EB Triple Kasumi-giri short cast and damage for right red followup\r\n# 85EC Unbound Spirit damage for red \"out\" Triple Kasumi-giri marker\r\n# 85ED Azure Coil damage for blue \"in\" Triple Kasumi-giri marker\r\n# 85EE Triple Kasumi-giri long cast and damage for back blue first\r\n# 85EF Triple Kasumi-giri long cast and damage for left blue first\r\n# 85F0 Triple Kasumi-giri long cast and damage for front blue first\r\n# 85F1 Triple Kasumi-giri long cast and damage for right blue first\r\n# 85F2 Triple Kasumi-giri short cast and damage for back blue followup\r\n# 85F3 Triple Kasumi-giri short cast and damage for left blue followup\r\n# 85F4 Triple Kasumi-giri short cast and damage for front blue followup\r\n# 85F5 Triple Kasumi-giri short cast and damage for right blue followup\r\n# 85C2 Fleeting Iai-giri cast and self-targeted ability for jumping Iai-giri (all types) from boss\r\n# 85C3 --sync-- boss jump ability for Fleeting Iai-giri\r\n# 85F6 Fleeting Iai-giri short cast and damage for back purple Iai-giri\r\n# 85F7 Fleeting Iai-giri short cast and damage for left purple Iai-giri\r\n# 85F8 Fleeting Iai-giri short cast and damage for right purple Iai-giri\r\n# 85C7 Shadow-twin cast and self-targeted to summon Moko's Shadow clones\r\n# 85C8 Double Iai-giri cast and self-targeted ability for Shadow clone (all types)\r\n# 85C9 --sync-- clone jump ability for Shadow Kasumi-giri\r\n# 85F9 Shadow Kasumi-giri short cast and damage for Shadow clone back purple first\r\n# 85FD Kenki Release cast and raidwide enrage from Shadow clones\r\n# 85FE Iron Rain very long initial cast and medium circle damage from red Ashigaru Kyuheis\r\n# 85FF Iron Storm very long initial cast and big circle damage from blue Ashigaru Kyuhei\r\n# 8600 Scarlet Auspice cast and damage for \"get out\" before Boundless Scarlet\r\n# 8601 Boundless Scarlet cast and damage for initial red lines before they grow\r\n# 8602 Explosion cast and damage for growing red lines\r\n# 8603 Azure Auspice cast and damage for \"get under\" donut before Boundless Azure\r\n# 8604 Boundless Azure cast and damage for initial blue lines before they bounce\r\n# 8605 Upwell cast and damage for blue line first bounce\r\n# 8606 Upwell damage for blue line ongoing bounces\r\n# 85D8 Far Edge cast and self-targeted ability paired with Accursed Edge on farthest players\r\n# 85D9 Near Edge cast and self-targeted ability paired with Accursed Edge on nearest players\r\n# 8607 Accursed Edge damage and bind on players from Far Edge / Near Edge\r\n# 85BD Invocation of Vengeance cast and self-targeted ability that gives debuffs during Explosions\r\n# 8608 Vengeful Flame spread damage\r\n# 8609 Vengeful Pyre stack damage\r\n# 860A Moonless Night cast and raidwide damage to summon Oni's Claw\r\n# 860B Clearout damage from Oni's Claw large circles hit 3\r\n# 860C Kenki Release cast and raidwide damage from boss\r\n# 85E2 Kenki Release enrage cast from boss\r\n# 860D Lateral Slice cast and tankbuster damage\r\n# 86CC Shadow Kasumi-giri short cast and damage for Shadow clone left purple followup\r\n# 86CD Shadow Kasumi-giri short cast and damage for Shadow clone front purple followup\r\n# 86CE Shadow Kasumi-giri short cast and damage for Shadow clone right purple followup\r\n# 871F --sync-- unknown self-targeted ability before Lateral Slice or Soldiers of Death\r\n# 8720 --sync-- unknown self-targeted ability before Lateral Slice or Soldiers of Death\r\n# 87A9 Iron Rain short followup cast and medium circle damage from red Ashigaru Kyuheis\r\n# 87AA Iron Storm short followup cast and big circle damage from blue Ashigaru Kyuhei\r\n# 8C22 Clearout cast and damage for Oni's Claw large circles hit 1 (of 3)\r\n# 8C28 Clearout damage from Oni's Claw large circles hit 2\r\n\r\n\r\n#~~~~~~~~~#\r\n# TRASH 1 #\r\n#~~~~~~~~~#\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 7A58 --sync-- various auto damage (trash 1)\r\n# 8665 Barreling Smash cast and damage for line charge\r\n# 8666 Howl cast and damage for Shishu Raiko raidwide\r\n# 8667 Master of Levin cast and damage for Shishu Raiki \"get in\" donut\r\n# 8668 Disciples of Levin cast and damage for Shishu Raiko \"get out\" circle\r\n# 8669 Bloody Caress cast and damage for Shishu Furutsubaki front conal\r\n# 866A Twister cast and damage for Shishu Fuko stack\r\n# 866B Crosswind cast and damage for Shishu Fuko knockback\r\n# 866C Scythe Tail cast and damage for Shishu Fuko \"get out\"\r\n# 866D Tornado cast and damage for Red Shishu Penghou targeted circle\r\n# 8688 Right Swipe cast and damage for Shishu Yuki right 180 cleave\r\n# 8689 Left Swipe cast and damage for Shishu Yuki left 180 cleave\r\n\r\n\r\n#~~~~~~~~~#\r\n# TRASH 2 #\r\n#~~~~~~~~~#\r\n\r\n# 7A56 --sync-- various auto damage (trash 2)\r\n# 866E Backward Blows cast and self-targeted ability for Shishu Kotengu front->back conals\r\n# 866F Leftward Blows cast and self-targeted ability for Shishu Kotengu front->left conals\r\n# 8670 Rightward Blows cast and self-targeted ability for Shishu Kotengu front->right conals\r\n# 8671 Blade of the Tengu damage from Shishu Kotengu Blows abilities\r\n# 8672 Wrath of the Tengu cast and damage for Shishu Kotengu raidwide + bleed\r\n# 8673 Gaze of the Tengu cast and ability for lookaway\r\n# 8674 Issen cast and damage for Shishu Onmitsugashira tankbuster\r\n# 8675 Huton cast and self-targeted ability for Shishu Onmitsugashira before multiple shuriken\r\n# 8676 Juji Shuriken cast and damage for Shishu Onmitsugashira line aoe\r\n# 867E Juji Shuriken cast and damage for Shishu Onmitsugashira multiple fast line aoe\r\n# 868A Mountain Breeze cast and damage from Shishu Yamabiko sprite line aoe\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/another_mount_rokkon.ts






const another_mount_rokkon_headmarkers = {
  // vfx/lockon/eff/sph_lockon2_num01_s8p.avfx (through sph_lockon2_num04_s8p)
  limitCut1: '0150',
  limitCut2: '0151',
  limitCut3: '0152',
  limitCut4: '0153'
};
const another_mount_rokkon_mokoVfxMap = {
  '24C': 'backRed',
  '24D': 'leftRed',
  '24E': 'frontRed',
  '24F': 'rightRed',
  '250': 'backBlue',
  '251': 'leftBlue',
  '252': 'frontBlue',
  '253': 'rightBlue'
};
const another_mount_rokkon_looseMokoVfxMap = another_mount_rokkon_mokoVfxMap;
const another_mount_rokkon_shadowVfxMap = {
  '248': 'back',
  '249': 'left',
  '24A': 'front',
  '24B': 'right'
};
const another_mount_rokkon_looseShadowVfxMap = another_mount_rokkon_shadowVfxMap;
const another_mount_rokkon_limitCutIds = Object.values(another_mount_rokkon_headmarkers);
const another_mount_rokkon_mokoCenterX = -200;
const another_mount_rokkon_mokoCenterY = 0;
const another_mount_rokkon_tripleKasumiFirstOutputStrings = {
  backRedFirst: {
    en: 'Back + Out',
    de: 'Hinten + Raus',
    fr: 'Arrière + Extérieur',
    ja: '後ろ + 外',
    cn: '后 + 远离',
    ko: '뒤 + 밖'
  },
  leftRedFirst: {
    en: 'Left + Out',
    de: 'Links + Raus',
    fr: 'Gauche + Extérieur',
    ja: '左 + 外',
    cn: '左 + 远离',
    ko: '왼쪽 + 밖'
  },
  frontRedFirst: {
    en: 'Front + Out',
    de: 'Vorne + Raus',
    fr: 'Devant + Extérieur',
    ja: '前 + 外',
    cn: '前 + 远离',
    ko: '앞 + 밖'
  },
  rightRedFirst: {
    en: 'Right + Out',
    de: 'Rechts + Raus',
    fr: 'Droite + Extérieur',
    ja: '右 + 外',
    cn: '右 + 远离',
    ko: '오른쪽 + 밖'
  },
  backBlueFirst: {
    en: 'Back + In',
    de: 'Hinten + Rein',
    fr: 'Arrière + Intérieur',
    ja: '後ろ + 中',
    cn: '后 + 靠近',
    ko: '뒤 + 안'
  },
  leftBlueFirst: {
    en: 'Left + In',
    de: 'Links + Rein',
    fr: 'Gauche + Intérieur',
    ja: '左 + 中',
    cn: '左 + 靠近',
    ko: '왼쪽 + 안'
  },
  frontBlueFirst: {
    en: 'Front + In',
    de: 'Vorne + Rein',
    fr: 'Devant + Intérieur',
    ja: '前 + 中',
    cn: '前 + 靠近',
    ko: '앞 + 안'
  },
  rightBlueFirst: {
    en: 'Right + In',
    de: 'Rechts + Rein',
    fr: 'Droite + Intérieur',
    ja: '右 + 中',
    cn: '右 + 靠近',
    ko: '오른쪽 + 안'
  }
};

// It might be more accurate to say "rotate right" here than "right" (implying right flank)
// but that's very long. This is one of those "you need to know the mechanic" situations.
const another_mount_rokkon_tripleKasumiFollowupOutputStrings = {
  backRed: {
    en: 'Stay + Out',
    de: 'bleib Stehen + Raus',
    fr: 'Restez + Extérieur',
    ja: 'そのまま + 外',
    cn: '停 + 远离',
    ko: '그대로 + 밖'
  },
  leftRed: {
    en: 'Left + Out',
    de: 'Links + Raus',
    fr: 'Gauche + Extérieur',
    ja: '左 + 外',
    cn: '左左左 + 远离',
    ko: '왼쪽 + 밖'
  },
  frontRed: {
    en: 'Through + Out',
    de: 'Durch + Raus',
    fr: 'À travers + Extérieur',
    ja: 'またいで + 外',
    cn: '穿 + 远离',
    ko: '가로지르기 + 밖'
  },
  rightRed: {
    en: 'Right + Out',
    de: 'Rechts + Raus',
    fr: 'Droite + Extérieur',
    ja: '右 + 外',
    cn: '右右右 + 远离',
    ko: '오른쪽 + 밖'
  },
  backBlue: {
    en: 'Stay + In',
    de: 'bleib Stehen + Rein',
    fr: 'Restez + Intérieur',
    ja: 'そのまま + 中',
    cn: '停 + 靠近',
    ko: '그대로 + 안'
  },
  leftBlue: {
    en: 'Left + In',
    de: 'Links + Rein',
    fr: 'Gauche + Intérieur',
    ja: '左 + 中',
    cn: '左左左 + 靠近',
    ko: '왼쪽 + 밖'
  },
  frontBlue: {
    en: 'Through + In',
    de: 'Durch + Rein',
    fr: 'À travers + Intérieur',
    ja: 'またいで + 中',
    cn: '穿 + 靠近',
    ko: '가로지르기 + 안'
  },
  rightBlue: {
    en: 'Right + In',
    de: 'Rechts + Rein',
    fr: 'Droite + Intérieur',
    ja: '右 + 中',
    cn: '右右右 + 靠近',
    ko: '오른쪽 + 안'
  }
};
const another_mount_rokkon_basicStackSpreadOutputStrings = {
  spread: outputs/* default.spread */.Z.spread,
  melee: {
    en: 'Melees Stack',
    de: 'Nahkämpfer sammeln',
    fr: 'Package mêlées',
    ja: '近接ペア',
    cn: '近战分摊',
    ko: '근딜 쉐어'
  },
  role: {
    en: 'Role Stacks',
    de: 'Rollengruppe sammeln',
    fr: 'Package par role',
    ja: 'ロールペア',
    cn: '职能分摊',
    ko: '역할별 쉐어'
  },
  partner: {
    en: 'Partner Stacks',
    de: 'Partner sammeln',
    fr: 'Package partenaire',
    ja: 'ペア',
    cn: '和搭档分摊',
    ko: '파트너 쉐어'
  },
  unknown: {
    en: 'Stacks',
    de: 'Sammeln',
    fr: 'Package',
    ja: '頭割り',
    cn: '分摊',
    ko: '쉐어'
  }
};
const another_mount_rokkon_tripleKasumiAbilityIds = ['85B0',
// back red first
'85B1',
// left red first
'85B2',
// front red first
'85B3',
// right red first
'85B4',
// back red followup
'85B5',
// left red followup
'85B6',
// front red followup
'85B7',
// right red followup
'85BA',
// back blue first
'85BB',
// left blue first
'85BC',
// front blue first
'85BD',
// right blue first
'85BE',
// back blue followup
'85BF',
// left blue followup
'85C0',
// front blue followup
'85C1' // right blue followup
];

const another_mount_rokkon_countJob = (job1, job2, func) => {
  return (func(job1) ? 1 : 0) + (func(job2) ? 1 : 0);
};

// For a given criteria func, if there's exactly one person who matches in the stack group
// and exactly one person who matches in the unmarked group, then they can stack together.
// This also filters out weird party comps naturally.
const another_mount_rokkon_couldStackLooseFunc = (stackJob1, stackJob2, unmarkedJob1, unmarkedJob2, func) => {
  const stackCount = another_mount_rokkon_countJob(stackJob1, stackJob2, func);
  const unmarkedCount = another_mount_rokkon_countJob(unmarkedJob1, unmarkedJob2, func);
  return stackCount === 1 && unmarkedCount === 1;
};
const another_mount_rokkon_isMeleeOrTank = x => util/* default.isMeleeDpsJob */.Z.isMeleeDpsJob(x) || util/* default.isTankJob */.Z.isTankJob(x);
const another_mount_rokkon_isSupport = x => util/* default.isHealerJob */.Z.isHealerJob(x) || util/* default.isTankJob */.Z.isTankJob(x);
const another_mount_rokkon_findStackPartners = (data, stack1, stack2, stackOrderOverride) => {
  const party = data.party;
  if (stack1 === undefined || stack2 === undefined) return 'unknown';
  const stacks = [stack1, stack2];
  const unmarked = party.partyNames.filter(x => !stacks.includes(x));
  if (unmarked.length !== 2 || party.partyNames.length !== 4) return 'unknown';
  const [stackJob1, stackJob2] = stacks.map(x => party.jobName(x));
  if (stackJob1 === undefined || stackJob2 === undefined) return 'unknown';
  const [unmarkedJob1, unmarkedJob2] = unmarked.map(x => party.jobName(x));
  if (unmarkedJob1 === undefined || unmarkedJob2 === undefined) return 'unknown';
  const couldStack = func => {
    return another_mount_rokkon_couldStackLooseFunc(stackJob1, stackJob2, unmarkedJob1, unmarkedJob2, func);
  };
  const stackOrder = stackOrderOverride ?? data.triggerSetConfig.stackOrder;
  if (stackOrder === 'meleeRolesPartners' && couldStack(another_mount_rokkon_isMeleeOrTank)) return 'melee';
  if (couldStack(another_mount_rokkon_isSupport)) return 'role';

  // if we get here, then you have a not normal light party comp, e.g. two ranged
  // or you have set the config option to be "rolesPartners" to not prefer melee.
  // For a tank/healer/ranged/ranged comp, this condition below will always be true
  // but make it anyway in case the party comp is something else entirely.
  const stackCount = another_mount_rokkon_countJob(stackJob1, stackJob2, another_mount_rokkon_isSupport);
  const unmarkedCount = another_mount_rokkon_countJob(unmarkedJob1, unmarkedJob2, another_mount_rokkon_isSupport);
  if (stackCount === 2 && unmarkedCount === 0 || stackCount === 0 && unmarkedCount === 2) return 'partner';

  // if something has gone incredibly awry, then just return the default
  return 'unknown';
};
const another_mount_rokkon_stackSpreadResponse = (data, output, collect, stackId, spreadId, hideStackList) => {
  // cactbot-builtin-response
  output.responseOutputStrings = {
    // In a 4 person party with two randomly assigned stacks,
    // there are a couple of different "kinds of pairs" that make sense to call.
    //
    // You can have two melees together and two ranged together,
    // or you can have two supports together and two dps together (role stacks)
    // or you have no melee in your comp, and you could have mixed support and range.
    // Arguably things like "tank+ranged, melee+healer" are possible but are harder to call.
    //
    // Prefer "melee/ranged" stacks here and elsewhere because it keeps
    // the tank and melee together for uptime.
    spreadThenMeleeStack: {
      en: 'Spread => Melees Stack',
      de: 'Verteilen => Nahkämpfer sammeln',
      fr: 'Écartez-vous => Package mêlées',
      ja: '散会 => 近接ペア',
      cn: '分散 => 近战分摊',
      ko: '산개 => 근딜 쉐어'
    },
    spreadThenRoleStack: {
      en: 'Spread => Role Stacks',
      de: 'Verteilen => Rollengruppe sammeln',
      fr: 'Écartez-vous => Package par rôle',
      ja: '散会 => ロールペア',
      cn: '分散 => 职能分摊',
      ko: '산개 => 역할별 쉐어'
    },
    spreadThenPartnerStack: {
      en: 'Spread => Partner Stacks',
      de: 'Verteilen => Partner sammeln',
      fr: 'Écartez-vous => Package partenaire',
      ja: '散会 => ペア',
      cn: '分散 => 和搭档分摊',
      ko: '산개 => 파트너 쉐어'
    },
    meleeStackThenSpread: {
      en: 'Melees Stack => Spread',
      de: 'Nahkämpfer sammeln => Verteilen',
      fr: 'Package mêlées => Écartez-vous',
      ja: '近接ペア => 散会',
      cn: '近战分摊 => 分散',
      ko: '근딜 쉐어 => 산개'
    },
    roleStackThenSpread: {
      en: 'Role Stacks => Spread',
      de: 'Rollengruppe sammeln => Verteilen',
      fr: 'Package par rôle => Écartez-vous',
      ja: 'ロールペア => 散会',
      cn: '职能分摊 => 分散',
      ko: '역할별 쉐어 => 산개'
    },
    partnerStackThenSpread: {
      en: 'Partner Stacks => Spread',
      de: 'Partner sammeln => Verteilen',
      fr: 'Package partenaire => Écartez-vous',
      ja: 'ペア => 散会',
      cn: '和搭档分摊 => 分散',
      ko: '파트너 쉐어 => 산개'
    },
    spreadThenStack: outputs/* default.spreadThenStack */.Z.spreadThenStack,
    stackThenSpread: outputs/* default.stackThenSpread */.Z.stackThenSpread,
    stacks: {
      en: 'Stacks: ${player1}, ${player2}',
      de: 'Sammeln: ${player1}, ${player2}',
      fr: 'Package : ${player1}, ${player2}',
      ja: '頭割り: ${player1}, ${player2}',
      cn: '分摊点: ${player1}, ${player2}',
      ko: '쉐어: ${player1}, ${player2}'
    }
  };
  const [stack1, stack2] = collect.filter(x => x.effectId === stackId);
  const spread = collect.find(x => x.effectId === spreadId);
  if (stack1 === undefined || stack2 === undefined || spread === undefined) return;
  const stackTime = parseFloat(stack1.duration);
  const spreadTime = parseFloat(spread.duration);
  const isStackFirst = stackTime < spreadTime;
  const stackType = another_mount_rokkon_findStackPartners(data, stack1.target, stack2.target);
  const stacks = [stack1, stack2].map(x => x.target).sort();
  const [player1, player2] = stacks.map(x => data.party.member(x));
  const stackInfo = hideStackList ? {} : {
    infoText: output.stacks({
      player1: player1,
      player2: player2
    })
  };
  data.stackSpreadFirstMechanic = isStackFirst ? stackType : 'spread';
  data.stackSpreadSecondMechanic = isStackFirst ? 'spread' : stackType;
  if (stackType === 'melee') {
    if (isStackFirst) return {
      alertText: output.meleeStackThenSpread(),
      ...stackInfo
    };
    return {
      alertText: output.spreadThenMeleeStack(),
      ...stackInfo
    };
  } else if (stackType === 'role') {
    if (isStackFirst) return {
      alertText: output.roleStackThenSpread(),
      ...stackInfo
    };
    return {
      alertText: output.spreadThenRoleStack(),
      ...stackInfo
    };
  } else if (stackType === 'partner') {
    if (isStackFirst) return {
      alertText: output.partnerStackThenSpread(),
      ...stackInfo
    };
    return {
      alertText: output.spreadThenPartnerStack(),
      ...stackInfo
    };
  }

  // 'unknown' catch-all
  if (isStackFirst) return {
    alertText: output.stackThenSpread(),
    ...stackInfo
  };
  return {
    alertText: output.spreadThenStack(),
    ...stackInfo
  };
};
const another_mount_rokkon_towerResponse = (data, output) => {
  // cactbot-builtin-response
  output.responseOutputStrings = {
    tetherThenBlueTower: {
      en: 'Tether ${num1} => Blue Tower ${num2}',
      de: 'Verbindung ${num1} => Blauer Turm ${num2}',
      fr: 'Lien ${num1} => Tour bleue ${num2}',
      ja: '線${num1} => 青塔${num2}',
      cn: '连线 ${num1} => 蓝塔 ${num2}',
      ko: '선 ${num1} => 파랑 기둥 ${num2}'
    },
    tetherThenOrangeTower: {
      en: 'Tether ${num1} => Orange Tower ${num2}',
      de: 'Verbindung ${num1} => Orangener Turm ${num2}',
      fr: 'Lien ${num1} => Tour orange ${num2}',
      ja: '線${num1} => 赤塔${num2}',
      cn: '连线 ${num1} => 橙塔 ${num2}',
      ko: '선 ${num1} => 주황 기둥 ${num2}'
    },
    tether: {
      en: 'Tether ${num}',
      de: 'Verbindung ${num}',
      fr: 'Lien ${num}',
      ja: '線${num}',
      cn: '连线 ${num}',
      ko: '선 ${num}'
    },
    blueTower: {
      en: 'Blue Tower ${num}',
      de: 'Blauer Turm ${num}',
      fr: 'Tour bleue ${num}',
      ja: '青塔${num}',
      cn: '蓝塔 ${num}',
      ko: '파랑 기둥 ${num}'
    },
    orangeTower: {
      en: 'Orange Tower ${num}',
      de: 'Orangener Turm ${num}',
      fr: 'Tour orange ${num}',
      ja: '赤塔${num}',
      cn: '橙塔 ${num}',
      ko: '주황 기둥 ${num}'
    },
    num1: outputs/* default.num1 */.Z.num1,
    num2: outputs/* default.num2 */.Z.num2,
    num3: outputs/* default.num3 */.Z.num3,
    num4: outputs/* default.num4 */.Z.num4
  };

  // data.rousingTowerCount is 0-indexed
  // towerNum for display is 1-indexed
  const theseTowers = data.rousingCollect[data.rousingTowerCount];
  const towerNum = data.rousingTowerCount + 1;
  data.rousingTowerCount++;
  if (theseTowers === undefined) return;
  const numMap = {
    1: output.num1(),
    2: output.num2(),
    3: output.num3(),
    4: output.num4()
  };
  const numStr = numMap[towerNum];
  if (numStr === undefined) return;
  if (data.me === theseTowers.blue) return {
    alertText: output.blueTower({
      num: numStr
    })
  };
  if (data.me === theseTowers.orange) return {
    alertText: output.orangeTower({
      num: numStr
    })
  };
  const nextTowers = data.rousingCollect[towerNum + 1];
  const nextNumStr = numMap[towerNum + 1];
  if (towerNum === 4 || nextTowers === undefined || nextNumStr === undefined) return {
    infoText: output.tether({
      num: numStr
    })
  };
  if (data.me === nextTowers.blue) return {
    infoText: output.tetherThenBlueTower({
      num1: numStr,
      num2: nextNumStr
    })
  };
  if (data.me === nextTowers.orange) return {
    infoText: output.tetherThenOrangeTower({
      num1: numStr,
      num2: nextNumStr
    })
  };

  // Just in case...
  return {
    infoText: output.tether({
      num: numStr
    })
  };
};
const another_mount_rokkon_triggerSet = {
  id: 'AnotherMountRokkon',
  zoneId: zone_id/* default.AnotherMountRokkon */.Z.AnotherMountRokkon,
  config: [{
    id: 'stackOrder',
    comment: {
      en: `For any two person stacks, this specifies the priority order for picking people to stack together.
           If you want your melee and tank to stick together if possible, pick the option with melees in it.
           Melees stack means melee+tank and healer+ranged. Role stacks means tank+healer and dps+dps.
           Partner stacks mean support+dps and support+dps (any combination works).
           If you have two ranged dps or two melee dps, it will never call "melees" regardless of this config option.
           There is no support for party comps that are not two support and two dps.`,
      de: `Für jeden Zwei-Personen-Stack gibt dies die Prioritätsreihenfolge für die Auswahl der Personen an, die sich sammeln.
           Wenn ihr wollt, dass Nahkämpfer und Tank nach Möglichkeit zusammenbleiben, wählt die Option mit den Nahkämpfern aus.
           Nahkampf-Stack bedeutet Nahkampf+Tank und Heiler+Ranger. Rollen-Stack bedeutet Tank+Heiler und Dps+Dps.
           Partner-Stack bedeuten Supporter+Dps und Supporter+Dps (jede Kombination ist möglich).
           Wenn du zwei Fernkampf-DPS oder zwei Nahkampf-DPS hast, wird es nie "Nahkämpfer" nennen, unabhängig von dieser Konfigurationsoption.
           Es gibt keine Unterstützung für Gruppenkombinationen, die nicht aus zwei Supportern und zwei DPS bestehen.`,
      fr: `Pour n'importe quel package à deux, ceci spécifie l'ordre de priorité pour choisir la personne avec qui se packer.
          Si vous voulez votre mêlée et tank ensemble, choisissez l'option contenant mêlée.
          Package mêlée signifie mêlée+tank et healer+distant. Package par rôle signifie tank+healer et dps+dps.
          Package partenaire signifie support+dps (n'importe quelle combinaison fonctionne).
          Si votre groupe est composée de deux distants ou deux mêlées, "mêlées" ne sera jamais annoncé quelque soit l'option choisie.
          Les groupes ne contenant pas deux supports et deux dps ne peuvent pas être annoncés.`,
      ja: `2人ペアで一緒にペアを作り優先順位を決めます。近接とタンクを組む場合は近接オプションを選んでください。
          近接ペアは近接+タンクとヒーラ+遠隔を意味します。ロールはタンク+ヒーラ、近接+遠隔を意味します。
          遠隔まだは近接が2人の場合は、ここの設定を無視して近接呼び出しはありません。
          および、タンク+ヒーラ+DPS2人じゃないパティは志願しません。`,
      cn: `对于所有双人分摊，该选项指定了选择谁与谁分摊的优先级。
           如果你想让近战和坦克分摊 (假设分摊没有同时点这两个人), 选择含有“近战 (melee)”的选项。
           近战 (melee) 分摊指的是 近战+坦克 和 治疗+远程。职能分摊指的是 坦克 + 治疗 和 DPS + DPS。
           搭档分摊指的是 支援 + DPS 和 支援 + DPS (任何组合都有可能，支援位是坦克和治疗)。
           如果队伍中有两名远程 DPS 或近战 DPS, 无论此配置选项如何, 它都不会报“近战 (melees)”。
           没有考虑对非标准阵容队伍 (非 2 支援 + 2DPS) 构成的支持。`,
      ko: `2인 쉐어에서, 함께 쉐어를 맞을 사람의 우선 순위를 지정합니다. 근딜과 탱커를 함께 배치하고 싶다면 근딜이 포함된 옵션을 선택하세요.
           근딜 쉐어는 근딜+탱커와 힐러+원딜을 의미합니다. 역할별 쉐어는 탱커+힐러와 딜러+딜러를 의미합니다.
           파트너 쉐어는 탱힐+딜러와 탱힐+딜러를 의미합니다(어떤 조합도 가능).
           원딜이 두 명 또는 근딜이 두 명일 경우, 이 설정 옵션과 상관없이 "근딜"을 호출하지 않습니다.
           탱힐 둘, 딜러 둘이 아닌 파티 구성은 지원되지 않습니다.`
    },
    name: {
      en: 'Stack Selection Order',
      de: 'Sammel-Reihenfolge',
      fr: 'Ordre de sélection des packages',
      ja: 'ペア優先順位',
      cn: '选择分摊次序',
      ko: '쉐어 우선순위'
    },
    type: 'select',
    options: {
      en: {
        'Melees > Roles > Partners': 'meleeRolesPartners',
        'Roles > Partners': 'rolesPartners'
      },
      de: {
        'Nahkämpfer > Rollen > Partner': 'meleeRolesPartners',
        'Rollen > Partner': 'rolesPartners'
      },
      fr: {
        'Mêlées > Rôles > Partenaires': 'meleeRolesPartners',
        'Rôles > Partenaires': 'rolesPartners'
      },
      ja: {
        '近接 > ロール > ペア': 'meleeRolesPartners',
        'ロール > ペア': 'rolesPartners'
      },
      cn: {
        '近战 > 职能 > 搭档': 'meleeRolesPartners',
        '职能 > 搭档': 'rolesPartners'
      },
      ko: {
        '근딜 > 역할군 > 파트너': 'meleeRolesPartners',
        '역할군 > 파트너': 'rolesPartners'
      }
    },
    default: 'meleeRolesPartners'
  }],
  timelineFile: 'another_mount_rokkon.txt',
  initData: () => {
    return {
      combatantData: [],
      smokeaterCount: 0,
      rairinCollect: [],
      wailingCollect: [],
      wailCount: 0,
      devilishThrallCollect: [],
      reishoCount: 0,
      ghostHeadmarkers: [],
      sparksCollect: [],
      sparksCount: 0,
      rousingCollect: [{}, {}, {}, {}],
      rousingTowerCount: 0,
      malformedCollect: [],
      myMalformedEffects: [],
      malformedTowerCount: 0,
      tripleKasumiCollect: [],
      explosionLineCollect: [],
      shadowKasumiCollect: {},
      shadowKasumiTether: {},
      invocationCollect: [],
      iaigiriTether: [],
      iaigiriPurple: [],
      iaigiriCasts: [],
      oniClawCollect: []
    };
  },
  triggers: [
  // ---------------- first trash ----------------
  {
    id: 'AMR Shishu Raiko Disciples of Levin',
    type: 'StartsUsing',
    netRegex: {
      id: '8656',
      source: 'Shishu Raiko',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'AMR Shishu Raiko Barreling Smash',
    type: 'StartsUsing',
    netRegex: {
      id: '8653',
      source: 'Shishu Raiko'
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        chargeOnYou: {
          en: 'Charge on YOU',
          de: 'Ansturm auf DIR',
          fr: 'Ruée sur VOUS',
          ja: '自分に突進',
          cn: '冲锋点名',
          ko: '돌진 대상자'
        },
        chargeOn: {
          en: 'Charge on ${player}',
          de: 'Ansturm auf ${player}',
          fr: 'Ruée sur ${player}',
          ja: '突進: ${player}',
          cn: '冲锋点 ${player}',
          ko: '돌진 ${player}'
        }
      };
      if (matches.target === data.me) return {
        alarmText: output.chargeOnYou()
      };
      return {
        alertText: output.chargeOn({
          player: data.party.member(matches.target)
        })
      };
    }
  }, {
    id: 'AMR Shishu Raiko Howl',
    type: 'StartsUsing',
    netRegex: {
      id: '8654',
      source: 'Shishu Raiko',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'AMR Shishu Raiko Master of Levin',
    type: 'StartsUsing',
    netRegex: {
      id: '8655',
      source: 'Shishu Raiko',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'AMR Shishu Fuko Scythe Tail',
    type: 'StartsUsing',
    netRegex: {
      id: '865A',
      source: 'Shishu Fuko',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'AMR Shishu Fuko Twister',
    type: 'StartsUsing',
    netRegex: {
      id: '8658',
      source: 'Shishu Fuko'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'AMR Shishu Fuko Crosswind',
    type: 'StartsUsing',
    netRegex: {
      id: '8659',
      source: 'Shishu Fuko',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'AMR Shishu Yuki Auto Tracker',
    type: 'Ability',
    netRegex: {
      id: '7A58',
      source: 'Shishu Yuki',
      capture: false
    },
    // Before being pulled (aka seeing an auto), Shishu Yuki faces south when doing
    // right/left cleaves. Make these absolute directions for clarity.
    // Shishu Yuki does have a buff that prevents pulling it, but there's no line
    // for this buff loss.
    run: data => data.seenShishuYukiAuto = true
  }, {
    id: 'AMR Shishu Yuki Right Swipe',
    type: 'StartsUsing',
    netRegex: {
      id: '8685',
      source: 'Shishu Yuki',
      capture: false
    },
    alertText: (data, _matches, output) => {
      return data.seenShishuYukiAuto ? output.left() : output.east();
    },
    outputStrings: {
      east: outputs/* default.east */.Z.east,
      left: outputs/* default.left */.Z.left
    }
  }, {
    id: 'AMR Shishu Yuki Left Swipe',
    type: 'StartsUsing',
    netRegex: {
      id: '8686',
      source: 'Shishu Yuki',
      capture: false
    },
    alertText: (data, _matches, output) => {
      return data.seenShishuYukiAuto ? output.right() : output.west();
    },
    outputStrings: {
      west: outputs/* default.west */.Z.west,
      right: outputs/* default.right */.Z.right
    }
  },
  // ---------------- Shishio ----------------
  {
    id: 'AMR Shishio Enkyo',
    type: 'StartsUsing',
    netRegex: {
      id: '841A',
      source: 'Shishio',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'AMR Shishio Smokeater Count',
    type: 'Ability',
    // 83F9 is the initial Smokeater, and 83FA is the followup optional two.
    netRegex: {
      id: ['83F9', '83FA'],
      source: 'Shishio'
    },
    sound: '',
    infoText: (data, matches, output) => {
      if (matches.id === '83F9') {
        data.smokeaterCount = 1;
        return output.num1();
      }
      data.smokeaterCount++;
      if (data.smokeaterCount === 2) return output.num2();
      return output.num3();
    },
    outputStrings: {
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3
    }
  }, {
    id: 'AMR Shishio Splitting Cry',
    type: 'StartsUsing',
    netRegex: {
      id: '841B',
      source: 'Shishio'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AMR Shishio Splitter',
    type: 'Ability',
    // This comes out ~4s after Splitting Cry.
    netRegex: {
      id: '841B',
      source: 'Shishio',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.goFrontOrSides */.n3.goFrontOrSides('info')
  }, {
    id: 'AMR Rairin Collect',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '12430'
    },
    run: (data, matches) => data.rairinCollect.push(matches)
  }, {
    id: 'AMR Noble Pursuit',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '12430',
      capture: false
    },
    condition: data => data.rairinCollect.length === 4,
    alertText: (data, _matches, output) => {
      const [one, two, three, four] = data.rairinCollect;
      if (one === undefined || two === undefined || three === undefined || four === undefined) return;

      // one is always north (0, -115)
      // two is always south (0, -85)
      // three is left or right (+/-15, -80)
      // four is either diagonal (7.5, -92.5) / (-6, -94) or back north (+/-20, -95)

      // We always end up on the opposite side as the third charge.
      const isThreeEast = parseFloat(three.x) > 0;
      // If four is diagonal, you go south otherwise north.
      const isFourDiagonal = Math.abs(parseFloat(four.x)) < 18;
      if (isFourDiagonal) return isThreeEast ? output.southwest() : output.southeast();
      return isThreeEast ? output.northwest() : output.northeast();
    },
    outputStrings: {
      northeast: outputs/* default.northeast */.Z.northeast,
      southeast: outputs/* default.southeast */.Z.southeast,
      southwest: outputs/* default.southwest */.Z.southwest,
      northwest: outputs/* default.northwest */.Z.northwest
    }
  }, {
    id: 'AMR Shishio Unnatural Wail Count',
    type: 'StartsUsing',
    netRegex: {
      id: '8417',
      source: 'Shishio',
      capture: false
    },
    run: data => {
      data.wailCount++;
      data.wailingCollect = [];
    }
  }, {
    id: 'AMR Shishio Wailing Collect',
    type: 'GainsEffect',
    // DEB = Scattered Wailing (spread)
    // DEC = Intensified Wailing (stack)
    netRegex: {
      effectId: ['DEB', 'DEC'],
      source: 'Shishio'
    },
    run: (data, matches) => data.wailingCollect.push(matches)
  }, {
    id: 'AMR Shishio Unnatural Wailing 1',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['DEB', 'DEC'],
      source: 'Shishio',
      capture: false
    },
    condition: data => data.wailCount === 1,
    delaySeconds: 0.5,
    suppressSeconds: 999999,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      return another_mount_rokkon_stackSpreadResponse(data, output, data.wailingCollect, 'DEC', 'DEB');
    }
  }, {
    id: 'AMR Shishio Vortex of the Thunder Eye',
    type: 'StartsUsing',
    // 8413 = Eye of the Thunder Vortex (out)
    // 8415 = Vortex of the Thnder Eye (in)
    netRegex: {
      id: ['8413', '8415'],
      source: 'Shishio'
    },
    durationSeconds: 7,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        out: outputs/* default.out */.Z.out,
        in: outputs/* default.in */.Z["in"],
        spreadThenMeleeStack: {
          en: '${inOut} + Spread => ${outIn} + Melees Stack',
          de: '${inOut} + Verteilen => ${outIn} + Nahkämpfer sammeln',
          fr: '${inOut} + Écartement => ${outIn} + Package mêlées',
          ja: '${inOut} + 散会 => ${outIn} + 近接ペア',
          cn: '${inOut} + 分散 => ${outIn} + 近战分摊',
          ko: '${inOut} + 산개 => ${outIn} + 근딜 쉐어'
        },
        spreadThenRoleStack: {
          en: '${inOut} + Spread => ${outIn} + Role Stacks',
          de: '${inOut} + Verteilen => ${outIn} + Rollengruppe sammeln',
          fr: '${inOut} + Écartement => ${outIn} + Package par rôle',
          ja: '${inOut} + 散会 => ${outIn} + ロールペア',
          cn: '${inOut} + 分散 => ${outIn} + 职能分摊',
          ko: '${inOut} + 산개 => ${outIn} + 역할별 쉐어'
        },
        spreadThenPartnerStack: {
          en: '${inOut} + Spread => ${outIn} + Partner Stacks',
          de: '${inOut} + Verteilen => ${outIn} + Partner sammeln',
          fr: '${inOut} + Écartement => ${outIn} + Package partenaire',
          ja: '${inOut} + 散会 => ${outIn} + ペア',
          cn: '${inOut} + 分散 => ${outIn} + 和搭档分摊',
          ko: '${inOut} + 산개 => ${outIn} + 파트너 쉐어'
        },
        meleeStackThenSpread: {
          en: '${inOut} + Melees Stack => ${outIn} + Spread',
          de: '${inOut} + Nahkämpfer sammeln => ${outIn} + Verteilen',
          fr: '${inOut} + Package mêlées => ${outIn} + Écartement',
          ja: '${inOut} + 近接ペア => ${outIn} + 散会',
          cn: '${inOut} + 近战分摊 => ${outIn} + 分散',
          ko: '${inOut} + 근딜 쉐어 => ${outIn} + 산개'
        },
        roleStackThenSpread: {
          en: '${inOut} + Role Stacks => ${outIn} + Spread',
          de: '${inOut} + Rollengruppe sammeln => ${outIn} + Verteilen',
          fr: '${inOut} + Package par rôle => ${outIn} + Écartement',
          ja: '${inOut} + ロールペア => ${outIn} + 散会',
          cn: '${inOut} + 职能分摊 => ${outIn} + 分散',
          ko: '${inOut} + 역할별 쉐어 => ${outIn} + 산개'
        },
        partnerStackThenSpread: {
          en: '${inOut} + Partner Stacks => ${outIn} + Spread',
          de: '${inOut} + Partner sammeln => ${outIn} + Verteilen',
          fr: '${inOut} + Package partenaire  => ${outIn} + Écartement',
          ja: '${inOut} + ペア => ${outIn} + 散会',
          cn: '${inOut} + 和搭档分摊 => ${outIn} + 分散',
          ko: '${inOut} + 파트너 쉐어 => ${outIn} + 산개'
        },
        spreadThenStack: {
          en: '${inOut} + Spread => ${outIn} + Stack',
          de: '${inOut} + Verteilen => ${outIn} + Sammeln',
          fr: '${inOut} + Écartement => ${outIn} + Package',
          ja: '${inOut} + 散会 => ${outIn} + ペア',
          cn: '${inOut} + 分散 => ${outIn} + 分摊',
          ko: '${inOut} + 산개 => ${outIn} + 쉐어'
        },
        stackThenSpread: {
          en: '${inOut} + Stack => ${outIn} + Spread',
          de: '${inOut} + Sammeln => ${outIn} + Verteilen',
          fr: '${inOut} + Package => ${outIn} + Écartement',
          ja: '${inOut} + ペア => ${outIn} + 散会',
          cn: '${inOut} + 分摊 => ${outIn} + 分散',
          ko: '${inOut} + 쉐어 => ${outIn} + 산개'
        },
        stacks: {
          en: 'Stacks: ${player1}, ${player2}',
          de: 'Sammeln: ${player1}, ${player2}',
          fr: 'Package : ${player1}, ${player2}',
          ja: '頭割り: ${player1}, ${player2}',
          cn: '分摊点: ${player1}, ${player2}',
          ko: '쉐어: ${player1}, ${player2}'
        }
      };
      const [stack1, stack2] = data.wailingCollect.filter(x => x.effectId === 'DEC');
      const spread = data.wailingCollect.find(x => x.effectId === 'DEB');
      if (stack1 === undefined || stack2 === undefined || spread === undefined) return;
      const stackTime = parseFloat(stack1.duration);
      const spreadTime = parseFloat(spread.duration);
      const isStackFirst = stackTime < spreadTime;
      const stackType = another_mount_rokkon_findStackPartners(data, stack1.target, stack2.target);
      const isInFirst = matches.id === '8415';
      const inOut = isInFirst ? output.in() : output.out();
      const outIn = isInFirst ? output.out() : output.in();
      const args = {
        inOut: inOut,
        outIn: outIn
      };
      const stacks = [stack1, stack2].map(x => x.target).sort();
      const [player1, player2] = stacks.map(x => data.party.member(x));
      const stackInfo = {
        infoText: output.stacks({
          player1: player1,
          player2: player2
        })
      };
      data.vortexSecondMechanic = isInFirst ? 'out' : 'in';
      data.stackSpreadFirstMechanic = isStackFirst ? stackType : 'spread';
      data.stackSpreadSecondMechanic = isStackFirst ? 'spread' : stackType;
      if (stackType === 'melee') {
        if (isStackFirst) return {
          alertText: output.meleeStackThenSpread(args),
          ...stackInfo
        };
        return {
          alertText: output.spreadThenMeleeStack(args),
          ...stackInfo
        };
      } else if (stackType === 'role') {
        if (isStackFirst) return {
          alertText: output.roleStackThenSpread(args),
          ...stackInfo
        };
        return {
          alertText: output.spreadThenRoleStack(args),
          ...stackInfo
        };
      } else if (stackType === 'partner') {
        if (isStackFirst) return {
          alertText: output.partnerStackThenSpread(args),
          ...stackInfo
        };
        return {
          alertText: output.spreadThenPartnerStack(args),
          ...stackInfo
        };
      }

      // 'unknown' catch-all
      if (isStackFirst) return {
        alertText: output.stackThenSpread(args),
        ...stackInfo
      };
      return {
        alertText: output.spreadThenStack(args),
        ...stackInfo
      };
    }
  }, {
    id: 'AMR Shishio Vortex of the Thunder Eye Followup',
    type: 'Ability',
    // 8418 = Unnatural Ailment
    // 8419 = Unnatural Force
    netRegex: {
      id: ['8418', '8419'],
      capture: false
    },
    condition: data => data.wailCount !== 1,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      const mech = data.stackSpreadSecondMechanic;
      if (mech === undefined) return;
      delete data.stackSpreadFirstMechanic;
      delete data.stackSpreadSecondMechanic;
      const mechanicStr = output[mech]();
      const inOut = data.vortexSecondMechanic;
      if (inOut === undefined) return;
      delete data.vortexSecondMechanic;
      const inOutStr = output[inOut]();
      return output.text({
        inOut: inOutStr,
        mechanic: mechanicStr
      });
    },
    outputStrings: {
      text: {
        en: '${inOut} + ${mechanic}',
        de: '${inOut} + ${mechanic}',
        fr: '${inOut} + ${mechanic}',
        ja: '${inOut} + ${mechanic}',
        cn: '${inOut} + ${mechanic}',
        ko: '${inOut} + ${mechanic}'
      },
      out: outputs/* default.out */.Z.out,
      in: outputs/* default.in */.Z["in"],
      ...another_mount_rokkon_basicStackSpreadOutputStrings
    }
  }, {
    id: 'AMR Shishio Thunder Vortex',
    type: 'StartsUsing',
    netRegex: {
      id: '8412',
      source: 'Shishio',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'AMR Shishio Devilish Thrall Collect',
    type: 'StartsUsing',
    // 840B = Right Swipe
    // 840C = Left Swipe
    netRegex: {
      id: ['840B', '840C'],
      source: 'Devilish Thrall'
    },
    run: (data, matches) => data.devilishThrallCollect.push(matches)
  }, {
    id: 'AMR Shishio Devilish Thrall Safe Spot',
    type: 'StartsUsing',
    // Note: the second call of this comes out before the first one happens,
    // but it's important to know where you're going.
    netRegex: {
      id: ['840B', '840C'],
      source: 'Devilish Thrall',
      capture: false
    },
    delaySeconds: 0.5,
    durationSeconds: 6,
    suppressSeconds: 1,
    promise: async data => {
      data.combatantData = [];
      const ids = data.devilishThrallCollect.map(x => parseInt(x.sourceId, 16));
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: ids
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      if (data.combatantData.length !== 4) return;
      const centerX = 0;
      const centerY = -100;

      // Intercard thralls:
      //   x = 0 +/- 10
      //   y = -100 +/- 10
      //   heading = intercards (pi/4 + pi/2 * n)
      // Cardinal thralls:
      //   x = 0 +/- 12
      //   y = -100 +/- 12
      //   heading = cardinals (pi/2 * n)

      // One is a set of four on cardinals, the others a set of 4 on intercards.
      // There seems to be only one pattern of thralls, rotated.
      // Two are pointed inward (direct opposite to their position)
      // and two are pointed outward (perpendicular to their position).
      // Because of this, no need to check left/right cleave as position and directions tell all.
      const states = data.combatantData.map(combatant => {
        return {
          dir: util/* Directions.combatantStatePosTo8Dir */.N.combatantStatePosTo8Dir(combatant, centerX, centerY),
          heading: util/* Directions.combatantStateHdgTo8Dir */.N.combatantStateHdgTo8Dir(combatant)
        };
      });
      const outwardStates = states.filter(state => state.dir !== (state.heading + 4) % 8);
      const [pos1, pos2] = outwardStates.map(x => x.dir).sort();
      if (pos1 === undefined || pos2 === undefined || outwardStates.length !== 2) return;
      const mech = data.stackSpreadFirstMechanic ?? data.stackSpreadSecondMechanic;
      const mechanicStr = mech !== undefined ? output[mech]() : output.unknownMech();
      if (data.stackSpreadFirstMechanic) delete data.stackSpreadFirstMechanic;else if (data.stackSpreadSecondMechanic) delete data.stackSpreadSecondMechanic;

      // 0/6 (average 7) and 1/7 (average 0) are the two cases where the difference is 6 and not 2.
      const averagePos = Math.floor((pos2 + pos1 + (pos2 - pos1 === 6 ? 8 : 0)) / 2) % 8;
      const params = {
        mechanic: mechanicStr
      };
      return {
        0: output.north(params),
        1: output.northeast(params),
        2: output.east(params),
        3: output.southeast(params),
        4: output.south(params),
        5: output.southwest(params),
        6: output.west(params),
        7: output.northwest(params)
      }[averagePos];
    },
    run: data => data.devilishThrallCollect = [],
    outputStrings: {
      north: {
        en: 'North Diamond + ${mechanic}',
        de: 'nördlicher Diamant + ${mechanic}',
        fr: 'Diamant Nord + ${mechanic}',
        ja: '北 + ${mechanic}',
        cn: '上 (北) 菱形 + ${mechanic}',
        ko: '북쪽 + ${mechanic}'
      },
      east: {
        en: 'East Diamond + ${mechanic}',
        de: 'östlicher Diamant + ${mechanic}',
        fr: 'Diamant Est + ${mechanic}',
        ja: '東 + ${mechanic}',
        cn: '右 (东) 菱形 + ${mechanic}',
        ko: '동쪽 + ${mechanic}'
      },
      south: {
        en: 'South Diamond + ${mechanic}',
        de: 'südlicher Diamant + ${mechanic}',
        fr: 'Diamant Sud + ${mechanic}',
        ja: '南 + ${mechanic}',
        cn: '下 (南) 菱形 + ${mechanic}',
        ko: '남쪽 + ${mechanic}'
      },
      west: {
        en: 'West Diamond + ${mechanic}',
        de: 'westlicher Diamant + ${mechanic}',
        fr: 'Diamant Ouest + ${mechanic}',
        ja: '西 + ${mechanic}',
        cn: '左 (西) 菱形 + ${mechanic}',
        ko: '서쪽 + ${mechanic}'
      },
      northeast: {
        en: 'Northeast Square + ${mechanic}',
        de: 'nordöstliches Viereck + ${mechanic}',
        fr: 'Carré Nord-Est + ${mechanic}',
        ja: '北東 + ${mechanic}',
        cn: '右上 (东北) 正方形 + ${mechanic}',
        ko: '북동쪽 + ${mechanic}'
      },
      southeast: {
        en: 'Southeast Square + ${mechanic}',
        de: 'südöstliches Viereck + ${mechanic}',
        fr: 'Carré Sud-Est + ${mechanic}',
        ja: '南東 + ${mechanic}',
        cn: '右下 (东南) 正方形 + ${mechanic}',
        ko: '남동쪽 + ${mechanic}'
      },
      southwest: {
        en: 'Southwest Square + ${mechanic}',
        de: 'südwestliches Viereck + ${mechanic}',
        fr: 'Carré Sud-Ouest + ${mechanic}',
        ja: '南西 + ${mechanic}',
        cn: '左下 (西南) 正方形 + ${mechanic}',
        ko: '남서쪽 + ${mechanic}'
      },
      northwest: {
        en: 'Northwest Square + ${mechanic}',
        de: 'nordwestliches Viereck + ${mechanic}',
        fr: 'Carré Nord-Ouest + ${mechanic}',
        ja: '北西 + ${mechanic}',
        cn: '左上 (西北) 正方形 + ${mechanic}',
        ko: '북서쪽 + ${mechanic}'
      },
      ...another_mount_rokkon_basicStackSpreadOutputStrings,
      unknownMech: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'AMR Shishio Haunting Thrall Reisho Count',
    type: 'Ability',
    // Sometimes these adds have not changed their name from Shishio to Haunting Thrall.
    netRegex: {
      id: '840D',
      capture: false
    },
    preRun: data => data.reishoCount++,
    durationSeconds: 1.5,
    // There are 8 pulses, 2 seconds apart.
    suppressSeconds: 0.5,
    // Play an alarm on the 8th one, but don't play noises for each count.
    sound: data => data.ghostMechanic === 'tower' && data.reishoCount === 8 ? undefined : '',
    alarmText: (data, _matches, output) => {
      if (data.ghostMechanic === 'tower' && data.reishoCount === 8) return output.tower();
    },
    infoText: (data, _matches, output) => output[`num${data.reishoCount}`](),
    outputStrings: {
      tower: {
        en: 'Tower',
        de: 'Türme',
        fr: 'Tour',
        ja: '塔',
        cn: '塔',
        ko: '기둥'
      },
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      num5: outputs/* default.num5 */.Z.num5,
      num6: outputs/* default.num6 */.Z.num6,
      num7: outputs/* default.num7 */.Z.num7,
      num8: outputs/* default.num8 */.Z.num8
    }
  }, {
    id: 'AMR Shishio Haunting Thrall Headmarker',
    type: 'HeadMarker',
    netRegex: {
      id: '01D8'
    },
    condition: (data, matches) => {
      data.ghostHeadmarkers.push(matches);
      return data.ghostHeadmarkers.length === 2;
    },
    alertText: (data, _matches, output) => {
      const spread = data.ghostHeadmarkers.map(x => x.target);
      const towers = data.party.partyNames.filter(x => !spread.includes(x));
      if (spread.includes(data.me)) {
        data.ghostMechanic = 'spread';
        const otherPlayer = spread.find(x => x !== data.me) ?? output.unknown();
        return output.spread({
          player: data.party.member(otherPlayer)
        });
      }
      data.ghostMechanic = 'tower';
      const otherPlayer = towers.find(x => x !== data.me) ?? output.unknown();
      return output.tower({
        player: data.party.member(otherPlayer)
      });
    },
    outputStrings: {
      tower: {
        en: 'Get Tower (w/${player})',
        de: 'Nimm Turm mit (w/${player})',
        fr: 'Prenez une tour (avec ${player})',
        ja: '塔踏み (${player})',
        cn: '踩塔 (与${player})',
        ko: '기둥 들어가기 (+${player})'
      },
      spread: {
        en: 'Spread (w/${player})',
        de: 'Verteilen (w/${player})',
        fr: 'Écartez-vous (avec ${player})',
        ja: '散会 (${player})',
        cn: '分散 (与${player})',
        ko: '산개 들어가기 (+${player})'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  },
  // ---------------- second trash ----------------
  {
    id: 'AMR Shishu Kotengu Backward Blows',
    type: 'StartsUsing',
    netRegex: {
      id: '865C',
      source: 'Shishu Kotengu',
      capture: false
    },
    durationSeconds: 5.7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sides (Stay Sides)',
        de: 'Seiten (Seitlich bleiben)',
        fr: 'Côtés (Restez sur les côtes',
        ja: '横へ (そのまま横)',
        cn: '两侧 (待在两侧)',
        ko: '양 옆 (양 옆에 있기)'
      }
    }
  }, {
    id: 'AMR Shishu Kotengu Leftward Blows',
    type: 'StartsUsing',
    netRegex: {
      id: '865D',
      source: 'Shishu Kotengu',
      capture: false
    },
    durationSeconds: 5.7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Right + Behind',
        de: 'Rechts + Hinten',
        fr: 'Droite + Derrière',
        ja: '右 + 後ろ',
        cn: '右右右 + 去背后',
        ko: '오른쪽 + 뒤'
      }
    }
  }, {
    id: 'AMR Shishu Kotengu Rightward Blows',
    type: 'StartsUsing',
    netRegex: {
      id: '865E',
      source: 'Shishu Kotengu',
      capture: false
    },
    durationSeconds: 5.7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Left + Behind',
        de: 'Links + Hinten',
        fr: 'Gauche + Derrière',
        ja: '左 + 後ろ',
        cn: '左左左 + 去背后',
        ko: '왼쪽 + 뒤'
      }
    }
  }, {
    id: 'AMR Shishu Kotengu Wrath of the Tengu',
    type: 'StartsUsing',
    netRegex: {
      id: '8660',
      source: 'Shishu Kotengu',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'AMR Shishu Kotengu Gaze of the Tengu',
    type: 'StartsUsing',
    netRegex: {
      id: '8661',
      source: 'Shishu Kotengu',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'AMR Shishu Onmitsugashira Juji Shuriken',
    type: 'StartsUsing',
    netRegex: {
      id: '8664',
      source: 'Shishu Onmitsugashira',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'AMR Shishu Onmitsugashira Issen',
    type: 'StartsUsing',
    netRegex: {
      id: '8662',
      source: 'Shishu Onmitsugashira'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AMR Shishu Onmitsugashira Huton',
    type: 'StartsUsing',
    netRegex: {
      id: '8663',
      source: 'Shishu Onmitsugashira',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dodge 4x Shuriken',
        de: 'Weiche 4x Shuriken aus',
        fr: 'Évitez le shuriken x4',
        ja: '4x 手裏剣',
        cn: '躲避 4 次手里剑',
        ko: '수리검 4개 피하기'
      }
    }
  },
  // ---------------- Gorai the Uncaged ----------------
  {
    id: 'AMR Gorai Unenlightenment',
    type: 'StartsUsing',
    netRegex: {
      id: '8534',
      source: 'Gorai the Uncaged',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe('info')
  }, {
    id: 'AMR Gorai Brazen Ballad Purple',
    type: 'StartsUsing',
    netRegex: {
      id: '8509',
      source: 'Gorai the Uncaged',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Expanding Lines',
        de: 'Weiche den größer werdenden Linien aus',
        fr: 'Évitez les lignes en expansion',
        ja: 'AOE回避',
        cn: '远离扩大连线',
        ko: '커지는 장판들 피하기'
      }
    }
  }, {
    id: 'AMR Gorai Brazen Ballad Blue',
    type: 'StartsUsing',
    netRegex: {
      id: '850A',
      source: 'Gorai the Uncaged',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Under Rock + Lines',
        de: 'Unter dem Stein + Linien',
        fr: 'Sous le rocher + lignes',
        ja: '石の下へ + 直線AOE',
        cn: '站在石头和线下',
        ko: '바위 밑으로 + 직선장판'
      }
    }
  }, {
    id: 'AMR Gorai Sparks Count',
    type: 'StartsUsing',
    netRegex: {
      id: '8503',
      source: 'Gorai the Uncaged',
      capture: false
    },
    run: data => {
      data.sparksCount++;
      data.sparksCollect = [];
    }
  }, {
    id: 'AMR Gorai Sparks Collect',
    type: 'GainsEffect',
    // E17 = Live Brazier (stack)
    // E18 = Live Candle (spread)
    netRegex: {
      effectId: ['E17', 'E18']
    },
    run: (data, matches) => data.sparksCollect.push(matches)
  }, {
    id: 'AMR Gorai Seal of Scurrying Sparks Flame and Sulphur',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E17', 'E18'],
      capture: false
    },
    condition: data => data.sparksCount !== 2,
    delaySeconds: 0.5,
    suppressSeconds: 10,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        meleeStack: another_mount_rokkon_basicStackSpreadOutputStrings.melee,
        roleStack: another_mount_rokkon_basicStackSpreadOutputStrings.role,
        partnerStack: another_mount_rokkon_basicStackSpreadOutputStrings.partner,
        stacks: {
          en: 'Stacks: ${player1}, ${player2}',
          de: 'Sammeln: ${player1}, ${player2}',
          fr: 'Package : ${player1}, ${player2}',
          ja: '頭割り: ${player1}, ${player2}',
          cn: '分摊点: ${player1}, ${player2}',
          ko: '쉐어: ${player1}, ${player2}'
        }
      };
      const [stack1, stack2] = data.sparksCollect.filter(x => x.effectId === 'E17');
      if (stack1 === undefined || stack2 === undefined) return;
      const stackType = another_mount_rokkon_findStackPartners(data, stack1.target, stack2.target);
      const stacks = [stack1, stack2].map(x => x.target).sort();
      const [player1, player2] = stacks.map(x => data.party.member(x));
      const stackInfo = {
        infoText: output.stacks({
          player1: player1,
          player2: player2
        })
      };
      if (stackType === 'melee') {
        return {
          alertText: output.meleeStack(),
          ...stackInfo
        };
      } else if (stackType === 'role') {
        return {
          alertText: output.roleStack(),
          ...stackInfo
        };
      } else if (stackType === 'partner') {
        return {
          alertText: output.partnerStack(),
          ...stackInfo
        };
      }

      // 'unknown' catch-all
      return stackInfo;
    }
  }, {
    id: 'AMR Gorai Seal of Scurrying Sparks Cloud to Ground',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E17', 'E18'],
      capture: false
    },
    condition: data => data.sparksCount === 2,
    delaySeconds: 0.5,
    suppressSeconds: 10,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      return another_mount_rokkon_stackSpreadResponse(data, output, data.sparksCollect, 'E17', 'E18');
    }
  }, {
    id: 'AMR Gorai Seal of Scurrying Sparks Cloud to Ground Followup',
    type: 'Ability',
    // 8505 = Greater Ball of Fire
    // 8605 = Great Ball of Fire
    netRegex: {
      id: ['8505', '8506'],
      capture: false
    },
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      const mech = data.stackSpreadSecondMechanic;
      if (mech === undefined) return;
      delete data.stackSpreadFirstMechanic;
      delete data.stackSpreadSecondMechanic;
      return output[mech]();
    },
    outputStrings: another_mount_rokkon_basicStackSpreadOutputStrings
  }, {
    id: 'AMR Gorai Torching Torment',
    type: 'StartsUsing',
    netRegex: {
      id: '8532',
      source: 'Gorai the Uncaged'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AMR Gorai Impure Purgation First Hit',
    type: 'StartsUsing',
    netRegex: {
      id: '852F',
      source: 'Gorai the Uncaged',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Protean',
        de: 'Um den Boss verteilen',
        fr: 'Position autour du boss',
        ja: 'ボス基準て散開',
        cn: '四方分散',
        ko: '산개'
      }
    }
  }, {
    id: 'AMR Gorai Impure Purgation Second Hit',
    type: 'StartsUsing',
    netRegex: {
      id: '8531',
      source: 'Gorai the Uncaged',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'AMR Gorai Humble Hammer',
    type: 'StartsUsing',
    netRegex: {
      id: '8525',
      source: 'Gorai the Uncaged'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Shrink Lone Orb',
        de: 'Einzel-Orb verkleinern',
        fr: 'Réduire l\'orbe isolé',
        ja: '玉の処理',
        cn: '缩小单独的球',
        ko: '혼자 있는 구슬 작아지게 만들기'
      }
    }
  }, {
    id: 'AMR Gorai Flintlock',
    type: 'StartsUsing',
    // Trigger this on the Humble Hammer damage; however this should hit
    // both one player (although possibly more) and one Ball of Levin (although possibly none)
    // so use `StartsUsing` with a delay to get the proper cast target here.
    netRegex: {
      id: '8525',
      source: 'Gorai the Uncaged'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime),
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.beBehindTank();
      if (data.role === 'tank') return output.blockLaser({
        player: data.party.member(matches.target)
      });
      return output.avoidLaser();
    },
    outputStrings: {
      beBehindTank: {
        en: 'Stay Behind Tank',
        de: 'Hinter dem Tank stehen',
        fr: 'Restez derrière le tank',
        ja: 'タンクの後ろ',
        cn: '站坦克后面',
        ko: '탱커 뒤에 서기'
      },
      blockLaser: {
        en: 'Block Laser on ${player}',
        de: 'Blockiere Laser auf ${player}',
        fr: 'Bloquer le laser sur ${player}',
        ja: '${player}の前でカバー',
        cn: '挡枪 ${player}',
        ko: '${player} 대상 레이저 앞에서 맞기'
      },
      avoidLaser: {
        en: 'Avoid Laser',
        de: 'Laser vermeiden',
        fr: 'Évitez le laser',
        ja: 'レイザー回避',
        cn: '躲避激光',
        ko: '레이저 피하기'
      }
    }
  }, {
    id: 'AMR Gorai Rousing Reincarnation Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E0D', 'E0E', 'E0F', 'E10', 'E11', 'E12', 'E13', 'E14']
    },
    condition: data => data.rousingTowerCount === 0,
    run: (data, matches) => {
      // Odder Incarnation = blue towers
      // Rodential Rebirth = orange towers
      // durations: I = 20s, II = 26s, III = 32s, IV = 38s
      const id = matches.effectId;
      if (id === 'E11') data.rousingCollect[0].blue = matches.target;else if (id === 'E0D') data.rousingCollect[0].orange = matches.target;else if (id === 'E12') data.rousingCollect[1].blue = matches.target;else if (id === 'E0E') data.rousingCollect[1].orange = matches.target;else if (id === 'E13') data.rousingCollect[2].blue = matches.target;else if (id === 'E0F') data.rousingCollect[2].orange = matches.target;else if (id === 'E14') data.rousingCollect[3].blue = matches.target;else if (id === 'E10') data.rousingCollect[3].orange = matches.target;
    }
  }, {
    id: 'AMR Gorai Rousing Reincarnation First Tower',
    type: 'StartsUsing',
    // Malformed Prayer cast
    netRegex: {
      id: '8518',
      source: 'Gorai the Uncaged',
      capture: false
    },
    durationSeconds: 15,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      return another_mount_rokkon_towerResponse(data, output);
    }
  }, {
    id: 'AMR Gorai Rousing Reincarnation Other Towers',
    type: 'Ability',
    // Technically 851F Pointed Purgation protean happens ~0.2s beforehand,
    // but wait on the tower burst to call things out.
    // 851B = Burst (blue tower)
    // 8519 = Burst (orange tower)
    // 851C = Dramatic Burst (missed tower)
    netRegex: {
      id: '851B',
      source: 'Gorai the Uncaged',
      capture: false
    },
    durationSeconds: 4,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      return another_mount_rokkon_towerResponse(data, output);
    }
  }, {
    id: 'AMR Gorai Fighting Spirits',
    type: 'StartsUsing',
    netRegex: {
      id: '852B',
      source: 'Gorai the Uncaged',
      capture: false
    },
    // this is also a light aoe but knockback is more important
    response: responses/* Responses.knockback */.n3.knockback('info')
  }, {
    id: 'AMR Gorai Fighting Spirits Limit Cut',
    type: 'HeadMarker',
    netRegex: {
      id: another_mount_rokkon_limitCutIds
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 6,
    alertText: (_data, matches, output) => {
      if (matches.id === another_mount_rokkon_headmarkers.limitCut1) return output.num1();
      if (matches.id === another_mount_rokkon_headmarkers.limitCut2) return output.num2();
      if (matches.id === another_mount_rokkon_headmarkers.limitCut3) return output.num3();
      if (matches.id === another_mount_rokkon_headmarkers.limitCut4) return output.num4();
    },
    outputStrings: {
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4
    }
  }, {
    id: 'AMR Gorai Malformed Reincarnation Collect',
    type: 'GainsEffect',
    // E0D = Rodential Rebirth 1 (first orange tower)
    // E0E = Rodential Rebirth 2 (second orange tower)
    // E0F = Rodential Rebirth 3 (third orange tower)
    // E10 = Rodential Rebirth 4 (fourth orange tower)
    // E11 = Odder Incarnation 1 (first blue tower)
    // E12 = Odder Incarnation 2 (second blue tower)
    // E13 = Odder Incarnation 3 (third blue tower)
    // E14 = Odder Incarnation 4 (fourth blue tower)
    // E15 = Squirrelly Prayer (place orange tower)
    // E16 = Odder Prayer (place blue tower)
    netRegex: {
      effectId: ['E0D', 'E0E', 'E0F', 'E11', 'E12', 'E13']
    },
    condition: data => data.rousingTowerCount !== 0,
    run: (data, matches) => {
      data.malformedCollect.push(matches);
      if (matches.target === data.me) data.myMalformedEffects.push(matches.effectId);
    }
  }, {
    id: 'AMR Gorai Malformed Reincarnation',
    // TODO: we could add more config options for this if needed, as there are many strats.
    // However, this given trigger should give enough info for most strats.
    // (1) player flex, always go mixed sides, people with all one color go to specific spots.
    //     See: https://www.youtube.com/watch?v=TzoNEWbMpQ0#t=7m53s
    // (2) no player flexing, go to opposite side, run THROUGH, possible swap sides for tower
    //     See: https://ff14.toolboxgaming.space/?id=938195953989861&preview=1
    // (3) different strats for half mixed / full mixed, flex only on full mixed
    //     See: https://raidplan.io/plan/9tVR4vj9kPjgF3PM
    comment: {
      en: `Full mixed means everybody has both colors (two of one, one of the other).
             Half mixed means two people have both colors and two people have all the same color.`,
      de: `Voll gemischt bedeutet, dass jeder beide Farben hat (zwei von der einen, eine von der anderen).
             Halb gemischt bedeutet, dass zwei Personen beide Farben haben und zwei Personen nur eine Farbe haben`,
      fr: `Complètement mixé signifie que tout le monde à les deux couleurs (deux de l'une et un de l'autre).
           Mixé à moitié signifie que deux personnes ont les deux couleurs et deux ont la même couleur.`,
      cn: `全异色 指的是所有人的 3 个 buff 中有 2 个同色 buff (2 个是一种颜色, 剩下 1 个是另一种)。
             半异色 指的是 2 个人有 2 个同色buff, 其余 2 人拥有 3 个同色buff。`,
      ko: `완전 혼합은 모든 사람이 두 가지 색을 가지고 있음을 의미합니다 (한 가지 색 두 개, 다른 색 하나).
             반혼합은 두 사람이 두 가지 종류를 가지고 있고, 다른 두 사람은 모두 같은 색을 가지고 있음을 의미합니다.`
    },
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E0D', 'E0E', 'E0F', 'E11', 'E12', 'E13'],
      capture: false
    },
    condition: data => data.rousingTowerCount !== 0,
    delaySeconds: 0.5,
    durationSeconds: 10,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        alertText: {
          en: '${color1} -> ${color2} -> ${color3} (${mixedType})',
          de: '${color1} -> ${color2} -> ${color3} (${mixedType})',
          fr: '${color1} -> ${color2} -> ${color3} (${mixedType})',
          ja: '${color1} -> ${color2} -> ${color3} (${mixedType})',
          cn: '${color1} -> ${color2} -> ${color3} (${mixedType})',
          ko: '${color1} -> ${color2} -> ${color3} (${mixedType})'
        },
        infoText: {
          en: '(first ${color} w/${player})',
          de: '(zuerst ${color} mit ${player})',
          fr: '(premier ${color} avec ${player})',
          ja: '1番 ${color} +${player}',
          cn: '(第一个 ${color} 和 ${player})',
          ko: '1번 ${color} +${player}'
        },
        orange: {
          en: 'Orange',
          de: 'Orange',
          fr: 'Orange',
          ja: '赤',
          cn: '橙色',
          ko: '주황'
        },
        blue: {
          en: 'Blue',
          de: 'Blau',
          fr: 'Bleu',
          ja: '青',
          cn: '蓝色',
          ko: '파랑'
        },
        mixedTypeFull: {
          en: 'full mixed',
          de: 'Voll gemischt',
          fr: 'Complètement mixé',
          ja: '全混合',
          cn: '全异色',
          ko: '완전 혼합'
        },
        mixedTypeHalf: {
          en: 'half mixed',
          de: 'Halb gemischt',
          fr: 'Mixé à moitié',
          ja: '半分混合',
          cn: '半异色',
          ko: '반혼합'
        },
        unknown: outputs/* default.unknown */.Z.unknown
      };
      let playerCount = 0;
      let mixedCount = 0;
      const firstColor = {};
      const myColors = [];
      for (const line of data.malformedCollect) {
        const isOrange = line.effectId === 'E0D' || line.effectId === 'E0E' || line.effectId === 'E0F';
        const color = isOrange ? 'orange' : 'blue';
        if (line.target === data.me) myColors.push(color);
        const lastColor = firstColor[line.target];
        if (lastColor === undefined) {
          playerCount++;
          firstColor[line.target] = color;
          continue;
        }
        if (lastColor === color) continue;
        mixedCount++;
      }
      const [color1, color2, color3] = myColors;
      if (color1 === undefined || color2 === undefined || color3 === undefined) return;

      // Try to handle dead players who don't have debuffs here.
      const isAllMixed = playerCount === mixedCount;
      const mixedType = isAllMixed ? output.mixedTypeFull() : output.mixedTypeHalf();
      let partner = output.unknown();
      for (const [name, color] of Object.entries(firstColor)) {
        if (name !== data.me && color === color1) {
          partner = data.party.member(name);
          break;
        }
      }
      const alertText = output.alertText({
        color1: output[color1](),
        color2: output[color2](),
        color3: output[color3](),
        mixedType: mixedType
      });
      const infoText = output.infoText({
        color: output[color1](),
        player: partner
      });
      return {
        alertText,
        infoText
      };
    }
  }, {
    id: 'AMR Gorai Malformed First Tower',
    type: 'LosesEffect',
    // E15 = Squirrelly Prayer (place orange tower)
    // E16 = Odder Prayer (place blue tower)
    netRegex: {
      effectId: ['E15', 'E16']
    },
    condition: (data, matches) => data.me === matches.target,
    durationSeconds: 4,
    alertText: (data, _matches, output) => {
      const effectId = data.myMalformedEffects.shift();
      if (effectId === 'E0D') return output.orangeTower1();
      if (effectId === 'E11') return output.blueTower1();
    },
    outputStrings: {
      blueTower1: {
        en: 'Inside Blue Tower 1',
        de: 'Innerhalb blauer Turm 1',
        fr: 'À l\'intérieur de la tour bleue 1',
        ja: '内側の青塔1',
        cn: '内侧 蓝塔 1',
        ko: '안쪽 파랑 기둥1'
      },
      orangeTower1: {
        en: 'Inside Orange Tower 1',
        de: 'Innerhalb orangener Turm 1',
        fr: 'À l\'intérieur de la tour orange 1',
        ja: '内側の赤塔1',
        cn: '内侧 橙塔 1',
        ko: '안쪽 주황 기둥1'
      }
    }
  }, {
    id: 'AMR Gorai Malformed Other Towers',
    type: 'Ability',
    netRegex: {
      id: '851B',
      source: 'Gorai the Uncaged',
      capture: false
    },
    condition: data => data.myMalformedEffects.length > 0,
    durationSeconds: 2,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      const effectId = data.myMalformedEffects.shift();
      if (effectId === 'E0E') return output.orangeTower2();
      if (effectId === 'E0F') return output.orangeTower3();
      if (effectId === 'E12') return output.blueTower2();
      if (effectId === 'E13') return output.blueTower3();
    },
    outputStrings: {
      blueTower1: {
        en: 'Inside Blue Tower 1',
        de: 'Mittig blauer Turm 1',
        fr: 'À l\'intérieur de la tour bleue 1',
        ja: '内側の青塔1',
        cn: '内侧 蓝塔 1',
        ko: '안쪽 파랑 기둥 1'
      },
      orangeTower1: {
        en: 'Inside Orange Tower 1',
        de: 'Mittig orangener Turm 1',
        fr: 'À l\'intérieur de la tour orange 1',
        ja: '内側の赤塔1',
        cn: '内侧 橙塔 1',
        ko: '안쪽 주황 기둥 1'
      },
      blueTower2: {
        en: 'Corner Blue Tower 2',
        de: 'Ecke blauer Turm 2',
        fr: 'Tour bleu 2 dans le coin',
        ja: '隅の青塔2',
        cn: '角落 蓝塔 2',
        ko: '구석 파랑 기둥 2'
      },
      orangeTower2: {
        en: 'Corner Orange Tower 2',
        de: 'Ecke orangener Turm 2',
        fr: 'Tour orange 2 dans le coin',
        ja: '隅の赤塔2',
        cn: '角落 橙塔 2',
        ko: '구석 주황 기둥 2'
      },
      blueTower3: {
        en: 'Placed Blue Tower 3',
        de: 'Platzierter blauer Turm 3',
        fr: 'Tour bleue placée 3',
        ja: '設置した青塔3',
        cn: '放置 蓝塔 3',
        ko: '설치한 파랑 기둥 3'
      },
      orangeTower3: {
        en: 'Placed Orange Tower 3',
        de: 'Platzierter orangener Turm 3',
        fr: 'Tour orange placée 3',
        ja: '設置した赤塔3',
        cn: '放置 橙塔 3',
        ko: '설치한 주황 기둥 3'
      }
    }
  }, {
    id: 'AMR Gorai Fire Spread',
    type: 'Ability',
    netRegex: {
      id: '8511',
      source: 'Gorai the Uncaged',
      capture: false
    },
    suppressSeconds: 30,
    response: responses/* Responses.moveAway */.n3.moveAway()
  },
  // ---------------- Moko the Restless ----------------
  {
    id: 'AMR Moko Kenki Release',
    type: 'StartsUsing',
    netRegex: {
      id: '85E0',
      source: 'Moko the Restless',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'AMR Moko Triple Kasumi-giri Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(another_mount_rokkon_mokoVfxMap)
    },
    run: (data, matches) => {
      const thisAbility = another_mount_rokkon_looseMokoVfxMap[matches.count];
      if (thisAbility === undefined) return;
      data.tripleKasumiCollect.push(thisAbility);
    }
  }, {
    id: 'AMR Moko Triple Kasumi-giri 1',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(another_mount_rokkon_mokoVfxMap),
      capture: false
    },
    condition: data => data.tripleKasumiCollect.length === 1,
    durationSeconds: 10,
    alertText: (data, _matches, output) => {
      const [ability] = data.tripleKasumiCollect;
      if (ability === undefined) return;
      return output[`${ability}First`]();
    },
    outputStrings: another_mount_rokkon_tripleKasumiFirstOutputStrings
  }, {
    id: 'AMR Moko Triple Kasumi-giri 2',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(another_mount_rokkon_mokoVfxMap),
      capture: false
    },
    condition: data => data.tripleKasumiCollect.length === 2,
    infoText: (data, _matches, output) => {
      const ability = data.tripleKasumiCollect[1];
      if (ability === undefined) return;
      const text = output[ability]();
      return output.text({
        text: text
      });
    },
    outputStrings: {
      text: {
        en: '(${text})',
        de: '(${text})',
        fr: '(${text})',
        ja: '(${text})',
        cn: '(${text})',
        ko: '(${text})'
      },
      ...another_mount_rokkon_tripleKasumiFollowupOutputStrings
    }
  }, {
    id: 'AMR Moko Triple Kasumi-giri 3',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(another_mount_rokkon_mokoVfxMap),
      capture: false
    },
    condition: data => data.tripleKasumiCollect.length === 3,
    durationSeconds: 10,
    infoText: (data, _matches, output) => {
      const [ability1, ability2, ability3] = data.tripleKasumiCollect;
      if (ability1 === undefined || ability2 === undefined || ability3 === undefined) return;
      const text1 = output[`${ability1}First`]();
      const text2 = output[ability2]();
      const text3 = output[ability3]();
      return output.text({
        text1: text1,
        text2: text2,
        text3: text3
      });
    },
    outputStrings: {
      text: {
        en: '${text1} => ${text2} => ${text3}',
        de: '${text1} => ${text2} => ${text3}',
        fr: '${text1} => ${text2} => ${text3}',
        ja: '${text1} => ${text2} => ${text3}',
        cn: '${text1} => ${text2} => ${text3}',
        ko: '${text1} => ${text2} => ${text3}'
      },
      ...another_mount_rokkon_tripleKasumiFirstOutputStrings,
      ...another_mount_rokkon_tripleKasumiFollowupOutputStrings
    }
  }, {
    id: 'AMR Moko Triple Kasumi-giri Followup',
    type: 'Ability',
    netRegex: {
      id: another_mount_rokkon_tripleKasumiAbilityIds,
      source: 'Moko the Restless',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      // First one has already been called, so ignore it.
      if (data.tripleKasumiCollect.length === 3) data.tripleKasumiCollect.shift();
      const ability = data.tripleKasumiCollect.shift();
      if (ability === undefined) return;
      return output[ability]();
    },
    outputStrings: another_mount_rokkon_tripleKasumiFollowupOutputStrings
  }, {
    id: 'AMR Moko Lateral Slice',
    type: 'StartsUsing',
    netRegex: {
      id: '85E3',
      source: 'Moko the Restless'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'AMR Moko Scarlet Auspice',
    type: 'StartsUsing',
    netRegex: {
      id: '85D1',
      source: 'Moko the Restless',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sides + Out => Stay Out',
        de: 'Seiten + Raus => Bleib drausen',
        fr: 'Côtés + Extérieur => Restez à l\'extérieur',
        ja: '横へ + 外 => そのまま外',
        cn: '两侧 + 远离 => 待在外面',
        ko: '양 옆 + 밖 => 밖에 있기'
      }
    }
  }, {
    id: 'AMR Moko Azure Auspice',
    type: 'StartsUsing',
    netRegex: {
      id: '85D4',
      source: 'Moko the Restless',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Under => Sides + Out',
        de: 'Unter ihn => Seiten + Geh Raus',
        fr: 'Dessous => Côtés + Extérieur',
        ja: 'ボスの下へ => 横へ + 外',
        cn: '去脚下 => 两侧 + 出去',
        ko: '안 => 양 옆 + 밖'
      }
    }
  }, {
    id: 'AMR Moko Azure Auspice Followup',
    type: 'Ability',
    netRegex: {
      id: '85D4',
      source: 'Moko the Restless',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sides + Out',
        de: 'Seiten + Raus',
        fr: 'Côtés + Extérieur',
        ja: '横へ + 外',
        cn: '两侧 + 出去',
        ko: '양 옆 + 밖'
      }
    }
  }, {
    id: 'AMR Moko Fire Line Collect',
    type: 'MapEffect',
    // flags:
    //   00010001 = make lines appear (both blue and red)
    //   00100020 = make lines glow (both blue and red)
    // locations:
    //   2C = N (fire)
    //   2D = NW<->SE (fire)
    //   2E = NE<->SW (fire)
    //   2F = S (fire)
    //   30-33 = blue lines, some order
    netRegex: {
      flags: '00100020',
      location: '2[CDEF]'
    },
    condition: (data, matches) => {
      data.explosionLineCollect.push(matches);
      return data.explosionLineCollect.length === 2;
    },
    durationSeconds: 5,
    alertText: (data, _matches, output) => {
      const isNorth = data.explosionLineCollect.find(x => x.location === '2F') !== undefined;
      const isSWOrNE = data.explosionLineCollect.find(x => x.location === '2D') !== undefined;
      if (isNorth) return isSWOrNE ? output.dirNE() : output.dirNW();
      return isSWOrNE ? output.dirSW() : output.dirSE();
    },
    outputStrings: {
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirSW: outputs/* default.dirSW */.Z.dirSW,
      dirNW: outputs/* default.dirNW */.Z.dirNW,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'AMR Moko Invocation Collect',
    type: 'GainsEffect',
    // E1A = Vengeful Flame (spread)
    // E1B = Vengeful Pyre (stack)
    netRegex: {
      effectId: ['E1A', 'E1B']
    },
    run: (data, matches) => data.invocationCollect.push(matches)
  }, {
    id: 'AMR Moko Invocation of Vengeance',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E1A', 'E1B'],
      capture: false
    },
    delaySeconds: 0.5,
    durationSeconds: 5,
    suppressSeconds: 999999,
    response: (data, _matches, output) => {
      // cactbot-builtin-response

      // TODO: the timing of this is a little bit tough to condense:
      //   t=0.0 these effects
      //   t=2.3 tether appears
      //   t=2.7 explosion lines start glowing
      // Right now we just call everything separately to call it as soon as possible.
      // A more complicated alternative to be to call this here, and then slightly later
      // figure out who should stack with the tether where, since you know if it's a melee stack
      // and the melee has a tether you could tell people "Stack with Tether SE" kind of thing.
      //
      // However, because there's so many calls, we'll drop the "stacks on" part of this.
      return another_mount_rokkon_stackSpreadResponse(data, output, data.invocationCollect, 'E1B', 'E1A', true);
    }
  }, {
    id: 'AMR Moko Invocation of Vengeance Followup',
    type: 'Ability',
    // 85DC = Vengeful Flame
    // 85DD = Vengeful Pyre
    netRegex: {
      id: ['85DC', '85DD'],
      capture: false
    },
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      const mech = data.stackSpreadSecondMechanic;
      if (mech === undefined) return;
      delete data.stackSpreadFirstMechanic;
      delete data.stackSpreadSecondMechanic;
      return output[mech]();
    },
    outputStrings: another_mount_rokkon_basicStackSpreadOutputStrings
  }, {
    id: 'AMR Moko Iai-giri Cleanup',
    type: 'StartsUsing',
    // 85C2 = Fleeting Iai-giri (from Moko the Restless)
    // 85C8 = Double Iai-giri (from Moko's Shadow)
    netRegex: {
      id: ['85C2', '85C8'],
      capture: false
    },
    // Clean up once so we can collect casts.
    suppressSeconds: 5,
    run: data => {
      data.iaigiriTether = [];
      data.iaigiriPurple = [];
      data.iaigiriCasts = [];
      delete data.myAccursedEdge;
      delete data.myIaigiriTether;
      delete data.oniClaw;
    }
  }, {
    id: 'AMR Moko Iai-giri Tether Collect',
    type: 'Tether',
    netRegex: {
      id: '0011'
    },
    run: (data, matches) => {
      data.iaigiriTether.push(matches);
      if (matches.target === data.me) data.myIaigiriTether = matches;
    }
  }, {
    id: 'AMR Moko Iai-giri Purple Marker Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(another_mount_rokkon_shadowVfxMap)
    },
    run: (data, matches) => data.iaigiriPurple.push(matches)
  }, {
    id: 'AMR Moko Iai-giri Double Iai-giri Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '85C8',
      source: 'Moko\'s Shadow'
    },
    run: (data, matches) => data.iaigiriCasts.push(matches)
  }, {
    id: 'AMR Moko Iai-giri Accursed Edge Collect',
    type: 'Ability',
    netRegex: {
      id: '85DA'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // You could (but shouldn't) be hit by multiple of these, so just take the last.
    run: (data, matches) => data.myAccursedEdge = matches
  }, {
    id: 'AMR Moko Fleeting Iai-giri',
    type: 'Tether',
    netRegex: {
      id: '0011',
      capture: false
    },
    delaySeconds: 0.5,
    durationSeconds: 7,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        backOnYou: {
          en: 'Back Tether on YOU',
          de: 'Zurück-Verbindung auf DIR',
          fr: 'Lien arrière sur VOUS',
          ja: '自分の後ろに線',
          cn: '后方连线点名!',
          ko: '선-뒤쪽 대상자'
        },
        leftOnYou: {
          en: 'Left Tether on YOU',
          de: 'Links-Verbindung auf DIR',
          fr: 'Lien à gauche sur VOUS',
          ja: '自分の左に線',
          cn: '左侧连线点名!',
          ko: '선-왼쪽 대상자'
        },
        frontOnYou: {
          en: 'Front Tether on YOU',
          de: 'Vorne-Verbindung auf DIR',
          fr: 'Lien avant sur VOUS',
          ja: '自分の前に線',
          cn: '前方连线点名!',
          ko: '선-앞쪽 대상자'
        },
        rightOnYou: {
          en: 'Right Tether on YOU',
          de: 'Rechts-Verbindung auf DIR',
          fr: 'Lien à droite sur VOUS',
          ja: '自分の右に線',
          cn: '右侧连线点名!',
          ko: '선-오른쪽 대상자'
        },
        backOnPlayer: {
          en: 'Back Tether on ${player}',
          de: 'Zurück-Verbindung auf ${player}',
          fr: 'Lien arrière sur ${player}',
          ja: '後ろの線: ${player}',
          cn: '后方连线点 ${player}',
          ko: '선-뒤쪽 ${player}'
        },
        leftOnPlayer: {
          en: 'Left Tether on ${player}',
          de: 'Links-Verbindung auf ${player}',
          fr: 'Lien à gauche sur ${player}',
          ja: '左の線: ${player}',
          cn: '左侧连线点 ${player}',
          ko: '선-왼쪽 ${player}'
        },
        frontOnPlayer: {
          en: 'Front Tether on ${player}',
          de: 'Vorne-Verbindung auf ${player}',
          fr: 'Lien avant sur ${player}',
          ja: '前の線: ${player}',
          cn: '前方连线点 ${player}',
          ko: '선-앞쪽 ${player}'
        },
        rightOnPlayer: {
          en: 'Right Tether on ${player}',
          de: 'Rechts-Verbindung auf ${player}',
          fr: 'Lien à droite sur ${player}',
          ja: '右の線: ${player}',
          cn: '右侧连线点 ${player}',
          ko: '선-오른쪽 ${player}'
        }
      };
      if (data.iaigiriTether.length !== 1 || data.iaigiriPurple.length !== 1) return;
      const [tether] = data.iaigiriTether;
      const [marker] = data.iaigiriPurple;
      if (tether === undefined || marker === undefined) return;
      const thisAbility = another_mount_rokkon_looseShadowVfxMap[marker.count];
      if (thisAbility === undefined) return;
      const player = tether.target;
      if (player === data.me) {
        const outputKey = `${thisAbility}OnYou`;
        return {
          alarmText: output[outputKey]()
        };
      }
      const outputKey = `${thisAbility}OnPlayer`;
      return {
        infoText: output[outputKey]({
          player: data.party.member(player)
        })
      };
    }
  }, {
    id: 'AMR Moko Double Shadow Kasumi-giri Initial',
    type: 'Tether',
    netRegex: {
      id: '0011',
      capture: false
    },
    condition: data => !data.seenSoldiersOfDeath,
    delaySeconds: 0.5,
    durationSeconds: 4,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        backOnYou: {
          en: 'Back Tether (${partners})',
          de: 'Zurück-Verbindung (${partners}))',
          fr: 'Lien arrière (${partners})',
          ja: '後ろの線 (${partners})',
          cn: '后方连线 (和 ${partners})',
          ko: '선-뒤쪽 (${partners})'
        },
        // These are probably impossible.
        leftOnYou: {
          en: 'Left Tether (${partners})',
          de: 'Links-Verbindung (${partners})',
          fr: 'Lien à gauche (${partners})',
          ja: '左の線 (${partners})',
          cn: '左侧连线 (和 ${partners})',
          ko: '선-왼쪽 (${partners})'
        },
        frontOnYou: {
          en: 'Front Tether (${partners})',
          de: 'Vorne-Verbindung (${partners})',
          fr: 'Lien avant (${partners})',
          ja: '前の線 (${partners})',
          cn: '前方连线 (和 ${partners})',
          ko: '선-앞쪽 (${partners})'
        },
        rightOnYou: {
          en: 'Right Tether (${partners})',
          de: 'Rechts-Verbindung (${partners})',
          fr: 'Lien à droite (${partners})',
          ja: '右の線 (${partners})',
          cn: '右侧连线 (和 ${partners})',
          ko: '선-오른쪽 (${partners})'
        },
        unmarked: {
          en: 'Unmarked (${partners})',
          de: 'Unmarkiert (${partners})',
          fr: 'Non-marqué (${partners})',
          ja: '線なし (${partners})',
          cn: '无点名 (和 ${partners})',
          ko: '무징 (${partners})'
        },
        melee: {
          en: 'melees together',
          de: 'Nahkämpfer zusammen',
          fr: 'Mêlées ensemble',
          ja: '近接ペア',
          cn: '近战同组',
          ko: '근딜끼리'
        },
        role: {
          en: 'roles together',
          de: 'Rollen zusammen',
          fr: 'Rôles ensemble',
          ja: 'ロールペア',
          cn: '职能分组',
          ko: '역할군끼리'
        },
        partner: {
          en: 'partners together',
          de: 'Partner zusammen',
          fr: 'Partenaires ensemble',
          ja: 'ペア',
          cn: '搭档分组',
          ko: '파트너끼리'
        },
        unknown: outputs/* default.unknown */.Z.unknown
      };
      if (data.iaigiriTether.length !== 2 || data.iaigiriPurple.length !== 2) return;
      const [tether1, tether2] = data.iaigiriTether;
      const [marker1, marker2] = data.iaigiriPurple;
      if (tether1 === undefined || tether2 === undefined || marker1 === undefined || marker2 === undefined) return;
      const player1 = tether1.target;
      const player2 = tether2.target;
      const stackType = another_mount_rokkon_findStackPartners(data, player1, player2);
      const stackStr = output[stackType]();
      if (data.myIaigiriTether === undefined) return {
        alertText: output.unmarked({
          partners: stackStr
        })
      };
      const myMarker = marker1.sourceId === data.myIaigiriTether.sourceId ? marker1 : marker2;
      const thisAbility = another_mount_rokkon_looseShadowVfxMap[myMarker.count];
      if (thisAbility === undefined) return;
      const outputKey = `${thisAbility}OnYou`;
      return {
        alarmText: output[outputKey]({
          partners: stackStr
        })
      };
    }
  }, {
    id: 'AMR Moko Oni Claw',
    type: 'GainsEffect',
    // This happens ~2.3 seconds prior to the Clearout/Far Edge/Near Edge cast starting,
    // and is the first time these adds appear in the log other than 261 change lines
    // which reposition these adds immediately prior to them gaining this effect.
    netRegex: {
      effectId: '808',
      count: '257'
    },
    suppressSeconds: 1,
    promise: async (data, matches) => {
      data.combatantData = [];
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.targetId, 16)]
      })).combatants;
    },
    // This is infoText to not conflict with the Unmarked/Tether calls.
    // We could combine this with the Near Far Edge call, but it seemed better to say it sooner.
    infoText: (data, _matches, output) => {
      const [combatant] = data.combatantData;
      if (combatant === undefined || data.combatantData.length !== 1) return;
      const dir = util/* Directions.xyTo4DirNum */.N.xyTo4DirNum(combatant.PosX, combatant.PosY, another_mount_rokkon_mokoCenterX, another_mount_rokkon_mokoCenterY);
      data.oniClaw = dir === 1 || dir === 3 ? 'northSouth' : 'eastWest';
      if (data.oniClaw === 'northSouth') return output.northSouth();
      return output.eastWest();
    },
    outputStrings: {
      northSouth: {
        en: 'North/South',
        de: 'Norden/Süden',
        fr: 'Nord/Sud',
        ja: '北・南',
        cn: '上 (北)/下 (南)',
        ko: '북쪽/남쪽'
      },
      eastWest: {
        en: 'East/West',
        de: 'Osten/Westen',
        fr: 'Est/Ouest',
        ja: '東・西',
        cn: '左 (西)/右 (东)',
        ko: '동쪽/서쪽'
      }
    }
  }, {
    id: 'AMR Moko Near Far Edge',
    type: 'StartsUsing',
    // 85D8 = Far Edge
    // 85D9 = Near Edge
    netRegex: {
      id: ['85D8', '85D9'],
      source: 'Moko the Restless'
    },
    alertText: (data, matches, output) => {
      const isFarEdge = matches.id === '85D8';
      if (data.myIaigiriTether === undefined) return isFarEdge ? output.baitFar() : output.baitNear();
      return isFarEdge ? output.tetherNear() : output.tetherFar();
    },
    outputStrings: {
      baitNear: {
        en: 'Bait Near (Tether Far)',
        de: 'Nah ködern (Verbindung Fern)',
        fr: 'Attirez proche (Lien éloigné)',
        ja: 'ニア (線ファー)',
        cn: '靠近引导 (连线远离)',
        ko: '유도 가까이 (선 멀리)'
      },
      baitFar: {
        en: 'Bait Far (Tether Near)',
        de: 'Fern ködern (Verbindung Nah)',
        fr: 'Attirez loin (Lien proche)',
        ja: 'ファー (線ニア)',
        cn: '远离引导 (连线靠近)',
        ko: '멀리 유도 (선 가까이)'
      },
      tetherNear: {
        en: 'Tether Near (Bait Far)',
        de: 'Verbindung Nahe (Fern ködern)',
        fr: 'Lien proche (Attirez loin)',
        ja: '線ニア (誘導ファー)',
        cn: '靠近拉线 (引导远离)',
        ko: '선 가까이 (유도 가까이)'
      },
      tetherFar: {
        en: 'Tether Far (Bait Near)',
        de: 'Verbindung Fern (Nahe ködern)',
        fr: 'Lien éloigné (Attirez proche)',
        ja: '線ファー (誘導ニア)',
        cn: '远离拉线 (引导靠近)',
        ko: '선 멀리 (유도 멀리)'
      }
    }
  }, {
    id: 'AMR Moko Double Shadow Kasumi-giri Second Mark',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(another_mount_rokkon_shadowVfxMap)
    },
    condition: (data, matches) => {
      if (data.seenSoldiersOfDeath) return false;

      // Ignore the first set of marks, which get called with the tether.
      if (data.iaigiriPurple.length <= 2) return false;

      // For the first two Double-Iaigiris before Soldiers of Death,
      // if this is the 4th mark (i.e. the 2nd in the 2nd set) and they are both the same,
      // then we can call that mark for everyone because it doesn't matter where they are.
      const third = data.iaigiriPurple[2]?.count;
      const fourth = data.iaigiriPurple[3]?.count;
      if (third === fourth && third !== undefined && !data.seenSoldiersOfDeath) return true;

      // See if the current player is attached to a tether that
      // is attached to the mob gaining this effect.
      // Since we aren't sure where the baiters are we can't really tell them anything.
      return data.myIaigiriTether?.sourceId === matches.targetId;
    },
    // Don't collide with Near Far Edge, which is more important.
    delaySeconds: 3,
    durationSeconds: 5.5,
    suppressSeconds: 5,
    infoText: (data, matches, output) => {
      const third = data.iaigiriPurple[2]?.count;
      const fourth = data.iaigiriPurple[3]?.count;
      if (third === fourth && third !== undefined && !data.seenSoldiersOfDeath) {
        const thisAbility = another_mount_rokkon_looseShadowVfxMap[third];
        if (thisAbility === undefined) return;
        return output[thisAbility]();
      }
      const thisAbility = another_mount_rokkon_looseShadowVfxMap[matches.count];
      if (thisAbility === undefined) return;
      return output[thisAbility]();
    },
    outputStrings: {
      // This is probably not possible.
      back: {
        en: '(then stay)',
        de: '(bleib stehen)',
        fr: '(puis restez)',
        ja: '(後はそのまま)',
        cn: '(稍后 停)',
        ko: '(이후 그대로)'
      },
      left: {
        en: '(then left)',
        de: '(dann links)',
        fr: '(puis à gauche)',
        ja: '(後は左)',
        cn: '(稍后 去左侧)',
        ko: '(이후 왼쪽)'
      },
      front: {
        en: '(then through)',
        de: '(dann durchgehen)',
        fr: '(puis devant)',
        ja: '(後はまたいで移動)',
        cn: '(稍后 穿)',
        ko: '(이후 가로지르기)'
      },
      right: {
        en: '(then right)',
        de: '(dann rechts)',
        fr: '(puis à droite)',
        ja: '(後は右)',
        cn: '(稍后 去右侧)',
        ko: '(이후 오른쪽)'
      }
    }
  }, {
    id: 'AMR Moko Shadow Kasumi-giri Back Tether',
    type: 'Ability',
    netRegex: {
      id: '85C9',
      source: 'Moko\'s Shadow'
    },
    condition: (data, matches) => data.myIaigiriTether?.sourceId === matches.sourceId,
    durationSeconds: 2,
    // Maybe you have two tethers, although it probably won't go well.
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.back(),
    outputStrings: {
      // This is a reminder to make sure to move after the clone jumps to you.
      // TODO: should see this say Back => Right or something?
      back: outputs/* default.back */.Z.back
    }
  }, {
    id: 'AMR Moko Shadow Kasumi-giri Followup',
    type: 'Ability',
    netRegex: {
      id: '85CA',
      source: 'Moko\'s Shadow'
    },
    condition: (data, matches) => {
      // Reject anybody not tethered by this add or not on the same side.
      if (data.myIaigiriTether === undefined) {
        if (data.oniClaw === 'northSouth') {
          const myYStr = data.myAccursedEdge?.targetY;
          if (myYStr === undefined) return false;
          const thisY = parseFloat(matches.y);
          const myY = parseFloat(myYStr);
          if (myY < another_mount_rokkon_mokoCenterY && thisY > another_mount_rokkon_mokoCenterY || myY > another_mount_rokkon_mokoCenterY && thisY < another_mount_rokkon_mokoCenterY) return false;
        } else if (data.oniClaw === 'eastWest') {
          const myXStr = data.myAccursedEdge?.targetX;
          if (myXStr === undefined) return false;
          const thisX = parseFloat(matches.x);
          const myX = parseFloat(myXStr);
          if (myX < another_mount_rokkon_mokoCenterX && thisX > another_mount_rokkon_mokoCenterX || myX > another_mount_rokkon_mokoCenterX && thisX < another_mount_rokkon_mokoCenterX) return false;
        } else if (data.oniClaw === undefined) {
          // missing data.oniClaw somehow??
          return false;
        }
      } else if (matches.sourceId !== data.myIaigiriTether.sourceId) {
        return false;
      }
      return true;
    },
    suppressSeconds: 1,
    alertText: (data, matches, output) => {
      // Find the second marker for this add.
      const marker = [...data.iaigiriPurple].reverse().find(x => {
        return x.targetId === matches.sourceId;
      });
      if (marker === undefined) return;
      const thisAbility = another_mount_rokkon_looseShadowVfxMap[marker.count];
      if (thisAbility === undefined) return;
      return output[thisAbility]();
    },
    outputStrings: {
      // This probably can't happen.
      back: {
        en: 'Stay',
        de: 'Bleib stehen',
        fr: 'Restez',
        ja: 'そのまま',
        cn: '停',
        ko: '그대로'
      },
      left: outputs/* default.left */.Z.left,
      front: {
        en: 'Through',
        de: 'Lauf durch',
        fr: 'À travers',
        ja: 'またいで',
        cn: '穿',
        ko: '가로지르기'
      },
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'AMR Moko Soldiers of Death',
    type: 'StartsUsing',
    netRegex: {
      id: '8593',
      source: 'Moko the Restless',
      capture: false
    },
    run: (data, _matches) => data.seenSoldiersOfDeath = true
  }, {
    id: 'AMR Moko Soldiers of Death Blue Add',
    type: 'GainsEffect',
    // The red soldiers get 1E8 effects, and the blue add gets 5E.
    netRegex: {
      effectId: '808',
      count: '5E'
    },
    promise: async (data, matches) => {
      data.combatantData = [];
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.targetId, 16)]
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      const [combatant] = data.combatantData;
      if (combatant === undefined || data.combatantData.length !== 1) return;
      const x = combatant.PosX - another_mount_rokkon_mokoCenterX;
      const y = combatant.PosY - another_mount_rokkon_mokoCenterY;

      // This add is off the edge (far) and then along that edge (less far).
      // We need to look at the "less far" direction and go opposite.
      // Additionally, if the add is north/south it will shoot "short"
      // and if it is east/west then it will shoot "long".
      const isShootingLongFromEastWest = Math.abs(x) > Math.abs(y);
      const isEast = x > 0;
      const isNorth = y < 0;
      if (isShootingLongFromEastWest) {
        if (isNorth) return isEast ? output.dirSE() : output.dirSW();
        return isEast ? output.dirNE() : output.dirNW();
      }
      if (isEast) return isNorth ? output.dirSW() : output.dirNW();
      return isNorth ? output.dirSE() : output.dirNE();
    },
    outputStrings: {
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirSW: outputs/* default.dirSW */.Z.dirSW,
      dirNW: outputs/* default.dirNW */.Z.dirNW
    }
  }, {
    id: 'AMR Moko Soldiers of Death Shadow Kasumi-giri Tether',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(another_mount_rokkon_shadowVfxMap),
      capture: false
    },
    // Ignore the first set of marks, which get called with the tether.
    condition: data => data.iaigiriPurple.length > 4,
    // Wait to collect or call immediately if we have everything.
    delaySeconds: data => data.iaigiriPurple.length === 8 ? 0 : 0.5,
    durationSeconds: 5,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      const myTether = data.myIaigiriTether;
      if (myTether === undefined) return;

      // Find the second marker for this add.
      const marker = [...data.iaigiriPurple].reverse().find(x => {
        return x.targetId === myTether.sourceId;
      });
      if (marker === undefined) return;
      const thisAbility = another_mount_rokkon_looseShadowVfxMap[marker.count];
      if (thisAbility !== 'left' && thisAbility !== 'right') return;

      // Find the matching marker for your marker.
      const matchingMarkers = data.iaigiriPurple.filter(x => {
        return x.count === marker.count && x.targetId !== marker.targetId;
      });
      // Make sure there's only one matching symbol, just in case.
      const [partnerMarker] = matchingMarkers;
      if (partnerMarker === undefined || matchingMarkers.length !== 1) return;

      // Find the matching tether for this matching marker.
      const partnerTether = data.iaigiriTether.find(x => {
        return x.sourceId === partnerMarker.targetId;
      });
      if (partnerTether === undefined) return;

      // It's better uptime for melee if the melee stick together if they can,
      // however it should always be safe to stick roles together here and so
      // for consistency, ignore the "melee first" option.
      const flexPartner = partnerTether.target;
      const stackType = another_mount_rokkon_findStackPartners(data, data.me, flexPartner, 'rolesPartners');
      const stackStr = output[stackType]();
      if (thisAbility === 'left') return output.left({
        partners: stackStr
      });
      return output.right({
        partners: stackStr
      });
    },
    outputStrings: {
      left: {
        en: 'Left Tether (${partners})',
        de: 'Linke Verbindung (${partners})',
        fr: 'Lien à gauche (${partners})',
        ja: '左線 (${partners})',
        cn: '左侧连线 (${partners})',
        ko: '왼쪽 선 (${partners})'
      },
      right: {
        en: 'Right Tether (${partners})',
        de: 'Rechte Verbindung (${partners})',
        fr: 'Lien à droite (${partners})',
        ja: '右線 (${partners})',
        cn: '右侧连线 (${partners})',
        ko: '오른쪽 선 (${partners})'
      },
      role: {
        en: 'roles together',
        de: 'Rollen zusammen',
        fr: 'Rôles ensemble',
        ja: 'ロールペア',
        cn: '职能集合',
        ko: '역할군끼리'
      },
      partner: {
        en: 'partners together',
        de: 'Partner zusammen',
        fr: 'Partenaires ensemble',
        ja: 'ペア',
        cn: '和搭档集合',
        ko: '파트너끼리'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Eye of the Thunder Vortex/Vortex of the Thunder Eye': 'Thunder Eye/Vortex',
      'Far Edge/Near Edge': 'Far/Near Edge',
      'Great Ball of Fire/Greater Ball of Fire': 'Greater/Great Ball of Fire',
      'Greater Ball of Fire/Great Ball of Fire': 'Great/Greater Ball of Fire',
      'Near Edge/Far Edge': 'Near/Far Edge',
      'Unnatural Ailment/Unnatural Force': 'Unnatural Ailment/Force',
      'Unnatural Force/Unnatural Ailment': 'Unnatural Force/Ailment',
      'Vengeful Flame/Vengeful Pyre': 'Vengeful Flame/Pyre',
      'Vortex of the Thunder Eye/Eye of the Thunder Vortex': 'Thunder Vortex/Eye'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Ashigaru Kyuhei': 'Ashigaru Kyuhei',
      'Ball of Levin': 'Elektrosphäre',
      'Devilish Thrall': 'hörig(?:e|er|es|en) Shiki',
      'Gorai the Uncaged': 'Gorai (?:der|die|das) Entfesselt(?:e|er|es|en)',
      'Moko the Restless': 'Moko (?:der|die|das) Rastlos(?:e|er|es|en)',
      'Moko\'s Shadow': 'Phantom-Moko',
      'Oni\'s Claw': 'Oni-Klaue',
      'Shishio': 'Shishio',
      'Shishu Fuko': 'Shishu-Fuko',
      'Shishu Furutsubaki': 'Shishu-Furutsubaki',
      'Shishu Kotengu': 'Shishu-Kotengu',
      'Shishu Onmitsugashira': 'Shishu-Onmitsugarashi',
      'Shishu Raiko': 'Shishu-Raiko',
      'Shishu Yuki': 'Shishu-Yuki',
      'The Trial Of Benevolence': 'Probe der Güte',
      'The Trial Of Responsibility': 'Probe der Pflicht',
      'The Trial Of Wisdom': 'Probe der Weisheit'
    },
    'replaceText': {
      '\\(circles\\)': '(Kreise)',
      '\\(lines\\)': '(Linien)',
      'Azure Auspice': 'Azurblauer Kenki-Fokus',
      'Boundless Azure': 'Grenzenloses Azurblau',
      'Boundless Scarlet': 'Grenzenloses Scharlachrot',
      'Brazen Ballad': 'Biwa-Weise',
      '(?<!Levin)Burst': 'Explosion',
      'Clearout': 'Ausräumung',
      'Cloud to Ground': 'Sturmkonzentration',
      'Double Iai-giri': 'Doppeltes Iai-giri',
      'Enkyo': 'Enkyo',
      'Explosion': 'Explosion',
      'Eye of the Thunder Vortex': 'Auge des Sturmwirbels',
      'Falling Rock': 'Steinschlag',
      'Far Edge': 'Fernschneidung',
      'Fighting Spirits': 'Kräftigender Schluck',
      'Fire Spread': 'Brandstiftung',
      'Flame and Sulphur': 'Flamme und Schwefel',
      'Fleeting Iai-giri': 'Leichtfüßiges Iai-giri',
      'Flickering Flame': 'Flackernde Flamme',
      'Flintlock': 'Steinschloss',
      'Great Ball of Fire': 'Großer Feuerball',
      'Greater Ball of Fire': 'Größerer Feuerball',
      'Haunting Cry': 'Klagender Schrei',
      'Humble Hammer': 'Entehrender Hammer',
      'Impure Purgation': 'Flammenwind',
      'Invocation of Vengeance': 'Ruf nach Vergeltung',
      'Iron Rain': 'Eisenregen',
      'Iron Storm': 'Eisensturm',
      'Kenki Release': 'Kenki-Entfesselung',
      'Lateral Slice': 'Lateralschlitzer',
      'Left Swipe': 'Linker Feger',
      'Levinburst': 'Blitzgang',
      'Malformed Prayer': 'Unheil des Perlenkranzes',
      'Malformed Reincarnation': 'Unheilvolle Verwandlung',
      'Moonless Night': 'Mondlose Nacht',
      'Near Edge': 'Nahschneidung',
      'Noble Pursuit': 'Reißzahn des Löwen',
      'Pointed Purgation': 'Gerichteter Flammenwind',
      'Right Swipe': 'Rechter Feger',
      'Rousing Reincarnation': 'Fluch der Verwandlung',
      'Scarlet Auspice': 'Scharlachroter Kenki-Fokus',
      'Seal of Scurrying Sparks': 'Siegel des Funkenflugs',
      'Shadow Kasumi-giri': 'Obskures Kasumi-giri',
      'Shadow-twin': 'Schattenzwilling',
      'Shock': 'Entladung',
      'Slither': 'Schlängeln',
      'Smokeater': 'Dunstfresser',
      'Soldiers of Death': 'Soldaten des Todes',
      'Splitting Cry': 'Schrecklicher Schrei',
      'Stormcloud Summons': 'Elektrizitätsgenerierung',
      'Stygian Aura': 'Schwarze Aura',
      '(?<!Eye of the )Thunder Vortex': 'Sturmwirbel',
      'Thundercall': 'Donnerruf',
      'Torching Torment': 'Höllische Hitze',
      'Triple Kasumi-giri': 'Dreifaches Kasumi-giri',
      'Unenlightenment': 'Glühende Geißel',
      'Unnatural Ailment': 'Unnatürliches Leiden',
      'Unnatural Force': 'Unnatürliche Macht',
      'Unnatural Wail': 'Unnatürliches Heulen',
      'Upwell': 'Strömung',
      'Vengeful Flame': 'Vergeltende Flamme',
      'Vengeful Pyre': 'Vergeltendes Feuer',
      'Vengeful Souls': 'Rachsüchtige Seelen',
      'Vermilion Aura': 'Rote Aura',
      'Vortex of the Thunder Eye': 'Wirbel des Sturmauges',
      'Worldly Pursuit': 'Schmerzschlag der Springmaus'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ashigaru Kyuhei': 'ashigaru kyûhei',
      'Ball of Levin': 'orbe de foudre',
      'Devilish Thrall': 'ilote malicieux',
      'Gorai the Uncaged': 'Gôrai le fureteur',
      'Moko the Restless': 'Môko le tourmenté',
      'Moko\'s Shadow': 'spectre de Môko',
      'Oni\'s Claw': 'griffe d\'oni',
      'Shishio': 'Shishiô',
      'Shishu Fuko': 'fûkô de Shishû',
      'Shishu Furutsubaki': 'furutsubaki de Shishû',
      'Shishu Kotengu': 'kotengu de Shishû',
      'Shishu Onmitsugashira': 'onmitsugashira de Shishû',
      'Shishu Raiko': 'raikô de Shishû',
      'Shishu Yuki': 'yûki de Shishû',
      'The Trial Of Benevolence': 'Épreuve de la Prospérité',
      'The Trial Of Responsibility': 'Épreuve de la Longévité',
      'The Trial Of Wisdom': 'Épreuve de la Connaissance'
    },
    'replaceText': {
      '\\(circles\\)': '(Cercles)',
      '\\(lines\\)': '(Lignes)',
      'Azure Auspice': 'Auspice azuré',
      'Boundless Azure': 'Lueur azurée',
      'Boundless Scarlet': 'Lueur écarlate',
      'Brazen Ballad': 'Ballade cuivrée',
      '(?<!Levin)Burst': 'Explosion',
      'Clearout': 'Fauchage',
      'Cloud to Ground': 'Attaque fulminante',
      'Double Iai-giri': 'Iai-giri double',
      'Enkyo': 'Enkyô',
      'Explosion': 'Explosion',
      'Eye of the Thunder Vortex': 'Œil du vortex de foudre',
      'Falling Rock': 'Chute de pierre',
      'Far Edge': 'Visée lointaine',
      'Fighting Spirits': 'Esprits spiritueux',
      'Fire Spread': 'Nappe de feu',
      'Flame and Sulphur': 'Soufre enflammé',
      'Fleeting Iai-giri': 'Iai-giri fugace',
      'Flickering Flame': 'Flamme vacillante',
      'Flintlock': 'Tir d\'artillerie',
      'Great Ball of Fire': 'Grande boule de feu',
      'Greater Ball of Fire': 'Grande sphère de feu',
      'Haunting Cry': 'Cri de tourmente',
      'Humble Hammer': 'Marteau d\'humilité',
      'Impure Purgation': 'Purgation impure',
      'Invocation of Vengeance': 'Invocation vengeresse',
      'Iron Rain': 'Pluie de fer',
      'Iron Storm': 'Orage de fer',
      'Kenki Release': 'Décharge Kenki',
      'Lateral Slice': 'Taillade latérale',
      'Left Swipe': 'Tranchage gauche',
      'Levinburst': 'Éclat de foudre',
      'Malformed Prayer': 'Prière difforme',
      'Malformed Reincarnation': 'Sceau de réincarnation difforme',
      'Moonless Night': 'Nuit noire',
      'Near Edge': 'Visée proche',
      'Noble Pursuit': 'Noble ambition',
      'Pointed Purgation': 'Purgation pointée',
      'Right Swipe': 'Tranchage droit',
      'Rousing Reincarnation': 'Réincarnation vibrante',
      'Scarlet Auspice': 'Auspice écarlate',
      'Seal of Scurrying Sparks': 'Sceau des feux follets',
      'Shadow Kasumi-giri': 'Kasumi-giri spectral',
      'Shadow-twin': 'Ombre jumelle',
      'Shock': 'Décharge électrostatique',
      'Slither': 'Serpentin',
      'Smokeater': 'Dévoreur de brouillard',
      'Soldiers of Death': 'Guerriers de la mort',
      'Splitting Cry': 'Cri d\'horreur',
      'Stormcloud Summons': 'Nuage d\'orage',
      'Stygian Aura': 'Aura stygienne',
      '(?<!Eye of the )Thunder Vortex': 'Spirale de foudre',
      'Thundercall': 'Drain fulminant',
      'Torching Torment': 'Brasier de tourments',
      'Triple Kasumi-giri': 'Kasumi-giri triple',
      'Unenlightenment': 'Sommeil spirituel',
      'Unnatural Ailment': 'Affection contre nature',
      'Unnatural Force': 'Force contre nature',
      'Unnatural Wail': 'Hurlement contre nature',
      'Upwell': 'Torrent violent',
      'Vengeful Flame': 'Flamme vengeresse',
      'Vengeful Pyre': 'Bûcher vengeur',
      'Vengeful Souls': 'Âmes vengeresses',
      'Vermilion Aura': 'Aura vermillon',
      'Vortex of the Thunder Eye': 'Vortex de l\'œil de foudre',
      'Worldly Pursuit': 'Matérialisme'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ashigaru Kyuhei': '足軽弓兵',
      'Ball of Levin': '雷球',
      'Devilish Thrall': '惑わされた屍鬼',
      'Gorai the Uncaged': '鉄鼠ゴウライ',
      'Moko the Restless': '怨霊モウコ',
      'Moko\'s Shadow': 'モウコの幻影',
      'Oni\'s Claw': '鬼腕',
      'Shishio': '獅子王',
      'Shishu Fuko': 'シシュウ・フウコウ',
      'Shishu Furutsubaki': 'シシュウ・フルツバキ',
      'Shishu Kotengu': 'シシュウ・コテング',
      'Shishu Onmitsugashira': 'シシュウ・オンミツガシラ',
      'Shishu Raiko': 'シシュウ・ライコウ',
      'Shishu Yuki': 'シシュウ・ユウキ',
      'The Trial Of Benevolence': '福徳の試練',
      'The Trial Of Responsibility': '寿徳の試練',
      'The Trial Of Wisdom': '智徳の試練'
    },
    'replaceText': {
      'Azure Auspice': '青帝剣気',
      'Boundless Azure': '青帝空閃刃',
      'Boundless Scarlet': '赤帝空閃刃',
      'Brazen Ballad': '琵琶の旋律',
      '(?<!Levin)Burst': '爆発',
      'Clearout': 'なぎ払い',
      'Cloud to Ground': '襲雷',
      'Double Iai-giri': '俊足居合二段',
      'Enkyo': '猿叫',
      'Explosion': '爆発',
      'Eye of the Thunder Vortex': '渦雷の連舞：円輪',
      'Falling Rock': '落石',
      'Far Edge': '遠間当て',
      'Fighting Spirits': '般若湯',
      'Fire Spread': '放火',
      'Flame and Sulphur': '岩火招来',
      'Fleeting Iai-giri': '俊足居合斬り',
      'Flickering Flame': '怪火招来',
      'Flintlock': '火砲',
      'Great Ball of Fire': '火球',
      'Greater Ball of Fire': '重火球',
      'Haunting Cry': '不気味な鳴声',
      'Humble Hammer': '打ち出の小槌',
      'Impure Purgation': '炎流',
      'Invocation of Vengeance': '怨呪の祈請',
      'Iron Rain': '矢の雨',
      'Iron Storm': '矢の嵐',
      'Kenki Release': '剣気解放',
      'Lateral Slice': '胴薙ぎ',
      'Left Swipe': '左爪薙ぎ払い',
      'Levinburst': '発雷',
      'Malformed Prayer': '呪珠印',
      'Malformed Reincarnation': '変現呪珠の印',
      'Moonless Night': '闇夜斬り',
      'Near Edge': '近間当て',
      'Noble Pursuit': '獅子王牙',
      'Pointed Purgation': '指向炎流',
      'Right Swipe': '右爪薙ぎ払い',
      'Rousing Reincarnation': '変現の呪い',
      'Scarlet Auspice': '赤帝剣気',
      'Seal of Scurrying Sparks': '乱火の印',
      'Shadow Kasumi-giri': '幻影霞斬り',
      'Shadow-twin': '幻影呼び',
      'Shock': '放電',
      'Slither': '蛇尾薙ぎ',
      'Smokeater': '霞喰い',
      'Soldiers of Death': '屍兵呼び',
      'Splitting Cry': '霊鳴砲',
      'Stormcloud Summons': '雷雲生成',
      'Stygian Aura': '黒妖弾',
      '(?<!Eye of the )Thunder Vortex': '輪転渦雷',
      'Thundercall': '招雷',
      'Torching Torment': '煩熱',
      'Triple Kasumi-giri': '霞三段',
      'Unenlightenment': '煩悩熾盛',
      'Unnatural Ailment': '妖撃',
      'Unnatural Force': '重妖撃',
      'Unnatural Wail': '不気味な呪声',
      'Upwell': '水流',
      'Vengeful Flame': '怨呪の火',
      'Vengeful Pyre': '怨呪の重火',
      'Vengeful Souls': '黒赤招魂',
      'Vermilion Aura': '赤妖弾',
      'Vortex of the Thunder Eye': '渦雷の連舞：輪円',
      'Worldly Pursuit': '跳鼠痛撃'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ashigaru Kyuhei': '足轻弓兵',
      'Ball of Levin': '闪电球',
      'Devilish Thrall': '被迷惑的尸鬼',
      'Gorai the Uncaged': '铁鼠豪雷',
      'Moko the Restless': '怨灵猛虎',
      'Moko\'s Shadow': '猛虎的幻影',
      'Oni\'s Claw': '鬼腕',
      'Shishio': '狮子王',
      'Shishu Fuko': '紫州风犼',
      'Shishu Furutsubaki': '紫州古椿精',
      'Shishu Kotengu': '紫州小天狗',
      'Shishu Onmitsugashira': '紫州隐密头领',
      'Shishu Raiko': '紫州雷犼',
      'Shishu Yuki': '紫州幽鬼',
      'The Trial Of Benevolence': '福德的试炼',
      'The Trial Of Responsibility': '寿德的试炼',
      'The Trial Of Wisdom': '智德的试炼'
    },
    'replaceText': {
      '\\(circles\\)': '(圆圈)',
      '\\(lines\\)': '(直线)',
      'Azure Auspice': '青帝剑气',
      'Boundless Azure': '青帝空闪刃',
      'Boundless Scarlet': '赤帝空闪刃',
      'Brazen Ballad': '琵琶的旋律',
      '(?<!Levin)Burst': '爆炸',
      'Clearout': '横扫',
      'Cloud to Ground': '袭雷',
      'Double Iai-giri': '二段迅步居合斩',
      'Enkyo': '猿啼',
      'Explosion': '爆炸',
      'Eye of the Thunder Vortex': '涡雷连舞之圆环',
      'Falling Rock': '落石',
      'Far Edge': '远刃击',
      'Fighting Spirits': '般若汤',
      'Fire Spread': '喷火',
      'Flame and Sulphur': '岩火招来',
      'Fleeting Iai-giri': '迅步居合斩',
      'Flickering Flame': '怪火招来',
      'Flintlock': '火炮',
      'Great Ball of Fire': '火球',
      'Greater Ball of Fire': '重火球',
      'Haunting Cry': '诡异的叫声',
      'Humble Hammer': '万宝槌',
      'Impure Purgation': '炎流',
      'Invocation of Vengeance': '怨咒的祈请',
      'Iron Rain': '钢铁箭雨',
      'Iron Storm': '箭雨风暴',
      'Kenki Release': '剑气解放',
      'Lateral Slice': '横斩中段',
      'Left Swipe': '左爪横扫',
      'Levinburst': '放雷',
      'Malformed Prayer': '咒珠印',
      'Malformed Reincarnation': '变见咒珠之印',
      'Moonless Night': '暗夜斩',
      'Near Edge': '近刃击',
      'Noble Pursuit': '狮子王牙',
      'Pointed Purgation': '指向炎流',
      'Right Swipe': '右爪横扫',
      'Rousing Reincarnation': '变见的诅咒',
      'Scarlet Auspice': '赤帝剑气',
      'Seal of Scurrying Sparks': '乱火之印',
      'Shadow Kasumi-giri': '幻影霞斩',
      'Shadow-twin': '召唤幻影',
      'Shock': '放电',
      'Slither': '蛇尾抽击',
      'Smokeater': '噬霞',
      'Soldiers of Death': '召唤阴兵',
      'Splitting Cry': '灵鸣炮',
      'Stormcloud Summons': '生成雷暴云',
      'Stygian Aura': '黑妖弹',
      '(?<!Eye of the )Thunder Vortex': '回环涡雷',
      'Thundercall': '招雷',
      'Torching Torment': '烦热',
      'Triple Kasumi-giri': '三段霞斩',
      'Unenlightenment': '烦恼炽盛',
      'Unnatural Ailment': '妖击',
      'Unnatural Force': '重妖击',
      'Unnatural Wail': '诡异的咒声',
      'Upwell': '水流',
      'Vengeful Flame': '怨咒之火',
      'Vengeful Pyre': '怨咒之重火',
      'Vengeful Souls': '黑赤招魂',
      'Vermilion Aura': '赤妖弹',
      'Vortex of the Thunder Eye': '涡雷连舞之环圆',
      'Worldly Pursuit': '跳鼠痛击'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ashigaru Kyuhei': '하급 궁병',
      'Ball of Levin': '번개 구체',
      'Devilish Thrall': '현혹된 시체귀신',
      'Gorai the Uncaged': '무쇠쥐 고우라이',
      'Moko the Restless': '원령 모우코',
      'Moko\'s Shadow': '모우코의 환영',
      'Oni\'s Claw': '악귀의 팔',
      'Shishio': '사자왕',
      'Shishu Fuko': '시슈 폭풍신',
      'Shishu Furutsubaki': '시슈 동백요괴',
      'Shishu Kotengu': '시슈 작은 텐구',
      'Shishu Onmitsugashira': '시슈 밀정 두목',
      'Shishu Raiko': '시슈 천둥신',
      'Shishu Yuki': '시슈 그림자요괴',
      'The Trial Of Benevolence': '복덕의 시련',
      'The Trial Of Responsibility': '수덕의 시련',
      'The Trial Of Wisdom': '지덕의 시련'
    },
    'replaceText': {
      '\\(circles\\)': '(원)',
      '\\(lines\\)': '(직선)',
      'Azure Auspice': '청제 검기',
      'Boundless Azure': '청제 공섬도',
      'Boundless Scarlet': '적제 공섬도',
      'Brazen Ballad': '비파의 선율',
      '(?<!Levin)Burst': '폭발',
      'Clearout': '휩쓸기',
      'Cloud to Ground': '습뢰',
      'Double Iai-giri': '이단 거합 준족베기',
      'Enkyo': '원숭이 포효',
      'Explosion': '폭발',
      'Eye of the Thunder Vortex': '와뢰 연무: 내외측',
      'Falling Rock': '낙석',
      'Far Edge': '원거리 찌르기',
      'Fighting Spirits': '반야탕',
      'Fire Spread': '방화',
      'Flame and Sulphur': '바위불 소환',
      'Fleeting Iai-giri': '거합 준족베기',
      'Flickering Flame': '귀신불 소환',
      'Flintlock': '화포',
      'Great Ball of Fire': '화염구',
      'Greater Ball of Fire': '겹불덩이',
      'Haunting Cry': '섬뜩한 괴성',
      'Humble Hammer': '요술 망치',
      'Impure Purgation': '염류',
      'Invocation of Vengeance': '원한의 기도',
      'Iron Rain': '화살비',
      'Iron Storm': '화살폭풍',
      'Kenki Release': '검기 해방',
      'Lateral Slice': '몸통 가로베기',
      'Left Swipe': '좌측 할퀴기',
      'Levinburst': '번개 발산',
      'Living Hell': '삼계화택',
      'Malformed Prayer': '염주 각인',
      'Malformed Reincarnation': '변신 염주 각인',
      'Moonless Night': '암야 베기',
      'Near Edge': '근거리 찌르기',
      'Noble Pursuit': '사자왕의 송곳니',
      'Pointed Purgation': '조준 염류',
      'Right Swipe': '우측 할퀴기',
      'Rousing Reincarnation': '변신 저주',
      'Scarlet Auspice': '적제 검기',
      'Seal of Scurrying Sparks': '불씨 뿌리기',
      'Shadow Kasumi-giri': '환영 안개베기',
      'Shadow-twin': '환영 부르기',
      'Shock': '방전',
      'Slither': '뱀꼬리 후리기',
      'Smokeater': '안개 흡입',
      'Soldiers of Death': '시체병 부르기',
      'Splitting Cry': '영명포',
      'Stormcloud Summons': '번개구름 생성',
      'Stygian Aura': '흑요탄',
      '(?<!Eye of the )Thunder Vortex': '외측 와뢰',
      'Thundercall': '초뢰',
      'Torching Torment': '번열',
      'Triple Kasumi-giri': '삼단 안개베기',
      'Unenlightenment': '번뇌치성',
      'Unnatural Ailment': '섬뜩한 폭발',
      'Unnatural Force': '섬뜩한 강력 폭발',
      'Unnatural Wail': '섬뜩한 저주',
      'Upwell': '물길',
      'Vengeful Flame': '원한의 불',
      'Vengeful Pyre': '원한의 겹불',
      'Vengeful Souls': '요탄 소환',
      'Vermilion Aura': '적요탄',
      'Vortex of the Thunder Eye': '와뢰 연무: 외내측',
      'Worldly Pursuit': '쥐 도약격'
    }
  }]
};
/* harmony default export */ const another_mount_rokkon = (another_mount_rokkon_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/another_mount_rokkon.txt
const dungeon_another_mount_rokkon_namespaceObject = "### ANOTHER MOUNT ROKKON\r\n# ZoneId: 483\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~#\r\n# SHISHIO #\r\n#~~~~~~~~~#\r\n\r\n# -p 841A:1012\r\n# -ii 86DF 83FB 83FC 83FD 83FE 83FF 8400 8401 840D 8402 8403 8404 8405 8406\r\n\r\n# Note: for Stormcloud Summons, differing amounts of Smokeater create different timings\r\n# and ability ids for both the \"circles\" and \"lines\" patterns. The timelines match up\r\n# after that, and the timings from a timeline are not that useful, so these are mostly\r\n# skipped. Triggers will probably do a better job for the \"circles\" case, while \"lines\"\r\n# is just a dodge check.\r\n\r\n# Trial of Benevolence will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10F8\" } window 10000,0\r\n1007.0 \"--sync--\" StartsUsing { id: \"841A\", source: \"Shishio\" } window 10000,0\r\n1012.0 \"Enkyo\" Ability { id: \"841A\", source: \"Shishio\" }\r\n\r\n1014.1 \"--middle--\" Ability { id: \"841D\", source: \"Shishio\" }\r\n1019.4 \"Stormcloud Summons (circles)\" Ability { id: \"83F8\", source: \"Shishio\" }\r\n1024.1 \"Smokeater 1\" Ability { id: \"83F9\", source: \"Shishio\" }\r\n1026.2 \"Smokeater 2?\" #Ability { id: \"83FA\", source: \"Shishio\" }\r\n1028.3 \"Smokeater 3?\" #Ability { id: \"83FA\", source: \"Shishio\" }\r\n\r\n1046.5 \"--sync--\" StartsUsing { id: \"841B\", source: \"Shishio\" } window 10,10\r\n1051.5 \"Splitting Cry\" Ability { id: \"841B\", source: \"Shishio\" }\r\n1055.5 \"Slither\" Ability { id: \"841C\", source: \"Shishio\" }\r\n\r\n1060.7 \"--north--\" Ability { id: \"841D\", source: \"Shishio\" }\r\n1071.0 \"Noble Pursuit 1\" Ability { id: \"8407\", source: \"Shishio\" }\r\n1071.8 \"Levinburst 1\" #Ability { id: \"8409\", source: \"Rairin\" }\r\n1072.5 \"Noble Pursuit 2\" #Ability { id: \"8408\", source: \"Shishio\" }\r\n1073.3 \"Levinburst 2\" #Ability { id: \"8409\", source: \"Rairin\" }\r\n1074.0 \"Noble Pursuit 3\" #Ability { id: \"8408\", source: \"Shishio\" }\r\n1074.8 \"Levinburst 3\" #Ability { id: \"8409\", source: \"Rairin\" }\r\n1075.5 \"Noble Pursuit 4\" #Ability { id: \"8408\", source: \"Shishio\" }\r\n1076.3 \"Levinburst 4\" #Ability { id: \"8409\", source: \"Rairin\" }\r\n1081.7 \"Enkyo\" Ability { id: \"841A\", source: \"Shishio\" }\r\n\r\n1083.8 \"--middle--\" Ability { id: \"841D\", source: \"Shishio\" }\r\n1088.8 \"Unnatural Wail\" Ability { id: \"8417\", source: \"Shishio\" }\r\n1093.9 \"Haunting Cry\" Ability { id: \"840A\", source: \"Shishio\" }\r\n1105.9 \"Right Swipe\" Ability { id: \"840B\", source: \"Devilish Thrall\" }\r\n1105.9 \"Left Swipe\" Ability { id: \"840C\", source: \"Devilish Thrall\" }\r\n1106.8 \"Unnatural Ailment/Unnatural Force 1\" Ability { id: [\"8418\", \"8419\"], source: \"Shishio\" }\r\n1112.9 \"Right Swipe\" Ability { id: \"840B\", source: \"Devilish Thrall\" }\r\n1112.9 \"Left Swipe\" Ability { id: \"840C\", source: \"Devilish Thrall\" }\r\n1113.8 \"Unnatural Force/Unnatural Ailment 2\" Ability { id: [\"8419\", \"8418\"], source: \"Shishio\" }\r\n\r\n1118.1 \"--middle--\" Ability { id: \"841D\", source: \"Shishio\" }\r\n1123.4 \"Stormcloud Summons (lines)\" Ability { id: \"83F8\", source: \"Shishio\" }\r\n1128.1 \"Smokeater 1\" Ability { id: \"83F9\", source: \"Shishio\" }\r\n1130.2 \"Smokeater 2?\" #Ability { id: \"83FA\", source: \"Shishio\" }\r\n1132.2 \"Smokeater 3?\" #Ability { id: \"83FA\", source: \"Shishio\" }\r\n\r\n1155.7 \"--middle--\" Ability { id: \"841D\", source: \"Shishio\" } window 10,10\r\n1160.8 \"Unnatural Wail\" Ability { id: \"8417\", source: \"Shishio\" }\r\n1168.1 \"Eye of the Thunder Vortex/Vortex of the Thunder Eye\" Ability { id: [\"8413\", \"8415\"], source: \"Shishio\" }\r\n1168.8 \"Unnatural Ailment/Unnatural Force 1\" Ability { id: [\"8418\", \"8419\"], source: \"Shishio\" }\r\n# Technically, the in/out and out/in for each pair are named the same thing.\r\n# But in a timeline, switching them makes it obvious it's the other.\r\n1172.1 \"Vortex of the Thunder Eye/Eye of the Thunder Vortex\" Ability { id: [\"8414\", \"8416\"], source: \"Shishio\" }\r\n1172.8 \"Unnatural Force/Unnatural Ailment 2\" Ability { id: [\"8419\", \"8418\"], source: \"Shishio\" }\r\n1181.4 \"Enkyo\" Ability { id: \"841A\", source: \"Shishio\" }\r\n\r\n1189.5 \"Haunting Cry\" Ability { id: \"840A\", source: \"Shishio\" }\r\n1194.6 \"--sync--\" Ability { id: \"841D\", source: \"Shishio\" }\r\n1211.9 \"Vengeful Souls\" Ability { id: \"840E\", source: \"Shishio\" }\r\n1211.9 \"Stygian Aura\" Ability { id: \"8410\", source: \"Shishio\" }\r\n1211.9 \"Vermilion Aura\" Ability { id: \"840F\", source: \"Shishio\" }\r\n\r\n1219.0 \"Thunder Vortex\" Ability { id: \"8412\", source: \"Shishio\" }\r\n1226.3 \"Splitting Cry\" Ability { id: \"841B\", source: \"Shishio\" }\r\n1230.3 \"Slither\" Ability { id: \"841C\", source: \"Shishio\" }\r\n\r\n1235.5 \"--middle--\" Ability { id: \"841D\", source: \"Shishio\" }\r\n1240.8 \"Stormcloud Summons (circles)\" Ability { id: \"83F8\", source: \"Shishio\" }\r\n1245.5 \"Smokeater 1\" Ability { id: \"83F9\", source: \"Shishio\" }\r\n1247.6 \"Smokeater 2?\" #Ability { id: \"83FA\", source: \"Shishio\" }\r\n1249.7 \"Smokeater 3?\" #Ability { id: \"83FA\", source: \"Shishio\" }\r\n\r\n1267.1 \"--middle--\" Ability { id: \"841D\", source: \"Shishio\" }\r\n1272.2 \"Stormcloud Summons (lines)\" Ability { id: \"83F8\", source: \"Shishio\" }\r\n1276.9 \"Smokeater 1\" Ability { id: \"83F9\", source: \"Shishio\" }\r\n1279.0 \"Smokeater 2?\" #Ability { id: \"83FA\", source: \"Shishio\" }\r\n1281.0 \"Smokeater 3?\" #Ability { id: \"83FA\", source: \"Shishio\" }\r\n\r\n1307.4 \"--middle--\" Ability { id: \"841D\", source: \"Shishio\" }\r\n1312.5 \"Unnatural Wail\" Ability { id: \"8417\", source: \"Shishio\" }\r\n1319.8 \"Eye of the Thunder Vortex/Vortex of the Thunder Eye\" Ability { id: [\"8413\", \"8415\"], source: \"Shishio\" }\r\n1320.4 \"Unnatural Ailment/Unnatural Force 1\" Ability { id: [\"8418\", \"8419\"], source: \"Shishio\" }\r\n1323.8 \"Vortex of the Thunder Eye/Eye of the Thunder Vortex\" Ability { id: [\"8414\", \"8416\"], source: \"Shishio\" }\r\n1324.4 \"Unnatural Force/Unnatural Ailment 2\" Ability { id: [\"8419\", \"8418\"], source: \"Shishio\" }\r\n\r\n1329.4 \"--sync--\" StartsUsing { id: \"841E\", source: \"Shishio\" } window 20,20\r\n1339.4 \"Enkyo Enrage\" Ability { id: \"841E\", source: \"Shishio\" }\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 83F8 Stormcloud Summons cast and self-targeted ability\r\n# 83F9 Smokeater cast and self-targeted ability for first inhale\r\n# 83FA Smokeater self-targeted ability for optional second and third inhales\r\n# 83FB --sync-- ability from Raiun cloud on Shishio after being inhaled\r\n# 83FC Rokujo Revel cast and self-targeted ability for first Smokeater line\r\n# 83FD Rokujo Revel cast and self-targeted ability for followup Smokeater lines\r\n# 83FE Rokujo Revel cast and damage for Smokeater lines\r\n# 83FF Leaping Levin cast and damage from Raiun cloud adds for 1x Smokeater small circles\r\n# 8400 Leaping Levin cast and damage from Raiun cloud adds for 2x Smokeater medium circles\r\n# 8401 Leaping Levin cast and damage from Raiun cloud adds for 3x Smokeater large circles\r\n# 8402 Lightning Bolt cast and self-targeted ability\r\n# 8403 Lightning Bolt cast and damage for initial cloud circles\r\n# 8404 Cloud to Cloud cast and damage for 1x Smokeater small lines\r\n# 8405 Cloud to Cloud cast and damage for 2x Smokeater medium lines\r\n# 8406 Cloud to Cloud cast and damage for 3x Smokeater large lines\r\n# 8407 Noble Pursuit cast and damage for initial charge\r\n# 8408 Noble Pursuit damage for followup changes\r\n# 8409 Levinburst line damage for going through rings during Noble Pursuit\r\n# 840A Haunting Cry cast and self-targeted ability to summon Devilish Thrall ghosts\r\n# 840B Right Swipe cast and damage for Devilish Thrall cleave during first Unnatural Wail\r\n# 840C Left Swipe cast and damage for Devilish Thrall cleave during first Unnatural Wail\r\n# 840D Reisho damage from Haunting Thrall untelegraphed aoes\r\n# 840E Vengeful Souls self-targeted ability at the same time as Vermillion/Stygian Aura\r\n# 840F Vermilion Aura damage from taking a tower at the same time as Stygian Aura\r\n# 8410 Stygian Aura spread marker damage at the same time as Vermillion Aura\r\n# 8411 Unmitigated Explosion damage from not taking towers\r\n# 8412 Thunder Vortex cast and damage for untelegraphed donut\r\n# 8413 Eye of the Thunder Vortex cast and damage for first \"out\" circle\r\n# 8414 Eye of the Thunder Vortex damage for second \"in\" donut\r\n# 8415 Vortex of the Thunder Eye cast and damage for first \"in\" donut\r\n# 8416 Vortex of the Thunder Eye damage for second \"out\" circle\r\n# 8417 Unnatural Wail cast and self-targeted ability\r\n# 8418 Unnatural Ailment damage for Unnatural Wail \"spread\"\r\n# 8419 Unnatural Force damage for Unnatural Wail \"stack\"\r\n# 841A Enkyo cast and damage for raidwide\r\n# 841B Splitting Cry cast and damage for tankbuster\r\n# 841C Slither fast cast and damage for back conal\r\n# 841D --sync-- repositioning ability\r\n# 841E Enkyo cast and damage for enrage\r\n# 86DF --sync-- auto damage\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~#\r\n# GORAI THE UNCAGED #\r\n#~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 8534:2014.3\r\n# -ii 8502 8504 8535 8504 851A 851D 851E 8513 8515 852F 8525 8257 8522 8533 8528 8519 852A 852D 852B 8527 8523\r\n\r\n# Trial of Wisdom will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10F9\" } window 10000,0\r\n2009.3 \"--sync--\" StartsUsing { id: \"8534\", source: \"Gorai the Uncaged\" } window 10000,0\r\n2014.3 \"Unenlightenment\" Ability { id: \"8534\", source: \"Gorai the Uncaged\" }\r\n\r\n2021.7 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n2028.0 \"Seal of Scurrying Sparks\" Ability { id: \"8503\", source: \"Gorai the Uncaged\" }\r\n2033.3 \"Flame and Sulphur\" Ability { id: \"8508\", source: \"Gorai the Uncaged\" }\r\n2044.6 \"Brazen Ballad\" Ability { id: [\"8509\", \"850A\"], source: \"Gorai the Uncaged\" }\r\n2047.7 \"Falling Rock\" Ability { id: [\"850E\", \"850F\"], source: \"Gorai the Uncaged\" }\r\n2047.7 \"Fire Spread\" Ability { id: [\"850B\", \"850C\"], source: \"Gorai the Uncaged\" }\r\n2048.0 \"Greater Ball of Fire\" Ability { id: \"8505\", source: \"Gorai the Uncaged\" }\r\n2055.6 \"Impure Purgation 1\" Ability { id: \"8530\", source: \"Gorai the Uncaged\" }\r\n2057.6 \"Impure Purgation 2\" Ability { id: \"8531\", source: \"Gorai the Uncaged\" }\r\n\r\n2063.5 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n2068.7 \"Thundercall\" Ability { id: \"8520\", source: \"Gorai the Uncaged\" }\r\n2079.6 \"Humble Hammer\" Ability { id: \"8524\", source: \"Gorai the Uncaged\" }\r\n2083.2 \"Flintlock\" Ability { id: \"8526\", source: \"Gorai the Uncaged\" }\r\n2083.6 \"Shock\" Ability { id: \"8521\", source: \"Ball of Levin\" }\r\n2094.5 \"Torching Torment\" Ability { id: \"8532\", source: \"Gorai the Uncaged\" }\r\n\r\n2100.9 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n2108.0 \"Rousing Reincarnation\" Ability { id: \"8512\", source: \"Gorai the Uncaged\" }\r\n2114.3 \"Malformed Prayer\" Ability { id: \"8518\", source: \"Gorai the Uncaged\" }\r\n2126.3 \"Pointed Purgation 1\" Ability { id: \"851F\", source: \"Gorai the Uncaged\" }\r\n2126.4 \"Burst 1\" Ability { id: \"851B\", source: \"Gorai the Uncaged\" }\r\n2132.4 \"Pointed Purgation 2\" Ability { id: \"851F\", source: \"Gorai the Uncaged\" }\r\n2132.4 \"Burst 2\" Ability { id: \"851B\", source: \"Gorai the Uncaged\" }\r\n2138.4 \"Pointed Purgation 3\" Ability { id: \"851F\", source: \"Gorai the Uncaged\" }\r\n2138.4 \"Burst 3\" Ability { id: \"851B\", source: \"Gorai the Uncaged\" }\r\n2144.4 \"Pointed Purgation 4\" Ability { id: \"851F\", source: \"Gorai the Uncaged\" }\r\n2144.4 \"Burst 4\" Ability { id: \"851B\", source: \"Gorai the Uncaged\" }\r\n2155.7 \"Unenlightenment\" Ability { id: \"8534\", source: \"Gorai the Uncaged\" }\r\n\r\n2163.1 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n2169.2 \"Seal of Scurrying Sparks\" Ability { id: \"8503\", source: \"Gorai the Uncaged\" }\r\n2178.5 \"Cloud to Ground\" Ability { id: \"8529\", source: \"Gorai the Uncaged\" } duration 6.3\r\n2180.5 \"Greater Ball of Fire/Great Ball of Fire\" Ability { id: [\"8505\", \"8506\"], source: \"Gorai the Uncaged\" } window 1,1\r\n2183.5 \"Great Ball of Fire/Greater Ball of Fire\" Ability { id: [\"8506\", \"8505\"], source: \"Gorai the Uncaged\" } window 1,1\r\n\r\n2193.5 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n2202.2 \"Fighting Spirits\" Ability { id: \"852C\", source: \"Gorai the Uncaged\" }\r\n2205.5 \"Worldly Pursuit 1\" Ability { id: \"850D\", source: \"Gorai the Uncaged\" }\r\n2208.6 \"Worldly Pursuit 2\" Ability { id: \"850D\", source: \"Gorai the Uncaged\" }\r\n2211.6 \"Worldly Pursuit 3\" Ability { id: \"850D\", source: \"Gorai the Uncaged\" }\r\n2214.6 \"Worldly Pursuit 4\" Ability { id: \"850D\", source: \"Gorai the Uncaged\" }\r\n2217.6 \"Worldly Pursuit 5\" Ability { id: \"850D\", source: \"Gorai the Uncaged\" }\r\n2232.2 \"Torching Torment\" Ability { id: \"8532\", source: \"Gorai the Uncaged\" }\r\n\r\n2238.6 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n2245.8 \"Malformed Reincarnation\" Ability { id: \"8514\", source: \"Gorai the Uncaged\" }\r\n2252.2 \"Malformed Prayer\" Ability { id: \"8518\", source: \"Gorai the Uncaged\" }\r\n2265.3 \"Flickering Flame\" Ability { id: \"8510\", source: \"Gorai the Uncaged\" }\r\n2267.3 \"Burst 1\" #Ability { id: \"851B\", source: \"Gorai the Uncaged\" }\r\n2269.9 \"Burst 2\" #Ability { id: \"851B\", source: \"Gorai the Uncaged\" }\r\n2271.9 \"Burst 3\" #Ability { id: \"851B\", source: \"Gorai the Uncaged\" }\r\n2272.6 \"Fire Spread 1\" #Ability { id: \"8511\", source: \"Gorai the Uncaged\" }\r\n2274.6 \"Fire Spread 2\" #Ability { id: \"8511\", source: \"Gorai the Uncaged\" }\r\n\r\n2282.9 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n2289.0 \"Seal of Scurrying Sparks\" Ability { id: \"8503\", source: \"Gorai the Uncaged\" }\r\n2294.3 \"Flame and Sulphur\" Ability { id: \"8508\", source: \"Gorai the Uncaged\" }\r\n2305.6 \"Brazen Ballad\" Ability { id: \"850A\", source: \"Gorai the Uncaged\" }\r\n2308.7 \"Falling Rock\" Ability { id: \"850F\", source: \"Gorai the Uncaged\" }\r\n2308.7 \"Fire Spread\" Ability { id: \"850C\", source: \"Gorai the Uncaged\" }\r\n2309.1 \"Greater Ball of Fire\" Ability { id: \"8505\", source: \"Gorai the Uncaged\" }\r\n2318.3 \"Unenlightenment\" Ability { id: \"8534\", source: \"Gorai the Uncaged\" }\r\n\r\n2325.4 \"--sync--\" StartsUsing { id: \"8536\", source: \"Gorai the Uncaged\" }\r\n2335.4 \"Living Hell Enrage\" Ability { id: \"8536\", source: \"Gorai the Uncaged\" }\r\n#2336.0 \"Living Hell\" #Ability { id: \"8538\", source: \"Gorai the Uncaged\" }\r\n#2337.8 \"Living Hell\" #Ability { id: \"8537\", source: \"Gorai the Uncaged\" }\r\n#2338.4 \"Living Hell\" #Ability { id: \"8538\", source: \"Gorai the Uncaged\" }\r\n#2340.2 \"Living Hell\" #Ability { id: \"8537\", source: \"Gorai the Uncaged\" }\r\n#2340.8 \"Living Hell\" #Ability { id: \"8538\", source: \"Gorai the Uncaged\" }\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 84D3 --sync-- repositioning\r\n# 8502 --sync-- auto damage\r\n# 8503 Seal of Scurrying Sparks cast and self-targeted ability\r\n# 8504 Seal of Scurrying Sparks ability on players that gives Live Brazier/Live Candle debuffs\r\n# 8505 Greater Ball of Fire pair stack damage from Live Brazier debuff\r\n# 8506 Great Ball of Fire spread damage from Live Candle debuff\r\n# 8508 Flame and Sulphur cast and self-targeted summoning rocks and lines\r\n# 8509 Brazen Ballad cast and self-targeted purple effect that expands everything\r\n# 850A Brazen Ballad cast and self-targeted blue effect that donutifies everything\r\n# 850B Fire Spread expanded line damage after Brazen Ballad 8509\r\n# 850C Fire Spread split line damage after Brazen Ballad 850A\r\n# 850D Worldly Pursuit cast and damage from cross jumps\r\n# 850E Falling Rock expanded rock damage after Brazen Ballad 8509\r\n# 850F Falling Rock donutified rock damage after Brazen Ballad 850A\r\n# 8510 Flickering Flame cast and ability (summoning blue flames for 8511)\r\n# 8511 Fire Spread cast and damage for waffle lines during second towers\r\n# 8512 Rousing Reincarnation cast and self-targeted ability\r\n# 8513 Rousing Reincarnation ability on player that gives Odder Incarnation and Rodential Rebirth\r\n# 8514 Malformed Reincarnation cast and self-targeted ability\r\n# 8515 Malformed Reincarnation ability on player like Rousing Reincarnation, but also gives Odder/Squirrelly Prayer\r\n# 8518 Malformed Prayer cast and self-targeted ability that starts the tower sequences\r\n# 8519 Burst orange tower damage\r\n# 851A Dramatic Burst missed tower damage (second set? or an orange color?)\r\n# 851B Burst blue tower damage\r\n# 851C Dramatic Burst missed tower damage (first set? or a blue color?)\r\n# 851D Pointed Purgation cast and self-targeted ability before first 851F protean cleave\r\n# 851E Pointed Purgation self-targeted ability before 2/3/4 851F protean cleaves\r\n# 851F Pointed Purgation damage for protean cleave from tether\r\n# 8520 Thundercall cast and self-targeted ability that summons Ball of Levin\r\n# 8521 Shock cast and self-targeted ability by Ball of Levin\r\n# 8522 Shock small ground circle damage from Ball of Levin hit by Humble Hammer\r\n# 8523 Shock large ground circle damage from Ball of Levin\r\n# 8524 Humble Hammer cast and self-targeted ability\r\n# 8525 Humble Hammer cast and damage headmarker on healer that gives mini debuff\r\n# 8526 Flintlock self-targeted ability\r\n# 8527 Flintlock damage for line stack after Humble Hammer\r\n# 8528 Cloud to Ground cast and self-targeted ability\r\n# 8529 Cloud to Ground cloud exaflare damage initial hit\r\n# 852A Cloud to Ground cloud exaflare damage ongoing hits\r\n# 852B Fighting Spirits cast and self-targeted\r\n# 852C Fighting Spirits cast and damage for knockback\r\n# 852D Worldly Pursuit untargeted ability jump before 850D cross cast and damage\r\n# 852F Impure Purgation cast and self-targeted ability\r\n# 8530 Impure Purgation initial protean damage\r\n# 8531 Impure Purgation cast and damage for follow-up protean\r\n# 8532 Torching Torment cast and ability on tank that give burns debuff\r\n# 8533 Torching Torment cast and damage on tank for tankbuster\r\n# 8534 Unenlightenment cast and self-targeted ability\r\n# 8535 Unenlightenment damage for raidwide bleed\r\n# 8536 Living Hell cast and self-targeted enrage\r\n# 8537 Living Hell self-targeted ability for follow-up enrage if 8536 failed\r\n# 8538 Living Hell damage for 8536/8537 enrage abilities\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~#\r\n# MOKO THE RESTLESS #\r\n#~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 85E0:3016.4\r\n# -ii 8507 85B8 85B9 85D2 85DF 8C27 85DA 85CE 85D5 85D7 8537 8538\r\n\r\n# Trial of Responsibility will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10FA\" } window 10000,0\r\n3011.4 \"--sync--\" StartsUsing { id: \"85E0\", source: \"Moko the Restless\" } window 10000,10\r\n3016.4 \"Kenki Release\" Ability { id: \"85E0\", source: \"Moko the Restless\" }\r\n\r\n3035.6 \"Triple Kasumi-giri 1\" Ability { id: [\"85B0\", \"85B1\", \"85B2\", \"85B3\", \"85BA\", \"85BB\", \"85BC\", \"85BD\"], source: \"Moko the Restless\" }\r\n3038.6 \"Triple Kasumi-giri 2\" Ability { id: [\"85B4\", \"85B5\", \"85B6\", \"85B7\", \"85BE\", \"85BF\", \"85C0\", \"85C1\"], source: \"Moko the Restless\" }\r\n3041.6 \"Triple Kasumi-giri 3\" Ability { id: [\"85B4\", \"85B5\", \"85B6\", \"85B7\", \"85BE\", \"85BF\", \"85C0\", \"85C1\"], source: \"Moko the Restless\" }\r\n3055.7 \"Triple Kasumi-giri 1\" Ability { id: [\"85B0\", \"85B1\", \"85B2\", \"85B3\", \"85BA\", \"85BB\", \"85BC\", \"85BD\"], source: \"Moko the Restless\" }\r\n3058.7 \"Triple Kasumi-giri 2\" Ability { id: [\"85B4\", \"85B5\", \"85B6\", \"85B7\", \"85BE\", \"85BF\", \"85C0\", \"85C1\"], source: \"Moko the Restless\" }\r\n3061.7 \"Triple Kasumi-giri 3\" Ability { id: [\"85B4\", \"85B5\", \"85B6\", \"85B7\", \"85BE\", \"85BF\", \"85C0\", \"85C1\"], source: \"Moko the Restless\" }\r\n\r\n3063.8 \"--sync--\" Ability { id: [\"871F\", \"8720\"], source: \"Moko the Restless\" }\r\n3071.1 \"Lateral Slice\" Ability { id: \"85E3\", source: \"Moko the Restless\" }\r\n\r\n3077.2 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3083.3 \"Scarlet Auspice\" Ability { id: \"85D1\", source: \"Moko the Restless\" }\r\n3088.9 \"Boundless Scarlet\" Ability { id: \"8599\", source: \"Moko the Restless\" }\r\n3096.0 \"Invocation of Vengeance\" Ability { id: \"85DB\", source: \"Moko the Restless\" }\r\n3108.1 \"Fleeting Iai-giri (cast)\" Ability { id: \"85C2\", source: \"Moko the Restless\" }\r\n3108.3 \"--jump--\" Ability { id: \"85C3\", source: \"Moko the Restless\" }\r\n3110.6 \"Fleeting Iai-giri\" Ability { id: [\"85C4\", \"85C5\", \"85C6\"], source: \"Moko the Restless\" }\r\n3111.7 \"Explosion 1\" Ability { id: \"85D3\", source: \"Moko the Restless\" }\r\n3111.8 \"Vengeful Flame/Vengeful Pyre\" Ability { id: [\"85DC\", \"85DD\"], source: \"Moko the Restless\" }\r\n3118.6 \"Explosion 2\" Ability { id: \"85D3\", source: \"Moko the Restless\" }\r\n3119.7 \"Vengeful Pyre/Vengeful Flame\" Ability { id: [\"85DD\", \"85DC\"], source: \"Moko the Restless\" }\r\n\r\n3127.6 \"Kenki Release\" Ability { id: \"85E0\", source: \"Moko the Restless\" }\r\n\r\n3134.8 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3139.0 \"Shadow-twin\" Ability { id: \"85C7\", source: \"Moko the Restless\" }\r\n\r\n3145.1 \"Moonless Night\" Ability { id: \"85DE\", source: \"Moko the Restless\" }\r\n3154.2 \"Near Edge/Far Edge 1\" Ability { id: [\"85D9\", \"85D8\"], source: \"Moko the Restless\" }\r\n3154.2 \"Double Iai-giri x2\" Ability { id: \"85C8\", source: \"Moko's Shadow\" }\r\n3154.2 \"Clearout x3\" Ability { id: \"8C21\", source: \"Oni's Claw\" }\r\n3154.2 \"--jump--\" Ability { id: \"85C9\", source: \"Moko's Shadow\" }\r\n3156.9 \"Shadow Kasumi-giri 1\" Ability { id: \"85CA\", source: \"Moko's Shadow\" }\r\n3160.0 \"Shadow Kasumi-giri 2\" Ability { id: [\"86C4\", \"86C5\", \"86C6\"], source: \"Moko's Shadow\" }\r\n\r\n3165.4 \"Moonless Night\" Ability { id: \"85DE\", source: \"Moko the Restless\" }\r\n3174.5 \"Far Edge/Near Edge 2\" Ability { id: [\"85D8\", \"85D9\"], source: \"Moko the Restless\" }\r\n3174.5 \"Double Iai-giri x2\" Ability { id: \"85C8\", source: \"Moko's Shadow\" }\r\n3174.5 \"Clearout x3\" Ability { id: \"8C21\", source: \"Oni's Claw\" }\r\n3174.7 \"--jump--\" Ability { id: \"85C9\", source: \"Moko's Shadow\" }\r\n3176.8 \"Shadow Kasumi-giri 1\" Ability { id: \"85CA\", source: \"Moko's Shadow\" }\r\n3179.8 \"Shadow Kasumi-giri 2\" Ability { id: [\"86C4\", \"86C5\", \"86C6\"], source: \"Moko's Shadow\" }\r\n\r\n3187.1 \"Kenki Release\" Ability { id: \"85E0\", source: \"Moko the Restless\" }\r\n\r\n3195.3 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3201.4 \"Azure Auspice\" Ability { id: \"85D4\", source: \"Moko the Restless\" }\r\n3207.0 \"Boundless Azure\" Ability { id: \"859D\", source: \"Moko the Restless\" }\r\n3218.8 \"Upwell 1\" Ability { id: \"85D6\", source: \"Moko the Restless\" }\r\n3221.8 \"Upwell 2\" Ability { id: \"85D6\", source: \"Moko the Restless\" }\r\n3224.8 \"Upwell 3\" Ability { id: \"85D6\", source: \"Moko the Restless\" }\r\n3225.2 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3227.8 \"Upwell 4\" Ability { id: \"85D6\", source: \"Moko the Restless\" }\r\n3238.7 \"Triple Kasumi-giri 1\" Ability { id: [\"85B0\", \"85B1\", \"85B2\", \"85B3\", \"85BA\", \"85BB\", \"85BC\", \"85BD\"], source: \"Moko the Restless\" }\r\n3241.7 \"Triple Kasumi-giri 2\" Ability { id: [\"85B4\", \"85B5\", \"85B6\", \"85B7\", \"85BE\", \"85BF\", \"85C0\", \"85C1\"], source: \"Moko the Restless\" }\r\n3244.7 \"Triple Kasumi-giri 3\" Ability { id: [\"85B4\", \"85B5\", \"85B6\", \"85B7\", \"85BE\", \"85BF\", \"85C0\", \"85C1\"], source: \"Moko the Restless\" }\r\n\r\n3251.8 \"Kenki Release\" Ability { id: \"85E0\", source: \"Moko the Restless\" }\r\n3254.9 \"--sync--\" Ability { id: [\"871F\", \"8720\"], source: \"Moko the Restless\" }\r\n3260.0 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3264.1 \"Soldiers of Death\" Ability { id: \"8593\", source: \"Moko the Restless\" }\r\n3270.2 \"Shadow-twin\" Ability { id: \"85C7\", source: \"Moko the Restless\" }\r\n3285.4 \"Double Iai-giri x4\" Ability { id: \"85C8\", source: \"Moko's Shadow\" }\r\n3285.6 \"--jump--\" Ability { id: \"85C9\", source: \"Moko's Shadow\" }\r\n3285.9 \"Iron Storm\" Ability { id: \"85D0\", source: \"Ashigaru Kyuhei\" }\r\n3285.9 \"Iron Rain\" Ability { id: \"85CF\", source: \"Ashigaru Kyuhei\" }\r\n3288.3 \"Shadow Kasumi-giri 1\" Ability { id: \"85CA\", source: \"Moko's Shadow\" }\r\n3291.3 \"Shadow Kasumi-giri 2\" Ability { id: [\"86C4\", \"86C6\"], source: \"Moko's Shadow\" }\r\n3291.7 \"Iron Storm\" Ability { id: \"87A8\", source: \"Ashigaru Kyuhei\" }\r\n3291.7 \"Iron Rain\" Ability { id: \"87A7\", source: \"Ashigaru Kyuhei\" }\r\n\r\n3291.8 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3305.1 \"Triple Kasumi-giri 1\" Ability { id: [\"85B0\", \"85B1\", \"85B2\", \"85B3\", \"85BA\", \"85BB\", \"85BC\", \"85BD\"], source: \"Moko the Restless\" }\r\n3308.2 \"Triple Kasumi-giri 2\" Ability { id: [\"85B4\", \"85B5\", \"85B6\", \"85B7\", \"85BE\", \"85BF\", \"85C0\", \"85C1\"], source: \"Moko the Restless\" }\r\n3311.3 \"Triple Kasumi-giri 3\" Ability { id: [\"85B4\", \"85B5\", \"85B6\", \"85B7\", \"85BE\", \"85BF\", \"85C0\", \"85C1\"], source: \"Moko the Restless\" }\r\n3318.3 \"Kenki Release\" Ability { id: \"85E0\", source: \"Moko the Restless\" }\r\n3321.4 \"--sync--\" Ability { id: [\"871F\", \"8720\"], source: \"Moko the Restless\" }\r\n3328.8 \"Lateral Slice\" Ability { id: \"85E3\", source: \"Moko the Restless\" }\r\n3336.8 \"Kenki Release\" Ability { id: \"85E0\", source: \"Moko the Restless\" }\r\n\r\n3342.0 \"--sync--\" StartsUsing { id: \"85E1\", source: \"Moko the Restless\" } window 10,10\r\n3352.0 \"Kenki Release Enrage\" Ability { id: \"85E1\", source: \"Moko the Restless\" }\r\n\r\n\r\n# TODO: are any of these possible??? I think no\r\n# TODO: Fleeting Iai-giri front safe\r\n# TODO: Shadow Kasumi-giri left safe initial\r\n# TODO: Shadow Kasumi-giri right safe initial\r\n# TODO: Shadow Kasumi-giri front safe initial\r\n# TODO: Shadow Kasumi-giri back safe followup\r\n\r\n# 8507 --sync-- auto damage\r\n# 8593 Soldiers of Death cast and self-targeted ability to summon Ashigaru Kyuhei adds\r\n# 8599 Boundless Scarlet cast and self-targeted ability to summon red lines\r\n# 859D Boundless Azure cast and self-targeted ability to summon blue lines\r\n# 85AF --sync-- repositioning\r\n# 85B0 Triple Kasumi-giri long cast and damage for back red first\r\n# 85B1 Triple Kasumi-giri long cast and damage for left red first\r\n# 85B2 Triple Kasumi-giri long cast and damage for front red first\r\n# 85B3 Triple Kasumi-giri long cast and damage for right red first\r\n# 85B4 Triple Kasumi-giri short cast and damage for back red followup\r\n# 85B5 Triple Kasumi-giri short cast and damage for left red followup\r\n# 85B6 Triple Kasumi-giri short cast and damage for front red followup\r\n# 85B7 Triple Kasumi-giri short cast and damage for right red followup\r\n# 85B8 Unbound Spirit damage for red \"out\" Triple Kasumi-giri marker\r\n# 85B9 Azure Coil damage for blue \"in\" Triple Kasumi-giri marker\r\n# 85BA Triple Kasumi-giri long cast and damage for back blue first\r\n# 85BB Triple Kasumi-giri long cast and damage for left blue first\r\n# 85BC Triple Kasumi-giri long cast and damage for front blue first\r\n# 85BD Triple Kasumi-giri long cast and damage for right blue first\r\n# 85BE Triple Kasumi-giri short cast and damage for back blue followup\r\n# 85BF Triple Kasumi-giri short cast and damage for left blue followup\r\n# 85C0 Triple Kasumi-giri short cast and damage for front blue followup\r\n# 85C1 Triple Kasumi-giri short cast and damage for right blue followup\r\n# 85C2 Fleeting Iai-giri cast and self-targeted ability for jumping Iai-giri (all types) from boss\r\n# 85C3 --sync-- boss jump ability for Fleeting Iai-giri\r\n# 85C4 Fleeting Iai-giri short cast and damage for back purple Iai-giri\r\n# 85C5 Fleeting Iai-giri short cast and damage for left purple Iai-giri\r\n# 85C6 Fleeting Iai-giri short cast and damage for right purple Iai-giri\r\n# 85C7 Shadow-twin cast and self-targeted to summon Moko's Shadow clones\r\n# 85C8 Double Iai-giri cast and self-targeted ability for Shadow clone (all types)\r\n# 85C9 --sync-- clone jump ability for Shadow Kasumi-giri\r\n# 85CA Shadow Kasumi-giri short cast and damage for Shadow clone back purple first\r\n# 85CE Kenki Release cast and raidwide enrage from Shadow clones\r\n# 85CF Iron Rain very long initial cast and medium circle damage from red Ashigaru Kyuheis\r\n# 85D0 Iron Storm very long initial cast and big circle damage from blue Ashigaru Kyuhei\r\n# 85D1 Scarlet Auspice cast and damage for \"get out\" before Boundless Scarlet\r\n# 85D2 Boundless Scarlet cast and damage for initial red lines before they grow\r\n# 85D3 Explosion cast and damage for growing red lines\r\n# 85D4 Azure Auspice cast and damage for \"get under\" donut before Boundless Azure\r\n# 85D5 Boundless Azure cast and damage for initial blue lines before they bounce\r\n# 85D6 Upwell cast and damage for blue line first bounce\r\n# 85D7 Upwell damage for blue line ongoing bounces\r\n# 85D8 Far Edge cast and self-targeted ability paired with Accursed Edge on farthest players\r\n# 85D9 Near Edge cast and self-targeted ability paired with Accursed Edge on nearest players\r\n# 85DA Accursed Edge damage and bind on players from Far Edge / Near Edge\r\n# 85DB Invocation of Vengeance cast and self-targeted ability that gives debuffs during Explosions\r\n# 85DC Vengeful Flame spread damage\r\n# 85DD Vengeful Pyre stack damage\r\n# 85DE Moonless Night cast and raidwide damage to summon Oni's Claw\r\n# 85DF Clearout damage from Oni's Claw large circles hit 3\r\n# 85E0 Kenki Release cast and raidwide damage from boss\r\n# 85E1 Kenki Release enrage cast from boss\r\n# 85E3 Lateral Slice cast and tankbuster damage\r\n# 86C4 Shadow Kasumi-giri short cast and damage for Shadow clone left purple followup\r\n# 86C5 Shadow Kasumi-giri short cast and damage for Shadow clone front purple followup\r\n# 86C6 Shadow Kasumi-giri short cast and damage for Shadow clone right purple followup\r\n# 871F --sync-- unknown self-targeted ability before Lateral Slice or Soldiers of Death\r\n# 8720 --sync-- unknown self-targeted ability before Lateral Slice or Soldiers of Death\r\n# 87A7 Iron Rain short followup cast and medium circle damage from red Ashigaru Kyuheis\r\n# 87A8 Iron Storm short followup cast and big circle damage from blue Ashigaru Kyuhei\r\n# 8C21 Clearout cast and damage for Oni's Claw large circles hit 1 (of 3)\r\n# 8C27 Clearout damage from Oni's Claw large circles hit 2\r\n\r\n\r\n#~~~~~~~~~#\r\n# TRASH 1 #\r\n#~~~~~~~~~#\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 7A58 --sync-- various auto damage (trash 1)\r\n# 8653 Barreling Smash cast and damage for line charge\r\n# 8654 Howl cast and damage for Shishu Raiko raidwide\r\n# 8655 Master of Levin cast and damage for Shishu Raiki \"get in\" donut\r\n# 8656 Disciples of Levin cast and damage for Shishu Raiko \"get out\" circle\r\n# 8657 Bloody Caress cast and damage for Shishu Furutsubaki front conal\r\n# 8658 Twister cast and damage for Shishu Fuko stack\r\n# 8659 Crosswind cast and damage for Shishu Fuko knockback\r\n# 865A Scythe Tail cast and damage for Shishu Fuko \"get out\"\r\n# 865B Tornado cast and damage for Red Shishu Penghou targeted circle\r\n# 8685 Right Swipe cast and damage for Shishu Yuki right 180 cleave\r\n# 8686 Left Swipe cast and damage for Shishu Yuki left 180 cleave\r\n\r\n\r\n#~~~~~~~~~#\r\n# TRASH 2 #\r\n#~~~~~~~~~#\r\n\r\n# 7A56 --sync-- various auto damage (trash 2)\r\n# 865C Backward Blows cast and self-targeted ability for Shishu Kotengu front->back conals\r\n# 865D Leftward Blows cast and self-targeted ability for Shishu Kotengu front->left conals\r\n# 865E Rightward Blows cast and self-targeted ability for Shishu Kotengu front->right conals\r\n# 865F Blade of the Tengu damage from Shishu Kotengu Blows abilities\r\n# 8660 Wrath of the Tengu cast and damage for Shishu Kotengu raidwide + bleed\r\n# 8661 Gaze of the Tengu cast and ability for lookaway\r\n# 8662 Issen cast and damage for Shishu Onmitsugashira tankbuster\r\n# 8663 Huton cast and self-targeted ability for Shishu Onmitsugashira before multiple shuriken\r\n# 8664 Juji Shuriken cast and damage for Shishu Onmitsugashira line aoe\r\n# 867D Juji Shuriken cast and damage for Shishu Onmitsugashira multiple fast line aoe\r\n# 8687 Mountain Breeze cast and damage from Shishu Yamabiko sprite line aoe\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/another_sildihn_subterrane-savage.ts
// This file was autogenerated from running npm run sync-files.
// DO NOT EDIT THIS FILE DIRECTLY.
// Edit the source file below and then run `npm run sync-files`
// Source: ui/raidboss/data/06-ew/dungeon/another_sildihn_subterrane.ts







// TODO: Gladiator adjustments to timeline
// TODO: Shadowcaster Infern Brand 1 and 4 safe location triggers if possible
// TODO: Shadowcaster adjustments to timeline
const puffWind = 'CE9';
const puffIce = 'CEA';
const puffLightning = 'CEB';
const firstInLine = 'BBC';
const secondInLine = 'BBD';
const dirs = ['N', 'NE', 'E', 'SE', 'S', 'SW', 'W', 'NW'];
const silkieCenterX = -335;
const silkieCenterY = -155;
const positionTo8Dir = (posX, posY, centerX, centerY) => {
  const relX = posX - centerX;
  const relY = posY - centerY;

  // Dirs: N = 0, NE = 1, ..., NW = 7
  return Math.round(4 - 4 * Math.atan2(relX, relY) / Math.PI) % 8;
};
const headingTo4Dir = heading => {
  // Dirs: N = 0, E = 1, S = 2, W = 3
  return (2 - Math.round(heading * 2 / Math.PI)) % 4;
};
const visageMapIdx = (col, row) => row * 4 + col;
const another_sildihn_subterrane_savage_triggerSet = {
  id: 'AnotherSildihnSubterraneSavage',
  zoneId: zone_id/* default.AnotherSildihnSubterraneSavage */.Z.AnotherSildihnSubterraneSavage,
  timelineFile: 'another_sildihn_subterrane-savage.txt',
  initData: () => {
    return {
      puffCounter: 0,
      silkenPuffs: {},
      soapCounter: 0,
      beaterCounter: 0,
      spreeCounter: 0,
      mightCasts: [],
      myVisage: {
        gold: 0,
        silver: 0
      },
      visageMap: {},
      screamOfTheFallen: {},
      arcaneFontCounter: 0,
      brandEffects: {},
      brandCounter: 0,
      flamesCutCounter: 0,
      waveCounter: 0
    };
  },
  triggers: [
  // ---------------- first trash ----------------
  {
    id: 'ASSS Atropine Spore',
    type: 'StartsUsing',
    netRegex: {
      id: '7978',
      source: 'Aqueduct Belladonna',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'ASSS Frond Affront',
    type: 'StartsUsing',
    netRegex: {
      id: '7979',
      source: 'Aqueduct Belladonna',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'ASSS Deracinator',
    type: 'StartsUsing',
    netRegex: {
      id: '797A',
      source: 'Aqueduct Belladonna'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'ASSS Left Sweep',
    type: 'StartsUsing',
    netRegex: {
      id: '797C',
      source: 'Aqueduct Kaluk',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'ASSS Right Sweep',
    type: 'StartsUsing',
    netRegex: {
      id: '797B',
      source: 'Aqueduct Kaluk',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'ASSS Creeping Ivy',
    type: 'StartsUsing',
    netRegex: {
      id: '797D',
      source: 'Aqueduct Kaluk',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'ASSS Honeyed Left',
    type: 'StartsUsing',
    netRegex: {
      id: '7973',
      source: 'Aqueduct Udumbara',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'ASSS Honeyed Right',
    type: 'StartsUsing',
    netRegex: {
      id: '7974',
      source: 'Aqueduct Udumbara',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'ASSS Honeyed Front',
    type: 'StartsUsing',
    netRegex: {
      id: '7975',
      source: 'Aqueduct Udumbara',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'ASSS Arboreal Storm',
    type: 'StartsUsing',
    netRegex: {
      id: '796F',
      source: 'Aqueduct Dryad',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  },
  // ---------------- Silkie ----------------
  {
    id: 'ASSS Soap\'s Up',
    type: 'StartsUsing',
    netRegex: {
      id: '777D',
      source: 'Silkie',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cardinals',
        de: 'Kardinal',
        fr: 'Cardinaux',
        ja: '十字回避',
        cn: '十字',
        ko: '십자방향으로'
      }
    }
  }, {
    id: 'ASSS Dust Bluster',
    type: 'StartsUsing',
    netRegex: {
      id: '778F',
      source: 'Silkie',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'ASSS Fresh Puff Tracker',
    // Use this separate trigger to increment data.puffCounter,
    // since we have multiple triggers to handle different Fresh Puffs
    type: 'StartsUsing',
    netRegex: {
      id: '7789',
      source: 'Silkie',
      capture: false
    },
    run: data => {
      ++data.puffCounter;
      data.silkenPuffs = {};
    }
  }, {
    id: 'ASSS Silken Puff Suds Gain',
    type: 'GainsEffect',
    // Silken Puffs:
    // CE9 Bracing Suds (Wind / Donut)
    // CEA Chilling Suds (Ice / Cardinal)
    // CEB Fizzling Suds (Lightning / Intercardinal)
    netRegex: {
      target: 'Silken Puff',
      effectId: 'CE[9AB]'
    },
    condition: data => data.puffCounter < 4,
    // don't track for Fresh Puff 4
    delaySeconds: 0.2,
    // sometimes a small delay between effects and updated pos data
    promise: async (data, matches) => {
      let puffCombatantData = null;
      puffCombatantData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.targetId, 16)]
      });
      if (puffCombatantData === null) return;
      if (puffCombatantData.combatants.length !== 1) return;
      const puff = puffCombatantData.combatants[0];
      if (!puff) return;
      const puffX = Math.floor(puff.PosX);
      const puffY = Math.floor(puff.PosY);
      const puffLoc = dirs[positionTo8Dir(puffX, puffY, silkieCenterX, silkieCenterY)];
      if (puffLoc === undefined) return;
      data.silkenPuffs[matches.targetId] = {
        effect: matches.effectId,
        location: puffLoc,
        x: puffX,
        y: puffY
      };
    }
  }, {
    id: 'ASSS Silken Puff Suds Lose',
    type: 'LosesEffect',
    // Silken Puffs:
    // CE9 Bracing Suds (Wind / Donut)
    // CEA Chilling Suds (Ice / Cardinal)
    // CEB Fizzling Suds (Lightning / Intercardinal)
    netRegex: {
      target: 'Silken Puff',
      effectId: 'CE[9AB]'
    },
    condition: data => data.puffCounter < 4,
    // don't track for Fresh Puff 4
    run: (data, matches) => delete data.silkenPuffs[matches.targetId]
  }, {
    id: 'ASSS Squeaky Clean Right',
    type: 'StartsUsing',
    netRegex: {
      id: '7774',
      source: 'Silkie',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'ASSS Squeaky Clean Left',
    type: 'StartsUsing',
    netRegex: {
      id: '7775',
      source: 'Silkie',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'ASSS Silkie Suds Gain',
    // Silkie:
    // CE1 Bracing Suds (Wind / Donut)
    // CE2 Chilling Suds (Ice / Cardinal)
    // CE3 Fizzling Suds (Lightning / Intercardinal)
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CE[1-3]',
      target: 'Silkie'
    },
    run: (data, matches) => data.suds = matches.effectId
  }, {
    id: 'ASSS Silkie Suds Lose',
    // Silkie:
    // CE1 Bracing Suds (Wind / Donut)
    // CE2 Chilling Suds (Ice / Cardinal)
    // CE3 Fizzling Suds (Lightning / Intercardinal)
    type: 'LosesEffect',
    netRegex: {
      effectId: 'CE[1-3]',
      target: 'Silkie',
      capture: false
    },
    run: data => delete data.suds
  }, {
    id: 'ASSS Fresh Puff 1',
    // 3 puffs in triangle formation
    type: 'StartsUsing',
    // use 7774/7775 (Squeaky Clean Left/Right), rather than 7789 (Fresh Puff)
    // Squeaky Clean will change the effects of two puffs after the Fresh Puff cast
    // so it is the easiest method to determine mechanic resolution
    netRegex: {
      id: ['7774', '7775'],
      source: 'Silkie'
    },
    condition: data => data.puffCounter === 1,
    delaySeconds: 9,
    // delay alert until after Squeaky Clean Left/Right completes to collect Silken Puff effects
    durationSeconds: 8,
    // keep alert up until just before Slippery Soap trigger fires
    alertText: (data, matches, output) => {
      if (Object.keys(data.silkenPuffs).length !== 3) return output.default();
      const puffsByLoc = {};
      for (const puff of Object.values(data.silkenPuffs)) {
        if (puff.location !== undefined) puffsByLoc[puff.location] = puff.effect;
      }

      // See Silken Puff Suds Gain trigger for list of Silken Puff effectIds
      // By this point, Squeaky Clean Left/Right has changed the N puff and either the SW/SE puff to CE9 (Bracing Suds)
      // We only care about the unaffected puff's status effect (CEA/CEB) for resolving the mechanic.
      let stackDir;
      let safeDir;
      if (matches.id === '7774') {
        // Squeaky Clean Right - resolve based on SW puff's effect
        if (puffsByLoc.SW === undefined) return output.default();
        stackDir = puffsByLoc.SW === puffIce ? 'SE' : 'N'; // if SW is ice, SE stack (unsafe later); if SW is lightning, N stack (unsafe later)
        safeDir = stackDir === 'SE' ? 'N' : 'SE'; // safeDir is the one we are not stacking at
      } else if (matches.id === '7775') {
        // Squeaky Clean Left - resolve based on SE puff's effect
        if (puffsByLoc.SE === undefined) return output.default();
        stackDir = puffsByLoc.SE === puffIce ? 'SW' : 'N'; // if SE is ice, SW stack (unsafe later); if SE is lightning, N stack (unsafe later)
        safeDir = stackDir === 'SW' ? 'N' : 'SW';
      } else {
        return output.default();
      }
      return output.stacksafe({
        dir1: output[stackDir](),
        dir2: output[safeDir]()
      });
    },
    outputStrings: {
      N: outputs/* default.dirN */.Z.dirN,
      SE: outputs/* default.dirSE */.Z.dirSE,
      SW: outputs/* default.dirSW */.Z.dirSW,
      stacksafe: {
        en: 'Stack ${dir1} (${dir2} safe after)',
        de: 'Sammeln ${dir1} (${dir2} danach sicher)',
        fr: 'Package ${dir1} (${dir2} sûr après)',
        ja: '${dir1}で頭割り (あとは${dir2}が安置)',
        cn: '${dir1}集合 (然后${dir2}安全)',
        ko: '${dir1}쪽에서 쉐어 (이후 ${dir2}쪽이 안전)'
      },
      default: {
        en: 'Stack near unsafe green puff',
        de: 'Neben unsicherem grünen Puschel sammeln',
        fr: 'Pack vers le pompon vert non safe',
        ja: '緑の下で頭割り',
        cn: '靠近危险绿球集合',
        ko: '초록색 구슬에서 쉐어'
      }
    }
  }, {
    id: 'ASSS Slippery Soap',
    // Happens 5 times in the encounter
    type: 'Ability',
    // Silkie begins casting Slippery Soap (7781), and at the same time, either Silkie or an invisible actor will use 79FB on a player
    // the 79FB ability appears to correspond to the stack marker on that player, so use that ability id instead
    netRegex: {
      id: '79FB'
    },
    preRun: data => data.soapCounter++,
    alertText: (data, matches, output) => {
      if (data.suds === 'CE1') {
        // Does not happen on first or third Slippery Soap
        if (matches.target === data.me) return output.getBehindPartyKnockback();
        return output.getInFrontOfPlayerKnockback({
          player: data.party.member(matches.target)
        });
      }
      if (matches.target === data.me) {
        if (data.soapCounter === 1) return output.getBehindPuff();
        if (data.soapCounter === 3) return output.getBehindPuffs();
        return output.getBehindParty();
      }
      return output.getInFrontOfPlayer({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      getBehindPuff: {
        en: 'Behind puff and party',
        de: 'Hinter Puschel und Gruppe',
        fr: 'Derrière le pompon et le groupe',
        ja: 'たまの一番後ろへ',
        cn: '站在球和队友后',
        ko: '구슬 뒤로'
      },
      getBehindPuffs: {
        en: 'Behind puffs and party (East/West)',
        de: 'Hinter Puschel und Gruppe (Osten/Westen)',
        fr: 'Derrière les pompons et le groupe (Est/Ouest)',
        ja: 'たまの一番後ろへ (東西)',
        cn: '站在球和队友后 (东/西)',
        ko: '구슬 뒤로 (동/서)'
      },
      getBehindParty: {
        en: 'Behind party',
        de: 'Hinter Gruppe',
        fr: 'Derrière le groupe',
        ja: '一番後ろへ',
        cn: '站在队友后',
        ko: '맨 뒤로'
      },
      getBehindPartyKnockback: {
        en: 'Behind party (Knockback)',
        de: 'Hinter Gruppe (Rückstoß)',
        fr: 'Derrière le groupe (Poussée)',
        ja: 'ノックバック！ 一番後ろへ',
        cn: '站在队友后 (击退)',
        ko: '맨 뒤로 (넉백)'
      },
      getInFrontOfPlayer: {
        en: 'In front of ${player}',
        de: 'Sei vor ${player}',
        fr: 'Devant ${player}',
        ja: '${player}の前へ',
        cn: '站在 ${player} 前',
        ko: '${player} 앞으로'
      },
      getInFrontOfPlayerKnockback: {
        en: 'In front of ${player} (Knockback)',
        de: 'Sei vor ${player} (Rückstoß)',
        fr: 'Devant ${player} (Poussée)',
        ja: 'ノックバック! ${player}の前へ',
        cn: '站在 ${player} 前 (击退)',
        ko: '${player} 앞으로 (넉백)'
      }
    }
  }, {
    id: 'ASSS Slippery Soap with Chilling Suds',
    type: 'StartsUsing',
    netRegex: {
      id: '7781',
      source: 'Silkie'
    },
    condition: data => data.suds === 'CE2',
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 1.5,
    response: responses/* Responses.moveAround */.n3.moveAround()
  }, {
    id: 'ASSS Slippery Soap After',
    type: 'Ability',
    netRegex: {
      id: '7781',
      source: 'Silkie',
      capture: false
    },
    infoText: (data, _matches, output) => {
      switch (data.suds) {
        case 'CE1':
          return output.getUnder();
        case 'CE2':
          return output.intercards();
        case 'CE3':
          return output.spreadCardinals();
      }
    },
    outputStrings: {
      getUnder: outputs/* default.getUnder */.Z.getUnder,
      spreadCardinals: {
        en: 'Spread Cardinals',
        de: 'Kardinal verteilen',
        fr: 'Écartez-vous en cardinal',
        ja: '十字回避 => 散会',
        cn: '十字分散',
        ko: '십자방향으로 산개'
      },
      intercards: {
        en: 'Intercards',
        de: 'Interkardinal',
        fr: 'Intercardinal',
        ja: '斜め',
        cn: '四角',
        ko: '대각선 쪽으로'
      }
    }
  }, {
    id: 'ASSS Carpet Beater',
    type: 'StartsUsing',
    netRegex: {
      id: '7772',
      source: 'Silkie'
    },
    preRun: data => data.beaterCounter++,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        busterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
        busterOnTarget: outputs/* default.tankBusterOnPlayer */.Z.tankBusterOnPlayer,
        busterOnYouPuffs: {
          en: 'Tank Buster on YOU, East/West Between Puffs',
          de: 'Tank Buster auf DIR, Osten/Westen zwischen Puschel',
          fr: 'Tankbuster sur VOUS, entre les pompons Est/Ouest',
          ja: '自分に強攻撃、東西で誘導',
          cn: '死刑点名, 左(西)/右(东) 球下引导',
          ko: '나에게 탱버, 동/서쪽 구슬 사이로'
        }
      };
      if (matches.target === data.me) {
        if (data.beaterCounter === 2) return {
          alertText: output.busterOnYouPuffs()
        };
        return {
          infoText: output.busterOnYou()
        };
      }
      if (data.role !== 'tank' && data.role !== 'healer') return;
      return {
        infoText: output.busterOnTarget({
          player: data.party.member(matches.target)
        })
      };
    }
  }, {
    id: 'ASSS Soaping Spree',
    // Boss does not cast Fizzling Duster with Soaping Spree
    type: 'StartsUsing',
    netRegex: {
      id: '778A',
      source: 'Silkie',
      capture: false
    },
    condition: data => {
      ++data.spreeCounter;
      // skip 2nd and 3rd sprees - those are handled by separate Fresh Puff triggers because safe area can be more nuanced
      return data.spreeCounter !== 2 && data.spreeCounter !== 3;
    },
    infoText: (data, _matches, output) => {
      switch (data.suds) {
        case 'CE1':
          // TODO: does spree 4 need an earlier warning to move the boss away from blue puffs?
          return output.getUnder();
        case 'CE2':
          return output.intercards();
        default:
          if (data.spreeCounter === 1) return output.underPuff();
          return output.avoidPuffs();
      }
    },
    outputStrings: {
      getUnder: outputs/* default.getUnder */.Z.getUnder,
      intercards: {
        en: 'Intercards',
        de: 'Interkardinal',
        fr: 'Intercardinal',
        ja: '斜めへ',
        cn: '四角',
        ko: '대각선 쪽으로'
      },
      underPuff: {
        en: 'Under green puff',
        de: 'Unter grünem Puschel',
        fr: 'Sous le pompon vert',
        ja: '緑に貼り付く',
        cn: '站在绿球下',
        ko: '초록색 구슬 밑으로'
      },
      avoidPuffs: {
        en: 'Avoid puff aoes',
        de: 'Weiche den Puschel AoEs aus',
        fr: 'Évitez les AoE des pompons',
        ja: 'たまからのゆか避けて',
        cn: '躲避球AOE',
        ko: '구슬 장판 피하기'
      }
    }
  }, {
    id: 'ASSS Total Wash',
    type: 'StartsUsing',
    netRegex: {
      id: '7773',
      source: 'Silkie',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'ASSS Fresh Puff 2 Bait',
    // 4 puffs on cardinals or intercardinals with tethers
    type: 'Tether',
    netRegex: {
      source: 'Silken Puff'
    },
    condition: (data, matches) => matches.target === data.me && data.puffCounter === 2,
    durationSeconds: 6,
    alertText: (data, matches, output) => {
      const dirCards = ['N', 'E', 'S', 'W'];
      let silkieStatus = undefined;
      switch (data.suds) {
        case 'CE1':
          // Middle Safe
          silkieStatus = 'bossWind';
          break;
        case 'CE2':
          // Intercards Safe
          silkieStatus = 'bossIce';
        // never CE3 (lightning) for this mechanic
      }

      if (silkieStatus === undefined) return output.default();
      const tetheredPuff = data.silkenPuffs[matches.sourceId];
      if (tetheredPuff === undefined) return;

      // See Silken Puff Suds Gain trigger for list of Silken Puff effectIds
      // Puff must be either CEA (Ice / blue) or CEB (Lightning / yellow) in this mechanic
      const puffEffect = tetheredPuff.effect === puffIce ? 'Blue' : 'Yellow';
      const puffDir = tetheredPuff.location;
      if (puffDir === undefined) return output.default();
      const puffLocs = dirCards.includes(puffDir) ? 'Cardinal' : 'Intercard';
      const baitOutput = `${silkieStatus + puffEffect + puffLocs}Puff`;
      const safeOutput = `${silkieStatus}Puffs${puffLocs}SafeLater`;

      // set the output for the subsequent safe call here and pass the output to the followup trigger
      // this keeps all of the interrelated output strings in this trigger for ease of customization
      data.freshPuff2SafeAlert = output[safeOutput]();
      return output.bait({
        boss: output[silkieStatus](),
        dir: output[puffDir](),
        puff: output[baitOutput]()
      });
    },
    outputStrings: {
      N: outputs/* default.dirN */.Z.dirN,
      E: outputs/* default.dirE */.Z.dirE,
      S: outputs/* default.dirS */.Z.dirS,
      W: outputs/* default.dirW */.Z.dirW,
      NW: outputs/* default.dirNW */.Z.dirNW,
      NE: outputs/* default.dirNE */.Z.dirNE,
      SE: outputs/* default.dirSE */.Z.dirSE,
      SW: outputs/* default.dirSW */.Z.dirSW,
      bait: {
        en: '${boss} - ${dir} ${puff}',
        de: '${boss} - ${dir} ${puff}',
        fr: '${boss} - ${dir} ${puff}',
        ja: '${boss} - ${dir} ${puff}',
        cn: '${boss} - ${dir} ${puff}',
        ko: '${boss} - ${dir} ${puff}'
      },
      bossIce: {
        en: 'Blue Tail',
        de: 'Blauer Schweif',
        fr: 'Queue bleue',
        ja: '青しっぽ',
        cn: '蓝尾巴',
        ko: '파란색 꼬리'
      },
      bossIcePuffsCardinalSafeLater: {
        en: 'Intercard Safe',
        de: 'Interkardinal sicher',
        fr: 'Intercardinal sûr',
        ja: '斜め',
        cn: '四角安全',
        ko: '대각선이 안전'
      },
      bossIcePuffsIntercardSafeLater: {
        en: 'Intercard Safe',
        de: 'Interkardinal sicher',
        fr: 'Intercardinal sûr',
        ja: '斜め',
        cn: '四角安全',
        ko: '대각선이 안전'
      },
      bossWind: {
        en: 'Green Tail',
        de: 'Grüner Schweif',
        fr: 'Queue verte',
        ja: '緑しっぽ',
        cn: '绿尾巴',
        ko: '초록색 꼬리'
      },
      bossWindPuffsCardinalSafeLater: {
        en: 'Middle Safe',
        de: 'Mitte sicher',
        fr: 'Milieu sûr',
        ja: '真ん中',
        cn: '中间安全',
        ko: '가운데가 안전'
      },
      bossWindPuffsIntercardSafeLater: {
        en: 'Middle Safe',
        de: 'Mitte sicher',
        fr: 'Milieu sûr',
        ja: '真ん中',
        cn: '中间安全',
        ko: '가운데가 안전'
      },
      // keep tethered puff info as separate outputStrings
      // so users can customize for their particular strat
      bossIceBlueCardinalPuff: {
        en: 'Blue Puff',
        de: 'Blauer Puschel',
        fr: 'Pompon bleu',
        ja: '青たま',
        cn: '蓝球',
        ko: '파란색 구슬'
      },
      bossIceBlueIntercardPuff: {
        en: 'Blue Puff',
        de: 'Blauer Puschel',
        fr: 'Pompon bleu',
        ja: '青たま',
        cn: '蓝球',
        ko: '파란색 구슬'
      },
      bossIceYellowCardinalPuff: {
        en: 'Yellow Puff',
        de: 'Gelber Puschel',
        fr: 'Pompon jaune',
        ja: '黄色たま',
        cn: '黄球',
        ko: '노란색 구슬'
      },
      bossIceYellowIntercardPuff: {
        en: 'Yellow Puff',
        de: 'Gelber Puschel',
        fr: 'Pompon jaune',
        ja: '黄色たま',
        cn: '黄球',
        ko: '노란색 구슬'
      },
      bossWindBlueCardinalPuff: {
        en: 'Blue Puff',
        de: 'Blauer Puschel',
        fr: 'Pompon bleu',
        ja: '青たま',
        cn: '蓝球',
        ko: '파란색 구슬'
      },
      bossWindBlueIntercardPuff: {
        en: 'Blue Puff',
        de: 'Blauer Puschel',
        fr: 'Pompon bleu',
        ja: '青たま',
        cn: '蓝球',
        ko: '파란색 구슬'
      },
      bossWindYellowCardinalPuff: {
        en: 'Yellow Puff',
        de: 'Gelber Puschel',
        fr: 'Pompon jaune',
        ja: '黄色たま',
        cn: '黄球',
        ko: '노란색 구슬'
      },
      bossWindYellowIntercardPuff: {
        en: 'Yellow Puff',
        de: 'Gelber Puschel',
        fr: 'Pompon jaune',
        ja: '黄色たま',
        cn: '黄球',
        ko: '노란색 구슬'
      },
      default: {
        en: 'Bait puff',
        de: 'Puschel ködern',
        fr: 'Attirez le pompon',
        ja: 'たま誘導',
        cn: '诱导球',
        ko: '구슬 유도'
      }
    }
  }, {
    id: 'ASSS Fresh Puff 2 Safe',
    type: 'Tether',
    netRegex: {
      source: 'Silken Puff'
    },
    condition: (data, matches) => matches.target === data.me && data.puffCounter === 2,
    delaySeconds: 6.5,
    // wait for bait alert to no longer display
    alertText: (data, _matches, output) => {
      if (data.freshPuff2SafeAlert !== undefined) return output.safe({
        safe: data.freshPuff2SafeAlert
      });
      return;
    },
    outputStrings: {
      safe: {
        en: '${safe}',
        de: '${safe}',
        fr: '${safe}',
        ja: '${safe}',
        cn: '${safe}',
        ko: '${safe}'
      }
    }
  }, {
    id: 'ASSS Brim Over',
    type: 'Ability',
    netRegex: {
      id: '7791',
      source: 'Eastern Ewer',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.avoidEwers(),
    outputStrings: {
      avoidEwers: {
        en: 'Avoid Ewers',
        de: 'Krug ausweichen',
        fr: 'Évitez les aiguières',
        ja: '壺確認',
        cn: '躲避水壶',
        ko: '항아리 피하기'
      }
    }
  }, {
    // For Fresh Puff 3, there are eight Silken Puffs in two rows.  Six are then "rinsed" by Eastern Ewers.
    // After suds effects are applied to all eight Silken Puffs, Silkie uses 'Eastern Ewers' (7790),
    // followed by three (existing) Eastern Ewer combatants using 'Brim Over' (7791).
    // ~1.6 seconds later, 3 new 'Eastern Ewer' combatants are added, who begin using 'Rinse' (7792).
    // They repeat using the Rinse ability about ~0.85 seconds as they move N->S through the arena.
    // On three of those recasts, they target the ability on Silken Puffs in their column (same ability ID, 7792):
    // 1st targets the N-most Puff; 2nd targets both Puffs in the column (separate 21 lines for each Puff); and 3rd targets just the S Puff.
    // As each Puff is targeted by a Rinse ability, it loses its Suds effect.
    // This trigger fires off of the first targeted use of 'Rinse'.
    id: 'ASSS Fresh Puff 3',
    type: 'Ability',
    netRegex: {
      id: '7792',
      source: 'Eastern Ewer',
      target: 'Silken Puff',
      capture: false
    },
    delaySeconds: 1.1,
    // wait for the Ewers to 'rinse' the six puffs, leaving 2 with status effects
    durationSeconds: 6,
    // leave alert up while Ewers finish rinsing until Puffs detonate
    suppressSeconds: 2,
    alertText: (data, _matches, output) => {
      if (Object.keys(data.silkenPuffs).length !== 2) return output.default();

      // Green and yellow are very hard to differentiate for some colorblind folks,
      // so give a north/south direction for any green or yellow.
      let dirStr = output.unknown();
      for (const puff of Object.values(data.silkenPuffs)) {
        if (puff.effect === puffWind || puff.effect === puffLightning) {
          dirStr = puff.y < silkieCenterY ? output.northPuff() : output.southPuff();

          // Wind takes precedence (since it can be with lightning)
          if (puff.effect === puffWind) break;
        }
      }

      // sort to simplify switch statement later
      const [puff0, puff1] = Object.values(data.silkenPuffs).map(x => x.effect).sort();

      // See Silken Puff Suds Gain trigger for list of Silken Puff effectIds
      if (puff0 === puffWind && puff1 === puffLightning) return output.windAndLightning({
        dir: dirStr
      });
      if (puff0 === puffIce && puff1 === puffIce) return output.doubleIce();
      if (puff0 === puffIce && puff1 === puffLightning) return output.iceAndLightning({
        dir: dirStr
      });
      if (puff0 === puffLightning && puff1 === puffLightning) return output.doubleLightning();
      return output.default();
    },
    outputStrings: {
      windAndLightning: {
        en: 'Under ${dir} green puff',
        de: 'Unter den grünen Puschel im ${dir}',
        fr: 'Sous le pompon vert ${dir}',
        ja: '緑のたまの下へ: ${dir}',
        cn: '去 ${dir} 绿球下',
        ko: '${dir} 초록색 구슬 밑으로'
      },
      doubleIce: {
        en: 'Intercards, away from puffs',
        de: 'Interkardinal, weg von den Puscheln',
        fr: 'Intercadinal, loin des pompons',
        ja: '斜め、たまから離れる',
        cn: '去四角, 避开球',
        ko: '대각선으로, 구슬에서 떨어지기'
      },
      iceAndLightning: {
        en: 'Sides of ${dir} yellow puff',
        de: 'Seitlich des gelben Puschel im ${dir}',
        fr: 'Côté du pompon jaune ${dir}',
        ja: '緑のたまの横へ: ${dir}',
        cn: '站在 ${dir} 黄球旁',
        ko: '${dir} 노란색 구슬 옆으로'
      },
      doubleLightning: {
        en: 'Between puffs',
        de: 'Zwischen Puscheln',
        fr: 'Entre les pompons',
        ja: 'たまとたまの間',
        cn: '站在球之间',
        ko: '구슬 사이로'
      },
      default: {
        en: 'Avoid puff AOEs',
        de: 'Puschel AoEs vermeiden',
        fr: 'Évitez les AoE des pompons',
        ja: 'たまのゆか回避',
        cn: '躲避球AOE',
        ko: '구슬 장판 피하기'
      },
      northPuff: outputs/* default.north */.Z.north,
      southPuff: outputs/* default.south */.Z.south,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  },
  // ---------------- second trash ----------------
  {
    id: 'ASSS Infernal Pain',
    type: 'StartsUsing',
    netRegex: {
      id: '7981',
      source: 'Sil\'dihn Dullahan',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'ASSS Blighted Gloom',
    type: 'StartsUsing',
    netRegex: {
      id: '797E',
      source: 'Sil\'dihn Dullahan',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'ASSS King\'s Will',
    type: 'StartsUsing',
    netRegex: {
      id: '7980',
      source: 'Sil\'dihn Dullahan',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'big autos',
        de: 'große Auto-Hits',
        fr: 'Grosses attaques auto',
        ja: '自己強化',
        cn: '强化平A',
        ko: '평타 강화'
      }
    }
  }, {
    id: 'ASSS Hells\' Nebula',
    type: 'StartsUsing',
    netRegex: {
      id: '7984',
      source: 'Sil\'dihn Armor',
      capture: false
    },
    condition: data => data.role === 'healer' || data.job === 'BLU',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'HP to 1',
        de: 'HP auf 1',
        fr: 'HP à 1',
        ja: '体力１!',
        cn: 'HP 归 1',
        ko: 'HP 1'
      }
    }
  }, {
    id: 'ASSS Infernal Weight',
    type: 'StartsUsing',
    netRegex: {
      id: '7983',
      source: 'Sil\'dihn Armor',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'aoe + In',
        de: 'AoE + Rein',
        fr: 'AoE + Intérieur',
        ja: 'ヘビィ, 足元へ',
        cn: 'AOE + 去脚下',
        ko: '전체공격 + 안으로'
      }
    }
  }, {
    id: 'ASSS Dominion Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '7982',
      source: 'Sil\'dihn Armor',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  },
  // ---------------- Gladiator of Sil'dih ----------------
  {
    id: 'ASSS Flash of Steel',
    type: 'StartsUsing',
    netRegex: {
      id: '77B3',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'ASSS Rush of Might 1',
    // Boss casts 779E (12.2s) and 779D (10.2s), twice
    // Gladiator of Mirage casts 779B, 779A, 779C, these target the environment
    type: 'StartsUsing',
    netRegex: {
      id: ['779A', '779B', '779C']
    },
    infoText: (data, matches, output) => {
      data.mightCasts.push(matches);
      const [mirage1, mirage2] = data.mightCasts;
      if (data.mightCasts.length !== 2 || mirage1 === undefined || mirage2 === undefined) return;
      data.mightCasts = [];
      const lineMap = {
        '779A': 1,
        '779B': 2,
        '779C': 3
      };
      const [line1, line2] = [mirage1.id, mirage2.id].map(x => lineMap[x]);
      if (line1 === undefined || line2 === undefined) throw new not_reached/* UnreachableCode */.$();
      const centerY = -268;
      const isNorth = parseFloat(mirage1.y) < centerY;
      const is1East = parseFloat(mirage1.x) > parseFloat(mirage2.x);
      const isLine1Left = isNorth && is1East || !isNorth && !is1East;
      const [leftNum, rightNum] = isLine1Left ? [line1, line2] : [line2, line1];

      // Call out the bigger number first, as it's the direction you'll have to move the most.
      if (leftNum === 3 && rightNum === 2) return output.goLeft3Right2();
      if (leftNum === 3 && rightNum === 1) return output.goLeft3Right1();
      if (leftNum === 2 && rightNum === 1) return output.goLeft2Right1();
      if (rightNum === 3 && leftNum === 2) return output.goRight3Left2();
      if (rightNum === 3 && leftNum === 1) return output.goRight3Left1();
      if (rightNum === 2 && leftNum === 1) return output.goRight2Left1();
    },
    outputStrings: {
      goLeft3Right2: {
        en: 'Go 3 Left 2 Right',
        de: 'Gehe Links 3, Rechts 2',
        fr: '3 à gauche, 2 à droite',
        ja: '左: 3, 右: 2',
        cn: '左 3, 右 2',
        ko: '왼쪽3 오른쪽2'
      },
      goLeft3Right1: {
        en: 'Go 3 Left (on line)',
        de: 'Gehe Links 3 (auf der Linie)',
        fr: '3 à gauche (sur la ligne)',
        ja: '左: 3 (線の上)',
        cn: '左 3 (线上)',
        ko: '왼쪽3 (선 위)'
      },
      goLeft2Right1: {
        en: 'Go 2 Left (on line)',
        de: 'Gehe Links 2 (auf der Linie)',
        fr: '2 à gauche (sur la ligne)',
        ja: '左: 2 (線の上)',
        cn: '左 2 (线上)',
        ko: '왼쪽2 (선 위)'
      },
      goRight3Left2: {
        en: 'Go 3 Right 2 Left',
        de: 'Gehe Rechts 3, Links 2',
        fr: '3 à droite, 2 à gauche',
        ja: '右: 3, 左: 2',
        cn: '右 3, 左 2',
        ko: '오른쪽3 왼쪽2'
      },
      goRight3Left1: {
        en: 'Go 3 Right (on line)',
        de: 'Gehe Rechts 3 (auf der Linie)',
        fr: '3 à droite (sur la ligne)',
        ja: '右: 3 (線の上)',
        cn: '右 3 (线上)',
        ko: '오른쪽3 (선 위)'
      },
      goRight2Left1: {
        en: 'Go 2 Right (on line)',
        de: 'Gehe Rechts 2 (auf der Linie)',
        fr: '2 à droite (sur la ligne)',
        ja: '右: 2 (線の上)',
        cn: '右 2 (线上)',
        ko: '오른쪽2 (선 위)'
      }
    }
  }, {
    id: 'ASSS Rush of Might 2',
    type: 'Ability',
    netRegex: {
      id: '779D',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.moveThrough(),
    outputStrings: {
      moveThrough: {
        en: 'Move through',
        de: 'Gehe durch',
        fr: 'Allez à travers',
        ja: '移動',
        cn: '穿穿穿',
        ko: '가로지르기'
      }
    }
  }, {
    id: 'ASSS Sculptor\'s Passion',
    // This is a wild charge, player in front takes most damage
    type: 'Ability',
    netRegex: {
      id: '6854',
      source: 'Gladiator of Sil\'dih'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.chargeOnYou();
      return output.chargeOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      chargeOn: {
        en: 'Charge on ${player}',
        de: 'Ansturm auf ${player}',
        fr: 'Ruée sur ${player}',
        ja: '${player}に突進',
        cn: '直线分摊点${player}',
        ko: '"${player}" 돌진 대상'
      },
      chargeOnYou: {
        en: 'Charge on YOU',
        de: 'Ansturm auf DIR',
        fr: 'Ruée sur VOUS',
        ja: '自分に突進',
        cn: '直线分摊点名',
        ko: '돌진 대상자'
      }
    }
  }, {
    id: 'ASSS Mighty Smite',
    type: 'StartsUsing',
    netRegex: {
      id: '77B4',
      source: 'Gladiator of Sil\'dih'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'ASSS Lingering Echoes',
    // CDC Lingering Echoes (Spread + Move)
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CDC'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: data => data.hasLingering = true,
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 2,
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'ASSS Thunderous Echo Collect',
    // CDD Thunderous Echo (Stack)
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CDD'
    },
    preRun: (data, matches) => data.thunderousEchoPlayer = matches.target
  }, {
    id: 'ASSS Curse of the Fallen',
    // CDA Echoes of the Fallen (Spread)
    // Two players will not have a second debuff, so check CDA
    // 14s = first
    // 17s = second
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CDA'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 0.1,
    durationSeconds: 10,
    infoText: (data, matches, output) => {
      const duration = parseFloat(matches.duration);
      data.isCurseSpreadFirst = duration < 16;
      if (data.isCurseSpreadFirst) {
        if (data.hasLingering) return output.spreadThenBait();
        if (data.me === data.thunderousEchoPlayer) return output.spreadThenStackOnYou();
        if (data.thunderousEchoPlayer === undefined) return output.spreadThenStack();
        return output.spreadThenStackOn({
          player: data.party.member(data.thunderousEchoPlayer)
        });
      }
      if (data.hasLingering) return output.baitThenSpread();
      if (data.me === data.thunderousEchoPlayer) return output.stackOnYouThenSpread();
      if (data.thunderousEchoPlayer === undefined) return output.stackThenSpread();
      return output.stackOnThenSpread({
        player: data.party.member(data.thunderousEchoPlayer)
      });
    },
    outputStrings: {
      stackThenSpread: outputs/* default.stackThenSpread */.Z.stackThenSpread,
      stackOnThenSpread: {
        en: 'Stack on ${player} => Spread',
        de: 'Auf ${player} sammeln => Verteilen',
        fr: 'Package sur ${player} -> Dispersion',
        ja: '${player}に頭割り => 散会',
        cn: '${player}处分摊 => 分散',
        ko: '${player} 쉐어 => 산개'
      },
      stackOnYouThenSpread: {
        en: 'Stack on YOU => Spread',
        de: 'Auf DIR sammeln => Verteilen',
        fr: 'Package sur VOUS -> Dispersion',
        ja: '自分に頭割り => 散会',
        cn: '分摊点名 => 分散',
        ko: '나에게 쉐어 => 산개'
      },
      spreadThenStack: outputs/* default.spreadThenStack */.Z.spreadThenStack,
      spreadThenStackOn: {
        en: 'Spread => Stack on ${player}',
        de: 'Verteilen => Auf ${player} sammeln',
        fr: 'Dispersion -> Package sur ${player}',
        ja: '散会 => ${player}に頭割り',
        cn: '分散 => ${player}处分摊',
        ko: '산개 => ${player} 쉐어'
      },
      spreadThenStackOnYou: {
        en: 'Spread => Stack on YOU',
        de: 'Verteilen => Auf DIR sammeln',
        fr: 'Dispersion -> package sur VOUS',
        ja: '散会 => 自分に頭割り',
        cn: '分散 => 分摊点名',
        ko: '산개 => 나에게 쉐어'
      },
      spreadThenBait: {
        en: 'Spread => Bait Puddle',
        de: 'Veretilen => Fläche ködern',
        fr: 'Dispersion -> Déposez',
        ja: '散会 => AOE誘導',
        cn: '分散 => 诱导AOE',
        ko: '산개 => 장판 유도'
      },
      baitThenSpread: {
        en: 'Bait Puddle => Spread',
        de: 'Fläche ködern => Veretilen',
        fr: 'Déposez -> Dispersion',
        ja: 'AOE誘導 => 散会',
        cn: '诱导AOE => 分散',
        ko: '장판 유도 => 산개'
      }
    }
  }, {
    id: 'ASSS Ring of Might',
    // There are 6 spells:
    //   Ring 1: 779F (9.7s) / 77A2 (11.7s)
    //   Ring 2: 77A0 (9.7s) / 77A3 (11.7s)
    //   Ring 3: 77A1 (9.7s) / 77A4 (11.7s)
    // Only tracking the 11.7s spell
    type: 'StartsUsing',
    netRegex: {
      id: ['77A2', '77A3', '77A4'],
      source: 'Gladiator of Sil\'dih'
    },
    infoText: (_data, matches, output) => {
      if (matches.id === '77A2') return output.outsideInner();
      if (matches.id === '77A3') return output.outsideMiddle();
      return output.outsideOuter();
    },
    outputStrings: {
      outsideInner: {
        en: 'Outside Inner Ring',
        de: 'Außerhalb des inneren Ringes',
        fr: 'À l\'extérieur de l\'anneau intérieur',
        ja: 'リングチャージ１',
        cn: '出内圈',
        ko: '안쪽 고리 바깥'
      },
      outsideMiddle: {
        en: 'Outside Middle Ring',
        de: 'Außerhalb des mittleren Ringes',
        fr: 'À l\'extérieur de l\'anneau central',
        ja: 'リングチャージ２',
        cn: '出中圈',
        ko: '중간 고리 바깥'
      },
      outsideOuter: {
        en: 'Outside Outer Ring',
        de: 'Außerhalb des äußeren Ringes',
        fr: 'À l\'extérieur de l\'anneau extérieur',
        ja: 'リングチャージ３',
        cn: '出外圈',
        ko: '바깥쪽 고리 바깥'
      }
    }
  }, {
    id: 'ASSS Curse of the Fallen Reminder',
    type: 'Ability',
    // Call this when the ring goes off and it's safe to move in.
    netRegex: {
      id: ['77A2', '77A3', '77A4'],
      source: 'Gladiator of Sil\'dih'
    },
    suppressSeconds: 1,
    infoText: (data, matches, output) => {
      if (!data.isCurseSpreadFirst) return output.spread();
      if (data.hasLingering) return output.baitPuddle();
      if (matches.target === data.me) return output.stackOnYou();
      return output.stackOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      // TODO: should this also say "In", e.g. "In + Spread" or "Spread (In)"?
      baitPuddle: {
        en: 'Bait Puddle',
        de: 'Fläche ködern',
        fr: 'Déposez',
        ja: 'AOE誘導',
        cn: '诱导圈圈',
        ko: '장판 유도'
      },
      spread: outputs/* default.spread */.Z.spread,
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'ASSS Nothing beside Remains',
    type: 'StartsUsing',
    netRegex: {
      id: '77BC',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'ASSS Accursed Visage Collect',
    // CDF = Gilded Fate
    // CE0 = Silvered Fate
    type: 'GainsEffect',
    netRegex: {
      effectId: ['CDF', 'CE0']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      const id = matches.effectId;
      if (id === 'CDF') data.myVisage.gold = parseInt(matches.count);else if (id === 'CE0') data.myVisage.silver = parseInt(matches.count);
    }
  }, {
    id: 'ASSS Golden/Silver Flame Collector',
    // 77B1 = Golden Flame
    // 77B2 = Silver Flame
    type: 'StartsUsing',
    netRegex: {
      id: ['77B1', '77B2'],
      source: 'Hateful Visage'
    },
    run: (data, matches) => {
      const x = Math.round(parseFloat(matches.x));
      const y = Math.round(parseFloat(matches.y));

      // These mobs have two faces, gold fires in the direction the mob is facing
      // and silver fires in reverse, so the heading needs to be reversed for silver.
      const isSilver = matches.id === '77B2';
      const heading = (headingTo4Dir(parseFloat(matches.heading)) + (isSilver ? 2 : 0)) % 4;
      const dir = {
        north: 0,
        east: 1,
        south: 2,
        west: 3
      };
      const mark = (col, row) => {
        const visage = data.visageMap[visageMapIdx(col, row)] ??= {
          gold: 0,
          silver: 0
        };
        if (isSilver) visage.silver++;else visage.gold++;
      };

      // Possible values for positions:
      // x: [-50, -40, -35, -30, -20]
      // y: [-286, -276, -271, -266, -256]

      if (x === -35) {
        // vertical
        const row = Math.round((y + 286) / 10);
        if (heading === dir.west) {
          mark(0, row);
          mark(1, row);
        } else if (heading === dir.east) {
          mark(2, row);
          mark(3, row);
        }
      } else if (y === -271) {
        // horizontal
        const col = Math.round((x + 50) / 10);
        if (heading === dir.north) {
          mark(col, 0);
          mark(col, 1);
        } else if (heading === dir.south) {
          mark(col, 2);
          mark(col, 3);
        }
      }
    }
  }, {
    id: 'ASSS Golden/Silver Flame',
    // 77B1 = Golden Flame
    // 77B2 = Silver Flame
    type: 'StartsUsing',
    netRegex: {
      id: ['77B1', '77B2'],
      source: 'Hateful Visage',
      capture: false
    },
    delaySeconds: 0.3,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      // The four inside corners.
      const uptimeIdx = [5, 6, 9, 10];
      const target = {
        gold: data.myVisage.silver,
        silver: data.myVisage.gold
      };
      const targetIsEmpty = target.gold === 0 && target.silver === 0;
      const squares = targetIsEmpty ? uptimeIdx : [...Array(16).keys()];
      let locStr = output.unknown();
      for (const idx of squares) {
        const visage = data.visageMap[idx] ?? {
          gold: 0,
          silver: 0
        };
        if (visage.gold === target.gold && visage.silver === target.silver) {
          locStr = {
            0: output.outsideNW(),
            1: output.outsideNNW(),
            2: output.outsideNNE(),
            3: output.outsideNE(),
            4: output.outsideWNW(),
            5: output.insideNW(),
            6: output.insideNE(),
            7: output.outsideENE(),
            8: output.outsideWSW(),
            9: output.insideSW(),
            10: output.insideSE(),
            11: output.outsideESE(),
            12: output.outsideSW(),
            13: output.outsideSSW(),
            14: output.outsideSSE(),
            15: output.outsideSE()
          }[idx] ?? output.unknown();
          break;
        }
      }
      if (target.silver > 0) {
        if (target.gold > 0) return output.bothFates({
          loc: locStr
        });
        return output.gildedFate({
          loc: locStr
        });
      }
      if (target.gold > 0) return output.silveredFate({
        loc: locStr
      });
      return output.neitherFate({
        loc: locStr
      });
    },
    run: data => data.visageMap = {},
    outputStrings: {
      bothFates: {
        en: 'Get hit by silver and gold (${loc})',
        de: 'Von Silber und Gold treffen lassen (${loc})',
        fr: 'Faites-vous toucher par l\'argent et l\'or (${loc})',
        ja: '金銀 一個ずつ (${loc})',
        cn: '吃金和银 (${loc})',
        ko: '은색 + 금색 맞기 (${loc})'
      },
      gildedFate: {
        en: 'Get hit by two silver (${loc})',
        de: 'Von 2 Silber treffen lassen (${loc})',
        fr: 'Faites-vous toucher par deux argent (${loc})',
        ja: '銀 二つ (${loc})',
        cn: '吃两个银 (${loc})',
        ko: '은색 2개 맞기 (${loc})'
      },
      silveredFate: {
        en: 'Get hit by two gold (${loc})',
        de: 'Von 2 Gold treffen lassen (${loc})',
        fr: 'Faites-vous toucher par deux or (${loc})',
        ja: '金 二つ (${loc})',
        cn: '吃两个金 (${loc})',
        ko: '금색 2개 맞기 (${loc})'
      },
      neitherFate: {
        en: 'Avoid lasers (uptime ${loc})',
        de: 'Vermeide Silber und Gold (${loc})',
        fr: 'Évitez les lasers (${loc})',
        ja: '顔からのビーム全部回避 (${loc})',
        cn: '都不吃 (${loc})',
        ko: '레이저 피하기 (업타임 ${loc})'
      },
      outsideNW: {
        en: 'NW Corner',
        de: 'NW Ecke',
        fr: 'Coin NO',
        ja: '北西 隅',
        cn: '左上 (西北) 角',
        ko: '북서쪽 구석'
      },
      outsideNNW: {
        en: 'NNW Outside',
        de: 'NNW außen',
        fr: 'Extérieur NNO',
        ja: '1列 西の内側',
        cn: '外侧 上偏左 (北偏西)',
        ko: '바깥 북쪽 왼칸'
      },
      outsideNNE: {
        en: 'NNE Outside',
        de: 'NNO außen',
        fr: 'Extérieur NNE',
        ja: '1列 東の内側',
        cn: '外侧 上偏右 (北偏东)',
        ko: '바깥 북쪽 오른칸'
      },
      outsideNE: {
        en: 'NE Corner',
        de: 'NO Ecke',
        fr: 'Coin NE',
        ja: '北東 隅',
        cn: '右上 (东北) 角',
        ko: '북동쪽 구석'
      },
      outsideWNW: {
        en: 'WNW Outside',
        de: 'WNW außen',
        fr: 'Extérieur ONO',
        ja: '2列 西の外側',
        cn: '外侧 左偏上 (西偏北)',
        ko: '바깥 서쪽 위칸'
      },
      insideNW: {
        en: 'NW Inside',
        de: 'NW innen',
        fr: 'Intérieur NO',
        ja: '内側 北西',
        cn: '内侧 左上 (西北)',
        ko: '안 북서쪽'
      },
      insideNE: {
        en: 'NE Inside',
        de: 'NO innen',
        fr: 'Intérieur NE',
        ja: '内側 北東',
        cn: '内侧 右上 (东北)',
        ko: '안 북동쪽'
      },
      outsideENE: {
        en: 'ENE Outside',
        de: 'ONO außen',
        fr: 'Extérieur ENE',
        ja: '2列 東の外側',
        cn: '外侧 右偏上 (东偏北)',
        ko: '바깥 동쪽 위칸'
      },
      outsideWSW: {
        en: 'WSW Outside',
        de: 'WSW außen',
        fr: 'Extérieur OSO',
        ja: '3列 西の外側',
        cn: '外侧 左偏下 (西偏南)',
        ko: '바깥 서쪽 아래칸'
      },
      insideSW: {
        en: 'SW Inside',
        de: 'SW innen',
        fr: 'Intérieur SO',
        ja: '内側 南西',
        cn: '内侧 左下 (西南)',
        ko: '안 남서쪽'
      },
      insideSE: {
        en: 'SE Inside',
        de: 'SO innen',
        fr: 'Intérieur SE',
        ja: '内側 南東',
        cn: '内侧 右下 (东南)',
        ko: '안 남동쪽'
      },
      outsideESE: {
        en: 'ESE Outside',
        de: 'OSO außen',
        fr: 'Extérieur ESE',
        ja: '3列 東の外側',
        cn: '外侧 右偏下 (东偏南)',
        ko: '바깥 동쪽 아래칸'
      },
      outsideSW: {
        en: 'SW Corner',
        de: 'SW Ecke',
        fr: 'Coin SO',
        ja: '南西 隅',
        cn: '左下 (西南) 角',
        ko: '남서쪽 구석'
      },
      outsideSSW: {
        en: 'SSW Outside',
        de: 'SSW außen',
        fr: 'Extérieur SSO',
        ja: '4列 西の内側',
        cn: '外侧 下偏左 (南偏西)',
        ko: '바깥 남쪽 왼칸'
      },
      outsideSSE: {
        en: 'SSE Outside',
        de: 'SSO außen',
        fr: 'Extérieur SSE',
        ja: '4列 東の内側',
        cn: '外侧 下偏右 (南偏东)',
        ko: '바깥 남쪽 오른칸'
      },
      outsideSE: {
        en: 'SE Corner',
        de: 'SO Ecke',
        fr: 'Coin SE',
        ja: '南東 隅',
        cn: '右下 (东南) 角',
        ko: '남동쪽 구석'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'ASSS Sundered Remains',
    // Using 77A8 Curse of the Monument
    type: 'StartsUsing',
    netRegex: {
      id: '77A8',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Middle, Shiva Circles',
        de: 'In die Mitte, Shiva Kreise',
        fr: 'Allez au milieu, cercles de Shiva',
        ja: '真ん中でAOE輪っか確認',
        cn: '中间集合, 九连环',
        ko: '중앙으로, 시바 얼음 장판'
      }
    }
  }, {
    id: 'ASSS Curse of the Monument',
    type: 'Ability',
    netRegex: {
      id: '77A8',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    response: responses/* Responses.breakChains */.n3.breakChains()
  }, {
    id: 'ASSS Scream of the Fallen Collect',
    // CDB = Scream of the Fallen (defamation)
    // BBC = First in Line
    // BBD = Second in Line
    // First/Second in Line are only used once all dungeon so we can just trigger off of them
    type: 'GainsEffect',
    netRegex: {
      effectId: 'BB[CD]'
    },
    run: (data, matches) => data.screamOfTheFallen[matches.target] = matches.effectId
  }, {
    id: 'ASSS Scream of the Fallen',
    // BBC = First in Line
    // BBD = Second in Line
    type: 'GainsEffect',
    netRegex: {
      effectId: 'BB[CD]',
      capture: false
    },
    // These debuffs go out very early while running out for chains,
    // so call as people are dodging into the safe spot.
    delaySeconds: 8,
    durationSeconds: 4,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      const myBuff = data.screamOfTheFallen[data.me];
      if (myBuff === undefined) return;

      // Figure out partner, so that you know if the person running out
      // with you has the same debuff.
      let partner = output.unknown();
      for (const [name, id] of Object.entries(data.screamOfTheFallen)) {
        if (name === data.me) continue;
        if (id === myBuff) {
          partner = data.party.member(name);
          break;
        }
      }
      if (myBuff === firstInLine) return output.spreadFirst({
        player: partner
      });
      return output.soakFirst({
        player: partner
      });
    },
    outputStrings: {
      soakFirst: {
        en: 'Soak First Towers (with ${player})',
        de: 'Steh im ersten Turm (mit ${player})',
        fr: 'Prenez les tours (avec ${player})',
        ja: 'さきに塔を踏み (+${player})',
        cn: '踩 1 塔 (与${player})',
        ko: '첫번째 기둥 밟기 (${player})'
      },
      spreadFirst: {
        en: 'Spread First (with ${player})',
        de: 'Zuerst verteilen (mit ${player})',
        fr: 'Écartez-vous d\'abord (avec ${player})',
        ja: 'さきに散会 (+${player})',
        cn: '先分散 (与${player})',
        ko: '산개 먼저 (${player})'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'ASSS Scream of the Fallen Towers Second',
    type: 'Ability',
    // Triggers off the "Scream of the Fallen" ability from the defamation.
    netRegex: {
      id: '77BA',
      source: 'Gladiator of Sil\'dih'
    },
    condition: (data, matches) => {
      if (data.me !== matches.target) return;
      return data.screamOfTheFallen[data.me] === firstInLine;
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.soakSecond(),
    outputStrings: {
      soakSecond: {
        en: 'Soak Second Towers',
        de: 'Steh im zweiten Turm',
        fr: 'Prenez les 2nd tours',
        ja: '塔を踏み',
        cn: '踩 2 塔',
        ko: '두번째 기둥 밟기'
      }
    }
  }, {
    id: 'ASSS Scream of the Fallen Spread Second',
    type: 'Ability',
    // Triggers off the "Explosion" ability from the towers.
    netRegex: {
      id: '77AC',
      source: 'Gladiator of Sil\'dih'
    },
    condition: (data, matches) => {
      if (data.me !== matches.target) return;
      return data.screamOfTheFallen[data.me] === secondInLine;
    },
    suppressSeconds: 1,
    response: responses/* Responses.spread */.n3.spread()
  },
  // ---------------- Shadowcaster Zeless Gah ----------------
  {
    id: 'ASSS Show of Strength',
    type: 'StartsUsing',
    netRegex: {
      id: '76C5',
      source: 'Shadowcaster Zeless Gah',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'ASSS Firesteel Fracture',
    type: 'StartsUsing',
    netRegex: {
      id: '76C4',
      source: 'Shadowcaster Zeless Gah'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'ASSS Infern Brand Counter',
    type: 'StartsUsing',
    netRegex: {
      id: '7491',
      source: 'Shadowcaster Zeless Gah',
      capture: false
    },
    run: data => {
      data.brandCounter++;
      data.arcaneFontCounter = 0;
    }
  }, {
    id: 'ASSS Arcane Font Tracker',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Arcane Font',
      capture: false
    },
    // Only run this trigger for second Infern Band, first set of portals
    condition: data => data.myFlame === undefined,
    run: data => data.arcaneFontCounter++
  }, {
    id: 'ASSS Infern Brand Collect',
    // Count field on 95D on Infern Brand indicates Brand's number:
    //   1C2 - 1C5, Orange 1 - 4
    //   1C6 - 1C9, Blue 1 - 4
    type: 'GainsEffect',
    netRegex: {
      effectId: '95D',
      target: 'Infern Brand'
    },
    run: (data, matches) => data.brandEffects[parseInt(matches.targetId, 16)] = matches.count
  }, {
    id: 'ASSS Infern Brand 2 Starting Corner',
    // CC4 First Brand
    // CC5 Second Brand
    // CC6 Third Brand
    // CC7 Fourth Brand
    type: 'GainsEffect',
    netRegex: {
      effectId: ['CC4', 'CC5', 'CC6', 'CC7']
    },
    condition: (data, matches) => data.me === matches.target && data.brandCounter === 2,
    delaySeconds: 0.2,
    // Delay to collect all Infern Brand Effects
    durationSeconds: (_data, matches) => parseFloat(matches.duration) - 0.1,
    infoText: (data, matches, output) => {
      const brandMap = {
        'CC4': 1,
        'CC5': 2,
        'CC6': 3,
        'CC7': 4
      };
      const myNum = brandMap[matches.effectId];
      if (myNum === undefined) throw new not_reached/* UnreachableCode */.$();

      // Store for later trigger
      data.myFlame = myNum;
      if (Object.keys(data.brandEffects).length !== 8) {
        // Missing Infern Brands, output number
        if (data.arcaneFontCounter === 3) return output.blueBrandNum({
          num: myNum
        });
        if (data.arcaneFontCounter === 2) return output.orangeBrandNum({
          num: myNum
        });
        return output.brandNum({
          num: myNum
        });
      }

      // Brands are located along East and South wall and in order by id
      // Blue N/S:
      //   304.00, -108.00, Used for NW/NE, 0 north
      //   304.00, -106.00, Used for NW/NE, 1 north
      //   304.00, -104.00, Used for SW/SE, 2 south
      //   304.00, -102.00, Used for SW/SE, 3 south
      // Orange E/W:
      //   286.00, -85.00, Used for SW/NW, 4 west
      //   288.00, -85.00, Used for SW/NW, 5 west
      //   290.00, -85.00, Used for SE/NE, 6 east
      //   292.00, -85.00, Used for SE/NE, 7 east
      // Set brandEffects to descending order to match
      const brandEffects = Object.entries(data.brandEffects).sort((a, b) => a[0] > b[0] ? -1 : 1);

      // Get just the effectIds
      const effectIds = brandEffects.map(value => {
        return value.slice(1, 2)[0];
      });

      // Split the results
      const blueBrands = effectIds.slice(0, 4);
      const orangeBrands = effectIds.slice(4, 8);
      const myNumToBlue = {
        4: '1C9',
        3: '1C8',
        2: '1C7',
        1: '1C6'
      };
      const myNumToOrange = {
        4: '1C5',
        3: '1C4',
        2: '1C3',
        1: '1C2'
      };

      // Find where our numbers are in each set of brands
      const x = orangeBrands.indexOf(myNumToOrange[myNum]);
      const y = blueBrands.indexOf(myNumToBlue[myNum]) + 4;
      const indexToCardinal = {
        0: 'south',
        1: 'south',
        2: 'north',
        3: 'north',
        4: 'east',
        5: 'east',
        6: 'west',
        7: 'west'
      };
      const cardX = indexToCardinal[x];
      const cardY = indexToCardinal[y];

      // Not able to be undefined as values determined from array that only has 8 indices
      if (cardX === undefined || cardY === undefined) throw new not_reached/* UnreachableCode */.$();

      // Check color of brand that will be cut
      if (data.arcaneFontCounter === 3) return output.blueBrandNumCorner({
        num: myNum,
        corner: output[cardX + cardY]()
      });
      if (data.arcaneFontCounter === 2) return output.orangeBrandNumCorner({
        num: myNum,
        corner: output[cardX + cardY]()
      });
      return output.brandNumCorner({
        num: myNum,
        corner: output[cardX + cardY]()
      });
    },
    run: data => data.brandEffects = {},
    outputStrings: {
      blueBrandNumCorner: {
        en: 'Blue Brand ${num}: ${corner} corner',
        de: 'Blaues Kryptogramm ${num}: ${corner} Ecke',
        fr: 'Étendard bleu ${num}: coin ${corner}',
        ja: '青線${num}: ${corner}の隅',
        cn: '蓝线${num}: ${corner}角',
        ko: '파란색 선 ${num}: ${corner} 구석'
      },
      orangeBrandNumCorner: {
        en: 'Orange Brand ${num}: ${corner} corner',
        de: 'Oranges Kryptogramm ${num}: ${corner} Ecke',
        fr: 'Étendard orange ${num}: coin ${corner}',
        ja: '赤線${num}: ${corner}の隅',
        cn: '红线${num}: ${corner}角',
        ko: '주황색 선 ${num}: ${corner} 구석'
      },
      brandNumCorner: {
        en: 'Brand ${num}: ${corner} corner',
        de: 'Kryptogramm ${num}: ${corner} Ecke',
        fr: 'Étendard ${num}: coin ${corner}',
        ja: '線${num}: ${corner}の隅',
        cn: '线${num}: ${corner}角',
        ko: '선 ${num}: ${corner} 구석'
      },
      blueBrandNum: {
        en: 'Blue Brand ${num}',
        de: 'Blaues Kryptogramm ${num}',
        fr: 'Étendard bleu ${num}',
        ja: '青線${num}',
        cn: '蓝线${num}',
        ko: '파란색 선 ${num}'
      },
      orangeBrandNum: {
        en: 'Orange Brand ${num}',
        de: 'Oranges Kryptogramm ${num}',
        fr: 'Étendard orange ${num}',
        ja: '赤線${num}',
        cn: '红线${num}',
        ko: '주황색 선 ${num}'
      },
      brandNum: {
        en: 'Brand ${num}',
        de: 'Kryptogramm ${num}',
        fr: 'Étendard ${num}',
        ja: '線${num}',
        cn: '线${num}',
        ko: '선 ${num}'
      },
      northwest: outputs/* default.northwest */.Z.northwest,
      northeast: outputs/* default.northeast */.Z.northeast,
      southeast: outputs/* default.southeast */.Z.southeast,
      southwest: outputs/* default.southwest */.Z.southwest
    }
  }, {
    id: 'ASSS Infern Brand 2 First Flame',
    // CC8 First Flame
    // CC9 Second Flame
    // CCA Third Flame
    // CCB Fourth Flame
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CC8'
    },
    condition: (data, matches) => data.me === matches.target && data.brandCounter === 2,
    alertText: (data, _matches, output) => {
      // Blue lines cut when three (West)
      if (data.arcaneFontCounter === 3) {
        // Set to two for 5th cut's color
        data.arcaneFontCounter = 2;
        return output.cutBlueOne();
      }

      // Orange lines cut when two (North)
      if (data.arcaneFontCounter === 2) {
        // Set to three for 5th cut's color
        data.arcaneFontCounter = 3;
        return output.cutOrangeOne();
      }
      return output.firstCut();
    },
    outputStrings: {
      cutBlueOne: {
        en: 'Cut Blue 1',
        de: 'Blau 1 durchtrennen',
        fr: 'Coupez Bleu 1',
        ja: '青線1 切る',
        cn: '剪蓝线 1',
        ko: '파란색 1 끊기'
      },
      cutOrangeOne: {
        en: 'Cut Orange 1',
        de: 'Orange 1 durchtrennen',
        fr: 'Coupez Orange 1',
        ja: '赤線1 切る',
        cn: '剪红线 1',
        ko: '주황색 1 끊기'
      },
      firstCut: {
        en: 'First Cut',
        de: 'Als Erster durchtrennen',
        fr: 'Coupe en 1er',
        ja: '線1 切る',
        cn: '剪线 1',
        ko: '첫번째 선 끊기'
      }
    }
  }, {
    id: 'ASSS Infern Brand 2 Remaining Flames',
    // Player receives Magic Vulnerability Up from Cryptic Flame for 7.96s after cutting
    // Trigger will delay for this Magic Vulnerability Up for safety
    // No exception for time remaining on debuff to sacrafice to cut the line
    type: 'LosesEffect',
    netRegex: {
      effectId: '95D',
      target: 'Infern Brand',
      count: '1C[2-9]'
    },
    condition: (data, matches) => {
      if (data.myFlame !== undefined && data.brandCounter === 2) {
        const countToNum = {
          '1C9': 4,
          '1C8': 3,
          '1C7': 2,
          '1C6': 1,
          '1C5': 4,
          '1C4': 3,
          '1C3': 2,
          '1C2': 1
        };

        // Check which flame order this is
        const flameCut = countToNum[matches.count];
        if (flameCut === undefined) return false;

        // Wraparound and add 1 as we need next flame to cut
        // Check if not our turn to cut
        if (flameCut % 4 + 1 !== data.myFlame) return false;
        return true;
      }
      return false;
    },
    delaySeconds: (data, matches) => {
      if (data.myLastCut === undefined) return 0;

      // Check if we still need to delay for Magic Vulnerability Up to expire
      // Magic Vulnerability Up lasts 7.96 from last cut
      const delay = 7.96 - (Date.parse(matches.timestamp) - data.myLastCut) / 1000;
      if (delay > 0) return delay;
      return 0;
    },
    alertText: (data, matches, output) => {
      if (data.arcaneFontCounter === 3 && matches.count.match(/1C[6-8]/)) {
        // Expected Blue and count is Blue
        data.arcaneFontCounter = 2;
        return output.cutBlueNum({
          num: data.myFlame
        });
      }
      if (data.arcaneFontCounter === 2 && matches.count.match(/1C[2-4]/)) {
        // Expected Orange and count is Orange
        data.arcaneFontCounter = 3;
        return output.cutOrangeNum({
          num: data.myFlame
        });
      }

      // Exception for First Flame on second set
      if (data.myFlame === 1) {
        if (data.arcaneFontCounter === 3 && matches.count === '1C5') return output.cutBlueNum({
          num: data.myFlame
        });
        if (data.arcaneFontCounter === 2 && matches.count === '1C9') return output.cutOrangeNum({
          num: data.myFlame
        });
      }
      // Unexpected result, mechanic is likely failed at this point
    },

    run: data => data.brandEffects = {},
    outputStrings: {
      cutOrangeNum: {
        en: 'Cut Orange ${num}',
        de: 'Orange ${num} durchtrennen',
        fr: 'Coupez Orange ${num}',
        ja: '赤線${num} 切る',
        cn: '剪红线 ${num}',
        ko: '주황색 ${num} 끊기'
      },
      cutBlueNum: {
        en: 'Cut Blue ${num}',
        de: 'Blau ${num} durchtrennen',
        fr: 'Coupez Bleu ${num}',
        ja: '青線${num} 切る',
        cn: '剪蓝线 ${num}',
        ko: '파란색 ${num} 끊기'
      }
    }
  }, {
    id: 'ASSS Infern Brand Cryptic Flame Collect',
    // Collect timestamp for when last cut flame
    type: 'Ability',
    netRegex: {
      id: '76CA',
      source: 'Infern Brand'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => data.myLastCut = Date.parse(matches.timestamp)
  }, {
    id: 'ASSS Banishment',
    // Players receive invisible effect that indicates rotation and direction
    // of their teleport attached teleport pad
    //
    // At the same time, two teleports on North and South are also marked:
    // one rotates outside the arena, the other rotates towards the inner rows
    // Players have 12s to teleport using the safe teleports prior to Call of
    // the Portal (CCC) expiration
    //
    // The first teleports occur at ~11.4s after these debuff go out
    // After first teleport, lasers block rows but can be teleported over
    // Hitting a laser results in stun and likely death
    //
    // Seconds after first teleport, two wards will go off that target the
    // two nearest players. Players need to have teleported close enough
    // to the ward to bait the ward away from other players
    //
    // Following the first set of baits, the player's teleport will go off
    // which should have been positioned to teleport across the laser to bait
    // the final ward away from other players
    //
    // 1CD Blue (Counterclockwise) Teleporting East
    // 1CE Orange (Clockwise) Teleporting West
    // 1D2 Orange (Clockwise) Teleporting East
    // 1D3 Blue (Counterclockwise) Teleporting West
    //
    // There are multiple strategies, so this only describes what you have,
    // from there you can create a personal call of where to go
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, matches, output) => {
      switch (matches.count) {
        case '1CD':
          return output.blueEast();
        case '1CE':
          return output.orangeWest();
        case '1D2':
          return output.orangeEast();
        case '1D3':
          return output.blueWest();
      }
    },
    outputStrings: {
      blueEast: {
        en: 'Blue Teleporting East',
        de: 'Blau Teleport nach Osten',
        fr: 'Téléportation du bleu à l\'Est',
        ja: '3列',
        cn: '第 3 行',
        ko: '파란색 동쪽 텔레포트'
      },
      blueWest: {
        en: 'Blue Teleporting West',
        de: 'Blau Teleport nach Westen',
        fr: 'Téléportation du bleu à l\'Ouest',
        ja: '4列',
        cn: '第 4 行',
        ko: '파란색 서쪽 텔레포트'
      },
      orangeEast: {
        en: 'Orange Teleporting East',
        de: 'Orange Teleport nach Osten',
        fr: 'Téléportation de l\'orange à l\'Est',
        ja: '2列',
        cn: '第 2 行',
        ko: '주황색 동쪽 텔레포트'
      },
      orangeWest: {
        en: 'Orange Teleporting West',
        de: 'Orange Teleport nach Westen',
        fr: 'Téléportation de l\'orange à l\'Ouest',
        ja: '1列',
        cn: '第 1 行',
        ko: '주황색 서쪽 텔레포트'
      }
    }
  }, {
    id: 'ASSS Banishment First Ward',
    // This debuff expires 4.7s before the first bait, but there is a slight
    // animation lock from the teleport that occurs
    // Repositioning may be required to bait the active ward's Infern Wave
    // Using Call of the Portal (CCC) expiration for trigger
    type: 'LosesEffect',
    netRegex: {
      effectId: 'CCC'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 0.75,
    // Delay for animation lock from teleport to complete
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait First Ward',
        de: 'Köder erste Wehr',
        fr: 'Attirez la 1ère barrière',
        ja: '1番目の扇誘導',
        cn: '诱导第 1 次扇形',
        ko: '첫번째 지팡이 유도하기'
      }
    }
  }, {
    id: 'ASSS Banishment Bait Second Ward',
    // After the second teleport and stun expiring, there is 2s before the
    // the last ward casts Infern Wave that must be baited
    // Rite of Passage (CCD) debuff is tied to the player's teleport going
    // off
    type: 'LosesEffect',
    netRegex: {
      effectId: 'CCD'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 2,
    // Delay for stun to complete
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Second Ward',
        de: 'Köder zweite Wehr',
        fr: 'Attirez la 2ème barrière',
        ja: '2番目の扇誘導',
        cn: '诱导第 2 次扇形',
        ko: '두번째 지팡이 유도하기'
      }
    }
  }, {
    id: 'ASSS Infern Brand 5 Starting Position',
    // CC4 First Brand
    // CC5 Second Brand
    // CC6 Third Brand
    // CC7 Fourth Brand
    // Although we can see where the 4 wards spawn, Does not seem to be a way
    // to determine which one is animated which is required to tell which color
    // to cut
    type: 'GainsEffect',
    netRegex: {
      effectId: ['CC4', 'CC5', 'CC6', 'CC7']
    },
    condition: (data, matches) => data.me === matches.target && data.brandCounter === 5,
    delaySeconds: 0.1,
    infoText: (data, matches, output) => {
      const brandMap = {
        'CC4': 1,
        'CC5': 2,
        'CC6': 3,
        'CC7': 4
      };
      const myNum = brandMap[matches.effectId];
      if (myNum === undefined) throw new not_reached/* UnreachableCode */.$();

      // Store for later trigger
      data.myFlame = myNum;

      // In Infern Brand 5, there are 4 wards in a + and blocked by 2 lines each
      // This creates an opening in middle where First Brand + Second Brand
      // while Third Brand and Fourth Brand need to bait the first ward
      // Blue N/S:
      //   (304.00, -110.00)
      //   (304.00, -108.00)
      //
      //   (304.00, -102.00)
      //   (304.00, -100.00)
      // Orange E/W:
      //   (284.00, -85.00)
      //   (286.00, -85.00)
      //
      //   (292.00, -85.00)
      //   (294.00, -85.00)

      // Generic output unless we find a method to determine which way to cut
      if (myNum === 1 || myNum === 2) return output.middle({
        num: myNum
      });
      return output.outThenBait({
        num: myNum
      });
    },
    run: data => data.brandEffects = {},
    outputStrings: {
      middle: {
        en: 'Brand ${num}: Get Middle',
        de: 'Kryptogramm ${num}: Geh in die Mitte',
        fr: 'Étendard ${num} : Au centre',
        ja: '線${num}: 真ん中へ',
        cn: '线${num}: 去中间',
        ko: '선 ${num}: 중앙으로'
      },
      outThenBait: {
        en: 'Brand ${num}: Out, Bait Ward',
        de: 'Kryptogramm ${num}: Wehr ködern',
        fr: 'Étendard ${num} : Extérieur, Attirez la barrière',
        ja: '線${num}: 外側へ/扇誘導',
        cn: '线${num}: 诱导扇形',
        ko: '선 ${num}: 밖으로, 지팡이 유도'
      }
    }
  }, {
    id: 'ASSS Infern Brand 5 First Flame',
    // CC8 First Flame
    // CC9 Second Flame
    // CCA Third Flame
    // CCB Fourth Flame
    // Until we find a way to determine color, call cut order only
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CC8'
    },
    condition: (data, matches) => data.me === matches.target && data.brandCounter === 5,
    alertText: (_data, _matches, output) => output.firstCut(),
    outputStrings: {
      firstCut: {
        en: 'First Cut',
        de: 'Als Erster durchtrennen',
        fr: '1ère coupe',
        ja: '1番目の線切る',
        cn: '剪线 1',
        ko: '첫번째 선 끊기'
      }
    }
  }, {
    id: 'ASSS Infern Brand 5 Infern Wave Counter',
    type: 'Ability',
    netRegex: {
      id: '76CD',
      source: 'Infern Brand',
      capture: false
    },
    condition: data => data.brandCounter === 5,
    preRun: data => data.waveCounter++,
    suppressSeconds: 1
  }, {
    id: 'ASSS Infern Brand 5 Cuts after Baits',
    // Utilizing 1.96s Magic Vulnerability Up (B7D) from Infern Wave to tell
    // when to start cutting after baiting the Infern Ward
    // Vulnerability expires after Pure Fire (749F) puddles, so no need to
    // add additional delay for the puddle
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B7D'
    },
    condition: (data, matches) => {
      const duration = parseFloat(matches.duration);
      return data.me === matches.target && data.brandCounter === 5 && duration <= 2;
    },
    delaySeconds: (_data, matches) => parseFloat(matches.duration),
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        cutOrangeNum: {
          en: 'Cut Orange ${num}',
          de: 'Orange ${num} durchtrennen',
          fr: 'Coupez Orange ${num}',
          ja: '赤線${num} 切る',
          cn: '剪红线 ${num}',
          ko: '주황색 ${num} 끊기'
        },
        cutBlueNum: {
          en: 'Cut Blue ${num}',
          de: 'Blau ${num} durchtrennen',
          fr: 'Coupez Bleu ${num}',
          ja: '青線${num} 切る',
          cn: '剪蓝线 ${num}',
          ko: '파란색 ${num} 끊기'
        },
        moveOrange: {
          en: 'Move for Orange ${num}',
          de: 'Bewegen für Orange ${num}',
          fr: 'Bougez pour l\'orange ${num}',
          ja: 'まもなく赤線${num}',
          cn: '去红线 ${num}',
          ko: '주황색 ${num} 끊을 준비'
        },
        moveBlue: {
          en: 'Move for Blue ${num}',
          de: 'Bewegen für Blau ${num}',
          fr: 'Bougez pour le bleu ${num}',
          ja: 'まもなく青線${num}',
          cn: '去蓝线 ${num}',
          ko: '파란색 ${num} 끊을 준비'
        }
      };

      // Check for race condition with Second Flame after first bait
      // or that it is the third bait that has no race
      if (data.waveCounter === 1 && data.flamesCutCounter === 1 || data.waveCounter === 3) {
        // Third and Fourth Flames need to move to cut across immediately after baiting
        // Three can cut their flame if they have baited and 2 has cut
        if (data.myFlame === 3) {
          if (data.firstColorCut === 'blue') return {
            alertText: output.cutBlueNum({
              num: data.myFlame
            })
          };
          return {
            alertText: output.cutOrangeNum({
              num: data.myFlame
            })
          };
        }
        if (data.myFlame === 4) {
          if (data.firstColorCut === 'blue') return {
            infoText: output.moveBlue({
              num: data.myFlame
            })
          };
          return {
            infoText: output.moveOrange({
              num: data.myFlame
            })
          };
        }
      }

      // First Flame needs to cut after the second bait
      if (data.waveCounter === 2 && data.myFlame === 1) {
        if (data.firstColorCut === 'orange') return {
          alertText: output.cutOrangeNum({
            num: data.myFlame
          })
        };
        return {
          alertText: output.cutBlueNum({
            num: data.myFlame
          })
        };
      }
    }
  }, {
    id: 'ASSS Infern Brand 5 Remaining Flames',
    type: 'LosesEffect',
    netRegex: {
      effectId: '95D',
      target: 'Infern Brand',
      count: '1C[2-9]'
    },
    condition: data => data.brandCounter === 5,
    preRun: (data, matches) => {
      data.flamesCutCounter++;
      // First and last of a set let us know what's being cut next
      if (data.flamesCutCounter === 1) {
        if (matches.count === '1C2') data.firstColorCut = 'orange';else if (matches.count === '1C6') data.firstColorCut = 'blue';
      } else if (data.flamesCutCounter === 4) {
        data.firstColorCut = data.firstColorCut === 'orange' ? 'blue' : 'orange';
      }
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        baitWardTwo: {
          en: 'Bait Ward 2 => Bait Puddles',
          de: 'Köder Wehr 2 => Köder Flächen',
          fr: 'Attirez barrière 2 -> Attirez les puddles',
          ja: '扇２ => AOE誘導',
          cn: '诱导扇形 2 => 诱导圈圈',
          ko: '지팡이 2 유도 => 장판 유도'
        },
        baitWardThree: {
          en: 'Bait Ward 3',
          de: 'Köder Wehr 3',
          fr: 'Attirez barrière 3',
          ja: '扇３',
          cn: '诱导扇形 3',
          ko: '지팡이 3 유도'
        },
        baitPuddles: {
          en: 'Bait Puddles',
          de: 'Köder Flächen',
          fr: 'Attirez les puddles',
          ja: 'AOE誘導',
          cn: '诱导圈圈',
          ko: '장판 유도'
        },
        cutOrangeNum: {
          en: 'Cut Orange ${num}',
          de: 'Orange ${num} durchtrennen',
          fr: 'Coupez Orange ${num}',
          ja: '赤線${num} 切る',
          cn: '剪红线 ${num}',
          ko: '주황색 ${num} 끊기'
        },
        cutBlueNum: {
          en: 'Cut Blue ${num}',
          de: 'Blau ${num} durchtrennen',
          fr: 'Coupez Bleu ${num}',
          ja: '青線${num} 切る',
          cn: '剪蓝线 ${num}',
          ko: '파란색 ${num} 끊기'
        },
        moveOrangeNum: {
          en: 'Move for Orange ${num}',
          de: 'Bewegen für Orange ${num}',
          fr: 'Bougez pour l\'orange ${num}',
          ja: 'まもなく赤線${num}',
          cn: '去红线 ${num}',
          ko: '주황색 ${num} 끊을 준비'
        },
        moveBlueNum: {
          en: 'Move for Blue ${num}',
          de: 'Bewegen für Blau ${num}',
          fr: 'Bougez pour le bleu ${num}',
          ja: 'まもなく青線${num}',
          cn: '去蓝线 ${num}',
          ko: '파란색 ${num} 끊을 준비'
        }
      };

      // Two can cut immediately after one
      if (data.myFlame === 2 && (data.flamesCutCounter === 1 || data.flamesCutCounter === 6)) {
        if (data.firstColorCut === 'blue') return {
          alertText: output.cutBlueNum({
            num: data.myFlame
          })
        };
        return {
          alertText: output.cutOrangeNum({
            num: data.myFlame
          })
        };
      }

      // Three can cut if they have baited their wave and two has cut
      if (data.myFlame === 3 && data.flamesCutCounter === 2 && data.waveCounter === 1) {
        if (data.firstColorCut === 'blue') return {
          alertText: output.cutBlueNum({
            num: data.myFlame
          })
        };
        return {
          alertText: output.cutOrangeNum({
            num: data.myFlame
          })
        };
      }
      // Four can follow three after they have baited and two has cut
      if (data.myFlame === 4 && data.flamesCutCounter === 2 && data.waveCounter === 1) {
        if (data.firstColorCut === 'blue') return {
          infoText: output.moveBlueNum({
            num: data.myFlame
          })
        };
        return {
          infoText: output.moveOrangeNum({
            num: data.myFlame
          })
        };
      }

      // Four can cut immediately after three
      if (data.myFlame === 4 && (data.flamesCutCounter === 3 || data.flamesCutCounter === 7)) {
        if (data.firstColorCut === 'blue') return {
          alertText: output.cutBlueNum({
            num: data.myFlame
          })
        };
        return {
          alertText: output.cutOrangeNum({
            num: data.myFlame
          })
        };
      }

      // Fourth Flame should open path for One and Two to bait second ward
      if (data.flamesCutCounter === 4) {
        if (data.myFlame === 1 || data.myFlame === 2) return {
          alertText: output.baitWardTwo()
        };
        return {
          infoText: output.baitPuddles()
        };
      }

      // Sixth Flame should open path for Three and Four to bait third ward
      if (data.flamesCutCounter === 6 && (data.myFlame === 3 || data.myFlame === 4)) return {
        alertText: output.baitWardThree()
      };
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      '(?<!/ )Chilling Duster / Fizzling Duster': 'Chilling/Fizzling Duster',
      'Bracing Duster / Chilling Duster / Fizzling Duster': 'Duster',
      'Bracing Duster / Chilling Duster(?! )': 'Bracing/Chilling Duster',
      'Bracing Duster / Fizzling Duster': 'Bracing/Fizzling Duster',
      'Bracing Suds / Chilling Suds / Fizzling Suds': 'Suds',
      'Bracing Suds / Chilling Suds(?! )': 'Bracing/Chilling Suds',
      'Bracing Suds / Fizzling Suds': 'Bracing/Fizzling Suds'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Aqueduct Belladonna': 'Aquädukt-Belladonna',
      'Aqueduct Dryad': 'Aquädukt-Dryade',
      'Aqueduct Kaluk': 'Aquädukt-Kaluk',
      'Aqueduct Udumbara': 'Aquädukt-Udumbara',
      'Arcane Font': 'arkan(?:e|er|es|en) Tafel',
      'Ball of Fire': 'Feuerball',
      'Eastern Ewer': 'Waschkrug',
      'Gladiator of Sil\'dih': 'Gladiator von Sil\'dih',
      'Hateful Visage': 'Hassendes Haupt',
      'Infern Brand': 'Infernales Mal',
      'Shadowcaster Zeless Gah': 'Schattenwirker Zeless Gah',
      'Sil\'dihn Armor': 'Sil\'dih-Kampfmaschine',
      'Sil\'dihn Dullahan': 'Sil\'dih-Dullahan',
      'Silken Puff': 'weich(?:e|er|es|en) Puschel',
      'Silkie': 'Silkie',
      'The Trial of Balance': 'Prüfung der Gerechtigkeit',
      'The Trial of Knowledge': 'Prüfung der Weisheit',
      'The Trial of Might': 'Prüfung der Macht'
    },
    'replaceText': {
      'Accursed Visage': 'Verdammtes Haupt',
      'Banishment': 'Verbannung',
      'Blazing Benifice': 'Heiliger Feuereifer',
      'Blessed Beacon': 'Himmelsfeuer',
      'Bracing Duster': 'Spritziger Wedel',
      'Bracing Suds': 'Spritziger Schaum',
      'Burn': 'Verbrennung',
      'Carpet Beater': 'Teppichklopfer',
      'Cast Shadow': 'Schattenfall',
      'Chilling Duster': 'Kalter Wedel',
      'Chilling Suds': 'Kalter Schaum',
      'Colossal Wreck': 'Riesig Trümmerbild',
      'Cryptic Flames': 'Kryptische Flammen',
      'Cryptic Portal': 'Kryptisches Portal',
      'Curse of the Fallen': 'Fluch des Zerfallenen',
      'Curse of the Monument': 'Fluch des Denkmals',
      'Dust Bluster': 'Staubbläser',
      'Eastern Ewers': 'Waschkrug',
      'Echo of the Fallen': 'Fluch des Äons',
      'Explosion': 'Explosion',
      'Firesteel Fracture': 'Feuerstahl-Brecher',
      'Firesteel Strike': 'Feuerstahl-Schlag',
      'Fizzling Duster': 'Prickelnder Wedel',
      'Fizzling Suds': 'Prickelnder Schaum',
      'Flash of Steel': 'Blitzender Stahl',
      'Fresh Puff': 'Frischer Puschel',
      'Gold Flame': 'Goldene Flamme',
      'Hateful Visage': 'Hassendes Haupt',
      'Infern Brand': 'Infernales Mal',
      'Infern Ward': 'Infernale Wehr',
      'Infern Wave': 'Infernale Welle',
      'Mighty Smite': 'Mächtiger Streich',
      'Nothing beside Remains': 'Nichts weiter blieb',
      'Puff and Tumble': 'Puschelputz',
      'Pure Fire': 'Reines Feuer',
      'Rinse': 'Spülung',
      'Rush of Might': 'Rausch der Macht',
      'Scream of the Fallen': 'Fluch der Ewigkeit',
      'Sculptor\'s Passion': 'Bildners Hohn',
      'Show of Strength': 'Kraftakt',
      'Silver Flame': 'Silberne Flamme',
      'Slippery Soap': 'Schmierige Seife',
      'Soap\'s Up': 'Einseifen',
      'Soaping Spree': 'Seifentaumel',
      'Specter of Might': 'Schemen der Macht',
      'Squeaky Clean': 'Blitzeblank',
      'Sundered Remains': 'Tote Trümmer',
      'Total Wash': 'Vollwäsche',
      'Wrath of Ruin': 'Düster Zorn'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aqueduct Belladonna': 'belladone des aqueducs',
      'Aqueduct Dryad': 'dryade des aqueducs',
      'Aqueduct Kaluk': 'kaluk des aqueducs',
      'Aqueduct Udumbara': 'udumbara des aqueducs',
      'Arcane Font': 'sphère arcanique',
      'Ball of Fire': 'Boule de flammes',
      'Eastern Ewer': 'cruche orientale',
      'Gladiator of Sil\'dih': 'gladiateur sildien',
      'Hateful Visage': 'Effigie maudite',
      'Infern Brand': 'Étendard sacré',
      'Shadowcaster Zeless Gah': 'Zeless Gah la Flamme ombrée',
      'Sil\'dihn Armor': 'armure maléfique sildien',
      'Sil\'dihn Dullahan': 'dullahan sildien',
      'Silken Puff': 'pompon de Silkie',
      'Silkie': 'Silkie',
      'The Trial of Balance': 'Épreuve de la Justice',
      'The Trial of Knowledge': 'Épreuve de la Sagesse',
      'The Trial of Might': 'Épreuve de la Puissance'
    },
    'replaceText': {
      'Accursed Visage': 'Visage d\'exécration',
      'Banishment': 'Bannissement',
      'Blazing Benifice': 'Canon des flammes sacrées',
      'Blessed Beacon': 'Flamme sacrée céleste',
      'Bracing Duster': 'Plumeau tonifiant',
      'Bracing Suds': 'Mousse tonifiante',
      'Burn': 'Combustion',
      'Carpet Beater': 'Tapette à tapis',
      'Cast Shadow': 'Ombre crépitante',
      'Chilling Duster': 'Plumeau givré',
      'Chilling Suds': 'Mousse givrée',
      'Colossal Wreck': 'Ruine colossale',
      'Cryptic Flames': 'Flammes cryptiques',
      'Cryptic Portal': 'Portail cryptique',
      'Curse of the Fallen': 'Malédiction hurlante',
      'Curse of the Monument': 'Malédiction monumentale',
      'Dust Bluster': 'Dépoussiérage',
      'Eastern Ewers': 'Aiguière aqueuse',
      'Echo of the Fallen': 'Écho déchu',
      'Explosion': 'Explosion',
      'Firesteel Fracture': 'Choc brasero',
      'Firesteel Strike': 'Frappe brasero',
      'Fizzling Duster': 'Plumeau pétillant',
      'Fizzling Suds': 'Mousse pétillante',
      'Flash of Steel': 'Éclair d\'acier',
      'Fresh Puff': 'Pompon lustré',
      'Gold Flame': 'Flamme dorée',
      'Hateful Visage': 'Visage de haine',
      'Infern Brand': 'Étendard sacré',
      'Infern Ward': 'Barrière infernale',
      'Infern Wave': 'Vague infernale',
      'Mighty Smite': 'Taillade belliqueuse',
      'Nothing beside Remains': 'Soulèvement général',
      'Puff and Tumble': 'Pompon culbuteur',
      'Pure Fire': 'Feu immaculé',
      'Rinse': 'Rinçage',
      'Rush of Might': 'Déferlement de puissance',
      'Scream of the Fallen': 'Grand écho déchu',
      'Sculptor\'s Passion': 'Canon belliqueux',
      'Show of Strength': 'Cri du guerrier',
      'Silver Flame': 'Flamme argentée',
      'Slippery Soap': 'Bain moussant glissant',
      'Soap\'s Up': 'Bain moussant explosif',
      'Soaping Spree': 'Bain moussant public',
      'Specter of Might': 'Spectre immémorial',
      'Squeaky Clean': 'Frottage',
      'Sundered Remains': 'Soulèvement belliqueux',
      'Total Wash': 'Lavage intégral',
      'Wrath of Ruin': 'Colère immémoriale'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aqueduct Belladonna': 'アクアダクト・ベラドンナ',
      'Aqueduct Dryad': 'アクアダクト・ドライアド',
      'Aqueduct Kaluk': 'アクアダクト・カルク',
      'Aqueduct Udumbara': 'アクアダクト・ウドンゲ',
      'Arcane Font': '立体魔法陣',
      'Ball of Fire': '火炎球',
      'Eastern Ewer': '洗い壺',
      'Gladiator of Sil\'dih': 'シラディハ・グラディアトル',
      'Hateful Visage': '呪像起動',
      'Infern Brand': '呪具設置',
      'Shadowcaster Zeless Gah': '影火のゼレズ・ガー',
      'Sil\'dihn Armor': 'シラディハ・イビルアーマー',
      'Sil\'dihn Dullahan': 'シラディハ・デュラハン',
      'Silken Puff': 'シルキーズ・ポンポン',
      'Silkie': 'シルキー',
      'The Trial of Balance': '参の試練',
      'The Trial of Knowledge': '壱の試練',
      'The Trial of Might': '弐の試練'
    },
    'replaceText': {
      'Accursed Visage': '呪怨呪像',
      'Banishment': '強制転移の呪',
      'Blazing Benifice': '聖火砲',
      'Blessed Beacon': '天の聖火',
      'Bracing Duster': 'そよそよダスター',
      'Bracing Suds': 'そよそよシャンプー',
      'Burn': '燃焼',
      'Carpet Beater': 'カーペットビーター',
      'Cast Shadow': '影火呪式',
      'Chilling Duster': 'ひえひえダスター',
      'Chilling Suds': 'ひえひえシャンプー',
      'Colossal Wreck': '亡国の霊塔',
      'Cryptic Flames': '火焔の呪印',
      'Cryptic Portal': '転移の呪印',
      'Curse of the Fallen': '呪怨の咆哮',
      'Curse of the Monument': '呪怨の連撃',
      'Dust Bluster': 'ダストブロワー',
      'Eastern Ewers': '洗い壺',
      'Echo of the Fallen': '呪怨の残響',
      'Explosion': '爆発',
      'Firesteel Fracture': '石火豪打',
      'Firesteel Strike': '石火豪衝',
      'Fizzling Duster': 'ぱちぱちダスター',
      'Fizzling Suds': 'ぱちぱちシャンプー',
      'Flash of Steel': '闘人の波動',
      'Fresh Puff': 'ポンポン創出',
      'Gold Flame': '黄金の閃火',
      'Hateful Visage': '呪像起動',
      'Infern Brand': '呪具設置',
      'Infern Ward': '呪具警陣',
      'Infern Wave': '呪具流火',
      'Mighty Smite': '闘人の斬撃',
      'Nothing beside Remains': '座下隆起',
      'Puff and Tumble': 'ポンポンはたきがけ',
      'Pure Fire': '劫火',
      'Rinse': 'すすぎ洗い',
      'Rush of Might': '大剛の突撃',
      'Scream of the Fallen': '呪怨の大残響',
      'Sculptor\'s Passion': '闘人砲',
      'Show of Strength': '勇士の咆哮',
      'Silver Flame': '白銀の閃火',
      'Slippery Soap': 'すべってシャンプーボム',
      'Soap\'s Up': 'シャンプーボム',
      'Soaping Spree': 'みんなでシャンプーボム',
      'Specter of Might': '亡念幻身',
      'Squeaky Clean': '水拭き',
      'Sundered Remains': '闘場隆起',
      'Total Wash': '水洗い',
      'Wrath of Ruin': '亡念励起'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aqueduct Belladonna': '水道剧毒美人',
      'Aqueduct Dryad': '水道树妖',
      'Aqueduct Kaluk': '水道卡栌克',
      'Aqueduct Udumbara': '水道优昙婆罗花',
      'Arcane Font': '立体魔法阵',
      'Ball of Fire': '火球',
      'Eastern Ewer': '倒水瓶',
      'Gladiator of Sil\'dih': '希拉狄哈剑斗士',
      'Hateful Visage': '亡国咒像',
      'Infern Brand': '蜥蜴人咒具',
      'Shadowcaster Zeless Gah': '鬼阴火 泽雷斯·夏',
      'Sil\'dihn Armor': '希拉狄哈恶魔装甲',
      'Sil\'dihn Dullahan': '希拉狄哈无头骑士',
      'Silken Puff': '羽衣精的绒球',
      'Silkie': '羽衣精',
      'The Trial of Balance': '第三试炼',
      'The Trial of Knowledge': '第一试炼',
      'The Trial of Might': '第二试炼'
    },
    'replaceText': {
      'Accursed Visage': '咒怨咒像',
      'Banishment': '强制传送之咒',
      'Blazing Benifice': '圣火炮',
      'Blessed Beacon': '祝福圣火',
      'Bracing Duster': '风清除尘',
      'Bracing Suds': '风清泡泡',
      'Burn': '燃烧',
      'Carpet Beater': '拍毯子',
      'Cast Shadow': '影火咒式',
      'Chilling Duster': '冰凉除尘',
      'Chilling Suds': '冰凉泡泡',
      'Colossal Wreck': '亡国灵塔',
      'Cryptic Flames': '火焰咒印',
      'Cryptic Portal': '传送咒印',
      'Curse of the Fallen': '咒怨咆哮',
      'Curse of the Monument': '咒怨连击',
      'Dust Bluster': '掸土',
      'Eastern Ewers': '倒水瓶',
      'Echo of the Fallen': '咒怨残响',
      'Explosion': '爆炸',
      'Firesteel Fracture': '石火豪打',
      'Firesteel Strike': '石火豪冲',
      'Fizzling Duster': '电气除尘',
      'Fizzling Suds': '电气泡泡',
      'Flash of Steel': '斗士波动',
      'Fresh Puff': '创造绒球',
      'Gold Flame': '黄金闪火',
      'Hateful Visage': '启动咒像',
      'Infern Brand': '设置咒具',
      'Infern Ward': '咒具警阵',
      'Infern Wave': '咒具流火',
      'Mighty Smite': '斗士斩击',
      'Nothing beside Remains': '座下隆起',
      'Puff and Tumble': '绒球翻滚',
      'Pure Fire': '劫火',
      'Rinse': '漂洗',
      'Rush of Might': '刚武突击',
      'Scream of the Fallen': '咒怨大残响',
      'Sculptor\'s Passion': '斗士炮',
      'Show of Strength': '勇士的咆哮',
      'Silver Flame': '白银闪火',
      'Slippery Soap': '泡泡滑行',
      'Soap\'s Up': '泡泡破裂',
      'Soaping Spree': '泡泡总动员',
      'Specter of Might': '亡念幻影',
      'Squeaky Clean': '擦拭',
      'Sundered Remains': '场地隆起',
      'Total Wash': '水洗',
      'Wrath of Ruin': '亡念激起'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aqueduct Belladonna': '지하수도 벨라돈나',
      'Aqueduct Dryad': '지하수도 드라이어드',
      'Aqueduct Kaluk': '지하수도 칼루크',
      'Aqueduct Udumbara': '지하수도 우담바라',
      'Arcane Font': '입체마법진',
      'Ball of Fire': '불덩이',
      'Eastern Ewer': '물동이',
      'Gladiator of Sil\'dih': '실디하 검투사',
      'Hateful Visage': '망국의 저주상',
      'Infern Brand': '아말쟈 주술도구',
      'Shadowcaster Zeless Gah': '그림자불 젤레즈 가',
      'Sil\'dihn Armor': '실디하 사악한 갑옷',
      'Sil\'dihn Dullahan': '실디하 둘라한',
      'Silken Puff': '실키 폼폼',
      'Silkie': '실키',
      'The Trial of Balance': '세 번째 시련',
      'The Trial of Knowledge': '첫 번째 시련',
      'The Trial of Might': '두 번째 시련'
    },
    'replaceText': {
      'Accursed Visage': '원한의 저주상',
      'Banishment': '강제 전송 주술',
      'Blazing Benifice': '성화포',
      'Blessed Beacon': '하늘의 성화',
      'Bracing Duster': '산들산들 닦기',
      'Bracing Suds': '산들산들 비누거품',
      'Burn': '연소',
      'Carpet Beater': '융단 털기',
      'Cast Shadow': '그림자불 주술식',
      'Chilling Duster': '오들오들 닦기',
      'Chilling Suds': '오들오들 비누거품',
      'Colossal Wreck': '망국의 탑',
      'Cryptic Flames': '화염 주술인',
      'Cryptic Portal': '묵직한 문',
      'Curse of the Fallen': '저주의 포효',
      'Curse of the Monument': '저주 연격',
      'Dust Bluster': '먼지 털기',
      'Eastern Ewers': '물동이',
      'Echo of the Fallen': '저주의 뒤울림',
      'Explosion': '폭발',
      'Firesteel Fracture': '석화호타',
      'Firesteel Strike': '석화호충',
      'Fizzling Duster': '파직파직 닦기',
      'Fizzling Suds': '파직파직 비누거품',
      'Flash of Steel': '투사의 파동',
      'Fresh Puff': '폼폼 만들기',
      'Gold Flame': '황금 섬화',
      'Hateful Visage': '망국의 저주상',
      'Infern Brand': '아말쟈 주술도구',
      'Infern Ward': '주술도구 경비진',
      'Infern Wave': '주술도구 불길',
      'Mighty Smite': '투사의 참격',
      'Nothing beside Remains': '발밑 융기',
      'Puff and Tumble': '폼폼 먼지떨이',
      'Pure Fire': '겁화',
      'Rinse': '헹구기',
      'Rush of Might': '강력한 돌격',
      'Scream of the Fallen': '저주의 큰뒤울림',
      'Sculptor\'s Passion': '투사포',
      'Show of Strength': '용사의 포효',
      'Silver Flame': '백은 섬화',
      'Slippery Soap': '미끄덩 비누 폭탄',
      'Soap\'s Up': '비누 폭탄',
      'Soaping Spree': '다 함께 비누 폭탄',
      'Specter of Might': '망념 환체',
      'Squeaky Clean': '물걸레질',
      'Sundered Remains': '검투장 융기',
      'Total Wash': '물청소',
      'Wrath of Ruin': '망념 상기'
    }
  }]
};
/* harmony default export */ const another_sildihn_subterrane_savage = (another_sildihn_subterrane_savage_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/another_sildihn_subterrane-savage.txt
const dungeon_another_sildihn_subterrane_savage_namespaceObject = "# This file was autogenerated from running npm run sync-files.\r\n# DO NOT EDIT THIS FILE DIRECTLY.\r\n# Edit the source file below and then run `npm run sync-files`\r\n# Source: ui/raidboss/data/06-ew/dungeon/another_sildihn_subterrane.txt\r\n\r\n# Another Sil'dihn Subterrane (Savage)\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~#\r\n# SILKIE #\r\n#~~~~~~~~#\r\n\r\n# -ii 7783 7784 7785 778B 778C 778D 77ED 77EE\r\n\r\n# Trial of Knowledge is sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DD\", param1: \"1087\" } window 0,1\r\n12.2 \"--sync--\" StartsUsing { id: \"777C\", source: \"Silkie\" } window 15,15\r\n14.9 \"Fizzling Suds\" Ability { id: \"777C\", source: \"Silkie\" }\r\n21.0 \"Soap's Up\" Ability { id: \"777D\", source: \"Silkie\" }\r\n22.0 \"Fizzling Duster\" Ability { id: \"7780\", source: \"Silkie\" }\r\n32.2 \"Dust Bluster\" Ability { id: \"778F\", source: \"Silkie\" }\r\n32.2 \"--middle--\"\r\n\r\n38.4 \"Fresh Puff 1\" Ability { id: \"7789\", source: \"Silkie\" }\r\n43.5 \"Bracing Suds\" Ability { id: \"777A\", source: \"Silkie\" }\r\n50.1 \"--sync--\" Ability { id: [\"7774\", \"7775\"], source: \"Silkie\" }\r\n51.6 \"Squeaky Clean\" Ability { id: \"7776\", source: \"Silkie\" } duration 3.2\r\n53.3 \"--sync--\" Ability { id: \"7777\", source: \"Silkie\" }\r\n54.8 \"--sync--\" Ability { id: [\"7778\", \"7779\"], source: \"Silkie\" }\r\n61.9 \"Chilling Suds\" Ability { id: \"777B\", source: \"Silkie\" }\r\n64.0 \"--sync--\" Ability { id: \"79FB\", source: \"Silkie\" }\r\n69.0 \"Slippery Soap\" Ability { id: \"7781\", source: \"Silkie\" }\r\n73.0 \"Chilling Duster\" Ability { id: \"7786\", source: \"Silkie\" }\r\n80.6 \"Carpet Beater\" Ability { id: \"7772\", source: \"Silkie\" }\r\n89.7 \"Soaping Spree\" Ability { id: \"778A\", source: \"Silkie\" }\r\n89.7 \"Chilling Duster / Fizzling Duster\" #Ability { id: [\"778B\", \"778D\"], source: \"Silken Puff\" }\r\n89.7 \"Bracing Duster\" #Ability { id: \"778C\", source: \"Silken Puff\" }\r\n89.7 \"Chilling Duster\" #Ability { id: \"778B\", source: \"Silken Puff\" }\r\n100.9 \"Total Wash 1\" Ability { id: \"7773\", source: \"Silkie\" }\r\n106.0 \"Bracing Suds / Chilling Suds\" Ability { id: [\"777A\", \"777B\"], source: \"Silkie\" }\r\n\r\n112.1 \"Fresh Puff 2\" Ability { id: \"7789\", source: \"Silkie\" }\r\n116.3 \"--middle--\"\r\n123.1 \"Puff and Tumble\" duration 0.7 #Ability { id: \"7794\", source: \"Silken Puff\" }\r\n129.5 \"Soaping Spree\" Ability { id: \"778A\", source: \"Silkie\" }\r\n129.5 \"Fizzling Duster x2\" #Ability { id: \"778D\", source: \"Silken Puff\" }\r\n129.5 \"Chilling Duster x2\" #Ability { id: \"778B\", source: \"Silken Puff\" }\r\n129.5 \"Bracing Duster / Chilling Duster\" #Ability { id: [\"778C\", \"778B\"], source: \"Silkie\" }\r\n134.6 \"Bracing Suds / Fizzling Suds\" Ability { id: [\"777A\", \"777C\"], source: \"Silkie\" }\r\n136.7 \"--sync--\" Ability { id: \"79FB\", source: \"Silkie\" }\r\n141.7 \"Slippery Soap\" Ability { id: \"7781\", source: \"Silkie\" }\r\n145.7 \"Bracing Duster / Fizzling Duster\" Ability { id: [\"7787\", \"7788\"], source: \"Silkie\" }\r\n160.1 \"Total Wash 2\" Ability { id: \"7773\", source: \"Silkie\" }\r\n\r\n166.2 \"Fresh Puff 3\" Ability { id: \"7789\", source: \"Silkie\" }\r\n172.3 \"Eastern Ewers\" Ability { id: \"7790\", source: \"Silkie\" }\r\n178.6 \"Rinse\" Ability { id: \"7792\", source: \"Eastern Ewer\" } duration 7.3\r\n188.1 \"Soaping Spree\" Ability { id: \"778A\", source: \"Silkie\" }\r\n188.1 \"Bracing Duster / Chilling Duster / Fizzling Duster\" #Ability { id: [\"778C\", \"778B\", \"778D\"], source: \"Silken Puff\" }\r\n188.1 \"Fizzling Duster\" #Ability { id: \"778D\", source: \"Silken Puff\" }\r\n195.2 \"Chilling Suds\" Ability { id: \"777B\", source: \"Silkie\" }\r\n202.3 \"Carpet Beater\" Ability { id: \"7772\", source: \"Silkie\" }\r\n204.4 \"--sync--\" Ability { id: \"79FB\", source: \"Eastern Ewer\" }\r\n209.4 \"Slippery Soap\" Ability { id: \"7781\", source: \"Silkie\" }\r\n213.4 \"Chilling Duster\" Ability { id: \"7786\", source: \"Silkie\" }\r\n225.9 \"Bracing Suds\" Ability { id: \"777A\", source: \"Silkie\" }\r\n233.0 \"Soaping Spree\" Ability { id: \"778A\", source: \"Silkie\" }\r\n233.0 \"Chilling Duster x6\" #Ability { id: \"778B\", source: \"Silken Puff\" }\r\n233.0 \"Bracing Duster\" #Ability { id: \"778C\", source: \"Silkie\" }\r\n244.2 \"Dust Bluster\" Ability { id: \"778F\", source: \"Silkie\" }\r\n244.2 \"--north--\"\r\n249.6 \"Bracing Suds\" Ability { id: \"777A\", source: \"Silkie\" }\r\n\r\n255.7 \"Fresh Puff 4\" Ability { id: \"7789\", source: \"Silkie\" }\r\n262.3 \"--sync--\" Ability { id: [\"7774\", \"7775\"], source: \"Silkie\" }\r\n263.8 \"Squeaky Clean\" Ability { id: \"7776\", source: \"Silkie\" } duration 3.2\r\n265.5 \"--sync--\" Ability { id: \"7777\", source: \"Silkie\" }\r\n266.9 \"Puff and Tumble x4\" duration 0.7 #Ability { id: \"7794\", source: \"Silken Puff\" }\r\n266.9 \"--sync--\" Ability { id: [\"7778\", \"7779\"], source: \"Silkie\" }\r\n276.0 \"Soaping Spree\" Ability { id: \"778A\", source: \"Silkie\" }\r\n276.0 \"Chilling Duster x4\" #Ability { id: \"778B\", source: \"Silken Puff\" }\r\n276.0 \"Bracing Duster\" #Ability { id: \"778C\", source: \"Silkie\" }\r\n283.1 \"Total Wash 3\" Ability { id: \"7773\", source: \"Silkie\" }\r\n292.3 \"Bracing Suds / Chilling Suds / Fizzling Suds\" Ability { id: [\"777A\", \"777B\", \"777C\"], source: \"Silkie\" }\r\n294.4 \"--sync--\" Ability { id: \"79FB\", source: \"Silkie\" }\r\n299.4 \"Slippery Soap\" Ability { id: \"7781\", source: \"Silkie\" }\r\n303.5 \"Bracing Duster / Chilling Duster / Fizzling Duster\" Ability { id: [\"7787\", \"7786\", \"7788\"], source: \"Silkie\" }\r\n309.0 \"Bracing Suds / Chilling Suds / Fizzling Suds\" Ability { id: [\"777A\", \"777B\", \"777C\"], source: \"Silkie\" }\r\n311.1 \"--sync--\" Ability { id: \"79FB\", source: \"Silkie\" }\r\n316.1 \"Slippery Soap\" Ability { id: \"7781\", source: \"Silkie\" }\r\n320.0 \"Bracing Duster / Chilling Duster / Fizzling Duster\" Ability { id: [\"7787\", \"7786\", \"7788\"], source: \"Silkie\" }\r\n\r\n322.9 \"--sync--\" StartsUsing { id: \"79E1\", source: \"Silkie\" } window 15,5\r\n332.9 \"Total Wash (enrage)\" Ability { id: \"79E1\", source: \"Silkie\" }\r\n338.1 \"Total Wash (enrage)\" Ability { id: \"79F9\", source: \"Silkie\" }\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~~~~#\r\n# Gladiator of Sil'dih #\r\n#~~~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 77B1 77B2 77B8 77B9 77BF 77A2 79F4\r\n\r\n# Trial of Might will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1088\" } window 1000,1\r\n1006.8 \"--sync--\" StartsUsing { id: \"77B3\", source: \"Gladiator of Sil'dih\" } window 1007.3,5\r\n1011.5 \"Flash of Steel\" Ability { id: \"77B3\", source: \"Gladiator of Sil'dih\" }\r\n1023.6 \"Specter of Might\" Ability { id: \"77B5\", source: \"Gladiator of Sil'dih\" }\r\n1038.3 \"Rush of Might 1\" Ability { id: \"779D\", source: \"Gladiator of Sil'dih\" }\r\n1040.4 \"Rush of Might 2\" Ability { id: \"779E\", source: \"Gladiator of Sil'dih\" }\r\n1042.8 \"Specter of Might\" Ability { id: \"77B5\", source: \"Gladiator of Sil'dih\" }\r\n1057.5 \"Rush of Might 1\" Ability { id: \"779D\", source: \"Gladiator of Sil'dih\" }\r\n1059.6 \"Rush of Might 2\" Ability { id: \"779E\", source: \"Gladiator of Sil'dih\" }\r\n1062.0 \"--sync--\" Ability { id: \"6854\", source: \"Gladiator of Sil'dih\" }\r\n1067.0 \"Sculptor's Passion\" Ability { id: \"77AE\", source: \"Gladiator of Sil'dih\" }\r\n1082.4 \"Mighty Smite\" Ability { id: \"77B4\", source: \"Gladiator of Sil'dih\" }\r\n\r\n1095.5 \"Curse of the Fallen\" Ability { id: \"77B6\", source: \"Gladiator of Sil'dih\" }\r\n1097.6 \"--middle--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n1110.2 \"--sync--\" Ability { id: \"77BF\", source: \"Gladiator of Sil'dih\" }\r\n1113.6 \"Echo of the Fallen\" Ability { id: \"77B7\", source: \"Gladiator of Sil'dih\" }\r\n1121.3 \"Flash of Steel\" Ability { id: \"77B3\", source: \"Gladiator of Sil'dih\" }\r\n1131.5 \"--middle--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n\r\n1136.6 \"Hateful Visage\" Ability { id: \"77B0\", source: \"Gladiator of Sil'dih\" }\r\n1141.7 \"Wrath of Ruin\" Ability { id: \"77A5\", source: \"Gladiator of Sil'dih\" }\r\n1150.7 \"Gold Flame x4\" Ability { id: \"77B1\", source: \"Hateful Visage\" }\r\n1150.7 \"Silver Flame x4\" #Ability { id: \"77B2\", source: \"Hateful Visage\" }\r\n1152.3 \"Nothing beside Remains\" Ability { id: [\"768B\", \"77BC\"], source: \"Gladiator of Sil'dih\" }\r\n1161.4 \"Flash of Steel\" Ability { id: \"77B3\", source: \"Gladiator of Sil'dih\" }\r\n1171.6 \"Accursed Visage\" Ability { id: \"77BE\", source: \"Gladiator of Sil'dih\" }\r\n1176.7 \"Wrath of Ruin\" Ability { id: \"77A5\", source: \"Gladiator of Sil'dih\" }\r\n1185.7 \"Gold Flame x4\" Ability { id: \"77B1\", source: \"Hateful Visage\" }\r\n1185.7 \"Silver Flame x4\" #Ability { id: \"77B2\", source: \"Hateful Visage\" }\r\n1187.3 \"Nothing beside Remains\" Ability { id: [\"768B\", \"77BC\"], source: \"Gladiator of Sil'dih\" }\r\n1196.4 \"Flash of Steel\" Ability { id: \"77B3\", source: \"Gladiator of Sil'dih\" }\r\n\r\n1206.6 \"--middle--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n1212.7 \"Curse of the Monument\" Ability { id: \"77A8\", source: \"Gladiator of Sil'dih\" }\r\n1219.9 \"Sundered Remains 1\" #Ability { id: \"77AA\", source: \"Gladiator of Sil'dih\" }\r\n1220.5 \"Sundered Remains 2\" #Ability { id: \"77AA\", source: \"Gladiator of Sil'dih\" }\r\n1221.1 \"Sundered Remains 3\" #Ability { id: \"77AA\", source: \"Gladiator of Sil'dih\" }\r\n1221.7 \"Sundered Remains 4\" #Ability { id: \"77AA\", source: \"Gladiator of Sil'dih\" }\r\n1222.3 \"Sundered Remains 5\" #Ability { id: \"77AA\", source: \"Gladiator of Sil'dih\" }\r\n1224.9 \"--middle--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n1232.9 \"Scream of the Fallen\" Ability { id: \"77BA\", source: \"Gladiator of Sil'dih\" }\r\n1233.3 \"Colossal Wreck\" Ability { id: \"77AB\", source: \"Gladiator of Sil'dih\" }\r\n1233.8 \"Explosion\" Ability { id: \"77AC\", source: \"Gladiator of Sil'dih\" }\r\n1237.0 \"Scream of the Fallen\" Ability { id: \"77BA\", source: \"Gladiator of Sil'dih\" }\r\n1237.8 \"Explosion\" Ability { id: \"77AC\", source: \"Gladiator of Sil'dih\" }\r\n\r\n1245.0 \"Flash of Steel\" Ability { id: \"77B3\", source: \"Gladiator of Sil'dih\" }\r\n1259.2 \"Specter of Might\" Ability { id: \"77B5\", source: \"Gladiator of Sil'dih\" }\r\n1273.9 \"Rush of Might 1\" Ability { id: \"779D\", source: \"Gladiator of Sil'dih\" }\r\n1276.0 \"Rush of Might 2\" Ability { id: \"779E\", source: \"Gladiator of Sil'dih\" }\r\n1278.3 \"Specter of Might\" Ability { id: \"77B5\", source: \"Gladiator of Sil'dih\" }\r\n1293.0 \"Rush of Might 1\" Ability { id: \"779D\", source: \"Gladiator of Sil'dih\" }\r\n1295.1 \"Rush of Might 2\" Ability { id: \"779E\", source: \"Gladiator of Sil'dih\" }\r\n1297.5 \"--sync--\" Ability { id: \"6854\", source: \"Gladiator of Sil'dih\" }\r\n1302.6 \"Sculptor's Passion\" Ability { id: \"77AE\", source: \"Gladiator of Sil'dih\" }\r\n\r\n1311.5 \"--middle--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n1318.9 \"Flash of Steel\" Ability { id: \"77B3\", source: \"Gladiator of Sil'dih\" }\r\n1321.0 \"--sync--\" StartsUsing { id: \"77BB\", source: \"Gladiator of Sil'dih\" } window 15,5\r\n1331.0 \"Flash of Steel (enrage)\" Ability { id: \"77BB\", source: \"Gladiator of Sil'dih\" }\r\n# There's probably a second, instant cast enrage version of the enrage after\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~~~~~~~#\r\n# Shadowcaster Zeless Gah #\r\n#~~~~~~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 76CA 74B8\r\n\r\n# Trial of Balance will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1089\" } window 2000,1\r\n2006.8 \"--sync--\" StartsUsing { id: \"76C5\", source: \"Shadowcaster Zeless Gah\" } window 2007.3,5\r\n2011.5 \"Show of Strength\" Ability { id: \"76C5\", source: \"Shadowcaster Zeless Gah\" }\r\n2023.7 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n2030.8 \"Cryptic Portal\" Ability { id: \"7494\", source: \"Shadowcaster Zeless Gah\" }\r\n2041.9 \"--sync--\" Ability { id: \"74B0\", source: \"Shadowcaster Zeless Gah\" }\r\n2042.3 \"Firesteel Strike 1\" #Ability { id: \"76C6\", source: \"Shadowcaster Zeless Gah\" }\r\n2043.3 \"Burn x4\" Ability { id: \"76BB\", source: \"Ball of Fire\" }\r\n2043.7 \"Firesteel Strike 2\" #Ability { id: \"76C7\", source: \"Shadowcaster Zeless Gah\" }\r\n2051.6 \"--sync--\" Ability { id: \"74B3\", source: \"Shadowcaster Zeless Gah\" }\r\n2052.0 \"Blessed Beacon 1\" Ability { id: \"76C8\", source: \"Shadowcaster Zeless Gah\" }\r\n2054.1 \"Blessed Beacon 2\" Ability { id: \"76C9\", source: \"Shadowcaster Zeless Gah\" }\r\n2064.4 \"Firesteel Fracture\" Ability { id: \"76C4\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n2076.6 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" } duration 12\r\n2088.0 \"Cryptic Flames\" Ability { id: \"74B6\", source: \"Shadowcaster Zeless Gah\" } duration 12\r\n2094.9 \"--middle--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n2101.4 \"Blazing Benifice 1\" Ability { id: \"76C1\", source: \"Arcane Font\" }\r\n2102.0 \"--sync--\" Ability { id: \"749A\", source: \"Shadowcaster Zeless Gah\" }\r\n2102.7 \"Cast Shadow 1\" Ability { id: \"76BD\", source: \"Shadowcaster Zeless Gah\" }\r\n2104.7 \"Cast Shadow 2\" Ability { id: \"76BE\", source: \"Shadowcaster Zeless Gah\" }\r\n2113.5 \"Blazing Benifice 2\" Ability { id: \"76C1\", source: \"Arcane Font\" }\r\n2117.7 \"Firesteel Fracture\" Ability { id: \"76C4\", source: \"Shadowcaster Zeless Gah\" }\r\n2126.8 \"Show of Strength\" Ability { id: \"76C5\", source: \"Shadowcaster Zeless Gah\" }\r\n2139.0 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n2147.1 \"--sync--\" Ability { id: \"74BA\", source: \"Shadowcaster Zeless Gah\" }\r\n2147.9 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n2150.3 \"--middle--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n2155.5 \"Banishment\" Ability { id: \"74BC\", source: \"Shadowcaster Zeless Gah\" }\r\n2163.7 \"Infern Ward\" Ability { id: \"7496\", source: \"Shadowcaster Zeless Gah\" }\r\n2164.5 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n2165.0 \"--sync--\" Ability { id: \"7497\", source: \"Shadowcaster Zeless Gah\" }\r\n2171.5 \"Infern Wave 1\" Ability { id: \"76CD\", source: \"Infern Brand\" }\r\n2179.5 \"Infern Wave 2\" Ability { id: \"76CD\", source: \"Infern Brand\" }\r\n2187.9 \"Firesteel Fracture\" Ability { id: \"76C4\", source: \"Shadowcaster Zeless Gah\" }\r\n2200.1 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n2207.2 \"Cryptic Portal\" Ability { id: \"7494\", source: \"Shadowcaster Zeless Gah\" }\r\n2218.3 \"--sync--\" Ability { id: \"74B0\", source: \"Shadowcaster Zeless Gah\" }\r\n2218.6 \"Firesteel Strike 1\" #Ability { id: \"76C6\", source: \"Shadowcaster Zeless Gah\" }\r\n2219.7 \"Blazing Benifice\" Ability { id: \"76C1\", source: \"Arcane Font\" }\r\n2220.1 \"Firesteel Strike 2\" #Ability { id: \"76C7\", source: \"Shadowcaster Zeless Gah\" }\r\n2228.1 \"--sync--\" Ability { id: \"74B3\", source: \"Shadowcaster Zeless Gah\" }\r\n2228.5 \"Blessed Beacon 1\" Ability { id: \"76C8\", source: \"Shadowcaster Zeless Gah\" }\r\n2230.7 \"Blessed Beacon 2\" Ability { id: \"76C9\", source: \"Shadowcaster Zeless Gah\" }\r\n2240.8 \"Show of Strength\" Ability { id: \"76C5\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n2253.0 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" } duration 12\r\n2261.2 \"--sync--\" Ability { id: \"74BA\", source: \"Shadowcaster Zeless Gah\" }\r\n2262.0 \"--sync--\" Ability { id: \"7495\", source: \"Infern Brand\" }\r\n2273.7 \"Cryptic Flames\" Ability { id: \"74B6\", source: \"Shadowcaster Zeless Gah\" } duration 12\r\n2277.7 \"Infern Wave 1\" Ability { id: \"76CD\", source: \"Infern Brand\" }\r\n2287.7 \"Infern Wave 2\" Ability { id: \"76CD\", source: \"Infern Brand\" }\r\n2288.7 \"--sync--\" Ability { id: \"749F\", source: \"Shadowcaster Zeless Gah\" }\r\n2292.4 \"Pure Fire\" Ability { id: \"76BF\", source: \"Shadowcaster Zeless Gah\" }\r\n2294.8 \"--middle--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n2297.6 \"Infern Wave 3\" Ability { id: \"76CD\", source: \"Infern Brand\" }\r\n2302.0 \"--sync--\" Ability { id: \"749A\", source: \"Shadowcaster Zeless Gah\" }\r\n2302.7 \"Cast Shadow 1\" Ability { id: \"76BD\", source: \"Shadowcaster Zeless Gah\" }\r\n2304.7 \"Cast Shadow 2\" Ability { id: \"76BE\", source: \"Shadowcaster Zeless Gah\" }\r\n2307.6 \"Infern Wave 4\" Ability { id: \"76CD\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n2314.5 \"Firesteel Fracture\" Ability { id: \"76C4\", source: \"Shadowcaster Zeless Gah\" }\r\n2323.6 \"Show of Strength\" Ability { id: \"76C5\", source: \"Shadowcaster Zeless Gah\" }\r\n2328.6 \"--sync--\" StartsUsing { id: \"74BF\", source: \"Shadowcaster Zeless Gah\" } window 15,5\r\n2338.6 \"Show of Strength (enrage)\" Ability { id: \"74BF\", source: \"Shadowcaster Zeless Gah\" }\r\n2341.7 \"Show of Strength (enrage)\" Ability { id: \"73C9\", source: \"Shadowcaster Zeless Gah\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/another_sildihn_subterrane.ts






// TODO: Gladiator adjustments to timeline
// TODO: Shadowcaster Infern Brand 1 and 4 safe location triggers if possible
// TODO: Shadowcaster adjustments to timeline
const another_sildihn_subterrane_puffWind = 'CE9';
const another_sildihn_subterrane_puffIce = 'CEA';
const another_sildihn_subterrane_puffLightning = 'CEB';
const another_sildihn_subterrane_firstInLine = 'BBC';
const another_sildihn_subterrane_secondInLine = 'BBD';
const another_sildihn_subterrane_dirs = ['N', 'NE', 'E', 'SE', 'S', 'SW', 'W', 'NW'];
const another_sildihn_subterrane_silkieCenterX = -335;
const another_sildihn_subterrane_silkieCenterY = -155;
const another_sildihn_subterrane_positionTo8Dir = (posX, posY, centerX, centerY) => {
  const relX = posX - centerX;
  const relY = posY - centerY;

  // Dirs: N = 0, NE = 1, ..., NW = 7
  return Math.round(4 - 4 * Math.atan2(relX, relY) / Math.PI) % 8;
};
const another_sildihn_subterrane_headingTo4Dir = heading => {
  // Dirs: N = 0, E = 1, S = 2, W = 3
  return (2 - Math.round(heading * 2 / Math.PI)) % 4;
};
const another_sildihn_subterrane_visageMapIdx = (col, row) => row * 4 + col;
const another_sildihn_subterrane_triggerSet = {
  id: 'AnotherSildihnSubterrane',
  zoneId: zone_id/* default.AnotherSildihnSubterrane */.Z.AnotherSildihnSubterrane,
  timelineFile: 'another_sildihn_subterrane.txt',
  initData: () => {
    return {
      puffCounter: 0,
      silkenPuffs: {},
      soapCounter: 0,
      beaterCounter: 0,
      spreeCounter: 0,
      mightCasts: [],
      myVisage: {
        gold: 0,
        silver: 0
      },
      visageMap: {},
      screamOfTheFallen: {},
      arcaneFontCounter: 0,
      brandEffects: {},
      brandCounter: 0,
      flamesCutCounter: 0,
      waveCounter: 0
    };
  },
  triggers: [
  // ---------------- first trash ----------------
  {
    id: 'ASS Atropine Spore',
    type: 'StartsUsing',
    netRegex: {
      id: '7960',
      source: 'Aqueduct Belladonna',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'ASS Frond Affront',
    type: 'StartsUsing',
    netRegex: {
      id: '7961',
      source: 'Aqueduct Belladonna',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'ASS Deracinator',
    type: 'StartsUsing',
    netRegex: {
      id: '7962',
      source: 'Aqueduct Belladonna'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'ASS Left Sweep',
    type: 'StartsUsing',
    netRegex: {
      id: '7964',
      source: 'Aqueduct Kaluk',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'ASS Right Sweep',
    type: 'StartsUsing',
    netRegex: {
      id: '7963',
      source: 'Aqueduct Kaluk',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'ASS Creeping Ivy',
    type: 'StartsUsing',
    netRegex: {
      id: '7965',
      source: 'Aqueduct Kaluk',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'ASS Honeyed Left',
    type: 'StartsUsing',
    netRegex: {
      id: '795B',
      source: 'Aqueduct Udumbara',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'ASS Honeyed Right',
    type: 'StartsUsing',
    netRegex: {
      id: '795C',
      source: 'Aqueduct Udumbara',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'ASS Honeyed Front',
    type: 'StartsUsing',
    netRegex: {
      id: '795D',
      source: 'Aqueduct Udumbara',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'ASS Arboreal Storm',
    type: 'StartsUsing',
    netRegex: {
      id: '7957',
      source: 'Aqueduct Dryad',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  },
  // ---------------- Silkie ----------------
  {
    id: 'ASS Soap\'s Up',
    type: 'StartsUsing',
    netRegex: {
      id: '775A',
      source: 'Silkie',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cardinals',
        de: 'Kardinal',
        fr: 'Cardinaux',
        ja: '十字回避',
        cn: '十字',
        ko: '십자방향으로'
      }
    }
  }, {
    id: 'ASS Dust Bluster',
    type: 'StartsUsing',
    netRegex: {
      id: '776C',
      source: 'Silkie',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'ASS Fresh Puff Tracker',
    // Use this separate trigger to increment data.puffCounter,
    // since we have multiple triggers to handle different Fresh Puffs
    type: 'StartsUsing',
    netRegex: {
      id: '7766',
      source: 'Silkie',
      capture: false
    },
    run: data => {
      ++data.puffCounter;
      data.silkenPuffs = {};
    }
  }, {
    id: 'ASS Silken Puff Suds Gain',
    type: 'GainsEffect',
    // Silken Puffs:
    // CE9 Bracing Suds (Wind / Donut)
    // CEA Chilling Suds (Ice / Cardinal)
    // CEB Fizzling Suds (Lightning / Intercardinal)
    netRegex: {
      target: 'Silken Puff',
      effectId: 'CE[9AB]'
    },
    condition: data => data.puffCounter < 4,
    // don't track for Fresh Puff 4
    delaySeconds: 0.2,
    // sometimes a small delay between effects and updated pos data
    promise: async (data, matches) => {
      let puffCombatantData = null;
      puffCombatantData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.targetId, 16)]
      });
      if (puffCombatantData === null) return;
      if (puffCombatantData.combatants.length !== 1) return;
      const puff = puffCombatantData.combatants[0];
      if (!puff) return;
      const puffX = Math.floor(puff.PosX);
      const puffY = Math.floor(puff.PosY);
      const puffLoc = another_sildihn_subterrane_dirs[another_sildihn_subterrane_positionTo8Dir(puffX, puffY, another_sildihn_subterrane_silkieCenterX, another_sildihn_subterrane_silkieCenterY)];
      if (puffLoc === undefined) return;
      data.silkenPuffs[matches.targetId] = {
        effect: matches.effectId,
        location: puffLoc,
        x: puffX,
        y: puffY
      };
    }
  }, {
    id: 'ASS Silken Puff Suds Lose',
    type: 'LosesEffect',
    // Silken Puffs:
    // CE9 Bracing Suds (Wind / Donut)
    // CEA Chilling Suds (Ice / Cardinal)
    // CEB Fizzling Suds (Lightning / Intercardinal)
    netRegex: {
      target: 'Silken Puff',
      effectId: 'CE[9AB]'
    },
    condition: data => data.puffCounter < 4,
    // don't track for Fresh Puff 4
    run: (data, matches) => delete data.silkenPuffs[matches.targetId]
  }, {
    id: 'ASS Squeaky Clean Right',
    type: 'StartsUsing',
    netRegex: {
      id: '7751',
      source: 'Silkie',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'ASS Squeaky Clean Left',
    type: 'StartsUsing',
    netRegex: {
      id: '7752',
      source: 'Silkie',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'ASS Silkie Suds Gain',
    // Silkie:
    // CE1 Bracing Suds (Wind / Donut)
    // CE2 Chilling Suds (Ice / Cardinal)
    // CE3 Fizzling Suds (Lightning / Intercardinal)
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CE[1-3]',
      target: 'Silkie'
    },
    run: (data, matches) => data.suds = matches.effectId
  }, {
    id: 'ASS Silkie Suds Lose',
    // Silkie:
    // CE1 Bracing Suds (Wind / Donut)
    // CE2 Chilling Suds (Ice / Cardinal)
    // CE3 Fizzling Suds (Lightning / Intercardinal)
    type: 'LosesEffect',
    netRegex: {
      effectId: 'CE[1-3]',
      target: 'Silkie',
      capture: false
    },
    run: data => delete data.suds
  }, {
    id: 'ASS Fresh Puff 1',
    // 3 puffs in triangle formation
    type: 'StartsUsing',
    // use 7751/7752 (Squeaky Clean Left/Right), rather than 7766 (Fresh Puff)
    // Squeaky Clean will change the effects of two puffs after the Fresh Puff cast
    // so it is the easiest method to determine mechanic resolution
    netRegex: {
      id: ['7751', '7752'],
      source: 'Silkie'
    },
    condition: data => data.puffCounter === 1,
    delaySeconds: 9,
    // delay alert until after Squeaky Clean Left/Right completes to collect Silken Puff effects
    durationSeconds: 8,
    // keep alert up until just before Slippery Soap trigger fires
    alertText: (data, matches, output) => {
      if (Object.keys(data.silkenPuffs).length !== 3) return output.default();
      const puffsByLoc = {};
      for (const puff of Object.values(data.silkenPuffs)) {
        if (puff.location !== undefined) puffsByLoc[puff.location] = puff.effect;
      }

      // See Silken Puff Suds Gain trigger for list of Silken Puff effectIds
      // By this point, Squeaky Clean Left/Right has changed the N puff and either the SW/SE puff to CE9 (Bracing Suds)
      // We only care about the unaffected puff's status effect (CEA/CEB) for resolving the mechanic.
      let stackDir;
      let safeDir;
      if (matches.id === '7751') {
        // Squeaky Clean Right - resolve based on SW puff's effect
        if (puffsByLoc.SW === undefined) return output.default();
        stackDir = puffsByLoc.SW === another_sildihn_subterrane_puffIce ? 'SE' : 'N'; // if SW is ice, SE stack (unsafe later); if SW is lightning, N stack (unsafe later)
        safeDir = stackDir === 'SE' ? 'N' : 'SE'; // safeDir is the one we are not stacking at
      } else if (matches.id === '7752') {
        // Squeaky Clean Left - resolve based on SE puff's effect
        if (puffsByLoc.SE === undefined) return output.default();
        stackDir = puffsByLoc.SE === another_sildihn_subterrane_puffIce ? 'SW' : 'N'; // if SE is ice, SW stack (unsafe later); if SE is lightning, N stack (unsafe later)
        safeDir = stackDir === 'SW' ? 'N' : 'SW';
      } else {
        return output.default();
      }
      return output.stacksafe({
        dir1: output[stackDir](),
        dir2: output[safeDir]()
      });
    },
    outputStrings: {
      N: outputs/* default.dirN */.Z.dirN,
      SE: outputs/* default.dirSE */.Z.dirSE,
      SW: outputs/* default.dirSW */.Z.dirSW,
      stacksafe: {
        en: 'Stack ${dir1} (${dir2} safe after)',
        de: 'Sammeln ${dir1} (${dir2} danach sicher)',
        fr: 'Package ${dir1} (${dir2} sûr après)',
        ja: '${dir1}で頭割り (あとは${dir2}が安置)',
        cn: '${dir1}集合 (然后${dir2}安全)',
        ko: '${dir1}쪽에서 쉐어 (이후 ${dir2}쪽이 안전)'
      },
      default: {
        en: 'Stack near unsafe green puff',
        de: 'Neben unsicherem grünen Puschel sammeln',
        fr: 'Pack vers le pompon vert non safe',
        ja: '緑の下で頭割り',
        cn: '靠近危险绿球集合',
        ko: '초록색 구슬에서 쉐어'
      }
    }
  }, {
    id: 'ASS Slippery Soap',
    // Happens 5 times in the encounter
    type: 'Ability',
    // Silkie begins casting Slippery Soap (775E), and at the same time, either Silkie or an invisible actor will use 79FB on a player
    // the 79FB ability appears to correspond to the stack marker on that player, so use that ability id instead
    netRegex: {
      id: '79FB'
    },
    preRun: data => data.soapCounter++,
    alertText: (data, matches, output) => {
      if (data.suds === 'CE1') {
        // Does not happen on first or third Slippery Soap
        if (matches.target === data.me) return output.getBehindPartyKnockback();
        return output.getInFrontOfPlayerKnockback({
          player: data.party.member(matches.target)
        });
      }
      if (matches.target === data.me) {
        if (data.soapCounter === 1) return output.getBehindPuff();
        if (data.soapCounter === 3) return output.getBehindPuffs();
        return output.getBehindParty();
      }
      return output.getInFrontOfPlayer({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      getBehindPuff: {
        en: 'Behind puff and party',
        de: 'Hinter Puschel und Gruppe',
        fr: 'Derrière le pompon et le groupe',
        ja: 'たまの一番後ろへ',
        cn: '站在球和队友后',
        ko: '구슬 뒤로'
      },
      getBehindPuffs: {
        en: 'Behind puffs and party (East/West)',
        de: 'Hinter Puschel und Gruppe (Osten/Westen)',
        fr: 'Derrière les pompons et le groupe (Est/Ouest)',
        ja: 'たまの一番後ろへ (東西)',
        cn: '站在球和队友后 (东/西)',
        ko: '구슬 뒤로 (동/서)'
      },
      getBehindParty: {
        en: 'Behind party',
        de: 'Hinter Gruppe',
        fr: 'Derrière le groupe',
        ja: '一番後ろへ',
        cn: '站在队友后',
        ko: '맨 뒤로'
      },
      getBehindPartyKnockback: {
        en: 'Behind party (Knockback)',
        de: 'Hinter Gruppe (Rückstoß)',
        fr: 'Derrière le groupe (Poussée)',
        ja: 'ノックバック！ 一番後ろへ',
        cn: '站在队友后 (击退)',
        ko: '맨 뒤로 (넉백)'
      },
      getInFrontOfPlayer: {
        en: 'In front of ${player}',
        de: 'Sei vor ${player}',
        fr: 'Devant ${player}',
        ja: '${player}の前へ',
        cn: '站在 ${player} 前',
        ko: '${player} 앞으로'
      },
      getInFrontOfPlayerKnockback: {
        en: 'In front of ${player} (Knockback)',
        de: 'Sei vor ${player} (Rückstoß)',
        fr: 'Devant ${player} (Poussée)',
        ja: 'ノックバック! ${player}の前へ',
        cn: '站在 ${player} 前 (击退)',
        ko: '${player} 앞으로 (넉백)'
      }
    }
  }, {
    id: 'ASS Slippery Soap with Chilling Suds',
    type: 'StartsUsing',
    netRegex: {
      id: '775E',
      source: 'Silkie'
    },
    condition: data => data.suds === 'CE2',
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 1.5,
    response: responses/* Responses.moveAround */.n3.moveAround()
  }, {
    id: 'ASS Slippery Soap After',
    type: 'Ability',
    netRegex: {
      id: '775E',
      source: 'Silkie',
      capture: false
    },
    infoText: (data, _matches, output) => {
      switch (data.suds) {
        case 'CE1':
          return output.getUnder();
        case 'CE2':
          return output.intercards();
        case 'CE3':
          return output.spreadCardinals();
      }
    },
    outputStrings: {
      getUnder: outputs/* default.getUnder */.Z.getUnder,
      spreadCardinals: {
        en: 'Spread Cardinals',
        de: 'Kardinal verteilen',
        fr: 'Écartez-vous en cardinal',
        ja: '十字回避 => 散会',
        cn: '十字分散',
        ko: '십자방향으로 산개'
      },
      intercards: {
        en: 'Intercards',
        de: 'Interkardinal',
        fr: 'Intercardinal',
        ja: '斜め',
        cn: '四角',
        ko: '대각선 쪽으로'
      }
    }
  }, {
    id: 'ASS Carpet Beater',
    type: 'StartsUsing',
    netRegex: {
      id: '774F',
      source: 'Silkie'
    },
    preRun: data => data.beaterCounter++,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        busterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
        busterOnTarget: outputs/* default.tankBusterOnPlayer */.Z.tankBusterOnPlayer,
        busterOnYouPuffs: {
          en: 'Tank Buster on YOU, East/West Between Puffs',
          de: 'Tank Buster auf DIR, Osten/Westen zwischen Puschel',
          fr: 'Tankbuster sur VOUS, entre les pompons Est/Ouest',
          ja: '自分に強攻撃、東西で誘導',
          cn: '死刑点名, 左(西)/右(东) 球下引导',
          ko: '나에게 탱버, 동/서쪽 구슬 사이로'
        }
      };
      if (matches.target === data.me) {
        if (data.beaterCounter === 2) return {
          alertText: output.busterOnYouPuffs()
        };
        return {
          infoText: output.busterOnYou()
        };
      }
      if (data.role !== 'tank' && data.role !== 'healer') return;
      return {
        infoText: output.busterOnTarget({
          player: data.party.member(matches.target)
        })
      };
    }
  }, {
    id: 'ASS Soaping Spree',
    // Boss does not cast Fizzling Duster with Soaping Spree
    type: 'StartsUsing',
    netRegex: {
      id: '7767',
      source: 'Silkie',
      capture: false
    },
    condition: data => {
      ++data.spreeCounter;
      // skip 2nd and 3rd sprees - those are handled by separate Fresh Puff triggers because safe area can be more nuanced
      return data.spreeCounter !== 2 && data.spreeCounter !== 3;
    },
    infoText: (data, _matches, output) => {
      switch (data.suds) {
        case 'CE1':
          // TODO: does spree 4 need an earlier warning to move the boss away from blue puffs?
          return output.getUnder();
        case 'CE2':
          return output.intercards();
        default:
          if (data.spreeCounter === 1) return output.underPuff();
          return output.avoidPuffs();
      }
    },
    outputStrings: {
      getUnder: outputs/* default.getUnder */.Z.getUnder,
      intercards: {
        en: 'Intercards',
        de: 'Interkardinal',
        fr: 'Intercardinal',
        ja: '斜めへ',
        cn: '四角',
        ko: '대각선 쪽으로'
      },
      underPuff: {
        en: 'Under green puff',
        de: 'Unter grünem Puschel',
        fr: 'Sous le pompon vert',
        ja: '緑に貼り付く',
        cn: '站在绿球下',
        ko: '초록색 구슬 밑으로'
      },
      avoidPuffs: {
        en: 'Avoid puff aoes',
        de: 'Weiche den Puschel AoEs aus',
        fr: 'Évitez les AoE des pompons',
        ja: 'たまからのゆか避けて',
        cn: '躲避球AOE',
        ko: '구슬 장판 피하기'
      }
    }
  }, {
    id: 'ASS Total Wash',
    type: 'StartsUsing',
    netRegex: {
      id: '7750',
      source: 'Silkie',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'ASS Fresh Puff 2 Bait',
    // 4 puffs on cardinals or intercardinals with tethers
    type: 'Tether',
    netRegex: {
      source: 'Silken Puff'
    },
    condition: (data, matches) => matches.target === data.me && data.puffCounter === 2,
    durationSeconds: 6,
    alertText: (data, matches, output) => {
      const dirCards = ['N', 'E', 'S', 'W'];
      let silkieStatus = undefined;
      switch (data.suds) {
        case 'CE1':
          // Middle Safe
          silkieStatus = 'bossWind';
          break;
        case 'CE2':
          // Intercards Safe
          silkieStatus = 'bossIce';
        // never CE3 (lightning) for this mechanic
      }

      if (silkieStatus === undefined) return output.default();
      const tetheredPuff = data.silkenPuffs[matches.sourceId];
      if (tetheredPuff === undefined) return;

      // See Silken Puff Suds Gain trigger for list of Silken Puff effectIds
      // Puff must be either CEA (Ice / blue) or CEB (Lightning / yellow) in this mechanic
      const puffEffect = tetheredPuff.effect === another_sildihn_subterrane_puffIce ? 'Blue' : 'Yellow';
      const puffDir = tetheredPuff.location;
      if (puffDir === undefined) return output.default();
      const puffLocs = dirCards.includes(puffDir) ? 'Cardinal' : 'Intercard';
      const baitOutput = `${silkieStatus + puffEffect + puffLocs}Puff`;
      const safeOutput = `${silkieStatus}Puffs${puffLocs}SafeLater`;

      // set the output for the subsequent safe call here and pass the output to the followup trigger
      // this keeps all of the interrelated output strings in this trigger for ease of customization
      data.freshPuff2SafeAlert = output[safeOutput]();
      return output.bait({
        boss: output[silkieStatus](),
        dir: output[puffDir](),
        puff: output[baitOutput]()
      });
    },
    outputStrings: {
      N: outputs/* default.dirN */.Z.dirN,
      E: outputs/* default.dirE */.Z.dirE,
      S: outputs/* default.dirS */.Z.dirS,
      W: outputs/* default.dirW */.Z.dirW,
      NW: outputs/* default.dirNW */.Z.dirNW,
      NE: outputs/* default.dirNE */.Z.dirNE,
      SE: outputs/* default.dirSE */.Z.dirSE,
      SW: outputs/* default.dirSW */.Z.dirSW,
      bait: {
        en: '${boss} - ${dir} ${puff}',
        de: '${boss} - ${dir} ${puff}',
        fr: '${boss} - ${dir} ${puff}',
        ja: '${boss} - ${dir} ${puff}',
        cn: '${boss} - ${dir} ${puff}',
        ko: '${boss} - ${dir} ${puff}'
      },
      bossIce: {
        en: 'Blue Tail',
        de: 'Blauer Schweif',
        fr: 'Queue bleue',
        ja: '青しっぽ',
        cn: '蓝尾巴',
        ko: '파란색 꼬리'
      },
      bossIcePuffsCardinalSafeLater: {
        en: 'Intercard Safe',
        de: 'Interkardinal sicher',
        fr: 'Intercardinal sûr',
        ja: '斜め',
        cn: '四角安全',
        ko: '대각선이 안전'
      },
      bossIcePuffsIntercardSafeLater: {
        en: 'Intercard Safe',
        de: 'Interkardinal sicher',
        fr: 'Intercardinal sûr',
        ja: '斜め',
        cn: '四角安全',
        ko: '대각선이 안전'
      },
      bossWind: {
        en: 'Green Tail',
        de: 'Grüner Schweif',
        fr: 'Queue verte',
        ja: '緑しっぽ',
        cn: '绿尾巴',
        ko: '초록색 꼬리'
      },
      bossWindPuffsCardinalSafeLater: {
        en: 'Middle Safe',
        de: 'Mitte sicher',
        fr: 'Milieu sûr',
        ja: '真ん中',
        cn: '中间安全',
        ko: '가운데가 안전'
      },
      bossWindPuffsIntercardSafeLater: {
        en: 'Middle Safe',
        de: 'Mitte sicher',
        fr: 'Milieu sûr',
        ja: '真ん中',
        cn: '中间安全',
        ko: '가운데가 안전'
      },
      // keep tethered puff info as separate outputStrings
      // so users can customize for their particular strat
      bossIceBlueCardinalPuff: {
        en: 'Blue Puff',
        de: 'Blauer Puschel',
        fr: 'Pompon bleu',
        ja: '青たま',
        cn: '蓝球',
        ko: '파란색 구슬'
      },
      bossIceBlueIntercardPuff: {
        en: 'Blue Puff',
        de: 'Blauer Puschel',
        fr: 'Pompon bleu',
        ja: '青たま',
        cn: '蓝球',
        ko: '파란색 구슬'
      },
      bossIceYellowCardinalPuff: {
        en: 'Yellow Puff',
        de: 'Gelber Puschel',
        fr: 'Pompon jaune',
        ja: '黄色たま',
        cn: '黄球',
        ko: '노란색 구슬'
      },
      bossIceYellowIntercardPuff: {
        en: 'Yellow Puff',
        de: 'Gelber Puschel',
        fr: 'Pompon jaune',
        ja: '黄色たま',
        cn: '黄球',
        ko: '노란색 구슬'
      },
      bossWindBlueCardinalPuff: {
        en: 'Blue Puff',
        de: 'Blauer Puschel',
        fr: 'Pompon bleu',
        ja: '青たま',
        cn: '蓝球',
        ko: '파란색 구슬'
      },
      bossWindBlueIntercardPuff: {
        en: 'Blue Puff',
        de: 'Blauer Puschel',
        fr: 'Pompon bleu',
        ja: '青たま',
        cn: '蓝球',
        ko: '파란색 구슬'
      },
      bossWindYellowCardinalPuff: {
        en: 'Yellow Puff',
        de: 'Gelber Puschel',
        fr: 'Pompon jaune',
        ja: '黄色たま',
        cn: '黄球',
        ko: '노란색 구슬'
      },
      bossWindYellowIntercardPuff: {
        en: 'Yellow Puff',
        de: 'Gelber Puschel',
        fr: 'Pompon jaune',
        ja: '黄色たま',
        cn: '黄球',
        ko: '노란색 구슬'
      },
      default: {
        en: 'Bait puff',
        de: 'Puschel ködern',
        fr: 'Attirez le pompon',
        ja: 'たま誘導',
        cn: '诱导球',
        ko: '구슬 유도'
      }
    }
  }, {
    id: 'ASS Fresh Puff 2 Safe',
    type: 'Tether',
    netRegex: {
      source: 'Silken Puff'
    },
    condition: (data, matches) => matches.target === data.me && data.puffCounter === 2,
    delaySeconds: 6.5,
    // wait for bait alert to no longer display
    alertText: (data, _matches, output) => {
      if (data.freshPuff2SafeAlert !== undefined) return output.safe({
        safe: data.freshPuff2SafeAlert
      });
      return;
    },
    outputStrings: {
      safe: {
        en: '${safe}',
        de: '${safe}',
        fr: '${safe}',
        ja: '${safe}',
        cn: '${safe}',
        ko: '${safe}'
      }
    }
  }, {
    id: 'ASS Brim Over',
    type: 'Ability',
    netRegex: {
      id: '776E',
      source: 'Eastern Ewer',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.avoidEwers(),
    outputStrings: {
      avoidEwers: {
        en: 'Avoid Ewers',
        de: 'Krug ausweichen',
        fr: 'Évitez les aiguières',
        ja: '壺確認',
        cn: '躲避水壶',
        ko: '항아리 피하기'
      }
    }
  }, {
    // For Fresh Puff 3, there are eight Silken Puffs in two rows.  Six are then "rinsed" by Eastern Ewers.
    // After suds effects are applied to all eight Silken Puffs, Silkie uses 'Eastern Ewers' (776D),
    // followed by three (existing) Eastern Ewer combatants using 'Brim Over' (776E).
    // ~1.6 seconds later, 3 new 'Eastern Ewer' combatants are added, who begin using 'Rinse' (776F).
    // They repeat using the Rinse ability about ~0.85 seconds as they move N->S through the arena.
    // On three of those recasts, they target the ability on Silken Puffs in their column (same ability ID, 776F):
    // 1st targets the N-most Puff; 2nd targets both Puffs in the column (separate 21 lines for each Puff); and 3rd targets just the S Puff.
    // As each Puff is targeted by a Rinse ability, it loses its Suds effect.
    // This trigger fires off of the first targeted use of 'Rinse'.
    id: 'ASS Fresh Puff 3',
    type: 'Ability',
    netRegex: {
      id: '776F',
      source: 'Eastern Ewer',
      target: 'Silken Puff',
      capture: false
    },
    delaySeconds: 1.1,
    // wait for the Ewers to 'rinse' the six puffs, leaving 2 with status effects
    durationSeconds: 6,
    // leave alert up while Ewers finish rinsing until Puffs detonate
    suppressSeconds: 2,
    alertText: (data, _matches, output) => {
      if (Object.keys(data.silkenPuffs).length !== 2) return output.default();

      // Green and yellow are very hard to differentiate for some colorblind folks,
      // so give a north/south direction for any green or yellow.
      let dirStr = output.unknown();
      for (const puff of Object.values(data.silkenPuffs)) {
        if (puff.effect === another_sildihn_subterrane_puffWind || puff.effect === another_sildihn_subterrane_puffLightning) {
          dirStr = puff.y < another_sildihn_subterrane_silkieCenterY ? output.northPuff() : output.southPuff();

          // Wind takes precedence (since it can be with lightning)
          if (puff.effect === another_sildihn_subterrane_puffWind) break;
        }
      }

      // sort to simplify switch statement later
      const [puff0, puff1] = Object.values(data.silkenPuffs).map(x => x.effect).sort();

      // See Silken Puff Suds Gain trigger for list of Silken Puff effectIds
      if (puff0 === another_sildihn_subterrane_puffWind && puff1 === another_sildihn_subterrane_puffLightning) return output.windAndLightning({
        dir: dirStr
      });
      if (puff0 === another_sildihn_subterrane_puffIce && puff1 === another_sildihn_subterrane_puffIce) return output.doubleIce();
      if (puff0 === another_sildihn_subterrane_puffIce && puff1 === another_sildihn_subterrane_puffLightning) return output.iceAndLightning({
        dir: dirStr
      });
      if (puff0 === another_sildihn_subterrane_puffLightning && puff1 === another_sildihn_subterrane_puffLightning) return output.doubleLightning();
      return output.default();
    },
    outputStrings: {
      windAndLightning: {
        en: 'Under ${dir} green puff',
        de: 'Unter den grünen Puschel im ${dir}',
        fr: 'Sous le pompon vert ${dir}',
        ja: '緑のたまの下へ: ${dir}',
        cn: '去 ${dir} 绿球下',
        ko: '${dir} 초록색 구슬 밑으로'
      },
      doubleIce: {
        en: 'Intercards, away from puffs',
        de: 'Interkardinal, weg von den Puscheln',
        fr: 'Intercadinal, loin des pompons',
        ja: '斜め、たまから離れる',
        cn: '去四角, 避开球',
        ko: '대각선으로, 구슬에서 떨어지기'
      },
      iceAndLightning: {
        en: 'Sides of ${dir} yellow puff',
        de: 'Seitlich des gelben Puschel im ${dir}',
        fr: 'Côté du pompon jaune ${dir}',
        ja: '緑のたまの横へ: ${dir}',
        cn: '站在 ${dir} 黄球旁',
        ko: '${dir} 노란색 구슬 옆으로'
      },
      doubleLightning: {
        en: 'Between puffs',
        de: 'Zwischen Puscheln',
        fr: 'Entre les pompons',
        ja: 'たまとたまの間',
        cn: '站在球之间',
        ko: '구슬 사이로'
      },
      default: {
        en: 'Avoid puff AOEs',
        de: 'Puschel AoEs vermeiden',
        fr: 'Évitez les AoE des pompons',
        ja: 'たまのゆか回避',
        cn: '躲避球AOE',
        ko: '구슬 장판 피하기'
      },
      northPuff: outputs/* default.north */.Z.north,
      southPuff: outputs/* default.south */.Z.south,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  },
  // ---------------- second trash ----------------
  {
    id: 'ASS Infernal Pain',
    type: 'StartsUsing',
    netRegex: {
      id: '7969',
      source: 'Sil\'dihn Dullahan',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'ASS Blighted Gloom',
    type: 'StartsUsing',
    netRegex: {
      id: '7966',
      source: 'Sil\'dihn Dullahan',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'ASS King\'s Will',
    type: 'StartsUsing',
    netRegex: {
      id: '7968',
      source: 'Sil\'dihn Dullahan',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'big autos',
        de: 'große Auto-Hits',
        fr: 'Grosses attaques auto',
        ja: '自己強化',
        cn: '强化平A',
        ko: '평타 강화'
      }
    }
  }, {
    id: 'ASS Hells\' Nebula',
    type: 'StartsUsing',
    netRegex: {
      id: '796C',
      source: 'Sil\'dihn Armor',
      capture: false
    },
    condition: data => data.role === 'healer' || data.job === 'BLU',
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'HP to 1',
        de: 'HP auf 1',
        fr: 'HP à 1',
        ja: '体力１!',
        cn: 'HP 归 1',
        ko: 'HP 1'
      }
    }
  }, {
    id: 'ASS Infernal Weight',
    type: 'StartsUsing',
    netRegex: {
      id: '796B',
      source: 'Sil\'dihn Armor',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'aoe + In',
        de: 'AoE + Rein',
        fr: 'AoE + Intérieur',
        ja: 'ヘビィ, 足元へ',
        cn: 'AOE + 去脚下',
        ko: '전체공격 + 안으로'
      }
    }
  }, {
    id: 'ASS Dominion Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '796A',
      source: 'Sil\'dihn Armor',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  },
  // ---------------- Gladiator of Sil'dih ----------------
  {
    id: 'ASS Flash of Steel',
    type: 'StartsUsing',
    netRegex: {
      id: '7671',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'ASS Rush of Might 1',
    // Boss casts 765C (12.2s) and 765B (10.2s), twice
    // Gladiator of Mirage casts 7659, 7658, 765A, these target the environment
    type: 'StartsUsing',
    netRegex: {
      id: ['7658', '7659', '765A']
    },
    infoText: (data, matches, output) => {
      data.mightCasts.push(matches);
      const [mirage1, mirage2] = data.mightCasts;
      if (data.mightCasts.length !== 2 || mirage1 === undefined || mirage2 === undefined) return;
      data.mightCasts = [];
      const lineMap = {
        '7658': 1,
        '7659': 2,
        '765A': 3
      };
      const [line1, line2] = [mirage1.id, mirage2.id].map(x => lineMap[x]);
      if (line1 === undefined || line2 === undefined) throw new not_reached/* UnreachableCode */.$();
      const centerY = -268;
      const isNorth = parseFloat(mirage1.y) < centerY;
      const is1East = parseFloat(mirage1.x) > parseFloat(mirage2.x);
      const isLine1Left = isNorth && is1East || !isNorth && !is1East;
      const [leftNum, rightNum] = isLine1Left ? [line1, line2] : [line2, line1];

      // Call out the bigger number first, as it's the direction you'll have to move the most.
      if (leftNum === 3 && rightNum === 2) return output.goLeft3Right2();
      if (leftNum === 3 && rightNum === 1) return output.goLeft3Right1();
      if (leftNum === 2 && rightNum === 1) return output.goLeft2Right1();
      if (rightNum === 3 && leftNum === 2) return output.goRight3Left2();
      if (rightNum === 3 && leftNum === 1) return output.goRight3Left1();
      if (rightNum === 2 && leftNum === 1) return output.goRight2Left1();
    },
    outputStrings: {
      goLeft3Right2: {
        en: 'Go 3 Left 2 Right',
        de: 'Gehe Links 3, Rechts 2',
        fr: '3 à gauche, 2 à droite',
        ja: '左: 3, 右: 2',
        cn: '左 3, 右 2',
        ko: '왼쪽3 오른쪽2'
      },
      goLeft3Right1: {
        en: 'Go 3 Left (on line)',
        de: 'Gehe Links 3 (auf der Linie)',
        fr: '3 à gauche (sur la ligne)',
        ja: '左: 3 (線の上)',
        cn: '左 3 (线上)',
        ko: '왼쪽3 (선 위)'
      },
      goLeft2Right1: {
        en: 'Go 2 Left (on line)',
        de: 'Gehe Links 2 (auf der Linie)',
        fr: '2 à gauche (sur la ligne)',
        ja: '左: 2 (線の上)',
        cn: '左 2 (线上)',
        ko: '왼쪽2 (선 위)'
      },
      goRight3Left2: {
        en: 'Go 3 Right 2 Left',
        de: 'Gehe Rechts 3, Links 2',
        fr: '3 à droite, 2 à gauche',
        ja: '右: 3, 左: 2',
        cn: '右 3, 左 2',
        ko: '오른쪽3 왼쪽2'
      },
      goRight3Left1: {
        en: 'Go 3 Right (on line)',
        de: 'Gehe Rechts 3 (auf der Linie)',
        fr: '3 à droite (sur la ligne)',
        ja: '右: 3 (線の上)',
        cn: '右 3 (线上)',
        ko: '오른쪽3 (선 위)'
      },
      goRight2Left1: {
        en: 'Go 2 Right (on line)',
        de: 'Gehe Rechts 2 (auf der Linie)',
        fr: '2 à droite (sur la ligne)',
        ja: '右: 2 (線の上)',
        cn: '右 2 (线上)',
        ko: '오른쪽2 (선 위)'
      }
    }
  }, {
    id: 'ASS Rush of Might 2',
    type: 'Ability',
    netRegex: {
      id: '765B',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.moveThrough(),
    outputStrings: {
      moveThrough: {
        en: 'Move through',
        de: 'Gehe durch',
        fr: 'Allez à travers',
        ja: '移動',
        cn: '穿穿穿',
        ko: '가로지르기'
      }
    }
  }, {
    id: 'ASS Sculptor\'s Passion',
    // This is a wild charge, player in front takes most damage
    type: 'Ability',
    netRegex: {
      id: '6854',
      source: 'Gladiator of Sil\'dih'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.chargeOnYou();
      return output.chargeOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      chargeOn: {
        en: 'Charge on ${player}',
        de: 'Ansturm auf ${player}',
        fr: 'Ruée sur ${player}',
        ja: '${player}に突進',
        cn: '直线分摊点${player}',
        ko: '"${player}" 돌진 대상'
      },
      chargeOnYou: {
        en: 'Charge on YOU',
        de: 'Ansturm auf DIR',
        fr: 'Ruée sur VOUS',
        ja: '自分に突進',
        cn: '直线分摊点名',
        ko: '돌진 대상자'
      }
    }
  }, {
    id: 'ASS Mighty Smite',
    type: 'StartsUsing',
    netRegex: {
      id: '7672',
      source: 'Gladiator of Sil\'dih'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'ASS Lingering Echoes',
    // CDC Lingering Echoes (Spread + Move)
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CDC'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: data => data.hasLingering = true,
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 2,
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'ASS Thunderous Echo Collect',
    // CDD Thunderous Echo (Stack)
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CDD'
    },
    preRun: (data, matches) => data.thunderousEchoPlayer = matches.target
  }, {
    id: 'ASS Curse of the Fallen',
    // CDA Echoes of the Fallen (Spread)
    // Two players will not have a second debuff, so check CDA
    // 14s = first
    // 17s = second
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CDA'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 0.1,
    durationSeconds: 10,
    infoText: (data, matches, output) => {
      const duration = parseFloat(matches.duration);
      data.isCurseSpreadFirst = duration < 16;
      if (data.isCurseSpreadFirst) {
        if (data.hasLingering) return output.spreadThenBait();
        if (data.me === data.thunderousEchoPlayer) return output.spreadThenStackOnYou();
        if (data.thunderousEchoPlayer === undefined) return output.spreadThenStack();
        return output.spreadThenStackOn({
          player: data.party.member(data.thunderousEchoPlayer)
        });
      }
      if (data.hasLingering) return output.baitThenSpread();
      if (data.me === data.thunderousEchoPlayer) return output.stackOnYouThenSpread();
      if (data.thunderousEchoPlayer === undefined) return output.stackThenSpread();
      return output.stackOnThenSpread({
        player: data.party.member(data.thunderousEchoPlayer)
      });
    },
    outputStrings: {
      stackThenSpread: outputs/* default.stackThenSpread */.Z.stackThenSpread,
      stackOnThenSpread: {
        en: 'Stack on ${player} => Spread',
        de: 'Auf ${player} sammeln => Verteilen',
        fr: 'Package sur ${player} -> Dispersion',
        ja: '${player}に頭割り => 散会',
        cn: '${player}处分摊 => 分散',
        ko: '${player} 쉐어 => 산개'
      },
      stackOnYouThenSpread: {
        en: 'Stack on YOU => Spread',
        de: 'Auf DIR sammeln => Verteilen',
        fr: 'Package sur VOUS -> Dispersion',
        ja: '自分に頭割り => 散会',
        cn: '分摊点名 => 分散',
        ko: '나에게 쉐어 => 산개'
      },
      spreadThenStack: outputs/* default.spreadThenStack */.Z.spreadThenStack,
      spreadThenStackOn: {
        en: 'Spread => Stack on ${player}',
        de: 'Verteilen => Auf ${player} sammeln',
        fr: 'Dispersion -> Package sur ${player}',
        ja: '散会 => ${player}に頭割り',
        cn: '分散 => ${player}处分摊',
        ko: '산개 => ${player} 쉐어'
      },
      spreadThenStackOnYou: {
        en: 'Spread => Stack on YOU',
        de: 'Verteilen => Auf DIR sammeln',
        fr: 'Dispersion -> package sur VOUS',
        ja: '散会 => 自分に頭割り',
        cn: '分散 => 分摊点名',
        ko: '산개 => 나에게 쉐어'
      },
      spreadThenBait: {
        en: 'Spread => Bait Puddle',
        de: 'Veretilen => Fläche ködern',
        fr: 'Dispersion -> Déposez',
        ja: '散会 => AOE誘導',
        cn: '分散 => 诱导AOE',
        ko: '산개 => 장판 유도'
      },
      baitThenSpread: {
        en: 'Bait Puddle => Spread',
        de: 'Fläche ködern => Veretilen',
        fr: 'Déposez -> Dispersion',
        ja: 'AOE誘導 => 散会',
        cn: '诱导AOE => 分散',
        ko: '장판 유도 => 산개'
      }
    }
  }, {
    id: 'ASS Ring of Might',
    // There are 6 spells:
    //   Ring 1: 765D (9.7s) / 7660 (11.7s)
    //   Ring 2: 765E (9.7s) / 7661 (11.7s)
    //   Ring 3: 765F (9.7s) / 7662 (11.7s)
    // Only tracking the 11.7s spell
    type: 'StartsUsing',
    netRegex: {
      id: ['7660', '7661', '7662'],
      source: 'Gladiator of Sil\'dih'
    },
    infoText: (_data, matches, output) => {
      if (matches.id === '7660') return output.outsideInner();
      if (matches.id === '7661') return output.outsideMiddle();
      return output.outsideOuter();
    },
    outputStrings: {
      outsideInner: {
        en: 'Outside Inner Ring',
        de: 'Außerhalb des inneren Ringes',
        fr: 'À l\'extérieur de l\'anneau intérieur',
        ja: 'リングチャージ１',
        cn: '出内圈',
        ko: '안쪽 고리 바깥'
      },
      outsideMiddle: {
        en: 'Outside Middle Ring',
        de: 'Außerhalb des mittleren Ringes',
        fr: 'À l\'extérieur de l\'anneau central',
        ja: 'リングチャージ２',
        cn: '出中圈',
        ko: '중간 고리 바깥'
      },
      outsideOuter: {
        en: 'Outside Outer Ring',
        de: 'Außerhalb des äußeren Ringes',
        fr: 'À l\'extérieur de l\'anneau extérieur',
        ja: 'リングチャージ３',
        cn: '出外圈',
        ko: '바깥쪽 고리 바깥'
      }
    }
  }, {
    id: 'ASS Curse of the Fallen Reminder',
    type: 'Ability',
    // Call this when the ring goes off and it's safe to move in.
    netRegex: {
      id: ['7660', '7661', '7662'],
      source: 'Gladiator of Sil\'dih'
    },
    suppressSeconds: 1,
    infoText: (data, matches, output) => {
      if (!data.isCurseSpreadFirst) return output.spread();
      if (data.hasLingering) return output.baitPuddle();
      if (matches.target === data.me) return output.stackOnYou();
      return output.stackOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      // TODO: should this also say "In", e.g. "In + Spread" or "Spread (In)"?
      baitPuddle: {
        en: 'Bait Puddle',
        de: 'Fläche ködern',
        fr: 'Déposez',
        ja: 'AOE誘導',
        cn: '诱导圈圈',
        ko: '장판 유도'
      },
      spread: outputs/* default.spread */.Z.spread,
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'ASS Nothing beside Remains',
    type: 'StartsUsing',
    netRegex: {
      id: '768C',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'ASS Accursed Visage Collect',
    // CDF = Gilded Fate
    // CE0 = Silvered Fate
    type: 'GainsEffect',
    netRegex: {
      effectId: ['CDF', 'CE0']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      const id = matches.effectId;
      if (id === 'CDF') data.myVisage.gold = parseInt(matches.count);else if (id === 'CE0') data.myVisage.silver = parseInt(matches.count);
    }
  }, {
    id: 'ASS Golden/Silver Flame Collector',
    // 766F = Golden Flame
    // 7670 = Silver Flame
    type: 'StartsUsing',
    netRegex: {
      id: ['766F', '7670'],
      source: 'Hateful Visage'
    },
    run: (data, matches) => {
      const x = Math.round(parseFloat(matches.x));
      const y = Math.round(parseFloat(matches.y));

      // These mobs have two faces, gold fires in the direction the mob is facing
      // and silver fires in reverse, so the heading needs to be reversed for silver.
      const isSilver = matches.id === '7670';
      const heading = (another_sildihn_subterrane_headingTo4Dir(parseFloat(matches.heading)) + (isSilver ? 2 : 0)) % 4;
      const dir = {
        north: 0,
        east: 1,
        south: 2,
        west: 3
      };
      const mark = (col, row) => {
        const visage = data.visageMap[another_sildihn_subterrane_visageMapIdx(col, row)] ??= {
          gold: 0,
          silver: 0
        };
        if (isSilver) visage.silver++;else visage.gold++;
      };

      // Possible values for positions:
      // x: [-50, -40, -35, -30, -20]
      // y: [-286, -276, -271, -266, -256]

      if (x === -35) {
        // vertical
        const row = Math.round((y + 286) / 10);
        if (heading === dir.west) {
          mark(0, row);
          mark(1, row);
        } else if (heading === dir.east) {
          mark(2, row);
          mark(3, row);
        }
      } else if (y === -271) {
        // horizontal
        const col = Math.round((x + 50) / 10);
        if (heading === dir.north) {
          mark(col, 0);
          mark(col, 1);
        } else if (heading === dir.south) {
          mark(col, 2);
          mark(col, 3);
        }
      }
    }
  }, {
    id: 'ASS Golden/Silver Flame',
    // 766F = Golden Flame
    // 7670 = Silver Flame
    type: 'StartsUsing',
    netRegex: {
      id: ['766F', '7670'],
      source: 'Hateful Visage',
      capture: false
    },
    delaySeconds: 0.3,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      // The four inside corners.
      const uptimeIdx = [5, 6, 9, 10];
      const target = {
        gold: data.myVisage.silver,
        silver: data.myVisage.gold
      };
      const targetIsEmpty = target.gold === 0 && target.silver === 0;
      const squares = targetIsEmpty ? uptimeIdx : [...Array(16).keys()];
      let locStr = output.unknown();
      for (const idx of squares) {
        const visage = data.visageMap[idx] ?? {
          gold: 0,
          silver: 0
        };
        if (visage.gold === target.gold && visage.silver === target.silver) {
          locStr = {
            0: output.outsideNW(),
            1: output.outsideNNW(),
            2: output.outsideNNE(),
            3: output.outsideNE(),
            4: output.outsideWNW(),
            5: output.insideNW(),
            6: output.insideNE(),
            7: output.outsideENE(),
            8: output.outsideWSW(),
            9: output.insideSW(),
            10: output.insideSE(),
            11: output.outsideESE(),
            12: output.outsideSW(),
            13: output.outsideSSW(),
            14: output.outsideSSE(),
            15: output.outsideSE()
          }[idx] ?? output.unknown();
          break;
        }
      }
      if (target.silver > 0) {
        if (target.gold > 0) return output.bothFates({
          loc: locStr
        });
        return output.gildedFate({
          loc: locStr
        });
      }
      if (target.gold > 0) return output.silveredFate({
        loc: locStr
      });
      return output.neitherFate({
        loc: locStr
      });
    },
    run: data => data.visageMap = {},
    outputStrings: {
      bothFates: {
        en: 'Get hit by silver and gold (${loc})',
        de: 'Von Silber und Gold treffen lassen (${loc})',
        fr: 'Faites-vous toucher par l\'argent et l\'or (${loc})',
        ja: '金銀 一個ずつ (${loc})',
        cn: '吃金和银 (${loc})',
        ko: '은색 + 금색 맞기 (${loc})'
      },
      gildedFate: {
        en: 'Get hit by two silver (${loc})',
        de: 'Von 2 Silber treffen lassen (${loc})',
        fr: 'Faites-vous toucher par deux argent (${loc})',
        ja: '銀 二つ (${loc})',
        cn: '吃两个银 (${loc})',
        ko: '은색 2개 맞기 (${loc})'
      },
      silveredFate: {
        en: 'Get hit by two gold (${loc})',
        de: 'Von 2 Gold treffen lassen (${loc})',
        fr: 'Faites-vous toucher par deux or (${loc})',
        ja: '金 二つ (${loc})',
        cn: '吃两个金 (${loc})',
        ko: '금색 2개 맞기 (${loc})'
      },
      neitherFate: {
        en: 'Avoid lasers (uptime ${loc})',
        de: 'Vermeide Silber und Gold (${loc})',
        fr: 'Évitez les lasers (${loc})',
        ja: '顔からのビーム全部回避 (${loc})',
        cn: '都不吃 (${loc})',
        ko: '레이저 피하기 (업타임 ${loc})'
      },
      outsideNW: {
        en: 'NW Corner',
        de: 'NW Ecke',
        fr: 'Coin NO',
        ja: '北西 隅',
        cn: '左上 (西北) 角',
        ko: '북서쪽 구석'
      },
      outsideNNW: {
        en: 'NNW Outside',
        de: 'NNW außen',
        fr: 'Extérieur NNO',
        ja: '1列 西の内側',
        cn: '外侧 上偏左 (北偏西)',
        ko: '바깥 북쪽 왼칸'
      },
      outsideNNE: {
        en: 'NNE Outside',
        de: 'NNO außen',
        fr: 'Extérieur NNE',
        ja: '1列 東の内側',
        cn: '外侧 上偏右 (北偏东)',
        ko: '바깥 북쪽 오른칸'
      },
      outsideNE: {
        en: 'NE Corner',
        de: 'NO Ecke',
        fr: 'Coin NE',
        ja: '北東 隅',
        cn: '右上 (东北) 角',
        ko: '북동쪽 구석'
      },
      outsideWNW: {
        en: 'WNW Outside',
        de: 'WNW außen',
        fr: 'Extérieur ONO',
        ja: '2列 西の外側',
        cn: '外侧 左偏上 (西偏北)',
        ko: '바깥 서쪽 위칸'
      },
      insideNW: {
        en: 'NW Inside',
        de: 'NW innen',
        fr: 'Intérieur NO',
        ja: '内側 北西',
        cn: '内侧 左上 (西北)',
        ko: '안 북서쪽'
      },
      insideNE: {
        en: 'NE Inside',
        de: 'NO innen',
        fr: 'Intérieur NE',
        ja: '内側 北東',
        cn: '内侧 右上 (东北)',
        ko: '안 북동쪽'
      },
      outsideENE: {
        en: 'ENE Outside',
        de: 'ONO außen',
        fr: 'Extérieur ENE',
        ja: '2列 東の外側',
        cn: '外侧 右偏上 (东偏北)',
        ko: '바깥 동쪽 위칸'
      },
      outsideWSW: {
        en: 'WSW Outside',
        de: 'WSW außen',
        fr: 'Extérieur OSO',
        ja: '3列 西の外側',
        cn: '外侧 左偏下 (西偏南)',
        ko: '바깥 서쪽 아래칸'
      },
      insideSW: {
        en: 'SW Inside',
        de: 'SW innen',
        fr: 'Intérieur SO',
        ja: '内側 南西',
        cn: '内侧 左下 (西南)',
        ko: '안 남서쪽'
      },
      insideSE: {
        en: 'SE Inside',
        de: 'SO innen',
        fr: 'Intérieur SE',
        ja: '内側 南東',
        cn: '内侧 右下 (东南)',
        ko: '안 남동쪽'
      },
      outsideESE: {
        en: 'ESE Outside',
        de: 'OSO außen',
        fr: 'Extérieur ESE',
        ja: '3列 東の外側',
        cn: '外侧 右偏下 (东偏南)',
        ko: '바깥 동쪽 아래칸'
      },
      outsideSW: {
        en: 'SW Corner',
        de: 'SW Ecke',
        fr: 'Coin SO',
        ja: '南西 隅',
        cn: '左下 (西南) 角',
        ko: '남서쪽 구석'
      },
      outsideSSW: {
        en: 'SSW Outside',
        de: 'SSW außen',
        fr: 'Extérieur SSO',
        ja: '4列 西の内側',
        cn: '外侧 下偏左 (南偏西)',
        ko: '바깥 남쪽 왼칸'
      },
      outsideSSE: {
        en: 'SSE Outside',
        de: 'SSO außen',
        fr: 'Extérieur SSE',
        ja: '4列 東の内側',
        cn: '外侧 下偏右 (南偏东)',
        ko: '바깥 남쪽 오른칸'
      },
      outsideSE: {
        en: 'SE Corner',
        de: 'SO Ecke',
        fr: 'Coin SE',
        ja: '南東 隅',
        cn: '右下 (东南) 角',
        ko: '남동쪽 구석'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'ASS Sundered Remains',
    // Using 7666 Curse of the Monument
    type: 'StartsUsing',
    netRegex: {
      id: '7666',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Middle, Shiva Circles',
        de: 'In die Mitte, Shiva Kreise',
        fr: 'Allez au milieu, cercles de Shiva',
        ja: '真ん中でAOE輪っか確認',
        cn: '中间集合, 九连环',
        ko: '중앙으로, 시바 얼음 장판'
      }
    }
  }, {
    id: 'ASS Curse of the Monument',
    type: 'Ability',
    netRegex: {
      id: '7666',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    response: responses/* Responses.breakChains */.n3.breakChains()
  }, {
    id: 'ASS Scream of the Fallen Collect',
    // CDB = Scream of the Fallen (defamation)
    // BBC = First in Line
    // BBD = Second in Line
    // First/Second in Line are only used once all dungeon so we can just trigger off of them
    type: 'GainsEffect',
    netRegex: {
      effectId: 'BB[CD]'
    },
    run: (data, matches) => data.screamOfTheFallen[matches.target] = matches.effectId
  }, {
    id: 'ASS Scream of the Fallen',
    // BBC = First in Line
    // BBD = Second in Line
    type: 'GainsEffect',
    netRegex: {
      effectId: 'BB[CD]',
      capture: false
    },
    // These debuffs go out very early while running out for chains,
    // so call as people are dodging into the safe spot.
    delaySeconds: 8,
    durationSeconds: 4,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      const myBuff = data.screamOfTheFallen[data.me];
      if (myBuff === undefined) return;

      // Figure out partner, so that you know if the person running out
      // with you has the same debuff.
      let partner = output.unknown();
      for (const [name, id] of Object.entries(data.screamOfTheFallen)) {
        if (name === data.me) continue;
        if (id === myBuff) {
          partner = data.party.member(name);
          break;
        }
      }
      if (myBuff === another_sildihn_subterrane_firstInLine) return output.spreadFirst({
        player: partner
      });
      return output.soakFirst({
        player: partner
      });
    },
    outputStrings: {
      soakFirst: {
        en: 'Soak First Towers (with ${player})',
        de: 'Steh im ersten Turm (mit ${player})',
        fr: 'Prenez les tours (avec ${player})',
        ja: 'さきに塔を踏み (+${player})',
        cn: '踩 1 塔 (与${player})',
        ko: '첫번째 기둥 밟기 (${player})'
      },
      spreadFirst: {
        en: 'Spread First (with ${player})',
        de: 'Zuerst verteilen (mit ${player})',
        fr: 'Écartez-vous d\'abord (avec ${player})',
        ja: 'さきに散会 (+${player})',
        cn: '先分散 (与${player})',
        ko: '산개 먼저 (${player})'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'ASS Scream of the Fallen Towers Second',
    type: 'Ability',
    // Triggers off the "Scream of the Fallen" ability from the defamation.
    netRegex: {
      id: '7678',
      source: 'Gladiator of Sil\'dih'
    },
    condition: (data, matches) => {
      if (data.me !== matches.target) return;
      return data.screamOfTheFallen[data.me] === another_sildihn_subterrane_firstInLine;
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.soakSecond(),
    outputStrings: {
      soakSecond: {
        en: 'Soak Second Towers',
        de: 'Steh im zweiten Turm',
        fr: 'Prenez les 2nd tours',
        ja: '塔を踏み',
        cn: '踩 2 塔',
        ko: '두번째 기둥 밟기'
      }
    }
  }, {
    id: 'ASS Scream of the Fallen Spread Second',
    type: 'Ability',
    // Triggers off the "Explosion" ability from the towers.
    netRegex: {
      id: '766A',
      source: 'Gladiator of Sil\'dih'
    },
    condition: (data, matches) => {
      if (data.me !== matches.target) return;
      return data.screamOfTheFallen[data.me] === another_sildihn_subterrane_secondInLine;
    },
    suppressSeconds: 1,
    response: responses/* Responses.spread */.n3.spread()
  },
  // ---------------- Shadowcaster Zeless Gah ----------------
  {
    id: 'ASS Show of Strength',
    type: 'StartsUsing',
    netRegex: {
      id: '74AF',
      source: 'Shadowcaster Zeless Gah',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'ASS Firesteel Fracture',
    type: 'StartsUsing',
    netRegex: {
      id: '74AD',
      source: 'Shadowcaster Zeless Gah'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'ASS Infern Brand Counter',
    type: 'StartsUsing',
    netRegex: {
      id: '7491',
      source: 'Shadowcaster Zeless Gah',
      capture: false
    },
    run: data => {
      data.brandCounter++;
      data.arcaneFontCounter = 0;
    }
  }, {
    id: 'ASS Arcane Font Tracker',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Arcane Font',
      capture: false
    },
    // Only run this trigger for second Infern Band, first set of portals
    condition: data => data.myFlame === undefined,
    run: data => data.arcaneFontCounter++
  }, {
    id: 'ASS Infern Brand Collect',
    // Count field on 95D on Infern Brand indicates Brand's number:
    //   1C2 - 1C5, Orange 1 - 4
    //   1C6 - 1C9, Blue 1 - 4
    type: 'GainsEffect',
    netRegex: {
      effectId: '95D',
      target: 'Infern Brand'
    },
    run: (data, matches) => data.brandEffects[parseInt(matches.targetId, 16)] = matches.count
  }, {
    id: 'ASS Infern Brand 2 Starting Corner',
    // CC4 First Brand
    // CC5 Second Brand
    // CC6 Third Brand
    // CC7 Fourth Brand
    type: 'GainsEffect',
    netRegex: {
      effectId: ['CC4', 'CC5', 'CC6', 'CC7']
    },
    condition: (data, matches) => data.me === matches.target && data.brandCounter === 2,
    delaySeconds: 0.2,
    // Delay to collect all Infern Brand Effects
    durationSeconds: (_data, matches) => parseFloat(matches.duration) - 0.1,
    infoText: (data, matches, output) => {
      const brandMap = {
        'CC4': 1,
        'CC5': 2,
        'CC6': 3,
        'CC7': 4
      };
      const myNum = brandMap[matches.effectId];
      if (myNum === undefined) throw new not_reached/* UnreachableCode */.$();

      // Store for later trigger
      data.myFlame = myNum;
      if (Object.keys(data.brandEffects).length !== 8) {
        // Missing Infern Brands, output number
        if (data.arcaneFontCounter === 3) return output.blueBrandNum({
          num: myNum
        });
        if (data.arcaneFontCounter === 2) return output.orangeBrandNum({
          num: myNum
        });
        return output.brandNum({
          num: myNum
        });
      }

      // Brands are located along East and South wall and in order by id
      // Blue N/S:
      //   304.00, -108.00, Used for NW/NE, 0 north
      //   304.00, -106.00, Used for NW/NE, 1 north
      //   304.00, -104.00, Used for SW/SE, 2 south
      //   304.00, -102.00, Used for SW/SE, 3 south
      // Orange E/W:
      //   286.00, -85.00, Used for SW/NW, 4 west
      //   288.00, -85.00, Used for SW/NW, 5 west
      //   290.00, -85.00, Used for SE/NE, 6 east
      //   292.00, -85.00, Used for SE/NE, 7 east
      // Set brandEffects to descending order to match
      const brandEffects = Object.entries(data.brandEffects).sort((a, b) => a[0] > b[0] ? -1 : 1);

      // Get just the effectIds
      const effectIds = brandEffects.map(value => {
        return value.slice(1, 2)[0];
      });

      // Split the results
      const blueBrands = effectIds.slice(0, 4);
      const orangeBrands = effectIds.slice(4, 8);
      const myNumToBlue = {
        4: '1C9',
        3: '1C8',
        2: '1C7',
        1: '1C6'
      };
      const myNumToOrange = {
        4: '1C5',
        3: '1C4',
        2: '1C3',
        1: '1C2'
      };

      // Find where our numbers are in each set of brands
      const x = orangeBrands.indexOf(myNumToOrange[myNum]);
      const y = blueBrands.indexOf(myNumToBlue[myNum]) + 4;
      const indexToCardinal = {
        0: 'south',
        1: 'south',
        2: 'north',
        3: 'north',
        4: 'east',
        5: 'east',
        6: 'west',
        7: 'west'
      };
      const cardX = indexToCardinal[x];
      const cardY = indexToCardinal[y];

      // Not able to be undefined as values determined from array that only has 8 indices
      if (cardX === undefined || cardY === undefined) throw new not_reached/* UnreachableCode */.$();

      // Check color of brand that will be cut
      if (data.arcaneFontCounter === 3) return output.blueBrandNumCorner({
        num: myNum,
        corner: output[cardX + cardY]()
      });
      if (data.arcaneFontCounter === 2) return output.orangeBrandNumCorner({
        num: myNum,
        corner: output[cardX + cardY]()
      });
      return output.brandNumCorner({
        num: myNum,
        corner: output[cardX + cardY]()
      });
    },
    run: data => data.brandEffects = {},
    outputStrings: {
      blueBrandNumCorner: {
        en: 'Blue Brand ${num}: ${corner} corner',
        de: 'Blaues Kryptogramm ${num}: ${corner} Ecke',
        fr: 'Étendard bleu ${num}: coin ${corner}',
        ja: '青線${num}: ${corner}の隅',
        cn: '蓝线${num}: ${corner}角',
        ko: '파란색 선 ${num}: ${corner} 구석'
      },
      orangeBrandNumCorner: {
        en: 'Orange Brand ${num}: ${corner} corner',
        de: 'Oranges Kryptogramm ${num}: ${corner} Ecke',
        fr: 'Étendard orange ${num}: coin ${corner}',
        ja: '赤線${num}: ${corner}の隅',
        cn: '红线${num}: ${corner}角',
        ko: '주황색 선 ${num}: ${corner} 구석'
      },
      brandNumCorner: {
        en: 'Brand ${num}: ${corner} corner',
        de: 'Kryptogramm ${num}: ${corner} Ecke',
        fr: 'Étendard ${num}: coin ${corner}',
        ja: '線${num}: ${corner}の隅',
        cn: '线${num}: ${corner}角',
        ko: '선 ${num}: ${corner} 구석'
      },
      blueBrandNum: {
        en: 'Blue Brand ${num}',
        de: 'Blaues Kryptogramm ${num}',
        fr: 'Étendard bleu ${num}',
        ja: '青線${num}',
        cn: '蓝线${num}',
        ko: '파란색 선 ${num}'
      },
      orangeBrandNum: {
        en: 'Orange Brand ${num}',
        de: 'Oranges Kryptogramm ${num}',
        fr: 'Étendard orange ${num}',
        ja: '赤線${num}',
        cn: '红线${num}',
        ko: '주황색 선 ${num}'
      },
      brandNum: {
        en: 'Brand ${num}',
        de: 'Kryptogramm ${num}',
        fr: 'Étendard ${num}',
        ja: '線${num}',
        cn: '线${num}',
        ko: '선 ${num}'
      },
      northwest: outputs/* default.northwest */.Z.northwest,
      northeast: outputs/* default.northeast */.Z.northeast,
      southeast: outputs/* default.southeast */.Z.southeast,
      southwest: outputs/* default.southwest */.Z.southwest
    }
  }, {
    id: 'ASS Infern Brand 2 First Flame',
    // CC8 First Flame
    // CC9 Second Flame
    // CCA Third Flame
    // CCB Fourth Flame
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CC8'
    },
    condition: (data, matches) => data.me === matches.target && data.brandCounter === 2,
    alertText: (data, _matches, output) => {
      // Blue lines cut when three (West)
      if (data.arcaneFontCounter === 3) {
        // Set to two for 5th cut's color
        data.arcaneFontCounter = 2;
        return output.cutBlueOne();
      }

      // Orange lines cut when two (North)
      if (data.arcaneFontCounter === 2) {
        // Set to three for 5th cut's color
        data.arcaneFontCounter = 3;
        return output.cutOrangeOne();
      }
      return output.firstCut();
    },
    outputStrings: {
      cutBlueOne: {
        en: 'Cut Blue 1',
        de: 'Blau 1 durchtrennen',
        fr: 'Coupez Bleu 1',
        ja: '青線1 切る',
        cn: '剪蓝线 1',
        ko: '파란색 1 끊기'
      },
      cutOrangeOne: {
        en: 'Cut Orange 1',
        de: 'Orange 1 durchtrennen',
        fr: 'Coupez Orange 1',
        ja: '赤線1 切る',
        cn: '剪红线 1',
        ko: '주황색 1 끊기'
      },
      firstCut: {
        en: 'First Cut',
        de: 'Als Erster durchtrennen',
        fr: 'Coupe en 1er',
        ja: '線1 切る',
        cn: '剪线 1',
        ko: '첫번째 선 끊기'
      }
    }
  }, {
    id: 'ASS Infern Brand 2 Remaining Flames',
    // Player receives Magic Vulnerability Up from Cryptic Flame for 7.96s after cutting
    // Trigger will delay for this Magic Vulnerability Up for safety
    // No exception for time remaining on debuff to sacrafice to cut the line
    type: 'LosesEffect',
    netRegex: {
      effectId: '95D',
      target: 'Infern Brand',
      count: '1C[2-9]'
    },
    condition: (data, matches) => {
      if (data.myFlame !== undefined && data.brandCounter === 2) {
        const countToNum = {
          '1C9': 4,
          '1C8': 3,
          '1C7': 2,
          '1C6': 1,
          '1C5': 4,
          '1C4': 3,
          '1C3': 2,
          '1C2': 1
        };

        // Check which flame order this is
        const flameCut = countToNum[matches.count];
        if (flameCut === undefined) return false;

        // Wraparound and add 1 as we need next flame to cut
        // Check if not our turn to cut
        if (flameCut % 4 + 1 !== data.myFlame) return false;
        return true;
      }
      return false;
    },
    delaySeconds: (data, matches) => {
      if (data.myLastCut === undefined) return 0;

      // Check if we still need to delay for Magic Vulnerability Up to expire
      // Magic Vulnerability Up lasts 7.96 from last cut
      const delay = 7.96 - (Date.parse(matches.timestamp) - data.myLastCut) / 1000;
      if (delay > 0) return delay;
      return 0;
    },
    alertText: (data, matches, output) => {
      if (data.arcaneFontCounter === 3 && matches.count.match(/1C[6-8]/)) {
        // Expected Blue and count is Blue
        data.arcaneFontCounter = 2;
        return output.cutBlueNum({
          num: data.myFlame
        });
      }
      if (data.arcaneFontCounter === 2 && matches.count.match(/1C[2-4]/)) {
        // Expected Orange and count is Orange
        data.arcaneFontCounter = 3;
        return output.cutOrangeNum({
          num: data.myFlame
        });
      }

      // Exception for First Flame on second set
      if (data.myFlame === 1) {
        if (data.arcaneFontCounter === 3 && matches.count === '1C5') return output.cutBlueNum({
          num: data.myFlame
        });
        if (data.arcaneFontCounter === 2 && matches.count === '1C9') return output.cutOrangeNum({
          num: data.myFlame
        });
      }
      // Unexpected result, mechanic is likely failed at this point
    },

    run: data => data.brandEffects = {},
    outputStrings: {
      cutOrangeNum: {
        en: 'Cut Orange ${num}',
        de: 'Orange ${num} durchtrennen',
        fr: 'Coupez Orange ${num}',
        ja: '赤線${num} 切る',
        cn: '剪红线 ${num}',
        ko: '주황색 ${num} 끊기'
      },
      cutBlueNum: {
        en: 'Cut Blue ${num}',
        de: 'Blau ${num} durchtrennen',
        fr: 'Coupez Bleu ${num}',
        ja: '青線${num} 切る',
        cn: '剪蓝线 ${num}',
        ko: '파란색 ${num} 끊기'
      }
    }
  }, {
    id: 'ASS Infern Brand Cryptic Flame Collect',
    // Collect timestamp for when last cut flame
    type: 'Ability',
    netRegex: {
      id: '74B7',
      source: 'Infern Brand'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => data.myLastCut = Date.parse(matches.timestamp)
  }, {
    id: 'ASS Banishment',
    // Players receive invisible effect that indicates rotation and direction
    // of their teleport attached teleport pad
    //
    // At the same time, two teleports on North and South are also marked:
    // one rotates outside the arena, the other rotates towards the inner rows
    // Players have 12s to teleport using the safe teleports prior to Call of
    // the Portal (CCC) expiration
    //
    // The first teleports occur at ~11.4s after these debuff go out
    // After first teleport, lasers block rows but can be teleported over
    // Hitting a laser results in stun and likely death
    //
    // Seconds after first teleport, two wards will go off that target the
    // two nearest players. Players need to have teleported close enough
    // to the ward to bait the ward away from other players
    //
    // Following the first set of baits, the player's teleport will go off
    // which should have been positioned to teleport across the laser to bait
    // the final ward away from other players
    //
    // 1CD Blue (Counterclockwise) Teleporting East
    // 1CE Orange (Clockwise) Teleporting West
    // 1D2 Orange (Clockwise) Teleporting East
    // 1D3 Blue (Counterclockwise) Teleporting West
    //
    // There are multiple strategies, so this only describes what you have,
    // from there you can create a personal call of where to go
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, matches, output) => {
      switch (matches.count) {
        case '1CD':
          return output.blueEast();
        case '1CE':
          return output.orangeWest();
        case '1D2':
          return output.orangeEast();
        case '1D3':
          return output.blueWest();
      }
    },
    outputStrings: {
      blueEast: {
        en: 'Blue Teleporting East',
        de: 'Blau Teleport nach Osten',
        fr: 'Téléportation du bleu à l\'Est',
        ja: '3列',
        cn: '第 3 行',
        ko: '파란색 동쪽 텔레포트'
      },
      blueWest: {
        en: 'Blue Teleporting West',
        de: 'Blau Teleport nach Westen',
        fr: 'Téléportation du bleu à l\'Ouest',
        ja: '4列',
        cn: '第 4 行',
        ko: '파란색 서쪽 텔레포트'
      },
      orangeEast: {
        en: 'Orange Teleporting East',
        de: 'Orange Teleport nach Osten',
        fr: 'Téléportation de l\'orange à l\'Est',
        ja: '2列',
        cn: '第 2 行',
        ko: '주황색 동쪽 텔레포트'
      },
      orangeWest: {
        en: 'Orange Teleporting West',
        de: 'Orange Teleport nach Westen',
        fr: 'Téléportation de l\'orange à l\'Ouest',
        ja: '1列',
        cn: '第 1 行',
        ko: '주황색 서쪽 텔레포트'
      }
    }
  }, {
    id: 'ASS Banishment First Ward',
    // This debuff expires 4.7s before the first bait, but there is a slight
    // animation lock from the teleport that occurs
    // Repositioning may be required to bait the active ward's Infern Wave
    // Using Call of the Portal (CCC) expiration for trigger
    type: 'LosesEffect',
    netRegex: {
      effectId: 'CCC'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 0.75,
    // Delay for animation lock from teleport to complete
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait First Ward',
        de: 'Köder erste Wehr',
        fr: 'Attirez la 1ère barrière',
        ja: '1番目の扇誘導',
        cn: '诱导第 1 次扇形',
        ko: '첫번째 지팡이 유도하기'
      }
    }
  }, {
    id: 'ASS Banishment Bait Second Ward',
    // After the second teleport and stun expiring, there is 2s before the
    // the last ward casts Infern Wave that must be baited
    // Rite of Passage (CCD) debuff is tied to the player's teleport going
    // off
    type: 'LosesEffect',
    netRegex: {
      effectId: 'CCD'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 2,
    // Delay for stun to complete
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Second Ward',
        de: 'Köder zweite Wehr',
        fr: 'Attirez la 2ème barrière',
        ja: '2番目の扇誘導',
        cn: '诱导第 2 次扇形',
        ko: '두번째 지팡이 유도하기'
      }
    }
  }, {
    id: 'ASS Infern Brand 5 Starting Position',
    // CC4 First Brand
    // CC5 Second Brand
    // CC6 Third Brand
    // CC7 Fourth Brand
    // Although we can see where the 4 wards spawn, Does not seem to be a way
    // to determine which one is animated which is required to tell which color
    // to cut
    type: 'GainsEffect',
    netRegex: {
      effectId: ['CC4', 'CC5', 'CC6', 'CC7']
    },
    condition: (data, matches) => data.me === matches.target && data.brandCounter === 5,
    delaySeconds: 0.1,
    infoText: (data, matches, output) => {
      const brandMap = {
        'CC4': 1,
        'CC5': 2,
        'CC6': 3,
        'CC7': 4
      };
      const myNum = brandMap[matches.effectId];
      if (myNum === undefined) throw new not_reached/* UnreachableCode */.$();

      // Store for later trigger
      data.myFlame = myNum;

      // In Infern Brand 5, there are 4 wards in a + and blocked by 2 lines each
      // This creates an opening in middle where First Brand + Second Brand
      // while Third Brand and Fourth Brand need to bait the first ward
      // Blue N/S:
      //   (304.00, -110.00)
      //   (304.00, -108.00)
      //
      //   (304.00, -102.00)
      //   (304.00, -100.00)
      // Orange E/W:
      //   (284.00, -85.00)
      //   (286.00, -85.00)
      //
      //   (292.00, -85.00)
      //   (294.00, -85.00)

      // Generic output unless we find a method to determine which way to cut
      if (myNum === 1 || myNum === 2) return output.middle({
        num: myNum
      });
      return output.outThenBait({
        num: myNum
      });
    },
    run: data => data.brandEffects = {},
    outputStrings: {
      middle: {
        en: 'Brand ${num}: Get Middle',
        de: 'Kryptogramm ${num}: Geh in die Mitte',
        fr: 'Étendard ${num} : Au centre',
        ja: '線${num}: 真ん中へ',
        cn: '线${num}: 去中间',
        ko: '선 ${num}: 중앙으로'
      },
      outThenBait: {
        en: 'Brand ${num}: Out, Bait Ward',
        de: 'Kryptogramm ${num}: Wehr ködern',
        fr: 'Étendard ${num} : Extérieur, Attirez la barrière',
        ja: '線${num}: 外側へ/扇誘導',
        cn: '线${num}: 诱导扇形',
        ko: '선 ${num}: 밖으로, 지팡이 유도'
      }
    }
  }, {
    id: 'ASS Infern Brand 5 First Flame',
    // CC8 First Flame
    // CC9 Second Flame
    // CCA Third Flame
    // CCB Fourth Flame
    // Until we find a way to determine color, call cut order only
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CC8'
    },
    condition: (data, matches) => data.me === matches.target && data.brandCounter === 5,
    alertText: (_data, _matches, output) => output.firstCut(),
    outputStrings: {
      firstCut: {
        en: 'First Cut',
        de: 'Als Erster durchtrennen',
        fr: '1ère coupe',
        ja: '1番目の線切る',
        cn: '剪线 1',
        ko: '첫번째 선 끊기'
      }
    }
  }, {
    id: 'ASS Infern Brand 5 Infern Wave Counter',
    type: 'Ability',
    netRegex: {
      id: '74BB',
      source: 'Infern Brand',
      capture: false
    },
    condition: data => data.brandCounter === 5,
    preRun: data => data.waveCounter++,
    suppressSeconds: 1
  }, {
    id: 'ASS Infern Brand 5 Cuts after Baits',
    // Utilizing 1.96s Magic Vulnerability Up (B7D) from Infern Wave to tell
    // when to start cutting after baiting the Infern Ward
    // Vulnerability expires after Pure Fire (749F) puddles, so no need to
    // add additional delay for the puddle
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B7D'
    },
    condition: (data, matches) => {
      const duration = parseFloat(matches.duration);
      return data.me === matches.target && data.brandCounter === 5 && duration <= 2;
    },
    delaySeconds: (_data, matches) => parseFloat(matches.duration),
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        cutOrangeNum: {
          en: 'Cut Orange ${num}',
          de: 'Orange ${num} durchtrennen',
          fr: 'Coupez Orange ${num}',
          ja: '赤線${num} 切る',
          cn: '剪红线 ${num}',
          ko: '주황색 ${num} 끊기'
        },
        cutBlueNum: {
          en: 'Cut Blue ${num}',
          de: 'Blau ${num} durchtrennen',
          fr: 'Coupez Bleu ${num}',
          ja: '青線${num} 切る',
          cn: '剪蓝线 ${num}',
          ko: '파란색 ${num} 끊기'
        },
        moveOrange: {
          en: 'Move for Orange ${num}',
          de: 'Bewegen für Orange ${num}',
          fr: 'Bougez pour l\'orange ${num}',
          ja: 'まもなく赤線${num}',
          cn: '去红线 ${num}',
          ko: '주황색 ${num} 끊을 준비'
        },
        moveBlue: {
          en: 'Move for Blue ${num}',
          de: 'Bewegen für Blau ${num}',
          fr: 'Bougez pour le bleu ${num}',
          ja: 'まもなく青線${num}',
          cn: '去蓝线 ${num}',
          ko: '파란색 ${num} 끊을 준비'
        }
      };

      // Check for race condition with Second Flame after first bait
      // or that it is the third bait that has no race
      if (data.waveCounter === 1 && data.flamesCutCounter === 1 || data.waveCounter === 3) {
        // Third and Fourth Flames need to move to cut across immediately after baiting
        // Three can cut their flame if they have baited and 2 has cut
        if (data.myFlame === 3) {
          if (data.firstColorCut === 'blue') return {
            alertText: output.cutBlueNum({
              num: data.myFlame
            })
          };
          return {
            alertText: output.cutOrangeNum({
              num: data.myFlame
            })
          };
        }
        if (data.myFlame === 4) {
          if (data.firstColorCut === 'blue') return {
            infoText: output.moveBlue({
              num: data.myFlame
            })
          };
          return {
            infoText: output.moveOrange({
              num: data.myFlame
            })
          };
        }
      }

      // First Flame needs to cut after the second bait
      if (data.waveCounter === 2 && data.myFlame === 1) {
        if (data.firstColorCut === 'orange') return {
          alertText: output.cutOrangeNum({
            num: data.myFlame
          })
        };
        return {
          alertText: output.cutBlueNum({
            num: data.myFlame
          })
        };
      }
    }
  }, {
    id: 'ASS Infern Brand 5 Remaining Flames',
    type: 'LosesEffect',
    netRegex: {
      effectId: '95D',
      target: 'Infern Brand',
      count: '1C[2-9]'
    },
    condition: data => data.brandCounter === 5,
    preRun: (data, matches) => {
      data.flamesCutCounter++;
      // First and last of a set let us know what's being cut next
      if (data.flamesCutCounter === 1) {
        if (matches.count === '1C2') data.firstColorCut = 'orange';else if (matches.count === '1C6') data.firstColorCut = 'blue';
      } else if (data.flamesCutCounter === 4) {
        data.firstColorCut = data.firstColorCut === 'orange' ? 'blue' : 'orange';
      }
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        baitWardTwo: {
          en: 'Bait Ward 2 => Bait Puddles',
          de: 'Köder Wehr 2 => Köder Flächen',
          fr: 'Attirez barrière 2 -> Attirez les puddles',
          ja: '扇２ => AOE誘導',
          cn: '诱导扇形 2 => 诱导圈圈',
          ko: '지팡이 2 유도 => 장판 유도'
        },
        baitWardThree: {
          en: 'Bait Ward 3',
          de: 'Köder Wehr 3',
          fr: 'Attirez barrière 3',
          ja: '扇３',
          cn: '诱导扇形 3',
          ko: '지팡이 3 유도'
        },
        baitPuddles: {
          en: 'Bait Puddles',
          de: 'Köder Flächen',
          fr: 'Attirez les puddles',
          ja: 'AOE誘導',
          cn: '诱导圈圈',
          ko: '장판 유도'
        },
        cutOrangeNum: {
          en: 'Cut Orange ${num}',
          de: 'Orange ${num} durchtrennen',
          fr: 'Coupez Orange ${num}',
          ja: '赤線${num} 切る',
          cn: '剪红线 ${num}',
          ko: '주황색 ${num} 끊기'
        },
        cutBlueNum: {
          en: 'Cut Blue ${num}',
          de: 'Blau ${num} durchtrennen',
          fr: 'Coupez Bleu ${num}',
          ja: '青線${num} 切る',
          cn: '剪蓝线 ${num}',
          ko: '파란색 ${num} 끊기'
        },
        moveOrangeNum: {
          en: 'Move for Orange ${num}',
          de: 'Bewegen für Orange ${num}',
          fr: 'Bougez pour l\'orange ${num}',
          ja: 'まもなく赤線${num}',
          cn: '去红线 ${num}',
          ko: '주황색 ${num} 끊을 준비'
        },
        moveBlueNum: {
          en: 'Move for Blue ${num}',
          de: 'Bewegen für Blau ${num}',
          fr: 'Bougez pour le bleu ${num}',
          ja: 'まもなく青線${num}',
          cn: '去蓝线 ${num}',
          ko: '파란색 ${num} 끊을 준비'
        }
      };

      // Two can cut immediately after one
      if (data.myFlame === 2 && (data.flamesCutCounter === 1 || data.flamesCutCounter === 6)) {
        if (data.firstColorCut === 'blue') return {
          alertText: output.cutBlueNum({
            num: data.myFlame
          })
        };
        return {
          alertText: output.cutOrangeNum({
            num: data.myFlame
          })
        };
      }

      // Three can cut if they have baited their wave and two has cut
      if (data.myFlame === 3 && data.flamesCutCounter === 2 && data.waveCounter === 1) {
        if (data.firstColorCut === 'blue') return {
          alertText: output.cutBlueNum({
            num: data.myFlame
          })
        };
        return {
          alertText: output.cutOrangeNum({
            num: data.myFlame
          })
        };
      }
      // Four can follow three after they have baited and two has cut
      if (data.myFlame === 4 && data.flamesCutCounter === 2 && data.waveCounter === 1) {
        if (data.firstColorCut === 'blue') return {
          infoText: output.moveBlueNum({
            num: data.myFlame
          })
        };
        return {
          infoText: output.moveOrangeNum({
            num: data.myFlame
          })
        };
      }

      // Four can cut immediately after three
      if (data.myFlame === 4 && (data.flamesCutCounter === 3 || data.flamesCutCounter === 7)) {
        if (data.firstColorCut === 'blue') return {
          alertText: output.cutBlueNum({
            num: data.myFlame
          })
        };
        return {
          alertText: output.cutOrangeNum({
            num: data.myFlame
          })
        };
      }

      // Fourth Flame should open path for One and Two to bait second ward
      if (data.flamesCutCounter === 4) {
        if (data.myFlame === 1 || data.myFlame === 2) return {
          alertText: output.baitWardTwo()
        };
        return {
          infoText: output.baitPuddles()
        };
      }

      // Sixth Flame should open path for Three and Four to bait third ward
      if (data.flamesCutCounter === 6 && (data.myFlame === 3 || data.myFlame === 4)) return {
        alertText: output.baitWardThree()
      };
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      '(?<!/ )Chilling Duster / Fizzling Duster': 'Chilling/Fizzling Duster',
      'Bracing Duster / Chilling Duster / Fizzling Duster': 'Duster',
      'Bracing Duster / Chilling Duster(?! )': 'Bracing/Chilling Duster',
      'Bracing Duster / Fizzling Duster': 'Bracing/Fizzling Duster',
      'Bracing Suds / Chilling Suds / Fizzling Suds': 'Suds',
      'Bracing Suds / Chilling Suds(?! )': 'Bracing/Chilling Suds',
      'Bracing Suds / Fizzling Suds': 'Bracing/Fizzling Suds'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Aqueduct Belladonna': 'Aquädukt-Belladonna',
      'Aqueduct Dryad': 'Aquädukt-Dryade',
      'Aqueduct Kaluk': 'Aquädukt-Kaluk',
      'Aqueduct Udumbara': 'Aquädukt-Udumbara',
      'Arcane Font': 'arkan(?:e|er|es|en) Tafel',
      'Ball of Fire': 'Feuerball',
      'Eastern Ewer': 'Waschkrug',
      'Gladiator of Sil\'dih': 'Gladiator von Sil\'dih',
      'Hateful Visage': 'Hassendes Haupt',
      'Infern Brand': 'Infernales Mal',
      'Shadowcaster Zeless Gah': 'Schattenwirker Zeless Gah',
      'Sil\'dihn Armor': 'Sil\'dih-Kampfmaschine',
      'Sil\'dihn Dullahan': 'Sil\'dih-Dullahan',
      'Silken Puff': 'weich(?:e|er|es|en) Puschel',
      'Silkie': 'Silkie',
      'The Trial of Balance': 'Prüfung der Gerechtigkeit',
      'The Trial of Knowledge': 'Prüfung der Weisheit',
      'The Trial of Might': 'Prüfung der Macht'
    },
    'replaceText': {
      'Accursed Visage': 'Verdammtes Haupt',
      'Banishment': 'Verbannung',
      'Blazing Benifice': 'Heiliger Feuereifer',
      'Blessed Beacon': 'Himmelsfeuer',
      'Bracing Duster': 'Spritziger Wedel',
      'Bracing Suds': 'Spritziger Schaum',
      'Burn': 'Verbrennung',
      'Carpet Beater': 'Teppichklopfer',
      'Cast Shadow': 'Schattenfall',
      'Chilling Duster': 'Kalter Wedel',
      'Chilling Suds': 'Kalter Schaum',
      'Colossal Wreck': 'Riesig Trümmerbild',
      'Cryptic Flames': 'Kryptische Flammen',
      'Cryptic Portal': 'Kryptisches Portal',
      'Curse of the Fallen': 'Fluch des Zerfallenen',
      'Curse of the Monument': 'Fluch des Denkmals',
      'Dust Bluster': 'Staubbläser',
      'Eastern Ewers': 'Waschkrug',
      'Echo of the Fallen': 'Fluch des Äons',
      'Explosion': 'Explosion',
      'Firesteel Fracture': 'Feuerstahl-Brecher',
      'Firesteel Strike': 'Feuerstahl-Schlag',
      'Fizzling Duster': 'Prickelnder Wedel',
      'Fizzling Suds': 'Prickelnder Schaum',
      'Flash of Steel': 'Blitzender Stahl',
      'Fresh Puff': 'Frischer Puschel',
      'Gold Flame': 'Goldene Flamme',
      'Hateful Visage': 'Hassendes Haupt',
      'Infern Brand': 'Infernales Mal',
      'Infern Ward': 'Infernale Wehr',
      'Infern Wave': 'Infernale Welle',
      'Mighty Smite': 'Mächtiger Streich',
      'Nothing beside Remains': 'Nichts weiter blieb',
      'Puff and Tumble': 'Puschelputz',
      'Pure Fire': 'Reines Feuer',
      'Rinse': 'Spülung',
      'Rush of Might': 'Rausch der Macht',
      'Scream of the Fallen': 'Fluch der Ewigkeit',
      'Sculptor\'s Passion': 'Bildners Hohn',
      'Show of Strength': 'Kraftakt',
      'Silver Flame': 'Silberne Flamme',
      'Slippery Soap': 'Schmierige Seife',
      'Soap\'s Up': 'Einseifen',
      'Soaping Spree': 'Seifentaumel',
      'Specter of Might': 'Schemen der Macht',
      'Squeaky Clean': 'Blitzeblank',
      'Sundered Remains': 'Tote Trümmer',
      'Total Wash': 'Vollwäsche',
      'Wrath of Ruin': 'Düster Zorn'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aqueduct Belladonna': 'belladone des aqueducs',
      'Aqueduct Dryad': 'dryade des aqueducs',
      'Aqueduct Kaluk': 'kaluk des aqueducs',
      'Aqueduct Udumbara': 'udumbara des aqueducs',
      'Arcane Font': 'sphère arcanique',
      'Ball of Fire': 'Boule de flammes',
      'Eastern Ewer': 'cruche orientale',
      'Gladiator of Sil\'dih': 'gladiateur sildien',
      'Hateful Visage': 'Effigie maudite',
      'Infern Brand': 'Étendard sacré',
      'Shadowcaster Zeless Gah': 'Zeless Gah la Flamme ombrée',
      'Sil\'dihn Armor': 'armure maléfique sildien',
      'Sil\'dihn Dullahan': 'dullahan sildien',
      'Silken Puff': 'pompon de Silkie',
      'Silkie': 'Silkie',
      'The Trial of Balance': 'Épreuve de la Justice',
      'The Trial of Knowledge': 'Épreuve de la Sagesse',
      'The Trial of Might': 'Épreuve de la Puissance'
    },
    'replaceText': {
      'Accursed Visage': 'Visage d\'exécration',
      'Banishment': 'Bannissement',
      'Blazing Benifice': 'Canon des flammes sacrées',
      'Blessed Beacon': 'Flamme sacrée céleste',
      'Bracing Duster': 'Plumeau tonifiant',
      'Bracing Suds': 'Mousse tonifiante',
      'Burn': 'Combustion',
      'Carpet Beater': 'Tapette à tapis',
      'Cast Shadow': 'Ombre crépitante',
      'Chilling Duster': 'Plumeau givré',
      'Chilling Suds': 'Mousse givrée',
      'Colossal Wreck': 'Ruine colossale',
      'Cryptic Flames': 'Flammes cryptiques',
      'Cryptic Portal': 'Portail cryptique',
      'Curse of the Fallen': 'Malédiction hurlante',
      'Curse of the Monument': 'Malédiction monumentale',
      'Dust Bluster': 'Dépoussiérage',
      'Eastern Ewers': 'Aiguière aqueuse',
      'Echo of the Fallen': 'Écho déchu',
      'Explosion': 'Explosion',
      'Firesteel Fracture': 'Choc brasero',
      'Firesteel Strike': 'Frappe brasero',
      'Fizzling Duster': 'Plumeau pétillant',
      'Fizzling Suds': 'Mousse pétillante',
      'Flash of Steel': 'Éclair d\'acier',
      'Fresh Puff': 'Pompon lustré',
      'Gold Flame': 'Flamme dorée',
      'Hateful Visage': 'Visage de haine',
      'Infern Brand': 'Étendard sacré',
      'Infern Ward': 'Barrière infernale',
      'Infern Wave': 'Vague infernale',
      'Mighty Smite': 'Taillade belliqueuse',
      'Nothing beside Remains': 'Soulèvement général',
      'Puff and Tumble': 'Pompon culbuteur',
      'Pure Fire': 'Feu immaculé',
      'Rinse': 'Rinçage',
      'Rush of Might': 'Déferlement de puissance',
      'Scream of the Fallen': 'Grand écho déchu',
      'Sculptor\'s Passion': 'Canon belliqueux',
      'Show of Strength': 'Cri du guerrier',
      'Silver Flame': 'Flamme argentée',
      'Slippery Soap': 'Bain moussant glissant',
      'Soap\'s Up': 'Bain moussant explosif',
      'Soaping Spree': 'Bain moussant public',
      'Specter of Might': 'Spectre immémorial',
      'Squeaky Clean': 'Frottage',
      'Sundered Remains': 'Soulèvement belliqueux',
      'Total Wash': 'Lavage intégral',
      'Wrath of Ruin': 'Colère immémoriale'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aqueduct Belladonna': 'アクアダクト・ベラドンナ',
      'Aqueduct Dryad': 'アクアダクト・ドライアド',
      'Aqueduct Kaluk': 'アクアダクト・カルク',
      'Aqueduct Udumbara': 'アクアダクト・ウドンゲ',
      'Arcane Font': '立体魔法陣',
      'Ball of Fire': '火炎球',
      'Eastern Ewer': '洗い壺',
      'Gladiator of Sil\'dih': 'シラディハ・グラディアトル',
      'Hateful Visage': '呪像起動',
      'Infern Brand': '呪具設置',
      'Shadowcaster Zeless Gah': '影火のゼレズ・ガー',
      'Sil\'dihn Armor': 'シラディハ・イビルアーマー',
      'Sil\'dihn Dullahan': 'シラディハ・デュラハン',
      'Silken Puff': 'シルキーズ・ポンポン',
      'Silkie': 'シルキー',
      'The Trial of Balance': '参の試練',
      'The Trial of Knowledge': '壱の試練',
      'The Trial of Might': '弐の試練'
    },
    'replaceText': {
      'Accursed Visage': '呪怨呪像',
      'Banishment': '強制転移の呪',
      'Blazing Benifice': '聖火砲',
      'Blessed Beacon': '天の聖火',
      'Bracing Duster': 'そよそよダスター',
      'Bracing Suds': 'そよそよシャンプー',
      'Burn': '燃焼',
      'Carpet Beater': 'カーペットビーター',
      'Cast Shadow': '影火呪式',
      'Chilling Duster': 'ひえひえダスター',
      'Chilling Suds': 'ひえひえシャンプー',
      'Colossal Wreck': '亡国の霊塔',
      'Cryptic Flames': '火焔の呪印',
      'Cryptic Portal': '転移の呪印',
      'Curse of the Fallen': '呪怨の咆哮',
      'Curse of the Monument': '呪怨の連撃',
      'Dust Bluster': 'ダストブロワー',
      'Eastern Ewers': '洗い壺',
      'Echo of the Fallen': '呪怨の残響',
      'Explosion': '爆発',
      'Firesteel Fracture': '石火豪打',
      'Firesteel Strike': '石火豪衝',
      'Fizzling Duster': 'ぱちぱちダスター',
      'Fizzling Suds': 'ぱちぱちシャンプー',
      'Flash of Steel': '闘人の波動',
      'Fresh Puff': 'ポンポン創出',
      'Gold Flame': '黄金の閃火',
      'Hateful Visage': '呪像起動',
      'Infern Brand': '呪具設置',
      'Infern Ward': '呪具警陣',
      'Infern Wave': '呪具流火',
      'Mighty Smite': '闘人の斬撃',
      'Nothing beside Remains': '座下隆起',
      'Puff and Tumble': 'ポンポンはたきがけ',
      'Pure Fire': '劫火',
      'Rinse': 'すすぎ洗い',
      'Rush of Might': '大剛の突撃',
      'Scream of the Fallen': '呪怨の大残響',
      'Sculptor\'s Passion': '闘人砲',
      'Show of Strength': '勇士の咆哮',
      'Silver Flame': '白銀の閃火',
      'Slippery Soap': 'すべってシャンプーボム',
      'Soap\'s Up': 'シャンプーボム',
      'Soaping Spree': 'みんなでシャンプーボム',
      'Specter of Might': '亡念幻身',
      'Squeaky Clean': '水拭き',
      'Sundered Remains': '闘場隆起',
      'Total Wash': '水洗い',
      'Wrath of Ruin': '亡念励起'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aqueduct Belladonna': '水道剧毒美人',
      'Aqueduct Dryad': '水道树妖',
      'Aqueduct Kaluk': '水道卡栌克',
      'Aqueduct Udumbara': '水道优昙婆罗花',
      'Arcane Font': '立体魔法阵',
      'Ball of Fire': '火球',
      'Eastern Ewer': '倒水瓶',
      'Gladiator of Sil\'dih': '希拉狄哈剑斗士',
      'Hateful Visage': '亡国咒像',
      'Infern Brand': '蜥蜴人咒具',
      'Shadowcaster Zeless Gah': '鬼阴火 泽雷斯·夏',
      'Sil\'dihn Armor': '希拉狄哈恶魔装甲',
      'Sil\'dihn Dullahan': '希拉狄哈无头骑士',
      'Silken Puff': '羽衣精的绒球',
      'Silkie': '羽衣精',
      'The Trial of Balance': '第三试炼',
      'The Trial of Knowledge': '第一试炼',
      'The Trial of Might': '第二试炼'
    },
    'replaceText': {
      'Accursed Visage': '咒怨咒像',
      'Banishment': '强制传送之咒',
      'Blazing Benifice': '圣火炮',
      'Blessed Beacon': '祝福圣火',
      'Bracing Duster': '风清除尘',
      'Bracing Suds': '风清泡泡',
      'Burn': '燃烧',
      'Carpet Beater': '拍毯子',
      'Cast Shadow': '影火咒式',
      'Chilling Duster': '冰凉除尘',
      'Chilling Suds': '冰凉泡泡',
      'Colossal Wreck': '亡国灵塔',
      'Cryptic Flames': '火焰咒印',
      'Cryptic Portal': '传送咒印',
      'Curse of the Fallen': '咒怨咆哮',
      'Curse of the Monument': '咒怨连击',
      'Dust Bluster': '掸土',
      'Eastern Ewers': '倒水瓶',
      'Echo of the Fallen': '咒怨残响',
      'Explosion': '爆炸',
      'Firesteel Fracture': '石火豪打',
      'Firesteel Strike': '石火豪冲',
      'Fizzling Duster': '电气除尘',
      'Fizzling Suds': '电气泡泡',
      'Flash of Steel': '斗士波动',
      'Fresh Puff': '创造绒球',
      'Gold Flame': '黄金闪火',
      'Hateful Visage': '启动咒像',
      'Infern Brand': '设置咒具',
      'Infern Ward': '咒具警阵',
      'Infern Wave': '咒具流火',
      'Mighty Smite': '斗士斩击',
      'Nothing beside Remains': '座下隆起',
      'Puff and Tumble': '绒球翻滚',
      'Pure Fire': '劫火',
      'Rinse': '漂洗',
      'Rush of Might': '刚武突击',
      'Scream of the Fallen': '咒怨大残响',
      'Sculptor\'s Passion': '斗士炮',
      'Show of Strength': '勇士的咆哮',
      'Silver Flame': '白银闪火',
      'Slippery Soap': '泡泡滑行',
      'Soap\'s Up': '泡泡破裂',
      'Soaping Spree': '泡泡总动员',
      'Specter of Might': '亡念幻影',
      'Squeaky Clean': '擦拭',
      'Sundered Remains': '场地隆起',
      'Total Wash': '水洗',
      'Wrath of Ruin': '亡念激起'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aqueduct Belladonna': '지하수도 벨라돈나',
      'Aqueduct Dryad': '지하수도 드라이어드',
      'Aqueduct Kaluk': '지하수도 칼루크',
      'Aqueduct Udumbara': '지하수도 우담바라',
      'Arcane Font': '입체마법진',
      'Ball of Fire': '불덩이',
      'Eastern Ewer': '물동이',
      'Gladiator of Sil\'dih': '실디하 검투사',
      'Hateful Visage': '망국의 저주상',
      'Infern Brand': '아말쟈 주술도구',
      'Shadowcaster Zeless Gah': '그림자불 젤레즈 가',
      'Sil\'dihn Armor': '실디하 사악한 갑옷',
      'Sil\'dihn Dullahan': '실디하 둘라한',
      'Silken Puff': '실키 폼폼',
      'Silkie': '실키',
      'The Trial of Balance': '세 번째 시련',
      'The Trial of Knowledge': '첫 번째 시련',
      'The Trial of Might': '두 번째 시련'
    },
    'replaceText': {
      'Accursed Visage': '원한의 저주상',
      'Banishment': '강제 전송 주술',
      'Blazing Benifice': '성화포',
      'Blessed Beacon': '하늘의 성화',
      'Bracing Duster': '산들산들 닦기',
      'Bracing Suds': '산들산들 비누거품',
      'Burn': '연소',
      'Carpet Beater': '융단 털기',
      'Cast Shadow': '그림자불 주술식',
      'Chilling Duster': '오들오들 닦기',
      'Chilling Suds': '오들오들 비누거품',
      'Colossal Wreck': '망국의 탑',
      'Cryptic Flames': '화염 주술인',
      'Cryptic Portal': '묵직한 문',
      'Curse of the Fallen': '저주의 포효',
      'Curse of the Monument': '저주 연격',
      'Dust Bluster': '먼지 털기',
      'Eastern Ewers': '물동이',
      'Echo of the Fallen': '저주의 뒤울림',
      'Explosion': '폭발',
      'Firesteel Fracture': '석화호타',
      'Firesteel Strike': '석화호충',
      'Fizzling Duster': '파직파직 닦기',
      'Fizzling Suds': '파직파직 비누거품',
      'Flash of Steel': '투사의 파동',
      'Fresh Puff': '폼폼 만들기',
      'Gold Flame': '황금 섬화',
      'Hateful Visage': '망국의 저주상',
      'Infern Brand': '아말쟈 주술도구',
      'Infern Ward': '주술도구 경비진',
      'Infern Wave': '주술도구 불길',
      'Mighty Smite': '투사의 참격',
      'Nothing beside Remains': '발밑 융기',
      'Puff and Tumble': '폼폼 먼지떨이',
      'Pure Fire': '겁화',
      'Rinse': '헹구기',
      'Rush of Might': '강력한 돌격',
      'Scream of the Fallen': '저주의 큰뒤울림',
      'Sculptor\'s Passion': '투사포',
      'Show of Strength': '용사의 포효',
      'Silver Flame': '백은 섬화',
      'Slippery Soap': '미끄덩 비누 폭탄',
      'Soap\'s Up': '비누 폭탄',
      'Soaping Spree': '다 함께 비누 폭탄',
      'Specter of Might': '망념 환체',
      'Squeaky Clean': '물걸레질',
      'Sundered Remains': '검투장 융기',
      'Total Wash': '물청소',
      'Wrath of Ruin': '망념 상기'
    }
  }]
};
/* harmony default export */ const another_sildihn_subterrane = (another_sildihn_subterrane_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/another_sildihn_subterrane.txt
const dungeon_another_sildihn_subterrane_namespaceObject = "# Another Sil'dihn Subterrane\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~#\r\n# SILKIE #\r\n#~~~~~~~~#\r\n\r\n# -ii 7760 7761 7762 7768 7769 776A 77ED 77EE\r\n\r\n# Trial of Knowledge is sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DD\", param1: \"1087\" } window 0,1\r\n12.2 \"--sync--\" StartsUsing { id: \"7759\", source: \"Silkie\" } window 15,15\r\n14.9 \"Fizzling Suds\" Ability { id: \"7759\", source: \"Silkie\" }\r\n21.0 \"Soap's Up\" Ability { id: \"775A\", source: \"Silkie\" }\r\n22.0 \"Fizzling Duster\" Ability { id: \"775D\", source: \"Silkie\" }\r\n32.2 \"Dust Bluster\" Ability { id: \"776C\", source: \"Silkie\" }\r\n32.2 \"--middle--\"\r\n\r\n38.4 \"Fresh Puff 1\" Ability { id: \"7766\", source: \"Silkie\" }\r\n43.5 \"Bracing Suds\" Ability { id: \"7757\", source: \"Silkie\" }\r\n50.1 \"--sync--\" Ability { id: [\"7751\", \"7752\"], source: \"Silkie\" }\r\n51.6 \"Squeaky Clean\" Ability { id: \"7753\", source: \"Silkie\" } duration 3.2\r\n53.3 \"--sync--\" Ability { id: \"7754\", source: \"Silkie\" }\r\n54.8 \"--sync--\" Ability { id: [\"7755\", \"7756\"], source: \"Silkie\" }\r\n61.9 \"Chilling Suds\" Ability { id: \"7758\", source: \"Silkie\" }\r\n64.0 \"--sync--\" Ability { id: \"79FB\", source: \"Silkie\" }\r\n69.0 \"Slippery Soap\" Ability { id: \"775E\", source: \"Silkie\" }\r\n73.0 \"Chilling Duster\" Ability { id: \"7763\", source: \"Silkie\" }\r\n80.6 \"Carpet Beater\" Ability { id: \"774F\", source: \"Silkie\" }\r\n89.7 \"Soaping Spree\" Ability { id: \"7767\", source: \"Silkie\" }\r\n89.7 \"Chilling Duster / Fizzling Duster\" #Ability { id: [\"7768\", \"776A\"], source: \"Silken Puff\" }\r\n89.7 \"Bracing Duster\" #Ability { id: \"7769\", source: \"Silken Puff\" }\r\n89.7 \"Chilling Duster\" #Ability { id: \"7768\", source: \"Silken Puff\" }\r\n100.9 \"Total Wash 1\" Ability { id: \"7750\", source: \"Silkie\" }\r\n106.0 \"Bracing Suds / Chilling Suds\" Ability { id: [\"7757\", \"7758\"], source: \"Silkie\" }\r\n\r\n112.1 \"Fresh Puff 2\" Ability { id: \"7766\", source: \"Silkie\" }\r\n116.3 \"--middle--\"\r\n123.1 \"Puff and Tumble\" duration 0.7 #Ability { id: \"7771\", source: \"Silken Puff\" }\r\n129.5 \"Soaping Spree\" Ability { id: \"7767\", source: \"Silkie\" }\r\n129.5 \"Fizzling Duster x2\" #Ability { id: \"776A\", source: \"Silken Puff\" }\r\n129.5 \"Chilling Duster x2\" #Ability { id: \"7768\", source: \"Silken Puff\" }\r\n129.5 \"Bracing Duster / Chilling Duster\" #Ability { id: [\"7769\", \"7768\"], source: \"Silkie\" }\r\n134.6 \"Bracing Suds / Fizzling Suds\" Ability { id: [\"7757\", \"7759\"], source: \"Silkie\" }\r\n136.7 \"--sync--\" Ability { id: \"79FB\", source: \"Silkie\" }\r\n141.7 \"Slippery Soap\" Ability { id: \"775E\", source: \"Silkie\" }\r\n145.7 \"Bracing Duster / Fizzling Duster\" Ability { id: [\"7764\", \"7765\"], source: \"Silkie\" }\r\n160.1 \"Total Wash 2\" Ability { id: \"7750\", source: \"Silkie\" }\r\n\r\n166.2 \"Fresh Puff 3\" Ability { id: \"7766\", source: \"Silkie\" }\r\n172.3 \"Eastern Ewers\" Ability { id: \"776D\", source: \"Silkie\" }\r\n178.6 \"Rinse\" Ability { id: \"776F\", source: \"Eastern Ewer\" } duration 7.3\r\n188.1 \"Soaping Spree\" Ability { id: \"7767\", source: \"Silkie\" }\r\n188.1 \"Bracing Duster / Chilling Duster / Fizzling Duster\" #Ability { id: [\"7769\", \"7768\", \"776A\"], source: \"Silken Puff\" }\r\n188.1 \"Fizzling Duster\" #Ability { id: \"776A\", source: \"Silken Puff\" }\r\n195.2 \"Chilling Suds\" Ability { id: \"7758\", source: \"Silkie\" }\r\n202.3 \"Carpet Beater\" Ability { id: \"774F\", source: \"Silkie\" }\r\n204.4 \"--sync--\" Ability { id: \"79FB\", source: \"Eastern Ewer\" }\r\n209.4 \"Slippery Soap\" Ability { id: \"775E\", source: \"Silkie\" }\r\n213.4 \"Chilling Duster\" Ability { id: \"7763\", source: \"Silkie\" }\r\n225.9 \"Bracing Suds\" Ability { id: \"7757\", source: \"Silkie\" }\r\n233.0 \"Soaping Spree\" Ability { id: \"7767\", source: \"Silkie\" }\r\n233.0 \"Chilling Duster x6\" #Ability { id: \"7768\", source: \"Silken Puff\" }\r\n233.0 \"Bracing Duster\" #Ability { id: \"7769\", source: \"Silkie\" }\r\n244.2 \"Dust Bluster\" Ability { id: \"776C\", source: \"Silkie\" }\r\n244.2 \"--north--\"\r\n249.6 \"Bracing Suds\" Ability { id: \"7757\", source: \"Silkie\" }\r\n\r\n255.7 \"Fresh Puff 4\" Ability { id: \"7766\", source: \"Silkie\" }\r\n262.3 \"--sync--\" Ability { id: [\"7751\", \"7752\"], source: \"Silkie\" }\r\n263.8 \"Squeaky Clean\" Ability { id: \"7753\", source: \"Silkie\" } duration 3.2\r\n265.5 \"--sync--\" Ability { id: \"7754\", source: \"Silkie\" }\r\n266.9 \"Puff and Tumble x4\" duration 0.7 #Ability { id: \"7771\", source: \"Silken Puff\" }\r\n266.9 \"--sync--\" Ability { id: [\"7755\", \"7756\"], source: \"Silkie\" }\r\n276.0 \"Soaping Spree\" Ability { id: \"7767\", source: \"Silkie\" }\r\n276.0 \"Chilling Duster x4\" #Ability { id: \"7768\", source: \"Silken Puff\" }\r\n276.0 \"Bracing Duster\" #Ability { id: \"7769\", source: \"Silkie\" }\r\n283.1 \"Total Wash 3\" Ability { id: \"7750\", source: \"Silkie\" }\r\n292.3 \"Bracing Suds / Chilling Suds / Fizzling Suds\" Ability { id: [\"7757\", \"7758\", \"7759\"], source: \"Silkie\" }\r\n294.4 \"--sync--\" Ability { id: \"79FB\", source: \"Silkie\" }\r\n299.4 \"Slippery Soap\" Ability { id: \"775E\", source: \"Silkie\" }\r\n303.5 \"Bracing Duster / Chilling Duster / Fizzling Duster\" Ability { id: [\"7764\", \"7763\", \"7765\"], source: \"Silkie\" }\r\n309.0 \"Bracing Suds / Chilling Suds / Fizzling Suds\" Ability { id: [\"7757\", \"7758\", \"7759\"], source: \"Silkie\" }\r\n311.1 \"--sync--\" Ability { id: \"79FB\", source: \"Silkie\" }\r\n316.1 \"Slippery Soap\" Ability { id: \"775E\", source: \"Silkie\" }\r\n320.0 \"Bracing Duster / Chilling Duster / Fizzling Duster\" Ability { id: [\"7764\", \"7763\", \"7765\"], source: \"Silkie\" }\r\n\r\n322.9 \"--sync--\" StartsUsing { id: \"79E0\", source: \"Silkie\" } window 15,5\r\n332.9 \"Total Wash (enrage)\" Ability { id: \"79E0\", source: \"Silkie\" }\r\n338.1 \"Total Wash (enrage)\" Ability { id: \"79F9\", source: \"Silkie\" }\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~~~~#\r\n# Gladiator of Sil'dih #\r\n#~~~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 766F 7670 7676 7677 77BF 7660 79F3\r\n\r\n# Trial of Might will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1088\" } window 1000,1\r\n1006.8 \"--sync--\" StartsUsing { id: \"7671\", source: \"Gladiator of Sil'dih\" } window 1007.3,5\r\n1011.5 \"Flash of Steel\" Ability { id: \"7671\", source: \"Gladiator of Sil'dih\" }\r\n1023.6 \"Specter of Might\" Ability { id: \"7673\", source: \"Gladiator of Sil'dih\" }\r\n1038.3 \"Rush of Might 1\" Ability { id: \"765B\", source: \"Gladiator of Sil'dih\" }\r\n1040.4 \"Rush of Might 2\" Ability { id: \"765C\", source: \"Gladiator of Sil'dih\" }\r\n1042.8 \"Specter of Might\" Ability { id: \"7673\", source: \"Gladiator of Sil'dih\" }\r\n1057.5 \"Rush of Might 1\" Ability { id: \"765B\", source: \"Gladiator of Sil'dih\" }\r\n1059.6 \"Rush of Might 2\" Ability { id: \"765C\", source: \"Gladiator of Sil'dih\" }\r\n1062.0 \"--sync--\" Ability { id: \"6854\", source: \"Gladiator of Sil'dih\" }\r\n1067.0 \"Sculptor's Passion\" Ability { id: \"766C\", source: \"Gladiator of Sil'dih\" }\r\n1082.4 \"Mighty Smite\" Ability { id: \"7672\", source: \"Gladiator of Sil'dih\" }\r\n\r\n1095.5 \"Curse of the Fallen\" Ability { id: \"7674\", source: \"Gladiator of Sil'dih\" }\r\n1097.6 \"--middle--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n1110.2 \"--sync--\" Ability { id: \"77BF\", source: \"Gladiator of Sil'dih\" }\r\n1113.6 \"Echo of the Fallen\" Ability { id: \"7675\", source: \"Gladiator of Sil'dih\" }\r\n1121.3 \"Flash of Steel\" Ability { id: \"7671\", source: \"Gladiator of Sil'dih\" }\r\n1131.5 \"--middle--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n\r\n1136.6 \"Hateful Visage\" Ability { id: \"766E\", source: \"Gladiator of Sil'dih\" }\r\n1141.7 \"Wrath of Ruin\" Ability { id: \"7663\", source: \"Gladiator of Sil'dih\" }\r\n1150.7 \"Gold Flame x4\" Ability { id: \"766F\", source: \"Hateful Visage\" }\r\n1150.7 \"Silver Flame x4\" #Ability { id: \"7670\", source: \"Hateful Visage\" }\r\n1152.3 \"Nothing beside Remains\" Ability { id: [\"768B\", \"768C\"], source: \"Gladiator of Sil'dih\" }\r\n1161.4 \"Flash of Steel\" Ability { id: \"7671\", source: \"Gladiator of Sil'dih\" }\r\n1171.6 \"Accursed Visage\" Ability { id: \"768D\", source: \"Gladiator of Sil'dih\" }\r\n1176.7 \"Wrath of Ruin\" Ability { id: \"7663\", source: \"Gladiator of Sil'dih\" }\r\n1185.7 \"Gold Flame x4\" Ability { id: \"766F\", source: \"Hateful Visage\" }\r\n1185.7 \"Silver Flame x4\" #Ability { id: \"7670\", source: \"Hateful Visage\" }\r\n1187.3 \"Nothing beside Remains\" Ability { id: [\"768B\", \"768C\"], source: \"Gladiator of Sil'dih\" }\r\n1196.4 \"Flash of Steel\" Ability { id: \"7671\", source: \"Gladiator of Sil'dih\" }\r\n\r\n1206.6 \"--middle--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n1212.7 \"Curse of the Monument\" Ability { id: \"7666\", source: \"Gladiator of Sil'dih\" }\r\n1219.9 \"Sundered Remains 1\" #Ability { id: \"7668\", source: \"Gladiator of Sil'dih\" }\r\n1220.5 \"Sundered Remains 2\" #Ability { id: \"7668\", source: \"Gladiator of Sil'dih\" }\r\n1221.1 \"Sundered Remains 3\" #Ability { id: \"7668\", source: \"Gladiator of Sil'dih\" }\r\n1221.7 \"Sundered Remains 4\" #Ability { id: \"7668\", source: \"Gladiator of Sil'dih\" }\r\n1222.3 \"Sundered Remains 5\" #Ability { id: \"7668\", source: \"Gladiator of Sil'dih\" }\r\n1224.9 \"--middle--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n1232.9 \"Scream of the Fallen\" Ability { id: \"7678\", source: \"Gladiator of Sil'dih\" }\r\n1233.3 \"Colossal Wreck\" Ability { id: \"7669\", source: \"Gladiator of Sil'dih\" }\r\n1233.8 \"Explosion\" Ability { id: \"766A\", source: \"Gladiator of Sil'dih\" }\r\n1237.0 \"Scream of the Fallen\" Ability { id: \"7678\", source: \"Gladiator of Sil'dih\" }\r\n1237.8 \"Explosion\" Ability { id: \"766A\", source: \"Gladiator of Sil'dih\" }\r\n\r\n1245.0 \"Flash of Steel\" Ability { id: \"7671\", source: \"Gladiator of Sil'dih\" }\r\n1259.2 \"Specter of Might\" Ability { id: \"7673\", source: \"Gladiator of Sil'dih\" }\r\n1273.9 \"Rush of Might 1\" Ability { id: \"765B\", source: \"Gladiator of Sil'dih\" }\r\n1276.0 \"Rush of Might 2\" Ability { id: \"765C\", source: \"Gladiator of Sil'dih\" }\r\n1278.3 \"Specter of Might\" Ability { id: \"7673\", source: \"Gladiator of Sil'dih\" }\r\n1293.0 \"Rush of Might 1\" Ability { id: \"765B\", source: \"Gladiator of Sil'dih\" }\r\n1295.1 \"Rush of Might 2\" Ability { id: \"765C\", source: \"Gladiator of Sil'dih\" }\r\n1297.5 \"--sync--\" Ability { id: \"6854\", source: \"Gladiator of Sil'dih\" }\r\n1302.6 \"Sculptor's Passion\" Ability { id: \"766C\", source: \"Gladiator of Sil'dih\" }\r\n\r\n1311.5 \"--middle--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n1318.9 \"Flash of Steel\" Ability { id: \"7671\", source: \"Gladiator of Sil'dih\" }\r\n1321.0 \"--sync--\" StartsUsing { id: \"7679\", source: \"Gladiator of Sil'dih\" } window 15,5\r\n1331.0 \"Flash of Steel (enrage)\" Ability { id: \"7679\", source: \"Gladiator of Sil'dih\" }\r\n# There's probably a second, instant cast enrage version of the enrage after\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~~~~~~~#\r\n# Shadowcaster Zeless Gah #\r\n#~~~~~~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -ii 74B7 74B8\r\n\r\n# Trial of Balance will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1089\" } window 2000,1\r\n2006.8 \"--sync--\" StartsUsing { id: \"74AF\", source: \"Shadowcaster Zeless Gah\" } window 2007.3,5\r\n2011.5 \"Show of Strength\" Ability { id: \"74AF\", source: \"Shadowcaster Zeless Gah\" }\r\n2023.7 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n2030.8 \"Cryptic Portal\" Ability { id: \"7494\", source: \"Shadowcaster Zeless Gah\" }\r\n2041.9 \"--sync--\" Ability { id: \"74B0\", source: \"Shadowcaster Zeless Gah\" }\r\n2042.3 \"Firesteel Strike 1\" #Ability { id: \"74B1\", source: \"Shadowcaster Zeless Gah\" }\r\n2043.3 \"Burn x4\" Ability { id: \"7490\", source: \"Ball of Fire\" }\r\n2043.7 \"Firesteel Strike 2\" #Ability { id: \"74B2\", source: \"Shadowcaster Zeless Gah\" }\r\n2051.6 \"--sync--\" Ability { id: \"74B3\", source: \"Shadowcaster Zeless Gah\" }\r\n2052.0 \"Blessed Beacon 1\" Ability { id: \"74B4\", source: \"Shadowcaster Zeless Gah\" }\r\n2054.1 \"Blessed Beacon 2\" Ability { id: \"74B5\", source: \"Shadowcaster Zeless Gah\" }\r\n2064.4 \"Firesteel Fracture\" Ability { id: \"74AD\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n2076.6 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" } duration 12\r\n2088.0 \"Cryptic Flames\" Ability { id: \"74B6\", source: \"Shadowcaster Zeless Gah\" } duration 12\r\n2094.9 \"--middle--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n2101.4 \"Blazing Benifice 1\" Ability { id: \"74A6\", source: \"Arcane Font\" }\r\n2102.0 \"--sync--\" Ability { id: \"749A\", source: \"Shadowcaster Zeless Gah\" }\r\n2102.7 \"Cast Shadow 1\" Ability { id: \"749C\", source: \"Shadowcaster Zeless Gah\" }\r\n2104.7 \"Cast Shadow 2\" Ability { id: \"749E\", source: \"Shadowcaster Zeless Gah\" }\r\n2113.5 \"Blazing Benifice 2\" Ability { id: \"74A6\", source: \"Arcane Font\" }\r\n2117.7 \"Firesteel Fracture\" Ability { id: \"74AD\", source: \"Shadowcaster Zeless Gah\" }\r\n2126.8 \"Show of Strength\" Ability { id: \"74AF\", source: \"Shadowcaster Zeless Gah\" }\r\n2139.0 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n2147.1 \"--sync--\" Ability { id: \"74BA\", source: \"Shadowcaster Zeless Gah\" }\r\n2147.9 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n2150.3 \"--middle--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n2155.5 \"Banishment\" Ability { id: \"74BC\", source: \"Shadowcaster Zeless Gah\" }\r\n2163.7 \"Infern Ward\" Ability { id: \"7496\", source: \"Shadowcaster Zeless Gah\" }\r\n2164.5 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n2165.0 \"--sync--\" Ability { id: \"7497\", source: \"Shadowcaster Zeless Gah\" }\r\n2171.5 \"Infern Wave 1\" Ability { id: \"74BB\", source: \"Infern Brand\" }\r\n2179.5 \"Infern Wave 2\" Ability { id: \"74BB\", source: \"Infern Brand\" }\r\n2187.9 \"Firesteel Fracture\" Ability { id: \"74AD\", source: \"Shadowcaster Zeless Gah\" }\r\n2200.1 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n2207.2 \"Cryptic Portal\" Ability { id: \"7494\", source: \"Shadowcaster Zeless Gah\" }\r\n2218.3 \"--sync--\" Ability { id: \"74B0\", source: \"Shadowcaster Zeless Gah\" }\r\n2218.6 \"Firesteel Strike 1\" #Ability { id: \"74B1\", source: \"Shadowcaster Zeless Gah\" }\r\n2219.7 \"Blazing Benifice\" Ability { id: \"74A6\", source: \"Arcane Font\" }\r\n2220.1 \"Firesteel Strike 2\" #Ability { id: \"74B2\", source: \"Shadowcaster Zeless Gah\" }\r\n2228.1 \"--sync--\" Ability { id: \"74B3\", source: \"Shadowcaster Zeless Gah\" }\r\n2228.5 \"Blessed Beacon 1\" Ability { id: \"74B4\", source: \"Shadowcaster Zeless Gah\" }\r\n2230.7 \"Blessed Beacon 2\" Ability { id: \"74B5\", source: \"Shadowcaster Zeless Gah\" }\r\n2240.8 \"Show of Strength\" Ability { id: \"74AF\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n2253.0 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" } duration 12\r\n2261.2 \"--sync--\" Ability { id: \"74BA\", source: \"Shadowcaster Zeless Gah\" }\r\n2262.0 \"--sync--\" Ability { id: \"7495\", source: \"Infern Brand\" }\r\n2273.7 \"Cryptic Flames\" Ability { id: \"74B6\", source: \"Shadowcaster Zeless Gah\" } duration 12\r\n2277.7 \"Infern Wave 1\" Ability { id: \"74BB\", source: \"Infern Brand\" }\r\n2287.7 \"Infern Wave 2\" Ability { id: \"74BB\", source: \"Infern Brand\" }\r\n2288.7 \"--sync--\" Ability { id: \"749F\", source: \"Shadowcaster Zeless Gah\" }\r\n2292.4 \"Pure Fire\" Ability { id: \"74A1\", source: \"Shadowcaster Zeless Gah\" }\r\n2294.8 \"--middle--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n2297.6 \"Infern Wave 3\" Ability { id: \"74BB\", source: \"Infern Brand\" }\r\n2302.0 \"--sync--\" Ability { id: \"749A\", source: \"Shadowcaster Zeless Gah\" }\r\n2302.7 \"Cast Shadow 1\" Ability { id: \"749C\", source: \"Shadowcaster Zeless Gah\" }\r\n2304.7 \"Cast Shadow 2\" Ability { id: \"749E\", source: \"Shadowcaster Zeless Gah\" }\r\n2307.6 \"Infern Wave 4\" Ability { id: \"74BB\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n2314.5 \"Firesteel Fracture\" Ability { id: \"74AD\", source: \"Shadowcaster Zeless Gah\" }\r\n2323.6 \"Show of Strength\" Ability { id: \"74AF\", source: \"Shadowcaster Zeless Gah\" }\r\n2328.6 \"--sync--\" StartsUsing { id: \"74BF\", source: \"Shadowcaster Zeless Gah\" } window 15,5\r\n2338.6 \"Show of Strength (enrage)\" Ability { id: \"74BF\", source: \"Shadowcaster Zeless Gah\" }\r\n2341.7 \"Show of Strength (enrage)\" Ability { id: \"73C9\", source: \"Shadowcaster Zeless Gah\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/ktisis_hyperboreia.ts




// TODO: Lyssa Frostbite and Seek
// TODO: Hermes correct meteor
// TODO: Hermes mirror dodge direction
const ktisis_hyperboreia_triggerSet = {
  id: 'KtisisHyperboreia',
  zoneId: zone_id/* default.KtisisHyperboreia */.Z.KtisisHyperboreia,
  timelineFile: 'ktisis_hyperboreia.txt',
  initData: () => {
    return {
      ladonBreaths: []
    };
  },
  triggers: [{
    id: 'Ktisis Lyssa Skull Dasher',
    type: 'StartsUsing',
    netRegex: {
      id: '625E',
      source: 'Lyssa'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ktisis Lyssa Frigid Stomp',
    type: 'StartsUsing',
    netRegex: {
      id: '625D',
      source: 'Lyssa',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Ktisis Lyssa Heavy Smash',
    type: 'StartsUsing',
    netRegex: {
      id: '625C',
      source: 'Lyssa'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Ktisis Ladon Lord Scratch',
    type: 'StartsUsing',
    netRegex: {
      id: '648F',
      source: 'Ladon Lord'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Ktisis Ladon Lord Intimidation',
    type: 'StartsUsing',
    netRegex: {
      id: '648D',
      source: 'Ladon Lord',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Ktisis Ladon Lord Pyric Blast',
    type: 'StartsUsing',
    netRegex: {
      id: '648E',
      source: 'Ladon Lord'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    // AFC: Center head; AFD: Right head; AFE: Left head
    id: 'Ktisis Ladon Lord Pyric Breath Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['AFC', 'AFD', 'AFE']
    },
    run: (data, matches) => data.ladonBreaths.push(matches.effectId)
  }, {
    id: 'Ktisis Ladon Lord Pyric Breath Call',
    type: 'Ability',
    netRegex: {
      id: '6485',
      source: 'Ladon Lord',
      capture: false
    },
    // Call on boss centering
    delaySeconds: 2,
    // Let the rotation happen first or simultaneously
    alertText: (data, _matches, output) => {
      // Somehow we have no breath data. Sadge.
      if (data.ladonBreaths.length === 0) return;

      // The first breath in the encounter is always center head
      if (data.ladonBreaths.length === 1) return output.awayFromFront();
      const safeId = ['AFC', 'AFD', 'AFE'].filter(id => !data.ladonBreaths.includes(id))[0];
      if (safeId === undefined) return;
      return {
        AFC: output.goFront,
        AFD: output.backLeft,
        AFE: output.backRight
      }[safeId]();
    },
    run: data => data.ladonBreaths = [],
    outputStrings: {
      awayFromFront: outputs/* default.awayFromFront */.Z.awayFromFront,
      goFront: outputs/* default.goFront */.Z.goFront,
      backRight: {
        en: 'Get behind and right',
        de: 'Nach Hinten und Rechts',
        fr: 'Allez derrière et à droite',
        ja: '右後ろ',
        cn: '去右后',
        ko: '오른쪽 뒤로'
      },
      backLeft: {
        en: 'Get behind and left',
        de: 'Nach Hinten und Links',
        fr: 'Allez derrière et à gauche',
        ja: '左後ろ',
        cn: '去左后',
        ko: '왼쪽 뒤로'
      }
    }
  }, {
    id: 'Ktisis Hermes Trimegistos',
    type: 'StartsUsing',
    netRegex: {
      id: '651E',
      source: 'Hermes',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe(),
    run: data => data.isHermes = true
  }, {
    id: 'Ktisis Hermes True Tornado',
    // StartsUsing line is self-targeted.
    type: 'HeadMarker',
    netRegex: {
      id: '00DA'
    },
    // This headmarker is used for the first two bosses but only Hermes cleaves.
    condition: data => data.isHermes,
    response: responses/* Responses.tankCleave */.n3.tankCleave('alert')
  }, {
    id: 'Ktisis Hermes True Aero',
    type: 'StartsUsing',
    netRegex: {
      id: '652B',
      source: 'Hermes',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Ktisis Hermes True Bravery',
    type: 'StartsUsing',
    netRegex: {
      id: '6533',
      source: 'Hermes'
    },
    condition: data => data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Ktisis Hermes Meteor Cosmic Kiss',
    type: 'Ability',
    netRegex: {
      id: '6523',
      source: 'Meteor',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide behind unbroken meteor',
        de: 'Hinter einem nicht zerbrochenen Meteor verstecken',
        fr: 'Cachez-vous derrière le météore intact',
        ja: '壊れていないメテオの後ろへ',
        cn: '躲在未破碎的陨石后',
        ko: '금이 안 간 돌 뒤에 숨기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Concept Review': 'Konzeptbewertung',
      'Hermes': 'Hermes',
      'Ice Pillar': 'Eissäule',
      'Karukeion': 'Kerykeion',
      'Ladon Lord': 'Ladon-Lord',
      'Lyssa': 'Lyssa',
      'Meteor': 'Meteor',
      'Pyric Sphere': 'Pyrische Sphäre',
      'The Celestial Sphere': 'Astralzone',
      'The Frozen Sphere': 'Kaltzone'
    },
    'replaceText': {
      'Cosmic Kiss': 'Einschlag',
      'Double': 'Doppel',
      'Frigid Stomp': 'Froststampfer',
      'Frostbite and Seek': 'In eisige Winde gehüllt',
      'Heavy Smash': 'Schwerer Klopfer',
      'Hermetica': 'Hermetika',
      'Ice Pillar': 'Eissäule',
      'Icicall': 'Eiszapfen-Brüller',
      'Inhale': 'Inhalieren',
      'Intimidation': 'Einschüchterungsversuch',
      'Meteor': 'Meteor',
      'Pillar Pierce': 'Säulendurchschlag',
      'Punishing Slice': 'Strafender Schlitzer',
      'Pyric Blast': 'Pyrischer Rumms',
      'Pyric Breath': 'Pyrischer Atem',
      'Pyric Sphere': 'Pyrische Sphäre',
      'Quadruple': 'Quadrupel',
      'Scratch': 'Schramme',
      'Skull Dasher': 'Schädelzertrümmerer',
      'Trismegistos': 'Trismegistus',
      'True Aero(?! I)': 'Vollkommener Wind',
      'True Aero II': 'Vollkommenes Windra',
      'True Aero IV': 'Vollkommenes Windka',
      'True Tornado': 'Vollkommener Tornado'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Concept Review': 'Salle d\'évaluation',
      'Hermes': 'Hermès',
      'Ice Pillar': 'Pilier de glace',
      'Karukeion': 'kerykeion',
      'Ladon Lord': 'seigneur Ladon',
      'Lyssa': 'Lyssa',
      'Meteor': 'Météore',
      'Pyric Sphere': 'Sphère pyrogène',
      'The Celestial Sphere': 'Voûte céleste',
      'The Frozen Sphere': 'Glacier artificiel'
    },
    'replaceText': {
      'Cosmic Kiss': 'Impact de canon',
      'Double': 'Double',
      'Frigid Stomp': 'Piétinement glacial',
      'Frostbite and Seek': 'Gelure furtive',
      'Heavy Smash': 'Fracas violent',
      'Hermetica': 'Hermética',
      'Ice Pillar': 'Pilier de glace',
      'Icicall': 'Stalactite rugissante',
      'Inhale': 'Inhalation',
      'Intimidation': 'Intimidation',
      'Meteor': 'Météore',
      'Pillar Pierce': 'Empalement',
      'Punishing Slice': 'Tranchage punitif',
      'Pyric Blast': 'Souffle pyrogène',
      'Pyric Breath': 'Bouffée pyrogène',
      'Pyric Sphere': 'Sphère pyrogène',
      'Quadruple': 'Quadruple',
      'Scratch': 'Griffade',
      'Skull Dasher': 'Charge du crâne',
      'Trismegistos': 'Trismégistos',
      'True Aero(?! I)': 'Vent véritable',
      'True Aero II': 'Extra Vent véritable',
      'True Aero IV': 'Giga Vent véritable',
      'True Tornado': 'Tornade véritable'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Concept Review': '創造生物評価室',
      'Hermes': 'ヘルメス',
      'Ice Pillar': '氷柱',
      'Karukeion': 'ケリュケイオン',
      'Ladon Lord': 'ラドンロード',
      'Lyssa': 'リッサ',
      'Meteor': 'メテオ',
      'Pyric Sphere': 'パイリックスフィア',
      'The Celestial Sphere': '天脈創造環境',
      'The Frozen Sphere': '寒冷創造環境'
    },
    'replaceText': {
      'Cosmic Kiss': '着弾',
      'Double': 'ダブル',
      'Frigid Stomp': 'フリジッドストンプ',
      'Frostbite and Seek': 'フロストバイト・アンドシーク',
      'Heavy Smash': 'ヘビースマッシュ',
      'Hermetica': 'ヘルメチカ',
      'Ice Pillar': '氷柱',
      'Icicall': 'アイシクルロア',
      'Inhale': 'インヘイル',
      'Intimidation': 'インティミデーション',
      'Meteor': 'メテオ',
      'Pillar Pierce': '激突',
      'Punishing Slice': 'パニッシングスライス',
      'Pyric Blast': 'パイリックブラスト',
      'Pyric Breath': 'パイリックブレス',
      'Pyric Sphere': 'パイリックスフィア',
      'Quadruple': 'クアドラプル',
      'Scratch': 'スクラッチ',
      'Skull Dasher': 'スカルダッシャー',
      'Trismegistos': 'トリスメギストス',
      'True Aero(?! I)': 'トゥルー・エアロ',
      'True Aero II': 'トゥルー・エアロラ',
      'True Aero IV': 'トゥルー・エアロジャ',
      'True Tornado': 'トゥルー・トルネド'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Concept Review': '创造生物评价室',
      'Hermes': '赫尔墨斯',
      'Ice Pillar': '冰柱',
      'Karukeion': '双蛇杖纹',
      'Ladon Lord': '拉冬之王',
      'Lyssa': '吕萨',
      'Meteor': '陨石',
      'Pyric Sphere': '燃烧晶球',
      'The Celestial Sphere': '天脉创造环境',
      'The Frozen Sphere': '寒冷创造环境'
    },
    'replaceText': {
      'Cosmic Kiss': '流星坠落',
      'Double': '双重',
      'Frigid Stomp': '严寒踏压',
      'Frostbite and Seek': '寒霜寻影',
      'Heavy Smash': '重挥碎击',
      'Hermetica': '赫尔墨斯文集',
      'Ice Pillar': '冰柱',
      'Icicall': '召唤冰柱',
      'Inhale': '吸引',
      'Intimidation': '恐吓',
      'Meteor': '陨石',
      'Pillar Pierce': '激突',
      'Punishing Slice': '惩罚切',
      'Pyric Blast': '燃烧爆发',
      'Pyric Breath': '燃烧吐息',
      'Pyric Sphere': '燃烧晶球',
      'Quadruple': '四重',
      'Scratch': '抓击',
      'Skull Dasher': '铁颅猛击',
      'Trismegistos': '三重伟大',
      'True Aero(?! I)': '纯正疾风',
      'True Aero II': '纯正烈风',
      'True Aero IV': '纯正飙风',
      'True Tornado': '纯正龙卷'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Concept Review': '창조 생물 평가실',
      'Hermes': '헤르메스',
      'Ice Pillar': '고드름',
      'Karukeion': '케뤼케이온',
      'Ladon Lord': '라돈 왕',
      'Lyssa': '릿사',
      'Meteor': '메테오',
      'Pyric Sphere': '연소 구체',
      'The Celestial Sphere': '천맥 창조 환경',
      'The Frozen Sphere': '한랭 창조 환경'
    },
    'replaceText': {
      'Cosmic Kiss': '착탄',
      'Double': '이중 공격',
      'Frigid Stomp': '냉혹한 발구르기',
      'Frostbite and Seek': '꽁꽁 숨바꼭질',
      'Heavy Smash': '육중한 타격',
      'Hermetica': '헤르메티카',
      'Ice Pillar': '고드름',
      'Icicall': '고드름 포효',
      'Inhale': '빨아들이기',
      'Intimidation': '엄포',
      'Meteor': '메테오',
      'Pillar Pierce': '격돌',
      'Punishing Slice': '벌칙 베기',
      'Pyric Blast': '연소 작렬',
      'Pyric Breath': '연소 숨결',
      'Pyric Sphere': '연소 구체',
      'Quadruple': '사중 공격',
      'Scratch': '생채기',
      'Skull Dasher': '두개골 박살',
      'Trismegistos': '트리스메기스토스',
      'True Aero II': '진 에어로라',
      'True Aero IV': '진 에어로쟈',
      'True Tornado': '진 토네이도',
      'True Aero(?! I)': '진 에어로'
    }
  }]
};
/* harmony default export */ const ktisis_hyperboreia = (ktisis_hyperboreia_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/ktisis_hyperboreia.txt
const dungeon_ktisis_hyperboreia_namespaceObject = "### KTISIS HYPERBORAEIA\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~#\r\n# LYSSA #\r\n#~~~~~~~#\r\n\r\n# -ii 1961 6258 6E90 -it Lyssa\r\n\r\n# Frozen Sphere will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"EB6\" } window 0,1\r\n10.7 \"Skull Dasher\" Ability { id: \"625E\", source: \"Lyssa\" } window 10.7,10\r\n21.2 \"Frostbite and Seek\" Ability { id: \"6257\", source: \"Lyssa\" }\r\n23.2 \"--untargetable--\"\r\n35.2 \"Punishing Slice\" Ability { id: \"6259\", source: \"Lyssa\" } window 35.2,30\r\n36.3 \"--targetable--\"\r\n42.0 \"--middle--\"\r\n46.0 \"Icicall\" Ability { id: \"625A\", source: \"Lyssa\" }\r\n50.9 \"Ice Pillar\" Ability { id: \"625B\", source: \"Ice Pillar\" }\r\n54.2 \"Frigid Stomp\" Ability { id: \"625D\", source: \"Lyssa\" }\r\n\r\n60.0 \"Pillar Pierce\" Ability { id: \"631F\", source: \"Ice Pillar\" } window 60.0,30\r\n70.6 \"Skull Dasher\" Ability { id: \"625E\", source: \"Lyssa\" }\r\n81.0 \"Frostbite and Seek\" Ability { id: \"6257\", source: \"Lyssa\" }\r\n83.1 \"--untargetable--\"\r\n98.0 \"Punishing Slice\" Ability { id: \"6259\", source: \"Lyssa\" }\r\n99.1 \"--targetable--\"\r\n109.2 \"Frigid Stomp\" Ability { id: \"625D\", source: \"Lyssa\" } window 30,30\r\n114.6 \"--middle--\"\r\n118.6 \"Icicall\" Ability { id: \"625A\", source: \"Lyssa\" }\r\n123.5 \"Ice Pillar\" Ability { id: \"625B\", source: \"Ice Pillar\" }\r\n\r\n# Rotate from here\r\n132.5 \"Pillar Pierce\" Ability { id: \"631F\", source: \"Ice Pillar\" } window 30,30\r\n133.8 \"Heavy Smash\" Ability { id: \"625C\", source: \"Lyssa\" }\r\n146.1 \"Skull Dasher\" Ability { id: \"625E\", source: \"Lyssa\" }\r\n156.7 \"Frostbite and Seek\" Ability { id: \"6257\", source: \"Lyssa\" }\r\n158.7 \"--untargetable--\"\r\n173.7 \"Punishing Slice\" Ability { id: \"6259\", source: \"Lyssa\" }\r\n174.8 \"--targetable--\"\r\n184.9 \"Frigid Stomp\" Ability { id: \"625D\", source: \"Lyssa\" } window 30,30\r\n190.7 \"--middle--\"\r\n194.7 \"Icicall\" Ability { id: \"625A\", source: \"Lyssa\" }\r\n199.5 \"Ice Pillar\" Ability { id: \"625B\", source: \"Ice Pillar\" }\r\n\r\n208.6 \"Pillar Pierce\" Ability { id: \"631F\", source: \"Ice Pillar\" } jump 132.5\r\n209.9 \"Heavy Smash\"\r\n222.2 \"Skull Dasher\"\r\n232.8 \"Frostbite and Seek\"\r\n234.8 \"--untargetable--\"\r\n249.8 \"Punishing Slice\"\r\n\r\n#~~~~~~~~~~~~#\r\n# LADON LORD #\r\n#~~~~~~~~~~~~#\r\n\r\n# -ii 368 653B\r\n\r\n# \"Pyric Breath\" Ability { id: [\"6486\", \"6487\", \"6488\", \"6489\", \"648A\", \"648B\"], source: \"Ladon Lord\" }\r\n\r\n# Concept Review will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"EB7\" } window 1000,5\r\n1010.3 \"Scratch\" Ability { id: \"648F\", source: \"Ladon Lord\" } window 1010.3,10\r\n1019.3 \"Inhale\" Ability { id: \"6484\", source: \"Ladon Lord\" }\r\n1025.5 \"--sync--\" Ability { id: \"6485\", source: \"Ladon Lord\" }\r\n1027.2 \"--rotate--\"\r\n1034.2 \"Pyric Breath\" Ability { id: \"6486\", source: \"Ladon Lord\" } window 1034.2,10\r\n1045.3 \"Inhale\" Ability { id: \"6484\", source: \"Ladon Lord\" }\r\n1051.6 \"--sync--\" Ability { id: \"6485\", source: \"Ladon Lord\" }\r\n1053.1 \"--rotate--\"\r\n1060.1 \"Pyric Breath #1\" #Ability { id: [\"6486\", \"6487\", \"6488\", \"6489\", \"648A\", \"648B\"], source: \"Ladon Lord\" }\r\n1062.2 \"Pyric Breath #2\" #Ability { id: [\"6486\", \"6487\", \"6488\", \"6489\", \"648A\", \"648B\"], source: \"Ladon Lord\" }\r\n1067.3 \"--sync--\" Ability { id: \"648C\", source: \"Ladon Lord\" }\r\n\r\n# Rotation block.\r\n\r\n# TODO: Need extended rotations on this. The Pyric Sphere at 120 may not always be there?\r\n\r\n1074.4 \"Inhale\" Ability { id: \"6484\", source: \"Ladon Lord\" } window 15,15\r\n1077.4 \"Pyric Sphere\" Ability { id: \"6490\", source: \"Pyric Sphere\" }\r\n1079.8 \"--sync--\" Ability { id: \"6485\", source: \"Ladon Lord\" }\r\n1081.9 \"--rotate--\"\r\n1082.5 \"Pyric Sphere\" Ability { id: \"6491\", source: \"Pyric Sphere\" }\r\n1088.9 \"Pyric Breath #1\" #Ability { id: [\"6486\", \"6487\", \"6488\", \"6489\", \"648A\", \"648B\"], source: \"Ladon Lord\" }\r\n1091.0 \"Pyric Breath #2\" #Ability { id: [\"6486\", \"6487\", \"6488\", \"6489\", \"648A\", \"648B\"], source: \"Ladon Lord\" }\r\n1099.1 \"Intimidation\" Ability { id: \"648D\", source: \"Ladon Lord\" }\r\n1105.3 \"--sync--\" Ability { id: \"648C\", source: \"Ladon Lord\" }\r\n1110.4 \"Inhale\" Ability { id: \"6484\", source: \"Ladon Lord\" } window 30,30\r\n1115.4 \"Pyric Sphere #1\" Ability { id: \"6490\", source: \"Pyric Sphere\" }\r\n1120.5 \"Pyric Sphere #2\" Ability { id: \"6491\", source: \"Pyric Sphere\" }\r\n1122.9 \"Pyric Blast\" Ability { id: \"648E\", source: \"Ladon Lord\" } window 10,10\r\n1126.2 \"--sync--\" Ability { id: \"6485\", source: \"Ladon Lord\" }\r\n1128.0 \"--rotate--\"\r\n1135.0 \"Pyric Breath #1\" #Ability { id: [\"6486\", \"6487\", \"6488\", \"6489\", \"648A\", \"648B\"], source: \"Ladon Lord\" }\r\n1137.1 \"Pyric Breath #2\" #Ability { id: [\"6486\", \"6487\", \"6488\", \"6489\", \"648A\", \"648B\"], source: \"Ladon Lord\" }\r\n1146.3 \"Scratch\" Ability { id: \"648F\", source: \"Ladon Lord\" }\r\n1151.4 \"--sync--\" Ability { id: \"648C\", source: \"Ladon Lord\" } window 30,30\r\n\r\n1158.8 \"Inhale\" Ability { id: \"6484\", source: \"Ladon Lord\" } jump 1074.4\r\n1161.8 \"Pyric Sphere\"\r\n1166.3 \"--rotate--\"\r\n1166.9 \"Pyric Sphere\"\r\n1173.3 \"Pyric Breath #1\"\r\n1175.4 \"Pyric Breath #2\"\r\n1183.5 \"Intimidation\"\r\n\r\n#~~~~~~~~#\r\n# HERMES #\r\n#~~~~~~~~#\r\n\r\n# -ii 368\r\n\r\n# Celestial Sphere will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"EB8\" } window 2000,10\r\n2013.1 \"Trismegistos\" Ability { id: \"651E\", source: \"Hermes\" } window 2013.1,10\r\n2020.2 \"--middle--\"\r\n2024.2 \"Hermetica\" Ability { id: \"6520\", source: \"Hermes\" }\r\n2029.7 \"True Aero IV\" Ability { id: \"6521\", source: \"Karukeion\" }\r\n2038.4 \"True Tornado\" Ability { id: \"652E\", source: \"Hermes\" }\r\n2038.5 \"--sync--\" Ability { id: \"652F\", source: \"Hermes\" } # True Tornado\r\n2038.5 \"--sync--\" Ability { id: [\"6530\", \"6531\"], source: \"Hermes\" } # True Tornado\r\n\r\n2046.6 \"Meteor\" Ability { id: \"6522\", source: \"Hermes\" } window 2046.6,30\r\n2054.7 \"Cosmic Kiss\" Ability { id: \"6523\", source: \"Meteor\" }\r\n2055.7 \"Double\" Ability { id: \"6524\", source: \"Hermes\" }\r\n2063.8 \"Hermetica\" Ability { id: \"6525\", source: \"Hermes\" }\r\n2066.3 \"True Aero IV #1\" #Ability { id: \"6CBC\", source: \"Karukeion\" }\r\n2069.3 \"True Aero IV #2\" #Ability { id: \"6CBC\", source: \"Karukeion\" }\r\n2074.7 \"--middle--\"\r\n2078.7 \"Double\" Ability { id: \"6524\", source: \"Hermes\" }\r\n2080.8 \"--sync--\" Ability { id: \"651F\", source: \"Hermes\" }\r\n2085.8 \"True Aero\" Ability { id: \"652B\", source: \"Hermes\" }\r\n2086.6 \"--sync--\" Ability { id: \"652C\", source: \"Hermes\" }\r\n2089.7 \"--sync--\" Ability { id: \"652D\", source: \"Hermes\" }\r\n2105.0 \"Trismegistos\" Ability { id: \"651E\", source: \"Hermes\" } window 30,30\r\n2115.3 \"Quadruple\" Ability { id: \"6526\", source: \"Hermes\" }\r\n2129.4 \"Hermetica\" Ability { id: \"6527\", source: \"Hermes\" }\r\n2131.9 \"True Aero IV #1\" Ability { id: \"6CBD\", source: \"Karukeion\" }\r\n2134.9 \"True Aero IV #2\" Ability { id: \"6CBD\", source: \"Karukeion\" }\r\n2137.9 \"True Aero IV #3\" Ability { id: \"6CBD\", source: \"Karukeion\" }\r\n2140.7 \"Double\" Ability { id: \"6524\", source: \"Hermes\" } window 30,10\r\n2140.9 \"True Aero IV #4\" Ability { id: \"6CBD\", source: \"Karukeion\" }\r\n2147.8 \"True Aero II #1\" Ability { id: [\"6528\", \"6529\"], source: \"Hermes\" }\r\n2152.3 \"True Aero II #2\" Ability { id: \"652A\", source: \"Hermes\" }\r\n2160.0 \"Double\" Ability { id: \"6524\", source: \"Hermes\" }\r\n2167.2 \"True Tornado\" Ability { id: \"652E\", source: \"Hermes\" } window 30,30\r\n2167.3 \"--sync--\" Ability { id: [\"6530\", \"6531\"], source: \"Hermes\" } # True Tornado\r\n2170.9 \"--sync--\" Ability { id: \"6532\", source: \"Hermes\" } # True Tornado\r\n2186.5 \"Trismegistos\" Ability { id: \"651E\", source: \"Hermes\" }\r\n2194.7 \"Trismegistos\" Ability { id: \"651E\", source: \"Hermes\" }\r\n\r\n# TODO: Likely the rotation point? Might need more data.\r\n2204.9 \"Meteor\" Ability { id: \"6522\", source: \"Hermes\" } jump 2046.6\r\n2213.0 \"Cosmic Kiss\"\r\n2214.0 \"Double\"\r\n2222.1 \"Hermetica\"\r\n2224.6 \"True Aero IV #1\"\r\n2227.6 \"True Aero IV #2\"\r\n2237.0 \"Double\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/lapis_manalis.ts




const albionWildBeastMapEffectFlag = '00020001';
const albionWildBeastMapEffectLocations = {
  '21': ['west', 'north'],
  '22': ['west', 'middlenorth'],
  '23': ['west', 'middlesouth'],
  '24': ['west', 'south'],
  '25': ['east', 'north'],
  '26': ['east', 'middlenorth'],
  '27': ['east', 'middlesouth'],
  '28': ['east', 'south']
};
const lapis_manalis_triggerSet = {
  id: 'LapisManalis',
  zoneId: zone_id/* default.LapisManalis */.Z.LapisManalis,
  timelineFile: 'lapis_manalis.txt',
  timelineTriggers: [{
    id: 'Lapis Manalis Cagnazzo Tsunami',
    regex: /Tsunami/,
    beforeSeconds: 5,
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }],
  triggers: [
  // ---------------- first trash ----------------
  {
    id: 'Lapis Manalis Albus Griffin Winds of Winter',
    type: 'StartsUsing',
    netRegex: {
      id: '8011',
      source: 'Albus Griffin',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  },
  // ---------------- Albion ----------------
  {
    id: 'Lapis Albion Wild Beasts',
    type: 'MapEffect',
    netRegex: {
      flags: albionWildBeastMapEffectFlag,
      location: Object.keys(albionWildBeastMapEffectLocations)
    },
    durationSeconds: 8,
    infoText: (_data, matches, output) => {
      const beasts = albionWildBeastMapEffectLocations[matches.location];
      if (beasts === undefined || beasts[0] === undefined || beasts[1] === undefined) return output.text({
        dir: output.unknown(),
        row: output.unknown()
      });
      return output.text({
        dir: output[beasts[0]](),
        row: output[beasts[1]]()
      });
    },
    outputStrings: {
      east: outputs/* default.east */.Z.east,
      west: outputs/* default.west */.Z.west,
      north: outputs/* default.north */.Z.north,
      south: outputs/* default.south */.Z.south,
      unknown: outputs/* default.unknown */.Z.unknown,
      middlenorth: {
        en: 'Middle-North',
        de: 'Norden-Mittig',
        fr: 'Milieu-Nord',
        ja: '中央ー北',
        cn: '中央-上 (北)',
        ko: '중앙-북쪽'
      },
      middlesouth: {
        en: 'Middle-South',
        de: 'Süden-Mittig',
        fr: 'Milieu-Sud',
        ja: '中央ー南',
        cn: '中央-下 (南)',
        ko: '중앙-남쪽'
      },
      text: {
        en: 'Stampede from ${dir} (${row} Row)',
        de: 'Stampede von ${dir} (${row} Reihe)',
        fr: 'Ruée depuis ${dir} (${row})',
        ja: '${dir}から突進 (${row}行)',
        cn: '${dir}冲锋 (${row} 行)',
        ko: '${dir}에서 돌진 (${row} 줄)'
      }
    }
  }, {
    id: 'Lapis Manalis Albion Albion\'s Embrace',
    type: 'StartsUsing',
    netRegex: {
      id: '7A85',
      source: 'Albion'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Lapis Manalis Albion Right Slam',
    type: 'StartsUsing',
    netRegex: {
      id: '802D',
      source: 'Albion',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Lapis Manalis Albion Left Slam',
    type: 'StartsUsing',
    netRegex: {
      id: '802E',
      source: 'Albion',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Lapis Manalis Albion Icebreaker',
    type: 'StartsUsing',
    netRegex: {
      source: 'Albion',
      id: '7A81',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from tethered rock',
        de: 'Weg vom verbundenen Felsen',
        fr: 'Éloignez-vous du rocher lié',
        ja: '線の繋がる石回避',
        cn: '躲避连线石头',
        ko: '선 연결된 돌 피하기'
      }
    }
  }, {
    id: 'Lapis Manalis Albion Icy Throes',
    type: 'StartsUsing',
    netRegex: {
      id: '7A83',
      source: 'Albion'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Lapis Manalis Albion Roar of Albion',
    type: 'StartsUsing',
    netRegex: {
      id: '7A84',
      source: 'Albion',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Boulder',
        de: 'Hinter Felsen verstecken',
        fr: 'Cachez-vous derrière le rocher',
        ja: 'ボルダーの後ろに',
        cn: '躲在石头后',
        ko: '돌 뒤에 숨기'
      }
    }
  },
  // ---------------- Galatea Magna ----------------
  {
    id: 'Lapis Manalis Galatea Magna Waxing Cycle',
    type: 'StartsUsing',
    netRegex: {
      id: '7A91',
      source: 'Galatea Magna',
      capture: false
    },
    response: responses/* Responses.getOutThenIn */.n3.getOutThenIn()
  }, {
    id: 'Lapis Manalis Galatea Magna Waning Cycle',
    type: 'StartsUsing',
    netRegex: {
      id: '7F6E',
      source: 'Galatea Magna',
      capture: false
    },
    response: responses/* Responses.getInThenOut */.n3.getInThenOut()
  }, {
    id: 'Lapis Manalis Galatea Magna Soul Nebula',
    type: 'StartsUsing',
    netRegex: {
      id: '7A9E',
      source: 'Galatea Magna',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Lapis Manalis Galatea Soul Scythe',
    type: 'StartsUsing',
    netRegex: {
      id: '7A9A',
      source: 'Galatea Magna',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Lapis Manalis Galatea Magna Doom',
    // D24 = Doom
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D24',
      source: 'Galatea Magna'
    },
    condition: data => data.CanCleanse(),
    alertText: (data, matches, output) => output.text({
      player: data.party.member(matches.target)
    }),
    outputStrings: {
      text: {
        en: 'Esuna ${player}',
        de: 'Medica ${player}',
        fr: 'Guérison sur ${player}',
        ja: '${player} にエスナ',
        cn: '驱散: ${player}',
        ko: '${player} 에스나'
      }
    }
  }, {
    id: 'Lapis Manalis Galatea Magna Glassy-eyed',
    // DB7 = Glassy-eyed
    type: 'GainsEffect',
    netRegex: {
      effectId: 'DB7',
      source: 'Galatea Magna'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 3,
    suppressSeconds: 1,
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Lapis Manalis Galatea Magna Tenebrism',
    type: 'Ability',
    netRegex: {
      id: '7A96',
      source: 'Galatea Magna',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔へ',
        cn: '踩塔',
        ko: '기둥 들어가기'
      }
    }
  }, {
    id: 'Lapis Manalis Galatea Magna Dark Harvest',
    type: 'StartsUsing',
    netRegex: {
      id: '7A9F',
      source: 'Galatea Magna'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  },
  // ---------------- Cagnazzo ----------------
  {
    id: 'Lapis Manalis Cagnazzo Stygian Deluge',
    type: 'StartsUsing',
    netRegex: {
      id: '79A3',
      source: 'Cagnazzo',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Lapis Manalis Cagnazzo Body Slam',
    // immune to knockback resist
    type: 'StartsUsing',
    netRegex: {
      id: '7992',
      source: 'Cagnazzo'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Lapis Manalis Cagnazzo Hydrofall',
    type: 'StartsUsing',
    netRegex: {
      id: '7A90',
      source: 'Cagnazzo'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Lapis Manalis Cagnazzo Neap Tide',
    // D01 = Neap Tide, source from environment
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D01'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 5,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Lapis Manalis Cagnazzo Spring Tide',
    // D00 = Spring Tide, source from environment
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D00'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 5,
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Lapis Manalis Cagnazzo Voidcleaver',
    type: 'StartsUsing',
    netRegex: {
      id: '7986',
      source: 'Cagnazzo',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Lapis Manalis Cagnazzo Void Torrent',
    type: 'StartsUsing',
    netRegex: {
      id: '798E',
      source: 'Cagnazzo'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Left Slam/Right Slam': 'Left/Right Slam',
      'Waxing Cycle/Waning Cycle': 'Waxing/Waning Cycle'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Albion': 'Albion',
      'Albus Griffin': 'Albus-Greif',
      'Cagnazzo': 'Cagnazzo',
      'Deepspine': 'Erdseim-Dornen',
      'Galatea Magna': 'Galatea Magna',
      'No more games!': 'Das ist euer Untergang!',
      'The Forum Messorum': 'Forum Messorem',
      'The Silvan Throne': 'Thron der Schneebestie'
    },
    'replaceText': {
      'Albion\'s Embrace': 'Albions Umarmung',
      'Antediluvian': 'Vorsintflutlich',
      'Body Slam': 'Bodenwelle',
      'Burst': 'Explosion',
      'Call of the Mountain': 'Ruf des Berges',
      'Cursed Tide': 'Fluch der Fluten',
      'Dark Harvest': 'Dunkle Ernte',
      'Hydraulic Ram': 'Hydroramme',
      'Hydrofall': 'Hydro-Sturz',
      'Hydrovent': 'Hydrovent',
      'Icebreaker': 'Eisbrecher',
      'Icy Throes': 'Eisige Agonie',
      'Knock on Ice': 'Eisklopfer',
      'Left Slam': 'Linker Arm von Albion',
      'Lifescleaver': 'Lebensschlitzer',
      'Neap Tide': 'Nipptide',
      'Right Slam': 'Rechter Arm von Albion',
      'Roar of Albion': 'Albion-Brüllen',
      'Scarecrow Chase': 'Bewegung & Kreuz',
      'Soul Nebula': 'Seelennebel',
      'Soul Scythe': 'Seelensense',
      'Spring Tide': 'Springtide',
      'Stony Gaze': 'Magisches Steinauge',
      'Stygian Deluge': 'Stygische Sintflut',
      'Tenebrism': 'Tenebrismus',
      'Tsunami': 'Tsunami',
      'Void Miasma': 'Nichtsfäule',
      'Void Torrent': 'Nichtshagel',
      'Voidcleaver': 'Nichtsschlitzer',
      'Waning Cycle': 'Kreis & Explosion',
      'Waxing Cycle': 'Explosion & Kreis',
      'Wildlife Crossing': 'Wilde Tiere'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Albion': 'Albion',
      'Albus Griffin': 'griffon de l\'Albus',
      'Cagnazzo': 'Cagnazzo',
      'Deepspine': 'Épines céruléennes',
      'Galatea Magna': 'Galatea Magna',
      'The Forum Messorum': 'Forum Messorem',
      'The Silvan Throne': 'Trône de la Bête des neiges',
      'No more games!': 'Vous voulez voir quand je m\'énerve!?'
    },
    'replaceText': {
      'Albion\'s Embrace': 'Étreinte d\'Albion',
      'Antediluvian': 'Antédiluvienne',
      'Body Slam': 'Charge physique',
      'Burst': 'Explosion',
      'Call of the Mountain': 'Appel bestial',
      'Cursed Tide': 'Maléfice submersif',
      'Dark Harvest': 'Sombre récolte',
      'Hydraulic Ram': 'Hydrotambourinage',
      'Hydrofall': 'Pilonnage hydrique',
      'Hydrovent': 'Hydro-exutoire',
      'Icebreaker': 'Briseur de glace',
      'Icy Throes': 'Jeté de glace',
      'Knock on Ice': 'Toucher de la glace',
      'Left Slam': 'Claque gauche d\'Albion',
      'Lifescleaver': 'Couperet vital',
      'Neap Tide': 'Mortes-eaux submersives',
      'Right Slam': 'Claque droite d\'Albion',
      'Roar of Albion': 'Rugissement d\'Albion',
      'Scarecrow Chase': 'Mouvement et croix',
      'Soul Nebula': 'Nébuleuse animique',
      'Soul Scythe': 'Faux animique',
      'Spring Tide': 'Vives-eaux submersives',
      'Stony Gaze': 'Œil pétrifiant maudit',
      'Stygian Deluge': 'Déluge stygien',
      'Tenebrism': 'Ténébrisme',
      'Tsunami': 'Raz-de-marée',
      'Void Miasma': 'Miasmes du néant',
      'Void Torrent': 'Torrent du néant',
      'Voidcleaver': 'Couperet du néant',
      'Waning Cycle': 'Cercle et explosion',
      'Waxing Cycle': 'Explosion et cercle',
      'Wildlife Crossing': 'Traversée'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Albion': 'アルビオン',
      'Albus Griffin': 'アルバス・グリフィン',
      'Cagnazzo': 'カイナッツォ',
      'Deepspine': '青炎の棘',
      'Galatea Magna': 'ガラテア・マグナ',
      'The Forum Messorum': 'フォルム・メッソルム',
      'The Silvan Throne': '雪獣の帝座',
      'No more games!': '俺様の本気を……くらいやがれェ！！'
    },
    'replaceText': {
      'Albion\'s Embrace': 'アルビオンハグ',
      'Antediluvian': 'アンテディルヴィアン',
      'Body Slam': 'ボディスラム',
      'Burst': '爆発',
      'Call of the Mountain': 'ビーストコール',
      'Cursed Tide': '水禍の呪い',
      'Dark Harvest': 'ダークハーベスト',
      'Hydraulic Ram': 'ハイドロラミング',
      'Hydrofall': 'ハイドロフォール',
      'Hydrovent': 'ハイドロベント',
      'Icebreaker': 'アイスブレイカー',
      'Icy Throes': 'アイススロー',
      'Knock on Ice': 'ノックオンアイス',
      'Left Slam': 'レフト・アルビオンスラム',
      'Lifescleaver': 'ライフクリーバー',
      'Neap Tide': '水禍の小潮',
      'Right Slam': 'ライト・アルビオンスラム',
      'Roar of Albion': 'アルビオンロア',
      'Scarecrow Chase': 'ムーブ＆クロス',
      'Soul Nebula': 'ソウルネビュラ',
      'Soul Scythe': 'ソウルサイズ',
      'Spring Tide': '水禍の大潮',
      'Stony Gaze': '呪いの石眼',
      'Stygian Deluge': 'スティギアンデリージュ',
      'Tenebrism': 'テネブリズム',
      'Tsunami': 'つなみ',
      'Void Miasma': 'ヴォイドの瘴気',
      'Void Torrent': 'ヴォイドトーレント',
      'Voidcleaver': 'ヴォイドクリーバー',
      'Waning Cycle': 'サークル＆バースト',
      'Waxing Cycle': 'バースト＆サークル',
      'Wildlife Crossing': '駆け抜け'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Albion': '白雪兽',
      'Albus Griffin': '白岭狮鹫',
      'Cagnazzo': '凯纳槽',
      'Deepspine': '青炎棘刺',
      'Galatea Magna': '大型伽拉忒亚人偶',
      'The Forum Messorum': '收割广场',
      'The Silvan Throne': '雪兽皇座',
      'No more games!': '我要用出全部力量！'
    },
    'replaceText': {
      'Albion\'s Embrace': '雪兽拥抱',
      'Antediluvian': '古洪将至',
      'Body Slam': '猛撞',
      'Burst': '爆炸',
      'Call of the Mountain': '野性呼唤',
      'Cursed Tide': '凶水之咒',
      'Dark Harvest': '黑暗收割',
      'Hydraulic Ram': '水力冲撞',
      'Hydrofall': '水瀑',
      'Hydrovent': '水涌',
      'Icebreaker': '碎冰',
      'Icy Throes': '投冰',
      'Knock on Ice': '敲击冰面',
      'Left Slam': '左侧猛击',
      'Lifescleaver': '生命劈砍',
      'Neap Tide': '凶水小潮',
      'Right Slam': '右侧猛击',
      'Roar of Albion': '雪兽怒号',
      'Scarecrow Chase': '人偶追逐',
      'Soul Nebula': '灵魂星云',
      'Soul Scythe': '灵魂钐割',
      'Spring Tide': '凶水大潮',
      'Stony Gaze': '诅咒石眼',
      'Stygian Deluge': '冥河泛滥',
      'Tenebrism': '暗色主义',
      'Tsunami': '大海啸',
      'Void Miasma': '虚无瘴气',
      'Void Torrent': '虚无洪流',
      'Voidcleaver': '虚无劈砍',
      'Waning Cycle': '环割圆切',
      'Waxing Cycle': '圆切环割',
      'Wildlife Crossing': '奔驰'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Albion': '알비온',
      'Albus Griffin': '알부스 그리핀',
      'Cagnazzo': '카냐초',
      'Deepspine': '푸른불 가시',
      'Galatea Magna': '갈라테아 마그나',
      'The Forum Messorum': '수확자의 광장',
      'The Silvan Throne': '눈짐승의 왕좌',
      'No more games!': '내 진짜 실력을…… 받아라!!'
    },
    'replaceText': {
      'Albion\'s Embrace': '알비온의 포옹',
      'Antediluvian': '태고의 물',
      'Body Slam': '몸통 박기',
      'Burst': '폭발',
      'Call of the Mountain': '짐승 부르기',
      'Cursed Tide': '수마의 저주',
      'Dark Harvest': '어둠의 수확',
      'Hydraulic Ram': '수력 격돌',
      'Hydrofall': '물 쏟기',
      'Hydrovent': '솟구치는 물',
      'Icebreaker': '얼음 부수기',
      'Icy Throes': '얼음 던지기',
      'Knock on Ice': '얼음 두드리기',
      'Left Slam': '알비온의 왼주먹',
      'Lifescleaver': '생명의 살육자',
      'Neap Tide': '수마의 작은물',
      'Right Slam': '알비온의 오른주먹',
      'Roar of Albion': '알비온의 포효',
      'Scarecrow Chase': '이동 십자베기',
      'Soul Nebula': '영혼의 성운',
      'Soul Scythe': '영혼의 낫',
      'Spring Tide': '수마의 큰물',
      'Stony Gaze': '석화 저주의 눈',
      'Stygian Deluge': '지저 대홍수',
      'Tenebrism': '테네브리즘',
      'Tsunami': '해일',
      'Void Miasma': '보이드의 독기',
      'Void Torrent': '보이드 급류',
      'Voidcleaver': '보이드의 살육자',
      'Waning Cycle': '회전 연속베기',
      'Waxing Cycle': '연속 회전베기',
      'Wildlife Crossing': '짐승 질주'
    }
  }]
};
/* harmony default export */ const lapis_manalis = (lapis_manalis_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/lapis_manalis.txt
const dungeon_lapis_manalis_namespaceObject = "# Lapis Manalis\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~#\r\n# Albion #\r\n#~~~~~~~~#\r\n\r\n# -ii 7A7D 7A7E\r\n\r\n# The Silvan Throne will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10B2\" } window 0,1\r\n6.0 \"--sync--\" Ability { id: \"802C\", source: \"Albion\" }\r\n10.6 \"Call of the Mountain\" Ability { id: \"7A7C\", source: \"Albion\" }\r\n\r\n12.9 \"Wildlife Crossing 1\" MapEffect { flags: \"00020001\" } duration 15 window 5,5\r\n26.9 \"Wildlife Crossing 2\" MapEffect { flags: \"00020001\" } duration 15 window 5,5\r\n41.4 \"Albion's Embrace\" Ability { id: \"7A85\", source: \"Albion\" }\r\n48.4 \"--sync--\" Ability { id: \"802C\", source: \"Albion\" }\r\n55.1 \"Left Slam/Right Slam\" Ability { id: [\"802E\", \"802D\"], source: \"Albion\" }\r\n65.7 \"Knock on Ice\" Ability { id: \"7A7F\", source: \"Albion\" }\r\n72.0 \"Icebreaker\" Ability { id: \"7A81\", source: \"Albion\" }\r\n75.0 \"--sync--\" Ability { id: \"7A82\", source: \"Albion\" }\r\n81.2 \"Icy Throes\" Ability { id: [\"800F\", \"7A83\"], source: \"Albion\" }\r\n81.6 \"--sync--\" Ability { id: \"802C\", source: \"Albion\" }\r\n86.2 \"Icy Throes\" Ability { id: \"7FB9\", source: \"Albion\" }\r\n\r\n90.2 \"Roar of Albion\" Ability { id: \"7A84\", source: \"Albion\" }\r\n103.3 \"Call of the Mountain\" Ability { id: \"7A7C\", source: \"Albion\" }\r\n106.1 \"Wildlife Crossing 1\" MapEffect { flags: \"00020001\" } duration 15 window 5,5\r\n108.7 \"--sync--\" Ability { id: \"802C\", source: \"Albion\" }\r\n115.5 \"Left Slam/Right Slam\" Ability { id: [\"802E\", \"802D\"], source: \"Albion\" }\r\n120.0 \"Wildlife Crossing 2\" MapEffect { flags: \"00020001\" } duration 15 window 5,5\r\n123.9 \"--sync--\" Ability { id: \"802C\", source: \"Albion\" }\r\n130.8 \"Left Slam/Right Slam\" Ability { id: [\"802E\", \"802D\"], source: \"Albion\" }\r\n141.4 \"Albion's Embrace\" Ability { id: \"7A85\", source: \"Albion\" }\r\n151.5 \"Knock on Ice\" Ability { id: \"7A7F\", source: \"Albion\" }\r\n157.6 \"Icebreaker\" Ability { id: \"7A81\", source: \"Albion\" }\r\n160.6 \"--sync--\" Ability { id: \"7A82\", source: \"Albion\" }\r\n166.8 \"Icy Throes\" Ability { id: [\"800F\", \"7A83\"], source: \"Albion\" }\r\n167.2 \"--sync--\" Ability { id: \"802C\", source: \"Albion\" }\r\n171.8 \"Icy Throes\" Ability { id: \"7FB9\", source: \"Albion\" }\r\n\r\n# loop\r\n175.8 \"Roar of Albion\" Ability { id: \"7A84\", source: \"Albion\" } window 30,30 jump 90.2\r\n188.9 \"Call of the Mountain\" #Ability { id: \"7A7C\", source: \"Albion\" }\r\n191.7 \"Wildlife Crossing 1\" #MapEffect { flags: \"00020001\" } duration 15 window 5,5\r\n194.3 \"--sync--\" #Ability { id: \"802C\", source: \"Albion\" }\r\n201.1 \"Left Slam/Right Slam\" #Ability { id: [\"802E\", \"802D\"], source: \"Albion\" }\r\n205.6 \"Wildlife Crossing 2\" #MapEffect { flags: \"00020001\" } duration 15 window 5,5\r\n209.5 \"--sync--\" #Ability { id: \"802C\", source: \"Albion\" }\r\n216.4 \"Left Slam/Right Slam\" #Ability { id: [\"802E\", \"802D\"], source: \"Albion\" }\r\n\r\n#~~~~~~~~~~~~~~~#\r\n# Galatea Magna #\r\n#~~~~~~~~~~~~~~~#\r\n\r\n# -ii 7F71 7A9D\r\n\r\n# Forum Messorum will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10B3\" } window 1000,1\r\n1010.2 \"--sync--\" Ability { id: \"7F71\", source: \"Galatea Magna\" } # manually added for early sync\r\n1015.2 \"Waxing Cycle/Waning Cycle\" Ability { id: [\"7A91\", \"7F6E\"], source: \"Galatea Magna\" }\r\n1016.8 \"--sync--\" Ability { id: \"7F6F\", source: \"Galatea Magna\" }\r\n1017.2 \"Waxing Cycle/Waning Cycle\" Ability { id: [\"7A93\", \"7F70\"], source: \"Galatea Magna\" }\r\n1028.3 \"Soul Scythe\" Ability { id: \"7A9A\", source: \"Galatea Magna\" }\r\n1037.4 \"Soul Nebula\" Ability { id: \"7A9E\", source: \"Galatea Magna\" }\r\n1049.1 \"--sync--\" Ability { id: \"7A9B\", source: \"Galatea Magna\" }\r\n1051.1 \"Scarecrow Chase 1\" Ability { id: \"7FBF\", source: \"Galatea Magna\" }\r\n1054.1 \"Scarecrow Chase 2\" Ability { id: \"7FBF\", source: \"Galatea Magna\" }\r\n1064.1 \"Tenebrism\" Ability { id: \"7A96\", source: \"Galatea Magna\" }\r\n1071.1 \"Burst 1\" #Ability { id: \"7A97\", source: \"Galatea Magna\" }\r\n1073.1 \"Burst 2\" #Ability { id: \"7A97\", source: \"Galatea Magna\" }\r\n1075.1 \"Burst 3\" #Ability { id: \"7A97\", source: \"Galatea Magna\" }\r\n1077.1 \"Burst 4\" #Ability { id: \"7A97\", source: \"Galatea Magna\" }\r\n1079.1 \"Stony Gaze x4\" Ability { id: \"7A99\", source: \"Galatea Magna\" }\r\n1091.1 \"Waxing Cycle/Waning Cycle\" Ability { id: [\"7A91\", \"7F6E\"], source: \"Galatea Magna\" }\r\n1092.7 \"--sync--\" Ability { id: \"7A92\", source: \"Galatea Magna\" }\r\n1093.9 \"Waxing Cycle/Waning Cycle\" Ability { id: [\"7A93\", \"7F70\"], source: \"Galatea Magna\" }\r\n1103.1 \"Soul Scythe\" Ability { id: \"7A9A\", source: \"Galatea Magna\" }\r\n1111.1 \"Soul Nebula\" Ability { id: \"7A9E\", source: \"Galatea Magna\" }\r\n1122.8 \"--sync--\" Ability { id: \"7A9B\", source: \"Galatea Magna\" }\r\n1124.8 \"Scarecrow Chase 1\" Ability { id: \"7FBF\", source: \"Galatea Magna\" }\r\n1127.8 \"Scarecrow Chase 2\" Ability { id: \"7FBF\", source: \"Galatea Magna\" }\r\n1130.8 \"Scarecrow Chase 3\" Ability { id: \"7FBF\", source: \"Galatea Magna\" }\r\n1133.8 \"Scarecrow Chase 4\" Ability { id: \"7FBF\", source: \"Galatea Magna\" }\r\n1140.8 \"Tenebrism\" Ability { id: \"7A96\", source: \"Galatea Magna\" }\r\n1147.8 \"Burst 1\" #Ability { id: \"7A97\", source: \"Galatea Magna\" }\r\n1149.8 \"Burst 2\" #Ability { id: \"7A97\", source: \"Galatea Magna\" }\r\n1151.8 \"Burst 3\" #Ability { id: \"7A97\", source: \"Galatea Magna\" }\r\n1153.8 \"Burst 4\" #Ability { id: \"7A97\", source: \"Galatea Magna\" }\r\n1155.8 \"Stony Gaze x4\" Ability { id: \"7A99\", source: \"Galatea Magna\" }\r\n1162.9 \"Waxing Cycle/Waning Cycle\" Ability { id: [\"7A91\", \"7F6E\"], source: \"Galatea Magna\" }\r\n1164.5 \"--sync--\" Ability { id: \"7A92\", source: \"Galatea Magna\" }\r\n1165.6 \"Waxing Cycle/Waning Cycle\" Ability { id: [\"7A93\", \"7F70\"], source: \"Galatea Magna\" }\r\n1174.3 \"Soul Scythe\" Ability { id: \"7A9A\", source: \"Galatea Magna\" }\r\n1182.3 \"Soul Nebula\" Ability { id: \"7A9E\", source: \"Galatea Magna\" }\r\n1194.0 \"--sync--\" Ability { id: \"7A9B\", source: \"Galatea Magna\" }\r\n1196.0 \"Scarecrow Chase 1\" Ability { id: \"7FBF\", source: \"Galatea Magna\" }\r\n1199.0 \"Scarecrow Chase 2\" Ability { id: \"7FBF\", source: \"Galatea Magna\" }\r\n1202.0 \"Scarecrow Chase 3\" Ability { id: \"7FBF\", source: \"Galatea Magna\" }\r\n1205.1 \"Scarecrow Chase 4\" Ability { id: \"7FBF\", source: \"Galatea Magna\" }\r\n1212.0 \"Tenebrism\" Ability { id: \"7A96\", source: \"Galatea Magna\" }\r\n1219.0 \"Burst 1\" #Ability { id: \"7A97\", source: \"Galatea Magna\" }\r\n1221.0 \"Burst 2\" #Ability { id: \"7A97\", source: \"Galatea Magna\" }\r\n1223.0 \"Burst 3\" #Ability { id: \"7A97\", source: \"Galatea Magna\" }\r\n1225.0 \"Burst 4\" #Ability { id: \"7A97\", source: \"Galatea Magna\" }\r\n1227.0 \"Stony Gaze x4\" #Ability { id: \"7A99\", source: \"Galatea Magna\" }\r\n1232.0 \"Dark Harvest\" Ability { id: \"7A9F\", source: \"Galatea Magna\" } # first time tankbuster is used\r\n1244.1 \"Waxing Cycle/Waning Cycle\" Ability { id: [\"7A91\", \"7F6E\"], source: \"Galatea Magna\" }\r\n1245.7 \"--sync--\" Ability { id: \"7F6F\", source: \"Galatea Magna\" }\r\n1246.1 \"Waxing Cycle/Waning Cycle\" Ability { id: [\"7A93\", \"7F70\"], source: \"Galatea Magna\" }\r\n\r\n# loop\r\n1256.0 \"Soul Scythe\" Ability { id: \"7A9A\", source: \"Galatea Magna\" } window 30,30 jump 1174.3\r\n1264.0 \"Soul Nebula\" #Ability { id: \"7A9E\", source: \"Galatea Magna\" }\r\n1275.7 \"--sync--\" #Ability { id: \"7A9B\", source: \"Galatea Magna\" }\r\n1277.7 \"Scarecrow Chase 1\" #Ability { id: \"7FBF\", source: \"Galatea Magna\" }\r\n1280.7 \"Scarecrow Chase 2\" #Ability { id: \"7FBF\", source: \"Galatea Magna\" }\r\n1283.7 \"Scarecrow Chase 3\" #Ability { id: \"7FBF\", source: \"Galatea Magna\" }\r\n1286.7 \"Scarecrow Chase 4\" #Ability { id: \"7FBF\", source: \"Galatea Magna\" }\r\n1293.6 \"Tenebrism\" #Ability { id: \"7A96\", source: \"Galatea Magna\" }\r\n\r\n#~~~~~~~~~~#\r\n# Cagnazzo #\r\n#~~~~~~~~~~#\r\n\r\n# -p 79A3:2015.6 799C:2102.9 7986:2513.2\r\n# -ii 7FB7 7FB5 7FB8\r\n# -it \"Cagnazzo\"\r\n\r\n# Deepspine will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10B4\" } window 2000,1\r\n2015.6 \"Stygian Deluge\" Ability { id: \"79A3\", source: \"Cagnazzo\" }\r\n2025.4 \"--sync--\" Ability { id: \"798F\", source: \"Cagnazzo\" }\r\n2038.0 \"Antediluvian 1\" Ability { id: \"7990\", source: \"Cagnazzo\" }\r\n2042.0 \"Antediluvian 2\" Ability { id: \"7990\", source: \"Cagnazzo\" }\r\n2043.3 \"--sync--\" Ability { id: \"7991\", source: \"Cagnazzo\" }\r\n2044.3 \"Body Slam\" Ability { id: [\"7992\", \"7993\"], source: \"Cagnazzo\" }\r\n2046.0 \"Antediluvian 3\" Ability { id: \"7990\", source: \"Cagnazzo\" }\r\n2051.1 \"--sync--\" Ability { id: \"799B\", source: \"Cagnazzo\" }\r\n2060.9 \"--sync--\" Ability { id: \"7FB4\", source: \"Cagnazzo\" }\r\n2062.8 \"Hydraulic Ram\" duration 6 #Ability { id: \"7FB6\", source: \"Cagnazzo\" }\r\n2069.4 \"--sync--\" Ability { id: \"7996\", source: \"Cagnazzo\" }\r\n2073.5 \"--sync--\" Ability { id: \"799B\", source: \"Cagnazzo\" }\r\n2084.6 \"--sync--\" Ability { id: \"7A8F\", source: \"Cagnazzo\" }\r\n2085.2 \"Hydrofall\" Ability { id: \"7A90\", source: \"Cagnazzo\" }\r\n2095.9 \"Cursed Tide\" Ability { id: \"799A\", source: \"Cagnazzo\" }\r\n\r\n# add phase\r\n2099.5 \"--untargetable--\"\r\n2099.5 \"--sync--\" Ability { id: \"799B\", source: \"Cagnazzo\" }\r\n2102.9 \"--sync--\" Ability { id: \"799C\", source: \"Cagnazzo\" }\r\n2113.7 \"Neap Tide\" Ability { id: \"799E\", source: \"Cagnazzo\" }\r\n2118.1 \"Hydrovent\" Ability { id: \"79A0\", source: \"Cagnazzo\" }\r\n2124.7 \"Spring Tide\" Ability { id: \"799F\", source: \"Cagnazzo\" }\r\n2134.1 \"Hydrovent\" Ability { id: \"79A0\", source: \"Cagnazzo\" }\r\n2145.1 \"Hydrovent\" Ability { id: \"79A0\", source: \"Cagnazzo\" }\r\n# probably more Hydrovent spam here until phase end or enrage\r\n\r\n2500.0 \"--sync--\" GameLog { code: \"0044\", name: \"Cagnazzo\", line: \"No more games!.*?\" } window 500,0\r\n2513.0 \"Tsunami\" Ability { id: \"79A1\", source: \"Cagnazzo\" } window 500,1 # if we miss the chatline sync we'll still resync here\r\n2516.9 \"--targetable--\"\r\n2523.0 \"--sync--\" Ability { id: \"799B\", source: \"Cagnazzo\" }\r\n2530.1 \"--sync--\" Ability { id: \"7986\", source: \"Cagnazzo\" }\r\n2531.0 \"Voidcleaver\" Ability { id: \"7987\", source: \"Cagnazzo\" }\r\n2540.0 \"Void Miasma 1\" Ability { id: \"7FB3\", source: \"Cagnazzo\" }\r\n2546.0 \"Void Miasma 2\" Ability { id: \"7FB3\", source: \"Cagnazzo\" }\r\n2546.3 \"--sync--\" Ability { id: \"7988\", source: \"Cagnazzo\" }\r\n2547.3 \"Lifescleaver x8\" Ability { id: \"7989\", source: \"Cagnazzo\" }\r\n2552.0 \"Void Miasma 3\" Ability { id: \"7FB3\", source: \"Cagnazzo\" }\r\n2556.7 \"Void Torrent\" Ability { id: \"798E\", source: \"Cagnazzo\" }\r\n2564.5 \"--sync--\" Ability { id: \"799B\", source: \"Cagnazzo\" }\r\n2574.3 \"--sync--\" Ability { id: \"7FB4\", source: \"Cagnazzo\" }\r\n2576.2 \"Hydraulic Ram\" duration 6 #Ability { id: \"7FB6\", source: \"Cagnazzo\" }\r\n2582.8 \"--sync--\" Ability { id: \"7996\", source: \"Cagnazzo\" }\r\n2586.8 \"--sync--\" Ability { id: \"799B\", source: \"Cagnazzo\" }\r\n2597.9 \"Stygian Deluge\" Ability { id: \"79A3\", source: \"Cagnazzo\" }\r\n2609.7 \"--sync--\" Ability { id: \"798F\", source: \"Cagnazzo\" }\r\n2622.3 \"Antediluvian 1\" Ability { id: \"7990\", source: \"Cagnazzo\" }\r\n2626.3 \"Antediluvian 2\" Ability { id: \"7990\", source: \"Cagnazzo\" }\r\n2627.6 \"--sync--\" Ability { id: \"7991\", source: \"Cagnazzo\" }\r\n2628.6 \"Body Slam\" Ability { id: [\"7992\", \"7993\"], source: \"Cagnazzo\" }\r\n2630.3 \"Antediluvian 3\" Ability { id: \"7990\", source: \"Cagnazzo\" }\r\n2635.3 \"--sync--\" Ability { id: \"799B\", source: \"Cagnazzo\" }\r\n2642.6 \"--sync--\" Ability { id: \"7986\", source: \"Cagnazzo\" }\r\n2643.5 \"Voidcleaver\" Ability { id: \"7987\", source: \"Cagnazzo\" }\r\n2652.5 \"Void Miasma 1\" Ability { id: \"7FB3\", source: \"Cagnazzo\" }\r\n2658.5 \"Void Miasma 2\" Ability { id: \"7FB3\", source: \"Cagnazzo\" }\r\n2658.7 \"--sync--\" Ability { id: \"7988\", source: \"Cagnazzo\" }\r\n2659.7 \"Lifescleaver x8\" Ability { id: \"7989\", source: \"Cagnazzo\" }\r\n2664.5 \"Void Miasma 3\" Ability { id: \"7FB3\", source: \"Cagnazzo\" }\r\n2669.1 \"Void Torrent\" Ability { id: \"798E\", source: \"Cagnazzo\" }\r\n2676.9 \"--sync--\" Ability { id: \"799B\", source: \"Cagnazzo\" }\r\n\r\n# loop\r\n2686.6 \"--sync--\" Ability { id: \"7FB4\", source: \"Cagnazzo\" } window 30,30 jump 2574.3\r\n2688.5 \"Hydraulic Ram\" duration 6 #Ability { id: \"7FB6\", source: \"Cagnazzo\" }\r\n2695.1 \"--sync--\" #Ability { id: \"7996\", source: \"Cagnazzo\" }\r\n2699.2 \"--sync--\" #Ability { id: \"799B\", source: \"Cagnazzo\" }\r\n2710.3 \"Stygian Deluge\" #Ability { id: \"79A3\", source: \"Cagnazzo\" }\r\n2722.0 \"--sync--\" #Ability { id: \"798F\", source: \"Cagnazzo\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/mount_rokkon.ts






// TODO: find network lines for Yozakura Seal of Riotous Bloom arrows (nothing in network logs)
// TODO: find network lines for Enenra Out of the Smoke (nothing in network logs)
// TODO: Yozakura Seasons of the Fleeting
//       you would need to track 8384 (pinwheel) and 8383 (line) *abilities* (not incorrect casts)
//       and use their positions and rotations to know whether to say front/back/card/intercard
//       she repositions beforehand, so front/back of her is a known safe position.
// TODO: Moko safe spots for Iron Rain
// TODO: Gorai path 06 Humble Hammer safe spots for which Ball of Levin hit by Humble Hammer
// TODO: Shishio Rokujo calls ("go SW, clockwise") kinda thing
const sealMap = {
  '837A': 'fire',
  '837B': 'wind',
  '837C': 'thunder',
  '837D': 'rain'
};
const sealDamageMap = {
  '8375': 'fire',
  '8376': 'wind',
  '8377': 'rain',
  '8378': 'thunder'
};
const sealIds = Object.keys(sealMap);
const sealDamageIds = Object.keys(sealDamageMap);
const mount_rokkon_mokoVfxMap = {
  '248': 'back',
  '249': 'left',
  '24A': 'front',
  '24B': 'right'
};
const mount_rokkon_triggerSet = {
  id: 'MountRokkon',
  zoneId: zone_id/* default.MountRokkon */.Z.MountRokkon,
  timelineFile: 'mount_rokkon.txt',
  initData: () => {
    return {
      combatantData: [],
      yozakuraSeal: [],
      yozakuraTatami: [],
      enenraPipeCleanerCollect: [],
      devilishThrallCollect: []
    };
  },
  triggers: [
  // --------- Yozakura the Fleeting ----------
  {
    id: 'Rokkon Yozakura Glory Neverlasting',
    type: 'StartsUsing',
    netRegex: {
      id: '83A9',
      source: 'Yozakura the Fleeting'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Rokkon Yozakura Art of the Windblossom',
    type: 'StartsUsing',
    netRegex: {
      id: '8369',
      source: 'Yozakura the Fleeting',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn('info')
  }, {
    id: 'Rokkon Yozakura Art of the Fireblossom',
    type: 'StartsUsing',
    netRegex: {
      id: '8368',
      source: 'Yozakura the Fleeting',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut('info')
  }, {
    id: 'Rokkon Yozakura Shadowflight',
    type: 'StartsUsing',
    netRegex: {
      id: '8380',
      source: 'Mirrored Yozakura',
      capture: false
    },
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'Rokkon Yozakura Kuge Rantsui',
    type: 'StartsUsing',
    netRegex: {
      id: '83AA',
      source: 'Yozakura the Fleeting',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Rokkon Yozakura Drifting Petals',
    type: 'StartsUsing',
    netRegex: {
      id: '8393',
      source: 'Yozakura the Fleeting',
      capture: false
    },
    alertText: (_data, _matches, output) => output.knockback(),
    outputStrings: {
      knockback: {
        en: 'Unavoidable Knockback',
        de: 'Unvermeidbarer Rückstoß',
        fr: 'Poussée inévitable',
        ja: '避けないノックバック',
        cn: '击退 (防击退无效)',
        ko: '넉백 방지 불가'
      }
    }
  }, {
    id: 'Rokkon Yozakura Seal Collect',
    type: 'Ability',
    netRegex: {
      id: sealIds,
      source: 'Yozakura the Fleeting'
    },
    run: (data, matches) => {
      // Collect flowers as they appear.
      // TODO: there are no network lines for which ones are active.
      // So we do the best we can, which is:
      // * show an alert for the first set (with only two)
      // * show nothing on the first pair of further sets (this is probably confusing to players)
      // * by process of elimination show the second pair on further sets
      const looseSealMap = sealMap;
      const seal = looseSealMap[matches.id];
      if (seal !== undefined) data.yozakuraSeal.push(seal);
    }
  }, {
    id: 'Rokkon Yozakura Seal of Riotous Bloom',
    type: 'StartsUsing',
    netRegex: {
      id: '8374',
      source: 'Yozakura the Fleeting',
      capture: false
    },
    alertText: (data, _matches, output) => {
      // If we know what this is, show something. Otherwise, sorry.
      if (data.yozakuraSeal.length !== 2) return;
      const isIn = data.yozakuraSeal.includes('wind');
      const isCardinals = data.yozakuraSeal.includes('rain');
      if (isIn && isCardinals) return output.inAndCards();
      if (isIn && !isCardinals) return output.inAndIntercards();
      if (!isIn && isCardinals) return output.outAndCards();
      if (!isIn && !isCardinals) return output.outAndIntercards();
    },
    outputStrings: {
      inAndCards: {
        en: 'In + Cardinals',
        de: 'Rein + Kardinal',
        fr: 'Intérieur + Cardinal',
        cn: '内 + 十字',
        ko: '안 + 십자방향'
      },
      outAndCards: {
        en: 'Out + Cardinals',
        de: 'Raus + Kardinal',
        fr: 'Extérieur + Cardinal',
        cn: '外 + 十字',
        ko: '밖 + 십자방향'
      },
      inAndIntercards: {
        en: 'In + Intercards',
        de: 'Rein + Interkardinal',
        fr: 'Intérieur + Intercardinal',
        cn: '内 + 四角',
        ko: '안 + 대각선'
      },
      outAndIntercards: {
        en: 'Out + Intercards',
        de: 'Raus + Interkardinal',
        fr: 'Extérieur + Intercardinal',
        cn: '外 + 四角',
        ko: '밖 + 대각선'
      }
    }
  }, {
    id: 'Rokkon Yozakura Seal Damage Collect',
    type: 'StartsUsing',
    netRegex: {
      id: sealDamageIds,
      source: 'Yozakura the Fleeting'
    },
    run: (data, matches) => {
      // Remove abilities that have happened so we can know the second pair.
      const seal = sealDamageMap[matches.id];
      data.yozakuraSeal = data.yozakuraSeal.filter(x => x !== seal);
    }
  }, {
    id: 'Rokkon Yozakura Art of the Fluff',
    type: 'StartsUsing',
    netRegex: {
      id: '839E',
      source: 'Shiromaru'
    },
    alertText: (_data, matches, output) => {
      const xPos = parseFloat(matches.x);
      // center = 737
      // east = 765
      // west = 709
      if (xPos > 737) return output.lookWest();
      return output.lookEast();
    },
    outputStrings: {
      lookWest: {
        en: 'Look West',
        de: 'Schau nach Westen',
        fr: 'Regardez à l\'Ouest',
        cn: '看左 (西) 侧',
        ko: '서쪽 보기'
      },
      lookEast: {
        en: 'Look East',
        de: 'Schau nach Osten',
        fr: 'Regardez à l\'Est',
        cn: '看右 (东) 侧',
        ko: '동쪽 보기'
      }
    }
  }, {
    id: 'Rokkon Yozakura Tatami Collect',
    type: 'MapEffect',
    // 00020001 = shake
    // 00080004 = go back to normal
    // 80038CA2 = flip
    netRegex: {
      flags: '00020001'
    },
    run: (data, matches) => data.yozakuraTatami.push(matches.location)
  }, {
    id: 'Rokkon Yozakura Tatami-gaeshi',
    type: 'StartsUsing',
    netRegex: {
      id: '8395',
      source: 'Yozakura the Fleeting',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const map = {
        '37': 'outsideNorth',
        '38': 'insideNorth',
        '39': 'insideSouth',
        '3A': 'outsideSouth'
      };
      for (const location of data.yozakuraTatami) delete map[location];

      // Call inside before outside.
      const callOrder = ['38', '39', '37', '3A'];
      for (const key of callOrder) {
        const outputKey = map[key];
        if (outputKey !== undefined) return output[outputKey]();
      }
    },
    run: data => data.yozakuraTatami = [],
    outputStrings: {
      outsideNorth: {
        en: 'Outside North',
        de: 'Nördlich außen',
        fr: 'Extérieur Nord',
        cn: '上 (北) 外',
        ko: '북쪽 바깥'
      },
      insideNorth: {
        en: 'Inside North',
        de: 'Nördlich innen',
        fr: 'Intérieur Nord',
        cn: '上 (北) 内',
        ko: '북쪽 안'
      },
      insideSouth: {
        en: 'Inside South',
        de: 'Südlich innen',
        fr: 'Intérieur Sud',
        cn: '下 (南) 内',
        ko: '남쪽 안'
      },
      outsideSouth: {
        en: 'Outside South',
        de: 'Südlich außen',
        fr: 'Extérieur Sud',
        cn: '下 (南) 外',
        ko: '남쪽 바깥'
      }
    }
  }, {
    id: 'Rokkon Yozakura Root Arrangement',
    type: 'HeadMarker',
    netRegex: {
      id: '00C5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: '4x Chasing AOE on YOU',
        de: '4x verfolgende AoE auf DIR',
        fr: '4x AoE sur VOUS',
        cn: '四连 AOE 点名',
        ko: '따라오는 장판 4번'
      }
    }
  },
  // --------- Moko the Restless ----------
  {
    id: 'Rokkon Moko Kenki Release',
    type: 'StartsUsing',
    netRegex: {
      id: '85AD',
      source: 'Moko the Restless',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Rokkon Moko Scarlet Auspice',
    type: 'StartsUsing',
    netRegex: {
      id: '8598',
      source: 'Moko the Restless',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Rokkon Moko Azure Auspice',
    type: 'StartsUsing',
    netRegex: {
      id: '859C',
      source: 'Moko the Restless',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Rokkon Moko Double Kasumi-Giri Checker',
    type: 'StartsUsing',
    // This cast comes out prior to the BA9 vfx.
    netRegex: {
      id: '858[BCDE]',
      source: 'Moko the Restless',
      capture: false
    },
    run: data => data.isDoubleKasumiGiri = true
  }, {
    id: 'Rokkon Moko Iai-kasumi-giri',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(mount_rokkon_mokoVfxMap)
    },
    condition: data => !data.isDoubleKasumiGiri,
    alertText: (_data, matches, output) => {
      const map = mount_rokkon_mokoVfxMap;
      const thisAbility = map[matches.count];
      if (thisAbility === undefined) return;
      return output[thisAbility]();
    },
    outputStrings: {
      back: outputs/* default.back */.Z.back,
      front: outputs/* default.front */.Z.front,
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'Rokkon Moko Double Kasumi-giri Second',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(mount_rokkon_mokoVfxMap)
    },
    condition: data => data.isDoubleKasumiGiri && data.firstKasumiGiri !== undefined,
    durationSeconds: 6,
    alertText: (data, matches, output) => {
      const map = mount_rokkon_mokoVfxMap;
      const thisAbility = map[matches.count];
      if (thisAbility === undefined) return;
      const firstDir = data.firstKasumiGiri;
      if (firstDir === undefined) return;
      const dir1 = output[firstDir]();
      const secondMap = {
        front: output.through(),
        back: output.stay(),
        left: output.rotateLeft(),
        right: output.rotateRight()
      };
      const dir2 = secondMap[thisAbility];
      return output.combo({
        dir1: dir1,
        dir2: dir2
      });
    },
    run: data => {
      delete data.firstKasumiGiri;
      delete data.isDoubleKasumiGiri;
    },
    outputStrings: {
      back: outputs/* default.back */.Z.back,
      front: outputs/* default.front */.Z.front,
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      through: {
        en: 'Run Through',
        de: 'Renn durch',
        fr: 'Traversez',
        cn: '穿',
        ko: '가로지르기'
      },
      stay: {
        en: 'Stay',
        de: 'Stehen bleiben',
        fr: 'Restez',
        cn: '停',
        ko: '그대로'
      },
      rotateLeft: {
        en: 'Rotate Left',
        de: 'Links rotieren',
        fr: 'Tournez vers la gauche',
        cn: '向左旋转',
        ko: '왼쪽으로'
      },
      rotateRight: {
        en: 'Rotate Right',
        de: 'Rechts rotieren',
        fr: 'Tourner vers la droite',
        cn: '向右旋转',
        ko: '오른쪽으로'
      },
      combo: {
        en: '${dir1} => ${dir2}',
        de: '${dir1} => ${dir2}',
        fr: '${dir1} => ${dir2}',
        cn: '${dir1} => ${dir2}',
        ko: '${dir1} => ${dir2}'
      }
    }
  }, {
    id: 'Rokkon Moko Double Kasumi-giri First',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B9A',
      count: Object.keys(mount_rokkon_mokoVfxMap)
    },
    condition: data => data.isDoubleKasumiGiri && data.firstKasumiGiri === undefined,
    infoText: (data, matches, output) => {
      const map = mount_rokkon_mokoVfxMap;
      const thisAbility = map[matches.count];
      if (thisAbility === undefined) return;
      data.firstKasumiGiri = thisAbility;
      return output.text({
        dir: output[thisAbility]()
      });
    },
    outputStrings: {
      text: {
        en: '(${dir} First)',
        de: '(${dir} Zuerst)',
        fr: '(${dir} en 1er)',
        cn: '(首先 ${dir})',
        ko: '(${dir} 먼저)'
      },
      back: outputs/* default.back */.Z.back,
      front: outputs/* default.front */.Z.front,
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      combo: {
        en: '${dir1} => ${dir2}',
        de: '${dir1} => ${dir2}',
        fr: '${dir1} => ${dir2}',
        cn: '${dir1} => ${dir2}',
        ko: '${dir1} => ${dir2}'
      }
    }
  },
  // --------- Gorai the Uncaged ----------
  {
    id: 'Rokkon Gorai Unenlightemnment',
    type: 'StartsUsing',
    netRegex: {
      id: '8500',
      source: 'Gorai the Uncaged',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Rokkon Gorai Fighting Spirits',
    type: 'StartsUsing',
    netRegex: {
      id: '84F8',
      source: 'Gorai the Uncaged',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Rokkon Gorai Biwa Breaker',
    type: 'StartsUsing',
    netRegex: {
      id: '84FD',
      source: 'Gorai the Uncaged',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Rokkon Gorai Torching Torment',
    type: 'StartsUsing',
    netRegex: {
      id: '84FE',
      source: 'Gorai the Uncaged'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Rokkon Gorai Summon Collect',
    type: 'StartsUsing',
    // 84D5 = Flickering Flame
    // 84D6 = Sulphuric Stone
    // 84D7 = Flame and Sulphur
    netRegex: {
      id: ['84D5', '84D6', '84D7'],
      source: 'Gorai the Uncaged'
    },
    run: (data, matches) => data.goraiSummon = matches
  }, {
    id: 'Rokkon Gorai Plectrum of Power',
    type: 'StartsUsing',
    netRegex: {
      id: '84D8',
      source: 'Gorai the Uncaged',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const id = data.goraiSummon?.id;
      if (id === '84D5') return output.lines();
      if (id === '84D6') return output.rocks();
      if (id === '84D7') return output.both();
    },
    run: data => delete data.goraiSummon,
    outputStrings: {
      lines: {
        en: 'Avoid Expanding Lines',
        de: 'Weiche den expandierenden Linien aus',
        fr: 'Évitez les lignes qui s\'étendent',
        cn: '远离扩张的线',
        ko: '커지는 직선 장판 피하기'
      },
      rocks: {
        en: 'Avoid Expanding Rocks',
        de: 'Weiche den expandierenden Steinen aus',
        fr: 'Évitez les rochers qui s\'étendent',
        cn: '远离变大的石头',
        ko: '커지는 바위 장판 피하기'
      },
      both: {
        en: 'Avoid Expanding Rocks/Lines',
        de: 'Weiche den expandierenden Steinen/Linien aus',
        fr: 'Évitez les rochers/lignes qui s\'étendent',
        cn: '远离扩张的线 + 石头',
        ko: '커지는 직선/바위 장판 피하기'
      }
    }
  }, {
    id: 'Rokkon Gorai Morphic Melody',
    type: 'StartsUsing',
    netRegex: {
      id: '84D9',
      source: 'Gorai the Uncaged',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const id = data.goraiSummon?.id;
      if (id === '84D5') return output.lines();
      if (id === '84D6') return output.rocks();
      if (id === '84D7') return output.both();
    },
    run: data => delete data.goraiSummon,
    outputStrings: {
      lines: outputs/* default.goIntoMiddle */.Z.goIntoMiddle,
      rocks: {
        en: 'Stand on Rock',
        de: 'Steh auf einem Stein',
        fr: 'Restez sur le rocher',
        cn: '站在石头上',
        ko: '바위 위에 있기'
      },
      both: {
        en: 'Stand on Rock + Line',
        de: 'Steh auf einem Stein + Linie',
        fr: 'Restez sur le rocher + la ligne',
        cn: '站在石头 + 线上',
        ko: '바위 + 직선장판 위에 있기'
      }
    }
  }, {
    id: 'Rokkon Gorai Malformed Prayer',
    type: 'StartsUsing',
    netRegex: {
      id: '84E1',
      source: 'Gorai the Uncaged',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand in All Towers',
        de: 'Steh in allen Türmen',
        fr: 'Restez dans les tours',
        cn: '站在塔里',
        ko: '모든 기둥 밟기'
      }
    }
  },
  // --------- Shishio ----------
  {
    id: 'Rokkon Shishio Enkyo',
    type: 'StartsUsing',
    netRegex: {
      id: '83F5',
      source: 'Shishio',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Rokkon Shishio Splitting Cry',
    type: 'StartsUsing',
    netRegex: {
      id: '83F6',
      source: 'Shishio'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Rokkon Shishio Noble Pursuit',
    type: 'StartsUsing',
    netRegex: {
      id: '83E6',
      source: 'Shishio',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Between Rings + Outside Line',
        de: 'Zwischen Ringen + äußere Linie',
        fr: 'Entre les anneaux + Extérieur des lignes',
        cn: '内环 + 外线',
        ko: '고리들 사이 + 바깥'
      }
    }
  }, {
    id: 'Rokkon Shishio Thunder Vortex',
    type: 'StartsUsing',
    netRegex: {
      id: '83F4',
      source: 'Shishio',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Rokkon Shishio Devilish Thrall Collect',
    type: 'StartsUsing',
    // 83F0 = Right Swipe
    // 83F1 = Left Swipe
    netRegex: {
      id: ['83F0', '83F1'],
      source: 'Devilish Thrall'
    },
    run: (data, matches) => data.devilishThrallCollect.push(matches)
  }, {
    id: 'Rokkon Shishio Devilish Thrall Safe Spot',
    type: 'StartsUsing',
    netRegex: {
      id: ['83F0', '83F1'],
      source: 'Devilish Thrall',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    promise: async data => {
      data.combatantData = [];
      const ids = data.devilishThrallCollect.map(x => parseInt(x.sourceId, 16));
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: ids
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      if (data.combatantData.length !== 4) return;
      const centerX = -40;
      const centerY = -300;

      // Cardinal thralls:
      //   x = -40 +/- 12
      //   y = -300 +/- 12
      //   heading = cardinals (pi/2 * n)

      // Variant Dungeon seems (at least in two pulls) to only have thralls
      // on cardinals, however handle a potential intercard thralls just in case.
      // There seems to be only one pattern of thralls, rotated.
      // Two are pointed inward (direct opposite to their position)
      // and two are pointed outward (perpendicular to their position).
      // Because of this, no need to check left/right cleave as position and directions tell all.
      const states = data.combatantData.map(combatant => {
        return {
          dir: util/* Directions.combatantStatePosTo8Dir */.N.combatantStatePosTo8Dir(combatant, centerX, centerY),
          heading: util/* Directions.combatantStateHdgTo8Dir */.N.combatantStateHdgTo8Dir(combatant)
        };
      });
      const outwardStates = states.filter(state => state.dir !== (state.heading + 4) % 8);
      const [pos1, pos2] = outwardStates.map(x => x.dir).sort();
      if (pos1 === undefined || pos2 === undefined || outwardStates.length !== 2) return;

      // The one case where the difference is 6 instead of 2.
      const averagePos = pos1 === 0 && pos2 === 6 ? 7 : Math.floor((pos2 + pos1) / 2);
      return {
        0: output.north(),
        1: output.northeast(),
        2: output.east(),
        3: output.southeast(),
        4: output.south(),
        5: output.southwest(),
        6: output.west(),
        7: output.northwest()
      }[averagePos];
    },
    run: data => data.devilishThrallCollect = [],
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      east: outputs/* default.east */.Z.east,
      south: outputs/* default.south */.Z.south,
      west: outputs/* default.west */.Z.west,
      northeast: outputs/* default.northeast */.Z.northeast,
      southeast: outputs/* default.southeast */.Z.southeast,
      southwest: outputs/* default.southwest */.Z.southwest,
      northwest: outputs/* default.northwest */.Z.northwest
    }
  },
  // --------- Enenra ----------
  {
    id: 'Rokkon Enenra Flagrant Combustion',
    type: 'StartsUsing',
    netRegex: {
      id: '8042',
      source: 'Enenra',
      capture: false
    },
    // Can be used during Smoke and Mirrors clone phase
    suppressSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Rokkon Enenra Smoke Rings',
    type: 'StartsUsing',
    netRegex: {
      id: '8053',
      source: 'Enenra',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Rokkon Enenra Clearing Smoke',
    type: 'StartsUsing',
    netRegex: {
      id: '8052',
      source: 'Enenra',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Rokkon Enenra Pipe Cleaner Collect',
    type: 'Tether',
    netRegex: {
      id: '0011'
    },
    run: (data, matches) => data.enenraPipeCleanerCollect.push(matches.source)
  }, {
    id: 'Rokkon Enenra Pipe Cleaner',
    type: 'StartsUsing',
    netRegex: {
      id: '8054',
      source: 'Enenra',
      capture: false
    },
    condition: data => data.enenraPipeCleanerCollect.includes(data.me),
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.enenraPipeCleanerCollect = [],
    outputStrings: {
      text: outputs/* default.earthshakerOnYou */.Z.earthshakerOnYou
    }
  }, {
    id: 'Rokkon Enenra Snuff',
    type: 'StartsUsing',
    netRegex: {
      id: '8056',
      source: 'Enenra'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Rokkon Enenra Uplift',
    type: 'Ability',
    // If hit by Snuff, move away from uplift.
    netRegex: {
      id: '8056',
      source: 'Enenra'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.moveAway */.n3.moveAway()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Clearing Smoke/Smoke Rings': 'Clearing Smoke/Rings',
      'Morphic Melody/Plectrum of Power': 'Morphic/Plectrum',
      'Plectrum of Power/Morphic Melody': 'Plectrum/Morphic'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Ancient Katana': 'antik(?:e|er|es|en) Katana',
      'Ashigaru Kyuhei': 'Ashigaru Kyuhei',
      'Autumn Rivers\' End': 'Ufer des Herbstflusses',
      'Ball of Levin': 'Elektrosphäre',
      'Devilish Thrall': 'hörig(?:e|er|es|en) Shiki',
      'Enenra': 'Enenra',
      'Feral Thrall': 'hörig(?:e|er|es|en) Moko',
      'Gorai the Uncaged': 'Gorai (?:der|die|das) Entfesselt(?:e|er|es|en)',
      'Haunting Thrall': 'hörig(?:e|er|es|en) Shiryo',
      'Ill-come Tengu': 'ungebeten(?:e|er|es|en) Tengu',
      'Last Glimpse': 'Letzter Blick',
      'Mirrored Yozakura': 'gedoppelt(?:e|er|es|en) Yozakura',
      'Moko the Restless': 'Moko (?:der|die|das) Rastlos(?:e|er|es|en)',
      'Oni\'s Claw': 'Oni-Klaue',
      'Rairin': 'Rairin',
      'Shiromaru': 'Shiromaru',
      'Shishio': 'Shishio',
      'Shishu White Baboon': 'weiß(?:e|er|es|en) Shishu-Pavian',
      'Stone\'s Silence': 'Steines Schweigen',
      'The Hall Of Becoming': 'Halle des Werdens',
      'The Hall Of Temptation': 'Halle der Versuchungen',
      'The Hall Of The Unseen': 'Halle der Verhüllung',
      'The Pond Of Spring Rain': 'Teich des Frühlingsregens',
      'Venomous Thrall': 'hörig(?:e|er|es|en) Daija',
      'Yozakura the Fleeting': 'Yozakura (?:der|die|das) Vergänglich(?:e|er|es|en)'
    },
    'replaceText': {
      '\\(cast\\)': '(wirken)',
      'Art of the Fireblossom': 'Kunst der Feuerblüte',
      'Art of the Fluff': 'Kunst der Flauschigkeit',
      'Art of the Windblossom': 'Kunst der Windblüte',
      'Azure Auspice': 'Azurblauer Kenki-Fokus',
      'Biwa Breaker': 'Biwa-Brecher',
      'Boundless Azure': 'Grenzenloses Azurblau',
      'Boundless Scarlet': 'Grenzenloses Scharlachrot',
      'Bunshin': 'Doppeltes Ich',
      '(?<!Levin)Burst': 'Explosion',
      'Clearing Smoke': 'Rauchauflösung',
      'Clearout': 'Ausräumung',
      'Donden-gaeshi': 'Donden-gaeshi',
      'Double Kasumi-giri': 'Doppeltes Kasumi-giri',
      'Drifting Petals': 'Blütenblätterregen',
      'Enkyo': 'Enkyo',
      'Explosion': 'Explosion',
      'Falling Rock': 'Steinschlag',
      'Fighting Spirits': 'Kräftigender Schluck',
      'Fire Spread': 'Brandstiftung',
      'Fireblossom Flare': 'Auflodern der Feuerblüte',
      'Flagrant Combustion': 'Abscheuliches Anfackeln',
      'Flame and Sulphur': 'Flamme und Schwefel',
      'Flickering Flame': 'Flackernde Flamme',
      'Focused Tremor': 'Kontrolliertes Beben',
      'Ghastly Grasp': 'Gruselgriff',
      'Glory Neverlasting': 'Trichterwinde',
      'Haunting Cry': 'Klagender Schrei',
      'Humble Hammer': 'Entehrender Hammer',
      'Iai-kasumi-giri': 'Iai-kasumi-giri',
      'Icebloom': 'Eisblüte',
      'Impure Purgation': 'Flammenwind',
      'Into the Fire': 'Blutgrätsche',
      'Iron Rain': 'Eisenregen',
      'Kenki Release': 'Kenki-Entfesselung',
      'Kiseru Clamor': 'Blutschwaden-Klatsche',
      'Kuge Rantsui': 'Kuge Rantsui',
      'Left Swipe': 'Linker Feger',
      'Levinblossom Lance': 'Blitz der Gewitterblüte',
      'Levinblossom Strike': 'Grollen der Gewitterblüte',
      'Levinburst': 'Blitzgang',
      'Malformed Prayer': 'Unheil des Perlenkranzes',
      'Moonless Night': 'Mondlose Nacht',
      'Morphic Melody': 'Morphende Melodie',
      'Mud Pie': 'Schlammklumpen',
      'Mudrain': 'Schlammblüte',
      'Noble Pursuit': 'Reißzahn des Löwen',
      'Nubuki': 'Nubuki',
      'Oka Ranman': 'Oka Ranman',
      'Once on Rokujo': 'Sechs Alleen: Einfach',
      'Out of the Smoke': 'Rauchwolke',
      'Pipe Cleaner': 'Klärende Aktion',
      'Plectrum of Power': 'Plektron der Macht',
      'Pure Shock': 'Elektrische Entladung',
      'Reisho': 'Reisho',
      'Right Swipe': 'Rechter Feger',
      'Root Arrangement': 'Wurzelwachstum',
      'Rousing Reincarnation': 'Fluch der Verwandlung',
      'Rush': 'Stürmen',
      'Scarlet Auspice': 'Scharlachroter Kenki-Fokus',
      'Seal Marker': 'Siegel Marker',
      'Seal of Riotous Bloom': 'Siegel des Wildblühens',
      'Seal of the Blossom': 'Siegel der Blüte',
      'Seal of the Fleeting': 'Kunst des Blütensiegels',
      'Season Indicator': 'Shikunshi Indikator',
      'Season of Element': 'Shikunshi des Elements',
      'Seasons of the Fleeting': 'Shikunshi',
      'Self-destruct': 'Selbstzerstörung',
      'Shadowflight': 'Schattenschlag',
      '(?<! )Shock': 'Entladung',
      'Silent Whistle': 'Hasenmedium',
      'Smoke Rings': 'Rauchringe',
      'Smoke Stack': 'Rauchschwade',
      'Smoke and Mirrors': 'Viel Rauch um nichts',
      'Smokeater': 'Dunstfresser',
      'Smoldering(?! Damnation)': 'Schwelendes Feuer',
      'Smoldering Damnation': 'Schwelende Verdammnis',
      'Snuff': 'Klatsche',
      'Soldiers of Death': 'Soldaten des Todes',
      'Spearman\'s Orders': 'Lanze vor!',
      'Spike of Flame': 'Flammenstachel',
      'Spiritflame': 'Geisterflamme',
      'Spiritspark': 'Geisterfunke',
      'Splitting Cry': 'Schrecklicher Schrei',
      'Stormcloud Summons': 'Elektrizitätsgenerierung',
      'String Snap': 'Bebende Erde',
      'Sulphuric Stone': 'Schwefliger Stein',
      'Tatami Trap': 'Fallenstellen',
      'Tatami-gaeshi': 'Tatami-gaeshi',
      'Tengu-yobi': 'Tengu-yobi',
      'Thunder Onefold': 'Blitzschlag: Einfach',
      'Thunder Threefold': 'Blitzschlag: Dreifach',
      'Thunder Twofold': 'Blitzschlag: Zweifach',
      'Thunder Vortex': 'Sturmwirbel',
      'Thundercall': 'Donnerruf',
      'Torching Torment': 'Höllische Hitze',
      'Unenlightenment': 'Glühende Geißel',
      'Unsheathing': 'Ziehen des Schwertes',
      'Untempered Sword': 'Zügelloses Schwert',
      'Uplift': 'Erhöhung',
      'Upwell': 'Strömung',
      'Vasoconstrictor': 'Vasokonstriktor',
      'Veil Sever': 'Schleierdurchtrennung',
      'Wily Wall': 'Missliche Mauerung',
      'Windblossom Whirl': 'Wirbel der Windblüte',
      'Witherwind': 'Blütenwirbel',
      'Worldly Pursuit': 'Springender Schmerzschlag',
      'Yama-kagura': 'Yama-kagura',
      'Yoki(?!-uzu)': 'Yoki',
      'Yoki-uzu': 'Yoki-uzu'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ancient Katana': 'katana ancien',
      'Ashigaru Kyuhei': 'ashigaru kyûhei',
      'Autumn Rivers\' End': 'Clairière de l\'Équinoxe',
      'Ball of Levin': 'orbe de foudre',
      'Devilish Thrall': 'ilote malicieux',
      'Enenra': 'Enenra',
      'Feral Thrall': 'ilote féroce',
      'Gorai the Uncaged': 'Gôrai le fureteur',
      'Haunting Thrall': 'ilote envoûtant',
      'Ill-come Tengu': 'tengu du Rokkon',
      'Last Glimpse': 'Clairière du Discernement',
      'Mirrored Yozakura': 'double de Yozakura',
      'Moko the Restless': 'Môko le tourmenté',
      'Oni\'s Claw': 'griffe d\'oni',
      'Rairin': 'cercle de foudre',
      'Shiromaru': 'Shiromaru',
      'Shishio': 'Shishiô',
      'Shishu White Baboon': 'babouin de Shishû',
      'Stone\'s Silence': 'Jardin des pierres silencieuses',
      'The Hall Of Becoming': 'Salle des trésors du Shôjôin',
      'The Hall Of Temptation': 'Vestibule doré',
      'The Pond Of Spring Rain': 'Bassin de la Pureté absolue',
      'Venomous Thrall': 'ilote venimeux',
      'Yozakura the Fleeting': 'Yozakura l\'élusive'
    },
    'replaceText': {
      'Art of the Fireblossom': 'Art floral de feu',
      'Art of the Fluff': 'Art molletonné',
      'Art of the Windblossom': 'Art floral de vent',
      'Azure Auspice': 'Auspice azuré',
      'Biwa Breaker': 'Biwa désaccordé',
      'Boundless Azure': 'Lueur azurée',
      'Boundless Scarlet': 'Lueur écarlate',
      'Bunshin': 'Bunshin',
      '(?<!Levin)Burst': 'Explosion',
      'Clearing Smoke': 'Fumée dissipante',
      'Clearout': 'Fauchage',
      'Donden-gaeshi': 'Donden-gaeshi',
      'Double Kasumi-giri': 'Kasumi-giri double',
      'Drifting Petals': 'Pétales faillissants',
      'Enkyo': 'Enkyô',
      'Explosion': 'Explosion',
      'Falling Rock': 'Chute de pierre',
      'Fighting Spirits': 'Esprits spiritueux',
      'Fire Spread': 'Nappe de feu',
      'Fireblossom Flare': 'Éruption en fleur',
      'Flagrant Combustion': 'Combustion incandescente',
      'Flame and Sulphur': 'Soufre enflammé',
      'Flickering Flame': 'Flamme vacillante',
      'Focused Tremor': 'Séisme localisé',
      'Ghastly Grasp': 'Étreinte funeste',
      'Glory Neverlasting': 'Gloire éphémère',
      'Haunting Cry': 'Cri de tourmente',
      'Humble Hammer': 'Marteau d\'humilité',
      'Iai-kasumi-giri': 'Iai-kasumi-giri',
      'Icebloom': 'Floraison de givre',
      'Impure Purgation': 'Purgation impure',
      'Into the Fire': 'Onde sanglante',
      'Iron Rain': 'Pluie de fer',
      'Kenki Release': 'Décharge Kenki',
      'Kiseru Clamor': 'Pipe sanglante',
      'Kuge Rantsui': 'Kuge Rantsui',
      'Left Swipe': 'Tranchage gauche',
      'Levinblossom Lance': 'Lumière en fleur',
      'Levinblossom Strike': 'Tonnerre en fleur',
      'Levinburst': 'Éclat de foudre',
      'Malformed Prayer': 'Prière difforme',
      'Moonless Night': 'Nuit noire',
      'Morphic Melody': 'Mélodie mutante',
      'Mud Pie': 'Boule de boue',
      'Mudrain': 'Lotus de boue',
      'Noble Pursuit': 'Noble ambition',
      'Nubuki': 'Nubuki',
      'Oka Ranman': 'Oka Ranman',
      'Once on Rokujo': 'Rokujô simple',
      'Out of the Smoke': 'Nuée de fumée',
      'Pipe Cleaner': 'Onde fumeuse',
      'Plectrum of Power': 'Plectre du pouvoir',
      'Pure Shock': 'Choc électrisant',
      'Reisho': 'Reishô',
      'Right Swipe': 'Tranchage droit',
      'Root Arrangement': 'Bouquet de racines',
      'Rousing Reincarnation': 'Réincarnation vibrante',
      'Rush': 'Ruée',
      'Scarlet Auspice': 'Auspice écarlate',
      'Seal of Riotous Bloom': 'Sceau de floraison vivace',
      'Seal of the Blossom': 'Sceau de floraison',
      'Seal of the Fleeting': 'Sceau des quatre saisons',
      'Seasons of the Fleeting': 'Quatre saisons',
      'Season of Element': 'Saison de l\'élément',
      'Self-destruct': 'Auto-destruction',
      'Shadowflight': 'Vol ombrageux',
      '(?<! )Shock': 'Décharge électrostatique',
      'Silent Whistle': 'Kuchiyose',
      'Smoke Rings': 'Ronds de fumée',
      'Smoke Stack': 'Signaux de fumée',
      'Smoke and Mirrors': 'Fumée sans feu',
      'Smokeater': 'Dévoreur de brouillard',
      'Smoldering(?! Damnation)': 'Combustion consumante',
      'Smoldering Damnation': 'Damnation consumante',
      'Snuff': 'Pipe écrasante',
      'Soldiers of Death': 'Guerriers de la mort',
      'Spearman\'s Orders': 'Ordre d\'attaque',
      'Spike of Flame': 'Explosion de feu',
      'Spiritflame': 'Flamme spirituelle',
      'Spiritspark': 'Étincelle spirituelle',
      'Splitting Cry': 'Cri d\'horreur',
      'Stormcloud Summons': 'Nuage d\'orage',
      'String Snap': 'Corde cassée',
      'Sulphuric Stone': 'Soufre rocheux',
      'Tatami Trap': 'Piège de paille',
      'Tatami-gaeshi': 'Tatami-gaeshi',
      'Tengu-yobi': 'Tengu-yobi',
      'Thunder Onefold': 'Éclair simple',
      'Thunder Threefold': 'Éclair triple',
      'Thunder Twofold': 'Éclair double',
      'Thunder Vortex': 'Spirale de foudre',
      'Thundercall': 'Drain fulminant',
      'Torching Torment': 'Brasier de tourments',
      'Unenlightenment': 'Sommeil spirituel',
      'Unsheathing': 'Défouraillage',
      'Untempered Sword': 'Lame impulsive',
      'Uplift': 'Exhaussement',
      'Upwell': 'Torrent violent',
      'Vasoconstrictor': 'Vasoconstricteur',
      'Veil Sever': 'Voile déchiré',
      'Wily Wall': 'Mur retors',
      'Windblossom Whirl': 'Pétales tournoyants',
      'Witherwind': 'Vent fanant',
      'Worldly Pursuit': 'Matérialisme',
      'Yama-kagura': 'Yama-kagura',
      'Yoki(?!-uzu)': 'Yôki',
      'Yoki-uzu': 'Yôki-uzu'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Ancient Katana': '古刀',
      'Ashigaru Kyuhei': '足軽弓兵',
      'Autumn Rivers\' End': '落葉川河畔',
      'Ball of Levin': '雷球',
      'Devilish Thrall': '惑わされた屍鬼',
      'Enenra': '煙々羅',
      'Feral Thrall': '惑わされた猛虎',
      'Gorai the Uncaged': '鉄鼠ゴウライ',
      'Haunting Thrall': '惑わされた屍霊',
      'Ill-come Tengu': '六根天狗',
      'Last Glimpse': '眼根の木間',
      'Mirrored Yozakura': 'ヨザクラの分身',
      'Moko the Restless': '怨霊モウコ',
      'Oni\'s Claw': '鬼腕',
      'Rairin': '雷輪',
      'Shiromaru': '忍犬シロマル',
      'Shishio': '獅子王',
      'Shishu White Baboon': 'シシュウ・ヒヒ',
      'Stone\'s Silence': '怪鳴石の磐座',
      'The Hall Of Becoming': '宝蔵の間',
      'The Hall Of Temptation': '金堂',
      'The Pond Of Spring Rain': '浄桜湖',
      'Venomous Thrall': '惑わされた大蛇',
      'Yozakura the Fleeting': '花遁のヨザクラ'
    },
    'replaceText': {
      'Art of the Fireblossom': '火花の術',
      'Art of the Fluff': 'もふもふの術',
      'Art of the Windblossom': '風花の術',
      'Azure Auspice': '青帝剣気',
      'Biwa Breaker': '琵琶誅撃',
      'Boundless Azure': '青帝空閃刃',
      'Boundless Scarlet': '赤帝空閃刃',
      'Bunshin': '分身の術',
      '(?<!Levin)Burst': '爆発',
      'Clearing Smoke': '衝撃煙管打ち',
      'Clearout': 'なぎ払い',
      'Donden-gaeshi': 'どんでん返しの術',
      'Double Kasumi-giri': '霞二段',
      'Drifting Petals': '落花流水の術',
      'Enkyo': '猿叫',
      'Explosion': '爆発',
      'Falling Rock': '落石',
      'Fighting Spirits': '般若湯',
      'Fire Spread': '放火',
      'Fireblossom Flare': '火花上騰の術',
      'Flagrant Combustion': '赤熱爆煙',
      'Flame and Sulphur': '岩火招来',
      'Flickering Flame': '怪火招来',
      'Focused Tremor': '局所地震',
      'Ghastly Grasp': '妖気刃',
      'Glory Neverlasting': '槿花一朝',
      'Haunting Cry': '不気味な鳴声',
      'Humble Hammer': '打ち出の小槌',
      'Iai-kasumi-giri': '居合霞斬り',
      'Icebloom': '氷花満開の術',
      'Impure Purgation': '炎流',
      'Into the Fire': '血煙重波撃',
      'Iron Rain': '矢の雨',
      'Kenki Release': '剣気解放',
      'Kiseru Clamor': '血煙重打撃',
      'Kuge Rantsui': '空花乱墜',
      'Left Swipe': '左爪薙ぎ払い',
      'Levinblossom Lance': '雷花閃光の術',
      'Levinblossom Strike': '雷花鳴響の術',
      'Levinburst': '発雷',
      'Malformed Prayer': '呪珠印',
      'Moonless Night': '闇夜斬り',
      'Morphic Melody': '変剋の旋律',
      'Mud Pie': '泥団子',
      'Mudrain': '泥中蓮花の術',
      'Noble Pursuit': '獅子王牙',
      'Nubuki': '芽吹きの術',
      'Oka Ranman': '桜花爛漫',
      'Once on Rokujo': '六条放雷：壱式',
      'Out of the Smoke': '雲煙飛動',
      'Pipe Cleaner': '重波撃',
      'Plectrum of Power': '強勢の旋律',
      'Pure Shock': '放雷衝',
      'Reisho': '霊障',
      'Right Swipe': '右爪薙ぎ払い',
      'Root Arrangement': '枯樹生花の術',
      'Rousing Reincarnation': '変現の呪い',
      'Rush': '突進',
      'Scarlet Auspice': '赤帝剣気',
      'Seal of Riotous Bloom': '花押印・乱咲',
      'Seal of the Fleeting': '花押印の術',
      'Seasons of the Fleeting': '四君子の術',
      'Self-destruct': '自爆',
      'Shadowflight': '影討ち',
      '(?<! )Shock': '放電',
      'Silent Whistle': '口寄せの術',
      'Smoke Rings': '円撃煙管打ち',
      'Smoke Stack': '集煙法',
      'Smoke and Mirrors': '分煙法',
      'Smokeater': '霞喰い',
      'Smoldering(?! Damnation)': '噴煙燃焼',
      'Smoldering Damnation': '噴煙地獄',
      'Snuff': '重打撃',
      'Soldiers of Death': '屍兵呼び',
      'Spearman\'s Orders': '突撃命令',
      'Spike of Flame': '爆炎',
      'Spiritflame': '怪火',
      'Spiritspark': '怪火呼び',
      'Splitting Cry': '霊鳴砲',
      'Stormcloud Summons': '雷雲生成',
      'String Snap': '鳴弦震動波',
      'Sulphuric Stone': '霊岩招来',
      'Tatami Trap': '罠仕込み',
      'Tatami-gaeshi': '畳返しの術',
      'Tengu-yobi': '天狗呼び',
      'Thunder Onefold': '落雷：壱式',
      'Thunder Threefold': '落雷：参式',
      'Thunder Twofold': '落雷：弐式',
      'Thunder Vortex': '輪転渦雷',
      'Thundercall': '招雷',
      'Torching Torment': '煩熱',
      'Unenlightenment': '煩悩熾盛',
      'Unsheathing': '妖刀具現',
      'Untempered Sword': '有構無構',
      'Uplift': '隆起',
      'Upwell': '水流',
      'Vasoconstrictor': '毒液噴射',
      'Veil Sever': '血地裂き',
      'Wily Wall': '法力障壁',
      'Windblossom Whirl': '風花旋回の術',
      'Witherwind': '風花落葉の術',
      'Worldly Pursuit': '跳鼠痛撃',
      'Yama-kagura': '山神楽',
      'Yoki(?!-uzu)': '妖気',
      'Yoki-uzu': '妖気渦'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ancient Katana': '古刀',
      'Ashigaru Kyuhei': '足轻弓兵',
      'Autumn Rivers\' End': '落叶川河畔',
      'Ball of Levin': '闪电球',
      'Devilish Thrall': '被迷惑的尸鬼',
      'Enenra': '烟烟罗',
      'Feral Thrall': '被迷惑的猛虎',
      'Gorai the Uncaged': '铁鼠豪雷',
      'Haunting Thrall': '被迷惑的尸灵',
      'Ill-come Tengu': '六根天狗',
      'Last Glimpse': '眼根树间地',
      'Mirrored Yozakura': '夜樱的分身',
      'Moko the Restless': '怨灵猛虎',
      'Oni\'s Claw': '鬼腕',
      'Rairin': '雷环',
      'Shiromaru': '忍犬白丸',
      'Shishio': '狮子王',
      'Shishu White Baboon': '紫州狒狒',
      'Stone\'s Silence': '怪鸣石磐座',
      'The Hall Of Becoming': '藏宝间',
      'The Hall Of Temptation': '金堂',
      'The Hall Of The Unseen': '眼根大堂',
      'The Pond Of Spring Rain': '净樱湖',
      'Venomous Thrall': '被迷惑的大蛇',
      'Yozakura the Fleeting': '花遁之夜樱'
    },
    'replaceText': {
      '\\(cast\\)': '(咏唱)',
      'Art of the Fireblossom': '火花之术',
      'Art of the Fluff': '茸茸之术',
      'Art of the Windblossom': '风花之术',
      'Azure Auspice': '青帝剑气',
      'Biwa Breaker': '琵琶诛击',
      'Boundless Azure': '青帝空闪刃',
      'Boundless Scarlet': '赤帝空闪刃',
      'Bunshin': '分身之术',
      '(?<!Levin)Burst': '爆炸',
      'Clearing Smoke': '烟管冲击',
      'Clearout': '横扫',
      'Donden-gaeshi': '翻转之术',
      'Double Kasumi-giri': '二段霞斩',
      'Drifting Petals': '落花流水之术',
      'Enkyo': '猿啼',
      'Explosion': '爆炸',
      'Falling Rock': '落石',
      'Fighting Spirits': '般若汤',
      'Fire Spread': '喷火',
      'Fireblossom Flare': '火花升腾之术',
      'Flagrant Combustion': '赤热爆烟',
      'Flame and Sulphur': '岩火招来',
      'Flickering Flame': '怪火招来',
      'Focused Tremor': '局部地震',
      'Ghastly Grasp': '妖气刃',
      'Glory Neverlasting': '槿花一日',
      'Haunting Cry': '诡异的叫声',
      'Humble Hammer': '万宝槌',
      'Iai-kasumi-giri': '居合霞斩',
      'Icebloom': '冰花满开之术',
      'Impure Purgation': '炎流',
      'Into the Fire': '血烟重波击',
      'Iron Rain': '钢铁箭雨',
      'Kenki Release': '剑气解放',
      'Kiseru Clamor': '血烟重打击',
      'Kuge Rantsui': '空花乱坠',
      'Left Swipe': '左爪横扫',
      'Levinblossom Lance': '雷花闪光之术',
      'Levinblossom Strike': '雷花鸣响之术',
      'Levinburst': '放雷',
      'Malformed Prayer': '咒珠印',
      'Moonless Night': '暗夜斩',
      'Morphic Melody': '变克的旋律',
      'Mud Pie': '泥球',
      'Mudrain': '泥中莲花之术',
      'Noble Pursuit': '狮子王牙',
      'Nubuki': '萌芽之术',
      'Oka Ranman': '樱花烂漫',
      'Once on Rokujo': '六条奔雷一式',
      'Out of the Smoke': '云烟飞动',
      'Pipe Cleaner': '重波击',
      'Plectrum of Power': '强势的旋律',
      'Pure Shock': '奔雷冲',
      'Reisho': '灵障',
      'Right Swipe': '右爪横扫',
      'Root Arrangement': '枯树生花之术',
      'Rousing Reincarnation': '变见的诅咒',
      'Rush': '突进',
      'Scarlet Auspice': '赤帝剑气',
      'Seal Marker': '花印标记',
      'Seal of Riotous Bloom': '花印齐放',
      'Seal of the Blossom': '花印开放',
      'Seal of the Fleeting': '花印之术',
      'Season Indicator': '四君子指示',
      'Season of Element': '四君子元素',
      'Seasons of the Fleeting': '四君子之术',
      'Self-destruct': '自爆',
      'Shadowflight': '影袭',
      '(?<! )Shock': '放电',
      'Silent Whistle': '通灵之术',
      'Smoke Rings': '烟管圆击',
      'Smoke Stack': '集烟法',
      'Smoke and Mirrors': '分烟法',
      'Smokeater': '噬霞',
      'Smoldering(?! Damnation)': '喷烟燃烧',
      'Smoldering Damnation': '喷烟地狱',
      'Snuff': '重打击',
      'Soldiers of Death': '召唤阴兵',
      'Spearman\'s Orders': '突击命令',
      'Spike of Flame': '爆炎柱',
      'Spiritflame': '怪火',
      'Spiritspark': '召唤怪火',
      'Splitting Cry': '灵鸣炮',
      'Stormcloud Summons': '生成雷暴云',
      'String Snap': '鸣弦震动波',
      'Sulphuric Stone': '灵岩招来',
      'Tatami Trap': '设置陷阱',
      'Tatami-gaeshi': '掀地板之术',
      'Tengu-yobi': '召唤天狗',
      'Thunder Onefold': '落雷一式',
      'Thunder Threefold': '落雷三式',
      'Thunder Twofold': '落雷二式',
      'Thunder Vortex': '回环涡雷',
      'Thundercall': '招雷',
      'Torching Torment': '烦热',
      'Unenlightenment': '烦恼炽盛',
      'Unsheathing': '妖刀具现',
      'Untempered Sword': '无势架势',
      'Uplift': '隆起',
      'Upwell': '水流',
      'Vasoconstrictor': '毒液喷射',
      'Veil Sever': '血地裂',
      'Wily Wall': '法力障壁',
      'Windblossom Whirl': '风花旋回之术',
      'Witherwind': '风花落叶之术',
      'Worldly Pursuit': '跳鼠痛击',
      'Yama-kagura': '山神乐',
      'Yoki(?!-uzu)': '妖气',
      'Yoki-uzu': '妖气涡'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ancient Katana': '오래된 칼',
      'Ashigaru Kyuhei': '하급 궁병',
      'Autumn Rivers\' End': '낙엽강 기슭',
      'Ball of Levin': '번개 구체',
      'Devilish Thrall': '현혹된 시체귀신',
      'Enenra': '엔엔라',
      'Feral Thrall': '현혹된 호랑이',
      'Gorai the Uncaged': '무쇠쥐 고우라이',
      'Haunting Thrall': '현혹된 사령',
      'Ill-come Tengu': '육근산 텐구',
      'Last Glimpse': '안근의 나무 사이',
      'Mirrored Yozakura': '요자쿠라의 분신',
      'Moko the Restless': '원령 모우코',
      'Oni\'s Claw': '악귀의 팔',
      'Rairin': '번개고리',
      'Shiromaru': '닌자개 시로마루',
      'Shishio': '사자왕',
      'Shishu White Baboon': '시슈 개코원숭이',
      'Stone\'s Silence': '괴성의 너러반석',
      'The Hall Of Becoming': '보물의 방',
      'The Hall Of Temptation': '금당',
      'The Hall Of The Unseen': '안근의 사당',
      'The Pond Of Spring Rain': '맑은벚꽃 호수',
      'Venomous Thrall': '현혹된 구렁이',
      'Yozakura the Fleeting': '벛꽃의 요자쿠라'
    },
    'replaceText': {
      '\\(cast\\)': '(시전)',
      'Art of the Fireblossom': '벚꽃 화둔술',
      'Art of the Fluff': '복슬복슬 인술',
      'Art of the Windblossom': '벚꽃 풍둔술',
      'Azure Auspice': '청제 검기',
      'Biwa Breaker': '비파 징벌격',
      'Boundless Azure': '청제 공섬도',
      'Boundless Scarlet': '적제 공섬도',
      'Bunshin': '분신',
      '(?<!Levin)Burst': '폭발',
      'Clearing Smoke': '방사형 곰방대 충돌',
      'Clearout': '휩쓸기',
      'Donden-gaeshi': '창호 회전술',
      'Double Kasumi-giri': '이단 안개베기',
      'Drifting Petals': '낙화유수술',
      'Enkyo': '원숭이 포효',
      'Explosion': '폭발',
      'Falling Rock': '낙석',
      'Fighting Spirits': '반야탕',
      'Fire Spread': '방화',
      'Fireblossom Flare': '치솟는 불꽃',
      'Flagrant Combustion': '붉은 폭연',
      'Flame and Sulphur': '바위불 소환',
      'Flickering Flame': '귀신불 소환',
      'Focused Tremor': '국소 지진',
      'Ghastly Grasp': '요기 칼날',
      'Glory Neverlasting': '근화일조',
      'Haunting Cry': '섬뜩한 괴성',
      'Humble Hammer': '요술 망치',
      'Iai-kasumi-giri': '거합 안개베기',
      'Icebloom': '활짝 피는 얼음꽃',
      'Impure Purgation': '염류',
      'Into the Fire': '핏빛 곰방대 털기',
      'Iron Rain': '화살비',
      'Kenki Release': '검기 해방',
      'Kiseru Clamor': '핏빛 곰방대 찍기',
      'Kuge Rantsui': '공화란추',
      'Left Swipe': '좌측 할퀴기',
      'Levinblossom Lance': '번쩍이는 번개꽃',
      'Levinblossom Strike': '내리치는 번개꽃',
      'Levinburst': '번개 발산',
      'Malformed Prayer': '염주 각인',
      'Moonless Night': '암야 베기',
      'Morphic Melody': '변형의 선율',
      'Mud Pie': '질퍽파이',
      'Mudrain': '진흙 속 연꽃',
      'Noble Pursuit': '사자왕의 송곳니',
      'Nubuki': '움트는 새싹',
      'Oka Ranman': '벚꽃 만개',
      'Once on Rokujo': '육조방뢰 1',
      'Out of the Smoke': '운연비동',
      'Pipe Cleaner': '곰방대 털기',
      'Plectrum of Power': '강세의 선율',
      'Pure Shock': '방뢰격',
      'Reisho': '영력장',
      'Right Swipe': '우측 할퀴기',
      'Root Arrangement': '피어나는 고목',
      'Rousing Reincarnation': '변신 저주',
      'Rush': '돌진',
      'Scarlet Auspice': '적제 검기',
      'Seal Marker': '꽃도장 속성 부여',
      'Seal of Riotous Bloom': '꽃도장 만개',
      'Seal of the Blossom': '꽃도장',
      'Seal of the Fleeting': '꽃도장 인술',
      'Season Indicator': '사군자 예고',
      'Season of Element': '사군자',
      'Seasons of the Fleeting': '사군자 인술',
      'Self-destruct': '자폭',
      'Shadowflight': '그림자 공격',
      '(?<! )Shock': '방전',
      'Silent Whistle': '소환술',
      'Smoke Rings': '원형 곰방대 충돌',
      'Smoke Stack': '연기 합체',
      'Smoke and Mirrors': '연기 분열',
      'Smokeater': '안개 흡입',
      'Smoldering(?! Damnation)': '연기 연소',
      'Smoldering Damnation': '연기 지옥',
      'Snuff': '곰방대 찍기',
      'Soldiers of Death': '시체병 부르기',
      'Spearman\'s Orders': '돌격 명령',
      'Spike of Flame': '폭염',
      'Spiritflame': '귀신불',
      'Spiritspark': '귀신불 부르기',
      'Splitting Cry': '영명포',
      'Stormcloud Summons': '번개구름 생성',
      'String Snap': '명현진동파',
      'Sulphuric Stone': '바위 소환',
      'Tatami Trap': '함정 설치',
      'Tatami-gaeshi': '장판 뒤집기',
      'Tengu-yobi': '텐구 부르기',
      'Thunder Onefold': '낙뢰 1',
      'Thunder Threefold': '낙뢰 3',
      'Thunder Twofold': '낙뢰 2',
      'Thunder Vortex': '외측 와뢰',
      'Thundercall': '초뢰',
      'Torching Torment': '번열',
      'Unenlightenment': '번뇌치성',
      'Unsheathing': '요도 구현',
      'Untempered Sword': '무초식',
      'Uplift': '융기',
      'Upwell': '물길',
      'Vasoconstrictor': '독액 분사',
      'Veil Sever': '핏빛 절단',
      'Wily Wall': '법력 장벽',
      'Windblossom Whirl': '휘도는 바람꽃',
      'Witherwind': '낙엽 바람꽃',
      'Worldly Pursuit': '쥐 도약격',
      'Yama-kagura': '산타령',
      'Yoki(?!-uzu)': '요기',
      'Yoki-uzu': '요기 소용돌이'
    }
  }]
};
/* harmony default export */ const mount_rokkon = (mount_rokkon_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/mount_rokkon.txt
const dungeon_mount_rokkon_namespaceObject = "### MOUNT ROKKON\r\n# ZoneId: 471\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#\r\n# Yozakura the Fleeting (left path) #\r\n#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 83A9:1011.6 837E:1365.9 838F:1663.8\r\n# -ii 838A 8391 8382\r\n\r\n# Last Glimpse will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10DC\" } window 10000,0\r\n1011.6 \"Glory Neverlasting\" Ability { id: \"83A9\", source: \"Yozakura the Fleeting\" }\r\n1021.6 \"Art of the Windblossom\" Ability { id: \"8369\", source: \"Yozakura the Fleeting\" }\r\n1030.7 \"Oka Ranman\" Ability { id: \"836E\", source: \"Yozakura the Fleeting\" }\r\n1035.8 \"--middle--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n1040.1 \"Seal of the Fleeting\" Ability { id: \"8379\", source: \"Yozakura the Fleeting\" }\r\n# TODO: is this always wind?\r\n#1040.3 \"Seal Marker 1\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#1042.3 \"Seal Marker 2\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n1049.5 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n1052.7 \"Seal of the Blossom\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n1059.7 \"--sync--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> rain path\r\n1060.9 \"--sync--\" StartsUsing { id: \"837E\", source: \"Yozakura the Fleeting\" } window 50,50 jump 1360.9\r\n1065.9 \"Bunshin?\" #Ability { id: \"837E\", source: \"Yozakura the Fleeting\" }\r\n\r\n# -> wind path\r\n1060.8 \"--sync--\" StartsUsing { id: \"838F\", source: \"Yozakura the Fleeting\" } window 50,50 jump 1660.8\r\n1070.1 \"Windblossom Whirl?\" #Ability { id: \"8390\", source: \"Yozakura the Fleeting\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Rain path\r\n1359.7 \"--sync--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n1360.9 \"--sync--\" StartsUsing { id: \"837E\", source: \"Yozakura the Fleeting\" }\r\n1365.9 \"Bunshin\" Ability { id: \"837E\", source: \"Yozakura the Fleeting\" }\r\n1375.0 \"Shadowflight (cast)\" Ability { id: \"837F\", source: \"Yozakura the Fleeting\" }\r\n1380.0 \"Shadowflight\" Ability { id: \"8380\", source: \"Mirrored Yozakura\" }\r\n1385.2 \"Art of the Fireblossom\" Ability { id: \"8368\", source: \"Yozakura the Fleeting\" }\r\n\r\n1394.3 \"Oka Ranman\" Ability { id: \"836E\", source: \"Yozakura the Fleeting\" }\r\n1399.4 \"--middle--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n1403.5 \"Seal of the Fleeting\" Ability { id: \"8379\", source: \"Yozakura the Fleeting\" }\r\n#1103.7 \"Seal Marker 1\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#1105.7 \"Seal Marker 2\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#1107.7 \"Seal Marker 3\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#1109.7 \"Seal Marker 4\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n1416.9 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n1420.1 \"Seal of the Blossom 1\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n1425.1 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n1428.1 \"Seal of the Blossom 2\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n1437.2 \"--sync--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n1443.4 \"Bunshin\" Ability { id: \"837E\", source: \"Yozakura the Fleeting\" }\r\n1451.5 \"Mudrain\" Ability { id: \"8389\", source: \"Yozakura the Fleeting\" }\r\n1456.7 \"--sync--\" Ability { id: \"838B\", source: \"Yozakura the Fleeting\" }\r\n1460.9 \"Icebloom 1\" #Ability { id: \"838C\", source: \"Yozakura the Fleeting\" }\r\n1462.9 \"Icebloom 2\" #Ability { id: \"838C\", source: \"Yozakura the Fleeting\" }\r\n1464.8 \"Mud Pie (cast)\" Ability { id: \"838D\", source: \"Yozakura the Fleeting\" }\r\n1464.9 \"Icebloom 3\" #Ability { id: \"838C\", source: \"Yozakura the Fleeting\" }\r\n1471.9 \"Mud Pie\" #Ability { id: \"838E\", source: \"Mud Bubble\" }\r\n1472.7 \"Shadowflight (cast)\" Ability { id: \"837F\", source: \"Yozakura the Fleeting\" }\r\n1477.7 \"Shadowflight\" Ability { id: \"8380\", source: \"Mirrored Yozakura\" }\r\n1484.9 \"Kuge Rantsui\" Ability { id: \"83AA\", source: \"Yozakura the Fleeting\" }\r\n1493.1 \"Glory Neverlasting\" Ability { id: \"83A9\", source: \"Yozakura the Fleeting\" }\r\n\r\n1503.3 \"Oka Ranman\" Ability { id: \"836E\", source: \"Yozakura the Fleeting\" } window 20,20 forcejump 1394.3\r\n\r\n\r\n# Wind path\r\n1659.7 \"--sync--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n1660.8 \"--sync--\" StartsUsing { id: \"838F\", source: \"Yozakura the Fleeting\" }\r\n1663.8 \"--sync--\" Ability { id: \"838F\", source: \"Yozakura the Fleeting\" }\r\n1670.1 \"Windblossom Whirl\" Ability { id: \"8390\", source: \"Yozakura the Fleeting\" }\r\n1670.1 \"Levinblossom Strike\" Ability { id: \"8392\", source: \"Yozakura the Fleeting\" }\r\n1675.2 \"Windblossom Whirl\" Ability { id: \"86F0\", source: \"Yozakura the Fleeting\" }\r\n1675.2 \"Levinblossom Strike\" Ability { id: \"8392\", source: \"Yozakura the Fleeting\" }\r\n1680.2 \"Windblossom Whirl\" Ability { id: \"86F0\", source: \"Yozakura the Fleeting\" }\r\n1680.2 \"Levinblossom Strike\" Ability { id: \"8392\", source: \"Yozakura the Fleeting\" }\r\n1685.2 \"Windblossom Whirl\" Ability { id: \"86F0\", source: \"Yozakura the Fleeting\" }\r\n1685.2 \"Levinblossom Strike\" Ability { id: \"8392\", source: \"Yozakura the Fleeting\" }\r\n1687.2 \"Drifting Petals\" Ability { id: \"8393\", source: \"Yozakura the Fleeting\" }\r\n1693.3 \"Windblossom Whirl\" Ability { id: \"8390\", source: \"Yozakura the Fleeting\" }\r\n1693.3 \"Levinblossom Strike\" Ability { id: \"8392\", source: \"Yozakura the Fleeting\" }\r\n1696.3 \"Art of the Fireblossom\" Ability { id: \"8368\", source: \"Yozakura the Fleeting\" }\r\n1705.4 \"Oka Ranman\" Ability { id: \"836E\", source: \"Yozakura the Fleeting\" }\r\n1710.5 \"--sync--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n1714.8 \"Seal of the Fleeting\" Ability { id: \"8379\", source: \"Yozakura the Fleeting\" }\r\n#1713.9 \"Seal Marker 1\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#1715.9 \"Seal Marker 2\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#1717.9 \"Seal Marker 3\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#1719.9 \"Seal Marker 4\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n1728.2 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n1731.4 \"Seal of the Blossom 1\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n1736.4 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n1739.4 \"Seal of the Blossom 2\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n\r\n1748.6 \"--sync--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n#1752.8 \"Season Indicator 1\" Ability { id: \"838[34]\", source: \"Yozakura the Fleeting\" }\r\n#1754.9 \"Season Indicator 2\" Ability { id: \"838[34]\", source: \"Yozakura the Fleeting\" }\r\n#1757.0 \"Season Indicator 3\" Ability { id: \"838[34]\", source: \"Yozakura the Fleeting\" }\r\n#1759.1 \"Season Indicator 4\" Ability { id: \"838[34]\", source: \"Yozakura the Fleeting\" }\r\n1759.5 \"Seasons of the Fleeting\" Ability { id: \"8381\", source: \"Yozakura the Fleeting\" }\r\n1760.4 \"Season of Element 1\" #Ability { id: \"838[5678]\", source: \"Yozakura the Fleeting\" }\r\n1762.5 \"Season of Element 2\" #Ability { id: \"838[5678]\", source: \"Yozakura the Fleeting\" }\r\n1764.6 \"Season of Element 3\" #Ability { id: \"838[5678]\", source: \"Yozakura the Fleeting\" }\r\n1766.7 \"Season of Element 4\" #Ability { id: \"838[5678]\", source: \"Yozakura the Fleeting\" }\r\n1776.0 \"Kuge Rantsui\" Ability { id: \"83AA\", source: \"Yozakura the Fleeting\" }\r\n1784.2 \"Glory Neverlasting\" Ability { id: \"83A9\", source: \"Yozakura the Fleeting\" }\r\n\r\n1789.3 \"--sync--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n1790.5 \"--sync--\" StartsUsing { id: \"838F\", source: \"Yozakura the Fleeting\" }\r\n1793.5 \"--sync--\" Ability { id: \"838F\", source: \"Yozakura the Fleeting\" } window 30,30 forcejump 1663.8\r\n\r\n# YOZAKURA ABILITIES (ALL PATHS)\r\n# 1961 attack\r\n# 8368 Art of the Fireblossom circle cast and damage\r\n# 8369 Art of the Windblossom donut cast and damage\r\n# 836E Oka Ranman self-targeted cast and ability for various Seal\r\n# 8374 Seal of Riotous Bloom self-targeted cast and ability during Oka Ranman\r\n# 8375 Seal of the Fireblossom circle damage\r\n# 8376 Seal of the Windblossom donut damage\r\n# 8377 Seal of the Rainblossom intercard damage\r\n# 8378 Seal of the Levinblossom card damage\r\n# 8379 Seal of the Fleeting self-targetd ability\r\n# 837A Seal of the Fireblossom fire marker\r\n# 837B Seal of the Windblossom wind marker\r\n# 837C Seal of the Levinblossom thunder marker\r\n# 837D Seal of the Rainblossom rain marker\r\n# 83A9 Glory Neverlasting cast and damage tankbuster\r\n# 83AA Kuge Rantsui cast and damage aoe\r\n# 8612 --sync-- repositioning\r\n\r\n# YOZAKURA ABILITIES (LEFT AND RIGHT PATH)\r\n# 837E Bunshin self-targeted cast and ability to summon clone\r\n# 837F Shadowflight self-targeted cast and ability\r\n# 8380 Shadowflight clone backstab damage\r\n# 8381 Seasons of the Fleeting cast and self-targeted ability\r\n# 8382 Seasons of the Fleeting self-targeted ability used between Seasons\r\n# 8383 --sync-- line indicator\r\n# 8384 --sync-- pinwheel indicator\r\n# 8385 Season of Fire 4x lines (back safe)\r\n# 8386 Season of Water 4x lines (front safe)\r\n# 8387 Season of Lightning intercardinal pinwheel\r\n# 8388 Season of Earth cardinal pinwheel\r\n# 8389 Mudrain self-targeted cast and ability\r\n# 838A Mudrain cast and damage for initial circles\r\n# 8393 Drifting Petals cast and knockback damage\r\n\r\n# YOZAKURA ABILITIES (LEFT PATH)\r\n# 838F Windblossom Whirl cast and self-targeted\r\n# 8390 Windblossom Whirl cast and damage for donut\r\n# 8391 Levinblossom Strike cast and self-targeted\r\n# 8392 Levinblossom Strike cast and damage for lightning circles\r\n# 838B Icebloom self-targeted cast and ability\r\n# 838C Icebloom cast and damage for three chasing circles\r\n# 838D Mud Pie self-targeted cast and ability\r\n# 838E Mud Pie cast and damage for mud line aoes\r\n# 86F0 Windblossom Whirl ongoing donut damage for repeated donuts\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~#\r\n# Moko the Restless #\r\n#~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 85AD:2011.9\r\n# -ii 8597 86D2 878A 85A0 859A 859E 871C 85A4 85A7\r\n\r\n# Hall of the Unseen will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10DF\" } window 10000,0\r\n2011.9 \"Kenki Release\" Ability { id: \"85AD\", source: \"Moko the Restless\" }\r\n2022.1 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2028.5 \"Iai-kasumi-giri\" Ability { id: \"8587\", source: \"Moko the Restless\" }\r\n2035.6 \"Iai-kasumi-giri\" Ability { id: \"858[98A]\", source: \"Moko the Restless\" }\r\n2048.7 \"Iai-kasumi-giri\" Ability { id: \"858[98A]\", source: \"Moko the Restless\" }\r\n2056.8 \"Soldiers of Death\" Ability { id: \"8593\", source: \"Moko the Restless\" }\r\n2071.8 \"Iron Rain\" Ability { id: \"8594\", source: \"Ashigaru Kyuhei\" }\r\n2074.9 \"Soldiers of Death\" Ability { id: \"8593\", source: \"Moko the Restless\" }\r\n2083.6 \"Spearman's Orders\" Ability { id: \"8595\", source: \"Moko the Restless\" }\r\n2083.6 \"--sync--\" Ability { id: \"8596\", source: \"Moko the Restless\" }\r\n2095.7 \"--sync--\" Ability { id: \"8596\", source: \"Moko the Restless\" }\r\n2103.1 \"Soldiers of Death\" Ability { id: \"8593\", source: \"Moko the Restless\" }\r\n2118.1 \"Iron Rain\" Ability { id: \"8594\", source: \"Ashigaru Kyuhei\" }\r\n2124.2 \"Kenki Release\" Ability { id: \"85AD\", source: \"Moko the Restless\" }\r\n2131.4 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2143.5 \"Double Kasumi-giri 1\" Ability { id: \"858[BCDE]\", source: \"Moko the Restless\" }\r\n2147.1 \"Double Kasumi-giri 2\" Ability { id: [\"858F\", \"859[012]\"], source: \"Moko the Restless\" }\r\n2160.2 \"Double Kasumi-giri 1\" Ability { id: \"858[BCDE]\", source: \"Moko the Restless\" }\r\n2163.8 \"Double Kasumi-giri 2\" Ability { id: [\"858F\", \"859[012]\"], source: \"Moko the Restless\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# => path 01\r\n2169.0 \"--sync--\" StartsUsing { id: \"85A8\", source: \"Moko the Restless\" } window 50,50 jump 2269\r\n2172.0 \"Untempered Sword?\" #Ability { id: \"85A8\", source: \"Moko the Restless\" }\r\n\r\n# => path 02\r\n2170.5 \"--sync--\" StartsUsing { id: \"85AB\", source: \"Moko the Restless\" } window 50,50 jump 2570.5\r\n2173.5 \"Moonless Night?\" #Ability { id: \"85AB\", source: \"Moko the Restless\" }\r\n\r\n# => path 03\r\n2169.0 \"--sync--\" StartsUsing { id: \"85A1\", source: \"Moko the Restless\" } window 50,50 jump 2869\r\n2172.0 \"Tengu-yobi?\" #Ability { id: \"85A1\", source: \"Moko the Restless\" }\r\n\r\n# => path 04\r\n2169.0 \"--sync--\" StartsUsing { id: \"85A5\", source: \"Moko the Restless\" } window 50,50 jump 3169\r\n2172.0 \"Spiritspark?\" #Ability { id: \"85A5\", source: \"Moko the Restless\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# path 01\r\n2231.4 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2243.5 \"Double Kasumi-giri 1\" Ability { id: \"858[BCDE]\", source: \"Moko the Restless\" }\r\n2247.1 \"Double Kasumi-giri 2\" Ability { id: [\"858F\", \"859[012]\"], source: \"Moko the Restless\" }\r\n2260.2 \"Double Kasumi-giri 1\" Ability { id: \"858[BCDE]\", source: \"Moko the Restless\" }\r\n2263.8 \"Double Kasumi-giri 2\" Ability { id: [\"858F\", \"859[012]\"], source: \"Moko the Restless\" }\r\n\r\n2269.0 \"--sync--\" StartsUsing { id: \"85A8\", source: \"Moko the Restless\" }\r\n2272.0 \"Untempered Sword\" Ability { id: \"85A8\", source: \"Moko the Restless\" }\r\n2276.0 \"Unsheathing 1\" Ability { id: \"85A9\", source: \"Ancient Katana\" }\r\n2280.0 \"Unsheathing 2\" Ability { id: \"85A9\", source: \"Ancient Katana\" }\r\n2282.2 \"Veil Sever 1\" Ability { id: \"85AA\", source: \"Ancient Katana\" }\r\n2284.1 \"Unsheathing 3\" Ability { id: \"85A9\", source: \"Ancient Katana\" }\r\n2286.3 \"Veil Sever 2\" Ability { id: \"85AA\", source: \"Ancient Katana\" }\r\n2288.2 \"Unsheathing 4\" Ability { id: \"85A9\", source: \"Ancient Katana\" }\r\n2290.4 \"Veil Sever 3\" Ability { id: \"85AA\", source: \"Ancient Katana\" }\r\n2294.4 \"Veil Sever 4\" Ability { id: \"85AA\", source: \"Ancient Katana\" }\r\n\r\n2298.1 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2304.4 \"Iai-kasumi-giri\" Ability { id: \"858[789A]\", source: \"Moko the Restless\" }\r\n2311.5 \"Kenki Release\" Ability { id: \"85AD\", source: \"Moko the Restless\" }\r\n\r\n2317.7 \"--sync--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2324.1 \"Azure Auspice\" Ability { id: \"859C\", source: \"Moko the Restless\" }\r\n2329.7 \"Boundless Azure\" Ability { id: \"859D\", source: \"Moko the Restless\" }\r\n2342.4 \"Upwell 1\" Ability { id: \"859F\", source: \"Moko the Restless\" } duration 10\r\n2348.3 \"Upwell 2\" Ability { id: \"859F\", source: \"Moko the Restless\" } duration 10\r\n2356.3 \"Upwell 3\" Ability { id: \"859F\", source: \"Moko the Restless\" } duration 10\r\n2366.7 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2378.8 \"Double Kasumi-giri 1\" Ability { id: \"858[BCDE]\", source: \"Moko the Restless\" }\r\n2382.4 \"Double Kasumi-giri 2\" Ability { id: [\"858F\", \"859[012]\"], source: \"Moko the Restless\" }\r\n2389.5 \"Kenki Release\" Ability { id: \"85AD\", source: \"Moko the Restless\" }\r\n2398.6 \"Soldiers of Death\" Ability { id: \"8593\", source: \"Moko the Restless\" }\r\n2407.3 \"Spearman's Orders\" Ability { id: \"8595\", source: \"Moko the Restless\" }\r\n2407.3 \"--sync--\" Ability { id: \"8596\", source: \"Moko the Restless\" }\r\n2418.8 \"--sync--\" Ability { id: \"8596\", source: \"Moko the Restless\" }\r\n2426.2 \"Soldiers of Death\" Ability { id: \"8593\", source: \"Moko the Restless\" }\r\n2441.2 \"Iron Rain\" Ability { id: \"8594\", source: \"Ashigaru Kyuhei\" }\r\n\r\n2448.4 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" } window 30,30 forcejump 2231.4\r\n\r\n\r\n# path 02\r\n2531.4 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2543.5 \"Double Kasumi-giri 1\" Ability { id: \"858[BCDE]\", source: \"Moko the Restless\" }\r\n2547.1 \"Double Kasumi-giri 2\" Ability { id: [\"858F\", \"859[012]\"], source: \"Moko the Restless\" }\r\n2560.2 \"Double Kasumi-giri 1\" Ability { id: \"858[BCDE]\", source: \"Moko the Restless\" }\r\n2563.8 \"Double Kasumi-giri 2\" Ability { id: [\"858F\", \"859[012]\"], source: \"Moko the Restless\" }\r\n\r\n2569.1 \"--sync--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2570.5 \"--sync--\" StartsUsing { id: \"85AB\", source: \"Moko the Restless\" }\r\n2573.5 \"Moonless Night\" Ability { id: \"85AB\", source: \"Moko the Restless\" }\r\n2581.7 \"Clearout 1\" Ability { id: \"85AC\", source: \"Oni's Claw\" }\r\n2590.9 \"Clearout 2\" Ability { id: \"85AC\", source: \"Oni's Claw\" }\r\n\r\n2595.7 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2601.9 \"Iai-kasumi-giri\" Ability { id: \"858[789A]\", source: \"Moko the Restless\" }\r\n2609.0 \"Kenki Release\" Ability { id: \"85AD\", source: \"Moko the Restless\" }\r\n\r\n2615.2 \"--sync--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2621.6 \"Scarlet Auspice\" Ability { id: \"8598\", source: \"Moko the Restless\" }\r\n2627.2 \"Boundless Scarlet\" Ability { id: \"8599\", source: \"Moko the Restless\" }\r\n2641.9 \"Explosion 1\" Ability { id: \"859B\", source: \"Moko the Restless\" }\r\n2646.9 \"Explosion 2\" Ability { id: \"859B\", source: \"Moko the Restless\" }\r\n2651.9 \"Explosion 3\" Ability { id: \"859B\", source: \"Moko the Restless\" }\r\n2652.3 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2664.5 \"Double Kasumi-giri 1\" Ability { id: \"858[BCDE]\", source: \"Moko the Restless\" }\r\n2668.1 \"Double Kasumi-giri 2\" Ability { id: [\"858F\", \"859[012]\"], source: \"Moko the Restless\" }\r\n2675.2 \"Kenki Release\" Ability { id: \"85AD\", source: \"Moko the Restless\" }\r\n2684.3 \"Soldiers of Death\" Ability { id: \"8593\", source: \"Moko the Restless\" }\r\n2693.0 \"Spearman's Orders\" Ability { id: \"8595\", source: \"Moko the Restless\" }\r\n2693.0 \"--sync--\" Ability { id: \"8596\", source: \"Moko the Restless\" }\r\n2704.7 \"--sync--\" Ability { id: \"8596\", source: \"Moko the Restless\" }\r\n2712.3 \"Soldiers of Death\" Ability { id: \"8593\", source: \"Moko the Restless\" }\r\n2727.3 \"Iron Rain\" Ability { id: \"8594\", source: \"Ashigaru Kyuhei\" }\r\n\r\n2734.5 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" } window 30,30 forcejump 2531.4\r\n\r\n\r\n# path 03\r\n2831.4 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2843.5 \"Double Kasumi-giri 1\" Ability { id: \"858[BCDE]\", source: \"Moko the Restless\" }\r\n2847.1 \"Double Kasumi-giri 2\" Ability { id: [\"858F\", \"859[012]\"], source: \"Moko the Restless\" }\r\n2860.2 \"Double Kasumi-giri 1\" Ability { id: \"858[BCDE]\", source: \"Moko the Restless\" }\r\n2863.8 \"Double Kasumi-giri 2\" Ability { id: [\"858F\", \"859[012]\"], source: \"Moko the Restless\" }\r\n\r\n2869.0 \"--sync--\" StartsUsing { id: \"85A1\", source: \"Moko the Restless\" }\r\n2872.0 \"Tengu-yobi\" Ability { id: \"85A1\", source: \"Moko the Restless\" }\r\n2884.0 \"Yama-kagura\" Ability { id: \"85A2\", source: \"Ill-come Tengu\" }\r\n\r\n2889.1 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2895.4 \"Iai-kasumi-giri\" Ability { id: \"858[789A]\", source: \"Moko the Restless\" }\r\n\r\n2908.6 \"Yama-kagura\" Ability { id: \"85A2\", source: \"Ill-come Tengu\" }\r\n2910.6 \"Ghastly Grasp\" Ability { id: \"85A3\", source: \"Moko the Restless\" }\r\n2918.6 \"Kenki Release\" Ability { id: \"85AD\", source: \"Moko the Restless\" }\r\n2924.7 \"--sync--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2931.1 \"Azure Auspice\" Ability { id: \"859C\", source: \"Moko the Restless\" }\r\n2936.7 \"Boundless Azure\" Ability { id: \"859D\", source: \"Moko the Restless\" }\r\n2949.4 \"Upwell 1\" Ability { id: \"859F\", source: \"Moko the Restless\" } duration 10\r\n2955.4 \"Upwell 2\" Ability { id: \"859F\", source: \"Moko the Restless\" } duration 10\r\n2963.4 \"Upwell 3\" Ability { id: \"859F\", source: \"Moko the Restless\" } duration 10\r\n\r\n2973.8 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n2985.9 \"Double Kasumi-giri 1\" Ability { id: \"858[BCDE]\", source: \"Moko the Restless\" }\r\n2989.5 \"Double Kasumi-giri 2\" Ability { id: [\"858F\", \"859[012]\"], source: \"Moko the Restless\" }\r\n2996.6 \"Kenki Release\" Ability { id: \"85AD\", source: \"Moko the Restless\" }\r\n\r\n3005.7 \"Soldiers of Death\" Ability { id: \"8593\", source: \"Moko the Restless\" }\r\n3014.3 \"Spearman's Orders\" Ability { id: \"8595\", source: \"Moko the Restless\" }\r\n3014.3 \"--sync--\" Ability { id: \"8596\", source: \"Moko the Restless\" }\r\n3026.0 \"--sync--\" Ability { id: \"8596\", source: \"Moko the Restless\" }\r\n3033.4 \"Soldiers of Death\" Ability { id: \"8593\", source: \"Moko the Restless\" }\r\n3048.4 \"Iron Rain\" Ability { id: \"8594\", source: \"Ashigaru Kyuhei\" }\r\n\r\n3055.6 \"--sync--\" Ability { id: \"85AF\", source: \"Moko the Restless\" } window 30,30 forcejump 2831.4\r\n\r\n\r\n# path 04\r\n3131.4 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3143.5 \"Double Kasumi-giri 1\" Ability { id: \"858[BCDE]\", source: \"Moko the Restless\" }\r\n3147.1 \"Double Kasumi-giri 2\" Ability { id: [\"858F\", \"859[012]\"], source: \"Moko the Restless\" }\r\n3160.2 \"Double Kasumi-giri 1\" Ability { id: \"858[BCDE]\", source: \"Moko the Restless\" }\r\n3163.8 \"Double Kasumi-giri 2\" Ability { id: [\"858F\", \"859[012]\"], source: \"Moko the Restless\" }\r\n\r\n3169.0 \"--sync--\" StartsUsing { id: \"85A5\", source: \"Moko the Restless\" }\r\n3172.0 \"Spiritspark\" Ability { id: \"85A5\", source: \"Moko the Restless\" }\r\n3177.0 \"Spiritflame 1\" Ability { id: \"85A6\", source: \"Moko the Restless\" }\r\n3182.8 \"Spiritflame 2\" Ability { id: \"85A6\", source: \"Moko the Restless\" }\r\n3188.6 \"Spiritflame 3\" Ability { id: \"85A6\", source: \"Moko the Restless\" }\r\n3194.3 \"Spiritflame 4\" Ability { id: \"85A6\", source: \"Moko the Restless\" }\r\n\r\n3205.1 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3211.4 \"Iai-kasumi-giri\" Ability { id: \"858[789A]\", source: \"Moko the Restless\" }\r\n3218.5 \"Kenki Release\" Ability { id: \"85AD\", source: \"Moko the Restless\" }\r\n\r\n3224.7 \"--sync--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3230.9 \"Scarlet Auspice\" Ability { id: \"8598\", source: \"Moko the Restless\" }\r\n3236.5 \"Boundless Scarlet\" Ability { id: \"8599\", source: \"Moko the Restless\" }\r\n3251.3 \"Explosion 1\" Ability { id: \"859B\", source: \"Moko the Restless\" }\r\n3256.3 \"Explosion 2\" Ability { id: \"859B\", source: \"Moko the Restless\" }\r\n3261.3 \"Explosion 3\" Ability { id: \"859B\", source: \"Moko the Restless\" }\r\n\r\n3261.7 \"--middle--\" Ability { id: \"85AF\", source: \"Moko the Restless\" }\r\n3273.9 \"Double Kasumi-giri 1\" Ability { id: \"858[BCDE]\", source: \"Moko the Restless\" }\r\n3277.5 \"Double Kasumi-giri 2\" Ability { id: [\"858F\", \"859[012]\"], source: \"Moko the Restless\" }\r\n3284.6 \"Kenki Release\" Ability { id: \"85AD\", source: \"Moko the Restless\" }\r\n3293.7 \"Soldiers of Death\" Ability { id: \"8593\", source: \"Moko the Restless\" }\r\n3302.4 \"Spearman's Orders\" Ability { id: \"8595\", source: \"Moko the Restless\" }\r\n3302.4 \"--sync--\" Ability { id: \"8596\", source: \"Moko the Restless\" }\r\n3314.1 \"--sync--\" Ability { id: \"8596\", source: \"Moko the Restless\" }\r\n3321.7 \"Soldiers of Death\" Ability { id: \"8593\", source: \"Moko the Restless\" }\r\n3336.7 \"Iron Rain\" Ability { id: \"8594\", source: \"Ashigaru Kyuhei\" }\r\n\r\n3343.9 \"--sync--\" Ability { id: \"85AF\", source: \"Moko the Restless\" } window 30,30 forcejump 3131.4\r\n\r\n\r\n# MOKO ABILITIES\r\n# 8587 Iai-kasumi-giri cast and damage for back-safe attack\r\n# 8588 Iai-kasumi-giri cast and damage for front-safe attack\r\n# 8589 Iai-kasumi-giri cast and damage for left-safe attack\r\n# 858A Iai-kasumi-giri cast and damage for right-safe attack\r\n# 858B Double Kasumi-giri long cast and damage for back-safe attack 1\r\n# 858C Double Kasumi-giri long cast and damage for left-safe attack 1\r\n# 858D Double Kasumi-giri long cast and damage for front-safe attack 1\r\n# 858E Double Kasumi-giri long cast and damage for right-safe attack 1\r\n# 858F Double Kasumi-giri short cast and damage for back-safe attack 2\r\n# 8590 Double Kasumi-giri short cast and damage for left-safe attack 2\r\n# 8591 Double Kasumi-giri short cast and damage for front-safe attack 2\r\n# 8592 Double Kasumi-giri short cast and damage for right-safe attack 2\r\n# 8593 Soldiers of Death cast and ability before Iron Rain\r\n# 8594 Iron Rain cast and damage for Soldiers of Death bombardment\r\n# 8595 Spearman's Orders cast and ability before Spearpoint Push\r\n# 8596 --sync-- unknown abilty during Spearman's Orders\r\n# 8597 Spearpoint Push initial damage from Spearman's Orders\r\n# 8598 Scarlet Auspice cast and circle damage\r\n# 8599 Boundless Scarlet cast and self-targeted ability\r\n# 859A Boundless Scarlet cast and damage for initial Z lines\r\n# 859B Explosion cast and damage from expanding lines\r\n# 85A2 Yama-kagua cast and knockback damage from Ill-come Tengu adds\r\n# 85A3 Ghastly Grasp cast and self-targeted\r\n# 85A4 Ghastly Grasp damage from ground aoes during Tengu pushback\r\n# 85AB Moonless Night cast and self-targeted summoning of Oni's Claw\r\n# 85AC Clearout cast and large circle damage from Oni's Claw\r\n# 895B Explosion cast and damage for exploding fire lines\r\n# 859C Azure Auspice cast and donut damage before Boundless Azure\r\n# 859D Boundless Azure cast and self-targeted ability\r\n# 859E Boundless Azure cast and damage for initial Z lines\r\n# 859F Upwell cast and initial damage for expanding water lines\r\n# 85A0 Upwell ongoing damage for expanding water lines\r\n# 85A1 Tengu-yobi cast and self-targeted summon of Ill-come Tengu\r\n# 85A2 Yama-kagura cast and damage for knockback lines\r\n# 85A5 Spiritspark cast and self-targeted ability\r\n# 85A6 Spiritflame cast and damage for ground circles\r\n# 85A7 Arm of Purgatory damage for running into summoned heads during Spiritspark\r\n# 85A8 Untempered Sword cast and ability before Unsheathing / Veil Sever\r\n# 85A9 Unsheathing cast and damage of initial sword circles\r\n# 85AA Veil Sever cast and damage of sword lines\r\n# 85AD Kenki Release cast and raidwide damage\r\n# 85AF --sync-- repositioning\r\n# 86D2 Spearpoint Push ongoing damage from Spearman's Orders\r\n# 871C --sync-- unknown ability during Spearman's Orders\r\n# 878A --sync-- auto damage\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#\r\n# Yozakura the Fleeting (middle path) #\r\n#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 83A9:4011.6\r\n# -ii 8396 8399 839A 839D 839F\r\n\r\n# Hall of Temptation will be sealed off\r\n4000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10DD\" } window 10000,0\r\n4011.6 \"Glory Neverlasting\" Ability { id: \"83A9\", source: \"Yozakura the Fleeting\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> door\r\n4016.7 \"--sync--\" StartsUsing { id: \"8394\", source: \"Yozakura the Fleeting\" } window 20,20 jump 4116.7\r\n4019.7 \"Tatami Trap?\" #Ability { id: \"8394\", source: \"Yozakura the Fleeting\" }\r\n\r\n# -> rope\r\n4015.7 \"--sync--\" StartsUsing { id: \"8369\", source: \"Yozakura the Fleeting\" } window 20,20 jump 4315.7\r\n4020.7 \"Art of the Windblossom?\" #Ability { id: \"8369\", source: \"Yozakura the Fleeting\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# door\r\n4116.7 \"--sync--\" StartsUsing { id: \"8394\", source: \"Yozakura the Fleeting\" }\r\n4119.7 \"Tatami Trap\" Ability { id: \"8394\", source: \"Yozakura the Fleeting\" }\r\n4129.8 \"Kuge Rantsui\" Ability { id: \"83AA\", source: \"Yozakura the Fleeting\" }\r\n4135.9 \"Tatami-gaeshi\" Ability { id: \"8395\", source: \"Yozakura the Fleeting\" }\r\n4146.2 \"Art of the Windblossom\" Ability { id: \"8369\", source: \"Yozakura the Fleeting\" }\r\n\r\n4155.3 \"Oka Ranman\" Ability { id: \"836E\", source: \"Yozakura the Fleeting\" }\r\n4160.4 \"--middle--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n4164.5 \"Seal of the Fleeting\" Ability { id: \"8379\", source: \"Yozakura the Fleeting\" }\r\n#4164.7 \"Seal Marker 1\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#4166.7 \"Seal Marker 2\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n4173.9 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n4176.9 \"Seal of the Blossom\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n\r\n4184.0 \"--middle--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n4188.2 \"Tatami Trap\" Ability { id: \"8394\", source: \"Yozakura the Fleeting\" }\r\n4195.4 \"Levinblossom Lance 1\" Ability { id: \"839[78]\", source: \"Yozakura the Fleeting\" } duration 5\r\n4207.7 \"Levinblossom Lance 2\" Ability { id: \"839[78]\", source: \"Yozakura the Fleeting\" } duration 5\r\n4217.7 \"Tatami-gaeshi\" Ability { id: \"8395\", source: \"Yozakura the Fleeting\" }\r\n\r\n4224.9 \"Art of the Fireblossom\" Ability { id: \"8368\", source: \"Yozakura the Fleeting\" }\r\n4234.0 \"Oka Ranman\" Ability { id: \"836E\", source: \"Yozakura the Fleeting\" }\r\n4239.1 \"--middle--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n4243.2 \"Seal of the Fleeting\" Ability { id: \"8379\", source: \"Yozakura the Fleeting\" }\r\n#4243.2 \"Seal Marker 1\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#4245.2 \"Seal Marker 2\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#4247.2 \"Seal Marker 3\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#4249.2 \"Seal Marker 4\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n4256.8 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n4259.9 \"Seal of the Blossom 1\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n4264.9 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n4267.9 \"Seal of the Blossom 2\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n4280.9 \"Kuge Rantsui\" Ability { id: \"83AA\", source: \"Yozakura the Fleeting\" }\r\n4289.1 \"Glory Neverlasting\" Ability { id: \"83A9\", source: \"Yozakura the Fleeting\" }\r\n\r\n4293.2 \"--middle--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n4297.3 \"Tatami Trap\" Ability { id: \"8394\", source: \"Yozakura the Fleeting\" } window 30,30 forcejump 4188.2\r\n\r\n\r\n# rope\r\n4315.7 \"--sync--\" StartsUsing { id: \"8369\", source: \"Yozakura the Fleeting\" }\r\n4320.7 \"Art of the Windblossom\" Ability { id: \"8369\", source: \"Yozakura the Fleeting\" }\r\n4329.8 \"Oka Ranman\" Ability { id: \"836E\", source: \"Yozakura the Fleeting\" }\r\n\r\n4334.9 \"--middle--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n4339.1 \"Seal of the Fleeting\" Ability { id: \"8379\", source: \"Yozakura the Fleeting\" }\r\n#4039.3 \"Seal Marker 1\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#4041.3 \"Seal Marker 2\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n4348.6 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n4351.8 \"Seal of the Blossom\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n\r\n4358.8 \"--north--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n4363.1 \"Silent Whistle\" Ability { id: \"839B\", source: \"Yozakura the Fleeting\" }\r\n4373.2 \"Donden-gaeshi\" Ability { id: \"839C\", source: \"Yozakura the Fleeting\" }\r\n4384.5 \"Art of the Fluff\" Ability { id: \"839E\", source: \"Shiromaru\" }\r\n4386.5 \"Fireblossom Flare\" Ability { id: \"83A0\", source: \"Yozakura the Fleeting\" }\r\n4391.6 \"Fireblossom Flare\" Ability { id: \"83A0\", source: \"Yozakura the Fleeting\" }\r\n4393.5 \"Donden-gaeshi\" Ability { id: \"839C\", source: \"Yozakura the Fleeting\" }\r\n4404.8 \"Art of the Fluff\" Ability { id: \"839E\", source: \"Shiromaru\" }\r\n4406.8 \"Fireblossom Flare\" Ability { id: \"83A0\", source: \"Yozakura the Fleeting\" }\r\n4411.9 \"Fireblossom Flare\" Ability { id: \"83A0\", source: \"Yozakura the Fleeting\" }\r\n4417.8 \"Art of the Fireblossom\" Ability { id: \"8368\", source: \"Yozakura the Fleeting\" }\r\n\r\n4427.0 \"Oka Ranman\" Ability { id: \"836E\", source: \"Yozakura the Fleeting\" }\r\n4432.1 \"--middle--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n4436.4 \"Seal of the Fleeting\" Ability { id: \"8379\", source: \"Yozakura the Fleeting\" }\r\n#4436.6 \"Seal Marker 1\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#4438.6 \"Seal Marker 2\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#4440.6 \"Seal Marker 3\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#4442.6 \"Seal Marker 4\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n4450.1 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n4453.2 \"Seal of the Blossom 1\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n4458.2 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n4461.4 \"Seal of the Blossom 2\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n4474.3 \"Kuge Rantsui\" Ability { id: \"83AA\", source: \"Yozakura the Fleeting\" }\r\n4482.5 \"Glory Neverlasting\" Ability { id: \"83A9\", source: \"Yozakura the Fleeting\" }\r\n\r\n4486.6 \"--north--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n4490.9 \"Silent Whistle\" Ability { id: \"839B\", source: \"Yozakura the Fleeting\" } window 50,50 jump 4363.1\r\n\r\n\r\n# YOZAKURA ABILITIES (MIDDLE PATH)\r\n# 8394 Tatami Trap cast and self-targeted ability for floor shaking\r\n# 8395 Tatami-gaeshi cast and self-targeted ability for floor flipping\r\n# 8396 Tatami-gaeshi cast and damage for floor flip\r\n# 8397 Levinblossom Lance cast and self-targeted for blue counterclockwise line aoes\r\n# 8398 Levinblossom Lance cast and self-targeted for orange clockwise line aoes\r\n# 8399 Levinblossom Lance cast and self-targeted ability for 839A\r\n# 839A Levinblossom Lance damage for rotating lance line aoe\r\n# 839B Silent Whistle cast and self-targeted ability to summon dogs\r\n# 839C Donden-gaeshi cast and self-targeted ability tethering dogs\r\n# 839D Art of the Fluff cast and damage for lookaway from Kuromaru/Shibamaru\r\n# 839E Art of the Fluff cast and damage for lookaway from Shiromaru\r\n# 839F Fireblossom Flare cast and self-targeted ability to summon ground circles\r\n# 83A0 Fireblossom Flare cast and damage for ground circle aoes\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~#\r\n# Gorai the Uncaged #\r\n#~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 8500:5017.6\r\n# -it \"Shishu White Baboon\"\r\n# -ii 84D4 8501 84EE 84E6 84E5 84E9 84E0 84FF 84F9 84F7 84F4 84F5\r\n\r\n# Hall of Becoming will be sealed off\r\n5000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10E0\" } window 10000,0\r\n5012.6 \"--sync--\" StartsUsing { id: \"8500\", source: \"Gorai the Uncaged\" }\r\n5017.6 \"Unenlightenment\" Ability { id: \"8500\", source: \"Gorai the Uncaged\" }\r\n\r\n5027.1 \"Flickering Flame\" Ability { id: \"84D5\", source: \"Gorai the Uncaged\" }\r\n5037.4 \"Plectrum of Power\" Ability { id: \"84D8\", source: \"Gorai the Uncaged\" }\r\n5040.1 \"Fire Spread\" Ability { id: \"84DA\", source: \"Gorai the Uncaged\" }\r\n\r\n5047.3 \"Flickering Flame\" Ability { id: \"84D5\", source: \"Gorai the Uncaged\" }\r\n5057.6 \"Morphic Melody\" Ability { id: \"84D9\", source: \"Gorai the Uncaged\" }\r\n5060.3 \"Fire Spread\" Ability { id: \"84DB\", source: \"Gorai the Uncaged\" }\r\n\r\n5072.6 \"Sulphuric Stone\" Ability { id: \"84D6\", source: \"Gorai the Uncaged\" }\r\n5082.9 \"Plectrum of Power\" Ability { id: \"84D8\", source: \"Gorai the Uncaged\" }\r\n5085.6 \"Falling Rock\" Ability { id: \"84DD\", source: \"Gorai the Uncaged\" }\r\n\r\n5092.8 \"Sulphuric Stone\" Ability { id: \"84D6\", source: \"Gorai the Uncaged\" }\r\n5103.1 \"Morphic Melody\" Ability { id: \"84D9\", source: \"Gorai the Uncaged\" }\r\n5105.8 \"Falling Rock\" Ability { id: \"84DE\", source: \"Gorai the Uncaged\" }\r\n\r\n# This is inconsistent among timelines, so don't sync.\r\n5111.1 \"--middle--\" #Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> path 05\r\n5114.3 \"--sync--\" StartsUsing { id: \"84ED\", source: \"Gorai the Uncaged\" } window 30,30 jump 5214.3\r\n5116.8 \"Pure Shock?\" #Ability { id: \"84ED\", source: \"Gorai the Uncaged\" }\r\n\r\n# -> path 06\r\n5112.1 \"--sync--\" StartsUsing { id: \"84F2\", source: \"Gorai the Uncaged\" } window 30,30 jump 5312.1\r\n5115.1 \"Thundercall?\" Ability { id: \"84F2\", source: \"Gorai the Uncaged\" }\r\n\r\n# -> path 07\r\n5112.1 \"--sync--\" StartsUsing { id: \"84F8\", source: \"Gorai the Uncaged\" } window 30,30 jump 5412.1\r\n5117.1 \"Fighting Spirits?\" #Ability { id: \"84F8\", source: \"Gorai the Uncaged\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# path 05\r\n5211.1 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n5214.3 \"--sync--\" StartsUsing { id: \"84ED\", source: \"Gorai the Uncaged\" }\r\n5216.8 \"Pure Shock\" Ability { id: \"84ED\", source: \"Gorai the Uncaged\" }\r\n5218.5 \"--stun--\" Ability { id: \"84EF\", source: \"Gorai the Uncaged\" }\r\n5220.2 \"Wily Wall\" Ability { id: \"84F0\", source: \"Shishu White Baboon\" }\r\n5222.2 \"--targetable--\"\r\n5228.1 \"Impure Purgation 1\" Ability { id: \"84E7\", source: \"Gorai the Uncaged\" }\r\n5230.1 \"Impure Purgation 2\" Ability { id: \"84E8\", source: \"Gorai the Uncaged\" }\r\n5236.1 \"Spike of Flame\" Ability { id: \"84E4\", source: \"Gorai the Uncaged\" }\r\n5245.0 \"String Snap 1\" Ability { id: \"84EA\", source: \"Gorai the Uncaged\" }\r\n5247.0 \"String Snap 2\" Ability { id: \"84EB\", source: \"Gorai the Uncaged\" }\r\n5249.0 \"String Snap 3\" Ability { id: \"84EC\", source: \"Gorai the Uncaged\" }\r\n5252.3 \"Self-destruct\" Ability { id: \"84F1\", source: \"Shishu White Baboon\" }\r\n# -> shared loop\r\n5260.4 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n5267.7 \"Rousing Reincarnation\" Ability { id: \"84DF\", source: \"Gorai the Uncaged\" } window 30,30 forcejump 5567.7\r\n\r\n\r\n# path 06\r\n5309.8 \"--sync--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n5312.1 \"--sync--\" StartsUsing { id: \"84F2\", source: \"Gorai the Uncaged\" }\r\n5315.1 \"Thundercall\" Ability { id: \"84F2\", source: \"Gorai the Uncaged\" }\r\n5329.0 \"Shock\" Ability { id: \"84DC\", source: \"Ball of Levin\" }\r\n5335.0 \"Humble Hammer\" Ability { id: \"84F6\", source: \"Gorai the Uncaged\" } duration 8.8\r\n5346.3 \"--sync--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n5351.6 \"Thundercall\" Ability { id: \"84F2\", source: \"Gorai the Uncaged\" }\r\n5359.5 \"Humble Hammer\" Ability { id: \"84F6\", source: \"Gorai the Uncaged\" } duration 8.8\r\n5376.5 \"Shock\" Ability { id: \"84F3\", source: \"Ball of Levin\" }\r\n# -> shared loop\r\n5379.9 \"--sync--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n5387.2 \"Rousing Reincarnation\" Ability { id: \"84DF\", source: \"Gorai the Uncaged\" } window 30,30 forcejump 5567.7\r\n\r\n\r\n# path 07\r\n5409.9 \"--sync--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n5412.1 \"--sync--\" StartsUsing { id: \"84F8\", source: \"Gorai the Uncaged\" }\r\n5417.1 \"Fighting Spirits\" Ability { id: \"84F8\", source: \"Gorai the Uncaged\" }\r\n5426.1 \"Worldly Pursuit 1\" Ability { id: \"84FB\", source: \"Gorai the Uncaged\" }\r\n5429.9 \"Worldly Pursuit 2\" Ability { id: \"84FC\", source: \"Gorai the Uncaged\" }\r\n5433.7 \"Worldly Pursuit 3\" Ability { id: \"84FC\", source: \"Gorai the Uncaged\" }\r\n5437.5 \"Worldly Pursuit 4\" Ability { id: \"84FC\", source: \"Gorai the Uncaged\" }\r\n5441.3 \"Worldly Pursuit 5\" Ability { id: \"84FC\", source: \"Gorai the Uncaged\" }\r\n5447.4 \"Biwa Breaker 1\" Ability { id: \"84FD\", source: \"Gorai the Uncaged\" }\r\n5449.1 \"Biwa Breaker 2\" #Ability { id: \"86D1\", source: \"Gorai the Uncaged\" }\r\n5450.8 \"Biwa Breaker 3\" #Ability { id: \"86D1\", source: \"Gorai the Uncaged\" }\r\n5452.5 \"Biwa Breaker 4\" #Ability { id: \"86D1\", source: \"Gorai the Uncaged\" }\r\n5454.2 \"Biwa Breaker 5\" #Ability { id: \"86D1\", source: \"Gorai the Uncaged\" }\r\n# -> shared loop\r\n5461.9 \"--sync--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n5469.1 \"Rousing Reincarnation\" Ability { id: \"84DF\", source: \"Gorai the Uncaged\" } window 30,30 forcejump 5567.7\r\n\r\n\r\n# shared loop\r\n5560.4 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n5567.7 \"Rousing Reincarnation\" Ability { id: \"84DF\", source: \"Gorai the Uncaged\" }\r\n5574.0 \"Malformed Prayer\" Ability { id: \"84E1\", source: \"Gorai the Uncaged\" }\r\n5585.0 \"Burst 1\" Ability { id: \"84E2\", source: \"Gorai the Uncaged\" }\r\n5586.2 \"Impure Purgation 1\" Ability { id: \"84E7\", source: \"Gorai the Uncaged\" }\r\n5588.2 \"Impure Purgation 2\" Ability { id: \"84E8\", source: \"Gorai the Uncaged\" }\r\n5591.0 \"Burst 2\" Ability { id: \"84E2\", source: \"Gorai the Uncaged\" }\r\n5597.0 \"Burst 3\" Ability { id: \"84E2\", source: \"Gorai the Uncaged\" }\r\n5599.1 \"Spike of Flame\" Ability { id: \"84E4\", source: \"Gorai the Uncaged\" }\r\n\r\n5610.9 \"Unenlightenment\" Ability { id: \"8500\", source: \"Gorai the Uncaged\" }\r\n5620.2 \"Flame and Sulphur\" Ability { id: \"84D7\", source: \"Gorai the Uncaged\" }\r\n5630.5 \"Plectrum of Power/Morphic Melody\" Ability { id: [\"84D8\", \"84D9\"], source: \"Gorai the Uncaged\" }\r\n5633.2 \"Falling Rock\" Ability { id: [\"84DD\", \"84DE\"], source: \"Gorai the Uncaged\" }\r\n5633.2 \"Fire Spread\" Ability { id: [\"84DA\", \"84DB\"], source: \"Gorai the Uncaged\" }\r\n5641.4 \"Flame and Sulphur\" Ability { id: \"84D7\", source: \"Gorai the Uncaged\" }\r\n5651.7 \"Morphic Melody/Plectrum of Power\" Ability { id: [\"84D9\", \"84D8\"], source: \"Gorai the Uncaged\" }\r\n5654.4 \"Falling Rock\" Ability { id: [\"84DD\", \"84DE\"], source: \"Gorai the Uncaged\" }\r\n5654.4 \"Fire Spread\" Ability { id: [\"84DA\", \"84DB\"], source: \"Gorai the Uncaged\" }\r\n\r\n5664.5 \"Torching Torment\" Ability { id: \"84FE\", source: \"Gorai the Uncaged\" }\r\n5676.8 \"Unenlightenment\" Ability { id: \"8500\", source: \"Gorai the Uncaged\" }\r\n5687.1 \"String Snap 1\" Ability { id: \"84EA\", source: \"Gorai the Uncaged\" }\r\n5689.1 \"String Snap 2\" Ability { id: \"84EB\", source: \"Gorai the Uncaged\" }\r\n5691.1 \"String Snap 3\" Ability { id: \"84EC\", source: \"Gorai the Uncaged\" }\r\n5697.0 \"Spike of Flame\" Ability { id: \"84E4\", source: \"Gorai the Uncaged\" }\r\n5708.8 \"Unenlightenment\" Ability { id: \"8500\", source: \"Gorai the Uncaged\" }\r\n\r\n5717.2 \"--middle--\" Ability { id: \"84D3\", source: \"Gorai the Uncaged\" }\r\n5724.4 \"Rousing Reincarnation\" Ability { id: \"84DF\", source: \"Gorai the Uncaged\" } window 100,100 forcejump 5567.7\r\n\r\n\r\n# GORAI ABILITIES\r\n# 84D3 --sync-- repositioning ability\r\n# 84D4 --sync-- auto damage\r\n# 84D5 Flickering Flame cast and self-targeted summoning blue flames for lines\r\n# 84D6 Sulphuric Stone cast and self-targeted summoning rocks\r\n# 84D7 Flame and Sulphur cast and self-targeted summoning rocks and lines\r\n# 84D8 Plectrum of Power cast and self-targeted purple effect that expands everything\r\n# 84D9 Morphic Melody cast and self-targeted blue effect that donutifies everything\r\n# 84DA Fire Spread expanded line damage after Plectrum of Power 84D8\r\n# 84DB Fire Spread split line damage after Morphic Melody 84D9\r\n# 84DC Shock Ball of Levin self-targeted ability before 84F5\r\n# 84DD Falling Rock expanded rock damage after Plectrum of Power 84D8\r\n# 84DE Falling Rock donutified rock damage after Morphic Melody 84D9\r\n# 84DF Rousing Reincarnation cast and self-targeted ability\r\n# 84E0 Rousing Reincarnation ability on player that gives Rodential Rebirth\r\n# 84E1 Malformed Prayer cast and self-targeted ability that starts the tower sequence\r\n# 84E2 Burst tower damage\r\n# 84E3 Dramatic Burst missed tower damage\r\n# 84E4 Spike of Flame cast and self-targeted ability\r\n# 84E5 Spike of Flame cast and damage for targeted circle on player\r\n# 84E6 Impure Purgation cast and self-targeted for 2x pinwheel\r\n# 84E7 Impure Purgation cast and damage for first pinwheel\r\n# 84E8 Impure Purgation cast and damage for second pinwheel\r\n# 84E9 String Snap cast and self-targeted ability\r\n# 84EA String Snap cast and damage for earth ring 1\r\n# 84EB String Snap cast and damage for earth ring 2\r\n# 84EC String Snap cast and damage for earth ring 3\r\n# 84F8 Fighting Spirits cast and self-targeted ability\r\n# 84F9 Fighting Spirits and and raidwide damage\r\n# 84FB Worldly Pursuit cast and damage from initial cross jump\r\n# 84FC Worldly Pursuit cast and damage from ongoing cross jumps\r\n# 84FD Biwa Breaker cast and initial damage from multiple raidwides\r\n# 84ED Pure Shock cast and self-targeted ability for chain to Shishu White Baboon\r\n# 84EE Pure Shock cast and damage for chain to Shishu White Baboon\r\n# 84EF --sync-- stun to pull to Shishu White Baboon\r\n# 84F0 Wily Wall cast and self-targeted Shishu White Baboon ability to create octagon wall\r\n# 84F1 Self-destruct long cast and damage from Shishu White Baboon\r\n# 84F2 Thundercall cast and self-targeted Ball of Levin summoning\r\n# 84F3 Shock Ball of Levin self-targeted ability before 84F4/84F5\r\n# 84F4 Shock small ground circle damage from Ball of Levin hit by Humble Hammer\r\n# 84F5 Shock arge ground circle damage from Ball of Levin\r\n# 84F6 Humble Hammer cast and self-targeted ability\r\n# 84F7 Humble Hammer ongoing hammer circles that shrink orbs\r\n# 84FE Torching Torment cast and ability for tankbuster\r\n# 84FF Torching Torment damage from tankbuster\r\n# 8500 Unenlightenment cast and self-targeted ability\r\n# 8501 Unenlightenment raidwide damage\r\n# 86D1 Biwa Breaker damage from followup raidwides\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#\r\n# Yozakura the Fleeting (right path) #\r\n#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 83A9:6012\r\n# -ii 83A2 83A3 83A8 8382 838A\r\n\r\n# Autumn Rivers' End will be sealed off\r\n6000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10DE\" } window 10000,0\r\n6012.0 \"Glory Neverlasting\" Ability { id: \"83A9\", source: \"Yozakura the Fleeting\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> no dogu\r\n6016.1 \"--sync--\" StartsUsing { id: \"8368\", source: \"Yozakura the Fleeting\" } window 30,30 jump 6116.1\r\n6019.1 \"Art of the Fireblossom?\" #Ability { id: \"8368\", source: \"Yozakura the Fleeting\" }\r\n\r\n# -> dogu\r\n6016.1 \"--sync--\" StartsUsing { id: \"8369\", source: \"Yozakura the Fleeting\" } window 30,30 jump 6316.1\r\n6021.1 \"Art of the Windblossom?\" Ability { id: \"8369\", source: \"Yozakura the Fleeting\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# no dogu path\r\n6116.1 \"--sync--\" StartsUsing { id: \"8368\", source: \"Yozakura the Fleeting\" }\r\n6119.1 \"Art of the Fireblossom\" Ability { id: \"8368\", source: \"Yozakura the Fleeting\" }\r\n6123.3 \"--sync--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n6129.6 \"Bunshin\" Ability { id: \"837E\", source: \"Yozakura the Fleeting\" }\r\n6138.7 \"Shadowflight (cast)\" Ability { id: \"837F\", source: \"Yozakura the Fleeting\" }\r\n6143.6 \"Shadowflight\" Ability { id: \"8380\", source: \"Mirrored Yozakura\" }\r\n\r\n6150.8 \"Oka Ranman\" Ability { id: \"836E\", source: \"Yozakura the Fleeting\" }\r\n6155.9 \"--sync--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n6160.0 \"Seal of the Fleeting\" Ability { id: \"8379\", source: \"Yozakura the Fleeting\" }\r\n#6060.2 \"Seal Marker 1\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#6062.2 \"Seal Marker 2\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n6169.4 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n6172.6 \"Seal of the Blossom\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n\r\n6182.6 \"Nubuki\" Ability { id: \"83A1\", source: \"Yozakura the Fleeting\" }\r\n6191.7 \"--sync--\" Ability { id: \"83A4\", source: \"Yozakura the Fleeting\" }\r\n6194.7 \"Root Arrangement 1\" Ability { id: \"83A5\", source: \"Yozakura the Fleeting\" }\r\n6195.8 \"Root Arrangement 2\" #Ability { id: \"83A6\", source: \"Yozakura the Fleeting\" }\r\n6196.8 \"Root Arrangement 3\" #Ability { id: \"83A6\", source: \"Yozakura the Fleeting\" }\r\n6197.8 \"Root Arrangement 4\" #Ability { id: \"83A6\", source: \"Yozakura the Fleeting\" }\r\n6206.7 \"--sync--\" Ability { id: \"83A4\", source: \"Yozakura the Fleeting\" }\r\n6209.7 \"Root Arrangement 1\" Ability { id: \"83A5\", source: \"Yozakura the Fleeting\" }\r\n6210.8 \"Root Arrangement 2\" #Ability { id: \"83A6\", source: \"Yozakura the Fleeting\" }\r\n6211.8 \"Root Arrangement 3\" #Ability { id: \"83A6\", source: \"Yozakura the Fleeting\" }\r\n6212.8 \"Root Arrangement 4\" #Ability { id: \"83A6\", source: \"Yozakura the Fleeting\" }\r\n\r\n6221.7 \"Art of the Windblossom\" Ability { id: \"8369\", source: \"Yozakura the Fleeting\" }\r\n6230.8 \"Oka Ranman\" Ability { id: \"836E\", source: \"Yozakura the Fleeting\" }\r\n6235.9 \"--sync--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n6240.1 \"Seal of the Fleeting\" Ability { id: \"8379\", source: \"Yozakura the Fleeting\" }\r\n#6140.3 \"Seal Marker 1\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#6142.3 \"Seal Marker 2\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#6144.3 \"Seal Marker 3\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#6146.3 \"Seal Marker 4\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n6253.8 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n6257.0 \"Seal of the Blossom 1\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n6262.0 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n6265.0 \"Seal of the Blossom 2\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n6278.0 \"Kuge Rantsui\" Ability { id: \"83AA\", source: \"Yozakura the Fleeting\" }\r\n6286.2 \"Glory Neverlasting\" Ability { id: \"83A9\", source: \"Yozakura the Fleeting\" }\r\n\r\n6293.3 \"Nubuki\" Ability { id: \"83A1\", source: \"Yozakura the Fleeting\" } window 30,30 forcejump 6182.6\r\n\r\n\r\n# dogu path\r\n6316.1 \"--sync--\" StartsUsing { id: \"8369\", source: \"Yozakura the Fleeting\" }\r\n6321.1 \"Art of the Windblossom\" Ability { id: \"8369\", source: \"Yozakura the Fleeting\" }\r\n6325.3 \"--sync--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n#6329.4 \"Season Indicator 1\" Ability { id: \"838[34]\", source: \"Yozakura the Fleeting\" }\r\n#6331.5 \"Season Indicator 2\" Ability { id: \"838[34]\", source: \"Yozakura the Fleeting\" }\r\n#6333.6 \"Season Indicator 3\" Ability { id: \"838[34]\", source: \"Yozakura the Fleeting\" }\r\n#6335.7 \"Season Indicator 4\" Ability { id: \"838[34]\", source: \"Yozakura the Fleeting\" }\r\n6336.1 \"Seasons of the Fleeting\" Ability { id: \"8381\", source: \"Yozakura the Fleeting\" }\r\n6337.0 \"Season of Element 1\" #Ability { id: \"838[5678]\", source: \"Yozakura the Fleeting\" }\r\n6339.1 \"Season of Element 2\" #Ability { id: \"838[5678]\", source: \"Yozakura the Fleeting\" }\r\n6341.2 \"Season of Element 3\" #Ability { id: \"838[5678]\", source: \"Yozakura the Fleeting\" }\r\n6343.3 \"Season of Element 4\" #Ability { id: \"838[5678]\", source: \"Yozakura the Fleeting\" }\r\n\r\n6351.6 \"Oka Ranman\" Ability { id: \"836E\", source: \"Yozakura the Fleeting\" }\r\n6356.7 \"--middle--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n6360.8 \"Seal of the Fleeting\" Ability { id: \"8379\", source: \"Yozakura the Fleeting\" }\r\n#6361.0 \"Seal Marker 1\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#6363.0 \"Seal Marker 2\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n6370.2 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n6373.4 \"Seal of the Blossom\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n\r\n6380.4 \"--middle--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n6384.5 \"Witherwind\" Ability { id: \"83A7\", source: \"Yozakura the Fleeting\" }\r\n6389.6 \"Mudrain\" Ability { id: \"8389\", source: \"Yozakura the Fleeting\" }\r\n6399.8 \"--sync--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n6405.8 \"Drifting Petals\" Ability { id: \"8393\", source: \"Yozakura the Fleeting\" }\r\n6429.9 \"Art of the Fireblossom\" Ability { id: \"8368\", source: \"Yozakura the Fleeting\" }\r\n6439.0 \"Oka Ranman\" Ability { id: \"836E\", source: \"Yozakura the Fleeting\" }\r\n\r\n6444.1 \"--sync--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n6448.3 \"Seal of the Fleeting\" Ability { id: \"8379\", source: \"Yozakura the Fleeting\" }\r\n#6448.5 \"Seal Marker 1\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#6450.5 \"Seal Marker 2\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#6452.5 \"Seal Marker 3\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n#6454.5 \"Seal Marker 4\" Ability { id: \"837[ABCD]\", source: \"Yozakura the Fleeting\" }\r\n6461.7 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n6464.7 \"Seal of the Blossom 1\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n6469.8 \"Seal of Riotous Bloom\" Ability { id: \"8374\", source: \"Yozakura the Fleeting\" }\r\n6473.0 \"Seal of the Blossom 2\" Ability { id: \"837[5678]\", source: \"Yozakura the Fleeting\" }\r\n6486.0 \"Kuge Rantsui\" Ability { id: \"83AA\", source: \"Yozakura the Fleeting\" }\r\n6494.2 \"Glory Neverlasting\" Ability { id: \"83A9\", source: \"Yozakura the Fleeting\" }\r\n\r\n6498.3 \"--middle--\" Ability { id: \"8612\", source: \"Yozakura the Fleeting\" }\r\n6502.4 \"Witherwind\" Ability { id: \"83A7\", source: \"Yozakura the Fleeting\" } window 30,30 forcejump 6384.5\r\n\r\n\r\n# YOZAKURA ABILITIES (RIGHT PATH)\r\n# 83A1 Nubuki cast and self-targeted to generate Accursed Seedling roots\r\n# 83A2 Behind Barbs damage from standing in the Accursed Seedling\r\n# 83A3 Explosion cast and damage from Living Gaol when it captures you\r\n# 83A4 Root Arrangement cast and self-targeted ability for chasing rock\r\n# 83A5 Root Arrangement cast and damage for chasing rock hit #1\r\n# 83A6 Root Arrangement damage for chasing rock hits #2-4\r\n# 83A7 Witherwind cast and self-targeted tornado summoning\r\n# 83A8 Cutting Leaves damage for hitting tornados\r\n\r\n\r\n#~~~~~~~~~#\r\n# Shishio #\r\n#~~~~~~~~~#\r\n\r\n# -p 83F5:7015.7\r\n# -ii 86DE 83DA 83DE 83DF 83E0 83E3 83E4 83E5 83E2 87F9 87FB 83DB 87A3 87A4 87A6 87AB 83ED 872B 83F2\r\n\r\n# Stone's Silence will be sealed off\r\n7000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10E1\" } window 10000,0\r\n7015.7 \"Enkyo\" Ability { id: \"83F5\", source: \"Shishio\" }\r\n7017.8 \"--middle--\" Ability { id: \"83F7\", source: \"Shishio\" }\r\n7022.0 \"Stormcloud Summons\" Ability { id: \"83D7\", source: \"Shishio\" }\r\n7026.7 \"Smokeater\" Ability { id: \"83D8\", source: \"Shishio\" }\r\n# Note: This always seems to be Once on Rokujo\r\n7036.8 \"Once on Rokujo\" Ability { id: \"83DD\", source: \"Shishio\" }\r\n7053.4 \"Splitting Cry\" Ability { id: \"83F6\", source: \"Shishio\" }\r\n7055.5 \"--middle--\" Ability { id: \"83F7\", source: \"Shishio\" }\r\n# Note: this one can be Twice or Thrice on Rokujo\r\n7059.8 \"Stormcloud Summons\" Ability { id: \"83D7\", source: \"Shishio\" }\r\n7064.5 \"Smokeater 1\" Ability { id: \"83D8\", source: \"Shishio\" }\r\n7066.6 \"Smokeater 2\" #Ability { id: \"83D9\", source: \"Shishio\" }\r\n7068.5 \"Smokeater 3?\" #Ability { id: \"83D9\", source: \"Shishio\" }\r\n7093.0 \"Haunting Cry\" Ability { id: \"83E8\", source: \"Shishio\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> path 08\r\n7104.0 \"--sync--\" StartsUsing { id: \"83EE\", source: \"Feral Thrall\" }\r\n7110.0 \"Rush?\" Ability { id: \"83EE\", source: \"Feral Thrall\" } window 30,30 jump 7210\r\n\r\n# -> path 09\r\n7093.9 \"--sync--\" StartsUsing { id: \"83E9\", source: \"Shishio\" } window 30,30 jump 7293.9\r\n7098.9 \"Focused Tremor?\" #Ability { id: \"83E9\", source: \"Shishio\" }\r\n\r\n# -> path 10\r\n7097.0 \"--sync--\" StartsUsing { id: \"83F0\", source: \"Devilish Thrall\" } window 30,30 jump 7397\r\n7105.0 \"Left Swipe?\" #Ability { id: \"83F1\", source: \"Devilish Thrall\" }\r\n7105.0 \"Right Swipe?\" #Ability { id: \"83F0\", source: \"Devilish Thrall\" }\r\n\r\n# -> path 11\r\n7099.0 \"--sync--\" StartsUsing { id: \"872B\", source: \"Haunting Thrall\" } window 30,30 jump 7599\r\n7103.0 \"Reisho?\" #Ability { id: \"872B\", source: \"Haunting Thrall\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# path 08\r\n7193.0 \"Haunting Cry\" Ability { id: \"83E8\", source: \"Shishio\" }\r\n7204.0 \"--sync--\" StartsUsing { id: \"83EE\", source: \"Feral Thrall\" }\r\n7210.0 \"Rush\" Ability { id: \"83EE\", source: \"Feral Thrall\" }\r\n7212.0 \"Vasoconstrictor 1\" Ability { id: \"83EF\", source: \"Venomous Thrall\" }\r\n7217.0 \"Vasoconstrictor 2\" Ability { id: \"83EF\", source: \"Venomous Thrall\" }\r\n7217.0 \"--sync--\" Ability { id: \"83F7\", source: \"Shishio\" }\r\n7223.0 \"Thunder Vortex\" Ability { id: \"83F4\", source: \"Shishio\" }\r\n7230.2 \"Splitting Cry\" Ability { id: \"83F6\", source: \"Shishio\" }\r\n# -> shared loop\r\n7240.3 \"Enkyo\" Ability { id: \"83F5\", source: \"Shishio\" } window 30,30 forcejump 7634.4\r\n\r\n# path 09\r\n7293.0 \"Haunting Cry\" Ability { id: \"83E8\", source: \"Shishio\" }\r\n7293.9 \"--sync--\" StartsUsing { id: \"83E9\", source: \"Shishio\" }\r\n7298.9 \"Focused Tremor\" Ability { id: \"83E9\", source: \"Shishio\" }\r\n7303.2 \"Yoki (cast)\" Ability { id: \"83EA\", source: \"Shishio\" }\r\n7308.0 \"Yoki 1\" Ability { id: \"83EB\", source: \"Shishio\" }\r\n7312.0 \"Yoki 2\" Ability { id: \"83EB\", source: \"Shishio\" }\r\n7315.3 \"--sync--\" Ability { id: \"83F7\", source: \"Shishio\" }\r\n7324.3 \"Yoki-uzu\" Ability { id: \"83EC\", source: \"Shishio\" }\r\n# -> shared loop\r\n7334.4 \"Enkyo\" Ability { id: \"83F5\", source: \"Shishio\" } window 30,30 forcejump 7634.4\r\n\r\n# path 10\r\n7393.0 \"Haunting Cry\" Ability { id: \"83E8\", source: \"Shishio\" }\r\n7397.0 \"--sync--\" StartsUsing { id: \"83F0\", source: \"Devilish Thrall\" }\r\n7405.0 \"Left Swipe 1\" Ability { id: \"83F1\", source: \"Devilish Thrall\" }\r\n7405.0 \"Right Swipe 1\" Ability { id: \"83F0\", source: \"Devilish Thrall\" }\r\n7415.3 \"Left Swipe 2\" Ability { id: \"83F1\", source: \"Devilish Thrall\" }\r\n7415.3 \"Right Swipe 2\" Ability { id: \"83F0\", source: \"Devilish Thrall\" }\r\n7424.3 \"Splitting Cry\" Ability { id: \"83F6\", source: \"Shishio\" }\r\n# -> shared loop\r\n7434.4 \"Enkyo\" Ability { id: \"83F5\", source: \"Shishio\" } window 30,30 forcejump 7634.4\r\n\r\n# path 11\r\n7593.0 \"Haunting Cry\" Ability { id: \"83E8\", source: \"Shishio\" }\r\n7599.0 \"--sync--\" StartsUsing { id: \"872B\", source: \"Haunting Thrall\" }\r\n7603.0 \"Reisho\" Ability { id: \"872B\", source: \"Haunting Thrall\" }\r\n7611.1 \"--middle--\" Ability { id: \"83F7\", source: \"Shishio\" }\r\n7617.1 \"Thunder Vortex\" Ability { id: \"83F4\", source: \"Shishio\" }\r\n7624.3 \"Splitting Cry\" Ability { id: \"83F6\", source: \"Shishio\" }\r\n# -> shared loop\r\n7634.4 \"Enkyo\" Ability { id: \"83F5\", source: \"Shishio\" } window 30,30 forcejump 7634.4\r\n\r\n\r\n# shared loop\r\n7634.4 \"Enkyo\" Ability { id: \"83F5\", source: \"Shishio\" }\r\n7636.5 \"--middle--\" Ability { id: \"83F7\", source: \"Shishio\" }\r\n7640.7 \"Stormcloud Summons\" Ability { id: \"83D7\", source: \"Shishio\" }\r\n7645.4 \"Smokeater\" Ability { id: \"83D8\", source: \"Shishio\" }\r\n# Note: This always seems to be Onefold the first time around.\r\n7650.5 \"Thunder Onefold\" Ability { id: \"83E1\", source: \"Shishio\" }\r\n7678.1 \"Splitting Cry\" Ability { id: \"83F6\", source: \"Shishio\" }\r\n\r\n7684.2 \"--jump--\" Ability { id: \"83F7\", source: \"Shishio\" }\r\n7693.5 \"Noble Pursuit\" Ability { id: \"83E6\", source: \"Shishio\" }\r\n7694.4 \"Levinburst\" Ability { id: \"83E7\", source: \"Rairin\" }\r\n7700.4 \"Thunder Vortex\" Ability { id: \"83F4\", source: \"Shishio\" }\r\n7707.5 \"Enkyo\" Ability { id: \"83F5\", source: \"Shishio\" }\r\n\r\n7713.7 \"--middle--\" Ability { id: \"83F7\", source: \"Shishio\" }\r\n7717.9 \"Stormcloud Summons\" Ability { id: \"83D7\", source: \"Shishio\" }\r\n7722.6 \"Smokeater 1\" Ability { id: \"83D8\", source: \"Shishio\" }\r\n7724.7 \"Smokeater 2?\" #Ability { id: \"83D9\", source: \"Shishio\" }\r\n7726.6 \"Smokeater 3?\" #Ability { id: \"83D9\", source: \"Shishio\" }\r\n7750.2 \"Enkyo\" Ability { id: \"83F5\", source: \"Shishio\" }\r\n\r\n# this is the start of the loop, as there's an extra delay on the 7713.7 jump\r\n# the first time through\r\n7757.4 \"--middle--\" Ability { id: \"83F7\", source: \"Shishio\" }\r\n7761.6 \"Stormcloud Summons\" Ability { id: \"83D7\", source: \"Shishio\" }\r\n7766.3 \"Smokeater 1\" Ability { id: \"83D8\", source: \"Shishio\" }\r\n7768.4 \"Smokeater 2?\" #Ability { id: \"83D9\", source: \"Shishio\" }\r\n7770.4 \"Smokeater 3?\" #Ability { id: \"83D9\", source: \"Shishio\" }\r\n# Note: this is +/- 2 seconds depending on how many Smokeaters, so no sync\r\n7773.4 \"Thunder Onefold/Thunder Twofold/Thunder Threefold\" #Ability { id: [\"83E1\", \"87AD\", \"87FA\"], source: \"Shishio\" }\r\n7798.8 \"Splitting Cry\" Ability { id: \"83F6\", source: \"Shishio\" }\r\n\r\n7804.9 \"--jump--\" Ability { id: \"83F7\", source: \"Shishio\" }\r\n7814.2 \"Noble Pursuit\" Ability { id: \"83E6\", source: \"Shishio\" }\r\n7815.1 \"Levinburst\" Ability { id: \"83E7\", source: \"Rairin\" }\r\n7821.1 \"Thunder Vortex\" Ability { id: \"83F4\", source: \"Shishio\" }\r\n7828.2 \"Enkyo\" Ability { id: \"83F5\", source: \"Shishio\" }\r\n\r\n7835.4 \"--middle--\" Ability { id: \"83F7\", source: \"Shishio\" }\r\n7839.6 \"Stormcloud Summons\" Ability { id: \"83D7\", source: \"Shishio\" } window 30,30 forcejump 7717.9\r\n\r\n\r\n# SHISHIO ABILITIES\r\n# 83D7 Stormcloud Summons cast and self-targeted ability\r\n# 83D8 Smokeater cast and self-targeted ability for first inhale\r\n# 83D9 Smokeater self-targeted ability for optional second and third inhales\r\n# 83DA --sync-- Raiun ability on Shishio after being inhaled\r\n# 83DB Once on Rokujo cast and self-targeted ability for 1x Smokeater line\r\n# 83DD Once on Rokujo cast and damage for 1x Smokeater line aoe\r\n# 83DE Leaping Levin Raiun 1x Smokeater small cloud circles\r\n# 83DF Leaping Levin Raiun 2x Smokeater medium cloud circles\r\n# 83E0 Leaping Levin Raiun 3x Smokeater large cloud circles\r\n# 83E1 Thunder Onefold cast and self-targeted ability\r\n# 83E2 Thunder Onefold cast and damage for 1x Smokeater initial cloud circles\r\n# 83E3 Cloud to Cloud cast and damage for 1x Smokeater small lines\r\n# 83E4 Cloud to Cloud cast and damage for 2x Smokeater medium lines\r\n# 83E5 Cloud to Cloud cast and damage for 3x Smokeater large lines\r\n# 83E6 Noble Pursuit cast and damage for line aoe\r\n# 83E7 Levinburst line damage for going through rings during Noble Pursuit\r\n# 83E8 Haunting Cry cast and raidwide damage\r\n# 83E9 Focused Tremor cast and raidwide damage\r\n# 83EA Yoki cast and self-targeted ability to summon circles\r\n# 83EB Yoki cast and damage for ground circles\r\n# 83EC Yoki-uzu cast and damage for \"get out (into quicksand)\" aoe\r\n# 83ED Unsagely Spin Clever Thrall centered circle\r\n# 83EE Rush Feral Thrall line aoe\r\n# 83EF Vasoconstrictor Venomous Trhall targeted circle\r\n# 83F0 Right Swipe cast and damage for Devilish Thrall cleave\r\n# 83F1 Left Swipe cast and damage for Devilish Thrall cleave\r\n# 83F2 Reisho Haunting Thrall centered circle\r\n# 83F4 Thunder Vortex cast and damage for donut\r\n# 83F5 Enkyo cast and damage for raidwide\r\n# 83F6 Splitting Cry cast and damage for tankbuster\r\n# 83F7 --sync-- repositioning\r\n# 86DE --sync-- auto damage\r\n# 872B Reisho Haunting Thrall centered circle\r\n# 872C Reisho Haunting Thrall centered circle\r\n# 87A3 Twice on Rokujo cast and self-targeted ability for 2x Smokeater lines\r\n# 87A4 Twice on Rokujo self-targeted ability (???)\r\n# 87A5 Twice on Rokujo cast and damage for 2x Smokeater line aoe\r\n# 87A6 Thrice on Rokujo cast and self-targeted ability for 3x Smokeater lines\r\n# 87AB Thrice on Rokujo self-targeted ability (???)\r\n# 87AC Thrice on Rokujo cast and damage for 3x Smokeater line aoe\r\n# 87AD Thunder Twofold cast and self-targeted ability\r\n# 87F9 Thunder Twofold cast and damage for 2x Smokeater initial cloud circles\r\n# 87FA Thunder Threefold cast and self-targeted ability\r\n# 87FB Thunder Threefold cast and damage for 3x Smokeater initial cloud circles\r\n\r\n\r\n#~~~~~~~~#\r\n# Enenra #\r\n#~~~~~~~~#\r\n\r\n# Note: you cannot kill a clone during the split phase, it will stop at 1 hp\r\n# and so the timeline is thankfully stable for that phase.\r\n\r\n# TODO: is Clearing Smoke / Smoke Rings random?\r\n\r\n# -p 8042:8013\r\n# -ii 8058 8049 804A 804B 8047\r\n\r\n# Pond of Spring Rain will be sealed off\r\n8000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"10E2\" } window 10000,0\r\n8013.0 \"Flagrant Combustion\" Ability { id: \"8042\", source: \"Enenra\" }\r\n8016.1 \"--jump--\" Ability { id: \"84C2\", source: \"Enenra\" }\r\n8029.9 \"Out of the Smoke\" Ability { id: \"804C\", source: \"Enenra\" }\r\n8030.1 \"--sync--\" Ability { id: \"804E\", source: \"Enenra\" }\r\n8034.0 \"Into the Fire\" Ability { id: \"804D\", source: \"Enenra\" }\r\n8043.1 \"Kiseru Clamor 1\" Ability { id: \"8048\", source: \"Enenra\" } duration 6\r\n8047.2 \"Kiseru Clamor 2\" Ability { id: \"8048\", source: \"Enenra\" } duration 6\r\n\r\n8049.3 \"--jump--\" Ability { id: \"84C2\", source: \"Enenra\" }\r\n8063.1 \"Out of the Smoke\" Ability { id: \"804C\", source: \"Enenra\" }\r\n8063.3 \"--sync--\" Ability { id: \"804E\", source: \"Enenra\" }\r\n8067.2 \"Into the Fire\" Ability { id: \"804D\", source: \"Enenra\" }\r\n\r\n8073.4 \"--west--\" Ability { id: \"84C2\", source: \"Enenra\" }\r\n8077.4 \"Smoke and Mirrors\" Ability { id: \"8043\", source: \"Enenra\" }\r\n8077.7 \"--sync--\" Ability { id: \"8045\", source: \"Enenra\" }\r\n8083.4 \"Kiseru Clamor x2\" Ability { id: \"8048\", source: \"Enenra\" } duration 6\r\n8087.5 \"Kiseru Clamor x2\" Ability { id: \"8048\", source: \"Enenra\" } duration 6\r\n8089.7 \"--jump--\" Ability { id: \"84C2\", source: \"Enenra\" }\r\n8103.5 \"Out of the Smoke x2\" Ability { id: \"804C\", source: \"Enenra\" }\r\n8103.7 \"--sync--\" Ability { id: \"804E\", source: \"Enenra\" }\r\n8107.6 \"Into the Fire x2\" #Ability { id: \"804D\", source: \"Enenra\" }\r\n8111.8 \"--sync--\" Ability { id: \"84C2\", source: \"Enenra\" }\r\n8121.6 \"--sync--\" Ability { id: [\"8062\", \"8063\"], source: \"Enenra\" }\r\n8125.0 \"Clearing Smoke/Smoke Rings\" Ability { id: [\"8052\", \"8053\"], source: \"Enenra\" }\r\n8130.8 \"Smoke Stack\" Ability { id: \"8046\", source: \"Enenra\" }\r\n\r\n8136.3 \"--sync--\" Ability { id: \"84C2\", source: \"Enenra\" }\r\n8142.0 \"Smoldering Damnation\" Ability { id: \"804F\", source: \"Enenra\" }\r\n8154.6 \"Smoldering 1\" #Ability { id: \"8050\", source: \"Enenra\" }\r\n8157.2 \"Smoldering 2\" #Ability { id: \"8050\", source: \"Enenra\" }\r\n8159.8 \"Smoldering 3\" #Ability { id: \"8050\", source: \"Enenra\" }\r\n8162.7 \"Pipe Cleaner\" Ability { id: \"8054\", source: \"Enenra\" }\r\n#8162.9 \"Pipe Cleaner\" Ability { id: \"8055\", source: \"Enenra\" }\r\n# TODO: this can tether multiple people and delay the timeline?\r\n\r\n8167.8 \"--west--\" Ability { id: \"84C2\", source: \"Enenra\" }\r\n8169.4 \"--sync--\" StartsUsing { id: \"8043\", source: \"Enenra\" } window 10,20\r\n8171.9 \"Smoke and Mirrors\" Ability { id: \"8043\", source: \"Enenra\" }\r\n8172.2 \"--sync--\" Ability { id: \"8045\", source: \"Enenra\" }\r\n8179.9 \"Flagrant Combustion x2\" Ability { id: \"8042\", source: \"Enenra\" }\r\n8182.9 \"--sync--\" Ability { id: \"84C2\", source: \"Enenra\" }\r\n8188.7 \"Smoldering Damnation\" Ability { id: \"804F\", source: \"Enenra\" }\r\n8195.3 \"--sync--\" Ability { id: \"84C2\", source: \"Enenra\" }\r\n8201.3 \"Smoldering 1\" #Ability { id: \"8050\", source: \"Enenra\" }\r\n8203.9 \"Smoldering 2\" #Ability { id: \"8050\", source: \"Enenra\" }\r\n8205.1 \"--sync--\" Ability { id: [\"8062\", \"8063\"], source: \"Enenra\" }\r\n8206.3 \"Smoldering 3\" #Ability { id: \"8050\", source: \"Enenra\" }\r\n8208.5 \"Clearing Smoke/Smoke Rings\" Ability { id: [\"8052\", \"8053\"], source: \"Enenra\" }\r\n8214.3 \"Smoke Stack\" Ability { id: \"8046\", source: \"Enenra\" }\r\n\r\n8222.7 \"Flagrant Combustion\" Ability { id: \"8042\", source: \"Enenra\" }\r\n8238.9 \"Snuff\" Ability { id: \"8056\", source: \"Enenra\" }\r\n8243.1 \"Uplift\" Ability { id: \"8057\", source: \"Enenra\" }\r\n8248.0 \"Flagrant Combustion\" Ability { id: \"8042\", source: \"Enenra\" }\r\n8258.1 \"Kiseru Clamor 1\" Ability { id: \"8048\", source: \"Enenra\" } duration 6\r\n8262.2 \"Kiseru Clamor 2\" Ability { id: \"8048\", source: \"Enenra\" } duration 6\r\n\r\n8264.3 \"--jump--\" Ability { id: \"84C2\", source: \"Enenra\" }\r\n8277.9 \"Out of the Smoke\" Ability { id: \"804C\", source: \"Enenra\" }\r\n8278.1 \"--sync--\" Ability { id: \"804E\", source: \"Enenra\" }\r\n8282.0 \"Into the Fire\" Ability { id: \"804D\", source: \"Enenra\" }\r\n8291.1 \"Flagrant Combustion\" Ability { id: \"8042\", source: \"Enenra\" }\r\n8300.2 \"Flagrant Combustion\" Ability { id: \"8042\", source: \"Enenra\" }\r\n\r\n8313.4 \"--sync--\" Ability { id: \"84C2\", source: \"Enenra\" }\r\n8317.4 \"Smoke and Mirrors\" Ability { id: \"8043\", source: \"Enenra\" } window 30,30 forcejump 8077.4\r\n\r\n\r\n# ENENRA ABILITIES\r\n# 1961 attack auto damage\r\n# 8042 Flagrant Combustion cast and raidwide damage\r\n# 8043 Smoke and Mirrors cast and self-targeted clone creation\r\n# 8045 --sync-- ability to create clone\r\n# 8046 Smoke Stack cast and self-targeted ability for one clone merge\r\n# 8047 Smoke Stack cast and self-targeted ability for other clone merge\r\n# 8048 Kiseru Clamor cast and damage for initial jump that creates Bedrock Uplift earth rings\r\n# 8049 Bedrock Uplift cast and damage for earth ring 2\r\n# 804A Bedrock Uplift cast and damage for earth ring 3\r\n# 804B Bedrock Uplift cast and damage for earth ring 4\r\n# 804C Out of the Smoke long cast and self-targeted prior to Into the Fire\r\n# 804D Into the Fire cast and self-targeted for 180 cleave\r\n# 804E --sync-- repositioning during Out of the Smoke\r\n# 804F Smoldering Damnation cast and self-targeted ability to summon growing circles\r\n# 8050 Smoldering cast and damage for growing ground circle\r\n# 8052 Clearing Smoke cast and damage for Clearing Smoke knockback\r\n# 8053 Smoke Rings cast and damage for \"get out\" Smoke Rings collision\r\n# 8054 Pipe Cleaner cast and self-targeted ability for tether line cleave\r\n# 8055 Pipe Cleaner damage from tether earthshaker-esque line cleave\r\n# 8056 Snuff cast and tankbuster damage\r\n# 8057 Uplift cast and followup ground circle to Snuff\r\n# 8058 Into the Fire cast and damage for 180 cleave\r\n# 8062 Clearing Smoke cast and self-targeted ability for Clearing Smoke knockback collision\r\n# 8063 Smoke Rings cast and self-targeted ability for Smoke Rings collision\r\n# 84C2 --sync-- repositioning\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/smileton.ts




// TODO: Big Cheese Bomb directions?
// TODO: Big Cheese Bombs are only spawned once, is it possible the fast one is always the same id?
const smileton_triggerSet = {
  id: 'Smileton',
  zoneId: zone_id/* default.Smileton */.Z.Smileton,
  timelineFile: 'smileton.txt',
  initData: () => {
    return {
      smileyFace: false,
      frownyFace: false
    };
  },
  triggers: [{
    id: 'Smileton Face Off My Lawn',
    type: 'StartsUsing',
    netRegex: {
      id: '673E',
      source: 'Face',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback (one row)',
        de: 'Rückstoß (eine Reihe)',
        fr: 'Poussée (une ligne)',
        ja: '一行ノックバック',
        cn: '击退 (向后一行)',
        ko: '넉백 (한 줄)'
      }
    }
  }, {
    id: 'Smileton Face Temper\'s Flare',
    type: 'StartsUsing',
    netRegex: {
      id: '6743',
      source: 'Face',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Smileton Face Heart on Fire IV',
    type: 'StartsUsing',
    netRegex: {
      id: '6742',
      source: 'Face'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Smileton Face Smiley Face Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'ACB',
      source: 'Relatively Small Face'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.smileyFace = true
  }, {
    id: 'Smileton Face Smiley Face Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: 'ACB',
      source: 'Relatively Small Face'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.smileyFace = false
  }, {
    id: 'Smileton Face Frowny Face Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'ACC',
      source: 'Relatively Small Face'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.frownyFace = true
  }, {
    id: 'Smileton Face Frowny Face Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: 'ACC',
      source: 'Relatively Small Face'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: data => data.frownyFace = false
  }, {
    id: 'Smileton Face MixedFeelings',
    type: 'StartsUsing',
    netRegex: {
      id: '6738',
      source: 'Face',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      if (data.smileyFace) return output.frowny();
      if (data.frownyFace) return output.smiley();
      return output.either();
    },
    outputStrings: {
      smiley: {
        en: 'Get hit by blue smiley',
        de: 'Von der blauen Grinsen treffen lassen',
        fr: 'Faites-vous toucher par un sourir bleu',
        ja: 'ニコニコ(青)',
        cn: '吃蓝脸AOE',
        ko: '파란 얼굴이 쏘는 레이저 맞기'
      },
      frowny: {
        en: 'Get hit by red frowny',
        de: 'Von dem roten Grimigen treffen lassen',
        fr: 'Faites-vous toucher par un visage en colère rouge',
        ja: 'ムカムカ(赤)',
        cn: '吃红脸AOE',
        ko: '빨간 얼굴이 쏘는 레이저 맞기'
      },
      either: {
        en: 'Get hit by red or blue face',
        de: 'Von irgendeiner Farbe treffen lassen',
        fr: 'Faites-vous toucher par une couleur',
        ja: '青か赤の攻撃を受ける',
        cn: '吃任意颜色脸的AOE',
        ko: '아무 색의 레이저 맞기'
      }
    }
  }, {
    id: 'Smileton Frameworker Circular Saw',
    type: 'StartsUsing',
    netRegex: {
      id: '6745',
      source: 'Frameworker',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Smileton Frameworker Steel Beam',
    type: 'StartsUsing',
    netRegex: {
      id: '6744',
      source: 'Frameworker'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Smileton The Big Cheese Violent Discharge',
    type: 'StartsUsing',
    netRegex: {
      id: '6752',
      source: 'The Big Cheese',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Smileton The Big Cheese Right Disassembler',
    type: 'StartsUsing',
    netRegex: {
      id: '674F',
      source: 'The Big Cheese',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Smileton The Big Cheese Left Disassembler',
    type: 'StartsUsing',
    netRegex: {
      id: '6750',
      source: 'The Big Cheese',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Smileton The Big Cheese Piercing Missile',
    type: 'StartsUsing',
    netRegex: {
      id: '6751',
      source: 'The Big Cheese'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Smileton The Big Cheese Leveling Missile',
    type: 'StartsUsing',
    netRegex: {
      id: '6755',
      source: 'The Big Cheese'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Smileton The Big Cheese Electric Arc',
    type: 'StartsUsing',
    netRegex: {
      id: '6753',
      source: 'The Big Cheese'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Left Disassembler/Right Disassembler': 'Left/Right Disassembler'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      '(?<!Excavation )Bomb': 'Bombe',
      'Excavation Bomb': 'Sprengladung',
      '(?<!Small )Face': 'Fratze',
      'Frameworker': 'Rahmenwerker',
      'Printed Worker': 'Druckwerker',
      'Relatively Small Face': 'Klein(?:e|er|es|en) Fratze',
      'Smileport': 'Tor des Breiten Lächelns',
      'The Big Cheese': 'Bittelächeln',
      'The Frame': 'Hauptrahmen',
      'The Welcome Wheel': 'Herzlich-Willkommen-Halle'
    },
    'replaceText': {
      'Circular Saw': 'Rundstreich',
      'Dispense Explosives': 'Schusslegung',
      'Electric Arc': 'Elektrischer Bogen',
      'Excavated': 'Schusssprengung',
      'Explosive Power': 'Schusszündung',
      'Explosives Distribution': 'Bombenladung',
      'Heart on Fire IV': 'Flackerndes Feuka',
      'Iron Kiss': 'Eiserner Kuss',
      'Leap Forward': 'Vorwärtssprung',
      'Left Disassembler': 'Linker Demontier-Arm',
      'Leveling Missile': 'Planierrakete',
      'Lines of Fire': 'Kommando Feuer',
      'Mixed Feelings': 'Fluch des Fressens',
      'Off My Lawn': 'Hinausdrängen',
      'Omnidimensional Onslaught': 'Omnidimensionale Offensive',
      'Piercing Missile': 'Förderrakete',
      'Print Workers': 'Werkerdruck',
      'Right Disassembler': 'Rechter Demontier-Arm',
      'Steel Beam': 'Frontalstreich',
      'Temper\'s Flare': 'Flackerndes Flare',
      'Temper, Temper': 'Flackernde Flamme',
      'Upside Down': 'Kommando Drehen',
      'Violent Discharge': 'Heftige Entladung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '(?<!Excavation )Bomb': 'bombe',
      'Excavation Bomb': 'mine de forage',
      '(?<!Small )Face': 'Visage Imperturbable',
      'Frameworker': 'ouvrier modeleur',
      'Printed Worker': 'ouvrier manufacturé',
      'Relatively Small Face': 'Visage Changeant',
      'Smileport': 'Porte de la Gaieté',
      'The Big Cheese': 'Béatotron',
      'The Frame': 'Matrice du Bonheur',
      'The Welcome Wheel': 'Place de l\'Hospitalité'
    },
    'replaceText': {
      'Circular Saw': 'Assaut tailladant omnidirectionnel',
      'Dispense Explosives': 'Explosifs de forage',
      'Electric Arc': 'Arc électrique',
      'Excavated': 'Mine de forage',
      'Explosive Power': 'Pose de mines de forage',
      'Explosives Distribution': 'Distributeur de charges explosives',
      'Heart on Fire IV': 'Giga Feu crépitant',
      'Iron Kiss': 'Charge explosive',
      'Leap Forward': 'Assaut plongeant avant',
      'Left Disassembler/Right Disassembler': 'Atomiseur gauche/droit',
      'Leveling Missile': 'Missile de nivellement',
      'Lines of Fire': 'Extériorisation',
      'Mixed Feelings': 'Humeur instable',
      'Off My Lawn': 'Bourrade amicale',
      'Omnidimensional Onslaught': 'Assaut omnidirectionnel en deux temps',
      'Piercing Missile': 'Missiles foreurs',
      'Print Workers': 'Manufacture d\'ouvrier',
      'Steel Beam': 'Assaut tailladant avant',
      'Temper\'s Flare': 'Brasier crépitant',
      'Temper, Temper': 'Flammes crépitantes',
      'Upside Down': 'Saute d\'humeur',
      'Violent Discharge': 'Décharge forcée'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      '(?<!Excavation )Bomb': '爆弾',
      'Excavation Bomb': '採掘爆弾',
      '(?<!Small )Face': 'フェイス',
      'Frameworker': 'フレームワーカー',
      'Printed Worker': 'プリンテッドワーカー',
      'Relatively Small Face': 'リトルフェイス',
      'Smileport': '笑顔あふれる正門',
      'The Big Cheese': 'ビッグチーズ',
      'The Frame': 'ビッグチーズ',
      'The Welcome Wheel': '大歓迎の玄関'
    },
    'replaceText': {
      'Circular Saw': '全体斬攻撃',
      'Dispense Explosives': '採掘爆弾設置',
      'Electric Arc': 'アーク放電',
      'Excavated': '採掘爆弾爆発',
      'Explosive Power': '採掘爆弾起爆',
      'Explosives Distribution': '爆弾供給',
      'Heart on Fire IV': 'メラメラファイジャ',
      'Iron Kiss': '着弾',
      'Leap Forward': '前方跳躍攻撃',
      'Left Disassembler': '左腕分解砲',
      'Leveling Missile': '整地ミサイル',
      'Lines of Fire': '斉射の号令',
      'Mixed Feelings': 'ペロペロの呪い',
      'Off My Lawn': '押し出し',
      'Omnidimensional Onslaught': '連続多方向攻撃',
      'Piercing Missile': '採掘ミサイル',
      'Print Workers': 'ワーカー・プリントアウト',
      'Right Disassembler': '右腕分解砲',
      'Steel Beam': '前方斬攻撃',
      'Temper\'s Flare': 'メラメラフレア',
      'Temper, Temper': 'メラメラフレイム',
      'Upside Down': '回転の号令',
      'Violent Discharge': '強制放電'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '(?<!Excavation )Bomb': '炸弹',
      'Excavation Bomb': '采掘炸弹',
      '(?<!Small )Face': '面像',
      'Frameworker': '框架工作员',
      'Printed Worker': '打印出的工作员',
      'Relatively Small Face': '小面像',
      'Smileport': '面带微笑的正门',
      'The Big Cheese': '大笑脸',
      'The Frame': '大笑脸',
      'The Welcome Wheel': '热烈欢迎的门厅'
    },
    'replaceText': {
      'Circular Saw': '全体斩击',
      'Dispense Explosives': '设置采掘炸弹',
      'Electric Arc': '弧状放电',
      'Excavated': '采掘炸弹爆炸',
      'Explosive Power': '引爆采掘炸弹',
      'Explosives Distribution': '炸弹供给',
      'Heart on Fire IV': '熊熊炽炎',
      'Iron Kiss': '钢铁之吻',
      'Leap Forward': '前方跃进攻击',
      'Left Disassembler': '左腕分解炮',
      'Leveling Missile': '整地导弹',
      'Lines of Fire': '齐射号令',
      'Mixed Feelings': '喜怒无常',
      'Off My Lawn': '击退',
      'Omnidimensional Onslaught': '连续多方向攻击',
      'Piercing Missile': '采掘导弹',
      'Print Workers': '生成工作员',
      'Right Disassembler': '右腕分解炮',
      'Steel Beam': '前方斩击',
      'Temper\'s Flare': '熊熊核爆',
      'Temper, Temper': '熊熊烈焰',
      'Upside Down': '回旋号令',
      'Violent Discharge': '强制放电'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Excavation Bomb': '채굴 폭탄',
      'Frameworker': '프레임워커',
      'Printed Worker': '출력된 워커',
      'Relatively Small Face': '작은 얼굴',
      'Smileport': '웃음이 넘치는 정문',
      'The Big Cheese': '빅치즈',
      'The Frame': '빅치즈',
      'The Welcome Wheel': '대환영 현관',
      '(?<!Excavation )Bomb': '폭탄',
      '(?<!Small )Face': '얼굴'
    },
    'replaceText': {
      'Circular Saw': '전체 베기 공격',
      'Dispense Explosives': '채굴 폭탄 설치',
      'Electric Arc': '아크 방전',
      'Excavated': '채굴 폭탄 폭발',
      'Explosive Power': '채굴 폭탄 기폭',
      'Explosives Distribution': '폭탄 공급',
      'Heart on Fire IV': '이글이글 파이쟈',
      'Iron Kiss': '착탄',
      'Leap Forward': '전방 도약 공격',
      'Left Disassembler': '왼팔 분해포',
      'Leveling Missile': '땅고르기 미사일',
      'Lines of Fire': '일제 사격 호령',
      'Mixed Feelings': '메롱메롱 저주',
      'Off My Lawn': '밀치기',
      'Omnidimensional Onslaught': '연속 다방향 공격',
      'Piercing Missile': '채굴 미사일',
      'Print Workers': '워커 출력',
      'Right Disassembler': '오른팔 분해포',
      'Steel Beam': '전방 베기 공격',
      'Temper\'s Flare': '이글이글 플레어',
      'Temper, Temper': '이글이글 플레임',
      'Upside Down': '회전 호령',
      'Violent Discharge': '강제 방전'
    }
  }]
};
/* harmony default export */ const smileton = (smileton_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/smileton.txt
const dungeon_smileton_namespaceObject = "### Smileton\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~#\r\n# FACE #\r\n#~~~~~~#\r\n\r\n# -p 6735:1009\r\n# -ii 6741 6736 6737 6C5E 673A 673B 673C 673D\r\n\r\n# Smileport will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"EBE\" } window 10000,0\r\n1009.0 \"Lines of Fire\" Ability { id: \"6735\", source: \"Face\" }\r\n1018.1 \"Mixed Feelings\" Ability { id: \"6738\", source: \"Face\" }\r\n1023.2 \"Lines of Fire\" Ability { id: \"6735\", source: \"Face\" }\r\n1032.3 \"Mixed Feelings\" Ability { id: \"6738\", source: \"Face\" }\r\n1043.4 \"Off My Lawn\" Ability { id: \"673E\", source: \"Face\" }\r\n1044.4 \"Temper, Temper\" Ability { id: \"6740\", source: \"Face\" }\r\n1054.6 \"Temper's Flare\" Ability { id: \"6743\", source: \"Face\" }\r\n\r\n1063.8 \"Upside Down\" Ability { id: \"6739\", source: \"Face\" }\r\n1072.0 \"Lines of Fire\" Ability { id: \"6735\", source: \"Face\" }\r\n1079.1 \"Off My Lawn\" Ability { id: \"673E\", source: \"Face\" }\r\n1081.1 \"Mixed Feelings\" Ability { id: \"6738\", source: \"Face\" }\r\n1091.3 \"Upside Down\" Ability { id: \"6739\", source: \"Face\" }\r\n1099.5 \"Lines of Fire\" Ability { id: \"6735\", source: \"Face\" }\r\n\r\n1106.7 \"Temper, Temper\" Ability { id: \"6740\", source: \"Face\" }\r\n1108.7 \"Mixed Feelings\" Ability { id: \"6738\", source: \"Face\" }\r\n1112.7 \"Lines of Fire\" Ability { id: \"6735\", source: \"Face\" }\r\n1119.8 \"Off My Lawn\" Ability { id: \"673E\", source: \"Face\" }\r\n1121.8 \"Mixed Feelings\" Ability { id: \"6738\", source: \"Face\" }\r\n1133.0 \"Heart on Fire IV\" Ability { id: \"6742\", source: \"Face\" }\r\n1140.2 \"Temper's Flare\" Ability { id: \"6743\", source: \"Face\" }\r\n\r\n# TODO: Guessing at the loop here.  1158.6 is the latest seen in an actual log.\r\n1150.4 \"Upside Down\" Ability { id: \"6739\", source: \"Face\" } window 50,50 jump 1063.8\r\n1158.6 \"Lines of Fire\" #Ability { id: \"6735\", source: \"Face\" }\r\n# guessing below here\r\n1165.7 \"Off My Lawn\" #Ability { id: \"673E\", source: \"Face\" }\r\n1167.7 \"Mixed Feelings\" #Ability { id: \"6738\", source: \"Face\" }\r\n1177.9 \"Upside Down\" #Ability { id: \"6739\", source: \"Face\" }\r\n1186.1 \"Lines of Fire\" #Ability { id: \"6735\", source: \"Face\" }\r\n\r\n\r\n#~~~~~~~~~~~~~#\r\n# FRAMEWORKER #\r\n#~~~~~~~~~~~~~#\r\n\r\n # -p 6745:2011\r\n # -ii 6749 674B\r\n\r\n# The Welcome Wheel will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"EBF\" } window 10000,0\r\n2011.0 \"Circular Saw\" Ability { id: \"6745\", source: \"Frameworker\" }\r\n2017.6 \"--sync--\" Ability { id: \"674A\", source: \"Frameworker\" }\r\n2022.8 \"Leap Forward\" Ability { id: \"6746\", source: \"Frameworker\" }\r\n\r\n2032.0 \"Print Workers\" Ability { id: \"6DBC\", source: \"Frameworker\" }\r\n2044.2 \"Leap Forward\" Ability { id: \"6747\", source: \"Printed Worker\" }\r\n2059.2 \"Omnidimensional Onslaught\" Ability { id: \"6748\", source: \"Frameworker\" }\r\n2070.4 \"Print Workers\" Ability { id: \"6DBC\", source: \"Frameworker\" }\r\n2082.1 \"Leap Forward\" Ability { id: \"6747\", source: \"Printed Worker\" }\r\n2095.6 \"Print Workers\" Ability { id: \"6DBC\", source: \"Frameworker\" }\r\n2107.3 \"Leap Forward\" Ability { id: \"6747\", source: \"Printed Worker\" }\r\n2112.0 \"Leap Forward\" Ability { id: \"6746\", source: \"Frameworker\" }\r\n\r\n2122.2 \"Print Workers\" Ability { id: \"6DBC\", source: \"Frameworker\" }\r\n2133.9 \"Leap Forward\" Ability { id: \"6747\", source: \"Printed Worker\" }\r\n2136.4 \"Omnidimensional Onslaught\" Ability { id: \"6748\", source: \"Frameworker\" }\r\n2140.6 \"Steel Beam\" Ability { id: \"6744\", source: \"Frameworker\" }\r\n# ???\r\n\r\n#~~~~~~~~~~~~~~~~#\r\n# THE BIG CHEESE #\r\n#~~~~~~~~~~~~~~~~#\r\n\r\n# -p 674E:3009\r\n# -ii 674C 6755\r\n\r\n# The Frame will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"EC0\" } window 10000,0\r\n3009.0 \"Explosives Distribution\" Ability { id: \"674E\", source: \"The Big Cheese\" }\r\n3022.2 \"Iron Kiss\" Ability { id: \"674D\", source: \"Bomb\" }\r\n3028.2 \"Piercing Missile\" Ability { id: \"6751\", source: \"The Big Cheese\" }\r\n3036.4 \"Dispense Explosives\" Ability { id: \"6C30\", source: \"The Big Cheese\" }\r\n3037.6 \"--sync--\" Ability { id: \"6C34\", source: \"Excavation Bomb\" }\r\n3041.6 \"Explosives Distribution\" Ability { id: \"674E\", source: \"The Big Cheese\" }\r\n3054.8 \"Iron Kiss\" Ability { id: \"674D\", source: \"Bomb\" }\r\n3058.8 \"Explosive Power\" Ability { id: \"6C31\", source: \"The Big Cheese\" }\r\n3060.0 \"Excavated\" Ability { id: \"6C32\", source: \"Excavation Bomb\" }\r\n3064.0 \"Explosives Distribution\" Ability { id: \"674E\", source: \"The Big Cheese\" }\r\n\r\n3077.1 \"Left Disassembler/Right Disassembler\" Ability { id: [\"674F\", \"6750\"], source: \"The Big Cheese\" }\r\n3077.1 \"Iron Kiss\" Ability { id: \"674D\", source: \"Bomb\" }\r\n3086.2 \"Dispense Explosives\" Ability { id: \"6C30\", source: \"The Big Cheese\" }\r\n3087.4 \"--sync--\" Ability { id: \"6C34\", source: \"Excavation Bomb\" }\r\n3091.4 \"Explosives Distribution\" Ability { id: \"674E\", source: \"The Big Cheese\" }\r\n3104.6 \"Iron Kiss\" Ability { id: \"674D\", source: \"Bomb\" }\r\n3108.6 \"Electric Arc\" Ability { id: \"6753\", source: \"The Big Cheese\" }\r\n3121.2 \"Iron Kiss\" Ability { id: \"674D\", source: \"Bomb\" }\r\n\r\n3124.7 \"Left Disassembler/Right Disassembler\" Ability { id: [\"674F\", \"6750\"], source: \"The Big Cheese\" }\r\n3137.8 \"Iron Kiss\" Ability { id: \"674D\", source: \"Bomb\" }\r\n3141.9 \"Leveling Missile\" Ability { id: \"6754\", source: \"The Big Cheese\" }\r\n3147.0 \"Explosive Power\" Ability { id: \"6C31\", source: \"The Big Cheese\" }\r\n3148.2 \"Excavated\" Ability { id: \"6C32\", source: \"Excavation Bomb\" }\r\n3158.2 \"Piercing Missile\" Ability { id: \"6751\", source: \"The Big Cheese\" }\r\n3165.3 \"Violent Discharge\" Ability { id: \"6752\", source: \"The Big Cheese\" }\r\n3173.4 \"Explosives Distribution\" Ability { id: \"674E\", source: \"The Big Cheese\" }\r\n\r\n3186.5 \"Left Disassembler/Right Disassembler\" Ability { id: [\"674F\", \"6750\"], source: \"The Big Cheese\" }\r\n3186.5 \"Iron Kiss\" Ability { id: \"674D\", source: \"Bomb\" }\r\n3196.6 \"Dispense Explosives\" Ability { id: \"6C30\", source: \"The Big Cheese\" }\r\n3197.8 \"--sync--\" Ability { id: \"6C34\", source: \"Excavation Bomb\" }\r\n3201.8 \"Explosives Distribution\" Ability { id: \"674E\", source: \"The Big Cheese\" }\r\n3215.0 \"Iron Kiss\" Ability { id: \"674D\", source: \"Bomb\" }\r\n3219.0 \"Electric Arc\" Ability { id: \"6753\", source: \"The Big Cheese\" }\r\n3231.6 \"Iron Kiss\" Ability { id: \"674D\", source: \"Bomb\" }\r\n3234.5 \"Excavated\" Ability { id: \"6C32\", source: \"Excavation Bomb\" }\r\n\r\n3235.1 \"Left Disassembler/Right Disassembler\" Ability { id: [\"674F\", \"6750\"], source: \"The Big Cheese\" } window 30,30 jump 3124.7\r\n3248.3 \"Iron Kiss\" #Ability { id: \"674D\", source: \"Bomb\" }\r\n3252.3 \"Leveling Missile\" #Ability { id: \"6754\", source: \"The Big Cheese\" }\r\n3257.4 \"Explosive Power\" #Ability { id: \"6C31\", source: \"The Big Cheese\" }\r\n3258.6 \"Excavated\" #Ability { id: \"6C32\", source: \"Excavation Bomb\" }\r\n3268.6 \"Piercing Missile\" #Ability { id: \"6751\", source: \"The Big Cheese\" }\r\n3275.7 \"Violent Discharge\" #Ability { id: \"6752\", source: \"The Big Cheese\" }\r\n3283.8 \"Explosives Distribution\" #Ability { id: \"674E\", source: \"The Big Cheese\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/stigma_dreamscape.ts





// TODO: Does Mustard Bomb cleave? Should it be tankCleave() instead?

const limitCutNumberMap = {
  '004F': 1,
  '0050': 2,
  '0051': 3,
  '0052': 4
};
const stigma_dreamscape_triggerSet = {
  id: 'TheStigmaDreamscape',
  zoneId: zone_id/* default.TheStigmaDreamscape */.Z.TheStigmaDreamscape,
  timelineFile: 'stigma_dreamscape.txt',
  initData: () => {
    return {
      lastBoss: false
    };
  },
  triggers: [{
    id: 'Dreamscape Side Cannons Left',
    type: 'StartsUsing',
    netRegex: {
      id: '6320',
      source: 'Proto-Omega',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Dreamscape Side Cannons Right',
    type: 'StartsUsing',
    netRegex: {
      id: '6321',
      source: 'Proto-Omega',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Dreamscape Forward Interceptors',
    type: 'StartsUsing',
    netRegex: {
      id: '6322',
      source: 'Proto-Omega',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Dreamscape Rear Interceptors',
    type: 'StartsUsing',
    netRegex: {
      id: '6324',
      source: 'Proto-Omega',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go front of boss',
        de: 'Geh vor den Boss',
        fr: 'Allez devant le boss',
        ja: 'ボスの前に',
        cn: '去boss前面',
        ko: '보스 앞으로'
      }
    }
  }, {
    id: 'Dreamscape Chemical Missile',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Dreamscape Electric Slide',
    type: 'HeadMarker',
    netRegex: {
      id: '0121'
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.target();
      return output.allies({
        target: matches.target
      });
    },
    outputStrings: {
      target: {
        en: 'Stack + Knockback on YOU!',
        de: 'Sammeln + Rückstoß auf DIR!',
        fr: 'Package + Poussée sur VOUS !',
        ja: '頭割り + ノックバック',
        cn: '分摊 + 击退点名',
        ko: '나에게 쉐어 + 넉백!'
      },
      allies: {
        en: 'Stack + knockback on ${target}',
        de: 'Sammeln + Rückstoß auf ${target}',
        fr: 'Package + Poussée sur ${target}',
        ja: '${target} に頭割り + ノックバック',
        cn: '分摊 + 击退点名 ${target}',
        ko: '쉐어 + 넉백: ${target}'
      }
    }
  }, {
    id: 'Dreamscape Guided Missile',
    type: 'Tether',
    netRegex: {
      id: '0011'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Guided Missile on YOU',
        de: 'Geführte Rakete auf DIR',
        fr: 'Missile guidé sur VOUS',
        ja: '誘導ミサイル',
        cn: '导弹点名',
        ko: '나에게 유도 미사일'
      }
    }
  }, {
    id: 'Dreamscape Mustard Bomb',
    type: 'StartsUsing',
    netRegex: {
      id: '632B',
      source: 'Proto-Omega'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Dreamscape Assault Cannon',
    type: 'StartsUsing',
    netRegex: {
      id: '63AB',
      source: 'Arch-Lambda',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get to wall at last dash',
        de: 'Geh zur Wand des letzten Ansturms',
        fr: 'Allez vers le mur après la dernière ruée',
        ja: '最後の突進先に移動',
        cn: '靠近最后一次冲锋终点的墙壁',
        ko: '마지막 돌진지점 맵 끝으로'
      }
    }
  }, {
    id: 'Dreamscape Sniper Cannon',
    type: 'HeadMarker',
    netRegex: {
      id: ['004F', '0050', '0051', '0052']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, matches, output) => {
      const limitCutNumber = limitCutNumberMap[matches.id];
      return output.text({
        num: limitCutNumber
      });
    },
    outputStrings: {
      text: {
        en: '#${num} laser on YOU!',
        de: '#${num} Laser auf DIR!',
        fr: '#${num} Laser sur VOUS !',
        ja: 'レーザー: #${num} 番',
        cn: '激光点名 #${num}',
        ko: '레이저: ${num}번'
      }
    }
  }, {
    id: 'Dreamscape Wheel',
    type: 'StartsUsing',
    netRegex: {
      id: '63B5',
      source: 'Arch-Lambda'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    // Dragons spawn outside the last boss, but those ones don't matter.
    // Ensure that we don't say anything until the player has engaged the last boss.
    // 6435 is Plasmafodder, Stigma-4's auto-attack.
    id: 'Dreamscape Last Boss',
    type: 'Ability',
    netRegex: {
      id: '6435',
      source: 'Stigma-4',
      capture: false
    },
    run: data => data.lastBoss = true
  }, {
    id: 'Dreamscape Atomic Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '63B4',
      source: 'Arch-Lambda',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // The Hybrid Dragon add uses Touchdown after spawning,
    // then immediately begins casting Fire Breath in a cone across the arena.
    // If the player is not already in motion by the time Fire Breath begins,
    // they are likely to be hit.
    id: 'Dreamscape Touchdown',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Hybrid Dragon'
    },
    condition: data => data.lastBoss,
    infoText: (_data, matches, output) => {
      // The arena is a 50x50 square, with (0,0) in the exact center.
      const isEast = parseFloat(matches.x) > 0;
      if (isEast) return output.east();
      return output.west();
    },
    outputStrings: {
      east: outputs/* default.east */.Z.east,
      west: outputs/* default.west */.Z.west
    }
  }, {
    id: 'Dreamscape Rush',
    type: 'StartsUsing',
    netRegex: {
      id: '642D',
      source: 'Proto-rocket Punch',
      capture: false
    },
    suppressSeconds: 5,
    // All five Punches use it at the same time
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid side dashes',
        de: 'Weiche den Anstürmen von der Seite aus',
        fr: 'Évitez les ruées sur les côtés',
        ja: '左右のロケットパンチを避ける',
        cn: '躲避两侧冲锋',
        ko: '옆쪽 로켓 주먹 피하기'
      }
    }
  }, {
    id: 'Dreamscape Electromagnetic Release Circle',
    type: 'StartsUsing',
    netRegex: {
      id: '6434',
      source: 'Stigma-4'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 4,
    // Full cast is 9.7s.
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Dreamscape Electromagnetic Release Donut',
    type: 'StartsUsing',
    netRegex: {
      id: '6432',
      source: 'Stigma-4'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 4,
    // Full cast is 9.7s.
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Dreamscape Proto-wave Cannons Left',
    type: 'StartsUsing',
    netRegex: {
      id: '642A',
      source: 'Omega Frame',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Dreamscape Proto-wave Cannons Right',
    type: 'StartsUsing',
    netRegex: {
      id: '642B',
      source: 'Omega Frame',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Dreamscape Forward March',
    type: 'GainsEffect',
    netRegex: {
      effectId: '7A6'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mindhack: Forward',
        de: 'Geistlenkung: Vorwärts',
        fr: 'Piratage mental : Vers l\'avant',
        ja: '強制移動 : 前',
        cn: '强制移动 : 前',
        ko: '강제이동: 앞'
      }
    }
  }, {
    id: 'Dreamscape About Face',
    type: 'GainsEffect',
    netRegex: {
      effectId: '7A7'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mindhack: Back',
        de: 'Geistlenkung: Rückwärts',
        fr: 'Piratage mental : Vers l\'arrière',
        ja: '強制移動 : 後ろ',
        cn: '强制移动 : 后',
        ko: '강제이동: 뒤'
      }
    }
  }, {
    id: 'Dreamscape Left Face',
    type: 'GainsEffect',
    netRegex: {
      effectId: '7A8'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mindhack: Left',
        de: 'Geistlenkung: Links',
        fr: 'Piratage mental : Vers la gauche',
        ja: '強制移動 : 左',
        cn: '强制移动 : 左',
        ko: '강제이동: 왼쪽'
      }
    }
  }, {
    id: 'Dreamscape Right Face',
    type: 'GainsEffect',
    netRegex: {
      effectId: '7A9'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Mindhack: Right',
        de: 'Geistlenkung: Rechts',
        fr: 'Piratage mental : Vers la droite',
        ja: '強制移動 : 右',
        cn: '强制移动 : 右',
        ko: '강제이동: 오른쪽'
      }
    }
  }, {
    id: 'Dreamscape Atomic Ray',
    type: 'StartsUsing',
    netRegex: {
      id: '6436',
      source: 'Stigma-4',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'A-4 Command': 'Kommando A4',
      'A-4 Conquest': 'Operation A4',
      'A-4 Headquarters': 'Hauptquartier A4',
      'Arch-Lambda': 'Erz-Lambda',
      'Hybrid Dragon': 'Hybrid-Drache',
      'Mark II Guided Missile': 'Lenkrakete II',
      'Omega Frame': 'Omega-Chassis',
      'Proto-Omega': 'Proto-Omega',
      'Proto-rocket Punch': 'Proto-Raketenschlag',
      'Stigma-4': 'Stigma-4'
    },
    'replaceText': {
      '(?<!Multi-)AI Takeover': 'Plan B',
      'Atomic Flame': 'Atomare Flamme',
      'Atomic Ray': 'Atomstrahlung',
      'Auto-mobile Assault Cannon': 'Wellengeschütz „Sturm”',
      'Auto-mobile Sniper Cannon': 'Wellengeschütz „Pfeil”',
      'Burn': 'Verbrennung',
      'Chemical Missile': 'Napalmrakete',
      'Electric Slide': 'Elektrosturz',
      'Electromagnetic Release': 'Elektromagnetische Entladung',
      'Entrench': 'Manöver „Sturm”',
      'Fire Breath': 'Feueratem',
      'Forward Interceptors': 'Frontale Abfangrakete',
      'Guided Missile': 'Lenkraketen',
      'Iron Kiss': 'Eiserner Kuss',
      'Mindhack': 'Hirnsonde',
      'Multi-AI Takeover': 'Gebündelte Kräfte',
      'Mustard Bomb': 'Senfbombe',
      'Proto-wave Cannon': 'Experimentelles Wellengeschütz',
      'Rear Interceptors': 'Rückwärtige Abfangrakete',
      'Rush': 'Stürmen',
      'Self-Destruct': 'Selbstzerstörung',
      'Side Cannons': 'Seitliche Maschinenkanone',
      'Touchdown': 'Aufsetzer',
      'Tread': 'Angriffsmanöver Alpha',
      '(?<!Proto-)Wave Cannon': 'Wellengeschütz',
      'Wheel': 'Rad'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'A-4 Command': 'Poste de commandement A-4',
      'A-4 Conquest': 'Conquête A-4',
      'A-4 Headquarters': 'Quartier général A-4',
      'Arch-Lambda': 'Arch-Lambda',
      'Hybrid Dragon': 'dragon hybride',
      'Mark II Guided Missile': 'missile autoguidé v2',
      'Omega Frame': 'châssis expérimental Oméga',
      'Proto-Omega': 'Proto-Oméga',
      'Proto-rocket Punch': 'proto-astéropoing',
      'Stigma-4': 'Stigma-4'
    },
    'replaceText': {
      '\\?': ' ?',
      '(?<!Multi-)AI Takeover': 'Appel de renforts',
      'Atomic Flame': 'Flammes atomiques',
      'Atomic Ray': 'Rayon atomique',
      'Auto-mobile Assault Cannon': 'Assaut plasmique',
      'Auto-mobile Sniper Cannon': 'Canon plasma longue portée',
      'Burn': 'Combustion',
      'Chemical Missile': 'Missile au napalm',
      'Electric Slide': 'Glissement Oméga',
      'Electromagnetic Release': 'Décharge électromagnétique',
      'Entrench': 'Manœuvre d\'assaut violent',
      'Fire Breath': 'Souffle enflammé',
      'Forward Interceptors': 'Contre-salve avant',
      'Guided Missile': 'Missile à tête chercheuse',
      'Iron Kiss': 'Impact de missile',
      'Mindhack': 'Piratage mental',
      'Multi-AI Takeover': 'Appel de renforts polyvalents',
      'Mustard Bomb': 'Obus d\'ypérite',
      'Proto-wave Cannon': 'Canon plasma expérimental',
      'Rear Interceptors': 'Contre-salve arrière',
      'Rush': 'Ruée',
      'Self-Destruct': 'Auto-destruction',
      'Side Cannons': 'Salve d\'obus latérale',
      'Touchdown': 'Atterrissage',
      'Tread': 'Manœuvre d\'assaut',
      '(?<!Proto-)Wave Cannon': 'Canon plasma',
      'Wheel': 'Roue'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'A-4 Command': 'コマンドA4',
      'A-4 Conquest': 'コンクエストA4',
      'A-4 Headquarters': 'ヘッドクォーターA4',
      'Arch-Lambda': 'アーチラムダ',
      'Hybrid Dragon': 'ハイブリッドドラゴン',
      'Mark II Guided Missile': 'ガイデッドミサイルII',
      'Omega Frame': 'オメガフレーム',
      'Proto-Omega': 'プロトオメガ',
      'Proto-rocket Punch': 'プロトロケットパンチ',
      'Stigma-4': 'スティグマ・フォー'
    },
    'replaceText': {
      '(?<!Multi-)AI Takeover': '支援要請',
      'Atomic Flame': 'アトミックフレイム',
      'Atomic Ray': 'アトミックレイ',
      'Auto-mobile Assault Cannon': '強襲式波動砲',
      'Auto-mobile Sniper Cannon': '狙撃式波動砲',
      'Burn': '燃焼',
      'Chemical Missile': 'ナパームミサイル',
      'Electric Slide': 'オメガスライド',
      'Electromagnetic Release': '電磁放射',
      'Entrench': '強襲機動',
      'Fire Breath': 'ファイアブレス',
      'Forward Interceptors': '前方迎撃ロケット',
      'Guided Missile': '誘導ミサイル',
      'Iron Kiss': '着弾',
      'Mindhack': 'ブレインハック',
      'Multi-AI Takeover': '複合支援要請',
      'Mustard Bomb': 'マスタードボム',
      'Proto-wave Cannon': '試作型波動砲',
      'Rear Interceptors': '後方迎撃ロケット',
      'Rush': '突進',
      'Self-Destruct': '自爆',
      'Side Cannons': '側面機関砲',
      'Touchdown': 'タッチダウン',
      'Tread': '突撃機動',
      '(?<!Proto-)Wave Cannon': '波動砲',
      'Wheel': 'ホイール'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'A-4 Command': 'A4指挥部',
      'A-4 Conquest': 'A4占领地',
      'A-4 Headquarters': 'A4司令部',
      'Arch-Lambda': '拉姆达总领',
      'Hybrid Dragon': '改造龙族',
      'Mark II Guided Missile': '二型制导导弹',
      'Omega Frame': '欧米茄框架',
      'Proto-Omega': '欧米茄原型',
      'Proto-rocket Punch': '原型火箭飞拳',
      'Stigma-4': '斯提格玛四'
    },
    'replaceText': {
      '(?<!Multi-)AI Takeover': '请求支援',
      'Atomic Flame': '原子烈火',
      'Atomic Ray': '原子射线',
      'Auto-mobile Assault Cannon': '强袭式波动炮',
      'Auto-mobile Sniper Cannon': '狙击式波动炮',
      'Burn': '燃烧',
      'Chemical Missile': '汽油导弹',
      'Electric Slide': '欧米茄滑跃',
      'Electromagnetic Release': '电磁放射',
      'Entrench': '强袭机动',
      'Fire Breath': '火焰吐息',
      'Forward Interceptors': '前方迎击火箭',
      'Guided Missile': '追踪导弹',
      'Iron Kiss': '钢铁之吻',
      'Mindhack': '精神入侵',
      'Multi-AI Takeover': '请求综合支援',
      'Mustard Bomb': '芥末爆弹',
      'Proto-wave Cannon': '试验型波动炮',
      'Rear Interceptors': '后方迎击火箭',
      'Rush': '突进',
      'Self-Destruct': '自爆',
      'Side Cannons': '侧面机关炮',
      'Touchdown': '空降',
      'Tread': '突击机动',
      '(?<!Proto-)Wave Cannon': '波动炮',
      'Wheel': '车轮'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'A-4 Command': '지휘소-A4',
      'A-4 Conquest': '점령지-A4',
      'A-4 Headquarters': '사령부-A4',
      'Arch-Lambda': '아치 람다',
      'Hybrid Dragon': '혼종 드래곤',
      'Mark II Guided Missile': '유도 미사일 II',
      'Omega Frame': '오메가 프레임',
      'Proto-Omega': '프로토 오메가',
      'Proto-rocket Punch': '프로토 로켓 주먹',
      'Stigma-4': '스티그마-4'
    },
    'replaceText': {
      'Atomic Flame': '원자 화염',
      'Atomic Ray': '원자 파동',
      'Auto-mobile Assault Cannon': '강습식 파동포',
      'Auto-mobile Sniper Cannon': '저격식 파동포',
      'Burn': '연소',
      'Chemical Missile': '네이팜 미사일',
      'Electric Slide': '오메가 슬라이드',
      'Electromagnetic Release': '전자기 방사',
      'Entrench': '강습기동',
      'Fire Breath': '화염 숨결',
      'Forward Interceptors': '전방 요격 로켓',
      'Guided Missile': '유도 미사일',
      'Iron Kiss': '착탄',
      'Mindhack': '두뇌 침입',
      'Multi-AI Takeover': '복합 지원 요청',
      'Mustard Bomb': '겨자 폭탄',
      'Proto-wave Cannon': '시험형 파동포',
      'Rear Interceptors': '후방 요격 로켓',
      'Rush': '돌진',
      'Self-Destruct': '자폭',
      'Side Cannons': '측면 기관포',
      'Touchdown': '착지',
      'Tread': '돌격기동',
      'Wheel': '바퀴',
      '(?<!Proto-)Wave Cannon': '파동포',
      '(?<!Multi-)AI Takeover': '지원 요청'
    }
  }]
};
/* harmony default export */ const stigma_dreamscape = (stigma_dreamscape_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/stigma_dreamscape.txt
const dungeon_stigma_dreamscape_namespaceObject = "### Stigma Dreamscape\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n\r\n#~~~~~~~~~~~~~#\r\n# PROTO-OMEGA #\r\n#~~~~~~~~~~~~~#\r\n\r\n# A-4 Command will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"ECF\" } window 0,1\r\n12.6 \"Side Cannons\" Ability { id: [\"6320\", \"6321\"], source: \"Proto-Omega\" } window 12.6,10\r\n24.2 \"Forward Interceptors/Rear Interceptors\" Ability { id: [\"6322\", \"6324\"], source: \"Proto-Omega\" }\r\n29.3 \"Chemical Missile\" Ability { id: \"6328\", source: \"Proto-Omega\" }\r\n34.4 \"Burn\" Ability { id: \"6329\", source: \"Proto-Omega\" }\r\n40.6 \"Electric Slide\" Ability { id: \"632A\", source: \"Proto-Omega\" } window 30,30\r\n49.7 \"Guided Missile\" Ability { id: \"6326\", source: \"Proto-Omega\" }\r\n\r\n65.6 \"Iron Kiss\" Ability { id: \"6327\", source: \"Mark II Guided Missile\" }\r\n73.0 \"Electric Slide\" Ability { id: \"632A\", source: \"Proto-Omega\" }\r\n84.2 \"Mustard Bomb\" Ability { id: \"632B\", source: \"Proto-Omega\" }\r\n96.4 \"Side Cannons\" Ability { id: [\"6320\", \"6321\"], source: \"Proto-Omega\" } window 10,10\r\n104.6 \"Guided Missile\" Ability { id: \"6326\", source: \"Proto-Omega\" }\r\n111.7 \"Chemical Missile\" Ability { id: \"6328\", source: \"Proto-Omega\" }\r\n116.8 \"Burn\" Ability { id: \"6329\", source: \"Proto-Omega\" }\r\n\r\n# TODO This is likely inaccurate, but it's all we have.\r\n# More data is needed.\r\n120.4 \"Iron Kiss\" Ability { id: \"6327\", source: \"Mark II Guided Missile\" } jump 65.6\r\n127.8 \"Electric Slide\"\r\n139.0 \"Mustard Bomb\"\r\n151.2 \"Side Cannons\"\r\n159.4 \"Guided Missile\"\r\n166.5 \"Chemical Missile\"\r\n171.6 \"Burn\"\r\n\r\n#~~~~~~~~~~~~~#\r\n# ARCH-LAMBDA #\r\n#~~~~~~~~~~~~~#\r\n\r\n# -ii 368 63AE 63B2\r\n\r\n# A-4 Conquest will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"ED0\" } window 1000,10\r\n1010.7 \"Wheel\" Ability { id: \"63B5\", source: \"Arch-Lambda\" } window 1010.7,10\r\n1021.0 \"--sync--\" Ability { id: \"63AA\", source: \"Arch-Lambda\" }\r\n1028.4 \"Auto-mobile Assault Cannon\" Ability { id: \"63AB\", source: \"Arch-Lambda\" }\r\n1028.7 \"Tread x4\" duration 4 #Ability { id: \"63AC\", source: \"Arch-Lambda\" }\r\n1032.1 \"--sync--\" Ability { id: \"63AD\", source: \"Arch-Lambda\" }\r\n1036.3 \"Wave Cannon\" Ability { id: \"63AF\", source: \"Arch-Lambda\" } window 30,30\r\n1049.5 \"Atomic Flame\" Ability { id: \"63B4\", source: \"Arch-Lambda\" }\r\n1061.8 \"--sync--\" Ability { id: \"63AA\", source: \"Arch-Lambda\" }\r\n1070.7 \"Auto-mobile Sniper Cannon\" Ability { id: \"63B0\", source: \"Arch-Lambda\" }\r\n1071.2 \"Entrench\" Ability { id: \"63B1\", source: \"Arch-Lambda\" }\r\n\r\n1080.9 \"Wheel\" Ability { id: \"63B5\", source: \"Arch-Lambda\" } window 30,30\r\n1091.1 \"--sync--\" Ability { id: \"63AA\", source: \"Arch-Lambda\" }\r\n1098.6 \"Auto-mobile Assault Cannon\" Ability { id: \"63AB\", source: \"Arch-Lambda\" }\r\n1098.9 \"Tread x4\" duration 4 #Ability { id: \"63AC\", source: \"Arch-Lambda\" }\r\n1102.2 \"--sync--\" Ability { id: \"63AD\", source: \"Arch-Lambda\" }\r\n1106.4 \"Wave Cannon\" Ability { id: \"63AF\", source: \"Arch-Lambda\" } window 30,30\r\n1119.6 \"Atomic Flame\" Ability { id: \"63B4\", source: \"Arch-Lambda\" }\r\n1131.9 \"--sync--\" Ability { id: \"63AA\", source: \"Arch-Lambda\" }\r\n1140.8 \"Auto-mobile Sniper Cannon\" Ability { id: \"63B0\", source: \"Arch-Lambda\" }\r\n1141.3 \"Entrench\" Ability { id: \"63B1\", source: \"Arch-Lambda\" }\r\n\r\n# TODO: Probably the loop point? More data needed.\r\n1151.0 \"Wheel\" Ability { id: \"63B5\", source: \"Arch-Lambda\" } window 30,30 jump 1080.9\r\n1168.7 \"Auto-mobile Assault Cannon\"\r\n1169.0 \"Tread x4\"\r\n1176.5 \"Wave Cannon\"\r\n1189.7 \"Atomic Flame\"\r\n1210.9 \"Auto-mobile Sniper Cannon\"\r\n1211.4 \"Entrench\"\r\n\r\n\r\n#~~~~~~~~~~#\r\n# STIGMA-4 #\r\n#~~~~~~~~~~#\r\n\r\n# -ii 6435\r\n\r\n# A-4 Headquarters will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"ED2\" } window 2000,1\r\n2010.0 \"AI Takeover\" Ability { id: \"6429\", source: \"Stigma-4\" }\r\n2015.6 \"Touchdown?\" Ability { id: \"68F9\", source: \"Hybrid Dragon\" }\r\n2024.7 \"Proto-wave Cannon?\" Ability { id: [\"642A\", \"642B\"], source: \"Omega Frame\" }\r\n2024.7 \"Fire Breath?\" Ability { id: \"642E\", source: \"Hybrid Dragon\" }\r\n2031.3 \"AI Takeover\" Ability { id: \"6429\", source: \"Stigma-4\" }\r\n2037.1 \"Touchdown?\" Ability { id: \"68F9\", source: \"Hybrid Dragon\" }\r\n2044.5 \"Self-Destruct?\" # 14.7s cast time, cast seems to start 5.1s after Breath/Cannon\r\n2046.2 \"Fire Breath?\" Ability { id: \"642E\", source: \"Hybrid Dragon\" }\r\n2046.2 \"Proto-wave Cannon?\" Ability { id: [\"642A\", \"642B\"], source: \"Omega Frame\" }\r\n2052.6 \"AI Takeover\" Ability { id: \"6429\", source: \"Stigma-4\" }\r\n2061.5 \"Rush\" Ability { id: \"642D\", source: \"Proto-rocket Punch\" } window 30,30\r\n2066.0 \"Self-Destruct?\"\r\n2067.0 \"--sync--\" Ability { id: \"6433\", source: \"Stigma-4\" }\r\n2077.0 \"Electromagnetic Release\" Ability { id: \"6434\", source: \"Stigma-4\" }\r\n2085.1 \"--sync--\" Ability { id: \"6431\", source: \"Stigma-4\" }\r\n2095.1 \"Electromagnetic Release\" Ability { id: \"6432\", source: \"Stigma-4\" }\r\n2108.2 \"Mindhack\" Ability { id: \"6430\", source: \"Stigma-4\" } window 30,30\r\n2113.4 \"--sync--\" Ability { id: [\"6431\", \"6433\"], source: \"Stigma-4\" }\r\n2123.4 \"Electromagnetic Release\" Ability { id: [\"6432\", \"6434\"], source: \"Stigma-4\" }\r\n2132.5 \"Atomic Ray\" Ability { id: \"6436\", source: \"Stigma-4\" }\r\n2142.7 \"Multi-AI Takeover\" Ability { id: \"6C4B\", source: \"Stigma-4\" }\r\n2148.4 \"Touchdown?\" Ability { id: \"68F9\", source: \"Hybrid Dragon\" }\r\n2151.6 \"Rush\" Ability { id: \"642D\", source: \"Proto-rocket Punch\" } window 30,30\r\n2157.5 \"Fire Breath?\" Ability { id: \"642E\", source: \"Hybrid Dragon\" }\r\n2157.5 \"Proto-wave Cannon?\" Ability { id: [\"642A\", \"642B\"], source: \"Omega Frame\" }\r\n\r\n# TODO: Still not a loop, more data is needed\r\n2168.1 \"Mindhack\" Ability { id: \"6430\", source: \"Stigma-4\" } window 30,30\r\n2172.2 \"--sync--\" Ability { id: [\"6431\", \"6433\"], source: \"Stigma-4\" }\r\n2177.3 \"Self-Destruct?\"\r\n2182.2 \"Electromagnetic Release\" Ability { id: [\"6432\", \"6434\"], source: \"Stigma-4\" }\r\n2192.3 \"Multi-AI Takeover\" Ability { id: \"6C4B\", source: \"Stigma-4\" }\r\n2198.0 \"Touchdown?\" Ability { id: \"68F9\", source: \"Hybrid Dragon\" }\r\n2201.1 \"Rush\" Ability { id: \"642D\", source: \"Proto-rocket Punch\" } window 30,30\r\n2207.1 \"Fire Breath?\" Ability { id: \"642E\", source: \"Hybrid Dragon\" }\r\n2207.1 \"Proto-wave Cannon?\" Ability { id: [\"642A\", \"642B\"], source: \"Omega Frame\" }\r\n2217.6 \"Atomic Ray\" Ability { id: \"6436\", source: \"Stigma-4\" }\r\n\r\n# ???\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/the_aitiascope.ts


const the_aitiascope_triggerSet = {
  id: 'TheAitiascope',
  zoneId: zone_id/* default.TheAitiascope */.Z.TheAitiascope,
  timelineFile: 'the_aitiascope.txt',
  triggers: [{
    id: 'Aitiascope Livia Frustration',
    type: 'StartsUsing',
    netRegex: {
      id: '6448',
      source: 'Livia the Undeterred',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aitiascope Livia Aglaea Climb NE/SW',
    type: 'StartsUsing',
    netRegex: {
      id: '6442',
      source: 'Livia the Undeterred',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Back Right / Front Left',
        de: 'hinten rechts / vorne links',
        fr: 'Derrière à droite / Devant à gauche',
        ja: '右下 / 左上',
        cn: '右后 / 左前',
        ko: '오른쪽 아래 / 왼쪽 위'
      }
    }
  }, {
    id: 'Aitiascope Livia Aglaea Climb NW/SE',
    type: 'StartsUsing',
    netRegex: {
      id: '6443',
      source: 'Livia the Undeterred',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Back Left / Front Right',
        de: 'hinten links / vorne rechts',
        fr: 'Derrière à gauche / Devant à droite',
        ja: '左下 / 右上',
        cn: '左后 / 右前',
        ko: '왼쪽 아래 / 오른쪽 위'
      }
    }
  }, {
    id: 'Aitiascope Livia Aglaea Bite',
    type: 'StartsUsing',
    netRegex: {
      id: '6449',
      source: 'Livia the Undeterred'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave('alert')
  }, {
    id: 'Aitiascope Livia Ignis Odi',
    type: 'StartsUsing',
    netRegex: {
      id: '644D',
      source: 'Livia the Undeterred'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Aitiascope Rhitahtyn Tartarean Impact',
    type: 'StartsUsing',
    netRegex: {
      id: '6455',
      source: 'Rhitahtyn the Unshakable',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aitiascope Rhitahtyn Shield Skewer',
    type: 'StartsUsing',
    netRegex: {
      id: '6450',
      source: 'Rhitahtyn the Unshakable',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide behind broken crystal',
        de: 'Hinter dem gebrochenen Kristall verstecken',
        fr: 'Cachez-vous derrière le cristal brisé',
        ja: '壊れたクリスタルの後ろ',
        cn: '躲在破碎的水晶后',
        ko: '부서진 수정 뒤로'
      }
    }
  }, {
    id: 'Aitiascope Rhitahtyn Shrapnel Shell',
    type: 'StartsUsing',
    netRegex: {
      id: '6452',
      source: 'Rhitahtyn the Unshakable',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from Crosshairs',
        de: 'Weg von den Zielmarkierungen',
        fr: 'Éloignez-vous de la zone de ciblage',
        ja: 'ゆかから離れる',
        cn: '远离准星',
        ko: '원형 장판에서 멀어지기'
      }
    }
  }, {
    id: 'Aitiascope Rhitahtyn Anvil of Tartarus',
    type: 'StartsUsing',
    netRegex: {
      id: '6456',
      source: 'Rhitahtyn the Unshakable'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Aitiascope Sinking Regret Lost Opportunity',
    type: 'StartsUsing',
    netRegex: {
      id: '6B1F',
      source: 'Sinking Regret'
    },
    condition: data => data.CanStun(),
    response: responses/* Responses.stun */.n3.stun()
  }, {
    id: 'Aitiascope Amon Dark Forte',
    type: 'StartsUsing',
    netRegex: {
      id: '6464',
      source: 'Amon the Undying'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Aitiascope Amon Ysayle\'s Spirit Dreams of Ice',
    type: 'Ability',
    netRegex: {
      id: '6C6C',
      source: 'Ysayle\'s Spirit',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide Behind Ice',
        de: 'hinter dem Eis verstecken',
        fr: 'Cachez-vous derrière la glace',
        ja: '氷の後ろ',
        cn: '躲在冰柱后面',
        ko: '얼음 뒤로'
      }
    }
  }, {
    id: 'Aitiascope Amon Entr\'acte',
    type: 'StartsUsing',
    netRegex: {
      id: '6465',
      source: 'Amon the Undying',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Aitiascope Amon Right Firaga Forte',
    type: 'StartsUsing',
    netRegex: {
      id: '6460',
      source: 'Amon the Undying',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Aitiascope Amon Left Firaga Forte',
    type: 'StartsUsing',
    netRegex: {
      id: '6461',
      source: 'Amon the Undying',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Left Firaga Forte/Right Firaga Forte': 'Left/Right Firaga Forte'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Aethershot': 'Ätherschuss',
      'Amon the Undying': 'Amon',
      'Livia the Undeterred': 'Livia (?:der|die|das) Glühend(?:e|er|es|en)',
      'Rhitahtyn the Unshakable': 'Rhitahtyn (?:der|die|das) Geplagt(?:e|er|es|en)',
      'Sinking Regret': 'Versunken(?:e|er|es|en) Reue',
      'The Central Observatory': 'Hauptwarte',
      'The Midnight Downwell': 'Wirbelstrom',
      'The Saltcrystal Strings': 'Kristalline Flur',
      'Ysayle\'s Spirit': 'Ysayles Seele'
    },
    'replaceText': {
      '\\(proximity\\)': '(Distanz)',
      'Aglaea Bite': 'Aglaia-Biss',
      'Aglaea Climb': 'Aglaia-Aufstieg',
      'Aglaea Shot': 'Aglaia-Schuss',
      'Antistrophe': 'Antistrophe',
      'Anvil of Tartarus': 'Amboss des Tartarus',
      'Curtain Call': 'Klimax',
      'Dark Forte': 'Dunkelung Forte',
      'Disparagement': 'Verunglimpfung',
      'Dreams of Ice': 'Eisige Träume',
      'Entr\'acte': 'Entracte',
      'Epode': 'Epode',
      'Eruption Forte': 'Eruption Forte',
      'Frustration': 'Frustration',
      'Ignis Amoris': 'Ignis Amoris',
      'Ignis Odi': 'Ignis Odi',
      '(?<!Tartarean )Impact': 'Begraben',
      'Left Firaga Forte': 'Linkes Firaga Forte',
      'Odi et Amo': 'Odi et Amo',
      'Right Firaga Forte': 'Rechtes Firaga Forte',
      'Shield Skewer': 'Schildspieß',
      'Shrapnel Shell': 'Schrapnell-Geschoss',
      '(?<!Anti)Strophe': 'Strophe',
      'Tartarean Impact': 'Schlag des Tartarus',
      'Tartarean Spark': 'Funken des Tartarus',
      'Thundaga Forte': 'Blitzga Forte',
      'Vexillatio': 'Vexillatio'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aethershot': 'Projectile d\'éther',
      'Amon the Undying': 'Amon',
      'Livia the Undeterred': 'Livia',
      'Rhitahtyn the Unshakable': 'Rhitahtyn',
      'Sinking Regret': 'Regret Enfoui',
      'The Central Observatory': 'Observatoire central',
      'The Midnight Downwell': 'Turbulences éthérées',
      'The Saltcrystal Strings': 'Enchevêtrements cristallins',
      'Ysayle\'s Spirit': 'âme d\'Ysayle'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(proximity\\)': '(proximité)',
      'Aglaea Bite': 'Morsure d\'Aglaia',
      'Aglaea Climb': 'Flambée d\'Aglaia',
      'Aglaea Shot': 'Tir d\'Aglaia',
      'Antistrophe': 'Antistrophe',
      'Anvil of Tartarus': 'Tartarus enclume',
      'Curtain Call': 'Rappel',
      'Dark Forte': 'Ténèbres forte',
      'Disparagement': 'Dénigrement',
      'Dreams of Ice': 'Illusions glacées',
      'Entr\'acte': 'Entracte',
      'Epode': 'Épode',
      'Eruption Forte': 'Éruption forte',
      'Frustration': 'Frustration',
      'Ignis Amoris': 'Ignis Amoris',
      'Ignis Odi': 'Ignis Odi',
      '(?<!Tartarean )Impact(?! )': 'Ensevelissement',
      'Left Firaga Forte(?!/)': 'Méga Feu forte gauche',
      'Left Firaga Forte/Right Firaga Forte': 'Méga Feu forte gauche/droite',
      'Odi et Amo': 'Odi et Amo',
      '(?<!/)Right Firaga Forte': 'Méga Feu forte droit',
      'Shield Skewer': 'Perce-bouclier',
      'Shrapnel Shell': 'Obus shrapnel',
      '(?<!Anti)Strophe': 'Strophe',
      'Tartarean Impact': 'Impact de Tartarus',
      'Tartarean Spark': 'Étincelle de Tartarus',
      'Thundaga Forte': 'Méga Foudre forte',
      'Vexillatio': 'Vexillatio'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aethershot': 'エーテル弾',
      'Amon the Undying': '異執のアモン',
      'Livia the Undeterred': '愛執のリウィア',
      'Rhitahtyn the Unshakable': '宿執のリットアティン',
      'Sinking Regret': 'サンクン・リグレト',
      'The Central Observatory': '主観測室',
      'The Midnight Downwell': '星海乱流域',
      'The Saltcrystal Strings': '星海結晶域',
      'Ysayle\'s Spirit': 'イゼルの魂'
    },
    'replaceText': {
      'Aglaea Bite': 'アグライアバイト',
      'Aglaea Climb': 'アグライアクライム',
      'Aglaea Shot': 'アグライアショット',
      'Antistrophe': 'アンティストロペー',
      'Anvil of Tartarus': 'タルタロスアンヴィル',
      'Curtain Call': '終幕の熱狂',
      'Dark Forte': 'フォルテダーク',
      'Disparagement': 'ディスペレッジメント',
      'Dreams of Ice': '氷結の幻想',
      'Entr\'acte': '幕間の風狂',
      'Epode': 'エポードス',
      'Eruption Forte': 'フォルテエラプション',
      'Frustration': 'フラストレーション',
      'Ignis Amoris': 'イグニス・アモリス',
      'Ignis Odi': 'イグニス・オディー',
      '(?<!Tartarean )Impact': '衝撃',
      'Left Firaga Forte': 'レフト・フォルテファイガ',
      'Odi et Amo': 'オディー・エト・アモー',
      'Right Firaga Forte': 'ライト・フォルテファイガ',
      'Shield Skewer': 'シールドスキュワー',
      'Shrapnel Shell': '榴散弾',
      '(?<!Anti)Strophe': 'ストロペー',
      'Tartarean Impact': 'タルタロスインパクト',
      'Tartarean Spark': 'タルタロススパーク',
      'Thundaga Forte': 'フォルテサンダガ',
      'Vexillatio': 'ウェクシッラティオ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aethershot': '以太弹',
      'Amon the Undying': '邪执外道的亚蒙',
      'Livia the Undeterred': '迷执爱恋的莉维亚',
      'Rhitahtyn the Unshakable': '强执忠义的里塔提恩',
      'Sinking Regret': '沉沦的后悔',
      'The Central Observatory': '主观测室',
      'The Midnight Downwell': '乱流海域',
      'The Saltcrystal Strings': '结晶海域',
      'Ysayle\'s Spirit': '伊塞勒的灵魂'
    },
    'replaceText': {
      '\\(proximity\\)': '(接近)',
      'Aglaea Bite': '典雅女神枪',
      'Aglaea Climb': '典雅女神连枪',
      'Aglaea Shot': '典雅女神射击',
      'Antistrophe': '回舞歌',
      'Anvil of Tartarus': '冥狱铁砧',
      'Curtain Call': '离场',
      'Dark Forte': '暗强音',
      'Disparagement': '蔑视',
      'Dreams of Ice': '寒冰的幻想',
      'Entr\'acte': '间歇',
      'Epode': '长短句交替',
      'Eruption Forte': '强音喷发',
      'Frustration': '挫败',
      'Ignis Amoris': '爱之火',
      'Ignis Odi': '恨之火',
      '(?<!Tartarean )Impact': '冲击',
      'Left Firaga Forte': '左侧强音爆炎',
      'Left Firaga Forte(?!/)': '左侧强音爆炎',
      'Odi et Amo': '恨且爱',
      'Right Firaga Forte': '右侧强音爆炎',
      'Shield Skewer': '盾牌穿刺',
      'Shrapnel Shell': '榴散弹',
      '(?<!Anti)Strophe': '正旋舞歌',
      'Tartarean Impact': '冥狱冲击',
      'Tartarean Spark': '冥狱火花',
      'Thundaga Forte': '强音暴雷',
      'Vexillatio': '布旗'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aethershot': '에테르탄',
      'Amon the Undying': '이집의 아몬',
      'Livia the Undeterred': '애집의 리위아',
      'Rhitahtyn the Unshakable': '숙집의 리트아틴',
      'Sinking Regret': '침잠한 후회',
      'The Central Observatory': '주 관측실',
      'The Midnight Downwell': '별바다 난류해역',
      'The Saltcrystal Strings': '별바다 결정해역',
      'Ysayle\'s Spirit': '이젤의 영혼'
    },
    'replaceText': {
      '\\(proximity\\)': '(중앙)',
      'Aglaea Bite': '아글라이아 쌍격',
      'Aglaea Climb': '아글라이아 상승격',
      'Aglaea Shot': '아글라이아 사격',
      'Antistrophe': '응답절',
      'Anvil of Tartarus': '타르타로스의 모루',
      'Curtain Call': '대단원의 열광',
      'Dark Forte': '포르테 다크',
      'Disparagement': '비방',
      'Dreams of Ice': '빙결의 환상',
      'Entr\'acte': '막간의 풍류광',
      'Epode': '최종절',
      'Eruption Forte': '포르테 분출',
      'Frustration': '좌절',
      'Ignis Amoris': '미움의 불',
      'Ignis Odi': '사랑의 불',
      'Left Firaga Forte': '왼쪽 포르테 파이가',
      'Odi et Amo': '오디 에트 아모',
      'Right Firaga Forte': '오른쪽 포르테 파이가',
      'Shield Skewer': '방패 찌르기',
      'Shrapnel Shell': '유산탄',
      'Tartarean Impact': '타르타로스의 충격',
      'Tartarean Spark': '타르타로스의 불꽃',
      'Thundaga Forte': '포르테 선더가',
      'Vexillatio': '파견 부대',
      'Left Firaga Forte(?!/)': '왼쪽 포르테 파이가',
      '(?<!/)Right Firaga Forte': '오른쪽 포르테 파이가',
      '(?<!Tartarean )Impact': '충격',
      '(?<!Anti)Strophe': '시작절'
    }
  }]
};
/* harmony default export */ const the_aitiascope = (the_aitiascope_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/the_aitiascope.txt
const dungeon_the_aitiascope_namespaceObject = "# The Aitiascope\r\n\r\n# TODO: Missing loop for Livia\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~~~~~~~~~~~~~~#\r\n# LIVIA THE UNDETERRED #\r\n#~~~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 6448:1012\r\n# -ii 60C3 6444 6446\r\n\r\n# Central Observatory will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"F98\" } window 10000,0\r\n1012.0 \"Frustration\" Ability { id: \"6448\", source: \"Livia the Undeterred\" }\r\n1022.2 \"Aglaea Bite\" Ability { id: \"6449\", source: \"Livia the Undeterred\" }\r\n1029.3 \"--middle--\"\r\n1037.3 \"Aglaea Climb\" Ability { id: \"644[23]\", source: \"Livia the Undeterred\" }\r\n1047.4 \"Aglaea Climb\" Ability { id: \"644[23]\", source: \"Livia the Undeterred\" }\r\n1057.8 \"Aglaea Shot 1\" Ability { id: \"6445\", source: \"Livia the Undeterred\" }\r\n1068.0 \"Aglaea Shot 2\" Ability { id: \"6447\", source: \"Aethershot\" }\r\n\r\n1079.0 \"Odi et Amo\" Ability { id: \"644B\", source: \"Livia the Undeterred\" }\r\n1083.9 \"Ignis Amoris\" Ability { id: \"644C\", source: \"Livia the Undeterred\" }\r\n1089.1 \"Ignis Odi\" Ability { id: \"644D\", source: \"Livia the Undeterred\" }\r\n1094.4 \"Disparagement\" Ability { id: \"644A\", source: \"Livia the Undeterred\" }\r\n\r\n1105.6 \"Frustration\" Ability { id: \"6448\", source: \"Livia the Undeterred\" }\r\n1117.0 \"Aglaea Shot 1\" Ability { id: \"6445\", source: \"Livia the Undeterred\" }\r\n1127.1 \"Aglaea Climb\" Ability { id: \"644[23]\", source: \"Livia the Undeterred\" }\r\n1128.2 \"Aglaea Shot 2\" Ability { id: \"6447\", source: \"Aethershot\" }\r\n\r\n1138.3 \"Frustration\" Ability { id: \"6448\", source: \"Livia the Undeterred\" }\r\n1150.6 \"Odi et Amo\" Ability { id: \"644B\", source: \"Livia the Undeterred\" }\r\n1155.5 \"Ignis Amoris\" Ability { id: \"644C\", source: \"Livia the Undeterred\" }\r\n1160.7 \"Ignis Odi\" Ability { id: \"644D\", source: \"Livia the Undeterred\" }\r\n1167.7 \"Aglaea Climb\" Ability { id: \"644[23]\", source: \"Livia the Undeterred\" }\r\n\r\n1180.8 \"Frustration\" Ability { id: \"6448\", source: \"Livia the Undeterred\" }\r\n1194.0 \"Aglaea Bite\" Ability { id: \"6449\", source: \"Livia the Undeterred\" }\r\n1207.4 \"Disparagement\" Ability { id: \"644A\", source: \"Livia the Undeterred\" }\r\n1218.8 \"Aglaea Shot 1\" Ability { id: \"6445\", source: \"Livia the Undeterred\" }\r\n1229.0 \"Aglaea Shot 2\" Ability { id: \"6447\", source: \"Aethershot\" }\r\n\r\n1240.0 \"Odi et Amo\" Ability { id: \"644B\", source: \"Livia the Undeterred\" } window 50,50 jump 1079\r\n1244.9 \"Ignis Amoris\" #Ability { id: \"644C\", source: \"Livia the Undeterred\" }\r\n1250.1 \"Ignis Odi\" #Ability { id: \"644D\", source: \"Livia the Undeterred\" }\r\n1255.4 \"Disparagement\" #Ability { id: \"644A\", source: \"Livia the Undeterred\" }\r\n\r\n1266.6 \"Frustration\" #Ability { id: \"6448\", source: \"Livia the Undeterred\" }\r\n1278.0 \"Aglaea Shot 1\" #Ability { id: \"6445\", source: \"Livia the Undeterred\" }\r\n1288.1 \"Aglaea Climb\" #Ability { id: \"644[23]\", source: \"Livia the Undeterred\" }\r\n1289.2 \"Aglaea Shot 2\" #Ability { id: \"6447\", source: \"Aethershot\" }\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~~~~~~~~~#\r\n# RHITAHTYN THE UNSHAKABLE #\r\n#~~~~~~~~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 6455:2012\r\n# -ii 6454\r\n\r\n# Saltcrystal Strings will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"F99\" } window 10000,0\r\n2012.0 \"Tartarean Impact\" Ability { id: \"6455\", source: \"Rhitahtyn the Unshakable\" }\r\n2020.5 \"Tartarean Spark\" Ability { id: \"6457\", source: \"Rhitahtyn the Unshakable\" }\r\n\r\n# Initial Shield Skewer\r\n2027.7 \"--north--\" Ability { id: \"6458\", source: \"Rhitahtyn the Unshakable\" }\r\n2034.0 \"Vexillatio\" Ability { id: \"644E\", source: \"Rhitahtyn the Unshakable\" }\r\n2034.0 \"Impact\" Ability { id: \"644F\", source: \"Rhitahtyn the Unshakable\" }\r\n2048.1 \"Shield Skewer\" Ability { id: \"6450\", source: \"Rhitahtyn the Unshakable\" }\r\n2051.3 \"--middle--\" Ability { id: \"6458\", source: \"Rhitahtyn the Unshakable\" }\r\n2059.5 \"Anvil of Tartarus\" Ability { id: \"6456\", source: \"Rhitahtyn the Unshakable\" }\r\n2065.7 \"--sync--\" Ability { id: \"6458\", source: \"Rhitahtyn the Unshakable\" }\r\n2071.0 \"Shrapnel Shell\" Ability { id: \"6452\", source: \"Rhitahtyn the Unshakable\" }\r\n2086.2 \"Tartarean Spark\" Ability { id: \"6457\", source: \"Rhitahtyn the Unshakable\" }\r\n2098.4 \"Tartarean Impact\" Ability { id: \"6455\", source: \"Rhitahtyn the Unshakable\" }\r\n\r\n# Shield Skewer with Shrapnel Shell\r\n2105.6 \"--north--\" Ability { id: \"6458\", source: \"Rhitahtyn the Unshakable\" }\r\n2111.9 \"Vexillatio\" Ability { id: \"644E\", source: \"Rhitahtyn the Unshakable\" }\r\n2111.9 \"Impact\" Ability { id: \"644F\", source: \"Rhitahtyn the Unshakable\" }\r\n2118.0 \"Shrapnel Shell\" Ability { id: \"6452\", source: \"Rhitahtyn the Unshakable\" }\r\n2132.2 \"Shield Skewer\" Ability { id: \"6450\", source: \"Rhitahtyn the Unshakable\" }\r\n2135.3 \"--middle--\" Ability { id: \"6458\", source: \"Rhitahtyn the Unshakable\" }\r\n2142.4 \"Tartarean Impact\" Ability { id: \"6455\", source: \"Rhitahtyn the Unshakable\" }\r\n2150.6 \"--sync--\" Ability { id: \"6458\", source: \"Rhitahtyn the Unshakable\" }\r\n2155.8 \"Shrapnel Shell\" Ability { id: \"6452\", source: \"Rhitahtyn the Unshakable\" }\r\n2162.1 \"Tartarean Spark\" Ability { id: \"6457\", source: \"Rhitahtyn the Unshakable\" }\r\n2168.4 \"Tartarean Spark\" Ability { id: \"6457\", source: \"Rhitahtyn the Unshakable\" }\r\n2176.6 \"Anvil of Tartarus\" Ability { id: \"6456\", source: \"Rhitahtyn the Unshakable\" }\r\n2188.7 \"Tartarean Impact\" Ability { id: \"6455\", source: \"Rhitahtyn the Unshakable\" }\r\n2200.9 \"Tartarean Impact\" Ability { id: \"6455\", source: \"Rhitahtyn the Unshakable\" }\r\n\r\n# Guessing this is the loop.  Have only seen up to 2239.8 in logs.\r\n2210.1 \"--north--\" Ability { id: \"6458\", source: \"Rhitahtyn the Unshakable\" } window 30,30 jump 2105.6\r\n2216.4 \"Vexillatio\" #Ability { id: \"644E\", source: \"Rhitahtyn the Unshakable\" }\r\n2216.4 \"Impact\" #Ability { id: \"644F\", source: \"Rhitahtyn the Unshakable\" }\r\n2222.5 \"Shrapnel Shell\" #Ability { id: \"6452\", source: \"Rhitahtyn the Unshakable\" }\r\n2236.7 \"Shield Skewer\" #Ability { id: \"6450\", source: \"Rhitahtyn the Unshakable\" }\r\n2239.8 \"--middle--\" #Ability { id: \"6458\", source: \"Rhitahtyn the Unshakable\" }\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~#\r\n# AMON THE UNDYING #\r\n#~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 6464:3012\r\n# -ii 6088\r\n\r\n# Midnight Downwell will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"F9A\" } window 10000,0\r\n3012.0 \"Dark Forte\" Ability { id: \"6464\", source: \"Amon the Undying\" }\r\n3022.2 \"Thundaga Forte (proximity)\" Ability { id: \"645A\", source: \"Amon the Undying\" }\r\n3028.0 \"Thundaga Forte 1\" Ability { id: \"645B\", source: \"Amon the Undying\" }\r\n3034.0 \"Thundaga Forte 2\" Ability { id: \"645C\", source: \"Amon the Undying\" }\r\n3038.4 \"Strophe\" Ability { id: \"645D\", source: \"Amon the Undying\" }\r\n3044.5 \"Antistrophe\" Ability { id: \"645E\", source: \"Amon the Undying\" }\r\n3053.3 \"Epode\" Ability { id: \"645F\", source: \"Amon the Undying\" }\r\n3061.7 \"Left Firaga Forte/Right Firaga Forte\" Ability { id: \"646[01]\", source: \"Amon the Undying\" }\r\n3071.8 \"Entr'acte\" Ability { id: \"6465\", source: \"Amon the Undying\" }\r\n3086.0 \"Eruption Forte\" Ability { id: \"6468\", source: \"Amon the Undying\" }\r\n3091.0 \"--sync--\" Ability { id: \"6467\", source: \"Ysayle's Spirit\" }\r\n3093.0 \"Eruption Forte\" Ability { id: \"6468\", source: \"Amon the Undying\" }\r\n\r\n3105.7 \"Dreams of Ice\" Ability { id: \"6C6C\", source: \"Ysayle's Spirit\" }\r\n3111.0 \"Curtain Call\" Ability { id: \"6466\", source: \"Amon the Undying\" }\r\n# post curtain-call branching\r\n# TODO: unclear if once post jump it keeps the pattern of Strophe vs Thundaga first, or if random.\r\n# 4/4 pulls that saw this all had the same, but that's not quite enough confidence.\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Strophe first, then Thundaga?\r\n3119.2 \"--sync--\" StartsUsing { id: \"645D\", source: \"Amon the Undying\" } window 50,50 jump 4119.2\r\n3122.2 \"Strophe?\" #Ability { id: \"645D\", source: \"Amon the Undying\" }\r\n3128.3 \"Antistrophe?\" #Ability { id: \"645E\", source: \"Amon the Undying\" }\r\n3137.1 \"Epode?\" #Ability { id: \"645F\", source: \"Amon the Undying\" }\r\n\r\n# -> Thundaga first, then Strophe?\r\n3119.2 \"--sync--\" StartsUsing { id: \"645A\", source: \"Amon the Undying\" } window 50,50 jump 5119.2\r\n3124.2 \"Thundaga Forte (proximity)?\" #Ability { id: \"645A\", source: \"Amon the Undying\" }\r\n3130.0 \"Thundaga Forte 1?\" #Ability { id: \"645B\", source: \"Amon the Undying\" }\r\n3136.0 \"Thundaga Forte 2?\" #Ability { id: \"645C\", source: \"Amon the Undying\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n### Strophe -> Thundaga -> shared Eruption section -> (Strophe or Thundaga)\r\n4119.2 \"--sync--\" StartsUsing { id: \"645D\", source: \"Amon the Undying\" }\r\n4122.2 \"Strophe\" Ability { id: \"645D\", source: \"Amon the Undying\" }\r\n4128.3 \"Antistrophe\" Ability { id: \"645E\", source: \"Amon the Undying\" }\r\n4137.1 \"Epode\" Ability { id: \"645F\", source: \"Amon the Undying\" }\r\n4146.4 \"Left Firaga Forte/Right Firaga Forte\" Ability { id: \"646[01]\", source: \"Amon the Undying\" }\r\n4154.5 \"Dark Forte\" Ability { id: \"6464\", source: \"Amon the Undying\" }\r\n4167.7 \"Thundaga Forte (proximity)\" Ability { id: \"645A\", source: \"Amon the Undying\" }\r\n4173.5 \"Thundaga Forte 1\" Ability { id: \"645B\", source: \"Amon the Undying\" }\r\n4179.5 \"Thundaga Forte 2\" Ability { id: \"645C\", source: \"Amon the Undying\" }\r\n4186.9 \"Left Firaga Forte/Right Firaga Forte\" Ability { id: \"646[01]\", source: \"Amon the Undying\" }\r\n4195.1 \"Entr'acte\" Ability { id: \"6465\", source: \"Amon the Undying\" }\r\n\r\n4206.3 \"Eruption Forte\" Ability { id: \"6085\", source: \"Amon the Undying\" }\r\n4210.3 \"Eruption Forte\" Ability { id: \"6468\", source: \"Amon the Undying\" }\r\n4220.5 \"Left Firaga Forte/Right Firaga Forte\" Ability { id: \"646[01]\", source: \"Amon the Undying\" }\r\n4230.7 \"Left Firaga Forte/Right Firaga Forte\" Ability { id: \"646[01]\", source: \"Amon the Undying\" }\r\n4238.9 \"Entr'acte\" Ability { id: \"6465\", source: \"Amon the Undying\" }\r\n4247.0 \"Dark Forte\" Ability { id: \"6464\", source: \"Amon the Undying\" }\r\n4255.1 \"Entr'acte\" Ability { id: \"6465\", source: \"Amon the Undying\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Strophe first, then Thundaga?\r\n4267.3 \"--sync--\" StartsUsing { id: \"645D\", source: \"Amon the Undying\" } window 50,50 jump 4119.2\r\n4270.3 \"Strophe?\" #Ability { id: \"645D\", source: \"Amon the Undying\" }\r\n4276.4 \"Antistrophe?\" #Ability { id: \"645E\", source: \"Amon the Undying\" }\r\n4285.2 \"Epode?\" #Ability { id: \"645F\", source: \"Amon the Undying\" }\r\n\r\n# -> Thundaga first, then Strophe?\r\n4267.3 \"--sync--\" StartsUsing { id: \"645A\", source: \"Amon the Undying\" } window 50,50 jump 5119.2\r\n4272.3 \"Thundaga Forte (proximity)?\" #Ability { id: \"645A\", source: \"Amon the Undying\" }\r\n4278.1 \"Thundaga Forte 1?\" #Ability { id: \"645B\", source: \"Amon the Undying\" }\r\n4284.1 \"Thundaga Forte 2?\" #Ability { id: \"645C\", source: \"Amon the Undying\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n### Thundaga -> Strophe -> shared Eruption section -> (Strophe or Thundaga)\r\n5119.2 \"--sync--\" StartsUsing { id: \"645A\", source: \"Amon the Undying\" }\r\n5124.2 \"Thundaga Forte\" Ability { id: \"645A\", source: \"Amon the Undying\" }\r\n5130.0 \"Thundaga Forte\" Ability { id: \"645B\", source: \"Amon the Undying\" }\r\n5136.0 \"Thundaga Forte\" Ability { id: \"645C\", source: \"Amon the Undying\" }\r\n5143.4 \"Left Firaga Forte\" Ability { id: \"6461\", source: \"Amon the Undying\" }\r\n5151.6 \"Entr'acte\" Ability { id: \"6465\", source: \"Amon the Undying\" }\r\n5162.8 \"Strophe\" Ability { id: \"645D\", source: \"Amon the Undying\" }\r\n5168.9 \"Antistrophe\" Ability { id: \"645E\", source: \"Amon the Undying\" }\r\n5177.7 \"Epode\" Ability { id: \"645F\", source: \"Amon the Undying\" }\r\n5187.0 \"Right Firaga Forte\" Ability { id: \"6460\", source: \"Amon the Undying\" }\r\n5195.2 \"Dark Forte\" Ability { id: \"6464\", source: \"Amon the Undying\" }\r\n\r\n5206.3 \"Eruption Forte\" Ability { id: \"6085\", source: \"Amon the Undying\" }\r\n5210.3 \"Eruption Forte\" Ability { id: \"6468\", source: \"Amon the Undying\" }\r\n5220.5 \"Left Firaga Forte/Right Firaga Forte\" Ability { id: \"646[01]\", source: \"Amon the Undying\" }\r\n5230.7 \"Left Firaga Forte/Right Firaga Forte\" Ability { id: \"646[01]\", source: \"Amon the Undying\" }\r\n5238.9 \"Entr'acte\" Ability { id: \"6465\", source: \"Amon the Undying\" }\r\n5247.0 \"Dark Forte\" Ability { id: \"6464\", source: \"Amon the Undying\" }\r\n5255.1 \"Entr'acte\" Ability { id: \"6465\", source: \"Amon the Undying\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Strophe first, then Thundaga?\r\n5267.3 \"--sync--\" StartsUsing { id: \"645D\", source: \"Amon the Undying\" } window 50,50 jump 4119.2\r\n5270.3 \"Strophe?\" #Ability { id: \"645D\", source: \"Amon the Undying\" }\r\n5276.4 \"Antistrophe?\" #Ability { id: \"645E\", source: \"Amon the Undying\" }\r\n5285.2 \"Epode?\" #Ability { id: \"645F\", source: \"Amon the Undying\" }\r\n\r\n# -> Thundaga first, then Strophe?\r\n5267.3 \"--sync--\" StartsUsing { id: \"645A\", source: \"Amon the Undying\" } window 50,50 jump 5119.2\r\n5272.3 \"Thundaga Forte (proximity)?\" #Ability { id: \"645A\", source: \"Amon the Undying\" }\r\n5278.1 \"Thundaga Forte 1?\" #Ability { id: \"645B\", source: \"Amon the Undying\" }\r\n5284.1 \"Thundaga Forte 2?\" #Ability { id: \"645C\", source: \"Amon the Undying\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/the_dead_ends.ts




const the_dead_ends_triggerSet = {
  id: 'TheDeadEnds',
  zoneId: zone_id/* default.TheDeadEnds */.Z.TheDeadEnds,
  timelineFile: 'the_dead_ends.txt',
  triggers: [{
    id: 'DeadEnds Grebuloff Miasmata',
    type: 'StartsUsing',
    netRegex: {
      id: '653C',
      source: 'Caustic Grebuloff',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'DeadEnds Grebuloff Certain Solitude',
    type: 'Ability',
    // Corresponds with 0037 headmarker that comes out ~0.5s later.
    netRegex: {
      id: '6EBD',
      source: 'Caustic Grebuloff'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.doritoStack */.n3.doritoStack()
  }, {
    id: 'DeadEnds Grebuloff Blighted Water',
    type: 'StartsUsing',
    netRegex: {
      id: '6542',
      source: 'Caustic Grebuloff'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'DeadEnds Grebuloff Befoulment',
    type: 'StartsUsing',
    netRegex: {
      id: '6544',
      source: 'Caustic Grebuloff'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'DeadEnds Grebuloff Necrosis',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B95'
    },
    condition: data => data.CanCleanse(),
    infoText: (data, matches, output) => output.text({
      player: data.party.member(matches.target)
    }),
    outputStrings: {
      text: {
        en: 'Esuna ${player}',
        de: 'Medica ${player}',
        fr: 'Guérison sur ${player}',
        ja: '${player} にエスナ',
        cn: '驱散: ${player}',
        ko: '${player} 에스나'
      }
    }
  }, {
    id: 'DeadEnds Pox Flail',
    type: 'StartsUsing',
    netRegex: {
      id: '6540',
      source: 'Caustic Grebuloff'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'DeadEnds Peacekeeper Decimation',
    type: 'StartsUsing',
    netRegex: {
      id: '6550',
      source: 'Peacekeeper',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'DeadEnds Peacekeeper Infantry Deterrent',
    type: 'StartsUsing',
    netRegex: {
      id: '6EC7',
      source: 'Peacekeeper'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'DeadEnds Peacekeeper No Future Spread',
    type: 'StartsUsing',
    netRegex: {
      id: '6548',
      source: 'Peacekeeper'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'DeadEnds Peacekeeper Order To Fire',
    type: 'StartsUsing',
    netRegex: {
      id: '6EBF',
      source: 'Peacekeeper',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand Between Bits',
        de: 'Zwichen den Satelliten stehen',
        fr: 'Placez-vous entre les drones',
        ja: '自動殺傷兵器の間に',
        cn: '站在浮游炮间隙躲避激光',
        ko: '비트 사이에 자리잡기'
      }
    }
  }, {
    id: 'DeadEnds Peacekeeper Eclipsing Exhaust',
    type: 'StartsUsing',
    netRegex: {
      id: '654B',
      source: 'Peacekeeper',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'DeadEnds Peacekeeper Elimination',
    type: 'StartsUsing',
    netRegex: {
      id: '654F',
      source: 'Peacekeeper'
    },
    // TODO: this is maybe worth promoting to responses?
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankLaserOnYou: {
          en: 'Tank Laser on YOU',
          de: 'Tank Laser auf DIR',
          fr: 'Tank laser sur VOUS',
          ja: '自分に対人光線',
          cn: '坦克激光点名',
          ko: '탱커 레이저'
        },
        tankLaserOnPlayer: {
          en: 'Tank Laser on ${player}',
          de: 'Tank Laser auf ${player}',
          fr: 'Tank laser sur ${player}',
          ja: '${player} に対人光線',
          cn: '坦克激光点名 ${player}',
          ko: '탱커 레이저: ${player}'
        },
        avoidLaserOnPlayer: {
          en: 'Avoid Laser on ${player}',
          de: 'Weiche dem Laser von ${player} aus',
          fr: 'Évitez le laser sur ${player}',
          ja: '${player} への対人光線を避ける',
          cn: '远离激光点名: ${player}',
          ko: '탱커 레이저 피하기: ${player}'
        }
      };
      if (data.me === matches.target) return {
        alertText: output.tankLaserOnYou()
      };
      if (data.role === 'healer') return {
        alertText: output.tankLaserOnPlayer({
          player: data.party.member(matches.target)
        })
      };
      return {
        info: output.avoidLaserOnPlayer({
          player: data.party.member(matches.target)
        })
      };
    }
  }, {
    id: 'DeadEnds Ra-La Warm Glow',
    type: 'StartsUsing',
    netRegex: {
      id: '655E',
      source: 'Ra-la',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'DeadEnds Ra-La Pity',
    type: 'StartsUsing',
    netRegex: {
      id: '655D',
      source: 'Ra-la'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'DeadEnds Ra-la Benevolence',
    type: 'StartsUsing',
    netRegex: {
      id: '655A',
      source: 'Ra-la'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'DeadEnds Ra-la Loving Embrace Right',
    type: 'StartsUsing',
    // The first Loving Embrace is a left/right cleave while the boss is in the middle of the room,
    // so give a left/right call to the safe side.  The remaining Loving Embrace casts are when
    // the boss has jumped all the way to an edge and the players are (probably) facing it and so
    // reverse the calls here.
    netRegex: {
      id: '6557',
      source: 'Ra-la',
      capture: false
    },
    alertText: (data, _matches, output) => data.seenLovingEmbrace ? output.right() : output.left(),
    run: data => data.seenLovingEmbrace = true,
    outputStrings: {
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'DeadEnds Ra-la Loving Embrace Left',
    type: 'StartsUsing',
    netRegex: {
      id: '6558',
      source: 'Ra-la',
      capture: false
    },
    alertText: (data, _matches, output) => data.seenLovingEmbrace ? output.left() : output.right(),
    run: data => data.seenLovingEmbrace = true,
    outputStrings: {
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'DeadEnds Ra-la Still Embrace',
    type: 'StartsUsing',
    netRegex: {
      id: '655C',
      source: 'Ra-la'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'DeadEnds Ra-la Doom Cleanse',
    type: 'GainsEffect',
    netRegex: {
      effectId: '6E9'
    },
    condition: data => data.CanCleanse(),
    alertText: (data, matches, output) => output.cleanse({
      player: data.party.member(matches.target)
    }),
    outputStrings: {
      cleanse: {
        en: 'Heal ${player} to Full',
        de: 'Heile ${player} voll',
        fr: 'Soignez ${player} complètement',
        ja: '${player} をフル回復',
        cn: '奶满 ${player}',
        ko: '완전 회복: ${player}'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Caustic Grebuloff': 'Typhoid der Endzeit',
      'Golden Wings': 'golden(?:e|er|es|en) Schmetterling',
      'Peacekeeper': 'Friedenswächter',
      'Perpetual War Machine': 'automatisiert(?:e|er|es|en) Exterminator',
      'Ra-la': 'Ra-la',
      'The Deterrence Grounds': 'Hügel der Abschreckung',
      'The Shell Mound': 'Verfallenes Muschelhaus',
      'The World Tree': 'Garten des Weltenbaums',
      'Weeping Miasma': 'Pestbeule'
    },
    'replaceText': {
      '\\(circles\\)': '(Kreise)',
      '\\(spread\\)': '(Verteilen)',
      'Befoulment': 'Brackwasserbombe',
      'Benevolence': 'Philanthropie',
      'Blighted Water': 'Brackige Seele',
      'Certain Solitude': 'Einsame Verzweiflung',
      'Cough Up': 'Mutagene Giftlache',
      'Decimation': 'Omnidirektionalschuss',
      'Disengage Hatch': 'Speicherlukenöffnung',
      'Eclipsing Exhaust': 'Atomare Druckwelle',
      'Electromagnetic Repellant': 'Elektro-Massenentladung',
      'Elimination': 'Mörderischer Lichtstrahl',
      'Infantry Deterrent': 'Flächenbombe',
      'Lamellar Light': 'Phosphoreszenz',
      'Lifesbreath': 'Ode an das Leben',
      'Loving Embrace': 'Barmherzige Schwingen',
      'Miasmata': 'Exponentielles Gift',
      'Necrotic Fluid': 'Giftiger Spritzer',
      'No Future': 'Endloses Bombardement',
      'Order to Fire': 'Feuerbefehl',
      'Peacefire': 'Friedenskanonade',
      'Pity': 'Herzensgüte',
      'Pox Flail': 'Pockenschlag',
      'Prance': 'Schmetterlingsschwarm',
      'Small-bore Laser': 'Kleinkaliberstrahl',
      'Still Embrace': 'Schwingen des Seelenfriedens',
      'Warm Glow': 'Erlösendes Licht',
      'Wave of Nausea': 'Giftstrom'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Caustic Grebuloff': 'Grébuloff en stade terminal',
      'Golden Wings': 'papillon d\'or',
      'Peacekeeper': 'Pacificateur',
      'Perpetual War Machine': 'drone antipersonnel',
      'Ra-la': 'Ra-la',
      'The Deterrence Grounds': 'Colline des Dés jetés',
      'The Shell Mound': 'Amas coquillier naufragé',
      'The World Tree': 'Jardin de l\'Arbre-Monde',
      'Weeping Miasma': 'boule de toxine'
    },
    'replaceText': {
      '\\(circles\\)': '(cercles)',
      '\\(spread\\)': '(dispersion)',
      'Befoulment': 'Bombe de pus',
      'Benevolence': 'Philanthropie',
      'Blighted Water': 'Eau contaminée',
      'Certain Solitude': 'Désespoir solitaire',
      'Cough Up': 'Épanchement pleural',
      'Decimation': 'Rayonnement incinérateur',
      'Disengage Hatch': 'Ouverture des écoutilles',
      'Eclipsing Exhaust': 'Purge des gaz',
      'Electromagnetic Repellant': 'Hyperdécharge électromagnétique',
      'Elimination': 'Laser antipersonnel',
      'Infantry Deterrent': 'Bombardement de terrassement',
      'Lamellar Light': 'Phosphorescence',
      'Lifesbreath': 'Vitalisme',
      'Loving Embrace': 'Aile de la bienveillance',
      'Miasmata': 'Propagation de la toxine',
      'Necrotic Fluid': 'Explosion de fiel',
      'No Future': 'Pas d\'avenir',
      'Order to Fire': 'Ordre d\'attaquer',
      'Peacefire': 'Dispenseur de paix',
      'Pity': 'Miséricorde',
      'Pox Flail': 'Poing variolé',
      'Prance': 'Cabriole',
      'Small-bore Laser': 'Laser à faisceau étroit',
      'Still Embrace': 'Aile du repos éternel',
      'Warm Glow': 'Lumière de la miséricorde',
      'Wave of Nausea': 'Torrent de toxine'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Caustic Grebuloff': 'グレビュオフ・メルター',
      'Golden Wings': '黄金蝶',
      'Peacekeeper': 'ピースキーパー',
      'Perpetual War Machine': '自動殺傷兵器',
      'Ra-la': 'ラーラー',
      'The Deterrence Grounds': '抑止の丘',
      'The Shell Mound': '消えゆく貝塚',
      'The World Tree': '世界樹の庭',
      'Weeping Miasma': '腐毒素'
    },
    'replaceText': {
      'Befoulment': '膿汁弾',
      'Benevolence': '博愛',
      'Blighted Water': '腐水塊',
      'Certain Solitude': '孤独の絶望',
      'Cough Up': '胸水流',
      'Decimation': '焼却光線',
      'Disengage Hatch': '格納ハッチ開放',
      'Eclipsing Exhaust': '大噴射',
      'Electromagnetic Repellant': '超電磁放射',
      'Elimination': '対人光線',
      'Infantry Deterrent': '対地爆弾',
      'Lamellar Light': '燐光',
      'Lifesbreath': '生気',
      'Loving Embrace': '慈愛の翼',
      'Miasmata': '腐毒素飛散',
      'Necrotic Fluid': '死腐毒飛散',
      'No Future': 'ノーフューチャー',
      'Order to Fire': '攻撃命令',
      'Peacefire': '平和砲',
      'Pity': '慈悲',
      'Pox Flail': '痘瘡の拳',
      'Prance': '躍動',
      'Small-bore Laser': '小口径光線',
      'Still Embrace': '安寧の翼',
      'Warm Glow': '慈光',
      'Wave of Nausea': '病の激流'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Caustic Grebuloff': '变异的格雷布洛弗',
      'Golden Wings': '黄金蝶',
      'Peacekeeper': '和平捍卫者',
      'Perpetual War Machine': '自动杀伤兵器',
      'Ra-la': '拉啦',
      'The Deterrence Grounds': '威慑山丘',
      'The Shell Mound': '即将消失的贝塚',
      'The World Tree': '世界树庭园',
      'Weeping Miasma': '腐烂毒素'
    },
    'replaceText': {
      '\\(circles\\)': '(圆)',
      '\\(spread\\)': '(扩散)',
      'Befoulment': '脓液弹',
      'Benevolence': '博爱',
      'Blighted Water': '腐水块',
      'Certain Solitude': '孤独的绝望',
      'Cough Up': '咳出',
      'Decimation': '烧尽光线',
      'Disengage Hatch': '开放仓库舱口',
      'Eclipsing Exhaust': '大喷射',
      'Electromagnetic Repellant': '超电磁放射',
      'Elimination': '对人光线',
      'Infantry Deterrent': '对地炸弹',
      'Lamellar Light': '燐光',
      'Lifesbreath': '生息',
      'Loving Embrace': '慈爱之翼',
      'Miasmata': '腐烂毒素飞散',
      'Necrotic Fluid': '致死腐烂毒素飞散',
      'No Future': '未来不再',
      'Order to Fire': '攻击命令',
      'Peacefire': '和平炮',
      'Pity': '慈悲',
      'Pox Flail': '痘疮之拳',
      'Prance': '跃动',
      'Small-bore Laser': '小口径射线',
      'Still Embrace': '安宁之翼',
      'Warm Glow': '慈光',
      'Wave of Nausea': '疾病激流'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Caustic Grebuloff': '부식된 그레불로프',
      'Golden Wings': '황금나비',
      'Peacekeeper': '평화수호자',
      'Perpetual War Machine': '자동살상병기',
      'Ra-la': '라라',
      'The Deterrence Grounds': '억제 언덕',
      'The Shell Mound': '사라져가는 패총',
      'The World Tree': '세계수 정원',
      'Weeping Miasma': '부패 독소'
    },
    'replaceText': {
      '\\(circles\\)': '(장판)',
      '\\(spread\\)': '(산개)',
      'Befoulment': '고름탄',
      'Benevolence': '박애',
      'Blighted Water': '썩은물 덩어리',
      'Certain Solitude': '고독의 절망',
      'Cough Up': '흉수류',
      'Decimation': '소각 광선',
      'Disengage Hatch': '격납문 개방',
      'Eclipsing Exhaust': '대분사',
      'Electromagnetic Repellant': '초전자 방사',
      'Elimination': '대인 광선',
      'Infantry Deterrent': '대지 폭탄',
      'Lamellar Light': '인광',
      'Lifesbreath': '생기',
      'Loving Embrace': '자애의 날개',
      'Miasmata': '부패 독소 살포',
      'Necrotic Fluid': '죽음의 부패독 살포',
      'No Future': '미래는 없다',
      'Order to Fire': '공격 명령',
      'Peacefire': '평화포',
      'Pity': '자비',
      'Pox Flail': '두창 주먹',
      'Prance': '약동',
      'Small-bore Laser': '소구경 광선',
      'Still Embrace': '안녕의 날개',
      'Warm Glow': '자광',
      'Wave of Nausea': '병의 격류'
    }
  }]
};
/* harmony default export */ const the_dead_ends = (the_dead_ends_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/the_dead_ends.txt
const dungeon_the_dead_ends_namespaceObject = "# The Dead Ends\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~~~~~~~~~~~#\r\n# CAUSTIC GREBULOFF #\r\n#~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 653C:1018.1\r\n# -ii 6542 6EBC 6544 653E\r\n\r\n# Shell Mound will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1008\" } window 10000,0\r\n1013.1 \"--sync--\" StartsUsing { id: \"653C\", source: \"Caustic Grebuloff\" }\r\n1018.1 \"Miasmata\" Ability { id: \"653C\", source: \"Caustic Grebuloff\" }\r\n1028.5 \"Necrotic Fluid\" Ability { id: \"653F\", source: \"Weeping Miasma\" } duration 10.6\r\n\r\n1050.2 \"Cough Up x3\" Ability { id: \"653D\", source: \"Caustic Grebuloff\" }\r\n1055.4 \"Certain Solitude\" Ability { id: \"6EBD\", source: \"Caustic Grebuloff\" }\r\n1067.5 \"Wave of Nausea\" Ability { id: \"6EBB\", source: \"Caustic Grebuloff\" }\r\n1080.8 \"Miasmata\" Ability { id: \"653C\", source: \"Caustic Grebuloff\" }\r\n1090.9 \"Wave of Nausea\" Ability { id: \"6EBB\", source: \"Caustic Grebuloff\" }\r\n1091.1 \"Necrotic Fluid\" Ability { id: \"653F\", source: \"Weeping Miasma\" } duration 10.6\r\n1114.9 \"Pox Flail\" Ability { id: \"6540\", source: \"Caustic Grebuloff\" }\r\n1125.0 \"Blighted Water\" Ability { id: \"6541\", source: \"Caustic Grebuloff\" }\r\n1135.2 \"Befoulment\" Ability { id: \"6543\", source: \"Caustic Grebuloff\" }\r\n\r\n1150.4 \"Cough Up x3\" Ability { id: \"653D\", source: \"Caustic Grebuloff\" } window 50,50 jump 1050.2\r\n1155.6 \"Certain Solitude\" #Ability { id: \"6EBD\", source: \"Caustic Grebuloff\" }\r\n1167.7 \"Wave of Nausea\" #Ability { id: \"6EBB\", source: \"Caustic Grebuloff\" }\r\n1181.0 \"Miasmata\" #Ability { id: \"653C\", source: \"Caustic Grebuloff\" }\r\n1191.1 \"Wave of Nausea\" #Ability { id: \"6EBB\", source: \"Caustic Grebuloff\" }\r\n\r\n\r\n#~~~~~~~~~~~~~#\r\n# PEACEKEEPER #\r\n#~~~~~~~~~~~~~#\r\n\r\n# -p 6550:2012\r\n# -ii 6579 6EBE 6547 654E\r\n\r\nhideall \"Disengage Hatch\"\r\n\r\n# Deterrence Grounds will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1009\" } window 10000,0\r\n2007.0 \"--sync--\" StartsUsing { id: \"6550\", source: \"Peacekeeper\" }\r\n2012.0 \"Decimation\" Ability { id: \"6550\", source: \"Peacekeeper\" }\r\n2018.1 \"Electromagnetic Repellant\" Ability { id: \"6EC8\", source: \"Peacekeeper\" }\r\n2021.0 \"Disengage Hatch\" Ability { id: \"6EC4\", source: \"Peacekeeper\" }\r\n2026.3 \"--sync--\" Ability { id: \"6EC5\", source: \"Peacekeeper\" }\r\n2028.6 \"Infantry Deterrent\" Ability { id: \"6EC6\", source: \"Peacekeeper\" }\r\n2036.7 \"Small-bore Laser\" Ability { id: \"6EC0\", source: \"Perpetual War Machine\" }\r\n2036.7 \"Order to Fire\" Ability { id: \"6EBF\", source: \"Peacekeeper\" }\r\n2038.6 \"Infantry Deterrent\" Ability { id: \"6EC7\", source: \"Peacekeeper\" }\r\n2041.0 \"Disengage Hatch\" Ability { id: \"6EC4\", source: \"Peacekeeper\" }\r\n2046.7 \"--sync--\" Ability { id: \"6EC5\", source: \"Peacekeeper\" }\r\n\r\n2051.9 \"No Future (circles)\" Ability { id: \"6545\", source: \"Peacekeeper\" } duration 12.4\r\n2064.9 \"--sync--\" Ability { id: \"6546\", source: \"Peacekeeper\" }\r\n2065.8 \"No Future (spread)\" Ability { id: \"6548\", source: \"Peacekeeper\" }\r\n\r\n2077.3 \"Peacefire\" Ability { id: \"654D\", source: \"Peacekeeper\" } duration 38.7\r\n2083.4 \"Electromagnetic Repellant\" Ability { id: \"6EC8\", source: \"Peacekeeper\" }\r\n2085.6 \"Disengage Hatch\" Ability { id: \"6EC4\", source: \"Peacekeeper\" }\r\n2090.8 \"--sync--\" Ability { id: \"6EC5\", source: \"Peacekeeper\" }\r\n2098.0 \"Small-bore Laser\" Ability { id: \"6EC0\", source: \"Perpetual War Machine\" }\r\n2098.0 \"Order to Fire\" Ability { id: \"6EBF\", source: \"Peacekeeper\" }\r\n2102.2 \"Disengage Hatch\" Ability { id: \"6EC4\", source: \"Peacekeeper\" }\r\n2107.9 \"--sync--\" Ability { id: \"6EC5\", source: \"Peacekeeper\" }\r\n2114.0 \"Eclipsing Exhaust\" Ability { id: \"654B\", source: \"Peacekeeper\" }\r\n2123.3 \"Elimination\" Ability { id: \"654F\", source: \"Peacekeeper\" }\r\n\r\n2134.0 \"No Future (circles)\" Ability { id: \"6545\", source: \"Peacekeeper\" }\r\n2151.4 \"No Future (spread)\" Ability { id: \"6548\", source: \"Peacekeeper\" }\r\n2153.1 \"--sync--\" Ability { id: \"6546\", source: \"Peacekeeper\" }\r\n2171.3 \"Decimation\" Ability { id: \"6550\", source: \"Peacekeeper\" }\r\n2182.5 \"Elimination\" Ability { id: \"654F\", source: \"Peacekeeper\" }\r\n2194.6 \"Decimation\" Ability { id: \"6550\", source: \"Peacekeeper\" }\r\n\r\n2203.9 \"Peacefire\" Ability { id: \"654D\", source: \"Peacekeeper\" } duration 38.7 window 50,50 jump 2077.3\r\n2210.0 \"Electromagnetic Repellant\" #Ability { id: \"6EC8\", source: \"Peacekeeper\" }\r\n2212.2 \"Disengage Hatch\" #Ability { id: \"6EC4\", source: \"Peacekeeper\" }\r\n2217.4 \"--sync--\" #Ability { id: \"6EC5\", source: \"Peacekeeper\" }\r\n2224.6 \"Small-bore Laser\" #Ability { id: \"6EC0\", source: \"Perpetual War Machine\" }\r\n2224.6 \"Order to Fire\" #Ability { id: \"6EBF\", source: \"Peacekeeper\" }\r\n\r\n\r\n#~~~~~~~#\r\n# RA-LA #\r\n#~~~~~~~#\r\n\r\n# -p 655E:3013.5\r\n# -ii 655A 655C 655F\r\n\r\n# The World Tree will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"100A\" } window 10000,0\r\n3008.5 \"--sync--\" StartsUsing { id: \"655E\", source: \"Ra-la\" }\r\n3013.5 \"Warm Glow\" Ability { id: \"655E\", source: \"Ra-la\" }\r\n3023.7 \"Pity\" Ability { id: \"655D\", source: \"Ra-la\" }\r\n3035.9 \"Prance 1\" Ability { id: \"6551\", source: \"Ra-la\" }\r\n3037.8 \"Prance 2\" #Ability { id: \"6552\", source: \"Ra-la\" }\r\n3039.6 \"Prance 3\" #Ability { id: \"6552\", source: \"Ra-la\" }\r\n3041.4 \"Prance 4\" #Ability { id: \"6552\", source: \"Ra-la\" }\r\n3043.1 \"Lamellar Light 1\" #Ability { id: \"6553\", source: \"Ra-la\" }\r\n3045.0 \"Lamellar Light 2\" #Ability { id: \"6553\", source: \"Ra-la\" }\r\n3046.8 \"Lamellar Light 3\" #Ability { id: \"6553\", source: \"Ra-la\" }\r\n3048.6 \"Lamellar Light 4\" #Ability { id: \"6553\", source: \"Ra-la\" }\r\n3055.2 \"Warm Glow\" Ability { id: \"655E\", source: \"Ra-la\" }\r\n3061.4 \"--jump--\" Ability { id: \"6555\", source: \"Ra-la\" }\r\n3067.8 \"Lifesbreath\" Ability { id: \"6554\", source: \"Ra-la\" }\r\n3071.9 \"--jump--\" Ability { id: \"6555\", source: \"Ra-la\" }\r\n3074.7 \"Lamellar Light\" Ability { id: \"6556\", source: \"Golden Wings\" }\r\n\r\n3082.0 \"Benevolence\" Ability { id: \"6559\", source: \"Ra-la\" }\r\n3095.2 \"Loving Embrace\" Ability { id: [\"6557\", \"6558\"], source: \"Ra-la\" }\r\n3103.3 \"Warm Glow\" Ability { id: \"655E\", source: \"Ra-la\" }\r\n3117.5 \"Prance 1\" Ability { id: \"6551\", source: \"Ra-la\" }\r\n3119.4 \"Prance 2\" #Ability { id: \"6552\", source: \"Ra-la\" }\r\n3121.2 \"Prance 3\" #Ability { id: \"6552\", source: \"Ra-la\" }\r\n3123.0 \"Prance 4\" #Ability { id: \"6552\", source: \"Ra-la\" }\r\n3124.7 \"Lamellar Light 1\" #Ability { id: \"6553\", source: \"Ra-la\" }\r\n3126.6 \"Lamellar Light 2\" #Ability { id: \"6553\", source: \"Ra-la\" }\r\n3128.4 \"Lamellar Light 3\" #Ability { id: \"6553\", source: \"Ra-la\" }\r\n3130.2 \"Lamellar Light 4\" #Ability { id: \"6553\", source: \"Ra-la\" }\r\n3135.8 \"Still Embrace\" Ability { id: \"655B\", source: \"Ra-la\" }\r\n\r\n3143.0 \"--jump--\" Ability { id: \"6555\", source: \"Ra-la\" }\r\n3149.4 \"Lifesbreath\" Ability { id: \"6554\", source: \"Ra-la\" }\r\n3156.4 \"Lamellar Light\" Ability { id: \"6556\", source: \"Golden Wings\" }\r\n3160.6 \"Loving Embrace\" Ability { id: [\"6557\", \"6558\"], source: \"Ra-la\" }\r\n3163.8 \"--jump--\" Ability { id: \"6555\", source: \"Ra-la\" }\r\n3170.9 \"Benevolence\" Ability { id: \"6559\", source: \"Ra-la\" }\r\n3183.1 \"Warm Glow\" Ability { id: \"655E\", source: \"Ra-la\" }\r\n3194.3 \"Warm Glow\" Ability { id: \"655E\", source: \"Ra-la\" }\r\n3205.6 \"Pity\" Ability { id: \"655D\", source: \"Ra-la\" }\r\n3218.8 \"Prance 1\" Ability { id: \"6551\", source: \"Ra-la\" }\r\n3220.7 \"Prance 2\" #Ability { id: \"6552\", source: \"Ra-la\" }\r\n3222.5 \"Prance 3\" #Ability { id: \"6552\", source: \"Ra-la\" }\r\n3224.3 \"Prance 4\" #Ability { id: \"6552\", source: \"Ra-la\" }\r\n3226.0 \"Lamellar Light 1\" #Ability { id: \"6553\", source: \"Ra-la\" }\r\n3227.9 \"Lamellar Light 2\" #Ability { id: \"6553\", source: \"Ra-la\" }\r\n3229.7 \"Lamellar Light 3\" #Ability { id: \"6553\", source: \"Ra-la\" }\r\n3231.5 \"Lamellar Light 4\" #Ability { id: \"6553\", source: \"Ra-la\" }\r\n3237.1 \"Still Embrace\" Ability { id: \"655B\", source: \"Ra-la\" }\r\n\r\n3244.3 \"--jump--\" Ability { id: \"6555\", source: \"Ra-la\" }\r\n3250.7 \"Lifesbreath\" Ability { id: \"6554\", source: \"Ra-la\" } window 50,50 jump 3149.4\r\n3257.7 \"Lamellar Light\" #Ability { id: \"6556\", source: \"Golden Wings\" }\r\n3261.9 \"Loving Embrace\" #Ability { id: [\"6557\", \"6558\"], source: \"Ra-la\" }\r\n3265.1 \"--jump--\" #Ability { id: \"6555\", source: \"Ra-la\" }\r\n3272.2 \"Benevolence\" #Ability { id: \"6559\", source: \"Ra-la\" }\r\n3284.4 \"Warm Glow\" #Ability { id: \"655E\", source: \"Ra-la\" }\r\n3295.6 \"Warm Glow\" #Ability { id: \"655E\", source: \"Ra-la\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/the_fell_court_of_troia.ts



const the_fell_court_of_troia_triggerSet = {
  id: 'TheFellCourtOfTroia',
  zoneId: zone_id/* default.TheFellCourtOfTroia */.Z.TheFellCourtOfTroia,
  timelineFile: 'the_fell_court_of_troia.txt',
  triggers: [{
    id: 'Troia Evil Dreamer Dark Vision',
    type: 'StartsUsing',
    netRegex: {
      source: 'Evil Dreamer',
      id: ['73BB', '73B8'],
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Eye Lasers',
        de: 'Weiche dem Augenlaser aus',
        fr: 'Évitez les lasers',
        ja: '目からビーム',
        cn: '躲避视线激光',
        ko: '눈이 쏘는 레이저 피하기'
      }
    }
  }, {
    id: 'Troia Beatrice Void Gravity',
    type: 'StartsUsing',
    netRegex: {
      source: 'Evil Dreamer',
      id: '73BA'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Troia Evil Dreamer Unite Mare',
    type: 'StartsUsing',
    netRegex: {
      source: 'Evil Dreamer',
      id: '73BC',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill One Eye',
        de: 'Besiege ein Auge',
        fr: 'Tuez une tête',
        ja: '安置になる目を攻撃',
        cn: '击杀一只小怪',
        ko: '눈 하나 집중해서 잡기'
      }
    }
  }, {
    id: 'Troia Beatrice Death Forseen Self',
    type: 'StartsUsing',
    netRegex: {
      source: 'Beatrice',
      id: '747D'
    },
    response: responses/* Responses.lookAwayFromSource */.n3.lookAwayFromSource()
  }, {
    id: 'Troia Beatrice Death Forseen Other',
    type: 'StartsUsing',
    netRegex: {
      source: 'Beatrice',
      id: '7484',
      capture: false
    },
    // TODO: calling out twice seems noisy, but not sure what else to say
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Look Away from Rings',
        de: 'Schau von den Ringen weg',
        fr: 'Ne regardez pas l\'anneau',
        ja: '輪の目から視線回避',
        cn: '视线避开圆环',
        ko: '고리 모양 눈 시선 피하기'
      }
    }
  }, {
    id: 'Troia Beatrice Beatific Scorn',
    type: 'StartsUsing',
    netRegex: {
      source: 'Beatrice',
      id: '7475',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Exploding Lines',
        de: 'Weg von den explodierenden Linien',
        fr: 'Éloignez-vous des lignes explosives',
        ja: '線から離れる',
        cn: '避开即将爆炸的线',
        ko: '폭발하는 선 멀리 피하기'
      }
    }
  }, {
    id: 'Troia Beatrice Hush',
    type: 'StartsUsing',
    // Does not cleave.
    netRegex: {
      source: 'Beatrice',
      id: '7480'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Troia Beatrice Void Nail',
    type: 'StartsUsing',
    netRegex: {
      source: 'Beatrice',
      id: '747F'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Troia Beatrice Eye of Troia',
    type: 'StartsUsing',
    netRegex: {
      source: 'Beatrice',
      id: '747A',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Troia Beatrice Antipressure',
    type: 'StartsUsing',
    netRegex: {
      source: 'Beatrice',
      id: '79E8'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Troia Scarmiglione Cursed Echo',
    type: 'StartsUsing',
    netRegex: {
      source: 'Scarmiglione',
      id: '7631',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'Troia Scarmiglione Rotten Rampage',
    type: 'StartsUsing',
    netRegex: {
      source: 'Scarmiglione',
      id: '7619'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Troia Scarmiglione Vacuum Wave',
    type: 'StartsUsing',
    netRegex: {
      source: 'Scarmiglione',
      id: '761C',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback Into Wall',
        de: 'Rückstoß in eine Wand',
        fr: 'Faites-vous pousser sur un mur',
        ja: '壁にノックバック',
        cn: '击退到护栏',
        ko: '벽으로 넉백되기'
      }
    }
  }, {
    id: 'Troia Scarmiglione Blighted Bladework',
    type: 'StartsUsing',
    netRegex: {
      source: 'Scarmiglione',
      id: '7633',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Behind and Out',
        de: 'Geh nach Hinten und Raus',
        fr: 'Passez derrière et extérieur',
        ja: '後ろの外側へ',
        cn: '去背后远离',
        ko: '보스 뒤 바깥쪽으로'
      }
    }
  }, {
    id: 'Troia Scarmiglione Blighted Sweep',
    type: 'StartsUsing',
    netRegex: {
      source: 'Scarmiglione',
      id: '7635',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Troia Scarmiglione Void Vortex',
    type: 'StartsUsing',
    // 7623 during add phase, 762E after
    netRegex: {
      source: 'Scarmiglione',
      id: ['7623', '762E']
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Troia Scarmiglione Void Gravity',
    type: 'StartsUsing',
    netRegex: {
      source: 'Scarmiglione',
      id: '7622'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Troia Scarmiglione Firedamp',
    type: 'StartsUsing',
    netRegex: {
      source: 'Scarmiglione',
      id: '7637'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Beatrice': 'Beatrice',
      'Evil Dreamer': 'bös(?:e|er|es|en) Träumer',
      'Penitence': 'Sühneshalle',
      'Scarmiglione': 'Scarmiglione',
      'The Seat Of The Foremost': 'Sitz der Hohepriesterin',
      'The Garden Of Epopts': 'Garten der Schwestern'
    },
    'replaceText': {
      'Antipressure': 'Nichtsdruck',
      'Beatific Scorn': 'Seliger Zorn',
      'Blighted Bedevilment': 'Verderbte Verhexung',
      'Blighted Bladework': 'Verderbtes Fechten',
      'Blighted Sweep': 'Verderbter Schwung',
      'Corruptor\'s Pitch': 'Morast des Verderbers',
      'Creeping Decay': 'Schleichendes Siechtum',
      'Cursed Echo': 'Fluches Hall',
      'Dark Vision': 'Dunkle Vision',
      'Death Foreseen': 'Tödliche Vorsehung',
      'Endless Nightmare': 'Ewiger Albtraum',
      'Eye of Troia': 'Auge von Troia',
      'Firedamp': 'Grubengas',
      'Hush': 'Totenstill',
      'Nox': 'Nox',
      'Rotten Rampage': 'Fauliger Amok',
      'Toric Void': 'Nichts-Torus',
      'Unite Mare': 'Alltraum',
      'Vacuum Wave': 'Vakuumwelle',
      'Void Gravity': 'Nichts-Gravitas',
      'Void Nail': 'Nichtsnagel',
      'Void Vortex': 'Nichtssog',
      'Voidshaker': 'Nichtsstoß'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Beatrice': 'Béatrice',
      'Evil Dreamer': 'rêveur maudit',
      'Penitence': 'Salle des admonestations',
      'Scarmiglione': 'Scarmiglione',
      'The Seat Of The Foremost': 'Salle des primiciers',
      'The Garden Of Epopts': 'Enclos des sœurs'
    },
    'replaceText': {
      'Antipressure': 'Pression du néant',
      'Beatific Scorn': 'Lueur mystique',
      'Blighted Bedevilment': 'Pirouette nécrophage',
      'Blighted Bladework': 'Lacération nécrophage',
      'Blighted Sweep': 'Balayage nécrophage',
      'Corruptor\'s Pitch': 'Bourbier corrupteur',
      'Creeping Decay': 'Déclin rampant',
      'Cursed Echo': 'Écho maudit',
      'Dark Vision': 'Vision cauchemardesque',
      'Death Foreseen': 'Œil de la faucheuse',
      'Endless Nightmare': 'Cauchemar sans fin',
      'Eye of Troia': 'Œil de Troïa',
      'Firedamp': 'Vapeur de feu',
      'Hush': 'Mise sous silence',
      'Nox': 'Nox',
      'Rotten Rampage': 'Ravage putride',
      'Toric Void': 'Tore du néant',
      'Unite Mare': 'Cauchemar traumatique',
      'Vacuum Wave': 'Vague de vide',
      'Void Gravity': 'Gravité du néant',
      'Void Nail': 'Clou du néant',
      'Void Vortex': 'Vortex du néant',
      'Voidshaker': 'Secousse du néant'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Beatrice': 'ベアトリーチェ',
      'Evil Dreamer': 'ドリームエビル',
      'Penitence': '責罪広場',
      'Scarmiglione': 'スカルミリョーネ',
      'The Seat Of The Foremost': '筆頭神官の間',
      'The Garden Of Epopts': '姉妹たちの園'
    },
    'replaceText': {
      'Antipressure': 'ヴォイドプレッシャー',
      'Beatific Scorn': '魔光閃',
      'Blighted Bedevilment': '死喰剣・旋転',
      'Blighted Bladework': '死喰剣・断裁',
      'Blighted Sweep': '死喰剣・払除',
      'Corruptor\'s Pitch': 'コラプターズ・ピッチ',
      'Creeping Decay': '腐屍招来',
      'Cursed Echo': 'カースドエコー',
      'Dark Vision': '夢魔の視線',
      'Death Foreseen': '死の魔眼',
      'Endless Nightmare': '死重爆',
      'Eye of Troia': 'トロイアの魔眼',
      'Firedamp': 'ファイアダンプ',
      'Hush': 'ハッシュスイング',
      'Nox': 'ノックス',
      'Rotten Rampage': 'ロトンランページ',
      'Toric Void': 'ヴォイドトーラス',
      'Unite Mare': '重魂爆',
      'Vacuum Wave': '真空波',
      'Void Gravity': 'ヴォイド・グラビデ',
      'Void Nail': 'ヴォイドネイル',
      'Void Vortex': 'ヴォイドヴォーテックス',
      'Voidshaker': 'ヴォイドシェイカー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Beatrice': '贝雅特丽齐',
      'Evil Dreamer': '梦祸',
      'Penitence': '责罪广场',
      'Scarmiglione': '斯卡米留尼',
      'The Seat Of The Foremost': '首席神官之间',
      'The Garden Of Epopts': '姐妹之园'
    },
    'replaceText': {
      'Antipressure': '虚无强压',
      'Beatific Scorn': '魔光闪',
      'Blighted Bedevilment': '食死剑·回旋',
      'Blighted Bladework': '食死剑·裁断',
      'Blighted Sweep': '食死剑·横扫',
      'Corruptor\'s Pitch': '腐败沥青池',
      'Creeping Decay': '召唤腐尸',
      'Cursed Echo': '诅咒回声',
      'Dark Vision': '梦祸视线',
      'Death Foreseen': '死亡魔眼',
      'Endless Nightmare': '死重爆',
      'Eye of Troia': '特罗亚魔眼',
      'Firedamp': '沼气',
      'Hush': '静寂一挥',
      'Nox': '夜',
      'Rotten Rampage': '腐烂狂怒',
      'Toric Void': '虚无环',
      'Unite Mare': '重魂爆',
      'Vacuum Wave': '真空波',
      'Void Gravity': '虚空重力',
      'Void Nail': '虚无钉',
      'Void Vortex': '虚无旋涡',
      'Voidshaker': '虚无摇动'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Beatrice': '베아트리체',
      'Evil Dreamer': '몽마',
      'Penitence': '문책 광장',
      'Scarmiglione': '스카르밀리오네',
      'The Seat Of The Foremost': '최고신관의 방',
      'The Garden Of Epopts': '자매의 뜰'
    },
    'replaceText': {
      'Antipressure': '보이드의 압력',
      'Beatific Scorn': '마광섬',
      'Blighted Bedevilment': '죽음을 먹는 검: 회전',
      'Blighted Bladework': '죽음을 먹는 검: 처단',
      'Blighted Sweep': '죽음을 먹는 검: 휩쓸기',
      'Corruptor\'s Pitch': '부패자의 늪',
      'Creeping Decay': '썩은 시체 소환',
      'Cursed Echo': '저주받은 메아리',
      'Dark Vision': '몽마의 시선',
      'Death Foreseen': '죽음의 마안',
      'Endless Nightmare': '죽음의 융합 폭발',
      'Eye of Troia': '트로이아의 마안',
      'Firedamp': '폭발 가스',
      'Hush': '정숙',
      'Nox': '암야',
      'Rotten Rampage': '썩은 광란',
      'Toric Void': '보이드의 고리',
      'Unite Mare': '융합 폭발',
      'Vacuum Wave': '진공파',
      'Void Gravity': '보이드 그라비데',
      'Void Nail': '보이드의 손톱',
      'Void Vortex': '보이드의 돌풍',
      'Voidshaker': '요동치는 보이드'
    }
  }]
};
/* harmony default export */ const the_fell_court_of_troia = (the_fell_court_of_troia_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/the_fell_court_of_troia.txt
const dungeon_the_fell_court_of_troia_namespaceObject = "# The Fell Court of Troia\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~~~~~~~~~#\r\n# EVIL DREAMER(s) #\r\n#~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 73B8:1208 73BA:1408 73BB:1608 73B6:1817 73BE:1860\r\n# -ii 73BD 73B5 73B7\r\n\r\n# Phase pushes here push when adds are all dead.\r\n# Hard to tell if there's a time based push, but have seen it push when some adds still alive?\r\n\r\n# Penitence will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1058\" } window 10000,0\r\n\r\n1200.0 \"--sync--\" StartsUsing { id: \"73B8\", source: \"Evil Dreamer\" } window 200,0\r\n1208.0 \"Dark Vision\" Ability { id: \"73B8\", source: \"Evil Dreamer\" }\r\n\r\n1400.0 \"--sync--\" StartsUsing { id: \"73B8\", source: \"Evil Dreamer\" } window 200,0\r\n1408.0 \"Dark Vision\" Ability { id: \"73B8\", source: \"Evil Dreamer\" }\r\n1408.0 \"Void Gravity\" Ability { id: \"73BA\", source: \"Evil Dreamer\" }\r\n\r\n1600.0 \"--sync--\" StartsUsing { id: \"73BB\", source: \"Evil Dreamer\" } window 200,0\r\n1608.0 \"Dark Vision\" Ability { id: \"73BB\", source: \"Evil Dreamer\" }\r\n1608.0 \"Unite Mare\" Ability { id: \"73BC\", source: \"Evil Dreamer\" }\r\n\r\n1800.0 \"--sync--\" StartsUsing { id: \"73BE\", source: \"Evil Dreamer\" } window 200,0\r\n1817.0 \"Unite Mare\" Ability { id: \"73B6\", source: \"Evil Dreamer\" }\r\n1828.0 \"Unite Mare\" Ability { id: \"73B6\", source: \"Evil Dreamer\" }\r\n# guessing at these\r\n1839.0 \"Unite Mare\" Ability { id: \"73B6\", source: \"Evil Dreamer\" }\r\n1850.0 \"Unite Mare\" Ability { id: \"73B6\", source: \"Evil Dreamer\" }\r\n\r\n1860.0 \"Endless Nightmare Enrage\" StartsUsing { id: \"73BE\", source: \"Evil Dreamer\" }\r\n\r\n\r\n#~~~~~~~~~~#\r\n# BEATRICE #\r\n#~~~~~~~~~~#\r\n\r\n# -p 747C:2011.3\r\n# -ii 79E7\r\n\r\n# TODO: Beatific Scorn is 747 + 5/8/4/7, or 3/8/6/7, are these directions??\r\n\r\n# Seat of the Foremost will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1059\" } window 10000,0\r\n2011.3 \"--middle--\" Ability { id: \"747C\", source: \"Beatrice\" }\r\n2016.5 \"Eye of Troia\" Ability { id: \"747A\", source: \"Beatrice\" }\r\n2022.5 \"Death Foreseen\" Ability { id: \"747D\", source: \"Beatrice\" }\r\n2029.7 \"Beatific Scorn x4\" #Ability { id: \"7475\", source: \"Beatrice\" } # ???\r\n2040.5 \"Beatific Scorn 1\" #Ability { id: \"7479\", source: \"Beatrice\" }\r\n2042.2 \"Beatific Scorn 2\" #Ability { id: \"7479\", source: \"Beatrice\" }\r\n2043.8 \"Beatific Scorn 3\" #Ability { id: \"7479\", source: \"Beatrice\" }\r\n2045.5 \"Beatific Scorn 4\" #Ability { id: \"7479\", source: \"Beatrice\" }\r\n2048.4 \"--sync--\" Ability { id: \"747B\", source: \"Beatrice\" }\r\n2060.6 \"Hush\" Ability { id: \"7480\", source: \"Beatrice\" }\r\n\r\n2067.7 \"--middle--\" Ability { id: \"747C\", source: \"Beatrice\" }\r\n2074.0 \"Voidshaker\" Ability { id: \"747E\", source: \"Beatrice\" }\r\n2077.0 \"Void Nail\" Ability { id: \"747F\", source: \"Beatrice\" }\r\n\r\n2084.2 \"--middle--\" Ability { id: \"747C\", source: \"Beatrice\" }\r\n2089.4 \"Eye of Troia\" Ability { id: \"747A\", source: \"Beatrice\" }\r\n2100.5 \"Death Foreseen 1\" Ability { id: \"7484\", source: \"Beatrice\" }\r\n2100.5 \"Toric Void\" Ability { id: \"7485\", source: \"Beatrice\" }\r\n2104.5 \"Death Foreseen 2\" Ability { id: \"7484\", source: \"Beatrice\" }\r\n2104.6 \"Toric Void\" Ability { id: \"79E6\", source: \"Beatrice\" }\r\n2107.4 \"Void Nail\" Ability { id: \"747F\", source: \"Beatrice\" }\r\n\r\n2114.8 \"--middle--\" Ability { id: \"747C\", source: \"Beatrice\" }\r\n2120.0 \"Beatific Scorn x4\" #Ability { id: \"7473\", source: \"Beatrice\" } # ???\r\n2122.9 \"Antipressure\" Ability { id: \"79E8\", source: \"Beatrice\" }\r\n2130.7 \"Beatific Scorn 1\" #Ability { id: \"7479\", source: \"Beatrice\" }\r\n2132.4 \"Beatific Scorn 2\" #Ability { id: \"7479\", source: \"Beatrice\" }\r\n2134.0 \"Beatific Scorn 3\" #Ability { id: \"7479\", source: \"Beatrice\" }\r\n2135.7 \"Beatific Scorn 4\" #Ability { id: \"7479\", source: \"Beatrice\" }\r\n2138.6 \"--sync--\" Ability { id: \"747B\", source: \"Beatrice\" }\r\n2150.8 \"Hush\" Ability { id: \"7480\", source: \"Beatrice\" }\r\n\r\n# loop\r\n2157.9 \"--middle--\" Ability { id: \"747C\", source: \"Beatrice\" }\r\n2164.2 \"Voidshaker\" Ability { id: \"747E\", source: \"Beatrice\" } window 80,80 jump 2074\r\n2167.2 \"Void Nail\" #Ability { id: \"747F\", source: \"Beatrice\" }\r\n\r\n2174.4 \"--middle--\" #Ability { id: \"747C\", source: \"Beatrice\" }\r\n2179.6 \"Eye of Troia\" #Ability { id: \"747A\", source: \"Beatrice\" }\r\n2190.7 \"Death Foreseen 1\" #Ability { id: \"7484\", source: \"Beatrice\" }\r\n2190.7 \"Toric Void\" #Ability { id: \"7485\", source: \"Beatrice\" }\r\n2194.7 \"Death Foreseen 2\" #Ability { id: \"7484\", source: \"Beatrice\" }\r\n2194.8 \"Toric Void\" #Ability { id: \"79E6\", source: \"Beatrice\" }\r\n2197.6 \"Void Nail\" #Ability { id: \"747F\", source: \"Beatrice\" }\r\n\r\n\r\n#~~~~~~~~~~~~~~#\r\n# SCARMIGLIONE #\r\n#~~~~~~~~~~~~~~#\r\n\r\n# -p 7631:3009.1 7625:3400\r\n# -ii 7632 7634 7618 7619 7637 7627 7628 7629\r\n# -it \"Scarmiglione\"\r\n\r\n# The Garden of Epopts will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"105A\" } window 10000,0\r\n3005.1 \"--sync--\" Ability { id: \"7631\", source: \"Scarmiglione\" } window 10,10\r\n3009.1 \"Cursed Echo\" Ability { id: \"7631\", source: \"Scarmiglione\" }\r\n3016.3 \"--sync--\" Ability { id: \"761D\", source: \"Scarmiglione\" }\r\n3027.1 \"Rotten Rampage\" Ability { id: \"7617\", source: \"Scarmiglione\" }\r\n3034.2 \"--sync--\" Ability { id: \"761A\", source: \"Scarmiglione\" }\r\n3041.6 \"Blighted Bedevilment\" Ability { id: \"761B\", source: \"Scarmiglione\" }\r\n3042.2 \"Vacuum Wave\" Ability { id: \"761C\", source: \"Scarmiglione\" }\r\n3048.3 \"--sync--\" Ability { id: \"761D\", source: \"Scarmiglione\" }\r\n3061.5 \"Blighted Bladework\" Ability { id: \"7633\", source: \"Scarmiglione\" }\r\n3072.5 \"Blighted Sweep\" Ability { id: \"7635\", source: \"Scarmiglione\" }\r\n3083.6 \"Firedamp\" Ability { id: \"7636\", source: \"Scarmiglione\" }\r\n3088.9 \"--sync--\" Ability { id: \"761D\", source: \"Scarmiglione\" }\r\n3095.3 \"Creeping Decay\" Ability { id: \"7620\", source: \"Scarmiglione\" }\r\n\r\n3098.4 \"--sync--\" Ability { id: \"7624\", source: \"Scarmiglione\" }\r\n3098.4 \"--untargetable--\"\r\n3115.5 \"Nox\" Ability { id: \"7621\", source: \"Scarmiglione\" }\r\n# These seem to be adjusted slightly in time based on which order they come in.\r\n3118.5 \"Void Gravity/Void Vortex\" #Ability { id: [\"7622\", \"7623\"], source: \"Scarmiglione\" }\r\n3142.1 \"Nox\" Ability { id: \"7621\", source: \"Scarmiglione\" }\r\n3148.1 \"Void Vortex/Void Gravity\" #Ability { id: [\"7623\", \"7622\"], source: \"Scarmiglione\" }\r\n\r\n# natural enrage, if add phase is failed\r\n3191.8 \"Corruptor's Pitch\" Ability { id: \"7625\", source: \"Scarmiglione\" } duration 8 window 200,50\r\n\r\n3206.4 \"--targetable--\"\r\n\r\n3212.5 \"--sync--\" Ability { id: \"761D\", source: \"Scarmiglione\" }\r\n3222.7 \"Rotten Rampage\" Ability { id: \"7617\", source: \"Scarmiglione\" }\r\n3229.8 \"--sync--\" Ability { id: \"761A\", source: \"Scarmiglione\" }\r\n3237.2 \"Blighted Bedevilment\" Ability { id: \"761B\", source: \"Scarmiglione\" }\r\n3237.8 \"Vacuum Wave\" Ability { id: \"761C\", source: \"Scarmiglione\" }\r\n3241.9 \"--sync--\" Ability { id: \"762D\", source: \"Scarmiglione\" }\r\n3246.9 \"Void Vortex\" Ability { id: \"762E\", source: \"Scarmiglione\" }\r\n3254.0 \"--sync--\" Ability { id: \"761D\", source: \"Scarmiglione\" }\r\n3266.2 \"Blighted Bladework\" Ability { id: \"7633\", source: \"Scarmiglione\" }\r\n3277.2 \"Blighted Sweep\" Ability { id: \"7635\", source: \"Scarmiglione\" }\r\n3291.4 \"Firedamp\" Ability { id: \"7636\", source: \"Scarmiglione\" }\r\n3301.5 \"Cursed Echo\" Ability { id: \"7631\", source: \"Scarmiglione\" }\r\n\r\n# loop\r\n3308.7 \"--sync--\" Ability { id: \"761D\", source: \"Scarmiglione\" }\r\n3318.9 \"Rotten Rampage\" Ability { id: \"7617\", source: \"Scarmiglione\" } window 50,50 jump 3222.7\r\n3326.0 \"--sync--\" #Ability { id: \"761A\", source: \"Scarmiglione\" }\r\n3333.4 \"Blighted Bedevilment\" #Ability { id: \"761B\", source: \"Scarmiglione\" }\r\n3334.0 \"Vacuum Wave\" #Ability { id: \"761C\", source: \"Scarmiglione\" }\r\n3338.1 \"--sync--\" #Ability { id: \"762D\", source: \"Scarmiglione\" }\r\n3343.1 \"Void Vortex\" #Ability { id: \"762E\", source: \"Scarmiglione\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/the_lunar_subterrane.ts






// TODO: Dark Elf tell people where to go for hidden staves
// TODO: Antlion tell people which row to be in for landslip + towerfall
const elfCenterX = -401.02;
const elfCenterY = -231.01;
const dirNumberToOutput = {
  1: 'northeast',
  3: 'southeast',
  5: 'southwest',
  7: 'northwest'
};
const the_lunar_subterrane_triggerSet = {
  id: 'TheLunarSubteranne',
  zoneId: zone_id/* default.TheLunarSubterrane */.Z.TheLunarSubterrane,
  timelineFile: 'the_lunar_subterrane.txt',
  initData: () => {
    return {
      fountsSeen: 0,
      fountX: [],
      fountY: [],
      staffMatches: []
    };
  },
  triggers: [{
    id: 'Lunar Subterrane Dark Elf Abyssal Outburst',
    type: 'StartsUsing',
    netRegex: {
      id: '87DE',
      source: 'Dark Elf',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Lunar Subterrane Dark Elf Void Dark II',
    type: 'StartsUsing',
    netRegex: {
      id: '87E4',
      source: 'Dark Elf'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Lunar Subterrane Dark Elf Staff Smite',
    type: 'StartsUsing',
    netRegex: {
      id: '8984',
      source: 'Dark Elf'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Lunar Subterrane Dark Elf Shadow Sigil Pink Triangle',
    type: 'StartsUsing',
    netRegex: {
      id: '87DB',
      source: 'Dark Elf',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Blue Square Safe',
        de: 'Blaues Viereck sicher',
        fr: 'Les carrés bleu sont sûrs',
        ja: '安置: 青四角',
        cn: '蓝方块安全',
        ko: '파란색 네모 안전'
      }
    }
  }, {
    id: 'Lunar Subterrane Dark Elf Shadow Sigil Blue Square',
    type: 'StartsUsing',
    netRegex: {
      id: '87DC',
      source: 'Dark Elf',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pink Triangle Safe',
        de: 'Pinkes Dreieck sicher',
        fr: 'Les triangles rose sont sûrs',
        ja: '安置: 赤三角',
        cn: '粉三角安全',
        ko: '분홍색 삼각형 안전'
      }
    }
  }, {
    id: 'Lunar Subterrane Dark Elf Ruinous Hex Collect',
    type: 'StartsUsing',
    netRegex: {
      id: ['89B6', '87DF'],
      source: 'Hexing Staff'
    },
    // Ruinous Hex cast
    run: (data, matches) => data.staffMatches.push(matches)
  }, {
    id: 'Lunar Subterrane Dark Elf Ruinous Hex Call',
    type: 'StartsUsing',
    netRegex: {
      id: '8985',
      source: 'Dark Elf',
      capture: false
    },
    // Cue off Ruinous Confluence
    delaySeconds: 0.5,
    alertText: (data, _matches, output) => {
      // The origin for this encounter is -401.02,-231.01
      // On rounds 1/2, there is almost always a staff in a close square.
      // The safespot in this situation is always diagonally opposite this close square.
      // If there's no close staff, the pattern is always south safe or (assumedly) west safe.
      // On round 3 and later, there is always one staff in a far corner,
      // while two spawn framing the close square opposite this far one:

      //      |-413|-405|-397|-389|
      //      |----|----|----|----|
      // -243 |0000|    |    |    |
      //      |----|----|----|----|
      // -235 |    |    |    |0000|
      //      |----|----|----|----|
      // -227 |    |    |    |    |
      //      |----|----|----|----|
      // -219 |    |0000|    |    |
      //      |----|----|----|----|

      // (This can also be rotated 180 degrees.)

      // To date, only some squares have been observed to be populated.
      // Blank squares here indicate locations that never have a staff.
      // All coordinates are exact, although the log lines include two digits of precision.
      // (-413.00, for instance.)

      //      |-413|-405|-397|-389|
      //      |----|----|----|----|
      // -243 |0000|    |0000|0000|
      //      |----|----|----|----|
      // -235 |    |    |0000|0000|
      //      |----|----|----|----|
      // -227 |0000|0000|0000|    |
      //      |----|----|----|----|
      // -219 |0000|0000|    |0000|
      //      |----|----|----|----|

      // There will *always* be a close safe square.
      // Don't bother with potential safe outer squares.
      let safeX = [-405, -397];
      let safeY = [-235, -227];
      for (const staff of data.staffMatches) {
        if (staff.x === undefined || staff.y === undefined) return output.unknown();
        const staffX = Math.round(parseFloat(staff.x));
        const staffY = Math.round(parseFloat(staff.y));
        safeX = safeX.filter(col => col !== staffX);
        safeY = safeY.filter(col => col !== staffY);
      }
      const finalX = safeX[0];
      const finalY = safeY[0];

      // We don't really care about the specific safe coordinates,
      // the important thing is that there's at least one safe in each of row and column.
      if (finalX === undefined || finalY === undefined) return output.unknown();
      const safeNumber = util/* Directions.xyTo8DirNum */.N.xyTo8DirNum(finalX, finalY, elfCenterX, elfCenterY);
      const outputSelect = dirNumberToOutput[safeNumber];
      if (outputSelect === undefined) return output.unknown();
      return output[outputSelect]();
    },
    run: data => data.staffMatches = [],
    outputStrings: {
      northeast: {
        en: 'Inner northeast safe',
        de: 'Innen nordöstlich sicher',
        fr: 'Nord-est intérieur sûr',
        cn: '内侧 右上(东北) 安全',
        ko: '안쪽 북동 안전'
      },
      northwest: {
        en: 'Inner northwest safe',
        de: 'Innen nordwestlich sicher',
        fr: 'Nord-ouest intérieur sûr',
        cn: '内侧 左上(西北) 安全',
        ko: '안쪽 북서 안전'
      },
      southeast: {
        en: 'Inner southeast safe',
        de: 'Innen südöstlich sicher',
        fr: 'Sud-est intérieur sûr',
        cn: '内侧 右下(东南) 安全',
        ko: '안쪽 남동 안전'
      },
      southwest: {
        en: 'Inner southwest safe',
        de: 'Innen südwestlich sicher',
        fr: 'Sud-Ouest intérieur sûr',
        cn: '内侧 左下(西南) 安全',
        ko: '안쪽 남서 안전'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'Lunar Subterrane Dark Elf Doom',
    type: 'GainsEffect',
    // Doom comes from being hit by Ruinous Hex (the staves).
    // Dark Whispers stacks from being hit by staves decrease the time on this debuff
    // from 15 -> 7 -> 3. The Dark Whispers stacks top out at 2.
    netRegex: {
      effectId: 'D24'
    },
    condition: data => util/* default.canCleanse */.Z.canCleanse(data.job),
    alertText: (data, matches, output) => {
      return output.cleanse({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      cleanse: {
        en: 'Cleanse ${player}\'s Doom',
        de: 'Reinige ${player}\'s Verhängnis',
        fr: 'Guérissez le Glas de ${player}',
        ja: 'エスナ: ${player}',
        cn: '康复: ${player}',
        ko: '${player} 선고 해제하기'
      }
    }
  }, {
    id: 'Lunar Subterrane Antlion Sandblast',
    type: 'StartsUsing',
    netRegex: {
      id: '87FD',
      source: 'Damcyan Antlion',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Lunar Subterrane Antlion Earthen Geyser',
    type: 'StartsUsing',
    netRegex: {
      id: '8806',
      source: 'Damcyan Antlion'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Lunar Subterrane Antlion Pound Sand',
    type: 'Ability',
    // This is on the Earthen Geyser hit.
    netRegex: {
      id: '8806',
      source: 'Damcyan Antlion'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Lunar Subterrane Durante Old Magic',
    type: 'StartsUsing',
    netRegex: {
      id: '88C3',
      source: 'Durante',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Lunar Subterrane Durante Fallen Grace',
    type: 'StartsUsing',
    netRegex: {
      id: '8C2A',
      source: 'Durante'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Lunar Subterrane Durante Antipodal Assault',
    type: 'Ability',
    netRegex: {
      id: '38FC',
      source: 'Durante'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Lunar Subterrane Durante Hard Slash',
    type: 'Ability',
    netRegex: {
      id: '88C0',
      source: 'Durante',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Sides on Wall',
        de: 'Geh seitlich an die Wand',
        fr: 'Allez sur les côtés du mur',
        ja: '壁の方へ',
        cn: '去墙边',
        ko: '옆쪽 벽에 붙기'
      }
    }
  }, {
    id: 'Lunar Subterrane Durante Twilight Phase',
    type: 'StartsUsing',
    netRegex: {
      id: '8CD8',
      source: 'Durante',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'Lunar Subterrane Durante Dark Impact',
    type: 'StartsUsing',
    netRegex: {
      id: '88BA',
      source: 'Durante',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Behind and Out',
        de: 'Geh nach Hinten und Raus',
        fr: 'Passez derrière et à l\'extérieur',
        ja: '後ろの外側へ',
        cn: '去背后远离',
        ko: '보스 뒤 바깥쪽으로'
      }
    }
  }, {
    id: 'Lunar Subterrane Durante Arcane Edge',
    type: 'StartsUsing',
    netRegex: {
      id: '88C2',
      source: 'Durante'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    // Round 1 is always a non-splitting line of orbs.
    id: 'Lunar Subterrane Durante Forsaken Fount 1',
    type: 'Ability',
    netRegex: {
      id: '88BB',
      source: 'Durante',
      capture: false
    },
    condition: data => data.fountsSeen === 0,
    delaySeconds: 1,
    // This collides with Fount 2 if we don't delay. ???
    infoText: (_data, _matches, output) => output.avoid(),
    run: data => data.fountsSeen += 1,
    outputStrings: {
      avoid: {
        en: 'Away from orbs',
        de: 'Weg von den Orbs',
        fr: 'Éloignez-vous des orbes',
        ja: '玉から離れて',
        cn: '远离球',
        ko: '구슬에서 멀리 떨어지기'
      }
    }
  }, {
    // Round 2 is always a splitting line. Center is always safe.
    id: 'Lunar Subterrane Durante Forsaken Fount 2',
    type: 'Ability',
    netRegex: {
      id: '88BB',
      source: 'Durante',
      capture: false
    },
    condition: data => data.fountsSeen === 1,
    delaySeconds: 1,
    response: responses/* Responses.goMiddle */.n3.goMiddle('info'),
    run: data => data.fountsSeen += 1
  }, {
    // On round three and subsequently, known  spawn locations for the Aetheric Charge orbs are:
    // (0,-422)
    // (0, -434.8)
    // (0, -409.2)
    // (3.65, -412.9)
    // (-3.65, -412.95)
    // (9.05, -412.8)
    // (-9.05, -418.35)
    // (9.15, -425.55)
    // (9.15, -431.1)
    // (-9.25, -431.1)
    // (12.8, -422)
    // (-12.8, -422)
    // (Other spawn locations exist for rounds 1/2, but we can ignore those.)

    // The primary known configurations for round three onward are:
    // West Safe
    // (-12.80,-422.00), (0.00,-422.00), (12.80,-422.00)
    // (9.15,-431.10)
    // (3.65,-412.90)

    // North Safe
    // (0.00,-409.20), (0.00,-422.00), (0.00,-434.80)
    // (9.05,-412.80)
    // (-9.05,-418.35)

    // East Safe
    // (-12.80,-422.00),  (0.00,-422.00), (12.80,-422.00)
    // (-9.25,-431.05)
    // (-3.65,-412.95)

    // Hourglass
    // (0.00,-409.20), (0.00,-422.00), (0.00,-434.80)
    // (-9.05,-418.35)
    // (9.15,-425.55)
    // So far nobody has seen a configuration with South being safe.

    // When the Y axis is normalized to 0, the sets look like this:
    // West Safe
    // (-12.80,0), (0,0), (12.8,0)
    // (9.15,-9.1)
    // (3.65,9.1)

    // North Safe
    // (0,12.8), (0,0), (0,-12.8)
    // (9.05,9.2)
    // (-9.05,3.65)

    // East Safe
    // (-12.8,0),  (0,0), (12.8,0)
    // (-9.25,-9.05)
    // (-3.65,9.05)

    // Hourglass
    // (0,12.8), (0,0), (0,-12.8)
    // (-9.05,3.65)
    // (9.15,-3.55)
    id: 'Lunar Subterrane Durante Forsaken Fount 3 Collect',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Aetheric Charge'
    },
    condition: data => data.fountsSeen === 2,
    run: (data, matches) => {
      // Because the positions are relatively fixed, we don't need a reliable order for coordinates.
      // Only the values and the count of those values really is important here.
      data.fountX.push(Math.round(parseFloat(matches.x)));
      data.fountY.push(Math.round(parseFloat(matches.y)) + 422); // Normalize the Y axis to 0
    }
  }, {
    id: 'Lunar Subterrane Durante Forsaken Fount 3 Call',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Aetheric Charge',
      capture: false
    },
    condition: data => data.fountsSeen === 2,
    delaySeconds: 0.5,
    infoText: (data, _matches, output) => {
      if (data.fountX.length < 5 || data.fountY.length < 5) return;
      // If there are five orbs on the field, three of them will, guaranteed,
      // have the same X or Y value. Those three are in a straight line.
      const hCount = data.fountY.filter(n => Math.abs(n) < 1).length;
      const vCount = data.fountX.filter(n => Math.abs(n) < 1).length;
      if (hCount === 3) {
        // Horizontal lines are always east/west safe hammer patterns.
        const xSum = data.fountX.reduce((a, b) => a + b, 0);

        // Don't rely on the rounded sum to be precise, but the sign will be reliable.
        if (xSum > 5) return output.west();
        if (xSum < 5) return output.east();
        return output.unknown();
      }
      if (vCount === 3) {
        // Remember that we're working with 0-normalized Y values here!
        // Positive Y values are south.

        // Vertical lines have two possible patterns, one hammer and one hourglass.
        // If it's hourglass, the rounded  Y positions sum to 0.
        // If it's hammer, the absolute value of rounded sums totals 13.
        // (So far we haven't seen a situation where the rounded total is -13,
        // but handle it anyway just in case.)
        const ySum = data.fountY.reduce((a, b) => a + b, 0);
        if (ySum > 10)
          // Multiple non-line orbs south.
          return output.north();
        if (ySum < -10)
          // Multiple non-line orbs north. THIS DOES NOT NECESSARILY EXIST.
          return output.south();
        return output.center(); // An hourglass configuration.
      }

      return output.unknown();
    },
    run: data => {
      data.fountX = [];
      data.fountY = [];
    },
    outputStrings: {
      west: outputs/* default.west */.Z.west,
      east: outputs/* default.east */.Z.east,
      north: outputs/* default.north */.Z.north,
      south: outputs/* default.south */.Z.south,
      center: outputs/* default.goIntoMiddle */.Z.goIntoMiddle,
      unknown: '???'
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aetheric Charge': 'magisch(?:e|er|es|en) Sphäre',
      'Damcyan Antlion': 'damcyanisch(?:e|er|es|en) Ameisenlöwe',
      'Dark Elf': 'Dunkelelf',
      'Durante': 'Durante',
      'Hexing Staff': 'Stab der Dunkelheit',
      'Stone Pillar': 'Steinsäule',
      'The Bloodied Barbican': 'Schlosspforte',
      'The Carnelian Courtyard': 'Schlossgarten',
      'The Cloven Crystal Square': 'Kristall-Platz'
    },
    'replaceText': {
      '\\(cast\\)': '(Wirken)',
      '\\(spread\\)': '(Verteilen)',
      'Abyssal Outburst': 'Finsterschwall',
      'Antipodal Assault': 'Antipodischer Stoß',
      'Antlion March': 'Mächtiger Marsch',
      'Arcane Edge': 'Arkane Schneide',
      'Contrapasso': 'Contrapasso',
      'Dark Impact': 'Dunkler Einschlag',
      'Death\'s Journey': 'Ende des Weges',
      'Duplicitous Battery': 'Doppelte Barrage',
      'Earthen Geyser': 'Staubiger Geysir',
      'Explosion': 'Explosion',
      'Fallen Grace': 'Banngeschoß',
      'Forsaken Fount': 'Magische Sphären',
      'Hard Slash': 'Harter Schlitzer',
      'Hexing Staves': 'Stäbe der Dunkelheit',
      'Landslip': 'Einsturz',
      'Old Magic': 'Magiefeuer',
      'Pound Sand': 'Sandhammer',
      'Ruinous Confluence': 'Verheerender Fluch',
      'Sandblast': 'Sandschwall',
      'Shadowy Sigil': 'Wappen der Dunkelheit',
      'Sorcerous Shroud': 'Vorhang der Dunkelheit',
      'Splinter': 'Sphärensplitterung',
      'Staff Smite': 'Stabschlag',
      'Towerfall': 'Turmsturz',
      'Twilight Phase': 'Zwielichtschnitt',
      'Void Dark II': 'Nichts-Negra'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aetheric Charge': 'globe magique',
      'Damcyan Antlion': 'fourmilion de Damcyan',
      'Dark Elf': 'Elfe noir',
      'Durante': 'Durante',
      'Hexing Staff': 'canne des ténèbres',
      'Stone Pillar': 'colonne',
      'The Bloodied Barbican': 'Portes du château de Baron',
      'The Carnelian Courtyard': 'Cour du château de Baron',
      'The Cloven Crystal Square': 'Place du cristal'
    },
    'replaceText': {
      '\\(cast\\)': '(Incante)',
      '\\(spread\\)': '(Écartement)',
      'Abyssal Outburst': 'Onde noire',
      'Antipodal Assault': 'Percée antipodale',
      'Antlion March': 'Marche des fourmilions',
      'Arcane Edge': 'Oblitérateur magique',
      'Contrapasso': 'Contrapasso',
      'Dark Impact': 'Décharge obscure',
      'Death\'s Journey': 'Cortège funèbre',
      'Duplicitous Battery': 'Multi-décharges',
      'Earthen Geyser': 'Geyser terrestre',
      'Explosion': 'Explosion',
      'Fallen Grace': 'Descente obscure',
      'Forsaken Fount': 'Globes magiques',
      'Hard Slash': 'Taillade violente',
      'Hexing Staves': 'Cannes des ténèbres',
      'Landslip': 'Sol mouvant',
      'Old Magic': 'Déferlante magique',
      'Pound Sand': 'Martèlement terrestre',
      'Ruinous Confluence': 'Cruci-cannes',
      'Sandblast': 'Explosion sableuse',
      'Shadowy Sigil': 'Sceau des ténèbres',
      'Sorcerous Shroud': 'Disparition ténébreuse',
      'Splinter': 'Rupture',
      'Staff Smite': 'Coup de canne',
      'Towerfall': 'Écroulement',
      'Twilight Phase': 'Ombre du crépuscule',
      'Void Dark II': 'Extra Ténèbres du néant'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aetheric Charge': '魔力球',
      'Damcyan Antlion': 'ダムシアン・アントリオン',
      'Dark Elf': 'ダークエルフ',
      'Durante': 'ドゥランテ',
      'Hexing Staff': '闇の杖',
      'Stone Pillar': '石柱',
      'The Bloodied Barbican': 'バロン城正門',
      'The Carnelian Courtyard': 'バロン城中庭',
      'The Cloven Crystal Square': 'クリスタル広場'
    },
    'replaceText': {
      'Abyssal Outburst': '暗黒波動',
      'Antipodal Assault': 'アンティポディース・スラスト',
      'Antlion March': 'アントリオンマーチ',
      'Arcane Edge': '魔針弾',
      'Contrapasso': 'コントラパッソ',
      'Dark Impact': '暗黒魔弾',
      'Death\'s Journey': 'ジャーニー・オブ・デス',
      'Duplicitous Battery': '双魔連弾',
      'Earthen Geyser': 'アースゲイザー',
      'Explosion': '爆発',
      'Fallen Grace': '降魔弾',
      'Forsaken Fount': '魔力球',
      'Hard Slash': 'ハードスラッシュ',
      'Hexing Staves': '闇の杖',
      'Landslip': '地滑り',
      'Old Magic': '魔力放出',
      'Pound Sand': 'アースパウンド',
      'Ruinous Confluence': '十字魔操',
      'Sandblast': 'サンドブラスト',
      'Shadowy Sigil': '闇の紋章',
      'Sorcerous Shroud': '闇の帳',
      'Splinter': '破裂',
      'Staff Smite': '杖撃',
      'Towerfall': '倒壊',
      'Twilight Phase': 'トワイライトフェイズ',
      'Void Dark II': 'ヴォイド・ダーラ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aetheric Charge': '魔力球',
      'Damcyan Antlion': '达姆希安蚁狮',
      'Dark Elf': '暗黑精灵',
      'Durante': '杜兰特',
      'Hexing Staff': '黑暗之杖',
      'Stone Pillar': '石柱',
      'The Bloodied Barbican': '巴隆城正门',
      'The Carnelian Courtyard': '巴隆城庭院',
      'The Cloven Crystal Square': '水晶广场'
    },
    'replaceText': {
      '\\(cast\\)': '(咏唱)',
      '\\(spread\\)': '(分散)',
      'Abyssal Outburst': '黑暗爆发',
      'Antipodal Assault': '对跖强刺',
      'Antlion March': '蚁狮行军',
      'Arcane Edge': '魔针弹',
      'Contrapasso': '因罪施罚',
      'Dark Impact': '暗黑魔弹',
      'Death\'s Journey': '死亡之旅',
      'Duplicitous Battery': '双连魔弹',
      'Earthen Geyser': '流沙泉',
      'Explosion': '爆炸',
      'Fallen Grace': '降魔弹',
      'Forsaken Fount': '魔力球',
      'Hard Slash': '重斩',
      'Hexing Staves': '黑暗之杖',
      'Landslip': '滑坡',
      'Old Magic': '释放魔力',
      'Pound Sand': '大地坠击',
      'Ruinous Confluence': '十字魔爆',
      'Sandblast': '喷沙',
      'Shadowy Sigil': '黑暗纹章',
      'Sorcerous Shroud': '黑暗帷帐',
      'Splinter': '碎裂',
      'Staff Smite': '杖击',
      'Towerfall': '崩塌',
      'Twilight Phase': '暮光相',
      'Void Dark II': '虚空昏暗'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aetheric Charge': '마력 구체',
      'Damcyan Antlion': '담시안 개미귀신',
      'Dark Elf': '다크 엘프',
      'Durante': '두란테',
      'Hexing Staff': '어둠의 지팡이',
      'Stone Pillar': '돌기둥',
      'The Bloodied Barbican': '바론 성 정문',
      'The Carnelian Courtyard': '바론 성 안뜰',
      'The Cloven Crystal Square': '크리스탈 광장'
    },
    'replaceText': {
      '\\(cast\\)': '(시전)',
      '\\(spread\\)': '(산개)',
      'Abyssal Outburst': '암흑 파동',
      'Antipodal Assault': '대척점 찌르기',
      'Antlion March': '개미귀신 행진',
      'Arcane Edge': '마침탄',
      'Contrapasso': '인과응보',
      'Dark Impact': '암흑 마탄',
      'Death\'s Journey': '죽음의 여정',
      'Duplicitous Battery': '연속 마탄',
      'Earthen Geyser': '대지 분출',
      'Explosion': '폭발',
      'Fallen Grace': '마탄 강하',
      'Forsaken Fount': '마력 구체',
      'Hard Slash': '강렬한 참격',
      'Hexing Staves': '어둠의 지팡이',
      'Landslip': '흐르는 대지',
      'Old Magic': '마력 방출',
      'Pound Sand': '대지 내리치기',
      'Ruinous Confluence': '십자 마력 조작',
      'Sandblast': '모래 폭발',
      'Shadowy Sigil': '어둠의 문장',
      'Sorcerous Shroud': '어둠의 장막',
      'Splinter': '파열',
      'Staff Smite': '지팡이 공격',
      'Towerfall': '무너짐',
      'Twilight Phase': '황혼녘',
      'Void Dark II': '보이드 다라'
    }
  }]
};
/* harmony default export */ const the_lunar_subterrane = (the_lunar_subterrane_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/the_lunar_subterrane.txt
const dungeon_the_lunar_subterrane_namespaceObject = "### THE LUNAR SUBTERRANE\r\n# ZoneId: 1164\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~~#\r\n# DARK ELF #\r\n#~~~~~~~~~~#\r\n\r\n# -p 87D9:1009\r\n# -ii  87E5 89B6 87DF\r\n\r\n# Cloven Crystal Square will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1153\" } window 10000,0\r\n1006.0 \"--sync--\" StartsUsing { id: \"87D9\", source: \"Dark Elf\" } window 10,10\r\n1009.0 \"Hexing Staves\" Ability { id: \"87D9\", source: \"Dark Elf\" }\r\n1017.1 \"Ruinous Confluence\" Ability { id: \"8985\", source: \"Dark Elf\" }\r\n1027.1 \"Shadowy Sigil\" Ability { id: \"87D[BC]\", source: \"Dark Elf\" }\r\n1027.5 \"Explosion\" Ability { id: \"87E3\", source: \"Dark Elf\" }\r\n1034.2 \"Hexing Staves\" Ability { id: \"87D9\", source: \"Dark Elf\" }\r\n1044.3 \"Sorcerous Shroud\" Ability { id: \"87DA\", source: \"Dark Elf\" }\r\n1051.0 \"Void Dark II (cast)\" Ability { id: \"87DD\", source: \"Dark Elf\" }\r\n1056.6 \"Void Dark II (spread)\" Ability { id: \"87E4\", source: \"Dark Elf\" }\r\n1060.3 \"Ruinous Confluence\" Ability { id: \"8985\", source: \"Dark Elf\" }\r\n\r\n1067.2 \"Hexing Staves\" Ability { id: \"87D9\", source: \"Dark Elf\" }\r\n1077.3 \"Sorcerous Shroud\" Ability { id: \"87DA\", source: \"Dark Elf\" }\r\n1084.0 \"Void Dark II (cast)\" Ability { id: \"87DD\", source: \"Dark Elf\" }\r\n1091.6 \"Void Dark II (spread)\" Ability { id: \"87E4\", source: \"Dark Elf\" }\r\n1092.2 \"Shadowy Sigil\" Ability { id: \"87D[BC]\", source: \"Dark Elf\" }\r\n1092.8 \"Explosion\" Ability { id: \"87E3\", source: \"Dark Elf\" }\r\n1099.4 \"Ruinous Confluence\" Ability { id: \"8985\", source: \"Dark Elf\" }\r\n1109.6 \"Staff Smite\" Ability { id: \"8984\", source: \"Dark Elf\" }\r\n1120.6 \"Abyssal Outburst\" Ability { id: \"87DE\", source: \"Dark Elf\" }\r\n1129.7 \"Abyssal Outburst\" Ability { id: \"87DE\", source: \"Dark Elf\" }\r\n\r\n1140.4 \"Hexing Staves\" Ability { id: \"87D9\", source: \"Dark Elf\" } window 50,50 forcejump 1067.2\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 368 Attack ye olde auto\r\n# 87D9 Hexing Staves cast to summon staves for Ruinous Hex\r\n# 87DA Sorcerous Shroud cast to hide staves\r\n# 87DB Shadowy Sigil pink triangle sigil cast\r\n# 87DC Shadowy Sigil blue/purple square sigil cast\r\n# 87DD Void Dark II self-targeted cast that gives people headmarkers for 87E4\r\n# 87DE Abyssal Outburst aoe\r\n# 87DF Ruinous Hex self-targeted ability from staves before 87E5\r\n# 87E3 Explosion casted damage for sigil explosions (either color)\r\n# 87E4 Void Dark II spread damage\r\n# 87E5 Ruinous Hex damage from hidden staves\r\n# 8984 Staff Smite non-cleaving tankbuster cast\r\n# 8985 Ruinous Confluence self-targeted cast at the same time as 89B6/87E5\r\n# 89B6 Ruinous Hex damage from first staves\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~#\r\n# Damcyan Antlion #\r\n#~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 87FD:2014.5\r\n# -ii 8C36 8803 8C1F 8801 8806\r\n\r\n# Note: Antlion March 8800 is into 5x Antlion March (8801) segments\r\n# Note: timing is the same, even once all towers have fallen\r\n\r\n# Bloodied Barbican will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1154\" } window 10000,0\r\n2009.5 \"--sync--\" StartsUsing { id: \"87FD\", source: \"Damcyan Antlion\" } window 10,10\r\n2014.5 \"Sandblast\" Ability { id: \"87FD\", source: \"Damcyan Antlion\" }\r\n2023.6 \"Landslip\" Ability { id: \"8802\", source: \"Damcyan Antlion\" }\r\n\r\n2028.8 \"--north--\" Ability { id: \"8808\", source: \"Damcyan Antlion\" }\r\n2037.0 \"Antlion March\" Ability { id: \"8800\", source: \"Damcyan Antlion\" } duration 4.1\r\n2049.6 \"Landslip\" Ability { id: \"8802\", source: \"Damcyan Antlion\" }\r\n2052.9 \"Towerfall 1\" Ability { id: \"8804\", source: \"Stone Pillar\" }\r\n\r\n2056.7 \"--middle--\" Ability { id: \"8808\", source: \"Damcyan Antlion\" }\r\n2062.8 \"Earthen Geyser\" Ability { id: \"8805\", source: \"Damcyan Antlion\" }\r\n2073.9 \"Pound Sand\" Ability { id: \"868B\", source: \"Damcyan Antlion\" }\r\n2083.0 \"Sandblast\" Ability { id: \"87FD\", source: \"Damcyan Antlion\" }\r\n\r\n# note: we cooould just loop here\r\n2089.1 \"--north--\" Ability { id: \"8808\", source: \"Damcyan Antlion\" }\r\n2097.3 \"Antlion March\" Ability { id: \"8800\", source: \"Damcyan Antlion\" } duration 4.1\r\n2109.9 \"Landslip\" Ability { id: \"8802\", source: \"Damcyan Antlion\" }\r\n2113.2 \"Towerfall 2\" Ability { id: \"8804\", source: \"Stone Pillar\" }\r\n\r\n2117.0 \"--middle--\" Ability { id: \"8808\", source: \"Damcyan Antlion\" }\r\n2123.1 \"Earthen Geyser\" Ability { id: \"8805\", source: \"Damcyan Antlion\" }\r\n2134.2 \"Pound Sand\" Ability { id: \"868B\", source: \"Damcyan Antlion\" }\r\n2143.3 \"Sandblast\" Ability { id: \"87FD\", source: \"Damcyan Antlion\" }\r\n\r\n2149.4 \"--north--\" Ability { id: \"8808\", source: \"Damcyan Antlion\" }\r\n2157.6 \"Antlion March\" Ability { id: \"8800\", source: \"Damcyan Antlion\" } duration 4.1\r\n2170.2 \"Landslip\" Ability { id: \"8802\", source: \"Damcyan Antlion\" }\r\n2173.5 \"Towerfall 3\" Ability { id: \"8804\", source: \"Stone Pillar\" }\r\n\r\n2177.3 \"--middle--\" Ability { id: \"8808\", source: \"Damcyan Antlion\" }\r\n2183.4 \"Earthen Geyser\" Ability { id: \"8805\", source: \"Damcyan Antlion\" }\r\n2194.5 \"Pound Sand\" Ability { id: \"868B\", source: \"Damcyan Antlion\" }\r\n2203.6 \"Sandblast\" Ability { id: \"87FD\", source: \"Damcyan Antlion\" }\r\n\r\n2209.7 \"--north--\" Ability { id: \"8808\", source: \"Damcyan Antlion\" }\r\n2217.9 \"Antlion March\" Ability { id: \"8800\", source: \"Damcyan Antlion\" } duration 4.1\r\n2230.5 \"Landslip\" Ability { id: \"8802\", source: \"Damcyan Antlion\" }\r\n2233.8 \"Towerfall 4\" Ability { id: \"8804\", source: \"Stone Pillar\" }\r\n\r\n2237.6 \"--middle--\" Ability { id: \"8808\", source: \"Damcyan Antlion\" }\r\n2243.7 \"Earthen Geyser\" Ability { id: \"8805\", source: \"Damcyan Antlion\" }\r\n2254.8 \"Pound Sand\" Ability { id: \"868B\", source: \"Damcyan Antlion\" }\r\n2263.9 \"Sandblast\" Ability { id: \"87FD\", source: \"Damcyan Antlion\" }\r\n\r\n2270.0 \"--north--\" Ability { id: \"8808\", source: \"Damcyan Antlion\" }\r\n2278.2 \"Antlion March\" Ability { id: \"8800\", source: \"Damcyan Antlion\" } duration 4.1\r\n2290.8 \"Landslip\" Ability { id: \"8802\", source: \"Damcyan Antlion\" }\r\n\r\n2297.9 \"--middle--\" Ability { id: \"8808\", source: \"Damcyan Antlion\" }\r\n2304.0 \"Earthen Geyser\" Ability { id: \"8805\", source: \"Damcyan Antlion\" }\r\n2315.1 \"Pound Sand\" Ability { id: \"868B\", source: \"Damcyan Antlion\" }\r\n2324.2 \"Sandblast\" Ability { id: \"87FD\", source: \"Damcyan Antlion\" }\r\n\r\n2330.3 \"--north--\" Ability { id: \"8808\", source: \"Damcyan Antlion\" } window 50,50 forcejump 2270\r\n\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 366 attack various background mobs doing autos\r\n# 367 attack various background mobs doing autos\r\n# 368 attack Antlion auto, but also various mobs in the background doing autos\r\n# 868B Pound Sand large targeted(?) circle after Earthen Geyser\r\n# 87FD Sandblast raidwide cast\r\n# 8800 Antlion March self-targeted cast\r\n# 8801 Antlion March damage for individual march segments\r\n# 8802 Landslip self-targeted cast for moving lines\r\n# 8803 Landslip cast and movement ability for each landslip line\r\n# 8804 Towerfall cast and damage for falling towers\r\n# 8805 Earthen Geyser self-targeted ability for stack\r\n# 8806 Earthen Geyser cast and damage for stack marker\r\n# 8808 --sync-- repositioning\r\n# 8C1F --sync-- Antlion March preview\r\n# 8C36 Aqua Vitae there's a Baron Knight-captain casting this in the background\r\n\r\n\r\n#~~~~~~~~~#\r\n# Durante #\r\n#~~~~~~~~~#\r\n\r\n# -p 88C3:3012.3\r\n# -ii 8CDA 88B2 88B6 8CD8 88C0 88B9 8C20 88B4\r\n\r\n# Carnelian Courtyard will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1155\" } window 10000,0\r\n3007.3 \"--sync--\" StartsUsing { id: \"88C3\", source: \"Durante\" } window 10,10\r\n3012.3 \"Old Magic\" Ability { id: \"88C3\", source: \"Durante\" }\r\n3014.4 \"--middle--\" Ability { id: \"88AF\", source: \"Durante\" }\r\n3022.7 \"Duplicitous Battery\" Ability { id: \"8CD9\", source: \"Durante\" } duration 2.5\r\n3035.5 \"Forsaken Fount\" Ability { id: \"88BB\", source: \"Durante\" }\r\n3044.3 \"Explosion\" Ability { id: \"88BE\", source: \"Aetheric Charge\" }\r\n\r\n3048.6 \"--middle--\" Ability { id: \"88AF\", source: \"Durante\" }\r\n3058.0 \"Duplicitous Battery\" Ability { id: \"8CD9\", source: \"Durante\" } duration 2.5\r\n3064.6 \"Fallen Grace\" Ability { id: \"8C2A\", source: \"Durante\" }\r\n\r\n3070.7 \"--north--\" Ability { id: \"88AF\", source: \"Durante\" }\r\n3076.1 \"Forsaken Fount\" Ability { id: \"88BB\", source: \"Durante\" }\r\n3081.2 \"Contrapasso\" Ability { id: \"8C41\", source: \"Durante\" }\r\n3082.1 \"Splinter\" Ability { id: \"88BC\", source: \"Aetheric Charge\" }\r\n3094.1 \"Explosion\" Ability { id: \"88BD\", source: \"Durante\" }\r\n\r\n3094.5 \"--north--\" Ability { id: \"88AF\", source: \"Durante\" }\r\n3099.8 \"Forsaken Fount\" Ability { id: \"88BB\", source: \"Durante\" }\r\n3104.9 \"Contrapasso\" Ability { id: \"8C41\", source: \"Durante\" }\r\n3105.8 \"Splinter\" Ability { id: \"88BC\", source: \"Aetheric Charge\" }\r\n3117.8 \"Explosion\" Ability { id: \"88BD\", source: \"Durante\" }\r\n3123.2 \"Old Magic\" Ability { id: \"88C3\", source: \"Durante\" }\r\n\r\n3128.4 \"--middle--\" Ability { id: \"88AF\", source: \"Durante\" }\r\n3130.4 \"--sync--\" Ability { id: \"38FC\", source: \"Durante\" }\r\n3135.4 \"Antipodal Assault\" Ability { id: \"88BF\", source: \"Durante\" }\r\n3142.9 \"Hard Slash\" Ability { id: \"88C1\", source: \"Durante\" }\r\n\r\n3145.2 \"--middle--\" Ability { id: \"88AF\", source: \"Durante\" }\r\n3154.4 \"Twilight Phase\" Ability { id: \"8CD7\", source: \"Durante\" }\r\n3165.6 \"Dark Impact\" Ability { id: \"88BA\", source: \"Durante\" }\r\n\r\n3172.3 \"--middle--\" Ability { id: \"88AF\", source: \"Durante\" }\r\n3180.6 \"Death's Journey\" Ability { id: \"88B3\", source: \"Durante\" }\r\n\r\n3185.7 \"--north--\" Ability { id: \"88AF\", source: \"Durante\" }\r\n3191.0 \"Forsaken Fount\" Ability { id: \"88BB\", source: \"Durante\" }\r\n3196.1 \"Contrapasso\" Ability { id: \"8C41\", source: \"Durante\" }\r\n3197.0 \"Splinter\" Ability { id: \"88BC\", source: \"Aetheric Charge\" }\r\n3209.0 \"Explosion\" Ability { id: \"88BD\", source: \"Durante\" }\r\n3212.3 \"Old Magic\" Ability { id: \"88C3\", source: \"Durante\" }\r\n\r\n3217.4 \"--middle--\" Ability { id: \"88AF\", source: \"Durante\" }\r\n3226.8 \"Duplicitous Battery\" Ability { id: \"8CD9\", source: \"Durante\" }\r\n3233.2 \"Fallen Grace\" Ability { id: \"8C2A\", source: \"Durante\" }\r\n\r\n3241.3 \"--middle--\" Ability { id: \"88AF\", source: \"Durante\" }\r\n3243.4 \"--sync--\" Ability { id: \"38FC\", source: \"Durante\" }\r\n3248.4 \"Antipodal Assault\" Ability { id: \"88BF\", source: \"Durante\" }\r\n3255.8 \"Hard Slash\" Ability { id: \"88C1\", source: \"Durante\" }\r\n\r\n3257.9 \"--middle--\" Ability { id: \"88AF\", source: \"Durante\" }\r\n3267.1 \"Twilight Phase\" Ability { id: \"8CD7\", source: \"Durante\" }\r\n3278.3 \"Dark Impact\" Ability { id: \"88BA\", source: \"Durante\" }\r\n3287.2 \"Arcane Edge\" Ability { id: \"88C2\", source: \"Durante\" }\r\n\r\n3295.4 \"--middle--\" Ability { id: \"88AF\", source: \"Durante\" }\r\n3303.7 \"Death's Journey\" Ability { id: \"88B3\", source: \"Durante\" } window 100,100 forcejump 3180.6\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 366 attack\r\n# 38FC --sync-- ability on line stack target for Antipodal Assault\r\n# 88AF --sync-- repositioning\r\n# 88B2 Duplicitous Battery damage\r\n# 88B3 Death's Journey cast and damage for center circle during purple line pinwheel\r\n# 88B4 Death's Journey cast and damage for lines during purple line pinwheel\r\n# 88B6 Twilight Phase self-targeted ability\r\n# 88B9 Dark Impact cast and untargeted no damage(?) ability before shooting an orb at the ground\r\n# 88BA Dark Impact cast and damage for large circle\r\n# 88BB Forsaken Fount self-targeted cast to summon Aetheric Charge orbs\r\n# 88BC Splinter splitting ability from Aetheric Orb after Contrapasso\r\n# 88BD Explosion split Aetheric Orb circle cast and damage\r\n# 88BE Explosion unsplit Aetheric Orb circle cast and damage\r\n# 88BF Antipodal Assault self-targeted cast for line stack\r\n# 88C0 Antipodal Assault line stack damage (no cast)\r\n# 88C1 Hard Slash large cleave from wall after Antipodal Assault charge\r\n# 88C2 Arcane Edge cast and non-cleaving tankbuster\r\n# 88C3 Old Magic raidwide aoe\r\n# 8C20 --sync-- unnamed ability tied to Death's Journey 88B4\r\n# 8C2A Fallen Grace cast and spread damage\r\n# 8C41 Contrapasso cast and minor raidwide damage that causes Splinter\r\n# 8CD7 Twilight Phase self-targeted cast\r\n# 8CD8 Twilight Phase cast and damage for large purple ribs (go sides)\r\n# 8CD9 Duplicitous Battery self-targeted cast (8CDA happens during cast, then 88B2 damage)\r\n# 8CDA --sync-- Duplicitous Battery telegraph\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/the_sildihn_subterrane.ts



// TODO: path 10 Gladiator static visage safe quadrant
// TODO: path 11 Gladiator rotating visage safe quadrant
// TODO: map effects for Geryon Intake / Boulder / Suddenly Sewage locations/directions
// TODO: lots of missing stuff for Shadowcaster and Thorne Knight
const leftDoorYesPump = ['standOnBlue', 'standOnBlue', 'knockback', 'launch', 'loopStart', 'charge', 'gigantomill', 'knockback', 'launchOrSwing'];
const leftDoorNoPump = ['standOnBlue', 'standOnBlue', 'launch', 'loopStart', 'charge', 'launchOrSwing'];
const middleDoorLeftHandle = ['standOnBlue', 'standOnBlue', 'knockback', 'launch', 'loopStart', 'gigantomill', 'charge', 'knockback', 'launchOrSwing'];
const middleDoorRightHandle = ['standOnBlue', 'standOnBlue', 'boulders', 'launch', 'loopStart', 'charge', 'gigantomill', 'boulders', 'launchOrSwing'];
const rightDoorYesCeruleum = ['standOnBlue', 'standOnBlue', 'launch', 'loopStart', 'gigantomill', 'charge', 'launchOrSwing'];
const rightDoorNoCeruleum = ['standOnBlue', 'standOnBlue', 'launch', 'loopStart', 'charge', 'launchOrSwing'];
const the_sildihn_subterrane_triggerSet = {
  id: 'TheSildihnSubterrane',
  zoneId: zone_id/* default.TheSildihnSubterrane */.Z.TheSildihnSubterrane,
  timelineFile: 'the_sildihn_subterrane.txt',
  initData: () => {
    return {
      catapultCount: 0,
      catapultMechs: ['standOnBlue', 'standOnBlue'],
      barrelActive: false
    };
  },
  timelineTriggers: [{
    id: 'Sildihn Geryon Intake',
    regex: /Intake/,
    beforeSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback onto Blue',
        de: 'Rückstoß auf Blau',
        fr: 'Poussée sur le bleu',
        ja: '青にノックバック',
        cn: '击退至蓝色',
        ko: '파란색쪽으로 넉백'
      }
    }
  }],
  triggers: [{
    id: 'Sildihn Geryon Seal Left Mechs',
    type: 'SystemLogMessage',
    // The Silt Pump will be sealed off
    netRegex: {
      id: '7DC',
      param1: '1068',
      capture: false
    },
    // May be overwritten by Runaway Sludge below.
    run: data => data.catapultMechs = leftDoorYesPump
  }, {
    id: 'Sildihn Geryon Runaway Sludge Mechs',
    type: 'StartsUsing',
    netRegex: {
      id: '74D6',
      source: 'Geryon the Steer',
      capture: false
    },
    suppressSeconds: 9999,
    run: data => data.catapultMechs = leftDoorNoPump
  }, {
    id: 'Sildihn Geryon Intake Mechs',
    type: 'MapEffect',
    netRegex: {
      flags: '00020001',
      location: '09',
      capture: false
    },
    suppressSeconds: 9999,
    run: data => data.catapultMechs = middleDoorLeftHandle
  }, {
    id: 'Sildihn Geryon Boulder Mechs',
    type: 'MapEffect',
    netRegex: {
      flags: '20000004',
      location: '0A',
      capture: false
    },
    suppressSeconds: 9999,
    run: data => data.catapultMechs = middleDoorRightHandle
  }, {
    id: 'Sildihn Geryon Seal Right Mechs',
    type: 'SystemLogMessage',
    // The Settling Basin will be sealed off
    netRegex: {
      id: '7DC',
      param1: '106D',
      capture: false
    },
    // May be overwritten by Suddenly Sewage below.
    run: data => data.catapultMechs = rightDoorNoCeruleum
  }, {
    id: 'Sildihn Geryon Suddenly Sewage Mechs',
    type: 'Ability',
    netRegex: {
      id: '74D8',
      source: 'Geryon the Steer',
      capture: false
    },
    suppressSeconds: 9999,
    run: data => data.catapultMechs = rightDoorYesCeruleum
  }, {
    id: 'Sildihn Geryon Colossal Strike',
    type: 'StartsUsing',
    netRegex: {
      id: '74CF',
      source: 'Geryon the Steer'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Sildihn Geryon Subterranean Shudder',
    type: 'StartsUsing',
    netRegex: {
      id: '74D2',
      source: 'Geryon the Steer',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Sildihn Geryon Exploding Catapult',
    type: 'StartsUsing',
    netRegex: {
      id: '74C7',
      source: 'Geryon the Steer',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe(),
    run: data => data.barrelActive = true
  }, {
    id: 'Sildihn Geryon Exploding Catapult Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '74C7',
      source: 'Geryon the Steer',
      capture: false
    },
    delaySeconds: 17,
    run: data => data.barrelActive = false
  }, {
    id: 'Sildihn Geryon Exploding Catapult Barrels',
    type: 'StartsUsing',
    netRegex: {
      id: '74C7',
      source: 'Geryon the Steer',
      capture: false
    },
    delaySeconds: 6.5,
    infoText: (data, _matches, output) => {
      let mech = data.catapultMechs[data.catapultCount];
      // loopStart is a fake entry to know where to loop back to
      if (mech === 'loopStart') {
        data.catapultCount++;
        mech = data.catapultMechs[data.catapultCount];
      }

      // Increment for next time, unless something has gone awry.
      if (data.catapultCount >= 0) data.catapultCount++;
      // If we run off the end of mechanics, loop back to the "loopStart" entry for next time.
      if (data.catapultCount >= data.catapultMechs.length) data.catapultCount = data.catapultMechs.indexOf('loopStart');
      if (mech === undefined) return;

      // These are all handled elsewhere in other triggers.
      if (mech === 'launch' || mech === 'charge' || mech === 'launchOrSwing' || mech === 'knockback') return;
      if (mech === 'standOnBlue' || mech === 'gigantomill') return output.standOnBlue();
      if (mech === 'boulders') return output.avoidBoulders();
    },
    outputStrings: {
      standOnBlue: {
        en: 'Stand on Blue',
        de: 'Bei Blau stehen',
        fr: 'Restez sur le bleu',
        ja: '青へ',
        cn: '站蓝色',
        ko: '파란색쪽으로'
      },
      avoidBoulders: {
        en: 'Stand on Blue (avoid boulders)',
        de: 'Bei Blau stehen (vermeide Steine)',
        fr: 'Restez sur le bleu (évitez les rochers)',
        ja: '青へ (岩回避)',
        cn: '站蓝色 (躲避岩石)',
        ko: '파란색쪽으로 (바위 피하기)'
      }
    }
  }, {
    id: 'Sildihn Geryon Shockwave',
    type: 'StartsUsing',
    netRegex: {
      id: '74CE',
      source: 'Geryon the Steer',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Sildihn Geryon Runaway Runoff',
    type: 'StartsUsing',
    netRegex: {
      id: '74D7',
      source: 'Geryon the Steer',
      capture: false
    },
    delaySeconds: 3,
    // 8 second cast
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback onto Blue',
        de: 'Rückstoß zu Blau',
        fr: 'Poussée sur le bleu',
        ja: '青へノックバック',
        cn: '击退至蓝色',
        ko: '파란색쪽으로 넉백'
      }
    }
  }, {
    id: 'Sildihn Geryon Colossal Swing',
    type: 'StartsUsing',
    netRegex: {
      id: '74D1',
      source: 'Geryon the Steer',
      capture: false
    },
    alertText: (data, _matches, output) => {
      return data.barrelActive ? output.getBehindOnBlue() : output.getBehind();
    },
    outputStrings: {
      getBehind: outputs/* default.getBehind */.Z.getBehind,
      getBehindOnBlue: {
        en: 'Get Behind on Blue',
        de: 'Geh hinter Blau',
        fr: 'Allez derrière le bleu',
        ja: 'ボスの後ろの青へ',
        cn: 'BOSS后蓝色',
        ko: '보스 뒤 파란색쪽으로'
      }
    }
  }, {
    id: 'Sildihn Geryon Colossal Launch',
    type: 'StartsUsing',
    netRegex: {
      id: '74C8',
      source: 'Geryon the Steer',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand on Red',
        de: 'Bei Rot stehen',
        fr: 'Restez sur le rouge',
        ja: '赤へ',
        cn: '站红色',
        ko: '빨간색쪽으로'
      }
    }
  }, {
    id: 'Sildihn Geryon Colossal Charge Left',
    type: 'StartsUsing',
    netRegex: {
      id: '74CD',
      source: 'Geryon the Steer',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand on Right Blue',
        de: 'Steh bei dem rechten Blau',
        fr: 'Restez sur le bleu à droite',
        ja: '右の青へ',
        cn: '站右侧蓝色',
        ko: '오른쪽 파란색쪽으로'
      }
    }
  }, {
    id: 'Sildihn Geryon Colossal Charge Right',
    type: 'StartsUsing',
    netRegex: {
      id: '74CC',
      source: 'Geryon the Steer',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stand on Left Blue',
        de: 'Steh bei dem linken Blau',
        fr: 'Restez sur le bleu à gauche',
        ja: '左の青へ',
        cn: '站左侧蓝色',
        ko: '왼쪽 파란색쪽으로'
      }
    }
  }, {
    id: 'Sildihn Geryon Gigantomill Left',
    type: 'StartsUsing',
    netRegex: {
      id: '74CA',
      source: 'Geryon the Steer',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft('info')
  }, {
    id: 'Sildihn Geryon Gigantomill Right',
    type: 'StartsUsing',
    netRegex: {
      id: '74C9',
      source: 'Geryon the Steer',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight('info')
  }, {
    id: 'Sildihn Silkie Total Wash',
    type: 'StartsUsing',
    netRegex: {
      id: '772C',
      source: 'Silkie',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Sildihn Silkie Squeaky Right',
    type: 'StartsUsing',
    netRegex: {
      id: '772D',
      source: 'Silkie',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Back Left',
        de: 'Nach hinten links',
        fr: 'Arrière Gauche',
        ja: '後ろ左',
        cn: '左后',
        ko: '뒤 왼쪽'
      }
    }
  }, {
    id: 'Sildihn Silkie Squeaky Left',
    type: 'StartsUsing',
    netRegex: {
      id: '772E',
      source: 'Silkie',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Back Right',
        de: 'Nach hinten rechts',
        fr: 'Arrière Droite',
        ja: '後ろ右',
        cn: '右后',
        ko: '뒤 오른쪽'
      }
    }
  }, {
    id: 'Sildihn Silkie Carpet Buster',
    type: 'StartsUsing',
    netRegex: {
      id: '772B',
      source: 'Silkie'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Sildihn Silkie Dust Bluster',
    type: 'StartsUsing',
    netRegex: {
      id: '7744',
      source: 'Silkie',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Sildihn Silkie Wash Out',
    type: 'StartsUsing',
    netRegex: {
      id: '7745',
      source: 'Silkie',
      capture: false
    },
    delaySeconds: 3,
    // 8 second cast
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Sildihn Silkie Chilling Duster',
    type: 'StartsUsing',
    netRegex: {
      id: '7738',
      source: 'Silkie',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Intercards',
        de: 'Interkardinal',
        fr: 'Intercardinal',
        ja: '斜め',
        cn: '斜角',
        ko: '대각선 쪽으로'
      }
    }
  }, {
    id: 'Sildihn Silkie Chilling Duster Slippery',
    type: 'StartsUsing',
    netRegex: {
      id: '773B',
      source: 'Silkie',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Follow => Intercards',
        de: 'Folgen => Interkardinal',
        fr: 'Suivez -> Intercardinal',
        ja: '近づく => 斜め',
        cn: '跟随 => 斜角',
        ko: '따라가기 => 대각선 쪽으로'
      }
    }
  }, {
    id: 'Sildihn Silkie Chilling Duster Puffs',
    type: 'StartsUsing',
    netRegex: {
      id: '773F',
      source: 'Silkie',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // TODO: how do you word this???
        // "Do the mechanic <se.6>"
        en: 'Avoid Crosses from Silkie and Puffs',
        de: 'Weiche den "+" von Silkie und den Puscheln aus',
        fr: 'Évitez les croix de Silkie et des pompons',
        ja: 'ボスとたまの斜め',
        cn: '躲避交叉攻击',
        ko: '보스와 구슬의 십자방향 피하기'
      }
    }
  }, {
    id: 'Sildihn Silkie Bracing Duster',
    type: 'StartsUsing',
    netRegex: {
      id: '7739',
      source: 'Silkie',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Sildihn Silkie Bracing Duster Slippery',
    type: 'StartsUsing',
    // No source here as sometimes the mob name is stale (!!) during the bridge section of the timeline.
    netRegex: {
      id: '773C',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Follow => Under',
        de: 'Folgen => Unter Ihn',
        fr: 'Suivez -> Dessous',
        ja: '近づく => 下へ',
        cn: '跟随 => 脚下',
        ko: '따라가기 => 밑으로'
      }
    }
  }, {
    id: 'Sildihn Gladiator Flash of Steel',
    type: 'StartsUsing',
    netRegex: {
      id: '7656',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Sildihn Gladiator Sculptor\'s Passion',
    type: 'StartsUsing',
    netRegex: {
      id: '764A',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Sildihn Gladiator Mighty Smite',
    type: 'StartsUsing',
    netRegex: {
      id: '7657',
      source: 'Gladiator of Sil\'dih'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Sildihn Gladiator Shattering Steel',
    type: 'StartsUsing',
    netRegex: {
      id: '764B',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    // Cast is 12s, Liftoff debuff is 5s
    delaySeconds: 7,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get in big wind circle',
        de: 'Geh in den großen Wind-Kreis',
        fr: 'Allez dans le grand cercle de vent',
        ja: '風ゆかの中へ',
        cn: '站进大风圈',
        ko: '큰 바람장판 안으로'
      }
    }
  }, {
    id: 'Sildihn Gladiator Ring of Might 1',
    type: 'StartsUsing',
    netRegex: {
      id: '763F',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Outside Inner Ring (1)',
        de: 'Außerhalb des inneren Ringes (1)',
        fr: 'À l\'extérieur de l\'anneau intérieur (1)',
        ja: 'リングチャージ１',
        cn: '出内圈 (1)',
        ko: '안쪽 고리 밖으로 (1)'
      }
    }
  }, {
    id: 'Sildihn Gladiator Ring of Might 2',
    type: 'StartsUsing',
    netRegex: {
      id: '7640',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Outside Middle Ring (2)',
        de: 'Außerhalb des mittleren Ringes (2)',
        fr: 'À l\'extérieur de l\'anneau central (2)',
        ja: 'リングチャージ２',
        cn: '出中圈 (2)',
        ko: '중간 고리 밖으로 (2)'
      }
    }
  }, {
    id: 'Sildihn Gladiator Ring of Might 3',
    type: 'StartsUsing',
    netRegex: {
      id: '7641',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Outside Outer Ring (3)',
        de: 'Außerhalb des äußeren Ringes (3)',
        fr: 'À l\'extérieur de l\'anneau extérieur (3)',
        ja: 'リングチャージ３',
        cn: '出外圈 (3)',
        ko: '바깥쪽 고리 밖으로 (3)'
      }
    }
  }, {
    id: 'Sildihn Gladiator Ring of Might Followup',
    type: 'Ability',
    netRegex: {
      id: ['763F', '7640', '7641'],
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.getIn */.n3.getIn('info')
  }, {
    id: 'Sildihn Gladiator Rush of Might 1',
    type: 'StartsUsing',
    netRegex: {
      id: '763A',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Behind Close Mark (1)',
        de: 'Hinter der nächsten Markierung (1)',
        fr: 'Derrière la marque de fermeture (1)',
        ja: '1番目',
        cn: '刻度 (1)',
        ko: '첫번째 선 뒤 (1)'
      }
    }
  }, {
    id: 'Sildihn Gladiator Rush of Might 2',
    type: 'StartsUsing',
    netRegex: {
      id: '763B',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Behind Middle Mark (2)',
        de: 'Hinter der mittleren Markierung (2)',
        fr: 'Derrière la marque centrale (2)',
        ja: '2番目',
        cn: '刻度 (2)',
        ko: '두번째 선 뒤 (2)'
      }
    }
  }, {
    id: 'Sildihn Gladiator Rush of Might 3',
    type: 'StartsUsing',
    netRegex: {
      id: '763C',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Behind Far Mark (3)',
        de: 'Hinter der entfernten Markierung (3)',
        fr: 'Derrière la marque éloignée (3)',
        ja: '3番目',
        cn: '刻度 (3)',
        ko: '세번째 선 뒤 (3)'
      }
    }
  }, {
    id: 'Sildihn Gladiator Rush of Might Followup',
    type: 'Ability',
    netRegex: {
      id: '763D',
      source: 'Gladiator of Sil\'dih',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move Through',
        de: 'Durchlaufen',
        fr: 'Passez à travers',
        ja: 'ボスをまたいで移動',
        cn: '穿穿穿',
        ko: '보스 통과하기'
      }
    }
  }, {
    id: 'Sildihn Shadowcaster Show of Strength',
    type: 'StartsUsing',
    netRegex: {
      id: '74AE',
      source: 'Shadowcaster Zeless Gah',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Sildihn Shadowcaster Firesteel Fracture',
    type: 'StartsUsing',
    netRegex: {
      id: '74AC',
      source: 'Shadowcaster Zeless Gah'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Sildihn Shadowcaster Infern Gale',
    type: 'Ability',
    netRegex: {
      id: '74A2',
      source: 'Shadowcaster Zeless Gah',
      capture: false
    },
    // 6.4s between 74A2 and 74A3 knockback (no cast)
    delaySeconds: 1.4,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Sildihn Shadowcaster Infern Wellw',
    type: 'Ability',
    netRegex: {
      id: '74A7',
      source: 'Shadowcaster Zeless Gah',
      capture: false
    },
    // 10s between 74A7 and 74AA draw-in (no cast)
    delaySeconds: 5,
    response: responses/* Responses.drawIn */.n3.drawIn()
  }, {
    id: 'Sildihn Thorne Cogwheel',
    type: 'StartsUsing',
    netRegex: {
      id: '70EB',
      source: 'Thorne Knight',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Sildihn Thorne Blistering Blow',
    type: 'StartsUsing',
    netRegex: {
      id: '70EA',
      source: 'Thorne Knight'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Sildihn Fore Honor',
    type: 'StartsUsing',
    netRegex: {
      id: '70EC',
      source: 'Thorne Knight',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Sildihn Slashburn Reversed',
    type: 'HeadMarker',
    netRegex: {
      id: '016B',
      target: 'Thorne Knight',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Reversed Slashburn',
        de: 'Umgekehrter Brandschlitzer',
        fr: 'Renversement',
        ja: 'ゆか反転',
        cn: '翻转',
        ko: '장판 반전'
      }
    }
  }],
  timelineReplace: [{
    locale: 'en',
    replaceText: {
      'Colossal Launch / Colossal Swing': 'Colossal Launch/Swing',
      'Squeaky Left/Squeaky Right': 'Squeaky Left/Right',
      'Bracing Suds / Chilling Suds': 'Bracing/Chilling Suds',
      'Bracing Duster / Chilling Duster': 'Bracing/Chilling Duster'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Amalj\'aa Artillery Carriage': 'Amalj\'aa-Artillerie',
      'Antique Boulder': 'locker(?:e|er|es|en) Felsen',
      'Arcane Font': 'arkan(?:e|er|es|en) Tafel',
      'Ball of Fire': 'Feuerball',
      'Cold Arms\' Quietus': 'Haus der kalten Waffen',
      'Eastern Ewer': 'Waschkrug',
      'Eternal Ease': 'Ewiger Einklang',
      'Geryon the Steer': 'Geryon (?:der|die|das) Gewaltsam(?:e|er|es|en)',
      'Gladiator of Sil\'dih': 'Gladiator von Sil\'dih',
      'Hateful Visage': 'Hassendes Haupt',
      'Infern Brand': 'Infernales Mal',
      'Magicked Puppet': 'magisch(?:e|er|es|en) Marionette',
      'Powder Keg': 'Pulverfass',
      'Regret': 'Bedauern',
      'Shadowcaster Zeless Gah': 'Schattenwirker Zeless Gah',
      'Silken Puff': 'weich(?:e|er|es|en) Puschel',
      'Silkie': 'Silkie',
      'The Cornice Of Favor': 'Kranz der Gunst',
      'The Forgotten Forecourt': 'Vergessener Vorhof',
      'The Settling Basin': 'Absatzbecken',
      'The Sifting Site': 'Siebstätte',
      'The Silt Pump': 'Schlickpumpe',
      'Thorne Knight': 'Ritter der Thorne'
    },
    'replaceText': {
      '--draw in--': '--Ranziehen',
      '\\(in\\)': '(Rein)',
      '\\(out\\)': '(Raus)',
      '\\(far\\)': '(Weit weg)',
      '\\(near\\)': '(Nah ran)',
      '\\(mid\\)': '(Mitte)',
      'Amalj\'aa Artillery': 'Amalj\'aa-Artillerie',
      'Biting Wind': 'Heftiger Wind',
      'Blaze of Glory': 'Heilige Kreuzflamme',
      'Blazing Benifice': 'Heiliger Feuereifer',
      'Blistering Blow': 'Schwelender Schlag',
      'Bracing Duster': 'Spritziger Wedel',
      'Bracing Suds': 'Spritziger Schaum',
      'Brim Over': 'Hundert Flüsse',
      '(?<!Slash)Burn': 'Verbrennung',
      'Carpet Beater': 'Teppichklopfer',
      'Cast Shadow': 'Schattenfall',
      'Chilling Duster': 'Kalter Wedel',
      'Chilling Suds': 'Kalter Schaum',
      'Cogwheel': 'Glutwind',
      'Colossal Charge': 'Kolossale Rage',
      'Colossal Launch': 'Kolossaler Schuss',
      'Colossal Slam': 'Kolossaler Schlag',
      'Colossal Strike': 'Kolossaler Streich',
      'Colossal Swing': 'Kolossaler Schwung',
      'Cryptic Portal': 'Kryptisches Portal',
      'Deep Clean': 'Großes Reinemachen',
      'Dust Bluster': 'Staubbläser',
      'Eastern Ewers': 'Waschkrug',
      'Exploding Catapult': 'Berstendes Katapult',
      'Explosion': 'Explosion',
      'Firesteel Fracture': 'Feuerstahl-Brecher',
      'Flash of Steel': 'Blitzender Stahl',
      'Fore Honor': 'Vorfeuer',
      'Fresh Puff': 'Frischer Puschel',
      'Gigantomill': 'Titanomühle',
      'Gladiator of Sil\'dih': 'Gladiator von Sil\'dih',
      'Golden Flame': 'Goldene Flamme',
      'Hateful Visage': 'Hassendes Haupt',
      'Infern Brand': 'Infernales Mal',
      'Infern Gale': 'Infernaler Wind',
      'Infern Ward': 'Infernale Wehr',
      'Infern Well': 'Infernaler Brunnen',
      'Intake': 'Einsaugen',
      'Landing': 'Schnelle Landung',
      'Magic Cannon': 'Magische Kanone',
      'Mighty Smite': 'Mächtiger Streich',
      'Puff and Tumble': 'Puschelputz',
      'Pure Fire': 'Reines Feuer',
      'Rack and Ruin': 'Düster Gram',
      'Ring of Might': 'Rausch der Macht',
      'Rinse': 'Spülung',
      'Rolling Boulder': 'Rollender Fels',
      'Runaway Runoff': 'Entfesselter Guss',
      'Runaway Sludge': 'Entfesselter Schlamm',
      'Rush of Might': 'Rausch der Macht',
      'Sculptor\'s Passion': 'Bildners Hohn',
      'Shattering Steel': 'Schmetternder Stahl',
      'Shockwave': 'Schockwelle',
      'Show of Strength': 'Kraftakt',
      'Signal Flare': 'Signalfeuer',
      'Silver Flame': 'Silberne Flamme',
      'Slashburn': 'Brandschlitzer',
      'Slippery Soap': 'Schmierige Seife',
      'Soap\'s Up': 'Einseifen',
      'Soaping Spree': 'Seifentaumel',
      'Spot Remover': 'Fleckweg',
      'Spring to Life': 'Zum Leben erwacht',
      'Squeaky Left': 'Blitzelinks',
      'Squeaky Right': 'Blitzerechts',
      'Subterranean Shudder': 'Schauder der Unterstadt',
      'Suddenly Sewage': 'Entfesseltes Abwasser',
      'Sundered Remains': 'Tote Trümmer',
      'Total Wash': 'Vollwäsche',
      'Wash Out': 'Abwasch',
      'Wrath of Ruin': 'Düster Zorn'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Amalj\'aa Artillery Carriage': 'canon de campagne amalj\'aa',
      'Antique Boulder': 'roche instable',
      'Arcane Font': 'sphère arcanique',
      'Ball of Fire': 'Boule de flammes',
      'Cold Arms\' Quietus': 'Entrepôt des armes sacrées',
      'Eastern Ewer': 'cruche orientale',
      'Eternal Ease': 'Tombe du héros trépassé',
      'Geryon the Steer': 'Géryon le Dominateur',
      'Gladiator of Sil\'dih': 'gladiateur sildien',
      'Hateful Visage': 'Visage de haine',
      'Infern Brand': 'Étendard sacré',
      'Magicked Puppet': 'soldat-mage des Thorne',
      'Powder Keg': 'tonneau de poudre',
      'Regret': 'Regret',
      'Shadowcaster Zeless Gah': 'Zeless Gah la Flamme ombrée',
      'Silken Puff': 'pompon de Silkie',
      'Silkie': 'Silkie',
      'The Cornice Of Favor': 'Arène des Faveurs',
      'The Forgotten Forecourt': 'Avant-cour abandonnée',
      'The Settling Basin': 'Bassin de sédiments',
      'The Sifting Site': 'Site de filtrage',
      'The Silt Pump': 'Salle des pompes à limon',
      'Thorne Knight': 'chevalier-mage des Thorne'
    },
    'replaceText': {
      '--draw in--': '--Attirez dedans--',
      '\\(in\\)': '(Intérieur)',
      '\\(out\\)': '(Extérieur)',
      '\\(far\\)': '(Éloigné)',
      '\\(near\\)': '(Proche)',
      '\\(mid\\)': '(Milieu)',
      'Amalj\'aa Artillery': 'Artillerie amalj\'aa',
      'Biting Wind': 'Tornade',
      'Blaze of Glory': 'Croix des flammes sacrées',
      'Blazing Benifice': 'Canon des flammes sacrées',
      'Blistering Blow': 'Coup fulgurant',
      'Bracing Duster': 'Plumeau tonifiant',
      'Bracing Suds': 'Mousse tonifiante',
      'Brim Over': 'Ras-le-bord',
      '(?<!Slash)Burn': 'Combustion',
      'Carpet Beater': 'Tapette à tapis',
      'Cast Shadow': 'Ombre crépitante',
      'Chilling Duster': 'Plumeau givré',
      'Chilling Suds': 'Mousse givrée',
      'Cogwheel': 'Souffle ardent',
      'Colossal Charge': 'Ruée colossale',
      'Colossal Launch': 'Lancer colossal',
      'Colossal Slam': 'Coup colossal',
      'Colossal Strike': 'Frappe colossale',
      'Colossal Swing': 'Swing colossal',
      'Cryptic Portal': 'Portail cryptique',
      'Deep Clean': 'Grand nettoyage',
      'Dust Bluster': 'Dépoussiérage',
      'Eastern Ewers': 'Aiguière aqueuse',
      'Exploding Catapult': 'Catapulte explosive',
      'Explosion': 'Explosion',
      'Firesteel Fracture': 'Choc brasero',
      'Flash of Steel': 'Éclair d\'acier',
      'Fore Honor': 'Lueur ardente',
      'Fresh Puff': 'Pompon lustré',
      'Gigantomill': 'Broyage colossal',
      'Gladiator of Sil\'dih': 'gladiateur sildien',
      'Golden Flame': 'Flamme dorée',
      'Hateful Visage': 'Visage de haine',
      'Infern Brand': 'Étendard sacré',
      'Infern Gale': 'Brise infernale',
      'Infern Ward': 'Barrière infernale',
      'Infern Well': 'Fourneau infernal',
      'Intake': 'Aspiration',
      'Landing': 'Atterrissage rapide',
      'Magic Cannon': 'Canon magique',
      'Mighty Smite': 'Taillade belliqueuse',
      'Puff and Tumble': 'Pompon culbuteur',
      'Pure Fire': 'Feu immaculé',
      'Rack and Ruin': 'Dévastation immémoriale',
      'Ring of Might': 'Rafale de puissance',
      'Rinse': 'Rinçage',
      'Rolling Boulder': 'Rocher roulant',
      'Runaway Runoff': 'Éruption boueuse',
      'Runaway Sludge': 'Éruption fangeuse',
      'Rush of Might': 'Déferlement de puissance',
      'Sculptor\'s Passion': 'Canon belliqueux',
      'Shattering Steel': 'Ravage d\'acier',
      'Shockwave': 'Onde de choc',
      'Show of Strength': 'Cri du guerrier',
      'Signal Flare': 'Brasier du tocsin',
      'Silver Flame': 'Flamme argentée',
      'Slashburn': 'Taillade enflammée',
      'Slippery Soap': 'Bain moussant glissant',
      'Soap\'s Up': 'Bain moussant explosif',
      'Soaping Spree': 'Bain moussant public',
      'Spot Remover': 'Antitaches',
      'Spring to Life': 'Source de vie',
      'Squeaky Left': 'Frottage gauche',
      'Squeaky Right': 'Frottage droit',
      'Subterranean Shudder': 'Frémissement souterrain',
      'Suddenly Sewage': 'Éruption crasseuse',
      'Sundered Remains': 'Soulèvement belliqueux',
      'Total Wash': 'Lavage intégral',
      'Wash Out': 'Essorage',
      'Wrath of Ruin': 'Colère immémoriale'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Amalj\'aa Artillery Carriage': 'アマルジャ式野砲',
      'Antique Boulder': '岩石',
      'Arcane Font': '立体魔法陣',
      'Ball of Fire': '火炎球',
      'Cold Arms\' Quietus': '聖火兵器安置場',
      'Eastern Ewer': '洗い壺',
      'Eternal Ease': '勇士たちの寝所',
      'Geryon the Steer': '覇道のゲーリュオン',
      'Gladiator of Sil\'dih': 'シラディハ・グラディアトル',
      'Hateful Visage': '呪像起動',
      'Infern Brand': '呪具設置',
      'Magicked Puppet': 'ソーン・マジックソルジャー',
      'Powder Keg': '樽爆弾',
      'Regret': '後悔',
      'Shadowcaster Zeless Gah': '影火のゼレズ・ガー',
      'Silken Puff': 'シルキーズ・ポンポン',
      'Silkie': 'シルキー',
      'The Cornice Of Favor': '御前闘技台',
      'The Forgotten Forecourt': '花園の前庭',
      'The Settling Basin': '汚泥処理池',
      'The Sifting Site': '沈石搬出施設',
      'The Silt Pump': '泥水ポンプ棟',
      'Thorne Knight': 'ソーン・マジックナイト'
    },
    'replaceText': {
      'Amalj\'aa Artillery': 'アマルジャ式野砲',
      'Biting Wind': '烈風',
      'Blaze of Glory': '十字聖火',
      'Blazing Benifice': '聖火砲',
      'Blistering Blow': '乱斬り',
      'Bracing Duster': 'そよそよダスター',
      'Bracing Suds': 'そよそよシャンプー',
      'Brim Over': '現出',
      '(?<!Slash)Burn': '燃焼',
      'Carpet Beater': 'カーペットビーター',
      'Cast Shadow': '影火呪式',
      'Chilling Duster': 'ひえひえダスター',
      'Chilling Suds': 'ひえひえシャンプー',
      'Cogwheel': '焔剣熱風斬',
      'Colossal Charge': 'コロッサスチャージ',
      'Colossal Launch': 'コロッサスローンチ',
      'Colossal Slam': 'コロッサススラム',
      'Colossal Strike': 'コロッサスストライク',
      'Colossal Swing': 'コロッサススイング',
      'Cryptic Portal': '転移の呪印',
      'Deep Clean': '大掃除',
      'Dust Bluster': 'ダストブロワー',
      'Eastern Ewers': '洗い壺',
      'Exploding Catapult': '爆弾ブン投げ',
      'Explosion': '爆発',
      'Firesteel Fracture': '石火豪打',
      'Flash of Steel': '闘人の波動',
      'Fore Honor': '前方焔剣閃',
      'Fresh Puff': 'ポンポン創出',
      'Gigantomill': 'コロッサスミル',
      'Gladiator of Sil\'dih': 'シラディハ・グラディアトル',
      'Golden Flame': '黄金の閃火',
      'Hateful Visage': '呪像起動',
      'Infern Brand': '呪具設置',
      'Infern Gale': '呪具暴風',
      'Infern Ward': '呪具警陣',
      'Infern Well': '呪具吸炎',
      'Intake': '吸引',
      'Landing': '落着',
      'Magic Cannon': '魔力砲',
      'Mighty Smite': '闘人の斬撃',
      'Puff and Tumble': 'ポンポンはたきがけ',
      'Pure Fire': '劫火',
      'Rack and Ruin': '亡念弾',
      'Ring of Might': '大剛の旋撃',
      'Rinse': 'すすぎ洗い',
      'Rolling Boulder': '転石',
      'Runaway Runoff': '水塊噴出',
      'Runaway Sludge': '泥塊噴出',
      'Rush of Might': '大剛の突撃',
      'Sculptor\'s Passion': '闘人砲',
      'Shattering Steel': '激発の波動',
      'Shockwave': '衝撃波',
      'Show of Strength': '勇士の咆哮',
      'Signal Flare': '烽火連天',
      'Silver Flame': '白銀の閃火',
      'Slashburn': '刀撃火種',
      'Slippery Soap': 'すべってシャンプーボム',
      'Soap\'s Up': 'シャンプーボム',
      'Soaping Spree': 'みんなでシャンプーボム',
      'Spot Remover': '水撒き',
      'Spring to Life': '兵装発動',
      'Squeaky Left': '左水拭き',
      'Squeaky Right': '右水拭き',
      'Subterranean Shudder': '連鎖振動波',
      'Suddenly Sewage': '汚水噴出',
      'Sundered Remains': '闘場隆起',
      'Total Wash': '水洗い',
      'Wash Out': '洗い流す',
      'Wrath of Ruin': '亡念励起'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Amalj\'aa Artillery Carriage': '蜥蜴人式野炮',
      'Antique Boulder': '岩石',
      'Arcane Font': '立体魔法阵',
      'Ball of Fire': '火球',
      'Cold Arms\' Quietus': '圣火兵器放置处',
      'Eastern Ewer': '倒水瓶',
      'Eternal Ease': '勇士安睡之地',
      'Geryon the Steer': '征服者 革律翁',
      'Gladiator of Sil\'dih': '希拉狄哈剑斗士',
      'Hateful Visage': '亡国咒像',
      'Infern Brand': '蜥蜴人咒具',
      'Magicked Puppet': '索恩自走士兵',
      'Powder Keg': '大桶炸弹',
      'Regret': '亡念',
      'Shadowcaster Zeless Gah': '鬼阴火 泽雷斯·夏',
      'Silken Puff': '羽衣精的绒球',
      'Silkie': '羽衣精',
      'The Cornice Of Favor': '御前斗技台',
      'The Forgotten Forecourt': '花园前庭',
      'The Settling Basin': '污泥处理池',
      'The Sifting Site': '滤石设施',
      'The Silt Pump': '泥水泵',
      'Thorne Knight': '索恩自走人偶'
    },
    'replaceText': {
      '--draw in--': '--拉入--',
      '\\(in\\)': '(内)',
      '\\(out\\)': '(外)',
      '\\(far\\)': '(远)',
      '\\(near\\)': '(近)',
      '\\(mid\\)': '(中间)',
      'Amalj\'aa Artillery': '蜥蜴人式野炮',
      'Biting Wind': '烈风',
      'Blaze of Glory': '十字圣火',
      'Blazing Benifice': '圣火炮',
      'Blistering Blow': '乱刃斩',
      'Bracing Duster': '风清除尘',
      'Bracing Suds': '风清泡泡',
      'Brim Over': '显现',
      '(?<!Slash)Burn': '燃烧',
      'Carpet Beater': '拍毯子',
      'Cast Shadow': '影火咒式',
      'Chilling Duster': '冰凉除尘',
      'Chilling Suds': '冰凉泡泡',
      'Cogwheel': '炎剑热风斩',
      'Colossal Charge': '巨大冲锋',
      'Colossal Launch': '巨大锤击',
      'Colossal Slam': '巨大抨击',
      'Colossal Strike': '巨大强击',
      'Colossal Swing': '巨大挥打',
      'Cryptic Portal': '传送咒印',
      'Deep Clean': '大扫除',
      'Dust Bluster': '掸土',
      'Eastern Ewers': '倒水瓶',
      'Exploding Catapult': '投掷炸弹',
      'Explosion': '爆炸',
      'Firesteel Fracture': '石火豪打',
      'Flash of Steel': '斗士波动',
      'Fore Honor': '前方炎剑闪',
      'Fresh Puff': '创造绒球',
      'Gigantomill': '粉碎旋击',
      'Gladiator of Sil\'dih': '希拉狄哈剑斗士',
      'Golden Flame': '黄金闪火',
      'Hateful Visage': '启动咒像',
      'Infern Brand': '设置咒具',
      'Infern Gale': '咒具暴风',
      'Infern Ward': '咒具警阵',
      'Infern Well': '咒具吸炎',
      'Intake': '吸引',
      'Landing': '落地',
      'Magic Cannon': '魔力炮',
      'Mighty Smite': '斗士斩击',
      'Puff and Tumble': '绒球翻滚',
      'Pure Fire': '劫火',
      'Rack and Ruin': '亡念弹',
      'Ring of Might': '刚武旋击',
      'Rinse': '漂洗',
      'Rolling Boulder': '滚动巨石',
      'Runaway Runoff': '水流喷涌',
      'Runaway Sludge': '污泥喷涌',
      'Rush of Might': '刚武突击',
      'Sculptor\'s Passion': '斗士炮',
      'Shattering Steel': '激发波动',
      'Shockwave': '冲击波',
      'Show of Strength': '勇士的咆哮',
      'Signal Flare': '烽火连天',
      'Silver Flame': '白银闪火',
      'Slashburn': '刀击火种',
      'Slippery Soap': '泡泡滑行',
      'Soap\'s Up': '泡泡破裂',
      'Soaping Spree': '泡泡总动员',
      'Spot Remover': '洒水',
      'Spring to Life': '发动兵装',
      'Squeaky Left': '左擦擦',
      'Squeaky Right': '右擦擦',
      'Subterranean Shudder': '连锁震动波',
      'Suddenly Sewage': '污水喷涌',
      'Sundered Remains': '场地隆起',
      'Total Wash': '水洗',
      'Wash Out': '冲水',
      'Wrath of Ruin': '亡念激起'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Amalj\'aa Artillery Carriage': '아말쟈식 야전포',
      'Antique Boulder': '암석',
      'Arcane Font': '입체마법진',
      'Ball of Fire': '불덩이',
      'Cold Arms\' Quietus': '성화병기 안치장',
      'Eastern Ewer': '물동이',
      'Eternal Ease': '용사들의 침소',
      'Geryon the Steer': '패도의 게리온',
      'Gladiator of Sil\'dih': '실디하 검투사',
      'Hateful Visage': '망국의 저주상',
      'Infern Brand': '아말쟈 주술도구',
      'Magicked Puppet': '손 마법병사',
      'Powder Keg': '나무통 폭탄',
      'Regret': '망념',
      'Shadowcaster Zeless Gah': '그림자불 젤레즈 가',
      'Silken Puff': '실키 폼폼',
      'Silkie': '실키',
      'The Cornice Of Favor': '어전 투기대',
      'The Forgotten Forecourt': '화원 앞뜰',
      'The Settling Basin': '진흙 처리 연못',
      'The Sifting Site': '암석 반출 시설',
      'The Silt Pump': '흙탕물 양수실',
      'Thorne Knight': '손 마법기사'
    },
    'replaceText': {
      '--draw in--': '--당겨짐--',
      '\\(in\\)': '(안)',
      '\\(out\\)': '(밖)',
      '\\(far\\)': '(멀리)',
      '\\(near\\)': '(가까이)',
      '\\(mid\\)': '(중간)',
      'Amalj\'aa Artillery': '아말쟈식 야전포',
      'Biting Wind': '맹렬한 바람',
      'Blaze of Glory': '십자성화',
      'Blazing Benifice': '성화포',
      'Blistering Blow': '마구베기',
      'Bracing Duster': '산들산들 닦기',
      'Bracing Suds': '산들산들 비누거품',
      'Brim Over': '물동이 출현',
      '(?<!Slash)Burn': '연소',
      'Carpet Beater': '융단 털기',
      'Cast Shadow': '그림자불 주술식',
      'Chilling Duster': '오들오들 닦기',
      'Chilling Suds': '오들오들 비누거품',
      'Cogwheel': '염검열풍참',
      'Colossal Charge': '우람한 돌진',
      'Colossal Launch': '우람한 내려찍기',
      'Colossal Slam': '우람한 후려치기',
      'Colossal Strike': '우람한 내려치기',
      'Colossal Swing': '우람한 휘두르기',
      'Cryptic Portal': '묵직한 문',
      'Deep Clean': '대청소',
      'Dust Bluster': '먼지 털기',
      'Eastern Ewers': '물동이',
      'Exploding Catapult': '폭탄 내던지기',
      'Explosion': '폭발',
      'Firesteel Fracture': '석화호타',
      'Flash of Steel': '투사의 파동',
      'Fore Honor': '전방 염검섬',
      'Fresh Puff': '폼폼 만들기',
      'Gigantomill': '우람한 으깨기',
      'Gladiator of Sil\'dih': '실디하 검투사',
      'Golden Flame': '황금 섬화',
      'Hateful Visage': '망국의 저주상',
      'Infern Brand': '아말쟈 주술도구',
      'Infern Gale': '주술도구 폭풍',
      'Infern Ward': '주술도구 경비진',
      'Infern Well': '주술도구 흡염',
      'Intake': '흡인',
      'Landing': '발착장',
      'Magic Cannon': '마력포',
      'Mighty Smite': '투사의 참격',
      'Puff and Tumble': '폼폼 먼지떨이',
      'Pure Fire': '겁화',
      'Rack and Ruin': '망념탄',
      'Ring of Might': '강력한 회전격',
      'Rinse': '헹구기',
      'Rolling Boulder': '구르는 돌',
      'Runaway Runoff': '물덩이 분출',
      'Runaway Sludge': '흙덩이 분출',
      'Rush of Might': '강력한 돌격',
      'Sculptor\'s Passion': '투사포',
      'Shattering Steel': '격발의 파동',
      'Shockwave': '충격파',
      'Show of Strength': '용사의 포효',
      'Signal Flare': '연속 봉화',
      'Silver Flame': '백은 섬화',
      'Slashburn': '검격 불씨',
      'Slippery Soap': '미끄덩 비누 폭탄',
      'Soap\'s Up': '비누 폭탄',
      'Soaping Spree': '다 함께 비누 폭탄',
      'Spot Remover': '물 뿌리기',
      'Spring to Life': '병기 발동',
      'Squeaky Left': '왼쪽 물걸레질',
      'Squeaky Right': '오른쪽 물걸레질',
      'Subterranean Shudder': '연쇄 진동파',
      'Suddenly Sewage': '구정물 분출',
      'Sundered Remains': '검투장 융기',
      'Total Wash': '물청소',
      'Wash Out': '씻어내기',
      'Wrath of Ruin': '망념 상기'
    }
  }]
};
/* harmony default export */ const the_sildihn_subterrane = (the_sildihn_subterrane_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/the_sildihn_subterrane.txt
const dungeon_the_sildihn_subterrane_namespaceObject = "# The Sil'dihn Subterrane\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n### Geryon the Steer (left door, 1st boss)\r\n# -p 74CF:1010.6 74D2:2019.7\r\n# -ii 7A1C 74D3\r\n\r\n# Silt Pump will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1068\" } window 100000,0\r\n1005.6 \"--sync--\" StartsUsing { id: \"74CF\", source: \"Geryon the Steer\" }\r\n1010.6 \"Colossal Strike\" Ability { id: \"74CF\", source: \"Geryon the Steer\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> yes pump\r\n1019.7 \"--sync--\" StartsUsing { id: \"74C7\", source: \"Geryon the Steer\" } window 20,20 jump 1219.7\r\n1024.7 \"Exploding Catapult?\" #Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n\r\n# -> no pump\r\n1014.7 \"--sync--\" StartsUsing { id: \"74D2\", source: \"Geryon the Steer\" } window 20,20 jump 2014.7\r\n1019.7 \"Subterranean Shudder\" #Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Geryon the Steer (left door, 1st boss, yes pump)\r\n1219.7 \"--sync--\" StartsUsing { id: \"74C7\", source: \"Geryon the Steer\" }\r\n1224.7 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n1241.5 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n1246.1 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n1256.3 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n1261.7 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n1265.7 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n\r\n1272.8 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n1283.9 \"Runaway Runoff\" Ability { id: \"74D7\", source: \"Geryon the Steer\" }\r\n1288.3 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n1292.7 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n1295.8 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n1304.0 \"Colossal Launch\" Ability { id: \"74C8\", source: \"Geryon the Steer\" }\r\n1309.2 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n1310.6 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n1316.5 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n1327.6 \"Colossal Charge\" Ability { id: \"74C[CD]\", source: \"Geryon the Steer\" }\r\n1333.0 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n1338.0 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n1347.4 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n1355.5 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n1364.4 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n1365.8 \"--sync--\" Ability { id: \"74C[9A]\", source: \"Geryon the Steer\" }\r\n1367.6 \"Gigantomill 1\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n1369.4 \"Gigantomill 2\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n1371.2 \"Gigantomill 3\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n1373.0 \"Gigantomill 4\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n1382.7 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n\r\n1389.8 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n1400.9 \"Runaway Runoff\" Ability { id: \"74D7\", source: \"Geryon the Steer\" }\r\n1405.5 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n1410.1 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n1413.2 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n1421.5 \"Colossal Launch / Colossal Swing\" Ability { id: [\"74C8\", \"74D1\"], source: \"Geryon the Steer\" } # only seen Launch\r\n1428.1 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n1434.9 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n1445.3 \"Colossal Strike\" Ability { id: \"74CF\", source: \"Geryon the Steer\" }\r\n1449.4 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n1456.7 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n1467.8 \"Colossal Charge\" Ability { id: \"74C[CD]\", source: \"Geryon the Steer\" }\r\n1473.2 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n1478.2 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n1487.6 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n1495.7 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n1504.6 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n1506.0 \"--sync--\" Ability { id: \"74C[9A]\", source: \"Geryon the Steer\" }\r\n1507.8 \"Gigantomill 1\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n1509.6 \"Gigantomill 2\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n1511.4 \"Gigantomill 3\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n1513.2 \"Gigantomill 4\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n1522.9 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n\r\n1530.0 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" } window 80,80 jump 1389.8\r\n1541.1 \"Runaway Runoff\" #Ability { id: \"74D7\", source: \"Geryon the Steer\" }\r\n1545.7 \"Explosion\" #Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n1550.3 \"Exploding Catapult\" #Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n1553.4 \"--sync--\" #Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n1561.7 \"Colossal Launch\" #Ability { id: \"74C8\", source: \"Geryon the Steer\" }\r\n1568.3 \"Explosion\" #Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n\r\n\r\n# Geryon the Steer (left door, 1st boss, no pump)\r\n2014.7 \"--sync--\" StartsUsing { id: \"74D2\", source: \"Geryon the Steer\" }\r\n2019.7 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n2025.8 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n2026.8 \"Runaway Sludge\" Ability { id: \"74D6\", source: \"Geryon the Steer\" }\r\n2033.1 \"Shockwave\" Ability { id: \"74CE\", source: \"Geryon the Steer\" }\r\n2042.3 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n2059.0 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n2063.6 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n2073.8 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n2079.2 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n2083.2 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n2086.3 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n2094.5 \"Colossal Launch\" Ability { id: \"74C8\", source: \"Geryon the Steer\" }\r\n2101.2 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n\r\n2104.8 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n2106.9 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n2111.9 \"Runaway Sludge\" Ability { id: \"74D6\", source: \"Geryon the Steer\" }\r\n2117.1 \"--sync--\" Ability { id: \"74C[9A]\", source: \"Geryon the Steer\" }\r\n2118.9 \"Gigantomill 1\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n2120.7 \"Gigantomill 2\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n2122.5 \"Gigantomill 3\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n2124.3 \"Gigantomill 4\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n2129.0 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n2136.3 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n2147.4 \"Colossal Charge\" Ability { id: \"74C[CD]\", source: \"Geryon the Steer\" }\r\n2152.8 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n2157.8 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n2167.2 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n2173.3 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n2174.3 \"Runaway Sludge\" Ability { id: \"74D6\", source: \"Geryon the Steer\" }\r\n2180.6 \"Shockwave\" Ability { id: \"74CE\", source: \"Geryon the Steer\" }\r\n2190.7 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n2193.8 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n2202.0 \"Colossal Launch / Colossal Swing\" Ability { id: [\"74C8\", \"74D1\"], source: \"Geryon the Steer\" }\r\n2208.7 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n2215.3 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n2225.7 \"Colossal Strike\" Ability { id: \"74CF\", source: \"Geryon the Steer\" }\r\n\r\n2235.8 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" } window 40,40 jump 2104.8\r\n2237.9 \"--sync--\" #Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n2242.9 \"Runaway Sludge\" #Ability { id: \"74D6\", source: \"Geryon the Steer\" }\r\n2248.1 \"--sync--\" #Ability { id: \"74C[9A]\", source: \"Geryon the Steer\" }\r\n2249.9 \"Gigantomill 1\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n2251.7 \"Gigantomill 2\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n2253.5 \"Gigantomill 3\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n2255.3 \"Gigantomill 4\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n\r\n\r\n### Geryon the Steer (middle door, 1st boss)\r\n# -p 74CF:3010 74D9:3276.2 74DA:4078.2\r\n# -ii 7A1C 74D3\r\n\r\n# Sifting Site will be sealed off\r\n3000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1070\" } window 100000,0\r\n3005.0 \"--sync--\" StartsUsing { id: \"74CF\", source: \"Geryon the Steer\" }\r\n3010.0 \"Colossal Strike\" Ability { id: \"74CF\", source: \"Geryon the Steer\" }\r\n3019.1 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n3035.8 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n3040.4 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n3050.6 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n3056.0 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n\r\n3060.0 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n3067.1 \"Exploding Catapult\" #Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> left handle\r\n3062.1 \"--sync--\" MapEffect { flags: \"00020001\", location: \"09\" } window 70,70 jump 3262.1\r\n3076.2 \"Intake?\" #Ability { id: \"74D9\", source: \"Geryon the Steer\" }\r\n\r\n# -> right handle\r\n3062.1 \"--sync--\" MapEffect { flags: \"20000004\", location: \"0A\" } window 70,70 jump 4062.1\r\n3078.2 \"Rolling Boulder?\" #Ability { id: \"74DA\", source: \"Geryon the Steer\" }\r\n\r\n# TODO: fix the test_timeline utilities (python doesn't handle this, typescript is broken)\r\n3076.2 \"--sync--\" Ability { id: \"74D9\", source: \"Geryon the Steer\" } window 70,70 jump 3276.2\r\n3078.2 \"--sync--\" Ability { id: \"74DA\", source: \"Geryon the Steer\" } window 70,70 jump 4078.2\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Geryon the Steer (middle door, 1st boss, left handle)\r\n3260.0 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n3262.1 \"--sync--\" MapEffect { flags: \"00020001\", location: \"09\" }\r\n3267.1 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n3276.2 \"Intake\" Ability { id: \"74D9\", source: \"Geryon the Steer\" } window 300,10\r\n3280.6 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n3285.2 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n3288.3 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n3296.5 \"Colossal Launch\" Ability { id: \"74C8\", source: \"Geryon the Steer\" }\r\n3303.2 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n3306.8 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n3314.9 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n3323.9 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n3325.3 \"--sync--\" Ability { id: \"74C[9A]\", source: \"Geryon the Steer\" }\r\n3327.1 \"Gigantomill 1\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n3328.9 \"Gigantomill 2\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n3330.7 \"Gigantomill 3\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n3332.5 \"Gigantomill 4\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n3336.2 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n3343.5 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n3354.6 \"Colossal Charge\" Ability { id: \"74C[CD]\", source: \"Geryon the Steer\" }\r\n3360.0 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n3365.0 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n\r\n3374.4 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n3381.5 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n3390.6 \"Intake\" Ability { id: \"74D9\", source: \"Geryon the Steer\" }\r\n3395.0 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n3399.6 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n3402.7 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n3410.8 \"Colossal Launch / Colossal Swing\" Ability { id: [\"74C8\", \"74D1\"], source: \"Geryon the Steer\" } # only seen Launch\r\n3417.5 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n3424.3 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n3433.7 \"Colossal Strike\" Ability { id: \"74CF\", source: \"Geryon the Steer\" }\r\n3442.8 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n3450.9 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n3459.6 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n3461.0 \"--sync--\" Ability { id: \"74C[9A]\", source: \"Geryon the Steer\" }\r\n3462.8 \"Gigantomill 1\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n3464.6 \"Gigantomill 2\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n3466.4 \"Gigantomill 3\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n3468.2 \"Gigantomill 4\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n3471.9 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n3479.2 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n3490.3 \"Colossal Charge\" Ability { id: \"74C[CD]\", source: \"Geryon the Steer\" }\r\n3495.7 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n3500.7 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n\r\n3510.1 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" } window 80,80 jump 3374.4\r\n3517.2 \"Exploding Catapult\" #Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n3526.3 \"Intake\" #Ability { id: \"74D9\", source: \"Geryon the Steer\" }\r\n3530.7 \"Explosion\" #Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n3535.3 \"Exploding Catapult\" #Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n\r\n\r\n# Geryon the Steer (middle door, 1st boss, right handle)\r\n4060.0 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n4067.1 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n4078.2 \"Rolling Boulder\" #Ability { id: \"74DA\", source: \"Geryon the Steer\" }\r\n4081.7 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n4086.1 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n4089.2 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n4097.3 \"Colossal Launch\" Ability { id: \"74C8\", source: \"Geryon the Steer\" }\r\n4102.5 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n4103.9 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n4109.8 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n4120.9 \"Colossal Charge\" Ability { id: \"74C[CD]\", source: \"Geryon the Steer\" }\r\n4126.3 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n4131.3 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n4140.7 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n4148.8 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n4157.6 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n4159.0 \"--sync--\" Ability { id: \"74C[9A]\", source: \"Geryon the Steer\" }\r\n4160.8 \"Gigantomill 1\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n4162.6 \"Gigantomill 2\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n4164.4 \"Gigantomill 3 \" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n4166.2 \"Gigantomill 4\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n\r\n4174.9 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n4182.0 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n4193.1 \"Rolling Boulder\" #Ability { id: \"74DA\", source: \"Geryon the Steer\" }\r\n4196.6 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n4201.1 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n4204.2 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n4212.3 \"Colossal Launch / Colossal Swing\" Ability { id: [\"74C8\", \"74D1\"], source: \"Geryon the Steer\" } # only seen Swing\r\n4218.0 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n4224.7 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n4234.1 \"Colossal Strike\" Ability { id: \"74CF\", source: \"Geryon the Steer\" }\r\n4238.2 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n4245.5 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n4256.6 \"Colossal Charge\" Ability { id: \"74C[CD]\", source: \"Geryon the Steer\" }\r\n4262.0 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n4267.0 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n4276.4 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n4284.5 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n4293.4 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n4294.8 \"--sync--\" Ability { id: \"74C[9A]\", source: \"Geryon the Steer\" }\r\n4296.6 \"Gigantomill 1\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n4298.4 \"Gigantomill 2\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n4300.2 \"Gigantomill 3\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n4302.0 \"Gigantomill 4\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n\r\n4310.7 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" } window 70,70 jump 4174.9\r\n4317.8 \"Exploding Catapult\" #Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n4328.9 \"Rolling Boulder\" #Ability { id: \"74DA\", source: \"Geryon the Steer\" }\r\n4332.4 \"Explosion\" #Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n4336.9 \"Exploding Catapult\" #Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n\r\n\r\n### Geryon the Steer (right door, 1st boss)\r\n# -p 74CF:5010\r\n# -ii 7A1C 74D3\r\n\r\n# Settling Basin will be sealed off\r\n5000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"106D\" } window 100000,0\r\n5005.0 \"--sync--\" StartsUsing { id: \"74CF\", source: \"Geryon the Steer\" }\r\n5010.0 \"Colossal Strike\" Ability { id: \"74CF\", source: \"Geryon the Steer\" }\r\n\r\n5020.1 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n\r\n# We could probably jump from MapEffect lines here to each branch\r\n# But for simplicity, just use the \"jump to middle\" before Gigantomill\r\n# to differentiate the timelines.\r\n5023.2 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" } window 30,30 jump 6023.2\r\n\r\n# Geryon the Steer (right door, 1st boss, ceruleum leak)\r\n5030.2 \"Suddenly Sewage 1\" #Ability { id: \"74D8\", source: \"Geryon the Steer\" }\r\n5032.2 \"Suddenly Sewage 2\" #Ability { id: \"74D8\", source: \"Geryon the Steer\" }\r\n5040.2 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n5056.9 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n5061.5 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n5071.7 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n5077.1 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n5081.1 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n5084.2 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n5092.4 \"Colossal Launch\" Ability { id: \"74C8\", source: \"Geryon the Steer\" }\r\n5099.1 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n5102.7 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n5110.8 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n5119.7 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n5121.1 \"--sync--\" Ability { id: \"74C[9A]\", source: \"Geryon the Steer\" }\r\n5122.9 \"Gigantomill 1\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n5124.7 \"Gigantomill 2\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n5126.5 \"Gigantomill 3\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n5128.3 \"Gigantomill 4\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n5132.0 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n5139.3 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n5150.4 \"Colossal Charge\" Ability { id: \"74C[CD]\", source: \"Geryon the Steer\" }\r\n5155.8 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n5160.8 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n\r\n5170.2 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n5174.3 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n5180.3 \"Suddenly Sewage 1\" #Ability { id: \"74D8\", source: \"Geryon the Steer\" }\r\n5181.7 \"Colossal Swing\" Ability { id: \"74D1\", source: \"Geryon the Steer\" }\r\n5182.3 \"Suddenly Sewage 2\" #Ability { id: \"74D8\", source: \"Geryon the Steer\" }\r\n5190.9 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n5194.0 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n5202.4 \"Colossal Launch / Colossal Swing\" Ability { id: [\"74C8\", \"74D1\"], source: \"Geryon the Steer\" }\r\n5209.1 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n5215.8 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n5225.2 \"Colossal Strike\" Ability { id: \"74CF\", source: \"Geryon the Steer\" }\r\n5234.3 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n5242.4 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n5251.3 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n5252.7 \"--sync--\" Ability { id: \"74C[9A]\", source: \"Geryon the Steer\" }\r\n5254.5 \"Gigantomill 1\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n5256.3 \"Gigantomill 2\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n5258.1 \"Gigantomill 3\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n5259.9 \"Gigantomill 4\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n5263.6 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n5270.9 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n5282.0 \"Colossal Charge\" Ability { id: \"74C[CD]\", source: \"Geryon the Steer\" }\r\n5287.4 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n5292.4 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n\r\n5301.8 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" } window 70,70 jump 5370.2\r\n5305.9 \"--sync--\" #Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n5311.9 \"Suddenly Sewage 1\" #Ability { id: \"74D8\", source: \"Geryon the Steer\" }\r\n5313.3 \"Colossal Swing\" #Ability { id: \"74D1\", source: \"Geryon the Steer\" }\r\n5313.9 \"Suddenly Sewage 2\" #Ability { id: \"74D8\", source: \"Geryon the Steer\" }\r\n5322.5 \"Exploding Catapult\" #Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n\r\n\r\n# Geryon the Steer (right door, 1st boss, no ceruleum leak)\r\n6020.1 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n6023.2 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n6033.6 \"--sync--\" Ability { id: \"74C[9A]\", source: \"Geryon the Steer\" }\r\n6035.4 \"Gigantomill 1\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n6037.2 \"Gigantomill 2\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n6039.0 \"Gigantomill 3\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n6040.8 \"Gigantomill 4\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n6049.5 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n6066.2 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n6070.8 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n6081.0 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n6086.4 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n6090.4 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n6093.5 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n6101.6 \"Colossal Launch\" Ability { id: \"74C8\", source: \"Geryon the Steer\" }\r\n6108.3 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n6108.9 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n6116.2 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n6127.3 \"Colossal Charge\" Ability { id: \"74C[CD]\", source: \"Geryon the Steer\" }\r\n6132.7 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n6137.7 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n\r\n6147.1 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" }\r\n6150.2 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n6160.5 \"--sync--\" Ability { id: \"74C[9A]\", source: \"Geryon the Steer\" }\r\n6162.3 \"Gigantomill 1\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n6164.1 \"Gigantomill 2\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n6165.9 \"Gigantomill 3\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n6167.7 \"Gigantomill 4\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n6176.4 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n6179.5 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n6187.7 \"Colossal Launch / Colossal Swing\" Ability { id: [\"74C8\", \"74D1\"], source: \"Geryon the Steer\" }\r\n6194.4 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n6201.0 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n6210.4 \"Colossal Strike\" Ability { id: \"74CF\", source: \"Geryon the Steer\" }\r\n6214.5 \"--sync--\" Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n6221.8 \"Exploding Catapult\" Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n6232.9 \"Colossal Charge\" Ability { id: \"74C[CD]\", source: \"Geryon the Steer\" }\r\n6238.3 \"Explosion\" Ability { id: \"74D[45]\", source: \"Powder Keg\" }\r\n6243.3 \"Colossal Slam\" Ability { id: \"74D0\", source: \"Geryon the Steer\" }\r\n\r\n6252.7 \"Subterranean Shudder\" Ability { id: \"74D2\", source: \"Geryon the Steer\" } window 70,70 jump 6147.1\r\n6255.8 \"--sync--\" #Ability { id: \"74C6\", source: \"Geryon the Steer\" }\r\n6266.1 \"--sync--\" #Ability { id: \"74C[9A]\", source: \"Geryon the Steer\" }\r\n6267.9 \"Gigantomill 1\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n6269.7 \"Gigantomill 2\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n6271.5 \"Gigantomill 3\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n6273.3 \"Gigantomill 4\" #Ability { id: \"74CB\", source: \"Geryon the Steer\" }\r\n6282.0 \"Exploding Catapult\" #Ability { id: \"74C7\", source: \"Geryon the Steer\" }\r\n\r\n\r\n### Silkie (left door, 2nd boss)\r\n# -p 772C:7014.3\r\n# -ii 772F 7730 7731 7732 7733 7734 7743 7749 7741 7746 774B 774C 77C0\r\n\r\n# Forgotten Forecourt will be sealed off\r\n7000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1069\" } window 100000,0\r\n7009.3 \"--sync--\" StartsUsing { id: \"772C\", source: \"Silkie\" } window 10,10\r\n7014.3 \"Total Wash\" Ability { id: \"772C\", source: \"Silkie\" }\r\n7022.0 \"Squeaky Left/Squeaky Right\" Ability { id: [\"772E\", \"772D\"], source: \"Silkie\" }\r\n7040.9 \"Carpet Beater\" Ability { id: \"772B\", source: \"Silkie\" }\r\n7051.6 \"Squeaky Left/Squeaky Right\" Ability { id: [\"772E\", \"772D\"], source: \"Silkie\" }\r\n7069.6 \"Chilling Suds\" Ability { id: \"7736\", source: \"Silkie\" }\r\n7076.7 \"Soap's Up\" Ability { id: \"7737\", source: \"Silkie\" }\r\n7077.7 \"Chilling Duster\" Ability { id: \"7738\", source: \"Silkie\" }\r\n7086.8 \"Bracing Suds\" Ability { id: \"7735\", source: \"Silkie\" }\r\n7093.9 \"Soap's Up\" Ability { id: \"7737\", source: \"Silkie\" }\r\n7094.9 \"Bracing Duster\" Ability { id: \"7739\", source: \"Silkie\" }\r\n7104.0 \"Bracing Suds / Chilling Suds\" Ability { id: [\"7735\", \"7736\"], source: \"Silkie\" }\r\n7112.8 \"Slippery Soap\" Ability { id: \"773A\", source: \"Silkie\" }\r\n7116.2 \"Bracing Duster / Chilling Duster\" Ability { id: [\"773B\", \"773C\"], source: \"Silkie\" }\r\n7128.3 \"Spot Remover\" Ability { id: \"7742\", source: \"Silkie\" }\r\n7137.4 \"Dust Bluster\" Ability { id: \"7744\", source: \"Silkie\" }\r\n7148.5 \"Total Wash\" Ability { id: \"772C\", source: \"Silkie\" }\r\n\r\n# TODO: depending on which branch you take, the middle\r\n# section of Silkie between Total Wash and Fresh Puff\r\n# (although possibly the second Fresh Puff) is different.\r\n# We could try to keep track of this and have a different\r\n# timeline, but it's less than a minute, happens once,\r\n# and is fairly obvious.  There's also triggers for\r\n# some of it, so maybe Good Enough (TM).\r\n\r\n# Bridge 01\r\n#7148.5 \"Total Wash\" Ability { id: \"772C\", source: \"Silkie\" }\r\n#7158.6 \"Eastern Ewers\" Ability { id: \"7747\", source: \"Silkie\" }\r\n#7162.7 \"Brim Over\" Ability { id: \"7748\", source: \"Eastern Ewer\" }\r\n#7164.7 \"Rinse\" duration 19.7 #Ability { id: \"7749\", source: \"Eastern Ewer\" }\r\n#7165.7 \"Brim Over\" Ability { id: \"7748\", source: \"Eastern Ewer\" }\r\n#7168.7 \"Brim Over\" Ability { id: \"7748\", source: \"Eastern Ewer\" }\r\n#7171.7 \"Brim Over\" Ability { id: \"7748\", source: \"Eastern Ewer\" }\r\n#7172.7 \"Chilling Suds\" Ability { id: \"7736\", source: \"Silkie\" }\r\n#7174.7 \"Brim Over\" Ability { id: \"7748\", source: \"Eastern Ewer\" }\r\n#7179.8 \"Soap's Up\" Ability { id: \"7737\", source: \"Silkie\" }\r\n#7180.8 \"Chilling Duster\" Ability { id: \"7738\", source: \"Silkie\" }\r\n#7191.0 \"Fresh Puff\" Ability { id: \"773D\", source: \"Silkie\" }\r\n\r\n# Bridge 02\r\n#7148.5 \"Total Wash\" Ability { id: \"772C\", source: \"Silkie\" }\r\n#7159.6 \"Bracing Suds\" Ability { id: \"7735\", source: \"Silkie\" }\r\n#7166.3 \"Spot Remover\" Ability { id: \"7742\", source: \"Silkie\" }\r\n#7178.4 \"Wash Out\" Ability { id: \"7745\", source: \"Silkie\" }\r\n#7186.4 \"Slippery Soap\" Ability { id: \"773A\", source: \"Silkie\" }\r\n#7190.0 \"Bracing Duster\" Ability { id: \"773C\", source: \"Silkie\" }\r\n#7200.9 \"Fresh Puff\" Ability { id: \"773D\", source: \"Silkie\" }\r\n\r\n# Bridge 03\r\n#7148.5 \"Total Wash\" Ability { id: \"772C\", source: \"Silkie\" }\r\n#7164.6 \"Fresh Puff\" Ability { id: \"773D\", source: \"Silkie\" }\r\n#7177.7 \"Bracing Suds\" Ability { id: \"7735\", source: \"Silkie\" }\r\n#7178.7 \"Deep Clean\" Ability { id: \"774E\", source: \"Silken Puff\" }\r\n#7186.9 \"Soap's Up\" Ability { id: \"7737\", source: \"Silkie\" }\r\n#7187.9 \"Bracing Duster\" Ability { id: \"7739\", source: \"Silkie\" }\r\n#7197.0 \"Fresh Puff\" Ability { id: \"773D\", source: \"Silkie\" }\r\n\r\n# Bridge 04\r\n#7148.5 \"Total Wash\" Ability { id: \"772C\", source: \"Silkie\" }\r\n#7158.6 \"Fresh Puff\" Ability { id: \"773D\", source: \"Silkie\" }\r\n#7164.8 \"Puff and Tumble\" Ability { id: \"774A\", source: \"Silken Puff\" } duration 11.4\r\n#7173.1 \"Bracing Suds\" Ability { id: \"7735\", source: \"Silkie\" }\r\n#7182.1 \"Slippery Soap\" Ability { id: \"773A\", source: \"Silkie\" }\r\n#7185.5 \"Bracing Duster\" Ability { id: \"773C\", source: \"Silkie\" }\r\n#7196.3 \"Fresh Puff\" Ability { id: \"773D\", source: \"Silkie\" }\r\n\r\n# Puffs\r\n# Note: this is timed to the longest of all bridge sections\r\n7196.9 \"--sync--\" StartsUsing { id: \"773D\", source: \"Silkie\" } window 20,100\r\n7200.9 \"Fresh Puff\" Ability { id: \"773D\", source: \"Silkie\" }\r\n7210.3 \"Chilling Suds\" Ability { id: \"7736\", source: \"Silkie\" }\r\n7217.0 \"Squeaky Left/Squeaky Right\" Ability { id: [\"772E\", \"772D\"], source: \"Silkie\" }\r\n7233.9 \"Soaping Spree\" Ability { id: \"773E\", source: \"Silkie\" }\r\n7234.9 \"Chilling Duster\" Ability { id: \"773F\", source: \"Silken Puff\" }\r\n7245.0 \"Total Wash\" Ability { id: \"772C\", source: \"Silkie\" }\r\n7256.2 \"Bracing Suds / Chilling Suds\" Ability { id: [\"7735\", \"7736\"], source: \"Silkie\" }\r\n7264.0 \"Slippery Soap\" Ability { id: \"773A\", source: \"Silkie\" }\r\n7267.6 \"Bracing Duster / Chilling Duster\" Ability { id: [\"773B\", \"773C\"], source: \"Silkie\" }\r\n\r\n7278.8 \"Squeaky Left/Squeaky Right\" Ability { id: [\"772E\", \"772D\"], source: \"Silkie\" }\r\n7298.7 \"Carpet Beater\" Ability { id: \"772B\", source: \"Silkie\" }\r\n7306.4 \"Spot Remover\" Ability { id: \"7742\", source: \"Silkie\" }\r\n7315.5 \"Dust Bluster\" Ability { id: \"7744\", source: \"Silkie\" }\r\n7326.6 \"Total Wash\" Ability { id: \"772C\", source: \"Silkie\" }\r\n7337.7 \"Bracing Suds / Chilling Suds\" Ability { id: [\"7735\", \"7736\"], source: \"Silkie\" }\r\n7345.4 \"Slippery Soap\" Ability { id: \"773A\", source: \"Silkie\" }\r\n7348.8 \"Bracing Duster / Chilling Duster\" Ability { id: [\"773B\", \"773C\"], source: \"Silkie\" }\r\n\r\n7359.9 \"Squeaky Left/Squeaky Right\" Ability { id: [\"772E\", \"772D\"], source: \"Silkie\" } window 20,20 jump 7278.8\r\n7379.8 \"Carpet Beater\" #Ability { id: \"772B\", source: \"Silkie\" }\r\n7387.5 \"Spot Remover\" #Ability { id: \"7742\", source: \"Silkie\" }\r\n7396.6 \"Dust Bluster\" #Ability { id: \"7744\", source: \"Silkie\" }\r\n7407.7 \"Total Wash\" #Ability { id: \"772C\", source: \"Silkie\" }\r\n7418.8 \"Bracing Suds / Chilling Suds\" #Ability { id: [\"7735\", \"7736\"], source: \"Silkie\" }\r\n7426.5 \"Slippery Soap\" #Ability { id: \"773A\", source: \"Silkie\" }\r\n7429.9 \"Bracing Duster / Chilling Duster\" #Ability { id: [\"773B\", \"773C\"], source: \"Silkie\" }\r\n\r\n\r\n### Gladiator of Sil'dih\r\n# -p 7656:8012\r\n# -ii 764E 763A 763B 763C 764D 7654 7655\r\n\r\n# The Cornice of Favor will be sealed off\r\n8000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1071\" } window 100000,0\r\n8007.0 \"--sync--\" StartsUsing { id: \"7656\", source: \"Gladiator of Sil'dih\" } window 20,20\r\n8012.0 \"Flash of Steel\" Ability { id: \"7656\", source: \"Gladiator of Sil'dih\" }\r\n8019.2 \"--middle--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n8031.4 \"Ring of Might (out)\" Ability { id: [\"763F\", \"7640\", \"7641\"], source: \"Gladiator of Sil'dih\" }\r\n8031.4 \"--sync--\" Ability { id: \"77BF\", source: \"Gladiator of Sil'dih\" }\r\n8033.4 \"Ring of Might (in)\" Ability { id: [\"7642\", \"7643\", \"7644\"], source: \"Gladiator of Sil'dih\" }\r\n8044.6 \"Sculptor's Passion\" Ability { id: \"764A\", source: \"Gladiator of Sil'dih\" }\r\n8050.8 \"--middle--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n8063.6 \"Ring of Might (out)\" Ability { id: [\"763F\", \"7640\", \"7641\"], source: \"Gladiator of Sil'dih\" }\r\n8063.6 \"--sync--\" Ability { id: \"77BF\", source: \"Gladiator of Sil'dih\" }\r\n8065.6 \"Ring of Might (in)\" Ability { id: [\"7642\", \"7643\", \"7644\"], source: \"Gladiator of Sil'dih\" }\r\n8078.8 \"Flash of Steel?\" Ability { id: \"764C\", source: \"Gladiator of Sil'dih\" }\r\n\r\n# Bridge 08\r\n#8065.6 \"Ring of Might (in)\" Ability { id: \"7644\", source: \"Gladiator of Sil'dih\" }\r\n#8078.8 \"Flash of Steel\" Ability { id: \"764C\", source: \"Gladiator of Sil'dih\" }\r\n#8080.9 \"--sync--\" StartsUsing { id: \"79F6\", source: \"Gladiator of Sil'dih\" }\r\n#8084.9 \"Biting Wind\" Ability { id: \"79F6\", source: \"Gladiator of Sil'dih\" }\r\n#8088.5 \"--sync--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n#8102.8 \"Shattering Steel\" Ability { id: \"764B\", source: \"Gladiator of Sil'dih\" }\r\n#8111.1 \"--sync--\" StartsUsing { id: \"7657\", source: \"Gladiator of Sil'dih\" }\r\n#8116.1 \"Mighty Smite\" Ability { id: \"7657\", source: \"Gladiator of Sil'dih\" }\r\n\r\n# Bridge 09\r\n#8065.6 \"Ring of Might (in)\" Ability { id: \"7644\", source: \"Gladiator of Sil'dih\" }\r\n#8078.8 \"Flash of Steel\" Ability { id: \"764F\", source: \"Gladiator of Sil'dih\" }\r\n#8081.9 \"--sync--\" StartsUsing { id: \"7650\", source: \"Antique Boulder\" }\r\n#8088.9 \"Landing 1\" Ability { id: \"7650\", source: \"Antique Boulder\" }\r\n#8092.9 \"Landing 2\" Ability { id: \"7650\", source: \"Antique Boulder\" }\r\n#8096.0 \"--sync--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n#8096.9 \"Landing 3\" Ability { id: \"7650\", source: \"Antique Boulder\" }\r\n#8100.9 \"Landing 4\" Ability { id: \"7650\", source: \"Antique Boulder\" }\r\n#8110.7 \"Shattering Steel\" Ability { id: \"764B\", source: \"Gladiator of Sil'dih\" }\r\n#8117.0 \"--sync--\" StartsUsing { id: \"7657\", source: \"Gladiator of Sil'dih\" }\r\n#8122.0 \"Mighty Smite\" Ability { id: \"7657\", source: \"Gladiator of Sil'dih\" }\r\n\r\n# Bridge 10\r\n#8065.6 \"Ring of Might (in)\" Ability { id: \"7644\", source: \"Gladiator of Sil'dih\" }\r\n#8073.8 \"--sync--\" StartsUsing { id: \"7651\", source: \"Gladiator of Sil'dih\" }\r\n#8076.8 \"Hateful Visage 1\" Ability { id: \"7651\", source: \"Gladiator of Sil'dih\" }\r\n#8089.0 \"Golden Flame 1\" Ability { id: \"7652\", source: \"Hateful Visage\" }\r\n#8095.0 \"Hateful Visage 2\" Ability { id: \"7651\", source: \"Gladiator of Sil'dih\" }\r\n#8107.2 \"Golden Flame 2\" Ability { id: \"7652\", source: \"Hateful Visage\" }\r\n#8107.2 \"Sculptor's Passion\" Ability { id: \"764A\", source: \"Gladiator of Sil'dih\" }\r\n#8114.5 \"--sync--\" StartsUsing { id: \"7657\", source: \"Gladiator of Sil'dih\" }\r\n#8119.5 \"Mighty Smite\" Ability { id: \"7657\", source: \"Gladiator of Sil'dih\" }\r\n\r\n# Bridge 11\r\n#8065.6 \"Ring of Might (in)\" Ability { id: \"7644\", source: \"Gladiator of Sil'dih\" }\r\n#8073.8 \"--sync--\" StartsUsing { id: \"7651\", source: \"Gladiator of Sil'dih\" }\r\n#8076.8 \"Hateful Visage\" Ability { id: \"7651\", source: \"Gladiator of Sil'dih\" }\r\n#8089.0 \"Silver Flame\" Ability { id: \"7653\", source: \"Hateful Visage\" } duration 7.7\r\n#8094.0 \"Sculptor's Passion\" Ability { id: \"764A\", source: \"Gladiator of Sil'dih\" }\r\n#8107.1 \"Flash of Steel\" Ability { id: \"7656\", source: \"Gladiator of Sil'dih\" }\r\n#8114.4 \"--sync--\" StartsUsing { id: \"7657\", source: \"Gladiator of Sil'dih\" }\r\n#8118.4 \"Mighty Smite\" Ability { id: \"7657\", source: \"Gladiator of Sil'dih\" }\r\n\r\n8117.0 \"--sync--\" StartsUsing { id: \"7657\", source: \"Gladiator of Sil'dih\" } window 120,20\r\n8122.0 \"Mighty Smite\" Ability { id: \"7657\", source: \"Gladiator of Sil'dih\" }\r\n8128.1 \"--corner--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n8141.3 \"Rush of Might (near)\" Ability { id: \"763D\", source: \"Gladiator of Sil'dih\" }\r\n8143.3 \"Rush of Might (far)\" Ability { id: \"763E\", source: \"Gladiator of Sil'dih\" }\r\n8152.0 \"Wrath of Ruin\" Ability { id: \"7645\", source: \"Gladiator of Sil'dih\" }\r\n8164.2 \"Rack and Ruin 1\" Ability { id: \"7646\", source: \"Regret\" }\r\n8165.2 \"Sculptor's Passion\" Ability { id: \"764A\", source: \"Gladiator of Sil'dih\" }\r\n8167.2 \"Rack and Ruin 2\" Ability { id: \"7646\", source: \"Regret\" }\r\n8167.3 \"--sync--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n8180.5 \"Rush of Might (near)\" Ability { id: \"763D\", source: \"Gladiator of Sil'dih\" }\r\n8182.5 \"Rush of Might (far)\" Ability { id: \"763E\", source: \"Gladiator of Sil'dih\" }\r\n\r\n8198.2 \"Flash of Steel\" Ability { id: \"7656\", source: \"Gladiator of Sil'dih\" }\r\n8206.3 \"Sundered Remains\" Ability { id: \"7648\", source: \"Gladiator of Sil'dih\" }\r\n8214.4 \"--middle--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n8218.4 \"Sundered Remains (mid)\" #Ability { id: \"7649\", source: \"Gladiator of Sil'dih\" }\r\n8226.9 \"Ring of Might (out)\" Ability { id: [\"763F\", \"7640\", \"7641\"], source: \"Gladiator of Sil'dih\" }\r\n8226.9 \"--sync--\" Ability { id: \"77BF\", source: \"Gladiator of Sil'dih\" }\r\n8228.9 \"Ring of Might (in)\" Ability { id: [\"7642\", \"7643\", \"7644\"], source: \"Gladiator of Sil'dih\" }\r\n8240.1 \"Mighty Smite\" Ability { id: \"7657\", source: \"Gladiator of Sil'dih\" }\r\n8253.2 \"Wrath of Ruin\" Ability { id: \"7645\", source: \"Gladiator of Sil'dih\" }\r\n8259.3 \"--corner--\" Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n8265.3 \"Rack and Ruin 1\" Ability { id: \"7646\", source: \"Regret\" }\r\n8268.3 \"Rack and Ruin 2\" Ability { id: \"7646\", source: \"Regret\" }\r\n8272.4 \"Rush of Might (near)\" Ability { id: \"763D\", source: \"Gladiator of Sil'dih\" }\r\n8274.4 \"Rush of Might (far)\" Ability { id: \"763E\", source: \"Gladiator of Sil'dih\" }\r\n\r\n8291.1 \"Flash of Steel\" Ability { id: \"7656\", source: \"Gladiator of Sil'dih\" } window 70,70 jump 8198.2\r\n8299.2 \"Sundered Remains\" #Ability { id: \"7648\", source: \"Gladiator of Sil'dih\" }\r\n8307.3 \"--middle--\" #Ability { id: \"7639\", source: \"Gladiator of Sil'dih\" }\r\n8311.3 \"Sundered Remains (mid)\" #Ability { id: \"7649\", source: \"Gladiator of Sil'dih\" }\r\n8319.8 \"Ring of Might (out)\" #Ability { id: [\"763F\", \"7640\", \"7641\"], source: \"Gladiator of Sil'dih\" }\r\n8319.8 \"--sync--\" #Ability { id: \"77BF\", source: \"Gladiator of Sil'dih\" }\r\n8321.8 \"Ring of Might (in)\" #Ability { id: [\"7642\", \"7643\", \"7644\"], source: \"Gladiator of Sil'dih\" }\r\n\r\n### Shadowcaster Zeless Gah\r\n# -p 74AE:9015.6\r\n# -ii 7498 7497 74\r\n\r\n# Eternal Ease will be sealed off\r\n9000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"106E\" } window 100000,0\r\n9010.6 \"--sync--\" StartsUsing { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" } window 20,20\r\n9015.6 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Path 05\r\n9019.7 \"--sync--\" StartsUsing { id: \"74A2\", source: \"Shadowcaster Zeless Gah\" } window 20,20 jump 10019.7\r\n9023.7 \"Infern Gale?\" #Ability { id: \"74A2\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n# -> Path 06\r\n9023.8 \"--sync--\" StartsUsing { id: \"7491\", source: \"Shadowcaster Zeless Gah\" } window 20,20 jump 11023.8\r\n9027.8 \"Infern Brand?\" #Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n# -> Path 07\r\n9019.7 \"--sync--\" StartsUsing { id: \"74A7\", source: \"Shadowcaster Zeless Gah\" } window 20,20 jump 12019.7\r\n9023.7 \"Infern Well?\" #Ability { id: \"74A7\", source: \"Shadowcaster Zeless Gah\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n### Path 05\r\n# Note: this could be combined with Path 07 with knockback/draw-in replacements\r\n# Eternal Ease will be sealed off\r\n10000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"106E\" }\r\n10010.6 \"--sync--\" StartsUsing { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" } window 20,20\r\n10015.6 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" }\r\n10019.7 \"--sync--\" StartsUsing { id: \"74A2\", source: \"Shadowcaster Zeless Gah\" }\r\n10023.7 \"Infern Gale\" Ability { id: \"74A2\", source: \"Shadowcaster Zeless Gah\" }\r\n10024.5 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n10030.1 \"--knockback--\" Ability { id: \"74A3\", source: \"Infern Brand\" }\r\n# 4 static fireballs\r\n10041.0 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n10052.3 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n10060.2 \"Firesteel Fracture\" Ability { id: \"74AC\", source: \"Shadowcaster Zeless Gah\" }\r\n# 4 fireballs with teleporters\r\n10068.3 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n10077.5 \"Cryptic Portal\" Ability { id: \"7492\", source: \"Shadowcaster Zeless Gah\" }\r\n10082.0 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n10085.6 \"Infern Gale\" Ability { id: \"74A2\", source: \"Shadowcaster Zeless Gah\" }\r\n10086.4 \"--sync--\" Ability { id: \"7495\", source: \"Infern Brand\" }\r\n10092.0 \"--knockback--\" Ability { id: \"74A3\", source: \"Infern Brand\" }\r\n# 4 staggered lasers\r\n10102.9 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n10111.1 \"Infern Ward\" Ability { id: \"7496\", source: \"Shadowcaster Zeless Gah\" }\r\n10111.9 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n10120.3 \"--sync--\" Ability { id: \"749F\", source: \"Shadowcaster Zeless Gah\" }\r\n10124.1 \"Pure Fire\" Ability { id: \"74A0\", source: \"Shadowcaster Zeless Gah\" }\r\n10126.5 \"--sync--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n10133.6 \"--sync--\" Ability { id: \"749A\", source: \"Shadowcaster Zeless Gah\" }\r\n10134.3 \"Cast Shadow 1\" Ability { id: \"749B\", source: \"Shadowcaster Zeless Gah\" }\r\n10136.3 \"Cast Shadow 2\" Ability { id: \"749D\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n10141.9 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" }\r\n# 2 static + 2 rotating fireballs\r\n10154.1 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n10166.3 \"Cryptic Portal\" Ability { id: \"7493\", source: \"Shadowcaster Zeless Gah\" }\r\n10170.8 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n10175.6 \"Firesteel Fracture\" Ability { id: \"74AC\", source: \"Shadowcaster Zeless Gah\" }\r\n# 4 vertical/horizontal lasers\r\n10187.7 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n10190.9 \"--sync--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n10196.1 \"Infern Ward\" Ability { id: \"7496\", source: \"Shadowcaster Zeless Gah\" }\r\n10196.9 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n10203.3 \"--sync--\" Ability { id: \"749F\", source: \"Shadowcaster Zeless Gah\" }\r\n10207.1 \"Pure Fire\" Ability { id: \"74A0\", source: \"Shadowcaster Zeless Gah\" }\r\n10213.5 \"Infern Gale\" Ability { id: \"74A2\", source: \"Shadowcaster Zeless Gah\" }\r\n10214.3 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n10217.7 \"--sync--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n10219.9 \"--knockback--\" Ability { id: \"74A3\", source: \"Infern Brand\" }\r\n10224.8 \"--sync--\" Ability { id: \"749A\", source: \"Shadowcaster Zeless Gah\" }\r\n10225.5 \"Cast Shadow 1\" Ability { id: \"749B\", source: \"Shadowcaster Zeless Gah\" }\r\n10227.5 \"Cast Shadow 2\" Ability { id: \"749D\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n10233.2 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" }\r\n# 4 fireballs with teleporters + knockback\r\n10245.4 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n10252.5 \"Infern Gale\" Ability { id: \"74A2\", source: \"Shadowcaster Zeless Gah\" }\r\n10253.3 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n10258.8 \"--knockback--\" Ability { id: \"74A3\", source: \"Infern Brand\" }\r\n10260.6 \"Cryptic Portal\" Ability { id: \"7492\", source: \"Shadowcaster Zeless Gah\" }\r\n10265.1 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n10269.9 \"Firesteel Fracture\" Ability { id: \"74AC\", source: \"Shadowcaster Zeless Gah\" }\r\n# 2 static + 2 rotating fireballs\r\n10278.0 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n10290.2 \"Cryptic Portal\" Ability { id: \"7493\", source: \"Shadowcaster Zeless Gah\" }\r\n10294.7 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n\r\n10299.3 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" }\r\n# 4 vertical/horizontal lasers\r\n10311.5 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n10314.7 \"--sync--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n10320.1 \"Infern Ward\" Ability { id: \"7496\", source: \"Shadowcaster Zeless Gah\" }\r\n10320.9 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n10327.2 \"--sync--\" Ability { id: \"749F\", source: \"Shadowcaster Zeless Gah\" }\r\n10331.0 \"Pure Fire\" Ability { id: \"74A0\", source: \"Shadowcaster Zeless Gah\" }\r\n10337.4 \"Infern Gale\" Ability { id: \"74A2\", source: \"Shadowcaster Zeless Gah\" }\r\n10338.2 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n10341.6 \"--sync--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n10343.8 \"--knockback--\" Ability { id: \"74A3\", source: \"Infern Brand\" }\r\n10348.6 \"--sync--\" Ability { id: \"749A\", source: \"Shadowcaster Zeless Gah\" }\r\n10349.3 \"Cast Shadow 1\" Ability { id: \"749B\", source: \"Shadowcaster Zeless Gah\" }\r\n10351.3 \"Cast Shadow 2\" Ability { id: \"749D\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n10357.0 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" } window 30,30 jump 10233.2\r\n10369.2 \"Infern Brand\" #Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n10376.3 \"Infern Gale\" #Ability { id: \"74A2\", source: \"Shadowcaster Zeless Gah\" }\r\n10377.1 \"--sync--\" #Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n### Path 06\r\n# Eternal Ease will be sealed off\r\n11000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"106E\" }\r\n11010.6 \"--sync--\" StartsUsing { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" } window 20,20\r\n11015.6 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" }\r\n# 2 static portals\r\n11023.8 \"--sync--\" StartsUsing { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n11027.8 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n11039.1 \"Blazing Benifice\" Ability { id: \"74A5\", source: \"Arcane Font\" }\r\n11047.0 \"Firesteel Fracture\" Ability { id: \"74AC\", source: \"Shadowcaster Zeless Gah\" }\r\n# 4 static fireballs\r\n11055.1 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n11066.5 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n# 3 portals with teleporters\r\n11078.4 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n11087.6 \"Cryptic Portal\" Ability { id: \"7492\", source: \"Shadowcaster Zeless Gah\" }\r\n11092.1 \"Blazing Benifice\" Ability { id: \"74A5\", source: \"Arcane Font\" }\r\n\r\n11097.7 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" }\r\n# 4 fireballs with teleporters\r\n11105.9 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n11115.1 \"Cryptic Portal\" Ability { id: \"7492\", source: \"Shadowcaster Zeless Gah\" }\r\n11119.6 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n# 4 staggered lasers\r\n11128.3 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n11136.4 \"Infern Ward\" Ability { id: \"7496\", source: \"Shadowcaster Zeless Gah\" }\r\n11137.2 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n11145.5 \"--sync--\" Ability { id: \"749F\", source: \"Shadowcaster Zeless Gah\" }\r\n11149.3 \"Pure Fire\" Ability { id: \"74A0\", source: \"Shadowcaster Zeless Gah\" }\r\n# 4 static fireballs\r\n11157.7 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n11169.0 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n# 3 portals with teleporters\r\n11177.8 \"Cryptic Portal\" Ability { id: \"7492\", source: \"Shadowcaster Zeless Gah\" }\r\n11182.3 \"Blazing Benifice\" Ability { id: \"74A5\", source: \"Arcane Font\" }\r\n11189.0 \"Firesteel Fracture\" Ability { id: \"74AC\", source: \"Shadowcaster Zeless Gah\" }\r\n11193.2 \"--sync--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n11200.3 \"--sync--\" Ability { id: \"749A\", source: \"Shadowcaster Zeless Gah\" }\r\n11201.0 \"Cast Shadow 1\" Ability { id: \"749B\", source: \"Shadowcaster Zeless Gah\" }\r\n11203.0 \"Cast Shadow 2\" Ability { id: \"749D\", source: \"Shadowcaster Zeless Gah\" }\r\n# 4 vertical/horizontal lasers\r\n11213.7 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" }\r\n11225.9 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n11229.1 \"--sync--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n11234.4 \"Infern Ward\" Ability { id: \"7496\", source: \"Shadowcaster Zeless Gah\" }\r\n11235.2 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n11241.6 \"--sync--\" Ability { id: \"749F\", source: \"Shadowcaster Zeless Gah\" }\r\n11245.4 \"Pure Fire\" Ability { id: \"74A0\", source: \"Shadowcaster Zeless Gah\" }\r\n11249.6 \"--sync--\" Ability { id: \"749A\", source: \"Shadowcaster Zeless Gah\" }\r\n11250.3 \"Cast Shadow 1\" Ability { id: \"749B\", source: \"Shadowcaster Zeless Gah\" }\r\n11252.3 \"Cast Shadow 2\" Ability { id: \"749D\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n11258.0 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" }\r\n# 2 static portals + 4 fireballs with teleporters\r\n11270.2 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n11281.5 \"Blazing Benifice\" Ability { id: \"74A5\", source: \"Arcane Font\" }\r\n11282.3 \"Cryptic Portal\" Ability { id: \"7492\", source: \"Shadowcaster Zeless Gah\" }\r\n11286.8 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n11293.5 \"Firesteel Fracture\" Ability { id: \"74AC\", source: \"Shadowcaster Zeless Gah\" }\r\n# 4 static fireballs\r\n11301.6 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n11312.9 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n# 3 portals with teleporters\r\n11321.7 \"Cryptic Portal\" Ability { id: \"7492\", source: \"Shadowcaster Zeless Gah\" }\r\n11326.2 \"Blazing Benifice\" Ability { id: \"74A5\", source: \"Arcane Font\" }\r\n\r\n11332.8 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" }\r\n11345.0 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n11348.2 \"--sync--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n11353.4 \"Infern Ward\" Ability { id: \"7496\", source: \"Shadowcaster Zeless Gah\" }\r\n11354.2 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n11360.5 \"--sync--\" Ability { id: \"749F\", source: \"Shadowcaster Zeless Gah\" }\r\n11364.3 \"Pure Fire\" Ability { id: \"74A0\", source: \"Shadowcaster Zeless Gah\" }\r\n11368.4 \"--sync--\" Ability { id: \"749A\", source: \"Shadowcaster Zeless Gah\" }\r\n11369.1 \"Cast Shadow 1\" Ability { id: \"749B\", source: \"Shadowcaster Zeless Gah\" }\r\n11371.1 \"Cast Shadow 2\" Ability { id: \"749D\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n11376.7 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" } window 30,30 jump 11258\r\n# 2 static portals + 4 fireballs with teleporters\r\n11388.9 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n11400.2 \"Blazing Benifice\" Ability { id: \"74A5\", source: \"Arcane Font\" }\r\n11401.0 \"Cryptic Portal\" Ability { id: \"7492\", source: \"Shadowcaster Zeless Gah\" }\r\n11405.5 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n11412.2 \"Firesteel Fracture\" Ability { id: \"74AC\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n\r\n### Path 07\r\n# Note: this could be combined with Path 05 with knockback/draw-in replacements\r\n# Eternal Ease will be sealed off\r\n12000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"106E\" }\r\n12010.6 \"--sync--\" StartsUsing { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" } window 20,20\r\n12015.6 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" }\r\n12019.7 \"--sync--\" StartsUsing { id: \"74A7\", source: \"Shadowcaster Zeless Gah\" }\r\n12023.7 \"Infern Well\" Ability { id: \"74A7\", source: \"Shadowcaster Zeless Gah\" }\r\n12024.6 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n12032.2 \"--sync--\" Ability { id: \"74A8\", source: \"Infern Brand\" }\r\n12033.7 \"--draw in--\" Ability { id: \"74AA\", source: \"Infern Brand\" }\r\n# 4 static fireballs\r\n12043.1 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n12054.5 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n12062.5 \"Firesteel Fracture\" Ability { id: \"74AC\", source: \"Shadowcaster Zeless Gah\" }\r\n# 4 fireballs with teleporters\r\n12070.6 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n12079.8 \"Cryptic Portal\" Ability { id: \"7492\", source: \"Shadowcaster Zeless Gah\" }\r\n12084.3 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n12087.9 \"Infern Well\" Ability { id: \"74A7\", source: \"Shadowcaster Zeless Gah\" }\r\n12088.7 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n12096.2 \"--sync--\" Ability { id: \"74A8\", source: \"Infern Brand\" }\r\n12097.7 \"--draw in--\" Ability { id: \"74AA\", source: \"Infern Brand\" }\r\n# 4 staggered lasers\r\n12107.1 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n12115.2 \"Infern Ward\" Ability { id: \"7496\", source: \"Shadowcaster Zeless Gah\" }\r\n12116.0 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n12124.4 \"--sync--\" Ability { id: \"749F\", source: \"Shadowcaster Zeless Gah\" }\r\n12128.2 \"Pure Fire\" Ability { id: \"74A0\", source: \"Shadowcaster Zeless Gah\" }\r\n12130.6 \"--sync--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n12137.8 \"--sync--\" Ability { id: \"749A\", source: \"Shadowcaster Zeless Gah\" }\r\n12138.5 \"Cast Shadow 1\" Ability { id: \"749B\", source: \"Shadowcaster Zeless Gah\" }\r\n12140.5 \"Cast Shadow 2\" Ability { id: \"749D\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n12146.1 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" }\r\n# 2 static + 2 rotating fireballs\r\n12158.3 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n12170.5 \"Cryptic Portal\" Ability { id: \"7493\", source: \"Shadowcaster Zeless Gah\" }\r\n12175.0 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n12179.7 \"Firesteel Fracture\" Ability { id: \"74AC\", source: \"Shadowcaster Zeless Gah\" }\r\n# 4 vertical/horizontal lasers\r\n12191.9 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n12195.0 \"--sync--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n12200.4 \"Infern Ward\" Ability { id: \"7496\", source: \"Shadowcaster Zeless Gah\" }\r\n12201.2 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n12207.5 \"--sync--\" Ability { id: \"749F\", source: \"Shadowcaster Zeless Gah\" }\r\n12211.3 \"Pure Fire\" Ability { id: \"74A0\", source: \"Shadowcaster Zeless Gah\" }\r\n12217.7 \"Infern Well\" Ability { id: \"74A7\", source: \"Shadowcaster Zeless Gah\" }\r\n12218.5 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n12223.9 \"--sync--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n12226.1 \"--sync--\" Ability { id: \"74A8\", source: \"Infern Brand\" }\r\n12227.6 \"--draw in--\" Ability { id: \"74AA\", source: \"Infern Brand\" }\r\n12231.1 \"--sync--\" Ability { id: \"749A\", source: \"Shadowcaster Zeless Gah\" }\r\n12231.8 \"Cast Shadow 1\" Ability { id: \"749B\", source: \"Shadowcaster Zeless Gah\" }\r\n12233.8 \"Cast Shadow 2\" Ability { id: \"749D\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n12239.4 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" }\r\n# 4 fireballs with teleporters + draw in\r\n12251.6 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n12258.7 \"Infern Well\" Ability { id: \"74A7\", source: \"Shadowcaster Zeless Gah\" }\r\n12259.5 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n12267.1 \"--sync--\" Ability { id: \"74A8\", source: \"Infern Brand\" }\r\n12268.6 \"--draw in--\" Ability { id: \"74AA\", source: \"Infern Brand\" }\r\n12268.9 \"Cryptic Portal\" Ability { id: \"7492\", source: \"Shadowcaster Zeless Gah\" }\r\n12273.4 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n12278.2 \"Firesteel Fracture\" Ability { id: \"74AC\", source: \"Shadowcaster Zeless Gah\" }\r\n# 2 static + 2 rotating fireballs\r\n12286.3 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n12298.5 \"Cryptic Portal\" Ability { id: \"7493\", source: \"Shadowcaster Zeless Gah\" }\r\n12303.0 \"Burn\" Ability { id: \"748F\", source: \"Ball of Fire\" }\r\n\r\n12307.6 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" }\r\n# 4 vertical/horizontal lasers\r\n12319.8 \"Infern Brand\" Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n12322.9 \"--sync--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n12328.1 \"Infern Ward\" Ability { id: \"7496\", source: \"Shadowcaster Zeless Gah\" }\r\n12328.9 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n12335.2 \"--sync--\" Ability { id: \"749F\", source: \"Shadowcaster Zeless Gah\" }\r\n12339.0 \"Pure Fire\" Ability { id: \"74A0\", source: \"Shadowcaster Zeless Gah\" }\r\n12345.4 \"Infern Well\" Ability { id: \"74A7\", source: \"Shadowcaster Zeless Gah\" }\r\n12346.2 \"--sync--\" Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n12351.6 \"--sync--\" Ability { id: \"74BE\", source: \"Shadowcaster Zeless Gah\" }\r\n12353.8 \"--sync--\" Ability { id: \"74A8\", source: \"Infern Brand\" }\r\n12355.3 \"Infern Well\" Ability { id: \"74AA\", source: \"Infern Brand\" }\r\n12358.8 \"--sync--\" Ability { id: \"749A\", source: \"Shadowcaster Zeless Gah\" }\r\n12359.5 \"Cast Shadow 1\" Ability { id: \"749B\", source: \"Shadowcaster Zeless Gah\" }\r\n12361.5 \"Cast Shadow 2\" Ability { id: \"749D\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n12367.1 \"Show of Strength\" Ability { id: \"74AE\", source: \"Shadowcaster Zeless Gah\" } window 30,30 jump 12239.4\r\n# 4 fireballs with teleporters + draw in\r\n12379.3 \"Infern Brand\" #Ability { id: \"7491\", source: \"Shadowcaster Zeless Gah\" }\r\n12386.4 \"Infern Well\" #Ability { id: \"74A7\", source: \"Shadowcaster Zeless Gah\" }\r\n12387.2 \"--sync--\" #Ability { id: \"7495\", source: \"Shadowcaster Zeless Gah\" }\r\n\r\n\r\n### Thorne Knight\r\n# -p 70EB:13016.8\r\n# -ii 70F9 70FA 7100 7101 70FE 70FF\r\n\r\n# Note: Slashburn is 70EF, 70F0, 70F1, 70F2\r\n# It's possible that 70EF/7102 are \"normal\" and 70F0/70F1 are reversed.\r\n\r\n# Cold Arms' Quietus will be sealed off\r\n13000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"1076\" } window 100000,0\r\n13011.8 \"--sync--\" StartsUsing { id: \"70EB\", source: \"Thorne Knight\" }\r\n13016.8 \"Cogwheel\" Ability { id: \"70EB\", source: \"Thorne Knight\" }\r\n13030.3 \"Spring to Life\" Ability { id: [\"70ED\", \"70EE\"], source: \"Thorne Knight\" }\r\n13031.1 \"--sync--\" Ability { id: \"7126\", source: \"Magicked Puppet\" }\r\n13034.1 \"Magic Cannon\" Ability { id: \"70F7\", source: \"Magicked Puppet\" }\r\n13034.7 \"Amalj'aa Artillery\" Ability { id: \"70F8\", source: \"Amalj'aa Artillery Carriage\" }\r\n13037.1 \"--sync--\" Ability { id: \"7127\", source: \"Magicked Puppet\" }\r\n13052.5 \"Blistering Blow\" Ability { id: \"70EA\", source: \"Thorne Knight\" }\r\n13064.6 \"Spring to Life\" Ability { id: [\"70ED\", \"70EE\"], source: \"Thorne Knight\" }\r\n13065.4 \"--sync--\" Ability { id: \"7126\", source: \"Magicked Puppet\" }\r\n13068.4 \"Magic Cannon\" Ability { id: \"70F7\", source: \"Magicked Puppet\" }\r\n13069.1 \"Amalj'aa Artillery\" Ability { id: \"70F8\", source: \"Amalj'aa Artillery Carriage\" }\r\n13071.5 \"--sync--\" Ability { id: \"7127\", source: \"Magicked Puppet\" }\r\n13075.1 \"Fore Honor\" Ability { id: \"70EC\", source: \"Thorne Knight\" }\r\n13090.8 \"Slashburn\" Ability { id: [\"70EF\", \"70F0\", \"70F1\", \"7102\"], source: \"Thorne Knight\" }\r\n13103.5 \"--sync--\" Ability { id: \"70F5\", source: \"Thorne Knight\" }\r\n\r\n13105.0 \"Signal Flare 1\" #Ability { id: \"70FB\", source: \"Thorne Knight\" }\r\n13106.6 \"Signal Flare 2\" #Ability { id: \"70FB\", source: \"Thorne Knight\" }\r\n13108.2 \"Signal Flare 3\" #Ability { id: \"70FB\", source: \"Thorne Knight\" }\r\n13114.1 \"Blistering Blow\" Ability { id: \"70EA\", source: \"Thorne Knight\" }\r\n13131.1 \"Slashburn\" Ability { id: [\"70EF\", \"70F0\", \"70F1\", \"7102\"], source: \"Thorne Knight\" }\r\n13142.7 \"Blaze of Glory\" Ability { id: \"70F4\", source: \"Thorne Knight\" }\r\n13152.6 \"Spring to Life\" Ability { id: [\"70ED\", \"70EE\"], source: \"Thorne Knight\" }\r\n13153.4 \"--sync--\" Ability { id: \"7126\", source: \"Magicked Puppet\" }\r\n13156.3 \"Magic Cannon\" Ability { id: \"70F7\", source: \"Magicked Puppet\" }\r\n13157.0 \"Amalj'aa Artillery\" Ability { id: \"70F8\", source: \"Amalj'aa Artillery Carriage\" }\r\n13157.0 \"Explosion\" Ability { id: \"70FD\", source: \"Ball of Fire\" }\r\n13159.4 \"--sync--\" Ability { id: \"7127\", source: \"Magicked Puppet\" }\r\n13169.2 \"Slashburn\" Ability { id: [\"70EF\", \"70F0\", \"70F1\", \"7102\"], source: \"Thorne Knight\" }\r\n13178.7 \"Blaze of Glory\" Ability { id: \"70F4\", source: \"Thorne Knight\" }\r\n13193.1 \"Explosion\" Ability { id: \"70FD\", source: \"Ball of Fire\" }\r\n13193.1 \"Slashburn\" Ability { id: [\"70EF\", \"70F0\", \"70F1\", \"7102\"], source: \"Thorne Knight\" }\r\n13205.7 \"--sync--\" Ability { id: \"70F5\", source: \"Thorne Knight\" }\r\n13207.3 \"Signal Flare 1\" #Ability { id: \"70FB\", source: \"Thorne Knight\" }\r\n13208.9 \"Signal Flare 2\" #Ability { id: \"70FB\", source: \"Thorne Knight\" }\r\n13210.4 \"Signal Flare 3\" #Ability { id: \"70FB\", source: \"Thorne Knight\" }\r\n13214.3 \"Fore Honor\" Ability { id: \"70EC\", source: \"Thorne Knight\" }\r\n\r\n13221.4 \"Cogwheel\" Ability { id: \"70EB\", source: \"Thorne Knight\" }\r\n13234.1 \"Blaze of Glory\" Ability { id: \"70F4\", source: \"Thorne Knight\" }\r\n13244.1 \"Spring to Life\" Ability { id: [\"70ED\", \"70EE\"], source: \"Thorne Knight\" }\r\n13244.9 \"--sync--\" Ability { id: \"7126\", source: \"Magicked Puppet\" }\r\n13247.9 \"Magic Cannon\" Ability { id: \"70F7\", source: \"Magicked Puppet\" }\r\n13248.5 \"Amalj'aa Artillery\" Ability { id: \"70F8\", source: \"Amalj'aa Artillery Carriage\" }\r\n13248.5 \"Explosion\" Ability { id: \"70FD\", source: \"Ball of Fire\" }\r\n13250.9 \"--sync--\" Ability { id: \"7127\", source: \"Magicked Puppet\" }\r\n\r\n13253.2 \"Cogwheel\" Ability { id: \"70EB\", source: \"Thorne Knight\" }\r\n13265.8 \"Blaze of Glory\" Ability { id: \"70F4\", source: \"Thorne Knight\" }\r\n13280.3 \"Slashburn\" Ability { id: [\"70EF\", \"70F0\", \"70F1\", \"7102\"], source: \"Thorne Knight\" }\r\n13280.3 \"Explosion\" Ability { id: \"70FD\", source: \"Ball of Fire\" }\r\n13293.0 \"--sync--\" Ability { id: \"70F5\", source: \"Thorne Knight\" }\r\n13294.6 \"Signal Flare 1\" #Ability { id: \"70FB\", source: \"Thorne Knight\" }\r\n13296.2 \"Signal Flare 2\" #Ability { id: \"70FB\", source: \"Thorne Knight\" }\r\n13297.7 \"Signal Flare 3\" #Ability { id: \"70FB\", source: \"Thorne Knight\" }\r\n13301.6 \"Fore Honor\" Ability { id: \"70EC\", source: \"Thorne Knight\" }\r\n\r\n13308.8 \"Cogwheel\" Ability { id: \"70EB\", source: \"Thorne Knight\" } window 40,40 jump 13221.4\r\n13321.5 \"Blaze of Glory\" #Ability { id: \"70F4\", source: \"Thorne Knight\" }\r\n13331.5 \"Spring to Life\" #Ability { id: [\"70ED\", \"70EE\"], source: \"Thorne Knight\" }\r\n13332.3 \"--sync--\" #Ability { id: \"7126\", source: \"Magicked Puppet\" }\r\n13335.3 \"Magic Cannon\" #Ability { id: \"70F7\", source: \"Magicked Puppet\" }\r\n13335.9 \"Amalj'aa Artillery\" #Ability { id: \"70F8\", source: \"Amalj'aa Artillery Carriage\" }\r\n13335.9 \"Explosion\" #Ability { id: \"70FD\", source: \"Ball of Fire\" }\r\n13338.3 \"--sync--\" #Ability { id: \"7127\", source: \"Magicked Puppet\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/the_tower_of_babil.ts



// TODO: Figure out a clean way to call the Charnel Claw dashes?
const the_tower_of_babil_triggerSet = {
  id: 'TheTowerOfBabil',
  zoneId: zone_id/* default.TheTowerOfBabil */.Z.TheTowerOfBabil,
  timelineFile: 'the_tower_of_babil.txt',
  triggers: [{
    id: 'Tower Of Babil Ground And Pound',
    type: 'StartsUsing',
    netRegex: {
      id: ['6247', '62EA'],
      source: 'Barnabas',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    // 00A3 is negative, 00A2 is positive
    // Used for both Dynamic Scrapline and Dynamic Pound
    // Because of this, we have to collect the player every time,
    // rather than using the player head marker as a trigger log line.
    id: 'Tower Of Babil Dynamic Player Collect',
    type: 'HeadMarker',
    netRegex: {
      id: ['00A2', '00A3']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => data.playerNegative = matches.id === '00A3'
  }, {
    // 0122 is negative, 0123 is positive.
    id: 'Tower Of Babil Dynamic Scrapline Barnabas Collect',
    type: 'HeadMarker',
    netRegex: {
      id: ['0122', '0123'],
      target: 'Barnabas'
    },
    run: (data, matches) => data.barnabasNegative = matches.id === '0122'
  }, {
    id: 'Tower Of Babil Dynamic Scrapline',
    type: 'StartsUsing',
    netRegex: {
      id: ['6246', '62F0'],
      source: 'Barnabas',
      capture: false
    },
    delaySeconds: 0.5,
    // Ensure we have markers stored.
    infoText: (data, _matches, output) => {
      if ([data.barnabasNegative, data.playerNegative].includes(undefined)) return; // Somehow we don't have data? Don't risk calling it wrongly.
      if (data.playerNegative === data.barnabasNegative) return output.close();
      return output.far();
    },
    run: data => {
      data.barnabasNegative = undefined;
      data.playerNegative = undefined;
    },
    outputStrings: {
      close: {
        en: 'Close to boss',
        de: 'Nahe am Boss',
        fr: 'Allez près du boss',
        ja: 'ボスに近づく',
        cn: '靠近boss',
        ko: '보스 가까이 붙기'
      },
      far: {
        en: 'Away from boss',
        de: 'Weg am Boss',
        fr: 'Éloignez-vous du boss',
        ja: 'ボスから離れる',
        cn: '远离boss',
        ko: '보스에게서 멀어지기'
      }
    }
  }, {
    // 6245 is negative, 62EE is positive.
    id: 'Tower Of Babil Dynamic Pound Collect',
    type: 'StartsUsing',
    netRegex: {
      id: ['6245', '62EE'],
      source: 'Barnabas'
    },
    run: (data, matches) => data.barnabasNegative = matches.id === '6245'
  }, {
    id: 'Tower Of Babil Dynamic Pound',
    type: 'StartsUsing',
    netRegex: {
      id: ['6245', '62EE'],
      source: 'Barnabas',
      capture: false
    },
    delaySeconds: 0.5,
    // Ensure we have markers stored.
    infoText: (data, _matches, output) => {
      if ([data.barnabasNegative, data.playerNegative].includes(undefined)) return; // Somehow we don't have data? Don't risk calling it wrongly.
      if (data.playerNegative === data.barnabasNegative) return output.close();
      return output.far();
    },
    run: data => {
      data.barnabasNegative = undefined;
      data.playerNegative = undefined;
    },
    outputStrings: {
      close: {
        en: 'Go center next to Scrapline',
        de: 'Geh zur mitte, nahe der Rollschlinge',
        fr: 'Allez au centre, près de la zone de frappe',
        ja: 'ゆかの中央の横へ',
        cn: '去中间，靠近AOE',
        ko: '장판 중앙부분 옆으로'
      },
      far: {
        en: 'Go sides away from Scrapline',
        de: 'Geh seidlich der Rollschlinge',
        fr: 'Allez sur les côtes, loin de la zone de frappe',
        ja: 'ゆかから離れる',
        cn: '去场边，远离AOE',
        ko: '장판과 멀리 떨어지기'
      }
    }
  }, {
    id: 'Tower Of Babil Rolling Scrapline',
    type: 'StartsUsing',
    netRegex: {
      id: '62EB',
      source: 'Barnabas',
      capture: false
    },
    response: responses/* Responses.outOfMelee */.n3.outOfMelee()
  }, {
    id: 'Tower Of Babil Shocking Force',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Tower Of Babil Magitek Chakram',
    type: 'Ability',
    netRegex: {
      id: '62F3',
      source: 'Lugae',
      capture: false
    },
    suppressSeconds: 10,
    infoText: (_data, _matches, outputs) => outputs.text(),
    outputStrings: {
      text: {
        en: 'Purple pad to shrink',
        de: 'Lilane Fläche zum schrumpfen',
        fr: 'Zone violette pour rétrécir',
        ja: '紫',
        cn: '踩紫色地板',
        ko: '보라색 바닥 밟고 작아지기'
      }
    }
  }, {
    id: 'Tower Of Babil Downpour',
    type: 'Ability',
    netRegex: {
      id: '62F5',
      source: 'Lugae',
      capture: false
    },
    infoText: (_data, _matches, outputs) => outputs.text(),
    outputStrings: {
      text: {
        en: 'Green pad for frog',
        de: 'Grüne Fläsche für Frosch',
        fr: 'Zone verte pour transormation en grenouille',
        ja: '緑',
        cn: '踩绿色地板',
        ko: '초록색 바닥 밟고 개구리 되기'
      }
    }
  }, {
    id: 'Tower Of Babil Thermal Suppression',
    type: 'StartsUsing',
    netRegex: {
      id: '62FA',
      source: 'Lugae',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Tower Of Babil Magitek Explosive',
    type: 'Ability',
    netRegex: {
      id: '62F8',
      source: 'Lugae',
      capture: false
    },
    infoText: (_data, _matches, outputs) => outputs.text(),
    outputStrings: {
      text: {
        en: 'Avoid bomb lines',
        de: 'Weiche den Bombenlinien aus',
        fr: 'Évitez la ligne de bombes',
        ja: '爆弾からの直線爆発回避',
        cn: '躲开炸弹十字AOE',
        ko: '폭탄의 직선범위 피하기'
      }
    }
  }, {
    // TODO: Math the positions of the corner nails and give an exact call.
    // Locations are (-19.50, -160), (-19.50, -199), (19.50, -160), (19.50, -199)
    id: 'Tower Of Babil Lunar Nail Warning',
    type: 'Ability',
    netRegex: {
      id: '62FE',
      source: 'Anima',
      capture: false
    },
    infoText: (_data, _matches, outputs) => outputs.text(),
    outputStrings: {
      text: {
        en: 'Go to safe quadrant',
        de: 'Geh in das sichere Feld',
        fr: 'Allez dans le quart safe',
        ja: '4分の安置へ',
        cn: '去安全角落',
        ko: '안전한 사분면으로'
      }
    }
  }, {
    id: 'Tower Of Babil Mega Graviton',
    type: 'StartsUsing',
    netRegex: {
      id: '6300',
      source: 'Anima',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // TODO: Math the Graviton locations so we can call a safe direction.
    id: 'Tower Of Babil Aetherial Pull',
    type: 'StartsUsing',
    netRegex: {
      id: '6301',
      source: 'Mega-graviton'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, outputs) => outputs.text(),
    outputStrings: {
      text: {
        en: 'Away from your tether add',
        de: 'Weg von dem mit dir verbundenem Add',
        fr: 'Éloignez-vous de votre add lié',
        ja: '線を伸ばして遠く離れる',
        cn: '远离连线黑洞',
        ko: '선이 연결된 곳과 멀리 떨어지기'
      }
    }
  }, {
    id: 'Tower Of Babil Boundless Pain',
    type: 'Ability',
    netRegex: {
      id: '6303',
      source: 'Anima',
      capture: false
    },
    alertText: (_data, _matches, outputs) => outputs.text(),
    outputStrings: {
      text: {
        en: 'Get to a corner!',
        de: 'Geh in eine Ecke!',
        fr: 'Allez dans un coin !',
        ja: '隅へ',
        cn: '快去角落!',
        ko: '구석으로!'
      }
    }
  }, {
    id: 'Tower Of Babil Coffin Scratch',
    type: 'HeadMarker',
    netRegex: {
      id: '00C5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, outputs) => outputs.text(),
    outputStrings: {
      text: {
        en: '5x chasing puddles on you!',
        de: '5x verfolgende Flächen auf dir!',
        fr: '5x zones au sol chainées sur vous !',
        ja: '5連続AOE回避',
        cn: '5连追踪AOE点名!',
        ko: '따라오는 5연속 장판 피하기!'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Anima': 'Anima',
      'Barnabas': 'Barnabas',
      'Iron Nail': 'Animas Bosheit',
      'Iron Womb': 'Eiserner Wanst',
      'Lugae': 'Lugae',
      'Magitek Chakram': 'Magitek-Chakram',
      'Magitek Explosive': 'Magiebombe',
      'Magitek Servicing': 'Magitek-Wartungsdepot',
      'Martial Conditioning': 'Kampfhalle',
      'Mega-graviton': 'Mega-Graviton',
      'Thunderball': 'Donnerkugel'
    },
    'replaceText': {
      'Aetherial Pull': 'Seidige Finger',
      'Boundless Pain': 'Grenzenloser Schmerz',
      'Charnel Claw': 'Laserklaue',
      'Coffin Scratch': 'Flüchtiges Scharren',
      'Downpour': 'Flutschwall',
      'Dynamic Pound': 'Elektromagnetische Erderschütterung',
      'Dynamic Scrapline': 'Elektromagnetische Rollschlinge',
      'Electromagnetic Release': 'Elektromagnetische Entladung',
      'Erupting Pain': 'Schmerzeruption',
      'Explosion': 'Explosion',
      'Graviton Spark': 'Gravitonfunke',
      'Ground and Pound': 'Erderschütterung',
      'Imperatum': 'Imperator',
      'Lunar Nail': 'Dunkle Fessel',
      'Magitek Chakram': 'Magitek-Chakram',
      'Magitek Explosive': 'Magiebombe',
      'Magitek Missile': 'Magitek-Rakete',
      'Magitek Ray': 'Magitek-Laser',
      'Mega Graviton': 'Mega-Graviton',
      'Mighty Blow': 'Säulendurchschlag',
      'Obliviating Claw': 'Klaue des Vergessens',
      'Oblivion': 'Chaosdimension',
      'Pater Patriae': 'Pater patriae',
      'Phantom Pain': 'Phantomschmerz',
      'Rolling Scrapline': 'Rollschlinge',
      'Shock(?!ing)': 'Entladung',
      'Shocking Force': 'Starkstromentladung',
      'Surface Missile': 'Raketenschlag',
      'Thermal Suppression': 'Massiver Beschuss',
      'Thundercall': 'Donnerruf'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Anima': 'Anima',
      'Barnabas': 'Barnabas',
      'Iron Nail': 'griffe d\'Anima',
      'Iron Womb': 'Cœur de Fer',
      'Lugae': 'Lugae',
      'Magitek Chakram': 'Chakram magitek',
      'Magitek Explosive': 'Bombe magitek',
      'Magitek Servicing': 'Entrepôt de maintenance magitek',
      'Martial Conditioning': 'Hall d\'entraînement',
      'Mega-graviton': 'méga graviton',
      'Thunderball': 'sphère de foudre'
    },
    'replaceText': {
      '\\?': ' ?',
      'Aetherial Pull': 'Aspiration',
      'Boundless Pain': 'Lamento',
      'Charnel Claw': 'Griffes nécrosantes',
      'Coffin Scratch': 'Griffes sépulcrales',
      'Downpour': 'Déluge',
      'Dynamic Pound': 'Frappe terrestre électromagnétique',
      'Dynamic Scrapline': 'Lariat tournoyant électromagnétique',
      'Electromagnetic Release': 'Décharge électromagnétique',
      'Erupting Pain': 'Éruption torturante',
      'Explosion': 'Explosion',
      'Graviton Spark': 'Étincelle graviton',
      'Ground and Pound': 'Frappe terrestre',
      'Imperatum': 'Imperator',
      'Lunar Nail': 'Pals grotesques',
      'Magitek Chakram': 'Chakram magitek',
      'Magitek Explosive': 'Bombe magitek',
      'Magitek Missile': 'Missiles magitek',
      'Magitek Ray': 'Rayon magitek',
      'Mega Graviton': 'Méga graviton',
      'Mighty Blow': 'Empalement',
      'Obliviating Claw': 'Griffes du néant',
      'Oblivion': 'Ruée chaotique',
      'Pater Patriae': 'Pater Patriae',
      'Phantom Pain': 'Supplice fantôme',
      'Rolling Scrapline': 'Lariat tournoyant',
      'Shock(?!ing)': 'Décharge électrostatique',
      'Shocking Force': 'Décharge à haute tension',
      'Surface Missile': 'Missiles sol-sol',
      'Thermal Suppression': 'Surcharge incendiaire',
      'Thundercall': 'Drain fulminant'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Anima': 'アニマ',
      'Barnabas': 'バルナバ',
      'Iron Nail': 'アニマの爪',
      'Iron Womb': '鉄の肚',
      'Lugae': 'ルゲイエ',
      'Magitek Chakram': '魔導チャクラム',
      'Magitek Explosive': '魔導爆弾',
      'Magitek Servicing': '魔導整備庫',
      'Martial Conditioning': '武術訓練ホール',
      'Mega-graviton': 'メガグラビトン',
      'Thunderball': 'サンダースフィア'
    },
    'replaceText': {
      'Aetherial Pull': '吸引',
      'Boundless Pain': 'バウンドレスペイン',
      'Charnel Claw': 'チャーネルクロウ',
      'Coffin Scratch': 'コフィンスクラッチ',
      'Downpour': '水責め',
      'Dynamic Pound': '超電磁グラウンドパンチ',
      'Dynamic Scrapline': '超電磁ローリングラリアット',
      'Electromagnetic Release': '電磁放射',
      'Erupting Pain': 'ペインエラプション',
      'Explosion': '爆発',
      'Graviton Spark': 'グラビトンスパーク',
      'Ground and Pound': 'グラウンドパンチ',
      'Imperatum': 'インペラトル',
      'Lunar Nail': '異形の楔',
      'Magitek Chakram': '魔導チャクラム',
      'Magitek Explosive': '魔導爆弾',
      'Magitek Missile': '魔導ミサイル',
      'Magitek Ray': '魔導レーザー',
      'Mega Graviton': 'メガグラビトン',
      'Mighty Blow': '激突',
      'Obliviating Claw': 'オブリビオンクロウ',
      'Oblivion': 'カオティック・ディメンション',
      'Pater Patriae': 'パテル・パトリアエ',
      'Phantom Pain': 'ファントムペイン',
      'Rolling Scrapline': 'ローリングラリアット',
      'Shock(?!ing)': '放電',
      'Shocking Force': '高電圧放電',
      'Surface Missile': '対地ミサイル',
      'Thermal Suppression': '火力制圧',
      'Thundercall': '招雷'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Anima': '阿尼玛',
      'Barnabas': '巴尔纳伯',
      'Iron Nail': '阿尼玛之爪',
      'Iron Womb': '铁腹',
      'Lugae': '卢格',
      'Magitek Chakram': '魔导轮',
      'Magitek Explosive': '魔导炸弹',
      'Magitek Servicing': '魔导整备库',
      'Martial Conditioning': '武术训练堂',
      'Mega-graviton': '百万重力',
      'Thunderball': '雷电球'
    },
    'replaceText': {
      'Aetherial Pull': '吸引',
      'Boundless Pain': '无际痛苦',
      'Charnel Claw': '阴森之爪',
      'Coffin Scratch': '棺椁抓击',
      'Downpour': '水刑',
      'Dynamic Pound': '超电磁地面重击',
      'Dynamic Scrapline': '超电磁回转碎颈臂',
      'Electromagnetic Release': '电磁放射',
      'Erupting Pain': '痛苦喷发',
      'Explosion': '爆炸',
      'Graviton Spark': '重力火花',
      'Ground and Pound': '地面重击',
      'Imperatum': '英白拉多',
      'Lunar Nail': '异形之楔',
      'Magitek Chakram': '魔导轮',
      'Magitek Explosive': '魔导炸弹',
      'Magitek Missile': '魔导飞弹',
      'Magitek Ray': '魔导激光',
      'Mega Graviton': '百万重力',
      'Mighty Blow': '激突',
      'Obliviating Claw': '忘却之爪',
      'Oblivion': '混沌次元',
      'Pater Patriae': '祖国之父',
      'Phantom Pain': '幻痛',
      'Rolling Scrapline': '回转碎颈臂',
      'Shock(?!ing)': '放电',
      'Shocking Force': '高压放电',
      'Surface Missile': '对地导弹',
      'Thermal Suppression': '火力压制',
      'Thundercall': '招雷'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Anima': '아니마',
      'Barnabas': '바르나바',
      'Iron Nail': '아니마의 발톱',
      'Iron Womb': '철의 태내',
      'Lugae': '루게이에',
      'Magitek Chakram': '마도 차크람',
      'Magitek Explosive': '마도 폭탄',
      'Magitek Servicing': '마도 정비고',
      'Martial Conditioning': '무술 훈련장',
      'Mega-graviton': '메가 그래비톤',
      'Thunderball': '번개 구체'
    },
    'replaceText': {
      'Aetherial Pull': '흡인',
      'Boundless Pain': '무한한 고통',
      'Charnel Claw': '무덤의 발톱',
      'Coffin Scratch': '관짝 할퀴기',
      'Downpour': '물고문',
      'Dynamic Pound': '초전자 그라운드 펀치',
      'Dynamic Scrapline': '초전자 롤링 래리어트',
      'Electromagnetic Release': '전자기 방사',
      'Erupting Pain': '고통의 불기둥',
      'Explosion': '폭발',
      'Graviton Spark': '그래비톤 스파크',
      'Ground and Pound': '그라운드 펀치',
      'Imperatum': '임페라토르',
      'Lunar Nail': '기괴한 말뚝',
      'Magitek Chakram': '마도 차크람',
      'Magitek Explosive': '마도 폭탄',
      'Magitek Missile': '마도 미사일',
      'Magitek Ray': '마도 레이저',
      'Mega Graviton': '메가 그래비톤',
      'Mighty Blow': '격돌',
      'Obliviating Claw': '망각의 발톱',
      'Oblivion': '혼돈의 차원',
      'Pater Patriae': '파테르 파트리아이',
      'Phantom Pain': '환상통',
      'Rolling Scrapline': '롤링 래리어트',
      'Shocking Force': '고전압 방전',
      'Surface Missile': '대지 미사일',
      'Thermal Suppression': '화력 제압',
      'Thundercall': '초뢰',
      'Shock(?!ing)': '방전'
    }
  }]
};
/* harmony default export */ const the_tower_of_babil = (the_tower_of_babil_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/the_tower_of_babil.txt
const dungeon_the_tower_of_babil_namespaceObject = "# The Tower Of Babil\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n\r\n#~~~~~~~~~~#\r\n# BARNABAS #\r\n#~~~~~~~~~~#\r\n\r\n# -ii 6076 61DE\r\n\r\n# Common opener\r\n# Magitek Servicing will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"101C\" } window 0,1\r\n5.7 \"--sync--\" StartsUsing { id: \"6247\", source: \"Barnabas\" } window 5.7,5\r\n8.9 \"Ground and Pound\" Ability { id: \"6247\", source: \"Barnabas\" }\r\n27.3 \"Ground and Pound\" Ability { id: \"62EA\", source: \"Barnabas\" }\r\n\r\n# Barnabas can use either Dynamic Pound or Dynamic Scrapline first.\r\n# Unfortunately, the timing on the abilities up to Thundercall\r\n# is just offset enough to make it impractical to interleave the possibilities.\r\n# The Thundercall after the Pound/Scrapline blocks is the same\r\n# regardless of path taken.\r\n33.8 \"--sync--\" StartsUsing { id: [\"6246\", \"62F0\"], source: \"Barnabas\" } window 33.8,5 jump 193.3\r\n36.4 \"--sync--\" StartsUsing { id: [\"6245\", \"62EE\"], source: \"Barnabas\" } window 36.4,5 jump 293.3\r\n40.5 \"Dynamic Scrapline?\"\r\n43.0 \"Electromagnetic Release?\"\r\n43.1 \"Dynamic Pound?\"\r\n45.6 \"Electromagnetic Release?\"\r\n55.2 \"Shocking Force\"\r\n\r\n# Scrapline first\r\n193.3 \"--sync--\" StartsUsing { id: [\"6246\", \"62F0\"], source: \"Barnabas\" }\r\n200.0 \"Dynamic Scrapline\" Ability { id: [\"6246\", \"62F0\"], source: \"Barnabas\" }\r\n201.1 \"--sync--\" Ability { id: \"61DD\", source: \"Barnabas\" }\r\n202.5 \"Electromagnetic Release\" Ability { id: \"62F1\", source: \"Barnabas\" }\r\n214.7 \"Shocking Force\" Ability { id: \"62EC\", source: \"Barnabas\" } window 15,15\r\n231.7 \"Dynamic Pound\" Ability { id: [\"6245\", \"62EE\"], source: \"Barnabas\" }\r\n232.8 \"--sync--\" Ability { id: \"6075\", source: \"Barnabas\" }\r\n234.2 \"Electromagnetic Release\" Ability { id: \"62EF\", source: \"Barnabas\" }\r\n\r\n244.8 \"Thundercall\" Ability { id: \"62ED\", source: \"Barnabas\" } window 44.8,5 jump 400\r\n251.3 \"Rolling Scrapline\"\r\n251.6 \"Shock\"\r\n261.8 \"Shocking Force\"\r\n270.4 \"Ground and Pound 1\"\r\n276.4 \"Ground and Pound 2\"\r\n\r\n# Pound first\r\n293.3 \"--sync--\" StartsUsing { id: [\"6245\", \"62EE\"], source: \"Barnabas\" }\r\n300.0 \"Dynamic Pound\" Ability { id: [\"6245\", \"62EE\"], source: \"Barnabas\" }\r\n301.1 \"--sync--\" Ability { id: \"6075\", source: \"Barnabas\" }\r\n302.5 \"Electromagnetic Release\" Ability { id: \"62EF\", source: \"Barnabas\" }\r\n314.7 \"Shocking Force\" Ability { id: \"62EC\", source: \"Barnabas\" } window 15,15\r\n329.9 \"Dynamic Scrapline\" Ability { id: [\"6246\", \"62F0\"], source: \"Barnabas\" }\r\n331.0 \"--sync--\" Ability { id: \"61DD\", source: \"Barnabas\" }\r\n332.4 \"Electromagnetic Release\" Ability { id: \"62F1\", source: \"Barnabas\" }\r\n\r\n342.7 \"Thundercall\" Ability { id: \"62ED\", source: \"Barnabas\" } window 42.7,5 jump 400\r\n349.2 \"Rolling Scrapline\"\r\n349.5 \"Shock\"\r\n359.8 \"Shocking Force\"\r\n368.4 \"Ground and Pound 1\"\r\n374.4 \"Ground and Pound 2\"\r\n\r\n# Common Thundercall block, looping back to one of the two blocks.\r\n400.0 \"Thundercall\" Ability { id: \"62ED\", source: \"Barnabas\" }\r\n406.5 \"Rolling Scrapline\" Ability { id: \"62EB\", source: \"Barnabas\" }\r\n406.8 \"Shock\" Ability { id: \"62F2\", source: \"Thunderball\" }\r\n417.0 \"Shocking Force\" Ability { id: \"62EC\", source: \"Barnabas\" }\r\n425.6 \"Ground and Pound 1\" Ability { id: \"62EA\", source: \"Barnabas\" }\r\n431.6 \"Ground and Pound 2\" Ability { id: \"62EA\", source: \"Barnabas\" }\r\n437.6 \"Ground and Pound 3\" Ability { id: \"62EA\", source: \"Barnabas\" }\r\n\r\n446.5 \"--sync--\" StartsUsing { id: [\"6246\", \"62F0\"], source: \"Barnabas\" } window 30,5 jump 193.3\r\n449.1 \"--sync--\" StartsUsing { id: [\"6245\", \"62EE\"], source: \"Barnabas\" } window 30,5 jump 293.3\r\n453.2 \"Dynamic Scrapline?\"\r\n455.7 \"Electromagnetic Release?\"\r\n455.8 \"Dynamic Pound?\"\r\n458.3 \"Electromagnetic Release?\"\r\n\r\n\r\n#~~~~~~~~~~~#\r\n# DR. LUGAE #\r\n#~~~~~~~~~~~#\r\n\r\n# Martial Conditioning will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"101D\" } window 1000,5\r\n1009.7 \"Thermal Suppression\" Ability { id: \"62FA\", source: \"Lugae\" } window 1009.7,10\r\n1018.2 \"Magitek Missile\" Ability { id: \"62F6\", source: \"Lugae\" }\r\n1022.5 \"Surface Missile\" Ability { id: \"62F7\", source: \"Lugae\" }\r\n1028.8 \"Magitek Ray\" Ability { id: \"62FC\", source: \"Lugae\" }\r\n\r\n1039.8 \"Magitek Chakram?\" Ability { id: \"62F3\", source: \"Lugae\" } window 1039.8,10 jump 1200\r\n1040.3 \"Downpour?\" Ability { id: \"62F5\", source: \"Lugae\" } window 1040.5,10 jump 1266.9\r\n1047.8 \"Magitek Missile?\"\r\n1048.3 \"Magitek Chakram?\"\r\n1050.8 \"Mighty Blow?\"\r\n1052.1 \"Surface Missile?\"\r\n1053.3 \"Magitek Missile?\"\r\n1057.6 \"Surface Missile?\"\r\n1058.8 \"Magitek Missile?\"\r\n1059.3 \"Mighty Blow?\"\r\n\r\n\r\n1200.0 \"Magitek Chakram\" Ability { id: \"62F3\", source: \"Lugae\" }\r\n1208.5 \"Magitek Chakram\" Ability { id: \"62F3\", source: \"Lugae\" }\r\n1211.0 \"Mighty Blow\" Ability { id: \"62F4\", source: \"Magitek Chakram\" }\r\n1219.5 \"Mighty Blow\" Ability { id: \"62F4\", source: \"Magitek Chakram\" }\r\n\r\n1227.0 \"Thermal Suppression\" Ability { id: \"62FA\", source: \"Lugae\" }\r\n1232.6 \"Magitek Ray\" Ability { id: \"62FC\", source: \"Lugae\" }\r\n1244.1 \"Magitek Explosive\" Ability { id: \"62F8\", source: \"Lugae\" }\r\n1255.1 \"Explosion\" Ability { id: \"62F9\", source: \"Magitek Explosive\" }\r\n\r\n1266.9 \"Downpour\" Ability { id: \"62F5\", source: \"Lugae\" } window 66.9,10\r\n1274.4 \"Magitek Missile\" Ability { id: \"62F6\", source: \"Lugae\" }\r\n1278.7 \"Surface Missile\" Ability { id: \"62F7\", source: \"Lugae\" }\r\n1279.9 \"Magitek Missile\" Ability { id: \"62F6\", source: \"Lugae\" }\r\n1284.2 \"Surface Missile\" Ability { id: \"62F7\", source: \"Lugae\" }\r\n1285.4 \"Magitek Missile\" Ability { id: \"62F6\", source: \"Lugae\" }\r\n1289.7 \"Surface Missile\" Ability { id: \"62F7\", source: \"Lugae\" }\r\n1294.9 \"Thermal Suppression\" Ability { id: \"62FA\", source: \"Lugae\" } window 30,30\r\n1300.4 \"Magitek Ray\" Ability { id: \"62FC\", source: \"Lugae\" }\r\n1312.0 \"Magitek Explosive\" Ability { id: \"62F8\", source: \"Lugae\" }\r\n1323.0 \"Explosion\" Ability { id: \"62F9\", source: \"Magitek Explosive\" }\r\n\r\n1335.3 \"Magitek Chakram\" Ability { id: \"62F3\", source: \"Lugae\" } jump 1200\r\n1343.8 \"Magitek Chakram\"\r\n1346.3 \"Mighty Blow\"\r\n1354.9 \"Mighty Blow\"\r\n1362.4 \"Thermal Suppression\"\r\n1368.0 \"Magitek Ray\"\r\n\r\n#~~~~~~~#\r\n# ANIMA #\r\n#~~~~~~~#\r\n\r\n# -ii 52BE 5E68 6305\r\n\r\n# The Iron Womb will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"101E\" } window 2000,1\r\n2009.8 \"Lunar Nail\" Ability { id: \"62FE\", source: \"Anima\" } window 2009.8,10\r\n2020.7 \"Phantom Pain\" Ability { id: \"62FF\", source: \"Anima\" }\r\n2029.8 \"Mega Graviton\" Ability { id: \"6300\", source: \"Anima\" }\r\n2037.8 \"Pater Patriae\" Ability { id: \"6306\", source: \"Anima\" }\r\n2043.7 \"Aetherial Pull\" Ability { id: \"6301\", source: \"Mega-graviton\" } window 2043.7,10\r\n2045.8 \"Graviton Spark\" Ability { id: \"6302\", source: \"Mega-graviton\" }\r\n2058.4 \"Boundless Pain\" Ability { id: \"6303\", source: \"Anima\" }\r\n2058.5 \"--sync--\" Ability { id: \"6675\", source: \"Anima\" }\r\n2059.6 \"Boundless Pain\" Ability { id: \"6304\", source: \"Anima\" } duration 11\r\n2082.5 \"Imperatum\" Ability { id: \"6309\", source: \"Anima\" } window 2082.5,10\r\n2083.3 \"--untargetable--\"\r\n2085.0 \"--sync--\" Ability { id: \"5D79\", source: \"Anima\" }\r\n\r\n# Teleport to alternate dimension. Possible HP% push?\r\n# TODO\r\n# Need more data in case there are mechanics past Charnel Claw 2.\r\n# Might repeat Obliviating Claw?\r\n2101.5 \"--targetable--\"\r\n2109.8 \"--sync--\" Ability { id: \"630B\", source: \"Anima\" }\r\n2116.6 \"Obliviating Claw #1\" Ability { id: \"630C\", source: \"Iron Nail\" }\r\n2121.6 \"Obliviating Claw #2\" Ability { id: \"630C\", source: \"Iron Nail\" }\r\n2127.6 \"Charnel Claw #1\" Ability { id: \"630D\", source: \"Iron Nail\" }\r\n2132.6 \"Charnel Claw #2\" Ability { id: \"630D\", source: \"Iron Nail\" }\r\n2135.1 \"--sync--\" Ability { id: \"6A5C\", source: \"Anima\" }\r\n2143.6 \"Obliviating Claw\" Ability { id: \"630A\", source: \"Anima\" }\r\n2149.1 \"Coffin Scratch x5\" Ability { id: \"630E\", source: \"Anima\" } duration 5\r\n2155.7 \"--sync--\" Ability { id: \"6A5C\", source: \"Anima\" }\r\n2164.2 \"--sync--\" Ability { id: \"630B\", source: \"Anima\" }\r\n2171.0 \"Obliviating Claw #1\" Ability { id: \"630C\", source: \"Iron Nail\" }\r\n2176.0 \"Obliviating Claw #2\" Ability { id: \"630C\", source: \"Iron Nail\" }\r\n2182.0 \"Charnel Claw #1\" Ability { id: \"630D\", source: \"Iron Nail\" }\r\n2187.0 \"Charnel Claw #2\" Ability { id: \"630D\", source: \"Iron Nail\" } # can be skipped if DPS is high enough\r\n2189.5 \"--sync--\" Ability { id: \"6A5C\", source: \"Anima\" } window 20,20\r\n2192.9 \"--untargetable--\"\r\n2199.1 \"Oblivion\" Ability { id: \"630F\", source: \"Anima\" } duration 5\r\n2205.8 \"--sync--\" Ability { id: \"5D40\", source: \"Anima\" } window 2205.8,30\r\n\r\n# Return from alternate dimension.\r\n2216.2 \"--targetable--\"\r\n2229.4 \"--sync--\" Ability { id: \"6303\", source: \"Anima\" } # Boundless Pain\r\n2229.5 \"--sync--\" Ability { id: \"6675\", source: \"Anima\" }\r\n2230.6 \"Boundless Pain\" Ability { id: \"6304\", source: \"Anima\" } duration 12\r\n2249.8 \"Pater Patriae\" Ability { id: \"6306\", source: \"Anima\" }\r\n2258.3 \"Lunar Nail\" Ability { id: \"62FE\", source: \"Anima\" }\r\n2269.2 \"Phantom Pain\" Ability { id: \"62FF\", source: \"Anima\" } window 30,30\r\n2289.2 \"Erupting Pain\" Ability { id: \"6308\", source: \"Anima\" }\r\n2289.6 \"--sync--\" Ability { id: \"6307\", source: \"Anima\" } # Erupting Pain\r\n2302.1 \"Mega Graviton\" Ability { id: \"6300\", source: \"Anima\" } window 30,30\r\n2310.1 \"Pater Patriae\" Ability { id: \"6306\", source: \"Anima\" }\r\n2316.0 \"Aetherial Pull\" Ability { id: \"6301\", source: \"Mega-graviton\" }\r\n2327.6 \"--sync--\" Ability { id: \"6307\", source: \"Anima\" } # Erupting Pain\r\n2327.6 \"Erupting Pain\" Ability { id: \"6308\", source: \"Anima\" }\r\n\r\n2349.4 \"Boundless Pain\" Ability { id: \"6304\", source: \"Anima\" } duration 12\r\n2368.6 \"Pater Patriae\" Ability { id: \"6306\", source: \"Anima\" } window 15,15 jump 2249.8\r\n2377.1 \"Lunar Nail\"\r\n2388.0 \"Phantom Pain\"\r\n2408.0 \"Erupting Pain\"\r\n2420.9 \"Mega Graviton\"\r\n2428.9 \"Pater Patriae\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/the_tower_of_zot.ts



const the_tower_of_zot_triggerSet = {
  id: 'TheTowerOfZot',
  zoneId: zone_id/* default.TheTowerOfZot */.Z.TheTowerOfZot,
  timelineFile: 'the_tower_of_zot.txt',
  initData: () => {
    return {
      orbCount: 0,
      orbs: new Map()
    };
  },
  triggers: [{
    id: 'Zot Minduruva Bio',
    type: 'StartsUsing',
    // 62CA in the final phase.
    netRegex: {
      id: ['62A9', '62CA'],
      source: 'Minduruva'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zot Minduruva Transmute Counter',
    type: 'StartsUsing',
    // 629A = Transmute Fire III
    // 631B = Transmute Blizzard III
    // 631C = Transmute Thunder III
    // 631D = Transmute Bio III
    netRegex: {
      id: ['629A', '631[BCD]'],
      source: 'Minduruva'
    },
    run: (data, matches) => {
      const transmuteFire = '629A';
      const transmuteBio = '631D';
      data.orbCount++;

      // We only expect one of these at once
      if (matches.id === transmuteFire) data.orbs.set('Fire', data.orbCount);else if (matches.id === transmuteBio) data.orbs.set('Bio', data.orbCount);
    }
  }, {
    id: 'Zot Minduruva Manusya III',
    type: 'StartsUsing',
    // 6291 = Manusya Fire III
    // 6292 = Manusya Blizzard III
    // 6293 = Manusya Thunder III
    // 6294 = Manusya Bio III
    netRegex: {
      id: ['629[1-4]'],
      source: 'Minduruva'
    },
    durationSeconds: data => {
      // Based on network log data analysis, the first orb will finish
      // 8 seconds after this cast started, while the second orb will
      // finish 12 seconds after this cast started.
      //
      // For simplicity, if we have an overlapping mechanic, use a
      // duration of 12 to keep this alert up long enough to cover all
      // cases.
      if (data.orbs.size > 0) return 12;
    },
    alertText: (data, matches, output) => {
      const fire = '6291';
      const blizzard = '6292';
      const thunder = '6293';
      const bio = '6294';
      if (matches.id === blizzard || matches.id === thunder) {
        if (data.orbs.has('Fire')) return output.fireOrb({
          num: data.orbs.get('Fire')
        });else if (data.orbs.has('Bio')) return output.bioOrb({
          num: data.orbs.get('Bio')
        });
      } else if (matches.id === fire) {
        if (data.orbs.has('Bio')) return output.fireThenBio({
          num: data.orbs.get('Bio')
        });
        return output.getUnder();
      } else if (matches.id === bio) {
        if (data.orbs.has('Fire')) return output.bioThenFire({
          num: data.orbs.get('Fire')
        });
        return output.getBehind();
      }
    },
    outputStrings: {
      fireOrb: {
        en: 'Under Orb ${num}',
        de: 'Unter den ${num}. Orb',
        fr: 'En dessous l\'orbe ${num}',
        ja: '${num}番目の玉へ',
        cn: '靠近第${num}个球',
        ko: '${num}번 구슬 밑으로'
      },
      bioOrb: {
        en: 'Behind Orb ${num}',
        de: 'Hinter den ${num}. Orb',
        fr: 'Allez derrière l\'orbe ${num}',
        ja: '${num}番目の玉の後ろへ',
        cn: '去第${num}个球的终点方向贴边',
        ko: '${num}번 구슬 뒤로'
      },
      fireThenBio: {
        en: 'Get Under => Behind Orb ${num}',
        de: 'Unter ihn => Hinter den ${num}. Orb',
        fr: 'En dessous => Allez derrière l\'orbe ${num}',
        ja: 'ボスに貼り付く=> ${num}番目の玉の後ろへ',
        cn: '去脚下 => 去第${num}个球的终点方向贴边',
        ko: '보스 아래로 => ${num}번 구슬 뒤로'
      },
      bioThenFire: {
        en: 'Get Behind => Under Orb ${num}',
        de: 'Hinter ihn => Unter den ${num}. Orb',
        fr: 'Passez derrière => En dessous l\'orbe ${num}',
        ja: '背面へ => ${num}番目の玉へ',
        cn: '去背后 => 靠近第${num}个球',
        ko: '보스 뒤로 => ${num}번 구슬 밑으로'
      },
      getUnder: outputs/* default.getUnder */.Z.getUnder,
      getBehind: outputs/* default.getBehind */.Z.getBehind
    }
  }, {
    id: 'Zot Minduruva Dhrupad Reset',
    type: 'StartsUsing',
    netRegex: {
      id: '629C',
      source: 'Minduruva',
      capture: false
    },
    // There's a Dhrupad cast after every transmute sequence.
    run: data => {
      data.orbCount = 0;
      data.orbs = new Map();
    }
  }, {
    id: 'Zot Sanduruva Isitva Siddhi',
    type: 'StartsUsing',
    // 62A9 is 2nd boss, 62C0 is 3rd boss.
    netRegex: {
      id: ['62A9', '62C0'],
      source: 'Sanduruva'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zot Sanduruva Manusya Berserk',
    type: 'Ability',
    // 62A1 is 2nd boss, 62BC in the 3rd boss.
    netRegex: {
      id: ['62A1', '62BC'],
      source: 'Sanduruva',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go behind empty spot',
        de: 'Hinter den leeren Spot gehen',
        fr: 'Allez derrière un espace vide',
        ja: '玉のない箇所へ',
        cn: '去没球球的角落贴边',
        ko: '빈 공간 끝으로'
      }
    }
  }, {
    id: 'Zot Sanduruva Manusya Confuse',
    type: 'StartsUsing',
    netRegex: {
      id: '62A5',
      source: 'Sanduruva',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go behind still clone',
        de: 'Geh hinter den ruhigen Klon',
        fr: 'Allez derrière le vrai clone',
        ja: '動いていないドグの後ろへ',
        cn: '找不动的boss',
        ko: '가만히 있는 분신 뒤로'
      }
    }
  }, {
    id: 'Zot Cinduruva Samsara',
    type: 'StartsUsing',
    netRegex: {
      id: '62B9',
      source: 'Cinduruva',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zot Cinduruva Isitva Siddhi',
    type: 'StartsUsing',
    netRegex: {
      id: '62A9',
      source: 'Cinduruva'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zot Cinduruva Delta Thunder III Stack',
    type: 'StartsUsing',
    netRegex: {
      id: '62B8',
      source: 'Cinduruva'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Berserker Sphere': 'Tollwutssphäre',
      'Cinduruva': 'Mug',
      'Ingenuity\'s Ingress': 'Gelass der Finesse',
      'Minduruva': 'Rug',
      'Prosperity\'S Promise': 'Gelass des Reichtums',
      'Sanduruva': 'Dug',
      'Wisdom\'S Ward': 'Gelass der Weisheit'
    },
    'replaceText': {
      'Cinduruva': 'Mug',
      'Sanduruva': 'Dug',
      'Delayed Element III': 'Verzögertes Element-ga',
      'Delayed Thunder III': 'Verzögertes Blitzga',
      'Delta Attack': 'Delta-Attacke',
      'Delta Blizzard/Fire/Thunder III': 'DeltaEisga/Feuga/Blitzga',
      'Dhrupad': 'Dhrupad',
      'Explosive Force': 'Zündung',
      'Isitva Siddhi': 'Isitva Siddhi',
      'Manusya Berserk': 'Manusya-Tollwut',
      'Manusya Bio(?! )': 'Manusya-Bio',
      'Manusya Bio III': 'Manusya-Bioga',
      'Manusya Blizzard(?! )': 'Manusya-Eis',
      'Manusya Blizzard III': 'Manusya-Eisga',
      'Manusya Confuse': 'Manusya-Konfus',
      'Manusya Element III': 'Manusya Element-ga',
      'Manusya Faith': 'Manusya-Ener',
      'Manusya Fire(?! )': 'Manusya-Feuer',
      'Manusya Fire III': 'Manusya-Feuga',
      'Manusya Reflect': 'Manusya-Reflektion',
      'Manusya Stop': 'Manusya-Stopp',
      'Manusya Thunder(?! )': 'Manusya-Blitz',
      'Manusya Thunder III': 'Manusya-Blitzga',
      'Prakamya Siddhi': 'Prakamya Siddhi',
      'Prapti Siddhi': 'Prapti Siddhi',
      'Samsara': 'Samsara',
      'Sphere Shatter': 'Sphärensplitterung',
      'Transmute Thunder III': 'Manipuliertes Blitzga',
      'Transmute Element III': 'Manipuliertes Element-ga'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Berserker Sphere': 'sphère berserk',
      'Cinduruva': 'Maria',
      'Ingenuity\'s Ingress': 'Chambre de l\'habileté',
      'Minduruva': 'Anabella',
      'Prosperity\'S Promise': 'Chambre de la fortune',
      'Sanduruva': 'Samanta',
      'Wisdom\'S Ward': 'Chambre de la sagesse'
    },
    'replaceText': {
      'Cinduruva': 'Maria',
      'Delayed Element III': 'Méga Élément retardé',
      'Delayed Thunder III': 'Méga Foudre retardé',
      'Delta Attack': 'Attaque Delta',
      'Delta Blizzard/Fire/Thunder III': 'Méga Glace/Feu/Foudre delta',
      'Dhrupad': 'Dhrupad',
      'Explosive Force': 'Détonation',
      'Isitva Siddhi': 'Isitva Siddhi',
      'Manusya Berserk': 'Berserk manusya',
      'Manusya Bio(?! )': 'Bactérie manusya',
      'Manusya Bio III': 'Méga Bactérie manusya',
      'Manusya Blizzard(?! )': 'Glace manusya',
      'Manusya Blizzard III': 'Méga Glace manusya',
      'Manusya Confuse': 'Confusion manusya',
      'Manusya Element III': 'Méga Élément manusya',
      'Manusya Faith': 'Foi manusya',
      'Manusya Fire(?! )': 'Feu manusya',
      'Manusya Fire III': 'Méga Feu manusya',
      'Manusya Reflect': 'Reflet manusya',
      'Manusya Stop': 'Stop manusya',
      'Manusya Thunder(?! )': 'Foudre manusya',
      'Manusya Thunder III': 'Méga Foudre manusya',
      'Prakamya Siddhi': 'Prakamya Siddhi',
      'Prapti Siddhi': 'Prapti Siddhi',
      'Samsara': 'Samsara',
      'Sanduruva': 'Samanta',
      'Sphere Shatter': 'Rupture',
      'Transmute Element III': 'Manipulation magique : Méga Élément',
      'Transmute Thunder III': 'Manipulation magique : Méga Foudre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Berserker Sphere': 'バーサクスフィア',
      'Cinduruva': 'マグ',
      'Ingenuity\'s Ingress': '技巧の間',
      'Minduruva': 'ラグ',
      'Prosperity\'S Promise': '富の間',
      'Sanduruva': 'ドグ',
      'Wisdom\'S Ward': '知恵の間'
    },
    'replaceText': {
      'Delayed Element III': '玉：？？？ガ',
      'Delta Attack': 'デルタアタック',
      'Delta Blizzard/Fire/Thunder III': 'デルタ・ブリザガ/ファイガ/サンダガ',
      'Dhrupad': 'ドゥルパド',
      'Explosive Force': '起爆',
      'Isitva Siddhi': 'イシトヴァシッディ',
      'Manusya Berserk': 'マヌシャ・バーサク',
      'Manusya Bio(?! )': 'マヌシャ・バイオ',
      'Manusya Bio III': 'マヌシャ・バイオガ',
      'Manusya Blizzard(?! )': 'マヌシャ・ブリザド',
      'Manusya Blizzard III': 'マヌシャ・ブリザガ',
      'Manusya Confuse': 'マヌシャ・コンフュ',
      'Manusya Element III': 'マヌシャ・？？？ガ',
      'Manusya Faith': 'マヌシャ・フェイス',
      'Manusya Fire(?! )': 'マヌシャ・ファイア',
      'Manusya Fire III': 'マヌシャ・ファイガ',
      'Manusya Reflect': 'マヌシャ・リフレク',
      'Manusya Stop': 'マヌシャ・ストップ',
      'Manusya Thunder(?! )': 'マヌシャ・サンダー',
      'Manusya Thunder III': 'マヌシャ・サンダガ',
      'Prakamya Siddhi': 'プラカーミャシッディ',
      'Prapti Siddhi': 'プラプティシッディ',
      'Samsara': 'サンサーラ',
      'Sphere Shatter': '破裂',
      'Transmute Element III': '魔力操作：？？？ガ',
      'Transmute Thunder III': '魔力操作：サンダガ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Berserker Sphere': '狂暴晶球',
      'Cinduruva': '马格',
      'Ingenuity\'s Ingress': '技巧之间',
      'Minduruva': '拉格',
      'Prosperity\'S Promise': '财富之间',
      'Prosperity\'s Promise': '财富之间',
      'Sanduruva': '多格',
      'Wisdom\'S Ward': '智慧之间',
      'Wisdom\'s Ward': '智慧之间'
    },
    'replaceText': {
      'Cinduruva': '马格',
      'Delayed Element III': '延迟元素',
      'Delayed Thunder III': '延迟暴雷',
      'Delta Attack': '三角攻击',
      'Delta Blizzard/Fire/Thunder III': '三角冰封/爆炎/暴雷',
      'Dhrupad': '德鲁帕德',
      'Explosive Force': '起爆',
      'Isitva Siddhi': '物创灭',
      'Manusya Berserk': '人趣狂暴',
      'Manusya Bio(?! )': '人趣毒菌',
      'Manusya Bio III': '人趣剧毒菌',
      'Manusya Blizzard(?! )': '人趣冰结',
      'Manusya Blizzard III': '人趣冰封',
      'Manusya Confuse': '人趣混乱',
      'Manusya Element III': '人趣元素',
      'Manusya Faith': '人趣信念',
      'Manusya Fire(?! )': '人趣火炎',
      'Manusya Fire III': '人趣爆炎',
      'Manusya Reflect': '人趣反射',
      'Manusya Stop': '人趣停止',
      'Manusya Thunder(?! )': '人趣闪雷',
      'Manusya Thunder III': '人趣暴雷',
      'Prakamya Siddhi': '大愿成',
      'Prapti Siddhi': '身所达',
      'Samsara': '轮回',
      'Sanduruva': '多格',
      'Sphere Shatter': '碎裂',
      'Transmute Element III': '魔力操纵：元素',
      'Transmute Thunder III': '魔力操纵：暴雷'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Berserker Sphere': '광폭화 구체',
      'Cinduruva': '마그',
      'Ingenuity\'s Ingress': '기교의 방',
      'Minduruva': '라그',
      'Prosperity\'S Promise': '부의 방',
      'Sanduruva': '도그',
      'Wisdom\'S Ward': '지혜의 방',
      'Prosperity\'s Promise': '부의 방',
      'Wisdom\'s Ward': '지혜의 방'
    },
    'replaceText': {
      'Cinduruva': '마그',
      'Sanduruva': '도그',
      'Delayed Element III': '지연 랜덤 마법',
      'Delayed Thunder III': '지연 선더가',
      'Delta Attack': '델타 공격',
      'Delta Blizzard/Fire/Thunder III': '델타 블리자가/파이가/선더가',
      'Dhrupad': '드루파드',
      'Explosive Force': '기폭',
      'Isitva Siddhi': '이시트바 싯디',
      'Manusya Berserk': '마누샤 광폭화',
      'Manusya Bio(?! )': '마누샤 바이오',
      'Manusya Bio III': '마누샤 바이오가',
      'Manusya Blizzard(?! )': '마누샤 블리자드',
      'Manusya Blizzard III': '마누샤 블리자가',
      'Manusya Confuse': '마누샤 혼란',
      'Manusya Element III': '마누샤 랜덤 마법',
      'Manusya Faith': '마누샤 신앙',
      'Manusya Fire(?! )': '마누샤 파이어',
      'Manusya Fire III': '마누샤 파이가',
      'Manusya Reflect': '마누샤 리플렉트',
      'Manusya Stop': '마누샤 정지',
      'Manusya Thunder(?! )': '마누샤 선더',
      'Manusya Thunder III': '마누샤 선더가',
      'Prakamya Siddhi': '프라카먀 싯디',
      'Prapti Siddhi': '프랍티 싯디',
      'Samsara': '삼사라',
      'Sphere Shatter': '파열',
      'Transmute Element III': '마력 조작: 랜덤 마법',
      'Transmute Thunder III': '마력 조작: 선더가'
    }
  }]
};
/* harmony default export */ const the_tower_of_zot = (the_tower_of_zot_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/the_tower_of_zot.txt
const dungeon_the_tower_of_zot_namespaceObject = "# The Tower Of Zot\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~~~#\r\n# MINDURUVA #\r\n#~~~~~~~~~~~#\r\n\r\n# -ii 366 6291 6292\r\n\r\n## Fixed-ish opening block\r\n# Ingenuity's Ingress will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E95\" } window 0,1\r\n8.9 \"Manusya Bio\" Ability { id: \"62A0\", source: \"Minduruva\" } window 8.9,5\r\n12.1 \"--sync--\" Ability { id: \"6299\", source: \"Minduruva\" }\r\n17.5 \"Manusya Blizzard III\" Ability { id: \"6296\", source: \"Minduruva\" }\r\n22.6 \"Manusya Fire III\" Ability { id: \"6295\", source: \"Minduruva\" }\r\n27.8 \"Manusya Thunder III x7\" Ability { id: \"6293\", source: \"Minduruva\" }\r\n32.9 \"Manusya Bio III\" Ability { id: \"6298\", source: \"Minduruva\" }\r\n34.1 \"--sync--\" Ability { id: \"6299\", source: \"Minduruva\" }\r\n38.0 \"Transmute Element III\" Ability { id: \"6(29A|31[BCD])\", source: \"Minduruva\" }\r\n38.9 \"--sync--\" Ability { id: \"629B\", source: \"Minduruva\" }\r\n42.3 \"Manusya Fire\" Ability { id: \"6463\", source: \"Minduruva\" }\r\n47.7 \"Manusya Element III\" #Ability { id: [\"6295\", \"6296\", \"6297\", \"6298\"], source: \"Minduruva\" }\r\n51.8 \"Delayed Element III\" #Ability { id: [\"6295\", \"6296\", \"6297\", \"6298\"], source: \"Minduruva\" }\r\n61.9 \"Manusya Bio\" Ability { id: \"62A0\", source: \"Minduruva\" }\r\n69.0 \"Dhrupad\" Ability { id: \"629C\", source: \"Minduruva\" } window 30,30\r\n\r\n# Transmute block, no initial Bio\r\n70.3 \"Manusya Fire\" Ability { id: \"629D\", source: \"Minduruva\" }\r\n71.4 \"Manusya Blizzard\" Ability { id: \"629E\", source: \"Minduruva\" }\r\n72.5 \"Manusya Thunder\" Ability { id: \"629F\", source: \"Minduruva\" }\r\n75.7 \"--sync--\" Ability { id: \"6299\", source: \"Minduruva\" }\r\n79.9 \"Transmute Element III #1\" Ability { id: \"6(29A|31[BCD])\", source: \"Minduruva\" }\r\n80.8 \"--sync--\" Ability { id: \"629B\", source: \"Minduruva\" }\r\n84.0 \"Transmute Element III #2\" Ability { id: \"6(29A|31[BCD])\", source: \"Minduruva\" }\r\n84.9 \"--sync--\" Ability { id: \"629B\", source: \"Minduruva\" }\r\n89.3 \"Manusya Element III\" #Ability { id: [\"6295\", \"6296\", \"6297\", \"6298\"], source: \"Minduruva\" }\r\n93.4 \"Delayed Element III #1\" #Ability { id: [\"6295\", \"6296\", \"6297\", \"6298\"], source: \"Minduruva\" }\r\n97.5 \"Delayed Element III #2\" #Ability { id: [\"6295\", \"6296\", \"6297\", \"6298\"], source: \"Minduruva\" }\r\n107.6 \"Dhrupad\" Ability { id: \"629C\", source: \"Minduruva\" } window 30,30\r\n\r\n# Rotation block with Bio\r\n108.8 \"Manusya Fire\" Ability { id: \"629D\", source: \"Minduruva\" }\r\n109.9 \"Manusya Blizzard\" Ability { id: \"629E\", source: \"Minduruva\" }\r\n111.0 \"Manusya Thunder\" Ability { id: \"629F\", source: \"Minduruva\" }\r\n117.1 \"Manusya Bio\" Ability { id: \"62A0\", source: \"Minduruva\" }\r\n127.3 \"--sync--\" Ability { id: \"6299\", source: \"Minduruva\" }\r\n131.5 \"Transmute Element III #1\" Ability { id: \"6(29A|31[BCD])\", source: \"Minduruva\" }\r\n132.4 \"--sync--\" Ability { id: \"629B\", source: \"Minduruva\" }\r\n135.5 \"Transmute Element III #2\" Ability { id: \"6(29A|31[BCD])\", source: \"Minduruva\" }\r\n136.4 \"--sync--\" Ability { id: \"629B\", source: \"Minduruva\" }\r\n140.8 \"Manusya Element III\" #Ability { id: [\"6295\", \"6296\", \"6297\", \"6298\"], source: \"Minduruva\" }\r\n144.9 \"Delayed Element III #1\" #Ability { id: [\"6295\", \"6296\", \"6297\", \"6298\"], source: \"Minduruva\" }\r\n148.9 \"Delayed Element III #2\" #Ability { id: [\"6295\", \"6296\", \"6297\", \"6298\"], source: \"Minduruva\" }\r\n159.0 \"Dhrupad\" Ability { id: \"629C\", source: \"Minduruva\" } window 30,30\r\n\r\n160.1 \"Manusya Fire\" Ability { id: \"629D\", source: \"Minduruva\" }\r\n161.2 \"Manusya Blizzard\" Ability { id: \"629E\", source: \"Minduruva\" }\r\n162.3 \"Manusya Thunder\" Ability { id: \"629F\", source: \"Minduruva\" }\r\n168.4 \"Manusya Bio\" Ability { id: \"62A0\", source: \"Minduruva\" }\r\n178.6 \"--sync--\" Ability { id: \"6299\", source: \"Minduruva\" }\r\n182.8 \"Transmute Element III #1\" Ability { id: \"6(29A|31[BCD])\", source: \"Minduruva\" }\r\n183.7 \"--sync--\" Ability { id: \"629B\", source: \"Minduruva\" }\r\n186.8 \"Transmute Element III #2\" Ability { id: \"6(29A|31[BCD])\", source: \"Minduruva\" }\r\n187.7 \"--sync--\" Ability { id: \"629B\", source: \"Minduruva\" }\r\n192.1 \"Manusya Element III\" #Ability { id: [\"6295\", \"6296\", \"6297\", \"6298\"], source: \"Minduruva\" }\r\n196.2 \"Delayed Element III #1\" #Ability { id: [\"6295\", \"6296\", \"6297\", \"6298\"], source: \"Minduruva\" }\r\n200.2 \"Delayed Element III #2\" #Ability { id: [\"6295\", \"6296\", \"6297\", \"6298\"], source: \"Minduruva\" }\r\n210.3 \"Dhrupad\" Ability { id: \"629C\", source: \"Minduruva\" } window 30,30\r\n\r\n211.4 \"Manusya Fire\" Ability { id: \"629D\", source: \"Minduruva\" } jump 160.1\r\n212.5 \"Manusya Blizzard\"\r\n213.6 \"Manusya Thunder\"\r\n219.7 \"Manusya Bio\"\r\n234.1 \"Transmute Element III #1\"\r\n238.1 \"Transmute Element III #2\"\r\n\r\n#~~~~~~~~~~~#\r\n# SANDURUVA #\r\n#~~~~~~~~~~~#\r\n\r\n# -ii 367\r\n\r\n# Opening block\r\n# Prosperity's Promise will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E96\" } window 1000,5\r\n1009.3 \"Isitva Siddhi\" Ability { id: \"62A9\", source: \"Sanduruva\" } window 1009.3,5\r\n1015.7 \"Prapti Siddhi #1\" Ability { id: \"62A8\", source: \"Sanduruva\" }\r\n1019.6 \"Prapti Siddhi #2\" #Ability { id: \"62A8\", source: \"Sanduruva\" }\r\n1023.4 \"Prapti Siddhi #3\" #Ability { id: \"62A8\", source: \"Sanduruva\" }\r\n1027.4 \"Prapti Siddhi #4\" #Ability { id: \"62A8\", source: \"Sanduruva\" }\r\n1032.3 \"Manusya Berserk\" Ability { id: \"62A1\", source: \"Sanduruva\" } window 15,15\r\n1041.5 \"Explosive Force\" Ability { id: \"62A2\", source: \"Sanduruva\" }\r\n1043.5 \"Sphere Shatter\" Ability { id: \"62A4\", source: \"Berserker Sphere\" }\r\n1050.6 \"Prakamya Siddhi\" Ability { id: \"62A3\", source: \"Sanduruva\" }\r\n\r\n# Rotation block\r\n1055.8 \"--sync--\" Ability { id: \"62A6\", source: \"Sanduruva\" } window 1055.8,10\r\n1059.9 \"Manusya Stop\" Ability { id: \"62A7\", source: \"Sanduruva\" }\r\n1067.1 \"Prapti Siddhi #1\" Ability { id: \"62A8\", source: \"Sanduruva\" }\r\n1070.9 \"Prapti Siddhi #2\" #Ability { id: \"62A8\", source: \"Sanduruva\" }\r\n1074.8 \"Prapti Siddhi #3\" #Ability { id: \"62A8\", source: \"Sanduruva\" }\r\n1078.7 \"Prapti Siddhi #4\" #Ability { id: \"62A8\", source: \"Sanduruva\" }\r\n1087.7 \"Manusya Confuse\" Ability { id: \"62A5\", source: \"Sanduruva\" }\r\n1102.8 \"Explosive Force\" Ability { id: \"62A2\", source: \"Sanduruva\" }\r\n1104.9 \"Sphere Shatter\" Ability { id: \"62A4\", source: \"Berserker Sphere\" }\r\n1112.0 \"Prakamya Siddhi\" Ability { id: \"62A3\", source: \"Sanduruva\" }\r\n1120.2 \"Isitva Siddhi\" Ability { id: \"62A9\", source: \"Sanduruva\" } window 30,30\r\n\r\n1127.3 \"--sync--\" Ability { id: \"62A6\", source: \"Sanduruva\" } jump 1055.8\r\n1131.4 \"Manusya Stop\"\r\n1138.6 \"Prapti Siddhi #1\"\r\n1142.4 \"Prapti Siddhi #2\"\r\n1146.3 \"Prapti Siddhi #3\"\r\n1150.2 \"Prapti Siddhi #4\"\r\n1159.2 \"Manusya Confuse\"\r\n\r\n#~~~~~~~~~~~~~~~#\r\n# MAGUS SISTERS #\r\n#~~~~~~~~~~~~~~~#\r\n\r\n# -ii 367 62BA\r\n\r\n# Because we have no idea which sister will die first,\r\n# we sync aggressively all over the rotation block.\r\n\r\n# Wisdom's Ward will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"E97\" } window 2000,5\r\n2002.5 \"--sync--\" Ability { id: \"62BA\", source: \"Cinduruva\" } window 2002.5,2\r\n2009.8 \"Samsara\" Ability { id: \"62B9\", source: \"Cinduruva\" }\r\n2025.6 \"Manusya Faith\" Ability { id: \"62AA\", source: \"Sanduruva\" }\r\n2025.8 \"Manusya Reflect\" Ability { id: \"62AB\", source: \"Cinduruva\" }\r\n2026.7 \"Delta Attack\" Ability { id: \"62A[CDE]\", source: \"Minduruva\" }\r\n2034.9 \"Delta Blizzard/Fire/Thunder III\" duration 10 #Ability { id: \"62B[37]\", source: \"Cinduruva\" }\r\n2056.2 \"Dhrupad\" Ability { id: \"62C1\", source: \"Minduruva\" }\r\n2056.3 \"Isitva Siddhi\" Ability { id: \"62C0\", source: \"Sanduruva\" }\r\n2057.3 \"Manusya Fire\" Ability { id: \"62C2\", source: \"Minduruva\" }\r\n2058.4 \"Manusya Blizzard\" Ability { id: \"62C3\", source: \"Minduruva\" }\r\n2059.5 \"Manusya Thunder\" Ability { id: \"62C4\", source: \"Minduruva\" }\r\n2063.6 \"Manusya Fire\" Ability { id: \"62C7\", source: \"Minduruva\" }\r\n2064.6 \"Prapti Siddhi\" Ability { id: \"62BB\", source: \"Sanduruva\" }\r\n2067.0 \"Samsara\" Ability { id: \"62B9\", source: \"Cinduruva\" }\r\n2067.8 \"Manusya Blizzard\" Ability { id: \"62C8\", source: \"Minduruva\" }\r\n2068.5 \"Prapti Siddhi\" Ability { id: \"62BB\", source: \"Sanduruva\" }\r\n2071.9 \"Manusya Thunder\" Ability { id: \"62C9\", source: \"Minduruva\" }\r\n\r\n2075.1 \"--sync--\" Ability { id: \"62A6\", source: \"Sanduruva\" } window 100,30\r\n2080.3 \"Manusya Faith\" Ability { id: \"62AA\", source: \"Sanduruva\" } window 30,30\r\n2080.4 \"Manusya Reflect\" Ability { id: \"62AB\", source: \"Cinduruva\" } window 30,30\r\n2081.2 \"Delta Attack\" Ability { id: \"62A[CDE]\", source: \"Minduruva\" }\r\n2089.4 \"Delta Blizzard/Fire/Thunder III\" duration 10 #Ability { id: \"62B[37]\", source: \"Cinduruva\" }\r\n2110.6 \"Dhrupad\" Ability { id: \"62C1\", source: \"Minduruva\" } window 30,30\r\n2110.7 \"Isitva Siddhi\" Ability { id: \"62C0\", source: \"Sanduruva\" } window 30,30\r\n2111.7 \"Manusya Fire\" Ability { id: \"62C2\", source: \"Minduruva\" }\r\n2112.8 \"Manusya Blizzard\" Ability { id: \"62C3\", source: \"Minduruva\" }\r\n2113.9 \"Manusya Thunder\" Ability { id: \"62C4\", source: \"Minduruva\" }\r\n2118.0 \"Manusya Fire\" Ability { id: \"62C7\", source: \"Minduruva\" }\r\n2118.9 \"Prapti Siddhi\" Ability { id: \"62BB\", source: \"Sanduruva\" } window 30,2.5\r\n2121.3 \"Samsara\" Ability { id: \"62B9\", source: \"Cinduruva\" } window 30,30\r\n2122.1 \"Manusya Blizzard\" Ability { id: \"62C8\", source: \"Minduruva\" }\r\n2122.7 \"Prapti Siddhi\" Ability { id: \"62BB\", source: \"Sanduruva\" }\r\n2126.2 \"Manusya Thunder\" Ability { id: \"62C9\", source: \"Minduruva\" }\r\n\r\n# We can't rely on any given sister being alive,\r\n# so sync + jump for all.\r\n2129.5 \"--sync--\" Ability { id: \"62A6\", source: \"Sanduruva\" } window 30,30\r\n2134.7 \"Manusya Faith\" Ability { id: \"62AA\", source: \"Sanduruva\" } window 30,30 jump 2080.3\r\n2134.8 \"Manusya Reflect\" Ability { id: \"62AB\", source: \"Cinduruva\" } window 30,30 jump 2080.4\r\n2135.6 \"Delta Attack\" Ability { id: \"62A[CDE]\", source: \"Minduruva\" } window 30,30 jump 2081.2\r\n2143.8 \"Delta Blizzard/Fire/Thunder III\"\r\n2165.0 \"Dhrupad\"\r\n2165.1 \"Isitva Siddhi\"\r\n2166.1 \"Manusya Fire\"\r\n2167.2 \"Manusya Blizzard\"\r\n2168.3 \"Manusya Thunder\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/vanaspati.ts




// TODO: is there any way to figure out Svarbhanu color? It doesn't seem to be a headmarker.

const vanaspati_triggerSet = {
  id: 'Vanaspati',
  zoneId: zone_id/* default.Vanaspati */.Z.Vanaspati,
  timelineFile: 'vanaspati.txt',
  triggers: [{
    id: 'Vanaspati Terminus Snatcher Note of Despair',
    type: 'StartsUsing',
    netRegex: {
      id: '6238',
      source: 'Terminus Snatcher',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Vanaspati Terminus Snatcher Mouth Off',
    type: 'StartsUsing',
    netRegex: {
      id: '6231',
      source: 'Terminus Snatcher',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go To Silent Mouth',
        de: 'Geh zum geschlossenen Mund',
        fr: 'Allez sur une bouche silencieuse',
        ja: '閉じた口へ',
        cn: '找闭着的嘴',
        ko: '말이 없는 입 쪽으로'
      }
    }
  }, {
    id: 'Vanaspati Terminus Snatcher Last Gasp',
    type: 'StartsUsing',
    netRegex: {
      id: '6235',
      source: 'Terminus Snatcher'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Vanaspati Terminus Snatcher What Is Right',
    type: 'StartsUsing',
    netRegex: {
      id: '6233',
      source: 'Terminus Snatcher',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Vanaspati Terminus Snatcher What Is Left',
    type: 'StartsUsing',
    netRegex: {
      id: '6234',
      source: 'Terminus Snatcher',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Vanaspati Terminus Snatcher Wallow',
    type: 'StartsUsing',
    netRegex: {
      id: '6236',
      source: 'Terminus Snatcher'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Vanaspati Terminus Wrecker Meaningless Destruction',
    type: 'StartsUsing',
    netRegex: {
      id: '6241',
      source: 'Terminus Wrecker',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Vanaspati Terminus Wrecker Total Wreck',
    type: 'StartsUsing',
    netRegex: {
      id: '6242',
      source: 'Terminus Wrecker'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Vanaspati Terminus Wrecker Aether Spray Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '623C',
      source: 'Terminus Wrecker'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Vanaspati Terminus Wrecker Aether Spray Bubble',
    type: 'StartsUsing',
    netRegex: {
      id: '623B',
      source: 'Terminus Wrecker',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get In Bubble',
        de: 'Geh in die Blase',
        fr: 'Allez dans une bulle',
        ja: '泡に入る',
        cn: '进泡泡',
        ko: '구슬 안에 들어가기'
      }
    }
  }, {
    id: 'Vanaspati Terminus Twitcher Double Hex Eye',
    type: 'StartsUsing',
    netRegex: {
      id: '6C21',
      source: 'Terminus Twitcher',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Vanaspati Svarbanu Flames of Decay',
    type: 'StartsUsing',
    netRegex: {
      id: '6252',
      source: 'Svarbhanu',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Vanaspati Svarbhanu Cosmic Kiss Spread',
    type: 'StartsUsing',
    netRegex: {
      id: '6250',
      source: 'Svarbhanu'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Vanaspati Svarbhanu Gnashing Of Teeth',
    type: 'StartsUsing',
    netRegex: {
      id: '6253',
      source: 'Svarbhanu'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Vanaspati Svarbhanu Aetherial Disruption',
    type: 'StartsUsing',
    netRegex: {
      id: '6248',
      source: 'Svarbhanu',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go To Opposite Color',
        de: 'Geh zur andere Farbe',
        fr: 'Allez sur la couleur opposée',
        ja: '反対の色へ',
        cn: '去异色地板',
        ko: '화면과 색이 다른 바닥으로'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'What Is Left/What Is Right': 'What Is Left/Right'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Devatagara': 'Devatagara',
      'Insight': 'Vor dem Haus des Weisen',
      'Svarbhanu': 'Svarbhanu',
      'Terminus Snatcher': 'Terminus-Häscher',
      'Terminus Twitcher': 'Terminus-Zerrer',
      'Terminus Wrecker': 'Terminus-Verwüster',
      'Trnakiya': 'Bucht im Meer der Bäume'
    },
    'replaceText': {
      '\\(Knockback\\)': '(Rückstoß)',
      '\\(Spread\\)': '(Verteilen)',
      '--meteor': '--Meteor',
      'Aether Siphon': 'Elementarer Sog',
      'Aether Spray': 'Elementarer Auswurf',
      'Aetherial Disruption': 'Erdwallung',
      'Chaotic Pulse': 'Erdlabung',
      'Chaotic Undercurrent': 'Venenströme',
      'Cosmic Kiss': 'Einschlag',
      'Crumbling Sky': 'Meteorruf',
      'Flames of Decay': 'Lohen des Leids',
      'Gnashing of Teeth': 'Verbeißen',
      'Last Gasp': 'Verzweifeltes Flehen',
      'Lost Hope': 'Klage der Ohnmächtigen',
      'Meaningless Destruction': 'Rasender Kummer',
      'Mouth Off': 'Reden ist Silber',
      'Note of Despair': 'Klage der Hoffnungslosen',
      'Poison Heart': 'Toxischer Ausfluss',
      'Total Wreck': 'Blinde Zerstörung',
      'Unholy Water': 'Wasserfolter',
      'Vitriol': 'Schweigen ist Gold',
      'Wallow': 'Schluchzen',
      'What Is Left': 'Schändliche Linke',
      'What Is Right': 'Schändliche Rechte'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Devatagara': 'Temple de Devata',
      'Insight': 'Résidence du doyen',
      'Svarbhanu': 'Svarbhanu',
      'Terminus Snatcher': 'pillard de l\'apocalypse',
      'Terminus Twitcher': 'Picoreur De L\'Apocalypse',
      'Terminus Wrecker': 'destructeur de l\'apocalypse',
      'Trnakiya': 'Clairière de Vanaspati'
    },
    'replaceText': {
      '\\(Bubble\\)': '(Bulle)',
      '\\(Knockback\\)': '(Poussée)',
      '\\(Spread\\)': '(Dispersion)',
      '--meteor': '--météore',
      'Aether Siphon': 'Absorption élémentaire',
      'Aether Spray': 'Déjection élémentaire',
      'Aetherial Disruption': 'Désolation terrestre',
      'Chaotic Pulse': 'Revivification terrestre',
      'Chaotic Undercurrent': 'Turbulence terrestre',
      'Cosmic Kiss': 'Impact',
      'Crumbling Sky': 'Appel des météores',
      'Flames of Decay': 'Désespoir brûlant',
      'Gnashing of Teeth': 'Grignotement',
      'Last Gasp': 'Supplication',
      'Lost Hope': 'Cri hébété',
      'Meaningless Destruction': 'Chagrin enragé',
      'Mouth Off': 'Parole d\'argent',
      'Note of Despair': 'Cri de désespoir',
      'Poison Heart': 'Décharge toxique',
      'Total Wreck': 'Destruction aveugle',
      'Unholy Water': 'Torture aqueuse',
      'Vitriol': 'Silence d\'or',
      'Wallow': 'Sanglot',
      'What Is Left/What Is Right': 'Main gauche/droite purulente'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Devatagara': 'デーヴァター寺院',
      'Insight': '里長邸前',
      'Svarbhanu': 'スヴァーバーヌ',
      'Terminus Snatcher': 'ターミナス・スナッチャー',
      'Terminus Twitcher': 'ターミナス・ツイッチャー',
      'Terminus Wrecker': 'ターミナス・レッカー',
      'Trnakiya': '樹海の空地'
    },
    'replaceText': {
      '\\(Knockback\\)': '(ノックバック)',
      '\\(Spread\\)': '(散開)',
      '--meteor (\\d)--': '--メテオ #$1--',
      'Aether Siphon': '属性吸収',
      'Aether Spray': '属性放出',
      'Aetherial Disruption': '地脈暴走',
      'Chaotic Pulse': '地脈活性',
      'Chaotic Undercurrent': '地脈乱流',
      'Cosmic Kiss': '着弾',
      'Crumbling Sky': '流星招来',
      'Flames of Decay': '絶望の炎',
      'Gnashing of Teeth': '噛みつき',
      'Last Gasp': '哀訴',
      'Lost Hope': '自失の叫び',
      'Meaningless Destruction': '絶望の狂乱',
      'Mouth Off': '有口無行',
      'Note of Despair': '絶望の叫び',
      'Poison Heart': '毒液塊',
      'Total Wreck': '打ち壊し',
      'Unholy Water': '水牢弾',
      'Vitriol': '有言実行',
      'Wallow': '嗚咽',
      'What Is Left/What Is Right': '穢れた左手/右手'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Devatagara': '天神寺',
      'Insight': '村长屋前',
      'Svarbhanu': '斯伐婆奴',
      'Terminus Snatcher': '终末的抢夺',
      'Terminus Twitcher': '终末的抽搐',
      'Terminus Wrecker': '终末的破坏',
      'Trnakiya': '森中空地'
    },
    'replaceText': {
      '\\(Knockback\\)': '(击退)',
      '\\(Spread\\)': '(扩散)',
      '--meteor': '--陨石',
      'Aether Siphon': '属性吸收',
      'Aether Spray': '属性放出',
      'Aetherial Disruption': '地脉失控',
      'Chaotic Pulse': '地脉活性',
      'Chaotic Undercurrent': '地脉乱流',
      'Cosmic Kiss': '流星坠落',
      'Crumbling Sky': '召唤流星',
      'Flames of Decay': '绝望之炎',
      'Gnashing of Teeth': '啃咬',
      'Last Gasp': '哀诉',
      'Lost Hope': '恍惚的叫声',
      'Meaningless Destruction': '绝望中的狂乱',
      'Mouth Off': '空口白话',
      'Note of Despair': '绝望的叫声',
      'Poison Heart': '毒液块',
      'Total Wreck': '极尽破坏',
      'Unholy Water': '水牢弹',
      'Vitriol': '言出必行',
      'Wallow': '呜咽',
      'What Is Left': '污秽的左手',
      'What Is Right': '污秽的右手'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Devatagara': '데바타 사원',
      'Insight': '이장 저택',
      'Svarbhanu': '스바르바누',
      'Terminus Snatcher': '종말의 강탈자',
      'Terminus Twitcher': '종말의 경련자',
      'Terminus Wrecker': '종말의 파괴자',
      'Trnakiya': '숲속 공터'
    },
    'replaceText': {
      '\\(Bubble\\)': '(구슬)',
      '\\(Knockback\\)': '(넉백)',
      '\\(Spread\\)': '(산개)',
      '--meteor': '--메테오',
      'Aether Siphon': '속성 흡수',
      'Aether Spray': '속성 방출',
      'Aetherial Disruption': '지맥 폭주',
      'Chaotic Pulse': '지맥 활성',
      'Chaotic Undercurrent': '지맥 난류',
      'Cosmic Kiss': '착탄',
      'Crumbling Sky': '유성 소환',
      'Flames of Decay': '절망의 불꽃',
      'Gnashing of Teeth': '물기',
      'Last Gasp': '슬픈 호소',
      'Lost Hope': '망연자실한 외침',
      'Meaningless Destruction': '절망의 광란',
      'Mouth Off': '유구무행',
      'Note of Despair': '절망의 외침',
      'Poison Heart': '독액 덩어리',
      'Total Wreck': '때려부수기',
      'Unholy Water': '물감옥',
      'Vitriol': '유언실행',
      'Wallow': '오열',
      'What Is Left/What Is Right': '부정한 왼손/오른손'
    }
  }]
};
/* harmony default export */ const vanaspati = (vanaspati_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/dungeon/vanaspati.txt
const dungeon_vanaspati_namespaceObject = "# Vanaspati\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# .*is no longer sealed\r\n0.0 \"--Reset--\" SystemLogMessage { id: \"7DE\" } window 0,100000 jump 0\r\n\r\n#~~~~~~~~~~~~~~~~~~~#\r\n# Terminus Snatcher #\r\n#~~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 6238:12.1\r\n# -ii 366 6291 6292\r\n\r\n# Trnakiya will be sealed off\r\n0.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"FAC\" } window 0,1\r\n7.1 \"--sync--\" StartsUsing { id: \"6238\", source: \"Terminus Snatcher\" } window 10,10\r\n12.1 \"Note of Despair\" Ability { id: \"6238\", source: \"Terminus Snatcher\" }\r\n19.6 \"Mouth Off\" Ability { id: \"6231\", source: \"Terminus Snatcher\" }\r\n31.4 \"Vitriol\" Ability { id: \"6232\", source: \"Terminus Snatcher\" }\r\n41.0 \"Last Gasp\" Ability { id: \"6235\", source: \"Terminus Snatcher\" }\r\n48.7 \"Mouth Off\" Ability { id: \"6231\", source: \"Terminus Snatcher\" }\r\n59.8 \"What Is Left/What Is Right\" Ability { id: \"623[34]\", source: \"Terminus Snatcher\" }\r\n60.5 \"Vitriol\" Ability { id: \"6232\", source: \"Terminus Snatcher\" }\r\n\r\n72.1 \"Note of Despair\" Ability { id: \"6238\", source: \"Terminus Snatcher\" }\r\n80.4 \"Lost Hope\" Ability { id: \"6237\", source: \"Terminus Snatcher\" }\r\n85.5 \"Mouth Off\" Ability { id: \"6231\", source: \"Terminus Snatcher\" }\r\n97.3 \"Vitriol\" Ability { id: \"6232\", source: \"Terminus Snatcher\" }\r\n107.0 \"Last Gasp\" Ability { id: \"6235\", source: \"Terminus Snatcher\" }\r\n114.8 \"Mouth Off\" Ability { id: \"6231\", source: \"Terminus Snatcher\" }\r\n125.9 \"What Is Left/What Is Right\" Ability { id: \"623[34]\", source: \"Terminus Snatcher\" }\r\n126.6 \"Vitriol\" Ability { id: \"6232\", source: \"Terminus Snatcher\" }\r\n137.1 \"What Is Left/What Is Right\" Ability { id: \"623[34]\", source: \"Terminus Snatcher\" }\r\n138.2 \"Wallow\" Ability { id: \"6236\", source: \"Terminus Snatcher\" }\r\n\r\n149.3 \"Note of Despair\" Ability { id: \"6238\", source: \"Terminus Snatcher\" } window 40,40 jump 72.1\r\n157.6 \"Lost Hope\" #Ability { id: \"6237\", source: \"Terminus Snatcher\" }\r\n162.7 \"Mouth Off\" #Ability { id: \"6231\", source: \"Terminus Snatcher\" }\r\n174.5 \"Vitriol\" #Ability { id: \"6232\", source: \"Terminus Snatcher\" }\r\n184.2 \"Last Gasp\" #Ability { id: \"6235\", source: \"Terminus Snatcher\" }\r\n\r\n\r\n#~~~~~~~~~~~~~~~~~~#\r\n# Terminus Wrecker #\r\n#~~~~~~~~~~~~~~~~~~#\r\n\r\n# -p 6241:1011.2\r\n# -ii 6CC7\r\n\r\n# Note: 623F is also called \"Poison Heart\" but that's when the stack marker appears.\r\n\r\n# Insight will be sealed off\r\n1000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"FAD\" } window 1000,0\r\n1006.2 \"--sync--\" StartsUsing { id: \"6241\", source: \"Terminus Wrecker\" } window 1010,10\r\n1011.2 \"Meaningless Destruction\" Ability { id: \"6241\", source: \"Terminus Wrecker\" }\r\n1021.4 \"Unholy Water\" Ability { id: \"6CCC\", source: \"Terminus Wrecker\" }\r\n1026.8 \"Aether Siphon\" Ability { id: \"623A\", source: \"Terminus Wrecker\" }\r\n1036.2 \"Aether Spray (Knockback)\" Ability { id: \"623C\", source: \"Terminus Wrecker\" }\r\n1048.5 \"Total Wreck\" Ability { id: \"6242\", source: \"Terminus Wrecker\" }\r\n1053.8 \"Unholy Water\" Ability { id: \"6CCC\", source: \"Terminus Wrecker\" }\r\n1059.2 \"Aether Siphon\" Ability { id: \"6239\", source: \"Terminus Wrecker\" }\r\n1068.5 \"Aether Spray (Bubble)\" Ability { id: \"623B\", source: \"Terminus Wrecker\" }\r\n\r\n1080.7 \"Meaningless Destruction\" Ability { id: \"6241\", source: \"Terminus Wrecker\" }\r\n1091.0 \"Unholy Water\" Ability { id: \"6CCC\", source: \"Terminus Wrecker\" }\r\n1096.4 \"Aether Siphon\" Ability { id: \"623A\", source: \"Terminus Wrecker\" }\r\n1105.8 \"Aether Spray (Knockback)\" Ability { id: \"623C\", source: \"Terminus Wrecker\" }\r\n1112.9 \"--sync--\" Ability { id: \"623F\", source: \"Terminus Wrecker\" }\r\n1118.0 \"Poison Heart\" Ability { id: \"6CCB\", source: \"Terminus Wrecker\" }\r\n1125.2 \"Total Wreck\" Ability { id: \"6242\", source: \"Terminus Wrecker\" }\r\n1135.5 \"Unholy Water\" Ability { id: \"6CCC\", source: \"Terminus Wrecker\" }\r\n1140.9 \"Aether Siphon\" Ability { id: \"6239\", source: \"Terminus Wrecker\" }\r\n1150.2 \"Aether Spray (Bubble)\" Ability { id: \"623B\", source: \"Terminus Wrecker\" }\r\n\r\n1162.4 \"Meaningless Destruction\" Ability { id: \"6241\", source: \"Terminus Wrecker\" } window 40,40 jump 1080.7\r\n1172.7 \"Unholy Water\" #Ability { id: \"6CCC\", source: \"Terminus Wrecker\" }\r\n1178.1 \"Aether Siphon\" #Ability { id: \"623A\", source: \"Terminus Wrecker\" }\r\n1187.5 \"Aether Spray (Knockback)\" #Ability { id: \"623C\", source: \"Terminus Wrecker\" }\r\n1194.6 \"--sync--\" #Ability { id: \"623F\", source: \"Terminus Wrecker\" }\r\n1199.7 \"Poison Heart\" #Ability { id: \"6CCB\", source: \"Terminus Wrecker\" }\r\n1206.9 \"Total Wreck\" #Ability { id: \"6242\", source: \"Terminus Wrecker\" }\r\n1217.2 \"Unholy Water\" #Ability { id: \"6CCC\", source: \"Terminus Wrecker\" }\r\n1222.6 \"Aether Siphon\" #Ability { id: \"6239\", source: \"Terminus Wrecker\" }\r\n1231.9 \"Aether Spray (Bubble)\" #Ability { id: \"623B\", source: \"Terminus Wrecker\" }\r\n\r\n\r\n#~~~~~~~~~~~#\r\n# Svarbhanu #\r\n#~~~~~~~~~~~#\r\n\r\n# -p 6252:2010.1\r\n# -it \"Svarbhanu\"\r\n\r\n# TODO: is 624C \"--middle--\"?\r\n\r\n# I think this is when the floor panels disappear?\r\nhideall \"Crumbling Sky\"\r\n\r\n# Devatagara will be sealed off\r\n2000.0 \"--sync--\" SystemLogMessage { id: \"7DC\", param1: \"FAE\" } window 2000,0\r\n2005.1 \"--sync--\" StartsUsing { id: \"6252\", source: \"Svarbhanu\" } window 2020,10\r\n2010.1 \"Flames of Decay\" Ability { id: \"6252\", source: \"Svarbhanu\" }\r\n2018.0 \"Chaotic Pulse\" Ability { id: \"6B61\", source: \"Svarbhanu\" }\r\n2020.1 \"--sync--\" Ability { id: \"624C\", source: \"Svarbhanu\" }\r\n2027.0 \"Aetherial Disruption\" Ability { id: \"6248\", source: \"Svarbhanu\" }\r\n2027.9 \"Chaotic Undercurrent\" Ability { id: \"624A\", source: \"Svarbhanu\" }\r\n2034.6 \"Chaotic Pulse\" Ability { id: \"6B61\", source: \"Svarbhanu\" }\r\n2039.7 \"Crumbling Sky\" Ability { id: \"624E\", source: \"Svarbhanu\" }\r\n2041.9 \"--sync--\" Ability { id: \"624D\", source: \"Svarbhanu\" }\r\n2048.8 \"Aetherial Disruption\" Ability { id: \"6248\", source: \"Svarbhanu\" }\r\n2049.3 \"Cosmic Kiss (Spread)\" Ability { id: \"6250\", source: \"Svarbhanu\" }\r\n2049.7 \"Chaotic Undercurrent\" Ability { id: \"624B\", source: \"Svarbhanu\" }\r\n2061.1 \"Gnashing of Teeth\" Ability { id: \"6253\", source: \"Svarbhanu\" }\r\n2068.2 \"Chaotic Pulse\" Ability { id: \"6B61\", source: \"Svarbhanu\" }\r\n2073.3 \"Crumbling Sky\" Ability { id: \"624E\", source: \"Svarbhanu\" }\r\n2075.5 \"--sync--\" Ability { id: \"624C\", source: \"Svarbhanu\" }\r\n2080.4 \"Cosmic Kiss (Knockback)\" Ability { id: \"6251\", source: \"Svarbhanu\" }\r\n2082.4 \"Aetherial Disruption\" Ability { id: \"6248\", source: \"Svarbhanu\" }\r\n2083.3 \"Chaotic Undercurrent\" Ability { id: \"624A\", source: \"Svarbhanu\" }\r\n2094.4 \"Crumbling Sky\" Ability { id: \"624E\", source: \"Svarbhanu\" }\r\n\r\n2096.4 \"--untargetable--\"\r\n2105.2 \"--sync--\" Ability { id: \"6249\", source: \"Svarbhanu\" }\r\n2110.3 \"--sync--\" Ability { id: \"6249\", source: \"Svarbhanu\" }\r\n2110.7 \"--meteor 1--\" Ability { id: \"631E\", source: \"Svarbhanu\" }\r\n2114.5 \"Cosmic Kiss\" Ability { id: \"624F\", source: \"Svarbhanu\" }\r\n2115.4 \"--sync--\" Ability { id: \"6249\", source: \"Svarbhanu\" }\r\n2115.8 \"--meteor 2--\" Ability { id: \"631E\", source: \"Svarbhanu\" }\r\n2119.5 \"Cosmic Kiss\" Ability { id: \"624F\", source: \"Svarbhanu\" }\r\n2120.9 \"--meteor 3--\" Ability { id: \"631E\", source: \"Svarbhanu\" }\r\n2123.5 \"Cosmic Kiss\" Ability { id: \"624F\", source: \"Svarbhanu\" }\r\n2125.1 \"--targetable--\"\r\n\r\n2136.2 \"Flames of Decay\" Ability { id: \"6252\", source: \"Svarbhanu\" } window 100,10\r\n2143.4 \"Chaotic Pulse\" Ability { id: \"6B61\", source: \"Svarbhanu\" }\r\n2148.5 \"Crumbling Sky\" Ability { id: \"624E\", source: \"Svarbhanu\" }\r\n2150.7 \"--sync--\" Ability { id: \"624C\", source: \"Svarbhanu\" }\r\n2155.6 \"Cosmic Kiss (Knockback)\" Ability { id: \"6251\", source: \"Svarbhanu\" }\r\n2157.6 \"Aetherial Disruption\" Ability { id: \"6248\", source: \"Svarbhanu\" }\r\n2158.5 \"Chaotic Undercurrent\" Ability { id: \"624A\", source: \"Svarbhanu\" }\r\n2159.6 \"Cosmic Kiss (Spread)\" Ability { id: \"6250\", source: \"Svarbhanu\" }\r\n2169.8 \"Gnashing of Teeth\" Ability { id: \"6253\", source: \"Svarbhanu\" }\r\n\r\n2187.7 \"Flames of Decay\" Ability { id: \"6252\", source: \"Svarbhanu\" } window 30,30 jump 2136.2\r\n2194.9 \"Chaotic Pulse\" #Ability { id: \"6B61\", source: \"Svarbhanu\" }\r\n2200.0 \"Crumbling Sky\" #Ability { id: \"624E\", source: \"Svarbhanu\" }\r\n2202.2 \"--sync--\" #Ability { id: \"624C\", source: \"Svarbhanu\" }\r\n2207.1 \"Cosmic Kiss (Knockback)\" #Ability { id: \"6251\", source: \"Svarbhanu\" }\r\n2209.1 \"Aetherial Disruption\" #Ability { id: \"6248\", source: \"Svarbhanu\" }\r\n2210.0 \"Chaotic Undercurrent\" #Ability { id: \"624A\", source: \"Svarbhanu\" }\r\n2211.1 \"Cosmic Kiss (Spread)\" #Ability { id: \"6250\", source: \"Svarbhanu\" }\r\n2221.3 \"Gnashing of Teeth\" #Ability { id: \"6253\", source: \"Svarbhanu\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/hunts/elpis.ts



// TODO: Gurangatch Octuple Slammer rotation directions
// TODO: Gurangatch Wild Charge (6B77) gap closer, but appears to have no cast?
const elpis_triggerSet = {
  id: 'Elpis',
  zoneId: zone_id/* default.Elpis */.Z.Elpis,
  triggers: [{
    id: 'Hunt Gurangatch Left Hammer Slammer',
    type: 'StartsUsing',
    netRegex: {
      id: '6B65',
      source: 'Gurangatch',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goRightThenLeft */.n3.goRightThenLeft('alarm')
  }, {
    id: 'Hunt Gurangatch Right Hammer Slammer',
    type: 'StartsUsing',
    netRegex: {
      id: '6B66',
      source: 'Gurangatch',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goLeftThenRight */.n3.goLeftThenRight('alarm')
  }, {
    id: 'Hunt Gurangatch Bone Shaker',
    type: 'StartsUsing',
    netRegex: {
      id: '6B78',
      source: 'Gurangatch',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Petalodus Marine Mayhem',
    type: 'StartsUsing',
    netRegex: {
      id: '69B7',
      source: 'Petalodus'
    },
    condition: data => data.inCombat && data.CanSilence(),
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'Hunt Petalodus Tidal Guillotine',
    type: 'StartsUsing',
    netRegex: {
      id: '69BC',
      source: 'Petalodus',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Petalodus Ancient Blizzard',
    type: 'StartsUsing',
    netRegex: {
      id: '69BD',
      source: 'Petalodus',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Hunt Petalodus Waterga IV',
    type: 'StartsUsing',
    netRegex: {
      id: '69BB',
      source: 'Petalodus'
    },
    condition: data => data.inCombat,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        waterOnYou: {
          en: 'GTFO with water',
          de: 'Geh mit Wasser raus',
          fr: 'Partez avec l\'eau',
          ja: 'ボスから離れる',
          cn: '快躲开水',
          ko: '나에게 물징 멀리 빠지기'
        },
        waterMarker: {
          en: 'Away from water marker',
          de: 'Weg vom Wasser Marker',
          fr: 'Éloignez-vous du marquage eau',
          ja: 'AOEから離れる',
          cn: '躲开水标记',
          ko: '물징에서 멀리 떨어지기'
        }
      };
      if (data.me === matches.target) return {
        alarmText: output.waterOnYou()
      };
      return {
        alertText: output.waterMarker()
      };
    }
  }, {
    id: 'Hunt Ophioneus Scratch',
    type: 'StartsUsing',
    netRegex: {
      id: '6AD4',
      source: 'Ophioneus'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'Hunt Ophioneus Right Maw',
    type: 'StartsUsing',
    netRegex: {
      id: '6AD6',
      source: 'Ophioneus',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Hunt Ophioneus Left Maw',
    type: 'StartsUsing',
    netRegex: {
      id: '6AD7',
      source: 'Ophioneus',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Hunt Ophioneus Pyric Circle',
    type: 'StartsUsing',
    netRegex: {
      id: '6AD8',
      source: 'Ophioneus',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Hunt Ophioneus Pyric Burst',
    type: 'StartsUsing',
    netRegex: {
      id: '6AD9',
      source: 'Ophioneus',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Ophioneus Leaping Pyric Circle',
    type: 'StartsUsing',
    // Followed by a 6AD2 fast cast.
    netRegex: {
      id: '6ACD',
      source: 'Ophioneus',
      capture: false
    },
    condition: data => data.inCombat,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Follow Jump => Under',
        de: 'Sprung folgen => Unter den Boss',
        fr: 'Suivre le saut => Sous le boss',
        ja: 'ジャンプ近づく => 下へ',
        cn: '跟随跳跃 => 脚下',
        ko: '점프 따라가기 => 보스 아래로'
      }
    }
  }, {
    id: 'Hunt Ophioneus Leaping Pyric Burst',
    type: 'StartsUsing',
    // Followed by a 6AD3 fast cast.
    netRegex: {
      id: '6ACE',
      source: 'Ophioneus',
      capture: false
    },
    condition: data => data.inCombat,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away From Jump',
        de: 'Weg vom Sprung',
        fr: 'Loin du saut',
        ja: 'ジャンプから離れる',
        cn: '远离跳跃',
        ko: '점프뛴 곳에서 멀리 떨어지기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Gurangatch': 'Gurangatch',
      'Ophioneus': 'Ophioneus',
      'Petalodus': 'Petalodus'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Gurangatch': 'Gurangatch',
      'Ophioneus': 'Ophion',
      'Petalodus': 'petalodus'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Gurangatch': 'グランガチ',
      'Ophioneus': 'オピオネウス',
      'Petalodus': 'ペタロドゥス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Gurangatch': '固兰盖奇',
      'Ophioneus': '俄菲翁尼厄斯',
      'Petalodus': '瓣齿鲨'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Gurangatch': '구랑가치',
      'Ophioneus': '오피오네우스',
      'Petalodus': '페탈로두스'
    }
  }]
};
/* harmony default export */ const elpis = (elpis_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/hunts/garlemald.ts


// TODO: Minerva Hammer Knuckles tankbuster
// TODO: Minerva Sonic Amplifier aoe
const garlemald_triggerSet = {
  id: 'Garlemald',
  zoneId: zone_id/* default.Garlemald */.Z.Garlemald,
  triggers: [{
    id: 'Hunt Aegeiros Leafstorm',
    type: 'StartsUsing',
    // This always precedes Rimestorm (6C3D).
    netRegex: {
      id: '6C3C',
      source: 'Aegeiros',
      capture: false
    },
    condition: data => data.inCombat,
    // Alarm text mostly because this one kills so many people.
    alarmText: (_data, _matches, output) => output.outAndBehind(),
    outputStrings: {
      outAndBehind: {
        en: 'Get Behind and Out',
        de: 'Geh hinter ihn und dann raus',
        fr: 'Passez derrière et à l\'extérieur',
        ja: '後ろの外側へ',
        cn: '去背后',
        ko: '뒤로 그리고 밖으로'
      }
    }
  }, {
    id: 'Hunt Aegeiros Backhand Blow',
    type: 'StartsUsing',
    netRegex: {
      id: '6C40',
      source: 'Aegeiros',
      capture: false
    },
    condition: data => data.inCombat,
    alertText: (_data, _matches, output) => output.getFront(),
    outputStrings: {
      getFront: {
        en: 'Get Front',
        de: 'Geh nach Vorne',
        fr: 'Allez devant',
        ja: '前へ',
        cn: '去正面',
        ko: '앞으로'
      }
    }
  }, {
    id: 'Hunt Minerva Anti-personnel Build Ballistic Missile',
    type: 'StartsUsing',
    netRegex: {
      id: '6B7D',
      source: 'Minerva'
    },
    condition: data => data.inCombat,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        missleOnYou: {
          en: 'GTFO with marker',
          de: 'Geh raus mit dem Marker',
          fr: 'Partez avec le marquage',
          ja: 'ボスから離れる',
          cn: '快躲开标记',
          ko: '나에게 징 멀리 빠지기'
        },
        missleMarker: {
          en: 'Away from marker',
          de: 'Weg vom Marker',
          fr: 'Éloignez-vous du marquage',
          ja: 'マーカー付きから離れる',
          cn: '躲开标记',
          ko: '징에서 멀리 떨어지기'
        }
      };
      if (data.me === matches.target) return {
        alarmText: output.missleOnYou()
      };
      return {
        alertText: output.missleMarker()
      };
    }
  }, {
    id: 'Hunt Minerva Ring Build Ballistic Missile',
    type: 'StartsUsing',
    netRegex: {
      id: '6B7E',
      source: 'Minerva'
    },
    condition: data => data.inCombat,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        missleOnYou: {
          en: 'Place donut marker under',
          de: 'Platziere Donut-Marker unter ihm',
          fr: 'En dessous le marquage du donut',
          ja: 'ボスから離れる',
          cn: '放置环形标记',
          ko: '나에게 도넛 장판'
        },
        missleMarker: {
          en: 'Stack on marker',
          de: 'Auf dem Marker sammeln',
          fr: 'Packez-vous sur les marquages',
          ja: 'マーカー付きから離れる',
          cn: '标记处集合',
          ko: '도넛징 대상자에게 붙기'
        }
      };
      if (data.me === matches.target) return {
        alarmText: output.missleOnYou()
      };
      return {
        alertText: output.missleMarker()
      };
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aegeiros': 'Aegeiros',
      'Minerva': 'Minerva'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aegeiros': 'ægeiros',
      'Minerva': 'Minerva'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aegeiros': 'アイゲイロス',
      'Minerva': 'ミネルウァ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aegeiros': '黑杨树精',
      'Minerva': '密涅瓦'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aegeiros': '아이게이로스',
      'Minerva': '미네르바'
    }
  }]
};
/* harmony default export */ const garlemald = (garlemald_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/hunts/labyrinthos.ts


const labyrinthos_triggerSet = {
  id: 'Labyrinthos',
  zoneId: zone_id/* default.Labyrinthos */.Z.Labyrinthos,
  triggers: [{
    id: 'Hunt Hulder Lay of Mislaid Memory',
    type: 'StartsUsing',
    netRegex: {
      id: '69C1',
      source: 'Hulder',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.awayFromFront */.n3.awayFromFront('info')
  }, {
    id: 'Hunt Hulder Tempestuous Wrath',
    type: 'StartsUsing',
    netRegex: {
      id: '69C3',
      source: 'Hulder',
      capture: false
    },
    condition: data => data.inCombat,
    infoText: (_data, _matches, output) => output.followCharge(),
    outputStrings: {
      followCharge: {
        en: 'Follow charge',
        de: 'Folge dem Ansturm',
        fr: 'Suivez la charge',
        ja: 'ボス従う',
        cn: '跟随冲锋',
        ko: '돌진 따라가기'
      }
    }
  }, {
    id: 'Hunt Hulder Rotting Elegy',
    type: 'StartsUsing',
    netRegex: {
      id: '69C4',
      source: 'Hulder',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getUnder */.n3.getUnder('alert')
  }, {
    id: 'Hunt Hulder Storm of Color',
    type: 'StartsUsing',
    netRegex: {
      id: '69C6',
      source: 'Hulder'
    },
    condition: data => data.inCombat,
    // Not a cleave.
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'Hunt Hulder Ode to Lost Love',
    type: 'StartsUsing',
    netRegex: {
      id: '69C5',
      source: 'Hulder',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Storsie Fang\'s End',
    type: 'StartsUsing',
    netRegex: {
      id: '6AE1',
      source: 'Storsie'
    },
    condition: data => data.inCombat,
    // Not a cleave.
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'Hunt Storsie Earth Aspect',
    type: 'Ability',
    // Before Earth Auger (6AE0).
    netRegex: {
      id: '6ADA',
      source: 'Storsie',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Storsie Wind Aspect',
    type: 'Ability',
    // Before Whorlstorm (6ADE).
    netRegex: {
      id: '6ADB',
      source: 'Storsie',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Hunt Storsie Lightning Aspect',
    type: 'Ability',
    // Before Defibrillate (6ADF).
    netRegex: {
      id: '6ADC',
      source: 'Storsie',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Hulder': 'Hulder',
      'Storsie': 'Storsie'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Hulder': 'huldre',
      'Storsie': 'Storsie'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Hulder': 'フルドラ',
      'Storsie': 'ストーシー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Hulder': '胡睹',
      'Storsie': '斯图希'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Hulder': '훌드라',
      'Storsie': '스토르시에'
    }
  }]
};
/* harmony default export */ const labyrinthos = (labyrinthos_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/hunts/mare_lamentorum.ts



const mare_lamentorum_triggerSet = {
  id: 'MareLamentorum',
  zoneId: zone_id/* default.MareLamentorum */.Z.MareLamentorum,
  resetWhenOutOfCombat: false,
  initData: () => {
    return {
      chitinous: []
    };
  },
  triggers: [{
    id: 'Hunt Lunatender Queen Away With You',
    type: 'StartsUsing',
    netRegex: {
      id: '6AE5',
      source: 'Lunatender Queen',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Lunatender Queen Away With You Whim',
    type: 'StartsUsing',
    netRegex: {
      id: '6AEB',
      source: 'Lunatender Queen',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Hunt Lunatender Queen You May Approach',
    type: 'StartsUsing',
    netRegex: {
      id: '6AE4',
      source: 'Lunatender Queen',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Hunt Lunatender Queen You May Approach Whim',
    type: 'StartsUsing',
    netRegex: {
      id: '6AEA',
      source: 'Lunatender Queen',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Lunatender Queen Avert Your Eyes',
    type: 'StartsUsing',
    netRegex: {
      id: '6AE3',
      source: 'Lunatender Queen',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Hunt Lunatender Queen Avert Your Eyes Whim',
    type: 'StartsUsing',
    netRegex: {
      id: '6AE9',
      source: 'Lunatender Queen',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.lookTowards */.n3.lookTowards()
  }, {
    id: 'Hunt Lunatender Queen 999,000 Needles',
    type: 'StartsUsing',
    netRegex: {
      id: '6AE6',
      source: 'Lunatender Queen',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.outOfMelee */.n3.outOfMelee()
  }, {
    id: 'Hunt Mousse Princess Rightward Whimsy',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B18',
      source: 'Mousse Princess',
      capture: false
    },
    condition: data => data.inCombat,
    durationSeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from Right Flank',
        de: 'Weg von der rechten Flanke',
        fr: 'Éloignez-vous du flanc droit',
        ja: '右が危険',
        cn: '远离右侧',
        ko: '보스 오른쪽 피하기'
      }
    }
  }, {
    id: 'Hunt Mousse Princess Backward Whimsy',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B1A',
      source: 'Mousse Princess',
      capture: false
    },
    condition: data => data.inCombat,
    durationSeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from Back',
        de: 'Weg von hinter ihr',
        fr: 'Éloignez-vous de l\'arrière',
        ja: '後ろが危険',
        cn: '远离后方',
        ko: '보스 뒤 피하기'
      }
    }
  }, {
    id: 'Hunt Mousse Princess Leftward Whimsy',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B19',
      source: 'Mousse Princess',
      capture: false
    },
    condition: data => data.inCombat,
    durationSeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from Left Flank',
        de: 'Weg von der linker Flanke',
        fr: 'Éloignez-vous du flanc gauche',
        ja: '左が危険',
        cn: '远离左侧',
        ko: '보스 왼쪽 피하기'
      }
    }
  }, {
    id: 'Hunt Mousse Princess Forward Whimsy',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B8E',
      source: 'Mousse Princess',
      capture: false
    },
    condition: data => data.inCombat,
    durationSeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from Front',
        de: 'Weg von Vorne',
        fr: 'Éloignez-vous du devant',
        ja: '前方が危険',
        cn: '远离前方',
        ko: '보스 앞 피하기'
      }
    }
  }, {
    id: 'Hunt Mousse Princess Banish',
    type: 'StartsUsing',
    netRegex: {
      id: '6ABB',
      source: 'Mousse Princess'
    },
    condition: data => data.inCombat,
    // Doesn't cleave (I think?).
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'Hunt Mousse Princess Amorphic Flail',
    type: 'StartsUsing',
    netRegex: {
      id: '6AB9',
      source: 'Mousse Princess',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.outOfMelee */.n3.outOfMelee()
  }, {
    // Note: "out" here means "get out", and "in" means "get in"
    // There's a Trace cast, followed by a number of indicators,
    // then an Advance/Reversal cast (which is the first set of damage)
    // followed by several instant damage casts, e.g.
    //
    //   68FA/68FC/68FD/68FC/68FC => 6923/6637/6638/6637
    //   ... means the following:
    //   68FA (trace, first out), 68FC (out), 68FD (in), 68FC (out), 68FC (in)
    //   6923 (reversal cast/in) -> 6637 (out) -> 6638 (in) -> 6637 (out)
    //
    // Casts:
    // 68FA = chitinous trace, first indicator is out (68FC)
    // 68FB = chitinous trace, first indicator is in (68FD)
    // 68FC = "get out" indicator
    // 68FD = "get in" indicator
    //
    // Casts that do damage:
    // 68FE = chitinous advance out first
    // 68FF = chitinous advance in first
    // 6923 = chitinous reversal out first
    // 6924 = chitinous reversal in first
    //
    // Instant Abilities:
    // 6637 = out (reversal)
    // 6638 = in (reversal)
    // 6900 = out (advance)
    // 6901 = in (advance)
    id: 'Hunt Ruminator Chitinous Trace',
    type: 'StartsUsing',
    netRegex: {
      id: ['68FA', '68FB'],
      source: 'Ruminator',
      capture: false
    },
    run: data => data.chitinous = []
  }, {
    id: 'Hunt Ruminator Chitinous Trace Out',
    type: 'StartsUsing',
    netRegex: {
      id: '68FC',
      source: 'Ruminator',
      capture: false
    },
    run: data => data.chitinous.push('out')
  }, {
    id: 'Hunt Ruminator Chitinous Trace In',
    type: 'StartsUsing',
    netRegex: {
      id: '68FD',
      source: 'Ruminator',
      capture: false
    },
    run: data => data.chitinous.push('in')
  }, {
    id: 'Hunt Ruminator Chitinous Reversal',
    type: 'StartsUsing',
    netRegex: {
      id: ['6923', '6924'],
      source: 'Ruminator',
      capture: false
    },
    run: data => data.chitinous.reverse()
  }, {
    id: 'Hunt Ruminator Chitinous All Dirs',
    type: 'StartsUsing',
    netRegex: {
      id: ['68FE', '68FF', '6923', '6924'],
      source: 'Ruminator',
      capture: false
    },
    // TODO: maybe figure out the duration from the length?
    durationSeconds: 5,
    sound: '',
    infoText: (data, _matches, output) => {
      if (data.chitinous.length === 0) return;
      if (!data.inCombat) return;
      return data.chitinous.map(x => output[x]()).join(output.joiner());
    },
    tts: null,
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      in: outputs/* default.in */.Z["in"],
      joiner: {
        en: ' => ',
        de: ' => ',
        fr: ' => ',
        ja: ' => ',
        cn: ' => ',
        ko: ' => '
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'Hunt Ruminator Chitinous Initial',
    type: 'StartsUsing',
    netRegex: {
      id: ['68FE', '68FF', '6923', '6924'],
      source: 'Ruminator',
      capture: false
    },
    alertText: (data, _matches, output) => {
      // TODO: should we verify that 68FE/6923 are out and 68FF/6924 are in?
      const key = data.chitinous.shift() ?? 'unknown';
      if (!data.inCombat) return;
      return output[key]();
    },
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      in: outputs/* default.in */.Z["in"],
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'Hunt Ruminator Chitinous Step',
    type: 'Ability',
    netRegex: {
      id: ['68FE', '68FF', '6923', '6924', '6637', '6638', '6900', '6901'],
      source: 'Ruminator',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      // Skip the last one.
      const key = data.chitinous.shift();
      if (!key) return;
      if (!data.inCombat) return;
      return output[key]();
    },
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      in: outputs/* default.in */.Z["in"]
    }
  }, {
    id: 'Hunt Ruminator Stygian Vapor',
    type: 'StartsUsing',
    netRegex: {
      id: '6902',
      source: 'Ruminator',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Lunatender Queen': 'Lunatender-Königin',
      'Mousse Princess': 'Mousse-Prinzessin',
      'Ruminator': 'Grübler'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Lunatender Queen': 'pampa sélénienne reine',
      'Mousse Princess': 'princesse mousse',
      'Ruminator': 'ruminateur'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Lunatender Queen': 'ルナテンダー・クイーン',
      'Mousse Princess': 'ムースプリンセス',
      'Ruminator': 'ルミネイター'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Lunatender Queen': '月面仙人刺女王',
      'Mousse Princess': '慕斯公主',
      'Ruminator': '沉思之物'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Lunatender Queen': '루나텐더 여왕',
      'Mousse Princess': '무스 공주',
      'Ruminator': '되새기는 자'
    }
  }]
};
/* harmony default export */ const mare_lamentorum = (mare_lamentorum_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/hunts/ss_rank.ts


// TODO:
// Ancient Flare is probably 6FB6?, Pyretic debuff effect is ?
// Whispered Incantation + Whispers Manifest
// Handle Mirrored Incantation + Interments
const hunts_ss_rank_triggerSet = {
  id: 'HuntEWSS',
  zoneId: [zone_id/* default.Labyrinthos */.Z.Labyrinthos, zone_id/* default.Thavnair */.Z.Thavnair, zone_id/* default.Garlemald */.Z.Garlemald, zone_id/* default.MareLamentorum */.Z.MareLamentorum, zone_id/* default.Elpis */.Z.Elpis, zone_id/* default.UltimaThule */.Z.UltimaThule],
  zoneLabel: {
    en: 'SS Rank Hunts',
    de: 'SS Jagdziele',
    fr: 'Objectifs de chasse SS',
    ja: 'SSモブ',
    cn: 'SS 级狩猎怪',
    ko: 'SS급 마물'
  },
  triggers: [{
    id: 'Hunt Ker Heliovoid',
    type: 'StartsUsing',
    netRegex: {
      id: '6BF4',
      source: 'Ker',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.outOfMelee */.n3.outOfMelee()
  }, {
    id: 'Hunt Ker Ancient Blizzard III',
    type: 'StartsUsing',
    netRegex: {
      id: '6BF5',
      source: 'Ker',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Hunt Ker Eternal Damnation',
    type: 'StartsUsing',
    netRegex: {
      id: '6BFF',
      source: 'Ker',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'Hunt Ker Ancient Holy',
    type: 'StartsUsing',
    netRegex: {
      id: '6BFE',
      source: 'Ker',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Ker Fore Interment',
    type: 'StartsUsing',
    netRegex: {
      id: '6BF9',
      source: 'Ker',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Ker Rear Interment',
    type: 'StartsUsing',
    netRegex: {
      id: '6BFA',
      source: 'Ker',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goFront */.n3.goFront()
  }, {
    id: 'Hunt Ker Right Interment',
    type: 'StartsUsing',
    netRegex: {
      id: '6BFB',
      source: 'Ker',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Hunt Ker Left Interment',
    type: 'StartsUsing',
    netRegex: {
      id: '6BFC',
      source: 'Ker',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goRight */.n3.goRight()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Ker': 'Ker'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ker': 'Kèr'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ker': 'ケール'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ker': '克尔'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ker': '케르'
    }
  }]
};
/* harmony default export */ const hunts_ss_rank = (hunts_ss_rank_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/hunts/thavnair.ts





// TODO: Yilan Bog Bomb (6A61) untelegraphed circle on a random target (can this be called?)

// TODO: promote something like this to Conditions?
const thavnair_tankBusterOnParty = (data, matches) => {
  if (matches.target === data.me) return true;
  if (data.role !== 'healer') return false;
  return data.party.inParty(matches.target);
};
const thavnair_triggerSet = {
  id: 'Thavnair',
  zoneId: zone_id/* default.Thavnair */.Z.Thavnair,
  resetWhenOutOfCombat: false,
  initData: () => {
    return {
      sphatikaBearing: []
    };
  },
  triggers: [{
    id: 'Hunt Sugriva Spark',
    type: 'StartsUsing',
    netRegex: {
      id: '6A55',
      source: 'Sugriva',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Hunt Sugriva Scythe Tail',
    type: 'StartsUsing',
    netRegex: {
      id: '6A56',
      source: 'Sugriva',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Sugriva Twister',
    type: 'StartsUsing',
    netRegex: {
      id: '6A53',
      source: 'Sugriva',
      capture: false
    },
    condition: data => data.inCombat,
    infoText: (_data, _matches, output) => output.knockbackStack(),
    outputStrings: {
      knockbackStack: {
        en: 'Knockback Stack',
        de: 'Rückstoß sammeln',
        fr: 'Package + Poussée',
        ja: 'ノックバック＋頭割り',
        cn: '集合击退',
        ko: '넉백 + 쉐어'
      }
    }
  }, {
    id: 'Hunt Sugriva Butcher',
    type: 'StartsUsing',
    // This is followed up with Rip (6A58) which is also a tank cleave.
    // We could call out 2x tank cleave, but maybe that's overkill.
    netRegex: {
      id: '6A57',
      source: 'Sugriva'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Hunt Sugriva Rock Throw',
    type: 'StartsUsing',
    // One telegraphed circle in front, then some untelegraphed ones.
    netRegex: {
      id: '6A59',
      source: 'Sugriva',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Sugriva Crosswind',
    type: 'StartsUsing',
    netRegex: {
      id: '6A5B',
      source: 'Sugriva',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Yilan Forward March',
    type: 'GainsEffect',
    netRegex: {
      effectId: '7A6',
      source: 'Yilan'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // t=0.0 gain effect (this line)
    // t=6.3 Mini Light starts casting
    // t=9.0 lose effect (forced march)
    // t=12.3 Mini Light ability
    // Full duration is 9s, but have seen this apply late for ~7 to some people.
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Forward March Away',
        de: 'Geistlenkung vorwärts',
        fr: 'Marche forcée en avant',
        ja: '強制移動：前',
        cn: '强制移动: 前',
        ko: '강제이동: 앞'
      }
    }
  }, {
    id: 'Hunt Yilan About Face',
    type: 'GainsEffect',
    netRegex: {
      effectId: '7A7',
      source: 'Yilan'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Backwards March Away',
        de: 'Geistlenkung rückwärts',
        fr: 'Marche forcée en arrière',
        ja: '強制移動：後ろ',
        cn: '强制移动: 后',
        ko: '강제이동: 뒤'
      }
    }
  }, {
    id: 'Hunt Yilan Left Face',
    type: 'GainsEffect',
    netRegex: {
      effectId: '7A8',
      source: 'Yilan'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Left March Away',
        de: 'Geistlenkung links',
        fr: 'Marche forcée à gauche',
        ja: '強制移動：左',
        cn: '强制移动: 左',
        ko: '강제이동: 왼쪽'
      }
    }
  }, {
    id: 'Hunt Yilan Right Face',
    type: 'GainsEffect',
    netRegex: {
      effectId: '7A9',
      source: 'Yilan'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Right March Away',
        de: 'Geistlenkung rechts',
        fr: 'Marche forcée à droite',
        ja: '強制移動：右',
        cn: '强制移动: 右',
        ko: '강제이동: 오른쪽'
      }
    }
  }, {
    id: 'Hunt Yilan Brackish Rain',
    type: 'StartsUsing',
    // Untelegraphed conal attack.
    netRegex: {
      id: '6A62',
      source: 'Yilan',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Yilan Mini Light',
    type: 'StartsUsing',
    netRegex: {
      id: '6A5F',
      source: 'Yilan',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Sphatika Gnaw',
    type: 'StartsUsing',
    netRegex: {
      id: '6BE1',
      source: 'Sphatika'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Hunt Sphatika Caterwaul',
    type: 'StartsUsing',
    netRegex: {
      id: '6BE3',
      source: 'Sphatika',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Sphatika Brace Init',
    type: 'StartsUsing',
    // brace ability ids:
    //   6BE4 = Forward Bearing => Backward Bearing
    //   6BE5 = Forward Bearing => Leftward Bearing
    //   6BE6 = Backward Bearing => Rightward Bearing
    //   6BE7 = Leftward Bearing => Rightward Bearing
    //
    // effect ids:
    //   B13 = Forward Bearing (down arrow)
    //   B14 = Backward Bearing (up arrow)
    //   B15 = Leftward Bearing (right arrow)
    //   B16 = Rightward Bearing (left arrow)
    //
    // The order of effect id lines in the log is not the same as the order of them applying.
    // It is somewhat non-deterministic and could be in either ordering.
    // However, it seems that the effect ids are sorted lowest->highest on the buff bar,
    // so that the lowest id will always go off first.
    //
    // The strategy is to read arrow images (not bearing names) left to right on the buff bar.
    // First arrow dir, then first arrow opposite, then second arrow dir, then second arrow opposite.
    // If it is Whiplick, then you do the reverse of the directions of the arrow images.
    // See: https://www.twitch.tv/asinametra/clip/ExquisiteNurturingPeanutBIRB-i4NMmHjZNjai5xP-
    netRegex: {
      id: ['6BE4', '6BE5', '6BE6', '6BE7'],
      source: 'Sphatika'
    },
    run: (data, matches) => {
      const bearingMap = {
        '6BE4': ['back', 'front', 'front', 'back'],
        '6BE5': ['back', 'front', 'right', 'left'],
        '6BE6': ['front', 'back', 'left', 'right'],
        '6BE7': ['right', 'left', 'left', 'right']
      };
      data.sphatikaBearing = bearingMap[matches.id] ?? [];
    }
  }, {
    id: 'Hunt Sphatika Whiplick Reverse',
    type: 'StartsUsing',
    netRegex: {
      id: '6BE9',
      source: 'Sphatika',
      capture: false
    },
    run: data => {
      // Whiplick does the directions in reverse, so reverse here so we can have a single logic path.
      data.sphatikaBearing = data.sphatikaBearing.map(x => {
        if (x === 'front') return 'back';
        if (x === 'back') return 'front';
        if (x === 'left') return 'right';
        return 'left';
      });
    }
  }, {
    id: 'Hunt Sphatika Stance All Dirs',
    type: 'StartsUsing',
    // 6BE8 = Lickwhip Stance
    // 6BE9 = Whiplick Stance
    netRegex: {
      id: ['6BE8', '6BE9'],
      source: 'Sphatika',
      capture: false
    },
    durationSeconds: 10,
    sound: '',
    infoText: (data, _matches, output) => {
      const [dir1, dir2, dir3, dir4] = data.sphatikaBearing;
      if (dir1 === undefined || dir2 === undefined || dir3 === undefined || dir4 === undefined) return;
      if (!data.inCombat) return;
      return output.text({
        dir1: output[dir1](),
        dir2: output[dir2](),
        dir3: output[dir3](),
        dir4: output[dir4]()
      });
    },
    tts: null,
    outputStrings: {
      front: outputs/* default.front */.Z.front,
      back: outputs/* default.back */.Z.back,
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      text: {
        en: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        de: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        fr: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        ja: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        cn: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        ko: '${dir1} => ${dir2} => ${dir3} => ${dir4}'
      }
    }
  }, {
    id: 'Hunt Sphatika Stance Initial',
    type: 'StartsUsing',
    // 6BE8 = Lickwhip Stance
    // 6BE9 = Whiplick Stance
    netRegex: {
      id: ['6BE8', '6BE9'],
      source: 'Sphatika',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const key = data.sphatikaBearing.shift();
      if (key === undefined) return;
      if (!data.inCombat) return;
      return output[key]();
    },
    outputStrings: {
      front: outputs/* default.front */.Z.front,
      back: outputs/* default.back */.Z.back,
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right
    }
  }, {
    id: 'Hunt Sphatika Stance Step',
    type: 'StartsUsing',
    // 6BEE, 6BEF, 6BF0, 6BF1, 6C43 = Hind Whip
    // 6BEA, 6BEB, 6BEC, 6BED, 6C42 = Long Lick
    netRegex: {
      id: ['6BE[A-F]', '6BF[01]', '6C4[23]'],
      source: 'Sphatika',
      capture: false
    },
    alertText: (data, _matches, output) => {
      const key = data.sphatikaBearing.shift();
      if (key === undefined) return;
      if (!data.inCombat) return;
      return output[key]();
    },
    outputStrings: {
      front: outputs/* default.front */.Z.front,
      back: outputs/* default.back */.Z.back,
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right
    }
  },
  // ---------------- Daivadipa Boss FATE ----------------
  {
    id: 'Hunt Daivadipa Drumbeat',
    type: 'StartsUsing',
    netRegex: {
      id: '678E',
      source: 'Daivadipa'
    },
    condition: thavnair_tankBusterOnParty,
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Hunt Daivadipa Cosmic Weave',
    type: 'StartsUsing',
    netRegex: {
      id: '6791',
      source: 'Daivadipa',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Daivadipa Infernal Redemption',
    type: 'StartsUsing',
    netRegex: {
      id: '6795',
      source: 'Daivadipa',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Daivadipa Leftward Trisula',
    type: 'StartsUsing',
    netRegex: {
      id: '678C',
      source: 'Daivadipa',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Hunt Daivadipa Rightward Parasu',
    type: 'StartsUsing',
    netRegex: {
      id: '678D',
      source: 'Daivadipa',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Hunt Daivadipa Divine Call',
    type: 'GainsEffect',
    // combos with other mechanics
    // limit to how many players are affected per cast
    // 7A6 = Forward March
    // 7A7 = About Face
    // 7A8 = Left Face
    // 7A9 = Right Face
    netRegex: {
      effectId: '7A[6-9]'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: (_data, matches) => parseFloat(matches.duration),
    infoText: (_data, matches, output) => {
      const effectId = matches.effectId.toUpperCase();
      if (effectId === '7A6') return output.forward();
      if (effectId === '7A7') return output.backward();
      if (effectId === '7A8') return output.left();
      if (effectId === '7A9') return output.right();
    },
    outputStrings: {
      forward: {
        en: 'Forward March',
        de: 'Geistlenkung vorwärts',
        fr: 'Marche avant',
        ja: '強制移動: 前',
        cn: '强制移动: 前',
        ko: '강제이동: 앞'
      },
      backward: {
        en: 'Backward March',
        de: 'Geistlenkung rückwärts',
        fr: 'Marche arrière',
        ja: '強制移動: 後ろ',
        cn: '强制移动: 后',
        ko: '강제이동: 뒤'
      },
      left: {
        en: 'Left March',
        de: 'Geistlenkung links',
        fr: 'Marche à gauche',
        ja: '強制移動: 左',
        cn: '强制移动: 左',
        ko: '강제이동: 왼쪽'
      },
      right: {
        en: 'Right March',
        de: 'Geistlenkung rechts',
        fr: 'Marche à droite',
        ja: '強制移動: 右',
        cn: '强制移动: 右',
        ko: '강제이동: 오른쪽'
      }
    }
  }, {
    id: 'Hunt Daivadipa Loyal Flame',
    type: 'StartsUsing',
    // 6782 = Red flames go first
    // 6783 = Blue flames go first
    netRegex: {
      id: '678[23]',
      source: 'Daivadipa'
    },
    condition: data => data.inCombat,
    alertText: (_data, matches, output) => {
      const id = matches.id.toUpperCase();
      if (id === '6782') return output.red();
      if (id === '6783') return output.blue();
    },
    outputStrings: {
      red: {
        en: 'Blue => Red',
        de: 'Blau => Rot',
        fr: 'Bleu => Rouge',
        ja: '青 => 赤',
        cn: '蓝 => 红',
        ko: '파랑 => 빨강'
      },
      blue: {
        en: 'Red => Blue',
        de: 'Rot => Blau',
        fr: 'Rouge => Bleu',
        ja: '赤 => 青',
        cn: '红 => 蓝',
        ko: '빨강 => 파랑'
      }
    }
  }, {
    id: 'Hunt Daivadipa Karmic Flames',
    type: 'StartsUsing',
    // proximity AoE from center of arena
    netRegex: {
      id: '6793',
      source: 'Daivadipa',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Daivadipa Errant Akasa',
    type: 'StartsUsing',
    netRegex: {
      id: '6792',
      source: 'Daivadipa',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Daivadipa': 'Daivadipa',
      'Sphatika': 'Sphatika',
      'Sugriva': 'Sugriva',
      'Yilan': 'Yilan'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Daivadipa': 'Daivadipa',
      'Sphatika': 'Sphatika',
      'Sugriva': 'Sugriva',
      'Yilan': 'yilan'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Daivadipa': 'ダイヴァディーパ',
      'Sphatika': 'スパティカ',
      'Sugriva': 'スグリーヴァ',
      'Yilan': 'ユラン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Daivadipa': '明灯天王',
      'Sphatika': '颇胝迦',
      'Sugriva': '须羯里婆',
      'Yilan': '尤兰'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Daivadipa': '다이바디파',
      'Sphatika': '스파티카',
      'Sugriva': '수그리바',
      'Yilan': '윌란'
    }
  }]
};
/* harmony default export */ const thavnair = (thavnair_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/hunts/ultima_thule.ts


// TODO: Narrow-rift Continual Meddling
// Continual Meddling = 6AC0, applies two of these, one 7 one 10 second, about ~1s before Empty Refrain cast:
//   7A6 = Forward March
//   7A7 = About Face
//   7A8 = Left Face
//   7A9 = Right Face
// TODO: Chi Bunker Buster
// TODO: Chi Bouncing Bomb
const ultima_thule_triggerSet = {
  id: 'UltimaThule',
  zoneId: zone_id/* default.UltimaThule */.Z.UltimaThule,
  triggers: [{
    id: 'Hunt Arch-Eta Energy Wave',
    type: 'StartsUsing',
    netRegex: {
      id: '6A85',
      source: 'Arch-Eta',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Hunt Arch-Eta Sonic Howl',
    type: 'StartsUsing',
    netRegex: {
      id: '6A88',
      source: 'Arch-Eta',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Arch-Eta Tail Swipe',
    type: 'StartsUsing',
    netRegex: {
      id: '6A86',
      source: 'Arch-Eta',
      capture: false
    },
    condition: data => data.inCombat,
    alertText: (_data, _matches, output) => output.getFront(),
    outputStrings: {
      getFront: {
        en: 'Get Front',
        de: 'Geh nach Vorne',
        fr: 'Allez devant',
        ja: '前へ',
        cn: '去正面',
        ko: '앞으로'
      }
    }
  }, {
    id: 'Hunt Arch-Eta Fanged Lunge',
    type: 'Ability',
    // Before Heavy Stomp (6A87) cast.
    netRegex: {
      id: '6A8A',
      source: 'Arch-Eta',
      capture: false
    },
    condition: data => data.inCombat,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from jump',
        de: 'Weg vom Sprung',
        fr: 'Éloignez-vous du saut',
        ja: '着地点から離れる',
        cn: '躲开跳跃',
        ko: '점프뛴 곳에서 멀리 떨어지기'
      }
    }
  }, {
    id: 'Hunt Arch-Eta Steel Fang',
    type: 'StartsUsing',
    netRegex: {
      id: '6A89',
      source: 'Arch-Eta'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'Hunt Fan Ail Cyclone Wing',
    type: 'StartsUsing',
    netRegex: {
      id: '6AF4',
      source: 'Fan Ail',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Fan Ail Plummet',
    type: 'StartsUsing',
    netRegex: {
      id: '6AF2',
      source: 'Fan Ail',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Hunt Fan Ail Divebomb',
    type: 'StartsUsing',
    netRegex: {
      id: '6AED',
      source: 'Fan Ail',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Hunt Fan Ail Death Sentence',
    type: 'StartsUsing',
    netRegex: {
      id: '6AF3',
      source: 'Fan Ail'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.tankBuster */.n3.tankBuster('info')
  }, {
    id: 'Hunt Narrow-rift Empty Promise Donut',
    type: 'StartsUsing',
    netRegex: {
      id: '6B60',
      source: 'Narrow-rift',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Hunt Narrow-rift Empty Promise Circle',
    type: 'StartsUsing',
    netRegex: {
      id: '6B5F',
      source: 'Narrow-rift',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Hunt Narrow-rift Vanishing Ray',
    type: 'Ability',
    // An unknown single-target ability that preceeds Vanishing Ray with no cast bar.
    netRegex: {
      id: '6AC5',
      source: 'Narrow-rift',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Narrow-rift Empty Refrain Out First',
    type: 'StartsUsing',
    // This is followed by a very short 6AC9 castbar.
    netRegex: {
      id: '6AC3',
      source: 'Narrow-rift',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getOutThenIn */.n3.getOutThenIn()
  }, {
    id: 'Hunt Narrow-rift Empty Refrain In Second',
    type: 'Ability',
    netRegex: {
      id: '6AC3',
      source: 'Narrow-rift',
      capture: false
    },
    condition: data => data.inCombat,
    suppressSeconds: 1,
    response: responses/* Responses.getIn */.n3.getIn('info')
  }, {
    id: 'Hunt Narrow-rift Empty Refrain In First',
    type: 'StartsUsing',
    // This is followed by a very short 6AC7 castbar.
    netRegex: {
      id: '6AC4',
      source: 'Narrow-rift',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getInThenOut */.n3.getInThenOut()
  }, {
    id: 'Hunt Narrow-rift Empty Refrain Out Second',
    type: 'Ability',
    netRegex: {
      id: '6AC4',
      source: 'Narrow-rift',
      capture: false
    },
    condition: data => data.inCombat,
    suppressSeconds: 1,
    response: responses/* Responses.getOut */.n3.getOut('info')
  },
  // ---------------- Chi Boss FATE ----------------
  {
    id: 'Hunt Chi Assault Carapace (Donut)',
    // 6561 = 4.7s cast
    // 6254 = 7.7s cast (during Bunker Buster)
    type: 'StartsUsing',
    netRegex: {
      id: ['6561', '6254'],
      source: 'Chi',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    id: 'Hunt Chi Assault Carapace (Line)',
    // 6562 = 4.7s cast
    // 6255 = 7.7s cast (during Bunker Buster)
    type: 'StartsUsing',
    netRegex: {
      id: ['6562', '6255'],
      source: 'Chi',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'Hunt Chi Rear Guns',
    type: 'StartsUsing',
    netRegex: {
      id: '656A',
      source: 'Chi',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.goFront */.n3.goFront()
  }, {
    id: 'Hunt Chi Fore Arms',
    type: 'StartsUsing',
    netRegex: {
      id: '6567',
      source: 'Chi',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Hunt Chi Rear Guns > Fore Arms 2.0',
    type: 'StartsUsing',
    netRegex: {
      id: '656B',
      source: 'Chi',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getFrontThenBack */.n3.getFrontThenBack()
  }, {
    id: 'Hunt Chi Fore Arms > Rear Guns 2.0',
    type: 'StartsUsing',
    netRegex: {
      id: '6568',
      source: 'Chi',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.getBackThenFront */.n3.getBackThenFront()
  }, {
    id: 'Hunt Chi Carapace > Fore Arms 2.0 (Donut)',
    type: 'StartsUsing',
    netRegex: {
      id: '6563',
      source: 'Chi',
      capture: false
    },
    condition: data => data.inCombat,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Under => Back',
        de: 'Unter Ihn => Hinter den Boss',
        fr: 'Dessous => Arrière',
        ja: '下 => 後ろ',
        cn: '脚下 => 背后',
        ko: '안으로 => 뒤로'
      }
    }
  }, {
    id: 'Hunt Chi Carapace > Fore Arms 2.0 (Line)',
    type: 'StartsUsing',
    netRegex: {
      id: '6565',
      source: 'Chi',
      capture: false
    },
    condition: data => data.inCombat,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sides => Back',
        de: 'Seiten => Hinter den Boss',
        fr: 'Côtés => Arrière',
        ja: '横 => 後ろ',
        cn: '两侧 => 背后',
        ko: '옆으로 => 뒤로'
      }
    }
  }, {
    id: 'Hunt Chi Carapace > Rear Guns 2.0 (Donut)',
    type: 'StartsUsing',
    netRegex: {
      id: '6564',
      source: 'Chi',
      capture: false
    },
    condition: data => data.inCombat,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Under => Front',
        de: 'Unter Ihn => Vor den Boss',
        fr: 'Dessous => Devant',
        ja: '下 => 前',
        cn: '脚下 => 正面',
        ko: '안으로 => 앞으로'
      }
    }
  }, {
    id: 'Hunt Chi Carapace > Rear Guns 2.0 (Line)',
    type: 'StartsUsing',
    netRegex: {
      id: '6566',
      source: 'Chi',
      capture: false
    },
    condition: data => data.inCombat,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sides => Front',
        de: 'Seiten => Vor den Boss',
        fr: 'Côtés => Devant',
        ja: '横 => 前',
        cn: '两侧 => 正面',
        ko: '옆으로 => 앞으로'
      }
    }
  }, {
    id: 'Hunt Chi Missile Shower',
    type: 'StartsUsing',
    netRegex: {
      id: '6571',
      source: 'Chi',
      capture: false
    },
    condition: data => data.inCombat,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hunt Chi Hellburner',
    // tankbuster aoe around marked target (primary threat)
    type: 'StartsUsing',
    netRegex: {
      id: '6574',
      source: 'Chi'
    },
    condition: data => data.inCombat,
    response: responses/* Responses.tankCleave */.n3.tankCleave('alert')
  }, {
    id: 'Hunt Chi Thermobaric Explosive',
    // dual proximity aoes either N/S or E/W targeting the environment (E0000000)
    // proximity aoe locations (x, y):
    //   N: (650.00, 15.00)
    //   S: (650.00, -15.00)
    //   E: (665.00, 0.00)
    //   W: (635.00, 0.00)
    type: 'StartsUsing',
    netRegex: {
      id: '656E',
      source: 'Chi'
    },
    condition: data => data.inCombat,
    suppressSeconds: 1,
    infoText: (_data, matches, output) => {
      if (Math.abs(parseFloat(matches.x) - 650) < 0.1) return output.eastWest();
      return output.northSouth();
    },
    outputStrings: {
      northSouth: {
        en: 'Go North / South edge',
        de: 'Geh zur Kante im Norden / Süden',
        fr: 'Allez au bord Nord/Sud',
        ja: '南北の隅へ',
        cn: '去南北边缘',
        ko: '남/북쪽 끝으로'
      },
      eastWest: {
        en: 'Go East / West edge',
        de: 'Geh zur Kante im Osten / Westen',
        fr: 'Allez au bord Est/Ouest',
        ja: '東西の隅へ',
        cn: '去东西边缘',
        ko: '동/서쪽 끝으로'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Arch-Eta': 'Erz-Eta',
      'Chi': 'Chi',
      'Fan Ail': 'Fan Ail',
      'Narrow-rift': 'Enger Riss'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Arch-Eta': 'Arch-Êta',
      'Chi': 'Chi',
      'Fan Ail': 'Fan Ail',
      'Narrow-rift': 'Rift-étroit'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Arch-Eta': 'アーチイータ',
      'Chi': 'カイ',
      'Fan Ail': 'ファン・アイル',
      'Narrow-rift': 'ナロー＝リフト'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Arch-Eta': '伊塔总领',
      'Chi': '希',
      'Fan Ail': '凡·艾尔',
      'Narrow-rift': '狭缝'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Arch-Eta': '아치 에타',
      'Chi': '키',
      'Fan Ail': '판 아일',
      'Narrow-rift': '내로 리프트'
    }
  }]
};
/* harmony default export */ const ultima_thule = (ultima_thule_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/map/the_excitatron_6000.ts



// TODO: Lucky Sphinx abilities

const excitatronOutputStrings = {
  spawn: {
    en: '${name} spawned!',
    de: '${name} erscheint!',
    fr: '${name} apparait !',
    ja: '${name} 現れる！',
    cn: '已生成 ${name}!',
    ko: '${name} 등장!'
  }
};
const the_excitatron_6000_triggerSet = {
  id: 'TheExcitatron6000',
  zoneId: zone_id/* default.TheExcitatron6000 */.Z.TheExcitatron6000,
  triggers: [
  // ---------------- random treasure mobs ----------------
  {
    id: 'Excitatron Rainbow Golem Spawn',
    // 10834 = Rainbow Golem
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '10834'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: excitatronOutputStrings.spawn
    }
  }, {
    id: 'Excitatron Golden Supporter Spawn',
    // 10833 = Golden Supporter
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '10833'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: excitatronOutputStrings.spawn
    }
  }, {
    id: 'Excitatron Exciting Mandragoras Spawn',
    // 10835 = Exciting Onion
    // 10836 = Exciting Egg
    // 10837 = Exciting Garlic
    // 10838 = Exciting Tomato
    // 10839 = Exciting Queen
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '1083[5-9]',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Exciting Mandragoras spawned, kill in order!',
        de: 'Mandragoras erscheinen, in Reihenfolge besiegen!',
        fr: 'Les mandragores apparaissent, tuez-les dans l\'ordre',
        ja: 'マンドラゴラ！順番に倒して！',
        cn: '已生成 惊奇蔓德拉战队, 依次击杀!',
        ko: '만드라즈 등장, 순서대로 잡기'
      }
    }
  },
  // ---------------- final chamber boss: Lucky Face ----------------
  {
    id: 'Excitatron Right in the Dark',
    type: 'StartsUsing',
    netRegex: {
      id: '6D57',
      source: 'Lucky Face',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Excitatron Left in the Dark',
    type: 'StartsUsing',
    netRegex: {
      id: '6D55',
      source: 'Lucky Face',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Excitatron Heart on Fire IV',
    type: 'StartsUsing',
    netRegex: {
      id: '6D4D',
      source: 'Lucky Face'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Excitatron Quake Me Away',
    type: 'StartsUsing',
    netRegex: {
      id: '6D5F',
      source: 'Lucky Face',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Excitatron Quake in Your Boots',
    type: 'StartsUsing',
    netRegex: {
      id: '6D5D',
      source: 'Lucky Face',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Excitatron Right in the Dark Reversed',
    // when Lucky Face casts Merry Go-round (6D4F, 6D51) and gains the Revolutionary (B59) buff, certain attacks are reversed
    // reversed attacks have different ids so we don't need to check for the buff
    type: 'StartsUsing',
    netRegex: {
      id: '6D5B',
      source: 'Lucky Face',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'Excitatron Left in the Dark Reversed',
    // when Lucky Face casts Merry Go-round (6D4F, 6D51) and gains the Revolutionary (B59) buff, certain attacks are reversed
    // reversed attacks have different ids so we don't need to check for the buff
    type: 'StartsUsing',
    netRegex: {
      id: '6D59',
      source: 'Lucky Face',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'Excitatron Quake Me Away Reversed',
    // when Lucky Face casts Merry Go-round (6D4F, 6D51) and gains the Revolutionary (B59) buff, certain attacks are reversed
    // reversed attacks have different ids so we don't need to check for the buff
    type: 'StartsUsing',
    netRegex: {
      id: '6DBB',
      source: 'Lucky Face',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Excitatron Quake in Your Boots Reversed',
    // when Lucky Face casts Merry Go-round (6D4F, 6D51) and gains the Revolutionary (B59) buff, certain attacks are reversed
    // reversed attacks have different ids so we don't need to check for the buff
    type: 'StartsUsing',
    netRegex: {
      id: '6DBA',
      source: 'Lucky Face',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Excitatron Heart on Fire III',
    // baited aoe on 2 players
    type: 'StartsUsing',
    netRegex: {
      id: '6D62',
      source: 'Lucky Face'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Excitatron Temper\'s Flare',
    type: 'StartsUsing',
    netRegex: {
      id: '6D4E',
      source: 'Lucky Face',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  },
  // ---------------- alternate final chamber boss: Lucky Sphinx ----------------
  {
    id: 'Excitatron Icewind Twister',
    type: 'StartsUsing',
    netRegex: {
      id: '6D69',
      source: 'Lucky Sphinx',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Excitatron Riddle of Frost',
    // inflicts Freezing Up (9EC) for 3s at end of cast
    // Freezing Up becomes Deep Freeze (4E6) if not continuously moving until debuff expires
    type: 'StartsUsing',
    netRegex: {
      id: '6D65',
      source: 'Lucky Sphinx'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 2,
    durationSeconds: 5,
    response: responses/* Responses.moveAround */.n3.moveAround('alert')
  }, {
    id: 'Excitatron Icebomb Burst',
    type: 'StartsUsing',
    netRegex: {
      id: '6D67',
      source: 'Lucky Sphinx',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }
  // Riddle of Flame - Pyretic on every player
  // Gold Thunder - stack donut on 1 player, deals high damge outside center safe-spot
  // Firedrop Blast - aoes under 4? players + aoe marker on 1 player, leaves burns on marked player if other players hit?
  // Superheat - tankbuster
  // Crackling Current - roomwide aoe
  ],

  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Lucky Face': 'Gesicht des Glücks',
      'Lucky Sphinx': 'Sphinx des Glücks'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Lucky Face': 'visage chanceux',
      'Lucky Sphinx': 'sphinx chanceux'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Lucky Face': 'ラッキー・フェイス',
      'Lucky Sphinx': 'ラッキー・スフィンクス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Lucky Face': '幸运石面',
      'Lucky Sphinx': '幸运斯芬克斯'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Lucky Face': '행운의 얼굴',
      'Lucky Sphinx': '행운의 스핑크스'
    }
  }]
};
/* harmony default export */ const the_excitatron_6000 = (the_excitatron_6000_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/map/the_shifting_gymnasion_agonon.ts




// TODO: ::greater summons::
// TODO: Gymnasiou Acheloios: Volcanic Howl - ???
// TODO: ::elder summons::
// TODO: ::final summons::
// TODO: Narkissos: Rock Hard - ???
// TODO: Narkissos: Putrid Breath - ???
// TODO: Hippomenes: all abilities
// TODO: Phaethon: all abilities
const agononOutputStrings = {
  spawn: {
    en: '${name} spawned!',
    de: '${name} erscheint!',
    fr: '${name} apparait !',
    ja: '${name} 現れる！',
    cn: '已生成 ${name}!',
    ko: '${name} 등장!'
  },
  adds: {
    en: 'Adds soon',
    de: 'Bald Adds',
    fr: 'Adds bientôt',
    ja: 'まもなくザコ出ます',
    cn: '小怪即将出现',
    ko: '곧 쫄 나옴'
  }
};
const the_shifting_gymnasion_agonon_triggerSet = {
  id: 'TheShiftingGymnasionAgonon',
  zoneId: zone_id/* default.TheShiftingGymnasionAgonon */.Z.TheShiftingGymnasionAgonon,
  triggers: [
  // ---------------- random treasure mobs ----------------
  {
    id: 'Shifting Gymnasion Agonon Gymnasiou Lampas/Lyssa Spawn',
    // 12034 = Gymnasiou Lampas
    // 12035 = Gymnasiou Lyssa
    // these two sometimes spawn at the same time, so only trigger on one to keep from being too noisy
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '1203[45]'
    },
    suppressSeconds: 1,
    infoText: (_data, matches, output) => output.spawn({
      name: matches.name
    }),
    outputStrings: {
      spawn: agononOutputStrings.spawn
    }
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Mandragorai Spawn',
    // 12036 = Gymnastic Onion
    // 12037 = Gymnastic Eggplant
    // 12038 = Gymnastic Garlic
    // 12039 = Gymnastic Tomato
    // 12040 = Gymnastic Queen
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: ['1203[6-9]', '12040'],
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Gymnasiou Mandragorai spawned, kill in order!',
        de: 'Gymnasiou-Mandragorai erscheinen, in Reihenfolge besiegen!',
        fr: 'Les mandragores apparaissent, tuez-les dans l\'ordre',
        ja: 'マンドラゴラ！順番に倒して！',
        cn: '已生成 育体蔓德拉!',
        ko: '만드라즈 등장, 순서대로 잡기'
      }
    }
  },
  // ---------------- lesser summons ----------------
  {
    id: 'Shifting Gymnasion Agonon Gymnasiou Leon Inferno Blast',
    type: 'StartsUsing',
    netRegex: {
      id: '7DCC',
      source: 'Gymnasiou Leon',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Leon Flare Star',
    // 802F - places proximity marker
    // 8030 - proximity aoe cast
    type: 'StartsUsing',
    netRegex: {
      id: '8030',
      source: 'Gymnasiou Leon',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Leon Roar',
    type: 'StartsUsing',
    netRegex: {
      id: '7DC9',
      source: 'Gymnasiou Leon',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut('info')
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Leon Pounce',
    type: 'StartsUsing',
    netRegex: {
      id: '7DC8',
      source: 'Gymnasiou Leon'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Satyros Storm Wing',
    type: 'StartsUsing',
    netRegex: {
      id: '7DD[BD]',
      source: 'Gymnasiou Satyros',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid green nails',
        de: 'Weiche den grünen Nägeln aus',
        fr: 'Évitez les griffes',
        ja: '緑の杭に避け',
        cn: '躲避风刃',
        ko: '초록 발톱 피하기'
      }
    }
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Satyros Dread Dive',
    type: 'StartsUsing',
    netRegex: {
      id: '7DDA',
      source: 'Gymnasiou Satyros'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Satyros Wingblow',
    type: 'StartsUsing',
    netRegex: {
      id: '7DE[01]',
      source: 'Gymnasiou Satyros',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Triton Pelagic Cleaver',
    type: 'StartsUsing',
    netRegex: {
      id: '7DE6',
      source: 'Gymnasiou Triton',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Triton Aquatic Lance',
    type: 'StartsUsing',
    netRegex: {
      id: '7DE7',
      source: 'Gymnasiou Triton',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Triton Protolithic Puncture',
    type: 'StartsUsing',
    netRegex: {
      id: '7DE4',
      source: 'Gymnasiou Triton'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Tigris Absolute Zero',
    type: 'StartsUsing',
    netRegex: {
      id: '7DD0',
      source: 'Gymnasiou Tigris',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Tigris Eyeshine',
    type: 'StartsUsing',
    netRegex: {
      id: '7DCF',
      source: 'Gymnasiou Tigris',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Tigris Frumious Jaws',
    type: 'StartsUsing',
    netRegex: {
      id: '7DCE',
      source: 'Gymnasiou Tigris'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Pithekos Thundercall',
    type: 'HeadMarker',
    netRegex: {
      id: '006F'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Place Marker on Wall',
        de: 'Markierung an der Wand ablegen',
        fr: 'Placez le marqueur sur le mur',
        ja: 'マーカーを壁に',
        cn: '在场边放置标记',
        ko: '벽에 징 놓기'
      }
    }
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Pithekos Spark',
    type: 'StartsUsing',
    // This happens at the same time as Ball of Levin's Thunder IV (7DD5).
    // "get in" is probably sufficient is the Thunder IV is far enough away.
    netRegex: {
      id: '7DD8',
      source: 'Gymnasiou Pithekos',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Pithekos Sweeping Gouge',
    type: 'StartsUsing',
    netRegex: {
      id: '7DD3',
      source: 'Gymnasiou Pithekos'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Megakantha Vine Whip',
    type: 'StartsUsing',
    netRegex: {
      id: '7DDE',
      source: 'Gymnasiou Megakantha'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Megakantha Odious Atmosphere',
    type: 'StartsUsing',
    netRegex: {
      id: '7DF1',
      source: 'Gymnasiou Megakantha',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Behind (Stay Behind)',
        de: 'Geh hinter den Boss (und bleib hinter ihm stehen)',
        fr: 'Allez derrière (et restez-y)',
        ja: '後ろへ (そのまま後ろ)',
        cn: '去背后 (待在背后)',
        ko: '뒤로 이동 (뒤에 머물기)'
      }
    }
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Megakantha Sludge Bomb',
    type: 'StartsUsing',
    netRegex: {
      id: '7DED',
      source: 'Gymnasiou Megakantha',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind('info')
  },
  // ---------------- greater summons ----------------
  {
    id: 'Shifting Gymnasion Agonon Gymnasiou Acheloios Tail Swing',
    type: 'StartsUsing',
    netRegex: {
      id: '7E17',
      source: 'Gymnasiou Acheloios',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Acheloios Double Hammer',
    // TODO: same pattern every time?
    type: 'StartsUsing',
    netRegex: {
      id: '7E19',
      source: 'Gymnasiou Acheloios',
      capture: false
    },
    alertText: (_data, _matches, output) => {
      return output.text({
        dir1: output.left(),
        dir2: output.right()
      });
    },
    outputStrings: {
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      text: {
        en: '${dir1} => ${dir2}',
        de: '${dir1} => ${dir2}',
        fr: '${dir1} => ${dir2}',
        ja: '${dir1} => ${dir2}',
        cn: '${dir1} => ${dir2}',
        ko: '${dir1} => ${dir2}'
      }
    }
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Acheloios Quadruple Hammer',
    // rotates counterclockwise after each cleave
    // TODO: same rotation/pattern every time?
    // FIXME: the correct way to solve this is to stand on the initial safe side
    // and then rotate opposite direction of rotation 90 degrees each time.
    // This should probably say "start back left (rotate CCW)" sorta thing.
    type: 'StartsUsing',
    netRegex: {
      id: '7E18',
      source: 'Gymnasiou Acheloios',
      capture: false
    },
    alertText: (_data, _matches, output) => {
      return output.text({
        dir1: output.left(),
        dir2: output.right(),
        dir3: output.left(),
        dir4: output.right()
      });
    },
    outputStrings: {
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      text: {
        en: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        de: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        fr: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        ja: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        cn: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        ko: '${dir1} => ${dir2} => ${dir3} => ${dir4}'
      }
    }
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Acheloios Deadly Hold',
    type: 'StartsUsing',
    netRegex: {
      id: '7E13',
      source: 'Gymnasiou Acheloios'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  },
  // TODO: Gymnasiou Acheloios: Volcanic Howl - ???
  {
    id: 'Shifting Gymnasion Agonon Gymnasiou Meganereis Wave of Turmoil',
    type: 'StartsUsing',
    netRegex: {
      id: '7E0[12]',
      source: 'Gymnasiou Meganereis',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Meganereis Falling Water',
    type: 'StartsUsing',
    netRegex: {
      id: '7E04',
      source: 'Gymnasiou Meganereis'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Meganereis Ceras',
    // inflicts Poison (829) for 15s
    type: 'StartsUsing',
    netRegex: {
      id: '7DFF',
      source: 'Gymnasiou Meganereis'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Meganereis Hydrocannon',
    type: 'StartsUsing',
    netRegex: {
      id: '7E00',
      source: 'Gymnasiou Meganereis',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Sphinx Explosion',
    // donut aoe centered on adds
    type: 'StartsUsing',
    netRegex: {
      id: '7E11',
      source: 'Verdant Plume',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Under Verdant Plume',
        de: 'Geh unter die blaue Feder',
        fr: 'Allez sous la plume verdoyante',
        ja: '濃緑の羽根の下へ',
        cn: '去浓绿之羽下方',
        ko: '진녹색 날개 밑으로'
      }
    }
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Sphinx Fervid Pulse',
    type: 'StartsUsing',
    netRegex: {
      id: '7E10',
      source: 'Gymnasiou Sphinx',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Intercards',
        de: 'Interkardinal',
        fr: 'Intercardinaux',
        ja: '斜め',
        cn: '斜角',
        ko: '대각선 쪽으로'
      }
    }
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Sphinx Frigid Pulse',
    type: 'StartsUsing',
    netRegex: {
      id: '7E0E',
      source: 'Gymnasiou Sphinx',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Sphinx Feather Rain',
    // can overlap with Frigid Pulse, possibly too noisy?
    type: 'StartsUsing',
    netRegex: {
      id: '7E0F',
      source: 'Gymnasiou Sphinx'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Sphinx Scratch',
    type: 'StartsUsing',
    netRegex: {
      id: '7E09',
      source: 'Gymnasiou Sphinx'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Styphnolobion Rake',
    type: 'StartsUsing',
    netRegex: {
      id: '7DF5',
      source: 'Gymnasiou Styphnolobion'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Styphnolobion Tiiimbeeer',
    type: 'StartsUsing',
    netRegex: {
      id: '7DF6',
      source: 'Gymnasiou Styphnolobion',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Styphnolobion Earth Shaker',
    type: 'StartsUsing',
    netRegex: {
      id: '7DFB',
      source: 'Gymnasiou Styphnolobion'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.earthshaker */.n3.earthshaker()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Styphnolobion Earth Quaker',
    type: 'StartsUsing',
    netRegex: {
      id: '7DF9',
      source: 'Gymnasiou Styphnolobion',
      capture: false
    },
    response: responses/* Responses.getOutThenIn */.n3.getOutThenIn()
  },
  // ---------------- elder summons ----------------
  {
    id: 'Shifting Gymnasion Agonon Lyssa Chrysine Heavy Smash',
    type: 'StartsUsing',
    netRegex: {
      id: '7E3A',
      source: 'Lyssa Chrysine'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Shifting Gymnasion Agonon Lyssa Chrysine Frigid Needle',
    type: 'StartsUsing',
    netRegex: {
      id: '7E36',
      source: 'Lyssa Chrysine',
      capture: false
    },
    response: responses/* Responses.getOutThenIn */.n3.getOutThenIn()
  }, {
    id: 'Shifting Gymnasion Agonon Lyssa Chrysine Circle of Ice',
    type: 'StartsUsing',
    netRegex: {
      id: '7E38',
      source: 'Lyssa Chrysine',
      capture: false
    },
    response: responses/* Responses.getInThenOut */.n3.getInThenOut()
  }, {
    id: 'Shifting Gymnasion Agonon Lyssa Chrysine Howl',
    type: 'StartsUsing',
    netRegex: {
      id: '7E28',
      source: 'Lyssa Chrysine',
      capture: false
    },
    infoText: (_data, _matches, output) => output.adds(),
    outputStrings: {
      adds: agononOutputStrings.adds
    }
  }, {
    id: 'Shifting Gymnasion Agonon Lyssa Chrysine Skull Dasher',
    type: 'StartsUsing',
    netRegex: {
      id: '7E32',
      source: 'Lyssa Chrysine'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Gymnasion Agonon Lampas Chrysine Lightburst',
    type: 'StartsUsing',
    netRegex: {
      id: '7E22',
      source: 'Lampas Chrysine'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Gymnasion Agonon Lampas Chrysine Summon',
    type: 'StartsUsing',
    netRegex: {
      id: '7E20',
      source: 'Lampas Chrysine',
      capture: false
    },
    infoText: (_data, _matches, output) => output.adds(),
    outputStrings: {
      adds: agononOutputStrings.adds
    }
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Mandragoras Ram',
    type: 'StartsUsing',
    netRegex: {
      id: '7E29',
      source: 'Gymnasiou Mandragoras'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Gymnasion Agonon Gymnasiou Mandragoras Saibai Mandragora',
    type: 'StartsUsing',
    netRegex: {
      id: '7E2C',
      source: 'Gymnasiou Mandragoras',
      capture: false
    },
    infoText: (_data, _matches, output) => output.adds(),
    outputStrings: {
      adds: agononOutputStrings.adds
    }
  },
  // ---------------- final summon: Narkissos ----------------
  {
    id: 'Shifting Gymnasion Agonon Narkissos Fetching Fulgence',
    type: 'StartsUsing',
    netRegex: {
      id: '7E4C',
      source: 'Narkissos',
      capture: false
    },
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'Shifting Gymnasion Agonon Narkissos Lash',
    type: 'StartsUsing',
    netRegex: {
      id: '7E4A',
      source: 'Narkissos'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Shifting Gymnasion Agonon Narkissos Extensible Tendrils',
    type: 'StartsUsing',
    netRegex: {
      id: '7E53',
      source: 'Narkissos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Cardinals',
        de: 'Kardinal',
        fr: 'Cardinaux',
        ja: '十字回避',
        cn: '十字',
        ko: '십자방향으로'
      }
    }
  }, {
    id: 'Shifting Gymnasion Agonon Narkissos Brainstorm',
    type: 'GainsEffect',
    // 7A6 = Forward March
    // 7A7 = About Face
    // 7A8 = Left Face
    // 7A9 = Right Face
    netRegex: {
      effectId: '7A[6-9]',
      source: 'Narkissos'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, matches, output) => {
      const effectId = matches.effectId.toUpperCase();
      if (effectId === '7A6') return output.forward();
      if (effectId === '7A7') return output.backward();
      if (effectId === '7A8') return output.left();
      if (effectId === '7A9') return output.right();
    },
    outputStrings: {
      forward: {
        en: 'March Forward into Safe Spot',
        de: 'marschiere Vorwärts in die sichere Stelle',
        fr: 'Marche avant dans une zone sûre',
        ja: '強制移動: 前',
        cn: '向前强制移动到安全区',
        ko: '강제 이동 앞'
      },
      backward: {
        en: 'March Backward into Safe Spot',
        de: 'marschiere Rückwärts in die sichere Stelle',
        fr: 'Marche arrière dans une zone sûre',
        ja: '強制移動: 後ろ',
        cn: '向后强制移动到安全区',
        ko: '강제 이동 뒤'
      },
      left: {
        en: 'March Left into Safe Spot',
        de: 'marschiere Links in die sichere Stelle',
        fr: 'Marche à gauche dans une zone sûre',
        ja: '強制移動: 左',
        cn: '向左强制移动到安全区',
        ko: '강제 이동 왼쪽'
      },
      right: {
        en: 'March Right into Safe Spot',
        de: 'marschiere Rechts in die sichere Stelle',
        fr: 'Marche à droite dans une zone sûre',
        ja: '強制移動: 右',
        cn: '向右强制移动到安全区',
        ko: '강제 이동 오른쪽'
      }
    }
  }
  // Narkissos: Rock Hard - ???
  // Narkissos: Putrid Breath - ???
  // ---------------- alternate final summon: Hippomenes ----------------
  // Hippomenes: Charge Blaster - applies 270 cone buffs to boss
  // Hippomenes: Dibrid Blaster - fires two 270 cones back-to-back, direction indicated by boss buffs from Charge Blaster
  // Hippomenes: Gouge - tankbuster
  // Hippomenes: Rumbling Thunder - aoe under random players?
  // Hippomenes: Electric Whisker - cardinal cones plus spread aoes on players?
  // Hippomenes: Tetrabrid Blaster - fires four 270 cones back-to-back, direction indicated by boss buffs from Charge Blaster
  // Hippomenes: Electric Burst - raidwide, summons adds (Ball of Levin: cast Shock - large PBAoE)
  // ---------------- alternate final summon: Phaethon ----------------
  // Phaethon: Illusive Fire - summons adds (Phantasmal Phaethon: cast Gallop - line aoe across arena)
  // Phaethon: Heat Blast - raidwide
  // Phaethon: Shining Sun - summons adds (Ball of Fire: cast Flame Blast - cross aoe)
  // Phaethon: Flare - two? flare markers on random? players
  // Phaethon: Flame Burst - tankbuster
  // Phaethon: Eruption - aoe under random players?
  ],

  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Gymnasiou Acheloios': 'Gymnasiou-Acheloios',
      'Gymnasiou Leon': 'Gymnasiou-Leon',
      'Gymnasiou Mandragoras': 'Gymnasiou-Mandragora',
      'Gymnasiou Megakantha': 'Gymnasiou-Megakantha',
      'Gymnasiou Meganereis': 'Gymnasiou-Meganereis',
      'Gymnasiou Pithekos': 'Gymnasiou-Pithekos',
      'Gymnasiou Satyros': 'Gymnasiou-Satyros',
      'Gymnasiou Sphinx': 'Gymnasiou-Sphinx',
      'Gymnasiou Styphnolobion': 'Gymnasiou-Styphnolobium',
      'Gymnasiou Tigris': 'Gymnasiou-Tigris',
      'Gymnasiou Triton': 'Gymnasiou-Triton',
      'Lampas Chrysine': 'Lampas Chrysine',
      'Lyssa Chrysine': 'Lyssa Chrysine',
      'Narkissos': 'Narkissos',
      'Verdant Plume': 'blau(?:e|er|es|en) Feder'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Gymnasiou Acheloios': 'gymnasiou achéloios',
      'Gymnasiou Leon': 'gymnasiou léon',
      'Gymnasiou Mandragoras': 'gymnasiou mandragoras',
      'Gymnasiou Megakantha': 'gymnasiou mégakantha',
      'Gymnasiou Meganereis': 'gymnasiou méganéréis',
      'Gymnasiou Pithekos': 'gymnasiou pithékos',
      'Gymnasiou Satyros': 'gymnasiou satyros',
      'Gymnasiou Sphinx': 'gymnasiou sphinx',
      'Gymnasiou Styphnolobion': 'gymnasiou styphnolobion',
      'Gymnasiou Tigris': 'gymnasiou tigris',
      'Gymnasiou Triton': 'gymnasiou triton',
      'Lampas Chrysine': 'lampas chrysine',
      'Lyssa Chrysine': 'lyssa chrysine',
      'Narkissos': 'Narcisse',
      'Verdant Plume': 'plume vert foncé'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Gymnasiou Acheloios': 'ギュムナシオー・アケローオス',
      'Gymnasiou Leon': 'ギュムナシオー・レオン',
      'Gymnasiou Mandragoras': 'ギュムナシオー・マンドラゴラ',
      'Gymnasiou Megakantha': 'ギュムナシオー・メガアカンサ',
      'Gymnasiou Meganereis': 'ギュムナシオー・メガネレイス',
      'Gymnasiou Pithekos': 'ギュムナシオー・ピテコス',
      'Gymnasiou Satyros': 'ギュムナシオー・サテュロス',
      'Gymnasiou Sphinx': 'ギュムナシオー・スフィンクス',
      'Gymnasiou Styphnolobion': 'ギュムナシオー・スティファノロビュウム',
      'Gymnasiou Tigris': 'ギュムナシオー・ティグリス',
      'Gymnasiou Triton': 'ギュムナシオー・トリトン',
      'Lampas Chrysine': 'クリュシネ・ランパス',
      'Lyssa Chrysine': 'クリュシネ・リッサ',
      'Narkissos': 'ナルキッソス',
      'Verdant Plume': '濃緑の羽根'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Gymnasiou Acheloios': '育体阿刻罗俄斯',
      'Gymnasiou Leon': '育体雄狮',
      'Gymnasiou Mandragoras': '育体蔓德拉',
      'Gymnasiou Megakantha': '育体巨型刺口花',
      'Gymnasiou Meganereis': '育体巨型涅瑞伊斯',
      'Gymnasiou Pithekos': '育体猿猴',
      'Gymnasiou Satyros': '育体萨提洛斯',
      'Gymnasiou Sphinx': '育体斯芬克斯',
      'Gymnasiou Styphnolobion': '育体槐龙',
      'Gymnasiou Tigris': '育体猛虎',
      'Gymnasiou Triton': '育体特里同',
      'Lampas Chrysine': '金光拉姆帕斯',
      'Lyssa Chrysine': '金光吕萨',
      'Narkissos': '纳西索斯',
      'Verdant Plume': '浓绿之羽'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Gymnasiou Acheloios': '김나시온 아켈로오스',
      'Gymnasiou Leon': '김나시온 사자',
      'Gymnasiou Mandragoras': '김나시온 만드라고라',
      'Gymnasiou Megakantha': '김나시온 큰가시풀',
      'Gymnasiou Meganereis': '김나시온 거대 네레이스',
      'Gymnasiou Pithekos': '김나시온 원숭이',
      'Gymnasiou Satyros': '김나시온 사티로스',
      'Gymnasiou Sphinx': '김나시온 스핑크스',
      'Gymnasiou Styphnolobion': '김나시온 회화나무',
      'Gymnasiou Tigris': '김나시온 호랑이',
      'Gymnasiou Triton': '김나시온 트리톤',
      'Lampas Chrysine': '람파스 크뤼시네',
      'Lyssa Chrysine': '뤼사 크뤼시네',
      'Narkissos': '나르키소스',
      'Verdant Plume': '진녹색 깃털'
    }
  }]
};
/* harmony default export */ const the_shifting_gymnasion_agonon = (the_shifting_gymnasion_agonon_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p10n.ts



const bossNameUnicode = 'Pand\u00e6monium';
const p10n_triggerSet = {
  id: 'AnabaseiosTheTenthCircle',
  zoneId: zone_id/* default.AnabaseiosTheTenthCircle */.Z.AnabaseiosTheTenthCircle,
  timelineFile: 'p10n.txt',
  initData: () => {
    return {
      silkspitPlayers: []
    };
  },
  triggers: [{
    id: 'P10N Silkspit Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '01CE'
    },
    run: (data, matches) => data.silkspitPlayers.push(matches.target)
  }, {
    id: 'P10N Silkspit',
    type: 'HeadMarker',
    netRegex: {
      id: '01CE',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 0.5,
    alertText: (data, _matches, output) => {
      if (data.silkspitPlayers.includes(data.me)) return output.onYou();
    },
    infoText: (data, _matches, output) => {
      if (!data.silkspitPlayers.includes(data.me)) return output.onOthers();
    },
    run: data => data.silkspitPlayers = [],
    outputStrings: {
      onYou: {
        en: 'Spread (avoid posts)',
        de: 'Verteilen (vermeide Stäbe)',
        fr: 'Écartez-vous (évitez les poteaux)',
        ja: '散会 (柱回避)',
        cn: '分散（远离柱子）',
        ko: '산개 (기둥 피하기)'
      },
      onOthers: {
        en: 'Avoid marked players',
        de: 'Vermeide markierte Spieler',
        fr: 'Évitez les joueurs marqués',
        ja: 'ウェブ回避',
        cn: '远离点名玩家',
        ko: '징 대상자 피하기'
      }
    }
  }, {
    id: 'P10N Pandaemonic Pillars',
    type: 'StartsUsing',
    netRegex: {
      id: '825D',
      source: bossNameUnicode,
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.getTowers */.n3.getTowers()
  }, {
    id: 'P10N Imprisonment',
    type: 'StartsUsing',
    netRegex: {
      id: '8262',
      source: bossNameUnicode,
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid jails',
        de: 'Gefängnisen vermeiden',
        fr: 'Évitez les pièges',
        ja: 'ジェイル回避',
        cn: '远离塔',
        ko: '감옥 벗어나기'
      }
    }
  }, {
    id: 'P10N Cannonspawn',
    type: 'StartsUsing',
    netRegex: {
      id: '8264',
      source: bossNameUnicode,
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Under jails',
        de: 'Geh unter ein Gefängnis',
        fr: 'Sous les pièges',
        ja: 'ジェイルの下へ',
        cn: '站在塔下（或远离）',
        ko: '감옥 아래로'
      }
    }
  }, {
    id: 'P10N Ultima',
    type: 'StartsUsing',
    netRegex: {
      id: '827B',
      source: bossNameUnicode,
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'P10N Pandaemoniac Meltdown',
    type: 'Ability',
    netRegex: {
      id: '87A2',
      source: bossNameUnicode
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'P10N Soul Grasp',
    type: 'StartsUsing',
    netRegex: {
      id: '8278',
      source: bossNameUnicode
    },
    response: responses/* Responses.sharedTankBuster */.n3.sharedTankBuster()
  }, {
    id: 'P10N Pandaemoniac Ray',
    type: 'StartsUsing',
    netRegex: {
      id: '826[57]',
      source: bossNameUnicode
    },
    infoText: (_data, matches, output) => {
      // Half-room cleave west (8265) or east (8267)
      const safeOutput = matches.id === '8265' ? 'east' : 'west';
      return output[safeOutput]();
    },
    outputStrings: {
      east: outputs/* default.getRightAndEast */.Z.getRightAndEast,
      west: outputs/* default.getLeftAndWest */.Z.getLeftAndWest
    }
  }, {
    id: 'P10N Touchdown',
    type: 'StartsUsing',
    netRegex: {
      id: '8268',
      source: bossNameUnicode,
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Side platform(s)',
        de: 'Seite-Platform(en)',
        fr: 'Plateforme(s) latérale(s)',
        ja: 'サイド島へ',
        cn: '去侧边平台',
        ko: '옆 플랫폼으로'
      }
    }
  }, {
    id: 'P10N Harrowing Hell x8',
    type: 'StartsUsing',
    netRegex: {
      id: '826A',
      source: bossNameUnicode,
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'P10N Harrowing Hell Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '826F',
      source: bossNameUnicode,
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'P10N Wicked Step',
    type: 'StartsUsing',
    netRegex: {
      id: '8272',
      source: bossNameUnicode,
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.party.isTank(data.me)) return output.soak();
    },
    infoText: (data, _matches, output) => {
      if (!data.party.isTank(data.me)) return output.avoid();
    },
    outputStrings: {
      soak: {
        en: 'Soak tower',
        de: 'Türme nehmen',
        fr: 'Prenez une tour',
        ja: '塔踏み',
        cn: '踩塔',
        ko: '기둥 들어가기'
      },
      avoid: {
        en: 'Avoid towers',
        de: 'Türme vermeiden',
        fr: 'Évitez les tours',
        ja: '塔回避',
        cn: '远离塔',
        ko: '기둥 피하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Pand(?:\\\\u00e6|\u00e6)monium': 'Pand\\u00e6monium'
    },
    'replaceText': {
      '\\(marked\\)': '(Markiert)',
      '\\(resolves\\)': '(Effekt)',
      '\\(knockback\\)': '(Rückstoß)',
      'Cannonspawn': 'Kanonenbrut',
      'Entangling Web': 'Großnetz',
      'Harrowing Hell': 'Höllenpein der Tiefe',
      'Imprisonment': 'Einkerkerung',
      'Pandaemoniac Meltdown': 'Pandaemonischer Kollaps',
      'Pandaemoniac Pillars': 'Pandaemonische Säule',
      'Pandaemoniac Ray': 'Pandaemonischer Strahl',
      'Parted Plumes': 'Teilungsstrahl',
      'Silkspit': 'Spucknetz',
      'Soul Grasp': 'Seelengreifer',
      'Touchdown': 'Himmelssturz',
      'Ultima': 'Ultima',
      'Wicked Step': 'Übler Schritt'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Pand(?:\\\\u00e6|\u00e6)monium': 'Pand\\u00e6monium'
    },
    'replaceText': {
      'Cannonspawn': 'Croissance de canon',
      'Entangling Web': 'Grande toile',
      'Harrowing Hell': 'Assaut sismique',
      'Imprisonment': 'Emprisonnement',
      'Pandaemoniac Meltdown': 'Fusion pandaemoniaque',
      'Pandaemoniac Pillars': 'Piliers pandaemoniaques',
      'Pandaemoniac Ray': 'Rayon pandaemoniaque',
      'Parted Plumes': 'Plumes fendantes',
      'Silkspit': 'Crachat de toile',
      'Soul Grasp': 'Saisie d\'âme',
      'Touchdown': 'Atterrissage',
      'Ultima': 'Ultima',
      'Wicked Step': 'Pattes effilées'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Pand(?:\\\\u00e6|\u00e6)monium': 'パンデモニウム'
    },
    'replaceText': {
      'Cannonspawn': 'キャノンスポーン',
      'Entangling Web': 'グランドウェブ',
      'Harrowing Hell': '魔殿の震撃',
      'Imprisonment': 'インプリズメント',
      'Pandaemoniac Meltdown': 'パンデモニックメルトン',
      'Pandaemoniac Pillars': 'パンデモニックピラー',
      'Pandaemoniac Ray': 'パンデモニックレイ',
      'Parted Plumes': 'ディバイドプルーム',
      'Silkspit': 'スピットウェブ',
      'Soul Grasp': 'ソウルグラスプ',
      'Touchdown': 'タッチダウン',
      'Ultima': 'アルテマ',
      'Wicked Step': '尖脚'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Pand(?:\\\\u00e6|\u00e6)monium': '万魔殿'
    },
    'replaceText': {
      '\\(marked\\)': '(标记)',
      '\\(resolves\\)': '(判定)',
      '\\(knockback\\)': '(击退)',
      'Cannonspawn': '扩散炮',
      'Entangling Web': '纠缠之网',
      'Harrowing Hell': '魔殿震击',
      'Imprisonment': '入狱',
      'Pandaemoniac Meltdown': '万魔殿熔毁',
      'Pandaemoniac Pillars': '万魔殿之柱',
      'Pandaemoniac Ray': '万魔殿射线',
      'Parted Plumes': '分割之羽',
      'Silkspit': '喷吐丝网',
      'Soul Grasp': '攥魂',
      'Touchdown': '空降',
      'Ultima': '究极',
      'Wicked Step': '尖脚'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Pand(?:\\\\u00e6|\u00e6)monium': '판데모니움'
    },
    'replaceText': {
      '\\(marked\\)': '(징)',
      '\\(resolves\\)': '(실행)',
      '\\(knockback\\)': '(넉백)',
      'Cannonspawn': '산탄포',
      'Entangling Web': '거대 거미줄',
      'Harrowing Hell': '판데모니움 격돌',
      'Imprisonment': '투옥',
      'Pandaemoniac Meltdown': '판데모니움 멜튼',
      'Pandaemoniac Pillars': '판데모니움 기둥',
      'Pandaemoniac Ray': '판데모니움 광선',
      'Parted Plumes': '깃털 분리',
      'Silkspit': '거미줄 뱉기',
      'Soul Grasp': '영혼 장악',
      'Touchdown': '착지',
      'Ultima': '알테마',
      'Wicked Step': '뾰족다리'
    }
  }]
};
/* harmony default export */ const p10n = (p10n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p10n.txt
const raid_p10n_namespaceObject = "### P10N: Anabaseios: The Tenth Circle\r\n#\r\n# -ii 825E 825F 8261 8263 8277 8279 825B 825C 8266 8269 8271 8273 8274 826B 826C 826D 826E 86B5 86B6 86B7 86B8\r\n#\r\n# Ignored Ids:\r\n# 825[EF] - 'Bury' action/damage from Pandaemoniac Pillars\r\n# 8261      'Imprisonment' extra\r\n# 8263      'Cannonspawn' extra\r\n# 8277      'Pandaemonic Meldown' extra\r\n# 8279      'Soul Grasp' extra\r\n# 825[BC]   'Entangling Web' extra\r\n# 8266      'Pandaemonic Ray' extra\r\n# 8269      'Touchdown' extra\r\n# 8271      'Parted Plumes' blades\r\n# 827[34]   'Wicked Step' individual towers\r\n# 826[B-E]  Supplemental AoE damage from 'Harrowing Hell'\r\n# 86B[5-8]  Supplemental AoE damage from 'Harrowing Hell'\r\n\r\n# Note: The boss's name has a Unicode character (æ)  which is causing syncs to fail.\r\n# The character is manually escaped in the syncs with the correct codepoint (U+00E6).\r\n# Entry names use \"ae\" as separate characters to ensure proper UI display.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.9 \"--sync--\" StartsUsing { id: \"8259\", source: \"Pand\\\\u00e6monium\" } window 15,15\r\n10.9 \"Silkspit (marked)\" Ability { id: \"8259\", source: \"Pand\\\\u00e6monium\" }\r\n23.0 \"Silkspit (resolves)\" Ability { id: \"825A\", source: \"Pand\\\\u00e6monium\" }\r\n35.4 \"Pandaemoniac Pillars\" Ability { id: \"825D\", source: \"Pand\\\\u00e6monium\" }\r\n43.4 \"Imprisonment\" Ability { id: \"8262\", source: \"Pand\\\\u00e6monium\" }\r\n50.1 \"Ultima\" Ability { id: \"827B\", source: \"Pand\\\\u00e6monium\" }\r\n59.9 \"Pandaemoniac Pillars\" Ability { id: \"825D\", source: \"Pand\\\\u00e6monium\" }\r\n67.8 \"Cannonspawn\" Ability { id: \"8264\", source: \"Pand\\\\u00e6monium\" }\r\n74.6 \"--sync--\" Ability { id: \"87A2\", source: \"Pand\\\\u00e6monium\" }\r\n80.0 \"Pandaemoniac Meltdown\" Ability { id: \"8276\", source: \"Pand\\\\u00e6monium\" }\r\n90.1 \"Soul Grasp\" Ability { id: \"8278\", source: \"Pand\\\\u00e6monium\" }\r\n101.3 \"Entangling Web\" Ability { id: \"8721\", source: \"Pand\\\\u00e6monium\" }\r\n114.7 \"Silkspit (marked)\" Ability { id: \"8259\", source: \"Pand\\\\u00e6monium\" }\r\n126.7 \"Silkspit (resolves)\" Ability { id: \"825A\", source: \"Pand\\\\u00e6monium\" }\r\n140.4 \"Pandaemoniac Ray\" Ability { id: \"826[57]\", source: \"Pand\\\\u00e6monium\" }\r\n150.6 \"Parted Plumes\" Ability { id: \"8270\", source: \"Pand\\\\u00e6monium\" } duration 11\r\n165.2 \"--sync--\" Ability { id: \"87A2\", source: \"Pand\\\\u00e6monium\" }\r\n170.5 \"Pandaemoniac Meltdown\" Ability { id: \"8276\", source: \"Pand\\\\u00e6monium\" }\r\n179.7 \"Soul Grasp\" Ability { id: \"8278\", source: \"Pand\\\\u00e6monium\" }\r\n191.0 \"Entangling Web\" Ability { id: \"8721\", source: \"Pand\\\\u00e6monium\" }\r\n210.5 \"Pandaemoniac Ray\" Ability { id: \"826[57]\", source: \"Pand\\\\u00e6monium\" }\r\n224.6 \"Touchdown\" Ability { id: \"8268\", source: \"Pand\\\\u00e6monium\" }\r\n233.8 \"Ultima\" Ability { id: \"827B\", source: \"Pand\\\\u00e6monium\" }\r\n245.7 \"Pandaemoniac Pillars\" Ability { id: \"825D\", source: \"Pand\\\\u00e6monium\" }\r\n253.5 \"Imprisonment/Cannonspawn\" Ability { id: \"826[24]\", source: \"Pand\\\\u00e6monium\" }\r\n259.3 \"--sync--\" Ability { id: \"87A2\", source: \"Pand\\\\u00e6monium\" }\r\n264.7 \"Pandaemoniac Meltdown\" Ability { id: \"8276\", source: \"Pand\\\\u00e6monium\" }\r\n272.8 \"Harrowing Hell (x8)\" Ability { id: \"826A\", source: \"Pand\\\\u00e6monium\" } duration 12\r\n289.0 \"Harrowing Hell (knockback)\" Ability { id: \"826F\", source: \"Pand\\\\u00e6monium\" }\r\n304.2 \"Parted Plumes\" Ability { id: \"8270\", source: \"Pand\\\\u00e6monium\" } duration 11\r\n322.7 \"Wicked Step\" Ability { id: \"8272\", source: \"Pand\\\\u00e6monium\" }\r\n\r\n# Loop begins here\r\n339.5 \"Pandaemoniac Pillars\" Ability { id: \"825D\", source: \"Pand\\\\u00e6monium\" }\r\n347.4 \"Imprisonment/Cannonspawn\" Ability { id: \"826[24]\", source: \"Pand\\\\u00e6monium\" }\r\n353.2 \"Entangling Web\" Ability { id: \"8721\", source: \"Pand\\\\u00e6monium\" }\r\n374.4 \"Touchdown\" Ability { id: \"8268\", source: \"Pand\\\\u00e6monium\" }\r\n380.5 \"--sync--\" Ability { id: \"87A2\", source: \"Pand\\\\u00e6monium\" }\r\n385.8 \"Pandaemoniac Meltdown\" Ability { id: \"8276\", source: \"Pand\\\\u00e6monium\" }\r\n392.0 \"Silkspit (marked)\" Ability { id: \"8259\", source: \"Pand\\\\u00e6monium\" }\r\n404.0 \"Silkspit (resolves)\" Ability { id: \"825A\", source: \"Pand\\\\u00e6monium\" }\r\n417.7 \"Pandaemoniac Ray\" Ability { id: \"826[57]\", source: \"Pand\\\\u00e6monium\" }\r\n423.8 \"Parted Plumes\" Ability { id: \"8270\", source: \"Pand\\\\u00e6monium\" } duration 11\r\n442.4 \"Soul Grasp\" Ability { id: \"8278\", source: \"Pand\\\\u00e6monium\" }\r\n457.6 \"Ultima\" Ability { id: \"827B\", source: \"Pand\\\\u00e6monium\" }\r\n\r\n# Repeat\r\n485.0 \"Pandaemoniac Pillars\" Ability { id: \"825D\", source: \"Pand\\\\u00e6monium\" } window 50,50 jump 339.5\r\n492.9 \"Imprisonment/Cannonspawn\" Ability { id: \"826[24]\", source: \"Pand\\\\u00e6monium\" }\r\n498.7 \"Entangling Web\" Ability { id: \"8721\", source: \"Pand\\\\u00e6monium\" }\r\n519.9 \"Touchdown\" Ability { id: \"8268\", source: \"Pand\\\\u00e6monium\" }\r\n525.9 \"--sync--\" Ability { id: \"87A2\", source: \"Pand\\\\u00e6monium\" }\r\n531.3 \"Pandaemoniac Meltdown\" Ability { id: \"8276\", source: \"Pand\\\\u00e6monium\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p10s.ts




const p10s_bossNameUnicode = 'Pand\u00e6monium';
const p10s_headmarkers = {
  // vfx/lockon/eff/com_share6_5s0c.avfx
  soulGrasp: '01D3',
  // vfx/lockon/eff/m0834trg_b0c.avfx
  webShare: '01AC',
  // vfx/lockon/eff/m0834trg_d0c.avfx
  webEntangling: '01AE',
  // vfx/lockon/eff/m0834trg_a0c.avfx
  webSpread: '01AB',
  // vfx/lockon/eff/lockon5_t0h.avfx
  spread: '0017'
};
const p10s_firstHeadmarker = parseInt(p10s_headmarkers.soulGrasp, 16);
const p10s_getHeadmarkerId = (data, matches) => {
  if (data.decOffset === undefined) data.decOffset = parseInt(matches.id, 16) - p10s_firstHeadmarker;
  return (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase().padStart(4, '0');
};
const bondsOffsetSeconds = data => {
  const fallbackDelay = 5;
  return {
    // t=145.8, call right after laser before running out to platforms
    1: 13,
    // t=223.9, call after 4th turret goes off
    2: 5,
    // t=329.9, call as donut/circle towers go off before ray
    3: 7,
    // t=459.3, call as harrowing hell knockback starts
    4: 9
  }[data.daemonicBondsCounter] ?? fallbackDelay;
};

// Helper function to call out the Daemonic Bonds spread/stack/partner ability.
const bondsDelaySeconds = (data, matches) => {
  return parseFloat(matches.duration) - bondsOffsetSeconds(data);
};
const bondsDurationSeconds = data => Math.max(bondsOffsetSeconds(data) - 3, 3);
const p10s_triggerSet = {
  id: 'AnabaseiosTheTenthCircleSavage',
  zoneId: zone_id/* default.AnabaseiosTheTenthCircleSavage */.Z.AnabaseiosTheTenthCircleSavage,
  timelineFile: 'p10s.txt',
  initData: () => {
    return {
      combatantData: [],
      dividingWingsTethers: [],
      dividingWingsStacks: [],
      dividingWingsEntangling: [],
      meltdownSpreads: [],
      daemonicBondsCounter: 0,
      tetradaemonicTarget: []
    };
  },
  triggers: [{
    id: 'P10S Headmarker Tracker',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.decOffset === undefined,
    // Unconditionally set the first headmarker here so that future triggers are conditional.
    run: (data, matches) => p10s_getHeadmarkerId(data, matches)
  }, {
    id: 'P10S Ultima',
    type: 'StartsUsing',
    netRegex: {
      id: '82A5',
      source: p10s_bossNameUnicode,
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'P10S Soul Grasp',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => p10s_getHeadmarkerId(data, matches) === p10s_headmarkers.soulGrasp,
    response: responses/* Responses.sharedTankBuster */.n3.sharedTankBuster()
  }, {
    id: 'P10S Pandaemon\'s Holy',
    type: 'StartsUsing',
    netRegex: {
      id: '82A6',
      source: p10s_bossNameUnicode,
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'P10S Circles of Pandaemonium',
    type: 'StartsUsing',
    netRegex: {
      id: '82A7',
      source: p10s_bossNameUnicode,
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'P10S Wicked Step',
    type: 'StartsUsing',
    netRegex: {
      id: '8299',
      source: p10s_bossNameUnicode,
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.party.isTank(data.me)) return output.soak();
    },
    infoText: (data, _matches, output) => {
      if (!data.party.isTank(data.me)) return output.avoid();
    },
    outputStrings: {
      soak: {
        en: 'Soak tower',
        de: 'Türme nehmen',
        fr: 'Prenez une tour',
        ja: '塔踏み',
        cn: '踩塔击飞',
        ko: '기둥 들어가기'
      },
      avoid: {
        en: 'Avoid towers',
        de: 'Türme vermeiden',
        fr: 'Évitez les tours',
        ja: '塔回避',
        cn: '远离塔',
        ko: '기둥 피하기'
      }
    }
  }, {
    id: 'P10S Dividing Wings Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '8297',
      source: p10s_bossNameUnicode,
      capture: false
    },
    run: data => {
      data.dividingWingsTethers = [];
      data.dividingWingsStacks = [];
      data.dividingWingsEntangling = [];
    }
  }, {
    id: 'P10S Dividing Wings Tether',
    type: 'Tether',
    netRegex: {
      id: '00F2',
      source: p10s_bossNameUnicode
    },
    preRun: (data, matches) => data.dividingWingsTethers.push(matches.target),
    promise: async (data, matches) => {
      if (data.me === matches.target) {
        data.combatantData = [];
        const wingId = parseInt(matches.sourceId, 16);
        if (wingId === undefined) return;
        data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
          call: 'getCombatants',
          ids: [wingId]
        })).combatants;
      }
    },
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) {
        const x = data.combatantData[0]?.PosX;
        if (x === undefined) return output.default();
        let wingDir;
        if (x > 100) {
          wingDir = output.east();
        } else if (x < 100) {
          wingDir = output.west();
        }
        if (wingDir !== undefined) return output.tetherside({
          dir: wingDir
        });
        return output.default();
      }
    },
    outputStrings: {
      tetherside: {
        en: 'Point ${dir} Tether Away',
        de: 'Zeige ${dir} Verbindung weg',
        fr: 'Orientez le lien à l\'extérieur - ${dir}',
        ja: '線伸ばし ${dir}',
        cn: '向 ${dir} 外侧引导',
        ko: '선을 ${dir}으로'
      },
      default: {
        en: 'Point Tether Away',
        de: 'Zeige Verbindung weg',
        fr: 'Orientez le lien à l\'extérieur',
        ja: '線伸ばし',
        cn: '向外引导',
        ko: '선을 바깥쪽으로'
      },
      west: {
        en: 'Left/West',
        de: 'Links/Westen',
        fr: 'Gauche/Ouest',
        ja: '左/西へ',
        cn: '左(西)',
        ko: '왼쪽/서쪽'
      },
      east: {
        en: 'Right/East',
        de: 'Rechts/Osten',
        fr: 'Droite/Est',
        ja: '右/東へ',
        cn: '右(东)',
        ko: '오른쪽/동쪽'
      }
    }
  }, {
    id: 'P10S Dividing Wings Tether Break',
    type: 'Ability',
    netRegex: {
      id: '827F',
      source: p10s_bossNameUnicode,
      capture: false
    },
    condition: data => data.dividingWingsTethers.includes(data.me),
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Break Tethers',
        de: 'Verbindung brechen',
        fr: 'Cassez les liens',
        ja: '線切る',
        cn: '截断丝线',
        ko: '선 끊기'
      }
    }
  }, {
    id: 'P10S Dividing Wings Stack You',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => p10s_getHeadmarkerId(data, matches) === p10s_headmarkers.webShare,
    alertText: (data, matches, output) => {
      data.dividingWingsStacks.push(matches.target);
      if (data.me === matches.target) return output.stackOnYou();
    },
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou
    }
  }, {
    id: 'P10S Dividing Wings Stacks',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => p10s_getHeadmarkerId(data, matches) === p10s_headmarkers.webShare,
    delaySeconds: 0.5,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      // Need to check these conditions after the delay as they are ordered:
      // tethers, stack(s), (optional) entangling.
      if (data.dividingWingsTethers.includes(data.me)) return;
      if (data.dividingWingsStacks.includes(data.me)) return;
      if (data.dividingWingsEntangling.includes(data.me)) return;
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'Stack',
        de: 'Sammeln',
        fr: 'Package',
        ja: 'あたまわり',
        cn: '分摊连线',
        ko: '쉐어'
      }
    }
  }, {
    id: 'P10S Entangling Web',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      if (data.me !== matches.target) return false;
      return p10s_getHeadmarkerId(data, matches) === p10s_headmarkers.webEntangling;
    },
    alertText: (_data, _matches, output) => output.text(),
    // This will happen for non-dividing entangling web headmarkers,
    // but will get cleaned up in time for the next dividing wings.
    run: (data, matches) => data.dividingWingsEntangling.push(matches.target),
    outputStrings: {
      text: {
        // TODO: should we say "on posts" or "on back wall" based on count?
        en: 'Overlap Webs',
        de: 'Netze überlappen',
        fr: 'Superposez les toiles',
        ja: 'ウェブ重なる',
        cn: '用网搭桥',
        ko: '거미줄 겹치기'
      }
    }
  }, {
    id: 'P10S Pandaemoniac Pillars',
    type: 'StartsUsing',
    netRegex: {
      id: '8280',
      source: p10s_bossNameUnicode,
      capture: false
    },
    response: responses/* Responses.getTowers */.n3.getTowers('alert')
  }, {
    id: 'P10S Pandaemoniac Turrets',
    type: 'StartsUsing',
    netRegex: {
      id: '87AF',
      source: p10s_bossNameUnicode,
      capture: false
    },
    response: responses/* Responses.getTowers */.n3.getTowers('alert')
  }, {
    id: 'P10S Silkspit',
    type: 'StartsUsing',
    netRegex: {
      id: '827C',
      source: p10s_bossNameUnicode,
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread for Webs',
        de: 'Für Netze verteilen',
        fr: 'Écartez-vous pour les toiles',
        ja: 'ウェブ散会',
        cn: '网分散',
        ko: '거미줄 산개'
      }
    }
  }, {
    id: 'P10S Pandaemoniac Meltdown Spread',
    // These come out before the meltdown cast below.
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => p10s_getHeadmarkerId(data, matches) === p10s_headmarkers.spread,
    alarmText: (data, matches, output) => {
      data.meltdownSpreads.push(matches.target);
      if (data.me === matches.target) return output.spread();
    },
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread
    }
  }, {
    id: 'P10S Pandaemoniac Meltdown Stack',
    type: 'StartsUsing',
    netRegex: {
      id: '829D',
      source: p10s_bossNameUnicode,
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (!data.meltdownSpreads.includes(data.me)) return output.text();
    },
    run: data => data.meltdownSpreads = [],
    outputStrings: {
      text: {
        en: 'Line stack',
        de: 'Linien-Stack',
        fr: 'Packez-vous en ligne',
        ja: '直線あたまわり',
        cn: '直线分摊',
        ko: '직선 쉐어'
      }
    }
  }, {
    // Daemoniac Bonds starts casting
    // Then all of the Daemoniac Bonds DDE (spread) effects go out
    // Then 4x DDF or 2x E70 effects go out.
    id: 'P10S Pandaemoniac Bonds Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '82A1',
      source: p10s_bossNameUnicode,
      capture: false
    },
    run: data => {
      delete data.daemonicBondsTime;
      delete data.bondsSecondMechanic;
      data.tetradaemonicTarget = [];
      data.daemonicBondsCounter++;
    }
  }, {
    id: 'P10S Tetradaemoniac Bonds Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'E70'
    },
    run: (data, matches) => {
      data.tetradaemonicTarget.push(matches.target);
    }
  }, {
    id: 'P10S Daemoniac Bonds Timer',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'DDE'
    },
    condition: data => data.daemonicBondsTime === undefined,
    run: (data, matches) => data.daemonicBondsTime = parseFloat(matches.duration)
  }, {
    id: 'P10S Dueodaemoniac Bonds Future',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'DDF'
    },
    durationSeconds: 7,
    suppressSeconds: 5,
    infoText: (data, matches, output) => {
      if (data.daemonicBondsTime === undefined) {
        console.error(`Daemoniac Bonds: ${matches.effectId} effect before DDE?`);
        return;
      }
      const duration = parseFloat(matches.duration);
      if (duration > data.daemonicBondsTime) {
        data.bondsSecondMechanic = 'partners';
        return output.spreadThenPartners();
      }
      data.bondsSecondMechanic = 'spread';
      return output.partnersThenSpread();
    },
    outputStrings: {
      spreadThenPartners: {
        en: '(spread => partners, for later)',
        de: '(Verteilen => Partner, für später)',
        fr: '(Écartez-vous => Partenaires, pour après)',
        ja: '(散会 => ペア)',
        cn: '(稍后 分散 => 分摊)',
        ko: '(곧 산개 => 파트너)'
      },
      partnersThenSpread: {
        en: '(partners => spread, for later)',
        de: '(Partner => Verteilen, für später)',
        fr: '(Partenaires => Écartez-vous, pour après)',
        ja: '(ペア => 散会)',
        cn: '(稍后 分摊 => 分散)',
        ko: '(곧 파트너 => 산개)'
      }
    }
  }, {
    id: 'P10S TetraDaemoniac Bonds Future',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'E70'
    },
    durationSeconds: 7,
    infoText: (data, matches, output) => {
      if (data.daemonicBondsTime === undefined) {
        console.error(`Daemoniac Bonds: ${matches.effectId} effect before DDE?`);
        return;
      }
      if (data.tetradaemonicTarget.length !== 2) return;
      const duration = parseFloat(matches.duration);
      if (duration > data.daemonicBondsTime) {
        data.bondsSecondMechanic = 'stack';
        return output.spreadThenStack({
          player1: data.party.member(data.tetradaemonicTarget[0]),
          player2: data.party.member(data.tetradaemonicTarget[1])
        });
      }
      data.bondsSecondMechanic = 'spread';
      return output.stackThenSpread({
        player1: data.party.member(data.tetradaemonicTarget[0]),
        player2: data.party.member(data.tetradaemonicTarget[1])
      });
    },
    outputStrings: {
      spreadThenStack: {
        en: '(spread => role stack (${player1}, ${player2}), for later)',
        de: '(Verteilen => Rollengruppe (${player1}, ${player2}), für später)',
        fr: '(Écartez-vous => Package par rôle (${player1}, ${player2}), pour après)',
        ja: '(散会 => 4:4あたまわり (${player1}, ${player2}))',
        // FIXME
        cn: '(稍后 分散 => 四人分摊 (${player1}, ${player2}))',
        ko: '(곧 산개 => 직업군별 쉐어 (${player1}, ${player2}))'
      },
      stackThenSpread: {
        en: '(role stack (${player1}, ${player2}) => spread, for later)',
        de: '(Rollengruppe (${player1}, ${player2}) => Verteilen, für später)',
        fr: '(Package par rôle (${player1}, ${player2}) => Écartez-vous, pour après)',
        ja: '(4:4あたまわり (${player1}, ${player2}) => 散会)',
        // FIXME
        cn: '(稍后 四人分摊 (${player1}, ${player2}) => 分散)',
        ko: '(곧 직업군별 쉐어 (${player1}, ${player2}) => 산개)'
      }
    }
  }, {
    id: 'P10S Daemoniac Bonds First',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'DDE'
    },
    delaySeconds: bondsDelaySeconds,
    durationSeconds: bondsDurationSeconds,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      // If this is undefined, then this is the second mechanic and will be called out elsewhere.
      // We can't make this a `condition` as this is not known until after some delay.
      if (data.bondsSecondMechanic === 'stack') return output.spreadThenStack({
        player1: data.party.member(data.tetradaemonicTarget[0]),
        player2: data.party.member(data.tetradaemonicTarget[1])
      });
      if (data.bondsSecondMechanic === 'partners') return output.spreadThenPartners();
    },
    outputStrings: {
      spreadThenStack: {
        en: 'Spread => Role Stack (${player1}, ${player2})',
        de: 'Verteilen => Rollengruppe (${player1}, ${player2})',
        fr: 'Écartez-vous => Package par rôle (${player1}, ${player2})',
        ja: '散会 => 4:4あたまわり (${player1}, ${player2})',
        // FIXME
        cn: '分散 => 四人分摊 (${player1}, ${player2})',
        ko: '산개 => 직업군별 쉐어 (${player1}, ${player2})'
      },
      spreadThenPartners: {
        en: 'Spread => Partners',
        de: 'Verteilen => Partner',
        fr: 'Écartez-vous => Partenaires',
        ja: '散会 => ペア',
        cn: '分散 => 分摊',
        ko: '산개 => 파트너'
      }
    }
  }, {
    id: 'P10S Dueodaemoniac Bonds First',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'DDF'
    },
    delaySeconds: bondsDelaySeconds,
    durationSeconds: bondsDurationSeconds,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      // If this is undefined, then this is the second mechanic and will be called out elsewhere.
      if (data.bondsSecondMechanic === 'spread') return output.partnersThenSpread();
    },
    outputStrings: {
      partnersThenSpread: {
        en: 'Partners => Spread',
        de: 'Partner => Verteilen',
        fr: 'Partenaires => Écartez-vous',
        ja: 'ペア => 散会',
        cn: '分摊 => 分散',
        ko: '파트너 => 산개'
      }
    }
  }, {
    id: 'P10S TetraDaemoniac Bonds First',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'E70'
    },
    delaySeconds: bondsDelaySeconds,
    durationSeconds: bondsDurationSeconds,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      // If this is undefined, then this is the second mechanic and will be called out elsewhere.
      if (data.bondsSecondMechanic === 'spread') return output.stackThenSpread({
        player1: data.party.member(data.tetradaemonicTarget[0]),
        player2: data.party.member(data.tetradaemonicTarget[1])
      });
    },
    outputStrings: {
      stackThenSpread: {
        en: 'Role Stack (${player1}, ${player2}) => Spread',
        de: 'Rollengruppe (${player1}, ${player2}) => Verteilen',
        fr: 'Package par rôle (${player1}, ${player2}) => Écartez-vous',
        ja: '4:4あたまわり (${player1}, ${player2}) => 散会',
        // FIXME
        cn: '四人分摊 (${player1}, ${player2}) => 分散',
        ko: '직업군별 쉐어 (${player1}, ${player2}) => 산개'
      }
    }
  }, {
    id: 'P10S Daemoniac Bonds Followup',
    type: 'Ability',
    // 82A2 = Daemoniac Bonds (spread)
    // 82A3 = Dueodaemoniac Bonds (partners)
    // 87AE = TetraDaemoniac Bonds (4 person stacks)
    netRegex: {
      id: ['82A2', '82A3', '87AE'],
      source: p10s_bossNameUnicode,
      capture: false
    },
    condition: data => data.bondsSecondMechanic !== undefined,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (data.bondsSecondMechanic === 'spread') return output.spread();
      if (data.bondsSecondMechanic === 'partners') return output.partners();
      if (data.bondsSecondMechanic === 'stack') return output.stack({
        player1: data.party.member(data.tetradaemonicTarget[0]),
        player2: data.party.member(data.tetradaemonicTarget[1])
      });
    },
    run: data => delete data.bondsSecondMechanic,
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread,
      partners: {
        en: 'Partners',
        de: 'Partner',
        fr: 'Partenaires',
        ja: 'ペア',
        cn: '分摊',
        ko: '파트너'
      },
      stack: {
        en: 'Role Stack (${player1}, ${player2})',
        de: 'Rollengruppe (${player1}, ${player2})',
        fr: 'Package par rôle (${player1}, ${player2})',
        ja: '4:4あたまわり (${player1}, ${player2})',
        // FIXME
        cn: '四人分摊 (${player1}, ${player2})',
        ko: '직업군별 쉐어 (${player1}, ${player2})'
      }
    }
  }, {
    id: 'P10S Pandaemoniac Ray',
    type: 'StartsUsing',
    netRegex: {
      id: ['8289', '828B'],
      source: p10s_bossNameUnicode
    },
    infoText: (_data, matches, output) => {
      // Half-room cleave west (8289) or east (828B)
      const safeOutput = matches.id === '8289' ? 'east' : 'west';
      return output[safeOutput]();
    },
    outputStrings: {
      east: outputs/* default.getRightAndEast */.Z.getRightAndEast,
      west: outputs/* default.getLeftAndWest */.Z.getLeftAndWest
    }
  }, {
    id: 'P10S Jade Passage',
    // Track addition of Arcane Sphere combatants
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '12356'
    },
    suppressSeconds: 5,
    infoText: (_data, matches, output) => {
      const y = parseInt(matches.y);
      return Math.floor(y / 2) % 2 === 1 ? output.lines() : output.boxes();
    },
    outputStrings: {
      lines: {
        en: 'On Lines (Avoid Lasers)',
        de: 'Auf die Linien (vermeide Laser)',
        fr: 'Sur les lignes (évitez les lasers)',
        ja: 'レーザー回避(マスの境界の上)',
        cn: '站在线上（躲避激光）',
        ko: '경계선 위 (레이저 피하기)'
      },
      boxes: {
        en: 'Inside Boxes (Avoid Lasers)',
        de: 'In den Boxen (vermeide Laser)',
        fr: 'Dans les carrés (évitez les lasers)',
        ja: 'レーザー回避(マスの内側)',
        cn: '站方格内（躲避激光）',
        ko: '네모칸 안 (레이저 피하기)'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Pandaemon\'s Holy/Circles of Pandaemonium': 'Holy/Circles'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Arcane Sphere': 'arkan(?:e|er|es|en) Körper',
      'Pand(?:\\\\u00e6|\u00e6)moniac Pillar': 'pand\u00e6monisch(?:e|er|es|en) Turm',
      'Pand(?:\\\\u00e6|\u00e6)monium': 'Pand\u00e6monium'
    },
    'replaceText': {
      '\\(cast\\)': '(Wirken)',
      '\\(cone\\)': '(Kegel-AoE)',
      '\\(knockback\\)': '(Rückstoß)',
      '\\(share\\)': '(Teilen)',
      'Bury': 'Impakt',
      'Circles of Pandaemonium': 'Pandaemonischer Ring',
      'Dividing Wings': 'Teilungsstrahl',
      'Daemoniac Bonds': 'Dæmonische Fessel',
      'Entangling Web': 'Großnetz',
      'Harrowing Hell': 'Höllenpein der Tiefe',
      'Jade Passage': 'Jadeweg',
      'Pandaemoniac Meltdown': 'Pandaemonischer Kollaps',
      'Pandaemoniac Pillars': 'Pandaemonische Säule',
      'Pandaemoniac Ray': 'Pandaemonischer Strahl',
      'Pandaemoniac Turrets': 'Pandæmonischer Feuerturm',
      'Pandaemoniac Web': 'Pandæmonisches Netz',
      'Pandaemon\'s Holy': 'Pandaemonisches Sanctus',
      'Parted Plumes': 'Teilungsstrahl',
      'Peal of Condemnation': 'Verdammungsschub',
      'Peal of Damnation': 'Kanone der Verdammnis',
      'Silkspit': 'Spucknetz',
      'Soul Grasp': 'Seelengreifer',
      'Steel Web': 'Schwernetz',
      'Touchdown': 'Himmelssturz',
      'Ultima': 'Ultima',
      'Wicked Step': 'Übler Schritt'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Arcane Sphere': 'sphère arcanique',
      'Pand(?:\\\\u00e6|\u00e6)moniac Pillar': 'pilier pand\u00e6moniaque',
      'Pand(?:\\\\u00e6|\u00e6)monium': 'Pand\u00e6monium'
    },
    'replaceText': {
      'Bury': 'Impact',
      'Circles of Pandaemonium': 'Anneau pandaemoniaque',
      'Dividing Wings': 'Ailes fendantes',
      'Daemoniac Bonds': 'Lien pandæmoniaque',
      'Entangling Web': 'Grande toile',
      'Harrowing Hell': 'Assaut sismique',
      'Jade Passage': 'Sentier de Jade',
      'Pandaemoniac Meltdown': 'Fusion pandaemoniaque',
      'Pandaemoniac Pillars': 'Piliers pandaemoniaques',
      'Pandaemoniac Ray': 'Rayon pandaemoniaque',
      'Pandaemoniac Turrets': 'Tourelles pandæmoniaques',
      'Pandaemoniac Web': 'Toile pandæmoniaque',
      'Pandaemon\'s Holy': 'Miracle pandaemoniaque',
      'Parted Plumes': 'Plumes fendantes',
      'Peal of Condemnation': 'Électrochoc condamnant',
      'Peal of Damnation': 'Électrochoc damnant',
      'Silkspit': 'Crachat de toile',
      'Soul Grasp': 'Saisie d\'âme',
      'Steel Web': 'Toile dense',
      'Touchdown': 'Atterrissage',
      'Ultima': 'Ultima',
      'Wicked Step': 'Pattes effilées'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Arcane Sphere': '立体魔法陣',
      'Pand(?:\\\\u00e6|\u00e6)moniac Pillar': '万魔殿の塔',
      'Pand(?:\\\\u00e6|\u00e6)monium': 'パンデモニウム'
    },
    'replaceText': {
      'Bury': '衝撃',
      'Circles of Pandaemonium': 'パンデモニックリング',
      'Dividing Wings': 'ディバイドウィング',
      'Daemoniac Bonds': 'パンデモニックボンド',
      'Entangling Web': 'グランドウェブ',
      'Harrowing Hell': '魔殿の震撃',
      'Jade Passage': 'ロード・オブ・ジェイド',
      'Pandaemoniac Meltdown': 'パンデモニックメルトン',
      'Pandaemoniac Pillars': 'パンデモニックピラー',
      'Pandaemoniac Ray': 'パンデモニックレイ',
      'Pandaemoniac Turrets': 'パンデモニックタレット',
      'Pandaemoniac Web': 'パンデモニックウェブ',
      'Pandaemon\'s Holy': 'パンデモニックホーリー',
      'Parted Plumes': 'ディバイドプルーム',
      'Peal of Condemnation': 'コンデムブラスター',
      'Peal of Damnation': 'ダムドブラスター',
      'Silkspit': 'スピットウェブ',
      'Soul Grasp': 'ソウルグラスプ',
      'Steel Web': 'ヘビーウェブ',
      'Touchdown': 'タッチダウン',
      'Ultima': 'アルテマ',
      'Wicked Step': '尖脚'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Arcane Sphere': '立体魔法阵',
      'Pand(?:\\\\u00e6|\u00e6)moniac Pillar': '万魔殿之塔',
      'Pand(?:\\\\u00e6|\u00e6)monium': '万魔殿'
    },
    'replaceText': {
      '\\(cast\\)': '(咏唱)',
      '\\(cone\\)': '(锥形)',
      '\\(knockback\\)': '(击退)',
      '\\(share\\)': '(分摊)',
      'Bury': '塌方',
      'Circles of Pandaemonium': '万魔殿之环',
      'Dividing Wings': '分割之翼',
      'Daemoniac Bonds': '万魔殿牢狱',
      'Entangling Web': '纠缠之网',
      'Harrowing Hell': '魔殿震击',
      'Jade Passage': '翡翠通道',
      'Pandaemoniac Meltdown': '万魔殿熔毁',
      'Pandaemoniac Pillars': '万魔殿之柱',
      'Pandaemoniac Ray': '万魔殿射线',
      'Pandaemoniac Turrets': '万魔殿炮塔',
      'Pandaemoniac Web': '万魔殿之网',
      'Pandaemon\'s Holy': '万魔殿神圣',
      'Parted Plumes': '分割之羽',
      'Peal of Condemnation': '谴责冲击波',
      'Peal of Damnation': '诅咒冲击波',
      'Silkspit': '喷吐丝网',
      'Soul Grasp': '攥魂',
      'Steel Web': '沉重之网',
      'Touchdown': '空降',
      'Ultima': '究极',
      'Wicked Step': '尖脚'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Arcane Sphere': '입체마법진',
      'Pand(?:\\\\u00e6|\u00e6)moniac Pillar': '마의 전당 탑',
      'Pand(?:\\\\u00e6|\u00e6)monium': '판데모니움'
    },
    'replaceText': {
      '\\(cast\\)': '(시전)',
      '\\(cone\\)': '(부채꼴)',
      '\\(knockback\\)': '(넉백)',
      '\\(share\\)': '(쉐어)',
      'Bury': '충격',
      'Circles of Pandaemonium': '판데모니움 고리',
      'Dividing Wings': '날개 분리',
      'Daemoniac Bonds': '판데모니움 결속',
      'Entangling Web': '거대 거미줄',
      'Harrowing Hell': '판데모니움 격돌',
      'Jade Passage': '제이드 통로',
      'Pandaemoniac Meltdown': '판데모니움 멜튼',
      'Pandaemoniac Pillars': '판데모니움 기둥',
      'Pandaemoniac Ray': '판데모니움 광선',
      'Pandaemoniac Turrets': '판데모니움 포탑',
      'Pandaemoniac Web': '판데모니움 거미줄',
      'Pandaemon\'s Holy': '판데모니움 홀리',
      'Parted Plumes': '깃털 분리',
      'Peal of Condemnation': '형벌 선포',
      'Peal of Damnation': '천벌 선포',
      'Silkspit': '거미줄 뱉기',
      'Soul Grasp': '영혼 장악',
      'Steel Web': '강력 거미줄',
      'Touchdown': '착지',
      'Ultima': '알테마',
      'Wicked Step': '뾰족다리'
    }
  }]
};
/* harmony default export */ const p10s = (p10s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p10s.txt
const raid_p10s_namespaceObject = "### P10S: Anabaseios: The Tenth Circle (Savage)\r\n\r\n# -p 82A5:14.1\r\n# -ii 82A0 8281 8284 8286 87B1 829E 828A 8296\r\n\r\n# Ignored abilities\r\n# Pandaemonium:82A0 Soul Grasp (damage)\r\n# Pandaemoniac Pillar:8281 Bury (self-targeted)\r\n# Pandaemoniac Pillar:8286 Cannonspawn (self-targeted)\r\n# Pandaemoniac Pillar:8284 Imprisonment (self-targeted)\r\n# Pandaemonium:8287 Cannonspawn (damage)\r\n# Pandaemonium:8285 Imprisonment (damage)\r\n# Pandaemonium:87B1 Pandaemoniac Meltdown (spread laser damage)\r\n# Pandaemonium:829E Pandaemoniac Meltdown (line stack damage)\r\n# Pandaemonium:828E Touchdown (damage)\r\n# Pandaemonium:828A Pandaemoniac Ray (damage)\r\n# Pandaemonium:8296 Parted Plumes (damage)\r\n\r\n# TODO: should we get rid of \"(cast)\" abilities and mark them \"--sync--\"\r\n# as they are not particularly useful mit-wise?\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n9.1 \"--sync--\" StartsUsing { id: \"82A5\", source: \"Pand\\\\u00e6monium\" } window 15,15\r\n14.1 \"Ultima\" Ability { id: \"82A5\", source: \"Pand\\\\u00e6monium\" }\r\n23.2 \"Soul Grasp x4\" Ability { id: \"829F\", source: \"Pand\\\\u00e6monium\" } duration 5.7\r\n34.7 \"Dividing Wings (cast)\" Ability { id: \"8297\", source: \"Pand\\\\u00e6monium\" }\r\n40.8 \"Steel Web (cast)\" Ability { id: \"8723\", source: \"Pand\\\\u00e6monium\" }\r\n48.5 \"Dividing Wings (cone)\" Ability { id: \"8298\", source: \"Pand\\\\u00e6monium\" }\r\n48.7 \"Steel Web (share)\" Ability { id: \"827F\", source: \"Pand\\\\u00e6monium\" }\r\n58.7 \"Pandaemon's Holy/Circles of Pandaemonium\" Ability { id: [\"82A6\", \"82A7\"], source: \"Pand\\\\u00e6monium\" }\r\n67.4 \"--sync--\" Ability { id: \"8299\", source: \"Pand\\\\u00e6monium\" }\r\n68.5 \"Wicked Step 1\" Ability { id: \"829A\", source: \"Pand\\\\u00e6monium\" }\r\n70.9 \"Wicked Step 2\" Ability { id: \"829B\", source: \"Pand\\\\u00e6monium\" }\r\n78.6 \"Entangling Web (cast)\" Ability { id: \"8722\", source: \"Pand\\\\u00e6monium\" }\r\n89.6 \"Entangling Web\" Ability { id: \"827E\", source: \"Pand\\\\u00e6monium\" }\r\n\r\n96.0 \"Pandaemoniac Pillars\" Ability { id: \"8280\", source: \"Pand\\\\u00e6monium\" }\r\n97.3 \"Bury\" Ability { id: \"8282\", source: \"Pand\\\\u00e6monium\" }\r\n102.9 \"Pandaemon's Holy/Circles of Pandaemonium\" Ability { id: [\"82A6\", \"82A7\"], source: \"Pand\\\\u00e6monium\" }\r\n103.0 \"Peal of Damnation\" Ability { id: \"87B0\", source: \"Pand\\\\u00e6moniac Pillar\" }\r\n\r\n108.4 \"Silkspit (cast)\" Ability { id: \"827C\", source: \"Pand\\\\u00e6monium\" }\r\n118.4 \"Silkspit\" Ability { id: \"827D\", source: \"Pand\\\\u00e6monium\" }\r\n122.8 \"Daemoniac Bonds\" Ability { id: \"82A1\", source: \"Pand\\\\u00e6monium\" }\r\n126.9 \"--sync--\" Ability { id: \"6854\", source: \"Pand\\\\u00e6monium\" }\r\n131.9 \"Pandaemoniac Meltdown\" Ability { id: \"829D\", source: \"Pand\\\\u00e6monium\" }\r\n\r\n144.2 \"Touchdown\" Ability { id: \"828D\", source: \"Pand\\\\u00e6monium\" }\r\n145.8 \"Daemoniac Bonds 1\" Ability { id: [\"82A2\", \"82A3\", \"87AE\"], source: \"Pand\\\\u00e6monium\" }\r\n148.8 \"Daemoniac Bonds 2\" Ability { id: [\"82A2\", \"82A3\", \"87AE\"], source: \"Pand\\\\u00e6monium\" }\r\n\r\n159.8 \"Ultima\" Ability { id: \"82A5\", source: \"Pand\\\\u00e6monium\" }\r\n168.9 \"Soul Grasp x4\" Ability { id: \"829F\", source: \"Pand\\\\u00e6monium\" } duration 5.7\r\n\r\n185.0 \"Daemoniac Bonds\" Ability { id: \"82A1\", source: \"Pand\\\\u00e6monium\" }\r\n194.1 \"Pandaemoniac Turrets\" Ability { id: \"87AF\", source: \"Pand\\\\u00e6monium\" }\r\n195.4 \"Bury\" Ability { id: \"8282\", source: \"Pand\\\\u00e6monium\" }\r\n206.1 \"Peal of Condemnation 1\" Ability { id: \"8288\", source: \"Pand\\\\u00e6moniac Pillar\" }\r\n210.7 \"Peal of Condemnation 2\" Ability { id: \"8288\", source: \"Pand\\\\u00e6moniac Pillar\" }\r\n215.1 \"Peal of Condemnation 3\" Ability { id: \"8288\", source: \"Pand\\\\u00e6moniac Pillar\" }\r\n219.7 \"Peal of Condemnation 4\" Ability { id: \"8288\", source: \"Pand\\\\u00e6moniac Pillar\" }\r\n\r\n223.9 \"Daemoniac Bonds 1\" Ability { id: [\"82A2\", \"82A3\", \"87AE\"], source: \"Pand\\\\u00e6monium\" }\r\n226.9 \"Daemoniac Bonds 2\" Ability { id: [\"82A2\", \"82A3\", \"87AE\"], source: \"Pand\\\\u00e6monium\" }\r\n233.8 \"Pandaemoniac Ray\" Ability { id: [\"8289\", \"828B\"], source: \"Pand\\\\u00e6monium\" }\r\n237.6 \"Jade Passage\" Ability { id: \"828C\", source: \"Arcane Sphere\" }\r\n\r\n249.3 \"Ultima\" Ability { id: \"82A5\", source: \"Pand\\\\u00e6monium\" }\r\n258.4 \"Soul Grasp x4\" Ability { id: \"829F\", source: \"Pand\\\\u00e6monium\" } duration 5.7\r\n277.5 \"--sync--\" Ability { id: \"8299\", source: \"Pand\\\\u00e6monium\" }\r\n278.6 \"Wicked Step 1\" Ability { id: \"829A\", source: \"Pand\\\\u00e6monium\" }\r\n281.0 \"Wicked Step 2\" Ability { id: \"829B\", source: \"Pand\\\\u00e6monium\" }\r\n288.7 \"Entangling Web (cast)\" Ability { id: \"8722\", source: \"Pand\\\\u00e6monium\" }\r\n298.9 \"Silkspit (cast)\" Ability { id: \"827C\", source: \"Pand\\\\u00e6monium\" }\r\n299.6 \"Entangling Web\" Ability { id: \"827E\", source: \"Pand\\\\u00e6monium\" }\r\n\r\n308.0 \"Daemoniac Bonds\" Ability { id: \"82A1\", source: \"Pand\\\\u00e6monium\" }\r\n308.9 \"Silkspit\" Ability { id: \"827D\", source: \"Pand\\\\u00e6monium\" }\r\n316.2 \"Pandaemoniac Pillars\" Ability { id: \"8280\", source: \"Pand\\\\u00e6monium\" }\r\n317.5 \"Bury\" Ability { id: \"8282\", source: \"Pand\\\\u00e6monium\" }\r\n323.1 \"Pandaemon's Holy/Circles of Pandaemonium\" Ability { id: [\"82A6\", \"82A7\"], source: \"Pand\\\\u00e6monium\" }\r\n323.2 \"Peal of Damnation\" Ability { id: \"87B0\", source: \"Pand\\\\u00e6moniac Pillar\" }\r\n\r\n329.9 \"Daemoniac Bonds 1\" Ability { id: [\"82A2\", \"82A3\", \"87AE\"], source: \"Pand\\\\u00e6monium\" }\r\n330.6 \"Pandaemoniac Ray\" Ability { id: [\"8289\", \"828B\"], source: \"Pand\\\\u00e6monium\" }\r\n333.9 \"Daemoniac Bonds 2\" Ability { id: [\"82A2\", \"82A3\", \"87AE\"], source: \"Pand\\\\u00e6monium\" }\r\n\r\n334.3 \"Jade Passage\" #Ability { id: \"828C\", source: \"Arcane Sphere\" }\r\n338.6 \"Dividing Wings\" Ability { id: \"8297\", source: \"Pand\\\\u00e6monium\" }\r\n344.7 \"Steel Web (cast)\" Ability { id: \"8723\", source: \"Pand\\\\u00e6monium\" }\r\n356.8 \"Touchdown\" Ability { id: \"828D\", source: \"Pand\\\\u00e6monium\" }\r\n357.4 \"Dividing Wings\" Ability { id: \"8298\", source: \"Pand\\\\u00e6monium\" }\r\n357.7 \"Steel Web\" Ability { id: \"827F\", source: \"Pand\\\\u00e6monium\" }\r\n357.7 \"Touchdown\" Ability { id: \"828E\", source: \"Pand\\\\u00e6monium\" }\r\n370.3 \"--sync--\" Ability { id: \"6854\", source: \"Pand\\\\u00e6monium\" }\r\n375.3 \"Pandaemoniac Meltdown\" Ability { id: \"829D\", source: \"Pand\\\\u00e6monium\" }\r\n384.6 \"Soul Grasp x4\" Ability { id: \"829F\", source: \"Pand\\\\u00e6monium\" } duration 5.7\r\n\r\n405.0 \"Dividing Wings\" Ability { id: \"8297\", source: \"Pand\\\\u00e6monium\" }\r\n411.1 \"Pandaemoniac Web (cast)\" Ability { id: \"8724\", source: \"Pand\\\\u00e6monium\" }\r\n418.9 \"Dividing Wings\" Ability { id: \"8298\", source: \"Pand\\\\u00e6monium\" }\r\n419.1 \"Steel Web\" Ability { id: \"827F\", source: \"Pand\\\\u00e6monium\" }\r\n419.2 \"Pandaemon's Holy\" Ability { id: \"82A6\", source: \"Pand\\\\u00e6monium\" }\r\n422.1 \"Entangling Web\" Ability { id: \"827E\", source: \"Pand\\\\u00e6monium\" }\r\n426.4 \"Daemoniac Bonds\" Ability { id: \"82A1\", source: \"Pand\\\\u00e6monium\" }\r\n428.1 \"Entangling Web\" Ability { id: \"827E\", source: \"Pand\\\\u00e6monium\" }\r\n\r\n437.8 \"Harrowing Hell (cast)\" Ability { id: \"828F\", source: \"Pand\\\\u00e6monium\" }\r\n438.8 \"Harrowing Hell 1\" Ability { id: \"8290\", source: \"Pand\\\\u00e6monium\" }\r\n440.8 \"Harrowing Hell 2\" Ability { id: \"8291\", source: \"Pand\\\\u00e6monium\" }\r\n442.6 \"Harrowing Hell 3\" Ability { id: \"8292\", source: \"Pand\\\\u00e6monium\" }\r\n444.3 \"Harrowing Hell 4\" Ability { id: \"8293\", source: \"Pand\\\\u00e6monium\" }\r\n446.0 \"Harrowing Hell 5\" Ability { id: \"86B9\", source: \"Pand\\\\u00e6monium\" }\r\n447.6 \"Harrowing Hell 6\" Ability { id: \"86BA\", source: \"Pand\\\\u00e6monium\" }\r\n448.9 \"Harrowing Hell 7\" Ability { id: \"86BB\", source: \"Pand\\\\u00e6monium\" }\r\n450.1 \"Harrowing Hell 8\" Ability { id: \"86BC\", source: \"Pand\\\\u00e6monium\" }\r\n454.0 \"Harrowing Hell (knockback)\" Ability { id: \"8294\", source: \"Pand\\\\u00e6monium\" }\r\n\r\n459.3 \"Daemoniac Bonds 1\" Ability { id: [\"82A2\", \"82A3\", \"87AE\"], source: \"Pand\\\\u00e6monium\" }\r\n462.3 \"Daemoniac Bonds 2\" Ability { id: [\"82A2\", \"82A3\", \"87AE\"], source: \"Pand\\\\u00e6monium\" }\r\n\r\n480.5 \"Ultima\" Ability { id: \"82A5\", source: \"Pand\\\\u00e6monium\" }\r\n490.6 \"Soul Grasp x4\" Ability { id: \"829F\", source: \"Pand\\\\u00e6monium\" } duration 5.7\r\n512.9 \"--sync--\" Ability { id: \"8299\", source: \"Pand\\\\u00e6monium\" }\r\n514.0 \"Wicked Step 1\" Ability { id: \"829A\", source: \"Pand\\\\u00e6monium\" }\r\n516.4 \"Wicked Step 2\" Ability { id: \"829B\", source: \"Pand\\\\u00e6monium\" }\r\n523.1 \"Entangling Web (cast)\" Ability { id: \"8722\", source: \"Pand\\\\u00e6monium\" }\r\n534.1 \"Entangling Web\" Ability { id: \"827E\", source: \"Pand\\\\u00e6monium\" }\r\n\r\n543.8 \"Parted Plumes\" Ability { id: \"8295\", source: \"Pand\\\\u00e6monium\" } duration 10\r\n\r\n555.9 \"Pandaemoniac Ray\" Ability { id: [\"8289\", \"828B\"], source: \"Pand\\\\u00e6monium\" }\r\n\r\n559.7 \"Jade Passage\" Ability { id: \"828C\", source: \"Arcane Sphere\" }\r\n563.0 \"Pandaemon's Holy/Circles of Pandaemonium\" Ability { id: [\"82A6\", \"82A7\"], source: \"Pand\\\\u00e6monium\" }\r\n569.1 \"Silkspit (cast)\" Ability { id: \"827C\", source: \"Pand\\\\u00e6monium\" }\r\n579.1 \"Silkspit\" Ability { id: \"827D\", source: \"Pand\\\\u00e6monium\" }\r\n\r\n586.4 \"Pandaemoniac Pillars\" Ability { id: \"8280\", source: \"Pand\\\\u00e6monium\" }\r\n587.3 \"Bury\" Ability { id: \"8281\", source: \"Pand\\\\u00e6moniac Pillar\" }\r\n593.3 \"Pandaemon's Holy/Circles of Pandaemonium\" Ability { id: [\"82A6\", \"82A7\"], source: \"Pand\\\\u00e6monium\" }\r\n593.4 \"Peal of Damnation\" Ability { id: \"87B0\", source: \"Pand\\\\u00e6moniac Pillar\" }\r\n\r\n595.8 \"--sync--\" Ability { id: \"6854\", source: \"Pand\\\\u00e6monium\" }\r\n600.8 \"Pandaemoniac Meltdown\" Ability { id: \"829D\", source: \"Pand\\\\u00e6monium\" }\r\n\r\n623.5 \"Harrowing Hell (cast)\" Ability { id: \"828F\", source: \"Pand\\\\u00e6monium\" }\r\n624.5 \"Harrowing Hell 1\" Ability { id: \"8290\", source: \"Pand\\\\u00e6monium\" }\r\n626.5 \"Harrowing Hell 2\" Ability { id: \"8291\", source: \"Pand\\\\u00e6monium\" }\r\n628.3 \"Harrowing Hell 3\" Ability { id: \"8292\", source: \"Pand\\\\u00e6monium\" }\r\n630.0 \"Harrowing Hell 4\" Ability { id: \"8293\", source: \"Pand\\\\u00e6monium\" }\r\n631.7 \"Harrowing Hell 5\" Ability { id: \"86B9\", source: \"Pand\\\\u00e6monium\" }\r\n633.3 \"Harrowing Hell 6\" Ability { id: \"86BA\", source: \"Pand\\\\u00e6monium\" }\r\n634.6 \"Harrowing Hell 7\" Ability { id: \"86BB\", source: \"Pand\\\\u00e6monium\" }\r\n635.8 \"Harrowing Hell 8\" Ability { id: \"86BC\", source: \"Pand\\\\u00e6monium\" }\r\n639.7 \"Harrowing Hell (enrage)\" Ability { id: \"8294\", source: \"Pand\\\\u00e6monium\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p11n.ts




const p11n_triggerSet = {
  id: 'AnabaseiosTheEleventhCircle',
  zoneId: zone_id/* default.AnabaseiosTheEleventhCircle */.Z.AnabaseiosTheEleventhCircle,
  timelineFile: 'p11n.txt',
  triggers: [{
    id: 'P11N Eunomia',
    type: 'StartsUsing',
    netRegex: {
      id: '81E2',
      source: 'Themis',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'P11N Divisive Ruling In',
    type: 'StartsUsing',
    netRegex: {
      id: '81B4',
      source: 'Themis',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Cleave -> In',
        de: 'Linien AoE -> Rein',
        fr: 'AoE en ligne -> Intérieur',
        ja: '直線AOE -> 内側へ',
        cn: '直线AoE -> 靠近',
        ko: '직선 장판 -> 안으로'
      }
    }
  }, {
    id: 'P11N Divisive Ruling Out',
    type: 'StartsUsing',
    netRegex: {
      id: '81B3',
      source: 'Themis',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Cleave -> Out',
        de: 'Linien AoE -> Raus',
        fr: 'AoE en ligne -> Extérieur',
        ja: '直線AOE -> 離れる',
        cn: '直线AoE -> 远离',
        ko: '직선 장판 -> 바깥으로'
      }
    }
  }, {
    id: 'P11N Dark Discord',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'DE4'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get in light puddle',
        de: 'Geh in die Licht-Fläche',
        fr: 'Allez dans la flaque de lumière',
        ja: 'ひかりの内側へ',
        cn: '前往光区域',
        ko: '빛 장판 안으로'
      }
    }
  }, {
    id: 'P11N Light Discord',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'DE3'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get in dark puddle',
        de: 'Geh in die Dunkel-Fläche',
        fr: 'Allez dans la flaque sombre',
        ja: 'やみの内側へ',
        cn: '前往暗区域',
        ko: '어둠 장판 안으로'
      }
    }
  }, {
    id: 'P11N Dineis',
    type: 'StartsUsing',
    netRegex: {
      id: '8725',
      source: 'Themis',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait puddles x2',
        de: 'Köder Fläche x2',
        fr: 'Déposez les flaques x2',
        ja: 'AOE誘導 x2',
        cn: '放置点名 x2',
        ko: '장판 유도 x2'
      }
    }
  }, {
    id: 'P11N Dismissal Ruling Dynamo',
    type: 'StartsUsing',
    netRegex: {
      id: '81FB',
      source: 'Themis',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback -> get in',
        de: 'Rückstoß -> geh rein',
        fr: 'Poussée -> Intérieur',
        ja: 'ノックバック => 内側へ',
        cn: '击退 -> 去脚下',
        ko: '넉백 -> 안으로'
      }
    }
  }, {
    id: 'P11N Dismissal Ruling Chariot',
    type: 'StartsUsing',
    netRegex: {
      id: '81FA',
      source: 'Themis',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback -> stay out',
        de: 'Rückstoß -> bleib außen',
        fr: 'Poussée -> Restez à l\'extérieur',
        ja: 'ノックバック => そのまま',
        cn: '击退 -> 远离',
        ko: '넉백 -> 바깥에 있기'
      }
    }
  }, {
    id: 'P11N Dike Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '00DA'
    },
    run: (data, matches) => {
      data.busterTargets ??= [];
      data.busterTargets.push(matches.target);
    }
  }, {
    id: 'P11N Dike Call',
    type: 'HeadMarker',
    netRegex: {
      id: '00DA',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 10,
    infoText: (data, _matches, output) => {
      if (data.busterTargets?.includes(data.me)) return output.busterOnYou();
      return output.busterOthers();
    },
    run: data => delete data.busterTargets,
    outputStrings: {
      busterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
      busterOthers: outputs/* default.tankBusters */.Z.tankBusters
    }
  }, {
    id: 'P11N Upheld Ruling Dynamo',
    type: 'HeadMarker',
    netRegex: {
      id: '01CF'
    },
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return output.avoidCleave({
        target: data.party.member(matches.target)
      });
      return output.cleaveOnYou();
    },
    outputStrings: {
      avoidCleave: {
        en: 'Cleaving ${target} -> get in',
        de: 'Cleave auf ${target} -> geh Rein',
        fr: 'Cleave sur ${target} -> Intérieur',
        ja: '${target}が対象 => 内側へ',
        cn: '引导 ${target} -> 去脚下',
        ko: '"${target}"에게 광역기 -> 안으로'
      },
      cleaveOnYou: {
        en: 'Cleave on YOU -> stay in',
        de: 'Cleave auf DIR -> bleib drin',
        fr: 'Cleave sur VOUS -> Restez à l\'intérieur',
        ja: '自分が対象 => 内側へ',
        cn: '引导 -> 站在脚下',
        ko: '광역기 대상자 -> 안에 있기'
      }
    }
  }, {
    id: 'P11N Upheld Ruling Chariot',
    type: 'HeadMarker',
    netRegex: {
      id: '013E'
    },
    infoText: (data, matches, output) => {
      return output.text({
        target: data.party.member(matches.target)
      });
    },
    outputStrings: {
      text: {
        en: 'Stack on ${target} -> get out',
        de: 'Auf ${target} Sammeln -> geh raus',
        fr: 'Package sur ${target} -> Extérieur',
        ja: '${target}とあたまわり => 外側へ',
        cn: '分摊 ${target} -> 远离',
        ko: '"${target}" 쉐어 -> 밖으로'
      }
    }
  }, {
    id: 'P11N Styx',
    type: 'HeadMarker',
    netRegex: {
      id: '0131'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'P11N Blinding Light',
    type: 'HeadMarker',
    netRegex: {
      id: '01D2'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'P11N Divisive Ruling Double',
    type: 'StartsUsing',
    netRegex: {
      id: '81D7',
      source: 'Illusory Themis',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Cleave -> In on dark adds',
        de: 'Linien AoE -> Rein auf dunkle Adds',
        fr: 'AoE en ligne -> Intérieur sur les adds sombres',
        ja: '直線AOE -> やみ回避',
        cn: '直线AoE -> 呆在暗区域',
        ko: '직선 장판 -> 어두운 장판 피하기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Illusory Themis': 'Phantom-Themis',
      '(?<!(-| ))Themis': 'Themis'
    },
    'replaceText': {
      '\\(random\\)': '(Zufall)',
      '\\(cast\\)': '(Ausführen)',
      '\\(puddle': '(Fläche',
      '\\(in/out\\)': '(rein/raus)',
      'dynamo\\)': 'Donut)',
      'chariot\\)': 'AoE-Fläche)',
      '\\(cleave': '(Cleave',
      '\\(stack': '(Sammeln',
      'Blinding Light': 'Blendendes Licht',
      'Dark Perimeter': 'Dunkler Kreis',
      'Dark and Light': 'Licht-Dunkel-Schlichtung',
      'Dike': 'Dike',
      'Dineis': 'Dine',
      'Dismissal Ruling': 'Verweisungsbeschluss',
      'Divine Ruination': 'Lichtbombe',
      'Divisive Ruling': 'Auflösungsbeschluss',
      'Emissary\'s Will': 'Schlichtung',
      'Eunomia': 'Eunomia',
      'Inner Light': 'Gleißendes Inneres',
      'Lightburst': 'Lichtstoß',
      'Outer Dark': 'Dunkles Äußeres',
      'Ripples of Gloom': 'Wellen der Betrübung',
      'Shadowed Messengers': 'Boten des Schattens',
      'Sigils of Discord': 'Siegel der Uneinigkeit',
      'Styx': 'Styx',
      'Upheld Ruling': 'Erhebungsbeschluss'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Illusory Themis': 'spectre de Thémis',
      '(?<! )Themis': 'Thémis'
    },
    'replaceText': {
      'Blinding Light': 'Lumière aveuglante',
      'Dark Perimeter': 'Cercle ténébreux',
      'Dark and Light': 'Médiation Lumière-Ténèbres',
      'Dike': 'Diké',
      'Dineis': 'Diné',
      'Dismissal Ruling': 'Rejet et décision',
      'Divine Ruination': 'Explosion sacrée',
      'Divisive Ruling': 'Partage et décision',
      'Emissary\'s Will': 'Médiation',
      'Eunomia': 'Eunomia',
      'Inner Light': 'Chatoiement interne',
      'Lightburst': 'Éclat de lumière',
      'Outer Dark': 'Obscurité externe',
      'Ripples of Gloom': 'Onde des ténèbres',
      'Shadowed Messengers': 'Fantasmagorie des préceptes',
      'Sigils of Discord': 'Pentacles de dissonance',
      'Styx': 'Styx',
      'Upheld Ruling': 'Maintien et décision'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Illusory Themis': 'テミスの幻影',
      '(?<! )Themis': 'テミス'
    },
    'replaceText': {
      'Blinding Light': '光弾',
      'Dark Perimeter': 'ダークサークル',
      'Dark and Light': '光と闇の調停',
      'Dike': 'ディケー',
      'Dineis': 'ディーネ',
      'Dismissal Ruling': 'ディスミサル＆ルーリング',
      'Divine Ruination': '光爆',
      'Divisive Ruling': 'ディバイド＆ルーリング',
      'Emissary\'s Will': '調停',
      'Eunomia': 'エウノミアー',
      'Inner Light': 'インナーグレア',
      'Lightburst': 'ライトバースト',
      'Outer Dark': 'アウターダーク',
      'Ripples of Gloom': '闇の衝撃',
      'Shadowed Messengers': '戒律の幻奏',
      'Sigils of Discord': '不和の判紋',
      'Styx': 'ステュクス',
      'Upheld Ruling': 'アップヘルド＆ルーリング'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Illusory Themis': '特弥斯的幻影',
      '(?<!(-| ))Themis': '特弥斯'
    },
    'replaceText': {
      '\\(random\\)': '(随机)',
      '\\(cast\\)': '(咏唱)',
      '\\(puddle': '(圈',
      '\\(in/out\\)': '(内/外)',
      'dynamo\\)': '月环)',
      'chariot\\)': '钢铁)',
      '\\(cleave': '(顺劈',
      '\\(stack': '(集合',
      'Blinding Light': '光弹',
      'Dark Perimeter': '黑暗回环',
      'Dark and Light': '光与暗的调停',
      'Dike': '正义',
      'Dineis': '旋涡',
      'Dismissal Ruling': '驳回判决',
      'Divine Ruination': '光爆',
      'Divisive Ruling': '分歧判决',
      'Emissary\'s Will': '调停者之意',
      'Eunomia': '秩序',
      'Inner Light': '内光',
      'Lightburst': '光爆破',
      'Outer Dark': '外暗',
      'Ripples of Gloom': '暗黑冲击',
      'Shadowed Messengers': '戒律幻奏',
      'Sigils of Discord': '失调的判纹',
      'Styx': '仇恨',
      'Upheld Ruling': '维持判决'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Illusory Themis': '테미스의 환영',
      '(?<!(-| ))Themis': '테미스'
    },
    'replaceText': {
      '\\(random\\)': '(랜덤)',
      '\\(cast\\)': '(시전)',
      '\\(puddle': '(장판',
      '\\(in/out\\)': '(안/밖)',
      'dynamo\\)': '도넛)',
      'chariot\\)': '원형)',
      '\\(cleave': '(탱버',
      '\\(stack': '(쉐어',
      'Blinding Light': '빛 폭탄',
      'Dark Perimeter': '어둠의 둘레',
      'Dark and Light': '빛과 어둠의 조정',
      'Dike': '디케',
      'Dineis': '디네',
      'Dismissal Ruling': '퇴거 집행',
      'Divine Ruination': '빛의 폭발',
      'Divisive Ruling': '분할 집행',
      'Emissary\'s Will': '조정',
      'Eunomia': '에우노미아',
      'Inner Light': '내면의 빛',
      'Lightburst': '빛 분출',
      'Outer Dark': '외면의 어둠',
      'Ripples of Gloom': '어둠의 충격',
      'Shadowed Messengers': '계율의 환영',
      'Sigils of Discord': '부조화의 인장',
      'Styx': '스틱스',
      'Upheld Ruling': '확정 집행'
    }
  }]
};
/* harmony default export */ const p11n = (p11n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p11n.txt
const raid_p11n_namespaceObject = "### P11N: Anabaseios: The Eleventh Circle\r\n\r\n# -ii 81B3 81B4 81B8 81C5 81C6 81D9 81DC 81E4 81E5 81F8 81F9 8790 8791 87CE 87CF\r\n\r\n# 81B3 Divisive Ruling\r\n# 81B4 Divisive Ruling\r\n# 81B8 Ripples of Gloom\r\n# 81C5 Katakrisis\r\n# 81C6 Katakrisis\r\n# 81D9 Ripples of Gloom\r\n# 81DC Styx\r\n# 81E4 Dike\r\n# 81E5 Dike\r\n# 81F8 Dismissal Ruling\r\n# 81F9 Dismissal Ruling\r\n# 8790 Katakrisis\r\n# 8791 Katakrisis\r\n# 87CE Upheld Ruling\r\n# 87CF Upheld Ruling\r\n\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.4 \"--sync--\" StartsUsing { id: \"81E2\", source: \"Themis\" } window 7.4,10\r\n12.1 \"Eunomia\" Ability { id: \"81E2\", source: \"Themis\" }\r\n\r\n# Divisive Ruling Intro\r\n16.2 \"--center--\" Ability { id: \"8235\", source: \"Themis\" }\r\n25.5 \"Divisive Ruling (in)\" Ability { id: \"81B5\", source: \"Themis\" }\r\n28.2 \"Ripples of Gloom\" Ability { id: [\"81B7\", \"81B8\"], source: \"Themis\" }\r\n37.8 \"Divisive Ruling (out)\" Ability { id: \"81B5\", source: \"Themis\" }\r\n40.4 \"Divine Ruination\" Ability { id: \"81B6\", source: \"Themis\" }\r\n50.1 \"Divisive Ruling (random)\" Ability { id: \"81B5\", source: \"Themis\" }\r\n52.7 \"Divine Ruination/Ripples of Gloom\" Ability { id: [\"81B6\", \"81B7\", \"81B8\"], source: \"Themis\" }\r\n60.9 \"Eunomia\" Ability { id: \"81E2\", source: \"Themis\" }\r\n\r\n# Dark and Light Intro\r\n67.0 \"--center--\" Ability { id: \"8235\", source: \"Themis\" } window 30,30\r\n73.1 \"Dark and Light\" Ability { id: \"81C3\", source: \"Themis\" }\r\n80.2 \"Sigils of Discord\" Ability { id: \"81C4\", source: \"Themis\" } window 80.2,15\r\n90.3 \"Dineis (cast)\" Ability { id: \"8725\", source: \"Themis\" }\r\n94.3 \"Dineis (puddle 1)\" #Ability { id: \"8726\", source: \"Themis\" }\r\n96.3 \"Dineis (puddle 2)\" #Ability { id: \"8726\", source: \"Themis\" }\r\n100.3 \"Emissary's Will\" Ability { id: \"81C7\", source: \"Themis\" }\r\n112.4 \"Dismissal Ruling (dynamo)\" Ability { id: \"81FB\", source: \"Themis\" }\r\n116.0 \"Outer Dark\" Ability { id: \"86F4\", source: \"Themis\" }\r\n123.1 \"Dismissal Ruling (chariot)\" Ability { id: \"81FA\", source: \"Themis\" }\r\n126.7 \"Inner Light\" Ability { id: \"86F3\", source: \"Themis\" }\r\n132.8 \"Dike\" Ability { id: \"81E3\", source: \"Themis\" }\r\n\r\n# Upheld Ruling Intro\r\n138.0 \"--center--\" Ability { id: \"8235\", source: \"Themis\" }\r\n144.1 \"Dark and Light\" Ability { id: \"81C3\", source: \"Themis\" }\r\n151.2 \"Sigils of Discord\" Ability { id: \"81C4\", source: \"Themis\" }\r\n164.3 \"Dismissal Ruling (random)\" Ability { id: [\"81FA\", \"81FB\"], source: \"Themis\" }\r\n167.9 \"Inner Light/Outer Dark\" Ability { id: [\"86F3\", \"86F4\"], source: \"Themis\" }\r\n174.0 \"Emissary's Will\" Ability { id: \"81C7\", source: \"Themis\" }\r\n186.4 \"Upheld Ruling (cleave -> dynamo)\" Ability { id: \"81BA\", source: \"Themis\" } window 186.4,10\r\n193.0 \"Dark Perimeter\" Ability { id: \"81BE\", source: \"Themis\" }\r\n201.0 \"Upheld Ruling (stack -> chariot)\" Ability { id: \"81B9\", source: \"Themis\" }\r\n206.7 \"Lightburst\" Ability { id: \"81BD\", source: \"Themis\" }\r\n216.3 \"Styx x5\" Ability { id: \"81DB\", source: \"Themis\" } duration 5 window 216.3,10\r\n\r\n# Combine it all to this point\r\n228.0 \"--center--\" Ability { id: \"8235\", source: \"Themis\" } window 30,30\r\n235.3 \"Dark and Light\" Ability { id: \"81C3\", source: \"Themis\" }\r\n242.4 \"Sigils of Discord\" Ability { id: \"81C4\", source: \"Themis\" }\r\n256.5 \"Divisive Ruling (in/out)\" Ability { id: \"81B5\", source: \"Themis\" }\r\n259.1 \"Divine Ruination/Ripples of Gloom\" Ability { id: [\"81B6\", \"81B7\", \"81B8\"], source: \"Themis\" }\r\n271.3 \"Dismissal Ruling (random)\" Ability { id: [\"81FA\", \"81FB\"], source: \"Themis\" }\r\n274.9 \"Inner Light/Outer Dark\" Ability { id: [\"86F3\", \"86F4\"], source: \"Themis\" }\r\n281.0 \"Emissary's Will\" Ability { id: \"81C7\", source: \"Themis\" }\r\n290.1 \"Dike\" Ability { id: \"81E3\", source: \"Themis\" }\r\n297.3 \"--center--\" Ability { id: \"8235\", source: \"Themis\" } window 30,30\r\n302.3 \"Dineis (cast)\" Ability { id: \"8725\", source: \"Themis\" }\r\n306.3 \"Dineis (puddle 1)\" #Ability { id: \"8726\", source: \"Themis\" }\r\n308.3 \"Dineis (puddle 2)\" #Ability { id: \"8726\", source: \"Themis\" }\r\n311.7 \"Divisive Ruling (in/out)\" Ability { id: \"81B5\", source: \"Themis\" }\r\n314.3 \"Divine Ruination/Ripples of Gloom\" Ability { id: [\"81B6\", \"81B7\", \"81B8\"], source: \"Themis\" }\r\n322.7 \"Upheld Ruling (random)\" Ability { id: [\"81B9\", \"81BA\"], source: \"Themis\" }\r\n329.3 \"Dark Perimeter/Lightburst\" Ability { id: [\"81BE\", \"81BD\"], source: \"Themis\" }\r\n336.9 \"Eunomia\" Ability { id: \"81E2\", source: \"Themis\" }\r\n346.1 \"Shadowed Messengers\" Ability { id: \"81D4\", source: \"Themis\" }\r\n\r\n# Camera-spinny Adds\r\n356.8 \"--center--\" Ability { id: \"8235\", source: \"Themis\" } window 15,15\r\n357.6 \"Divisive Ruling\" Ability { id: \"81D7\", source: \"Illusory Themis\" }\r\n360.7 \"Divine Ruination\" Ability { id: \"81D8\", source: \"Illusory Themis\" }\r\n360.7 \"Ripples of Gloom\" Ability { id: [\"81D9\", \"81DA\"], source: \"Illusory Themis\" }\r\n361.8 \"--sync--\" Ability { id: \"81E0\", source: \"Themis\" } window 361.8,10  # Blinding Light cast\r\n367.0 \"Blinding Light\" Ability { id: \"81E1\", source: \"Themis\" }\r\n372.0 \"Dismissal Ruling (random)\" Ability { id: [\"81FA\", \"81FB\"], source: \"Themis\" }\r\n375.6 \"Inner Light/Outer Dark\" Ability { id: [\"86F3\", \"86F4\"], source: \"Themis\" }\r\n380.7 \"Styx x5\" Ability { id: \"81DB\", source: \"Themis\" } duration 5\r\n\r\n# Loop until death (208.2)\r\n391.4 \"--center--\" Ability { id: \"8235\", source: \"Themis\" } window 15,15\r\n396.4 \"Dineis (cast)\" Ability { id: \"8725\", source: \"Themis\" }\r\n400.4 \"Dineis (puddle 1)\" #Ability { id: \"8726\", source: \"Themis\" }\r\n402.4 \"Dineis (puddle 2)\" #Ability { id: \"8726\", source: \"Themis\" }\r\n406.0 \"Divisive Ruling (in/out)\" Ability { id: \"81B5\", source: \"Themis\" }\r\n408.6 \"Divine Ruination/Ripples of Gloom\" Ability { id: [\"81B6\", \"81B7\", \"81B8\"], source: \"Themis\" }\r\n417.3 \"Upheld Ruling (random)\" Ability { id: [\"81B9\", \"81BA\"], source: \"Themis\" }\r\n423.0 \"Dark Perimeter/Lightburst\" Ability { id: [\"81BE\", \"81BD\"], source: \"Themis\" }\r\n431.6 \"Eunomia\" Ability { id: \"81E2\", source: \"Themis\" }\r\n436.8 \"--center--\" Ability { id: \"8235\", source: \"Themis\" } window 30,30\r\n444.0 \"Dark and Light\" Ability { id: \"81C3\", source: \"Themis\" }\r\n451.1 \"Sigils of Discord\" Ability { id: \"81C4\", source: \"Themis\" }\r\n465.1 \"Divisive Ruling (in/out)\" Ability { id: \"81B5\", source: \"Themis\" }\r\n467.7 \"Divine Ruination/Ripples of Gloom\" Ability { id: [\"81B6\", \"81B7\", \"81B8\"], source: \"Themis\" }\r\n479.9 \"Dismissal Ruling (random)\" Ability { id: [\"81FA\", \"81FB\"], source: \"Themis\" }\r\n483.5 \"Inner Light/Outer Dark\" Ability { id: [\"86F3\", \"86F4\"], source: \"Themis\" }\r\n489.6 \"Emissary's Will\" Ability { id: \"81C7\", source: \"Themis\" }\r\n498.7 \"Dike\" Ability { id: \"81E3\", source: \"Themis\" }\r\n505.9 \"--center--\" Ability { id: \"8235\", source: \"Themis\" } window 30,30\r\n510.9 \"Dineis (cast)\" Ability { id: \"8725\", source: \"Themis\" }\r\n514.9 \"Dineis\" #Ability { id: \"8726\", source: \"Themis\" }\r\n516.9 \"Dineis\" #Ability { id: \"8726\", source: \"Themis\" }\r\n520.3 \"Divisive Ruling (in/out)\" Ability { id: \"81B5\", source: \"Themis\" }\r\n522.9 \"Divine Ruination/Ripples of Gloom\" Ability { id: [\"81B6\", \"81B7\", \"81B8\"], source: \"Themis\" }\r\n531.5 \"Upheld Ruling (random)\" Ability { id: [\"81B9\", \"81BA\"], source: \"Themis\" }\r\n537.2 \"Dark Perimeter/Lightburst\" Ability { id: [\"81BE\", \"81BD\"], source: \"Themis\" }\r\n545.6 \"Eunomia\" Ability { id: \"81E2\", source: \"Themis\" }\r\n554.7 \"Shadowed Messengers\" Ability { id: \"81D4\", source: \"Themis\" }\r\n565.4 \"--center--\" Ability { id: \"8235\", source: \"Themis\" }\r\n566.1 \"Divisive Ruling\" Ability { id: \"81D7\", source: \"Illusory Themis\" }\r\n569.2 \"Divine Ruination\" Ability { id: \"81D8\", source: \"Illusory Themis\" }\r\n569.2 \"Ripples of Gloom\" Ability { id: [\"81D9\", \"81DA\"], source: \"Illusory Themis\" }\r\n570.3 \"--sync--\" Ability { id: \"81E0\", source: \"Themis\" } # Blinding Light cast\r\n575.5 \"Blinding Light\" Ability { id: \"81E1\", source: \"Themis\" }\r\n580.5 \"Dismissal Ruling (random)\" Ability { id: [\"81FA\", \"81FB\"], source: \"Themis\" }\r\n584.1 \"Inner Light/Outer Dark\" Ability { id: [\"86F3\", \"86F4\"], source: \"Themis\" }\r\n589.2 \"Styx x5\" Ability { id: \"81DB\", source: \"Themis\" } duration 5\r\n\r\n\r\n599.6 \"--center--\" Ability { id: \"8235\", source: \"Themis\" } window 30,30 jump 391.4\r\n604.6 \"Dineis (cast)\"\r\n608.6 \"Dineis (puddle 1)\"\r\n610.6 \"Dineis (puddle 2)\"\r\n614.2 \"Divisive Ruling (in/out)\"\r\n616.8 \"Divine Ruination/Ripples of Gloom\"\r\n625.5 \"Upheld Ruling (random)\"\r\n631.2 \"Dark Perimeter/Lightburst\"\r\n639.8 \"Eunomia\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p11s.ts




// TODO: tankbuster calls
// TODO: call out where Arcane Revelation+Arche light/dark portals are
// TODO: if party standing on Dark Orbs during Arcane Revelation+Unlucky Lot, say rotate or stay?
// TODO: call out where Letter of the Law safe spots are (e.g. N lean E / S lean W)
const p11s_headmarkers = {
  // vfx/lockon/eff/tank_lockon04_7sk1.avfx
  dike: '01DB',
  // tankbuster
  // vfx/lockon/eff/com_share4a1.avfx
  styx: '0131',
  // multi-hit stack, currently unused
  // vfx/lockon/eff/m0515_turning_right01c.avfx
  orangeCW: '009C',
  // orange clockwise rotation
  // vfx/lockon/eff/m0515_turning_left01c.avfx
  blueCCW: '009D' // blue counterclockwise rotation
};

const p11s_firstHeadmarker = parseInt(p11s_headmarkers.dike, 16);
const p11s_getHeadmarkerId = (data, matches) => {
  if (data.decOffset === undefined) data.decOffset = parseInt(matches.id, 16) - p11s_firstHeadmarker;
  return (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase().padStart(4, '0');
};
const p11s_triggerSet = {
  id: 'AnabaseiosTheEleventhCircleSavage',
  zoneId: zone_id/* default.AnabaseiosTheEleventhCircleSavage */.Z.AnabaseiosTheEleventhCircleSavage,
  timelineFile: 'p11s.txt',
  initData: () => {
    return {
      upheldTethers: [],
      lightDarkDebuff: {},
      lightDarkBuddy: {},
      lightDarkTether: {},
      cylinderCollect: [],
      styxCount: 4,
      busterTargets: []
    };
  },
  triggers: [{
    id: 'P11S Headmarker Tracker',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.decOffset === undefined,
    suppressSeconds: 99999,
    // Unconditionally set the first headmarker here so that future triggers are conditional.
    run: (data, matches) => p11s_getHeadmarkerId(data, matches)
  }, {
    id: 'P11S Phase Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: ['8219', '81FE', '87D2'],
      source: 'Themis'
    },
    run: (data, matches) => {
      data.upheldTethers = [];
      const phaseMap = {
        '8219': 'messengers',
        '81FE': 'darkLight',
        '87D2': 'letter'
      };
      data.phase = phaseMap[matches.id];
    }
  }, {
    id: 'P11S Upheld Tether Collector',
    type: 'Tether',
    netRegex: {
      id: '00F9'
    },
    run: (data, matches) => data.upheldTethers.push(matches)
  }, {
    id: 'P11S Eunomia',
    type: 'StartsUsing',
    netRegex: {
      id: '822B',
      source: 'Themis',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'P11S Dike',
    type: 'StartsUsing',
    netRegex: {
      id: ['8230', '822F'],
      capture: true
    },
    preRun: (data, matches) => data.busterTargets.push(matches.target),
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankBusterAndSwap: {
          en: 'Tank Buster + Swap',
          de: 'Tankbuster + Wechsel',
          fr: 'Tank buster + Swap',
          ja: 'タンクバスター + スイッチ',
          cn: '死刑 + 换T',
          ko: '탱버 + 교대'
        },
        tankBusterOnYOU: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
        tankBusterOthers: outputs/* default.tankBusters */.Z.tankBusters
      };
      if (data.busterTargets.length === 2) {
        if (data.busterTargets.includes(data.me)) {
          if (data.role === 'tank') {
            return {
              alertText: output.tankBusterAndSwap()
            };
          }
          return {
            alarmText: output.tankBusterOnYOU()
          };
        }
        return {
          infoText: output.tankBusterOthers()
        };
      }
    }
  }, {
    id: 'P11S Dike Clean',
    type: 'StartsUsing',
    netRegex: {
      id: ['8230', '822F'],
      capture: false
    },
    delaySeconds: 1,
    suppressSeconds: 1,
    run: data => data.busterTargets.length = 0
  }, {
    id: 'P11S Jury Overruling Light',
    type: 'StartsUsing',
    netRegex: {
      id: '81E6',
      source: 'Themis',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Protean => Healer Stacks',
        de: 'Himmelsrichtungen => Heiler Gruppen',
        fr: 'Positions => Package sur les heals',
        ja: '基本散会 => 4:4あたまわり',
        cn: '八方分散 => 治疗分摊',
        ko: '8방향 산개 => 힐러 그룹 쉐어'
      }
    }
  }, {
    id: 'P11S Jury Overruling Light Followup',
    type: 'Ability',
    netRegex: {
      id: '81E8',
      capture: false
    },
    durationSeconds: 4,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Healer Stacks',
        de: 'Heiler Gruppen',
        fr: 'Groupes sur les heals',
        ja: '4:4あたまわり',
        cn: '治疗分摊',
        ko: '힐러 그룹 쉐어'
      }
    }
  }, {
    id: 'P11S Jury Overruling Dark',
    type: 'StartsUsing',
    netRegex: {
      id: '81E7',
      source: 'Themis',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Protean => Partners',
        de: 'Himmelsrichtungen => Partner',
        fr: 'Positions => Partenaires',
        ja: '基本散会 => ペア',
        cn: '八方分散 => 两人分摊',
        ko: '8방향 산개 => 파트너'
      }
    }
  }, {
    id: 'P11S Jury Overruling Dark Followup',
    type: 'Ability',
    netRegex: {
      id: '81E9',
      capture: false
    },
    durationSeconds: 4,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Partners',
        de: 'Partner',
        fr: 'Partenaires',
        ja: 'ぺあ',
        cn: '两人分摊',
        ko: '파트너'
      }
    }
  }, {
    id: 'P11S Upheld Overruling Light',
    type: 'StartsUsing',
    netRegex: {
      id: '87D3',
      source: 'Themis',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.upheldTethers = [],
    outputStrings: {
      text: {
        en: 'Party In => Out + Healer Stacks',
        de: 'Party Rein => Raus + Heiler Gruppen',
        fr: 'Intérieur => Extérieur + package sur les heals',
        ja: '内側から => 外側へ + 4:4あたまわり',
        cn: '场中集合 => 场边 + 治疗分摊',
        ko: '본대 안으로 => 밖으로 + 힐러 그룹 쉐어'
      }
    }
  }, {
    id: 'P11S Upheld Overruling Light Followup',
    type: 'Ability',
    netRegex: {
      id: '81F2',
      capture: false
    },
    durationSeconds: 4,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out + Healer Stacks',
        de: 'Raus + Heiler Gruppen',
        fr: 'Extérieur + Package sur les heals',
        ja: '外側で + 4:4あたまわり',
        cn: '场外 + 治疗分摊',
        ko: '밖으로 + 힐러 그룹 쉐어'
      }
    }
  }, {
    id: 'P11S Upheld Overruling Dark',
    type: 'StartsUsing',
    netRegex: {
      id: '87D4',
      source: 'Themis',
      capture: false
    },
    durationSeconds: 6,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        upheldOnYou: {
          en: 'You In (party out) => In + Partners',
          de: 'Du rein (Gruppe raus) => Rein + Partner',
          fr: 'Vous à l\'intérieur (groupe à l\'extérieur) => Intérieur + Partenaires',
          ja: '真ん中で誘導 => 内側で + ペア',
          cn: '引导月环 => 场中 + 两人分摊',
          ko: '안으로 (본대 밖) => 안으로 + 파트너'
        },
        upheldOnPlayer: {
          en: 'Party Out (${player} in)=> In + Partners',
          de: 'Gruppe raus (${player} rein)=> Rein + Partner',
          fr: 'Groupe à l\'extérieur (${player} intérieur) => Intérieur + Partenaires',
          ja: '外側へ (${player}が内側) => 内側で + ペア',
          cn: '场外 (${player} 引导) => 场中 + 两人分摊',
          ko: '본대 밖으로 (${player} 안) => 안으로 + 파트너'
        },
        upheldNotOnYou: {
          en: 'Party Out => In + Partners',
          de: 'Party Raus => Rein + Partner',
          fr: 'Groupe à l\'extérieur => Intérieur + Partenaires',
          ja: '外側へ => 内側で + ペア',
          cn: '场外 => 场中 + 两人分摊',
          ko: '본대 밖으로 => 안으로 + 파트너'
        }
      };
      const [tether] = data.upheldTethers;
      if (tether === undefined || data.upheldTethers.length !== 1) return {
        alertText: output.upheldNotOnYou()
      };
      if (tether.target === data.me) return {
        alarmText: output.upheldOnYou()
      };
      return {
        alertText: output.upheldOnPlayer({
          player: data.party.member(tether.target)
        })
      };
    },
    run: data => data.upheldTethers = []
  }, {
    id: 'P11S Upheld Overruling Dark Followup',
    type: 'Ability',
    netRegex: {
      id: '81F3',
      capture: false
    },
    durationSeconds: 4,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'In + Partners',
        de: 'Rein + Partner',
        fr: 'Intérieur + Partenaires',
        ja: '内側で + ペア',
        cn: '场中 + 两人分摊',
        ko: '안으로 + 파트너'
      }
    }
  }, {
    id: 'P11S Upheld Ruling Tether',
    type: 'StartsUsing',
    // Two adds tether players; the light add casts 87D0, the dark casts 87D1.
    // There's also a WeaponId 27/28 change too, but we don't need it.
    netRegex: {
      id: '87D1'
    },
    // Wait until after the Inevitable Law/Sentence during messengers.
    delaySeconds: data => data.phase === 'messengers' ? 5.7 : 0,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankTether: {
          en: 'Away from Party',
          de: 'Weg von der Gruppe',
          fr: 'Éloignez-vous du groupe',
          ja: 'みんなと離れる',
          cn: '远离放月环',
          ko: '본대와 멀어지기'
        },
        partyStackPlayerOut: {
          en: 'Party Stack (${player} out)',
          de: 'Mit der Gruppe sammeln (${player} raus)',
          fr: 'Package en groupe (${player} à l\'extérieur)',
          ja: 'あたまわり (${player}が外側)',
          cn: '集合 (${player} 放月环)',
          ko: '쉐어 (${player} 밖)'
        },
        // If we're not sure who the tether is on.
        partyStack: {
          en: 'Party Stack',
          de: 'In der Gruppe sammeln',
          fr: 'Package en groupe',
          ja: 'あたまわり',
          cn: '分摊',
          ko: '쉐어'
        }
      };
      const sourceId = matches.sourceId;
      const [tether] = data.upheldTethers.filter(x => x.sourceId === sourceId);
      if (tether === undefined || data.upheldTethers.length !== 2) return {
        alertText: output.partyStack()
      };
      if (tether.target === data.me) return {
        alarmText: output.tankTether()
      };
      return {
        alertText: output.partyStackPlayerOut({
          player: data.party.member(tether.target)
        })
      };
    },
    run: data => data.upheldTethers = []
  }, {
    id: 'P11S Upheld Ruling Dark Followup',
    type: 'Ability',
    netRegex: {
      id: '8221',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get in Donut',
        de: 'Geh in den Donut',
        fr: 'Intérieur du donut',
        ja: 'ドーナツの内側へ',
        cn: '进入月环',
        ko: '도넛 안으로'
      }
    }
  }, {
    id: 'P11S Dark Perimeter Followup',
    type: 'Ability',
    netRegex: {
      id: '8225',
      capture: false
    },
    condition: data => data.phase === 'letter',
    suppressSeconds: 5,
    response: responses/* Responses.getTowers */.n3.getTowers('alert')
  }, {
    id: 'P11S Divisive Overruling Light',
    type: 'StartsUsing',
    netRegex: {
      id: '81EC',
      source: 'Themis',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.divisiveColor = 'light',
    outputStrings: {
      text: {
        en: 'Sides => Healer Stacks + Out',
        de: 'Seiten => Heiler Gruppen + Raus',
        fr: 'Côtés => Extérieur + Package sur les heals',
        ja: '横 => 外側で + 4:4あたまわり',
        cn: '两侧 => 治疗分摊 + 场外',
        ko: '양 옆 => 밖으로 + 힐러 그룹 쉐어'
      }
    }
  }, {
    id: 'P11S Divisive Overruling Dark',
    type: 'StartsUsing',
    netRegex: {
      id: '81ED',
      source: 'Themis',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.divisiveColor = 'dark',
    outputStrings: {
      text: {
        en: 'Sides => In + Partners',
        de: 'Seiten => Rein + Partner',
        fr: 'Côtés => Intérieur + Partenaires',
        ja: '横 => 内側で + ペア',
        cn: '两侧 => 两人分摊 + 场内',
        ko: '양 옆 => 안으로 + 파트너'
      }
    }
  }, {
    id: 'P11S Divisive Overruling Dark Followup',
    type: 'Ability',
    netRegex: {
      id: '81EE',
      capture: false
    },
    durationSeconds: 4,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (data.divisiveColor === 'dark') return output.dark();
      if (data.divisiveColor === 'light') return output.light();
    },
    run: data => delete data.divisiveColor,
    outputStrings: {
      light: {
        en: 'Healer Stacks + Out',
        de: 'Heiler Gruppen + Raus',
        fr: 'Package sur les heals + Extérieur',
        ja: '4:4あたまわり + 外側へ',
        cn: '治疗分摊 + 场外',
        ko: '힐러 그룹 쉐어 + 밖으로'
      },
      dark: {
        en: 'In + Partners',
        de: 'Rein + Partner',
        fr: 'Intérieur + Partenaires',
        ja: '内側へ + ペア',
        cn: '场中 + 两人分摊',
        ko: '안으로 + 파트너'
      }
    }
  }, {
    id: 'P11S Divisive Overruling Light Shadowed Messengers',
    type: 'StartsUsing',
    netRegex: {
      id: '87B3',
      source: 'Themis',
      capture: false
    },
    durationSeconds: 8,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Healer Stacks + Out',
        de: 'Heiler Gruppen + Raus',
        fr: 'Extérieur + Package sur les heals',
        ja: '4:4あたまわり + 外側へ',
        cn: '治疗分摊 + 场外',
        ko: '힐러 그룹 쉐어 + 밖으로'
      }
    }
  }, {
    id: 'P11S Divisive Overruling Dark Shadowed Messengers',
    type: 'StartsUsing',
    netRegex: {
      id: '87B4',
      source: 'Themis',
      capture: false
    },
    durationSeconds: 8,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Partners + In',
        de: 'Partner + Rein',
        fr: 'Partenaires + Intérieur',
        ja: 'ペア + 内側へ',
        cn: '两人分摊 + 场内',
        ko: '파트너 + 안으로'
      }
    }
  }, {
    id: 'P11S Dismissal Overruling Light',
    type: 'StartsUsing',
    netRegex: {
      id: '8784',
      source: 'Themis',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback => Healer Stacks + Out',
        de: 'Rückstoß => Heiler Gruppen + Raus',
        fr: 'Poussée => Extérieur + Package sur les heals',
        ja: 'ノックバック => 外側で + 4:4あたまわり',
        cn: '击退 => 治疗分摊 + 场外',
        ko: '넉백 => 밖으로 + 힐러 그룹 쉐어'
      }
    }
  }, {
    id: 'P11S Dismissal Overruling Light Followup',
    type: 'Ability',
    netRegex: {
      id: '8784',
      capture: false
    },
    durationSeconds: 4,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Healer Stacks + Out',
        de: 'Heiler Gruppen + Raus',
        fr: 'Package sur les heals + Extérieur',
        ja: '4:4あたまわり + 外側へ',
        cn: '治疗分摊 + 场外',
        ko: '힐러 그룹 쉐어 + 밖으로'
      }
    }
  }, {
    id: 'P11S Dismissal Overruling Dark',
    type: 'StartsUsing',
    netRegex: {
      id: '8785',
      source: 'Themis',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback => In + Partners',
        de: 'Rückstoß => Rein + Partner',
        fr: 'Poussée => Intérieur + Partenaires',
        ja: 'ノックバック => 内側で + ペア',
        cn: '击退 => 两人分摊 + 场内',
        ko: '넉백 => 안으로 + 파트너'
      }
    }
  }, {
    id: 'P11S Dismissal Overruling Dark Followup',
    type: 'Ability',
    netRegex: {
      id: '8785',
      capture: false
    },
    durationSeconds: 4,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'In + Partners',
        de: 'Rein + Partner',
        fr: 'Intérieur + Partenaires',
        ja: '内側で + ペア',
        cn: '场中 + 两人分摊',
        ko: '안으로 + 파트너'
      }
    }
  }, {
    id: 'P11S Arcane Revelation Light Portals',
    type: 'StartsUsing',
    netRegex: {
      id: '820D',
      source: 'Themis',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to Dark Portals',
        de: 'Geh zu einem Dunkel-Portal',
        fr: 'Allez vers les portails sombres',
        ja: 'やみの方へ',
        cn: '去暗门前',
        ko: '어둠 문 쪽으로'
      }
    }
  }, {
    id: 'P11S Arcane Revelation Dark Portals',
    type: 'StartsUsing',
    netRegex: {
      id: '820E',
      source: 'Themis',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to Light Portals',
        de: 'Geh zu einem Licht-Portal',
        fr: 'Allez sur les portails de lumière',
        ja: 'ひかりの方へ',
        cn: '去光门前',
        ko: '빛 문 쪽으로'
      }
    }
  }, {
    id: 'P11S Arcane Revelation Light Orbs',
    type: 'StartsUsing',
    netRegex: {
      id: '820F',
      source: 'Themis',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Rotate to Dark Orbs',
        de: 'Rotiere zu den dunklen Orbs',
        fr: 'Tournez vers les orbes sombres',
        ja: 'やみの玉の方へ',
        cn: '暗球侧安全',
        ko: '어둠 구슬 쪽으로'
      }
    }
  }, {
    id: 'P11S Arcane Revelation Dark Orbs',
    type: 'StartsUsing',
    netRegex: {
      id: '8210',
      source: 'Themis',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Rotate to Light Orbs',
        de: 'Rotiere zu den licht Orbs',
        fr: 'Tournez vers les orbes de lumière',
        ja: 'ひかりの玉の方へ',
        cn: '光球侧安全',
        ko: '빛 구슬 쪽으로'
      }
    }
  }, {
    id: 'P11S Dark and Light Buff Collect',
    type: 'GainsEffect',
    // DE1 = Light's Accord
    // DE2 = Dark's Accord
    // DE3 = Light's Discord
    // DE4 = Dark's Discord
    netRegex: {
      effectId: ['DE1', 'DE2', 'DE3', 'DE4']
    },
    run: (data, matches) => {
      const isLight = matches.effectId === 'DE1' || matches.effectId === 'DE3';
      data.lightDarkDebuff[matches.target] = isLight ? 'light' : 'dark';
    }
  }, {
    id: 'P11S Dark and Light Tether Collect',
    type: 'Tether',
    // 00EC = light far tether (correct)
    // 00ED = light far tether (too close)
    // 00EE = dark far tether (correct)
    // 00EF = dark far tether (too close)
    // 00F0 = near tether (correct)
    // 00F1 = near tether (too far)
    netRegex: {
      id: ['00EC', '00ED', '00EE', '00EF', '00F0', '00F1']
    },
    run: (data, matches) => {
      const isNear = matches.id === '00F0' || matches.id === '00F1';
      const nearFarStr = isNear ? 'near' : 'far';
      data.lightDarkTether[matches.source] = data.lightDarkTether[matches.target] = nearFarStr;
      data.lightDarkBuddy[matches.source] = matches.target;
      data.lightDarkBuddy[matches.target] = matches.source;
    }
  }, {
    id: 'P11S Dark and Light Tether Callout',
    type: 'Tether',
    netRegex: {
      id: ['00EC', '00ED', '00EE', '00EF', '00F0', '00F1'],
      capture: false
    },
    delaySeconds: 0.5,
    durationSeconds: 6,
    suppressSeconds: 9999,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        lightNear: {
          en: 'Light Near w/${player} (${role})',
          de: 'Licht Nahe w/${player} (${role})',
          fr: 'Lumière proche avec ${player} (${role})',
          ja: 'ひかりニア => ${player} (${role})',
          cn: '光靠近 => ${player} (${role})',
          ko: '빛 가까이 +${player} (${role})'
        },
        lightFar: {
          en: 'Light Far w/${player} (${role})',
          de: 'Licht Entfernt w/${player} (${role})',
          fr: 'Lumière éloignée avec ${player} (${role})',
          ja: 'ひかりファー => ${player} (${role})',
          cn: '光远离 => ${player} (${role})',
          ko: '빛 멀리 +${player} (${role})'
        },
        darkNear: {
          en: 'Dark Near w/${player} (${role})',
          de: 'Dunkel Nahe w/${player} (${role})',
          fr: 'Sombre proche avec ${player} (${role})',
          ja: 'やみニア => ${player} (${role})',
          cn: '暗靠近 => ${player} (${role})',
          ko: '어둠 가까이 +${player} (${role})'
        },
        darkFar: {
          en: 'Dark Far w/${player} (${role})',
          de: 'Dunkel Entfernt w/${player} (${role})',
          fr: 'Sombre éloigné avec ${player} (${role})',
          ja: 'やみファー => ${player} (${role})',
          cn: '暗远离 => ${player} (${role})',
          ko: '어둠 멀리 +${player} (${role})'
        },
        otherNear: {
          en: 'Other Near: ${player1}, ${player2}',
          de: 'Anderes Nahe: ${player1}, ${player2}',
          fr: 'Autre proche : ${player1}, ${player2}',
          ja: '他のペア: ${player1}, ${player2}',
          cn: '另一组靠近：${player1}, ${player2}',
          ko: '다른 가까이: ${player1}, ${player2}'
        },
        otherFar: {
          en: 'Other Far: ${player1}, ${player2}',
          de: 'Anderes Entfernt: ${player1}, ${player2}',
          fr: 'Autre éloigné : ${player1}, ${player2}',
          ja: '他のペア: ${player1}, ${player2}',
          cn: '另一组远离：${player1}, ${player2}',
          ko: '다른 멀리: ${player1}, ${player2}'
        },
        tank: outputs/* default.tank */.Z.tank,
        healer: outputs/* default.healer */.Z.healer,
        dps: outputs/* default.dps */.Z.dps,
        unknown: outputs/* default.unknown */.Z.unknown
      };
      const myColor = data.lightDarkDebuff[data.me];
      const myBuddy = data.lightDarkBuddy[data.me];
      const myLength = data.lightDarkTether[data.me];
      if (myColor === undefined || myBuddy === undefined || myLength === undefined) {
        // Heuristic for "is this a synthetic execution".
        // TODO: maybe we need a field on data for this?
        if (Object.keys(data.lightDarkDebuff).length === 0) return;
        console.log(`Dark and Light: missing data for ${data.me}`);
        console.log(`Dark and Light: lightDarkDebuff: ${JSON.stringify(data.lightDarkDebuff)}`);
        console.log(`Dark and Light: lightDarkBuddy: ${JSON.stringify(data.lightDarkBuddy)}`);
        console.log(`Dark and Light: lightDarkTether: ${JSON.stringify(data.lightDarkTether)}`);
        return;
      }
      let myBuddyRole;
      if (data.party.isDPS(myBuddy)) myBuddyRole = output.dps();else if (data.party.isTank(myBuddy)) myBuddyRole = output.tank();else if (data.party.isHealer(myBuddy)) myBuddyRole = output.healer();else myBuddyRole = output.unknown();
      const myBuddyShort = data.party.member(myBuddy);
      let alertText;
      if (myLength === 'near') {
        if (myColor === 'light') alertText = output.lightNear({
          player: myBuddyShort,
          role: myBuddyRole
        });else alertText = output.darkNear({
          player: myBuddyShort,
          role: myBuddyRole
        });
      } else {
        if (myColor === 'light') alertText = output.lightFar({
          player: myBuddyShort,
          role: myBuddyRole
        });else alertText = output.darkFar({
          player: myBuddyShort,
          role: myBuddyRole
        });
      }
      let infoText = undefined;
      const playerNames = Object.keys(data.lightDarkTether);
      const sameLength = playerNames.filter(x => data.lightDarkTether[x] === myLength);
      const others = sameLength.filter(x => x !== data.me && x !== myBuddy).sort();
      const [player1, player2] = others.map(x => data.party.member(x));
      if (player1 !== undefined && player2 !== undefined) {
        if (myLength === 'near') infoText = output.otherNear({
          player1: player1,
          player2: player2
        });else infoText = output.otherFar({
          player1: player1,
          player2: player2
        });
      }
      return {
        alertText: alertText,
        infoText: infoText
      };
    }
  }, {
    id: 'P11S Twofold Revelation Light',
    type: 'StartsUsing',
    netRegex: {
      id: '8211',
      source: 'Themis',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to Dark Orb + Dark Portals',
        de: 'Geh zum dunklen Orb + dunkle Portale',
        fr: 'Allez vers l\'orbe sombre + Portail sombre',
        ja: 'やみ玉 + ポータル',
        cn: '去暗球 + 暗门',
        ko: '어둠 구슬 + 어둠 문'
      }
    }
  }, {
    id: 'P11S Twofold Revelation Dark',
    type: 'StartsUsing',
    netRegex: {
      id: '8212',
      source: 'Themis',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to Light Orb + Light Portals',
        de: 'Geh zum hellen Orb + helle Portale',
        fr: 'Allez vers l\'orbe de lumière + Portail de lumière',
        ja: 'ひかり玉 ＋ ポータル',
        cn: '去光球 + 光门',
        ko: '빛 구슬 + 빛 문'
      }
    }
  }, {
    id: 'P11S Lightstream Collect',
    type: 'HeadMarker',
    netRegex: {
      target: 'Arcane Cylinder'
    },
    condition: (data, matches) => {
      const id = p11s_getHeadmarkerId(data, matches);
      if (id !== p11s_headmarkers.orangeCW && id !== p11s_headmarkers.blueCCW) return false;
      data.cylinderCollect.push(matches);
      return data.cylinderCollect.length === 3;
    },
    alertText: (data, _matches, output) => {
      let cylinderValue = 0;

      // targetId is in hex, but that's still lexicographically sorted so no need to parseInt.
      const sortedCylinders = data.cylinderCollect.sort((a, b) => {
        return a.targetId.localeCompare(b.targetId);
      });
      const markers = sortedCylinders.map(m => p11s_getHeadmarkerId(data, m));

      // Once sorted by id, the lasers will always be in NW, S, NE order.
      // Create a 3 digit binary value, Orange = 0, Blue = 1.
      // e.g. BBO = 110 = 6
      for (const marker of markers) {
        cylinderValue *= 2;
        if (marker === p11s_headmarkers.blueCCW) cylinderValue += 1;
      }

      // The safe spot is the one just CW of two reds or just CCW of two blues.
      // There's always two of one color and one of the other.
      const outputs = {
        0b000: undefined,
        0b001: output.northwest(),
        0b010: output.east(),
        0b011: output.northeast(),
        0b100: output.southwest(),
        0b101: output.west(),
        0b110: output.southeast(),
        0b111: undefined
      };
      return outputs[cylinderValue];
    },
    run: data => data.cylinderCollect = [],
    outputStrings: {
      east: outputs/* default.east */.Z.east,
      northeast: outputs/* default.northeast */.Z.northeast,
      northwest: outputs/* default.northwest */.Z.northwest,
      southeast: outputs/* default.southeast */.Z.southeast,
      southwest: outputs/* default.southwest */.Z.southwest,
      west: outputs/* default.west */.Z.west
    }
  }, {
    id: 'P11S Styx Stack',
    type: 'StartsUsing',
    netRegex: {
      id: '8217',
      source: 'Themis',
      capture: false
    },
    preRun: data => {
      data.styxCount++;
    },
    infoText: (data, _matches, output) => output.text({
      num: data.styxCount
    }),
    outputStrings: {
      text: {
        en: 'Stack (${num} times)',
        de: 'Sammeln (${num} Mal)',
        fr: 'Packez-vous (${num} fois)',
        ja: '頭割り（${num}回）',
        cn: '集合分摊 (${num}次)',
        ko: '쉐어뎀 (${num}번)'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Inevitable Law/Inevitable Sentence': 'Inevitable Law/Sentence'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Arcane Cylinder': 'arkan(?:e|er|es|en) Zylinder',
      'Arcane Sphere': 'arkan(?:e|er|es|en) Körper',
      'Illusory Themis': 'Phantom-Themis',
      '(?<! )Themis': 'Themis'
    },
    'replaceText': {
      '\\(cast\\)': '(wirken)',
      '\\(enrage\\)': '(Finalangriff)',
      'Arcane Revelation': 'Arkane Enthüllung',
      'Arche': 'Arche',
      'Blinding Light': 'Blendendes Licht',
      'Dark Current': 'Dunkelstrahl',
      'Dark Perimeter': 'Dunkler Kreis',
      'Dark and Light': 'Licht-Dunkel-Schlichtung',
      'Dike': 'Dike',
      'Dismissal Overruling': 'Verweisungsbefehl',
      'Divisive Overruling': 'Auflösungsbefehl',
      'Divisive Ruling': 'Auflösungsbeschluss',
      'Emissary\'s Will': 'Schlichtung',
      'Eunomia': 'Eunomia',
      '(?<!Magie)Explosion': 'Explosion',
      'Heart of Judgment': 'Urteilsschlag',
      'Inevitable Law': 'Langer Arm des Rechts',
      'Inevitable Sentence': 'Langer Arm der Strafe',
      'Jury Overruling': 'Schöffenbefehl',
      'Letter of the Law': 'Phantomgesetz',
      'Lightburst': 'Lichtstoß',
      'Lightstream': 'Lichtstrahl',
      'Shadowed Messengers': 'Boten des Schattens',
      'Styx': 'Styx',
      'Twofold Revelation': 'Zweifache Enthüllung',
      'Ultimate Verdict': 'Letzte Schlichtung',
      'Unlucky Lot': 'Magieexplosion',
      'Upheld Overruling': 'Erhebungsbefehl',
      'Upheld Ruling': 'Erhebungsbeschluss'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Arcane Cylinder': 'sphère arcanique orientée',
      'Arcane Sphere': 'sphère arcanique',
      'Illusory Themis': 'spectre de Thémis',
      '(?<! )Themis': 'Thémis'
    },
    'replaceText': {
      'Arcane Revelation': 'Déploiement arcanique',
      'Arche': 'Arkhé',
      'Blinding Light': 'Lumière aveuglante',
      'Dark Current': 'Flux sombre',
      'Dark Perimeter': 'Cercle ténébreux',
      'Dark and Light': 'Médiation Lumière-Ténèbres',
      'Dike': 'Diké',
      'Dismissal Overruling': 'Rejet et annulation',
      'Divisive Overruling': 'Partage et annulation',
      'Divisive Ruling': 'Partage et décision',
      'Emissary\'s Will': 'Médiation',
      'Eunomia': 'Eunomia',
      'Explosion': 'Explosion',
      'Heart of Judgment': 'Onde pénale',
      'Inevitable Law': 'Ligne additionnelle',
      'Inevitable Sentence': 'Peine complémentaire',
      'Jury Overruling': 'Jugement et annulation',
      'Letter of the Law': 'Fantasmagorie des lois',
      'Lightburst': 'Éclat de lumière',
      'Lightstream': 'Flux lumineux',
      'Shadowed Messengers': 'Fantasmagorie des préceptes',
      'Styx': 'Styx',
      'Twofold Revelation': 'Double déploiement arcanique',
      'Ultimate Verdict': 'Médiation ultime',
      'Unlucky Lot': 'Déflagration éthérée',
      'Upheld Overruling': 'Maintien et annulation',
      'Upheld Ruling': 'Maintien et décision'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Arcane Cylinder': '指向魔法陣',
      'Arcane Sphere': '立体魔法陣',
      'Illusory Themis': 'テミスの幻影',
      '(?<! )Themis': 'テミス'
    },
    'replaceText': {
      'Arcane Revelation': '魔法陣展開',
      'Arche': 'アルケー',
      'Blinding Light': '光弾',
      'Dark Current': 'ダークストリーム',
      'Dark Perimeter': 'ダークサークル',
      'Dark and Light': '光と闇の調停',
      'Dike': 'ディケー',
      'Dismissal Overruling': 'ディスミサル＆オーバールール',
      'Divisive Overruling': 'ディバイド＆オーバールール',
      'Divisive Ruling': 'ディバイド＆ルーリング',
      'Emissary\'s Will': '調停',
      'Eunomia': 'エウノミアー',
      'Explosion': '爆発',
      'Heart of Judgment': '刑律の波動',
      'Inevitable Law': 'アディショナルロウ',
      'Inevitable Sentence': 'アディショナルセンテンス',
      'Jury Overruling': 'ジューリー＆オーバールール',
      'Letter of the Law': '理法の幻奏',
      'Lightburst': 'ライトバースト',
      'Lightstream': 'ライトストリーム',
      'Shadowed Messengers': '戒律の幻奏',
      'Styx': 'ステュクス',
      'Twofold Revelation': '二種魔法陣展開',
      'Ultimate Verdict': '究極調停',
      'Unlucky Lot': '魔爆',
      'Upheld Overruling': 'アップヘルド＆オーバールール',
      'Upheld Ruling': 'アップヘルド＆ルーリング'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Arcane Cylinder': '指向魔法阵',
      'Arcane Sphere': '立体魔法阵',
      'Illusory Themis': '特弥斯的幻影',
      '(?<! )Themis': '特弥斯'
    },
    'replaceText': {
      '\\(cast\\)': '(咏唱)',
      '\\(enrage\\)': '(狂暴)',
      'Arcane Revelation': '魔法阵展开',
      'Arche': '始基',
      'Blinding Light': '光弹',
      'Dark Current': '黑暗奔流',
      'Dark Perimeter': '黑暗回环',
      'Dark and Light': '光与暗的调停',
      'Dike': '正义',
      'Dismissal Overruling': '驳回否决',
      'Divisive Overruling': '分歧否决',
      'Divisive Ruling': '驳回判决',
      'Emissary\'s Will': '调停者之意',
      'Eunomia': '秩序',
      '(?<!Magie)Explosion': '爆炸',
      'Heart of Judgment': '刑律波动',
      'Inevitable Law': '追加律法',
      'Inevitable Sentence': '追加刑罚',
      'Jury Overruling': '陪审团否决',
      'Letter of the Law': '理法幻奏',
      'Lightburst': '光爆破',
      'Lightstream': '光明奔流',
      'Shadowed Messengers': '戒律幻奏',
      'Styx': '仇恨',
      'Twofold Revelation': '魔法阵双重展开',
      'Ultimate Verdict': '究极调停',
      'Unlucky Lot': '魔爆',
      'Upheld Overruling': '维持否决',
      'Upheld Ruling': '维持判决'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Arcane Cylinder': '방향마법진',
      'Arcane Sphere': '입체마법진',
      'Illusory Themis': '테미스의 환영',
      '(?<! )Themis': '테미스'
    },
    'replaceText': {
      '\\(cast\\)': '(시전)',
      'Arcane Revelation': '마법진 전개',
      'Arche': '아르케',
      'Blinding Light': '빛 폭탄',
      'Dark Current': '암운의 격류',
      'Dark Perimeter': '어둠의 둘레',
      'Dark and Light': '빛과 어둠의 조정',
      'Dike': '디케',
      'Dismissal Overruling': '퇴거 강행',
      'Divisive Overruling': '분할 강행',
      'Divisive Ruling': '분할 집행',
      'Emissary\'s Will': '조정',
      'Eunomia': '에우노미아',
      '(?<!Magie)Explosion': '폭발',
      'Heart of Judgment': '형률의 파동',
      'Inevitable Law': '추가 기소',
      'Inevitable Sentence': '추가 선고',
      'Jury Overruling': '배심 강행',
      'Letter of the Law': '이법의 환영',
      'Lightburst': '빛 분출',
      'Lightstream': '빛의 급류',
      'Shadowed Messengers': '계율의 환영',
      'Styx': '스틱스',
      'Twofold Revelation': '이중 마법진 전개',
      'Ultimate Verdict': '궁극의 조정',
      'Unlucky Lot': '마력 폭발',
      'Upheld Overruling': '확정 강행',
      'Upheld Ruling': '확정 집행'
    }
  }]
};
/* harmony default export */ const p11s = (p11s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p11s.txt
const raid_p11s_namespaceObject = "### P11S: Anabaseios: The Eleventh Circle (Savage)\r\n# -ii 8218 8234 822F 8230 8231 8232 81E8 81E9 81EA 81EB 81F2 81F3 81F6 81F7 81F0 81F1 8786 8787 8788 8789 821A 821B 821D 821E 821F 8205 8206 8208 87B6 87B7 87B8 87D0 87D1 8220 820A 822A 81EF 81FF 8200\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11.0 \"--sync--\" StartsUsing { id: \"822B\", source: \"Themis\" } window 12,10\r\n16.0 \"Eunomia\" Ability { id: \"822B\", source: \"Themis\" }\r\n26.1 \"Dike 1\" Ability { id: \"822D\", source: \"Themis\" }\r\n29.2 \"Dike 2\" Ability { id: \"822E\", source: \"Themis\" }\r\n\r\n42.3 \"Jury Overruling\" Ability { id: [\"81E6\", \"81E7\"], source: \"Themis\" }\r\n48.3 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n\r\n61.7 \"Upheld Overruling\" Ability { id: [\"87D3\", \"87D4\"], source: \"Themis\" }\r\n66.3 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n\r\n70.3 \"--middle--\" Ability { id: \"867F\", source: \"Themis\" }\r\n79.9 \"Divisive Overruling\" Ability { id: [\"81EC\", \"81ED\"], source: \"Themis\" }\r\n84.5 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n\r\n93.7 \"Styx x5\" Ability { id: \"8217\", source: \"Themis\" } duration 4.4\r\n\r\n105.2 \"--middle--\" Ability { id: \"867F\", source: \"Themis\" }\r\n113.3 \"Arcane Revelation\" Ability { id: [\"820D\", \"820E\"], source: \"Themis\" }\r\n120.4 \"Dismissal Overruling\" Ability { id: [\"8784\", \"8785\"], source: \"Themis\" }\r\n122.8 \"Arche\" Ability { id: [\"8213\", \"8214\"], source: \"Arcane Sphere\" }\r\n125.8 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n\r\n145.5 \"--middle--\" Ability { id: \"867F\", source: \"Themis\" }\r\n152.6 \"Shadowed Messengers\" Ability { id: \"8219\", source: \"Themis\" }\r\n166.9 \"Divisive Ruling\" Ability { id: \"821C\", source: \"Illusory Themis\" }\r\n169.6 \"Divisive Overruling\" Ability { id: [\"87B3\", \"87B4\"], source: \"Themis\" }\r\n174.1 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n179.5 \"Upheld Ruling\" Ability { id: \"8221\", source: \"Illusory Themis\" }\r\n183.5 \"Lightburst\" Ability { id: \"8224\", source: \"Illusory Themis\" }\r\n183.5 \"Dark Perimeter\" Ability { id: \"8225\", source: \"Illusory Themis\" }\r\n\r\n189.2 \"Jury Overruling\" Ability { id: [\"81E6\", \"81E7\"], source: \"Themis\" }\r\n195.2 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n\r\n203.3 \"Styx x6\" Ability { id: \"8217\", source: \"Themis\" } duration 5.5\r\n\r\n220.9 \"Lightstream (cast)\" Ability { id: \"8203\", source: \"Themis\" }\r\n230.6 \"--sync--\" Ability { id: \"867F\", source: \"Themis\" }\r\n233.2 \"Lightstream x7\" Ability { id: \"8207\", source: \"Arcane Cylinder\" } duration 6.1\r\n\r\n240.1 \"Divisive Overruling\" Ability { id: [\"81EC\", \"81ED\"], source: \"Themis\" }\r\n244.7 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n\r\n256.8 \"Eunomia\" Ability { id: \"822B\", source: \"Themis\" }\r\n271.2 \"Upheld Overruling\" Ability { id: [\"87D3\", \"87D4\"], source: \"Themis\" }\r\n275.6 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n\r\n286.6 \"--middle--\" Ability { id: \"867F\", source: \"Themis\" }\r\n293.9 \"Dark and Light\" Ability { id: \"81FE\", source: \"Themis\" }\r\n307.0 \"Arcane Revelation\" Ability { id: [\"820F\", \"8210\"], source: \"Themis\" }\r\n316.7 \"Unlucky Lot\" Ability { id: [\"8215\", \"8216\"], source: \"Arcane Sphere\" }\r\n323.1 \"Jury Overruling\" Ability { id: [\"81E6\", \"81E7\"], source: \"Themis\" }\r\n329.1 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n341.5 \"Divisive Overruling\" Ability { id: [\"81EC\", \"81ED\"], source: \"Themis\" }\r\n346.1 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n353.2 \"Emissary's Will\" Ability { id: \"8202\", source: \"Themis\" }\r\n\r\n361.4 \"Styx x7\" Ability { id: \"8217\", source: \"Themis\" } duration 6.6\r\n\r\n380.2 \"Dike 1\" Ability { id: \"822D\", source: \"Themis\" }\r\n383.3 \"Dike 2\" Ability { id: \"822E\", source: \"Themis\" }\r\n\r\n395.4 \"--middle--\" Ability { id: \"867F\", source: \"Themis\" }\r\n402.5 \"Dark Current (cast)\" Ability { id: \"8204\", source: \"Themis\" }\r\n410.6 \"Dark Current x8\" Ability { id: \"8209\", source: \"Themis\" } duration 7\r\n412.5 \"Blinding Light\" Ability { id: \"8229\", source: \"Themis\" }\r\n\r\n426.6 \"Jury Overruling\" Ability { id: [\"81E6\", \"81E7\"], source: \"Themis\" }\r\n432.6 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n446.0 \"Upheld Overruling\" Ability { id: [\"87D3\", \"87D4\"], source: \"Themis\" }\r\n450.4 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n\r\n456.4 \"--middle--\" Ability { id: \"867F\", source: \"Themis\" }\r\n466.2 \"Divisive Overruling\" Ability { id: [\"81EC\", \"81ED\"], source: \"Themis\" }\r\n470.8 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n483.9 \"Eunomia\" Ability { id: \"822B\", source: \"Themis\" }\r\n\r\n503.1 \"--middle--\" Ability { id: \"867F\", source: \"Themis\" }\r\n510.2 \"Letter of the Law\" Ability { id: \"87D2\", source: \"Themis\" }\r\n517.3 \"Twofold Revelation\" Ability { id: [\"8211\", \"8212\"], source: \"Themis\" }\r\n526.4 \"Heart of Judgment\" Ability { id: \"8226\", source: \"Themis\" }\r\n527.0 \"Arche\" Ability { id: [\"8213\", \"8214\"], source: \"Arcane Sphere\" }\r\n527.0 \"Unlucky Lot\" Ability { id: [\"8215\", \"8216\"], source: \"Arcane Sphere\" }\r\n529.5 \"Upheld Ruling\" Ability { id: \"8221\", source: \"Illusory Themis\" }\r\n533.5 \"Lightburst\" Ability { id: \"8224\", source: \"Illusory Themis\" }\r\n533.5 \"Dark Perimeter\" Ability { id: \"8225\", source: \"Illusory Themis\" }\r\n538.4 \"Explosion\" Ability { id: \"8227\", source: \"Themis\" }\r\n541.8 \"Divisive Ruling\" Ability { id: \"821C\", source: \"Illusory Themis\" }\r\n\r\n547.4 \"Dismissal Overruling\" Ability { id: [\"8784\", \"8785\"], source: \"Themis\" }\r\n553.0 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n\r\n561.6 \"Styx x8\" Ability { id: \"8217\", source: \"Themis\" } duration 7.7\r\n\r\n580.4 \"Lightstream (cast)\" Ability { id: \"8203\", source: \"Themis\" }\r\n589.5 \"--sync--\" Ability { id: \"867F\", source: \"Themis\" }\r\n592.6 \"Lightstream x7\" Ability { id: \"8207\", source: \"Arcane Cylinder\" } duration 6.1\r\n\r\n598.9 \"Divisive Overruling\" Ability { id: [\"81EC\", \"81ED\"], source: \"Themis\" }\r\n603.4 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n\r\n619.5 \"Dike 1\" Ability { id: \"822D\", source: \"Themis\" }\r\n622.6 \"Dike 2\" Ability { id: \"822E\", source: \"Themis\" }\r\n\r\n638.7 \"Jury Overruling\" Ability { id: [\"81E6\", \"81E7\"], source: \"Themis\" }\r\n644.7 \"Inevitable Law/Inevitable Sentence\" Ability { id: [\"81FC\", \"81FD\"], source: \"Themis\" }\r\n655.8 \"Eunomia\" Ability { id: \"822B\", source: \"Themis\" }\r\n\r\n662.5 \"--sync--\" StartsUsing { id: \"822C\", source: \"Themis\" } window 30,10\r\n672.5 \"Ultimate Verdict (enrage)\" Ability { id: \"822C\", source: \"Themis\" }\r\n\r\n\r\n# Abilities, ignored and not\r\n#\r\n# Themis:8218 Styx share damage\r\n# Themis:8234 auto\r\n# Themis:822F Dike MT hit 1\r\n# Themis:8230 Dike OT hit 1\r\n# Themis:8231 Dike (new) MT hit 2\r\n# Themis:8232 Dike (new) OT hit 2\r\n# Themis:81EA Illusory Glare light puddle during Jury Overruling\r\n# Themis:81EB Illusory Gloom dark donuts during Jury Overruling\r\n# Themis:81FC Inevitable Law healer stacks during Jury Overruling, Upheld Overruling\r\n# Themis:81FD Inevitable Sentence partner stacks during Jury Overruling, Upheld Overruling\r\n# Themis:81F2 Upheld Overruling light party stack damage\r\n# Themis:81F3 Upheld Overruling dark tank solo damage\r\n# Themis:81F6 Lightburst large circle during Upheld Overruling light\r\n# Themis:81F7 Dark Permimeter large donut during Upheld Overruling dark\r\n# Themis:81EE Divisive Overruling dividing line light and dark (normally)\r\n# Themis:87B5 Divisive Overruling dividing line light and dark during Messengers\r\n# Themis:81EF Divine Ruination expanding line during Divisive Overruling light\r\n# Themis:81F0 Ripples of Gloom large line (one side) during Divisive Overruling dark\r\n# Themis:81F1 Ripples of Gloom large line (other side) during Divisive Overruling dark\r\n# Themis:87B6 Divine Ruination expanding line during Divisive Overruling light Messengers\r\n# Themis:87B7 Ripples of Gloom large line (one side) during Divisive Overruling dark Messengers\r\n# Themis:87B8 Ripples of Gloom large line (other side) during Divisive Overruling dark Messengers\r\n# Themis:8786 Dismissal Overruling light knockback\r\n# Themis:8787 Dismissal Overruling dark knockback\r\n# Themis:8788 Inner Light large circle during Dismissal Overruling light\r\n# Themis:8789 Outer Dark large donut during Dismissal Overruling dark\r\n# Themis:8205 unknown unnamed ability (Lightstream)\r\n# Themis:8206 unknown unnamed ability (Dark Current)\r\n# Themis:8209 Dark Current initial circles\r\n# Themis:820A Dark Current rotating circles\r\n# Themis:822A Blinding Light spread damage during Dark Current\r\n# Themis:81FF Katakrisis light tether failure damage\r\n# Themis:8200 Katakrisis dark tether failure damage\r\n#\r\n# Illusory Themis:81E8 Jury Overruling light protean damage\r\n# Illusory Themis:81E9 Jury Overruling dark protean damage\r\n# Illusory Themis:821A Divisive Ruling (light?) clone self-targeted cast during Messengers/Letter\r\n# Illusory Themis:821B Divisive Ruling (dark?) clone self-targeted cast during Messengers/Letter\r\n# Illusory Themis:821C Divisive Ruling damage from initial clone lines during Messengers/Letter\r\n# Illusory Themis:821D Divine Ruination light line expansion clone line during Messengers/Letter\r\n# Illusory Themis:821E Ripples of Gloom large line (one side) dark clone during Messengers/Letter\r\n# Illusory Themis:821F Ripples of Gloom large line (other side) dark clone during Messengers/Letter\r\n# Illusory Themis:87D0 Upheld Ruling clone self-targeted cast during Messengers/Letter\r\n# Illusory Themis:87D1 Upheld Ruling clone self-targeted cast during Messengers/Letter\r\n# Illusory Themis:8220 Upheld Overruling light party stack damage from clone during Messengers/Letter\r\n# Illusory Themis:8221 Upheld Overruling dark tank solo damage from clone during Messengers/Letter\r\n# Illusory Themis:8224 Lightburst large circle during Upheld Overruling light from clone during Messengers/Letter\r\n# Illusory Themis:8225 Dark Permimeter large donut during Upheld Overruling dark from clone during Messengers/Letter\r\n#\r\n# Arcane Sphere:8213 Arche light portal lasers\r\n# Arcane Sphere:8214 Arche dark portal lasers\r\n# Arcane Sphere:8215 Unlucky Lot light sphere explosion\r\n# Arcane Sphere:8216 Unlucky Lot dark sphere explosion\r\n#\r\n# Arcane Cylinder:8207 Lightstream initial ground aoes\r\n# Arcane Cylinder:8208 Lightstream rotating lasers\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p12n.ts




const wings = {
  // vfx/lockon/eff/m0829_cst19_9s_c0v.avfx
  topLeft: '01A5',
  // 82C2 cast and damage
  // vfx/lockon/eff/m0829_cst20_9s_c0v.avfx
  topRight: '01A6',
  // 82C1 cast and damage
  // vfx/lockon/eff/m0829_cst21_6s_c0v.avfx
  middleLeft: '01A7',
  // 82C4 damage
  // vfx/lockon/eff/m0829_cst22_6s_c0v.avfx
  middleRight: '01A8',
  // 82C3 damage
  // vfx/lockon/eff/m0829_cst22_6s_c0v.avfx
  bottomLeft: '01B1',
  // 82C6 damage
  // vfx/lockon/eff/m0829_cst23_3s_c0v.avfx
  bottomRight: '01B2' // 82C5 damage
  // vfx/lockon/eff/m0829_cst24_3s_c0v.avfx
};

const wingIds = Object.values(wings);
const wingOutputStrings = {
  // Sure, we could say "left" and "right" here, but folks are going to be mad
  // when the boss is (probably) facing the party during Unnatural Enchainment.
  // Personally, I think it's better to be consistent than to switch the
  // meaning of right and left mid-raid.  To make it more clear what this means,
  // these say "Left Flank" (i.e. the boss's left flank) vs "Left" which could
  // mean your left or the boss's left or that you've left off reading this.
  leftFlank: {
    en: 'Left Flank',
    de: 'Linke Flanke',
    fr: 'Flanc gauche',
    ja: '左',
    cn: '左翅膀',
    ko: '왼쪽'
  },
  rightFlank: {
    en: 'Right Flank',
    de: 'Rechte Flanke',
    fr: 'Flanc droit',
    ja: '右',
    cn: '右翅膀',
    ko: '오른쪽'
  }
};
const p12n_triggerSet = {
  id: 'AnabaseiosTheTwelfthCircle',
  zoneId: zone_id/* default.AnabaseiosTheTwelfthCircle */.Z.AnabaseiosTheTwelfthCircle,
  timelineFile: 'p12n.txt',
  initData: () => {
    return {
      superchainCount: 0,
      wingCollect: []
    };
  },
  triggers: [{
    id: 'P12N On the Soul',
    type: 'StartsUsing',
    netRegex: {
      id: '82D9',
      source: 'Athena',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P12N Wing Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: ['82C1', '82C2'],
      source: 'Athena',
      capture: false
    },
    run: data => data.wingCollect = []
  }, {
    id: 'P12N Wing Collect',
    type: 'HeadMarker',
    netRegex: {
      id: wingIds
    },
    durationSeconds: 5.5,
    infoText: (data, matches, output) => {
      data.wingCollect.push(matches);
      if (data.wingCollect.length !== 3) return;
      const [first, second, third] = data.wingCollect.map(x => x.id);
      if (first === undefined || second === undefined || third === undefined) return;
      const firstStr = first === wings.topLeft ? output.right() : output.left();
      const secondStr = second === wings.middleLeft ? output.right() : output.left();
      const thirdStr = third === wings.bottomLeft ? output.right() : output.left();
      return output.text({
        first: firstStr,
        second: secondStr,
        third: thirdStr
      });
    },
    outputStrings: {
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      text: {
        en: '${first} => ${second} => ${third}',
        de: '${first} => ${second} => ${third}',
        fr: '${first} => ${second} => ${third}',
        ja: '${first} => ${second} => ${third}',
        cn: '${first} => ${second} => ${third}',
        ko: '${first} => ${second} => ${third}'
      }
    }
  }, {
    id: 'P12N First Wing',
    type: 'HeadMarker',
    netRegex: {
      id: [wings.topLeft, wings.topRight],
      capture: false
    },
    durationSeconds: 7,
    alertText: (data, _matches, output) => {
      const first = data.wingCollect[0]?.id;
      if (first === undefined) return;
      if (first === wings.topLeft) return output.rightFlank();
      return output.leftFlank();
    },
    outputStrings: wingOutputStrings
  }, {
    id: 'P12N Second Wing',
    type: 'Ability',
    netRegex: {
      id: ['82C1', '82C2'],
      source: 'Athena',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      const second = data.wingCollect[1]?.id;
      if (second === undefined) return;
      if (second === wings.middleLeft) return output.rightFlank();
      return output.leftFlank();
    },
    outputStrings: wingOutputStrings
  }, {
    id: 'P12N Third Wing',
    type: 'Ability',
    netRegex: {
      id: ['82C3', '82C4'],
      source: 'Athena',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      const third = data.wingCollect[2]?.id;
      if (third === undefined) return;
      if (third === wings.bottomLeft) return output.rightFlank();
      return output.leftFlank();
    },
    outputStrings: wingOutputStrings
  }, {
    id: 'P12N Glaukopis',
    type: 'StartsUsing',
    netRegex: {
      id: '82D5',
      source: 'Athena'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave('alert')
  }, {
    id: 'P12N Superchain Theory',
    type: 'StartsUsing',
    netRegex: {
      id: '82BC',
      source: 'Athena',
      capture: false
    },
    infoText: (data, _matches, output) => {
      data.superchainCount++;

      // 1, 2, 3, 4, 3, 4, 3, 4, etc
      const count = data.superchainCount > 3 ? (data.superchainCount - 3) % 2 + 3 : data.superchainCount;
      return {
        1: output.superchain1(),
        2: output.superchain2(),
        3: output.superchain3(),
        4: output.superchain4()
      }[count];
    },
    outputStrings: {
      superchain1: {
        en: 'Follow Donut',
        de: 'Donut folgen',
        fr: 'Suivez le donut',
        ja: 'ドーナツへ',
        cn: '跟随月环',
        ko: '도넛 따라가기'
      },
      superchain2: {
        en: 'Short Donut => Long Donut',
        de: 'Kurzer Donut => Langer Donut',
        fr: 'Donut court => Donut long',
        ja: '早ドーナツ => 遅ドーナツ',
        cn: '短月环 => 长月环',
        ko: '짧은 도넛 => 긴 도넛'
      },
      superchain3: {
        en: 'Follow Donut (avoid cleave)',
        de: 'Donut folgen (Cleave ausweichen)',
        fr: 'Suivez le donut (évitez le cleave)',
        ja: 'ボスの横からドーナツへ',
        cn: '跟随月环（远离钢铁）',
        ko: '도넛 따라가기 (광역기 피하기)'
      },
      superchain4: {
        en: 'Avoid Spheres',
        de: 'Spheren vermeiden',
        fr: 'Évitez les sphères',
        ja: 'オブ回避',
        cn: '远离钢铁',
        ko: '구체 피하기'
      }
    }
  }, {
    id: 'P12N Parthenos',
    type: 'StartsUsing',
    netRegex: {
      id: '82D8',
      source: 'Athena',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'P12N Unnatural Enchainment',
    type: 'StartsUsing',
    netRegex: {
      id: '82BF',
      source: 'Athena',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Chained Platforms',
        de: 'Vermeide angekettete Platformen',
        fr: 'Évitez les plateformes enchaînées',
        ja: '壊れそうなマス回避',
        cn: '远离连线地板',
        ko: '연결된 플랫폼 피하기'
      }
    }
  }, {
    id: 'P12N Spread',
    // Used for both Palladion during add phase (no cast) and Dialogos (82D7).
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'P12N Dialogos Stack',
    type: 'StartsUsing',
    netRegex: {
      id: '82D6',
      source: 'Athena'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Anthropos': 'Anthropos',
      'Athena': 'Athena',
      'Thymou Idea': 'Thymos'
    },
    'replaceText': {
      '\\(spread\\)': '(Verteilen)',
      '\\(stack\\)': '(Sammeln)',
      'Clear Cut': 'Klarer Schnitt',
      'Dialogos': 'Dialogos',
      'Glaukopis': 'Glaukopis',
      'On the Soul': 'Auf der Seele',
      'Palladion': 'Palladion',
      'Paradeigma': 'Paradigma',
      'Parthenos': 'Parthenos',
      'Ray of Light': 'Lichtstrahl',
      'Sample': 'Vielfraß',
      'Superchain Burst': 'Superkette - Ausbruch',
      'Superchain Coil': 'Superkette - Kreis',
      'Superchain Theory': 'Superkette - Theorie',
      'Theos\'s Ultima': 'Theos Ultima',
      'Trinity of Souls': 'Dreifaltigkeit der Seelen',
      'Ultima Blade': 'Ultima-Klinge',
      'Unnatural Enchainment': 'Seelenfessel',
      'White Flame': 'Weißes Feuer'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Anthropos': 'anthropos',
      'Athena': 'Athéna',
      'Thymou Idea': 'thymou idea'
    },
    'replaceText': {
      'Clear Cut': 'Tranchage balayant',
      'Dialogos': 'Dialogos',
      'Glaukopis': 'Glaukopis',
      'On the Soul': 'Sur les âmes',
      'Palladion': 'Palladion',
      'Paradeigma': 'Paradeigma',
      'Parthenos': 'Parthénon',
      'Ray of Light': 'Onde de lumière',
      'Sample': 'Voracité',
      'Superchain Burst': 'Salve des superchaînes',
      'Superchain Coil': 'Cercle des superchaînes',
      'Superchain Theory': 'Théorie des superchaînes',
      'Theos\'s Ultima': 'Ultima de théos',
      'Trinity of Souls': 'Âmes trinité',
      'Ultima Blade': 'Lames Ultima',
      'Unnatural Enchainment': 'Enchaînement d\'âmes',
      'White Flame': 'Feu blanc'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Anthropos': 'アンスロポス',
      'Athena': 'アテナ',
      'Thymou Idea': 'テューモス・イデア'
    },
    'replaceText': {
      'Clear Cut': '斬り払い',
      'Dialogos': 'ディアロゴス',
      'Glaukopis': 'グラウコピス',
      'On the Soul': 'オン・ザ・ソウル',
      'Palladion': 'パラディオン',
      'Paradeigma': 'パラデイグマ',
      'Parthenos': 'パルテノン',
      'Ray of Light': '光波',
      'Sample': '貪食',
      'Superchain Burst': 'スーパーチェイン・バースト',
      'Superchain Coil': 'スーパーチェイン・サークル',
      'Superchain Theory': 'スーパーチェイン・セオリー',
      'Theos\'s Ultima': 'テオス・アルテマ',
      'Trinity of Souls': 'トリニティ・ソウル',
      'Ultima Blade': 'アルテマブレイド',
      'Unnatural Enchainment': '魂の鎖',
      'White Flame': '白火'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Anthropos': '人',
      'Athena': '雅典娜',
      'Thymou Idea': '激情理念'
    },
    'replaceText': {
      '\\(spread\\)': '(分散)',
      '\\(stack\\)': '(集合)',
      'Clear Cut': '横斩',
      'Dialogos': '对话',
      'Glaukopis': '明眸',
      'On the Soul': '论灵魂',
      'Palladion': '女神的护佑',
      'Paradeigma': '范式',
      'Parthenos': '贞女',
      'Ray of Light': '光波',
      'Sample': '贪食',
      'Superchain Burst': '超链爆发',
      'Superchain Coil': '超链回环',
      'Superchain Theory': '超链理论',
      'Theos\'s Ultima': '神之究极',
      'Trinity of Souls': '三魂一体',
      'Ultima Blade': '究极之刃',
      'Unnatural Enchainment': '灵魂链',
      'White Flame': '白火'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Anthropos': '안트로포스',
      'Athena': '아테나',
      'Thymou Idea': '기개의 이데아'
    },
    'replaceText': {
      '\\(spread\\)': '(산개)',
      '\\(stack\\)': '(쉐어)',
      'Clear Cut': '후려베기',
      'Dialogos': '디아로고스',
      'Glaukopis': '글라우코피스',
      'On the Soul': '영혼에 관하여',
      'Palladion': '팔라디온',
      'Paradeigma': '파라데이그마',
      'Parthenos': '파르테노스',
      'Ray of Light': '빛살',
      'Sample': '남식',
      'Superchain Burst': '초사슬 폭발',
      'Superchain Coil': '초사슬 고리',
      'Superchain Theory': '초사슬 이론',
      'Theos\'s Ultima': '테오스 알테마',
      'Trinity of Souls': '삼위일혼',
      'Ultima Blade': '알테마 블레이드',
      'Unnatural Enchainment': '영혼의 사슬',
      'White Flame': '하얀 불꽃'
    }
  }]
};
/* harmony default export */ const p12n = (p12n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p12n.txt
const raid_p12n_namespaceObject = "### P12N: Anabaseios: The Twelfth Circle\r\n# -ii 8679 82CA 82CC 87A1 82CF 82D0 8314\r\n# -p 82D9:12 -p 82D1:500\r\n# -it Athena\r\n# -it Anthropos\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n# Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.0 \"--sync--\" StartsUsing { id: \"82D9\", source: \"Athena\" } window 20,20\r\n12.0 \"On the Soul\" Ability { id: \"82D9\", source: \"Athena\" }\r\n29.1 \"Trinity of Souls 1\" Ability { id: \"82C[12]\", source: \"Athena\" }\r\n31.8 \"Trinity of Souls 2\" Ability { id: \"82C[34]\", source: \"Athena\" }\r\n34.4 \"Trinity of Souls 3\" Ability { id: \"82C[56]\", source: \"Athena\" }\r\n43.7 \"Paradeigma\" Ability { id: \"82C7\", source: \"Athena\" }\r\n47.9 \"--sync--\" Ability { id: \"8314\", source: \"Thymou Idea\" }\r\n57.1 \"Ray of Light\" Ability { id: \"82C8\", source: \"Anthropos\" }\r\n57.1 \"White Flame\" Ability { id: \"82C9\", source: \"Anthropos\" }\r\n70.8 \"Trinity of Souls 1\" Ability { id: \"82C[12]\", source: \"Athena\" }\r\n73.5 \"Trinity of Souls 2\" Ability { id: \"82C[34]\", source: \"Athena\" }\r\n76.1 \"Trinity of Souls 3\" Ability { id: \"82C[56]\", source: \"Athena\" }\r\n84.3 \"On the Soul\" Ability { id: \"82D9\", source: \"Athena\" }\r\n92.5 \"Glaukopis\" Ability { id: \"82D5\", source: \"Athena\" }\r\n104.6 \"Superchain Theory\" Ability { id: \"82BC\", source: \"Athena\" }\r\n119.8 \"Superchain Coil\" Ability { id: \"82BE\", source: \"Athena\" }\r\n119.8 \"Superchain Burst\" Ability { id: \"82BD\", source: \"Athena\" }\r\n130.8 \"Superchain Theory\" Ability { id: \"82BC\", source: \"Athena\" }\r\n144.0 \"Superchain Coil 1\" Ability { id: \"82BE\", source: \"Athena\" }\r\n147.0 \"Superchain Coil 2\" Ability { id: \"82BE\", source: \"Athena\" }\r\n155.0 \"Parthenos\" Ability { id: \"82D8\", source: \"Athena\" }\r\n162.7 \"On the Soul\" Ability { id: \"82D9\", source: \"Athena\" }\r\n169.9 \"--sync--\" Ability { id: \"8315\", source: \"Athena\" }\r\n178.5 \"Unnatural Enchainment\" Ability { id: \"82BF\", source: \"Athena\" }\r\n179.6 \"Sample\" Ability { id: \"82C0\", source: \"Athena\" }\r\n186.6 \"Paradeigma\" Ability { id: \"82C7\", source: \"Athena\" }\r\n190.8 \"--sync--\" Ability { id: \"8314\", source: \"Thymou Idea\" }\r\n196.8 \"--sync--\" Ability { id: \"8315\", source: \"Athena\" }\r\n200.0 \"Ray of Light\" Ability { id: \"82C8\", source: \"Anthropos\" }\r\n200.0 \"White Flame\" Ability { id: \"82C9\", source: \"Anthropos\" }\r\n205.1 \"Unnatural Enchainment\" Ability { id: \"82BF\", source: \"Athena\" }\r\n206.2 \"Sample\" Ability { id: \"82C0\", source: \"Athena\" }\r\n221.2 \"Trinity of Souls 1\" Ability { id: \"82C[12]\", source: \"Athena\" }\r\n223.9 \"Trinity of Souls 2\" Ability { id: \"82C[34]\", source: \"Athena\" }\r\n226.5 \"Trinity of Souls 3\" Ability { id: \"82C[56]\", source: \"Athena\" }\r\n234.7 \"On the Soul\" Ability { id: \"82D9\", source: \"Athena\" }\r\n241.8 \"--sync--\" Ability { id: \"8315\", source: \"Athena\" }\r\n246.4 \"Ultima Blade\" Ability { id: \"82CB\", source: \"Athena\" }\r\n256.4 \"--untargetable--\"\r\n\r\n# Add Phase\r\n256.4 \"--adds targetable--\"\r\n266.7 \"--sync--\" Ability { id: \"82CD\", source: \"Athena\" } window 30,30\r\n266.9 \"Palladion 1\" Ability { id: \"82CE\", source: \"Athena\" }\r\n268.5 \"Ray of Light\" Ability { id: \"82D4\", source: \"Anthropos\" }\r\n270.1 \"Palladion 2\" Ability { id: \"82CE\", source: \"Athena\" }\r\n273.1 \"Palladion 3\" Ability { id: \"82CE\", source: \"Athena\" }\r\n274.1 \"Clear Cut\" Ability { id: \"82D3\", source: \"Anthropos\" }\r\n276.2 \"Palladion 4\" Ability { id: \"82CE\", source: \"Athena\" }\r\n279.2 \"Palladion 5\" Ability { id: \"82CE\", source: \"Athena\" }\r\n281.0 \"Ray of Light\" Ability { id: \"82D4\", source: \"Anthropos\" }\r\n282.3 \"Palladion 6\" Ability { id: \"82CE\", source: \"Athena\" }\r\n285.3 \"Palladion 7\" Ability { id: \"82CE\", source: \"Athena\" }\r\n287.4 \"Clear Cut\" Ability { id: \"82D3\", source: \"Anthropos\" }\r\n288.4 \"Palladion 8\" Ability { id: \"82CE\", source: \"Athena\" }\r\n293.4 \"Ray of Light\" Ability { id: \"82D4\", source: \"Anthropos\" }\r\n# ??? this is ~90% on the enrage\r\n\r\n# Final Phase\r\n500.0 \"--sync--\" StartsUsing { id: \"82D1\", source: \"Athena\" } window 500,0\r\n505.8 \"Palladion\" Ability { id: \"82D1\", source: \"Athena\" }\r\n510.8 \"--sync--\" StartsUsing { id: \"82D2\", source: \"Athena\" }\r\n517.8 \"Theos's Ultima\" Ability { id: \"82D2\", source: \"Athena\" } window 20,20\r\n525.8 \"--targetable--\"\r\n\r\n537.4 \"Superchain Theory\" Ability { id: \"82BC\", source: \"Athena\" }\r\n550.5 \"Superchain Burst\" Ability { id: \"82BD\", source: \"Athena\" }\r\n554.6 \"Parthenos\" Ability { id: \"82D8\", source: \"Athena\" }\r\n555.5 \"Superchain Burst\" Ability { id: \"82BD\", source: \"Athena\" }\r\n560.5 \"Superchain Coil\" Ability { id: \"82BE\", source: \"Athena\" }\r\n560.5 \"Superchain Burst\" Ability { id: \"82BD\", source: \"Athena\" }\r\n569.3 \"Trinity of Souls 1\" Ability { id: \"82C[12]\", source: \"Athena\" }\r\n572.0 \"Trinity of Souls 2\" Ability { id: \"82C[34]\", source: \"Athena\" }\r\n574.6 \"Trinity of Souls 3\" Ability { id: \"82C[56]\", source: \"Athena\" }\r\n582.8 \"Dialogos (stack)\" Ability { id: \"82D6\", source: \"Athena\" }\r\n587.8 \"Dialogos (spread)\" Ability { id: \"82D7\", source: \"Athena\" }\r\n596.5 \"Glaukopis\" Ability { id: \"82D5\", source: \"Athena\" }\r\n606.6 \"Paradeigma\" Ability { id: \"82C7\", source: \"Athena\" }\r\n614.7 \"Superchain Theory\" Ability { id: \"82BC\", source: \"Athena\" }\r\n628.7 \"Superchain Burst\" Ability { id: \"82BD\", source: \"Athena\" }\r\n628.7 \"Ray of Light\" Ability { id: \"82C8\", source: \"Anthropos\" }\r\n628.7 \"White Flame\" Ability { id: \"82C9\", source: \"Anthropos\" }\r\n631.6 \"Unnatural Enchainment\" Ability { id: \"82BF\", source: \"Athena\" }\r\n632.7 \"Sample\" Ability { id: \"82C0\", source: \"Athena\" }\r\n643.7 \"Parthenos\" Ability { id: \"82D8\", source: \"Athena\" }\r\n651.4 \"On the Soul\" Ability { id: \"82D9\", source: \"Athena\" }\r\n661.6 \"Paradeigma\" Ability { id: \"82C7\", source: \"Athena\" }\r\n669.8 \"Dialogos (stack)\" Ability { id: \"82D6\", source: \"Athena\" }\r\n674.8 \"Dialogos (spread)\" Ability { id: \"82D7\", source: \"Athena\" }\r\n678.8 \"Ray of Light\" Ability { id: \"82C8\", source: \"Anthropos\" }\r\n678.8 \"White Flame\" Ability { id: \"82C9\", source: \"Anthropos\" }\r\n683.4 \"Glaukopis\" Ability { id: \"82D5\", source: \"Athena\" }\r\n691.5 \"On the Soul\" Ability { id: \"82D9\", source: \"Athena\" }\r\n\r\n# TODO: probably a loop, have seen up to Paradeigma at 606.6/767.3\r\n703.7 \"Superchain Theory\" Ability { id: \"82BC\", source: \"Athena\" } window 30,30 jump 537.4\r\n716.8 \"Superchain Burst\" #Ability { id: \"82BD\", source: \"Athena\" }\r\n720.9 \"Parthenos\" #Ability { id: \"82D8\", source: \"Athena\" }\r\n721.8 \"Superchain Burst\" #Ability { id: \"82BD\", source: \"Athena\" }\r\n726.8 \"Superchain Coil\" #Ability { id: \"82BE\", source: \"Athena\" }\r\n726.8 \"Superchain Burst\" #Ability { id: \"82BD\", source: \"Athena\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p12s.ts







// TODO: add phase dash calls?? (maybe this is overkill)

// TODO: crush helm tankbusters??? (+esuna calls for non-invulning tanks??)
// TODO: detect(?!) hex strat for caloric2 and tell people who to go to??
const p12s_centerX = 100;
const p12s_centerY = 100;
const distSqr = (a, b) => {
  const dX = parseFloat(a.x) - parseFloat(b.x);
  const dY = parseFloat(a.y) - parseFloat(b.y);
  return dX * dX + dY * dY;
};
const p12s_wings = {
  // vfx/lockon/eff/m0829_cst19_9s_c0v.avfx
  topLeftFirst: '01A5',
  // 82E2 cast and damage
  // vfx/lockon/eff/m0829_cst20_9s_c0v.avfx
  topRightFirst: '01A6',
  // 82E1 cast and damage
  // vfx/lockon/eff/m0829_cst21_6s_c0v.avfx
  middleLeftSecond: '01A7',
  // 82E4 damage (top down), 82EA damage (bottom up)
  // vfx/lockon/eff/m0829_cst22_6s_c0v.avfx
  middleRightSecond: '01A8',
  // 82E3 damage (top down), 82E9 damage (bottom up)
  // vfx/lockon/eff/m0829_cst23_9s_c0v.avfx
  bottomLeftFirst: '01A9',
  // 82E8 cast and damage
  // vfx/lockon/eff/m0829_cst24_9s_c0v.avfx
  bottomRightFirst: '01AA',
  // 82E7 cast and damage
  // vfx/lockon/eff/m0829_cst19_3s_c0v.avfx
  topLeftThird: '01AF',
  // 82EC damage
  // vfx/lockon/eff/m0829_cst20_3s_c0v.avfx
  topRightThird: '01B0',
  // 82EB damage
  // vfx/lockon/eff/m0829_cst22_6s_c0v.avfx
  bottomLeftThird: '01B1',
  // 82E6 damage
  // vfx/lockon/eff/m0829_cst23_3s_c0v.avfx
  bottomRightThird: '01B2' // 82E5 damage
};

const superchainNpcNameId = '12377';
const superchainNpcBaseIdMap = {
  destination: '16176',
  out: '16177',
  in: '16178',
  protean: '16179',
  partners: '16180'
};
const engravementLabelMapAsConst = {
  DF8: 'lightTilt',
  DF9: 'darkTilt',
  DFB: 'lightTower',
  DFC: 'darkTower',
  DFD: 'lightBeam',
  DFE: 'darkBeam',
  DFF: 'crossMarked',
  E00: 'xMarked'
};
const engravementLabelMap = engravementLabelMapAsConst;
const engravementIdMap = Object.fromEntries(Object.entries(engravementLabelMap).map(([k, v]) => [v, k]));
const engravementBeamIds = [engravementIdMap.lightBeam, engravementIdMap.darkBeam];
const engravementTowerIds = [engravementIdMap.lightTower, engravementIdMap.darkTower];
const engravementTiltIds = [engravementIdMap.lightTilt, engravementIdMap.darkTilt];
const engravement3TheosSoulIds = [engravementIdMap.crossMarked, engravementIdMap.xMarked];
const anthroposTetherMap = {
  '00E9': 'light',
  // needs stretching
  '00EA': 'dark',
  // needs stretching
  '00FA': 'light',
  // adequately stretched
  '00FB': 'dark' // adequately stretched
};

const tetherAbilityToTowerMap = {
  '82F1': 'lightTower',
  '82F2': 'darkTower'
};
const p12s_headmarkers = {
  ...p12s_wings,
  // vfx/lockon/eff/tank_laser_5sec_lockon_c0a1.avfx
  glaukopis: '01D7',
  // vfx/lockon/eff/sph_lockon2_num01_s8p.avfx (through sph_lockon2_num04_s8p)
  limitCut1: '0150',
  limitCut2: '0151',
  limitCut3: '0152',
  limitCut4: '0153',
  // vfx/lockon/eff/sph_lockon2_num05_s8t.avfx (through sph_lockon2_num08_s8t)
  limitCut5: '01B5',
  limitCut6: '01B6',
  limitCut7: '01B7',
  limitCut8: '01B8',
  // vfx/lockon/eff/tank_lockonae_0m_5s_01t.avfx
  palladianGrasp: '01D4',
  // vfx/lockon/eff/m0376trg_fire3_a0p.avfx
  chains: '0061',
  // vfx/lockon/eff/lockon3_t0h.avfx
  geocentrismSpread: '0016',
  // vfx/lockon/eff/lockon_en_01v.avfx
  playstationCircle: '016F',
  // vfx/lockon/eff/lockon_sitasankaku_01v.avfx
  playstationTriangle: '0170',
  // vfx/lockon/eff/lockon_sikaku_01v.avfx
  playstationSquare: '0171',
  // vfx/lockon/eff/lockon_batu_01v.avfx
  playstationCross: '0172',
  // vfx/lockon/eff/m0124trg_a4c.avfx
  caloric1Beacon: '012F',
  // vfx/lockon/eff/lockon8_line_1v.avfx
  caloric2InitialFire: '01D6',
  // vfx/lockon/eff/d1014trg_8s_0v.avfx
  caloric2Wind: '01D5'
};
const limitCutMap = {
  [p12s_headmarkers.limitCut1]: 1,
  [p12s_headmarkers.limitCut2]: 2,
  [p12s_headmarkers.limitCut3]: 3,
  [p12s_headmarkers.limitCut4]: 4,
  [p12s_headmarkers.limitCut5]: 5,
  [p12s_headmarkers.limitCut6]: 6,
  [p12s_headmarkers.limitCut7]: 7,
  [p12s_headmarkers.limitCut8]: 8
};
const p12s_limitCutIds = Object.keys(limitCutMap);
const p12s_wingIds = Object.values(p12s_wings);
const superchainNpcBaseIds = Object.values(superchainNpcBaseIdMap);
const whiteFlameDelayOutputStrings = {
  delay1: {
    en: 'now',
    de: 'jetzt',
    fr: 'Maintenant',
    cn: '现在!',
    ko: '바로'
  },
  delay2: {
    en: 'soon',
    de: 'bald',
    fr: 'Bientôt',
    cn: '等1只小怪',
    ko: '1번째 쫄'
  },
  delay3: {
    en: 'delayed',
    de: 'verzögert',
    fr: 'Retardé',
    cn: '等2只小怪',
    ko: '2번째 쫄'
  },
  delay4: {
    en: 'very delayed',
    de: 'sehr verzögert',
    fr: 'Très retardé',
    cn: '等3只小怪',
    ko: '3번째 쫄'
  },
  delay5: {
    en: 'verrry delayed',
    de: 'seeeeehr verzögert',
    fr: 'Trèèèès retardé',
    cn: '等4只小怪',
    ko: '4번째 쫄'
  }
};
const conceptPairMap = {
  [p12s_headmarkers.playstationCircle]: 'circle',
  [p12s_headmarkers.playstationTriangle]: 'triangle',
  [p12s_headmarkers.playstationSquare]: 'square',
  [p12s_headmarkers.playstationCross]: 'cross'
};
const conceptDebuffIds = {
  DE8: 'alpha',
  DE9: 'beta'
};
const conceptDebuffToColor = {
  alpha: 'red',
  beta: 'yellow'
};
const npcBaseIdToConceptColor = {
  16183: 'red',
  16184: 'blue',
  16185: 'yellow'
};
const conceptDebuffEffectIds = Object.keys(conceptDebuffIds);
const conceptNpcBaseIds = Object.keys(npcBaseIdToConceptColor);
const conceptPairIds = Object.keys(conceptPairMap);

// The below functions assign a numerical value to all (shapes) and intercept points:
// xy: 88       96       104       112
// 84  (0)--5--(10)--15--(20)--25--(30)
//      |        |         |         |
//      1       11        21        31
//      |        |         |         |
// 92  (2)--7--(12)--17--(22)--27--(32)
//      |        |         |         |
//      3       13        23        33
//      |        |         |         |
// 100 (4)--9--(14)--19--(24)--29--(34)

const conceptLocationMap = {
  north: [0, 10, 20, 30],
  middle: [2, 12, 22, 32],
  south: [4, 14, 24, 34]
};
const getConceptLocation = concept => {
  const x = parseFloat(concept.x);
  const y = parseFloat(concept.y);
  let row;
  if (y < 88) row = 'north';else row = y > 96 ? 'south' : 'middle';
  let col;
  if (x < 92) col = 0;else if (x > 108) col = 3;else col = x > 100 ? 2 : 1;
  return conceptLocationMap[row][col];
};
const getConceptMap = startLoc => {
  // takes a concept location and returns an array containing pairs of [adjacentLocation, interceptLocation]
  const conceptMap = [];
  const expectedLocs = [...conceptLocationMap.north, ...conceptLocationMap.middle, ...conceptLocationMap.south];
  const [n, e, s, w] = [startLoc - 2, startLoc + 10, startLoc + 2, startLoc - 10];
  if (expectedLocs.includes(n)) conceptMap.push([n, n + 1]);
  if (expectedLocs.includes(e)) conceptMap.push([e, e - 5]);
  if (expectedLocs.includes(s)) conceptMap.push([s, s - 1]);
  if (expectedLocs.includes(w)) conceptMap.push([w, w + 5]);
  return conceptMap;
};
const pangenesisEffects = {
  stableSystem: 'E22',
  unstableFactor: 'E09',
  lightTilt: 'DF8',
  darkTilt: 'DF9'
};
const pangenesisEffectIds = Object.values(pangenesisEffects);
const p12s_getHeadmarkerId = (data, matches) => {
  if (data.decOffset === undefined) {
    if (data.expectedFirstHeadmarker === undefined) {
      console.error('missing expected first headmarker');
      return 'OOPS';
    }
    data.decOffset = parseInt(matches.id, 16) - parseInt(data.expectedFirstHeadmarker, 16);
  }
  return (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase().padStart(4, '0');
};
const p12s_triggerSet = {
  id: 'AnabaseiosTheTwelfthCircleSavage',
  zoneId: zone_id/* default.AnabaseiosTheTwelfthCircleSavage */.Z.AnabaseiosTheTwelfthCircleSavage,
  config: [{
    id: 'engravement1DropTower',
    name: {
      en: 'Paradeigma 2 Tower Strategy',
      de: 'Paradigma 2 Türme Strategy',
      fr: 'Paradeigma Stratégie 2 Tours',
      ja: 'パラデイグマ2の塔処理方法',
      cn: '范式 2 踩塔方法',
      ko: '파라데이그마 2 기둥 공략'
    },
    type: 'select',
    options: {
      en: {
        'Based on Tether': 'tetherbase',
        'Tether direct across + nearest quadrant tower (Game8)': 'quadrant',
        'Clockwise tower from tether': 'clockwise',
        'No strategy: just call tower color': 'tower'
      },
      de: {
        'Verbindungen gerade rüber + nächstgelegener Quadrant Turm (Game8)': 'quadrant',
        'Turm im Uhrzeigersinn von der Verbindungen': 'clockwise',
        'Keine Strategie: einfach Turmfarbe nennen': 'tower'
      },
      fr: {
        'Basé sur les liens': 'tetherbase',
        'Lien direct à travers + tour du quadrant le plus proche (Game8)': 'quadrant',
        'Tour en sens horaire depuis les liens': 'clockwise',
        'Aucune stratégie : Call des couleur des tours uniquement': 'tower'
      },
      ja: {
        'ぬけまるとGame8': 'quadrant',
        '腺から時計回り': 'clockwise',
        '方針なし': 'tower'
      },
      cn: {
        '看小怪位置(菓子)': 'tetherbase',
        '垂直拉线 (Game8)': 'quadrant',
        '对角拉线': 'clockwise',
        '仅提示塔颜色': 'tower'
      },
      ko: {
        '선 위치 기반': 'tetherbase',
        '반대편 + 가까운 사분면의 기둥 (Game8)': 'quadrant',
        '선 연결된 곳의 시계방향': 'clockwise',
        '공략 없음: 그냥 기둥 색만 알림': 'tower'
      }
    },
    default: 'tower'
  }, {
    id: 'classicalConceptsPairOrder',
    name: {
      en: 'Classical Concepts: Pairs Order (Left->Right)',
      de: 'Elementarschöpfung: Ordnen nach Paaren (Links->Rechts)',
      fr: 'Concepts élémentaires : Ordre des paires (Gauche->Droite)',
      cn: '经典概念 索尼顺序（左->右）',
      ko: 'Classical Concepts: 도형 순서 (왼 -> 오)'
    },
    type: 'select',
    options: {
      en: {
        'X□○Δ (BPOG)': 'xsct',
        '○XΔ□ (Lines)': 'cxts',
        '○Δ□X (Rocketship)': 'ctsx',
        '○ΔX□ (Rainbow)': 'ctxs',
        'Δ○X□ (TOXS)': 'tcxs',
        'Just call shape and debuff': 'shapeAndDebuff'
      },
      de: {
        'X□○Δ (BLOG)': 'xsct',
        '○XΔ□ (Linien)': 'cxts',
        '○Δ□X (Raketenschiff)': 'ctsx',
        '○ΔX□ (Regenbogen)': 'ctxs',
        'Δ○X□ (TOXS)': 'tcxs',
        'Just call shape and debuff': 'shapeAndDebuff' // FIXME
      },

      fr: {
        'X□○Δ (BPOG)': 'xsct',
        '○XΔ□ (Lignes)': 'cxts',
        '○Δ□X (Fusée)': 'ctsx',
        '○ΔX□ (Arc-en-ciel)': 'ctxs',
        'Δ○X□ (TOXS)': 'tcxs',
        'Afficher uniquement la forme et le débuff': 'shapeAndDebuff'
      },
      cn: {
        'X□○Δ (BPOG)': 'xsct',
        '○XΔ□ (1234笔画)': 'cxts',
        '○Δ□X (Rocketship)': 'ctsx',
        '○ΔX□ (彩虹)': 'ctxs',
        'Δ○X□ (TOXS)': 'tcxs',
        '只报形状和debuff': 'shapeAndDebuff'
      },
      ko: {
        'X□○Δ (파보빨초)': 'xsct',
        '○XΔ□ (1234)': 'cxts',
        '○Δ□X (동세네엑)': 'ctsx',
        '○ΔX□ (무지개)': 'ctxs',
        'Δ○X□ (TOXS)': 'tcxs',
        '모양과 디버프만 알림': 'shapeAndDebuff'
      }
    },
    default: 'shapeAndDebuff'
  }, {
    id: 'classicalConcepts2ActualNoFlip',
    comment: {
      en: `Only calls final position immediately in chosen pair order with no flip.
             For example, for BPOG, the blue X (crosses) will be far west.
             <a href="https://overlayplugin.github.io/cactbot/resources/images/06ew_raid_p12s_classic2_noflip.webp" target="_blank">Visual</a>`,
      de: `Nennt die endgültige Position nur sofort in der gewählten Paarreihenfolge ohne Flip.
             Bei BPOG beispielsweise befindet sich das blaue X (Kreuze) weit westlich.
             <a href="https://overlayplugin.github.io/cactbot/resources/images/06ew_raid_p12s_classic2_noflip.webp" target="_blank">Visual</a>`,
      fr: `Afficher la position finale uniquement dans l\'ordre des paires choisies, sans inversion.
            Par exemple, pour le BPOG, le X bleu (croix) sera loin à l\'ouest.
            <a href="https://overlayplugin.github.io/cactbot/resources/images/06ew_raid_p12s_classic2_noflip.webp" target="_blank">Visual</a>`,
      cn: `只报自己图案的最终位置，没有位置变换。例如，对于 BPOG 打法，蓝 X 是第一列（西面最远）。
            <a href="https://overlayplugin.github.io/cactbot/resources/images/06ew_raid_p12s_classic2_noflip.webp" target="_blank">Visual</a>`,
      ko: `선택한 도형 순서에 따른 최종 위치만 알립니다. 예시에서 파보빨초를 기준으로 파랑 X는 1열이 됩니다.
            <a href="https://overlayplugin.github.io/cactbot/resources/images/06ew_raid_p12s_classic2_noflip.webp" target="_blank">Visual</a>`
    },
    name: {
      en: 'Classical Concepts 2: Actual only & no inversion',
      de: 'Classical Concepts 2: Nur tatsächlich & keine Umkehrung',
      fr: 'Classical Concepts 2 : Actuel uniquement & pas d\'inversion',
      cn: '经典概念2: 实际位置 (没有位置变换)',
      ko: '원소 이데아 2: 반전 없이 실제 위치만 알림'
    },
    type: 'checkbox',
    default: false
  }, {
    id: 'pangenesisFirstTower',
    name: {
      en: 'Pangenesis: First Towers',
      de: 'Pangenesis: Erste Türme',
      fr: 'Pangenesis: Première tour',
      cn: '黑白塔',
      ko: '범생설: 첫번째 기둥'
    },
    type: 'select',
    options: {
      en: {
        'Call Required Swaps Only': 'agnostic',
        '0+2 (HRT)': 'not',
        '1+2 (Yuki/Rinon)': 'one'
      },
      de: {
        'Nenne nur benötigte Wechsel': 'agnostic',
        '0+2 (HRT)': 'not',
        '1+2 (Yuki/Rinon)': 'one'
      },
      fr: {
        'Afficher uniquement les swaps nécessaires': 'agnostic',
        '0+2 (HRT)': 'not',
        '1+2 (Yuki/Rinon)': 'one'
      },
      cn: {
        '只提示交换颜色': 'agnostic',
        '0+2 (HRT)': 'not',
        '1+2 (Yuki/Rinon)': 'one'
      },
      ko: {
        '교체가 필요할 때만 알림': 'agnostic',
        '0+2 (빠른 융합)': 'not',
        '1+2 (Yuki/Rinon)': 'one'
      }
    },
    default: 'agnostic'
  }],
  timelineFile: 'p12s.txt',
  initData: () => {
    return {
      isDoorBoss: true,
      combatantData: [],
      paradeigmaCounter: 0,
      glaukopisSecondHitSame: false,
      engravementCounter: 0,
      engravement1BeamsPosMap: new Map(),
      engravement1TetherIds: [],
      engravement1TetherPlayers: {},
      engravement1LightBeamsPos: [],
      engravement1DarkBeamsPos: [],
      engravement1Towers: [],
      engravement3TowerPlayers: [],
      engravement3TetherPlayers: {},
      wingCollect: [],
      wingCalls: [],
      superchainCollect: [],
      lcCombatants: [],
      lcCombatantsOffset: 0,
      whiteFlameCounter: 0,
      sampleTiles: [],
      darknessClones: [],
      conceptData: {},
      pangenesisRole: {},
      pangenesisTowerCount: 0,
      gaiaochosCounter: 0,
      classicalCounter: 0,
      classicalMarker: {},
      classicalAlphaBeta: {},
      caloricCounter: 0,
      caloric1First: [],
      caloric1Buff: {},
      caloric2PassCount: 0,
      gaiaochosTetherCollect: [],
      seenSecondTethers: false
    };
  },
  triggers: [{
    id: 'P12S Phase Tracker 1',
    type: 'StartsUsing',
    netRegex: {
      id: ['82DA', '82F5', '86FA', '86FB'],
      source: 'Athena'
    },
    run: (data, matches) => {
      data.whiteFlameCounter = 0;
      data.superchainCollect = [];
      const phaseMap = {
        '82DA': 'superchain1',
        '82F5': 'palladion',
        '86FA': 'superchain2a',
        '86FB': 'superchain2b'
      };
      data.phase = phaseMap[matches.id];
    }
  }, {
    id: 'P12S Phase Tracker 2',
    type: 'StartsUsing',
    // 8682 = Ultima cast
    netRegex: {
      id: '8682',
      source: 'Pallas Athena',
      capture: false
    },
    run: data => {
      data.isDoorBoss = false;
      data.expectedFirstHeadmarker = p12s_headmarkers.palladianGrasp;
    }
  }, {
    id: 'P12S Phase Tracker 3',
    type: 'StartsUsing',
    netRegex: {
      id: ['8326', '8331', '8338', '833F'],
      source: 'Pallas Athena'
    },
    run: (data, matches) => {
      switch (matches.id) {
        case '8326':
          data.phase = data.gaiaochosCounter === 0 ? 'gaiaochos1' : 'gaiaochos2';
          data.gaiaochosCounter++;
          break;
        case '8331':
          data.phase = data.classicalCounter === 0 ? 'classical1' : 'classical2';
          data.classicalCounter++;
          break;
        case '8338':
          data.phase = 'caloric';
          data.caloricCounter++;
          break;
        case '833F':
          data.phase = 'pangenesis';
          break;
      }
    }
  }, {
    id: 'P12S Door Boss Headmarker Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: ['82E7', '82E8'],
      source: 'Athena'
    },
    suppressSeconds: 99999,
    run: (data, matches) => {
      // The first headmarker in the door boss is EITHER the bottom left or bottom right wing.
      const isBottomLeft = matches.id === '82E8';
      const first = isBottomLeft ? p12s_headmarkers.bottomLeftFirst : p12s_headmarkers.bottomRightFirst;
      data.expectedFirstHeadmarker = first;
    }
  },
  // --------------------- Phase 1 ------------------------
  {
    id: 'P12S On the Soul',
    type: 'StartsUsing',
    netRegex: {
      id: '8304',
      source: 'Athena',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P12S Paradeigma Counter',
    type: 'StartsUsing',
    netRegex: {
      id: '82ED',
      source: 'Athena',
      capture: false
    },
    run: data => data.paradeigmaCounter++
  }, {
    id: 'P12S Paradeigma 1 Clones',
    type: 'Ability',
    // 8314 appears to transform the orbs ("Ideas") into clones once in position
    netRegex: {
      id: '8314',
      source: 'Thymou Idea'
    },
    condition: data => data.paradeigmaCounter === 1,
    delaySeconds: 0.5,
    // need a small delay to let position data catch up
    suppressSeconds: 10,
    // we only need y-pos of one add, and don't refire on the 2nd set of orbs
    promise: async (data, matches) => {
      data.combatantData = [];
      const id = parseInt(matches.sourceId, 16);
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [id]
      })).combatants;
    },
    infoText: (data, _matches, output) => {
      if (data.combatantData.length === 0) return output.clones({
        dir: output.unknown()
      });
      const y = data.combatantData[0]?.PosY;
      if (y === undefined) return output.clones({
        dir: output.unknown()
      });
      const cloneSide = y > p12s_centerY ? 'south' : 'north';
      return output.clones({
        dir: output[cloneSide]()
      });
    },
    outputStrings: {
      clones: {
        en: 'Clones ${dir}',
        de: 'Klone ${dir}',
        fr: 'Clones ${dir}',
        ja: '${dir}',
        cn: '分身 ${dir}',
        ko: '분신 ${dir}'
      },
      north: outputs/* default.north */.Z.north,
      south: outputs/* default.south */.Z.south,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  },
  // In Ray 1 (Paradeigma2), two adds always spawn north in pairs with PosX of [85, 105] or [95, 115].
  // Each cleaves 1/4th of the arena. So given one PosX, we can determine the inside/outside safe lanes.
  {
    id: 'P12S Ray of Light 1',
    type: 'StartsUsing',
    netRegex: {
      id: '82EE',
      source: 'Anthropos'
    },
    condition: data => data.paradeigmaCounter === 2,
    suppressSeconds: 1,
    alertText: (_data, matches, output) => {
      const x = Math.round(parseFloat(matches.x));
      let safeLanes;
      if (x < 90) safeLanes = 'insideWestOutsideEast';else if (x > 110) safeLanes = 'insideEastOutsideWest';else safeLanes = x < 100 ? 'insideEastOutsideWest' : 'insideWestOutsideEast';
      return output[safeLanes]();
    },
    outputStrings: {
      insideWestOutsideEast: {
        en: 'Inside West / Outside East',
        de: 'Westen innen / Osten außen',
        fr: 'Intérieur Ouest / Extérieur Est',
        ja: '西の内側 / 東の外側',
        cn: '内左 (西) / 外右 (东)',
        ko: '서쪽 안 / 동쪽 바깥'
      },
      insideEastOutsideWest: {
        en: 'Inside East / Outside West',
        de: 'Osten innen / Westen außen',
        fr: 'Intérieur Est / Extérieur Ouest',
        ja: '西の外側 / 東の内側',
        cn: '内右 (东) / 外左 (西)',
        ko: '동쪽 안 / 서쪽 바깥'
      }
    }
  }, {
    id: 'P12S First Wing',
    type: 'StartsUsing',
    netRegex: {
      id: ['82E7', '82E8', '82E1', '82E2'],
      source: 'Athena'
    },
    durationSeconds: 7,
    alertText: (data, matches, output) => {
      data.wingCollect = [];
      data.wingCalls = [];
      const isLeftAttack = matches.id === '82E8' || matches.id === '82E2';

      // Normal wings.
      const firstDir = data.superchain2aFirstDir;
      const secondDir = data.superchain2aSecondDir;
      if (data.phase !== 'superchain2a' || firstDir === undefined || secondDir === undefined) return isLeftAttack ? output.right() : output.left();
      if (isLeftAttack) {
        if (firstDir === 'north') {
          if (secondDir === 'north') return output.superchain2aRightNorthNorth();
          return output.superchain2aRightNorthSouth();
        }
        if (secondDir === 'north') return output.superchain2aRightSouthNorth();
        return output.superchain2aRightSouthSouth();
      }
      if (firstDir === 'north') {
        if (secondDir === 'north') return output.superchain2aLeftNorthNorth();
        return output.superchain2aLeftNorthSouth();
      }
      if (secondDir === 'north') return output.superchain2aLeftSouthNorth();
      return output.superchain2aLeftSouthSouth();
    },
    outputStrings: {
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      // This could *also* say partners, but it's always partners and that feels like
      // too much information.  The "after" call could be in an info text or something,
      // but the wings are also calling out info text too.  This is a compromise.
      // Sorry also for spelling this out so explicitly, but I suspect some people
      // might want different left/right calls based on North/South boss facing
      // and it's nice to have a "go through" or "go back" description too.
      superchain2aLeftNorthNorth: {
        en: 'North + Her Left (then back North)',
        de: 'Norden + Links von Ihr (dannach Norden)',
        fr: 'Nord + Sa gauche (puis Nord à nouveau)',
        ja: '北 + 北に戻る (左安置)',
        cn: '上 (北) + Boss左侧 (稍后 回上北)',
        ko: '북쪽 + 보스 왼쪽 (그리고 다시 북쪽)'
      },
      superchain2aLeftNorthSouth: {
        en: 'North + Her Left (then go South)',
        de: 'Norden + Links von Ihr (dannach Süden)',
        fr: 'Nord + Sa gauche (puis aller au Sud)',
        ja: '北 + 南へ前進 (左安置)',
        cn: '上 (北) + Boss左侧 (稍后 去下南)',
        ko: '북쪽 + 보스 왼쪽 (그리고 남쪽으로)'
      },
      superchain2aLeftSouthNorth: {
        en: 'South + Left (then go North)',
        de: 'Süden + Links (dannach Norden)',
        fr: 'Sud + Gauche (puis aller au Nord)',
        ja: '南 + 北へ前進 (左安置)',
        cn: '下 (南) + 左 (稍后 去上北)',
        ko: '남쪽 + 왼쪽 (그리고 북쪽으로)'
      },
      superchain2aLeftSouthSouth: {
        en: 'South + Left (then back South)',
        de: 'Süden + Links (dannach Süden)',
        fr: 'Sud + Gauche (puis Sud à nouveau)',
        ja: '南 + 南に戻る (左安置)',
        cn: '下 (南) + 左 (稍后 回下南)',
        ko: '남쪽 + 왼쪽 (그리고 다시 남쪽)'
      },
      superchain2aRightNorthNorth: {
        en: 'North + Her Right (then back North)',
        de: 'Norden + Rechts von Ihr (dannach Norden)',
        fr: 'Nord + Sa droite (puis Nord à nouveau)',
        ja: '北 + 北に戻る (右安置)',
        cn: '上 (北) + Boss右侧 (稍后 回上北)',
        ko: '북쪽 + 보스 오른쪽 (그리고 다시 북쪽)'
      },
      superchain2aRightNorthSouth: {
        en: 'North + Her Right (then go South)',
        de: 'Norden + Rechts von Ihr (dannach Süden)',
        fr: 'Nord + Sa droite (puis aller au Sud)',
        ja: '北 + 南へ前進 (右安置)',
        cn: '上 (北) + Boss右侧 (稍后 去下南)',
        ko: '북쪽 + 보스 오른쪽 (그리고 남쪽으로)'
      },
      superchain2aRightSouthNorth: {
        en: 'South + Right (then go North)',
        de: 'Süden + Rechts (dannach Norden)',
        fr: 'Sud + Droite (puis aller au Nord)',
        ja: '南 + 北へ前進 (右安置)',
        cn: '下 (南) + 右 (稍后 去上北)',
        ko: '남쪽 + 오른쪽 (그리고 북쪽으로)'
      },
      superchain2aRightSouthSouth: {
        en: 'South + Right (then back South)',
        de: 'Süden + Rechts (dannach Süden)',
        fr: 'Sud + Droite (puis Sud à nouveau)',
        ja: '南 + 南に戻る (右安置)',
        cn: '下 (南) + 右 (稍后 回下南)',
        ko: '남쪽 + 오른쪽 (그리고 다시 남쪽)'
      }
    }
  }, {
    id: 'P12S Wing Collect',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      const id = p12s_getHeadmarkerId(data, matches);
      if (!p12s_wingIds.includes(id)) return false;
      data.wingCollect.push(id);
      return true;
    },
    delaySeconds: data => data.decOffset === undefined ? 1 : 0,
    durationSeconds: data => data.wingCollect.length === 3 ? 7 : 2,
    infoText: (data, _matches, output) => {
      if (data.wingCollect.length !== 3 && data.wingCollect.length !== 2) return;
      const [first, second, third] = data.wingCollect;
      if (first === undefined || second === undefined) return;
      const isFirstLeft = first === p12s_wings.topLeftFirst || first === p12s_wings.bottomLeftFirst;
      const isSecondLeft = second === p12s_wings.middleLeftSecond;
      const isThirdLeft = third === p12s_wings.topLeftThird || third === p12s_wings.bottomLeftThird;
      const firstStr = isFirstLeft ? output.right() : output.left();
      const isFirstTop = first === p12s_wings.topLeftFirst || first === p12s_wings.topRightFirst;
      let secondCall;
      let thirdCall;
      if (isFirstTop) {
        secondCall = isFirstLeft === isSecondLeft ? 'stay' : 'swap';
        thirdCall = isSecondLeft === isThirdLeft ? 'stay' : 'swap';
      } else {
        secondCall = isFirstLeft === isSecondLeft ? 'swap' : 'stay';
        thirdCall = isSecondLeft === isThirdLeft ? 'swap' : 'stay';
      }
      data.wingCalls = [secondCall, thirdCall];

      // This is the second call only.
      if (third === undefined) {
        if (secondCall === 'stay') return output.secondWingCallStay();
        return output.secondWingCallSwap();
      }
      return output.allThreeWings({
        first: firstStr,
        second: output[secondCall](),
        third: output[thirdCall]()
      });
    },
    outputStrings: {
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      swap: {
        en: 'Swap',
        de: 'Wechseln',
        fr: 'Swap',
        ja: '横へ',
        cn: '穿',
        ko: '이동'
      },
      stay: {
        en: 'Stay',
        de: 'bleib Stehen',
        fr: 'Restez',
        ja: '止まる',
        cn: '停',
        ko: '가만히'
      },
      secondWingCallStay: {
        en: '(stay)',
        de: '(bleib Stehen)',
        fr: '(restez)',
        ja: '(止まる)',
        cn: '(停)',
        ko: '(가만히)'
      },
      secondWingCallSwap: {
        en: '(swap)',
        de: '(Wechseln)',
        fr: '(swap)',
        ja: '(横へ)',
        cn: '(穿)',
        ko: '(이동)'
      },
      allThreeWings: {
        en: '${first} => ${second} => ${third}',
        de: '${first} => ${second} => ${third}',
        fr: '${first} => ${second} => ${third}',
        cn: '${first} => ${second} => ${third}',
        ko: '${first} => ${second} => ${third}'
      }
    }
  }, {
    id: 'P12S Wing Followup',
    type: 'Ability',
    netRegex: {
      id: ['82E1', '82E2', '82E3', '82E4', '82E7', '82E8', '82E9', '82EA'],
      source: 'Athena',
      capture: false
    },
    // These are exactly 3 apart, so give them some room to disappear and not stack up.
    durationSeconds: 2.5,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      const call = data.wingCalls.shift();
      if (call === undefined) return;

      // Check if a normal wing call, not during Superchain IIA.
      const firstDir = data.superchain2aFirstDir;
      const secondDir = data.superchain2aSecondDir;
      const secondMech = data.superchain2aSecondMech;
      if (data.phase !== 'superchain2a' || firstDir === undefined || secondDir === undefined || secondMech === undefined) {
        if (call === 'swap') return output.swap();
        return output.stay();
      }

      // Second wing call (when middle) during Superchain IIA.
      const isSecondWing = data.wingCalls.length === 1;
      const finalDir = secondDir === 'north' ? output.north() : output.south();
      if (isSecondWing) {
        const isReturnBack = firstDir === secondDir;
        if (call === 'swap') {
          if (isReturnBack) return output.superchain2aSwapMidBack({
            dir: finalDir
          });
          return output.superchain2aSwapMidGo({
            dir: finalDir
          });
        }
        if (isReturnBack) return output.superchain2aStayMidBack({
          dir: finalDir
        });
        return output.superchain2aStayMidGo({
          dir: finalDir
        });
      }

      // Third wing call (when at final destination).
      const isProtean = secondMech === 'protean';
      if (call === 'swap') {
        if (isProtean) return output.superchain2aSwapProtean({
          dir: finalDir
        });
        return output.superchain2aSwapPartners({
          dir: finalDir
        });
      }
      if (isProtean) return output.superchain2aStayProtean({
        dir: finalDir
      });
      return output.superchain2aStayPartners({
        dir: finalDir
      });
    },
    outputStrings: {
      swap: {
        en: 'Swap',
        de: 'Wechseln',
        fr: 'Swap',
        ja: '横へ',
        cn: '穿',
        ko: '이동'
      },
      stay: {
        en: 'Stay',
        de: 'bleib Stehen',
        fr: 'Restez',
        ja: '止まる',
        cn: '停',
        ko: '가만히'
      },
      superchain2aSwapMidBack: {
        en: 'Swap + Mid => Back ${dir}',
        de: 'Wechseln + Mitte => Zurück nach ${dir}',
        fr: 'Swap + Milieu => Retour vers ${dir}',
        ja: '真ん中 => また${dir} (横へ)',
        cn: '穿 + 去中间 => 回到 ${dir}',
        ko: '이동 + 가운데 => 다시 ${dir}'
      },
      superchain2aSwapMidGo: {
        en: 'Swap + Mid => Go ${dir}',
        de: 'Wechseln + Mitte => Geh nach ${dir}',
        fr: 'Swap + Milieu => Allez ${dir}',
        ja: '真ん中 => ${dir}前進 (横へ)',
        cn: '穿 + 去中间 => 去 ${dir}',
        ko: '이동 + 가운데 => ${dir}으로'
      },
      superchain2aStayMidBack: {
        en: 'Stay + Mid => Back ${dir}',
        de: 'Bleib stehen + Mitte => Zurück nach ${dir}',
        fr: 'Restez + Milieu => Retour vers ${dir}',
        ja: '真ん中 => また${dir} (止まる)',
        cn: '停 + 去中间 => 回到 ${dir}',
        ko: '가만히 + 가운데 => 다시 ${dir}'
      },
      superchain2aStayMidGo: {
        en: 'Stay + Mid => Go ${dir}',
        de: 'Bleib stehen + Mitte => Geh nach ${dir}',
        fr: 'Restez + Milieu => Aller vers ${dir}',
        ja: '真ん中 => ${dir}前進 (止まる)',
        cn: '停 + 去中间 => 去 ${dir}',
        ko: '가만히 + 가운데 => ${dir}으로'
      },
      superchain2aSwapProtean: {
        en: 'Swap => Protean + ${dir}',
        de: 'Wechseln => Himmelsrichtungen + ${dir}',
        fr: 'Swap => Position + ${dir}',
        ja: '基本散会 + ${dir} (横へ)',
        cn: '穿 => 八方分散 + ${dir}',
        ko: '이동 => 8방향 산개 + ${dir}'
      },
      superchain2aStayProtean: {
        en: 'Stay => Protean + ${dir}',
        de: 'Bleib stehen => Himmelsrichtungen + ${dir}',
        fr: 'Restez => Position + ${dir}',
        ja: '基本散会 + ${dir} (止まる)',
        cn: '停 => 八方分散 + ${dir}',
        ko: '가만히 => 8방향 산개 + ${dir}'
      },
      superchain2aSwapPartners: {
        en: 'Swap => Partners + ${dir}',
        de: 'Wechseln => Partner + ${dir}',
        fr: 'Swap => Partenaires + ${dir}',
        ja: 'ペア + ${dir} (横へ)',
        cn: '穿 => 双人分摊 + ${dir}',
        ko: '이동 => 파트너 + ${dir}'
      },
      superchain2aStayPartners: {
        en: 'Stay => Partners + ${dir}',
        de: 'Bleib stehen => Partner + ${dir}',
        fr: 'Restez => Partenaires + ${dir}',
        ja: 'ペア + ${dir} (止まる)',
        cn: '停 => 双人分摊 + ${dir}',
        ko: '가만히 => 파트너 + ${dir}'
      },
      north: outputs/* default.north */.Z.north,
      south: outputs/* default.south */.Z.south
    }
  }, {
    id: 'P12S Wing Followup Third Wing Superchain IIA',
    type: 'Ability',
    netRegex: {
      id: ['82E5', '82E6', '82EB', '82EC'],
      source: 'Athena',
      capture: false
    },
    condition: data => data.phase === 'superchain2a',
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      const secondMech = data.superchain2aSecondMech;
      if (secondMech === undefined) return;

      // No direction needed here, because if you're not already here you're not going to make it.
      if (secondMech === 'protean') return output.protean();
      return output.partners();
    },
    outputStrings: {
      protean: {
        en: 'Protean',
        de: 'Himmelsrichtungen',
        fr: 'Positions',
        ja: '基本散会',
        cn: '八方分散',
        ko: '8방향 산개'
      },
      partners: {
        en: 'Partners',
        de: 'Partner',
        fr: 'Partenaires',
        ja: 'ペア',
        cn: '双人分摊',
        ko: '파트너'
      }
    }
  }, {
    id: 'P12S Engravement of Souls Tracker',
    type: 'Ability',
    netRegex: {
      id: '8305',
      source: 'Athena',
      capture: false
    },
    run: data => ++data.engravementCounter
  },
  // In Engravement 1 (Paradeigma 2), 2 players receive lightTower and 2 players receive darkTower,
  // 2 players need to guide the light beam and 2 players need to guide the dark beam.
  // The operator of the beam extends the beam directly from the outside. The beam is attenuated until the jagged line disappears.
  // The people in the tower find the people who have the opposite attribute to the debuff and put them in four places.
  // At NE NW SE SW as a # shape. The position of outside Anthropos is fixed by two situation.
  // {[97, 75], [125, 97], [103, 125], [75, 103]} and {[103, 75], [125, 103], [97, 125], [75, 97]}. The Anthropos will cast
  // 'Searing Radiance' for light beam and 'Shadowsear' for dark beam. We use those as a trigger for Tower players place
  // the Tower.
  // When debuffs expire and towers drop, their debuff changes to lightTilt or darkTilt (same as tower color).
  // At the same time the towers drop, the 4 tethered players receive lightTilt or darkTilt depending on their tether color.
  //
  {
    id: 'P12S Engravement 1 Tether Tracker',
    type: 'Tether',
    netRegex: {
      id: Object.keys(anthroposTetherMap),
      source: 'Anthropos'
    },
    run: (data, matches) => {
      const tetherType = anthroposTetherMap[matches.id];
      if (tetherType === undefined) return;
      data.engravement1TetherPlayers[matches.sourceId] = tetherType;
      data.engravement1TetherIds.push(parseInt(matches.sourceId, 16));
    }
  }, {
    id: 'P12S Engravement 1 Beam',
    type: 'StartsUsing',
    netRegex: {
      id: Object.keys(tetherAbilityToTowerMap),
      source: 'Anthropos'
    },
    condition: data => data.engravementCounter === 1,
    alertText: (data, matches, output) => {
      if (data.me === matches.target) {
        if (matches.id === '82F1') return output.lightBeam();
        return output.darkBeam();
      }
    },
    outputStrings: {
      lightBeam: {
        en: 'light beam',
        de: 'Heller Laser',
        fr: 'Rayon de lumière',
        ja: 'ひかりビーム',
        cn: '引导光激光',
        ko: '빛 선'
      },
      darkBeam: {
        en: 'dark beam',
        de: 'Dunkler Laser',
        fr: 'Rayon sombre',
        ja: 'やみビーム',
        cn: '引导暗激光',
        ko: '어둠 선'
      }
    }
  }, {
    id: 'P12S Engravement 1 Tower Drop',
    type: 'GainsEffect',
    netRegex: {
      effectId: engravementTowerIds
    },
    condition: data => data.engravementCounter === 1,
    durationSeconds: (_data, matches) => parseFloat(matches.duration),
    promise: async data => {
      data.combatantData = [];
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: data.engravement1TetherIds
      })).combatants;
    },
    alertText: (data, matches, output) => {
      data.engravement1Towers.push(matches.target);
      if (data.me !== matches.target) return;

      // if Only notify tower color
      if (data.triggerSetConfig.engravement1DropTower === 'tower') {
        if (matches.effectId === engravementIdMap.lightTower) return output.lightTower();
        return output.darkTower();
      }
      const locations = ['NE', 'SW', 'SE', 'NW'];
      const towerList = [];
      const towerStrategy = data.triggerSetConfig.engravement1DropTower;
      for (const combatant of data.combatantData) {
        const x = combatant.PosX;
        const y = combatant.PosY;
        const combatantId = combatant.ID;
        if (combatantId === undefined) return;
        const tempColor = data.engravement1TetherPlayers[combatantId.toString(16).toUpperCase()];
        const color = tempColor === 'light' ? 'dark' : 'light';
        const isCorrectColor = color === 'light' && matches.effectId === engravementIdMap.lightTower || color === 'dark' && matches.effectId === engravementIdMap.darkTower;
        if (!isCorrectColor) continue;
        if (towerStrategy === 'quadrant' || towerStrategy === 'tetherbase') {
          if (x < 80 && y < 100) {
            // WNW: x = 75 && y = 97
            towerList.push({
              location: 'NE',
              clone: 'WNW'
            });
          } else if (x < 100 && y < 80) {
            // NNW: x = 97 && y = 75
            towerList.push({
              location: 'SW',
              clone: 'NNW'
            });
          } else if (x > 100 && y < 80) {
            // NNE: x = 103 && y = 75
            towerList.push({
              location: 'SE',
              clone: 'NNE'
            });
          } else if (x > 120 && y < 100) {
            // ENE: x = 125 && y = 97
            towerList.push({
              location: 'NW',
              clone: 'ENE'
            });
          } else if (x > 120 && y > 100) {
            // ESE: x = 125 && y = 103
            towerList.push({
              location: 'SW',
              clone: 'ESE'
            });
          } else if (x > 100 && y > 120) {
            // SSE: x = 103 && y = 125
            towerList.push({
              location: 'NE',
              clone: 'SSE'
            });
          } else if (x < 100 && y > 120) {
            // SSW: x = 97 && y = 125
            towerList.push({
              location: 'NW',
              clone: 'SSW'
            });
          } else if (x < 80 && y > 100) {
            // WSW: x = 75 && y = 103
            towerList.push({
              location: 'SE',
              clone: 'WSW'
            });
          }
        } else if (data.triggerSetConfig.engravement1DropTower === 'clockwise') {
          // Tether stretches across and tower is clockwise; e.g. N add stretches S, and tower is SW.
          if (x < 80 && y < 100) {
            // WNW: x = 75 && y = 97
            towerList.push({
              location: 'SE',
              clone: 'WNW'
            });
          } else if (x < 100 && y < 80) {
            // NNW: x = 97 && y = 75
            towerList.push({
              location: 'SW',
              clone: 'NNW'
            });
          } else if (x > 100 && y < 80) {
            // NNE: x = 103 && y = 75
            towerList.push({
              location: 'SW',
              clone: 'NNE'
            });
          } else if (x > 120 && y < 100) {
            // ENE: x = 125 && y = 97
            towerList.push({
              location: 'NW',
              clone: 'ENE'
            });
          } else if (x > 120 && y > 100) {
            // ESE: x = 125 && y = 103
            towerList.push({
              location: 'NW',
              clone: 'ESE'
            });
          } else if (x > 100 && y > 120) {
            // SSE: x = 103 && y = 125
            towerList.push({
              location: 'NE',
              clone: 'SSE'
            });
          } else if (x < 100 && y > 120) {
            // SSW: x = 97 && y = 125
            towerList.push({
              location: 'NE',
              clone: 'SSW'
            });
          } else if (x < 80 && y > 100) {
            // WSW: x = 75 && y = 103
            towerList.push({
              location: 'SE',
              clone: 'WSW'
            });
          }
        }
      }

      // Now use strategy and towerList (which only contains the correct color for the player)
      // to call out two spots or sort down to one spot.
      const outputMap = {
        NW: output.northwest(),
        NE: output.northeast(),
        SE: output.southeast(),
        SW: output.southwest()
      };
      const [tower0, tower1] = towerList;
      if (tower0 === undefined || tower1 === undefined) return;
      if (towerStrategy === 'clockwise' || towerStrategy === 'quadrant') {
        if (matches.effectId === engravementIdMap.lightTower) {
          return output.lightTowerSide({
            pos1: outputMap[tower0.location],
            pos2: outputMap[tower1.location]
          });
        }
        return output.darkTowerSide({
          pos1: outputMap[tower0.location],
          pos2: outputMap[tower1.location]
        });
      } else if (towerStrategy === 'tetherbase') {
        let towerResult;

        // Do the sort by role
        if (data.role === 'dps') {
          if (tower0.clone === 'WSW' || tower0.clone === 'WNW') {
            towerResult = tower0.location;
          } else if (tower1.clone === 'WSW' || tower1.clone === 'WNW') {
            towerResult = tower1.location;
          } else if (tower0.clone === 'SSW' || tower0.clone === 'SSE') {
            towerResult = tower0.location;
          } else if (tower1.clone === 'SSW' || tower1.clone === 'SSE') {
            towerResult = tower1.location;
          } else if (tower0.clone === 'ENE' || tower0.clone === 'ESE') {
            towerResult = tower0.location;
          } else if (tower1.clone === 'ENE' || tower1.clone === 'ESE') {
            towerResult = tower1.location;
          }
        } else {
          if (tower0.clone === 'NNW' || tower0.clone === 'NNE') {
            towerResult = tower0.location;
          } else if (tower1.clone === 'NNW' || tower1.clone === 'NNE') {
            towerResult = tower1.location;
          } else if (tower0.clone === 'ENE' || tower0.clone === 'ESE') {
            towerResult = tower0.location;
          } else if (tower1.clone === 'ENE' || tower1.clone === 'ESE') {
            towerResult = tower1.location;
          } else if (tower0.clone === 'SSW' || tower0.clone === 'SSE') {
            towerResult = tower0.location;
          } else if (tower1.clone === 'SSW' || tower1.clone === 'SSE') {
            towerResult = tower1.location;
          }
        }
        if (towerResult === undefined) return;
        if (matches.effectId === engravementIdMap.lightTower) {
          return output.lightTowerOneSide({
            pos1: outputMap[towerResult]
          });
        }
        return output.darkTowerOneSide({
          pos1: outputMap[towerResult]
        });
      }
    },
    outputStrings: {
      lightTowerSide: {
        en: 'Drop light tower ${pos1}/${pos2}',
        de: 'Heller Turm ${pos1}/${pos2} ablegen',
        fr: 'Déposez la tour de lumière ${pos1}/${pos2}',
        ja: 'ひかり設置 ${pos1}/${pos2}',
        cn: '去 ${pos1}/${pos2} 放光塔',
        ko: '빛 기둥 ${pos1}/${pos2}에 놓기'
      },
      darkTowerSide: {
        en: 'Drop dark tower at ${pos1}/${pos2}',
        de: 'Dunkler Turm ${pos1}/${pos2} ablegen',
        fr: 'Déposez la tour sombre ${pos1}/${pos2}',
        ja: 'やみ設置 ${pos1}/${pos2}',
        cn: '去 ${pos1}/${pos2} 放暗塔',
        ko: '어둠 기둥 ${pos1}/${pos2}에 놓기'
      },
      lightTowerOneSide: {
        en: 'Drop light tower ${pos1}',
        de: 'Heller Turm ${pos1} ablegen',
        fr: 'Déposez la tour de lumière ${pos1}',
        ja: 'ひかり設置 ${pos1}',
        cn: '去 ${pos1} 放光塔',
        ko: '빛 기둥 ${pos1}에 놓기'
      },
      darkTowerOneSide: {
        en: 'Drop dark tower at ${pos1}',
        de: 'Dunkler Turm ${pos1} ablegen',
        fr: 'Déposez la tour sombre ${pos1}',
        ja: 'やみ設置 ${pos1}',
        cn: '去 ${pos1} 放暗塔',
        ko: '어둠 기둥 ${pos1}에 놓기'
      },
      lightTower: {
        en: 'Drop light tower',
        de: 'Heller Turm ablegen',
        fr: 'Déposez la tour de lumière',
        ja: 'ひかり設置',
        cn: '放光塔',
        ko: '빛 기둥 놓기'
      },
      darkTower: {
        en: 'Drop dark tower',
        de: 'Dunkler Turm ablegen',
        fr: 'Déposez la tour sombre',
        ja: 'やみ設置',
        cn: '放暗塔',
        ko: '어둠 기둥 놓기'
      },
      northeast: outputs/* default.dirNE */.Z.dirNE,
      northwest: outputs/* default.dirNW */.Z.dirNW,
      southeast: outputs/* default.dirSE */.Z.dirSE,
      southwest: outputs/* default.dirSW */.Z.dirSW
    }
  }, {
    id: 'P12S Engravement 1 Tower Soak',
    type: 'GainsEffect',
    netRegex: {
      effectId: engravementTiltIds
    },
    condition: (data, matches) => data.engravementCounter === 1 && data.me === matches.target,
    suppressSeconds: 5,
    // avoid second (incorrect) alert when debuff switches from soaking tower
    alertText: (data, matches, output) => {
      if (!data.engravement1Towers.includes(data.me)) {
        // Did not drop a tower, so needs to soak one.
        if (matches.effectId === engravementIdMap.lightTilt) return output.lightTilt();
        return output.darkTilt();
      }
    },
    outputStrings: {
      lightTilt: {
        en: 'Soak dark tower',
        de: 'Dunklen Turm nehmen',
        fr: 'Prenez la tour sombre',
        ja: 'やみ塔踏み',
        cn: '踩暗塔',
        ko: '어둠 기둥 들어가기'
      },
      darkTilt: {
        en: 'Soak light tower',
        de: 'Hellen Turm nehmen',
        fr: 'Prenez la tour de lumière',
        ja: 'ひかり塔踏み',
        cn: '踩光塔',
        ko: '빛 기둥 들어가기'
      }
    }
  },
  // In Engravement 2 (Superchain 1), all supports or DPS will receive lightTilt and darkTilt (2 each).
  // All 4 also receive Heavensflame Soul.
  // The other role group will receive lightTower, darkTower, lightBeam, and darkBeam.
  // To resolve the Beams during the 2nd orb, lightBeam needs to stack with darkTower and both darkTilts, and vice versa.
  // After the 3rd orb, lightTower and darkTower will drop their towers, and  darkBeam and lightBeam (respectively) will soak them.
  // The four Heavensflame players all simultaneously need to spread to drop their AoEs.
  // Debuffs do change based on mechanic resolution, which can complicate things:
  // - When a lightTilt player soaks a dark beam, their debuff will change to darkTilt, and vice versa.
  // - Once the beams detonate, the lightBeam debuff disappears and is replaced with lightTilt (same with dark).
  // So only use the initial debuff to resolve the mechanic, and use a long suppress to avoid incorrect later alerts.
  {
    id: 'P12S Engravement 2 Debuff',
    type: 'GainsEffect',
    netRegex: {
      effectId: [...engravementBeamIds, ...engravementTowerIds, ...engravementTiltIds]
    },
    condition: (data, matches) => data.engravementCounter === 2 && data.me === matches.target,
    suppressSeconds: 30,
    run: (data, matches) => data.engravement2MyLabel = engravementLabelMap[matches.effectId]
  }, {
    id: 'P12S Engravement 2 Heavensflame Soul Early',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'DFA'
    },
    condition: (data, matches) => data.engravementCounter === 2 && data.me === matches.target,
    delaySeconds: 6.5,
    // display a reminder as the player is moving into the second orb stack groups
    infoText: (_data, _matches, output) => output.spreadLater(),
    outputStrings: {
      spreadLater: {
        en: '(spread later)',
        de: '(später verteilen)',
        fr: '(Écartez-vous plus tard)',
        cn: '（稍后分散）',
        ko: '(나중에 산개)'
      }
    }
  },
  // darkTower/lightTower are 20s, but lightBeam/darkBeam are shorter and swap to lightTilt/darkTilt before the mechanic resolves.
  // So use a fixed delay rather than one based on effect duration.
  // TODO: Add additional logic/different outputs if oopsies happen?  (E.g. soak player hit by tower drop -> debuff change, backup soak by spread player, etc.)
  // TODO: Combine this with the second part (in/out) of Superchain I Third Mechanic?
  {
    id: 'P12S Engravement 2 Tower Drop/Soak Reminder',
    type: 'GainsEffect',
    netRegex: {
      effectId: [...engravementTowerIds, ...engravementBeamIds]
    },
    condition: (data, matches) => data.engravementCounter === 2 && data.me === matches.target,
    delaySeconds: 16,
    alertText: (_data, matches, output) => {
      const engraveLabel = engravementLabelMap[matches.effectId];
      if (engraveLabel === undefined) return;
      return output[engraveLabel]();
    },
    outputStrings: {
      lightBeam: {
        en: 'Soak Dark Tower',
        de: 'Dunklen Turm nehmen',
        fr: 'Prenez la tour sombre',
        ja: 'やみ塔踏み (右)',
        cn: '踩暗塔',
        ko: '어둠 기둥 들어가기'
      },
      darkBeam: {
        en: 'Soak Light Tower',
        de: 'Hellen Turm nehmen',
        fr: 'Prenez la tour de lumière',
        ja: 'ひかり塔踏み (左)',
        cn: '踩光塔',
        ko: '빛 기둥 들어가기'
      },
      lightTower: {
        en: 'Drop Light Tower',
        de: 'Hellen Turm ablegen',
        fr: 'Déposez la tour de lumière',
        ja: 'ひかり塔設置 (左)',
        cn: '放光塔',
        ko: '빛 기둥 놓기'
      },
      darkTower: {
        en: 'Drop Dark Tower',
        de: 'Dunklen Turm ablegen',
        fr: 'Déposez la tour sombre',
        ja: 'やみ塔設置 (右)',
        cn: '放暗塔',
        ko: '어둠 기둥 놓기'
      }
    }
  }, {
    id: 'P12S Engravement 2 Heavensflame Soul',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'DFA'
    },
    condition: (data, matches) => data.engravementCounter === 2 && data.me === matches.target,
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 4,
    response: responses/* Responses.spread */.n3.spread('alert')
  },
  // In Engravement 3 (Paradeigma 3), 2 support players will both receive either lightTower or darkTower.
  // The other 2 support players receive a '+'/Cross (DFF) or 'x'/Saltire (E00) debuff.
  // Because of platform separation during the mechanic, the '+' and 'x' players must soak the far north/south towers,
  // while the lightTower or darkTower players must soak the middle towers (so they can then drop their towers for DPS to soak).
  // All DPS receive tethers (2 light, 2 dark), and they receive corresponding lightTilt/darkTilt when tethers resolve.
  // If the support players receive lightTower, the darkTilt DPS must soak those towers, or vice versa.
  // While the light & dark towers are being soaked, the '+' and 'x' supports and  other 2 DPS must bait the adds' line cleaves.
  {
    id: 'P12S Engravement 3 Theos Initial',
    type: 'GainsEffect',
    netRegex: {
      effectId: engravement3TheosSoulIds
    },
    condition: (data, matches) => data.engravementCounter === 3 && data.me === matches.target,
    alertText: (_data, matches, output) => {
      const engraveLabel = engravementLabelMap[matches.effectId];
      if (engraveLabel === undefined) return;
      return output[engraveLabel]();
    },
    outputStrings: {
      crossMarked: {
        en: '\'+\' AoE on You',
        de: '\'+\' AoE auf DIR',
        fr: 'AoE \'+\' sur VOUS',
        ja: '自分に\'+\'',
        cn: '十 点名',
        ko: '\'+\' 장판 대상자'
      },
      xMarked: {
        en: '\'x\' AoE on You',
        de: '\'x\' AoE auf DIR',
        fr: 'AoE \'x\' sur VOUS',
        ja: '自分に\'x\'',
        cn: '\'x\' 点名',
        ko: '\'x\' 장판 대상자'
      }
    }
  }, {
    id: 'P12S Engravement 3 Theos Drop AoE',
    type: 'GainsEffect',
    netRegex: {
      effectId: engravement3TheosSoulIds
    },
    condition: (data, matches) => data.engravementCounter === 3 && data.me === matches.target,
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 4,
    alertText: (_data, matches, output) => {
      const engraveLabel = engravementLabelMap[matches.effectId];
      if (engraveLabel === undefined) return;
      return output[engraveLabel]();
    },
    outputStrings: {
      crossMarked: {
        en: 'Drop \'+\' AoE',
        de: '\'+\' AoE ablegen',
        fr: 'Déposez l\'AoE \'+\'',
        ja: '隅へ\'+\'設置',
        cn: '放置 十 点名',
        ko: '\'+\' 장판 놓기'
      },
      xMarked: {
        en: 'Drop \'x\' AoE',
        de: '\'x\' AoE ablegen',
        fr: 'Déposez l\'AoE \'x\'',
        ja: '中央へ\'x\'設置',
        cn: '放置 \'x\' 点名',
        ko: '\'x\' 장판 놓기'
      }
    }
  }, {
    id: 'P12S Engravement 3 Theos Bait Adds',
    type: 'GainsEffect',
    netRegex: {
      effectId: engravement3TheosSoulIds
    },
    condition: (data, matches) => data.engravementCounter === 3 && data.me === matches.target,
    delaySeconds: (_data, matches) => parseFloat(matches.duration),
    alertText: (_data, _matches, output) => output.baitCleave(),
    outputStrings: {
      baitCleave: {
        en: 'Bait line cleave',
        de: 'Linien AoEs ködern',
        fr: 'Attirez le cleave en ligne',
        ja: '外からのレーザー誘導',
        cn: '引导射线',
        ko: '레이저 유도'
      }
    }
  }, {
    id: 'P12S Engravement 3 Towers Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: engravementTowerIds
    },
    condition: data => data.engravementCounter === 3,
    run: (data, matches) => {
      data.engravement3TowerPlayers.push(matches.target);
      data.engravement3TowerType = matches.effectId === engravementIdMap.lightTower ? 'lightTower' : 'darkTower';
    }
  }, {
    id: 'P12S Engravement 3 Paradeigma Adds Collect',
    type: 'StartsUsing',
    netRegex: {
      id: ['82F1', '82F2'],
      source: 'Anthropos'
    },
    condition: data => data.engravementCounter === 3,
    run: (data, matches) => {
      // 82F1 = Searing Radiance (used on light tethers)
      // 82F2 = Shadowsear (used on dark tethers)
      // If the Anthroposes (Anthropi?) casting 82F1 are east, e.g., the tethered players will be west when the mechanic resolves.
      // lightTower/darkTower is applied ~1.1s before these abilities.
      const tetherPlayerSide = parseFloat(matches.x) > 100 ? 'west' : 'east';
      if (tetherAbilityToTowerMap[matches.id] === data.engravement3TowerType) data.engravement3TethersSide = tetherPlayerSide;
    }
  }, {
    id: 'P12S Engravement 3 Towers Initial',
    type: 'GainsEffect',
    netRegex: {
      effectId: engravementTowerIds
    },
    condition: (data, matches) => data.engravementCounter === 3 && data.me === matches.target,
    delaySeconds: 0.3,
    alertText: (data, _matches, output) => {
      let towerColor = output.unknown();
      if (data.engravement3TowerType !== undefined) towerColor = data.engravement3TowerType === 'lightTower' ? output.light() : output.dark();
      const partner = data.party.member(data.engravement3TowerPlayers.find(name => name !== data.me)) ?? output.unknown();
      return output.towerOnYou({
        color: towerColor,
        partner: partner
      });
    },
    outputStrings: {
      towerOnYou: {
        en: '${color} Tower on You (w/ ${partner})',
        de: '${color} Turm auf Dir (mit ${partner})',
        fr: 'Tour ${color} sur vous (avec ${partner})',
        ja: '自分に${color}塔 (${partner})',
        cn: '${color} 塔点名 (+ ${partner})',
        ko: '${color} 기둥 대상자 (+ ${partner})'
      },
      light: {
        en: 'Light',
        de: 'Heller',
        fr: 'de lumière',
        ja: 'ひかり',
        cn: '光',
        ko: '빛'
      },
      dark: {
        en: 'Dark',
        de: 'Dunkler',
        fr: 'sombre',
        ja: 'やみ',
        cn: '暗',
        ko: '어둠'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'P12S Engravement 3 Paradeigma Tethers Collect',
    type: 'Tether',
    // Because tethers can spawn unstretched or already satisfied, we need to catch all 4 states
    netRegex: {
      id: Object.keys(anthroposTetherMap),
      source: 'Anthropos'
    },
    condition: data => data.engravementCounter === 3,
    run: (data, matches) => {
      const tetherType = anthroposTetherMap[matches.id];
      if (tetherType === undefined) return;
      data.engravement3TetherPlayers[matches.target] = tetherType;
    }
  }, {
    id: 'P12S Engravement 3 Paradeigma Early Tower Color',
    type: 'Tether',
    // Because tethers can spawn unstretched or already satisfied, we need to trigger on all 4 states
    netRegex: {
      id: Object.keys(anthroposTetherMap),
      source: 'Anthropos'
    },
    condition: (data, matches) => data.engravementCounter === 3 && data.me === matches.target,
    suppressSeconds: 10,
    infoText: (data, _matches, output) => {
      let towerColor = output.unknown();
      if (data.engravement3TowerType !== undefined) towerColor = data.engravement3TowerType === 'lightTower' ? output.light() : output.dark();
      return output.towersLater({
        color: towerColor
      });
    },
    outputStrings: {
      towersLater: {
        en: '${color} towers (later)',
        de: '${color} Türme (später)',
        fr: 'Tours ${color} (plus tard)',
        ja: '塔: ${color}',
        cn: '稍后 ${color} 塔',
        ko: '${color} 기둥 (나중에)'
      },
      light: {
        en: 'Light',
        de: 'Helle',
        fr: 'de lumière',
        ja: 'ひかり',
        cn: '光',
        ko: '빛'
      },
      dark: {
        en: 'Dark',
        de: 'Dunkle',
        fr: 'sombre',
        ja: 'やみ',
        cn: '暗',
        ko: '어둠'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  },
  // If player starts with darkTower/lightTower, they will start east or west to soak the inside towers.
  // Use their relative position at the time 8312 (Shock) is used (the initial tower soak) to determine where they should drop their tower.
  {
    id: 'P12S Engravement 3 Towers Drop Location',
    type: 'Ability',
    netRegex: {
      id: '8312',
      source: 'Athena'
    },
    condition: (data, matches) => data.engravementCounter === 3 && data.me === matches.target && data.engravement3TowerPlayers.includes(data.me),
    durationSeconds: 6,
    alertText: (data, matches, output) => {
      let towerColor = output.unknown();
      if (data.engravement3TowerType !== undefined) towerColor = data.engravement3TowerType === 'lightTower' ? output.light() : output.dark();
      if (data.engravement3TethersSide === undefined) return output.dropTower({
        color: towerColor,
        spot: output.unknown()
      });
      const mySide = parseFloat(matches.x) > 100 ? 'east' : 'west';
      const towerSpot = mySide === data.engravement3TethersSide ? output.corner() : output.platform();
      return output.dropTower({
        color: towerColor,
        spot: towerSpot
      });
    },
    outputStrings: {
      dropTower: {
        en: 'Drop ${color} Tower (${spot})',
        de: '${color} Turm (${spot})',
        fr: 'Déposez la tour ${color} (${spot})',
        ja: '${spot}に${color}塔設置',
        cn: '在 ${spot} 放 ${color} 塔',
        ko: '${color} 기둥 놓기 (${spot})'
      },
      light: {
        en: 'Light',
        de: 'Heller',
        fr: 'de lumière',
        ja: 'ひかり',
        cn: '光',
        ko: '빛'
      },
      dark: {
        en: 'Dark',
        de: 'Dunkler',
        fr: 'sombre',
        ja: 'やみ',
        cn: '暗',
        ko: '어둠'
      },
      platform: {
        en: 'Platform',
        de: 'Platform',
        fr: 'Plateforme',
        ja: 'マス内部',
        cn: '平台内',
        ko: '플랫폼 내부'
      },
      corner: {
        en: 'Inside Corner',
        de: 'In der Ecke',
        fr: 'Dans le coin',
        ja: '真ん中のコーナー',
        cn: '平台交叉处',
        ko: '플랫폼 교차지점'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'P12S Engravement 3 Soak Tower/Bait Adds',
    type: 'GainsEffect',
    netRegex: {
      effectId: engravementTiltIds
    },
    condition: (data, matches) => {
      if (!data.isDoorBoss) return false;
      if (data.engravementCounter === 3 && data.me === matches.target) return true;
      return false;
    },
    suppressSeconds: 15,
    // avoid second (incorrect) alert when debuff switches from soaking tower
    alertText: (data, matches, output) => {
      // lightTower/darkTower support players receive lightTilt/darkTilt once dropping their tower
      // so exclude them from receiving this alert
      if (data.engravement3TowerPlayers.includes(data.me)) return;
      const soakMap = {
        lightTower: 'darkTilt',
        darkTower: 'lightTilt'
      };
      const myEffect = engravementLabelMap[matches.effectId];
      if (myEffect === undefined || data.engravement3TowerType === undefined) return;
      const soakTiltType = soakMap[data.engravement3TowerType];
      const towerColor = data.engravement3TowerType === 'lightTower' ? output.light() : output.dark();
      if (myEffect === soakTiltType) return output.soakTower({
        color: towerColor
      });
      return output.baitCleaves();
    },
    outputStrings: {
      soakTower: {
        en: 'Soak ${color} Tower',
        de: '${color} Turm nehmen',
        fr: 'Prenez la tour ${color}',
        ja: '${color}塔踏み',
        cn: '踩 ${color} 塔',
        ko: '${color} 기둥 들어가기'
      },
      baitCleaves: {
        en: 'Bait line cleave',
        de: 'Linien AoE ködern',
        fr: 'Attirez le cleave en ligne',
        ja: 'レーザー誘導',
        cn: '引导射线',
        ko: '레이저 유도'
      },
      light: {
        en: 'Light',
        de: 'Hellen',
        fr: 'de lumière',
        ja: 'ひかり',
        cn: '光',
        ko: '빛'
      },
      dark: {
        en: 'Dark',
        de: 'Dunklen',
        fr: 'sombre',
        ja: 'やみ',
        cn: '暗',
        ko: '어둠'
      }
    }
  }, {
    id: 'P12S Glaukopis First Cleave',
    type: 'StartsUsing',
    netRegex: {
      id: '82FC',
      source: 'Athena'
    },
    response: (data, matches, output) => {
      // don't use Responses.tankCleave(); we want to tell the non-targeted tank to swap
      // cactbot-builtin-response
      output.responseOutputStrings = {
        cleaveOnYou: outputs/* default.tankCleaveOnYou */.Z.tankCleaveOnYou,
        tankBusterCleaves: outputs/* default.tankBusterCleaves */.Z.tankBusterCleaves,
        cleaveSwap: outputs/* default.tankSwap */.Z.tankSwap,
        avoidTankCleaves: outputs/* default.avoidTankCleaves */.Z.avoidTankCleaves
      };
      // Multiple players can be hit by the line cleave AoE,
      // but we only care about the intended target for the Followup trigger
      data.glaukopisFirstHit = matches.target;
      if (data.me === matches.target) return {
        alertText: output.cleaveOnYou()
      };
      if (data.role === 'tank') return {
        alertText: output.cleaveSwap()
      };
      if (data.role === 'healer' || data.job === 'BLU') return {
        alertText: output.tankBusterCleaves()
      };
      return {
        infoText: output.avoidTankCleaves()
      };
    }
  },
  // Since multiple players could be hit by the 2nd cleave (whoopsie!), we need to check
  // if *any* of the targets of the 2nd cleave were the original cast target (MT) of the 1st cleave.
  // If so, we'll assume the original target is using invuln, and no need to swap after the 2nd.
  {
    id: 'P12S Glaukopis Second Cleave Collect',
    type: 'Ability',
    netRegex: {
      id: '82FD',
      source: 'Athena'
    },
    run: (data, matches) => {
      if (matches.target === data.glaukopisFirstHit) data.glaukopisSecondHitSame = true;
    }
  }, {
    id: 'P12S Glaukopis Second Cleave Swap',
    type: 'Ability',
    netRegex: {
      id: '82FD',
      source: 'Athena',
      capture: false
    },
    condition: data => data.role === 'tank' || data.job === 'BLU',
    delaySeconds: 0.1,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      if (data.me === data.glaukopisFirstHit && !data.glaukopisSecondHitSame) return output.tankSwap();
    },
    run: data => {
      delete data.glaukopisFirstHit;
      data.glaukopisSecondHitSame = false;
    },
    outputStrings: {
      tankSwap: outputs/* default.tankSwap */.Z.tankSwap
    }
  }, {
    id: 'P12S Peridialogos',
    type: 'StartsUsing',
    netRegex: {
      id: '82FF',
      source: 'Athena',
      capture: false
    },
    alertText: (data, _matches, output) => data.role === 'tank' ? output.tanksInPartyOut() : output.partyOutTanksIn(),
    outputStrings: {
      partyOutTanksIn: {
        en: 'Party Out (Tanks In)',
        de: 'Gruppe Raus (Tanks Rein)',
        fr: 'Équipe à l\'extérieur (Tanks à l\'intérieur)',
        ja: 'ボスから離れる (タンクが内側)',
        cn: '小队出 (T进)',
        ko: '본대 밖 (탱커 안)'
      },
      tanksInPartyOut: {
        en: 'Tanks In (Party Out)',
        de: 'Tanks Rein (Gruppe Raus)',
        fr: 'Tanks à l\'intérieur (Équipe à l\'extérieur',
        ja: 'ボスに足元へ (パーティーは離れる)',
        cn: 'T进 (小队出)',
        ko: '탱커 안 (본대 밖)'
      }
    }
  }, {
    id: 'P12S Apodialogos',
    type: 'StartsUsing',
    netRegex: {
      id: '82FE',
      source: 'Athena',
      capture: false
    },
    alertText: (data, _matches, output) => data.role === 'tank' ? output.tanksOutPartyIn() : output.partyInTanksOut(),
    outputStrings: {
      partyInTanksOut: {
        en: 'Party In (Tanks Out)',
        de: 'Gruppe Rein (Tanks Raus)',
        fr: 'Équipe à l\'intérieur (Tanks à l\'extérieur)',
        ja: 'ボスの足元へ (タンクは離れる)',
        cn: '小队进 (T出)',
        ko: '본대 안 (탱커 밖)'
      },
      tanksOutPartyIn: {
        en: 'Tanks Out (Party In)',
        de: 'Tanks Raus (Gruppe Rein)',
        fr: 'Tanks à l\'extérieur (Équipe à l\'intérieur',
        ja: 'ボスからはなれる (パーティーが内側)',
        cn: 'T出 (小队进)',
        ko: '탱커 밖 (본대 안)'
      }
    }
  }, {
    id: 'P12S Limit Cut',
    type: 'HeadMarker',
    netRegex: {},
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 20,
    alertText: (data, matches, output) => {
      const id = p12s_getHeadmarkerId(data, matches);
      if (!p12s_limitCutIds.includes(id)) return;
      const num = limitCutMap[id];
      if (num === undefined) return;
      data.limitCutNumber = num;
      return output.text({
        num: num
      });
    },
    outputStrings: {
      text: {
        en: '${num}',
        de: '${num}',
        fr: '${num}',
        ja: '${num}番目',
        cn: '${num}',
        ko: '${num}'
      }
    }
  }, {
    id: 'P12S Limit Cut Combatant Tracker',
    type: 'Ability',
    netRegex: {
      id: '82F3',
      source: 'Athena',
      capture: false
    },
    promise: async data => {
      const actorData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants'
      });
      if (actorData === null) {
        console.error(`LC Combatant Tracker: null data`);
        return;
      }
      const combatants = actorData.combatants.filter(combatant => {
        const distX = Math.abs(100 - combatant.PosX);
        const distY = Math.abs(100 - combatant.PosY);
        const distance = Math.hypot(distX, distY);
        // Only "Anthropos" (12378) combatants at roughly the correct distance (roughly 9.89y intercard/10y card away from middle)
        return combatant.BNpcNameID === 12378 && Math.abs(distance - 10) < 0.25;
      });
      if (combatants.length !== 8) {
        console.error(`LC Combatant Tracker: expected 8, got ${combatants.length}`);
        return;
      }
      data.lcCombatants = combatants;
    }
  }, {
    id: 'P12S Limit Cut Line Bait Collector',
    type: 'CombatantMemory',
    netRegex: {
      id: '40[0-9A-F]{6}',
      pair: [{
        key: 'ModelStatus',
        value: '16384'
      }],
      capture: true
    },
    condition: (data, matches) => {
      // This happens repeatedly, so suppress future calls.
      if (data.lcWhiteFlameDelay !== undefined) return false;
      const combatant = data.lcCombatants.find(c => c.ID === parseInt(matches.id, 16));
      if (combatant === undefined) return false;
      combatant.order = data.lcCombatantsOffset;
      ++data.lcCombatantsOffset;
      return data.lcCombatantsOffset === 8;
    },
    run: data => {
      // Find the intercardinal adds that jumped, and then sort by order.
      const orderedJumps = data.lcCombatants.filter(combatant => util/* Directions.xyTo8DirNum */.N.xyTo8DirNum(combatant.PosX, combatant.PosY, 100, 100) % 2 === 1).map(combatant => combatant.order).sort((left, right) => (left ?? 0) - (right ?? 0));
      if (orderedJumps.length !== 4) {
        console.error(`LC Line Bait Collector: Incorrect count of intercardinal adds`, data.lcCombatants);
        return;
      }
      const [o1, o2, o3, o4] = orderedJumps;
      if (o1 === undefined || o2 === undefined || o3 === undefined || o4 === undefined) return;
      data.lcWhiteFlameDelay = [o1 + 1, o2 - o1, o3 - o2, o4 - o3];
    }
  }, {
    id: 'P12S Palladion White Flame Initial',
    type: 'StartsUsing',
    // 82F5 = Palladion cast
    // 8 seconds from Palladion starts casting to first White Flame damage
    // This is also an 8 second cast.
    // ~3 seconds after that for every potential White Flame
    netRegex: {
      id: '82F5',
      source: 'Athena',
      capture: false
    },
    // Don't collide with number callout.
    delaySeconds: 2,
    durationSeconds: data => {
      const delay = data.lcWhiteFlameDelay?.[0] ?? 1;
      // 8 seconds from cast start - 2 second delay already
      return 8 - 2 + 3 * (delay - 1) - 0.5;
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        baitLaser: {
          en: 'Bait (${delay})',
          de: 'Laser Ködern (${delay})',
          fr: 'Bait (${delay})',
          ja: 'レーザー誘導 (${delay})',
          // FIXME
          cn: '引导激光 (${delay})',
          ko: '레이저 유도 (${delay})'
        },
        firstWhiteFlame: {
          en: '(5 and 7 ${delay})',
          de: '(5 und 7 ködern ${delay})',
          fr: '(5 et 7 ${delay})',
          ja: '(5と7誘導 ${delay})',
          // FIXME
          cn: '(5 和 7 引导 ${delay})',
          ko: '(5, 7 레이저 ${delay})'
        },
        ...whiteFlameDelayOutputStrings
      };
      const delayMap = {
        1: output.delay1(),
        2: output.delay2(),
        3: output.delay3(),
        4: output.delay4(),
        5: output.delay5()
      };
      const delayStr = delayMap[data.lcWhiteFlameDelay?.[0] ?? 1];
      const infoText = output.firstWhiteFlame({
        delay: delayStr
      });
      if (data.limitCutNumber === 5 || data.limitCutNumber === 7) return {
        alertText: output.baitLaser({
          delay: delayStr
        }),
        infoText: infoText
      };
      return {
        infoText: infoText
      };
    }
  }, {
    id: 'P12S Palladion White Flame Followup',
    type: 'Ability',
    netRegex: {
      id: '82EF',
      source: 'Anthropos',
      capture: false
    },
    condition: data => data.phase === 'palladion',
    preRun: data => data.whiteFlameCounter++,
    durationSeconds: data => {
      const delay = data.lcWhiteFlameDelay?.[data.whiteFlameCounter] ?? 1;
      return 3 * delay - 0.5;
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        baitLaser: {
          en: 'Bait (${delay})',
          de: 'Laser Ködern (${delay})',
          fr: 'Bait (${delay})',
          ja: 'レーザー誘導 (${delay})',
          // FIXME
          cn: '引导激光 (${delay})',
          ko: '레이저 유도 (${delay})'
        },
        secondWhiteFlame: {
          en: '(6 and 8 ${delay})',
          de: '(6 und 8 ködern ${delay})',
          fr: '(6 et 8 ${delay})',
          ja: '(6と8誘導 ${delay})',
          // FIXME
          cn: '(6 和 8 引导 ${delay})',
          ko: '(6, 8 레이저 ${delay})'
        },
        thirdWhiteFlame: {
          en: '(1 and 3 ${delay})',
          de: '(1 und 3 ködern ${delay})',
          fr: '(1 et 3 ${delay})',
          ja: '(1と3誘導 ${delay})',
          // FIXME
          cn: '(1 和 3 引导 ${delay})',
          ko: '(1, 3 레이저 ${delay})'
        },
        fourthWhiteFlame: {
          en: '(2 and 4 ${delay})',
          de: '(2 und 6 ködern ${delay})',
          fr: '(2 et 4 ${delay})',
          ja: '(2と4誘導 ${delay})',
          // FIXME
          cn: '(2 和 4 引导 ${delay})',
          ko: '(2, 4 레이저 ${delay})'
        },
        ...whiteFlameDelayOutputStrings
      };
      const delayMap = {
        1: output.delay1(),
        2: output.delay2(),
        3: output.delay3(),
        4: output.delay4(),
        5: output.delay5()
      };
      const delayStr = delayMap[data.lcWhiteFlameDelay?.[data.whiteFlameCounter] ?? 1];
      const baitLaser = output.baitLaser({
        delay: delayStr
      });
      if (data.whiteFlameCounter === 1) {
        const infoText = output.secondWhiteFlame({
          delay: delayStr
        });
        if (data.limitCutNumber === 6 || data.limitCutNumber === 8) return {
          alertText: baitLaser,
          infoText: infoText
        };
        return {
          infoText: infoText
        };
      }
      if (data.whiteFlameCounter === 2) {
        const infoText = output.thirdWhiteFlame({
          delay: delayStr
        });
        if (data.limitCutNumber === 1 || data.limitCutNumber === 3) return {
          alertText: baitLaser,
          infoText: infoText
        };
        return {
          infoText: infoText
        };
      }
      if (data.whiteFlameCounter === 3) {
        const infoText = output.fourthWhiteFlame({
          delay: delayStr
        });
        if (data.limitCutNumber === 2 || data.limitCutNumber === 4) return {
          alertText: baitLaser,
          infoText: infoText
        };
        return {
          infoText: infoText
        };
      }
    }
  }, {
    id: 'P12S Superchain Theory Collect',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: superchainNpcNameId,
      npcBaseId: superchainNpcBaseIds
    },
    // Note: do not modify or clear this in any trigger but phase reset.
    run: (data, matches) => data.superchainCollect.push(matches)
  }, {
    id: 'P12S Superchain Theory I First Mechanic',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: superchainNpcNameId,
      npcBaseId: superchainNpcBaseIds,
      capture: false
    },
    condition: data => data.phase === 'superchain1' && data.superchainCollect.length === 3,
    alertText: (data, _matches, output) => {
      const ids = data.superchainCollect.slice(0, 3).map(x => x.npcBaseId).sort();
      const [destMatches] = data.superchainCollect.filter(x => x.npcBaseId === superchainNpcBaseIdMap.destination);

      // Based on id sorting (see: superchainNpcBaseIdMap), they will always be in this order.
      const [, inOut, proteanPartner] = ids;
      if (destMatches === undefined || inOut === undefined || proteanPartner === undefined) return;

      // TODO: technically this is just intercardinals and we don't need all outputs here.
      // Do we need another helper for this?
      const dirStr = util/* Directions.addedCombatantPosTo8DirOutput */.N.addedCombatantPosTo8DirOutput(destMatches, p12s_centerX, p12s_centerY);
      const dir = output[dirStr]();
      data.superchain1FirstDest = destMatches;
      if (inOut === superchainNpcBaseIdMap.in) {
        if (proteanPartner === superchainNpcBaseIdMap.protean) return output.inAndProtean({
          dir: dir
        });
        return output.inAndPartners({
          dir: dir
        });
      }
      if (proteanPartner === superchainNpcBaseIdMap.protean) return output.outAndProtean({
        dir: dir
      });
      return output.outAndPartners({
        dir: dir
      });
    },
    outputStrings: {
      inAndProtean: {
        en: 'In + Protean (${dir})',
        de: 'Rein + Himmelsrichtungen (${dir})',
        fr: 'Intérieur + Position (${dir})',
        ja: '内側へ + 基本散会 (${dir})',
        cn: '靠近 + 八方分散 (${dir})',
        ko: '안 + 8방향 산개 (${dir})'
      },
      inAndPartners: {
        en: 'In + Partners (${dir})',
        de: 'Rein + Partner (${dir})',
        fr: 'Intérieur + Partenaire (${dir})',
        ja: '内側へ + ペア (${dir})',
        cn: '靠近 + 双人分摊 (${dir})',
        ko: '안 + 파트너 (${dir})'
      },
      outAndProtean: {
        en: 'Out + Protean (${dir})',
        de: 'Raus + Himmelsrichtungen (${dir})',
        fr: 'Extérieur + Position (${dir})',
        ja: '外側へ + 基本散会 (${dir})',
        cn: '远离 + 八方分散 (${dir})',
        ko: '밖 + 8방향 산개 (${dir})'
      },
      outAndPartners: {
        en: 'Out + Partners (${dir})',
        de: 'Raus + Partner (${dir})',
        fr: 'Extérieur + Partenaire (${dir})',
        ja: '外側へ + ペア (${dir})',
        cn: '远离 + 双人分摊 (${dir})',
        ko: '밖 + 파트너 (${dir})'
      },
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  }, {
    id: 'P12S Superchain Theory I Second Mechanic',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: superchainNpcNameId,
      npcBaseId: superchainNpcBaseIds,
      capture: false
    },
    condition: data => data.phase === 'superchain1' && data.superchainCollect.length === 7,
    // TODO: should we base this off of the first coil/burst instead?
    // 7.2 seconds is the time until the second mechanic finishes, so call early.
    delaySeconds: 4.5,
    durationSeconds: 8,
    // keep active until right before 2nd orb resolves
    alertText: (data, _matches, output) => {
      // Sort ascending.
      const collect = data.superchainCollect.slice(3, 7).sort((a, b) => parseInt(a.npcBaseId) - parseInt(b.npcBaseId));
      const firstMechDest = data.superchain1FirstDest;
      if (firstMechDest === undefined) return;
      const [dest1, dest2, donut, sphere] = collect;
      if (dest1 === undefined || dest2 === undefined || donut === undefined || sphere === undefined) return;

      // TODO: it'd sure be nice if we had more info about what is tethered to what
      // as part of AddedCombatant, but for now we can heuristic our way out of this.
      const expectedDistanceSqr = 561.3101;
      const dest1Donut = Math.abs(distSqr(dest1, donut) - expectedDistanceSqr);
      const dest2Donut = Math.abs(distSqr(dest2, donut) - expectedDistanceSqr);
      const dest1Sphere = Math.abs(distSqr(dest1, sphere) - expectedDistanceSqr);
      const dest2Sphere = Math.abs(distSqr(dest2, sphere) - expectedDistanceSqr);
      let donutDest;
      // Extra checks just in case??
      if (dest1Donut < dest1Sphere && dest2Donut > dest2Sphere) donutDest = dest1;else if (dest1Donut > dest1Sphere && dest2Donut < dest2Sphere) donutDest = dest2;
      if (donutDest === undefined) return;
      const prevDir = util/* Directions.addedCombatantPosTo8Dir */.N.addedCombatantPosTo8Dir(firstMechDest, p12s_centerX, p12s_centerY);
      const thisDir = util/* Directions.addedCombatantPosTo8Dir */.N.addedCombatantPosTo8Dir(donutDest, p12s_centerX, p12s_centerY);
      const engrave = output[data.engravement2MyLabel ?? 'unknown']();
      const rotation = (thisDir - prevDir + 8) % 8;
      if (rotation === 2) return output.leftClockwise({
        engrave: engrave
      });
      if (rotation === 6) return output.rightCounterclockwise({
        engrave: engrave
      });
    },
    outputStrings: {
      // This is left and right facing the boss.
      leftClockwise: {
        en: 'Left (CW) => ${engrave}',
        de: 'Links (im Uhrzeigersinn) => ${engrave}',
        fr: 'Gauche (horaire) => ${engrave}',
        ja: '時計回り => ${engrave}',
        cn: '左左左 (顺时针) => ${engrave}',
        ko: '왼쪽 (시계방향) => ${engrave}'
      },
      rightCounterclockwise: {
        en: 'Right (CCW) => ${engrave}',
        de: 'Rechts (gegen Uhrzeigersinn) => ${engrave}',
        fr: 'Droite (Anti-horaire) => ${engrave}',
        ja: '反時計回り => ${engrave}',
        cn: '右右右 (逆时针) => ${engrave}',
        ko: '오른쪽 (반시계방향) => ${engrave}'
      },
      lightBeam: {
        en: 'Light Beam (Stack w/Dark)',
        de: 'Heller Laser (mit Dunkel sammeln)',
        fr: 'Rayon de lumière (Pack avec sombre)',
        ja: '右塔踏み',
        cn: '光激光（与暗分摊）',
        ko: '빛 레이저 (어둠 쉐어)'
      },
      darkBeam: {
        en: 'Dark Beam (Stack w/Light)',
        de: 'Dunkler Laser (mit Hell sammeln)',
        fr: 'Rayon sombre (Pack avec la lumière)',
        ja: '左塔踏み',
        cn: '暗激光（与光分摊）',
        ko: '어둠 레이저 (빛 쉐어),'
      },
      lightTower: {
        en: 'Light Tower',
        de: 'Heller Turm',
        fr: 'Tour de lumière',
        ja: '左塔設置',
        cn: '光塔点名',
        ko: '빛 기둥'
      },
      darkTower: {
        en: 'Dark Tower',
        de: 'Dunkler Turm',
        fr: 'Tour sombre',
        ja: '右塔設置',
        cn: '暗塔点名',
        ko: '어둠 기둥'
      },
      lightTilt: {
        en: 'Light Group',
        de: 'Helle Gruppe',
        fr: 'Groupe Lumière',
        ja: '左散会',
        cn: '光分摊组',
        ko: '빛 쉐어'
      },
      darkTilt: {
        en: 'Dark Group',
        de: 'Dunkle Gruppe',
        fr: 'Groupe Sombre',
        ja: '右散会',
        cn: '暗分摊组',
        ko: '어둠 쉐어'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'P12S Superchain Theory I Third Mechanic',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: superchainNpcNameId,
      npcBaseId: superchainNpcBaseIds,
      capture: false
    },
    condition: data => data.phase === 'superchain1' && data.superchainCollect.length === 10,
    // TODO: should we base this off of the first coil/burst instead?
    // 10.6 seconds is the time until the second mechanic finishes, so call early.
    delaySeconds: 9.1,
    durationSeconds: 5.5,
    alertText: (data, _matches, output) => {
      // Sort ascending.
      const collect = data.superchainCollect.slice(7, 10).sort((a, b) => parseInt(a.npcBaseId) - parseInt(b.npcBaseId));

      // Based on id sorting (see: superchainNpcBaseIdMap), they will always be in this order.
      const [dest, donut, sphere] = collect;
      if (dest === undefined || donut === undefined || sphere === undefined) return;
      const donutDistSqr = distSqr(donut, dest);
      const sphereDistSqr = distSqr(sphere, dest);
      const moveOrder = donutDistSqr > sphereDistSqr ? output.inThenOut() : output.outThenIn();
      const engrave = output[data.engravement2MyLabel ?? 'unknown']();
      return output.combined({
        move: moveOrder,
        engrave: engrave
      });
    },
    outputStrings: {
      combined: {
        en: '${move} => ${engrave}',
        de: '${move} => ${engrave}',
        fr: '${move} => ${engrave}',
        ja: '${move} => ${engrave}',
        cn: '${move} => ${engrave}',
        ko: '${move} => ${engrave}'
      },
      inThenOut: outputs/* default.inThenOut */.Z.inThenOut,
      outThenIn: outputs/* default.outThenIn */.Z.outThenIn,
      lightBeam: {
        en: 'Soak Dark Tower',
        de: 'Dunklen Turm nehmen',
        fr: 'Prenez la tour sombre',
        ja: '右塔踏み',
        cn: '踩暗塔',
        ko: '어둠 기둥 들어가기'
      },
      darkBeam: {
        en: 'Soak Light Tower',
        de: 'Hellen Turm nehmen',
        fr: 'Prenez la tour de lumière',
        ja: '左塔踏み',
        cn: '踩光塔',
        ko: '빛 기둥 들어가기'
      },
      lightTower: {
        en: 'Drop Light Tower',
        de: 'Hellen Turm ablegen',
        fr: 'Déposez la tour de lumière',
        ja: '左塔設置',
        cn: '放光塔',
        ko: '빛 기둥 놓기'
      },
      darkTower: {
        en: 'Drop Dark Tower',
        de: 'Dunklen Turm ablegen',
        fr: 'Déposez la tour sombre',
        ja: '右塔設置',
        cn: '放暗塔',
        ko: '어둠 기둥 놓기'
      },
      lightTilt: outputs/* default.spread */.Z.spread,
      darkTilt: outputs/* default.spread */.Z.spread,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'P12S Superchain Theory IIa ',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: superchainNpcNameId,
      npcBaseId: superchainNpcBaseIds,
      capture: false
    },
    condition: data => data.phase === 'superchain2a' && data.superchainCollect.length === 10,
    run: data => {
      // Sort ascending.
      const collect = data.superchainCollect.sort((a, b) => parseInt(a.npcBaseId) - parseInt(b.npcBaseId));

      // Based on id sorting (see: superchainNpcBaseIdMap), they will always be in this order.
      const [dest1, dest2, dest3,

        /* out1 */
        /* out2 */
        /* out3 */
        /* out4 */
        /* in1 */
      ,,,,, mech1, mech2] = collect;
      if (dest1 === undefined || dest2 === undefined || dest3 === undefined || mech1 === undefined || mech2 === undefined) return;

      // These are all at x = 100, y = 100 +/- 10
      const [destNorth, /* destMid */, destSouth] = [dest1, dest2, dest3].sort((a, b) => parseFloat(a.y) - parseFloat(b.y));
      if (destNorth === undefined || destSouth === undefined) return;
      const mech1NorthDist = distSqr(mech1, destNorth);
      const mech2NorthDist = distSqr(mech2, destNorth);
      const mech1SouthDist = distSqr(mech1, destSouth);
      const mech2SouthDist = distSqr(mech2, destSouth);

      // Distance between mechanic and destination determines which goes off when.
      // ~81 distance for first mechanic, ~1190 for second mechanic
      // ~440, ~480 for comparing with wrong destination.
      const firstDistance = 100;
      const secondDistance = 1000;
      let secondMech;
      let firstDir;
      let secondDir;
      if (mech1NorthDist < firstDistance || mech2NorthDist < firstDistance) firstDir = 'north';else if (mech1SouthDist < firstDistance || mech2SouthDist < firstDistance) firstDir = 'south';
      if (mech1NorthDist > secondDistance) {
        secondDir = 'north';
        secondMech = mech1;
      } else if (mech1SouthDist > secondDistance) {
        secondDir = 'south';
        secondMech = mech1;
      } else if (mech2NorthDist > secondDistance) {
        secondDir = 'north';
        secondMech = mech2;
      } else if (mech2SouthDist > secondDistance) {
        secondDir = 'south';
        secondMech = mech2;
      }
      if (secondMech === undefined || firstDir === undefined || secondDir === undefined) {
        const distances = [mech1NorthDist, mech1SouthDist, mech2NorthDist, mech2SouthDist];
        console.error(`Superchain2a: bad distances: ${JSON.stringify(distances)}`);
        return;
      }

      // To avoid trigger overload, we'll combine these calls with the wings calls.
      const isSecondMechProtean = secondMech.npcBaseId === superchainNpcBaseIdMap.protean;
      data.superchain2aFirstDir = firstDir;
      data.superchain2aSecondDir = secondDir;
      data.superchain2aSecondMech = isSecondMechProtean ? 'protean' : 'partners';
    }
  }, {
    id: 'P12S Superchain Theory IIb First Mechanic',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: superchainNpcNameId,
      npcBaseId: superchainNpcBaseIds,
      capture: false
    },
    condition: data => data.phase === 'superchain2b' && data.superchainCollect.length === 4,
    alertText: (data, _matches, output) => {
      // Sort ascending. collect: [dest1, dest2, out/sphere, in/donut]
      const collect = data.superchainCollect.slice(0, 4).sort((a, b) => parseInt(a.npcBaseId) - parseInt(b.npcBaseId));
      const donut = collect[3];
      if (donut === undefined) return;

      // For the first mechanic, two destination orbs span at [100,95] and [100,105]
      // Each has a short tether to either an 'in' or 'out' orb on the same N/S half of the area.
      // We therefore only need to know whether the 'in' orb is N or S to identify the safe spot.
      if (parseFloat(donut.y) > 100) {
        data.superchain2bFirstDir = 'south';
        return output.south();
      }
      data.superchain2bFirstDir = 'north';
      return output.north();
    },
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      south: outputs/* default.south */.Z.south
    }
  }, {
    id: 'P12S Superchain Theory IIb Second Mechanic',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: superchainNpcNameId,
      npcBaseId: superchainNpcBaseIds,
      capture: false
    },
    condition: data => data.phase === 'superchain2b' && data.superchainCollect.length === 8,
    delaySeconds: 4.5,
    durationSeconds: 8,
    // keep active until just before Ray of Light 2
    alertText: (data, _matches, output) => {
      // Sort ascending. collect: [dest1, dest2, out, partnerProtean]
      const collect = data.superchainCollect.slice(4, 8).sort((a, b) => parseInt(a.npcBaseId) - parseInt(b.npcBaseId));
      const partnerProtean = collect[3];
      if (partnerProtean === undefined) return;
      let mechanicStr;
      if (partnerProtean.npcBaseId === superchainNpcBaseIdMap.protean) {
        mechanicStr = output.protean();
        data.superchain2bSecondMech = 'protean';
      } else {
        mechanicStr = output.partners();
        data.superchain2bSecondMech = 'partners';
      }

      // For the second mechanic, the two destination orbs spawn at [92,100] and [108,100]
      // One is tethered to a sphere (out) orb, and the other to a partner or protean orb.
      // The partner/protean orb is always on the same E/W half as the destination orb it is tethered to.
      // We therefore only need to know whether the partnerProteam orb is E or W to identify the safe spot.
      const x = parseFloat(partnerProtean.x);
      data.superchain2bSecondDir = x > 100 ? 'east' : 'west';
      let dirStr;
      if (x > 100) {
        data.superchain2bSecondDir = 'east';
        dirStr = data.superchain2bFirstDir === 'south' ? 'eastFromSouth' : 'eastFromNorth';
      } else {
        data.superchain2bSecondDir = 'west';
        dirStr = data.superchain2bFirstDir === 'south' ? 'westFromSouth' : 'westFromNorth';
      }
      return output.combined({
        dir: output[dirStr](),
        mechanic: mechanicStr
      });
    },
    outputStrings: {
      combined: {
        en: '${dir} (Side) => ${mechanic} After',
        de: '${dir} (Seiten) => ${mechanic} danach',
        fr: '${dir} (Côté) => ${mechanic} ensuite',
        cn: '去 ${dir}(侧) => 稍后 ${mechanic}',
        ko: '${dir} (옆) => ${mechanic}'
      },
      east: outputs/* default.east */.Z.east,
      west: outputs/* default.west */.Z.west,
      eastFromSouth: {
        en: 'Right/East',
        de: 'Rechts/Osten',
        fr: 'Droite/Est',
        cn: '右/东',
        ko: '오른쪽/동쪽'
      },
      eastFromNorth: {
        en: 'Left/East',
        de: 'Links/Osten',
        fr: 'Gauche/Est',
        cn: '左/东',
        ko: '왼쪽/동쪽'
      },
      westFromSouth: {
        en: 'Left/West',
        de: 'Links/Westen',
        fr: 'Gauche/Ouest',
        cn: '左/西',
        ko: '왼쪽/서쪽'
      },
      westFromNorth: {
        en: 'Right/West',
        de: 'Rechts/Westen',
        fr: 'Droite/Ouest',
        cn: '右/西',
        ko: '오른쪽/서쪽'
      },
      protean: {
        en: 'Protean',
        de: 'Himmelsrichtungen',
        fr: 'Positions',
        cn: '八方分散',
        ko: '8방향 산개'
      },
      partners: {
        en: 'Partners',
        de: 'Partner',
        fr: 'Partenaires',
        cn: '两人分摊',
        ko: '파트너'
      }
    }
  }, {
    id: 'P12S Superchain Theory IIb Second Mechanic + Ray of Light 2',
    type: 'StartsUsing',
    netRegex: {
      id: '82EE',
      source: 'Anthropos'
    },
    // Ray of Light cleaves from North adds
    condition: data => data.paradeigmaCounter === 4,
    suppressSeconds: 1,
    alertText: (data, matches, output) => {
      if (data.superchain2bSecondMech === undefined) return output.avoid();
      const mechanicStr = output[data.superchain2bSecondMech]();
      const x = Math.round(parseFloat(matches.x));
      if (data.superchain2bSecondDir === undefined || x === undefined) return output.combined({
        mechanic: mechanicStr,
        dir: output.avoid()
      });
      let safeLane = output.avoid(); // default if unable to determine safe lane

      // In Ray 2 (SC IIB), the adds spawn with PosX of [87, 103] or [97, 113].
      // Because of mech timing, there is only realistically time to move either inside or outside
      // (relative to the orb) to avoid the cleave.
      if (x < 92) safeLane = data.superchain2bSecondDir === 'east' ? output.outside() : output.inside();else if (x > 108) safeLane = data.superchain2bSecondDir === 'east' ? output.inside() : output.outside();else if (x > 100) safeLane = data.superchain2bSecondDir === 'east' ? output.outside() : output.inside();else safeLane = data.superchain2bSecondDir === 'east' ? output.inside() : output.outside();
      return output.combined({
        mechanic: mechanicStr,
        dir: safeLane
      });
    },
    outputStrings: {
      combined: {
        en: '${mechanic} => ${dir}',
        de: '${mechanic} => ${dir}',
        fr: '${mechanic} => ${dir}',
        cn: '${mechanic} => ${dir}',
        ko: '${mechanic} => ${dir}'
      },
      protean: {
        en: 'Protean',
        de: 'Himmelsrichtungen',
        fr: 'Position',
        cn: '八方分散',
        ko: '8방향 산개'
      },
      partners: {
        en: 'Partners',
        de: 'Partner',
        fr: 'Partenaires',
        cn: '两人分摊',
        ko: '파트너'
      },
      inside: {
        en: 'Inside (avoid clones)',
        de: 'Innen (Klonen ausweichen)',
        fr: 'Intérieur (évitez les clones)',
        cn: '内侧 (躲避小怪激光)',
        ko: '안쪽 (분신 피하기)'
      },
      outside: {
        en: 'Outside (avoid clones)',
        de: 'Außen (Klonen ausweichen)',
        fr: 'Extérieur (évitez les clones)',
        cn: '外侧 (躲避小怪激光)',
        ko: '바깥쪽 (분신 피하기)'
      },
      avoid: {
        en: 'Avoid Line Cleaves',
        de: 'Vermeide Linien AoEs',
        fr: 'Évitez les cleaves en ligne',
        ja: '直線回避',
        cn: '躲避小怪激光',
        ko: '직선 장판 피하기'
      }
    }
  }, {
    id: 'P12S Superchain Theory IIb Third Mechanic',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: superchainNpcNameId,
      npcBaseId: superchainNpcBaseIds,
      capture: false
    },
    condition: data => data.phase === 'superchain2b' && data.superchainCollect.length === 13,
    delaySeconds: 13.6,
    durationSeconds: 6,
    alertText: (data, _matches, output) => {
      // Sort ascending. collect: [dest1, dest2, out, out, partnerProtean]
      const collect = data.superchainCollect.slice(8, 13).sort((a, b) => parseInt(a.npcBaseId) - parseInt(b.npcBaseId));
      const partnerProtean = collect[4];
      if (partnerProtean === undefined) return;

      // For the third mechanic, the three destination orbs spawn at [100,90] and [100,110]
      // Both are tethered to a sphere (out) orb, and one is tethered to a partner/protean orb.
      // The partner/protean orb is always on opposite N/S half as the destination orb it is tethered to.
      // We therefore only need to know whether the partnerProteam orb is N or S to identify the safe spot.
      const mechanicStr = partnerProtean.npcBaseId === superchainNpcBaseIdMap.protean ? output.protean() : output.partners();
      const dirStr = parseFloat(partnerProtean.y) > 100 ? output.north() : output.south();
      return output.combined({
        dir: dirStr,
        mechanic: mechanicStr
      });
    },
    outputStrings: {
      combined: {
        en: '${dir} => Out + ${mechanic}',
        de: '${dir} => Raus + ${mechanic}',
        fr: '${dir} => Extérieur + ${mechanic}',
        cn: '${dir} => 远离 + ${mechanic}',
        ko: '${dir} => 밖으로 + ${mechanic}'
      },
      north: outputs/* default.north */.Z.north,
      south: outputs/* default.south */.Z.south,
      protean: {
        en: 'Protean',
        de: 'Himmelsrichtungen',
        fr: 'Positions',
        cn: '八方分散',
        ko: '8방향 산개'
      },
      partners: {
        en: 'Partners',
        de: 'Partner',
        fr: 'Partenaires',
        cn: '两人分摊',
        ko: '파트너'
      }
    }
  }, {
    id: 'P12S Sample Collect',
    type: 'Tether',
    netRegex: {
      id: '00E8',
      target: 'Athena'
    },
    condition: data => data.phase === 'superchain2b',
    run: (data, matches) => data.sampleTiles.push(matches)
  }, {
    id: 'P12S Sample Safe Tile',
    type: 'Tether',
    netRegex: {
      id: '00E8',
      target: 'Athena',
      capture: false
    },
    // tile combatants are the source
    condition: data => data.phase === 'superchain2b' && data.sampleTiles.length === 7,
    delaySeconds: 1,
    // short delay to avoid collision
    promise: async data => {
      data.combatantData = [];
      const ids = data.sampleTiles.map(tile => parseInt(tile.sourceId, 16));
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: ids
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      if (data.combatantData.length !== 7) return output.default();
      // platform 'combatants' can be at x:[90,110], y:[85,95,105,115]
      let safeTiles = ['outsideNW', 'outsideNE', 'insideNW', 'insideNE', 'insideSW', 'insideSE', 'outsideSW', 'outsideSE'];
      data.combatantData.forEach(tile => {
        if (tile.PosX !== undefined && tile.PosY !== undefined) {
          let unsafeTile;
          if (tile.PosX < p12s_centerX) {
            // west
            if (tile.PosY < 90) unsafeTile = 'outsideNW';else if (tile.PosY > 110) unsafeTile = 'outsideSW';else unsafeTile = tile.PosY < p12s_centerY ? 'insideNW' : 'insideSW';
          } else {
            // east
            if (tile.PosY < 90) unsafeTile = 'outsideNE';else if (tile.PosY > 110) unsafeTile = 'outsideSE';else unsafeTile = tile.PosY < p12s_centerY ? 'insideNE' : 'insideSE';
          }
          safeTiles = safeTiles.filter(tile => tile !== unsafeTile);
        }
      });
      if (safeTiles.length !== 1) return output.default();
      const safeTile = safeTiles[0];
      if (safeTile === undefined) return output.default();
      return output[safeTile]();
    },
    outputStrings: {
      outsideNW: {
        en: 'Outside NW',
        de: 'Außerhalb NW',
        fr: 'Extérieur NO',
        cn: '外侧 左上 (西北)',
        ko: '북서 바깥'
      },
      outsideNE: {
        en: 'Outside NE',
        de: 'Außerhalb NO',
        fr: 'Extérieur NE',
        cn: '外侧 右上(东北)',
        ko: '북동 바깥'
      },
      insideNW: {
        en: 'Inside NW',
        de: 'Innen NW',
        fr: 'Intérieur NO',
        cn: '内侧 左上(西北)',
        ko: '북서 안'
      },
      insideNE: {
        en: 'Inside NE',
        de: 'Innen NO',
        fr: 'Intérieur NE',
        cn: '内侧 右上(东北)',
        ko: '북동 안'
      },
      insideSW: {
        en: 'Inside SW',
        de: 'Innen SW',
        fr: 'Intérieur SO',
        cn: '内侧 左下(西南)',
        ko: '남서 안'
      },
      insideSE: {
        en: 'Inside SE',
        de: 'Innen SO',
        fr: 'Intérieur SE',
        cn: '内侧 右下(东南)',
        ko: '남동 안'
      },
      outsideSW: {
        en: 'Outside SW',
        de: 'Außerhalb SW',
        fr: 'Extérieur SO',
        cn: '外侧 左下(西南)',
        ko: '남서 바깥'
      },
      outsideSE: {
        en: 'Outside SE',
        de: 'Außerhalb SO',
        fr: 'Extérieur SE',
        cn: '外侧 右下(东南)',
        ko: '남동 바깥'
      },
      default: {
        en: 'Find safe tile',
        de: 'Sichere Fläche finden',
        fr: 'Trouvez la position sûre',
        cn: '找安全地板',
        ko: '안전한 타일 찾기'
      }
    }
  },
  // --------------------- Phase 2 ------------------------
  {
    id: 'P12S Geocentrism Vertical',
    type: 'StartsUsing',
    netRegex: {
      id: '8329',
      source: 'Pallas Athena',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.phase === 'gaiaochos1') return output.text();
      data.geocentrism2OutputStr = output.text();
      return;
    },
    outputStrings: {
      text: {
        en: 'Vertical',
        de: 'Vertikal',
        fr: 'Vertical',
        ja: '縦',
        cn: '垂直',
        ko: '세로'
      }
    }
  }, {
    id: 'P12S Geocentrism Circle',
    type: 'StartsUsing',
    netRegex: {
      id: '832A',
      source: 'Pallas Athena',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.phase === 'gaiaochos1') return output.text();
      data.geocentrism2OutputStr = output.text();
      return;
    },
    outputStrings: {
      text: {
        en: 'Inny Spinny',
        de: 'Innerer Kreis',
        fr: 'Cercle intérieur',
        ja: 'ドーナツ',
        cn: '月环',
        ko: '가운데 원'
      }
    }
  }, {
    id: 'P12S Geocentrism Horizontal',
    type: 'StartsUsing',
    netRegex: {
      id: '832B',
      source: 'Pallas Athena',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.phase === 'gaiaochos1') return output.text();
      data.geocentrism2OutputStr = output.text();
      return;
    },
    outputStrings: {
      text: {
        en: 'Horizontal',
        de: 'Horizontal',
        fr: 'Horizontal',
        ja: '横',
        cn: '水平',
        ko: '가로'
      }
    }
  }, {
    id: 'P12S Classical Concepts Headmarker',
    type: 'HeadMarker',
    netRegex: {},
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => {
      const id = p12s_getHeadmarkerId(data, matches);
      if (!conceptPairIds.includes(id)) return;
      const pair = conceptPairMap[id];
      if (pair === undefined) return;
      data.conceptPair = pair;
    }
  }, {
    id: 'P12S Classical Concepts Debuff',
    type: 'GainsEffect',
    netRegex: {
      effectId: conceptDebuffEffectIds
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => data.conceptDebuff = conceptDebuffIds[matches.effectId]
  }, {
    id: 'P12S Classical Concepts Shape Collect',
    type: 'AddedCombatant',
    netRegex: {
      npcBaseId: conceptNpcBaseIds
    },
    run: (data, matches) => {
      const location = getConceptLocation(matches);
      const color = npcBaseIdToConceptColor[parseInt(matches.npcBaseId)];
      if (location !== undefined && color !== undefined) data.conceptData[location] = color;
    }
  }, {
    id: 'P12S Classical Concepts',
    type: 'StartsUsing',
    // 8331 = The Classical Concepts (6.7s cast)
    // 8336 = Panta Rhei (9.7s cast during classical2 that inverts shapes)
    netRegex: {
      id: ['8331', '8336'],
      source: 'Pallas Athena'
    },
    delaySeconds: (_data, matches) => {
      if (matches.id === '8331')
        // for Classical Concepts, 6.7 cast time + 1.8 for shape/debuff/headmarker data (some variability)
        return 8.5;
      return 0; // for Panta Rhei, fire immediately once cast starts
    },

    durationSeconds: (data, matches) => {
      if (data.phase === 'classical1') return 12; // keep active until shapes tether
      if (matches.id === '8331') return 7; // for classical2 initial, display initially to allow player to find (stand in) initial position
      return 9.7; // for Panta Rhei, display until shape inversion completes
    },

    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        classic1: {
          en: '${column}, ${row} => ${intercept}',
          de: '${column}, ${row} => ${intercept}',
          fr: '${column}, ${row} => ${intercept}',
          cn: '${column}, ${row} => ${intercept}',
          ko: '${column}, ${row} => ${intercept}'
        },
        classic2initial: {
          en: 'Initial: ${column}, ${row} => ${intercept}',
          de: 'Initial: ${column}, ${row} => ${intercept}',
          fr: 'Initial : ${column}, ${row} => ${intercept}',
          cn: '先去 ${column}, ${row} => ${intercept}',
          ko: '시작: ${column}, ${row} => ${intercept}'
        },
        classic2actual: {
          en: 'Actual: ${column}, ${row} => ${intercept}',
          de: 'Tatsächlich: ${column}, ${row} => ${intercept}',
          fr: 'Actuel : ${column}, ${row} => ${intercept}',
          cn: '去 ${column}, ${row} => ${intercept}',
          ko: '실제: ${column}, ${row} => ${intercept}'
        },
        shapeAndDebuff: {
          en: '${shape}, ${debuff}',
          de: '${shape}, ${debuff}',
          fr: '${shape}, ${debuff}',
          ja: '${shape}, ${debuff}',
          cn: '${shape}, ${debuff}',
          ko: '${shape}, ${debuff}'
        },
        outsideWest: {
          en: 'Outside West',
          de: 'Außerhalb Westen',
          fr: 'Extérieur Ouest',
          cn: '第1列 (左西 外侧)',
          ko: '1열 (서쪽 바깥)'
        },
        insideWest: {
          en: 'Inside West',
          de: 'Innen Westen',
          fr: 'Intérieur Ouest',
          cn: '第2列 (左西 内侧)',
          ko: '2열 (서쪽 안)'
        },
        insideEast: {
          en: 'Inside East',
          de: 'Innen Osten',
          fr: 'Intérieur Est',
          cn: '第3列 (右东 内侧)',
          ko: '3열 (동쪽 안)'
        },
        outsideEast: {
          en: 'Outside East',
          de: 'Außerhalb Osten',
          fr: 'Extérieur Est',
          cn: '第4列 (右东 外侧)',
          ko: '4열 (동쪽 바깥)'
        },
        northRow: {
          en: 'North Blue',
          de: 'Norden Blau',
          fr: 'Nord Bleu',
          cn: '第1个蓝方块',
          ko: '위쪽 파란색'
        },
        middleRow: {
          en: 'Middle Blue',
          de: 'Mitte Blau',
          fr: 'Milieu Bleu',
          cn: '第2个蓝方块',
          ko: '가운데 파란색'
        },
        southRow: {
          en: 'South Blue',
          de: 'Süden Blau',
          fr: 'Sud Bleu',
          cn: '第3个蓝方块',
          ko: '아래쪽 파란색'
        },
        leanNorth: {
          en: 'Lean North',
          de: 'Nördlich halten',
          fr: 'Légèrement au Nord',
          cn: '靠上(北)',
          ko: '위쪽'
        },
        leanEast: {
          en: 'Lean East',
          de: 'Östlich halten',
          fr: 'Légèrement à l\'Est',
          cn: '靠右(东)',
          ko: '오른쪽'
        },
        leanSouth: {
          en: 'Lean South',
          de: 'Südlich halten',
          fr: 'Légèrement au Sud',
          cn: '靠下(南)',
          ko: '아래쪽'
        },
        leanWest: {
          en: 'Lean West',
          de: 'Westlich halten',
          fr: 'Légèrement à l\'Ouest',
          cn: '靠左(西)',
          ko: '왼쪽'
        },
        circle: {
          en: 'Red Circle',
          de: 'Roter Kreis',
          fr: 'Cercle rouge',
          ja: '赤まる',
          cn: '红圆圈',
          ko: '빨강 동그라미'
        },
        triangle: {
          en: 'Green Triangle',
          de: 'Grünes Dreieck',
          fr: 'Triangle vert',
          ja: '緑さんかく',
          cn: '绿三角',
          ko: '초록 삼각'
        },
        square: {
          en: 'Purple Square',
          de: 'Lila Viereck',
          fr: 'Carré violet',
          ja: '紫しかく',
          cn: '紫方块',
          ko: '보라 사각'
        },
        cross: {
          en: 'Blue X',
          de: 'Blaues X',
          fr: 'Croix bleue',
          ja: '青バツ',
          cn: '蓝 X',
          ko: '파랑 X'
        },
        alpha: {
          en: 'Alpha',
          de: 'Alpha',
          fr: 'Alpha',
          ja: 'アルファ',
          cn: '阿尔法',
          ko: '알파'
        },
        beta: {
          en: 'Beta',
          de: 'Beta',
          fr: 'Beta',
          ja: 'ベータ',
          cn: '贝塔',
          ko: '베타'
        }
      };
      if (Object.keys(data.conceptData).length !== 12 || data.conceptDebuff === undefined || data.conceptPair === undefined) return;
      if (data.triggerSetConfig.classicalConceptsPairOrder === 'shapeAndDebuff') {
        if (matches.id === '8336')
          // prevent going off again on Panta Rhei
          return;
        const myShape = data.conceptPair;
        const myDebuff = data.conceptDebuff;
        const outputStr = output.shapeAndDebuff({
          shape: output[myShape](),
          debuff: output[myDebuff]()
        });
        return {
          alertText: outputStr
        };
      }
      let myColumn;
      let myRow;
      let myInterceptOutput;
      if (matches.id === '8331') {
        // for classic1 and classic2, find the (initial) position for the player to intercept
        const columnOrderFromConfig = {
          xsct: ['cross', 'square', 'circle', 'triangle'],
          cxts: ['circle', 'cross', 'triangle', 'square'],
          ctsx: ['circle', 'triangle', 'square', 'cross'],
          ctxs: ['circle', 'triangle', 'cross', 'square'],
          tcxs: ['triangle', 'circle', 'cross', 'square']
        };
        const columnOrder = columnOrderFromConfig[data.triggerSetConfig.classicalConceptsPairOrder];
        if (columnOrder?.length !== 4) return;

        // If classicalConcepts2ActualNoFlip is enabled for classic2, the left/west assigned pair will handle
        // the left/west column, as opposed to flipping to pre-position in the right/east column before Panta Rhei.
        // To accommodate this, and because the shapes spawn in their flipped arrangement,
        // we just reverse the columnOrder from the config settings when determining initial safe spots.
        if (data.triggerSetConfig.classicalConcepts2ActualNoFlip && data.phase === 'classical2') columnOrder.reverse();
        myColumn = columnOrder.indexOf(data.conceptPair);
        const myColumnLocations = [conceptLocationMap.north[myColumn], conceptLocationMap.middle[myColumn], conceptLocationMap.south[myColumn]];
        const [north, middle, south] = myColumnLocations;
        if (north === undefined || middle === undefined || south === undefined) return;
        let myColumnBlueLocation;
        if (data.conceptData[north] === 'blue') myColumnBlueLocation = north;else myColumnBlueLocation = data.conceptData[middle] === 'blue' ? middle : south;
        myRow = myColumnLocations.indexOf(myColumnBlueLocation);
        const conceptMap = getConceptMap(myColumnBlueLocation);
        const myShapeColor = conceptDebuffToColor[data.conceptDebuff];
        const possibleLocations = [];
        const possibleIntercepts = [];
        conceptMap.forEach(adjacentPair => {
          const [location, intercept] = adjacentPair;
          if (location !== undefined && intercept !== undefined) {
            const adjacentColor = data.conceptData[location];
            if (adjacentColor === myShapeColor) {
              possibleLocations.push(location);
              possibleIntercepts.push(intercept);
            }
          }
        });
        let myIntercept; // don't set this initially in case there's something wrong with possibleLocations
        if (possibleLocations.length === 1) {
          // only one possible adjacent shape to intercept; we're done
          myIntercept = possibleIntercepts[0];
        } else if (possibleLocations.length === 2) {
          // two adjacent shapes that match player's debuff (does happen)
          // the one that is NOT adjacent to a different blue is the correct shape.
          // NOTE: There is a theoretical arrangement where both possibles are adjacent to another blue,
          // but this has never been observed in-game, and it generates two valid solution sets.
          // Since there is no single solution, we should not generate an output for it.
          const possible1 = possibleLocations[0];
          myIntercept = possibleIntercepts[0];
          if (possible1 === undefined) return;
          const possible1AdjacentsMap = getConceptMap(possible1);
          for (const [possibleAdjacentLocation] of possible1AdjacentsMap) {
            if (possibleAdjacentLocation === undefined) continue;
            const possibleAdjacentColor = data.conceptData[possibleAdjacentLocation];
            if (possibleAdjacentColor === 'blue' && possibleAdjacentLocation !== myColumnBlueLocation) {
              // there's an adjacent blue (not the one the player is responsible for), so possibleLocations[0] is eliminated
              myIntercept = possibleIntercepts[1];
              break;
            }
          }
        }
        if (myIntercept === undefined) return;
        const interceptDelta = myIntercept - myColumnBlueLocation;
        if (interceptDelta === -1) myInterceptOutput = 'leanNorth';else if (interceptDelta === 5) myInterceptOutput = 'leanEast';else if (interceptDelta === 1) myInterceptOutput = 'leanSouth';
        // else: interceptDelta === -5
        else myInterceptOutput = 'leanWest';
        if (data.phase === 'classical2') {
          data.classical2InitialColumn = myColumn;
          data.classical2InitialRow = myRow;
          data.classical2Intercept = myInterceptOutput;
        }
      }
      if (matches.id === '8336' || matches.id === '8331' && data.triggerSetConfig.classicalConcepts2ActualNoFlip) {
        // invert myColumn, myRow, and myInterceptOutput to correspond to final/actual positions
        if (data.classical2InitialColumn !== undefined) myColumn = 3 - data.classical2InitialColumn;
        if (data.classical2InitialRow !== undefined) myRow = 2 - data.classical2InitialRow;
        if (data.classical2Intercept !== undefined) {
          const interceptOutputInvertMap = {
            leanNorth: 'leanSouth',
            leanSouth: 'leanNorth',
            leanEast: 'leanWest',
            leanWest: 'leanEast'
          };
          myInterceptOutput = interceptOutputInvertMap[data.classical2Intercept];
        }
      }
      if (myColumn === undefined || myRow === undefined || myInterceptOutput === undefined) return;
      const columnOutput = ['outsideWest', 'insideWest', 'insideEast', 'outsideEast'][myColumn];
      const rowOutput = ['northRow', 'middleRow', 'southRow'][myRow];
      if (columnOutput === undefined || rowOutput === undefined) return;
      let outputStr;
      if (data.phase === 'classical1') {
        outputStr = output.classic1({
          column: output[columnOutput](),
          row: output[rowOutput](),
          intercept: output[myInterceptOutput]()
        });
        return {
          alertText: outputStr
        };
      }
      // call the actual position on Panta Rhei or on classical2 cast (depending on classicalConcepts2ActualNoFlip)
      if (matches.id === '8336' && !data.triggerSetConfig.classicalConcepts2ActualNoFlip || matches.id === '8331' && data.triggerSetConfig.classicalConcepts2ActualNoFlip) {
        outputStr = output.classic2actual({
          column: output[columnOutput](),
          row: output[rowOutput](),
          intercept: output[myInterceptOutput]()
        });
        return {
          alertText: outputStr
        };
      }
      // the initial call is not suppressed by classicalConcepts2ActualNoFlip, so call it for classical2
      if (matches.id === '8331') {
        outputStr = output.classic2initial({
          column: output[columnOutput](),
          row: output[rowOutput](),
          intercept: output[myInterceptOutput]()
        });
        return {
          infoText: outputStr
        };
      }
      // only case left is Panta Rhei where initial call was suppressed by classicalConcepts2ActualNoFlip, so don't call anything
      return;
    },
    run: data => {
      if (data.phase === 'classical1') {
        delete data.conceptPair;
        data.conceptData = {};
      }
    }
  }, {
    id: 'P12S Palladian Ray 1 Initial',
    type: 'LosesEffect',
    netRegex: {
      effectId: 'E04'
    },
    // Shackled Together
    condition: (data, matches) => data.me === matches.target && data.phase === 'classical1',
    // shapes use 8333 (Implode) at t+5.6s, and 8324 (Palladian Ray cleaves) snapshots at t+8.9s
    durationSeconds: 8,
    alertText: (data, _matches, output) => {
      if (data.conceptDebuff === undefined) return output.default();
      return data.conceptDebuff === 'alpha' ? output.baitAlphaDebuff() : output.baitBetaDebuff();
    },
    run: data => delete data.conceptDebuff,
    outputStrings: {
      baitAlphaDebuff: {
        en: 'Avoid Shapes => Bait Proteans (Alpha)',
        de: 'Vermeide Formen => Himmelsrichtungen ködern (Alpha)',
        fr: 'Évitez les formes => Positions (Alpha)',
        cn: '远离方块 => 引导射线 (α)',
        ko: '도형 피하기 => 장판 유도 (알파)'
      },
      baitBetaDebuff: {
        en: 'Avoid Shapes => Bait Proteans (Beta)',
        de: 'Vermeide Formen => Himmelsrichtungen ködern (Beta)',
        fr: 'Évitez les formes => Positions (Beta)',
        cn: '远离方块 => 引导射线 (β)',
        ko: '도형 피하기 => 장판 유도 (베타)'
      },
      default: {
        en: 'Bait Proteans',
        de: 'Himmelsrichtungen ködern',
        fr: 'Positions',
        cn: '引导射线',
        ko: '장판 유도'
      }
    }
  }, {
    id: 'P12S Palladian Ray 2 Initial',
    type: 'Tether',
    netRegex: {
      id: '0001',
      source: ['Concept of Fire', 'Concept of Earth']
    },
    condition: (data, matches) => data.me === matches.target && data.phase === 'classical2',
    alertText: (data, _matches, output) => {
      if (data.conceptDebuff === undefined) return output.default();
      return data.conceptDebuff === 'alpha' ? output.baitAlphaDebuff() : output.baitBetaDebuff();
    },
    outputStrings: {
      baitAlphaDebuff: {
        en: 'Bait Proteans (Alpha)',
        de: 'Himmelsrichtungen ködern (Alpha)',
        fr: 'Positions (Alpha)',
        cn: '引导射线 (α)',
        ko: '장판 유도 (알파)'
      },
      baitBetaDebuff: {
        en: 'Bait Proteans (Beta)',
        de: 'Himmelsrichtungen ködern (Beta)',
        fr: 'Positions (Beta)',
        cn: '引导射线 (β)',
        ko: '장판 유도 (베타)'
      },
      default: {
        en: 'Bait Proteans',
        de: 'Himmelsrichtungen ködern',
        fr: 'Positions',
        cn: '引导射线',
        ko: '장판 유도'
      }
    }
  }, {
    id: 'P12S Palladian Ray Followup',
    type: 'Ability',
    netRegex: {
      id: '8323',
      source: 'Pallas Athena',
      capture: false
    },
    delaySeconds: 2.5,
    alertText: (data, _matches, output) => {
      if (data.phase === 'classical2') return output.moveAvoid();
      return output.move();
    },
    outputStrings: {
      moveAvoid: {
        en: 'Move! (avoid shapes)',
        de: 'Bewegen! (Formen vermeiden)',
        fr: 'Bougez ! (évitez les formes)',
        cn: '快躲开! (远离方块)',
        ko: '이동! (도형 피하기)'
      },
      move: outputs/* default.moveAway */.Z.moveAway
    }
  }, {
    id: 'P12S Pangenesis Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: pangenesisEffectIds
    },
    condition: data => !data.pangenesisDebuffsCalled && data.phase === 'pangenesis',
    run: (data, matches) => {
      const id = matches.effectId;
      if (id === pangenesisEffects.darkTilt) {
        const duration = parseFloat(matches.duration);
        // 16 = short, 20 = long
        data.pangenesisRole[matches.target] = duration > 18 ? 'longDark' : 'shortDark';
      } else if (id === pangenesisEffects.lightTilt) {
        const duration = parseFloat(matches.duration);
        // 16 = short, 20 = long
        data.pangenesisRole[matches.target] = duration > 18 ? 'longLight' : 'shortLight';
      } else if (id === pangenesisEffects.unstableFactor) {
        if (matches.count === '01') data.pangenesisRole[matches.target] = 'one';
      } else if (id === pangenesisEffects.stableSystem) {
        // Ordered: Unstable Factor / Stable System / Umbral Tilt (light) / Astral Tilt (dark)
        // ...and applied per person in that order.  Don't overwrite roles here.
        data.pangenesisRole[matches.target] ??= 'not';
      }
    }
  }, {
    id: 'P12S Pangenesis Initial',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'E22',
      capture: false
    },
    delaySeconds: 0.5,
    durationSeconds: data => {
      // There's ~13 seconds until the first tower and ~18 until the second tower.
      // Based on the strat chosen in the triggerset config, to avoid noisy alerts,
      // only extend duration for the long tilts and other players not taking the first towers.
      const myRole = data.pangenesisRole[data.me];
      if (myRole === undefined) return;
      const strat = data.triggerSetConfig.pangenesisFirstTower;
      const longerDuration = ['longDark', 'longLight'];
      if (strat === 'one') longerDuration.push('not');else if (strat === 'not') longerDuration.push('one');
      return longerDuration.includes(myRole) ? 17 : 12;
    },
    suppressSeconds: 999999,
    alertText: (data, _matches, output) => {
      const strat = data.triggerSetConfig.pangenesisFirstTower;
      const myRole = data.pangenesisRole[data.me];
      if (myRole === undefined) return;
      if (myRole === 'shortLight') return output.shortLight();
      if (myRole === 'longLight') return strat === 'not' ? output.longLightMerge() : output.longLight();
      if (myRole === 'shortDark') return output.shortDark();
      if (myRole === 'longDark') return strat === 'not' ? output.longDarkMerge() : output.longDark();
      const myBuddy = Object.keys(data.pangenesisRole).find(x => {
        return data.pangenesisRole[x] === myRole && x !== data.me;
      });
      const player = myBuddy === undefined ? output.unknown() : data.party.member(myBuddy);
      if (myRole === 'not') {
        if (strat === 'not') return output.nothingWithTower({
          player: player,
          tower: output.firstTower()
        });else if (strat === 'one') return output.nothingWithTower({
          player: player,
          tower: output.secondTower()
        });
        return output.nothing({
          player: player
        });
      }
      if (strat === 'not') return output.oneWithTower({
        player: player,
        tower: output.secondTowerMerge()
      });else if (strat === 'one') return output.oneWithTower({
        player: player,
        tower: output.firstTower()
      });
      return output.one({
        player: player
      });
    },
    run: data => data.pangenesisDebuffsCalled = true,
    outputStrings: {
      nothing: {
        en: 'Nothing (w/${player})',
        de: 'Nichts (mit ${player})',
        fr: 'Rien (avec ${player})',
        ja: '無職: 2番目の上の塔 (${player})',
        cn: '闲人: 踩第2轮塔 (${player})',
        ko: '디버프 없음 (+ ${player})'
      },
      nothingWithTower: {
        en: 'Nothing (w/${player}) - ${tower}',
        de: 'Nichts (mit ${player}) - ${tower}',
        fr: 'Rien (avec ${player}) - ${tower}',
        cn: '闲人 (与${player}) - ${tower}',
        ko: '디버프 없음 (+ ${player}) - ${tower}'
      },
      one: {
        en: 'One (w/${player})',
        de: 'Eins (mit ${player})',
        fr: 'Un (avec ${player})',
        ja: '因子1: 1番目の塔 (${player})',
        cn: '单因子: 踩第1轮塔 (${player})',
        ko: '1번 (+ ${player})'
      },
      oneWithTower: {
        en: 'One (w/${player}) - ${tower}',
        de: 'Eins (mit ${player}) - ${tower}',
        fr: 'Un (avec ${player}) - ${tower}',
        cn: '单因子 (与${player}) - ${tower}',
        ko: '1번 (+ ${player}) - ${tower}'
      },
      shortLight: {
        en: 'Short Light (get first dark)',
        de: 'Hell kurz (nimm erstes Dunkel)',
        fr: 'Lumière courte (prenez le 1er sombre)',
        ja: '早: 1番目のやみ塔',
        cn: '短光: 踩第1轮黑塔',
        ko: '짧은 빛 (첫 어둠 대상)'
      },
      longLight: {
        en: 'Long Light (get second dark)',
        de: 'Hell lang (nimm zweites Dunkel)',
        fr: 'Lumière long (prenez le 2nd sombre)',
        ja: '遅: 2番目の下のやみ塔',
        cn: '长光: 踩第2轮黑塔',
        ko: '긴 빛 (두번째 어둠 대상)'
      },
      longLightMerge: {
        en: 'Long Light (get second dark - merge first)',
        de: 'Hell lang (nimm zweites Dunkel - zuerst kombinieren)',
        fr: 'Lumière long (prenez le 2nd sombre - fusionnez d\'abord)',
        cn: '长光 (踩第2轮黑塔 - 先合成)',
        ko: '긴 빛 (두번째 어둠 대상 - 융합 먼저)'
      },
      shortDark: {
        en: 'Short Dark (get first light)',
        de: 'Dunkel kurz (nimm erstes Hell)',
        fr: 'Sombre court (prenez la 1ère lumière)',
        ja: '早: 1番目のひかり塔',
        cn: '短暗: 踩第1轮白塔',
        ko: '짧은 어둠 (첫 빛 대상)'
      },
      longDark: {
        en: 'Long Dark (get second light)',
        de: 'Dunkel lang (nimm zweites Hell)',
        fr: 'Sombre long (prenez la 2nde lumière)',
        ja: '遅: 2番目の下のひかり塔',
        cn: '长暗: 踩第2轮白塔',
        ko: '긴 어둠 (두번째 빛 대상)'
      },
      longDarkMerge: {
        en: 'Long Dark (get second light - merge first)',
        de: 'Dunkel lang (nimm zweites Hell - zuerst kombinieren)',
        fr: 'Sombre long (prenez le 2nde lumière - fusionnez d\'abord)',
        cn: '长暗 (踩第2轮白塔 - 先合成)',
        ko: '긴 어둠 (두번째 빛 대상 - 융합 먼저)'
      },
      firstTower: {
        en: 'First Tower',
        de: 'Erster Turm',
        fr: 'Première tour',
        cn: '1 塔',
        ko: '첫번째 기둥'
      },
      secondTower: {
        en: 'Second Tower',
        de: 'Zweiter Turm',
        fr: 'Deuxième tour',
        cn: '2 塔',
        ko: '두번째 기둥'
      },
      secondTowerMerge: {
        en: 'Second Tower (Merge first)',
        de: 'Zweiter Turm (zuerst kombinieren)',
        fr: 'Deuxième tour (fusionnez d\'abord)',
        cn: '2 塔 (先合成)',
        ko: '두번째 기둥 (융합 먼저)'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'P12S Pangenesis Tilt Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: [pangenesisEffects.lightTilt, pangenesisEffects.darkTilt]
    },
    condition: (data, matches) => matches.target === data.me && data.phase === 'pangenesis',
    run: (data, matches) => {
      const color = matches.effectId === pangenesisEffects.lightTilt ? 'light' : 'dark';
      data.pangenesisCurrentColor = color;
    }
  }, {
    id: 'P12S Pangenesis Tilt Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: [pangenesisEffects.lightTilt, pangenesisEffects.darkTilt]
    },
    condition: (data, matches) => matches.target === data.me && data.phase === 'pangenesis',
    run: data => data.pangenesisCurrentColor = undefined
  }, {
    id: 'P12S Pangenesis Tower',
    type: 'Ability',
    // 8343 = Umbral Advent (light tower), 8344 = Astral Advent (dark tower)
    netRegex: {
      id: ['8343', '8344']
    },
    condition: (data, matches) => matches.target === data.me && data.phase === 'pangenesis',
    run: (data, matches) => {
      const color = matches.id === '8343' ? 'light' : 'dark';
      data.lastPangenesisTowerColor = color;
    }
  }, {
    id: 'P12S Pangenesis Slime Reminder',
    type: 'Ability',
    // 8343 = Umbral Advent (light tower), 8344 = Astral Advent (dark tower)
    // There's always 1-2 of each, so just watch one.
    netRegex: {
      id: '8343',
      capture: false
    },
    condition: data => data.phase === 'pangenesis',
    preRun: data => data.pangenesisTowerCount++,
    suppressSeconds: 3,
    alarmText: (data, _matches, output) => {
      if (data.pangenesisTowerCount !== 3) return;
      if (data.pangenesisRole[data.me] !== 'not') return;
      return output.slimeTethers();
    },
    outputStrings: {
      slimeTethers: {
        en: 'Get Slime Tethers',
        de: 'Nimm Schleim Verbindung',
        fr: 'Prenez les liens Slime',
        ja: 'スライムの線取り',
        cn: '接线',
        ko: '슬라임 선 가져가기'
      }
    }
  }, {
    id: 'P12S Pangenesis Tower Call',
    type: 'GainsEffect',
    netRegex: {
      effectId: pangenesisEffects.lightTilt,
      capture: false
    },
    condition: data => {
      if (data.phase !== 'pangenesis') return false;
      return data.lastPangenesisTowerColor !== undefined && data.pangenesisTowerCount !== 3;
    },
    delaySeconds: 0.5,
    suppressSeconds: 3,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        // TODO: with more tracking we could even tell you who you're supposed
        // to be with so that you could yell something on comms to fix mistakes.
        lightTower: {
          en: 'Light Tower',
          de: 'Heller Turm',
          fr: 'Tour de lumière',
          ja: 'ひかり塔',
          cn: '踩白塔',
          ko: '빛 기둥'
        },
        darkTower: {
          en: 'Dark Tower',
          de: 'Dunkler Turm',
          fr: 'Tour sombre',
          ja: 'やみ塔',
          cn: '踩黑塔',
          ko: '어둠 기둥'
        },
        lightTowerSwitch: {
          en: 'Light Tower (switch)',
          de: 'Heller Turm (wechsel)',
          fr: 'Tour de lumière (switch)',
          ja: 'やみ -> ひかり塔',
          cn: '踩白塔 (换色)',
          ko: '빛 기둥 (교체)'
        },
        darkTowerSwitch: {
          en: 'Dark Tower (switch)',
          de: 'Dunkler Turm (wechsel)',
          fr: 'Tour sombre (switch)',
          ja: 'ひかり -> やみ塔',
          cn: '踩黑塔 (换色)',
          ko: '어둠 기둥 (교체)'
        }
      };
      const strat = data.triggerSetConfig.pangenesisFirstTower;
      const myRole = data.pangenesisRole[data.me];
      if (myRole === undefined) return;
      const switchOutput = data.lastPangenesisTowerColor === 'light' ? 'darkTowerSwitch' : 'lightTowerSwitch';
      const stayOutput = data.lastPangenesisTowerColor === 'light' ? 'lightTower' : 'darkTower';

      // 2nd towers
      if (data.pangenesisTowerCount === 1) {
        if (strat === 'not') {
          // in the 0+2 strat, 2nd tower responsibilities are fixed based on 1st tower soaks.
          // the shortLight, shortDark, and both 'not' players always take the northern (opposite color) towers.
          // the longLight, longDark, and both 'one' players soak the southern (same color) towers - per their still-active Pangenesis Initial call
          const swapRoles = ['not', 'shortLight', 'shortDark'];
          if (swapRoles.includes(myRole)) return {
            infoText: output[switchOutput]()
          }; // infoText because, although a switch, it's 100% anticipated and should be treated as a reminder
          return;
        } else if (strat === 'one') {
          // in the 1+2 strat, 2nd tower responsibilities are flexible based on debuffs applied by the 1st tower
          // the 'not' players take the northern towers and the longLight and longDark players taken the southern towers
          // for the 'one' and shortDark/shortLight players, whomever receives a same-color debuff from the first tower goes north (swaps), the other goes south
          const swapRoles = ['one', 'shortLight', 'shortDark'];
          if (data.pangenesisCurrentColor === data.lastPangenesisTowerColor) return {
            alertText: output[switchOutput]()
          };else if (swapRoles.includes(myRole)) return {
            infoText: output[stayOutput]()
          };
        } else if (data.pangenesisCurrentColor === data.lastPangenesisTowerColor) return {
          alertText: output[switchOutput]()
        }; // if no strat, only call a swap for players who must swap or deadge
        return;
      }

      // 3rd towers
      // in both the 0+2 and 1+2 strats, only the players whose debuff is incompatible with the next tower will swap; all others stay
      if (data.pangenesisCurrentColor === data.lastPangenesisTowerColor) return {
        alertText: output[switchOutput]()
      };
      if (strat === 'not' || strat === 'one') return {
        infoText: output[stayOutput]()
      };
    }
  }, {
    id: 'P12S Summon Darkness Preposition',
    type: 'StartsUsing',
    netRegex: {
      id: '832F',
      source: 'Pallas Athena',
      capture: false
    },
    condition: data => data.seenSecondTethers === false,
    infoText: (_data, _matches, output) => output.stackForTethers(),
    outputStrings: {
      stackForTethers: {
        en: 'Stack for Tethers',
        de: 'Sammeln für Verbindungen',
        fr: 'Packez pour les liens',
        cn: '集合等待连线出现',
        ko: '선 생기기 전에 모이기'
      }
    }
  }, {
    id: 'P12S Ultima Ray 1',
    type: 'StartsUsing',
    netRegex: {
      id: '8330',
      source: 'Hemitheos'
    },
    condition: data => data.phase === 'gaiaochos1',
    infoText: (data, matches, output) => {
      data.darknessClones.push(matches);
      if (data.darknessClones.length !== 3) return;

      // during 'UAV' phase, the center of the circular arena is [100, 90]
      const uavCenterX = 100;
      const uavCenterY = 90;
      const unsafeMap = {
        dirN: 'dirS',
        dirNE: 'dirSW',
        dirE: 'dirW',
        dirSE: 'dirNW',
        dirS: 'dirN',
        dirSW: 'dirNE',
        dirW: 'dirE',
        dirNW: 'dirSE'
      };
      let safeDirs = Object.keys(unsafeMap);
      data.darknessClones.forEach(clone => {
        const x = parseFloat(clone.x);
        const y = parseFloat(clone.y);
        const cloneDir = util/* Directions.xyTo8DirOutput */.N.xyTo8DirOutput(x, y, uavCenterX, uavCenterY);
        const pairedDir = unsafeMap[cloneDir];
        safeDirs = safeDirs.filter(dir => dir !== cloneDir && dir !== pairedDir);
      });
      if (safeDirs.length !== 2) return;
      const [dir1, dir2] = safeDirs.sort();
      if (dir1 === undefined || dir2 === undefined) return;
      return output.combined({
        dir1: output[dir1](),
        dir2: output[dir2]()
      });
    },
    outputStrings: {
      combined: {
        en: '${dir1} / ${dir2} Safe',
        de: '${dir1} / ${dir2} Sicher',
        fr: '${dir1} / ${dir2} Sûr',
        cn: '${dir1} / ${dir2} 安全',
        ko: '${dir1} / ${dir2} 안전'
      },
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  }, {
    id: 'P12S Ultima Ray 2',
    type: 'StartsUsing',
    netRegex: {
      id: '8330',
      source: 'Hemitheos'
    },
    condition: data => data.phase === 'gaiaochos2',
    infoText: (_data, matches, output) => {
      // during 'UAV' phase, the center of the circular arena is [100, 90]
      const uavCenterX = 100;
      const uavCenterY = 90;
      const safeMap = {
        // for each dir, identify the two dirs 90 degrees away
        dirN: ['dirW', 'dirE'],
        dirNE: ['dirNW', 'dirSE'],
        dirE: ['dirN', 'dirS'],
        dirSE: ['dirNE', 'dirSW'],
        dirS: ['dirW', 'dirE'],
        dirSW: ['dirNW', 'dirSE'],
        dirW: ['dirN', 'dirS'],
        dirNW: ['dirNE', 'dirSW'],
        unknown: []
      };
      const x = parseFloat(matches.x);
      const y = parseFloat(matches.y);
      const cloneDir = util/* Directions.xyTo8DirOutput */.N.xyTo8DirOutput(x, y, uavCenterX, uavCenterY);
      const [dir1, dir2] = safeMap[cloneDir];
      if (dir1 === undefined || dir2 === undefined) return;
      return output.combined({
        dir1: output[dir1](),
        dir2: output[dir2]()
      });
    },
    outputStrings: {
      combined: {
        en: '${dir1} / ${dir2} Safe',
        de: '${dir1} / ${dir2} Sicher',
        fr: '${dir1} / ${dir2} Sûr',
        cn: '${dir1} / ${dir2} 安全',
        ko: '${dir1} / ${dir2} 안전'
      },
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  }, {
    id: 'P12S Gaiaochos',
    type: 'StartsUsing',
    netRegex: {
      id: '8326',
      source: 'Pallas Athena',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe('alert')
  }, {
    id: 'P12S Gaiaochos Tether',
    type: 'Tether',
    netRegex: {
      id: '0009'
    },
    condition: data => data.phase === 'gaiaochos1' || data.phase === 'gaiaochos2',
    durationSeconds: data => data.phase === 'gaiaochos2' ? 6 : 4,
    alertText: (data, matches, output) => {
      if (matches.source !== data.me && matches.target !== data.me) return;
      const partner = matches.source === data.me ? matches.target : matches.source;
      if (data.phase === 'gaiaochos1') return output.uav1({
        partner: data.party.member(partner)
      });
      data.seenSecondTethers = true;
      return output.uav2({
        partner: data.party.member(partner),
        geocentrism: data.geocentrism2OutputStr ?? output.unknown()
      });
    },
    outputStrings: {
      uav1: {
        en: 'Break tether (w/ ${partner})',
        de: 'Verbindung brechen (mit ${partner})',
        fr: 'Cassez le lien (avec ${partner})',
        ja: '線切る (${partner})',
        cn: '拉断连线 (和 ${partner})',
        ko: '선 끊기 (+ ${partner})'
      },
      uav2: {
        en: 'Break tether (w/ ${partner}) => ${geocentrism}',
        de: 'Verbindung brechen (mit ${partner}) => ${geocentrism}',
        fr: 'Cassez le lien (avec ${partner}) => ${geocentrism}',
        cn: '拉断连线 (和 ${partner}) => ${geocentrism}',
        ko: '선 끊기 (+ ${partner}) => ${geocentrism}'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'P12S Ultima Blow Tether Collect',
    type: 'Tether',
    netRegex: {
      id: '0001'
    },
    condition: data => data.phase === 'gaiaochos2',
    run: (data, matches) => data.gaiaochosTetherCollect.push(matches.target)
  }, {
    id: 'P12S Ultima Blow Tether',
    type: 'Tether',
    netRegex: {
      id: '0001',
      capture: false
    },
    condition: data => data.phase === 'gaiaochos2',
    delaySeconds: 0.5,
    suppressSeconds: 5,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        blockPartner: {
          en: 'Block tether',
          de: 'Verbindung blockieren',
          fr: 'Bloquez le lien',
          ja: '相棒の前でビームを受ける',
          cn: '挡枪',
          ko: '선 대상자 앞에 서기'
        },
        stretchTether: {
          en: 'Stretch tether',
          de: 'Verbindung lang ziehen',
          fr: 'Étirez le lien',
          cn: '拉线',
          ko: '선 늘리기'
        }
      };
      if (data.gaiaochosTetherCollect.includes(data.me)) return {
        infoText: output.stretchTether()
      };
      return {
        alertText: output.blockPartner()
      };
    },
    // If people die, it's not always on the opposite role, so just re-collect.
    run: data => data.gaiaochosTetherCollect = []
  }, {
    id: 'P12S Ultima',
    type: 'StartsUsing',
    netRegex: {
      id: ['8682', '86F6'],
      source: 'Pallas Athena',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe('alert')
  }, {
    id: 'P12S Palladian Grasp Target',
    type: 'HeadMarker',
    netRegex: {},
    run: (data, matches) => {
      const id = p12s_getHeadmarkerId(data, matches);
      if (id === p12s_headmarkers.palladianGrasp) data.palladionGrapsTarget = matches.target;
    }
  }, {
    id: 'P12S Palladian Grasp',
    type: 'StartsUsing',
    netRegex: {
      id: '831A',
      source: 'Pallas Athena',
      capture: false
    },
    response: (data, _match, output) => {
      // cactbot-builtin-response
      // We could suggest to swap here, but I think this is mostly invulned.
      output.responseOutputStrings = {
        tankBusterCleavesOnYou: outputs/* default.tankBusterCleavesOnYou */.Z.tankBusterCleavesOnYou,
        tankBusterCleaves: outputs/* default.tankBusterCleaves */.Z.tankBusterCleaves,
        avoidTankCleaves: outputs/* default.avoidTankCleaves */.Z.avoidTankCleaves
      };
      if (data.palladionGrapsTarget === data.me) return {
        alertText: output.tankBusterCleavesOnYou()
      };
      if (data.role === 'tank' || data.role === 'healer' || data.job === 'BLU') return {
        alertText: output.tankBusterCleaves()
      };
      return {
        infoText: output.avoidTankCleaves()
      };
    }
  }, {
    id: 'P12S Caloric Theory 1 Beacon Collect',
    type: 'HeadMarker',
    netRegex: {},
    run: (data, matches) => {
      const id = p12s_getHeadmarkerId(data, matches);
      if (id === p12s_headmarkers.caloric1Beacon) data.caloric1First.push(matches.target);
    }
  }, {
    id: 'P12S Caloric Theory 1 Beacon',
    type: 'StartsUsing',
    netRegex: {
      id: '8338',
      source: 'Pallas Athena',
      capture: false
    },
    condition: data => data.caloricCounter === 1,
    preRun: data => {
      data.caloric1Buff = {};
      data.caloric1Mine = undefined;
    },
    delaySeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        noBeacon: {
          en: 'Initial Fire: ${player1}, ${player2}',
          de: 'Initiales Feuer: ${player1}, ${player2}',
          fr: 'Feu initial : ${player1}, ${player2}',
          cn: '火标记点: ${player1}, ${player2}',
          ko: '첫 불: ${player1}, ${player2}'
        },
        beacon: {
          en: 'Initial Fire (w/ ${partner})',
          de: 'Initiales Feuer (mit ${partner})',
          fr: 'Feu initial (avec ${partner})',
          ja: '自分に初炎 (${partner})',
          // FIXME
          cn: '火标记点名 (和 ${partner})',
          ko: '첫 불 대상자 (+ ${partner})'
        }
      };
      if (data.caloric1First.length !== 2) return;
      const index = data.caloric1First.indexOf(data.me);
      if (index < 0) return {
        infoText: output.noBeacon({
          player1: data.party.member(data.caloric1First[0]),
          player2: data.party.member(data.caloric1First[1])
        })
      };
      const partner = index === 0 ? 1 : 0;
      return {
        alertText: output.beacon({
          partner: data.party.member(data.caloric1First[partner])
        })
      };
    }
  }, {
    id: 'P12S Caloric Theory 1 Wind',
    type: 'GainsEffect',
    // E07 = Atmosfaction
    netRegex: {
      effectId: 'E07'
    },
    run: (data, matches) => data.caloric1Buff[matches.target] = 'wind'
  }, {
    id: 'P12S Caloric Theory 1 Fire',
    type: 'GainsEffect',
    // E06 = Pyrefaction
    netRegex: {
      effectId: 'E06'
    },
    alertText: (data, matches, output) => {
      data.caloric1Buff[matches.target] = 'fire';
      const duration = parseFloat(matches.duration);
      if (duration < 12 && matches.target === data.me) return output.text();
    },
    outputStrings: {
      text: {
        en: 'Fire again',
        de: 'nochmal Feuer',
        fr: 'Feu à nouveau',
        ja: '再び炎！無職とあたまわり',
        cn: '二次火标记点名',
        ko: '두번째 불'
      }
    }
  }, {
    id: 'P12S Caloric Theory 1 Fire Final',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['E06']
    },
    condition: (_data, matches) => parseFloat(matches.duration) > 11,
    delaySeconds: 12.8,
    suppressSeconds: 2,
    alertText: (data, _matches, output) => {
      if (data.caloric1Mine === 'fire' && data.caloric1Buff[data.me] === undefined) return output.none();
      if (data.caloric1Mine === 'wind') return output.wind();
    },
    outputStrings: {
      none: {
        en: 'Stack with Fire',
        de: 'Mit Feuer sammeln',
        fr: 'Package avec le Feu',
        ja: '無職！炎とあたまわり',
        // FIXME
        cn: '与火标记分摊',
        ko: '불 쉐어'
      },
      wind: {
        en: 'Spread Wind',
        de: 'Wind verteilen',
        fr: 'Écartez le vent',
        ja: '風！ 散会',
        cn: '风点名散开',
        ko: '바람 산개'
      }
    }
  }, {
    id: 'P12S Caloric Theory 1 Initial Buff',
    type: 'Ability',
    netRegex: {
      id: '8338',
      source: 'Pallas Athena',
      capture: false
    },
    condition: data => data.caloricCounter === 1,
    delaySeconds: 2,
    durationSeconds: 8,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        fire: {
          en: 'Fire (w/${team})',
          de: 'Feuer (mit ${team})',
          fr: 'Feu (avec ${team})',
          ja: '自分に炎 (${team})',
          cn: '火标记点名 (和 ${team})',
          ko: '불 (+ ${team})'
        },
        wind: {
          en: 'Wind (w/${team})',
          de: 'Wind (mit ${team})',
          fr: 'Vent (avec ${team})',
          ja: '自分に風 (${team})',
          cn: '风标记点名 (和 ${team})',
          ko: '바람 (+ ${team})'
        },
        windBeacon: {
          en: 'Initial Wind',
          de: 'Initial Wind',
          fr: 'Vent inital',
          ja: '自分に初風',
          // FIXME
          cn: '风标记点名',
          ko: '첫 바람 대상자'
        }
      };
      const myBuff = data.caloric1Buff[data.me];
      data.caloric1Mine = myBuff;
      if (myBuff === undefined) return;
      if (myBuff === 'fire') {
        const myTeam = [];
        for (const [name, stat] of Object.entries(data.caloric1Buff)) {
          if (stat === myBuff && name !== data.me) myTeam.push(name);
        }
        return {
          alertText: output.fire({
            team: myTeam.sort().map(x => data.party.member(x))
          })
        };
      }
      if (data.caloric1First.includes(data.me)) return {
        infoText: output.windBeacon()
      };
      const myTeam = [];
      for (const [name, stat] of Object.entries(data.caloric1Buff)) {
        if (stat === myBuff && name !== data.me && !data.caloric1First.includes(name)) myTeam.push(name);
      }
      return {
        alertText: output.wind({
          team: myTeam.sort().map(x => data.party.member(x))
        })
      };
    },
    run: data => {
      data.caloric1First = [];
      data.caloric1Buff = {};
    }
  }, {
    id: 'P12S Caloric Theory 2 Fire Beacon',
    type: 'HeadMarker',
    netRegex: {},
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        fireOnMe: {
          // TODO: is "first marker" ambiguous with "first person to pass fire"
          // This is meant to be "person without wind who gets an extra stack".
          en: 'Fire Marker',
          de: 'Feuer Markierung',
          fr: 'Marqueur de feu',
          ja: '自分に初炎!',
          // FIXME
          cn: '火标记点名',
          ko: '불 대상자'
        },
        fireOn: {
          en: 'Fire on ${player}',
          de: 'Feuer auf ${player}',
          fr: 'Feu sur ${player}',
          ja: '初炎: ${player}',
          cn: '火标记点 ${player}',
          ko: '불: ${player}'
        }
      };
      if (data.decOffset === undefined) return;
      const id = p12s_getHeadmarkerId(data, matches);
      if (id !== p12s_headmarkers.caloric2InitialFire) return;
      if (data.me === matches.target) return {
        alarmText: output.fireOnMe()
      };
      return {
        infoText: output.fireOn({
          player: data.party.member(matches.target)
        })
      };
    }
  }, {
    id: 'P12S Caloric Theory 2 Wind',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => data.me === matches.target,
    infoText: (data, matches, output) => {
      const id = p12s_getHeadmarkerId(data, matches);
      if (id !== p12s_headmarkers.caloric2Wind) return;
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'Wind Spread',
        de: 'Wind verteilen',
        fr: 'Écartez le vent',
        ja: '自分に風、散会',
        cn: '风点名散开',
        ko: '바람 산개'
      }
    }
  }, {
    id: 'P12S Caloric Theory 2 Pass',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'E08'
    },
    condition: data => data.caloricCounter === 2,
    durationSeconds: 3,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        passFire: {
          en: 'Pass Fire',
          de: 'Feuer weitergeben',
          fr: 'Passez le feu',
          ja: '次に移る！',
          cn: '传火!',
          ko: '불 건네기'
        },
        moveAway: outputs/* default.moveAway */.Z.moveAway
      };
      const prevFire = data.caloric2Fire;
      const thisFire = matches.target;

      // Order of events:
      // - Player 1 gets the debuff at 8
      // - Player 1 gets the debuff at 7
      //
      // loop:
      // - Player 2 gets the debuff at 7
      // - Player 1 loses the debuff
      // - Player 2 gets the debuff at 6
      // etc.
      //
      // Ignore duplicates, only consider transfers.
      if (prevFire === thisFire) return;
      data.caloric2Fire = matches.target;
      data.caloric2PassCount++;
      if (thisFire !== data.me && prevFire !== data.me) return;
      if (data.caloric2PassCount === 8 || prevFire === data.me) return {
        infoText: output.moveAway()
      };
      if (thisFire === data.me) return {
        alertText: output.passFire()
      };
    }
  }, {
    id: 'P12S Ekpyrosis Cast',
    type: 'StartsUsing',
    netRegex: {
      id: '831E',
      source: 'Pallas Athena',
      capture: false
    },
    // This cast happens while people need to plant for the end of Caloric 2,
    // so delay the call to avoid people jumping the gun.
    delaySeconds: data => data.caloricCounter === 2 ? 3 : 0,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Exaflare + Big AoE!',
        de: 'Exaflare + Große AoE!',
        fr: 'Brasier + Grosse AoE !',
        ja: 'エクサフレア + 全体攻撃',
        cn: '地火 + 大AoE伤害!',
        ko: '엑사플레어 + 전체 공격!'
      }
    }
  }, {
    id: 'P12S Ekpyrosis Spread',
    type: 'Ability',
    netRegex: {
      id: '831F',
      source: 'Pallas Athena',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 2,
    response: responses/* Responses.spread */.n3.spread('alert')
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceSync': {
      'Apodialogos/Peridialogos': 'Apodia/Peridia',
      'Astral Advance/Umbral Advance': 'Astral/Umbral Advance',
      'Astral Advent/Umbral Advent': 'Astral/Umbral Advent',
      'Astral Glow/Umbral Glow': 'Astral/Umbral Glow',
      'Astral Impact/Umbral Impact': 'Astral/Umbral Impact',
      'Superchain Coil/Superchain Burst': 'Superchain Coil/Burst',
      'Theos\'s Saltire/Theos\'s Cross': 'Saltire/Cross'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      '(?<! )Athena': 'Athena',
      'Anthropos': 'Anthropos',
      'Concept of Earth': 'Substanz der Erde',
      'Concept of Fire': 'Substanz des Feuers',
      'Concept of Water': 'Substanz des Wassers',
      'Forbidden Factor': 'Tabu',
      'Hemitheos': 'Hemitheos',
      'Pallas Athena': 'Pallas Athena',
      'Thymou Idea': 'Thymos'
    },
    'replaceText': {
      '\\(Floor Drop\\)': '(Boden bricht weg)',
      '\\(cast\\)': '(Wirken)',
      '\\(enrage\\)': '(Finalangriff)',
      '\\(proximity\\)': '(Entfernung)',
      '\\(spread\\)': '(Verteilen)',
      '--tethers--': '--Verbindungen--',
      'Apodialogos': 'Apodialogos',
      'Astral Advance': 'Lichtvordringen',
      'Astral Advent': 'Vorzeit des Lichts',
      'Astral Glow': 'Lichtglühen',
      'Astral Impact': 'Lichtschlag',
      'Caloric Theory': 'Kalorische Theorie',
      'Crush Helm': 'Zenitspaltung',
      'Demi Parhelion': 'Demi-Parhelion',
      '(?<!(Apo|Peri))Dialogos': 'Dialogos',
      'Divine Excoriation': 'Gottes Wort',
      'Dynamic Atmosphere': 'Dynamische Atmosphäre',
      'Ekpyrosis': 'Ekpyrosis',
      'Engravement of Souls': 'Seelensiegel',
      'Entropic Excess': 'Entropischer Exzess',
      'Factor In': 'Interner Faktor',
      'Gaiaochos': 'Gaiaochos',
      'Geocentrism': 'Geozentrismus',
      'Glaukopis': 'Glaukopis',
      'Ignorabimus': 'Ignorabimus',
      'Implode': 'Desintegration',
      'Missing Link': 'Schmerzende Kette',
      'On the Soul': 'Auf der Seele',
      'Palladian Grasp': 'Pallas-Griff',
      'Palladian Ray': 'Pallas-Strahl',
      'Palladion': 'Palladion',
      'Pangenesis': 'Pangenesis',
      'Panta Rhei': 'Panta Rhei',
      'Paradeigma': 'Paradigma',
      'Parthenos': 'Parthenos',
      'Peridialogos': 'Peridialogos',
      'Polarized Ray': 'Polarisierter Strahl',
      'Pyre Pulse': 'Pyrischer Puls',
      'Ray of Light': 'Lichtstrahl',
      'Sample': 'Vielfraß',
      'Searing Radiance': 'Radianz',
      'Shadowsear': 'Seelenbrenner',
      'Shock': 'Entladung',
      'Summon Darkness': 'Beschwörung der Dunkelheit',
      'Superchain Burst': 'Superkette - Ausbruch',
      'Superchain Coil': 'Superkette - Kreis',
      'Superchain Theory I(?!I)': 'Superkette - Theorie 1',
      'Superchain Theory IIA': 'Superkette - Theorie 2a',
      'Superchain Theory IIB': 'Superkette - Theorie 2b',
      'The Classical Concepts': 'Elementarschöpfung',
      'Theos\'s Cross': 'Theisches Kreuz',
      'Theos\'s Holy': 'Theisches Sanctus',
      'Theos\'s Saltire': 'Theisches Schrägkreuz',
      'Theos\'s Ultima': 'Theos Ultima',
      'Trinity of Souls': 'Dreifaltigkeit der Seelen',
      '(?<! )Ultima(?! (B|R))': 'Ultima',
      'Ultima Blade': 'Ultima-Klinge',
      'Ultima Blow': 'Ultima-Schlag',
      'Ultima Ray': 'Ultima-Strahl',
      'Umbral Advance': 'Schattenvordringen',
      'Umbral Advent': 'Vorzeit der Schatten',
      'Umbral Glow': 'Dunkelglühen',
      'Umbral Impact': 'Dunkelschlag',
      'Unnatural Enchainment': 'Seelenfessel',
      'White Flame': 'Weißes Feuer'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '(?<! )Athena': 'Athéna',
      'Anthropos': 'anthropos',
      'Concept of Earth': 'concept de la terre',
      'Concept of Fire': 'concept du feu',
      'Concept of Water': 'concept de l\'eau',
      'Forbidden Factor': 'facteur tabou',
      'Hemitheos': 'hémithéos',
      'Pallas Athena': 'Pallas Athéna',
      'Thymou Idea': 'thymou idea'
    },
    'replaceText': {
      '--tethers--': '--liens--',
      'Apodialogos': 'Apo dialogos',
      'Astral Advance': 'Avancée astrale',
      'Astral Advent': 'Avènement astral',
      'Astral Glow': 'Lueur astrale',
      'Astral Impact': 'Attaque astrale',
      'Caloric Theory': 'Théorie du calorique',
      'Crush Helm': 'Bombardement céleste',
      'Demi Parhelion': 'Demi-parhélie',
      '(?<!(Apo| |Peri))Dialogos': 'Dialogos',
      'Divine Excoriation': 'Châtiment céleste',
      'Dynamic Atmosphere': 'Vent perçant',
      'Ekpyrosis': 'Ekpyrosis',
      'Engravement of Souls': 'Marquage d\'âme',
      'Entropic Excess': 'Vague de chaleur ardente',
      'Factor In': 'Restauration des facteurs',
      'Gaiaochos': 'Gaiaochos',
      'Geocentrism': 'Géocentrisme',
      'Glaukopis': 'Glaukopis',
      'Ignorabimus': 'Ignorabimus',
      'Implode': 'Auto-effondrement',
      'Missing Link': 'Chaînes suppliciantes',
      'On the Soul': 'Sur les âmes',
      'Palladian Grasp': 'Main de Pallas',
      'Palladian Ray': 'Rayon de Pallas',
      'Palladion': 'Palladion',
      'Pangenesis': 'Pangenèse',
      'Panta Rhei': 'Panta rhei',
      'Paradeigma': 'Paradeigma',
      'Parthenos': 'Parthénon',
      'Peridialogos': 'Péri dialogos',
      'Polarized Ray': 'Rayon de polarité',
      'Pyre Pulse': 'Vague de chaleur intense',
      'Ray of Light': 'Onde de lumière',
      'Sample': 'Voracité',
      'Searing Radiance': 'Radiance',
      'Shadowsear': 'Brûlure d\'ombre',
      'Shock': 'Décharge électrostatique',
      'Summon Darkness': 'Invocation des ténèbres',
      'Superchain Burst': 'Salve des superchaînes',
      'Superchain Coil': 'Cercle des superchaînes',
      'Superchain Theory I(?!I)': 'Théorie des superchaînes I',
      'Superchain Theory IIA': 'Théorie des superchaînes IIA',
      'Superchain Theory IIB': 'Théorie des superchaînes IIB',
      'The Classical Concepts': 'Concepts élémentaires',
      'Theos\'s Cross': 'Croix de théos',
      'Theos\'s Holy': 'Miracle de théos',
      'Theos\'s Saltire': 'Croix décussée de théos',
      'Theos\'s Ultima': 'Ultima de théos',
      'Trinity of Souls': 'Âmes trinité',
      '(?<! )Ultima(?! (B|R))': 'Ultima',
      'Ultima Blade': 'Lames Ultima',
      'Ultima Blow': 'Souffle Ultima',
      'Ultima Ray': 'Rayon Ultima',
      'Umbral Advance': 'Avancée ombrale',
      'Umbral Advent': 'Avènement ombral',
      'Umbral Glow': 'Lueur ombrale',
      'Umbral Impact': 'Attaque ombrale',
      'Unnatural Enchainment': 'Enchaînement d\'âmes',
      'White Flame': 'Feu blanc'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      '(?<! )Athena': 'アテナ',
      'Anthropos': 'アンスロポス',
      'Concept of Earth': '土の概念',
      'Concept of Fire': '火の概念',
      'Concept of Water': '水の概念',
      'Forbidden Factor': '禁忌因子',
      'Hemitheos': 'ヘーミテオス',
      'Pallas Athena': 'パラスアテナ',
      'Thymou Idea': 'テューモス・イデア'
    },
    'replaceText': {
      'Apodialogos': 'アポ・ディアロゴス',
      'Astral Advance': 'アストラルアドバンス',
      'Astral Advent': 'アストラルアドベント',
      'Astral Glow': 'アストラルグロウ',
      'Astral Impact': '星撃',
      'Caloric Theory': 'カロリックセオリー',
      'Crush Helm': '星天爆撃打',
      'Demi Parhelion': 'デミパルヘリオン',
      '(?<!(Apo|Peri))Dialogos': 'ディアロゴス',
      'Divine Excoriation': '神罰',
      'Dynamic Atmosphere': '衝風',
      'Ekpyrosis': 'エクピロシス',
      'Engravement of Souls': '魂の刻印',
      'Entropic Excess': '焦熱波',
      'Factor In': '因子還元',
      'Gaiaochos': 'ガイアオコス',
      'Geocentrism': 'ジオセントリズム',
      'Glaukopis': 'グラウコピス',
      'Ignorabimus': 'イグノラビムス',
      'Implode': '自壊',
      'Missing Link': '苦痛の鎖',
      'On the Soul': 'オン・ザ・ソウル',
      'Palladian Grasp': 'パラスの手',
      'Palladian Ray': 'パラスレイ',
      'Palladion': 'パラディオン',
      'Pangenesis': 'パンゲネシス',
      'Panta Rhei': 'パンタレイ',
      'Paradeigma': 'パラデイグマ',
      'Parthenos': 'パルテノン',
      'Peridialogos': 'ペリ・ディアロゴス',
      'Polarized Ray': 'ポラリティレイ',
      'Pyre Pulse': '重熱波',
      'Ray of Light': '光波',
      'Sample': '貪食',
      'Searing Radiance': 'レイディアンス',
      'Shadowsear': 'シャドーシアー',
      'Shock': '放電',
      'Summon Darkness': 'サモンダークネス',
      'Superchain Burst': 'スーパーチェイン・バースト',
      'Superchain Coil': 'スーパーチェイン・サークル',
      'Superchain Theory I(?!I)': 'スーパーチェイン・セオリーI',
      'Superchain Theory IIA': 'スーパーチェイン・セオリーIIA',
      'Superchain Theory IIB': 'スーパーチェイン・セオリーIIB',
      'The Classical Concepts': 'イデア・エレメンタル',
      'Theos\'s Cross': 'テオス・クロス',
      'Theos\'s Holy': 'テオス・ホーリー',
      'Theos\'s Saltire': 'テオス・サルタイアー',
      'Theos\'s Ultima': 'テオス・アルテマ',
      'Trinity of Souls': 'トリニティ・ソウル',
      '(?<! )Ultima(?! (B|R))': 'アルテマ',
      'Ultima Blade': 'アルテマブレイド',
      'Ultima Blow': 'アルテマブロウ',
      'Ultima Ray': 'アルテマレイ',
      'Umbral Advance': 'アンブラルアドバンス',
      'Umbral Advent': 'アンブラルアドベント',
      'Umbral Glow': 'アンブラルグロウ',
      'Umbral Impact': '霊撃',
      'Unnatural Enchainment': '魂の鎖',
      'White Flame': '白火'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '(?<! )Athena': '雅典娜',
      'Anthropos': '人',
      'Concept of Earth': '土之概念',
      'Concept of Fire': '火之概念',
      'Concept of Water': '水之概念',
      'Forbidden Factor': '禁忌因子',
      'Hemitheos': '半神',
      'Pallas Athena': '帕拉斯雅典娜',
      'Thymou Idea': '激情理念'
    },
    'replaceText': {
      '\\(Floor Drop\\)': '(地板坠落)',
      '\\(cast\\)': '(咏唱)',
      '\\(enrage\\)': '(狂暴)',
      '\\(proximity\\)': '(近)',
      '\\(spread\\)': '(分散)',
      '--tethers--': '--连线--',
      'Apodialogos': '远距离对话',
      'Astral Advance': '星极进升',
      'Astral Advent': '星极临',
      'Astral Glow': '星极炽光',
      'Astral Impact': '星击',
      'Buster': '死刑',
      'Caloric Theory': '热质说',
      'Crush Helm': '星天爆击打',
      'Demi Parhelion': '亚幻日',
      '(?<!(Apo|Peri))Dialogos': '对话',
      'Divine Excoriation': '神罚',
      'Dynamic Atmosphere': '冲风',
      'Ekpyrosis': '宇宙火劫',
      'Engravement of Souls': '灵魂刻印',
      'Entropic Excess': '焦热波',
      'Factor In': '因子还原',
      'Gaiaochos': '大地之主',
      'Geocentrism': '地心说',
      'Glaukopis': '明眸',
      'Ignorabimus': '我仍将一无所知',
      'Implode': '自我毁灭',
      'Missing Link': '苦痛锁链',
      'On the Soul': '论灵魂',
      'Palladian Grasp': '帕拉斯之手',
      'Palladian Ray': '帕拉斯射线',
      'Palladion': '女神的护佑',
      'Pangenesis': '泛生论',
      'Panta Rhei': '万物流变',
      'Paradeigma': '范式',
      'Parthenos': '贞女',
      'Peridialogos': '近距离对话',
      'Polarized Ray': '偏振射线',
      'Pyre Pulse': '重热波',
      'Ray of Light': '光波',
      'Sample': '贪食',
      'Searing Radiance': '飞光',
      'Shadowsear': '影伤',
      'Shock': '放电',
      'Summon Darkness': '黑暗召唤',
      'Superchain Burst': '超链爆发',
      'Superchain Coil': '超链回环',
      'Superchain Theory I(?!I)': '超链理论I',
      'Superchain Theory IIA': '超链理论IIA',
      'Superchain Theory IIB': '超链理论IIB',
      'The Classical Concepts': '元素理念',
      'Theos\'s Cross': '神之十字',
      'Theos\'s Holy': '神之神圣',
      'Theos\'s Saltire': '神之交错',
      'Theos\'s Ultima': '神之究极',
      'Trinity of Souls': '三魂一体',
      '(?<! )Ultima(?! (B|R))': '究极',
      'Ultima Blade': '究极之刃',
      'Ultima Blow': '究极强击',
      'Ultima Ray': '究极射线',
      'Umbral Advance': '灵极进升',
      'Umbral Advent': '灵极临',
      'Umbral Glow': '灵极炽光',
      'Umbral Impact': '灵击',
      'Unnatural Enchainment': '灵魂链',
      'White Flame': '白火'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '(?<! )Athena': '아테나',
      'Anthropos': '안트로포스',
      'Concept of Earth': '땅의 개념',
      'Concept of Fire': '불의 개념',
      'Concept of Water': '물의 개념',
      'Forbidden Factor': '금기 인자',
      'Hemitheos': '헤미테오스',
      'Pallas Athena': '팔라스 아테나',
      'Thymou Idea': '기개의 이데아'
    },
    'replaceText': {
      '\\(Floor Drop\\)': '(바닥 사라짐)',
      '\\(cast\\)': '(시전)',
      '\\(proximity\\)': '(근접)',
      '\\(spread\\)': '(산개)',
      '--tethers--': '--선--',
      'Apodialogos': '원거리 디아로고스',
      'Astral Advance': '별빛 촉진',
      'Astral Advent': '별빛 강림',
      'Astral Glow': '별빛 생장',
      'Astral Impact': '별빛 충격',
      'Buster': '버스터',
      'Caloric Theory': '열소설',
      'Crush Helm': '성천폭격타',
      'Demi Parhelion': '버금 무리해',
      '(?<!(Apo|Peri))Dialogos': '디아로고스',
      'Divine Excoriation': '신벌',
      'Dynamic Atmosphere': '충격풍',
      'Ekpyrosis': '에크피로시스',
      'Engravement of Souls': '영혼의 각인',
      'Entropic Excess': '초열파',
      'Factor In': '인자 환원',
      'Gaiaochos': '대지의 주인',
      'Geocentrism': '천동설',
      'Glaukopis': '글라우코피스',
      'Ignorabimus': '이그노라비무스',
      'Implode': '자기 붕괴',
      'Missing Link': '고통의 사슬',
      'On the Soul': '영혼에 관하여',
      'Palladian Grasp': '팔라스의 손',
      'Palladian Ray': '팔라스의 광휘',
      'Palladion': '팔라디온',
      'Pangenesis': '범생설',
      'Panta Rhei': '만물유전',
      'Paradeigma': '파라데이그마',
      'Parthenos': '파르테노스',
      'Peridialogos': '근거리 디아로고스',
      'Polarized Ray': '극성 광선',
      'Pyre Pulse': '중열파',
      'Ray of Light': '빛살',
      'Sample': '남식',
      'Searing Radiance': '불사르는 빛',
      'Shadowsear': '불사르는 어둠',
      'Shock': '방전',
      'Summon Darkness': '어둠 소환',
      'Superchain Burst': '초사슬 폭발',
      'Superchain Coil': '초사슬 고리',
      'Superchain Theory I(?!I)': '초사슬 이론 I',
      'Superchain Theory IIA': '초사슬 이론 IIA',
      'Superchain Theory IIB': '초사슬 이론 IIB',
      'The Classical Concepts': '원소 이데아',
      'Theos\'s Cross': '테오스 십자 불길',
      'Theos\'s Holy': '테오스 홀리',
      'Theos\'s Saltire': '테오스 교차 불길',
      'Theos\'s Ultima': '테오스 알테마',
      'Trinity of Souls': '삼위일혼',
      '(?<! )Ultima(?! (B|R))': '알테마',
      'Ultima Blade': '알테마 블레이드',
      'Ultima Blow': '알테마 공격',
      'Ultima Ray': '알테마 광선',
      'Umbral Advance': '그림자 촉진',
      'Umbral Advent': '그림자 강림',
      'Umbral Glow': '그림자 생장',
      'Umbral Impact': '그림자 충격',
      'Unnatural Enchainment': '영혼의 사슬',
      'White Flame': '하얀 불꽃'
    }
  }]
};
/* harmony default export */ const p12s = (p12s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p12s.txt
const raid_p12s_namespaceObject = "### P12S: Anabaseios: The Twelfth Circle (Savage)\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n### Phase 1: Athena\r\n# -ii 8677 8314 8350 82F0 8308 8309 8331 8313\r\n# -p 8304:11.1\r\n# -it \"Athena\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n1.0 \"--sync--\" AddedCombatant { npcNameId: \"12383\", name: \"Hemitheos\", job: \"00\", level: \"5A\", ownerId: \"0{4}\", worldId: \"00\" } window 10,3 jump 1000.5 # Sync to P2 immediately through AddCombatant.\r\n11.1 \"On the Soul\" Ability { id: \"8304\", source: \"Athena\" } window 20,20\r\n21.2 \"Paradeigma 1\" Ability { id: \"82ED\", source: \"Athena\" }\r\n24.3 \"--middle--\" Ability { id: \"8315\", source: \"Athena\" }\r\n36.7 \"Trinity of Souls 1\" Ability { id: [\"82E7\", \"82E8\"], source: \"Athena\" }\r\n36.7 \"White Flame\" Ability { id: \"82EF\", source: \"Anthropos\" }\r\n39.3 \"Trinity of Souls 2\" Ability { id: [\"82E9\", \"82EA\"], source: \"Athena\" }\r\n41.7 \"White Flame\" Ability { id: \"82EF\", source: \"Anthropos\" }\r\n41.9 \"Trinity of Souls 3\" Ability { id: [\"82EB\", \"82EC\"], source: \"Athena\" }\r\n\r\n57.3 \"Paradeigma 2\" Ability { id: \"82ED\", source: \"Athena\" }\r\n65.0 \"Engravement of Souls\" Ability { id: \"8305\", source: \"Athena\" }\r\n74.8 \"Searing Radiance/Shadowsear\" Ability { id: \"82F[12]\", source: \"Anthropos\" }\r\n75.8 \"Astral Glow/Umbral Glow\" Ability { id: \"830[CD]\", source: \"Athena\" }\r\n78.8 \"Astral Advance/Umbral Advance\" Ability { id: \"830[EF]\", source: \"Anthropos\" }\r\n81.8 \"Ray of Light\" Ability { id: \"82EE\", source: \"Anthropos\" }\r\n\r\n88.8 \"On the Soul\" Ability { id: \"8304\", source: \"Athena\" }\r\n97.0 \"Glaukopis 1\" Ability { id: \"82FC\", source: \"Athena\" }\r\n100.0 \"Glaukopis 2\" Ability { id: \"82FD\", source: \"Athena\" }\r\n\r\n116.1 \"Superchain Theory I\" Ability { id: \"82DA\", source: \"Athena\" }\r\n123.2 \"Engravement of Souls\" Ability { id: \"8305\", source: \"Athena\" }\r\n128.2 \"Superchain Coil/Superchain Burst\" Ability { id: \"82D[BC]\", source: \"Athena\" }\r\n134.3 \"Polarized Ray\" Ability { id: \"8307\", source: \"Athena\" }\r\n135.2 \"Superchain Coil/Superchain Burst\" Ability { id: \"82D[BC]\", source: \"Athena\" }\r\n135.5 \"Astral Impact/Umbral Impact\" Ability { id: \"830[89]\", source: \"Athena\" }\r\n140.2 \"Superchain Coil/Superchain Burst\" #Ability { id: \"82D[BC]\", source: \"Athena\" }\r\n142.2 \"Superchain Coil/Superchain Burst\" #Ability { id: \"82D[BC]\", source: \"Athena\" }\r\n143.5 \"Astral Glow/Umbral Glow\" Ability { id: \"830[CD]\", source: \"Athena\" }\r\n145.2 \"Theos's Holy\" Ability { id: \"8306\", source: \"Athena\" }\r\n146.4 \"Astral Advance/Umbral Advance\" Ability { id: \"830[FE]\", source: \"Anthropos\" }\r\n\r\n157.4 \"Trinity of Souls 1\" Ability { id: [\"82E7\", \"82E8\", \"82E1\", \"82E2\"], source: \"Athena\" }\r\n160.1 \"Trinity of Souls 2\" Ability { id: [\"82E9\", \"82EA\"], source: \"Athena\" }\r\n162.7 \"Trinity of Souls 3\" Ability { id: [\"82EB\", \"82EC\", \"82E5\", \"82E6\"], source: \"Athena\" }\r\n\r\n171.1 \"Apodialogos/Peridialogos\" Ability { id: \"830[01]\", source: \"Athena\" }\r\n172.1 \"Dialogos\" Ability { id: \"8302\", source: \"Athena\" }\r\n178.8 \"On the Soul\" Ability { id: \"8304\", source: \"Athena\" }\r\n190.0 \"--middle--\" Ability { id: \"8315\", source: \"Athena\" }\r\n195.3 \"Paradeigma 3\" Ability { id: \"82ED\", source: \"Athena\" }\r\n202.4 \"Engravement of Souls\" Ability { id: \"8305\", source: \"Athena\" }\r\n212.5 \"Shock\" Ability { id: \"8312\", source: \"Athena\" }\r\n213.6 \"Sample\" Ability { id: \"82E0\", source: \"Athena\" }\r\n213.7 \"Searing Radiance/Shadowsear\" Ability { id: \"82F[12]\", source: \"Anthropos\" }\r\n220.5 \"Theos's Saltire/Theos's Cross\" Ability { id: \"830[AB]\", source: \"Athena\" }\r\n220.7 \"White Flame\" Ability { id: \"82EF\", source: \"Anthropos\" }\r\n220.8 \"Astral Glow/Umbral Glow\" Ability { id: \"830[CD]\", source: \"Athena\" }\r\n223.8 \"Astral Advance/Umbral Advance\" Ability { id: \"830[EF]\", source: \"Anthropos\" }\r\n\r\n229.8 \"On the Soul\" Ability { id: \"8304\", source: \"Athena\" }\r\n242.1 \"Glaukopis 1\" Ability { id: \"82FC\", source: \"Athena\" }\r\n245.2 \"Glaukopis 2\" Ability { id: \"82FD\", source: \"Athena\" }\r\n254.3 \"--middle--\" Ability { id: \"8315\", source: \"Athena\" }\r\n259.9 \"--sync--\" Ability { id: \"82F3\", source: \"Athena\" }\r\n267.3 \"Ultima Blade\" Ability { id: \"82F4\", source: \"Athena\" }\r\n280.0 \"--untargetable--\"\r\n\r\n# Laser/Cleave order is random here so we can only really timeline the Palladion dashes.\r\n290.6 \"Palladion 1\" Ability { id: \"82F6\", source: \"Athena\" } window 1.5,0.5\r\n293.7 \"Palladion 2\" Ability { id: \"82F6\", source: \"Athena\" } window 1.5,0.5\r\n296.8 \"Palladion 3\" Ability { id: \"82F6\", source: \"Athena\" } window 1.5,0.5\r\n299.9 \"Palladion 4\" Ability { id: \"82F6\", source: \"Athena\" } window 1.5,0.5\r\n303.0 \"Palladion 5\" Ability { id: \"82F6\", source: \"Athena\" } window 1.5,0.5\r\n306.1 \"Palladion 6\" Ability { id: \"82F6\", source: \"Athena\" } window 1.5,0.5\r\n309.2 \"Palladion 7\" Ability { id: \"82F6\", source: \"Athena\" } window 1.5,0.5\r\n312.4 \"Palladion 8\" Ability { id: \"82F6\", source: \"Athena\" } window 1.5,0.5\r\n317.5 \"--sync--\" Ability { id: \"82F8\", source: \"Athena\" }\r\n321.5 \"Palladion (Floor Drop)\" Ability { id: \"82F9\", source: \"Athena\" } window 20,20\r\n\r\n324.4 \"--targetable--\"\r\n333.2 \"Theos's Ultima\" Ability { id: \"82FA\", source: \"Athena\" }\r\n352.6 \"Superchain Theory IIA\" Ability { id: \"86FA\", source: \"Athena\" }\r\n365.7 \"Trinity of Souls 1\" Ability { id: [\"82E7\", \"82E8\", \"82E1\", \"82E2\"], source: \"Athena\" }\r\n368.3 \"Trinity of Souls 2\" Ability { id: [\"82E9\", \"82EA\"], source: \"Athena\" }\r\n370.7 \"Trinity of Souls 3\" Ability { id: [\"82EB\", \"82EC\", \"82E5\", \"82E6\"], source: \"Athena\" }\r\n374.0 \"Superchain Coil/Superchain Burst\" Ability { id: \"82D[BC]\", source: \"Athena\" }\r\n\r\n380.2 \"Apodialogos/Peridialogos\" Ability { id: \"830[01]\", source: \"Athena\" }\r\n381.2 \"Dialogos\" Ability { id: \"8302\", source: \"Athena\" }\r\n387.9 \"On the Soul\" Ability { id: \"8304\", source: \"Athena\" }\r\n395.1 \"--middle--\" Ability { id: \"8315\", source: \"Athena\" }\r\n402.5 \"Superchain Theory IIB\" Ability { id: \"86FB\", source: \"Athena\" }\r\n408.6 \"Paradeigma 4\" Ability { id: \"82ED\", source: \"Athena\" }\r\n415.6 \"Superchain Coil/Superchain Burst\" Ability { id: \"82D[BC]\", source: \"Athena\" }\r\n418.6 \"Parthenos\" Ability { id: \"8303\", source: \"Athena\" }\r\n422.5 \"Superchain Coil/Superchain Burst\" Ability { id: \"82D[BC]\", source: \"Athena\" }\r\n424.9 \"Ray of Light\" Ability { id: \"82EE\", source: \"Anthropos\" }\r\n431.5 \"Superchain Coil/Superchain Burst\" Ability { id: \"82D[BC]\", source: \"Athena\" }\r\n\r\n434.3 \"Unnatural Enchainment\" Ability { id: \"82DF\", source: \"Athena\" }\r\n435.4 \"Sample\" Ability { id: \"82E0\", source: \"Athena\" }\r\n442.4 \"On the Soul\" Ability { id: \"8304\", source: \"Athena\" }\r\n450.5 \"On the Soul\" Ability { id: \"8304\", source: \"Athena\" }\r\n459.0 \"--untargetable--\" StartsUsing { id: \"8556\", source: \"Athena\" }\r\n466.0 \"Theos's Ultima (enrage)\" Ability { id: \"8556\", source: \"Athena\" }\r\n\r\n\r\n### Phase 2: Pallas Athena\r\n# -p 8682:1012.1\r\n# -ii 8678 831C 831D 879F 832C 87A0 8334 8325 8323 833D 8792 833E 86FD 831F 8683 8320 8322 8340 8328 834D 86F5 8337 8339 8341 8332 8335\r\n\r\n1007.1 \"--sync--\" StartsUsing { id: \"8682\", source: \"Pallas Athena\" } window 1100,10\r\n1012.1 \"Ultima 1\" Ability { id: \"8682\", source: \"Pallas Athena\" }\r\n1024.2 \"Palladian Grasp 1\" Ability { id: \"831A\", source: \"Pallas Athena\" }\r\n1027.4 \"Palladian Grasp 2\" Ability { id: \"831B\", source: \"Pallas Athena\" }\r\n1040.8 \"Gaiaochos 1\" Ability { id: \"8326\", source: \"Pallas Athena\" }\r\n1051.9 \"Summon Darkness\" Ability { id: \"832F\", source: \"Pallas Athena\" }\r\n1059.0 \"--tethers--\"\r\n1063.8 \"Ultima Ray\" Ability { id: \"8330\", source: \"Hemitheos\" }\r\n\r\n1065.1 \"Missing Link\" Ability { id: \"8586\", source: \"Pallas Athena\" }\r\n1074.1 \"Demi Parhelion\" Ability { id: \"8327\", source: \"Pallas Athena\" }\r\n1084.2 \"Geocentrism\" Ability { id: \"832[AB9]\", source: \"Pallas Athena\" }\r\n1085.2 \"Divine Excoriation\" Ability { id: \"832E\", source: \"Pallas Athena\" }\r\n\r\n1094.4 \"Ultima 2\" Ability { id: \"86F6\", source: \"Pallas Athena\" }\r\n1108.6 \"The Classical Concepts 1\" Ability { id: \"8331\", source: \"Pallas Athena\" }\r\n1130.0 \"Implode\" Ability { id: \"8333\", source: \"Concept of Water\" }\r\n1133.4 \"Palladian Ray\" Ability { id: \"8324\", source: \"Pallas Athena\" } duration 4\r\n\r\n1143.8 \"Ultima 3\" Ability { id: \"8682\", source: \"Pallas Athena\" }\r\n1153.0 \"--sync--\" Ability { id: \"8317\", source: \"Pallas Athena\" }\r\n1153.8 \"Crush Helm 1\" #Ability { id: \"8318\", source: \"Pallas Athena\" }\r\n1154.9 \"Crush Helm 2\" #Ability { id: \"8318\", source: \"Pallas Athena\" }\r\n1156.0 \"Crush Helm 3\" #Ability { id: \"8318\", source: \"Pallas Athena\" }\r\n1157.1 \"Crush Helm 4\" #Ability { id: \"8318\", source: \"Pallas Athena\" }\r\n1159.2 \"Crush Helm Buster\" Ability { id: \"8319\", source: \"Pallas Athena\" }\r\n\r\n1173.2 \"Caloric Theory 1\" Ability { id: \"8338\", source: \"Pallas Athena\" }\r\n1185.9 \"Pyre Pulse 1\" Ability { id: \"833A\", source: \"Pallas Athena\" }\r\n1197.3 \"Pyre Pulse 2\" Ability { id: \"833A\", source: \"Pallas Athena\" }\r\n1197.3 \"Dynamic Atmosphere\" Ability { id: \"833B\", source: \"Pallas Athena\" }\r\n\r\n1207.6 \"Ekpyrosis (cast)\" Ability { id: \"831E\", source: \"Pallas Athena\" }\r\n1215.4 \"Ekpyrosis (proximity)\" Ability { id: \"8683\", source: \"Pallas Athena\" }\r\n1218.5 \"Ekpyrosis (spread)\" Ability { id: \"8322\", source: \"Pallas Athena\" }\r\n\r\n1226.8 \"Ultima 4\" Ability { id: \"8682\", source: \"Pallas Athena\" }\r\n1241.0 \"Pangenesis\" Ability { id: \"833F\", source: \"Pallas Athena\" }\r\n\r\n1254.9 \"Astral Advent/Umbral Advent 1\" Ability { id: \"834[34]\", source: \"Hemitheos\" }\r\n1260.0 \"Astral Advent/Umbral Advent 2\" Ability { id: \"834[34]\", source: \"Hemitheos\" }\r\n1265.0 \"Astral Advent/Umbral Advent 3\" Ability { id: \"834[34]\", source: \"Hemitheos\" }\r\n1277.4 \"Factor In\" Ability { id: \"8347\", source: \"Forbidden Factor\" }\r\n1280.4 \"Palladian Grasp 1\" Ability { id: \"831A\", source: \"Pallas Athena\" }\r\n1283.6 \"Palladian Grasp 2\" Ability { id: \"831B\", source: \"Pallas Athena\" }\r\n\r\n1296.8 \"The Classical Concepts 2\" Ability { id: \"8331\", source: \"Pallas Athena\" }\r\n1313.9 \"Panta Rhei\" Ability { id: \"8336\", source: \"Pallas Athena\" }\r\n1322.7 \"Palladian Ray\" Ability { id: \"8324\", source: \"Pallas Athena\" } duration 4\r\n1325.2 \"Implode\" Ability { id: \"8333\", source: \"Concept of Water\" }\r\n\r\n1333.1 \"Ultima 5\" Ability { id: \"8682\", source: \"Pallas Athena\" }\r\n1342.2 \"--sync--\" Ability { id: \"8317\", source: \"Pallas Athena\" }\r\n1343.0 \"Crush Helm 1\" #Ability { id: \"8318\", source: \"Pallas Athena\" }\r\n1344.1 \"Crush Helm 2\" #Ability { id: \"8318\", source: \"Pallas Athena\" }\r\n1345.2 \"Crush Helm 3\" #sync / 1[56]:[^:]*:Pallas Athena:8318:\r\n1346.3 \"Crush Helm 4\" #Ability { id: \"8318\", source: \"Pallas Athena\" }\r\n1348.4 \"Crush Helm Buster\" Ability { id: \"8319\", source: \"Pallas Athena\" }\r\n\r\n1362.5 \"Caloric Theory 2\" Ability { id: \"8338\", source: \"Pallas Athena\" }\r\n1369.3 \"Entropic Excess 1\" Ability { id: \"833C\", source: \"Pallas Athena\" } window 1.5,1.5\r\n1372.3 \"Entropic Excess 2\" Ability { id: \"833C\", source: \"Pallas Athena\" } window 1.5,1.5\r\n1375.3 \"Entropic Excess 3\" Ability { id: \"833C\", source: \"Pallas Athena\" } window 1.5,1.5\r\n1378.3 \"Entropic Excess 4\" Ability { id: \"833C\", source: \"Pallas Athena\" } window 1.5,1.5\r\n1381.3 \"Entropic Excess 5\" Ability { id: \"833C\", source: \"Pallas Athena\" } window 1.5,1.5\r\n1384.3 \"Entropic Excess 6\" Ability { id: \"833C\", source: \"Pallas Athena\" } window 1.5,1.5\r\n1387.3 \"Entropic Excess 7\" Ability { id: \"833C\", source: \"Pallas Athena\" } window 1.5,1.5\r\n1390.3 \"Entropic Excess 8\" Ability { id: \"833C\", source: \"Pallas Athena\" } window 1.5,1.5\r\n1390.3 \"Dynamic Atmosphere\" Ability { id: \"833B\", source: \"Pallas Athena\" }\r\n\r\n1392.6 \"Ekpyrosis (cast)\" Ability { id: \"831E\", source: \"Pallas Athena\" }\r\n1400.4 \"Ekpyrosis (proximity)\" Ability { id: \"8683\", source: \"Pallas Athena\" }\r\n1403.5 \"Ekpyrosis (spread)\" Ability { id: \"8322\", source: \"Pallas Athena\" }\r\n\r\n1411.7 \"Ultima 6\" Ability { id: \"8682\", source: \"Pallas Athena\" }\r\n1425.9 \"Gaiaochos 2\" Ability { id: \"8326\", source: \"Pallas Athena\" }\r\n1437.0 \"Summon Darkness\" Ability { id: \"832F\", source: \"Pallas Athena\" }\r\n1443.1 \"Demi Parhelion\" Ability { id: \"8327\", source: \"Pallas Athena\" }\r\n1448.1 \"--tethers--\"\r\n1453.2 \"Geocentrism\" Ability { id: \"832[AB9]\", source: \"Pallas Athena\" }\r\n1453.8 \"Ultima Ray\" Ability { id: \"8330\", source: \"Hemitheos\" }\r\n1454.0 \"Missing Link\" Ability { id: \"8586\", source: \"Pallas Athena\" }\r\n1457.1 \"Divine Excoriation\" Ability { id: \"832E\", source: \"Pallas Athena\" }\r\n\r\n1465.2 \"Summon Darkness\" Ability { id: \"832F\", source: \"Pallas Athena\" }\r\n1476.2 \"Ultima Blow\" #Ability { id: \"8348\", source: \"Hemitheos\" }\r\n1480.4 \"Ultima 7\" Ability { id: \"86F6\", source: \"Pallas Athena\" }\r\n1490.1 \"Ultima Blow\" #Ability { id: \"8348\", source: \"Hemitheos\" }\r\n1494.6 \"Ultima 8\" Ability { id: \"86F6\", source: \"Pallas Athena\" }\r\n\r\n1508.4 \"--sync--\" StartsUsing { id: \"8349\", source: \"Pallas Athena\" } window 30,30\r\n1523.4 \"Ignorabimus\" Ability { id: \"8349\", source: \"Pallas Athena\" }\r\n\r\n\r\n### Ability Chart\r\n#\r\n## Phase 1\r\n#\r\n# Athena:8677 auto\r\n# Athena:8304 On the Soul, cast and damage\r\n# Athena:82ED Paradeigma, cast and self-targeted\r\n# Athena:8315 unknown unnamed ability (recentering?)\r\n# Athena:82E1 Trinity of Souls, top right first wing cast and damage\r\n# Athena:82E2 Trinity of Souls, top left first wing cast and damage\r\n# Athena:82E3 Trinity of Souls, middle right second wing (top down) damage\r\n# Athena:82E4 Trinity of Souls, middle left second wing (top down) damage\r\n# Athena:82E5 Trinity of Souls, bottom right third wing damage\r\n# Athena:82E6 Trinity of Souls, bottom left third wing damage\r\n# Athena:82E7 Trinity of Souls, bottom right first wing cast and damage\r\n# Athena:82E8 Trinity of Souls, top right first wing cast and damage\r\n# Athena:82E9 Trinity of Souls, middle right second wing (bottom up) damage\r\n# Athena:82EA Trinity of Souls, middle left second wing (bottom up) damage\r\n# Athena:82EB Trinity of Souls, top right third wing damage\r\n# Athena:82EC Trinity of Souls, top left third wing damage\r\n# Thymou Idea:8314, untargeted unnamed ability, White Flame add positioning?\r\n# Anthropos:82EF White Flame, self-targeted ability\r\n# Anthropos:82F0 White Flame, damage\r\n# Athena:82ED Paradeigma, cast and self-targeted ability\r\n# Epithymias Idea :8314 (yes a space in name??), unnamed untargeted tether add positioning\r\n# Logou Idea:8314, unnamed untargeted Ray add positioning\r\n# Athena:8305 Engravement of Souls, cast and self-targeted ability for debuffs\r\n# Athena:8350 Polarized Glow, self-targeted ability\r\n# Anthropos:82F1 Searing Radiance, light tether damage\r\n# Anthropos:82F2 Shadowsear, dark tether damage\r\n# Athena:830C Umbral Glow, placing a light tower damage\r\n# Athena:830D Astral Glow, placing a dark tower damage\r\n# Anthropos:830E Umbral Advance, taking a light tower damage\r\n# Anthropos:830F Astral Advance, taking a dark tower damage\r\n# Anthropos:8331 Unmitigated Explosion, wipe damage for failing towers\r\n# Anthropos:82EE Ray of Light, laser damage\r\n# Athena:82FC Glaukopis, tankbuster cast and damage first hit\r\n# Athena:82FD Glaukopis, tankbuster damage second hit\r\n# Athena:82DA Superchain Theory I, cast and self-targeted ability\r\n# Athena:82DE Superchain Emission, 2x stack damage\r\n# Athnea:82DF Superchain Radiation, protean damage\r\n# Athena:82DB Superchain Burst, \"get out\" sphere damage\r\n# Athena:82DC Superchain Coil, \"get in\" donut damage\r\n# Athena:8307 Polarized Ray, self-targeted ability (before 8308/8309)\r\n# Athena:8308 Umbral Impact, light laser damage\r\n# Athena:8309 Astral Impact, dark laser damage\r\n# Athena:8306 Theos's Holy, spread damage\r\n# Athena:82FE Apodialogos, cast and self-targeted\r\n# Athena:82FF Peridialogos, cast and self-targeted\r\n# Athnea:8300 Apodialogos, tank damage\r\n# Athena:8301 Peridialogos, tank damage\r\n# Athena:8302 Dialogos, shared party damage\r\n# Athena:8312 Shock, unaspected tower damage\r\n# Athena:8313 Electrify, raidwide failure damage for not taking an 8312 tower\r\n# Athena:82DF Unnatural Enchainment, cast and self-targeted prior to Sample\r\n# Athena:82E0 Sample, damage from platforms breaking\r\n# Athena:830A Theos's Cross, cast and damage from cross ground aoe\r\n# Athena:830B Theos's Saltire, cast and damage from rotated cross ground aoe\r\n# Athena:82F3 Ultima Blade, self-targeted prior to real aoe\r\n# Athena:82F4 Ultima Blade, aoe damage\r\n# Athena:82F6 Palladion, circle damage\r\n# Athena:82F7 Shockwave, proximity charge damage\r\n# Anthropos:82FB Clear Cut, ground aoe damage from middle circle (White Flame alternative)\r\n# Athena:82F8 Palladion, self-targeted after all Palladion damage is done\r\n# Athena:82F9 Palladion, damage from breaking ground\r\n# Athena:82FA Theos's Ultima, cast and damage\r\n# Athena:86FA Superchain Theory IIA, cast and self-targeted\r\n# Athena:86FB Superchain Theory IIB, cast and self-targeted\r\n# Athena:8303 Parthenos, line aoe damage\r\n# Athena:8556 Theos's Ultima, cast and damage for enrage\r\n# Athena:834C unnamed ability transition to phase 2 (targetable in ~61.3s after this)\r\n#\r\n## Phase 2\r\n#\r\n# Pallas Athena:8678 auto (initial)\r\n# Pallas Athena:86F5 auto (Gaiochos)\r\n# Pallas Athena:8682 Ultima, cast and damage\r\n# Pallas Athena:86F6 Ultima, cast and damage (Gaiochos)\r\n# Pallas Athena:87A0 Ultima, self-targeted (Gaiochos, comes slightly after 86F6 damage?)\r\n# Pallas Athena:831A Palladian Grasp, self-targeted 1\r\n# Pallas Athena:831B Palladian Grasp, self-targeted 2\r\n# Pallas Athena:831C Palladian Grasp, damage west side\r\n# Pallas Athena:831D Palladian Grasp, damage east side\r\n# Pallas Athena:834D unknown unnamed, probably Gaiaochos effect\r\n# Pallas Athena:8326 Gaiaochos, cast and damage\r\n# Pallas Athena:879F Gaiaochos, self-targeted (comes slightly after 8326 damage?)\r\n# Pallas Athena:832F Summon Darkness, creates 1 or 3 Hemitheos adds\r\n# Hemitheos:8330 Ultima Ray, cast and damage laser from adds\r\n# Pallas Atena:8586 Missing Link, ability with no target ~after chains break\r\n# Pallas Athena:8327 Demi Parhelion, cast and self-targeted\r\n# Pallas Athena:8328 Demi Parhelion, cast and damage for 9x circles\r\n# Pallas Athena:8329 Geocentrism, cast and self-targeted, vertical version\r\n# Pallas Athena:832A Geocentrism, cast and self-targeted, circle version\r\n# Pallas Athena:832B Geocentrism, cast and self-targeted, horizontal version\r\n# Pallas Athena:832C Demi Parhelion, fire damage during Geocentrism\r\n# Pallas Athena:832E Divine Excoriation, spread damage during Demi Parhelion/Geocentrism\r\n# Pallas Athena:8331 The Classical Concepts, cast and damage\r\n# Concept of Fire:8334 Aspect Effect, untargeted ability, maybe tethering?\r\n# Concept of Earth:8334 Aspect Effect, untargeted ability, maybe tethering?\r\n# Concept of Fire:8333 Implode, ground circle (triangle? square?)\r\n# Concept of Earth:8333 Implode, ground circle (triangle? square?)\r\n# Concept of Water:8333 Implode, ground circle (icosahedron)\r\n# Pallas Athena:8332 Fusion Burst, failing shape tethers and having shapes combine\r\n# Pallas Athena:8335 Tilted Balance, damage for failed tether distance\r\n# Pallas Athena:8323 Palladian Ray, self-targeted ability, protean sword drop\r\n# Pallas Athena:8324 Palladian Ray, damage, first protean hit\r\n# Pallas Athena:8325 Palladian Ray, damage, avoidable followup proteans\r\n# Pallas Athena:8317 Crush Helm, cast and self-targeted buster\r\n# Pallas Athena:8318 Crush Helm, first four damage hits on tanks (non-cleaving)\r\n# Pallas Athena:8319 Crush Helm, final damage hit on tank (non-cleaving)\r\n# Pallas Athena:8338 Caloric Theory, cast and damage\r\n# Pallas Athena:833D Caloric Theory, self-targeted only for Caloric Theory 1\r\n# Pallas Athena:86FD Pyre Pulse, self-targeted ability for 833A\r\n# Pallas Athena:833A Pyre Pulse, 2 person stack damage for fires\r\n# Pallas Athena:833B Dynamic Atmosphere, wind donut explosion damage\r\n# Pallas Athena:8339 Unmitigated Explosion, wipe damage for failing to do Caloric Theory right\r\n# Pallas Athena:831E Ekpyrosis, cast and self-targeted for exaflare mechanic\r\n# Pallas Athena:831F Ekpyrosis, cast and damage for initial exaflare circles\r\n# Pallas Athena:8683 Ekpyrosis, cast and damage for proximity damage\r\n# Pallas Athena:8320 Ekpyrosis, damage for ongoing exaflare circles\r\n# Pallas Athena:8322 Ekpyrosis, spread damage during exaflares\r\n# Pallas Athena:833F Pangenesis, cast and damage\r\n# Pallas Athena:8342 Pantheos, cast and self-targeted ability\r\n# Hemitheos:8343 Umbral Advent, tower\r\n# Hemitheos:8344 Astral Advent, tower\r\n# Pallas Athena:8340 Biochemical Factor, two people merging?\r\n# Pallas Athena:8341 Ex-factor, wipe damage for failing to cleanse Unstable Factor\r\n# Forbidden Factor:8347 Factor In, slime damage\r\n# Pallas Athena:8336 Panta Rhei, cast and self-targeted \"swap places\" mechanic\r\n# Concept of Fire:8337 Panta Rhei, untargeted \"swap places\" ability\r\n# Concept of Earth:8337 Panta Rhei, untargeted \"swap places\" ability\r\n# Concept of Water:8337 Panta Rhei, untargeted \"swap places\" ability\r\n# Pallas Athena:833E Caloric Theory, cast and damage on initial spread person\r\n# Pallas Athena:8792 Caloric Theory, cast and damage for initial wind donut\r\n# Pallas Athena:833C Entropic Excess, cast and ground targeted circles\r\n# Pallas Athena:8339 Unmitigated Explosion, caloric theory failure\r\n# Hemitheos:8348 Ultima Blow, tether laser damage during Gaiaochos 2\r\n# Pallas Athena:8349 Ignorabimus, enrage cast and damage\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p1n.ts




// TODO: Intemperance calls out a 4th time; should only call out three
// TODO: Right/Left + Fire/Light happen at the same time later; collect these together
const p1n_triggerSet = {
  id: 'AsphodelosTheFirstCircle',
  zoneId: zone_id/* default.AsphodelosTheFirstCircle */.Z.AsphodelosTheFirstCircle,
  timelineFile: 'p1n.txt',
  triggers: [{
    // Also happens during Aetherflail Right (65DF)
    id: 'P1N Gaoler\'s Flail Right',
    type: 'StartsUsing',
    netRegex: {
      id: '6DA2',
      source: 'Erichthonios',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    // Also happens during Aetherflail Left (65E0)
    id: 'P1N Gaoler\'s Flail Left',
    type: 'StartsUsing',
    netRegex: {
      id: '6DA3',
      source: 'Erichthonios',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'P1N Warder\'s Wrath',
    type: 'StartsUsing',
    netRegex: {
      id: '65F4',
      source: 'Erichthonios',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P1N Shining Cells',
    type: 'StartsUsing',
    netRegex: {
      id: '65E9',
      source: 'Erichthonios',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P1N Slam Shut',
    type: 'StartsUsing',
    netRegex: {
      id: '65EA',
      source: 'Erichthonios',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P1N Pitiless Flail KB',
    type: 'HeadMarker',
    netRegex: {
      id: '0001'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'P1N Pitiless Flail Stack',
    type: 'HeadMarker',
    netRegex: {
      id: '003E',
      capture: false
    },
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }, {
    id: 'P1N Intemperance',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['AB3', 'AB4'],
      capture: true
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => {
      return _matches.effectId === 'AB3' ? output.red() : output.blue();
    },
    outputStrings: {
      red: {
        en: 'Get hit by red',
        de: 'Von Rot treffen lassen',
        fr: 'Faites-vous toucher par le rouge',
        ja: '炎に当たる',
        cn: '去吃火',
        ko: '빨간색 맞기'
      },
      blue: {
        en: 'Get hit by blue',
        de: 'Von Blau treffen lassen',
        fr: 'Faites-vous toucher par le bleu',
        ja: '氷に当たる',
        cn: '去吃冰',
        ko: '파란색 맞기'
      }
    }
  }, {
    id: 'P1N Heavy Hand',
    type: 'StartsUsing',
    netRegex: {
      id: '65F3',
      source: 'Erichthonios'
    },
    condition: conditions/* default.caresAboutPhysical */.Z.caresAboutPhysical(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'P1N Powerful Light',
    type: 'GainsEffect',
    netRegex: {
      effectId: '893',
      capture: true
    },
    alertText: (_data, matches, output) => {
      if (matches.count === '14C') return output.light();
      return output.fire();
    },
    outputStrings: {
      fire: {
        en: 'Stand on fire',
        de: 'Auf der Feuerfläche stehen',
        fr: 'Placez-vous sur le feu',
        ja: '炎の床へ',
        cn: '站在火',
        ko: '빨간색 바닥 위에 서기'
      },
      light: {
        en: 'Stand on light',
        de: 'Auf der Lichtfläche stehen',
        fr: 'Placez-vous sur la lumière',
        ja: '光の床へ',
        cn: '站在光',
        ko: '흰색 바닥 위에 서기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Gaoler\'s Flail Left/Gaoler\'s Flail Right': 'Gaoler\'s Flail Left/Right',
      'Gaoler\'s Flail Right/Gaoler\'s Flail Left': 'Gaoler\'s Flail Right/Left',
      'Hot Spell/Cold Spell': 'Hot/Cold Spell',
      'Powerful Fire/Powerful Light': 'Powerful Fire/Light',
      'Aetherflail Left/Aetherflail Right': 'Aetherflail Left/Right',
      'Aetherflail Right/Aetherflail Left': 'Aetherflail Right/Left'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Erichthonios': 'Erichthonios'
    },
    'replaceText': {
      '--knockback stack--': '--Rückstoß sammeln--',
      'Aetherchain': 'Berstende Ketten',
      'Aetherflail Left': 'Apodiktische Zucht Links',
      'Aetherflail Right': 'Apodiktische Zucht Rechts',
      'Cold Spell': 'Entfesselter Frost',
      'Gaoler\'s Flail Left': 'Eiserne Zucht Links',
      'Gaoler\'s Flail Right': 'Eiserne Zucht Rechts',
      'Heavy Hand': 'Marter',
      'Hot Spell': 'Entfesseltes Feuer',
      'Intemperance': 'Zehrende Elemente',
      'Intemperate Torment': 'Zehrende Vollstreckung',
      'Pitiless Flail': 'Zucht und Ordnung',
      'Powerful Fire': 'Entladenes Feuer',
      'Powerful Light': 'Entladenes Licht',
      'Shining Cells': 'Ätherzwinger',
      'Slam Shut': 'Freigang',
      'True Holy': 'Vollkommenes Sanctus',
      'Warder\'s Wrath': 'Kettenmagie'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Erichthonios': 'Érichthonios'
    },
    'replaceText': {
      '--knockback stack--': '--package poussée--',
      'Aetherchain': 'Chaînes explosives',
      'Aetherflail Left/Aetherflail Right': 'Chaîne de rétribution gauche/droite',
      'Aetherflail Right/Aetherflail Left': 'Chaîne de rétribution droite/gauche',
      'Gaoler\'s Flail Left/Gaoler\'s Flail Right': 'Chaîne punitive gauche/droite',
      'Gaoler\'s Flail Right/Gaoler\'s Flail Left': 'Chaîne punitive droite/gauche',
      'Heavy Hand': 'Chaîne de supplice',
      'Hot Spell/Cold Spell': 'Déchaînement de feu/glace',
      'Intemperance': 'Corrosion élémentaire',
      'Intemperate Torment': 'Exécution corrosive',
      'Pitiless Flail': 'Chaîne transperçante',
      'Powerful Fire/Powerful Light': 'Explosion infernale/sacrée',
      'Shining Cells': 'Geôle limbique',
      'Slam Shut': 'Occlusion terminale',
      'True Holy': 'Miracle véritable',
      'Warder\'s Wrath': 'Chaînes torrentielles'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Erichthonios': 'エリクトニオス'
    },
    'replaceText': {
      'Aetherchain': '爆鎖',
      'Aetherflail': '懲罰爆鎖',
      'Cold Spell': '魔力解放・氷',
      'Gaoler\'s Flail': '懲罰撃',
      'Heavy Hand': '痛撃',
      'Hot Spell': '魔力解放・火',
      'Intemperance': '氷火の侵食',
      'Intemperate Torment': '侵食執行',
      'Pitiless Flail': '懲罰連撃',
      'Powerful Fire': '炎爆',
      'Powerful Light': '光爆',
      'Shining Cells': '光炎監獄',
      'Slam Shut': '監獄閉塞',
      'True Holy': 'トゥルー・ホーリー',
      'Warder\'s Wrath': '魔鎖乱流'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Erichthonios': '埃里克特翁尼亚斯'
    },
    'replaceText': {
      '--knockback stack--': '--集合击退--',
      'Aetherchain': '爆锁',
      'Aetherflail Left': '左惩罚爆锁',
      'Aetherflail Right': '右惩罚爆锁',
      'Cold Spell': '魔力解放·冰',
      'Gaoler\'s Flail Left': '左惩罚抽击',
      'Gaoler\'s Flail Right': '右惩罚抽击',
      'Heavy Hand': '掌掴',
      'Hot Spell': '魔力解放·火',
      'Intemperance': '冰火侵蚀',
      'Intemperate Torment': '侵蚀发动',
      'Pitiless Flail': '惩罚连击',
      'Powerful Fire': '炎爆',
      'Powerful Light': '光爆',
      'Shining Cells': '光炎监狱',
      'Slam Shut': '监狱封闭',
      'True Holy': '纯正神圣',
      'Warder\'s Wrath': '魔锁乱流'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Erichthonios': '에리크토니오스'
    },
    'replaceText': {
      '--knockback stack--': '--넉백 쉐어--',
      'Aetherchain': '폭쇄',
      'Aetherflail Left/Aetherflail Right': '징벌 폭쇄 왼쪽/오른쪽',
      'Aetherflail Right/Aetherflail Left': '징벌 폭쇄 오른쪽/왼쪽',
      'Gaoler\'s Flail Left/Gaoler\'s Flail Right': '징벌격 왼쪽/오른쪽',
      'Gaoler\'s Flail Right/Gaoler\'s Flail Left': '징벌격 오른쪽/왼쪽',
      'Heavy Hand': '통격',
      'Hot Spell/Cold Spell': '마력 해방: 불/얼음',
      'Intemperance': '얼음불 침식',
      'Intemperate Torment': '침식 집행',
      'Pitiless Flail': '징벌 연격',
      'Powerful Fire': '염폭',
      'Powerful Light': '광폭',
      'Shining Cells': '광염 감옥',
      'Slam Shut': '감옥 폐쇄',
      'True Holy': '진 홀리',
      'Warder\'s Wrath': '사슬난류'
    }
  }]
};
/* harmony default export */ const p1n = (p1n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p1n.txt
const raid_p1n_namespaceObject = "### P1N: Asphodelos: The First Circle\r\n#\r\n# -ii 65F2 65E6 65DA 65D9 65E0 65DF\r\n\r\n# Note: Gaoler's Flail cast is reworded to Aetherflail (65E0|65DF) in the\r\n# timeline as that is the cast that is visible. However, damage is from the\r\n# Gaoler's Flail (6DA3|6DA2) cast end after.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n\r\n## First Gaoler's Flail\r\n8.7 \"--sync--\" StartsUsing { id: [\"6DA3\", \"6DA2\"], source: \"Erichthonios\" } window 10,9\r\n17.4 \"Gaoler's Flail Left/Gaoler's Flail Right\" Ability { id: [\"6DA3\", \"6DA2\"], source: \"Erichthonios\" }\r\n28.5 \"Gaoler's Flail Right/Gaoler's Flail Left\" Ability { id: [\"6DA2\", \"6DA3\"], source: \"Erichthonios\" }\r\n39.0 \"Warder's Wrath\" Ability { id: \"65F4\", source: \"Erichthonios\" }\r\n46.2 \"--knockback stack--\" Ability { id: \"6D15\", source: \"Erichthonios\" }\r\n51.5 \"Pitiless Flail\" Ability { id: \"65E5\", source: \"Erichthonios\" }\r\n58.6 \"True Holy\" Ability { id: \"65E7\", source: \"Erichthonios\" }\r\n\r\n## Third Gaoler's Flail\r\n70.5 \"Gaoler's Flail Left/Gaoler's Flail Right\" Ability { id: [\"6DA3\", \"6DA2\"], source: \"Erichthonios\" }\r\n81.1 \"Heavy Hand\" Ability { id: \"65F3\", source: \"Erichthonios\" }\r\n93.2 \"Intemperance\" Ability { id: \"65EE\", source: \"Erichthonios\" }\r\n97.3 \"--middle--\" Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n105.1 \"Intemperate Torment\" Ability { id: \"65EF\", source: \"Erichthonios\" }\r\n107.7 \"Hot Spell/Cold Spell 1\" Ability { id: [\"65F0\", \"54F1\"], source: \"Erichthonios\" }\r\n116.7 \"Hot Spell/Cold Spell 2\" Ability { id: [\"6CC5\", \"6CC6\"], source: \"Erichthonios\" }\r\n125.7 \"Hot Spell/Cold Spell 3\" Ability { id: [\"6CC5\", \"6CC6\"], source: \"Erichthonios\" }\r\n135.3 \"Warder's Wrath\" Ability { id: \"65F4\", source: \"Erichthonios\" }\r\n147.6 \"Heavy Hand\" Ability { id: \"65F3\", source: \"Erichthonios\" }\r\n162.7 \"Shining Cells\" Ability { id: \"65E9\", source: \"Erichthonios\" }\r\n174.9 \"Aetherchain\" Ability { id: \"65EB\", source: \"Erichthonios\" }\r\n175.8 \"Powerful Fire/Powerful Light\" Ability { id: [\"65EC\", \"65ED\"], source: \"Erichthonios\" }\r\n183.1 \"Aetherchain\" Ability { id: \"65EB\", source: \"Erichthonios\" }\r\n184.0 \"Powerful Fire/Powerful Light\" Ability { id: [\"65EC\", \"65ED\"], source: \"Erichthonios\" }\r\n\r\n## Beginning of Loop\r\n188.3 \"--middle--\" Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n\r\n# Fourth Gaoler's Flail\r\n198.7 \"Aetherflail Left/Aetherflail Right\" Ability { id: [\"6DA3\", \"6DA2\"], source: \"Erichthonios\" }\r\n198.8 \"Powerful Fire/Powerful Light\" Ability { id: [\"65EC\", \"65ED\"], source: \"Erichthonios\" }\r\n209.8 \"Aetherflail Right/Aetherflail Left\" Ability { id: [\"6DA2\", \"6DA3\"], source: \"Erichthonios\" }\r\n209.9 \"Powerful Fire/Powerful Light\" Ability { id: [\"65EC\", \"65ED\"], source: \"Erichthonios\" }\r\n214.3 \"--knockback stack--\" Ability { id: \"6D15\", source: \"Erichthonios\" }\r\n219.6 \"Pitiless Flail\" Ability { id: \"65E5\", source: \"Erichthonios\" }\r\n226.7 \"True Holy\" Ability { id: \"65E7\", source: \"Erichthonios\" }\r\n232.9 \"--middle--\" Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n\r\n# Sixth Gaoler's Flail\r\n243.3 \"Aetherflail Left/Aetherflail Right\" Ability { id: [\"6DA3\", \"6DA2\"], source: \"Erichthonios\" }\r\n243.4 \"Powerful Fire/Powerful Light\" Ability { id: [\"65EC\", \"65ED\"], source: \"Erichthonios\" }\r\n260.8 \"Slam Shut\" Ability { id: \"65EA\", source: \"Erichthonios\" }\r\n270.0 \"Intemperance\" Ability { id: \"65EE\", source: \"Erichthonios\" }\r\n274.1 \"--middle--\" Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n281.7 \"Intemperate Torment\" Ability { id: \"65EF\", source: \"Erichthonios\" }\r\n284.3 \"Hot Spell/Cold Spell 1\" Ability { id: [\"65F0\", \"54F1\"], source: \"Erichthonios\" }\r\n293.3 \"Hot Spell/Cold Spell 2\" Ability { id: [\"6CC5\", \"6CC6\"], source: \"Erichthonios\" }\r\n302.3 \"Hot Spell/Cold Spell 3\" Ability { id: [\"6CC5\", \"6CC6\"], source: \"Erichthonios\" }\r\n305.6 \"Gaoler's Flail Right/Gaoler's Flail Left\" Ability { id: [\"6DA2\", \"6DA3\"], source: \"Erichthonios\" }\r\n316.1 \"Warder's Wrath\" Ability { id: \"65F4\", source: \"Erichthonios\" }\r\n327.3 \"Warder's Wrath\" Ability { id: \"65F4\", source: \"Erichthonios\" }\r\n336.6 \"Heavy Hand\" Ability { id: \"65F3\", source: \"Erichthonios\" }\r\n355.8 \"Shining Cells\" Ability { id: \"65E9\", source: \"Erichthonios\" }\r\n\r\n# Repeat\r\n360.0 \"--middle--\" Ability { id: \"65F5\", source: \"Erichthonios\" } window 50,50 jump 188.3\r\n370.3 \"Aetherflail Left/Aetherflail Right\" #Ability { id: [\"6DA3\", \"6DA2\"], source: \"Erichthonios\" }\r\n370.4 \"Powerful Fire/Powerful Light\" #Ability { id: [\"65EC\", \"65ED\"], source: \"Erichthonios\" }\r\n381.4 \"Aetherflail Right/Aetherflail Left\" #Ability { id: [\"6DA2\", \"6DA3\"], source: \"Erichthonios\" }\r\n381.5 \"Powerful Fire/Powerful Light\" #Ability { id: [\"65EC\", \"65ED\"], source: \"Erichthonios\" }\r\n385.9 \"--knockback stack--\" #Ability { id: \"6D15\", source: \"Erichthonios\" }\r\n391.2 \"Pitiless Flail\" #Ability { id: \"65E5\", source: \"Erichthonios\" }\r\n398.3 \"True Holy\" #Ability { id: \"65E7\", source: \"Erichthonios\" }\r\n404.5 \"--middle--\" #Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p1s.ts





// TODO: Fixup Intemperance callouts
// TODO: Add Aetherflail callouts to Powerful Light/Fire
const flailDirections = {
  l: outputs/* default.left */.Z.left,
  r: outputs/* default.right */.Z.right,
  combo: {
    en: '${first} => ${second}',
    de: '${first} => ${second}',
    fr: '${first} => ${second}',
    ja: '${first} => ${second}',
    cn: '${first} => ${second}',
    ko: '${first} => ${second}'
  }
};
const fireLightOutputStrings = {
  fire: {
    en: 'Stand on fire',
    de: 'Auf der Feuerfläche stehen',
    fr: 'Placez-vous sur le feu',
    ja: '炎の床へ',
    cn: '站在火',
    ko: '빨간 바닥으로'
  },
  light: {
    en: 'Stand on light',
    de: 'Auf der Lichtfläche stehen',
    fr: 'Placez-vous sur la lumière',
    ja: '光の床へ',
    cn: '站在光',
    ko: '흰 바닥으로'
  }
};
const p1s_triggerSet = {
  id: 'AsphodelosTheFirstCircleSavage',
  zoneId: zone_id/* default.AsphodelosTheFirstCircleSavage */.Z.AsphodelosTheFirstCircleSavage,
  timelineFile: 'p1s.txt',
  timelineTriggers: [{
    id: 'P1S Tile Positions',
    regex: /(?:First|Second|Third) Element/,
    beforeSeconds: 3,
    infoText: (_data, _matches, output) => output.positions(),
    outputStrings: {
      positions: {
        en: 'Tile Positions',
        de: 'Flächen-Positionen',
        fr: 'Positions sur les cases',
        ja: '自分の担当マスへ',
        cn: '上自己的方块',
        ko: '담당 타일로'
      }
    }
  }],
  triggers: [{
    id: 'P1S Warder\'s Wrath',
    type: 'StartsUsing',
    netRegex: {
      id: '662A',
      source: 'Erichthonios',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P1S Shackles of Companionship',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'AB6'
    },
    preRun: (data, matches) => data.companionship = matches.target,
    durationSeconds: (_data, matches) => parseFloat(matches.duration) - 2,
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.closeShacklesOnYou();
    },
    outputStrings: {
      closeShacklesOnYou: {
        en: 'Close Shackles on YOU',
        de: 'Nahe Fesseln auf DIR',
        fr: 'Chaînes proches sur VOUS',
        ja: '紫鎖（近い方）',
        cn: '紫锁（近）点名',
        ko: '안쪽 쇠사슬(보라색)'
      }
    }
  }, {
    id: 'P1S Shackles of Loneliness',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'AB7'
    },
    preRun: (data, matches) => data.loneliness = matches.target,
    durationSeconds: (_data, matches) => parseFloat(matches.duration) - 2,
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.farShacklesOnYou();
    },
    outputStrings: {
      farShacklesOnYou: {
        en: 'Far Shackles on YOU',
        de: 'Entfernte Fesseln auf DIR',
        fr: 'Chaînes éloignées sur VOUS',
        ja: '赤鎖（遠い方）',
        cn: '红锁（远）点名',
        ko: '바깥쪽 쇠사슬(빨간색)'
      }
    }
  }, {
    // Callout the other shackle(s) at info level
    id: 'P1S Aetherial Shackles Callout',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'AB[67]'
    },
    condition: data => data.companionship !== undefined && data.loneliness !== undefined,
    durationSeconds: (_data, matches) => parseFloat(matches.duration) - 2,
    infoText: (data, _matches, output) => {
      if (data.companionship === data.me) return output.farShacklesOn({
        far: data.party.member(data.loneliness)
      });
      if (data.loneliness === data.me) return output.closeShacklesOn({
        close: data.party.member(data.companionship)
      });
      return output.shacklesOn({
        close: data.party.member(data.companionship),
        far: data.party.member(data.loneliness)
      });
    },
    tts: (data, _matches, output) => {
      if (data.companionship === data.me || data.loneliness === data.me) return null;
      return output.shacklesOn({
        close: data.party.member(data.companionship),
        far: data.party.member(data.loneliness)
      });
    },
    run: data => {
      delete data.companionship;
      delete data.loneliness;
    },
    outputStrings: {
      closeShacklesOn: {
        en: 'Close Shackles on ${close}',
        de: 'Nahe Fesseln auf ${close}',
        fr: 'Chaînes proches sur ${close}',
        ja: '紫鎖（近い方）：${close}',
        cn: '紫锁（近）：${close}',
        ko: '안쪽 쇠사슬: ${close}'
      },
      farShacklesOn: {
        en: 'Far Shackles on ${far}',
        de: 'Entfernte Fesseln auf ${far}',
        fr: 'Chaînes éloignées sur ${far}',
        ja: '赤鎖（遠い方）：${far}',
        cn: '红锁（远）：${far}',
        ko: '바깥쪽 쇠사슬: ${far}'
      },
      shacklesOn: {
        en: 'Close: ${close}, Far: ${far}',
        de: 'Nahe: ${close}, Entfernt: ${far}',
        fr: 'Proches : ${close}, Éloignées : ${far}',
        ja: '紫鎖（近い方）：${close}、赤鎖（遠い方）：${far}',
        cn: '紫锁（近）：${close}、红锁（远）：${far}',
        ko: '안쪽: ${close}, 바깥쪽: ${far}'
      }
    }
  }, {
    id: 'P1S Shining Cells',
    type: 'StartsUsing',
    netRegex: {
      id: '6616',
      source: 'Erichthonios',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P1S Slam Shut',
    type: 'StartsUsing',
    netRegex: {
      id: '6617',
      source: 'Erichthonios',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P1S Gaoler\'s Flail Left => Right',
    type: 'StartsUsing',
    netRegex: {
      id: '65F6',
      source: 'Erichthonios',
      capture: false
    },
    alertText: (_data, _matches, output) => output.combo({
      first: output.l(),
      second: output.r()
    }),
    outputStrings: flailDirections
  }, {
    id: 'P1S Gaoler\'s Flail Right => Left',
    type: 'StartsUsing',
    netRegex: {
      id: '65F7',
      source: 'Erichthonios',
      capture: false
    },
    alertText: (_data, _matches, output) => output.combo({
      first: output.r(),
      second: output.l()
    }),
    outputStrings: flailDirections
  }, {
    id: 'P1S Gaoler\'s Flail Out => In',
    type: 'StartsUsing',
    netRegex: {
      id: ['65F8', '65F9'],
      source: 'Erichthonios',
      capture: false
    },
    alertText: (_data, _matches, output) => output.outThenIn(),
    outputStrings: {
      outThenIn: outputs/* default.outThenIn */.Z.outThenIn
    }
  }, {
    id: 'P1S Gaoler\'s Flail In => Out',
    type: 'StartsUsing',
    netRegex: {
      id: ['65FA', '65FB'],
      source: 'Erichthonios',
      capture: false
    },
    alertText: (_data, _matches, output) => output.inThenOut(),
    outputStrings: {
      inThenOut: outputs/* default.inThenOut */.Z.inThenOut
    }
  }, {
    id: 'P1S Heavy Hand',
    type: 'StartsUsing',
    netRegex: {
      id: '6629',
      source: 'Erichthonios'
    },
    condition: conditions/* default.caresAboutPhysical */.Z.caresAboutPhysical(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'P1S Pitiless Flail of Grace',
    type: 'StartsUsing',
    netRegex: {
      id: '660E',
      source: 'Erichthonios',
      capture: false
    },
    alertText: (_data, _matches, output) => output.directions(),
    outputStrings: {
      directions: {
        en: 'Tankbuster+Knockback => Stack',
        de: 'Tankbuster+Rückstoß => Sammeln',
        fr: 'Tank buster + Poussée => Packez-vous',
        ja: 'タンクバスター+ノックバック => 頭割り',
        cn: '坦克死刑+击退 => 分摊',
        ko: '탱버 + 넉백 => 쉐어'
      }
    }
  }, {
    id: 'P1S Pitiless Flail of Purgation',
    type: 'StartsUsing',
    netRegex: {
      id: '660F',
      source: 'Erichthonios',
      capture: false
    },
    alertText: (_data, _matches, output) => output.directions(),
    outputStrings: {
      directions: {
        en: 'Tankbuster+Knockback => Flare',
        de: 'Tankbuster+Rückstoß => Flare',
        fr: 'Tank buster + Poussée => Brasier',
        ja: 'タンクバスター+ノックバック => フレア',
        cn: '坦克死刑+击退 => 核爆',
        ko: '탱버 + 넉백 => 플레어'
      }
    }
  }, {
    id: 'P1S Intemperate Torment Bottom',
    type: 'StartsUsing',
    netRegex: {
      id: '661F',
      source: 'Erichthonios',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bottom First',
        de: 'Unten zuerst',
        fr: 'Cube inférieur en premier',
        ja: '下から',
        cn: '底部开始',
        ko: '아래부터'
      }
    }
  }, {
    id: 'P1S Intemperate Torment Top',
    type: 'StartsUsing',
    netRegex: {
      id: '6620',
      source: 'Erichthonios',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Top First',
        de: 'Oben zuerst',
        fr: 'Cube supérieur en premier',
        ja: '上から',
        cn: '顶部开始',
        ko: '위부터'
      }
    }
  },
  // Copy/paste from normal, seems to be the same
  {
    id: 'P1S Hot/Cold Spell',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['AB3', 'AB4']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, matches, output) => {
      return matches.effectId === 'AB3' ? output.red() : output.blue();
    },
    outputStrings: {
      red: {
        en: 'Get hit by red',
        de: 'Von Rot treffen lassen',
        fr: 'Faites-vous toucher par le rouge',
        ja: '炎に当たる',
        cn: '去吃火',
        ko: '빨간색 맞기'
      },
      blue: {
        en: 'Get hit by blue',
        de: 'Von Blau treffen lassen',
        fr: 'Faites-vous toucher par le bleu',
        ja: '氷に当たる',
        cn: '去吃冰',
        ko: '파란색 맞기'
      }
    }
  }, {
    id: 'P1S Powerful Light/Fire',
    type: 'GainsEffect',
    netRegex: {
      effectId: '893'
    },
    preRun: (data, matches) => {
      data.safeColor = matches.count === '14C' ? 'light' : 'fire';
    },
    alertText: (data, _matches, output) => data.safeColor && output[data.safeColor](),
    outputStrings: fireLightOutputStrings
  }, {
    id: 'P1S Shackles of Time',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'AB5'
    },
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.oppositeParty();
      return output.oppositePlayer({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      oppositePlayer: {
        en: 'Opposite color of ${player}',
        de: 'Gegenteilige Farbe von ${player}',
        fr: 'Couleur opposée de ${player}',
        ja: '${player}と反対の色へ',
        cn: '${player}的相反颜色',
        ko: '${player}의 반대 색으로'
      },
      oppositeParty: {
        en: 'Opposite color of Party',
        de: 'Gegenteilige Farbe von der Party',
        fr: 'Couleur opposée à l\'équipe',
        ja: '他のメンバーと反対の色へ',
        cn: '其他队友的相反颜色',
        ko: '혼자 반대 색으로'
      }
    }
  }, {
    id: 'P1S Fourfold Shackles of Companionship 1',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B45'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: (_data, matches) => parseFloat(matches.duration),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Close (3s)',
        de: 'Nahe (3s)',
        fr: 'Proches (3s)',
        ja: '紫鎖（近い方） (3s)',
        cn: '紫锁 (近) (3秒)',
        ko: '안쪽#1 (3초)'
      }
    }
  }, {
    id: 'P1S Fourfold Shackles of Companionship 2',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B46'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: (_data, matches) => parseFloat(matches.duration),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Close (8s)',
        de: 'Nahe (8s)',
        fr: 'Proches (8s)',
        ja: '紫鎖（近い方） (8s)',
        cn: '紫锁 (近) (8秒)',
        ko: '안쪽#2 (8초)'
      }
    }
  }, {
    id: 'P1S Fourfold Shackles of Companionship 3',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B47'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: (_data, matches) => parseFloat(matches.duration),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Close (13s)',
        de: 'Nahe (13s)',
        fr: 'Proches (13s)',
        ja: '紫鎖（近い方） (13s)',
        cn: '紫锁 (近) (13秒)',
        ko: '안쪽#3 (13초)'
      }
    }
  }, {
    id: 'P1S Fourfold Shackles of Companionship 4',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B6B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: (_data, matches) => parseFloat(matches.duration),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Close (18s)',
        de: 'Nahe (18s)',
        fr: 'Proches (18s)',
        ja: '紫鎖（近い方） (18s)',
        cn: '紫锁 (近) (18秒)',
        ko: '안쪽#4 (18초)'
      }
    }
  }, {
    id: 'P1S Fourfold Shackles of Loneliness 1',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B48'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: (_data, matches) => parseFloat(matches.duration),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Far (3s)',
        de: 'Entfernt (3s)',
        fr: 'Éloignées (3s)',
        ja: '赤鎖（遠い方） (3s)',
        cn: '红锁 (远) (3秒)',
        ko: '바깥쪽#1 (3초)'
      }
    }
  }, {
    id: 'P1S Fourfold Shackles of Loneliness 2',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B49'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: (_data, matches) => parseFloat(matches.duration),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Far (8s)',
        de: 'Entfernt (8s)',
        fr: 'Éloignées (8s)',
        ja: '赤鎖（遠い方） (8s)',
        cn: '红锁 (远) (8秒)',
        ko: '바깥쪽#2 (8초)'
      }
    }
  }, {
    id: 'P1S Fourfold Shackles of Loneliness 3',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B4A'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: (_data, matches) => parseFloat(matches.duration),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Far (13s)',
        de: 'Entfernt (13s)',
        fr: 'Éloignées (13s)',
        ja: '赤鎖（遠い方） (13s)',
        cn: '红锁 (远) (13秒)',
        ko: '바깥쪽#3 (13초)'
      }
    }
  }, {
    id: 'P1S Fourfold Shackles of Loneliness 4',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B6C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: (_data, matches) => parseFloat(matches.duration),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Far (18s)',
        de: 'Entfernt (18s)',
        fr: 'Éloignées (18s)',
        ja: '赤鎖（遠い方） (18s)',
        cn: '红锁 (远) (18秒)',
        ko: '바깥쪽#4 (18초)'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Pitiless Flail of Grace/Pitiless Flail of Purgation': 'Flail of Grace/Purgation',
      'True Flare/True Holy': 'True Flare/Holy',
      'Powerful Fire/Powerful Light': 'Powerful Fire/Light',
      'Inevitable Flame/Inevitable Light': 'Inevitable Flame/Light'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Erichthonios': 'Erichthonios'
    },
    'replaceText': {
      'Aetherchain': 'Berstende Ketten',
      'Aetherial Shackles': 'Fluchesketten',
      'Chain Pain': 'Verfluchte Vollstreckung',
      'First Element': 'Erstes Element',
      'Fourfold Shackles': 'Vierfache Fluchesketten',
      'Gaoler\'s Flail(?! [IO])': 'Eiserne Zucht',
      'Gaoler\'s Flail In/Out': 'Eiserne Zucht Rein/Raus',
      'Gaoler\'s Flail Out/In': 'Eiserne Zucht Raus/Rein',
      'Heavy Hand': 'Marter',
      'Inevitable Flame': 'Aspektiertes Feuer',
      'Inevitable Light': 'Aspektiertes Licht',
      'Intemperance': 'Zehrende Elemente',
      'Intemperate Torment': 'Zehrende Vollstreckung',
      'Lethe': 'Schloss und Riegel',
      'Pitiless Flail of Grace': 'Heilige Zucht und Ordnung',
      'Pitiless Flail of Purgation': 'Feurige Zucht und Ordnung',
      'Powerful Fire': 'Entladenes Feuer',
      'Powerful Light': 'Entladenes Licht',
      'Second Element': 'Zweites Element',
      'Shackles of Time': 'Aspektierende Ketten',
      'Shining Cells': 'Ätherzwinger',
      'Slam Shut': 'Freigang',
      'Third Element': 'Drittes Element',
      'True Flare': 'Vollkommenes Flare',
      'True Holy': 'Vollkommenes Sanctus',
      'Warder\'s Wrath': 'Kettenmagie'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Erichthonios': 'Érichthonios'
    },
    'replaceText': {
      '\\?': ' ?',
      'Aetherchain': 'Chaînes explosives',
      '(?<!/)Aetherial Shackles': 'Chaîne de malédiction',
      'Chain Pain': 'Exécution maudite',
      'First Element': 'Premier élément',
      'Fourfold Shackles': 'Chaîne de malédiction quadruple',
      'Gaoler\'s Flail(?! [IO])': 'Chaîne punitive',
      'Gaoler\'s Flail In/Out': 'Chaîne intérieur/extérieur',
      'Gaoler\'s Flail Out/In': 'Chaîne extérieur/intérieur',
      'Heavy Hand': 'Chaîne de supplice',
      'Inevitable Flame/Inevitable Light': 'Explosion à retardement',
      'Intemperance': 'Corrosion élémentaire',
      'Intemperate Torment': 'Exécution corrosive',
      'Lethe': 'Descente aux limbes',
      'Pitiless Flail of Grace(?!/)': 'Chaîne transperçante sacrée',
      'Pitiless Flail of Grace/Pitiless Flail of Purgation': 'Chaîne sacrée/infernale',
      'Powerful Fire/Powerful Light': 'Explosion infernale/sacrée',
      'Second Element': 'Deuxième élément',
      'Shackles of Time(?!/)': 'Chaîne à retardement',
      'Shackles of Time/Aetherial Shackles': 'Chaîne à retardement/malédiction',
      'Shining Cells': 'Geôle limbique',
      'Slam Shut': 'Occlusion terminale',
      'Third Element': 'Troisième élément',
      'True Flare/True Holy': 'Brasier/Miracle véritable',
      'Warder\'s Wrath': 'Chaînes torrentielles'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Erichthonios': 'エリクトニオス'
    },
    'replaceText': {
      'Aetherchain': '爆鎖',
      'Aetherial Shackles': '結呪の魔鎖',
      'Chain Pain': '結呪執行',
      'Fourfold Shackles': '結呪の四連魔鎖',
      'Gaoler\'s Flail': '懲罰撃',
      'Heavy Hand': '痛撃',
      'Inevitable Flame': '時限炎爆',
      'Inevitable Light': '時限光爆',
      'Intemperance': '氷火の侵食',
      'Intemperate Torment': '侵食執行',
      'Lethe': '辺獄送り',
      'Pitiless Flail of Grace': '懲罰連撃・聖',
      'Pitiless Flail of Purgation': '懲罰連撃・炎',
      'Powerful Fire': '炎爆',
      'Powerful Light': '光爆',
      'Shackles of Time': '時限の魔鎖',
      'Shining Cells': '光炎監獄',
      'Slam Shut': '監獄閉塞',
      'True Flare': 'トゥルー・フレア',
      'True Holy': 'トゥルー・ホーリー',
      'Warder\'s Wrath': '魔鎖乱流'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Erichthonios': '埃里克特翁尼亚斯'
    },
    'replaceText': {
      'Aetherchain': '爆锁',
      'Aetherial Shackles': '结咒魔锁',
      'Chain Pain': '结咒发动',
      'First Element': '第一元素',
      'Fourfold Shackles': '结咒四连魔锁',
      'Gaoler\'s Flail(?! [IO])': '惩罚抽击',
      'Gaoler\'s Flail In/Out': '惩罚抽击 内/外',
      'Gaoler\'s Flail Out/In': '惩罚抽击 外/内',
      'Heavy Hand': '掌掴',
      'Inevitable Flame': '限时炎爆',
      'Inevitable Light': '限时光爆',
      'Intemperance': '冰火侵蚀',
      'Intemperate Torment': '侵蚀发动',
      'Lethe': '边境流刑',
      'Pitiless Flail of Grace': '惩罚连击·圣',
      'Pitiless Flail of Purgation': '惩罚连击·炎',
      'Powerful Fire': '炎爆',
      'Powerful Light': '光爆',
      'Second Element': '第二元素',
      'Shackles of Time': '限时魔锁',
      'Shining Cells': '光炎监狱',
      'Slam Shut': '监狱封闭',
      'Third Element': '第三元素',
      'True Flare': '纯正核爆',
      'True Holy': '纯正神圣',
      'Warder\'s Wrath': '魔锁乱流'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Erichthonios': '에리크토니오스'
    },
    'replaceText': {
      'Aetherchain': '폭쇄',
      'Aetherial Shackles': '결박 사슬',
      'Chain Pain': '결박 집행',
      'First Element': '큐브 폭발 #1',
      'Fourfold Shackles': '4연속 결박 사슬',
      'Gaoler\'s Flail(?! [IO])': '징벌격',
      'Gaoler\'s Flail In/Out': '징벌격 안/밖',
      'Gaoler\'s Flail Out/In': '징벌격 밖/안',
      'Heavy Hand': '통격',
      'Inevitable Flame/Inevitable Light': '시한 염폭/광폭',
      'Intemperance': '얼음불 침식',
      'Intemperate Torment': '침식 집행',
      'Lethe': '변옥 수감',
      'Pitiless Flail of Grace(?!/)': '징벌 연격: 신성',
      'Pitiless Flail of Grace/Pitiless Flail of Purgation': '징벌 연격: 신성/화염',
      'Powerful Fire': '염폭',
      'Powerful Light': '광폭',
      'Second Element': '큐브 폭발 #2',
      'Shackles of Time(?!/)': '시한부 사슬',
      'Shackles of Time/Aetherial Shackles': '시한부/결박 사슬',
      'Shining Cells': '광염 감옥',
      'Slam Shut': '감옥 폐쇄',
      'Third Element': '큐브 폭발 #3',
      'True Flare/True Holy': '진 플레어/홀리',
      'Warder\'s Wrath': '사슬난류'
    }
  }]
};
/* harmony default export */ const p1s = (p1s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p1s.txt
const raid_p1s_namespaceObject = "### P1S: Asphodelos: The First Circle (Savage)\r\n#\r\n# -p 6629:14.1\r\n# -ii 6612 6628 6622 6623 6624 6613 65F6 65F7 65F8 65F9 65FA 65FB 65FC 65FD 65FE 65FF 6600 6601 6602 6603 6606 6607 6608 6609 660A 660B 660C 660D\r\n\r\n# Notes:\r\n# * Chain Pain both 6627/6628, but only sync on one.\r\n# * Hot Spell/Cold Spell are renamed First/Second/Third Element\r\n# * Hot Spell/Cold Spell happen at the same time, so only sync on one.\r\n# * Gaoler's Flail has many different ids, 6F56-6601 and 6DA6-6DAD.\r\n#   6DA6-6DAD appear to be the damage, so consistently use this everywhere and ignore the casts,\r\n#   some of which are for the animation and (maybe?) the weapons dropping which can hit people\r\n#   but doesn't seem to do damage??\r\n# * Aetherflail is 6602 6603 6606 6607 6608 6609 660A 660B 660C 660D and also is paired with\r\n#   Gaoler's Flail 6DA6-6DAD for damage, so for timing consistency skip these as well and use damage.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n# First flail set\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n9.4 \"--sync--\" StartsUsing { id: \"6629\", source: \"Erichthonios\" } window 11,9\r\n14.1 \"Heavy Hand\" Ability { id: \"6629\", source: \"Erichthonios\" }\r\n18.2 \"--sync--\" Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n22.8 \"Aetherial Shackles\" Ability { id: \"6625\", source: \"Erichthonios\" }\r\n31.9 \"Warder's Wrath\" Ability { id: \"662A\", source: \"Erichthonios\" }\r\n41.7 \"Chain Pain\" Ability { id: \"6627\", source: \"Erichthonios\" }\r\n58.5 \"Gaoler's Flail\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" } window 3,2\r\n61.3 \"Gaoler's Flail\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" } window 2,3\r\n\r\n# First tank mechanic\r\n72.1 \"Pitiless Flail of Grace/Pitiless Flail of Purgation\" Ability { id: \"660[EF]\", source: \"Erichthonios\" }\r\n75.5 \"True Flare/True Holy\" Ability { id: \"661[01]\", source: \"Erichthonios\" }\r\n\r\n# Second flail set\r\n91.9 \"Gaoler's Flail\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" } window 3,2\r\n94.7 \"Gaoler's Flail\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" } window 2,3\r\n105.3 \"Warder's Wrath\" Ability { id: \"662A\", source: \"Erichthonios\" }\r\n\r\n# Tiles 1\r\n118.5 \"Intemperance\" Ability { id: \"661E\", source: \"Erichthonios\" }\r\n122.6 \"--sync--\" Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n134.4 \"Intemperate Torment\" Ability { id: [\"661F\", \"6620\"], source: \"Erichthonios\" }\r\n135.3 \"First Element\" Ability { id: \"6621\", source: \"Erichthonios\" }\r\n141.4 \"Warder's Wrath\" Ability { id: \"662A\", source: \"Erichthonios\" }\r\n146.4 \"Second Element\" Ability { id: \"6621\", source: \"Erichthonios\" }\r\n151.6 \"Warder's Wrath\" Ability { id: \"662A\", source: \"Erichthonios\" }\r\n157.3 \"Third Element\" Ability { id: \"6621\", source: \"Erichthonios\" }\r\n\r\n# Second tank mechanic\r\n167.9 \"Pitiless Flail of Grace/Pitiless Flail of Purgation\" Ability { id: \"660[EF]\", source: \"Erichthonios\" }\r\n171.1 \"True Flare/True Holy\" Ability { id: \"661[01]\", source: \"Erichthonios\" }\r\n\r\n# Cells 1\r\n188.2 \"Shining Cells\" Ability { id: \"6616\", source: \"Erichthonios\" }\r\n194.5 \"--sync--\" Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n208.6 \"Powerful Fire/Powerful Light\" Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n208.6 \"Gaoler's Flail\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" }\r\n211.4 \"Powerful Fire/Powerful Light\" Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n211.4 \"Gaoler's Flail\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" }\r\n224.2 \"Pitiless Flail of Grace/Pitiless Flail of Purgation\" Ability { id: \"660[EF]\", source: \"Erichthonios\" }\r\n227.6 \"True Flare/True Holy\" Ability { id: \"661[01]\", source: \"Erichthonios\" }\r\n229.7 \"--sync--\" Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n243.7 \"Powerful Fire/Powerful Light\" Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n243.7 \"Gaoler's Flail\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" }\r\n246.5 \"Powerful Fire/Powerful Light\" Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n246.5 \"Gaoler's Flail\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" }\r\n255.1 \"Shackles of Time\" Ability { id: \"661C\", source: \"Erichthonios\" }\r\n265.3 \"Heavy Hand\" Ability { id: \"6629\", source: \"Erichthonios\" }\r\n270.0 \"Inevitable Flame/Inevitable Light\" Ability { id: \"6EC[12]\", source: \"Erichthonios\" }\r\n278.4 \"Slam Shut\" Ability { id: \"6617\", source: \"Erichthonios\" }\r\n289.6 \"--sync--\" Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n\r\n# Fourfold Shackles\r\n294.2 \"Fourfold Shackles\" Ability { id: \"6626\", source: \"Erichthonios\" }\r\n303.2 \"Chain Pain #1\" Ability { id: \"6627\", source: \"Erichthonios\" }\r\n308.2 \"Chain Pain #2\" Ability { id: \"6627\", source: \"Erichthonios\" }\r\n313.2 \"Chain Pain #3\" Ability { id: \"6627\", source: \"Erichthonios\" }\r\n318.2 \"Chain Pain #4\" Ability { id: \"6627\", source: \"Erichthonios\" }\r\n328.4 \"Warder's Wrath\" Ability { id: \"662A\", source: \"Erichthonios\" }\r\n\r\n# Tiles 2\r\n341.6 \"Intemperance\" Ability { id: \"661E\", source: \"Erichthonios\" }\r\n345.7 \"--sync--\" Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n357.4 \"Intemperate Torment\" Ability { id: [\"661F\", \"6620\"], source: \"Erichthonios\" }\r\n358.6 \"First Element\" Ability { id: \"6621\", source: \"Erichthonios\" }\r\n369.6 \"Second Element\" Ability { id: \"6621\", source: \"Erichthonios\" }\r\n374.0 \"Gaoler's Flail In/Out\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" } window 3,2\r\n376.8 \"Gaoler's Flail Out/In\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" } window 2,3\r\n380.6 \"Third Element\" Ability { id: \"6621\", source: \"Erichthonios\" }\r\n389.4 \"Warder's Wrath\" Ability { id: \"662A\", source: \"Erichthonios\" }\r\n\r\n\r\n# Cells 2 -> branch\r\n407.6 \"Shining Cells\" Ability { id: \"6616\", source: \"Erichthonios\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Shackles of Time first?\r\n417.8 \"Shackles of Time?\" Ability { id: \"661C\", source: \"Erichthonios\" } window 20,20 jump 617.8\r\n425.1 \"Pitiless Flail of Grace/Pitiless Flail of Purgation?\" #Ability { id: \"660[EF]\", source: \"Erichthonios\" }\r\n428.4 \"True Flare/True Holy?\" #Ability { id: \"661[01]\", source: \"Erichthonios\" }\r\n432.8 \"Inevitable Flame/Inevitable Light?\" #Ability { id: \"6EC[12]\", source: \"Erichthonios\" }\r\n441.9 \"Warder's Wrath?\" #Ability { id: \"662A\", source: \"Erichthonios\" }\r\n\r\n# -> Aetherial Shackles first?\r\n417.8 \"Aetherial Shackles?\" Ability { id: \"6625\", source: \"Erichthonios\" } window 20,20 jump 1010.8\r\n428.9 \"Aetherchain?\" #Ability { id: \"6619\", source: \"Erichthonios\" }\r\n429.8 \"Powerful Fire/Powerful Light?\" #Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n436.7 \"Chain Pain?\" #Ability { id: \"6627\", source: \"Erichthonios\" }\r\n438.0 \"Powerful Fire/Powerful Light?\" #Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n447.3 \"Warder's Wrath?\" #Ability { id: \"662A\", source: \"Erichthonios\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Cells 2, Shackles of Time first\r\n617.8 \"Shackles of Time\" Ability { id: \"661C\", source: \"Erichthonios\" }\r\n625.1 \"Pitiless Flail of Grace/Pitiless Flail of Purgation\" Ability { id: \"660[EF]\", source: \"Erichthonios\" }\r\n628.4 \"True Flare/True Holy\" Ability { id: \"661[01]\", source: \"Erichthonios\" }\r\n632.8 \"Inevitable Flame/Inevitable Light\" Ability { id: \"6EC[12]\", source: \"Erichthonios\" }\r\n641.9 \"Warder's Wrath\" Ability { id: \"662A\", source: \"Erichthonios\" }\r\n649.1 \"--sync--\" Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n653.9 \"Aetherial Shackles\" Ability { id: \"6625\", source: \"Erichthonios\" }\r\n665.1 \"Aetherchain\" Ability { id: \"6619\", source: \"Erichthonios\" }\r\n666.0 \"Powerful Fire/Powerful Light\" Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n672.9 \"Chain Pain\" Ability { id: \"6627\", source: \"Erichthonios\" }\r\n674.2 \"Powerful Fire/Powerful Light\" Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n\r\n685.5 \"Warder's Wrath\" Ability { id: \"662A\", source: \"Erichthonios\" } jump 1077.3\r\n692.7 \"--sync--\" #Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n706.8 \"Powerful Fire/Powerful Light\" #Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n706.8 \"Gaoler's Flail\" #Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" }\r\n709.6 \"Powerful Fire/Powerful Light\" #Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n709.6 \"Gaoler's Flail\" #Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" }\r\n\r\n\r\n# Cells 2, Aetherial Shackles first\r\n1010.8 \"Aetherial Shackles\" Ability { id: \"6625\", source: \"Erichthonios\" }\r\n1021.9 \"Aetherchain\" Ability { id: \"6619\", source: \"Erichthonios\" }\r\n1022.8 \"Powerful Fire/Powerful Light\" Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n1029.7 \"Chain Pain\" Ability { id: \"6627\", source: \"Erichthonios\" }\r\n1031.0 \"Powerful Fire/Powerful Light\" Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n1040.3 \"Warder's Wrath\" Ability { id: \"662A\", source: \"Erichthonios\" }\r\n1051.5 \"Shackles of Time\" Ability { id: \"661C\", source: \"Erichthonios\" }\r\n1058.9 \"Pitiless Flail of Grace/Pitiless Flail of Purgation\" Ability { id: \"660[EF]\", source: \"Erichthonios\" }\r\n1062.1 \"True Flare/True Holy\" Ability { id: \"661[01]\", source: \"Erichthonios\" }\r\n1066.4 \"Inevitable Flame/Inevitable Light\" Ability { id: \"6EC[12]\", source: \"Erichthonios\" }\r\n\r\n\r\n# Final section\r\n1077.3 \"Warder's Wrath\" Ability { id: \"662A\", source: \"Erichthonios\" }\r\n1084.5 \"--sync--\" Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n\r\n# Seems to be E/W+In/Out for first two, and last one swaps between In/Out\r\n1098.6 \"Powerful Fire/Powerful Light\" Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n1098.6 \"Gaoler's Flail\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" }\r\n1101.4 \"Powerful Fire/Powerful Light\" Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n1101.4 \"Gaoler's Flail\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" }\r\n\r\n1115.7 \"Powerful Fire/Powerful Light\" Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n1115.7 \"Gaoler's Flail\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" }\r\n1119.5 \"Powerful Fire/Powerful Light\" Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n1119.5 \"Gaoler's Flail\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" }\r\n\r\n1134.2 \"Powerful Fire/Powerful Light\" Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n1134.2 \"Gaoler's Flail\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" }\r\n1137.3 \"Powerful Fire/Powerful Light\" Ability { id: \"661[AB]\", source: \"Erichthonios\" }\r\n1137.3 \"Gaoler's Flail\" Ability { id: \"6DA[2-9A-D]\", source: \"Erichthonios\" }\r\n\r\n# Soft enrage\r\n1152.7 \"Warder's Wrath\" Ability { id: \"662A\", source: \"Erichthonios\" }\r\n1161.9 \"Warder's Wrath\" Ability { id: \"662A\", source: \"Erichthonios\" }\r\n1171.1 \"Warder's Wrath\" Ability { id: \"662A\", source: \"Erichthonios\" }\r\n\r\n1177.0 \"--sync--\" Ability { id: \"65F5\", source: \"Erichthonios\" }\r\n1190.6 \"Lethe (enrage)\" Ability { id: \"6618\", source: \"Erichthonios\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p2n.ts





const p2n_triggerSet = {
  id: 'AsphodelosTheSecondCircle',
  zoneId: zone_id/* default.AsphodelosTheSecondCircle */.Z.AsphodelosTheSecondCircle,
  timelineFile: 'p2n.txt',
  triggers: [{
    id: 'P2N Murky Depths',
    type: 'StartsUsing',
    netRegex: {
      id: '680F',
      source: 'Hippokampos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P2N Doubled Impact',
    type: 'StartsUsing',
    netRegex: {
      id: '680E',
      source: 'Hippokampos'
    },
    response: responses/* Responses.sharedTankBuster */.n3.sharedTankBuster()
  }, {
    id: 'P2N Spoken Cataract',
    type: 'StartsUsing',
    netRegex: {
      id: ['67F8', '67F7', '67F9'],
      source: 'Hippokampos'
    },
    delaySeconds: 1,
    promise: async data => {
      const callData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants'
      });
      if (!callData.combatants.length) {
        console.error('SpokenCataract: failed to get combatants: ${JSON.stringify(callData)}');
        return;
      }
      // This is the real hippo, according to hp.
      const hippos = callData.combatants.filter(c => c.BNpcID === 13721);
      if (hippos.length !== 1) {
        console.error('SpokenCataract: There is not exactly one Hippo?!?: ${JSON.stringify(hippos)}');
        data.bodyActor = undefined;
        return;
      }
      data.bodyActor = hippos[0];
    },
    alertText: (data, matches, output) => {
      if (!data.bodyActor) {
        console.error('SpokenCataract: No boss actor found. Did the promise fail?');
        return;
      }
      // Convert radians into 4 quarters N = 0, E = 1, S = 2, W = 3
      const heading = Math.round(2 - 2 * data.bodyActor.Heading / Math.PI) % 4;
      if (matches.id === '67F8') {
        switch (heading) {
          case 0:
            return output.nc();
          case 1:
            return output.ec();
          case 2:
            return output.sc();
          case 3:
            return output.wc();
        }
      }
      if (matches.id === '67F7') {
        switch (heading) {
          case 0:
            return output.w();
          case 1:
            return output.n();
          case 2:
            return output.e();
          case 3:
            return output.s();
        }
      }
      if (matches.id === '67F9') {
        switch (heading) {
          case 0:
            return output.e();
          case 1:
            return output.s();
          case 2:
            return output.w();
          case 3:
            return output.n();
        }
      }
    },
    outputStrings: {
      n: outputs/* default.north */.Z.north,
      e: outputs/* default.east */.Z.east,
      w: outputs/* default.west */.Z.west,
      s: outputs/* default.south */.Z.south,
      nc: {
        en: 'North Corners',
        de: 'nördliche Ecken',
        fr: 'Au coin nord',
        ja: '北の角へ',
        cn: '去上 (北) 边角落',
        ko: '북쪽 모서리'
      },
      ec: {
        en: 'East Corners',
        de: 'östliche Ecken',
        fr: 'Au coin est',
        ja: '東の角へ',
        cn: '去右 (东) 边角落',
        ko: '동쪽 모서리'
      },
      sc: {
        en: 'South Corners',
        de: 'südliche Ecken',
        fr: 'Au coin sud',
        ja: '南の角へ',
        cn: '去下 (南) 边角落',
        ko: '남쪽 모서리'
      },
      wc: {
        en: 'West Corners',
        de: 'westliche Ecken',
        fr: 'Au coin ouest',
        ja: '西の角へ',
        cn: '去左 (西) 边角落',
        ko: '서쪽 모서리'
      }
    }
  }, {
    id: 'P2N Sewage Deluge',
    type: 'StartsUsing',
    netRegex: {
      id: '67F6',
      source: 'Hippokampos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Spread aoe marker on some players, not all
    id: 'P2N Tainted Flood',
    type: 'StartsUsing',
    netRegex: {
      id: '6809',
      source: 'Hippokampos'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'P2N Predatory Sight',
    type: 'StartsUsing',
    netRegex: {
      id: '680A',
      source: 'Hippokampos',
      capture: false
    },
    delaySeconds: 3,
    response: responses/* Responses.doritoStack */.n3.doritoStack()
  }, {
    id: 'P2N Coherence Flare',
    type: 'HeadMarker',
    // This always comes before 6D14 below for the line stack marker.
    netRegex: {
      id: '0057'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    run: (data, matches) => data.flareTarget = matches.target,
    outputStrings: {
      text: {
        en: 'Flare on YOU',
        de: 'Flare auf DIR',
        fr: 'Brasier sur VOUS',
        ja: '自分にフレア',
        cn: '核爆点名',
        ko: '플레어 대상자'
      }
    }
  }, {
    id: 'P2N Coherence Stack',
    // Coherence (6801) cast has an unknown (6D14) ability with the target before it.
    type: 'Ability',
    netRegex: {
      id: '6D14'
    },
    condition: data => data.flareTarget !== data.me,
    alertText: (data, matches, output) => output.lineStackOn({
      player: data.party.member(matches.target)
    }),
    outputStrings: {
      lineStackOn: {
        en: 'Line stack on ${player}',
        de: 'In einer Linie auf ${player} sammeln',
        fr: 'Packez-vous en ligne sur ${player}',
        ja: '${player}に直線頭割り',
        cn: '${player} 直线分摊',
        ko: '${player} 직선 쉐어'
      }
    }
  }, {
    // Raidwide knockback -> dont get knocked into slurry
    id: 'P2N Shockwave',
    type: 'StartsUsing',
    netRegex: {
      id: '6807',
      source: 'Hippokampos',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    // Aoe from head outside the arena
    id: 'P2N Dissociation',
    type: 'StartsUsing',
    netRegex: {
      id: '6806',
      source: 'Hippokampos'
    },
    alertText: (_data, matches, output) => {
      const xCoord = parseFloat(matches.x);
      if (xCoord > 100) return output.w();
      if (xCoord < 100) return output.e();
    },
    outputStrings: {
      e: outputs/* default.east */.Z.east,
      w: outputs/* default.west */.Z.west
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Hippokampos': 'Hippokampos'
    },
    'replaceText': {
      '\\(knockback\\)': '(Rückstoß)',
      'Coherence Flare': 'Kohärenz Flare',
      'Coherence Line': 'Kohärenz Linie',
      'Dissociation(?! Dive)': 'Dissoziation',
      'Dissociation Dive': 'Dissoziation Sturzflug',
      'Doubled Impact': 'Doppeleinschlag',
      'Murky Depths': 'Trübe Tiefen',
      'Predatory Sight': 'Mal der Beute',
      'Sewage Deluge': 'Abwasserflut',
      'Sewage Eruption': 'Abwassereruption',
      'Shockwave': 'Schockwelle',
      'Spoken Cataract': 'Gehauchter Katarakt',
      'Tainted Flood': 'Verseuchte Flut'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Hippokampos': 'hippokampos'
    },
    'replaceText': {
      '\\(knockback\\)': '(poussée)',
      'Coherence Flare': 'Cohérence Brasier',
      'Coherence Line': 'Cohérence en ligne',
      'Dissociation(?! Dive)': 'Dissociation',
      'Dissociation Dive': 'Dissociation et plongeon',
      'Doubled Impact': 'Double impact',
      'Murky Depths': 'Tréfonds troubles',
      'Predatory Sight': 'Marque de la proie',
      'Sewage Deluge': 'Déluge d\'eaux usées',
      'Sewage Eruption': 'Éruption d\'eaux usées',
      'Shockwave': 'Onde de choc',
      'Spoken Cataract': 'Souffle et cataracte',
      'Tainted Flood': 'Inondation infâme'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Hippokampos': 'ヒッポカムポス'
    },
    'replaceText': {
      'Dissociation': 'ディソシエーション',
      'Doubled Impact': 'ダブルインパクト',
      'Murky Depths': 'マーキーディープ',
      'Predatory Sight': '生餌の刻印',
      'Sewage Deluge': 'スウェッジデリージュ',
      'Sewage Eruption': 'スウェッジエラプション',
      'Shockwave': 'ショックウェーブ',
      'Spoken Cataract': 'ブレス＆カタラクティス',
      'Tainted Flood': 'テインテッドフラッド'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Hippokampos': '鱼尾海马怪'
    },
    'replaceText': {
      '\\(knockback\\)': '(击退)',
      'Coherence Flare': '连贯攻击 (核爆)',
      'Coherence Line': '连贯攻击 (分摊)',
      'Dissociation(?! Dive)': '分离',
      'Dissociation Dive': '分离 (冲锋)',
      'Doubled Impact': '双重冲击',
      'Murky Depths': '深度污浊',
      'Predatory Sight': '活饵的刻印',
      'Sewage Deluge': '污水泛滥',
      'Sewage Eruption': '污水喷发',
      'Shockwave': '震荡波',
      'Spoken Cataract': '吐息飞瀑',
      'Tainted Flood': '污染洪水'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Hippokampos': '히포캄포스'
    },
    'replaceText': {
      '\\(knockback\\)': '(넉백)',
      'Coherence Flare': '간섭 공격 (플레어)',
      'Coherence Line': '간섭 공격 (쉐어)',
      'Dissociation(?! Dive)': '머리 분리',
      'Dissociation Dive': '머리 분리 (돌진)',
      'Doubled Impact': '이중 충격',
      'Murky Depths': '짙은 탁류',
      'Predatory Sight': '먹잇감 각인',
      'Sewage Deluge': '하수 범람',
      'Sewage Eruption': '하수 분출',
      'Shockwave': '충격 파동',
      'Spoken Cataract': '숨결 홍수',
      'Tainted Flood': '오염 침수'
    }
  }]
};
/* harmony default export */ const p2n = (p2n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p2n.txt
const raid_p2n_namespaceObject = "### P2N: Asphodelos: The Second Circle\r\n#\r\n# -ii 6808 680A 6801 680C\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n9.3 \"--sync--\" StartsUsing { id: \"680F\", source: \"Hippokampos\" } window 20,20\r\n14.3 \"Murky Depths\" Ability { id: \"680F\", source: \"Hippokampos\" }\r\n26.6 \"Doubled Impact\" Ability { id: \"680E\", source: \"Hippokampos\" }\r\n32.8 \"--middle--\" Ability { id: \"6835\", source: \"Hippokampos\" }\r\n43.6 \"Spoken Cataract\" Ability { id: [\"67F7\", \"67F8\", \"67F9\", \"67FD\"], source: \"Hippokampos\" }\r\n58.3 \"Spoken Cataract\" Ability { id: [\"67F7\", \"67F8\", \"67F9\", \"67FD\"], source: \"Hippokampos\" }\r\n72.0 \"Murky Depths\" Ability { id: \"680F\", source: \"Hippokampos\" }\r\n77.2 \"--middle--\" Ability { id: \"6835\", source: \"Hippokampos\" }\r\n84.6 \"Sewage Deluge\" Ability { id: \"67F6\", source: \"Hippokampos\" }\r\n111.0 \"Tainted Flood\" Ability { id: \"6809\", source: \"Hippokampos\" }\r\n126.9 \"Predatory Sight\" Ability { id: \"680B\", source: \"Hippokampos\" }\r\n137.3 \"Shockwave\" Ability { id: \"6807\", source: \"Hippokampos\" }\r\n148.6 \"Dissociation\" Ability { id: \"6804\", source: \"Hippokampos\" }\r\n153.7 \"--sync--\" Ability { id: \"6805\", source: \"Hippokampos\" }\r\n165.8 \"Dissociation Dive\" Ability { id: \"6806\", source: \"Hippokampos\" }\r\n172.5 \"--sync--\" Ability { id: \"6D14\", source: \"Hippokampos\" }\r\n178.2 \"Coherence Flare\" Ability { id: \"6800\", source: \"Hippokampos\" }\r\n180.7 \"Coherence Line\" Ability { id: \"6802\", source: \"Hippokampos\" }\r\n182.7 \"--sync--\" Ability { id: \"6803\", source: \"Hippokampos\" }\r\n194.8 \"Murky Depths\" Ability { id: \"680F\", source: \"Hippokampos\" }\r\n\r\n201.0 \"--middle--\" Ability { id: \"6835\", source: \"Hippokampos\" }\r\n208.6 \"Sewage Deluge\" Ability { id: \"67F6\", source: \"Hippokampos\" }\r\n227.1 \"Tainted Flood\" Ability { id: \"6809\", source: \"Hippokampos\" }\r\n235.0 \"Spoken Cataract\" Ability { id: [\"67F7\", \"67F8\", \"67F9\", \"67FD\"], source: \"Hippokampos\" }\r\n250.7 \"Sewage Eruption 1\" #Ability { id: \"680D\", source: \"Hippokampos\" }\r\n252.2 \"Sewage Eruption 2\" #Ability { id: \"680D\", source: \"Hippokampos\" }\r\n253.7 \"Sewage Eruption 3\" #Ability { id: \"680D\", source: \"Hippokampos\" }\r\n259.5 \"Spoken Cataract\" Ability { id: [\"67F7\", \"67F8\", \"67F9\", \"67FD\"], source: \"Hippokampos\" }\r\n273.4 \"Tainted Flood\" Ability { id: \"6809\", source: \"Hippokampos\" }\r\n279.8 \"Predatory Sight\" Ability { id: \"680B\", source: \"Hippokampos\" }\r\n287.0 \"Murky Depths\" Ability { id: \"680F\", source: \"Hippokampos\" }\r\n296.2 \"Dissociation\" Ability { id: \"6804\", source: \"Hippokampos\" }\r\n301.3 \"--sync--\" Ability { id: \"6805\", source: \"Hippokampos\" }\r\n310.7 \"Shockwave (knockback)\" Ability { id: \"6807\", source: \"Hippokampos\" }\r\n313.4 \"Dissociation Dive\" Ability { id: \"6806\", source: \"Hippokampos\" }\r\n318.9 \"--middle--\" Ability { id: \"6835\", source: \"Hippokampos\" }\r\n325.3 \"Dissociation\" Ability { id: \"6804\", source: \"Hippokampos\" }\r\n330.4 \"--sync--\" Ability { id: \"6805\", source: \"Hippokampos\" }\r\n342.3 \"--sync--\" Ability { id: \"6D14\", source: \"Hippokampos\" }\r\n342.5 \"Dissociation Dive\" Ability { id: \"6806\", source: \"Hippokampos\" }\r\n342.5 \"Sewage Eruption 1\" #Ability { id: \"680D\", source: \"Hippokampos\" }\r\n344.0 \"Sewage Eruption 2\" #Ability { id: \"680D\", source: \"Hippokampos\" }\r\n345.5 \"Sewage Eruption 3\" #Ability { id: \"680D\", source: \"Hippokampos\" }\r\n347.9 \"Coherence Flare\" Ability { id: \"6800\", source: \"Hippokampos\" }\r\n350.4 \"Coherence Line\" Ability { id: \"6802\", source: \"Hippokampos\" }\r\n352.4 \"--sync--\" Ability { id: \"6803\", source: \"Hippokampos\" }\r\n360.6 \"Murky Depths\" Ability { id: \"680F\", source: \"Hippokampos\" }\r\n371.8 \"Murky Depths\" Ability { id: \"680F\", source: \"Hippokampos\" }\r\n383.1 \"Doubled Impact\" Ability { id: \"680E\", source: \"Hippokampos\" }\r\n\r\n392.3 \"--middle--\" Ability { id: \"6835\", source: \"Hippokampos\" } window 50,50 jump 201\r\n399.7 \"Sewage Deluge\" #Ability { id: \"67F6\", source: \"Hippokampos\" }\r\n418.2 \"Tainted Flood\" #Ability { id: \"6809\", source: \"Hippokampos\" }\r\n426.1 \"Spoken Cataract\" #Ability { id: [\"67F7\", \"67F8\", \"67F9\", \"67FD\"], source: \"Hippokampos\" }\r\n441.8 \"Sewage Eruption 1\" #Ability { id: \"680D\", source: \"Hippokampos\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p2s.ts





// TODO: Callout cardinal for Spoken Cataract
// TODO: Debuff collect for Marks and callouts for those without debuff
// TODO: Add cardinal to Channeling Flow
// TODO: Fix headmarker ids for Kampeos Harma Callouts
// Due to changes introduced in patch 5.2, overhead markers now have a random offset
// added to their ID. This offset currently appears to be set per instance, so
// we can determine what it is from the first overhead marker we see.
// The first 1B marker in the encounter is an Doubled Impact (0103).
const p2s_firstHeadmarker = parseInt('0103', 16);
const p2s_getHeadmarkerId = (data, matches) => {
  // If we naively just check !data.decOffset and leave it, it breaks if the first marker is 00DA.
  // (This makes the offset 0, and !0 is true.)
  if (typeof data.decOffset === 'undefined') data.decOffset = parseInt(matches.id, 16) - p2s_firstHeadmarker;
  // The leading zeroes are stripped when converting back to string, so we re-add them here.
  // Fortunately, we don't have to worry about whether or not this is robust,
  // since we know all the IDs that will be present in the encounter.
  return (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase().padStart(4, '0');
};
const p2s_triggerSet = {
  id: 'AsphodelosTheSecondCircleSavage',
  zoneId: zone_id/* default.AsphodelosTheSecondCircleSavage */.Z.AsphodelosTheSecondCircleSavage,
  timelineFile: 'p2s.txt',
  triggers: [{
    id: 'P2S Headmarker Tracker',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.decOffset === undefined,
    // Unconditionally set the first headmarker here so that future triggers are conditional.
    run: (data, matches) => p2s_getHeadmarkerId(data, matches)
  }, {
    id: 'P2S Murky Depths',
    type: 'StartsUsing',
    netRegex: {
      id: '6833',
      source: 'Hippokampos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P2S Doubled Impact',
    type: 'StartsUsing',
    netRegex: {
      id: '6832',
      source: 'Hippokampos'
    },
    response: responses/* Responses.sharedTankBuster */.n3.sharedTankBuster()
  }, {
    id: 'P2S Sewage Deluge',
    type: 'StartsUsing',
    netRegex: {
      id: '6810',
      source: 'Hippokampos',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'P2S Spoken Cataract',
    type: 'StartsUsing',
    netRegex: {
      id: ['6817', '6811', '6812', '6813'],
      source: 'Hippokampos',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.directions(),
    outputStrings: {
      directions: {
        en: 'Back of head',
        de: 'Zur Rückseite des Kopfes',
        fr: 'Derrière la tête',
        ja: '頭の後ろへ',
        cn: '去头的后面',
        ko: '머리 뒤쪽으로'
      }
    }
  }, {
    id: 'P2S Winged Cataract',
    type: 'StartsUsing',
    netRegex: {
      id: ['6814', '6815', '6818', '6816'],
      source: 'Hippokampos',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.directions(),
    outputStrings: {
      directions: {
        en: 'Front of head',
        de: 'Zur Vorderseite des Kopfes',
        fr: 'Devant la tête',
        ja: '頭の前へ',
        cn: '去头的前面',
        ko: '머리 앞쪽으로'
      }
    }
  }, {
    id: 'P2S Ominous Bubbling',
    type: 'StartsUsing',
    netRegex: {
      id: '682B',
      source: 'Hippokampos',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.groups(),
    outputStrings: {
      groups: {
        en: 'Healer Groups',
        de: 'Heiler-Gruppen',
        fr: 'Groupes sur les heals',
        ja: 'ヒラに頭割り',
        cn: '与治疗分摊',
        ko: '힐러 그룹 쉐어'
      }
    }
  }, {
    id: 'P2S Mark of the Tides Collect',
    type: 'GainsEffect',
    // Status goes out with Predatory Avarice (6827).
    netRegex: {
      effectId: 'AD0'
    },
    run: (data, matches) => (data.avarice ??= []).push(matches)
  }, {
    id: 'P2S Mark of the Tides',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'AD0',
      capture: false
    },
    delaySeconds: data => data.avarice?.length === 2 ? 0 : 0.5,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        marks: {
          en: 'Marks: ${player1}, ${player2}',
          de: 'Marker: ${player1}, ${player2}',
          fr: 'Marques sur : ${player1}, ${player2}',
          ja: 'マーカー: ${player1}, ${player2}',
          cn: '标记: ${player1}, ${player2}',
          ko: '징: ${player1}, ${player2}'
        },
        avariceOnYou: {
          en: 'Avarice on YOU',
          de: 'Marker auf DIR',
          fr: 'Marque sur VOUS',
          ja: 'マーカーついた',
          cn: '标记点名',
          ko: '내가 징 대상자'
        },
        unknown: outputs/* default.unknown */.Z.unknown
      };
      if (data.avarice === undefined) return;
      const name1 = data.party.member(data.avarice[0]?.target);
      const name2 = data.party.member(data.avarice[1]?.target);
      const markText = output.marks({
        player1: name1,
        player2: name2
      });
      const isOnYou = data.avarice.find(m => m.target === data.me);
      if (isOnYou) {
        return {
          alertText: output.avariceOnYou(),
          infoText: markText
        };
      }
      return {
        infoText: markText
      };
    },
    run: data => delete data.avarice
  }, {
    id: 'P2S Mark of the Tides Move',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'AD0'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // 23 second duration, safe to move ~16.7s for first time, ~15s for the second.
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 6,
    alarmText: (_data, _matches, output) => output.awayFromGroup(),
    outputStrings: {
      awayFromGroup: outputs/* default.awayFromGroup */.Z.awayFromGroup
    }
  }, {
    id: 'P2S Mark of the Depths',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'AD1'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.stackOnYou(),
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou
    }
  }, {
    id: 'P2S Channeling Flow',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['AD2', 'AD3', 'AD4', 'AD5']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, matches, output) => {
      const t = parseFloat(matches.duration);
      // Effect durations are 13 seconds (short) and 28 seconds (long)
      if (t < 15) return output.arrowFirst();
      return output.spreadFirst();
    },
    outputStrings: {
      arrowFirst: {
        en: 'Arrow First',
        de: 'Pfeil zuerst',
        fr: 'Flèches en premières',
        ja: '突進→散開',
        cn: '先对冲',
        ko: '화살표 처리 먼저'
      },
      spreadFirst: {
        en: 'Spread First',
        de: 'Verteilen zuerst',
        fr: 'Dispersez-vous en premier',
        ja: '散開→突進',
        cn: '先散开',
        ko: '산개 먼저'
      }
    }
  }, {
    // Aoe from head outside the arena
    id: 'P2S Dissociation',
    type: 'StartsUsing',
    netRegex: {
      id: '682E',
      source: 'Hippokampos'
    },
    alertText: (_data, matches, output) => {
      const xCoord = parseFloat(matches.x);
      if (xCoord > 100) return output.w();
      if (xCoord < 100) return output.e();
    },
    outputStrings: {
      e: outputs/* default.east */.Z.east,
      w: outputs/* default.west */.Z.west
    }
  }, {
    // Spread aoe marker on some players, not all
    id: 'P2S Tainted Flood',
    type: 'StartsUsing',
    netRegex: {
      id: '6838',
      source: 'Hippokampos'
    },
    condition: (data, matches) => matches.target === data.me,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'P2S Coherence Flare',
    type: 'Tether',
    // Whoever has tether when cast of 681B ends will be flared
    netRegex: {
      id: '0054',
      source: 'Hippokampos'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    run: (data, matches) => data.flareTarget = matches.target,
    outputStrings: {
      text: {
        en: 'Flare Tether',
        de: 'Flare Verbindung',
        fr: 'Lien Brasier',
        ja: 'フレアの線',
        cn: '核爆连线',
        ko: '플레어 선'
      }
    }
  }, {
    id: 'P2S Coherence Stack',
    type: 'StartsUsing',
    netRegex: {
      id: '681B',
      source: 'Hippokampos'
    },
    condition: data => data.flareTarget !== data.me,
    // 12 second cast, delay for tether to settle
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 6,
    alertText: (data, _matches, output) => {
      if (data.role === 'tank') return output.flareLineTank();
      return output.flareLineStack();
    },
    outputStrings: {
      flareLineStack: {
        en: 'Line Stack (behind tank)',
        de: 'Linien-Sammeln (hinter dem Tank)',
        fr: 'Package en ligne (derrière le tank)',
        ja: '直線頭割り（タンクより後ろ）',
        cn: '直线分摊（站坦克后面）',
        ko: '직선 쉐어 (탱커 뒤로)'
      },
      flareLineTank: {
        en: 'Line Stack (be in front)',
        de: 'Linien-Sammeln (vorne sein)',
        fr: 'Package en ligne (Placez-vous devant)',
        ja: '直線頭割り（みんなの前に）',
        cn: '直线分摊（坦克站前面）',
        ko: '직선 쉐어 (맨 앞으로)'
      }
    }
  }, {
    // Raidwide knockback -> dont get knocked into slurry
    id: 'P2S Shockwave',
    type: 'StartsUsing',
    netRegex: {
      id: '682F',
      source: 'Hippokampos'
    },
    // 7.7 cast time, delay for proper arm's length
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'P2S Kampeos Harma Marker',
    type: 'HeadMarker',
    netRegex: {},
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        squareAcross: {
          en: '#${num} Square, go across',
          de: '#${num} Viereck, geh gegenüber',
          fr: '#${num} Carré, allez à l\'opposé',
          ja: '四角 #${num}：ボスの対角へ',
          cn: '方块 #${num}: 去Boss对角',
          ko: '#${num} 네모, 보스 대각 발판으로'
        },
        // Trying not to confuse with boss/across
        squareBoss: {
          en: '#${num} Square, boss tile',
          de: '#${num} Viereck, Boss Fläche',
          fr: '#${num} Carré, case du boss',
          ja: '四角 #${num}：ボスの下へ',
          cn: '方块 #${num}: 去Boss脚下',
          ko: '#${num} 네모, 보스 발판으로'
        },
        triangle: {
          en: '#${num} Triangle',
          de: '#${num} Dreieck',
          fr: '#${num} Triangle',
          ja: '三角 #${num}',
          cn: '三角 #${num}',
          ko: '#${num} 세모'
        }
      };
      const id = p2s_getHeadmarkerId(data, matches);
      if (!id) return;
      const harmaMarkers = ['0091', '0092', '0093', '0094', '0095', '0096', '0097', '0098'];
      if (!harmaMarkers.includes(id)) return;
      let num = parseInt(id);
      const isTriangle = num >= 95;
      num -= 90;
      if (isTriangle) num -= 4;

      // 1/3 have to run to the other side, so make this louder.
      const isOdd = num % 2;
      if (isTriangle) return {
        ['infoText']: output.triangle({
          num: num
        })
      };else if (isOdd) return {
        ['alarmText']: output.squareAcross({
          num: num
        })
      };
      return {
        ['alertText']: output.squareBoss({
          num: num
        })
      };
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Spoken Cataract/Winged Cataract': 'Spoken/Winged Cataract'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Hippokampos': 'Hippokampos'
    },
    'replaceText': {
      '\\(knockback\\)': '(Rückstoß)',
      '\\(short\\)': '(Kurz)',
      '\\(long\\)': '(Lang)',
      'Channeling Flow': 'Kanalschnellen',
      'Channeling Overflow': 'Kanalfluten',
      'Coherence(?! [FL])': 'Kohärenz',
      'Coherence Flare': 'Kohärenz Flare',
      'Coherence Line': 'Kohärenz Linie',
      'Crash': 'Impakt',
      'Deadly Current': 'Tödliche Strömung',
      'Dissociation(?! Dive)': 'Dissoziation',
      'Dissociation Dive': 'Dissoziation Sturzflug',
      'Doubled Impact': 'Doppeleinschlag',
      'Great Typhoon': 'Große Welle',
      'Hard Water': 'Reißendes Wasser',
      'Kampeos Harma': 'Kampeos Harma',
      'Murky Depths': 'Trübe Tiefen',
      'Ominous Bubbling(?! Groups)': 'Kopfwasser',
      'Ominous Bubbling Groups': 'Kopfwasser Gruppen',
      'Predatory Avarice': 'Massenmal',
      'Predatory Sight': 'Mal der Beute',
      'Sewage Deluge': 'Abwasserflut',
      'Sewage Eruption': 'Abwassereruption',
      'Shockwave': 'Schockwelle',
      'Spoken Cataract': 'Gehauchter Katarakt',
      'Tainted Flood': 'Verseuchte Flut',
      'Winged Cataract': 'Beschwingter Katarakt'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Hippokampos': 'hippokampos'
    },
    'replaceText': {
      '\\(long\\)': '(long)',
      '\\(knockback\\)': '(poussée)',
      '\\(short\\)': '(court)',
      'Channeling Flow': 'Courant canalisant',
      'Channeling Overflow': 'Déversement canalisant',
      'Coherence(?! [FL])': 'Cohérence',
      'Coherence Flare': 'Cohérence Brasier',
      'Coherence Line': 'Cohérence en ligne',
      'Crash': 'Collision',
      'Deadly Current': 'Torrent mortel',
      'Dissociation(?! Dive)': 'Dissociation',
      'Dissociation Dive': 'Dissociation et plongeon',
      'Doubled Impact': 'Double impact',
      'Great Typhoon': 'Flots tumultueux',
      'Hard Water': 'Oppression aqueuse',
      'Kampeos Harma': 'Kampeos harma',
      'Murky Depths': 'Tréfonds troubles',
      'Ominous Bubbling(?! Groups)': 'Hydro-agression',
      'Ominous Bubbling Groups': 'Hydro-agression en groupes',
      'Predatory Avarice': 'Double marque',
      'Predatory Sight': 'Marque de la proie',
      'Sewage Deluge': 'Déluge d\'eaux usées',
      'Sewage Eruption': 'Éruption d\'eaux usées',
      'Shockwave': 'Onde de choc',
      'Spoken Cataract/Winged Cataract': 'Souffle/Aile et cataracte',
      'Tainted Flood': 'Inondation infâme',
      'Winged Cataract/Spoken Cataract': 'Aile/Souffle et cataracte'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Hippokampos': 'ヒッポカムポス'
    },
    'replaceText': {
      'Channeling Flow': 'チャネリングフロウ',
      'Channeling Overflow': 'チャネリングオーバーフロウ',
      'Coherence(?! [FL])': 'コヒーレンス',
      'Crash': '衝突',
      'Deadly Current': '激流衝',
      'Dissociation': 'ディソシエーション',
      'Doubled Impact': 'ダブルインパクト',
      'Great Typhoon': '荒波',
      'Hard Water': '重水塊',
      'Kampeos Harma': 'カンペオスハルマ',
      'Murky Depths': 'マーキーディープ',
      'Ominous Bubbling': '霊水弾',
      'Predatory Avarice': '多重刻印',
      'Predatory Sight': '生餌の刻印',
      'Sewage Deluge': 'スウェッジデリージュ',
      'Sewage Eruption': 'スウェッジエラプション',
      'Shockwave': 'ショックウェーブ',
      'Spoken Cataract': 'ブレス＆カタラクティス',
      'Tainted Flood': 'テインテッドフラッド',
      'Winged Cataract': 'ウィング＆カタラクティス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Hippokampos': '鱼尾海马怪'
    },
    'replaceText': {
      '\\(knockback\\)': '(击退)',
      '\\(short\\)': '(短)',
      '\\(long\\)': '(长)',
      'Channeling Flow': '沟流充溢',
      'Channeling Overflow': '沟流溢出',
      'Coherence(?! [FL])': '连贯攻击',
      'Coherence Flare': '连贯攻击 (核爆)',
      'Coherence Line': '连贯攻击 (分摊)',
      'Crash': '冲撞',
      'Deadly Current': '激流冲',
      'Dissociation(?! Dive)': '分离',
      'Dissociation Dive': '分离 (冲锋)',
      'Doubled Impact': '双重冲击',
      'Great Typhoon': '荒波',
      'Hard Water': '重水块',
      'Kampeos Harma': '海怪战车',
      'Murky Depths': '深度污浊',
      'Ominous Bubbling(?! Groups)': '灵水弹',
      'Ominous Bubbling Groups': '灵水弹 (分组)',
      'Predatory Avarice': '多重刻印',
      'Predatory Sight': '活饵的刻印',
      'Sewage Deluge': '污水泛滥',
      'Sewage Eruption': '污水喷发',
      'Shockwave': '震荡波',
      'Spoken Cataract': '吐息飞瀑',
      'Tainted Flood': '污染洪水',
      'Winged Cataract': '展翅飞瀑'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Hippokampos': '히포캄포스'
    },
    'replaceText': {
      '\\(knockback\\)': '(넉백)',
      '\\(short\\)': '(13초)',
      '\\(long\\)': '(28초)',
      'Channeling Flow': '방향성 흐름',
      'Channeling Overflow': '방향성 급류',
      'Coherence(?! [FL])': '간섭 공격',
      'Coherence Flare': '간섭 공격 (플레어)',
      'Coherence Line': '간섭 공격 (쉐어)',
      'Crash': '충돌',
      'Deadly Current': '격류 충돌',
      'Dissociation(?! Dive)': '머리 분리',
      'Dissociation Dive': '머리 분리 (돌진)',
      'Doubled Impact': '이중 충격',
      'Great Typhoon': '황파',
      'Hard Water': '무거운 물덩어리',
      'Kampeos Harma': '바다괴물 전차',
      'Murky Depths': '짙은 탁류',
      'Ominous Bubbling(?! Groups)': '불길한 물방울',
      'Ominous Bubbling Groups': '불길한 물방울 (쉐어)',
      'Predatory Avarice': '다중 각인',
      'Predatory Sight': '먹잇감 각인',
      'Sewage Deluge': '하수 범람',
      'Sewage Eruption': '하수 분출',
      'Shockwave': '충격 파동',
      'Spoken Cataract/Winged Cataract': '숨결/날갯짓 홍수',
      'Tainted Flood': '오염 침수',
      'Winged Cataract/Spoken Cataract': '날갯짓/숨결 홍수'
    }
  }]
};
/* harmony default export */ const p2s = (p2s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p2s.txt
const raid_p2s_namespaceObject = "### P2S: Asphodelos: The Second Circle (Savage)\r\n#\r\n# -p 6833:11\r\n# -it Hippokampos -oc Hippokampos -ii 6822 6821 6829 6D4A 6825 6826\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11.0 \"--sync--\" StartsUsing { id: \"6833\", source: \"Hippokampos\" } window 15,15\r\n16.0 \"Murky Depths\" Ability { id: \"6833\", source: \"Hippokampos\" }\r\n26.3 \"Doubled Impact\" Ability { id: \"6832\", source: \"Hippokampos\" }\r\n31.5 \"--middle--\" Ability { id: \"6836\", source: \"Hippokampos\" }\r\n38.8 \"Sewage Deluge\" Ability { id: \"6810\", source: \"Hippokampos\" }\r\n48.0 \"--middle--\" Ability { id: \"6836\", source: \"Hippokampos\" }\r\n61.8 \"Spoken Cataract/Winged Cataract\" Ability { id: [\"6811\", \"6812\", \"6813\", \"6814\", \"6815\", \"6816\", \"6817\", \"6818\"], source: \"Hippokampos\" }\r\n81.9 \"Coherence\" Ability { id: \"681B\", source: \"Hippokampos\" }\r\n82.6 \"Coherence Flare\" Ability { id: \"681A\", source: \"Hippokampos\" }\r\n85.1 \"Coherence Line\" Ability { id: \"681C\", source: \"Hippokampos\" }\r\n87.2 \"--sync--\" Ability { id: \"681D\", source: \"Hippokampos\" }\r\n98.4 \"Murky Depths\" Ability { id: \"6833\", source: \"Hippokampos\" }\r\n105.1 \"Ominous Bubbling\" Ability { id: \"682A\", source: \"Hippokampos\" }\r\n115.9 \"Shockwave\" Ability { id: \"682F\", source: \"Hippokampos\" }\r\n119.7 \"Ominous Bubbling Groups\" Ability { id: \"682B\", source: \"Hippokampos\" }\r\n\r\n# Predatory Avarice and Channeling Flow\r\n128.1 \"--middle--\" Ability { id: \"6836\", source: \"Hippokampos\" }\r\n134.5 \"Predatory Avarice\" Ability { id: \"6827\", source: \"Hippokampos\" }\r\n152.2 \"Winged Cataract/Spoken Cataract\" Ability { id: [\"6811\", \"6812\", \"6813\", \"6814\", \"6815\", \"6816\", \"6817\", \"6818\"], source: \"Hippokampos\" }\r\n158.5 \"Hard Water\" Ability { id: \"6828\", source: \"Hippokampos\" }\r\n158.5 \"Deadly Current\" #sync Ability { id: \"6829\", source: \"Hippokampos\" }\r\n171.9 \"Channeling Flow\" Ability { id: \"681E\", source: \"Hippokampos\" }\r\n187.2 \"Great Typhoon\" Ability { id: [\"6820\", \"6822\"], source: \"Hippokampos\" }\r\n187.7 \"Crash\" #Ability { id: \"6821\", source: \"Hippokampos\" }\r\n202.2 \"Doubled Impact\" Ability { id: \"6832\", source: \"Hippokampos\" }\r\n212.3 \"Murky Depths\" Ability { id: \"6833\", source: \"Hippokampos\" }\r\n\r\n# Kampeos Harma\r\n221.5 \"--middle--\" Ability { id: \"6836\", source: \"Hippokampos\" }\r\n228.9 \"Sewage Deluge\" Ability { id: \"6810\", source: \"Hippokampos\" }\r\n246.4 \"Shockwave\" Ability { id: \"682F\", source: \"Hippokampos\" }\r\n259.3 \"Kampeos Harma\" Ability { id: \"6823\", source: \"Hippokampos\" }\r\n259.3 \"--untargetable--\"\r\n259.7 \"Kampeos Harma 1\" #Ability { id: \"6824\", source: \"Hippokampos\" }\r\n261.5 \"Kampeos Harma 2\" #Ability { id: \"6824\", source: \"Hippokampos\" }\r\n263.3 \"Kampeos Harma 3\" #Ability { id: \"6824\", source: \"Hippokampos\" }\r\n265.2 \"Kampeos Harma 4\" Ability { id: \"6824\", source: \"Hippokampos\" }\r\n266.7 \"--targetable--\"\r\n266.8 \"--sync--\" Ability { id: \"682D\", source: \"Hippokampos\" }\r\n269.9 \"--middle--\" Ability { id: \"6836\", source: \"Hippokampos\" }\r\n281.7 \"Doubled Impact\" Ability { id: \"6832\", source: \"Hippokampos\" }\r\n290.8 \"Murky Depths\" Ability { id: \"6833\", source: \"Hippokampos\" }\r\n\r\n# Timed Channeling Flow 1\r\n297.0 \"--middle--\" Ability { id: \"6836\", source: \"Hippokampos\" }\r\n304.4 \"Channeling Overflow\" Ability { id: \"6DC2\", source: \"Hippokampos\" }\r\n311.6 \"--sync--\" Ability { id: \"6837\", source: \"Hippokampos\" }\r\n318.7 \"Tainted Flood\" Ability { id: \"6838\", source: \"Hippokampos\" }\r\n319.7 \"Great Typhoon (short)\" Ability { id: [\"6820\", \"6822\"], source: \"Hippokampos\" }\r\n320.2 \"Crash\" #Ability { id: \"6821\", source: \"Hippokampos\" }\r\n327.0 \"--sync--\" Ability { id: \"6837\", source: \"Hippokampos\" }\r\n334.1 \"Tainted Flood\" Ability { id: \"6838\", source: \"Hippokampos\" }\r\n334.7 \"Great Typhoon (long)\" Ability { id: [\"6820\", \"6822\"], source: \"Hippokampos\" }\r\n335.2 \"Crash\" #Ability { id: \"6821\", source: \"Hippokampos\" }\r\n345.2 \"Spoken Cataract/Winged Cataract\" Ability { id: [\"6811\", \"6812\", \"6813\", \"6814\", \"6815\", \"6816\", \"6817\", \"6818\"], source: \"Hippokampos\" }\r\n\r\n# Dissociation and Sewage Eruption 1\r\n357.9 \"--middle--\" Ability { id: \"6836\", source: \"Hippokampos\" }\r\n364.4 \"Predatory Avarice\" Ability { id: \"6827\", source: \"Hippokampos\" }\r\n370.8 \"Dissociation\" Ability { id: \"682C\", source: \"Hippokampos\" }\r\n375.9 \"--sync--\" Ability { id: \"682D\", source: \"Hippokampos\" }\r\n388.5 \"Hard Water\" Ability { id: \"6828\", source: \"Hippokampos\" }\r\n388.5 \"Deadly Current\" #Ability { id: \"6829\", source: \"Hippokampos\" }\r\n388.9 \"Dissociation Dive\" #Ability { id: \"682E\", source: \"Hippokampos\" }\r\n388.9 \"Winged Cataract/Spoken Cataract\" #Ability { id: [\"6811\", \"6812\", \"6813\", \"6814\", \"6815\", \"6816\", \"6817\", \"6818\"], source: \"Hippokampos\" }\r\n402.6 \"Dissociation\" Ability { id: \"682C\", source: \"Hippokampos\" }\r\n407.7 \"--sync--\" Ability { id: \"682D\", source: \"Hippokampos\" }\r\n415.8 \"Sewage Eruption\" Ability { id: \"6830\", source: \"Hippokampos\" }\r\n419.8 \"Sewage Eruption 1\" #Ability { id: \"6831\", source: \"Hippokampos\" }\r\n421.1 \"--sync--\" Ability { id: \"6837\", source: \"Hippokampos\" }\r\n421.6 \"Dissociation Dive\" #Ability { id: \"682E\", source: \"Hippokampos\" }\r\n421.6 \"Sewage Eruption 2\" #Ability { id: \"6831\", source: \"Hippokampos\" }\r\n423.4 \"Sewage Eruption 3\" #Ability { id: \"6831\", source: \"Hippokampos\" }\r\n428.2 \"Tainted Flood\" Ability { id: \"6838\", source: \"Hippokampos\" }\r\n437.8 \"--sync--\" Ability { id: \"681B\", source: \"Hippokampos\" }\r\n438.5 \"Coherence Flare\" Ability { id: \"681A\", source: \"Hippokampos\" }\r\n441.1 \"Coherence Line\" Ability { id: \"681C\", source: \"Hippokampos\" }\r\n443.1 \"--sync--\" Ability { id: \"681D\", source: \"Hippokampos\" }\r\n453.4 \"Doubled Impact\" Ability { id: \"6832\", source: \"Hippokampos\" }\r\n461.5 \"Murky Depths\" Ability { id: \"6833\", source: \"Hippokampos\" }\r\n\r\n# Timed Channeling Flow 2\r\n471.7 \"--middle--\" Ability { id: \"6836\", source: \"Hippokampos\" }\r\n479.2 \"Sewage Deluge\" Ability { id: \"6810\", source: \"Hippokampos\" }\r\n488.4 \"--middle--\" Ability { id: \"6836\", source: \"Hippokampos\" }\r\n496.1 \"Channeling Overflow\" Ability { id: \"6DC2\", source: \"Hippokampos\" }\r\n511.3 \"Great Typhoon (short)\" Ability { id: [\"6820\", \"6822\"], source: \"Hippokampos\" }\r\n511.8 \"Crash\" #Ability { id: \"6821\", source: \"Hippokampos\" }\r\n513.5 \"Coherence\" Ability { id: \"681B\", source: \"Hippokampos\" }\r\n514.2 \"Coherence Flare\" Ability { id: \"681A\", source: \"Hippokampos\" }\r\n516.6 \"Coherence Line\" Ability { id: \"681C\", source: \"Hippokampos\" }\r\n518.6 \"--sync--\" Ability { id: \"681D\", source: \"Hippokampos\" }\r\n526.2 \"Great Typhoon (long)\" Ability { id: [\"6820\", \"6822\"], source: \"Hippokampos\" }\r\n526.7 \"Crash\" #Ability { id: \"6821\", source: \"Hippokampos\" }\r\n\r\n# Dissociation and Sewage Eruption 2\r\n538.8 \"Dissociation\" Ability { id: \"682C\", source: \"Hippokampos\" }\r\n543.9 \"--sync--\" Ability { id: \"682D\", source: \"Hippokampos\" }\r\n552.0 \"Sewage Eruption\" Ability { id: \"6830\", source: \"Hippokampos\" }\r\n555.9 \"Dissociation Dive\" #Ability { id: \"682E\", source: \"Hippokampos\" }\r\n556.0 \"Sewage Eruption 1\" #Ability { id: \"6831\", source: \"Hippokampos\" }\r\n557.8 \"Sewage Eruption 2\" #Ability { id: \"6831\", source: \"Hippokampos\" }\r\n559.6 \"Sewage Eruption 3\" #Ability { id: \"6831\", source: \"Hippokampos\" }\r\n563.3 \"Ominous Bubbling\" Ability { id: \"682A\", source: \"Hippokampos\" }\r\n573.9 \"Shockwave\" Ability { id: \"682F\", source: \"Hippokampos\" }\r\n577.9 \"Ominous Bubbling Groups\" Ability { id: \"682B\", source: \"Hippokampos\" }\r\n588.3 \"Doubled Impact\" Ability { id: \"6832\", source: \"Hippokampos\" }\r\n600.4 \"Murky Depths\" Ability { id: \"6833\", source: \"Hippokampos\" }\r\n611.6 \"Murky Depths\" Ability { id: \"6833\", source: \"Hippokampos\" }\r\n\r\n626.5 \"Sewage Deluge (enrage)\" Ability { id: \"6834\", source: \"Hippokampos\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p3n.ts




const p3n_triggerSet = {
  id: 'AsphodelosTheThirdCircle',
  zoneId: zone_id/* default.AsphodelosTheThirdCircle */.Z.AsphodelosTheThirdCircle,
  timelineFile: 'p3n.txt',
  triggers: [{
    id: 'P3N Experimental Fireplume Rotating',
    type: 'StartsUsing',
    netRegex: {
      id: '6698',
      source: 'Phoinix',
      capture: false
    },
    infoText: (_data, _matches, output) => output.startMiddle(),
    outputStrings: {
      startMiddle: {
        en: 'Start Middle',
        de: 'Starte mittig',
        fr: 'Commencez au milieu',
        ja: '中央から',
        cn: '从中间开始',
        ko: '가운데에 있다가 밖으로'
      }
    }
  }, {
    id: 'P3N Experimental Fireplume Out',
    type: 'StartsUsing',
    // This is Experimental Fireplume (6696) into Fireplume (6697), which is an 11s warning.
    netRegex: {
      id: '6696',
      source: 'Phoinix',
      capture: false
    },
    durationSeconds: 8,
    infoText: (_data, _matches, output) => output.outOfMiddle(),
    outputStrings: {
      outOfMiddle: {
        en: 'Out Of Middle Soon',
        de: 'Bald raus aus der Mitte',
        fr: 'Sortez du milieu bientôt',
        ja: '中央から離れて',
        cn: '远离中间',
        ko: '맵 바깥쪽으로'
      }
    }
  }, {
    id: 'P3N Scorched Exaltation',
    type: 'StartsUsing',
    netRegex: {
      id: '66B8',
      source: 'Phoinix',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P3N Heat of Condemnation',
    type: 'StartsUsing',
    netRegex: {
      id: '66B2',
      source: 'Phoinix'
    },
    suppressSeconds: 1,
    response: responses/* Responses.tankCleave */.n3.tankCleave('alert')
  }, {
    id: 'P3N Darkened Fire Aoe',
    type: 'HeadMarker',
    netRegex: {
      id: '010[C-F]'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => {
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'Stand on Darkened Fire',
        de: 'Auf einer Schwarzen Lohe stehen',
        fr: 'Placez-vous sur une flamme sombre',
        ja: '黒い炎の上へ',
        cn: '站在黑色火焰',
        ko: '불꽃 위에 서기'
      }
    }
  }, {
    id: 'P3N Right Cinderwing',
    type: 'StartsUsing',
    netRegex: {
      id: '66B4',
      source: 'Phoinix',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'P3N Left Cinderwing',
    type: 'StartsUsing',
    netRegex: {
      id: '66B5',
      source: 'Phoinix',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    // Could check the log line's x y coordinate to determine from where to where it charges, npc at charge target casts 66AF?
    id: 'P3N Trail of Condemnation',
    type: 'StartsUsing',
    netRegex: {
      id: '66AD',
      source: 'Phoinix',
      capture: false
    },
    alertText: (_data, _matches, output) => {
      return output.avoidCharge();
    },
    outputStrings: {
      avoidCharge: {
        en: 'Avoid Charge',
        de: 'Charge ausweichen',
        fr: 'Évitez les charges',
        ja: '突進避けて',
        cn: '躲避冲锋',
        ko: '돌진 피하기'
      }
    }
  }, {
    id: 'P3N Sunbird Spawn',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Sunbird',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      if (data.role === 'tank' || data.job === 'BLU') return output.tank();
      return output.text();
    },
    outputStrings: {
      tank: {
        en: 'Pull add circles apart',
        de: 'Zieh die Kreise der Adds auseinander',
        fr: 'Attaquez les adds séparément',
        ja: '雑魚を離れさせる',
        cn: '拉开小怪',
        ko: '원 끼리 겹치지 않게 하기'
      },
      text: outputs/* default.killAdds */.Z.killAdds
    }
  }, {
    id: 'P3N Dead Rebirth',
    type: 'StartsUsing',
    netRegex: {
      id: '66A9',
      source: 'Phoinix',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P3N Ashen Eye',
    type: 'StartsUsing',
    netRegex: {
      id: '66AB',
      source: 'Sparkfledged'
    },
    alertText: (data, matches, output) => {
      if (!data.ashenEyeDirections) data.ashenEyeDirections = [];
      // Convert radians into 4 quarters N = 0, E = 1, S = 2, W = 3
      const heading = Math.round(2 - 2 * parseFloat(matches.heading) / Math.PI) % 4;
      data.ashenEyeDirections.push(heading);
      if (data.ashenEyeDirections.length === 2) {
        let safeSpot = '';
        let first = '';
        const dir1 = data.ashenEyeDirections[0];
        const dir2 = data.ashenEyeDirections[1];
        switch (dir1) {
          case 0:
            safeSpot = output.n();
            break;
          case 1:
            safeSpot = output.e();
            break;
          case 2:
            safeSpot = output.s();
            break;
          case 3:
            safeSpot = output.w();
            break;
        }
        switch (dir2) {
          case 0:
            first = output.s();
            break;
          case 1:
            first = output.w();
            break;
          case 2:
            first = output.n();
            break;
          case 3:
            first = output.e();
            break;
        }
        return output.combo({
          first: first,
          second: safeSpot
        });
      } else if (data.ashenEyeDirections.length > 3) {
        data.ashenEyeDirections = [];
      }
    },
    outputStrings: {
      n: outputs/* default.north */.Z.north,
      e: outputs/* default.east */.Z.east,
      w: outputs/* default.west */.Z.west,
      s: outputs/* default.south */.Z.south,
      combo: {
        en: '${first} => ${second}',
        de: '${first} => ${second}',
        fr: '${first} => ${second}',
        ja: '${first} => ${second}',
        cn: '${first} => ${second}',
        ko: '${first} => ${second}'
      }
    }
  }, {
    id: 'P3N Devouring Brand',
    type: 'StartsUsing',
    netRegex: {
      id: '669E',
      source: 'Phoinix',
      capture: false
    },
    alertText: (_data, _matches, output) => {
      return output.text();
    },
    outputStrings: {
      text: {
        en: 'Split Intercardinals',
        de: 'Interkardinal aufteilen',
        fr: 'Dispersez-vous en intercardinal',
        ja: 'フィールド十字分断',
        cn: '分割场地',
        ko: '대각선 쪽으로 나눠 자리잡기'
      }
    }
  }, {
    id: 'P3N Spread Marker',
    type: 'HeadMarker',
    netRegex: {
      id: '008B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Left Cinderwing/Right Cinderwing': 'Left/Right Cinderwing'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Phoinix': 'Phoinix',
      'Sparkfledged': 'Saat des Phoinix',
      'Sunbird': 'Spross Des Phoinix'
    },
    'replaceText': {
      '--fire expands--': '--Feuer breitet sich aus--',
      '--giant fireplume\\?--': '--riesige Feuerfieder?--',
      'Ashen Eye': 'Aschener Blick',
      'Blazing Rain': 'Flammender Regen',
      'Brightened Fire': 'Lichte Lohe',
      '(?<!\\w )Charplume': 'Aschenfieder',
      'Darkened Fire': 'Schwarze Lohe',
      'Dead Rebirth': 'Melaphoinix',
      'Devouring Brand': 'Kreuzbrand',
      'Experimental Charplume': 'Experimentelle Schwarzfieder',
      'Experimental Fireplume': 'Experimentelle Feuerfieder',
      'Flames of Undeath': 'Totenflamme',
      'Flare of Condemnation': 'Limbische Flamme',
      'Fledgling Flight': 'Flüggewerden',
      'Heat of Condemnation': 'Limbisches Lodern',
      'Joint Pyre': 'Gemeinschaft des Feuers',
      'Left Cinderwing': 'Linke Aschenschwinge',
      'Right Cinderwing': 'Rechte Aschenschwinge',
      'Scorched Exaltation': 'Aschenlohe',
      'Searing Breeze': 'Sengender Hauch',
      'Trail of Condemnation': 'Limbischer Odem'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Phoinix': 'protophénix',
      'Sparkfledged': 'oiselet de feu',
      'Sunbird': 'oiselet étincelant'
    },
    'replaceText': {
      '--fire expands--': '--élargissement du feu--',
      '--giant fireplume\\?--': '--immolation de feu géant ?--',
      'Ashen Eye': 'Œil sombre',
      'Blazing Rain': 'Pluie brûlante',
      'Brightened Fire': 'Flamme de lumière',
      '(?<!\\w )Charplume': 'Immolation de feu sombre',
      'Darkened Fire': 'Flamme sombre',
      'Dead Rebirth': 'Phénix noir',
      'Devouring Brand': 'Croix enflammée',
      'Experimental Charplume': 'Synthèse de mana : immolation de feu sombre',
      'Experimental Fireplume': 'Synthèse de mana : immolation de feu',
      'Flames of Undeath': 'Feu réincarné',
      'Flare of Condemnation': 'Souffle infernal',
      'Fledgling Flight': 'Nuée ailée',
      'Heat of Condemnation': 'Bourrasque infernale',
      'Joint Pyre': 'Combustion résonnante',
      'Left Cinderwing/Right Cinderwing': 'Incinération senestre/dextre',
      'Scorched Exaltation': 'Flamme calcinante',
      'Searing Breeze': 'Jet incandescent',
      'Trail of Condemnation': 'Embrasement infernal'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Phoinix': 'フェネクス',
      'Sparkfledged': '火霊鳥',
      'Sunbird': '陽炎鳥'
    },
    'replaceText': {
      'Ashen Eye': '闇の瞳',
      'Blazing Rain': '炎の雨',
      'Brightened Fire': '光の炎',
      '(?<!\\w )Charplume': '闇の劫火天焦',
      'Darkened Fire': '闇の炎',
      'Dead Rebirth': '黒き不死鳥',
      'Devouring Brand': '十字走火',
      'Experimental Charplume': '魔力錬成：闇の劫火天焦',
      'Experimental Fireplume': '魔力錬成：劫火天焦',
      'Flames of Undeath': '反魂の炎',
      'Flare of Condemnation': '獄炎の火撃',
      'Fledgling Flight': '群鳥飛翔',
      'Heat of Condemnation': '獄炎の炎撃',
      'Joint Pyre': '共燃',
      'Left Cinderwing': '左翼焼却',
      'Right Cinderwing': '右翼焼却',
      'Scorched Exaltation': '灰燼の炎',
      'Searing Breeze': '熱噴射',
      'Trail of Condemnation': '獄炎の焔'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Phoinix': '菲尼克司',
      'Sparkfledged': '火灵鸟',
      'Sunbird': '阳炎鸟'
    },
    'replaceText': {
      '--fire expands--': '--火焰扩大--',
      '--giant fireplume\\?--': '--巨大火柱?--',
      'Ashen Eye': '暗之瞳',
      'Blazing Rain': '炎之雨',
      'Brightened Fire': '光之炎',
      '(?<!\\w )Charplume': '暗之劫火焚天',
      'Darkened Fire': '暗之炎',
      'Dead Rebirth': '黑暗不死鸟',
      'Devouring Brand': '十字地火',
      'Experimental Charplume': '魔力炼成：暗之劫火焚天',
      'Experimental Fireplume': '魔力炼成：劫火焚天',
      'Flames of Undeath': '返魂之炎',
      'Flare of Condemnation': '狱炎火击',
      'Fledgling Flight': '群鸟飞翔',
      'Heat of Condemnation': '狱炎炎击',
      'Joint Pyre': '共燃',
      'Left Cinderwing': '左翼焚烧',
      'Right Cinderwing': '右翼焚烧',
      'Scorched Exaltation': '灰烬火焰',
      'Searing Breeze': '热喷射',
      'Trail of Condemnation': '狱炎之焰'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Phoinix': '페넥스',
      'Sparkfledged': '화령조',
      'Sunbird': '양염조'
    },
    'replaceText': {
      '--fire expands--': '--불장판 커짐--',
      '--giant fireplume\\?--': '--특대 장판?--',
      'Ashen Eye': '어둠의 눈동자',
      'Blazing Rain': '불비',
      'Brightened Fire': '빛의 불꽃',
      '(?<!\\w )Charplume': '어둠의 겁화천초',
      'Darkened Fire': '어둠의 불꽃',
      'Dead Rebirth': '검은 불사조',
      'Devouring Brand': '십자 불길',
      'Experimental Charplume': '마력 연성: 어둠의 겁화천초',
      'Experimental Fireplume': '마력 연성: 겁화천초',
      'Flames of Undeath': '반혼의 불꽃',
      'Flare of Condemnation': '지옥불 화격',
      'Fledgling Flight': '새떼 비상',
      'Heat of Condemnation': '지옥불 염격',
      'Joint Pyre': '동반 연소',
      'Left Cinderwing/Right Cinderwing': '왼/오른날개 소각',
      'Scorched Exaltation': '잿더미 화염',
      'Searing Breeze': '열 분사',
      'Trail of Condemnation': '지옥불 불길'
    }
  }]
};
/* harmony default export */ const p3n = (p3n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p3n.txt
const raid_p3n_namespaceObject = "## Pandaemonium: Asphedolos, the Third Circle\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n# -ii 669F 66A7 66A8 66A0 66A1 66AF 66B0 66B3 6D0C 6DDC 6EDD\r\n# -ic \"Liturgic Bell\"\r\n# -it Phoinix\r\n# -p 66AD:118 66A3: 200\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n9.1 \"--sync--\" StartsUsing { id: [\"6696\", \"6698\"], source: \"Phoinix\" } window 9.1,5\r\n13.8 \"Experimental Fireplume\" Ability { id: [\"6696\", \"6698\"], source: \"Phoinix\" } window 13.8,5\r\n19.0 \"--giant fireplume?--\" #Ability { id: [\"6697\", \"6699\"], source: \"Phoinix\" }\r\n31.0 \"Experimental Fireplume\" Ability { id: [\"6696\", \"6698\"], source: \"Phoinix\" }\r\n37.1 \"--giant fireplume?--\" #Ability { id: [\"6697\", \"6699\"], source: \"Phoinix\" }\r\n49.2 \"Scorched Exaltation\" Ability { id: \"66B8\", source: \"Phoinix\" }\r\n61.4 \"Heat of Condemnation\" Ability { id: \"66B2\", source: \"Phoinix\" } window 61.4,10\r\n75.6 \"Darkened Fire\" Ability { id: \"6EDA\", source: \"Phoinix\" }\r\n85.7 \"--sync--\" Ability { id: \"6EDC\", source: \"Phoinix\" }\r\n86.1 \"Brightened Fire #1\" #Ability { id: \"6EDD\", source: \"Phoinix\" }\r\n87.2 \"Brightened Fire #2\" #Ability { id: \"6EDD\", source: \"Phoinix\" }\r\n88.4 \"Brightened Fire #3\" #Ability { id: \"6EDD\", source: \"Phoinix\" }\r\n89.5 \"Brightened Fire #4\" #Ability { id: \"6EDD\", source: \"Phoinix\" }\r\n105.6 \"Left Cinderwing/Right Cinderwing\" Ability { id: [\"66B4\", \"66B5\"], source: \"Phoinix\" }\r\n\r\n# There might be an enrage here? More data will be needed.\r\n110.7 \"--untargetable--\"\r\n118.0 \"Trail of Condemnation\" Ability { id: \"66AD\", source: \"Phoinix\" } window 118.0,10\r\n126.8 \"--adds targetable--\"\r\n127.0 \"Blazing Rain\" Ability { id: \"66A2\", source: \"Phoinix\" }\r\n135.1 \"Blazing Rain\" Ability { id: \"66A2\", source: \"Phoinix\" } jump 127\r\n143.2 \"Blazing Rain\"\r\n151.3 \"Blazing Rain\"\r\n159.4 \"Blazing Rain\"\r\n167.5 \"Blazing Rain\"\r\n175.6 \"Blazing Rain\"\r\n183.7 \"Blazing Rain\"\r\n\r\n# There's no cast time on this ability.\r\n200.0 \"Flames of Undeath\" Ability { id: \"66A3\", source: \"Phoinix\" } window 200,10\r\n202.0 \"--targetable--\"\r\n\r\n# Post-intermission block, small differences from main rotation block.\r\n203.4 \"Blazing Rain\" Ability { id: \"66A2\", source: \"Phoinix\" }\r\n206.2 \"Joint Pyre\" Ability { id: \"66A5\", source: \"Sparkfledged\" }\r\n209.1 \"--sync--\" Ability { id: \"66AC\", source: \"Phoinix\" }\r\n221.2 \"Dead Rebirth\" Ability { id: \"66A9\", source: \"Phoinix\" } window 221.2,60\r\n231.4 \"Left Cinderwing/Right Cinderwing\" Ability { id: [\"66B4\", \"66B5\"], source: \"Phoinix\" }\r\n239.6 \"Fledgling Flight\" Ability { id: \"66AA\", source: \"Phoinix\" }\r\n253.8 \"Ashen Eye #1\" #Ability { id: \"66AB\", source: \"Sparkfledged\" }\r\n255.7 \"Ashen Eye #2\" #Ability { id: \"66AB\", source: \"Sparkfledged\" }\r\n257.7 \"Experimental Charplume\" Ability { id: \"669C\", source: \"Phoinix\" }\r\n257.7 \"Ashen Eye #3\" #Ability { id: \"66AB\", source: \"Sparkfledged\" }\r\n259.7 \"Ashen Eye #4\" #Ability { id: \"66AB\", source: \"Sparkfledged\" }\r\n262.8 \"Charplume\" Ability { id: \"669D\", source: \"Phoinix\" }\r\n262.8 \"--sync--\" Ability { id: \"66AC\", source: \"Phoinix\" }\r\n277.9 \"Heat of Condemnation\" Ability { id: \"66B2\", source: \"Phoinix\" }\r\n289.2 \"--sync--\" Ability { id: \"669E\", source: \"Phoinix\" }\r\n291.3 \"Devouring Brand\" Ability { id: \"66A0\", source: \"Phoinix\" } duration 13\r\n300.7 \"--fire expands--\" Ability { id: \"6D82\", source: \"Phoinix\" }\r\n305.6 \"--sync--\" Ability { id: \"66B6\", source: \"Phoinix\" }\r\n308.7 \"Searing Breeze\" Ability { id: \"66B7\", source: \"Phoinix\" }\r\n316.8 \"Scorched Exaltation\" Ability { id: \"66B8\", source: \"Phoinix\" }\r\n326.0 \"Experimental Charplume\" Ability { id: \"669C\", source: \"Phoinix\" }\r\n331.1 \"Charplume\" Ability { id: \"669D\", source: \"Phoinix\" }\r\n335.1 \"Experimental Fireplume\" Ability { id: [\"6696\", \"6698\"], source: \"Phoinix\" } window 30,30\r\n341.2 \"--giant fireplume?--\" #Ability { id: [\"6697\", \"6699\"], source: \"Phoinix\" }\r\n349.2 \"--untargetable--\"\r\n356.5 \"Trail of Condemnation\" Ability { id: \"66AD\", source: \"Phoinix\" }\r\n361.2 \"--targetable--\"\r\n\r\n# Rotation block\r\n369.3 \"Heat of Condemnation\" Ability { id: \"66B2\", source: \"Phoinix\" }\r\n378.5 \"Fledgling Flight\" Ability { id: \"66AA\", source: \"Phoinix\" }\r\n392.4 \"Ashen Eye #1\" #Ability { id: \"66AB\", source: \"Sparkfledged\" }\r\n394.3 \"Ashen Eye #2\" #Ability { id: \"66AB\", source: \"Sparkfledged\" }\r\n396.3 \"Ashen Eye #3\" #Ability { id: \"66AB\", source: \"Sparkfledged\" }\r\n398.3 \"Ashen Eye #4\" #Ability { id: \"66AB\", source: \"Sparkfledged\" }\r\n399.7 \"Experimental Fireplume\" Ability { id: [\"6696\", \"6698\"], source: \"Phoinix\" }\r\n405.8 \"--giant fireplume?--\" #Ability { id: [\"6697\", \"6699\"], source: \"Phoinix\" }\r\n405.9 \"--sync--\" Ability { id: \"66AC\", source: \"Phoinix\" }\r\n417.0 \"--sync--\" Ability { id: \"66B6\", source: \"Phoinix\" }\r\n420.1 \"Searing Breeze x3\" #Ability { id: \"66B7\", source: \"Phoinix\" }\r\n422.1 \"Devouring Brand\" Ability { id: \"669E\", source: \"Phoinix\" } duration 15\r\n433.4 \"Darkened Fire\" Ability { id: \"6EDA\", source: \"Phoinix\" }\r\n433.8 \"--fire expands--\" Ability { id: \"6D82\", source: \"Phoinix\" }\r\n443.7 \"--sync--\" Ability { id: \"6EDC\", source: \"Phoinix\" }\r\n444.0 \"Brightened Fire #1\" #Ability { id: \"6EDD\", source: \"Phoinix\" }\r\n445.2 \"Brightened Fire #2\" #Ability { id: \"6EDD\", source: \"Phoinix\" }\r\n446.3 \"Brightened Fire #3\" #Ability { id: \"6EDD\", source: \"Phoinix\" }\r\n447.5 \"Brightened Fire #4\" #Ability { id: \"6EDD\", source: \"Phoinix\" }\r\n463.6 \"Left Cinderwing/Right Cinderwing\" Ability { id: [\"66B4\", \"66B5\"], source: \"Phoinix\" } window 30,30\r\n474.7 \"Scorched Exaltation\" Ability { id: \"66B8\", source: \"Phoinix\" }\r\n484.9 \"Experimental Charplume\" Ability { id: \"669C\", source: \"Phoinix\" }\r\n490.0 \"Charplume\" Ability { id: \"669D\", source: \"Phoinix\" }\r\n494.0 \"Experimental Fireplume\" Ability { id: [\"6696\", \"6698\"], source: \"Phoinix\" } window 30,30\r\n500.1 \"--giant fireplume?--\" #Ability { id: [\"6697\", \"6699\"], source: \"Phoinix\" }\r\n508.1 \"--untargetable--\"\r\n515.4 \"Trail of Condemnation\" Ability { id: \"66AD\", source: \"Phoinix\" }\r\n518.9 \"Flare of Condemnation\" Ability { id: \"66B0\", source: \"Phoinix\" }\r\n520.1 \"--targetable--\"\r\n\r\n528.2 \"Heat of Condemnation\" Ability { id: \"66B2\", source: \"Phoinix\" } jump 369.3\r\n537.4 \"Fledgling Flight\"\r\n551.3 \"Ashen Eye #1\"\r\n553.2 \"Ashen Eye #2\"\r\n555.2 \"Ashen Eye #3\"\r\n557.2 \"Ashen Eye #4\"\r\n558.6 \"Experimental Fireplume\"\r\n564.7 \"--giant fireplume?--\"\r\n\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p3s.ts





// Due to changes introduced in patch 5.2, overhead markers now have a random offset
// added to their ID. This offset currently appears to be set per instance, so
// we can determine what it is from the first overhead marker we see.
// The first 1B marker in the encounter is the #1 Bright Fire marker (004F).
const p3s_firstHeadmarker = parseInt('004F', 16);
const p3s_getHeadmarkerId = (data, matches) => {
  // If we naively just check !data.decOffset and leave it, it breaks if the first marker is 00DA.
  // (This makes the offset 0, and !0 is true.)
  if (typeof data.decOffset === 'undefined') data.decOffset = parseInt(matches.id, 16) - p3s_firstHeadmarker;
  // The leading zeroes are stripped when converting back to string, so we re-add them here.
  // Fortunately, we don't have to worry about whether or not this is robust,
  // since we know all the IDs that will be present in the encounter.
  return (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase().padStart(4, '0');
};
const p3s_triggerSet = {
  id: 'AsphodelosTheThirdCircleSavage',
  zoneId: zone_id/* default.AsphodelosTheThirdCircleSavage */.Z.AsphodelosTheThirdCircleSavage,
  timelineFile: 'p3s.txt',
  initData: () => {
    return {
      sunbirds: [],
      sunbirdTethers: []
    };
  },
  triggers: [{
    id: 'P3S Headmarker Tracker',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.decOffset === undefined,
    // Unconditionally set the first headmarker here so that future triggers are conditional.
    run: (data, matches) => p3s_getHeadmarkerId(data, matches)
  }, {
    id: 'P3S Scorched Exaltation',
    type: 'StartsUsing',
    netRegex: {
      id: '6706',
      source: 'Phoinix',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P3S Darkened Fire',
    type: 'StartsUsing',
    netRegex: {
      id: '66B9',
      source: 'Phoinix',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Fire Positions',
        de: 'Feuer-Positionen',
        fr: 'Positions pour les flammes',
        ja: '黒い炎の位置に散開',
        cn: '暗炎站位',
        ko: '불꽃 산개'
      }
    }
  }, {
    id: 'P3S Heat of Condemnation',
    type: 'StartsUsing',
    netRegex: {
      id: '6700',
      source: 'Phoinix',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank Tethers',
        de: 'Tank-Verbindungen',
        fr: 'Liens Tank',
        ja: 'タンク線取り',
        cn: '坦克截线',
        ko: '탱커가 선 가로채기'
      }
    }
  }, {
    id: 'P3S Experimental Fireplume Rotating Cast',
    type: 'StartsUsing',
    netRegex: {
      id: '66C0',
      source: 'Phoinix',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Middle (then rotate)',
        de: 'Geh in die Mitte (und rotiere dann)',
        fr: 'Placez-vous au milieu (puis tournez)',
        ja: '中央 → 小玉・ぐるぐる',
        cn: '中间集合, 九连环',
        ko: '가운데 → 작은 구슬, 바깥 회전 장판'
      }
    }
  }, {
    id: 'P3S Experimental Fireplume Out Cast',
    type: 'StartsUsing',
    netRegex: {
      id: '66BE',
      source: 'Phoinix',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Middle (then out)',
        de: 'Geh in die Mitte (und dann raus)',
        fr: 'Placez-vous au milieu (puis sortez)',
        ja: '中央 → 大玉・離れる',
        cn: '中间集合, 然后远离',
        ko: '가운데 → 큰 구슬, 밖으로'
      }
    }
  }, {
    id: 'P3S Experimental Fireplume Out Marker',
    type: 'Ability',
    netRegex: {
      id: '66BE',
      source: 'Phoinix',
      capture: false
    },
    // goldfish brain needs an extra "get out" call
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'P3S Right Cinderwing',
    type: 'StartsUsing',
    netRegex: {
      id: '6702',
      source: 'Phoinix',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'P3S Left Cinderwing',
    type: 'StartsUsing',
    netRegex: {
      id: '6703',
      source: 'Phoinix',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'P3S Flare of Condemnation',
    type: 'StartsUsing',
    netRegex: {
      id: '66FB',
      source: 'Phoinix',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Sides + Spread',
        de: 'Seiten + Verteilen',
        fr: 'Côtés + Dispersez-vous',
        ja: '横側安置：散開',
        cn: '两侧 + 分散',
        ko: '바깥쪽에서 산개'
      }
    }
  }, {
    id: 'P3S Spark of Condemnation',
    type: 'StartsUsing',
    netRegex: {
      id: '66FC',
      source: 'Phoinix',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Middle Pairs',
        de: 'Mittlere Paare',
        fr: 'Paires au milieu',
        ja: '中央直線安置：二人組で頭割り',
        cn: '中间 两人分摊',
        ko: '가운데서 2명씩 산개'
      }
    }
  }, {
    id: 'P3S Bright Fire Marker and Fledgling Flights',
    type: 'HeadMarker',
    netRegex: {},
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (data, matches, output) => {
      const id = p3s_getHeadmarkerId(data, matches);
      return {
        '004F': output.num1(),
        '0050': output.num2(),
        '0051': output.num3(),
        '0052': output.num4(),
        '0053': output.num5(),
        '0054': output.num6(),
        '0055': output.num7(),
        '0056': output.num8(),
        '006B': data.deathsToll ? output.west() : output.east(),
        '006C': data.deathsToll ? output.east() : output.west(),
        '006D': data.deathsToll ? output.north() : output.south(),
        '006E': data.deathsToll ? output.south() : output.north()
      }[id];
    },
    outputStrings: {
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      num5: outputs/* default.num5 */.Z.num5,
      num6: outputs/* default.num6 */.Z.num6,
      num7: outputs/* default.num7 */.Z.num7,
      num8: outputs/* default.num8 */.Z.num8,
      east: outputs/* default.east */.Z.east,
      west: outputs/* default.west */.Z.west,
      south: outputs/* default.south */.Z.south,
      north: outputs/* default.north */.Z.north
    }
  }, {
    id: 'P3S Sunbird Tether Collector',
    type: 'Tether',
    // 0039 when pink, 0001 when stretched purple.
    // TODO: in general, it seems like the tethers are picked to start unstretched,
    // but plausibly you could create a scenario where one starts stretched?
    netRegex: {
      source: 'Sunbird',
      id: ['0039', '0001']
    },
    run: (data, matches) => data.sunbirdTethers.push(matches)
  }, {
    id: 'P3S Sunbird Collector',
    type: 'AddedCombatant',
    // Small birds are 13633, and big birds are 13635.
    netRegex: {
      npcBaseId: '13635'
    },
    run: (data, matches) => data.sunbirds.push(matches)
  }, {
    id: 'P3S Sunbird Tether',
    type: 'Tether',
    // There is no need for a delay here, because all of the tethers are ordered:
    //   SunbirdA => Player1
    //   Player1 => Player2
    //   SunbirdB => Player3
    //   Player3 => Player4
    // ...therefore if this tether has the current player as a target, then we
    // will have seen the Sunbird => Player tether previously if it exists in the
    // Sunbird Tether Collector line.
    netRegex: {
      id: ['0039', '0001']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // There are additional tether lines when you stretch/unstretch the tether, and
    // adds will re-tether somebody new if somebody dies right before dashing.  Only call once.
    suppressSeconds: 9999,
    alertText: (data, matches, output) => {
      const myTether = matches;
      const parentTether = data.sunbirdTethers.find(x => x.targetId === myTether.sourceId);
      const birdId = parentTether?.sourceId ?? myTether.sourceId;
      const bird = data.sunbirds.find(x => x.id === birdId);
      if (!bird) {
        // Note: 0001 tethers happen later with the Sunshadow birds during the Fountain of Fire
        // section.  In most cases, a player will get a tether during add phase and then this
        // will be suppressed in the fountain section.  In the rare case they don't, they
        // may get this error, but nothing will be printed on screen.
        console.error(`SunbirdTether: no bird ${birdId}`);
        return;
      }
      const centerX = 100;
      const centerY = 100;
      const x = parseFloat(bird.x) - centerX;
      const y = parseFloat(bird.y) - centerY;
      const birdDir = Math.round(4 - 4 * Math.atan2(x, y) / Math.PI) % 8;
      const adjustedDir = (birdDir + (parentTether === undefined ? 4 : 0)) % 8;
      const outputDir = {
        0: output.north(),
        1: output.northeast(),
        2: output.east(),
        3: output.southeast(),
        4: output.south(),
        5: output.southwest(),
        6: output.west(),
        7: output.northwest()
      }[adjustedDir];
      if (outputDir === undefined) throw new not_reached/* UnreachableCode */.$();
      if (parentTether) {
        return output.playerTether({
          dir: outputDir,
          player: data.party.member(myTether.source)
        });
      }
      return output.birdTether({
        dir: outputDir
      });
    },
    outputStrings: {
      playerTether: {
        en: '${dir} (away from ${player})',
        de: '${dir} (weg von ${player})',
        fr: '${dir} (éloignez-vous de ${player})',
        ja: '${dir} (${player}と繋がる)',
        cn: '${dir} (远离${player})',
        ko: '${dir} (${player}에게서 멀리 떨어지기)'
      },
      birdTether: {
        en: '${dir} (away from bird)',
        de: '${dir} (weg vom Vogel)',
        fr: '${dir} (éloignez-vous de l\'oiseau)',
        ja: '${dir} (鳥と繋がる)',
        cn: '${dir} (远离鸟)',
        ko: '${dir} (새와 멀리 떨어지기)'
      },
      north: outputs/* default.north */.Z.north,
      northeast: outputs/* default.northeast */.Z.northeast,
      east: outputs/* default.east */.Z.east,
      southeast: outputs/* default.southeast */.Z.southeast,
      south: outputs/* default.south */.Z.south,
      southwest: outputs/* default.southwest */.Z.southwest,
      west: outputs/* default.west */.Z.west,
      northwest: outputs/* default.northwest */.Z.northwest
    }
  }, {
    id: 'P3S Dead Rebirth',
    type: 'StartsUsing',
    netRegex: {
      id: '66E4',
      source: 'Phoinix',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'P3S Experimental Gloryplume Rotate Cast',
    type: 'StartsUsing',
    // 66CA (self) -> 66CB (rotating) -> etc
    netRegex: {
      id: '66CA',
      source: 'Phoinix',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Middle (then rotate)',
        de: 'Geh in die Mitte (und rotiere dann)',
        fr: 'Placez-vous au milieu (puis tournez)',
        ja: '中央 → 小玉・ぐるぐる',
        cn: '中间集合, 九连环',
        ko: '가운데 → 작은 구슬, 바깥 회전 장판'
      }
    }
  }, {
    id: 'P3S Experimental Gloryplume Out Cast',
    type: 'StartsUsing',
    // 66C6 (self) -> 66C7 (middle) -> etc
    netRegex: {
      id: '66C6',
      source: 'Phoinix',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Middle (then out)',
        de: 'Geh in die Mitte (und dann raus)',
        fr: 'Placez-vous au milieu (puis sortez)',
        ja: '中央 → 大玉・離れる',
        cn: '中间集合, 然后远离',
        ko: '가운데 → 큰 구슬, 밖으로'
      }
    }
  }, {
    id: 'P3S Experimental Gloryplume Out',
    type: 'Ability',
    // 66C6 (self) -> 66C7 (middle) -> etc
    netRegex: {
      id: '66C6',
      source: 'Phoinix',
      capture: false
    },
    // If you hang around to wait for the spread/stack, you will get killed.
    // It's easy to get complacement by the end of the fight, so make this loud.
    response: responses/* Responses.getOut */.n3.getOut('alarm')
  }, {
    id: 'P3S Experimental Gloryplume Stack',
    type: 'Ability',
    // 66CA (self) -> 66CB (rotating) -> 66CC (instant) -> 66CD (stacks)
    // 66C6 (self) -> 66C7 (middle) -> 66CC (instant) -> 66CD (stacks)
    netRegex: {
      id: '66CC',
      source: 'Phoinix',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stacks After',
        de: 'Danach sammeln',
        fr: 'Packez-vous après',
        ja: 'あとは頭割り',
        cn: '然后分摊',
        ko: '그 다음 쉐어'
      }
    }
  }, {
    id: 'P3S Experimental Gloryplume Spread',
    type: 'Ability',
    // 66CA (self) -> 66CB (rotating) -> 66C8 (instant) -> 66C9 (spread)
    // 66C6 (self) -> 66C7 (middle) -> 66C8 (instant) -> 66C9 (spread)
    netRegex: {
      id: '66C8',
      source: 'Phoinix',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread After',
        de: 'Danach verteilen',
        fr: 'Dispersez-vous après',
        ja: 'あとは散開',
        cn: '然后分散',
        ko: '그 다음 산개'
      }
    }
  }, {
    id: 'P3S Sun\'s Pinion',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => data.me === matches.target && p3s_getHeadmarkerId(data, matches) === '007A',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread => Bird Tether',
        de: 'Verteilen => Vogel-Verbindungen',
        fr: 'Dispersez-vous => Liens oiseaux',
        ja: '散開 => 鳥の線',
        cn: '散开 => 鸟连线',
        ko: '산개 => 새 줄 연결'
      }
    }
  }, {
    id: 'P3S Firestorms of Asphodelos',
    type: 'StartsUsing',
    netRegex: {
      id: '66F0',
      source: 'Phoinix',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'P3S Experimental Ashplume Stacks',
    type: 'Ability',
    // 66C2 cast -> 66C3 stacks damage
    netRegex: {
      id: '66C2',
      source: 'Phoinix',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stacks',
        de: 'Sammeln',
        fr: 'Packez-vous',
        ja: '頭割り',
        cn: '分摊',
        ko: '쉐어'
      }
    }
  }, {
    id: 'P3S Experimental Ashplume Spread',
    type: 'Ability',
    // 66C4 cast -> 66C5 spread damage
    netRegex: {
      id: '66C4',
      source: 'Phoinix',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread',
        de: 'Verteilen',
        fr: 'Dispersez-vous',
        ja: '散開',
        cn: '分散',
        ko: '산개'
      }
    }
  }, {
    id: 'P3S Death\'s Toll Number',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['ACA'],
      capture: true
    },
    // Force this to only run once without Conditions.targetIsYou()
    // in case user is dead but needs to place fledgling flight properly
    preRun: data => data.deathsToll = true,
    // Delay callout until Ashen Eye start's casting
    delaySeconds: 15.5,
    infoText: (data, matches, output) => {
      if (matches.target === data.me && !data.deathsTollPending) {
        data.deathsTollPending = true;
        return {
          '01': output.outCardinals(),
          '02': output.outIntercards(),
          '04': output.middle()
        }[matches.count];
      }
    },
    outputStrings: {
      middle: outputs/* default.middle */.Z.middle,
      outIntercards: {
        en: 'Intercards + Out',
        de: 'Interkardinal + Raus',
        fr: 'Intercadinal + Extérieur',
        ja: '斜め + 外側',
        cn: '斜角 + 外侧',
        ko: '대각선 + 바깥'
      },
      outCardinals: {
        en: 'Out + Cardinals',
        de: 'Raus + Kardinal',
        fr: 'Extérieur + Cardinal',
        ja: '外側 + 十字',
        cn: '外侧 + 十字',
        ko: '바깥 + 십자'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Left Cinderwing/Right Cinderwing': 'Left/Right Cinderwing',
      'Flare of Condemnation/Sparks of Condemnation': 'Flare/Sparks of Condemnation'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Darkblaze Twister': 'Schwarzlohensturm',
      'Fountain of Fire': 'Quell des Feuers',
      'Phoinix': 'Phoinix',
      'Sparkfledged': 'Saat des Phoinix',
      'Sunbird': 'Spross des Phoinix'
    },
    'replaceText': {
      '--fire expands--': '--Feuer breitet sich aus--',
      '--giant fireplume\\?--': '--riesige Feuerfieder?--',
      'Ashen Eye': 'Aschener Blick',
      '(?<!\\w )Ashplume': 'Aschenfieder',
      'Beacons of Asphodelos': 'Asphodeische Flamme',
      'Blazing Rain': 'Flammender Regen',
      'Brightened Fire': 'Lichte Lohe',
      'Burning Twister': 'Lohenwinde',
      'Dark Twister': 'Schwarze Winde',
      'Darkblaze Twister': 'Schwarzlohensturm',
      'Darkened Fire': 'Schwarze Lohe',
      'Dead Rebirth': 'Melaphoinix',
      'Death\'s Toll': 'Eid des Abschieds',
      'Devouring Brand': 'Kreuzbrand',
      'Experimental Ashplume': 'Experimentelle Aschenfieder',
      'Experimental Fireplume': 'Experimentelle Feuerfieder',
      'Experimental Gloryplume': 'Experimentelle Prachtfieder',
      'Final Exaltation': 'Ewige Asche',
      'Fireglide Sweep': 'Gleitjagd',
      'Firestorms of Asphodelos': 'Asphodeischer Feuersturm',
      'Flames of Asphodelos': 'Asphodeisches Feuer',
      'Flames of Undeath': 'Totenflamme',
      'Flare of Condemnation': 'Limbische Flamme',
      'Fledgling Flight': 'Flüggewerden',
      'Fountain of Death': 'Quell des Todes',
      'Fountain of Fire': 'Quell des Feuers',
      '(?<!\\w )Gloryplume': 'Prachtfieder',
      'Great Whirlwind': 'Windhose',
      'Heat of Condemnation': 'Limbisches Lodern',
      'Joint Pyre': 'Gemeinschaft des Feuers',
      'Left Cinderwing': 'Linke Aschenschwinge',
      'Life\'s Agonies': 'Lohen des Lebens',
      'Right Cinderwing': 'Rechte Aschenschwinge',
      'Scorched Exaltation': 'Aschenlohe',
      'Searing Breeze': 'Sengender Hauch',
      'Sparks of Condemnation': 'Limbische Glut',
      '(?<!fire)Storms of Asphodelos': 'Asphodeischer Sturm',
      'Sun\'s Pinion': 'Schwelende Schwinge',
      'Trail of Condemnation': 'Limbischer Odem',
      'Winds of Asphodelos': 'Asphodeische Winde'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Darkblaze Twister': 'Tourbillon enflammé des Limbes',
      'Fountain of Fire': 'Flamme de la vie',
      'Phoinix': 'protophénix',
      'Sparkfledged': 'oiselet de feu',
      'Sunbird': 'oiselet étincelant'
    },
    'replaceText': {
      '\\?': ' ?',
      '--fire expands--': '--élargissement du feu--',
      '--giant fireplume': '--immolation de feu géant',
      'Ashen Eye': 'Œil sombre',
      '(?<!\\w )Ashplume': 'Immolation de feu ténébreux',
      'Beacons of Asphodelos': 'Feu des Limbes',
      'Blazing Rain': 'Pluie brûlante',
      'Brightened Fire': 'Flamme de lumière',
      'Burning Twister': 'Tourbillon enflammé',
      'Dark Twister': 'Tourbillon sombre',
      'Darkblaze Twister': 'Tourbillon enflammé des Limbes',
      'Darkened Fire': 'Flamme sombre',
      'Dead Rebirth': 'Phénix noir',
      'Death\'s Toll': 'Destin mortel',
      'Devouring Brand': 'Croix enflammée',
      'Experimental Ashplume': 'Synthèse de mana : immolation de feu ténébreux',
      'Experimental Fireplume': 'Synthèse de mana : immolation de feu',
      'Experimental Gloryplume': 'Synthèse de mana : feu des profondeurs',
      'Final Exaltation': 'Conflagration calcinante',
      'Fireglide Sweep': 'Plongeons en chaîne',
      'Firestorms of Asphodelos': 'Volcan des Limbes',
      'Flames of Asphodelos': 'Flamme des Limbes',
      'Flames of Undeath': 'Feu réincarné',
      'Flare of Condemnation/Sparks of Condemnation': 'Souffle/Artifice infernal',
      'Fledgling Flight': 'Nuée ailée',
      'Fountain of Death': 'Onde de la vie',
      'Fountain of Fire': 'Flamme de la vie',
      '(?<!\\w )Gloryplume': 'Feu des profondeurs',
      'Great Whirlwind': 'Grand tourbillon',
      'Heat of Condemnation': 'Bourrasque infernale',
      'Joint Pyre': 'Combustion résonnante',
      'Left Cinderwing/Right Cinderwing': 'Incinération senestre/dextre',
      'Life\'s Agonies': 'Flamme de souffrance',
      'Scorched Exaltation': 'Flamme calcinante',
      'Searing Breeze': 'Jet incandescent',
      '(?<!fire)Storms of Asphodelos': 'Tempête des Limbes',
      'Sun\'s Pinion': 'Ailes étincelantes',
      'Trail of Condemnation': 'Embrasement infernal',
      'Winds of Asphodelos': 'Tempête des Limbes'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Darkblaze Twister': '辺獄の闇炎旋風',
      'Fountain of Fire': '霊泉の炎',
      'Phoinix': 'フェネクス',
      'Sparkfledged': '火霊鳥',
      'Sunbird': '陽炎鳥'
    },
    'replaceText': {
      'Ashen Eye': '闇の瞳',
      '(?<!\\w )Ashplume': '暗闇の劫火天焦',
      'Beacons of Asphodelos': '辺獄の火',
      'Blazing Rain': '炎の雨',
      'Brightened Fire': '光の炎',
      'Burning Twister': '炎旋風',
      'Dark Twister': '闇旋風',
      'Darkblaze Twister': '辺獄の闇炎旋風',
      'Darkened Fire': '闇の炎',
      'Dead Rebirth': '黒き不死鳥',
      'Death\'s Toll': '死の運命',
      'Devouring Brand': '十字走火',
      'Experimental Ashplume': '魔力錬成：暗闇の劫火天焦',
      'Experimental Fireplume': '魔力錬成：劫火天焦',
      'Experimental Gloryplume': '魔力錬成：炎闇劫火',
      'Final Exaltation': '灰燼の豪炎',
      'Fireglide Sweep': '連続強襲滑空',
      'Firestorms of Asphodelos': '辺獄の炎嵐',
      'Flames of Asphodelos': '辺獄の炎',
      'Flames of Undeath': '反魂の炎',
      'Flare of Condemnation': '獄炎の火撃',
      'Fledgling Flight': '群鳥飛翔',
      'Fountain of Death': '霊泉の波動',
      'Fountain of Fire': '霊泉の炎',
      '(?<!\\w )Gloryplume': '炎闇劫火',
      'Great Whirlwind': '大旋風',
      'Heat of Condemnation': '獄炎の炎撃',
      'Joint Pyre': '共燃',
      'Left Cinderwing': '左翼焼却',
      'Life\'s Agonies': '生苦の炎',
      'Right Cinderwing': '右翼焼却',
      'Scorched Exaltation': '灰燼の炎',
      'Searing Breeze': '熱噴射',
      'Sparks of Condemnation': '獄炎の火花',
      '(?<!fire)Storms of Asphodelos': '辺獄の嵐',
      'Sun\'s Pinion': '陽炎の翼',
      'Trail of Condemnation': '獄炎の焔',
      'Winds of Asphodelos': '辺獄の風'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Darkblaze Twister': '边境暗炎旋风',
      'Fountain of Fire': '灵泉之炎',
      'Phoinix': '菲尼克司',
      'Sparkfledged': '火灵鸟',
      'Sunbird': '阳炎鸟'
    },
    'replaceText': {
      '--fire expands--': '--火焰扩大--',
      '--giant fireplume\\?--': '--巨大火柱?--',
      'Ashen Eye': '暗之瞳',
      '(?<!\\w )Ashplume': '暗黑劫火焚天',
      'Beacons of Asphodelos': '边境之火',
      'Blazing Rain': '炎之雨',
      'Brightened Fire': '光之炎',
      'Burning Twister': '炎旋风',
      'Dark Twister': '暗旋风',
      'Darkblaze Twister': '边境暗炎旋风',
      'Darkened Fire': '暗之炎',
      'Dead Rebirth': '黑暗不死鸟',
      'Death\'s Toll': '死亡的命运',
      'Devouring Brand': '十字地火',
      'Experimental Ashplume': '魔力炼成：暗黑劫火焚天',
      'Experimental Fireplume': '魔力炼成：劫火焚天',
      'Experimental Gloryplume': '魔力炼成：炎暗劫火',
      'Final Exaltation': '灰烬豪焰',
      'Fireglide Sweep': '连续滑空强袭',
      'Firestorms of Asphodelos': '边境火焰风暴',
      'Flames of Asphodelos': '边境火焰',
      'Flames of Undeath': '返魂之炎',
      'Flare of Condemnation': '狱炎火击',
      'Fledgling Flight': '群鸟飞翔',
      'Fountain of Death': '灵泉之波动',
      'Fountain of Fire': '灵泉之炎',
      '(?<!\\w )Gloryplume': '炎暗劫火',
      'Great Whirlwind': '大旋风',
      'Heat of Condemnation': '狱炎炎击',
      'Joint Pyre': '共燃',
      'Left Cinderwing': '左翼焚烧',
      'Life\'s Agonies': '生苦之炎',
      'Right Cinderwing': '右翼焚烧',
      'Scorched Exaltation': '灰烬火焰',
      'Searing Breeze': '热喷射',
      'Sparks of Condemnation': '狱炎火花',
      '(?<!fire)Storms of Asphodelos': '边境风暴',
      'Sun\'s Pinion': '阳炎之翼',
      'Trail of Condemnation': '狱炎之焰',
      'Winds of Asphodelos': '边境之风'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Darkblaze Twister': '어둠불꽃 회오리',
      'Fountain of Fire': '영검의 불꽃',
      'Phoinix': '페넥스',
      'Sparkfledged': '화령조',
      'Sunbird': '양염조'
    },
    'replaceText': {
      '--fire expands--': '--불장판 커짐--',
      '--giant fireplume\\?--': '--특대 장판?--',
      'Ashen Eye': '어둠의 눈동자',
      '(?<!\\w )Ashplume': '암흑의 겁화천초',
      'Beacons of Asphodelos': '변옥의 불',
      'Blazing Rain': '불비',
      'Brightened Fire': '빛의 불꽃',
      'Burning Twister': '불꽃 회오리',
      'Dark Twister': '어둠 회오리',
      'Darkblaze Twister': '변옥의 어둠불꽃 회오리',
      'Darkened Fire': '어둠의 불꽃',
      'Dead Rebirth': '검은 불사조',
      'Death\'s Toll': '죽음의 운명',
      'Devouring Brand': '십자 불길',
      'Experimental Ashplume': '마력 연성: 암흑의 겁화천초',
      'Experimental Fireplume': '마력 연성: 겁화천초',
      'Experimental Gloryplume': '마력 연성: 염암겁화',
      'Final Exaltation': '잿더미 대화염',
      'Fireglide Sweep': '연속 강습 활공',
      'Firestorms of Asphodelos': '변옥의 화염 폭풍',
      'Flames of Asphodelos': '변옥의 화염',
      'Flames of Undeath': '반혼의 불꽃',
      'Flare of Condemnation/Sparks of Condemnation': '지옥불 화격/불똥',
      'Fledgling Flight': '새떼 비상',
      'Fountain of Death': '영검의 파동',
      'Fountain of Fire': '영검의 불꽃',
      '(?<!\\w )Gloryplume': '염암겁화',
      'Great Whirlwind': '대선풍',
      'Heat of Condemnation': '지옥불 염격',
      'Joint Pyre': '동반 연소',
      'Left Cinderwing/Right Cinderwing': '왼/오른날개 소각',
      'Life\'s Agonies': '생고의 불꽃',
      'Scorched Exaltation': '잿더미 화염',
      'Searing Breeze': '열 분사',
      '(?<!fire)Storms of Asphodelos': '변옥의 폭풍',
      'Sun\'s Pinion': '양염의 날개',
      'Trail of Condemnation': '지옥불 불길',
      'Winds of Asphodelos': '변옥의 바람'
    }
  }]
};
/* harmony default export */ const p3s = (p3s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p3s.txt
const raid_p3s_namespaceObject = "### P3S: Pandaemonium: Asphedolos, the Third Circle (Savage)\r\n# -p 6706:13.7 66E4:521.2\r\n# -it \"Phoinix\" \"Sunbird\"\r\n# -ii 6701 66C1 66BD 66BF 6D0D 66CF 66D0 66C1 66D1 66FD 6705 66CB 66EC 66C7 6DDD 6D0F\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Note: 66BF \"middle\" happens 6.2s after experimental fireplume\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n8.7 \"--sync--\" StartsUsing { id: \"6706\", source: \"Phoinix\" } window 10,10\r\n13.7 \"Scorched Exaltation\" Ability { id: \"6706\", source: \"Phoinix\" }\r\n22.8 \"Heat of Condemnation\" Ability { id: \"6700\", source: \"Phoinix\" }\r\n\r\n34.0 \"Experimental Fireplume\" Ability { id: [\"66BE\", \"66C0\"], source: \"Phoinix\" }\r\n40.1 \"--giant fireplume?--\" #Ability { id: \"66BF\", source: \"Phoinix\" }\r\n44.6 \"Left Cinderwing/Right Cinderwing\" Ability { id: [\"6702\", \"6703\"], source: \"Phoinix\" }\r\n58.8 \"Darkened Fire\" Ability { id: \"66B9\", source: \"Phoinix\" }\r\n69.0 \"Brightened Fire x8\" Ability { id: \"66BC\", source: \"Phoinix\" } duration 8.7\r\n96.5 \"Heat of Condemnation\" Ability { id: \"6700\", source: \"Phoinix\" }\r\n104.7 \"Scorched Exaltation\" Ability { id: \"6706\", source: \"Phoinix\" }\r\n114.9 \"Devouring Brand\" Ability { id: \"66CE\", source: \"Phoinix\" }\r\n122.0 \"Experimental Fireplume\" Ability { id: [\"66BE\", \"66C0\"], source: \"Phoinix\" }\r\n128.2 \"--giant fireplume?--\" #Ability { id: \"66BF\", source: \"Phoinix\" }\r\n131.9 \"--fire expands--\" Ability { id: \"6D83\", source: \"Phoinix\" }\r\n132.2 \"Searing Breeze\" Ability { id: \"6704\", source: \"Phoinix\" }\r\n140.4 \"Left Cinderwing/Right Cinderwing\" Ability { id: [\"6702\", \"6703\"], source: \"Phoinix\" }\r\n149.5 \"Heat of Condemnation\" Ability { id: \"6700\", source: \"Phoinix\" }\r\n157.6 \"Experimental Fireplume\" Ability { id: [\"66BE\", \"66C0\"], source: \"Phoinix\" }\r\n162.2 \"--untargetable--\"\r\n163.7 \"--giant fireplume?--\" #Ability { id: \"66BF\", source: \"Phoinix\" }\r\n\r\n172.0 \"Trail of Condemnation\" Ability { id: [\"66FB\", \"66FC\"], source: \"Phoinix\" }\r\n173.6 \"Flare of Condemnation/Sparks of Condemnation\" Ability { id: [\"66FE\", \"66FF\"], source: \"Phoinix\" }\r\n\r\n# Adds Phase 1\r\n180.8 \"--adds targetable--\"\r\n180.9 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n189.0 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n197.1 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n205.2 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n208.9 \"Great Whirlwind (enrage?)\" Ability { id: \"66D3\", source: \"Sunbird\" }\r\n\r\n# Adds Phase 2\r\n300.0 \"Flames of Undeath 1\" Ability { id: \"66D6\", source: \"Phoinix\" } window 300,0\r\n300.3 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n301.1 \"--adds targetable--\"\r\n303.3 \"Joint Pyre\" Ability { id: \"66D8\", source: \"Sunbird\" }\r\n303.8 \"Joint Pyre\" #Ability { id: \"66D8\", source: \"Sunbird\" }\r\n304.7 \"Joint Pyre\" Ability { id: \"66D8\", source: \"Sunbird\" }\r\n305.1 \"Joint Pyre\" #Ability { id: \"66D8\", source: \"Sunbird\" }\r\n308.3 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n316.4 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n317.2 \"Fireglide Sweep\" Ability { id: \"66E0\", source: \"Sunbird\" }\r\n317.5 \"Fireglide Sweep 1\" #Ability { id: \"66E1\", source: \"Sunbird\" }\r\n319.8 \"Fireglide Sweep 2\" #Ability { id: \"66E1\", source: \"Sunbird\" }\r\n324.4 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n332.5 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n340.6 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n348.7 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n354.1 \"Great Whirlwind (enrage?)\" Ability { id: \"66D5\", source: \"Sunbird\" }\r\n\r\n# Adds Phase 3\r\n500.0 \"Flames of Undeath 2\" Ability { id: \"66D6\", source: \"Phoinix\" } window 199,0\r\n\r\n502.0 \"--targetable--\"\r\n509.1 \"--sync--\" Ability { id: \"66AC\", source: \"Phoinix\" }\r\n511.2 \"--sync--\" StartsUsing { id: \"66E4\", source: \"Phoinix\" } window 600,20\r\n521.2 \"Dead Rebirth\" Ability { id: \"66E4\", source: \"Phoinix\" }\r\n\r\n536.4 \"Heat of Condemnation\" Ability { id: \"6700\", source: \"Phoinix\" }\r\n547.6 \"Fledgling Flight\" Ability { id: \"66AA\", source: \"Phoinix\" }\r\n561.9 \"Ashen Eye\" Ability { id: \"66E6\", source: \"Sparkfledged\" }\r\n\r\n564.8 \"--sync--\" Ability { id: \"66AC\", source: \"Phoinix\" }\r\n574.9 \"Experimental Gloryplume\" Ability { id: \"66CA\", source: \"Phoinix\" }\r\n577.5 \"--sync--\" Ability { id: [\"66CC\", \"66C8\"], source: \"Phoinix\" }\r\n588.1 \"Gloryplume\" Ability { id: [\"66CD\", \"66C9\"], source: \"Phoinix\" }\r\n606.1 \"Fountain of Fire\" Ability { id: \"66E7\", source: \"Phoinix\" }\r\n614.2 \"Sun's Pinion\" Ability { id: \"66EA\", source: \"Phoinix\" }\r\n614.2 \"Sun's Pinion 1\" Ability { id: \"66EB\", source: \"Phoinix\" }\r\n616.1 \"Fountain of Death 1\" Ability { id: \"66E9\", source: \"Fountain of Fire\" }\r\n619.3 \"Sun's Pinion 2\" Ability { id: \"66EB\", source: \"Phoinix\" }\r\n621.1 \"Fountain of Death 2\" Ability { id: \"66E9\", source: \"Fountain of Fire\" }\r\n624.3 \"Sun's Pinion 3\" Ability { id: \"66EB\", source: \"Phoinix\" }\r\n626.1 \"Fountain of Death 3\" Ability { id: \"66E9\", source: \"Fountain of Fire\" }\r\n631.1 \"Fountain of Death 4\" Ability { id: \"66E9\", source: \"Fountain of Fire\" }\r\n637.4 \"Scorched Exaltation\" Ability { id: \"6706\", source: \"Phoinix\" }\r\n644.5 \"Scorched Exaltation\" Ability { id: \"6706\", source: \"Phoinix\" }\r\n655.6 \"Heat of Condemnation\" Ability { id: \"6700\", source: \"Phoinix\" }\r\n\r\n661.8 \"--sync--\" Ability { id: \"6F16\", source: \"Phoinix\" }\r\n670.3 \"Firestorms of Asphodelos\" Ability { id: \"66F0\", source: \"Phoinix\" }\r\n\r\n676.5 \"Flames of Asphodelos\" Ability { id: \"66F1\", source: \"Phoinix\" }\r\n681.7 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n683.7 \"Experimental Ashplume\" Ability { id: [\"66C2\", \"66C4\"], source: \"Phoinix\" }\r\n684.5 \"Flames of Asphodelos 1\" Ability { id: \"66F2\", source: \"Phoinix\" }\r\n685.5 \"Flames of Asphodelos 2\" Ability { id: \"66F3\", source: \"Phoinix\" }\r\n686.5 \"Flames of Asphodelos 3\" Ability { id: \"66F4\", source: \"Phoinix\" }\r\n687.8 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n689.8 \"Ashplume\" Ability { id: [\"66C3\", \"66C5\"], source: \"Phoinix\" }\r\n\r\n694.8 \"Flames of Asphodelos\" Ability { id: \"66F1\", source: \"Phoinix\" }\r\n696.9 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n702.7 \"Flames of Asphodelos 1\" Ability { id: \"66F2\", source: \"Phoinix\" }\r\n703.7 \"Flames of Asphodelos 2\" Ability { id: \"66F3\", source: \"Phoinix\" }\r\n704.7 \"Flames of Asphodelos 3\" Ability { id: \"66F4\", source: \"Phoinix\" }\r\n708.9 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n\r\n712.9 \"Storms of Asphodelos\" Ability { id: \"66F5\", source: \"Phoinix\" }\r\n713.0 \"Winds of Asphodelos\" Ability { id: \"66F6\", source: \"Phoinix\" }\r\n713.1 \"Beacons of Asphodelos\" Ability { id: \"66F7\", source: \"Phoinix\" }\r\n719.0 \"Darkblaze Twister\" Ability { id: \"66F8\", source: \"Phoinix\" }\r\n721.0 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n726.1 \"Searing Breeze\" Ability { id: \"6704\", source: \"Phoinix\" }\r\n728.1 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n\r\n735.2 \"Experimental Ashplume\" Ability { id: [\"66C2\", \"66C4\"], source: \"Phoinix\" }\r\n736.2 \"Blazing Rain\" Ability { id: \"66D2\", source: \"Phoinix\" }\r\n738.0 \"Dark Twister\" Ability { id: \"66F9\", source: \"Darkblaze Twister\" }\r\n740.0 \"Burning Twister\" Ability { id: \"66FA\", source: \"Darkblaze Twister\" }\r\n742.3 \"Ashplume\" Ability { id: [\"66C3\", \"66C5\"], source: \"Phoinix\" }\r\n749.3 \"Scorched Exaltation\" Ability { id: \"6706\", source: \"Phoinix\" }\r\n\r\n762.5 \"Death's Toll\" Ability { id: \"66ED\", source: \"Phoinix\" }\r\n768.7 \"Fledgling Flight\" Ability { id: \"66AA\", source: \"Phoinix\" }\r\n783.0 \"Ashen Eye x4\" duration 3 #Ability { id: \"66E6\", source: \"Sparkfledged\" }\r\n\r\n794.9 \"Life's Agonies\" Ability { id: \"66EE\", source: \"Phoinix\" }\r\n798.1 \"--sync--\" Ability { id: \"66AC\", source: \"Phoinix\" }\r\n\r\n807.2 \"Experimental Gloryplume\" Ability { id: \"66C6\", source: \"Phoinix\" }\r\n809.8 \"--sync--\" Ability { id: [\"66CC\", \"66C8\"], source: \"Phoinix\" }\r\n814.4 \"Gloryplume\" Ability { id: [\"66CD\", \"66C9\"], source: \"Phoinix\" }\r\n817.3 \"--untargetable--\"\r\n827.1 \"Trail of Condemnation\" Ability { id: [\"66FB\", \"66FC\"], source: \"Phoinix\" }\r\n828.7 \"Flare of Condemnation/Sparks of Condemnation\" Ability { id: [\"66FE\", \"66FF\"], source: \"Phoinix\" }\r\n831.8 \"--targetable--\"\r\n839.9 \"Devouring Brand\" Ability { id: \"66CE\", source: \"Phoinix\" }\r\n847.0 \"Experimental Fireplume\" Ability { id: \"66BE\", source: \"Phoinix\" }\r\n856.9 \"Devouring Brand\" Ability { id: \"6D83\", source: \"Phoinix\" }\r\n857.2 \"Searing Breeze\" Ability { id: \"6704\", source: \"Phoinix\" }\r\n865.4 \"Left Cinderwing/Right Cinderwing\" Ability { id: [\"6702\", \"6703\"], source: \"Phoinix\" }\r\n876.5 \"Scorched Exaltation\" Ability { id: \"6706\", source: \"Phoinix\" }\r\n883.6 \"Scorched Exaltation\" Ability { id: \"6706\", source: \"Phoinix\" }\r\n\r\n885.8 \"--sync--\" StartsUsing { id: \"6C2B\", source: \"Phoinix\" } window 20,20\r\n895.8 \"Final Exaltation (enrage)\" Ability { id: \"6C2B\", source: \"Phoinix\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p4n.ts


const p4n_triggerSet = {
  id: 'AsphodelosTheFourthCircle',
  zoneId: zone_id/* default.AsphodelosTheFourthCircle */.Z.AsphodelosTheFourthCircle,
  timelineFile: 'p4n.txt',
  triggers: [{
    id: 'P4N Elegant Evisceration',
    type: 'StartsUsing',
    netRegex: {
      id: '6A50',
      source: 'Hesperos'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave('alert')
  },
  // Strong proximity Aoe
  {
    id: 'P4N Levinstrike Pinax',
    type: 'StartsUsing',
    netRegex: {
      id: '6A3F',
      source: 'Hesperos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go to Corner',
        de: 'In eine Ecke gehen',
        fr: 'Allez dans un coin',
        ja: '角へ',
        cn: '去角落',
        ko: '구석으로'
      }
    }
  }, {
    id: 'P4N Well Pinax',
    type: 'StartsUsing',
    netRegex: {
      id: '6A3E',
      source: 'Hesperos',
      capture: false
    },
    delaySeconds: 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Middle Knockback',
        de: 'Rückstoß von der Mitte',
        fr: 'Poussée au milieu',
        ja: '真ん中からノックバック',
        cn: '中间击退',
        ko: '중앙에서 넉백'
      }
    }
  }, {
    id: 'P4N Acid Pinax',
    type: 'StartsUsing',
    netRegex: {
      id: '6A3C',
      source: 'Hesperos',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'P4N Lava Pinax',
    type: 'StartsUsing',
    netRegex: {
      id: '6A3D',
      source: 'Hesperos',
      capture: false
    },
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }, {
    id: 'P4N Decollation',
    type: 'StartsUsing',
    netRegex: {
      id: '6A51',
      source: 'Hesperos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P4N Bloodrake',
    type: 'StartsUsing',
    netRegex: {
      id: '6A40',
      source: 'Hesperos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P4N Hell Skewer',
    type: 'StartsUsing',
    netRegex: {
      id: '6A4F',
      source: 'Hesperos',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'P4N Belone Coils',
    type: 'StartsUsing',
    netRegex: {
      id: '69DD',
      source: 'Hesperos',
      capture: false
    },
    delaySeconds: 2,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Other Role Tower',
        de: 'Geh in einen Turm einer anderen Rolle',
        fr: 'Prenez la tour d\'un autre rôle',
        ja: '他のロールの塔を処理',
        cn: '踩其他职能的塔',
        ko: '내 직업군이 아닌쪽 장판 밟기'
      }
    }
  }, {
    id: 'P4N Northerly Shift Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '6A4A',
      source: 'Hesperos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go North Edge',
        de: 'Geh zur nördlichen Kante',
        fr: 'Allez au bord nord',
        ja: '北側へ',
        cn: '去上 (北) 边',
        ko: '북쪽 구석으로'
      }
    }
  }, {
    id: 'P4N Easterly Shift Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '6A4C',
      source: 'Hesperos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go East Edge',
        de: 'Geh zur östlichen Kante',
        fr: 'Allez au bord est',
        ja: '東側へ',
        cn: '去右 (东) 边',
        ko: '동쪽 구석으로'
      }
    }
  }, {
    id: 'P4N Southerly Shift Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '6A4B',
      source: 'Hesperos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go South Edge',
        de: 'Geh zur südlichen Kante',
        fr: 'Allez au bord sud',
        ja: '南側へ',
        cn: '去下 (南) 边',
        ko: '남쪽 구석으로'
      }
    }
  }, {
    id: 'P4N Westerly Shift Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '6A4D',
      source: 'Hesperos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go West Edge',
        de: 'Geh zur westlichen Kante',
        fr: 'Allez au bord ouest',
        ja: '西側へ',
        cn: '去左 (西) 边',
        ko: '서쪽 구석으로'
      }
    }
  }, {
    id: 'P4N Northerly Shift Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '6DAE',
      source: 'Hesperos',
      capture: false
    },
    delaySeconds: 2,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'North Knockback',
        de: 'Rückstoß vom Norden',
        fr: 'Poussée au nord',
        ja: '北側からノックバック',
        cn: '上 (北) 击退',
        ko: '북쪽 넉백'
      }
    }
  }, {
    id: 'P4N Easterly Shift Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '6DB0',
      source: 'Hesperos',
      capture: false
    },
    delaySeconds: 2,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'East Knockback',
        de: 'Rückstoß vom Osten',
        fr: 'Poussée à l\'est',
        ja: '東側からノックバック',
        cn: '右 (东) 击退',
        ko: '동쪽 넉백'
      }
    }
  }, {
    id: 'P4N Southerly Shift Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '6DAF',
      source: 'Hesperos',
      capture: false
    },
    delaySeconds: 2,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'South Knockback',
        de: 'Rückstoß vom Süden',
        fr: 'Poussée au sud',
        ja: '南側からノックバック',
        cn: '下 (南) 击退',
        ko: '남쪽 넉백'
      }
    }
  }, {
    id: 'P4N Westerly Shift Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '6DB1',
      source: 'Hesperos',
      capture: false
    },
    delaySeconds: 2,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'West Knockback',
        de: 'Rückstoß vom Westen',
        fr: 'Poussée à l\'ouest',
        ja: '西側からノックバック',
        cn: '左 (西) 击退',
        ko: '서쪽 넉백'
      }
    }
  }, {
    id: 'P4N Belone Bursts',
    type: 'StartsUsing',
    netRegex: {
      id: '69D9',
      source: 'Hesperos',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Pop other role orbs',
        de: 'Nimm einen Orb einer anderen Rolle',
        fr: 'Éclatez l\'orbe d\'un autre rôle',
        ja: '他のロールの玉に当たる',
        cn: '撞其他职能的球',
        ko: '내 직업군과 다른 구슬 터뜨리기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Well Pinax/Levinstrike Pinax': 'Well/Levinstrike Pinax',
      'Levinstrike Pinax/Well Pinax': 'Levinstrike/Well Pinax'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Hesperos': 'Hesperos'
    },
    'replaceText': {
      '\\(cleave\\)': '(Cleave)',
      '\\(knockback\\)': '(Rückstoß)',
      'Acid Pinax': 'Säure-Pinax',
      'Belone Bursts': 'Berstendes Belone',
      'Belone Coils': 'Gewundenes Belone',
      'Bloodrake': 'Blutharke',
      'Burst(?!s)': 'Einschlag',
      'Decollation': 'Enthauptung',
      'Directional Shift': 'Himmelsrichtung-Schwingen',
      'Elegant Evisceration': 'Adrette Ausweidung',
      'Hell Skewer': 'Höllenspieß',
      'Levinstrike Pinax': 'Donner-Pinax',
      '(?<!\\w )Pinax': 'Pinax',
      'Setting the Scene': 'Vorhang auf',
      'Shifting Strike': 'Schwingenschlag',
      'Well Pinax': 'Brunnen-Pinax',
      'Westerly Shift': 'Schwingen gen Westen'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Hesperos': 'Hespéros'
    },
    'replaceText': {
      '\\(cleave\\)': '(cleave)',
      '\\(knockback\\)': '(poussée)',
      'Acid Pinax': 'Pinax de poison',
      'Belone Bursts': 'Bélos enchanté : explosion',
      'Belone Coils': 'Bélos enchanté : rotation',
      'Bloodrake': 'Racle de sang',
      'Burst(?!s)': 'Explosion',
      'Decollation': 'Décollation',
      'Directional Shift': 'Frappe mouvante vers un cardinal',
      'Elegant Evisceration': 'Éviscération élégante',
      'Hell Skewer': 'Embrochement infernal',
      '(?<!/)Levinstrike Pinax(?!/)': 'Pinax de foudre',
      'Levinstrike Pinax/Well Pinax': 'Pinax de foudre/eau',
      '(?<!\\w )Pinax': 'Pinax',
      'Setting the Scene': 'Lever de rideau',
      'Shifting Strike': 'Frappe mouvante',
      '(?<!/)Well Pinax(?!/)': 'Pinax d\'eau',
      'Well Pinax/Levinstrike Pinax': 'Pinax d\'eau/foudre',
      'Westerly Shift': 'Frappe mouvante vers l\'ouest'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Hesperos': 'ヘスペロス'
    },
    'replaceText': {
      'Acid Pinax': 'ピナクスポイズン',
      'Belone Bursts': 'エンチャンテッドペロネー：エクスプロージョン',
      'Belone Coils': 'エンチャンテッドペロネー：ラウンド',
      'Bloodrake': 'ブラッドレイク',
      'Burst(?!s)': '大爆発',
      'Decollation': 'デコレーション',
      'Elegant Evisceration': 'エレガントイヴィセレーション',
      'Hell Skewer': 'ヘルスキュアー',
      'Levinstrike Pinax': 'ピナクスサンダー',
      '(?<!\\w )Pinax': 'ピナクス',
      'Setting the Scene': '劇場創造',
      'Shifting Strike': 'シフティングストライク',
      'Well Pinax': 'ピナクススプラッシュ',
      'Westerly Shift': 'シフティングストライクW'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Hesperos': '赫斯珀洛斯'
    },
    'replaceText': {
      '\\(cleave\\)': '(顺劈)',
      '\\(knockback\\)': '(击退)',
      'Acid Pinax': '剧毒板画',
      'Belone Bursts': '附魔佩罗涅·爆炸',
      'Belone Coils': '附魔佩罗涅·场地',
      'Bloodrake': '聚血',
      'Burst(?!s)': '大爆炸',
      'Decollation': '断头',
      'Directional Shift': '换位强袭·方位',
      'Elegant Evisceration': '优雅除脏',
      'Hell Skewer': '地狱穿刺',
      'Levinstrike Pinax': '雷电板画',
      '(?<!\\w )Pinax': '板画',
      'Setting the Scene': '布置剧场',
      'Shifting Strike': '换位强袭',
      'Well Pinax': '喷水板画',
      'Westerly Shift': '换位强袭·西'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Hesperos': '헤스페로스'
    },
    'replaceText': {
      '\\(cleave\\)': '(칼)',
      '\\(knockback\\)': '(넉백)',
      'Acid Pinax': '독 배경판',
      'Belone Bursts': '마법검 벨로네: 폭발',
      'Belone Coils': '마법검 벨로네: 원형',
      'Bloodrake': '피갈퀴',
      'Burst(?!s)': '대폭발',
      'Decollation': '집단 참수',
      'Directional Shift': '이동 공격: 동서남북',
      'Elegant Evisceration': '우아한 적출',
      'Hell Skewer': '지옥 찌르기',
      'Levinstrike Pinax': '번개 배경판',
      '(?<!\\w )Pinax': '배경판',
      'Setting the Scene': '극장 창조',
      'Shifting Strike': '이동 공격',
      'Well Pinax': '물기둥 배경판',
      'Westerly Shift': '이동 공격: 서'
    }
  }]
};
/* harmony default export */ const p4n = (p4n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p4n.txt
const raid_p4n_namespaceObject = "### P4N: Asphodelos: The Fourth Circle\r\n#\r\n# -p 6A50:15.8\r\n# -ii 6A41 6A42 6A43 6A38 6A39 6A3A 6A3B\r\n\r\n# Note: every Pinax is also accompanied by a Mekhane (6A38 through 6A3B)\r\n# of the same name.  These all happen at the same time, and are the\r\n# abilities that hit the player, so are removed.\r\n\r\n# Note: Northerly Shift (6A4A, 6DAE), Southerly Shift (6A4B, 6DAF),\r\n# Easterly Shift (6A4C, 6DB0), and Westerly Shift (6A4D, 6DB1)\r\n# are all combined into \"Directional Shift\" for brevity.  The first\r\n# id is for a shift + cleave, and the second id is for shift + knockback.\r\n# Only the first two ids are fixed (cleave first, then knockback) and it\r\n# is random after that.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n10.8 \"--sync--\" StartsUsing { id: \"6A50\", source: \"Hesperos\" } window 20,20\r\n15.8 \"Elegant Evisceration\" Ability { id: \"6A50\", source: \"Hesperos\" }\r\n24.0 \"--sync--\" Ability { id: \"69CA\", source: \"Hesperos\" }\r\n\r\n31.0 \"Setting the Scene 1\" Ability { id: \"69CB\", source: \"Hesperos\" }\r\n43.2 \"Pinax\" Ability { id: \"69CF\", source: \"Hesperos\" }\r\n53.3 \"Levinstrike Pinax\" Ability { id: \"6A3F\", source: \"Hesperos\" }\r\n65.4 \"Decollation\" Ability { id: \"6A51\", source: \"Hesperos\" }\r\n69.6 \"--sync--\" Ability { id: \"69CA\", source: \"Hesperos\" }\r\n\r\n76.6 \"Setting the Scene 2\" Ability { id: \"69CB\", source: \"Hesperos\" }\r\n88.8 \"Pinax\" Ability { id: \"69CF\", source: \"Hesperos\" }\r\n98.9 \"Well Pinax\" Ability { id: \"6A3E\", source: \"Hesperos\" }\r\n112.1 \"Hell Skewer\" Ability { id: \"6A4F\", source: \"Hesperos\" }\r\n121.3 \"Elegant Evisceration\" Ability { id: \"6A50\", source: \"Hesperos\" }\r\n125.5 \"--sync--\" Ability { id: \"69CA\", source: \"Hesperos\" }\r\n\r\n132.5 \"Setting the Scene 3\" Ability { id: \"69CB\", source: \"Hesperos\" }\r\n144.7 \"Pinax\" Ability { id: \"69CF\", source: \"Hesperos\" }\r\n154.8 \"Well Pinax/Levinstrike Pinax\" Ability { id: [\"6A3E\", \"6A3F\"], source: \"Hesperos\" }\r\n162.0 \"Hell Skewer\" Ability { id: \"6A4F\", source: \"Hesperos\" }\r\n165.7 \"Acid Pinax\" Ability { id: \"6A3C\", source: \"Hesperos\" }\r\n176.7 \"Levinstrike Pinax/Well Pinax\" Ability { id: [\"6A3E\", \"6A3F\"], source: \"Hesperos\" }\r\n184.1 \"Hell Skewer\" Ability { id: \"6A4F\", source: \"Hesperos\" }\r\n199.3 \"Bloodrake\" Ability { id: \"6A40\", source: \"Hesperos\" }\r\n208.4 \"Belone Coils\" Ability { id: \"69DD\", source: \"Hesperos\" }\r\n219.2 \"Burst\" Ability { id: \"6A4[456]\", source: \"Hesperos\" }\r\n223.3 \"Hell Skewer\" Ability { id: \"6A4F\", source: \"Hesperos\" }\r\n232.5 \"Decollation\" Ability { id: \"6A51\", source: \"Hesperos\" }\r\n\r\n239.7 \"--middle--\" Ability { id: \"69CE\", source: \"Hesperos\" }\r\n248.4 \"Directional Shift\" Ability { id: [\"6A4A\", \"6A4B\", \"6A4C\", \"6A4D\"], source: \"Hesperos\" }\r\n249.9 \"Shifting Strike (cleave)\" Ability { id: \"6A4E\", source: \"Hesperos\" }\r\n257.6 \"--middle--\" Ability { id: \"69CE\", source: \"Hesperos\" }\r\n266.2 \"Directional Shift\" Ability { id: [\"6DAE\", \"6DAF\", \"6DB0\", \"6DB1\"], source: \"Hesperos\" }\r\n267.9 \"Shifting Strike (knockback)\" Ability { id: \"6DB2\", source: \"Hesperos\" }\r\n269.4 \"--middle--\" Ability { id: \"69CE\", source: \"Hesperos\" }\r\n278.4 \"Directional Shift\" Ability { id: [\"6A4A\", \"6A4B\", \"6A4C\", \"6A4D\", \"6DAE\", \"6DAF\", \"6DB0\", \"6DB1\"], source: \"Hesperos\" }\r\n279.9 \"Shifting Strike\" Ability { id: [\"6DB2\", \"6A4E\"], source: \"Hesperos\" }\r\n285.6 \"--middle--\" Ability { id: \"69CE\", source: \"Hesperos\" }\r\n\r\n292.3 \"Bloodrake\" Ability { id: \"6A40\", source: \"Hesperos\" }\r\n300.5 \"Belone Bursts\" Ability { id: \"69D9\", source: \"Hesperos\" }\r\n324.7 \"Elegant Evisceration\" Ability { id: \"6A50\", source: \"Hesperos\" }\r\n328.9 \"--sync--\" Ability { id: \"69CA\", source: \"Hesperos\" }\r\n\r\n335.9 \"Setting the Scene\" Ability { id: \"69CB\", source: \"Hesperos\" }\r\n349.1 \"Bloodrake\" Ability { id: \"6A40\", source: \"Hesperos\" }\r\n358.3 \"Pinax\" Ability { id: \"69CF\", source: \"Hesperos\" }\r\n368.4 \"Pinax 1\" Ability { id: [\"6A3C\", \"6A3D\", \"6A3E\", \"6A3F\"], source: \"Hesperos\" }\r\n371.5 \"Hell Skewer\" Ability { id: \"6A4F\", source: \"Hesperos\" }\r\n379.4 \"Pinax 2\" Ability { id: [\"6A3C\", \"6A3D\", \"6A3E\", \"6A3F\"], source: \"Hesperos\" }\r\n380.7 \"--sync--\" Ability { id: \"69CE\", source: \"Hesperos\" }\r\n386.3 \"Belone Coils\" Ability { id: \"69DD\", source: \"Hesperos\" }\r\n390.4 \"Pinax 3\" Ability { id: [\"6A3C\", \"6A3D\", \"6A3E\", \"6A3F\"], source: \"Hesperos\" }\r\n397.1 \"Burst\" Ability { id: \"6A4[456]\", source: \"Hesperos\" }\r\n403.4 \"Pinax 4\" Ability { id: [\"6A3C\", \"6A3D\", \"6A3E\", \"6A3F\"], source: \"Hesperos\" }\r\n404.5 \"--middle--\" Ability { id: \"69CE\", source: \"Hesperos\" }\r\n413.5 \"Directional Shift\" Ability { id: [\"6A4A\", \"6A4B\", \"6A4C\", \"6A4D\", \"6DAE\", \"6DAF\", \"6DB0\", \"6DB1\"], source: \"Hesperos\" }\r\n415.0 \"Shifting Strike\" Ability { id: [\"6DB2\", \"6A4E\"], source: \"Hesperos\" }\r\n428.9 \"Decollation\" Ability { id: \"6A51\", source: \"Hesperos\" }\r\n\r\n438.1 \"Bloodrake\" Ability { id: \"6A40\", source: \"Hesperos\" }\r\n446.3 \"Belone Bursts\" Ability { id: \"69D9\", source: \"Hesperos\" }\r\n454.5 \"--middle--\" Ability { id: \"69CE\", source: \"Hesperos\" }\r\n463.1 \"Westerly Shift\" Ability { id: \"6DB1\", source: \"Hesperos\" }\r\n464.8 \"Shifting Strike\" Ability { id: \"6DB2\", source: \"Hesperos\" }\r\n478.3 \"Decollation\" Ability { id: \"6A51\", source: \"Hesperos\" }\r\n491.5 \"Elegant Evisceration\" Ability { id: \"6A50\", source: \"Hesperos\" }\r\n495.7 \"--sync--\" Ability { id: \"69CA\", source: \"Hesperos\" }\r\n\r\n502.7 \"Setting the Scene\" Ability { id: \"69CB\", source: \"Hesperos\" } window 50,50 jump 335.9\r\n515.9 \"Bloodrake\" #Ability { id: \"6A40\", source: \"Hesperos\" }\r\n525.1 \"Pinax\" #Ability { id: \"69CF\", source: \"Hesperos\" }\r\n535.2 \"Pinax 1\" #Ability { id: [\"6A3C\", \"6A3D\", \"6A3E\", \"6A3F\"], source: \"Hesperos\" }\r\n538.3 \"Hell Skewer\" #Ability { id: \"6A4F\", source: \"Hesperos\" }\r\n546.2 \"Pinax 2\" #Ability { id: [\"6A3C\", \"6A3D\", \"6A3E\", \"6A3F\"], source: \"Hesperos\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p4s.ts






// Part Two
// TODO: Better Dark Design/tether break callouts
// TODO: Wreath of Thorns 3 strategy (1 = melee, 2 = ranged) or
//       something more intelligent such as tracking the vulnerabilities?
// TODO: Heart Stake is tankbuster with DoT, does it need to be output differrently?
// TODO: Curtain Call tank swap
const roleOutputStrings = {
  tankHealer: {
    en: 'Tank/Healer',
    de: 'Tank/Heiler',
    fr: 'Tank/Healer',
    ja: 'タンク＆ヒーラ',
    cn: '坦克/治疗',
    ko: '탱/힐'
  },
  dps: {
    en: 'DPS',
    de: 'DPS',
    fr: 'DPS',
    ja: 'DPS',
    cn: 'DPS',
    ko: '딜러'
  },
  roleTethers: {
    en: '${role} Tethers',
    de: '${role} Verbindung',
    fr: 'Liens ${role}',
    ja: '線もらう: ${role}',
    cn: '${role} 截线',
    ko: '줄 받기: ${role}'
  },
  roleDebuffs: {
    en: '${role} Role Calls',
    de: '${role} Dreifäulenoper',
    fr: 'Debuffs ${role}',
    ja: 'デバフもらう: ${role}',
    cn: '${role} 拿毒',
    ko: '디버프 받기: ${role}'
  },
  roleEverything: {
    en: '${role} Everything',
    de: '${role} Alles',
    fr: '${role} pour tout',
    ja: '${role} 全てもらう',
    cn: '${role} 处理全部',
    ko: '${role} 전부 받기'
  },
  roleTowers: {
    en: '${role} Towers',
    de: '${role} Türme',
    fr: 'Tours ${role}',
    ja: '塔: ${role}',
    cn: '${role} 踩塔',
    ko: '기둥: ${role}'
  },
  unknown: outputs/* default.unknown */.Z.unknown
};
const curtainCallOutputStrings = {
  group: {
    en: 'Group ${num}',
    de: 'Group ${num}',
    fr: 'Groupe ${num}',
    ja: '${num} 組',
    cn: '${num} 组',
    ko: '그룹: ${num}'
  }
};

// Due to changes introduced in patch 5.2, overhead markers now have a random offset
// added to their ID. This offset currently appears to be set per instance, so
// we can determine what it is from the first overhead marker we see.
// The first 1B marker in the encounter is an Elegant Evisceration (00DA).
// The first 1B marker in the phase 2 encounter is the Act 2 fire headmarker (012F).
const eviscerationMarker = parseInt('00DA', 16);
const orangeMarker = parseInt('012F', 16);
const p4s_getHeadmarkerId = (data, matches, firstDecimalMarker) => {
  // If we naively just check !data.decOffset and leave it, it breaks if the first marker is 00DA.
  // (This makes the offset 0, and !0 is true.)
  if (typeof data.decOffset === 'undefined') data.decOffset = parseInt(matches.id, 16) - firstDecimalMarker;
  // The leading zeroes are stripped when converting back to string, so we re-add them here.
  // Fortunately, we don't have to worry about whether or not this is robust,
  // since we know all the IDs that will be present in the encounter.
  return (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase().padStart(4, '0');
};
const p4s_triggerSet = {
  id: 'AsphodelosTheFourthCircleSavage',
  zoneId: zone_id/* default.AsphodelosTheFourthCircleSavage */.Z.AsphodelosTheFourthCircleSavage,
  timelineFile: 'p4s.txt',
  initData: () => {
    return {
      actHeadmarkers: {}
    };
  },
  timelineTriggers: [{
    id: 'P4S Dark Design',
    regex: /Dark Design/,
    beforeSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack for Puddle AOEs',
        de: 'Stacken (Pfützen)',
        fr: 'Packez les zones au sol d\'AoEs',
        ja: 'AoEを誘導',
        cn: '集合放置AOE',
        ko: '모여서 장판 한곳에 깔기'
      }
    }
  }, {
    id: 'P4S Kothornos Kick',
    regex: /Kothornos Kick/,
    beforeSeconds: 5.3,
    infoText: (data, _matches, output) => {
      let jumpDir = '';
      if (data.jumpDir1 === 'east') jumpDir = !data.kickTwo ? output.west() : output.east();else if (data.jumpDir1 === 'west') jumpDir = !data.kickTwo ? output.east() : output.west();else return output.baitJump();
      return output.baitJumpDir({
        dir: jumpDir
      });
    },
    run: data => data.kickTwo = true,
    outputStrings: {
      baitJumpDir: {
        en: 'Bait Jump ${dir}?',
        de: 'Sprung ködern ${dir}?',
        fr: 'Attirez le saut à l\'${dir}?',
        ja: 'ジャンプ誘導?: ${dir}',
        cn: '引导跳跃 ${dir}?',
        ko: '점프 유도?: ${dir}'
      },
      baitJump: {
        en: 'Bait Jump?',
        de: 'Sprung ködern?',
        fr: 'Attirez le saut ?',
        ja: 'ジャンプ誘導?',
        cn: '引导跳跃?',
        ko: '점프 유도?'
      },
      east: outputs/* default.east */.Z.east,
      west: outputs/* default.west */.Z.west,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'P4S Kothornos Quake',
    regex: /Kothornos Quake/,
    beforeSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Earthshakers?',
        de: 'Erdstoß ködern?',
        fr: 'Orientez les secousses ?',
        ja: 'アスシェイカー誘導?',
        cn: '引导地震?',
        ko: '부채꼴 공격 유도?'
      }
    }
  }, {
    id: 'P4S Hemitheos\'s Water IV',
    regex: /Hemitheos's Water IV/,
    beforeSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Middle Knockback',
        de: 'Rückstoß von der Mitte',
        fr: 'Poussée au milieu',
        ja: '真ん中でノックバック',
        cn: '中间击退',
        ko: '중앙에서 넉백'
      }
    }
  }],
  triggers: [{
    id: 'P4S Headmarker Tracker',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.decOffset === undefined,
    // Unconditionally set the first headmarker here so that future triggers are conditional.
    run: (data, matches) => {
      const isDoorBoss = data.act === undefined;
      const first = isDoorBoss ? eviscerationMarker : orangeMarker;
      p4s_getHeadmarkerId(data, matches, first);
    }
  }, {
    id: 'P4S Decollation',
    type: 'StartsUsing',
    netRegex: {
      id: '6A09',
      source: 'Hesperos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P4S Bloodrake',
    // AoE hits tethered players in first one, the non-tethered in second
    type: 'StartsUsing',
    netRegex: {
      id: '69D8',
      source: 'Hesperos',
      capture: false
    },
    preRun: data => data.bloodrakeCounter = (data.bloodrakeCounter ?? 0) + 1,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P4S Bloodrake Store',
    type: 'Ability',
    netRegex: {
      id: '69D8',
      source: 'Hesperos'
    },
    condition: data => (data.bloodrakeCounter ?? 0) < 3,
    suppressSeconds: 1,
    infoText: (data, matches, output) => {
      const roles = {
        'dps': output.dps(),
        'tank/healer': output.tankHealer()
      };
      const roleRaked = data.party.isDPS(matches.target) ? 'dps' : 'tank/healer';
      const roleOther = data.party.isDPS(matches.target) ? 'tank/healer' : 'dps';

      // Second bloodrake = Debuffs later
      if ((data.bloodrakeCounter ?? 0) === 2) {
        if (roleRaked === 'dps') {
          (data.debuffRole ??= []).push('healer');
          data.debuffRole.push('tank');
        } else {
          (data.debuffRole ??= []).push(roleOther);
        }

        // May end up needing both tether and debuff
        const tetherRole = data.tetherRole ??= [];
        const debuffRole = data.debuffRole ??= [];
        if (tetherRole[0] === debuffRole[0]) return output.roleEverything({
          role: roles[roleOther]
        });
        return output.roleDebuffs({
          role: roles[roleOther]
        });
      }

      // First bloodrake = Tethers later
      if (roleRaked === 'dps') {
        (data.tetherRole ??= []).push('healer');
        data.tetherRole.push('tank');
      } else {
        (data.tetherRole ??= []).push(roleOther);
      }
      return output.roleTethers({
        role: roles[roleOther]
      });
    },
    outputStrings: roleOutputStrings
  }, {
    id: 'P4S Belone Coils',
    // 69DE is No Tank/Healer Belone Coils
    // 69DF is No DPS Belone Coils
    type: 'StartsUsing',
    netRegex: {
      id: ['69DE', '69DF', '69E0', '69E1'],
      source: 'Hesperos'
    },
    preRun: data => {
      if (!data.beloneCoilsTwo) {
        delete data.debuffRole;
        delete data.tetherRole;
        data.hasRoleCall = false;
        data.ignoreChlamys = true;
      } else {
        data.ignoreChlamys = false;
      }
    },
    suppressSeconds: 1,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = roleOutputStrings;
      const roles = {
        'dps': output.dps(),
        'tank/healer': output.tankHealer()
      };
      const roleTowers = matches.id === '69DE' ? 'dps' : 'tank/healer';
      const roleOther = matches.id === '69DE' ? 'tank/healer' : 'dps';

      // Second Coils = Debuffs later
      if (data.beloneCoilsTwo) {
        if (roleTowers === 'dps') {
          (data.debuffRole ??= []).push('healer');
          data.debuffRole.push('tank');
        } else {
          (data.debuffRole ??= []).push('dps');
        }

        // For second coils, if you are not in the debuff list here you are tower
        if (!data.debuffRole.includes(data.role)) return {
          ['alertText']: output.roleTowers({
            role: roles[roleTowers]
          })
        };

        // If you have tethers and debuff, you need everything
        const tetherRole = data.tetherRole ??= [];
        const debuffRole = data.debuffRole ??= [];
        if (debuffRole[0] === tetherRole[0]) return {
          ['infoText']: output.roleEverything({
            role: roles[roleOther]
          })
        };
        return {
          ['infoText']: output.roleDebuffs({
            role: roles[roleOther]
          })
        };
      }

      // First Coils = Tethers later
      if (roleTowers === 'dps') {
        (data.tetherRole ??= []).push('healer');
        data.tetherRole.push('tank');
      } else {
        (data.tetherRole ??= []).push('dps');
      }

      // For first coils, there are tower and tethers
      if (data.tetherRole.includes(data.role)) return {
        ['alertText']: output.roleTethers({
          role: roles[roleOther]
        })
      };
      return {
        ['alertText']: output.roleTowers({
          role: roles[roleTowers]
        })
      };
    },
    run: data => data.beloneCoilsTwo = true
  }, {
    id: 'P4S Role Call',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['AF2', 'AF3'],
      capture: true
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (data, matches, output) => {
      const debuffRole = (data.debuffRole ??= []).includes(data.role);
      if (matches.effectId === 'AF2') {
        // Call Pass Role Call if not in the debuff role
        if (!debuffRole) return output.passRoleCall();
        data.hasRoleCall = true;
      }

      // AF3 is obtained after passing Role Call (AF2)
      if (matches.effectId === 'AF3') data.hasRoleCall = false;
    },
    outputStrings: {
      passRoleCall: {
        en: 'Pass Role Call',
        de: 'Dreifäulenoper weitergeben',
        fr: 'Passez votre debuff',
        ja: 'デバフ渡す',
        cn: '传毒',
        ko: '디버프 건네기'
      }
    }
  }, {
    id: 'P4S Director\'s Belone',
    type: 'Ability',
    netRegex: {
      id: '69E6',
      source: 'Hesperos',
      capture: false
    },
    // Delay callout until debuffs are out
    delaySeconds: 1.4,
    alertText: (data, _matches, output) => {
      const debuffRole = (data.debuffRole ??= []).includes(data.role);
      if (!data.hasRoleCall && debuffRole) return output.text();
    },
    outputStrings: {
      text: {
        en: 'Get Role Call',
        de: 'Nimm Dreifäulenoper',
        fr: 'Prenez un debuff',
        ja: 'デバフもらう',
        cn: '拿毒',
        ko: '디버프 받기'
      }
    }
  }, {
    id: 'P4S Inversive Chlamys',
    // Possible a player still has not yet passed debuff
    type: 'StartsUsing',
    netRegex: {
      id: '69ED',
      source: 'Hesperos',
      capture: false
    },
    condition: data => !data.ignoreChlamys,
    alertText: (data, _matches, output) => {
      const dps = (data.tetherRole ??= []).includes('dps');
      if (dps) return output.roleTethers({
        role: output.dps()
      });
      if (data.tetherRole.length) return output.roleTethers({
        role: output.tankHealer()
      });
      return output.roleTethers({
        role: output.unknown()
      });
    },
    run: data => {
      if (!data.beloneCoilsTwo) {
        delete data.tetherRole;
        data.hasRoleCall = false;
      }
    },
    outputStrings: roleOutputStrings
  }, {
    id: 'P4S Elegant Evisceration',
    // This one does an aoe around the tank
    type: 'StartsUsing',
    netRegex: {
      id: '6A08',
      source: 'Hesperos'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap('alert')
  }, {
    id: 'P4S Levinstrike Pinax',
    // Strong proximity Aoe
    type: 'StartsUsing',
    netRegex: {
      id: '69D7',
      source: 'Hesperos',
      capture: false
    },
    preRun: data => data.pinaxCount = (data.pinaxCount ?? 0) + 1,
    durationSeconds: 6,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Thunder',
        de: 'Blitz',
        fr: 'Foudre',
        ja: '雷',
        cn: '雷',
        ko: '번개'
      }
    }
  }, {
    id: 'P4S Well Pinax',
    type: 'StartsUsing',
    netRegex: {
      id: '69D6',
      source: 'Hesperos',
      capture: false
    },
    preRun: data => data.pinaxCount = (data.pinaxCount ?? 0) + 1,
    infoText: (data, _matches, output) => {
      if ((data.pinaxCount ?? 0) % 2) return output.text();
      data.wellShiftKnockback = true;
      return output.shiftWell();
    },
    outputStrings: {
      text: {
        en: 'Well Pinax',
        de: 'Brunnen-Pinax',
        fr: 'Pinax d\'eau',
        ja: '水',
        cn: '水',
        ko: '물'
      },
      shiftWell: {
        en: 'Well => Shift',
        de: 'Brunnen => Schwingen',
        fr: 'Eau => Frappe mouvante',
        ja: '水 => シフティング',
        cn: '水 => 位移',
        ko: '물 => 이동공격'
      }
    }
  }, {
    id: 'P4S Well Pinax Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '69D6',
      source: 'Hesperos'
    },
    delaySeconds: (data, matches) => {
      // Delay for for Directional Shift on Even Well/Levinstrike Pinax Count
      if ((data.pinaxCount ?? 0) % 2) return parseFloat(matches.castTime) - 5;
      return parseFloat(matches.castTime) - 2.4;
    },
    durationSeconds: data => data.wellShiftKnockback ? 2.4 : 5,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        knockback: outputs/* default.knockback */.Z.knockback,
        middleKnockback: {
          en: 'Middle Knockback',
          de: 'Rückstoß von der Mitte',
          fr: 'Poussée au milieu',
          ja: '真ん中でノックバック',
          cn: '中间击退',
          ko: '중앙에서 넉백'
        }
      };
      if (data.wellShiftKnockback) return {
        ['alertText']: output.knockback()
      };
      return {
        ['infoText']: output.middleKnockback()
      };
    }
  }, {
    id: 'P4S Acid Pinax',
    type: 'StartsUsing',
    netRegex: {
      id: '69D4',
      source: 'Hesperos',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'P4S Lava Pinax',
    type: 'StartsUsing',
    netRegex: {
      id: '69D5',
      source: 'Hesperos',
      capture: false
    },
    infoText: (_data, _matches, output) => output.groups(),
    outputStrings: {
      groups: {
        en: 'Healer Groups',
        de: 'Heiler-Gruppen',
        fr: 'Groupes sur les heals',
        ja: 'ヒラに頭割り',
        cn: '治疗分摊组',
        ko: '힐러 그룹 쉐어'
      }
    }
  }, {
    id: 'P4S Northerly Shift Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '6A02',
      source: 'Hesperos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'North Cleave',
        de: 'Cleave -> Geh in den Norden',
        fr: 'Cleave au nord',
        ja: '北の横',
        cn: '上 (北) 两侧',
        ko: '북쪽 칼 휘두르기'
      }
    }
  }, {
    id: 'P4S Easterly Shift Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '6A04',
      source: 'Hesperos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'East Cleave',
        de: 'Cleave -> Geh in den Osten',
        fr: 'Cleave à l\'est',
        ja: '東の横',
        cn: '右 (东) 两侧',
        ko: '동쪽 칼 휘두르기'
      }
    }
  }, {
    id: 'P4S Southerly Shift Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '6A03',
      source: 'Hesperos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'South Cleave',
        de: 'Cleave -> Geh in den Süden',
        fr: 'Cleave au sud',
        ja: '南の横',
        cn: '下 (南) 两侧',
        ko: '남쪽 칼 휘두르기'
      }
    }
  }, {
    id: 'P4S Westerly Shift Slash',
    type: 'StartsUsing',
    netRegex: {
      id: '6A05',
      source: 'Hesperos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'West Cleave',
        de: 'Cleave -> Geh in den Westen',
        fr: 'Cleave à l\'ouest',
        ja: '西の横',
        cn: '左 (西) 两侧',
        ko: '서쪽 칼 휘두르기'
      }
    }
  }, {
    id: 'P4S Northerly Shift Cape',
    type: 'StartsUsing',
    netRegex: {
      id: '69FD',
      source: 'Hesperos',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'North Cape',
        de: 'Rückstoß -> Geh in den Norden',
        fr: 'Poussée au nord',
        ja: '北でノックバック',
        cn: '上 (北) 击退',
        ko: '북쪽 망토'
      }
    }
  }, {
    id: 'P4S Easterly Shift Cape',
    type: 'StartsUsing',
    netRegex: {
      id: '69FF',
      source: 'Hesperos',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'East Cape',
        de: 'Rückstoß -> Geh in den Osten',
        fr: 'Poussée à l\'est',
        ja: '東でノックバック',
        cn: '右 (东) 击退',
        ko: '동쪽 망토'
      }
    }
  }, {
    id: 'P4S Southerly Shift Cape',
    type: 'StartsUsing',
    netRegex: {
      id: '69FE',
      source: 'Hesperos',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'South Cape',
        de: 'Rückstoß -> Geh in den Süden',
        fr: 'Poussée au sud',
        ja: '南でノックバック',
        cn: '下 (南) 击退',
        ko: '남쪽 망토'
      }
    }
  }, {
    id: 'P4S Westerly Shift Cape',
    type: 'StartsUsing',
    netRegex: {
      id: '6A00',
      source: 'Hesperos',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'West Cape',
        de: 'Rückstoß -> Geh in den Westen',
        fr: 'Poussée à l\'ouest',
        ja: '西でノックバック',
        cn: '左 (西) 击退',
        ko: '서쪽 망토'
      }
    }
  }, {
    id: 'P4S Directional Shift Knockback',
    // Callout Knockback during Levinstrike + Shift
    type: 'StartsUsing',
    netRegex: {
      id: ['69FD', '69FE', '69FF', '6A00'],
      source: 'Hesperos'
    },
    condition: data => !data.wellShiftKnockback,
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    response: responses/* Responses.knockback */.n3.knockback(),
    run: data => data.wellShiftKnockback = false
  }, {
    id: 'P4S Acting Role',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['B6D', 'B6E', 'B6F'],
      capture: true
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (data, matches, output) => {
      const actingRoles = {
        'B6D': output.dps(),
        'B6E': output.healer(),
        'B6F': output.tank()
      };
      return output.text({
        actingRole: data.actingRole = actingRoles[matches.effectId]
      });
    },
    outputStrings: {
      text: {
        en: 'Acting ${actingRole}',
        de: 'Handel ale ${actingRole}',
        fr: 'Rôle ${actingRole}',
        ja: 'ロール: ${actingRole}',
        cn: '扮演 ${actingRole}',
        ko: '역할: ${actingRole}'
      },
      dps: roleOutputStrings.dps,
      healer: {
        en: 'Healer',
        de: 'Heiler',
        fr: 'Healer',
        ja: 'ヒーラ',
        cn: '治疗',
        ko: '힐러'
      },
      tank: {
        en: 'Tank',
        de: 'Tank',
        fr: 'Tank',
        ja: 'タンク',
        cn: '坦克',
        ko: '탱커'
      }
    }
  }, {
    id: 'P4S Belone Bursts',
    type: 'StartsUsing',
    netRegex: {
      id: '69D9',
      source: 'Hesperos',
      capture: false
    },
    infoText: (_data, _matches, output) => output.rolePositions(),
    outputStrings: {
      rolePositions: {
        en: 'Orb role positions',
        de: 'Orb Rollenposition',
        fr: 'Positions pour les orbes de rôles',
        ja: '玉、ロール散開',
        cn: '职能撞球站位',
        ko: '구슬, 역할별 위치로'
      }
    }
  }, {
    id: 'P4S Periaktoi',
    type: 'StartsUsing',
    netRegex: {
      id: ['69F5', '69F6', '69F7', '69F8'],
      source: 'Hesperos'
    },
    alertText: (_data, matches, output) => {
      const pinax = {
        '69F5': output.acid(),
        '69F6': output.lava(),
        '69F7': output.well(),
        '69F8': output.thunder()
      };
      return output.text({
        pinax: pinax[matches.id]
      });
    },
    outputStrings: {
      text: {
        en: '${pinax} safe',
        de: '${pinax} sicher',
        fr: '${pinax} safe',
        ja: '安置: ${pinax}',
        cn: '${pinax} 安全',
        ko: '안전한 곳: ${pinax}'
      },
      acid: {
        en: 'Acid',
        de: 'Gift',
        fr: 'Poison',
        ja: '毒/緑',
        cn: '毒',
        ko: '독/녹색'
      },
      lava: {
        en: 'Lava',
        de: 'Lava',
        fr: 'Feu',
        ja: '炎/赤',
        cn: '火',
        ko: '불/빨강'
      },
      well: {
        en: 'Well',
        de: 'Brunnen',
        fr: 'Eau',
        ja: '水/白',
        cn: '水',
        ko: '물/하양'
      },
      thunder: {
        en: 'Thunder',
        de: 'Blitz',
        fr: 'Foudre',
        ja: '雷/青',
        cn: '雷',
        ko: '번개/파랑'
      }
    }
  }, {
    id: 'P4S Searing Stream',
    type: 'StartsUsing',
    netRegex: {
      id: '6A2D',
      source: 'Hesperos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P4S Act Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: ['6A0C', '6EB[4-7]', '6A36'],
      source: 'Hesperos'
    },
    run: (data, matches) => {
      const actMap = {
        '6A0C': '1',
        '6EB4': '2',
        '6EB5': '3',
        '6EB6': '4',
        '6EB7': 'finale',
        '6A36': 'curtain'
      };
      data.act = actMap[matches.id];
      data.actHeadmarkers = {};
    }
  }, {
    id: 'P4S Thorns Collector',
    type: 'StartsUsing',
    netRegex: {
      id: '6A0C',
      source: 'Hesperos'
    },
    promise: async (data, matches, _output) => {
      // Collect all Hesperos entities up front
      let combatantName = null;
      combatantName = matches.source;
      let combatantData = null;
      if (combatantName) {
        combatantData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
          call: 'getCombatants',
          names: [combatantName]
        });
      }

      // if we could not retrieve combatant data, the
      // trigger will not work, so just resume promise here
      if (combatantData === null) {
        console.error(`Hesperos: null data`);
        return;
      }
      const combatantDataLength = combatantData.combatants.length;
      if (combatantDataLength < 8) {
        console.error(`Hesperos: expected at least 8 combatants got ${combatantDataLength}`);
        return;
      }

      // the lowest eight Hesperos IDs are the thorns that tether the boss
      const sortCombatants = (a, b) => (a.ID ?? 0) - (b.ID ?? 0);
      const sortedCombatantData = combatantData.combatants.sort(sortCombatants).splice(combatantDataLength - 8, combatantDataLength);
      sortedCombatantData.forEach(combatant => {
        (data.thornIds ??= []).push(combatant.ID ?? 0);
      });
    }
  }, {
    id: 'P4S Act One Safe Spots',
    type: 'Tether',
    netRegex: {
      id: '00AD',
      source: 'Hesperos'
    },
    condition: data => data.act === '1',
    // Tethers come out Cardinals (0 seconds), (3s) Towers, (6s) Other Cardinals
    suppressSeconds: 7,
    infoText: (data, matches, output) => {
      const thorn = (data.thornIds ??= []).indexOf(parseInt(matches.sourceId, 16));
      const thornMap = {
        4: output.text({
          dir1: output.north(),
          dir2: output.south()
        }),
        5: output.text({
          dir1: output.north(),
          dir2: output.south()
        }),
        6: output.text({
          dir1: output.east(),
          dir2: output.west()
        }),
        7: output.text({
          dir1: output.east(),
          dir2: output.west()
        })
      };
      return thornMap[thorn];
    },
    outputStrings: {
      text: {
        en: '${dir1}/${dir2} first',
        de: '${dir1}/${dir2} zuerst',
        fr: '${dir1}/${dir2} en premier',
        ja: '${dir1}/${dir2}から',
        cn: '先去 ${dir1}/${dir2}',
        ko: '${dir1}/${dir2}부터'
      },
      north: outputs/* default.north */.Z.north,
      east: outputs/* default.east */.Z.east,
      south: outputs/* default.south */.Z.south,
      west: outputs/* default.west */.Z.west
    }
  }, {
    id: 'P4S Nearsight',
    type: 'StartsUsing',
    netRegex: {
      id: '6A26',
      source: 'Hesperos',
      capture: false
    },
    alertText: (data, _matches, output) => data.role === 'tank' ? output.tanksInPartyOut() : output.partyOutTanksIn(),
    outputStrings: {
      partyOutTanksIn: {
        en: 'Party Out (Tanks In)',
        de: 'Gruppe Raus (Tanks Rein)',
        fr: 'Équipe à l\'extérieur (Tanks à l\'intérieur)',
        ja: 'ボスから離れる (タンクが内側)',
        cn: '小队出 (T进)',
        ko: '본대 밖 (탱커 안)'
      },
      tanksInPartyOut: {
        en: 'Tanks In (Party Out)',
        de: 'Gruppe Rein (Tanks Raus)',
        fr: 'Tanks à l\'intérieur (Équipe à l\'extérieur',
        ja: 'ボスに足元へ (パーティーは離れる)',
        cn: 'T进 (小队出)',
        ko: '탱커 안 (본대 밖)'
      }
    }
  }, {
    id: 'P4S Farsight',
    type: 'StartsUsing',
    netRegex: {
      id: '6A27',
      source: 'Hesperos',
      capture: false
    },
    alertText: (data, _matches, output) => data.role === 'tank' ? output.tanksOutPartyIn() : output.partyInTanksOut(),
    outputStrings: {
      partyInTanksOut: {
        en: 'Party In (Tanks Out)',
        de: 'Gruppe Rein (Tanks Raus)',
        fr: 'Équipe à l\'intérieur (Tanks à l\'extérieur)',
        ja: 'ボスの足元へ (タンクは離れる)',
        cn: '小队进 (T出)',
        ko: '본대 안 (탱커 밖)'
      },
      tanksOutPartyIn: {
        en: 'Tanks Out (Party In)',
        de: 'Tanks Raus (Gruppe Rein)',
        fr: 'Tanks à l\'extérieur (Équipe à l\'intérieur',
        ja: 'ボスからはなれる (パーティーが内側)',
        cn: 'T出 (小队进)',
        ko: '탱커 밖 (본대 안)'
      }
    }
  }, {
    id: 'P4S Demigod Double',
    type: 'StartsUsing',
    netRegex: {
      id: '6E78',
      source: 'Hesperos'
    },
    condition: conditions/* default.caresAboutPhysical */.Z.caresAboutPhysical(),
    response: responses/* Responses.sharedTankBuster */.n3.sharedTankBuster()
  }, {
    id: 'P4S Act Two Safe Spots',
    type: 'Tether',
    netRegex: {
      id: '00AD',
      source: 'Hesperos'
    },
    condition: data => data.act === '2',
    // Tethers come out Cardinals (0 seconds), (3s) Other Cardinals
    suppressSeconds: 4,
    infoText: (data, matches, output) => {
      const thorn = (data.thornIds ??= []).indexOf(parseInt(matches.sourceId, 16));
      const thornMap = {
        0: output.text({
          dir1: output.north(),
          dir2: output.south()
        }),
        1: output.text({
          dir1: output.north(),
          dir2: output.south()
        }),
        2: output.text({
          dir1: output.north(),
          dir2: output.south()
        }),
        3: output.text({
          dir1: output.north(),
          dir2: output.south()
        }),
        4: output.text({
          dir1: output.east(),
          dir2: output.west()
        }),
        5: output.text({
          dir1: output.east(),
          dir2: output.west()
        }),
        6: output.text({
          dir1: output.east(),
          dir2: output.west()
        }),
        7: output.text({
          dir1: output.east(),
          dir2: output.west()
        })
      };
      return thornMap[thorn];
    },
    outputStrings: {
      text: {
        en: '${dir1}/${dir2} first',
        de: '${dir1}/${dir2} zuerst',
        fr: '${dir1}/${dir2} en premier',
        ja: '${dir1}/${dir2}から',
        cn: '先去 ${dir1}/${dir2}',
        ko: '${dir1}/${dir2}부터'
      },
      north: outputs/* default.north */.Z.north,
      east: outputs/* default.east */.Z.east,
      south: outputs/* default.south */.Z.south,
      west: outputs/* default.west */.Z.west
    }
  }, {
    id: 'P4S Act Headmarker Collector',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.act !== undefined,
    run: (data, matches) => {
      data.actHeadmarkers[matches.target] = p4s_getHeadmarkerId(data, matches, orangeMarker);
    }
  }, {
    id: 'P4S Act 2 Color Tether',
    type: 'Tether',
    netRegex: {
      id: '00AC'
    },
    condition: data => data.act === '2',
    alertText: (data, matches, output) => {
      if (matches.target !== data.me && matches.source !== data.me) return;

      // Only the healer gets a purple headmarker, and the tethered tank does not.
      const id = data.actHeadmarkers[matches.source] ?? data.actHeadmarkers[matches.target];
      if (id === undefined) {
        console.error(`Act 2 Tether: missing headmarker: ${JSON.stringify(data.actHeadmarkers)}`);
        return;
      }
      const other = data.party.member(matches.target === data.me ? matches.source : matches.target);
      return {
        '012D': output.purpleTether({
          player: other
        }),
        '012E': output.greenTether({
          player: other
        }),
        '012F': output.orangeTether({
          player: other
        })
      }[id];
    },
    outputStrings: {
      purpleTether: {
        en: 'Purple (with ${player})',
        de: 'Lila (mit ${player})',
        fr: 'Violet (avec ${player})',
        ja: 'ダージャ (${player})',
        cn: '暗线 (${player})',
        ko: '다쟈 (${player})'
      },
      orangeTether: {
        en: 'Fire (with ${player})',
        de: 'Feuer (mit ${player})',
        fr: 'Feu (avec ${player})',
        ja: 'ファイガ (${player})',
        cn: '火线 (${player})',
        ko: '파이가 (${player})'
      },
      greenTether: {
        en: 'Air (with ${player})',
        de: 'Luft (mit ${player})',
        fr: 'Air (avec ${player})',
        ja: 'エアロガ (${player})',
        cn: '风线 (${player})',
        ko: '에어로가 (${player})'
      }
    }
  }, {
    id: 'P4S Act 4 Color Tether',
    type: 'Tether',
    // Tether comes after the headmarker color.
    netRegex: {
      id: '00A[CD]',
      source: 'Hesperos'
    },
    condition: (data, matches) => data.act === '4' && matches.target === data.me,
    durationSeconds: (data, matches) => data.actHeadmarkers[matches.target] === '012D' ? 12 : 9,
    suppressSeconds: 9999,
    promise: async (data, matches) => {
      const result = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.sourceId, 16)]
      });
      const myThorn = result.combatants[0];
      if (!myThorn) {
        console.error(`Act 4 Tether: null data`);
        return;
      }
      data.actFourThorn = myThorn;
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        blueTether: {
          en: 'Blue Tether',
          de: 'Blaue Verbindung',
          fr: 'Lien bleu',
          ja: 'ワタガ (青)',
          cn: '蓝标连线',
          ko: '워터가 (파랑)'
        },
        purpleTether: {
          en: 'Purple Tether',
          de: 'Lila Verbindung',
          fr: 'lien violet',
          ja: 'ダージャ(紫)',
          cn: '紫标连线',
          ko: '다쟈 (보라색)'
        },
        blueTetherDir: {
          en: 'Blue Tether (${dir})',
          de: 'Blaue Verbindung (${dir})',
          fr: 'Lien bleu direction (${dir})',
          cn: '蓝标连线 (${dir})',
          ko: '워터가 (파랑) (${dir})'
        },
        purpleTetherDir: {
          en: 'Purple Tether (${dir})',
          de: 'Lilane Verbindung (${dir})',
          fr: 'lien violet direction (${dir})',
          cn: '紫标连线 (${dir})',
          ko: '다쟈 (보라색) (${dir})'
        },
        dirN: outputs/* default.dirN */.Z.dirN,
        dirNE: outputs/* default.dirNE */.Z.dirNE,
        dirE: outputs/* default.dirE */.Z.dirE,
        dirSE: outputs/* default.dirSE */.Z.dirSE,
        dirS: outputs/* default.dirS */.Z.dirS,
        dirSW: outputs/* default.dirSW */.Z.dirSW,
        dirW: outputs/* default.dirW */.Z.dirW,
        dirNW: outputs/* default.dirNW */.Z.dirNW,
        unknown: outputs/* default.unknown */.Z.unknown
      };
      const id = data.actHeadmarkers[matches.target];
      if (id === undefined) return;
      if (data.actFourThorn === undefined) {
        if (id === '012C') return {
          infoText: output.blueTether()
        };
        if (id === '012D') return {
          alertText: output.purpleTether()
        };
        return;
      }
      const centerX = 100;
      const centerY = 100;
      const x = data.actFourThorn.PosX - centerX;
      const y = data.actFourThorn.PosY - centerY;
      // Dirs: N = 0, NE = 1, ..., NW = 7
      const thornDir = Math.round(4 - 4 * Math.atan2(x, y) / Math.PI) % 8;
      const dirStr = {
        0: output.dirN(),
        1: output.dirNE(),
        2: output.dirE(),
        3: output.dirSE(),
        4: output.dirS(),
        5: output.dirSW(),
        6: output.dirW(),
        7: output.dirNW()
      }[thornDir] ?? output.unknown();
      if (id === '012C') return {
        infoText: output.blueTetherDir({
          dir: dirStr
        })
      };
      if (id === '012D') return {
        alertText: output.purpleTetherDir({
          dir: dirStr
        })
      };
    }
  }, {
    id: 'P4S Ultimate Impulse',
    type: 'StartsUsing',
    netRegex: {
      id: '6A2C',
      source: 'Hesperos',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'P4S Act Three Bait Order',
    type: 'Tether',
    netRegex: {
      id: '00AD',
      source: 'Hesperos'
    },
    condition: data => data.act === '3',
    // Tethers come out East or West (0 seconds), (3s) Middle knockack, (6) Opposite Cardinal
    suppressSeconds: 7,
    infoText: (data, matches, output) => {
      const thorn = (data.thornIds ??= []).indexOf(parseInt(matches.sourceId, 16));
      const thornMapDirs = {
        0: 'east',
        1: 'east',
        2: 'east',
        3: 'east',
        4: 'west',
        5: 'west',
        6: 'west',
        7: 'west'
      };
      data.jumpDir1 = thornMapDirs[thorn];
      return output[thornMapDirs[thorn] ??= 'unknown']();
    },
    outputStrings: {
      text: {
        en: 'Bait Jump ${dir1} first',
        de: 'Köder Sprung ${dir1} zuerst',
        fr: 'Attirez le saut à l\'${dir1} en premier',
        ja: 'ジャンプ誘導: ${dir1}',
        cn: '引导跳跃 先去 ${dir1}',
        ko: '점프 유도: ${dir1} 먼저'
      },
      east: outputs/* default.east */.Z.east,
      west: outputs/* default.west */.Z.west,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'P4S Heart Stake',
    type: 'StartsUsing',
    netRegex: {
      id: '6A2B',
      source: 'Hesperos'
    },
    condition: conditions/* default.caresAboutPhysical */.Z.caresAboutPhysical(),
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'P4S Wreath of Thorns 5',
    type: 'StartsUsing',
    netRegex: {
      id: '6A34',
      source: 'Hesperos',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread at tethered thorn',
        de: 'Verteilen bei der Dornenhecke',
        fr: 'Dispersez-vous vers une épine liée',
        ja: '結ばれた羽の方で散開',
        cn: '在连线荆棘处散开',
        ko: '연결된 가시 주위로 산개'
      }
    }
  }, {
    id: 'P4S Fleeting Impulse',
    type: 'Ability',
    netRegex: {
      id: '6A1C',
      source: 'Hesperos'
    },
    preRun: (data, _matches) => {
      data.fleetingImpulseCounter = (data.fleetingImpulseCounter ?? 0) + 1;
    },
    // ~22.3 seconds between #1 Fleeting Impulse (6A1C) to #1 Hemitheos's Thunder III (6A0E)
    // ~21.2 seconds between #8 Fleeting Impulse (6A1C) to #8 Hemitheos's Thunder III (6A0E).
    // Split the difference with 22 seconds.
    durationSeconds: 22,
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.text({
        num: data.fleetingImpulseCounter
      });
    },
    outputStrings: {
      text: {
        en: '${num}',
        de: '${num}',
        fr: '${num}',
        ja: '羽: ${num}番目',
        cn: '${num}',
        ko: '가시: ${num}번째'
      }
    }
  }, {
    id: 'P4S Curtain Call Debuffs',
    // Durations could be 12s, 22s, 32s, and 42s
    type: 'GainsEffect',
    netRegex: {
      effectId: 'AF4',
      capture: true
    },
    condition: (data, matches) => {
      return data.me === matches.target && data.act === 'curtain';
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = curtainCallOutputStrings;
      data.curtainCallGroup = Math.ceil((parseFloat(matches.duration) - 2) / 10);
      if (data.curtainCallGroup === 1) return {
        alarmText: output.group({
          num: data.curtainCallGroup
        })
      };
      return {
        infoText: output.group({
          num: data.curtainCallGroup
        })
      };
    }
  }, {
    id: 'P4S Curtain Call Reminders',
    // Alarms for the other groups
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B7D',
      capture: true
    },
    condition: data => data.act === 'curtain',
    preRun: data => data.curtainCallTracker = (data.curtainCallTracker ?? 0) + 1,
    delaySeconds: (_data, matches) => parseFloat(matches.duration),
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      if (data.curtainCallGroup === 2 && data.curtainCallTracker === 2 || data.curtainCallGroup === 3 && data.curtainCallTracker === 4 || data.curtainCallGroup === 4 && data.curtainCallTracker === 6) return output.group({
        num: data.curtainCallGroup
      });
    },
    run: data => {
      // Clear once 8 tethers have been broken
      if (data.curtainCallTracker === 8) {
        data.curtainCallTracker = 0;
        data.curtainCallGroup = 0;
      }
    },
    outputStrings: curtainCallOutputStrings
  }, {
    id: 'P4S Hell\'s Sting',
    type: 'StartsUsing',
    netRegex: {
      id: '6A1E',
      source: 'Hesperos',
      capture: false
    },
    infoText: (_data, _matches, output) => output.protean(),
    outputStrings: {
      protean: {
        en: 'Protean',
        de: 'Himmelsrichtungen',
        fr: 'Positions',
        ja: '8方向散開',
        cn: '分散站位',
        ko: '정해진 위치로 산개'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Well Pinax/Levinstrike Pinax': 'Well/Levinstrike Pinax',
      'Levinstrike Pinax/Well Pinax': 'Levinstrike/Well Pinax',
      'Acid Pinax/Lava Pinax': 'Acid/Lava Pinax',
      'Lava Pinax/Acid Pinax': 'Lava/Acid Pinax'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Hesperos': 'Hesperos'
    },
    'replaceText': {
      '--debuffs--': '--Debuffs--',
      '--element debuffs--': '--Elementar-Debuffs--',
      '--role debuffs--': '--Rollen-Debuffs--',
      'Acid Pinax': 'Säure-Pinax',
      'Aetheric Chlamys': 'Ätherische Chlamys',
      'Akanthai: Act 1': 'Akanthai: Erster Akt',
      'Akanthai: Act 2': 'Akanthai: Zweiter Akt',
      'Akanthai: Act 3': 'Akanthai: Dritter Akt',
      'Akanthai: Act 4': 'Akanthai: Vierter Akt',
      'Akanthai: Curtain Call': 'Akanthai: Vorhang',
      'Akanthai: Finale': 'Akanthai: Finale',
      'Belone Bursts': 'Berstendes Belone',
      'Belone Coils': 'Gewundenes Belone',
      'Bloodrake': 'Blutharke',
      '(?<!Belone )Burst': 'Explosion',
      'Cursed Casting': 'Fluches Frucht',
      'Dark Design': 'Finsteres Formen',
      'Decollation': 'Enthauptung',
      'Demigod Double': 'Hemitheischer Hieb',
      'Director\'s Belone': 'Maskiertes Belone',
      'Directional Shift': 'Himmelsrichtung-Schwingen',
      'Elegant Evisceration': 'Adrette Ausweidung',
      'Elemental Belone': 'Elementares Belone',
      'Farsight': 'Blick in die Ferne',
      'Fleeting Impulse': 'Flüchtiger Impuls',
      'Heart Stake': 'Herzenspfahl',
      'Hell\'s Sting': 'Höllenstich',
      'Hemitheos\'s Aero III': 'Hemitheisches Windga',
      'Hemitheos\'s Dark IV': 'Hemitheisches Nachtka',
      'Hemitheos\'s Fire III': 'Hemitheisches Feuga',
      'Hemitheos\'s Fire IV': 'Hemitheisches Feuka',
      'Hemitheos\'s Thunder III': 'Hemitheisches Blitzga',
      'Hemitheos\'s Water IV': 'Hemitheisches Aquaka',
      'Inversive Chlamys': 'Invertierte Chlamys',
      'Kothornos Kick': 'Kothornoi-Tritt',
      'Kothornos Quake': 'Kothornoi-Beben',
      'Lava Pinax': 'Lava-Pinax',
      'Levinstrike Pinax': 'Donner-Pinax',
      'Nearsight': 'Blick nach innen',
      'Periaktoi': 'Periaktoi',
      '(?<!\\w )Pinax': 'Pinax',
      'Searing Stream': 'Sengender Strom',
      'Setting the Scene': 'Vorhang auf',
      'Shifting Strike': 'Schwingenschlag',
      'Ultimate Impulse': 'Ultimativer Impuls',
      'Vengeful Belone': 'Rachsüchtiges Belone',
      'Well Pinax': 'Brunnen-Pinax',
      'Wreath of Thorns': 'Dornenhecke'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Hesperos': 'Hespéros'
    },
    'replaceText': {
      '--debuffs--': '--debuffs--',
      '--element debuffs--': '--debuffs d\'éléments--',
      '--role debuffs--': '--debuffs de rôles--',
      '(?<!/)Acid Pinax(?!/)': 'Pinax de poison',
      'Acid Pinax/Lava Pinax': 'Pinax de poison/feu',
      'Aetheric Chlamys': 'Chlamyde d\'éther',
      'Akanthai: Act 1': 'La Tragédie des épines : acte I',
      'Akanthai: Act 2': 'La Tragédie des épines : acte II',
      'Akanthai: Act 3': 'La Tragédie des épines : acte III',
      'Akanthai: Act 4': 'La Tragédie des épines : acte IV',
      'Akanthai: Curtain Call': 'La Tragédie des épines : rappel',
      'Akanthai: Finale': 'La Tragédie des épines : acte final',
      'Belone Bursts': 'Bélos enchanté : explosion',
      'Belone Coils': 'Bélos enchanté : rotation',
      'Bloodrake': 'Racle de sang',
      '(?<!Belone )Burst': 'Explosion',
      'Cursed Casting': 'Malédiction immortelle',
      'Dark Design': 'Dessein noir',
      'Decollation': 'Décollation',
      'Demigod Double': 'Gémellité du demi-dieu',
      'Directional Shift': 'Frappe mouvante vers un cardinal',
      'Director\'s Belone': 'Bélos enchanté : persona',
      'Elegant Evisceration': 'Éviscération élégante',
      'Elemental Belone': 'Bélos enchanté : élémentaire',
      'Fleeting Impulse': 'Impulsion fugace',
      'Heart Stake': 'Pieu dans le cœur',
      'Hell\'s Sting': 'Pointe infernale',
      'Hemitheos\'s Aero III': 'Méga Vent de l\'hémithéos',
      'Hemitheos\'s Dark IV': 'Giga Ténèbres de l\'hémithéos',
      'Hemitheos\'s Fire III': 'Méga Feu de l\'hémithéos',
      'Hemitheos\'s Fire IV': 'Giga Feu de l\'hémithéos',
      'Hemitheos\'s Thunder III': 'Méga Foudre de l\'hémithéos',
      'Hemitheos\'s Water IV': 'Giga Eau de l\'hémithéos',
      'Inversive Chlamys': 'Chlamyde retournée',
      'Kothornos Kick': 'Coup de cothurne',
      'Kothornos Quake': 'Piétinement de cothurne',
      '(?<!/)Lava Pinax(?!/)': 'Pinax de feu',
      'Lava Pinax/Acid Pinax': 'Pinax de feu/poison',
      '(?<!/)Levinstrike Pinax(?!/)': 'Pinax de foudre',
      'Levinstrike Pinax/Well Pinax': 'Pinax de foudre/eau',
      'Nearsight/Farsight': 'Frappe introspéctive/visionnaire',
      'Periaktoi': 'Périacte',
      '(?<!\\w )Pinax': 'Pinax',
      'Searing Stream': 'Flux ardent',
      'Setting the Scene': 'Lever de rideau',
      'Shifting Strike': 'Frappe mouvante',
      'Ultimate Impulse': 'Impulsion ultime',
      'Vengeful Belone': 'Bélos enchanté : vengeance',
      '(?<!/)Well Pinax(?!/)': 'Pinax d\'eau',
      'Well Pinax/Levinstrike Pinax': 'Pinax d\'eau/foudre',
      'Wreath of Thorns': 'Haie d\'épines'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Hesperos': 'ヘスペロス'
    },
    'replaceText': {
      'Acid Pinax': 'ピナクスポイズン',
      'Aetheric Chlamys': 'エーテルクラミュス',
      'Akanthai: Act 1': '茨の悲劇：序幕',
      'Akanthai: Act 2': '茨の悲劇：第ニ幕',
      'Akanthai: Act 3': '茨の悲劇：第三幕',
      'Akanthai: Act 4': '茨の悲劇：第四幕',
      'Akanthai: Curtain Call': '茨の悲劇：カーテンコール',
      'Akanthai: Finale': '茨の悲劇：終幕',
      'Belone Bursts': 'エンチャンテッドペロネー：エクスプロージョン',
      'Belone Coils': 'エンチャンテッドペロネー：ラウンド',
      'Bloodrake': 'ブラッドレイク',
      '(?<!Belone )Burst': '爆発',
      'Cursed Casting': '呪詛発動',
      'Dark Design': 'ダークデザイン',
      'Decollation': 'デコレーション',
      'Director\'s Belone': 'エンチャンテッドペロネー：ペルソナ',
      'Elegant Evisceration': 'エレガントイヴィセレーション',
      'Elemental Belone': 'エンチャンテッドペロネー：エレメンタル',
      'Fleeting Impulse': 'フリーティングインパルス',
      'Heart Stake': 'ハートステイク',
      'Hell\'s Sting': 'ヘルスティング',
      'Hemitheos\'s Aero III': 'ヘーミテオス・エアロガ',
      'Hemitheos\'s Dark IV': 'ヘーミテオス・ダージャ',
      'Hemitheos\'s Fire III': 'ヘーミテオス・ファイガ',
      'Hemitheos\'s Fire IV': 'ヘーミテオス・ファイジャ',
      'Hemitheos\'s Thunder III': 'ヘーミテオス・サンダガ',
      'Hemitheos\'s Water IV': 'ヘーミテオス・ウォタジャ',
      'Inversive Chlamys': 'インヴァースクラミュス',
      'Kothornos Kick': 'コトルヌスキック',
      'Kothornos Quake': 'コトルヌスクエイク',
      'Lava Pinax': 'ピナクスラーヴァ',
      'Levinstrike Pinax': 'ピナクスサンダー',
      'Periaktoi': 'ペリアクトイ',
      '(?<!\\w )Pinax': 'ピナクス',
      'Searing Stream': 'シアリングストリーム',
      'Setting the Scene': '劇場創造',
      'Shifting Strike': 'シフティングストライク',
      'Ultimate Impulse': 'アルティメットインパルス',
      'Vengeful Belone': 'エンチャンテッドペロネー：リベンジ',
      'Well Pinax': 'ピナクススプラッシュ',
      'Wreath of Thorns': 'ソーンヘッジ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Hesperos': '赫斯珀洛斯'
    },
    'replaceText': {
      '--debuffs--': '--Debuff--',
      '--element debuffs--': '--元素Debuff--',
      '--role debuffs--': '--职能Debuff--',
      'Acid Pinax': '剧毒板画',
      'Aetheric Chlamys': '以太斗篷',
      'Akanthai: Act 1': '荆棘悲剧：序幕',
      'Akanthai: Act 2': '荆棘悲剧：第二幕',
      'Akanthai: Act 3': '荆棘悲剧：第三幕',
      'Akanthai: Act 4': '荆棘悲剧：第四幕',
      'Akanthai: Curtain Call': '荆棘悲剧：谢幕',
      'Akanthai: Finale': '荆棘悲剧：结幕',
      'Belone Bursts': '附魔佩罗涅·爆炸',
      'Belone Coils': '附魔佩罗涅·场地',
      'Bloodrake': '聚血',
      '(?<!Belone )Burst': '爆炸',
      'Cursed Casting': '诅咒发动',
      'Dark Design': '黑暗设计',
      'Decollation': '断头',
      'Demigod Double': '半神双击',
      'Director\'s Belone': '附魔佩罗涅·职责',
      'Directional Shift': '换位强袭·方位',
      'Elegant Evisceration': '优雅除脏',
      'Elemental Belone': '附魔佩罗涅·元素',
      'Farsight': '远见的魔击',
      'Fleeting Impulse': '闪现脉冲',
      'Heart Stake': '刺心桩',
      'Hell\'s Sting': '地狱苦痛',
      'Hemitheos\'s Aero III': '半神暴风',
      'Hemitheos\'s Dark IV': '半神冥暗',
      'Hemitheos\'s Fire III': '半神爆炎',
      'Hemitheos\'s Fire IV': '半神炽炎',
      'Hemitheos\'s Thunder III': '半神暴雷',
      'Hemitheos\'s Water IV': '半神骇水',
      'Inversive Chlamys': '翻转斗篷',
      'Kothornos Kick': '舞台靴重踢',
      'Kothornos Quake': '舞台靴踏地',
      'Lava Pinax': '熔岩板画',
      'Levinstrike Pinax': '雷电板画',
      'Nearsight': '近思的魔击',
      'Periaktoi': '场景旋转',
      '(?<!\\w )Pinax': '板画',
      'Searing Stream': '灼热流',
      'Setting the Scene': '布置剧场',
      'Shifting Strike': '换位强袭',
      'Ultimate Impulse': '究极脉冲',
      'Vengeful Belone': '附魔佩罗涅·复仇',
      'Well Pinax': '喷水板画',
      'Wreath of Thorns': '荆棘缠绕'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Hesperos': '헤스페로스'
    },
    'replaceText': {
      '--debuffs--': '--디버프--',
      '--element debuffs--': '--속성 디버프--',
      '--role debuffs--': '--역할 디버프--',
      '(?<!/)Acid Pinax(?!/)': '독 배경판',
      'Acid Pinax/Lava Pinax': '독/용암 배경판',
      'Aetheric Chlamys': '에테르 망토',
      'Akanthai: Act 1': '가시의 비극: 서막',
      'Akanthai: Act 2': '가시의 비극: 제2막',
      'Akanthai: Act 3': '가시의 비극: 제3막',
      'Akanthai: Act 4': '가시의 비극: 제4막',
      'Akanthai: Curtain Call': '가시의 비극: 커튼콜',
      'Akanthai: Finale': '가시의 비극: 종막',
      'Belone Bursts': '마법검 벨로네: 폭발',
      'Belone Coils': '마법검 벨로네: 원형',
      'Bloodrake': '피갈퀴',
      '(?<!Belone )Burst': '폭발',
      'Cursed Casting': '저주 발동',
      'Dark Design': '어둠 설계',
      'Decollation': '집단 참수',
      'Demigod Double': '반신의 쌍격',
      'Director\'s Belone': '마법검 벨로네: 역할',
      'Directional Shift': '이동 공격: 동서남북',
      'Elegant Evisceration': '우아한 적출',
      'Elemental Belone': '마법검 벨로네: 속성',
      'Fleeting Impulse': '순간 충격',
      'Heart Stake(?! )': '심장 말뚝',
      'Heart Stake OT': '심장 말뚝 2타',
      'Hell\'s Sting': '지옥 할퀴기',
      'Hemitheos\'s Aero III': '헤미테오스 에어로가',
      'Hemitheos\'s Dark IV': '헤미테오스 다쟈',
      'Hemitheos\'s Fire III': '헤미테오스 파이가',
      'Hemitheos\'s Fire IV': '헤미테오스 파이쟈',
      'Hemitheos\'s Thunder III': '헤미테오스 선더가',
      'Hemitheos\'s Water IV': '헤미테오스 워터쟈',
      'Inversive Chlamys': '망토 휘두르기',
      'Kothornos Kick': '무대신 발길질',
      'Kothornos Quake': '무대신 땅울림',
      '(?<!/)Lava Pinax(?!/)': '용암 배경판',
      'Lava Pinax/Acid Pinax': '용암/독 배경판',
      '(?<!/)Levinstrike Pinax(?!/)': '번개 배경판',
      'Levinstrike Pinax/Well Pinax': '번개/물기둥 배경판',
      'Nearsight/Farsight': '근거리/원거리 마격',
      'Periaktoi': '삼면 배경',
      '(?<!\\w )Pinax': '배경판',
      'Searing Stream': '작열 기류',
      'Setting the Scene': '극장 창조',
      'Shifting Strike': '이동 공격',
      'Ultimate Impulse': '극한 충격',
      'Vengeful Belone': '마법검 벨로네: 복수',
      '(?<!/)Well Pinax(?!/)': '물기둥 배경판',
      'Well Pinax/Levinstrike Pinax': '물기둥/번개 배경판',
      'Wreath of Thorns': '가시 울타리'
    }
  }]
};
/* harmony default export */ const p4s = (p4s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p4s.txt
const raid_p4s_namespaceObject = "### P4S: Asphodelos: The Fourth Circle (Savage)\r\n#\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n### Hesperos I\r\n#\r\n# -p 6A09:15\r\n# -ii 6A16 69DA 69DB 69DC 69D0 69D1 69D2 69D3 69F5 69F6 69F7 69F8 69F9 69FA\r\n#     69FB 69FC\r\n\r\n# Note: every Pinax is also accompanied by a Mekhane (69D0 through 69D3)\r\n# of the same name.  These all happen at the same time, and are the\r\n# abilities that hit the player, so are removed.\r\n\r\n# Note: Northerly Shift (6A02, 69FD), Southerly Shift (6A03, 69FE),\r\n# Easterly Shift (6A04, 69FF), and Westerly Shift (6A05, 6A00)\r\n# are all combined into \"Directional Shift\" for brevity.  The first\r\n# id is for a shift + cleave, and the second id is for shift + knockback.\r\n\r\n# Note: Periaktoi is accompanied by three explosive tiles and one non-explosive.\r\n# The non-explosive tile is the one not tethered in an earlier mechanic and has\r\n# Acid Pinax (69F5), Lava Pinax (69F6), Well Pinax (69F7), Levinstrike Pinax (69F8)\r\n# are the safe tiles.\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n10.0 \"--sync--\" StartsUsing { id: \"6A09\", source: \"Hesperos\" } window 10,20\r\n15.0 \"Decollation\" Ability { id: \"6A09\", source: \"Hesperos\" }\r\n23.2 \"Bloodrake\" Ability { id: \"69D8\", source: \"Hesperos\" }\r\n30.3 \"Aetheric Chlamys\" Ability { id: \"69EC\", source: \"Hesperos\" }\r\n38.5 \"Bloodrake\" Ability { id: \"69D8\", source: \"Hesperos\" }\r\n47.7 \"Director's Belone\" Ability { id: \"69E6\", source: \"Hesperos\" }\r\n48.5 \"--debuffs--\" Ability { id: \"69E7\", source: \"Hesperos\" }\r\n63.9 \"Inversive Chlamys\" Ability { id: \"69ED\", source: \"Hesperos\" }\r\n64.1 \"Cursed Casting\" Ability { id: [\"69E8\", \"69E9\"], source: \"Hesperos\" }\r\n64.7 \"Inversive Chlamys\" Ability { id: [\"69EE\", \"69EF\"], source: \"Hesperos\" }\r\n73.1 \"Decollation\" Ability { id: \"6A09\", source: \"Hesperos\" }\r\n82.3 \"Elegant Evisceration 1\" Ability { id: \"6A08\", source: \"Hesperos\" }\r\n85.5 \"Elegant Evisceration 2\" Ability { id: \"6819\", source: \"Hesperos\" }\r\n93.7 \"--sync--\" Ability { id: \"69CA\", source: \"Hesperos\" }\r\n\r\n# Scene 1\r\n100.7 \"Setting the Scene\" Ability { id: \"69CB\", source: \"Hesperos\" }\r\n113.8 \"Pinax\" Ability { id: \"69CF\", source: \"Hesperos\" }\r\n123.9 \"Well Pinax/Levinstrike Pinax\" Ability { id: [\"69D6\", \"69D7\"], source: \"Hesperos\" }\r\n126.8 \"Acid Pinax/Lava Pinax\" Ability { id: [\"69D4\", \"69D5\"], source: \"Hesperos\" }\r\n128.9 \"--middle--\" Ability { id: \"69CE\", source: \"Hesperos\" }\r\n136.8 \"Levinstrike Pinax/Well Pinax\" Ability { id: [\"69D7\", \"69D6\"], source: \"Hesperos\" }\r\n138.4 \"Directional Shift\" Ability { id: [\"69FD\", \"69FE\", \"69FF\", \"6A00\", \"6A02\", \"6A03\", \"6A04\", \"6A05\"], source: \"Hesperos\" }\r\n140.1 \"Shifting Strike\" Ability { id: [\"6A01\", \"6A06\"], source: \"Hesperos\" }\r\n147.7 \"Lava Pinax/Acid Pinax\" Ability { id: [\"69D5\", \"69D4\"], source: \"Hesperos\" }\r\n156.5 \"Elegant Evisceration 1\" Ability { id: \"6A08\", source: \"Hesperos\" }\r\n159.7 \"Elegant Evisceration 2\" Ability { id: \"6819\", source: \"Hesperos\" }\r\n\r\n# Scene 2\r\n167.8 \"Bloodrake\" Ability { id: \"69D8\", source: \"Hesperos\" }\r\n172.0 \"--sync--\" Ability { id: \"69CA\", source: \"Hesperos\" }\r\n179.0 \"Setting the Scene\" Ability { id: \"69CB\", source: \"Hesperos\" }\r\n191.1 \"Vengeful Belone\" Ability { id: \"6E22\", source: \"Hesperos\" }\r\n191.9 \"--role debuffs--\" Ability { id: \"6E23\", source: \"Hesperos\" }\r\n199.3 \"Elemental Belone\" Ability { id: \"69F2\", source: \"Hesperos\" }\r\n200.1 \"--element debuffs--\" Ability { id: \"69F3\", source: \"Hesperos\" }\r\n207.5 \"Bloodrake\" Ability { id: \"69D8\", source: \"Hesperos\" }\r\n216.7 \"Belone Bursts\" Ability { id: \"69D9\", source: \"Hesperos\" }\r\n230.8 \"Periaktoi\" Ability { id: \"69F4\", source: \"Hesperos\" }\r\n230.8 \"Acid Pinax\" #Ability { id: [\"69F5\", \"69F9\"], source: \"Hesperos\" }\r\n230.8 \"Well Pinax\" #Ability { id: [\"69F7\", \"69FB\"], source: \"Hesperos\" }\r\n230.8 \"Lava Pinax\" #Ability { id: [\"69F6\", \"69FA\"], source: \"Hesperos\" }\r\n230.8 \"Levinstrike Pinax\" #Ability { id: [\"69F8\", \"69FC\"], source: \"Hesperos\" }\r\n\r\n# Towers\r\n243.0 \"Bloodrake\" Ability { id: \"69D8\", source: \"Hesperos\" }\r\n250.1 \"Belone Coils\" Ability { id: \"69DD\", source: \"Hesperos\" }\r\n260.3 \"Inversive Chlamys\" Ability { id: \"69ED\", source: \"Hesperos\" }\r\n260.9 \"Burst\" Ability { id: [\"69DE\", \"69DF\", \"69E0\", \"69E1\"], source: \"Hesperos\" }\r\n261.1 \"Inversive Chlamys\" #Ability { id: \"6F15\", source: \"Hesperos\" }\r\n267.4 \"Aetheric Chlamys\" Ability { id: \"69EC\", source: \"Hesperos\" }\r\n275.6 \"Bloodrake\" Ability { id: \"69D8\", source: \"Hesperos\" }\r\n283.7 \"Belone Coils\" Ability { id: \"69DD\", source: \"Hesperos\" }\r\n294.5 \"Burst\" Ability { id: [\"69DE\", \"69DF\", \"69E0\", \"69E1\"], source: \"Hesperos\" }\r\n297.9 \"Director's Belone\" Ability { id: \"69E6\", source: \"Hesperos\" }\r\n298.7 \"--debuffs--\" Ability { id: \"69E7\", source: \"Hesperos\" }\r\n314.1 \"Inversive Chlamys\" Ability { id: \"69ED\", source: \"Hesperos\" }\r\n314.3 \"Cursed Casting\" #Ability { id: [\"69E8\", \"69E9\"], source: \"Hesperos\" }\r\n314.9 \"Inversive Chlamys\" Ability { id: [\"69EE\", \"69EF\"], source: \"Hesperos\" }\r\n323.3 \"Decollation\" Ability { id: \"6A09\", source: \"Hesperos\" }\r\n332.5 \"Elegant Evisceration 1\" Ability { id: \"6A08\", source: \"Hesperos\" }\r\n335.7 \"Elegant Evisceration 2\" Ability { id: \"6819\", source: \"Hesperos\" }\r\n343.9 \"--sync--\" Ability { id: \"69CA\", source: \"Hesperos\" }\r\n\r\n# Scene 3\r\n350.9 \"Setting the Scene\" Ability { id: \"69CB\", source: \"Hesperos\" }\r\n364.1 \"Pinax\" Ability { id: \"69CF\", source: \"Hesperos\" }\r\n374.2 \"Well Pinax/Levinstrike Pinax\" Ability { id: [\"69D6\", \"69D7\"], source: \"Hesperos\" }\r\n377.1 \"Acid Pinax/Lava Pinax\" Ability { id: [\"69D4\", \"69D5\"], source: \"Hesperos\" }\r\n379.2 \"--middle--\" Ability { id: \"69CE\", source: \"Hesperos\" }\r\n387.1 \"Levinstrike Pinax/Well Pinax\" Ability { id: [\"69D7\", \"69D6\"], source: \"Hesperos\" }\r\n389.1 \"Directional Shift\" Ability { id: [\"69FD\", \"69FE\", \"69FF\", \"6A00\", \"6A02\", \"6A03\", \"6A04\", \"6A05\"], source: \"Hesperos\" }\r\n390.6 \"Shifting Strike\" Ability { id: [\"6A01\", \"6A06\"], source: \"Hesperos\" }\r\n398.1 \"Lava Pinax/Acid Pinax\" Ability { id: [\"69D5\", \"69D4\"], source: \"Hesperos\" }\r\n403.2 \"Decollation\" Ability { id: \"6A09\", source: \"Hesperos\" }\r\n412.4 \"Decollation\" Ability { id: \"6A09\", source: \"Hesperos\" }\r\n421.6 \"Decollation\" Ability { id: \"6A09\", source: \"Hesperos\" }\r\n432.5 \"--untargetable--\"\r\n437.6 \"Decollation (enrage)\" Ability { id: \"6A0B\", source: \"Hesperos\" }\r\n\r\n\r\n### Hesperos II\r\n#\r\n# -p 6A2D:1016\r\n# -ii 6A0D 6A0E 6A14 6A16 6A18 6A1C 6A1E 6A1F 6A28 6DDB 6A22 6A26 6A27 6A29\r\n#     6A25 6CD7 6A0F 6A1A\r\n\r\n# Note: Thorn mechanics have a pass (first) and fail (second) spell.\r\n#       Hemitheos's Thunder III (6A0E, 6A0F)\r\n#       Hemitheos's Fire III (6A18, 6CD7)\r\n#       Hemitheos's Aero III (6A1B, 6A1A)\r\n\r\n1000.0 \"Start\"\r\n1011.0 \"--sync--\" StartsUsing { id: \"6A2D\", source: \"Hesperos\" } window 1011,0\r\n1016.0 \"Searing Stream\" Ability { id: \"6A2D\", source: \"Hesperos\" }\r\n\r\n# Act 1 - Thorns 1\r\n1031.2 \"Akanthai: Act 1\" Ability { id: \"6A0C\", source: \"Hesperos\" }\r\n1040.4 \"Searing Stream\" Ability { id: \"6A2D\", source: \"Hesperos\" }\r\n1054.6 \"Wreath of Thorns 1\" Ability { id: \"6A2F\", source: \"Hesperos\" }\r\n1057.7 \"Hemitheos's Fire IV\" Ability { id: \"6A0D\", source: \"Hesperos\" }\r\n1060.7 \"Hemitheos's Thunder III\" Ability { id: \"6A0E\", source: \"Hesperos\" }\r\n1063.7 \"Hemitheos's Fire IV\" Ability { id: \"6A0D\", source: \"Hesperos\" }\r\n1070.9 \"Nearsight/Farsight\" Ability { id: [\"6A28\", \"6DDB\"], source: \"Hesperos\" }\r\n\r\n# Act 2 - Thorns 2 with Red/Purple/Green Colors\r\n1083.0 \"Akanthai: Act 2\" Ability { id: \"6EB4\", source: \"Hesperos\" }\r\n1092.2 \"Demigod Double\" Ability { id: \"6E78\", source: \"Hesperos\" }\r\n1102.4 \"Wreath of Thorns 2\" Ability { id: \"6A30\", source: \"Hesperos\" }\r\n1110.4 \"Hemitheos's Dark IV\" #Ability { id: \"6A16\", source: \"Hesperos\" }\r\n1113.7 \"Dark Design\" Ability { id: \"6A2A\", source: \"Hesperos\" }\r\n1115.5 \"Hemitheos's Fire IV\" Ability { id: [\"6A0D\", \"6A0E\"], source: \"Hesperos\" }\r\n1115.5 \"Hemitheos's Thunder III x2\" #Ability { id: \"6A0E\", source: \"Hesperos\" }\r\n1115.9 \"Hemitheos's Fire III x2\" #Ability { id: \"6A18\", source: \"Hesperos\" }\r\n1122.5 \"Hemitheos's Thunder III x2\" Ability { id: [\"6A0D\", \"6A0E\"], source: \"Hesperos\" }\r\n1122.5 \"Hemitheos's Fire IV\" #Ability { id: \"6A0D\", source: \"Hesperos\" }\r\n1123.2 \"Hemitheos's Fire III x2\" #Ability { id: \"6A18\", source: \"Hesperos\" }\r\n1124.2 \"Hemitheos's Aero III\" #Ability { id: \"6A1B\", source: \"Hesperos\" }\r\n1129.7 \"Ultimate Impulse\" Ability { id: \"6A2C\", source: \"Hesperos\" }\r\n\r\n# Act 3 - Thorns 3 plus Jump, Shakers, and Knockback\r\n1142.9 \"Akanthai: Act 3\" Ability { id: \"6EB5\", source: \"Hesperos\" }\r\n1155.1 \"Wreath of Thorns 3\" Ability { id: \"6A31\", source: \"Hesperos\" }\r\n1163.3 \"Kothornos Kick 1\" Ability { id: \"6A23\", source: \"Hesperos\" }\r\n1167.4 \"Kothornos Quake 1\" Ability { id: \"6E74\", source: \"Hesperos\" }\r\n1168.2 \"Hemitheos's Thunder III 1\" Ability { id: \"6A0E\", source: \"Hesperos\" }\r\n1170.2 \"Hemitheos's Water IV\" Ability { id: \"6A10\", source: \"Hesperos\" }\r\n1173.5 \"Kothornos Kick 2\" Ability { id: \"6A23\", source: \"Hesperos\" }\r\n1174.2 \"Hemitheos's Thunder III 2\" Ability { id: \"6A0E\", source: \"Hesperos\" }\r\n1177.5 \"Kothornos Quake 2\" Ability { id: \"6A24\", source: \"Hesperos\" }\r\n1187.7 \"Nearsight/Farsight\" Ability { id: [\"6A28\", \"6DDB\"], source: \"Hesperos\" }\r\n1201.8 \"Heart Stake\" Ability { id: \"6A2B\", source: \"Hesperos\" }\r\n1205.0 \"Heart Stake OT\" Ability { id: \"6E77\", source: \"Hesperos\" }\r\n\r\n# Act 4 - Thorns 4 plus 4x Water/Thunder and 4x Dark/Fire Tethers\r\n# Note: Water and Thunder resolve first, then Dark and Fire resolve\r\n1214.1 \"Akanthai: Act 4\" Ability { id: \"6EB6\", source: \"Hesperos\" }\r\n1223.3 \"Searing Stream\" Ability { id: \"6A2D\", source: \"Hesperos\" }\r\n1232.5 \"Wreath of Thorns 4\" Ability { id: \"6A32\", source: \"Hesperos\" }\r\n1240.6 \"Searing Stream\" Ability { id: \"6A2D\", source: \"Hesperos\" }\r\n1275.8 \"Ultimate Impulse\" Ability { id: \"6A2C\", source: \"Hesperos\" }\r\n1290.1 \"Searing Stream\" Ability { id: \"6A2D\", source: \"Hesperos\" }\r\n\r\n# Finale - Thorns 5 and plus Fleeting Impulse\r\n1299.3 \"Akanthai: Finale\" Ability { id: \"6EB7\", source: \"Hesperos\" }\r\n1308.5 \"Wreath of Thorns 5\" Ability { id: \"6A34\", source: \"Hesperos\" }\r\n1316.5 \"Fleeting Impulse x8\" Ability { id: \"6EB8\", source: \"Hesperos\" } duration 9.8\r\n1327.3 \"Hemitheos's Aero III\" Ability { id: \"6A1B\", source: \"Hesperos\" }\r\n1336.0 \"Wreath of Thorns 6\" Ability { id: \"6A35\", source: \"Hesperos\" }\r\n1339.1 \"Hemitheos's Thunder III x8\" #Ability { id: \"6A0E\", source: \"Hesperos\" } duration 8.4\r\n1353.3 \"Nearsight/Farsight\" Ability { id: [\"6A28\", \"6DDB\"], source: \"Hesperos\" }\r\n1365.4 \"Searing Stream\" Ability { id: \"6A2D\", source: \"Hesperos\" }\r\n1374.5 \"Demigod Double\" Ability { id: \"6E78\", source: \"Hesperos\" }\r\n\r\n# Curtain Call\r\n# Note: Each player must break a tether that triggers Hemitheos's Dark IV AoE\r\n#       These need to all break before Ultimate Impulse.\r\n1387.7 \"Akanthai: Curtain Call\" Ability { id: \"6A36\", source: \"Hesperos\" }\r\n1401.0 \"Hell's Sting 1\" Ability { id: \"6A20\", source: \"Hesperos\" }\r\n1404.1 \"Hell's Sting 2\" Ability { id: \"6A21\", source: \"Hesperos\" }\r\n1421.2 \"Hell's Sting 1\" Ability { id: \"6A20\", source: \"Hesperos\" }\r\n1424.3 \"Hell's Sting 2\" Ability { id: \"6A21\", source: \"Hesperos\" }\r\n1440.4 \"Ultimate Impulse\" Ability { id: \"6A2C\", source: \"Hesperos\" }\r\n1450.5 \"Hell's Sting 1\" Ability { id: \"6A20\", source: \"Hesperos\" }\r\n1453.6 \"Hell's Sting 2\" Ability { id: \"6A21\", source: \"Hesperos\" }\r\n1470.7 \"Hell's Sting 1\" Ability { id: \"6A20\", source: \"Hesperos\" }\r\n1473.8 \"Hell's Sting 2\" Ability { id: \"6A21\", source: \"Hesperos\" }\r\n1489.9 \"Ultimate Impulse\" Ability { id: \"6A2C\", source: \"Hesperos\" }\r\n1504.8 \"Ultimate Impulse (enrage)\" Ability { id: \"6A37\", source: \"Hesperos\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p5n.ts





// TODO: Better Topaz Stones guidance
// TODO: Better Starving Stampede guidance
const p5n_triggerSet = {
  id: 'AbyssosTheFifthCircle',
  zoneId: zone_id/* default.AbyssosTheFifthCircle */.Z.AbyssosTheFifthCircle,
  timelineFile: 'p5n.txt',
  initData: () => {
    return {
      topazRayDirections: [undefined, undefined]
    };
  },
  triggers: [{
    id: 'P5N Searing Ray',
    type: 'StartsUsing',
    netRegex: {
      id: '76D7',
      source: 'Proto-Carbuncle',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'P5N Searing Ray Reflected',
    type: 'StartsUsing',
    netRegex: {
      id: '76D8',
      source: 'Proto-Carbuncle',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.acid && data.numStones) return output.goFrontAvoid();
      return output.goFront();
    },
    outputStrings: {
      goFront: outputs/* default.goFront */.Z.goFront,
      goFrontAvoid: {
        en: 'Go Front (avoid puddle)',
        de: 'Geh nach Vorne (weiche Flächen aus)',
        fr: 'Allez devant (Évitez les zones au sol)',
        ja: '前へ (ゆか回避)',
        cn: '去前面 (避开圈圈)',
        ko: '보스 앞으로 (장판 피하기)'
      }
    }
  }, {
    id: 'P5N Ruby Glow',
    type: 'StartsUsing',
    netRegex: {
      id: '76D[45]',
      source: 'Proto-Carbuncle',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P5N Crunch',
    type: 'StartsUsing',
    netRegex: {
      id: '76F0',
      source: 'Proto-Carbuncle'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'P5N Topaz Stones Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '76DF',
      source: 'Proto-Carbuncle',
      capture: false
    },
    preRun: data => data.numStones = (data.numStones || 0) + 1
  }, {
    id: 'P5N Topaz Stones',
    type: 'Ability',
    netRegex: {
      id: '76DE',
      source: 'Proto-Carbuncle',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (!data.seenStones || !data.numStones) return; // First time is just floor AoEs
      if (data.numStones === 2) {
        if (data.acid) return; // Handled in Searing Ray Reflected
        return output.getInEmptyTile();
      }
      if (data.numStones < 4) return output.getInEmptyTile();
      return output.moveAway();
    },
    run: data => data.seenStones = true,
    outputStrings: {
      getInEmptyTile: {
        en: 'Get in empty tile (no stones)',
        de: 'Geh ins leere Feld (ohne Stein)',
        fr: 'Allez dans une case vide (sans pierres)',
        ja: '石がないマスへ',
        cn: '去空方块 (没有石头)',
        ko: '돌이 없는 빈 칸으로'
      },
      moveAway: {
        en: 'Move away from puddles',
        de: 'Geh weg von den Flächen',
        fr: 'Éloignez-vous des zones au sol',
        ja: 'ゆかから離れる',
        cn: '躲避圈圈',
        ko: '장판으로부터 멀리 떨어지기'
      }
    }
  }, {
    // Delay cleanup for a while for Topaz Stone + Searing Ray combo
    id: 'P5N Topaz Stones Cleanup',
    type: 'Ability',
    netRegex: {
      id: '76DE',
      source: 'Proto-Carbuncle',
      capture: false
    },
    delaySeconds: 9,
    run: data => data.numStones = 0
  }, {
    id: 'P5N Topaz Cluster',
    type: 'StartsUsing',
    // 76E[7-A] are casts from the Topaz Stone placeholders
    // 76E7 is 3.7s, 76EA is 9.7s
    // Callout will call to start at 76EA -> move to 76E7
    netRegex: {
      id: '76E[7A]',
      source: 'Proto-Carbuncle'
    },
    durationSeconds: 7,
    infoText: (data, matches, output) => {
      // Coordinates range from [92.5, 107.5]
      // Map to [-1, 1]
      const x = Math.round((parseFloat(matches.x) - 100) / 7.5);
      const y = Math.round((parseFloat(matches.y) - 100) / 7.5);
      const directions = {
        '0,1': 'dirSW',
        '1,0': 'dirSE',
        '0,-1': 'dirNE',
        '-1,0': 'dirNW'
      };
      const direction = directions[`${x},${y}`];
      if (direction === undefined) return;
      if (matches.id === '76E7') data.topazRayDirections[0] = direction;
      if (matches.id === '76EA') data.topazRayDirections[1] = direction;
      if (data.topazRayDirections[0] === undefined || data.topazRayDirections[1] === undefined) return;
      const dir0Str = output[data.topazRayDirections[0]]();
      const dir1Str = output[data.topazRayDirections[1]]();
      return output.text({
        start: dir1Str,
        end: dir0Str
      });
    },
    outputStrings: {
      dirSW: outputs/* default.dirSW */.Z.dirSW,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirNW: outputs/* default.dirNW */.Z.dirNW,
      text: {
        en: 'start at ${start} -> move to ${end}',
        de: 'Starte im ${start} -> Bewegen nach ${end}',
        fr: 'Commencez à ${start} -> allez vers ${end}',
        ja: '${start}から -> ${end}へ移動',
        cn: '${start} 开始 -> 移动到 ${end}',
        ko: '${start}쪽에서 시작 -> ${end}쪽으로 이동'
      }
    }
  }, {
    id: 'P5N Topaz Cluster Cleanup',
    type: 'Ability',
    // 76E6 comes from the main Proto-Carbuncle
    netRegex: {
      id: '76E6',
      source: 'Proto-Carbuncle',
      capture: false
    },
    run: data => data.topazRayDirections = [undefined, undefined]
  }, {
    id: 'P5N Sonic Howl',
    type: 'StartsUsing',
    netRegex: {
      id: '76F2',
      source: 'Proto-Carbuncle',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P5N Acidic Slaver',
    type: 'StartsUsing',
    netRegex: {
      id: '78EB',
      source: 'Proto-Carbuncle',
      capture: false
    },
    run: data => data.acid = true
  }, {
    id: 'P5N Toxic Crunch',
    type: 'StartsUsing',
    netRegex: {
      id: '76F1',
      source: 'Proto-Carbuncle'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'P5N Venom Rain',
    type: 'HeadMarker',
    netRegex: {
      id: '0178'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'P5N Venom Pool',
    type: 'HeadMarker',
    netRegex: {
      id: '0064'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'P5N Starving Stampede',
    type: 'StartsUsing',
    netRegex: {
      id: '79E9',
      source: 'Proto-Carbuncle',
      capture: false
    },
    delaySeconds: 2,
    durationSeconds: 5,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Start in middle -> move to first jump',
        de: 'Starte in der Mitte -> zum ersten Sprung bewegen',
        fr: 'Démarrez au milieu -> allez vers le 1er saut',
        ja: '真ん中 -> 1回目のジャンプへ',
        cn: '中间开始 -> 移动到第一跳的位置',
        ko: '중앙으로 => 첫번째 점프한 곳으로'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Proto-Carbuncle': 'Proto-Karfunkel'
    },
    'replaceText': {
      '(?<!Toxic )Crunch': 'Quetscher',
      'Ruby Glow': 'Rubinlicht',
      'Searing Ray': 'Sengender Strahl',
      'Sonic Howl': 'Schallheuler',
      'Starving Stampede': 'Hungerstampede',
      'Topaz Cluster': 'Topasbündel',
      'Topaz Stones': 'Topasstein',
      'Toxic Crunch': 'Giftquetscher',
      'Venom Pool': 'Giftschwall',
      'Venom Rain': 'Giftregen',
      'Venom Squall': 'Giftwelle'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Proto-Carbuncle': 'Proto-Carbuncle'
    },
    'replaceText': {
      '(?<!Toxic )Crunch': 'Croqueur',
      'Ruby Glow': 'Lumière rubis',
      'Searing Ray': 'Rayon irradiant',
      'Sonic Howl': 'Hurlement sonique',
      'Starving Stampede': 'Charge affamée',
      'Topaz Cluster': 'Chaîne de topazes',
      'Topaz Stones': 'Topazes',
      'Toxic Crunch': 'Croqueur venimeux',
      'Venom Pool': 'Giclée de venin',
      'Venom Rain': 'Pluie de venin',
      'Venom Squall': 'Crachat de venin'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Proto-Carbuncle': 'プロトカーバンクル'
    },
    'replaceText': {
      '(?<!Toxic )Crunch': 'クランチ',
      'Ruby Glow': 'ルビーの光',
      'Searing Ray': 'シアリングレイ',
      'Sonic Howl': 'ソニックハウル',
      'Starving Stampede': 'スターヴィング・スタンピード',
      'Topaz Cluster': 'トパーズクラスター',
      'Topaz Stones': 'トパーズストーン',
      'Toxic Crunch': 'ベノムクランチ',
      'Venom Pool': 'ベノムスプラッシュ',
      'Venom Rain': 'ベノムレイン',
      'Venom Squall': 'ベノムスコール'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Proto-Carbuncle': '原型宝石兽'
    },
    'replaceText': {
      '(?<!Toxic )Crunch': '重咬',
      'Ruby Glow': '红宝石之光',
      'Searing Ray': '灼热射线',
      'Sonic Howl': '音嚎',
      'Starving Stampede': '穷凶极饿',
      'Topaz Cluster': '黄宝石晶簇',
      'Topaz Stones': '黄宝石',
      'Toxic Crunch': '毒液重咬',
      'Venom Pool': '毒液飞溅',
      'Venom Rain': '毒液雨',
      'Venom Squall': '毒液风暴'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Proto-Carbuncle': '프로토 카벙클'
    },
    'replaceText': {
      '(?<!Toxic )Crunch': '짓씹기',
      'Ruby Glow': '루비의 빛',
      'Searing Ray': '타오르는 빛줄기',
      'Sonic Howl': '음속 포효',
      'Starving Stampede': '굶주림의 광란',
      'Topaz Cluster': '토파즈 클러스터',
      'Topaz Stones': '토파즈 스톤',
      'Toxic Crunch': '독성 짓씹기',
      'Venom Pool': '독성 물보라',
      'Venom Rain': '독성 비',
      'Venom Squall': '독성 소나기'
    }
  }]
};
/* harmony default export */ const p5n = (p5n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p5n.txt
const raid_p5n_namespaceObject = "### P5N: Abyssos: The Fifth Circle\r\n# -ii 79F2 79F1 76D5 7725 7727 7728 76DA 76E2 76EE 79FC 79FD 76E0 79E9 7A1F\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n10.3 \"--sync--\" Ability { id: \"76D6\", source: \"Proto-Carbuncle\" } window 11,10\r\n19.1 \"Searing Ray\" Ability { id: \"76D7\", source: \"Proto-Carbuncle\" }\r\n28.2 \"Ruby Glow\" Ability { id: \"76D4\", source: \"Proto-Carbuncle\" }\r\n31.4 \"--sync--\" Ability { id: \"76D6\", source: \"Proto-Carbuncle\" }\r\n39.7 \"Searing Ray\" Ability { id: \"76D8\", source: \"Proto-Carbuncle\" }\r\n51.9 \"Crunch\" Ability { id: \"76F0\", source: \"Proto-Carbuncle\" }\r\n59.1 \"Topaz Stones\" Ability { id: \"76DE\", source: \"Proto-Carbuncle\" }\r\n59.1 \"--sync--\" Ability { id: \"76DF\", source: \"Proto-Carbuncle\" }\r\n75.3 \"Ruby Glow\" Ability { id: \"76D4\", source: \"Proto-Carbuncle\" }\r\n81.4 \"Topaz Stones\" Ability { id: \"76DE\", source: \"Proto-Carbuncle\" }\r\n81.4 \"--sync--\" Ability { id: \"76DF\", source: \"Proto-Carbuncle\" }\r\n97.6 \"Sonic Howl\" Ability { id: \"76F2\", source: \"Proto-Carbuncle\" }\r\n101.8 \"--sync--\" Ability { id: \"76D6\", source: \"Proto-Carbuncle\" }\r\n110.4 \"Searing Ray\" Ability { id: \"76D7\", source: \"Proto-Carbuncle\" }\r\n117.6 \"Crunch\" Ability { id: \"76F0\", source: \"Proto-Carbuncle\" }\r\n126.7 \"Sonic Howl\" Ability { id: \"76F2\", source: \"Proto-Carbuncle\" }\r\n128.8 \"--sync--\" Ability { id: \"76E3\", source: \"Proto-Carbuncle\" }\r\n138.9 \"--sync--\" Ability { id: \"78EA\", source: \"Proto-Carbuncle\" }\r\n144.2 \"--untargetable--\" Ability { id: \"78EB\", source: \"Proto-Carbuncle\" } # Acidic Slaver\r\n\r\n189.2 \"--targetable--\"\r\n199.7 \"Ruby Glow\" Ability { id: \"76D4\", source: \"Proto-Carbuncle\" } window 20,20\r\n205.8 \"Topaz Stones\" Ability { id: \"76DE\", source: \"Proto-Carbuncle\" }\r\n205.8 \"--sync--\" Ability { id: \"76DF\", source: \"Proto-Carbuncle\" }\r\n220.9 \"Toxic Crunch\" Ability { id: \"76F1\", source: \"Proto-Carbuncle\" }\r\n238.0 \"Venom Squall\" Ability { id: \"76EC\", source: \"Proto-Carbuncle\" }\r\n245.8 \"Venom Rain\" Ability { id: \"76ED\", source: \"Proto-Carbuncle\" }\r\n252.8 \"Venom Pool\" Ability { id: \"76EF\", source: \"Proto-Carbuncle\" }\r\n261.2 \"Sonic Howl\" Ability { id: \"76F2\", source: \"Proto-Carbuncle\" }\r\n272.3 \"Topaz Stones\" Ability { id: \"76DE\", source: \"Proto-Carbuncle\" }\r\n272.3 \"--sync--\" Ability { id: \"76DF\", source: \"Proto-Carbuncle\" }\r\n281.4 \"Toxic Crunch\" Ability { id: \"76F1\", source: \"Proto-Carbuncle\" }\r\n300.6 \"--sync--\" Ability { id: \"76E3\", source: \"Proto-Carbuncle\" }\r\n311.8 \"--untargetable--\" Ability { id: \"76E5\", source: \"Proto-Carbuncle\" }\r\n311.8 \"Starving Stampede\" Ability { id: \"76E5\", source: \"Proto-Carbuncle\" } duration 6\r\n317.8 \"--targetable--\"\r\n324.8 \"--sync--\" Ability { id: \"7A21\", source: \"Proto-Carbuncle\" } window 5,5\r\n325.9 \"--sync--\" Ability { id: \"76D6\", source: \"Proto-Carbuncle\" }\r\n334.1 \"Ruby Glow\" Ability { id: \"76D4\", source: \"Proto-Carbuncle\" }\r\n\r\n340.2 \"Topaz Cluster\" Ability { id: \"76E6\", source: \"Proto-Carbuncle\" } window 5,5\r\n342.2 \"--sync--\" Ability { id: \"76E8\", source: \"Proto-Carbuncle\" }\r\n344.2 \"--sync--\" Ability { id: \"76E9\", source: \"Proto-Carbuncle\" }\r\n346.2 \"--sync--\" Ability { id: \"76EA\", source: \"Proto-Carbuncle\" }\r\n359.3 \"--sync--\" Ability { id: \"76D6\", source: \"Proto-Carbuncle\" }\r\n368.1 \"Searing Ray\" Ability { id: \"76D7\", source: \"Proto-Carbuncle\" }\r\n382.3 \"Ruby Glow\" Ability { id: \"76D4\", source: \"Proto-Carbuncle\" }\r\n388.4 \"Topaz Stones\" Ability { id: \"76DE\", source: \"Proto-Carbuncle\" }\r\n388.4 \"--sync--\" Ability { id: \"76DF\", source: \"Proto-Carbuncle\" }\r\n394.5 \"--sync--\" Ability { id: \"76D6\", source: \"Proto-Carbuncle\" }\r\n402.8 \"Searing Ray\" Ability { id: \"76D8\", source: \"Proto-Carbuncle\" }\r\n415.9 \"Toxic Crunch\" Ability { id: \"76F1\", source: \"Proto-Carbuncle\" }\r\n425.0 \"Ruby Glow\" Ability { id: \"76D4\", source: \"Proto-Carbuncle\" }\r\n431.1 \"Topaz Stones\" Ability { id: \"76DE\", source: \"Proto-Carbuncle\" }\r\n431.1 \"--sync--\" Ability { id: \"76DF\", source: \"Proto-Carbuncle\" }\r\n438.2 \"Venom Squall\" Ability { id: \"76EC\", source: \"Proto-Carbuncle\" }\r\n446.0 \"Venom Rain\" Ability { id: \"76ED\", source: \"Proto-Carbuncle\" }\r\n453.0 \"Venom Pool\" Ability { id: \"76EF\", source: \"Proto-Carbuncle\" }\r\n463.3 \"Sonic Howl\" Ability { id: \"76F2\", source: \"Proto-Carbuncle\" }\r\n475.5 \"Toxic Crunch\" Ability { id: \"76F1\", source: \"Proto-Carbuncle\" }\r\n482.6 \"Ruby Glow\" Ability { id: \"76D4\", source: \"Proto-Carbuncle\" }\r\n488.7 \"Topaz Cluster\" Ability { id: \"76E6\", source: \"Proto-Carbuncle\" } window 5,5 jump 340.2\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p5s.ts




// TODO: Callout safe quadrant/half for Venom Pool with Crystals

const p5s_directions = ['NW', 'NE', 'SE', 'SW'];
const convertCoordinatesToDirection = (x, y) => {
  if (x > 100) return y < 100 ? 'NE' : 'SE';
  return y < 100 ? 'NW' : 'SW';
};
const p5s_triggerSet = {
  id: 'AbyssosTheFifthCircleSavage',
  zoneId: zone_id/* default.AbyssosTheFifthCircleSavage */.Z.AbyssosTheFifthCircleSavage,
  timelineFile: 'p5s.txt',
  initData: () => {
    return {
      topazClusterCombatantIdToAbilityId: {},
      topazRays: {},
      clawCount: 0,
      ruby1TopazStones: [],
      isRuby1Done: false
    };
  },
  triggers: [{
    // The tank busters are not cast on a target,
    // keep track of who the boss is auto attacking.
    id: 'P5S Attack',
    type: 'Ability',
    netRegex: {
      id: '7A0E',
      source: 'Proto-Carbuncle'
    },
    run: (data, matches) => data.target = matches.target
  }, {
    // Update target whenever Provoke is used.
    id: 'P5S Provoke',
    type: 'Ability',
    netRegex: {
      id: '1D6D'
    },
    run: (data, matches) => data.target = matches.source
  }, {
    id: 'P5S Sonic Howl',
    type: 'StartsUsing',
    netRegex: {
      id: '7720',
      source: 'Proto-Carbuncle',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P5S Ruby Glow',
    type: 'StartsUsing',
    netRegex: {
      id: '76F3',
      source: 'Proto-Carbuncle',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P5S Ruby 1 Topaz Stone Collect',
    type: 'Ability',
    netRegex: {
      id: '76FE',
      source: 'Proto-Carbuncle'
    },
    condition: data => !data.isRuby1Done,
    run: (data, matches) => {
      data.ruby1TopazStones.push(matches);
    }
  }, {
    id: 'P5S Ruby 1 Topaz Stones',
    type: 'Ability',
    netRegex: {
      id: '76FE',
      source: 'Proto-Carbuncle',
      capture: false
    },
    condition: data => !data.isRuby1Done,
    delaySeconds: 0.3,
    // allow collector to finish
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      const safeQuadrants = new Set(p5s_directions);
      for (const stone of data.ruby1TopazStones) safeQuadrants.delete(convertCoordinatesToDirection(parseFloat(stone.targetX), parseFloat(stone.targetY)));
      const safe = Array.from(safeQuadrants);
      const [safe0, safe1] = safe;
      data.isRuby1Done = true;
      if (safe1 !== undefined)
        // too many safe quadrants
        return;else if (safe0 !== undefined)
        // one safe quadrant, we're done
        return output[safe0]();

      // no safe quadrants - find the one with a stone closest to center (x100,y100)
      // magic stones will always have an x/y center offset of 7.5/1.0 or 1.0/7.5
      // poison stone closest to center will always have an x/y center offset of 4.0/4.0
      for (const stone of data.ruby1TopazStones) {
        const stoneX = parseFloat(stone.targetX);
        const stoneY = parseFloat(stone.targetY);
        if (Math.abs(stoneX - 100) < 5 && Math.abs(stoneY - 100) < 5) return output.safeCorner({
          dir1: output[convertCoordinatesToDirection(stoneX, stoneY)]()
        });
      }
      return;
    },
    outputStrings: {
      NE: outputs/* default.dirNE */.Z.dirNE,
      SE: outputs/* default.dirSE */.Z.dirSE,
      SW: outputs/* default.dirSW */.Z.dirSW,
      NW: outputs/* default.dirNW */.Z.dirNW,
      safeCorner: {
        en: '${dir1} Corner (avoid poison)',
        de: '${dir1} Ecke (vermeide das Gift)',
        fr: 'Coin ${dir1} (évitez le poison)',
        ja: '${dir1}の隅へ (毒回避)',
        cn: '${dir1} 角落 (避开毒)',
        ko: '${dir1} 구석 (독 피하기)'
      }
    }
  }, {
    id: 'P5S Venomous Mass',
    type: 'StartsUsing',
    netRegex: {
      id: '771D',
      source: 'Proto-Carbuncle',
      capture: false
    },
    alarmText: (data, _matches, output) => {
      if (data.role === 'tank' && data.target !== data.me) return output.tankSwap();
    },
    alertText: (data, _matches, output) => {
      if (data.role === 'tank' && data.target !== data.me) return;
      if (data.target === data.me) return output.busterOnYou();
      return output.busterOnTarget({
        player: data.party.member(data.target)
      });
    },
    outputStrings: {
      busterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
      busterOnTarget: outputs/* default.tankBusterOnPlayer */.Z.tankBusterOnPlayer,
      tankSwap: outputs/* default.tankSwap */.Z.tankSwap
    }
  }, {
    id: 'P5S Toxic Crunch',
    type: 'StartsUsing',
    netRegex: {
      id: '784A',
      source: 'Proto-Carbuncle',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.role === 'tank' && data.target !== data.me) return;
      if (data.target === data.me) return output.busterOnYou();
      return output.tankBuster();
    },
    outputStrings: {
      busterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
      tankBuster: outputs/* default.tankBuster */.Z.tankBuster
    }
  }, {
    id: 'P5S Double Rush',
    type: 'StartsUsing',
    netRegex: {
      id: '771B',
      source: 'Proto-Carbuncle',
      capture: false
    },
    delaySeconds: 3,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    // Collect CombatantIds for the Topaz Stone Proto-Carbuncles
    id: 'P5S Ruby 3 Topaz Cluster Collect',
    type: 'StartsUsing',
    // 7703: 3.7s, 7704: 6.2s, 7705: 8.7s, 7706: 11.2s
    netRegex: {
      id: '770[3456]',
      source: 'Proto-Carbuncle'
    },
    run: (data, matches) => data.topazClusterCombatantIdToAbilityId[parseInt(matches.sourceId, 16)] = matches.id
  }, {
    id: 'P5S Ruby 3 Topaz Cluster',
    type: 'Ability',
    netRegex: {
      id: '7702',
      source: 'Proto-Carbuncle',
      capture: false
    },
    durationSeconds: 12,
    promise: async data => {
      // Log position data can be stale, call OverlayPlugin
      const result = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: Object.keys(data.topazClusterCombatantIdToAbilityId).map(Number)
      });

      // For each topaz stone combatant, determine the quadrant
      for (const combatant of result.combatants) {
        if (combatant.ID === undefined) continue;
        const abilityId = data.topazClusterCombatantIdToAbilityId[combatant.ID];
        if (abilityId === undefined) continue;

        // Convert from ability id to [0-3] index
        // 7703 is the Topaz Ray cast with the lowest cast time
        const index = parseInt(abilityId, 16) - parseInt('7703', 16);
        data.topazRays[index] ??= [];

        // Map from coordinate position to intercardinal quadrant
        const direction = convertCoordinatesToDirection(combatant.PosX, combatant.PosY);
        data.topazRays[index]?.push(direction);
      }
    },
    infoText: (data, _matches, output) => {
      const remainingDirections = {};
      for (const [index, dirs] of Object.entries(data.topazRays)) {
        remainingDirections[index] = new Set(p5s_directions);
        for (const dir of dirs) remainingDirections[index]?.delete(dir);
      }

      // 770[34] cast 2 times, 770[56] cast 3 times
      const expectedLengths = [2, 2, 1, 1];
      const safeDirs = [];
      for (let i = 0; i < 4; i++) {
        if (remainingDirections[i]?.size !== expectedLengths[i]) return;
        const tmpDirs = [...(remainingDirections[i] ?? [])];
        if (!tmpDirs[0]) return;

        // If there's one safe location, print that
        let dirStr = tmpDirs[0];
        // If there's multiple, prefer south
        if (tmpDirs.length === 2 && tmpDirs[1]) dirStr = ['SE', 'SW'].includes(tmpDirs[0]) ? tmpDirs[0] : tmpDirs[1];
        safeDirs.push(output[dirStr]());
      }
      if (safeDirs.length !== 4) return;
      return output.text({
        dir1: safeDirs[0],
        dir2: safeDirs[1],
        dir3: safeDirs[2],
        dir4: safeDirs[3]
      });
    },
    outputStrings: {
      NE: outputs/* default.dirNE */.Z.dirNE,
      SE: outputs/* default.dirSE */.Z.dirSE,
      SW: outputs/* default.dirSW */.Z.dirSW,
      NW: outputs/* default.dirNW */.Z.dirNW,
      text: {
        en: '${dir1} -> ${dir2} -> ${dir3} -> ${dir4}',
        de: '${dir1} -> ${dir2} -> ${dir3} -> ${dir4}',
        fr: '${dir1} -> ${dir2} -> ${dir3} -> ${dir4}',
        ja: '${dir1} -> ${dir2} -> ${dir3} -> ${dir4}',
        cn: '${dir1} -> ${dir2} -> ${dir3} -> ${dir4}',
        ko: '${dir1} -> ${dir2} -> ${dir3} -> ${dir4}'
      }
    }
  }, {
    id: 'P5S Venom Squall/Surge',
    type: 'StartsUsing',
    netRegex: {
      id: '771[67]',
      source: 'Proto-Carbuncle'
    },
    durationSeconds: 5,
    alertText: (_data, matches, output) => {
      const spread = output.spread();
      const healerGroups = output.healerGroups();
      // Venom Squall
      if (matches.id === '7716') return output.text({
        dir1: spread,
        dir2: healerGroups
      });
      return output.text({
        dir1: healerGroups,
        dir2: spread
      });
    },
    outputStrings: {
      healerGroups: outputs/* default.healerGroups */.Z.healerGroups,
      spread: outputs/* default.spread */.Z.spread,
      text: {
        en: '${dir1} -> Bait -> ${dir2}',
        de: '${dir1} -> Ködern -> ${dir2}',
        fr: '${dir1} -> Attendez -> ${dir2}',
        ja: '${dir1} -> 真ん中 -> ${dir2}',
        cn: '${dir1} -> 诱导 -> ${dir2}',
        ko: '${dir1} -> 장판 유도 -> ${dir2}'
      }
    }
  }, {
    id: 'P5S Venom Pool with Crystals',
    // TODO: Callout safe quadrant/half
    type: 'StartsUsing',
    netRegex: {
      id: '79E2',
      source: 'Proto-Carbuncle',
      capture: false
    },
    infoText: (_data, _matches, output) => {
      return output.groups();
    },
    outputStrings: {
      groups: {
        en: 'Healer Groups on Topaz Stones',
        de: 'Heilergruppen auf Topassteine',
        fr: 'Groupes heal sur les Topazes',
        ja: 'トパーズの上でヒーラーと頭割り',
        cn: '黄宝石处治疗分组分摊',
        ko: '돌 위에서 힐러 그룹 쉐어'
      }
    }
  }, {
    id: 'P5S Tail to Claw',
    type: 'StartsUsing',
    netRegex: {
      id: '7712',
      source: 'Proto-Carbuncle',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.getFrontThenBack */.n3.getFrontThenBack()
  }, {
    id: 'P5S Raging Tail Move',
    type: 'Ability',
    netRegex: {
      id: '7A0C',
      source: 'Proto-Carbuncle',
      capture: false
    },
    infoText: (_data, _matches, output) => output.moveBehind(),
    outputStrings: {
      moveBehind: {
        en: 'Move Behind',
        de: 'Nach Hinten bewegen',
        fr: 'Allez derrière',
        ja: '背面へ',
        cn: '去背面',
        ko: '보스 뒤로'
      }
    }
  }, {
    id: 'P5S Claw to Tail',
    type: 'StartsUsing',
    netRegex: {
      id: '770E',
      source: 'Proto-Carbuncle',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.getBackThenFront */.n3.getBackThenFront()
  }, {
    id: 'P5S Raging Claw Move',
    type: 'Ability',
    netRegex: {
      id: '7710',
      source: 'Proto-Carbuncle',
      capture: false
    },
    condition: data => {
      data.clawCount = data.clawCount + 1;
      return data.clawCount === 6;
    },
    infoText: (_data, _matches, output) => output.moveFront(),
    run: data => {
      data.clawCount = 0;
    },
    outputStrings: {
      moveFront: {
        en: 'Move Front',
        de: 'Nach Vorne bewegen',
        fr: 'Allez devant',
        ja: '前へ',
        cn: '去正面',
        ko: '보스 앞으로'
      }
    }
  }, {
    id: 'P5S Searing Ray',
    type: 'StartsUsing',
    netRegex: {
      id: '76[DF]7',
      source: 'Proto-Carbuncle',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.goFront */.Z.goFront
    }
  }, {
    id: 'P5S Raging Claw',
    type: 'StartsUsing',
    netRegex: {
      id: '76FA',
      source: 'Proto-Carbuncle',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Lively Bait': 'zappelnd(?:e|er|es|en) Köder',
      'Proto-Carbuncle': 'Proto-Karfunkel'
    },
    'replaceText': {
      '--towers--': '--Türme--',
      'Acidic Slaver': 'Säurespeichel',
      'Claw to Tail': 'Kralle und Schwanz',
      'Devour': 'Verschlingen',
      'Double Rush': 'Doppelsturm',
      'Impact': 'Impakt',
      'Raging Claw': 'Wütende Kralle',
      'Raging Tail': 'Wütender Schwanz',
      'Ruby Glow': 'Rubinlicht',
      'Ruby Reflection': 'Rubinspiegelung',
      'Scatterbait': 'Streuköder',
      'Searing Ray': 'Sengender Strahl',
      'Sonic Howl': 'Schallheuler',
      'Sonic Shatter': 'Schallbrecher',
      'Spit': 'Hypersekretion',
      'Starving Stampede': 'Hungerstampede',
      'Tail to Claw': 'Schwanz und Kralle',
      'Topaz Cluster': 'Topasbündel',
      'Topaz Ray': 'Topasstrahl',
      'Topaz Stones': 'Topasstein',
      'Toxic Crunch': 'Giftquetscher',
      'Venom(?!( |ous))': 'Toxinspray',
      'Venom Drops': 'Gifttropfen',
      'Venom Pool': 'Giftschwall',
      'Venom Rain': 'Giftregen',
      'Venom Squall': 'Giftwelle',
      'Venom Surge': 'Giftwallung',
      'Venomous Mass': 'Giftmasse'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Lively Bait': 'amuse-gueule',
      'Proto-Carbuncle': 'Proto-Carbuncle'
    },
    'replaceText': {
      '--towers--': '--Tours--',
      'Acidic Slaver': 'Salive acide',
      'Claw to Tail': 'Griffes et queue',
      'Devour': 'Dévoration',
      'Double Rush': 'Double ruée',
      'Impact': 'Impact',
      'Raging Claw': 'Griffes enragées',
      'Raging Tail': 'Queue enragée',
      'Ruby Glow': 'Lumière rubis',
      'Ruby Reflection': 'Réflexion rubis',
      'Scatterbait': 'Éclate-appât',
      'Searing Ray': 'Rayon irradiant',
      'Sonic Howl': 'Hurlement sonique',
      'Sonic Shatter': 'Pulvérisation sonique',
      'Spit': 'Crachat',
      'Starving Stampede': 'Charge affamée',
      'Tail to Claw': 'Queue et griffes',
      'Topaz Cluster': 'Chaîne de topazes',
      'Topaz Ray': 'Rayon topaze',
      'Topaz Stones': 'Topazes',
      'Toxic Crunch': 'Croqueur venimeux',
      'Venom(?!( |ous))': 'Venin',
      'Venom Drops': 'Crachin de venin',
      'Venom Pool': 'Giclée de venin',
      'Venom Rain': 'Pluie de venin',
      'Venom Squall': 'Crachat de venin',
      'Venom Surge': 'Déferlante de venin',
      'Venomous Mass': 'Masse venimeuse'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Lively Bait': 'ライブリー・ベイト',
      'Proto-Carbuncle': 'プロトカーバンクル'
    },
    'replaceText': {
      'Acidic Slaver': 'アシッドスレイバー',
      'Claw to Tail': 'クロウ・アンド・テイル',
      'Devour': '捕食',
      'Double Rush': 'ダブルラッシュ',
      'Impact': '衝撃',
      'Raging Claw': 'レイジングクロウ',
      'Raging Tail': 'レイジングテイル',
      'Ruby Glow': 'ルビーの光',
      'Ruby Reflection': 'ルビーリフレクション',
      'Scatterbait': 'スキャッターベイト',
      'Searing Ray': 'シアリングレイ',
      'Sonic Howl': 'ソニックハウル',
      'Sonic Shatter': 'ソニックシャッター',
      'Spit': '放出',
      'Starving Stampede': 'スターヴィング・スタンピード',
      'Tail to Claw': 'テイル・アンド・クロウ',
      'Topaz Cluster': 'トパーズクラスター',
      'Topaz Ray': 'トパーズレイ',
      'Topaz Stones': 'トパーズストーン',
      'Toxic Crunch': 'ベノムクランチ',
      'Venom(?!( |ous))': '毒液',
      'Venom Drops': 'ベノムドロップ',
      'Venom Pool': 'ベノムスプラッシュ',
      'Venom Rain': 'ベノムレイン',
      'Venom Squall': 'ベノムスコール',
      'Venom Surge': 'ベノムサージ',
      'Venomous Mass': 'ベノムマス'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Lively Bait': '活饵',
      'Proto-Carbuncle': '原型宝石兽'
    },
    'replaceText': {
      '--towers--': '--塔--',
      'Acidic Slaver': '酸性唾液',
      'Claw to Tail': '利爪凶尾',
      'Devour': '捕食',
      'Double Rush': '二连冲',
      'Impact': '践踏冲击',
      'Raging Claw': '暴怒连爪',
      'Raging Tail': '暴怒扫尾',
      'Ruby Glow': '红宝石之光',
      'Ruby Reflection': '红宝石反射',
      'Scatterbait': '碎饵',
      'Searing Ray': '灼热射线',
      'Sonic Howl': '音嚎',
      'Sonic Shatter': '音碎',
      'Spit': '吐出',
      'Starving Stampede': '穷凶极饿',
      'Tail to Claw': '凶尾利爪',
      'Topaz Cluster': '黄宝石晶簇',
      'Topaz Ray': '黄宝石射线',
      'Topaz Stones': '黄宝石',
      'Toxic Crunch': '毒液重咬',
      'Venom(?!( |ous))': '毒液',
      'Venom Drops': '毒液滴落',
      'Venom Pool': '毒液飞溅',
      'Venom Rain': '毒液雨',
      'Venom Squall': '毒液风暴',
      'Venom Surge': '毒液喷涌',
      'Venomous Mass': '毒液倾泻'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Lively Bait': '팔팔한 먹이',
      'Proto-Carbuncle': '프로토 카벙클'
    },
    'replaceText': {
      '--towers--': '--장판--',
      'Acidic Slaver': '산성 군침',
      'Claw to Tail': '발톱과 꼬리',
      'Devour': '포식',
      'Double Rush': '이중 돌진',
      'Impact': '충격',
      'Raging Claw': '성난 발톱',
      'Raging Tail': '성난 꼬리',
      'Ruby Glow': '루비의 빛',
      'Ruby Reflection': '루비 반사',
      'Scatterbait': '먹이 뿌리기',
      'Searing Ray': '타오르는 빛줄기',
      'Sonic Howl': '음속 포효',
      'Sonic Shatter': '음속 박살',
      'Spit': '방출',
      'Starving Stampede': '굶주림의 광란',
      'Tail to Claw': '꼬리와 발톱',
      'Topaz Cluster': '토파즈 클러스터',
      'Topaz Ray': '토파즈 광선',
      'Topaz Stones': '토파즈 스톤',
      'Toxic Crunch': '독성 짓씹기',
      'Venom(?!( |ous))': '독액',
      'Venom Drops': '독성 빗방울',
      'Venom Pool': '독성 물보라',
      'Venom Rain': '독성 비',
      'Venom Squall': '독성 소나기',
      'Venom Surge': '독성 파도',
      'Venomous Mass': '독성 덩어리'
    }
  }]
};
/* harmony default export */ const p5s = (p5s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p5s.txt
const raid_p5s_namespaceObject = "### P5S: Abyssos: The Fifth Circle (Savage)\r\n#\r\n# -p 7720:14.9\r\n# -ii 7A0E 76F4 7701 771E 771F 76F9 7710 76FB 75FC 7711 770F 770A 79E3 76FC\r\n# -it \"Proto-Carbuncle\"\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n9.9 \"--sync--\" StartsUsing { id: \"7720\", source: \"Proto-Carbuncle\" } window 20,20\r\n14.9 \"Sonic Howl\" Ability { id: \"7720\", source: \"Proto-Carbuncle\" }\r\n22.0 \"Ruby Glow 1\" Ability { id: \"76F3\", source: \"Proto-Carbuncle\" }\r\n29.1 \"Topaz Stones\" Ability { id: \"76FD\", source: \"Proto-Carbuncle\" }\r\n29.1 \"--sync--\" Ability { id: \"76FE\", source: \"Proto-Carbuncle\" }\r\n42.7 \"Topaz Ray\" Ability { id: \"79FE\", source: \"Proto-Carbuncle\" }\r\n43.3 \"Ruby Reflection\" Ability { id: \"7700\", source: \"Proto-Carbuncle\" }\r\n56.3 \"Venomous Mass\" Ability { id: \"771D\", source: \"Proto-Carbuncle\" }\r\n63.5 \"Toxic Crunch\" Ability { id: \"784A\", source: \"Proto-Carbuncle\" }\r\n72.1 \"--towers--\" duration 10\r\n94.1 \"Venomous Mass\" Ability { id: \"771D\", source: \"Proto-Carbuncle\" } window 20,20 # safety\r\n101.3 \"Toxic Crunch\" Ability { id: \"784A\", source: \"Proto-Carbuncle\" }\r\n\r\n# Double Rush\r\n115.6 \"Ruby Glow 2\" Ability { id: \"76F3\", source: \"Proto-Carbuncle\" }\r\n122.7 \"Topaz Stones\" Ability { id: \"76FD\", source: \"Proto-Carbuncle\" }\r\n122.7 \"--sync--\" Ability { id: \"76FE\", source: \"Proto-Carbuncle\" }\r\n125.9 \"--sync--\" Ability { id: \"76F5\", source: \"Proto-Carbuncle\" }\r\n133.2 \"Double Rush 1\" Ability { id: \"771B\", source: \"Proto-Carbuncle\" }\r\n135.2 \"Double Rush 2\" Ability { id: \"771C\", source: \"Proto-Carbuncle\" }\r\n136.1 \"Topaz Ray\" Ability { id: \"79FE\", source: \"Proto-Carbuncle\" }\r\n136.7 \"Ruby Reflection\" Ability { id: \"76F8\", source: \"Proto-Carbuncle\" }\r\n137.3 \"--sync--\" Ability { id: \"76F5\", source: \"Proto-Carbuncle\" }\r\n146.4 \"Sonic Howl\" Ability { id: \"7720\", source: \"Proto-Carbuncle\" }\r\n\r\n# Topaz Stones Memory Dodge\r\n159.6 \"Ruby Glow 3\" Ability { id: \"76F3\", source: \"Proto-Carbuncle\" }\r\n165.7 \"Topaz Cluster\" Ability { id: \"7702\", source: \"Proto-Carbuncle\" }\r\n165.7 \"--sync--\" Ability { id: \"7703\", source: \"Proto-Carbuncle\" }\r\n168.1 \"--sync--\" Ability { id: \"7704\", source: \"Proto-Carbuncle\" }\r\n170.5 \"--sync--\" Ability { id: \"7705\", source: \"Proto-Carbuncle\" }\r\n173.1 \"--sync--\" Ability { id: \"7706\", source: \"Proto-Carbuncle\" }\r\n#176.1 \"Topaz Ray 1\" #Ability { id: \"79FF\", source: \"Proto-Carbuncle\" }\r\n176.7 \"Ruby Reflection 1\" #Ability { id: \"7700\", source: \"Proto-Carbuncle\" }\r\n#178.7 \"Topaz Ray 2\" #Ability { id: \"79FF\", source: \"Proto-Carbuncle\" }\r\n179.3 \"Ruby Reflection 2\" #Ability { id: \"7700\", source: \"Proto-Carbuncle\" }\r\n#181.3 \"Topaz Ray 3\" #Ability { id: \"79FF\", source: \"Proto-Carbuncle\" }\r\n181.9 \"Ruby Reflection 3\" #Ability { id: \"7700\", source: \"Proto-Carbuncle\" }\r\n#183.9 \"Topaz Ray 4\" #Ability { id: \"79FF\", source: \"Proto-Carbuncle\" }\r\n184.5 \"Ruby Reflection 4\" #Ability { id: \"7700\", source: \"Proto-Carbuncle\" }\r\n\r\n193.1 \"Venomous Mass\" Ability { id: \"771D\", source: \"Proto-Carbuncle\" }\r\n200.2 \"Toxic Crunch\" Ability { id: \"784A\", source: \"Proto-Carbuncle\" }\r\n\r\n211.6 \"Venom Squall/Venom Surge\" Ability { id: [\"7716\", \"7717\"], source: \"Proto-Carbuncle\" }\r\n215.5 \"Venom Rain/Venom Pool\" Ability { id: [\"7718\", \"771A\"], source: \"Proto-Carbuncle\" }\r\n221.5 \"Venom Drops\" Ability { id: \"7719\", source: \"Proto-Carbuncle\" }\r\n224.5 \"Venom Pool/Venom Rain\" Ability { id: [\"771A\", \"7718\"], source: \"Proto-Carbuncle\" }\r\n232.8 \"Claw to Tail/Tail to Claw\" Ability { id: [\"770E\", \"7712\"], source: \"Proto-Carbuncle\" }\r\n#232.8 \"Raging Claw x7\" Ability { id: \"770F\", source: \"Proto-Carbuncle\" } duration 2.2\r\n#236.7 \"Raging Tail\" Ability { id: \"7711\", source: \"Proto-Carbuncle\" }\r\n\r\n239.0 \"--sync--\" Ability { id: \"76F5\", source: \"Proto-Carbuncle\" }\r\n245.1 \"--sync--\" Ability { id: \"7708\", source: \"Proto-Carbuncle\" }\r\n256.1 \"--untargetable--\"\r\n257.0 \"Starving Stampede 1\" duration 9 #Ability { id: \"7A03\", source: \"Proto-Carbuncle\" }\r\n258.4 \"Starving Stampede 2\" #Ability { id: \"7A03\", source: \"Proto-Carbuncle\" }\r\n259.8 \"Starving Stampede 3\" #Ability { id: \"7A03\", source: \"Proto-Carbuncle\" }\r\n261.2 \"Starving Stampede 4\" #Ability { id: \"7A03\", source: \"Proto-Carbuncle\" }\r\n262.5 \"Starving Stampede 5\" #Ability { id: \"7A03\", source: \"Proto-Carbuncle\" }\r\n263.7 \"Starving Stampede 6\" #Ability { id: \"7A03\", source: \"Proto-Carbuncle\" }\r\n264.9 \"Starving Stampede 7\" #Ability { id: \"7A03\", source: \"Proto-Carbuncle\" }\r\n266.0 \"Starving Stampede 8\" #Ability { id: \"7A03\", source: \"Proto-Carbuncle\" }\r\n267.0 \"--targetable--\"\r\n\r\n# This section can be extended by 10+ seconds if multiple towers are missed\r\n# due to multiple Devour/Spits.  Have this timelime reflect the \"good\" pattern.\r\n# Unclear what the timeline looks like if you let one bait spawn.\r\n267.0 \"--targetable--\"\r\n270.3 \"Venom\" Ability { id: \"770C\", source: \"Proto-Carbuncle\" }\r\n272.4 \"Devour\" Ability { id: \"7849\", source: \"Proto-Carbuncle\" }\r\n275.5 \"--sync--\" Ability { id: \"76F5\", source: \"Proto-Carbuncle\" }\r\n\r\n# 2/3 Topaz Stones + stacks to break them\r\n280.6 \"--sync--\" StartsUsing { id: \"7720\", source: \"Proto-Carbuncle\" } window 50,10\r\n285.6 \"Sonic Howl\" Ability { id: \"7720\", source: \"Proto-Carbuncle\" }\r\n292.7 \"Ruby Glow 4\" Ability { id: \"76F3\", source: \"Proto-Carbuncle\" }\r\n298.8 \"Topaz Stones\" Ability { id: \"76FD\", source: \"Proto-Carbuncle\" }\r\n298.8 \"--sync--\" Ability { id: \"76FE\", source: \"Proto-Carbuncle\" }\r\n305.9 \"Venom Pool\" Ability { id: \"79E2\", source: \"Proto-Carbuncle\" }\r\n311.1 \"--sync--\" Ability { id: \"76F5\", source: \"Proto-Carbuncle\" }\r\n312.3 \"Topaz Ray\" Ability { id: \"79FE\", source: \"Proto-Carbuncle\" }\r\n312.9 \"Ruby Reflection\" Ability { id: \"76F8\", source: \"Proto-Carbuncle\" }\r\n318.0 \"Raging Claw x7 / Searing Ray?\" #Ability { id: [\"76FA\", \"76F7\"], source: \"Proto-Carbuncle\" }\r\n318.8 \"Ruby Reflection?\" #Ability { id: \"76F8\", source: \"Proto-Carbuncle\" }\r\n\r\n# Light party splits\r\n332.1 \"Venomous Mass\" Ability { id: \"771D\", source: \"Proto-Carbuncle\" }\r\n339.2 \"Toxic Crunch\" Ability { id: \"784A\", source: \"Proto-Carbuncle\" }\r\n352.6 \"Ruby Glow 5\" Ability { id: \"76F3\", source: \"Proto-Carbuncle\" }\r\n359.7 \"Topaz Stones\" Ability { id: \"76FD\", source: \"Proto-Carbuncle\" }\r\n359.7 \"--sync--\" Ability { id: \"76FE\", source: \"Proto-Carbuncle\" }\r\n373.3 \"Topaz Ray\" Ability { id: \"79FE\", source: \"Proto-Carbuncle\" }\r\n373.9 \"Ruby Reflection\" Ability { id: \"7700\", source: \"Proto-Carbuncle\" }\r\n373.9 \"Venom Squall\" Ability { id: \"7716\", source: \"Proto-Carbuncle\" }\r\n377.8 \"Venom Rain\" Ability { id: \"7718\", source: \"Proto-Carbuncle\" }\r\n383.8 \"Venom Drops\" Ability { id: \"7719\", source: \"Proto-Carbuncle\" }\r\n386.8 \"Venom Pool\" Ability { id: \"771A\", source: \"Proto-Carbuncle\" }\r\n\r\n390.0 \"--towers--\" duration 10 # guessing\r\n404.8 \"Claw to Tail/Tail to Claw\" Ability { id: [\"770E\", \"7712\"], source: \"Proto-Carbuncle\" }\r\n#414.9 \"Raging Tail\" Ability { id: \"7A0C\", source: \"Proto-Carbuncle\" }\r\n#416.8 \"Raging Claw\" Ability { id: \"7713\", source: \"Proto-Carbuncle\" } duration 2.2\r\n417.0 \"Venomous Mass\" Ability { id: \"771D\", source: \"Proto-Carbuncle\" }\r\n424.1 \"Toxic Crunch\" Ability { id: \"784A\", source: \"Proto-Carbuncle\" }\r\n435.4 \"Sonic Howl\" Ability { id: \"7720\", source: \"Proto-Carbuncle\" }\r\n\r\n# Break Topaz Stones with poison stacks again\r\n442.5 \"Ruby Glow 6\" Ability { id: \"76F3\", source: \"Proto-Carbuncle\" }\r\n448.6 \"Topaz Stones\" Ability { id: \"76FD\", source: \"Proto-Carbuncle\" }\r\n448.6 \"--sync--\" Ability { id: \"76FE\", source: \"Proto-Carbuncle\" }\r\n455.7 \"Venom Pool\" Ability { id: \"79E2\", source: \"Proto-Carbuncle\" }\r\n462.2 \"Topaz Ray\" Ability { id: \"79FE\", source: \"Proto-Carbuncle\" }\r\n462.8 \"Ruby Reflection\" Ability { id: \"7700\", source: \"Proto-Carbuncle\" }\r\n\r\n# Double Rush\r\n465.6 \"--sync--\" Ability { id: \"76F5\", source: \"Proto-Carbuncle\" }\r\n472.7 \"Double Rush 1\" Ability { id: \"771B\", source: \"Proto-Carbuncle\" }\r\n474.7 \"Double Rush 2\" Ability { id: \"771C\", source: \"Proto-Carbuncle\" }\r\n\r\n476.7 \"--sync--\" Ability { id: \"76F5\", source: \"Proto-Carbuncle\" }\r\n482.7 \"Venomous Mass\" Ability { id: \"771D\", source: \"Proto-Carbuncle\" }\r\n489.8 \"Toxic Crunch\" Ability { id: \"784A\", source: \"Proto-Carbuncle\" }\r\n503.2 \"Sonic Howl\" Ability { id: \"7720\", source: \"Proto-Carbuncle\" }\r\n\r\n511.4 \"Venom Squall/Venom Surge\" Ability { id: [\"7716\", \"7717\"], source: \"Proto-Carbuncle\" }\r\n515.3 \"Venom Rain/Venom Pool\" Ability { id: [\"7718\", \"771A\"], source: \"Proto-Carbuncle\" }\r\n521.3 \"Venom Drops\" Ability { id: \"7719\", source: \"Proto-Carbuncle\" }\r\n524.3 \"Venom Pool/Venom Rain\" Ability { id: [\"771A\", \"7718\"], source: \"Proto-Carbuncle\" }\r\n\r\n530.7 \"Claw to Tail/Tail to Claw\" Ability { id: [\"770E\", \"7712\"], source: \"Proto-Carbuncle\" }\r\n544.1 \"Venomous Mass\" Ability { id: \"771D\", source: \"Proto-Carbuncle\" }\r\n551.2 \"Toxic Crunch\" Ability { id: \"784A\", source: \"Proto-Carbuncle\" }\r\n\r\n# Soft enrage\r\n565.5 \"Sonic Shatter\" Ability { id: \"7721\", source: \"Proto-Carbuncle\" }\r\n568.6 \"Sonic Shatter\" Ability { id: \"7722\", source: \"Proto-Carbuncle\" }\r\n571.7 \"Sonic Shatter\" Ability { id: \"7722\", source: \"Proto-Carbuncle\" }\r\n574.8 \"Sonic Shatter\" Ability { id: \"7722\", source: \"Proto-Carbuncle\" }\r\n577.9 \"Sonic Shatter\" Ability { id: \"7722\", source: \"Proto-Carbuncle\" }\r\n583.0 \"--sync--\" Ability { id: \"7708\", source: \"Proto-Carbuncle\" }\r\n\r\n# Hard Enrage\r\n593.4 \"--sync--\" StartsUsing { id: \"7723\", source: \"Proto-Carbuncle\" } window 1850,10\r\n598.1 \"Acidic Slaver (enrage)\" Ability { id: \"7723\", source: \"Proto-Carbuncle\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p6n.ts





// TODO: Find some data, any data, in the network logs that will let us call Polyominous Dark.
// and Transmission.
const p6n_triggerSet = {
  id: 'AbyssosTheSixthCircle',
  zoneId: zone_id/* default.AbyssosTheSixthCircle */.Z.AbyssosTheSixthCircle,
  timelineFile: 'p6n.txt',
  initData: () => {
    return {
      busterTargets: []
    };
  },
  triggers: [{
    id: 'P6N Hemitheos Dark IV',
    type: 'StartsUsing',
    netRegex: {
      id: '784E',
      source: 'Hegemone',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P6N Choros Ixou Sides',
    type: 'StartsUsing',
    netRegex: {
      id: '7858',
      source: 'Hegemone',
      capture: false
    },
    response: responses/* Responses.goFrontBack */.n3.goFrontBack()
  }, {
    id: 'P6N Choros Ixou Front Back',
    type: 'StartsUsing',
    netRegex: {
      id: '7857',
      source: 'Hegemone',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'P6N Synergy Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '0157'
    },
    run: (data, matches) => data.busterTargets.push(matches.target)
  }, {
    id: 'P6N Synergy Call',
    type: 'HeadMarker',
    netRegex: {
      id: '0157',
      capture: false
    },
    delaySeconds: 0.3,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      if (data.busterTargets.includes(data.me)) return output.markerYou();
      return output.avoid();
    },
    outputStrings: {
      markerYou: outputs/* default.tankCleave */.Z.tankCleave,
      avoid: outputs/* default.avoidTankCleave */.Z.avoidTankCleave
    }
  }, {
    id: 'P6N Synergy Cleanup',
    type: 'HeadMarker',
    netRegex: {
      id: '0157',
      capture: false
    },
    delaySeconds: 5,
    run: data => data.busterTargets = []
  }, {
    id: 'P6N Glossomorph Initial',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CF2'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, matches, output) => {
      if (parseFloat(matches.duration) > 15) return output.second();
      return output.first();
    },
    outputStrings: {
      first: {
        en: 'Short parasite on YOU',
        de: 'Kurzer Parasit auf DIR',
        fr: 'Parasite court sur VOUS',
        ja: '自分に短い寄生',
        cn: '短寄生点名',
        ko: '짧은 기생 디버프 대상자'
      },
      second: {
        en: 'Long parasite on YOU',
        de: 'Langer Parasit auf DIR',
        fr: 'Parasite long sur VOUS',
        ja: '自分に長い寄生',
        cn: '长寄生点名',
        ko: '긴 기생 디버프 대상자'
      }
    }
  }, {
    id: 'P6N Glossomorph Call',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CF2'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Face outside: Parasite',
        de: 'Nach außen schauen: Parasit',
        fr: 'Regardez vers l\'extérieur : Parasite',
        ja: '外向き：寄生',
        cn: '面向外面: 寄生',
        ko: '바깥 보기: 기생'
      }
    }
  }, {
    // 00A7 is the orange clockwise indicator. 00A8 is the blue counterclockwise one.
    id: 'P6N Strophe Ixou',
    type: 'HeadMarker',
    netRegex: {
      id: ['00A7', '00A8']
    },
    infoText: (_data, matches, output) => matches.id === '00A7' ? output.left() : output.right(),
    outputStrings: {
      left: {
        en: 'Rotate left',
        de: 'Nach links rotieren',
        fr: 'Tournez vers la gauche',
        ja: '左回り',
        cn: '向左转',
        ko: '왼쪽으로 회전'
      },
      right: {
        en: 'Rotate right',
        de: 'Nach rechts rotieren',
        fr: 'Tournez vers la droite',
        ja: '右回り',
        cn: '向右转',
        ko: '오른쪽으로 회전'
      }
    }
  }, {
    id: 'P6N Dark Ashes',
    type: 'HeadMarker',
    netRegex: {
      id: '0065'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'P6N Aetherial Exchange',
    type: 'Ability',
    netRegex: {
      id: '784D',
      source: 'Hegemone',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Be opposite tethered safespot',
        de: 'Sei gegenüber dem verbundenen, sicheren Platz',
        fr: 'Placez vous sur la zone sûre de l\'élément opposé',
        ja: '線が繋がってる安置へ移動',
        cn: '去连线方格对侧安全区',
        ko: '선 연결된 기둥의 안전지대로'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Hegemone': 'Hegemone',
      'Parasitos': 'Parasit'
    },
    'replaceText': {
      'random': 'Zufällig',
      'sides': 'Seiten',
      'front': 'Vorne',
      'back': 'Hinten',
      'Aetherial Exchange': 'Ätherwechsel',
      'Aetheric Polyominoid': 'Äther-Polyomino',
      'Choros Ixou': 'Choros Ixou',
      'Dark Ashes': 'Dunkle Asche',
      'Hemitheos\'s Dark IV': 'Hemitheisches Nachtka',
      'Polyominoid Sigma': 'Äther-Polyomino Σ',
      'Polyominous Dark IV': 'Neka-Polyomino',
      'Reek Havoc': 'Gasausstoß',
      'Strophe Ixou': 'Strophe Ixou',
      'Synergy': 'Synergie',
      'Transmission': 'Parasitismus'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Hegemone': 'Hégémone',
      'Parasitos': 'créature parasite'
    },
    'replaceText': {
      'Aetherial Exchange': 'Changement éthéréen',
      'Aetheric Polyominoid': 'Polyomino éthéré',
      'Choros Ixou': 'Choros Ixou',
      'Dark Ashes': 'Cendres ténébreuses',
      'Hemitheos\'s Dark IV': 'Giga Ténèbres d\'hémithéos',
      'Polyominoid Sigma': 'Polyomino éthéré Σ',
      'Polyominous Dark IV': 'Polyomino Giga Ténèbres',
      'Reek Havoc': 'Exhalaison',
      'Strophe Ixou': 'Strophe Ixou',
      'Synergy': 'Synergie',
      'Transmission': 'Parasitage'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Hegemone': 'ヘーゲモネー',
      'Parasitos': '寄生生物'
    },
    'replaceText': {
      'Aetherial Exchange': 'エーテルチェンジ',
      'Aetheric Polyominoid': 'エーテル・ポリオミノ',
      'Choros Ixou': 'ホロス・イクソス',
      'Dark Ashes': 'ダークアッシュ',
      'Hemitheos\'s Dark IV': 'ヘーミテオス・ダージャ',
      'Polyominoid Sigma': 'エーテル・ポリオミノΣ',
      'Polyominous Dark IV': 'ダージャ・ポリオミノ',
      'Reek Havoc': '噴気',
      'Strophe Ixou': 'ストロペー・イクソス',
      'Synergy': 'シュネルギア',
      'Transmission': '寄生'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Hegemone': '赫革摩涅',
      'Parasitos': '寄生生物'
    },
    'replaceText': {
      'random': '随机',
      'sides': '两侧',
      'front': '前方',
      'back': '后方',
      'Aetherial Exchange': '以太交换',
      'Aetheric Polyominoid': '以太多连方',
      'Choros Ixou': '寄生之舞',
      'Dark Ashes': '冥灰',
      'Hemitheos\'s Dark IV': '半神冥暗',
      'Polyominoid Sigma': '以太多连方Σ',
      'Polyominous Dark IV': '多连方冥暗',
      'Reek Havoc': '喷气',
      'Strophe Ixou': '寄生之旋',
      'Synergy': '协同',
      'Transmission': '寄生传染'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Hegemone': '헤게모네',
      'Parasitos': '기생생물'
    },
    'replaceText': {
      'random': '랜덤',
      'sides': '옆',
      'front': '앞',
      'back': '뒤',
      'Aetherial Exchange': '에테르 변환',
      'Aetheric Polyominoid': '에테르 폴리오미노',
      'Choros Ixou': '기생체의 춤',
      'Dark Ashes': '어둠의 잿더미',
      'Hemitheos\'s Dark IV': '헤미테오스 다쟈',
      'Polyominoid Sigma': '에테르 폴리오미노Σ',
      'Polyominous Dark IV': '다쟈 폴리오미노',
      'Reek Havoc': '입김',
      'Strophe Ixou': '기생체의 회전',
      'Synergy': '협동 공격',
      'Transmission': '기생'
    }
  }]
};
/* harmony default export */ const p6n = (p6n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p6n.txt
const raid_p6n_namespaceObject = "### P6N: Abyssos: The Sixth Circle\r\n# -ii 784B 785C 785D 7859 785A 785E 7A13 7A16 7A17 7A14 7A15\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n10.1 \"Aetheric Polyominoid\" Ability { id: \"7853\", source: \"Hegemone\" } window 11,5\r\n10.1 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n20.0 \"Polyominous Dark IV\" Ability { id: \"7855\", source: \"Hegemone\" }\r\n23.8 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n30.9 \"Choros Ixou 1\" Ability { id: [\"7857\", \"7858\"], source: \"Hegemone\" }\r\n41.0 \"Choros Ixou 2\" Ability { id: [\"7857\", \"7858\"], source: \"Hegemone\" }\r\n51.1 \"Choros Ixou 3\" Ability { id: [\"7857\", \"7858\"], source: \"Hegemone\" }\r\n62.6 \"Hemitheos's Dark IV\" Ability { id: \"784E\", source: \"Hegemone\" } window 65,10\r\n74.3 \"Transmission 1\" Ability { id: \"784F\", source: \"Hegemone\" }\r\n84.0 \"Transmission 2\" Ability { id: \"784F\", source: \"Hegemone\" }\r\n91.1 \"Reek Havoc 1\" Ability { id: \"79ED\", source: \"Parasitos\" }\r\n100.8 \"Reek Havoc 2\" Ability { id: \"79ED\", source: \"Parasitos\" }\r\n109.9 \"Synergy\" Ability { id: \"785B\", source: \"Hegemone\" }\r\n121.8 \"Aetheric Polyominoid\" Ability { id: \"7853\", source: \"Hegemone\" }\r\n121.8 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n127.5 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n134.7 \"Choros Ixou\" Ability { id: [\"7857\", \"7858\"], source: \"Hegemone\" }\r\n135.9 \"Polyominous Dark IV\" Ability { id: \"7855\", source: \"Hegemone\" }\r\n141.3 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n149.1 \"Strophe Ixou x8\" Ability { id: \"7A11\", source: \"Hegemone\" }\r\n\r\n# Transmission All + Choros Ixou + Ashes\r\n170.7 \"Hemitheos's Dark IV\" Ability { id: \"784E\", source: \"Hegemone\" } window 30,30\r\n177.5 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n185.2 \"Transmission\" Ability { id: \"784F\", source: \"Hegemone\" }\r\n195.4 \"Choros Ixou\" Ability { id: \"7858\", source: \"Hegemone\" }\r\n201.8 \"Reek Havoc 1\" Ability { id: \"79ED\", source: \"Parasitos\" }\r\n203.0 \"--sync--\" Ability { id: \"785E\", source: \"Hegemone\" }\r\n211.8 \"Reek Havoc 2\" Ability { id: \"79ED\", source: \"Parasitos\" }\r\n211.8 \"Dark Ashes\" Ability { id: \"785F\", source: \"Hegemone\" }\r\n221.4 \"Synergy\" Ability { id: \"785B\", source: \"Hegemone\" } window 30,30\r\n\r\n# Exchange Introduction\r\n234.3 \"Hemitheos's Dark IV\" Ability { id: \"784E\", source: \"Hegemone\" }\r\n244.1 \"Aetherial Exchange\" Ability { id: \"784D\", source: \"Hegemone\" }\r\n250.8 \"Polyominoid Sigma\" Ability { id: \"7856\", source: \"Hegemone\" }\r\n250.8 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n262.5 \"Polyominous Dark IV\" Ability { id: \"7855\", source: \"Hegemone\" }\r\n270.5 \"Aetherial Exchange\" Ability { id: \"784D\", source: \"Hegemone\" }\r\n277.2 \"Polyominoid Sigma\" Ability { id: \"7856\", source: \"Hegemone\" }\r\n277.2 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n288.9 \"Polyominous Dark IV\" Ability { id: \"7855\", source: \"Hegemone\" }\r\n297.9 \"Hemitheos's Dark IV\" Ability { id: \"784E\", source: \"Hegemone\" } window 30,30\r\n307.7 \"Aetherial Exchange\" Ability { id: \"784D\", source: \"Hegemone\" }\r\n314.4 \"Polyominoid Sigma\" Ability { id: \"7856\", source: \"Hegemone\" }\r\n314.4 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n319.0 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n326.8 \"Strophe Ixou x8\" Ability { id: \"7A11\", source: \"Hegemone\" } duration 11.5\r\n327.0 \"Polyominous Dark IV\" Ability { id: \"7855\", source: \"Hegemone\" }\r\n347.3 \"Synergy\" Ability { id: \"785B\", source: \"Hegemone\" } window 30,30\r\n\r\n# Transmission All + Exchange + Choros Ixou\r\n360.2 \"Hemitheos's Dark IV\" Ability { id: \"784E\", source: \"Hegemone\" }\r\n372.0 \"Transmission\" Ability { id: \"784F\", source: \"Hegemone\" }\r\n381.7 \"Aetheric Polyominoid\" Ability { id: \"7853\", source: \"Hegemone\" }\r\n381.7 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n388.7 \"Reek Havoc 1\" Ability { id: \"79ED\", source: \"Parasitos\" }\r\n394.0 \"Polyominous Dark IV\" Ability { id: \"7855\", source: \"Hegemone\" }\r\n398.7 \"Reek Havoc 2\" Ability { id: \"79ED\", source: \"Parasitos\" }\r\n407.4 \"Aetherial Exchange\" Ability { id: \"784D\", source: \"Hegemone\" }\r\n414.1 \"Polyominoid Sigma\" Ability { id: \"7856\", source: \"Hegemone\" }\r\n414.1 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n419.2 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n426.4 \"Choros Ixou\" Ability { id: [\"7857\", \"7858\"], source: \"Hegemone\" }\r\n427.1 \"Polyominous Dark IV\" Ability { id: \"7855\", source: \"Hegemone\" }\r\n437.2 \"Synergy\" Ability { id: \"785B\", source: \"Hegemone\" }\r\n\r\n# Exchange + Ashes\r\n450.1 \"Hemitheos's Dark IV\" Ability { id: \"784E\", source: \"Hegemone\" }\r\n459.9 \"Aetherial Exchange\" Ability { id: \"784D\", source: \"Hegemone\" }\r\n466.6 \"Polyominoid Sigma\" Ability { id: \"7856\", source: \"Hegemone\" }\r\n466.6 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n474.2 \"--sync--\" Ability { id: \"785E\", source: \"Hegemone\" }\r\n482.9 \"Polyominous Dark IV\" Ability { id: \"7855\", source: \"Hegemone\" }\r\n483.1 \"Dark Ashes\" Ability { id: \"785F\", source: \"Hegemone\" }\r\n491.3 \"Aetherial Exchange\" Ability { id: \"784D\", source: \"Hegemone\" }\r\n498.0 \"Polyominoid Sigma\" Ability { id: \"7856\", source: \"Hegemone\" }\r\n498.0 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n502.6 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n510.5 \"Strophe Ixou x8\" Ability { id: \"7A11\", source: \"Hegemone\" } duration 11.5\r\n510.6 \"Polyominous Dark IV\" Ability { id: \"7855\", source: \"Hegemone\" }\r\n531.0 \"Synergy\" Ability { id: \"785B\", source: \"Hegemone\" }\r\n\r\n# -> loop\r\n543.9 \"Hemitheos's Dark IV\" Ability { id: \"784E\", source: \"Hegemone\" } window 50,50 jump 360.2\r\n555.7 \"Transmission\" #Ability { id: \"784F\", source: \"Hegemone\" }\r\n565.4 \"Aetheric Polyominoid\" #Ability { id: \"7853\", source: \"Hegemone\" }\r\n565.4 \"--sync--\" #Ability { id: \"7854\", source: \"Hegemone\" }\r\n572.4 \"Reek Havoc 1\" #Ability { id: \"79ED\", source: \"Parasitos\" }\r\n577.7 \"Polyominous Dark IV\" #Ability { id: \"7855\", source: \"Hegemone\" }\r\n582.4 \"Reek Havoc 2\" #Ability { id: \"79ED\", source: \"Parasitos\" }\r\n591.1 \"Aetherial Exchange\" #Ability { id: \"784D\", source: \"Hegemone\" }\r\n597.8 \"Polyominoid Sigma\" #Ability { id: \"7856\", source: \"Hegemone\" }\r\n597.8 \"--sync--\" #Ability { id: \"7854\", source: \"Hegemone\" }\r\n602.9 \"--sync--\" #Ability { id: \"784C\", source: \"Hegemone\" }\r\n610.1 \"Choros Ixou\" #Ability { id: [\"7857\", \"7858\"], source: \"Hegemone\" }\r\n610.8 \"Polyominous Dark IV\" #Ability { id: \"7855\", source: \"Hegemone\" }\r\n620.9 \"Synergy\" #Ability { id: \"785B\", source: \"Hegemone\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p6s.ts





// Due to changes introduced in patch 5.2, overhead markers now have a random offset
// added to their ID. This offset currently appears to be set per instance, so
// we can determine what it is from the first overhead marker we see.
// The first 1B marker in the encounter is an Unholy Darkness stack marker (013E).
const p6s_firstHeadmarker = parseInt('013E', 16);
const p6s_getHeadmarkerId = (data, matches) => {
  // If we naively just check !data.decOffset and leave it, it breaks if the first marker is 013E.
  // (This makes the offset 0, and !0 is true.)
  if (typeof data.decOffset === 'undefined') data.decOffset = parseInt(matches.id, 16) - p6s_firstHeadmarker;
  // The leading zeroes are stripped when converting back to string, so we re-add them here.
  // Fortunately, we don't have to worry about whether or not this is robust,
  // since we know all the IDs that will be present in the encounter.
  return (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase().padStart(4, '0');
};
const crossTileFlags = '00020001'; // mapEffect flags for '+' tile effect
const diagonalTileFlags = '00400020'; // mapEffect flags for 'x' tile effect

const p6s_triggerSet = {
  id: 'AbyssosTheSixthCircleSavage',
  zoneId: zone_id/* default.AbyssosTheSixthCircleSavage */.Z.AbyssosTheSixthCircleSavage,
  timelineFile: 'p6s.txt',
  initData: () => {
    return {
      pathogenicCellsCounter: 0,
      aetheronecrosisDuration: 0,
      predationCount: 0,
      polyInstance: 0,
      tileTethers: [],
      mapEffects: [],
      combatantData: [],
      darkSpheres: []
    };
  },
  triggers: [{
    id: 'P6S Headmarker Tracker',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.decOffset === undefined,
    // Unconditionally set the first headmarker here so that future triggers are conditional.
    run: (data, matches) => {
      p6s_getHeadmarkerId(data, matches);
    }
  }, {
    id: 'P6S Hemitheos\'s Dark IV',
    type: 'StartsUsing',
    netRegex: {
      id: '7860',
      source: 'Hegemone',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P6S Chelic Synergy',
    type: 'StartsUsing',
    netRegex: {
      id: '788A',
      source: 'Hegemone'
    },
    response: responses/* Responses.sharedTankBuster */.n3.sharedTankBuster()
  }, {
    id: 'P6S Synergy',
    type: 'StartsUsing',
    // There are 7889 individual starts using casts on the two tanks as well,
    // if this trigger wanted to be more complicated.
    netRegex: {
      id: '7887',
      source: 'Hegemone',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Split Tankbusters',
        de: 'getrennte Tankbuster',
        fr: 'Séparez les Tankbusters',
        ja: '2人同時タンク強攻撃',
        cn: '分散死刑',
        ko: '따로맞는 탱버'
      }
    }
  }, {
    id: 'P6S Polyominoid Tether Collect',
    type: 'Tether',
    netRegex: {
      id: '00CF'
    },
    run: (data, matches) => {
      data.tileTethers.push(matches);
    }
  }, {
    id: 'P6S Polyominoid MapEffect Collect',
    type: 'MapEffect',
    netRegex: {
      flags: [crossTileFlags, diagonalTileFlags]
    },
    run: (data, matches) => {
      // location '00' won't be used for determining mechanic resolution
      if (matches.location !== '00') data.mapEffects.push(matches);
    }
  }, {
    // Use a single trigger for Aetherial Polyominod (7866) and
    // Polyominoid Sigma (7868).  Both use MapEffects, but only
    // 7868 uses tethers to hidden actors to "swap" tiles.
    id: 'P6S Polyominoid All',
    type: 'Ability',
    netRegex: {
      id: '786[68]',
      source: 'Hegemone',
      capture: false
    },
    delaySeconds: 2,
    // relevant mapeffect and trigger lines are consistently sent ~1.83s after the cast
    durationSeconds: 10,
    // leave the output up while overlapping mechanics resolve
    promise: async data => {
      data.combatantData = [];
      const ids = [];
      if (data.tileTethers.length !== 0) {
        for (const tether of data.tileTethers) ids.push(parseInt(tether.sourceId, 16), parseInt(tether.targetId, 16));
        data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
          call: 'getCombatants',
          ids: ids
        })).combatants;
      }
    },
    infoText: (data, _matches, output) => {
      data.polyInstance++;
      if (data.tileTethers.length > 0 && data.combatantData.length === 0) return;
      if (data.mapEffects.length < 2) return;
      if (data.polyInstance === 4)
        // lots of safe spots, doesn't need a trigger response
        return;
      const safe = {
        // This ordering matters for most Poly instances.
        insideNW: true,
        insideNE: true,
        insideSW: true,
        insideSE: true,
        cornerNW: true,
        cornerNE: true,
        cornerSW: true,
        cornerSE: true,
        outsideNNW: true,
        outsideNNE: true,
        outsideSSW: true,
        outsideSSE: true,
        outsideWNW: true,
        outsideENE: true,
        outsideWSW: true,
        outsideESE: true
      };

      // Tile index mapped to arrays containing the MapEffect location code
      // for that tile and the corresponding tile name in safe[].
      const unsafeMap = {
        0: ['01', 'cornerNW'],
        1: ['02', 'outsideNNW'],
        2: ['03', 'outsideNNE'],
        3: ['04', 'cornerNE'],
        10: ['0F', 'outsideWNW'],
        11: ['05', 'insideNW'],
        12: ['06', 'insideNE'],
        13: ['10', 'outsideENE'],
        20: ['0D', 'outsideWSW'],
        21: ['07', 'insideSW'],
        22: ['08', 'insideSE'],
        23: ['0E', 'outsideESE'],
        30: ['09', 'cornerSW'],
        31: ['0A', 'outsideSSW'],
        32: ['0B', 'outsideSSE'],
        33: ['0C', 'cornerSE']
      };
      const mapLookup = Object.fromEntries(Object.entries(unsafeMap).map(([tile, [location]]) => [location, parseInt(tile, 10)]));

      // Polys 2, 3, 5, and 6 involve tethers. We only care about which
      // tiles have tethers, not which tiles are tethered together.
      // This is because there are only two types of tiles, and swaps
      // are only done between tiles of opposite types.
      const tetheredTiles = [];
      if (data.tileTethers.length >= 1) {
        for (const tile of data.combatantData) {
          // x, y = 85, 95, 105, 115 (with a little variance)
          // map to ([0, 1, 2, 3] and [0, 10, 20, 30]
          const x = Math.floor((tile.PosX - 83) / 10); // add in a -2/+8 buffer in case of goofy pos data
          const y = Math.floor((tile.PosY - 83) / 10) * 10; // add in a -2/+8 buffer in case of goofy pos data
          const idx = x + y;
          if (unsafeMap[idx] === undefined) return;
          tetheredTiles.push(idx);
        }
      }

      // modifiers used to calculate unsafeMap indexes to be removed for each type of tile
      const relCrossTiles = new Int8Array([-30, -20, -10, -3, -2, -1, 1, 2, 3, 10, 20, 30]);
      const relDiagonalTiles = new Int8Array([-33, -27, -22, -18, -11, -9, 9, 11, 18, 22, 27, 33]);
      for (const effect of data.mapEffects) {
        if (mapLookup[effect.location] === undefined) return;
        const startTile = mapLookup[effect.location];
        const isTethered = tetheredTiles.includes(startTile);
        if (unsafeMap[startTile] !== undefined) delete safe[unsafeMap[startTile][1]]; // delete tile where effect appears, as it will always be unsafe
        if (effect.flags === crossTileFlags && !isTethered || effect.flags === diagonalTileFlags && isTethered) {
          relCrossTiles.forEach(tileMod => {
            const deleteTile = startTile + tileMod;
            if (unsafeMap[deleteTile] !== undefined) delete safe[unsafeMap[deleteTile][1]];
          });
        } else if (effect.flags === diagonalTileFlags && !isTethered || effect.flags === crossTileFlags && isTethered) {
          relDiagonalTiles.forEach(tileMod => {
            const deleteTile = startTile + tileMod;
            if (unsafeMap[deleteTile] !== undefined) delete safe[unsafeMap[deleteTile][1]];
          });
        } else {
          return;
        }
      }
      const safeTiles = Object.keys(safe);
      const [safe0, safe1] = safeTiles;
      if (safe0 === undefined) return;
      const outsideFrontBackTiles = ['outsideNNW', 'outsideNNE', 'outsideSSW', 'outsideSSE'];
      const outsideSideTiles = ['outsideWNW', 'outsideENE', 'outsideWSW', 'outsideESE'];
      // establishes pairs of east/west tiles that will be safe during Poly 6
      const poly6Pairs = {
        insideNW: 'outsideSSW',
        insideNE: 'outsideSSE',
        insideSW: 'outsideNNW',
        insideSE: 'outsideNNE',
        cornerNW: 'outsideWSW',
        cornerNE: 'outsideESE',
        cornerSE: 'outsideENE',
        cornerSW: 'outsideWNW'
      };
      switch (data.polyInstance) {
        case 1:
          // four safe spots: two inside (east or west pair) and two outside (opposite east or west pair)
          if (safeTiles.length !== 4) return;
          if (safe0 === 'insideNW') return output.combo({
            dir1: output.insideWest(),
            dir2: output.outsideEast()
          });else if (safe0 === 'insideNE') return output.combo({
            dir1: output.insideEast(),
            dir2: output.outsideWest()
          });
          return;
        case 2:
          // one inside safe spot
          if (safeTiles.length !== 1 || output[safe0] === undefined) return;
          return output.single({
            dir1: output[safe0]()
          });
        case 3:
          // two inside safe spots
          if (safeTiles.length !== 2 || safe1 === undefined || output[safe0] === undefined || output[safe1] === undefined) return;
          return output.combo({
            dir1: output[safe0](),
            dir2: output[safe1]()
          });
        case 4:
          // here for completeness, but should never be run
          return;
        case 5:
          // two outside safe spots (reduced to one by Chorus Ixou)
          if (safeTiles.length !== 2 || safe1 === undefined) return;
          if (outsideFrontBackTiles.includes(safe0) && outsideSideTiles.includes(safe1)) {
            // should be always true because of ordering
            data.poly5FrontBackTile = output[safe0]();
            data.poly5SideTile = output[safe1]();
            return; // success - output will be handled by Chorus Ixou trigger
          }

          return;
        case 6:
          // Cachexia 2 - four safe spots that form corners of a 3x3 tile sub-grid
          if (safeTiles.length !== 4 || safe1 === undefined || data.predationDebuff === undefined) return;
          // data.predationDebuff should be set by P6S Predation Debuff Collect
          // - CF7 Glossal Resistance Down (Snake Icon) (Left/west safe)
          // - CF8 Chelic Resistance Down (Wing Icon) (right/east safe)
          // for pol6, safe0 should always be an inside tile, and safe1 should always be a corner tile
          if (data.predationDebuff === 'CF7') {
            data.poly6SafeSide = output.left();
            if (safe0 === 'insideNW' || safe0 === 'insideSW')
              // inside + wall tile safe
              return output.poly6({
                dir1: output.left(),
                dir2: output[safe0](),
                dir3: output[poly6Pairs[safe0]]()
              });else if (safe1 === 'cornerNW' || safe1 === 'cornerSW') return output.poly6({
              dir1: output.left(),
              dir2: output[safe1](),
              dir3: output[poly6Pairs[safe1]]()
            });
            return;
          } else if (data.predationDebuff === 'CF8') {
            data.poly6SafeSide = output.right();
            if (safe0 === 'insideNE' || safe0 === 'insideSE')
              // inside + wall tile safe
              return output.poly6({
                dir1: output.right(),
                dir2: output[safe0](),
                dir3: output[poly6Pairs[safe0]]()
              });else if (safe1 === 'cornerNE' || safe1 === 'cornerSE') return output.poly6({
              dir1: output.right(),
              dir2: output[safe1](),
              dir3: output[poly6Pairs[safe1]]()
            });
            return;
          }
          return;
        case 7:
          // one inside safe spot
          if (safeTiles.length !== 1 || output[safe0] === undefined) return;
          return output.single({
            dir1: output[safe0]()
          });
        case 8:
          // four safe spots: two inside (east or west pair) and two outside (opposite east or west pair)
          if (safeTiles.length !== 4) return;
          if (safe0 === 'insideNW') return output.combo({
            dir1: output.insideWest(),
            dir2: output.outsideEast()
          });else if (safe0 === 'insideNE') return output.combo({
            dir1: output.insideEast(),
            dir2: output.outsideWest()
          });
          return;
        default:
          return;
      }
    },
    run: data => {
      data.tileTethers = [];
      data.mapEffects = [];
      data.combatantData = [];
    },
    outputStrings: {
      combo: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        ja: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      },
      single: {
        en: '${dir1}',
        de: '${dir1}',
        fr: '${dir1}',
        ja: '${dir1}',
        cn: '${dir1}',
        ko: '${dir1}'
      },
      poly6: {
        en: '${dir1}: ${dir2} / ${dir3}',
        de: '${dir1}: ${dir2} / ${dir3}',
        fr: '${dir1}: ${dir2} / ${dir3}',
        ja: '${dir1}: ${dir2} / ${dir3}',
        cn: '${dir1}: ${dir2} / ${dir3}',
        ko: '${dir1}: ${dir2} / ${dir3}'
      },
      left: {
        en: 'Left (Wing Side)',
        de: 'Links (Flügel-Seite)',
        fr: 'Gauche (Côté aile)',
        ja: '左 (翼)',
        cn: '左 (翅膀侧)',
        ko: '왼쪽 (날개쪽)'
      },
      right: {
        en: 'Right (Snake Side)',
        de: 'Rechts (Schlangen-Seite)',
        fr: 'Droite (Côté serpent)',
        ja: '右 (蛇)',
        cn: '右 (蛇侧)',
        ko: '오른쪽 (뱀쪽)'
      },
      insideWest: {
        en: 'Inside West',
        de: 'Westen innen',
        fr: 'Intérieur Ouest',
        ja: '内側 西',
        cn: '内侧 左 (西)',
        ko: '안 서쪽'
      },
      insideEast: {
        en: 'Inside East',
        de: 'Osten innen',
        fr: 'Intérieur Est',
        ja: '内側 東',
        cn: '内侧 右 (东)',
        ko: '안 동쪽'
      },
      outsideWest: {
        en: 'Outside West',
        de: 'Westen außen',
        fr: 'Extérieur Ouest',
        ja: '外側 西',
        cn: '外侧 左 (西)',
        ko: '바깥 서쪽'
      },
      outsideEast: {
        en: 'Outside East',
        de: 'Osten außen',
        fr: 'Extérieur Est',
        ja: '外側 東',
        cn: '外侧 右 (东)',
        ko: '바깥 동쪽'
      },
      insideNW: {
        en: 'Inside NW',
        de: 'NW innen',
        fr: 'Intérieur NO',
        ja: '内側 北西',
        cn: '内侧 左上 (西北)',
        ko: '안 북서쪽'
      },
      insideNE: {
        en: 'Inside NE',
        de: 'NO innen',
        fr: 'Intérieur NE',
        ja: '内側 北東',
        cn: '内侧 右上 (东北)',
        ko: '안 북동쪽'
      },
      insideSE: {
        en: 'Inside SE',
        de: 'SO innen',
        fr: 'Intérieur SE',
        ja: '内側 南東',
        cn: '内侧 右下 (东南)',
        ko: '안 남동쪽'
      },
      insideSW: {
        en: 'Inside SW',
        de: 'SW innen',
        fr: 'Intérieur SO',
        ja: '内側 南西',
        cn: '内侧 左下 (西南)',
        ko: '안 남서쪽'
      },
      outsideNNW: {
        en: 'Outside NNW',
        de: 'NNW außen',
        fr: 'Extérieur NNO',
        ja: '1列 西の内側',
        cn: '外侧 上偏左 (北偏西)',
        ko: '바깥 북쪽 왼칸'
      },
      outsideNNE: {
        en: 'Outside NNE',
        de: 'NNO außen',
        fr: 'Extérieur NNE',
        ja: '1列 東の内側',
        cn: '外侧 上偏右 (北偏东)',
        ko: '바깥 북쪽 오른칸'
      },
      outsideSSW: {
        en: 'Outside SSW',
        de: 'SSW außen',
        fr: 'Extérieur SSO',
        ja: '4列 西の内側',
        cn: '外侧 下偏左 (南偏西)',
        ko: '바깥 남쪽 왼칸'
      },
      outsideSSE: {
        en: 'Outside SSE',
        de: 'SSO außen',
        fr: 'Extérieur SSE',
        ja: '4列 東の内側',
        cn: '外侧 下偏右 (南偏东)',
        ko: '바깥 남쪽 오른칸'
      },
      outsideWNW: {
        en: 'Outside WNW',
        de: 'WNW außen',
        fr: 'Extérieur ONO',
        ja: '2列 西の外側',
        cn: '外侧 左偏上 (西偏北)',
        ko: '바깥 서쪽 위칸'
      },
      outsideENE: {
        en: 'Outside ENE',
        de: 'ONO außen',
        fr: 'Extérieur ENE',
        ja: '2列 東の外側',
        cn: '外侧 右偏上 (东偏北)',
        ko: '바깥 동쪽 위칸'
      },
      outsideWSW: {
        en: 'Outside WSW',
        de: 'WSW außen',
        fr: 'Extérieur OSO',
        ja: '3列 西の外側',
        cn: '外侧 左偏下 (西偏南)',
        ko: '바깥 서쪽 아래칸'
      },
      outsideESE: {
        en: 'Outside ESE',
        de: 'OSO außen',
        fr: 'Extérieur ESE',
        ja: '3列 東の外側',
        cn: '外侧 右偏下 (东偏南)',
        ko: '바깥 동쪽 아래칸'
      },
      cornerNW: {
        en: 'NW Corner',
        de: 'NW Ecke',
        fr: 'Coin NO',
        ja: '北西 隅',
        cn: '左上 (西北) 角',
        ko: '북서쪽 구석'
      },
      cornerNE: {
        en: 'NE Corner',
        de: 'NO Ecke',
        fr: 'Coin NE',
        ja: '北東 隅',
        cn: '右上 (东北) 角',
        ko: '북동쪽 구석'
      },
      cornerSE: {
        en: 'SE Corner',
        de: 'SO Ecke',
        fr: 'Coin SE',
        ja: '南東 隅',
        cn: '右下 (东南) 角',
        ko: '남동쪽 구석'
      },
      cornerSW: {
        en: 'SW Corner',
        de: 'SW Ecke',
        fr: 'Coin SO',
        ja: '南西 隅',
        cn: '左下 (西南) 角',
        ko: '남서쪽 구석'
      }
    }
  }, {
    id: 'P6S Exocleaver Healer Groups',
    // Unholy Darkness stack headmarkers are same time as first Exocleaver
    type: 'StartsUsing',
    netRegex: {
      id: ['7869', '786B'],
      source: 'Hegemone',
      capture: false
    },
    condition: data => !data.secondExocleavers,
    alertText: (_data, _matches, output) => output.healerGroups(),
    run: data => data.secondExocleavers = true,
    outputStrings: {
      healerGroups: outputs/* default.healerGroups */.Z.healerGroups
    }
  }, {
    id: 'P6S Exocleaver Move',
    type: 'Ability',
    netRegex: {
      id: ['7869', '786B'],
      source: 'Hegemone',
      capture: false
    },
    // Supress until after second Exocleaver in the set
    suppressSeconds: 4,
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'P6S Polyominoid Healer Groups',
    type: 'StartsUsing',
    netRegex: {
      id: '7892',
      source: 'Hegemone',
      capture: false
    },
    // Should not be fired during Poly 1, since the Unholy Darkness headmarkers there
    // are handled by P6S Exocleaver Healer Groups.
    condition: data => data.polyInstance === 3,
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.healerGroups(),
    outputStrings: {
      healerGroups: outputs/* default.healerGroups */.Z.healerGroups
    }
  }, {
    id: 'P6S Choros Ixou Front Back',
    type: 'StartsUsing',
    netRegex: {
      id: '7883',
      source: 'Hegemone',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.polyInstance === 5 && data.poly5FrontBackTile !== undefined) return output.goFrontBackPoly5({
        tile: data.poly5FrontBackTile
      });
      return output.goFrontBack();
    },
    outputStrings: {
      goFrontBack: outputs/* default.goFrontBack */.Z.goFrontBack,
      goFrontBackPoly5: {
        en: 'Go Front/Back (${tile})',
        de: 'Gehe nach Vorne/Hinten (${tile})',
        fr: 'Allez Devant/Derrière (${tile})',
        ja: '縦へ (${tile})',
        cn: '去前/后 (${tile})',
        ko: '앞/뒤로 (${tile})'
      }
    }
  }, {
    id: 'P6S Choros Ixou Sides',
    type: 'StartsUsing',
    netRegex: {
      id: '7881',
      source: 'Hegemone',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.polyInstance === 5 && data.poly5SideTile !== undefined) return output.goSidesPoly5({
        tile: data.poly5SideTile
      });
      return output.goSides();
    },
    outputStrings: {
      goSides: outputs/* default.sides */.Z.sides,
      goSidesPoly5: {
        en: 'Sides (${tile})',
        de: 'Seiten (${tile})',
        fr: 'Côté (${tile})',
        ja: '横へ (${tile})',
        cn: '去两侧 (${tile})',
        ko: '옆으로 (${tile})'
      }
    }
  }, {
    id: 'P6S Pathogenic Cells Numbers',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      return data.me === matches.target && /00(?:4F|5[0-6])/.test(p6s_getHeadmarkerId(data, matches));
    },
    preRun: (data, matches) => {
      const correctedMatch = p6s_getHeadmarkerId(data, matches);
      const pathogenicCellsNumberMap = {
        '004F': 1,
        '0050': 2,
        '0051': 3,
        '0052': 4,
        '0053': 5,
        '0054': 6,
        '0055': 7,
        '0056': 8
      };
      data.pathogenicCellsNumber = pathogenicCellsNumberMap[correctedMatch];
      const pathogenicCellsDelayMap = {
        '004F': 8.6,
        '0050': 10.6,
        '0051': 12.5,
        '0052': 14.4,
        '0053': 16.4,
        '0054': 18.3,
        '0055': 20.2,
        '0056': 22.2
      };
      data.pathogenicCellsDelay = pathogenicCellsDelayMap[correctedMatch];
    },
    durationSeconds: data => {
      // Because people are very forgetful,
      // show the number until you are done.
      return data.pathogenicCellsDelay;
    },
    alertText: (data, _matches, output) => output.text({
      num: data.pathogenicCellsNumber
    }),
    outputStrings: {
      text: {
        en: '#${num}',
        de: '#${num}',
        fr: '#${num}',
        ja: '自分: ${num}番',
        cn: '#${num}',
        ko: '${num}번째'
      }
    }
  }, {
    id: 'P6S Pathogenic Cells Counter',
    type: 'Ability',
    netRegex: {
      id: '7865',
      source: 'Hegemone',
      capture: false
    },
    preRun: (data, _matches) => data.pathogenicCellsCounter++,
    durationSeconds: 1.5,
    suppressSeconds: 1,
    sound: '',
    infoText: (data, _matches, output) => output.text({
      num: data.pathogenicCellsCounter
    }),
    tts: null,
    outputStrings: {
      text: {
        en: '${num}',
        de: '${num}',
        fr: '${num}',
        ja: '${num}番',
        cn: '${num}',
        ko: '${num}'
      }
    }
  }, {
    // Each head marker is for each scenario.
    // There are markers for: stack, no exchange; spread exchanged to donut; spread exchanged to stack; etc.
    // Therefore, there is no need to keep track of tethers as well.
    id: 'P6S Exchange of Agonies Markers',
    type: 'HeadMarker',
    netRegex: {},
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (data, matches, output) => {
      const correctedMatch = p6s_getHeadmarkerId(data, matches);
      switch (correctedMatch) {
        case '0163': // stack
        case '0167': // spread exchanged to stack
        case '0169':
          // donut exchanged to stack
          return output.stackOnYou();
        case '0164': // spread
        case '0165': // stack exchanged to spread
        case '016A':
          // donut exchanged to spread
          return output.spreadCorner();
        case '0166': // stack exchanged to donut
        case '0168': // spread exchanged to donut
        case '016E':
          // donut
          return output.donut();
      }
    },
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      donut: {
        en: 'Stack Donut',
        de: 'Sammeln Donut',
        fr: 'Packez-vous, donut',
        ja: '頭割り',
        cn: '集合放月环',
        ko: '도넛 장판, 쉐어'
      },
      spreadCorner: {
        en: 'Spread Corner',
        de: 'In Ecken Verteilen',
        fr: 'Écartez-vous dans le coin',
        ja: '隅で散会',
        cn: '去角落',
        ko: '구석으로 산개'
      }
    }
  }, {
    id: 'P6S Dark Dome Bait',
    type: 'StartsUsing',
    netRegex: {
      id: '788B',
      source: 'Hegemone',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Circles',
        de: 'Kreise ködern',
        fr: 'Déposez les cercles',
        ja: 'ゆか誘導',
        cn: '集合放圈',
        ko: '장판 유도'
      }
    }
  }, {
    id: 'P6S Dark Dome Move',
    type: 'Ability',
    netRegex: {
      id: '788B',
      source: 'Hegemone',
      capture: false
    },
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'P6S Predation Debuff Collect',
    // CF7 Glossal Resistance Down (Snake Icon)
    // CF8 Chelic Resistance Down (Wing Icon)
    type: 'GainsEffect',
    netRegex: {
      effectId: ['CF7', 'CF8']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    run: (data, matches) => data.predationDebuff = matches.effectId
  }, {
    id: 'P6S Predation Bait Order',
    // Using Aetheronecrosis (CF9)
    // These come out as 20s, 16s, 12s, or 8s
    type: 'GainsEffect',
    netRegex: {
      effectId: 'CF9'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: (data, matches) => data.aetheronecrosisDuration = parseFloat(matches.duration),
    delaySeconds: 0.1,
    durationSeconds: (_data, matches) => {
      const duration = parseFloat(matches.duration);
      // First Dual Predation is 3.7s before expiration
      // Remaining Dual Predations are 12.3s (second), 12.4s (third/fourth)
      return duration > 16 ? duration - 3.8 : duration + 12.3;
    },
    infoText: (data, matches, output) => {
      const duration = parseFloat(matches.duration);
      const dir = data.predationDebuff === 'CF7' ? output.left() : output.right();
      let numBait;

      // Allow for slight variation in duration
      if (duration <= 8) {
        numBait = output.secondBait();
      } else if (duration <= 12) {
        numBait = output.thirdBait();
      } else if (duration <= 16) {
        numBait = output.fourthBait();
      } else {
        // 20s
        numBait = output.firstBait();
      }
      return output.text({
        dir: dir,
        bait: numBait
      });
    },
    outputStrings: {
      text: {
        en: '${dir}, ${bait}',
        de: '${dir}, ${bait}',
        fr: '${dir}, ${bait}',
        ja: '${dir}, ${bait}',
        cn: '${dir}, ${bait}',
        ko: '${dir}, ${bait}'
      },
      left: {
        en: 'Left (Wing Side)',
        de: 'Links (Flügel-Seite)',
        fr: 'Gauche (Côté Aile)',
        ja: '左 (翼)',
        cn: '左 (翅膀侧)',
        ko: '왼쪽 (날개쪽)'
      },
      right: {
        en: 'Right (Snake Side)',
        de: 'Rechts (Schlangen-Seite)',
        fr: 'Droite (Côté Serpent)',
        ja: '右 (蛇)',
        cn: '右 (蛇侧)',
        ko: '오른쪽 (뱀쪽)'
      },
      firstBait: {
        en: 'First Bait (20s)',
        de: 'Köder als 1. (20s)',
        fr: 'Dépose en 1er (20s)',
        ja: '1番目 (20秒)',
        cn: '1组引导 (20秒)',
        ko: '유도 1번 (20초)'
      },
      secondBait: {
        en: 'Second Bait (8s)',
        de: 'Köder als 2. (8s)',
        fr: 'Dépose en 2ème (8s)',
        ja: '2番目 (8秒)',
        cn: '2组引导 (8秒)',
        ko: '유도 2번 (8초)'
      },
      thirdBait: {
        en: 'Third Bait (12s)',
        de: 'Köder als 3. (12s)',
        fr: 'Dépose en 3ème (12s)',
        ja: '3番目 (12秒)',
        cn: '3组引导 (12秒)',
        ko: '유도 3번 (12초)'
      },
      fourthBait: {
        en: 'Fourth Bait (16s)',
        de: 'Köder als 4. (16s)',
        fr: 'Dépose en 4ème (16s)',
        ja: '4番目 (16秒)',
        cn: '4组引导 (16秒)',
        ko: '유도 4번 (16초)'
      }
    }
  }, {
    id: 'P6S Predation In First Bait Reminder',
    // Using Dual Predation (7878)
    // Delayed to give roughly same notice interval as other bait reminders
    type: 'StartsUsing',
    netRegex: {
      id: '7878',
      source: 'Hegemone'
    },
    condition: data => data.aetheronecrosisDuration > 16,
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 4,
    infoText: (_data, _matches, output) => output.inFirstBait(),
    outputStrings: {
      inFirstBait: {
        en: 'In (First Bait)',
        de: 'Rein (Köder als 1.)',
        fr: 'À l\'intérieur (1er)',
        ja: '内側へ (1番目)',
        cn: '内侧引导 (第1组)',
        ko: '안으로 (유도 1번)'
      }
    }
  }, {
    id: 'P6S Predation In Bait Reminder',
    // Using Chelic Predation (787B) and Glossal Predation (787A)
    // Player could get hit at wrong time and still get this trigger
    type: 'Ability',
    netRegex: {
      id: ['787A', '787B'],
      source: 'Hegemone',
      capture: false
    },
    durationSeconds: 4,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      data.predationCount = data.predationCount + 1;
      let countMap;

      // Allow for slight variation in duration
      if (data.aetheronecrosisDuration <= 8) {
        countMap = 1;
      } else if (data.aetheronecrosisDuration <= 12) {
        countMap = 2;
      } else if (data.aetheronecrosisDuration <= 16) {
        countMap = 3;
      } else {
        // 20s
        countMap = 0;
      }

      // Output for in players
      if (countMap === data.predationCount) {
        const inBaitMap = {
          1: output.inSecondBait(),
          2: output.inThirdBait(),
          3: output.inFourthBait()
        };
        return inBaitMap[data.predationCount];
      }
    },
    outputStrings: {
      inSecondBait: {
        en: 'In (Second Bait)',
        de: 'Rein (Köder als 2.)',
        fr: 'À l\'intérieur (2ème)',
        ja: '内側へ (2番目)',
        cn: '内侧引导 (第2组)',
        ko: '안으로 (유도 2번)'
      },
      inThirdBait: {
        en: 'In (Third Bait)',
        de: 'Rein (Köder als 3.)',
        fr: 'À l\'intérieur (3ème)',
        ja: '内側へ (3番目)',
        cn: '内侧引导 (第3组)',
        ko: '안으로 (유도 3번)'
      },
      inFourthBait: {
        en: 'In (Fourth Bait)',
        de: 'Rein (Köder als 4.)',
        fr: 'À l\'intérieur (4ème)',
        ja: '内側へ (4番目)',
        cn: '内侧引导 (第4组)',
        ko: '안으로 (유도 4번)'
      }
    }
  }, {
    id: 'P6S Predation Out',
    type: 'Ability',
    netRegex: {
      id: ['787A', '787B'],
      source: 'Hegemone'
    },
    // Don't bother calling "out" for the final person.
    condition: (data, matches) => data.me === matches.target && data.aetheronecrosisDuration <= 12,
    infoText: (_data, _matches, output) => output.out(),
    outputStrings: {
      out: outputs/* default.out */.Z.out
    }
  }, {
    id: 'P6S Ptera Ixou',
    type: 'StartsUsing',
    netRegex: {
      id: '787C',
      source: 'Hegemone',
      capture: false
    },
    condition: data => data.polyInstance !== 6,
    // do not run during Poly 6/Cachexia 2 - this is handled by P6S Cachexia 2 Dark Spheres
    infoText: (data, _matches, output) => data.predationDebuff === 'CF7' ? output.left() : output.right(),
    outputStrings: {
      left: {
        en: 'Left (Wing Side)',
        de: 'Links (Flügel-Seite)',
        fr: 'Gauche (Côté Aile)',
        ja: '左 (翼)',
        cn: '左 (翅膀侧)',
        ko: '왼쪽 (날개쪽)'
      },
      right: {
        en: 'Right (Snake Side)',
        de: 'Rechts (Schlangen-Seite)',
        fr: 'Droite (Côté Serpent)',
        ja: '右 (蛇)',
        cn: '右 (蛇侧)',
        ko: '오른쪽 (뱀쪽)'
      }
    }
  }, {
    id: 'P6S Transmission',
    type: 'GainsEffect',
    // CF3 Chelomorph (Wing icon - cleave behind player)
    // D48 Glossomorph (Snake icon - cleave in front of player)
    netRegex: {
      effectId: ['CF3', 'D48']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => {
      // 1st transmission has 11s duration, 2nd has 25s duration
      // in either case, trigger should fire 3s before debuff expires
      return parseFloat(matches.duration) - 3;
    },
    infoText: (_data, matches, output) => {
      return matches.effectId === 'D48' ? output.forwardCleave() : output.backwardCleave();
    },
    outputStrings: {
      forwardCleave: {
        en: 'Front Cleave',
        de: 'Kegel Aoe nach Vorne',
        fr: 'Cleave Avant',
        ja: '口からおくび',
        cn: '前方扇形',
        ko: '전방 부채꼴 장판'
      },
      backwardCleave: {
        en: 'Rear Cleave',
        de: 'Kegel Aoe nach Hinten',
        fr: 'Cleave Arrière',
        ja: '尻からおなら',
        cn: '背后扇形',
        ko: '후방 부채꼴 장판'
      }
    }
  }, {
    id: 'P6S Transmission Instant',
    type: 'GainsEffect',
    // CF3 Chelomorph (Wing icon - cleave behind player)
    // D48 Glossomorph (Snake icon - cleave in front of player)
    netRegex: {
      effectId: ['CF3', 'D48']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, matches, output) => {
      return matches.effectId === 'D48' ? output.forwardCleave() : output.backwardCleave();
    },
    outputStrings: {
      forwardCleave: {
        en: 'Front Cleave, for later',
        de: 'Kegel Aoe nach Vorne, für später',
        fr: 'Cleave Avant, pour après',
        ja: '後で口からおくび',
        cn: '稍后 前方扇形',
        ko: '곧 전방 부채꼴 장판'
      },
      backwardCleave: {
        en: 'Rear Cleave, for later',
        de: 'Kegel Aoe nach Hinten, für später',
        fr: 'Cleave Arrière, pour après',
        ja: '後で尻からおなら',
        cn: '稍后 背后扇形',
        ko: '곧 후방 부채꼴 장판'
      }
    }
  }, {
    id: 'P6S Dark Spheres Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '7880',
      source: 'Hegemone'
    },
    run: (data, matches) => data.darkSpheres.push(matches)
  }, {
    id: 'P6S Cachexia 2 Dark Spheres',
    type: 'StartsUsing',
    netRegex: {
      id: '7880',
      source: 'Hegemone',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      for (const darkSphere of data.darkSpheres) {
        if (data.me === darkSphere.target) return data.poly6SafeSide === undefined ? output.spread() : output.spreadSide({
          dir1: data.poly6SafeSide
        });
        return data.poly6SafeSide === undefined ? output.stack() : output.stackSide({
          dir1: data.poly6SafeSide
        });
      }
    },
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread,
      stack: outputs/* default.stackMarker */.Z.stackMarker,
      spreadSide: {
        en: 'Spread ${dir1}',
        de: 'Verteilen ${dir1}',
        fr: 'Dispersion ${dir1}',
        ja: '散会 ${dir1}',
        cn: '分散 ${dir1}',
        ko: '산개 ${dir1}'
      },
      stackSide: {
        en: 'Stack ${dir1}',
        de: 'Sammeln ${dir1}',
        fr: 'Package ${dir1}',
        ja: '頭割り ${dir1}',
        cn: '分摊 ${dir1}',
        ko: '쉐어 ${dir1}'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Hegemone': 'Hegemone',
      'Parasitos': 'Parasit'
    },
    'replaceText': {
      'Aetherial Exchange': 'Ätherwechsel',
      'Aetheric Polyominoid': 'Äther-Polyomino',
      'Aetheronecrosis': 'Explozelle',
      'Cachexia': 'Cachexia',
      'Chelic Claw': 'Chelische Kralle',
      'Choros Ixou': 'Choros Ixou',
      'Dark Ashes': 'Dunkle Asche',
      'Dark Dome': 'Dunkles Gewölbe',
      'Dark Sphere': 'Dunkle Kugel',
      'Dual Predation': 'Doppelte Prädation',
      'Exchange Of Agonies': 'Wechselschub',
      'Exocleaver': 'Exospalter',
      'Hemitheos\'s Dark IV': 'Hemitheisches Nachtka',
      'Pathogenic Cells': 'Pathogene Zellen',
      'Polyominoid Sigma': 'Äther-Polyomino Σ',
      'Polyominous Dark IV': 'Neka-Polyomino',
      '(?<!Dual )Predation': 'Prädation',
      'Ptera Ixou': 'Ptera Ixou',
      'Reek Havoc': 'Gasausstoß',
      'Synergy': 'Synergie',
      'Transmission': 'Parasitismus',
      'Unholy Darkness': 'Unheiliges Dunkel'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Hegemone': 'Hégémone',
      'Parasitos': 'créature parasite'
    },
    'replaceText': {
      'Aetherial Exchange': 'Changement éthéréen',
      'Aetheric Polyominoid': 'Polyomino éthéré',
      'Aetheronecrosis': 'Cellules magiques actives',
      'Cachexia': 'Cachexie',
      'Chelic Claw': 'Griffe chélique',
      'Choros Ixou': 'Choros Ixou',
      'Dark Ashes': 'Cendres ténébreuses',
      'Dark Dome': 'Dôme ténébreux',
      'Dark Sphere': 'Sphère sombre',
      'Dual Predation': 'Double attaque parasitaire',
      'Exchange Of Agonies': 'Panaché ténébreux',
      'Exocleaver': 'Exo-couperet',
      'Hemitheos\'s Dark IV': 'Giga Ténèbres d\'hémithéos',
      'Pathogenic Cells': 'Souffle de cellules parasites',
      'Polyominoid Sigma': 'Polyomino éthéré Σ',
      'Polyominous Dark IV': 'Polyomino Giga Ténèbres',
      '(?<!Dual )Predation': 'Attaque parasitaire',
      'Ptera Ixou': 'Ptera Ixou',
      'Reek Havoc': 'Exhalaison',
      'Synergy': 'Synergie',
      'Transmission': 'Parasitage',
      'Unholy Darkness': 'Miracle ténébreux'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Hegemone': 'ヘーゲモネー',
      'Parasitos': '寄生生物'
    },
    'replaceText': {
      'Aetherial Exchange': 'エーテルチェンジ',
      'Aetheric Polyominoid': 'エーテル・ポリオミノ',
      'Aetheronecrosis': '魔活細胞',
      'Cachexia': 'カヘキシー',
      'Chelic Claw': '爪撃',
      'Choros Ixou': 'ホロス・イクソス',
      'Dark Ashes': 'ダークアッシュ',
      'Dark Dome': 'ダークドーム',
      'Dark Sphere': 'ダークスフィア',
      'Dual Predation': '甲軟双撃',
      'Exchange Of Agonies': 'チェンジバースト',
      'Exocleaver': 'エクソークリーバー',
      'Hemitheos\'s Dark IV': 'ヘーミテオス・ダージャ',
      'Pathogenic Cells': '軟体細胞流',
      'Polyominoid Sigma': 'エーテル・ポリオミノΣ',
      'Polyominous Dark IV': 'ダージャ・ポリオミノ',
      'Ptera Ixou': 'プテラ・イクソス',
      'Reek Havoc': '噴気',
      'Synergy': 'シュネルギア',
      'Transmission': '寄生',
      'Unholy Darkness': 'ダークホーリー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Hegemone': '赫革摩涅',
      'Parasitos': '寄生生物'
    },
    'replaceText': {
      'Aetherial Exchange': '以太交换',
      'Aetheric Polyominoid': '以太多连方',
      'Aetheronecrosis': '魔活细胞',
      'Cachexia': '恶病质',
      'Chelic Claw': '爪击',
      'Choros Ixou': '寄生之舞',
      'Dark Ashes': '冥灰',
      'Dark Dome': '暗天顶',
      'Dark Sphere': '黑暗球',
      'Dual Predation': '甲软双击',
      'Exchange Of Agonies': '极苦交换',
      'Exocleaver': '外劈',
      'Hemitheos\'s Dark IV': '半神冥暗',
      'Pathogenic Cells': '软体细胞流',
      'Polyominoid Sigma': '以太多连方Σ',
      'Polyominous Dark IV': '多连方冥暗',
      '(?<!Dual )Predation': '双击',
      'Ptera Ixou': '寄生之翼',
      'Reek Havoc': '喷气',
      'Synergy': '协同',
      'Transmission': '寄生传染',
      'Unholy Darkness': '黑暗神圣'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Hegemone': '헤게모네',
      'Parasitos': '기생생물'
    },
    'replaceText': {
      'Aetherial Exchange': '에테르 변환',
      'Aetheric Polyominoid': '에테르 폴리오미노',
      'Aetheronecrosis': '마활세포',
      'Cachexia': '악액질',
      'Chelic Claw': '갈퀴',
      'Choros Ixou': '기생체의 춤',
      'Dark Ashes': '어둠의 잿더미',
      'Dark Dome': '어둠의 반구',
      'Dark Sphere': '어둠의 구체',
      'Dual Predation': '갑각연체 쌍격',
      'Exchange Of Agonies': '변환 폭격',
      'Exocleaver': '외측 살육',
      'Hemitheos\'s Dark IV': '헤미테오스 다쟈',
      'Pathogenic Cells': '연체세포류',
      'Polyominoid Sigma': '에테르 폴리오미노Σ',
      'Polyominous Dark IV': '다쟈 폴리오미노',
      '(?<!Dual )Predation': '연체/갑각 공격',
      'Ptera Ixou': '기생체의 날갯짓',
      'Reek Havoc': '입김',
      'Synergy': '협동 공격',
      'Transmission': '기생',
      'Unholy Darkness': '다크 홀리'
    }
  }]
};
/* harmony default export */ const p6s = (p6s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p6s.txt
const raid_p6s_namespaceObject = "### P6S: Abyssos: The Sixth Circle (Savage)\r\n# -ii 7865 786A 7870 7871 7872 7873 7875 7879 787D 787E 7885 7886 7888 7889 7890 7892 79EB 79EC 7A18\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n9.5 \"--sync--\" StartsUsing { id: \"7860\", source: \"Hegemone\" } window 10,5\r\n14.2 \"Hemitheos's Dark IV\" Ability { id: \"7860\", source: \"Hegemone\" }\r\n28.0 \"Synergy\" Ability { id: [\"7887\", \"788A\"], source: \"Hegemone\" }\r\n35.1 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n42.0 \"Aetheric Polyominoid\" Ability { id: \"7866\", source: \"Hegemone\" } window 15,15\r\n42.0 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n48.6 \"Unholy Darkness\" Ability { id: [\"786D\", \"786E\", \"7891\"], source: \"Hegemone\" }\r\n54.6 \"Polyominous Dark IV\" Ability { id: \"7867\", source: \"Hegemone\" }\r\n54.7 \"Exocleaver 1\" Ability { id: [\"7869\", \"786B\"], source: \"Hegemone\" } window 2,2\r\n56.8 \"Unholy Darkness\" Ability { id: \"7892\", source: \"Hegemone\" }\r\n57.2 \"Exocleaver 2\" Ability { id: [\"7869\", \"786B\"], source: \"Hegemone\" } window 2,2\r\n71.2 \"--sync--\" Ability { id: \"7864\", source: \"Hegemone\" }\r\n71.7 \"#1 Pathogenic Cells\" #Ability { id: \"7865\", source: \"Hegemone\" }\r\n73.6 \"#2 Pathogenic Cells\" #Ability { id: \"7865\", source: \"Hegemone\" }\r\n75.6 \"#3 Pathogenic Cells\" #Ability { id: \"7865\", source: \"Hegemone\" }\r\n77.5 \"#4 Pathogenic Cells\" #Ability { id: \"7865\", source: \"Hegemone\" }\r\n79.5 \"#5 Pathogenic Cells\" #Ability { id: \"7865\", source: \"Hegemone\" }\r\n81.4 \"#6 Pathogenic Cells\" #Ability { id: \"7865\", source: \"Hegemone\" }\r\n83.4 \"#7 Pathogenic Cells\" #Ability { id: \"7865\", source: \"Hegemone\" }\r\n85.3 \"#8 Pathogenic Cells\" #Ability { id: \"7865\", source: \"Hegemone\" }\r\n\r\n91.9 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n97.7 \"Aetherial Exchange\" Ability { id: \"784D\", source: \"Hegemone\" } window 100,30\r\n104.4 \"Exchange Of Agonies\" Ability { id: \"786C\", source: \"Hegemone\" }\r\n111.6 \"Choros Ixou 1\" Ability { id: [\"7881\", \"7882\", \"7883\", \"7884\"], source: \"Hegemone\" }\r\n112.3 \"Unholy Darkness\" Ability { id: [\"786D\", \"786E\", \"7891\"], source: \"Hegemone\" }\r\n114.7 \"Choros Ixou 2\" Ability { id: [\"7881\", \"7882\", \"7883\", \"7884\"], source: \"Hegemone\" }\r\n128.5 \"Synergy\" Ability { id: [\"7887\", \"788A\"], source: \"Hegemone\" }\r\n141.4 \"Hemitheos's Dark IV\" Ability { id: \"7860\", source: \"Hegemone\" } window 30,30\r\n153.2 \"Transmission\" Ability { id: \"7861\", source: \"Hegemone\" }\r\n159.0 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n166.1 \"Choros Ixou 1\" Ability { id: [\"7881\", \"7882\", \"7883\", \"7884\"], source: \"Hegemone\" }\r\n168.0 \"Chelic Claw/Reek Havoc\" Ability { id: [\"79EE\", \"79EF\"], source: \"Parasitos\" }\r\n169.2 \"Choros Ixou 2\" Ability { id: [\"7881\", \"7882\", \"7883\", \"7884\"], source: \"Hegemone\" }\r\n179.0 \"Aetherial Exchange\" Ability { id: \"784D\", source: \"Hegemone\" }\r\n185.7 \"Polyominoid Sigma\" Ability { id: \"7868\", source: \"Hegemone\" } window 30,30\r\n185.7 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n195.3 \"Dark Dome 1\" Ability { id: \"788B\", source: \"Hegemone\" }\r\n200.1 \"Polyominous Dark IV\" Ability { id: \"7867\", source: \"Hegemone\" }\r\n200.1 \"Dark Dome 2\" Ability { id: \"788C\", source: \"Hegemone\" }\r\n204.0 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n209.8 \"Aetherial Exchange\" Ability { id: \"784D\", source: \"Hegemone\" }\r\n216.5 \"Exchange Of Agonies\" Ability { id: \"786C\", source: \"Hegemone\" } window 30,30\r\n224.4 \"Exocleaver 1\" Ability { id: [\"7869\", \"786B\"], source: \"Hegemone\" } window 2,2\r\n224.4 \"Unholy Darkness\" Ability { id: \"7A0F\", source: \"Hegemone\" }\r\n227.0 \"Exocleaver 2\" Ability { id: [\"7869\", \"786B\"], source: \"Hegemone\" } window 2,2\r\n239.3 \"Synergy\" Ability { id: [\"7887\", \"788A\"], source: \"Hegemone\" }\r\n252.2 \"Hemitheos's Dark IV\" Ability { id: \"7860\", source: \"Hegemone\" } window 30,30\r\n262.0 \"Aetherial Exchange\" Ability { id: \"784D\", source: \"Hegemone\" }\r\n268.7 \"Polyominoid Sigma\" Ability { id: \"7868\", source: \"Hegemone\" }\r\n268.7 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n275.3 \"Unholy Darkness\" Ability { id: \"7892\", source: \"Hegemone\" }\r\n282.3 \"Polyominous Dark IV\" Ability { id: \"7867\", source: \"Hegemone\" } window 30,30\r\n287.3 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n294.0 \"Dark Ashes\" Ability { id: \"788D\", source: \"Hegemone\" }\r\n302.0 \"Choros Ixou 1\" Ability { id: [\"7881\", \"7882\", \"7883\", \"7884\"], source: \"Hegemone\" }\r\n303.0 \"Dark Ashes\" Ability { id: \"788E\", source: \"Hegemone\" }\r\n305.1 \"Choros Ixou 2\" Ability { id: [\"7881\", \"7882\", \"7883\", \"7884\"], source: \"Hegemone\" }\r\n311.8 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n317.6 \"Cachexia\" Ability { id: \"7876\", source: \"Hegemone\" } window 30,30\r\n326.6 \"Aetheronecrosis 1\" #Ability { id: \"7877\", source: \"Hegemone\" }\r\n330.6 \"Aetheronecrosis 2\" #Ability { id: \"7877\", source: \"Hegemone\" }\r\n334.6 \"Aetheronecrosis 3\" #Ability { id: \"7877\", source: \"Hegemone\" }\r\n334.8 \"Dual Predation\" Ability { id: \"7878\", source: \"Hegemone\" }\r\n335.8 \"Predation 1\" Ability { id: [\"787A\", \"787B\"], source: \"Hegemone\" }\r\n338.7 \"Aetheronecrosis 4\" #Ability { id: \"7877\", source: \"Hegemone\" }\r\n339.9 \"Predation 2\" Ability { id: [\"787A\", \"787B\"], source: \"Hegemone\" }\r\n343.9 \"Predation 3\" Ability { id: [\"787A\", \"787B\"], source: \"Hegemone\" }\r\n347.9 \"Predation 4\" Ability { id: [\"787A\", \"787B\"], source: \"Hegemone\" }\r\n356.9 \"Ptera Ixou\" Ability { id: \"787C\", source: \"Hegemone\" }\r\n372.2 \"Synergy\" Ability { id: [\"7887\", \"788A\"], source: \"Hegemone\" }\r\n384.3 \"Hemitheos's Dark IV\" Ability { id: \"7860\", source: \"Hegemone\" } window 30,30\r\n395.0 \"Aetheric Polyominoid\" Ability { id: \"7866\", source: \"Hegemone\" }\r\n395.0 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n401.6 \"Dark Sphere\" Ability { id: \"788F\", source: \"Hegemone\" }\r\n407.7 \"Dark Dome 1\" Ability { id: \"788B\", source: \"Hegemone\" }\r\n408.6 \"Polyominous Dark IV\" Ability { id: \"7867\", source: \"Hegemone\" }\r\n412.6 \"Dark Dome 2\" Ability { id: \"788C\", source: \"Hegemone\" }\r\n417.5 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" } window 30,30\r\n423.4 \"Aetherial Exchange\" Ability { id: \"784D\", source: \"Hegemone\" }\r\n430.1 \"Exchange Of Agonies\" Ability { id: \"786C\", source: \"Hegemone\" }\r\n437.3 \"Choros Ixou 1\" Ability { id: [\"7881\", \"7882\", \"7883\", \"7884\"], source: \"Hegemone\" }\r\n437.8 \"Unholy Darkness\" Ability { id: [\"786D\", \"786E\", \"7891\"], source: \"Hegemone\" }\r\n440.2 \"Choros Ixou 2\" Ability { id: [\"7881\", \"7882\", \"7883\", \"7884\"], source: \"Hegemone\" }\r\n449.9 \"Aetherial Exchange\" Ability { id: \"784D\", source: \"Hegemone\" }\r\n456.6 \"Polyominoid Sigma\" Ability { id: \"7868\", source: \"Hegemone\" }\r\n456.6 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n461.2 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n468.3 \"Choros Ixou 1\" Ability { id: [\"7881\", \"7882\", \"7883\", \"7884\"], source: \"Hegemone\" }\r\n469.2 \"Polyominous Dark IV\" Ability { id: \"7867\", source: \"Hegemone\" }\r\n471.4 \"Choros Ixou 2\" Ability { id: [\"7881\", \"7882\", \"7883\", \"7884\"], source: \"Hegemone\" }\r\n485.0 \"Synergy\" Ability { id: [\"7887\", \"788A\"], source: \"Hegemone\" }\r\n497.1 \"Hemitheos's Dark IV\" Ability { id: \"7860\", source: \"Hegemone\" }\r\n503.9 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n509.7 \"Cachexia\" Ability { id: \"7876\", source: \"Hegemone\" }\r\n517.4 \"Transmission\" Ability { id: \"7861\", source: \"Hegemone\" } window 30,30\r\n525.1 \"Aetherial Exchange\" Ability { id: \"784D\", source: \"Hegemone\" }\r\n531.8 \"Polyominoid Sigma\" Ability { id: \"7868\", source: \"Hegemone\" }\r\n531.8 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n537.5 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n545.3 \"Polyominous Dark IV\" Ability { id: \"7867\", source: \"Hegemone\" }\r\n545.4 \"Dark Sphere\" Ability { id: \"7880\", source: \"Hegemone\" }\r\n545.4 \"Ptera Ixou\" Ability { id: \"787C\", source: \"Hegemone\" } window 30,30\r\n545.4 \"Unholy Darkness\" Ability { id: \"787F\", source: \"Hegemone\" }\r\n546.4 \"Chelic Claw/Reek Havoc\" Ability { id: [\"79EE\", \"79EF\"], source: \"Parasitos\" }\r\n551.6 \"--sync--\" Ability { id: \"7A19\", source: \"Hegemone\" }\r\n558.7 \"Aetheric Polyominoid\" Ability { id: \"7866\", source: \"Hegemone\" }\r\n558.7 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n567.3 \"Dark Dome\" Ability { id: \"788B\", source: \"Hegemone\" }\r\n571.7 \"Polyominous Dark IV\" Ability { id: \"7867\", source: \"Hegemone\" }\r\n572.1 \"Dark Dome\" Ability { id: \"788C\", source: \"Hegemone\" }\r\n577.0 \"--sync--\" Ability { id: \"784C\", source: \"Hegemone\" }\r\n583.7 \"Aetheric Polyominoid\" Ability { id: \"7866\", source: \"Hegemone\" }\r\n583.7 \"--sync--\" Ability { id: \"7854\", source: \"Hegemone\" }\r\n592.8 \"Choros Ixou 1\" Ability { id: [\"7881\", \"7882\", \"7883\", \"7884\"], source: \"Hegemone\" }\r\n593.5 \"Polyominous Dark IV\" Ability { id: \"7867\", source: \"Hegemone\" }\r\n595.9 \"Choros Ixou 2\" Ability { id: [\"7881\", \"7882\", \"7883\", \"7884\"], source: \"Hegemone\" }\r\n608.9 \"Synergy\" Ability { id: [\"7887\", \"788A\"], source: \"Hegemone\" }\r\n621.8 \"Hemitheos's Dark IV\" Ability { id: \"7860\", source: \"Hegemone\" }\r\n\r\n# Enrage\r\n631.0 \"--sync--\" StartsUsing { id: \"7893\", source: \"Hegemone\" } window 1000,10\r\n640.7 \"Hemitheos's Dark IV (enrage)\" Ability { id: \"7893\", source: \"Hegemone\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p7n.ts




const p7n_triggerSet = {
  id: 'AbyssosTheSeventhCircle',
  zoneId: zone_id/* default.AbyssosTheSeventhCircle */.Z.AbyssosTheSeventhCircle,
  timelineFile: 'p7n.txt',
  initData: () => {
    return {
      busterTargets: []
    };
  },
  timelineTriggers: [{
    id: 'P7N Burst',
    regex: /Burst/,
    beforeSeconds: 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get towers',
        de: 'Türme nehmen',
        fr: 'Prenez les tours',
        ja: '塔へ',
        cn: '踩塔',
        ko: '기둥 들어가기'
      }
    }
  }],
  triggers: [{
    id: 'P7N Bough Of Attis Out',
    type: 'StartsUsing',
    netRegex: {
      id: '77F9',
      source: 'Agdistis',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'P7N Bough Of Attis In',
    type: 'StartsUsing',
    netRegex: {
      id: '77FE',
      source: 'Agdistis',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'P7N Bough Of Attis Left',
    type: 'StartsUsing',
    netRegex: {
      id: '77FC',
      source: 'Agdistis',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'P7N Bough Of Attis Right',
    type: 'StartsUsing',
    netRegex: {
      id: '77FB',
      source: 'Agdistis',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'P7N Hemitheos Holy Spread',
    type: 'HeadMarker',
    netRegex: {
      id: '0137'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'P7N Hemitheos Glare',
    type: 'StartsUsing',
    netRegex: {
      id: '79FA',
      source: 'Agdistis',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move center when safe',
        de: 'Geh in die Mitte, wenn es sicher ist',
        fr: 'Allez au centre quand il est sûr',
        ja: '安置に入る',
        cn: '安全时去中间',
        ko: '중앙 바닥이 생기면 들어가기'
      }
    }
  }, {
    id: 'P7N Immortals Obol',
    type: 'StartsUsing',
    netRegex: {
      id: '77F5',
      source: 'Agdistis',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get to edge (in circle)',
        de: 'Geh zum Rand (in den Kreisen)',
        fr: 'Allez sur le bord (dans le cercle)',
        ja: '外側の隅へ (円の中)',
        cn: '去边缘 (圆圈中)',
        ko: '구석으로 (원 안으로)'
      }
    }
  }, {
    id: 'P7N Hemitheos Aero II Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '016C'
    },
    run: (data, matches) => data.busterTargets.push(matches.target)
  }, {
    id: 'P7N Hemitheos Aero II Call',
    type: 'HeadMarker',
    netRegex: {
      id: '016C',
      capture: false
    },
    delaySeconds: 0.3,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      if (data.busterTargets.includes(data.me)) return output.markerYou();
      return output.avoid();
    },
    outputStrings: {
      markerYou: outputs/* default.tankCleave */.Z.tankCleave,
      avoid: outputs/* default.avoidTankCleave */.Z.avoidTankCleave
    }
  }, {
    id: 'P7N Hemitheos Aero II Cleanup',
    type: 'HeadMarker',
    netRegex: {
      id: '016C',
      capture: false
    },
    delaySeconds: 5,
    run: data => data.busterTargets = []
  }, {
    id: 'P7N Spark Of Life',
    type: 'StartsUsing',
    netRegex: {
      id: '780B',
      source: 'Agdistis',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'P7N Static Moon',
    type: 'StartsUsing',
    netRegex: {
      id: '7802',
      source: 'Immature Io',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Behemoths',
        de: 'Behemoths ausweichen',
        fr: 'Évitez les Behemoths',
        ja: 'ベヒーモスから離れる',
        cn: '躲避贝爷',
        ko: '베히모스 피하기'
      }
    }
  }, {
    id: 'P7N Stymphalian Strike',
    type: 'StartsUsing',
    netRegex: {
      id: '7803',
      source: 'Immature Stymphalide',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid line dashes',
        de: 'Linien Anstürme ausweichen',
        fr: 'Évitez les ruées en ligne',
        ja: '突進回避',
        cn: '躲避直线冲锋',
        ko: '직선 돌진 피하기'
      }
    }
  }, {
    id: 'P7N Blades Of Attis',
    type: 'StartsUsing',
    netRegex: {
      id: '7805',
      source: 'Agdistis',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Exaflares',
        de: 'Exaflares ausweichen',
        fr: 'Évitez les brasiers',
        ja: 'エクサプレア',
        cn: '躲避地火',
        ko: '엑사플레어 피하기'
      }
    }
  }, {
    id: 'P7N Hemitheos Aero IV',
    type: 'StartsUsing',
    netRegex: {
      id: '7840',
      source: 'Agdistis'
    },
    // The cast time is slightly longer than Arm's Length/Surecast's duration.
    // Don't risk someone being too fast.
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 6,
    response: responses/* Responses.knockback */.n3.knockback('info') // avoid collisions with Forbidden Fruit triggers.
  }],

  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Agdistis': 'Agdistis',
      'Immature Io': 'unreif(?:e|er|es|en) Io',
      'Immature Stymphalide': 'unreif(?:e|er|es|en) Stymphalides'
    },
    'replaceText': {
      'left': 'Links',
      'right': 'Rechts',
      'lines': 'Linien',
      'triangle': 'Dreieck',
      'Blades of Attis': 'Schwertblatt des Attis',
      'Bough of Attis': 'Ast des Attis',
      'Burst': 'Explosion',
      'Forbidden Fruit': 'Frucht des Lebens',
      'Hemitheos\'s Aero II': 'Hemitheisches Windra',
      'Hemitheos\'s Aero IV': 'Hemitheisches Windka',
      'Hemitheos\'s Glare III': 'Hemitheisches Blendga',
      'Hemitheos\'s Holy': 'Hemitheisches Sanctus',
      'Immortal\'s Obol': 'Leitstab des Lebens',
      'Shadow of Attis': 'Lichttropfen des Attis',
      'Spark of Life': 'Schein des Lebens',
      'Static Moon': 'Statischer Mond',
      'Stymphalian Strike': 'Vogelschlag'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Agdistis': 'Agdistis',
      'Immature Io': 'io immature',
      'Immature Stymphalide': 'stymphalide immature'
    },
    'replaceText': {
      'left': 'Gauche',
      'right': 'Droite',
      'lines': 'Ligne',
      'Blades of Attis': 'Lames d\'Attis',
      'Bough of Attis': 'Grandes branches d\'Attis',
      'Burst': 'Explosion',
      'Forbidden Fruit': 'Fruits de la vie',
      'Hemitheos\'s Aero II': 'Extra Vent d\'hémithéos',
      'Hemitheos\'s Aero IV': 'Giga Vent d\'hémithéos',
      'Hemitheos\'s Glare III': 'Méga Chatoiement d\'hémithéos',
      'Hemitheos\'s Holy': 'Miracle d\'hémithéos',
      'Immortal\'s Obol': 'Branche de vie et de mort',
      'Shadow of Attis': 'Rai d\'Attis',
      'Spark of Life': 'Étincelle de vie',
      'Static Moon': 'Lune statique',
      'Stymphalian Strike': 'Assaut stymphalide'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Agdistis': 'アグディスティス',
      'Immature Io': 'イマチュア・イーオー',
      'Immature Stymphalide': 'イマチュア・ステュムパリデス'
    },
    'replaceText': {
      'Blades of Attis': 'アッティスの刃葉',
      'Bough of Attis': 'アッティスの巨枝',
      'Burst': '爆発',
      'Forbidden Fruit': '生命の果実',
      'Hemitheos\'s Aero II': 'ヘーミテオス・エアロラ',
      'Hemitheos\'s Aero IV': 'ヘーミテオス・エアロジャ',
      'Hemitheos\'s Glare III': 'ヘーミテオス・グレアガ',
      'Hemitheos\'s Holy': 'ヘーミテオス・ホーリー',
      'Immortal\'s Obol': '生滅の導枝',
      'Shadow of Attis': 'アッティスの光雫',
      'Spark of Life': '生命の光芒',
      'Static Moon': 'スタティックムーン',
      'Stymphalian Strike': 'バードストライク'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Agdistis': '阿格狄斯提斯',
      'Immature Io': '未成熟的伊娥',
      'Immature Stymphalide': '未成熟的铁爪怪鸟'
    },
    'replaceText': {
      'left': '左',
      'right': '右',
      'lines': '直线',
      'triangle': '三角',
      'Blades of Attis': '阿提斯的叶刃',
      'Bough of Attis': '阿提斯的巨枝',
      'Burst': '爆炸',
      'Forbidden Fruit': '生命之果',
      'Hemitheos\'s Aero II': '半神烈风',
      'Hemitheos\'s Aero IV': '半神飙风',
      'Hemitheos\'s Glare III': '半神闪灼',
      'Hemitheos\'s Holy': '半神神圣',
      'Immortal\'s Obol': '不灭者的导枝',
      'Shadow of Attis': '阿提斯的光露',
      'Spark of Life': '生命的光芒',
      'Static Moon': '静电之月',
      'Stymphalian Strike': '怪鸟强袭'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Agdistis': '아그디스티스',
      'Immature Io': '덜 자란 이오',
      'Immature Stymphalide': '덜 자란 스팀팔로스 괴조'
    },
    'replaceText': {
      'left': '왼',
      'right': '오른',
      'lines': '직선',
      'triangle': '삼각',
      'Blades of Attis': '아티스의 칼날잎',
      'Bough of Attis': '아티스의 큰가지',
      'Burst': '폭발',
      'Forbidden Fruit': '생명의 열매',
      'Hemitheos\'s Aero II': '헤미테오스 에어로라',
      'Hemitheos\'s Aero IV': '헤미테오스 에어로쟈',
      'Hemitheos\'s Glare III': '헤미테오스 글레어가',
      'Hemitheos\'s Holy': '헤미테오스 홀리',
      'Immortal\'s Obol': '생멸의 가지',
      'Shadow of Attis': '아티스의 빛방울',
      'Spark of Life': '생명의 광망',
      'Static Moon': '정전기 달',
      'Stymphalian Strike': '괴조 충돌'
    }
  }]
};
/* harmony default export */ const p7n = (p7n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p7n.txt
const raid_p7n_namespaceObject = "### P7N: Abyssos: The Seventh Circle\r\n#\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n# -ii 77F6 77F7 77FA 77FD 77FF 7800 7804 7806 7807 780A 783E 7841\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n3.0 \"--sync--\" Ability { id: \"78E3\", source: \"Agdistis\" } window 3,0\r\n15.8 \"Bough of Attis (out)\" Ability { id: \"77F9\", source: \"Agdistis\" } window 16,5\r\n23.4 \"Bough of Attis (left/right)\" Ability { id: [\"77FB\", \"77FC\"], source: \"Agdistis\" }\r\n37.6 \"Hemitheos's Holy\" Ability { id: \"7808\", source: \"Agdistis\" }\r\n44.0 \"Hemitheos's Glare III\" Ability { id: \"77F8\", source: \"Agdistis\" }\r\n54.1 \"Bough of Attis (in)\" Ability { id: \"77FE\", source: \"Agdistis\" }\r\n64.5 \"Bough of Attis (out)\" Ability { id: \"77F9\", source: \"Agdistis\" }\r\n72.1 \"Bough of Attis (left/right)\" Ability { id: [\"77FB\", \"77FC\"], source: \"Agdistis\" }\r\n81.9 \"Immortal's Obol\" Ability { id: \"77F5\", source: \"Agdistis\" }\r\n102.0 \"Bough of Attis (out)\" Ability { id: \"77F9\", source: \"Agdistis\" }\r\n109.6 \"Bough of Attis (left/right)\" Ability { id: [\"77FB\", \"77FC\"], source: \"Agdistis\" }\r\n119.7 \"Hemitheos's Aero II\" Ability { id: \"7809\", source: \"Agdistis\" } window 215,10\r\n128.9 \"Spark of Life\" Ability { id: \"780B\", source: \"Agdistis\" }\r\n143.2 \"Forbidden Fruit\" Ability { id: \"7801\", source: \"Agdistis\" }\r\n154.9 \"Static Moon\" Ability { id: \"7802\", source: \"Immature Io\" } window 155,10\r\n166.9 \"Blades of Attis (lines)\" Ability { id: \"7805\", source: \"Agdistis\" }\r\n184.1 \"Forbidden Fruit\" Ability { id: \"7801\", source: \"Agdistis\" }\r\n195.8 \"Stymphalian Strike\" Ability { id: \"7803\", source: \"Immature Stymphalide\" } window 50,50\r\n216.9 \"Hemitheos's Glare III\" Ability { id: \"79FA\", source: \"Agdistis\" }\r\n224.5 \"Blades of Attis (triangle)\" Ability { id: \"7805\", source: \"Agdistis\" }\r\n238.5 \"Bough of Attis (out)\" Ability { id: \"77F9\", source: \"Agdistis\" }\r\n246.1 \"Bough of Attis (left/right)\" Ability { id: \"77FB\", source: \"Agdistis\" }\r\n\r\n# Forbidden Fruit pre-cast\r\n249.5 \"--sync--\" StartsUsing { id: \"7800\", source: \"Agdistis\" } window 30,30 jump 400\r\n# Hemitheos' Holy pre-cast\r\n250.6 \"--sync--\" StartsUsing { id: \"7807\", source: \"Agdistis\" } window 30,30 jump 1000\r\n258.2 \"Forbidden Fruit?\"\r\n260.4 \"Hemitheos's Holy?\"\r\n266.8 \"Hemitheos's Glare III?\"\r\n270.3 \"Static Moon?\"\r\n270.3 \"Hemitheos's Holy?\"\r\n276.9 \"Bough of Attis?\"\r\n280.1 \"Immortal's Obol?\"\r\n287.3 \"Bough of Attis?\"\r\n\r\n\r\n# Forbidden Fruit block\r\n400.0 \"--sync--\" StartsUsing { id: \"7800\", source: \"Agdistis\" }\r\n408.7 \"Forbidden Fruit\" Ability { id: \"7801\", source: \"Agdistis\" }\r\n420.8 \"Static Moon\" Ability { id: \"7802\", source: \"Immature Io\" }\r\n420.8 \"Hemitheos's Holy\" Ability { id: \"7808\", source: \"Agdistis\" }\r\n430.6 \"Immortal's Obol\" Ability { id: \"77F5\", source: \"Agdistis\" }\r\n450.9 \"Forbidden Fruit\" Ability { id: \"7801\", source: \"Agdistis\" }\r\n464.3 \"Bough of Attis (in)\" Ability { id: \"77FE\", source: \"Agdistis\" }\r\n465.7 \"Static Moon\" Ability { id: \"7802\", source: \"Immature Io\" }\r\n475.9 \"Hemitheos's Aero II\" Ability { id: \"7809\", source: \"Agdistis\" } window 30,30\r\n489.2 \"Forbidden Fruit\" Ability { id: \"7801\", source: \"Agdistis\" }\r\n492.3 \"Shadow of Attis\" Ability { id: \"783C\", source: \"Agdistis\" }\r\n500.7 \"Static Moon/Stymphalian Strike\" Ability { id: [\"7802\", \"7803\"], source: [\"Immature Io\", \"Immature Stymphalide\"] }\r\n505.4 \"Burst\" Ability { id: \"783D\", source: \"Agdistis\" }\r\n513.6 \"Bough of Attis (out)\" Ability { id: \"77F9\", source: \"Agdistis\" }\r\n521.2 \"Bough of Attis (left/right)\" Ability { id: [\"77FB\", \"77FC\"], source: \"Agdistis\" }\r\n530.4 \"Spark of Life\" Ability { id: \"780B\", source: \"Agdistis\" }\r\n539.5 \"Spark of Life\" Ability { id: \"780B\", source: \"Agdistis\" }\r\n548.6 \"Spark of Life\" Ability { id: \"780B\", source: \"Agdistis\" }\r\n563.8 \"Forbidden Fruit\" Ability { id: \"7801\", source: \"Agdistis\" }\r\n576.9 \"Hemitheos's Aero IV\" Ability { id: \"7840\", source: \"Agdistis\" } window 30,30\r\n580.5 \"Stymphalian Strike\" Ability { id: \"7803\", source: \"Immature Stymphalide\" }\r\n580.5 \"Static Moon\" Ability { id: \"7802\", source: \"Immature Io\" }\r\n588.2 \"Blades of Attis (lines)\" Ability { id: \"7805\", source: \"Agdistis\" }\r\n599.5 \"Hemitheos's Holy\" Ability { id: \"7808\", source: \"Agdistis\" }\r\n607.8 \"Spark of Life\" Ability { id: \"780B\", source: \"Agdistis\" }\r\n616.9 \"Hemitheos's Aero II\" Ability { id: \"7809\", source: \"Agdistis\" }\r\n636.1 \"Hemitheos's Glare III\" Ability { id: \"79FA\", source: \"Agdistis\" } window 30,30\r\n643.7 \"Blades of Attis (triangle)\" Ability { id: \"7805\", source: \"Agdistis\" }\r\n658.0 \"Bough of Attis (out)\" Ability { id: \"77F9\", source: \"Agdistis\" }\r\n665.6 \"Bough of Attis (left/right)\" Ability { id: [\"77FB\", \"77FC\"], source: \"Agdistis\" }\r\n\r\n669.1 \"--sync--\" StartsUsing { id: \"7800\", source: \"Agdistis\" } window 30,30 jump 400\r\n670.2 \"--sync--\" StartsUsing { id: \"7807\", source: \"Agdistis\" } window 30,30 jump 1000\r\n677.8 \"Forbidden Fruit?\"\r\n680.0 \"Hemitheos's Holy?\"\r\n686.4 \"Hemitheos's Glare III?\"\r\n689.9 \"Static Moon?\"\r\n689.9 \"Hemitheos's Holy?\"\r\n696.5 \"Bough of Attis?\"\r\n699.7 \"Immortal's Obol?\"\r\n706.9 \"Bough of Attis?\"\r\n\r\n\r\n# Hemitheos' Holy block\r\n1000.0 \"--sync--\" StartsUsing { id: \"7807\", source: \"Agdistis\" }\r\n1009.8 \"Hemitheos's Holy\" Ability { id: \"7808\", source: \"Agdistis\" }\r\n1016.2 \"Hemitheos's Glare III\" Ability { id: \"77F8\", source: \"Agdistis\" } window 30,30\r\n1026.3 \"Bough of Attis (in)\" Ability { id: \"77FE\", source: \"Agdistis\" }\r\n1036.7 \"Bough of Attis (out)\" Ability { id: \"77F9\", source: \"Agdistis\" }\r\n1044.3 \"Bough of Attis (left/right)\" Ability { id: [\"77FB\", \"77FC\"], source: \"Agdistis\" }\r\n1054.1 \"Immortal's Obol\" Ability { id: \"77F5\", source: \"Agdistis\" } window 30,30\r\n1074.2 \"Bough of Attis (out)\" Ability { id: \"77F9\", source: \"Agdistis\" }\r\n1081.8 \"Bough of Attis (left/right)\" Ability { id: [\"77FB\", \"77FC\"], source: \"Agdistis\" }\r\n1091.9 \"Hemitheos's Aero II\" Ability { id: \"7809\", source: \"Agdistis\" } window 30,30\r\n1101.1 \"Spark of Life\" Ability { id: \"780B\", source: \"Agdistis\" }\r\n1115.5 \"Forbidden Fruit\" Ability { id: \"7801\", source: \"Agdistis\" }\r\n1127.2 \"Static Moon\" Ability { id: \"7802\", source: \"Immature Io\" }\r\n1139.2 \"Blades of Attis\" Ability { id: \"7805\", source: \"Agdistis\" }\r\n1156.9 \"Forbidden Fruit\" Ability { id: \"7801\", source: \"Agdistis\" }\r\n1168.6 \"Stymphalian Strike\" Ability { id: \"7803\", source: \"Immature Stymphalide\" }\r\n1189.8 \"Hemitheos's Glare III\" Ability { id: \"79FA\", source: \"Agdistis\" } window 30,30\r\n1197.4 \"Blades of Attis\" Ability { id: \"7805\", source: \"Agdistis\" }\r\n1211.7 \"Bough of Attis (out)\" Ability { id: \"77F9\", source: \"Agdistis\" }\r\n1219.3 \"Bough of Attis (left/right)\" Ability { id: [\"77FB\", \"77FC\"], source: \"Agdistis\" }\r\n\r\n1222.5 \"--sync--\" StartsUsing { id: \"7800\", source: \"Agdistis\" } window 30,30 jump 400\r\n1223.6 \"--sync--\" StartsUsing { id: \"7807\", source: \"Agdistis\" } window 30,30 jump 1000\r\n1231.2 \"Forbidden Fruit?\"\r\n1233.4 \"Hemitheos's Holy?\"\r\n1239.8 \"Hemitheos's Glare III?\"\r\n1243.3 \"Static Moon?\"\r\n1243.3 \"Hemitheos's Holy?\"\r\n1249.9 \"Bough of Attis?\"\r\n1253.1 \"Immortal's Obol?\"\r\n1260.3 \"Bough of Attis?\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p7s.ts






// TODO: Tether locations, and/or additional egg locations

// Due to changes introduced in patch 5.2, overhead markers now have a random offset
// added to their ID. This offset currently appears to be set per instance, so
// we can determine what it is from the first overhead marker we see.
// The first 1B marker in the encounter is an Hemitheos's Holy III stack marker (013E).
const p7s_firstHeadmarker = parseInt('013E', 16);
const p7s_getHeadmarkerId = (data, matches) => {
  // If we naively just check !data.decOffset and leave it, it breaks if the first marker is 013E.
  // (This makes the offset 0, and !0 is true.)
  if (typeof data.decOffset === 'undefined') data.decOffset = parseInt(matches.id, 16) - p7s_firstHeadmarker;
  // The leading zeroes are stripped when converting back to string, so we re-add them here.
  // Fortunately, we don't have to worry about whether or not this is robust,
  // since we know all the IDs that will be present in the encounter.
  return (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase().padStart(4, '0');
};

// Calculate combatant position in an all 8 cards/intercards
const matchedPositionTo8Dir = combatant => {
  // Positions are moved up 100 and right 100
  const y = combatant.PosY - 100;
  const x = combatant.PosX - 100;

  // Majority of mechanics center around three circles:
  // NW at 0, NE at 2, South at 5
  // Map NW = 0, N = 1, ..., W = 7

  return Math.round(5 - 4 * Math.atan2(x, y) / Math.PI) % 8;
};

// effect ids for inviolate purgation
const p7s_effectIdToOutputStringKey = {
  'CEE': 'spread',
  'D3F': 'spread',
  'D40': 'spread',
  'D41': 'spread',
  'CEF': 'stack',
  'D42': 'stack',
  'D43': 'stack',
  'D44': 'stack'
};
const p7s_triggerSet = {
  id: 'AbyssosTheSeventhCircleSavage',
  zoneId: zone_id/* default.AbyssosTheSeventhCircleSavage */.Z.AbyssosTheSeventhCircleSavage,
  timelineFile: 'p7s.txt',
  initData: () => ({
    fruitCount: 0,
    rootsCount: 0,
    tetherCollect: [],
    purgationDebuffs: ['stack', 'stack', 'stack', 'stack'],
    purgationDebuffCount: 0,
    purgationEffectIndex: 0
  }),
  triggers: [{
    id: 'P7S Headmarker Tracker',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.decOffset === undefined,
    // Unconditionally set the first headmarker here so that future triggers are conditional.
    run: (data, matches) => {
      p7s_getHeadmarkerId(data, matches);
    }
  }, {
    id: 'P7S Egg Tracker',
    // Collects combatantData of the eggs
    // combatant.BNpcNameID Mapping:
    //   11375 => Immature Io
    //   11376 => Immature Stymphalide
    //   11377 => Immature Minotaur
    // unhatchedEggs Mapping:
    //   0-5 are Minotaurs
    //   6-9 are Birds
    //   10-12 are Ios
    type: 'Ability',
    netRegex: {
      id: '7811',
      source: 'Agdistis',
      capture: false
    },
    preRun: data => data.fruitCount = data.fruitCount + 1,
    delaySeconds: 0.5,
    promise: async data => {
      const fruitLocaleNames = {
        en: 'Forbidden Fruit',
        de: 'Frucht des Lebens',
        fr: 'Fruits de la vie',
        ja: '生命の果実',
        cn: '生命之果',
        ko: '생명의 열매'
      };

      // Select the Forbidden Fruits
      const combatantNameFruits = [fruitLocaleNames[data.parserLang] ?? fruitLocaleNames['en']];
      const combatantData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        names: combatantNameFruits
      });
      // if we could not retrieve combatant data, the
      // trigger will not work, so just resume promise here
      if (combatantData === null) {
        console.error(`Forbidden Fruit: null data`);
        return;
      }
      const combatantDataLength = combatantData.combatants.length;
      if (combatantDataLength < 13) {
        console.error(`Forbidden Fruit: expected at least 13 combatants got ${combatantDataLength}`);
        return;
      }

      // Sort the combatants for parsing its role in the encounter
      const sortCombatants = (a, b) => (a.ID ?? 0) - (b.ID ?? 0);
      const sortedCombatantData = combatantData.combatants.sort(sortCombatants);
      data.unhatchedEggs = sortedCombatantData;
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        left: outputs/* default.left */.Z.left,
        right: outputs/* default.right */.Z.right,
        south: outputs/* default.south */.Z.south,
        twoPlatforms: {
          en: '${platform1} / ${platform2}',
          de: '${platform1} / ${platform2}',
          fr: '${platform1} / ${platform2}',
          ja: '${platform1} / ${platform2}',
          cn: '${platform1} / ${platform2}',
          ko: '${platform1} / ${platform2}'
        },
        orientation: {
          en: 'Line Bull: ${location}',
          de: 'Bullen-Linie: ${location}',
          fr: 'Taureau Ligne : ${location}',
          ja: '線付き牛: ${location}',
          cn: '连线牛: ${location}',
          ko: '줄 달린 소: ${location}'
        },
        famineOrientation: {
          en: 'Minotaurs without Bird: ${location}',
          de: 'Minotauren ohne Vögel: ${location}',
          fr: 'Minotaure sans oiseau : ${location}',
          ja: 'ミノがある場所: ${location}',
          cn: '无鸟牛头人: ${location}',
          ko: '새 없는 곳: ${location}'
        },
        deathOrientation: {
          en: 'Lightning Bull: ${location}',
          de: 'Blitz-Bulle: ${location}',
          fr: 'Taureau éclair : ${location}',
          ja: '線付いてない牛: ${location}',
          cn: '钢铁牛: ${location}',
          ko: '줄 안달린 소: ${location}'
        },
        warOrientation: {
          en: 'Bird with Minotaurs: ${location}',
          de: 'Vögel mit Minotauren : ${location}',
          fr: 'Oiseau sans Minotaure : ${location}',
          ja: 'ミノと鳥: ${location}',
          cn: '有鸟牛头人: ${location}',
          ko: '새 + 미노타우로스: ${location}'
        }
      };

      // Map of dirs to Platform locations
      // Note: Eggs may spawn in additional cardinals/intercardinals
      const dirToPlatform = {
        0: 'left',
        2: 'right',
        3: 'right',
        5: 'south',
        7: 'left'
      };

      // Platforms array used to filter for new platforms
      const platforms = ['right', 'left', 'south'];
      if (data.fruitCount === 1) {
        // Find location of the north-most bird
        // Forbidden Fruit 1 uses last two birds
        if (data.unhatchedEggs === undefined || data.unhatchedEggs[8] === undefined || data.unhatchedEggs[9] === undefined) {
          console.error(`Forbidden Fruit ${data.fruitCount}: Missing egg data.`);
          return;
        }
        const bird1 = data.unhatchedEggs[8];
        const bird2 = data.unhatchedEggs[9];

        // Lower PosY = more north
        const northBird = bird1.PosY < bird2.PosY ? bird1 : bird2;

        // Check north bird's side
        if (northBird.PosX < 100) return {
          alertText: output.left()
        };
        return {
          alertText: output.right()
        };
      }
      if (data.fruitCount === 4 || data.fruitCount === 6) {
        // Check where bull is
        // Forbidden Fruit 4 and 6 use last bull
        if (data.unhatchedEggs === undefined || data.unhatchedEggs[12] === undefined) {
          console.error(`Forbidden Fruit ${data.fruitCount}: Missing egg data.`);
          return;
        }
        const bullDir = matchedPositionTo8Dir(data.unhatchedEggs[12]);
        const platform = dirToPlatform[bullDir];
        if (data.fruitCount === 4) {
          // Call out orientation based on bull's platform
          if (platform !== undefined) return {
            infoText: output.orientation({
              location: output[platform]()
            })
          };
        }
        if (data.fruitCount === 6) {
          // Callout where bull is not
          // Remove platform from platforms
          const newPlatforms = platforms.filter(val => val !== platform);
          if (newPlatforms.length === 2) {
            const safePlatform1 = newPlatforms[0];
            const safePlatform2 = newPlatforms[1];
            if (safePlatform1 !== undefined && safePlatform2 !== undefined) return {
              infoText: output.twoPlatforms({
                platform1: output[safePlatform1](),
                platform2: output[safePlatform2]()
              })
            };
          }
        }
        console.error(`Forbidden Fruit ${data.fruitCount}: Invalid positions.`);
      }
      if (data.fruitCount === 10) {
        // Check where minotaurs are to determine middle bird
        // Forbidden Fruit 10 uses last two minotaurs
        if (data.unhatchedEggs === undefined || data.unhatchedEggs[4] === undefined || data.unhatchedEggs[5] === undefined) {
          console.error(`Forbidden Fruit ${data.fruitCount}: Missing egg data.`);
          return;
        }
        const minotaurDir1 = matchedPositionTo8Dir(data.unhatchedEggs[4]);
        const minotaurDir2 = matchedPositionTo8Dir(data.unhatchedEggs[5]);

        // Return if received bad data
        const validDirs = [1, 4, 6];
        if (!validDirs.includes(minotaurDir1) || !validDirs.includes(minotaurDir2)) {
          console.error(`Forbidden Fruit ${data.fruitCount}: Expected minotaurs at 1, 4, or 6. Got ${minotaurDir1} and ${minotaurDir2}.`);
          return;
        }

        // Add the two positions to calculate platform between
        // Minotaurs spawn at dirs 1 (N), 4 (SE), or 6 (SW)
        const bridgeDirsToPlatform = {
          5: 'right',
          // N + SE
          7: 'left',
          // N + SW
          10: 'south' // SE + SW
        };

        const platform = bridgeDirsToPlatform[minotaurDir1 + minotaurDir2];
        if (platform !== undefined) return {
          infoText: output.warOrientation({
            location: output[platform]()
          })
        };
      }
      if (data.fruitCount > 6 && data.fruitCount < 10) {
        // Check each location for bird, call out where there is no bird
        // Forbidden Fruit 7 - 10 use last two birds
        if (data.unhatchedEggs === undefined || data.unhatchedEggs[8] === undefined || data.unhatchedEggs[9] === undefined) {
          console.error(`Forbidden Fruit ${data.fruitCount}: Missing egg data.`);
          return;
        }
        const birdDir1 = matchedPositionTo8Dir(data.unhatchedEggs[8]);
        const birdDir2 = matchedPositionTo8Dir(data.unhatchedEggs[9]);
        const birdPlatform1 = dirToPlatform[birdDir1];
        const birdPlatform2 = dirToPlatform[birdDir2];

        // Remove platform from platforms
        const newPlatforms = platforms.filter(val => val !== birdPlatform1 && val !== birdPlatform2);
        if (newPlatforms.length === 1) {
          const platform = newPlatforms[0];
          if (platform !== undefined) {
            switch (data.fruitCount) {
              case 7:
                return {
                  infoText: output[platform]()
                };
              case 8:
                return {
                  infoText: output.famineOrientation({
                    location: output[platform]()
                  })
                };
              case 9:
                return {
                  infoText: output.deathOrientation({
                    location: output[platform]()
                  })
                };
            }
          }
          console.error(`Forbidden Fruit ${data.fruitCount}: Invalid positions.`);
        }
      }
    }
  }, {
    id: 'P7S Hemitheos\'s Holy III Healer Groups',
    type: 'HeadMarker',
    netRegex: {},
    suppressSeconds: 1,
    infoText: (data, matches, output) => {
      const correctedMatch = p7s_getHeadmarkerId(data, matches);
      if (correctedMatch === '013E') return output.healerGroups();
    },
    outputStrings: {
      healerGroups: outputs/* default.healerGroups */.Z.healerGroups
    }
  }, {
    id: 'P7S Condensed Aero II',
    type: 'StartsUsing',
    netRegex: {
      id: '7836',
      source: 'Agdistis'
    },
    response: responses/* Responses.sharedTankBuster */.n3.sharedTankBuster()
  }, {
    id: 'P7S Dispersed Aero II',
    type: 'StartsUsing',
    netRegex: {
      id: '7835',
      source: 'Agdistis',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Split Tankbusters',
        de: 'getrennte Tankbuster',
        fr: 'Séparez des Tankbusters',
        ja: '2人同時タンク強攻撃',
        cn: '分散死刑',
        ko: '따로맞는 탱버'
      }
    }
  }, {
    id: 'P7S Bough of Attis Left Arrows',
    type: 'StartsUsing',
    netRegex: {
      id: '7824',
      source: 'Agdistis',
      capture: false
    },
    response: responses/* Responses.goLeft */.n3.goLeft()
  }, {
    id: 'P7S Bough of Attis Right Arrows',
    type: 'StartsUsing',
    netRegex: {
      id: '7823',
      source: 'Agdistis',
      capture: false
    },
    response: responses/* Responses.goRight */.n3.goRight()
  }, {
    id: 'P7S Roots of Attis 3',
    type: 'StartsUsing',
    netRegex: {
      id: '780E',
      source: 'Agdistis',
      capture: false
    },
    condition: data => data.rootsCount === 2,
    infoText: (_data, _matches, output) => output.baitSoon(),
    outputStrings: {
      baitSoon: {
        en: 'Bait on Empty Platform Soon',
        de: 'Bald auf freier Plattform ködern',
        fr: 'Déposez sur une plateforme vide bientôt',
        ja: '果実がない空きの円盤へ移動',
        cn: '移动到空平台',
        ko: '빈 플랫폼에서 장판 유도 준비'
      }
    }
  }, {
    id: 'P7S Roots of Attis 2',
    type: 'StartsUsing',
    netRegex: {
      id: '780E',
      source: 'Agdistis',
      capture: false
    },
    condition: data => data.rootsCount === 1,
    infoText: (_data, _matches, output) => output.separateHealerGroups(),
    run: data => data.rootsCount = data.rootsCount + 1,
    outputStrings: {
      separateHealerGroups: {
        en: 'Healer Group Platforms',
        de: 'Heiler-Gruppen Plattformen',
        fr: 'Groupes heals sur les plateformes',
        ja: '円盤の内でヒーラーと頭割り',
        cn: '治疗分组平台',
        ko: '힐러 그룹별로 플랫폼'
      }
    }
  }, {
    // First breaks north bridge for upcoming South Knockback Spreads
    // Second breaks remaining bridges, Separate Healer Groups
    // Third breaks all bridges, Bait on Empty Platform
    id: 'P7S Roots of Attis 1',
    type: 'StartsUsing',
    netRegex: {
      id: '780E',
      source: 'Agdistis',
      capture: false
    },
    condition: data => data.rootsCount === 0,
    run: data => data.rootsCount = data.rootsCount + 1
  }, {
    id: 'P7S Hemitheos\'s Aero IV',
    type: 'StartsUsing',
    netRegex: {
      id: '7A0B',
      source: 'Agdistis',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'P7S Immature Stymphalide Tether',
    type: 'Tether',
    netRegex: {
      id: '0011',
      source: 'Immature Stymphalide',
      capture: false
    },
    // ~9s between tether and Bronze Bellows (no cast) in all cases.
    delaySeconds: 4,
    // Just give this to everyone.  People in towers or elsewhere can be safe.
    suppressSeconds: 1,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'P7S Spark of Life',
    type: 'StartsUsing',
    netRegex: {
      id: '7839',
      source: 'Agdistis',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'P7S Inviolate Bonds',
    type: 'GainsEffect',
    // CEC/D45 = Inviolate Winds
    // CED/D56 = Holy Bonds
    netRegex: {
      effectId: ['CEC', 'D45']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 20,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        stackThenSpread: outputs/* default.stackThenSpread */.Z.stackThenSpread,
        spreadThenStack: outputs/* default.spreadThenStack */.Z.spreadThenStack
      };

      // Store debuff for reminders
      data.bondsDebuff = matches.effectId === 'CEC' ? 'spread' : 'stackMarker';
      const longTimer = parseFloat(matches.duration) > 9;
      if (longTimer) return {
        infoText: output.stackThenSpread()
      };
      return {
        infoText: output.spreadThenStack()
      };
    }
  }, {
    id: 'P7S Forbidden Fruit 4 and Harvest Tethers',
    // 0001 Immature Minotaur Spike Tether
    // 0006 Immature Io (Bull) Tether
    // 0039 Immature Minotaur Tether
    // 0011 Immature Stymphalide (Bird) Tether
    // Forbidden Fruit 4: 4 Bull Tethers, 2 Minotaur Tethers, 1 Non-tethered Minotaur
    // Famine: 4 Minotaur Tethers, 2 Non-tethered Minotaurs, 2 Static Birds
    // Death: 2 Bulls with Tethers, 1 Bull casting Puddle AoE, 2 Static Birds
    // War: 4 Bull Tethers, 2 Minotaur Tethers, 2 Bird Tethers
    // TODO: Get locations with OverlayPlugin via X, Y and bird headings?
    type: 'Tether',
    netRegex: {
      id: ['0001', '0006', '0039', '0011']
    },
    condition: data => !data.stopTethers,
    preRun: (data, matches) => data.tetherCollect.push(matches.target),
    delaySeconds: 0.1,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        bullTether: {
          en: 'Bull Tether (Line AoE)',
          de: 'Stier-Verbindung (Linien AoE)',
          fr: 'Lien Taureau (AoE en ligne)',
          ja: '牛から直線',
          cn: '牛连线 (直线AOE)',
          ko: '소 (직선 장판)'
        },
        deathBullTether: {
          en: 'Bull Tether (Line AoE)',
          de: 'Stier-Verbindung (Linien AoE)',
          fr: 'Lien Taureau (AoE en ligne)',
          ja: '牛から直線',
          cn: '牛连线 (直线AOE)',
          ko: '소 (직선 장판)'
        },
        warBullTether: {
          en: 'Bull Tether (Line AoE)',
          de: 'Stier-Verbindung (Linien AoE)',
          fr: 'Lien Taureau (AoE en ligne)',
          ja: '牛から直線',
          cn: '牛连线 (直线AOE)',
          ko: '소 (직선 장판)'
        },
        minotaurTether: {
          en: 'Minotaur Tether (Big Cleave)',
          de: 'Minotaurus-Verbindung (Große Kegel-AoE)',
          fr: 'Lien Minotaure (Gros Cleave)',
          ja: 'ミノから扇',
          cn: '牛头人连线 (大顺劈)',
          ko: '미노타우로스 (부채꼴 장판)'
        },
        famineMinotaurTether: {
          en: 'Cross Minotaur Tethers (Big Cleave)',
          de: 'Überkreuze Minotaurus-Verbindung (Große Kegel-AoE)',
          fr: 'Lien Minotaure en croix (Gros Cleave)',
          ja: 'ミノからの扇を交える',
          cn: '交叉牛头人连线 (大顺劈)',
          ko: '미노타우로스 선 교차시키기 (부채꼴 장판)'
        },
        warMinotaurTether: {
          en: 'Minotaur Tether (Big Cleave)',
          de: 'Minotaurus-Verbindung (Große Kegel-AoE)',
          fr: 'Lien Minotaure (Gros Cleave)',
          ja: 'ミノから扇',
          cn: '牛头人连线 (大顺劈)',
          ko: '미노타우로스 (부채꼴 장판)'
        },
        warBirdTether: {
          en: 'Bird Tether',
          de: 'Vogel-Verbindung',
          fr: 'Lien Oiseau',
          ja: '鳥から線',
          cn: '鸟连线',
          ko: '새'
        },
        noTether: {
          en: 'No Tether, Bait Minotaur Cleave (Middle)',
          de: 'Keine Verbindung, Minotaurus-Verbindung ködern (Mitte)',
          fr: 'Aucun lien, encaissez le cleave du Minotaure (Milieu)',
          ja: '線なし、中央で扇を誘導',
          cn: '无连线，诱导牛头人顺劈 (中间)',
          ko: '선 없음, 미노타우로스 유도 (중앙)'
        },
        famineNoTether: {
          en: 'No Tether, Bait Minotaur Cleave',
          de: 'Keine Verbindung, Minotaurus-Verbindung ködern',
          fr: 'Aucun lien, encaissez le cleave du Minotaure',
          ja: '線なし、ミノからの扇を誘導',
          cn: '无连线，诱导牛头人顺劈',
          ko: '선 없음, 미노타우로스 유도'
        }
      };
      if (data.me === matches.target) {
        // Bull Tethers
        if (matches.id === '0006') {
          if (data.tetherCollectPhase === 'death') return {
            infoText: output.deathBullTether()
          };
          if (data.tetherCollectPhase === 'war') return {
            infoText: output.warBullTether()
          };
          return {
            infoText: output.bullTether()
          };
        }

        // Minotaur Tethers
        if (matches.id === '0001' || matches.id === '0039') {
          if (data.tetherCollectPhase === 'famine') return {
            infoText: output.famineMinotaurTether()
          };
          if (data.tetherCollectPhase === 'war') return {
            infoText: output.warMinotaurTether()
          };
          return {
            infoText: output.minotaurTether()
          };
        }

        // Bird Tethers
        if (matches.id === '0011') return {
          infoText: output.warBirdTether()
        };
      }

      // No Tethers
      if (!data.tetherCollect.includes(data.me)) {
        // Prevent duplicate callout
        data.tetherCollect.push(data.me);
        if (data.tetherCollectPhase === undefined) return {
          infoText: output.noTether()
        };
        if (data.tetherCollectPhase === 'famine') return {
          alertText: output.famineNoTether()
        };
      }
    }
  }, {
    id: 'P7S Forbidden Fruit 4 and Harvest Stop Collection',
    // 0001 Tether also goes off on players that get 0039 Tethers which leads
    // to 0039 possibly reapplying. This trigger is used to only collect tethers
    // during a defined window.
    type: 'Tether',
    netRegex: {
      id: ['0006', '0039'],
      capture: false
    },
    delaySeconds: 0.2,
    suppressSeconds: 6,
    run: data => data.stopTethers = true
  }, {
    id: 'P7S Harvest Phase Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: ['7A4F', '7A50', '7A51']
    },
    run: (data, matches) => {
      data.stopTethers = false;
      data.tetherCollect = [];
      switch (matches.id) {
        case '7A4F':
          data.tetherCollectPhase = 'famine';
          break;
        case '7A50':
          data.tetherCollectPhase = 'death';
          break;
        case '7A51':
          data.tetherCollectPhase = 'war';
          break;
      }
    }
  }, {
    id: 'P7S Inviolate Bonds Reminders',
    // First trigger is ~4s after debuffs callout
    // These happen 6s before cast
    type: 'HeadMarker',
    netRegex: {},
    condition: data => !data.seenInviolatePurgation,
    suppressSeconds: 1,
    infoText: (data, matches, output) => {
      const correctedMatch = p7s_getHeadmarkerId(data, matches);
      if (correctedMatch === '00A6' && data.bondsDebuff) return output[data.bondsDebuff]();
    },
    run: data => data.bondsDebuff = data.bondsDebuff === 'spread' ? 'stackMarker' : 'spread',
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread,
      stackMarker: outputs/* default.stackMarker */.Z.stackMarker
    }
  }, {
    id: 'P7S Inviolate Purgation Collect',
    type: 'GainsEffect',
    // CEE = Purgatory Winds I
    // D3F = Purgatory Winds II
    // D40 = Purgatory Winds III
    // D41 = Purgatory Winds IV
    // CEF = Holy Purgation I
    // D42 = Holy Purgation II
    // D43 = Holy Purgation III
    // D44 = Holy Purgation IV
    netRegex: {
      effectId: ['CE[EF]', 'D3F', 'D4[01234]']
    },
    run: (data, matches) => {
      data.seenInviolatePurgation = true;
      if (data.me !== matches.target) return;
      const effectId = matches.effectId.toUpperCase();
      const duration = parseFloat(matches.duration);
      const effectStr = p7s_effectIdToOutputStringKey[effectId];
      if (effectStr === undefined) return;
      if (duration < 11) data.purgationDebuffs[0] = effectStr;else if (duration < 26) data.purgationDebuffs[1] = effectStr;else if (duration < 41) data.purgationDebuffs[2] = effectStr;else if (duration < 56) data.purgationDebuffs[3] = effectStr;else console.log(`Invalid purg debuff duration ${duration}`);
    }
  }, {
    id: 'P7S Inviolate Purgation',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['CE[EF]', 'D3F', 'D4[01234]'],
      capture: false
    },
    delaySeconds: 0.5,
    durationSeconds: 55,
    suppressSeconds: 10,
    infoText: (data, _matches, output) => {
      const [effect1, effect2, effect3, effect4] = data.purgationDebuffs;
      return output.comboText({
        effect1: output[effect1](),
        effect2: output[effect2](),
        effect3: output[effect3](),
        effect4: output[effect4]()
      });
    },
    outputStrings: {
      comboText: {
        en: '${effect1} => ${effect2} => ${effect3} => ${effect4}',
        de: '${effect1} => ${effect2} => ${effect3} => ${effect4}',
        fr: '${effect1} => ${effect2} => ${effect3} => ${effect4}',
        ja: '${effect1} => ${effect2} => ${effect3} => ${effect4}',
        cn: '${effect1} => ${effect2} => ${effect3} => ${effect4}',
        ko: '${effect1} => ${effect2} => ${effect3} => ${effect4}'
      },
      spread: outputs/* default.spread */.Z.spread,
      stack: outputs/* default.stackMarker */.Z.stackMarker
    }
  }, {
    id: 'P7S Inviolate Purgation Reminders',
    // First trigger is ~4s after debuffs callout
    // These happen 6s before cast
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.seenInviolatePurgation,
    suppressSeconds: 1,
    infoText: (data, matches, output) => {
      // Return if we are missing effects
      if (data.purgationDebuffs === undefined) return;
      const correctedMatch = p7s_getHeadmarkerId(data, matches);
      if (correctedMatch === '00A6') {
        const text = data.purgationDebuffs[data.purgationEffectIndex];
        data.purgationEffectIndex = data.purgationEffectIndex + 1;
        if (text === undefined) return;
        return output[text]();
      }
    },
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread,
      stack: outputs/* default.stackMarker */.Z.stackMarker
    }
  }, {
    id: 'P7S Light of Life',
    type: 'StartsUsing',
    netRegex: {
      id: '78E2',
      source: 'Agdistis',
      capture: false
    },
    // ~5s castTime, but boss cancels it and ability goes off 26s after start
    delaySeconds: 21,
    alertText: (_data, _matches, output) => output.bigAoEMiddle(),
    outputStrings: {
      bigAoEMiddle: {
        en: 'Big AOE, Get Middle',
        de: 'Große AoE, geh in die Mitte',
        fr: 'Grosse AoE, allez au milieu',
        ja: '強力な全体攻撃、真ん中へ',
        cn: '超大伤害，去中间',
        ko: '아픈 광뎀, 중앙으로'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Condensed Aero II/Dispersed Aero II': 'Condensed/Dispersed Aero II'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Agdistis': 'Agdistis',
      'Immature Io': 'unreif(?:e|er|es|en) Io',
      'Immature Minotaur': 'unreif(?:e|er|es|en) Minotaurus',
      'Immature Stymphalide': 'unreif(?:e|er|es|en) Stymphalides'
    },
    'replaceText': {
      '--chasing aoe--': '--verfolgende AoEs--',
      '--eggs--': '--Eier--',
      'arrow': 'Pfeil',
      'close': 'Nahe',
      'far': 'Entfernt',
      'Blades of Attis': 'Schwertblatt des Attis',
      'Bough of Attis': 'Ast des Attis',
      'Bronze Bellows': 'Böenschlag',
      'Bullish Slash': 'Bullenansturm',
      'Bullish Swipe': 'Bullenfeger',
      'Condensed Aero II': 'Gehäuftes Windra',
      'Death\'s Harvest': 'Unheilvolle Wucherung des Lebens',
      'Dispersed Aero II': 'Flächiges Windra',
      'Famine\'s Harvest': 'Wilde Wucherung des Lebens',
      'Forbidden Fruit': 'Frucht des Lebens',
      'Hemitheos\'s Aero III': 'Hemitheisches Windga',
      'Hemitheos\'s Aero IV': 'Hemitheisches Windka',
      'Hemitheos\'s Glare(?! III)': 'Hemitheische Blendung',
      'Hemitheos\'s Glare III': 'Hemitheisches Blendga',
      'Hemitheos\'s Holy(?! III)': 'Hemitheisches Sanctus',
      'Hemitheos\'s Holy III': 'Hemitheisches Sanctga',
      'Hemitheos\'s Tornado': 'Hemitheischer Tornado',
      'Immortal\'s Obol': 'Zweig des Lebens und des Todes',
      'Inviolate Bonds': 'Siegelschaffung',
      'Inviolate Purgation': 'Siegelschaffung der Hölle',
      'Light of Life': 'Aurora des Lebens',
      'Multicast': 'Multizauber',
      'Roots of Attis': 'Wurzel des Attis',
      'Shadow of Attis': 'Lichttropfen des Attis',
      'Spark of Life': 'Schein des Lebens',
      'Static Path': 'Statischer Pfad',
      'Stymphalian Strike': 'Vogelschlag',
      'War\'s Harvest': 'Chaotische Wucherung des Lebens'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Agdistis': 'Agdistis',
      'Immature Io': 'Io immature',
      'Immature Minotaur': 'Minotaure immature',
      'Immature Stymphalide': 'Stymphalide immature'
    },
    'replaceText': {
      '--chasing aoe--': '--AoE en ligne--',
      '--eggs--': '--Œufs--',
      'arrow': 'Flèche',
      'close': 'Proche',
      'far': 'Loin',
      'Blades of Attis': 'Lames d\'Attis',
      'Bough of Attis': 'Grandes branches d\'Attis',
      'Bronze Bellows': 'Frappe rafale',
      'Bullish Slash': 'Taillade catabatique',
      'Bullish Swipe': 'Balayage catabatique',
      'Condensed Aero II': 'Extra Vent concentré',
      'Death\'s Harvest': 'Bourgeonnement de vie morbide',
      'Dispersed Aero II': 'Extra vent étendu',
      'Famine\'s Harvest': 'Bourgeonnement de vie féroce',
      'Forbidden Fruit': 'Fruits de la vie',
      'Hemitheos\'s Aero III': 'Méga Vent d\'hémithéos',
      'Hemitheos\'s Aero IV': 'Giga Vent d\'hémithéos',
      'Hemitheos\'s Glare(?! III)': 'Chatoiement d\'hémithéos',
      'Hemitheos\'s Glare III': 'Méga Chatoiement d\'hémithéos',
      'Hemitheos\'s Holy(?! III)': 'Miracle d\'hémithéos',
      'Hemitheos\'s Holy III': 'Méga Miracle d\'hémithéos',
      'Hemitheos\'s Tornado': 'Tornade d\'hémithéos',
      'Immortal\'s Obol': 'Branche de vie et de mort',
      'Inviolate Bonds': 'Tracé de sigil',
      'Inviolate Purgation': 'Tracé de sigils multiples',
      'Light of Life': 'Éclair de vie',
      'Multicast': 'Multisort',
      'Roots of Attis': 'Racines d\'Attis',
      'Shadow of Attis': 'Rai d\'Attis',
      'Spark of Life': 'Étincelle de vie',
      'Static Path': 'Chemin statique',
      'Stymphalian Strike': 'Assaut stymphalide',
      'War\'s Harvest': 'Bourgeonnement de vie chaotique'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Agdistis': 'アグディスティス',
      'Immature Io': 'イマチュア・イーオー',
      'Immature Minotaur': 'イマチュア・タウロス',
      'Immature Stymphalide': 'イマチュア・ステュムパリデス'
    },
    'replaceText': {
      'Blades of Attis': 'アッティスの刃葉',
      'Bough of Attis': 'アッティスの巨枝',
      'Bronze Bellows': 'ガストストライク',
      'Bullish Slash': 'ブルスラッシュ',
      'Bullish Swipe': 'ブルスワイプ',
      'Condensed Aero II': 'アグリゲート・エアロラ',
      'Death\'s Harvest': '生命の繁茂【凶】',
      'Dispersed Aero II': 'スプレッド・エアロラ',
      'Famine\'s Harvest': '生命の繁茂【猛】',
      'Forbidden Fruit': '生命の果実',
      'Hemitheos\'s Aero III': 'ヘーミテオス・エアロガ',
      'Hemitheos\'s Aero IV': 'ヘーミテオス・エアロジャ',
      'Hemitheos\'s Glare(?! III)': 'ヘーミテオス・グレア',
      'Hemitheos\'s Glare III': 'ヘーミテオス・グレアガ',
      'Hemitheos\'s Holy(?! III)': 'ヘーミテオス・ホーリー',
      'Hemitheos\'s Holy III': 'ヘーミテオス・ホーリガ',
      'Hemitheos\'s Tornado': 'ヘーミテオス・トルネド',
      'Immortal\'s Obol': '生滅の導枝',
      'Inviolate Bonds': '魔印創成',
      'Inviolate Purgation': '魔印創成・獄',
      'Light of Life': '生命の極光',
      'Multicast': 'マルチキャスト',
      'Roots of Attis': 'アッティスの根',
      'Shadow of Attis': 'アッティスの光雫',
      'Spark of Life': '生命の光芒',
      'Static Path': 'スタティックパース',
      'Stymphalian Strike': 'バードストライク',
      'War\'s Harvest': '生命の繁茂【乱】'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Agdistis': '阿格狄斯提斯',
      'Immature Io': '未成熟的伊娥',
      'Immature Minotaur': '未成熟的弥诺陶洛斯',
      'Immature Stymphalide': '未成熟的铁爪怪鸟'
    },
    'replaceText': {
      '--chasing aoe--': '--追踪AOE--',
      '--eggs--': '--蛋--',
      'arrow': '箭头',
      'close': '近',
      'far': '远',
      'Blades of Attis': '阿提斯的叶刃',
      'Bough of Attis': '阿提斯的巨枝',
      'Bronze Bellows': '突风强袭',
      'Bullish Slash': '牛魔猛击',
      'Bullish Swipe': '牛魔横扫',
      'Condensed Aero II': '集聚烈风',
      'Death\'s Harvest': '生命繁茂之凶',
      'Dispersed Aero II': '流散烈风',
      'Famine\'s Harvest': '生命繁茂之猛',
      'Forbidden Fruit': '生命之果',
      'Hemitheos\'s Aero III': '半神暴风',
      'Hemitheos\'s Aero IV': '半神飙风',
      'Hemitheos\'s Glare(?! III)': '半神闪耀',
      'Hemitheos\'s Glare III': '半神闪灼',
      'Hemitheos\'s Holy(?! III)': '半神神圣',
      'Hemitheos\'s Holy III': '半神豪圣',
      'Hemitheos\'s Tornado': '半神龙卷',
      'Immortal\'s Obol': '不灭者的导枝',
      'Inviolate Bonds': '创造魔印',
      'Inviolate Purgation': '创造双印',
      'Light of Life': '生命的极光',
      'Multicast': '多重施法',
      'Roots of Attis': '阿提斯的根足',
      'Shadow of Attis': '阿提斯的光露',
      'Spark of Life': '生命的光芒',
      'Static Path': '静电之路',
      'Stymphalian Strike': '怪鸟强袭',
      'War\'s Harvest': '生命繁茂之乱'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Agdistis': '아그디스티스',
      'Immature Io': '덜 자란 이오',
      'Immature Minotaur': '덜 자란 미노타우로스',
      'Immature Stymphalide': '덜 자란 스팀팔로스 괴조'
    },
    'replaceText': {
      '--chasing aoe--': '--추적 장판--',
      '--eggs--': '--알--',
      'arrow': '화살표',
      'close': '가까이',
      'far': '멀리',
      'Blades of Attis': '아티스의 칼날잎',
      'Bough of Attis': '아티스의 큰가지',
      'Bronze Bellows': '돌풍 충돌',
      'Bullish Slash': '황소 매질',
      'Bullish Swipe': '황소 휘두르기',
      'Condensed Aero II/Dispersed Aero II': '집합/산개 에어로라',
      'Death\'s Harvest': '흉포한 생명의 번성',
      'Famine\'s Harvest': '맹렬한 생명의 번성',
      'Forbidden Fruit': '생명의 열매',
      'Hemitheos\'s Aero III': '헤미테오스 에어로가',
      'Hemitheos\'s Aero IV': '헤미테오스 에어로쟈',
      'Hemitheos\'s Glare(?! III)': '헤미테오스 글레어',
      'Hemitheos\'s Glare III': '헤미테오스 글레어가',
      'Hemitheos\'s Holy(?! III)': '헤미테오스 홀리',
      'Hemitheos\'s Holy III': '헤미테오스 홀리가',
      'Hemitheos\'s Tornado': '헤미테오스 토네이도',
      'Immortal\'s Obol': '생멸의 가지',
      'Inviolate Bonds': '마법각인 생성',
      'Inviolate Purgation': '연옥의 마법각인 생성',
      'Light of Life': '생명의 극광',
      'Multicast': '다중 시전',
      'Roots of Attis': '아티스의 뿌리',
      'Shadow of Attis': '아티스의 빛방울',
      'Spark of Life': '생명의 광망',
      'Static Path': '정전기 길',
      'Stymphalian Strike': '괴조 충돌',
      'War\'s Harvest': '난폭한 생명의 번성'
    }
  }]
};
/* harmony default export */ const p7s = (p7s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p7s.txt
const raid_p7s_namespaceObject = "### P7S: Abyssos: The Seventh Circle (Savage)\r\n#\r\n# -ii 782A 7837 7838 7830 780D 7822 7825 7827 7819 7814\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n13.0 \"Spark of Life\" Ability { id: \"7839\", source: \"Agdistis\" } window 50,50\r\n26.3 \"Condensed Aero II/Dispersed Aero II\" Ability { id: [\"7836\", \"7835\"], source: \"Agdistis\" }\r\n34.1 \"--sync--\" Ability { id: \"782E\", source: \"Agdistis\" }\r\n42.7 \"Immortal's Obol\" Ability { id: \"780C\", source: \"Agdistis\" }\r\n44.6 \"Blades of Attis\" Ability { id: \"782F\", source: \"Agdistis\" } duration 14\r\n\r\n# Forbidden Fruit: Healer Stacks\r\n59.4 \"Forbidden Fruit\" Ability { id: \"7810\", source: \"Agdistis\" }\r\n64.5 \"--eggs--\" Ability { id: \"7811\", source: \"Agdistis\" }\r\n70.7 \"--sync--\" Ability { id: \"783A\", source: \"Agdistis\" }\r\n79.8 \"Hemitheos's Holy III\" Ability { id: \"783B\", source: \"Agdistis\" }\r\n80.0 \"Bough of Attis (far)\" Ability { id: \"7826\", source: \"Agdistis\" }\r\n80.3 \"Stymphalian Strike\" Ability { id: \"7815\", source: \"Immature Stymphalide\" }\r\n91.7 \"Condensed Aero II/Dispersed Aero II\" Ability { id: [\"7836\", \"7835\"], source: \"Agdistis\" }\r\n102.5 \"Spark of Life\" Ability { id: \"7839\", source: \"Agdistis\" }\r\n\r\n# Inviolate Bonds: Spread/Stack\r\n111.8 \"Inviolate Bonds\" Ability { id: \"781A\", source: \"Agdistis\" }\r\n121.8 \"Bough of Attis (close)\" Ability { id: \"7821\", source: \"Agdistis\" }\r\n121.9 \"Hemitheos's Aero III\" Ability { id: \"781B\", source: \"Agdistis\" }\r\n121.9 \"Hemitheos's Holy III\" Ability { id: \"781C\", source: \"Agdistis\" }\r\n129.4 \"Bough of Attis (arrow)\" Ability { id: [\"7823\", \"7824\"], source: \"Agdistis\" }\r\n132.9 \"Hemitheos's Aero III\" Ability { id: \"781B\", source: \"Agdistis\" }\r\n132.9 \"Hemitheos's Holy III\" Ability { id: \"781C\", source: \"Agdistis\" }\r\n138.6 \"Roots of Attis\" Ability { id: \"780E\", source: \"Agdistis\" }\r\n157.1 \"Condensed Aero II/Dispersed Aero II\" Ability { id: [\"7836\", \"7835\"], source: \"Agdistis\" }\r\n\r\n# Forbidden Fruit: Birds + Knockback\r\n165.8 \"Forbidden Fruit\" Ability { id: \"7810\", source: \"Agdistis\" }\r\n170.9 \"--eggs--\" Ability { id: \"7811\", source: \"Agdistis\" }\r\n176.0 \"Multicast\" Ability { id: \"79F5\", source: \"Agdistis\" }\r\n182.0 \"Hemitheos's Aero IV\" Ability { id: \"7A0B\", source: \"Agdistis\" }\r\n185.8 \"Hemitheos's Holy\" Ability { id: \"7832\", source: \"Agdistis\" }\r\n186.8 \"Stymphalian Strike\" Ability { id: \"7815\", source: \"Immature Stymphalide\" }\r\n194.1 \"Roots of Attis\" Ability { id: \"780E\", source: \"Agdistis\" }\r\n\r\n# Forbidden Fruit: Stacks on walkway\r\n205.5 \"Forbidden Fruit\" Ability { id: \"7810\", source: \"Agdistis\" }\r\n210.6 \"--eggs--\" Ability { id: \"7811\", source: \"Agdistis\" }\r\n217.4 \"--sync--\" Ability { id: \"783A\", source: \"Agdistis\" }\r\n223.4 \"Hemitheos's Holy III\" Ability { id: \"783B\", source: \"Agdistis\" }\r\n\r\n240.6 \"Bough of Attis (close)\" Ability { id: \"7821\", source: \"Agdistis\" }\r\n248.2 \"Bough of Attis (arrow)\" Ability { id: [\"7823\", \"7824\"], source: \"Agdistis\" }\r\n258.3 \"Condensed Aero II/Dispersed Aero II\" Ability { id: [\"7836\", \"7835\"], source: \"Agdistis\" }\r\n\r\n# Forbidden Fruit: 3 Minos, 2 Bulls\r\n266.0 \"Forbidden Fruit\" Ability { id: \"7810\", source: \"Agdistis\" }\r\n271.1 \"--eggs--\" Ability { id: \"7811\", source: \"Agdistis\" }\r\n286.7 \"Bullish Swipe\" Ability { id: \"7818\", source: \"Immature Minotaur\" }\r\n286.7 \"Bullish Slash\" Ability { id: \"7817\", source: \"Immature Minotaur\" }\r\n286.7 \"Static Path\" Ability { id: \"7813\", source: \"Immature Io\" }\r\n\r\n# Knockback into stack groups with exaflares\r\n294.8 \"--sync--\" Ability { id: \"782E\", source: \"Agdistis\" }\r\n300.9 \"Multicast\" Ability { id: \"79F5\", source: \"Agdistis\" }\r\n305.3 \"Blades of Attis\" Ability { id: \"782F\", source: \"Agdistis\" } duration 14\r\n307.0 \"Hemitheos's Aero IV\" Ability { id: \"7834\", source: \"Agdistis\" }\r\n309.7 \"Hemitheos's Holy III\" Ability { id: \"783B\", source: \"Agdistis\" }\r\n324.2 \"Condensed Aero II/Dispersed Aero II\" Ability { id: [\"7836\", \"7835\"], source: \"Agdistis\" }\r\n\r\n# Forbidden Fruit: Towers and Birds\r\n333.9 \"Forbidden Fruit\" Ability { id: \"7810\", source: \"Agdistis\" }\r\n339.0 \"--eggs--\" Ability { id: \"7811\", source: \"Agdistis\" }\r\n342.7 \"Shadow of Attis\" Ability { id: \"782B\", source: \"Agdistis\" }\r\n354.2 \"Bronze Bellows\" Ability { id: \"7816\", source: \"Immature Stymphalide\" }\r\n363.3 \"Spark of Life\" Ability { id: \"7839\", source: \"Agdistis\" }\r\n376.1 \"Immortal's Obol\" Ability { id: \"780C\", source: \"Agdistis\" }\r\n\r\n# Inviolate Purgation\r\n385.2 \"Forbidden Fruit\" Ability { id: \"7810\", source: \"Agdistis\" }\r\n390.3 \"--eggs--\" Ability { id: \"7811\", source: \"Agdistis\" }\r\n396.4 \"Inviolate Purgation\" Ability { id: \"781E\", source: \"Agdistis\" }\r\n407.5 \"Hemitheos's Holy III\" Ability { id: \"781C\", source: \"Agdistis\" }\r\n407.5 \"Hemitheos's Aero III\" Ability { id: \"781B\", source: \"Agdistis\" }\r\n407.9 \"Stymphalian Strike\" Ability { id: \"7815\", source: \"Immature Stymphalide\" }\r\n422.5 \"Hemitheos's Aero III\" Ability { id: \"781B\", source: \"Agdistis\" }\r\n422.5 \"Hemitheos's Holy III\" Ability { id: \"781C\", source: \"Agdistis\" }\r\n422.6 \"Hemitheos's Glare III\" Ability { id: \"7820\", source: \"Agdistis\" }\r\n422.6 \"Hemitheos's Tornado\" Ability { id: \"781F\", source: \"Agdistis\" }\r\n429.7 \"Light of Life 1\" Ability { id: \"78E2\", source: \"Agdistis\" }\r\n437.5 \"Hemitheos's Aero III\" Ability { id: \"781B\", source: \"Agdistis\" }\r\n437.5 \"Hemitheos's Holy III\" Ability { id: \"781C\", source: \"Agdistis\" }\r\n437.5 \"Hemitheos's Tornado\" Ability { id: \"781F\", source: \"Agdistis\" }\r\n437.5 \"Hemitheos's Glare III\" Ability { id: \"7820\", source: \"Agdistis\" }\r\n437.5 \"Hemitheos's Tornado\" Ability { id: \"781F\", source: \"Agdistis\" }\r\n452.5 \"Hemitheos's Aero III\" Ability { id: \"781B\", source: \"Agdistis\" }\r\n452.5 \"Hemitheos's Holy III\" Ability { id: \"781C\", source: \"Agdistis\" }\r\n452.5 \"Hemitheos's Tornado\" Ability { id: \"781F\", source: \"Agdistis\" }\r\n452.5 \"Hemitheos's Glare III\" Ability { id: \"7820\", source: \"Agdistis\" }\r\n452.5 \"Hemitheos's Tornado\" Ability { id: \"781F\", source: \"Agdistis\" }\r\n460.8 \"Light of Life 2\" Ability { id: \"78E2\", source: \"Agdistis\" }\r\n467.5 \"Hemitheos's Tornado\" Ability { id: \"781F\", source: \"Agdistis\" }\r\n467.5 \"Hemitheos's Glare III\" Ability { id: \"7820\", source: \"Agdistis\" }\r\n\r\n# Forbidden Fruit: chasing aoes\r\n476.2 \"Forbidden Fruit\" Ability { id: \"7810\", source: \"Agdistis\" }\r\n481.3 \"--eggs--\" Ability { id: \"7811\", source: \"Agdistis\" }\r\n486.4 \"Roots of Attis\" Ability { id: \"780E\", source: \"Agdistis\" }\r\n493.5 \"Hemitheos's Glare\" Ability { id: \"7828\", source: \"Agdistis\" }\r\n498.5 \"--chasing aoe--\" Ability { id: \"7829\", source: \"Agdistis\" } duration 5.5\r\n501.1 \"Stymphalian Strike\" Ability { id: \"7815\", source: \"Immature Stymphalide\" }\r\n\r\n# Famine's Harvest\r\n508.0 \"Famine's Harvest\" Ability { id: \"7A4F\", source: \"Agdistis\" }\r\n513.1 \"--eggs--\" Ability { id: \"7811\", source: \"Agdistis\" }\r\n528.7 \"Bullish Swipe\" Ability { id: \"7818\", source: \"Immature Minotaur\" }\r\n528.7 \"Bullish Slash\" Ability { id: \"7817\", source: \"Immature Minotaur\" }\r\n528.9 \"Stymphalian Strike\" Ability { id: \"7815\", source: \"Immature Stymphalide\" }\r\n\r\n# Death's Harvest\r\n540.6 \"Death's Harvest\" Ability { id: \"7A50\", source: \"Agdistis\" }\r\n545.7 \"--eggs--\" Ability { id: \"7811\", source: \"Agdistis\" }\r\n561.3 \"Static Path\" Ability { id: \"7813\", source: \"Immature Io\" }\r\n561.6 \"Stymphalian Strike\" Ability { id: \"7815\", source: \"Immature Stymphalide\" }\r\n\r\n# War's Harvest\r\n573.3 \"War's Harvest\" Ability { id: \"7A51\", source: \"Agdistis\" }\r\n578.4 \"--eggs--\" Ability { id: \"7811\", source: \"Agdistis\" }\r\n594.0 \"Bullish Slash\" Ability { id: \"7817\", source: \"Immature Minotaur\" }\r\n594.0 \"Bronze Bellows\" Ability { id: \"7816\", source: \"Immature Stymphalide\" }\r\n594.0 \"Static Path\" Ability { id: \"7813\", source: \"Immature Io\" }\r\n\r\n607.0 \"Spark of Life\" Ability { id: \"7839\", source: \"Agdistis\" }\r\n617.3 \"--sync--\" Ability { id: \"783A\", source: \"Agdistis\" }\r\n626.3 \"Bough of Attis (close)\" Ability { id: \"7821\", source: \"Agdistis\" }\r\n627.5 \"Hemitheos's Holy III\" Ability { id: \"783B\", source: \"Agdistis\" }\r\n633.9 \"Bough of Attis (arrow)\" Ability { id: [\"7823\", \"7824\"], source: \"Agdistis\" }\r\n643.1 \"Spark of Life\" Ability { id: \"7839\", source: \"Agdistis\" }\r\n656.3 \"Spark of Life\" Ability { id: \"7839\", source: \"Agdistis\" }\r\n\r\n663.5 \"--sync--\" StartsUsing { id: \"783F\", source: \"Agdistis\" } window 50,50\r\n673.5 \"Light of Life (enrage)\" Ability { id: \"783F\", source: \"Agdistis\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p8n.ts







// TODO: Cthonic Vent is tricky; the initial cast is ~5s, but the next two explosions are ~2s.
//       There's no map events.  There's two Suneater adds that are added immediately before
//       the first 78F5 cast, and these same two combatants are used for the next two circles.
//       It seems like these adds that are doing damage are moved only at the last second.
//       It's possible there's some other hidden combatants moving around, or this is
//       just a case of missing some animation data in network logs that would tell us.
// TODO: how to detect/what to say for Blazing Footfalls knockbacks?
// TODO: how to detect/what to say for Blazing Footfalls knockbacks?

const p8n_centerX = 100;
const p8n_centerY = 100;
const p8n_positionTo8Dir = combatant => {
  const x = combatant.PosX - p8n_centerX;
  const y = combatant.PosY - p8n_centerY;

  // Dirs: N = 0, NE = 1, ..., NW = 7
  return Math.round(4 - 4 * Math.atan2(x, y) / Math.PI) % 8;
};
const p8n_triggerSet = {
  id: 'AbyssosTheEighthCircle',
  zoneId: zone_id/* default.AbyssosTheEighthCircle */.Z.AbyssosTheEighthCircle,
  timelineFile: 'p8n.txt',
  initData: () => {
    return {
      combatantData: [],
      ventIds: [],
      torches: []
    };
  },
  triggers: [{
    id: 'P8N Genesis of Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '7905',
      source: 'Hephaistos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P8N Scorching Fang',
    type: 'StartsUsing',
    // has 78EC Sunforge castbar
    netRegex: {
      id: '78EE',
      source: 'Hephaistos',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'P8N Sun\'s Pinion',
    type: 'StartsUsing',
    // also has 78EC Sunforge castbar
    netRegex: {
      id: '78EF',
      source: 'Hephaistos',
      capture: false
    },
    // There are two casts, one for each side.
    suppressSeconds: 1,
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'P8N Flameviper',
    type: 'StartsUsing',
    netRegex: {
      id: '7908',
      source: 'Hephaistos'
    },
    // This is a "line" tank cleave that leaves a bleed.
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'P8N Petrifaction',
    type: 'StartsUsing',
    netRegex: {
      id: '78FC',
      source: 'Gorgon',
      capture: false
    },
    // There are two casts, one for each Gorgon.
    suppressSeconds: 1,
    response: responses/* Responses.lookAway */.n3.lookAway()
  }, {
    id: 'P8N Gorgon Add',
    type: 'Ability',
    // We could use addedCombatant({ npcNameId: '11517' }), but this also fires on the
    // spawn of the lookaway eyeballs.
    netRegex: {
      id: '78FC',
      source: 'Gorgon',
      capture: false
    },
    suppressSeconds: 1,
    response: responses/* Responses.killAdds */.n3.killAdds()
  }, {
    id: 'P8N Ektothermos',
    type: 'StartsUsing',
    netRegex: {
      id: '78FE',
      source: 'Hephaistos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P8N Abyssal Fires',
    type: 'StartsUsing',
    netRegex: {
      id: '78F1',
      source: 'Hephaistos',
      capture: false
    },
    // There are four of these, one for each fire.
    suppressSeconds: 1,
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'P8N Rearing Rampage',
    type: 'StartsUsing',
    netRegex: {
      id: '79AB',
      source: 'Hephaistos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P8N Suneater Cthonic Vent Add',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '11404'
    },
    run: (data, matches) => data.ventIds.push(matches.id)
  }, {
    id: 'P8N Suneater Cthonic Vent Initial',
    type: 'StartsUsing',
    netRegex: {
      id: '78F5',
      source: 'Suneater',
      capture: false
    },
    suppressSeconds: 1,
    promise: async data => {
      data.combatantData = [];
      if (data.ventIds.length !== 2) return;
      const ids = data.ventIds.map(id => parseInt(id, 16));
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: ids
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      if (data.combatantData.length === 0) return;
      const unsafeSpots = data.combatantData.map(c => p8n_positionTo8Dir(c)).sort();
      const [unsafe0, unsafe1] = unsafeSpots;
      if (unsafe0 === undefined || unsafe1 === undefined) throw new not_reached/* UnreachableCode */.$();

      // edge case wraparound
      if (unsafe0 === 1 && unsafe1 === 7) return output.south();

      // adjacent unsafe spots, cardinal is safe
      if (unsafe1 - unsafe0 === 2) {
        // this average is safe to do because wraparound was taken care of above.
        const unsafeCard = Math.floor((unsafe0 + unsafe1) / 2);
        const safeDirMap = {
          0: output.south(),
          // this won't happen, but here for completeness
          2: output.west(),
          4: output.north(),
          6: output.east()
        };
        return safeDirMap[unsafeCard] ?? output.unknown();
      }

      // two intercards are safe, they are opposite each other,
      // so we can pick the intercard counterclock of each unsafe spot.
      // e.g. 1/5 are unsafe (NE and SW), so SE and NW are safe.
      const safeIntercardMap = {
        1: output.dirNW(),
        3: output.dirNE(),
        5: output.dirSE(),
        7: output.dirSW()
      };
      const safeStr0 = safeIntercardMap[unsafe0] ?? output.unknown();
      const safeStr1 = safeIntercardMap[unsafe1] ?? output.unknown();
      return output.comboDir({
        dir1: safeStr0,
        dir2: safeStr1
      });
    },
    outputStrings: {
      comboDir: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        ja: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      },
      north: outputs/* default.north */.Z.north,
      east: outputs/* default.east */.Z.east,
      south: outputs/* default.south */.Z.south,
      west: outputs/* default.west */.Z.west,
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirSW: outputs/* default.dirSW */.Z.dirSW,
      dirNW: outputs/* default.dirNW */.Z.dirNW,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'P8N Volcanic Torches Cleanup',
    type: 'StartsUsing',
    // This always precedes 78F8 Torch Flame casts.
    netRegex: {
      id: ['78F7', '71DE'],
      source: 'Hephaistos',
      capture: false
    },
    run: data => data.torches = []
  }, {
    id: 'P8N Torch Flame Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '78F8',
      source: 'Hephaistos'
    },
    run: (data, matches) => data.torches.push(matches)
  }, {
    id: 'P8N Torch Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '78F8',
      source: 'Hephaistos',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    promise: async data => {
      data.combatantData = [];
      const ids = data.torches.map(torch => parseInt(torch.sourceId, 16));
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: ids
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      if (data.combatantData.length === 0) return;
      const safe = {
        outsideNorth: true,
        insideNorth: true,
        outsideEast: true,
        insideEast: true,
        outsideSouth: true,
        insideSouth: true,
        outsideWest: true,
        insideWest: true
      };

      // Loop through all torches, remove any rows/columns it intersects with
      // to find safe lanes.
      for (const torch of data.combatantData) {
        // x, y = 85, 95, 105, 115
        // map to ([0, 3], [0, 3])
        const x = Math.floor((torch.PosX - 85) / 10);
        const y = Math.floor((torch.PosY - 85) / 10);
        const xMap = {
          0: 'outsideWest',
          1: 'insideWest',
          2: 'insideEast',
          3: 'outsideEast'
        };
        const xKey = xMap[x];
        if (xKey === undefined) return;
        delete safe[xKey];
        const yMap = {
          0: 'outsideNorth',
          1: 'insideNorth',
          2: 'insideSouth',
          3: 'outsideSouth'
        };
        const yKey = yMap[y];
        if (yKey === undefined) return;
        delete safe[yKey];
      }
      const [safe0, safe1, safe2] = Object.keys(safe);

      // Unexpectedly zero safe zones.
      if (safe0 === undefined) return;
      // Not set up to handle more than two safe zones.
      if (safe2 !== undefined) return;
      if (safe1 === undefined) return output[safe0]();
      const dir1 = output[safe0]();
      const dir2 = output[safe1]();
      return output.combo({
        dir1: dir1,
        dir2: dir2
      });
    },
    outputStrings: {
      combo: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        ja: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      },
      outsideNorth: {
        en: 'Outside North',
        de: 'Im Norden raus',
        fr: 'Nord Extérieur',
        ja: '北の外側',
        cn: '上 (北) 外',
        ko: '북쪽 바깥'
      },
      insideNorth: {
        en: 'Inside North',
        de: 'Im Norden rein',
        fr: 'Nord Intérieur',
        ja: '北の内側',
        cn: '上 (北) 内',
        ko: '북쪽 안'
      },
      outsideEast: {
        en: 'Outside East',
        de: 'Im Osten raus',
        fr: 'Est Extérieur',
        ja: '東の外側',
        cn: '右 (东) 外',
        ko: '동쪽 바깥'
      },
      insideEast: {
        en: 'Inside East',
        de: 'Im Osten rein',
        fr: 'Est Intérieur',
        ja: '東の内側',
        cn: '右 (东) 内',
        ko: '동쪽 안'
      },
      outsideSouth: {
        en: 'Outside South',
        de: 'Im Süden raus',
        fr: 'Sud Extérieur',
        ja: '南の外側',
        cn: '下 (南) 外',
        ko: '남쪽 바깥'
      },
      insideSouth: {
        en: 'Inside South',
        de: 'Im Süden rein',
        fr: 'Sud Intérieur',
        ja: '南の内側',
        cn: '下 (南) 内',
        ko: '남쪽 안'
      },
      outsideWest: {
        en: 'Outside West',
        de: 'Im Westen raus',
        fr: 'Ouest Extérieur',
        ja: '西の外側',
        cn: '左 (西) 外',
        ko: '서쪽 바깥'
      },
      insideWest: {
        en: 'Inside West',
        de: 'Im Westen rein',
        fr: 'Ouest Intérieur',
        ja: '西の内側',
        cn: '左 (西) 内',
        ko: '서쪽 안'
      }
    }
  }, {
    id: 'P8N Hemitheos\'s Flare',
    type: 'StartsUsing',
    netRegex: {
      id: '7907',
      source: 'Hephaistos'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Gorgon': 'Gorgone',
      '(?<!Illusory )Hephaistos': 'Hephaistos',
      'Illusory Hephaistos': 'Hephaistos-Phantom',
      'Suneater': 'Schlund des Phoinix'
    },
    'replaceText': {
      'Abyssal Fires': 'Feuersturm',
      'Blazing Footfalls': 'Fackelnde Füße',
      'Cthonic Vent': 'Lodernde Schlange',
      'Ektothermos': 'Ektothermos',
      'Flameviper': 'Flammenviper',
      'Fourfold Fires': 'Vierfacher Feuersturm',
      'Genesis of Flame': 'Flammende Genesis',
      'Gorgospit': 'Gorgons Speichel',
      'Hemitheos\'s Flare': 'Hemitheos-Flare',
      'Into the Shadows': 'In die Schatten',
      'Petrifaction': 'Versteinerung',
      'Quadrupedal Crush': 'Fußmalmer',
      'Quadrupedal Impact': 'Fußstampfer',
      'Rearing Rampage': 'Gleißender Amok',
      'Reforged Reflection': 'Mutierte Schöpfung',
      'Scorching Fang': 'Flammender Zahn',
      'Sun\'s Pinion': 'Versengte Schwinge',
      'Sunforge': 'Flammenreigen der Schöpfung',
      'Torch Flame': 'Glutfeuer',
      'Trailblaze': 'Flammender Pfad',
      'Volcanic Torches': 'Vulkanfackel'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Gorgon': 'gorgone',
      '(?<!Illusory )Hephaistos': 'Héphaïstos',
      'Illusory Hephaistos': 'spectre d\'Héphaïstos',
      'Suneater': 'serpent en flammes'
    },
    'replaceText': {
      'Abyssal Fires': 'Tempête enflammée',
      'Blazing Footfalls': 'Pas ardents',
      'Cthonic Vent': 'Serpents de flammes ascendants',
      'Ektothermos': 'Vague d\'énergie explosive',
      'Flameviper': 'Serpent-canon',
      'Fourfold Fires': 'Quadruple tempête enflammée',
      'Genesis of Flame': 'Flammes de la création',
      'Gorgospit': 'Crachat de gorgone',
      'Hemitheos\'s Flare': 'Brasier d\'hémithéos',
      'Into the Shadows': 'Dans l\'ombre',
      'Petrifaction': 'Pétrification',
      'Quadrupedal Crush': 'Écrasement quadrupède',
      'Quadrupedal Impact': 'Impact quadrupède',
      'Rearing Rampage': 'Cabrage ravageur',
      'Reforged Reflection': 'Mutation corporelle',
      'Scorching Fang': 'Crocs embrasants',
      'Sun\'s Pinion': 'Aile embrasante',
      'Sunforge': 'Bête enflammée',
      'Torch Flame': 'Explosion de braises',
      'Trailblaze': 'Traînée ardente',
      'Volcanic Torches': 'Boutefeux magiques'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Gorgon': 'ゴルゴン',
      '(?<!Illusory )Hephaistos': 'ヘファイストス',
      'Illusory Hephaistos': 'ヘファイストスの幻影',
      'Suneater': '炎霊蛇'
    },
    'replaceText': {
      'Abyssal Fires': '炎嵐',
      'Blazing Footfalls': 'ブレイジングフィート',
      'Cthonic Vent': '噴炎昇蛇',
      'Ektothermos': '爆炎波動',
      'Flameviper': '炎蛇砲',
      'Fourfold Fires': '四重炎嵐',
      'Genesis of Flame': '創世の真炎',
      'Gorgospit': 'ゴルゴンスピット',
      'Hemitheos\'s Flare': 'ヘーミテオス・フレア',
      'Into the Shadows': 'イントゥシャドウ',
      'Petrifaction': 'ペトリファクション',
      'Quadrupedal Crush': 'フィートクラッシュ',
      'Quadrupedal Impact': 'フィートインパクト',
      'Rearing Rampage': 'リアリングランページ',
      'Reforged Reflection': '変異創身',
      'Scorching Fang': '炎の牙',
      'Sun\'s Pinion': '炎の翼',
      'Sunforge': '創獣炎舞',
      'Torch Flame': '熾炎',
      'Trailblaze': 'トレイルブレイズ',
      'Volcanic Torches': '熾炎創火'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Gorgon': '戈尔贡',
      '(?<!Illusory )Hephaistos': '赫淮斯托斯',
      'Illusory Hephaistos': '赫淮斯托斯的幻影',
      'Suneater': '炎灵蛇'
    },
    'replaceText': {
      'Abyssal Fires': '火炎风暴',
      'Blazing Footfalls': '炽热践踏',
      'Cthonic Vent': '喷炎升蛇',
      'Ektothermos': '爆热波动',
      'Flameviper': '炎蛇炮',
      'Fourfold Fires': '四重火炎风暴',
      'Genesis of Flame': '创世真炎',
      'Gorgospit': '戈尔贡喷吐',
      'Hemitheos\'s Flare': '半神核爆',
      'Into the Shadows': '潜入阴影',
      'Petrifaction': '石化',
      'Quadrupedal Crush': '践踏碎击',
      'Quadrupedal Impact': '践踏冲击',
      'Rearing Rampage': '双足狂怒',
      'Reforged Reflection': '变异创身',
      'Scorching Fang': '烈火牙',
      'Sun\'s Pinion': '炎之翼',
      'Sunforge': '创兽炎舞',
      'Torch Flame': '灼炎',
      'Trailblaze': '踏火寻迹',
      'Volcanic Torches': '灼炎创火'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Gorgon': '고르곤',
      '(?<!Illusory )Hephaistos': '헤파이스토스',
      'Illusory Hephaistos': '헤파이스토스의 환영',
      'Suneater': '염령사'
    },
    'replaceText': {
      'Abyssal Fires': '화염 폭풍',
      'Blazing Footfalls': '맹렬한 발걸음',
      'Cthonic Vent': '불뱀 승천',
      'Ektothermos': '폭염 파동',
      'Flameviper': '불뱀 진격',
      'Fourfold Fires': '4중 화염 폭풍',
      'Genesis of Flame': '창세의 불꽃',
      'Gorgospit': '고르곤의 침',
      'Hemitheos\'s Flare': '헤미테오스 플레어',
      'Into the Shadows': '그림자 속으로',
      'Petrifaction': '석화',
      'Quadrupedal Crush': '발걸음 파괴',
      'Quadrupedal Impact': '발걸음 충격',
      'Rearing Rampage': '난폭한 앞발질',
      'Reforged Reflection': '신체 변이',
      'Scorching Fang': '타오르는 송곳니',
      'Sun\'s Pinion': '타오르는 날개',
      'Sunforge': '창조물의 불꽃춤',
      'Torch Flame': '단불',
      'Trailblaze': '불꽃 발자국',
      'Volcanic Torches': '단불 창조'
    }
  }]
};
/* harmony default export */ const p8n = (p8n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p8n.txt
const raid_p8n_namespaceObject = "### P8N: Abyssos: The Eighth Circle\r\n#\r\n# -ii 7909 790F 78F3 78F4 7902 790E 790C\r\n# -it \"Gorgon\"\r\n# -it \"Hephaistos\"\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Phase flowchart:\r\n#\r\n#           +-> Quadruped -> Vent -> Gorgon -+\r\n# Sunforge -+                                +-> Torches -> (continued below)\r\n#           +-> Gorgon -> Vent -> Quadruped -+\r\n#\r\n#\r\n#           +-> Quadruped v2 -> Vent v2 -> Gorgon v2 -+                +-> Quadruped v2 -> etc\r\n# (cont.) --+                                         +-> Sunforge v2 -+\r\n#           +-> Gorgon v2 -> Vent v2 -> Quadruped v2 -+                +-> Gorgon v2 -> etc\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.0 \"--sync--\" StartsUsing { id: \"7905\", source: \"Hephaistos\" } window 10,10\r\n12.0 \"Genesis of Flame\" Ability { id: \"7905\", source: \"Hephaistos\" }\r\n\r\n# Sunforge v1\r\n17.1 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n26.4 \"Sunforge\" Ability { id: \"78EC\", source: \"Hephaistos\" }\r\n27.4 \"Scorching Fang\" Ability { id: \"78EE\", source: \"Hephaistos\" }\r\n36.6 \"Sunforge\" Ability { id: \"78ED\", source: \"Hephaistos\" }\r\n37.6 \"Sun's Pinion\" Ability { id: \"78EF\", source: \"Hephaistos\" }\r\n46.8 \"Sunforge\" Ability { id: [\"78EC\", \"78ED\"], source: \"Hephaistos\" }\r\n47.8 \"Scorching Fang/Sun's Pinion\" Ability { id: [\"78EE\", \"78EF\"], source: \"Hephaistos\" }\r\n56.1 \"Flameviper\" Ability { id: \"7908\", source: \"Hephaistos\" }\r\n# jump to Quadruped v1 or Gorgon v1\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Quadruped v1 branch\r\n63.3 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n68.5 \"Reforged Reflection\" Ability { id: \"794B\", source: \"Hephaistos\" } window 50,50 jump 168.5\r\n79.1 \"Quadrupedal Crush?\" #Ability { id: \"7904\", source: \"Hephaistos\" }\r\n85.1 \"--sync--\" #Ability { id: \"790B\", source: \"Hephaistos\" }\r\n91.6 \"Blazing Footfalls?\" #Ability { id: \"7900\", source: \"Hephaistos\" }\r\n\r\n# -> Gorgon v1 branch\r\n63.3 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n# don't double up with quadruped's 794B Reforged Reflection above\r\n68.5 \"--sync--\" Ability { id: \"794C\", source: \"Hephaistos\" } window 50,50 jump 468.5\r\n80.8 \"Into the Shadows?\" #Ability { id: \"78FB\", source: \"Hephaistos\" }\r\n88.8 \"--sync--\" #Ability { id: \"78FC\", source: \"Gorgon\" }\r\n89.9 \"Petrifaction?\" #Ability { id: \"6723\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Quadruped v1 (Quadruped branch)\r\n163.3 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n168.5 \"Reforged Reflection\" Ability { id: \"794B\", source: \"Hephaistos\" }\r\n179.1 \"Quadrupedal Crush\" Ability { id: \"7904\", source: \"Hephaistos\" }\r\n185.1 \"--sync--\" Ability { id: \"790B\", source: \"Hephaistos\" }\r\n191.6 \"Blazing Footfalls\" Ability { id: \"7900\", source: \"Hephaistos\" }\r\n191.6 \"--untargetable--\"\r\n192.3 \"Trailblaze\" Ability { id: \"790D\", source: \"Hephaistos\" }\r\n194.6 \"Quadrupedal Impact\" Ability { id: \"7103\", source: \"Hephaistos\" }\r\n197.2 \"Quadrupedal Impact\" Ability { id: \"7103\", source: \"Hephaistos\" }\r\n198.9 \"--targetable--\"\r\n208.0 \"Rearing Rampage\" Ability { id: \"79AB\", source: \"Hephaistos\" }\r\n\r\n# Vent v1 (Quadruped branch)\r\n221.5 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n226.8 \"Fourfold Fires\" Ability { id: \"78F2\", source: \"Hephaistos\" }\r\n232.6 \"Abyssal Fires\" Ability { id: \"78F1\", source: \"Hephaistos\" }\r\n235.9 \"--sync--\" Ability { id: \"78F0\", source: \"Hephaistos\" }\r\n241.8 \"Cthonic Vent 1\" Ability { id: \"78F5\", source: \"Suneater\" }\r\n249.8 \"Cthonic Vent 2\" Ability { id: \"794D\", source: \"Suneater\" }\r\n257.8 \"Cthonic Vent 3\" Ability { id: \"78F6\", source: \"Suneater\" }\r\n264.2 \"Sunforge\" Ability { id: [\"78EC\", \"78ED\"], source: \"Hephaistos\" }\r\n265.2 \"Scorching Fang/Sun's Pinion\" Ability { id: [\"78EE\", \"78EF\"], source: \"Hephaistos\" }\r\n272.3 \"Genesis of Flame\" Ability { id: \"7905\", source: \"Hephaistos\" }\r\n\r\n# Gorgon v1 (Quadruped branch)\r\n279.5 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n284.7 \"Reforged Reflection\" Ability { id: \"794C\", source: \"Hephaistos\" }\r\n297.0 \"Into the Shadows\" Ability { id: \"78FB\", source: \"Hephaistos\" }\r\n305.0 \"--sync--\" Ability { id: \"78FC\", source: \"Gorgon\" }\r\n306.1 \"Petrifaction\" Ability { id: \"6723\" }\r\n306.1 \"--targetable--\"\r\n312.3 \"Gorgospit\" Ability { id: \"78FF\", source: \"Hephaistos\" }\r\n319.6 \"Gorgospit\" Ability { id: \"78FF\", source: \"Hephaistos\" }\r\n327.7 \"Ektothermos\" Ability { id: \"78FE\", source: \"Hephaistos\" }\r\n338.1 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n\r\n# -> Torches v1 (both branches)\r\n343.6 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n348.7 \"Volcanic Torches\" Ability { id: \"78F7\", source: \"Hephaistos\" } window 50,50 jump 643.7\r\n362.7 \"Torch Flame\" #Ability { id: \"78F8\", source: \"Hephaistos\" }\r\n366.8 \"Volcanic Torches\" #Ability { id: \"78F7\", source: \"Hephaistos\" }\r\n374.9 \"Hemitheos's Flare\" #Ability { id: \"7906\", source: \"Hephaistos\" }\r\n380.8 \"Torch Flame\" #Ability { id: \"78F8\", source: \"Hephaistos\" }\r\n380.9 \"Hemitheos's Flare\" #Ability { id: \"7907\", source: \"Hephaistos\" }\r\n388.1 \"Sunforge\" #Ability { id: [\"78EC\", \"78ED\"], source: \"Hephaistos\" }\r\n389.1 \"Scorching Fang/Sun's Pinion\" #Ability { id: [\"78EE\", \"78EF\"], source: \"Hephaistos\" }\r\n396.2 \"Genesis of Flame\" #Ability { id: \"7905\", source: \"Hephaistos\" }\r\n404.4 \"Flameviper\" #Ability { id: \"7908\", source: \"Hephaistos\" }\r\n\r\n# Gorgon v1 (Gorgon branch)\r\n463.3 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n468.5 \"Reforged Reflection\" Ability { id: \"794C\", source: \"Hephaistos\" }\r\n480.8 \"Into the Shadows\" Ability { id: \"78FB\", source: \"Hephaistos\" }\r\n488.8 \"--sync--\" Ability { id: \"78FC\", source: \"Gorgon\" }\r\n489.9 \"Petrifaction\" Ability { id: \"6723\" }\r\n489.9 \"--targetable--\"\r\n496.1 \"Gorgospit\" Ability { id: \"78FF\", source: \"Hephaistos\" }\r\n503.4 \"Gorgospit\" Ability { id: \"78FF\", source: \"Hephaistos\" }\r\n511.5 \"Ektothermos\" Ability { id: \"78FE\", source: \"Hephaistos\" }\r\n\r\n# Vent v1 (Gorgon branch)\r\n521.9 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n527.2 \"Fourfold Fires\" Ability { id: \"78F2\", source: \"Hephaistos\" }\r\n533.0 \"Abyssal Fires\" Ability { id: \"78F1\", source: \"Hephaistos\" }\r\n536.3 \"--sync--\" Ability { id: \"78F0\", source: \"Hephaistos\" }\r\n542.2 \"Cthonic Vent 1\" Ability { id: \"78F5\", source: \"Suneater\" }\r\n550.2 \"Cthonic Vent 2\" Ability { id: \"794D\", source: \"Suneater\" }\r\n558.2 \"Cthonic Vent 3\" Ability { id: \"78F6\", source: \"Suneater\" }\r\n564.6 \"Sunforge\" Ability { id: [\"78EC\", \"78ED\"], source: \"Hephaistos\" }\r\n565.6 \"Scorching Fang/Sun's Pinion\" Ability { id: [\"78EE\", \"78EF\"], source: \"Hephaistos\" }\r\n572.7 \"Genesis of Flame\" Ability { id: \"7905\", source: \"Hephaistos\" }\r\n\r\n# Quadruped v1 (Gorgon branch)\r\n579.9 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n585.1 \"Reforged Reflection\" Ability { id: \"794B\", source: \"Hephaistos\" }\r\n595.8 \"Quadrupedal Crush\" Ability { id: \"7904\", source: \"Hephaistos\" }\r\n601.8 \"--sync--\" Ability { id: \"790B\", source: \"Hephaistos\" }\r\n608.4 \"Blazing Footfalls\" Ability { id: \"7900\", source: \"Hephaistos\" }\r\n608.4 \"--untargetable--\"\r\n609.1 \"Trailblaze\" Ability { id: \"790D\", source: \"Hephaistos\" }\r\n611.6 \"Quadrupedal Impact 1\" Ability { id: \"7103\", source: \"Hephaistos\" }\r\n614.4 \"Quadrupedal Impact 2\" Ability { id: \"7103\", source: \"Hephaistos\" }\r\n616.2 \"--targetable--\"\r\n625.3 \"Rearing Rampage\" Ability { id: \"79AB\", source: \"Hephaistos\" }\r\n\r\n\r\n# Torches v1 (both branches)\r\n638.6 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n643.7 \"Volcanic Torches\" Ability { id: \"78F7\", source: \"Hephaistos\" }\r\n657.7 \"Torch Flame\" Ability { id: \"78F8\", source: \"Hephaistos\" }\r\n661.8 \"Volcanic Torches\" Ability { id: \"78F7\", source: \"Hephaistos\" }\r\n669.9 \"Hemitheos's Flare\" Ability { id: \"7906\", source: \"Hephaistos\" }\r\n675.8 \"Torch Flame\" Ability { id: \"78F8\", source: \"Hephaistos\" }\r\n675.9 \"Hemitheos's Flare\" Ability { id: \"7907\", source: \"Hephaistos\" }\r\n683.1 \"Sunforge\" Ability { id: [\"78EC\", \"78ED\"], source: \"Hephaistos\" }\r\n684.1 \"Scorching Fang/Sun's Pinion\" Ability { id: [\"78EE\", \"78EF\"], source: \"Hephaistos\" }\r\n691.2 \"Genesis of Flame\" Ability { id: \"7905\", source: \"Hephaistos\" }\r\n699.4 \"Flameviper\" Ability { id: \"7908\", source: \"Hephaistos\" }\r\n# jump to Quadruped v2 or Gorgon v2\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Quadruped v2 branch\r\n706.5 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n711.7 \"Reforged Reflection\" Ability { id: \"794B\", source: \"Hephaistos\" } window 50,50 jump 811.7\r\n722.3 \"Quadrupedal Crush?\" #Ability { id: \"7904\", source: \"Hephaistos\" }\r\n728.3 \"--sync--\" #Ability { id: \"790B\", source: \"Hephaistos\" }\r\n737.0 \"Blazing Footfalls?\" #Ability { id: \"790A\", source: \"Hephaistos\" }\r\n\r\n# -> Gorgon v2 branch\r\n706.5 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n711.7 \"--sync--\" Ability { id: \"794C\", source: \"Hephaistos\" } window 50,50 jump 1111.7\r\n724.0 \"Into the Shadows?\" #Ability { id: \"78FB\", source: \"Hephaistos\" }\r\n732.0 \"--sync--\" #Ability { id: \"78FC\", source: \"Gorgon\" }\r\n732.0 \"Gorgospit?\" #Ability { id: \"6FD7\", source: \"Illusory Hephaistos\" }\r\n732.0 \"Volcanic Torches?\" #Ability { id: \"71DE\", source: \"Hephaistos\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n\r\n# Quadruped v2 (Quadruped2 branch)\r\n806.5 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n811.7 \"Reforged Reflection\" Ability { id: \"794B\", source: \"Hephaistos\" }\r\n822.3 \"Quadrupedal Crush\" Ability { id: \"7904\", source: \"Hephaistos\" }\r\n828.3 \"--sync--\" Ability { id: \"790B\", source: \"Hephaistos\" }\r\n837.0 \"Blazing Footfalls\" Ability { id: \"790A\", source: \"Hephaistos\" }\r\n837.0 \"--untargetable--\"\r\n837.7 \"Trailblaze\" Ability { id: \"790D\", source: \"Hephaistos\" }\r\n840.2 \"Quadrupedal Impact 1\" Ability { id: \"7103\", source: \"Hephaistos\" }\r\n843.0 \"Quadrupedal Impact 2\" Ability { id: \"7103\", source: \"Hephaistos\" }\r\n845.8 \"Quadrupedal Impact 3\" Ability { id: \"7103\", source: \"Hephaistos\" }\r\n847.6 \"--targetable--\"\r\n857.7 \"Rearing Rampage\" Ability { id: \"79AB\", source: \"Hephaistos\" }\r\n\r\n# Vent v2 (Quadruped2 branch)\r\n871.1 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n876.2 \"Fourfold Fires\" Ability { id: \"78F2\", source: \"Hephaistos\" }\r\n882.0 \"Abyssal Fires\" Ability { id: \"78F1\", source: \"Hephaistos\" }\r\n885.3 \"--sync--\" Ability { id: \"78F0\", source: \"Hephaistos\" }\r\n891.2 \"Cthonic Vent 1\" Ability { id: \"78F5\", source: \"Suneater\" }\r\n896.4 \"Volcanic Torches\" Ability { id: \"78F7\", source: \"Hephaistos\" }\r\n899.1 \"Cthonic Vent 2\" Ability { id: \"794D\", source: \"Suneater\" }\r\n907.1 \"Cthonic Vent 3\" Ability { id: \"78F6\", source: \"Suneater\" }\r\n909.5 \"--sync--\" Ability { id: \"7906\", source: \"Hephaistos\" }\r\n910.4 \"Torch Flame\" Ability { id: \"78F8\", source: \"Hephaistos\" }\r\n915.5 \"Hemitheos's Flare\" Ability { id: \"7907\", source: \"Hephaistos\" }\r\n919.7 \"Sunforge\" Ability { id: [\"78EC\", \"78ED\"], source: \"Hephaistos\" }\r\n920.7 \"Scorching Fang/Sun's Pinion\" Ability { id: [\"78EE\", \"78EF\"], source: \"Hephaistos\" }\r\n927.8 \"Genesis of Flame\" Ability { id: \"7905\", source: \"Hephaistos\" }\r\n935.9 \"Genesis of Flame\" Ability { id: \"7905\", source: \"Hephaistos\" }\r\n944.1 \"Flameviper\" Ability { id: \"7908\", source: \"Hephaistos\" }\r\n\r\n# Gorgon v2 (Quadruped2 branch)\r\n952.2 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n957.4 \"Reforged Reflection\" Ability { id: \"794C\", source: \"Hephaistos\" }\r\n969.7 \"Into the Shadows\" Ability { id: \"78FB\", source: \"Hephaistos\" }\r\n977.7 \"--sync--\" Ability { id: \"78FC\", source: \"Gorgon\" }\r\n977.7 \"Gorgospit\" Ability { id: \"6FD7\", source: \"Illusory Hephaistos\" }\r\n977.7 \"Volcanic Torches\" Ability { id: \"71DE\", source: \"Hephaistos\" }\r\n978.7 \"Petrifaction\" Ability { id: \"6723\" }\r\n978.7 \"--targetable--\"\r\n983.9 \"Gorgospit\" Ability { id: \"78FF\", source: \"Hephaistos\" }\r\n990.1 \"Gorgospit\" Ability { id: \"78FF\", source: \"Hephaistos\" }\r\n991.7 \"Torch Flame\" Ability { id: \"78F8\", source: \"Hephaistos\" }\r\n998.3 \"Ektothermos\" Ability { id: \"78FE\", source: \"Hephaistos\" }\r\n\r\n# -> Sunforge v2 (both branches)\r\n1008.7 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n1017.9 \"Sunforge\" Ability { id: [\"78EC\", \"78ED\"], source: \"Hephaistos\" } window 50,50 jump 1317.9\r\n1018.9 \"Scorching Fang/Sun\\'s Pinion\" #Ability { id: [\"78EE\", \"78EF\"], source: \"Hephaistos\" }\r\n1029.1 \"Genesis of Flame\" #Ability { id: \"7905\", source: \"Hephaistos\" }\r\n1037.4 \"Flameviper\" #Ability { id: \"7908\", source: \"Hephaistos\" }\r\n1052.6 \"Sunforge\" #Ability { id: \"78EC\", source: \"Hephaistos\" }\r\n1053.6 \"Scorching Fang/Sun\\'s Pinion\" #Ability { id: [\"78EE\", \"78EF\"], source: \"Hephaistos\" }\r\n\r\n\r\n\r\n# Gorgon v2 (Gorgon2 branch)\r\n1106.5 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n1111.7 \"Reforged Reflection\" Ability { id: \"794C\", source: \"Hephaistos\" }\r\n1124.0 \"Into the Shadows\" Ability { id: \"78FB\", source: \"Hephaistos\" }\r\n1132.0 \"--sync--\" Ability { id: \"78FC\", source: \"Gorgon\" }\r\n1132.0 \"Gorgospit\" Ability { id: \"6FD7\", source: \"Illusory Hephaistos\" }\r\n1132.0 \"Volcanic Torches\" Ability { id: \"71DE\", source: \"Hephaistos\" }\r\n1133.0 \"Petrifaction\" Ability { id: \"6723\" }\r\n1133.0 \"--targetable--\"\r\n1138.2 \"Gorgospit\" Ability { id: \"78FF\", source: \"Hephaistos\" }\r\n1144.4 \"Gorgospit\" Ability { id: \"78FF\", source: \"Hephaistos\" }\r\n1146.0 \"Torch Flame\" Ability { id: \"78F8\", source: \"Hephaistos\" }\r\n1152.6 \"Ektothermos\" Ability { id: \"78FE\", source: \"Hephaistos\" }\r\n\r\n# Vent v2 (Gorgon2 branch)\r\n1163.0 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n1168.1 \"Fourfold Fires\" Ability { id: \"78F2\", source: \"Hephaistos\" }\r\n1173.9 \"Abyssal Fires\" Ability { id: \"78F1\", source: \"Hephaistos\" }\r\n1177.2 \"--sync--\" Ability { id: \"78F0\", source: \"Hephaistos\" }\r\n1183.1 \"Cthonic Vent 1\" Ability { id: \"78F5\", source: \"Suneater\" }\r\n1188.3 \"Volcanic Torches\" Ability { id: \"78F7\", source: \"Hephaistos\" }\r\n1191.0 \"Cthonic Vent 2\" Ability { id: \"794D\", source: \"Suneater\" }\r\n1199.0 \"Cthonic Vent 3\" Ability { id: \"78F6\", source: \"Suneater\" }\r\n1201.4 \"--sync--\" Ability { id: \"7906\", source: \"Hephaistos\" }\r\n1202.3 \"Torch Flame\" Ability { id: \"78F8\", source: \"Hephaistos\" }\r\n1207.4 \"Hemitheos's Flare\" Ability { id: \"7907\", source: \"Hephaistos\" }\r\n1211.6 \"Sunforge\" Ability { id: [\"78EC\", \"78ED\"], source: \"Hephaistos\" }\r\n1212.6 \"Scorching Fang/Sun's Pinion\" Ability { id: [\"78EE\", \"78EF\"], source: \"Hephaistos\" }\r\n1219.7 \"Genesis of Flame\" Ability { id: \"7905\", source: \"Hephaistos\" }\r\n1227.8 \"Genesis of Flame\" Ability { id: \"7905\", source: \"Hephaistos\" }\r\n1236.0 \"Flameviper\" Ability { id: \"7908\", source: \"Hephaistos\" }\r\n\r\n# Quadruped v2 (Gorgon2 branch)\r\n1244.1 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n1249.3 \"Reforged Reflection\" Ability { id: \"794B\", source: \"Hephaistos\" }\r\n1259.9 \"Quadrupedal Crush\" Ability { id: \"7904\", source: \"Hephaistos\" }\r\n1265.9 \"--sync--\" Ability { id: \"790B\", source: \"Hephaistos\" }\r\n1274.6 \"Blazing Footfalls\" Ability { id: \"790A\", source: \"Hephaistos\" }\r\n1274.6 \"--untargetable--\"\r\n1275.3 \"Trailblaze\" Ability { id: \"790D\", source: \"Hephaistos\" }\r\n1277.8 \"Quadrupedal Impact 1\" Ability { id: \"7103\", source: \"Hephaistos\" }\r\n1280.6 \"Quadrupedal Impact 2\" Ability { id: \"7103\", source: \"Hephaistos\" }\r\n1283.4 \"Quadrupedal Impact 3\" Ability { id: \"7103\", source: \"Hephaistos\" }\r\n1285.2 \"--targetable--\"\r\n1295.3 \"Rearing Rampage\" Ability { id: \"79AB\", source: \"Hephaistos\" }\r\n\r\n# Sunforge v2 (both branches)\r\n1308.7 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n1317.9 \"Sunforge\" Ability { id: [\"78EC\", \"78ED\"], source: \"Hephaistos\" }\r\n1318.9 \"Scorching Fang/Sun\\'s Pinion\" Ability { id: [\"78EE\", \"78EF\"], source: \"Hephaistos\" }\r\n1329.1 \"Genesis of Flame\" Ability { id: \"7905\", source: \"Hephaistos\" }\r\n1337.4 \"Flameviper\" Ability { id: \"7908\", source: \"Hephaistos\" }\r\n1352.6 \"Sunforge\" Ability { id: \"78EC\", source: \"Hephaistos\" }\r\n1353.6 \"Scorching Fang/Sun\\'s Pinion\" Ability { id: [\"78EE\", \"78EF\"], source: \"Hephaistos\" }\r\n# jump to Quadruped v2 or Gorgon v2\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> Quadruped v2 branch\r\n1360.8 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n1366.0 \"Reforged Reflection\" Ability { id: \"794B\", source: \"Hephaistos\" } window 50,50 jump 811.7\r\n1376.6 \"Quadrupedal Crush?\" #Ability { id: \"7904\", source: \"Hephaistos\" }\r\n1382.6 \"--sync--\" #Ability { id: \"790B\", source: \"Hephaistos\" }\r\n1391.3 \"Blazing Footfalls?\" #Ability { id: \"790A\", source: \"Hephaistos\" }\r\n\r\n# -> Gorgon v2 branch\r\n1360.8 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n1366.0 \"--sync--\" Ability { id: \"794C\", source: \"Hephaistos\" } window 50,50 jump 1111.7\r\n1378.3 \"Into the Shadows?\" #Ability { id: \"78FB\", source: \"Hephaistos\" }\r\n1386.3 \"--sync--\" #Ability { id: \"78FC\", source: \"Gorgon\" }\r\n1386.3 \"Gorgospit?\" #Ability { id: \"6FD7\", source: \"Illusory Hephaistos\" }\r\n1386.3 \"Volcanic Torches?\" #Ability { id: \"71DE\", source: \"Hephaistos\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p8s.ts







// TODO: call out shriek specifically again when debuff soon? (or maybe even gaze/poison/stack too?)
// TODO: initial tank auto call on final boss as soon as boss pulled
const towerColors = (/* unused pure expression or super */ null && (['green', 'blue', 'purple']));
const perfectedConcepts = ['alpha', 'beta', 'gamma'];
const p8s_centerX = 100;
const p8s_centerY = 100;
const positionMatchesTo8Dir = combatant => {
  const x = parseFloat(combatant.x) - p8s_centerX;
  const y = parseFloat(combatant.y) - p8s_centerY;

  // Dirs: N = 0, NE = 1, ..., NW = 7
  return Math.round(4 - 4 * Math.atan2(x, y) / Math.PI) % 8;
};
const p8s_positionTo8Dir = combatant => {
  const x = combatant.PosX - p8s_centerX;
  const y = combatant.PosY - p8s_centerY;

  // Dirs: N = 0, NE = 1, ..., NW = 7
  return Math.round(4 - 4 * Math.atan2(x, y) / Math.PI) % 8;
};
const headingTo8Dir = heading => {
  // Dirs: N = 0, NE = 1, ..., NW = 7
  return (2 - Math.round(heading * 8 / Math.PI) / 2 + 2) % 8;
};
const ventOutputStrings = {
  comboDir: {
    en: '${dir1} / ${dir2}',
    de: '${dir1} / ${dir2}',
    fr: '${dir1} / ${dir2}',
    ja: '${dir1} / ${dir2}',
    cn: '${dir1} / ${dir2}',
    ko: '${dir1} / ${dir2}'
  },
  north: outputs/* default.north */.Z.north,
  east: outputs/* default.east */.Z.east,
  south: outputs/* default.south */.Z.south,
  west: outputs/* default.west */.Z.west,
  dirNE: outputs/* default.dirNE */.Z.dirNE,
  dirSE: outputs/* default.dirSE */.Z.dirSE,
  dirSW: outputs/* default.dirSW */.Z.dirSW,
  dirNW: outputs/* default.dirNW */.Z.dirNW,
  unknown: outputs/* default.unknown */.Z.unknown
};

// Shared alertText for vent triggers, using `ventOutputStrings` above.
const ventOutput = (unsafeSpots, output) => {
  const [unsafe0, unsafe1] = [...unsafeSpots].sort();
  if (unsafe0 === undefined || unsafe1 === undefined) throw new not_reached/* UnreachableCode */.$();

  // edge case wraparound
  if (unsafe0 === 1 && unsafe1 === 7) return output.south();

  // adjacent unsafe spots, cardinal is safe
  if (unsafe1 - unsafe0 === 2) {
    // this average is safe to do because wraparound was taken care of above.
    const unsafeCard = Math.floor((unsafe0 + unsafe1) / 2);
    const safeDirMap = {
      0: output.south(),
      // this won't happen, but here for completeness
      2: output.west(),
      4: output.north(),
      6: output.east()
    };
    return safeDirMap[unsafeCard] ?? output.unknown();
  }

  // two intercards are safe, they are opposite each other,
  // so we can pick the intercard counterclock of each unsafe spot.
  // e.g. 1/5 are unsafe (NE and SW), so SE and NW are safe.
  const safeIntercardMap = {
    1: output.dirNW(),
    3: output.dirNE(),
    5: output.dirSE(),
    7: output.dirSW()
  };
  const safeStr0 = safeIntercardMap[unsafe0] ?? output.unknown();
  const safeStr1 = safeIntercardMap[unsafe1] ?? output.unknown();
  return output.comboDir({
    dir1: safeStr0,
    dir2: safeStr1
  });
};
const arcaneChannelFlags = '00020001'; // mapEffect flags for tower tile effect

const p8s_triggerSet = {
  id: 'AbyssosTheEighthCircleSavage',
  zoneId: zone_id/* default.AbyssosTheEighthCircleSavage */.Z.AbyssosTheEighthCircleSavage,
  timelineFile: 'p8s.txt',
  initData: () => {
    return {
      combatantData: [],
      torches: [],
      flareTargets: [],
      upliftCounter: 0,
      footfallsDirs: [],
      footfallsOrder: [],
      trailblazeCount: 0,
      ventCasts: [],
      gorgons: [],
      gorgonCount: 0,
      firstSnakeOrder: {},
      firstSnakeDebuff: {},
      secondSnakeGazeFirst: {},
      secondSnakeDebuff: {},
      concept: {},
      splicer: {},
      arcaneChannelCount: 0,
      arcaneChannelColor: new Set(),
      alignmentTargets: [],
      burstCounter: 0,
      flareCounter: 0,
      inverseMagics: {},
      deformationHit: [],
      deformationNotHit: [],
      deformationOnMe: false
    };
  },
  timelineTriggers: [{
    id: 'P8S Tank Cleave Autos',
    regex: /--auto--/,
    beforeSeconds: 8,
    suppressSeconds: 20,
    alertText: (data, _matches, output) => {
      // TODO: because of how the timeline starts in a doorboss fight, this call occurs
      // somewhere after the first few autos and so feels really weird.  Ideally, figure
      // out some way to call this out immediately when combat starts?? Maybe off engage?
      if (data.seenFirstTankAutos) return output.text();
    },
    run: data => data.seenFirstTankAutos = true,
    outputStrings: {
      text: {
        en: 'Tank Autos',
        de: 'Tank Auto-Angriffe',
        fr: 'Auto sur le tank',
        ja: 'タンクオートアタック',
        cn: '坦克平A',
        ko: '탱커 평타'
      }
    }
  }],
  triggers: [
  // ---------------- Part 1 ----------------
  {
    id: 'P8S Genesis of Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '7944',
      source: 'Hephaistos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P8S Scorching Fang',
    type: 'StartsUsing',
    netRegex: {
      id: '7912',
      source: 'Hephaistos',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.conceptual === 'octa') return output.outAndSpread();
      if (data.conceptual === 'tetra') return output.outAndStacks();
      return output.out();
    },
    run: data => delete data.conceptual,
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      outAndSpread: {
        en: 'Out + Spread',
        de: 'Raus + Verteilen',
        fr: 'Extérieur + Écartez-vous',
        ja: '黒線の外側 + 散会',
        cn: '黑线外侧 + 分散',
        ko: '밖으로 + 산개'
      },
      outAndStacks: {
        en: 'Out + Stacks',
        de: 'Raus + Sammeln',
        fr: 'Extérieur + Package',
        ja: '黒線の外側 + 2人頭割り',
        cn: '黑线外侧 + 2人分摊',
        ko: '밖으로 + 쉐어'
      }
    }
  }, {
    id: 'P8S Sun\'s Pinion',
    type: 'StartsUsing',
    netRegex: {
      id: '7913',
      source: 'Hephaistos',
      capture: false
    },
    // There are two casts, one for each side.
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      if (data.conceptual === 'octa') return output.inAndSpread();
      if (data.conceptual === 'tetra') return output.inAndStacks();
      return output.in();
    },
    run: data => delete data.conceptual,
    outputStrings: {
      in: outputs/* default.in */.Z["in"],
      inAndSpread: {
        en: 'In + Spread',
        de: 'Rein + Verteilen',
        fr: 'Intérieur + Écartez-vous',
        ja: '黒線の内側 + 散会',
        cn: '黑线内侧 + 分散',
        ko: '안으로 + 산개'
      },
      inAndStacks: {
        en: 'In + Stacks',
        de: 'Rein + Sammeln',
        fr: 'Intérieur + Package',
        ja: '黒線の内側 + 2人頭割り',
        cn: '黑线内侧 + 2人分摊',
        ko: '안으로 + 쉐어'
      }
    }
  }, {
    id: 'P8S Flameviper',
    type: 'StartsUsing',
    netRegex: {
      id: '7945',
      source: 'Hephaistos'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'P8S Conceptual Diflare Quadruped',
    type: 'StartsUsing',
    // 7915 normally
    // 7916 during Blazing Footfalls
    netRegex: {
      id: '7917',
      source: 'Hephaistos',
      capture: false
    },
    durationSeconds: 12,
    infoText: (_data, _matches, output) => output.healerGroups(),
    run: (data, _matches, output) => data.footfallsConcept = output.healerGroups(),
    outputStrings: {
      healerGroups: outputs/* default.healerGroups */.Z.healerGroups
    }
  }, {
    id: 'P8S Conceptual Tetraflare Quadruped',
    type: 'StartsUsing',
    // 7915 normally
    // 7916 during Blazing Footfalls
    netRegex: {
      id: '7916',
      source: 'Hephaistos',
      capture: false
    },
    durationSeconds: 12,
    infoText: (_data, _matches, output) => output.text(),
    run: (data, _matches, output) => data.footfallsConcept = output.text(),
    outputStrings: {
      text: {
        en: 'Partner Stacks',
        de: 'Mit Partner sammeln',
        fr: 'Package avec votre partenaire',
        ja: '2人頭割り',
        cn: '2人分摊',
        ko: '2인 쉐어'
      }
    }
  }, {
    id: 'P8S Conceptual Tetraflare',
    type: 'StartsUsing',
    // 7915 normally
    // 7916 during Blazing Footfalls
    netRegex: {
      id: '7915',
      source: 'Hephaistos',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.conceptual = 'tetra',
    outputStrings: {
      text: {
        en: '(partner stack, for later)',
        de: '(Partner-Stacks, für später)',
        fr: '(Package partenaire, pour après)',
        ja: '(後で2人頭割り)',
        cn: '(稍后 2人分摊)',
        ko: '(곧 2인 쉐어)'
      }
    }
  }, {
    id: 'P8S Conceptual Octaflare',
    type: 'StartsUsing',
    netRegex: {
      id: '7914',
      source: 'Hephaistos',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.conceptual = 'octa',
    outputStrings: {
      text: {
        en: '(spread, for later)',
        de: '(Verteilen, für später)',
        fr: '(Écartez-vous, pour après)',
        ja: '(後で散会)',
        cn: '(稍后 分散)',
        ko: '(곧 산개)'
      }
    }
  }, {
    id: 'P8S Octaflare',
    type: 'StartsUsing',
    netRegex: {
      id: '791D',
      source: 'Hephaistos',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread('alarm')
  }, {
    id: 'P8S Tetraflare',
    type: 'StartsUsing',
    // During vents and also during clones.
    netRegex: {
      id: '791E',
      source: 'Hephaistos',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.illusory === 'bird') return output.inAndStacks();
      if (data.illusory === 'snake') return output.outAndStacks();
      return output.stacks();
    },
    run: data => delete data.illusory,
    outputStrings: {
      inAndStacks: {
        en: 'In + Stacks',
        de: 'Rein + Sammeln',
        fr: 'Intérieur + Package',
        ja: '黒線の内側 + 2人頭割り',
        cn: '黑线内侧 + 2人分摊',
        ko: '안으로 + 쉐어'
      },
      outAndStacks: {
        en: 'Out + Stacks',
        de: 'Raus + Sammeln',
        fr: 'Extérieur + Package',
        ja: '黒線の外側 + 2人頭割り',
        cn: '黑线外侧 + 2人分摊',
        ko: '밖으로 + 쉐어'
      },
      stacks: {
        en: 'Partner Stacks',
        de: 'Mit Partner sammeln',
        fr: 'Package avec votre partenaire',
        ja: '2人頭割り',
        cn: '2人分摊',
        ko: '2인 쉐어'
      }
    }
  }, {
    id: 'P8S Nest of Flamevipers',
    type: 'StartsUsing',
    // During clones.
    netRegex: {
      id: '791F',
      source: 'Hephaistos',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.illusory === 'bird') return output.inAndProtean();
      if (data.illusory === 'snake') return output.outAndProtean();
      // This shouldn't happen, but just in case.
      return output.protean();
    },
    run: data => delete data.illusory,
    outputStrings: {
      inAndProtean: {
        en: 'In + Protean',
        de: 'Rein + Himmelsrichtung',
        fr: 'Intérieur + Positions',
        ja: '黒線の内側 + 基本散会',
        cn: '黑线内侧 + 分散引导',
        ko: '안으로 + 산개'
      },
      outAndProtean: {
        en: 'Out + Protean',
        de: 'Raus + Himmelsrichtung',
        fr: 'Extérieur + Positions',
        ja: '黒線の外側 + 散会',
        cn: '黑线外侧 + 分散引导',
        ko: '밖으로 + 산개'
      },
      protean: {
        en: 'Protean',
        de: 'Himmelsrichtung',
        fr: 'Positions',
        ja: '散会',
        cn: '分散',
        ko: '산개'
      }
    }
  }, {
    id: 'P8S Torch Flame Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '7927',
      source: 'Hephaistos'
    },
    run: (data, matches) => data.torches.push(matches)
  }, {
    id: 'P8S Torch Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '7927',
      source: 'Hephaistos',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    promise: async data => {
      data.combatantData = [];
      const ids = data.torches.map(torch => parseInt(torch.sourceId, 16));
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: ids
      })).combatants;
      data.torches = [];
    },
    alertText: (data, _matches, output) => {
      if (data.combatantData.length === 0) return;
      const safe = {
        cornerNW: true,
        cornerNE: true,
        cornerSE: true,
        cornerSW: true,
        // Unlike normal mode, these "outside" are two tiles and not 4,
        // e.g. "outsideNorth" = NNW/NNE tiles.
        // The ordering here matters.
        outsideNorth: true,
        insideNorth: true,
        outsideWest: true,
        insideWest: true,
        outsideEast: true,
        insideEast: true,
        outsideSouth: true,
        insideSouth: true
      };

      // idx = x + y * 4
      // This map is the tile index mapped to the keys that any
      // torch exploding on that square would make unsafe.
      const unsafeMap = {
        0: ['cornerNW'],
        1: ['outsideNorth'],
        2: ['outsideNorth'],
        3: ['cornerNE'],
        4: ['outsideWest'],
        5: ['insideWest', 'insideNorth'],
        6: ['insideEast', 'insideNorth'],
        7: ['outsideEast'],
        8: ['outsideWest'],
        9: ['insideWest', 'insideSouth'],
        10: ['insideEast', 'insideSouth'],
        11: ['outsideEast'],
        12: ['cornerSW'],
        13: ['outsideSouth'],
        14: ['outsideSouth'],
        15: ['cornerSE']
      };

      // Loop through all torches, remove any rows/columns it intersects with
      // to find safe lanes.
      for (const torch of data.combatantData) {
        // x, y = 85, 95, 105, 115
        // map to ([0, 3], [0, 3])
        const x = Math.floor((torch.PosX - 85) / 10);
        const y = Math.floor((torch.PosY - 85) / 10);
        const idx = x + y * 4;
        const unsafeArr = unsafeMap[idx];
        for (const entry of unsafeArr ?? []) delete safe[entry];
      }
      const safeKeys = Object.keys(safe);
      const [safe0, safe1, safe2, safe3] = safeKeys;

      // Unexpectedly zero safe zones.
      if (safe0 === undefined) return;

      // Blazing Foothills will have 4 safe spots
      // However, it will only be East or West
      if (data.trailblazeCount === 1) {
        if (safeKeys.length !== 3) return;
        if (safe0 === 'cornerNE' && safe1 === 'cornerSE' && safe2 === 'outsideEast') data.trailblazeTorchSafeZone = 'east';
        if (safe0 === 'cornerNW' && safe1 === 'cornerSW' && safe2 === 'outsideWest') data.trailblazeTorchSafeZone = 'west';
        return;
      }

      // Special case inner four squares.
      if (safeKeys.length === 4 &&
      // Ordered same as keys above.
      safe0 === 'insideNorth' && safe1 === 'insideWest' && safe2 === 'insideEast' && safe3 === 'insideSouth') return output.insideSquare();

      // Not set up to handle more than two safe zones.
      if (safe2 !== undefined) return;
      if (safe1 === undefined) return output[safe0]();
      const dir1 = output[safe0]();
      const dir2 = output[safe1]();
      return output.combo({
        dir1: dir1,
        dir2: dir2
      });
    },
    outputStrings: {
      combo: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        ja: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      },
      insideSquare: {
        en: 'Inside Square',
        de: 'Inneres Viereck',
        fr: 'Intérieur carré',
        ja: '内側の四角の中',
        cn: '场中',
        ko: '중앙'
      },
      cornerNW: {
        en: 'NW Corner',
        de: 'NW Ecke',
        fr: 'Coin NO',
        ja: '北西の隅',
        cn: '左上 (西北) 角',
        ko: '북서쪽 구석'
      },
      cornerNE: {
        en: 'NE Corner',
        de: 'NO Ecke',
        fr: 'Coin NE',
        ja: '北東の隅',
        cn: '右上 (东北) 角',
        ko: '북동쪽 구석'
      },
      cornerSE: {
        en: 'SE Corner',
        de: 'SO Ecke',
        fr: 'Coin SE',
        ja: '南東の隅',
        cn: '右下 (东南) 角',
        ko: '남동쪽 구석'
      },
      cornerSW: {
        en: 'SW Corner',
        de: 'SW Ecke',
        fr: 'Coin SO',
        ja: '南西の隅',
        cn: '左下 (西南) 角',
        ko: '남서쪽 구석'
      },
      outsideNorth: {
        en: 'Outside North',
        de: 'Im Norden raus',
        fr: 'Nord Extérieur',
        ja: '北の外側',
        cn: '上 (北) 外侧',
        ko: '북쪽 바깥'
      },
      insideNorth: {
        en: 'Inside North',
        de: 'Im Norden rein',
        fr: 'Nord Intérieur',
        ja: '北の内側',
        cn: '上 (北) 内侧',
        ko: '북쪽 안'
      },
      outsideEast: {
        en: 'Outside East',
        de: 'Im Osten raus',
        fr: 'Est Extérieur',
        ja: '東の外側',
        cn: '右 (东) 外侧',
        ko: '동쪽 바깥'
      },
      insideEast: {
        en: 'Inside East',
        de: 'Im Osten rein',
        fr: 'Est Intérieur',
        ja: '東の内側',
        cn: '右 (东) 内侧',
        ko: '동쪽 안'
      },
      outsideSouth: {
        en: 'Outside South',
        de: 'Im Süden raus',
        fr: 'Sud Extérieur',
        ja: '南の外側',
        cn: '下 (南) 外侧',
        ko: '남쪽 바깥'
      },
      insideSouth: {
        en: 'Inside South',
        de: 'Im Süden rein',
        fr: 'Sud Intérieur',
        ja: '南の内側',
        cn: '下 (南) 内侧',
        ko: '남쪽 안'
      },
      outsideWest: {
        en: 'Outside West',
        de: 'Im Westen raus',
        fr: 'Ouest Extérieur',
        ja: '西の外側',
        cn: '左 (西) 外侧',
        ko: '서쪽 바깥'
      },
      insideWest: {
        en: 'Inside West',
        de: 'Im Westen rein',
        fr: 'Ouest Intérieur',
        ja: '西の内側',
        cn: '左 (西) 内侧',
        ko: '서쪽 안'
      }
    }
  }, {
    id: 'P8S Ektothermos',
    type: 'StartsUsing',
    netRegex: {
      id: '79EA',
      source: 'Hephaistos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P8S Footprint',
    type: 'Ability',
    // There is 6.4 seconds between this Reforged Reflection ability and the Footprint (7109) ability.
    netRegex: {
      id: '794B',
      source: 'Hephaistos',
      capture: false
    },
    delaySeconds: 1.5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'P8S Snaking Kick',
    type: 'StartsUsing',
    // This is the Reforged Reflection cast.
    netRegex: {
      id: '794C',
      source: 'Hephaistos',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'P8S Gorgon Collect',
    type: 'AddedCombatant',
    netRegex: {
      npcNameId: '11517',
      npcBaseId: '15052'
    },
    // We could technically call WAY ahead of time here.
    run: (data, matches) => data.gorgons.push(matches)
  }, {
    id: 'P8S Gorgon Location',
    type: 'StartsUsing',
    // We could call the very first one out immediately on the Added Combatant line,
    // but then we'd have to duplicate this.
    netRegex: {
      id: '792B',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      data.gorgonCount++;

      // Gorgons fire in order of actor id (highest first), but are added in any order.
      // Sort from lowest id to highest, so we can pull off the end.
      data.gorgons.sort((a, b) => a.id.localeCompare(b.id));
      const gorgons = [];
      if (data.gorgonCount === 1 || data.gorgonCount === 2) {
        // For Snake 1, all positions are known ahead of time, so do 2 at a time.
        const g0 = data.gorgons.pop();
        const g1 = data.gorgons.pop();
        if (g0 === undefined || g1 === undefined) return;
        gorgons.push(g0);
        gorgons.push(g1);
      } else {
        // For Snake 2, just call all at once.
        gorgons.push(...data.gorgons);
        data.gorgons = [];
      }
      if (gorgons.length !== 2 && gorgons.length !== 4) return;
      const dirs = gorgons.map(positionMatchesTo8Dir).sort();
      const [d0, d1] = dirs;
      if (d0 === undefined || d1 === undefined) return;
      if (dirs.length === 4) return d0 === 0 ? output.intercards() : output.cardinals();
      const outputMap = {
        0: output.dirN(),
        1: output.dirNE(),
        2: output.dirE(),
        3: output.dirSE(),
        4: output.dirS(),
        5: output.dirSW(),
        6: output.dirW(),
        7: output.dirNW()
      };
      const dir1 = outputMap[d0] ?? output.unknown();
      const dir2 = outputMap[d1] ?? output.unknown();
      return output.gorgons({
        dir1: dir1,
        dir2: dir2
      });
    },
    outputStrings: {
      cardinals: {
        en: 'Look Cardinals',
        de: 'Schaue Kardinal',
        fr: 'Regardez en cardinal',
        ja: '視線を十字に',
        cn: '看正点',
        ko: '시선을 동서남북쪽으로'
      },
      intercards: {
        en: 'Look Intercards',
        de: 'Schaue Interkardinal',
        fr: 'Regardez en intercardinal',
        ja: '視線を斜めに',
        cn: '看斜点',
        ko: '시선을 대각선쪽으로'
      },
      gorgons: {
        en: '${dir1}/${dir2} Gorgons',
        de: '${dir1}/${dir2} Gorgone',
        fr: 'Gorgones ${dir1}/${dir2}',
        ja: 'ゴルゴン：${dir1}/${dir2}',
        cn: '蛇: ${dir1}/${dir2}',
        ko: '${dir1}/${dir2} 고르곤'
      },
      dirN: outputs/* default.dirN */.Z.dirN,
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirE: outputs/* default.dirE */.Z.dirE,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirS: outputs/* default.dirS */.Z.dirS,
      dirSW: outputs/* default.dirSW */.Z.dirSW,
      dirW: outputs/* default.dirW */.Z.dirW,
      dirNW: outputs/* default.dirNW */.Z.dirNW,
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'P8S First Snake Debuff Collect',
    // BBC = First in Line
    // BBD = Second in Line,
    // D17 = Eye of the Gorgon
    // D18 = Crown of the Gorgon
    // CFE = Blood of the Gorgon
    // CFF = Breath of the Gorgon
    type: 'GainsEffect',
    netRegex: {
      effectId: ['BB[CD]', 'D17', 'CFE']
    },
    condition: data => !data.firstSnakeCalled,
    run: (data, matches) => {
      const id = matches.effectId;
      if (id === 'BBC') data.firstSnakeOrder[matches.target] = 1;else if (id === 'BBD') data.firstSnakeOrder[matches.target] = 2;else if (id === 'D17') data.firstSnakeDebuff[matches.target] = 'gaze';else if (id === 'CFE') data.firstSnakeDebuff[matches.target] = 'poison';
    }
  }, {
    id: 'P8S First Snake Debuff Initial Call',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['BB[CD]', 'D17', 'CFE'],
      capture: false
    },
    condition: data => !data.firstSnakeCalled,
    delaySeconds: 0.3,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        firstGaze: {
          en: 'First Gaze (w/ ${player})',
          de: 'Erster Blick (+ ${player})',
          fr: 'Premier Regard (+ ${player})',
          ja: '先の石化 (+${player})',
          cn: '1组 石化 (+ ${player})',
          ko: '첫번째 석화 (+ ${player})'
        },
        secondGaze: {
          en: 'Second Gaze (w/ ${player})',
          de: 'Zweiter Blick (+ ${player})',
          fr: 'Second Regard (+ ${player})',
          ja: '後の石化 (+${player})',
          cn: '2组 石化 (+ ${player})',
          ko: '두번째 석화 (+ ${player})'
        },
        firstPoison: {
          en: 'First Poison (w/ ${player})',
          de: 'Erstes Gift (+ ${player})',
          fr: 'Premier Poison (+ ${player})',
          ja: '先の毒 (+${player})',
          cn: '1组 毒 (+ ${player})',
          ko: '첫번째 독장판 (+ ${player})'
        },
        secondPoison: {
          en: 'Second Poison (w/ ${player})',
          de: 'Zweites Gift (+ ${player})',
          fr: 'Second Poison (+ ${player})',
          ja: '後の毒 (+${player})',
          cn: '2组 毒 (+ ${player})',
          ko: '두번째 독장판 (+ ${player})'
        },
        unknown: outputs/* default.unknown */.Z.unknown
      };
      const myNumber = data.firstSnakeOrder[data.me];
      if (myNumber === undefined) return;
      const myDebuff = data.firstSnakeDebuff[data.me];
      if (myDebuff === undefined) return;
      let partner = output.unknown();
      for (const [name, theirDebuff] of Object.entries(data.firstSnakeDebuff)) {
        if (myDebuff !== theirDebuff || name === data.me) continue;
        const theirNumber = data.firstSnakeOrder[name];
        if (myNumber === theirNumber) {
          partner = data.party.member(name);
          break;
        }
      }
      if (myNumber === 1) {
        if (myDebuff === 'gaze') return {
          alertText: output.firstGaze({
            player: partner
          })
        };
        return {
          alertText: output.firstPoison({
            player: partner
          })
        };
      }
      if (myDebuff === 'gaze') return {
        infoText: output.secondGaze({
          player: partner
        })
      };
      return {
        infoText: output.secondPoison({
          player: partner
        })
      };
    },
    run: data => data.firstSnakeCalled = true
  }, {
    id: 'P8S Second Snake Debuff Collect',
    // D17 = Eye of the Gorgon (gaze)
    // D18 = Crown of the Gorgon (shriek)
    // CFE = Blood of the Gorgon (small poison)
    // CFF = Breath of the Gorgon (stack poison)
    type: 'GainsEffect',
    netRegex: {
      effectId: ['D1[78]', 'CFF']
    },
    condition: data => data.firstSnakeCalled,
    run: (data, matches) => {
      const id = matches.effectId;
      if (id === 'D17') {
        // 23s short, 29s long
        const duration = parseFloat(matches.duration);
        data.secondSnakeGazeFirst[matches.target] = duration < 24;
        data.secondSnakeDebuff[matches.target] ??= 'nothing';
      } else if (id === 'D18') {
        data.secondSnakeDebuff[matches.target] = 'shriek';
      } else if (id === 'CFF') {
        data.secondSnakeDebuff[matches.target] = 'stack';
      }
    }
  }, {
    id: 'P8S Second Snake Debuff Initial Call',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['D1[78]', 'CFF'],
      capture: false
    },
    condition: data => data.firstSnakeCalled,
    delaySeconds: 0.3,
    durationSeconds: 6,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        firstGaze: {
          en: 'First Gaze',
          de: 'Erster Blick',
          fr: 'Premier Regard',
          ja: '先の石化',
          cn: '1组 石化',
          ko: '첫번째 석화'
        },
        secondGaze: {
          en: 'Second Gaze',
          de: 'Zweiter Blick',
          fr: 'Second Regard',
          ja: '後の石化',
          cn: '2组 石化',
          ko: '두번째 석화'
        },
        shriek: {
          en: 'Shriek later (with ${player})',
          de: 'Schrei später (mit ${player})',
          fr: 'Cri plus tard (avec ${player})',
          ja: '自分に魔眼 (+${player})',
          cn: '石化点名 (+ ${player}',
          ko: '나중에 마안 (+ ${player})'
        },
        stack: {
          en: 'Stack later (with ${player})',
          de: 'Später sammeln (mit ${player})',
          fr: 'Package plus tard (avec ${player})',
          ja: '自分に頭割り (+${player})',
          cn: '稍后分摊 (与${player})',
          ko: '나중에 쉐어 (+ ${player})'
        },
        noDebuff: {
          en: 'No debuff (w/ ${player1}, ${player2}, ${player3})',
          de: 'Kein Debuff (+ ${player1}, ${player2}, ${player3})',
          fr: 'Aucun debuff (+ ${player1}, ${player2}, ${player3})',
          ja: '無職 (${player1}, ${player2}, ${player3})',
          cn: '无Debuff (+ ${player1}, ${player2}, ${player3})',
          ko: '디버프 없음 (+ ${player1}, ${player2}, ${player3})'
        }
      };
      const isGazeFirst = data.secondSnakeGazeFirst[data.me];
      const myDebuff = data.secondSnakeDebuff[data.me];
      if (isGazeFirst === undefined || myDebuff === undefined) return;
      const friends = [];
      for (const [name, theirDebuff] of Object.entries(data.secondSnakeDebuff)) {
        if (myDebuff === theirDebuff && name !== data.me) friends.push(data.party.member(name));
      }
      const gazeAlert = isGazeFirst ? output.firstGaze() : output.secondGaze();
      if (myDebuff === 'nothing') {
        return {
          alertText: gazeAlert,
          infoText: output.noDebuff({
            player1: friends[0],
            player2: friends[1],
            player3: friends[2]
          })
        };
      }
      if (myDebuff === 'shriek') {
        return {
          alertText: gazeAlert,
          infoText: output.shriek({
            player: friends[0]
          })
        };
      }
      if (myDebuff === 'stack') {
        return {
          alertText: gazeAlert,
          infoText: output.stack({
            player: friends[0]
          })
        };
      }
    }
  }, {
    id: 'P8S Uplift Counter',
    type: 'Ability',
    netRegex: {
      id: '7935',
      source: 'Hephaistos',
      capture: false
    },
    // Count in a separate trigger so that we can suppress it, but still call out for
    // both people hit.
    preRun: (data, _matches) => data.upliftCounter++,
    durationSeconds: 1.7,
    suppressSeconds: 1,
    sound: '',
    infoText: (data, _matches, output) => output.text({
      num: data.upliftCounter
    }),
    tts: null,
    outputStrings: {
      text: {
        en: '${num}',
        de: '${num}',
        fr: '${num}',
        ja: '${num}番',
        cn: '${num}',
        ko: '${num}'
      }
    }
  }, {
    id: 'P8S Uplift Number',
    type: 'Ability',
    netRegex: {
      id: '7935',
      source: 'Hephaistos'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // ~12.8 seconds between #1 Uplift (7935) to #1 Stomp Dead (7937)
    // ~13.8 seconds between #4 Uplift (7935) to #4 Stomp Dead (7937).
    // Split the difference with 13.3 seconds.
    durationSeconds: 13.3,
    alertText: (data, _matches, output) => output.text({
      num: data.upliftCounter
    }),
    outputStrings: {
      text: {
        en: '${num}',
        de: '${num}',
        fr: '${num}',
        ja: '自分: ${num}番',
        cn: '${num}',
        ko: '${num}'
      }
    }
  }, {
    id: 'P8S Quadrupedal Impact/Crush',
    // 7A04 Quadrupedal Impact
    // 7A05 Quadrupedal Crush
    type: 'StartsUsing',
    netRegex: {
      id: ['7A04', '7A05'],
      source: 'Hephaistos'
    },
    promise: async (data, matches) => {
      // select the Hephaistoss with same source id
      let hephaistosData = null;
      hephaistosData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.sourceId, 16)]
      });

      // if we could not retrieve combatant data, the
      // trigger will not work, so just resume promise here
      if (hephaistosData === null) {
        console.error(`Hephaistos: null data`);
        return;
      }
      if (hephaistosData.combatants.length !== 1) {
        console.error(`Hephaistos: expected 1, got ${hephaistosData.combatants.length}`);
        return;
      }
      const hephaistos = hephaistosData.combatants[0];
      if (!hephaistos) return;

      // Boss faces 3.14159274 or -3.13727832 when North
      // Flip callout if crush (7A05)
      const epsilon = 0.1;
      if (Math.abs(Math.abs(hephaistos.Heading) - 3.14) < epsilon) data.crushImpactSafeZone = matches.id === '7A05' ? 'south' : 'north';
      // Boss will be facing South
      else data.crushImpactSafeZone = matches.id === '7A05' ? 'north' : 'south';
    },
    infoText: (data, matches, output) => {
      if (data.crushImpactSafeZone === undefined) {
        if (matches.id === '7A05') return output.crush();
        return output.impact();
      }
      if (matches.id === '7A05') return output.crushDir({
        dir: output[data.crushImpactSafeZone]()
      });
      return output.impactDir({
        dir: output[data.crushImpactSafeZone]()
      });
    },
    outputStrings: {
      impactDir: {
        en: 'Follow to ${dir} (Knockback)',
        de: 'Nach ${dir} folgen (Rückstoß)',
        fr: 'Allez vers ${dir} (Poussée)',
        ja: '${dir}に近づく (ノックバック)',
        cn: '去 ${dir} 被击退',
        ko: '${dir}으로 따라가기 (넉백)'
      },
      crushDir: {
        en: 'Away to ${dir}',
        de: 'Weg nach ${dir}',
        fr: 'Loin vers ${dir}',
        ja: '${dir}が安置 (クラッシュ)',
        cn: '去 ${dir}',
        ko: '${dir}으로 피하기'
      },
      crush: {
        en: 'Away From Jump',
        de: 'Weg vom Sprung',
        fr: 'Éloignez-vous du saut',
        ja: '離れる',
        cn: '远离跳的方向',
        ko: '멀리 떨어지기'
      },
      impact: {
        en: 'Follow Jump',
        de: 'Sprung folgen',
        fr: 'Suivez le saut',
        ja: '近づく',
        cn: '靠近跳的方向',
        ko: '보스 따라가기'
      },
      north: outputs/* default.north */.Z.north,
      south: outputs/* default.south */.Z.south
    }
  }, {
    id: 'P8S Blazing Footfalls',
    // 793B Trailblaze Shown
    // 793D Quadrupedal Crush Shown
    // 793C Quadrupedal Impact Shown
    // These are shown in the span of 8.5s
    // Blazing Footfalls takes 14.5s to complete +4s to resolve Torch Flames
    type: 'Ability',
    netRegex: {
      id: ['793C', '793D'],
      source: 'Hephaistos'
    },
    preRun: (data, matches) => {
      const x = parseInt(matches.targetX) - 100;
      const y = parseInt(matches.targetY) - 100;
      // 0 = N, 1 = E, etc
      const dir = Math.round(2 - 2 * Math.atan2(x, y) / Math.PI) % 4;
      if (matches.id === '793C') {
        data.footfallsOrder.push('impact');
        data.footfallsDirs.push(dir);
      } else {
        data.footfallsOrder.push('crush');
        data.footfallsDirs.push((dir + 2) % 4);
      }
    },
    durationSeconds: 9,
    infoText: (data, _matches, output) => {
      const dirToCard = {
        0: output.north(),
        1: output.east(),
        2: output.south(),
        3: output.west()
      };
      const validDirs = [0, 1, 2, 3];

      // Output first push direction
      if (data.footfallsDirs[0] !== undefined && data.footfallsOrder[0] !== undefined && data.footfallsDirs[1] === undefined && data.footfallsOrder[1] === undefined) {
        if (!validDirs.includes(data.footfallsDirs[0])) {
          console.error(`Blazing Footfalls: Unexpected dirs, got ${data.footfallsDirs[0]}}`);
          return;
        }
        return output.firstTrailblaze({
          dir: dirToCard[data.footfallsDirs[0]],
          concept: data.footfallsConcept
        });
      }
    },
    outputStrings: {
      firstTrailblaze: {
        en: '${dir} Black Line => ${concept}',
        de: '${dir} Schwarze Linie => ${concept}',
        fr: '${dir} Ligne noire -> ${concept}',
        ja: '${dir}の黒線 => ${concept}',
        cn: '${dir} 黑线 => ${concept}',
        ko: '${dir} 검은 선 => ${concept}'
      },
      north: outputs/* default.north */.Z.north,
      east: outputs/* default.east */.Z.east,
      south: outputs/* default.south */.Z.south,
      west: outputs/* default.west */.Z.west
    }
  }, {
    id: 'P8S Blazing Footfalls Trailblaze 2',
    type: 'StartsUsing',
    netRegex: {
      id: ['7106', '7107'],
      source: 'Hephaistos',
      capture: false
    },
    condition: data => data.trailblazeCount === 1,
    durationSeconds: 3.9,
    // Keep up until Trailblaze
    infoText: (data, _matches, output) => {
      if (data.footfallsDirs[1] !== undefined && data.footfallsOrder[1] !== undefined) {
        // Check if have valid dirs
        const validDirs = [0, 1, 2, 3];
        if (!validDirs.includes(data.footfallsDirs[1])) {
          console.error(`Blazing Footfalls Reminder: Unexpected dirs, got ${data.footfallsDirs[1]}`);
          return;
        }
        const dirToCard = {
          0: output.north(),
          1: output.east(),
          2: output.south(),
          3: output.west()
        };
        return output.trailblaze({
          dir: dirToCard[data.footfallsDirs[1]],
          action: output[data.footfallsOrder[1]]()
        });
      }
    },
    outputStrings: {
      trailblaze: {
        en: '${dir} Black Line => ${action}',
        de: '${dir} Schwarze Linie => ${action}',
        fr: '${dir} Ligne noire -> ${action}',
        ja: '${dir}の黒線 => ${action}',
        cn: '${dir} 黑线 => ${action}',
        ko: '${dir} 검은 선 => ${action}'
      },
      crush: {
        en: 'Crush',
        de: 'Zerquetschen',
        fr: 'Écrasement',
        ja: 'クラッシュ',
        cn: '碎击',
        ko: '파괴'
      },
      impact: outputs/* default.knockback */.Z.knockback,
      north: outputs/* default.north */.Z.north,
      east: outputs/* default.east */.Z.east,
      south: outputs/* default.south */.Z.south,
      west: outputs/* default.west */.Z.west
    }
  }, {
    id: 'P8S Blazing Footfalls Crush/Impact Reminder',
    // Reminder after Trailblaze for Impact/Crush Movement
    type: 'StartsUsing',
    netRegex: {
      id: '793E',
      source: 'Hephaistos'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime),
    durationSeconds: 4,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        trailblaze: {
          en: 'Wait => ${dir}',
          de: 'Warte => ${dir}',
          fr: 'Attendez -> ${dir}',
          ja: '待機 => ${dir}',
          cn: '等待 => ${dir}',
          ko: '대기 => ${dir}'
        },
        trailblazeKnockback: {
          en: '${dir} Knockback',
          de: '${dir} Rückstoß',
          fr: '${dir} Poussée',
          ja: 'ノックバック: ${dir}',
          cn: '${dir} 击退',
          ko: '${dir} 넉백'
        },
        trailblazeKnockbackToDir: {
          en: '${dir1} Knockback ${dir2}',
          de: '${dir1} Rückstoß ${dir2}',
          fr: '${dir1} Poussée ${dir2}',
          ja: 'ノックバック: ${dir1} => ${dir2}',
          cn: '${dir1} 击退到 ${dir2}',
          ko: '${dir1}에서 ${dir2}으로 넉백'
        },
        trailblazeKnockbackSide: {
          en: 'Knockback ${dir}',
          de: 'Rückstoß ${dir}',
          fr: 'Poussée ${dir}',
          ja: 'ノックバック: ${dir}',
          cn: '${dir} 击退',
          ko: '${dir} 넉백'
        },
        trailblazeCrushSide: {
          en: 'Run ${dir}',
          de: 'Renne nach ${dir}',
          fr: 'Courez ${dir}',
          ja: '${dir}へ走れ',
          cn: '去 ${dir}',
          ko: '${dir}으로 뛰기'
        },
        left: outputs/* default.left */.Z.left,
        right: outputs/* default.right */.Z.right,
        north: outputs/* default.north */.Z.north,
        east: outputs/* default.east */.Z.east,
        south: outputs/* default.south */.Z.south,
        west: outputs/* default.west */.Z.west
      };
      if (data.footfallsDirs[0] !== undefined && data.footfallsOrder[0] !== undefined && data.footfallsDirs[1] !== undefined && data.footfallsOrder[1] !== undefined) {
        // Check if have valid dirs
        const validDirs = [0, 1, 2, 3];
        const dir = data.footfallsDirs[data.trailblazeCount];
        if (dir === undefined) {
          console.error(`Blazing Footfalls Crush/Impact Reminder: Unable to retreive direction.`);
          return;
        }
        if (!validDirs.includes(dir)) {
          if (data.trailblazeCount === 0) console.error(`Blazing Footfalls Crush/Impact Reminder: Unexpected dirs, got ${data.footfallsDirs[0]}`);
          console.error(`Blazing Footfalls Crush/Impact Reminder: Unexpected dirs, got ${data.footfallsDirs[1]}`);
          return;
        }
        const dirToCard = {
          0: output.north(),
          1: output.east(),
          2: output.south(),
          3: output.west()
        };

        // First trailblaze may require moving to new cardinal during Crush/Impact
        if (data.trailblazeCount === 0) {
          // Call move to next push back side if Crush
          // Only need to call this out if there is an upcoming pushback
          if (data.footfallsOrder[data.trailblazeCount] === 'crush') return {
            infoText: output.trailblaze({
              dir: dirToCard[data.footfallsDirs[1]]
            })
          };

          // Call future push location if knockback
          if (data.footfallsOrder[data.trailblazeCount] === 'impact') return {
            infoText: output.trailblazeKnockbackToDir({
              dir1: dirToCard[dir],
              dir2: dirToCard[data.footfallsDirs[1]]
            })
          };
        }

        // Second trailblaze should call torch location
        // Dir is flipped for crush, thus matching knockback direction
        if (data.trailblazeTorchSafeZone === 'east' && dir === 0 || data.trailblazeTorchSafeZone === 'west' && dir === 2) {
          if (data.footfallsOrder[data.trailblazeCount] === 'impact') return {
            alertText: output.trailblazeKnockbackSide({
              dir: output.left()
            })
          };
          if (data.footfallsOrder[data.trailblazeCount] === 'crush') return {
            infoText: output.trailblazeCrushSide({
              dir: output.left()
            })
          };
        }
        if (data.trailblazeTorchSafeZone === 'west' && dir === 0 || data.trailblazeTorchSafeZone === 'east' && dir === 2) {
          if (data.footfallsOrder[data.trailblazeCount] === 'impact') return {
            alertText: output.trailblazeKnockbackSide({
              dir: output.right()
            })
          };
          if (data.footfallsOrder[data.trailblazeCount] === 'crush') return {
            infoText: output.trailblazeCrushSide({
              dir: output.right()
            })
          };
        }
        // Unable to determine direction, output only knockback
        if (data.footfallsOrder[data.trailblazeCount] === 'impact') return {
          alertText: output.trailblazeKnockback({
            dir1: dirToCard[dir]
          })
        };
      }
    },
    run: data => data.trailblazeCount++
  }, {
    id: 'P8S Illusory Hephaistos Scorched Pinion First',
    type: 'StartsUsing',
    // This is "Illusory Hephaistos" but sometimes it says "Gorgon", so drop the name.
    // This trigger calls out the Scorched Pinion location (7953), but is looking
    // for the Scorching Fang (7952) ability.  The reason for this is that there are
    // two casts of 7953 and only one 7952, and there's some suspicion that position
    // data may be incorrect on one of the 7953 mobs.
    netRegex: {
      id: '7952'
    },
    condition: data => data.flareTargets.length === 0,
    // For some reason the position data does not appear to be correct for either
    // 7952 or 7953.  Add a delay to hope that it gets up to date.
    // 7952/7953 is the real damage.  We could also try looking for 7950/7951, which is
    // a different mob with the Sunforge cast bar.  This might be in the correct place.
    delaySeconds: 0.3,
    promise: async (data, matches) => {
      data.combatantData = [];
      const id = parseInt(matches.sourceId, 16);
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [id]
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      const combatant = data.combatantData[0];
      if (combatant === undefined || data.combatantData.length !== 1) return;

      // This trigger finds the snake, so call the opposite.
      const dir = p8s_positionTo8Dir(combatant);
      if (dir === 0 || dir === 4) return output.eastWest();
      if (dir === 2 || dir === 6) return output.northSouth();
    },
    outputStrings: {
      northSouth: {
        en: 'North/South Bird',
        de: 'Norden/Süden Vogel',
        fr: 'Oiseau Nord/Sud',
        ja: '南北フェニックス',
        cn: '南/北 凤凰',
        ko: '새 남/북쪽'
      },
      eastWest: {
        en: 'East/West Bird',
        de: 'Osten/Westen Vogel',
        fr: 'Oiseau Est/Ouest',
        ja: '東西フェニックス',
        cn: '东/西 凤凰',
        ko: '새 동/서쪽'
      }
    }
  }, {
    id: 'P8S Illusory Hephaistos Scorched Pinion Second',
    type: 'StartsUsing',
    netRegex: {
      id: '7953',
      capture: false
    },
    condition: data => data.flareTargets.length > 0,
    suppressSeconds: 1,
    run: data => data.illusory = 'bird'
  }, {
    id: 'P8S Illusory Hephaistos Scorching Fang Second',
    type: 'StartsUsing',
    netRegex: {
      id: '7952',
      capture: false
    },
    condition: data => data.flareTargets.length > 0,
    suppressSeconds: 1,
    run: data => data.illusory = 'snake'
  }, {
    id: 'P8S Hemitheos\'s Flare Hit',
    type: 'Ability',
    netRegex: {
      id: '72CE',
      source: 'Hephaistos'
    },
    preRun: (data, matches) => data.flareTargets.push(matches.target),
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    outputStrings: {
      text: {
        en: '(avoid proteans)',
        de: '(weiche Himmelsrichtungen aus)',
        fr: '(évitez les positions)',
        ja: '(十字で回避)',
        cn: '(远离回避)',
        ko: '(피하기)'
      }
    }
  }, {
    id: 'P8S Hemitheos\'s Flare Not Hit',
    type: 'Ability',
    netRegex: {
      id: '72CE',
      source: 'Hephaistos',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      if (!data.flareTargets.includes(data.me)) return output.text();
    },
    outputStrings: {
      text: {
        en: 'In for Protean',
        de: 'rein für Himmelsrichtungen',
        fr: 'Intérieur pour les positions',
        ja: '近づく、内側で誘導',
        cn: '靠近引导',
        ko: '안에서 장판 유도'
      }
    }
  }, {
    id: 'P8S Suneater Cthonic Vent Initial',
    type: 'StartsUsing',
    netRegex: {
      id: '7925'
    },
    condition: (data, matches) => {
      data.ventCasts.push(matches);
      return data.ventCasts.length === 2;
    },
    // Sometimes these initial positions are incorrect, so compensate with some delay.
    // TODO: can we detect/ignore these incorrect initial positions??
    delaySeconds: 0.5,
    promise: async data => {
      data.combatantData = [];
      const ids = data.ventCasts.map(m => parseInt(m.sourceId, 16));
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: ids
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      if (data.combatantData.length === 0) return;
      const unsafeSpots = data.combatantData.map(c => p8s_positionTo8Dir(c));
      return ventOutput(unsafeSpots, output);
    },
    run: data => data.ventCasts = [],
    outputStrings: ventOutputStrings
  }, {
    id: 'P8S Suneater Cthonic Vent Later',
    type: 'Ability',
    netRegex: {
      id: ['7923', '7924']
    },
    condition: (data, matches) => {
      data.ventCasts.push(matches);
      return data.ventCasts.length === 2;
    },
    delaySeconds: 0.5,
    promise: async data => {
      data.combatantData = [];
      const ids = data.ventCasts.map(m => parseInt(m.sourceId, 16));
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: ids
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      if (data.combatantData.length !== 2) return;
      const unsafeSpots = [];
      for (const c of data.combatantData) {
        const originalPos = p8s_positionTo8Dir(c);
        const heading = headingTo8Dir(c.Heading);

        // There's maybe some way to do this more generally, but I don't see it.
        // Also, if this fails for some reason, it will just not call anything below.
        if (originalPos === 7 && heading === 2 || originalPos === 3 && heading === 0 || originalPos === 5 && heading === 1) {
          // Going towards NE
          unsafeSpots.push(1);
        } else if (originalPos === 1 && heading === 4 || originalPos === 5 && heading === 2 || originalPos === 7 && heading === 3) {
          // Going towards SE
          unsafeSpots.push(3);
        } else if (originalPos === 3 && heading === 6 || originalPos === 1 && heading === 5 || originalPos === 7 && heading === 4) {
          // Going towards SW
          unsafeSpots.push(5);
        } else if (originalPos === 5 && heading === 0 || originalPos === 1 && heading === 6 || originalPos === 3 && heading === 7) {
          // Going towards NW
          unsafeSpots.push(7);
        }
      }
      return ventOutput(unsafeSpots, output);
    },
    run: data => data.ventCasts = [],
    outputStrings: ventOutputStrings
  }, {
    id: 'P8S Snake 2 Illusory Creation',
    type: 'StartsUsing',
    // Illusory Creation happens elsewhere, but this id only in Snake 2.
    // This is used to differentiate the 4x 7932 Gorgospit from the 1x 7932 Gorgospit that
    // (ideally) kills two Gorgons.
    netRegex: {
      id: '7931',
      source: 'Hephaistos',
      capture: false
    },
    run: data => data.seenSnakeIllusoryCreation = true
  }, {
    id: 'P8S Gorgospit Location',
    type: 'StartsUsing',
    netRegex: {
      id: '7932'
    },
    condition: data => data.seenSnakeIllusoryCreation,
    promise: async (data, matches) => {
      data.combatantData = [];
      const id = parseInt(matches.sourceId, 16);
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [id]
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      const combatant = data.combatantData[0];
      if (combatant === undefined || data.combatantData.length !== 1) return;

      // If Gorgons on cardinals, clone is (100, 100+/-20) or (100+/-20, 100).
      // If Gorgons on intercards, clone is (100+/-10, 100+/ 20) or (100+/-20, 100+/-10).
      // Also sometimes it's +/-11 and not +/-10 (???)

      const x = combatant.PosX;
      const y = combatant.PosY;

      // Add a little slop to find positions, just in case.  See note above about 11 vs 10.
      const epsilon = 3;

      // Handle 4x potential locations for line hitting cardinal Gorgons.
      if (Math.abs(x - 100) < epsilon) return output.eastWest();
      if (Math.abs(y - 100) < epsilon) return output.northSouth();

      // Handle 8x potential locations for line hitting intercard Gorgons.
      if (Math.abs(x - 90) < epsilon) return output.east();
      if (Math.abs(x - 110) < epsilon) return output.west();
      if (Math.abs(y - 90) < epsilon) return output.south();
      if (Math.abs(y - 110) < epsilon) return output.north();
    },
    outputStrings: {
      northSouth: {
        en: 'North / South',
        de: 'Norden / Süden',
        fr: 'Nord / Sud',
        ja: '南・北',
        cn: '南 / 北',
        ko: '남/북쪽'
      },
      eastWest: {
        en: 'East / West',
        de: 'Osten / Westen',
        fr: 'Est / Ouest',
        ja: '東・西',
        cn: '东 / 西',
        ko: '동/서쪽'
      },
      north: outputs/* default.north */.Z.north,
      east: outputs/* default.east */.Z.east,
      west: outputs/* default.west */.Z.west,
      south: outputs/* default.south */.Z.south
    }
  },
  // ---------------- Part 2 ----------------
  {
    id: 'P8S Aioniopyr',
    type: 'StartsUsing',
    netRegex: {
      id: '79DF',
      source: 'Hephaistos',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'P8S Tyrant\'s Unholy Darkness',
    type: 'StartsUsing',
    // Untargeted, with 79DE damage after.
    netRegex: {
      id: '79DD',
      source: 'Hephaistos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Split Tankbusters',
        de: 'getrennte Tankbuster',
        fr: 'Séparez les Tankbuster',
        ja: '2人同時タンク強攻撃',
        cn: '分散死刑',
        ko: '따로맞는 탱버'
      }
    }
  }, {
    id: 'P8S Ashing Blaze Right',
    type: 'StartsUsing',
    netRegex: {
      id: '79D7',
      source: 'Hephaistos',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.firstAlignmentSecondAbility === 'stack') return output.rightAndStack();
      if (data.firstAlignmentSecondAbility === 'spread') return output.rightAndSpread();
      return output.right();
    },
    run: data => delete data.firstAlignmentSecondAbility,
    outputStrings: {
      right: outputs/* default.right */.Z.right,
      rightAndSpread: {
        en: 'Right + Spread',
        de: 'Rechts + Verteilen',
        fr: 'Droite + Écartez-vous',
        ja: '右 + 散会',
        cn: '右 + 分散',
        ko: '오른쪽 + 산개'
      },
      rightAndStack: {
        en: 'Right + Stack',
        de: 'Rechts + Sammeln',
        fr: 'Droite + Package',
        ja: '右 + 頭割り',
        cn: '右 + 分摊',
        ko: '오른쪽 + 쉐어'
      }
    }
  }, {
    id: 'P8S Ashing Blaze Left',
    type: 'StartsUsing',
    netRegex: {
      id: '79D8',
      source: 'Hephaistos',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.firstAlignmentSecondAbility === 'stack') return output.leftAndStack();
      if (data.firstAlignmentSecondAbility === 'spread') return output.leftAndSpread();
      return output.left();
    },
    run: data => delete data.firstAlignmentSecondAbility,
    outputStrings: {
      left: outputs/* default.left */.Z.left,
      leftAndSpread: {
        en: 'Left + Spread',
        de: 'Links + Verteilen',
        fr: 'Gauche + Écartez-vous',
        ja: '左 + 散会',
        cn: '左 + 分散',
        ko: '왼쪽 + 산개'
      },
      leftAndStack: {
        en: 'Left + Stack',
        de: 'Links + Sammeln',
        fr: 'Gauche + Package',
        ja: '左 + 頭割り',
        cn: '左 + 分摊',
        ko: '왼쪽 + 쉐어'
      }
    }
  }, {
    id: 'P8S High Concept',
    type: 'StartsUsing',
    netRegex: {
      id: '79AC',
      source: 'Hephaistos',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe(),
    run: data => {
      data.concept = {};
      data.splicer = {};
    }
  }, {
    id: 'P8S Inverse Magics',
    type: 'GainsEffect',
    // This gets recast a lot on the same people, but shouldn't cause an issue.
    // This also only happens once on the second time through, so no need to reset.
    netRegex: {
      effectId: 'D15'
    },
    infoText: (data, matches, output) => {
      if (!data.inverseMagics[matches.target]) return output.reversed({
        player: data.party.member(matches.target)
      });
    },
    run: (data, matches) => data.inverseMagics[matches.target] = true,
    outputStrings: {
      reversed: {
        en: '${player} reversed',
        de: '${player} umgekehrt',
        fr: '${player} inversé',
        ja: '反転：${player}',
        cn: '${player} 颠倒',
        ko: '${player} 반전'
      }
    }
  }, {
    id: 'P8S Natural Alignment Purple on You',
    type: 'GainsEffect',
    netRegex: {
      effectId: '9F8',
      count: '209'
    },
    preRun: (data, matches) => data.alignmentTargets.push(matches.target),
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    outputStrings: {
      text: {
        en: 'Alignment on YOU',
        de: 'Anpassung auf DIR',
        fr: 'Alignement sur VOUS',
        ja: '自分に記述',
        cn: '记述点名',
        ko: '원판 대상자'
      }
    }
  }, {
    id: 'P8S Natural Alignment Purple Targets',
    type: 'GainsEffect',
    netRegex: {
      effectId: '9F8',
      count: '209',
      capture: false
    },
    delaySeconds: 0.3,
    suppressSeconds: 5,
    sound: '',
    infoText: (data, _matches, output) => {
      const [name1, name2] = data.alignmentTargets.sort();
      return output.text({
        player1: data.party.member(name1),
        player2: data.party.member(name2)
      });
    },
    tts: null,
    run: data => data.alignmentTargets = [],
    outputStrings: {
      text: {
        en: 'Alignment on ${player1}, ${player2}',
        de: 'Anpassung auf ${player1}, ${player2}',
        fr: 'Alignement sur ${player1}, ${player2}',
        ja: '記述：${player1}, ${player2}',
        cn: '记述点 ${player1}, ${player2}',
        ko: '${player1}, ${player2} 원판'
      }
    }
  }, {
    id: 'P8S Natural Alignment First',
    type: 'GainsEffect',
    // This is a magic effectId with a statusloopvfx count, like 808 elsewhere.
    netRegex: {
      effectId: '9F8'
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        ice: {
          en: 'Ice Groups First',
          de: 'Eis Gruppen zuerst',
          fr: 'Groupe Glace en 1er',
          ja: '氷の頭割りから',
          cn: '先冰分摊',
          ko: '얼음 쉐어 먼저'
        },
        fire: {
          en: 'Fire Partners First',
          de: 'Feuer Partner zuerst',
          fr: 'Partenaires de feu en 1er',
          ja: '火の2人頭割りから',
          cn: '先火分摊',
          ko: '불 2인쉐어 먼저'
        },
        stack: {
          en: 'Stack First',
          de: 'Zuerst sammeln',
          fr: 'Package en 1er',
          ja: '頭割りから',
          cn: '先分摊',
          ko: '쉐어 먼저'
        },
        spread: {
          en: 'Spread First',
          de: 'Zuerst verteilen',
          fr: 'Écartement en 1er',
          ja: '散会から',
          cn: '先散开',
          ko: '산개 먼저'
        },
        baitAndStack: {
          en: 'Bait => Stack',
          de: 'Ködern => Sammeln',
          fr: 'Déposez -> Package',
          ja: '誘導 => 頭割り',
          cn: '诱导 => 分摊',
          ko: '장판 유도 => 쉐어'
        },
        baitAndSpread: {
          en: 'Bait => Spread',
          de: 'Ködern => Verteilen',
          fr: 'Déposez -> Écartez-vous',
          ja: '誘導 => 散会',
          cn: '诱导 => 分散',
          ko: '장판 유도 => 산개'
        }
      };
      const isReversed = data.inverseMagics[matches.target] === true;
      const id = matches.count;

      // Huge credit to Aya for this.  Also note `209` is the purple swirl.
      const ids = {
        fireThenIce: '1DC',
        iceThenFire: '1DE',
        stackThenSpread: '1E0',
        spreadThenStack: '1E2'
      };

      // The first time through, use the "bait" version to avoid people running off
      // as soon as they hear the beepy boops.
      if (!data.seenFirstAlignmentStackSpread) {
        // The first one can't be reversed.
        // Store the follow-up ability so it can be used with the left/right Ashing Blaze.
        if (id === ids.stackThenSpread) {
          data.firstAlignmentSecondAbility = 'spread';
          return {
            alertText: output.baitAndStack()
          };
        }
        if (id === ids.spreadThenStack) {
          data.firstAlignmentSecondAbility = 'stack';
          return {
            alertText: output.baitAndSpread()
          };
        }
      }
      const key = isReversed ? 'alarmText' : 'alertText';
      if (!isReversed && id === ids.fireThenIce || isReversed && id === ids.iceThenFire) return {
        [key]: output.fire()
      };
      if (!isReversed && id === ids.iceThenFire || isReversed && id === ids.fireThenIce) return {
        [key]: output.ice()
      };
      if (!isReversed && id === ids.spreadThenStack || isReversed && id === ids.stackThenSpread) return {
        [key]: output.spread()
      };
      if (!isReversed && id === ids.stackThenSpread || isReversed && id === ids.spreadThenStack) return {
        [key]: output.stack()
      };
    }
  }, {
    id: 'P8S Natural Alignment Second',
    type: 'Ability',
    netRegex: {
      id: ['79C0', '79BF', '79BD', '79BE'],
      source: 'Hephaistos'
    },
    suppressSeconds: 8,
    alertText: (data, matches, output) => {
      // Due to the way suppress works, put this check here and not in the condition field.
      // This callout will get merged with the left/right which happens at the same time.
      if (!data.seenFirstAlignmentStackSpread) return;
      const id = matches.id;
      const ids = {
        spread: '79C0',
        stack: '79BF',
        fire: '79BD',
        ice: '79BE'
      };

      // TODO: Should the left/right call (or some future "front row"/"2nd row") call be combined
      // with the followup here?
      if (id === ids.spread) return output.stack();
      if (id === ids.stack) return output.spread();
      if (id === ids.ice) return output.fire();
      if (id === ids.fire) return output.ice();
    },
    run: data => data.seenFirstAlignmentStackSpread = true,
    outputStrings: {
      stack: outputs/* default.stackMarker */.Z.stackMarker,
      spread: outputs/* default.spread */.Z.spread,
      ice: {
        en: 'Ice Groups',
        de: 'Eis Gruppen',
        fr: 'Groupe de glace',
        ja: '氷の頭割り',
        cn: '冰分摊',
        ko: '얼음 그룹 쉐어'
      },
      fire: {
        en: 'Fire Partners',
        de: 'Feuer Partner',
        fr: 'Partenaires de feu',
        ja: '火の2人頭割り',
        cn: '火分摊',
        ko: '불 2인 쉐어'
      }
    }
  }, {
    id: 'P8S Illusory Hephaistos End of Days',
    type: 'StartsUsing',
    netRegex: {
      id: '7A8B'
    },
    infoText: (_data, matches, output) => {
      // Illusory Hephaistos are at x=(80 or 120), y=(85 or 95 or 105 or 115).
      // Either the first or second row is always free.
      const y = parseFloat(matches.y);
      const epsilon = 2;
      const row1y = 85;
      const row2y = 95;

      // TODO: combine this with the ice/fire/stack/spread calls too?
      if (Math.abs(y - row1y) < epsilon) return output.row2();
      if (Math.abs(y - row2y) < epsilon) return output.row1();
    },
    outputStrings: {
      row1: {
        en: 'Front Row',
        de: 'Vordere Reihe',
        fr: 'Première rangée',
        ja: '1列目',
        cn: '第 1 行',
        ko: '첫번째 줄'
      },
      row2: {
        en: 'Second Row',
        de: 'Zweite Reihe',
        fr: 'Deuxième rangée',
        ja: '2列目',
        cn: '第 2 行',
        ko: '두번째 줄'
      }
    }
  }, {
    id: 'P8S High Concept Collect',
    // D02 = Imperfection: Alpha
    // D03 = Imperfection: Beta
    // D04 = Imperfection: Gamma
    // D05 = Perfection: Alpha
    // D06 = Perfection: Beta
    // D07 = Perfection: Gamma
    // D08 = Inconceivable (temporary after merging)
    // D09 = Winged Conception (alpha + beta)
    // D0A = Aquatic Conception (alpha + gamma)
    // D0B = Shocking Conception (beta + gamma)
    // D0C = Fiery Conception (ifrits, alpha + alpha)
    // D0D = Toxic Conception (snake, beta + beta)
    // D0E = Growing Conception (tree together, gamma + gamma)
    // D0F = Immortal Spark (feather)
    // D10 = Immortal Conception (phoenix)
    // D11 = Solosplice
    // D12 = Multisplice
    // D13 = Supersplice
    type: 'GainsEffect',
    // Ignore D08 in the regex here.
    netRegex: {
      effectId: ['D0[2-79A-F]', 'D1[0-3]']
    },
    run: (data, matches) => {
      const id = matches.effectId;
      // 8 and 26s second debuffs.
      const isLong = parseFloat(matches.duration) > 10;
      if (id === 'D02') data.concept[matches.target] = isLong ? 'longalpha' : 'shortalpha';else if (id === 'D03') data.concept[matches.target] = isLong ? 'longbeta' : 'shortbeta';else if (id === 'D04') data.concept[matches.target] = isLong ? 'longgamma' : 'shortgamma';else if (id === 'D05') data.concept[matches.target] = 'alpha';else if (id === 'D06') data.concept[matches.target] = 'beta';else if (id === 'D07') data.concept[matches.target] = 'gamma';else if (id === 'D11') data.splicer[matches.target] = 'solosplice';else if (id === 'D12') data.splicer[matches.target] = 'multisplice';else if (id === 'D13') data.splicer[matches.target] = 'supersplice';else data.concept[matches.target] = 'primal';
    }
  }, {
    id: 'P8S High Concept Debuffs',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['D0[2-4]', 'D1[1-3]'],
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        noDebuff: {
          en: 'No Debuff',
          de: 'Kein Debuff',
          fr: 'Aucun debuff',
          ja: '無職',
          cn: '无buff',
          ko: '디버프 없음'
        },
        shortAlpha: {
          en: 'Short Alpha',
          de: 'kurzes Alpha',
          fr: 'Alpha court',
          ja: '早アルファ',
          cn: '短阿尔法',
          ko: '짧은 알파'
        },
        longAlpha: {
          en: 'Long Alpha',
          de: 'langes Alpha',
          fr: 'Alpha long',
          ja: '遅アルファ',
          cn: '长阿尔法',
          ko: '긴 알파'
        },
        longAlphaSplicer: {
          en: 'Long Alpha + ${splicer}',
          de: 'langes Alpha + ${splicer}',
          fr: 'Alpha long + ${splicer}',
          ja: '遅アルファ + ${splicer}',
          cn: '长阿尔法+ ${splicer}',
          ko: '긴 알파 + ${splicer}'
        },
        shortBeta: {
          en: 'Short Beta',
          de: 'kurzes Beta',
          fr: 'Beta court',
          ja: '早ベータ',
          cn: '短贝塔',
          ko: '짧은 베타'
        },
        longBeta: {
          en: 'Long Beta',
          de: 'langes Beta',
          fr: 'Beta long',
          ja: '遅ベータ',
          cn: '长贝塔',
          ko: '긴 베타'
        },
        longBetaSplicer: {
          en: 'Long Beta + ${splicer}',
          de: 'langes Beta + ${splicer}',
          fr: 'Beta long + ${splicer}',
          ja: '遅ベータ + ${splicer}',
          cn: '长贝塔+ ${splicer}',
          ko: '긴 베타 + ${splicer}'
        },
        shortGamma: {
          en: 'Short Gamma',
          de: 'kurzes Gamma',
          fr: 'Gamma court',
          ja: '早ガンマ',
          cn: '短伽马',
          ko: '짧은 감마'
        },
        longGamma: {
          en: 'Long Gamma',
          de: 'langes Gamma',
          fr: 'Gamma long',
          ja: '遅ガンマ',
          cn: '长伽马',
          ko: '긴 감마'
        },
        longGammaSplicer: {
          en: 'Long Gamma + ${splicer}',
          de: 'langes Gamma + ${splicer}',
          fr: 'Gamma long + ${splicer}',
          ja: '遅ガンマ + ${splicer}',
          cn: '长伽马 + ${splicer}',
          ko: '긴 감마 + ${splicer}'
        },
        soloSplice: {
          en: 'Solo Stack',
          de: 'Einzelnes Sammeln',
          fr: 'Package solo',
          ja: '1人受け',
          cn: '单人分摊',
          ko: '1인징'
        },
        multiSplice: {
          en: 'Two Stack',
          de: 'Zwei sammeln',
          fr: 'Package à 2',
          ja: '2人頭割り',
          cn: '双人分摊',
          ko: '2인징'
        },
        superSplice: {
          en: 'Three Stack',
          de: 'Drei sammeln',
          fr: 'Package à 3',
          ja: '3人頭割り',
          cn: '三人分摊',
          ko: '3인징'
        }
      };

      // General thought here: alarm => EXPLOSION GO, alert/info => go to safe corner

      const concept = data.concept[data.me];
      const splicer = data.splicer[data.me];
      const singleConceptMap = {
        shortalpha: output.shortAlpha(),
        longalpha: output.longAlpha(),
        shortbeta: output.shortBeta(),
        longbeta: output.longBeta(),
        shortgamma: output.shortGamma(),
        longgamma: output.longGamma()
      };
      if (splicer === undefined) {
        if (concept === undefined) return {
          alarmText: output.noDebuff()
        };
        const isShort = concept === 'shortalpha' || concept === 'shortbeta' || concept === 'shortgamma';
        const conceptStr = singleConceptMap[concept];
        if (isShort) return {
          alarmText: conceptStr
        };
        return {
          alertText: conceptStr
        };
      }
      const splicerMap = {
        solosplice: output.soloSplice(),
        multisplice: output.multiSplice(),
        supersplice: output.superSplice()
      };
      const splicerStr = splicerMap[splicer];
      if (concept === undefined) return {
        infoText: splicerStr
      };else if (concept === 'longalpha') return {
        alertText: output.longAlphaSplicer({
          splicer: splicerStr
        })
      };else if (concept === 'longbeta') return {
        alertText: output.longBetaSplicer({
          splicer: splicerStr
        })
      };else if (concept === 'longgamma') return {
        alertText: output.longGammaSplicer({
          splicer: splicerStr
        })
      };

      // If we get here then we have a short concept with a splicer which shouldn't be possible,
      // but at least return *something* just in case.
      return {
        alarmText: singleConceptMap[concept]
      };
    }
  }, {
    id: 'P8S Arcane Channel Collect',
    type: 'MapEffect',
    netRegex: {
      flags: arcaneChannelFlags
    },
    // Flags exist in phase 1, only execute trigger if phase 2
    condition: data => data.seenFirstTankAutos,
    run: (data, matches) => {
      const colorInt = parseInt(matches.location, 16);
      if (colorInt >= 0x1A && colorInt <= 0x23) data.arcaneChannelColor.add('purple');
      if (colorInt >= 0x24 && colorInt <= 0x2D) data.arcaneChannelColor.add('blue');
      if (colorInt >= 0x2E && colorInt <= 0x37) data.arcaneChannelColor.add('green');
    }
  }, {
    id: 'P8S Arcane Channel Color',
    type: 'MapEffect',
    netRegex: {
      flags: arcaneChannelFlags,
      capture: false
    },
    condition: data => data.arcaneChannelColor.size > 0,
    delaySeconds: 0.1,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        colorTowerMergePlayer: {
          en: '${color} Tower (with ${player})',
          de: '${color} Turm (mit ${player})',
          fr: 'Tour ${color} (avec ${player})',
          ja: '${color}塔 (+${player})',
          cn: '${color} 塔 (与${player})',
          ko: '${color} 기둥 (${player})'
        },
        colorTowerMergeLetter: {
          en: '${color} Tower (with ${letter})',
          de: '${color} Turm (mit ${letter})',
          fr: 'Tour ${color} (avec ${letter})',
          ja: '${color}塔 (+${letter})',
          cn: '${color} 塔 (与 ${letter})',
          ko: '${color} 기둥 (${letter})'
        },
        colorTowerMergePlayers: {
          en: '${color} Tower (with ${player1} or ${player2})',
          de: '${color} Turm (mit ${player1} oder ${player2})',
          fr: 'Tour ${color} (avec ${player1} ou ${player2})',
          ja: '${color}塔 (+${player1}/${player2})',
          cn: '${color} 塔 (与${player1} 或 ${player2})',
          ko: '${color} 기둥 (${player1} 또는 ${player2})'
        },
        towerMergeLetters: {
          en: 'Tower (with ${letter1} or ${letter2})',
          de: 'Turm (mit ${letter1} oder ${letter2})',
          fr: 'Tour (avec ${letter1} ou ${letter2})',
          ja: '塔 (+${letter1}/${letter2})',
          cn: '塔 (与 ${letter1} 或 ${letter2})',
          ko: '기둥 (${letter1} 또는 ${letter2})'
        },
        towerMergePlayers: {
          en: 'Tower (with ${player1} or ${player2})',
          de: 'Turm (mit ${player1} oder ${player2})',
          fr: 'Tour (avec ${player1} ou ${player2})',
          ja: '塔 (+${player1}/${player2})',
          cn: '塔 (与${player1} 或 ${player2})',
          ko: '기둥 (${player1} 또는 ${player2})'
        },
        colorTowerAvoid: {
          en: 'Avoid ${color} Towers',
          de: 'Vermeide ${color} Turm',
          fr: 'Évitez les tours ${color}',
          ja: '組合せずに逃げて: ${color}',
          cn: '避开 ${color} 塔',
          ko: '${color} 기둥 피하기'
        },
        cloneTether: {
          en: 'Get clone tether',
          de: 'Nimm Klon Verbindung',
          fr: 'Prenez les liens des clones',
          ja: '線を付けて散開位置へ',
          cn: '拉线',
          ko: '선 가져가기'
        },
        alpha: {
          en: 'Alpha',
          de: 'Alpha',
          fr: 'Alpha',
          ja: 'アルファ',
          cn: '阿尔法',
          ko: '알파'
        },
        beta: {
          en: 'Beta',
          de: 'Beta',
          fr: 'Beta',
          ja: 'ベータ',
          cn: '贝塔',
          ko: '베타'
        },
        gamma: {
          en: 'Gamma',
          de: 'Gamma',
          fr: 'Gamma',
          ja: 'ガンマ',
          cn: '伽马',
          ko: '감마'
        },
        purple: {
          en: 'Purple',
          de: 'Lila',
          fr: 'Violet',
          ja: '紫',
          cn: '紫',
          ko: '보라'
        },
        blue: {
          en: 'Blue',
          de: 'Blau',
          fr: 'Bleu',
          ja: '青',
          cn: '蓝',
          ko: '파랑'
        },
        green: {
          en: 'Green',
          de: 'Grün',
          fr: 'Vert',
          ja: '緑',
          cn: '绿',
          ko: '초록'
        }
      };
      const towerColors = Array.from(data.arcaneChannelColor.keys());
      const [tower1, tower2] = towerColors;
      if (tower1 === undefined) return;
      const myConcept = data.concept[data.me];
      if (myConcept !== 'alpha' && myConcept !== 'beta' && myConcept !== 'gamma') {
        // Long debuffs, splicers, and primals avoid towers
        if (data.arcaneChannelCount !== 3) return {
          infoText: output.colorTowerAvoid({
            color: output[tower1]()
          })
        };

        // Primals on HC2 Second Towers get clones
        if (tower2 !== undefined && myConcept === 'primal') return {
          alertText: output.cloneTether()
        };
        // Likely not solveable anymore.
        return;
      }
      const towerToConcept = {
        'green': ['alpha', 'beta'],
        'blue': ['alpha', 'gamma'],
        'purple': ['beta', 'gamma']
      };
      const conceptToPlayers = {
        'alpha': [],
        'beta': [],
        'gamma': []
      };
      for (const [name, concept] of Object.entries(data.concept)) {
        if (concept === 'alpha' || concept === 'beta' || concept === 'gamma') conceptToPlayers[concept].push(name);
      }

      // HC1 (both parts), HC2 (initial tower)
      if (tower2 === undefined) {
        const color = output[tower1]();
        const concepts = towerToConcept[tower1];

        // Unused concept avoids tower
        if (!concepts.includes(myConcept)) return {
          infoText: output.colorTowerAvoid({
            color: color
          })
        };
        const [otherConcept] = [...concepts].filter(x => x !== myConcept);
        if (otherConcept === undefined) throw new not_reached/* UnreachableCode */.$();
        const [name1, name2] = conceptToPlayers[otherConcept].map(x => data.party.member(x));
        if (name1 === undefined) return {
          alertText: output.colorTowerMergeLetter({
            color: color,
            letter: output[otherConcept]()
          })
        };
        if (name2 === undefined) return {
          alertText: output.colorTowerMergePlayer({
            color: color,
            player: name1
          })
        };
        return {
          alertText: output.colorTowerMergePlayers({
            color: color,
            player1: name1,
            player2: name2
          })
        };
      }

      // HC2 (final towers), in order to solve this, you need a 2nd beta or gamma
      const [doubled, doub2] = perfectedConcepts.filter(x => conceptToPlayers[x].length === 2);
      if (doub2 !== undefined || doubled === undefined) return;

      // If doubled, merge with somebody who doesn't have your debuff.
      if (myConcept === doubled) {
        const [concept1, concept2] = [...perfectedConcepts].filter(x => x !== myConcept);
        if (concept1 === undefined || concept2 === undefined) throw new not_reached/* UnreachableCode */.$();
        const [name1, name2] = [...conceptToPlayers[concept1], ...conceptToPlayers[concept2]].map(x => data.party.member(x));
        if (name1 === undefined || name2 === undefined) return {
          alertText: output.towerMergeLetters({
            letter1: output[concept1](),
            letter2: output[concept2]()
          })
        };
        return {
          alertText: output.towerMergePlayers({
            player1: name1,
            player2: name2
          })
        };
      }

      // If not doubled, merge with one of the doubled folks (because they can't merge together).
      const [name1, name2] = conceptToPlayers[doubled].map(x => data.party.member(x));
      const [tower] = towerColors.filter(x => towerToConcept[x].includes(myConcept));
      if (tower === undefined) throw new not_reached/* UnreachableCode */.$();
      const color = output[tower]();
      if (name1 === undefined || name2 === undefined) return {
        alertText: output.colorTowerMergeLetter({
          color: color,
          letter: output[doubled]()
        })
      };
      return {
        alertText: output.colorTowerMergePlayers({
          color: color,
          player1: name1,
          player2: name2
        })
      };
    },
    run: data => {
      data.arcaneChannelColor.clear();
      data.arcaneChannelCount++;
    }
  }, {
    id: 'P8S Limitless Desolation',
    type: 'StartsUsing',
    netRegex: {
      id: '75ED',
      source: 'Hephaistos',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'P8S Tyrant\'s Fire III Counter',
    type: 'Ability',
    netRegex: {
      id: '75F0',
      source: 'Hephaistos',
      capture: false
    },
    preRun: data => data.burstCounter++,
    durationSeconds: 2,
    suppressSeconds: 1,
    sound: '',
    infoText: (data, _matches, output) => output.text({
      num: data.burstCounter
    }),
    tts: null,
    outputStrings: {
      text: {
        en: '${num}',
        de: '${num}',
        fr: '${num}',
        ja: '${num}番',
        cn: '${num}',
        ko: '${num}'
      }
    }
  }, {
    id: 'P8S Tyrant\'s Fire III Bait then Tower',
    type: 'Ability',
    netRegex: {
      id: '75F0',
      source: 'Hephaistos'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    durationSeconds: 7.9,
    alertText: (data, _matches, output) => output.text({
      num: data.burstCounter
    }),
    run: data => data.myTower = data.burstCounter,
    outputStrings: {
      text: {
        en: '${num}',
        de: '${num}',
        fr: '${num}',
        ja: '自分: ${num}番',
        cn: '${num}',
        ko: '${num}'
      }
    }
  }, {
    id: 'P8S Tyrant\'s Flare II Soak Tower',
    type: 'StartsUsing',
    netRegex: {
      id: '7A88',
      source: 'Hephaistos',
      capture: false
    },
    preRun: data => data.flareCounter++,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      if (data.flareCounter === data.myTower) return output.text({
        num: data.myTower
      });
    },
    outputStrings: {
      text: {
        en: 'Soak Tower ${num}',
        de: 'Turm ${num} nehmen',
        fr: 'Prenez la tour ${num}',
        ja: '${num}番目の塔踏み',
        cn: '${num} 塔',
        ko: '${num}번째 기둥 밟기'
      }
    }
  }, {
    id: 'P8S Dominion',
    type: 'StartsUsing',
    netRegex: {
      id: '79D9',
      source: 'Hephaistos',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread('alert'),
    run: data => {
      data.deformationHit = [];
      data.deformationNotHit = [...data.party.partyNames];
      data.deformationOnMe = false;
      // TODO: should this be undefined and not empty string??
      data.deformationPartner = '';
    }
  }, {
    id: 'P8S Orogenic Deformation Collect',
    type: 'Ability',
    netRegex: {
      id: '79DB',
      source: 'Hephaistos'
    },
    run: (data, matches) => {
      const idx = data.deformationNotHit.indexOf(matches.target);
      if (idx !== -1) data.deformationNotHit.splice(idx, 1);
      if (data.me === matches.target) {
        data.deformationOnMe = true;
      } else {
        data.deformationHit.push(matches.target);
      }
    }
  }, {
    id: 'P8S Orogenic Deformation Hit',
    type: 'Ability',
    netRegex: {
      id: '79DB',
      source: 'Hephaistos'
    },
    condition: (data, matches) => data.me === matches.target,
    delaySeconds: 0.5,
    durationSeconds: 10,
    infoText: (data, _matches, output) => {
      const myRole = data.party.isDPS(data.me) ? 'dps' : 'support';
      let partnerCount = 0;
      for (const p of data.deformationHit) {
        const pRole = data.party.isDPS(p) ? 'dps' : 'support';
        if (pRole === myRole) {
          partnerCount++;
          data.deformationPartner = p;
        }
      }
      if (data.deformationHit.length === 3 && partnerCount !== 1) {
        // non-standard party comp with multiple possible role partners - show all hit
        return output.multiple({
          player1: data.party.member(data.deformationHit[0]),
          player2: data.party.member(data.deformationHit[1]),
          player3: data.party.member(data.deformationHit[2])
        });
      } else if (partnerCount === 1) {
        return output.partner({
          player: data.deformationPartner
        });
      }
      return output.unknown();
    },
    outputStrings: {
      multiple: {
        en: 'Second Towers (w/ ${player1}, ${player2}, ${player3})',
        de: 'Zweite Türme (+ ${player1}, ${player2}, ${player3})',
        fr: 'Secondes tours (+ ${player1}, ${player2}, ${player3})',
        ja: '2番目で入る (${player1}, ${player2}, ${player3})',
        cn: '第二轮塔 (+ ${player1}, ${player2}, ${player3})',
        ko: '두번째 기둥 (+ ${player1}, ${player2}, ${player3})'
      },
      partner: {
        en: 'Second Towers (with ${player})',
        de: 'Zweite Türme (mit ${player})',
        fr: 'Secondes tours (avec ${player})',
        ja: '2番目で入る (+${player})',
        cn: '第二轮塔 (与${player})',
        ko: '두번째 기둥 (+ ${player})'
      },
      unknown: {
        en: 'Second Towers',
        de: 'Zweite Türme',
        fr: 'Secondes tours',
        ja: '2番目で入る',
        cn: '第二轮塔',
        ko: '두번째 기둥'
      }
    }
  }, {
    id: 'P8S Orogenic Deformation Not Hit',
    type: 'Ability',
    netRegex: {
      id: '79DB',
      source: 'Hephaistos',
      capture: false
    },
    delaySeconds: 0.5,
    durationSeconds: 5,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      if (!data.deformationOnMe) {
        const idx = data.deformationNotHit.indexOf(data.me);
        if (idx !== -1) data.deformationNotHit.splice(idx, 1);
        const myRole = data.party.isDPS(data.me) ? 'dps' : 'support';
        let partnerCount = 0;
        for (const p of data.deformationNotHit) {
          const pRole = data.party.isDPS(p) ? 'dps' : 'support';
          if (pRole === myRole) {
            partnerCount++;
            data.deformationPartner = p;
          }
        }
        if (data.deformationNotHit.length === 3 && partnerCount !== 1) {
          // non-standard party comp with multiple possible role partners - show all not hit
          return output.multiple({
            player1: data.party.member(data.deformationNotHit[0]),
            player2: data.party.member(data.deformationNotHit[1]),
            player3: data.party.member(data.deformationNotHit[2])
          });
        } else if (partnerCount === 1) {
          return output.partner({
            player: data.party.member(data.deformationPartner)
          });
        }
        return output.unknown();
      }
    },
    outputStrings: {
      multiple: {
        en: 'First Towers (w/ ${player1}, ${player2}, ${player3})',
        de: 'Erste Türme (+ ${player1}, ${player2}, ${player3})',
        fr: 'Premières tours (+ ${player1}, ${player2}, ${player3})',
        ja: '先に入る (${player1}, ${player2}, ${player3})',
        cn: '第一轮塔 (+ ${player1}, ${player2}, ${player3})',
        ko: '첫번째 기둥 (+ ${player1}, ${player2}, ${player3})'
      },
      partner: {
        en: 'First Towers (with ${player})',
        de: 'Erste Türme (mit ${player})',
        fr: 'Premières tours (avec ${player})',
        ja: '先に入る (+${player})',
        cn: '第一轮塔 (与${player})',
        ko: '첫번째 기둥 (+ ${player})'
      },
      unknown: {
        en: 'First Towers',
        de: 'Erste Türme',
        fr: 'Premières tours',
        ja: '先に入る',
        cn: '第一轮塔',
        ko: '첫번째 기둥'
      }
    }
  }, {
    id: 'P8S Aionagonia',
    type: 'StartsUsing',
    netRegex: {
      id: '7A22',
      source: 'Hephaistos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'big aoe + bleed',
        de: 'große AoE + Blutung',
        fr: 'Grosse AoE + Saignement',
        ja: '全体攻撃 + 出血',
        cn: '大AOE+流血',
        ko: '아픈 전체공격 + 도트'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Conceptual Octaflare/Conceptual Tetraflare': 'Conceptual Octa/Tetraflare',
      'Emergent Octaflare/Emergent Tetraflare': 'Emergent Octa/Tetraflare',
      'Tetraflare/Octaflare': 'Tetra/Octaflare',
      'Scorching Fang/Scorched Pinion': 'Fang/Pinion',
      'Scorching Fang/Sun\'s Pinion': 'Fang/Pinion',
      'Tetraflare/Nest of Flamevipers': 'Tetraflare/Flamevipers',
      'Quadrupedal Impact/Quadrupedal Crush': 'Quadrupedal Impact/Crush',
      'Quadrupedal Crush/Quadrupedal Impact': 'Quadrupedal Crush/Impact',
      'Emergent Diflare/Emergent Tetraflare': 'Emergent Di/Tetraflare',
      'Forcible Trifire/Forcible Difreeze': 'Forcible Trifire/Difreeze',
      'Forcible Difreeze/Forcible Trifire': 'Forcible Difreeze/Trifire',
      'Forcible Fire III/Forcible Fire II': 'Forcible Fire III/II',
      'Forcible Fire II/Forcible Fire III': 'Forcible Fire II/III'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      '(?<!Illusory )Hephaistos': 'Hephaistos',
      'Gorgon': 'Gorgone',
      'Illusory Hephaistos': 'Hephaistos-Phantom',
      'Suneater': 'Schlund des Phoinix'
    },
    'replaceText': {
      'line': 'Linie',
      '--auto--': '--auto--',
      'Abyssal Fires': 'Feuersturm',
      'Aionagonia': 'Eiserne Agonie',
      'Aioniopyr': 'Aioniopyr',
      'Arcane Channel': 'Zirkelimpuls',
      'Arcane Control': 'Beleben des Kreises',
      'Ashing Blaze': 'Aschelodern',
      'Blazing Footfalls': 'Fackelnde Füße',
      'Blood of the Gorgon': 'Gorgons Schlangengift',
      'Breath of the Gorgon': 'Gorgons Übelgift',
      'Burst': 'Explosion',
      'Conceptual Diflare': 'Konzeptionelle Diflare',
      'Conceptual Octaflare': 'Konzeptionelle Oktaflare',
      'Conceptual Shift': 'Konzeptänderung',
      'Conceptual Tetraflare': 'Konzeptionelle Tetraflare',
      'Creation on Command': 'Schöpfungsauftrag',
      'Crown of the Gorgon': 'Gorgons Steinlicht',
      'Cthonic Vent': 'Lodernde Schlange',
      'Deconceptualize': 'Konzepttilgung',
      'Dominion': 'Schlag des Herrschers',
      'Ego Death': 'Egotod',
      'Ektothermos': 'Ektothermos',
      'Emergent Diflare': 'Steigende Diflare',
      'Emergent Octaflare': 'Steigende Oktaflare',
      'Emergent Tetraflare': 'Steigende Tetraflare',
      'End of Days': 'Ende aller Tage',
      'Everburn': 'Phoinix-Erschaffung',
      'Eye of the Gorgon': 'Gorgons Steinauge',
      '(?<!Nest of )Flameviper': 'Flammenviper',
      'Footprint': 'Fußschock',
      'Forcible Difreeze': 'Erzwungenes Di-Einfrieren',
      'Forcible Fire II(?!I)': 'Erzwungenes Feura',
      'Forcible Fire III': 'Erzwungenes Feuga',
      'Forcible Trifire': 'Erzwungenes Trifeuer',
      'Fourfold Fires': 'Vierfacher Feuersturm',
      'Genesis of Flame': 'Flammende Genesis',
      'Gorgomanteia': 'Gorgons Fluch',
      'Gorgospit': 'Gorgons Speichel',
      'Hemitheos\'s Flare': 'Hemitheos-Flare',
      'High Concept': 'Konzeptkontrolle',
      'Illusory Creation': 'Illusionsschatten',
      'Into the Shadows': 'In die Schatten',
      'Inverse Magicks': 'Magische Umkehr',
      'Limitless Desolation': 'Kosmische Verkohlung',
      'Manifold Flames': 'Mannigfaltige Flammen',
      'Natural Alignment': 'Rituelle Anpassung',
      'Nest of Flamevipers': 'Ausbreitende Viper',
      '(?<! )Octaflare': 'Oktaflare',
      'Orogenic Deformation': 'Gewaltige Bodenhebung',
      'Orogenic Shift': 'Bodenhebung',
      'Petrifaction': 'Versteinerung',
      'Quadrupedal Crush': 'Fußmalmer',
      'Quadrupedal Impact': 'Fußstampfer',
      'Reforged Reflection': 'Mutierte Schöpfung',
      'Scorched Pinion': 'Versengte Schwinge',
      'Scorching Fang': 'Flammender Zahn',
      'Snaking Kick': 'Natterntritt',
      'Splicer': 'Konzeptreflektion',
      'Stomp Dead': 'Fataler Stampfer',
      'Sun\'s Pinion': 'Schwelende Schwinge',
      'Sunforge': 'Flammenreigen der Schöpfung',
      '(?<! )Tetraflare': 'Tetraflare',
      'Torch Flame': 'Glutfeuer',
      'Trailblaze': 'Flammender Pfad',
      'Twist Nature': 'Zwangsbeschwörung',
      'Tyrant\'s Fire III': 'Feuga des Tyrannen',
      'Tyrant\'s Flare(?! II)': 'Flare des Tyrannen',
      'Tyrant\'s Flare II': 'Flare des Tyrannen II',
      'Tyrant\'s Unholy Darkness': 'Unheiliges Dunkel des Tyrannen',
      'Uplift': 'Erhöhung',
      'Volcanic Torches': 'Vulkanfackel'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '(?<!Illusory )Hephaistos': 'Héphaïstos',
      'Gorgon': 'Gorgone',
      'Illusory Hephaistos': 'spectre d\'Héphaïstos',
      'Suneater': 'Serpent en flammes'
    },
    'replaceText': {
      'line': 'Ligne',
      '--auto--': '--Auto--',
      'Abyssal Fires': 'Tempête enflammée',
      'Aionagonia': 'Aion agonia',
      'Aioniopyr': 'Aion pur',
      'Arcane Channel': 'Vague arcanique',
      'Arcane Control': 'Activation arcanique',
      'Ashing Blaze': 'Enfer cendreux',
      'Blazing Footfalls': 'Pas ardents',
      'Blood of the Gorgon': 'Venin reptilien de gorgone',
      'Breath of the Gorgon': 'Poison insidieux de gorgone',
      'Burst': 'Explosion',
      'Conceptual Diflare': 'Dibrasier conceptuel',
      'Conceptual Octaflare': 'Octobrasier conceptuel',
      'Conceptual Shift': 'Bascule conceptuelle',
      'Conceptual Tetraflare': 'Tetrabrasier conceptuel',
      'Creation on Command': 'Ordre de création',
      'Crown of the Gorgon': 'Lueur pétrifiante de gorgone',
      'Cthonic Vent': 'Serpents de flammes ascendants',
      'Deconceptualize': 'Effacement conceptuel',
      'Dominion': 'Poing du maître',
      'Ego Death': 'Destruction de l\'ego',
      'Ektothermos': 'Vague d\'énergie explosive',
      'Emergent Diflare': 'Dibrasier émergent',
      'Emergent Octaflare': 'Octobrasier émergent',
      'Emergent Tetraflare': 'Tetrabrasier émergent',
      'End of Days': 'Flamme de Megiddo',
      'Everburn': 'Oiseau immortel',
      'Eye of the Gorgon': 'Œil pétrifiant de gorgone',
      '(?<!Nest of )Flameviper': 'Serpent-canon',
      'Footprint': 'Choc quadrupède',
      'Forcible Difreeze': 'Di Gel forcé',
      'Forcible Fire II(?!I)': 'Extra Feu forcé',
      'Forcible Fire III': 'Méga Feu forcé',
      'Forcible Trifire': 'Tri Feu forcé',
      'Fourfold Fires': 'Quadruple tempête enflammée',
      'Genesis of Flame': 'Flammes de la création',
      'Gorgomanteia': 'Malédiction de gorgone',
      'Gorgospit': 'Crachat de gorgone',
      'Hemitheos\'s Flare': 'Brasier d\'hémithéos',
      'High Concept': 'Manipulation conceptuelle',
      'Illusory Creation': 'Création d\'ombres',
      'Into the Shadows': 'Dans l\'ombre',
      'Inverse Magicks': 'Inversion magique',
      'Limitless Desolation': 'Cendrage universel',
      'Manifold Flames': 'Flammes orientées multiples',
      'Natural Alignment': 'Description rituelle',
      'Nest of Flamevipers': 'Vipère élancée',
      '(?<! )Octaflare': 'Octobrasier',
      'Orogenic Deformation': 'Grande surrection',
      'Orogenic Shift': 'Surrection',
      'Petrifaction': 'Pétrification',
      'Quadrupedal Crush': 'Écrasement quadrupède',
      'Quadrupedal Impact': 'Impact quadrupède',
      'Reforged Reflection': 'Mutation corporelle',
      'Scorched Pinion': 'Aile embrasante',
      'Scorching Fang': 'Crocs embrasants',
      'Snaking Kick': 'Coup de pied du serpent',
      'Splicer': 'Réaction conceptuelle',
      'Stomp Dead': 'Piétinement mortel',
      'Sun\'s Pinion': 'Ailes étincelantes',
      'Sunforge': 'Bête enflammée',
      '(?<! )Tetraflare': 'Tetrabrasier',
      'Torch Flame': 'Explosion de braises',
      'Trailblaze': 'Traînée ardente',
      'Twist Nature': 'Incantation forcée',
      'Tyrant\'s Fire III': 'Méga Feu de tyran',
      'Tyrant\'s Flare(?! II)': 'Brasier de tyran',
      'Tyrant\'s Flare II': 'Brasier de tyran II',
      'Tyrant\'s Unholy Darkness': 'Miracle ténébreux de tyran',
      'Uplift': 'Exhaussement',
      'Volcanic Torches': 'Boutefeux magiques'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      '(?<!Illusory )Hephaistos': 'ヘファイストス',
      'Gorgon': 'ゴルゴン',
      'Illusory Hephaistos': 'ヘファイストスの幻影',
      'Suneater': '炎霊蛇'
    },
    'replaceText': {
      'Abyssal Fires': '炎嵐',
      'Aionagonia': 'アイオンアゴニア',
      'Aioniopyr': 'アイオンピュール',
      'Arcane Channel': '魔陣波動',
      'Arcane Control': '魔法陣起動',
      'Ashing Blaze': 'アッシュブレイズ',
      'Blazing Footfalls': 'ブレイジングフィート',
      'Blood of the Gorgon': 'ゴルゴンの蛇毒',
      'Breath of the Gorgon': 'ゴルゴンの邪毒',
      'Burst': '爆発',
      'Conceptual Diflare': 'ディフレア・コンシーヴ',
      'Conceptual Octaflare': 'オクタフレア・コンシーヴ',
      'Conceptual Shift': '概念変異',
      'Conceptual Tetraflare': 'テトラフレア・コンシーヴ',
      'Creation on Command': '創造命令',
      'Crown of the Gorgon': 'ゴルゴンの石光',
      'Cthonic Vent': '噴炎昇蛇',
      'Deconceptualize': '概念消去',
      'Dominion': '支配者の一撃',
      'Ego Death': '自己概念崩壊',
      'Ektothermos': '爆炎波動',
      'Emergent Diflare': 'エマージ・ディフレア',
      'Emergent Octaflare': 'エマージ・オクタフレア',
      'Emergent Tetraflare': 'エマージ・テトラフレア',
      'End of Days': 'メギドフレイム',
      'Everburn': '不死鳥創造',
      'Eye of the Gorgon': 'ゴルゴンの石眼',
      '(?<!Nest of )Flameviper': '炎蛇砲',
      'Footprint': 'フィートショック',
      'Forcible Difreeze': 'フォースド・ディフリーズ',
      'Forcible Fire II(?!I)': 'フォースド・ファイラ',
      'Forcible Fire III': 'フォースド・ファイガ',
      'Forcible Trifire': 'フォースド・トリファイア',
      'Fourfold Fires': '四重炎嵐',
      'Genesis of Flame': '創世の真炎',
      'Gorgomanteia': 'ゴルゴンの呪詛',
      'Gorgospit': 'ゴルゴンスピット',
      'Hemitheos\'s Flare': 'ヘーミテオス・フレア',
      'High Concept': '概念支配',
      'Illusory Creation': '幻影創造',
      'Into the Shadows': 'イントゥシャドウ',
      'Inverse Magicks': 'マジックインヴァージョン',
      'Limitless Desolation': '万象灰燼',
      'Manifold Flames': '多重操炎',
      'Natural Alignment': '術式記述',
      'Nest of Flamevipers': 'スプレッドヴァイパー',
      '(?<! )Octaflare': 'オクタフレア',
      'Orogenic Deformation': '地盤大隆起',
      'Orogenic Shift': '地盤隆起',
      'Petrifaction': 'ペトリファクション',
      'Quadrupedal Crush': 'フィートクラッシュ',
      'Quadrupedal Impact': 'フィートインパクト',
      'Reforged Reflection': '変異創身',
      'Scorched Pinion': '炎の翼',
      'Scorching Fang': '炎の牙',
      'Snaking Kick': 'スネークキック',
      'Splicer': '概念反発',
      'Stomp Dead': 'フェイタルストンプ',
      'Sun\'s Pinion': '陽炎の翼',
      'Sunforge': '創獣炎舞',
      '(?<! )Tetraflare': 'テトラフレア',
      'Torch Flame': '熾炎',
      'Trailblaze': 'トレイルブレイズ',
      'Twist Nature': '強制詠唱',
      'Tyrant\'s Fire III': 'タイラント・ファイガ',
      'Tyrant\'s Flare(?! II)': 'タイラント・フレア',
      'Tyrant\'s Flare II': 'タイラント・フレアII',
      'Tyrant\'s Unholy Darkness': 'タイラント・ダークホーリー',
      'Uplift': '隆起',
      'Volcanic Torches': '熾炎創火'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      '(?<!Illusory )Hephaistos': '赫淮斯托斯',
      'Gorgon': '戈尔贡',
      'Illusory Hephaistos': '赫淮斯托斯的幻影',
      'Suneater': '炎灵蛇'
    },
    'replaceText': {
      'line': '直线',
      '--auto--': '--平A--',
      'Abyssal Fires': '火炎风暴',
      'Aionagonia': '永恒之苦',
      'Aioniopyr': '永恒之火',
      'Arcane Channel': '魔法阵波动',
      'Arcane Control': '魔法阵启动',
      'Ashing Blaze': '激火燃灰',
      'Blazing Footfalls': '炽热践踏',
      'Blood of the Gorgon': '戈尔贡蛇毒',
      'Breath of the Gorgon': '戈尔贡邪毒',
      'Burst': '爆炸',
      'Conceptual Diflare': '二分核爆之念',
      'Conceptual Octaflare': '八分核爆之念',
      'Conceptual Shift': '概念变异',
      'Conceptual Tetraflare': '四分核爆之念',
      'Creation on Command': '创造命令',
      'Crown of the Gorgon': '戈尔贡石光',
      'Cthonic Vent': '喷炎升蛇',
      'Deconceptualize': '概念消除',
      'Dominion': '支配者的一击',
      'Ego Death': '自我概念崩坏',
      'Ektothermos': '爆热波动',
      'Emergent Diflare': '二分核爆之现',
      'Emergent Octaflare': '八分核爆之现',
      'Emergent Tetraflare': '四分核爆之现',
      'End of Days': '米吉多烈焰',
      'Everburn': '创造不死鸟',
      'Eye of the Gorgon': '戈尔贡石眼',
      '(?<!Nest of )Flameviper': '炎蛇炮',
      'Footprint': '践踏',
      'Forcible Difreeze': '强制二分玄冰',
      'Forcible Fire II(?!I)': '强制烈炎',
      'Forcible Fire III': '强制爆炎',
      'Forcible Trifire': '强制三分火炎',
      'Fourfold Fires': '四重火炎风暴',
      'Genesis of Flame': '创世真炎',
      'Gorgomanteia': '戈尔贡的诅咒',
      'Gorgospit': '戈尔贡喷吐',
      'Hemitheos\'s Flare': '半神核爆',
      'High Concept': '概念支配',
      'Illusory Creation': '创造幻影',
      'Into the Shadows': '潜入阴影',
      'Inverse Magicks': '逆魔法',
      'Limitless Desolation': '万象灰烬',
      'Manifold Flames': '多重灼炎',
      'Natural Alignment': '术式记述',
      'Nest of Flamevipers': '炎蛇群翔',
      '(?<! )Octaflare': '八分核爆',
      'Orogenic Deformation': '地面隆踊',
      'Orogenic Shift': '地面隆起',
      'Petrifaction': '石化',
      'Quadrupedal Crush': '践踏碎击',
      'Quadrupedal Impact': '践踏冲击',
      'Reforged Reflection': '变异创身',
      'Scorched Pinion': '炎之翼',
      'Scorching Fang': '烈火牙',
      'Snaking Kick': '回旋蛇踢',
      'Splicer': '概念排斥',
      'Stomp Dead': '致命践踏',
      'Sun\'s Pinion': '炎之翼',
      'Sunforge': '创兽炎舞',
      '(?<! )Tetraflare': '四分核爆之念',
      'Torch Flame': '灼炎',
      'Trailblaze': '踏火寻迹',
      'Twist Nature': '强制咏唱',
      'Tyrant\'s Fire III': '暴君爆炎',
      'Tyrant\'s Flare(?! II)': '暴君核爆',
      'Tyrant\'s Flare II': '暴君核爆II',
      'Tyrant\'s Unholy Darkness': '暴君黑暗神圣',
      'Uplift': '隆起',
      'Volcanic Torches': '灼炎创火'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      '(?<!Illusory )Hephaistos': '헤파이스토스',
      'Gorgon': '고르곤',
      'Illusory Hephaistos': '헤파이스토스의 환영',
      'Suneater': '염령사'
    },
    'replaceText': {
      'line': '직선',
      '--auto--': '--평타--',
      'Conceptual Octaflare/Conceptual Tetraflare': '옥타플레어/테트라플레어 구상',
      'Conceptual Diflare/Conceptual Tetraflare': '디플레어/테트라플레어 구상',
      'Emergent Octaflare/Emergent Tetraflare': '옥타플레어/테트라플레어 발동',
      'Emergent Diflare/Emergent Tetraflare': '디플레어/테트라플레어 발동',
      'Tetraflare/Octaflare': '테트라/옥타플레어',
      'Scorching Fang/Scorched Pinion': '타오르는 송곳니/날개',
      'Scorching Fang/Sun\'s Pinion': '타오르는 송곳니/날개',
      'Tetraflare/Nest of Flamevipers': '테트라플레어/불뱀 살포',
      'Quadrupedal Impact/Quadrupedal Crush': '발걸음 충격/파괴',
      'Quadrupedal Crush/Quadrupedal Impact': '발걸음 파괴/충격',
      'Forcible Trifire/Forcible Difreeze': '강제 트리파이어/디프리즈',
      'Forcible Difreeze/Forcible Trifire': '강제 디프리즈/트리파이어',
      'Forcible Fire III/Forcible Fire II': '강제 파이가/파이라',
      'Forcible Fire II/Forcible Fire III': '강제 파이라/파이가',
      'Abyssal Fires': '화염 폭풍',
      'Aionagonia': '영원한 고통',
      'Aioniopyr': '영원한 불꽃',
      'Arcane Channel': '마법진 파동',
      'Arcane Control': '마법진 기동',
      'Ashing Blaze': '재의 불길',
      'Blazing Footfalls': '맹렬한 발걸음',
      'Blood of the Gorgon': '고르곤의 뱀독',
      'Breath of the Gorgon': '고르곤의 맹독',
      'Burst': '폭발',
      'Conceptual Shift': '개념 변이',
      'Creation on Command': '창조 명령',
      'Crown of the Gorgon': '고르곤의 빛',
      'Cthonic Vent': '불뱀 승천',
      'Deconceptualize': '개념 소거',
      'Dominion': '도미니온',
      'Ego Death': '자기 개념 붕괴',
      'Ektothermos': '폭염 파동',
      'End of Days': '메기도 플레임',
      'Everburn': '불사조 창조',
      'Eye of the Gorgon': '고르곤의 눈',
      '(?<!Nest of )Flameviper': '불뱀 진격',
      'Footprint': '발도장',
      'Fourfold Fires': '4중 화염 폭풍',
      'Genesis of Flame': '창세의 불꽃',
      'Gorgomanteia': '고르곤의 저주',
      'Gorgospit': '고르곤의 침',
      'Hemitheos\'s Flare': '헤미테오스 플레어',
      'High Concept': '개념 지배',
      'Illusory Creation': '환영 창조',
      'Into the Shadows': '그림자 속으로',
      'Inverse Magicks': '마법 역행',
      'Limitless Desolation': '만상의 잿더미',
      'Manifold Flames': '다중 화염 조작',
      'Natural Alignment': '술식 기술',
      '(?<!/)Nest of Flamevipers': '불뱀 살포',
      'Orogenic Deformation': '지반 대융기',
      'Orogenic Shift': '지반 융기',
      'Petrifaction': '석화',
      'Reforged Reflection': '신체 변이',
      '(?<!/)Scorched Pinion': '타오르는 날개',
      'Scorching Fang(?!/)': '타오르는 송곳니',
      'Snaking Kick': '뱀꼬리 공격',
      'Splicer': '개념 반발',
      'Stomp Dead': '치명적인 내려찍기',
      '(?<!/)Sun\'s Pinion': '타오르는 날개',
      'Sunforge': '창조물의 불꽃춤',
      'Torch Flame': '단불',
      'Trailblaze': '불꽃 발자국',
      'Twist Nature': '강제 시전',
      'Tyrant\'s Fire III': '폭군의 파이가',
      'Tyrant\'s Flare(?! II)': '폭군의 플레어',
      'Tyrant\'s Flare II': '폭군의 플레어 2',
      'Tyrant\'s Unholy Darkness': '폭군의 다크 홀리',
      'Uplift': '융기',
      'Volcanic Torches': '단불 창조'
    }
  }]
};
/* harmony default export */ const p8s = (p8s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p8s.txt
const raid_p8s_namespaceObject = "### P8S: Abyssos: The Eighth Circle (Savage)\r\n#\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n### P8S Part 1\r\n# -p 7944:12.1\r\n# -ii 7947 7923 7933 7934 7935 7951 7104 7105\r\n# -it Hephaistos\r\n\r\n# Two paths:\r\n# Human1 -> Snake1 -> Human2 -> Beast1 -> Human3 -> Snake2 -> Beast2 -> Human4\r\n# Human1 -> Beast1 -> Human2 -> Snake1 -> Human3 -> Beast2 -> Snake2 -> Human4\r\n\r\n# instant auto @_@;;\r\n0.0 \"--sync--\" Ability { id: \"7947\", source: \"Hephaistos\" } window 1,0\r\n7.1 \"--sync--\" StartsUsing { id: \"7944\", source: \"Hephaistos\" } window 20,20\r\n12.1 \"Genesis of Flame\" Ability { id: \"7944\", source: \"Hephaistos\" }\r\n18.2 \"Conceptual Octaflare/Conceptual Tetraflare\" Ability { id: [\"7914\", \"7915\"], source: \"Hephaistos\" }\r\n24.4 \"Volcanic Torches\" Ability { id: \"78F7\", source: \"Hephaistos\" }\r\n30.6 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n38.5 \"Torch Flame\" Ability { id: \"7927\", source: \"Hephaistos\" }\r\n\r\n# Human 1\r\n39.9 \"Sunforge\" Ability { id: \"7911\", source: \"Hephaistos\" }\r\n40.9 \"Scorching Fang/Sun's Pinion\" Ability { id: [\"7912\", \"7913\"], source: \"Hephaistos\" }\r\n41.1 \"Emergent Octaflare/Emergent Tetraflare\" Ability { id: [\"7918\", \"7919\"], source: \"Hephaistos\" }\r\n48.3 \"Flameviper 1\" Ability { id: \"7945\", source: \"Hephaistos\" }\r\n51.5 \"Flameviper 2\" Ability { id: \"7946\", source: \"Hephaistos\" }\r\n\r\n58.7 \"--sync--\" #Ability { id: \"7108\", source: \"Hephaistos\" }\r\n63.9 \"Reforged Reflection\"\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# => Snake first branch\r\n58.7 \"--sync--\" #Ability { id: \"7108\", source: \"Hephaistos\" }\r\n63.9 \"--sync--\" Ability { id: \"794C\", source: \"Hephaistos\" } window 100,100 jump 163.9\r\n71.2 \"Snaking Kick?\" #Ability { id: \"7929\", source: \"Hephaistos\" }\r\n77.3 \"Gorgomanteia?\" #Ability { id: \"791A\", source: \"Hephaistos\" }\r\n83.4 \"Into the Shadows?\" #Ability { id: \"792A\", source: \"Hephaistos\" }\r\n\r\n# => Beast first branch\r\n58.7 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n63.9 \"--sync--\" Ability { id: \"794B\", source: \"Hephaistos\" } window 100,100 jump 1163.9\r\n70.3 \"Footprint?\" #Ability { id: \"7109\", source: \"Hephaistos\" }\r\n77.2 \"Uplift 1?\" #Ability { id: \"7935\", source: \"Hephaistos\" }\r\n79.3 \"Uplift 2?\" #Ability { id: \"7935\", source: \"Hephaistos\" }\r\n81.5 \"Uplift 3?\" #Ability { id: \"7935\", source: \"Hephaistos\" }\r\n83.6 \"Uplift 4?\" #Ability { id: \"7935\", source: \"Hephaistos\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Snake 1 (Snake first)\r\n158.7 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n163.9 \"Reforged Reflection\" Ability { id: \"794C\", source: \"Hephaistos\" }\r\n171.2 \"Snaking Kick\" Ability { id: \"7929\", source: \"Hephaistos\" }\r\n177.3 \"Gorgomanteia\" Ability { id: \"791A\", source: \"Hephaistos\" }\r\n183.4 \"Into the Shadows\" Ability { id: \"792A\", source: \"Hephaistos\" }\r\n197.5 \"--sync--\" Ability { id: \"792B\", source: \"Gorgon\" }\r\n198.6 \"Petrifaction 1\" Ability { id: \"6724\", source: \"Gorgon\" }\r\n201.1 \"Eye of the Gorgon 1\" Ability { id: \"792D\", source: \"Hephaistos\" }\r\n204.2 \"Blood of the Gorgon 1\" Ability { id: \"792F\", source: \"Hephaistos\" }\r\n205.5 \"--sync--\" Ability { id: \"792B\", source: \"Gorgon\" }\r\n206.7 \"Petrifaction 2\" Ability { id: \"6724\", source: \"Gorgon\" }\r\n209.2 \"Eye of the Gorgon 2\" Ability { id: \"792D\", source: \"Hephaistos\" }\r\n212.2 \"Blood of the Gorgon 2\" Ability { id: \"792F\", source: \"Hephaistos\" }\r\n216.8 \"--sync--\" Ability { id: \"7949\", source: \"Hephaistos\" }\r\n221.8 \"Ektothermos\" Ability { id: \"79EA\", source: \"Hephaistos\" }\r\n\r\n# Human 2 (Snake first)\r\n224.8 \"--sync--\" Ability { id: \"7949\", source: \"Hephaistos\" }\r\n240.2 \"Illusory Creation\" Ability { id: \"791C\", source: \"Hephaistos\" }\r\n246.3 \"Creation on Command\" Ability { id: \"794F\", source: \"Hephaistos\" }\r\n254.1 \"Sunforge\" Ability { id: \"7950\", source: \"Illusory Hephaistos\" }\r\n254.5 \"Manifold Flames\" Ability { id: \"7921\", source: \"Hephaistos\" }\r\n255.1 \"Scorching Fang\" Ability { id: \"7952\", source: \"Illusory Hephaistos\" }\r\n255.1 \"Scorched Pinion\" Ability { id: \"7953\", source: \"Illusory Hephaistos\" }\r\n255.3 \"Hemitheos's Flare\" Ability { id: \"72CE\", source: \"Hephaistos\" }\r\n258.7 \"Manifold Flames\" Ability { id: \"7922\", source: \"Hephaistos\" }\r\n259.5 \"Nest of Flamevipers\" Ability { id: \"7920\", source: \"Hephaistos\" }\r\n266.2 \"Sunforge\" Ability { id: [\"7950\", \"7951\"], source: \"Illusory Hephaistos\" }\r\n266.8 \"Tetraflare/Nest of Flamevipers\" Ability { id: [\"791E\", \"791F\"], source: \"Hephaistos\" }\r\n267.2 \"Scorching Fang/Scorched Pinion\" Ability { id: [\"7952\", \"7953\"], source: \"Illusory Hephaistos\" }\r\n267.6 \"Emergent Octaflare/Emergent Tetraflare\" Ability { id: [\"7918\", \"7919\"], source: \"Hephaistos\" }\r\n279.8 \"Torch Flame\" Ability { id: \"7927\", source: \"Hephaistos\" }\r\n283.9 \"Genesis of Flame\" Ability { id: \"7944\", source: \"Hephaistos\" }\r\n\r\n# Beast 1 (Snake first)\r\n291.1 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n296.4 \"Reforged Reflection\" Ability { id: \"794B\", source: \"Hephaistos\" }\r\n302.8 \"Footprint\" Ability { id: \"7109\", source: \"Hephaistos\" }\r\n309.7 \"Uplift 1\" #Ability { id: \"7935\", source: \"Hephaistos\" }\r\n311.8 \"Uplift 2\" #Ability { id: \"7935\", source: \"Hephaistos\" }\r\n314.0 \"Uplift 3\" #Ability { id: \"7935\", source: \"Hephaistos\" }\r\n316.1 \"Uplift 4\" #Ability { id: \"7935\", source: \"Hephaistos\" }\r\n322.3 \"--sync--\" Ability { id: \"7936\", source: \"Hephaistos\" }\r\n322.5 \"Stomp Dead 1\" #Ability { id: \"7937\", source: \"Hephaistos\" }\r\n324.8 \"Stomp Dead 2\" #Ability { id: \"7937\", source: \"Hephaistos\" }\r\n327.1 \"Stomp Dead 3\" #Ability { id: \"7937\", source: \"Hephaistos\" }\r\n329.3 \"Stomp Dead 4\" #Ability { id: \"7937\", source: \"Hephaistos\" }\r\n\r\n# Human 3 (Snake first)\r\n346.7 \"Conceptual Octaflare/Conceptual Tetraflare\" Ability { id: [\"7914\", \"7915\"], source: \"Hephaistos\" }\r\n352.8 \"Fourfold Fires\" Ability { id: \"78F2\", source: \"Hephaistos\" } window 300,10\r\n358.6 \"Abyssal Fires\" Ability { id: \"7954\", source: \"Hephaistos\" }\r\n362.0 \"--sync--\" Ability { id: \"78F0\", source: \"Hephaistos\" }\r\n367.9 \"Cthonic Vent 1\" Ability { id: \"7925\", source: \"Suneater\" }\r\n376.9 \"Cthonic Vent 2\" Ability { id: \"794E\", source: \"Suneater\" }\r\n377.2 \"Tetraflare/Octaflare\" Ability { id: [\"791E\", \"791D\"], source: \"Hephaistos\" }\r\n381.4 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n385.9 \"Cthonic Vent 3\" Ability { id: \"7926\", source: \"Suneater\" }\r\n390.6 \"Sunforge\" Ability { id: [\"7910\", \"7911\"], source: \"Hephaistos\" }\r\n391.6 \"Scorching Fang/Sun's Pinion\" Ability { id: [\"7912\", \"7913\"], source: \"Hephaistos\" }\r\n391.8 \"Emergent Octaflare/Emergent Tetraflare\" Ability { id: [\"7918\", \"7919\"], source: \"Hephaistos\" }\r\n399.0 \"Flameviper 1\" Ability { id: \"7945\", source: \"Hephaistos\" }\r\n402.2 \"Flameviper 2\" Ability { id: \"7946\", source: \"Hephaistos\" }\r\n\r\n# Snake 2 (Snake first)\r\n409.4 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n414.6 \"Reforged Reflection\" Ability { id: \"794C\", source: \"Hephaistos\" }\r\n421.9 \"Snaking Kick\" Ability { id: \"7929\", source: \"Hephaistos\" }\r\n428.0 \"Gorgomanteia\" Ability { id: \"791A\", source: \"Hephaistos\" }\r\n434.1 \"Into the Shadows\" Ability { id: \"792A\", source: \"Hephaistos\" }\r\n448.1 \"--sync--\" Ability { id: \"792B\", source: \"Gorgon\" }\r\n449.3 \"Petrifaction\" Ability { id: \"6724\", source: \"Gorgon\" }\r\n450.3 \"Gorgospit (outside)\" Ability { id: \"7932\", source: \"Illusory Hephaistos\" }\r\n451.8 \"Blood of the Gorgon 1\" Ability { id: \"792F\", source: \"Hephaistos\" }\r\n451.8 \"Eye of the Gorgon 1\" Ability { id: \"792D\", source: \"Hephaistos\" }\r\n456.4 \"Illusory Creation\" Ability { id: \"7931\", source: \"Hephaistos\" }\r\n457.8 \"Blood of the Gorgon 2\" Ability { id: \"792F\", source: \"Hephaistos\" }\r\n457.8 \"Eye of the Gorgon 2\" Ability { id: \"792D\", source: \"Hephaistos\" }\r\n465.3 \"Gorgospit (line)\" Ability { id: \"7932\", source: \"Illusory Hephaistos\" }\r\n466.9 \"Crown of the Gorgon\" Ability { id: \"792E\", source: \"Hephaistos\" }\r\n467.8 \"Breath of the Gorgon\" Ability { id: \"7930\", source: \"Hephaistos\" }\r\n481.0 \"Flameviper 1\" Ability { id: \"7945\", source: \"Hephaistos\" }\r\n484.2 \"Flameviper 2\" Ability { id: \"7946\", source: \"Hephaistos\" }\r\n\r\n# Beast 2 (Snake first)\r\n491.4 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n496.6 \"Reforged Reflection\" Ability { id: \"794B\", source: \"Hephaistos\" }\r\n503.1 \"Footprint\" Ability { id: \"7109\", source: \"Hephaistos\" }\r\n509.4 \"Quadrupedal Impact/Quadrupedal Crush\" Ability { id: [\"7A04\", \"7A05\"], source: \"Hephaistos\" }\r\n515.8 \"Conceptual Diflare/Conceptual Tetraflare\" Ability { id: [\"7917\", \"7916\"], source: \"Hephaistos\" }\r\n522.0 \"--sync--\" Ability { id: \"793B\", source: \"Hephaistos\" }\r\n524.2 \"--sync--\" Ability { id: \"793D\", source: \"Hephaistos\" }\r\n526.4 \"--sync--\" Ability { id: \"793B\", source: \"Hephaistos\" }\r\n528.6 \"--sync--\" Ability { id: \"793C\", source: \"Hephaistos\" }\r\n531.0 \"--untargetable--\"\r\n531.0 \"Blazing Footfalls\" Ability { id: \"7938\", source: \"Hephaistos\" }\r\n531.6 \"Trailblaze 1\" Ability { id: \"793E\", source: \"Hephaistos\" }\r\n532.8 \"Emergent Diflare/Emergent Tetraflare\" Ability { id: [\"791B\", \"7919\"], source: \"Hephaistos\" }\r\n535.7 \"--sync--\" Ability { id: \"793F\", source: \"Hephaistos\" }\r\n536.6 \"Quadrupedal Impact/Quadrupedal Crush\" Ability { id: \"7107\", source: \"Hephaistos\" }\r\n539.5 \"--sync--\" Ability { id: \"7939\", source: \"Hephaistos\" }\r\n540.2 \"Trailblaze 2\" Ability { id: \"793E\", source: \"Hephaistos\" }\r\n542.2 \"--sync--\" Ability { id: \"793A\", source: \"Hephaistos\" }\r\n543.1 \"Quadrupedal Impact/Quadrupedal Crush\" Ability { id: \"7106\", source: \"Hephaistos\" }\r\n546.5 \"Torch Flame\" Ability { id: \"7927\", source: \"Hephaistos\" }\r\n547.4 \"--targetable--\"\r\n\r\n# Human 4 (Snake first)\r\n552.6 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n559.9 \"Genesis of Flame\" Ability { id: \"7944\", source: \"Hephaistos\" }\r\n568.1 \"--untargetable--\"\r\n573.1 \"Genesis of Flame (enrage)\" Ability { id: \"794A\", source: \"Hephaistos\" }\r\n\r\n\r\n# Beast 1 (Beast first)\r\n1158.7 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n1163.9 \"Reforged Reflection\" Ability { id: \"794B\", source: \"Hephaistos\" }\r\n1170.3 \"Footprint\" Ability { id: \"7109\", source: \"Hephaistos\" } window 100,100\r\n1177.2 \"Uplift 1\" #Ability { id: \"7935\", source: \"Hephaistos\" }\r\n1179.3 \"Uplift 2\" #Ability { id: \"7935\", source: \"Hephaistos\" }\r\n1181.5 \"Uplift 3\" #Ability { id: \"7935\", source: \"Hephaistos\" }\r\n1183.6 \"Uplift 4\" #Ability { id: \"7935\", source: \"Hephaistos\" }\r\n1189.8 \"--sync--\" Ability { id: \"7936\", source: \"Hephaistos\" }\r\n1190.0 \"Stomp Dead 1\" #Ability { id: \"7937\", source: \"Hephaistos\" }\r\n1192.3 \"Stomp Dead 2\" #Ability { id: \"7937\", source: \"Hephaistos\" }\r\n1194.6 \"Stomp Dead 3\" #Ability { id: \"7937\", source: \"Hephaistos\" }\r\n1196.8 \"Stomp Dead 4\" #Ability { id: \"7937\", source: \"Hephaistos\" }\r\n\r\n# Human 2 (Beast first)\r\n1214.1 \"Illusory Creation\" Ability { id: \"791C\", source: \"Hephaistos\" }\r\n1220.2 \"Creation on Command\" Ability { id: \"794F\", source: \"Hephaistos\" }\r\n1228.0 \"Sunforge\" Ability { id: \"7950\", source: \"Illusory Hephaistos\" }\r\n1228.4 \"Manifold Flames\" Ability { id: \"7921\", source: \"Hephaistos\" }\r\n1229.0 \"Scorching Fang\" Ability { id: \"7952\", source: \"Illusory Hephaistos\" }\r\n1229.0 \"Scorched Pinion\" Ability { id: \"7953\", source: \"Illusory Hephaistos\" }\r\n1229.2 \"Hemitheos's Flare\" Ability { id: \"72CE\", source: \"Hephaistos\" }\r\n1232.6 \"Manifold Flames\" Ability { id: \"7922\", source: \"Hephaistos\" }\r\n1233.4 \"Nest of Flamevipers\" Ability { id: \"7920\", source: \"Hephaistos\" }\r\n1240.1 \"Sunforge\" Ability { id: [\"7950\", \"7951\"], source: \"Illusory Hephaistos\" }\r\n1240.7 \"Tetraflare/Nest of Flamevipers\" Ability { id: [\"791E\", \"791F\"], source: \"Hephaistos\" }\r\n1241.1 \"Scorching Fang/Scorched Pinion\" Ability { id: [\"7952\", \"7953\"], source: \"Illusory Hephaistos\" }\r\n1241.5 \"Emergent Octaflare/Emergent Tetraflare\" Ability { id: [\"7918\", \"7919\"], source: \"Hephaistos\" }\r\n1253.7 \"Torch Flame\" Ability { id: \"7927\", source: \"Hephaistos\" }\r\n1257.8 \"Genesis of Flame\" Ability { id: \"7944\", source: \"Hephaistos\" }\r\n\r\n# Snake 1 (Beast first)\r\n1265.0 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n1270.2 \"Reforged Reflection\" Ability { id: \"794C\", source: \"Hephaistos\" }\r\n1277.5 \"Snaking Kick\" Ability { id: \"7929\", source: \"Hephaistos\" }\r\n1283.6 \"Gorgomanteia\" Ability { id: \"791A\", source: \"Hephaistos\" }\r\n1289.7 \"Into the Shadows\" Ability { id: \"792A\", source: \"Hephaistos\" }\r\n1303.8 \"--sync--\" Ability { id: \"792B\", source: \"Gorgon\" }\r\n1304.9 \"Petrifaction 1\" Ability { id: \"6724\", source: \"Gorgon\" }\r\n1307.4 \"Eye of the Gorgon 1\" Ability { id: \"792D\", source: \"Hephaistos\" }\r\n1310.5 \"Blood of the Gorgon 1\" Ability { id: \"792F\", source: \"Hephaistos\" }\r\n1311.8 \"--sync--\" Ability { id: \"792B\", source: \"Gorgon\" }\r\n1313.0 \"Petrifaction 2\" Ability { id: \"6724\", source: \"Gorgon\" }\r\n1315.5 \"Eye of the Gorgon 2\" Ability { id: \"792D\", source: \"Hephaistos\" }\r\n1318.5 \"Blood of the Gorgon 2\" Ability { id: \"792F\", source: \"Hephaistos\" }\r\n1323.1 \"--sync--\" Ability { id: \"7949\", source: \"Hephaistos\" }\r\n1328.1 \"Ektothermos\" Ability { id: \"79EA\", source: \"Hephaistos\" }\r\n\r\n# Human 3 (Beast first)\r\n1331.1 \"--sync--\" Ability { id: \"7949\", source: \"Hephaistos\" }\r\n1346.5 \"Conceptual Octaflare/Conceptual Tetraflare\" Ability { id: [\"7914\", \"7915\"], source: \"Hephaistos\" }\r\n1352.6 \"Fourfold Fires\" Ability { id: \"78F2\", source: \"Hephaistos\" } window 300,10\r\n1358.4 \"Abyssal Fires\" Ability { id: \"7954\", source: \"Hephaistos\" }\r\n1361.8 \"--sync--\" Ability { id: \"78F0\", source: \"Hephaistos\" }\r\n1367.7 \"Cthonic Vent 1\" Ability { id: \"7925\", source: \"Suneater\" }\r\n1376.7 \"Cthonic Vent 2\" Ability { id: \"794E\", source: \"Suneater\" }\r\n1377.0 \"Tetraflare/Octaflare\" Ability { id: [\"791E\", \"791D\"], source: \"Hephaistos\" }\r\n1381.2 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n1385.7 \"Cthonic Vent 3\" Ability { id: \"7926\", source: \"Suneater\" }\r\n1390.4 \"Sunforge\" Ability { id: [\"7910\", \"7911\"], source: \"Hephaistos\" }\r\n1391.4 \"Scorching Fang/Sun's Pinion\" Ability { id: [\"7912\", \"7913\"], source: \"Hephaistos\" }\r\n1391.6 \"Emergent Octaflare/Emergent Tetraflare\" Ability { id: [\"7918\", \"7919\"], source: \"Hephaistos\" }\r\n1398.8 \"Flameviper 1\" Ability { id: \"7945\", source: \"Hephaistos\" }\r\n1402.0 \"Flameviper 2\" Ability { id: \"7946\", source: \"Hephaistos\" }\r\n\r\n# Beast 2 (Beast first)\r\n1409.1 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n1414.3 \"Reforged Reflection\" Ability { id: \"794B\", source: \"Hephaistos\" }\r\n1420.8 \"Footprint\" Ability { id: \"7109\", source: \"Hephaistos\" }\r\n1427.1 \"Quadrupedal Impact/Quadrupedal Crush\" Ability { id: [\"7A04\", \"7A05\"], source: \"Hephaistos\" }\r\n1433.5 \"Conceptual Diflare/Conceptual Tetraflare\" Ability { id: [\"7917\", \"7916\"], source: \"Hephaistos\" }\r\n1439.7 \"--sync--\" Ability { id: \"793B\", source: \"Hephaistos\" }\r\n1441.9 \"--sync--\" Ability { id: \"793D\", source: \"Hephaistos\" }\r\n1444.1 \"--sync--\" Ability { id: \"793B\", source: \"Hephaistos\" }\r\n1446.3 \"--sync--\" Ability { id: \"793C\", source: \"Hephaistos\" }\r\n1448.7 \"--untargetable--\"\r\n1448.7 \"Blazing Footfalls\" Ability { id: \"7938\", source: \"Hephaistos\" }\r\n1449.3 \"Trailblaze 1\" Ability { id: \"793E\", source: \"Hephaistos\" }\r\n1450.5 \"Emergent Diflare/Emergent Tetraflare\" Ability { id: [\"791B\", \"7919\"], source: \"Hephaistos\" }\r\n1453.4 \"--sync--\" Ability { id: \"793F\", source: \"Hephaistos\" }\r\n1454.3 \"Quadrupedal Impact/Quadrupedal Crush\" Ability { id: \"7107\", source: \"Hephaistos\" }\r\n1457.2 \"--sync--\" Ability { id: \"7939\", source: \"Hephaistos\" }\r\n1457.9 \"Trailblaze 2\" Ability { id: \"793E\", source: \"Hephaistos\" }\r\n1459.9 \"--sync--\" Ability { id: \"793A\", source: \"Hephaistos\" }\r\n1460.8 \"Quadrupedal Impact/Quadrupedal Crush\" Ability { id: \"7106\", source: \"Hephaistos\" }\r\n1464.2 \"Torch Flame\" Ability { id: \"7927\", source: \"Hephaistos\" }\r\n1465.1 \"--targetable--\"\r\n1470.3 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n1477.7 \"Flameviper 1\" Ability { id: \"7945\", source: \"Hephaistos\" }\r\n1480.9 \"Flameviper 2\" Ability { id: \"7946\", source: \"Hephaistos\" }\r\n\r\n# Snake 2 (Beast first)\r\n1488.0 \"--sync--\" Ability { id: \"7108\", source: \"Hephaistos\" }\r\n1493.2 \"Reforged Reflection\" Ability { id: \"794C\", source: \"Hephaistos\" }\r\n1500.5 \"Snaking Kick\" Ability { id: \"7929\", source: \"Hephaistos\" }\r\n1506.6 \"Gorgomanteia\" Ability { id: \"791A\", source: \"Hephaistos\" }\r\n1512.7 \"Into the Shadows\" Ability { id: \"792A\", source: \"Hephaistos\" }\r\n1526.7 \"--sync--\" Ability { id: \"792B\", source: \"Gorgon\" }\r\n1527.9 \"Petrifaction\" Ability { id: \"6724\", source: \"Gorgon\" }\r\n1528.9 \"Gorgospit (outside)\" Ability { id: \"7932\", source: \"Illusory Hephaistos\" }\r\n1530.4 \"Blood of the Gorgon 1\" Ability { id: \"792F\", source: \"Hephaistos\" }\r\n1530.4 \"Eye of the Gorgon 1\" Ability { id: \"792D\", source: \"Hephaistos\" }\r\n1535.0 \"Illusory Creation\" Ability { id: \"7931\", source: \"Hephaistos\" }\r\n1536.4 \"Blood of the Gorgon 2\" Ability { id: \"792F\", source: \"Hephaistos\" }\r\n1536.4 \"Eye of the Gorgon 2\" Ability { id: \"792D\", source: \"Hephaistos\" }\r\n1543.9 \"Gorgospit (line)\" Ability { id: \"7932\", source: \"Illusory Hephaistos\" }\r\n1545.5 \"Crown of the Gorgon\" Ability { id: \"792E\", source: \"Hephaistos\" }\r\n1546.4 \"Breath of the Gorgon\" Ability { id: \"7930\", source: \"Hephaistos\" }\r\n\r\n# Human 4 (Beast first)\r\n1559.4 \"Genesis of Flame\" Ability { id: \"7944\", source: \"Hephaistos\" }\r\n1567.4 \"--untargetable--\"\r\n1572.4 \"Genesis of Flame (enrage)\" Ability { id: \"794A\", source: \"Hephaistos\" }\r\n\r\n\r\n### P8S Part 2\r\n#\r\n# -p 72C2:5005 79DF:5016\r\n# -ii 79DE 79AE 79AF 79B0 79B2 79B4 7A86 7AA0 79B5\r\n# -it \"Hephaistos\"\r\n\r\n5000.0 \"--sync--\"\r\n5005.0 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5008.0 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5011.0 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5011.0 \"--sync--\" StartsUsing { id: \"79DF\", source: \"Hephaistos\" } window 6000,10\r\n5016.0 \"Aioniopyr\" Ability { id: \"79DF\", source: \"Hephaistos\" }\r\n5019.0 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5022.0 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5027.2 \"Tyrant's Unholy Darkness\" Ability { id: \"79DD\", source: \"Hephaistos\" }\r\n5032.2 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5035.3 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n\r\n5040.4 \"Natural Alignment 1\" Ability { id: \"79BB\", source: \"Hephaistos\" } window 20,20\r\n5049.5 \"Twist Nature\" Ability { id: \"79BC\", source: \"Hephaistos\" }\r\n5055.6 \"Tyrant's Flare\" Ability { id: \"7A89\", source: \"Hephaistos\" }\r\n5058.6 \"Forcible Fire III/Forcible Fire II\" Ability { id: [\"79BF\", \"79C0\"], source: \"Hephaistos\" }\r\n5058.6 \"Tyrant's Flare\" Ability { id: \"7A8A\", source: \"Hephaistos\" }\r\n5064.6 \"Forcible Fire II/Forcible Fire III\" Ability { id: [\"79C0\", \"79BF\"], source: \"Hephaistos\" }\r\n\r\n5064.6 \"Ashing Blaze\" Ability { id: [\"79D7\", \"79D8\"], source: \"Hephaistos\" }\r\n5076.4 \"Forcible Trifire/Forcible Difreeze\" Ability { id: [\"79BD\", \"79BE\"], source: \"Hephaistos\" }\r\n5082.4 \"Forcible Difreeze/Forcible Trifire\" Ability { id: [\"79BE\", \"79BD\"], source: \"Hephaistos\" }\r\n\r\n5088.7 \"Aioniopyr\" Ability { id: \"79DF\", source: \"Hephaistos\" } window 20,20\r\n5091.7 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5094.8 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5101.9 \"Tyrant's Unholy Darkness\" Ability { id: \"79DD\", source: \"Hephaistos\" }\r\n5106.9 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5114.1 \"--sync--\" Ability { id: \"79AC\", source: \"Hephaistos\" }\r\n5118.6 \"High Concept 1\" Ability { id: \"710A\", source: \"Hephaistos\" } window 20,20\r\n5118.6 \"--untargetable--\"\r\n5126.3 \"Arcane Control\" Ability { id: \"79B6\", source: \"Hephaistos\" }\r\n5126.7 \"Conceptual Shift\" Ability { id: \"79AD\", source: \"Hephaistos\" }\r\n5126.7 \"Splicer\" Ability { id: \"79B3\", source: \"Hephaistos\" }\r\n5138.5 \"Ashing Blaze\" Ability { id: [\"79D7\", \"79D8\"], source: \"Hephaistos\" }\r\n5138.5 \"Arcane Channel\" Ability { id: \"79B7\", source: \"Hephaistos\" }\r\n5144.6 \"Arcane Control\" Ability { id: \"79B6\", source: \"Hephaistos\" }\r\n5144.7 \"Conceptual Shift\" Ability { id: \"79AD\", source: \"Hephaistos\" }\r\n5156.7 \"Ashing Blaze\" Ability { id: [\"79D7\", \"79D8\"], source: \"Hephaistos\" }\r\n5156.7 \"Arcane Channel\" Ability { id: \"79B7\", source: \"Hephaistos\" }\r\n5159.8 \"--targetable--\"\r\n5162.8 \"Deconceptualize\" Ability { id: \"7A8E\", source: \"Hephaistos\" }\r\n\r\n5170.9 \"Aioniopyr\" Ability { id: \"79DF\", source: \"Hephaistos\" } window 20,20\r\n5174.0 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5177.1 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5180.1 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5185.3 \"Limitless Desolation\" Ability { id: \"75ED\", source: \"Hephaistos\" }\r\n5186.5 \"Tyrant's Fire III 1\" Ability { id: \"75F0\", source: \"Hephaistos\" }\r\n5189.5 \"Tyrant's Fire III 2\" Ability { id: \"75F0\", source: \"Hephaistos\" }\r\n5192.5 \"Tyrant's Fire III 3\" Ability { id: \"75F0\", source: \"Hephaistos\" }\r\n5195.5 \"Tyrant's Fire III 4\" Ability { id: \"75F0\", source: \"Hephaistos\" }\r\n5197.5 \"Tyrant's Flare II\" Ability { id: \"7A88\", source: \"Hephaistos\" }\r\n5197.5 \"Burst 1\" #Ability { id: \"79D5\", source: \"Hephaistos\" }\r\n5200.4 \"Tyrant's Flare II\" #Ability { id: \"7A88\", source: \"Hephaistos\" }\r\n5200.4 \"Burst 2\" #Ability { id: \"79D5\", source: \"Hephaistos\" }\r\n5203.4 \"Tyrant's Flare II\" #Ability { id: \"7A88\", source: \"Hephaistos\" }\r\n5203.4 \"Burst 3\" #Ability { id: \"79D5\", source: \"Hephaistos\" }\r\n5206.3 \"Tyrant's Flare II\" #Ability { id: \"7A88\", source: \"Hephaistos\" }\r\n5206.3 \"Burst 4\" #Ability { id: \"79D5\", source: \"Hephaistos\" }\r\n\r\n5213.2 \"Aioniopyr\" Ability { id: \"79DF\", source: \"Hephaistos\" } window 20,20\r\n5216.3 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5219.3 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5226.3 \"Tyrant's Unholy Darkness\" Ability { id: \"79DD\", source: \"Hephaistos\" }\r\n5231.4 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5234.4 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5241.5 \"Natural Alignment 2\" Ability { id: \"79BB\", source: \"Hephaistos\" }\r\n5247.6 \"Inverse Magicks\" Ability { id: \"79C2\", source: \"Hephaistos\" }\r\n5253.7 \"Twist Nature\" Ability { id: \"79BC\", source: \"Hephaistos\" }\r\n5262.9 \"Forcible Fire III/Forcible Fire II\" Ability { id: [\"79BF\", \"79C0\"], source: \"Hephaistos\" }\r\n5268.9 \"Forcible Fire II/Forcible Fire III\" Ability { id: [\"79C0\", \"79BF\"], source: \"Hephaistos\" }\r\n5281.8 \"Forcible Trifire/Forcible Difreeze\" Ability { id: [\"79BD\", \"79BE\"], source: \"Hephaistos\" }\r\n5287.9 \"Forcible Difreeze/Forcible Trifire\" Ability { id: [\"79BE\", \"79BD\"], source: \"Hephaistos\" }\r\n5293.8 \"Ashing Blaze\" Ability { id: [\"79D7\", \"79D8\"], source: \"Hephaistos\" }\r\n\r\n5301.9 \"Aioniopyr\" Ability { id: \"79DF\", source: \"Hephaistos\" } window 20,20\r\n5305.0 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5308.0 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n5315.0 \"Tyrant's Unholy Darkness\" Ability { id: \"79DD\", source: \"Hephaistos\" }\r\n5320.2 \"--auto--\" #Ability { id: \"72C2\", source: \"Hephaistos\" }\r\n\r\n5327.2 \"--sync--\" Ability { id: \"79AC\", source: \"Hephaistos\" }\r\n5331.7 \"High Concept 2\" Ability { id: \"710A\", source: \"Hephaistos\" } window 20,20\r\n5331.7 \"--untargetable--\"\r\n5339.4 \"Arcane Control\" Ability { id: \"79B6\", source: \"Hephaistos\" }\r\n5339.8 \"Conceptual Shift\" Ability { id: \"79AD\", source: \"Hephaistos\" }\r\n5339.8 \"Splicer\" Ability { id: \"79B3\", source: \"Hephaistos\" }\r\n5351.6 \"Ashing Blaze\" Ability { id: [\"79D7\", \"79D8\"], source: \"Hephaistos\" }\r\n5351.6 \"Arcane Channel\" Ability { id: \"79B7\", source: \"Hephaistos\" }\r\n5357.7 \"Arcane Control\" Ability { id: \"79B6\", source: \"Hephaistos\" }\r\n5357.8 \"Conceptual Shift\" Ability { id: \"79AD\", source: \"Hephaistos\" }\r\n5370.0 \"End of Days\" Ability { id: \"79B9\", source: \"Illusory Hephaistos\" }\r\n5370.0 \"Arcane Channel\" Ability { id: \"79B7\", source: \"Hephaistos\" }\r\n5373.9 \"--targetable--\"\r\n5390.0 \"Ego Death\" Ability { id: \"79BA\", source: \"Hephaistos\" }\r\n5403.4 \"--sync--\" Ability { id: \"79F0\", source: \"Hephaistos\" }\r\n\r\n5424.5 \"Aionagonia 1\" Ability { id: \"7A22\", source: \"Hephaistos\" } window 20,20\r\n5434.6 \"Dominion\" Ability { id: \"79D9\", source: \"Hephaistos\" }\r\n5435.7 \"Orogenic Deformation\" Ability { id: \"79DB\", source: \"Hephaistos\" }\r\n5442.7 \"Orogenic Shift 1\" Ability { id: \"79DC\", source: \"Hephaistos\" }\r\n5448.7 \"Orogenic Shift 2\" Ability { id: \"79DC\", source: \"Hephaistos\" }\r\n\r\n5453.8 \"Aionagonia 2\" Ability { id: \"7A22\", source: \"Hephaistos\" }\r\n5463.9 \"Dominion\" Ability { id: \"79D9\", source: \"Hephaistos\" }\r\n5465.0 \"Orogenic Deformation\" Ability { id: \"79DB\", source: \"Hephaistos\" }\r\n5472.0 \"Orogenic Shift 1\" Ability { id: \"79DC\", source: \"Hephaistos\" }\r\n5478.0 \"Orogenic Shift 2\" Ability { id: \"79DC\", source: \"Hephaistos\" }\r\n\r\n5483.0 \"Aionagonia 3\" Ability { id: \"7A22\", source: \"Hephaistos\" } window 20,20\r\n\r\n5490.3 \"--sync--\" StartsUsing { id: \"79E4\", source: \"Hephaistos\" } window 50,50\r\n5506.3 \"Ego Death (enrage)\" Ability { id: \"79E4\", source: \"Hephaistos\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p9n.ts




const p9n_triggerSet = {
  id: 'AnabaseiosTheNinthCircle',
  zoneId: zone_id/* default.AnabaseiosTheNinthCircle */.Z.AnabaseiosTheNinthCircle,
  timelineFile: 'p9n.txt',
  triggers: [{
    id: 'P9N Gluttony\'s Augur',
    type: 'StartsUsing',
    netRegex: {
      id: '8116',
      source: 'Kokytos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P9N Global Spell',
    type: 'StartsUsing',
    netRegex: {
      id: '8141',
      source: 'Kokytos',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'P9N Ascendant Fist',
    type: 'StartsUsing',
    netRegex: {
      id: '8131',
      source: 'Kokytos',
      capture: true
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'P9N Pulverizing Pounce',
    type: 'HeadMarker',
    netRegex: {
      id: '00A1'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'P9N Fire III',
    type: 'HeadMarker',
    netRegex: {
      id: '01C5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'P9N Charybdis',
    type: 'StartsUsing',
    netRegex: {
      id: '8133',
      source: 'Kokytos',
      capture: true
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Drop Puddles Outside',
        de: 'Flächen drausen ablegen',
        fr: 'Déposez les zones au sol à l\'extérieur',
        ja: '散開',
        cn: '散开',
        ko: '바깥쪽에 장판 놓기'
      }
    }
  }, {
    id: 'P9N Archaic Rockbreaker',
    type: 'StartsUsing',
    netRegex: {
      id: '8128',
      source: 'Kokytos',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'P9N Beastly Roar',
    type: 'StartsUsing',
    netRegex: {
      id: '8138',
      source: 'Kokytos',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'P9N Archaic Demolish',
    type: 'StartsUsing',
    netRegex: {
      id: '812F',
      source: 'Kokytos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.healerGroups(),
    outputStrings: {
      healerGroups: outputs/* default.healerGroups */.Z.healerGroups
    }
  }, {
    id: 'P9N Front Combination + Inside Roundhouse',
    type: 'StartsUsing',
    netRegex: {
      id: '8148',
      source: 'Kokytos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Behind and Under',
        de: 'Geh nach Hinten und Unter den Boss',
        fr: 'Allez derrière et sous le boss',
        ja: '後ろ => 中へ',
        cn: '去背后靠近',
        ko: '보스 뒤 그리고 안으로'
      }
    }
  }, {
    id: 'P9N Rear Combination + Inside Roundhouse',
    type: 'StartsUsing',
    netRegex: {
      id: '814A',
      source: 'Kokytos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Front and Under',
        de: 'Geh nach Vorne und Unter den Boss',
        fr: 'Allez devant et sous le boss',
        ja: '前 => 中へ',
        cn: '去正面靠近',
        ko: '보스 앞 그리고 안으로'
      }
    }
  }, {
    id: 'P9N Front Combination + Outside Roundhouse',
    type: 'StartsUsing',
    netRegex: {
      id: '8147',
      source: 'Kokytos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get Behind and Out',
        de: 'Geh nach Hinten und Raus',
        fr: 'Allez derrière et à l\'extérieur',
        ja: '後ろの外側へ',
        cn: '去背后远离',
        ko: '보스 뒤 바깥쪽으로'
      }
    }
  }, {
    id: 'P9N Rear Combination + Outside Roundhouse',
    type: 'StartsUsing',
    netRegex: {
      id: '8149',
      source: 'Kokytos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go Front and Out',
        de: 'Geh nach Vorne und Raus',
        fr: 'Allez devant et à l\'extérieur',
        ja: '前の外側へ',
        cn: '去正面远离',
        ko: '보스 앞 바깥쪽으로'
      }
    }
  }, {
    id: 'P9N Ecliptic Meteor',
    type: 'StartsUsing',
    netRegex: {
      id: '813B',
      source: 'Kokytos',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Hide behind unbroken meteor',
        de: 'Hinter einem nicht zerbrochenen Meteor verstecken',
        fr: 'Cachez-vous derrière le météore intact',
        ja: '壊れていないメテオの後ろへ',
        cn: '躲在未破碎的陨石后',
        ko: '금이 안 간 돌 뒤에 숨기'
      }
    }
  }, {
    id: 'P9N Burst',
    type: 'StartsUsing',
    netRegex: {
      id: '8136',
      source: 'Comet',
      capture: false
    },
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'P9N Gluttonous Rampage',
    type: 'HeadMarker',
    netRegex: {
      id: '013A',
      capture: true
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.tankbusterOnYouStretchTethers();
      if (data.role === 'healer' || data.job === 'BLU') return output.tankbusterOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      tankbusterOnYouStretchTethers: {
        en: 'Tankbuster on YOU -- stretch tether',
        de: 'Tankbuster auf DIR -- Verbindung strecken',
        fr: 'Tankbuster sur VOUS -- Étirez le lien',
        ja: 'タン強 -- 離れる',
        cn: '坦克死刑 -- 远离',
        ko: '탱버 대상자 -- 멀리 떨어지기'
      },
      tankbusterOn: {
        en: 'Tankbuster on ${player}',
        de: 'Tankbuster auf ${player}',
        fr: 'Tankbuster sur ${player}',
        ja: 'タン強: ${player}',
        cn: '坦克死刑 ${player}',
        ko: '"${player}" 탱버'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Front Combination/Rear Combination': 'Front/Rear Combination',
      'Inside Roundhouse/Outside Roundhouse': 'Inside/Outside Roundhouse'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Comet': 'Komet',
      'Fire Sphere': 'Feuersphäre',
      'Ice Sphere': 'Eissphäre',
      'Kokytos': 'Kokytos'
    },
    'replaceText': {
      '\\(Behemoth\\)': '(Behemot)',
      '\\(Fighter\\)': '(Kämpfer)',
      '\\(Mage\\)': '(Magier)',
      '\\(cast\\)': '(Wirken)',
      '\\(resolve\\)': '(Auflösen)',
      'Archaic Demolish': 'Altes Demolieren',
      'Archaic Rockbreaker': 'Alte Erdspaltung',
      'Ascendant Fist': 'Steigende Faust',
      'Beastly Bile': 'Bestiengalle',
      'Beastly Roar': 'Bestialisches Brüllen',
      'Blizzard III': 'Eisga',
      'Burst': 'Zerschmetterung',
      'Charybdis': 'Charybdis',
      'Comet': 'Komet',
      'Disgorge': 'Seelenwende',
      'Dualspell': 'Doppelspruch',
      'Ecliptic Meteor': 'Ekliptik-Meteor',
      'Explosion': 'Explosion',
      'Fire III': 'Feuga',
      'Front Combination': 'Trittfolge vor',
      'Global Spell': 'Spruchsphäre',
      'Gluttonous Rampage': 'Fresswahn',
      'Gluttony\'s Augur': 'Omen der Fresssucht',
      'Iceflame Summoning': 'Beschwörung von Feuer und Eis',
      'Inside Roundhouse': 'Rundumtritt innen',
      'Outside Roundhouse': 'Rundumtritt außen',
      'Pulverizing Pounce': 'Schweres Schmettern',
      'Ravening': 'Seelenfresser',
      'Ravenous Bite': 'Mordshunger',
      'Rear Combination': 'Trittfolge zurück',
      'Shockwave': 'Schockwelle',
      'Sphere Shatter': 'Sphärensplitterung',
      'Swinging Kick': 'Schwungattacke',
      'Touchdown': 'Himmelssturz'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Comet': 'Comète',
      'Fire Sphere': 'Sphère de feu',
      'Ice Sphere': 'sphère gelée',
      'Kokytos': 'Cocyte'
    },
    'replaceText': {
      'Archaic Demolish': 'Démolition archaïque',
      'Archaic Rockbreaker': 'Briseur de rocs archaïque',
      'Ascendant Fist': 'Uppercut pénétrant',
      'Beastly Bile': 'Bile de bête',
      'Beastly Roar': 'Rugissement bestial',
      'Blizzard III': 'Méga Glace',
      'Burst': 'Éclatement',
      'Charybdis': 'Charybde',
      'Comet': 'Comète',
      'Disgorge': 'Renvoi d\'âme',
      'Dualspell': 'Double sort',
      'Ecliptic Meteor': 'Météore écliptique',
      'Explosion': 'Explosion',
      'Fire III': 'Méga Feu',
      'Front Combination': 'Coups de pied pivotants avant en série',
      'Global Spell': 'Sort englobant',
      'Gluttonous Rampage': 'Ravage glouton',
      'Gluttony\'s Augur': 'Augure de gloutonnerie',
      'Iceflame Summoning': 'Invocation de feu et de glace',
      'Inside Roundhouse': 'Coup de pied pivotant intérieur',
      'Outside Roundhouse': 'Coup de pied pivotant extérieur',
      'Pulverizing Pounce': 'Attaque subite violente',
      'Ravening': 'Dévoration d\'âme',
      'Ravenous Bite': 'Morsure vorace',
      'Rear Combination': 'Coups de pied pivotants arrière en série',
      'Shockwave': 'Onde de choc',
      'Sphere Shatter': 'Rupture glacée',
      'Swinging Kick': 'Demi-pivot',
      'Touchdown': 'Atterrissage'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Comet': 'コメット',
      'Fire Sphere': 'ファイアスフィア',
      'Ice Sphere': 'アイススフィア',
      'Kokytos': 'コキュートス'
    },
    'replaceText': {
      'Archaic Demolish': '古式破砕拳',
      'Archaic Rockbreaker': '古式地烈斬',
      'Ascendant Fist': '穿昇拳',
      'Beastly Bile': 'ビーストバイル',
      'Beastly Roar': 'ビーストロア',
      'Blizzard III': 'ブリザガ',
      'Burst': '飛散',
      'Charybdis': 'ミールストーム',
      'Comet': 'コメット',
      'Disgorge': 'ソウルリバース',
      'Dualspell': 'ダブルスペル',
      'Ecliptic Meteor': 'エクリプスメテオ',
      'Explosion': '爆発',
      'Fire III': 'ファイガ',
      'Front Combination': '前方連転脚',
      'Global Spell': 'スペルグローブ',
      'Gluttonous Rampage': 'グラットンランページ',
      'Gluttony\'s Augur': 'グラトニーズアーガー',
      'Iceflame Summoning': 'サモンファイア＆アイス',
      'Inside Roundhouse': '内転脚',
      'Outside Roundhouse': '外転脚',
      'Pulverizing Pounce': 'ヘビーパウンス',
      'Ravening': '魂喰らい',
      'Ravenous Bite': 'ラヴェナスバイト',
      'Rear Combination': '後方連転脚',
      'Shockwave': '衝撃波',
      'Sphere Shatter': '破裂',
      'Swinging Kick': '旋身撃',
      'Touchdown': 'タッチダウン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Comet': '彗星',
      'Fire Sphere': '烈火晶球',
      'Ice Sphere': '冰晶球',
      'Kokytos': '科库托斯'
    },
    'replaceText': {
      '\\(Behemoth\\)': '(野兽)',
      '\\(Fighter\\)': '(武术家)',
      '\\(Mage\\)': '(魔法师)',
      '\\(cast\\)': '(咏唱)',
      '\\(resolve\\)': '(判定)',
      'Archaic Demolish': '古式破碎拳',
      'Archaic Rockbreaker': '古式地烈劲',
      'Ascendant Fist': '穿升拳',
      'Beastly Bile': '野兽胆汁',
      'Beastly Roar': '残虐咆哮',
      'Blizzard III': '冰封',
      'Burst': '飞散',
      'Charybdis': '大漩涡',
      'Comet': '彗星',
      'Disgorge': '吐魂',
      'Dualspell': '双重咏唱',
      'Ecliptic Meteor': '黄道陨石',
      'Explosion': '爆炸',
      'Fire III': '爆炎',
      'Front Combination': '前方连转脚',
      'Global Spell': '全域咏唱',
      'Gluttonous Rampage': '暴食狂怒',
      'Gluttony\'s Augur': '暴食预兆',
      'Iceflame Summoning': '冰火召唤',
      'Inside Roundhouse': '内转脚',
      'Outside Roundhouse': '外转脚',
      'Pulverizing Pounce': '重爪袭',
      'Ravening': '噬魂',
      'Ravenous Bite': '极饿咬',
      'Rear Combination': '后方连转脚',
      'Shockwave': '冲击波',
      'Sphere Shatter': '碎裂',
      'Swinging Kick': '旋身击',
      'Touchdown': '空降'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Comet': '혜성',
      'Fire Sphere': '불 구체',
      'Ice Sphere': '얼음 구체',
      'Kokytos': '코퀴토스'
    },
    'replaceText': {
      '\\(Behemoth\\)': '(마수)',
      '\\(Fighter\\)': '(격투가)',
      '\\(Mage\\)': '(마도사)',
      '\\(cast\\)': '(시전)',
      '\\(resolve\\)': '(실행)',
      'Archaic Demolish': '고대 파쇄권',
      'Archaic Rockbreaker': '고대 지열참',
      'Ascendant Fist': '천승권',
      'Beastly Bile': '마수 담즙',
      'Beastly Roar': '야수의 포효',
      'Blizzard III': '블리자가',
      'Burst': '산산조각',
      'Charybdis': '대소용돌이',
      'Comet': '혜성',
      'Disgorge': '영혼 토출',
      'Dualspell': '이중 시전',
      'Ecliptic Meteor': '황도 메테오',
      'Explosion': '폭발',
      'Fire III': '파이가',
      'Front Combination': '전방 연속 돌려차기',
      'Global Spell': '전방위 마법',
      'Gluttonous Rampage': '게걸스러운 돌격',
      'Gluttony\'s Augur': '폭식의 전조',
      'Iceflame Summoning': '얼음불 소환',
      'Inside Roundhouse': '안쪽 돌려차기',
      'Outside Roundhouse': '바깥쪽 돌려차기',
      'Pulverizing Pounce': '육중한 덮치기',
      'Ravening': '영혼 포식',
      'Ravenous Bite': '탐욕스러운 입질',
      'Rear Combination': '후방 연속 돌려차기',
      'Shockwave': '충격파',
      'Sphere Shatter': '파열',
      'Swinging Kick': '후려차기',
      'Touchdown': '착지'
    }
  }]
};
/* harmony default export */ const p9n = (p9n_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p9n.txt
const raid_p9n_namespaceObject = "### P9N: Anabaseios: The Ninth Circle\r\n#\r\n# List of all ability IDs seen at the bottom of the file\r\n#\r\n# Autos\r\n# -ii 811C 8115 8127 8140\r\n# Cast resolutions\r\n# -ii 8117 8130 8142 813E\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.0 \"--sync--\" Ability { id: \"8115\", source: \"Kokytos\" } window 10,10\r\n18.2 \"Gluttony's Augur\" Ability { id: \"8116\", source: \"Kokytos\" } window 15,15\r\n\r\n\r\n\r\n# Mage Phase 1\r\n26.4 \"Ravening (Mage)\" Ability { id: \"8118\", source: \"Kokytos\" }\r\n41.7 \"--sync--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n48.4 \"Fire III (cast)\" Ability { id: \"814E\", source: \"Kokytos\" }\r\n51.7 \"--sync--\" Ability { id: \"8122\", source: \"Kokytos\" }\r\n56.3 \"Fire III (resolve)\" Ability { id: \"8120\", source: \"Kokytos\" }\r\n68.1 \"Blizzard III (cast)\" Ability { id: \"814F\", source: \"Kokytos\" }\r\n71.4 \"--sync--\" Ability { id: \"8123\", source: \"Kokytos\" }\r\n76.0 \"Blizzard III (resolve)\" Ability { id: \"8121\", source: \"Kokytos\" }\r\n82.6 \"Dualspell\" Ability { id: \"811D\", source: \"Kokytos\" }\r\n85.9 \"--sync--\" Ability { id: \"812[23]\", source: \"Kokytos\" }\r\n90.3 \"Fire III\" Ability { id: [\"8120\", \"811E\"], source: \"Kokytos\" }\r\n90.3 \"Blizzard III\" Ability { id: [\"811F\", \"8121\"], source: \"Kokytos\" }\r\n99.8 \"Global Spell\" Ability { id: \"8141\", source: \"Kokytos\" }\r\n103.0 \"Disgorge\" Ability { id: \"8124\", source: \"Kokytos\" }\r\n\r\n\r\n\r\n# Fighter phase 1\r\n115.2 \"Ravening (Fighter)\" Ability { id: \"8119\", source: \"Kokytos\" }\r\n136.6 \"Archaic Rockbreaker\" Ability { id: \"8128\", source: \"Kokytos\" }\r\n138.2 \"Shockwave\" Ability { id: \"8129\", source: \"Kokytos\" }\r\n145.1 \"Archaic Rockbreaker 1\" Ability { id: \"812A\", source: \"Kokytos\" }\r\n150.1 \"Archaic Rockbreaker 2\" Ability { id: \"812A\", source: \"Kokytos\" }\r\n156.7 \"Archaic Demolish\" Ability { id: \"812F\", source: \"Kokytos\" }\r\n163.8 \"Gluttony's Augur\" Ability { id: \"8116\", source: \"Kokytos\" }\r\n170.9 \"Ascendant Fist\" Ability { id: \"8131\", source: \"Kokytos\" }\r\n183.2 \"Front Combination/Rear Combination\" Ability { id: \"814[8A]\", source: \"Kokytos\" }\r\n183.4 \"Outside Roundhouse\" Ability { id: \"812C\", source: \"Kokytos\" }\r\n186.4 \"Swinging Kick\" Ability { id: \"812[DE]\", source: \"Kokytos\" }\r\n190.5 \"Disgorge\" Ability { id: \"8125\", source: \"Kokytos\" }\r\n198.8 \"--sync--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n\r\n\r\n\r\n# Behemoth phase 1\r\n203.5 \"Ravening (Behemoth)\" Ability { id: \"811A\", source: \"Kokytos\" }\r\n220.8 \"Charybdis\" Ability { id: \"8132\", source: \"Kokytos\" }\r\n221.8 \"--sync--\" Ability { id: \"8133\", source: \"Kokytos\" }\r\n226.9 \"Beastly Roar\" Ability { id: \"8138\", source: \"Kokytos\" }\r\n229.0 \"Beastly Bile\" Ability { id: \"813D\", source: \"Kokytos\" }\r\n238.1 \"Pulverizing Pounce\" Ability { id: \"813F\", source: \"Kokytos\" }\r\n253.4 \"Gluttonous Rampage\" Ability { id: \"8139\", source: \"Kokytos\" }\r\n253.6 \"Ravenous Bite 1\" #Ability { id: \"813A\", source: \"Kokytos\" }\r\n255.7 \"Ravenous Bite 2\" #Ability { id: \"813A\", source: \"Kokytos\" }\r\n257.9 \"Touchdown\" Ability { id: \"8137\", source: \"Kokytos\" }\r\n258.1 \"--sync--\" Ability { id: \"8146\", source: \"Kokytos\" }\r\n268.8 \"Comet\" Ability { id: \"8134\", source: \"Kokytos\" }\r\n269.8 \"--sync--\" Ability { id: \"8135\", source: \"Comet\" }\r\n277.8 \"--sync--\" Ability { id: \"813B\", source: \"Kokytos\" }\r\n278.8 \"--sync--\" Ability { id: \"813C\", source: \"Kokytos\" }\r\n279.8 \"Ecliptic Meteor\" Ability { id: \"8188\", source: \"Kokytos\" }\r\n279.9 \"--sync--\" Ability { id: \"8143\", source: \"Comet\" }\r\n285.9 \"Burst\" Ability { id: \"8136\", source: \"Comet\" }\r\n286.0 \"Pulverizing Pounce\" Ability { id: \"813F\", source: \"Kokytos\" }\r\n288.8 \"Disgorge\" Ability { id: \"8126\", source: \"Kokytos\" }\r\n\r\n\r\n\r\n# Mage phase 2\r\n304.3 \"Ravening (Mage)\" Ability { id: \"8118\", source: \"Kokytos\" }\r\n318.6 \"--sync--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n325.2 \"Iceflame Summoning\" Ability { id: \"86E1\", source: \"Kokytos\" }\r\n330.1 \"--sync--\" Ability { id: \"812[23]\", source: \"Kokytos\" }\r\n336.1 \"--sync--\" Ability { id: \"872[9A]\", source: \"Ice Sphere\" }\r\n336.1 \"--sync--\" Ability { id: \"872[78]\", source: \"Fire Sphere\" }\r\n336.1 \"Sphere Shatter\" Ability { id: \"86E[45]\", source: \"Ice Sphere\" }\r\n336.1 \"Explosion\" Ability { id: \"86E[23]\", source: \"Fire Sphere\" }\r\n340.7 \"Iceflame Summoning\" Ability { id: \"86E1\", source: \"Kokytos\" }\r\n345.6 \"--sync--\" Ability { id: \"812[23]\", source: \"Kokytos\" }\r\n351.6 \"--sync--\" Ability { id: \"872[9A]\", source: \"Ice Sphere\" }\r\n351.6 \"--sync--\" Ability { id: \"872[78]\", source: \"Fire Sphere\" }\r\n351.6 \"Sphere Shatter\" Ability { id: \"86E[45]\", source: \"Ice Sphere\" }\r\n351.6 \"Explosion\" Ability { id: \"86E[23]\", source: \"Fire Sphere\" }\r\n356.0 \"Dualspell\" Ability { id: \"811D\", source: \"Kokytos\" }\r\n359.3 \"--sync--\" Ability { id: \"812[23]\", source: \"Kokytos\" }\r\n363.8 \"Blizzard III\" Ability { id: [\"811F\", \"8121\"], source: \"Kokytos\" }\r\n363.8 \"Fire III\" Ability { id: [\"811E\", \"8120\"], source: \"Kokytos\" }\r\n370.5 \"Global Spell\" Ability { id: \"8141\", source: \"Kokytos\" }\r\n372.7 \"Disgorge\" Ability { id: \"8124\", source: \"Kokytos\" }\r\n\r\n\r\n\r\n# Fighter phase 2\r\n385.0 \"Ravening (Fighter)\" Ability { id: \"8119\", source: \"Kokytos\" }\r\n403.2 \"Archaic Rockbreaker\" Ability { id: \"8128\", source: \"Kokytos\" }\r\n404.8 \"Shockwave\" Ability { id: \"8129\", source: \"Kokytos\" }\r\n411.7 \"Archaic Rockbreaker 1\" Ability { id: \"812A\", source: \"Kokytos\" }\r\n416.7 \"Archaic Rockbreaker 2\" Ability { id: \"812A\", source: \"Kokytos\" }\r\n421.8 \"Front Combination/Rear Combination\" Ability { id: \"814[789A]\", source: \"Kokytos\" }\r\n422.0 \"Inside Roundhouse/Outside Roundhouse\" Ability { id: \"812[BC]\", source: \"Kokytos\" }\r\n425.0 \"Swinging Kick\" Ability { id: \"812[DE]\", source: \"Kokytos\" }\r\n433.1 \"Gluttony's Augur\" Ability { id: \"8116\", source: \"Kokytos\" }\r\n445.4 \"Ascendant Fist\" Ability { id: \"8131\", source: \"Kokytos\" }\r\n447.5 \"Disgorge\" Ability { id: \"8125\", source: \"Kokytos\" }\r\n457.9 \"--sync--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n\r\n\r\n\r\n# Behemoth phase 2\r\n462.5 \"Ravening (Behemoth)\" Ability { id: \"811A\", source: \"Kokytos\" }\r\n486.1 \"Comet\" Ability { id: \"8134\", source: \"Kokytos\" }\r\n487.1 \"--sync--\" Ability { id: \"8135\", source: \"Comet\" }\r\n495.1 \"--sync--\" Ability { id: \"813B\", source: \"Kokytos\" }\r\n496.1 \"--sync--\" Ability { id: \"813C\", source: \"Kokytos\" }\r\n497.1 \"Ecliptic Meteor\" Ability { id: \"8188\", source: \"Kokytos\" }\r\n497.2 \"--sync--\" Ability { id: \"8143\", source: \"Comet\" }\r\n501.2 \"Beastly Bile\" Ability { id: \"813D\", source: \"Kokytos\" }\r\n503.1 \"Burst\" Ability { id: \"8136\", source: \"Comet\" }\r\n510.3 \"Pulverizing Pounce\" Ability { id: \"813F\", source: \"Kokytos\" }\r\n523.7 \"Gluttonous Rampage\" Ability { id: \"8139\", source: \"Kokytos\" }\r\n523.9 \"Ravenous Bite 1\" #Ability { id: \"813A\", source: \"Kokytos\" }\r\n526.1 \"Ravenous Bite 2\" #Ability { id: \"813A\", source: \"Kokytos\" }\r\n528.1 \"Touchdown\" Ability { id: \"8137\", source: \"Kokytos\" }\r\n528.5 \"--sync--\" Ability { id: \"8146\", source: \"Kokytos\" }\r\n531.3 \"Disgorge\" Ability { id: \"8126\", source: \"Kokytos\" }\r\n\r\n\r\n\r\n# Mage phase 3, loops back to mage phase 2\r\n549.8 \"Ravening (Mage)\" Ability { id: \"8118\", source: \"Kokytos\" } window 50,50 jump 304.3\r\n570.7 \"Iceflame Summoning\" #Ability { id: \"86E1\", source: \"Kokytos\" }\r\n581.6 \"Sphere Shatter\" #Ability { id: \"86E[45]\", source: \"Ice Sphere\" }\r\n581.6 \"Explosion\" #Ability { id: \"86E[23]\", source: \"Fire Sphere\" }\r\n586.2 \"Iceflame Summoning\" #Ability { id: \"86E1\", source: \"Kokytos\" }\r\n\r\n# Ability IDs that appear in this instance:\r\n# UMFB = Unaspected, Mage, Fighter, Behemoth\r\n# \"Unaspected\" being the state the boss is in before the first Ravening, and between Disgorge and Ravening\r\n#\r\n# Ability ID   | UMFB | Description\r\n# Kokytos:8115 | U    | Auto-attack (unaspected)\r\n# Kokytos:8116 | U F  | Gluttony's Augur - cast bar\r\n# Kokytos:8117 | U F  | Gluttony's Augur - damage\r\n# Kokytos:8118 | U  B | Ravening - move to mage phase\r\n# Kokytos:8119 |  M   | Ravening - move to fighter phase\r\n# Kokytos:811A |   F  | Ravening - move to Behemoth phase\r\n# Kokytos:811C |  M   | Auto-attack (magical, mage)\r\n# Kokytos:811D |  M   | Dualspell\r\n# Kokytos:811E |  M   | Fire III (small, static)\r\n# Kokytos:811F |  M   | Blizzard III (large, static)\r\n# Kokytos:8120 |  M   | Fire III (large, growing)\r\n# Kokytos:8121 |  M   | Blizzard III (small, shrinking)\r\n# Kokytos:8122 |  M   | Fire VFX flash\r\n# Kokytos:8123 |  M   | Ice VFX flash\r\n# Kokytos:8124 |  M   | Disgorge (end of mage phase)\r\n# Kokytos:8125 |   F  | Disgorge (end of fighter phase)\r\n# Kokytos:8126 |    B | Disgorge (end of Behemoth phase)\r\n# Kokytos:8127 |   F  | Auto-attack (physical, fighter)\r\n# Kokytos:8128 |   F  | Archaic Rockbreaker (cast)\r\n# Kokytos:8129 |   F  | Shockwave\r\n# Kokytos:812A |   F  | Archaic Rockbreaker (AoE explosion)\r\n# Kokytos:812B |   F  | Inside Roundhouse\r\n# Kokytos:812C |   F  | Outside Roundhouse\r\n# Kokytos:812D |   F  | Swinging Kick (Front Combination)\r\n# Kokytos:812E |   F  | Swinging Kick (Rear Combination)\r\n# Kokytos:812F |   F  | Archaic Demolish (cast)\r\n# Kokytos:8130 |   F  | Archaic Demolish (damage)\r\n# Kokytos:8131 |   F  | Ascendant Fist\r\n# Kokytos:8132 |    B | Charybdis (cast, self-targeted)\r\n# Kokytos:8133 |    B | Charybdis (damage, targets 4 players)\r\n# Kokytos:8134 |    B | Comet\r\n# Kokytos:8135 |    B | Comet Impact\r\n#   Comet:8136 |      | Burst\r\n# Kokytos:8137 |    B | Touchdown\r\n# Kokytos:8138 |    B | Beastly Roar\r\n# Kokytos:8139 |    B | Gluttonous Rampage\r\n# Kokytos:813A |    B | Ravenous Bite (tankbuster)\r\n# Kokytos:813B |    B | Ecliptic Meteor\r\n# Kokytos:813C |    B | Ecliptic Meteor\r\n# Kokytos:813D |    B | Beastly Bile (cast)\r\n# Kokytos:813E |    B | Beastly Bile (damage)\r\n# Kokytos:813F |    B | Pulverizing Pounce\r\n# Kokytos:8140 |    B | Auto-attack (physical, behemoth)\r\n# Kokytos:8141 |  M   | Global Spell (cast)\r\n# Kokytos:8142 |  M   | Global Spell (damage)\r\n#   Comet:8143 |      | Burst\r\n# Kokytos:8144 | UM   | ???\r\n# Kokytos:8146 |    B | ???\r\n# Kokytos:8147 |   F  | Front Combination (second phase)\r\n# Kokytos:8148 |   F  | Front Combination (first phase)\r\n# Kokytos:8149 |   F  | Rear Combination (second phase)\r\n# Kokytos:814A |   F  | Rear Combination (first phase)\r\n# Kokytos:814E |  M   | Fire III - Cast\r\n# Kokytos:814F |  M   | Blizzard III - Cast\r\n# Kokytos:8188 |    B | Ecliptic Meteor\r\n# Kokytos:86E1 |  M   | Iceflame Summoning\r\n#\r\n# Ice Sphere:86E4 | Sphere Shatter (small)\r\n# Ice Sphere:86E5 | Sphere Shatter (large)\r\n# Ice Sphere:872A | Large omen\r\n# Ice Sphere:8729 | Small omen\r\n#\r\n# Fire Sphere:86E2 | Explosion (small)\r\n# Fire Sphere:86E3 | Explosion (large)\r\n# Fire Sphere:8727 | Small omen\r\n# Fire Sphere:8728 | Large omen\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p9s.ts





// TODO: something for Charybdis??

const dualspells = {
  fireIce: ['8154', '8184'],
  thunderIce: ['8155', '8185']
};
const p9s_headmarkers = {
  // vfx/lockon/eff/tank_lockonae_0m_5s_01t.avfx
  dualityOfDeath: '01D4',
  // vfx/lockon/eff/m0361trg_a1t.avfx (through m0361trg_a8t)
  limitCut1: '004F',
  limitCut2: '0050',
  limitCut3: '0051',
  limitCut4: '0052',
  limitCut5: '0053',
  limitCut6: '0054',
  limitCut7: '0055',
  limitCut8: '0056',
  // vfx/lockon/eff/r1fz_skywl_s9x.avfx
  defamation: '014A',
  // vfx/lockon/eff/n5r9_lockon_bht_c0g.avfx
  cometMarker: '01B3'
};
const limitCutMarkers = [p9s_headmarkers.limitCut1, p9s_headmarkers.limitCut2, p9s_headmarkers.limitCut3, p9s_headmarkers.limitCut4, p9s_headmarkers.limitCut5, p9s_headmarkers.limitCut6, p9s_headmarkers.limitCut7, p9s_headmarkers.limitCut8];
const p9s_limitCutNumberMap = {
  '004F': 1,
  '0050': 2,
  '0051': 3,
  '0052': 4,
  '0053': 5,
  '0054': 6,
  '0055': 7,
  '0056': 8
};
const limitCutPlayerActive = [
// These ordered nested arrays contain the limit cut headmarkers for [ dash order, tower soak order ]
[2, 6], [4, 8], [6, 2], [8, 4]];

// Time between headmarker and defamation for Chimeric Succession.
const chimericLimitCutTime = {
  1: 10,
  2: 13,
  3: 16,
  4: 19
};
const p9s_firstHeadmarker = parseInt(p9s_headmarkers.dualityOfDeath, 16);
const p9s_getHeadmarkerId = (data, matches) => {
  // If we naively just check !data.decOffset and leave it, it breaks if the first marker is 00DA.
  // (This makes the offset 0, and !0 is true.)
  if (data.decOffset === undefined) data.decOffset = parseInt(matches.id, 16) - p9s_firstHeadmarker;
  // The leading zeroes are stripped when converting back to string, so we re-add them here.
  // Fortunately, we don't have to worry about whether or not this is robust,
  // since we know all the IDs that will be present in the encounter.
  return (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase().padStart(4, '0');
};
const p9s_centerX = 100;
const p9s_centerY = 100;
const p9s_triggerSet = {
  id: 'AnabaseiosTheNinthCircleSavage',
  zoneId: zone_id/* default.AnabaseiosTheNinthCircleSavage */.Z.AnabaseiosTheNinthCircleSavage,
  timelineFile: 'p9s.txt',
  initData: () => {
    return {
      dualityBuster: [],
      levinOrbs: {},
      limitCutDash: 0,
      limitCut1Count: 0
    };
  },
  triggers: [{
    id: 'P9S Headmarker Tracker',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.decOffset === undefined,
    suppressSeconds: 99999,
    // Unconditionally set the first headmarker here so that future triggers are conditional.
    run: (data, matches) => p9s_getHeadmarkerId(data, matches)
  }, {
    id: 'P9S Gluttony\'s Augur',
    type: 'StartsUsing',
    netRegex: {
      id: '814C',
      source: 'Kokytos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P9S Soul Surge',
    type: 'Ability',
    // Soul Surge happens ~6s after any Ravening with no cast bar.
    netRegex: {
      id: ['8118', '8119', '817B', '811A'],
      source: 'Kokytos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'P9S Duality of Death Collect',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => p9s_getHeadmarkerId(data, matches) === p9s_headmarkers.dualityOfDeath,
    run: (data, matches) => data.dualityBuster.push(matches.target)
  }, {
    id: 'P9S Duality of Death',
    type: 'StartsUsing',
    netRegex: {
      id: '8151',
      source: 'Kokytos',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankBusterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
        tankSwap: outputs/* default.tankSwap */.Z.tankSwap,
        tankBusters: outputs/* default.tankBusters */.Z.tankBusters
      };
      if (data.dualityBuster.includes(data.me)) {
        if (data.role !== 'tank' && data.job !== 'BLU') return {
          alarmText: output.tankBusterOnYou()
        };
        return {
          alertText: output.tankSwap()
        };
      }
      return {
        infoText: output.tankBusters()
      };
    },
    run: data => data.dualityBuster = []
  }, {
    id: 'P9S Dualspell Fire/Ice',
    type: 'StartsUsing',
    netRegex: {
      id: dualspells.fireIce,
      source: 'Kokytos'
    },
    durationSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    run: (data, matches) => data.lastDualspellId = matches.id,
    outputStrings: {
      text: {
        en: 'Partners + Donut',
        de: 'Partner + Donut',
        fr: 'Partenaires + Donut',
        ja: 'ペア + ドーナツ',
        cn: '双人分摊 + 月环',
        ko: '파트너 + 도넛'
      }
    }
  }, {
    id: 'P9S Dualspell Thunder/Ice',
    type: 'StartsUsing',
    netRegex: {
      id: dualspells.thunderIce,
      source: 'Kokytos'
    },
    durationSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    run: (data, matches) => data.lastDualspellId = matches.id,
    outputStrings: {
      text: {
        en: 'Protean + Donut',
        de: 'Himmelsrichtungen + Donut',
        fr: 'Positions + Donut',
        ja: '基本散会 + ドーナツ',
        cn: '八方分散 + 月环',
        ko: '8방향 산개 + 도넛'
      }
    }
  }, {
    id: 'P9S Fire Symbol',
    type: 'Ability',
    netRegex: {
      id: '8122',
      source: 'Kokytos',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.lastDualspellId === undefined) return output.out();
      if (dualspells.fireIce.includes(data.lastDualspellId)) return output.fireIceOut();
      return output.out();
    },
    run: data => delete data.lastDualspellId,
    outputStrings: {
      fireIceOut: {
        en: 'Out + Partners',
        de: 'Raus + Partner',
        fr: 'Extérieur + Partenaires',
        ja: '外側へ + ペア',
        cn: '远离 + 双人分摊',
        ko: '밖으로 + 파트너'
      },
      out: outputs/* default.out */.Z.out
    }
  }, {
    id: 'P9S Ice Symbol',
    type: 'Ability',
    netRegex: {
      id: '8123',
      source: 'Kokytos',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.lastDualspellId === undefined) return output.in();
      if (dualspells.fireIce.includes(data.lastDualspellId)) return output.fireIceIn();
      if (dualspells.thunderIce.includes(data.lastDualspellId)) return output.thunderIceIn();
      return output.in();
    },
    run: data => delete data.lastDualspellId,
    outputStrings: {
      fireIceIn: {
        en: 'In + Partners',
        de: 'Rein + Partner',
        fr: 'Intérieur + Partenaires',
        ja: '内側へ + ペア',
        cn: '靠近 + 双人分摊',
        ko: '안으로 + 파트너'
      },
      thunderIceIn: {
        en: 'In + Protean',
        de: 'Rein + Himmelsrichtungen',
        fr: 'Intérieur + Positions',
        ja: '内側へ + 基本散会',
        cn: '靠近 + 八方分散',
        ko: '안으로 + 8방향 산개'
      },
      in: outputs/* default.in */.Z["in"]
    }
  }, {
    id: 'P9S Thunder Symbol',
    type: 'Ability',
    netRegex: {
      id: '815C',
      source: 'Kokytos',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.lastDualspellId === undefined) return output.out();
      if (dualspells.thunderIce.includes(data.lastDualspellId)) return output.thunderIceOut();
      return output.out();
    },
    run: data => delete data.lastDualspellId,
    outputStrings: {
      thunderIceOut: {
        en: 'Out + Protean',
        de: 'Raus + Himmelsrichtungen',
        fr: 'Extérieur + Positions',
        ja: '外側へ + 基本散会',
        cn: '远离 + 八方分散',
        ko: '밖으로 + 8방향 산개'
      },
      out: outputs/* default.out */.Z.out
    }
  }, {
    id: 'P9S Ascendant Fist',
    type: 'StartsUsing',
    netRegex: {
      id: '816F',
      source: 'Kokytos'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'P9S Archaic Rockbreaker',
    type: 'StartsUsing',
    netRegex: {
      id: '815F',
      source: 'Kokytos',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Knockback into Wall',
        de: 'Rückstoß in die Wand',
        fr: 'Poussée sur un mur',
        ja: 'ノックバック',
        cn: '向墙边击退',
        ko: '벽으로 넉백'
      }
    }
  }, {
    id: 'P9S Archaic Demolish',
    type: 'StartsUsing',
    netRegex: {
      id: '816D',
      source: 'Kokytos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.healerGroups(),
    outputStrings: {
      healerGroups: outputs/* default.healerGroups */.Z.healerGroups
    }
  }, {
    // Ball of Levin combatants are added ~0.3 seconds after Kokytos finishes using Levinstrike Summoning
    // and ~1.7 before Kokytos begins using Scrambled Succession (which is when limit cut markers appear)
    // These combatants are added in their actual positions, so no need to check OP for combatant data.
    id: 'P9S Limit Cut Levin Orb Collect',
    type: 'AddedCombatant',
    // There are multiple invsible combatants that share this name, but the ones that receive HeadMarkers
    // in limit cut (the ones we care about) are distinguishable because their level attribute is set to 90.
    netRegex: {
      name: 'Ball of Levin',
      level: '5A'
    },
    run: (data, matches) => {
      // (0 = N, 1 = NE ... 7 = NW)
      const orb8Dir = util/* Directions.addedCombatantPosTo8Dir */.N.addedCombatantPosTo8Dir(matches, p9s_centerX, p9s_centerY);
      data.levinOrbs[matches.id] = {
        dir: orb8Dir
      };
    }
  }, {
    id: 'P9S Limit Cut Levin Orb Order Collect',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      return limitCutMarkers.includes(p9s_getHeadmarkerId(data, matches)) && Object.keys(data.levinOrbs).includes(matches.targetId);
    },
    run: (data, matches) => {
      const correctedMatch = p9s_getHeadmarkerId(data, matches);
      const orbLimitCutNumber = p9s_limitCutNumberMap[correctedMatch];

      // Levin orbs should always receive a odd-numbered limit cut headmarker
      const expectedOrbLimitCutNumbers = [1, 3, 5, 7];
      if (orbLimitCutNumber === undefined || !expectedOrbLimitCutNumbers.includes(orbLimitCutNumber)) {
        console.error('Invalid limit cut headmarker on orb');
        return;
      }
      const orbData = data.levinOrbs[matches.targetId] ?? {};
      if (typeof orbData.dir === 'undefined') {
        console.error('Limit cut headmarker on unknown orb');
        return;
      }
      orbData.order = orbLimitCutNumber;
      data.levinOrbs[matches.targetId] = orbData;
    }
  }, {
    id: 'P9S Limit Cut Levin Orb Start and Rotation',
    type: 'StartsUsing',
    netRegex: {
      id: '817D',
      source: 'Kokytos',
      capture: false
    },
    delaySeconds: 1.5,
    // allow for orb headmarker data to be collected, and delay so as not to collide with player dash order callout
    infoText: (data, _matches, output) => {
      let firstOrb8Dir;
      let secondOrb8Dir;
      // Orb order is limit cut headmarkers 1 > 3 > 5 > 7
      // 1 is always adjacent to 3, 3 is always adjacent to 5, and so on.
      for (const combatant in data.levinOrbs) {
        switch (data.levinOrbs[combatant]?.order) {
          case 1:
            firstOrb8Dir = data.levinOrbs[combatant]?.dir;
            break;
          case 3:
            secondOrb8Dir = data.levinOrbs[combatant]?.dir;
            break;
        }
      }
      if (firstOrb8Dir === undefined || secondOrb8Dir === undefined) return;
      const firstOrb8DirStr = util/* Directions.outputFrom8DirNum */.N.outputFrom8DirNum(firstOrb8Dir);
      if (firstOrb8DirStr === undefined) return;
      const firstOrbDir = output[firstOrb8DirStr]();
      const rotationDir = (secondOrb8Dir - firstOrb8Dir + 8) % 8 === 2 ? output.clockwise() : output.counterclock();
      if (firstOrbDir !== undefined && rotationDir !== undefined) return output.text({
        dir: firstOrbDir,
        rotation: rotationDir
      });
      return;
    },
    outputStrings: {
      text: {
        en: 'First Orb ${dir} => ${rotation}',
        de: 'Erster Orb ${dir} => ${rotation}',
        fr: 'Premier orbe ${dir} => ${rotation}',
        ja: '1回目の玉 ${dir} => ${rotation}',
        cn: '第一个球 ${dir} => ${rotation}',
        ko: '첫번째 구슬 ${dir} => ${rotation}'
      },
      clockwise: outputs/* default.clockwise */.Z.clockwise,
      counterclock: outputs/* default.counterclockwise */.Z.counterclockwise,
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  }, {
    id: 'P9S Limit Cut 1 Player Number',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      return !data.seenChimericSuccession && limitCutMarkers.includes(p9s_getHeadmarkerId(data, matches));
    },
    preRun: (data, matches) => {
      data.limitCut1Count++;
      if (data.me === matches.target) {
        const correctedMatch = p9s_getHeadmarkerId(data, matches);
        data.limitCutNumber = p9s_limitCutNumberMap[correctedMatch];
      }
    },
    durationSeconds: 30,
    infoText: (data, matches, output) => {
      if (data.me !== matches.target) return;
      const expectedLimitCutNumbers = [2, 4, 6, 8];
      if (data.limitCutNumber === undefined || !expectedLimitCutNumbers.includes(data.limitCutNumber)) return;
      return output[data.limitCutNumber]();
    },
    tts: (data, matches, output) => {
      if (data.me !== matches.target || data.limitCutNumber === undefined) return;
      return output.tts({
        num: data.limitCutNumber
      });
    },
    outputStrings: {
      2: {
        en: '2: First dash, third tower',
        de: '2: 1. Raus, 3. Turm',
        fr: '2: 1er Saut, 3ème tour',
        cn: '2麻 1火3塔',
        ko: '2: 1돌진, 3기둥'
      },
      4: {
        en: '4: Second dash, last tower',
        de: '4: 2. Raus, 4. Turm',
        fr: '4: 2nd Saut, Dernière tour',
        cn: '4麻 2火4塔',
        ko: '4: 2돌진, 4기둥'
      },
      6: {
        en: '6: First tower, third dash',
        de: '6: 1. Turm, 3. Raus',
        fr: '6: 1ère Tour, 3ème Saut',
        cn: '6麻 1塔3火',
        ko: '6: 1기둥, 3돌진'
      },
      8: {
        en: '8: Second tower, last dash',
        de: '8: 2. Turm, 4. Raus',
        fr: '8: 2ème Tour, Dernier Saut',
        cn: '8麻 2塔4火',
        ko: '8: 2기둥, 4돌진'
      },
      tts: {
        en: '${num}',
        de: '${num}',
        fr: '${num}',
        ja: '${num}',
        cn: '${num}',
        ko: '${num}'
      }
    }
  }, {
    id: 'P9S Limit Cut 1 Early Defamation',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      return data.limitCut1Count === 4 && !data.seenChimericSuccession && limitCutMarkers.includes(p9s_getHeadmarkerId(data, matches));
    },
    infoText: (data, _matches, output) => {
      if (data.limitCutNumber !== undefined) return;
      return output.defamationLater();
    },
    outputStrings: {
      defamationLater: {
        en: 'Defamation on you (later)',
        de: 'Ehrenstrafe auf dir (später)',
        fr: 'Diffamation sur vous (après)',
        cn: '大圈点名 (稍后放置)',
        ko: '광역 대상자 (나중에)'
      }
    }
  }, {
    id: 'P9S Chimeric Limit Cut Player Number',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      return data.seenChimericSuccession && data.me === matches.target && limitCutMarkers.includes(p9s_getHeadmarkerId(data, matches));
    },
    preRun: (data, matches) => {
      const correctedMatch = p9s_getHeadmarkerId(data, matches);
      data.limitCutNumber = p9s_limitCutNumberMap[correctedMatch];
    },
    durationSeconds: 20,
    infoText: (data, _matches, output) => {
      const expectedLimitCutNumbers = [1, 2, 3, 4];
      if (data.limitCutNumber === undefined || !expectedLimitCutNumbers.includes(data.limitCutNumber)) return;
      return output.number({
        num: data.limitCutNumber
      });
    },
    outputStrings: {
      number: {
        en: '${num}',
        de: '${num}',
        fr: '${num}',
        ja: '${num}',
        cn: '${num}',
        ko: '${num}'
      }
    }
  }, {
    id: 'P9S Chimeric Limit Cut Defamation',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      return data.seenChimericSuccession && data.me === matches.target && data.limitCutNumber !== undefined && limitCutMarkers.includes(p9s_getHeadmarkerId(data, matches));
    },
    delaySeconds: data => {
      if (data.limitCutNumber === undefined) return 0;
      const time = chimericLimitCutTime[data.limitCutNumber];
      if (time === undefined) return 0;
      // 6 seconds ahead of time
      return time - 6;
    },
    alarmText: (_data, _matches, output) => output.defamation(),
    outputStrings: {
      defamation: {
        en: 'Defamation on YOU',
        de: 'Ehrenstrafe aud DIR',
        fr: 'Diffamation sur VOUS',
        ja: '自分の巨大な爆発',
        cn: '大圈点名',
        ko: '광역징 대상자'
      }
    }
  }, {
    // When Kokytos uses 'Scrambled Succession' (817D), there is ~4.0s. until the first tower appears (8181)
    // and about ~5.0s until he dashes and uses Firemeld (8180) on the #2 limit cut player.  Because these abilities
    // have very short (or no) cast times, we can base the first combo trigger on the use of Scrambled Succession, and
    // base subsequent combo triggers on the prior use of Firemeld (which is ~4.6s before the next tower spawns)
    id: 'P9S Limit Cut First Dash/Tower Combo',
    type: 'Ability',
    netRegex: {
      id: '817D',
      source: 'Kokytos',
      capture: false
    },
    condition: data => data.limitCutDash === 0,
    alertText: (data, _matches, output) => {
      const activePlayers = limitCutPlayerActive[data.limitCutDash];
      if (activePlayers === undefined) return;
      const [dashPlayer, soakPlayer] = activePlayers;
      if (dashPlayer === undefined || soakPlayer === undefined) return;
      if (data.limitCutNumber === dashPlayer) return output.dash();else if (data.limitCutNumber === soakPlayer) return output.soak();
      return;
    },
    outputStrings: {
      dash: {
        en: 'Bait dash',
        de: 'Sprung ködern',
        fr: 'Encaissez le saut',
        ja: '突進誘導',
        cn: '引导BOSS',
        ko: '돌진 유도'
      },
      soak: {
        en: 'Soak tower',
        de: 'Im Turm stehen',
        fr: 'Prenez votre tour',
        ja: '塔踏み',
        cn: '踩塔',
        ko: '기둥 들어가기'
      }
    }
  }, {
    id: 'P9S Limit Cut Combo Tracker',
    type: 'Ability',
    netRegex: {
      id: '8180',
      source: 'Kokytos',
      capture: false
    },
    run: data => data.limitCutDash++
  }, {
    id: 'P9S Limit Cut Later Dash/Tower Combo',
    type: 'Ability',
    netRegex: {
      id: '8180',
      source: 'Kokytos',
      capture: false
    },
    condition: data => data.limitCutDash > 0 && data.limitCutDash < 4,
    delaySeconds: data => {
      // delay 'soak tower' call by 1 second to prevent confusion due to ability timing
      return limitCutPlayerActive[data.limitCutDash]?.[1] === data.limitCutNumber ? 1 : 0;
    },
    alertText: (data, _matches, output) => {
      const [dashPlayer, soakPlayer] = limitCutPlayerActive[data.limitCutDash] ?? [];
      if (dashPlayer === undefined || soakPlayer === undefined) return;
      if (data.limitCutNumber === dashPlayer) return output.dash();else if (data.limitCutNumber === soakPlayer) return output.soak();
      return;
    },
    outputStrings: {
      dash: {
        en: 'Bait dash',
        de: 'Sprung ködern',
        fr: 'Encaissez le saut',
        ja: '突進誘導',
        cn: '引导BOSS',
        ko: '돌진 유도'
      },
      soak: {
        en: 'Soak tower',
        de: 'Im Turm stehen',
        fr: 'Prenez votre tour',
        ja: '塔踏み',
        cn: '踩塔',
        ko: '기둥 들어가기'
      }
    }
  }, {
    id: 'P9S Limit Cut 1 Defamation',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      return data.me === matches.target && p9s_getHeadmarkerId(data, matches) === p9s_headmarkers.defamation;
    },
    alarmText: (_data, _matches, output) => output.defamation(),
    outputStrings: {
      defamation: {
        en: 'Defamation on YOU',
        de: 'Ehrenstrafe aud DIR',
        fr: 'Diffamation sur VOUS',
        ja: '自分に巨大な爆発',
        cn: '大圈点名',
        ko: '광역징 대상자'
      }
    }
  }, {
    id: 'P9S Charybdis',
    type: 'StartsUsing',
    netRegex: {
      id: '8170',
      source: 'Kokytos',
      capture: false
    },
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'P9S Front Inside Combination',
    type: 'StartsUsing',
    netRegex: {
      id: '8167',
      source: 'Kokytos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.combination = 'front',
    outputStrings: {
      text: {
        en: 'Out => Back',
        de: 'Raus => Hinten',
        fr: 'Extérieur => Derrière',
        ja: '外側 => 後ろへ',
        cn: '远离 => 去背后',
        ko: '밖으로 => 뒤로'
      }
    }
  }, {
    id: 'P9S Front Outside Combination',
    type: 'StartsUsing',
    netRegex: {
      id: '8168',
      source: 'Kokytos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.combination = 'front',
    outputStrings: {
      text: {
        en: 'In => Back',
        de: 'Rein => Hinten',
        fr: 'Intérieur => Derrière',
        ja: '内側 => 後ろへ',
        cn: '靠近 => 去背后',
        ko: '안으로 => 뒤로'
      }
    }
  }, {
    id: 'P9S Rear Inside Roundhouse',
    type: 'StartsUsing',
    netRegex: {
      id: '8169',
      source: 'Kokytos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.combination = 'rear',
    outputStrings: {
      text: {
        en: 'Out => Front',
        de: 'Raus => Vorne',
        fr: 'Extérieur => Devant',
        ja: '外側 => 前へ',
        cn: '远离 => 去面前',
        ko: '밖으로 => 앞으로'
      }
    }
  }, {
    id: 'P9S Rear Outside Roundhouse',
    type: 'StartsUsing',
    netRegex: {
      id: '816A',
      source: 'Kokytos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.combination = 'rear',
    outputStrings: {
      text: {
        en: 'In => Front',
        de: 'Rein => Vorne',
        fr: 'Intérieur => Devant',
        ja: '内側 => 前へ',
        cn: '靠近 => 去面前',
        ko: '안으로 => 앞으로'
      }
    }
  }, {
    id: 'P9S Roundhouse Followup',
    type: 'Ability',
    netRegex: {
      id: ['8238', '8239'],
      source: 'Kokytos'
    },
    suppressSeconds: 15,
    alertText: (data, matches, output) => {
      const isInsideRoundhouse = matches.id === '8238';
      const isOutsideRoundhouse = matches.id === '8239';
      if (data.combination === 'front') {
        if (isOutsideRoundhouse) return output.outAndBack();
        if (isInsideRoundhouse) return output.inAndBack();
      }
      if (data.combination === 'rear') {
        if (isOutsideRoundhouse) return output.outAndFront();
        if (isInsideRoundhouse) return output.inAndFront();
      }
      if (isOutsideRoundhouse) return output.out();
      if (isInsideRoundhouse) return output.in();
    },
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      in: outputs/* default.in */.Z["in"],
      outAndFront: {
        en: 'Out + Front',
        de: 'Raus + Vorne',
        fr: 'Extérieur + Devant',
        ja: '外側 + 前へ',
        cn: '远离 => 去面前',
        ko: '밖으로 + 앞으로'
      },
      outAndBack: {
        en: 'Out + Back',
        de: 'Raus + Hinten',
        fr: 'Extérieur + Derrière',
        ja: '外側 + 後ろへ',
        cn: '远离 => 去背后',
        ko: '밖으로 + 뒤로'
      },
      inAndFront: {
        en: 'In + Front',
        de: 'Rein + Vorne',
        fr: 'Intérieur + Devant',
        ja: '内側 + 前へ',
        cn: '靠近 => 去面前',
        ko: '안으로 + 앞으로'
      },
      inAndBack: {
        en: 'In + Back',
        de: 'Rein + Hinten',
        fr: 'Intérieur + Derrière',
        ja: '内側 + 後ろへ',
        cn: '靠近 => 去背后',
        ko: '안으로 + 뒤로'
      }
    }
  }, {
    id: 'P9S Chimeric Succession',
    type: 'StartsUsing',
    netRegex: {
      id: '81BB',
      source: 'Kokytos',
      capture: false
    },
    run: data => data.seenChimericSuccession = true
  }, {
    id: 'P9S Front Firestrikes',
    type: 'StartsUsing',
    netRegex: {
      id: '878E',
      source: 'Kokytos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Charge => Stay',
        de: 'Sprung => Stehen bleiben',
        fr: 'Saut => Restez',
        ja: '突進 => 止まれ',
        cn: '突进 => 停',
        ko: '돌진 => 가만히'
      }
    }
  }, {
    id: 'P9S Rear Firestrikes',
    type: 'StartsUsing',
    netRegex: {
      id: '878F',
      source: 'Kokytos',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Charge => Run Through',
        de: 'Sprung => Geh durch den Boss',
        fr: 'Saut => Traversez le boss',
        ja: '突進 => 移動',
        cn: '突进 => 穿',
        ko: '돌진 => 가로지르기'
      }
    }
  }, {
    id: 'P9S Beastly Fury',
    type: 'StartsUsing',
    netRegex: {
      id: '8186',
      source: 'Kokytos',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Aero IV/Fire IV': 'Aero/Fire IV',
      'Front Combination/Rear Combination': 'Front/Rear Combination',
      'Front Firestrikes/Rear Firestrikes': 'Front/Rear Firestrikes',
      'Inside Roundhouse/Outside Roundhouse': 'Inside/Outside Roundhouse',
      'Outside Roundhouse/Inside Roundhouse': 'Outside/Inside Roundhouse'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Ball of Levin': 'Elektrosphäre',
      'Comet': 'Komet',
      'Kokytos(?!\')': 'Kokytos',
      'Kokytos\'s Echo': 'Phantom-Kokytos'
    },
    'replaceText': {
      '\\(Beast': '(Bestie',
      '\\(Chimera': '(Chimäre',
      '\\(Fighter': '(Kämpfer',
      '\\(Final\\)': '(Finale)',
      '\\(Mage': '(Magier',
      '\\(cast\\)': '(Wirken)',
      '\\(resolve\\)': '(Auflösen)',
      'Aero IV': 'Windka',
      'Archaic Demolish': 'Altes Demolieren',
      'Archaic Rockbreaker': 'Alte Erdspaltung',
      'Ascendant Fist': 'Steigende Faust',
      'Beastly Bile': 'Bestiengalle',
      'Beastly Fury': 'Animalischer Zorn',
      'Blizzard III': 'Eisga',
      'Burst': 'Zerschmetterung',
      'Charybdis': 'Charybdis',
      'Chimeric Succession': 'Chimärische Kombo',
      'Comet': 'Komet',
      'Disgorge': 'Seelenwende',
      'Disintegration': 'Auflösung',
      'Duality of Death': 'Dualer Tod',
      'Dualspell': 'Doppelspruch',
      'Ecliptic Meteor': 'Ekliptik-Meteor',
      'Fire IV': 'Feuka',
      'Fire(?!( |m|s))': 'Feuer',
      'Firemeld': 'Feuerbinder',
      'Front Combination': 'Trittfolge vor',
      'Front Firestrikes': 'Flammensalve vorne',
      'Gluttony\'s Augur': 'Omen der Fresssucht',
      'Ice(?!meld)': 'Eis',
      'Icemeld': 'Eisbinder',
      'Inside Roundhouse': 'Rundumtritt innen',
      'Levinstrike Summoning': 'Blitzrufung',
      'Outside Roundhouse': 'Rundumtritt außen',
      'Pile Pyre': 'Flammenhaufen',
      'Pyremeld': 'Pyrischer Puls',
      'Ravening': 'Seelenfresser',
      'Rear Combination': 'Trittfolge zurück',
      'Rear Firestrikes': 'Flammensalve hinten',
      'Scrambled Succession': 'Gemischte Kombo',
      'Shock(?!wave)': 'Entladung',
      'Shockwave': 'Schockwelle',
      'Soul Surge': 'Seelenschub',
      'Swinging Kick': 'Schwungattacke',
      'Thunder III': 'Blitzga',
      'Thunder(?!( |bolt))': 'Blitz',
      'Thunderbolt': 'Donnerkeil',
      'Two Minds': 'Zwei Seelen'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Ball of Levin': 'orbe de foudre',
      'Comet': 'Comète',
      'Kokytos(?!\')': 'Cocyte',
      'Kokytos\'s Echo': 'spectre de Cocyte'
    },
    'replaceText': {
      'Aero IV': 'Giga Vent',
      'Archaic Demolish': 'Démolition archaïque',
      'Archaic Rockbreaker': 'Briseur de rocs archaïque',
      'Ascendant Fist': 'Uppercut pénétrant',
      'Beastly Bile': 'Bile de bête',
      'Beastly Fury': 'Furie de bête',
      'Blizzard III': 'Méga Glace',
      'Burst': 'Éclatement',
      'Charybdis': 'Charybde',
      'Chimeric Succession': 'Combo chimérique',
      'Comet': 'Comète',
      'Disgorge': 'Renvoi d\'âme',
      'Disintegration': 'Désintégration',
      'Duality of Death': 'Mort double',
      'Dualspell': 'Double sort',
      'Ecliptic Meteor': 'Météore écliptique',
      'Fire IV': 'Giga Feu',
      'Fire(?!( |m|s))': 'Feu',
      'Firemeld': 'Impact de feu démoniaque',
      'Front Combination': 'Coups de pied pivotants avant en série',
      'Front Firestrikes': 'Coups enflammés avant en série',
      'Gluttony\'s Augur': 'Augure de gloutonnerie',
      'Icemeld': 'Impact de glace démoniaque',
      'Inside Roundhouse': 'Coup de pied pivotant intérieur',
      'Levinstrike Summoning': 'Invocation d\'éclairs',
      'Outside Roundhouse': 'Coup de pied pivotant extérieur',
      'Pile Pyre': 'Flammes empilées',
      'Pyremeld': 'Grand coup enflammé',
      'Ravening': 'Dévoration d\'âme',
      'Rear Combination': 'Coups de pied pivotants arrière en série',
      'Rear Firestrikes': 'Coups enflammés arrière en série',
      'Scrambled Succession': 'Combo mixte',
      'Shock(?!wave)': 'Décharge électrostatique',
      'Shockwave': 'Onde de choc',
      'Soul Surge': 'Déferlante d\'âme',
      'Swinging Kick': 'Demi-pivot',
      'Thunder III': 'Méga Foudre',
      'Thunder(?!( |bolt))': 'Foudre',
      'Thunderbolt': 'Éclair',
      'Two Minds': 'Double esprit démoniaque'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Ball of Levin': '雷球',
      'Comet': 'コメット',
      'Kokytos(?!\')': 'コキュートス',
      'Kokytos\'s Echo': 'コキュートスの幻影'
    },
    'replaceText': {
      'Aero IV': 'エアロジャ',
      'Archaic Demolish': '古式破砕拳',
      'Archaic Rockbreaker': '古式地烈斬',
      'Ascendant Fist': '穿昇拳',
      'Beastly Bile': 'ビーストバイル',
      'Beastly Fury': 'ビーストフューリー',
      'Blizzard III': 'ブリザガ',
      'Burst': '飛散',
      'Charybdis': 'ミールストーム',
      'Chimeric Succession': 'キメリックコンボ',
      'Comet': 'コメット',
      'Disgorge': 'ソウルリバース',
      'Disintegration': 'ディスインテグレーション',
      'Duality of Death': 'デストゥワイス',
      'Dualspell': 'ダブルスペル',
      'Ecliptic Meteor': 'エクリプスメテオ',
      'Fire IV': 'ファイジャ',
      'Fire(?!( |m|s))': 'ファイア',
      'Firemeld': '炎魔衝',
      'Front Combination': '前方連転脚',
      'Front Firestrikes': '前方炎連撃',
      'Gluttony\'s Augur': 'グラトニーズアーガー',
      'Icemeld': '氷魔衝',
      'Inside Roundhouse': '内転脚',
      'Levinstrike Summoning': 'サモンライトニング',
      'Outside Roundhouse': '外転脚',
      'Pile Pyre': 'パイリングフレイム',
      'Pyremeld': '重炎撃',
      'Ravening': '魂喰らい',
      'Rear Combination': '後方連転脚',
      'Rear Firestrikes': '後方炎連撃',
      'Scrambled Succession': 'ジャンブルコンボ',
      'Shock(?!wave)': '放電',
      'Shockwave': '衝撃波',
      'Soul Surge': 'ソウルサージ',
      'Swinging Kick': '旋身撃',
      'Thunder III': 'サンダガ',
      'Thunder(?!( |bolt))': 'サンダー',
      'Thunderbolt': 'サンダーボルト',
      'Two Minds': '憑魔双撃'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Ball of Levin': '雷球',
      'Comet': '彗星',
      'Kokytos(?!\')': '科库托斯',
      'Kokytos\'s Echo': '科库托斯的幻影'
    },
    'replaceText': {
      '\\(Beast': '(野兽',
      '\\(Chimera': '(合成体',
      '\\(Fighter': '(武术家',
      '\\(Final\\)': '(最终)',
      '\\(Mage': '(魔法师',
      '\\(cast\\)': '(咏唱)',
      '\\(resolve\\)': '(判定)',
      '\\(stacks\\)': '(分摊)',
      'Aero IV': '飙风',
      'Archaic Demolish': '古式破碎拳',
      'Archaic Rockbreaker': '古式地烈劲',
      'Ascendant Fist': '穿升拳',
      'Beastly Bile': '野兽胆汁',
      'Beastly Fury': '野兽之怒',
      'Blizzard III': '冰封',
      'Burst': '飞散',
      'Charybdis': '大漩涡',
      'Chimeric Succession': '合成体连击',
      'Comet': '彗星',
      'Disgorge': '吐魂',
      'Disintegration': '崩毁',
      'Duality of Death': '双重死亡',
      'Dualspell': '双重咏唱',
      'Ecliptic Meteor': '黄道陨石',
      'Fire IV': '炽炎',
      'Fire(?!( |m|s))': '火炎',
      'Firemeld': '炎魔冲',
      'Front Combination': '前方连转脚',
      'Front Firestrikes': '前方炎连击',
      'Gluttony\'s Augur': '暴食预兆',
      'Ice(?!meld)': '冰结',
      'Icemeld': '冰魔冲',
      'Inside Roundhouse': '内转脚',
      'Levinstrike Summoning': '雷电召唤',
      'Outside Roundhouse': '外转脚',
      'Pile Pyre': '烈火桩',
      'Pyremeld': '重炎击',
      'Ravening': '噬魂',
      'Rear Combination': '后方连转脚',
      'Rear Firestrikes': '后方炎连击',
      'Scrambled Succession': '混乱连击',
      'Shock(?!wave)': '放电',
      'Shockwave': '冲击波',
      'Soul Surge': '灵魂涌动',
      'Swinging Kick': '旋身击',
      'Thunder III': '暴雷',
      'Thunder(?!( |bolt))': '闪雷',
      'Thunderbolt': '霹雳',
      'Two Minds': '附魂双击'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Ball of Levin': '번개 구체',
      'Comet': '혜성',
      'Kokytos(?!\')': '코퀴토스',
      'Kokytos\'s Echo': '코퀴토스의 환영'
    },
    'replaceText': {
      '\\(Beast': '(마수',
      '\\(Chimera': '(합성영혼',
      '\\(Fighter': '(격투가',
      '\\(Final\\)': '(전멸기)',
      '\\(Mage': '(마도사',
      '\\(cast\\)': '(시전)',
      '\\(resolve\\)': '(실행)',
      '\\(stacks\\)': '(쉐어)',
      'Aero IV': '에어로쟈',
      'Archaic Demolish': '고대 파쇄권',
      'Archaic Rockbreaker': '고대 지열참',
      'Ascendant Fist': '천승권',
      'Beastly Bile': '마수 담즙',
      'Beastly Fury': '짐승의 격분',
      'Blizzard III': '블리자가 기둥',
      'Burst': '산산조각',
      'Charybdis': '대소용돌이',
      'Chimeric Succession': '합성 연격',
      'Comet': '혜성',
      'Disgorge': '영혼 토출',
      'Disintegration': '영혼 분열',
      'Duality of Death': '거듭되는 죽음',
      'Dualspell': '이중 시전',
      'Ecliptic Meteor': '황도 메테오',
      'Fire IV': '파이쟈',
      'Fire(?!( |m|s))': '불',
      'Firemeld': '화염 충격',
      'Front Combination': '전방 연속 돌려차기',
      'Front Firestrikes': '전방 연속 화염격',
      'Gluttony\'s Augur': '폭식의 전조',
      'Ice(?!meld)': '얼음',
      'Icemeld': '빙결 충격',
      'Inside Roundhouse': '안쪽 돌려차기',
      'Levinstrike Summoning': '번개 소환',
      'Outside Roundhouse': '바깥쪽 돌려차기',
      'Pile Pyre': '불더미',
      'Pyremeld': '겹불꽃 충격 ',
      'Ravening': '영혼 포식',
      'Rear Combination': '후방 연속 돌려차기',
      'Rear Firestrikes': '후방 연속 화염격',
      'Scrambled Succession': '뒤죽박죽 연격',
      'Shock(?!wave)': '방전',
      'Shockwave': '충격파',
      'Soul Surge': '영혼 격동',
      'Swinging Kick': '후려차기',
      'Thunder III': '선더가',
      'Thunder(?!( |bolt))': '번개',
      'Thunderbolt': '낙뢰',
      'Two Minds': '빙의 쌍격'
    }
  }]
};
/* harmony default export */ const p9s = (p9s_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/raid/p9s.txt
const raid_p9s_namespaceObject = "### P9S: Anabaseios: The Ninth Circle (Savage)\r\n\r\n# -p 814C:12.2\r\n# -ii 814B 814D 8150 815D 816E 815E 8165 8166 820B 820C 8222 8223 817F 8171 8173 817A 8176 8188 8189 8143 8187 818B\r\n# -it \"Kokytos\"\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.2 \"--sync--\" StartsUsing { id: \"814C\", source: \"Kokytos\" } window 10,10\r\n12.2 \"Gluttony's Augur\" Ability { id: \"814C\", source: \"Kokytos\" }\r\n19.6 \"--middle--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n\r\n# Mage 1\r\n25.3 \"Ravening (Mage #1)\" Ability { id: \"8118\", source: \"Kokytos\" }\r\n32.0 \"Soul Surge\" Ability { id: \"811B\", source: \"Kokytos\" }\r\n47.0 \"Duality of Death\" Ability { id: \"8151\", source: \"Kokytos\" }\r\n47.9 \"Aero IV/Fire IV #1\" #Ability { id: [\"8152\", \"8153\"], source: \"Kokytos\" }\r\n50.2 \"Aero IV/Fire IV #2\" #Ability { id: [\"8152\", \"8153\"], source: \"Kokytos\" }\r\n\r\n60.4 \"Dualspell (Fire/Ice)\" Ability { id: \"8154\", source: \"Kokytos\" }\r\n63.7 \"--sync--\" Ability { id: [\"8122\", \"8123\"], source: \"Kokytos\" }\r\n68.1 \"Blizzard III\" Ability { id: [\"8157\", \"8159\"], source: \"Kokytos\" }\r\n68.1 \"Pile Pyre\" Ability { id: [\"8156\", \"8158\"], source: \"Kokytos\" }\r\n\r\n73.4 \"Dualspell (Thunder/Ice)\" Ability { id: \"8155\", source: \"Kokytos\" }\r\n76.7 \"--sync--\" Ability { id: [\"8123\", \"815C\"], source: \"Kokytos\" }\r\n81.1 \"Blizzard III\" Ability { id: [\"8157\", \"8159\"], source: \"Kokytos\" }\r\n81.1 \"Thunder III\" Ability { id: [\"815A\", \"815B\"], source: \"Kokytos\" }\r\n\r\n86.4 \"Dualspell (Fire/Ice)\" Ability { id: \"8154\", source: \"Kokytos\" }\r\n89.7 \"--sync--\" Ability { id: [\"8122\", \"8123\"], source: \"Kokytos\" }\r\n94.1 \"Blizzard III\" Ability { id: [\"8157\", \"8159\"], source: \"Kokytos\" }\r\n94.1 \"Pile Pyre\" Ability { id: [\"8156\", \"8158\"], source: \"Kokytos\" }\r\n\r\n101.8 \"Disgorge\" Ability { id: \"8124\", source: \"Kokytos\" }\r\n\r\n# Fighter\r\n114.2 \"Ravening (Fighter)\" Ability { id: \"8119\", source: \"Kokytos\" } window 40,40\r\n120.9 \"Soul Surge\" Ability { id: \"811B\", source: \"Kokytos\" }\r\n134.0 \"Ascendant Fist\" Ability { id: \"816F\", source: \"Kokytos\" }\r\n\r\n146.4 \"Archaic Rockbreaker (cast)\" Ability { id: \"815F\", source: \"Kokytos\" }\r\n148.0 \"Shockwave\" Ability { id: \"8160\", source: \"Kokytos\" }\r\n149.3 \"Archaic Rockbreaker (stacks)\" Ability { id: \"8162\", source: \"Kokytos\" }\r\n155.5 \"Front Combination/Rear Combination\" Ability { id: [\"8167\", \"8168\", \"8169\", \"816A\"], source: \"Kokytos\" }\r\n155.8 \"Archaic Rockbreaker #1\" Ability { id: \"8161\", source: \"Kokytos\" }\r\n156.3 \"Inside Roundhouse/Outside Roundhouse\" Ability { id: [\"8238\", \"8239\"], source: \"Kokytos\" }\r\n158.7 \"Swinging Kick\" Ability { id: [\"816B\", \"816C\"], source: \"Kokytos\" }\r\n161.7 \"Archaic Rockbreaker #2\" Ability { id: \"8161\", source: \"Kokytos\" }\r\n162.4 \"Outside Roundhouse/Inside Roundhouse\" Ability { id: [\"8239\", \"8238\"], source: \"Kokytos\" }\r\n168.7 \"Archaic Demolish\" Ability { id: \"816D\", source: \"Kokytos\" }\r\n\r\n175.8 \"Gluttony's Augur\" Ability { id: \"814C\", source: \"Kokytos\" }\r\n187.1 \"Ascendant Fist\" Ability { id: \"816F\", source: \"Kokytos\" }\r\n\r\n194.5 \"Disgorge\" Ability { id: \"8125\", source: \"Kokytos\" }\r\n\r\n# Chimera 1\r\n202.9 \"--middle--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n208.2 \"Ravening (Chimera #1)\" Ability { id: \"817B\", source: \"Kokytos\" }\r\n214.8 \"Soul Surge\" Ability { id: \"811B\", source: \"Kokytos\" }\r\n\r\n221.4 \"Levinstrike Summoning\" Ability { id: \"817C\", source: \"Kokytos\" }\r\n233.5 \"Scrambled Succession\" Ability { id: \"817D\", source: \"Kokytos\" }\r\n233.6 \"--untargetable--\"\r\n\r\n# Limit Cut 1\r\n233.7 \"--sync--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n235.3 \"--sync--\" Ability { id: \"817E\", source: \"Kokytos\" }\r\n238.4 \"Firemeld #1\" Ability { id: \"8180\", source: \"Kokytos\" }\r\n238.5 \"Icemeld #1\" Ability { id: \"8183\", source: \"Kokytos's Echo\" }\r\n239.4 \"Shock #1\" Ability { id: \"8181\", source: \"Kokytos\" }\r\n\r\n239.4 \"--sync--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n241.0 \"--sync--\" Ability { id: \"817E\", source: \"Kokytos\" }\r\n244.1 \"Firemeld #2\" Ability { id: \"8180\", source: \"Kokytos\" }\r\n244.3 \"Icemeld #2\" Ability { id: \"8190\", source: \"Kokytos's Echo\" }\r\n245.2 \"Shock #2\" Ability { id: \"8181\", source: \"Kokytos\" }\r\n\r\n245.2 \"--sync--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n246.6 \"--sync--\" Ability { id: \"817E\", source: \"Kokytos\" }\r\n249.7 \"Firemeld #3\" Ability { id: \"8180\", source: \"Kokytos\" }\r\n250.0 \"Icemeld #3\" Ability { id: \"8191\", source: \"Kokytos's Echo\" }\r\n250.7 \"Shock #3\" Ability { id: \"8181\", source: \"Kokytos\" }\r\n\r\n250.7 \"--sync--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n252.3 \"--sync--\" Ability { id: \"817E\", source: \"Kokytos\" }\r\n255.4 \"Firemeld #4\" Ability { id: \"8180\", source: \"Kokytos\" }\r\n255.8 \"Icemeld #4\" Ability { id: \"8192\", source: \"Kokytos's Echo\" }\r\n256.5 \"Shock #4\" Ability { id: \"8181\", source: \"Kokytos\" }\r\n256.5 \"--middle--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n\r\n258.1 \"--targetable--\"\r\n262.2 \"--sync--\" Ability { id: [\"8122\", \"8123\", \"815C\"], source: \"Kokytos\" }\r\n265.1 \"Two Minds\" Ability { id: [\"8184\", \"8185\"], source: \"Kokytos\" }\r\n266.2 \"Blizzard III\" Ability { id: [\"8157\", \"8159\"], source: \"Kokytos\" }\r\n266.2 \"Pile Pyre/Thunder III\" Ability { id: [\"8156\", \"8158\", \"815A\", \"815B\"], source: \"Kokytos\" }\r\n272.2 \"Gluttony's Augur\" Ability { id: \"814C\", source: \"Kokytos\" }\r\n\r\n276.3 \"Disgorge\" Ability { id: \"8236\", source: \"Kokytos\" }\r\n\r\n# Beast\r\n284.7 \"--middle--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n289.1 \"Ravening (Beast)\" Ability { id: \"811A\", source: \"Kokytos\" }\r\n297.0 \"Soul Surge\" Ability { id: \"811B\", source: \"Kokytos\" }\r\n302.6 \"Charybdis\" Ability { id: \"8170\", source: \"Kokytos\" }\r\n309.7 \"Comet\" Ability { id: \"8172\", source: \"Kokytos\" }\r\n\r\n318.7 \"Beastly Bile (cast)\" Ability { id: \"8177\", source: \"Kokytos\" }\r\n323.8 \"Thunderbolt #1\" Ability { id: \"8179\", source: \"Kokytos\" }\r\n325.7 \"Beastly Bile #1\" Ability { id: \"8178\", source: \"Kokytos\" }\r\n\r\n329.9 \"Thunderbolt #2\" Ability { id: \"8179\", source: \"Kokytos\" }\r\n331.7 \"Beastly Bile #2\" Ability { id: \"8178\", source: \"Kokytos\" }\r\n\r\n332.5 \"Burst #1\" Ability { id: \"8174\", source: \"Comet\" }\r\n338.5 \"Burst #2\" Ability { id: \"8174\", source: \"Comet\" }\r\n341.3 \"Ecliptic Meteor\" Ability { id: \"8175\", source: \"Kokytos\" }\r\n349.4 \"Burst #3\" Ability { id: \"8174\", source: \"Comet\" }\r\n355.0 \"Beastly Fury\" Ability { id: \"8186\", source: \"Kokytos\" }\r\n\r\n357.2 \"Disgorge\" Ability { id: \"8126\", source: \"Kokytos\" }\r\n\r\n# Chimera 2\r\n368.9 \"--middle--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n374.2 \"Ravening (Chimera #2)\" Ability { id: \"817B\", source: \"Kokytos\" }\r\n380.8 \"Soul Surge\" Ability { id: \"811B\", source: \"Kokytos\" }\r\n393.7 \"Duality of Death\" Ability { id: \"8151\", source: \"Kokytos\" }\r\n394.6 \"Aero IV/Fire IV #1\" #Ability { id: [\"8152\", \"8153\"], source: \"Kokytos\" }\r\n396.4 \"Aero IV/Fire IV #2\" #Ability { id: [\"8152\", \"8153\"], source: \"Kokytos\" }\r\n\r\n402.9 \"Archaic Rockbreaker (cast)\" Ability { id: \"815F\", source: \"Kokytos\" }\r\n404.5 \"Shockwave\" Ability { id: \"8160\", source: \"Kokytos\" }\r\n405.8 \"Archaic Rockbreaker (stacks)\" Ability { id: \"8162\", source: \"Kokytos\" }\r\n412.5 \"Archaic Rockbreaker #1\" Ability { id: \"8161\", source: \"Kokytos\" }\r\n413.2 \"Dualspell\" Ability { id: [\"8154\", \"8155\"], source: \"Kokytos\" }\r\n416.5 \"--sync--\" Ability { id: [\"8122\", \"8123\", \"815C\"], source: \"Kokytos\" }\r\n418.5 \"Archaic Rockbreaker #2\" Ability { id: \"8161\", source: \"Kokytos\" }\r\n\r\n420.9 \"Blizzard III\" Ability { id: [\"8157\", \"8159\"], source: \"Kokytos\" }\r\n420.9 \"Pile Pyre/Thunder III\" Ability { id: [\"8156\", \"8158\", \"815A\", \"815B\"], source: \"Kokytos\" }\r\n426.2 \"Gluttony's Augur\" Ability { id: \"814C\", source: \"Kokytos\" }\r\n\r\n# Limit Cut 2\r\n438.6 \"Chimeric Succession\" Ability { id: \"81BB\", source: \"Kokytos\" }\r\n449.5 \"Icemeld #1\" Ability { id: \"8183\", source: \"Kokytos's Echo\" }\r\n452.5 \"Icemeld #2\" Ability { id: \"8190\", source: \"Kokytos's Echo\" }\r\n454.2 \"Front Firestrikes/Rear Firestrikes\" Ability { id: [\"878E\", \"878F\"], source: \"Kokytos\" }\r\n\r\n454.4 \"Pyremeld\" Ability { id: [\"8793\", \"8794\"], source: \"Kokytos\" }\r\n455.8 \"Icemeld #3\" Ability { id: \"8191\", source: \"Kokytos's Echo\" }\r\n458.6 \"Icemeld #4\" Ability { id: \"8192\", source: \"Kokytos's Echo\" }\r\n459.7 \"Swinging Kick\" Ability { id: [\"8795\", \"8796\"], source: \"Kokytos\" }\r\n\r\n461.8 \"--middle--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n467.4 \"--sync--\" Ability { id: [\"8122\", \"8123\", \"815C\"], source: \"Kokytos\" }\r\n470.3 \"Two Minds\" Ability { id: [\"8184\", \"8185\"], source: \"Kokytos\" }\r\n471.4 \"Blizzard III\" Ability { id: [\"8157\", \"8159\"], source: \"Kokytos\" }\r\n471.4 \"Pile Pyre/Thunder III\" Ability { id: [\"8156\", \"8158\", \"815A\", \"815B\"], source: \"Kokytos\" }\r\n\r\n472.4 \"Disgorge\" Ability { id: \"8236\", source: \"Kokytos\" }\r\n\r\n# Mage 2\r\n480.8 \"--middle--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n486.1 \"Ravening (Mage #2)\" Ability { id: \"8118\", source: \"Kokytos\" }\r\n492.7 \"Soul Surge\" Ability { id: \"811B\", source: \"Kokytos\" }\r\n\r\n500.3 \"Dualspell\" Ability { id: [\"8154\", \"8155\"], source: \"Kokytos\" }\r\n503.6 \"--sync--\" Ability { id: [\"8122\", \"8123\", \"815C\"], source: \"Kokytos\" }\r\n508.2 \"Blizzard III\" Ability { id: [\"8157\", \"8159\"], source: \"Kokytos\" }\r\n508.2 \"Pile Pyre/Thunder III\" Ability { id: [\"8156\", \"8158\", \"815A\", \"815B\"], source: \"Kokytos\" }\r\n513.5 \"Gluttony's Augur\" Ability { id: \"814C\", source: \"Kokytos\" }\r\n\r\n520.6 \"Dualspell\" Ability { id: [\"8154\", \"8155\"], source: \"Kokytos\" }\r\n523.9 \"--sync--\" Ability { id: [\"8122\", \"8123\", \"815C\"], source: \"Kokytos\" }\r\n528.5 \"Blizzard III\" Ability { id: [\"8157\", \"8159\"], source: \"Kokytos\" }\r\n528.5 \"Pile Pyre/Thunder III\" Ability { id: [\"8156\", \"8158\", \"815A\", \"815B\"], source: \"Kokytos\" }\r\n\r\n534.8 \"Duality of Death\" Ability { id: \"8151\", source: \"Kokytos\" }\r\n535.7 \"Aero IV/Fire IV #1\" #Ability { id: [\"8152\", \"8153\"], source: \"Kokytos\" }\r\n538.0 \"Aero IV/Fire IV #2\" #Ability { id: [\"8152\", \"8153\"], source: \"Kokytos\" }\r\n\r\n544.0 \"Dualspell\" Ability { id: [\"8154\", \"8155\"], source: \"Kokytos\" }\r\n547.3 \"--sync--\" Ability { id: [\"8122\", \"8123\", \"815C\"], source: \"Kokytos\" }\r\n551.9 \"Blizzard III\" Ability { id: [\"8157\", \"8159\"], source: \"Kokytos\" }\r\n551.9 \"Pile Pyre/Thunder III\" Ability { id: [\"8156\", \"8158\", \"815A\", \"815B\"], source: \"Kokytos\" }\r\n557.1 \"Gluttony's Augur\" Ability { id: \"814C\", source: \"Kokytos\" }\r\n\r\n564.7 \"Disgorge\" Ability { id: \"8124\", source: \"Kokytos\" }\r\n\r\n# Final sequence\r\n573.1 \"--middle--\" Ability { id: \"8144\", source: \"Kokytos\" }\r\n578.5 \"Ravening (Final)\" Ability { id: \"817B\", source: \"Kokytos\" }\r\n585.1 \"Soul Surge\" Ability { id: \"811B\", source: \"Kokytos\" }\r\n\r\n597.7 \"Disintegration (enrage)\" Ability { id: \"818A\", source: \"Kokytos\" }\r\n\r\n\r\n# Abilities\r\n#\r\n# Ball of Levin:817F Shock, Levinstrike orb explosion\r\n# Comet:8143 Burst, self-targeted ability for targeted comet during Ecliptic Meteor\r\n# Comet:8173 Comet Impact, cast and proximity damage during Charybdis\r\n# Comet:8174 Burst, cast and damage for full meteor circle explosion\r\n# Kokytos:8118 Ravening, self-targeted cast for turning into Mage\r\n# Kokytos:8119 Ravening, self-targeted cast for turning into Fighter\r\n# Kokytos:811A Ravening, self-targeted cast for turning into Beast\r\n# Kokytos:811B Soul Surge, raidwide damage after all Ravening\r\n# Kokytos:8122 unknown_8122, self-targeted ability Fire symbol\r\n# Kokytos:8123 unknown_8123, self-targeted ability Ice symbol\r\n# Kokytos:8124 Disgorge, self-targeted ability after Mage phase\r\n# Kokytos:8125 Disgorge, self-targeted ability after Fighter phase\r\n# Kokytos:8126 Disgorge, self-targeted ability after Beast phase\r\n# Kokytos:8144 unknown_8144, repositioning middle self-targeted ability\r\n# Kokytos:814B unknown_814b, unaspected auto damage\r\n# Kokytos:814C Gluttony's Augur, self-targeted cast ability\r\n# Kokytos:814D Gluttony's Augur, raidwide damage\r\n# Kokytos:8150 unknown_8150, mage auto damage\r\n# Kokytos:8151 Duality of Death, self-targeted cast tankbuster\r\n# Kokytos:8152 Fire IV, damage on MT during Duality of Death\r\n# Kokytos:8153 Aero IV, damage on OT during Duality of Death\r\n# Kokytos:8154 Dualspell, self-targeted cast Fire and Ice spell\r\n# Kokytos:8155 Dualspell, self-targeted cast Thunder and Ice spell\r\n# Kokytos:8156 Pile Pyre, normal fire partner stack damage\r\n# Kokytos:8157 Blizzard III, normal ice donut damage\r\n# Kokytos:8158 Pile Pyre, empowered fire partner stack damage\r\n# Kokytos:8159 Blizzard III, empowered ice donut damage\r\n# Kokytos:815A Thunder III, empowered thunder protean damage\r\n# Kokytos:815B Thunder III, normal thunder protean damage\r\n# Kokytos:815C unknown_815c, self-targeted ability Thunder icon\r\n# Kokytos:815D unknown_815d, fighter auto damage\r\n# Kokytos:815E Uplift, ground aoe damage raising walls\r\n# Kokytos:815F Archaic Rockbreaker, purple knockback circle damage\r\n# Kokytos:8160 Shockwave, knockback damage into walls\r\n# Kokytos:8161 Archaic Rockbreaker, cast and damage for fuse explosions\r\n# Kokytos:8162 Archaic Rockbreaker, partner stack damage after Shockwave\r\n# Kokytos:8165 Inside Roundhouse, telegraph ability\r\n# Kokytos:8166 Outside Roundhouse, telegraph ability\r\n# Kokytos:8167 Front Combination, self-targeted cast for Front+Inside combo\r\n# Kokytos:8168 Front Combination, self-targeted cast for Front+Outside combo\r\n# Kokytos:8169 Rear Combination, self-targeted cast for Rear+Inside combo\r\n# Kokytos:816A Rear Combination, self-targeted cast for Rear+Outside combo\r\n# Kokytos:816B Swinging Kick, self-targeted ability paired with 8222\r\n# Kokytos:816C Swinging Kick, self-targeted ability paired with 8223\r\n# Kokytos:816D Archaic Demolish, self-targeted cast\r\n# Kokytos:816E Archaic Demolish, healer stack damage\r\n# Kokytos:816F Ascendant Fist, tank-targeted cast and tankbuster damage\r\n# Kokytos:8170 Charybdis, self-targeted cast ability\r\n# Kokytos:8171 Charybdis, cast and damage for initial tornado circles\r\n# Kokytos:8172 Comet, cast and self-targeted comet summoning before 8173\r\n# Kokytos:8175 Ecliptic Meteor, self-targeted cast of LOS meteor damage\r\n# Kokytos:8176 Ecliptic Meteor, self-targeted ability paired with 8188 (probably)\r\n# Kokytos:8177 Beastly Bile, self-targeted cast of poison stack damage\r\n# Kokytos:8178 Beastly Bile, shared damage with comet\r\n# Kokytos:8179 Thunderbolt, self-targeted cast of proteans during meteors\r\n# Kokytos:817A Thunderbolt, protean lightning damage from 8179\r\n# Kokytos:817B Ravening, self-targeted cast for turning into Chimera\r\n# Kokytos:817C Levinstrike Summoning, self-targeted cast for this mechanic\r\n# Kokytos:817D Scrambled Succession, self-targeted cast during which limit cut dots appear\r\n# Kokytos:817E unknown_817e, unknown ability during Levinstrike Summoning (repositioning?)\r\n# Kokytos:8180 Firemeld, spread damage in limit cut order\r\n# Kokytos:8181 Shock, tower damage\r\n# Kokytos:8182 Shock, raidwide damage if 8181 hits no target\r\n# Kokytos:8184 Two Minds, self-targeted cast Fire and Ice spell\r\n# Kokytos:8185 Two Minds, self-targeted cast Thunder and Ice spell\r\n# Kokytos:8186 Beastly Fury, self-targeted cast for 8187 raidwide\r\n# Kokytos:8187 Beastly Fury, raidwide damage\r\n# Kokytos:8188 Ecliptic Meteor, damage for not LOS-ing meteor (on other meteors, boss, players)\r\n# Kokytos:8189 unknown_8189, beast auto damage\r\n# Kokytos:818A Disintegration, self-targeted cast for enrage\r\n# Kokytos:818B Disintegration, raidwide enrage damage\r\n# Kokytos:81BB Chimeric Succession, self-targeted cast starting this mechanic\r\n# Kokytos:820B unknown_820b, unknown self-targeted cast mutually exclusive with 820C\r\n# Kokytos:820C unknown_820c, unknown self-targeted cast exclusive with 820B\r\n# Kokytos:8222 Swinging Kick, cast and damage from front combination dodge\r\n# Kokytos:8223 Swinging Kick, cast and damage from rear combination dodge\r\n# Kokytos:8236 Disgorge, self-targeted ability after Chimera phase\r\n# Kokytos:8238 Inside Roundhouse, cast and damage for \"get out\"\r\n# Kokytos:8239 Outside Roundhouse, cast and damage for \"get in\"\r\n# Kokytos:878E Front Firestrikes, self-targeted cast\r\n# Kokytos:878F Rear Firestrikes, self-targeted cast\r\n# Kokytos:8793 Pyremeld, Front Firestrikes charge damage\r\n# Kokytos:8794 Pyremeld, Rear Firestrikes charge damage\r\n# Kokytos:8795 Swinging Kick, cast and damage for Front Firestrikes Kick\r\n# Kokytos:8796 Swinging Kick, cast and damage for Rear Firestrikes Kick\r\n# Kokytos's Echo:8183 Icemeld, first defamation damage during Levinstrike/Succession\r\n# Kokytos's Echo:8190 Icemeld, second defamation damage during Levinstrike/Succession\r\n# Kokytos's Echo:8191 Icemeld, third defamation damage during Levinstrike/Succession\r\n# Kokytos's Echo:8192 Icemeld, fourth defamation damage during Levinstrike/Succession\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/asura.ts





const bossIconographyIds = {
  '8C81': 'out',
  // Pedestal Purge
  '8C83': 'in',
  // Wheel of Deincarnation
  '8C85': 'sides' // Bladewise
};

const outSafeSpots = {
  'dirN': 'dirS',
  'dirE': 'dirW',
  'dirS': 'dirN',
  'dirW': 'dirE',
  'unknown': 'unknown'
};
const sidesSafeSpots = {
  'dirN': ['dirE', 'dirW'],
  'dirE': ['dirN', 'dirS'],
  'dirS': ['dirE', 'dirW'],
  'dirW': ['dirN', 'dirS'],
  'unknown': ['unknown', 'unknown']
};
const asura_centerX = 100;
const asura_centerY = 100;
const asura_triggerSet = {
  id: 'TheGildedAraya',
  zoneId: zone_id/* default.TheGildedAraya */.Z.TheGildedAraya,
  timelineFile: 'asura.txt',
  initData: () => {
    return {
      iconicExecutionCount: 0
    };
  },
  triggers: [{
    id: 'Asura Lower Realm',
    type: 'StartsUsing',
    netRegex: {
      id: '8CA1',
      source: 'Asura',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Asura Cutting Jewel',
    type: 'StartsUsing',
    netRegex: {
      id: '8CA0',
      source: 'Asura',
      capture: true
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Asura Ephemerality',
    type: 'Ability',
    netRegex: {
      id: '8C96',
      source: 'Asura',
      capture: false
    },
    suppressSeconds: 2,
    alertText: (_data, _matches, output) => output.avoidClones(),
    outputStrings: {
      'avoidClones': {
        en: 'Avoid clones',
        de: 'Vermeide Klone',
        fr: 'Évitez les clones',
        cn: '躲避分身',
        ko: '분신 피하기'
      }
    }
  },
  // After the first three Iconography mechanics, all future casts will be preceded by
  // the Asura Image jumping to a random(?) cardinal.
  {
    id: 'Asura Pedestal Purge',
    type: 'StartsUsing',
    netRegex: {
      id: '8C81',
      source: 'Asura',
      capture: false
    },
    alertText: (data, _matches, output) => {
      data.storedIconMech = 'out';
      if (data.iconicExecutionCount < 3) return output.noJump();
      return output.withJump();
    },
    outputStrings: {
      noJump: {
        en: 'Out => Away from Image',
        de: 'Raus => Weg von der Inkarnation',
        fr: 'Extérieur => Loin de l\'incarnation',
        cn: '远离 => 远离场边分身',
        ko: '밖으로 => 분신에서 멀리 떨어지기'
      },
      withJump: {
        en: 'Out => Away from Image After Jump',
        de: 'Raus => Weg von der Inkarnation nach dem Sprung',
        fr: 'Extérieur => Loin de l\'incarnation après le saut',
        cn: '远离 => 远离场边跳跃后的分身',
        ko: '밖으로 => 이동 이후 분신에서 멀리 떨어지기'
      }
    }
  }, {
    id: 'Asura Wheel of Deincarnation',
    type: 'StartsUsing',
    netRegex: {
      id: '8C83',
      source: 'Asura',
      capture: false
    },
    alertText: (data, _matches, output) => {
      data.storedIconMech = 'in';
      if (data.iconicExecutionCount < 3) return output.noJump();
      return output.withJump();
    },
    outputStrings: {
      noJump: {
        en: 'In => Under Image',
        de: 'Rein => Unter die Inkarnation',
        fr: 'Intérieur => Sous l\'incarnation',
        cn: '靠近 => 靠近场边分身',
        ko: '안으로 => 분신 쪽으로'
      },
      withJump: {
        en: 'In => Under Image After Jump',
        de: 'Rein => Unter die Inkarnation nach dem Sprung',
        fr: 'Intérieur => Sous l\'incarnation après le saut',
        cn: '靠近 => 靠近场边跳跃后的分身',
        ko: '안으로 => 이동 이후 분신 쪽으로'
      }
    }
  }, {
    id: 'Asura Bladewise',
    type: 'StartsUsing',
    netRegex: {
      id: '8C85',
      source: 'Asura',
      capture: false
    },
    alertText: (data, _matches, output) => {
      data.storedIconMech = 'sides';
      if (data.iconicExecutionCount < 3) return output.noJump();
      return output.withJump();
    },
    outputStrings: {
      noJump: {
        en: 'Avoid Cleave => Sides of Image',
        de: 'Cleave ausweichen => Seitlich der Inkarnation',
        fr: 'Évitez le cleave => Côtés de l\'incarnation',
        cn: '躲避直线AoE => 去场边分身两侧',
        ko: '직선 장판 피하기 => 분신 옆으로'
      },
      withJump: {
        en: 'Avoid Cleave => Sides of Image After Jump',
        de: 'Cleave ausweichen => Seitlich der Inkarnation nach dem Sprung',
        fr: 'Évitez le cleave => Côtés de l\'incarnation après le saut',
        cn: '躲避直线AoE => 去场边跳跃后的分身两侧',
        ko: '직선 장판 피하기 => 이동 이후 분신 옆으로'
      }
    }
  }, {
    id: 'Asura Iconic Execution Tracker',
    type: 'Ability',
    netRegex: {
      id: '8CB1',
      source: 'Asura',
      capture: false
    },
    run: data => data.iconicExecutionCount++
  }, {
    id: 'Asura Image Combatant ID Collect',
    type: 'Ability',
    // Divine Awakening
    netRegex: {
      id: '8C80',
      source: 'Asura Image',
      capture: true
    },
    run: (data, matches) => data.asuraImageId = matches.sourceId
  }, {
    id: 'Asura Iconic Execution No Jump',
    type: 'Ability',
    netRegex: {
      id: Object.keys(bossIconographyIds),
      source: 'Asura',
      capture: false
    },
    condition: data => data.iconicExecutionCount < 3,
    delaySeconds: 2,
    // short delay to let boss action finish and align better with image action
    alertText: (data, _matches, output) => {
      const iconType = data.storedIconMech;
      if (iconType === undefined) return;
      const spotOutput = output[iconType]();

      // For the No-Jump mechanics, the Image is always north.
      let dirsOutput;
      if (iconType === 'in') dirsOutput = output['dirN']();else if (iconType === 'out') dirsOutput = output[outSafeSpots['dirN']]();else {
        // sides
        const [dir1, dir2] = sidesSafeSpots['dirN'];
        const dir1Output = output[dir1 ?? 'unknown']();
        const dir2Output = output[dir2 ?? 'unknown']();
        dirsOutput = output.doubledirs({
          dir1: dir1Output,
          dir2: dir2Output
        });
      }
      return output.text({
        dirs: dirsOutput,
        spot: spotOutput
      });
    },
    run: data => delete data.storedIconMech,
    outputStrings: {
      text: {
        en: 'Go ${dirs} ${spot}',
        de: 'Geh ${dirs} ${spot}',
        fr: 'Allez ${dirs} ${spot}',
        cn: '去 ${dirs} ${spot}',
        ko: '${dirs} ${spot}'
      },
      doubledirs: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      },
      in: {
        en: '(under image)',
        de: '(Unter die Inkarnation)',
        fr: '(Sous l\'incarnation)',
        cn: '(靠近分身)',
        ko: '(분신 밑)'
      },
      out: {
        en: '(away from image)',
        de: '(Weg von der Inkarnation)',
        fr: '(Loin de l\'incarnation',
        cn: '(远离分身)',
        ko: '(분신과 멀리 떨어지기)'
      },
      sides: {
        en: '(sides of image)',
        de: '(Setlich der Inkarnation)',
        fr: '(Côtés de l\'incarnation',
        cn: '(分身两侧)',
        ko: '(분신 옆)'
      },
      ...util/* Directions.outputStringsCardinalDir */.N.outputStringsCardinalDir
    }
  }, {
    id: 'Asura Iconic Execution With Jump',
    type: 'ActorSetPos',
    // The Asura Image doesn't have associated ActorSetPos lines except for this mechanic.
    // Can't meaningfully filter regex as nearly all 271 lines are NPCs; but it's <100 in total.
    netRegex: {},
    condition: (data, matches) => data.iconicExecutionCount >= 3 && data.asuraImageId === matches.id && data.storedIconMech !== undefined,
    alertText: (data, matches, output) => {
      const imageLoc = util/* Directions.xyToCardinalDirOutput */.N.xyToCardinalDirOutput(parseFloat(matches.x), parseFloat(matches.y), asura_centerX, asura_centerY);
      const iconType = data.storedIconMech;
      if (iconType === undefined) return;
      const spotOutput = output[iconType]();
      let dirsOutput;
      if (iconType === 'in') dirsOutput = output[imageLoc]();else if (iconType === 'out') dirsOutput = output[outSafeSpots[imageLoc]]();else {
        // sides
        const [dir1, dir2] = sidesSafeSpots[imageLoc];
        const dir1Output = output[dir1 ?? 'unknown']();
        const dir2Output = output[dir2 ?? 'unknown']();
        dirsOutput = output.doubledirs({
          dir1: dir1Output,
          dir2: dir2Output
        });
      }
      return output.text({
        dirs: dirsOutput,
        spot: spotOutput
      });
    },
    run: data => delete data.storedIconMech,
    outputStrings: {
      text: {
        en: 'Go ${dirs} ${spot}',
        de: 'Geh ${dirs} ${spot}',
        fr: 'Allez ${dirs} ${spot}',
        cn: '去 ${dirs} ${spot}',
        ko: '${dirs} ${spot}'
      },
      doubledirs: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      },
      in: {
        en: '(under image)',
        de: '(Unter die Inkarnation)',
        fr: '(Sous l\'incarnation)',
        cn: '(靠近分身)',
        ko: '(분신 밑)'
      },
      out: {
        en: '(away from image)',
        de: '(Weg von der Inkarnation)',
        fr: '(Loin de l\'incarnation)',
        cn: '(远离分身)',
        ko: '(분신과 멀리 떨어지기)'
      },
      sides: {
        en: '(sides of image)',
        de: '(Setlich der Inkarnation)',
        fr: '(Côtés de l\'incarnation)',
        cn: '(分身两侧)',
        ko: '(분신 옆)'
      },
      ...util/* Directions.outputStringsCardinalDir */.N.outputStringsCardinalDir
    }
  },
  // 8C90 - Red E, Blue W
  // 8C92 - Red N, Blue S
  {
    id: 'Asura Face of Wrath',
    type: 'StartsUsing',
    netRegex: {
      id: ['8C90', '8C92'],
      source: 'Asura',
      capture: false
    },
    alertText: (_data, _matches, output) => output.wrath(),
    outputStrings: {
      'wrath': {
        en: 'Stand in blue half',
        de: 'Steh in der blauen Hälfte',
        fr: 'Restez dans la moitié bleue',
        cn: '站蓝色半场',
        ko: '파란색 위로'
      }
    }
  },
  // 8C93 - Red N, Blue S
  // 8C95 - Blue N, Red S
  {
    id: 'Asura Face of Delight',
    type: 'StartsUsing',
    netRegex: {
      id: ['8C93', '8C95'],
      source: 'Asura',
      capture: false
    },
    alertText: (_data, _matches, output) => output.delight(),
    outputStrings: {
      'delight': {
        en: 'Stand in red half',
        de: 'Steh in der roten Hälfte',
        fr: 'Restez dans la moitié rouge',
        cn: '站红色半场',
        ko: '빨간색 위로'
      }
    }
  },
  // Khadga has two fixed patterns of attacks.
  // The first cast always cleaves N>W>E>N>W>E; the second cast always cleaves N>E>W>N>E>W.
  // There are later casts as the encounter begins to loop (3rd happens around 9:08), but
  // we have insufficient info to know which patterns future casts will use (fixed or random).
  // We can determine which pattern it is, though, by looking at the xPos of the combatant
  // who receives the 2nd limit cut headmarker (either east or west).
  // Cleaves happen fast, and character positions snapshot very early, so rather than call
  // movements based on delays that depend on precise reaction time, provide a single popup
  // with the entire movement sequence that remains for the duration of the mechanic.
  {
    id: 'Asura Six-bladed Khadga LC2 Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '01C7',
      capture: true
    },
    // no delay needed - combatatnt is repositioned ~3s before headmarker comes out
    promise: async (data, matches) => {
      const combatantData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.targetId, 16)]
      });
      data.khadgaLC2Combatant = combatantData.combatants[0];
    },
    run: data => {
      if (data.khadgaLC2Combatant === undefined) return;
      const lc2SideDir = util/* Directions.combatantStatePosTo8DirOutput */.N.combatantStatePosTo8DirOutput(data.khadgaLC2Combatant, asura_centerX, asura_centerY);
      if (lc2SideDir === 'dirW') data.khadgaLC2Loc = 'west';else if (lc2SideDir === 'dirE') data.khadgaLC2Loc = 'east';else console.log('Could not determine Khadga sequence.');
      return;
    }
  }, {
    id: 'Asura Six-bladed Khadga',
    type: 'StartsUsing',
    netRegex: {
      id: '8C88',
      source: 'Asura',
      capture: false
    },
    delaySeconds: 4.5,
    // allow for LC2 headmarker data to be collected (~3.5s + safety margin)
    durationSeconds: 19.5,
    alertText: (data, _matches, output) => {
      if (data.khadgaLC2Loc === 'west') return output.text({
        dir1: output.dirSE(),
        dir2: output.dirSW(),
        dir3: output.dirE(),
        dir4: output.dirW()
      });else if (data.khadgaLC2Loc === 'east') return output.text({
        dir1: output.dirSW(),
        dir2: output.dirSE(),
        dir3: output.dirW(),
        dir4: output.dirE()
      });
      return;
    },
    run: data => {
      delete data.khadgaLC2Combatant;
      delete data.khadgaLC2Loc;
    },
    outputStrings: {
      text: {
        en: '${dir1} (x2) => ${dir2} (x2) => ${dir3} => ${dir4}',
        de: '${dir1} (x2) => ${dir2} (x2) => ${dir3} => ${dir4}',
        fr: '${dir1} (x2) => ${dir2} (x2) => ${dir3} => ${dir4}',
        cn: '${dir1} (x2) => ${dir2} (x2) => ${dir3} => ${dir4}',
        ko: '${dir1} (x2) => ${dir2} (x2) => ${dir3} => ${dir4}'
      },
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirSW: outputs/* default.dirSW */.Z.dirSW,
      dirE: outputs/* default.dirE */.Z.dirE,
      dirW: outputs/* default.dirW */.Z.dirW
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Pedestal Purge/Wheel Of Deincarnation/Bladewise': 'Purge/Wheel/Bladewise'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      '(?<! )Asura(?! )': 'Asura',
      'Asura Image': 'Asuras Inkarnation',
      'Phantom Asura': 'Asura-Abbild'
    },
    'replaceText': {
      '\\(execute\\)': '(Ausführen)',
      '\\(preview\\)': '(Vorschau)',
      '\\(release\\)': '(Freilassen)',
      '\\(store\\)': '(Speichern)',
      'Asuri Chakra': 'Rad der Lehre',
      'Bladescatter': 'Klingenlicht',
      '(?<! )Bladewise': 'Klingenspitze',
      'Cutting Jewel': 'Schneidendes Juwel',
      'Divine Awakening': 'Göttliches Erwachen',
      'Divinity': 'Göttlichkeit',
      'Ephemerality': 'Vergänglichkeit',
      'Iconic Execution': 'Göttliche Klingen',
      'Iconography: Bladewise': 'Ikonografie: Klingenspitze',
      'Iconography: Pedestal Purge': 'Ikonografie: Sockelschnitt',
      'Iconography: Wheel Of Deincarnation': 'Ikonografie: Rad der Deinkarnation',
      '(?<! )Khadga': 'Khadga',
      'Laceration': 'Zerreißen',
      'Lower Realm': 'Irdene Ebene',
      'Many Faces': 'Vielgesichtig',
      'Myriad Aspects': 'Blendender Schein',
      'Ordered Chaos': 'Licht der Ordnung',
      '(?<! )Pedestal Purge': 'Sockelschnitt',
      'Six-bladed Khadga': 'Sechsklingen-Khadga',
      'The Face Of Delight': 'Antlitz des Vergnügens',
      'The Face Of Wrath': 'Antlitz des Zorns',
      '(?<! )Wheel Of Deincarnation': 'Rad der Deinkarnation'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      '(?<! )Asura(?! )': 'Asura',
      'Asura Image': 'incarnation d\'Asura',
      'Phantom Asura': 'illusion d\'Asura'
    },
    'replaceText': {
      '\\(execute\\)': '(Execute)',
      '\\(preview\\)': '(Aperçu)',
      '\\(release\\)': '(Libération)',
      '\\(store\\)': '(Sauvegarde)',
      'Asuri Chakra': 'Cercle rituel',
      'Bladescatter': 'Illumination chaotique',
      '(?<! )Bladewise': 'Entaille rayonnante',
      'Cutting Jewel': 'Illumination guerrière',
      'Divine Awakening': 'Éveil d\'incarnation',
      'Divinity': 'Incarnation',
      'Ephemerality': 'Transmigration',
      'Iconic Execution': 'Danselame incarnée',
      'Iconography: Bladewise': 'Danselame rayonnante',
      'Iconography: Pedestal Purge': 'Danselame tournoyante',
      'Iconography: Wheel Of Deincarnation': 'Danselame circulaire',
      '(?<! )Khadga': 'Éventaille',
      'Laceration': 'Lacération',
      'Lower Realm': 'Prestige de la Reine',
      'Many Faces': 'Samsâra',
      'Myriad Aspects': 'Illumination fulgurante',
      'Ordered Chaos': 'Nirvâna',
      '(?<! )Pedestal Purge': 'Entaille tournoyante',
      'Six-bladed Khadga': 'Sextuor de lames',
      'The Face Of Delight': 'Jubilation incarnée',
      'The Face Of Wrath': 'Fureur incarnée',
      '(?<! )Wheel Of Deincarnation': 'Entaille circulaire'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      '(?<! )Asura(?! )': 'アスラ',
      'Asura Image': 'アスラの化身',
      'Phantom Asura': 'アスラの幻影'
    },
    'replaceText': {
      'Asuri Chakra': '転法輪',
      'Bladescatter': '乱れ光波',
      '(?<! )Bladewise': '剣光波',
      'Cutting Jewel': '光玉',
      'Divine Awakening': '化身開眼',
      'Divinity': '化身',
      'Ephemerality': '神出鬼没',
      'Iconic Execution': '化身剣技',
      'Iconography: Bladewise': '剣技転写・剣光波',
      'Iconography: Pedestal Purge': '剣技転写・旋回斬り',
      'Iconography: Wheel Of Deincarnation': '剣技転写・輪転斬り',
      '(?<! )Khadga': '断撃',
      'Laceration': '斬撃',
      'Lower Realm': '王妃の威光',
      'Many Faces': '神気変容',
      'Myriad Aspects': '光芒一閃',
      'Ordered Chaos': '天光',
      '(?<! )Pedestal Purge': '旋回斬り',
      'Six-bladed Khadga': '三面六臂：断',
      'The Face Of Delight': '愉悦の神気',
      'The Face Of Wrath': '憤怒の神気',
      '(?<! )Wheel Of Deincarnation': '輪転斬り'
    }
  }]
};
/* harmony default export */ const asura = (asura_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/asura.txt
const trial_asura_namespaceObject = "### The Gilded Araya\r\n# ZoneId: 470\r\n\r\n# -ii 8C80 8C99 8C9B 8C9C 8C9D 8C9E 8C9F 8CAB 8CAC 8CAD 8CAE 8CAF 8CB0\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n# Note that a number of \"extra-wide\" sync windows are present.\r\n# This is a future-proofing measure in case any timeline skips\r\n# are discovered in later exapnsions due to increased DPS.\r\n# The first couple of wide syncs also help in the event someone starts ACT after the encounter begins.\r\n\r\n# Intro block\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11.3 \"Lower Realm\" Ability { id: \"8CA1\", source: \"Asura\" } window 10,5\r\n18.4 \"--center--\" Ability { id: \"8C7E\", source: \"Asura\" }\r\n26.7 \"Asuri Chakra\" Ability { id: \"8C9A\", source: \"Asura\" }\r\n39.8 \"Cutting Jewel\" Ability { id: \"8CA0\", source: \"Asura\" } window 40,10\r\n47.9 \"--center--\" Ability { id: \"8C7E\", source: \"Asura\" }\r\n55.0 \"Ephemerality\" Ability { id: \"8C96\", source: \"Asura\" }\r\n63.2 \"Laceration\" Ability { id: \"8C97\", source: \"Phantom Asura\" }\r\n68.2 \"--center--\" Ability { id: \"8C7E\", source: \"Asura\" }\r\n71.6 \"--sync--\" Ability { id: \"8CA9\", source: \"Asura Image\" }\r\n71.6 \"Divinity\" Ability { id: \"8CA8\", source: \"Asura\" }\r\n\r\n# The first Divine Awakening trio appears to be a fixed order.\r\n87.6 \"--sync--\" Ability { id: \"8C7F\", source: \"Asura\" } #Divine Awakening\r\n97.2 \"Iconography: Pedestal Purge\" Ability { id: \"8C81\", source: \"Asura\" }\r\n104.3 \"Pedestal Purge\" Ability { id: \"8C82\", source: \"Asura Image\" }\r\n104.3 \"Iconic Execution (release)\" Ability { id: \"8CB1\", source: \"Asura\" }\r\n114.4 \"Iconography: Wheel Of Deincarnation\" Ability { id: \"8C83\", source: \"Asura\" }\r\n121.5 \"Wheel Of Deincarnation\" Ability { id: \"8C84\", source: \"Asura Image\" }\r\n121.5 \"Iconic Execution (release)\" Ability { id: \"8CB1\", source: \"Asura\" }\r\n131.9 \"Iconography: Bladewise\" Ability { id: \"8C85\", source: \"Asura\" }\r\n139.0 \"Bladewise\" Ability { id: \"8C86\", source: \"Asura Image\" }\r\n139.0 \"Iconic Execution (release)\" Ability { id: \"8CB1\", source: \"Asura\" }\r\n144.1 \"--sync--\" Ability { id: \"8CAA\", source: \"Asura Image\" }\r\n\r\n# As with Divine Awakening, the first Khadga set is a fixed order.\r\n149.1 \"--center--\" Ability { id: \"8C7E\", source: \"Asura\" }\r\n151.5 \"Six-bladed Khadga (preview)\" StartsUsing { id: \"8C88\", source: \"Asura\" } duration 12.7\r\n164.2 \"Six-bladed Khadga (execute)\" Ability { id: \"8C88\", source: \"Asura\" }\r\n165.2 \"Khadga 1\" Ability { id: \"8C89\", source: \"Asura\" }\r\n167.2 \"Khadga 2\" Ability { id: \"8C8D\", source: \"Asura\" }\r\n169.2 \"Khadga 3\" Ability { id: \"8C8C\", source: \"Asura\" }\r\n171.2 \"Khadga 4\" Ability { id: \"8C8A\", source: \"Asura\" }\r\n173.2 \"Khadga 5\" Ability { id: \"8C8E\", source: \"Asura\" }\r\n175.2 \"Khadga 6\" Ability { id: \"8C8B\", source: \"Asura\" }\r\n182.3 \"--center--\" Ability { id: \"8C7E\", source: \"Asura\" }\r\n184.4 \"--sync--\" Ability { id: \"8CB6\", source: \"Asura\" }\r\n192.4 \"--sync--\" Ability { id: \"8C90\", source: \"Asura\" } # Face Of Wrath castbar\r\n192.5 \"The Face Of Wrath\" Ability { id: \"8CA6\", source: \"Asura\" }\r\n197.5 \"--sync--\" Ability { id: \"8CB3\", source: \"Asura\" } # Myriad Aspects castbar\r\n198.5 \"Myriad Aspects 1\" Ability { id: \"8CB4\", source: \"Asura\" }\r\n200.5 \"Myriad Aspects 2\" Ability { id: \"8CB5\", source: \"Asura\" }\r\n204.6 \"--center--\" Ability { id: \"8C7E\", source: \"Asura\" }\r\n211.7 \"Bladescatter x24\" Ability { id: \"8C98\", source: \"Asura\" } duration 10\r\n228.8 \"Lower Realm\" Ability { id: \"8CA1\", source: \"Asura\" }\r\n\r\n# Rotation block\r\n# Technically the second Khadga in here is fixed,\r\n# and the same is true for Face of Wrath/Delight,\r\n# and then potentially random thereafter,\r\n# but we just account for the possibilities within a single loop body.\r\n236.0 \"--center--\" Ability { id: \"8C7E\", source: \"Asura\" }\r\n238.4 \"--sync--\" Ability { id: \"8C7F\", source: \"Asura\" } window 100,10 #Divine Awakening\r\n248.1 \"Iconography: Pedestal Purge/Wheel Of Deincarnation/Bladewise 1\" Ability { id: [\"8C81\", \"8CB3\", \"8C85\"], source: \"Asura\" }\r\n254.3 \"Iconic Execution (store)\" Ability { id: \"8CB2\", source: \"Asura\" }\r\n261.4 \"Pedestal Purge/Wheel Of Deincarnation/Bladewise\" Ability { id: [\"8C82\", \"8C84\", \"8C86\"], source: \"Asura Image\" }\r\n261.4 \"Iconic Execution (release)\" Ability { id: \"8CB1\", source: \"Asura\" }\r\n\r\n271.5 \"Iconography: Pedestal Purge/Wheel Of Deincarnation/Bladewise 2\" Ability { id: [\"8C81\", \"8CB3\", \"8C85\"], source: \"Asura\" }\r\n277.6 \"Iconic Execution (store)\" Ability { id: \"8CB2\", source: \"Asura\" }\r\n284.7 \"Pedestal Purge/Wheel Of Deincarnation/Bladewise\" Ability { id: [\"8C82\", \"8C84\", \"8C86\"], source: \"Asura Image\" }\r\n284.7 \"Iconic Execution (release)\" Ability { id: \"8CB1\", source: \"Asura\" }\r\n\r\n295.4 \"Iconography: Pedestal Purge/Wheel Of Deincarnation/Bladewise 3\" Ability { id: [\"8C81\", \"8CB3\", \"8C85\"], source: \"Asura\" }\r\n301.5 \"Iconic Execution (store)\" Ability { id: \"8CB2\", source: \"Asura\" }\r\n308.6 \"Pedestal Purge/Wheel Of Deincarnation/Bladewise\" Ability { id: [\"8C82\", \"8C84\", \"8C86\"], source: \"Asura Image\" }\r\n308.6 \"Iconic Execution (release)\" Ability { id: \"8CB1\", source: \"Asura\" }\r\n\r\n313.7 \"--sync--\" Ability { id: \"8CAA\", source: \"Asura Image\" }\r\n319.7 \"--center--\" Ability { id: \"8C7E\", source: \"Asura\" }\r\n322.2 \"Six-bladed Khadga (preview)\" StartsUsing { id: \"8C88\", source: \"Asura\" } duration 12.7\r\n324.9 \"--sync--\" Ability { id: [\"8CAB\", \"8CAC\", \"8CAD\",], source: \"Asura\" }\r\n326.9 \"--sync--\" Ability { id: [\"8CAB\", \"8CAC\", \"8CAD\",], source: \"Asura\" }\r\n328.9 \"--sync--\" Ability { id: [\"8CAB\", \"8CAC\", \"8CAD\",], source: \"Asura\" }\r\n330.9 \"--sync--\" Ability { id: [\"8CAB\", \"8CAC\", \"8CAD\",], source: \"Asura\" }\r\n332.9 \"--sync--\" Ability { id: [\"8CAB\", \"8CAC\", \"8CAD\",], source: \"Asura\" }\r\n334.9 \"--sync--\" Ability { id: [\"8CAB\", \"8CAC\", \"8CAD\",], source: \"Asura\" }\r\n334.9 \"Six-bladed Khadga (execute)\" Ability { id: \"8C88\", source: \"Asura\" }\r\n335.9 \"Khadga 1\" Ability { id: \"8C89\", source: \"Asura\" }\r\n337.9 \"Khadga 2\" Ability { id: [\"8C8C\", \"8C8D\"], source: \"Asura\" }\r\n339.9 \"Khadga 3\" Ability { id: [\"8C8C\", \"8C8D\"], source: \"Asura\" }\r\n341.9 \"Khadga 4\" Ability { id: \"8C8A\", source: \"Asura\" }\r\n343.9 \"Khadga 5\" Ability { id: [\"8C8B\", \"8C8E\"], source: \"Asura\" }\r\n345.9 \"Khadga 6\" Ability { id: [\"8C8B\", \"8C8E\"], source: \"Asura\" }\r\n\r\n# Many Faces + Myriad Aspects + Ordered Chaos.\r\n# The order is probably completely fixed,\r\n# but the face choice is random on round 3+.\r\n353.0 \"--center--\" Ability { id: \"8C7E\", source: \"Asura\" }\r\n359.1 \"Many Faces\" Ability { id: \"8C8F\", source: \"Asura\" }\r\n361.1 \"--sync--\" Ability { id: \"8CB7\", source: \"Asura\" }\r\n369.1 \"--sync--\" Ability { id: [\"8C90\", \"8C95\"], source: \"Asura\" } # Face Of Wrath/Face Of Delight\r\n369.2 \"The Face Of Wrath/The Face Of Delight\" Ability { id: [\"8CA6\", \"8CA7\"], source: \"Asura\" }\r\n374.2 \"--sync--\" Ability { id: \"8CB3\", source: \"Asura\" } # Myriad Aspects castbar\r\n375.2 \"Myriad Aspects 1\" Ability { id: \"8CB4\", source: \"Asura\" }\r\n377.2 \"Myriad Aspects 2\" Ability { id: \"8CB5\", source: \"Asura\" }\r\n383.4 \"--center--\" Ability { id: \"8C7E\", source: \"Asura\" }\r\n385.5 \"--sync--\" Ability { id: \"8CA2\", source: \"Asura\" } # Ordered Chaos castbar\r\n391.4 \"Ordered Chaos\" Ability { id: \"8CA3\", source: \"Asura\" }\r\n393.5 \"Asuri Chakra\" Ability { id: \"8C9A\", source: \"Asura\" }\r\n406.6 \"Lower Realm\" Ability { id: \"8CA1\", source: \"Asura\" }\r\n413.7 \"--center--\" Ability { id: \"8C7E\", source: \"Asura\" }\r\n420.8 \"Ephemerality\" Ability { id: \"8C96\", source: \"Asura\" }\r\n429.1 \"Laceration\" Ability { id: \"8C97\", source: \"Phantom Asura\" }\r\n434.4 \"Bladescatter x24\" Ability { id: \"8C98\", source: \"Asura\" } duration 10\r\n452.5 \"Cutting Jewel\" Ability { id: \"8CA0\", source: \"Asura\" }\r\n\r\n# And the block loops here\r\n# As noted in the comment up top, we place a wide sync window here for safety.\r\n# It's unlikely there will be any DPS-based pushes this late,\r\n# since the boss will be dead by this point in that case,\r\n# but let's be principled about it.\r\n459.7 \"--sync--\" Ability { id: \"8C7E\", source: \"Asura\" }\r\n461.9 \"Divine Awakening\" Ability { id: \"8C7F\", source: \"Asura\" } window 100,10 forcejump 238.4\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 366 attack\r\n# 8C7E --sync--\r\n# 8C7F Divine Awakening\r\n# 8C80 Divine Awakening\r\n# 8C81 Iconography: Pedestal Purge\r\n# 8C82 Pedestal Purge\r\n# 8C83 Iconography: Wheel Of Deincarnation\r\n# 8C84 Wheel Of Deincarnation\r\n# 8C85 Iconography: Bladewise\r\n# 8C86 Bladewise\r\n# 8C88 Six-bladed Khadga\r\n# 8C89 Khadga\r\n# 8C8A Khadga\r\n# 8C8B Khadga\r\n# 8C8C Khadga\r\n# 8C8D Khadga\r\n# 8C8E Khadga\r\n# 8C8F Many Faces\r\n# 8C90 The Face Of Wrath\r\n# 8C95 The Face Of Delight\r\n# 8C96 Ephemerality\r\n# 8C97 Laceration\r\n# 8C98 Bladescatter\r\n# 8C99 Scattering\r\n# 8C9A Asuri Chakra\r\n# 8C9B Chakra\r\n# 8C9C Chakra\r\n# 8C9D Chakra\r\n# 8C9E Chakra\r\n# 8C9F Chakra\r\n# 8CA0 Cutting Jewel\r\n# 8CA1 Lower Realm\r\n# 8CA2 Ordered Chaos\r\n# 8CA3 Ordered Chaos\r\n# 8CA6 The Face Of Wrath\r\n# 8CA7 The Face Of Delight\r\n# 8CA8 Divinity\r\n# 8CA9 --sync--\r\n# 8CAA --sync--\r\n# 8CAB --sync--\r\n# 8CAC --sync--\r\n# 8CAD --sync--\r\n# 8CAE Many Faces\r\n# 8CAF --sync--\r\n# 8CB0 --sync--\r\n# 8CB1 Iconic Execution\r\n# 8CB2 Iconic Execution\r\n# 8CB3 Myriad Aspects\r\n# 8CB4 Myriad Aspects\r\n# 8CB5 Myriad Aspects\r\n# 8CB6 --sync--\r\n# 8CB7 --sync--\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/barbariccia-ex.ts




const barbariccia_ex_triggerSet = {
  id: 'StormsCrownExtreme',
  zoneId: zone_id/* default.StormsCrownExtreme */.Z.StormsCrownExtreme,
  timelineFile: 'barbariccia-ex.txt',
  initData: () => {
    return {
      secretBreezeCount: 0,
      boldBoulderTargets: [],
      boulderBreakCount: 0,
      hairFlayUpbraidTargets: [],
      blowAwayCount: 0,
      blowAwayPuddleCount: 0
    };
  },
  timelineTriggers: [{
    id: 'BarbaricciaEx Knuckle Drum',
    regex: /Knuckle Drum/,
    beforeSeconds: 5,
    suppressSeconds: 15,
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'BarbaricciaEx Blow Away',
    regex: /Blow Away/,
    beforeSeconds: 10,
    durationSeconds: 5,
    suppressSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack to Bait Puddles',
        de: 'Sammeln um Flächen zu ködern',
        fr: 'Packez-vous pour déposer les flaques',
        ja: 'AOE誘導のために頭割り',
        cn: '集合诱导黄圈',
        ko: '장판 유도를 위해 모이기'
      }
    }
  }],
  triggers: [{
    id: 'BarbaricciaEx Curling Iron Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '75B2',
      source: 'Barbariccia',
      capture: false
    },
    suppressSeconds: 5,
    run: data => {
      // This is mostly to clean up the rogue "Hair Spray" that happens
      // not during Savage Barbery.
      delete data.barberyMechanic;
      delete data.nextBarberyMechanic;
    }
  }, {
    id: 'BarbaricciaEx Void Aero IV',
    type: 'StartsUsing',
    netRegex: {
      id: '7570',
      source: 'Barbariccia',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Savage Barbery has 3 casts that all start at the same time.
    // 5.7 duration: 7464, 7465, 7466, 7489, 748B, 7573 (all actual cast bar, unknown how to differentiate)
    // 6.7 duration: 7574 (donut), 757A (line)
    // 8.8 duration: 7575 (out, paired with donut), 757B (out, paired with line)
    id: 'BarbaricciaEx Savage Barbery Donut',
    type: 'StartsUsing',
    netRegex: {
      id: '7574',
      source: 'Barbariccia',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'BarbaricciaEx Savage Barbery Line',
    type: 'StartsUsing',
    netRegex: {
      id: '757A',
      source: 'Barbariccia',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out and Away',
        de: 'Raus und Weg',
        fr: 'Extérieur et derrière',
        ja: '外へ',
        cn: '外侧远离',
        ko: '밖으로'
      }
    }
  }, {
    // Hair Raid has 2 casts that start at the same time, then a slight delay for stack/spread.
    // 5.7 duration: 757C (wall), 757E (donut)
    // 7.7 duration: 757D (paired with wall), 757F (paired with donut)
    //
    // ~2.2s delay, and then:
    // 7.7 duration (Hair Spray): 75A6
    // 7.7 duration (Deadly Twist): 75A7
    id: 'BarbaricciaEx Hair Raid Donut',
    type: 'StartsUsing',
    netRegex: {
      id: '757E',
      source: 'Barbariccia',
      capture: false
    },
    durationSeconds: data => data.nextBarberyMechanic === undefined ? undefined : 5,
    alertText: (data, _matches, output) => {
      if (data.nextBarberyMechanic === 'stack') return output.inAndHealerGroups();
      if (data.nextBarberyMechanic === 'spread') return output.inThenSpread();
      return output.in();
    },
    outputStrings: {
      in: outputs/* default.in */.Z["in"],
      inThenSpread: {
        en: 'In => Spread',
        de: 'Rein => Verteilen',
        fr: 'Intérieur -> Écartez-vous',
        ja: '中 => 散会',
        cn: '靠近 => 分散',
        ko: '안으로 => 산개'
      },
      inAndHealerGroups: {
        en: 'In => Healer Groups',
        de: 'Rein => Heiler Gruppen',
        fr: 'Intérieur -> Groupes sur les heals',
        ja: '中 => ヒーラと4:4頭割り',
        cn: '靠近 => 治疗分组分摊',
        ko: '안으로 => 힐러 그룹 쉐어'
      }
    }
  }, {
    id: 'BarbaricciaEx Hair Raid Donut Move',
    type: 'Ability',
    netRegex: {
      id: '757F',
      source: 'Barbariccia',
      capture: false
    },
    condition: data => data.barberyMechanic === 'spread',
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread Out',
        de: 'Außen Verteilen',
        fr: 'Écartez-vous',
        ja: '散会',
        cn: '分散',
        ko: '산개'
      }
    }
  }, {
    id: 'BarbaricciaEx Hair Raid Wall',
    type: 'StartsUsing',
    netRegex: {
      id: '757C',
      source: 'Barbariccia',
      capture: false
    },
    durationSeconds: data => data.nextBarberyMechanic === undefined ? undefined : 5,
    alertText: (data, _matches, output) => {
      if (data.nextBarberyMechanic === 'stack') return output.wallAndHealerGroups();
      if (data.nextBarberyMechanic === 'spread') return output.wallThenSpread();
      return output.wall();
    },
    outputStrings: {
      wall: {
        en: 'Wall',
        de: 'Wand',
        fr: 'Mur',
        ja: '壁へ',
        cn: '去场边',
        ko: '벽으로'
      },
      wallAndHealerGroups: {
        en: 'Wall + Healer Groups',
        de: 'Wand + Heiler Gruppen',
        fr: 'Mur + Groupes sur les heals',
        ja: '壁へ + ヒーラと4:4頭割り',
        cn: '去场边 + 治疗分组分摊',
        ko: '벽으로 + 힐러 그룹 쉐어'
      },
      wallThenSpread: {
        en: 'Wall => Spread',
        de: 'Wand => Verteilen',
        fr: 'Mur -> Écartez-vous',
        ja: '壁へ => 散会',
        cn: '去场边 => 分散',
        ko: '벽으로 => 산개'
      }
    }
  }, {
    id: 'BarbaricciaEx Hair Raid Wall Move',
    type: 'Ability',
    netRegex: {
      id: '757D',
      source: 'Barbariccia',
      capture: false
    },
    condition: data => data.barberyMechanic === 'spread',
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread Out',
        de: 'Außen Verteilen',
        fr: 'Écartez-vous',
        ja: '散会',
        cn: '分散',
        ko: '산개'
      }
    }
  }, {
    id: 'BarbaricciaEx Hair Spray',
    type: 'StartsUsing',
    netRegex: {
      id: '75A6',
      source: 'Barbariccia',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      // This spread mechanic is used later in other phases of the fight as well.
      // However, that extra usage is fixed in the Curling Iron Cleanup trigger.
      data.barberyMechanic = 'spread';
      data.nextBarberyMechanic ??= 'stack';

      // Suppress extra "spread" if we handled it in Hair Raid.
      if (data.nextBarberyMechanic === 'spread') {
        delete data.nextBarberyMechanic;
        return;
      }
      return output.spread();
    },
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread
    }
  }, {
    id: 'BarbaricciaEx Deadly Twist',
    type: 'StartsUsing',
    netRegex: {
      id: '75A7',
      source: 'Barbariccia',
      capture: false
    },
    suppressSeconds: 2,
    infoText: (data, _matches, output) => {
      data.barberyMechanic = 'stack';
      data.nextBarberyMechanic ??= 'spread';

      // Suppress extra "stack" if we handled it in Hair Raid.
      if (data.nextBarberyMechanic === 'stack') {
        delete data.nextBarberyMechanic;
        return;
      }
      return output.groups();
    },
    outputStrings: {
      groups: outputs/* default.healerGroups */.Z.healerGroups
    }
  }, {
    id: 'BarbaricciaEx Void Aero III',
    type: 'StartsUsing',
    netRegex: {
      id: '7571',
      source: 'Barbariccia'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'BarbaricciaEx Secret Breeze 1',
    type: 'Ability',
    // Trigger on 7413 Hair Flay (large spreads during partner stacks)
    netRegex: {
      id: '7413',
      source: 'Barbariccia',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.protean(),
    outputStrings: {
      protean: {
        en: 'Protean Spread',
        de: 'in Himmelsrichtungen verteilen',
        fr: 'Positions écartées',
        ja: '散会',
        cn: '八方分散',
        ko: '8방향 산개'
      }
    }
  }, {
    id: 'BarbaricciaEx Secret Breeze Others',
    type: 'StartsUsing',
    netRegex: {
      id: '7580',
      source: 'Barbariccia',
      capture: false
    },
    preRun: data => data.secretBreezeCount++,
    durationSeconds: 3,
    alertText: (data, _matches, output) => {
      // On the first one, don't call too early. Call after the spread/partner stacks go off.
      if (data.secretBreezeCount !== 1) return output.protean();
    },
    outputStrings: {
      protean: {
        en: 'Protean',
        de: 'Himmelsrichtungen',
        fr: 'Positions',
        ja: '散開',
        cn: '八方分散',
        ko: '8방향 산개'
      }
    }
  }, {
    id: 'BarbaricciaEx Boulder Break',
    type: 'StartsUsing',
    netRegex: {
      id: '7383',
      source: 'Barbariccia'
    },
    response: responses/* Responses.sharedTankBuster */.n3.sharedTankBuster()
  }, {
    id: 'BarbaricciaEx Brittle Boulder 1',
    type: 'Ability',
    netRegex: {
      id: '7383',
      source: 'Barbariccia',
      capture: false
    },
    durationSeconds: 8,
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Middle => Out + Spread',
        de: 'In der Mitte Ködern => Raus (verteilen)',
        fr: 'Posez au centre -> Écartez-vous à l\'extérieur',
        ja: '真ん中で誘導 => 散開',
        cn: '中间集合 => 八方分散',
        ko: '중앙에 장판 유도 => 밖으로 산개'
      }
    }
  }, {
    id: 'BarbaricciaEx Boulder',
    type: 'HeadMarker',
    netRegex: {
      id: '0173',
      capture: false
    },
    suppressSeconds: 2,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out + Spread',
        de: 'Raus + Verteilen',
        fr: 'Extérieur + Écartez-vous',
        ja: '外へ + 散会',
        cn: '远离 => 分散',
        ko: '밖으로 + 산개'
      }
    }
  }, {
    // These also favor a certain order of Tank/Healer for first set then DPS second set,
    // but if people are dead anybody can get these.
    id: 'BarbaricciaEx Brutal Rush',
    type: 'Tether',
    netRegex: {
      id: '0011'
    },
    condition: (data, matches) => matches.source === data.me,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Brutal Rush tether on You',
        de: 'Grausame Hatz Verbindung auf DIR',
        fr: 'Lien de Ruée brutale sur VOUS',
        ja: '自分に突進',
        cn: '冲拳点名',
        ko: '나에게 선 연결'
      }
    }
  }, {
    id: 'BarbaricciaEx Brutal Rush Move',
    type: 'Ability',
    // When the Brutal Rush hits you, the follow-up Brutal Gust has locked in.
    netRegex: {
      id: ['7583', '7584'],
      source: 'Barbariccia'
    },
    condition: (data, matches) => {
      // Suppress during the middle of puddles where these are (usually) naturally dodged.
      if (data.blowAwayPuddleCount !== 0 && data.blowAwayPuddleCount !== 4) return false;
      return matches.target === data.me;
    },
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'BarbaricciaEx Hair Flay',
    type: 'StartsUsing',
    netRegex: {
      id: '7413',
      source: 'Barbariccia'
    },
    alertText: (data, matches, output) => {
      data.hairFlayUpbraidTargets.push(matches.target);
      if (data.me === matches.target) return output.spread();
    },
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread
    }
  }, {
    id: 'BarbaricciaEx Upbraid',
    type: 'StartsUsing',
    netRegex: {
      id: '75A8',
      source: 'Barbariccia'
    },
    alertText: (data, matches, output) => {
      data.hairFlayUpbraidTargets.push(matches.target);
      if (data.me === matches.target) return output.partnerStack();
    },
    outputStrings: {
      partnerStack: {
        en: 'Partner Stack',
        de: 'Mit Partner sammeln',
        fr: 'Package partenaire',
        ja: 'ペア',
        cn: '2 人分摊',
        ko: '2인 쉐어'
      }
    }
  }, {
    id: 'BarbaricciaEx Upbraid Untargeted',
    type: 'StartsUsing',
    netRegex: {
      id: '75A8',
      source: 'Barbariccia',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 2,
    alertText: (data, _matches, output) => {
      if (data.hairFlayUpbraidTargets.includes(data.me)) return;
      return output.partnerStack();
    },
    run: data => data.hairFlayUpbraidTargets = [],
    outputStrings: {
      partnerStack: {
        en: 'Partner Stack (unmarked)',
        de: 'Mit Partner sammeln (nicht markiert)',
        fr: 'Package partenaire (sans marque)',
        ja: 'ペア (マーカーなし)',
        cn: '2 人分摊 (无点名)',
        ko: '2인 쉐어 (징 없음)'
      }
    }
  }, {
    id: 'BarbaricciaEx Bold Boulder',
    type: 'StartsUsing',
    netRegex: {
      id: '759B',
      source: 'Barbariccia'
    },
    infoText: (data, matches, output) => {
      data.boldBoulderTargets.push(matches.target);
      if (data.me === matches.target) return output.flareOnYou();
    },
    outputStrings: {
      flareOnYou: {
        en: 'Flare on YOU',
        de: 'Flare auf DIR',
        fr: 'Brasier sur VOUS',
        ja: '自分にフレア',
        cn: '核爆点名',
        ko: '플레어 대상자'
      }
    }
  }, {
    id: 'BarbaricciaEx Trample',
    type: 'StartsUsing',
    // There's no castbar for Trample, so use Bold Boulder and collect flares.
    // There's also an 0064 stack headmarker, but that's used elsewhere.
    netRegex: {
      id: '759B',
      source: 'Barbariccia',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    // info to match spread and flare to not conflict during knockback
    infoText: (data, _matches, output) => {
      if (data.boldBoulderTargets.includes(data.me)) return;
      return output.stackMarker();
    },
    run: data => data.boldBoulderTargets = [],
    outputStrings: {
      stackMarker: outputs/* default.stackMarker */.Z.stackMarker
    }
  }, {
    id: 'BarbaricciaEx Blow Away Reset',
    type: 'Ability',
    netRegex: {
      id: '7595',
      source: 'Barbariccia',
      capture: false
    },
    run: data => {
      data.blowAwayCount++;
      data.blowAwayPuddleCount = 0;
    }
  }, {
    id: 'BarbaricciaEx Blow Away Puddle Count',
    type: 'StartsUsing',
    netRegex: {
      id: '7596',
      source: 'Barbariccia',
      capture: false
    },
    preRun: data => data.blowAwayPuddleCount++,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      // This handles Brittle Boulder 2 as well.
      if (data.blowAwayCount === 2 && data.blowAwayPuddleCount === 4) return output.stackMiddle();
    },
    infoText: (data, _matches, output) => {
      return output[`num${data.blowAwayPuddleCount}`]();
    },
    outputStrings: {
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      num4: outputs/* default.num4 */.Z.num4,
      stackMiddle: {
        en: 'Bait Middle',
        de: 'Mitte ködern',
        fr: 'Attirez au milieu',
        ja: '真ん中で誘導',
        cn: '中间诱导',
        ko: '중앙에 유도하기'
      }
    }
  }, {
    id: 'BarbaricciaEx Impact',
    type: 'StartsUsing',
    netRegex: {
      id: '75A0',
      source: 'Barbariccia'
    },
    // Could also have used 75A1, full cast time is 5.9s
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'BarbaricciaEx Playstation Hair Chains',
    type: 'HeadMarker',
    netRegex: {},
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, matches, output) => {
      switch (matches.id) {
        case '016F':
          return output.circle();
        case '0170':
          return output.triangle();
        case '0171':
          return output.square();
        case '0172':
          return output.cross();
      }
    },
    outputStrings: {
      circle: {
        en: 'Red Circle',
        de: 'Roter Kreis',
        fr: 'Cercle rouge',
        ja: '赤まる',
        cn: '红圆圈',
        ko: '빨강 동그라미'
      },
      triangle: {
        en: 'Green Triangle',
        de: 'Grünes Dreieck',
        fr: 'Triangle vert',
        ja: '緑さんかく',
        cn: '绿三角',
        ko: '초록 삼각'
      },
      square: {
        en: 'Purple Square',
        de: 'Lilanes Viereck',
        fr: 'Carré violet',
        ja: '紫しかく',
        cn: '紫方块',
        ko: '보라 사각'
      },
      cross: {
        en: 'Blue X',
        de: 'Blaues X',
        fr: 'Croix bleue',
        ja: '青バツ',
        cn: '蓝 X',
        ko: '파랑 X'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Barbariccia': 'Barbarizia',
      'Stiff Breeze': 'Föhn'
    },
    'replaceText': {
      'ground': 'Boden',
      'line': 'Linie',
      'donut': 'Donut',
      'protean': 'Himmelsrichtungen',
      'Blow Away': 'Hauerwelle',
      'Blustery Ruler': 'Tosende Herrin',
      'Bold Boulder': 'Feister Fels',
      '(?<!(Brittle|Bold) )Boulder(?! Break)': 'Fels',
      'Boulder Break': 'Felsbruch',
      'Brittle Boulder': 'Feiner Fels',
      'Brush with Death': 'Haaresbreite',
      'Brutal Gust': 'Grausame Bö',
      'Brutal Rush': 'Grausame Hatz',
      'Catabasis': 'Katabasis',
      'Curling Iron': 'In Schale',
      'Deadly Twist': 'Flechtfolter',
      'Dry Blows': 'Haue',
      'Entanglement': 'Fesselnde Strähnen',
      'Fetters': 'Fesselung',
      'Hair Raid': 'Haarstreich',
      'Hair Spray': 'Wildwuchs',
      'Impact': 'Impakt',
      'Iron Out': 'Coiffure',
      'Knuckle Drum': 'Kahlhieb',
      'Maelstrom': 'Charybdis',
      'Raging Storm': 'Tobender Sturm',
      'Savage Barbery': 'Brutale Barbierei',
      'Secret Breeze': 'Heimlicher Hauch',
      '(?<!(Teasing |En))Tangle': 'Strähne',
      'Teasing Tangles': 'Sinistre Strähnen',
      'Tornado Chain': 'Kettenorkan',
      'Tousle': 'Föhn',
      'Trample': 'Trampeln',
      'Upbraid': 'Sturmfrisur',
      'Void Aero III': 'Nichts-Windga',
      'Void Aero IV': 'Nichts-Windka',
      'Voidstrom': 'Nichtssturm',
      'Winding Gale': 'Windende Winde'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Barbariccia': 'Barbariccia',
      'Stiff Breeze': 'rafale de vent'
    },
    'replaceText': {
      'ground': 'Sol',
      'line': 'Ligne',
      'donut': 'Donut',
      'protean': 'Positions',
      'Blow Away': 'Coups convulsifs',
      'Blustery Ruler': 'Despote venteux',
      'Bold Boulder': 'Grand conglomérat',
      '(?<!(Brittle|Bold) )Boulder(?! Break)': 'Conglomérat',
      'Boulder Break': 'Conglomérat pesant',
      'Brittle Boulder': 'Petit conglomérat',
      'Brush with Death': 'Brossage mortel',
      'Brutal Gust': 'Rafale brutale',
      'Brutal Rush': 'Ruée brutale',
      'Catabasis': 'Catabase',
      'Curling Iron': 'Boucle de fer',
      'Deadly Twist': 'Nœud fatal',
      'Dry Blows': 'Coups secs',
      'Entanglement': 'Enchevêtrement',
      'Fetters': 'Attache',
      'Hair Raid': 'Raid capillaire',
      'Hair Spray': 'Tresse laquée',
      'Impact': 'Impact',
      'Iron Out': 'Repassage capillaire',
      'Knuckle Drum': 'Batterie de poings',
      'Maelstrom': 'Charybde',
      'Raging Storm': 'Tempête enragée',
      'Savage Barbery': 'Barbarie sauvage',
      'Secret Breeze': 'Brise secrète',
      '(?<!(Teasing |En))Tangle': 'Emmêlement',
      'Teasing Tangles': 'Emmêlement railleur',
      'Tornado Chain': 'Chaîne de tornades',
      'Tousle': 'Ébourrifage',
      'Trample': 'Martèlement',
      'Upbraid': 'Natte sermonneuse',
      'Void Aero III': 'Méga Vent du néant',
      'Void Aero IV': 'Giga Vent du néant',
      'Voidstrom': 'Tempête du néant',
      'Winding Gale': 'Vent sinueux'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Barbariccia': 'バルバリシア',
      'Stiff Breeze': '荒風'
    },
    'replaceText': {
      'Blow Away': '拳震動地',
      'Blustery Ruler': 'ブロウルーラー',
      'Bold Boulder': '大岩礫',
      '(?<!(Brittle|Bold) )Boulder(?! Break)': '岩礫',
      'Boulder Break': '重岩礫',
      'Brittle Boulder': '小岩礫',
      'Brush with Death': '呪髪操作',
      'Brutal Gust': 'ブルータルガスト',
      'Brutal Rush': 'ブルータルラッシュ',
      'Catabasis': 'カタバシス',
      'Curling Iron': '呪髪装衣',
      'Deadly Twist': '呪髪穿',
      'Dry Blows': '拳震',
      'Entanglement': '呪髪呪縛',
      'Fetters': '拘束',
      'Hair Raid': 'ヘアレイド',
      'Hair Spray': '呪髪針',
      'Impact': '衝撃',
      'Iron Out': '髪衣還元',
      'Knuckle Drum': 'ナックルビート',
      'Maelstrom': 'ミールストーム',
      'Raging Storm': 'レイジングストーム',
      'Savage Barbery': 'サベッジバルバリー',
      'Secret Breeze': 'シークレットブリーズ',
      '(?<!(Teasing |En))Tangle': '呪髪',
      'Teasing Tangles': '呪髪拘束',
      'Tornado Chain': 'チェイントルネード',
      'Tousle': '荒風',
      'Trample': '踏みつけ',
      'Upbraid': '呪髪嵐',
      'Void Aero III': 'ヴォイド・エアロガ',
      'Void Aero IV': 'ヴォイド・エアロジャ',
      'Voidstrom': 'ヴォイドストーム',
      'Winding Gale': 'ウィンディングゲイル'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Barbariccia': '巴尔巴莉希娅',
      'Stiff Breeze': '荒风'
    },
    'replaceText': {
      'ground': '地面',
      'line': '直线',
      'donut': '月环',
      'protean': '八方',
      'Blow Away': '重拳激震',
      'Blustery Ruler': '天风主宰',
      'Bold Boulder': '巨岩砾',
      '(?<!(Brittle|Bold) )Boulder(?! Break)': '岩砾',
      'Boulder Break': '砾岩碎',
      'Brittle Boulder': '小岩砾',
      'Brush with Death': '咒发操控',
      'Brutal Gust': '残暴突风',
      'Brutal Rush': '残暴冲锋',
      'Catabasis': '落狱煞',
      'Curling Iron': '咒发武装',
      'Deadly Twist': '咒发刺',
      'Dry Blows': '拳震',
      'Entanglement': '咒发束缚',
      'Fetters': '拘束',
      'Hair Raid': '咒发突袭',
      'Hair Spray': '咒发针',
      'Impact': '冲击',
      'Iron Out': '咒发卸甲',
      'Knuckle Drum': '怒拳连震',
      'Maelstrom': '大漩涡',
      'Raging Storm': '愤怒风暴',
      'Savage Barbery': '野蛮剃',
      'Secret Breeze': '隐秘之风',
      '(?<!(Teasing |En))Tangle': '咒发',
      'Teasing Tangles': '咒发拘束',
      'Tornado Chain': '龙卷连风',
      'Tousle': '荒风',
      'Trample': '踩踏',
      'Upbraid': '咒发突',
      'Void Aero III': '虚空暴风',
      'Void Aero IV': '虚空飙风',
      'Voidstrom': '虚无风暴',
      'Winding Gale': '追命狂风'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Barbariccia': '바르바리차',
      'Stiff Breeze': '바람타래'
    },
    'replaceText': {
      'ground': '바닥',
      'line': '직선',
      'donut': '도넛',
      'protean': '8방',
      'Blow Away': '융기격',
      'Blustery Ruler': '바람의 지배자',
      'Bold Boulder': '큰 바윗덩이',
      '(?<!(Brittle|Bold) )Boulder(?! Break)': '바윗덩이',
      'Boulder Break': '무거운 바윗덩이',
      'Brittle Boulder': '작은 바윗덩이',
      'Brush with Death': '머리털 조작',
      'Brutal Gust': '사나운 돌풍',
      'Brutal Rush': '사나운 돌격',
      'Catabasis': '카타바시스',
      'Curling Iron': '머리털 갑옷',
      'Deadly Twist': '머리털 송곳',
      'Dry Blows': '지진격',
      'Entanglement': '머리카락 포박',
      'Fetters': '구속',
      'Hair Raid': '머리칼 급습',
      'Hair Spray': '머리털 바늘',
      'Impact': '충격',
      'Iron Out': '머리털 복원',
      'Knuckle Drum': '주먹 연타',
      'Maelstrom': '흑와 투기장',
      'Raging Storm': '성난 폭풍',
      'Savage Barbery': '난폭한 이발',
      'Secret Breeze': '은밀한 바람',
      '(?<!(Teasing |En))Tangle': '요술 머리털',
      'Teasing Tangles': '머리털 구속',
      'Tornado Chain': '연속 회오리',
      'Tousle': '바람타래',
      'Trample': '짓밟기',
      'Upbraid': '머리털 용오름',
      'Void Aero III': '보이드 에어로가',
      'Void Aero IV': '보이드 에어로쟈',
      'Voidstrom': '보이드의 폭풍',
      'Winding Gale': '휘도는 큰바람'
    }
  }]
};
/* harmony default export */ const barbariccia_ex = (barbariccia_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/barbariccia-ex.txt
const trial_barbariccia_ex_namespaceObject = "### Barbariccia Extreme\r\n#\r\n# -ii 7413 7415 7581 7577 7578 7585 7586 7587 7588 7589 758B 7594 7598 75A1 75A0 758E 758F 758A 7589 7596 75AB 7592 7582 7593 7590 759C 7382\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Brush with Death\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n10.1 \"--sync--\" StartsUsing { id: \"7570\", source: \"Barbariccia\" } window 11,10\r\n15.1 \"Void Aero IV\" Ability { id: \"7570\", source: \"Barbariccia\" }\r\n22.3 \"Raging Storm\" Ability { id: \"7572\", source: \"Barbariccia\" }\r\n\r\n# Pattern 1a, linked with pattern 2a through 757A+7575 and 757A+757B\r\n# 6? Possible Spell Ids\r\n25.7 \"--sync--\" StartsUsing { id: [\"7573\", \"7464\", \"7465\", \"7466\", \"7489\", \"748B\"], source: \"Barbariccia\" } window 10,10\r\n31.7 \"--sync--\" Ability { id: [\"7573\", \"7464\", \"7465\", \"7466\", \"7489\", \"748B\"], source: \"Barbariccia\" }\r\n32.7 \"Savage Barbery (line/donut)\" Ability { id: [\"7574\", \"757A\"], source: \"Barbariccia\" }\r\n34.8 \"Savage Barbery (out)\" Ability { id: [\"7575\", \"757B\"], source: \"Barbariccia\" }\r\n35.8 \"Brush with Death\" Ability { id: \"75A4\", source: \"Barbariccia\" }\r\n\r\n# Pattern 1b, linked with Pattern 2b through 757C+757D and 757E+757F and also independently by 75A6 and 75A7\r\n44.9 \"--sync--\" Ability { id: [\"757C\", \"757E\"], source: \"Barbariccia\" }\r\n46.9 \"Hair Raid\" Ability { id: [\"757D\", \"757F\"], source: \"Barbariccia\" }\r\n49.1 \"Hair Spray/Deadly Twist\" Ability { id: [\"75A6\", \"75A7\"], source: \"Barbariccia\" }\r\n\r\n51.0 \"Raging Storm\" Ability { id: \"7572\", source: \"Barbariccia\" }\r\n\r\n# Pattern 2a\r\n54.4 \"--sync--\" StartsUsing { id: [\"7573\", \"7464\", \"7465\", \"7466\", \"7489\", \"748B\"], source: \"Barbariccia\" } window 10,10\r\n60.4 \"--sync--\" Ability { id: [\"7573\", \"7464\", \"7465\", \"7466\", \"7489\", \"748B\"], source: \"Barbariccia\" }\r\n61.4 \"Savage Barbery (donut/line)\" Ability { id: [\"757A\", \"7574\"], source: \"Barbariccia\" }\r\n63.5 \"Savage Barbery (out)\" Ability { id: [\"757B\", \"7575\"], source: \"Barbariccia\" }\r\n64.5 \"Brush with Death\" Ability { id: \"75A4\", source: \"Barbariccia\" }\r\n\r\n# Pattern 2b\r\n73.6 \"--sync--\" Ability { id: [\"757E\", \"757C\"], source: \"Barbariccia\" }\r\n75.6 \"Hair Raid\" Ability { id: [\"757F\", \"757D\"], source: \"Barbariccia\" }\r\n77.9 \"Deadly Twist/Hair Spray\" Ability { id: [\"75A7\", \"75A6\"], source: \"Barbariccia\" }\r\n\r\n85.8 \"Void Aero IV\" Ability { id: \"7570\", source: \"Barbariccia\" }\r\n92.9 \"Void Aero III\" Ability { id: \"7571\", source: \"Barbariccia\" }\r\n100.1 \"Raging Storm\" Ability { id: \"7572\", source: \"Barbariccia\" }\r\n\r\n# Teasing Tangles 1\r\n107.2 \"Teasing Tangles\" Ability { id: \"75A9\", source: \"Barbariccia\" }\r\n108.0 \"Fetters\" Ability { id: \"75B0\", source: \"Barbariccia\" }\r\n109.5 \"--sync--\" Ability { id: \"75AC\", source: \"Barbariccia\" }\r\n110.3 \"Brush with Death\" Ability { id: \"75A3\", source: \"Barbariccia\" }\r\n119.1 \"Upbraid\" Ability { id: \"75A8\", source: \"Barbariccia\" }\r\n119.6 \"Secret Breeze (ground)\" #Ability { id: \"7415\", source: \"Barbariccia\" }\r\n121.6 \"Secret Breeze (protean)\" #Ability { id: \"7581\", source: \"Barbariccia\" }\r\n130.7 \"Void Aero IV\" Ability { id: \"7570\", source: \"Barbariccia\" }\r\n137.9 \"Raging Storm\" Ability { id: \"7572\", source: \"Barbariccia\" }\r\n\r\n# Transition 1 - First Curling Iron\r\n146.3 \"--sync--\" Ability { id: \"75B2\", source: \"Barbariccia\" }\r\n152.0 \"Voidstrom\" duration 2 #Ability { id: \"7577\", source: \"Barbariccia\" }\r\n154.5 \"Curling Iron\" Ability { id: \"75B3\", source: \"Barbariccia\" }\r\n156.9 \"--sync--\" Ability { id: \"75B4\", source: \"Barbariccia\" }\r\n160.6 \"--untargetable--\"\r\n163.7 \"--sync--\" Ability { id: \"7488\", source: \"Barbariccia\" }\r\n171.7 \"Catabasis\" Ability { id: \"7576\", source: \"Barbariccia\" }\r\n\r\n### Phase 2\r\n171.8 \"--targetable--\"\r\n175.9 \"Brutal Rush 1\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n177.7 \"Brutal Rush 2\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n179.4 \"Brutal Rush 3\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n181.2 \"Brutal Rush 4\" Ability { id: \"7584\", source: \"Barbariccia\" }\r\n190.1 \"Winding Gale\" Ability { id: \"7486\", source: \"Barbariccia\" }\r\n190.9 \"Boulder Break\" Ability { id: \"7383\", source: \"Barbariccia\" }\r\n192.7 \"Brush with Death\" Ability { id: \"75A5\", source: \"Barbariccia\" }\r\n203.8 \"Brittle Boulder\" Ability { id: \"759E\", source: \"Barbariccia\" }\r\n204.6 \"Winding Gale\" Ability { id: \"7486\", source: \"Barbariccia\" }\r\n204.8 \"Boulder\" Ability { id: \"759D\", source: \"Barbariccia\" }\r\n208.4 \"Tornado Chain (out)\" Ability { id: \"758C\", source: \"Barbariccia\" }\r\n210.9 \"Tornado Chain (in)\" Ability { id: \"758D\", source: \"Barbariccia\" }\r\n212.0 \"Upbraid\" Ability { id: \"75A8\", source: \"Barbariccia\" }\r\n214.9 \"Brutal Rush 1\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n216.5 \"Brutal Rush 2\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n218.3 \"Brutal Rush 3\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n219.9 \"Brutal Rush 4\" Ability { id: \"7584\", source: \"Barbariccia\" }\r\n222.9 \"--sync--\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n225.2 \"Knuckle Drum\" duration 7.5 #Ability { id: \"7598\", source: \"Barbariccia\" }\r\n232.7 \"--sync--\" Ability { id: \"7599\", source: \"Barbariccia\" }\r\n234.8 \"Blow Away\" Ability { id: \"7595\", source: \"Barbariccia\" }\r\n238.5 \"Brutal Rush 1\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n240.1 \"Brutal Rush 2\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n241.7 \"Brutal Rush 3\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n243.3 \"Brutal Rush 4\" Ability { id: \"7584\", source: \"Barbariccia\" }\r\n244.9 \"--sync--\" Ability { id: \"759A\", source: \"Barbariccia\" }\r\n250.1 \"Impact\" Ability { id: \"759F\", source: \"Barbariccia\" }\r\n252.9 \"Bold Boulder\" Ability { id: \"759B\", source: \"Barbariccia\" }\r\n253.3 \"Trample\" Ability { id: \"75A2\", source: \"Barbariccia\" }\r\n259.1 \"Brutal Rush 1\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n260.7 \"Brutal Rush 2\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n262.3 \"Brutal Rush 3\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n264.0 \"Brutal Rush 4\" Ability { id: \"7584\", source: \"Barbariccia\" }\r\n\r\n# Teasing Tangles 2\r\n266.7 \"Teasing Tangles\" Ability { id: \"75AA\", source: \"Barbariccia\" }\r\n267.5 \"Fetters\" Ability { id: \"75B0\", source: \"Barbariccia\" }\r\n269.0 \"--sync--\" Ability { id: \"75AC\", source: \"Barbariccia\" }\r\n270.8 \"Blustery Ruler\" Ability { id: \"7591\", source: \"Barbariccia\" }\r\n278.0 \"Brush with Death\" Ability { id: \"75A5\", source: \"Barbariccia\" }\r\n279.1 \"Dry Blows\" duration 8.2 #Ability { id: \"7594\", source: \"Barbariccia\" }\r\n285.7 \"Tornado Chain (out)\" Ability { id: \"758C\", source: \"Barbariccia\" }\r\n288.1 \"Tornado Chain (in)\" Ability { id: \"758D\", source: \"Barbariccia\" }\r\n290.0 \"Upbraid\" Ability { id: \"75A8\", source: \"Barbariccia\" }\r\n291.0 \"--sync--\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n293.3 \"Knuckle Drum\" duration 7.5 #Ability { id: \"7598\", source: \"Barbariccia\" }\r\n300.8 \"--sync--\" Ability { id: \"7599\", source: \"Barbariccia\" }\r\n\r\n# Transition 2\r\n304.2 \"--sync--\" Ability { id: \"75B5\", source: \"Barbariccia\" }\r\n309.4 \"Voidstrom\" duration 2 #Ability { id: \"7577\", source: \"Barbariccia\" }\r\n312.4 \"Iron Out\" Ability { id: \"7455\", source: \"Barbariccia\" }\r\n318.5 \"Raging Storm\" Ability { id: \"7572\", source: \"Barbariccia\" }\r\n\r\n# Playstation 1\r\n325.6 \"Entanglement\" Ability { id: \"75AD\", source: \"Barbariccia\" }\r\n326.4 \"Fetters\" Ability { id: \"75B0\", source: \"Barbariccia\" }\r\n327.9 \"--sync--\" Ability { id: \"75AF\", source: \"Barbariccia\" }\r\n335.1 \"--sync--\" Ability { id: \"7580\", source: \"Barbariccia\" }\r\n336.1 \"Secret Breeze (ground)\" #Ability { id: \"7415\", source: \"Barbariccia\" }\r\n338.2 \"Secret Breeze (protean)\" #Ability { id: \"7581\", source: \"Barbariccia\" }\r\n\r\n# Pattern 3a, linked with pattern 4a through 757A+7575 and 757A+757B\r\n341.4 \"--sync--\" StartsUsing { id: [\"7573\", \"7464\", \"7465\", \"7466\", \"7489\", \"748B\"], source: \"Barbariccia\" } window 10,10\r\n347.4 \"--sync--\" Ability { id: [\"7573\", \"7464\", \"7465\", \"7466\", \"7489\", \"748B\"], source: \"Barbariccia\" }\r\n348.4 \"Savage Barbery (line/donut)\" Ability { id: [\"7574\", \"757A\"], source: \"Barbariccia\" }\r\n350.5 \"Savage Barbery (out)\" Ability { id: [\"7575\", \"757B\"], source: \"Barbariccia\" }\r\n\r\n351.5 \"Brush with Death\" Ability { id: \"75A4\", source: \"Barbariccia\" }\r\n\r\n# Pattern 3b, linked with Pattern 4b through 757C+757D and 757E+757F and also independently by 75A6 and 75A7\r\n360.6 \"--sync--\" Ability { id: [\"757C\", \"757E\"], source: \"Barbariccia\" }\r\n362.6 \"Hair Raid\" Ability { id: [\"757D\", \"757F\"], source: \"Barbariccia\" }\r\n364.9 \"Deadly Twist/Hair Spray\" Ability { id: [\"75A7\", \"75A6\"], source: \"Barbariccia\" }\r\n\r\n373.8 \"Void Aero IV\" Ability { id: \"7570\", source: \"Barbariccia\" }\r\n380.9 \"Void Aero III\" Ability { id: \"7571\", source: \"Barbariccia\" }\r\n388.1 \"Raging Storm\" Ability { id: \"7572\", source: \"Barbariccia\" }\r\n\r\n# Playstation 2\r\n395.2 \"Entanglement\" Ability { id: \"75AD\", source: \"Barbariccia\" }\r\n396.0 \"Fetters\" Ability { id: \"75B0\", source: \"Barbariccia\" }\r\n397.5 \"--sync--\" Ability { id: \"75AF\", source: \"Barbariccia\" }\r\n400.4 \"Brush with Death\" Ability { id: \"75A3\", source: \"Barbariccia\" }\r\n409.2 \"Upbraid\" Ability { id: \"75A8\", source: \"Barbariccia\" }\r\n\r\n# Pattern 4a\r\n410.7 \"--sync--\" StartsUsing { id: [\"7573\", \"7464\", \"7465\", \"7466\", \"7489\", \"748B\"], source: \"Barbariccia\" } window 10,10\r\n416.7 \"--sync--\" Ability { id: [\"7573\", \"7464\", \"7465\", \"7466\", \"7489\", \"748B\"], source: \"Barbariccia\" }\r\n417.7 \"Savage Barbery (donut/line)\" Ability { id: [\"757A\", \"7574\"], source: \"Barbariccia\" }\r\n419.8 \"Savage Barbery (out)\" Ability { id: [\"757B\", \"7575\"], source: \"Barbariccia\" }\r\n\r\n# Pattern 4b\r\n426.8 \"--sync--\" Ability { id: [\"757C\", \"757E\"], source: \"Barbariccia\" }\r\n428.8 \"Hair Raid\" Ability { id: [\"757D\", \"757F\"], source: \"Barbariccia\" }\r\n430.7 \"Hair Spray/Deadly Twist\" Ability { id: [\"75A6\", \"75A7\"], source: \"Barbariccia\" }\r\n\r\n439.9 \"Void Aero IV\" Ability { id: \"7570\", source: \"Barbariccia\" }\r\n447.1 \"Raging Storm\" Ability { id: \"7572\", source: \"Barbariccia\" }\r\n\r\n# Transition 3 - Second Curling Iron\r\n455.4 \"--sync--\" Ability { id: \"75B2\", source: \"Barbariccia\" }\r\n460.7 \"Voidstrom\" duration 2 #Ability { id: \"7577\", source: \"Barbariccia\" }\r\n463.7 \"Curling Iron\" Ability { id: \"75B3\", source: \"Barbariccia\" }\r\n\r\n468.8 \"Brutal Rush 1\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n470.6 \"Brutal Rush 2\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n472.3 \"Brutal Rush 3\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n474.1 \"Brutal Rush 4\" Ability { id: \"7584\", source: \"Barbariccia\" }\r\n477.1 \"--sync--\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n479.4 \"Knuckle Drum\" duration 7.5 #Ability { id: \"7598\", source: \"Barbariccia\" }\r\n486.9 \"--sync--\" Ability { id: \"7599\", source: \"Barbariccia\" }\r\n489.0 \"Blow Away\" Ability { id: \"7595\", source: \"Barbariccia\" }\r\n500.5 \"Brutal Rush 1\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n502.1 \"Brutal Rush 2\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n503.1 \"Brittle Boulder\" Ability { id: \"759E\", source: \"Barbariccia\" }\r\n503.7 \"Brutal Rush 3\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n504.1 \"Boulder\" Ability { id: \"759D\", source: \"Barbariccia\" }\r\n505.4 \"Brutal Rush 4\" Ability { id: \"7584\", source: \"Barbariccia\" }\r\n509.2 \"Brush with Death\" Ability { id: \"75A5\", source: \"Barbariccia\" }\r\n513.1 \"Tornado Chain (out)\" Ability { id: \"758C\", source: \"Barbariccia\" }\r\n515.6 \"Tornado Chain (in)\" Ability { id: \"758D\", source: \"Barbariccia\" }\r\n518.5 \"Impact\" Ability { id: \"759F\", source: \"Barbariccia\" }\r\n521.0 \"Hair Spray\" Ability { id: \"75A6\", source: \"Barbariccia\" }\r\n522.8 \"Brutal Rush 1\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n524.4 \"Brutal Rush 2\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n526.2 \"Brutal Rush 3\" #Ability { id: \"7583\", source: \"Barbariccia\" }\r\n527.9 \"Brutal Rush 4\" Ability { id: \"7584\", source: \"Barbariccia\" }\r\n530.6 \"Blustery Ruler\" Ability { id: \"7591\", source: \"Barbariccia\" }\r\n538.9 \"Dry Blows\" duration 8.2 #Ability { id: \"7594\", source: \"Barbariccia\" }\r\n543.6 \"Tornado Chain (out)\" Ability { id: \"758C\", source: \"Barbariccia\" }\r\n546.2 \"Tornado Chain (in)\" Ability { id: \"758D\", source: \"Barbariccia\" }\r\n548.8 \"Boulder Break\" Ability { id: \"7383\", source: \"Barbariccia\" }\r\n554.2 \"Winding Gale\" Ability { id: \"7486\", source: \"Barbariccia\" }\r\n561.9 \"Tornado Chain (out)\" Ability { id: \"758C\", source: \"Barbariccia\" }\r\n564.4 \"Tornado Chain (in)\" Ability { id: \"758D\", source: \"Barbariccia\" }\r\n569.2 \"Winding Gale\" Ability { id: \"7486\", source: \"Barbariccia\" }\r\n572.0 \"Trample\" Ability { id: \"75A2\", source: \"Barbariccia\" }\r\n572.9 \"Bold Boulder\" Ability { id: \"759B\", source: \"Barbariccia\" }\r\n576.9 \"--sync--\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n579.2 \"Knuckle Drum\" duration 7.5 #Ability { id: \"7598\", source: \"Barbariccia\" }\r\n586.7 \"--sync--\" Ability { id: \"7599\", source: \"Barbariccia\" }\r\n\r\n# Transition 4\r\n589.0 \"--sync--\" Ability { id: \"75B5\", source: \"Barbariccia\" }\r\n594.2 \"Voidstrom\" duration 2 #Ability { id: \"7577\", source: \"Barbariccia\" }\r\n597.2 \"Iron Out\" Ability { id: \"7455\", source: \"Barbariccia\" }\r\n603.3 \"Raging Storm\" Ability { id: \"7572\", source: \"Barbariccia\" }\r\n\r\n# Playstation 3\r\n610.4 \"Entanglement\" Ability { id: \"75AD\", source: \"Barbariccia\" }\r\n611.2 \"Fetters\" Ability { id: \"75B0\", source: \"Barbariccia\" }\r\n612.7 \"--sync--\" Ability { id: \"75AF\", source: \"Barbariccia\" }\r\n619.9 \"--sync--\" Ability { id: \"7580\", source: \"Barbariccia\" }\r\n620.9 \"Secret Breeze (ground)\" #Ability { id: \"7415\", source: \"Barbariccia\" }\r\n622.9 \"Secret Breeze (protean)\" #Ability { id: \"7581\", source: \"Barbariccia\" }\r\n\r\n# Pattern 5a\r\n626.2 \"--sync--\" StartsUsing { id: [\"7573\", \"7464\", \"7465\", \"7466\", \"7489\", \"748B\"], source: \"Barbariccia\" } window 10,10\r\n632.2 \"--sync--\" Ability { id: [\"7573\", \"7464\", \"7465\", \"7466\", \"7489\", \"748B\"], source: \"Barbariccia\" }\r\n633.2 \"Savage Barbery (line/donut)\" Ability { id: [\"7574\", \"757A\"], source: \"Barbariccia\" }\r\n635.3 \"Savage Barbery (out)\" Ability { id: [\"7575\", \"757B\"], source: \"Barbariccia\" }\r\n\r\n636.3 \"Brush with Death\" Ability { id: \"75A4\", source: \"Barbariccia\" }\r\n\r\n# Pattern 5b\r\n645.4 \"--sync--\" Ability { id: [\"757C\", \"757E\"], source: \"Barbariccia\" }\r\n647.4 \"Hair Raid\" Ability { id: [\"757D\", \"757F\"], source: \"Barbariccia\" }\r\n649.7 \"Hair Spray/Deadly Twist\" Ability { id: [\"75A6\", \"75A7\"], source: \"Barbariccia\" }\r\n\r\n658.6 \"Void Aero IV\" Ability { id: \"7570\", source: \"Barbariccia\" }\r\n660.7 \"Raging Storm\" Ability { id: \"7572\", source: \"Barbariccia\" }\r\n\r\n664.0 \"--sync--\" StartsUsing { id: \"75BE\", source: \"Barbariccia\" } window 700,10\r\n673.0 \"Maelstrom (enrage)\" Ability { id: \"75BE\", source: \"Barbariccia\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/barbariccia.ts




const barbariccia_triggerSet = {
  id: 'StormsCrown',
  zoneId: zone_id/* default.StormsCrown */.Z.StormsCrown,
  timelineFile: 'barbariccia.txt',
  timelineTriggers: [{
    id: 'Barbariccia Knuckle Drum',
    regex: /Knuckle Drum/,
    beforeSeconds: 5,
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'Barbariccia Blow Away',
    regex: /Blow Away/,
    beforeSeconds: 5,
    response: responses/* Responses.getTogether */.n3.getTogether('info')
  }],
  triggers: [{
    id: 'Barbariccia Void Aero IV',
    type: 'StartsUsing',
    netRegex: {
      id: '75B6',
      source: 'Barbariccia',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    // Savage Barbery has 3 casts that all start at the same time.
    // 6.7 duration: 7468, 748C, 748E (all actual cast bar, unknown how to differentiate)
    // 7.7 duration: 75BA (donut), 75C0 (line)
    // 9.8 duration: 75BB (out, paired with donut), 75C1 (out, paired with line)
    id: 'Barbariccia Savage Barbery Donut',
    type: 'StartsUsing',
    netRegex: {
      id: '75BA',
      source: 'Barbariccia',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'Barbariccia Savage Barbery Line',
    type: 'StartsUsing',
    netRegex: {
      id: '75C0',
      source: 'Barbariccia',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Out and Away',
        de: 'Raus und Weg',
        fr: 'Extérieur et loin',
        ja: '外へ',
        cn: '外侧远离',
        ko: '밖으로'
      }
    }
  }, {
    id: 'Barbariccia Hair Raid Wall',
    type: 'StartsUsing',
    netRegex: {
      id: '75C2',
      source: 'Barbariccia',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Wall',
        de: 'Wand',
        fr: 'Mur',
        ja: '壁へ',
        cn: '去场边',
        ko: '벽으로'
      }
    }
  }, {
    id: 'Barbariccia Void Aero III',
    type: 'StartsUsing',
    netRegex: {
      id: '75B7',
      source: 'Barbariccia'
    },
    response: responses/* Responses.sharedTankBuster */.n3.sharedTankBuster()
  }, {
    id: 'Barbariccia Deadly Twist',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Barbariccia Hair Spray',
    type: 'HeadMarker',
    netRegex: {
      id: '0175'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Barbariccia Brutal Rush Move',
    type: 'Ability',
    // When the Brutal Rush hits you, the follow-up Brutal Gust has locked in.
    netRegex: {
      id: '75C6',
      source: 'Barbariccia'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'Barbariccia Boulder',
    type: 'HeadMarker',
    netRegex: {
      id: '0160'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.awayFrom */.n3.awayFrom()
  }, {
    id: 'Barbariccia Boulder Break Tankbuster',
    type: 'StartsUsing',
    netRegex: {
      id: '73CF',
      source: 'Voidwalker',
      capture: false
    },
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.tankBusters */.Z.tankBusters
    }
  }, {
    id: 'Barbariccia Bold Boulder',
    type: 'StartsUsing',
    netRegex: {
      id: '75D6',
      source: 'Barbariccia'
    },
    infoText: (data, matches, output) => {
      data.boldBoulderTarget = matches.target;
      if (data.me === matches.target) return output.flareOnYou();
    },
    run: data => delete data.boldBoulderTarget,
    outputStrings: {
      flareOnYou: {
        en: 'Flare on YOU',
        de: 'Flare auf DIR',
        fr: 'Brasier sur VOUS',
        ja: '自分にフレア',
        cn: '核爆点名',
        ko: '플레어 대상자'
      }
    }
  }, {
    id: 'Barbariccia Trample',
    type: 'HeadMarker',
    netRegex: {
      id: '0064'
    },
    condition: data => data.boldBoulderTarget !== data.me,
    delaySeconds: 0.5,
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Barbariccia Touchdown',
    type: 'StartsUsing',
    netRegex: {
      id: '746D',
      source: 'Barbariccia'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Barbariccia Impact',
    type: 'StartsUsing',
    netRegex: {
      id: '75D8',
      source: 'Barbariccia'
    },
    // Could also have used 75D9, full cast time is 5.9s
    delaySeconds: (_data, matches) => parseFloat(matches.castTime) - 5,
    response: responses/* Responses.knockback */.n3.knockback('info') // probably used on Touchdown
  }],

  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Barbariccia': 'Barbarizia',
      'Voidwalker': 'Nichtswandler'
    },
    'replaceText': {
      'Blow Away': 'Hauerwelle',
      'Bold Boulder': 'Feister Fels',
      'Boulder Break': 'Felsbruch',
      'Brush with Death': 'Haaresbreite',
      'Brutal Rush': 'Grausame Hatz',
      'Catabasis': 'Katabasis',
      'Curling Iron': 'In Schale',
      'Deadly Twist': 'Flechtfolter',
      'Dry Blows': 'Haue',
      'Fetters': 'Fesselung',
      'Hair Raid': 'Haarstreich',
      'Hair Spray': 'Wildwuchs',
      'Impact': 'Impakt',
      'Knuckle Drum': 'Kahlhieb',
      'Savage Barbery': 'Brutale Barbierei',
      'Secret Breeze': 'Heimlicher Hauch',
      'Teasing Tangles': 'Sinistre Strähnen',
      'Tornado Chain': 'Kettenorkan',
      'Touchdown': 'Himmelssturz',
      'Trample': 'Trampeln',
      'Void Aero(?! )': 'Nichtswind',
      'Void Aero III': 'Nichts-Windga',
      'Void Aero IV': 'Nichts-Windka',
      'Voidstrom': 'Nichtssturm',
      'Winding Gale': 'Windende Winde'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Barbariccia': 'Barbariccia',
      'Voidwalker': 'marcheuse du néant'
    },
    'replaceText': {
      'Blow Away': 'Coups convulsifs',
      'Bold Boulder': 'Grand conglomérat',
      'Boulder Break': 'Conglomérat pesant',
      'Brush with Death': 'Brossage mortel',
      'Brutal Rush': 'Ruée brutale',
      'Catabasis': 'Catabase',
      'Curling Iron': 'Boucle de fer',
      'Deadly Twist': 'Nœud fatal',
      'Dry Blows': 'Coups secs',
      'Fetters': 'Attache',
      'Hair Raid': 'Raid capillaire',
      'Hair Spray': 'Tresse laquée',
      'Impact': 'Impact',
      'Knuckle Drum': 'Batterie de poings',
      'Savage Barbery': 'Barbarie sauvage',
      'Secret Breeze': 'Brise secrète',
      'Teasing Tangles': 'Emmêlement railleur',
      'Tornado Chain': 'Chaîne de tornades',
      'Touchdown': 'Atterrissage',
      'Trample': 'Martèlement',
      'Void Aero(?! )': 'Vent du néant',
      'Void Aero III': 'Méga Vent du néant',
      'Void Aero IV': 'Giga Vent du néant',
      'Voidstrom': 'Tempête du néant',
      'Winding Gale': 'Vent sinueux'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Barbariccia': 'バルバリシア',
      'Voidwalker': 'ヴォイドウォーカー'
    },
    'replaceText': {
      'Blow Away': '拳震動地',
      'Bold Boulder': '大岩礫',
      'Boulder Break': '重岩礫',
      'Brush with Death': '呪髪操作',
      'Brutal Rush': 'ブルータルラッシュ',
      'Catabasis': 'カタバシス',
      'Curling Iron': '呪髪装衣',
      'Deadly Twist': '呪髪穿',
      'Dry Blows': '拳震',
      'Fetters': '拘束',
      'Hair Raid': 'ヘアレイド',
      'Hair Spray': '呪髪針',
      'Impact': '衝撃',
      'Knuckle Drum': 'ナックルビート',
      'Savage Barbery': 'サベッジバルバリー',
      'Secret Breeze': 'シークレットブリーズ',
      'Teasing Tangles': '呪髪拘束',
      'Tornado Chain': 'チェイントルネード',
      'Touchdown': 'タッチダウン',
      'Trample': '踏みつけ',
      'Void Aero(?! )': 'ヴォイド・エアロ',
      'Void Aero III': 'ヴォイド・エアロガ',
      'Void Aero IV': 'ヴォイド・エアロジャ',
      'Voidstrom': 'ヴォイドストーム',
      'Winding Gale': 'ウィンディングゲイル'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Barbariccia': '巴尔巴莉希娅',
      'Voidwalker': '虚无行者'
    },
    'replaceText': {
      'Blow Away': '重拳激震',
      'Bold Boulder': '巨岩砾',
      'Boulder Break': '砾岩碎',
      'Brush with Death': '咒发操控',
      'Brutal Rush': '残暴冲锋',
      'Catabasis': '落狱煞',
      'Curling Iron': '咒发武装',
      'Deadly Twist': '咒发刺',
      'Dry Blows': '拳震',
      'Fetters': '拘束',
      'Hair Raid': '咒发突袭',
      'Hair Spray': '咒发针',
      'Impact': '冲击',
      'Knuckle Drum': '怒拳连震',
      'Savage Barbery': '野蛮剃',
      'Secret Breeze': '隐秘之风',
      'Teasing Tangles': '咒发拘束',
      'Tornado Chain': '龙卷连风',
      'Touchdown': '空降',
      'Trample': '踩踏',
      'Void Aero(?! )': '虚空疾风',
      'Void Aero III': '虚空暴风',
      'Void Aero IV': '虚空飙风',
      'Voidstrom': '虚无风暴',
      'Winding Gale': '追命狂风'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Barbariccia': '바르바리차',
      'Voidwalker': '보이드워커'
    },
    'replaceText': {
      'Blow Away': '융기격',
      'Bold Boulder': '큰 바윗덩이',
      'Boulder Break': '무거운 바윗덩이',
      'Brush with Death': '머리털 조작',
      'Brutal Rush': '사나운 돌격',
      'Catabasis': '카타바시스',
      'Curling Iron': '머리털 갑옷',
      'Deadly Twist': '머리털 송곳',
      'Dry Blows': '지진격',
      'Fetters': '구속',
      'Hair Raid': '머리칼 급습',
      'Hair Spray': '머리털 바늘',
      'Impact': '충격',
      'Knuckle Drum': '주먹 연타',
      'Savage Barbery': '난폭한 이발',
      'Secret Breeze': '은밀한 바람',
      'Teasing Tangles': '머리털 구속',
      'Tornado Chain': '연속 회오리',
      'Touchdown': '착지',
      'Trample': '짓밟기',
      'Void Aero(?! )': '보이드 에어로',
      'Void Aero III': '보이드 에어로가',
      'Void Aero IV': '보이드 에어로쟈',
      'Voidstrom': '보이드의 폭풍',
      'Winding Gale': '휘도는 큰바람'
    }
  }]
};
/* harmony default export */ const barbariccia = (barbariccia_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/barbariccia.txt
const trial_barbariccia_namespaceObject = "### Barbariccia\r\n#\r\n# -ii 748C 75D9 759F 75D4 75D2 75D7 7591 75D0 75C3 75C0 759C 7382 7488 75BC 7468 75BB 75E0 748E 75C8 75D3 75C9 75CE 75CF 746C 75D5 7586 75CB 75CC 75CD 7487 75B9 759A 75E2 7578\r\n# -ic \"Stiff Breeze\"\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Brush with Death\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n\r\n# Intro\r\n15.1 \"Void Aero IV\" Ability { id: \"75B6\", source: \"Barbariccia\" } window 16,10\r\n22.3 \"--sync--\" Ability { id: \"7381\", source: \"Barbariccia\" }\r\n34.6 \"Savage Barbery\" Ability { id: \"75C1\", source: \"Barbariccia\" } window 10,10\r\n41.6 \"Hair Raid\" Ability { id: \"75C2\", source: \"Barbariccia\" }\r\n50.8 \"Void Aero III\" Ability { id: \"75B7\", source: \"Barbariccia\" }\r\n56.9 \"--sync--\" Ability { id: \"7381\", source: \"Barbariccia\" }\r\n67.3 \"Savage Barbery\" Ability { id: \"75BA\", source: \"Barbariccia\" }\r\n76.4 \"Hair Raid\" Ability { id: \"75C2\", source: \"Barbariccia\" }\r\n88.6 \"Void Aero IV\" Ability { id: \"75B6\", source: \"Barbariccia\" }\r\n95.8 \"--sync--\" Ability { id: \"7381\", source: \"Barbariccia\" }\r\n101.4 \"Teasing Tangles\" Ability { id: \"75DE\", source: \"Barbariccia\" }\r\n102.2 \"Fetters\" Ability { id: \"75B0\", source: \"Barbariccia\" }\r\n103.7 \"--sync--\" Ability { id: \"75AC\", source: \"Barbariccia\" }\r\n111.5 \"Secret Breeze\" Ability { id: \"75C4\", source: \"Barbariccia\" } window 10,10\r\n114.5 \"Secret Breeze\" Ability { id: \"75C5\", source: \"Barbariccia\" }\r\n118.7 \"Brush with Death\" Ability { id: \"75A3\", source: \"Barbariccia\" } window 10,10\r\n124.5 \"Deadly Twist\" Ability { id: \"75DC\", source: \"Barbariccia\" }\r\n129.8 \"--sync--\" Ability { id: \"7381\", source: \"Barbariccia\" }\r\n142.0 \"Savage Barbery\" Ability { id: \"75C1\", source: \"Barbariccia\" }\r\n143.1 \"Brush with Death\" Ability { id: \"75A4\", source: \"Barbariccia\" }\r\n152.2 \"Hair Raid\" Ability { id: \"75C2\", source: \"Barbariccia\" }\r\n160.0 \"Hair Spray\" Ability { id: \"75DB\", source: \"Barbariccia\" }\r\n168.5 \"Void Aero IV\" Ability { id: \"75B6\", source: \"Barbariccia\" }\r\n175.6 \"Void Aero III\" Ability { id: \"75B7\", source: \"Barbariccia\" }\r\n182.7 \"--sync--\" Ability { id: \"7381\", source: \"Barbariccia\" }\r\n188.5 \"Teasing Tangles\" Ability { id: \"75DE\", source: \"Barbariccia\" }\r\n189.3 \"Fetters\" Ability { id: \"75B0\", source: \"Barbariccia\" }\r\n190.8 \"--sync--\" Ability { id: \"75AC\", source: \"Barbariccia\" }\r\n198.6 \"Secret Breeze\" Ability { id: \"75C4\", source: \"Barbariccia\" } window 10,10\r\n199.6 \"Secret Breeze\" Ability { id: \"75C5\", source: \"Barbariccia\" }\r\n205.7 \"Void Aero\" Ability { id: \"746A\", source: \"Barbariccia\" }\r\n208.8 \"--sync--\" Ability { id: \"7380\", source: \"Barbariccia\" }\r\n210.5 \"Void Aero\" Ability { id: \"746B\", source: \"Barbariccia\" }\r\n212.9 \"--sync--\" Ability { id: \"7381\", source: \"Barbariccia\" }\r\n\r\n# Phase Change\r\n219.5 \"Curling Iron\" Ability { id: \"75B2\", source: \"Barbariccia\" }\r\n225.3 \"Voidstrom\" Ability { id: \"75BD\", source: \"Barbariccia\" } duration 2 window 10,10\r\n230.3 \"Catabasis\" Ability { id: \"75E3\", source: \"Barbariccia\" }\r\n262.4 \"Brutal Rush 1\" Ability { id: \"75C6\", source: \"Barbariccia\" } window 5,5\r\n264.0 \"Brutal Rush 2\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n265.7 \"Brutal Rush 3\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n267.3 \"Brutal Rush 4\" Ability { id: \"75C7\", source: \"Barbariccia\" } window 20,20\r\n270.1 \"Winding Gale\" Ability { id: \"75CA\", source: \"Barbariccia\" }\r\n273.6 \"Brush with Death\" Ability { id: \"75A5\", source: \"Barbariccia\" }\r\n289.5 \"Deadly Twist\" Ability { id: \"75DC\", source: \"Barbariccia\" }\r\n295.6 \"Boulder Break\" Ability { id: \"73CF\", source: \"Barbariccia\" }\r\n295.7 \"Knuckle Drum\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n\r\n# Loop every other trample?\r\n317.8 \"Trample\" Ability { id: \"75DA\", source: \"Barbariccia\" }\r\n317.9 \"Bold Boulder\" Ability { id: \"75D6\", source: \"Barbariccia\" }\r\n320.9 \"--sync--\" Ability { id: \"7582\", source: \"Barbariccia\" }\r\n322.0 \"Brush with Death\" Ability { id: \"75A5\", source: \"Barbariccia\" }\r\n325.1 \"Tornado Chain (out)\" Ability { id: \"758E\", source: \"Barbariccia\" }\r\n327.7 \"Tornado Chain (in)\" Ability { id: \"758F\", source: \"Barbariccia\" }\r\n331.3 \"Knuckle Drum\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n332.8 \"Hair Spray\" Ability { id: \"75DB\", source: \"Barbariccia\" }\r\n344.7 \"Brutal Rush 1\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n346.3 \"Brutal Rush 2\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n348.0 \"Brutal Rush 3\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n349.7 \"Brutal Rush 4\" Ability { id: \"75C7\", source: \"Barbariccia\" }\r\n351.3 \"Blow Away\" Ability { id: \"7595\", source: \"Barbariccia\" }\r\n354.9 \"Brutal Rush 1\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n356.5 \"Brutal Rush 2\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n358.1 \"Brutal Rush 3\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n359.8 \"Brutal Rush 4\" Ability { id: \"75C7\", source: \"Barbariccia\" }\r\n361.4 \"--sync--\" Ability { id: \"7582\", source: \"Barbariccia\" }\r\n362.5 \"Teasing Tangles\" Ability { id: \"75DF\", source: \"Barbariccia\" }\r\n363.3 \"Fetters\" Ability { id: \"75B0\", source: \"Barbariccia\" }\r\n364.8 \"--sync--\" Ability { id: \"75AC\", source: \"Barbariccia\" }\r\n368.1 \"Tornado Chain (out)\" Ability { id: \"758E\", source: \"Barbariccia\" }\r\n370.7 \"Tornado Chain (in)\" Ability { id: \"758F\", source: \"Barbariccia\" }\r\n375.3 \"Touchdown\" Ability { id: \"746D\", source: \"Barbariccia\" }\r\n377.4 \"--sync--\" Ability { id: \"7582\", source: \"Barbariccia\" }\r\n383.5 \"Boulder Break\" Ability { id: \"73CF\", source: \"Barbariccia\" }\r\n383.6 \"Knuckle Drum\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n396.8 \"Brutal Rush 1\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n398.6 \"Brutal Rush 2\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n400.2 \"Brutal Rush 3\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n401.9 \"Brutal Rush 4\" Ability { id: \"75C7\", source: \"Barbariccia\" }\r\n404.3 \"Impact\" Ability { id: \"75D8\", source: \"Barbariccia\" }\r\n406.7 \"Dry Blows\" Ability { id: \"7593\", source: \"Barbariccia\" }\r\n412.5 \"Brutal Rush 1\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n414.2 \"Brutal Rush 2\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n416.0 \"Brutal Rush 3\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n417.6 \"Brutal Rush 4\" Ability { id: \"75C7\", source: \"Barbariccia\" }\r\n420.2 \"Teasing Tangles\" Ability { id: \"75DF\", source: \"Barbariccia\" }\r\n421.0 \"Fetters\" Ability { id: \"75B0\", source: \"Barbariccia\" }\r\n422.5 \"--sync--\" Ability { id: \"75AC\", source: \"Barbariccia\" }\r\n423.3 \"--sync--\" Ability { id: \"7582\", source: \"Barbariccia\" }\r\n428.0 \"Knuckle Drum\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n440.1 \"Tornado Chain (out)\" Ability { id: \"758E\", source: \"Barbariccia\" }\r\n442.7 \"Tornado Chain (in)\" Ability { id: \"758F\", source: \"Barbariccia\" }\r\n446.3 \"Knuckle Drum\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n459.7 \"Brutal Rush 1\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n461.3 \"Brutal Rush 2\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n462.9 \"Brutal Rush 3\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n464.6 \"Brutal Rush 4\" Ability { id: \"75C7\", source: \"Barbariccia\" }\r\n467.4 \"Winding Gale\" Ability { id: \"75CA\", source: \"Barbariccia\" }\r\n470.9 \"Brush with Death\" Ability { id: \"75A5\", source: \"Barbariccia\" }\r\n486.8 \"Deadly Twist\" Ability { id: \"75DC\", source: \"Barbariccia\" }\r\n492.9 \"Boulder Break\" Ability { id: \"73CF\", source: \"Barbariccia\" }\r\n493.0 \"Knuckle Drum\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n515.1 \"Trample\" Ability { id: \"75DA\", source: \"Barbariccia\" }\r\n515.2 \"Bold Boulder\" Ability { id: \"75D6\", source: \"Barbariccia\" }\r\n518.2 \"--sync--\" Ability { id: \"7582\", source: \"Barbariccia\" }\r\n519.3 \"Brush with Death\" Ability { id: \"75A5\", source: \"Barbariccia\" }\r\n522.4 \"Tornado Chain (out)\" Ability { id: \"758E\", source: \"Barbariccia\" }\r\n525.0 \"Tornado Chain (in)\" Ability { id: \"758F\", source: \"Barbariccia\" }\r\n528.6 \"Knuckle Drum\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n530.1 \"Hair Spray\" Ability { id: \"75DB\", source: \"Barbariccia\" }\r\n542.0 \"Brutal Rush 1\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n543.6 \"Brutal Rush 2\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n545.4 \"Brutal Rush 3\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n547.2 \"Brutal Rush 4\" Ability { id: \"75C7\", source: \"Barbariccia\" }\r\n548.8 \"Blow Away\" Ability { id: \"7595\", source: \"Barbariccia\" }\r\n552.5 \"Brutal Rush 1\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n554.3 \"Brutal Rush 2\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n556.0 \"Brutal Rush 3\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n557.6 \"Brutal Rush 4\" Ability { id: \"75C7\", source: \"Barbariccia\" }\r\n559.2 \"--sync--\" Ability { id: \"7582\", source: \"Barbariccia\" }\r\n560.3 \"Teasing Tangles\" Ability { id: \"75DF\", source: \"Barbariccia\" }\r\n561.1 \"Fetters\" Ability { id: \"75B0\", source: \"Barbariccia\" }\r\n562.6 \"--sync--\" Ability { id: \"75AC\", source: \"Barbariccia\" }\r\n565.9 \"Tornado Chain (out)\" Ability { id: \"758E\", source: \"Barbariccia\" }\r\n568.5 \"Tornado Chain (in)\" Ability { id: \"758F\", source: \"Barbariccia\" }\r\n571.6 \"--sync--\" Ability { id: \"7380\", source: \"Barbariccia\" }\r\n573.1 \"Touchdown\" Ability { id: \"746D\", source: \"Barbariccia\" }\r\n575.3 \"--sync--\" Ability { id: \"7582\", source: \"Barbariccia\" }\r\n581.4 \"Boulder Break\" Ability { id: \"73CF\", source: \"Barbariccia\" }\r\n581.5 \"Knuckle Drum\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n594.7 \"Brutal Rush 1\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n596.4 \"Brutal Rush 2\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n598.0 \"Brutal Rush 3\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n599.6 \"Brutal Rush 4\" Ability { id: \"75C7\", source: \"Barbariccia\" }\r\n602.1 \"Impact\" Ability { id: \"75D8\", source: \"Barbariccia\" }\r\n604.3 \"Dry Blows\" Ability { id: \"7593\", source: \"Barbariccia\" }\r\n609.9 \"Brutal Rush 1\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n611.6 \"Brutal Rush 2\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n613.4 \"Brutal Rush 3\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n615.2 \"Brutal Rush 4\" Ability { id: \"75C7\", source: \"Barbariccia\" }\r\n617.8 \"Teasing Tangles\" Ability { id: \"75DF\", source: \"Barbariccia\" }\r\n618.6 \"Fetters\" Ability { id: \"75B0\", source: \"Barbariccia\" }\r\n620.9 \"--sync--\" Ability { id: \"7582\", source: \"Barbariccia\" }\r\n625.6 \"Knuckle Drum\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n637.7 \"Tornado Chain (out)\" Ability { id: \"758E\", source: \"Barbariccia\" }\r\n640.3 \"Tornado Chain (in)\" Ability { id: \"758F\", source: \"Barbariccia\" }\r\n643.9 \"Knuckle Drum\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n657.3 \"Brutal Rush 1\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n659.0 \"Brutal Rush 2\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n660.6 \"Brutal Rush 3\" #Ability { id: \"75C6\", source: \"Barbariccia\" }\r\n662.3 \"Brutal Rush 4\" Ability { id: \"75C7\", source: \"Barbariccia\" }\r\n663.9 \"--sync--\" Ability { id: \"7582\", source: \"Barbariccia\" }\r\n665.1 \"Winding Gale\" Ability { id: \"75CA\", source: \"Barbariccia\" }\r\n668.6 \"Brush with Death\" Ability { id: \"75A5\", source: \"Barbariccia\" }\r\n684.5 \"Deadly Twist\" Ability { id: \"75DC\", source: \"Barbariccia\" }\r\n690.6 \"Boulder Break\" Ability { id: \"73CF\", source: \"Barbariccia\" }\r\n690.7 \"Knuckle Drum\" Ability { id: \"7597\", source: \"Barbariccia\" }\r\n712.7 \"Trample\" Ability { id: \"75DA\", source: \"Barbariccia\" } window 10,10 jump 317.8\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/endsinger-ex.ts







// TODO: in the four planets section, earlier/combined callout of where the third planet is

const echoesOutputStrings = {
  stack: outputs/* default.stackOnYou */.Z.stackOnYou,
  donut: {
    en: 'Stack Donut',
    de: 'Sammeln Donut',
    fr: 'Packez-vous, donut',
    ja: '頭割り',
    cn: '集合放月环',
    ko: '도넛 장판, 쉐어'
  },
  spread: outputs/* default.spread */.Z.spread,
  flare: {
    en: 'Flare',
    de: 'Flare',
    fr: 'Brasier',
    ja: 'フレア',
    cn: '核爆',
    ko: '플레어'
  }
};
const headDir = {
  ne: 1,
  se: 3,
  sw: 5,
  nw: 7,
  none: 0
};
const endsinger_ex_orbOutputStrings = {
  ne: outputs/* default.dirNE */.Z.dirNE,
  nw: outputs/* default.dirNW */.Z.dirNW,
  se: outputs/* default.dirSE */.Z.dirSE,
  sw: outputs/* default.dirSW */.Z.dirSW,
  n: outputs/* default.dirN */.Z.dirN,
  e: outputs/* default.dirE */.Z.dirE,
  s: outputs/* default.dirS */.Z.dirS,
  w: outputs/* default.dirW */.Z.dirW,
  knockback: {
    en: '${dir} Knockback',
    de: '${dir} Rückstoß',
    fr: 'Poussée ${dir}',
    ja: '${dir} ノックバック',
    cn: '${dir} 击退',
    ko: '${dir} 넉백'
  },
  knockbackWithHead: {
    en: '${dir1} Knockback -> ${dir2}',
    de: '${dir1} Rückstoß -> ${dir2}',
    fr: 'Poussée ${dir1} -> ${dir2}',
    ja: '${dir1} ノックバック -> ${dir2}',
    cn: '${dir1} 击退 -> ${dir2}',
    ko: '${dir1} 넉백 -> ${dir2}'
  },
  aoeWithHead: {
    en: 'Go ${dir1} (lean ${dir2})',
    de: 'Geh ${dir1} (nach ${dir2} bewegen)',
    fr: 'Allez ${dir1} (côté ${dir2})',
    ja: '${dir1}方に (そっと${dir2}方へ)',
    cn: '去${dir1} (偏${dir2})',
    ko: '${dir1}쪽으로 (살짝 ${dir2}쪽으로)'
  }
};
const get5HeadSafeDir = (posX, posY, output) => {
  // NOTE: in both this function and the other safe dir, it's probably not possible to have the head facing
  // exactly where the knockback destination / aoe safe zone is.  For completionism, we'll add some
  // instruction but this probably can't happen.

  if (posX < 100) {
    if (posY < 100) return output.nw();
    return output.sw();
  }
  if (posY < 100) return output.ne();
  return output.se();
};
const getKBOrbSafeDir = (posX, posY, output, head8Dir) => {
  if (head8Dir === undefined || head8Dir % 2 === 0) head8Dir = headDir.none;

  // NOTE: in both this function and the other safe dir, it's probably not possible to have the head facing
  // exactly where the knockback destination / aoe safe zone is.  For completionism, we'll add some
  // instruction but this probably can't happen.  Additionally, since "SW", "S", and "SE" are not really
  // melee uptime friendly, try to call "W", "N", and "E" as the head safe spots.

  if (posX < 100) {
    if (posY < 100) {
      const mainDir = output.nw();
      return {
        [headDir.none]: output.knockback({
          dir: mainDir
        }),
        [headDir.ne]: output.knockbackWithHead({
          dir1: mainDir,
          dir2: output.s()
        }),
        [headDir.se]: output.knockbackWithHead({
          dir1: mainDir,
          dir2: output.w()
        }),
        [headDir.sw]: output.knockbackWithHead({
          dir1: mainDir,
          dir2: output.e()
        }),
        [headDir.nw]: output.knockback({
          dir: mainDir
        })
      }[head8Dir];
    }
    const mainDir = output.sw();
    return {
      [headDir.none]: output.knockback({
        dir: mainDir
      }),
      [headDir.ne]: output.knockbackWithHead({
        dir1: mainDir,
        dir2: output.w()
      }),
      [headDir.se]: output.knockbackWithHead({
        dir1: mainDir,
        dir2: output.n()
      }),
      [headDir.sw]: output.knockback({
        dir: mainDir
      }),
      [headDir.nw]: output.knockbackWithHead({
        dir1: mainDir,
        dir2: output.e()
      })
    }[head8Dir];
  }
  if (posY < 100) {
    const mainDir = output.ne();
    return {
      [headDir.none]: output.knockback({
        dir: mainDir
      }),
      [headDir.ne]: output.knockback({
        dir: mainDir
      }),
      [headDir.se]: output.knockbackWithHead({
        dir1: mainDir,
        dir2: output.w()
      }),
      [headDir.sw]: output.knockbackWithHead({
        dir1: mainDir,
        dir2: output.e()
      }),
      [headDir.nw]: output.knockbackWithHead({
        dir1: mainDir,
        dir2: output.s()
      })
    }[head8Dir];
  }
  const mainDir = output.se();
  return {
    [headDir.none]: output.knockback({
      dir: mainDir
    }),
    [headDir.ne]: output.knockbackWithHead({
      dir1: mainDir,
      dir2: output.w()
    }),
    [headDir.se]: output.knockback({
      dir: mainDir
    }),
    [headDir.sw]: output.knockbackWithHead({
      dir1: mainDir,
      dir2: output.n()
    }),
    [headDir.nw]: output.knockbackWithHead({
      dir1: mainDir,
      dir2: output.e()
    })
  }[head8Dir];
};
const getAoEOrbSafeDir = (posX, posY, output, head8Dir) => {
  if (head8Dir === undefined || head8Dir % 2 === 0) head8Dir = headDir.none;
  if (posX < 100) {
    if (posY < 100) {
      const mainDir = output.se();
      return {
        [headDir.none]: mainDir,
        [headDir.ne]: output.aoeWithHead({
          dir1: mainDir,
          dir2: output.s()
        }),
        [headDir.se]: output.aoeWithHead({
          dir1: mainDir,
          dir2: output.w()
        }),
        [headDir.sw]: output.aoeWithHead({
          dir1: mainDir,
          dir2: output.e()
        }),
        [headDir.nw]: mainDir
      }[head8Dir];
    }
    const mainDir = output.ne();
    return {
      [headDir.none]: mainDir,
      [headDir.ne]: output.aoeWithHead({
        dir1: mainDir,
        dir2: output.w()
      }),
      [headDir.se]: output.aoeWithHead({
        dir1: mainDir,
        dir2: output.n()
      }),
      [headDir.sw]: mainDir,
      [headDir.nw]: output.aoeWithHead({
        dir1: mainDir,
        dir2: output.e()
      })
    }[head8Dir];
  }
  if (posY < 100) {
    const mainDir = output.sw();
    return {
      [headDir.none]: mainDir,
      [headDir.ne]: mainDir,
      [headDir.se]: output.aoeWithHead({
        dir1: mainDir,
        dir2: output.w()
      }),
      [headDir.sw]: output.aoeWithHead({
        dir1: mainDir,
        dir2: output.e()
      }),
      [headDir.nw]: output.aoeWithHead({
        dir1: mainDir,
        dir2: output.s()
      })
    }[head8Dir];
  }
  const mainDir = output.nw();
  return {
    [headDir.none]: mainDir,
    [headDir.ne]: output.aoeWithHead({
      dir1: mainDir,
      dir2: output.w()
    }),
    [headDir.se]: mainDir,
    [headDir.sw]: output.aoeWithHead({
      dir1: mainDir,
      dir2: output.n()
    }),
    [headDir.nw]: output.aoeWithHead({
      dir1: mainDir,
      dir2: output.e()
    })
  }[head8Dir];
};
const getStarPositionFromHeading = heading => {
  const dir = util/* Directions.hdgTo8DirNum */.N.hdgTo8DirNum(parseFloat(heading));
  return {
    1: [114, 86],
    //  NE
    3: [114, 114],
    // SE
    5: [86, 114],
    //  SW
    7: [86, 86] //  NW
  }[dir] ?? [];
};
const getStarText = (head8Dir, matches, output) => {
  let posX;
  let posY;

  // Some 6FFA/6FFB (single) stars are at the correct position with no heading, others are center with a heading.
  // Of the 122 single star lines, I have:
  // 31 lines that are middle with a heading
  // 91 lines that are correct position, heading = 0
  // All other stars are center with a heading. This holds true for all 294 log lines I have for this event.
  if (Math.round(parseFloat(matches.heading)) !== 0) {
    [posX, posY] = getStarPositionFromHeading(matches.heading);
  } else {
    posX = parseFloat(matches.x);
    posY = parseFloat(matches.y);
  }
  if (posX === undefined || posY === undefined) {
    console.error(`EndsingerEx getStarText: Could not resolve star position from heading ${JSON.stringify(matches)}`);
    return;
  }
  if (['6FF9', '6FFB', '7000', '7001'].includes(matches.id)) return getKBOrbSafeDir(posX, posY, output, head8Dir);
  if (['6FF8', '6FFA', '6FFE', '6FFF'].includes(matches.id)) return getAoEOrbSafeDir(posX, posY, output, head8Dir);
  console.error(`EndsingerEx getStarText: Could not match ability ID ${matches.id} to color`);
  return;
};
const elenchosComboMap = {
  1: 'towers',
  2: 'solo',
  3: 'stacks',
  4: 'solo',
  5: 'solo',
  6: 'towers',
  7: 'stacks',
  8: 'solo'
};
const endsinger_ex_triggerSet = {
  id: 'TheMinstrelsBalladEndsingersAria',
  zoneId: zone_id/* default.TheMinstrelsBalladEndsingersAria */.Z.TheMinstrelsBalladEndsingersAria,
  timelineFile: 'endsinger-ex.txt',
  initData: () => {
    return {
      combatantData: [],
      starMechanicCounter: 0,
      storedStars: {},
      storedHeads: {},
      rewindHeads: {},
      storedMechs: {
        counter: 1
      },
      elenchosCount: 0
    };
  },
  triggers: [
  // Fire this trigger on ability since actual damage is 5s after cast bar finishes
  {
    id: 'EndsingerEx Elegeia',
    type: 'Ability',
    netRegex: {
      id: '6FF6',
      source: 'The Endsinger',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'EndsingerEx Telos',
    type: 'StartsUsing',
    netRegex: {
      id: '702E',
      source: 'The Endsinger',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'EndsingerEx Telomania',
    // This is a long series of small aoes and one big aoe with bleed.
    // The big aoe is ~10s after the ability goes off so delay call here.
    type: 'Ability',
    netRegex: {
      id: '72C3',
      source: 'The Endsinger',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'EndsingerEx Elenchos Middle',
    type: 'StartsUsing',
    netRegex: {
      id: '7022',
      source: 'The Endsinger',
      capture: false
    },
    preRun: data => data.elenchosCount++,
    durationSeconds: 5,
    alertText: (data, _matches, output) => {
      const combo = elenchosComboMap[data.elenchosCount];
      if (combo === undefined || combo === 'solo') return output.sides();
      if (combo === 'towers') return output.sidesWithTower();
      return output.sidesWithStacks();
    },
    outputStrings: {
      sides: {
        en: 'Out (Sides)',
        de: 'Raus (Seiten)',
        fr: 'Extérieur (Côtés)',
        ja: '外 (横へ)',
        cn: '去外面 (两边)',
        ko: '밖으로 (양 옆)'
      },
      sidesWithTower: {
        en: 'Tower + Outside',
        de: 'Turm + Außerhalb',
        fr: 'Tour + Extérieur',
        ja: '塔踏み + 外側',
        cn: '踩塔 + 去外面',
        ko: '기둥 + 양 옆'
      },
      sidesWithStacks: {
        en: 'Outside + Healer Groups',
        de: 'Außerhalb + Heiler-Gruppen',
        fr: 'Extérieur + Groupes sur les heals',
        ja: '外側 + ヒーラと4:4頭割り',
        cn: '去外面 + 治疗分组分摊',
        ko: '양 옆 + 힐러 그룹'
      }
    }
  }, {
    id: 'EndsingerEx Elenchos Outsides',
    type: 'StartsUsing',
    netRegex: {
      id: '7020',
      source: 'The Endsinger',
      capture: false
    },
    preRun: data => data.elenchosCount++,
    durationSeconds: 5,
    alertText: (data, _matches, output) => {
      const combo = elenchosComboMap[data.elenchosCount];
      if (combo === undefined || combo === 'solo') return output.middle();
      if (combo === 'towers') return output.middleWithTower();
      return output.middleWithStacks();
    },
    outputStrings: {
      middle: {
        en: 'Inside (Middle)',
        de: 'Innen (Mitte)',
        fr: 'Intérieur (Milieu)',
        ja: '中へ (真ん中)',
        cn: '去里面 (中间)',
        ko: '안으로 (가운데)'
      },
      middleWithTower: {
        en: 'Tower + Inside',
        de: 'Turm + Innen',
        fr: 'Tour + Intérieur',
        ja: '塔踏み + 内側',
        cn: '踩塔 + 去里面',
        ko: '기둥 + 안으로'
      },
      middleWithStacks: {
        en: 'Inside + Healer Groups',
        de: 'Innen + Heiler-Gruppen',
        fr: 'Intérieur + Groupes sur les heals',
        ja: '内側 + ヒーラと4:4頭割り',
        cn: '去里面 + 治疗分组分摊',
        ko: '안으로 + 힐러 그룹'
      }
    }
  }, {
    id: 'EndsingerEx Hubris',
    type: 'StartsUsing',
    netRegex: {
      id: '702C',
      source: 'The Endsinger',
      capture: true
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave('alert')
  }, {
    id: 'EndsingerEx Diairesis Head Spawn',
    type: 'GainsEffect',
    // This appears to happen ~6s before cast starts.
    // It is also the same id the whole fight, so don't bother resetting.
    netRegex: {
      effectId: '891',
      count: '187',
      capture: true
    },
    run: (data, matches) => data.diairesisId = matches.targetId
  }, {
    id: 'EndsingerEx Single Star',
    type: 'StartsUsing',
    // Each single star is also paired with a head in the middle doing a 180 cleave in some direction.
    // The head is already in place by the time this cast starts.
    netRegex: {
      id: ['6FFA', '6FFB']
    },
    durationSeconds: 6,
    promise: async data => {
      data.combatantData = [];
      if (data.diairesisId === undefined) return;
      const decimalIds = [data.diairesisId].map(x => parseInt(x, 16));
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: decimalIds
      })).combatants;
    },
    alertText: (data, matches, output) => {
      const simpleOutput = getStarText(undefined, matches, output);
      const [head] = data.combatantData;
      if (data.combatantData.length !== 1 || head === undefined) return simpleOutput;

      // Head should be facing intercardinalish.
      const rawHead8Dir = util/* Directions.hdgTo8DirNum */.N.hdgTo8DirNum(head.Heading);
      const head8Dir = rawHead8Dir % 2 === 0 ? undefined : rawHead8Dir;
      return getStarText(head8Dir, matches, output);
    },
    outputStrings: endsinger_ex_orbOutputStrings
  }, {
    id: 'EndsingerEx Grip of Despair Cast',
    type: 'StartsUsing',
    netRegex: {
      id: '701D',
      source: 'The Endsinger',
      capture: false
    },
    response: responses/* Responses.stackMiddle */.n3.stackMiddle()
  }, {
    id: 'EndsingerEx Grip of Despair Chains',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'BB1'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.breakChains */.n3.breakChains('alert')
  }, {
    id: 'EndsingerEx Eironeia',
    type: 'StartsUsing',
    netRegex: {
      id: ['702F', '7030'],
      source: 'The Endsinger',
      capture: false
    },
    suppressSeconds: 4,
    infoText: (data, _matches, output) => {
      // This is combined with the Elenchos call so suppress here.
      const combo = elenchosComboMap[data.elenchosCount];
      if (combo === 'stacks') return;
      return output.groups();
    },
    outputStrings: {
      groups: {
        en: 'Healer Groups',
        de: 'Heiler-Gruppen',
        fr: 'Groupes sur les heals',
        ja: 'ヒラに頭割り',
        cn: '治疗分组分摊',
        ko: '힐러 그룹 쉐어'
      }
    }
  }, {
    id: 'EndsingerEx Star Order Resolver',
    type: 'Ability',
    netRegex: {
      id: ['6FFE', '6FFF', '7000', '7001']
    },
    delaySeconds: (data, matches) => {
      ++data.starMechanicCounter;
      switch (matches.id) {
        case '6FFE':
        case '7000':
          return 0;
        case '6FFF':
        case '7001':
          return 6.5;
      }
      return 0;
    },
    alertText: (_data, matches, output) => getStarText(undefined, matches, output),
    outputStrings: endsinger_ex_orbOutputStrings
  }, {
    id: 'EndsingerEx Star Cleanup',
    type: 'Ability',
    netRegex: {
      id: ['6FFE', '6FFF', '7000', '7001'],
      capture: false
    },
    delaySeconds: 30,
    run: data => {
      data.starMechanicCounter = 0;
    }
  }, {
    id: 'EndsingerEx Head Phase Detector',
    type: 'Ability',
    netRegex: {
      id: ['7007', '72B1']
    },
    run: (data, matches) => {
      switch (matches.id) {
        case '7007':
          data.headPhase = 5;
          break;
        case '72B1':
          data.headPhase = 6;
          break;
      }
    }
  }, {
    id: 'EndsingerEx Head Phase Cleanup',
    type: 'Ability',
    netRegex: {
      id: ['7007', '72B1'],
      capture: false
    },
    delaySeconds: 50,
    run: data => {
      data.headPhase = undefined;
    }
  }, {
    id: 'EndsingerEx 5Head Initial Direction',
    type: 'GainsEffect',
    netRegex: {
      effectId: '891',
      capture: true
    },
    condition: data => data.headPhase === 5,
    delaySeconds: 0.5,
    promise: async (data, matches) => {
      const headData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.targetId, 16)]
      });
      if (headData.combatants.length !== 1) {
        console.error(`5Head Initial Direction: null data`);
        return;
      }
      for (const head of headData.combatants) {
        const headId = head.ID?.toString(16).toUpperCase();
        if (headId === undefined) {
          console.error(`5Head Initial Direction: invalid head ID`);
          continue;
        }
        data.storedHeads[headId] = {
          state: head,
          mechanics: []
        };
      }
    },
    infoText: (data, matches, output) => {
      const headCombatant = data.storedHeads[matches.targetId];
      if (!headCombatant) {
        console.error(`5Head Collector: null data`);
        return;
      }

      // Snap heading to closest card and add 2 for opposite direction
      // N = 0, E = 1, S = 2, W = 3
      const cardinal = (util/* Directions.hdgTo4DirNum */.N.hdgTo4DirNum(headCombatant.state.Heading) + 2) % 4;
      const dirs = {
        0: output.north(),
        1: output.east(),
        2: output.south(),
        3: output.west()
      };
      return dirs[cardinal];
    },
    outputStrings: {
      unknown: outputs/* default.unknown */.Z.unknown,
      north: outputs/* default.north */.Z.north,
      east: outputs/* default.east */.Z.east,
      south: outputs/* default.south */.Z.south,
      west: outputs/* default.west */.Z.west
    }
  }, {
    id: 'EndsingerEx 5Head Mechanics Collector',
    type: 'StartsUsing',
    netRegex: {
      id: ['6FFC', '7006', '7009', '700A'],
      source: 'The Endsinger',
      capture: true
    },
    condition: data => data.headPhase === 5,
    // Do not need delaySeconds here, heads have been spawned for 5+ seconds
    promise: async (data, matches) => {
      // Early out if we already have this head
      if (data.storedHeads[matches.targetId]) return;
      const headData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.targetId, 16)]
      });
      if (headData.combatants.length !== 1) {
        console.error(`5Head Mechanics Collector: null data`);
        return;
      }
      for (const head of headData.combatants) {
        const headId = head.ID?.toString(16).toUpperCase();
        if (headId === undefined) {
          console.error(`5Head Mechanics Collector: invalid head ID`);
          continue;
        }
        data.storedHeads[headId] = {
          state: head,
          mechanics: []
        };
      }
    },
    infoText: (data, matches, output) => {
      const head = data.storedHeads[matches.sourceId];
      if (!head) {
        console.error(`5Head Mechanics Collector: null data/missing head`);
        return;
      }
      if (matches.id === '7009') {
        head.mechanics.push('aoe');
      } else if (matches.id === '700A') {
        head.mechanics.push('donut');
      } else {
        // Snap heading to closest card and add 2 for opposite direction
        const cardinal = (util/* Directions.hdgTo4DirNum */.N.hdgTo4DirNum(parseFloat(matches.heading)) + 2) % 4;
        const safeDir = {
          0: 'safeN',
          1: 'safeE',
          2: 'safeS',
          3: 'safeW'
        };
        head.mechanics.push(safeDir[cardinal] ?? 'unknown');
      }

      // If we have the same count of mechanics stored for all 5 heads, resolve safe spot
      const heads = Object.values(data.storedHeads);
      if (heads.length === heads.filter(h => h.mechanics.length === head.mechanics.length).length && heads.length === 5) {
        const lastMechanic = head.mechanics.length - 1;
        const safeDirHead = heads.find(h => h.mechanics[0]?.includes('safe'));
        const [donutHead1, donutHead2] = heads.filter(h => h.mechanics[lastMechanic] === 'donut');
        if (!safeDirHead || !donutHead1 || !donutHead2) {
          console.error(`5Head Mechanics Collector: Missing safe/donut head`);
          return;
        }
        switch (safeDirHead.mechanics[lastMechanic]) {
          case 'safeN':
            if (donutHead1.state.PosY < 100) return get5HeadSafeDir(donutHead1.state.PosX, donutHead1.state.PosY, output);
            return get5HeadSafeDir(donutHead2.state.PosX, donutHead2.state.PosY, output);
          case 'safeE':
            if (donutHead1.state.PosX > 100) return get5HeadSafeDir(donutHead1.state.PosX, donutHead1.state.PosY, output);
            return get5HeadSafeDir(donutHead2.state.PosX, donutHead2.state.PosY, output);
          case 'safeS':
            if (donutHead1.state.PosY > 100) return get5HeadSafeDir(donutHead1.state.PosX, donutHead1.state.PosY, output);
            return get5HeadSafeDir(donutHead2.state.PosX, donutHead2.state.PosY, output);
          case 'safeW':
            if (donutHead1.state.PosX < 100) return get5HeadSafeDir(donutHead1.state.PosX, donutHead1.state.PosY, output);
            return get5HeadSafeDir(donutHead2.state.PosX, donutHead2.state.PosY, output);
        }
      }
    },
    outputStrings: endsinger_ex_orbOutputStrings
  }, {
    id: 'EndsingerEx 5Head Mechanics Rewind Collector',
    type: 'GainsEffect',
    netRegex: {
      effectId: '808',
      target: 'The Endsinger',
      capture: true
    },
    condition: data => data.headPhase === 5,
    durationSeconds: 5,
    alertText: (data, matches, output) => {
      const head = data.storedHeads[matches.targetId];
      if (!head) {
        console.error(`5Head Mechanics Rewind Collector: null data`);
        return;
      }
      const mechanicIndex = {
        '178': 2,
        '179': 1,
        '17A': 0
      }[matches.count];
      const mechanic = head.mechanics[mechanicIndex ?? 0];
      if (mechanicIndex === undefined || !mechanic) {
        console.error(`5Head Mechanics Rewind Collector: no mapping for buff count`);
        return;
      }
      data.rewindHeads[matches.targetId] = {
        state: head.state,
        mechanic: mechanic
      };

      // If we have all 5 heads accounted for, resolve safe spot
      const heads = Object.values(data.rewindHeads);
      if (heads.length === 5) {
        const safeDirHead = heads.find(h => h.mechanic.includes('safe'));
        const donutHeads = heads.filter(h => h.mechanic === 'donut');

        // Clean up here for next iteration
        data.storedHeads = {};
        data.rewindHeads = {};
        if (!safeDirHead || donutHeads.length < 1) {
          console.error(`5Head Mechanics Rewind Collector: missing required head`);
          return;
        }
        let safeDonut;
        switch (safeDirHead.mechanic) {
          case 'safeN':
            safeDonut = donutHeads.find(head => head.state.PosY < 100);
            break;
          case 'safeE':
            safeDonut = donutHeads.find(head => head.state.PosX > 100);
            break;
          case 'safeS':
            safeDonut = donutHeads.find(head => head.state.PosY > 100);
            break;
          case 'safeW':
            safeDonut = donutHeads.find(head => head.state.PosX < 100);
            break;
        }
        if (!safeDonut) {
          console.error(`5Head Mechanics Rewind Collector: no safe donut found`);
          return;
        }
        return get5HeadSafeDir(safeDonut.state.PosX, safeDonut.state.PosY, output);
      }
    },
    outputStrings: endsinger_ex_orbOutputStrings
  }, {
    id: 'EndsingerEx 6 Head Collector',
    type: 'Tether',
    netRegex: {
      id: ['00BD', '00B5'],
      target: 'The Endsinger',
      capture: true
    },
    condition: data => data.headPhase === 6,
    delaySeconds: 0.5,
    promise: async (data, matches) => {
      const headData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.sourceId, 16)]
      });
      const headCombatant = headData.combatants[0];
      if (!headCombatant) {
        console.error(`6 Head Collector: null data`);
        return;
      }
      data.storedHeads[matches.sourceId] = {
        state: headCombatant,
        mechanics: []
      };
    },
    infoText: (data, _matches, output) => {
      const heads = Object.values(data.storedHeads);
      if (heads.length === 4) {
        data.storedHeads = {};
        let headPositions = ['e', 'ne', 'nw', 'w', 'se', 'sw'];
        for (const head of heads) {
          let dir = '';
          if (head.state.PosY < 100) dir = 'n';else if (head.state.PosY > 100) dir = 's';
          if (head.state.PosX < 100) dir += 'w';else dir += 'e';
          headPositions = headPositions.filter(pos => pos !== dir);
        }
        const dir1 = headPositions[0];
        const dir2 = headPositions[1];
        if (dir1 === undefined || dir2 === undefined) {
          console.error(`6 Head Collector: expected 2 safe heads`);
          return;
        }
        return output.text({
          dir1: output[dir1](),
          dir2: output[dir2]()
        });
      }
    },
    outputStrings: {
      e: outputs/* default.dirE */.Z.dirE,
      w: outputs/* default.dirW */.Z.dirW,
      nw: outputs/* default.dirNW */.Z.dirNW,
      ne: outputs/* default.dirNE */.Z.dirNE,
      sw: outputs/* default.dirSW */.Z.dirSW,
      se: outputs/* default.dirSE */.Z.dirSE,
      text: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        ja: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      }
    }
  }, {
    id: 'EndsingerEx Echoes of Benevolence',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'BB0'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 60,
    infoText: (data, _matches, output) => {
      data.storedMechs[data.storedMechs.counter] = 'stack';
      data.storedMechs.counter++;
      return output.stack();
    },
    outputStrings: {
      stack: echoesOutputStrings.stack
    }
  }, {
    id: 'EndsingerEx Echoes of Nausea',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'BAD'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 60,
    infoText: (data, _matches, output) => {
      data.storedMechs[data.storedMechs.counter] = 'donut';
      data.storedMechs.counter++;
      return output.donut();
    },
    outputStrings: {
      donut: echoesOutputStrings.donut
    }
  }, {
    id: 'EndsingerEx Echoes of the Future',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'BAF'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 60,
    infoText: (data, _matches, output) => {
      data.storedMechs[data.storedMechs.counter] = 'flare';
      data.storedMechs.counter++;
      return output.flare();
    },
    outputStrings: {
      flare: echoesOutputStrings.flare
    }
  }, {
    id: 'EndsingerEx Echoes of Befoulment',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'BAE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 60,
    infoText: (data, _matches, output) => {
      data.storedMechs[data.storedMechs.counter] = 'spread';
      data.storedMechs.counter++;
      return output.spread();
    },
    outputStrings: {
      spread: echoesOutputStrings.spread
    }
  }, {
    id: 'EndsingerEx Echoes Rewind',
    type: 'GainsEffect',
    netRegex: {
      effectId: '95D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (data, matches, output) => {
      const mechanicIndex = {
        '17C': 3,
        '17D': 2,
        '17E': 1
      }[matches.count];
      const mechanic = data.storedMechs[mechanicIndex ?? 1];
      if (mechanicIndex === undefined || !mechanic) {
        console.error(`5Head Mechanics Rewind Collector: no mapping for buff count`);
        return;
      }
      return output[mechanic]();
    },
    outputStrings: echoesOutputStrings
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Azure Star': 'blau(?:e|er|es|en) Himmelskörper',
      'Fiery Star': 'rot(?:e|er|es|en) Himmelskörper',
      'The Endsinger': 'Endsängerin'
    },
    'replaceText': {
      'Befoulment': 'Brackwasserbombe',
      'Benevolence': 'Philanthropie',
      'Despair Unforgotten': 'Verzweiflung der Chronistin',
      'Diairesis': 'Diairesis',
      'Eironeia': 'Eironeia',
      'Elegeia Unforgotten': 'Elegeia der Chronistin',
      'Elenchos': 'Elenchos',
      'Endsong\'s Aporrhoia': 'Aporia des Liedes vom Ende',
      'Endsong(?!\')': 'Lied vom Ende',
      '(?<! )Fatalism': 'Fatalismus',
      'Grip of Despair': 'Griff der Verzweiflung',
      'Hubris': 'Hybris',
      'Star Collision': 'Planeten Kollision',
      'Telomania': 'Telomanie',
      'Telos': 'Telos',
      'Tower Explosion': 'Turm Explosion',
      'Theological Fatalism': 'Theologischer Fatalismus',
      'Twinsong\'s Aporrhoia': 'Aporia der Verzweiflung',
      'Ultimate Fate': 'Ultimatives Schicksal'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Azure Star': 'Astre azuré',
      'Fiery Star': 'Astre incarnat',
      'The Endsinger': 'Chantre de l\'anéantissement'
    },
    'replaceText': {
      'Befoulment': 'Bombe de pus',
      'Benevolence': 'Philanthropie',
      'Despair Unforgotten': 'Chronique tourmentante',
      'Diairesis': 'Diérèse',
      'Eironeia': 'Ironie',
      'Elegeia Unforgotten': 'Chronique élégiaque',
      'Elenchos': 'Élenchos',
      'Endsong\'s Aporrhoia': 'Antienne aporétique',
      'Endsong(?!\')': 'Ultime antienne',
      '(?<! )Fatalism(?!e)': 'Fatalisme',
      'Grip of Despair': 'Chaînes du désespoir',
      'Hubris': 'Hubris',
      'Star Collision': 'Collision d\'étoile',
      'Telomania': 'Télomanie',
      'Telos': 'Télos',
      'Tower Explosion': 'Explosion de tour',
      'Theological Fatalism': 'Fatalisme théologique',
      'Twinsong\'s Aporrhoia': 'Chœur aporétique',
      'Ultimate Fate': 'Ultime destin'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Azure Star': '青色天体',
      'Fiery Star': '赤色天体',
      'The Endsinger': '終焉を謳うもの'
    },
    'replaceText': {
      'Befoulment': '膿汁弾',
      'Benevolence': '博愛',
      'Despair Unforgotten': '絶望浸食：事象記録',
      'Diairesis': 'ディアイレシス',
      'Eironeia': 'エイロネイア',
      'Elegeia Unforgotten': 'エレゲイア：事象記録',
      'Elenchos': 'エレンコス',
      'Endsong\'s Aporrhoia': 'アポロイア：絶望輪唱',
      'Endsong(?!\')': '絶望輪唱',
      '(?<! )Fatalism': 'フェイタリズム',
      'Grip of Despair': '絶望の鎖',
      'Hubris': 'ヒュブリス',
      'Telomania': 'テロスマニア',
      'Telos': 'テロス',
      'Theological Fatalism': 'セオロジカル・フェイタリズム',
      'Twinsong\'s Aporrhoia': 'アポロイア：絶望合唱',
      'Ultimate Fate': 'ウルティマフェイト'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Azure Star': '蓝色天体',
      'Fiery Star': '红色天体',
      'The Endsinger': '讴歌终结之物'
    },
    'replaceText': {
      'Befoulment': '脓液弹',
      'Benevolence': '博爱',
      'Despair Unforgotten': '绝望侵蚀：记录事件',
      'Diairesis': '分离',
      'Eironeia': '反讽',
      'Elegeia Unforgotten': '哀歌：记录事件',
      'Elenchos': '反诘',
      'Endsong\'s Aporrhoia': '流溢：绝望轮唱',
      'Endsong(?!\')': '绝望轮唱',
      '(?<! )Fatalism': '宿命',
      'Grip of Despair': '绝望的锁链',
      'Hubris': '傲慢',
      'Star Collision': '天体撞击',
      'Telomania': '终末狂热',
      'Telos': '终末',
      'Tower Explosion': '塔爆炸',
      'Theological Fatalism': '神学宿命',
      'Twinsong\'s Aporrhoia': '流溢：绝望合唱',
      'Ultimate Fate': '终极命运'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Azure Star': '청색천체',
      'Fiery Star': '적색천체',
      'The Endsinger': '종언을 노래하는 자'
    },
    'replaceText': {
      '\\(big\\)': '(강)',
      '\\(cast\\)': '(시전)',
      '\\(small\\)': '(약)',
      'Befoulment': '고름탄',
      'Benevolence': '박애',
      'Despair Unforgotten': '절망 침식: 현상 기록',
      'Diairesis': '디아이레시스',
      'Eironeia': '에이로네이아',
      'Elegeia Unforgotten': '엘레게이아: 현상 기록',
      'Elenchos': '엘렝코스',
      'Endsong\'s Aporrhoia': '발출: 절망 돌림노래',
      'Endsong(?!\')': '절망 돌림노래',
      '(?<! )Fatalism': '운명론',
      'Grip of Despair': '절망의 사슬',
      'Hubris': '휴브리스',
      'Star Collision': '천체 충돌',
      'Telomania': '텔로스마니아',
      'Telos': '텔로스',
      'Tower Explosion': '기둥 폭발',
      'Theological Fatalism': '신학적 운명론',
      'Twinsong\'s Aporrhoia': '발출: 절망 합창',
      'Ultimate Fate': '종언의 운명'
    }
  }]
};
/* harmony default export */ const endsinger_ex = (endsinger_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/endsinger-ex.txt
const trial_endsinger_ex_namespaceObject = "# Endsinger Extreme\r\n# -it 'The Endsinger'\r\n# -oc 'The Endsinger' 'Kakodaimon'\r\n# -ii 6FF5 6FF7 6FF8 6FF9 6FFE 6FFF 7000 7001 7003 7005 7008 700C 700D 7009 700A 700E 700F 7010 7011 7013 7015 7017 7018 7019 7019 7021 7029 702B 702D 72C4\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.0 \"--sync--\" StartsUsing { id: \"6FF6\", source: \"The Endsinger\" } window 10,10\r\n11.7 \"Elegeia Unforgotten\" Ability { id: \"6FF6\", source: \"The Endsinger\" }\r\n25.1 \"Star Collision\" Ability { id: \"6FF[AB]\", source: [\"Fiery Star\", \"Azure Star\"] }\r\n26.7 \"Diairesis\" Ability { id: \"6FFC\", source: \"The Endsinger\" }\r\n29.9 \"Elegeia Unforgotten\" Ability { id: \"6FF6\", source: \"The Endsinger\" }\r\n43.3 \"Star Collision\" Ability { id: \"6FF[AB]\", source: [\"Fiery Star\", \"Azure Star\"] }\r\n44.9 \"Diairesis\" Ability { id: \"6FFC\", source: \"The Endsinger\" }\r\n55.3 \"Grip of Despair\" Ability { id: \"701D\", source: \"The Endsinger\" }\r\n\r\n# Towers 1\r\n64.6 \"Tower Explosion\" #Ability { id: \"702A\", source: \"The Endsinger\" }\r\n65.4 \"Elenchos\" Ability { id: \"702[02]\", source: \"The Endsinger\" }\r\n74.5 \"Telos\" Ability { id: \"702E\", source: \"The Endsinger\" }\r\n84.6 \"Hubris\" Ability { id: \"702C\", source: \"The Endsinger\" }\r\n96.8 \"Elegeia Unforgotten\" Ability { id: \"6FF6\", source: \"The Endsinger\" }\r\n110.2 \"Star Collision\" Ability { id: \"6FF[AB]\", source: [\"Fiery Star\", \"Azure Star\"] }\r\n111.8 \"Diairesis\" Ability { id: \"6FFC\", source: \"The Endsinger\" }\r\n114.1 \"Eironeia\" Ability { id: \"702F\", source: \"The Endsinger\" }\r\n122.3 \"Fatalism\" Ability { id: \"6FFD\", source: \"The Endsinger\" }\r\n132.6 \"Star Collision 1\" Ability { id: \"700[24]\", source: [\"Fiery Star\", \"Azure Star\"] }\r\n139.1 \"Star Collision 2\" Ability { id: \"700[24]\", source: [\"Fiery Star\", \"Azure Star\"] }\r\n145.4 \"Elenchos\" Ability { id: \"702[02]\", source: \"The Endsinger\" }\r\n\r\n# 5Head 1\r\n154.6 \"Twinsong's Aporrhoia\" Ability { id: \"7007\", source: \"The Endsinger\" }\r\n165.7 \"Diairesis 1\" Ability { id: \"7006\", source: \"The Endsinger\" }\r\n174.8 \"Diairesis 2\" Ability { id: \"7006\", source: \"The Endsinger\" }\r\n183.9 \"Diairesis 3\" Ability { id: \"6FFC\", source: \"The Endsinger\" }\r\n192.0 \"Theological Fatalism\" Ability { id: \"700B\", source: \"The Endsinger\" }\r\n205.2 \"Elenchos\" Ability { id: \"702[02]\", source: \"The Endsinger\" }\r\n205.2 \"Eironeia\" Ability { id: \"702F\", source: \"The Endsinger\" }\r\n214.4 \"Hubris\" Ability { id: \"702C\", source: \"The Endsinger\" }\r\n\r\n# Stack/Flare/Donut/Spread\r\n224.6 \"Despair Unforgotten\" Ability { id: \"7012\", source: \"The Endsinger\" }\r\n232.1 \"Benevolence\" Ability { id: \"7016\", source: \"The Endsinger\" }\r\n237.8 \"Despair Unforgotten\" Ability { id: \"7012\", source: \"The Endsinger\" }\r\n245.3 \"Befoulment\" Ability { id: \"7014\", source: \"The Endsinger\" }\r\n250.0 \"Elenchos\" Ability { id: \"702[02]\", source: \"The Endsinger\" }\r\n258.1 \"Despair Unforgotten\" Ability { id: \"7012\", source: \"The Endsinger\" }\r\n265.6 \"Benevolence\" Ability { id: \"7016\", source: \"The Endsinger\" }\r\n272.3 \"Theological Fatalism\" Ability { id: \"700B\", source: \"The Endsinger\" }\r\n282.5 \"Benevolence\" Ability { id: \"701A\", source: \"The Endsinger\" }\r\n\r\n289.5 \"Telomania (cast)\" Ability { id: \"72C3\", source: \"The Endsinger\" }\r\n291.4 \"Telomania (small) x4\" duration 5 #Ability { id: \"665F\", source: \"The Endsinger\" }\r\n299.7 \"Telomania (big)\" Ability { id: \"72C5\", source: \"The Endsinger\" }\r\n\r\n# 6 Head Dodges 1\r\n313.6 \"Endsong's Aporrhoia\" Ability { id: \"72B1\", source: \"The Endsinger\" }\r\n321.8 \"Endsong 1\" Ability { id: \"701B\", source: \"The Endsinger\" }\r\n332.3 \"Endsong 2\" Ability { id: \"701C\", source: \"The Endsinger\" }\r\n341.4 \"Endsong 3\" Ability { id: \"701C\", source: \"The Endsinger\" }\r\n350.5 \"Endsong 4\" Ability { id: \"701C\", source: \"The Endsinger\" }\r\n354.0 \"Elenchos\" Ability { id: \"702[02]\", source: \"The Endsinger\" }\r\n363.1 \"Telos\" Ability { id: \"702E\", source: \"The Endsinger\" }\r\n373.2 \"Hubris\" Ability { id: \"702C\", source: \"The Endsinger\" }\r\n387.4 \"Elegeia Unforgotten\" Ability { id: \"6FF6\", source: \"The Endsinger\" }\r\n400.8 \"Star Collision\" Ability { id: \"6FF[AB]\", source: [\"Fiery Star\", \"Azure Star\"] }\r\n402.4 \"Diairesis\" Ability { id: \"6FFC\", source: \"The Endsinger\" }\r\n404.7 \"Eironeia\" Ability { id: \"702F\", source: \"The Endsinger\" }\r\n410.8 \"Fatalism\" Ability { id: \"6FFD\", source: \"The Endsinger\" }\r\n420.9 \"Fatalism\" Ability { id: \"6FFD\", source: \"The Endsinger\" }\r\n\r\n# Four Planets 1\r\n421.1 \"Star Collision 1\" Ability { id: \"700[24]\", source: [\"Fiery Star\", \"Azure Star\"] }\r\n427.6 \"Star Collision 2\" Ability { id: \"700[24]\", source: [\"Fiery Star\", \"Azure Star\"] }\r\n431.2 \"Star Collision 3\" Ability { id: \"700[24]\", source: [\"Fiery Star\", \"Azure Star\"] }\r\n437.7 \"Star Collision 4\" Ability { id: \"700[24]\", source: [\"Fiery Star\", \"Azure Star\"] }\r\n\r\n# Towers 2\r\n446.5 \"Tower Explosion\" #Ability { id: \"702A\", source: \"The Endsinger\" }\r\n447.2 \"Elenchos\" Ability { id: \"702[02]\", source: \"The Endsinger\" } window 5,5\r\n456.3 \"Telomania (cast)\" Ability { id: \"72C3\", source: \"The Endsinger\" }\r\n458.2 \"Telomania (small) x4\" duration 5 #Ability { id: \"665F\", source: \"The Endsinger\" }\r\n466.5 \"Telomania (big)\" Ability { id: \"72C5\", source: \"The Endsinger\" }\r\n\r\n# 5Head 2\r\n480.5 \"Twinsong's Aporrhoia\" Ability { id: \"7007\", source: \"The Endsinger\" }\r\n491.6 \"Diairesis 1\" Ability { id: \"7006\", source: \"The Endsinger\" }\r\n500.7 \"Diairesis 2\" Ability { id: \"7006\", source: \"The Endsinger\" }\r\n509.9 \"Diairesis 3\" Ability { id: \"6FFC\", source: \"The Endsinger\" }\r\n518.0 \"Theological Fatalism\" Ability { id: \"700B\", source: \"The Endsinger\" }\r\n531.1 \"Elenchos\" Ability { id: \"702[02]\", source: \"The Endsinger\" }\r\n531.1 \"Eironeia\" Ability { id: \"702F\", source: \"The Endsinger\" }\r\n540.2 \"Hubris\" Ability { id: \"702C\", source: \"The Endsinger\" }\r\n\r\n# 6 Head Dodges 2\r\n550.4 \"Endsong's Aporrhoia\" Ability { id: \"72B1\", source: \"The Endsinger\" }\r\n558.6 \"Endsong 1\" Ability { id: \"701B\", source: \"The Endsinger\" }\r\n569.1 \"Endsong 2\" Ability { id: \"701C\", source: \"The Endsinger\" }\r\n578.1 \"Endsong 3\" Ability { id: \"701C\", source: \"The Endsinger\" }\r\n587.1 \"Endsong 4\" Ability { id: \"701C\", source: \"The Endsinger\" }\r\n590.7 \"Elenchos\" Ability { id: \"702[02]\", source: \"The Endsinger\" }\r\n599.8 \"Telos\" Ability { id: \"702E\", source: \"The Endsinger\" }\r\n613.0 \"Fatalism\" Ability { id: \"6FFD\", source: \"The Endsinger\" }\r\n623.1 \"Fatalism\" Ability { id: \"6FFD\", source: \"The Endsinger\" }\r\n\r\n# Four Planets 2\r\n623.3 \"Star Collision 1\" Ability { id: \"700[24]\", source: [\"Fiery Star\", \"Azure Star\"] }\r\n629.8 \"Star Collision 2\" Ability { id: \"700[24]\", source: [\"Fiery Star\", \"Azure Star\"] }\r\n633.4 \"Star Collision 3\" Ability { id: \"700[24]\", source: [\"Fiery Star\", \"Azure Star\"] }\r\n639.9 \"Star Collision 4\" Ability { id: \"700[24]\", source: [\"Fiery Star\", \"Azure Star\"] }\r\n647.2 \"Telos\" Ability { id: \"702E\", source: \"The Endsinger\" }\r\n661.4 \"Fatalism\" Ability { id: \"7031\", source: \"The Endsinger\" }\r\n\r\n683.7 \"--untargetable--\"\r\n688.7 \"Ultimate Fate (enrage)\" Ability { id: \"7032\", source: \"The Endsinger\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/endsinger.ts






// @TODO:
// Interstellar - Test the timing more. Seems OK but the delaySeconds timing might be too tight depending on latency?
// Add phase triggers
// Final phase triggers
// Telomania - 4x small AoE followed by big AoE + bleed
const endsinger_orbOutputStrings = {
  ne: outputs/* default.northeast */.Z.northeast,
  nw: outputs/* default.northwest */.Z.northwest,
  se: outputs/* default.southeast */.Z.southeast,
  sw: outputs/* default.southwest */.Z.southwest
};
const getOrbSafeDir = (data, id, output) => {
  const starCombatant = data.storedStars[id];
  if (!starCombatant) {
    console.error(`Doomed Stars AoE: null data`);
    return;
  }
  if (starCombatant.PosX < 100) {
    if (starCombatant.PosY < 100) return output.se();
    return output.ne();
  }
  if (starCombatant.PosY < 100) return output.sw();
  return output.nw();
};
const endsinger_triggerSet = {
  id: 'TheFinalDay',
  zoneId: zone_id/* default.TheFinalDay */.Z.TheFinalDay,
  timelineFile: 'endsinger.txt',
  initData: () => {
    return {
      storedStars: {},
      phase: 1
    };
  },
  triggers: [{
    id: 'Endsinger Doomed Stars AoE',
    type: 'StartsUsing',
    netRegex: {
      id: ['662E', '6634'],
      source: 'Doomed Stars',
      capture: true
    },
    delaySeconds: 0.5,
    promise: async (data, matches) => {
      const starData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.sourceId, 16)]
      });
      const starCombatant = starData.combatants[0];
      if (!starCombatant) {
        console.error(`Doomed Stars AoE: null data`);
        return;
      }
      data.storedStars[matches.sourceId] = starCombatant;
    },
    alertText: (data, matches, output) => {
      return getOrbSafeDir(data, matches.sourceId, output);
    },
    outputStrings: endsinger_orbOutputStrings
  }, {
    id: 'Endsinger Elegeia',
    type: 'StartsUsing',
    netRegex: {
      id: ['662C', '6682'],
      source: 'The Endsinger',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Endsinger Doomed Stars Fatalism Tether',
    type: 'Tether',
    netRegex: {
      source: 'The Endsinger',
      id: '00A6'
    },
    delaySeconds: 10,
    alertText: (data, matches, output) => {
      return getOrbSafeDir(data, matches.targetId, output);
    },
    outputStrings: endsinger_orbOutputStrings
  }, {
    id: 'Endsinger Galaxias',
    type: 'StartsUsing',
    netRegex: {
      id: '6C69',
      source: 'The Endsinger',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'Endsinger Elenchos Middle',
    type: 'StartsUsing',
    netRegex: {
      id: '6644',
      source: 'The Endsinger',
      capture: false
    },
    response: responses/* Responses.goSides */.n3.goSides()
  }, {
    id: 'Endsinger Elenchos Outsides',
    type: 'StartsUsing',
    netRegex: {
      id: '6642',
      source: 'The Endsinger',
      capture: false
    },
    response: responses/* Responses.goMiddle */.n3.goMiddle()
  }, {
    id: 'Endsinger Death\'s Embrace',
    type: 'StartsUsing',
    netRegex: {
      id: '6649',
      source: 'The Endsinger',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Endsinger Death\'s Embrace Feathers',
    type: 'Ability',
    netRegex: {
      id: '6649',
      source: 'The Endsinger',
      capture: false
    },
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'Endsinger Death\'s Aporrhoia',
    type: 'StartsUsing',
    netRegex: {
      id: '663D',
      source: 'The Endsinger',
      capture: false
    },
    infoText: (_data, _matches, output) => {
      return output.avoidLasers();
    },
    outputStrings: {
      avoidLasers: {
        en: 'Avoid Head Lasers',
        de: 'Weiche den Kopflaser aus',
        fr: 'Évitez les lasers des têtes',
        ja: '顔の直線AoEを避ける',
        cn: '躲避头部激光',
        ko: '머리가 쏘는 레이저 피하기'
      }
    }
  }, {
    id: 'Endsinger Hubris',
    type: 'StartsUsing',
    netRegex: {
      id: '6652',
      source: 'The Endsinger',
      capture: true
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Endsinger Epigonoi',
    type: 'StartsUsing',
    netRegex: {
      id: '6646',
      source: 'The Endsinger',
      capture: true
    },
    condition: (_data, matches) => {
      // Find one head that's not dead center
      return parseFloat(matches.x) !== 100 || parseFloat(matches.y) !== 100;
    },
    suppressSeconds: 3,
    infoText: (_data, matches, output) => {
      // If it's cardinal, then intercardinal is safe
      if (parseFloat(matches.x) === 100 || parseFloat(matches.y) === 100) return output.intercardinal();
      return output.cardinal();
    },
    outputStrings: {
      cardinal: {
        en: 'Cardinal edge',
        de: 'Kardinaler Rand',
        fr: 'Au bord cardinal',
        ja: '東西南北の端へ',
        cn: '去四边',
        ko: '동서남북 끝으로'
      },
      intercardinal: {
        en: 'Intercardinal edge',
        de: 'Interkardinaler Rand',
        fr: 'Au bord intercardinal',
        ja: '斜めの端へ',
        cn: '去四角',
        ko: '대각선 끝으로'
      }
    }
  }, {
    id: 'Endsinger Interstellar Toggle',
    type: 'NameToggle',
    netRegex: {
      toggle: '00',
      name: 'The Endsinger',
      capture: true
    },
    condition: data => data.phase === 1,
    delaySeconds: 4,
    promise: async (data, matches) => {
      const bossData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.id, 16)]
      });
      const bossCombatant = bossData.combatants[0];
      if (!bossCombatant) {
        console.error(`Interstellar: null data`);
        return;
      }
      data.storedBoss = bossCombatant;
    },
    alertText: (data, _matches, output) => {
      const boss = data.storedBoss;
      if (!boss) return undefined;
      const x = boss.PosX;
      const y = boss.PosY;

      // Handle cardinals the easy way
      if (x === 100) {
        return output.direction({
          dir1: output.east(),
          dir2: output.west()
        });
      }
      if (y === 100) {
        return output.direction({
          dir1: output.north(),
          dir2: output.south()
        });
      }
      if (x < 100) {
        if (y < 100) {
          return output.direction({
            dir1: output.northeast(),
            dir2: output.southwest()
          });
        }
        return output.direction({
          dir1: output.northwest(),
          dir2: output.southeast()
        });
      }
      if (y < 100) {
        return output.direction({
          dir1: output.northwest(),
          dir2: output.southeast()
        });
      }
      return output.direction({
        dir1: output.northeast(),
        dir2: output.southwest()
      });
    },
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      northeast: outputs/* default.northeast */.Z.northeast,
      east: outputs/* default.east */.Z.east,
      southeast: outputs/* default.southeast */.Z.southeast,
      south: outputs/* default.south */.Z.south,
      southwest: outputs/* default.southwest */.Z.southwest,
      west: outputs/* default.west */.Z.west,
      northwest: outputs/* default.northwest */.Z.northwest,
      direction: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        ja: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      }
    }
  }, {
    id: 'Endsinger Planetes',
    type: 'StartsUsing',
    netRegex: {
      id: '6B58',
      source: 'The Endsinger',
      capture: false
    },
    run: data => data.phase = 2
  }, {
    id: 'Endsinger Nemesis',
    type: 'StartsUsing',
    netRegex: {
      id: '664E',
      source: 'The Endsinger',
      capture: true
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Endsinger Ultimate Fate',
    type: 'StartsUsing',
    netRegex: {
      id: '6B59',
      source: 'The Endsinger',
      capture: false
    },
    alarmText: (data, _matches, output) => {
      if (data.role === 'tank' || data.job === 'BLU') return output.text();
    },
    outputStrings: {
      text: {
        en: 'Tank LB NOW',
        de: 'JETZT Tank LB',
        fr: 'Transcendance Tank maintenant !',
        ja: '今タンクLB',
        cn: '坦克LB！',
        ko: '탱리밋'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Doomed Stars': 'Endzeitplanet',
      'Kakodaimon': 'Kakodæmon',
      'The Endsinger': 'Endsängerin',
      'oblivion': 'Chaosdimension'
    },
    'replaceText': {
      '\\(big\\)': '(groß)',
      '\\(cast\\)': '(Wirkung)',
      '\\(small\\)': '(klein)',
      'Aporrhoia': 'Aporia',
      'Crash': 'Impakt',
      'Dead Star': 'Planetenkollaps',
      'Death\'s Embrace': 'Umarmung des Todes',
      'Ekstasis': 'Ekstasis',
      'Elegeia(?! )': 'Elegeia',
      'Elegeia Unforgotten': 'Elegeia der Chronistin',
      'Elenchos': 'Elenchos',
      'Epigonoi': 'Epigonoi',
      'Fatalism': 'Fatalismus',
      'Galaxias': 'Galaxias',
      'Hubris': 'Hybris',
      'Interstellar': 'Sternes Gram',
      'Katastrophe': 'Katastrophe',
      'Meteor Outburst': 'Meteoreruption',
      'Meteor Radiant': 'Meteoritenschein',
      'Nemesis': 'Nemesis',
      'Planetes': 'Planetes',
      'Telomania': 'Telomanie',
      'Telos': 'Telos',
      'Ultimate Fate': 'Ultimatives Schicksal'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Doomed Stars': 'Planète À L\'Agonie',
      'Kakodaimon': 'cacodæmon',
      'The Endsinger': 'chantre de l\'anéantissement',
      'oblivion': 'Ruée chaotique'
    },
    'replaceText': {
      '\\(big\\)': '(gros)',
      '\\(cast\\)': '(lancement)',
      '\\(small\\)': '(petit)',
      'Aporrhoia': 'Aporie',
      'Crash': 'Collision',
      'Dead Star': 'Effondrement planétaire',
      'Death\'s Embrace': 'Étreinte de la mort',
      'Ekstasis': 'Extase',
      'Elegeia(?! )': 'Élégie',
      'Elegeia Unforgotten': 'Chronique élégiaque',
      'Elenchos': 'Élenchos',
      'Epigonoi': 'Épigonoï',
      'Fatalism': 'Fatalisme',
      'Galaxias': 'Galaxias',
      'Hubris': 'Hubris',
      'Interstellar': 'Danse des astres',
      'Katastrophe': 'Catastrophisme',
      'Meteor Outburst': 'Explosion météorique',
      'Meteor Radiant': 'Radiance météorique',
      'Nemesis': 'Némésis',
      'Planetes': 'Planétaire',
      'Telomania': 'Télomanie',
      'Telos': 'Télos',
      'Ultimate Fate': 'Ultime destin'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Doomed Stars': '終の星',
      'Kakodaimon': 'カコダイモーン',
      'The Endsinger': '終焉を謳うもの',
      'oblivion': 'カオティック・ディメンション'
    },
    'replaceText': {
      '\\(cast\\)': '(キャスト)',
      '\\(small\\)': '(小さい)',
      '\\(big\\)': '(大きい)',
      'Aporrhoia': 'アポロイア',
      'Crash': '衝突',
      'Dead Star': '惑星崩壊',
      'Death\'s Embrace': 'デスエンブレース',
      'Ekstasis': 'エクスタシス',
      'Elegeia(?! )': 'エレゲイア',
      'Elegeia Unforgotten': 'エレゲイア：事象記録',
      'Elenchos': 'エレンコス',
      'Epigonoi': 'エピノゴイ',
      'Fatalism': 'フェイタリズム',
      'Galaxias': 'ガラクシアス',
      'Hubris': 'ヒュブリス',
      'Interstellar': '星渡り',
      'Katastrophe': 'カタストロフ',
      'Meteor Outburst': 'メテオアウトバースト',
      'Meteor Radiant': 'メテオレディアント',
      'Nemesis': 'ネメシス',
      'Planetes': 'プラネテス',
      'Telomania': 'テロスマニア',
      'Telos': 'テロス',
      'Ultimate Fate': 'ウルティマフェイト'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Doomed Stars': '迈向终结的星球',
      'Kakodaimon': '恶灵魔',
      'The Endsinger': '讴歌终结之物',
      'oblivion': '混沌次元'
    },
    'replaceText': {
      '\\(big\\)': '(大)',
      '\\(cast\\)': '(投掷)',
      '\\(small\\)': '(小)',
      'Aporrhoia': '流溢',
      'Crash': '冲撞',
      'Dead Star': '坍缩星',
      'Death\'s Embrace': '死亡拥抱',
      'Ekstasis': '恍惚',
      'Elegeia(?! )': '哀歌',
      'Elegeia Unforgotten': '哀歌：记录事件',
      'Elenchos': '反诘',
      'Epigonoi': '后裔',
      'Fatalism': '宿命',
      'Galaxias': '银河',
      'Hubris': '傲慢',
      'Interstellar': '星际穿越',
      'Katastrophe': '灾祟',
      'Meteor Outburst': '陨石爆发',
      'Meteor Radiant': '陨石辐射点',
      'Nemesis': '复仇',
      'Planetes': '行迈之星',
      'Telomania': '终末狂热',
      'Telos': '终末',
      'Ultimate Fate': '终极命运'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Doomed Stars': '멸망한 별',
      'Kakodaimon': '카코다이몬',
      'The Endsinger': '종언을 노래하는 자',
      'oblivion': '혼돈의 차원'
    },
    'replaceText': {
      '\\(big\\)': '(강)',
      '\\(cast\\)': '(시전)',
      '\\(small\\)': '(약)',
      'Aporrhoia': '발출',
      'Crash': '충돌',
      'Dead Star': '행성 붕괴',
      'Death\'s Embrace': '죽음의 포옹',
      'Ekstasis': '엑스타시스',
      'Elegeia(?! )': '엘레게이아',
      'Elegeia Unforgotten': '엘레게이아: 현상 기록',
      'Elenchos': '엘렝코스',
      'Epigonoi': '에피고노이',
      'Fatalism': '운명론',
      'Galaxias': '은하',
      'Hubris': '휴브리스',
      'Interstellar': '성간이동',
      'Katastrophe': '참사',
      'Meteor Outburst': '유성 폭발',
      'Meteor Radiant': '유성우 방사',
      'Nemesis': '네메시스',
      'Planetes': '떠돌이별',
      'Telomania': '텔로스마니아',
      'Telos': '텔로스',
      'Ultimate Fate': '종언의 운명'
    }
  }]
};
/* harmony default export */ const endsinger = (endsinger_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/endsinger.txt
const trial_endsinger_namespaceObject = "# Endsinger Normal\r\n# -p \"662C:13.7\" \"6B58:1000\" \"6B5B:2000\"\r\n# -it 'The Endsinger' 'Kakodaimon'\r\n# -oc 'The Endsinger' 'Kakodaimon'\r\n# -ii 6281 6C61 6660 6661 6C6A 664B 6653 6643 67FA 6642 6648 67FB 6655\r\n\r\n# Not sure if/where P1 loops. Might be a two-part loop,\r\n# death => hubris is one pattern, and death => elenchos is the other?\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n# P1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n8.7 \"--sync--\" StartsUsing { id: \"662C\", source: \"The Endsinger\" } window 15,15\r\n13.7 \"Elegeia\" Ability { id: \"662C\", source: \"The Endsinger\" }\r\n36.9 \"Elegeia\" Ability { id: \"662C\", source: \"The Endsinger\" }\r\n56.1 \"Galaxias\" Ability { id: \"6C69\", source: \"The Endsinger\" }\r\n69.3 \"Elenchos\" Ability { id: \"6644\", source: \"The Endsinger\" }\r\n87.6 \"--sync--\" Ability { id: \"664A\", source: \"The Endsinger\" }\r\n93.6 \"Death's Embrace\" Ability { id: \"6649\", source: \"The Endsinger\" }\r\n105.8 \"Aporrhoia\" Ability { id: \"663D\", source: \"The Endsinger\" }\r\n115.4 \"Elenchos\" Ability { id: \"663E\", source: \"The Endsinger\" }\r\n120.0 \"Hubris\" Ability { id: \"6652\", source: \"The Endsinger\" }\r\n132.2 \"Elegeia Unforgotten\" Ability { id: \"6682\", source: \"The Endsinger\" }\r\n158.4 \"Fatalism\" Ability { id: \"6632\", source: \"The Endsinger\" }\r\n185.6 \"Elegeia Unforgotten\" Ability { id: \"6682\", source: \"The Endsinger\" }\r\n211.7 \"Fatalism\" Ability { id: \"6632\", source: \"The Endsinger\" }\r\n223.9 \"Galaxias\" Ability { id: \"6C69\", source: \"The Endsinger\" }\r\n238.1 \"Ekstasis\" Ability { id: \"6645\", source: \"The Endsinger\" }\r\n241.9 \"Epigonoi\" Ability { id: \"6646\", source: \"The Endsinger\" }\r\n244.4 \"--sync--\" Ability { id: \"6647\", source: \"The Endsinger\" }\r\n262.1 \"--sync--\" Ability { id: \"6692\", source: \"The Endsinger\" }\r\n265.1 \"--untargetable--\"\r\n274.4 \"Interstellar\" Ability { id: \"664D\", source: \"The Endsinger\" }\r\n276.6 \"Nemesis\" Ability { id: \"664E\", source: \"The Endsinger\" }\r\n282.6 \"--targetable--\"\r\n285.7 \"Aporrhoia\" Ability { id: \"663D\", source: \"The Endsinger\" }\r\n295.3 \"Elenchos\" Ability { id: \"663E\", source: \"The Endsinger\" }\r\n313.1 \"Elegeia Unforgotten\" Ability { id: \"6682\", source: \"The Endsinger\" }\r\n332.3 \"Elegeia Unforgotten\" Ability { id: \"6682\", source: \"The Endsinger\" }\r\n357.5 \"Fatalism\" Ability { id: \"6632\", source: \"The Endsinger\" }\r\n369.7 \"Galaxias\" Ability { id: \"6C69\", source: \"The Endsinger\" }\r\n375.9 \"Fatalism\" Ability { id: \"6632\", source: \"The Endsinger\" }\r\n388.0 \"Nemesis\" Ability { id: \"6654\", source: \"The Endsinger\" }\r\n401.2 \"--sync--\" Ability { id: \"664A\", source: \"The Endsinger\" }\r\n407.2 \"Death's Embrace\" Ability { id: \"6649\", source: \"The Endsinger\" }\r\n417.3 \"Elenchos\" Ability { id: \"6644\", source: \"The Endsinger\" }\r\n426.4 \"Hubris\" Ability { id: \"6652\", source: \"The Endsinger\" }\r\n436.6 \"Aporrhoia\" Ability { id: \"663D\", source: \"The Endsinger\" }\r\n446.2 \"Elenchos\" Ability { id: \"663E\", source: \"The Endsinger\" }\r\n450.8 \"Elenchos\" Ability { id: \"6644\", source: \"The Endsinger\" }\r\n464.0 \"Elegeia\" Ability { id: \"662C\", source: \"The Endsinger\" }\r\n483.2 \"Nemesis\" Ability { id: \"6654\", source: \"The Endsinger\" }\r\n490.3 \"--untargetable--\"\r\n499.6 \"Interstellar\" Ability { id: \"664D\", source: \"The Endsinger\" }\r\n501.8 \"Nemesis\" Ability { id: \"664E\", source: \"The Endsinger\" }\r\n507.8 \"--targetable--\"\r\n513.9 \"--sync--\" Ability { id: \"664A\", source: \"The Endsinger\" }\r\n519.9 \"Death's Embrace\" Ability { id: \"6649\", source: \"The Endsinger\" }\r\n539.2 \"Hubris\" Ability { id: \"6652\", source: \"The Endsinger\" }\r\n549.4 \"Aporrhoia\" Ability { id: \"663D\", source: \"The Endsinger\" }\r\n559.0 \"Elenchos\" Ability { id: \"663E\", source: \"The Endsinger\" }\r\n563.5 \"Elenchos\" Ability { id: \"6644\", source: \"The Endsinger\" }\r\n576.7 \"Elegeia\" Ability { id: \"662C\", source: \"The Endsinger\" }\r\n\r\n# Phase 2, add spawns\r\n1000.0 \"Planetes\" Ability { id: \"6B58\", source: \"The Endsinger\" } window 1000,0\r\n1000.0 \"--untargetable--\"\r\n1014.3 \"--targetable--\"\r\n1023.4 \"Meteor Radiant\" Ability { id: \"6656\", source: \"Kakodaimon\" }\r\n1035.2 \"Crash\" Ability { id: \"6657\", source: \"Kakodaimon\" }\r\n1040.2 \"Crash\" Ability { id: \"6657\", source: \"Kakodaimon\" }\r\n1045.2 \"Crash\" Ability { id: \"6657\", source: \"Kakodaimon\" }\r\n1050.2 \"Crash\" Ability { id: \"6657\", source: \"Kakodaimon\" }\r\n1056.6 \"Meteor Outburst\" Ability { id: \"665C\", source: \"Kakodaimon\" }\r\n# Loop Katastrophe raidwide until enrage\r\n1067.8 \"Katastrophe\" Ability { id: \"665B\", source: \"Kakodaimon\" }\r\n1078.9 \"Katastrophe\" Ability { id: \"665B\", source: \"Kakodaimon\" } jump 1067.8\r\n1090.0 \"Katastrophe\"\r\n1101.1 \"Katastrophe\"\r\n1112.2 \"Katastrophe\"\r\n1123.3 \"Katastrophe\"\r\n\r\n# https://xivapi.com/InstanceContentTextData/30034\r\n# en: 10 seconds until oblivion is sealed...\r\n1200.0 \"--sync--\" BattleTalk2 { instanceContentTextId: \"7552\" } window 200,0\r\n1212.2 \"Ultimate Fate\" Ability { id: \"6B59\", source: \"The Endsinger\" } window 10,10\r\n1218.9 \"--targetable--\"\r\n\r\n# Phase 3, loops until soft enrage\r\n2000.0 \"Fatalism\" Ability { id: \"6B5B\", source: \"The Endsinger\" } window 1000,0\r\n2036.0 \"--untargetable--\"\r\n2074.0 \"--targetable--\"\r\n2086.1 \"Telos\" Ability { id: \"665E\", source: \"The Endsinger\" }\r\n2099.3 \"Telomania (cast)\" Ability { id: \"665F\", source: \"The Endsinger\" }\r\n2103.6 \"Telomania (small) x4\" duration 5 #Ability { id: \"6660\", source: \"The Endsinger\" }\r\n2114.6 \"Telomania (big)\" Ability { id: \"6661\", source: \"The Endsinger\" }\r\n2120.1 \"Dead Star x3\" duration 6 #Ability { id: \"5E4E\", source: \"The Endsinger\" }\r\n2124.5 \"Telomania (cast)\" Ability { id: \"665F\", source: \"The Endsinger\" } window 10,30 jump 2099.3\r\n2128.8 \"Telomania (small) x4\" duration 5 #Ability { id: \"6660\", source: \"The Endsinger\" }\r\n2139.8 \"Telomania (big)\" #Ability { id: \"6661\", source: \"The Endsinger\" }\r\n2145.3 \"Dead Star x3\" duration 6 #Ability { id: \"5E4E\", source: \"The Endsinger\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/golbez-ex.ts



// These don't seem to be randomized.
// Listing them all in case future BLU players want to call out who the stacks are on.
const golbez_ex_headmarkers = {
  voidMeteor: '0158',
  spread: '0178',
  knockback: '01DA',
  flare: '01D9',
  cauterize: '0001',
  partnerStackAbyssalQuasar: '015B',
  healerStackImmolatingShade: '00A1',
  healerStackVoidBlizzardIII: '013E',
  partnerStackVoidAeroIII: '01C3'
};
const arcticAssaultQuadrants = {
  '00': 'nw',
  '01': 'ne',
  '02': 'ne',
  '03': 'se',
  '04': 'sw',
  '05': 'se',
  '06': 'nw',
  '07': 'sw'
};
const galeSphereOutputStrings = {
  middle: outputs/* default.middle */.Z.middle,
  n: outputs/* default.north */.Z.north,
  e: outputs/* default.east */.Z.east,
  s: outputs/* default.south */.Z.south,
  w: outputs/* default.west */.Z.west,
  unknown: outputs/* default.unknown */.Z.unknown,
  dirAndMechanic: {
    en: '${dir} + ${mechanic}',
    de: '${dir} + ${mechanic}',
    fr: '${dir} + ${mechanic}',
    ja: '${dir} + ${mechanic}',
    cn: '${dir} + ${mechanic}',
    ko: '${dir} + ${mechanic}'
  },
  healerGroups: outputs/* default.healerGroups */.Z.healerGroups,
  partnerStack: {
    en: 'Partner Stack',
    de: 'Mit Partner sammeln',
    fr: 'Package partenaire',
    ja: 'ペア',
    cn: '2 人分摊',
    ko: '2인 쉐어'
  }
};

// MapEffect info:
/*
Slots:
  00 = Middle North ice wall, facing west
  01 = Middle North ice wall, facing east
  02 = Center East ice wall, facing north
  03 = Center East ice wall, facing south
  04 = Middle South ice wall, facing west
  05 = Middle South ice wall, facing east
  06 = Center West ice wall, facing north
  07 = Center West ice wall, facing south

  08/0A = NW/SE meteors
  09/0B = NE/SW meteors

  0C = lightning effect during lingering spark
  0D = unknown, during towers+meteors

Flags:
  For ice wall and lightning, `00020001` enables, `00080004` disables
  For meteors, `00010004` enables, seems to auto-disable
*/
const golbez_ex_triggerSet = {
  id: 'TheVoidcastDaisExtreme',
  zoneId: zone_id/* default.TheVoidcastDaisExtreme */.Z.TheVoidcastDaisExtreme,
  timelineFile: 'golbez-ex.txt',
  initData: () => {
    return {
      terrastormCount: 0,
      terrastormCombatantDirs: [],
      galeSphereShadows: [],
      galeSphereCasts: [],
      galeSafeSpots: [],
      arcticAssaultMapEffects: [],
      arcticAssaultCount: 0,
      dragonsDescentMarker: []
    };
  },
  timelineTriggers: [{
    id: 'GolbezEx Flames of Eventide 1',
    regex: /Flames of Eventide 1/,
    beforeSeconds: 5,
    suppressSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'GolbezEx Flames of Eventide Swap',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'DF5',
      count: '01'
    },
    condition: (data, matches) => {
      if (data.me === matches.target) return false;
      return data.role === 'tank' || data.job === 'BLU';
    },
    suppressSeconds: 10,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.tankSwap */.Z.tankSwap
    }
  }, {
    id: 'GolbezEx Terrastorm 1',
    type: 'MapEffect',
    netRegex: {
      location: '0[89]',
      flags: '00010004',
      capture: true
    },
    alertText: (data, matches, output) => {
      data.terrastormCount++;
      data.terrastormDir = matches.location === '08' ? 'nw' : 'ne';

      // We'll handle this elsewhere to combine with arctic assault.
      if (data.terrastormCount === 2) return;
      if (data.terrastormDir === 'nw') return output.dirNESW();
      return output.dirNWSE();
    },
    outputStrings: {
      dirNWSE: {
        en: 'NW / SE',
        de: 'NW / SO',
        fr: 'NO / SE',
        ja: '北西 / 南東',
        cn: '左上 (西北) / 右下 (东南)',
        ko: '북서 / 남동'
      },
      dirNESW: {
        en: 'NE / SW',
        de: 'NO / SW',
        fr: 'NE / SO',
        ja: '北東 / 南西',
        cn: '右上 (东北) / 左下 (西南)',
        ko: '북동 / 남서'
      }
    }
  }, {
    id: 'GolbezEx Lingering Spark Bait',
    type: 'StartsUsing',
    netRegex: {
      id: '8468',
      source: 'Golbez',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Circles',
        de: 'Kreise ködern',
        fr: 'Déposez les cercles',
        ja: 'AOE誘導',
        cn: '集合放圈',
        ko: '장판 유도'
      }
    }
  }, {
    id: 'GolbezEx Lingering Spark Move',
    type: 'StartsUsing',
    netRegex: {
      id: '846A',
      source: 'Golbez',
      capture: false
    },
    suppressSeconds: 3,
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'GolbezEx Phases of the Blade',
    type: 'StartsUsing',
    netRegex: {
      id: '86DB',
      source: 'Golbez',
      capture: false
    },
    durationSeconds: 4,
    response: responses/* Responses.getBackThenFront */.n3.getBackThenFront('alert')
  }, {
    id: 'GolbezEx Phases of the Blade Followup',
    type: 'Ability',
    netRegex: {
      id: '86DB',
      source: 'Golbez',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.front(),
    outputStrings: {
      front: outputs/* default.front */.Z.front
    }
  }, {
    id: 'GolbezEx Phases of the Shadow',
    type: 'StartsUsing',
    netRegex: {
      id: '86E7',
      source: 'Golbez',
      capture: false
    },
    durationSeconds: 4,
    alertText: (data, _matches, output) => {
      if (data.recordedShadowMechanic === 'spread') return output.backThenFrontThenSpread();
      if (data.recordedShadowMechanic === 'stack') return output.backThenFrontThenHealerGroups();
      return output.backThenFront();
    },
    outputStrings: {
      backThenFront: outputs/* default.backThenFront */.Z.backThenFront,
      backThenFrontThenHealerGroups: {
        en: 'Back => Front => Out => Stacks',
        de: 'Hinten => Vorne => Raus => Sammeln',
        fr: 'Derrière => Devant => Extérieur => Package',
        ja: '後ろ => 前 => 外側 => ペア',
        cn: '后 => 前 => 钢铁 => 集合',
        ko: '뒤 => 앞 => 밖 => 쉐어'
      },
      backThenFrontThenSpread: {
        en: 'Back => Front => Under => Spread',
        de: 'Hinten => Vorne => Unter ihn => Verteilen',
        fr: 'Derrière => Devant => Dessous => Écartez-vous',
        ja: '後ろ => 前 => 内側 => 散会',
        cn: '后 => 前 => 月环 => 分散',
        ko: '뒤 => 앞 => 안 => 산개'
      }
    }
  }, {
    id: 'GolbezEx Phases of the Shadow Followup',
    type: 'Ability',
    netRegex: {
      id: '86E7',
      source: 'Golbez',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (data.recordedShadowMechanic === 'spread') return output.frontThenSpread();
      if (data.recordedShadowMechanic === 'stack') return output.frontThenHealerGroups();
      return output.front();
    },
    run: data => delete data.recordedShadowMechanic,
    outputStrings: {
      front: outputs/* default.front */.Z.front,
      frontThenHealerGroups: {
        en: 'Front => Out => Stacks',
        de: 'Vorne => Raus => Sammeln',
        fr: 'Devant => Extérieur => Package',
        ja: '前 => 外側 => ペア',
        cn: '前 => 钢铁 => 集合',
        ko: '앞 => 밖 => 쉐어'
      },
      frontThenSpread: {
        en: 'Front => Under',
        de: 'Vorne => Unter ihn',
        fr: 'Devant => Dessous',
        ja: '前 => 内側',
        cn: '前 => 月环',
        ko: '앞 => 안'
      }
    }
  }, {
    id: 'GolbezEx Rising Ring Followup',
    type: 'Ability',
    netRegex: {
      id: '86ED',
      source: 'Golbez',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.outAndSpread(),
    outputStrings: {
      outAndSpread: {
        en: 'Spread Out',
        de: 'Außen verteilen',
        fr: 'Écartez-vous',
        ja: '散会',
        cn: '分散',
        ko: '산개'
      }
    }
  }, {
    id: 'GolbezEx Binding Cold',
    type: 'StartsUsing',
    netRegex: {
      id: '84B3',
      source: 'Golbez',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'GolbezEx Void Meteor',
    type: 'StartsUsing',
    netRegex: {
      id: '84AD',
      source: 'Golbez',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.tankBusters */.Z.tankBusters
    }
  }, {
    id: 'GolbezEx Black Fang',
    type: 'StartsUsing',
    netRegex: {
      id: '8471',
      source: 'Golbez',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'GolbezEx Abyssal Quasar',
    type: 'StartsUsing',
    netRegex: {
      id: '84AB',
      source: 'Golbez',
      capture: false
    },
    suppressSeconds: 3,
    alertText: (_data, _matches, output) => output.partnerStack(),
    outputStrings: {
      partnerStack: {
        en: 'Partner Stack',
        de: 'Mit Partner sammeln',
        fr: 'Package partenaire',
        ja: 'ペア',
        cn: '2 人分摊',
        ko: '2인 쉐어'
      }
    }
  }, {
    id: 'GolbezEx Eventide Triad',
    type: 'StartsUsing',
    netRegex: {
      id: '8480',
      source: 'Golbez',
      capture: false
    },
    alertText: (_data, _matches, output) => output.rolePositions(),
    outputStrings: {
      rolePositions: {
        en: 'Role positions',
        de: 'Rollenposition',
        fr: 'Positions par rôle',
        ja: 'ロール散会',
        cn: '去指定位置',
        ko: '직업군별 위치로'
      }
    }
  }, {
    id: 'GolbezEx Eventide Fall',
    type: 'StartsUsing',
    netRegex: {
      id: '8485',
      source: 'Golbez',
      capture: false
    },
    suppressSeconds: 3,
    alertText: (_data, _matches, output) => output.healerGroups(),
    outputStrings: {
      healerGroups: outputs/* default.healerGroups */.Z.healerGroups
    }
  }, {
    id: 'GolbezEx Azdaja\'s Shadow Out Tell',
    type: 'StartsUsing',
    netRegex: {
      id: '8478',
      source: 'Golbez',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.recordedShadowMechanic = 'stack',
    outputStrings: {
      text: {
        en: '(out + healer groups, for later)',
        de: '(raus + Heiler Gruppen, für später)',
        fr: '(extérieur + gourpes sur les heals, pour après)',
        ja: '(外 + 後でヒーラと4:4頭割り)',
        cn: '(钢铁 + 稍后治疗分组分摊)',
        ko: '(밖으로 + 힐러 그룹 쉐어, 나중에)'
      }
    }
  }, {
    id: 'GolbezEx Azdaja\'s Shadow In Tell',
    type: 'StartsUsing',
    netRegex: {
      id: '8479',
      source: 'Golbez',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    run: data => data.recordedShadowMechanic = 'spread',
    outputStrings: {
      text: {
        en: '(in + spread, for later)',
        de: '(rein + verteilen, für später)',
        fr: '(intérieur + écartement, pour après)',
        ja: '(中 + 後で散会)',
        cn: '(月环 + 稍后分散)',
        ko: '(안 + 산개, 나중에)'
      }
    }
  }, {
    id: 'GolbezEx Void Tornado / Void Aero III',
    type: 'StartsUsing',
    // 845C = Void Aero III (partner stacks)
    // 845D = Void Tornado (healer stacks)
    netRegex: {
      id: '845[CD]',
      source: 'Golbez'
    },
    suppressSeconds: 30,
    run: (data, matches) => {
      if (matches.id === '845D') {
        data.firstGaleMechanic = 'healer';
        data.secondGaleMechanic = 'partner';
      } else {
        data.firstGaleMechanic = 'partner';
        data.secondGaleMechanic = 'healer';
      }
    }
  }, {
    id: 'GolbezEx Gale Sphere Collector',
    type: 'StartsUsing',
    netRegex: {
      id: '845[89AB]',
      source: 'Gale Sphere',
      capture: true
    },
    run: (data, matches) => {
      data.galeSafeSpots = [];
      data.galeSphereCasts.push({
        x: parseFloat(matches.x),
        y: parseFloat(matches.y),
        castTime: parseFloat(matches.castTime)
      });
    }
  }, {
    id: 'GolbezEx Gale Sphere Directions',
    type: 'Ability',
    netRegex: {
      id: '84(?:4F|50|51|52)',
      source: 'Golbez\'s Shadow',
      capture: true
    },
    infoText: (data, matches, output) => {
      switch (matches.id) {
        case '844F':
          data.galeSphereShadows.push('n');
          break;
        case '8450':
          data.galeSphereShadows.push('e');
          break;
        case '8451':
          data.galeSphereShadows.push('w');
          break;
        case '8452':
          data.galeSphereShadows.push('s');
          break;
      }
      if (data.galeSphereShadows.length < 4) return;
      const [dir1, dir2, dir3, dir4] = data.galeSphereShadows;
      data.galeSphereShadows = [];
      return output.clones({
        dir1: dir1,
        dir2: dir2,
        dir3: dir3,
        dir4: dir4
      });
    },
    outputStrings: {
      n: outputs/* default.dirN */.Z.dirN,
      e: outputs/* default.dirE */.Z.dirE,
      s: outputs/* default.dirS */.Z.dirS,
      w: outputs/* default.dirW */.Z.dirW,
      unknown: outputs/* default.unknown */.Z.unknown,
      clones: {
        en: 'Clones: ${dir1}->${dir2}->${dir3}->${dir4}',
        de: 'Klone: ${dir1}->${dir2}->${dir3}->${dir4}',
        fr: 'Clones : ${dir1}->${dir2}->${dir3}->${dir4}',
        ja: '分身: ${dir1}->${dir2}->${dir3}->${dir4}',
        cn: '分身：${dir1}->${dir2}->${dir3}->${dir4}',
        ko: '분신：${dir1}->${dir2}->${dir3}->${dir4}'
      }
    }
  }, {
    id: 'GolbezEx Gale Safe Spots',
    type: 'StartsUsing',
    netRegex: {
      id: '845[89AB]',
      source: 'Gale Sphere',
      capture: false
    },
    condition: data => data.galeSphereCasts.length === 16,
    durationSeconds: 15,
    infoText: (data, _matches, output) => {
      const order = [];
      const safeSpots = {
        n: 'unknown',
        e: 'unknown',
        s: 'unknown',
        w: 'unknown'
      };
      data.galeSphereCasts.sort((left, right) => {
        return left.castTime - right.castTime;
      });
      data.galeSphereCasts.forEach(sphere => {
        let dir;
        if (sphere.x > 113) dir = 'e';else if (sphere.y > 113) dir = 's';else if (sphere.x < 87) dir = 'w';else dir = 'n';
        if (!order.includes(dir)) order.push(dir);
      });
      const sphereDirections = {
        n: data.galeSphereCasts.filter(sphere => sphere.y < 87),
        e: data.galeSphereCasts.filter(sphere => sphere.x > 113),
        s: data.galeSphereCasts.filter(sphere => sphere.y > 113),
        w: data.galeSphereCasts.filter(sphere => sphere.x < 87)
      };
      const possibleDirs = ['n', 'e', 's', 'w'];
      for (const dir of possibleDirs) {
        const spheres = sphereDirections[dir];
        const key = ['n', 's'].includes(dir) ? 'x' : 'y';

        // For these, there are 6 possible cast locations, of which 4 will be present
        // We only need to check three of the six to determine the safe spot
        // All of these coordinates are 0.50 higher. To avoid floating point issues
        // we're just using the floor'd coordinates.
        const possibleSpots = {
          112: ['s', 'e'],
          102: ['middle'],
          87: ['n', 'w']
        };
        for (const sphere of spheres) {
          delete possibleSpots[Math.floor(sphere[key])];
        }
        const remainingSpots = Object.values(possibleSpots);
        const spot = remainingSpots[0];
        if (remainingSpots.length > 1 || !spot) continue;
        let finalSpot = 'unknown';
        if (spot[0] === 'middle') finalSpot = 'middle';else finalSpot = key === 'y' ? spot[0] : spot[1];
        safeSpots[dir] = finalSpot ?? 'unknown';
      }
      data.galeSafeSpots = [];
      for (const dir of order) data.galeSafeSpots.push(safeSpots[dir]);
      data.galeSphereCasts = [];
      const [dir1, dir2, dir3, dir4] = data.galeSafeSpots.map(x => output[x]());
      if (dir1 === undefined || dir2 === undefined || dir3 === undefined || dir4 === undefined) return;
      return output.safeSpotList({
        dir1: dir1,
        dir2: dir2,
        dir3: dir3,
        dir4: dir4
      });
    },
    outputStrings: {
      safeSpotList: {
        en: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        de: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        fr: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        ja: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        cn: '${dir1} => ${dir2} => ${dir3} => ${dir4}',
        ko: '${dir1} => ${dir2} => ${dir3} => ${dir4}'
      },
      ...galeSphereOutputStrings
    }
  }, {
    id: 'GolbezEx Gale Initial Safe Spot',
    type: 'StartsUsing',
    netRegex: {
      id: '845[89AB]',
      source: 'Gale Sphere',
      capture: false
    },
    condition: data => data.galeSafeSpots.length === 4,
    alertText: (data, _matches, output) => {
      const spot = data.galeSafeSpots.shift();
      if (spot === undefined) return;
      const dir = output[spot]();
      const mech = data.firstGaleMechanic;
      delete data.firstGaleMechanic;
      if (mech === undefined) return dir;
      const mechanicStr = mech === 'partner' ? output.partnerStack() : output.healerGroups();
      return output.dirAndMechanic({
        dir: dir,
        mechanic: mechanicStr
      });
    },
    outputStrings: galeSphereOutputStrings
  }, {
    id: 'GolbezEx Arctic Assault Collector',
    type: 'MapEffect',
    netRegex: {
      location: '0[0-7]',
      flags: '00020001'
    },
    run: (data, matches) => {
      delete data.arcticAssaultSafeSpots;
      data.arcticAssaultMapEffects.push(matches.location);
      if (data.arcticAssaultMapEffects.length < 2) return;

      // 1 = Gale Sphere 1
      // 2 = Terrastorm 2
      // 3 = Gale Sphere 2
      // 4 = Gale Sphere 3
      data.arcticAssaultCount++;
      const safe = ['nw', 'ne', 'sw', 'se'];
      data.arcticAssaultSafeSpots = safe.filter(quadrant => {
        for (const slot of data.arcticAssaultMapEffects) {
          if (arcticAssaultQuadrants[slot] === quadrant) return false;
        }
        return true;
      });
      data.arcticAssaultMapEffects = [];
    }
  }, {
    id: 'GolbezEx Terrastorm 2',
    // The terrastorm meteors come out before the arctic assault, and so wait for them.
    type: 'MapEffect',
    netRegex: {
      location: '0[0-7]',
      flags: '00020001',
      capture: false
    },
    condition: data => {
      return data.arcticAssaultCount === 2 && data.arcticAssaultSafeSpots !== undefined;
    },
    alertText: (data, _matches, output) => {
      const [safe1, safe2] = data.arcticAssaultSafeSpots ?? [];
      const terrastormDir = data.terrastormDir;
      if (terrastormDir === undefined || safe1 === undefined || safe2 === undefined) return;
      const isSafe1Safe = terrastormDir === 'nw' && safe1 !== 'nw' && safe1 !== 'se' || terrastormDir === 'ne' && safe1 !== 'ne' && safe1 !== 'sw';
      const isSafe2Safe = terrastormDir === 'nw' && safe2 !== 'nw' && safe2 !== 'se' || terrastormDir === 'ne' && safe2 !== 'ne' && safe2 !== 'sw';
      if (isSafe1Safe && isSafe2Safe || !isSafe1Safe && !isSafe2Safe) return;
      const dir = {
        ne: output.northeast(),
        se: output.southeast(),
        sw: output.southwest(),
        nw: output.northwest()
      }[isSafe1Safe ? safe1 : safe2];
      return output.text({
        dir: dir
      });
    },
    outputStrings: {
      text: {
        en: '${dir} => Healer Groups',
        de: '${dir} => Heiler Gruppen',
        fr: '${dir} => Groupe sur les heals',
        ja: '${dir} => ヒーラと4:4頭割り',
        cn: '${dir} => 治疗分组分摊',
        ko: '${dir} => 힐러 그룹 쉐어'
      },
      northeast: outputs/* default.northeast */.Z.northeast,
      southeast: outputs/* default.southeast */.Z.southeast,
      southwest: outputs/* default.southwest */.Z.southwest,
      northwest: outputs/* default.northwest */.Z.northwest
    }
  }, {
    id: 'GolbezEx Gale Sphere Followup Safe Spots',
    type: 'Ability',
    netRegex: {
      id: '845[89AB]',
      source: 'Gale Sphere',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      const spot = data.galeSafeSpots.shift();
      if (spot === undefined) return;
      const nextSpot = data.galeSafeSpots[0] ?? 'unknown';

      // Safe spot 2 with arctic assault.
      if (data.galeSafeSpots.length === 2 && data.arcticAssaultSafeSpots !== undefined) {
        if (spot === 'w' && data.arcticAssaultSafeSpots.includes('nw')) return output.northwest();
        if (spot === 'w' && data.arcticAssaultSafeSpots.includes('sw')) return output.southwest();
        if (spot === 'e' && data.arcticAssaultSafeSpots.includes('ne')) return output.northeast();
        if (spot === 'e' && data.arcticAssaultSafeSpots.includes('se')) return output.southeast();
        // If in the middle, try to steer people towards the next safe spot.
        if (spot === 'middle') {
          if (nextSpot === 'n') {
            if (data.arcticAssaultSafeSpots.includes('nw')) return output.middleLean({
              dir: output.dirNW()
            });
            if (data.arcticAssaultSafeSpots.includes('ne')) return output.middleLean({
              dir: output.dirNE()
            });
          } else if (nextSpot === 's') {
            if (data.arcticAssaultSafeSpots.includes('sw')) return output.middleLean({
              dir: output.dirSW()
            });
            if (data.arcticAssaultSafeSpots.includes('se')) return output.middleLean({
              dir: output.dirSE()
            });
          }
        }
      }

      // Safe spot 3.
      const dir = output[spot]();
      if (data.galeSafeSpots.length > 0) return dir;

      // Safe spot 4
      const mech = data.secondGaleMechanic;
      delete data.secondGaleMechanic;
      if (mech === undefined) return dir;
      const mechanicStr = mech === 'partner' ? output.partnerStack() : output.healerGroups();
      return output.dirAndMechanic({
        dir: dir,
        mechanic: mechanicStr
      });
    },
    outputStrings: {
      ...galeSphereOutputStrings,
      northwest: outputs/* default.northwest */.Z.northwest,
      northeast: outputs/* default.northeast */.Z.northeast,
      southwest: outputs/* default.southwest */.Z.southwest,
      southeast: outputs/* default.southeast */.Z.southeast,
      dirNW: outputs/* default.dirNW */.Z.dirNW,
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirSW: outputs/* default.dirSW */.Z.dirSW,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      middleLean: {
        en: 'Middle (lean ${dir})',
        de: 'Mitte (${dir} halten)',
        fr: 'Milieu (côté ${dir})',
        ja: '真ん中 (すこし${dir})',
        cn: '中间 (偏 ${dir})',
        ko: '중앙 (약간 ${dir})'
      }
    }
  }, {
    id: 'GolbezEx Knockback Headmarker',
    type: 'HeadMarker',
    netRegex: {
      id: golbez_ex_headmarkers.knockback
    },
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    run: (data, matches) => data.dragonsDescentMarker.push(matches.target),
    outputStrings: {
      text: {
        en: 'Knockback on YOU',
        de: 'Rückstoß auf DIR',
        fr: 'Poussée sur VOUS',
        ja: '自分にノックバック',
        cn: '击退点名',
        ko: '넉백 대상자'
      }
    }
  }, {
    id: 'GolbezEx Flare Headmarker',
    type: 'HeadMarker',
    netRegex: {
      id: golbez_ex_headmarkers.flare
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    run: (data, matches) => data.dragonsDescentMarker.push(matches.target),
    outputStrings: {
      text: {
        en: 'Flare on YOU',
        de: 'Flare auf DIR',
        fr: 'Brasier sur VOUS',
        ja: '自分にフレア',
        cn: '陨石点名',
        ko: '플레어 대상자'
      }
    }
  }, {
    id: 'GolbezEx No Headmarker',
    type: 'HeadMarker',
    netRegex: {
      id: golbez_ex_headmarkers.flare,
      capture: false
    },
    condition: data => data.dragonsDescentMarker.length === 3,
    infoText: (data, _matches, output) => {
      if (!data.dragonsDescentMarker.includes(data.me)) return output.text();
    },
    run: data => data.dragonsDescentMarker = [],
    outputStrings: {
      text: {
        en: 'Get Tower',
        de: 'Nimm Turm',
        fr: 'Prenez une tour',
        ja: '塔踏み',
        cn: '踩塔',
        ko: '기둥 들어가기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Eventide Fall/Eventide Triad': 'Eventide Fall/Triad',
      'Void Aero III/Void Tornado': 'Void Aero III/Tornado',
      'Void Tornado/Void Aero III': 'Void Tornado/Aero III'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Gale Sphere': 'Windsphäre',
      'Golbez': 'Golbez',
      'Shadow Dragon': 'Schattendrache'
    },
    'replaceText': {
      '\\(Enrage\\)': '(Finalangriff)',
      '\\(big\\)': '(Groß)',
      '\\(small\\)': '(Klein)',
      '\\(light parties\\)': '(Leichter Trupp)',
      '\\(spread\\)': '(Verteilen)',
      '\\(explode\\)': '(Explodieren)',
      '\\(snapshot\\)': '(Speichern)',
      '\\(back\\)': '(Hinten)',
      '\\(cast\\)': '(Aktivierung)',
      '\\(front\\)': '(Vorne)',
      '\\(out\\)': '(Raus)',
      '\\(record\\)': '(Merken)',
      '\\(under\\)': '(Unter)',
      '\\(hit\\)': '(Treffer)',
      '\\(preview\\)': '(Vorschau)',
      'Abyssal Quasar': 'Abyssus-Nova',
      'Arctic Assault': 'Frostschuss',
      'Azdaja\'s Shadow': 'Azdajas Schatten',
      'Binding Cold': 'Eisfessel',
      'Black Fang': 'Schwarze Fänge',
      'Cauterize': 'Kauterisieren',
      'Double Meteor': 'Doppel-Meteo',
      'Dragon\'s Descent': 'Fallender Drache',
      'Eventide Fall': 'Gebündelte Abendglut',
      'Eventide Triad': 'Dreifache Abendglut',
      'Explosion': 'Explosion',
      'Flames of Eventide': 'Flammen des Abendrots',
      'Gale Sphere': 'Windsphäre',
      'Immolating Shade': 'Äschernder Schatten',
      'Lingering Spark': 'Lauernder Funke',
      'Phases of the Blade': 'Sichelsturm',
      'Phases of the Shadow': 'Schwarzer Sichelsturm',
      'Rising Beacon': 'Hohes Fanal',
      'Rising Ring': 'Hoher Zirkel',
      'Terrastorm': 'Irdene Breitseite',
      'Void Aero III': 'Nichts-Windga',
      'Void Blizzard III': 'Nichts-Eisga',
      'Void Comet': 'Nichts-Komet',
      'Void Meteor': 'Nichts-Meteo',
      'Void Stardust': 'Nichts-Sternenstaub',
      'Void Tornado': 'Nichtstornado'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Gale Sphere': 'Sphères de vent ténébreux',
      'Golbez': 'Golbez',
      'Shadow Dragon': 'dragonne obscure'
    },
    'replaceText': {
      '\\(Enrage\\)': '(Enrage)',
      '\\(big\\)': '(Gros)',
      '\\(small\\)': '(Petit)',
      '\\(light parties\\)': '(Petit groupe)',
      '\\(spread\\)': '(Écartement)',
      '\\(explode\\)': '(Explosion)',
      '\\(snapshot\\)': '(Sauvegarde)',
      '\\(back\\)': '(Arrière)',
      '\\(cast\\)': '(Incantation)',
      '\\(front\\)': '(Devant)',
      '\\(out\\)': '(Extérieur)',
      '\\(record\\)': '(Enregistrement)',
      '\\(under\\)': '(Dessous)',
      '\\(hit\\)': '(Frappe)',
      '\\(preview\\)': '(Aperçu)',
      'Abyssal Quasar': 'Quasar abyssal',
      'Arctic Assault': 'Assaut arctique',
      'Azdaja\'s Shadow': 'Ombre d\'Azdaja',
      'Binding Cold': 'Geôle glaciale',
      'Black Fang': 'Croc obscur',
      'Cauterize': 'Cautérisation',
      'Double Meteor': 'Météore double',
      'Dragon\'s Descent': 'Descente draconique',
      'Eventide Fall': 'Éclat crépusculaire concentré',
      'Eventide Triad': 'Triple éclat crépusculaire',
      'Explosion': 'Explosion',
      'Flames of Eventide': 'Flammes du crépuscule',
      'Gale Sphere': 'Sphères de vent ténébreux',
      'Immolating Shade': 'Ombre incandescente',
      'Lingering Spark': 'Étincelle persistante',
      'Phases of the Blade': 'Taillade demi-lune',
      'Phases of the Shadow': 'Taillade demi-lune obscure',
      'Rising Beacon': 'Flambeau ascendant',
      'Rising Ring': 'Anneau ascendant',
      'Terrastorm': 'Aérolithe flottant',
      'Void Aero III': 'Méga Vent du néant',
      'Void Blizzard III': 'Méga Glace du néant',
      'Void Comet': 'Comète du néant',
      'Void Meteor': 'Météore du néant',
      'Void Stardust': 'Pluie de comètes du néant',
      'Void Tornado': 'Tornade du néant'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Gale Sphere': 'ウィンドスフィア',
      'Golbez': 'ゴルベーザ',
      'Shadow Dragon': '黒竜'
    },
    'replaceText': {
      'Abyssal Quasar': 'アビスクエーサー',
      'Arctic Assault': 'コールドブラスト',
      'Azdaja\'s Shadow': '黒竜剣アジュダヤ',
      'Binding Cold': '呪縛の冷気',
      'Black Fang': '黒い牙',
      'Cauterize': 'カータライズ',
      'Double Meteor': 'ダブルメテオ',
      'Dragon\'s Descent': '降竜爆火',
      'Eventide Fall': '集束黒竜閃',
      'Eventide Triad': '三連黒竜閃',
      'Explosion': '爆発',
      'Flames of Eventide': '黒竜炎',
      'Gale Sphere': 'ウィンドスフィア',
      'Immolating Shade': '重黒炎',
      'Lingering Spark': 'ディレイスパーク',
      'Phases of the Blade': '弦月連剣',
      'Phases of the Shadow': '弦月黒竜連剣',
      'Rising Beacon': '昇竜烽火',
      'Rising Ring': '昇竜輪火',
      'Terrastorm': 'ディレイアース',
      'Void Aero III': 'ヴォイド・エアロガ',
      'Void Blizzard III': 'ヴォイド・ブリザガ',
      'Void Comet': 'ヴォイド・コメット',
      'Void Meteor': 'ヴォイド・メテオ',
      'Void Stardust': 'ヴォイド・コメットレイン',
      'Void Tornado': 'ヴォイド・トルネド'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Gale Sphere': '风球',
      'Golbez': '高贝扎',
      'Shadow Dragon': '黑龙'
    },
    'replaceText': {
      '\\(Enrage\\)': '(狂暴)',
      '\\(big\\)': '(大)',
      '\\(small\\)': '(小)',
      '\\(light parties\\)': '(四四分组)',
      '\\(spread\\)': '(分散)',
      '\\(explode\\)': '(爆炸)',
      '\\(snapshot\\)': '(快照)',
      '\\(back\\)': '(后)',
      '\\(cast\\)': '(咏唱)',
      '\\(front\\)': '(前)',
      '\\(out\\)': '(外)',
      '\\(record\\)': '(记录)',
      '\\(under\\)': '(下方)',
      '\\(hit\\)': '(打击)',
      '\\(preview\\)': '(预览)',
      'Abyssal Quasar': '深渊类星体',
      'Arctic Assault': '极寒突袭',
      'Azdaja\'s Shadow': '黑龙剑阿珠达雅',
      'Binding Cold': '咒缚寒气',
      'Black Fang': '黑牙',
      'Burning Shade': '黑炎',
      'Cauterize': '黑炎俯冲',
      'Double Meteor': '双重陨石',
      'Dragon\'s Descent': '降龙爆火',
      'Eventide Fall': '集束黑龙闪',
      'Eventide Triad': '三连黑龙闪',
      'Explosion': '爆炸',
      'Flames of Eventide': '黑龙炎',
      'Gale Sphere': '风晶球',
      'Immolating Shade': '重黑炎',
      'Lingering Spark': '迟缓电火花',
      'Phases of the Blade': '弦月连剑',
      'Phases of the Shadow': '弦月黑龙连剑',
      'Rising Beacon': '升龙烽火',
      'Rising Ring': '升龙环火',
      'Terrastorm': '迟缓地暴',
      'Void Aero III': '虚空暴风',
      'Void Blizzard III': '虚空冰封',
      'Void Comet': '虚空彗星',
      'Void Meteor': '虚空陨石',
      'Void Stardust': '虚空彗星雨',
      'Void Tornado': '虚空龙卷'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Gale Sphere': '바람 구체',
      'Golbez': '골베자',
      'Shadow Dragon': '흑룡'
    },
    'replaceText': {
      '\\(big\\)': '(큰)',
      '\\(small\\)': '(작은)',
      '\\(light parties\\)': '(4-4 쉐어)',
      '\\(spread\\)': '(산개)',
      '\\(explode\\)': '(폭발)',
      '\\(snapshot\\)': '(시전)',
      '\\(back\\)': '(뒤)',
      '\\(cast\\)': '(시전)',
      '\\(front\\)': '(앞)',
      '\\(out\\)': '(밖)',
      '\\(under\\)': '(밑)',
      '\\(hit\\)': '(폭발)',
      '\\(preview\\)': '(예고)',
      'Abyssal Quasar': '심연의 퀘이사',
      'Arctic Assault': '냉기 작렬',
      'Azdaja\'s Shadow': '흑룡검 아주다야',
      'Binding Cold': '주박의 냉기',
      'Black Fang': '검은 이빨',
      'Burning Shade': '흑염',
      'Burning/Immolating Shade': '흑염/중흑염',
      'Cauterize': '인두질',
      'Double Meteor': '더블 메테오',
      'Dragon\'s Descent': '강룡폭화',
      'Eventide Fall': '집속 흑룡섬',
      'Eventide Triad': '삼연속 흑룡섬',
      'Explosion': '폭발',
      'Flames of Eventide': '흑룡염',
      'Gale Sphere': '바람 구체',
      '(?<!/)Immolating Shade': '중흑염',
      'Lingering Spark': '잔존 벼락',
      'Phases of the Blade': '연속 현월검',
      'Phases of the Shadow': '연속 현월 흑룡검',
      'Rising Beacon': '승룡봉화',
      'Rising Ring': '승룡륜화',
      'Terrastorm': '잔존 암석',
      'Void Aero III': '보이드 에어로가',
      'Void Blizzard III': '보이드 블리자가',
      'Void Comet': '보이드 혜성',
      'Void Meteor': '보이드 메테오',
      'Void Stardust': '보이드 혜성우',
      'Void Tornado': '보이드 토네이도'
    }
  }]
};
/* harmony default export */ const golbez_ex = (golbez_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/golbez-ex.txt
const trial_golbez_ex_namespaceObject = "### The Voidcast Dais (Extreme)\r\n# -ii 84B5 84B7 849E 84A8 84AA 8481 86B2 8461 848D 848E\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n9.4 \"--sync--\" StartsUsing { id: \"8464\", source: \"Golbez\" } window 15,15\r\n12.4 \"Terrastorm (cast)\" Ability { id: \"8464\", source: \"Golbez\" }\r\n21.5 \"Terrastorm (hit)\" Ability { id: \"8466\", source: \"Golbez\" }\r\n22.5 \"Lingering Spark (snapshot)\" Ability { id: \"8468\", source: \"Golbez\" }\r\n26.6 \"Lingering Spark (explode)\" Ability { id: \"846A\", source: \"Golbez\" }\r\n31.8 \"Phases of the Blade (front)\" Ability { id: \"86DB\", source: \"Golbez\" }\r\n33.6 \"--sync--\" Ability { id: \"86DD\", source: \"Golbez\" }\r\n35.3 \"Phases of the Blade (back)\" Ability { id: \"86F2\", source: \"Golbez\" }\r\n44.6 \"Binding Cold\" Ability { id: \"84B3\", source: \"Golbez\" }\r\n\r\n52.8 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n57.9 \"Gale Sphere\" Ability { id: \"844D\", source: \"Golbez\" }\r\n68.6 \"--sync--\" Ability { id: \"844E\", source: \"Golbez\" }\r\n71.2 \"Gale Sphere 1\" Ability { id: \"845[89AB]\", source: \"Gale Sphere\" }\r\n73.6 \"Arctic Assault\" Ability { id: \"845F\", source: \"Golbez\" }\r\n74.6 \"Gale Sphere 2\" Ability { id: \"845[89AB]\", source: \"Gale Sphere\" }\r\n77.9 \"Gale Sphere 3\" Ability { id: \"845[89AB]\", source: \"Gale Sphere\" }\r\n81.5 \"Gale Sphere 4\" Ability { id: \"845[89AB]\", source: \"Gale Sphere\" }\r\n86.7 \"Phases of the Blade (front)\" Ability { id: \"86DB\", source: \"Golbez\" }\r\n88.6 \"--sync--\" Ability { id: \"86DD\", source: \"Golbez\" }\r\n90.3 \"Phases of the Blade (back)\" Ability { id: \"86F2\", source: \"Golbez\" }\r\n99.7 \"Binding Cold\" Ability { id: \"84B3\", source: \"Golbez\" }\r\n\r\n107.8 \"Void Meteor\" Ability { id: \"84AD\", source: \"Golbez\" }\r\n107.9 \"Void Comet x4\" duration 3 #Ability { id: \"84B0\", source: \"Golbez\" }\r\n111.9 \"Void Meteor (big)\" Ability { id: \"84B1\", source: \"Golbez\" }\r\n\r\n119.0 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n126.3 \"Azdaja's Shadow\" Ability { id: \"86FF\", source: \"Golbez\" }\r\n136.4 \"--sync--\" Ability { id: \"8472\", source: \"Shadow Dragon\" }\r\n136.4 \"Black Fang (big)\" Ability { id: \"8471\", source: \"Golbez\" }\r\n140.3 \"Black Fang (small) x5\" Ability { id: \"871A\", source: \"Golbez\" }\r\n143.1 \"Black Fang (big)\" Ability { id: \"8474\", source: \"Golbez\" }\r\n\r\n# After this point, there's two possible sets of mechanics for each mini-phase\r\n# 8478 = type 1\r\n#   If buster is next, this leads to out + light parties, after exaflares if this is the 2nd/3rd iteration\r\n# 8479 = type 2\r\n#   If buster is next, this leads to in -> spread, after exaflares if this is the 2nd/3rd iteration\r\n\r\n\r\n144.4 \"--sync--\" Ability { id: \"8475\", source: \"Golbez\" }\r\n159.5 \"Azdaja's Shadow\" Ability { id: \"8478\", source: \"Golbez\" } jump 200\r\n159.5 \"--sync--\" Ability { id: \"8479\", source: \"Golbez\" } jump 300\r\n164.7 \"Flames of Eventide 1\"\r\n167.8 \"Flames of Eventide 2\"\r\n170.9 \"Flames of Eventide 3\"\r\n\r\n# Mini-phase 1, in then spread, or out then light parties\r\n\r\n# out -> light parties variation\r\n\r\n200.0 \"Azdaja's Shadow\" Ability { id: \"8478\", source: \"Golbez\" }\r\n205.2 \"Flames of Eventide 1\" Ability { id: \"847B\", source: \"Golbez\" }\r\n208.3 \"Flames of Eventide 2\" Ability { id: \"847B\", source: \"Golbez\" }\r\n211.4 \"Flames of Eventide 3\" Ability { id: \"847B\", source: \"Golbez\" }\r\n213.4 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n\r\n220.7 \"Phases of the Shadow (front)\" Ability { id: \"86E7\", source: \"Golbez\" }\r\n222.5 \"--sync--\" Ability { id: \"86E9\", source: \"Golbez\" }\r\n224.2 \"Phases of the Shadow (back)\" Ability { id: \"86EF\", source: \"Golbez\" }\r\n225.4 \"Rising Beacon (out)\" Ability { id: \"86EC\", source: \"Golbez\" }\r\n228.1 \"Immolating Shade (light parties)\" Ability { id: \"8496\", source: \"Golbez\" }\r\n228.7 \"--north--\" Ability { id: \"84B8\", source: \"Golbez\" } forcejump 400\r\n\r\n# in -> spread variation\r\n\r\n300.0 \"Azdaja's Shadow\" Ability { id: \"8479\", source: \"Golbez\" }\r\n305.2 \"Flames of Eventide 1\" Ability { id: \"847B\", source: \"Golbez\" }\r\n308.3 \"Flames of Eventide 2\" Ability { id: \"847B\", source: \"Golbez\" }\r\n311.4 \"Flames of Eventide 3\" Ability { id: \"847B\", source: \"Golbez\" }\r\n313.4 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n\r\n320.7 \"Phases of the Shadow (front)\" Ability { id: \"86E7\", source: \"Golbez\" }\r\n322.5 \"--sync--\" Ability { id: \"86E9\", source: \"Golbez\" }\r\n324.2 \"Phases of the Shadow (back)\" Ability { id: \"86EF\", source: \"Golbez\" }\r\n325.4 \"Rising Ring (under)\" Ability { id: \"86ED\", source: \"Golbez\" }\r\n328.1 \"Burning Shade (spread)\" Ability { id: \"8494\", source: \"Golbez\" }\r\n328.7 \"--north--\" Ability { id: \"84B8\", source: \"Golbez\" } forcejump 400\r\n\r\n\r\n# knockback phase\r\n\r\n400.0 \"--north--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n410.4 \"Dragon's Descent\" Ability { id: \"8498\", source: \"Shadow Dragon\" }\r\n412.8 \"Explosion\" Ability { id: \"849D\", source: \"Golbez\" }\r\n413.5 \"Double Meteor\" Ability { id: \"878C\", source: \"Golbez\" }\r\n415.1 \"Cauterize\" Ability { id: \"84A2\", source: \"Shadow Dragon\" }\r\n418.7 \"--sync--\" Ability { id: \"8475\", source: \"Golbez\" }\r\n436.8 \"Azdaja's Shadow\" Ability { id: \"8478\", source: \"Golbez\" } jump 500\r\n436.8 \"--sync--\" Ability { id: \"8479\", source: \"Golbez\" } jump 700\r\n\r\n# repeated for timeline rolling\r\n\r\n442.0 \"Flames of Eventide 1\"\r\n445.1 \"Flames of Eventide 2\"\r\n448.2 \"Flames of Eventide 3\"\r\n455.3 \"Void Stardust (preview)\"\r\n461.4 \"Void Stardust\"\r\n\r\n# Mini-phase 2, exaflares -> pairs -> role stacks or light parties -> out then light parties\r\n\r\n500.0 \"Azdaja's Shadow\" Ability { id: \"8478\", source: \"Golbez\" }\r\n505.2 \"Flames of Eventide 1\" Ability { id: \"847B\", source: \"Golbez\" }\r\n508.3 \"Flames of Eventide 2\" Ability { id: \"847B\", source: \"Golbez\" }\r\n511.4 \"Flames of Eventide 3\" Ability { id: \"847B\", source: \"Golbez\" }\r\n513.4 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n518.5 \"Void Stardust (preview)\" Ability { id: \"84A4\", source: \"Golbez\" }\r\n524.6 \"Void Stardust\" Ability { id: \"84A6\", source: \"Golbez\" } duration 2.3\r\n530.4 \"Abyssal Quasar\" Ability { id: \"84AB\", source: \"Golbez\" }\r\n535.4 \"Eventide Fall?\" Ability { id: \"8485\", source: \"Golbez\" }\r\n540.4 \"Eventide Triad?\" Ability { id: \"8480\", source: \"Golbez\" }\r\n548.5 \"Binding Cold\" Ability { id: \"84B3\", source: \"Golbez\" }\r\n\r\n556.6 \"Void Meteor\" Ability { id: \"84AD\", source: \"Golbez\" }\r\n556.7 \"Void Comet x4\" duration 3 #Ability { id: \"84B0\", source: \"Golbez\" }\r\n560.7 \"Void Meteor\" Ability { id: \"84B1\", source: \"Golbez\" }\r\n\r\n562.7 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n570.0 \"Phases of the Shadow (front)\" Ability { id: \"86E7\", source: \"Golbez\" }\r\n571.8 \"--sync--\" Ability { id: \"86E9\", source: \"Golbez\" }\r\n573.5 \"Phases of the Shadow (back)\" Ability { id: \"86EF\", source: \"Golbez\" }\r\n574.7 \"Rising Beacon (out)\" Ability { id: \"86EC\", source: \"Golbez\" }\r\n576.8 \"--sync--\" Ability { id: \"8475\", source: \"Golbez\" }\r\n577.2 \"Immolating Shade (light parties)\" Ability { id: \"8496\", source: \"Golbez\" } forcejump 1000\r\n\r\n\r\n# Mini-phase 2, exaflares -> pairs -> role stacks or light parties -> in then spread\r\n\r\n700.0 \"Azdaja's Shadow\" Ability { id: \"8479\", source: \"Golbez\" }\r\n705.2 \"Flames of Eventide 1\" Ability { id: \"847B\", source: \"Golbez\" }\r\n708.3 \"Flames of Eventide 2\" Ability { id: \"847B\", source: \"Golbez\" }\r\n711.4 \"Flames of Eventide 3\" Ability { id: \"847B\", source: \"Golbez\" }\r\n713.4 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n718.5 \"Void Stardust (preview)\" Ability { id: \"84A4\", source: \"Golbez\" }\r\n724.6 \"Void Stardust\" Ability { id: \"84A6\", source: \"Golbez\" } duration 2.3\r\n730.4 \"Abyssal Quasar\" Ability { id: \"84AB\", source: \"Golbez\" }\r\n735.4 \"Eventide Fall?\" Ability { id: \"8485\", source: \"Golbez\" }\r\n740.4 \"Eventide Triad?\" Ability { id: \"8480\", source: \"Golbez\" }\r\n748.5 \"Binding Cold\" Ability { id: \"84B3\", source: \"Golbez\" }\r\n\r\n756.6 \"Void Meteor\" Ability { id: \"84AD\", source: \"Golbez\" }\r\n756.7 \"Void Comet x4\" duration 3 #Ability { id: \"84B0\", source: \"Golbez\" }\r\n760.7 \"Void Meteor\" Ability { id: \"84B1\", source: \"Golbez\" }\r\n\r\n762.7 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n770.0 \"Phases of the Shadow (front)\" Ability { id: \"86E7\", source: \"Golbez\" }\r\n771.8 \"--sync--\" Ability { id: \"86E9\", source: \"Golbez\" }\r\n773.5 \"Phases of the Shadow (back)\" Ability { id: \"86EF\", source: \"Golbez\" }\r\n774.7 \"Rising Ring (under)\" Ability { id: \"86ED\", source: \"Golbez\" }\r\n776.8 \"--sync--\" Ability { id: \"8475\", source: \"Golbez\" }\r\n777.2 \"Burning Shade (spread)\" Ability { id: \"8494\", source: \"Golbez\" } forcejump 1000\r\n\r\n# terrastorm + light parties\r\n\r\n1000.0 \"Burning/Immolating Shade\"\r\n1007.8 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n1012.9 \"Terrastorm (cast)\" Ability { id: \"8464\", source: \"Golbez\" }\r\n1019.0 \"Arctic Assault\" Ability { id: \"845F\", source: \"Golbez\" }\r\n1022.0 \"Void Blizzard III\" Ability { id: \"8462\", source: \"Golbez\" }\r\n1022.0 \"Terrastorm (hit)\" Ability { id: \"8466\", source: \"Golbez\" }\r\n1029.1 \"Binding Cold\" Ability { id: \"84B3\", source: \"Golbez\" }\r\n\r\n# gale sphere + light parties or pairs mechanic\r\n# tornado = lp, aero = pairs\r\n\r\n1035.2 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n1040.3 \"Gale Sphere\" Ability { id: \"844D\", source: \"Golbez\" }\r\n1051.0 \"--sync--\" Ability { id: \"844E\", source: \"Golbez\" }\r\n1053.3 \"Void Tornado/Void Aero III\" Ability { id: \"845[CD]\", source: \"Golbez\" }\r\n1053.5 \"Gale Sphere 1\" Ability { id: \"845[89AB]\", source: \"Gale Sphere\" }\r\n1056.0 \"Arctic Assault\" Ability { id: \"845F\", source: \"Golbez\" }\r\n1057.0 \"Gale Sphere 2\" Ability { id: \"845[89AB]\", source: \"Gale Sphere\" }\r\n1060.4 \"Gale Sphere 3\" Ability { id: \"845[89AB]\", source: \"Gale Sphere\" }\r\n1063.8 \"Gale Sphere 4\" Ability { id: \"845[89AB]\", source: \"Gale Sphere\" }\r\n1065.0 \"Void Aero III/Void Tornado\" Ability { id: \"845[CD]\", source: \"Golbez\" }\r\n1069.1 \"Phases of the Blade (front)\" Ability { id: \"86DB\", source: \"Golbez\" }\r\n1071.0 \"--sync--\" Ability { id: \"86DD\", source: \"Golbez\" }\r\n1072.7 \"Phases of the Blade (back)\" Ability { id: \"86F2\", source: \"Golbez\" }\r\n1082.1 \"Binding Cold\" Ability { id: \"84B3\", source: \"Golbez\" }\r\n1098.2 \"Azdaja's Shadow\" Ability { id: \"8478\", source: \"Golbez\" } jump 1200\r\n1098.2 \"--sync--\" Ability { id: \"8479\", source: \"Golbez\" } jump 1400\r\n\r\n# repeated for timeline rolling\r\n\r\n1103.4 \"Flames of Eventide 1\"\r\n1106.5 \"Flames of Eventide 2\"\r\n1109.6 \"Flames of Eventide 3\"\r\n1116.7 \"Void Stardust (preview)\"\r\n1122.8 \"Void Stardust\"\r\n\r\n# Mini-phase 3, exaflares -> pairs -> role stacks or light parties -> out then light parties\r\n\r\n1200.0 \"Azdaja's Shadow\" Ability { id: \"8478\", source: \"Golbez\" }\r\n1205.2 \"Flames of Eventide 1\" Ability { id: \"847B\", source: \"Golbez\" }\r\n1208.3 \"Flames of Eventide 2\" Ability { id: \"847B\", source: \"Golbez\" }\r\n1211.4 \"Flames of Eventide 3\" Ability { id: \"847B\", source: \"Golbez\" }\r\n1213.4 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n1218.5 \"Void Stardust (preview)\" Ability { id: \"84A4\", source: \"Golbez\" }\r\n1224.6 \"Void Stardust\" Ability { id: \"84A6\", source: \"Golbez\" } duration 2.3\r\n1230.4 \"Abyssal Quasar\" Ability { id: \"84AB\", source: \"Golbez\" }\r\n1231.3 \"Lingering Spark (cast)\" Ability { id: \"8468\", source: \"Golbez\" }\r\n1235.4 \"Lingering Spark (explode)\" Ability { id: \"846A\", source: \"Golbez\" }\r\n1240.4 \"Eventide Fall/Eventide Triad\" Ability { id: \"848[05]\", source: \"Golbez\" }\r\n\r\n1251.4 \"Phases of the Shadow (front)\" Ability { id: \"86E7\", source: \"Golbez\" }\r\n1253.2 \"--sync--\" Ability { id: \"86E9\", source: \"Golbez\" }\r\n1254.9 \"Phases of the Shadow (back)\" Ability { id: \"86EF\", source: \"Golbez\" }\r\n1256.1 \"Rising Beacon (out)\" Ability { id: \"86EC\", source: \"Golbez\" }\r\n1258.2 \"--sync--\" Ability { id: \"8475\", source: \"Golbez\" }\r\n1258.6 \"Immolating Shade (light parties)\" Ability { id: \"8496\", source: \"Golbez\" } forcejump 1600\r\n\r\n# Mini-phase 3, exaflares -> pairs -> role stacks or light parties -> in then spread\r\n\r\n1400.0 \"Azdaja's Shadow\" Ability { id: \"8479\", source: \"Golbez\" }\r\n1405.2 \"Flames of Eventide 1\" Ability { id: \"847B\", source: \"Golbez\" }\r\n1408.3 \"Flames of Eventide 2\" Ability { id: \"847B\", source: \"Golbez\" }\r\n1411.4 \"Flames of Eventide 3\" Ability { id: \"847B\", source: \"Golbez\" }\r\n1413.4 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n1418.5 \"Void Stardust (preview)\" Ability { id: \"84A4\", source: \"Golbez\" }\r\n1424.6 \"Void Stardust\" Ability { id: \"84A6\", source: \"Golbez\" } duration 2.3\r\n1430.4 \"Abyssal Quasar\" Ability { id: \"84AB\", source: \"Golbez\" }\r\n1431.3 \"Lingering Spark (cast)\" Ability { id: \"8468\", source: \"Golbez\" }\r\n1435.4 \"Lingering Spark (explode)\" Ability { id: \"846A\", source: \"Golbez\" }\r\n1440.4 \"Eventide Fall/Eventide Triad\" Ability { id: \"848[05]\", source: \"Golbez\" }\r\n\r\n1451.4 \"Phases of the Shadow (front)\" Ability { id: \"86E7\", source: \"Golbez\" }\r\n1453.2 \"--sync--\" Ability { id: \"86E9\", source: \"Golbez\" }\r\n1454.9 \"Phases of the Shadow (back)\" Ability { id: \"86EF\", source: \"Golbez\" }\r\n1456.1 \"Rising Ring (under)\" Ability { id: \"86ED\", source: \"Golbez\" }\r\n1458.2 \"--sync--\" Ability { id: \"8475\", source: \"Golbez\" }\r\n1458.6 \"Burning Shade (spread)\" Ability { id: \"8494\", source: \"Golbez\" } forcejump 1600\r\n\r\n# knockback phase\r\n\r\n1600.0 \"Burning/Immolating Shade\"\r\n1600.4 \"--north--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n1610.8 \"Dragon's Descent\" Ability { id: \"8498\", source: \"Shadow Dragon\" }\r\n1613.2 \"Explosion\" Ability { id: \"849D\", source: \"Golbez\" }\r\n1613.9 \"Double Meteor\" Ability { id: \"878C\", source: \"Golbez\" }\r\n1615.5 \"Cauterize\" Ability { id: \"84A2\", source: \"Shadow Dragon\" }\r\n\r\n1618.9 \"--sync--\" Ability { id: \"8475\", source: \"Golbez\" }\r\n1629.0 \"Void Meteor\" Ability { id: \"84AD\", source: \"Golbez\" }\r\n1629.1 \"Void Comet x4\" duration 3 #Ability { id: \"84B0\", source: \"Golbez\" }\r\n1633.1 \"Void Meteor\" Ability { id: \"84B1\", source: \"Golbez\" }\r\n\r\n1640.2 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n1645.3 \"Gale Sphere\" Ability { id: \"844D\", source: \"Golbez\" }\r\n1656.0 \"--sync--\" Ability { id: \"844E\", source: \"Golbez\" }\r\n1658.3 \"Void Tornado/Void Aero III\" Ability { id: \"845[CD]\", source: \"Golbez\" }\r\n1658.5 \"Gale Sphere 1\" Ability { id: \"845[89AB]\", source: \"Gale Sphere\" }\r\n1661.0 \"Arctic Assault\" Ability { id: \"845F\", source: \"Golbez\" }\r\n1662.0 \"Gale Sphere 2\" Ability { id: \"845[89AB]\", source: \"Gale Sphere\" }\r\n1665.4 \"Gale Sphere 3\" Ability { id: \"845[89AB]\", source: \"Gale Sphere\" }\r\n1668.8 \"Gale Sphere 4\" Ability { id: \"845[89AB]\", source: \"Gale Sphere\" }\r\n1670.0 \"Void Aero III/Void Tornado\" Ability { id: \"845[CD]\", source: \"Golbez\" }\r\n1674.1 \"Phases of the Blade (front)\" Ability { id: \"86DB\", source: \"Golbez\" }\r\n1676.0 \"--sync--\" Ability { id: \"86DD\", source: \"Golbez\" }\r\n1677.7 \"Phases of the Blade (back)\" Ability { id: \"86F2\", source: \"Golbez\" }\r\n1687.1 \"Binding Cold\" Ability { id: \"84B3\", source: \"Golbez\" }\r\n1703.6 \"Azdaja's Shadow\" Ability { id: \"8478\", source: \"Golbez\" } jump 1800\r\n1703.6 \"--sync--\" Ability { id: \"8479\", source: \"Golbez\" } jump 1900\r\n\r\n# repeated for timeline rolling\r\n1708.8 \"Flames of Eventide 1\" #Ability { id: \"847B\", source: \"Golbez\" }\r\n1711.9 \"Flames of Eventide 2\" #Ability { id: \"847B\", source: \"Golbez\" }\r\n1715.0 \"Flames of Eventide 3\" #Ability { id: \"847B\", source: \"Golbez\" }\r\n1717.0 \"--middle--\" #Ability { id: \"84B8\", source: \"Golbez\" }\r\n1724.3 \"Phases of the Shadow (front)\" #Ability { id: \"86E7\", source: \"Golbez\" }\r\n1727.8 \"Phases of the Shadow (back)\" #Ability { id: \"86EF\", source: \"Golbez\" }\r\n\r\n# Mini-phase 4, in then spread, or out then light parties\r\n\r\n# out -> light parties variation\r\n\r\n1800.0 \"Azdaja's Shadow\" Ability { id: \"8478\", source: \"Golbez\" }\r\n1805.2 \"Flames of Eventide 1\" Ability { id: \"847B\", source: \"Golbez\" }\r\n1808.3 \"Flames of Eventide 2\" Ability { id: \"847B\", source: \"Golbez\" }\r\n1811.4 \"Flames of Eventide 3\" Ability { id: \"847B\", source: \"Golbez\" }\r\n1813.4 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n\r\n1820.7 \"Phases of the Shadow (front)\" Ability { id: \"86E7\", source: \"Golbez\" }\r\n1822.5 \"--sync--\" Ability { id: \"86E9\", source: \"Golbez\" }\r\n1824.2 \"Phases of the Shadow (back)\" Ability { id: \"86EF\", source: \"Golbez\" }\r\n1825.4 \"Rising Beacon (out)\" Ability { id: \"86EC\", source: \"Golbez\" }\r\n1828.1 \"Immolating Shade (light parties)\" Ability { id: \"8496\", source: \"Golbez\" } forcejump 2000\r\n\r\n# in -> spread variation\r\n\r\n1900.0 \"Azdaja's Shadow\" Ability { id: \"8479\", source: \"Golbez\" }\r\n1905.2 \"Flames of Eventide 1\" Ability { id: \"847B\", source: \"Golbez\" }\r\n1908.3 \"Flames of Eventide 2\" Ability { id: \"847B\", source: \"Golbez\" }\r\n1911.4 \"Flames of Eventide 3\" Ability { id: \"847B\", source: \"Golbez\" }\r\n\r\n1913.4 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n1920.7 \"Phases of the Shadow (front)\" Ability { id: \"86E7\", source: \"Golbez\" }\r\n1922.5 \"--sync--\" Ability { id: \"86E9\", source: \"Golbez\" }\r\n1924.2 \"Phases of the Shadow (back)\" Ability { id: \"86EF\", source: \"Golbez\" }\r\n1925.4 \"Rising Ring (under)\" Ability { id: \"86ED\", source: \"Golbez\" }\r\n1928.1 \"Burning Shade (spread)\" Ability { id: \"8494\", source: \"Golbez\" } forcejump 2000\r\n\r\n# final segment\r\n2000.0 \"Burning/Immolating Shade\"\r\n2009.3 \"Binding Cold\" Ability { id: \"84B3\", source: \"Golbez\" }\r\n2022.5 \"Binding Cold\" Ability { id: \"84B3\", source: \"Golbez\" }\r\n\r\n# last buster\r\n\r\n2030.6 \"Void Meteor\" Ability { id: \"84AD\", source: \"Golbez\" }\r\n2030.7 \"Void Comet x4\" duration 3 #Ability { id: \"84B0\", source: \"Golbez\" }\r\n2034.7 \"Void Meteor\" Ability { id: \"84B1\", source: \"Golbez\" }\r\n\r\n# enrage\r\n\r\n2038.7 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n2046.0 \"Azdaja's Shadow\" Ability { id: \"84B9\", source: \"Golbez\" }\r\n2055.1 \"--sync--\" Ability { id: \"84BB\", source: \"Shadow Dragon\" }\r\n2055.2 \"Black Fang (big)\" Ability { id: \"84BA\", source: \"Golbez\" }\r\n2059.1 \"Black Fang (small) x5\" Ability { id: \"871B\", source: \"Golbez\" }\r\n2061.9 \"Black Fang (Enrage)\" Ability { id: \"84BC\", source: \"Golbez\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/golbez.ts




const golbez_triggerSet = {
  id: 'TheVoidcastDais',
  zoneId: zone_id/* default.TheVoidcastDais */.Z.TheVoidcastDais,
  timelineFile: 'golbez.txt',
  initData: () => {
    return {
      galeSphereShadows: []
    };
  },
  triggers: [{
    id: 'Golbez Terrastorm',
    type: 'Ability',
    netRegex: {
      id: '8463',
      source: 'Golbez',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid meteor',
        de: 'Vermeide Meteor',
        fr: 'Évitez le météore',
        ja: 'メテオ回避',
        cn: '远离陨石',
        ko: '메테오 피하기'
      }
    }
  }, {
    id: 'Golbez Crescent Blade',
    type: 'StartsUsing',
    netRegex: {
      id: '846B',
      source: 'Golbez',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'Golbez Void Meteor',
    type: 'StartsUsing',
    netRegex: {
      id: '84AC',
      source: 'Golbez',
      capture: true
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Golbez Binding Cold',
    type: 'StartsUsing',
    netRegex: {
      id: '84B2',
      source: 'Golbez',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'Golbez Black Fang',
    type: 'StartsUsing',
    netRegex: {
      id: '8471',
      source: 'Golbez',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'Golbez Shadow Crescent',
    type: 'StartsUsing',
    netRegex: {
      id: '8487',
      source: 'Golbez',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get behind, then out',
        de: 'Geh hinter, dann raus',
        fr: 'Derrière puis extérieur',
        ja: '後ろ => 外へ',
        cn: '去背后 => 远离',
        ko: '보스 뒤로 => 밖으로'
      }
    }
  }, {
    id: 'Golbez Gale Sphere Directions',
    type: 'Ability',
    netRegex: {
      id: '84(?:4F|50|51|52)',
      source: 'Golbez\'s Shadow',
      capture: true
    },
    infoText: (data, matches, output) => {
      switch (matches.id) {
        case '844F':
          data.galeSphereShadows.push('dirN');
          break;
        case '8450':
          data.galeSphereShadows.push('dirE');
          break;
        case '8451':
          data.galeSphereShadows.push('dirW');
          break;
        case '8452':
          data.galeSphereShadows.push('dirS');
          break;
      }
      if (data.galeSphereShadows.length < 4) return;
      const [dir1, dir2, dir3, dir4] = data.galeSphereShadows;
      if (dir1 === undefined || dir2 === undefined || dir3 === undefined || dir4 === undefined) return;
      data.galeSphereShadows = [];
      return output.clones({
        dir1: output[dir1]() ?? output.unknown(),
        dir2: output[dir2]() ?? output.unknown(),
        dir3: output[dir3]() ?? output.unknown(),
        dir4: output[dir4]() ?? output.unknown()
      });
    },
    outputStrings: {
      clones: {
        en: 'Clones: ${dir1}->${dir2}->${dir3}->${dir4}',
        de: 'Klone: ${dir1}->${dir2}->${dir3}->${dir4}',
        fr: 'Clones : ${dir1}->${dir2}->${dir3}->${dir4}',
        ja: '${dir1}->${dir2}->${dir3}->${dir4}',
        cn: '分身：${dir1}->${dir2}->${dir3}->${dir4}',
        ko: '분신: ${dir1}->${dir2}->${dir3}->${dir4}'
      },
      unknown: outputs/* default.unknown */.Z.unknown,
      ...util/* Directions.outputStringsCardinalDir */.N.outputStringsCardinalDir
    }
  }, {
    id: 'Golbez Eventide Fall',
    type: 'StartsUsing',
    netRegex: {
      id: '8482',
      source: 'Golbez',
      capture: false
    },
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }, {
    id: 'Golbez Immolating Shade',
    type: 'StartsUsing',
    netRegex: {
      id: '8495',
      source: 'Golbez'
    },
    alertText: (data, matches, output) => {
      const target = data.party.member(matches.target);
      return output.text({
        player: target
      });
    },
    outputStrings: {
      text: {
        en: 'Out first => stack w/ ${player}',
        de: 'Zuerst Raus => Sammeln mit ${player}',
        fr: 'Extérieur d\'abord => package avec ${player}',
        ja: '外へ => あたまわり (${player})',
        cn: '远离 => 与 ${player} 分摊',
        ko: '밖으로 => ${player} 쉐어'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Golbez': 'Golbez',
      'Golbez\'s Shadow': 'Phantom-Golbez'
    },
    'replaceText': {
      '\\(preview\\)': '(Vorschau)',
      'Arctic Assault': 'Frostschuss',
      'Azdaja\'s Shadow': 'Azdajas Schatten',
      'Binding Cold': 'Eisfessel',
      'Black Fang': 'Schwarze Fänge',
      'Burning Shade': 'Brennender Schatten',
      'Crescent Blade': 'Sichelstreich',
      'Double Meteor': 'Doppel-Meteo',
      'Eventide Fall': 'Gebündelte Abendglut',
      'Explosion': 'Explosion',
      'Gale Sphere': 'Windsphäre',
      'Immolating Shade': 'Äschernder Schatten',
      'Lingering Spark': 'Lauernder Funke',
      'Rising Beacon': 'Hohes Fanal',
      'Shadow Crescent': 'Schwarzer Sichelstreich',
      'Terrastorm': 'Irdene Breitseite',
      'Void Meteor': 'Nichts-Meteo',
      'Void Stardust': 'Nichts-Sternenstaub'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Golbez': 'Golbez',
      'Golbez\'s Shadow': 'spectre de Golbez'
    },
    'replaceText': {
      'Arctic Assault': 'Assaut arctique',
      'Azdaja\'s Shadow': 'Ombre d\'Azdaja',
      'Binding Cold': 'Geôle glaciale',
      'Black Fang': 'Croc obscur',
      'Burning Shade': 'Ombre brûlante',
      'Crescent Blade': 'Lame demi-lune',
      'Double Meteor': 'Météore double',
      'Eventide Fall': 'Éclat crépusculaire concentré',
      'Explosion': 'Explosion',
      'Gale Sphere': 'Sphères de vent ténébreux',
      'Immolating Shade': 'Ombre incandescente',
      'Lingering Spark': 'Étincelle persistante',
      'Rising Beacon': 'Flambeau ascendant',
      'Shadow Crescent': 'Lame demi-lune obscure',
      'Terrastorm': 'Aérolithe flottant',
      'Void Meteor': 'Météore du néant',
      'Void Stardust': 'Pluie de comètes du néant'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Golbez': 'ゴルベーザ',
      'Golbez\'s Shadow': 'ゴルベーザの幻影'
    },
    'replaceText': {
      'Arctic Assault': 'コールドブラスト',
      'Azdaja\'s Shadow': '黒竜剣アジュダヤ',
      'Binding Cold': '呪縛の冷気',
      'Black Fang': '黒い牙',
      'Burning Shade': '黒炎',
      'Crescent Blade': '弦月剣',
      'Double Meteor': 'ダブルメテオ',
      'Eventide Fall': '集束黒竜閃',
      'Explosion': '爆発',
      'Gale Sphere': 'ウィンドスフィア',
      'Immolating Shade': '重黒炎',
      'Lingering Spark': 'ディレイスパーク',
      'Rising Beacon': '昇竜烽火',
      'Shadow Crescent': '弦月黒竜剣',
      'Terrastorm': 'ディレイアース',
      'Void Meteor': 'ヴォイド・メテオ',
      'Void Stardust': 'ヴォイド・コメットレイン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Golbez': '高贝扎',
      'Golbez\'s Shadow': '高贝扎的幻影'
    },
    'replaceText': {
      '\\(preview\\)': '(预览)',
      'Arctic Assault': '极寒突袭',
      'Azdaja\'s Shadow': '黑龙剑阿珠达雅',
      'Binding Cold': '咒缚寒气',
      'Black Fang': '黑牙',
      'Burning Shade': '黑炎',
      'Crescent Blade': '弦月剑',
      'Double Meteor': '双重陨石',
      'Eventide Fall': '集束黑龙闪',
      'Explosion': '爆炸',
      'Gale Sphere': '风晶球',
      'Immolating Shade': '重黑炎',
      'Lingering Spark': '迟缓电火花',
      'Rising Beacon': '升龙烽火',
      'Shadow Crescent': '弦月黑龙剑',
      'Terrastorm': '迟缓地暴',
      'Void Meteor': '虚空陨石',
      'Void Stardust': '虚空彗星雨'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Golbez': '골베자',
      'Golbez\'s Shadow': '골베자의 환영'
    },
    'replaceText': {
      '\\(preview\\)': '(예고)',
      'Arctic Assault': '냉기 작렬',
      'Azdaja\'s Shadow': '흑룡검 아주다야',
      'Binding Cold': '주박의 냉기',
      'Black Fang': '검은 이빨',
      'Burning Shade': '흑염',
      'Crescent Blade': '현월검',
      'Double Meteor': '더블 메테오',
      'Eventide Fall': '집속 흑룡섬',
      'Explosion': '폭발',
      'Gale Sphere': '바람 구체',
      'Immolating Shade': '중흑염',
      'Lingering Spark': '잔존 벼락',
      'Rising Beacon': '승룡봉화',
      'Shadow Crescent': '현월 흑룡검',
      'Terrastorm': '잔존 암석',
      'Void Meteor': '보이드 메테오',
      'Void Stardust': '보이드 혜성우'
    }
  }]
};
/* harmony default export */ const golbez = (golbez_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/golbez.txt
const trial_golbez_namespaceObject = "### The Voidcast Dais\r\n#\r\n# -ii 844B 8463 8460 84AE 84AF 8469 8719 86CF 8473 849B 878B 84B6 84A7 84A9 8483 86B3 8484\r\n# -it \"Golbez\"\r\n# -ic \"Gale Sphere\" \"Shadow Dragon\" \"Golbez's Shadow\"\r\n\r\n# Ignored Ids:\r\n#  - 844B      (autos)\r\n#  - 8463      Terrastorm (initial cast; meteor telegraph/damage is 8465)\r\n#  - 8460      Damage from Arctic Assault\r\n#  - 84AE      Damage from Void Comet (small initial hits from Void Meteor)\r\n#  - 84AF      Damage from Void Meteor (final larger hit from Void Meteor)\r\n#  - 8469      Damage from Lingering Spark puddles\r\n#  - 8719      Duplicative Black Fang\r\n#  - 86CF      Duplicative Black Fang\r\n#  - 8473      Duplicative Black Fang\r\n#  - 849B      Duplicative Explosion\r\n#  - 878B      Duplicative Double Meteor\r\n#  - 84B6      Duplicative Double Meteor\r\n#  - 84A7      sync/vfx?\r\n#  - 84A9      Subsequent meteors (+ damage) during Void Stardust\r\n#  - 8483      Duplicative Eventide Fall\r\n#  - 86B3      Duplicative Eventide Fall\r\n#  - 8484      sync/vfx?\r\n\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"--middle--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11.0 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" } window 12,12\r\n25.2 \"Terrastorm\" Ability { id: \"8465\", source: \"Golbez\" }\r\n30.3 \"Crescent Blade\" Ability { id: \"846B\", source: \"Golbez\" }\r\n37.0 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n42.1 \"Arctic Assault\" Ability { id: \"845E\", source: \"Golbez\" }\r\n50.3 \"Crescent Blade\" Ability { id: \"846B\", source: \"Golbez\" }\r\n60.9 \"Void Meteor\" Ability { id: \"84AC\", source: \"Golbez\" } duration 4\r\n69.1 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n74.2 \"Lingering Spark\" Ability { id: \"8467\", source: \"Golbez\" } duration 8\r\n86.5 \"Crescent Blade\" Ability { id: \"846B\", source: \"Golbez\" }\r\n97.1 \"Binding Cold\" Ability { id: \"84B2\", source: \"Golbez\" }\r\n106.3 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n113.6 \"Azdaja's Shadow\" Ability { id: \"86FE\", source: \"Golbez\" }\r\n113.6 \"--untargetable--\"\r\n128.6 \"--targetable--\"\r\n132.6 \"Black Fang\" Ability { id: \"8471\", source: \"Golbez\" } duration 6.5\r\n142.7 \"--sync--\" Ability { id: \"8475\", source: \"Golbez\" }\r\n150.8 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n156.8 \"Azdaja's Shadow\" Ability { id: \"8476\", source: \"Golbez\" }\r\n167.1 \"Shadow Crescent\" Ability { id: \"8487\", source: \"Golbez\" }\r\n169.4 \"Rising Beacon\" Ability { id: \"848F\", source: \"Golbez\" }\r\n172.2 \"Burning Shade\" Ability { id: \"8493\", source: \"Golbez\" }\r\n172.8 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n186.7 \"Explosion\" Ability { id: \"8499\", source: \"Golbez\" }\r\n191.1 \"Double Meteor\" Ability { id: \"84B4\", source: \"Golbez\" }\r\n194.2 \"--sync--\" Ability { id: \"8475\", source: \"Golbez\" }\r\n200.3 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n205.6 \"Gale Sphere\" Ability { id: \"844D\", source: \"Golbez\" }\r\n225.3 \"--sync--\" Ability { id: \"844E\", source: \"Golbez\" }\r\n234.3 \"Void Stardust (preview)\" Ability { id: \"84A3\", source: \"Golbez\" }\r\n238.2 \"Void Stardust\" Ability { id: \"84A5\", source: \"Golbez\" } duration 3\r\n248.5 \"Void Meteor\" Ability { id: \"84AC\", source: \"Golbez\" } duration 4\r\n259.7 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n265.7 \"Azdaja's Shadow\" Ability { id: \"8476\", source: \"Golbez\" }\r\n274.0 \"Lingering Spark\" Ability { id: \"8467\", source: \"Golbez\" } duration 8\r\n285.2 \"Eventide Fall\" Ability { id: \"8482\", source: \"Golbez\" } duration 4.6\r\n298.5 \"Gale Sphere\" Ability { id: \"844D\", source: \"Golbez\" }\r\n318.2 \"--sync--\" Ability { id: \"844E\", source: \"Golbez\" }\r\n325.5 \"Shadow Crescent\" Ability { id: \"8487\", source: \"Golbez\" }\r\n327.8 \"Rising Beacon\" Ability { id: \"848F\", source: \"Golbez\" }\r\n330.0 \"--sync--\" Ability { id: \"8475\", source: \"Golbez\" }\r\n331.4 \"Immolating Shade\" Ability { id: \"8495\", source: \"Golbez\" }\r\n\r\n# begin loop\r\n340.1 \"Binding Cold\" Ability { id: \"84B2\", source: \"Golbez\" }\r\n346.3 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n352.3 \"Azdaja's Shadow\" Ability { id: \"8476\", source: \"Golbez\" }\r\n360.5 \"Void Stardust (preview)\" Ability { id: \"84A3\", source: \"Golbez\" }\r\n364.4 \"Void Stardust\" Ability { id: \"84A5\", source: \"Golbez\" } duration 3\r\n370.7 \"Arctic Assault\" Ability { id: \"845E\", source: \"Golbez\" }\r\n386.9 \"Terrastorm\" Ability { id: \"8465\", source: \"Golbez\" }\r\n391.2 \"Shadow Crescent\" Ability { id: \"8487\", source: \"Golbez\" }\r\n393.5 \"Rising Beacon\" Ability { id: \"848F\", source: \"Golbez\" }\r\n396.3 \"Burning Shade\" Ability { id: \"8493\", source: \"Golbez\" }\r\n396.9 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n410.9 \"Explosion\" Ability { id: \"849A\", source: \"Golbez\" }\r\n415.3 \"Double Meteor\" Ability { id: \"84B4\", source: \"Golbez\" }\r\n418.4 \"--sync--\" Ability { id: \"8475\", source: \"Golbez\" }\r\n431.5 \"Void Meteor\" Ability { id: \"84AC\", source: \"Golbez\" } duration 4\r\n441.7 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n447.7 \"Azdaja's Shadow\" Ability { id: \"8476\", source: \"Golbez\" }\r\n456.1 \"Lingering Spark\" Ability { id: \"8467\", source: \"Golbez\" } duration 8\r\n467.3 \"Eventide Fall\" Ability { id: \"8482\", source: \"Golbez\" } duration 4.6\r\n480.4 \"Gale Sphere\" Ability { id: \"844D\", source: \"Golbez\" }\r\n500.1 \"--sync--\" Ability { id: \"844E\", source: \"Golbez\" }\r\n507.4 \"Shadow Crescent\" Ability { id: \"8487\", source: \"Golbez\" }\r\n509.7 \"Rising Beacon\" Ability { id: \"848F\", source: \"Golbez\" }\r\n511.9 \"--sync--\" Ability { id: \"8475\", source: \"Golbez\" }\r\n\r\n# jump + fake loop\r\n522.0 \"Binding Cold\" Ability { id: \"84B2\", source: \"Golbez\" } window 60,60 jump 340.1\r\n528.2 \"--middle--\" Ability { id: \"84B8\", source: \"Golbez\" }\r\n534.2 \"Azdaja's Shadow\" Ability { id: \"8476\", source: \"Golbez\" }\r\n542.4 \"Void Stardust (preview)\" Ability { id: \"84A3\", source: \"Golbez\" }\r\n546.3 \"Void Stardust\" Ability { id: \"84A5\", source: \"Golbez\" }\r\n552.6 \"Arctic Assault\" Ability { id: \"845E\", source: \"Golbez\" }\r\n568.8 \"Terrastorm\" Ability { id: \"8465\", source: \"Golbez\" }\r\n572.9 \"Shadow Crescent\" Ability { id: \"8487\", source: \"Golbez\" }\r\n575.2 \"Rising Beacon\" Ability { id: \"848F\", source: \"Golbez\" }\r\n\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/hydaelyn-ex.ts




// TODO: how to call out crystal LOS???
// TODO: call Chakram stack locations / direction to run
// TODO: call out intercard to run to in the final phase
// TODO: Lightwave has different ids, do these mean anything?
const storedMechanicsOutputStrings = {
  spread: outputs/* default.spread */.Z.spread,
  groups: {
    en: 'Healer Groups',
    de: 'Heiler-Gruppen',
    fr: 'Groupes sur les heals',
    ja: 'ヒラに頭割り',
    cn: '治疗分组分摊',
    ko: '힐러 그룹 쉐어'
  },
  stack: {
    en: 'Party Stack',
    de: 'Mit der Party sammeln',
    fr: 'Package en équipe',
    ja: '全員集合',
    cn: '全体分摊',
    ko: '파티 전체 쉐어'
  }
};
const crystallizeOutputStrings = {
  ...storedMechanicsOutputStrings,
  crystallize: {
    en: 'Crystallize: ${name}',
    de: 'Kristalisieren: ${name}',
    fr: 'Cristallisation : ${name}',
    ja: 'クリスタライズ: ${name}',
    cn: '水晶化: ${name}',
    ko: '크리스탈화: ${name}'
  }
};
const comboOutputStrings = {
  ...storedMechanicsOutputStrings,
  combo: {
    en: '${first} => ${second}',
    de: '${first} => ${second}',
    fr: '${first} => ${second}',
    ja: '${first} => ${second}',
    cn: '${first} => ${second}',
    ko: '${first} => ${second}'
  }
};
const hydaelyn_ex_triggerSet = {
  id: 'TheMinstrelsBalladHydaelynsCall',
  zoneId: zone_id/* default.TheMinstrelsBalladHydaelynsCall */.Z.TheMinstrelsBalladHydaelynsCall,
  timelineFile: 'hydaelyn-ex.txt',
  timelineTriggers: [{
    id: 'HydaelynEx Marker Equinox',
    // There is no 8E1 effect here (maybe because it is deterministic?) so use a timeline trigger.
    regex: /Equinox/,
    beforeSeconds: 3.5,
    durationSeconds: data => data.crystallize ? 6.5 : 3.5,
    alertText: (data, _matches, output) => {
      if (data.crystallize) return output.combo({
        first: output.intercards(),
        second: output[data.crystallize]()
      });
      return output.intercards();
    },
    run: data => delete data.crystallize,
    outputStrings: {
      ...comboOutputStrings,
      intercards: {
        en: 'Intercards',
        de: 'Interkardinal',
        fr: 'Intercardinal',
        ja: '斜めへ',
        cn: '四角',
        ko: '대각선 쪽으로'
      }
    }
  }],
  triggers: [{
    id: 'HydaelynEx Heros\'s Radiance',
    type: 'StartsUsing',
    netRegex: {
      id: '65C1',
      source: 'Hydaelyn',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'HydaelynEx Shining Saber',
    type: 'StartsUsing',
    netRegex: {
      id: '68C8',
      source: 'Hydaelyn',
      capture: false
    },
    // In the final phase, there's a Shining Saber -> Crystalline Water III section.
    durationSeconds: data => data.crystallize ? 7 : 4,
    alertText: (data, _matches, output) => {
      if (data.crystallize) return output.combo({
        first: output.stack(),
        second: output[data.crystallize]()
      });
      return output.stack();
    },
    run: data => delete data.crystallize,
    outputStrings: comboOutputStrings
  }, {
    id: 'HydaelynEx Magos\'s Raidance',
    type: 'StartsUsing',
    netRegex: {
      id: '65C2',
      source: 'Hydaelyn',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'HydaelynEx Parhelion Tracker',
    type: 'StartsUsing',
    netRegex: {
      id: '65B0',
      source: 'Hydaelyn',
      capture: false
    },
    run: data => data.parhelion = true
  }, {
    id: 'HydaelynEx Crystallize Water',
    type: 'Ability',
    // We could call this out on startsUsing, but no action needs to be taken for ~17 seconds,
    // and so just call this out on the action.
    netRegex: {
      id: ['659A', '6ED5'],
      source: 'Hydaelyn',
      capture: false
    },
    infoText: (_data, _matches, output) => output.crystallize({
      name: output.groups()
    }),
    run: data => data.crystallize = 'groups',
    outputStrings: crystallizeOutputStrings
  }, {
    // During Parhelion, there's a Crystallize Water with no mechanic in between.
    id: 'HydaelynEx Crystallize Water Parhelion',
    type: 'Ability',
    netRegex: {
      id: ['659A', '6ED5'],
      source: 'Hydaelyn',
      capture: false
    },
    condition: data => data.parhelion,
    // There's 10 seconds between Crystallize Water ability and action in this one case.
    // Subparhelion occurs ~2s before, but that's too soon.
    delaySeconds: 5,
    alertText: (_data, _matches, output) => output.groups(),
    run: data => {
      delete data.crystallize;
      delete data.parhelion;
    },
    outputStrings: {
      groups: crystallizeOutputStrings.groups
    }
  }, {
    id: 'HydaelynEx Crystallize Ice',
    type: 'Ability',
    netRegex: {
      id: ['659C', '659D'],
      source: 'Hydaelyn',
      capture: false
    },
    infoText: (_data, _matches, output) => output.crystallize({
      name: output.spread()
    }),
    run: data => data.crystallize = 'spread',
    outputStrings: crystallizeOutputStrings
  }, {
    id: 'HydaelynEx Crystallize Stone',
    type: 'Ability',
    netRegex: {
      id: ['659B', '659E'],
      source: 'Hydaelyn',
      capture: false
    },
    infoText: (_data, _matches, output) => output.crystallize({
      name: output.stack()
    }),
    run: data => data.crystallize = 'stack',
    outputStrings: crystallizeOutputStrings
  }, {
    id: 'HydaelynEx Marker Anthelion',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8E1',
      source: 'Hydaelyn',
      count: '1B5',
      capture: false
    },
    // Example timeline:
    //     t=0 StartsCasting Crystallize
    //     t=4 ActionEffect Crystalize
    //     t=7 StatusAdd 81E (this regex)
    //     t=9.5 marker appears
    //     t=13 ActionEffect Anthelion
    //     t=17 ActionEffect Crystalline Blizzard
    //
    // We could call this out immediately, but then it's very close to the Crystallize call.
    // Additionally, if we call this out immediately then players have to remember something
    // for 10 seconds.  A delay of 2.5 feels more natural in terms of time to react and
    // handle this, rather than calling it out extremely early.  Also, add a duration so that
    // this stays on screen until closer to the Crystalline action.  This also puts this call
    // closer to when the marker appears on screen, and so feels a little bit more natural.
    delaySeconds: 2.5,
    durationSeconds: data => data.crystallize ? 6.5 : 3.5,
    alertText: (data, _matches, output) => {
      if (data.crystallize) return output.combo({
        first: output.in(),
        second: output[data.crystallize]()
      });
      return output.in();
    },
    run: data => delete data.crystallize,
    outputStrings: {
      ...comboOutputStrings,
      in: outputs/* default.in */.Z["in"]
    }
  }, {
    id: 'HydaelynEx Marker Highest Holy',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8E1',
      source: 'Hydaelyn',
      count: '1B4',
      capture: false
    },
    delaySeconds: 2.5,
    durationSeconds: data => data.crystallize ? 6.5 : 3.5,
    alertText: (data, _matches, output) => {
      if (data.crystallize) return output.combo({
        first: output.out(),
        second: output[data.crystallize]()
      });
      return output.out();
    },
    run: data => delete data.crystallize,
    outputStrings: {
      ...comboOutputStrings,
      out: outputs/* default.out */.Z.out
    }
  }, {
    id: 'HydaelynEx Aureole',
    type: 'StartsUsing',
    netRegex: {
      id: ['6C91', '6F11'],
      source: 'Hydaelyn',
      capture: false
    },
    // Late in the fight there is a Crystallize -> Aureole combo.
    alertText: (data, _matches, output) => {
      if (data.crystallize) return output.combo({
        first: output.sides(),
        second: output[data.crystallize]()
      });
      return output.sides();
    },
    run: data => delete data.crystallize,
    outputStrings: {
      ...comboOutputStrings,
      sides: outputs/* default.sides */.Z.sides
    }
  }, {
    id: 'HydaelynEx Lateral Aureole',
    type: 'StartsUsing',
    netRegex: {
      id: ['65C5', '6F13'],
      source: 'Hydaelyn',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.crystallize) return output.combo({
        first: output.frontBack(),
        second: output[data.crystallize]()
      });
      return output.frontBack();
    },
    run: data => delete data.crystallize,
    outputStrings: {
      ...comboOutputStrings,
      frontBack: outputs/* default.goFrontBack */.Z.goFrontBack
    }
  }, {
    id: 'HydaelynEx Mousa\'s Scorn',
    type: 'StartsUsing',
    netRegex: {
      id: '65C0',
      source: 'Hydaelyn'
    },
    response: responses/* Responses.sharedTankBuster */.n3.sharedTankBuster()
  }, {
    id: 'HydaelynEx Crystal of Light',
    type: 'Ability',
    netRegex: {
      id: '65BE',
      source: 'Crystal of Light',
      capture: true
    },
    // Each of the three adds fires every 1.1s or so until about Exodus or their death
    suppressSeconds: 60,
    infoText: (data, matches, output) => {
      // North Crystals: (87.87, 93.00),  (100.00, 86.00), (112.12, 93)
      // South Crystals: (87.87, 107.00), (100.00, 114.00), (112.12, 107.00)
      const isSouthFirst = parseFloat(matches.y) > 100;
      if (data.role === 'tank') return output.dirEchoes({
        dir: isSouthFirst ? output.north() : output.south()
      });
      return output.dirCrystals({
        dir: isSouthFirst ? output.south() : output.north()
      });
    },
    outputStrings: {
      dirCrystals: {
        en: '${dir} Crystals first',
        de: 'Kristall im ${dir} zuerst',
        fr: 'Premiers cristaux au ${dir} ',
        ja: '${dir}のクリスタルから',
        cn: '先攻击 ${dir} 水晶',
        ko: '${dir} 크리스탈 먼저'
      },
      dirEchoes: {
        en: 'Move Echoes ${dir} first',
        de: 'Bewege Echoes zuerst nach ${dir}',
        fr: 'Déplacez les échos au ${dir} en premier',
        ja: '${dir}に誘導',
        cn: '先拉回声到 ${dir} ',
        ko: '쫄 ${dir}으로 먼저 데려가기'
      },
      north: outputs/* default.north */.Z.north,
      south: outputs/* default.south */.Z.south
    }
  }, {
    id: 'HydaelynEx Exodus',
    type: 'Ability',
    netRegex: {
      id: '6B55',
      source: 'Hydaelyn',
      capture: false
    },
    // 14.8 seconds from this ability (no cast) to 662B raidwide.
    delaySeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'HydaelynEx Halo',
    type: 'StartsUsing',
    netRegex: {
      id: '65A5',
      source: 'Hydaelyn',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'HydaelynEx Radiant Halo',
    type: 'StartsUsing',
    netRegex: {
      id: '6B54',
      source: 'Hydaelyn',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'HydaelynEx Heros\'s Sundering',
    type: 'StartsUsing',
    netRegex: {
      id: '65BF',
      source: 'Hydaelyn'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave('alert')
  }, {
    id: 'HydaelynEx Infralateral Arc',
    type: 'StartsUsing',
    netRegex: {
      id: '6669',
      source: 'Hydaelyn',
      capture: false
    },
    durationSeconds: 4,
    infoText: (_data, _matches, output) => output.rolePositions(),
    outputStrings: {
      rolePositions: {
        en: 'Role positions',
        de: 'Rollenposition',
        fr: 'Positions par rôle',
        ja: 'ロール特定位置へ',
        cn: '去指定位置',
        ko: '직업별 산개위치로'
      }
    }
  }, {
    id: 'HydaelynEx Heros\'s Glory',
    type: 'StartsUsing',
    netRegex: {
      id: '65A8',
      source: 'Hydaelyn',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'HydaelynEx Parhelic Circle',
    type: 'StartsUsing',
    netRegex: {
      id: '65AC',
      source: 'Hydaelyn',
      capture: false
    },
    durationSeconds: 9,
    alertText: (_data, _matches, output) => {
      // This is always crystallize === 'spread'.
      return output.combo({
        first: output.avoid(),
        second: output.spread()
      });
    },
    run: data => delete data.crystallize,
    outputStrings: {
      ...comboOutputStrings,
      avoid: {
        en: 'Avoid Line Ends',
        de: 'Weiche den Enden der Linien aus',
        fr: 'Évitez les fins de lignes',
        ja: '線の端から離れる',
        cn: '远离线',
        ko: '선의 끝부분 피하기'
      }
    }
  }, {
    id: 'HydaelynEx Echoes',
    type: 'StartsUsing',
    netRegex: {
      id: '65B5',
      source: 'Hydaelyn',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack 5x',
        de: '5x Sammeln',
        fr: '5x Packages',
        ja: '頭割り５回',
        cn: '5连分摊',
        ko: '쉐어 5번'
      }
    }
  }, {
    id: 'HydaelynEx Bright Spectrum',
    type: 'StartsUsing',
    netRegex: {
      id: '65B9',
      source: 'Hydaelyn'
    },
    preRun: (data, matches) => (data.brightSpectrumStack ??= []).push(matches.target),
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.spread();
    },
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread
    }
  }, {
    // In practice, this cast begins after the Bright Spectrum casts.
    id: 'HydaelynEx Dichroic Spectrum',
    type: 'StartsUsing',
    netRegex: {
      id: '65B8',
      source: 'Hydaelyn'
    },
    infoText: (data, matches, output) => {
      if (data.brightSpectrumStack?.includes(data.me)) return;
      if (data.me === matches.target || data.role === 'tank') return output.sharedTankbuster();
    },
    run: data => delete data.brightSpectrumStack,
    outputStrings: {
      sharedTankbuster: outputs/* default.sharedTankbuster */.Z.sharedTankbuster
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Crystal of Light': 'Lichtkristall',
      'Hydaelyn': 'Hydaelyn',
      'Mystic Refulgence': 'Truglicht',
      'Parhelion': 'Parhelion'
    },
    'replaceText': {
      '--transition--': '--Übergang--',
      '--top-middle': '--Oben-Mitte',
      '--middle': '--Mitte',
      'Anthelion': 'Anthelion',
      'Aureole': 'Aureole',
      'Beacon': 'Lichtschein',
      'Bright Spectrum': 'Gleißendes Spektrum',
      'Crystalline Blizzard III': 'Kristall-Eisga',
      'Crystalline Stone III': 'Kristall-Steinga',
      'Crystalline Water/Stone III': 'Kristall-Aquaga/Steinga',
      'Crystalline Water III': 'Kristall-Aquaga',
      'Crystallize': 'Kristallisieren',
      'Dichroic Spectrum': 'Dichroitisches Spektrum',
      'Echoes': 'Echos',
      'Equinox': 'Äquinoktium',
      'Exodus': 'Exodus',
      '(?<!Radiant )Halo': 'Halo',
      'Heros\'s Glory': 'Glorie des Heros',
      'Heros\'s Radiance': 'Glanz des Heros',
      'Heros\'s Sundering': 'Schlag des Heros',
      'Highest Holy': 'Höchstes Sanctus',
      'Incandescence': 'Inkandeszenz',
      'Infralateral Arc': 'Infralateralbogen',
      'Lateral Aureole': 'Lateralaureole',
      'Light of the Crystal': 'Licht des Kristalls',
      'Lightwave': 'Lichtwoge',
      'Magos\'s Radiance': 'Glanz des Magos',
      'Mousa\'s Scorn': 'Zorn der Mousa',
      'Parhelic Circle': 'Horizontalkreis',
      '(?<!Sub)Parhelion': 'Parhelion',
      'Pure Crystal': 'Reiner Kristall',
      'Radiant Halo': 'Strahlender Halo',
      'Shining Saber': 'Strahlender Säbel',
      'Subparhelion': 'Subparhelion'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Crystal of Light': 'Cristal De Lumière',
      'Hydaelyn': 'Hydaelyn',
      'Mystic Refulgence': 'illusion de Lumière',
      'Parhelion': 'Parhélie'
    },
    'replaceText': {
      '\\?': ' ?',
      '--top-middle': '--En haut au milieu',
      '--middle': '--Milieu',
      'Anthelion': 'Anthélie',
      'Aureole/Lateral Aureole': 'Auréole/Auréole latérale',
      'Beacon': 'Rayon de Lumière',
      'Bright Spectrum': 'Spectre lumineux',
      'Crystalline Blizzard III': 'Méga Glace cristallisée',
      'Crystalline Stone III': 'Méga Terre cristallisée',
      'Crystalline Water III': 'Méga Eau cristallisée',
      'Crystalline Water/Stone III': 'Méga Eau/Terre cristallisée',
      'Crystallize': 'Cristallisation',
      'Dichroic Spectrum': 'Spectre dichroïque',
      'Echoes': 'Échos',
      'Equinox': 'Équinoxe',
      'Exodus': 'Exode',
      '(?<!Radiant )Halo': 'Halo',
      'Heros\'s Glory': 'Gloire du héros',
      'Heros\'s Radiance': 'Radiance du héros',
      'Heros\'s Sundering': 'Fragmentation du héros',
      'Highest Holy': 'Miracle suprême',
      'Incandescence': 'Incandescence',
      'Infralateral Arc': 'Arc infralatéral',
      'Light of the Crystal': 'Lumière du cristal',
      'Lightwave': 'Vague de Lumière',
      'Magos\'s Radiance': 'Radiance du mage',
      'Mousa\'s Scorn': 'Mépris de la muse',
      'Parhelic Circle': 'Cercle parhélique',
      '(?<!Sub)Parhelion': 'Parhélie',
      'Pure Crystal': 'Cristal pur',
      'Radiant Halo': 'Halo radiant',
      'Shining Saber': 'Sabre de brillance',
      'Subparhelion': 'Subparhélie'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Crystal of Light': '光のクリスタル',
      'Hydaelyn': 'ハイデリン',
      'Mystic Refulgence': '幻想光',
      'Parhelion': 'パルヘリオン'
    },
    'replaceText': {
      '--middle': '--中央',
      '--top-middle': '--中央前方',
      'Anthelion': 'アントゥヘリオン',
      'Aureole/Lateral Aureole': '(サイド?) オーレオール',
      'Beacon': '光芒',
      'Bright Spectrum': 'ブライトスペクトル',
      'Crystalline Blizzard III': 'クリスタル・ブリザガ',
      'Crystalline Stone III': 'クリスタル・ストンガ',
      'Crystalline Water III': 'クリスタル・ウォタガ',
      'Crystalline Water/Stone III': 'クリスタル・ウォタガ/ストンガ',
      'Crystallize': 'クリスタライズ',
      'Dichroic Spectrum': 'ダイクロイックスペクトル',
      'Echoes': 'エコーズ',
      'Equinox': 'エクイノックス',
      'Exodus': 'エクソダス',
      '(?<!Radiant )Halo': 'ヘイロー',
      'Heros\'s Glory': 'ヘロイスグローリー',
      'Heros\'s Radiance': 'ヘロイスラジエンス',
      'Heros\'s Sundering': 'ヘロイスサンダリング',
      'Highest Holy': 'ハイエストホーリー',
      'Incandescence': '幻閃光',
      'Infralateral Arc': 'ラテラルアーク',
      'Light of the Crystal': 'ライト・オブ・クリスタル',
      'Lightwave': 'ライトウェーブ',
      'Magos\'s Radiance': 'マゴスラジエンス',
      'Mousa\'s Scorn': 'ムーサスコーン',
      'Parhelic Circle': 'パーヘリックサークル',
      '(?<!Sub)Parhelion': 'パルヘリオン',
      'Pure Crystal': 'ピュアクリスタル',
      'Radiant Halo': 'レディアントヘイロー',
      'Shining Saber': 'シャイニングセイバー',
      'Subparhelion': 'サブパルヘリオン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Crystal of Light': '光之水晶',
      'Hydaelyn': '海德林',
      'Mystic Refulgence': '幻想光',
      'Parhelion': '幻日'
    },
    'replaceText': {
      '--top-middle': '--前方中间',
      '--middle': '--中间',
      'Anthelion': '反假日',
      'Aureole': '晕光',
      'Beacon': '光芒',
      'Bright Spectrum': '明亮光谱',
      'Crystalline Blizzard III': '水晶冰封',
      'Crystalline Stone III': '水晶垒石',
      'Crystalline Water III': '水晶狂水',
      'Crystalline Water/Stone III': '水晶狂水/垒石',
      'Crystallize': '结晶',
      'Dichroic Spectrum': '二色光谱',
      'Echoes': '回声',
      'Equinox': '昼夜二分',
      'Exodus': '众生离绝',
      '(?<!Radiant )Halo': '光环',
      'Heros\'s Glory': '守护者的荣耀',
      'Heros\'s Radiance': '守护者的光辉',
      'Heros\'s Sundering': '守护者的斩断',
      'Highest Holy': '至高神圣',
      'Incandescence': '幻闪光',
      'Infralateral Arc': '外侧晕弧',
      'Lateral Aureole': '侧晕光',
      'Light of the Crystal': '水晶之光',
      'Lightwave': '光波',
      'Magos\'s Radiance': '魔法师的光辉',
      'Mousa\'s Scorn': '演艺家的蔑视',
      'Parhelic Circle': '幻日环',
      '(?<!Sub)Parhelion': '幻日',
      'Pure Crystal': '纯净水晶',
      'Radiant Halo': '明辉光环',
      'Shining Saber': '光芒刃',
      'Subparhelion': '映幻日'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Crystal of Light': '빛의 크리스탈',
      'Hydaelyn': '하이델린',
      'Mystic Refulgence': '환상빛',
      'Parhelion': '무리해'
    },
    'replaceText': {
      '--top-middle': '--위쪽 중앙',
      '--middle': '--중앙',
      'Anthelion': '맞무리해',
      'Aureole': '후광',
      'Beacon': '광망',
      'Bright Spectrum': '환한 분광',
      'Crystalline Blizzard III': '크리스탈 블리자가',
      'Crystalline Stone III': '크리스탈 스톤가',
      'Crystalline Water III': '크리스탈 워터가',
      'Crystalline Water/Stone III': '크리스탈 워터가/스톤가',
      'Crystallize': '크리스탈화',
      'Dichroic Spectrum': '이분광',
      'Echoes': '되울림',
      'Equinox': '이분점',
      'Exodus': '엑소더스',
      'Heros\'s Glory': '헤로이스의 영광',
      'Heros\'s Radiance': '헤로이스의 광휘',
      'Heros\'s Sundering': '헤로이스의 절단',
      'Highest Holy': '지고의 홀리',
      'Incandescence': '환섬광',
      'Infralateral Arc': '접선호',
      'Lateral Aureole': '측면 후광',
      'Light of the Crystal': '크리스탈의 빛',
      'Lightwave': '빛의 파도',
      'Magos\'s Radiance': '마고스의 광휘',
      'Mousa\'s Scorn': '무사의 경멸',
      'Parhelic Circle': '무리해고리',
      'Pure Crystal': '순수 크리스탈',
      'Radiant Halo': '눈부신 빛무리',
      'Shining Saber': '찬란한 검',
      'Subparhelion': '무리햇빛',
      '(?<!Radiant )Halo': '빛무리',
      '(?<!Sub)Parhelion': '무리해'
    }
  }]
};
/* harmony default export */ const hydaelyn_ex = (hydaelyn_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/hydaelyn-ex.txt
const trial_hydaelyn_ex_namespaceObject = "### Hydaelyn Extreme\r\n# -p 65BC:336.2 65BB:1433.6\r\n# -ii 65A7 6F12 65BA 6507 65AA 6596 6690 65BE 686C 6C92\r\n# -it Hydaelyn\r\n# -it Echo of Hydaelyn\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11.0 \"--sync--\" StartsUsing { id: \"65C1\", source: \"Hydaelyn\" } window 15,15\r\n16.0 \"Heros's Radiance\" Ability { id: \"65C1\", source: \"Hydaelyn\" }\r\n26.1 \"Shining Saber\" Ability { id: \"68C8\", source: \"Hydaelyn\" }\r\n\r\n# Crystallize 1\r\n35.6 \"Crystallize\" Ability { id: \"659A\", source: \"Hydaelyn\" }\r\n44.8 \"--sync--\" Ability { id: \"6598\", source: \"Hydaelyn\" } jump 144.8\r\n44.8 \"--sync--\" Ability { id: \"6594\", source: \"Hydaelyn\" } jump 242.9\r\n\r\n44.8 \"Highest Holy/Anthelion?\" #Ability { id: [\"6598\", \"6594\"], source: \"Hydaelyn\" }\r\n47.9 \"--sync--\" #Ability { id: \"65A[01]\", source: \"Hydaelyn\" }\r\n48.8 \"Crystalline Water III\" #Ability { id: \"65A2\", source: \"Hydaelyn\" }\r\n56.4 \"Magos's Radiance/Mousa's Scorn?\" #Ability { id: [\"65C2\", \"65C0\"], source: \"Hydaelyn\" }\r\n66.6 \"Aureole/Lateral Aureole?\" #Ability { id: [\"6C91\", \"6F13\"], source: \"Hydaelyn\" }\r\n\r\n\r\n# Highest Holy first\r\n144.8 \"Highest Holy\" Ability { id: \"6598\", source: \"Hydaelyn\" }\r\n147.9 \"--sync--\" Ability { id: \"65A0\", source: \"Hydaelyn\" }\r\n148.8 \"Crystalline Water III\" Ability { id: \"65A2\", source: \"Hydaelyn\" }\r\n156.4 \"Magos's Radiance\" Ability { id: \"65C2\", source: \"Hydaelyn\" }\r\n166.6 \"Aureole/Lateral Aureole\" Ability { id: [\"6C91\", \"6F13\"], source: \"Hydaelyn\" }\r\n175.7 \"Crystallize\" Ability { id: \"659C\", source: \"Hydaelyn\" }\r\n184.9 \"Anthelion\" Ability { id: \"6594\", source: \"Hydaelyn\" }\r\n188.0 \"--sync--\" Ability { id: \"65A1\", source: \"Hydaelyn\" }\r\n188.9 \"Crystalline Blizzard III\" Ability { id: \"65A4\", source: \"Hydaelyn\" }\r\n197.1 \"Mousa's Scorn\" Ability { id: \"65C0\", source: \"Hydaelyn\" }\r\n\r\n207.3 \"Aureole/Lateral Aureole\" Ability { id: [\"6F11\", \"65C5\"], source: \"Hydaelyn\" } jump 307.1\r\n216.6 \"Crystallize\" #Ability { id: [\"659E\", \"6ED5\", \"659A\", \"659B\"], source: \"Hydaelyn\" }\r\n225.8 \"Equinox\" #Ability { id: \"65C3\", source: \"Hydaelyn\" }\r\n228.9 \"--sync--\" #Ability { id: \"659F\", source: \"Hydaelyn\" }\r\n229.8 \"Crystalline Water/Stone III\" #Ability { id: \"65A[23]\", source: \"Hydaelyn\" }\r\n231.9 \"--untargetable--\"\r\n\r\n\r\n# Anthelion first\r\n242.9 \"Anthelion\" Ability { id: \"6594\", source: \"Hydaelyn\" }\r\n246.0 \"--sync--\" Ability { id: \"65A1\", source: \"Hydaelyn\" }\r\n246.9 \"Crystalline Water III\" Ability { id: \"65A2\", source: \"Hydaelyn\" }\r\n255.1 \"Mousa's Scorn\" Ability { id: \"65C0\", source: \"Hydaelyn\" }\r\n265.3 \"Aureole/Lateral Aureole\" Ability { id: [\"6F11\", \"65C5\"], source: \"Hydaelyn\" }\r\n276.1 \"Crystallize\" Ability { id: \"659D\", source: \"Hydaelyn\" }\r\n285.3 \"Highest Holy\" Ability { id: \"6598\", source: \"Hydaelyn\" }\r\n288.4 \"--sync--\" Ability { id: \"65A0\", source: \"Hydaelyn\" }\r\n289.2 \"Crystalline Blizzard III\" Ability { id: \"65A4\", source: \"Hydaelyn\" }\r\n296.9 \"Magos's Radiance\" Ability { id: \"65C2\", source: \"Hydaelyn\" }\r\n# -> naturally into Crystallize 3 (or jump from above)\r\n\r\n# Crystallize 3 (Equinox and Water/Stone)\r\n307.1 \"Aureole/Lateral Aureole\" Ability { id: [\"6C91\", \"6F13\"], source: \"Hydaelyn\" }\r\n316.4 \"Crystallize\" Ability { id: [\"659E\", \"6ED5\", \"659A\", \"659B\"], source: \"Hydaelyn\" }\r\n325.6 \"Equinox\" Ability { id: \"65C3\", source: \"Hydaelyn\" }\r\n328.7 \"--sync--\" Ability { id: \"659F\", source: \"Hydaelyn\" }\r\n329.6 \"Crystalline Water/Stone III\" Ability { id: \"65A[23]\", source: \"Hydaelyn\" }\r\n331.7 \"--untargetable--\"\r\n\r\n\r\n# Adds\r\n336.2 \"--sync--\" Ability { id: \"65BC\", source: \"Hydaelyn\" } window 350,10\r\n344.3 \"Pure Crystal\" Ability { id: \"65BD\", source: \"Hydaelyn\" }\r\n344.3 \"--targetable--\"\r\n\r\n1433.6 \"Exodus\" Ability { id: \"65BB\", source: \"Hydaelyn\" } window 2000,10\r\n1448.4 \"Exodus\" Ability { id: \"662B\", source: \"Hydaelyn\" }\r\n1453.7 \"--targetable--\"\r\n1468.8 \"Halo\" Ability { id: \"65A5\", source: \"Hydaelyn\" }\r\n\r\n\r\n# Lightwave 1\r\n1476.9 \"Lightwave\" Ability { id: \"6693\", source: \"Hydaelyn\" }\r\n1488.7 \"Light of the Crystal\" #Ability { id: \"65A6\", source: \"Hydaelyn\" }\r\n1490.7 \"--top-middle--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n1490.8 \"Light of the Crystal\" #Ability { id: \"65A6\", source: \"Hydaelyn\" }\r\n1496.6 \"Infralateral Arc x3\" Ability { id: \"6669\", source: \"Hydaelyn\" } duration 3.2\r\n1497.8 \"Light of the Crystal\" Ability { id: \"65A6\", source: \"Hydaelyn\" }\r\n\r\n# Lightwave 2\r\n1505.8 \"Lightwave\" Ability { id: \"6693\", source: \"Hydaelyn\" }\r\n1509.0 \"--top-middle--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n1515.4 \"Heros's Glory\" Ability { id: \"65A8\", source: \"Hydaelyn\" }\r\n1520.5 \"Light of the Crystal\" Ability { id: \"65A6\", source: \"Hydaelyn\" }\r\n1523.9 \"Light of the Crystal\" Ability { id: \"65A6\", source: \"Hydaelyn\" }\r\n1527.1 \"Light of the Crystal\" #Ability { id: \"65A6\", source: \"Hydaelyn\" }\r\n1528.7 \"--top-middle--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n1529.9 \"Light of the Crystal\" Ability { id: \"65A6\", source: \"Hydaelyn\" }\r\n1535.1 \"Heros's Glory\" Ability { id: \"65A8\", source: \"Hydaelyn\" }\r\n1536.3 \"Light of the Crystal\" Ability { id: \"65A6\", source: \"Hydaelyn\" }\r\n1544.6 \"Halo\" Ability { id: \"65A5\", source: \"Hydaelyn\" }\r\n1555.7 \"Heros's Sundering\" Ability { id: \"65BF\", source: \"Hydaelyn\" }\r\n1565.8 \"Shining Saber\" Ability { id: \"68C8\", source: \"Hydaelyn\" }\r\n\r\n# Parhelion or Parhelic Circle\r\n1575.3 \"--sync--\" Ability { id: \"6594\", source: \"Hydaelyn\" } jump 1675.3\r\n1575.3 \"--sync--\" Ability { id: \"6598\", source: \"Hydaelyn\" } jump 1966.1\r\n1575.3 \"Anthelion/Highest Holy?\" #Ability { id: [\"6594\", \"6598\"], source: \"Hydaelyn\" }\r\n1585.5 \"Mousa's Scorn/Magos's Radiance?\" #Ability { id: [\"65C0\", \"65C2\"], source: \"Hydaelyn\" }\r\n1590.7 \"--middle?--\" #Ability { id: \"6E7A\", source: \"Hydaelyn\" }\r\n1594.6 \"Crystallize?\" #Ability { id: \"659C\", source: \"Hydaelyn\" }\r\n1597.2 \"Parhelion?\" Ability { id: [\"65B0\", \"65AC\"], source: \"Hydaelyn\" }\r\n1597.8 \"--top-middle?--\" #Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n1605.4 \"Parhelic Circle?\" #Ability { id: \"65AC\", source: \"Hydaelyn\" }\r\n\r\n\r\n# Parhelion first\r\n1675.3 \"Anthelion\" Ability { id: \"6594\", source: \"Hydaelyn\" }\r\n1685.5 \"Mousa's Scorn\" Ability { id: \"65C0\", source: \"Hydaelyn\" }\r\n1690.7 \"--middle--\" Ability { id: \"6E7A\", source: \"Hydaelyn\" }\r\n1697.2 \"Parhelion\" Ability { id: \"65B0\", source: \"Hydaelyn\" }\r\n1697.5 \"Beacon 1\" #Ability { id: \"65B2\", source: \"Parhelion\" }\r\n1699.1 \"Beacon 2\" #Ability { id: \"65B2\", source: \"Parhelion\" }\r\n1700.7 \"Beacon 3\" #Ability { id: \"65B2\", source: \"Parhelion\" }\r\n1706.0 \"Crystallize\" Ability { id: \"6ED5\", source: \"Hydaelyn\" }\r\n1714.1 \"Subparhelion\" Ability { id: \"6C56\", source: \"Hydaelyn\" }\r\n1716.1 \"Crystalline Water III\" Ability { id: \"65A2\", source: \"Hydaelyn\" }\r\n1716.3 \"Beacon 1\" #Ability { id: \"65B3\", source: \"Parhelion\" }\r\n1717.2 \"--sync--\" Ability { id: \"65A1\", source: \"Hydaelyn\" }\r\n1717.9 \"Beacon 2\" #Ability { id: \"65B3\", source: \"Parhelion\" }\r\n1719.5 \"Beacon 3\" #Ability { id: \"65B3\", source: \"Parhelion\" }\r\n1724.4 \"Aureole/Lateral Aureole\" Ability { id: [\"6F11\", \"65C5\"], source: \"Hydaelyn\" }\r\n\r\n1733.5 \"Highest Holy\" Ability { id: \"6598\", source: \"Hydaelyn\" }\r\n1743.6 \"Magos's Radiance\" Ability { id: \"65C2\", source: \"Hydaelyn\" }\r\n1752.7 \"Crystallize\" Ability { id: \"659C\", source: \"Hydaelyn\" }\r\n1755.9 \"--top-middle--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n1763.5 \"Parhelic Circle\" Ability { id: \"65AC\", source: \"Hydaelyn\" }\r\n1764.3 \"--sync--\" Ability { id: \"65AE\", source: \"Mystic Refulgence\" }\r\n1765.4 \"Incandescence\" Ability { id: \"65AF\", source: \"Mystic Refulgence\" }\r\n1766.7 \"--sync--\" Ability { id: \"65A0\", source: \"Hydaelyn\" }\r\n1768.9 \"Crystalline Blizzard III\" Ability { id: \"65A4\", source: \"Hydaelyn\" }\r\n1774.7 \"Aureole/Lateral Aureole\" Ability { id: [\"6C91\", \"6F13\"], source: \"Hydaelyn\" }\r\n1783.8 \"Equinox\" Ability { id: \"65C3\", source: \"Hydaelyn\" }\r\n1791.0 \"--middle--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n1797.6 \"Radiant Halo\" Ability { id: \"65B4\", source: \"Hydaelyn\" }\r\n\r\n1806.7 \"Lightwave\" Ability { id: \"669[345]\", source: \"Hydaelyn\" } jump 2206.7\r\n1826.3 \"Echoes x5\" #Ability { id: \"65B5\", source: \"Hydaelyn\" } duration 4.5\r\n1834.0 \"Bright Spectrum\" #Ability { id: \"65B9\", source: \"Hydaelyn\" }\r\n1834.0 \"Dichroic Spectrum\" #Ability { id: \"65B8\", source: \"Hydaelyn\" }\r\n1846.3 \"Crystallize\" #Ability { id: \"659A\", source: \"Hydaelyn\" }\r\n\r\n\r\n# Parhelic Circle first\r\n1966.1 \"Highest Holy\" Ability { id: \"6598\", source: \"Hydaelyn\" }\r\n1976.3 \"Magos's Radiance\" Ability { id: \"65C2\", source: \"Hydaelyn\" }\r\n1985.4 \"Crystallize\" Ability { id: \"659C\", source: \"Hydaelyn\" }\r\n1988.6 \"--top-middle--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n1996.3 \"Parhelic Circle\" Ability { id: \"65AC\", source: \"Hydaelyn\" }\r\n1997.1 \"--sync--\" Ability { id: \"65AE\", source: \"Mystic Refulgence\" }\r\n1998.2 \"Incandescence\" Ability { id: \"65AF\", source: \"Mystic Refulgence\" }\r\n1999.5 \"--sync--\" Ability { id: \"65A0\", source: \"Hydaelyn\" }\r\n2001.7 \"Crystalline Blizzard III\" Ability { id: \"65A4\", source: \"Hydaelyn\" }\r\n2007.6 \"Aureole/Lateral Aureole\" Ability { id: [\"6C91\", \"6F13\"], source: \"Hydaelyn\" }\r\n\r\n2016.7 \"Anthelion\" Ability { id: \"6594\", source: \"Hydaelyn\" }\r\n2026.9 \"Mousa's Scorn\" Ability { id: \"65C0\", source: \"Hydaelyn\" }\r\n2032.1 \"--middle--\" Ability { id: \"6E7A\", source: \"Hydaelyn\" }\r\n2038.7 \"Parhelion\" Ability { id: \"65B0\", source: \"Hydaelyn\" }\r\n2039.0 \"Beacon 1\" #Ability { id: \"65B2\", source: \"Parhelion\" }\r\n2040.6 \"Beacon 2\" #Ability { id: \"65B2\", source: \"Parhelion\" }\r\n2042.2 \"Beacon 3\" #Ability { id: \"65B2\", source: \"Parhelion\" }\r\n2047.5 \"Crystallize\" Ability { id: \"6ED5\", source: \"Hydaelyn\" }\r\n2055.6 \"Subparhelion\" Ability { id: \"6C56\", source: \"Hydaelyn\" }\r\n2057.6 \"Crystalline Water III\" Ability { id: \"65A2\", source: \"Hydaelyn\" }\r\n2057.8 \"Beacon 1\" #Ability { id: \"65B3\", source: \"Parhelion\" }\r\n2058.7 \"--sync--\" Ability { id: \"65A1\", source: \"Hydaelyn\" }\r\n2059.4 \"Beacon 2\" #Ability { id: \"65B3\", source: \"Parhelion\" }\r\n2061.0 \"Beacon 3\" #Ability { id: \"65B3\", source: \"Parhelion\" }\r\n2065.8 \"Aureole/Lateral Aureole\" Ability { id: [\"6F11\", \"65C5\"], source: \"Hydaelyn\" }\r\n2074.9 \"Equinox\" Ability { id: \"65C3\", source: \"Hydaelyn\" }\r\n2082.1 \"--top-middle--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n2088.6 \"Radiant Halo\" Ability { id: \"65B4\", source: \"Hydaelyn\" }\r\n\r\n2097.7 \"Lightwave\" Ability { id: \"669[345]\", source: \"Hydaelyn\" } jump 2206.7\r\n2117.2 \"Echoes x5\" #Ability { id: \"65B5\", source: \"Hydaelyn\" }\r\n2125.0 \"Bright Spectrum\" #Ability { id: \"65B9\", source: \"Hydaelyn\" }\r\n2125.0 \"Dichroic Spectrum\" #Ability { id: \"65B8\", source: \"Hydaelyn\" }\r\n2137.3 \"Crystallize\" #Ability { id: \"659A\", source: \"Hydaelyn\" }\r\n\r\n\r\n# Lightwave 3\r\n2206.7 \"Lightwave\" Ability { id: \"669[345]\", source: \"Hydaelyn\" }\r\n2226.3 \"Echoes x5\" Ability { id: \"65B5\", source: \"Hydaelyn\" } duration 4.5\r\n2234.0 \"Bright Spectrum\" Ability { id: \"65B9\", source: \"Hydaelyn\" }\r\n2234.0 \"Dichroic Spectrum\" Ability { id: \"65B8\", source: \"Hydaelyn\" }\r\n\r\n2246.3 \"Crystallize\" Ability { id: \"659A\", source: \"Hydaelyn\" }\r\n2253.9 \"Shining Saber\" Ability { id: \"68C8\", source: \"Hydaelyn\" }\r\n2258.2 \"Crystalline Water III\" Ability { id: \"65A2\", source: \"Hydaelyn\" }\r\n2263.2 \"Highest Holy/Anthelion\" Ability { id: [\"6594\", \"6598\"], source: \"Hydaelyn\" }\r\n2266.3 \"--sync--\" Ability { id: \"65A[01]\", source: \"Hydaelyn\" }\r\n\r\n# Lightwave 4\r\n2274.4 \"Lightwave\" Ability { id: \"669[345]\", source: \"Hydaelyn\" }\r\n2293.9 \"Echoes x5\" Ability { id: \"65B[67]\", source: \"Hydaelyn\" }\r\n2301.8 \"Bright Spectrum\" Ability { id: \"65B9\", source: \"Hydaelyn\" }\r\n2301.8 \"Dichroic Spectrum\" Ability { id: \"65B8\", source: \"Hydaelyn\" }\r\n\r\n2314.0 \"Crystallize\" Ability { id: \"659[CD]\", source: \"Hydaelyn\" }\r\n2321.7 \"Aureole/Lateral Aureole\" Ability { id: [\"6C91\", \"6F13\", \"6F11\", \"65C5\"], source: \"Hydaelyn\" }\r\n2325.9 \"Crystalline Blizzard III\" Ability { id: \"65A4\", source: \"Hydaelyn\" }\r\n2330.9 \"Highest Holy/Anthelion\" Ability { id: [\"6594\", \"6598\"], source: \"Hydaelyn\" }\r\n2334.0 \"--sync--\" Ability { id: \"65A[01]\", source: \"Hydaelyn\" }\r\n\r\n2342.1 \"Crystallize\" Ability { id: \"659E\", source: \"Hydaelyn\" }\r\n2350.3 \"Aureole/Lateral Aureole\" Ability { id: [\"6C91\", \"6F13\", \"6F11\", \"65C5\"], source: \"Hydaelyn\" }\r\n2354.5 \"Crystalline Stone III\" Ability { id: \"65A3\", source: \"Hydaelyn\" }\r\n2359.5 \"Equinox\" Ability { id: \"65C3\", source: \"Hydaelyn\" }\r\n\r\n2362.6 \"--sync--\" Ability { id: \"659F\", source: \"Hydaelyn\" }\r\n2369.7 \"--sync--\" StartsUsing { id: \"5FFB\", source: \"Hydaelyn\" } window 100,10\r\n2379.7 \"Heros's Radiance Enrage\" Ability { id: \"5FFB\", source: \"Hydaelyn\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/hydaelyn.ts





// TODO: Lightwave has different ids, do these mean anything?

const hydaelyn_storedMechanicsOutputStrings = {
  spread: outputs/* default.spread */.Z.spread,
  stack: {
    en: 'Party Stack',
    de: 'Mit der Party sammeln',
    fr: 'Package en groupe',
    ja: '全員集合',
    cn: '全体分摊',
    ko: '파티 전체 쉐어'
  }
};
const hydaelyn_crystallizeOutputStrings = {
  ...hydaelyn_storedMechanicsOutputStrings,
  crystallize: {
    en: 'Crystallize: ${name}',
    de: 'Kristalisieren: ${name}',
    fr: 'Cristallisation : ${name}',
    ja: 'クリスタライズ: ${name}',
    cn: '水晶化: ${name}',
    ko: '크리스탈화: ${name}'
  }
};
const hydaelyn_comboOutputStrings = {
  ...hydaelyn_storedMechanicsOutputStrings,
  combo: {
    en: '${first} => ${second}',
    de: '${first} => ${second}',
    fr: '${first} => ${second}',
    ja: '${first} => ${second}',
    cn: '${first} => ${second}',
    ko: '${first} => ${second}'
  }
};

// Hydaelyn Normal Mode
const hydaelyn_triggerSet = {
  id: 'TheMothercrystal',
  zoneId: zone_id/* default.TheMothercrystal */.Z.TheMothercrystal,
  timelineFile: 'hydaelyn.txt',
  triggers: [{
    id: 'Hydaelyn Heros\'s Radiance',
    type: 'StartsUsing',
    netRegex: {
      id: '65D7',
      source: 'Hydaelyn',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hydaelyn Magos\'s Raidance',
    type: 'StartsUsing',
    netRegex: {
      id: '65D8',
      source: 'Hydaelyn',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hydaelyn Crystallize Ice',
    type: 'Ability',
    netRegex: {
      id: '659C',
      source: 'Hydaelyn',
      capture: false
    },
    infoText: (_data, _matches, output) => output.crystallize({
      name: output.spread()
    }),
    run: data => data.crystallize = 'spread',
    outputStrings: hydaelyn_crystallizeOutputStrings
  }, {
    id: 'Hydaelyn Crystallize Stone',
    type: 'Ability',
    netRegex: {
      id: '659E',
      source: 'Hydaelyn',
      capture: false
    },
    infoText: (_data, _matches, output) => output.crystallize({
      name: output.stack()
    }),
    run: data => data.crystallize = 'stack',
    outputStrings: hydaelyn_crystallizeOutputStrings
  }, {
    id: 'Hydaelyn Dawn Mantle Equinox',
    type: 'StartsUsing',
    // Equinox is more complicated in normal mode than extreme.
    // There is no 8E1 effect for Equinox (a parser bug?), and there are some places where
    // it is used randomly and not in fixed places, and so it can't just be a timeline trigger.
    // However, in normal mode, Dawn Mantle is always cast prior to the marker appearing,
    // so assume any Dawn Mantle is Equinox unless we figure out otherwise.
    netRegex: {
      id: '6C0C',
      source: 'Hydaelyn',
      capture: false
    },
    preRun: data => data.isEquinox = true,
    // Dawn Mantle is a 4.9s cast, plus the normal 2.5s delay.  (See Anthelion comment below.)
    delaySeconds: 2.5 + 4.9,
    durationSeconds: data => data.crystallize ? 6.5 : 3.5,
    alertText: (data, _matches, output) => {
      // If we've gotten some 8E1 effect, ignore this.
      if (!data.isEquinox) return;
      if (data.crystallize) return output.combo({
        first: output.intercards(),
        second: output[data.crystallize]()
      });
      return output.intercards();
    },
    run: data => {
      // Don't clear the crystallize if it's going to be used for Anthelion or Highest Holy.
      if (data.isEquinox) delete data.crystallize;
    },
    outputStrings: {
      ...hydaelyn_comboOutputStrings,
      intercards: {
        en: 'Intercards',
        de: 'Interkardinal',
        fr: 'Intercardinal',
        ja: '斜めへ',
        cn: '四角',
        ko: '대각선 쪽으로'
      }
    }
  }, {
    id: 'Hydaelyn Marker Anthelion',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8E1',
      source: 'Hydaelyn',
      count: '1B5',
      capture: false
    },
    // Example timeline:
    //     t=0 StartsCasting Crystallize
    //     t=4 ActionEffect Crystalize
    //     t=7 StatusAdd 81E (this regex)
    //     t=9.5 marker appears
    //     t=13 ActionEffect Anthelion
    //     t=17 ActionEffect Crystalline Blizzard
    //
    // We could call this out immediately, but then it's very close to the Crystallize call.
    // Additionally, if we call this out immediately then players have to remember something
    // for 10 seconds.  A delay of 2.5 feels more natural in terms of time to react and
    // handle this, rather than calling it out extremely early.  Also, add a duration so that
    // this stays on screen until closer to the Crystalline action.  This also puts this call
    // closer to when the marker appears on screen, and so feels a little bit more natural.
    preRun: data => data.isEquinox = false,
    delaySeconds: 2.5,
    durationSeconds: data => data.crystallize ? 6.5 : 3.5,
    alertText: (data, _matches, output) => {
      if (data.crystallize) return output.combo({
        first: output.in(),
        second: output[data.crystallize]()
      });
      return output.in();
    },
    run: data => delete data.crystallize,
    outputStrings: {
      ...hydaelyn_comboOutputStrings,
      in: outputs/* default.in */.Z["in"]
    }
  }, {
    id: 'Hydaelyn Marker Highest Holy',
    type: 'GainsEffect',
    netRegex: {
      effectId: '8E1',
      source: 'Hydaelyn',
      count: '1B4',
      capture: false
    },
    preRun: data => data.isEquinox = false,
    delaySeconds: 2.5,
    durationSeconds: data => data.crystallize ? 6.5 : 3.5,
    alertText: (data, _matches, output) => {
      if (data.crystallize) return output.combo({
        first: output.out(),
        second: output[data.crystallize]()
      });
      return output.out();
    },
    run: data => delete data.crystallize,
    outputStrings: {
      ...hydaelyn_comboOutputStrings,
      out: outputs/* default.out */.Z.out
    }
  }, {
    id: 'Hydaelyn Mousa\'s Scorn',
    type: 'StartsUsing',
    netRegex: {
      id: '65D6',
      source: 'Hydaelyn'
    },
    response: responses/* Responses.sharedTankBuster */.n3.sharedTankBuster()
  }, {
    id: 'Hydaelyn Exodus',
    type: 'Ability',
    netRegex: {
      id: '65BB',
      source: 'Hydaelyn',
      capture: false
    },
    // 14.8 seconds from this ability (no cast) to 662B raidwide.
    delaySeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hydaelyn Radiant Halo',
    type: 'StartsUsing',
    netRegex: {
      id: '65D0',
      source: 'Hydaelyn',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Hydaelyn Heros\'s Sundering',
    type: 'StartsUsing',
    netRegex: {
      id: '65D5',
      source: 'Hydaelyn'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave('alert')
  }, {
    id: 'Hydaelyn Echo Crystaline Stone III',
    type: 'StartsUsing',
    // Midphase stack.
    netRegex: {
      id: '6C59',
      source: 'Echo of Hydaelyn',
      capture: false
    },
    alertText: (_data, _matches, output) => output.stack(),
    outputStrings: {
      stack: hydaelyn_crystallizeOutputStrings.stack
    }
  }, {
    id: 'Hydaelyn Echo Crystaline Blizzard III',
    type: 'StartsUsing',
    // Midphase spread.
    netRegex: {
      id: '6C5A',
      source: 'Echo of Hydaelyn'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.spread(),
    outputStrings: {
      spread: hydaelyn_crystallizeOutputStrings.spread
    }
  }, {
    id: 'Hydaelyn Parhelic Circle',
    type: 'StartsUsing',
    netRegex: {
      id: '65AC',
      source: 'Hydaelyn',
      capture: false
    },
    durationSeconds: 9,
    alertText: (_data, _matches, output) => output.avoid(),
    run: data => delete data.crystallize,
    outputStrings: {
      avoid: {
        en: 'Avoid Line Ends',
        de: 'Weiche den Enden der Linien aus',
        fr: 'Évitez les fins de lignes',
        ja: '線の端から離れる',
        cn: '远离线',
        ko: '선의 끝부분 피하기'
      }
    }
  }, {
    id: 'Hydaelyn Echoes',
    type: 'StartsUsing',
    netRegex: {
      id: '65B[567]',
      source: 'Hydaelyn',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack 5x',
        de: '5x Sammeln',
        fr: '5x Packages',
        ja: '頭割り５回',
        cn: '5连分摊',
        ko: '쉐어 5번'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Crystalline Blizzard III/Crystalline Stone III': 'Crystalline Blizzard/Stone III'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Echo of Hydaelyn': 'Echo der Hydaelyn',
      '(?<!of )Hydaelyn': 'Hydaelyn',
      'Mystic Refulgence': 'Truglicht'
    },
    'replaceText': {
      'Anthelion': 'Anthelion',
      'Beacon': 'Lichtschein',
      'Crystalline Blizzard III': 'Kristall-Eisga',
      'Crystalline Stone III': 'Kristall-Steinga',
      'Crystallize': 'Kristallisieren',
      'Dawn Mantle': 'Neuer Mantel',
      'Echoes': 'Echos',
      'Equinox': 'Äquinoktium',
      'Exodus': 'Exodus',
      'Heros\'s Radiance': 'Glanz des Heros',
      'Heros\'s Sundering': 'Schlag des Heros',
      'Highest Holy': 'Höchstes Sanctus',
      'Hydaelyn\'s Ray': 'Strahl der Hydaelyn',
      'Incandescence': 'Inkandeszenz',
      'Lightwave': 'Lichtwoge',
      'Magos\'s Radiance': 'Glanz des Magos',
      'Mousa\'s Scorn': 'Zorn der Mousa',
      'Parhelic Circle': 'Horizontalkreis',
      '(?<!Sub)Parhelion': 'Parhelion',
      'Radiant Halo': 'Strahlender Halo',
      'Subparhelion': 'Subparhelion'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Echo of Hydaelyn': 'écho d\'Hydaelyn',
      '(?<!of )Hydaelyn': 'Hydaelyn',
      'Mystic Refulgence': 'illusion de Lumière'
    },
    'replaceText': {
      '\\?': ' ?',
      'Anthelion': 'Anthélie',
      'Beacon': 'Rayon de Lumière',
      'Crystalline Blizzard III': 'Méga Glace cristallisée',
      'Crystalline Stone III': 'Méga Terre cristallisée',
      'Crystallize': 'Cristallisation',
      'Dawn Mantle': 'Changement de cape',
      'Echoes': 'Échos',
      'Equinox': 'Équinoxe',
      'Exodus': 'Exode',
      'Heros\'s Radiance': 'Radiance du héros',
      'Heros\'s Sundering': 'Fragmentation du héros',
      'Highest Holy': 'Miracle suprême',
      'Hydaelyn\'s Ray': 'Rayon d\'Hydaelyn',
      'Incandescence': 'Incandescence',
      'Lightwave': 'Vague de Lumière',
      'Magos\'s Radiance': 'Radiance du mage',
      'Mousa\'s Scorn': 'Mépris de la muse',
      'Parhelic Circle': 'Cercle parhélique',
      '(?<!Sub)Parhelion': 'Parhélie',
      'Radiant Halo': 'Halo radiant',
      'Subparhelion': 'Subparhélie'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Echo of Hydaelyn': 'ハイデリン・エコー',
      '(?<!of )Hydaelyn': 'ハイデリン',
      'Mystic Refulgence': '幻想光'
    },
    'replaceText': {
      'Anthelion': 'アントゥヘリオン',
      'Beacon': '光芒',
      'Crystalline Blizzard III': 'クリスタル・ブリザガ',
      'Crystalline Stone III': 'クリスタル・ストンガ',
      'Crystallize': 'クリスタライズ',
      'Dawn Mantle': 'マントチェンジ',
      'Echoes': 'エコーズ',
      'Equinox': 'エクイノックス',
      'Exodus': 'エクソダス',
      'Heros\'s Radiance': 'ヘロイスラジエンス',
      'Heros\'s Sundering': 'ヘロイスサンダリング',
      'Highest Holy': 'ハイエストホーリー',
      'Hydaelyn\'s Ray': 'ハイデリンレイ',
      'Incandescence': '幻閃光',
      'Lightwave': 'ライトウェーブ',
      'Magos\'s Radiance': 'マゴスラジエンス',
      'Mousa\'s Scorn': 'ムーサスコーン',
      'Parhelic Circle': 'パーヘリックサークル',
      '(?<!Sub)Parhelion': 'パルヘリオン',
      'Radiant Halo': 'レディアントヘイロー',
      'Subparhelion': 'サブパルヘリオン'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Echo of Hydaelyn': '海德林的回声',
      '(?<!of )Hydaelyn': '海德林',
      'Mystic Refulgence': '幻想光'
    },
    'replaceText': {
      'Anthelion': '反假日',
      'Beacon': '光芒',
      'Crystalline Blizzard III': '水晶冰封',
      'Crystalline Stone III': '水晶垒石',
      'Crystallize': '结晶',
      'Dawn Mantle': '职责更换',
      'Echoes': '回声',
      'Equinox': '昼夜二分',
      'Exodus': '众生离绝',
      'Heros\'s Radiance': '守护者的光辉',
      'Heros\'s Sundering': '守护者的斩断',
      'Highest Holy': '至高神圣',
      'Hydaelyn\'s Ray': '海德林光线',
      'Incandescence': '幻闪光',
      'Lightwave': '光波',
      'Magos\'s Radiance': '魔法师的光辉',
      'Mousa\'s Scorn': '演艺家的蔑视',
      'Parhelic Circle': '幻日环',
      '(?<!Sub)Parhelion': '幻日',
      'Radiant Halo': '明辉光环',
      'Subparhelion': '映幻日'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Echo of Hydaelyn': '하이델린 투영체',
      'Mystic Refulgence': '환상빛',
      '(?<!of )Hydaelyn': '하이델린'
    },
    'replaceText': {
      'Anthelion': '맞무리해',
      'Beacon': '광망',
      'Crystalline Blizzard III': '크리스탈 블리자가',
      'Crystalline Stone III': '크리스탈 스톤가',
      'Crystallize': '크리스탈화',
      'Dawn Mantle': '망토 변경',
      'Echoes': '되울림',
      'Equinox': '이분점',
      'Exodus': '엑소더스',
      'Heros\'s Radiance': '헤로이스의 광휘',
      'Heros\'s Sundering': '헤로이스의 절단',
      'Highest Holy': '지고의 홀리',
      'Hydaelyn\'s Ray': '하이델린 광선',
      'Incandescence': '환섬광',
      'Lightwave': '빛의 파도',
      'Magos\'s Radiance': '마고스의 광휘',
      'Mousa\'s Scorn': '무사의 경멸',
      'Parhelic Circle': '무리해고리',
      'Radiant Halo': '눈부신 빛무리',
      'Subparhelion': '무리햇빛',
      '(?<!Sub)Parhelion': '무리해'
    }
  }]
};
/* harmony default export */ const hydaelyn = (hydaelyn_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/hydaelyn.txt
const trial_hydaelyn_namespaceObject = "### Hydaelyn Normal\r\n# -p 65D7:16.1 65BB:1000\r\n# -ii 668F 6CCE 6CCF 65CA 65D1 6C54 6C55 65B1\r\n# -it Hydaelyn\r\n# -it \"Crystal of Light\"\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n# Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n11.1 \"--sync--\" StartsUsing { id: \"65D7\", source: \"Hydaelyn\" } window 20,20\r\n16.1 \"Heros's Radiance\" Ability { id: \"65D7\", source: \"Hydaelyn\" }\r\n23.3 \"--middle--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n29.9 \"Dawn Mantle\" Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n36.2 \"Anthelion\" Ability { id: \"65C8\", source: \"Hydaelyn\" }\r\n45.3 \"Mousa's Scorn\" Ability { id: \"65D6\", source: \"Hydaelyn\" }\r\n52.5 \"--middle--\" Ability { id: \"6E7A\", source: \"Hydaelyn\" }\r\n58.8 \"Dawn Mantle\" Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n65.1 \"Highest Holy\" Ability { id: \"65C7\", source: \"Hydaelyn\" }\r\n74.2 \"Magos's Radiance\" Ability { id: \"65D8\", source: \"Hydaelyn\" }\r\n78.7 \"--middle--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n85.1 \"Dawn Mantle\" Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n91.4 \"Equinox\" Ability { id: \"65C3\", source: \"Hydaelyn\" }\r\n100.6 \"Heros's Sundering\" Ability { id: \"65D5\", source: \"Hydaelyn\" }\r\n107.8 \"--middle--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n114.1 \"Dawn Mantle\" Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n# -> branch\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# Anthelion branch jump\r\n120.4 \"Anthelion?\" Ability { id: \"65C8\", source: \"Hydaelyn\" } window 30,30 jump 220.4\r\n129.5 \"Mousa's Scorn?\" #Ability { id: \"65D6\", source: \"Hydaelyn\" }\r\n133.7 \"--middle--\" #Ability { id: \"6E7A\", source: \"Hydaelyn\" }\r\n140.0 \"Dawn Mantle?\" #Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n146.3 \"Equinox?\" #Ability { id: \"65C3\", source: \"Hydaelyn\" }\r\n154.4 \"--untargetable--\"\r\n\r\n# Highest Holy branch jump\r\n# FIXME: are Dawn Mantle/Equinox times slightly different here or is that just one log?\r\n120.4 \"Highest Holy?\" Ability { id: \"65C7\", source: \"Hydaelyn\" } window 30,30 jump 320.4\r\n129.5 \"Magos's Radiance?\" #Ability { id: \"65D8\", source: \"Hydaelyn\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n# Anthelion/Mousa's Scorn -> add phase\r\n220.4 \"Anthelion\" Ability { id: \"65C8\", source: \"Hydaelyn\" }\r\n229.5 \"Mousa's Scorn\" Ability { id: \"65D6\", source: \"Hydaelyn\" }\r\n233.7 \"--middle--\" Ability { id: \"6E7A\", source: \"Hydaelyn\" }\r\n240.0 \"Dawn Mantle\" Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n246.3 \"Equinox\" Ability { id: \"65C3\", source: \"Hydaelyn\" }\r\n254.4 \"--untargetable--\"\r\n258.8 \"--sync--\" Ability { id: \"65D3\", source: \"Hydaelyn\" } window 50,50 jump 804.4\r\n\r\n\r\n# Highest Holy/Raidwide -> add phase\r\n320.4 \"Highest Holy\" Ability { id: \"65C7\", source: \"Hydaelyn\" }\r\n329.5 \"Magos's Radiance\" Ability { id: \"65D8\", source: \"Hydaelyn\" }\r\n334.0 \"--middle--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n340.3 \"Dawn Mantle\" Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n346.6 \"Equinox\" Ability { id: \"65C3\", source: \"Hydaelyn\" }\r\n354.7 \"--untargetable--\"\r\n359.1 \"--sync--\" Ability { id: \"65D3\", source: \"Hydaelyn\" } window 50,50 jump 804.4\r\n\r\n\r\n# Add phase: timed push (70% push?)\r\n800.0 \"--untargetable--\"\r\n804.4 \"--sync--\" Ability { id: \"65D3\", source: \"Hydaelyn\" } window 1000,1000\r\n812.4 \"--targetable--\"\r\n826.7 \"Hydaelyn's Ray\" Ability { id: \"65CC\", source: \"Echo of Hydaelyn\" }\r\n828.8 \"Crystallize\" Ability { id: \"6C51\", source: \"Echo of Hydaelyn\" }\r\n837.7 \"Crystalline Stone III\" Ability { id: \"6C59\", source: \"Echo of Hydaelyn\" }\r\n840.1 \"--sync--\" Ability { id: \"659F\", source: \"Echo of Hydaelyn\" }\r\n853.8 \"Hydaelyn's Ray\" Ability { id: \"65CC\", source: \"Echo of Hydaelyn\" }\r\n858.9 \"Crystallize\" Ability { id: \"6CCD\", source: \"Echo of Hydaelyn\" }\r\n867.8 \"Crystalline Blizzard III\" Ability { id: \"6C5A\", source: \"Echo of Hydaelyn\" }\r\n870.2 \"--sync--\" Ability { id: \"659F\", source: \"Echo of Hydaelyn\" }\r\n880.9 \"Hydaelyn's Ray\" Ability { id: \"65CC\", source: \"Echo of Hydaelyn\" }\r\n886.0 \"Crystallize\" Ability { id: \"6C51\", source: \"Echo of Hydaelyn\" }\r\n894.9 \"Crystalline Stone III\" Ability { id: \"6C59\", source: \"Echo of Hydaelyn\" }\r\n\r\n\r\n# Final Phase\r\n1000.0 \"Exodus\" Ability { id: \"65BB\", source: \"Hydaelyn\" } window 1000,0\r\n1014.8 \"Exodus\" Ability { id: \"65D2\", source: \"Hydaelyn\" }\r\n1020.0 \"--targetable--\"\r\n1029.2 \"--sync--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n1034.8 \"Crystallize\" Ability { id: \"659C\", source: \"Hydaelyn\" }\r\n1042.8 \"Dawn Mantle\" Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n1052.0 \"Crystalline Blizzard III\" #Ability { id: \"6C5A\", source: \"Hydaelyn\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# -> jump to Parhelic Circle first\r\n1049.1 \"Highest Holy\" Ability { id: \"65C7\", source: \"Hydaelyn\" } window 30,30 jump 2049.1\r\n1066.0 \"Parhelic Circle?\" Ability { id: \"65AC\", source: \"Hydaelyn\" }\r\n\r\n# -> jump to Parhelion first\r\n1049.1 \"Anthelion\" Ability { id: \"65C8\", source: \"Hydaelyn\" } window 30,30 jump 3049.1\r\n1064.3 \"Mousa's Scorn?\" #Ability { id: \"65D6\", source: \"Hydaelyn\" }\r\n1075.0 \"Parhelion?\" #Ability { id: \"65B0\", source: \"Hydaelyn\" }\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n### Parhelic Circle first\r\n2034.8 \"Crystallize\" Ability { id: \"659C\", source: \"Hydaelyn\" }\r\n2042.8 \"Dawn Mantle\" Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n2049.1 \"Highest Holy\" Ability { id: \"65C7\", source: \"Hydaelyn\" }\r\n2052.0 \"Crystalline Blizzard III\" Ability { id: \"6C5A\", source: \"Hydaelyn\" }\r\n2052.2 \"--sync--\" Ability { id: \"65A0\", source: \"Hydaelyn\" }\r\n2058.3 \"--sync--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n\r\n2066.0 \"Parhelic Circle\" Ability { id: \"65AC\", source: \"Hydaelyn\" }\r\n2066.8 \"--sync--\" Ability { id: \"65AE\", source: \"Mystic Refulgence\" }\r\n2066.8 \"--sync--\" Ability { id: \"65AD\", source: \"Mystic Refulgence\" }\r\n2069.3 \"Incandescence\" Ability { id: \"65CD\", source: \"Mystic Refulgence\" }\r\n2077.2 \"Magos's Radiance\" Ability { id: \"65D8\", source: \"Hydaelyn\" }\r\n2081.8 \"--sync--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n2087.5 \"Crystallize\" Ability { id: \"659C\", source: \"Hydaelyn\" }\r\n2095.6 \"Dawn Mantle\" Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n2101.9 \"Anthelion\" Ability { id: \"65C8\", source: \"Hydaelyn\" }\r\n2105.0 \"--sync--\" Ability { id: \"65A1\", source: \"Hydaelyn\" }\r\n2105.7 \"Crystalline Blizzard III\" Ability { id: \"6C5A\", source: \"Hydaelyn\" }\r\n2117.1 \"Mousa's Scorn\" Ability { id: \"65D6\", source: \"Hydaelyn\" }\r\n2121.2 \"--middle--\" Ability { id: \"6E7A\", source: \"Hydaelyn\" }\r\n\r\n2127.7 \"Parhelion\" Ability { id: \"65B0\", source: \"Hydaelyn\" }\r\n2128.0 \"Beacon 1\" #Ability { id: \"65CE\", source: \"Parhelion\" }\r\n2129.6 \"Beacon 2\" #Ability { id: \"65CE\", source: \"Parhelion\" }\r\n2131.2 \"Beacon 3\" #Ability { id: \"65CE\", source: \"Parhelion\" }\r\n2137.6 \"Subparhelion\" Ability { id: \"6C56\", source: \"Hydaelyn\" }\r\n2141.8 \"--sync--\" Ability { id: \"6E7A\", source: \"Hydaelyn\" }\r\n2144.0 \"Beacon 1\" #Ability { id: \"65CF\", source: \"Parhelion\" }\r\n2145.6 \"Beacon 2\" #Ability { id: \"65CF\", source: \"Parhelion\" }\r\n2147.2 \"Beacon 3\" #Ability { id: \"65CF\", source: \"Parhelion\" }\r\n\r\n# -> jump back to shared loop below\r\n2147.3 \"Crystallize\" Ability { id: \"659E\", source: \"Hydaelyn\" } window 50,50 jump 3147.3\r\n2155.4 \"Dawn Mantle\" #Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n2161.7 \"Equinox\" #Ability { id: \"65C3\", source: \"Hydaelyn\" }\r\n2164.8 \"--sync--\" #Ability { id: \"659F\", source: \"Hydaelyn\" }\r\n2165.5 \"Crystalline Blizzard III/Crystalline Stone III\" #Ability { id: [\"6C5A\", \"6C59\"], source: \"Hydaelyn\" }\r\n\r\n\r\n### Parhelion first\r\n3034.8 \"Crystallize\" Ability { id: \"659C\", source: \"Hydaelyn\" }\r\n3042.9 \"Dawn Mantle\" Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n3049.1 \"Anthelion\" Ability { id: \"65C8\", source: \"Hydaelyn\" }\r\n3052.3 \"--sync--\" Ability { id: \"65A1\", source: \"Hydaelyn\" }\r\n3053.0 \"Crystalline Blizzard III\" Ability { id: \"6C5A\", source: \"Hydaelyn\" }\r\n3064.4 \"Mousa's Scorn\" Ability { id: \"65D6\", source: \"Hydaelyn\" }\r\n3068.6 \"--sync--\" Ability { id: \"6E7A\", source: \"Hydaelyn\" }\r\n3075.1 \"Parhelion\" Ability { id: \"65B0\", source: \"Hydaelyn\" }\r\n3075.3 \"Beacon 1\" #Ability { id: \"65CE\", source: \"Parhelion\" }\r\n3076.9 \"Beacon 2\" #Ability { id: \"65CE\", source: \"Parhelion\" }\r\n3078.5 \"Beacon 3\" #Ability { id: \"65CE\", source: \"Parhelion\" }\r\n3084.9 \"Subparhelion\" Ability { id: \"6C56\", source: \"Hydaelyn\" }\r\n3089.1 \"--sync--\" Ability { id: \"6E7A\", source: \"Hydaelyn\" }\r\n3091.2 \"Beacon 1\" #Ability { id: \"65CF\", source: \"Parhelion\" }\r\n3092.8 \"Beacon 2\" #Ability { id: \"65CF\", source: \"Parhelion\" }\r\n3094.4 \"Beacon 3\" #Ability { id: \"65CF\", source: \"Parhelion\" }\r\n\r\n3094.5 \"Crystallize\" Ability { id: \"659E\", source: \"Hydaelyn\" }\r\n3102.5 \"Dawn Mantle\" Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n3108.8 \"Highest Holy\" Ability { id: \"65C7\", source: \"Hydaelyn\" }\r\n3111.9 \"--sync--\" Ability { id: \"65A0\", source: \"Hydaelyn\" }\r\n3112.7 \"Crystalline Stone III\" Ability { id: \"6C59\", source: \"Hydaelyn\" }\r\n3118.1 \"--sync--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n3125.8 \"Parhelic Circle\" Ability { id: \"65AC\", source: \"Hydaelyn\" }\r\n3126.6 \"--sync--\" Ability { id: \"65AE\", source: \"Mystic Refulgence\" }\r\n3126.6 \"--sync--\" Ability { id: \"65AD\", source: \"Mystic Refulgence\" }\r\n3129.1 \"Incandescence\" Ability { id: \"65CD\", source: \"Mystic Refulgence\" }\r\n3136.9 \"Magos's Radiance\" Ability { id: \"65D8\", source: \"Hydaelyn\" }\r\n3141.5 \"--sync--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n# -> Crystallize below\r\n\r\n\r\n### Shared branch after Parhelion / Parhelic Circle\r\n3147.2 \"Crystallize\" Ability { id: \"659C\", source: \"Hydaelyn\" }\r\n3155.2 \"Dawn Mantle\" Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n3161.5 \"Equinox\" Ability { id: \"65C3\", source: \"Hydaelyn\" }\r\n3164.6 \"--sync--\" Ability { id: \"659F\", source: \"Hydaelyn\" }\r\n3165.4 \"Crystalline Blizzard III/Crystalline Stone III\" Ability { id: [\"6C5A\", \"6C59\"], source: \"Hydaelyn\" }\r\n3176.9 \"Heros's Sundering\" Ability { id: \"65D5\", source: \"Hydaelyn\" }\r\n3180.0 \"--sync--\" Ability { id: \"65A9\", source: \"Hydaelyn\" }\r\n3186.5 \"Radiant Halo\" Ability { id: \"65D0\", source: \"Hydaelyn\" }\r\n\r\n\r\n# Lightwave loop\r\n3191.8 \"--sync--\" StartsUsing { id: [\"6693\", \"6694\", \"6695\"], source: \"Hydaelyn\" }\r\n3195.8 \"Lightwave\" Ability { id: [\"6693\", \"6694\", \"6695\"], source: \"Hydaelyn\" }\r\n3203.9 \"Echoes\" Ability { id: [\"65B5\", \"65B6\", \"65B7\"], source: \"Hydaelyn\" }\r\n3221.1 \"Crystallize\" Ability { id: \"659[CE]\", source: \"Hydaelyn\" }\r\n3224.3 \"--middle--\" Ability { id: [\"65A9\", \"6E7A\"], source: \"Hydaelyn\" }\r\n3230.7 \"Dawn Mantle\" Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n3237.0 \"Highest Holy/Anthelion/Equinox\" Ability { id: [\"65C3\", \"65C7\", \"65C8\"], source: \"Hydaelyn\" }\r\n# This timing is +/- 1 second for some reason (even with the same Crystallize),\r\n# so don't sync because it throws Lightwave off even more.\r\n3239.9 \"Crystalline Blizzard III/Crystalline Stone III\" #Ability { id: [\"6C5A\", \"6C59\"], source: \"Hydaelyn\" }\r\n\r\n# Even ignoring the blizzard/stone above, this is still +/- 0.5s, so add a starts using cast.\r\n# TODO: it's possible the first loop is slightly different??\r\n3245.8 \"--sync--\" StartsUsing { id: [\"6693\", \"6694\", \"6695\"], source: \"Hydaelyn\" } window 30,30 jump 3191.8\r\n3249.8 \"Lightwave\" #Ability { id: [\"6693\", \"6694\", \"6695\"], source: \"Hydaelyn\" }\r\n3257.9 \"Echoes\" #Ability { id: [\"65B5\", \"65B6\", \"65B7\"], source: \"Hydaelyn\" }\r\n3275.1 \"Crystallize\" #Ability { id: \"659[CE]\", source: \"Hydaelyn\" }\r\n3278.3 \"--middle--\" #Ability { id: [\"65A9\", \"6E7A\"], source: \"Hydaelyn\" }\r\n3284.7 \"Dawn Mantle\" #Ability { id: \"6C0C\", source: \"Hydaelyn\" }\r\n3291.0 \"Highest Holy/Anthelion/Equinox\" #Ability { id: [\"65C3\", \"65C7\", \"65C8\"], source: \"Hydaelyn\" }\r\n3293.9 \"Crystalline Blizzard III/Crystalline Stone III\" #Ability { id: [\"6C5A\", \"6C59\"], source: \"Hydaelyn\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/rubicante-ex.ts







// 7D09 Ghastly Torch during add phase *is* an aoe + bleed but is constant and small, so skipped.

const effectIds = {
  bloomingWeltFlare: 'D9B',
  furiousWeltStack: 'D9C',
  stingingWeltSpread: 'D9D'
};
const mapEffectFlags = {
  clockwise: '00020001',
  counter: '00200010',
  // just for reference
  clearClockwise: '00080004',
  clearCounter: '00400004',
  fiery: '00020001',
  notFiery: '00080004'
};
const mapEffectSlots = {
  inner: '01',
  middle: '02',
  outer: '03'
};

// First headmarker is tankbuster on MT
const rubicante_ex_firstHeadmarker = parseInt('0156', 16);
const rubicante_ex_getHeadmarkerId = (data, matches) => {
  if (typeof data.decOffset === 'undefined') data.decOffset = parseInt(matches.id, 16) - rubicante_ex_firstHeadmarker;
  return (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase().padStart(4, '0');
};
const ordealPromise = async data => {
  data.combatantData = [];
  if (data.innerCircleId === undefined || data.middleCircleId === undefined || data.outerCircleId === undefined) return;
  const hexIds = [data.innerCircleId, data.middleCircleId, data.outerCircleId];
  const decIds = hexIds.map(x => parseInt(x, 16));

  // Sort combatant data by the same order of hexIds, aka [inner, middle, outer]
  data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
    call: 'getCombatants',
    ids: decIds
  })).combatants.sort((a, b) => decIds.indexOf(a?.ID ?? 0) - decIds.indexOf(b?.ID ?? 0));
};
const rubicante_ex_triggerSet = {
  id: 'MountOrdealsExtreme',
  zoneId: zone_id/* default.MountOrdealsExtreme */.Z.MountOrdealsExtreme,
  timelineFile: 'rubicante-ex.txt',
  initData: () => {
    return {
      combatantData: [],
      ordealCount: 0,
      flamespireBrandDebuffCollect: [],
      dualfireTargets: [],
      flamespireClawCounter: 0,
      spinnyCollect: []
    };
  },
  triggers: [{
    id: 'RubicanteEx Headmarker Tracker',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.decOffset === undefined,
    run: (data, matches) => {
      rubicante_ex_getHeadmarkerId(data, matches);
    }
  }, {
    id: 'RubicanteEx Inferno Raidwide',
    type: 'StartsUsing',
    netRegex: {
      id: '7D2C',
      source: 'Rubicante',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'RubicanteEx Circle Id Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: '808'
    },
    run: (data, matches) => {
      const count = matches.count;
      // Inner can also be 21F (V shape) and 220 (two lines), but 21E (one line) is first.
      if (count === '21E') data.innerCircleId = matches.targetId;else if (count === '221') data.middleCircleId = matches.targetId;else if (count === '222') data.outerCircleId = matches.targetId;
    }
  }, {
    id: 'RubicanteEx Circle Spinny Collect',
    type: 'MapEffect',
    netRegex: {
      flags: [mapEffectFlags.clockwise, mapEffectFlags.counter],
      location: ['01', '02', '03']
    },
    run: (data, matches) => data.spinnyCollect.push(matches)
  }, {
    id: 'RubicanteEx Circle Spinny Clear',
    type: 'Ability',
    netRegex: {
      id: '80E9',
      source: 'Rubicante',
      capture: false
    },
    run: data => data.spinnyCollect = []
  }, {
    id: 'RubicanteEx Ordeal of Purgation Counter',
    type: 'StartsUsing',
    netRegex: {
      id: '80E9',
      source: 'Rubicante',
      capture: false
    },
    run: data => data.ordealCount++
  }, {
    id: 'RubicanteEx Ordeal of Purgation 1',
    type: 'StartsUsing',
    netRegex: {
      id: '80E9',
      source: 'Rubicante',
      capture: false
    },
    condition: data => data.ordealCount === 1,
    durationSeconds: 8,
    promise: ordealPromise,
    alertText: (data, _matches, output) => {
      // inner and outer rotating
      const spinny = data.spinnyCollect.find(x => x.location === mapEffectSlots.inner);
      if (data.spinnyCollect.length !== 2 || spinny === undefined) return;

      // CW = go north
      // CCW = go south
      // Note: You can also always go opposite the inner line and slightly in the direction of rotation.
      const isCW = spinny.flags === mapEffectFlags.clockwise;
      const dirStr = isCW ? output.north() : output.south();
      return output.text({
        dir: dirStr
      });
    },
    outputStrings: {
      text: {
        en: '${dir} (max melee)',
        de: '${dir} (max Nahkämpfer-Entfernung)',
        fr: '${dir} (max melee)',
        cn: '${dir} (最远近战距离)',
        ko: '${dir} (칼끝딜)'
      },
      north: outputs/* default.north */.Z.north,
      south: outputs/* default.south */.Z.south
    }
  }, {
    id: 'RubicanteEx Ordeal of Purgation 2',
    type: 'StartsUsing',
    netRegex: {
      id: '80E9',
      source: 'Rubicante',
      capture: false
    },
    condition: data => data.ordealCount === 2,
    durationSeconds: 8,
    promise: ordealPromise,
    alertText: (data, _matches, output) => {
      const [inner, middle, outer] = data.combatantData;
      if (inner === undefined || middle === undefined || outer === undefined) return;
      const innerDir8 = util/* Directions.combatantStateHdgTo8Dir */.N.combatantStateHdgTo8Dir(inner);
      // The "left" leg of the V is north.
      // The middle of the V is innerDir + 1.
      // We want to go opposite, aka + 4.
      const safeDir8 = (innerDir8 + 1 + 4) % 8;
      return output[util/* Directions.outputFrom8DirNum */.N.outputFrom8DirNum(safeDir8)]();
    },
    // The entire quadrant is safe.
    outputStrings: util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
  }, {
    id: 'RubicanteEx Ordeal of Purgation 3',
    type: 'StartsUsing',
    netRegex: {
      id: '80E9',
      source: 'Rubicante',
      capture: false
    },
    condition: data => data.ordealCount === 3 || data.ordealCount === 7,
    durationSeconds: 8,
    promise: ordealPromise,
    alertText: (data, _matches, output) => {
      const [inner, middle, outer] = data.combatantData;
      if (inner === undefined || middle === undefined || outer === undefined) return;
      const innerDir = util/* Directions.combatantStateHdgTo8Dir */.N.combatantStateHdgTo8Dir(inner);
      // The "left" leg of the V is north.
      // Tell people to go max melee to either inside interintercardinal of the V legs.
      // TODO: you could use middle's orientation here to say if the intercard between
      // the V legs is safe too.
      const safeDir16 = (innerDir * 2 + 1) % 16;
      const dirStr = {
        1: output.dirNNE(),
        3: output.dirENE(),
        5: output.dirESE(),
        7: output.dirSSE(),
        9: output.dirSSW(),
        11: output.dirWSW(),
        13: output.dirWNW(),
        15: output.dirNNW()
      }[safeDir16];
      return output.text({
        dir: dirStr
      });
    },
    outputStrings: {
      text: {
        en: '${dir} (max melee)',
        de: '${dir} (max Nahkämpfer-Entfernung)',
        fr: '${dir} (max melee)',
        cn: '${dir} (最远近战距离)',
        ko: '${dir} (칼끝딜)'
      },
      dirNNE: outputs/* default.dirNNE */.Z.dirNNE,
      dirENE: outputs/* default.dirENE */.Z.dirENE,
      dirESE: outputs/* default.dirESE */.Z.dirESE,
      dirSSE: outputs/* default.dirSSE */.Z.dirSSE,
      dirSSW: outputs/* default.dirSSW */.Z.dirSSW,
      dirWSW: outputs/* default.dirWSW */.Z.dirWSW,
      dirWNW: outputs/* default.dirWNW */.Z.dirWNW,
      dirNNW: outputs/* default.dirNNW */.Z.dirNNW
    }
  }, {
    id: 'RubicanteEx Ordeal of Purgation 4',
    type: 'StartsUsing',
    netRegex: {
      id: '80E9',
      source: 'Rubicante',
      capture: false
    },
    condition: data => data.ordealCount === 4 || data.ordealCount === 8,
    durationSeconds: 8,
    promise: ordealPromise,
    alertText: (data, _matches, output) => {
      const [inner, middle, outer] = data.combatantData;
      if (inner === undefined || middle === undefined || outer === undefined) return;

      // only middle rotating
      const spinny = data.spinnyCollect.find(x => x.location === mapEffectSlots.middle);
      if (data.spinnyCollect.length !== 1 || spinny === undefined) return;
      const isCW = spinny.flags === mapEffectFlags.clockwise;
      const middleDir8 = util/* Directions.combatantStateHdgTo8Dir */.N.combatantStateHdgTo8Dir(middle);

      // Ordeal 4 is "use cat ears, follow the arrow".
      // "north" for middle is upside-down cat ears.
      // Therefore, if CW we go to WSW and if CCW we go to ESE.

      const safeDir16 = (middleDir8 * 2 + (isCW ? 11 : 5)) % 16;
      return {
        1: output.dirNNE(),
        3: output.dirENE(),
        5: output.dirESE(),
        7: output.dirSSE(),
        9: output.dirSSW(),
        11: output.dirWSW(),
        13: output.dirWNW(),
        15: output.dirNNW()
      }[safeDir16];
    },
    // The entire eighth pie slice is safe.
    outputStrings: {
      dirNNE: outputs/* default.dirNNE */.Z.dirNNE,
      dirENE: outputs/* default.dirENE */.Z.dirENE,
      dirESE: outputs/* default.dirESE */.Z.dirESE,
      dirSSE: outputs/* default.dirSSE */.Z.dirSSE,
      dirSSW: outputs/* default.dirSSW */.Z.dirSSW,
      dirWSW: outputs/* default.dirWSW */.Z.dirWSW,
      dirWNW: outputs/* default.dirWNW */.Z.dirWNW,
      dirNNW: outputs/* default.dirNNW */.Z.dirNNW
    }
  }, {
    id: 'RubicanteEx Ordeal of Purgation 5',
    type: 'StartsUsing',
    netRegex: {
      id: '80E9',
      source: 'Rubicante',
      capture: false
    },
    condition: data => data.ordealCount === 5,
    durationSeconds: 8,
    promise: ordealPromise,
    alertText: (data, _matches, output) => {
      const [inner, middle, outer] = data.combatantData;
      if (inner === undefined || middle === undefined || outer === undefined) return;
      const innerDir8 = util/* Directions.combatantStateHdgTo8Dir */.N.combatantStateHdgTo8Dir(inner);
      // if the inner line is N, there are a number of safe areas here.
      // S max melee ccw to ESE max melee, along with ENE max melee.
      // but SE (aka dir8 of 3) is the most generous safe spot.

      const safeDir8 = (innerDir8 + 3) % 8;
      return output[util/* Directions.outputFrom8DirNum */.N.outputFrom8DirNum(safeDir8)]();
    },
    // The entire quadrant is safe.
    outputStrings: util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
  }, {
    id: 'RubicanteEx Ordeal of Purgation 6',
    type: 'StartsUsing',
    netRegex: {
      id: '80E9',
      source: 'Rubicante',
      capture: false
    },
    condition: data => data.ordealCount === 6,
    promise: ordealPromise,
    alertText: (data, _matches, output) => {
      const [inner, middle, outer] = data.combatantData;
      if (inner === undefined || middle === undefined || outer === undefined) return;

      // Inner should always be facing north (V pointing NE)
      // or facing south (V pointing SW).
      const innerDir8 = util/* Directions.combatantStateHdgTo8Dir */.N.combatantStateHdgTo8Dir(inner);
      if (innerDir8 !== 0 && innerDir8 !== 4) return;

      // only middle rotating
      const spinny = data.spinnyCollect.find(x => x.location === mapEffectSlots.middle);
      if (data.spinnyCollect.length !== 1 || spinny === undefined) return;
      const isCW = spinny.flags === mapEffectFlags.clockwise;
      const isNorth = innerDir8 === 0;

      // Only a few patterns possible, so just call cardinals for ease.
      if (isCW) return isNorth ? output.south() : output.east();
      return isNorth ? output.west() : output.north();
    },
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      east: outputs/* default.east */.Z.east,
      south: outputs/* default.south */.Z.south,
      west: outputs/* default.west */.Z.west
    }
  }, {
    id: 'RubicanteEx Inferno Spread',
    // also applies a 15s bleed to each player
    type: 'StartsUsing',
    netRegex: {
      id: '7D0F',
      source: 'Rubicante',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'RubicanteEx Shattering Heat',
    type: 'StartsUsing',
    netRegex: {
      id: '7D2D',
      source: 'Rubicante'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'RubicanteEx Spike of Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '7D02',
      source: 'Rubicante'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'RubicanteEx Fourfold Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '7D03',
      source: 'Rubicante',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.group(),
    outputStrings: {
      group: outputs/* default.healerGroups */.Z.healerGroups
    }
  }, {
    id: 'RubicanteEx Twinfold Flame',
    type: 'StartsUsing',
    netRegex: {
      id: '7D04',
      source: 'Rubicante',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.stack(),
    outputStrings: {
      stack: {
        en: 'Partner Stacks',
        de: 'Mit Partner sammeln',
        fr: 'Package avec votre partenaire',
        ja: '2人頭割り',
        cn: '2人分摊',
        ko: '2인 쉐어'
      }
    }
  }, {
    id: 'RubicanteEx Radial Flagration',
    type: 'StartsUsing',
    netRegex: {
      id: '7CFE',
      source: 'Rubicante',
      capture: false
    },
    alertText: (_data, _matches, output) => output.spread(),
    outputStrings: {
      spread: {
        en: 'Protean',
        de: 'Himmelsrichtung',
        fr: 'Positions',
        ja: '基本散会',
        cn: '分散引导',
        ko: '기본 산개'
      }
    }
  }, {
    id: 'RubicanteEx Flamesent Ghastly Wind Tether',
    type: 'Tether',
    netRegex: {
      id: '00C0'
    },
    condition: (data, matches) => matches.target === data.me,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Face tether out',
        de: 'Verbindung nach draußen richten',
        fr: 'Lien vers l\'extérieur',
        ja: '線を外へ向ける',
        cn: '离开人群背对连线',
        ko: '본진 바깥으로 선 유도하기'
      }
    }
  }, {
    id: 'RubicanteEx Flamesent Shattering Heat Tether',
    type: 'Tether',
    netRegex: {
      id: '0054',
      capture: false
    },
    suppressSeconds: 15,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank Tethers',
        de: 'Tank Verbindungen',
        fr: 'Liens tanks',
        ja: 'タンク線取り',
        cn: '坦克接线',
        ko: '탱커가 선 가로채기'
      }
    }
  }, {
    id: 'RubicanteEx Blazing Rapture',
    type: 'StartsUsing',
    netRegex: {
      id: '7D07',
      source: 'Rubicante',
      capture: false
    },
    // This is a 14 second cast.
    delaySeconds: 4,
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'RubicanteEx Flamespire Brand Debuff Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: [effectIds.bloomingWeltFlare, effectIds.furiousWeltStack]
    },
    run: (data, matches) => {
      data.flamespireBrandDebuffCollect.push(matches);
      if (matches.effectId === effectIds.furiousWeltStack) data.flamespireBrandStack = matches.target;
      if (matches.effectId === effectIds.bloomingWeltFlare && data.me === matches.target) data.flamespireBrandHasFlare = true;
    }
  }, {
    id: 'RubicanteEx Flamespire Brand Blooming Welt',
    type: 'Ability',
    // 7D18 = 0.2s telegraph for the first Flamerake along with 7D1B/7D19 damage
    netRegex: {
      id: '7D18',
      source: 'Rubicante',
      capture: false
    },
    condition: data => data.flamespireBrandHasFlare,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      if (data.flamerakeInitialSafe === undefined) return output.out();
      if (data.flamerakeInitialSafe === 'cardinal') return output.outIntercard();
      return output.outCardinal();
    },
    outputStrings: {
      out: outputs/* default.out */.Z.out,
      outCardinal: {
        en: 'Out + Cardinal',
        de: 'Raus + Kardinal',
        fr: 'Extérieur + Cardinal',
        cn: '外 + 十字',
        ko: '밖 + 십자방향'
      },
      outIntercard: {
        en: 'Out + Intercard',
        de: 'Raus + Interkardinal',
        fr: 'Extérieur + Intercardinal',
        cn: '外 + 四角',
        ko: '밖 + 대각선'
      }
    }
  }, {
    id: 'RubicanteEx Flamespire Brand Furious Welt',
    type: 'Ability',
    // 7D18 = 0.2s telegraph for the first Flamerake along with 7D1B/7D19 damage
    netRegex: {
      id: '7D18',
      source: 'Rubicante',
      capture: false
    },
    condition: data => !data.flamespireBrandHasFlare,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      if (data.flamespireBrandStack === data.me) return output.stackOnYou();
      return output.stackOnPlayer({
        player: data.party.member(data.flamespireBrandStack)
      });
    },
    outputStrings: {
      stackOnPlayer: outputs/* default.stackOnPlayer */.Z.stackOnPlayer,
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou
    }
  }, {
    id: 'RubicanteEx Flamespire Brand Stinging Welt',
    type: 'Ability',
    // 7D1C and 7D1E are damage abilities for the second bounce of the flamerake.
    netRegex: {
      id: '7D1C',
      source: 'Rubicante',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'RubicanteEx Scalding Signal',
    type: 'StartsUsing',
    netRegex: {
      id: '7D24',
      source: 'Rubicante',
      capture: false
    },
    alertText: (_data, _matches, output) => output.outAndProtean(),
    outputStrings: {
      outAndProtean: {
        en: 'Out + Protean',
        de: 'Raus + Himmelsrichtung',
        fr: 'Extérieur + Positions',
        ja: '外側 + 基本散会',
        cn: '外侧 + 分散引导',
        ko: '밖으로 + 기본 산개'
      }
    }
  }, {
    id: 'RubicanteEx Scalding Ring',
    type: 'StartsUsing',
    netRegex: {
      id: '7D25',
      source: 'Rubicante',
      capture: false
    },
    alertText: (_data, _matches, output) => output.inAndProtean(),
    outputStrings: {
      inAndProtean: {
        en: 'In + Protean',
        de: 'Rein + Himmelsrichtung',
        fr: 'Intérieur + Positions',
        ja: '内側 + 基本散会',
        cn: '内侧 + 分散引导',
        ko: '안으로 + 기본 산개'
      }
    }
  }, {
    id: 'RubicanteEx Sweeping Immolation Spread',
    type: 'StartsUsing',
    netRegex: {
      id: '7D20',
      source: 'Rubicante',
      capture: false
    },
    alertText: (_data, _matches, output) => output.spreadBehind(),
    outputStrings: {
      spreadBehind: {
        en: 'Spread behind Boss',
        de: 'Hinter dem Boss verteilen',
        fr: 'Écartez-vous derrière le boss',
        ja: 'ボスの後ろで散会',
        cn: 'BOSS背后分散',
        ko: '보스 뒤에서 산개'
      }
    }
  }, {
    id: 'RubicanteEx Sweeping Immolation Stack',
    type: 'StartsUsing',
    netRegex: {
      id: '7D21',
      source: 'Rubicante',
      capture: false
    },
    infoText: (_data, _matches, output) => output.stackBehind(),
    outputStrings: {
      stackBehind: {
        en: 'Stack behind Boss',
        de: 'Hinter dem Boss sammeln',
        fr: 'Packez-vous derrière le boss',
        ja: 'ボスの後ろで頭割り',
        cn: 'BOSS背后分摊',
        ko: '보스 뒤에서 쉐어'
      }
    }
  }, {
    id: 'RubicanteEx Dualfire Target',
    // These headmarkers come out just before the 72DE self-targeted cast.
    type: 'HeadMarker',
    netRegex: {},
    alertText: (data, matches, output) => {
      const id = rubicante_ex_getHeadmarkerId(data, matches);
      if (id !== '00E6') return;
      data.dualfireTargets.push(matches.target);
      if (data.me === matches.target) return output.tankCleaveOnYou();
    },
    outputStrings: {
      tankCleaveOnYou: outputs/* default.tankCleaveOnYou */.Z.tankCleaveOnYou
    }
  }, {
    id: 'RubicanteEx Dualfire Not You',
    type: 'StartsUsing',
    netRegex: {
      id: '7D2E',
      source: 'Rubicante',
      capture: false
    },
    infoText: (data, _matches, output) => {
      if (data.dualfireTargets.includes(data.me)) return;
      if (data.role === 'healer') return output.tankBusterCleaves();
      return output.avoidTankCleaves();
    },
    run: data => data.dualfireTargets = [],
    outputStrings: {
      tankBusterCleaves: outputs/* default.tankBusterCleaves */.Z.tankBusterCleaves,
      avoidTankCleaves: outputs/* default.avoidTankCleaves */.Z.avoidTankCleaves
    }
  }, {
    id: 'RubicanteEx Flamespire Claw Numbers',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      return data.me === matches.target && /00(?:4F|5[0-6])/.test(rubicante_ex_getHeadmarkerId(data, matches));
    },
    preRun: (data, matches) => {
      const correctedMatch = rubicante_ex_getHeadmarkerId(data, matches);
      const clawNumberMap = {
        '004F': 1,
        '0050': 2,
        '0051': 3,
        '0052': 4,
        '0053': 5,
        '0054': 6,
        '0055': 7,
        '0056': 8
      };
      data.flamespireClawNumber = clawNumberMap[correctedMatch];
      const clawDelayMap = {
        '004F': 8.3,
        '0050': 10.3,
        '0051': 12.3,
        '0052': 14.3,
        '0053': 16.3,
        '0054': 18.3,
        '0055': 20.3,
        '0056': 22.3
      };
      data.flamespireClawDelay = clawDelayMap[correctedMatch];
      data.flamespireClawCounter = 0;
    },
    durationSeconds: data => {
      return data.flamespireClawDelay;
    },
    alertText: (data, _matches, output) => {
      // A common strategy is to have 7 and 8 grab the first tether
      // and everybody pick up a tether after being hit.
      if (data.flamespireClawNumber !== undefined && data.flamespireClawNumber <= 6) return output.num({
        num: data.flamespireClawNumber
      });
      return output.numGetTether({
        num: data.flamespireClawNumber
      });
    },
    outputStrings: {
      num: {
        en: '#${num}',
        de: '#${num}',
        fr: '#${num}',
        ja: '${num}番',
        cn: '#${num}',
        ko: '${num}번째'
      },
      numGetTether: {
        en: '#${num} (Get Tether)',
        de: '#${num} (Verbindung nehmen)',
        fr: '#${num} (Prenez le lien)',
        ja: '${num}番 (線取りに行く)',
        cn: '#${num} (接线)',
        ko: '${num}번째 (선 가져가기)'
      }
    }
  }, {
    id: 'RubicanteEx Flamespire Claw Counter',
    type: 'Ability',
    netRegex: {
      id: '7D29',
      source: 'Rubicante',
      targetIndex: '0',
      capture: false
    },
    preRun: (data, _matches) => data.flamespireClawCounter++,
    durationSeconds: 1,
    sound: '',
    infoText: (data, _matches, output) => output.text({
      num: data.flamespireClawCounter
    }),
    tts: null,
    outputStrings: {
      text: {
        en: '${num}',
        de: '${num}',
        fr: '${num}',
        ja: '${num}番',
        cn: '${num}',
        ko: '${num}'
      }
    }
  }, {
    id: 'RubicanteEx Flamespire Claw Hit You',
    type: 'Ability',
    netRegex: {
      id: '7E73',
      source: 'Rubicante'
    },
    condition: (data, matches) => {
      if (data.me !== matches.target) return false;
      if (data.flamespireClawCounter >= 7) return false;
      return data.flamespireClawCounter === data.flamespireClawNumber;
    },
    infoText: (_data, _matches, output) => output.getTether(),
    outputStrings: {
      getTether: {
        en: 'Get Tether',
        de: 'Verbindung nehmen',
        fr: 'Prenez le lien',
        ja: '線取りに行く',
        cn: '接线',
        ko: '선 가져가기'
      }
    }
  }, {
    id: 'RubicanteEx Flamespire Brand Call',
    type: 'MapEffect',
    netRegex: {
      location: '04',
      capture: true
    },
    suppressSeconds: 15,
    alertText: (data, matches, output) => {
      const intercardFlags = ['02000200', '00200020', '00020002', '00800080'];
      const isIntercardSafeFirst = intercardFlags.includes(matches.flags);
      data.flamerakeInitialSafe = isIntercardSafeFirst ? 'intercardinal' : 'cardinal';
      const mech = data.flamespireBrandHasFlare ? output.outFlare() : output.inStack();
      const safe = isIntercardSafeFirst ? output.intercards() : output.cardinals();
      return output.text({
        safe: safe,
        mech: mech
      });
    },
    infoText: (data, _matches, output) => {
      let flareDPSCount = 0;
      let flareSupportCount = 0;
      let stackDPSCount = 0;
      let stackSupportCount = 0;
      for (const line of data.flamespireBrandDebuffCollect) {
        const isDPS = data.party.isDPS(line.target);
        if (line.effectId === effectIds.bloomingWeltFlare) {
          if (isDPS) flareDPSCount++;else flareSupportCount++;
        }
        if (line.effectId === effectIds.furiousWeltStack) {
          if (isDPS) stackDPSCount++;else stackSupportCount++;
        }
      }
      if (flareDPSCount > 0 && flareSupportCount > 0) return;
      if (stackDPSCount === 0 && stackSupportCount === 0) return;
      if (flareDPSCount === 0 && flareSupportCount === 0) return;
      if (flareDPSCount > 0 && stackSupportCount > 0) return output.supportStack();
      if (flareSupportCount > 0 && stackDPSCount > 0) return output.dpsStack();
    },
    outputStrings: {
      text: {
        en: '${safe} => ${mech}',
        de: '${safe} => ${mech}',
        fr: '${safe} => ${mech}',
        cn: '${safe} => ${mech}',
        ko: '${safe} => ${mech}'
      },
      cardinals: {
        en: 'Cardinal',
        de: 'Kardinal',
        fr: 'Cardinaux',
        ja: '十字回避',
        cn: '十字',
        ko: '십자방향'
      },
      intercards: {
        en: 'Intercard',
        de: 'Interkardinal',
        fr: 'Intercardinaux',
        ja: '斜めへ',
        cn: '斜角',
        ko: '대각선'
      },
      outFlare: {
        en: 'Out + Flare',
        de: 'Raus+Flare',
        fr: 'Extérieur + Brasier',
        ja: '外側＋フレア',
        cn: '外侧＋核爆',
        ko: '바깥+플레어'
      },
      inStack: {
        en: 'In + Stack',
        de: 'Rein+Sammeln',
        fr: 'Intérieur + Package',
        ja: '内側＋頭割り',
        cn: '内侧＋分摊',
        ko: '안+쉐어'
      },
      supportStack: {
        en: '(supports stack)',
        de: '(Supporter sammeln)',
        fr: '(package support)',
        cn: '(T奶分摊)',
        ko: '(탱힐 쉐어)'
      },
      dpsStack: {
        en: '(dps stack)',
        de: '(DPS sammeln)',
        fr: '(Package DPS)',
        cn: '(DPS分摊)',
        ko: '(딜러 쉐어)'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Partial Immolation/Total Immolation': 'Partial/Total Immolation',
      'Scalding Ring/Scalding Signal': 'Scalding Ring/Signal',
      'Spike of Flame/Fourfold Flame/Twinfold Flame': 'Spike/Twin/Four'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Circle of Purgatory': 'Kreis der Läuterung',
      '(?<!Greater )Flamesent': 'Flammengesandt(?:e|er|es|en)',
      'Greater Flamesent': 'Infernogesandt(?:e|er|es|en)',
      'Rubicante': 'Rubicante',
      'Rubicante Mirage': 'Phantom-Rubicante'
    },
    'replaceText': {
      '\\(aoe\\)': '(AoE)',
      '\\(spread\\)': '(verteilen)',
      'Arcane Revelation': 'Arkane Enthüllung',
      'Arch Inferno': 'Erzinferno',
      'Blazing Rapture': 'Lodernde Entrückung',
      'Blooming Welt': 'Loderndes Mal',
      'Conflagration': 'Feuersnot',
      'Dualfire': 'Zwieflamme',
      'Explosive Pyre': 'Brausender Scheiterhaufen',
      'Fiery Expiation': 'Feurige Sühne',
      'Flamerake': 'Brennender Nagel',
      'Flamespire Brand': 'Mal des Flammendorns',
      'Flamespire Claw': 'Nagel des Flammendorns',
      'Fourfold Flame': 'Vierfache Flamme',
      'Furious Welt': 'Zehrendes Mal',
      'Ghastly Flame': 'Finstere Flamme',
      'Ghastly Torch': 'Finstere Fackel',
      'Ghastly Wind': 'Finstere Winde',
      'Hope Abandon Ye': 'Lasset alle Hoffnung fahren',
      'Infernal Slaughter': 'Infernales Schlachten',
      '(?<!(Arch |Erz))Inferno(?! Devil)': 'Höllenfahrt',
      'Inferno Devil': 'Höllenteufel',
      'Ordeal of Purgation': 'Probe der Läuterung',
      'Partial Immolation': 'Teilverbrennung',
      'Radial Flagration': 'Schwelender Reigen',
      'Scalding Fleet': 'Äschernder Schwarm',
      'Scalding Ring': 'Äschernder Kreis',
      'Scalding Signal': 'Äscherndes Fanal',
      'Shattering Heat': 'Klirrende Hitze',
      'Spike of Flame': 'Flammenstachel',
      'Stinging Welt': 'Flammenmal',
      'Sweeping Immolation': 'Breite Verbrennung',
      'Total Immolation': 'Totalverbrennung',
      'Twinfold Flame': 'Zweifache Flamme'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Circle of Purgatory': 'cercle arcanique du Purgatoire',
      '(?<!Greater )Flamesent': 'flamme démoniaque',
      'Greater Flamesent': 'flamme démoniaque inexorable',
      'Rubicante': 'Rubicante',
      'Rubicante Mirage': 'spectre de Rubicante'
    },
    'replaceText': {
      'Arcane Revelation': 'Déploiement arcanique',
      'Arch Inferno': 'Enfer tourbillonnant',
      'Blazing Rapture': 'Flammes folles',
      'Blooming Welt': 'Grosse malédiction explosive',
      'Conflagration': 'Jets enflammés',
      'Dualfire': 'Jets enflammés jumeaux',
      'Explosive Pyre': 'Attaque de feu explosive',
      'Fiery Expiation': 'Flamme expiatoire',
      'Flamerake': 'Griffes écarlates',
      'Flamespire Brand': 'Marque de flamme maudite',
      'Flamespire Claw': 'Griffes enflammées maudites',
      'Fourfold Flame': 'Quadruple explosion de feu',
      'Furious Welt': 'Malédiction explosive massive',
      'Ghastly Flame': 'Feu spectral',
      'Ghastly Torch': 'Flamme spectrale',
      'Ghastly Wind': 'Vent enflammé spectral',
      'Hope Abandon Ye': 'Ouverture du Purgatoire',
      'Infernal Slaughter': 'Déchaînement infernal',
      '(?<!Arch )Inferno(?! Devil)': 'Flambée',
      'Inferno Devil': 'Enfer tournoyant',
      'Ordeal of Purgation': 'Purgatoire vermillon',
      'Partial Immolation': 'Vague écarlate dispersée',
      'Radial Flagration': 'Jets enflammés radiaux',
      'Scalding Fleet': 'Calcination terrestre brutale',
      'Scalding Ring': 'Calcination terrestre circulaire',
      'Scalding Signal': 'Calcination terrestre ascendante',
      'Shattering Heat': 'Attaque de feu',
      'Spike of Flame': 'Explosion de feu',
      'Stinging Welt': 'Malédiction explosive',
      'Sweeping Immolation': 'Vague écarlate',
      'Total Immolation': 'Vague écarlate concentrée',
      'Twinfold Flame': 'Double explosion de feu'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Circle of Purgatory': '煉獄魔陣',
      '(?<!Greater )Flamesent': '炎妖',
      'Greater Flamesent': '業炎妖',
      'Rubicante(?! )': 'ルビカンテ',
      'Rubicante Mirage': 'ルビカンテの幻影'
    },
    'replaceText': {
      'Arcane Revelation': '魔法陣展開',
      'Arch Inferno': '烈風火燕流',
      'Blazing Rapture': '狂える炎',
      'Blooming Welt': '大爆呪',
      'Conflagration': '劫火流',
      'Dualfire': '双炎流',
      'Explosive Pyre': '爆炎撃',
      'Fiery Expiation': '獄炎',
      'Flamerake': '烈火赤滅爪',
      'Flamespire Brand': '炎禍の呪い',
      'Flamespire Claw': '炎禍の武爪',
      'Fourfold Flame': '四重爆炎',
      'Furious Welt': '重爆呪',
      'Ghastly Flame': '妖火',
      'Ghastly Torch': '妖火炎',
      'Ghastly Wind': '妖火風',
      'Hope Abandon Ye': '煉獄招来',
      'Infernal Slaughter': '火燕乱撃',
      '(?<!Arch )Inferno(?! Devil)': '火燕流',
      'Inferno Devil': '火燕旋風',
      'Ordeal of Purgation': '煉獄の朱炎',
      'Partial Immolation': '赤滅熱波：散炎',
      'Radial Flagration': '放散火流',
      'Scalding Fleet': '滅土焼尽：迅火',
      'Scalding Ring': '滅土焼尽：輪火',
      'Scalding Signal': '滅土焼尽：烽火',
      'Shattering Heat': '炎撃',
      'Spike of Flame': '爆炎',
      'Stinging Welt': '爆呪',
      'Sweeping Immolation': '赤滅熱波',
      'Total Immolation': '赤滅熱波：重炎',
      'Twinfold Flame': '二重爆炎'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Circle of Purgatory': '炼狱魔阵',
      '(?<!Greater )Flamesent': '炎妖',
      'Greater Flamesent': '业炎妖',
      'Rubicante(?! )': '卢比坎特',
      'Rubicante Mirage': '卢比坎特的幻影'
    },
    'replaceText': {
      '\\(aoe\\)': '(AOE)',
      '\\(spread\\)': '(分散)',
      'Arcane Revelation': '魔法阵展开',
      'Arch Inferno': '烈风火焰流',
      'Blazing Rapture': '狂炎',
      'Blooming Welt': '大爆咒',
      'Conflagration': '劫火流',
      'Dualfire': '双炎流',
      'Explosive Pyre': '爆炎击',
      'Fiery Expiation': '狱炎',
      'Flamerake': '烈火赤灭爪',
      'Flamespire Brand': '炀火之咒',
      'Flamespire Claw': '炀火武爪',
      'Fourfold Flame': '四重爆炎',
      'Furious Welt': '重爆咒',
      'Ghastly Flame': '妖火',
      'Ghastly Torch': '妖火炎',
      'Ghastly Wind': '妖火风',
      'Hope Abandon Ye': '炼狱招来',
      'Infernal Slaughter': '火焰乱击',
      '(?<!(Arch |Erz))Inferno(?! Devil)': '火焰流',
      'Inferno Devil': '火焰旋风',
      'Ordeal of Purgation': '炼狱朱炎',
      'Partial Immolation': '赤灭热波：散炎',
      'Radial Flagration': '放散火流',
      'Scalding Fleet': '灭土烧尽：迅火',
      'Scalding Ring': '灭土烧尽：环火',
      'Scalding Signal': '灭土烧尽：烽火',
      'Shattering Heat': '炎击',
      'Spike of Flame': '爆炎柱',
      'Stinging Welt': '爆咒',
      'Sweeping Immolation': '赤灭热波',
      'Total Immolation': '赤灭热波：重炎',
      'Twinfold Flame': '双重爆炎'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Circle of Purgatory': '연옥 마법진',
      '(?<!Greater )Flamesent': '불꽃 요마',
      'Greater Flamesent': '업화의 요마',
      'Rubicante(?! )': '루비칸테',
      'Rubicante Mirage': '루비칸테의 환영'
    },
    'replaceText': {
      '\\(aoe\\)': '(광역)',
      '\\(spread\\)': '(산개)',
      'Arcane Revelation': '마법진 전개',
      'Arch Inferno': '열풍화연류',
      'Blazing Rapture': '광란의 불꽃',
      'Blooming Welt': '대폭발 저주',
      'Conflagration': '불보라',
      'Dualfire': '쌍염류',
      'Explosive Pyre': '폭염격',
      'Fiery Expiation': '지옥불',
      'Flamerake': '열화적멸조',
      'Flamespire Brand': '화마의 저주',
      'Flamespire Claw': '화마의 발톱',
      'Fourfold Flame': '사중 폭염',
      'Furious Welt': '집중 폭발 저주',
      'Ghastly Flame': '요마의 불',
      'Ghastly Torch': '요마의 화염',
      'Ghastly Wind': '요마의 불바람',
      'Hope Abandon Ye': '연옥 출현',
      'Infernal Slaughter': '화연난격',
      '(?<!(Arch |Erz))Inferno(?! Devil)': '화연류',
      'Inferno Devil': '화연선풍',
      'Ordeal of Purgation': '연옥의 홍염',
      'Partial Immolation': '적멸열파: 분산',
      'Radial Flagration': '갈래불',
      'Scalding Fleet': '멸토 소진: 돌진',
      'Scalding Ring': '멸토 소진: 고리',
      'Scalding Signal': '멸토 소진: 봉화',
      'Shattering Heat': '염격',
      'Spike of Flame': '폭염',
      'Stinging Welt': '폭발 저주',
      'Sweeping Immolation': '적멸열파',
      'Total Immolation': '적멸열파: 집중',
      'Twinfold Flame': '이중 폭염'
    }
  }]
};
/* harmony default export */ const rubicante_ex = (rubicante_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/rubicante-ex.txt
const trial_rubicante_ex_namespaceObject = "### Rubicante Extreme\r\n\r\n# -ii 7F6D 7CBF 8025 8022 8CBE 7D0C 8024 7CFA 7CFC 7E73 7CFF 7EFA 7EFB 7CC0 7D10 7D2F 7D1A 7D1B 7D1E 7D1F\r\n# -it \"Rubicante\"\r\n# -p 7D2C:12 7D05:232.7 7D06:1000\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Infernal Slaughter\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"40000010\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.0 \"--sync--\" StartsUsing { id: \"7D2C\", source: \"Rubicante\" } window 10,20\r\n12.0 \"Inferno (aoe)\" Ability { id: \"7D2C\", source: \"Rubicante\" }\r\n\r\n# Purgation 1 & 2\r\n15.1 \"--middle--\" Ability { id: \"7CBC\", source: \"Rubicante\" }\r\n17.4 \"Hope Abandon Ye\" Ability { id: \"7F27\", source: \"Rubicante\" }\r\n26.8 \"Arcane Revelation\" Ability { id: \"7CBE\", source: \"Rubicante\" }\r\n49.0 \"Ordeal of Purgation 1\" Ability { id: \"80E9\", source: \"Rubicante\" }\r\n57.0 \"Fiery Expiation\" Ability { id: [\"7CEF\", \"7CF0\"], source: \"Circle of Purgatory\" }\r\n75.8 \"Ordeal of Purgation 2\" Ability { id: \"80E9\", source: \"Rubicante\" }\r\n83.8 \"Fiery Expiation\" Ability { id: \"7CF0\", source: \"Circle of Purgatory\" }\r\n97.9 \"Shattering Heat\" Ability { id: \"7D2D\", source: \"Rubicante\" }\r\n\r\n# Archi Inferno\r\n105.1 \"--middle--\" Ability { id: \"7CBC\", source: \"Rubicante\" }\r\n113.1 \"Arch Inferno\" Ability { id: \"7CF9\", source: \"Rubicante\" }\r\n113.1 \"Inferno Devil x2\" Ability { id: \"7CFB\", source: \"Rubicante\" } duration 26\r\n116.2 \"Infernal Slaughter\" Ability { id: \"7D00\", source: \"Rubicante\" }\r\n122.1 \"Spike of Flame/Fourfold Flame/Twinfold Flame 1\" Ability { id: [\"7D02\", \"7D03\", \"7D04\"], source: \"Rubicante\" }\r\n126.3 \"Conflagration\" Ability { id: \"7CFD\", source: \"Rubicante\" }\r\n129.4 \"Infernal Slaughter\" Ability { id: \"7D00\", source: \"Rubicante\" }\r\n135.3 \"Spike of Flame/Fourfold Flame/Twinfold Flame 2\" Ability { id: [\"7D02\", \"7D03\", \"7D04\"], source: \"Rubicante\" }\r\n\r\n142.5 \"Radial Flagration\" Ability { id: \"7CFE\", source: \"Rubicante\" }\r\n152.6 \"Inferno (aoe)\" Ability { id: \"7D2C\", source: \"Rubicante\" }\r\n\r\n# Purgation 3 & 4\r\n155.7 \"--middle--\" Ability { id: \"7CBC\", source: \"Rubicante\" }\r\n157.9 \"Hope Abandon Ye\" Ability { id: \"7F27\", source: \"Rubicante\" }\r\n167.3 \"Arcane Revelation\" Ability { id: \"7CBE\", source: \"Rubicante\" }\r\n190.3 \"Ordeal of Purgation 3\" Ability { id: \"80E9\", source: \"Rubicante\" }\r\n198.3 \"Fiery Expiation\" Ability { id: \"7CEF\", source: \"Circle of Purgatory\" }\r\n217.2 \"Ordeal of Purgation 4\" Ability { id: \"80E9\", source: \"Rubicante\" }\r\n225.2 \"Fiery Expiation\" Ability { id: \"7CF0\", source: \"Circle of Purgatory\" }\r\n230.3 \"--untargetable--\"\r\n\r\n# Adds phase\r\n232.7 \"--sync--\" Ability { id: \"7D05\", source: \"Rubicante\" } window 500,0\r\n240.8 \"Ghastly Flame\" Ability { id: \"7D0D\", source: \"Flamesent\" }\r\n244.8 \"Ghastly Torch\" Ability { id: \"7D09\", source: \"Greater Flamesent\" }\r\n247.8 \"Ghastly Wind\" Ability { id: \"7D0B\", source: \"Flamesent\" }\r\n250.8 \"Ghastly Torch\" Ability { id: \"7D09\", source: \"Greater Flamesent\" }\r\n259.8 \"Shattering Heat\" Ability { id: \"7D0A\", source: \"Flamesent\" }\r\n270.8 \"Ghastly Flame\" Ability { id: \"7D0D\", source: \"Flamesent\" }\r\n# ???\r\n\r\n# Phase 2\r\n996.0 \"--sync--\" StartsUsing { id: \"7D06\", source: \"Rubicante\" } window 1000,0\r\n1000.0 \"--sync--\" Ability { id: \"7D06\", source: \"Rubicante\" }\r\n1009.8 \"Blazing Rapture\" Ability { id: \"7D07\", source: \"Rubicante\" }\r\n\r\n# Flamespire Brand\r\n1034.4 \"--middle--\" Ability { id: \"7CBD\", source: \"Rubicante\" }\r\n1040.5 \"Flamespire Brand\" Ability { id: \"7D13\", source: \"Rubicante\" }\r\n1048.6 \"--sync--\" Ability { id: \"7D17\", source: \"Rubicante\" }\r\n1049.9 \"--sync--\" Ability { id: \"7D18\", source: \"Rubicante\" }\r\n1051.1 \"Flamerake 1\" Ability { id: \"7D19\", source: \"Rubicante\" }\r\n1053.1 \"Flamerake 2\" Ability { id: \"7D1C\", source: \"Rubicante\" }\r\n1053.5 \"Blooming Welt\" Ability { id: \"7D14\", source: \"Rubicante\" }\r\n1053.5 \"Furious Welt\" Ability { id: \"7D15\", source: \"Rubicante\" }\r\n1055.5 \"Flamerake 3\" Ability { id: \"7D1D\", source: \"Rubicante\" }\r\n1056.5 \"Stinging Welt\" Ability { id: \"7D16\", source: \"Rubicante\" }\r\n\r\n1059.9 \"Explosive Pyre\" Ability { id: \"7D11\", source: \"Rubicante\" }\r\n1066.9 \"Inferno (spread)\" Ability { id: \"7D0F\", source: \"Rubicante\" }\r\n\r\n# Scalding/Line baits 1\r\n1071.0 \"--middle--\" Ability { id: \"7CBD\", source: \"Rubicante\" }\r\n1078.0 \"Scalding Ring/Scalding Signal\" Ability { id: [\"7D25\", \"7D24\"], source: \"Rubicante\" }\r\n1079.1 \"Scalding Fleet\" Ability { id: \"7D26\", source: \"Rubicante Mirage\" }\r\n1088.1 \"Sweeping Immolation\" Ability { id: \"7D21\", source: \"Rubicante\" }\r\n1088.5 \"Scalding Fleet\" #Ability { id: \"7D27\", source: \"Rubicante Mirage\" }\r\n1088.5 \"Partial Immolation/Total Immolation\" Ability { id: [\"7D22\", \"7D23\"], source: \"Rubicante\" }\r\n\r\n1094.2 \"Explosive Pyre\" Ability { id: \"7D11\", source: \"Rubicante\" }\r\n1102.3 \"Dualfire\" Ability { id: \"7D2E\", source: \"Rubicante\" }\r\n\r\n# Purgation 5 & 6\r\n1112.5 \"--middle--\" Ability { id: \"7CBC\", source: \"Rubicante\" }\r\n1114.7 \"Hope Abandon Ye\" Ability { id: \"7F27\", source: \"Rubicante\" }\r\n1124.1 \"Arcane Revelation\" Ability { id: \"7CBE\", source: \"Rubicante\" }\r\n1146.8 \"Ordeal of Purgation 5\" Ability { id: \"80E9\", source: \"Rubicante\" }\r\n1154.8 \"Fiery Expiation\" Ability { id: [\"7CEF\", \"7CF0\"], source: \"Circle of Purgatory\" }\r\n1173.1 \"Ordeal of Purgation 6\" Ability { id: \"80E9\", source: \"Rubicante\" }\r\n1181.1 \"Fiery Expiation\" Ability { id: [\"7CEF\", \"7CF0\"], source: \"Circle of Purgatory\" }\r\n\r\n1190.2 \"Inferno (aoe)\" Ability { id: \"7D2C\", source: \"Rubicante\" }\r\n\r\n# Flamespire Claw Limit Cut\r\n1199.4 \"--middle--\" Ability { id: \"7CBD\", source: \"Rubicante\" }\r\n1207.4 \"--sync--\" Ability { id: \"7D28\", source: \"Rubicante\" } window 20,20\r\n1207.8 \"Flamespire Claw 1\" #Ability { id: \"7D29\", source: \"Rubicante\" }\r\n1210.2 \"Flamespire Claw 2\" #Ability { id: \"7D29\", source: \"Rubicante\" }\r\n1212.6 \"Flamespire Claw 3\" #Ability { id: \"7D29\", source: \"Rubicante\" }\r\n1215.4 \"Flamespire Claw 4\" #Ability { id: \"7D29\", source: \"Rubicante\" }\r\n1218.2 \"Flamespire Claw 5\" #Ability { id: \"7D29\", source: \"Rubicante\" }\r\n1221.0 \"Flamespire Claw 6\" #Ability { id: \"7D29\", source: \"Rubicante\" }\r\n1223.6 \"Flamespire Claw 7\" #Ability { id: \"7D29\", source: \"Rubicante\" }\r\n1226.0 \"Flamespire Claw 8\" #Ability { id: \"7D29\", source: \"Rubicante\" }\r\n\r\n1236.0 \"Inferno (spread)\" Ability { id: \"7D0F\", source: \"Rubicante\" }\r\n\r\n# Scalding/Line baits 2\r\n1240.1 \"--middle--\" Ability { id: \"7CBD\", source: \"Rubicante\" }\r\n1247.1 \"Scalding Ring/Scalding Signal\" Ability { id: [\"7D25\", \"7D24\"], source: \"Rubicante\" }\r\n1248.2 \"Scalding Fleet\" Ability { id: \"7D26\", source: \"Rubicante Mirage\" }\r\n1257.4 \"Sweeping Immolation\" Ability { id: \"7D20\", source: \"Rubicante\" }\r\n1257.7 \"Scalding Fleet\" Ability { id: \"7D27\", source: \"Rubicante Mirage\" }\r\n1257.8 \"Partial Immolation/Total Immolation\" Ability { id: [\"7D22\", \"7D23\"], source: \"Rubicante\" }\r\n\r\n1263.5 \"Explosive Pyre\" Ability { id: \"7D11\", source: \"Rubicante\" }\r\n1271.5 \"Dualfire\" Ability { id: \"7D2E\", source: \"Rubicante\" }\r\n\r\n# Purgation 7 & 8\r\n1281.8 \"--middle--\" Ability { id: \"7CBC\", source: \"Rubicante\" }\r\n1284.1 \"Hope Abandon Ye\" Ability { id: \"7F27\", source: \"Rubicante\" }\r\n1293.5 \"Arcane Revelation\" Ability { id: \"7CBE\", source: \"Rubicante\" }\r\n1315.8 \"Ordeal of Purgation 7\" Ability { id: \"80E9\", source: \"Rubicante\" }\r\n1323.8 \"Fiery Expiation\" Ability { id: \"7CEF\", source: \"Circle of Purgatory\" }\r\n1342.2 \"Ordeal of Purgation 8\" Ability { id: \"80E9\", source: \"Rubicante\" }\r\n1350.2 \"Fiery Expiation\" Ability { id: \"7CF0\", source: \"Circle of Purgatory\" }\r\n\r\n# Enrage\r\n1359.4 \"--middle--\" Ability { id: \"7CBC\", source: \"Rubicante\" }\r\n1371.7 \"Inferno Enrage\" Ability { id: \"7D2B\", source: \"Rubicante\" }\r\n1371.7 \"--untargetable--\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/rubicante.ts





/**
Map Effects

Locations/Slots:
00 = Arena visual
02 = Middle ring
04 = Flamerake "compass"
05-0C = Cardinals/intercardinals [N,NE...NW] - *starting* direction of Ordeal of Purgation

00 flags:
00020001 = Fiery
00080004 = Clear fiery
00200010 = Rocky terrain after boss death

02 flags:
00020001 = Arrows rotating CW
00080004 = Clear CW arrows
00200010 = Arrows rotating CCW
00400004 = Clear CCW arrows

04 flags:  **WIP**
00100010 = cleaves NW/SE (vfx starts from NW)
01000100 = cleaves NW/SE (vfx starts from SE - otherwise same as above)
00020002 = cleaves E/W (vfx starts from W)
00800080 = cleaves E/W (vfx starts from E - otherwise same as above)
00080004 = clear indicator

05-0C flags:
00010004 = initial telegraph - straight line in given direction
00020004 = initial telegraph - CW jagged line (turns 1 dir CW from starting direction) (only used for Purg 2)
00080004 = initial telegraph - CCW jagged line (turns 1 dir CCW from starting direction) (only used for Purg 2)
00800004 = clear telegraph of fire line
00100004 = fire pulse - straight line in given direction
00200004 = fire pulse - CW jagged line (turns 1 dir CW from starting direction) (paired with CCW arrows)
00400004 = fire pulse - CCW jagged line (turns 1 dir CCW from starting direction) (paired with CW arrows)
 */

// 7CD4 Ghastly Torch during add phase *is* an aoe but is constant and small, so skipped.

// TO-DO:
//  - Flamerake - identify initial orientation of line cleave?
// ordered from N, NE ... NW
const purgationLocations = ['05', '06', '07', '08', '09', '0A', '0B', 'OC'];
const purgationStraightLineFlag = '00010004';
const purgationCWLineFlag = '00020004';
const purgationCCWLineFlag = '00080004';
const purgationLineFlags = [purgationStraightLineFlag, purgationCWLineFlag, purgationCCWLineFlag];
const purgationMidRingLoc = '02';
const purgationMidRotateCWFlag = '00020001';
const purgationMidRotateCCWFlag = '00200010';
const purgationMidRotateFlags = [purgationMidRotateCWFlag, purgationMidRotateCCWFlag];
const rubicante_triggerSet = {
  id: 'MountOrdeals',
  zoneId: zone_id/* default.MountOrdeals */.Z.MountOrdeals,
  timelineFile: 'rubicante.txt',
  initData: () => {
    return {
      purgation: 1,
      dualfireTarget: false
    };
  },
  triggers: [{
    id: 'Rubicante Inferno Raidwide',
    type: 'StartsUsing',
    netRegex: {
      id: '7CEA',
      source: 'Rubicante',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Rubicante Ordeal of Purgation Line',
    type: 'MapEffect',
    netRegex: {
      flags: purgationLineFlags,
      location: purgationLocations
    },
    run: (data, matches) => {
      data.purgationLoc = matches.location;
      data.purgationLine = matches.flags;
    }
  }, {
    id: 'Rubicante Ordeal of Purgation Rotate',
    type: 'MapEffect',
    netRegex: {
      flags: purgationMidRotateFlags,
      location: purgationMidRingLoc
    },
    run: (data, matches) => data.purgationMidRotate = matches.flags
  }, {
    id: 'Rubicante Ordeal of Purgation',
    type: 'StartsUsing',
    netRegex: {
      id: ['7CC4', '80E8'],
      source: 'Rubicante',
      capture: false
    },
    delaySeconds: 0.2,
    durationSeconds: 8,
    alertText: (data, _matches, output) => {
      // keys correspond to order of elements in purgationLocation
      const outputMap = {
        0: output.north(),
        1: output.northeast(),
        2: output.east(),
        3: output.southeast(),
        4: output.south(),
        5: output.southwest(),
        6: output.west(),
        7: output.northwest()
      };
      const dirUnknown = output.unknown();
      let idx = data.purgationLoc !== undefined ? purgationLocations.indexOf(data.purgationLoc) : undefined;
      if (idx === undefined || idx === -1) return output.avoidCone({
        dir: dirUnknown
      });

      // adjust idx for 2nd & 3rd+ purgations based on jagged middle lines or rotation
      if (data.purgation === 2) {
        // 2nd purgation - CW/CCW line only, no rotation
        const jaggedLineFlags = [purgationCWLineFlag, purgationCCWLineFlag];
        if (data.purgationLine === undefined || !jaggedLineFlags.includes(data.purgationLine)) return output.avoidCone({
          dir: dirUnknown
        });
        const modIdx = data.purgationLine === purgationCWLineFlag ? 1 : -1; // +1 if CW line, -1 if CCW line
        idx = (idx + purgationLocations.length + modIdx) % purgationLocations.length;
      } else if (data.purgation > 2) {
        // 3rd+ purgation - straight line, CW/CCW rotation.
        // CW rotation results in CCW final path, and vice versa.
        if (data.purgationMidRotate === undefined || !purgationMidRotateFlags.includes(data.purgationMidRotate)) return output.avoidCone({
          dir: dirUnknown
        });
        const modIdx = data.purgationMidRotate === purgationMidRotateCCWFlag ? 1 : -1;
        idx = (idx + purgationLocations.length + modIdx) % purgationLocations.length;
      }
      const dir1 = outputMap[idx] ?? dirUnknown;
      return output.avoidCone({
        dir: dir1
      });
    },
    run: data => {
      data.purgation++;
      delete data.purgationLoc;
      delete data.purgationLine;
      delete data.purgationMidRotate;
    },
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      northeast: outputs/* default.northeast */.Z.northeast,
      east: outputs/* default.east */.Z.east,
      southeast: outputs/* default.southeast */.Z.southeast,
      south: outputs/* default.south */.Z.south,
      southwest: outputs/* default.southwest */.Z.southwest,
      west: outputs/* default.west */.Z.west,
      northwest: outputs/* default.northwest */.Z.northwest,
      unknown: outputs/* default.unknown */.Z.unknown,
      avoidCone: {
        en: 'Avoid cone (from ${dir})',
        de: 'Weiche dem KEgel aus (von ${dir})',
        fr: 'Évitez le cône (depuis ${dir})',
        ja: '${dir}からの扇回避',
        cn: '躲避扇形 (从${dir})',
        ko: '${dir}의 삼각형 장판 피하기'
      }
    }
  }, {
    id: 'Rubicante Shattering Heat',
    type: 'StartsUsing',
    netRegex: {
      id: '7CEB',
      source: 'Rubicante'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Rubicante Blazing Rapture',
    type: 'StartsUsing',
    netRegex: {
      id: '7CD2',
      source: 'Rubicante',
      capture: false
    },
    // This is a ~14 second cast.
    delaySeconds: 5,
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'Rubicante Inferno Spread',
    type: 'StartsUsing',
    netRegex: {
      id: '7CDA',
      source: 'Rubicante'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Rubicante Flamerake',
    type: 'StartsUsing',
    netRegex: {
      id: '7CDD',
      source: 'Rubicante',
      capture: false
    },
    // Spinning compass animation is 6 seconds; damage goes out 2.6 seconds later
    delaySeconds: 3,
    alertText: (_data, _matches, output) => output.avoid(),
    outputStrings: {
      avoid: {
        en: 'Avoid line cleave, then in',
        de: 'Weiche Linien Cleave aus, dann rein',
        fr: 'Évitez le cleave en ligne, puis intérieur',
        ja: '直線AOE回避 => 中へ',
        cn: '躲避直线攻击, 然后去中间',
        ko: '직선 장판 피하고, 안으로'
      }
    }
  }, {
    id: 'Rubicante Soulscald',
    type: 'Ability',
    netRegex: {
      id: '7CE8',
      source: 'Rubicante Mirage',
      capture: false
    },
    suppressSeconds: 0.5,
    response: responses/* Responses.moveAway */.n3.moveAway('alert')
  }, {
    id: 'Rubicante Dualfire Target',
    // These headmarkers come out just before the 7D95 self-targeted cast.
    type: 'HeadMarker',
    netRegex: {
      id: '00E6'
    },
    alertText: (data, matches, output) => {
      if (data.me === matches.target) {
        data.dualfireTarget = true;
        return output.tankCleaveOnYou();
      }
    },
    outputStrings: {
      tankCleaveOnYou: outputs/* default.tankCleaveOnYou */.Z.tankCleaveOnYou
    }
  }, {
    id: 'Rubicante Dualfire Not Target',
    type: 'StartsUsing',
    netRegex: {
      id: '7D95',
      source: 'Rubicante',
      capture: false
    },
    delaySeconds: 0.5,
    infoText: (data, _matches, output) => {
      if (!data.dualfireTarget) {
        if (data.role === 'healer') return output.tankBusterCleaves();
        return output.avoidTankCleaves();
      }
      return;
    },
    run: data => data.dualfireTarget = false,
    outputStrings: {
      tankBusterCleaves: outputs/* default.tankCleave */.Z.tankCleave,
      avoidTankCleaves: outputs/* default.avoidTankCleave */.Z.avoidTankCleave
    }
  }, {
    id: 'Rubicante Sweeping Immolation Stack',
    type: 'StartsUsing',
    netRegex: {
      id: '7CE3',
      source: 'Rubicante',
      capture: false
    },
    infoText: (_data, _matches, output) => output.stackBehind(),
    outputStrings: {
      stackBehind: {
        en: 'Stack behind Boss',
        de: 'Hinter dem Boss sammeln',
        fr: 'Packez-vous derrière le boss',
        ja: 'ボスの後ろで頭割り',
        cn: 'BOSS背后分摊',
        ko: '보스 뒤에서 쉐어'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Circle of Purgatory': 'Kreis der Läuterung',
      '(?<!Greater )Flamesent': 'Flammengesandt(?:e|er|es|en)',
      'Greater Flamesent': 'Infernogesandt(?:e|er|es|en)',
      'Rubicante(?! )': 'Rubicante',
      'Rubicante Mirage': 'Phantom-Rubicante'
    },
    'replaceText': {
      '\\(aoe\\)': '(AoE)',
      '\\(spread\\)': '(verteilen)',
      'Arcane Revelation': 'Arkane Enthüllung',
      'Arch Inferno': 'Erzinferno',
      'Blazing Rapture': 'Lodernde Entrückung',
      'Conflagration': 'Feuersnot',
      'Dualfire': 'Zwieflamme',
      'Explosive Pyre': 'Brausender Scheiterhaufen',
      'Fiery Expiation': 'Feurige Sühne',
      'Flamerake': 'Brennender Nagel',
      'Ghastly Flame': 'Finstere Flamme',
      'Ghastly Torch': 'Finstere Fackel',
      'Ghastly Wind': 'Finstere Winde',
      'Hope Abandon Ye': 'Lasset alle Hoffnung fahren',
      'Infernal Slaughter': 'Infernales Schlachten',
      '(?<!(Arch |Erz))Inferno(?! Devil)': 'Höllenfahrt',
      'Inferno Devil': 'Höllenteufel',
      'Ordeal of Purgation': 'Probe der Läuterung',
      'Radial Flagration': 'Schwelender Reigen',
      'Scalding Fleet': 'Äschernder Schwarm',
      'Shattering Heat': 'Klirrende Hitze',
      'Soulscald': 'Äschernes Grab',
      'Sweeping Immolation': 'Breite Verbrennung',
      'Total Immolation': 'Totalverbrennung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Circle of Purgatory': 'cercle arcanique du Purgatoire',
      '(?<!Greater )Flamesent': 'flamme démoniaque',
      'Greater Flamesent': 'flamme démoniaque inexorable',
      'Rubicante(?! )': 'Rubicante',
      'Rubicante Mirage': 'spectre de Rubicante'
    },
    'replaceText': {
      'Arcane Revelation': 'Déploiement arcanique',
      'Arch Inferno': 'Enfer tourbillonnant',
      'Blazing Rapture': 'Flammes folles',
      'Conflagration': 'Jets enflammés',
      'Dualfire': 'Jets enflammés jumeaux',
      'Explosive Pyre': 'Attaque de feu explosive',
      'Fiery Expiation': 'Flamme expiatoire',
      'Flamerake': 'Griffes écarlates',
      'Ghastly Flame': 'Feu spectral',
      'Ghastly Torch': 'Flamme spectrale',
      'Ghastly Wind': 'Vent enflammé spectral',
      'Hope Abandon Ye': 'Ouverture du Purgatoire',
      'Infernal Slaughter': 'Déchaînement infernal',
      '(?<!Arch )Inferno(?! Devil)': 'Flambée',
      'Inferno Devil': 'Enfer tournoyant',
      'Ordeal of Purgation': 'Purgatoire vermillon',
      'Radial Flagration': 'Jets enflammés radiaux',
      'Scalding Fleet': 'Calcination terrestre brutale',
      'Shattering Heat': 'Attaque de feu',
      'Soulscald': 'Calcination terrestre',
      'Sweeping Immolation': 'Vague écarlate',
      'Total Immolation': 'Vague écarlate concentrée'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Circle of Purgatory': '煉獄魔陣',
      '(?<!Greater )Flamesent': '炎妖',
      'Greater Flamesent': '業炎妖',
      'Rubicante(?! )': 'ルビカンテ',
      'Rubicante Mirage': 'ルビカンテの幻影'
    },
    'replaceText': {
      'Arcane Revelation': '魔法陣展開',
      'Arch Inferno': '烈風火燕流',
      'Blazing Rapture': '狂える炎',
      'Conflagration': '劫火流',
      'Dualfire': '双炎流',
      'Explosive Pyre': '爆炎撃',
      'Fiery Expiation': '獄炎',
      'Flamerake': '烈火赤滅爪',
      'Ghastly Flame': '妖火',
      'Ghastly Torch': '妖火炎',
      'Ghastly Wind': '妖火風',
      'Hope Abandon Ye': '煉獄招来',
      'Infernal Slaughter': '火燕乱撃',
      '(?<!Arch )Inferno(?! Devil)': '火燕流',
      'Inferno Devil': '火燕旋風',
      'Ordeal of Purgation': '煉獄の朱炎',
      'Radial Flagration': '放散火流',
      'Scalding Fleet': '滅土焼尽：迅火',
      'Shattering Heat': '炎撃',
      'Soulscald': '滅土焼尽',
      'Sweeping Immolation': '赤滅熱波',
      'Total Immolation': '赤滅熱波：重炎'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Circle of Purgatory': '炼狱魔阵',
      '(?<!Greater )Flamesent': '炎妖',
      'Greater Flamesent': '业炎妖',
      'Rubicante(?! )': '卢比坎特',
      'Rubicante Mirage': '卢比坎特的幻影'
    },
    'replaceText': {
      '\\(aoe\\)': '(AOE)',
      '\\(spread\\)': '(分散)',
      'Arcane Revelation': '魔法阵展开',
      'Arch Inferno': '烈风火焰流',
      'Blazing Rapture': '狂炎',
      'Conflagration': '劫火流',
      'Dualfire': '双炎流',
      'Explosive Pyre': '爆炎击',
      'Fiery Expiation': '狱炎',
      'Flamerake': '烈火赤灭爪',
      'Ghastly Flame': '妖火',
      'Ghastly Torch': '妖火炎',
      'Ghastly Wind': '妖火风',
      'Hope Abandon Ye': '炼狱招来',
      'Infernal Slaughter': '火焰乱击',
      '(?<!(Arch |Erz))Inferno(?! Devil)': '火焰流',
      'Inferno Devil': '火焰旋风',
      'Ordeal of Purgation': '炼狱朱炎',
      'Radial Flagration': '放散火流',
      'Scalding Fleet': '灭土烧尽：迅火',
      'Shattering Heat': '炎击',
      'Soulscald': '灭土烧尽',
      'Sweeping Immolation': '赤灭热波',
      'Total Immolation': '赤灭热波：重炎'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Circle of Purgatory': '연옥 마법진',
      '(?<!Greater )Flamesent': '불꽃 요마',
      'Greater Flamesent': '업화의 요마',
      'Rubicante(?! )': '루비칸테',
      'Rubicante Mirage': '루비칸테의 환영'
    },
    'replaceText': {
      '\\(aoe\\)': '(광역)',
      '\\(spread\\)': '(산개)',
      'Arcane Revelation': '마법진 전개',
      'Arch Inferno': '열풍화연류',
      'Blazing Rapture': '광란의 불꽃',
      'Conflagration': '불보라',
      'Dualfire': '쌍염류',
      'Explosive Pyre': '폭염격',
      'Fiery Expiation': '지옥불',
      'Flamerake': '열화적멸조',
      'Ghastly Flame': '요마의 불',
      'Ghastly Torch': '요마의 화염',
      'Ghastly Wind': '요마의 불바람',
      'Hope Abandon Ye': '연옥 출현',
      'Infernal Slaughter': '화연난격',
      '(?<!(Arch |Erz))Inferno(?! Devil)': '화연류',
      'Inferno Devil': '화연선풍',
      'Ordeal of Purgation': '연옥의 홍염',
      'Radial Flagration': '갈래불',
      'Scalding Fleet': '멸토 소진: 돌진',
      'Shattering Heat': '염격',
      'Soulscald': '멸토 소진',
      'Sweeping Immolation': '적멸열파',
      'Total Immolation': '적멸열파: 집중'
    }
  }]
};
/* harmony default export */ const rubicante = (rubicante_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/rubicante.txt
const trial_rubicante_namespaceObject = "# Rubicante\r\n\r\n# -ii 8022 7F6C 7CC8 7CCA 7CCF 7CCD 8024 7CBF 8025 7CD8 7CD1 7CD9 7CBD 7CDB 7CDE 7CE8 7D96 7CC0\r\n# -it \"Rubicante\"\r\n# -p 7CD0:1000 7CD2:2000\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\nhideall \"Arcane Revelation\"\r\nhideall \"Infernal Slaughter\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.0 \"--sync--\" StartsUsing { id: \"7CEA\", source: \"Rubicante\" } window 10,10\r\n12.0 \"Inferno\" Ability { id: \"7CEA\", source: \"Rubicante\" }\r\n\r\n# Phase 1 (Purgations & Arch Inferno)\r\n15.1 \"--middle--\" Ability { id: \"7CBC\", source: \"Rubicante\" }\r\n17.3 \"Hope Abandon Ye\" Ability { id: \"7F26\", source: \"Rubicante\" }\r\n26.7 \"Arcane Revelation\" Ability { id: \"7CBE\", source: \"Rubicante\" }\r\n47.7 \"Ordeal of Purgation\" Ability { id: \"7CC4\", source: \"Rubicante\" } # no spin, straight line\r\n52.7 \"Fiery Expiation\" Ability { id: \"7CC5\", source: \"Circle of Purgatory\" }\r\n68.9 \"Ordeal of Purgation\" Ability { id: \"7CC4\", source: \"Rubicante\" } # no spin, jagged line\r\n73.9 \"Fiery Expiation\" Ability { id: \"7CC5\", source: \"Circle of Purgatory\" }\r\n86.9 \"Shattering Heat\" Ability { id: \"7CEB\", source: \"Rubicante\" }\r\n94.1 \"--middle--\" Ability { id: \"7CBC\", source: \"Rubicante\" }\r\n\r\n102.1 \"Arch Inferno\" Ability { id: \"7CC7\", source: \"Rubicante\" } window 30,30\r\n102.1 \"Inferno Devil\" Ability { id: \"7CC9\", source: \"Rubicante\" }\r\n105.2 \"Infernal Slaughter\" Ability { id: \"7CCE\", source: \"Rubicante\" }\r\n112.2 \"Conflagration\" Ability { id: \"7CCB\", source: \"Rubicante\" }\r\n115.3 \"Infernal Slaughter\" Ability { id: \"7CCE\", source: \"Rubicante\" }\r\n122.3 \"Radial Flagration\" Ability { id: \"7CCC\", source: \"Rubicante\" }\r\n130.4 \"--middle--\" Ability { id: \"7CBC\", source: \"Rubicante\" }\r\n\r\n132.8 \"Hope Abandon Ye\" Ability { id: \"7F26\", source: \"Rubicante\" } window 30,30\r\n142.2 \"Arcane Revelation\" Ability { id: \"7CBE\", source: \"Rubicante\" }\r\n163.1 \"Ordeal of Purgation\" Ability { id: \"80E8\", source: \"Rubicante\" } # middle-disc spin, jagged line (from this point forward)\r\n171.1 \"Fiery Expiation\" Ability { id: \"7CC5\", source: \"Circle of Purgatory\" }\r\n187.5 \"Ordeal of Purgation\" Ability { id: \"80E8\", source: \"Rubicante\" }\r\n195.5 \"Fiery Expiation\" Ability { id: \"7CC5\", source: \"Circle of Purgatory\" }\r\n201.6 \"--untargetable--\"\r\n\r\n# Adds Phase\r\n# The adds will intermittently cast various AoEs.\r\n# All are ground-telegraphed except 7CD4 (Ghastly Torch), a small raid-wide.\r\n# Because variation in adds deaths can affect casts, only display the first few mechanics.\r\n1000.0 \"--sync--\" Ability { id: \"7CD0\", source: \"Rubicante\" } window 1000,0\r\n1011.1 \"Ghastly Torch\" Ability { id: \"7CD4\", source: \"Greater Flamesent\" }\r\n1012.1 \"Ghastly Flame\" Ability { id: \"7CD7\", source: \"Flamesent\" }\r\n1016.2 \"Ghastly Wind\" Ability { id: \"7CD6\", source: \"Flamesent\" }\r\n1017.2 \"Ghastly Torch\" Ability { id: \"7CD4\", source: \"Greater Flamesent\" }\r\n1022.2 \"Shattering Heat\" Ability { id: \"7CD5\", source: \"Flamesent\" }\r\n\r\n# Phase 2 (Flamerake & Sweeping Immolation)\r\n1986.4 \"--sync--\" StartsUsing { id: \"7CD2\", source: \"Rubicante\" } window 1000,0\r\n1986.4 \"--targetable--\"\r\n2000.0 \"Blazing Rapture\" Ability { id: \"7CD2\", source: \"Rubicante\" }\r\n2013.4 \"--untargetable--\"\r\n2036.4 \"--targetable--\"\r\n2048.5 \"Inferno (spread)\" Ability { id: \"7CDA\", source: \"Rubicante\" }\r\n2062.2 \"--sync--\" Ability { id: \"7CDD\", source: \"Rubicante\" }\r\n2064.6 \"Flamerake 1\" Ability { id: \"7CDF\", source: \"Rubicante\" }\r\n2065.6 \"Flamerake 2\" Ability { id: \"7CE0\", source: \"Rubicante\" }\r\n2066.6 \"Flamerake 3\" Ability { id: \"7CE1\", source: \"Rubicante\" }\r\n2077.0 \"--sync--\" Ability { id: \"7CC3\", source: \"Rubicante\" }\r\n2082.0 \"Soulscald\" Ability { id: \"7CE6\", source: \"Rubicante\" }\r\n2088.1 \"Scalding Fleet\" #Ability { id: \"7CE9\", source: \"Rubicante Mirage\" }\r\n2094.3 \"--sync--\" Ability { id: \"8034\", source: \"Rubicante\" }\r\n2099.3 \"Dualfire\" Ability { id: \"7D95\", source: \"Rubicante\" }\r\n2114.1 \"Sweeping Immolation\" Ability { id: \"7CE3\", source: \"Rubicante\" }\r\n2114.5 \"Total Immolation\" Ability { id: \"7CE5\", source: \"Rubicante\" } window 30,30\r\n\r\n# Loop begins\r\n2127.5 \"--middle--\" Ability { id: \"7CBC\", source: \"Rubicante\" }\r\n2129.7 \"Hope Abandon Ye\" Ability { id: \"7F26\", source: \"Rubicante\" }\r\n2139.1 \"Arcane Revelation\" Ability { id: \"7CBE\", source: \"Rubicante\" }\r\n2160.0 \"Ordeal of Purgation\" Ability { id: \"80E8\", source: \"Rubicante\" }\r\n2168.0 \"Fiery Expiation\" Ability { id: \"7CC5\", source: \"Circle of Purgatory\" }\r\n2184.7 \"Ordeal of Purgation\" Ability { id: \"80E8\", source: \"Rubicante\" }\r\n2192.7 \"Fiery Expiation\" Ability { id: \"7CC5\", source: \"Circle of Purgatory\" }\r\n2201.7 \"Inferno (aoe)\" Ability { id: \"7CEA\", source: \"Rubicante\" }\r\n2207.8 \"--middle--\" Ability { id: \"7CBC\", source: \"Rubicante\" }\r\n2215.8 \"Arch Inferno\" Ability { id: \"7CC7\", source: \"Rubicante\" }\r\n2215.8 \"Inferno Devil\" Ability { id: \"7CC9\", source: \"Rubicante\" }\r\n2218.9 \"Infernal Slaughter\" Ability { id: \"7CCE\", source: \"Rubicante\" }\r\n2225.9 \"Conflagration\" Ability { id: \"7CCB\", source: \"Rubicante\" }\r\n2229.0 \"Infernal Slaughter\" Ability { id: \"7CCE\", source: \"Rubicante\" }\r\n2236.0 \"Radial Flagration\" Ability { id: \"7CCC\", source: \"Rubicante\" }\r\n2257.3 \"--sync--\" Ability { id: \"7CDD\", source: \"Rubicante\" }\r\n2259.5 \"Flamerake 1\" Ability { id: \"7CDF\", source: \"Rubicante\" }\r\n2260.5 \"Flamerake 2\" Ability { id: \"7CE0\", source: \"Rubicante\" }\r\n2261.5 \"Flamerake 3\" Ability { id: \"7CE1\", source: \"Rubicante\" }\r\n2273.5 \"Inferno (spread)\" Ability { id: \"7CDA\", source: \"Rubicante\" }\r\n2281.8 \"--sync--\" Ability { id: \"7CC3\", source: \"Rubicante\" }\r\n2286.8 \"Soulscald\" Ability { id: \"7CE6\", source: \"Rubicante\" }\r\n2292.9 \"Scalding Fleet\" #Ability { id: \"7CE9\", source: \"Rubicante Mirage\" }\r\n2299.1 \"--sync--\" Ability { id: \"8034\", source: \"Rubicante\" }\r\n2304.1 \"Dualfire\" Ability { id: \"7D95\", source: \"Rubicante\" }\r\n2318.9 \"Sweeping Immolation\" Ability { id: \"7CE3\", source: \"Rubicante\" }\r\n2319.3 \"Total Immolation\" Ability { id: \"7CE5\", source: \"Rubicante\" } window 30,10000 jump 1114.5\r\n# pretty sure this is the end of the loop, but didn't go far enough to see it loop around again\r\n\r\n# Fake loop\r\n2332.3 \"--middle--\"\r\n2334.5 \"Hope Abandon Ye\"\r\n2343.9 \"Arcane Revelation\"\r\n2364.8 \"Ordeal of Purgation\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/sephirot-un.ts




const sephirot_un_triggerSet = {
  id: 'ContainmentBayS1T7Unreal',
  zoneId: zone_id/* default.ContainmentBayS1T7Unreal */.Z.ContainmentBayS1T7Unreal,
  timelineFile: 'sephirot-un.txt',
  initData: () => {
    return {
      phase: 1,
      pillarActive: false
    };
  },
  timelineTriggers: [{
    id: 'SephirotUn Tiferet',
    regex: /Tiferet/,
    beforeSeconds: 4,
    suppressSeconds: 5,
    // Timeline syncs can otherwise make this extra-noisy
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'SephirotUn Triple Trial',
    regex: /Triple Trial/,
    beforeSeconds: 4,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'SephirotUn Ein Sof Rage',
    regex: /Ein Sof \(4 puddles\)/,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Move to safe quadrant',
        de: 'Beweg dich in den sicheren Quadranten',
        fr: 'Allez sur un quart safe',
        ja: '安置へ移動',
        cn: '移动到安全区域',
        ko: '안전한 지역으로 이동'
      }
    }
  }, {
    id: 'SephirotUn Ein Sof Ratzon',
    regex: /Ein Sof \(1 puddle\)/,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait toward puddle',
        de: 'In Richtung Fläche ködern',
        fr: 'Attendez devant la zone au sol',
        ja: '緑ドームの方へ誘導',
        cn: '靠近圈圈集合诱导AOE',
        ko: '장판 쪽으로 아인 유도'
      }
    }
  }, {
    id: 'SephirotUn Yesod Bait',
    regex: /Yesod/,
    beforeSeconds: 6,
    alertText: (data, _matches, output) => {
      if (data.pillarActive) return output.withPillar();
      return output.noPillar();
    },
    outputStrings: {
      noPillar: {
        en: 'Bait Yesod',
        de: 'Yesod ködern',
        fr: 'Attirez Yesod',
        ja: 'イェソドクラッシュ誘導',
        cn: '集合诱导基盘碎击',
        ko: '예소드 붕괴 유도'
      },
      withPillar: {
        en: 'Bait Yesod inside puddle',
        de: 'Yesod in die Fläche ködern',
        fr: 'Attirez Yesod dans une zone au sol',
        ja: '青いサークルの中でイェソドクラッシュ誘導',
        cn: '圈圈内集合诱导基盘碎击',
        ko: '장판 안에 예소드 유도하기'
      }
    }
  }, {
    id: 'SephirotUn Pillar Activate',
    regex: /Pillar of Mercy 1/,
    beforeSeconds: 10,
    run: data => data.pillarActive = true
  }, {
    id: 'SephirotUn Pillar Deactivate',
    regex: /Pillar of Mercy 3/,
    run: data => data.pillarActive = false
  }],
  triggers: [{
    id: 'SephirotUn Main Tank',
    type: 'Ability',
    netRegex: {
      id: '368',
      source: 'Sephirot'
    },
    // We make this conditional to avoid constant noise in the raid emulator.
    condition: (data, matches) => data.mainTank !== matches.target,
    run: (data, matches) => data.mainTank = matches.target
  }, {
    id: 'SephirotUn Chesed Buster',
    type: 'StartsUsing',
    netRegex: {
      id: '7694',
      source: 'Sephirot'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'SephirotUn Ein',
    type: 'StartsUsing',
    netRegex: {
      id: '7696',
      source: 'Sephirot',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'SephirotUn Ratzon Spread',
    type: 'HeadMarker',
    netRegex: {
      id: ['0046', '0047']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (_data, matches, output) => {
      if (matches.id === '0046') return output.green();
      return output.purple();
    },
    outputStrings: {
      purple: {
        en: 'Purple spread',
        de: 'Lila verteilen',
        fr: 'Violet écartez-vous',
        ja: '紫散会',
        cn: '紫圈分散',
        ko: '보라색 징 산개'
      },
      green: {
        en: 'Green spread',
        de: 'Grün verteilen',
        fr: 'Vert écartez-vous',
        ja: '緑散会',
        cn: '绿圈分散',
        ko: '초록색 징 산개'
      }
    }
  }, {
    id: 'SephirotUn Fiendish Rage',
    type: 'HeadMarker',
    netRegex: {
      id: '0048',
      capture: false
    },
    condition: data => data.phase === 1,
    suppressSeconds: 10,
    alertText: (data, _matches, output) => {
      if (data.me === data.mainTank) return output.noStack();
      return output.stack();
    },
    outputStrings: {
      noStack: {
        en: 'Don\'t Stack!',
        de: 'Nicht sammeln!',
        fr: 'Ne vous packez pas !',
        ja: '頭割りに参加しないで',
        cn: '不要重合！',
        ko: '겹치면 안됨!'
      },
      stack: {
        en: 'Group Stacks',
        de: 'In der Gruppe sammeln',
        fr: 'Package en groupe',
        ja: 'グループ頭割り',
        cn: '分组集合',
        ko: '그룹 쉐어'
      }
    }
  }, {
    id: 'SephirotUn Da\'at Spread',
    type: 'StartsUsing',
    netRegex: {
      id: '769F',
      source: 'Sephirot',
      capture: false
    },
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'SephirotUn Malkuth',
    type: 'StartsUsing',
    netRegex: {
      id: '76AF',
      source: 'Sephirot',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'SephirotUn Yesod Move',
    type: 'StartsUsing',
    netRegex: {
      id: '76AB',
      source: 'Sephirot',
      capture: false
    },
    suppressSeconds: 2,
    response: responses/* Responses.moveAway */.n3.moveAway('alarm') // This *will* kill if a non-tank takes 2+.
  }, {
    id: 'SephirotUn Force Against Might',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3ED'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, matches, output) => output.text({
      force: matches.effect
    }),
    run: (data, matches) => data.force = matches.effectId,
    outputStrings: {
      text: {
        en: 'Orange (${force})',
        de: 'Orange (${force})',
        fr: '${force} Orange',
        ja: '自分に${force}',
        // FIXME
        cn: '橙点名 (${force})',
        ko: '노랑 (${force})'
      }
    }
  }, {
    id: 'SephirotUn Force Against Magic',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3EE'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, matches, output) => output.text({
      force: matches.effect
    }),
    run: (data, matches) => data.force = matches.effectId,
    outputStrings: {
      text: {
        en: 'Green (${force})',
        de: 'Grün (${force})',
        fr: '${force} Vert',
        ja: '自分に${force}',
        // FIXME
        cn: '绿点名 (${force})',
        ko: '초록 (${force})'
      }
    }
  }, {
    // Orange left, Green right. Match color to Force debuff.
    id: 'SephirotUn Gevurah Chesed',
    type: 'StartsUsing',
    netRegex: {
      id: '76A5',
      capture: false
    },
    alertText: (data, _matches, output) => {
      // Here and for Chesed Gevurah, if the player doesn't have a color debuff,
      // they just take moderate AoE damage.
      // Unlike Flood of Naught (colors) in O4s,
      // standing center is safe if the user has no debuff.
      if (data.force !== undefined) return data.force === '3ED' ? output.left() : output.right();
      return output.aoe();
    },
    outputStrings: {
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      aoe: outputs/* default.aoe */.Z.aoe
    }
  }, {
    // Green left, Orange right. Match color to Force debuff.
    id: 'SephirotUn Chesed Gevurah',
    type: 'StartsUsing',
    netRegex: {
      id: '76A6',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.force !== undefined) return data.force === '3EE' ? output.left() : output.right();
      return output.aoe();
    },
    outputStrings: {
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      aoe: outputs/* default.aoe */.Z.aoe
    }
  }, {
    id: 'SephirotUn Fiendish Wail',
    type: 'Ability',
    netRegex: {
      id: '76A2',
      source: 'Sephirot',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.force === '3ED' || data.force === undefined && data.role === 'tank') return output.getTower();
      return output.avoidTower();
    },
    outputStrings: {
      getTower: {
        en: 'Get a tower',
        de: 'Nimm einen Turm',
        fr: 'Prenez une tour',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '기둥 밟기'
      },
      avoidTower: {
        en: 'Avoid towers',
        de: 'Turm meiden',
        fr: 'Évitez les tours',
        ja: '塔から離れる',
        cn: '躲塔',
        ko: '기둥 피하기'
      }
    }
  }, {
    id: 'SephirotUn Da\'at Tethers',
    type: 'Tether',
    netRegex: {
      id: '0030',
      capture: false
    },
    suppressSeconds: 30,
    // The tethers jump around a lot
    alertText: (data, _matches, output) => {
      if (data.force === '3EE') return output.magic();
      return output.might();
    },
    outputStrings: {
      might: {
        en: 'Get Away, Avoid Puddles + Tethers',
        de: 'Geh weg, weiche Flächen und Verbindungen aus',
        fr: 'Éloignez-vous, Évitez les zones au sol et les liens',
        ja: '離れる、AOEと線回避',
        cn: '远离, 躲避圈圈 + 连线',
        ko: '멀리 떨어지고, 장판 + 선 피하기'
      },
      magic: {
        en: 'Go Front; Get Tether',
        de: 'Geh nach Vorne; Nimm eine Verbindung',
        fr: 'Allez devant puis prenez les liens',
        ja: '前へ、線取り',
        cn: '去前面; 接线',
        ko: '앞으로 가서 선 가져가기'
      }
    }
  }, {
    id: 'SephirotUn Force Against Lose',
    type: 'LosesEffect',
    netRegex: {
      effectId: ['3ED', '3EE'],
      capture: false
    },
    run: data => delete data.force
  }, {
    id: 'SephirotUn Earth Shaker Collect',
    type: 'HeadMarker',
    netRegex: {
      id: '0028'
    },
    run: (data, matches) => {
      data.shakerTargets = data.shakerTargets ??= [];
      data.shakerTargets.push(matches.target);
    }
  }, {
    id: 'SephirotUn Earth Shaker Call',
    type: 'HeadMarker',
    netRegex: {
      id: '0028',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      if (data.shakerTargets?.includes(data.me)) return output.shakerTarget();
      return output.shakerAvoid();
    },
    outputStrings: {
      shakerTarget: {
        en: 'Earth Shaker (Max Melee)',
        de: 'Erdstoß (Max Nahkampf)',
        fr: 'Secousse (Max Melée)',
        ja: 'アスシェイカー',
        cn: '大地摇动 (最远近战距离)',
        ko: '어스징 (칼끝딜 거리)'
      },
      shakerAvoid: {
        en: 'Avoid Earth Shakers',
        de: 'Weiche Erdstoß aus',
        fr: 'Évitez les secousses',
        ja: 'アスシェイカー回避',
        cn: '躲避大地摇动',
        ko: '어스징 피하기'
      }
    }
  }, {
    id: 'SephirotUn Earth Shaker Cleanup',
    type: 'HeadMarker',
    netRegex: {
      id: '0028',
      capture: false
    },
    delaySeconds: 5,
    run: data => delete data.shakerTargets
  }, {
    id: 'SephirotUn Storm of Words Revelation',
    type: 'StartsUsing',
    netRegex: {
      id: '7680',
      source: 'Storm of Words',
      capture: false
    },
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Storm of Words',
        de: 'Wörtersturm besiegen',
        fr: 'Tuez Tempête de mots ou mourrez',
        ja: 'ストーム・オブ・ワードから攻撃',
        cn: '击杀言语风暴!',
        ko: '신언의 폭풍 제거'
      }
    }
  }, {
    id: 'SephirotUn Ascension',
    type: 'HeadMarker',
    netRegex: {
      id: '003E',
      capture: false
    },
    response: responses/* Responses.stackMarker */.n3.stackMarker()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Coronal Wind': 'Koronalwind',
      'Sephirot': 'Sephirot',
      'Storm Of Words': 'Wörtersturm'
    },
    'replaceText': {
      'Tethers': 'Verbindungen',
      'spread': 'verteilen',
      'puddles': 'Flächen',
      'puddle(?!s)': 'Fläche',
      'Adds Spawn': 'Adds erscheinen',
      'Ascension': 'Himmelfahrt',
      'Chesed': 'Chesed',
      'Da\'at': 'Da\'at',
      'Earth Shaker': 'Erdstoß',
      'Ein Sof': 'En Sof',
      'Fiendish Rage': 'Dämonischer Zorn',
      'Fiendish Wail': 'Dämonische Klage',
      'Force Field': 'Kraftfeld',
      'Impact of Hod': 'Macht von Hod',
      'Life Force': 'Lebenskraft',
      'Malkuth': 'Malkuth',
      'Pillar of Mercy': 'Pfeiler der Gnade',
      'Pillar of Severity': 'Pfeiler der Strenge',
      'Ratzon': 'Ratzon',
      'Spirit': 'Geist',
      'Tiferet': 'Tiferet',
      'Triple Trial': 'Tripel-Triade',
      'Yesod': 'Yesod'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Coronal Wind': 'vent coronaire',
      'Sephirot': 'Sephirot',
      'Storm Of Words': 'tempête de mots'
    },
    'replaceText': {
      'Adds Spawn': 'Apparition d\'adds',
      'Ascension': 'Ascension',
      'Chesed': 'Chesed',
      'Chesed Gevurah': 'Chesed Gevurah',
      'Da\'at Tethers': 'Liens Da\'at',
      'Da\'at spread': 'Dispersion Da\'at',
      'Earth Shaker': 'Secousse',
      'Ein Sof': 'Ein Sof',
      'Fiendish Rage': 'Colère de Sephirot',
      'Fiendish Wail': 'Plainte de Sephirot',
      'Force Field': 'Champ de force',
      'Impact of Hod': 'Impact Hod',
      'Life Force': 'Force vitale',
      'Malkuth': 'Malkuth',
      'Pillar of Mercy': 'Pilier de la miséricorde',
      'Pillar of Severity': 'Pilier de la rigueur',
      'Ratzon': 'Ratzon',
      'Spirit': 'Esprit',
      'Tiferet': 'Tiferet',
      'Triple Trial': 'Triple coup',
      'Yesod': 'Yesod'
    }
  }, {
    'locale': 'ja',
    'missingTranslations': true,
    'replaceSync': {
      'Coronal Wind': 'コロナルウィンド',
      'Sephirot': 'セフィロト',
      'Storm Of Words': 'ストーム・オブ・ワード'
    },
    'replaceText': {
      'Adds Spawn': '雑魚',
      'Ascension': 'アセンション',
      '(?! )Chesed(?! )': 'ケセド',
      'Chesed Gevurah': 'ケセド・ゲブラー',
      'Da\'at': 'ダアト',
      'Earth Shaker': 'アースシェイカー',
      'Ein Sof(?! )': 'アイン・ソフ',
      'Ein Sof Ohr': 'アイン・ソフ・オウル',
      'Fiendish Rage': '魔神の怒り',
      'Fiendish Wail': '魔神の嘆き',
      'Force Field': 'フォースフィールド',
      'Impact of Hod': 'ホドインパクト',
      'Life Force': 'ライフフォース',
      'Malkuth': 'マルクト',
      'Pillar of Mercy': 'ピラー・オブ・メルシー',
      'Pillar of Severity': 'ピラー・オブ・セベリティ',
      'Ratzon': 'ラツォン',
      '(?<= )spread': '散開',
      'Spirit': 'スピリット',
      '(?<= )Tethers': '線',
      'Tiferet': 'ティファレト',
      'Triple Trial': 'トリプルブロー',
      'Yesod': 'イェソドクラッシュ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Coronal Wind': '冠状气流',
      'Sephirot': '萨菲洛特',
      'Storm Of Words': '言语风暴'
    },
    'replaceText': {
      'puddle(?:s)?': '圈圈',
      'spread': '散开',
      'Tethers': '连线',
      'Adds Spawn': '小怪出现',
      'Ascension': '上升气流',
      'Chesed(?! Gevurah)': '仁慈',
      'Chesed Gevurah': '仁慈之严酷',
      'Da\'at': '知识',
      'Earth Shaker': '大地摇动',
      'Ein Sof': '无限',
      'Fiendish Rage': '魔神之怒',
      'Fiendish Wail': '魔神之叹',
      'Force Field': '力场',
      'Impact of Hod': '荣光撞击',
      'Life Force': '生命领域',
      'Malkuth': '王国',
      'Pillar of Mercy': '慈悲之柱',
      'Pillar of Severity': '严厉之柱',
      'Ratzon': '意志',
      'Spirit': '圣灵领域',
      'Tiferet': '美丽',
      'Triple Trial': '三重强击',
      'Yesod': '基盘碎击'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Coronal Wind': '관상기류',
      'Sephirot': '세피로트',
      'Storm Of Words': '신언의 폭풍'
    },
    'replaceText': {
      'puddle(?:s)?': '장판',
      'Adds Spawn': '쫄 등장',
      'Ascension': '승천',
      'Chesed(?! Gevurah)': '헤세드',
      'Chesed Gevurah': '헤세드 게부라',
      'Da\'at spread': '다아트 산개',
      'Da\'at Tethers': '다아트 선',
      'Earth Shaker': '요동치는 대지',
      'Ein Sof(?! Ohr)': '아인 소프',
      'Ein Sof Ohr': '아인 소프 오르',
      'Fiendish Rage': '마신의 분노',
      'Fiendish Wail': '마신의 탄식',
      'Force Field': '역장',
      'Impact of Hod': '호드 대충격',
      'Life Force': '생명의 권능',
      'Malkuth': '말쿠트',
      'Pillar of Mercy': '자비의 기둥',
      'Pillar of Severity': '준엄의 기둥',
      'Ratzon': '라촌',
      'Spirit': '성령의 은사',
      'Tiferet': '티페레트',
      'Triple Trial': '삼중 강타',
      'Yesod': '예소드 붕괴'
    }
  }]
};
/* harmony default export */ const sephirot_un = (sephirot_un_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/sephirot-un.txt
const trial_sephirot_un_namespaceObject = "### Sephirot Unreal\r\n# -ic Binah Cochma\r\n# -ii 7698 769C 769D 76A9 76A0 76A1 76A2 76AE\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.1 \"Triple Trial\" Ability { id: \"7693\", source: \"Sephirot\" } window 7.1,5\r\n11.2 \"Tiferet\" Ability { id: \"7695\", source: \"Sephirot\" }\r\n17.4 \"Tiferet\" Ability { id: \"7695\", source: \"Sephirot\" }\r\n\r\n# Phase 1 rotation block, 76.3 seconds\r\n21.6 \"Triple Trial\" Ability { id: \"7693\", source: \"Sephirot\" }\r\n25.6 \"Ein Sof (4 puddles)\" Ability { id: \"769B\", source: \"Sephirot\" }\r\n29.7 \"Tiferet\" Ability { id: \"7695\", source: \"Sephirot\" }\r\n38.3 \"Fiendish Rage 1\" Ability { id: \"769A\", source: \"Sephirot\" }\r\n42.0 \"Fiendish Rage 2\" Ability { id: \"769A\", source: \"Sephirot\" }\r\n49.2 \"Tiferet\" Ability { id: \"7695\", source: \"Sephirot\" }\r\n53.3 \"Tiferet\" Ability { id: \"7695\", source: \"Sephirot\" }\r\n59.4 \"Chesed\" Ability { id: \"7694\", source: \"Sephirot\" } window 20,20\r\n61.6 \"Triple Trial\" Ability { id: \"7693\", source: \"Sephirot\" }\r\n67.7 \"Ein Sof (1 puddle)\" Ability { id: \"769B\", source: \"Sephirot\" }\r\n70.9 \"Tiferet\" Ability { id: \"7695\", source: \"Sephirot\" }\r\n81.3 \"Ratzon\" # Ability { id: \"7697\", source: \"Sephirot\" }\r\n85.5 \"Tiferet\" Ability { id: \"7695\", source: \"Sephirot\" }\r\n89.6 \"Tiferet\" Ability { id: \"7695\", source: \"Sephirot\" }\r\n95.7 \"Chesed\" Ability { id: \"7694\", source: \"Sephirot\" } window 20,20\r\n\r\n97.9 \"Triple Trial\" Ability { id: \"7693\", source: \"Sephirot\" }\r\n101.9 \"Ein Sof (4 puddles)\" Ability { id: \"769B\", source: \"Sephirot\" }\r\n106.0 \"Tiferet\" Ability { id: \"7695\", source: \"Sephirot\" }\r\n114.6 \"Fiendish Rage 1\" Ability { id: \"769A\", source: \"Sephirot\" }\r\n118.3 \"Fiendish Rage 2\" Ability { id: \"769A\", source: \"Sephirot\" }\r\n125.5 \"Tiferet\" Ability { id: \"7695\", source: \"Sephirot\" }\r\n129.6 \"Tiferet\" Ability { id: \"7695\", source: \"Sephirot\" }\r\n135.7 \"Chesed\" Ability { id: \"7694\", source: \"Sephirot\" } window 20,20\r\n137.9 \"Triple Trial\" Ability { id: \"7693\", source: \"Sephirot\" }\r\n144.0 \"Ein Sof (1 puddle)\" Ability { id: \"769B\", source: \"Sephirot\" }\r\n147.2 \"Tiferet\" Ability { id: \"7695\", source: \"Sephirot\" }\r\n157.6 \"Ratzon\" # Ability { id: \"7697\", source: \"Sephirot\" }\r\n161.8 \"Tiferet\" Ability { id: \"7695\", source: \"Sephirot\" }\r\n165.9 \"Tiferet\" Ability { id: \"7695\", source: \"Sephirot\" }\r\n172.0 \"Chesed\" Ability { id: \"7694\", source: \"Sephirot\" } window 20,20 jump 95.7\r\n\r\n174.2 \"Triple Trial\"\r\n178.2 \"Ein Sof (4 puddles)\"\r\n182.3 \"Tiferet\"\r\n190.9 \"Fiendish Rage 1\"\r\n194.6 \"Fiendish Rage 2\"\r\n201.8 \"Tiferet\"\r\n205.9 \"Tiferet\"\r\n\r\n\r\n# The intermission doesn't have anything worthwhile to sync.\r\n# Instead we just go straight for the ultimate cast. (It has no cast time.)\r\n# However, we don't want timeline triggers firing during the intermission.\r\n\r\n500.0 \"--sync--\" NameToggle { name: \"Sephirot\", toggle: \"00\" } window 500,0\r\n1000.0 \"Ein Sof Ohr\" Ability { id: \"769E\", source: \"Sephirot\" } window 1000,5\r\n\r\n# Phase 2 rotation block, 197.3 seconds\r\n1013.2 \"Yesod\" Ability { id: \"76AB\", source: \"Sephirot\" } window 30,30\r\n1016.2 \"Force Field\" Ability { id: \"76B4\", source: \"Sephirot\" }\r\n1028.4 \"Chesed Gevurah\" Ability { id: [\"76A5\", \"76A6\"], source: \"Sephirot\" }\r\n1029.0 \"Life Force + Spirit\" Ability { id: [\"76A7\", \"76A8\"], source: \"Sephirot\" }\r\n1034.6 \"Fiendish Wail\" Ability { id: \"76A3\", source: \"Sephirot\" }\r\n1042.7 \"Da'at Tethers\" duration 5 #Ability { id: \"769F\", source: \"Sephirot\" }\r\n1053.3 \"Fiendish Wail\" Ability { id: \"76A3\", source: \"Sephirot\" }\r\n1060.3 \"Chesed Gevurah\" Ability { id: [\"76A5\", \"76A6\"], source: \"Sephirot\" }\r\n1060.9 \"Life Force + Spirit\" Ability { id: [\"76A7\", \"76A8\"], source: \"Sephirot\" }\r\n1068.4 \"Earth Shaker\" Ability { id: \"76AA\", source: \"Sephirot\" }\r\n1070.1 \"Yesod\" Ability { id: \"76AB\", source: \"Sephirot\" } window 20,20\r\n1077.7 \"Da'at spread\" duration 3.2 #Ability { id: \"76AD\", source: \"Sephirot\" }\r\n1085.1 \"Fiendish Wail\" Ability { id: \"76A3\", source: \"Sephirot\" }\r\n1092.2 \"Chesed Gevurah\" Ability { id: [\"76A5\", \"76A6\"], source: \"Sephirot\" }\r\n1092.9 \"Life Force + Spirit\" Ability { id: [\"76A7\", \"76A8\"], source: \"Sephirot\" }\r\n1101.0 \"Pillar of Mercy 1\" Ability { id: \"76AD\", source: \"Sephirot\" }\r\n1101.3 \"Yesod\" Ability { id: \"76AB\", source: \"Sephirot\" } window 20,20\r\n1106.2 \"Pillar of Mercy 2\" Ability { id: \"76AD\", source: \"Sephirot\" }\r\n1110.1 \"Pillar of Mercy 3\" Ability { id: \"76AD\", source: \"Sephirot\" }\r\n1119.3 \"Earth Shaker\" Ability { id: \"76AA\", source: \"Sephirot\" }\r\n1128.8 \"Da'at spread\" duration 3.2 #Ability { id: \"76AD\", source: \"Sephirot\" }\r\n1129.7 \"Yesod\" Ability { id: \"76AB\", source: \"Sephirot\" } window 20,20\r\n1136.1 \"Fiendish Wail\" Ability { id: \"76A3\", source: \"Sephirot\" }\r\n1143.2 \"Chesed Gevurah\" Ability { id: [\"76A5\", \"76A6\"], source: \"Sephirot\" }\r\n1143.8 \"Life Force + Spirit\" Ability { id: [\"76A7\", \"76A8\"], source: \"Sephirot\" }\r\n1149.4 \"Malkuth\" Ability { id: \"76AF\", source: \"Sephirot\" } window 30,30\r\n1150.5 \"Adds Spawn\" AddedCombatant { name: \"Storm Of Words\" }\r\n1158.7 \"Chesed Gevurah\" Ability { id: [\"76A5\", \"76A6\"], source: \"Sephirot\" }\r\n1159.3 \"Life Force + Spirit\" Ability { id: [\"76A7\", \"76A8\"], source: \"Sephirot\" }\r\n1164.9 \"Fiendish Wail\" Ability { id: \"76A3\", source: \"Sephirot\" }\r\n1166.5 \"Yesod\" Ability { id: \"76AB\", source: \"Sephirot\" }\r\n1172.2 \"Chesed Gevurah\" Ability { id: [\"76A5\", \"76A6\"], source: \"Sephirot\" }\r\n1172.8 \"Life Force + Spirit\" Ability { id: [\"76A7\", \"76A8\"], source: \"Sephirot\" }\r\n1185.8 \"Yesod\" Ability { id: \"76AB\", source: \"Sephirot\" }\r\n1188.4 \"Chesed Gevurah\" Ability { id: [\"76A5\", \"76A6\"], source: \"Sephirot\" }\r\n1189.0 \"Life Force + Spirit\" Ability { id: [\"76A7\", \"76A8\"], source: \"Sephirot\" }\r\n1191.6 \"Pillar of Severity\" Ability { id: \"76B2\", source: \"Sephirot\" }\r\n1195.3 \"Impact of Hod\" Ability { id: \"76BA\", source: \"Sephirot\" }\r\n1199.7 \"Ascension\" Ability { id: \"76B1\", source: \"Coronal Wind\" }\r\n\r\n1210.4 \"Yesod\" Ability { id: \"76AB\", source: \"Sephirot\" } window 30,30\r\n1213.5 \"Force Field\" Ability { id: \"76B4\", source: \"Sephirot\" }\r\n1225.7 \"Chesed Gevurah\" Ability { id: [\"76A5\", \"76A6\"], source: \"Sephirot\" }\r\n1226.3 \"Life Force + Spirit\" Ability { id: [\"76A7\", \"76A8\"], source: \"Sephirot\" }\r\n1231.9 \"Fiendish Wail\" Ability { id: \"76A3\", source: \"Sephirot\" }\r\n1240.0 \"Da'at Tethers\" duration 5 #Ability { id: \"769F\", source: \"Sephirot\" }\r\n1250.6 \"Fiendish Wail\" Ability { id: \"76A3\", source: \"Sephirot\" }\r\n1257.6 \"Chesed Gevurah\" Ability { id: [\"76A5\", \"76A6\"], source: \"Sephirot\" }\r\n1258.2 \"Life Force + Spirit\" Ability { id: [\"76A7\", \"76A8\"], source: \"Sephirot\" }\r\n1265.7 \"Earth Shaker\" Ability { id: \"76AA\", source: \"Sephirot\" }\r\n1267.4 \"Yesod\" Ability { id: \"76AB\", source: \"Sephirot\" } window 20,20\r\n1275.0 \"Da'at spread\" duration 3.2 #Ability { id: \"76AD\", source: \"Sephirot\" }\r\n1282.4 \"Fiendish Wail\" Ability { id: \"76A3\", source: \"Sephirot\" }\r\n1289.5 \"Chesed Gevurah\" Ability { id: [\"76A5\", \"76A6\"], source: \"Sephirot\" }\r\n1290.2 \"Life Force + Spirit\" Ability { id: [\"76A7\", \"76A8\"], source: \"Sephirot\" }\r\n1298.3 \"Pillar of Mercy 1\" Ability { id: \"76AD\", source: \"Sephirot\" }\r\n1298.6 \"Yesod\" Ability { id: \"76AB\", source: \"Sephirot\" } window 20,20\r\n1303.5 \"Pillar of Mercy 2\" Ability { id: \"76AD\", source: \"Sephirot\" }\r\n1307.4 \"Pillar of Mercy 3\" Ability { id: \"76AD\", source: \"Sephirot\" }\r\n1316.6 \"Earth Shaker\" Ability { id: \"76AA\", source: \"Sephirot\" }\r\n1326.1 \"Da'at spread\" duration 3.2 #Ability { id: \"76AD\", source: \"Sephirot\" }\r\n1327.0 \"Yesod\" Ability { id: \"76AB\", source: \"Sephirot\" } window 20,20\r\n1333.4 \"Fiendish Wail\" Ability { id: \"76A3\", source: \"Sephirot\" }\r\n1340.5 \"Chesed Gevurah\" Ability { id: [\"76A5\", \"76A6\"], source: \"Sephirot\" }\r\n1341.1 \"Life Force + Spirit\" Ability { id: [\"76A7\", \"76A8\"], source: \"Sephirot\" }\r\n1346.7 \"Malkuth\" Ability { id: \"76AF\", source: \"Sephirot\" }\r\n1347.8 \"Adds Spawn\" AddedCombatant { name: \"Storm Of Words\" }\r\n1356.0 \"Chesed Gevurah\" Ability { id: [\"76A5\", \"76A6\"], source: \"Sephirot\" }\r\n1356.6 \"Life Force + Spirit\" Ability { id: [\"76A7\", \"76A8\"], source: \"Sephirot\" }\r\n1362.2 \"Fiendish Wail\" Ability { id: \"76A3\", source: \"Sephirot\" }\r\n1363.8 \"Yesod\" Ability { id: \"76AB\", source: \"Sephirot\" }\r\n1369.5 \"Chesed Gevurah\" Ability { id: [\"76A5\", \"76A6\"], source: \"Sephirot\" }\r\n1370.1 \"Life Force + Spirit\" Ability { id: [\"76A7\", \"76A8\"], source: \"Sephirot\" }\r\n1382.9 \"Yesod\" Ability { id: \"76AB\", source: \"Sephirot\" }\r\n1385.7 \"Chesed Gevurah\" Ability { id: [\"76A5\", \"76A6\"], source: \"Sephirot\" }\r\n1386.3 \"Life Force + Spirit\" Ability { id: [\"76A7\", \"76A8\"], source: \"Sephirot\" }\r\n1388.9 \"Pillar of Severity\" Ability { id: \"76B2\", source: \"Sephirot\" }\r\n1392.6 \"Impact of Hod\" Ability { id: \"76BA\", source: \"Sephirot\" }\r\n1397.0 \"Pillar of Severity Enrage\" Ability { id: \"76B2\", source: \"Sephirot\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/sophia-un.ts
// This file was autogenerated from running npm run sync-files.
// DO NOT EDIT THIS FILE DIRECTLY.
// Edit the source file below and then run `npm run sync-files`
// Source: ui/raidboss/data/03-hw/trial/sophia-ex.ts





const sophia_un_findSafeDir = data => {
  // Tethers are ordered with all East tethers first. This *doesn't* mean that the East
  // or West tethers are themselves in order within their half!
  // The eight scale entities are listed in the data object, with West at indices 0-3,
  // under data.scaleSophias.
  let safeDir = 0;
  // If there's a side with more tethers, we know for sure that's the safe side.
  // This will give us the tilt direction for all but the 1/1, 2/2, and 3/3 cases.
  // The safe side is represented here by whether safeDir is positive or negative.
  // (West/negative, East/positive.)
  for (const tether of data.quasarTethers ?? []) {
    const idx = data.scaleSophias?.indexOf(tether);
    if (idx === undefined) throw new not_reached/* UnreachableCode */.$();
    safeDir += idx < 4 ? -1 : 1;
  }
  return safeDir;
};
const sophia_un_callSafeDir = (callIndex, output) => {
  const outputs = {
    '2': output.goEastHardTilt(),
    '1': output.goEastSoftTilt(),
    '-2': output.goWestHardTilt(),
    '-1': output.goWestSoftTilt()
    // Stringified because Javascript doesn't do negative-integer key values.
  };

  return outputs[callIndex.toString()];
};
const sophia_un_tiltOutputStrings = {
  goEastHardTilt: {
    en: 'Go East (Hard Tilt)',
    de: 'Nach Osten gehen (starke Neigung)',
    fr: 'Allez à l\'Est (Inclinaison forte)',
    ja: '東へ (大きい斜め)',
    cn: '去东边（大倾斜）',
    ko: '동쪽으로 (크게 기울어짐)'
  },
  goEastSoftTilt: {
    en: 'Go East (Soft Tilt)',
    de: 'Nach Osten gehen (leichte Neigung)',
    fr: 'Allez à l\'Est (Inclinaison faible)',
    ja: '東へ (小さい斜め)',
    cn: '去东边（小倾斜）',
    ko: '동쪽으로 (작게 기울어짐)'
  },
  goWestHardTilt: {
    en: 'Go West (Hard Tilt)',
    de: 'Nach Westen gehen (starke Neigung)',
    fr: 'Allez à l\'Ouest (Inclinaison forte)',
    ja: '西へ (大きい斜め)',
    cn: '去西边（大倾斜）',
    ko: '서쪽으로 (크게 기울어짐)'
  },
  goWestSoftTilt: {
    en: 'Go West (Soft Tilt)',
    de: 'Nach Westen gehen (leichte Neigung)',
    fr: 'Allez à l\'Ouest (Inclinaison faible)',
    ja: '西へ (小さい斜め)',
    cn: '去西边（小倾斜）',
    ko: '서쪽으로 (작게 기울어짐)'
  }
};
const sophia_un_triggerSet = {
  id: 'ContainmentBayP1T6Unreal',
  zoneId: zone_id/* default.ContainmentBayP1T6Unreal */.Z.ContainmentBayP1T6Unreal,
  timelineFile: 'sophia-un.txt',
  initData: () => {
    return {
      isQuadrantSafe: {
        NW: true,
        NE: true,
        SW: true,
        SE: true
      }
    };
  },
  timelineTriggers: [{
    // Gnosis does in fact have a cast time, but it's only 2.7 seconds.
    // It's safer to warn via the timeline.
    id: 'SophiaUN Gnosis',
    regex: /Gnosis/,
    beforeSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    // Onrush also has a 2.7 second cast time and thus is best notified from the timeline.
    id: 'SophiaUN Onrush',
    regex: /Onrush/,
    beforeSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid Dash Attack',
        de: 'Ansturm-Angriff ausweichen',
        fr: 'Évitez l\'attaque Charge',
        ja: '突進回避',
        cn: '躲避击飞',
        ko: '돌진 공격 피하기'
      }
    }
  }, {
    id: 'SophiaUN Cintamani',
    regex: /Cintamani/,
    beforeSeconds: 4,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'SophiaUN Dischordant Cleansing',
    regex: /Dischordant Cleansing/,
    beforeSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stack With Partner',
        de: 'Mit Partner stacken',
        fr: 'Packez-vous avec votre partenaire',
        ja: '白と黒で重なる',
        cn: '黑白配',
        ko: '흑백 파트너랑 모이기'
      }
    }
  }, {
    id: 'SophiaUN Quasar Bait',
    regex: /Quasar \(Snapshot\)/,
    beforeSeconds: 6,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Quasar Meteors',
        de: 'Quasar Meteore ködern',
        fr: 'Attirez les météores du Quasar',
        ja: 'メテオを誘導',
        cn: '诱导陨石',
        ko: '운석 유도하기'
      }
    }
  }],
  triggers: [{
    id: 'SophiaUN Tank Buster',
    type: 'StartsUsing',
    netRegex: {
      id: '7DBE',
      source: 'Sophia'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'SophiaUN Thunder 2',
    type: 'StartsUsing',
    netRegex: {
      id: '7DAA',
      source: 'Sophia',
      capture: false
    },
    response: responses/* Responses.awayFromFront */.n3.awayFromFront()
  }, {
    id: 'SophiaUN Thunder 3',
    type: 'StartsUsing',
    netRegex: {
      id: '7DA6',
      source: 'Sophia',
      capture: false
    },
    response: responses/* Responses.getUnder */.n3.getUnder()
  }, {
    // Technically this one does have a telegraph, but it feels really weird
    // to have Thunder 3 with popup text and this one not.
    id: 'SophiaUN Aero 3',
    type: 'StartsUsing',
    netRegex: {
      id: '7DA8',
      source: 'Sophia',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'SophiaUN Divine Spark',
    type: 'StartsUsing',
    netRegex: {
      id: '7DB0',
      source: 'The Second Demiurge'
    },
    response: responses/* Responses.lookAwayFromSource */.n3.lookAwayFromSource()
  }, {
    id: 'SophiaUN Gnostic Rant',
    type: 'StartsUsing',
    netRegex: {
      id: '7DB2',
      source: 'The Third Demiurge',
      capture: false
    },
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Get behind lancer',
        de: 'Geh hinter dem 3. Demiurg',
        fr: 'Passez derrière le lancier',
        ja: '三の従者の後ろに',
        cn: '躲在3号小怪后',
        ko: '제3신도 뒤로 가기'
      }
    }
  }, {
    id: 'SophiaUN Infusion',
    type: 'StartsUsing',
    netRegex: {
      id: '7D9F',
      source: 'The First Demiurge'
    },
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.infusionOnYou();
      return output.infusionOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      infusionOnYou: {
        en: 'Infusion on YOU',
        de: 'Schneisenschläger auf DIR',
        fr: 'Infusion sur VOUS',
        ja: '自分に猛突進',
        cn: '冲锋点名',
        ko: '맹돌진 대상자'
      },
      infusionOn: {
        en: 'Infusion on ${player}',
        de: 'Schneisenschläger auf ${player}',
        fr: 'Infusion sur ${player}',
        ja: '${player}に猛突進',
        cn: '冲锋点${player}',
        ko: '${player} 에게 맹돌진'
      }
    }
  }, {
    // The Aion Teleos clones have 10 fixed points where they can appear, but not all
    // combinations are valid:
    // (0,9), (0,-9), (-10,9), (-10,-9), (10,9), (10,-9), (-15,9), (-15,-9), (15,9), (15,-9).
    // Each quadrant can contain 0 or 1 clones, and the center can have 0-2.
    // There will always be 4 clones.
    // There can never be more than 3 clones North or South.

    // The full sequence for clones is:
    // 1. Clones appear, alongside a Cintamani cast
    // If it's the first clone set:
    // 2. Sophia casts Thunder III
    // 3. Sophia casts Aero
    // 4. Sophia casts Arms of Wisdom
    // 5. Barbelo moves to cast Light Dew
    // 6. Barbelo casts Light Dew and Sophia casts Execute
    // 7. Clones disappear

    // If it's not the first clone set:
    // 2. Sophia casts Arms Of Wisdom
    // 3. Sophia casts Thunder
    // 4. Sophia casts Aero
    // 5. Quasars cast, snapshot, and resolve
    // 6. Sophia casts Arms Of Wisdom again
    // 7. Dischordant Cleansing circles go out and resolve
    // 8. Sophia casts Execute
    // 9. Clones disappear
    id: 'SophiaUN Clone Collect',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Aion Teleos'
    },
    run: (data, matches) => {
      data.cloneSpots ??= {};
      const x = parseFloat(matches.x);
      const y = parseFloat(matches.y);
      // We start with Y since it's a binary choice.
      // Note that Y-values are inverted! (In-game, 0,1 is one unit South from the origin)
      let positionString = y > 0 ? 'S' : 'N';
      // The center two clones aren't exactly on the centerline, so we round the X coordinates.
      if (Math.round(x) !== 0) positionString += Math.round(x) < 0 ? 'W' : 'E';
      // Yes, we have to specifically uppercase this for 03 log lines.
      // No, we don't know why. Blame Square/Ravahn/Hydaelyn.
      data.cloneSpots[matches.id.toUpperCase()] = positionString;
    }
  }, {
    // Thunder is always cast first when the Aion Teleos spawn.
    // Because we don't know whether there will be one or two Thunder tethers,
    // we have to separate out the "seen Thunder" logic.
    id: 'SophiaUN Duplicate Collect',
    type: 'Tether',
    netRegex: {
      id: '002D'
    },
    run: (data, matches) => {
      const spot = data.cloneSpots?.[matches.sourceId];
      if (spot === undefined) throw new not_reached/* UnreachableCode */.$();
      // Only Thunder 2 is ever used on centerline clones,
      // so center clones will never affect quadrant safety.
      if (spot === 'N' || spot === 'S') {
        return;
      }
      if (data.seenThunder) {
        data.isQuadrantSafe[spot] = false;
      }
    }
  }, {
    id: 'SophiaUN Thunder Seen',
    type: 'StartsUsing',
    netRegex: {
      id: '7DA5',
      source: 'Aion Teleos',
      capture: false
    },
    delaySeconds: 1,
    suppressSeconds: 5,
    run: data => data.seenThunder = true
  }, {
    // Quasar can either be meteor baits or a platform tilt,
    // but the platform will not tilt while clones are active.
    // Since both have the same tethers and initial cast,
    // our best way to call the mechanic is to check whether clones are active.
    id: 'SophiaUN Clones Active',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Aion Teleos',
      capture: false
    },
    run: data => data.clonesActive = true
  }, {
    // During the first post-intermission clones sequence,
    // Barbelo separates and makes one safespot dangerous with Light Dew, the orange laser.
    // Unfortunately Barbelo doesn't have a cast time on Light Dew, so we can't use that.
    // Instead, we warn the user when Barbelo separates from Sophia, which is 7D9D.
    id: 'SophiaUN Light Dew',
    type: 'Ability',
    netRegex: {
      id: '7D9D',
      source: 'Sophia',
      capture: false
    },
    condition: data => data.clonesActive,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Avoid head laser',
        de: 'Kopflaser ausweichen',
        fr: 'Évitez le laser de la tête',
        ja: '頭レーザー回避',
        cn: '躲避人头炮',
        ko: '머리 레이저 피하기'
      }
    }
  }, {
    id: 'SophiaUN Execute',
    type: 'StartsUsing',
    netRegex: {
      id: '7DA4',
      source: 'Sophia'
    },
    durationSeconds: (_data, matches) => parseFloat(matches.castTime),
    alertText: (data, _matches, output) => {
      const localeCompass = {
        'NW': output.northwest(),
        'NE': output.northeast(),
        'SW': output.southwest(),
        'SE': output.southeast()
      };
      const safeSpots = [];
      for (const dir of Object.keys(data.isQuadrantSafe)) {
        if (data.isQuadrantSafe[dir]) safeSpots.push(localeCompass[dir]);
      }
      if (safeSpots.length === 1) {
        return safeSpots[0];
      }
      return output.multiple({
        dir1: safeSpots[0],
        dir2: safeSpots[1]
      });
    },
    outputStrings: {
      northwest: outputs/* default.northwest */.Z.northwest,
      northeast: outputs/* default.northeast */.Z.northeast,
      southwest: outputs/* default.southwest */.Z.southwest,
      southeast: outputs/* default.southeast */.Z.southeast,
      multiple: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        ja: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      }
    }
  }, {
    id: 'SophiaUN Clone Cleanup',
    type: 'Ability',
    netRegex: {
      id: '7DA4',
      source: 'Sophia',
      capture: false
    },
    delaySeconds: 5,
    run: data => {
      delete data.clonesActive;
      delete data.seenThunder;
      data.isQuadrantSafe = {
        NW: true,
        NE: true,
        SW: true,
        SE: true
      };
    }
  }, {
    // The eight Sophia entities on the scale pans have IDs that run sequentially,
    // from n + 0 to n + 7. They spawn into the instance in a random order, but the
    // locations where they spawn have a fixed association with their sequence number offset:

    // 0: (-55.0637, -3.496415)
    // 1: (-55.06367, -10.1404)
    // 2: (-55.06363, 9.5766)
    // 3: (-55.0637, 3.523648)
    // 4: (54.9907, 3.387837)
    // 5: (54.98699, 9.576593)
    // 6: (54.9907, -3.50686)
    // 7: (54.99068, -10.14043)

    // Because of this, we need only see one entity use a 21 log line and we can find the rest.
    id: 'SophiaUN Quasar Setup',
    type: 'Ability',
    netRegex: {
      id: ['7DA2', '7DA3']
    },
    condition: data => !data.scaleSophias,
    // We *really* shouldn't have to suppress this...
    suppressSeconds: 5,
    run: (data, matches) => {
      let offset;
      const yKey = Math.floor(parseFloat(matches.y)).toString();
      if (parseFloat(matches.x) < 0) {
        const offsetMap = {
          '-4': 0,
          '-11': 1,
          '9': 2,
          '3': 3
        };
        offset = offsetMap[yKey];
      } else {
        const offsetMap = {
          '3': 4,
          '9': 5,
          '-4': 6,
          '-11': 7
        };
        offset = offsetMap[yKey];
      }
      if (offset === undefined) throw new not_reached/* UnreachableCode */.$();
      const seqStart = parseInt(matches.sourceId, 16) - offset;
      for (let i = 0; i < 8; i++) {
        data.scaleSophias ??= [];
        data.scaleSophias.push((seqStart + i).toString(16).toUpperCase());
      }
    }
  }, {
    // We collect tethers here for later use on Quasar calls.
    // Blue Quasars (7DA3) weigh 3 units, while orange ones (7DA2) weigh 1.
    // Meteor Quasars happen only when we have a 3/1 split of tethers (balanced).
    // If the tether split is not 3/1, it will always be one of these possibilities:
    // 1/1, 2/2, 3/3, 2/1, 3/2, 4/2, 4/3
    // If the difference of the sum of weights on each side is 1, the tilt will be soft.
    // Otherwise it will be hard.
    // There will always be exactly one blue Quasar, unless the split is 4/2.
    id: 'SophiaUN Quasar Tether Collect',
    type: 'Tether',
    netRegex: {
      id: '0011'
    },
    condition: data => {
      // We shouldn't run this while Aion Teleos mechanics are active.
      return !data.clonesActive;
    },
    run: (data, matches) => {
      data.quasarTethers ??= [];
      data.quasarTethers.push(matches.sourceId);
    }
  }, {
    id: 'SophiaUN Tilt Via Tether',
    type: 'Tether',
    netRegex: {
      id: '0011',
      capture: false
    },
    condition: data => {
      // No platform tilts if clones are up.
      return !data.clonesActive;
    },
    // We let the storage triggers catch up before calling.
    delaySeconds: .5,
    durationSeconds: 12,
    // Ensuring that forgetful people aren't forgotten.
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      // If we somehow skipped the first set of Quasars, we won't know the locations of
      // the scale entities. Activate the sadTethers flag and wait for the actual casts.
      if (!data.scaleSophias) {
        data.sadTethers = true;
        return;
      }
      const safeDir = sophia_un_findSafeDir(data);
      if (safeDir === 0) {
        // If it's the 1/1, 2/2, or 3/3 case, we sadly don't have enough information.
        // We have to quit here and wait for the actual cast.
        data.sadTethers = true;
        return;
      }
      return sophia_un_callSafeDir(safeDir, output);
    },
    outputStrings: sophia_un_tiltOutputStrings
  }, {
    // This specifically calls the case where it's 1/1;2/2;3/3 tethers,
    // or any tether combination if we skipped the first Meteor Quasars.
    // The blue Quasar, 7DA3, is *alway* on the dangerous side.
    // The 20/startsUsing log lines don't actually have position data,
    // but we enumerated all the locations earlier,
    // so anytime one of these entities casts, we know where it is.
    id: 'SophiaUN Tilt Via Cast',
    type: 'StartsUsing',
    netRegex: {
      id: '7DA3',
      source: 'Sophia'
    },
    condition: data => data.sadTethers,
    durationSeconds: 10,
    suppressSeconds: 5,
    alertText: (data, matches, output) => {
      let safeDir = sophia_un_findSafeDir(data);
      // If this is the first set of Meteor Quasars, there is no tilt.
      if (data.quasarTethers?.length === 4 && safeDir !== 0) return;
      if (safeDir === 0) {
        const idx = data.scaleSophias?.indexOf(matches.sourceId);
        if (idx === undefined) throw new not_reached/* UnreachableCode */.$();
        safeDir = idx < 4 ? 2 : -2;
      }
      return sophia_un_callSafeDir(safeDir, output);
    },
    outputStrings: sophia_un_tiltOutputStrings
  }, {
    id: 'SophiaUN Quasar Cleanup',
    type: 'Ability',
    netRegex: {
      id: '7DA3',
      capture: false
    },
    run: data => {
      delete data.quasarTethers;
      delete data.sadTethers;
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Aion Teleos': 'Aion Teleos',
      'Barbelo': 'Barbelo',
      'Sophia': 'Sophia',
      'The First Demiurge': 'Erst(?:e|er|es|en) Demiurg',
      'The Second Demiurge': 'Zweit(?:e|er|es|en) Demiurg',
      'The Third Demiurge': 'Dritt(?:e|er|es|en) Demiurg'
    },
    'replaceText': {
      '\\(Meteor Detonate\\)': '(Meteor Explosion)',
      '\\(Snapshot\\)': '(Meteor Positionen)',
      '\\(Tilt\\)': '(Neigung)',
      'Aero III': 'Windga',
      'Arms of Wisdom': 'Arme der Weisheit',
      'Cintamani': 'Chintamani',
      'Cloudy Heavens': 'Nebulöse Himmel',
      'Dischordant Cleansing': 'Dissonante Buße',
      'Divine Spark': 'Göttlicher Funke',
      'Execute': 'Exekutieren',
      'Gnosis': 'Gnosis',
      'Gnostic Spear': 'Gnostischer Speer',
      'Horizontal Kenoma': 'Horizontales Kenoma',
      'Light Dew': 'Lichttau',
      'Onrush': 'Heranstürmen',
      'Quasar': 'Quasar',
      'Ring of Pain': 'Ring des Schmerzes',
      'The Scales Of Wisdom': 'Waage der Weisheit',
      'Tethers': 'Verbindungen',
      'Thunder II\\/III': 'Blitzra/Blitzga',
      'Thunder II(?!(?:I|\\/))': 'Blitzra',
      'Thunder III': 'Blitzga',
      'Vertical Kenoma': 'Vertikales Kenoma',
      'Zombification': 'Zombie'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Aion Teleos': 'Aion Teleos',
      'Barbelo': 'Barbelo',
      'Sophia': 'Sophia',
      'The First Demiurge': 'Premier Démiurge',
      'The Second Demiurge': 'Second Démiurge',
      'The Third Demiurge': 'Troisième Démiurge'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(Meteor Detonate\\)': '(Explosion des météores)',
      '\\(Snapshot\\)': '(Instantané)',
      '\\(Tilt\\)': '(Inclinaison)',
      'Aero III': 'Méga Vent',
      'Arms of Wisdom': 'Bras de la sagesse',
      'Cintamani': 'Chintamani',
      'Cloudy Heavens': 'Ciel nébuleux',
      'Dischordant Cleansing': 'Purification Discordante',
      'Divine Spark': 'Étincelle divine',
      'Execute': 'Exécution',
      'Gnosis': 'Gnose',
      'Gnostic Spear': 'Épieu Gnostique',
      'Horizontal Kenoma': 'Kenoma horizontal',
      'Light Dew': 'Rosée De Lumière',
      'Onrush': 'Charge',
      'Quasar': 'Quasar',
      'Quasar Tethers': 'Liens Quasar',
      'Ring of Pain': 'Anneau de douleur',
      'The Scales Of Wisdom': 'Balance de la sagesse',
      'Thunder II\\/III': 'Extra Foudre/Mega Foudre',
      'Thunder II(?!(?:I|\\/))': 'Extra Foudre',
      'Thunder III': 'Méga Foudre',
      'Vertical Kenoma': 'Kenoma Vertical',
      'Zombification': 'Zombification'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Aion Teleos': 'アイオーン・ソフィア',
      'Barbelo': 'バルベロ',
      'Sophia': 'ソフィア',
      'The First Demiurge': '一の従者',
      'The Second Demiurge': '二の従者',
      'The Third Demiurge': '三の従者'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(Meteor Detonate\\)': '(メテオ)',
      '\\(Snapshot\\)': '(ヘッド)',
      '\\(Tilt\\)': '(斜め)',
      'Aero III': 'エアロガ',
      'Arms of Wisdom': 'ウィズダムアームズ',
      'Cintamani': 'チンターマニ',
      'Cloudy Heavens': 'クラウディヘヴン',
      'Dischordant Cleansing': '不調和の罰',
      'Divine Spark': '熱いまなざし',
      'Execute': 'エクセキュート',
      'Gnosis': 'グノーシス',
      'Gnostic Spear': '魔槍突き',
      'Horizontal Kenoma': '側面堅守',
      'Light Dew': 'ライトデュー',
      'Onrush': 'オンラッシュ',
      'Quasar': 'クエーサー',
      'Ring of Pain': 'リング・オブ・ペイン',
      'The Scales Of Wisdom': 'バランス・オブ・ウィズダム',
      '(?<= )Tethers': '線',
      'Thunder II\\/III': 'サンダー/サンダガ',
      'Thunder II(?!(?:I|\\/I))': 'サンダラ',
      'Thunder III': 'サンダガ',
      'Vertical Kenoma': '前後堅守',
      'Zombification': 'ゾンビー'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Aion Teleos': '移涌',
      'Barbelo': '芭碧萝',
      'Sophia': '索菲娅',
      'The First Demiurge': '信徒其一',
      'The Second Demiurge': '信徒其二',
      'The Third Demiurge': '信徒其三'
    },
    'replaceText': {
      '\\?': ' ?',
      '\\(Meteor Detonate\\)': '(陨石爆炸)',
      '\\(Snapshot\\)': '(快照)',
      '\\(Tilt\\)': '(倾斜)',
      'Aero III': '暴风',
      'Arms of Wisdom': '睿智之秤',
      'Cintamani': '如意宝珠',
      'Cloudy Heavens': '阴云天堂',
      'Dischordant Cleansing': '不平衡之罚',
      'Divine Spark': '灼热视线',
      'Execute': '处决',
      'Gnosis': '灵知',
      'Gnostic Spear': '魔枪突刺',
      'Horizontal Kenoma': '侧面坚守',
      'Light Dew': '光露',
      'Onrush': '突袭',
      'Quasar': '类星体',
      'Ring of Pain': '痛苦环刺',
      'The Scales Of Wisdom': '睿智之天平',
      'Thunder II\\/III': '震雷/暴雷',
      'Thunder II(?!(?:I|\\/))': '震雷',
      'Thunder III': '暴雷',
      'Vertical Kenoma': '前后坚守',
      'Zombification': '僵尸'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Aion Teleos': '아이온 소피아',
      'Barbelo': '바르벨로',
      'Sophia': '소피아',
      'The First Demiurge': '제1신도',
      'The Second Demiurge': '제2신도',
      'The Third Demiurge': '제3신도'
    },
    'replaceText': {
      'Aero III': '에어로가',
      'Arms of Wisdom': '지혜의 무기',
      'Cintamani': '친타마니',
      'Cloudy Heavens': '흐린 낙원',
      'Dischordant Cleansing': '부조화의 벌',
      'Divine Spark': '뜨거운 시선',
      'Execute': '이행',
      'Gnosis': '영적 지혜',
      'Gnostic Spear': '마창 찌르기',
      'Horizontal Kenoma': '측면 견제',
      'Light Dew': '빛의 이슬',
      'Onrush': '돌진',
      'Quasar': '퀘이사',
      'Ring Of Pain': '고통의 소용돌이',
      'The Scales Of Wisdom': '지혜의 저울',
      'Thunder II\\/III': '선더라/선더가',
      'Thunder II(?!(?:I|\\/))': '선더라',
      'Thunder III': '선더가',
      'Vertical Kenoma': '앞뒤 견제',
      'Zombification': '좀비'
    }
  }]
};
/* harmony default export */ const sophia_un = (sophia_un_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/sophia-un.txt
const trial_sophia_un_namespaceObject = "# This file was autogenerated from running npm run sync-files.\r\n# DO NOT EDIT THIS FILE DIRECTLY.\r\n# Edit the source file below and then run `npm run sync-files`\r\n# Source: ui/raidboss/data/03-hw/trial/sophia-ex.txt\r\n\r\n# Containment Bay S1-T6 (Unreal)\r\n# Sophia Unreal\r\n\r\n# -ii 7D9D 7D9E 7DA0 7DA2 7DA3 7DA7 7DA9 7DAB 7E46 7EB8 7EB9\r\n\r\n# Enrage is 7DC5, but it comes up immediately after the impossible Sin/Suffering.\r\n# There's no way to differentiate this in the timeline.\r\n\r\n# 7E46 is not a Quasar ability. It's instead one of two \"unknown\" abilities that\r\n# move the stage background and slide the player.\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n12.0 \"Thunder II\" Ability { id: \"7DAA\", source: \"Sophia\" } window 12,5\r\n22.4 \"Gnosis\" Ability { id: \"7DBC\", source: \"Barbelo\" }\r\n41.4 \"Arms Of Wisdom?\" Ability { id: \"7DBE\", source: \"Sophia\" } # May be skipped depending on DPS\r\n\r\n# This section will be reached either at 56.0, or at the time she is pushed to 90%\r\n56.0 \"--clones appear--\" AddedCombatant { name: \"Aion Teleos\" } window 56,5\r\n63.6 \"Thunder II/III\" Ability { id: [\"7DA6\", \"7DAA\"], source: \"Sophia\" }\r\n63.6 \"--sync--\" Ability { id: \"7DA5\", source: \"Aion Teleos\" } window 30,2.5\r\n69.7 \"Aero III\" Ability { id: \"7DA8\", source: \"Sophia\" }\r\n69.7 \"--sync--\" Ability { id: \"7DA5\", source: \"Aion Teleos\" }\r\n79.8 \"Execute\" Ability { id: \"7DA4\", source: \"Sophia\" }\r\n#79.8 \"Execute\" Ability { id: \"7DA9\", source: \"Aion Teleos\" }\r\n90.2 \"Arms Of Wisdom\" Ability { id: \"7DBE\", source: \"Sophia\" }\r\n\r\n# Intermission.\r\n# Divine Spark can be pushed and thus is not synced.\r\n# Gnostic Rant and Infusion are purely HP-based pushes.\r\n110.6 \"Cloudy Heavens\" Ability { id: \"7DB8\", source: \"Sophia\" } window 110.6,0\r\n111.6 \"--untargetable--\"\r\n111.6 \"--adds spawn--\"\r\n120.9 \"Horizontal Kenoma/Vertical Kenoma\" Ability { id: [\"7DB5\", \"7DB6\"], source: \"The First Demiurge\" }\r\n121.9 \"Gnostic Spear\" Ability { id: \"7DB3\", source: \"The Third Demiurge\" }\r\n125.9 \"Divine Spark\" # Ability { id: \"7DB0\", source: \"The Second Demiurge\" }\r\n129.0 \"Ring Of Pain\" Ability { id: \"7DB4\", source: \"The Third Demiurge\" }\r\n135.1 \"Horizontal Kenoma/Vertical Kenoma\" Ability { id: [\"7DB5\", \"7DB6\"], source: \"The First Demiurge\" }\r\n147.3 \"Gnostic Spear?\" Ability { id: \"7DB3\", source: \"The Third Demiurge\" }\r\n149.2 \"Horizontal Kenoma/Vertical Kenoma\" Ability { id: [\"7DB5\", \"7DB6\"], source: \"The First Demiurge\" }\r\n191.6 \"Zombification Enrage?\"\r\n\r\n# There's an introductory block leading into a rotation.\r\n250.0 \"The Scales Of Wisdom\" Ability { id: \"7D9C\", source: \"Sophia\" } window 250,5\r\n267.5 \"The Scales Of Wisdom\" Ability { id: \"7DC6\", source: \"Sophia\" }\r\n272.9 \"--targetable--\"\r\n280.8 \"Quasar (Snapshot)\" Ability { id: [\"7D9B\", \"7DA1\"], source: \"Sophia\" }\r\n286.8 \"Quasar (Meteor Detonate)\" Ability { id: \"7E81\", source: \"Sophia\" }\r\n291.3 \"Aero III/Thunder II/Thunder III\" Ability { id: [\"7DA6\", \"7DA8\", \"7DAA\"], source: \"Sophia\" } window 41.3,5\r\n297.1 \"Quasar Tethers\" Ability { id: \"7D9B\", source: \"Sophia\" }\r\n305.7 \"Quasar (Tilt)\" Ability { id: \"7E46\", source: \"Sophia\" }\r\n310.7 \"Cintamani x2\" duration 3 # Ability { id: \"7DBF\", source: \"Sophia\" }\r\n318.8 \"Arms Of Wisdom\" Ability { id: \"7DBE\", source: \"Sophia\" }\r\n\r\n # Potential landing point if DPS is high. Push seems to be 70%?\r\n328.3 \"Thunder II\" Ability { id: \"7DAA\", source: \"Sophia\" } window 35.8,5\r\n334.0 \"Quasar Tethers\" Ability { id: \"7DA1\", source: \"Sophia\" }\r\n335.0 \"--untargetable--\"\r\n341.2 \"Onrush\" Ability { id: \"7DBB\", source: \"Sophia\" }\r\n341.8 \"Quasar (Tilt)\" # Ability { id: \"7E46\", source: \"Sophia\" }\r\n345.4 \"--targetable--\"\r\n361.5 \"Dischordant Cleansing\" # Ability { id: [\"7DAD\", \"7DAF\"], source: \"Sophia\" }\r\n361.5 \"Cintamani x2\" duration 3 # Ability { id: \"7DBF\", source: \"Sophia\" }\r\n370.8 \"Arms Of Wisdom\" Ability { id: \"7DBE\", source: \"Sophia\" } window 30,5\r\n379.0 \"--clones appear--\" AddedCombatant { name: \"Aion Teleos\" } window 60,20\r\n382.0 \"Cintamani x3\" duration 6 # Ability { id: \"7DBF\", source: \"Sophia\" }\r\n393.3 \"--sync--\" Ability { id: \"7DA5\", source: \"Aion Teleos\" }\r\n393.3 \"Thunder II/III\" Ability { id: [\"7DA6\", \"7DAA\"], source: \"Sophia\" }\r\n399.4 \"--sync--\" Ability { id: \"7DA5\", source: \"Aion Teleos\" }\r\n399.4 \"Aero III\" Ability { id: \"7DA8\", source: \"Sophia\" } window 30,5\r\n408.5 \"Arms Of Wisdom\" Ability { id: \"7DBE\", source: \"Sophia\" }\r\n419.8 \"Light Dew\" Ability { id: \"7DB9\", source: \"Barbelo\" }\r\n420.5 \"Execute\" Ability { id: \"7DA4\", source: \"Sophia\" } window 30,30\r\n\r\n# Rotation block.\r\n# Technically it can loop, but unless party DPS is VERY high,\r\n# enrage will occur long before the second loop completes.\r\n429.3 \"Cintamani x3\" duration 6 # Ability { id: \"7DBF\", source: \"Sophia\" } duration 5\r\n440.7 \"Arms Of Wisdom\" Ability { id: \"7DBE\", source: \"Sophia\" }\r\n446.5 \"Quasar Tethers\" Ability { id: \"7D9B\", source: \"Sophia\" }\r\n455.2 \"Quasar (Tilt)\" Ability { id: \"7E46\", source: \"Sophia\" }\r\n457.7 \"Light Dew\" Ability { id: \"7DB9\", source: \"Barbelo\" } window 30,30\r\n470.0 \"Thunder III\" Ability { id: \"7DA6\", source: \"Sophia\" }\r\n478.3 \"Arms Of Wisdom\" Ability { id: \"7DBE\", source: \"Sophia\" }\r\n484.5 \"Quasar Tethers\" Ability { id: \"7DA1\", source: \"Sophia\" }\r\n485.5 \"--untargetable--\"\r\n493.2 \"Quasar (Tilt)\" Ability { id: \"7E46\", source: \"Sophia\" }\r\n494.7 \"Onrush\" Ability { id: \"7DBB\", source: \"Sophia\" }\r\n495.7 \"Light Dew\" Ability { id: \"7DBA\", source: \"Barbelo\" } window 30,30\r\n499.0 \"--targetable--\"\r\n507.1 \"Cintamani x3\" duration 6 # Ability { id: \"7DBF\", source: \"Sophia\" }\r\n518.3 \"Arms Of Wisdom\" Ability { id: \"7DBE\", source: \"Sophia\" }\r\n525.4 \"Thunder II\" Ability { id: \"7DAA\", source: \"Sophia\" }\r\n535.9 \"Dischordant Cleansing\" # Ability { id: [\"7DAD\", \"7DAF\"], source: \"Sophia\" }\r\n539.7 \"Gnosis\" Ability { id: \"7DBC\", source: \"Barbelo\" } window 30,5\r\n552.2 \"Arms Of Wisdom\" Ability { id: \"7DBE\", source: \"Sophia\" }\r\n567.0 \"Quasar Tethers\" Ability { id: \"7D9B\", source: \"Sophia\" }\r\n568.3 \"Dischordant Cleansing\" # Ability { id: [\"7DAD\", \"7DAF\"], source: \"Sophia\" }\r\n575.7 \"Quasar (Tilt)\" # Ability { id: \"7E46\", source: \"Sophia\" }\r\n577.5 \"--clones appear--\" AddedCombatant { name: \"Aion Teleos\" } window 60,5\r\n581.5 \"Cintamani x3\" duration 6 # Ability { id: \"7DBF\", source: \"Sophia\" }\r\n592.8 \"Arms Of Wisdom\" Ability { id: \"7DBE\", source: \"Sophia\" }\r\n599.9 \"--sync--\" Ability { id: \"7DA5\", source: \"Aion Teleos\" } window 10,2.5\r\n599.9 \"Thunder II/III\" Ability { id: [\"7DA6\", \"7DAA\"], source: \"Sophia\" }\r\n606.1 \"--sync--\" Ability { id: \"7DA5\", source: \"Aion Teleos\" }\r\n606.1 \"Aero III\" Ability { id: \"7DA8\", source: \"Sophia\" }\r\n611.9 \"Quasar (Snapshot)\" Ability { id: [\"7D9B\", \"7DA1\"], source: \"Sophia\" }\r\n617.9 \"Quasar (Meteor Detonate)\" Ability { id: \"7E81\", source: \"Sophia\" }\r\n624.4 \"Arms Of Wisdom\" Ability { id: \"7DBE\", source: \"Sophia\" }\r\n636.6 \"Dischordant Cleansing\" # Ability { id: [\"7DAD\", \"7DAF\"], source: \"Sophia\" }\r\n639.0 \"Execute\" Ability { id: \"7DA4\", source: \"Sophia\" } window 30,30 jump 420.5\r\n\r\n650.9 \"Cintamani x3\"\r\n662.3 \"Arms Of Wisdom\"\r\n668.1 \"Quasar Tethers\"\r\n676.9 \"Quasar (Tilt)\"\r\n679.3 \"Light Dew\"\r\n691.6 \"Thunder III\"\r\n699.9 \"Arms Of Wisdom\"\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/thordan-un.ts
// This file was autogenerated from running npm run sync-files.
// DO NOT EDIT THIS FILE DIRECTLY.
// Edit the source file below and then run `npm run sync-files`
// Source: ui/raidboss/data/03-hw/trial/thordan-ex.ts






const thordan_un_unsafeMap = {
  dirN: 'dirS',
  dirNE: 'dirSW',
  dirE: 'dirW',
  dirSE: 'dirNW',
  dirS: 'dirN',
  dirSW: 'dirNE',
  dirW: 'dirE',
  dirNW: 'dirSE'
};
const thordan_un_fullDirNameMap = {
  dirN: outputs/* default.north */.Z.north,
  dirNE: outputs/* default.northeast */.Z.northeast,
  dirE: outputs/* default.east */.Z.east,
  dirSE: outputs/* default.southeast */.Z.southeast,
  dirS: outputs/* default.south */.Z.south,
  dirSW: outputs/* default.southwest */.Z.southwest,
  dirW: outputs/* default.west */.Z.west,
  dirNW: outputs/* default.northwest */.Z.northwest,
  unknown: outputs/* default.unknown */.Z.unknown
};
const thordan_un_triggerSet = {
  id: 'TheSingularityReactorUnreal',
  zoneId: zone_id/* default.TheSingularityReactorUnreal */.Z.TheSingularityReactorUnreal,
  timelineFile: 'thordan-un.txt',
  initData: () => {
    return {
      phase: 1,
      thrustPositions: [],
      seenThrust: false,
      defCounter: 1
    };
  },
  timelineTriggers: [
  // All timeline triggers include a base suppression of 5 seconds
  // to avoid potential noise from timeline jitter.
  {
    id: 'ThordanUN Ascalons Might',
    regex: /Ascalon's Might/,
    beforeSeconds: 4,
    suppressSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    // Puddle positions snapshot well before the actual Heavensflame explosion.
    // BeforeSeconds: 10 is correct, as it ends up being only 5-6 seconds
    // in practice.
    id: 'ThordanUN Heavensflame',
    regex: /Heavensflame 1/,
    beforeSeconds: 10,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.baitPuddles(),
    outputStrings: {
      baitPuddles: {
        en: 'Bait puddles',
        de: 'Flächen Ködern',
        fr: 'Attirez les flaques',
        ja: 'AOE誘導',
        cn: '诱导圈圈',
        ko: '장판 유도'
      }
    }
  }, {
    id: 'ThordanUN Heavenly Slash',
    regex: /Heavenly Slash/,
    beforeSeconds: 4,
    suppressSeconds: 5,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'ThordanUN Faith Unmoving',
    regex: /Faith Unmoving/,
    beforeSeconds: 6,
    condition: data => data.phase === 2,
    suppressSeconds: 5,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'ThordanUN Dimensional Collapse',
    regex: /Dimensional Collapse/,
    beforeSeconds: 10,
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.baitPuddles(),
    outputStrings: {
      baitPuddles: {
        en: 'Bait gravity puddles',
        de: 'Köder Gravitationsflächen',
        fr: 'Attirez les flaques de gravité',
        ja: '黒AOE誘導',
        cn: '诱导黑圈',
        ko: '검은색 장판 유도'
      }
    }
  }, {
    id: 'ThordanUN Light Of Ascalon',
    regex: /The Light of Ascalon 1/,
    beforeSeconds: 5,
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.knockbackAoe(),
    outputStrings: {
      knockbackAoe: {
        en: 'AOE + knockback x7',
        de: 'AoE + Rückstoß x7',
        fr: 'AoE + Poussée x7',
        ja: '全体攻撃 + ノックバック x7',
        cn: 'AOE + 击退 x7',
        ko: '전체공격 + 넉백x7'
      }
    }
  }, {
    id: 'ThordanUN Ultimate End',
    regex: /Ultimate End/,
    beforeSeconds: 6,
    suppressSeconds: 5,
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }],
  triggers: [
  // Phase tracking
  {
    // Cue off Thordan's movement ability alongside him going untargetable
    id: 'ThordanUN Intermission Phase',
    type: 'Ability',
    netRegex: {
      id: '89BA',
      source: 'King Thordan',
      capture: false
    },
    run: data => data.phase = 2
  }, {
    // Cue off Knights of the Round
    id: 'ThordanUN Post-Intermission Phase Tracker',
    type: 'Ability',
    netRegex: {
      id: '89CB',
      source: 'King Thordan',
      capture: false
    },
    run: data => data.phase += 1
  }, {
    id: 'ThordanUN Main Tank Tracker',
    type: 'Ability',
    netRegex: {
      id: '89BC',
      source: 'King Thordan'
    },
    condition: (data, matches) => data.mainTank !== matches.target,
    run: (data, matches) => data.mainTank = matches.target
  }, {
    id: 'ThordanUN Lightning Storm',
    type: 'HeadMarker',
    netRegex: {
      id: '0018'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'ThordanUN Dragons Rage',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'ThordanUN Ancient Quaga',
    type: 'StartsUsing',
    netRegex: {
      id: '89C4',
      source: 'King Thordan',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'ThordanUN Heavenly Heel',
    type: 'StartsUsing',
    netRegex: {
      id: '89C6',
      source: 'King Thordan'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'ThordanUN Holy Chains',
    type: 'Tether',
    netRegex: {
      id: '0009'
    },
    condition: (data, matches) => data.me === matches.source || data.me === matches.target,
    alertText: (data, matches, output) => {
      const partner = data.me === matches.source ? matches.target : matches.source;
      return output.breakChains({
        partner: data.party.member(partner)
      });
    },
    outputStrings: {
      breakChains: {
        en: 'Break chains with ${partner}',
        de: 'Ketten mit ${partner} zerbrechen',
        fr: 'Cassez les chaînes avec ${partner}',
        ja: '線切り: ${partner}',
        cn: '与 ${partner} 拉断连锁',
        ko: '${partner} 사슬 끊기'
      }
    }
  }, {
    id: 'ThordanUN Conviction',
    type: 'StartsUsing',
    netRegex: {
      id: '89DC',
      source: 'Ser Hermenost',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.getTowers */.n3.getTowers()
  }, {
    id: 'ThordanUN Dragons Gaze',
    type: 'StartsUsing',
    netRegex: {
      id: '89C8',
      source: 'King Thordan',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data.phase === 1) return output.singleGaze();
      return output.doubleGaze();
    },
    outputStrings: {
      singleGaze: {
        en: 'Look away from Thordan',
        de: 'Schau weg von Thordan',
        fr: 'Ne regardez pas Thordan',
        ja: 'ボスを見ないで',
        cn: '背对托尔丹',
        ko: '토르당에게서 뒤돌기'
      },
      doubleGaze: {
        en: 'Look away from Thordan and Eye',
        de: 'Schau weg von Thordan und dem Auge',
        fr: 'Ne regardez pas Thordan ni l\'œil',
        ja: 'ボスと目を見ないで',
        cn: '背对托尔丹和眼睛',
        ko: '토르당과 눈에 대해 뒤돌기'
      }
    }
  }, {
    id: 'ThordanUN Triple Spiral Thrust Collect',
    type: 'Ability',
    netRegex: {
      id: '89B7',
      source: ['Ser Ignasse', 'Ser Paulecrain', 'Ser Vellguine']
    },
    // Shared ability from all knights when they teleport in.
    condition: data => data.phase === 2 && !data.seenThrust,
    run: (data, matches) => data.thrustPositions.push(matches)
  }, {
    id: 'ThordanUN Triple Spiral Thrust Call',
    type: 'Ability',
    netRegex: {
      id: '89B7',
      source: ['Ser Ignasse', 'Ser Paulecrain', 'Ser Vellguine'],
      capture: false
    },
    // Shared ability from all knights when they teleport in.
    condition: data => data.phase === 2 && !data.seenThrust,
    delaySeconds: 0.5,
    infoText: (data, _matches, output) => {
      if (data.thrustPositions.length !== 3) return;
      let safeDirs = Object.keys(thordan_un_unsafeMap);
      data.thrustPositions.forEach(knight => {
        const knightNum = util/* Directions.hdgTo8DirNum */.N.hdgTo8DirNum(parseFloat(knight.heading));
        const knightDir = util/* Directions.outputFrom8DirNum */.N.outputFrom8DirNum(knightNum);
        const pairedDir = thordan_un_unsafeMap[knightDir];
        safeDirs = safeDirs.filter(dir => dir !== knightDir && dir !== pairedDir);
      });
      if (safeDirs.length !== 2) return;
      const [dir1, dir2] = safeDirs.sort();
      if (dir1 === undefined || dir2 === undefined) return;
      return output.combined({
        dir1: output[dir1](),
        dir2: output[dir2]()
      });
    },
    run: data => {
      data.thrustPositions = [];
      data.seenThrust = true;
    },
    outputStrings: {
      combined: {
        en: '${dir1} / ${dir2} Safe',
        de: '${dir1} / ${dir2} Sicher',
        fr: '${dir1} / ${dir2} Sûr',
        ja: '${dir1} / ${dir2} 安置',
        cn: '${dir1} / ${dir2} 安全',
        ko: '${dir1} / ${dir2} 안전'
      },
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  }, {
    id: 'ThordanUN Sword Of The Heavens',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3B0'
    },
    infoText: (_data, matches, output) => output.attackSword({
      swordKnight: matches.target
    }),
    run: (data, matches) => data.swordKnight = matches.target,
    outputStrings: {
      attackSword: {
        en: 'Attack ${swordKnight}',
        de: 'Greife ${swordKnight} an',
        fr: 'Attaquez ${swordKnight}',
        ja: '攻撃: ${swordKnight}',
        cn: '攻击 ${swordKnight}',
        ko: '${swordKnight} 공격'
      }
    }
  }, {
    id: 'ThordanUN Shield Of The Heavens',
    type: 'GainsEffect',
    netRegex: {
      effectId: '3B1'
    },
    run: (data, matches) => data.shieldKnight = matches.target
  }, {
    id: 'ThordanUN Holiest Of Holy',
    type: 'StartsUsing',
    netRegex: {
      id: '89D4',
      source: ['Ser Adelphel', 'Ser Janlenoux'],
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'ThordanUN Holy Bladedance Collect',
    type: 'StartsUsing',
    netRegex: {
      id: '89D5',
      source: ['Ser Adelphel', 'Ser Janlenoux']
    },
    run: (data, matches) => {
      if (data.swordKnight === matches.source) data.swordTarget = matches.target;
      if (data.shieldKnight === matches.source) data.shieldTarget = matches.target;
    }
  }, {
    id: 'ThordanUN Holy Bladedance Call',
    type: 'StartsUsing',
    netRegex: {
      id: '89D5',
      source: ['Ser Adelphel', 'Ser Janlenoux'],
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      if (data.swordTarget === undefined || data.shieldTarget === undefined) return output.unknownDance();
      const swordTarget = data.party.member(data.swordTarget);
      const shieldTarget = data.party.member(data.shieldTarget);
      if (data.swordTarget === data.shieldTarget) return output.singleDance({
        target: swordTarget
      });
      return output.doubleDance({
        sword: swordTarget,
        shield: shieldTarget
      });
    },
    run: data => {
      delete data.shieldKnight;
      delete data.swordKnight;
      delete data.shieldTarget;
      delete data.swordTarget;
    },
    outputStrings: {
      unknownDance: {
        en: 'Heavy busters',
        de: 'Harter Tankbuster',
        fr: 'Gros busters',
        ja: 'タン強',
        cn: '高伤死刑',
        ko: '탱버'
      },
      singleDance: {
        en: '2x buster on ${target}',
        de: '2x Tankbuster auf ${target}',
        fr: 'Buster x2 sur ${target}',
        ja: '${target} タン強 x2',
        cn: '双死刑点 ${target}',
        ko: '${target} 탱버 x2'
      },
      doubleDance: {
        en: 'Sword buster on ${sword} (shield on ${shield})',
        de: 'Schwert-Tankbuster auf ${sword} (Schild auf ${shield})',
        fr: 'Buster épée sur ${sword} (bouclier sur ${shield})',
        ja: '剣のタン強: ${sword} (盾: ${shield})',
        cn: '剑死刑点 ${sword} (盾死刑点 ${shield})',
        ko: '칼 탱버 ${sword} (방패 ${shield})'
      }
    }
  }, {
    id: 'ThordanUN Skyward Leap',
    type: 'HeadMarker',
    netRegex: {
      id: '000E'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (data, _matches, output) => {
      if (data.phase !== 2) return output.defamationNoNumber();
      return output.defamationCounted({
        number: data.defCounter
      });
    },
    run: data => data.defCounter += 1,
    outputStrings: {
      defamationNoNumber: {
        en: 'Defamation on YOU',
        de: 'Große AoE auf YOU',
        fr: 'Diffamation sur VOUS',
        ja: '自分に青サークル',
        cn: '穿天点名',
        ko: '광역 대상자'
      },
      defamationCounted: {
        en: 'Defamation #${number} on YOU',
        de: 'Große AoE #${number} auf DIR',
        fr: 'Diffamation #${number} sur VOUS',
        ja: '自分に青サークル#${number}',
        cn: '穿天 #${number} 点名',
        ko: '광역 #${number} 대상자'
      }
    }
  }, {
    id: 'ThordanUN Spiral Pierce',
    type: 'Tether',
    netRegex: {
      id: '0005'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.pierceYou(),
    outputStrings: {
      pierceYou: {
        en: 'Line AoE on YOU',
        de: 'Linien-AoE auf DIR',
        fr: 'AoE en ligne sur VOUS',
        ja: '自分に直線AOE',
        cn: '直线AOE点名',
        ko: '직선 쉐어 대상자'
      }
    }
  }, {
    id: 'ThordanUN Hiemal Storm',
    type: 'HeadMarker',
    netRegex: {
      id: '001D'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.icePuddleYou(),
    outputStrings: {
      icePuddleYou: {
        en: 'Ice puddle on YOU',
        de: 'Eisfläche auf DIR',
        fr: 'Flaque de glace sur VOUS',
        ja: '自分にAOE',
        cn: '冰圈点名',
        ko: '얼음 장판 대상자'
      }
    }
  }, {
    id: 'ThordanUN Comet Puddles',
    type: 'HeadMarker',
    netRegex: {
      id: '000B'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.meteorYou(),
    outputStrings: {
      meteorYou: {
        en: '4x meteor puddles on YOU',
        de: '4x Meteorflächen auf DIR',
        fr: '4x Météor sur VOUS',
        ja: '自分に4xメテオ',
        cn: '4连陨石点名',
        ko: '4연속 운석 장판 대상자'
      }
    }
  }, {
    id: 'ThordanUN Fury Spear',
    type: 'HeadMarker',
    netRegex: {
      id: '0010'
    },
    alarmText: (data, matches, output) => {
      // Whoever is actively tanking Thordan must not stack,
      // because they will be taking Heavenly Heel shortly after.
      // If they stack, they will receive the physical vulnerability up and auto-die.
      if (data.me !== data.mainTank) return;
      if (data.me === matches.target) return output.spearYou();
      return output.spearMainTank();
    },
    alertText: (data, matches, output) => {
      if (data.me === data.mainTank) return;
      if (data.me === matches.target) return output.spearYou();
      return output.spearOther({
        spearTarget: matches.target
      });
    },
    outputStrings: {
      spearYou: {
        en: 'Wild Charge on YOU',
        de: 'Ansturm auf DIR',
        fr: 'Charge sauvage sur VOUS',
        ja: '自分に突進',
        cn: '奶枪点名',
        ko: '돌진 대상자'
      },
      spearMainTank: {
        en: 'Wild Charge: STAY OUT',
        de: 'Ansturm: BLEIB DRAUSEN',
        fr: 'Charge sauvage : RESTEZ À L\'EXTÉRIEUR',
        ja: '突進: そのままヘイト取り',
        cn: '奶枪: 保持远离',
        ko: '돌진: 밖으로'
      },
      spearOther: {
        en: 'Wild Charge: Intercept ${spearTarget}',
        de: 'Ansturm: Zwichen ${spearTarget} stehen',
        fr: 'Charge sauvage : Interceptez ${spearTarget}',
        ja: '突進: ${spearTarget}のカバー',
        cn: '奶枪: 挡住 ${spearTarget}',
        ko: '돌진: ${spearTarget} 앞으로'
      }
    }
  }, {
    id: 'ThordanUN Pure Of Soul',
    type: 'StartsUsing',
    netRegex: {
      id: '89F0',
      source: 'Ser Charibert',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'ThordanUN Single Spiral Thrust',
    type: 'Ability',
    netRegex: {
      id: '89B7',
      source: 'Ser Vellguine'
    },
    // Shared ability from all knights when they teleport in.
    condition: data => data.phase === 5,
    infoText: (_data, matches, output) => {
      const knightNum = util/* Directions.hdgTo8DirNum */.N.hdgTo8DirNum(parseFloat(matches.heading));
      const knightDir = util/* Directions.outputFrom8DirNum */.N.outputFrom8DirNum(knightNum);
      const [dir1, dir2] = [knightDir, thordan_un_unsafeMap[knightDir]].sort();
      if (dir1 === undefined || dir2 === undefined) return;
      return output.combined({
        dir1: output[dir1](),
        dir2: output[dir2]()
      });
    },
    outputStrings: {
      combined: {
        en: '${dir1} / ${dir2} Unsafe',
        de: '${dir1} / ${dir2} Nicht Sicher',
        fr: '${dir1} / ${dir2} non-sûr',
        ja: '${dir1} / ${dir2} 危険場',
        cn: '${dir1} / ${dir2} 危险',
        ko: '${dir1} / ${dir2} 위험'
      },
      ...util/* Directions.outputStrings8Dir */.N.outputStrings8Dir
    }
  }, {
    id: 'ThordanUN Faith Unmoving Off Center',
    type: 'Ability',
    netRegex: {
      id: '89B7',
      source: 'Ser Grinnaux'
    },
    // Shared ability from all knights when they teleport in.
    condition: data => data.phase === 4,
    delaySeconds: 7,
    // Grinnaux insta-casts Faith Unmoving 13s after appearing. Give ~6s of warning.
    alertText: (_data, matches, output) => {
      const knightX = parseFloat(matches.x);
      const knightY = parseFloat(matches.y);
      const knightDir = util/* Directions.xyTo8DirOutput */.N.xyTo8DirOutput(knightX, knightY, 0, 0);
      return output.knockbackWarn({
        knightDir: output[knightDir]()
      });
    },
    outputStrings: {
      knockbackWarn: {
        en: 'Knockback from ${knightDir}',
        de: 'Rückstoß von ${knightDir}',
        fr: 'Poussée depuis ${knightDir}',
        ja: '${knightDir} ノックバック',
        cn: '${knightDir} 击退',
        ko: '${knightDir} 넉백'
      },
      ...thordan_un_fullDirNameMap
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'The Dragon\'s Gaze/The Dragon\'s Glory': 'The Dragon\'s Gaze/Glory'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Comet Circle': 'Meteoritensiegel',
      'King Thordan': 'Thordan',
      'Meteor Circle': 'Meteorsiegel',
      'Ser Adelphel': 'Adelphel',
      'Ser Charibert': 'Charibert',
      'Ser Grinnaux': 'Grinnaux',
      'Ser Guerrique': 'Guerrique',
      'Ser Haumeric': 'Haumeric',
      'Ser Hermenost': 'Hermenost',
      'Ser Ignasse': 'Ignasse',
      'Ser Janlenoux': 'Janlenoux',
      'Ser Noudenet': 'Noudenet',
      'Ser Paulecrain': 'Paulecrain',
      'Ser Vellguine': 'Vellguine',
      'Ser Zephirin': 'Zephirin'
    },
    'replaceText': {
      '--chains appear--': '--Ketten erscheinen--',
      '--towers spawn--': '--Türme erscheinen--',
      'Absolute Conviction': 'Absolute Konviktion',
      'Ancient Quaga': 'Seisga Antiqua',
      'Ascalon\'s Mercy': 'Gnade von Askalon',
      'Ascalon\'s Might': 'Macht von Askalon',
      'Comet(?! Impact)': 'Komet',
      'Comet Impact': 'Kometeneinschlag',
      '(?<!Absolute )Conviction': 'Konviktion',
      'Dimensional Collapse': 'Dimensionskollaps',
      'Divine Right': 'Göttliches Recht',
      'Faith Unmoving': 'Fester Glaube',
      'Heavenly Heel': 'Himmelsschritt',
      'Heavenly Slash': 'Himmelsschlag',
      'Heavensflame': 'Himmlische Flamme',
      'Heavensward Leap': 'Sprung himmelwärts',
      'Heavy Impact': 'Heftiger Einschlag',
      'Hiemal Storm': 'Hiemaler Sturm',
      'Holiest Of Holy': 'Quell der Heiligkeit',
      'Holy Bladedance': 'Geweihter Schwerttanz',
      'Holy Meteor': 'Heiliger Meteor',
      'Holy Shield Bash': 'Heiliger Schildschlag',
      'Knights Of the Round': 'Ritter der Runde',
      'Lightning Storm': 'Blitzsturm',
      'Meteor Impact': 'Meteoreinschlag',
      'Meteorain': 'Meteorregen',
      'Pure Of Soul': 'Reine Seele',
      'Sacred Cross': 'Heiliges Kreuz',
      'Skyward Leap': 'Luftsprung',
      'Spear Of the Fury': 'Speer der Furie',
      'Spiral Pierce': 'Spiralstich',
      'Spiral Thrust': 'Spiralstoß',
      'The Dragon\'s Gaze': 'Blick des Drachen',
      'The Dragon\'s Glory': 'Ruhm des Drachen',
      'The Light Of Ascalon': 'Licht von Askalon',
      'Ultimate End': 'Ultimatives Ende',
      'the Dragon\'s Eye': 'Auge des Drachen',
      'the Dragon\'s Gaze': 'Blick des Drachen',
      'the Dragon\'s Rage': 'Zorn des Drachen'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Comet Circle': 'sceau de la comète',
      'King Thordan': 'roi Thordan',
      'Meteor Circle': 'sceau du météore',
      'Ser Adelphel': 'sire Adelphel',
      'Ser Charibert': 'sire Charibert',
      'Ser Grinnaux': 'sire Grinnaux',
      'Ser Guerrique': 'sire Guerrique',
      'Ser Haumeric': 'sire Haumeric',
      'Ser Hermenost': 'sire Hermenoist',
      'Ser Ignasse': 'sire Ignassel',
      'Ser Janlenoux': 'sire Janlenoux',
      'Ser Noudenet': 'sire Noudenet',
      'Ser Paulecrain': 'sire Paulecrain',
      'Ser Vellguine': 'sire Vellguine',
      'Ser Zephirin': 'sire Zéphirin'
    },
    'replaceText': {
      '--chains appear--': '--Apparition des chaines--',
      '--towers spawn--': '--Apparition des tours--',
      'Absolute Conviction': 'Conviction absolue',
      'Ancient Quaga': 'Méga Séisme ancien',
      'Ascalon\'s Mercy': 'Grâce d\'Ascalon',
      'Ascalon\'s Might': 'Puissance d\'Ascalon',
      'Comet(?! Impact)': 'Comète',
      'Comet Impact': 'Impact de comète',
      '(?<!Absolute )Conviction': 'Conviction',
      'Dimensional Collapse': 'Effondrement dimensionnel',
      'Divine Right': 'Droit divin',
      'Faith Unmoving': 'Foi immuable',
      'Heavenly Heel': 'Estoc céleste',
      'Heavenly Slash': 'Lacération céleste',
      'Heavensflame': 'Flamme céleste',
      'Heavensward Leap': 'Bond divin',
      'Heavy Impact': 'Impact violent',
      'Hiemal Storm': 'Tempête hiémale',
      'Holiest Of Holy': 'Saint des saints',
      'Holy Bladedance': 'Danse de la lame céleste',
      'Holy Meteor': 'Météore sacré',
      'Holy Shield Bash': 'Coup de bouclier saint',
      'Knights Of the Round': 'Chevaliers de la Table ronde',
      'Lightning Storm': 'Pluie d\'éclairs',
      'Meteor Impact': 'Impact de météore',
      'Meteorain': 'Pluie de météorites',
      'Pure Of Soul': 'Pureté d\'âme',
      'Sacred Cross': 'Croix sacrée',
      'Skyward Leap': 'Bond céleste',
      'Spear Of the Fury': 'Lance de la Conquérante',
      'Spiral Pierce': 'Empalement tournoyant',
      'Spiral Thrust': 'Transpercement tournoyant',
      'The Dragon\'s Gaze': 'Regard du dragon',
      'The Dragon\'s Glory': 'Gloire du dragon',
      'The Light Of Ascalon': 'Lumière d\'Ascalon',
      'Ultimate End': 'Fin ultime',
      'the Dragon\'s Eye': 'Œil du dragon',
      'the Dragon\'s Gaze': 'Regard du dragon',
      'the Dragon\'s Rage': 'Colère du dragon'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Comet Circle': '星片の聖紋',
      'King Thordan': '騎神トールダン',
      'Meteor Circle': '流星の聖紋',
      'Ser Adelphel': '聖騎士アデルフェル',
      'Ser Charibert': '聖騎士シャリベル',
      'Ser Grinnaux': '聖騎士グリノー',
      'Ser Guerrique': '聖騎士ゲリック',
      'Ser Haumeric': '聖騎士オムリク',
      'Ser Hermenost': '聖騎士エルムノスト',
      'Ser Ignasse': '聖騎士イニアセル',
      'Ser Janlenoux': '聖騎士ジャンルヌ',
      'Ser Noudenet': '聖騎士ヌドゥネー',
      'Ser Paulecrain': '聖騎士ポールクラン',
      'Ser Vellguine': '聖騎士ヴェルギーン',
      'Ser Zephirin': '聖騎士ゼフィラン'
    },
    'replaceText': {
      '--chains appear--': '--線連結--',
      '--towers spawn--': '--塔--',
      'Absolute Conviction': 'アブソルートコンヴィクション',
      'Ancient Quaga': 'エンシェントクエイガ',
      'Ascalon\'s Mercy': 'アスカロンメルシー',
      'Ascalon\'s Might': 'アスカロンマイト',
      'Comet(?! Impact)': 'コメット',
      'Comet Impact': 'コメットインパクト',
      '(?<!Absolute )Conviction': 'コンヴィクション',
      'Dimensional Collapse': 'ディメンションクラッシュ',
      'Divine Right': '蒼天の構え',
      'Faith Unmoving': 'フェイスアンムーブ',
      'Heavenly Heel': 'ヘヴンリーヒール',
      'Heavenly Slash': 'ヘヴンリースラッシュ',
      'Heavensflame': 'ヘヴンフレイム',
      'Heavensward Leap': 'ヘヴンスリープ',
      'Heavy Impact': 'ヘヴィインパクト',
      'Hiemal Storm': 'ハイマルストーム',
      'Holiest Of Holy': 'ホリエストホーリー',
      'Holy Bladedance': 'ホーリーブレードダンス',
      'Holy Meteor': 'ホーリーメテオ',
      'Holy Shield Bash': 'ホーリーシールドバッシュ',
      'Knights Of the Round': 'ナイツ・オブ・ラウンド',
      'Lightning Storm': '百雷',
      'Meteor Impact': 'メテオインパクト',
      'Meteorain': 'メテオレイン',
      'Pure Of Soul': 'ピュア・オブ・ソウル',
      'Sacred Cross': 'セイクリッドクロス',
      'Skyward Leap': 'スカイワードリープ',
      'Spear Of the Fury': 'スピア・オブ・ハルオーネ',
      'Spiral Pierce': 'スパイラルピアス',
      'Spiral Thrust': 'スパイラルスラスト',
      'The Dragon\'s Gaze': '竜の邪眼',
      'The Dragon\'s Glory': '邪竜の眼光',
      'The Light Of Ascalon': 'ライト・オブ・アスカロン',
      'Ultimate End': 'アルティメットエンド',
      'the Dragon\'s Eye': '竜の眼',
      'the Dragon\'s Gaze': '竜の邪眼',
      'the Dragon\'s Rage': '邪竜の魔炎'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Comet Circle': '星屑圣纹',
      'King Thordan': '骑神托尔丹',
      'Meteor Circle': '流星圣纹',
      'Ser Adelphel': '圣骑士阿代尔斐尔',
      'Ser Charibert': '圣骑士沙里贝尔',
      'Ser Grinnaux': '圣骑士格里诺',
      'Ser Guerrique': '圣骑士盖里克',
      'Ser Haumeric': '圣骑士奥默里克',
      'Ser Hermenost': '圣骑士埃尔姆诺斯特',
      'Ser Ignasse': '圣骑士伊尼亚斯',
      'Ser Janlenoux': '圣骑士让勒努',
      'Ser Noudenet': '圣骑士努德内',
      'Ser Paulecrain': '圣骑士波勒克兰',
      'Ser Vellguine': '圣骑士韦尔吉纳',
      'Ser Zephirin': '圣骑士泽菲兰'
    },
    'replaceText': {
      '--chains appear--': '--锁链出现--',
      '--towers spawn--': '--塔生成--',
      'Absolute Conviction': '绝对信仰',
      'Ancient Quaga': '古代爆震',
      'Ascalon\'s Mercy': '阿斯卡隆之仁',
      'Ascalon\'s Might': '阿斯卡隆之威',
      'Comet(?! Impact)': '彗星',
      'Comet Impact': '星屑冲击',
      '(?<!Absolute )Conviction': '信仰',
      'Dimensional Collapse': '空间破碎',
      'Divine Right': '苍穹体势',
      'Faith Unmoving': '坚定信仰',
      'Heavenly Heel': '天踵',
      'Heavenly Slash': '天斩',
      'Heavensflame': '天火',
      'Heavensward Leap': '穿越苍穹',
      'Heavy Impact': '沉重冲击',
      'Hiemal Storm': '严冬风暴',
      'Holiest Of Holy': '至圣',
      'Holy Bladedance': '圣光剑舞',
      'Holy Meteor': '陨石圣星',
      'Holy Shield Bash': '圣盾猛击',
      'Knights Of the Round': '圆桌骑士',
      'Lightning Storm': '百雷',
      'Meteor Impact': '陨石冲击',
      'Meteorain': '流星雨',
      'Pure Of Soul': '纯粹灵魂',
      'Sacred Cross': '神圣十字',
      'Skyward Leap': '穿天',
      'Spear Of the Fury': '战女神之枪',
      'Spiral Pierce': '螺旋枪',
      'Spiral Thrust': '螺旋刺',
      'The Dragon\'s Gaze': '龙眼之邪',
      'The Dragon\'s Glory': '邪龙目光',
      'The Light Of Ascalon': '阿斯卡隆之光',
      'Ultimate End': '万物终结',
      'the Dragon\'s Eye': '龙眼之光',
      'the Dragon\'s Gaze': '龙眼之邪',
      'the Dragon\'s Rage': '邪龙魔炎'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Comet Circle': '성스러운 별조각 문양',
      'King Thordan': '기사신 토르당',
      'Meteor Circle': '성스러운 별똥별 문양',
      'Ser Adelphel': '성기사 아델펠',
      'Ser Charibert': '성기사 샤리베르',
      'Ser Grinnaux': '성기사 그리노',
      'Ser Guerrique': '성기사 게리크',
      'Ser Haumeric': '성기사 오메리크',
      'Ser Hermenost': '성기사 에르메노',
      'Ser Ignasse': '성기사 이냐스',
      'Ser Janlenoux': '성기사 장르누',
      'Ser Noudenet': '성기사 누데네',
      'Ser Paulecrain': '성기사 폴르크랭',
      'Ser Vellguine': '성기사 벨긴',
      'Ser Zephirin': '성기사 제피랭'
    },
    'replaceText': {
      '--chains appear--': '--사슬 연결--',
      '--towers spawn--': '--기둥 등장--',
      'Absolute Conviction': '절대적 신념',
      'Ancient Quaga': '에인션트 퀘이가',
      'Ascalon\'s Mercy': '아스칼론의 자비',
      'Ascalon\'s Might': '아스칼론의 권능',
      'Comet(?! Impact)': '혜성',
      'Comet Impact': '혜성 낙하',
      '(?<!Absolute )Conviction': '신념',
      'Dimensional Collapse': '차원 파괴',
      'Divine Right': '창천 태세',
      'Faith Unmoving': '굳건한 신앙',
      'Heavenly Heel': '천상의 발꿈치',
      'Heavenly Slash': '천상의 참격',
      'Heavensflame': '천상의 불꽃',
      'Heavensward Leap': '천상의 도약',
      'Heavy Impact': '무거운 충격',
      'Hiemal Storm': '동장군 폭풍',
      'Holiest Of Holy': '지고한 신성',
      'Holy Bladedance': '신성한 검무',
      'Holy Meteor': '홀리 메테오',
      'Holy Shield Bash': '성스러운 방패 강타',
      'Knights Of the Round': '나이츠 오브 라운드',
      'Lightning Storm': '백뢰',
      'Meteor Impact': '운석 낙하',
      'Meteorain': '메테오 레인',
      'Pure Of Soul': '영혼의 순수',
      'Sacred Cross': '거룩한 십자가',
      'Skyward Leap': '공중 도약',
      'Spear Of the Fury': '할로네의 창',
      'Spiral Pierce': '나선 관통',
      'Spiral Thrust': '나선 찌르기',
      'The Dragon\'s Gaze': '용의 마안',
      'The Dragon\'s Glory': '사룡의 눈빛',
      'The Light Of Ascalon': '아스칼론의 광휘',
      'Ultimate End': '궁극의 종말',
      'the Dragon\'s Eye': '용의 눈',
      'the Dragon\'s Gaze': '용의 마안',
      'the Dragon\'s Rage': '사룡의 마염'
    }
  }]
};
/* harmony default export */ const thordan_un = (thordan_un_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/thordan-un.txt
const trial_thordan_un_namespaceObject = "# This file was autogenerated from running npm run sync-files.\r\n# DO NOT EDIT THIS FILE DIRECTLY.\r\n# Edit the source file below and then run `npm run sync-files`\r\n# Source: ui/raidboss/data/03-hw/trial/thordan-ex.txt\r\n\r\n### THE SINGULARITY REACTOR (UNREAL)\r\n# ZoneId: 1\r\n\r\n# -ii 89B8 89BF 89DE\r\n# -it \"King Thordan\" \"Ser Janlenoux\"\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Phase 1. Pushes at 70% HP?\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n5.0 \"Ascalon's Might\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n14.8 \"Meteorain\" Ability { id: \"89C2\", source: \"King Thordan\" }\r\n15.1 \"--sync--\" Ability { id: \"89C3\", source: \"King Thordan\" } # Meteorain\r\n20.0 \"--sync--\" Ability { id: \"89BE\", source: \"King Thordan\" }\r\n20.0 \"Ascalon's Mercy\" Ability { id: \"89BF\", source: \"King Thordan\" }\r\n22.1 \"Ascalon's Might\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n27.2 \"the Dragon's Eye\" Ability { id: \"89C7\", source: \"King Thordan\" }\r\n37.3 \"the Dragon's Gaze\" Ability { id: \"89C8\", source: \"King Thordan\" }\r\n42.4 \"Ascalon's Might\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n51.1 \"Lightning Storm\" Ability { id: \"89C0\", source: \"King Thordan\" }\r\n51.5 \"--sync--\" Ability { id: \"89C1\", source: \"King Thordan\" } # Lightning Storm\r\n58.2 \"the Dragon's Rage\" Ability { id: \"89CA\", source: \"King Thordan\" }\r\n63.3 \"Ancient Quaga\" Ability { id: \"89C4\", source: \"King Thordan\" }\r\n69.4 \"Ascalon's Might\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n75.4 \"Heavenly Heel\" Ability { id: \"89C6\", source: \"King Thordan\" }\r\n77.5 \"Ascalon's Might\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n79.6 \"--untargetable--\"\r\n\r\n# Phase 2\r\n# Intermission part 1\r\n82.4 \"--sync--\" Ability { id: \"89BA\", source: \"King Thordan\" } window 82.4,10\r\n91.4 \"--sync--\" Ability { id: \"89B7\", source: \"Ser Charibert\" }\r\n93.4 \"--sync--\" Ability { id: \"89B7\", source: \"Ser Hermenost\" }\r\n95.7 \"--chains appear--\"\r\n98.0 \"--sync--\" Ability { id: \"89EA\", source: \"Ser Charibert\" } window 10,10 # Heavensflame cast\r\n98.4 \"Heavensflame 1\" #Ability { id: \"89EB\", source: \"Ser Charibert\" }\r\n99.4 \"Heavensflame 2\" #Ability { id: \"89EB\", source: \"Ser Charibert\" }\r\n99.4 \"--towers spawn--\"\r\n100.4 \"Heavensflame 3\" #Ability { id: \"89EB\", source: \"Ser Charibert\" }\r\n101.4 \"Heavensflame 4\" #Ability { id: \"89EB\", source: \"Ser Charibert\" }\r\n101.5 \"--sync--\" Ability { id: \"89DB\", source: \"Ser Hermenost\" } # Conviction (model animation, no actual snapshot)\r\n104.3 \"Conviction\" Ability { id: \"89DC\", source: \"Ser Hermenost\" }\r\n107.4 \"Sacred Cross\" StartsUsing { id: \"89CF\", source: \"Ser Zephirin\" } duration 19.7\r\n127.1 \"--sync--\" Ability { id: \"89CF\", source: \"Ser Zephirin\" }\r\n133.1 \"Spiral Thrust\" Ability { id: \"89E5\", source: [\"Ser Ignasse\", \"Ser Paulecrain\", \"Ser Vellguine\"] }\r\n\r\n# Intermission part 2\r\n# This loops until both Adelphel and Janlenoux are dead.\r\n# 3x Skyward Leaps happen during this loop,\r\n# but the other knights hold their mechanics until after both are dead.\r\n\r\n# Adelphel and Janlenoux's shared mechanics can be offset by 0.1 seconds,\r\n# but it's more important that we sync during the loop,\r\n# so we accept a small amount of jumpiness in the timeline.\r\n140.2 \"--targetable--\"\r\n150.2 \"Divine Right\" Ability { id: \"89D2\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n159.3 \"Holy Bladedance\" Ability { id: \"89D5\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n175.3 \"Skyward Leap 1\" Ability { id: \"89E8\", source: \"Ser Vellguine\" }\r\n177.3 \"Divine Right\" Ability { id: \"89D2\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n178.3 \"Skyward Leap 2\" Ability { id: \"89E8\", source: \"Ser Paulecrain\" }\r\n179.4 \"Heavenly Slash\" Ability { id: \"89D3\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n181.3 \"Skyward Leap 3\" Ability { id: \"89E8\", source: \"Ser Ignasse\" }\r\n192.4 \"Holiest Of Holy\" Ability { id: \"89D4\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n198.5 \"Holy Bladedance\" Ability { id: \"89D5\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n205.6 \"Divine Right\" Ability { id: \"89D2\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n212.7 \"Holiest Of Holy\" Ability { id: \"89D4\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n216.8 \"Heavenly Slash\" Ability { id: \"89D3\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n\r\n232.9 \"Divine Right\" Ability { id: \"89D2\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n242.0 \"Holy Bladedance\" Ability { id: \"89D5\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n260.0 \"Divine Right\" Ability { id: \"89D2\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n262.1 \"Heavenly Slash\" Ability { id: \"89D3\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n275.2 \"Holiest Of Holy\" Ability { id: \"89D4\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n281.3 \"Holy Bladedance\" Ability { id: \"89D5\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n288.3 \"Divine Right\" Ability { id: \"89D2\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n295.4 \"Holiest Of Holy\" Ability { id: \"89D4\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n299.5 \"Heavenly Slash\" Ability { id: \"89D3\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] } forcejump 216.8\r\n\r\n\r\n# Intermission part 3\r\n350.0 \"--sync--\" Ability { id: \"89B7\", source: \"Ser Paulecrain\" } window 150,10\r\n352.0 \"--sync--\" Ability { id: \"89B7\", source: \"Ser Grinnaux\" } window 150,10\r\n353.0 \"--sync--\" Ability { id: \"89B7\", source: \"Ser Haumeric\" } window 150,10\r\n359.6 \"Hiemal Storm\" Ability { id: \"89ED\", source: \"Ser Haumeric\" } window 328,10\r\n359.8 \"--sync--\" Ability { id: \"89EE\", source: [\"Ser Haumeric\", \"Ser Noudenet\"] } # Hiemal Storm\r\n360.2 \"Spiral Pierce\" Ability { id: \"89E6\", source: [\"Ser Ignasse\", \"Ser Paulecrain\", \"Ser Vellguine\"] }\r\n361.5 \"Dimensional Collapse\" Ability { id: \"89D8\", source: \"Ser Grinnaux\" }\r\n361.9 \"--sync--\" Ability { id: \"89D9\", source: \"Ser Grinnaux\" } # Dimensional Collapse\r\n365.0 \"Faith Unmoving\" Ability { id: \"89DA\", source: \"Ser Grinnaux\" }\r\n\r\n# Intermission part 4\r\n# Two sets of four Heavy Impacts used during this intermission.\r\n# They overlap heavily. Because they use different IDs for each ring,\r\n# it's safe to leave them all synced.\r\n366.0 \"Holy Meteor\" Ability { id: \"89EF\", source: \"Ser Noudenet\" } window 220,10\r\n374.6 \"Heavy Impact Set 1\" Ability { id: \"89DE\", source: \"Ser Guerrique\" } duration 10\r\n376.0 \"Comet x4\" duration 4 #Ability { id: \"89F4\", source: \"Ser Noudenet\" }\r\n379.9 \"Heavy Impact Set 2\" Ability { id: \"89DE\", source: \"Ser Guerrique\" } duration 10\r\n383.8 \"Comet x4\" duration 4 #Ability { id: \"89F4\", source: \"Ser Noudenet\" }\r\n398.1 \"Comet Impact\" Ability { id: \"89F2\", source: \"Comet Circle\" }\r\n420.7 \"Meteor Impact Enrage\" Ability { id: \"89F3\", source: \"Meteor Circle\" }\r\n\r\n\r\n427.0 \"--sync--\" Ability { id: \"89BB\", source: \"King Thordan\" } window 260,10\r\n437.7 \"The Light Of Ascalon 1\" #Ability { id: \"89CE\", source: \"Ascalon\" }\r\n439.1 \"The Light Of Ascalon 2\" #Ability { id: \"89CE\", source: \"Ascalon\" }\r\n440.5 \"The Light Of Ascalon 3\" #Ability { id: \"89CE\", source: \"Ascalon\" }\r\n441.9 \"The Light Of Ascalon 4\" #Ability { id: \"89CE\", source: \"Ascalon\" }\r\n443.3 \"The Light Of Ascalon 5\" #Ability { id: \"89CE\", source: \"Ascalon\" }\r\n444.7 \"The Light Of Ascalon 6\" #Ability { id: \"89CE\", source: \"Ascalon\" }\r\n446.1 \"The Light Of Ascalon 7\" #Ability { id: \"89CE\", source: \"Ascalon\" }\r\n447.2 \"--sync--\" Ability { id: \"89CC\", source: \"King Thordan\" } # Ultimate End wind-up\r\n451.8 \"--sync--\" Ability { id: \"89B9\" } # All the knights use this unknown attack here\r\n455.8 \"Ultimate End\" Ability { id: \"89CD\", source: \"King Thordan\" }\r\n460.3 \"--targetable--\"\r\n\r\n# Phase 3\r\n# Save the [healer]!\r\n466.4 \"the Dragon's Eye\" Ability { id: \"89C7\", source: \"King Thordan\" }\r\n476.6 \"Knights Of the Round\" Ability { id: \"89CB\", source: \"King Thordan\" }\r\n481.7 \"Ascalon's Might\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n488.1 \"Holy Shield Bash\" Ability { id: \"89D6\", source: [\"Ser Adelphel\", \"Ser Janlenoux\"] }\r\n497.1 \"Spear Of the Fury\" Ability { id: \"89D1\", source: \"Ser Zephirin\" } # A smile better suits a hero\r\n499.5 \"Heavenly Heel\" Ability { id: \"89C6\", source: \"King Thordan\" }\r\n504.6 \"The Dragon's Gaze/The Dragon's Glory\" Ability { id: [\"89C8\", \"89C9\"], source: \"King Thordan\" }\r\n516.6 \"Ancient Quaga\" Ability { id: \"89C4\", source: \"King Thordan\" }\r\n\r\n#Phase 4\r\n# Conviction Trio\r\n521.8 \"the Dragon's Eye\" Ability { id: \"89C7\", source: \"King Thordan\" }\r\n532.0 \"Knights Of the Round\" Ability { id: \"89CB\", source: \"King Thordan\" }\r\n543.1 \"The Dragon's Gaze/The Dragon's Glory\" Ability { id: [\"89C8\", \"89C9\"], source: \"King Thordan\" }\r\n543.2 \"Conviction\" Ability { id: \"89DB\", source: \"Ser Hermenost\" }\r\n544.1 \"Heavy Impact 1\" Ability { id: \"89DF\", source: \"Ser Guerrique\" }\r\n546.0 \"Conviction\" Ability { id: \"89DC\", source: \"Ser Hermenost\" }\r\n546.0 \"Heavy Impact 2\" Ability { id: \"89E0\", source: \"Ser Guerrique\" }\r\n548.0 \"Heavy Impact 3\" Ability { id: \"89E1\", source: \"Ser Guerrique\" }\r\n550.0 \"Heavy Impact 4\" Ability { id: \"89E2\", source: \"Ser Guerrique\" }\r\n552.4 \"Dimensional Collapse\" Ability { id: \"89D8\", source: \"Ser Grinnaux\" }\r\n552.8 \"--sync--\" Ability { id: \"89D9\", source: \"Ser Grinnaux\" } # Dimensional Collapse\r\n555.9 \"Faith Unmoving\" Ability { id: \"89DA\", source: \"Ser Grinnaux\" }\r\n557.9 \"the Dragon's Rage\" Ability { id: \"89CA\", source: \"King Thordan\" }\r\n563.0 \"Ascalon's Might\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n\r\n# Phase 5\r\n# Spiral Sky Trio\r\n572.1 \"the Dragon's Eye\" Ability { id: \"89C7\", source: \"King Thordan\" }\r\n582.2 \"Knights Of the Round\" Ability { id: \"89CB\", source: \"King Thordan\" }\r\n588.9 \"Lightning Storm\" Ability { id: \"89C0\", source: \"King Thordan\" }\r\n589.3 \"--sync--\" Ability { id: \"89C1\", source: \"King Thordan\" }# Lightning Storm\r\n597.3 \"Spiral Thrust\" Ability { id: \"89E5\", source: \"Ser Vellguine\" }\r\n597.3 \"Spiral Pierce\" Ability { id: \"89E6\", source: \"Ser Paulecrain\" }\r\n597.5 \"Skyward Leap\" Ability { id: \"89E8\", source: \"Ser Ignasse\" }\r\n598.9 \"the Dragon's Rage\" Ability { id: \"89CA\", source: \"King Thordan\" }\r\n609.9 \"Heavenly Heel\" Ability { id: \"89C6\", source: \"King Thordan\" }\r\n612.0 \"Ascalon's Might\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n\r\n# Phase 6\r\n# Meteor Trio\r\n622.1 \"the Dragon's Eye\" Ability { id: \"89C7\", source: \"King Thordan\" }\r\n632.3 \"Knights Of the Round\" Ability { id: \"89CB\", source: \"King Thordan\" }\r\n638.4 \"Ascalon's Might\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n641.5 \"--chains appear--\"\r\n642.4 \"Holy Meteor\" Ability { id: \"89EF\", source: \"Ser Noudenet\" }\r\n643.5 \"Comet x4\" duration 4 #Ability { id: \"89F4\", source: \"Ser Noudenet\" }\r\n643.5 \"The Dragon's Gaze/The Dragon's Glory\" Ability { id: [\"89C8\", \"89C9\"], source: \"King Thordan\" }\r\n643.8 \"--sync--\" Ability { id: \"89EA\", source: \"Ser Charibert\" } # Heavensflame (cast)\r\n644.2 \"Heavensflame 1\" #Ability { id: \"89EB\", source: \"Ser Charibert\" }\r\n645.3 \"Heavensflame 2\" #Ability { id: \"89EB\", source: \"Ser Charibert\" }\r\n646.4 \"Heavensflame 3\" #Ability { id: \"89EB\", source: \"Ser Charibert\" }\r\n646.8 \"Hiemal Storm\" Ability { id: \"89ED\", source: \"Ser Haumeric\" }\r\n647.4 \"--sync--\" Ability { id: \"89EE\", source: [\"Ser Haumeric\", \"Ser Noudenet\"] } # Hiemal Storm\r\n648.7 \"Ascalon's Mercy\" Ability { id: \"89BE\", source: \"King Thordan\" }\r\n656.8 \"Ancient Quaga\" Ability { id: \"89C4\", source: \"King Thordan\" }\r\n662.9 \"Heavenly Heel\" Ability { id: \"89C6\", source: \"King Thordan\" }\r\n668.0 \"Ancient Quaga\" Ability { id: \"89C4\", source: \"King Thordan\" }\r\n\r\n# Phase 7 -- zomg SO MUCH AOE DAMAGE\r\n# Heavensward Trio\r\n673.1 \"the Dragon's Eye\" Ability { id: \"89C7\", source: \"King Thordan\" }\r\n683.3 \"Knights Of the Round\" Ability { id: \"89CB\", source: \"King Thordan\" }\r\n688.4 \"Ascalon's Might\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n693.4 \"Holiest Of Holy\" Ability { id: \"89D4\", source: \"Ser Janlenoux\" }\r\n698.5 \"Ascalon's Might\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n704.6 \"Heavensward Leap 1\" Ability { id: \"89E9\", source: \"Ser Vellguine\" }\r\n707.6 \"Heavensward Leap 2\" Ability { id: \"89E9\", source: \"Ser Paulecrain\" }\r\n710.6 \"Heavensward Leap 3\" Ability { id: \"89E9\", source: \"Ser Ignasse\" }\r\n718.7 \"Sacred Cross\" StartsUsing { id: \"89D0\", source: \"Ser Zephirin\" } duration 24.7\r\n724.6 \"Pure Of Soul\" Ability { id: [\"89F0\", \"89F1\"], source: [\"Ser Charibert\", \"Ser Noudenet\", \"Ser Haumeric\"] }\r\n732.6 \"Absolute Conviction 1\" Ability { id: \"89E3\", source: \"Ser Guerrique\" }\r\n735.5 \"Absolute Conviction 2\" Ability { id: \"89E4\", source: \"Ser Hermenost\" }\r\n740.6 \"The Dragon's Gaze/The Dragon's Glory\" Ability { id: [\"89C8\", \"89C9\"], source: \"King Thordan\" }\r\n743.4 \"--sync--\" Ability { id: \"89D0\", source: \"Ser Zephirin\" } # Sacred Cross resolves\r\n750.7 \"Ancient Quaga\" Ability { id: \"89C4\", source: \"King Thordan\" }\r\n\r\n# Enrage sequence\r\n759.8 \"Heavenly Heel\" Ability { id: \"89C6\", source: \"King Thordan\" }\r\n761.9 \"Ascalon's Might 1\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n767.0 \"Ascalon's Might 2\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n770.1 \"Ascalon's Might 3\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n773.2 \"Ascalon's Might 4\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n776.3 \"Ascalon's Might 5\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n779.4 \"Ascalon's Might 6\" Ability { id: \"89BD\", source: \"King Thordan\" }\r\n791.4 \"Ancient Quaga\" Ability { id: \"89C5\", source: \"King Thordan\" }\r\n\r\n# IGNORED ABILITIES\r\n# 89B7 --sync--\r\n# 89B8 --sync--\r\n# 89BF Ascalon's Mercy\r\n# 89DD Eternal Conviction\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 366 attack\r\n# 89B7 --sync--\r\n# 89B8 --sync--\r\n# 89B9 --sync--\r\n# 89BA --sync--\r\n# 89BB --sync--\r\n# 89BC attack\r\n# 89BD Ascalon's Might\r\n# 89BE Ascalon's Mercy\r\n# 89BF Ascalon's Mercy\r\n# 89C0 Lightning Storm\r\n# 89C1 Lightning Storm\r\n# 89C2 Meteorain\r\n# 89C3 Meteorain\r\n# 89C4 Ancient Quaga\r\n# 89C5 Ancient Quaga\r\n# 89C6 Heavenly Heel\r\n# 89C7 the Dragon's Eye\r\n# 89C8 the Dragon's Gaze\r\n# 89C9 the Dragon's Glory\r\n# 89CA the Dragon's Rage\r\n# 89CB Knights Of the Round\r\n# 89CC Ultimate End\r\n# 89CD Ultimate End\r\n# 89CE the Light Of Ascalon\r\n# 89CF Sacred Cross\r\n# 89D0 Sacred Cross\r\n# 89D1 Spear Of the Fury\r\n# 89D2 Divine Right\r\n# 89D3 Heavenly Slash\r\n# 89D4 Holiest Of Holy\r\n# 89D5 Holy Bladedance\r\n# 89D6 Holy Shield Bash\r\n# 89D8 Dimensional Collapse\r\n# 89D9 Dimensional Collapse\r\n# 89DA Faith Unmoving\r\n# 89DB Conviction\r\n# 89DC Conviction\r\n# 89DD Eternal Conviction\r\n# 89DE Heavy Impact\r\n# 89DF Heavy Impact\r\n# 89E0 Heavy Impact\r\n# 89E1 Heavy Impact\r\n# 89E2 Heavy Impact\r\n# 89E3 Absolute Conviction\r\n# 89E4 Absolute Conviction\r\n# 89E5 Spiral Thrust\r\n# 89E6 Spiral Pierce\r\n# 89E8 Skyward Leap\r\n# 89E9 Heavensward Leap\r\n# 89EA Heavensflame\r\n# 89EB Heavensflame\r\n# 89ED Hiemal Storm\r\n# 89EE Hiemal Storm\r\n# 89EF Holy Meteor\r\n# 89F0 Pure Of Soul\r\n# 89F1 Pure Of Soul\r\n# 89F2 Comet Impact\r\n# 89F3 Meteor Impact\r\n# 89F4 Comet\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/ultima-un.ts



const ultima_un_triggerSet = {
  id: 'UltimasBaneUnreal',
  zoneId: zone_id/* default.UltimasBaneUnreal */.Z.UltimasBaneUnreal,
  timelineFile: 'ultima-un.txt',
  initData: () => {
    return {
      plasmTargets: [],
      boomCounter: 1
    };
  },
  timelineTriggers: [{
    id: 'Ultima Unreal Homing Lasers',
    regex: /Homing Lasers/,
    beforeSeconds: 4,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread--Homing Lasers',
        de: 'Verteilen--Leitlaser',
        fr: 'Écartez-vous -- Lasers autoguidés',
        cn: '分散--追踪激光',
        ko: '산개--유도 레이저'
      }
    }
  }, {
    id: 'Ultima Unreal Diffractive Laser',
    regex: /Diffractive Laser/,
    beforeSeconds: 4,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }, {
    id: 'Ultima Unreal Vulcan Burst',
    regex: /Vulcan Burst/,
    beforeSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Melee knockback',
        de: 'Melee Rückstoß',
        fr: 'Poussée',
        cn: '近战击退',
        ko: '근접 넉백'
      }
    }
  }],
  triggers: [{
    id: 'Ultima Unreal Tank Purge',
    type: 'StartsUsing',
    netRegex: {
      id: '6EF9',
      source: 'The Ultima Weapon',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    // At 5 stacks of Viscous Aetheroplasm, the target begins taking massive damage.
    id: 'Ultima Unreal Viscous Aetheroplasm',
    type: 'GainsEffect',
    netRegex: {
      effectId: '171',
      count: '04',
      capture: false
    },
    condition: data => data.role === 'tank',
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: outputs/* default.tankSwap */.Z.tankSwap
    }
  }, {
    id: 'Ultima Unreal Homing Aetheroplasm Collect',
    type: 'Ability',
    netRegex: {
      id: '6F07'
    },
    run: (data, matches) => {
      data.plasmTargets = data.plasmTargets ??= [];
      data.plasmTargets.push(matches.target);
    }
  }, {
    // This ability is ARR 2.0's version of headmarkers. No associated 27 lines are present.
    // These lines are sent by entities with no name and no 03/04 lines.
    id: 'Ultima Unreal Homing Aetheroplasm Call',
    type: 'Ability',
    netRegex: {
      id: '6F07',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (data.plasmTargets?.includes(data.me)) return output.target();
      return output.avoid();
    },
    outputStrings: {
      target: {
        en: 'Homing Aetheroplasm on YOU',
        de: 'Verfolgendes Ätheroplasma auf DIR',
        fr: 'Laser + Éthéroplasma sur VOUS',
        cn: '追踪激光点名',
        ko: '에테르 폭뢰 대상자'
      },
      avoid: {
        en: 'Avoid Homing Aetheroplasm',
        de: 'Weiche dem verfolgendem Ätheroplasma aus',
        fr: 'Évitez le laser + l\'Éthéroplasma',
        cn: '躲避追踪激光',
        ko: '에테르 폭뢰 피하기'
      }
    }
  }, {
    id: 'Ultima Unreal Homing Aetheroplasm Cleanup',
    type: 'Ability',
    netRegex: {
      id: '6F07',
      capture: false
    },
    delaySeconds: 5,
    suppressSeconds: 5,
    run: data => delete data.plasmTargets
  }, {
    // We use a StartsUsing line here because we can't use timeline triggers for this,
    // and we want to warn players as early as possible.
    id: 'Ultima Unreal Aetheric Boom Orbs',
    type: 'StartsUsing',
    netRegex: {
      id: '6EF6',
      source: 'The Ultima Weapon',
      capture: false
    },
    alarmText: (data, _matches, output) => output[`boom${data.boomCounter}`](),
    run: data => data.boomCounter += 1,
    outputStrings: {
      boom1: {
        en: 'Orbs: Cardinals',
        de: 'Orbs: Kardinal',
        fr: 'Orbes : Cardinaux',
        cn: '球: 十字',
        ko: '구슬: 십자'
      },
      boom2: {
        en: 'Orbs: Cardinals (N/S first)',
        de: 'Orbs: Kardinal (N/S zuerst)',
        fr: 'Orbes : Cardinaux (N/S en premier)',
        cn: '球: 十字（先南/北）',
        ko: '구슬: 십자(남/북 먼저)'
      },
      boom3: {
        en: 'Orbs: Intercardinals',
        de: 'Orbs: Interkardinal',
        fr: 'Orbes : Intercardinaux',
        cn: '球: 方形',
        ko: '구슬: 사각형'
      }
    }
  }, {
    id: 'Ultima Unreal Aetheric Boom Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '6EF6',
      source: 'The Ultima Weapon',
      capture: false
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'The Ultima Weapon': 'Ultima-Waffe',
      'Ultima Garuda': 'Ultima-Garuda',
      'Ultima Ifrit': 'Ultima-Ifrit',
      'Ultima Titan': 'Ultima-Titan'
    },
    'replaceText': {
      'Aetheric Boom': 'Ätherknall',
      'Ceruleum Vent': 'Erdseim-Entlüfter',
      'Crimson Cyclone': 'Zinnober-Zyklon',
      'Diffractive Laser': 'Diffraktiver Laser',
      'Eruption': 'Eruption',
      'Eye of the Storm': 'Auge des Sturms',
      'Geocrush': 'Geo-Stoß',
      'Homing Lasers': 'Leitlaser',
      'Magitek Ray': 'Magitek-Laser',
      'Mistral Song': 'Mistral-Song',
      'Radiant Plume': 'Scheiterhaufen',
      'Tank Purge': 'Tankreinigung',
      'Ultima': 'Ultima',
      'Viscous Aetheroplasm': 'Viskoses Ätheroplasma',
      'Vulcan Burst': 'Feuerstoß',
      'Weight of the Land': 'Gaias Gewicht'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'The Ultima Weapon': 'Ultima Arma',
      'Ultima Garuda': 'Ultima-Garuda',
      'Ultima Ifrit': 'Ultima-Ifrit',
      'Ultima Titan': 'Ultima-Titan'
    },
    'replaceText': {
      'Aetheric Boom': 'Onde d\'éther',
      'Ceruleum Vent': 'Exutoire à céruleum',
      'Crimson Cyclone': 'Cyclone écarlate',
      'Diffractive Laser': 'Laser diffractif',
      'Eruption': 'Éruption',
      'Eye of the Storm': 'Œil du cyclone',
      'Geocrush': 'Broie-terre',
      'Homing Lasers': 'Lasers autoguidés',
      'Magitek Ray': 'Rayon magitek',
      'Mistral Song': 'Chant du mistral',
      'Radiant Plume': 'Panache radiant',
      'Tank Purge': 'Vidange de réservoir',
      'Ultima': 'Ultima',
      'Viscous Aetheroplasm': 'Éthéroplasma poisseux',
      'Vulcan Burst': 'Explosion volcanique',
      'Weight of the Land': 'Poids de la terre'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'The Ultima Weapon': 'アルテマウェポン',
      'Ultima Garuda': 'アルテマ・ガルーダ',
      'Ultima Ifrit': 'アルテマ・イフリート',
      'Ultima Titan': 'アルテマ・タイタン'
    },
    'replaceText': {
      'Aetheric Boom': 'エーテル波動',
      'Ceruleum Vent': 'セルレアムベント',
      'Crimson Cyclone': 'クリムゾンサイクロン',
      'Diffractive Laser': '拡散レーザー',
      'Eruption': 'エラプション',
      'Eye of the Storm': 'アイ・オブ・ストーム',
      'Geocrush': 'ジオクラッシュ',
      'Homing Lasers': '誘導レーザー',
      'Magitek Ray': '魔導レーザー',
      'Mistral Song': 'ミストラルソング',
      'Radiant Plume': '光輝の炎柱',
      'Tank Purge': '魔導フレア',
      'Ultima': 'アルテマ',
      'Viscous Aetheroplasm': '吸着式エーテル爆雷',
      'Vulcan Burst': 'バルカンバースト',
      'Weight of the Land': '大地の重み'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'The Ultima Weapon': '究极神兵',
      'Ultima Garuda': '究极迦楼罗',
      'Ultima Ifrit': '究极伊弗利特',
      'Ultima Titan': '究极泰坦'
    },
    'replaceText': {
      'Aetheric Boom': '以太波动',
      'Ceruleum Vent': '青磷放射',
      'Crimson Cyclone': '深红旋风',
      'Diffractive Laser': '扩散射线',
      'Eruption': '地火喷发',
      'Eye of the Storm': '台风眼',
      'Geocrush': '大地粉碎',
      'Homing Lasers': '诱导射线',
      'Magitek Ray': '魔导激光',
      'Mistral Song': '寒风之歌',
      'Radiant Plume': '光辉炎柱',
      'Tank Purge': '魔导核爆',
      'Ultima': '究极',
      'Viscous Aetheroplasm': '吸附式以太炸弹',
      'Vulcan Burst': '火神爆裂',
      'Weight of the Land': '大地之重'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'The Ultima Weapon': '알테마 웨폰',
      'Ultima Garuda': '알테마 가루다',
      'Ultima Ifrit': '알테마 이프리트',
      'Ultima Titan': '알테마 타이탄'
    },
    'replaceText': {
      'Aetheric Boom': '에테르 파동',
      'Ceruleum Vent': '청린 방출',
      'Crimson Cyclone': '진홍 회오리',
      'Diffractive Laser': '확산 레이저',
      'Eruption': '용암 분출',
      'Eye of the Storm': '태풍의 눈',
      'Geocrush': '대지 붕괴',
      'Homing Lasers': '유도 레이저',
      'Magitek Ray': '마도 레이저',
      'Mistral Song': '삭풍의 노래',
      'Radiant Plume': '광휘의 불기둥',
      'Tank Purge': '마도 플레어',
      'Ultima': '알테마',
      'Viscous Aetheroplasm': '흡착식 에테르 폭뢰',
      'Vulcan Burst': '폭렬 난사',
      'Weight of the Land': '대지의 무게'
    }
  }]
};
/* harmony default export */ const ultima_un = (ultima_un_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/ultima-un.txt
const trial_ultima_un_namespaceObject = "### The Minstrel's Ballad: Ultima's Bane\r\n\r\n# -ii 6EFA 6F06 6F0A 6EF7 6EF8\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n\r\n# Phase 1: 100% - 85%\r\n3.2 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" } window 3.2,10\r\n15.1 \"Vulcan Burst\" Ability { id: \"6EFD\", source: \"The Ultima Weapon\" }\r\n16.6 \"Mistral Song\" Ability { id: \"6EFC\", source: \"Ultima Garuda\" }\r\n26.4 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n29.7 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n33.0 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" } window 10,10\r\n41.3 \"Eye of the Storm\" Ability { id: \"6EFE\", source: \"The Ultima Weapon\" }\r\n43.9 \"Geocrush\" Ability { id: \"6EFF\", source: \"Ultima Titan\" }\r\n48.4 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n51.7 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n\r\n55.0 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" } window 10,10 jump 3.2\r\n66.9 \"Vulcan Burst\"\r\n68.4 \"Mistral Song\"\r\n78.2 \"Homing Lasers\"\r\n81.5 \"Ceruleum Vent\"\r\n84.8 \"Viscous Aetheroplasm\"\r\n\r\n\r\n# Phase 2: 84.9% - 65%\r\n# The animation for Garuda dying precedes this,\r\n# but there are no log lines that show for her death.\r\n98.3 \"--sync--\" StartsUsing { id: \"6F00\", source: \"The Ultima Weapon\" } window 98.3,5\r\n100.0 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n103.0 \"Weight of the Land\" Ability { id: \"6F01\", source: \"The Ultima Weapon\" }\r\n107.1 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n\r\n115.9 \"Tank Purge\" Ability { id: \"6EF9\", source: \"The Ultima Weapon\" } window 30,30\r\n119.3 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n125.6 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n129.6 \"Weight of the Land\" Ability { id: \"6F01\", source: \"The Ultima Weapon\" }\r\n130.7 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n134.0 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n141.3 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n148.6 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n151.6 \"Weight of the Land\" Ability { id: \"6F01\", source: \"The Ultima Weapon\" }\r\n152.7 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n156.0 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n\r\n164.8 \"Tank Purge\" Ability { id: \"6EF9\", source: \"The Ultima Weapon\" } window 30,30\r\n168.2 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n175.5 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n179.5 \"Weight of the Land\" Ability { id: \"6F01\", source: \"The Ultima Weapon\" }\r\n179.6 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n182.9 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n190.3 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n195.7 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n198.6 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n201.6 \"Weight of the Land\" Ability { id: \"6F01\", source: \"The Ultima Weapon\" }\r\n203.7 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n\r\n212.5 \"Tank Purge\" Ability { id: \"6EF9\", source: \"The Ultima Weapon\" } window 30,30 jump 164.8\r\n215.9 \"Homing Lasers\"\r\n223.2 \"Radiant Plume\"\r\n227.2 \"Weight of the Land\"\r\n227.3 \"Ceruleum Vent\"\r\n230.6 \"Viscous Aetheroplasm\"\r\n\r\n\r\n# Phase 3: 64.9% -50%\r\n# As in phase 2, Titan's death animation comes first with no indicator.\r\n# The phase opens with what seems to be a *long* set of fixed blocks.\r\n# A Viscous Aetheroplasm may or may not be skipped.\r\n\r\n297.3 \"--sync--\" StartsUsing { id: \"6F03\", source: \"The Ultima Weapon\" } window 297.3,0\r\n300.0 \"Eruption x5\" duration 8 #Ability { id: \"6F03\", source: \"The Ultima Weapon\" }\r\n306.6 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n315.3 \"Tank Purge\" Ability { id: \"6EF9\", source: \"The Ultima Weapon\" } window 15,15\r\n318.6 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n323.9 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n327.2 \"Viscous Aetheroplasm?\" #Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n332.4 \"--sync--\" StartsUsing { id: \"6F00\", source: \"The Ultima Weapon\" } window 20,2.5\r\n335.1 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n337.9 \"Crimson Cyclone\" Ability { id: \"6F04\", source: \"Ultima Ifrit\" }\r\n339.2 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n343.2 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n345.4 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" } window 15,15\r\n345.9 \"Crimson Cyclone\" Ability { id: \"6F04\", source: \"Ultima Ifrit\" }\r\n347.1 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n352.7 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n\r\n360.6 \"Eruption x5\" duration 8 #Ability { id: \"6F03\", source: \"The Ultima Weapon\" }\r\n365.1 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n368.5 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n377.2 \"Tank Purge\" Ability { id: \"6EF9\", source: \"The Ultima Weapon\" } window 15,15\r\n380.6 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n\r\n# A possible extra block is here, but it doesn't seem to change the rotation.\r\n# Ceruleum Vent jumps to a small sidetrack before continuing.\r\n385.2 \"--sync--\" StartsUsing { id: \"6F00\", source: \"The Ultima Weapon\" } window 15,15 jump 547.3 # Radiant Plume\r\n385.9 \"Ceruleum Vent?\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" } window 15,15 jump 450\r\n387.9 \"Radiant Plume?\"\r\n389.2 \"Viscous Aetheroplasm?\"\r\n390.7 \"Crimson Cyclone?\"\r\n392.0 \"Radiant Plume?\"\r\n396.0 \"Radiant Plume?\"\r\n396.5 \"Homing Lasers?\"\r\n\r\n# Vent sidetrack into normal early Eruption block\r\n450.0 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n453.3 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n460.6 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n466.0 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n\r\n# Normal early Eruption block\r\n466.5 \"--sync--\" StartsUsing { id: \"6F03\", source: \"The Ultima Weapon\" } window 30,1\r\n469.2 \"Eruption x5\" duration 8 #Ability { id: \"6F03\", source: \"The Ultima Weapon\" }\r\n475.0 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n483.8 \"Tank Purge\" Ability { id: \"6EF9\", source: \"The Ultima Weapon\" } window 15,15\r\n487.1 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n492.5 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n\r\n# Eruption and Cyclone blocks will alternate from here.\r\n# *However*, at any time, a Viscous Aetheroplasm bridge may follow.\r\n# Subesquent blocks are different, ending with an Aetheroplasm rather than a Vent.\r\n\r\n492.7 \"--sync--\" StartsUsing { id: \"6F00\", source: \"The Ultima Weapon\" } window 20,20 jump 547.3 # Radiant Plume\r\n495.4 \"Radiant Plume?\"\r\n495.8 \"Viscous Aetheroplasm?\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" } window 15,15 jump 650\r\n498.2 \"Crimson Cyclone?\"\r\n499.5 \"Radiant Plume\"\r\n503.1 \"Homing Lasers?\"\r\n503.5 \"Radiant Plume?\"\r\n506.3 \"Crimson Cyclone?\"\r\n\r\n# Normal early Cyclone block\r\n# Ceruleum Vent doesn't always happen during these Cyclone blocks.\r\n# However, timings don't seem dependent on its use,\r\n# so we can safely just not sync it and leave the block alone.\r\n547.3 \"--sync--\" StartsUsing { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n550.0 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n552.8 \"Crimson Cyclone\" Ability { id: \"6F04\", source: \"Ultima Ifrit\" }\r\n554.1 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n558.1 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n560.9 \"Crimson Cyclone\" Ability { id: \"6F04\", source: \"Ultima Ifrit\" }\r\n561.1 \"Ceruleum Vent?\" #Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n562.1 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n564.4 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n571.7 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n577.1 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n\r\n# Jump to the Aetheroplasm bridge or the early Eruption block\r\n577.4 \"--sync--\" StartsUsing { id: \"6F03\", source: \"The Ultima Weapon\" } window 20,20 jump 466.5\r\n580.1 \"Eruption x5?\"\r\n580.4 \"Viscous Aetheroplasm?\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" } window 5,5 jump 650\r\n585.9 \"Viscous Aetheroplasm?\"\r\n587.7 \"Homing Lasers?\"\r\n593.0 \"Ceruleum Vent?\"\r\n594.7 \"Tank Purge\"\r\n\r\n# An Aetheroplasm immediately following a Vent seems to indicate the start of the late rotation.\r\n# If this block follows an Eruption block, Tank Purge is skipped.\r\n# If this block follows a Cyclone block, Aetheroplasm is skipped\r\n650.0 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n658.7 \"Tank Purge?\" #Ability { id: \"6EF9\", source: \"The Ultima Weapon\" }\r\n662.0 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" } window 12,5\r\n667.3 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n670.7 \"Viscous Aetheroplasm?\" #Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n\r\n#cactbot-timeline-lint-disable-sync-order\r\n# From here, the late Cyclone/EruptionHoming Lasers blocks are added.\r\n669.9 \"--sync--\" StartsUsing { id: \"6F00\", source: \"The Ultima Weapon\" } window 15,15 jump 697.3 # Radiant Plume\r\n671.0 \"--sync--\" StartsUsing { id: \"6F03\", source: \"The Ultima Weapon\" } window 15,15 jump 797.3 # Eruption\r\n#cactbot-timeline-lint-enable-sync-order\r\n\r\n672.6 \"Radiant Plume?\"\r\n673.7 \"Eruption x5?\"\r\n675.4 \"Crimson Cyclone?\"\r\n676.7 \"Radiant Plume?\"\r\n678.0 \"Homing Lasers?\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" } window 10,10 jump 900\r\n680.7 \"Radiant Plume?\"\r\n684.3 \"Tank Purge?\"\r\n\r\n# Late Cyclone block\r\n697.3 \"--sync--\" StartsUsing { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n700.0 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n702.8 \"Crimson Cyclone\" Ability { id: \"6F04\", source: \"Ultima Ifrit\" }\r\n704.1 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n708.1 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n710.9 \"Crimson Cyclone\" Ability { id: \"6F04\", source: \"Ultima Ifrit\" }\r\n712.1 \"Radiant Plume\" Ability { id: \"6F00\", source: \"The Ultima Weapon\" }\r\n716.1 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" } window 12,5\r\n721.4 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n724.7 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n\r\n727.3 \"--sync--\" StartsUsing { id: \"6F03\", source: \"The Ultima Weapon\" } window 15,15 jump 797.3 # Eruption\r\n730.0 \"Eruption x5?\"\r\n732.0 \"Homing Lasers?\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" } window 10,10 jump 900\r\n737.3 \"Ceruleum Vent?\"\r\n740.6 \"Viscous Aetheroplasm?\"\r\n740.6 \"Tank Purge?\"\r\n743.9 \"Homing Lasers?\"\r\n\r\n# Late Eruption block\r\n797.3 \"--sync--\" StartsUsing { id: \"6F03\", source: \"The Ultima Weapon\" } window 2.5,0\r\n800.0 \"Eruption x5\" duration 8 #Ability { id: \"6F03\", source: \"The Ultima Weapon\" }\r\n810.6 \"Tank Purge\" Ability { id: \"6EF9\", source: \"The Ultima Weapon\" } window 15,15\r\n813.9 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n819.2 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n822.5 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n\r\n825.1 \"--sync--\" StartsUsing { id: \"6F00\", source: \"The Ultima Weapon\" } window 15,15 jump 697.3 # Radiant  Plume\r\n827.8 \"Radiant Plume?\"\r\n829.8 \"Homing Lasers?\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" } window 10,10 jump 900\r\n830.6 \"Crimson Cyclone?\"\r\n831.9 \"Radiant Plume?\"\r\n835.1 \"Ceruleum Vent?\"\r\n835.9 \"Radiant Plume?\"\r\n838.4 \"Viscous Aetheroplasm?\"\r\n\r\n# Late Homing Lasers sidetrack\r\n900.0 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n905.3 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n908.6 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n\r\n912.3 \"--sync--\" StartsUsing { id: \"6F03\", source: \"The Ultima Weapon\" } window 15,15 jump 797.3 # Eruption\r\n913.2 \"--sync--\" StartsUsing { id: \"6F00\", source: \"The Ultima Weapon\" } window 15,15 jump 697.3 # Radiant Plume\r\n915.0 \"Eruption x5?\"\r\n915.9 \"Radiant Plume?\"\r\n918.7 \"Crimson Cyclone?\"\r\n920.0 \"Radiant Plume?\"\r\n924.0 \"Radiant Plume?\"\r\n924.1 \"Tank Purge?\"\r\n927.4 \"Homing Lasers?\"\r\n\r\n\r\n# Phase 4 -- 49.9% - 0%\r\n# Phase 4 seems to have a single rotation block.\r\n# Aetheric Boom and Freefire events happen at HP thresholds,\r\n# but they do not appear to change ability usage,\r\n# they just delay whatever ability was queued up next.\r\n# Because of this, we add many more sync windows than we normally would.\r\n\r\n# The opening block is short.\r\n1000.0 \"Aetheric Boom\" Ability { id: \"6EF6\", source: \"The Ultima Weapon\" } window 1000,5\r\n1011.3 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n1015.6 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" }\r\n1019.9 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n1023.1 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n1034.1 \"Magitek Ray 1\" Ability { id: [\"6EF2\", \"6EF3\", \"6EF4\"], source: \"The Ultima Weapon\" }\r\n1037.1 \"Magitek Ray 2\" Ability { id: [\"6EF2\", \"6EF3\", \"6EF4\"], source: \"The Ultima Weapon\" }\r\n1040.1 \"Magitek Ray 3\" Ability { id: [\"6EF2\", \"6EF3\", \"6EF4\"], source: \"The Ultima Weapon\" }\r\n\r\n1042.7 \"--sync--\" StartsUsing { id: \"6EF9\", source: \"The Ultima Weapon\" } window 45,45\r\n1045.9 \"Tank Purge\" Ability { id: \"6EF9\", source: \"The Ultima Weapon\" }\r\n1049.2 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n1052.5 \"Diffractive Laser\" Ability { id: \"6EF1\", source: \"The Ultima Weapon\" } window 20,20\r\n1054.8 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" } window 20,20\r\n1059.1 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n1062.4 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n1070.5 \"Magitek Ray 1\" Ability { id: [\"6EF2\", \"6EF3\", \"6EF4\"], source: \"The Ultima Weapon\" } window 15,1\r\n1073.5 \"Magitek Ray 2\" Ability { id: [\"6EF2\", \"6EF3\", \"6EF4\"], source: \"The Ultima Weapon\" }\r\n1076.5 \"Magitek Ray 3\" Ability { id: [\"6EF2\", \"6EF3\", \"6EF4\"], source: \"The Ultima Weapon\" }\r\n1080.8 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n1084.1 \"Diffractive Laser\" Ability { id: \"6EF1\", source: \"The Ultima Weapon\" } window 10,20\r\n1086.4 \"Homing Lasers\" Ability { id: \"6EF0\", source: \"The Ultima Weapon\" } window 10,20\r\n1090.7 \"Ceruleum Vent\" Ability { id: \"6EEF\", source: \"The Ultima Weapon\" }\r\n1094.0 \"Viscous Aetheroplasm\" Ability { id: \"6EEE\", source: \"The Ultima Weapon\" }\r\n1105.1 \"Magitek Ray 1\" Ability { id: [\"6EF2\", \"6EF3\", \"6EF4\"], source: \"The Ultima Weapon\" } window 15,1\r\n1108.1 \"Magitek Ray 2\" Ability { id: [\"6EF2\", \"6EF3\", \"6EF4\"], source: \"The Ultima Weapon\" }\r\n1111.0 \"Magitek Ray 3\" Ability { id: [\"6EF2\", \"6EF3\", \"6EF4\"], source: \"The Ultima Weapon\" }\r\n\r\n1113.6 \"--sync--\" StartsUsing { id: \"6EF9\", source: \"The Ultima Weapon\" } window 45,45 jump 1042.7\r\n1116.8 \"Tank Purge\"\r\n1120.2 \"Viscous Aetheroplasm\"\r\n1123.5 \"Diffractive Laser\"\r\n1125.8 \"Homing Lasers\"\r\n1130.1 \"Ceruleum Vent\"\r\n1133.4 \"Viscous Aetheroplasm\"\r\n1141.5 \"Magitek Ray 1\"\r\n\r\n\r\n\r\n# Enrage appears to be at 10:30.\r\n# Ultima Weapon teleports to the center and casts Ultima.\r\n9989.3 \"--sync--\" StartsUsing { id: \"6EFB\", source: \"The Ultima Weapon\" } window 10000,0\r\n10000.0 \"Ultima Enrage\" Ability { id: \"6EFB\", source: \"The Ultima Weapon\" }\r\n\r\n\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/zeromus-ex.ts







// TODO: Abyssal Echoes safe spots
// TODO: Flare safe spots
// TODO: Meteor tether calls (could we say like 3 left, 1 right?)
const headmarkerMap = {
  tankBuster: '016C',
  blackHole: '014A',
  tether: '0146',
  // Most spread markers (Big Bang, Big Crunch, Dark Divides)
  spread: '0178',
  accelerationBomb: '010B',
  nox: '00C5',
  akhRhaiSpread: '0017',
  enums: '00D3',
  // The Dark Beckons, but also Umbral Rays
  stack: '003E'
};
const zeromus_ex_centerX = 100;
const zeromus_ex_centerY = 100;
const zeromus_ex_triggerSet = {
  id: 'TheAbyssalFractureExtreme',
  zoneId: zone_id/* default.TheAbyssalFractureExtreme */.Z.TheAbyssalFractureExtreme,
  timelineFile: 'zeromus-ex.txt',
  initData: () => {
    return {
      phase: 'one',
      miasmicBlasts: [],
      busterPlayers: [],
      forkedPlayers: [],
      noxPlayers: []
    };
  },
  timelineTriggers: [{
    id: 'ZeromusEx Flare',
    // Extra time for spreading out.
    // This could also be StartsUsing 85BD.
    regex: /^Flare$/,
    beforeSeconds: 13,
    suppressSeconds: 20,
    response: responses/* Responses.getTowers */.n3.getTowers()
  }, {
    id: 'ZeromusEx Big Bang Spread',
    // Extra time for spreading out.
    // This could alternatively be StartsUsing 8B4C or HeadMarker 0178.
    regex: /^Big Bang$/,
    beforeSeconds: 13,
    suppressSeconds: 20,
    response: responses/* Responses.spread */.n3.spread('alert')
  }, {
    id: 'ZeromusEx Big Crunch Spread',
    // Extra time for spreading out.
    // This could alternatively be StartsUsing 8B4D or HeadMarker 0178.
    regex: /^Big Crunch$/,
    beforeSeconds: 13,
    suppressSeconds: 20,
    response: responses/* Responses.spread */.n3.spread('alert')
  }],
  triggers: [{
    id: 'ZeromusEx Abyssal Nox',
    type: 'GainsEffect',
    netRegex: {
      effectId: '6E9',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Heal to full',
        de: 'Voll heilen',
        fr: 'Soin complet',
        ja: 'HPを満タンに',
        cn: '奶满全队',
        ko: '체력 풀피로'
      }
    }
  }, {
    id: 'ZeromusEx Sable Thread',
    type: 'Ability',
    netRegex: {
      id: '8AEF',
      source: 'Zeromus'
    },
    alertText: (data, matches, output) => {
      const num = data.seenSableThread ? 7 : 6;
      data.seenSableThread = true;
      if (matches.target === data.me) return output.lineStackOnYou({
        num: num
      });
      return output.lineStackOn({
        num: num,
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      lineStackOn: {
        en: '${num}x line stack on ${player}',
        de: '${num}x in einer Linie sammeln mit ${player}',
        fr: 'Package en ligne ${num}x sur ${player}',
        ja: '${num}x 直線頭割り (${player})',
        cn: '${num}x 直线分摊 (${player})',
        ko: '${num}x 직선 쉐어 (${player})'
      },
      lineStackOnYou: {
        en: '${num}x line stack on YOU',
        de: '${num}x in einer Linie sammeln mit DIR',
        fr: 'Package en ligne ${num}x sur VOUS',
        ja: '自分に${num}x 直線頭割り',
        cn: '${num}x 直线分摊点名',
        ko: '${num}x 직선 쉐어 대상자'
      }
    }
  }, {
    id: 'ZeromusEx Dark Matter You',
    type: 'HeadMarker',
    netRegex: {
      id: headmarkerMap.tankBuster
    },
    alertText: (data, matches, output) => {
      data.busterPlayers.push(matches.target);
      if (data.me === matches.target) return output.tankBusterOnYou();
    },
    outputStrings: {
      tankBusterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou
    }
  }, {
    id: 'ZeromusEx Dark Matter Others',
    type: 'HeadMarker',
    netRegex: {
      id: headmarkerMap.tankBuster,
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 2,
    infoText: (data, _matches, output) => {
      if (!data.busterPlayers.includes(data.me)) return output.tankBusters();
    },
    outputStrings: {
      tankBusters: outputs/* default.tankBusters */.Z.tankBusters
    }
  }, {
    id: 'ZeromusEx Dark Matter Cleanup',
    type: 'Ability',
    netRegex: {
      id: '8B84',
      source: 'Zeromus',
      capture: false
    },
    suppressSeconds: 5,
    run: data => data.busterPlayers = []
  }, {
    id: 'ZeromusEx Visceral Whirl NE Safe',
    type: 'StartsUsing',
    netRegex: {
      id: '8B43',
      source: 'Zeromus',
      capture: false
    },
    infoText: (_data, _matches, output) => {
      return output.text({
        dir1: output.ne(),
        dir2: output.sw()
      });
    },
    outputStrings: {
      text: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        ja: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      },
      ne: outputs/* default.northeast */.Z.northeast,
      sw: outputs/* default.southwest */.Z.southwest
    }
  }, {
    id: 'ZeromusEx Visceral Whirl NW Safe',
    type: 'StartsUsing',
    netRegex: {
      id: '8B46',
      source: 'Zeromus',
      capture: false
    },
    infoText: (_data, _matches, output) => {
      return output.text({
        dir1: output.nw(),
        dir2: output.se()
      });
    },
    outputStrings: {
      text: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        ja: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      },
      nw: outputs/* default.northwest */.Z.northwest,
      se: outputs/* default.southeast */.Z.southeast
    }
  }, {
    id: 'ZeromusEx Miasmic Blasts Reset',
    type: 'StartsUsing',
    // reset Blasts combatant data when the preceding Visceral Whirl is used
    netRegex: {
      id: '8B4[36]',
      source: 'Zeromus',
      capture: false
    },
    run: data => data.miasmicBlasts = []
  }, {
    id: 'ZeromusEx Miasmic Blast Safe Spots',
    type: 'StartsUsing',
    netRegex: {
      id: '8B49',
      source: 'Zeromus',
      capture: true
    },
    delaySeconds: 0.5,
    promise: async (data, matches) => {
      const combatants = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.sourceId, 16)]
      })).combatants;
      if (combatants.length !== 1) return;
      const combatant = combatants[0];
      if (combatant === undefined) return;
      data.miasmicBlasts.push(combatant);
    },
    alertText: (data, _matches, output) => {
      if (data.miasmicBlasts.length !== 3) {
        return;
      }
      // Blasts can spawn center, on cardinals (+/-14 from center), or on intercards (+/-7 from center).
      // Unsafe spots vary for each of the 9 possible spawn points, but are always the same *relative* to that type.
      // So apply a fixed set of modifiers based on type, regardless of spawn point, to eliminate unsafe spots.
      const cardinal16Dirs = [0, 4, 8, 12];
      const intercard16Dirs = [2, 6, 10, 14];
      const unsafe16DirModifiers = {
        cardinal: [-1, 0, 1, 4, 5, 11, 12],
        intercard: [-2, 0, 2, 3, 8, 13]
      };

      // Filter to north half.
      const validSafeSpots = ['dirNNE', 'dirNE', 'dirENE', 'dirWNW', 'dirNW', 'dirNNW'];
      let possibleSafeSpots = [...validSafeSpots];
      for (const blast of data.miasmicBlasts) {
        // special case for center - don't need to find relative dirs, just remove all intercards
        if (Math.round(blast.PosX) === 100 && Math.round(blast.PosY) === 100) intercard16Dirs.forEach(intercard => possibleSafeSpots = possibleSafeSpots.filter(dir => dir !== util/* Directions.output16Dir */.N.output16Dir[intercard]));else {
          const blastPos16Dir = util/* Directions.xyTo16DirNum */.N.xyTo16DirNum(blast.PosX, blast.PosY, zeromus_ex_centerX, zeromus_ex_centerY);
          const relativeUnsafeDirs = cardinal16Dirs.includes(blastPos16Dir) ? unsafe16DirModifiers.cardinal : unsafe16DirModifiers.intercard;
          for (const relativeUnsafeDir of relativeUnsafeDirs) {
            const actualUnsafeDir = (16 + blastPos16Dir + relativeUnsafeDir) % 16;
            possibleSafeSpots = possibleSafeSpots.filter(dir => dir !== util/* Directions.output16Dir */.N.output16Dir[actualUnsafeDir]);
          }
        }
      }
      if (possibleSafeSpots.length !== 1) return output.avoidUnknown();
      const [safeDir] = possibleSafeSpots;
      if (safeDir === undefined) return output.avoidUnknown();
      return output[safeDir]();
    },
    outputStrings: {
      avoidUnknown: {
        en: 'Avoid Line Cleaves',
        de: 'Weiche den Linien Cleaves aus',
        fr: 'Évitez les cleaves en ligne',
        ja: '直線AOE回避',
        cn: '远离十字AOE',
        ko: '직선 장판 피하기'
      },
      dirNNE: {
        en: 'North Wall (NNE/WSW)',
        de: 'Nördliche Wand (NNO/WSW)',
        fr: 'Mur Nord (NNE/OSO)',
        ja: '1時・8時',
        cn: '右上前方/左下侧边',
        ko: '1시/8시'
      },
      dirNNW: {
        en: 'North Wall (NNW/ESE)',
        de: 'Nördliche Wand (NNW/OSO)',
        fr: 'Mur Nord (NNO/ESE)',
        ja: '11時・4時',
        cn: '左上前方/右下侧边',
        ko: '11시/4시'
      },
      dirNE: {
        en: 'Corners (NE/SW)',
        de: 'Ecken (NO/SW)',
        fr: 'Coins (NE/SO)',
        ja: '隅へ (北東・南西)',
        cn: '右上/左下角落',
        ko: '구석 (북동/남서)'
      },
      dirNW: {
        en: 'Corners (NW/SE)',
        de: 'Ecken (NW/SO)',
        fr: 'Coins (NO/SE)',
        ja: '隅へ (北西・南東)',
        cn: '左上/右下角落',
        ko: '구석 (북서/남동)'
      },
      dirENE: {
        en: 'East Wall (ENE/SSW)',
        de: 'Östliche Wand (ONO/SSW)',
        fr: 'Mur Est (ENE/SSO)',
        ja: '2時・7時',
        cn: '右上侧边/左下后方',
        ko: '2시/7시'
      },
      dirWNW: {
        en: 'West Wall (WNW/SSE)',
        de: 'Westliche Wand (WNW/SSO)',
        fr: 'Mur Ouest (ONO/SSE)',
        ja: '10時・5時',
        cn: '左上侧边/右下后方',
        ko: '10시/5시'
      }
    }
  }, {
    id: 'ZeromusEx Big Bang',
    type: 'StartsUsing',
    netRegex: {
      id: '8B4C',
      source: 'Zeromus',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'ZeromusEx Forked Lightning',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'ED7'
    },
    condition: (data, matches) => {
      data.forkedPlayers.push(matches.target);
      return matches.target === data.me;
    },
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 6,
    durationSeconds: 5,
    alarmText: (_data, _matches, output) => output.forkedLightning(),
    outputStrings: {
      forkedLightning: {
        en: 'Spread (forked lightning)',
        de: 'Verteilen (Gabelblitz)',
        fr: 'Écartez-vous (Éclair ramifié)',
        ja: '散会 (自分にAOE)',
        cn: '分散（闪电点名）',
        ko: '산개'
      }
    }
  }, {
    id: 'ZeromusEx The Dark Beckons Stack Collect',
    type: 'HeadMarker',
    netRegex: {
      id: headmarkerMap.stack
    },
    condition: data => data.phase === 'one',
    run: (data, matches) => data.bigBangStackPlayer = matches.target
  }, {
    id: 'ZeromusEx The Dark Beckons Stack',
    type: 'HeadMarker',
    netRegex: {
      id: [headmarkerMap.stack, headmarkerMap.tankBuster]
    },
    condition: data => {
      if (data.phase !== 'one') return false;
      return data.bigBangStackPlayer !== undefined;
    },
    // If we have both busters, run immediately otherwise wait a reasonable amount of time
    // for them to show up.
    delaySeconds: data => data.busterPlayers.length === 2 ? 0 : 1,
    suppressSeconds: 10,
    alertText: (data, matches, output) => {
      if (data.busterPlayers.includes(data.me)) return;
      if (data.forkedPlayers.includes(data.me)) return;
      if (data.me === matches.target) return output.stackOnYou();
      return output.stackOnTarget({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOnTarget: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'ZeromusEx Acceleration Bomb',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'A61'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 3,
    response: responses/* Responses.stopEverything */.n3.stopEverything()
  }, {
    id: 'ZeromusEx Tether Bait',
    type: 'HeadMarker',
    netRegex: {
      id: headmarkerMap.tether,
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Group middle for tethers',
        de: 'Gruppe in die Mitte für Verbindungen',
        fr: 'Groupe au centre pour les liens',
        ja: '真ん中で線連結を待つ',
        cn: '集合等待连线',
        ko: '중앙에 모여서 사슬 연결 기다리기'
      }
    }
  }, {
    id: 'ZeromusEx Tether',
    type: 'Tether',
    netRegex: {
      id: ['00A3', '010B']
    },
    condition: (data, matches) => data.me === matches.target || data.me === matches.source,
    suppressSeconds: 10,
    alertText: (data, matches, output) => {
      const partner = matches.source === data.me ? matches.target : matches.source;
      return output.breakTether({
        partner: data.party.member(partner)
      });
    },
    outputStrings: {
      breakTether: {
        en: 'Break tether (w/ ${partner})',
        de: 'Verbindung brechen (mit ${partner})',
        fr: 'Cassez le lien (avec ${partner})',
        ja: '線切る (${partner})',
        cn: '拉断连线 (和 ${partner})',
        ko: '선 끊기 (+ ${partner})'
      }
    }
  }, {
    id: 'ZeromusEx Black Hole Tracker',
    type: 'HeadMarker',
    netRegex: {
      id: headmarkerMap.blackHole
    },
    run: (data, matches) => data.blackHolePlayer = matches.target
  }, {
    id: 'ZeromusEx Fractured Eventide NE Safe',
    type: 'StartsUsing',
    netRegex: {
      id: '8B3C',
      source: 'Zeromus',
      capture: false
    },
    alarmText: (data, _matches, output) => {
      if (data.me === data.blackHolePlayer) return output.blackHole();
    },
    alertText: (_data, _matches, output) => output.northeast(),
    run: data => delete data.blackHolePlayer,
    outputStrings: {
      northeast: outputs/* default.northeast */.Z.northeast,
      blackHole: {
        en: 'East Black Hole on Wall',
        de: 'Schwarzes Loch an die östliche Wand',
        fr: 'Trou noir Est sur Mur',
        ja: '右にブラックホール',
        cn: '右上放置黑洞',
        ko: '오른쪽 구석에 블랙홀 놓기'
      }
    }
  }, {
    id: 'ZeromusEx Fractured Eventide NW Safe',
    type: 'StartsUsing',
    netRegex: {
      id: '8B3D',
      source: 'Zeromus',
      capture: false
    },
    alarmText: (data, _matches, output) => {
      if (data.me === data.blackHolePlayer) return output.blackHole();
    },
    alertText: (_data, _matches, output) => output.northwest(),
    run: data => delete data.blackHolePlayer,
    outputStrings: {
      northwest: outputs/* default.northwest */.Z.northwest,
      blackHole: {
        en: 'West Black Hole on Wall',
        de: 'Schwarzes Loch an die westliche Wand',
        fr: 'Trou noir Ouest sur Mur',
        ja: '左にブラックホール',
        cn: '左上放置黑洞',
        ko: '왼쪽 구석에 블랙홀 놓기'
      }
    }
  }, {
    id: 'ZeromusEx Big Crunch',
    type: 'StartsUsing',
    netRegex: {
      id: '8B4D',
      source: 'Zeromus',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'ZeromusEx Sparking Flare Tower',
    type: 'StartsUsing',
    netRegex: {
      id: '8B5E',
      source: 'Zeromus',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.flareMechanic = 'spread',
    outputStrings: {
      text: {
        en: 'Get Towers => Spread',
        de: 'Türme nehmen => Verteilen',
        fr: 'Prenez les tours -> Écartez-vous',
        ja: '塔踏み => 散会',
        cn: '踩塔 => 分散',
        ko: '기둥 밟기 => 산개'
      }
    }
  }, {
    id: 'ZeromusEx Branding Flare Tower',
    type: 'StartsUsing',
    netRegex: {
      id: '8B5F',
      source: 'Zeromus',
      capture: false
    },
    durationSeconds: 6,
    alertText: (_data, _matches, output) => output.text(),
    run: data => data.flareMechanic = 'stack',
    outputStrings: {
      text: {
        en: 'Get Towers => Partner Stacks',
        de: 'Türme nehmen => mit Partner sammeln',
        fr: 'Prenez les tours -> Partenaires',
        ja: '塔踏み => ペア',
        cn: '踩塔 => 分摊',
        ko: '기둥 밟기 => 2인 쉐어'
      }
    }
  }, {
    id: 'ZeromusEx Flare Mechanic With Nox',
    type: 'HeadMarker',
    netRegex: {
      id: headmarkerMap.nox
    },
    condition: (data, matches) => {
      data.noxPlayers.push(matches.target);
      return data.me === matches.target;
    },
    alarmText: (data, _matches, output) => {
      if (data.flareMechanic === 'stack') return output.stackWithNox();
      if (data.flareMechanic === 'spread') return output.spreadWithNox();
    },
    outputStrings: {
      stackWithNox: {
        en: 'Partner Stack + Chasing Nox',
        de: 'Mit Partner Sammeln + verfolgendes Nox',
        fr: 'Package partenaires + Nox',
        ja: 'ペア + ついてくるAOE',
        cn: '分摊 + 步进点名',
        ko: '2인 쉐어 + 따라오는 장판'
      },
      spreadWithNox: {
        en: 'Spread + Chasing Nox',
        de: 'Verteilen + verfolgendes Nox',
        fr: 'Écartez-vous + Nox',
        ja: '散会 + ついてくるAOE',
        cn: '分散 + 步进点名',
        ko: '산개 + 따라오는 장판'
      }
    }
  }, {
    id: 'ZeromusEx Flare Mechanic No Nox',
    type: 'HeadMarker',
    netRegex: {
      id: headmarkerMap.nox,
      capture: false
    },
    delaySeconds: data => data.noxPlayers.length === 2 ? 0 : 0.5,
    suppressSeconds: 5,
    alertText: (data, _matches, output) => {
      if (data.noxPlayers.includes(data.me)) return;
      if (data.flareMechanic === 'stack') return output.stack();
      if (data.flareMechanic === 'spread') return output.spread();
    },
    outputStrings: {
      stack: {
        en: 'Partner Stack',
        de: 'mit Partner sammeln',
        fr: 'Package avec partenaire',
        ja: 'ペア',
        cn: '分摊',
        ko: '2인 쉐어'
      },
      spread: {
        en: 'Spread',
        de: 'Verteilen',
        fr: 'Écartez-vous',
        ja: '散会',
        cn: '分散',
        ko: '산개'
      }
    }
  }, {
    id: 'ZeromusEx Rend the Rift',
    type: 'StartsUsing',
    netRegex: {
      id: '8C0D',
      source: 'Zeromus',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe(),
    run: data => data.phase = 'two'
  }, {
    id: 'ZeromusEx Nostalgia',
    type: 'Ability',
    // Call this on the ability not the cast so 10 second mits last.
    netRegex: {
      id: '8B6B',
      source: 'Zeromus',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'ZeromusEx Flow of the Abyss',
    type: 'MapEffect',
    netRegex: {
      flags: '00020001',
      location: ['02', '03', '04']
    },
    infoText: (data, matches, output) => {
      const flowMap = {
        '02': 'north',
        '03': 'middle',
        '04': 'south'
      };
      data.flowLocation = flowMap[matches.location];
      if (data.flowLocation === 'north') return output.north();
      if (data.flowLocation === 'middle') return output.middle();
      if (data.flowLocation === 'south') return output.south();
    },
    outputStrings: {
      north: {
        en: 'Out of North',
        de: 'Weg vom Norden',
        fr: 'En dehors du Nord',
        ja: '北危険',
        cn: '远离北边',
        ko: '북쪽 피하기'
      },
      middle: {
        en: 'Out of Middle',
        de: 'Weg von der Mitte',
        fr: 'En dehors du milieu',
        ja: '中央危険',
        cn: '远离中间',
        ko: '중앙 피하기'
      },
      south: {
        en: 'Out of South',
        de: 'Weg vom Süden',
        fr: 'En dehors du Sud',
        ja: '南危険',
        cn: '远离南边',
        ko: '남쪽 피하기'
      }
    }
  }, {
    id: 'ZeromusEx Akh Rhai',
    type: 'HeadMarker',
    netRegex: {
      id: headmarkerMap.akhRhaiSpread
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (data, _matches, output) => {
      if (data.flowLocation === undefined) return output.spread();
      return output[`${data.flowLocation}Spread`]();
    },
    run: data => delete data.flowLocation,
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread,
      northSpread: {
        en: 'Spread Middle/South',
        de: 'Verteilen Mitte/Süden',
        fr: 'Écartez-vous Milieu/Sud',
        ja: '中央・南で散会',
        cn: '中间/南边 分散',
        ko: '중앙/남쪽으로 산개'
      },
      middleSpread: {
        en: 'Spread North/South',
        de: 'Verteilen Norden/Süden',
        fr: 'Écartez-vous Nord/Sud',
        ja: '北・南で散会',
        cn: '北边/南边 分散',
        ko: '북쪽/남쪽으로 산개'
      },
      southSpread: {
        en: 'Spread North/Middle',
        de: 'Verteilen Norden/Mitte',
        fr: 'Écartez-vous Nord/Milieu',
        ja: '北・中央で散会',
        cn: '北边/中间 分散',
        ko: '북쪽/중앙으로 산개'
      }
    }
  }, {
    id: 'ZeromusEx Akh Rhai Followup',
    type: 'Ability',
    netRegex: {
      id: '8B74',
      source: 'Zeromus',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'ZeromusEx Umbral Prism Enumeration',
    type: 'HeadMarker',
    netRegex: {
      id: headmarkerMap.enums,
      capture: false
    },
    suppressSeconds: 2,
    alertText: (data, _matches, output) => {
      if (data.flowLocation === undefined) return output.enumeration();
      return output[`${data.flowLocation}Enumeration`]();
    },
    run: data => delete data.flowLocation,
    outputStrings: {
      enumeration: {
        en: 'Enumeration',
        de: 'Enumeration',
        fr: 'Énumération',
        ja: 'エアーバンプ',
        cn: '蓝圈分摊',
        ko: '2인 장판'
      },
      northEnumeration: {
        en: 'Enumeration Middle/South',
        de: 'Enumeration Mitte/Süden',
        fr: 'Énumération Milieu/Sud',
        ja: '中央・南でエアーバンプ',
        cn: '中间/南边 蓝圈分摊',
        ko: '2인 장판 중앙/남쪽'
      },
      middleEnumeration: {
        en: 'Enumeration North/South',
        de: 'Enumeration Norden/Süden',
        fr: 'Énumération Nord/Sud',
        ja: '北・南でエアーバンプ',
        cn: '北边/南边 蓝圈分摊',
        ko: '2인 장판 북쪽/남쪽'
      },
      southEnumeration: {
        en: 'Enumeration North/Middle',
        de: 'Enumeration Norden/Mitte',
        fr: 'Énumération Nord/Milieu',
        ja: '北・中央でエアーバンプ',
        cn: '北边/中间 蓝圈分摊',
        ko: '2인 장판 북쪽/중앙'
      }
    }
  }, {
    id: 'ZeromusEx Umbral Rays Stack',
    type: 'HeadMarker',
    netRegex: {
      id: headmarkerMap.stack,
      capture: false
    },
    condition: data => data.phase === 'two',
    alertText: (data, _matches, output) => {
      if (data.flowLocation === undefined) return output.stack();
      return output[`${data.flowLocation}Stack`]();
    },
    run: data => delete data.flowLocation,
    outputStrings: {
      stack: outputs/* default.stackMarker */.Z.stackMarker,
      northStack: {
        en: 'Stack Middle',
        de: 'Mittig sammeln',
        fr: 'Packez-vous au milieu',
        ja: '中央で頭割り',
        cn: '中间分摊',
        ko: '중앙에서 쉐어'
      },
      middleStack: {
        en: 'Stack North',
        de: 'Nördlich sammeln',
        fr: 'Packez-vous au Nord',
        ja: '北で頭割り',
        cn: '北边分摊',
        ko: '북쪽에서 쉐어'
      },
      southStack: {
        en: 'Stack North/Middle',
        de: 'Nördlich/Mittig sammeln',
        fr: 'Packez-vous au Nord/milieu',
        ja: '北・中央で頭割り',
        cn: '北边/中间 分摊',
        ko: '북쪽/중앙에서 쉐어'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Branding Flare/Sparking Flare': 'Branding/Sparking Flare'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Comet': 'Komet',
      'Toxic Bubble': 'Giftblase',
      'Zeromus': 'Zeromus'
    },
    'replaceText': {
      '--spread--': '--verteilen--',
      '--towers--': '--Türme--',
      'Abyssal Echoes': 'Abyssal-Echos',
      'Abyssal Nox': 'Abyssal-Nox',
      'Akh Rhai': 'Akh Rhai',
      'Big Bang': 'Großer Knall',
      'Big Crunch': 'Großer Quetscher',
      'Black Hole': 'Schwarzes Loch',
      'Branding Flare': 'Flare-Brand',
      'Burst': 'Kosmos-Splitter',
      'Bury': 'Impakt',
      'Chasmic Nails': 'Abyssal-Nagel',
      'Dark Matter': 'Dunkelmaterie',
      'Dimensional Surge': 'Dimensionsschwall',
      'Explosion': 'Explosion',
      '(?<! )Flare': 'Flare',
      'Flow of the Abyss': 'Abyssaler Strom',
      'Forked Lightning': 'Gabelblitz',
      'Fractured Eventide': 'Abendglut',
      'Meteor Impact': 'Meteoreinschlag',
      'Miasmic Blast': 'Miasma-Detonation',
      'Nostalgia': 'Heimweh',
      'Primal Roar': 'Lautes Gebrüll',
      'Prominence Spine': 'Ossale Protuberanz',
      'Rend the Rift': 'Dimensionsstörung',
      '(?<! )Roar': 'Brüllen',
      'Sable Thread': 'Pechschwarzer Pfad',
      'Sparking Flare': 'Flare-Funken',
      'The Dark Beckons': 'Fressende Finsternis: Last',
      'The Dark Divides': 'Fressende Finsternis: Zerschmetterung',
      'Umbral Prism': 'Umbrales Prisma',
      'Umbral Rays': 'Pfad der Dunkelheit',
      'Visceral Whirl': 'Viszerale Schürfwunden',
      'Void Bio': 'Nichts-Bio',
      'Void Meteor': 'Nichts-Meteo',
      'the Dark Beckons': 'Fressende Finsternis: Last',
      'the Dark Binds': 'Fressende Finsternis: Kette',
      'the Dark Divides': 'Fressende Finsternis: Zerschmetterung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Comet': 'comète',
      'Toxic Bubble': 'bulle empoisonnée',
      'Zeromus': 'Zeromus'
    },
    'replaceText': {
      '--spread--': '--Écartement--',
      '--towers--': '--Tours--',
      'Abyssal Echoes': 'Écho abyssal',
      'Abyssal Nox': 'Nox abyssal',
      'Akh Rhai': 'Akh Rhai',
      'Big Bang': 'Big bang',
      'Big Crunch': 'Big crunch',
      'Black Hole': 'Trou noir',
      'Branding Flare': 'Marque de brasier',
      'Burst': 'Éclatement',
      'Bury': 'Impact',
      'Chasmic Nails': 'Clous abyssaux',
      'Dark Matter': 'Matière sombre',
      'Dimensional Surge': 'Déferlante dimensionnelle',
      'Explosion': 'Explosion',
      '(?<! )Flare': 'Brasier',
      'Flow of the Abyss': 'Flot abyssal',
      'Forked Lightning': 'Éclair ramifié',
      'Fractured Eventide': 'Éclat crépusculaire',
      'Meteor Impact': 'Impact de météore',
      'Miasmic Blast': 'Explosion miasmatique',
      'Nostalgia': 'Nostalgie',
      'Primal Roar': 'Rugissement furieux',
      'Prominence Spine': 'Évidence ossuaire',
      'Rend the Rift': 'Déchirure dimensionnelle',
      '(?<! )Roar': 'Rugissement',
      'Sable Thread': 'Rayon sombre',
      'Sparking Flare': 'Étincelle de brasier',
      'The Dark Beckons': 'Ténèbres rongeuses : Gravité',
      'The Dark Divides': 'Ténèbres rongeuses : Pulvérisation',
      'Umbral Prism': 'Déluge de Ténèbres',
      'Umbral Rays': 'Voie de ténèbres',
      'Visceral Whirl': 'Écorchure viscérale',
      'Void Bio': 'Bactéries du néant',
      'Void Meteor': 'Météores du néant',
      'the Dark Beckons': 'Ténèbres rongeuses : Gravité',
      'the Dark Binds': 'Ténèbres rongeuses : Chaînes',
      'the Dark Divides': 'Ténèbres rongeuses : Pulvérisation'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Comet': 'コメット',
      'Toxic Bubble': 'ポイズナスバブル',
      'Zeromus': 'ゼロムス'
    },
    'replaceText': {
      '--spread--': '--散会--',
      '--towers--': '--塔--',
      'Abyssal Echoes': 'アビサルエコー',
      'Abyssal Nox': 'アビサルノックス',
      'Akh Rhai': 'アク・ラーイ',
      'Big Bang': 'ビッグバーン',
      'Big Crunch': 'ビッグクランチ',
      'Black Hole': 'ブラックホール',
      'Branding Flare': 'フレアブランド',
      'Burst': '飛散',
      'Bury': '衝撃',
      'Chasmic Nails': 'アビサルネイル',
      'Dark Matter': 'ダークマター',
      'Dimensional Surge': 'ディメンションサージ',
      'Explosion': '爆発',
      '(?<! )Flare': 'フレア',
      'Flow of the Abyss': 'アビサルフロウ',
      'Forked Lightning': 'フォークライトニング',
      'Fractured Eventide': '黒竜閃',
      'Meteor Impact': 'メテオインパクト',
      'Miasmic Blast': '瘴気爆発',
      'Nostalgia': '望郷',
      'Primal Roar': '大咆哮',
      'Prominence Spine': 'プロミネンススパイン',
      'Rend the Rift': '次元干渉',
      '(?<! )Roar': '咆哮',
      'Sable Thread': '漆黒の熱線',
      'Sparking Flare': 'フレアスパーク',
      'The Dark Beckons': '闇の侵食：重',
      'The Dark Divides': '闇の侵食：砕',
      'Umbral Prism': '闇の重波動',
      'Umbral Rays': '闇の波動',
      'Visceral Whirl': 'ヴィセラルワール',
      'Void Bio': 'ヴォイド・バイオ',
      'Void Meteor': 'ヴォイド・メテオ',
      'the Dark Beckons': '闇の侵食：重',
      'the Dark Binds': '闇の侵食：鎖',
      'the Dark Divides': '闇の侵食：砕'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Comet': '彗星',
      'Toxic Bubble': '有毒气泡',
      'Zeromus': '泽罗姆斯'
    },
    'replaceText': {
      '--spread--': '--分散--',
      '--towers--': '--塔--',
      'Abyssal Echoes': '深渊回声',
      'Abyssal Nox': '深渊之夜',
      'Akh Rhai': '天光轮回',
      'Big Bang': '宇宙大爆炸',
      'Big Crunch': '宇宙大挤压',
      'Black Hole': '黑洞',
      'Branding Flare': '核爆火印',
      'Burst': '飞散',
      'Bury': '塌方',
      'Chasmic Nails': '深渊连爪',
      'Dark Matter': '暗物质',
      'Dimensional Surge': '次元涌动',
      'Explosion': '爆炸',
      '(?<! )Flare': '核爆',
      'Flow of the Abyss': '深渊激流',
      'Forked Lightning': '叉形闪电',
      'Fractured Eventide': '黑龙闪',
      'Meteor Impact': '陨石冲击',
      'Miasmic Blast': '瘴气爆发',
      'Nostalgia': '望乡',
      'Primal Roar': '大咆哮',
      'Prominence Spine': '日珥焰棘',
      'Rend the Rift': '次元干涉',
      '(?<! )Roar': '咆哮',
      'Sable Thread': '漆黑射线',
      'Sparking Flare': '核爆火花',
      'The Dark Beckons': '黑暗侵蚀：重击',
      'The Dark Divides': '黑暗侵蚀：飞散',
      'Umbral Prism': '暗之重波动',
      'Umbral Rays': '暗之波动',
      'Visceral Whirl': '旋骨利爪',
      'Void Bio': '虚空毒菌',
      'Void Meteor': '虚空陨石',
      'the Dark Beckons': '黑暗侵蚀：重击',
      'the Dark Binds': '黑暗侵蚀：锁链',
      'the Dark Divides': '黑暗侵蚀：飞散'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Comet': '혜성',
      'Toxic Bubble': '독성 거품',
      'Zeromus': '제로무스'
    },
    'replaceText': {
      '--spread--': '--산개--',
      '--towers--': '--기둥--',
      'Abyssal Echoes': '심연의 메아리',
      'Abyssal Nox': '심연의 암야',
      'Akh Rhai': '아크 라이',
      'Big Bang': '빅뱅',
      'Big Crunch': '빅 크런치',
      'Black Hole': '블랙홀',
      'Branding Flare': '플레어 횃불',
      'Burst': '산산조각',
      'Bury': '충격',
      'Chasmic Nails': '심연의 손톱',
      'Dark Matter': '암흑물질',
      'Dimensional Surge': '차원 쇄도',
      'Explosion': '폭발',
      '(?<! )Flare': '플레어',
      'Flow of the Abyss': '심연의 흐름',
      'Forked Lightning': '갈래 번개',
      'Fractured Eventide': '흑룡섬',
      'Meteor Impact': '운석 낙하',
      'Miasmic Blast': '독기 폭발',
      'Nostalgia': '망향',
      'Primal Roar': '대포효',
      'Prominence Spine': '홍염의 가시',
      'Rend the Rift': '차원 간섭',
      '(?<! )Roar': '포효',
      'Sable Thread': '칠흑의 열선',
      'Sparking Flare': '플레어 불꽃',
      'The Dark Beckons': '어둠의 침식: 집중',
      'The Dark Divides': '어둠의 침식: 분산',
      'Umbral Prism': '어둠의 겹파동',
      'Umbral Rays': '어둠의 파동',
      'Visceral Whirl': '본능의 상흔',
      'Void Bio': '보이드 바이오',
      'Void Meteor': '보이드 메테오',
      'the Dark Beckons': '어둠의 침식: 집중',
      'the Dark Binds': '어둠의 침식: 사슬',
      'the Dark Divides': '어둠의 침식: 분산'
    }
  }]
};
/* harmony default export */ const zeromus_ex = (zeromus_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/zeromus-ex.txt
const trial_zeromus_ex_namespaceObject = "### THE ABYSSAL FRACTURE (EXTREME)\r\n# ZoneId: 1169\r\n\r\n# -p 8B3F:11.1 8C0D:1006\r\n# -ii 8CB9 8B55 8B5B 8B5C 8C49 8B40 8B41 8D2B 8AEF 8B3B 8B47 8B48 8CF8 8B60 8B62 8BB6 8B44 8B45 8B4E 8B3E 8BB2 8D31 8D32 8D24 8D2A 8D34 8B67 8B7E 8B75 8B27 8B28 8B29 8B2A 8B2B 8B79 8B7A 8B7B 8B7C 8B7D 8B4E\r\n\r\n# Optional extra ignores used for duration timings\r\n# -ii 8B39 8B3A 8B84\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Phase 1\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n6.1 \"--sync--\" StartsUsing { id: \"8B3F\", source: \"Zeromus\" } window 10,10\r\n11.1 \"Abyssal Nox\" Ability { id: \"8B3F\", source: \"Zeromus\" }\r\n27.1 \"Abyssal Echoes 1\" Ability { id: \"8B42\", source: \"Zeromus\" }\r\n32.1 \"Abyssal Echoes 2\" Ability { id: \"8B42\", source: \"Zeromus\" }\r\n42.1 \"Sable Thread x6\" Ability { id: \"8B38\", source: \"Zeromus\" } duration 6.9\r\n#43.8 \"Sable Thread\" #Ability { id: \"8B39\", source: \"Zeromus\" }\r\n#45.1 \"Sable Thread\" #Ability { id: \"8B39\", source: \"Zeromus\" }\r\n#46.4 \"Sable Thread\" #Ability { id: \"8B39\", source: \"Zeromus\" }\r\n#47.7 \"Sable Thread\" #Ability { id: \"8B39\", source: \"Zeromus\" }\r\n49.0 \"--sync--\" Ability { id: \"8B3A\", source: \"Zeromus\" }\r\n\r\n61.7 \"Dark Matter x3\" Ability { id: \"8B83\", source: \"Zeromus\" } duration 4.1\r\n\r\n78.8 \"Visceral Whirl\" Ability { id: \"8B4[36]\", source: \"Zeromus\" }\r\n87.8 \"Miasmic Blast\" Ability { id: \"8B49\", source: \"Zeromus\" }\r\n\r\n101.8 \"Flare\" Ability { id: \"8B5D\", source: \"Zeromus\" }\r\n109.9 \"Prominence Spine\" Ability { id: \"8B63\", source: \"Zeromus\" }\r\n119.9 \"Void Bio\" Ability { id: \"8B66\", source: \"Zeromus\" }\r\n134.1 \"Visceral Whirl\" Ability { id: \"8B4[36]\", source: \"Zeromus\" }\r\n143.1 \"Miasmic Blast\" Ability { id: \"8B49\", source: \"Zeromus\" }\r\n\r\n148.1 \"--sync--\" StartsUsing { id: \"8B4C\", source: \"Zeromus\" } window 10,10\r\n153.1 \"--spread--\" #Ability { id: \"8BDE\", source: \"Zeromus\" }\r\n158.1 \"Big Bang\" Ability { id: \"8B4C\", source: \"Zeromus\" }\r\n\r\n173.1 \"Void Meteor\" Ability { id: \"8B57\", source: \"Zeromus\" }\r\n186.3 \"--sync--\" Ability { id: \"8B56\", source: \"Zeromus\" }\r\n188.3 \"Meteor Impact 1\" #Ability { id: \"8B58\", source: \"Comet\" }\r\n194.8 \"Meteor Impact 2\" #Ability { id: \"8B58\", source: \"Comet\" }\r\n202.0 \"Explosion\" Ability { id: \"8D34\", source: \"Comet\" }\r\n\r\n214.4 \"Visceral Whirl\" Ability { id: \"8B4[36]\", source: \"Zeromus\" }\r\n223.5 \"Miasmic Blast\" Ability { id: \"8B49\", source: \"Zeromus\" }\r\n227.1 \"The Dark Divides\" Ability { id: \"8B52\", source: \"Zeromus\" }\r\n233.5 \"Dark Matter x3\" Ability { id: \"8B83\", source: \"Zeromus\" } duration 4.1\r\n234.1 \"The Dark Beckons\" Ability { id: \"8D3A\", source: \"Zeromus\" }\r\n234.1 \"Forked Lightning\" Ability { id: \"8B54\", source: \"Zeromus\" }\r\n\r\n247.7 \"Black Hole\" Ability { id: \"8B69\", source: \"Zeromus\" }\r\n259.8 \"Fractured Eventide\" Ability { id: \"8B3[CD]\", source: \"Zeromus\" }\r\n\r\n278.0 \"--sync--\" StartsUsing { id: \"8B4D\", source: \"Zeromus\" } window 10,10\r\n282.1 \"--spread--\" #Ability { id: \"8D32\", source: \"Zeromus\" }\r\n288.0 \"Big Crunch\" Ability { id: \"8B4D\", source: \"Zeromus\" }\r\n\r\n303.2 \"Abyssal Nox\" Ability { id: \"8B3F\", source: \"Zeromus\" }\r\n319.2 \"Abyssal Echoes 1\" Ability { id: \"8B42\", source: \"Zeromus\" }\r\n324.2 \"Abyssal Echoes 2\" Ability { id: \"8B42\", source: \"Zeromus\" }\r\n329.2 \"Sable Thread x7\" Ability { id: \"8B38\", source: \"Zeromus\" } duration 8.2\r\n#330.9 \"Sable Thread\" #Ability { id: \"8B39\", source: \"Zeromus\" }\r\n#332.2 \"Sable Thread\" #Ability { id: \"8B39\", source: \"Zeromus\" }\r\n#333.5 \"Sable Thread\" #Ability { id: \"8B39\", source: \"Zeromus\" }\r\n#334.8 \"Sable Thread\" #Ability { id: \"8B39\", source: \"Zeromus\" }\r\n#336.1 \"Sable Thread\" #Ability { id: \"8B39\", source: \"Zeromus\" }\r\n337.4 \"--sync--\" Ability { id: \"8B3A\", source: \"Zeromus\" }\r\n\r\n353.2 \"--towers--\" Ability { id: \"8B5[EF]\", source: \"Zeromus\" }\r\n361.2 \"Branding Flare/Sparking Flare\" Ability { id: \"8B6[45]\", source: \"Zeromus\" }\r\n361.2 \"Prominence Spine\" Ability { id: \"8B63\", source: \"Zeromus\" }\r\n380.2 \"Void Bio\" Ability { id: \"8B66\", source: \"Zeromus\" }\r\n394.4 \"Visceral Whirl\" Ability { id: \"8B4[36]\", source: \"Zeromus\" }\r\n403.4 \"Miasmic Blast\" Ability { id: \"8B49\", source: \"Zeromus\" }\r\n414.4 \"Dark Matter x3\" Ability { id: \"8B83\", source: \"Zeromus\" } duration 4.1\r\n\r\n430.6 \"--towers--\" Ability { id: \"8B5[EF]\", source: \"Zeromus\" }\r\n438.6 \"Branding Flare/Sparking Flare\" Ability { id: \"8B6[45]\", source: \"Zeromus\" }\r\n438.6 \"Prominence Spine\" Ability { id: \"8B63\", source: \"Zeromus\" }\r\n467.7 \"Abyssal Nox\" Ability { id: \"8B3F\", source: \"Zeromus\" }\r\n483.7 \"Abyssal Echoes 1\" Ability { id: \"8B42\", source: \"Zeromus\" }\r\n488.7 \"Abyssal Echoes 2\" Ability { id: \"8B42\", source: \"Zeromus\" }\r\n493.7 \"Sable Thread x7\" Ability { id: \"8B38\", source: \"Zeromus\" } duration 8.2\r\n#495.4 \"Sable Thread\" #Ability { id: \"8B39\", source: \"Zeromus\" }\r\n#496.7 \"Sable Thread\" #Ability { id: \"8B39\", source: \"Zeromus\" }\r\n#498.0 \"Sable Thread\" #Ability { id: \"8B39\", source: \"Zeromus\" }\r\n#499.3 \"Sable Thread\" #Ability { id: \"8B39\", source: \"Zeromus\" }\r\n#500.6 \"Sable Thread\" #Ability { id: \"8B39\", source: \"Zeromus\" }\r\n501.9 \"--sync--\" Ability { id: \"8B3A\", source: \"Zeromus\" }\r\n\r\n517.7 \"--towers--\" Ability { id: \"8B5[EF]\", source: \"Zeromus\" }\r\n525.7 \"Branding Flare/Sparking Flare\" Ability { id: \"8B6[45]\", source: \"Zeromus\" }\r\n525.7 \"Prominence Spine\" Ability { id: \"8B63\", source: \"Zeromus\" }\r\n544.8 \"Void Bio\" Ability { id: \"8B66\", source: \"Zeromus\" }\r\n558.9 \"Visceral Whirl\" Ability { id: \"8B4[36]\", source: \"Zeromus\" }\r\n567.9 \"Miasmic Blast\" Ability { id: \"8B49\", source: \"Zeromus\" }\r\n578.9 \"Dark Matter x3\" Ability { id: \"8B83\", source: \"Zeromus\" } duration 4.1\r\n\r\n595.0 \"--towers--\" Ability { id: \"8B5[EF]\", source: \"Zeromus\" }\r\n603.0 \"Branding Flare/Sparking Flare\" Ability { id: \"8B6[45]\", source: \"Zeromus\" }\r\n603.0 \"Prominence Spine\" Ability { id: \"8B63\", source: \"Zeromus\" }\r\n632.1 \"Abyssal Nox\" Ability { id: \"8B3F\", source: \"Zeromus\" }\r\n648.1 \"Abyssal Echoes 1\" Ability { id: \"8B42\", source: \"Zeromus\" }\r\n653.1 \"Abyssal Echoes 2\" Ability { id: \"8B42\", source: \"Zeromus\" }\r\n\r\n# Note that this enrage can happen at any time in P2, because it always happens at roughly 11m into the pull regardless of when you hit P2\r\n658.2 \"--sync--\" StartsUsing { id: \"8C1E\", source: \"Zeromus\" } window 1000,1000\r\n668.2 \"Big Bang (Enrage)\" Ability { id: \"8C1E\", source: \"Zeromus\" }\r\n\r\n\r\n# Phase 2: ~25% push\r\n1000.0 \"--sync--\" StartsUsing { id: \"8C0D\", source: \"Zeromus\" } window 1000,0\r\n1006.0 \"Rend the Rift\" Ability { id: \"8C0D\", source: \"Zeromus\" }\r\n1023.1 \"Nostalgia\" Ability { id: \"8B6B\", source: \"Zeromus\" }\r\n1023.9 \"Bury 1\" Ability { id: \"8B6D\", source: \"Zeromus\" }\r\n1024.9 \"Bury 2\" Ability { id: \"8B6E\", source: \"Zeromus\" }\r\n1025.9 \"Bury 3\" Ability { id: \"8B6F\", source: \"Zeromus\" }\r\n1026.9 \"Bury 4\" Ability { id: \"8B70\", source: \"Zeromus\" }\r\n1028.9 \"Roar 5\" Ability { id: \"8B71\", source: \"Zeromus\" }\r\n1029.9 \"Roar 6\" Ability { id: \"8B72\", source: \"Zeromus\" }\r\n1032.9 \"Primal Roar 7\" Ability { id: \"8B73\", source: \"Zeromus\" }\r\n\r\n1047.2 \"Flow of the Abyss\" Ability { id: \"8CFA\", source: \"Zeromus\" }\r\n1048.3 \"Akh Rhai/Umbral Prism/Umbral Rays\" Ability { id: \"8B7[467]\", source: \"Zeromus\" }\r\n1049.2 \"Dimensional Surge\" Ability { id: \"8B82\", source: \"Zeromus\" }\r\n1060.3 \"Chasmic Nails\" Ability { id: \"8B78\", source: \"Zeromus\" }\r\n1062.3 \"Dimensional Surge\" Ability { id: \"8B82\", source: \"Zeromus\" }\r\n\r\n1081.4 \"Flow of the Abyss\" Ability { id: \"8CFA\", source: \"Zeromus\" }\r\n1082.5 \"Akh Rhai/Umbral Prism/Umbral Rays\" Ability { id: \"8B7[467]\", source: \"Zeromus\" }\r\n1083.4 \"Dimensional Surge\" Ability { id: \"8B82\", source: \"Zeromus\" }\r\n1094.5 \"Chasmic Nails\" Ability { id: \"8B78\", source: \"Zeromus\" }\r\n1096.5 \"Dimensional Surge\" Ability { id: \"8B82\", source: \"Zeromus\" }\r\n\r\n# Is this the loop?\r\n1114.7 \"Nostalgia\" Ability { id: \"8B6B\", source: \"Zeromus\" } window 30,30 forcejump 1023.1\r\n\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 8AEF --sync-- unnamed ability on line stack target for Sable Thread\r\n# 8B27 --sync-- Chasmic Nail preview 1\r\n# 8B28 --sync-- Chasmic Nail preview 2\r\n# 8B29 --sync-- Chasmic Nail preview 3\r\n# 8B2A --sync-- Chasmic Nail preview 4\r\n# 8B2B --sync-- Chasmic Nail preview 5\r\n# 8B38 Sable Thread self-targeted cast for line stack\r\n# 8B39 Sable Thread self-targeted ability before each non-first/non-last hit\r\n# 8B3A Sable Thread self-targeted ability for final hit\r\n# 8B3B Sable Thread line stack share damage\r\n# 8B3C Fractured Eventide cast and self-targeted ability (NE safe)\r\n# 8B3D Fractured Eventide cast and self-targeted ability (NW safe)\r\n# 8B3E Fractured Eventide initial damage from Eventide line (both)\r\n# 8B3F Abyssal Nox cast and set-to-1 ability\r\n# 8B40 --sync-- unnamed unknown ability before Abyssal Echoes\r\n# 8B41 --sync-- unnamed unknown ability before Abyssal Echoes\r\n# 8B42 Abyssal Echoes cast and damage for lines->circle light up on floor\r\n# 8B43 Visceral Whirl cast and self-targeted claw swipes NE/SW safe\r\n# 8B44 Visceral Whirl cast and damage paired with 8B43 version\r\n# 8B45 Visceral Whirl cast and damage paired with 8B43 version\r\n# 8B46 Visceral Whirl cast and self-targeted claw swipes NW/SE safe\r\n# 8B47 Visceral Whirl cast and damage paired with 8B46 version\r\n# 8B48 Visceral Whirl cast and damage paired with 8B46 version\r\n# 8B49 Miasmic Blast cast and damage for 3 X's after Visceral Whirl\r\n# 8B4C Big Bang cast and damage on players to give debuffs while 8B4E puddles appear\r\n# 8B4D Big Crunch cast and damage on players while 8D31 puddles appear\r\n# 8B4E Big Bang ground aoe damage during 8BDE\r\n# 8B52 The Dark Divides spread damage after Big Bang\r\n# 8B54 Forked Lightning damage (on others) from a player's Forked Lightning debuff, the player is not hit\r\n# 8B55 The Dark Binds damage from tether failures\r\n# 8B5B Massive Explosion raidwide damage from colliding meteors from Comet\r\n# 8B56 Meteor Impact self-targeted cast for meteor tethers\r\n# 8B57 Void Meteor cast and self-targeted ability to summon meteors for prox damage\r\n# 8B58 Meteor Impact damage from 8B56 meteor tethers (both sets of meteors)\r\n# 8B5C Meteor Impact cast and proximity damage from Comet\r\n# 8B5D Flare self-targeted tower light party share\r\n# 8B5E Sparking Flare self-targeted cast for tower before Sparking Flare spread\r\n# 8B5F Branding Flare self-targeted cast for tower before Branding Flare partner stacks\r\n# 8B60 Flare cast and damage for 85BD tower share (all light party towers)\r\n# 8B62 Flare (???) damage from standing in the post-tower meteor itself when it goes off\r\n# 8B63 Prominence Spine line aoe damage shooting from post-tower meteor\r\n# 8B64 Sparking Flare spread damage after 8B5E\r\n# 8B65 Branding Flare partner stack damage after 8B5F\r\n# 8B66 Void Bio self-targeted cast to summon Toxic Bubbles\r\n# 8B67 Burst damage from hitting an 8B66 Toxic Bubble\r\n# 8B69 Black Hole self-targeted cast to summon black hole during Fractured Eventide\r\n# 8B6B Nostalgia cast and self-targeted for multi-hit physical/magic damage\r\n# 8B6D Bury physical damage 1 from Nostalgia\r\n# 8B6E Bury physical damage 2 from Nostalgia\r\n# 8B6F Bury physical damage 3 from Nostalgia\r\n# 8B70 Bury physical damage 4 from Nostalgia\r\n# 8B71 Roar magical damage 5 from Nostalgia\r\n# 8B72 Roar magical damage 6 from Nostalgia\r\n# 8B73 Primal Roar final hit of Nostalgia\r\n# 8B74 Akh Rhai self-targeted cast before Akh Rhais\r\n# 8B75 Akh Rhai ongoing damage from Akh Rhai\r\n# 8B76 Umbral Rays cast and full party stack damage\r\n# 8B77 Umbral Prism cast and damage for two stack enumerations\r\n# 8B78 Chasmic Nails cast and self-targeted ability\r\n# 8B79 Chasmic Nails damage 1\r\n# 8B7A Chasmic Nails damage 2\r\n# 8B7B Chasmic Nails damage 3\r\n# 8B7C Chasmic Nails damage 4\r\n# 8B7D Chasmic Nails damage 5\r\n# 8B7E Dimensional Surge ground circle damage after Rend the Rift\r\n# 8B82 Dimensional Surge cast and damage for line cleave from tether to wall\r\n# 8B83 Dark Matter self-targeted cast for tankbuster\r\n# 8B84 Dark Matter tankbuster damage\r\n# 8BB2 Fractured Eventide ongoing damage from Eventide line\r\n# 8BB6 Scald very light damage from standing in the post-tower meteor\r\n# 8BDE Big Bang spread damage on players during 8B4C cast\r\n# 8C0D Rend the Rift cast and raidwide damage phase transition\r\n# 8C1E Big Bang enrage cast and damge\r\n# 8C49 --sync-- auto damage on main tank\r\n# 8CB9 Meteor Impact unknown untargeted damage during meteor tethers (maybe correlated with Massive Explosion)\r\n# 8CF8 --sync-- unnamed unknown self-targeted cast during Miasmic Blast 8B49\r\n# 8CFA Flow of the Abyss cast and self-targeted tether to wall before 8B82 Dimension Surge line\r\n# 8D24 Nox damage for chasing Nox orbs\r\n# 8D28 Nox self-targeted cast for chasing orbs\r\n# 8D2A Nox cast and damage for initial circle for chasing orbs\r\n# 8D2B --sync-- unnamed unknown ability before Abyssal Echoes\r\n# 8D31 Big Crunch ground aoe damage during 8B4D\r\n# 8D32 Big Crunch spread damage on players during 8B4D cast\r\n# 8D34 Explosion cast and ground damage from Comet meteors landed during Void Meteor\r\n# 8D3A The Dark Beckons stack damage after Big Bang\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/zeromus.ts





// TODO: better positions for 8AFA Abyssal Echoes

// TODO: Dimensional Surge calls (maybe this shares with Extreme)
// Are there other patterns in normal mode???
//
// Dimensional Surge 8B35 tether middle west
// [16:31:35.624] 257 101:80034E7B:00200004:02:00:0000
const zeromus_triggerSet = {
  id: 'TheAbyssalFracture',
  zoneId: zone_id/* default.TheAbyssalFracture */.Z.TheAbyssalFracture,
  timelineFile: 'zeromus.txt',
  triggers: [{
    id: 'Zeromus Abyssal Nox',
    type: 'Ability',
    netRegex: {
      id: '8AF7',
      source: 'Zeromus',
      capture: false
    },
    suppressSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Heal to full',
        de: 'Voll heilen',
        fr: 'Soignez complètement',
        ja: 'HPを全回復する',
        cn: '奶满全队',
        ko: '체력 풀피로'
      }
    }
  }, {
    id: 'Zeromus Abyssal Echoes',
    type: 'Ability',
    netRegex: {
      id: '8AF9',
      source: 'Zeromus',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Away from glowing circles',
        de: 'Weg von den leuchtenden Kreisen',
        fr: 'Loin des cercles brillants',
        ja: '光っている円から離れる',
        cn: '远离黑洞',
        ko: '빛나는 원에서 멀리 떨어지기'
      }
    }
  }, {
    id: 'Zeromus Sable Thread',
    type: 'Ability',
    netRegex: {
      id: '8AEF',
      source: 'Zeromus'
    },
    alertText: (data, matches, output) => {
      return output.lineStackOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      lineStackOn: {
        en: '5x line stack on ${player}',
        de: '5x in einer Linie Sammeln auf ${player}',
        fr: 'Package en ligne x5 sur ${player}',
        ja: '${player}に5回の直線頭割り',
        cn: '${player} 直线分摊 (5次)',
        ko: '${player} 직선 쉐어 5번'
      }
    }
  }, {
    id: 'Zeromus Visceral Whirl NE Safe',
    type: 'StartsUsing',
    netRegex: {
      id: '8AFB',
      capture: false
    },
    infoText: (_data, _matches, output) => {
      return output.text({
        dir1: output.ne(),
        dir2: output.sw()
      });
    },
    outputStrings: {
      text: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        ja: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      },
      ne: outputs/* default.northeast */.Z.northeast,
      sw: outputs/* default.southwest */.Z.southwest
    }
  }, {
    id: 'Zeromus Visceral Whirl NW Safe',
    type: 'StartsUsing',
    netRegex: {
      id: '8AFE',
      source: 'Zeromus',
      capture: false
    },
    infoText: (_data, _matches, output) => {
      return output.text({
        dir1: output.nw(),
        dir2: output.se()
      });
    },
    outputStrings: {
      text: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        ja: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      },
      nw: outputs/* default.northwest */.Z.northwest,
      se: outputs/* default.southeast */.Z.southeast
    }
  }, {
    id: 'Zeromus Dark Matter',
    type: 'HeadMarker',
    netRegex: {
      id: '016C'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zeromus Nox',
    type: 'HeadMarker',
    netRegex: {
      id: '00C5'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Zeromus Fractured Eventide NE Safe',
    type: 'StartsUsing',
    netRegex: {
      id: '8AF3',
      source: 'Zeromus',
      capture: false
    },
    alertText: (_data, _matches, output) => output.ne(),
    outputStrings: {
      ne: outputs/* default.northeast */.Z.northeast
    }
  }, {
    id: 'Zeromus Fractured Eventide NW Safe',
    type: 'StartsUsing',
    netRegex: {
      id: '8AF4',
      source: 'Zeromus',
      capture: false
    },
    alertText: (_data, _matches, output) => output.nw(),
    outputStrings: {
      nw: outputs/* default.northwest */.Z.northwest
    }
  }, {
    id: 'Zeromus Flare',
    type: 'StartsUsing',
    netRegex: {
      id: '8B12',
      source: 'Zeromus',
      capture: false
    },
    alertText: (_data, _matches, output) => output.tower(),
    outputStrings: {
      tower: {
        en: 'Stand in Tower',
        de: 'Steh im Turm',
        fr: 'Restez dans une tour',
        ja: '塔を踏む',
        cn: '踩塔',
        ko: '기둥 밟기'
      }
    }
  }, {
    id: 'Zeromus Flare Hit',
    type: 'Ability',
    netRegex: {
      id: '8B12',
      source: 'Zeromus',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.getOut */.n3.getOut('info')
  }, {
    id: 'Zeromus Big Bang',
    type: 'StartsUsing',
    netRegex: {
      id: '8B03',
      source: 'Zeromus',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zeromus Acceleration Bomb',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'A61'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 3,
    response: responses/* Responses.stopEverything */.n3.stopEverything()
  }, {
    id: 'Zeromus The Dark Divides',
    type: 'HeadMarker',
    netRegex: {
      id: '0178'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'Zeromus The Dark Beckons',
    type: 'HeadMarker',
    netRegex: {
      id: '0064'
    },
    response: responses/* Responses.stackMarkerOn */.n3.stackMarkerOn()
  }, {
    id: 'Zeromus Big Crunch',
    type: 'StartsUsing',
    netRegex: {
      id: '8B04',
      source: 'Zeromus',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'Zeromus Nostalgia',
    type: 'StartsUsing',
    netRegex: {
      id: '8B1A',
      source: 'Zeromus',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'Zeromus Akh Rhai',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Spread + Stay Out',
        de: 'Verteilen + Draußen stehen',
        fr: 'Écartez-vous + Extérieur',
        ja: '散開 + 範囲から離れる',
        cn: '分散 + 远离',
        ko: '산개 + 범위에서 벗어나기'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Comet': 'Komet',
      'Zeromus': 'Zeromus'
    },
    'replaceText': {
      '\\(cast\\)': '(Wirken)',
      '\\(proximity\\)': '(Distanz',
      'Abyssal Echoes': 'Abyssal-Echos',
      'Abyssal Nox': 'Abyssal-Nox',
      'Big Bang': 'Großer Knall',
      'Big Crunch': 'Großer Quetscher',
      'Black Hole': 'Schwarzes Loch',
      'Bury': 'Impakt',
      'Chasmic Nails': 'Abyssal-Nagel',
      'Dark Matter': 'Dunkelmaterie',
      'Dimensional Surge': 'Dimensionsschwall',
      'Explosion': 'Explosion',
      'Flare': 'Flare',
      'Flow of the Abyss': 'Abyssaler Strom',
      'Fractured Eventide': 'Abendglut',
      'Meteor Impact': 'Meteoreinschlag',
      'Nostalgia': 'Heimweh',
      '(?<! )Nox': 'Nox',
      'Primal Roar': 'Lautes Gebrüll',
      'Prominence Spine': 'Ossale Protuberanz',
      'Rend the Rift': 'Dimensionsstörung',
      '(?<! )Roar': 'Brüllen',
      'Sable Thread': 'Pechschwarzer Pfad',
      'The Dark Beckons': 'Fressende Finsternis: Last',
      'The Dark Divides': 'Fressende Finsternis: Zerschmetterung',
      'Visceral Whirl': 'Viszerale Schürfwunden',
      'Void Bio': 'Nichts-Bio',
      'Void Meteor': 'Nichts-Meteo'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Comet': 'comète',
      'Zeromus': 'Zeromus'
    },
    'replaceText': {
      'Abyssal Echoes': 'Écho abyssal',
      'Abyssal Nox': 'Nox abyssal',
      'Big Bang': 'Big bang',
      'Big Crunch': 'Big crunch',
      'Black Hole': 'Trou noir',
      'Bury': 'Impact',
      'Chasmic Nails': 'Clous abyssaux',
      'Dark Matter': 'Matière sombre',
      'Dimensional Surge': 'Déferlante dimensionnelle',
      'Explosion': 'Explosion',
      'Flare': 'Brasier',
      'Flow of the Abyss': 'Flot abyssal',
      'Fractured Eventide': 'Éclat crépusculaire',
      'Meteor Impact': 'Impact de météore',
      'Nostalgia': 'Nostalgie',
      '(?<! )Nox': 'Nox',
      'Primal Roar': 'Rugissement furieux',
      'Prominence Spine': 'Évidence ossuaire',
      'Rend the Rift': 'Déchirure dimensionnelle',
      '(?<! )Roar': 'Rugissement',
      'Sable Thread': 'Rayon sombre',
      'The Dark Beckons': 'Ténèbres rongeuses : Gravité',
      'The Dark Divides': 'Ténèbres rongeuses : Pulvérisation',
      'Visceral Whirl': 'Écorchure viscérale',
      'Void Bio': 'Bactéries du néant',
      'Void Meteor': 'Météores du néant'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Comet': 'コメット',
      'Zeromus': 'ゼロムス'
    },
    'replaceText': {
      'Abyssal Echoes': 'アビサルエコー',
      'Abyssal Nox': 'アビサルノックス',
      'Big Bang': 'ビッグバーン',
      'Big Crunch': 'ビッグクランチ',
      'Black Hole': 'ブラックホール',
      'Bury': '衝撃',
      'Chasmic Nails': 'アビサルネイル',
      'Dark Matter': 'ダークマター',
      'Dimensional Surge': 'ディメンションサージ',
      'Explosion': '爆発',
      'Flare': 'フレア',
      'Flow of the Abyss': 'アビサルフロウ',
      'Fractured Eventide': '黒竜閃',
      'Meteor Impact': 'メテオインパクト',
      'Nostalgia': '望郷',
      '(?<! )Nox': 'ノックス',
      'Primal Roar': '大咆哮',
      'Prominence Spine': 'プロミネンススパイン',
      'Rend the Rift': '次元干渉',
      '(?<! )Roar': '咆哮',
      'Sable Thread': '漆黒の熱線',
      'The Dark Beckons': '闇の侵食：重',
      'The Dark Divides': '闇の侵食：砕',
      'Visceral Whirl': 'ヴィセラルワール',
      'Void Bio': 'ヴォイド・バイオ',
      'Void Meteor': 'ヴォイド・メテオ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Comet': '彗星',
      'Zeromus': '泽罗姆斯'
    },
    'replaceText': {
      '\\(cast\\)': '(咏唱)',
      '\\(proximity\\)': '(接近)',
      'Abyssal Echoes': '深渊回声',
      'Abyssal Nox': '深渊之夜',
      'Big Bang': '宇宙大爆炸',
      'Big Crunch': '宇宙大挤压',
      'Black Hole': '黑洞',
      'Bury': '塌方',
      'Chasmic Nails': '深渊连爪',
      'Dark Matter': '暗物质',
      'Dimensional Surge': '次元涌动',
      'Explosion': '爆炸',
      'Flare': '核爆',
      'Flow of the Abyss': '深渊激流',
      'Fractured Eventide': '黑龙闪',
      'Meteor Impact': '陨石冲击',
      'Nostalgia': '望乡',
      '(?<! )Nox': '夜',
      'Primal Roar': '大咆哮',
      'Prominence Spine': '日珥焰棘',
      'Rend the Rift': '次元干涉',
      '(?<! )Roar': '咆哮',
      'Sable Thread': '漆黑射线',
      'The Dark Beckons': '黑暗侵蚀：重击',
      'The Dark Divides': '黑暗侵蚀：飞散',
      'Visceral Whirl': '旋骨利爪',
      'Void Bio': '虚空毒菌',
      'Void Meteor': '虚空陨石'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Comet': '혜성',
      'Zeromus': '제로무스'
    },
    'replaceText': {
      '\\(cast\\)': '(시전)',
      '\\(proximity\\)': '(거리감쇠)',
      'Abyssal Echoes': '심연의 메아리',
      'Abyssal Nox': '심연의 암야',
      'Big Bang': '빅뱅',
      'Big Crunch': '빅 크런치',
      'Black Hole': '블랙홀',
      'Bury': '충격',
      'Chasmic Nails': '심연의 손톱',
      'Dark Matter': '암흑물질',
      'Dimensional Surge': '차원 쇄도',
      'Explosion': '폭발',
      'Flare': '플레어',
      'Flow of the Abyss': '심연의 흐름',
      'Fractured Eventide': '흑룡섬',
      'Meteor Impact': '운석 낙하',
      'Nostalgia': '망향',
      '(?<! )Nox': '암야',
      'Primal Roar': '대포효',
      'Prominence Spine': '홍염의 가시',
      'Rend the Rift': '차원 간섭',
      '(?<! )Roar': '포효',
      'Sable Thread': '칠흑의 열선',
      'The Dark Beckons': '어둠의 침식: 집중',
      'The Dark Divides': '어둠의 침식: 분산',
      'Visceral Whirl': '본능의 상흔',
      'Void Bio': '보이드 바이오',
      'Void Meteor': '보이드 메테오'
    }
  }]
};
/* harmony default export */ const zeromus = (zeromus_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/zeromus.txt
const trial_zeromus_namespaceObject = "### THE ABYSSAL FRACTURE\r\n# ZoneId: 1168\r\n\r\n# -p 8B19:1006\r\n# -ii 8C48 8AF9 8AF2 8AFF 8B00 8B13 8BB5 8B15 8B18 8AFC 8AFD 8B05 8B0D 8CB8 8D26 8AF5 8AF6 8C46 8D30 8B0F 8B0E 8B10 8B31 8B32 8B33 8B24\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n6.7 \"--sync--\" StartsUsing { id: \"8AF7\", source: \"Zeromus\" } window 10,10\r\n11.7 \"Abyssal Nox\" Ability { id: \"8AF7\", source: \"Zeromus\" }\r\n20.7 \"--sync--\" Ability { id: \"8AF8\", source: \"Zeromus\" }\r\n27.7 \"Abyssal Echoes\" Ability { id: \"8AFA\", source: \"Zeromus\" }\r\n33.8 \"--sync--\" Ability { id: \"8AEF\", source: \"Zeromus\" }\r\n38.8 \"Sable Thread x5\" Ability { id: \"8AEE\", source: \"Zeromus\" } duration 5.6\r\n#40.5 \"Sable Thread\" #Ability { id: \"8AF0\", source: \"Zeromus\" }\r\n#41.8 \"Sable Thread\" #Ability { id: \"8AF0\", source: \"Zeromus\" }\r\n#43.1 \"Sable Thread\" #Ability { id: \"8AF0\", source: \"Zeromus\" }\r\n44.4 \"--sync--\" Ability { id: \"8AF1\", source: \"Zeromus\" }\r\n\r\n61.8 \"Visceral Whirl\" Ability { id: \"8AF[BE]\", source: \"Zeromus\" }\r\n\r\n73.0 \"Dark Matter x3\" Ability { id: \"8B36\", source: \"Zeromus\" } duration 4.1\r\n#73.9 \"Dark Matter\" #Ability { id: \"8B37\", source: \"Zeromus\" }\r\n#75.5 \"Dark Matter\" #Ability { id: \"8B37\", source: \"Zeromus\" }\r\n#77.1 \"Dark Matter\" #Ability { id: \"8B37\", source: \"Zeromus\" }\r\n\r\n89.2 \"Flare\" Ability { id: \"8B12\", source: \"Zeromus\" }\r\n95.3 \"Nox (cast)\" Ability { id: \"8D27\", source: \"Zeromus\" }\r\n97.3 \"Prominence Spine\" Ability { id: \"8B16\", source: \"Zeromus\" }\r\n\r\n101.3 \"Nox x3\" Ability { id: \"8D29\", source: \"Zeromus\" } duration 3.3\r\n#103.0 \"Nox\" #Ability { id: \"8D23\", source: \"Zeromus\" }\r\n#104.6 \"Nox\" #Ability { id: \"8D23\", source: \"Zeromus\" }\r\n\r\n116.6 \"Void Bio\" Ability { id: \"8B17\", source: \"Zeromus\" }\r\n130.8 \"Visceral Whirl\" Ability { id: \"8AF[BE]\", source: \"Zeromus\" }\r\n\r\n135.8 \"--sync--\" StartsUsing { id: \"8B03\", source: \"Zeromus\" } window 20,20\r\n145.8 \"Big Bang\" Ability { id: \"8B03\", source: \"Zeromus\" }\r\n163.9 \"Visceral Whirl\" Ability { id: \"8AF[BE]\", source: \"Zeromus\" }\r\n172.7 \"The Dark Beckons\" Ability { id: \"8B0A\", source: \"Zeromus\" }\r\n177.7 \"The Dark Divides\" Ability { id: \"8B09\", source: \"Zeromus\" }\r\n\r\n195.1 \"Meteor Impact\" Ability { id: \"8B0B\", source: \"Zeromus\" }\r\n\r\n210.2 \"Dark Matter x3\" Ability { id: \"8B36\", source: \"Zeromus\" } duration 4.1\r\n#211.1 \"Dark Matter\" #Ability { id: \"8B37\", source: \"Zeromus\" }\r\n#212.7 \"Dark Matter\" #Ability { id: \"8B37\", source: \"Zeromus\" }\r\n#214.3 \"Dark Matter\" #Ability { id: \"8B37\", source: \"Zeromus\" }\r\n\r\n225.5 \"Black Hole\" Ability { id: \"8D25\", source: \"Zeromus\" }\r\n235.6 \"Fractured Eventide\" Ability { id: \"8AF[34]\", source: \"Zeromus\" }\r\n\r\n256.6 \"Void Meteor\" Ability { id: \"8B0C\", source: \"Zeromus\" }\r\n257.8 \"Meteor Impact (proximity)\" Ability { id: \"8B11\", source: \"Comet\" }\r\n269.7 \"Meteor Impact (cast)\" Ability { id: \"8B0B\", source: \"Zeromus\" }\r\n274.1 \"Meteor Impact\" Ability { id: \"8B0F\", source: \"Zeromus\" }\r\n280.1 \"Explosion\" Ability { id: \"8D33\", source: \"Comet\" }\r\n\r\n286.7 \"Black Hole\" Ability { id: \"8D25\", source: \"Zeromus\" }\r\n296.8 \"Fractured Eventide\" Ability { id: \"8AF[34]\", source: \"Zeromus\" }\r\n\r\n# Note: seen slightly irregular +3 time offsets here\r\n309.9 \"--sync--\" StartsUsing { id: \"8B04\", source: \"Zeromus\" } window 20,20\r\n319.9 \"Big Crunch\" Ability { id: \"8B04\", source: \"Zeromus\" }\r\n\r\n335.1 \"Abyssal Nox\" Ability { id: \"8AF7\", source: \"Zeromus\" }\r\n344.1 \"--sync--\" Ability { id: \"8AF8\", source: \"Zeromus\" }\r\n351.1 \"Abyssal Echoes\" Ability { id: \"8AFA\", source: \"Zeromus\" }\r\n354.1 \"--sync--\" Ability { id: \"8AEF\", source: \"Zeromus\" }\r\n359.1 \"Sable Thread x5\" Ability { id: \"8AEE\", source: \"Zeromus\" }\r\n#360.8 \"Sable Thread\" #Ability { id: \"8AF0\", source: \"Zeromus\" }\r\n#362.1 \"Sable Thread\" #Ability { id: \"8AF0\", source: \"Zeromus\" }\r\n#363.4 \"Sable Thread\" #Ability { id: \"8AF0\", source: \"Zeromus\" }\r\n364.7 \"--sync--\" Ability { id: \"8AF1\", source: \"Zeromus\" }\r\n\r\n380.1 \"Flare\" Ability { id: \"8B12\", source: \"Zeromus\" }\r\n386.1 \"Nox (cast)\" Ability { id: \"8D27\", source: \"Zeromus\" }\r\n388.1 \"Prominence Spine\" Ability { id: \"8B16\", source: \"Zeromus\" }\r\n392.1 \"Nox x3\" Ability { id: \"8D29\", source: \"Zeromus\" } duration 3.3\r\n#393.8 \"Nox\" #Ability { id: \"8D23\", source: \"Zeromus\" }\r\n#395.4 \"Nox\" #Ability { id: \"8D23\", source: \"Zeromus\" }\r\n\r\n412.4 \"Dark Matter x3\" Ability { id: \"8B36\", source: \"Zeromus\" } duration 4.1\r\n#413.3 \"Dark Matter\" #Ability { id: \"8B37\", source: \"Zeromus\" }\r\n#414.9 \"Dark Matter\" #Ability { id: \"8B37\", source: \"Zeromus\" }\r\n#416.5 \"Dark Matter\" #Ability { id: \"8B37\", source: \"Zeromus\" }\r\n\r\n428.7 \"Void Bio\" Ability { id: \"8B17\", source: \"Zeromus\" }\r\n442.8 \"Visceral Whirl\" Ability { id: \"8AFB\", source: \"Zeromus\" }\r\n\r\n# FIXME: is this the loop? have seen through the sable thread at 360/484\r\n460.9 \"Abyssal Nox\" Ability { id: \"8AF7\", source: \"Zeromus\" } window 30,30 forcejump 335.1\r\n\r\n\r\n# Phase 2: ~25% push\r\n1000.0 \"--sync--\" StartsUsing { id: \"8B19\", source: \"Zeromus\" } window 1000,0\r\n1006.0 \"Rend the Rift\" Ability { id: \"8B19\", source: \"Zeromus\" }\r\n1023.3 \"Nostalgia\" Ability { id: \"8B1A\", source: \"Zeromus\" }\r\n1024.1 \"Bury 1\" Ability { id: \"8B1C\", source: \"Zeromus\" }\r\n1025.1 \"Bury 2\" Ability { id: \"8B1D\", source: \"Zeromus\" }\r\n1026.1 \"Bury 3\" Ability { id: \"8B1E\", source: \"Zeromus\" }\r\n1027.1 \"Bury 4\" Ability { id: \"8B1F\", source: \"Zeromus\" }\r\n1029.1 \"Roar 5\" Ability { id: \"8B20\", source: \"Zeromus\" }\r\n1030.1 \"Roar 6\" Ability { id: \"8B21\", source: \"Zeromus\" }\r\n1033.1 \"Primal Roar 7\" Ability { id: \"8B22\", source: \"Zeromus\" }\r\n\r\n1047.4 \"Flow of the Abyss\" Ability { id: \"8CF9\", source: \"Zeromus\" }\r\n1049.4 \"Dimensional Surge\" Ability { id: \"8B35\", source: \"Zeromus\" }\r\n\r\n1057.9 \"--sync--\" Ability { id: \"8B27\", source: \"Zeromus\" }\r\n1059.5 \"--sync--\" Ability { id: \"8B28\", source: \"Zeromus\" }\r\n1060.5 \"--sync--\" Ability { id: \"8B29\", source: \"Zeromus\" }\r\n1061.5 \"--sync--\" Ability { id: \"8B2A\", source: \"Zeromus\" }\r\n1062.5 \"--sync--\" Ability { id: \"8B2B\", source: \"Zeromus\" }\r\n\r\n1063.5 \"--sync--\" Ability { id: \"8B26\", source: \"Zeromus\" }\r\n1064.2 \"Chasmic Nails 1\" Ability { id: \"8B2C\", source: \"Zeromus\" }\r\n1065.0 \"Chasmic Nails 2\" Ability { id: \"8B2D\", source: \"Zeromus\" }\r\n1065.8 \"Chasmic Nails 3\" Ability { id: \"8B2E\", source: \"Zeromus\" }\r\n1066.5 \"Chasmic Nails 4\" Ability { id: \"8B2F\", source: \"Zeromus\" }\r\n1067.3 \"Chasmic Nails 5\" Ability { id: \"8B30\", source: \"Zeromus\" }\r\n\r\n# TODO: probably the loop??\r\n1082.1 \"Nostalgia\" Ability { id: \"8B1A\", source: \"Zeromus\" } window 40,40 forcejump 1023.3\r\n\r\n\r\n# ALL ENCOUNTER ABILITIES\r\n# 8AEE Sable Thread self-targeted cast for line stack\r\n# 8AEF --sync-- unnamed ability on line stack target for Sable Thread\r\n# 8AF0 Sable Thread self-targeted ability before each non-first/non-last hit\r\n# 8AF1 Sable Thread self-targeted ability for final hit\r\n# 8AF2 Sable Thread line stack share damage\r\n# 8AF3 Fractured Eventide cast and self-targeted ability (NE safe)\r\n# 8AF4 Fractured Eventide cast and self-targeted ability (NW safe)\r\n# 8AF5 Fractured Eventide initial damage from Eventide line (NE safe)\r\n# 8AF6 Fractured Eventide ongoing damage from Eventide line\r\n# 8AF7 Abyssal Nox cast and set-to-1 ability\r\n# 8AF8 --sync-- unnamed unknown ability before Abyssal Echoes\r\n# 8AF9 --sync-- unnamed unknown ability before Abyssal Echoes\r\n# 8AFA Abyssal Echoes cast and damage for lines->circle light up on floor\r\n# 8AFB Visceral Whirl cast and self-targeted claw swipes NE/SW safe\r\n# 8AFC Visceral Whirl cast and damage paired with 8AFB version\r\n# 8AFD Visceral Whirl cast and damage paired with 8AFB version\r\n# 8AFE Visceral Whirl cast and self-targeted claw swipes NW/SE safe\r\n# 8AFF Visceral Whirl cast and damage paired with 8AFE version\r\n# 8B00 Visceral Whirl cast and damage paired with 8AFE version\r\n# 8B03 Big Bang cast and damage on players to give debuffs while 8B05 puddles appear\r\n# 8B04 Big Crunch cast and damage on players while 8D30 puddles appear\r\n# 8B05 Big Bang ground aoe damage during 8B03\r\n# 8B09 The Dark Divides spread damage after Big Bang\r\n# 8B0A The Dark Beckons stack damage after Big Bang\r\n# 8B0B Meteor Impact self-targeted cast for meteor tethers\r\n# 8B0C Void Meteor cast and self-targeted ability to summon meteors for prox damage\r\n# 8B0D Meteor Impact damage from 8B0B meteor tethers (first set of meteors)\r\n# 8B0E Meteor Impact unknown untargeted damage during meteor tethers (maybe correlated with Unmitigated Explosion)\r\n# 8B0F Meteor Impact damage from 8B0B meteor tethers (second set of meteors)\r\n# 8B10 Unmitigated Explosion raidwide damage from colliding meteors from Comet\r\n# 8B11 Meteor Impact cast and proximity damage from Comet\r\n# 8B12 Flare self-targeted tower party share cast\r\n# 8B13 Flare cast and damage for tower share\r\n# 8B15 Flare (???) damage from standing in the post-tower meteor itself when it goes off\r\n# 8B16 Prominence Spine line aoe damage shooting from post-tower meteor\r\n# 8B17 Void Bio self-targeted cast to summon Toxic Bubbles\r\n# 8B18 Burst damage from hitting an 8B17 Toxic Bubble\r\n# 8B19 Rend the Rift cast and raidwide damage phase transition\r\n# 8B1A Nostalgia cast and self-targeted for multi-hit physical/magic damage\r\n# 8B1C Bury physical damage 1 from Nostalgia\r\n# 8B1D Bury physical damage 2 from Nostalgia\r\n# 8B1E Bury physical damage 3 from Nostalgia\r\n# 8B1F Bury physical damage 4 from Nostalgia\r\n# 8B20 Roar magical damage 5 from Nostalgia\r\n# 8B21 Roar magical damage 6 from Nostalgia\r\n# 8B22 Primal Roar final hit of Nostalgia\r\n# 8B23 Akh Rhai self-targeted cast for Akh Rhai\r\n# 8B24 Akh Rhai ongoing damage from Akh Rhai\r\n# 8B26 Chasmic Nails cast and self-targeted ability\r\n# 8B27 --sync-- Chasmic Nail preview 1\r\n# 8B28 --sync-- Chasmic Nail preview 2\r\n# 8B29 --sync-- Chasmic Nail preview 3\r\n# 8B2A --sync-- Chasmic Nail preview 4\r\n# 8B2B --sync-- Chasmic Nail preview 5\r\n# 8B2C Chasmic Nails damage 1\r\n# 8B2D Chasmic Nails damage 2\r\n# 8B2E Chasmic Nails damage 3\r\n# 8B2F Chasmic Nails damage 4\r\n# 8B30 Chasmic Nails damage 5\r\n# 8B31 Dimensional Surge ground circle damage after Rend the Rift\r\n# 8B32 Dimensional Surge small ground circle damage attached to 8B33 lines after Rend the Rift\r\n# 8B33 Dimensional Surge ground line damage attached to 8B32 circles\r\n# 8B35 Dimensional Surge cast and damage for line cleave from tether to wall\r\n# 8B36 Dark Matter self-targeted cast for tankbuster\r\n# 8B37 Dark Matter tankbuster damage\r\n# 8BB5 Scald very light damage from standing in the post-tower meteor\r\n# 8C46 Fractured Eventide initial damage from Eventide line (NW safe)\r\n# 8C48 --sync-- tank auto damage\r\n# 8CB8 Meteor Impact unknown untargeted damage during meteor tethers\r\n# 8CF9 Flow of the Abyss cast and self-targeted tether to wall before 8B35 Dimension Surge line\r\n# 8D23 Nox damage for chasing Nox orbs\r\n# 8D25 Black Hole self-targeted cast to summon black hole during Fractured Eventide\r\n# 8D26 Black Hole (???) damage if standing in black hole when it spawns\r\n# 8D27 Nox self-targeted cast for chasing orbs\r\n# 8D29 Nox cast and damage for initial circle for chasing orbs\r\n# 8D30 Big Crunch ground aoe damage during 8B04\r\n# 8D33 Explosion cast and ground damage from Comet meteors landed during Void Meteor\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/zodiark-ex.ts




const mapEffectLoc = {
  firebar: '05',
  astralEclipse1: '06',
  astralEclipse2: '07',
  astralEclipse3: '08',
  behemothNW: '09',
  behemothNE: '0A',
  behemothSW: '0B',
  behemothSE: '0C',
  snakesNorthOutsideWest: '0D',
  snakesNorthOutsideEast: '0E',
  snakesSouthOutsideWest: '0F',
  snakesSouthOutsideEast: '10',
  snakesWestOutsideNorth: '11',
  snakesWestOutsideSouth: '12',
  snakesEastOutsideNorth: '13',
  snakesEastOutsideSouth: '14',
  birdNW: '15',
  birdNE: '16',
  birdSW: '17',
  birdSE: '18'
};
const clockwiseMap = {
  // Included for completeness, but unused.  Pass through unchanged.
  [mapEffectLoc.firebar]: mapEffectLoc.firebar,
  [mapEffectLoc.astralEclipse1]: mapEffectLoc.astralEclipse1,
  [mapEffectLoc.astralEclipse2]: mapEffectLoc.astralEclipse2,
  [mapEffectLoc.astralEclipse3]: mapEffectLoc.astralEclipse3,
  [mapEffectLoc.behemothNW]: mapEffectLoc.behemothNE,
  [mapEffectLoc.behemothNE]: mapEffectLoc.behemothSE,
  [mapEffectLoc.behemothSW]: mapEffectLoc.behemothNW,
  [mapEffectLoc.behemothSE]: mapEffectLoc.behemothSW,
  [mapEffectLoc.snakesNorthOutsideWest]: mapEffectLoc.snakesEastOutsideNorth,
  [mapEffectLoc.snakesNorthOutsideEast]: mapEffectLoc.snakesEastOutsideSouth,
  [mapEffectLoc.snakesSouthOutsideWest]: mapEffectLoc.snakesWestOutsideNorth,
  [mapEffectLoc.snakesSouthOutsideEast]: mapEffectLoc.snakesWestOutsideSouth,
  [mapEffectLoc.snakesWestOutsideNorth]: mapEffectLoc.snakesNorthOutsideEast,
  [mapEffectLoc.snakesWestOutsideSouth]: mapEffectLoc.snakesNorthOutsideWest,
  [mapEffectLoc.snakesEastOutsideNorth]: mapEffectLoc.snakesSouthOutsideEast,
  [mapEffectLoc.snakesEastOutsideSouth]: mapEffectLoc.snakesSouthOutsideWest,
  [mapEffectLoc.birdNW]: mapEffectLoc.birdNE,
  [mapEffectLoc.birdNE]: mapEffectLoc.birdSE,
  [mapEffectLoc.birdSW]: mapEffectLoc.birdNW,
  [mapEffectLoc.birdSE]: mapEffectLoc.birdSW
};
const counterclockwiseMap = {
  // Included for completeness, but unused.  Pass through unchanged.
  [mapEffectLoc.firebar]: mapEffectLoc.firebar,
  [mapEffectLoc.astralEclipse1]: mapEffectLoc.astralEclipse1,
  [mapEffectLoc.astralEclipse2]: mapEffectLoc.astralEclipse2,
  [mapEffectLoc.astralEclipse3]: mapEffectLoc.astralEclipse3,
  [mapEffectLoc.behemothNW]: mapEffectLoc.behemothSW,
  [mapEffectLoc.behemothNE]: mapEffectLoc.behemothNW,
  [mapEffectLoc.behemothSW]: mapEffectLoc.behemothSE,
  [mapEffectLoc.behemothSE]: mapEffectLoc.behemothNE,
  [mapEffectLoc.snakesNorthOutsideWest]: mapEffectLoc.snakesWestOutsideSouth,
  [mapEffectLoc.snakesNorthOutsideEast]: mapEffectLoc.snakesWestOutsideNorth,
  [mapEffectLoc.snakesSouthOutsideWest]: mapEffectLoc.snakesEastOutsideSouth,
  [mapEffectLoc.snakesSouthOutsideEast]: mapEffectLoc.snakesEastOutsideNorth,
  [mapEffectLoc.snakesWestOutsideNorth]: mapEffectLoc.snakesSouthOutsideWest,
  [mapEffectLoc.snakesWestOutsideSouth]: mapEffectLoc.snakesSouthOutsideEast,
  [mapEffectLoc.snakesEastOutsideNorth]: mapEffectLoc.snakesNorthOutsideWest,
  [mapEffectLoc.snakesEastOutsideSouth]: mapEffectLoc.snakesNorthOutsideEast,
  [mapEffectLoc.birdNW]: mapEffectLoc.birdSW,
  [mapEffectLoc.birdNE]: mapEffectLoc.birdNW,
  [mapEffectLoc.birdSW]: mapEffectLoc.birdSE,
  [mapEffectLoc.birdSE]: mapEffectLoc.birdNE
};
const firebarSWToNEFlags = '00020001';
const firebarSEToNWFlags = '00400020';
const sigil = {
  greenBeam: '67E4',
  redBox: '67E5',
  blueCone: '67E6'
};
const fetchCombatantsById = async id => {
  const decIds = [];
  for (const i of id) decIds.push(parseInt(i, 16));
  const callData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
    call: 'getCombatants',
    ids: decIds
  });
  return callData.combatants;
};
const paradeigmaLeanOutputStrings = {
  dirWithLean: {
    en: '${dir} bird (lean ${lean})',
    de: '${dir} Vogel (nach ${lean} neigen)',
    fr: 'Oiseau ${dir} (côté ${lean})',
    ja: '${dir}の鳥 (すこし${lean})',
    cn: '${dir}鸟 (偏${lean})',
    ko: '${dir}쪽 새, (약간 ${lean}쪽으로)'
  },
  dirN: outputs/* default.dirN */.Z.dirN,
  dirNE: outputs/* default.dirNE */.Z.dirNE,
  dirE: outputs/* default.dirE */.Z.dirE,
  dirSE: outputs/* default.dirSE */.Z.dirSE,
  dirS: outputs/* default.dirS */.Z.dirS,
  dirSW: outputs/* default.dirSW */.Z.dirSW,
  dirW: outputs/* default.dirW */.Z.dirW,
  dirNW: outputs/* default.dirNW */.Z.dirNW,
  // Separate out "lean" here, as people might want to use markers for "dir",
  // but that makes less sense for "lean".
  leanNNE: outputs/* default.dirNNE */.Z.dirNNE,
  leanNE: outputs/* default.dirNE */.Z.dirNE,
  leanENE: outputs/* default.dirENE */.Z.dirENE,
  leanESE: outputs/* default.dirESE */.Z.dirESE,
  leanSE: outputs/* default.dirSE */.Z.dirSE,
  leanSSE: outputs/* default.dirSSE */.Z.dirSSE,
  leanSSW: outputs/* default.dirSSW */.Z.dirSSW,
  leanSW: outputs/* default.dirSW */.Z.dirSW,
  leanWSW: outputs/* default.dirWSW */.Z.dirWSW,
  leanWNW: outputs/* default.dirWNW */.Z.dirWNW,
  leanNW: outputs/* default.dirNW */.Z.dirNW,
  leanNNW: outputs/* default.dirNNW */.Z.dirNNW
};
const eclipseOutputStrings = {
  north: outputs/* default.north */.Z.north,
  northeast: outputs/* default.northeast */.Z.northeast,
  east: outputs/* default.east */.Z.east,
  southeast: outputs/* default.southeast */.Z.southeast,
  south: outputs/* default.south */.Z.south,
  southwest: outputs/* default.southwest */.Z.southwest,
  west: outputs/* default.west */.Z.west,
  northwest: outputs/* default.northwest */.Z.northwest,
  middle: outputs/* default.middle */.Z.middle,
  unknown: outputs/* default.unknown */.Z.unknown
};

// Because there are only six patterns, the third eclipse can be uniquely
// determined by the first two.
const getThirdEclipse = (flag1, flag2) => {
  const finalPattern = {
    '00020001,00200010': '00800040',
    '10000800,00800040': '00020001',
    '00020001,10000800': '00200010',
    '10000800,00200010': '00800040',
    '00200010,10000800': '00800040',
    '00200010,00800040': '00020001'
  };
  return finalPattern[`${flag1},${flag2}`];
};
const eclipseOutput = (idx, flags) => {
  // Astral Eclipse reference: https://twitter.com/xiv_stats/status/1469852444116996096

  // pattern 1: W, mid, NE  (00020001, 00200010, 00800040)
  // pattern 2: NW, W, N    (10000800, 00800040, 00020001)
  // pattern 3: W, N, mid   (00020001, 10000800, 00200010)
  // pattern 4: NW, mid, NE (10000800, 00200010, 00800040)
  // pattern 5: NW, N, NE   (00200010, 10000800, 00800040)
  // pattern 6: NW, W, N    (00200010, 00800040, 00020001)

  // Note: it's likely that these flags are a bit pattern of the two holes, so we could
  // solve this in some general sense, but you'd also have to rotate them all based
  // on perspective etc etc.  Since there's only six patterns, we'll hardcode.

  if (flags === undefined) return 'unknown';
  if (idx === 0) {
    return flags === '00020001' ? 'west' : 'northwest';
  } else if (idx === 1) {
    if (flags === '00200010') return 'middle';else if (flags === '10000800') return 'north';
    return 'west';
  } else if (idx === 2) {
    if (flags === '00200010') return 'middle';else if (flags === '00020001') return 'north';
    return 'northeast';
  }
  return 'unknown';
};
const zodiark_ex_triggerSet = {
  id: 'TheMinstrelsBalladZodiarksFall',
  zoneId: zone_id/* default.TheMinstrelsBalladZodiarksFall */.Z.TheMinstrelsBalladZodiarksFall,
  timelineFile: 'zodiark-ex.txt',
  initData: () => ({
    activeSigils: [],
    activeFrontSigils: [],
    paradeigmaCounter: 0,
    seenAdikia: false,
    styxCount: 6,
    eclipseFlags: [],
    eclipseExplosionCount: 0,
    paradeigmaCollect: []
  }),
  triggers: [{
    id: 'ZodiarkEx Ania',
    type: 'StartsUsing',
    netRegex: {
      id: '6B63',
      source: 'Zodiark'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap()
  }, {
    id: 'ZodiarkEx Kokytos',
    type: 'StartsUsing',
    netRegex: {
      id: '6C60',
      source: 'Zodiark',
      capture: false
    },
    response: responses/* Responses.bigAoe */.n3.bigAoe()
  }, {
    id: 'ZodiarkEx Paradeigma',
    type: 'Ability',
    netRegex: {
      id: '67BF',
      source: 'Zodiark',
      capture: false
    },
    alertText: (data, _matches, output) => {
      ++data.paradeigmaCounter;
      data.paradeigmaCollect = [];

      // Search for "Paradeigma X" in this file to find where these are handled.
      // They are moved to Algedon, Aldikia, and Astral Flow, depending on the Paradeigma.

      // Paradeigma 1 (4 birds, static)
      if (data.paradeigmaCounter === 1) return output.underQuetz();
    },
    outputStrings: {
      underQuetz: {
        en: 'Under NW Quetzalcoatl',
        de: 'Unter NW Quetzalcoatl',
        fr: 'Sous le Quetzalcóatl NO',
        ja: '北東の鳥の下',
        cn: '站在左上 (西北) 鸟',
        ko: '북동쪽 새 밑으로' // This is northeast. Because Korean folks go there.
      }
    }
  }, {
    id: 'ZodiarkEx Paradeigma Animal Collect',
    type: 'MapEffect',
    netRegex: {
      flags: '00200010',
      location: ['0[9-F]', '1[0-8]']
    },
    run: (data, matches) => data.paradeigmaCollect.push(matches)
  }, {
    id: 'ZodiarkEx Paradeigma Firebar Collect',
    type: 'MapEffect',
    netRegex: {
      location: '05'
    },
    run: (data, matches) => data.paradeigmaCollect.push(matches)
  }, {
    id: 'ZodiarkEx Astral Flow',
    type: 'StartsUsing',
    netRegex: {
      id: ['6662', '6663'],
      source: 'Zodiark'
    },
    // "Firebar Collect" and "Astral Flow" triggers are racy with each other,
    // and sometimes the firebar appears ~0.5-0.75s later than the astral flow cast.
    // TODO: this delay is a super hack, and probably we should run this logic inside of
    // firebar collect immediately when it happens rather than always waiting a second.
    // But that's a lot of rewriting, so this is probably Good Enough (TM) for now.
    delaySeconds: data => data.paradeigmaCounter === 3 ? 0 : 1,
    alertText: (data, matches, output) => {
      const isClockwise = matches.id === '6662';
      const origLocs = data.paradeigmaCollect.map(x => x.location);
      const firebar = data.paradeigmaCollect.find(x => x.location === mapEffectLoc.firebar);
      const firebarFlags = firebar?.flags;
      const lastSigil = data.lastSigilDir;
      data.paradeigmaCollect = [];
      data.lastSigilDir = undefined;
      const rotateMap = isClockwise ? clockwiseMap : counterclockwiseMap;
      const locs = origLocs.map(x => rotateMap[x]);

      // Paradeigma 3 (2 snakes, portal, rotate)
      // Paradeigma 7 (2 snakes, portal, firebar, rotate)
      if (data.paradeigmaCounter === 3 || data.paradeigmaCounter === 7) {
        // TODO: this ignores the firebar for Paradeigma 7, but it should be obvious given the portal/snake constraints.
        // TODO: we could consider combining with the sigil call and say "outside north + west" or something
        // but probably the player has already started moving when the sigil appeared, and so it's redundant.
        const outsideNorthBad = locs.includes(mapEffectLoc.snakesWestOutsideNorth) || locs.includes(mapEffectLoc.snakesEastOutsideNorth);
        const outsideSouthBad = locs.includes(mapEffectLoc.snakesWestOutsideSouth) || locs.includes(mapEffectLoc.snakesEastOutsideSouth);
        if (outsideNorthBad) return output.insideNorth();
        if (outsideSouthBad) return output.outsideNorth();
        const outsideWestBad = locs.includes(mapEffectLoc.snakesNorthOutsideWest) || locs.includes(mapEffectLoc.snakesSouthOutsideWest);
        const outsideEastBad = locs.includes(mapEffectLoc.snakesNorthOutsideEast) || locs.includes(mapEffectLoc.snakesSouthOutsideEast);
        if (lastSigil === 'west' && outsideWestBad) return output.insideWest();
        if (lastSigil === 'west' && outsideEastBad) return output.outsideWest();
        if (lastSigil === 'east' && outsideWestBad) return output.outsideEast();
        if (lastSigil === 'east' && outsideEastBad) return output.insideEast();
        return;
      }

      // Firebar is either SW->NE or SE->NW.  No matter which way it rotates,
      // it will either hit east/west in a cone or north/south in a cone.
      const isFirebarEastWestSafe = firebarFlags === firebarSWToNEFlags && !isClockwise || firebarFlags === firebarSEToNWFlags && isClockwise;

      // Paradeigma 5 (2 birds, 2 behemoth, firebar, rotate)
      // Paradeigma 8 (2 birds, 2 behemoths, firebar, portal, rotate)
      if (data.paradeigmaCounter === 5 || data.paradeigmaCounter === 8) {
        const sigil = data.paradeigmaCounter !== 5 ? lastSigil : undefined;
        // It shouldn't be possible for the sigil to be south for Paradeigma 8, but handle it just in case.
        const northwestSafe = sigil === 'west' || sigil === 'north' || sigil === undefined;
        if (locs.includes(mapEffectLoc.birdNW) && northwestSafe) {
          const lean = isFirebarEastWestSafe ? output.leanSW() : output.leanNE();
          return output.dirWithLean({
            dir: output.dirNW(),
            lean: lean
          });
        }
        const northeastSafe = sigil === 'east' || sigil === 'north' || sigil === undefined;
        if (locs.includes(mapEffectLoc.birdNE) && northeastSafe) {
          const lean = isFirebarEastWestSafe ? output.leanSE() : output.leanNW();
          return output.dirWithLean({
            dir: output.dirNE(),
            lean: lean
          });
        }
        const southwestSafe = sigil === 'south' || sigil === 'west' || sigil === undefined;
        if (locs.includes(mapEffectLoc.birdSW) && southwestSafe) {
          const lean = isFirebarEastWestSafe ? output.leanNW() : output.leanSE();
          return output.dirWithLean({
            dir: output.dirSW(),
            lean: lean
          });
        }
        const southeastSafe = sigil === 'south' || sigil === 'east' || sigil === undefined;
        if (locs.includes(mapEffectLoc.birdSE) && southeastSafe) {
          const lean = isFirebarEastWestSafe ? output.leanNE() : output.leanSW();
          return output.dirWithLean({
            dir: output.dirSE(),
            lean: lean
          });
        }
        return;
      }

      // Paradeigma 6 (4 birds, 2 snakes, firebar, rotate)
      // Paradeigma 9 (4 birds, 2 snakes, firebar, portal, rotate)
      if (data.paradeigmaCounter === 6 || data.paradeigmaCounter === 9) {
        const sigil = data.paradeigmaCounter === 6 ? 'west' : lastSigil;
        const outsideNorthBad = locs.includes(mapEffectLoc.snakesWestOutsideNorth) || locs.includes(mapEffectLoc.snakesEastOutsideNorth);
        const outsideSouthBad = locs.includes(mapEffectLoc.snakesWestOutsideSouth) || locs.includes(mapEffectLoc.snakesEastOutsideSouth);
        const outsideWestBad = locs.includes(mapEffectLoc.snakesNorthOutsideWest) || locs.includes(mapEffectLoc.snakesSouthOutsideWest);
        const outsideEastBad = locs.includes(mapEffectLoc.snakesNorthOutsideEast) || locs.includes(mapEffectLoc.snakesSouthOutsideEast);
        if (outsideNorthBad) {
          if (sigil === 'west') {
            const lean = isFirebarEastWestSafe ? output.leanSW() : output.leanESE();
            return output.dirWithLean({
              dir: output.dirNW(),
              lean: lean
            });
          } else if (sigil === 'east') {
            const lean = isFirebarEastWestSafe ? output.leanSE() : output.leanWSW();
            return output.dirWithLean({
              dir: output.dirNE(),
              lean: lean
            });
          }
        } else if (outsideSouthBad) {
          if (sigil === 'west') {
            const lean = isFirebarEastWestSafe ? output.leanWNW() : output.leanNE();
            return output.dirWithLean({
              dir: output.dirNW(),
              lean: lean
            });
          } else if (sigil === 'east') {
            const lean = isFirebarEastWestSafe ? output.leanENE() : output.leanNW();
            return output.dirWithLean({
              dir: output.dirNE(),
              lean: lean
            });
          }
        } else if (outsideWestBad) {
          if (sigil === 'west') {
            const lean = isFirebarEastWestSafe ? output.leanSSE() : output.leanNE();
            return output.dirWithLean({
              dir: output.dirNW(),
              lean: lean
            });
          }
          const lean = isFirebarEastWestSafe ? output.leanSE() : output.leanNNE();
          return output.dirWithLean({
            dir: output.dirNE(),
            lean: lean
          });
        } else if (outsideEastBad) {
          if (sigil === 'west') {
            const lean = isFirebarEastWestSafe ? output.leanSW() : output.leanNNW();
            return output.dirWithLean({
              dir: output.dirNW(),
              lean: lean
            });
          }
          const lean = isFirebarEastWestSafe ? output.leanSSW() : output.leanNW();
          return output.dirWithLean({
            dir: output.dirNE(),
            lean: lean
          });
        }
      }
    },
    outputStrings: {
      outsideNorth: {
        en: 'Outside North',
        de: 'Außen Norden',
        fr: 'Nord Extérieur',
        ja: '北の外側',
        cn: '上 (北) 外',
        ko: '북쪽 바깥'
      },
      insideNorth: {
        en: 'Inside North',
        de: 'Innen Norden',
        fr: 'Nord Intérieur',
        ja: '北の内側',
        cn: '上 (北) 内',
        ko: '북쪽 안'
      },
      outsideWest: {
        en: 'Outside West',
        de: 'Außen Westen',
        fr: 'Ouest Extérieur',
        ja: '西の外側',
        cn: '左 (西) 外',
        ko: '서쪽 바깥'
      },
      insideWest: {
        en: 'Inside West',
        de: 'Innen Westen',
        fr: 'Ouest Intérieur',
        ja: '西の内側',
        cn: '左 (西) 内',
        ko: '서쪽 안'
      },
      outsideEast: {
        en: 'Outside East',
        de: 'Außen Osten',
        fr: 'Est Extérieur',
        ja: '東の外側',
        cn: '右 (东) 外',
        ko: '동쪽 바깥'
      },
      insideEast: {
        en: 'Inside East',
        de: 'Innen Osten',
        fr: 'Est Intérieur',
        ja: '東の内側',
        cn: '右 (东) 内',
        ko: '동쪽 안'
      },
      ...paradeigmaLeanOutputStrings
    }
  }, {
    id: 'ZodiarkEx Styx',
    type: 'StartsUsing',
    netRegex: {
      id: '67F3',
      source: 'Zodiark',
      capture: false
    },
    alertText: (data, _matches, output) => output.text({
      num: data.styxCount
    }),
    run: data => data.styxCount = Math.min(data.styxCount + 1, 9),
    outputStrings: {
      text: {
        en: 'Stack x${num}',
        de: 'Sammeln x${num}',
        fr: 'Package x${num}',
        ja: '頭割り x${num}',
        cn: '${num}次分摊',
        ko: '쉐어 ${num}번'
      }
    }
  }, {
    id: 'ZodiarkEx Arcane Sigil End',
    type: 'Ability',
    netRegex: {
      id: [sigil.greenBeam, sigil.redBox, sigil.blueCone],
      source: 'Arcane Sigil'
    },
    run: (data, matches, _output) => {
      for (let i = 0; i < data.activeSigils.length; ++i) {
        const sig = data.activeSigils[i];
        if (sig?.npcId === matches.sourceId) data.activeSigils.splice(i, 1);
      }
    }
  }, {
    id: 'ZodiarkEx Green Laser Second',
    type: 'Ability',
    netRegex: {
      id: sigil.greenBeam,
      source: 'Arcane Sigil',
      capture: false
    },
    condition: data => data.prevGreenSigil !== undefined,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      if (data.prevGreenSigil === 'sides') return output.middle();
      if (data.prevGreenSigil === 'middle') return output.sides();
    },
    run: data => delete data.prevGreenSigil,
    outputStrings: {
      sides: {
        // Specify "for laser" to disambiguate with the astral eclipse going on at the same time.
        // Similarly, there's a Algedon knockback call too.
        en: 'sides (for laser)',
        de: 'Seiten (für die Laser)',
        fr: 'Côtés (pour les lasers)',
        ja: '横側 (レーザー回避)',
        cn: '两边 (躲避激光)',
        ko: '양옆 (레이저 피하기)'
      },
      middle: {
        en: 'middle (for laser)',
        de: 'Mitte (für die Laser)',
        fr: 'Milieu (pour les lasers)',
        ja: '真ん中 (レーザー回避)',
        cn: '中间 (躲避激光)',
        ko: '중앙 (레이저 피하기)'
      }
    }
  }, {
    id: 'ZodiarkEx Blue Cone Tether',
    type: 'Tether',
    netRegex: {
      id: '00A4',
      source: 'Zodiark'
    },
    promise: async (data, matches) => {
      const portalActors = await fetchCombatantsById([matches.targetId]);
      for (const actor of portalActors) {
        if (actor.ID) data.activeSigils.push({
          x: actor.PosX,
          y: actor.PosY,
          typeId: sigil.blueCone,
          npcId: actor.ID.toString(16).toUpperCase()
        });
      }
    },
    alertText: (data, matches, output) => {
      const target = data.activeSigils[data.activeSigils.length - 1];
      if (!target) {
        console.error(`Blue Tether: Missing target, ${JSON.stringify(matches)}`);
        return;
      }
      if (target.x < 100) {
        data.lastSigilDir = 'west';
        return output.westCone();
      }
      if (target.x > 100) {
        data.lastSigilDir = 'east';
        return output.eastCone();
      }
      if (target.y < 100) {
        data.lastSigilDir = 'north';
        return output.northCone();
      }
      data.lastSigilDir = 'south';
      return output.southCone();
    },
    outputStrings: {
      northCone: {
        en: 'North Cone',
        de: 'Nördliche Kegel-AoE',
        fr: 'Cône Nord',
        ja: '北のさんかく',
        cn: '上 (北) 扇形',
        ko: '북쪽 삼각형'
      },
      eastCone: {
        en: 'East Cone',
        de: 'Östliche Kegel-AoE',
        fr: 'Cône Est',
        ja: '東のさんかく',
        cn: '右 (东) 扇形',
        ko: '동쪽 삼각형'
      },
      westCone: {
        en: 'West Cone',
        de: 'Westliche Kegel-AoE',
        fr: 'Cône Ouest',
        ja: '西のさんかく',
        cn: '左 (西) 扇形',
        ko: '서쪽 삼각형'
      },
      southCone: {
        en: 'South Cone',
        de: 'Südliche Kegel-AoE',
        fr: 'Cône Sud',
        ja: '南のさんかく',
        cn: '下 (南) 扇形',
        ko: '남쪽 삼각형'
      }
    }
  }, {
    id: 'ZodiarkEx Red Box Tether',
    type: 'Tether',
    netRegex: {
      id: '00AB',
      source: 'Zodiark'
    },
    promise: async (data, matches) => {
      const portalActors = await fetchCombatantsById([matches.targetId]);
      for (const actor of portalActors) {
        if (actor.ID) data.activeSigils.push({
          x: actor.PosX,
          y: actor.PosY,
          typeId: sigil.redBox,
          npcId: actor.ID.toString(16).toUpperCase()
        });
      }
    },
    alertText: (data, matches, output) => {
      const target = data.activeSigils[data.activeSigils.length - 1];
      if (!target) {
        console.error(`Red Tether: Missing target, ${JSON.stringify(matches)}`);
        return;
      }
      if (target.x < 100) {
        data.lastSigilDir = 'east';
        return output.east();
      }
      if (target.x > 100) {
        data.lastSigilDir = 'west';
        return output.west();
      }
      if (target.y < 100) {
        data.lastSigilDir = 'south';
        return output.south();
      }
      data.lastSigilDir = 'north';
      return output.north();
    },
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      west: outputs/* default.west */.Z.west,
      south: outputs/* default.south */.Z.south,
      east: outputs/* default.east */.Z.east
    }
  }, {
    id: 'ZodiarkEx Roiling Darkness Spawn',
    type: 'AddedCombatant',
    netRegex: {
      name: 'Roiling Darkness',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill adds (back first)',
        de: 'Adds besiegen (hinten zuerst)',
        fr: 'Tuez les adds (arrière d\'abord)',
        ja: '雑魚から倒して (下の雑魚から)',
        cn: '击杀小怪 (先打后方的)',
        ko: '쫄 잡기 (아래쪽 먼저)'
      }
    }
  }, {
    id: 'ZodiarkEx Arcane Sigil Start',
    type: 'StartsUsing',
    netRegex: {
      id: [sigil.greenBeam, sigil.redBox, sigil.blueCone],
      source: 'Arcane Sigil'
    },
    run: (data, matches, _output) => {
      if (parseFloat(matches.y) < 100) data.activeFrontSigils.push({
        x: parseFloat(matches.x),
        y: parseFloat(matches.y),
        typeId: matches.id,
        npcId: matches.sourceId
      });
    }
  }, {
    id: 'ZodiarkEx Arcane Sigil',
    type: 'StartsUsing',
    netRegex: {
      id: [sigil.greenBeam, sigil.redBox, sigil.blueCone],
      source: 'Arcane Sigil',
      capture: false
    },
    delaySeconds: 0.2,
    durationSeconds: 4,
    suppressSeconds: 0.5,
    alertText: (data, _matches, output) => {
      const activeFrontSigils = data.activeFrontSigils;
      data.activeFrontSigils = [];

      // In a sides->middle or middle->sides transition, avoid the 2nd call from coming
      // up before the first call has gone off.
      if (data.prevGreenSigil !== undefined && activeFrontSigils[0]?.typeId === sigil.greenBeam) return;
      if (activeFrontSigils.length === 1 && activeFrontSigils[0]?.typeId === sigil.greenBeam) {
        data.prevGreenSigil = 'sides';
        return output.sides();
      }
      if (activeFrontSigils.length === 1 && activeFrontSigils[0]?.typeId === sigil.redBox) return output.south();
      if (activeFrontSigils.length === 1 && activeFrontSigils[0]?.typeId === sigil.blueCone) return output.north();
      if (activeFrontSigils.length === 2 && activeFrontSigils[0]?.typeId === sigil.greenBeam && activeFrontSigils[1]?.typeId === sigil.greenBeam) {
        data.prevGreenSigil = 'middle';
        return output.middle();
      }
      if (activeFrontSigils.length === 3) {
        for (const sig of activeFrontSigils) {
          // Find the middle sigil
          if (sig.x > 90 && sig.x < 110) {
            if (sig.typeId === sigil.greenBeam) return output.frontsides();
            if (sig.typeId === sigil.redBox) return output.backmiddle();
            if (sig.typeId === sigil.blueCone) return output.frontmiddle();
          }
        }
      }
    },
    outputStrings: {
      south: outputs/* default.south */.Z.south,
      north: outputs/* default.north */.Z.north,
      frontsides: {
        en: 'front sides',
        de: 'Vorne Seiten',
        fr: 'Devant sur les côtés',
        ja: '前の横側',
        cn: '前方两边',
        ko: '앞쪽 양옆'
      },
      backmiddle: {
        en: 'back middle',
        de: 'Hinten Mitte',
        fr: 'Arrière centre',
        ja: '後ろの真ん中',
        cn: '后方中间',
        ko: '뒤쪽 중앙'
      },
      frontmiddle: {
        en: 'front middle',
        de: 'Vorne Mitte',
        fr: 'Avant centre',
        ja: '前の中央',
        cn: '前方中间',
        ko: '앞쪽 중앙'
      },
      sides: {
        // Specify "for laser" to disambiguate with the astral eclipse going on at the same time.
        // Similarly, there's a Algedon knockback call too.
        en: 'sides (for laser)',
        de: 'Seiten (für die Laser)',
        fr: 'Côtés (pour les lasers)',
        ja: '横側 (レーザー回避)',
        cn: '两边 (躲避激光)',
        ko: '양옆 (레이저 피하기)'
      },
      middle: {
        en: 'middle (for laser)',
        de: 'Mitte (für die Laser)',
        fr: 'Milieu (pour les lasers)',
        ja: '真ん中 (レーザー回避)',
        cn: '中间 (躲避激光)',
        ko: '중앙 (레이저 피하기)'
      }
    }
  }, {
    id: 'ZodiarkEx Algedon',
    type: 'StartsUsing',
    // 67EC is leaning left, 67ED is leaning right
    netRegex: {
      id: ['67EC', '67ED'],
      source: 'Zodiark'
    },
    infoText: (data, matches, output) => {
      // Paradeigma 2 (2 birds, 2 behemoth, algedon, static)
      if (data.paradeigmaCounter === 2 && data.paradeigmaCollect.length > 0) {
        const locs = data.paradeigmaCollect.map(x => x.location);
        data.paradeigmaCollect = [];
        const isNWSafe = locs.includes(mapEffectLoc.birdNW);
        const isNESafe = locs.includes(mapEffectLoc.birdNE);

        // If there's a bird in melee range in the safe spot, call that exclusively.
        // Otherwise, fall through to calling both and folks can take the vuln from behemoth.
        if (matches.id === '67EC' && isNESafe) return output.dirWithLean({
          dir: output.dirNE(),
          lean: output.leanNE()
        });
        if (matches.id === '67ED' && isNWSafe) return output.dirWithLean({
          dir: output.dirNW(),
          lean: output.leanNW()
        });

        // North spots unsafe, but call them anyway.  Technically the second
        // option requires a "lean" like the above, but that's too much text.
        if (matches.id === '67EC' && isNWSafe) return output.combo({
          first: output.dirNW(),
          second: output.dirSW()
        });
        if (matches.id === '67ED' && isNESafe) return output.combo({
          first: output.dirNE(),
          second: output.dirSE()
        });

        // Otherwise, we're in a situation where both behemoths are north,
        // so fall through to the normal logic to tell people to dodge Algedon,
        // and they can choose to stand in the behemoth if they'd like.
      }

      // Between paradeigma 5 and 6, there's an Algedon with an Esoterikos.
      // Call only the melee uptime spot if it is safe, otherwise call
      // the unsafe uptime spot and the safe downtime spot.
      if (data.paradeigmaCounter === 5) {
        if (data.lastSigilDir === 'east') {
          if (matches.id === '67EC') return output.single({
            dir: output.dirNE(),
            lean: output.leanNE()
          });
          return output.combo({
            first: output.dirNE(),
            second: output.dirSE()
          });
        } else if (data.lastSigilDir === 'west') {
          if (matches.id === '67ED') return output.single({
            dir: output.dirNW(),
            lean: output.leanNW()
          });
          return output.combo({
            first: output.dirNW(),
            second: output.dirSW()
          });
        }
      }
      if (matches.id === '67EC') {
        // NE/SW
        return output.combo({
          first: output.dirNE(),
          second: output.dirSW()
        });
      }
      if (matches.id === '67ED') {
        // NW/SE
        return output.combo({
          first: output.dirNW(),
          second: output.dirSE()
        });
      }
    },
    outputStrings: {
      combo: {
        en: 'Go ${first} / ${second}',
        de: 'Geh ${first} / ${second}',
        fr: 'Allez ${first} / ${second}',
        ja: '${first} / ${second}',
        cn: '去 ${first} / ${second}',
        ko: '${first} / ${second}'
      },
      single: {
        en: 'Go ${dir} (lean ${lean})',
        de: 'Geh nach ${dir} (nach ${lean} neigen)',
        fr: 'Allez ${dir} (légèrement ${lean})',
        ja: '${dir}の鳥 (すこし${lean})',
        cn: '去 ${dir} (偏 ${lean})',
        ko: '${dir}쪽으로, (약간 ${lean}쪽으로)'
      },
      ...paradeigmaLeanOutputStrings
    }
  }, {
    id: 'ZodiarkEx Algedon Knockback',
    type: 'StartsUsing',
    netRegex: {
      id: '67EE',
      source: 'Zodiark',
      capture: false
    },
    // Algedon the castbar (67EC/67ED) is a 7 second cast.  67EE the knockback is an 8 second cast.
    delaySeconds: 3,
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'ZodiarkEx Adikia',
    type: 'StartsUsing',
    netRegex: {
      id: '63A9',
      source: 'Zodiark',
      capture: false
    },
    alertText: (data, _matches, output) => {
      // Paradeigma 4 (adikia, 2 snakes, static)
      if (data.paradeigmaCollect.length > 0) {
        const locs = data.paradeigmaCollect.map(x => x.location);
        data.paradeigmaCollect = [];
        // These snakes always seem to be east or west.
        if (locs.includes(mapEffectLoc.snakesWestOutsideSouth) || locs.includes(mapEffectLoc.snakesEastOutsideSouth)) return output.adikia1OutsideNorth();
        if (locs.includes(mapEffectLoc.snakesWestOutsideNorth) || locs.includes(mapEffectLoc.snakesEastOutsideNorth)) return output.adikia1InsideNorth();
        // Otherwise, fall back to generic answer if this has failed.
      }

      return data.seenAdikia ? output.adikia2() : output.adikia1();
    },
    run: data => data.seenAdikia = true,
    outputStrings: {
      adikia1: {
        en: 'Double fists (look for pythons)',
        de: 'Doppel-Fäuste (halt Ausschau nach den Pythons)',
        fr: 'Poings doubles (regardez les pythons)',
        ja: 'ダブルフィスト (ヘビー確認)',
        cn: '双拳 (找蛇)',
        ko: '양 옆 큰 원형 장판 (뱀 위치 확인)'
      },
      adikia1OutsideNorth: {
        en: 'Double fists (outside north)',
        de: 'Doppel-Fäuste (nördlich außen)',
        fr: 'Poings doubles (nord extérieur)',
        ja: 'ダブルフィスト (北の外側)',
        cn: '双拳 (上北外)',
        ko: '양 옆 큰 원형 장판 (북쪽 바깥)'
      },
      adikia1InsideNorth: {
        en: 'Double fists (inside north)',
        de: 'Doppel-Fäuste (nördlich innen)',
        fr: 'Poings doubles (nord intérieur)',
        ja: 'ダブルフィスト (北の内側)',
        cn: '双拳 (上北内)',
        ko: '양 옆 큰 원형 장판 (북쪽 안)'
      },
      adikia2: {
        en: 'Double fists',
        de: 'Doppel-Fäuste',
        fr: 'Poings doubles',
        ja: 'ダブルフィスト',
        cn: '双拳',
        ko: '양 옆 큰 원형 장판'
      }
    }
  }, {
    id: 'ZodiarkEx Phobos',
    type: 'StartsUsing',
    netRegex: {
      id: '67F0',
      source: 'Zodiark',
      capture: false
    },
    response: responses/* Responses.bleedAoe */.n3.bleedAoe('alert')
  }, {
    id: 'ZodiarkEx Astral Eclipse Cleanup',
    type: 'StartsUsing',
    netRegex: {
      id: '67C3',
      source: 'Zodiark',
      capture: false
    },
    run: data => {
      data.eclipseFlags = [];
      data.eclipseExplosionCount = 0;
    }
  }, {
    id: 'ZodiarkEx Astral Eclipse Collect',
    type: 'MapEffect',
    // Note: there are more lines with these during the explosions, so ignore them.
    // It's unclear what the flags are doing for those lines.
    netRegex: {
      location: '0[678]'
    },
    run: (data, matches) => {
      if (data.eclipseFlags.length === 0) {
        data.eclipseFlags.push(matches.flags);
      } else if (data.eclipseFlags.length === 1) {
        const second = matches.flags;
        data.eclipseFlags.push(second);
        const first = data.eclipseFlags[0];
        if (first === undefined) return;
        // The third mark can be uniquely determined by the first two, so just call it.
        const third = getThirdEclipse(first, second);
        if (third !== undefined) data.eclipseFlags.push(third);
      }
    }
  }, {
    id: 'ZodiarkEx Astral Eclipse Initial',
    type: 'MapEffect',
    netRegex: {
      location: '0[678]',
      capture: false
    },
    suppressSeconds: 30,
    alertText: (data, _matches, output) => {
      return output[eclipseOutput(0, data.eclipseFlags[0])]();
    },
    outputStrings: eclipseOutputStrings
  }, {
    id: 'ZodiarkEx Astral Eclipse Instructions',
    type: 'MapEffect',
    netRegex: {
      location: '0[678]',
      capture: false
    },
    condition: data => data.eclipseFlags.length === 3,
    durationSeconds: 19,
    suppressSeconds: 30,
    infoText: (data, _matches, output) => {
      const dir1 = output[eclipseOutput(0, data.eclipseFlags[0])]();
      const dir2 = output[eclipseOutput(1, data.eclipseFlags[1])]();
      const dir3 = output[eclipseOutput(2, data.eclipseFlags[2])]();
      return output.combo({
        dir1: dir1,
        dir2: dir2,
        dir3: dir3
      });
    },
    outputStrings: {
      combo: {
        en: '${dir1} > ${dir2} > ${dir3}',
        de: '${dir1} > ${dir2} > ${dir3}',
        fr: '${dir1} > ${dir2} > ${dir3}',
        ja: '${dir1} > ${dir2} > ${dir3}',
        cn: '${dir1} > ${dir2} > ${dir3}',
        ko: '${dir1} > ${dir2} > ${dir3}'
      },
      ...eclipseOutputStrings
    }
  }, {
    id: 'ZodiarkEx Astral Eclipse Step',
    type: 'Ability',
    netRegex: {
      id: '67E7',
      source: 'Zodiark',
      capture: false
    },
    suppressSeconds: 2,
    alertText: (data, _matches, output) => {
      data.eclipseExplosionCount++;
      if (data.eclipseExplosionCount >= 3) return;
      const flags = data.eclipseFlags[data.eclipseExplosionCount];
      return output[eclipseOutput(data.eclipseExplosionCount, flags)]();
    },
    outputStrings: eclipseOutputStrings
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Esoteric Dyad/Esoteric Sect': 'Esoteric Dyad/Sect'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Arcane Sigil': 'Geheimzeichen',
      'Behemoth': 'Behemoth',
      'Quetzalcoatl': 'Quetzalcoatl',
      'Roiling Darkness': 'Strom der Dunkelheit',
      'Zodiark': 'Zodiark',
      'python': 'Python'
    },
    'replaceText': {
      'Adikia': 'Adikia',
      'Algedon': 'Algedon',
      'Ania': 'Ania',
      'Apomnemoneumata': 'Apomnemoneumata',
      'Astral Eclipse': 'Astraleklipse',
      'Astral Flow': 'Lichtstrom',
      'Esoteric Dyad': 'Esoterische Dyade',
      'Esoteric Pattern': 'Esoteric Muster',
      '(?<!Triple )Esoteric Ray': 'Esoterischer Strahl',
      'Esoteric Sect': 'Esoterische Sekte',
      'Esoterikos': 'Esoterikos',
      '(?<!Trimorphos )Exoterikos': 'Exoterikos',
      'Explosion': 'Explosion',
      'Infernal Stream': 'Infernostrom',
      'Infernal Torrent': 'Infernaler Strom',
      'Keraunos Eidolon': 'Keraunos',
      'Kokytos': 'Kokytos',
      'Meteoros Eidolon': 'Meteoros',
      'Opheos Eidolon': 'Opheos',
      'Paradeigma': 'Paradeigma',
      'Phlegethon': 'Phlegethon',
      'Phobos': 'Phobos',
      'Styx': 'Styx',
      'Trimorphos Exoterikos': 'Trimorphos Exoterikos',
      'Triple Esoteric Ray': 'Esoterischer Dreierstrahl'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Arcane Sigil': 'emblème secret',
      'Behemoth': 'béhémoth',
      'Quetzalcoatl': 'Quetzalcóatl',
      'Roiling Darkness': 'orbe des Ténèbres',
      'Zodiark': 'Zordiarche',
      'python': 'Python'
    },
    'replaceText': {
      'Adikia': 'Adikia',
      'Algedon': 'Algedon',
      'Ania': 'Ania',
      'Apomnemoneumata': 'Apomnemoneumata',
      'Astral Eclipse': 'Éclipse astrale',
      'Astral Flow': 'Flux astral',
      'Esoteric Dyad(?!/)': 'Dyade ésotérique',
      'Esoteric Dyad/Esoteric Sect': 'Dyade/Cabale ésotérique',
      '(?<!Triple )Esoteric Ray': 'Rayon ésotérique',
      '(?<!/)Esoteric Sect': 'Cabale ésotérique',
      'Esoteric Pattern': 'Schéma ésotérique',
      'Esoterikos': 'Esoterikos',
      '(?<!Trimorphos )Exoterikos': 'Exoterikos',
      'Explosion': 'Explosion',
      'Infernal Stream': 'Courant infernal',
      'Infernal Torrent': 'Torrent infernal',
      'Keraunos Eidolon': 'Keraunos',
      'Kokytos': 'Kokytos',
      'Meteoros Eidolon': 'Meteoros',
      'Opheos Eidolon': 'Opheos',
      'Paradeigma': 'Paradeigma',
      'Phlegethon': 'Phlégéthon',
      'Phobos': 'Phobos',
      'Styx': 'Styx',
      'Trimorphos Exoterikos': 'Trimorphos Exoterikos',
      'Triple Esoteric Ray': 'Rayon ésotérique triple'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Arcane Sigil': '秘紋',
      'Behemoth': 'ベヒーモス',
      'Quetzalcoatl': 'ケツァクウァトル',
      'Roiling Darkness': '闇の奔流',
      'Zodiark': 'ゾディアーク',
      'python': 'ピュトン'
    },
    'replaceText': {
      'Adikia': 'アディキア',
      'Algedon': 'アルゲドン',
      'Ania': 'アニア',
      'Apomnemoneumata': 'アポムネーモネウマタ',
      'Astral Eclipse': 'アストラルエクリプス',
      'Astral Flow': 'アストラルフロウ',
      'Esoteric Dyad': 'エソテリックダイアド',
      'Esoteric Pattern': '秘紋図形',
      '(?<!Triple )Esoteric Ray': 'エソテリックレイ',
      'Esoteric Sect': 'エソテリックセクト',
      'Esoterikos': 'エソーテリコス',
      '(?<!Trimorphos )Exoterikos': 'エクソーテリコス',
      'Explosion': '爆発',
      'Infernal Stream': 'インフェルノストリーム',
      'Infernal Torrent': 'インフェルノトレント',
      'Keraunos Eidolon': 'ケラノウス・エイドロン',
      'Kokytos': 'コキュートス',
      'Meteoros Eidolon': 'メテオロス・エイドロン',
      'Opheos Eidolon': 'オフェオス・エイドロン',
      'Paradeigma': 'パラデイグマ',
      'Phlegethon': 'プレゲトン',
      'Phobos': 'フォボス',
      'Styx': 'ステュクス',
      'Trimorphos Exoterikos': 'トライ・エクソーテリコス',
      'Triple Esoteric Ray': 'トライ・エソテリックレイ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Arcane Sigil': '秘纹',
      'Behemoth': '贝希摩斯',
      'Quetzalcoatl': '克察尔科亚特尔',
      'Roiling Darkness': '黑暗奔流',
      'Zodiark': '佐迪亚克',
      'python': '大蟒'
    },
    'replaceText': {
      'Adikia': '不义',
      'Algedon': '痛苦',
      'Ania': '悲伤',
      'Apomnemoneumata': '悼念',
      'Astral Eclipse': '星蚀',
      'Astral Flow': '星极超流',
      'Esoteric Dyad': '神秘二分',
      'Esoteric Pattern': '秘纹图案',
      '(?<!Triple )Esoteric Ray': '神秘光线',
      'Esoteric Sect': '神秘切割',
      'Esoterikos': '内纹',
      '(?<!Trimorphos )Exoterikos': '外纹',
      'Explosion': '爆炸',
      'Infernal Stream': '狱火奔流',
      'Infernal Torrent': '狱火洪流',
      'Keraunos Eidolon': '雷霆幻影',
      'Kokytos': '悲痛',
      'Meteoros Eidolon': '陨石幻影',
      'Opheos Eidolon': '巨蛇幻影',
      'Paradeigma': '范式',
      'Phlegethon': '冥火',
      'Phobos': '恐惧',
      'Styx': '仇恨',
      'Trimorphos Exoterikos': '三重外纹',
      'Triple Esoteric Ray': '三重神秘光线'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Arcane Sigil': '비문',
      'Behemoth': '베히모스',
      'Quetzalcoatl': '케찰코아틀',
      'Roiling Darkness': '어둠의 급류',
      'Zodiark': '조디아크',
      'python': '퓌톤'
    },
    'replaceText': {
      'Adikia': '불의',
      'Algedon': '아픔',
      'Ania': '핍박',
      'Apomnemoneumata': '기억들',
      'Astral Eclipse': '별들의 식',
      'Astral Flow': '천상의 흐름',
      'Esoteric Dyad(?!/)': '내밀한 양면',
      'Esoteric Dyad/Esoteric Sect': '내밀한 양면/종파',
      '(?<!/)Esoteric Sect': '내밀한 종파',
      'Esoteric Pattern': '내밀한 양면/종파/광선',
      'Esoterikos': '에소테리코스',
      'Explosion': '폭산',
      'Infernal Stream': '지옥불 흐름',
      'Infernal Torrent': '지옥불 급류',
      'Keraunos Eidolon': '허깨비 낙뢰',
      'Kokytos': '코퀴토스',
      'Meteoros Eidolon': '허깨비 운석',
      'Opheos Eidolon': '허깨비 뱀',
      'Paradeigma': '시범',
      'Phlegethon': '플레게톤',
      'Phobos': '포보스',
      'Styx': '스틱스',
      'Trimorphos Exoterikos': '삼중 엑소테리코스',
      'Triple Esoteric Ray': '내밀한 삼중 광선',
      '(?<!Triple )Esoteric Ray': '내밀한 광선',
      '(?<!Trimorphos )Exoterikos': '엑소테리코스'
    }
  }]
};
/* harmony default export */ const zodiark_ex = (zodiark_ex_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/zodiark-ex.txt
const trial_zodiark_ex_namespaceObject = "# Zodiark Extreme\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n# Useful for syncing, but just noisy.\r\nhideall \"Exoterikos\"\r\nhideall \"Triple Esoteric Ray\"\r\nhideall \"Infernal Stream\"\r\nhideall \"Infernal Torrent\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n10.8 \"Kokytos\" Ability { id: \"6C60\", source: \"Zodiark\" } window 11.3,5\r\n21.0 \"Paradeigma 1\" Ability { id: \"67BF\", source: \"Zodiark\" }\r\n33.0 \"Keraunos Eidolon\" Ability { id: \"67E1\", source: \"Quetzalcoatl\" }\r\n37.1 \"Styx x6\" Ability { id: \"67F3\", source: \"Zodiark\" } duration 5.5\r\n50.4 \"Ania\" Ability { id: \"67EF\", source: \"Zodiark\" }\r\n60.5 \"Exoterikos 1\" Ability { id: \"67C1\", source: \"Zodiark\" }\r\n69.6 \"Esoterikos 2\" Ability { id: \"67C0\", source: \"Zodiark\" }\r\n69.7 \"Esoteric Dyad/Esoteric Sect\" Ability { id: \"67E[56]\", source: \"Arcane Sigil\" }\r\n\r\n81.8 \"Paradeigma 2\" Ability { id: \"67BF\", source: \"Zodiark\" }\r\n93.8 \"Keraunos Eidolon\" Ability { id: \"67E1\", source: \"Quetzalcoatl\" }\r\n93.9 \"Algedon\" Ability { id: \"67E[CD]\", source: \"Zodiark\" }\r\n94.3 \"Meteoros Eidolon\" Ability { id: \"67E2\", source: \"Behemoth\" }\r\n106.1 \"Phobos\" Ability { id: \"67F0\", source: \"Zodiark\" }\r\n\r\n116.3 \"Paradeigma 3\" Ability { id: \"67BF\", source: \"Zodiark\" }\r\n123.5 \"Exoterikos\" Ability { id: \"67C1\", source: \"Zodiark\" }\r\n135.6 \"Astral Flow\" Ability { id: \"666[23]\", source: \"Zodiark\" }\r\n141.2 \"Esoteric Dyad/Esoteric Sect\" Ability { id: \"67E[56]\", source: \"Arcane Sigil\" }\r\n141.8 \"Opheos Eidolon\" Ability { id: \"67E3\", source: \"python\" }\r\n148.8 \"Ania\" Ability { id: \"67EF\", source: \"Zodiark\" }\r\n\r\n155.9 \"Paradeigma 4\" Ability { id: \"67BF\", source: \"Zodiark\" }\r\n166.0 \"Adikia\" Ability { id: \"67F1\", source: \"Zodiark\" }\r\n167.4 \"Opheos Eidolon\" Ability { id: \"67E3\", source: \"python\" }\r\n\r\n# Adds\r\n177.4 \"--adds targetable--\"\r\n182.3 \"--sync--\" Ability { id: \"6631\", source: \"Roiling Darkness\" }\r\n187.4 \"--sync--\" Ability { id: \"6631\", source: \"Roiling Darkness\" }\r\n190.6 \"Esoteric Pattern 1\" Ability { id: \"67E[456]\", source: \"Arcane Sigil\" }\r\n\r\n192.5 \"--sync--\" Ability { id: \"6631\", source: \"Roiling Darkness\" }\r\n197.6 \"--sync--\" Ability { id: \"6631\", source: \"Roiling Darkness\" }\r\n200.9 \"Esoteric Pattern 2\" Ability { id: \"67E[456]\", source: \"Arcane Sigil\" }\r\n\r\n202.6 \"--sync--\" Ability { id: \"6631\", source: \"Roiling Darkness\" }\r\n207.7 \"--sync--\" Ability { id: \"6631\", source: \"Roiling Darkness\" }\r\n211.2 \"Esoteric Pattern 3\" Ability { id: \"67E[456]\", source: \"Arcane Sigil\" }\r\n\r\n# Note: 67E8 + 67EA is adds still alive, 67E9 + 6D7B means all adds were killed\r\n214.4 \"Apomnemoneumata Enrage?\" Ability { id: \"67E8\", source: \"Zodiark\" }\r\n225.9 \"Apomnemoneumata\" Ability { id: \"6D7A\", source: \"Zodiark\" }\r\n\r\n# Star tethers\r\n314.4 \"--sync--\" Ability { id: \"67E9\", source: \"Zodiark\" } window 300,10\r\n325.9 \"Apomnemoneumata\" Ability { id: \"6D7B\", source: \"Zodiark\" }\r\n336.9 \"--targetable--\"\r\n347.6 \"Astral Eclipse\" Ability { id: \"67C3\", source: \"Zodiark\" }\r\n347.6 \"--untargetable--\"\r\n359.7 \"--targetable--\"\r\n364.7 \"Explosion 1\" Ability { id: \"67E7\", source: \"Zodiark\" }\r\n368.7 \"Explosion 2\" Ability { id: \"67E7\", source: \"Zodiark\" }\r\n372.7 \"Explosion 3\" Ability { id: \"67E7\", source: \"Zodiark\" }\r\n\r\n374.8 \"Triple Esoteric Ray\" Ability { id: \"67C4\", source: \"Zodiark\" }\r\n374.9 \"Esoteric Ray 1\" Ability { id: \"67E4\", source: \"Arcane Sigil\" }\r\n377.9 \"Esoteric Ray 2\" Ability { id: \"67E4\", source: \"Arcane Sigil\" }\r\n390.9 \"Paradeigma 5\" Ability { id: \"67BF\", source: \"Zodiark\" }\r\n406.1 \"Astral Flow\" Ability { id: \"666[23]\", source: \"Zodiark\" }\r\n406.2 \"Infernal Stream\" Ability { id: \"52D1\", source: \"Zodiark\" }\r\n407.2 \"Infernal Torrent\" #Ability { id: \"67E0\", source: \"Zodiark\" } duration 2\r\n411.9 \"Keraunos Eidolon\" Ability { id: \"67E1\", source: \"Quetzalcoatl\" }\r\n412.4 \"Meteoros Eidolon\" Ability { id: \"67E2\", source: \"Behemoth\" }\r\n\r\n425.2 \"Ania\" Ability { id: \"67EF\", source: \"Zodiark\" }\r\n437.3 \"Exoterikos\" Ability { id: \"67C1\", source: \"Zodiark\" }\r\n446.4 \"Algedon\" Ability { id: \"67E[CD]\", source: \"Zodiark\" }\r\n447.5 \"Esoteric Dyad/Esoteric Sect\" Ability { id: \"67E[56]\", source: \"Arcane Sigil\" }\r\n\r\n460.6 \"Paradeigma 6\" Ability { id: \"67BF\", source: \"Zodiark\" }\r\n475.8 \"Astral Flow\" Ability { id: \"666[23]\", source: \"Zodiark\" }\r\n475.9 \"Infernal Stream\" Ability { id: \"52D1\", source: \"Zodiark\" }\r\n476.9 \"Infernal Torrent\" #Ability { id: \"67E0\", source: \"Zodiark\" } duration 2\r\n481.6 \"Keraunos Eidolon\" Ability { id: \"67E1\", source: \"Quetzalcoatl\" }\r\n481.6 \"Opheos Eidolon\" Ability { id: \"67E3\", source: \"python\" }\r\n\r\n486.9 \"Styx x7\" Ability { id: \"67F3\", source: \"Zodiark\" } duration 8\r\n506.0 \"Esoteric Dyad/Esoteric Sect\" Ability { id: \"67E[56]\", source: \"Arcane Sigil\" }\r\n508.3 \"Trimorphos Exoterikos\" Ability { id: \"67C2\", source: \"Zodiark\" }\r\n510.1 \"Esoteric Dyad/Esoteric Sect\" Ability { id: \"67E[56]\", source: \"Arcane Sigil\" }\r\n514.1 \"Esoteric Dyad/Esoteric Sect\" Ability { id: \"67E[56]\", source: \"Arcane Sigil\" }\r\n520.5 \"Adikia\" Ability { id: \"67F1\", source: \"Zodiark\" }\r\n\r\n# Star tethers 2\r\n535.7 \"Astral Eclipse\" Ability { id: \"67C3\", source: \"Zodiark\" }\r\n535.7 \"--untargetable--\"\r\n547.8 \"--targetable--\"\r\n552.8 \"Explosion 1\" Ability { id: \"67E7\", source: \"Zodiark\" }\r\n556.8 \"Explosion 2\" Ability { id: \"67E7\", source: \"Zodiark\" }\r\n560.8 \"Explosion 3\" Ability { id: \"67E7\", source: \"Zodiark\" }\r\n565.3 \"Algedon\" Ability { id: \"67E[CD]\", source: \"Zodiark\" }\r\n577.5 \"Ania\" Ability { id: \"67EF\", source: \"Zodiark\" }\r\n\r\n587.6 \"Paradeigma 7\" Ability { id: \"67BF\", source: \"Zodiark\" }\r\n594.7 \"Exoterikos\" Ability { id: \"67C1\", source: \"Zodiark\" }\r\n606.8 \"Astral Flow\" Ability { id: \"666[23]\", source: \"Zodiark\" }\r\n606.9 \"Infernal Stream\" Ability { id: \"52D1\", source: \"Zodiark\" }\r\n607.9 \"Infernal Torrent\" #Ability { id: \"67E0\", source: \"Zodiark\" } duration 2\r\n612.4 \"Esoteric Dyad/Esoteric Sect\" Ability { id: \"67E[56]\", source: \"Arcane Sigil\" }\r\n613.0 \"Opheos Eidolon\" Ability { id: \"67E3\", source: \"python\" }\r\n615.9 \"Phlegethon x3\" Ability { id: \"67EB\", source: \"Zodiark\" } duration 4\r\n\r\n622.9 \"Styx x8\" Ability { id: \"67F3\", source: \"Zodiark\" } duration 9\r\n639.3 \"Exoterikos\" Ability { id: \"67C1\", source: \"Zodiark\" }\r\n648.4 \"Triple Esoteric Ray\" Ability { id: \"67C4\", source: \"Zodiark\" }\r\n648.5 \"Esoteric Ray 1\" Ability { id: \"67E4\", source: \"Arcane Sigil\" }\r\n648.5 \"Esoteric Dyad/Esoteric Sect\" Ability { id: \"67E[56]\", source: \"Arcane Sigil\" }\r\n651.5 \"Esoteric Ray 2\" Ability { id: \"67E4\", source: \"Arcane Sigil\" }\r\n\r\n659.6 \"Paradeigma 8\" Ability { id: \"67BF\", source: \"Zodiark\" }\r\n666.7 \"Exoterikos\" Ability { id: \"67C1\", source: \"Zodiark\" }\r\n678.8 \"Astral Flow\" Ability { id: \"666[23]\", source: \"Zodiark\" }\r\n678.9 \"Infernal Stream\" Ability { id: \"52D1\", source: \"Zodiark\" }\r\n679.9 \"Infernal Torrent\" #Ability { id: \"67E0\", source: \"Zodiark\" } duration 2\r\n684.4 \"Esoteric Dyad/Esoteric Sect\" Ability { id: \"67E[56]\", source: \"Arcane Sigil\" }\r\n685.0 \"Keraunos Eidolon\" Ability { id: \"67E1\", source: \"Quetzalcoatl\" }\r\n685.5 \"Meteoros Eidolon\" Ability { id: \"67E2\", source: \"Behemoth\" }\r\n\r\n693.9 \"Phobos\" Ability { id: \"67F0\", source: \"Zodiark\" }\r\n714.8 \"Esoteric Sect\" Ability { id: \"67E6\", source: \"Arcane Sigil\" }\r\n717.0 \"Trimorphos Exoterikos\" Ability { id: \"67C2\", source: \"Zodiark\" }\r\n718.7 \"Esoteric Dyad/Esoteric Sect\" Ability { id: \"67E[56]\", source: \"Arcane Sigil\" }\r\n722.7 \"Esoteric Dyad/Esoteric Sect\" Ability { id: \"67E[56]\", source: \"Arcane Sigil\" }\r\n729.2 \"Algedon\" Ability { id: \"67E[CD]\", source: \"Zodiark\" }\r\n738.4 \"Styx x9\" Ability { id: \"67F3\", source: \"Zodiark\" } duration 10\r\n\r\n751.8 \"Paradeigma 9\" Ability { id: \"67BF\", source: \"Zodiark\" }\r\n758.9 \"Exoterikos\" Ability { id: \"67C1\", source: \"Zodiark\" }\r\n771.0 \"Astral Flow\" Ability { id: \"666[23]\", source: \"Zodiark\" }\r\n771.1 \"Infernal Stream\" Ability { id: \"52D1\", source: \"Zodiark\" }\r\n772.1 \"Infernal Torrent\" # Ability { id: \"67E0\", source: \"Zodiark\" } duration 2\r\n776.6 \"Esoteric Dyad/Esoteric Sect\" Ability { id: \"67E[56]\", source: \"Arcane Sigil\" }\r\n777.2 \"Keraunos Eidolon\" Ability { id: \"67E1\", source: \"Quetzalcoatl\" }\r\n777.2 \"Opheos Eidolon\" Ability { id: \"67E3\", source: \"python\" }\r\n\r\n782.1 \"Styx x9\" Ability { id: \"67F3\", source: \"Zodiark\" } duration 10\r\n803.6 \"Apomnemoneumata Enrage\" Ability { id: \"67F5\", source: \"Zodiark\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/zodiark.ts



// TODO: how to call out Astral Flow rotations? Behemoths can be adjacent/catty corner
// TODO: Esoteric Ray has only one id for starting mid / starting sides (maybe startsUsing pos?)
// TODO: Exoterikos has differentiating ids, but need to know where (maybe startsUsing pos?)
// TODO: Astral Eclipse star patterns? Are they fixed?
// TODO: in the last phase, is the Exoterikos always Sect during Triple Esoteric Ray?
// TODO: heal to full for Kokytos
const zodiark_triggerSet = {
  id: 'TheDarkInside',
  zoneId: zone_id/* default.TheDarkInside */.Z.TheDarkInside,
  timelineFile: 'zodiark.txt',
  triggers: [{
    id: 'Zodiark Ania',
    type: 'StartsUsing',
    netRegex: {
      id: '6B62',
      source: 'Zodiark'
    },
    response: responses/* Responses.tankBuster */.n3.tankBuster()
  }, {
    id: 'Zodiark Algedon NE',
    type: 'StartsUsing',
    netRegex: {
      id: '67D1',
      source: 'Zodiark',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    // Warn about knockback just as a precaution in case players don't make it.
    // Also, technically NE/SW is safe, but having all players run together is better.
    outputStrings: {
      text: {
        en: 'Go NE (knockback)',
        de: 'Geh nach NO (Rückstoß)',
        fr: 'Allez au NE (poussée)',
        ja: '北東へ (ノックバック)',
        cn: '去右上 (东北)',
        ko: '북동쪽으로 (넉백)'
      }
    }
  }, {
    id: 'Zodiark Algedon NW',
    type: 'StartsUsing',
    netRegex: {
      id: '67D2',
      source: 'Zodiark',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Go NW (knockback)',
        de: 'Geh nach NW (Rückstoß)',
        fr: 'Allez au NO (poussée)',
        ja: '北西へ (ノックバック)',
        cn: '去左上 (西北)',
        ko: '북서쪽으로 (넉백)'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Esoteric Dyad/Esoteric Sect': 'Esoteric Dyad/Sect'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Arcane Sigil': 'Geheimzeichen',
      'Behemoth': 'Behemoth',
      'Python': 'Python',
      'Zodiark': 'Zodiark'
    },
    'replaceText': {
      'Adikia': 'Adikia',
      'Algedon': 'Algedon',
      'Ania': 'Ania',
      'Astral Eclipse': 'Astraleklipse',
      'Astral Flow': 'Lichtstrom',
      'Complete Control': 'Totale Verbindung',
      'Esoteric Dyad': 'Esoterische Dyade',
      '(?<!Triple )Esoteric Ray': 'Esoterischer Strahl',
      'Esoteric Sect': 'Esoterische Sekte',
      '(?<!Trimorphos )Exoterikos': 'Exoterikos',
      'Explosion': 'Explosion',
      'Kokytos': 'Kokytos',
      'Meteoros Eidolon': 'Meteoros',
      'Opheos Eidolon': 'Opheos',
      'Paradeigma': 'Paradeigma',
      'Phlegethon': 'Phlegethon',
      'Styx': 'Styx',
      'Trimorphos Exoterikos': 'Trimorphos Exoterikos',
      'Triple Esoteric Ray': 'Esoterischer Dreierstrahl'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Arcane Sigil': 'emblème secret',
      'Behemoth': 'béhémoth',
      'Python': 'Python',
      'Zodiark': 'Zordiarche'
    },
    'replaceText': {
      'Adikia': 'Adikia',
      'Algedon': 'Algedon',
      'Ania': 'Ania',
      'Astral Eclipse': 'Éclipse astrale',
      'Astral Flow': 'Flux astral',
      'Complete Control': 'Contrôle total',
      'Esoteric Dyad(?!/)': 'Dyade ésotérique',
      'Esoteric Dyad/Esoteric Sect': 'Dyade/Cabale ésotérique',
      '(?<!Triple )Esoteric Ray': 'Rayon ésotérique',
      '(?<!/)Esoteric Sect': 'Cabale ésotérique',
      '(?<!Trimorphos )Exoterikos': 'Exoterikos',
      'Explosion': 'Explosion',
      'Kokytos': 'Kokytos',
      'Meteoros Eidolon': 'Meteoros',
      'Opheos Eidolon': 'Opheos',
      'Paradeigma': 'Paradeigma',
      'Phlegethon': 'Phlégéthon',
      'Styx': 'Styx',
      'Trimorphos Exoterikos': 'Trimorphos Exoterikos',
      'Triple Esoteric Ray': 'Rayon ésotérique triple'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Arcane Sigil': '秘紋',
      'Behemoth': 'ベヒーモス',
      'Python': 'ピュトン',
      'Zodiark': 'ゾディアーク'
    },
    'replaceText': {
      'Adikia': 'アディキア',
      'Algedon': 'アルゲドン',
      'Ania': 'アニア',
      'Astral Eclipse': 'アストラルエクリプス',
      'Astral Flow': 'アストラルフロウ',
      'Complete Control': '完全接続',
      'Esoteric Dyad': 'エソテリックダイアド',
      '(?<!Triple )Esoteric Ray': 'エソテリックレイ',
      'Esoteric Sect': 'エソテリックセクト',
      '(?<!Trimorphos )Exoterikos': 'エクソーテリコス',
      'Explosion': '爆発',
      'Kokytos': 'コキュートス',
      'Meteoros Eidolon': 'メテオロス・エイドロン',
      'Opheos Eidolon': 'オフェオス・エイドロン',
      'Paradeigma': 'パラデイグマ',
      'Phlegethon': 'プレゲトン',
      'Styx': 'ステュクス',
      'Trimorphos Exoterikos': 'トライ・エクソーテリコス',
      'Triple Esoteric Ray': 'トライ・エソテリックレイ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Arcane Sigil': '秘纹',
      'Behemoth': '贝希摩斯',
      'Python': '大蟒',
      'Zodiark': '佐迪亚克'
    },
    'replaceText': {
      'Adikia': '不义',
      'Algedon': '痛苦',
      'Ania': '悲伤',
      'Astral Eclipse': '星蚀',
      'Astral Flow': '星极超流',
      'Complete Control': '完全控制',
      'Esoteric Dyad': '神秘二分',
      '(?<!Triple )Esoteric Ray': '神秘光线',
      'Esoteric Sect': '神秘切割',
      '(?<!Trimorphos )Exoterikos': '外纹',
      'Explosion': '爆炸',
      'Kokytos': '悲痛',
      'Meteoros Eidolon': '陨石幻影',
      'Opheos Eidolon': '巨蛇幻影',
      'Paradeigma': '范式',
      'Phlegethon': '冥火',
      'Styx': '仇恨',
      'Trimorphos Exoterikos': '三重外纹',
      'Triple Esoteric Ray': '三重神秘光线'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Arcane Sigil': '비문',
      'Behemoth': '베히모스',
      'Python': '퓌톤',
      'Zodiark': '조디아크'
    },
    'replaceText': {
      'Adikia': '불의',
      'Algedon': '아픔',
      'Ania': '핍박',
      'Astral Eclipse': '별들의 식',
      'Astral Flow': '천상의 흐름',
      'Complete Control': '완전 접속',
      'Esoteric Dyad(?!/)': '내밀한 양면',
      'Esoteric Dyad/Esoteric Sect': '내밀한 양면/종파',
      '(?<!/)Esoteric Sect': '내밀한 종파',
      'Explosion': '폭산',
      'Kokytos': '코퀴토스',
      'Meteoros Eidolon': '허깨비 운석',
      'Opheos Eidolon': '허깨비 뱀',
      'Paradeigma': '시범',
      'Phlegethon': '플레게톤',
      'Styx': '스틱스',
      'Trimorphos Exoterikos': '삼중 엑소테리코스',
      'Triple Esoteric Ray': '내밀한 삼중 광선',
      '(?<!Triple )Esoteric Ray': '내밀한 광선',
      '(?<!Trimorphos )Exoterikos': '엑소테리코스'
    }
  }]
};
/* harmony default export */ const zodiark = (zodiark_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/zodiark.txt
const trial_zodiark_namespaceObject = "# Zodiark Normal\r\n# -p 6C27:11.1\r\n# -it \"Zodiark\"\r\n# -ii 6B62 664F 6650 6CD4 63A8 67D9 67DC 67CE 67D3\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n# Useful for syncing, but just noisy.\r\nhideall \"Exoterikos\"\r\nhideall \"Paradeigma\"\r\nhideall \"Triple Esoteric Ray\"\r\n\r\n# Note: Trimorphos Exoterikos is a 13 second cast that goes off midway through\r\n# all of the Esoteric X abilities, so put the name on the start cast instead.\r\n\r\n# Note: Opheos Eidolon sometimes comes from Zodiark/Behemoth and not Python,\r\n# maybe a race condition in FFXIV ACT Plugin?\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n7.1 \"--sync--\" StartsUsing { id: \"6C27\", source: \"Zodiark\" } window 10,10\r\n11.1 \"Kokytos\" Ability { id: \"6C27\", source: \"Zodiark\" }\r\n20.2 \"Exoterikos\" Ability { id: \"6C36\", source: \"Zodiark\" }\r\n27.5 \"Esoteric Sect\" Ability { id: \"67CC\", source: \"Arcane Sigil\" }\r\n31.5 \"Ania\" Ability { id: \"67D5\", source: \"Zodiark\" }\r\n41.6 \"Exoterikos\" Ability { id: \"6C36\", source: \"Zodiark\" }\r\n48.9 \"Esoteric Dyad\" Ability { id: \"67CB\", source: \"Arcane Sigil\" }\r\n58.3 \"Paradeigma\" Ability { id: \"67C8\", source: \"Zodiark\" }\r\n71.0 \"Meteoros Eidolon\" Ability { id: \"67C6\", source: \"Behemoth\" }\r\n76.1 \"Paradeigma\" Ability { id: \"67C8\", source: \"Zodiark\" }\r\n88.3 \"Opheos Eidolon\" Ability { id: \"67C7\", source: [\"Python\", \"Behemoth\", \"Zodiark\"] }\r\n94.9 \"Phlegethon x3\" Ability { id: \"67D0\", source: \"Zodiark\" } duration 4.6\r\n103.1 \"Styx x5\" Ability { id: \"67DB\", source: \"Zodiark\" } duration 5.5\r\n115.7 \"Paradeigma\" Ability { id: \"67C8\", source: \"Zodiark\" }\r\n122.8 \"Exoterikos\" Ability { id: \"6C36\", source: \"Zodiark\" }\r\n129.1 \"Esoteric Dyad/Esoteric Sect\" Ability { id: [\"67CB\", \"67CC\"], source: \"Arcane Sigil\" }\r\n129.4 \"Meteoros Eidolon\" Ability { id: \"67C6\", source: \"Behemoth\" }\r\n\r\n# Cutscene\r\n144.6 \"--sync--\" StartsUsing { id: \"6734\", source: \"Zodiark\" } window 150,10\r\n149.6 \"Complete Control\" Ability { id: \"6734\", source: \"Zodiark\" }\r\n150.2 \"--untargetable--\"\r\n150.3 \"--sync--\" Ability { id: \"67DD\", source: \"Zodiark\" }\r\n174.3 \"--targetable--\"\r\n\r\n179.4 \"Paradeigma\" Ability { id: \"67BF\", source: \"Zodiark\" }\r\n194.5 \"Astral Flow\" Ability { id: \"6EC9\", source: \"Zodiark\" }\r\n205.3 \"Meteoros Eidolon\" Ability { id: \"67C6\", source: \"Behemoth\" }\r\n215.0 \"Adikia\" Ability { id: \"67D8\", source: \"Zodiark\" }\r\n226.2 \"Phlegethon x3\" Ability { id: \"67CF\", source: \"Zodiark\" } duration 4.6\r\n235.3 \"Triple Esoteric Ray\" Ability { id: \"67C4\", source: \"Zodiark\" }\r\n235.4 \"Esoteric Ray 1\" Ability { id: \"67CA\", source: \"Arcane Sigil\" }\r\n238.4 \"Esoteric Ray 2\" Ability { id: \"67CA\", source: \"Arcane Sigil\" }\r\n247.4 \"Algedon\" Ability { id: \"67D[12]\", source: \"Zodiark\" }\r\n253.6 \"Paradeigma\" Ability { id: \"67BF\", source: \"Zodiark\" }\r\n268.7 \"Astral Flow\" Ability { id: \"6630\", source: \"Zodiark\" }\r\n# Note: this mob is sometimes Zodiark and sometimes Python.\r\n274.6 \"Opheos Eidolon\" Ability { id: \"67C7\", source: [\"Python\", \"Behemoth\", \"Zodiark\"] } window 10,10\r\n\r\n# Star tethers\r\n280.9 \"--sync--\" StartsUsing { id: \"67C3\", source: \"Zodiark\" } window 300,10\r\n285.9 \"Astral Eclipse\" Ability { id: \"67C3\", source: \"Zodiark\" }\r\n285.9 \"--untargetable--\"\r\n298.0 \"--targetable--\"\r\n303.0 \"Explosion 1\" Ability { id: \"67CD\", source: \"Zodiark\" }\r\n307.0 \"Explosion 2\" Ability { id: \"67CD\", source: \"Zodiark\" }\r\n311.0 \"Explosion 3\" Ability { id: \"67CD\", source: \"Zodiark\" }\r\n\r\n318.1 \"Styx x5\" Ability { id: \"67DA\", source: \"Zodiark\" } duration 5.5\r\n333.2 \"Kokytos\" Ability { id: \"6C5F\", source: \"Zodiark\" }\r\n338.3 \"Paradeigma\" Ability { id: \"67BF\", source: \"Zodiark\" }\r\n353.4 \"Astral Flow\" Ability { id: [\"662F\", \"6630\"], source: \"Zodiark\" }\r\n359.8 \"Meteoros Eidolon\" Ability { id: \"67C6\", source: \"Behemoth\" }\r\n368.6 \"Styx\" Ability { id: \"67DA\", source: \"Zodiark\" }\r\n378.7 \"Exoterikos\" Ability { id: \"67C1\", source: \"Zodiark\" }\r\n386.8 \"Adikia\" Ability { id: \"67D8\", source: \"Zodiark\" }\r\n388.0 \"Esoteric Dyad\" Ability { id: \"67CB\", source: \"Arcane Sigil\" }\r\n\r\n391.0 \"Trimorphos Exoterikos\" StartsUsing { id: \"67C2\", source: \"Zodiark\" }\r\n401.7 \"Esoteric Dyad/Esoteric Sect\" Ability { id: [\"67CB\", \"67CC\"], source: \"Arcane Sigil\" }\r\n405.7 \"Esoteric Dyad/Esoteric Sect\" Ability { id: [\"67CB\", \"67CC\"], source: \"Arcane Sigil\" }\r\n409.7 \"Esoteric Dyad/Esoteric Sect\" Ability { id: [\"67CB\", \"67CC\"], source: \"Arcane Sigil\" }\r\n416.2 \"Paradeigma\" Ability { id: \"67BF\", source: \"Zodiark\" }\r\n431.4 \"Astral Flow\" Ability { id: [\"662F\", \"6630\"], source: \"Zodiark\" }\r\n437.2 \"Opheos Eidolon\" Ability { id: \"67C7\", source: [\"Python\", \"Behemoth\", \"Zodiark\"] }\r\n446.5 \"Styx x5\" Ability { id: \"67DA\", source: \"Zodiark\" } duration 5.5\r\n456.6 \"Exoterikos\" Ability { id: \"67C1\", source: \"Zodiark\" }\r\n465.7 \"Triple Esoteric Ray\" Ability { id: \"67C4\", source: \"Zodiark\" }\r\n465.8 \"Esoteric Ray 1\" Ability { id: \"67CA\", source: \"Arcane Sigil\" }\r\n465.9 \"Esoteric Sect\" Ability { id: \"67CC\", source: \"Arcane Sigil\" }\r\n468.8 \"Esoteric Ray 2\" Ability { id: \"67CA\", source: \"Arcane Sigil\" }\r\n472.8 \"Ania\" Ability { id: \"67D4\", source: \"Zodiark\" }\r\n\r\n479.0 \"Trimorphos Exoterikos\" StartsUsing { id: \"67C2\", source: \"Zodiark\" }\r\n489.8 \"Esoteric Dyad/Esoteric Sect\" Ability { id: [\"67CB\", \"67CC\"], source: \"Arcane Sigil\" }\r\n493.8 \"Esoteric Dyad/Esoteric Sect\" Ability { id: [\"67CB\", \"67CC\"], source: \"Arcane Sigil\" }\r\n497.1 \"Phlegethon x3\" Ability { id: \"67CF\", source: \"Zodiark\" } duration 4.6\r\n497.7 \"Esoteric Dyad/Esoteric Sect\" Ability { id: [\"67CB\", \"67CC\"], source: \"Arcane Sigil\" }\r\n505.3 \"Styx x5\" Ability { id: \"67DA\", source: \"Zodiark\" } duration 5.5\r\n517.5 \"Algedon\" Ability { id: \"67D[12]\", source: \"Zodiark\" }\r\n530.7 \"Paradeigma\" Ability { id: \"67BF\", source: \"Zodiark\" }\r\n545.9 \"Astral Flow\" Ability { id: [\"662F\", \"6630\"], source: \"Zodiark\" }\r\n551.7 \"Opheos Eidolon\" Ability { id: \"67C7\", source: [\"Python\", \"Behemoth\", \"Zodiark\"] }\r\n561.0 \"Styx x5\" Ability { id: \"67DA\", source: \"Zodiark\" } duration 5.5\r\n571.2 \"Exoterikos\" Ability { id: \"67C1\", source: \"Zodiark\" }\r\n580.3 \"Triple Esoteric Ray\" Ability { id: \"67C4\", source: \"Zodiark\" }\r\n580.4 \"Esoteric Ray 1\" Ability { id: \"67CA\", source: \"Arcane Sigil\" }\r\n580.4 \"Esoteric Sect\" Ability { id: \"67CC\", source: \"Arcane Sigil\" }\r\n583.4 \"Esoteric Ray 2\" Ability { id: \"67CA\", source: \"Arcane Sigil\" }\r\n587.4 \"Ania\" Ability { id: \"67D4\", source: \"Zodiark\" }\r\n\r\n593.5 \"Trimorphos Exoterikos\" StartsUsing { id: \"67C2\", source: \"Zodiark\" } window 50,50 jump 479\r\n604.3 \"Esoteric Dyad/Esoteric Sect\" #Ability { id: [\"67CB\", \"67CC\"], source: \"Arcane Sigil\" }\r\n608.3 \"Esoteric Dyad/Esoteric Sect\" #Ability { id: [\"67CB\", \"67CC\"], source: \"Arcane Sigil\" }\r\n611.6 \"Phlegethon x3\" #Ability { id: \"67CF\", source: \"Zodiark\" } duration 4.6\r\n612.2 \"Esoteric Dyad/Esoteric Sect\" #Ability { id: [\"67CB\", \"67CC\"], source: \"Arcane Sigil\" }\r\n619.8 \"Styx x5\" #Ability { id: \"67DA\", source: \"Zodiark\" } duration 5.5\r\n632.0 \"Algedon\" #Ability { id: \"67D[12]\", source: \"Zodiark\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/zurvan-un.ts
// This file was autogenerated from running npm run sync-files.
// DO NOT EDIT THIS FILE DIRECTLY.
// Edit the source file below and then run `npm run sync-files`
// Source: ui/raidboss/data/03-hw/trial/zurvan-ex.ts





const zurvan_un_triggerSet = {
  id: 'ContainmentBayZ1T9Unreal',
  zoneId: zone_id/* default.ContainmentBayZ1T9Unreal */.Z.ContainmentBayZ1T9Unreal,
  timelineFile: 'zurvan-un.txt',
  initData: () => {
    return {
      isPhaseOne: true
    };
  },
  timelineTriggers: [{
    id: 'ZurvanUN Metal Cutter',
    regex: /Metal Cutter/,
    beforeSeconds: 4,
    suppressSeconds: data => data.isPhaseOne === true ? 10 : 16,
    response: responses/* Responses.tankCleave */.n3.tankCleave()
  }],
  triggers: [{
    id: 'ZurvanUN Phase Tracker',
    type: 'Ability',
    netRegex: {
      id: '8559',
      source: 'Zurvan',
      capture: false
    },
    run: data => data.isPhaseOne = false
  }, {
    id: 'ZurvanUN Wave Cannon Avoid',
    type: 'HeadMarker',
    netRegex: {
      id: '000E'
    },
    alarmText: (data, matches, output) => {
      if (data.me === matches.target) return output.waveCannonTarget();
    },
    alertText: (data, matches, output) => {
      if (!(data.me === matches.target)) return output.avoidWaveCannon({
        target: data.party.member(matches.target)
      });
    },
    outputStrings: {
      waveCannonTarget: {
        en: 'Wave Cannon on YOU',
        de: 'Wellenkanone auf DIR',
        fr: 'Canon plasma sur VOUS',
        ja: '波動砲対象',
        cn: '波动炮点名',
        ko: '파동포 대상자'
      },
      avoidWaveCannon: {
        en: 'Away from ${target} -- Wave Cannon',
        de: 'Weg von ${target} -- Wellenkanone',
        fr: 'Éloignez-vous de ${target} -- Canon plasma',
        ja: '${target} から離れる -- 波動砲',
        cn: '远离 ${target} -- 波动炮',
        ko: '${target} 피하기 -- 파동포'
      }
    }
  }, {
    id: 'ZurvanUN Wave Cannon Stack',
    // Zurvan targets himself with this attack
    type: 'StartsUsing',
    netRegex: {
      id: '857B',
      source: 'Zurvan',
      capture: false
    },
    alertText: (data, _matches, output) => {
      if (data?.waveTarget === data.me)
        // The target is stunned during this mechanic
        return;
      if (data.waveTarget === undefined) return output.unknownStackTarget();
      return output.stackOn({
        player: data.party.member(data.waveTarget)
      });
    },
    outputStrings: {
      unknownStackTarget: outputs/* default.stackMarker */.Z.stackMarker,
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'ZurvanUN Wave Cannon Stack Cleanup',
    type: 'Ability',
    netRegex: {
      id: '857B',
      source: 'Zurvan',
      capture: false
    },
    run: data => delete data.waveTarget
  }, {
    id: 'ZurvanUN Demon Claw',
    type: 'StartsUsing',
    netRegex: {
      id: '857A',
      source: 'Zurvan'
    },
    preRun: (data, matches) => data.waveTarget ??= matches.target,
    alertText: (data, matches, output) => {
      if (matches.target === data.me) return output.demonClawYou();
    },
    outputStrings: {
      demonClawYou: {
        en: 'Knockback from boss on YOU',
        de: 'Rückstoß vom Boss auf DIR',
        fr: 'Poussée depuis le boss sur VOUS',
        ja: 'デモンクロー ノックバック対象',
        cn: 'BOSS击退点名',
        ko: '넉백공격 대상자'
      }
    }
  }, {
    id: 'ZurvanUN Flaming Halberd',
    type: 'HeadMarker',
    netRegex: {
      id: '002C'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 1,
    // Don't spam people who run this solo.
    response: responses/* Responses.spread */.n3.spread()
  }, {
    id: 'ZurvanUN Demonic Dive',
    type: 'HeadMarker',
    netRegex: {
      id: '003E'
    },
    delaySeconds: 1,
    alertText: (data, matches, output) => {
      if (data?.flameTarget === data.me) return;
      if (matches.target === data.me) return output.stackYou();
      return output.stackOn({
        player: data.party.member(matches.target)
      });
    },
    outputStrings: {
      stackYou: outputs/* default.stackOnYou */.Z.stackOnYou,
      stackOn: outputs/* default.stackOnPlayer */.Z.stackOnPlayer
    }
  }, {
    id: 'ZurvanUN Cool Flame Call',
    type: 'HeadMarker',
    netRegex: {
      id: '0017'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: (data, matches) => data.flameTarget ??= matches.target,
    alertText: (_data, _matches, output) => output.demonicSpread(),
    outputStrings: {
      demonicSpread: {
        en: 'Spread -- Don\'t stack!',
        de: 'Verteilen -- Nicht aufeinander!',
        fr: 'Écartez-vous - Ne vous packez pas !',
        ja: '散開 -- 重ならないで！',
        cn: '分散 -- 不要集合!',
        ko: '산개 -- 쉐어맞으면 안됨!'
      }
    }
  }, {
    id: 'ZurvanUN Cool Flame Cleanup',
    type: 'Ability',
    netRegex: {
      id: '855F',
      source: 'Zurvan',
      capture: false
    },
    run: data => delete data.flameTarget
  }, {
    id: 'ZurvanUN Biting Halberd',
    type: 'StartsUsing',
    netRegex: {
      id: '8562',
      source: 'Zurvan',
      capture: false
    },
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'ZurvanUN Tail End',
    type: 'StartsUsing',
    netRegex: {
      id: '8563',
      source: 'Zurvan',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'ZurvanUN Ciclicle',
    type: 'StartsUsing',
    netRegex: {
      id: '8564',
      source: 'Zurvan',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'ZurvanUN Ice And Fire',
    type: 'Ability',
    netRegex: {
      id: '8561',
      source: 'Zurvan',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stay outside hitbox',
        de: 'Auserhalb der Hitbox stehen',
        fr: 'Restez à l\'extérieur de la hitbox',
        ja: '範囲攻撃を避ける',
        cn: '站在判定圈外',
        ko: '히트박스 밖으로'
      }
    }
  }, {
    id: 'ZurvanUN Meracydian Fear',
    type: 'StartsUsing',
    netRegex: {
      id: '856F',
      source: 'Execrated Wile'
    },
    response: responses/* Responses.lookAwayFromSource */.n3.lookAwayFromSource()
  }, {
    id: 'ZurvanUN Tyrfing',
    type: 'StartsUsing',
    netRegex: {
      id: '8576',
      source: 'Zurvan'
    },
    response: responses/* Responses.tankCleave */.n3.tankCleave() // Tyrfing doesn't cleave, but the Fire III follow-up does
  }, {
    id: 'ZurvanUN Southern Cross Stack',
    type: 'StartsUsing',
    netRegex: {
      id: '8565',
      source: 'Zurvan',
      capture: false
    },
    suppressSeconds: 1,
    alarmText: (_data, _matches, output) => output.baitSouthernCross(),
    outputStrings: {
      baitSouthernCross: {
        en: 'Bait Ice Puddles',
        de: 'Eisflächen ködern',
        fr: 'Bait les puddles de glace',
        ja: '氷範囲を捨てる',
        cn: '诱导冰圈',
        ko: '얼음장판 유도'
      }
    }
  }, {
    id: 'ZurvanUN Southern Cross Move',
    type: 'StartsUsing',
    netRegex: {
      id: '8566',
      source: 'Zurvan',
      capture: false
    },
    suppressSeconds: 5,
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'ZurvanUN Infinite Tethers',
    type: 'Tether',
    netRegex: {
      id: ['0005', '0008']
    },
    condition: (data, matches) => [matches.source, matches.target].includes(data.me),
    preRun: (data, matches) => {
      const buddy = data.me === matches.source ? matches.target : matches.source;
      data.tetherBuddy ??= buddy;
    },
    alertText: (data, _matches, output) => {
      return output.tetherBuddy({
        buddy: data.party.member(data.tetherBuddy)
      });
    },
    outputStrings: {
      tetherBuddy: {
        en: 'Tethered with ${buddy}',
        de: 'Mit ${buddy} verbunden',
        fr: 'Lié avec ${buddy}',
        ja: '${buddy} とペア',
        cn: '与 ${buddy} 连线',
        ko: '선 연결 ${buddy}'
      }
    }
  }, {
    // 477 is Infinite Fire, 478 is Infinite Ice
    id: 'ZurvanUN Infinite Debuffs',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['477', '478']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    preRun: (data, matches) => {
      const element = matches.effectId === '477' ? 'fire' : 'ice';
      data.infiniteElement ??= element;
    },
    delaySeconds: 2,
    // Don't overlap the tether buddy call
    infoText: (data, _matches, output) => {
      let element = output.unknown();
      if (data.infiniteElement === 'fire') element = output.fire();
      if (data.infiniteElement === 'ice') element = output.ice();
      return output.infiniteDebuff({
        element: element
      });
    },
    outputStrings: {
      infiniteDebuff: {
        en: '${element} on you',
        de: '${element} auf dir',
        fr: '${element} sur vous',
        ja: '${element} 付与',
        cn: '${element} 点名',
        ko: '${element}'
      },
      fire: {
        en: 'Fire',
        de: 'Feuer',
        fr: 'Feu',
        ja: '炎',
        cn: '火',
        ko: '불'
      },
      ice: {
        en: 'Ice',
        de: 'Eis',
        fr: 'Glace',
        ja: '氷',
        cn: '冰',
        ko: '얼음'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'ZurvanUN Broken Seal',
    type: 'StartsUsing',
    netRegex: {
      id: '857D',
      source: 'Zurvan',
      capture: false
    },
    alertText: (data, _matches, output) => {
      let element = output.unknown();
      if (data.infiniteElement === 'fire') element = output.fire();
      if (data.infiniteElement === 'ice') element = output.ice();
      const buddy = data.tetherBuddy;
      return output.sealTowers({
        element: element,
        buddy: data.party.member(buddy)
      });
    },
    outputStrings: {
      sealTowers: {
        en: '${element} towers with ${buddy}',
        de: '${element} Türme mit ${buddy}',
        fr: 'Tour de ${element} avec ${buddy}',
        ja: '${buddy} と ${element} の塔に入る',
        cn: '与${buddy}踩${element}塔',
        ko: '${element} 기둥 +${buddy}'
      },
      fire: {
        en: 'Fire',
        de: 'Feuer',
        fr: 'Feu',
        ja: '炎',
        cn: '火',
        ko: '불'
      },
      ice: {
        en: 'Ice',
        de: 'Eis',
        fr: 'Glace',
        ja: '氷',
        cn: '冰',
        ko: '얼음'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'ZurvanUN Seal Cleanup',
    type: 'Ability',
    netRegex: {
      id: '857D',
      source: 'Zurvan',
      capture: false
    },
    run: data => {
      delete data.tetherBuddy;
      delete data.infiniteElement;
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Execrated Wile': 'verflucht(?:e|er|es|en) List',
      'Zurvan': 'Zurvan'
    },
    'replaceText': {
      '\\(circles\\)': '(Kreise)',
      '\\(explosion\\)': '(Explosion)',
      '\\(puddle\\)': '(Fläche)',
      '\\(snapshot\\)': '(Speichern)',
      '\\(avoid\\)': '(Vermeiden)',
      '\\(stack\\)': '(Sammeln)',
      'Ahura Mazda': 'Ahura Mazda',
      'Biting Halberd': 'Beißende Hellebarde',
      'Broken Seal': 'Endloses Siegel',
      'Ciclicle': 'Cyclotit',
      'Cool Flame': 'Kühle Flamme',
      'Demonic Dive': 'Dämonenschwung',
      'Fire III': 'Feuga',
      'Flaming Halberd': 'Flammenhellebarde',
      'Flare Star': 'Flare-Stern',
      'Ice and Fire': 'Eis und Feuer',
      'Infinite Fire': 'Endloses Feuer',
      'Infinite Ice': 'Endloses Eis',
      'Metal Cutter': 'Metallschneider',
      'Eidos': 'Sarva',
      'Soar': 'Auffliegen',
      'Southern Cross': 'Kreuz des Südens',
      'Tail End': 'Schweifspitze',
      'The Demon\'s Claw': 'Klaue des Dämonen',
      'Twin Spirit': 'Zwiegeist',
      'Tyrfing': 'Tyrfing',
      'Wave Cannon': 'Wellenkanone',
      'the Purge': 'Läuterung'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Execrated Wile': 'ruse honnie',
      'Zurvan': 'Zurvan'
    },
    'replaceText': {
      '\\(circles\\)': '(Cerles)',
      '\\(explosion\\)': '(Explosion)',
      '\\(puddle\\)': '(Puddle)',
      '\\(snapshot\\)': '(Copie)',
      '\\(avoid\\)': '(Évitez)',
      '\\(stack\\)': '(Package)',
      'Ahura Mazda': 'Ahura Mazda',
      'Biting Halberd': 'Hallebarde mordante',
      'Broken Seal': 'Marque brisée',
      'Ciclicle': 'Cyclictite',
      'Cool Flame': 'Flamme froide',
      'Demonic Dive': 'Plongeon du démon',
      'Fire III': 'Méga Feu',
      'Flaming Halberd': 'Hallebarde de flammes',
      'Flare Star': 'Astre flamboyant',
      'Ice and Fire': 'Glace et feu',
      'Infinite Fire': 'Feu infini',
      'Infinite Ice': 'Glace infinie',
      'Metal Cutter': 'Métaillade',
      'Eidos': 'Sarva',
      'Soar': 'Ascension',
      'Southern Cross': 'Croix du sud',
      'Tail End': 'Pointe de queue',
      'The Demon\'s Claw': 'Griffe du démon',
      'Twin Spirit': 'Double spirituel',
      'Tyrfing': 'Tyrfing',
      'Wave Cannon': 'Canon plasma',
      'the Purge': 'Purge'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Execrated Wile': 'テンパード・ワイル',
      'Zurvan': 'ズルワーン'
    },
    'replaceText': {
      'Ahura Mazda': 'アフラ・マズダー',
      'Biting Halberd': 'バイティングハルバード',
      'Broken Seal': '氷炎の紋',
      'Ciclicle': 'シクリクル',
      'Cool Flame': 'クールフレイム',
      'Demonic Dive': 'デモンダイブ',
      'Fire III': 'ファイガ',
      'Flaming Halberd': 'フレイムハルバード',
      'Flare Star': 'フレアスター',
      'Ice and Fire': 'アイス・アンド・ファイア',
      'Infinite Fire': '炎の刻印',
      'Infinite Ice': '氷の刻印',
      'Metal Cutter': 'メタルカッター',
      'Eidos': '変異',
      'Soar': '飛翔',
      'Southern Cross': 'サザンクロス',
      'Tail End': 'テイルエンド',
      'The Demon\'s Claw': 'デモンクロー',
      'Twin Spirit': 'ツインスピリット',
      'Tyrfing': 'ティルフィング',
      'Wave Cannon': '波動砲',
      'the Purge': 'パージ'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Execrated Wile': '狡诈信徒',
      'Zurvan': '祖尔宛'
    },
    'replaceText': {
      '\\(circles\\)': '(圆)',
      '\\(explosion\\)': '(爆炸)',
      '\\(puddle\\)': '(圈)',
      '\\(snapshot\\)': '(快照)',
      '\\(avoid\\)': '(躲避)',
      '\\(stack\\)': '(集合)',
      'Ahura Mazda': '阿胡拉·马兹达',
      'Biting Halberd': '刺骨冰戟',
      'Broken Seal': '冰炎之纹',
      'Ciclicle': '旋冰射线',
      'Cool Flame': '冷炎',
      'Demonic Dive': '鬼神冲',
      'Fire III': '爆炎',
      'Flaming Halberd': '焚身炎戟',
      'Flare Star': '耀星',
      'Ice and Fire': '冰与火',
      'Infinite Fire': '炎之刻印',
      'Infinite Ice': '冰之刻印',
      'Metal Cutter': '金属利刃',
      'Eidos': '变异',
      'Soar': '飞翔',
      'Southern Cross': '南十字星',
      'Tail End': '煞尾',
      'The Demon\'s Claw': '鬼神之爪',
      'Twin Spirit': '多重灵身',
      'Tyrfing': '提尔锋',
      'Wave Cannon': '波动炮',
      'the Purge': '肃清'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Execrated Wile': '책략의 신도',
      'Zurvan': '주르반'
    },
    'replaceText': {
      '\\(circles\\)': '(원)',
      '\\(explosion\\)': '(폭발)',
      '\\(puddle\\)': '(장판)',
      '\\(snapshot\\)': '(유도)',
      '\\(avoid\\)': '(피하기)',
      '\\(stack\\)': '(쉐어)',
      'Ahura Mazda': '아후라 마즈다',
      'Biting Halberd': '매서운 얼음창',
      'Broken Seal': '얼음불 문장',
      'Ciclicle': '얼음 선풍',
      'Cool Flame': '서늘한 불덩이',
      'Demonic Dive': '귀신강하',
      'Fire III': '파이가',
      'Flaming Halberd': '화염창',
      'Flare Star': '타오르는 별',
      'Ice and Fire': '얼음과 불',
      'Infinite Fire': '불의 각인',
      'Infinite Ice': '얼음의 각인',
      'Metal Cutter': '금속 절단',
      'Eidos': '변이',
      'Soar': '비상',
      'Southern Cross': '남십자성',
      'Tail End': '꼬리 쓸기',
      'The Demon\'s Claw': '귀신의 발톱',
      'Twin Spirit': '쌍둥이 영혼',
      'Tyrfing': '티르핑',
      'Wave Cannon': '파동포',
      'the Purge': '숙청'
    }
  }]
};
/* harmony default export */ const zurvan_un = (zurvan_un_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/trial/zurvan-un.txt
const trial_zurvan_un_namespaceObject = "# This file was autogenerated from running npm run sync-files.\r\n# DO NOT EDIT THIS FILE DIRECTLY.\r\n# Edit the source file below and then run `npm run sync-files`\r\n# Source: ui/raidboss/data/03-hw/trial/zurvan-ex.txt\r\n\r\n# Containment Bay Z1-T9 (Unreal)\r\n# Zurvan Unreal\r\n\r\n# -ic \"Execrated Wile\" \"Execrated Will\" \"Execrated Wit\"\r\n# -ii 855B 855C 8572 8573 8577 859D 859E\r\n# -it Zurvan\r\n\r\n# 855B: Twin Spirit\r\n# 855C: Twin Spirit\r\n# 8572: the South Star\r\n# 8573: the North Star\r\n# 8577: Tyrfing\r\n# 859D: the South Star\r\n# 859E: the North Star\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n# Preliminary phase. No pushes.\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n6.4 \"Metal Cutter\" Ability { id: \"857F\", source: \"Zurvan\" } window 6.5,2.5\r\n10.5 \"Metal Cutter\" Ability { id: \"857F\", source: \"Zurvan\" }\r\n16.6 \"Flare Star (circles)\" Ability { id: \"8557\", source: \"Zurvan\" }\r\n17.3 \"Flare Star (explosion)\" Ability { id: \"8558\", source: \"Zurvan\" }\r\n21.9 \"Metal Cutter\" Ability { id: \"857F\", source: \"Zurvan\" }\r\n28.0 \"Metal Cutter\" Ability { id: \"857F\", source: \"Zurvan\" }\r\n35.0 \"Flare Star (circles)\" Ability { id: \"8557\", source: \"Zurvan\" }\r\n35.7 \"Flare Star (explosion)\" Ability { id: \"8558\", source: \"Zurvan\" }\r\n40.6 \"the Purge\" Ability { id: \"8559\", source: \"Zurvan\" } window 40.6,10\r\n49.6 \"--untargetable--\"\r\n\r\n\r\n58.6 \"--targetable--\"\r\n61.7 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" } window 61.7,2.5 # Different from preliminary phase, so this is safe.\r\n66.8 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n73.9 \"Wave Cannon (avoid)\" Ability { id: \"857C\", source: \"Zurvan\" }\r\n\r\n80.0 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n85.1 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n90.2 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n95.3 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n102.4 \"Wave Cannon (avoid)\" Ability { id: \"857C\", source: \"Zurvan\" }\r\n\r\n108.5 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" } jump 80\r\n113.6 \"Metal Cutter\"\r\n118.7 \"Metal Cutter\"\r\n123.8 \"Metal Cutter\"\r\n130.9 \"Wave Cannon (avoid)\"\r\n137.0 \"Metal Cutter\"\r\n142.1 \"Metal Cutter\"\r\n\r\n\r\n#Phase push at <90%\r\n# It may look like this is two copies of one block,\r\n# but it alternates between one and two Metal Cutters after Soar.\r\n200.0 \"Eidos\" Ability { id: \"855A\", source: \"Zurvan\" } window 200,10\r\n206.1 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n211.2 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n\r\n221.3 \"Soar\" Ability { id: \"857E\", source: \"Zurvan\" } window 30,30\r\n221.4 \"--untargetable--\"\r\n230.4 \"Flaming Halberd\" Ability { id: \"855D\", source: \"Zurvan\" }\r\n235.5 \"Demonic Dive\" Ability { id: \"855E\", source: \"Zurvan\" }\r\n236.4 \"Cool Flame\" Ability { id: \"855F\", source: \"Zurvan\" }\r\n238.5 \"--targetable--\"\r\n241.6 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n246.7 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n254.8 \"The Demon's Claw\" Ability { id: \"857A\", source: \"Zurvan\" }\r\n261.9 \"Wave Cannon (stack)\" Ability { id: \"857B\", source: \"Zurvan\" }\r\n268.0 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n273.1 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n\r\n283.1 \"Soar\" Ability { id: \"857E\", source: \"Zurvan\" } window 30,30\r\n283.2 \"--untargetable--\"\r\n292.2 \"Flaming Halberd\" Ability { id: \"855D\", source: \"Zurvan\" }\r\n297.3 \"Demonic Dive\" Ability { id: \"855E\", source: \"Zurvan\" }\r\n298.2 \"Cool Flame\" Ability { id: \"855F\", source: \"Zurvan\" }\r\n300.3 \"--targetable--\"\r\n303.4 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n311.5 \"The Demon's Claw\" Ability { id: \"857A\", source: \"Zurvan\" }\r\n318.6 \"Wave Cannon (stack)\" Ability { id: \"857B\", source: \"Zurvan\" }\r\n324.7 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n329.8 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n\r\n339.8 \"Soar\" Ability { id: \"857E\", source: \"Zurvan\" } window 30,30 jump 221.3\r\n339.8 \"Twin Spirit\"\r\n339.9 \"--untargetable--\"\r\n348.9 \"Flaming Halberd\"\r\n348.9 \"Twin Spirit\"\r\n354.0 \"Demonic Dive\"\r\n355.0 \"Cool Flame\"\r\n357.1 \"--targetable--\"\r\n\r\n\r\n\r\n# Phase push at <75%\r\n\r\n400.0 \"Eidos\" Ability { id: \"8560\", source: \"Zurvan\" } window 150,50\r\n403.1 \"Ice and Fire\" Ability { id: \"8561\", source: \"Zurvan\" } window 403.1,10\r\n407.2 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n411.2 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n415.2 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n\r\n423.2 \"Biting Halberd\" Ability { id: \"8562\", source: \"Zurvan\" }\r\n429.3 \"Southern Cross (snapshot)\" Ability { id: \"8565\", source: \"Zurvan\" } window 430,10\r\n432.9 \"Southern Cross (puddle)\" Ability { id: \"8566\", source: \"Zurvan\" }\r\n434.6 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n444.7 \"Biting Halberd/Ciclicle/Tail End\" Ability { id: [\"8562\", \"8563\", \"8564\"], source: \"Zurvan\" }\r\n\r\n# This is the earliest point this phase can push\r\n448.8 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n452.9 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n457.0 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n465.1 \"Biting Halberd\" Ability { id: \"8562\", source: \"Zurvan\" } window 15,15 jump 423.2\r\n471.2 \"Southern Cross (snapshot)\"\r\n474.8 \"Southern Cross (puddle)\"\r\n476.5 \"Metal Cutter\"\r\n486.6 \"Biting Halberd/Ciclicle/Tail End\"\r\n494.9 \"Metal Cutter\"\r\n\r\n\r\n\r\n# Intermission push at <69%\r\n# This ability is untranslated, so we ensure it doesn't cause issues in non-JP timelines.\r\n# 鬼神：履行技スタート：演出アクション：極\r\n500.0 \"--sync--\" Ability { id: \"8567\", source: \"Zurvan\" } window 500,10\r\n\r\n# Intermission gauge increases will vary depnding on how fast mobs die and in what order.\r\n# There's no good way to figure out the gauge timing here,\r\n# so just ignore it and hope for the best.\r\n\r\n\r\n\r\n990.3 \"Eidos\" Ability { id: \"8568\", source: \"Zurvan\" } window 500,10\r\n1000.0 \"Ahura Mazda\" Ability { id: \"8569\", source: \"Zurvan\" } window 1000,10\r\n1018.2 \"--targetable--\"\r\n1024.4 \"Infinite Fire/Infinite Ice\" Ability { id: [\"8570\", \"8571\"], source: \"Zurvan\" }\r\n1032.5 \"Wave Cannon (avoid)\" Ability { id: \"857C\", source: \"Zurvan\" }\r\n1039.7 \"Tyrfing x5\" Ability { id: \"8576\", source: \"Zurvan\" } duration 5 window 1040,5\r\n1044.8 \"Fire III\" Ability { id: \"8578\", source: \"Zurvan\" }\r\n1050.9 \"Southern Cross (snapshot)\" Ability { id: \"8565\", source: \"Zurvan\" }\r\n1054.5 \"Southern Cross (puddle)\" Ability { id: \"8566\", source: \"Zurvan\" }\r\n1056.2 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n1065.3 \"Broken Seal\" Ability { id: \"857D\", source: \"Zurvan\" } window 30,30\r\n1081.0 \"Biting Halberd/Ciclicle/Tail End\" Ability { id: [\"8562\", \"8564\", \"8563\"], source: \"Zurvan\" }\r\n1086.3 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n1091.1 \"Infinite Fire/Infinite Ice\" Ability { id: [\"8570\", \"8571\"], source: \"Zurvan\" }\r\n1099.5 \"Wave Cannon (avoid)\" Ability { id: \"857C\", source: \"Zurvan\" }\r\n1106.6 \"Tyrfing x6\" Ability { id: \"8576\", source: \"Zurvan\" } duration 6\r\n1112.7 \"Fire III\" Ability { id: \"8578\", source: \"Zurvan\" }\r\n1118.8 \"Southern Cross (snapshot)\" Ability { id: \"8565\", source: \"Zurvan\" }\r\n1122.4 \"Southern Cross (puddle)\" Ability { id: \"8566\", source: \"Zurvan\" }\r\n1124.1 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n1133.2 \"Broken Seal\" Ability { id: \"857D\", source: \"Zurvan\" }\r\n1147.9 \"Biting Halberd/Ciclicle/Tail End\" Ability { id: [\"8562\", \"8564\", \"8563\"], source: \"Zurvan\" }\r\n1154.0 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n1164.1 \"Soar\" Ability { id: \"857E\", source: \"Zurvan\" } window 100,20\r\n1164.2 \"--untargetable--\"\r\n1173.2 \"Flaming Halberd\" Ability { id: \"855D\", source: \"Zurvan\" }\r\n1178.3 \"Demonic Dive\" Ability { id: \"855E\", source: \"Zurvan\" }\r\n1179.2 \"Cool Flame\" Ability { id: \"855F\", source: \"Zurvan\" }\r\n1181.3 \"--targetable--\"\r\n1187.4 \"The Demon's Claw\" Ability { id: \"857A\", source: \"Zurvan\" }\r\n1194.5 \"Wave Cannon (stack)\" Ability { id: \"857B\", source: \"Zurvan\" }\r\n1200.6 \"Infinite Fire/Infinite Ice\" Ability { id: [\"8570\", \"8571\"], source: \"Zurvan\" }\r\n1208.7 \"Wave Cannon (avoid)\" Ability { id: \"857C\", source: \"Zurvan\" }\r\n1215.8 \"Tyrfing x7\" Ability { id: \"8576\", source: \"Zurvan\" } duration 7\r\n1222.9 \"Fire III\" Ability { id: \"8578\", source: \"Zurvan\" }\r\n1229.0 \"Southern Cross (snapshot)\" Ability { id: \"8565\", source: \"Zurvan\" }\r\n1232.6 \"Southern Cross (puddle)\" Ability { id: \"8566\", source: \"Zurvan\" }\r\n1234.3 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n1243.4 \"Broken Seal\" Ability { id: \"857D\", source: \"Zurvan\" } window 30,30\r\n1258.4 \"Biting Halberd/Ciclicle/Tail End\" Ability { id: [\"8562\", \"8564\", \"8563\"], source: \"Zurvan\" }\r\n1264.5 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n1269.6 \"Infinite Fire/Infinite Ice\" Ability { id: [\"8570\", \"8571\"], source: \"Zurvan\" }\r\n1277.7 \"Wave Cannon (avoid)\" Ability { id: \"857C\", source: \"Zurvan\" }\r\n1284.8 \"Tyrfing x8\" Ability { id: \"8576\", source: \"Zurvan\" } duration 8\r\n1292.9 \"Fire III\" Ability { id: \"8578\", source: \"Zurvan\" }\r\n1299.0 \"Southern Cross (snapshot)\" Ability { id: \"8565\", source: \"Zurvan\" }\r\n1302.6 \"Southern Cross (puddle)\" Ability { id: \"8566\", source: \"Zurvan\" }\r\n1304.3 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n1313.4 \"Broken Seal\" Ability { id: \"857D\", source: \"Zurvan\" }\r\n1328.6 \"Biting Halberd/Ciclicle/Tail End\" Ability { id: [\"8562\", \"8564\", \"8563\"], source: \"Zurvan\" }\r\n1334.8 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n1344.8 \"Soar\" Ability { id: \"857E\", source: \"Zurvan\" } window 100,20\r\n1344.9 \"--untargetable--\"\r\n1353.9 \"Flaming Halberd\" Ability { id: \"855D\", source: \"Zurvan\" }\r\n1359.0 \"Demonic Dive\" Ability { id: \"855E\", source: \"Zurvan\" }\r\n1359.9 \"Cool Flame\" Ability { id: \"855F\", source: \"Zurvan\" }\r\n1362.0 \"--targetable--\"\r\n1368.1 \"The Demon's Claw\" Ability { id: \"857A\", source: \"Zurvan\" }\r\n1375.2 \"Wave Cannon (stack)\" Ability { id: \"857B\", source: \"Zurvan\" }\r\n1381.3 \"Infinite Fire/Infinite Ice\" Ability { id: [\"8570\", \"8571\"], source: \"Zurvan\" }\r\n1389.5 \"Wave Cannon (avoid)\" Ability { id: \"857C\", source: \"Zurvan\" }\r\n1396.6 \"Tyrfing x9\" Ability { id: \"8576\", source: \"Zurvan\" } duration 9\r\n1405.7 \"Fire III\" Ability { id: \"8578\", source: \"Zurvan\" }\r\n1411.8 \"Southern Cross (snapshot)\" Ability { id: \"8565\", source: \"Zurvan\" }\r\n1415.4 \"Southern Cross (puddle)\" Ability { id: \"8566\", source: \"Zurvan\" }\r\n1417.1 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n1426.2 \"Broken Seal\" Ability { id: \"857D\", source: \"Zurvan\" } window 30,30\r\n1441.2 \"Biting Halberd/Ciclicle/Tail End\" Ability { id: [\"8562\", \"8564\", \"8563\"], source: \"Zurvan\" }\r\n\r\n# It should theoretically be impossible to reach here before enrage,\r\n# but just in case we'll unroll a bit more to get to 10x Tyrfings.\r\n1447.4 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n1452.5 \"Infinite Fire/Infinite Ice\" Ability { id: [\"8570\", \"8571\"], source: \"Zurvan\" }\r\n1460.6 \"Wave Cannon (avoid)\" Ability { id: \"857C\", source: \"Zurvan\" }\r\n1467.7 \"Tyrfing x10\" Ability { id: \"8576\", source: \"Zurvan\" } duration 10\r\n1475.8 \"Fire III\" Ability { id: \"8578\", source: \"Zurvan\" }\r\n1481.9 \"Southern Cross (snapshot)\" Ability { id: \"8565\", source: \"Zurvan\" }\r\n1485.5 \"Southern Cross (puddle)\" Ability { id: \"8566\", source: \"Zurvan\" }\r\n1487.2 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n1496.3 \"Broken Seal\" Ability { id: \"857D\", source: \"Zurvan\" }\r\n1511.5 \"Biting Halberd/Ciclicle/Tail End\" Ability { id: [\"8562\", \"8564\", \"8563\"], source: \"Zurvan\" }\r\n1517.7 \"Metal Cutter\" Ability { id: \"8579\", source: \"Zurvan\" }\r\n1527.7 \"Soar\" Ability { id: \"857E\", source: \"Zurvan\" }\r\n1527.8 \"--untargetable--\"\r\n\r\n\r\n\r\n# Enrage at 12 minutes\r\n1989.7 \"--sync--\" StartsUsing { id: \"8592\", source: \"Zurvan\" } window 2000,100\r\n1998.8 \"Flame Halberd Enrage\" Ability { id: \"8592\", source: \"Zurvan\" }\r\n1998.8 \"--untargetable--\"\r\n2000.0 \"--sync--\" Ability { id: \"8591\", source: \"Zurvan\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/ultimate/dragonsongs_reprise_ultimate.ts







// TODO: Ser Adelphel left/right movement after initial charge
// TODO: Meteor "run" call?
// TODO: Wyrmsbreath 2 cardinal positions for Cauterize and adjust delay
// TODO: Trigger for Hallowed Wings with Hot Tail/Hot Wings
// TODO: Phase 6 Resentment callout?
const playstationMarkers = ['circle', 'cross', 'triangle', 'square'];
// Due to changes introduced in patch 5.2, overhead markers now have a random offset
// added to their ID. This offset currently appears to be set per instance, so
// we can determine what it is from the first overhead marker we see.
const dragonsongs_reprise_ultimate_headmarkers = {
  // vfx/lockon/eff/lockon6_t0t.avfx
  'hyperdimensionalSlash': '00EA',
  // vfx/lockon/eff/r1fz_firechain_01x.avfx through 04x
  'firechainCircle': '0119',
  'firechainTriangle': '011A',
  'firechainSquare': '011B',
  'firechainX': '011C',
  // vfx/lockon/eff/r1fz_skywl_s9x.avfx
  'skywardTriple': '014A',
  // vfx/lockon/eff/m0244trg_a1t.avfx and a2t
  'sword1': '0032',
  'sword2': '0033',
  // vfx/lockon/eff/r1fz_holymeteo_s12x.avfx
  'meteor': '011D',
  // vfx/lockon/eff/r1fz_lockon_num01_s5x.avfx through num03
  'dot1': '013F',
  'dot2': '0140',
  'dot3': '0141',
  // vfx/lockon/eff/m0005sp_19o0t.avfx
  'skywardSingle': '000E',
  // vfx/lockon/eff/bahamut_wyvn_glider_target_02tm.avfx
  'cauterize': '0014'
};
const playstationHeadmarkerIds = [dragonsongs_reprise_ultimate_headmarkers.firechainCircle, dragonsongs_reprise_ultimate_headmarkers.firechainTriangle, dragonsongs_reprise_ultimate_headmarkers.firechainSquare, dragonsongs_reprise_ultimate_headmarkers.firechainX];
const playstationMarkerMap = {
  [dragonsongs_reprise_ultimate_headmarkers.firechainCircle]: 'circle',
  [dragonsongs_reprise_ultimate_headmarkers.firechainTriangle]: 'triangle',
  [dragonsongs_reprise_ultimate_headmarkers.firechainSquare]: 'square',
  [dragonsongs_reprise_ultimate_headmarkers.firechainX]: 'cross'
};
const firstMarker = phase => {
  return phase === 'doorboss' ? dragonsongs_reprise_ultimate_headmarkers.hyperdimensionalSlash : dragonsongs_reprise_ultimate_headmarkers.skywardTriple;
};
const dragonsongs_reprise_ultimate_getHeadmarkerId = (data, matches, firstDecimalMarker) => {
  // If we naively just check !data.decOffset and leave it, it breaks if the first marker is 00DA.
  // (This makes the offset 0, and !0 is true.)
  if (data.decOffset === undefined) {
    // This must be set the first time this function is called in DSR Headmarker Tracker.
    if (firstDecimalMarker === undefined) throw new not_reached/* UnreachableCode */.$();
    data.decOffset = parseInt(matches.id, 16) - firstDecimalMarker;
  }
  // The leading zeroes are stripped when converting back to string, so we re-add them here.
  // Fortunately, we don't have to worry about whether or not this is robust,
  // since we know all the IDs that will be present in the encounter.
  return (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase().padStart(4, '0');
};

// Calculate combatant position in an all 8 cards/intercards
const dragonsongs_reprise_ultimate_matchedPositionTo8Dir = combatant => {
  // Positions are moved up 100 and right 100
  const y = combatant.PosY - 100;
  const x = combatant.PosX - 100;

  // During Thordan, knight dives start at the 8 cardinals + numerical
  // slop on a radius=23 circle.
  // N = (100, 77), E = (123, 100), S = (100, 123), W = (77, 100)
  // NE = (116.26, 83.74), SE = (116.26, 116.26), SW = (83.74, 116.26), NW = (83.74, 83.74)
  //
  // Map NW = 0, N = 1, ..., W = 7

  return Math.round(5 - 4 * Math.atan2(x, y) / Math.PI) % 8;
};

// Calculate combatant position in 4 cardinals
const matchedPositionTo4Dir = combatant => {
  // Positions are moved up 100 and right 100
  const y = combatant.PosY - 100;
  const x = combatant.PosX - 100;

  // During the vault knights, Adelphel will jump to one of the 4 cardinals
  // N = (100, 78), E = (122, 100), S = (100, 122), W = (78, 100)
  //
  // N = 0, E = 1, S = 2, W = 3

  return Math.round(2 - 2 * Math.atan2(x, y) / Math.PI) % 4;
};
const dragonsongs_reprise_ultimate_triggerSet = {
  id: 'DragonsongsRepriseUltimate',
  zoneId: zone_id/* default.DragonsongsRepriseUltimate */.Z.DragonsongsRepriseUltimate,
  timelineFile: 'dragonsongs_reprise_ultimate.txt',
  initData: () => {
    return {
      combatantData: [],
      phase: 'doorboss',
      firstAdelphelJump: true,
      brightwingCounter: 1,
      thordanMeteorMarkers: [],
      diveFromGraceNum: {},
      diveFromGraceHasArrow: {
        1: false,
        2: false,
        3: false
      },
      diveFromGraceLashGnashKey: 'unknown',
      diveFromGracePositions: {},
      diveFromGraceDir: {},
      eyeOfTheTyrantCounter: 0,
      diveFromGracePreviousPosition: {},
      diveCounter: 1,
      thunderstruck: [],
      hasDoom: {},
      deathMarker: {},
      hallowedWingsCount: 0,
      spreadingFlame: [],
      entangledFlame: []
    };
  },
  timelineTriggers: [{
    id: 'DSR Eye of the Tyrant Counter',
    regex: /Eye of the Tyrant/,
    beforeSeconds: 1,
    run: data => data.eyeOfTheTyrantCounter++
  }, {
    id: 'DSR Resentment',
    regex: /Resentment/,
    beforeSeconds: 5,
    condition: data => data.phase === 'nidhogg',
    response: responses/* Responses.bleedAoe */.n3.bleedAoe()
  }, {
    id: 'DSR Mortal Vow',
    regex: /Mortal Vow/,
    // 3.7s to avoid early movement at Touchdown and last Mortal Vow
    beforeSeconds: 3.7,
    durationSeconds: 3.7,
    infoText: (data, _matches, output) => {
      if (data.me === data.mortalVowPlayer) return output.vowOnYou();
      if (data.mortalVowPlayer !== undefined) return output.vowOn({
        player: data.party.member(data.mortalVowPlayer)
      });
      return output.vowSoon();
    },
    outputStrings: {
      vowOnYou: {
        en: 'Vow on you',
        de: 'Schwur auf DIR',
        fr: 'Vœu sur VOUS',
        ja: '自分に滅殺',
        cn: '毒点名',
        ko: '멸살의 맹세 대상자'
      },
      vowOn: {
        en: 'Vow on ${player}',
        de: 'Schwur auf ${player}',
        fr: 'Vœu sur ${player}',
        ja: '${player}に滅殺',
        cn: '毒点 ${player}',
        ko: '${player} 멸살의 맹세'
      },
      vowSoon: {
        en: 'Vow soon (Spread)',
        de: 'Schwur bald (verteilen)',
        fr: 'Vœu bientôt (Écartez-vous)',
        ja: 'まもなく滅殺 (散会)',
        cn: '即将上毒 (分散)',
        ko: '곧 멸살의 맹세 (산개)'
      }
    }
  }],
  triggers: [{
    id: 'DSR Phase Tracker',
    type: 'StartsUsing',
    // 62D4 = Holiest of Holy
    // 63C8 = Ascalon's Mercy Concealed
    // 6708 = Final Chorus
    // 62E2 = Spear of the Fury
    // 6B86 = Incarnation
    netRegex: {
      id: ['62D4', '63C8', '6708', '62E2', '6B86'],
      capture: true
    },
    run: (data, matches) => {
      // On the unlikely chance that somebody proceeds directly from the checkpoint into the next phase.
      data.brightwingCounter = 1;
      switch (matches.id) {
        case '62D4':
          data.phase = 'doorboss';
          break;
        case '63C8':
          data.phase = 'thordan';
          break;
        case '6708':
          data.phase = 'nidhogg';
          break;
        case '62E2':
          // This ability is used in both doorboss and haurchefant.
          if (data.phase !== 'doorboss') data.phase = 'haurchefant';
          break;
        case '6B86':
          data.phase = 'thordan2';
          break;
      }
    }
  }, {
    id: 'DSR Phase Tracker P6 and P7',
    type: 'Ability',
    // 6667 = unknown_6667
    // 71E4 = Shockwave
    netRegex: {
      id: ['6667', '71E4']
    },
    suppressSeconds: 1,
    run: (data, matches) => {
      switch (matches.id) {
        case '6667':
          data.phase = 'nidhogg2';
          break;
        case '71E4':
          data.phase = 'dragon-king';
          break;
      }
    }
  }, {
    id: 'DSR Headmarker Tracker',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.decOffset === undefined,
    // Unconditionally set the first headmarker here so that future triggers are conditional.
    run: (data, matches) => {
      const firstHeadmarker = parseInt(firstMarker(data.phase), 16);
      dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches, firstHeadmarker);
    }
  }, {
    id: 'DSR Holiest of Holy',
    type: 'StartsUsing',
    netRegex: {
      id: '62D4',
      source: 'Ser Adelphel',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'DSR Holiest Hallowing',
    type: 'StartsUsing',
    netRegex: {
      id: '62D0',
      source: 'Ser Adelphel'
    },
    response: responses/* Responses.interrupt */.n3.interrupt()
  }, {
    id: 'DSR Empty Dimension',
    type: 'StartsUsing',
    netRegex: {
      id: '62DA',
      source: 'Ser Grinnaux',
      capture: false
    },
    alertText: (data, _matches, output) => {
      return data.phase !== 'doorboss' || data.seenEmptyDimension ? output.in() : output.inAndTether();
    },
    run: data => data.seenEmptyDimension = true,
    outputStrings: {
      inAndTether: {
        en: 'In + Tank Tether',
        de: 'Rein + Tank-Verbindung',
        fr: 'Intérieur + Liens tanks',
        ja: '中へ + タンク線取り',
        cn: '中间 + 坦克接线',
        ko: '안으로 + 탱커가 선 가로채기'
      },
      in: outputs/* default.in */.Z["in"]
    }
  }, {
    id: 'DSR Full Dimension',
    type: 'StartsUsing',
    netRegex: {
      id: '62DB',
      source: 'Ser Grinnaux',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'DSR Faith Unmoving',
    type: 'StartsUsing',
    netRegex: {
      id: '62DC',
      source: 'Ser Grinnaux',
      capture: false
    },
    condition: data => {
      // Drop the knockback call during Playstation2 as there is too much going on.
      if (data.phase === 'thordan2') return false;
      return data.phase !== 'doorboss' || data.adelphelDir === undefined;
    },
    response: responses/* Responses.knockback */.n3.knockback()
  }, {
    id: 'DSR Hyperdimensional Slash Headmarker',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => data.phase === 'doorboss' && data.me === matches.target,
    alertText: (data, matches, output) => {
      const id = dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches);
      if (id === dragonsongs_reprise_ultimate_headmarkers.hyperdimensionalSlash) return output.slashOnYou();
    },
    outputStrings: {
      slashOnYou: {
        en: 'Slash on YOU',
        de: 'Schlag auf DIR',
        fr: 'Slash sur VOUS',
        ja: '自分にハイパーディメンション',
        cn: '空间斩点名',
        ko: '고차원 대상자'
      }
    }
  }, {
    id: 'DSR Adelphel ID Tracker',
    // 62D2 Is Ser Adelphel's Holy Bladedance, casted once during the encounter
    type: 'Ability',
    netRegex: {
      id: '62D2',
      source: 'Ser Adelphel'
    },
    run: (data, matches) => data.adelphelId = matches.sourceId
  }, {
    id: 'DSR Adelphel KB Direction',
    type: 'NameToggle',
    netRegex: {
      toggle: '01'
    },
    condition: (data, matches) => data.phase === 'doorboss' && matches.id === data.adelphelId && data.firstAdelphelJump,
    // Delay 0.1s here to prevent any race condition issues with getCombatants
    delaySeconds: 0.1,
    promise: async (data, matches) => {
      data.firstAdelphelJump = false;
      // Select Ser Adelphel
      let adelphelData = null;
      adelphelData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.id, 16)]
      });

      // if we could not retrieve combatant data, the
      // trigger will not work, so just resume promise here
      if (adelphelData === null) {
        console.error(`Ser Adelphel: null data`);
        return;
      }
      const adelphelDataLength = adelphelData.combatants.length;
      if (adelphelDataLength !== 1) {
        console.error(`Ser Adelphel: expected 1 combatants got ${adelphelDataLength}`);
        return;
      }

      // Add the combatant's position
      const adelphel = adelphelData.combatants.pop();
      if (!adelphel) throw new not_reached/* UnreachableCode */.$();
      data.adelphelDir = matchedPositionTo4Dir(adelphel);
    },
    infoText: (data, _matches, output) => {
      // Map of directions, reversed to call out KB direction
      const dirs = {
        0: output.south(),
        1: output.west(),
        2: output.north(),
        3: output.east(),
        4: output.unknown()
      };
      return output.adelphelLocation({
        dir: dirs[data.adelphelDir ?? 4]
      });
    },
    run: data => delete data.adelphelDir,
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      east: outputs/* default.east */.Z.east,
      south: outputs/* default.south */.Z.south,
      west: outputs/* default.west */.Z.west,
      unknown: outputs/* default.unknown */.Z.unknown,
      adelphelLocation: {
        en: 'Go ${dir} (knockback)',
        de: 'Geh ${dir} (Rückstoß)',
        fr: 'Allez ${dir} (Poussée)',
        ja: '${dir}へ (ノックバック)',
        cn: '去 ${dir} (击退)',
        ko: '${dir}으로 (넉백)'
      }
    }
  }, {
    id: 'DSR Playstation Fire Chains',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => data.phase === 'doorboss' && data.me === matches.target,
    alertText: (data, matches, output) => {
      const id = dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches);
      if (id === dragonsongs_reprise_ultimate_headmarkers.firechainCircle) return output.circle();
      if (id === dragonsongs_reprise_ultimate_headmarkers.firechainTriangle) return output.triangle();
      if (id === dragonsongs_reprise_ultimate_headmarkers.firechainSquare) return output.square();
      if (id === dragonsongs_reprise_ultimate_headmarkers.firechainX) return output.cross();
    },
    outputStrings: {
      circle: {
        en: 'Red Circle',
        de: 'Roter Kreis',
        fr: 'Cercle rouge',
        ja: '赤まる',
        cn: '红圆圈',
        ko: '빨강 동그라미'
      },
      triangle: {
        en: 'Green Triangle',
        de: 'Grünes Dreieck',
        fr: 'Triangle vert',
        ja: '緑さんかく',
        cn: '绿三角',
        ko: '초록 삼각'
      },
      square: {
        en: 'Purple Square',
        de: 'Lilanes Viereck',
        fr: 'Carré violet',
        ja: '紫しかく',
        cn: '紫方块',
        ko: '보라 사각'
      },
      cross: {
        en: 'Blue X',
        de: 'Blaues X',
        fr: 'Croix bleue',
        ja: '青バツ',
        cn: '蓝X',
        ko: '파랑 X'
      }
    }
  }, {
    id: 'DSR Brightwing Counter',
    type: 'Ability',
    // Visually, this comes from Ser Charibert.  However, ~30% of the time
    // the first set of Brightwing cleaves come from King Thordan/Ser Hermonst
    // entities.  This is likely just stale combatant data from the ffxiv plugin.
    netRegex: {
      id: '6319',
      capture: false
    },
    // One ability for each player hit (hopefully only two??)
    suppressSeconds: 1,
    infoText: (data, _matches, output) => output[`dive${data.brightwingCounter}`](),
    run: data => data.brightwingCounter++,
    outputStrings: {
      // Ideally folks can customize this with who needs to run in.
      dive1: outputs/* default.num1 */.Z.num1,
      dive2: outputs/* default.num2 */.Z.num2,
      dive3: outputs/* default.num3 */.Z.num3,
      dive4: outputs/* default.num4 */.Z.num4
    }
  }, {
    id: 'DSR Brightwing Move',
    type: 'Ability',
    netRegex: {
      id: '6319',
      source: 'Ser Charibert'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // Once hit, drop your Skyblind puddle somewhere else.
    response: responses/* Responses.moveAway */.n3.moveAway('alert')
  }, {
    id: 'DSR Skyblind',
    // 631A Skyblind (2.2s cast) is a targeted ground aoe where A65 Skyblind
    // effect expired on the player.
    type: 'GainsEffect',
    netRegex: {
      effectId: 'A65'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration),
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'DSR Ascalon\'s Mercy Concealed',
    type: 'StartsUsing',
    netRegex: {
      id: '63C8',
      source: 'King Thordan',
      capture: true
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime),
    response: responses/* Responses.moveAway */.n3.moveAway()
  }, {
    id: 'DSR Spiral Thrust Safe Spots',
    // 63D3 Strength of the Ward
    type: 'Ability',
    netRegex: {
      id: '63D3',
      source: 'King Thordan',
      capture: false
    },
    condition: data => data.phase === 'thordan',
    // It appears that these adds can be in place at ~4.5s, but with latency this may fail for some.
    delaySeconds: 5,
    promise: async data => {
      // Collect Ser Vellguine (3636), Ser Paulecrain (3637), Ser Ignasse (3638) entities
      const vellguineLocaleNames = {
        en: 'Ser Vellguine',
        de: 'Vellguine',
        fr: 'Sire Vellguine',
        ja: '聖騎士ヴェルギーン',
        cn: '圣骑士韦尔吉纳',
        ko: '성기사 벨긴'
      };
      const paulecrainLocaleNames = {
        en: 'Ser Paulecrain',
        de: 'Paulecrain',
        fr: 'Sire Paulecrain',
        ja: '聖騎士ポールクラン',
        cn: '圣骑士波勒克兰',
        ko: '성기사 폴르크랭'
      };
      const ignasseLocaleNames = {
        en: 'Ser Ignasse',
        de: 'Ignasse',
        fr: 'Sire Ignassel',
        ja: '聖騎士イニアセル',
        cn: '圣骑士伊尼亚斯',
        ko: '성기사 이냐스'
      };

      // Select the knights
      const combatantNameKnights = [];
      combatantNameKnights.push(vellguineLocaleNames[data.parserLang] ?? vellguineLocaleNames['en']);
      combatantNameKnights.push(paulecrainLocaleNames[data.parserLang] ?? paulecrainLocaleNames['en']);
      combatantNameKnights.push(ignasseLocaleNames[data.parserLang] ?? ignasseLocaleNames['en']);
      const spiralThrusts = [];
      const knightCombatantData = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        names: combatantNameKnights
      });

      // if we could not retrieve combatant data, the
      // trigger will not work, so just resume promise here
      if (knightCombatantData === null) {
        console.error(`Spiral Thrust: null data`);
        return;
      }
      const combatantDataLength = knightCombatantData.combatants.length;
      if (combatantDataLength !== 3) {
        console.error(`Spiral Thrust: expected 3 combatants got ${combatantDataLength}`);
        return;
      }
      for (const combatant of knightCombatantData.combatants) spiralThrusts.push(dragonsongs_reprise_ultimate_matchedPositionTo8Dir(combatant));
      const [thrust0, thrust1, thrust2] = spiralThrusts;
      if (thrust0 === undefined || thrust1 === undefined || thrust2 === undefined) return;

      // Array of dirNums
      const dirNums = [0, 1, 2, 3, 4, 5, 6, 7];

      // Remove where the knights are at and where they will go to
      delete dirNums[(thrust0 + 4) % 8];
      delete dirNums[thrust0];
      delete dirNums[(thrust1 + 4) % 8];
      delete dirNums[thrust1];
      delete dirNums[(thrust2 + 4) % 8];
      delete dirNums[thrust2];

      // Remove null elements from the array to get remaining two dirNums
      dirNums.forEach(dirNum => {
        if (dirNum !== null) (data.spiralThrustSafeZones ??= []).push(dirNum);
      });
    },
    infoText: (data, _matches, output) => {
      data.spiralThrustSafeZones ??= [];
      if (data.spiralThrustSafeZones.length !== 2) {
        console.error(`Spiral Thrusts: expected 2 safe zones got ${data.spiralThrustSafeZones.length}`);
        return;
      }
      // Map of directions
      const dirs = {
        0: output.northwest(),
        1: output.north(),
        2: output.northeast(),
        3: output.east(),
        4: output.southeast(),
        5: output.south(),
        6: output.southwest(),
        7: output.west(),
        8: output.unknown()
      };
      return output.safeSpots({
        dir1: dirs[data.spiralThrustSafeZones[0] ?? 8],
        dir2: dirs[data.spiralThrustSafeZones[1] ?? 8]
      });
    },
    run: data => delete data.spiralThrustSafeZones,
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      northeast: outputs/* default.northeast */.Z.northeast,
      east: outputs/* default.east */.Z.east,
      southeast: outputs/* default.southeast */.Z.southeast,
      south: outputs/* default.south */.Z.south,
      southwest: outputs/* default.southwest */.Z.southwest,
      west: outputs/* default.west */.Z.west,
      northwest: outputs/* default.northwest */.Z.northwest,
      unknown: outputs/* default.unknown */.Z.unknown,
      safeSpots: {
        en: '${dir1} / ${dir2}',
        de: '${dir1} / ${dir2}',
        fr: '${dir1} / ${dir2}',
        ja: '${dir1} / ${dir2}',
        cn: '${dir1} / ${dir2}',
        ko: '${dir1} / ${dir2}'
      }
    }
  }, {
    id: 'DSR Dragon\'s Rage',
    type: 'Ability',
    netRegex: {
      id: '63D7',
      source: 'Ser Guerrique',
      capture: false
    },
    durationSeconds: 7,
    promise: async data => {
      // These are the first actions these actors take, so can't easily get their ids earlier.
      // Therefore, use names.  There should be exactly one of each.
      // TODO: maybe we need data function to do this sort of translating so it's
      // not duplicating the timelineReplace section below.
      const names = {
        en: ['Ser Adelphel', 'Ser Janlenoux'],
        de: ['Adelphel', 'Janlenoux'],
        fr: ['Sire Adelphel', 'Sire Janlenoux'],
        ja: ['聖騎士アデルフェル', '聖騎士ジャンルヌ'],
        cn: ['圣骑士阿代尔斐尔', '圣骑士让勒努'],
        ko: ['성기사 아델펠', '성기사 장르누']
      };
      const combatantNames = names[data.parserLang] ?? names['en'];
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        names: combatantNames
      })).combatants;
    },
    // Deliberately don't play a sound here, because there's also a sound for the
    // Ascalon's Mercy Concealed and you don't want people to be jumpy.
    sound: '',
    infoText: (data, _matches, output) => {
      const [c1, c2] = data.combatantData;
      if (data.combatantData.length !== 2 || c1 === undefined || c2 === undefined) {
        console.error(`DragonsRage: wrong length: ${JSON.stringify(data.combatantData)}`);
        return;
      }

      // Ser Adelphel and Ser Janlenoux appear on the field in two spots.  It is random which
      // side they are on.  Thordan appears opposite of them.  If they are SW and SE, then
      // Thordan is N.  They will always be two spaces apart.
      let d1 = dragonsongs_reprise_ultimate_matchedPositionTo8Dir(c1);
      let d2 = dragonsongs_reprise_ultimate_matchedPositionTo8Dir(c2);

      // Adjust for wrapping around n=0/8 so that we can average the two points below.
      if (d2 === 6 && d1 === 0 || d2 === 7 && d1 === 1) d1 += 8;
      if (d1 === 6 && d2 === 0 || d1 === 7 && d2 === 1) d2 += 8;

      // After the above adjustment to handle modular math wrapping,
      // d1 and d2 should be exactly two spaces apart.
      if (d2 - d1 !== 2 && d1 - d2 !== 2) {
        console.error(`DragonsRage: bad dirs: ${d1}, ${d2}, ${JSON.stringify(data.combatantData)}`);
        return;
      }

      // Average to find the point between d1 and d2, then add 4 to find its opposite.
      const thordanDir = (Math.floor((d1 + d2) / 2) + 4) % 8;
      const dirs = {
        0: output.northwest(),
        1: output.north(),
        2: output.northeast(),
        3: output.east(),
        4: output.southeast(),
        5: output.south(),
        6: output.southwest(),
        7: output.west()
      };
      return output.thordanLocation({
        dir: dirs[thordanDir] ?? output.unknown()
      });
    },
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      northeast: outputs/* default.northeast */.Z.northeast,
      east: outputs/* default.east */.Z.east,
      southeast: outputs/* default.southeast */.Z.southeast,
      south: outputs/* default.south */.Z.south,
      southwest: outputs/* default.southwest */.Z.southwest,
      west: outputs/* default.west */.Z.west,
      northwest: outputs/* default.northwest */.Z.northwest,
      unknown: outputs/* default.unknown */.Z.unknown,
      thordanLocation: {
        en: '${dir} Thordan',
        de: '${dir} Thordan',
        fr: '${dir} Thordan',
        ja: 'トールダン ${dir}',
        cn: '骑神 ${dir}',
        ko: '토르당 ${dir}'
      }
    }
  }, {
    id: 'DSR Skyward Leap',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => data.phase === 'thordan' && data.me === matches.target,
    alertText: (data, matches, output) => {
      const id = dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches);
      if (id === dragonsongs_reprise_ultimate_headmarkers.skywardTriple) return output.leapOnYou();
    },
    outputStrings: {
      leapOnYou: {
        en: 'Leap on YOU',
        de: 'Sprung auf DIR',
        fr: 'Saut sur VOUS',
        ja: '自分に青マーカー',
        cn: '蓝球点名',
        ko: '광역 대상자'
      }
    }
  }, {
    id: 'DSR Ancient Quaga',
    type: 'StartsUsing',
    netRegex: {
      id: '63C6',
      source: 'King Thordan',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'DSR Heavenly Heel',
    type: 'StartsUsing',
    netRegex: {
      id: '63C7',
      source: 'King Thordan'
    },
    response: responses/* Responses.tankBusterSwap */.n3.tankBusterSwap('alert', 'alert')
  }, {
    id: 'DSR Sanctity of the Ward Direction',
    type: 'Ability',
    netRegex: {
      id: '63E1',
      source: 'King Thordan',
      capture: false
    },
    condition: data => data.phase === 'thordan',
    delaySeconds: 4.7,
    // Keep message up until knights are done dashing
    durationSeconds: 13,
    promise: async (data, _matches, output) => {
      // The two gladiators spawn in one of two positions: West (95, 100) or East (105, 100).
      // This triggers uses east/west location of the white knight, Ser Janlennoux (3635) to
      // determine where both knights will dash as they each only look in two directions.
      // Ser Janlenoux only looks towards the north (northeast or northwest).
      // Ser Adelphel only looks towards the south (southwest or southeast).
      // Thus we can just use one knight and get whether it is east or west for location.
      // Callout assumes starting from DRK position, but for east/west (two-movement strategy)
      // you can reverse the cw/ccw callout.
      const janlenouxLocaleNames = {
        en: 'Ser Janlenoux',
        de: 'Janlenoux',
        fr: 'Sire Janlenoux',
        ja: '聖騎士ジャンルヌ',
        cn: '圣骑士让勒努',
        ko: '성기사 장르누'
      };

      // Select Ser Janlenoux
      let combatantNameJanlenoux = null;
      combatantNameJanlenoux = janlenouxLocaleNames[data.parserLang];
      let combatantDataJanlenoux = null;
      if (combatantNameJanlenoux !== undefined) {
        combatantDataJanlenoux = await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
          call: 'getCombatants',
          names: [combatantNameJanlenoux]
        });
      }

      // if we could not retrieve combatant data, the
      // trigger will not work, so just resume promise here
      if (combatantDataJanlenoux === null) {
        console.error(`Ser Janlenoux: null data`);
        return;
      }
      const combatantDataJanlenouxLength = combatantDataJanlenoux.combatants.length;
      if (combatantDataJanlenouxLength < 1) {
        console.error(`Ser Janlenoux: expected at least 1 combatants got ${combatantDataJanlenouxLength}`);
        return;
      }

      // Sort to retreive last combatant in list
      const sortCombatants = (a, b) => (a.ID ?? 0) - (b.ID ?? 0);
      const combatantJanlenoux = combatantDataJanlenoux.combatants.sort(sortCombatants).shift();
      if (!combatantJanlenoux) throw new not_reached/* UnreachableCode */.$();

      // West (95, 100) or East (105, 100).
      if (combatantJanlenoux.PosX < 100) data.sanctityWardDir = output.clockwise();
      if (combatantJanlenoux.PosX > 100) data.sanctityWardDir = output.counterclock();
    },
    infoText: (data, _matches, output) => {
      return data.sanctityWardDir ?? output.unknown();
    },
    run: data => delete data.sanctityWardDir,
    outputStrings: {
      clockwise: {
        en: 'Clockwise',
        de: 'Im Uhrzeigersinn',
        fr: 'Horaire',
        ja: '時計回り',
        cn: '顺时针起跑',
        ko: '시계방향'
      },
      counterclock: {
        en: 'Counterclockwise',
        de: 'Gegen den Uhrzeigersinn',
        fr: 'Anti-horaire',
        ja: '反時計回り',
        cn: '逆时针起跑',
        ko: '반시계방향'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'DSR Sanctity of the Ward Swords',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => data.phase === 'thordan' && data.me === matches.target,
    alarmText: (data, matches, output) => {
      const id = dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches);
      if (id === dragonsongs_reprise_ultimate_headmarkers.sword1) return output.sword1();
      if (id === dragonsongs_reprise_ultimate_headmarkers.sword2) return output.sword2();
    },
    outputStrings: {
      sword1: {
        en: '1',
        de: '1',
        fr: '1',
        ja: '1',
        cn: '1',
        ko: '1'
      },
      sword2: {
        en: '2',
        de: '2',
        fr: '2',
        ja: '2',
        cn: '2',
        ko: '2'
      }
    }
  }, {
    id: 'DSR Sanctity of the Ward Sword Names',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.phase === 'thordan',
    sound: '',
    infoText: (data, matches, output) => {
      const id = dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches);
      if (id === dragonsongs_reprise_ultimate_headmarkers.sword1) data.sanctitySword1 = matches.target;else if (id === dragonsongs_reprise_ultimate_headmarkers.sword2) data.sanctitySword2 = matches.target;else return;
      if (data.sanctitySword1 === undefined || data.sanctitySword2 === undefined) return;
      const name1 = data.party.member(data.sanctitySword1);
      const name2 = data.party.member(data.sanctitySword2);
      return output.text({
        name1: name1,
        name2: name2
      });
    },
    // Don't collide with the more important 1/2 call.
    tts: '',
    outputStrings: {
      text: {
        en: 'Swords: ${name1}, ${name2}',
        de: 'Schwerter: ${name1}, ${name2}',
        fr: 'Épées : ${name1}, ${name2}',
        ja: '剣：${name1}, ${name2}',
        cn: '剑: ${name1}, ${name2}',
        ko: '돌진 대상자: ${name1}, ${name2}'
      }
    }
  }, {
    id: 'DSR Dragon\'s Gaze',
    type: 'StartsUsing',
    netRegex: {
      id: '63D0',
      source: 'King Thordan',
      capture: false
    },
    durationSeconds: 5,
    response: responses/* Responses.lookAway */.n3.lookAway('alert')
  }, {
    id: 'DSR Sanctity of the Ward Meteor Role',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.phase === 'thordan',
    // Keep this up through the first tower.
    durationSeconds: 10,
    infoText: (data, matches, output) => {
      const id = dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches);
      if (id !== dragonsongs_reprise_ultimate_headmarkers.meteor) return;
      data.thordanMeteorMarkers.push(matches.target);
      const [p1, p2] = data.thordanMeteorMarkers.sort();
      if (data.thordanMeteorMarkers.length !== 2 || p1 === undefined || p2 === undefined) return;
      const p1dps = data.party.isDPS(p1);
      const p2dps = data.party.isDPS(p2);
      if (p1dps && p2dps) return output.dpsMeteors({
        player1: data.party.member(p1),
        player2: data.party.member(p2)
      });
      if (!p1dps && !p2dps) return output.tankHealerMeteors({
        player1: data.party.member(p1),
        player2: data.party.member(p2)
      });
      return output.unknownMeteors({
        player1: data.party.member(p1),
        player2: data.party.member(p2)
      });
    },
    outputStrings: {
      tankHealerMeteors: {
        en: 'Tank/Healer Meteors (${player1}, ${player2})',
        de: 'Tank/Heiler Meteore (${player1}, ${player2})',
        fr: 'Météores Tank/Healer (${player1}, ${player2})',
        ja: 'タンヒラ 隕石 (${player1}, ${player2})',
        cn: 'T/奶 陨石 (${player1}, ${player2})',
        ko: '탱/힐 메테오 (${player1}, ${player2})'
      },
      dpsMeteors: {
        en: 'DPS Meteors (${player1}, ${player2})',
        de: 'DDs Meteore (${player1}, ${player2})',
        fr: 'Météores DPS (${player1}, ${player2})',
        ja: 'DPS 隕石 (${player1}, ${player2})',
        cn: 'DPS 陨石 (${player1}, ${player2})',
        ko: '딜러 메테오 (${player1}, ${player2})'
      },
      unknownMeteors: {
        en: '??? Meteors (${player1}, ${player2})',
        de: '??? Meteore (${player1}, ${player2})',
        fr: 'Météores ??? (${player1}, ${player2})',
        ja: '??? 隕石 (${player1}, ${player2})',
        cn: '??? 陨石 (${player1}, ${player2})',
        ko: '??? 메테오 (${player1}, ${player2})'
      }
    }
  }, {
    id: 'DSR Sanctity of the Ward Meteor You',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => data.phase === 'thordan' && data.me === matches.target,
    alertText: (data, matches, output) => {
      const id = dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches);
      if (id === dragonsongs_reprise_ultimate_headmarkers.meteor) return output.meteorOnYou();
    },
    outputStrings: {
      meteorOnYou: outputs/* default.meteorOnYou */.Z.meteorOnYou
    }
  }, {
    id: 'DSR Broad Swing Right',
    type: 'StartsUsing',
    netRegex: {
      id: '63C0',
      source: 'King Thordan',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Behind => Right',
        de: 'Hinter ihn => Rechts',
        fr: 'Derrière => Gauche',
        ja: '後ろ => 右',
        cn: '后 => 右',
        ko: '뒤 => 오른쪽'
      }
    }
  }, {
    id: 'DSR Broad Swing Left',
    type: 'StartsUsing',
    netRegex: {
      id: '63C1',
      source: 'King Thordan',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Behind => Left',
        de: 'Hinter ihn => Links',
        fr: 'Derrière => Droite',
        ja: '後ろ => 左',
        cn: '后 => 左',
        ko: '뒤 => 왼쪽'
      }
    }
  }, {
    id: 'DSR Dive From Grace Number',
    // This comes out ~5s before symbols.
    type: 'HeadMarker',
    netRegex: {},
    infoText: (data, matches, output) => {
      const id = dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches);
      if (id === dragonsongs_reprise_ultimate_headmarkers.dot1) {
        data.diveFromGraceNum[matches.target] = 1;
        if (matches.target === data.me) return output.num1();
      } else if (id === dragonsongs_reprise_ultimate_headmarkers.dot2) {
        data.diveFromGraceNum[matches.target] = 2;
        if (matches.target === data.me) return output.stackNorthNum({
          num: output.num2()
        });
      } else if (id === dragonsongs_reprise_ultimate_headmarkers.dot3) {
        data.diveFromGraceNum[matches.target] = 3;
        if (matches.target === data.me) return output.stackNorthNum({
          num: output.num3()
        });
      }
    },
    outputStrings: {
      num1: outputs/* default.num1 */.Z.num1,
      num2: outputs/* default.num2 */.Z.num2,
      num3: outputs/* default.num3 */.Z.num3,
      stackNorthNum: {
        en: '${num} (stack North)',
        de: '${num} (Im Norden sammeln)',
        fr: '${num} (package au Nord)',
        ja: '${num} (北で頭割り)',
        cn: '${num} (上北分摊)',
        ko: '${num} (북쪽에서 쉐어)'
      }
    }
  }, {
    id: 'DSR Dive From Grace Dir Collect',
    type: 'GainsEffect',
    // AC3 = High Jump Target
    // AC4 = Spineshatter Dive Target
    // AC5 = Elusive Jump Target
    netRegex: {
      effectId: ['AC3', 'AC4', 'AC5']
    },
    run: (data, matches) => {
      if (matches.effectId === 'AC4' || matches.effectId === 'AC5') {
        const duration = parseFloat(matches.duration);
        // These come out in 9, 19, 30 seconds.
        if (duration < 15) data.diveFromGraceHasArrow[1] = true;else if (duration < 25) data.diveFromGraceHasArrow[2] = true;else data.diveFromGraceHasArrow[3] = true;
      }
      // Store result for position callout
      switch (matches.effectId) {
        case 'AC3':
          data.diveFromGraceDir[matches.target] = 'circle';
          break;
        case 'AC4':
          data.diveFromGraceDir[matches.target] = 'up';
          break;
        case 'AC5':
          data.diveFromGraceDir[matches.target] = 'down';
          break;
      }
    }
  }, {
    id: 'DSR Dive From Grace Dir You',
    type: 'GainsEffect',
    // AC3 = High Jump Target
    // AC4 = Spineshatter Dive Target
    // AC5 = Elusive Jump Target
    netRegex: {
      effectId: ['AC3', 'AC4', 'AC5']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: 0.5,
    durationSeconds: 5,
    alertText: (data, _matches, output) => {
      const num = data.diveFromGraceNum[data.me];
      if (!num) {
        console.error(`DFGYou: missing number: ${JSON.stringify(data.diveFromGraceNum)}`);
        return;
      }
      if (data.diveFromGraceDir[data.me] === 'up') return output.upArrow({
        num: num
      });else if (data.diveFromGraceDir[data.me] === 'down') return output.downArrow({
        num: num
      });
      if (data.diveFromGraceHasArrow[num]) return output.circleWithArrows({
        num: num
      });
      return output.circleAllCircles({
        num: num
      });
    },
    outputStrings: {
      circleAllCircles: {
        en: '#${num} All Circles',
        de: '#${num} Alle Kreise',
        fr: '#${num} Tous les cercles',
        ja: '#${num} みんなハイジャンプ',
        cn: '#${num} 全圆圈',
        ko: '#${num} 모두 하이점프'
      },
      circleWithArrows: {
        en: '#${num} Circle (with arrows)',
        de: '#${num} Kreise (mit Pfeilen)',
        fr: '#${num} Cercle (avec flèches)',
        ja: '#${num} 自分のみハイジャンプ',
        cn: '#${num} 圆圈 (有箭头)',
        ko: '#${num} 나만 하이점프'
      },
      upArrow: {
        en: '#${num} Up Arrow',
        de: '#${num} Pfeil nach Vorne',
        fr: '#${num} Flèche en haut',
        ja: '#${num} 上矢印 / スパインダイブ',
        cn: '#${num} 上箭头',
        ko: '#${num} 위 화살표 / 척추 강타'
      },
      downArrow: {
        en: '#${num} Down Arrow',
        de: '#${num} Pfeil nach Hinten',
        fr: '#${num} Flèche en bas',
        ja: '#${num} 下矢印 / イルーシヴジャンプ',
        cn: '#${num} 下箭头',
        ko: '#${num} 아래 화살표 / 교묘한 점프'
      }
    }
  }, {
    id: 'DSR Gnash and Lash',
    type: 'StartsUsing',
    // 6712 = Gnash and Lash (out then in)
    // 6713 = Lash and Gnash (in then out)
    netRegex: {
      id: ['6712', '6713'],
      source: 'Nidhogg'
    },
    durationSeconds: 5,
    alertText: (data, matches, output) => {
      const key = matches.id === '6712' ? 'out' : 'in';
      const inout = output[key]();
      data.diveFromGraceLashGnashKey = key;
      const num = data.diveFromGraceNum[data.me];
      if (num !== 1 && num !== 2 && num !== 3) {
        console.error(`DSR Gnash and Lash: missing number: ${JSON.stringify(data.diveFromGraceNum)}`);
        return inout;
      }

      // Special case for side ones baiting the two towers.
      if (data.eyeOfTheTyrantCounter === 1 && num === 1 && data.diveFromGracePreviousPosition[data.me] !== 'middle') return output.baitStackInOut({
        inout: inout
      });

      // Filter out anybody who needs to be stacking.
      const firstStack = data.eyeOfTheTyrantCounter === 0 && num !== 1;
      const secondStack = data.eyeOfTheTyrantCounter === 1 && num !== 3;
      if (firstStack || secondStack) return output.stackInOut({
        inout: inout
      });

      // Call out all circles.
      if (!data.diveFromGraceHasArrow[num]) {
        return {
          1: output.circlesDive1({
            inout: inout
          }),
          2: inout,
          // this shouldn't happen, but TypeScript wants this key
          3: output.circlesDive3({
            inout: inout
          })
        }[num];
      }

      // Remaining people are arrow dives.
      if (num === 1) {
        if (data.diveFromGraceDir[data.me] === 'circle') return output.southDive1({
          inout: inout
        });
        if (data.diveFromGraceDir[data.me] === 'up') return output.upArrowDive1({
          inout: inout
        });
        if (data.diveFromGraceDir[data.me] === 'down') return output.downArrowDive1({
          inout: inout
        });
      } else if (num === 3) {
        if (data.diveFromGraceDir[data.me] === 'circle') return output.southDive3({
          inout: inout
        });
        if (data.diveFromGraceDir[data.me] === 'up') return output.upArrowDive3({
          inout: inout
        });
        if (data.diveFromGraceDir[data.me] === 'down') return output.downArrowDive3({
          inout: inout
        });
      }

      // If things have gone awry, at least output something.
      return inout;
    },
    // The 2 dives are called after the in/out occurs.
    // The 1+3 dives get separate output strings here in case somebody has a weird strat
    // that does different things for them and want better output strings.
    // The idea here is that folks can rename "Up Arrow Dive" to "East Dive" depending on
    // which way their strat wants them to look.
    // TODO: should we warn the south tower here? e.g. Stack => Out => South Tower?
    outputStrings: {
      in: outputs/* default.in */.Z["in"],
      out: outputs/* default.out */.Z.out,
      stackInOut: {
        en: 'Stack => ${inout}',
        de: 'Sammeln => ${inout}',
        fr: 'Package => ${inout}',
        ja: '頭割り => ${inout}',
        cn: '分摊 => ${inout}',
        ko: '쉐어 => ${inout}'
      },
      baitStackInOut: {
        en: 'Bait => Stack => ${inout}',
        de: 'Ködern => Sammeln => ${inout}',
        fr: 'Attirez => Package => ${inout}',
        ja: '誘導 => 頭割り => ${inout}',
        cn: '引导 => 分摊 => ${inout}',
        ko: '공격 유도 => 쉐어 => ${inout}'
      },
      circlesDive1: {
        en: 'Dive (all circles) => ${inout}',
        de: 'Sturz (alle Kreise) => ${inout}',
        fr: 'Saut (tous les cercles) => ${inout}',
        ja: 'ダイブ (みんなハイジャ) => ${inout}',
        cn: '俯冲 (全圆圈) => ${inout}',
        ko: '다이브 (모두 하이점프) => ${inout}'
      },
      circlesDive3: {
        en: 'Dive (all circles) => ${inout}',
        de: 'Sturz (alle Kreise) => ${inout}',
        fr: 'Saut (tous les cercles) => ${inout}',
        ja: 'ダイブ (みんなハイジャ) => ${inout}',
        cn: '俯冲 (全圆圈) => ${inout}',
        ko: '다이브 (모두 하이점프) => ${inout}'
      },
      southDive1: {
        en: 'South Dive => ${inout}',
        de: 'Südlicher Sturz => ${inout}',
        fr: 'Saut Sud => ${inout}',
        ja: '南ダイブ => ${inout}',
        cn: '下南俯冲 => ${inout}',
        ko: '남쪽 다이브 => ${inout}'
      },
      southDive3: {
        en: 'South Dive => ${inout}',
        de: 'Südlicher Sturz => ${inout}',
        fr: 'Saut Sud => ${inout}',
        ja: '南ダイブ => ${inout}',
        cn: '下南俯冲 => ${inout}',
        ko: '남쪽 다이브 => ${inout}'
      },
      upArrowDive1: {
        en: 'Up Arrow Dive => ${inout}',
        de: 'Vorne-Pfeil-Sturz => ${inout}',
        fr: 'Saut flèche en haut => ${inout}',
        ja: '上矢印 => ${inout}',
        cn: '上箭头俯冲 => ${inout}',
        ko: '위 화살표 => ${inout}'
      },
      upArrowDive3: {
        en: 'Up Arrow Dive => ${inout}',
        de: 'Vorne-Pfeil-Sturz => ${inout}',
        fr: 'Saut flèche en haut => ${inout}',
        ja: '上矢印 => ${inout}',
        cn: '上箭头俯冲 => ${inout}',
        ko: '위 화살표 => ${inout}'
      },
      downArrowDive1: {
        en: 'Down Arrow Dive => ${inout}',
        de: 'Hinten-Pfeil-Sturz => ${inout}',
        fr: 'Saut flèche en bas => ${inout}',
        ja: '下矢印 => ${inout}',
        cn: '下箭头俯冲 => ${inout}',
        ko: '아래 화살표 => ${inout}'
      },
      downArrowDive3: {
        en: 'Down Arrow Dive => ${inout}',
        de: 'Hinten-Pfeil-Sturz => ${inout}',
        fr: 'Saut flèche en bas => ${inout}',
        ja: '下矢印 => ${inout}',
        cn: '下箭头俯冲 => ${inout}',
        ko: '아래 화살표 => ${inout}'
      }
    }
  }, {
    id: 'DSR Lash Gnash Followup',
    type: 'Ability',
    // 6715 = Gnashing Wheel
    // 6716 = Lashing Wheel
    netRegex: {
      id: ['6715', '6716'],
      source: 'Nidhogg'
    },
    // These are ~3s apart.  Only call after the first (and ignore multiple people getting hit).
    suppressSeconds: 6,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        out: outputs/* default.out */.Z.out,
        in: outputs/* default.in */.Z["in"],
        inOutAndBait: {
          en: '${inout} + Bait',
          de: '${inout} + Ködern',
          fr: '${inout} + Attirez',
          ja: '${inout} + 誘導',
          cn: '${inout} + 引导',
          ko: '${inout} + 공격 유도'
        },
        circlesDive2: {
          en: '${inout} => Dive (all circles)',
          de: '${inout} => Sturz (alle Kreise)',
          fr: '${inout} + Saut (tout les cercles)',
          ja: '${inout} => ダイブ (みんなハイジャ)',
          cn: '${inout} => 俯冲 (全圆圈)',
          ko: '${inout} => 다이브 (모두 하이점프)'
        },
        upArrowDive2: {
          en: '${inout} => Up Arrow Dive',
          de: '${inout} => Vorne-Pfeil-Sturz',
          fr: '${inout} => Saut flèche en haut',
          ja: '${inout} => 上矢印',
          cn: '${inout} => 上箭头俯冲',
          ko: '${inout} => 위 화살표'
        },
        downArrowDive2: {
          en: '${inout} => Down Arrow Dive',
          de: '${inout} => Hinten-Pfeil-Sturz',
          fr: '${inout} => Saut flèche en bas',
          ja: '${inout} => 下矢印',
          cn: '${inout} => 下箭头俯冲',
          ko: '${inout} => 아래 화살표'
        }
      };
      const key = matches.id === '6715' ? 'in' : 'out';
      const inout = output[key]();
      data.diveFromGraceLashGnashKey = key;
      const num = data.diveFromGraceNum[data.me];
      if (num === undefined) {
        // Don't print a console error here because this response gets eval'd as part
        // of the config ui and testing.  We'll get errors elsewhere if needed.
        // TODO: maybe have a better way to know if we're in the middle of testing?
        return {
          infoText: inout
        };
      }
      if (data.eyeOfTheTyrantCounter === 1) {
        if (num === 2) {
          if (!data.diveFromGraceHasArrow[num]) return {
            alertText: output.circlesDive2({
              inout: inout
            })
          };
          if (data.diveFromGraceDir[data.me] === 'up') return {
            alertText: output.upArrowDive2({
              inout: inout
            })
          };
          if (data.diveFromGraceDir[data.me] === 'down') return {
            alertText: output.downArrowDive2({
              inout: inout
            })
          };
        } else if (num === 3) {
          return {
            alertText: output.inOutAndBait({
              inout: inout
            })
          };
        }
      } else if (data.eyeOfTheTyrantCounter === 2) {
        if (num === 2 || num === 1 && data.diveFromGracePreviousPosition[data.me] === 'middle') return {
          alertText: output.inOutAndBait({
            inout: inout
          })
        };
      }

      // Otherwise, just tell the remaining people the dodge.
      return {
        infoText: inout
      };
    }
  }, {
    id: 'DSR Dive From Grace Dive Collect',
    // 670E Dark High Jump
    // 670F Dark Spineshatter Dive
    // 6710 Dark Elusive Jump
    // Collect players hit by dive
    type: 'Ability',
    netRegex: {
      id: ['670E', '670F', '6710'],
      source: 'Nidhogg'
    },
    run: (data, matches) => {
      const posX = parseFloat(matches.targetX);
      data.diveFromGracePositions[matches.target] = posX;
    }
  }, {
    id: 'DSR Dive From Grace Post Stack',
    // Triggered on first instance of Eye of the Tyrant (6714)
    type: 'Ability',
    netRegex: {
      id: '6714',
      source: 'Nidhogg',
      capture: false
    },
    // Ignore targetIsYou() incase player misses stack
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      const num = data.diveFromGraceNum[data.me];
      if (!num) {
        console.error(`DFG Tower 1 Reminder: missing number: ${JSON.stringify(data.diveFromGraceNum)}`);
        return;
      }
      const inout = output[data.diveFromGraceLashGnashKey]();
      if (data.eyeOfTheTyrantCounter === 1) {
        // Tower 1 soaks only based on debuffs.
        if (num === 3) {
          if (data.diveFromGraceDir[data.me] === 'circle') {
            if (data.diveFromGraceHasArrow[3]) return output.southTower1({
              inout: inout
            });
            return output.circleTowers1({
              inout: inout
            });
          } else if (data.diveFromGraceDir[data.me] === 'up') {
            return output.upArrowTower1({
              inout: inout
            });
          } else if (data.diveFromGraceDir[data.me] === 'down') {
            return output.downArrowTower1({
              inout: inout
            });
          }
          return output.unknownTower({
            inout: inout
          });
        }
        // Folks who could be placing a two tower here just get
        // the normal "in" or "out" below, and the Lash Gnash Followup
        // will say "In => Up Arrow Tower" as a reminder.
      } else if (data.eyeOfTheTyrantCounter === 2) {
        // Tower 3 soaks based on debuffs and previous positions.
        const pos = data.diveFromGracePreviousPosition[data.me];
        if (num === 1) {
          if (pos === 'middle') return output.southTower3({
            inout: inout
          });
          // Already soaked the number two towers.
          if (pos === 'east' || pos === 'west') return;
        } else if (num === 2) {
          if (pos === 'west') return output.westTower3({
            inout: inout
          });
          if (pos === 'east') return output.eastTower3({
            inout: inout
          });
        } else if (num === 3) {
          return;
        }
        return output.unknownTower({
          inout: inout
        });
      }

      // Anybody who isn't placing or taking a tower here just gets a "in/out" reminder.
      return inout;
    },
    outputStrings: {
      unknown: outputs/* default.unknown */.Z.unknown,
      in: outputs/* default.in */.Z["in"],
      out: outputs/* default.out */.Z.out,
      unknownTower: {
        en: 'Tower (${inout})',
        de: 'Turm (${inout})',
        fr: 'Tour (${inout})',
        ja: '塔 (${inout})',
        cn: '塔 (${inout})',
        ko: '기둥 (${inout})'
      },
      southTower1: {
        en: 'South Tower (${inout})',
        de: 'Südlicher Turm (${inout})',
        fr: 'Tour sud (${inout})',
        ja: '南塔 (${inout})',
        cn: '下南塔 (${inout})',
        ko: '남쪽 기둥 (${inout})'
      },
      southTower3: {
        en: 'South Tower (${inout})',
        de: 'Südlicher Turm (${inout})',
        fr: 'Tour sud (${inout})',
        ja: '南塔 (${inout})',
        cn: '下南塔 (${inout})',
        ko: '남쪽 기둥 (${inout})'
      },
      circleTowers1: {
        en: 'Tower (all circles, ${inout})',
        de: 'Türme (alle Kreise, ${inout})',
        fr: 'Tour (tout les cercles, ${inout})',
        ja: '塔 (みんなハイジャ、${inout})',
        cn: '塔 (全圆圈, ${inout})',
        ko: '기둥 (모두 하이점프, ${inout})'
      },
      circleTowers3: {
        en: 'Tower (all circles, ${inout})',
        de: 'Türme (alle Kreise, ${inout})',
        fr: 'Tour (tout les cercles, ${inout})',
        ja: '塔 (みんなハイジャ、${inout})',
        cn: '塔 (全圆圈, ${inout})',
        ko: '기둥 (모두 하이점프, ${inout})'
      },
      upArrowTower1: {
        en: 'Up Arrow Tower (${inout})',
        de: 'Vorne-Pfeil-Turm (${inout})',
        fr: 'Tour flèche en haut (${inout})',
        ja: '上矢印の塔 (${inout})',
        cn: '上箭头塔 (${inout})',
        ko: '위 화살표 기둥 (${inout})'
      },
      downArrowTower1: {
        en: 'Down Arrow Tower (${inout})',
        de: 'Hinten-Pfeil-Turm (${inout})',
        fr: 'Tour flèche en bas (${inout})',
        ja: '下矢印の塔 (${inout})',
        cn: '下箭头塔 (${inout})',
        ko: '아래 화살표 기둥 (${inout})'
      },
      upArrowTower3: {
        en: 'Up Arrow Tower (${inout})',
        de: 'Vorne-Pfeil-Turm (${inout})',
        fr: 'Tour flèche en haut (${inout})',
        ja: '上矢印の塔 (${inout})',
        cn: '上箭头塔 (${inout})',
        ko: '위 화살표 기둥 (${inout})'
      },
      downArrowTower3: {
        en: 'Down Arrow Tower (${inout})',
        de: 'Hinten-Pfeil-Turm (${inout})',
        fr: 'Tour flèche en bas (${inout})',
        ja: '下矢印の塔 (${inout})',
        cn: '下箭头塔 (${inout})',
        ko: '아래 화살표 기둥 (${inout})'
      },
      westTower3: {
        en: 'West Tower (${inout})',
        de: 'Westlicher Turm (${inout})',
        fr: 'Tour ouest (${inout})',
        ja: '東塔 (${inout})',
        cn: '左西塔 (${inout})',
        ko: '서쪽 기둥 (${inout})'
      },
      eastTower3: {
        en: 'East Tower (${inout})',
        de: 'Östlicher Turm (${inout})',
        fr: 'Tour est (${inout})',
        ja: '西塔 (${inout})',
        cn: '右东塔 (${inout})',
        ko: '동쪽 기둥 (${inout})'
      }
    }
  }, {
    id: 'DSR Dive From Grace Post Dive',
    // 670E Dark High Jump
    // 670F Dark Spineshatter Dive
    // 6710 Dark Elusive Jump
    // Defaults:
    //   High Jump South if solo, no assignment if all circle
    //   Assumes North Party Stack
    type: 'Ability',
    netRegex: {
      id: ['670E', '670F', '6710'],
      source: 'Nidhogg',
      capture: false
    },
    preRun: data => data.diveFromGraceTowerCounter = (data.diveFromGraceTowerCounter ?? 0) + 1,
    delaySeconds: 0.2,
    suppressSeconds: 1,
    alertText: (data, _matches, output) => {
      const num = data.diveFromGraceNum[data.me];
      if (!num) {
        console.error(`DFG Tower 1 and 2: missing number: ${JSON.stringify(data.diveFromGraceNum)}`);
        return;
      }

      // Sorted from west to east, and filled in with unknown if missing.
      const [nameA, nameB, nameC] = [...Object.keys(data.diveFromGracePositions).sort((keyA, keyB) => {
        const posA = data.diveFromGracePositions[keyA];
        const posB = data.diveFromGracePositions[keyB];
        if (posA === undefined || posB === undefined) return 0;
        return posA - posB;
      }), output.unknown(), output.unknown(), output.unknown()];

      // Dive 1 and Dive 3 have 3 players
      if (data.diveFromGraceTowerCounter !== 2) {
        data.diveFromGracePreviousPosition[nameA] = 'west';
        data.diveFromGracePreviousPosition[nameB] = 'middle';
        data.diveFromGracePreviousPosition[nameC] = 'east';
      } else {
        data.diveFromGracePreviousPosition[nameA] = 'west';
        data.diveFromGracePreviousPosition[nameB] = 'east';
      }
      if (num === 1 && data.diveFromGraceTowerCounter === 2) {
        if (data.diveFromGracePreviousPosition[data.me] === 'west') return output.northwestTower2();
        if (data.diveFromGracePreviousPosition[data.me] === 'east') return output.northeastTower2();
        if (data.diveFromGracePreviousPosition[data.me] === 'middle') return;
        return output.unknownTower();
      }
    },
    run: data => data.diveFromGracePositions = {},
    outputStrings: {
      unknown: outputs/* default.unknown */.Z.unknown,
      unknownTower: {
        en: 'Tower',
        de: 'Turm',
        fr: 'Tour',
        ja: '塔',
        cn: '塔',
        ko: '기둥'
      },
      northwestTower2: {
        en: 'Northwest Tower',
        de: 'Nordwestlicher Turm',
        fr: 'Tour Nord-ouest',
        ja: '北東塔',
        cn: '(左上) 西北塔',
        ko: '북서쪽 기둥'
      },
      northeastTower2: {
        en: 'Northeast Tower',
        de: 'Nordöstlicher Turm',
        fr: 'Tour Nord-est',
        ja: '北西塔',
        cn: '(右上) 东北塔',
        ko: '북동쪽 기둥'
      }
    }
  }, {
    id: 'DSR Darkdragon Dive Single Tower',
    type: 'Ability',
    netRegex: {
      id: '6711',
      source: 'Nidhogg'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      const num = data.diveFromGraceNum[data.me];
      if (!num) {
        console.error(`DFG Dive Single Tower: missing number: ${JSON.stringify(data.diveFromGraceNum)}`);
        return output.text();
      }
      // To condense messages, two tower baiters get this call during the gnash and lash.
      if (data.diveFromGraceTowerCounter === 2) {
        data.stackAfterGeirskogul = true;
        return;
      }
      return output.text();
    },
    run: data => data.waitingForGeirskogul = true,
    outputStrings: {
      text: {
        en: 'Bait',
        de: 'Ködern',
        fr: 'Attirez',
        ja: '誘導',
        cn: '引导',
        ko: '공격 유도'
      }
    }
  }, {
    id: 'DSR Geirskogul',
    type: 'StartsUsing',
    netRegex: {
      id: '670A',
      source: 'Nidhogg',
      capture: false
    },
    condition: data => data.waitingForGeirskogul,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      if (!data.waitingForGeirskogul) return;
      // Two tower baiters need to quickly get to the stack here.
      if (data.stackAfterGeirskogul) {
        const inout = output[data.diveFromGraceLashGnashKey]();
        return output.stackInOut({
          inout: inout
        });
      }
      return output.move();
    },
    run: data => {
      delete data.waitingForGeirskogul;
      delete data.stackAfterGeirskogul;
    },
    outputStrings: {
      in: outputs/* default.in */.Z["in"],
      out: outputs/* default.out */.Z.out,
      unknown: outputs/* default.unknown */.Z.unknown,
      stackInOut: {
        en: 'Stack => ${inout}',
        de: 'Sammeln => ${inout}',
        fr: 'Package => ${inout}',
        ja: '頭割り => ${inout}',
        cn: '分摊 => ${inout}',
        ko: '쉐어 => ${inout}'
      },
      move: outputs/* default.moveAway */.Z.moveAway
    }
  }, {
    id: 'DSR Drachenlance',
    type: 'StartsUsing',
    netRegex: {
      id: '670C',
      source: 'Nidhogg',
      capture: false
    },
    // This could be "out of front" as sides are safe but this is urgent, so be more clear.
    response: responses/* Responses.getBehind */.n3.getBehind()
  }, {
    id: 'DSR Right Eye Blue Tether',
    type: 'Tether',
    netRegex: {
      id: '0033'
    },
    condition: (data, matches) => matches.source === data.me,
    // Have blue/red be different alert/info to differentiate.
    // Since dives are usually blue people dropping off their blue tether
    // to a red person (who needs to run in), make the blue tether
    // the higher severity one.
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Blue',
        de: 'Blau',
        fr: 'Bleu',
        ja: '青',
        cn: '蓝点名',
        ko: '파랑'
      }
    }
  }, {
    id: 'DSR Left Eye Red tether',
    type: 'Tether',
    netRegex: {
      id: '0034'
    },
    condition: (data, matches) => matches.source === data.me,
    // See note above on Right Eye Blue Tether.
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Red',
        de: 'Rot',
        fr: 'Rouge',
        ja: '赤',
        cn: '红点名',
        ko: '빨강'
      }
    }
  }, {
    id: 'DSR Eyes Dive Cast',
    type: 'StartsUsing',
    netRegex: {
      id: '68C3',
      source: ['Right Eye', 'Left Eye'],
      capture: false
    },
    // One cast for each dive.  68C3 is the initial cast/self-targeted ability.
    // 68C4 is the damage on players.
    suppressSeconds: 1,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Dives Soon',
        de: 'Stürze bald',
        fr: 'Saut bientôt',
        ja: 'まもなくダイブ',
        cn: '即将幻象冲',
        ko: '곧 다이브'
      }
    }
  }, {
    id: 'DSR Eyes Dive Counter',
    type: 'Ability',
    // TODO: should this call out who it was on? some strats involve the
    // first dive targets swapping with the third dive targets.
    netRegex: {
      id: '68C4',
      source: 'Nidhogg',
      capture: false
    },
    // One ability for each player hit.
    suppressSeconds: 1,
    infoText: (data, _matches, output) => output[`dive${data.diveCounter}`](),
    run: data => data.diveCounter++,
    outputStrings: {
      dive1: outputs/* default.num1 */.Z.num1,
      dive2: outputs/* default.num2 */.Z.num2,
      dive3: outputs/* default.num3 */.Z.num3,
      dive4: outputs/* default.num4 */.Z.num4
    }
  }, {
    id: 'DSR Eyes Steep in Rage',
    type: 'StartsUsing',
    netRegex: {
      id: '68BD',
      source: ['Right Eye', 'Left Eye'],
      capture: false
    },
    // Each of the eyes (if alive) will start this aoe.  It has the same id from each eye.
    suppressSeconds: 1,
    response: responses/* Responses.bigAoe */.n3.bigAoe('alert')
  }, {
    id: 'DSR Right Eye Reminder',
    type: 'StartsUsing',
    // If the Right Eye is dead and the Left Eye gets the aoe off, then the Right Eye
    // will be revived and you shouldn't forget about it.
    netRegex: {
      id: '68BD',
      source: 'Left Eye'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime),
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Kill Right Eye',
        de: 'Besiege Rechtes Auge',
        fr: 'Tuez l\'œil droit',
        ja: '右目を攻撃',
        cn: '击杀右眼',
        ko: '오른눈 잡기'
      }
    }
  }, {
    id: 'DSR Spear of the Fury Limit Break',
    type: 'StartsUsing',
    netRegex: {
      id: '62E2',
      source: 'Ser Zephirin',
      capture: false
    },
    // This ability also happens in doorboss phase.
    condition: data => data.role === 'tank' && data.phase === 'haurchefant',
    // This is a 10 second cast, and (from video) my understanding is to
    // hit tank LB when the cast bar gets to the "F" in "Fury", which is
    // roughly 2.8 seconds before it ends.
    delaySeconds: 10 - 2.8,
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'TANK LB!!',
        de: 'TANK LB!!',
        fr: 'LB TANK !!',
        ja: 'タンクLB!!',
        cn: '坦克LB！！',
        ko: '탱리밋!!'
      }
    }
  }, {
    id: 'DSR Twisting Dive',
    type: 'Ability',
    netRegex: {
      id: '6B8B',
      source: 'Vedrfolnir',
      capture: false
    },
    suppressSeconds: 1,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Twisters',
        de: 'Wirbelstürme',
        fr: 'Tornades',
        ja: 'ツイスター',
        cn: '旋风',
        ko: '회오리'
      }
    }
  }, {
    id: 'DSR Wrath Spiral Pierce',
    type: 'Tether',
    netRegex: {
      id: '0005'
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tether on YOU',
        de: 'Verbindung auf DIR',
        fr: 'Lien sur VOUS',
        ja: '自分に線',
        cn: '连线点名',
        ko: '선 대상자'
      }
    }
  }, {
    id: 'DSR Wrath Skyward Leap',
    type: 'HeadMarker',
    netRegex: {},
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (data, matches, output) => {
      const id = dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches);
      // The Wrath of the Heavens skyward leap is a different headmarker.
      if (id === dragonsongs_reprise_ultimate_headmarkers.skywardSingle) return output.leapOnYou();
    },
    outputStrings: {
      leapOnYou: {
        en: 'Leap on YOU',
        de: 'Sprung auf DIR',
        fr: 'Saut sur VOUS',
        ja: '自分に青マーカー',
        cn: '蓝球点名',
        ko: '광역 대상자'
      }
    }
  }, {
    id: 'DSR Wrath Thunderstruck',
    // This is effectId B11, but the timing is somewhat inconsistent based on statuses rolling out.
    // Use the Chain Lightning ability instead.
    type: 'Ability',
    netRegex: {
      id: '6B8F',
      source: 'Darkscale'
    },
    // Call this after, which is ~2.3s after this ability.
    // This avoids people with itchy feet running when they hear something.
    delaySeconds: 2.5,
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.text();
    },
    run: (data, matches) => data.thunderstruck.push(matches.target),
    outputStrings: {
      text: {
        en: 'Thunder on YOU',
        de: 'Blitz auf DIR',
        fr: 'Foudre sur VOUS',
        ja: '自分に雷',
        cn: '雷点名',
        ko: '번개 대상자'
      }
    }
  }, {
    id: 'DSR Wrath Thunderstruck Targets',
    type: 'Ability',
    netRegex: {
      id: '6B8F',
      source: 'Darkscale',
      capture: false
    },
    delaySeconds: 2.8,
    suppressSeconds: 1,
    // This is just pure extra info, no need to make noise for people.
    sound: '',
    infoText: (data, _matches, output) => {
      // In case somebody wants to do some "go in the order cactbot tells you" sort of strat.
      const [fullName1, fullName2] = data.thunderstruck.sort();
      const name1 = data.party.member(fullName1);
      const name2 = data.party.member(fullName2);
      return output.text({
        name1: name1,
        name2: name2
      });
    },
    // Sorry tts players, but "Thunder on YOU" and "Thunder: names" are too similar.
    tts: null,
    outputStrings: {
      text: {
        en: 'Thunder: ${name1}, ${name2}',
        de: 'Blitz: ${name1}, ${name2}',
        fr: 'Foudre : ${name1}, ${name2}',
        ja: '雷: ${name1}, ${name2}',
        cn: '雷点: ${name1}, ${name2}',
        ko: '번개: ${name1}, ${name2}'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'DSR Wrath Cauterize Marker',
    type: 'HeadMarker',
    netRegex: {},
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    alarmText: (data, matches, output) => {
      const id = dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches);
      if (id === dragonsongs_reprise_ultimate_headmarkers.cauterize) return output.diveOnYou();
    },
    outputStrings: {
      diveOnYou: {
        en: 'Divebomb (opposite warrior)',
        de: 'Sturz (gegenüber des Kriegers)',
        fr: 'Saut (guerrier opposé)',
        ja: '自分にダイブ (杖の後ろ)',
        cn: '俯冲 (去法师场边)',
        ko: '카탈 대상자 (도끼 든 성기사 반대편)'
      }
    }
  }, {
    id: 'DSR Doom Gain',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'BA0'
    },
    preRun: (data, matches) => data.hasDoom[matches.target] = true,
    alertText: (data, matches, output) => {
      if (data.me === matches.target) return output.doomOnYou();
    },
    infoText: (data, _matches, output) => {
      const dooms = Object.keys(data.hasDoom).filter(x => data.hasDoom[x]);
      if (dooms.length !== 4 || dooms.includes(data.me)) return;
      return output.noDoom();
    },
    outputStrings: {
      doomOnYou: {
        en: 'Doom on YOU',
        de: 'Verhängnis auf DIR',
        fr: 'Glas sur VOUS',
        ja: '自分に死の宣告',
        cn: '死宣点名',
        ko: '선고 대상자'
      },
      noDoom: {
        en: 'No Doom',
        de: 'Kein Verhängnis',
        fr: 'Pas de Glas',
        ja: '自分は無職',
        cn: '无死宣',
        ko: '선고 없음'
      }
    }
  }, {
    id: 'DSR Playstation2 Fire Chains',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.phase === 'thordan2',
    alertText: (data, matches, output) => {
      const id = dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches);
      const marker = playstationMarkerMap[id];
      if (marker === undefined) return;
      data.deathMarker[matches.target] = marker;
      if (data.me !== matches.target) return;

      // Note: in general, both circles should always have Doom and both crosses
      // should not have Doom.  If one doom dies, it seems that crosses are
      // removed and there's a double triangle non-doom.  If enough people die,
      // anything can happen.  For example, in P1 tanks can get circles if enough people are dead.

      if (data.hasDoom[data.me]) {
        if (marker === 'circle') return output.circleWithDoom();else if (marker === 'triangle') return output.triangleWithDoom();else if (marker === 'square') return output.squareWithDoom();else if (marker === 'cross') return output.crossWithDoom();
      } else {
        if (marker === 'circle') return output.circle();else if (marker === 'triangle') return output.triangle();else if (marker === 'square') return output.square();else if (marker === 'cross') return output.cross();
      }
    },
    outputStrings: {
      circle: {
        en: 'Red Circle',
        de: 'Roter Kreis',
        fr: 'Cercle rouge',
        ja: '赤まる',
        cn: '红圆圈',
        ko: '빨강 동그라미'
      },
      triangle: {
        en: 'Green Triangle',
        de: 'Grünes Dreieck',
        fr: 'Triangle vert',
        ja: '緑さんかく',
        cn: '绿三角',
        ko: '초록 삼각'
      },
      square: {
        en: 'Purple Square',
        de: 'Lilanes Viereck',
        fr: 'Carré violet',
        ja: '紫しかく',
        cn: '紫方块',
        ko: '보라 사각'
      },
      cross: {
        en: 'Blue X',
        de: 'Blaues X',
        fr: 'Croix bleue',
        ja: '青バツ',
        cn: '蓝X',
        ko: '파랑 X'
      },
      circleWithDoom: {
        en: 'Red Circle (Doom)',
        de: 'Roter Kreis (Verhängnis)',
        fr: 'Cercle rouge (Glas)',
        ja: '赤まる (死の宣告)',
        cn: '红圆圈 (死宣)',
        ko: '빨강 동그라미 (선고)'
      },
      triangleWithDoom: {
        en: 'Green Triangle (Doom)',
        de: 'Grünes Dreieck (Verhängnis)',
        fr: 'Triangle vers (Glas)',
        ja: '緑さんかく (死の宣告)',
        cn: '绿三角 (死宣)',
        ko: '초록 삼각 (선고)'
      },
      squareWithDoom: {
        en: 'Purple Square (Doom)',
        de: 'Lilanes Viereck (Verhängnis)',
        fr: 'Carré violet (Glas)',
        ja: '紫しかく (死の宣告)',
        cn: '紫方块 (死宣)',
        ko: '보라 사각 (선고)'
      },
      crossWithDoom: {
        en: 'Blue X (Doom)',
        de: 'Blaues X (Verhängnis)',
        fr: 'Croix bleue (Glas)',
        ja: '青バツ(死の宣告)',
        cn: '蓝X (死宣)',
        ko: '파랑 X (선고)'
      }
    }
  }, {
    // If one doom person dies, then there will be an unmarked non-doom player (cross)
    // and two non-doom players who will get the same symbol (triangle OR square).
    // If there's more than two symbols missing this is probably a wipe,
    // so don't bother trying to call out "unmarked circle or square".
    // TODO: should we run this on Playstation1 as well (and consolidate triggers?)
    id: 'DSR Playstation2 Fire Chains No Marker',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => data.phase === 'thordan2' && playstationHeadmarkerIds.includes(dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches)),
    delaySeconds: 0.5,
    suppressSeconds: 5,
    alarmText: (data, _matches, output) => {
      if (data.deathMarker[data.me] !== undefined) return;
      const seenMarkers = Object.values(data.deathMarker);
      const markers = [...playstationMarkers].filter(x => !seenMarkers.includes(x));
      const [marker] = markers;
      if (marker === undefined || markers.length !== 1) return;

      // Note: this will still call out for the dead doom person, but it seems better
      // in case they somehow got insta-raised.
      if (data.hasDoom[data.me]) {
        if (marker === 'circle') return output.circleWithDoom();else if (marker === 'triangle') return output.triangleWithDoom();else if (marker === 'square') return output.squareWithDoom();else if (marker === 'cross') return output.crossWithDoom();
      } else {
        if (marker === 'circle') return output.circle();else if (marker === 'triangle') return output.triangle();else if (marker === 'square') return output.square();else if (marker === 'cross') return output.cross();
      }
    },
    outputStrings: {
      circle: {
        en: 'Unmarked Red Circle',
        de: 'Unmarkierter roter Kreis',
        fr: 'Cercle rouge non-marqué',
        ja: '無職で赤まる',
        cn: '无标记红圆圈',
        ko: '무징 빨강 동그라미'
      },
      triangle: {
        en: 'Unmarked Green Triangle',
        de: 'Unmarkiertes grünes Dreieck',
        fr: 'Triangle vert non-marqué',
        ja: '無職で緑さんかく',
        cn: '无标记绿三角',
        ko: '무징 초록 삼각'
      },
      square: {
        en: 'Unmarked Purple Square',
        de: 'Unmarkiertes lilanes Viereck',
        fr: 'Carré violet non-marqué',
        ja: '無職で紫しかく',
        cn: '无标记紫方块',
        ko: '무징 보라 사각'
      },
      cross: {
        en: 'Unmarked Blue X',
        de: 'Unmarkiertes blaues X ',
        fr: 'Croix bleue non-marquée',
        ja: '無職で青バツ',
        cn: '无标记蓝X',
        ko: '무징 파랑 X'
      },
      circleWithDoom: {
        en: 'Unmarked Red Circle (Doom)',
        de: 'Unmarkierter roter Kreis (Verhängnis)',
        fr: 'Cercle rouge non-marqué (Glas)',
        ja: '無職で赤まる (死の宣告)',
        cn: '无标记红圆圈 (死宣)',
        ko: '무징 빨강 동그라미 (선고)'
      },
      triangleWithDoom: {
        en: 'Unmarked Green Triangle (Doom)',
        de: 'Unmarkiertes grünes Dreieck (Verhängnis)',
        fr: 'Triangle vert non-marqué (Glas)',
        ja: '無職で緑さんかく (死の宣告)',
        cn: '无标记绿三角 (死宣)',
        ko: '무징 초록 삼각 (선고)'
      },
      squareWithDoom: {
        en: 'Unmarked Purple Square (Doom)',
        de: 'Unmarkiertes lilanes Viereck (Verhängnis)',
        fr: 'Carré violet non-marqué (Glas)',
        ja: '無職で紫しかく (死の宣告)',
        cn: '无标记紫方块 (死宣)',
        ko: '무징 보라 사각 (선고)'
      },
      crossWithDoom: {
        en: 'Unmarked Blue X (Doom)',
        de: 'Unmarkiertes blaues X (Verhängnis)',
        fr: 'Croix bleue non-marquée (Glas)',
        ja: '無職で青バツ (死の宣告)',
        cn: '无标记蓝X (死宣)',
        ko: '무징 파랑 X (선고)'
      }
    }
  }, {
    // This will only fire if you got a marker, so that it's mutually exclusive
    // with the "No Marker" trigger above.
    id: 'DSR Playstation2 Fire Chains Unexpected Pair',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => {
      if (data.phase !== 'thordan2') return false;
      if (data.me !== matches.target) return false;
      return playstationHeadmarkerIds.includes(dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches));
    },
    delaySeconds: 0.5,
    alarmText: (data, matches, output) => {
      const id = dragonsongs_reprise_ultimate_getHeadmarkerId(data, matches);
      const myMarker = playstationMarkerMap[id];
      if (myMarker === undefined) return;

      // Find person with the same mark.
      let partner = undefined;
      for (const [player, marker] of Object.entries(data.deathMarker)) {
        if (player !== data.me && marker === myMarker) {
          partner = player;
          break;
        }
      }
      if (partner === undefined) return;

      // If a circle ends up with a non-doom or a cross ends up with a doom,
      // I think you're in serious unrecoverable trouble.  These people also
      // already need to look and adjust to the other person, vs the triangle
      // and square which can have a fixed position based on doom vs non-doom.
      if (myMarker === 'circle' || myMarker === 'cross') return;

      // I think circles fill out with doom first, so it should be impossible
      // to have two doom triangles or two doom squares as well.
      if (data.hasDoom[data.me] || data.hasDoom[partner]) return;
      if (myMarker === 'triangle') return output.doubleTriangle({
        player: data.party.member(partner)
      });
      if (myMarker === 'square') return output.doubleSquare({
        player: data.party.member(partner)
      });
    },
    outputStrings: {
      // In case users want to have triangle vs square say something different.
      doubleTriangle: {
        en: 'Double Non-Doom (${player})',
        de: 'Doppeltes Nicht-Verhängnis (${player})',
        fr: 'Double Non-Glas (${player})',
        ja: '自分と相棒は死の宣告なし (${player})',
        cn: '双无死宣 (${player})',
        ko: '둘 다 선고 없음 (${player})'
      },
      doubleSquare: {
        en: 'Double Non-Doom (${player})',
        de: 'Doppeltes Nicht-Verhängnis (${player})',
        fr: 'Double Non-Glas (${player})',
        ja: '自分と相棒は死の宣告なし (${player})',
        cn: '双无死宣 (${player})',
        ko: '둘 다 선고 없음 (${player})'
      }
    }
  }, {
    id: 'DSR Great Wyrmsbreath Hraesvelgr Not Glowing',
    type: 'StartsUsing',
    netRegex: {
      id: '6D34',
      source: 'Hraesvelgr',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tanksApart: {
          en: 'Apart (Hrae buster)',
          de: 'Auseinander (Hrae-buster)',
          fr: 'Séparation (Hrae buster)',
          ja: '離れる (フレスから攻撃)',
          cn: '分散 (圣龙死刑)',
          ko: '떨어지기 (흐레스벨그 탱버)'
        },
        hraesvelgrTankbuster: {
          en: 'Hrae Tankbuster',
          de: 'Hrae Tankbuster',
          fr: 'Hrae Tankbuster',
          ja: 'フレスから攻撃',
          cn: '圣龙死刑',
          ko: '흐레스벨그 탱버'
        }
      };
      if (data.role === 'tank') return {
        alertText: output.tanksApart()
      };
      return {
        infoText: output.hraesvelgrTankbuster()
      };
    }
  }, {
    id: 'DSR Great Wyrmsbreath Hraesvelgr Glowing',
    type: 'StartsUsing',
    netRegex: {
      id: '6D35',
      source: 'Hraesvelgr',
      capture: false
    },
    run: data => data.hraesvelgrGlowing = true
  }, {
    id: 'DSR Great Wyrmsbreath Nidhogg Not Glowing',
    type: 'StartsUsing',
    netRegex: {
      id: '6D32',
      source: 'Nidhogg',
      capture: false
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tanksApart: {
          en: 'Apart (Nid buster)',
          de: 'Auseinander (Nid-buster)',
          fr: 'Séparation (Nid buster)',
          ja: '離れる (ニーズから攻撃)',
          cn: '分散 (邪龙死刑)',
          ko: '떨어지기 (니드호그 탱버)'
        },
        nidTankbuster: {
          en: 'Nid Tankbuster',
          de: 'Nid Tankbuster',
          fr: 'Nid Tankbuster',
          ja: 'ニーズから攻撃',
          cn: '邪龙死刑',
          ko: '니드호그 탱버'
        }
      };
      if (data.role === 'tank') return {
        alertText: output.tanksApart()
      };
      return {
        infoText: output.nidTankbuster()
      };
    }
  }, {
    id: 'DSR Great Wyrmsbreath Nidhogg Glowing',
    type: 'StartsUsing',
    netRegex: {
      id: '6D33',
      source: 'Nidhogg',
      capture: false
    },
    run: data => data.nidhoggGlowing = true
  }, {
    // Great Wyrmsbreath ids
    //   6D32 Nidhogg not glowing
    //   6D33 Nidhogg glowing
    //   6D34 Hraesvelgr not glowing
    //   6D35 Hraesvelgr glowing
    // Hraesvelger and Nidhogg are different actors so can go in either order.
    id: 'DSR Great Wyrmsbreath Both Glowing',
    type: 'StartsUsing',
    netRegex: {
      id: ['6D33', '6D35'],
      source: ['Hraesvelgr', 'Nidhogg'],
      capture: false
    },
    delaySeconds: 0.3,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        sharedBuster: {
          en: 'Shared Buster',
          de: 'geteilter Tankbuster',
          fr: 'Tankbuster partagé',
          ja: 'タンク二人で頭割り',
          cn: '分摊死刑',
          ko: '쉐어 탱버'
        }
      };
      if (!data.hraesvelgrGlowing || !data.nidhoggGlowing) return;
      if (data.role === 'tank') return {
        alertText: output.sharedBuster()
      };
      return {
        infoText: output.sharedBuster()
      };
    },
    run: data => {
      delete data.hraesvelgrGlowing;
      delete data.nidhoggGlowing;
    }
  }, {
    id: 'DSR Mortal Vow Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'B50'
    },
    suppressSeconds: 1,
    run: (data, matches) => data.mortalVowPlayer = matches.target
  }, {
    id: 'DSR Akh Afah',
    // 6D41 Akh Afah from Hraesvelgr, and 64D2 is immediately after
    // 6D43 Akh Afah from Nidhogg, and 6D44 is immediately after
    // Hits the two healers.  If a healer is dead, then the target is random.
    type: 'StartsUsing',
    netRegex: {
      id: ['6D41', '6D43'],
      source: ['Hraesvelgr', 'Nidhogg'],
      capture: false
    },
    suppressSeconds: 2,
    alertText: (_data, _matches, output) => output.groups(),
    outputStrings: {
      groups: {
        en: 'Healer Groups',
        de: 'Heiler-Gruppen',
        fr: 'Groupes sur les heals',
        ja: 'ヒラに頭割り',
        cn: '治疗分组分摊',
        ko: '힐러 그룹 쉐어'
      }
    }
  }, {
    id: 'DSR Adds Phase Nidhogg',
    type: 'AddedCombatant',
    // There are many Nidhoggs, but the real one (and the one that moves for cauterize) is npcBaseId=12612.
    netRegex: {
      npcNameId: '3458',
      npcBaseId: '12612'
    },
    run: (data, matches) => data.addsPhaseNidhoggId = matches.id
  }, {
    id: 'DSR Hallowed Wings and Plume',
    // Calls left and right while looking at Hraesvelgr.
    // 6D23 Head Down, Left Wing
    // 6D24 Head Up, Left Wing
    // 6D26 Head Down, Right Wing
    // 6D27 Head Up, Right Wing
    // Head Up = Tanks Far
    // Head Down = Tanks Near
    type: 'StartsUsing',
    netRegex: {
      id: ['6D23', '6D24', '6D26', '6D27'],
      source: 'Hraesvelgr'
    },
    preRun: data => data.hallowedWingsCount++,
    durationSeconds: 6,
    promise: async data => {
      data.combatantData = [];

      // TODO: implement Hot Tail/Hot Wing combination here
      if (data.hallowedWingsCount !== 1) return;

      // If we have missed the Nidhogg id (somehow?), we'll handle it later.
      const id = data.addsPhaseNidhoggId;
      if (id === undefined) return;
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(id, 16)]
      })).combatants;
      if (data.combatantData.length === 0) console.error(`Hallowed: no Nidhoggs found`);else if (data.combatantData.length > 1) console.error(`Hallowed: unexpected number of Nidhoggs: ${JSON.stringify(data.combatantData)}`);
    },
    alertText: (data, matches, output) => {
      const wings = matches.id === '6D23' || matches.id === '6D24' ? output.left() : output.right();
      let head;
      const isHeadDown = matches.id === '6D23' || matches.id === '6D26';
      if (isHeadDown) head = data.role === 'tank' ? output.tanksNear() : output.partyFar();else head = data.role === 'tank' ? output.tanksFar() : output.partyNear();
      const [nidhogg] = data.combatantData;
      if (nidhogg !== undefined && data.combatantData.length === 1) {
        // Nidhogg is at x = 100 +/- 11, y = 100 +/- 34
        const dive = nidhogg.PosX < 100 ? output.forward() : output.backward();
        return output.wingsDiveHead({
          wings: wings,
          dive: dive,
          head: head
        });
      }

      // If something has gone awry (or this is the second hallowed), call out what we can.
      return output.wingsHead({
        wings: wings,
        head: head
      });
    },
    outputStrings: {
      // The calls here assume that all players are looking at Hraesvelgr, and thus
      // "Forward" means east and "Backward" means west, and "Left" means
      // north and "Right" means south.  The cactbot UI could rename them if this
      // wording is awkward to some people.
      //
      // Also, in case somebody is raid calling, differentiate "Party Near" vs "Tanks Near".
      // This will also help in a rare edge case bug where sometimes people don't have the
      // right job, see: https://github.com/quisquous/cactbot/issues/4237.
      //
      // Yes, these are also tank busters, but there's too many things to call out here,
      // and this is a case of "tanks and healers need to know what's going on ahead of time".
      left: outputs/* default.left */.Z.left,
      right: outputs/* default.right */.Z.right,
      forward: {
        en: 'Forward',
        de: 'Vorwärts',
        fr: 'Avant',
        ja: '前へ',
        cn: '向前',
        ko: '앞쪽으로'
      },
      backward: {
        en: 'Backward',
        de: 'Rückwärts',
        fr: 'Arrière',
        ja: '後ろへ',
        cn: '向后',
        ko: '뒤쪽으로'
      },
      partyNear: {
        en: 'Party Near',
        de: 'Party nahe',
        fr: 'Groupe proche',
        ja: 'パーティが前へ',
        cn: '人群靠近',
        ko: '본대가 가까이'
      },
      tanksNear: {
        en: 'Tanks Near',
        de: 'Tanks nahe',
        fr: 'Tanks proches',
        ja: 'タンクが前へ',
        cn: '坦克靠近',
        ko: '탱커가 가까이'
      },
      partyFar: {
        en: 'Party Far',
        de: 'Party weit weg',
        fr: 'Groupe au loin',
        ja: 'パーティが後ろへ',
        cn: '人群远离',
        ko: '본대가 멀리'
      },
      tanksFar: {
        en: 'Tanks Far',
        de: 'Tanks weit weg',
        fr: 'Tanks au loin',
        ja: 'タンクが後ろへ',
        cn: '坦克远离',
        ko: '탱커가 멀리'
      },
      wingsHead: {
        en: '${wings}, ${head}',
        de: '${wings}, ${head}',
        fr: '${wings}, ${head}',
        ja: '${wings}, ${head}',
        cn: '${wings}, ${head}',
        ko: '${wings}, ${head}'
      },
      wingsDiveHead: {
        en: '${wings} + ${dive}, ${head}',
        de: '${wings} + ${dive}, ${head}',
        fr: '${wings} + ${dive}, ${head}',
        ja: '${wings} + ${dive}, ${head}',
        cn: '${wings} + ${dive}, ${head}',
        ko: '${wings} + ${dive}, ${head}'
      }
    }
  }, {
    id: 'DSR Nidhogg Hot Wing',
    type: 'StartsUsing',
    netRegex: {
      id: '6D2B',
      source: 'Nidhogg',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        // Often cactbot uses "in" and "out", but that's usually hitbox relative vs
        // anything else.  Because this is more arena-relative.
        en: 'Inside',
        de: 'Rein',
        fr: 'Intérieur',
        ja: '内側へ',
        cn: '中间',
        ko: '중앙쪽으로'
      }
    }
  }, {
    id: 'DSR Nidhogg Hot Tail',
    type: 'StartsUsing',
    netRegex: {
      id: '6D2D',
      source: 'Nidhogg',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Outside',
        de: 'Raus',
        fr: 'Extérieur',
        ja: '外側へ',
        cn: '两侧',
        ko: '바깥쪽으로'
      }
    }
  }, {
    id: 'DSR Wyrmsbreath 2 Boiling and Freezing',
    type: 'GainsEffect',
    // B52 = Boiling
    // B53 = Freezing
    // TODO: Get cardinal of the dragon to stand in
    // TODO: Adjust delay to when the bosses jump to cardinal
    netRegex: {
      effectId: ['B52', 'B53']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // Lasts 10.96s, but bosses do not cast Cauterize until 7.5s after debuff
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 6,
    infoText: (_data, matches, output) => {
      if (matches.effectId === 'B52') return output.hraesvelgr();
      return output.nidhogg();
    },
    outputStrings: {
      nidhogg: {
        en: 'Get hit by Nidhogg',
        de: 'Werde von Nidhogg getroffen',
        fr: 'Faites-vous toucher par Nidhogg',
        ja: 'ニーズヘッグに当たる',
        cn: '吃邪龙俯冲',
        ko: '니드호그에게 맞기'
      },
      hraesvelgr: {
        en: 'Get hit by Hraesvelgr',
        de: 'Werde von Hraesvelgr getroffen',
        fr: 'Faites-vous toucher par Hraesvelgr',
        ja: 'フレースヴェルグに当たる',
        cn: '吃圣龙俯冲',
        ko: '흐레스벨그에게 맞기'
      }
    }
  }, {
    id: 'DSR Wyrmsbreath 2 Pyretic',
    type: 'GainsEffect',
    // B52 = Boiling
    // When Boiling expires, Pyretic (3C0) will apply
    // Pyretic will cause damage on movement
    netRegex: {
      effectId: ['B52']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    // Boiling lasts 10.96s, after which Pyretic is applied provide warning
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 1,
    // Player will have Pyretic for about 3s before hit by Cauterize
    durationSeconds: 4,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Stop',
        de: 'Stopp',
        fr: 'Stop',
        ja: '動かない',
        cn: '停停停',
        ko: '멈추기'
      }
    }
  }, {
    id: 'DSR Spreading/Entangled Flame',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['AC6', 'AC7']
    },
    preRun: (data, matches) => {
      if (matches.effectId === 'AC6') data.spreadingFlame.push(matches.target);
      if (matches.effectId === 'AC7') data.entangledFlame.push(matches.target);
    },
    infoText: (data, _matches, output) => {
      if (data.spreadingFlame.length < 4) return;
      if (data.entangledFlame.length < 2) return;
      if (data.spreadingFlame.includes(data.me)) return output.spread();
      if (data.entangledFlame.includes(data.me)) return output.stack();
      return output.nodebuff();
    },
    outputStrings: {
      spread: {
        en: 'Spread',
        de: 'Verteilen',
        fr: 'Écartez-vous',
        ja: '散会',
        cn: '分散',
        ko: '산개징 대상자'
      },
      stack: {
        en: 'Stack',
        de: 'Sammeln',
        fr: 'Package',
        ja: '頭割り',
        cn: '分摊',
        ko: '쉐어징 대상자'
      },
      nodebuff: {
        en: 'No debuff (Stack)',
        de: 'Kein Debuff (Sammeln)',
        fr: 'Aucun debuff (package)',
        ja: 'バフなし (頭割り)',
        cn: '无Debuff (分摊)',
        ko: '무징 (쉐어)'
      }
    }
  }, {
    id: 'DSR Flames of Ascalon',
    type: 'GainsEffect',
    netRegex: {
      effectId: '808',
      count: '12A',
      capture: false
    },
    response: responses/* Responses.getOut */.n3.getOut()
  }, {
    id: 'DSR Ice of Ascalon',
    type: 'GainsEffect',
    netRegex: {
      effectId: '808',
      count: '12B',
      capture: false
    },
    response: responses/* Responses.getIn */.n3.getIn()
  }, {
    id: 'DSR Trinity Tank Dark Resistance',
    type: 'GainsEffect',
    // C40 = Dark Resistance Down, highest enmity target
    netRegex: {
      effectId: 'C40',
      count: '02'
    },
    condition: (data, matches) => data.me === matches.target && data.role === 'tank',
    alertText: (_data, matches, output) => {
      if (parseFloat(matches.duration) > 10) return output.text();
    },
    outputStrings: {
      text: {
        // Only showing 'swap' is really confusing, in my opinion
        en: 'Get 2nd enmity',
        de: 'Sei 2. in der Aggro',
        fr: 'Restez 2ème à l\'aggro',
        ja: 'スタンスオフ',
        cn: '建立二仇',
        ko: '적개심 2순위 잡기'
      }
    }
  }, {
    id: 'DSR Trinity Tank Light Resistance',
    type: 'GainsEffect',
    // C3F = Light Resistance Down, 2nd highest enmity target
    netRegex: {
      effectId: 'C3F',
      count: '02'
    },
    condition: (data, matches) => data.me === matches.target && data.role === 'tank',
    // To prevent boss rotating around before Exaflare
    delaySeconds: 2.5,
    alertText: (_data, matches, output) => {
      if (parseFloat(matches.duration) > 10) return output.text();
    },
    outputStrings: {
      text: {
        en: 'Provoke',
        de: 'Herausforderung',
        fr: 'Provoquez',
        ja: '挑発',
        cn: '挑衅',
        ko: '도발'
      }
    }
  }, {
    id: 'DSR Gigaflare',
    // 6D9A fires first, followed by 6DD2, then 6DD3
    // 6D99 is cast by boss at the center
    // Only need to compare the rotation of 6D9A to 6DD2
    type: 'StartsUsing',
    netRegex: {
      id: ['6D99', '6D9A', '6DD2'],
      source: 'Dragon-king Thordan'
    },
    durationSeconds: 10,
    infoText: (data, matches, output) => {
      // Positions are moved up 100 and right 100
      const x = parseFloat(matches.x) - 100;
      const y = parseFloat(matches.y) - 100;

      // Collect Gigaflare position
      switch (matches.id) {
        case '6D99':
          data.centerGigaflare = [x, y, parseFloat(matches.heading)];
          break;
        case '6D9A':
          data.firstGigaflare = [x, y];
          break;
        case '6DD2':
          data.secondGigaflare = [x, y];
          break;
      }
      if (data.firstGigaflare !== undefined && data.secondGigaflare !== undefined && data.centerGigaflare !== undefined) {
        // Store temporary copies and remove data for next run
        const first = data.firstGigaflare;
        const second = data.secondGigaflare;
        const center = data.centerGigaflare;
        delete data.firstGigaflare;
        delete data.secondGigaflare;
        delete data.centerGigaflare;
        if (first[0] === undefined || first[1] === undefined || second[0] === undefined || second[1] === undefined || center[0] === undefined || center[1] === undefined || center[2] === undefined) {
          console.error(`Gigaflare: missing coordinates`);
          return;
        }

        // Compute atan2 of determinant and dot product to get rotational direction
        // Note: X and Y are flipped due to Y axis being reversed
        const getRotation = (x1, y1, x2, y2) => {
          return Math.atan2(y1 * x2 - x1 * y2, y1 * y2 + x1 * x2);
        };

        // Get rotation of first and second gigaflares
        const rotation = getRotation(first[0], first[1], second[0], second[1]);

        // Get rotation of first gigaflare relative to boss
        let start;

        // Case for if front since data for heading is not exact
        // To detect if front, added angles must match 180 degrees
        const thetaFirstGigaflare = Math.abs(Math.atan2(first[0], first[1]));
        const thetaCenterGigaflare = Math.abs(center[2]);
        const thetaCenterPlusFirst = thetaFirstGigaflare + thetaCenterGigaflare;
        if (Math.round(thetaCenterPlusFirst * 180 / Math.PI) % 180 === 0) {
          start = output.front();
        } else {
          // Gigaflare was not in line with boss facing,
          // Compute initial location relative to boss by
          // calculating point on circle where boss is facing
          const radius = Math.sqrt((center[0] - first[0]) ** 2 + (center[1] - first[1]) ** 2);
          const relX = Math.round(radius * Math.sin(center[2]));
          const relY = Math.round(radius * Math.cos(center[2]));

          // Check rotation of boss facing to first gigaflare:
          const startNum = getRotation(relX, relY, first[0], first[1]);
          if (startNum < 0) start = output.backLeft();else if (startNum > 0) start = output.backRight();else start = output.unknown();
        }
        if (rotation < 0) {
          return output.directions({
            start: start,
            rotation: output.clockwise()
          });
        }
        if (rotation > 0) {
          return output.directions({
            start: start,
            rotation: output.counterclock()
          });
        }
      }
    },
    outputStrings: {
      directions: {
        en: '${start} => ${rotation}',
        de: '${start} => ${rotation}',
        fr: '${start} => ${rotation}',
        ja: '${start} => ${rotation}',
        cn: '${start} => ${rotation}',
        ko: '${start} => ${rotation}'
      },
      backLeft: {
        en: 'Back left',
        de: 'Hinten links',
        fr: 'Arrière gauche',
        ja: '左後ろ',
        cn: '左后',
        ko: '뒤 왼쪽'
      },
      backRight: {
        en: 'Back right',
        de: 'Hinten rechts',
        fr: 'Arrière droit',
        ja: '右後ろ',
        cn: '右后',
        ko: '뒤 오른쪽'
      },
      front: {
        en: 'Front',
        de: 'Vorne',
        fr: 'Devant',
        ja: '前',
        cn: '前',
        ko: '앞'
      },
      unknown: outputs/* default.unknown */.Z.unknown,
      clockwise: {
        en: 'Clockwise',
        de: 'Im Uhrzeigersinn',
        fr: 'Horaire',
        ja: '時計回り',
        cn: '顺时针',
        ko: '시계방향'
      },
      counterclock: {
        en: 'Counterclockwise',
        de: 'Gegen den Uhrzeigersinn',
        fr: 'Anti-horaire',
        ja: '反時計回り',
        cn: '逆时针',
        ko: '반시계방향'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'en',
    'replaceText': {
      'Empty Dimension/Full Dimension': 'Empty/Full Dimension',
      'Lash and Gnash/Gnash and Lash': 'Lash and Gnash',
      'Ice of Ascalon/Flames of Ascalon': 'Ice/Flames of Ascalon'
    }
  }, {
    'locale': 'de',
    'replaceSync': {
      'Darkscale': 'Dunkelschuppe',
      'Dragon-king Thordan': 'König Thordan',
      'Estinien': 'Estinien',
      'Haurchefant': 'Haurchefant',
      'Hraesvelgr': 'Hraesvelgr',
      '(?<!Dragon-)King Thordan': 'Thordan',
      'Left Eye': 'link(?:e|er|es|en) Auge',
      'Meteor Circle': 'Meteorsiegel',
      'Nidhogg': 'Nidhogg',
      'Right Eye': 'recht(?:e|er|es|en) Auge',
      'Ser Adelphel': 'Adelphel',
      'Ser Charibert': 'Charibert',
      'Ser Grinnaux': 'Grinnaux',
      'Ser Guerrique': 'Guerrique',
      'Ser Haumeric': 'Haumeric',
      'Ser Hermenost': 'Hermenost',
      'Ser Ignasse': 'Ignasse',
      'Ser Janlenoux': 'Janlenoux',
      'Ser Noudenet': 'Noudenet',
      'Ser Zephirin': 'Zephirin',
      'Spear of the Fury': 'Speer der Furie',
      'Vedrfolnir': 'Vedrfölnir',
      'Ysayle': 'Ysayle'
    },
    'replaceText': {
      'Aetheric Burst': 'Ätherschub',
      'Akh Afah': 'Akh Afah',
      'Akh Morn(?!\'s Edge)': 'Akh Morn',
      'Akh Morn\'s Edge': 'Akh Morns Klinge',
      'Ancient Quaga': 'Seisga Antiqua',
      'Alternative End': 'Ein neues Ende',
      'Altar Flare': 'Altar-Flare',
      'Ascalon\'s Mercy Concealed': 'Askalons geheime Gnade',
      'Ascalon\'s Mercy Revealed': 'Askalons enthüllte Gnade',
      'Ascalon\'s Might': 'Macht von Askalon',
      'Brightblade\'s Steel': 'Schimmernder Stahl',
      'Brightwing(?!ed)': 'Lichtschwinge',
      'Brightwinged Flight': 'Flug der Lichtschwingen',
      'Broad Swing': 'Ausladender Schwung',
      'Cauterize': 'Kauterisieren',
      'Chain Lightning': 'Kettenblitz',
      'Conviction': 'Konviktion',
      'Dark Orb': 'Dunkler Orbis',
      'Darkdragon Dive': 'Dunkeldrachensturz',
      'Death of the Heavens': 'Himmel des Todes',
      'Deathstorm': 'Todessturm',
      'Dimensional Collapse': 'Dimensionskollaps',
      'Dive from Grace': 'Gefallener Drache ',
      'Drachenlance': 'Drachenlanze',
      'Dread Wyrmsbreath': 'Dunkler Drachenodem',
      'Empty Dimension': 'Dimension der Leere',
      'Entangled Flames': 'Verwobene Flammen',
      'Exaflare\'s Edge': 'Exaflare-Klinge',
      'Execution': 'Exekution',
      'Eye of the Tyrant': 'Auge des Tyrannen',
      'Faith Unmoving': 'Fester Glaube',
      'Final Chorus': 'Endchoral',
      'Flame Breath': 'Flammenatem',
      'Flames of Ascalon': 'Flamme von Askalon',
      'Flare Nova': 'Flare Nova',
      'Flare Star': 'Flare-Stern',
      'Full Dimension': 'Dimension der Weite',
      'Geirskogul': 'Geirskogul',
      'Gigaflare\'s Edge': 'Gigaflare-Klinge',
      'Gnash and Lash': 'Reißen und Beißen',
      'Great Wyrmsbreath': 'Heller Drachenodem',
      'Hallowed Plume': 'Geweihte Feder',
      'Hallowed Wings': 'Heilige Schwingen',
      'Hatebound': 'Nidhoggs Hass',
      'Heavenly Heel': 'Himmelsschritt',
      'Heavens\' Stake': 'Himmelslanze',
      'Heavensblaze': 'Himmlisches Lodern',
      'Heavensflame': 'Himmlische Flamme',
      'Heavy Impact': 'Heftiger Einschlag',
      'Hiemal Storm': 'Hiemaler Sturm',
      'Holiest of Holy': 'Quell der Heiligkeit',
      'Holy Bladedance': 'Geweihter Schwerttanz',
      'Holy Breath': 'Heiliger Atem',
      'Holy Comet': 'Heiliger Komet',
      'Holy Meteor': 'Heiliger Meteor',
      'Holy Orb': 'Heiliger Orbis',
      'Holy Shield Bash': 'Heiliger Schildschlag',
      'Hot Tail': 'Schwelender Schweif',
      'Hot Wing': 'Flirrender Flügel',
      'Hyperdimensional Slash': 'Hyperdimensionsschlag',
      'Ice Breath': 'Eisatem',
      'Ice of Ascalon': 'Eis von Askalon',
      'Incarnation': 'Inkarnation',
      'Knights of the Round': 'Ritter der Runde',
      'Lash and Gnash': 'Beißen und Reißen',
      'Lightning Storm': 'Blitzsturm',
      'Liquid Heaven': 'Himmlisches Fluid',
      'Meteor Impact': 'Meteoreinschlag',
      'Mirage Dive': 'Illusionssprung',
      'Mortal Vow': 'Schwur der Vergeltung',
      'Morn Afah\'s Edge': 'Morn Afahs Klinge',
      'Planar Prison': 'Dimensionsfalle',
      'Pure of Heart': 'Reines Herz',
      'Resentment': 'Bitterer Groll',
      'Revenge of the Horde': 'Rache der Horde',
      'Sacred Sever': 'Sakralschnitt',
      'Sanctity of the Ward': 'Erhabenheit der Königsschar',
      'Shockwave': 'Schockwelle',
      'Skyblind': 'Lichtblind',
      'Skyward Leap': 'Luftsprung',
      'Soul Tether': 'Seelenstrick',
      'Soul of Devotion': 'Essenz der Tugend',
      'Soul of Friendship': 'Essenz der Freundschaft',
      'Spear of the Fury': 'Speer der Furie',
      'Spiral Pierce': 'Spiralstich',
      'Spiral Thrust': 'Spiralstoß',
      'Spreading Flames': 'Flammende Rache',
      'Staggering Breath': 'Stoßender Atem',
      'Steep in Rage': 'Welle des Zorns',
      'Strength of the Ward': 'Übermacht der Königsschar',
      'Swirling Blizzard': 'Blizzardwirbel',
      'The Bull\'s Steel': 'Unbändiger Stahl',
      'The Dragon\'s Eye': 'Auge des Drachen',
      'The Dragon\'s Gaze': 'Blick des Drachen',
      'The Dragon\'s Glory': 'Ruhm des Drachen',
      'The Dragon\'s Rage': 'Zorn des Drachen',
      'Tower': 'Turm',
      'Touchdown': 'Himmelssturz',
      'Trinity': 'Trinität',
      'Twisting Dive': 'Spiralschwinge',
      'Ultimate End': 'Ultimatives Ende',
      'Wrath of the Heavens': 'Himmel des Zorns',
      'Wroth Flames': 'Flammender Zorn'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Darkscale': 'Sombrécaille',
      'Dragon-king Thordan': 'Thordan le Dieu Dragon',
      'Estinien': 'Estinien',
      'Haurchefant': 'Haurchefant',
      'Hraesvelgr': 'Hraesvelgr',
      '(?<!Dragon-)King Thordan': 'roi Thordan',
      'Left Eye': 'Œil gauche de Nidhogg',
      'Meteor Circle': 'sceau du météore',
      'Nidhogg': 'Nidhogg',
      'Right Eye': 'Œil droit de Nidhogg',
      'Ser Adelphel': 'sire Adelphel',
      'Ser Charibert': 'sire Charibert',
      'Ser Grinnaux': 'sire Grinnaux',
      'Ser Guerrique': 'sire Guerrique',
      'Ser Haumeric': 'sire Haumeric',
      'Ser Hermenost': 'sire Hermenoist',
      'Ser Ignasse': 'sire Ignassel',
      'Ser Janlenoux': 'sire Janlenoux',
      'Ser Noudenet': 'sire Noudenet',
      'Ser Zephirin': 'sire Zéphirin',
      'Spear of the Fury': 'Lance de la Conquérante',
      'Vedrfolnir': 'Vedrfolnir',
      'Ysayle': 'Ysayle'
    },
    'replaceText': {
      'Aetheric Burst': 'Explosion éthérée',
      'Akh Afah': 'Akh Afah',
      'Akh Morn(?!\'s Edge)': 'Akh Morn',
      'Akh Morn\'s Edge': 'Lame d\'Akh Morn',
      'Ancient Quaga': 'Méga Séisme ancien',
      'Alternative End': 'Fin alternative',
      'Altar Flare': 'Brasier de l\'autel',
      'Ascalon\'s Mercy Concealed': 'Grâce d\'Ascalon dissimulée',
      'Ascalon\'s Mercy Revealed': 'Grâce d\'Ascalon révélée',
      'Ascalon\'s Might': 'Puissance d\'Ascalon',
      'Brightblade\'s Steel': 'Résolution radiante',
      'Brightwing(?!ed)': 'Aile lumineuse',
      'Brightwinged Flight': 'Vol céleste',
      'Broad Swing': 'Grand balayage',
      'Cauterize': 'Cautérisation',
      'Chain Lightning': 'Chaîne d\'éclairs',
      'Conviction': 'Conviction',
      'Dark Orb': 'Orbe ténébreux',
      'Darkdragon Dive': 'Piqué du dragon sombre',
      'Death of the Heavens': 'Condamnation d\'azur',
      'Deathstorm': 'Tempête de la mort',
      'Dimensional Collapse': 'Effondrement dimensionnel',
      'Dive from Grace': 'Dragon déchu',
      'Drachenlance': 'Drachenlance',
      'Dread Wyrmsbreath': 'Souffle de Nidhogg',
      'Empty Dimension': 'Vide dimensionnel',
      'Entangled Flames': 'Flammes enchevêtrées',
      'Exaflare\'s Edge': 'Lame d\'ExaBrasier',
      'Execution': 'Exécution',
      'Eye of the Tyrant': 'Œil du tyran',
      'Faith Unmoving': 'Foi immuable',
      'Final Chorus': 'Chant ultime',
      'Flame Breath': 'Pyrosouffle',
      'Flames of Ascalon': 'Feu d\'Ascalon',
      'Flare Nova': 'Désastre flamboyant',
      'Flare Star': 'Astre flamboyant',
      'Full Dimension': 'Plénitude dimensionnelle',
      'Geirskogul': 'Geirskögul',
      'Gigaflare\'s Edge': 'Lame de GigaBrasier',
      'Gnash and Lash': 'Grincement tordu',
      'Great Wyrmsbreath': 'Souffle de Hraesvelgr',
      'Hallowed Plume': 'Écaille sacrée',
      'Hallowed Wings': 'Aile sacrée',
      'Hatebound': 'Lacération de Nidhogg',
      'Heavenly Heel': 'Estoc céleste',
      'Heavens\' Stake': 'Pal d\'azur',
      'Heavensblaze': 'Embrasement céleste',
      'Heavensflame': 'Flamme céleste',
      'Heavy Impact': 'Impact violent',
      'Hiemal Storm': 'Tempête hiémale',
      'Holiest of Holy': 'Saint des saints',
      'Holy Bladedance': 'Danse de la lame céleste',
      'Holy Breath': 'Souffle miraculeux',
      'Holy Comet': 'Comète miraculeuse',
      'Holy Meteor': 'Météore sacré',
      'Holy Orb': 'Orbe miraculeux',
      'Holy Shield Bash': 'Coup de bouclier saint',
      'Hot Tail': 'Queue calorifique',
      'Hot Wing': 'Aile calorifique',
      'Hyperdimensional Slash': 'Lacération hyperdimensionnelle',
      'Ice Breath': 'Givrosouffle',
      'Ice of Ascalon': 'Glace d\'Ascalon',
      'Incarnation': 'Incarnation sacrée',
      'Knights of the Round': 'Chevaliers de la Table ronde',
      'Lash and Gnash': 'Torsion grinçante',
      'Lightning Storm': 'Pluie d\'éclairs',
      'Liquid Heaven': 'Paradis liquide',
      'Meteor Impact': 'Impact de météore',
      'Mirage Dive': 'Piqué mirage',
      'Mortal Vow': 'Vœu d\'anéantissement',
      'Morn Afah\'s Edge': 'Lame de Morn Afah',
      'Planar Prison': 'Prison dimensionnelle',
      'Pure of Heart': 'Pureté du cœur',
      'Resentment': 'Râle d\'agonie',
      'Revenge of the Horde': 'Chant pour l\'avenir',
      'Sacred Sever': 'Scission sacrée',
      'Sanctity of the Ward': 'Béatitude du Saint-Siège',
      'Shockwave': 'Onde de choc',
      'Skyblind': 'Sceau céleste',
      'Skyward Leap': 'Bond céleste',
      'Soul Tether': 'Bride de l\'âme',
      'Soul of Devotion': 'Dévotion éternelle',
      'Soul of Friendship': 'Amitié éternelle',
      'Spear of the Fury': 'Lance de la Conquérante',
      'Spiral Pierce': 'Empalement tournoyant',
      'Spiral Thrust': 'Transpercement tournoyant',
      'Spreading Flames': 'Vengeance consumante',
      'Staggering Breath': 'Souffle ébranlant',
      'Steep in Rage': 'Onde de fureur',
      'Strength of the Ward': 'Force du Saint-Siège',
      'Swirling Blizzard': 'Blizzard tourbillonnant',
      'The Bull\'s Steel': 'Résolution rueuse',
      'The Dragon\'s Eye': 'Œil du dragon',
      'The Dragon\'s Gaze': 'Regard du dragon',
      'The Dragon\'s Glory': 'Gloire du dragon',
      'The Dragon\'s Rage': 'Colère du dragon',
      'Touchdown': 'Atterrissage',
      'Tower': 'Tour',
      'Trinity': 'Trinité',
      'Twisting Dive': 'Plongeon-trombe',
      'Ultimate End': 'Fin ultime',
      'Wrath of the Heavens': 'Colère d\'azur',
      'Wroth Flames': 'Haine enflammée'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Darkscale': 'ダークスケール',
      'Dragon-king Thordan': '騎竜神トールダン',
      'Estinien': 'エスティニアン',
      'Haurchefant': 'オルシュファン',
      'Hraesvelgr': 'フレースヴェルグ',
      '(?<!Dragon-)King Thordan': '騎神トールダン',
      'Left Eye': '邪竜の左眼',
      'Meteor Circle': '流星の聖紋',
      'Nidhogg': 'ニーズヘッグ',
      'Right Eye': '邪竜の右眼',
      'Ser Adelphel': '聖騎士アデルフェル',
      'Ser Charibert': '聖騎士シャリベル',
      'Ser Grinnaux': '聖騎士グリノー',
      'Ser Guerrique': '聖騎士ゲリック',
      'Ser Haumeric': '聖騎士オムリク',
      'Ser Hermenost': '聖騎士エルムノスト',
      'Ser Ignasse': '聖騎士イニアセル',
      'Ser Janlenoux': '聖騎士ジャンルヌ',
      'Ser Noudenet': '聖騎士ヌドゥネー',
      'Ser Zephirin': '聖騎士ゼフィラン',
      'Spear of the Fury': 'スピア・オブ・ハルオーネ',
      'Vedrfolnir': 'ヴェズルフェルニル',
      'Ysayle': 'イゼル'
    },
    'replaceText': {
      'Aetheric Burst': 'エーテルバースト',
      'Akh Afah': 'アク・アファー',
      'Akh Morn(?!\'s Edge)': 'アク・モーン',
      'Akh Morn\'s Edge': '騎竜剣アク・モーン',
      'Ancient Quaga': 'エンシェントクエイガ',
      'Alternative End': 'アルティメットエンド・オルタナ',
      'Altar Flare': 'アルターフレア',
      'Ascalon\'s Mercy Concealed': 'インビジブル・アスカロンメルシー',
      'Ascalon\'s Mercy Revealed': 'レベレーション・アスカロンメルシー',
      'Ascalon\'s Might': 'アスカロンマイト',
      'Brightblade\'s Steel': '美剣の覚悟',
      'Brightwing(?!ed)': '光翼閃',
      'Brightwinged Flight': '蒼天の光翼',
      'Broad Swing': '大振り',
      'Cauterize': 'カータライズ',
      'Chain Lightning': 'チェインライトニング',
      'Conviction': 'コンヴィクション',
      'Dark Orb': 'ダークオーブ',
      'Darkdragon Dive': 'ダークドラゴンダイブ',
      'Death of the Heavens': '至天の陣：死刻',
      'Deathstorm': 'デスストーム',
      'Dimensional Collapse': 'ディメンションクラッシュ',
      'Dive from Grace': '堕天のドラゴンダイブ',
      'Drachenlance': 'ドラッケンランス',
      'Dread Wyrmsbreath': '邪竜の息吹',
      'Empty Dimension': 'エンプティディメンション',
      'Entangled Flames': '道連れの炎',
      'Exaflare\'s Edge': '騎竜剣エクサフレア',
      'Execution': 'エクスキューション',
      'Eye of the Tyrant': 'アイ・オブ・タイラント',
      'Faith Unmoving': 'フェイスアンムーブ',
      'Final Chorus': '終焉の竜詩',
      'Flame Breath': 'フレイムブレス',
      'Flames of Ascalon': 'フレイム・オブ・アスカロン',
      'Flare Nova': 'フレアディザスター',
      'Flare Star': 'フレアスター',
      'Full Dimension': 'フルディメンション',
      'Geirskogul': 'ゲイルスコグル',
      'Gigaflare\'s Edge': '騎竜剣ギガフレア',
      'Gnash and Lash': '牙尾の連旋',
      'Great Wyrmsbreath': '聖竜の息吹',
      'Hallowed Plume': 'ホーリーフェザー',
      'Hallowed Wings': 'ホーリーウィング',
      'Hatebound': '邪竜爪牙',
      'Heavenly Heel': 'ヘヴンリーヒール',
      'Heavens\' Stake': 'ヘヴンステイク',
      'Heavensblaze': 'ヘヴンブレイズ',
      'Heavensflame': 'ヘヴンフレイム',
      'Heavy Impact': 'ヘヴィインパクト',
      'Hiemal Storm': 'ハイマルストーム',
      'Holiest of Holy': 'ホリエストホーリー',
      'Holy Bladedance': 'ホーリーブレードダンス',
      'Holy Breath': 'ホーリーブレス',
      'Holy Comet': 'ホーリーコメット',
      'Holy Meteor': 'ホーリーメテオ',
      'Holy Orb': 'ホーリーオーブ',
      'Holy Shield Bash': 'ホーリーシールドバッシュ',
      'Hot Tail': 'ヒートテイル',
      'Hot Wing': 'ヒートウィング',
      'Hyperdimensional Slash': 'ハイパーディメンション',
      'Ice Breath': 'コールドブレス',
      'Ice of Ascalon': 'アイス・オブ・アスカロン',
      'Incarnation': '聖徒化',
      'Knights of the Round': 'ナイツ・オブ・ラウンド',
      'Lash and Gnash': '尾牙の連旋',
      'Lightning Storm': '百雷',
      'Liquid Heaven': 'ヘブンリキッド',
      'Meteor Impact': 'メテオインパクト',
      'Mirage Dive': 'ミラージュダイブ',
      'Mortal Vow': '滅殺の誓い',
      'Morn Afah\'s Edge': '騎竜剣モーン・アファー',
      'Planar Prison': 'ディメンションジェイル',
      'Pure of Heart': 'ピュア・オブ・ハート',
      'Resentment': '苦悶の咆哮',
      'Revenge of the Horde': '最期の咆哮',
      'Sacred Sever': 'セイクリッドカット',
      'Sanctity of the Ward': '蒼天の陣：聖杖',
      'Shockwave': '衝撃波',
      'Skyblind': '蒼天の刻印',
      'Skyward Leap': 'スカイワードリープ',
      'Soul Tether': 'ソウルテザー',
      'Soul of Devotion': '巫女の想い',
      'Soul of Friendship': '盟友の想い',
      'Spear of the Fury': 'スピア・オブ・ハルオーネ',
      'Spiral Pierce': 'スパイラルピアス',
      'Spiral Thrust': 'スパイラルスラスト',
      'Spreading Flames': '復讐の炎',
      'Staggering Breath': 'スタッガーブレス',
      'Steep in Rage': '憤怒の波動',
      'Strength of the Ward': '蒼天の陣：雷槍',
      'Swirling Blizzard': 'ブリザードサークル',
      'The Bull\'s Steel': '戦狂の覚悟',
      'The Dragon\'s Eye': '竜の眼',
      'The Dragon\'s Gaze': '竜の邪眼',
      'The Dragon\'s Glory': '邪竜の眼光',
      'The Dragon\'s Rage': '邪竜の魔炎',
      'Tower': '塔',
      'Touchdown': 'タッチダウン',
      'Trinity': 'トリニティ',
      'Twisting Dive': 'ツイスターダイブ',
      'Ultimate End': 'アルティメットエンド',
      'Wrath of the Heavens': '至天の陣：風槍',
      'Wroth Flames': '邪念の炎'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Darkscale': '暗鳞黑龙',
      'Dragon-king Thordan': '龙威骑神托尔丹',
      'Estinien': '埃斯蒂尼安',
      'Haurchefant': '奥尔什方',
      'Hraesvelgr': '赫拉斯瓦尔格',
      '(?<!Dragon-)King Thordan': '骑神托尔丹',
      'Left Eye': '邪龙的左眼',
      'Meteor Circle': '流星圣纹',
      'Nidhogg': '尼德霍格',
      'Right Eye': '邪龙的右眼',
      'Ser Adelphel': '圣骑士阿代尔斐尔',
      'Ser Charibert': '圣骑士沙里贝尔',
      'Ser Grinnaux': '圣骑士格里诺',
      'Ser Guerrique': '圣骑士盖里克',
      'Ser Haumeric': '圣骑士奥默里克',
      'Ser Hermenost': '圣骑士埃尔姆诺斯特',
      'Ser Ignasse': '圣骑士伊尼亚斯',
      'Ser Janlenoux': '圣骑士让勒努',
      'Ser Noudenet': '圣骑士努德内',
      'Ser Zephirin': '圣骑士泽菲兰',
      'Spear of the Fury': '战女神之枪',
      'Vedrfolnir': '维德佛尔尼尔',
      'Ysayle': '伊塞勒'
    },
    'replaceText': {
      'Aetheric Burst': '以太爆发',
      'Akh Afah': '无尽轮回',
      'Akh Morn(?!\'s Edge)': '死亡轮回',
      'Akh Morn\'s Edge': '死亡轮回剑',
      'Ancient Quaga': '古代爆震',
      'Alternative End': '异史终结',
      'Altar Flare': '圣坛核爆',
      'Ascalon\'s Mercy Concealed': '阿斯卡隆之仁·隐秘',
      'Ascalon\'s Mercy Revealed': '阿斯卡隆之仁·揭示',
      'Ascalon\'s Might': '阿斯卡隆之威',
      'Brightblade\'s Steel': '光辉剑的决意',
      'Brightwing(?!ed)': '光翼闪',
      'Brightwinged Flight': '苍穹光翼',
      'Broad Swing': '奋力一挥',
      'Cauterize': '洁白俯冲',
      'Chain Lightning': '雷光链',
      'Conviction': '信仰',
      'Dark Orb': '暗天球',
      'Darkdragon Dive': '黑暗龙炎冲',
      'Death of the Heavens': '至天之阵：死刻',
      'Deathstorm': '死亡风暴',
      'Dimensional Collapse': '空间破碎',
      'Dive from Grace': '堕天龙炎冲',
      'Drachenlance': '腾龙枪',
      'Dread Wyrmsbreath': '邪龙的吐息',
      'Empty Dimension': '无维空间',
      'Entangled Flames': '同归于尽之炎',
      'Exaflare\'s Edge': '百京核爆剑',
      'Execution': '处刑',
      'Eye of the Tyrant': '暴君之瞳',
      'Faith Unmoving': '坚定信仰',
      'Final Chorus': '灭绝之诗',
      'Flame Breath': '火焰吐息',
      'Flames of Ascalon': '阿斯卡隆之焰',
      'Flare Nova': '核爆灾祸',
      'Flare Star': '耀星',
      'Full Dimension': '全维空间',
      'Geirskogul': '武神枪',
      'Gigaflare\'s Edge': '十亿核爆剑',
      'Gnash and Lash': '牙尾连旋',
      'Great Wyrmsbreath': '圣龙的吐息',
      'Hallowed Plume': '神圣之羽',
      'Hallowed Wings': '神圣之翼',
      'Hatebound': '邪龙爪牙',
      'Heavenly Heel': '天踵',
      'Heavens\' Stake': '苍穹火刑',
      'Heavensblaze': '苍穹炽焰',
      'Heavensflame': '天火',
      'Heavy Impact': '沉重冲击',
      'Hiemal Storm': '严冬风暴',
      'Holiest of Holy': '至圣',
      'Holy Bladedance': '圣光剑舞',
      'Holy Breath': '神圣吐息',
      'Holy Comet': '神圣彗星',
      'Holy Meteor': '陨石圣星',
      'Holy Orb': '神圣球',
      'Holy Shield Bash': '圣盾猛击',
      'Hot Tail': '燃烧之尾',
      'Hot Wing': '燃烧之翼',
      'Hyperdimensional Slash': '多维空间斩',
      'Ice Breath': '寒冰吐息',
      'Ice of Ascalon': '阿斯卡隆之冰',
      'Incarnation': '圣徒洗礼',
      'Knights of the Round': '圆桌骑士',
      'Lash and Gnash': '尾牙连旋',
      'Lightning Storm': '百雷',
      'Liquid Heaven': '苍天火液',
      'Meteor Impact': '陨石冲击',
      'Mirage Dive': '幻象冲',
      'Mortal Vow': '灭杀的誓言',
      'Morn Afah\'s Edge': '无尽顿悟剑',
      '(?<! )Pierce': '贯穿',
      'Planar Prison': '空间牢狱',
      'Pure of Heart': '纯洁心灵',
      'Resentment': '苦闷怒嚎',
      'Revenge of the Horde': '绝命怒嚎',
      'Sacred Sever': '神圣裂斩',
      'Sanctity of the Ward': '苍穹之阵：圣杖',
      'Shockwave': '冲击波',
      'Skyblind': '苍穹刻印',
      'Skyward Leap': '穿天',
      'Soul Tether': '追魂炮',
      'Soul of Devotion': '巫女的思念',
      'Soul of Friendship': '盟友的思念',
      'Spear of the Fury': '战女神之枪',
      'Spiral Pierce': '螺旋枪',
      'Spiral Thrust': '螺旋刺',
      'Spreading Flames': '复仇之炎',
      'Staggering Breath': '交错吐息',
      'Steep in Rage': '愤怒波动',
      'Strength of the Ward': '苍穹之阵：雷枪',
      'Swirling Blizzard': '冰结环',
      'The Bull\'s Steel': '战争狂的决意',
      'The Dragon\'s Eye': '龙眼之光',
      'The Dragon\'s Gaze': '龙眼之邪',
      'The Dragon\'s Glory': '邪龙目光',
      'The Dragon\'s Rage': '邪龙魔炎',
      'Tower': '塔',
      'Touchdown': '空降',
      'Trinity': '三剑一体',
      'Twisting Dive': '旋风冲',
      'Ultimate End': '万物终结',
      'Wrath of the Heavens': '至天之阵：风枪',
      'Wroth Flames': '邪念之炎'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Darkscale': '검은미늘',
      'Dragon-king Thordan': '기룡신 토르당',
      'Estinien': '에스티니앙',
      'Haurchefant': '오르슈팡',
      'Hraesvelgr': '흐레스벨그',
      '(?<!Dragon-)King Thordan': '기사신 토르당',
      'Left Eye': '사룡의 왼눈',
      'Meteor Circle': '성스러운 별똥별 문양',
      'Nidhogg': '니드호그',
      'Right Eye': '사룡의 오른눈',
      'Ser Adelphel': '성기사 아델펠',
      'Ser Charibert': '성기사 샤리베르',
      'Ser Grinnaux': '성기사 그리노',
      'Ser Guerrique': '성기사 게리크',
      'Ser Haumeric': '성기사 오메리크',
      'Ser Hermenost': '성기사 에르메노',
      'Ser Ignasse': '성기사 이냐스',
      'Ser Janlenoux': '성기사 장르누',
      'Ser Noudenet': '성기사 누데네',
      'Ser Zephirin': '성기사 제피랭',
      'Spear of the Fury': '할로네의 창',
      'Vedrfolnir': '베드르폴니르',
      'Ysayle': '이젤'
    },
    'replaceText': {
      'Empty Dimension/Full Dimension': '공허한/충만한 차원',
      'Lash and Gnash/Gnash and Lash': '꼬리이빨/이빨꼬리 연속 회전',
      'Ice of Ascalon/Flames of Ascalon': '아스칼론의 불꽃/얼음',
      'Aetheric Burst': '에테르 분출',
      'Akh Afah': '아크 아파',
      'Akh Morn(?!\'s Edge)': '아크 몬',
      'Akh Morn\'s Edge': '기룡검 아크 몬',
      'Ancient Quaga': '에인션트 퀘이가',
      'Alternative End': '또 다른 궁극의 종말',
      'Altar Flare': '제단의 불길',
      'Ascalon\'s Mercy Concealed': '아스칼론의 자비: 불가시',
      'Ascalon\'s Mercy Revealed': '아스칼론의 자비: 계시',
      'Ascalon\'s Might': '아스칼론의 권능',
      'Brightblade\'s Steel': '미검의 각오',
      'Brightwing(?!ed)': '광익섬',
      'Brightwinged Flight': '창천의 광익',
      'Broad Swing': '휘두르기',
      'Cauterize': '인두질',
      'Chain Lightning': '번개 사슬',
      'Conviction': '눈보라 절벽',
      'Dark Orb': '암흑 구체',
      'Darkdragon Dive': '암룡 강타',
      'Death of the Heavens': '지천의 진: 죽음',
      'Deathstorm': '죽음의 폭풍',
      'Dimensional Collapse': '차원 파괴',
      'Dive from Grace': '타락한 천룡 강타',
      'Drachenlance': '용창 가르기',
      'Dread Wyrmsbreath': '사룡의 숨결',
      'Empty Dimension(?!/)': '공허한 차원',
      'Entangled Flames': '길동무 불꽃',
      'Exaflare\'s Edge': '기룡검 엑사플레어',
      'Execution': '집행',
      'Eye of the Tyrant': '폭군의 눈동자',
      'Faith Unmoving': '굳건한 신앙',
      'Final Chorus': '종언의 용시',
      'Flame Breath': '화염 숨결',
      'Flare Nova': '타오르는 샛별',
      'Flare Star': '타오르는 별',
      '(?<!/)Full Dimension': '충만한 차원',
      'Geirskogul': '게이르스코굴',
      'Gigaflare\'s Edge': '기룡검 기가플레어',
      'Great Wyrmsbreath': '성룡의 숨결',
      'Hallowed Plume': '신성한 깃털',
      'Hallowed Wings': '신성한 날개',
      'Hatebound': '사룡의 발톱이빨',
      'Heavenly Heel': '천상의 발꿈치',
      'Heavens\' Stake': '천상의 화형',
      'Heavensblaze': '천상의 불',
      'Heavensflame': '천상의 불꽃',
      'Heavy Impact': '무거운 충격',
      'Hiemal Storm': '동장군 폭풍',
      'Holiest of Holy': '지고한 신성',
      'Holy Bladedance': '신성한 검무',
      'Holy Breath': '신성 숨결',
      'Holy Comet': '신성한 혜성',
      'Holy Meteor': '홀리 메테오',
      'Holy Orb': '신성 구체',
      'Holy Shield Bash': '성스러운 방패 강타',
      'Hot Tail': '뜨거운 꼬리',
      'Hot Wing': '뜨거운 날개',
      'Hyperdimensional Slash': '고차원',
      'Ice Breath': '냉기 숨결',
      'Incarnation': '성스러운 신도화',
      'Knights of the Round': '나이츠 오브 라운드',
      'Lightning Storm': '백뢰',
      'Liquid Heaven': '천국의 늪',
      'Meteor Impact': '운석 낙하',
      'Mirage Dive': '환영 강타',
      'Mortal Vow': '멸살의 맹세',
      'Morn Afah\'s Edge': '기룡검 몬 아파',
      '(?<!Spiral )Pierce': '관통',
      'Planar Prison': '차원 감옥',
      'Pure of Heart': '정결한 마음',
      'Resentment': '고통의 포효',
      'Revenge of the Horde': '최후의 포효',
      'Sacred Sever': '신성한 돌진',
      'Sanctity of the Ward': '창천의 진: 지팡이',
      'Shockwave': '충격파',
      'Skyblind': '창천의 각인',
      'Skyward Leap': '공중 도약',
      'Soul Tether': '혼의 사슬',
      'Soul of Devotion': '무녀의 넋',
      'Soul of Friendship': '맹우의 넋',
      'Spear of the Fury': '할로네의 창',
      'Spiral Pierce': '나선 관통',
      'Spiral Thrust': '나선 찌르기',
      'Spreading Flames': '복수의 불꽃',
      'Staggering Breath': '제압의 숨결',
      'Steep in Rage': '분노의 파동',
      'Strength of the Ward': '창천의 진: 번개창',
      'Swirling Blizzard': '환형 눈보라',
      'The Bull\'s Steel': '전쟁광의 각오',
      'The Dragon\'s Eye': '용의 눈',
      'The Dragon\'s Gaze': '용의 마안',
      'The Dragon\'s Glory': '사룡의 눈빛',
      'The Dragon\'s Rage': '사룡의 마염',
      'Tower': '기둥',
      'Touchdown': '착지',
      'Trinity': '삼위일체',
      'Twisting Dive': '회오리 강하',
      'Ultimate End': '궁극의 종말',
      'Wrath of the Heavens': '지천의 진: 바람창',
      'Wroth Flames': '사념의 불꽃'
    }
  }]
};
/* harmony default export */ const dragonsongs_reprise_ultimate = (dragonsongs_reprise_ultimate_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/ultimate/dragonsongs_reprise_ultimate.txt
const ultimate_dragonsongs_reprise_ultimate_namespaceObject = "### Dragonsong's Reprise Ultimate\r\n# phase 1 logs: -p 62D4:10 62E1:500\r\n# -p 63C8:553 6708:1000 717A:1500 62E1:2000 6B86:3000 6667:3500 71E4:4000\r\n# -ii 6F73 6F74 62D3 63EE 62CE 62CF 63EC 62E3 63DC 63CF 63C9 63E2 6FAF 6FB0 63D0 63E7 63E9 737C 6FEB 63C2 6715 6716 670C 6318 72A2 63CB 62DF 6D22 6D25 6D28 6D2C 6D2E 6D2A 6D32 6D41 6D43 6D44 6D9D 6D96 6D97 6D94 6D95 6DD2 6DD3 68C7\r\n\r\n\r\n# TODO: should we include something for P1 62CE/62CF Shining Blade/Bright Flare stuff?\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n### Phase 1: Adelphel, Grinnaux and Charibert\r\n\r\n# No engage sync, due to checkpoint.\r\n0.0 \"Start\"\r\n6.0 \"--sync--\" StartsUsing { id: \"62D4\", source: \"Ser Adelphel\" } window 10,10\r\n10.0 \"Holiest of Holy\" Ability { id: \"62D4\", source: \"Ser Adelphel\" }\r\n23.2 \"Empty Dimension\" Ability { id: \"62DA\", source: \"Ser Grinnaux\" }\r\n23.2 \"Holy Shield Bash\" Ability { id: \"62D1\", source: \"Ser Adelphel\" }\r\n23.9 \"--sync--\" Ability { id: \"63EB\", source: \"Ser Adelphel\" }\r\n25.3 \"Holy Bladedance\" Ability { id: \"62D2\", source: \"Ser Adelphel\" } duration 2.5\r\n28.2 \"Heavensblaze\" Ability { id: \"62DD\", source: \"Ser Charibert\" }\r\n36.5 \"--middle--\" Ability { id: \"62E9\", source: \"Ser Grinnaux\" }\r\n38.4 \"--untargetable--\"\r\n43.6 \"--sync--\" Ability { id: \"62D6\", source: \"Ser Grinnaux\" }\r\n# These slashes come from Ser Grinnaux, but sometimes name updates are sloppy.\r\n44.8 \"Hyperdimensional Slash 1\" Ability { id: \"62D7\", source: [\"Ser Grinnaux\", \"Ser Charibert\"] }\r\n50.7 \"--sync--\" Ability { id: \"6315\", source: \"Ser Grinnaux\" }\r\n51.9 \"Hyperdimensional Slash 2\" Ability { id: \"62D7\", source: [\"Ser Grinnaux\", \"Ser Charibert\"] }\r\n54.8 \"--targetable--\"\r\n59.8 \"Faith Unmoving\" Ability { id: \"62DC\", source: \"Ser Grinnaux\" }\r\n60.9 \"Holiest of Holy\" Ability { id: \"62D4\", source: \"Ser Adelphel\" }\r\n67.5 \"--untargetable--\"\r\n69.1 \"Execution\" Ability { id: \"62D5\", source: \"Ser Adelphel\" }\r\n70.8 \"--targetable--\"\r\n86.2 \"Faith Unmoving\" Ability { id: \"62DC\", source: \"Ser Grinnaux\" }\r\n88.2 \"Heavensflame\" Ability { id: \"62DE\", source: \"Ser Charibert\" }\r\n102.2 \"Holiest of Holy\" Ability { id: \"62D4\", source: \"Ser Adelphel\" }\r\n104.2 \"Empty Dimension/Full Dimension\" Ability { id: [\"62DA\", \"62DB\"], source: \"Ser Grinnaux\" }\r\n122.2 \"Holiest of Holy\" Ability { id: \"62D4\", source: \"Ser Adelphel\" }\r\n# \"soft\" enrage\r\n127.4 \"The Bull's Steel\" Ability { id: \"62CD\", source: \"Ser Grinnaux\" }\r\n127.4 \"Brightblade's Steel\" Ability { id: \"62CC\", source: \"Ser Adelphel\" }\r\n133.6 \"Faith Unmoving\" Ability { id: \"62DC\", source: \"Ser Grinnaux\" }\r\n133.6 \"Holiest of Holy\" Ability { id: \"62D4\", source: \"Ser Adelphel\" }\r\n# ???\r\n\r\n\r\n### Phase 1.5: Haurchefant v1, a time loop better suits a hero\r\n500.0 \"Planar Prison\" Ability { id: \"62E1\", source: \"Ser Grinnaux\" } window 500,0\r\n500.0 \"Pure of Heart\" StartsUsing { id: \"62E4\", source: \"Ser Charibert\" } duration 36\r\n500.0 \"Brightwinged Flight\" Ability { id: \"6316\", source: \"Ser Adelphel\" }\r\n510.0 \"Spear of the Fury\" Ability { id: \"62E2\", source: \"Ser Zephirin\" }\r\n515.9 \"Brightwing 1\" Ability { id: \"6319\", source: \"Ser Charibert\" }\r\n520.9 \"Brightwing 2\" Ability { id: \"6319\", source: \"Ser Charibert\" }\r\n523.8 \"Skyblind 1\" Ability { id: \"631A\", source: \"Ser Charibert\" }\r\n525.9 \"Brightwing 3\" Ability { id: \"6319\", source: \"Ser Charibert\" }\r\n528.8 \"Skyblind 2\" Ability { id: \"631A\", source: \"Ser Charibert\" }\r\n530.9 \"Brightwing 4\" Ability { id: \"6319\", source: \"Ser Charibert\" }\r\n533.8 \"Skyblind 3\" Ability { id: \"631A\", source: \"Ser Charibert\" }\r\n535.9 \"Pure of Heart\" Ability { id: \"62E4\", source: \"Ser Charibert\" }\r\n537.8 \"--untargetable--\"\r\n538.8 \"Skyblind 4\" Ability { id: \"631A\", source: \"Ser Charibert\" }\r\n# Enrage?? (or just die to Pure of Heart?)\r\n\r\n\r\n### Phase 2: King Thordan\r\n541.5 \"--targetable--\"\r\n550.0 \"--sync--\" StartsUsing { id: \"63C8\", source: \"King Thordan\" } window 600,10\r\n553.0 \"Ascalon's Mercy Concealed\" Ability { id: \"63C8\", source: \"King Thordan\" }\r\n554.6 \"--sync--\" Ability { id: \"63C9\", source: \"King Thordan\" }\r\n556.2 \"Ascalon's Might 1\" #Ability { id: \"63C5\", source: \"King Thordan\" }\r\n557.8 \"Ascalon's Might 2\" #Ability { id: \"63C5\", source: \"King Thordan\" }\r\n559.4 \"Ascalon's Might 3\" #Ability { id: \"63C5\", source: \"King Thordan\" }\r\n562.2 \"--sync--\" Ability { id: \"63C4\", source: \"King Thordan\" }\r\n563.3 \"Knights of the Round\" Ability { id: \"63ED\", source: \"King Thordan\" }\r\n570.4 \"Strength of the Ward\" Ability { id: \"63D3\", source: \"King Thordan\" }\r\n573.5 \"--untargetable--\"\r\n581.3 \"--sync--\" Ability { id: \"63D5\", source: \"Ser Guerrique\" } # self-targeted Heavy Impact\r\n582.7 \"Lightning Storm\" Ability { id: \"63CC\", source: \"King Thordan\" }\r\n583.0 \"Heavy Impact 1\" Ability { id: \"63D6\", source: \"Ser Guerrique\" }\r\n583.0 \"Spiral Thrust\" Ability { id: \"63D4\", source: \"Ser Ignasse\" }\r\n584.9 \"Heavy Impact 2\" Ability { id: \"63D7\", source: \"Ser Guerrique\" }\r\n586.8 \"Heavy Impact 3\" Ability { id: \"63D8\", source: \"Ser Guerrique\" }\r\n588.1 \"Ascalon's Mercy Concealed\" Ability { id: \"63C8\", source: \"King Thordan\" }\r\n588.7 \"Heavy Impact 4\" Ability { id: \"63D9\", source: \"Ser Guerrique\" }\r\n589.7 \"--sync--\" Ability { id: \"63C9\", source: \"King Thordan\" }\r\n590.3 \"--sync--\" Ability { id: \"63C4\", source: \"King Thordan\" }\r\n590.6 \"Heavy Impact 5\" Ability { id: \"63DA\", source: \"Ser Guerrique\" }\r\n598.1 \"Dimensional Collapse\" Ability { id: \"63DB\", source: \"Ser Grinnaux\" }\r\n598.1 \"The Dragon's Rage\" Ability { id: \"63CE\", source: \"King Thordan\" }\r\n599.0 \"Skyward Leap\" #Ability { id: \"63DD\", source: \"Ser Ignasse\" }\r\n599.4 \"Holy Shield Bash\" Ability { id: \"62D1\", source: \"Ser Adelphel\" }\r\n599.9 \"--sync--\" Ability { id: \"63DE\", source: \"Ser Hermenost\" } # Conviction, self-casted\r\n600.1 \"--sync--\" Ability { id: \"63EB\", source: \"Ser Janlenoux\" } # Holy Shield Bash line aoe\r\n601.5 \"Holy Bladedance\" Ability { id: \"62D2\", source: \"Ser Adelphel\" }\r\n602.5 \"--sync--\" Ability { id: \"63C4\", source: \"King Thordan\" }\r\n602.8 \"Conviction\" Ability { id: \"63DF\", source: \"Ser Hermenost\" }\r\n\r\n604.9 \"--targetable--\"\r\n611.0 \"Ancient Quaga\" Ability { id: \"63C6\", source: \"King Thordan\" }\r\n621.2 \"Heavenly Heel\" Ability { id: \"63C7\", source: \"King Thordan\" }\r\n624.4 \"Ascalon's Might 1\" #Ability { id: \"63C5\", source: \"King Thordan\" }\r\n626.0 \"Ascalon's Might 2\" #Ability { id: \"63C5\", source: \"King Thordan\" }\r\n627.7 \"Ascalon's Might 3\" #Ability { id: \"63C5\", source: \"King Thordan\" }\r\n\r\n630.5 \"--sync--\" Ability { id: \"63C4\", source: \"King Thordan\" }\r\n631.6 \"Knights of the Round\" Ability { id: \"63ED\", source: \"King Thordan\" }\r\n638.7 \"Sanctity of the Ward\" Ability { id: \"63E1\", source: \"King Thordan\" }\r\n641.8 \"--untargetable--\"\r\n652.2 \"Sacred Sever 1\" #Ability { id: \"63E3\", source: \"Ser Zephirin\" }\r\n652.4 \"The Dragon's Glory\" Ability { id: \"63D2\", source: \"King Thordan\" }\r\n652.4 \"The Dragon's Gaze\" Ability { id: \"63D1\", source: \"King Thordan\" }\r\n654.0 \"Sacred Sever 2\" #Ability { id: \"63E3\", source: \"Ser Zephirin\" }\r\n655.8 \"Sacred Sever 3\" #Ability { id: \"63E3\", source: \"Ser Zephirin\" }\r\n657.6 \"Sacred Sever 4\" #Ability { id: \"63E3\", source: \"Ser Zephirin\" }\r\n658.5 \"--sync--\" Ability { id: \"63C4\", source: \"King Thordan\" }\r\n669.8 \"Heavens' Stake\" Ability { id: \"6FAE\", source: \"Ser Charibert\" }\r\n669.8 \"Hiemal Storm\" Ability { id: \"63E6\", source: \"Ser Haumeric\" }\r\n671.9 \"Conviction 1\" Ability { id: \"737B\", source: \"Ser Hermenost\" }\r\n674.7 \"--sync--\" Ability { id: \"63E8\", source: \"Ser Noudenet\" }\r\n675.6 \"Holy Comet 1\" #Ability { id: \"63E9\", source: \"Holy Comet\" }\r\n677.0 \"Holy Comet 2\" #Ability { id: \"63E9\", source: \"Holy Comet\" }\r\n678.4 \"Holy Comet 3\" #Ability { id: \"63E9\", source: \"Holy Comet\" }\r\n679.8 \"Holy Comet 4\" #Ability { id: \"63E9\", source: \"Holy Comet\" }\r\n681.2 \"Holy Comet 5\" #Ability { id: \"63E9\", source: \"Holy Comet\" }\r\n682.6 \"Holy Comet 6\" #Ability { id: \"63E9\", source: \"Holy Comet\" }\r\n684.0 \"Holy Comet 7\" #Ability { id: \"63E9\", source: \"Holy Comet\" }\r\n\r\n685.1 \"Faith Unmoving\" Ability { id: \"62DC\", source: \"Ser Grinnaux\" }\r\n685.2 \"Conviction 2\" Ability { id: \"6FEA\", source: \"Ser Hermenost\" }\r\n692.5 \"--targetable--\"\r\n\r\n692.6 \"--sync--\" Ability { id: \"63BC\", source: \"King Thordan\" }\r\n697.7 \"--sync--\" Ability { id: \"63BD\", source: \"King Thordan\" } window 20,20\r\n706.1 \"Ultimate End\" Ability { id: \"63BE\", source: \"King Thordan\" }\r\n\r\n711.8 \"--sync--\" Ability { id: \"63BF\", source: \"King Thordan\" }\r\n718.4 \"Broad Swing 1\" Ability { id: \"63C[01]\", source: \"King Thordan\" }\r\n726.9 \"Broad Swing 2\" Ability { id: \"63C[01]\", source: \"King Thordan\" }\r\n732.0 \"--sync--\" StartsUsing { id: \"63C3\", source: \"King Thordan\" } window 30,10\r\n738.0 \"Aetheric Burst Enrage\" Ability { id: \"63C3\", source: \"King Thordan\" }\r\n\r\n\r\n### Phase 3: Nidhogg\r\n# Tower ability notes:\r\n# 670E = Dark High Jump (circle marker)\r\n# 670F = Dark Spineshatter Dive (upward/forwards arrow)\r\n# 6710 = Dark Elusive Jump (downward/backwards arrow)\r\n# 6711, 6717, 6178, 6719, 671B = Darkdragon Dive (taking a tower, unsure why different)\r\n\r\n# If Aetheric Burst gets interrupted, then we can sync earlier,\r\n# but if you kill it before then, there's less indication of when to sync.\r\n993.1 \"--sync--\" NetworkCancelAbility { id: \"63C3\", source: \"King Thordan\" } window 300,0\r\n1000.0 \"--sync--\" Ability { id: \"6708\", source: \"Nidhogg\" } window 1000,0\r\n1002.3 \"--targetable--\"\r\n1002.3 \"Final Chorus\" Ability { id: \"6709\", source: \"Nidhogg\" }\r\n1020.5 \"Dive from Grace\" Ability { id: \"670D\", source: \"Nidhogg\" }\r\n1030.2 \"Lash and Gnash/Gnash and Lash\" Ability { id: \"671[23]\", source: \"Nidhogg\" }\r\n1030.4 \"Tower 1\" Ability { id: [\"670E\", \"670F\", \"6710\"], source: \"Nidhogg\" }\r\n1030.5 \"Eye of the Tyrant\" Ability { id: \"6714\", source: \"Nidhogg\" }\r\n1036.9 \"Darkdragon Dive\" Ability { id: \"671[1789B]\", source: \"Nidhogg\" }\r\n1040.3 \"Tower 2\" Ability { id: [\"670E\", \"670F\", \"6710\"], source: \"Nidhogg\" }\r\n1044.0 \"Geirskogul\" Ability { id: \"670A\", source: \"Nidhogg\" }\r\n1046.9 \"Darkdragon Dive\" Ability { id: \"671[1789B]\", source: \"Nidhogg\" }\r\n1051.3 \"Tower 3\" Ability { id: [\"670E\", \"670F\", \"6710\"], source: \"Nidhogg\" }\r\n1051.7 \"Lash and Gnash/Gnash and Lash\" Ability { id: \"671[23]\", source: \"Nidhogg\" }\r\n1052.0 \"Eye of the Tyrant\" Ability { id: \"6714\", source: \"Nidhogg\" }\r\n1054.0 \"Geirskogul\" Ability { id: \"670A\", source: \"Nidhogg\" }\r\n1057.9 \"Darkdragon Dive\" Ability { id: \"671[1789B]\", source: \"Nidhogg\" }\r\n1064.9 \"Geirskogul\" Ability { id: \"670A\", source: \"Nidhogg\" }\r\n1069.9 \"Drachenlance\" Ability { id: \"670B\", source: \"Nidhogg\" }\r\n1073.0 \"Tower x4\" # TODO: can this be better timed?\r\n1077.0 \"Darkdragon Dive\" Ability { id: \"671[1789B]\", source: \"Nidhogg\" }\r\n1084.0 \"Soul Tether x2\" Ability { id: \"671C\", source: \"Nidhogg\" }\r\n1084.0 \"Geirskogul\" Ability { id: \"670A\", source: \"Nidhogg\" }\r\n1107.8 \"Drachenlance\" Ability { id: \"670B\", source: \"Nidhogg\" }\r\n1120.9 \"Revenge of the Horde Enrage\" Ability { id: \"7436\", source: \"Nidhogg\" }\r\n\r\n\r\n### Phase 4: The Eyes\r\n1500.0 \"--sync--\" Ability { id: \"717A\", source: \"Right Eye\" } window 500,0\r\n1502.9 \"--targetable--\"\r\n1503.0 \"Soul of Devotion\" Ability { id: \"68C6\", source: \"Ysayle\" }\r\n1503.0 \"Soul of Friendship\" Ability { id: \"68C5\", source: \"Haurchefant\" }\r\n1510.2 \"Resentment\" Ability { id: \"68BA\", source: \"Estinien\" }\r\n1518.6 \"Hatebound\" Ability { id: \"68BE\", source: \"Right Eye\" }\r\n\r\n# These times are very roughly when it has grown enough and you can pop it.\r\n1526.4 \"Flare Nova x2\" #Ability { id: \"68C1\", source: \"The Gilded Price\" }\r\n1532.4 \"Flare Star x4\" #Ability { id: \"68BF\", source: \"The Azure Price\" }\r\n\r\n1544.7 \"--sync--\" Ability { id: \"68C3\", source: \"Right Eye\" }\r\n1545.5 \"Mirage Dive 1\" #Ability { id: \"68C4\", source: \"Nidhogg\" }\r\n1550.6 \"Mirage Dive 2\" #Ability { id: \"68C4\", source: \"Nidhogg\" }\r\n1555.7 \"Mirage Dive 3\" #Ability { id: \"68C4\", source: \"Nidhogg\" }\r\n1560.8 \"Mirage Dive 4\" #Ability { id: \"68C4\", source: \"Nidhogg\" }\r\n1570.6 \"Steep in Rage\" #Ability { id: \"68BD\", source: \"Right Eye\" }\r\n1577.9 \"--untargetable--\"\r\n1590.1 \"Revenge of the Horde Enrage\" Ability { id: \"6722\", source: \"Nidhogg\" }\r\n\r\n\r\n### Phase 4.5: Haurchefant v2\r\n2000.0 \"Planar Prison\" Ability { id: \"62E1\", source: \"Ser Grinnaux\" } window 500,0\r\n2000.0 \"Brightwinged Flight\" Ability { id: \"6316\", source: \"Ser Adelphel\" }\r\n2010.0 \"Spear of the Fury\" Ability { id: \"62E2\", source: \"Ser Zephirin\" }\r\n2015.9 \"Brightwing 1\" Ability { id: \"6319\", source: \"Ser Charibert\" }\r\n2021.0 \"Brightwing 2\" Ability { id: \"6319\", source: \"Ser Charibert\" }\r\n2024.0 \"Skyblind 1\" Ability { id: \"631A\", source: \"Ser Charibert\" }\r\n2026.1 \"Brightwing 3\" Ability { id: \"6319\", source: \"Ser Charibert\" }\r\n2029.0 \"Skyblind 2\" Ability { id: \"631A\", source: \"Ser Charibert\" }\r\n2031.1 \"Brightwing 4\" Ability { id: \"6319\", source: \"Ser Charibert\" }\r\n2034.1 \"Skyblind 3\" Ability { id: \"631A\", source: \"Ser Charibert\" }\r\n2036.3 \"Pure of Heart\" Ability { id: \"62E4\", source: \"Ser Charibert\" }\r\n2038.3 \"--targetable--\"\r\n2039.3 \"Skyblind 4\" Ability { id: \"631A\", source: \"Ser Charibert\" }\r\n2041.0 \"--sync--\" StartsUsing { id: \"69B5\", source: \"Spear of the Fury\" } window 10,10\r\n2052.0 \"Pierce Enrage\" Ability { id: \"69B5\", source: \"Spear of the Fury\" }\r\n\r\n# Ascalon's Mercy Concealed cast from King Thordan if Haurchefant dies and it loops.\r\n2055.9 \"--sync--\" StartsUsing { id: \"63C8\", source: \"King Thordan\" } window 60,200 jump 550\r\n\r\n\r\n\r\n### Phase 5: King Thordan II\r\n2980.8 \"--sync--\" Ability { id: \"6317\", source: \"Haurchefant\" } window 1000,0\r\n2995.9 \"--targetable--\"\r\n2996.0 \"--sync--\" StartsUsing { id: \"6B86\", source: \"King Thordan\" } window 1000,10\r\n3000.0 \"Incarnation\" Ability { id: \"6B86\", source: \"King Thordan\" }\r\n3006.2 \"The Dragon's Eye\" Ability { id: \"6B87\", source: \"King Thordan\" }\r\n3016.7 \"--sync--\" Ability { id: \"63C4\", source: \"King Thordan\" }\r\n\r\n3017.8 \"Knights of the Round\" Ability { id: \"63ED\", source: \"King Thordan\" }\r\n3024.9 \"Wrath of the Heavens\" Ability { id: \"6B89\", source: \"King Thordan\" }\r\n3028.0 \"--untargetable--\"\r\n3034.4 \"Chain Lightning\" Ability { id: \"6B8F\", source: \"Darkscale\" }\r\n3036.8 \"Twisting Dive\" Ability { id: \"6B8B\", source: \"Vedrfolnir\" }\r\n3036.8 \"Skyward Leap\" #Ability { id: \"72A2\", source: \"Ser Paulecrain\" }\r\n3036.8 \"Spiral Pierce\" #Ability { id: \"6B8A\", source: \"Ser Ignasse\" }\r\n3042.2 \"Ascalon's Mercy Revealed\" Ability { id: \"63CA\", source: \"King Thordan\" }\r\n3043.1 \"Liquid Heaven 1\" #Ability { id: \"6B91\", source: \"Vedrfolnir\" }\r\n3044.3 \"Liquid Heaven 2\" #Ability { id: \"6B91\", source: \"Vedrfolnir\" }\r\n3045.5 \"Liquid Heaven 3\" #Ability { id: \"6B91\", source: \"Vedrfolnir\" }\r\n3046.6 \"--sync--\" Ability { id: \"63E4\", source: \"Ser Charibert\" }\r\n3046.7 \"Liquid Heaven 4\" #Ability { id: \"6B91\", source: \"Vedrfolnir\" }\r\n3047.1 \"Altar Flare 1\" #Ability { id: \"63E5\", source: \"Ser Charibert\" }\r\n3047.9 \"Liquid Heaven 5\" #Ability { id: \"6B91\", source: \"Vedrfolnir\" }\r\n3048.7 \"Altar Flare 2\" #Ability { id: \"63E5\", source: \"Ser Charibert\" }\r\n3050.1 \"Cauterize\" Ability { id: \"6B8D\", source: \"Darkscale\" }\r\n3050.2 \"Altar Flare 3\" #Ability { id: \"63E5\", source: \"Ser Charibert\" }\r\n3050.3 \"Empty Dimension\" Ability { id: \"62DA\", source: \"Ser Grinnaux\" }\r\n3051.4 \"--targetable--\"\r\n3051.7 \"Altar Flare 4\" #Ability { id: \"63E5\", source: \"Ser Charibert\" }\r\n\r\n3057.4 \"Ancient Quaga\" Ability { id: \"63C6\", source: \"King Thordan\" }\r\n3067.8 \"Heavenly Heel\" Ability { id: \"63C7\", source: \"King Thordan\" }\r\n3071.0 \"Ascalon's Might 1\" #Ability { id: \"63C5\", source: \"King Thordan\" }\r\n3072.6 \"Ascalon's Might 2\" #Ability { id: \"63C5\", source: \"King Thordan\" }\r\n3074.2 \"Ascalon's Might 3\" #Ability { id: \"63C5\", source: \"King Thordan\" }\r\n\r\n3077.0 \"--sync--\" Ability { id: \"63C4\", source: \"King Thordan\" }\r\n3078.1 \"Knights of the Round\" Ability { id: \"63ED\", source: \"King Thordan\" }\r\n3085.2 \"Death of the Heavens\" Ability { id: \"6B92\", source: \"King Thordan\" }\r\n3088.3 \"--untargetable--\"\r\n3092.2 \"Deathstorm\" Ability { id: \"6B94\", source: \"Darkscale\" }\r\n3100.4 \"Heavy Impact 1\" Ability { id: \"63D6\", source: \"Ser Guerrique\" }\r\n3102.0 \"Lightning Storm\" Ability { id: \"63CC\", source: \"King Thordan\" }\r\n3102.3 \"Twisting Dive\" #Ability { id: \"6B8B\", source: \"Vedrfolnir\" }\r\n3102.3 \"Cauterize\" Ability { id: \"6B8D\", source: \"Darkscale\" }\r\n3102.3 \"Spear of the Fury\" #Ability { id: \"6B93\", source: \"Ser Zephirin\" }\r\n3102.3 \"Heavy Impact 2\" #Ability { id: \"63D7\", source: \"Ser Guerrique\" }\r\n3102.4 \"Lightning Storm\" #Ability { id: \"63CD\", source: \"King Thordan\" }\r\n3104.1 \"Heavy Impact 3\" Ability { id: \"63D8\", source: \"Ser Guerrique\" }\r\n3106.0 \"Heavy Impact 4\" Ability { id: \"63D9\", source: \"Ser Guerrique\" }\r\n3107.9 \"Heavy Impact 5\" Ability { id: \"63DA\", source: \"Ser Guerrique\" }\r\n3115.5 \"Faith Unmoving\" #Ability { id: \"62DC\", source: \"Ser Grinnaux\" }\r\n3115.5 \"The Dragon's Gaze\" #Ability { id: \"63D1\", source: \"King Thordan\" }\r\n3115.5 \"The Dragon's Glory\" #Ability { id: \"63D2\", source: \"King Thordan\" }\r\n3117.4 \"Heavensflame\" Ability { id: \"62DE\", source: \"Ser Charibert\" }\r\n3119.7 \"Holy Meteor\" Ability { id: \"6B97\", source: \"Ser Noudenet\" }\r\n\r\n# Meteors targetable\r\n3120.7 \"--targetable--\"\r\n3135.4 \"Meteor Impact?\" Ability { id: \"6B98\", source: \"Meteor Circle\" }\r\n\r\n# skip to here when meteors are killed\r\n3200.0 \"--targetable--\"\r\n3202.1 \"--sync--\" StartsUsing { id: \"63C6\", source: \"King Thordan\" } window 80,10\r\n3208.1 \"Ancient Quaga\" Ability { id: \"63C6\", source: \"King Thordan\" }\r\n3218.3 \"Heavenly Heel\" Ability { id: \"63C7\", source: \"King Thordan\" }\r\n3221.4 \"Ascalon's Might 1\" #Ability { id: \"63C5\", source: \"King Thordan\" }\r\n3223.0 \"Ascalon's Might 2\" #Ability { id: \"63C5\", source: \"King Thordan\" }\r\n3224.6 \"Ascalon's Might 3\" #Ability { id: \"63C5\", source: \"King Thordan\" }\r\n3229.5 \"--sync--\" StartsUsing { id: \"6B88\", source: \"King Thordan\" }\r\n3235.5 \"Aetheric Burst Enrage\" Ability { id: \"6B88\", source: \"King Thordan\" }\r\n\r\n\r\n# Phase 6: Nidhogg v2\r\n# 6D23 => 6D25 Head Down, Left Wing\r\n# 6D24 => 6D25 Head Up, Left Wing\r\n# 6D26 => 6D28 Head Down, Right Wing\r\n# 6D27 => 6D28 Head Up, Right Wing\r\n# 6D2D => 6D2E Hot Tail\r\n# 6D2B => 6D2C Hot Wing\r\n3500.0 \"--sync--\" Ability { id: \"6667\", source: \"King Thordan\" } window 500,0\r\n3517.3 \"--targetable--\"\r\n3535.0 \"Great Wyrmsbreath\" Ability { id: \"6D35\", source: \"Hraesvelgr\" }\r\n3535.0 \"Dread Wyrmsbreath\" #Ability { id: \"6D33\", source: \"Nidhogg\" }\r\n3535.7 \"Swirling Blizzard\" #Ability { id: \"6D38\", source: \"Hraesvelgr\" }\r\n3535.8 \"Ice Breath\" #Ability { id: \"6D37\", source: \"Hraesvelgr\" }\r\n3535.8 \"Holy Breath\" #Ability { id: \"6D3C\", source: \"Hraesvelgr\" }\r\n3535.8 \"Flame Breath\" #Ability { id: \"6D36\", source: \"Nidhogg\" }\r\n3535.8 \"Staggering Breath\" #Ability { id: \"6D3D\", source: \"Nidhogg\" }\r\n3543.0 \"Mortal Vow\" Ability { id: \"6D30\", source: \"Nidhogg\" }\r\n3554.3 \"Akh Afah\" Ability { id: \"6D42\", source: \"Hraesvelgr\" }\r\n3558.3 \"--untargetable--\"\r\n3559.5 \"--targetable--\"\r\n3567.4 \"Hallowed Wings\" Ability { id: [\"6D23\", \"6D24\", \"6D26\", \"6D27\"], source: \"Hraesvelgr\" }\r\n3568.2 \"Hallowed Plume\" #Ability { id: \"6D29\", source: \"Hraesvelgr\" }\r\n3568.5 \"Cauterize\" Ability { id: \"6D3E\", source: \"Nidhogg\" }\r\n3568.8 \"--untargetable--\"\r\n3571.9 \"--targetable--\"\r\n3577.0 \"Mortal Vow\" Ability { id: \"6D31\", source: \"Nidhogg\" }\r\n3582.4 \"Wroth Flames\" Ability { id: \"6D45\", source: \"Nidhogg\" }\r\n3583.3 \"--untargetable--\"\r\n3584.5 \"--targetable--\"\r\n3593.2 \"Akh Morn 1\" Ability { id: \"6D46\", source: \"Nidhogg\" }\r\n3593.3 \"Cauterize\" Ability { id: \"6D3F\", source: \"Hraesvelgr\" }\r\n3593.8 \"--untargetable--\"\r\n3594.9 \"Akh Morn 2\" #Ability { id: \"6D47\", source: \"Nidhogg\" }\r\n3596.5 \"Akh Morn 3\" #Ability { id: \"6D47\", source: \"Nidhogg\" }\r\n3598.1 \"Akh Morn 4\" #Ability { id: \"6D47\", source: \"Nidhogg\" }\r\n3599.1 \"--targetable--\"\r\n3605.2 \"Hot Tail/Hot Wing\" Ability { id: [\"6D2D\", \"6D2B\"], source: \"Nidhogg\" }\r\n3607.2 \"Spreading Flames\" #Ability { id: \"742B\", source: \"Nidhogg\" }\r\n3607.2 \"Entangled Flames\" #Ability { id: \"742C\", source: \"Nidhogg\" }\r\n3607.2 \"Spreading Flames\" #Ability { id: \"742B\", source: \"Nidhogg\" }\r\n3607.2 \"Entangled Flames\" #Ability { id: \"742C\", source: \"Nidhogg\" }\r\n3611.1 \"Mortal Vow\" Ability { id: \"6D31\", source: \"Nidhogg\" }\r\n3623.4 \"Akh Afah\" Ability { id: \"6D42\", source: \"Hraesvelgr\" }\r\n3635.4 \"Hallowed Wings\" Ability { id: [\"6D23\", \"6D24\", \"6D26\", \"6D27\"], source: \"Hraesvelgr\" }\r\n3635.4 \"Hot Tail/Hot Wing\" #Ability { id: [\"6D2D\", \"6D2B\"], source: \"Nidhogg\" }\r\n3635.5 \"Hallowed Plume\" #Ability { id: \"6D29\", source: \"Hraesvelgr\" }\r\n3645.1 \"Mortal Vow\" Ability { id: \"6D31\", source: \"Nidhogg\" }\r\n3655.1 \"Great Wyrmsbreath\" Ability { id: \"6D35\", source: \"Hraesvelgr\" }\r\n3655.1 \"Dread Wyrmsbreath\" #Ability { id: \"6D33\", source: \"Nidhogg\" }\r\n3655.8 \"Swirling Blizzard\" #Ability { id: \"6D38\", source: \"Hraesvelgr\" }\r\n3655.9 \"Ice Breath\" #Ability { id: \"6D37\", source: \"Hraesvelgr\" }\r\n3655.9 \"Holy Orb\" #Ability { id: \"6D3A\", source: \"Hraesvelgr\" }\r\n3655.9 \"Flame Breath\" #Ability { id: \"6D36\", source: \"Nidhogg\" }\r\n3655.9 \"Dark Orb\" #Ability { id: \"6D39\", source: \"Nidhogg\" }\r\n3661.2 \"--untargetable--\"\r\n3662.4 \"--targetable--\"\r\n3668.4 \"Cauterize\" Ability { id: \"6D3F\", source: \"Hraesvelgr\" }\r\n3668.7 \"--untargetable--\"\r\n3674.5 \"--sync--\" Ability { id: \"6D40\", source: \"Hraesvelgr\" }\r\n3675.4 \"Touchdown\" Ability { id: \"70E7\", source: [\"Hraesvelgr\", \"Nidhogg\"] }\r\n3675.7 \"--targetable--\"\r\n3679.1 \"Mortal Vow\" Ability { id: \"6D31\", source: \"Nidhogg\" }\r\n3701.8 \"Revenge of the Horde (enrage)\" Ability { id: \"6D21\", source: [\"Hraesvelgr\", \"Nidhogg\"] }\r\n\r\n3711.8 \"Resentment?\"\r\n3718.8 \"Shockwave?\" #Ability { id: \"71E4\", source: [\"King Thordan\", \"Nidhogg\"] }\r\n3744.6 \"Alternative End?\" #Ability { id: \"7438\", source: \"Dragon-king Thordan\" }\r\n\r\n\r\n# Phase 6.5: Eyes v2\r\n# Note: Shockwave could come from King Thordan or Nidhogg\r\n3809.5 \"--sync--\" Ability { id: \"717A\", source: \"Right Eye\" } window 200,0\r\n3809.5 \"Resentment\"\r\n3826.5 \"Shockwave?\" #Ability { id: \"71E4\", source: [\"King Thordan\", \"Nidhogg\"] }\r\n3828.3 \"--sync--\" #Ability { id: \"63F3\", source: \"Left Eye\" }\r\n3828.5 \"--sync--\" #Ability { id: \"63F3\", source: \"Right Eye\" }\r\n3842.3 \"Alternative End?\" #Ability { id: \"7438\", source: \"Dragon-king Thordan\" }\r\n\r\n\r\n# Phase 7: Dragon-king Thordan\r\n# Note: Nidhogg seems to get named for the first Chariot\r\n# Note: King Thordan can appear as one of the Exaflare casters in the first set\r\n# Note: Many of these spells are not named in garland db, so here is a name mapping:\r\n# Exaflare's Edge Spells:\r\n#   6D9B = Cast\r\n#   69DC = First Exaflare\r\n#   6D9D = Subsequent Exaflares\r\n# Akh Morn's Edge Spells:\r\n#  69D3 = Cast\r\n#  730C = 3 player tower (First hit)\r\n#  730D = 3 player tower (First hit)\r\n#  730E = 2 player tower (First hit)\r\n#  6D96 = 3 player tower (after first hit)\r\n#  6D97 = 2 player tower (after first hit)\r\n#  6D94 = Cast that checks if player is in towers?\r\n#  6D95 = Last cast in the Akh Morn in the sets in place of 6D94\r\n#  ???? = Raidwide spellid(s) if miss a tower\r\n# Trinity Spells:\r\n#  6D9E = Cast\r\n#  6D9F = Highest Emnity\r\n#  6DA0 = Second Highest Emnity\r\n#  6DA1 = Nearest Player\r\n# Gigaflare Spells:\r\n#  6D99 = Cast\r\n#  6D9A = First Proximity AoE\r\n#  6DD2 = Second Proximity AoE\r\n#  6DD3 = Third Proximity AoE\r\n# 6D91 = Flames of Ascalon (Out/Chariot)\r\n# 6D92 = Ice of Ascalon (In/Dynamo)\r\n4000.0 \"Shockwave\" Ability { id: \"71E4\", source: [\"King Thordan\", \"Nidhogg\"] } window 400,0\r\n4001.8 \"--sync--\" Ability { id: \"63F3\", source: \"Left Eye\" }\r\n4002.0 \"--sync--\" #Ability { id: \"63F3\", source: \"Right Eye\" }\r\n4015.8 \"Alternative End\" Ability { id: \"7438\", source: \"Dragon-king Thordan\" }\r\n4024.8 \"--targetable--\"\r\n4035.1 \"--sync--\" Ability { id: \"6D9B\", source: \"Dragon-king Thordan\" }\r\n4036.0 \"Exaflare's Edge\" duration 9.3 #Ability { id: \"6D9C\", source: \"Dragon-king Thordan\" }\r\n4036.2 \"Ice of Ascalon/Flames of Ascalon\" Ability { id: [\"6D92\", \"6D91\"], source: [\"Nidhogg\", \"Dragon-king Thordan\"] }\r\n4043.2 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4044.3 \"Trinity 1\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4047.3 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4048.4 \"Trinity 2\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4056.3 \"--sync--\" Ability { id: \"6D93\", source: \"Dragon-king Thordan\" }\r\n4057.0 \"Akh Morn's Edge x5\" duration 5.5 #Ability { id: [\"730C\", \"730D\", \"730E\"], source: \"Dragon-king Thordan\" }\r\n4057.1 \"Ice of Ascalon/Flames of Ascalon\" Ability { id: [\"6D92\", \"6D91\"], source: \"Dragon-king Thordan\" }\r\n4067.8 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4068.9 \"Trinity 3\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4071.9 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4073.0 \"Trinity 4\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4082.9 \"--sync--\" Ability { id: \"6D99\", source: \"Dragon-king Thordan\" }\r\n4083.9 \"Gigaflare's Edge x3\" duration 7.9 #Ability { id: \"6D9A\", source: \"Dragon-king Thordan\" }\r\n4084.0 \"Ice of Ascalon/Flames of Ascalon\" Ability { id: [\"6D92\", \"6D91\"], source: \"Dragon-king Thordan\" }\r\n4100.9 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4102.0 \"Trinity 5\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4104.9 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4106.0 \"Trinity 6\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4113.9 \"--sync--\" Ability { id: \"6D9B\", source: \"Dragon-king Thordan\" }\r\n4114.8 \"Exaflare's Edge\" duration 9.3 #Ability { id: \"6D9C\", source: \"Dragon-king Thordan\" }\r\n4115.0 \"Ice of Ascalon/Flames of Ascalon\" Ability { id: [\"6D92\", \"6D91\"], source: \"Dragon-king Thordan\" }\r\n4121.9 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4122.9 \"Trinity 1\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4125.8 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4126.9 \"Trinity 2\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4134.9 \"--sync--\" Ability { id: \"6D93\", source: \"Dragon-king Thordan\" }\r\n4135.6 \"Akh Morn's Edge x6\" duration 6.6 #Ability { id: [\"730C\", \"730D\", \"730E\"], source: \"Dragon-king Thordan\" }\r\n4135.7 \"Ice of Ascalon/Flames of Ascalon\" Ability { id: [\"6D92\", \"6D91\"], source: \"Dragon-king Thordan\" }\r\n4147.5 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4148.6 \"Trinity 3\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4151.6 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4152.7 \"Trinity 4\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4162.6 \"Gigaflare's Edge x3\" Ability { id: \"6D99\", source: \"Dragon-king Thordan\" } duration 7.9\r\n4163.7 \"Ice of Ascalon/Flames of Ascalon\" Ability { id: [\"6D92\", \"6D91\"], source: \"Dragon-king Thordan\" }\r\n4180.8 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4181.9 \"Trinity 5\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4184.9 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4186.0 \"Trinity 6\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4193.9 \"--sync--\" Ability { id: \"6D9B\", source: \"Dragon-king Thordan\" }\r\n4194.8 \"Exaflare's Edge\" duration 9.3 #Ability { id: \"6D9C\", source: \"Dragon-king Thordan\" }\r\n4195.0 \"Ice of Ascalon/Flames of Ascalon\" Ability { id: [\"6D92\", \"6D91\"], source: \"Dragon-king Thordan\" }\r\n4201.9 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4202.9 \"Trinity 1\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4205.8 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4206.9 \"Trinity 2\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4214.8 \"--sync--\" Ability { id: \"6D93\", source: \"Dragon-king Thordan\" }\r\n4215.5 \"Akh Morn's Edge x7\" duration 7.7 #Ability { id: [\"730C\", \"730D\", \"730E\"], source: \"Dragon-king Thordan\" }\r\n4215.6 \"Ice of Ascalon/Flames of Ascalon\" Ability { id: [\"6D92\", \"6D91\"], source: \"Dragon-king Thordan\" }\r\n4228.5 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4229.6 \"Trinity 3\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4232.6 \"--sync--\" Ability { id: \"6D9E\", source: \"Dragon-king Thordan\" }\r\n4233.7 \"Trinity 4\" #Ability { id: [\"6D9F\", \"6DA0\", \"6DA1\"], source: \"Dragon-king Thordan\" }\r\n4245.6 \"--sync--\" Ability { id: \"6E2E\", source: \"Dragon-king Thordan\" }\r\n4246.3 \"Morn Afah's Edge x3\" Ability { id: [\"730F\", \"7310\", \"7311\"], source: \"Dragon-king Thordan\" }\r\n\r\n# This seems to loop indefinitely\r\n# 6E31 will fire if 6E30 does not hit a player\r\n4248.7 \"--sync--\" Ability { id: \"6E2F\", source: \"Dragon-king Thordan\" }\r\n4249.5 \"Morn Afah's Edge x3\" Ability { id: \"6E30\", source: \"Dragon-king Thordan\" }\r\n4251.8 \"--sync--\" Ability { id: \"6E2F\", source: \"Dragon-king Thordan\" } jump 4248.7\r\n4252.6 \"Morn Afah's Edge x3\" #Ability { id: \"6E30\", source: \"Dragon-king Thordan\" }\r\n4255.7 \"Morn Afah's Edge x3\" #Ability { id: \"6E30\", source: \"Dragon-king Thordan\" }\r\n4258.8 \"Morn Afah's Edge x3\" #Ability { id: \"6E30\", source: \"Dragon-king Thordan\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/ultimate/the_omega_protocol.ts






// TODO: Delta green tether break calls
// TODO: Sigma say if you are unmarked / marked with unmarked / double mark pair
// TODO: Sigma can we find towers and tell people where north tower is?
// TODO: Sigma staff/feet call
// TODO: Omega tell people they must be a monitor (alarm) if they are Second in Line + two Quickening Dynamis
// TODO: Adjust Omega dodge locations
// TODO: p6 magic number tank lb / healer lb triggers
const the_omega_protocol_playstationMarkers = (/* unused pure expression or super */ null && (['circle', 'cross', 'triangle', 'square']));
const phaseReset = data => {
  data.monitorPlayers = [];
  data.trioDebuff = {};
};

// Due to changes introduced in patch 5.2, overhead markers now have a random offset
// added to their ID. This offset currently appears to be set per instance, so
// we can determine what it is from the first overhead marker we see.
const the_omega_protocol_headmarkers = {
  // vfx/lockon/eff/lockon5_t0h.avfx
  spread: '0017',
  // vfx/lockon/eff/tank_lockonae_5m_5s_01k1.avfx
  buster: '0157',
  // vfx/lockon/eff/z3oz_firechain_01c.avfx through 04c
  firechainCircle: '01A0',
  firechainTriangle: '01A1',
  firechainSquare: '01A2',
  firechainX: '01A3',
  // vfx/lockon/eff/com_share2i.avfx
  stack: '0064',
  // vfx/lockon/eff/all_at8s_0v.avfx
  meteor: '015A'
};
const the_omega_protocol_playstationHeadmarkerIds = [the_omega_protocol_headmarkers.firechainCircle, the_omega_protocol_headmarkers.firechainTriangle, the_omega_protocol_headmarkers.firechainSquare, the_omega_protocol_headmarkers.firechainX];
const the_omega_protocol_playstationMarkerMap = {
  [the_omega_protocol_headmarkers.firechainCircle]: 'circle',
  [the_omega_protocol_headmarkers.firechainTriangle]: 'triangle',
  [the_omega_protocol_headmarkers.firechainSquare]: 'square',
  [the_omega_protocol_headmarkers.firechainX]: 'cross'
};
const the_omega_protocol_firstMarker = parseInt('0017', 16);
const the_omega_protocol_getHeadmarkerId = (data, matches) => {
  if (data.decOffset === undefined) data.decOffset = parseInt(matches.id, 16) - the_omega_protocol_firstMarker;
  // The leading zeroes are stripped when converting back to string, so we re-add them here.
  // Fortunately, we don't have to worry about whether or not this is robust,
  // since we know all the IDs that will be present in the encounter.
  return (parseInt(matches.id, 16) - data.decOffset).toString(16).toUpperCase().padStart(4, '0');
};
const nearDistantOutputStrings = {
  near: {
    en: 'Near World',
    de: 'Hallo Welt: Nah',
    fr: 'Bonjour le monde : Proche',
    ja: 'ニア',
    cn: '近处世界',
    ko: '헬로 월드: 근거리'
  },
  distant: {
    en: 'Distant World',
    de: 'Hallo Welt: Fern',
    fr: 'Bonjour le monde : Distant',
    ja: 'ファー',
    cn: '远处世界',
    ko: '헬로 월드: 원거리'
  }
};
const staffSwordMidHelper = (isEastWest, posX, posY, output) => {
  if (isEastWest) {
    // East/West Safe
    if (posX < 100 && posY < 100) {
      // NW
      return output.dirWSW();
    } else if (posX < 100 && posY > 100) {
      // SW
      return output.dirWNW();
    } else if (posX > 100 && posY < 100) {
      // NE
      return output.dirESE();
    }
    // SE
    return output.dirENE();
  }

  // North/South Safe
  if (posX < 100 && posY < 100) {
    // NW
    return output.dirNNE();
  } else if (posX < 100 && posY > 100) {
    // SW
    return output.dirSSE();
  } else if (posX > 100 && posY < 100) {
    // NE
    return output.dirNNW();
  }

  // SE
  return output.dirSSW();
};
const the_omega_protocol_triggerSet = {
  id: 'TheOmegaProtocolUltimate',
  zoneId: zone_id/* default.TheOmegaProtocolUltimate */.Z.TheOmegaProtocolUltimate,
  config: [{
    id: 'staffSwordDodge',
    comment: {
      en: '<a href="https://github.com/quisquous/cactbot/releases/tag/v0.28.19" target="_blank">Read Notes</a>',
      de: '<a href="https://github.com/quisquous/cactbot/releases/tag/v0.28.19" target="_blank">Notizen lesen</a>',
      fr: '<a href="https://github.com/quisquous/cactbot/releases/tag/v0.28.19" target="_blank">Notes</a>',
      ja: '<a href="https://github.com/quisquous/cactbot/releases/tag/v0.28.19" target="_blank">ノート参考</a>',
      cn: '<a href="https://github.com/quisquous/cactbot/releases/tag/v0.28.19" target="_blank">阅读笔记</a>',
      ko: '<a href="https://github.com/quisquous/cactbot/releases/tag/v0.28.19" target="_blank">참고</a>'
    },
    name: {
      en: 'Run: Omega Staff Sword Dodge Direction',
      de: 'Renn: Omega Stab Schwert Ausweich-Richtung',
      fr: 'Sprint : Direction d\'esquive de l\'épée Oméga',
      ja: 'オメガの杖の回避方向',
      cn: '欧米茄运动会杖剑躲避方向',
      ko: '코드: 오메가 지팡이 칼 회피 방향'
    },
    type: 'select',
    options: {
      en: {
        'Dodge Far (by Omega-M)': 'far',
        'Dodge Mid (by Omega-F)': 'mid'
      },
      de: {
        'Ausweichen Fern (von Omega-M)': 'far',
        'Ausweichen Mitte (von Omega-F)': 'mid'
      },
      fr: {
        'Esquive au loin (par Oméga-M)': 'far',
        'Esquive au milieu (par Oméga-F)': 'mid'
      },
      cn: {
        '躲远 (by Omega-M)': 'far',
        '躲中 (by Omega-F)': 'mid'
      },
      ko: {
        '멀리 (Omega-M)': 'far',
        '중간 (Omega-F)': 'mid'
      }
    },
    default: 'far'
  }],
  timelineFile: 'the_omega_protocol.txt',
  initData: () => {
    return {
      combatantData: [],
      phase: 'p1',
      inLine: {},
      loopBlasterCount: 0,
      pantoMissileCount: 0,
      solarRayTargets: [],
      synergyMarker: {},
      spotlightStacks: [],
      meteorTargets: [],
      cannonFodder: {},
      smellDefamation: [],
      smellRot: {},
      regression: {},
      bugRot: {},
      latentDefectCount: 0,
      patchVulnCount: 0,
      waveCannonStacks: [],
      monitorPlayers: [],
      deltaTethers: {},
      trioDebuff: {},
      cosmoArrowCount: 0,
      cosmoArrowExaCount: 0,
      waveCannonFlares: []
    };
  },
  timelineTriggers: [{
    id: 'TOP Flash Gale Tank Auto',
    regex: /Flash Gale 1/,
    beforeSeconds: 5.5,
    infoText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Tank Autos',
        de: 'Tank Autos',
        fr: 'Autos sur le tank',
        ja: 'タンクへのオートアタック',
        cn: '坦克平A',
        ko: '탱커 평타'
      }
    }
  }, {
    id: 'TOP Wave Cannon Protean',
    regex: /Wave Cannon 1/,
    beforeSeconds: 6,
    durationSeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Protean',
        de: 'Himmelsrichtungen',
        fr: 'Positions',
        ja: '基本散会',
        cn: '八方分散',
        ko: '기본 산개'
      }
    }
  }],
  triggers: [{
    id: 'TOP Phase Tracker',
    type: 'StartsUsing',
    // 7B40 = Firewall
    // 8014 = Run ****mi* (Sigma Version)
    // 8015 = Run ****mi* (Omega Version)
    netRegex: {
      id: ['7B40', '8014', '8015'],
      capture: true
    },
    run: (data, matches) => {
      phaseReset(data);
      switch (matches.id) {
        case '7B40':
          data.phase = 'p2';
          break;
        case '8014':
          data.phase = 'sigma';
          break;
        case '8015':
          data.phase = 'omega';
          break;
      }
    }
  }, {
    id: 'TOP Phase Ability Tracker',
    type: 'Ability',
    // 7BFD = attack (Omega)
    // 7B13 = self-cast on omega
    // 7B47 = self-cast on omega
    // 7B7C = self-cast on omega
    // 7F72 = Blind Faith (non-enrage)
    netRegex: {
      id: ['7BFD', '7B13', '7B47', '7B7C', '7F72'],
      capture: true
    },
    suppressSeconds: 20,
    // Ignore multiple delta/omega captures
    run: (data, matches) => {
      phaseReset(data);
      switch (matches.id) {
        case '7BFD':
          data.phase = 'p1';
          break;
        case '7B13':
          data.phase = 'p3';
          break;
        case '7B47':
          data.phase = 'p4';
          break;
        case '7B7C':
          data.phase = 'delta';
          break;
        case '7F72':
          data.phase = 'p6';
          break;
      }
    }
  }, {
    id: 'TOP Headmarker Tracker',
    type: 'HeadMarker',
    netRegex: {},
    condition: data => data.decOffset === undefined,
    // Unconditionally set the first headmarker here so that future triggers are conditional.
    run: (data, matches) => the_omega_protocol_getHeadmarkerId(data, matches)
  }, {
    id: 'TOP In Line Debuff Collector',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['BBC', 'BBD', 'BBE', 'D7B']
    },
    run: (data, matches) => {
      const effectToNum = {
        BBC: 1,
        BBD: 2,
        BBE: 3,
        D7B: 4
      };
      const num = effectToNum[matches.effectId];
      if (num === undefined) return;
      data.inLine[matches.target] = num;
    }
  }, {
    id: 'TOP In Line Debuff Cleanup',
    type: 'StartsUsing',
    // 7B03 = Program Loop
    // 7B0B = Pantokrator
    netRegex: {
      id: ['7B03', '7B0B'],
      source: 'Omega',
      capture: false
    },
    // Don't clean up when the buff is lost, as that happens after taking a tower.
    run: data => data.inLine = {}
  }, {
    id: 'TOP In Line Debuff',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['BBC', 'BBD', 'BBE', 'D7B'],
      capture: false
    },
    condition: data => data.phase === 'p1',
    delaySeconds: 0.5,
    durationSeconds: 5,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      const myNum = data.inLine[data.me];
      if (myNum === undefined) return;
      let partner = output.unknown();
      for (const [name, num] of Object.entries(data.inLine)) {
        if (num === myNum && name !== data.me) {
          partner = name;
          break;
        }
      }
      return output.text({
        num: myNum,
        player: data.party.member(partner)
      });
    },
    outputStrings: {
      text: {
        en: '${num} (with ${player})',
        de: '${num} (mit ${player})',
        fr: '${num} (avec ${player})',
        ja: '${num} (${player})',
        cn: '${num} (与${player})',
        ko: '${num} (+ ${player})'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'TOP Program Loop First Debuffs',
    type: 'StartsUsing',
    // 7B07 = Blaster cast (only one cast, but 4 abilities)
    netRegex: {
      id: '7B07',
      source: 'Omega',
      capture: false
    },
    durationSeconds: data => {
      const myNum = data.inLine[data.me];
      if (myNum === 1 || myNum === 3) return 7;
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tower: {
          en: 'Tower 1',
          de: 'Turm 1',
          fr: 'Tour 1',
          ja: '塔1',
          cn: '塔 1',
          ko: '기둥 1'
        },
        tether: {
          en: 'Tether 1',
          de: 'Verbindung 1',
          fr: 'Lien 1',
          ja: '線1',
          cn: '线 1',
          ko: '선 1'
        },
        numNoMechanic: {
          en: '1',
          de: '1',
          fr: '1',
          ja: '1',
          cn: '1',
          ko: '1'
        }
      };
      const myNum = data.inLine[data.me];
      if (myNum === undefined) return;
      if (myNum === 1) return {
        alertText: output.tower()
      };
      if (myNum === 3) return {
        alertText: output.tether()
      };
      return {
        infoText: output.numNoMechanic()
      };
    }
  }, {
    id: 'TOP Program Loop Other Debuffs',
    type: 'Ability',
    netRegex: {
      id: '7B08',
      source: 'Omega',
      capture: false
    },
    preRun: data => data.loopBlasterCount++,
    durationSeconds: data => {
      const mechanicNum = data.loopBlasterCount + 1;
      const myNum = data.inLine[data.me];
      if (myNum === undefined) return;
      if (mechanicNum === myNum || mechanicNum === myNum + 2 || mechanicNum === myNum - 2) return 7;
    },
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tower: {
          en: 'Tower ${num}',
          de: 'Turm ${num}',
          fr: 'Tour ${num}',
          ja: '塔 ${num}',
          cn: '塔 ${num}',
          ko: '기둥 ${num}'
        },
        tether: {
          en: 'Tether ${num}',
          de: 'Verbindung ${num}',
          fr: 'Lien ${num}',
          ja: '線 ${num}',
          cn: '线 ${num}',
          ko: '선 ${num}'
        },
        numNoMechanic: {
          en: '${num}',
          de: '${num}',
          fr: '${num}',
          ja: '${num}',
          cn: '${num}',
          ko: '${num}'
        }
      };
      const mechanicNum = data.loopBlasterCount + 1;
      if (mechanicNum >= 5) return;
      const myNum = data.inLine[data.me];
      if (myNum === undefined) return {
        infoText: output.numNoMechanic({
          num: mechanicNum
        })
      };
      if (myNum === mechanicNum) return {
        alertText: output.tower({
          num: mechanicNum
        })
      };
      if (mechanicNum === myNum + 2 || mechanicNum === myNum - 2) return {
        alertText: output.tether({
          num: mechanicNum
        })
      };
      return {
        infoText: output.numNoMechanic({
          num: mechanicNum
        })
      };
    }
  }, {
    id: 'TOP Pantokrator First Debuffs',
    type: 'StartsUsing',
    // 7B0D = initial Flame Thrower cast, 7E70 = later ones
    netRegex: {
      id: '7B0D',
      source: 'Omega',
      capture: false
    },
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        lineStack: {
          en: '1',
          de: '1',
          fr: '1',
          ja: '1',
          cn: '1',
          ko: '1'
        },
        spread: {
          en: '1 Out (on YOU)',
          de: '1 Raus (auf Dir)',
          fr: '1 Extérieur (sur VOUS)',
          ja: '1 外へ',
          cn: '1 出 (点名)',
          ko: '밖으로 1'
        }
      };
      const myNum = data.inLine[data.me];
      if (myNum === 1) return {
        alertText: output.spread()
      };
      return {
        infoText: output.lineStack()
      };
    }
  }, {
    id: 'TOP Pantokrator Other Debuffs',
    type: 'Ability',
    // 7B0E = Guided Missile Kyrios spread damage
    netRegex: {
      id: '7B0E',
      source: 'Omega',
      capture: false
    },
    preRun: data => data.pantoMissileCount++,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        lineStack: {
          en: '${num}',
          de: '${num}',
          fr: '${num}',
          ja: '${num}',
          cn: '${num}',
          ko: '${num}'
        },
        spread: {
          en: '${num} Out (on YOU)',
          de: '${num} Raus (auf Dir)',
          fr: '${num} Extérieur (sur VOUS)',
          ja: '${num} 外へ',
          cn: '${num} 出 (点名)',
          ko: '밖으로 ${num}'
        }
      };
      const mechanicNum = data.pantoMissileCount + 1;
      if (mechanicNum >= 5) return;
      const myNum = data.inLine[data.me];
      if (myNum === mechanicNum) return {
        alertText: output.spread({
          num: mechanicNum
        })
      };
      return {
        infoText: output.lineStack({
          num: mechanicNum
        })
      };
    }
  }, {
    id: 'TOP Diffuse Wave Cannon Kyrios',
    type: 'HeadMarker',
    netRegex: {},
    // We normally call this stuff out for other roles, but tanks often invuln this.
    condition: data => data.role === 'tank',
    suppressSeconds: 20,
    alertText: (data, matches, output) => {
      const id = the_omega_protocol_getHeadmarkerId(data, matches);
      if (id === the_omega_protocol_headmarkers.spread) return output.tankCleaves();
    },
    outputStrings: {
      tankCleaves: {
        en: 'Tank Cleaves',
        de: 'Tank Cleaves',
        fr: 'Tank Cleaves',
        ja: 'タンク前方攻撃',
        cn: '坦克顺劈',
        ko: '광역 탱버'
      }
    }
  }, {
    id: 'TOP Wave Cannon Kyrios',
    type: 'HeadMarker',
    netRegex: {},
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    infoText: (data, matches, output) => {
      const id = the_omega_protocol_getHeadmarkerId(data, matches);
      if (id === the_omega_protocol_headmarkers.spread) return output.laserOnYou();
    },
    outputStrings: {
      laserOnYou: {
        en: 'Laser on YOU',
        de: 'Laser auf DIR',
        fr: 'Laser sur VOUS',
        ja: '自分のレーザー',
        cn: '激光点名',
        ko: '레이저 대상자'
      }
    }
  }, {
    id: 'TOP Solar Ray You',
    type: 'StartsUsing',
    netRegex: {
      id: ['7E6A', '7E6B'],
      source: 'Omega'
    },
    preRun: (data, matches) => data.solarRayTargets.push(matches.target),
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        tankBusterOnYou: outputs/* default.tankBusterOnYou */.Z.tankBusterOnYou,
        tankBusters: outputs/* default.tankBusters */.Z.tankBusters
      };
      if (matches.target === data.me) return {
        alertText: output.tankBusterOnYou()
      };
      if (data.solarRayTargets.length === 2 && !data.solarRayTargets.includes(data.me)) return {
        infoText: output.tankBusters()
      };
    }
  }, {
    id: 'TOP Mid Remote Glitch',
    type: 'GainsEffect',
    // D63 = Mid Glitch
    // D64 = Remote Glitch
    netRegex: {
      effectId: ['D63', 'D64']
    },
    suppressSeconds: 10,
    run: (data, matches) => data.glitch = matches.effectId === 'D63' ? 'mid' : 'remote'
  }, {
    id: 'TOP Synergy Marker Collect',
    type: 'HeadMarker',
    netRegex: {},
    run: (data, matches) => {
      const id = the_omega_protocol_getHeadmarkerId(data, matches);
      const marker = the_omega_protocol_playstationMarkerMap[id];
      if (marker === undefined) return;
      data.synergyMarker[matches.target] = marker;
    }
  }, {
    id: 'TOP Party Synergy',
    type: 'Ability',
    netRegex: {
      id: '7B3E',
      source: 'Omega',
      capture: false
    },
    // Untargetable 3s after this, things appear ~2 after this, 2.5 for safety.
    delaySeconds: 5.5,
    promise: async data => {
      data.combatantData = [];
      // TODO: filter this by the combatants added right before Party Synergy???
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants'
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      const omegaMNPCId = 15714;
      const omegaFNPCId = 15715;
      let countM = 0;
      let countF = 0;
      let isFIn = false;
      let isMIn = false;
      for (const c of data.combatantData) {
        if (c.BNpcID === omegaMNPCId) {
          countM++;
          if (c.WeaponId === 4) isMIn = true;
        }
        if (c.BNpcID === omegaFNPCId) {
          countF++;
          if (c.WeaponId === 4) isFIn = true;
        }
      }
      if (countM === 0 || countF === 0) {
        console.error(`PartySynergy: missing m/f: ${JSON.stringify(data.combatantData)}`);
        return;
      }
      if (isFIn && isMIn) return output.superliminalStrength();
      if (isFIn && !isMIn) return output.superliminalBladework();
      if (!isFIn && isMIn) return output.blizzardStrength();
      if (!isFIn && !isMIn) return output.blizzardBladework();
    },
    outputStrings: {
      blizzardBladework: {
        en: 'Out Out',
        de: 'Raus Raus',
        fr: 'Extérieur Extérieur',
        ja: '外 外',
        cn: '远离男女',
        ko: '밖 밖'
      },
      superliminalStrength: {
        en: 'In In on M',
        de: 'Rein Rein auf M',
        fr: 'Intérieur Intérieur sur M',
        ja: '内 内(男)',
        cn: '靠近男人',
        ko: '안 안 M'
      },
      superliminalBladework: {
        en: 'Under F',
        de: 'Unter W',
        fr: 'Sous F',
        ja: '女の下',
        cn: '靠近女人',
        ko: 'F 밑'
      },
      blizzardStrength: {
        en: 'M Sides',
        de: 'Seitlich von M',
        fr: 'Côtés de M',
        ja: '男の横',
        cn: '男人两侧',
        ko: 'M 양옆'
      }
    }
  }, {
    id: 'TOP Synergy Marker',
    type: 'GainsEffect',
    // In practice, glitch1 glitch2 marker1 marker2 glitch3 glitch4 etc ordering.
    netRegex: {
      effectId: ['D63', 'D64'],
      capture: false
    },
    delaySeconds: 0.5,
    durationSeconds: 14,
    suppressSeconds: 10,
    infoText: (data, _matches, output) => {
      const glitch = data.glitch ? {
        mid: output.midGlitch(),
        remote: output.remoteGlitch()
      }[data.glitch] : output.unknown();
      const myMarker = data.synergyMarker[data.me];
      // If something has gone awry, at least return something here.
      if (myMarker === undefined) return glitch;
      let partner = output.unknown();
      for (const [name, marker] of Object.entries(data.synergyMarker)) {
        if (marker === myMarker && name !== data.me) {
          partner = name;
          break;
        }
      }
      return {
        circle: output.circle({
          glitch: glitch,
          player: data.party.member(partner)
        }),
        triangle: output.triangle({
          glitch: glitch,
          player: data.party.member(partner)
        }),
        square: output.square({
          glitch: glitch,
          player: data.party.member(partner)
        }),
        cross: output.cross({
          glitch: glitch,
          player: data.party.member(partner)
        })
      }[myMarker];
    },
    outputStrings: {
      midGlitch: {
        en: 'Mid',
        de: 'Mittel',
        fr: 'Milieu',
        ja: 'ミドル',
        cn: '中',
        ko: '가까이'
      },
      remoteGlitch: {
        en: 'Far',
        de: 'Fern',
        fr: 'Loin',
        ja: 'ファー',
        cn: '远',
        ko: '멀리'
      },
      circle: {
        en: '${glitch} Circle (with ${player})',
        de: '${glitch} Kreis (mit ${player})',
        fr: 'Cercle ${glitch} (avec ${player})',
        ja: '${glitch} 円 (${player})',
        cn: '${glitch} 圆圈 (与${player})',
        ko: '${glitch} 동그라미 (+ ${player})'
      },
      triangle: {
        en: '${glitch} Triangle (with ${player})',
        de: '${glitch} Dreieck (mit ${player})',
        fr: 'Triangle ${glitch} (avec ${player})',
        ja: '${glitch} 三角 (${player})',
        cn: '${glitch} 三角 (与${player})',
        ko: '${glitch} 삼각 (+ ${player})'
      },
      square: {
        en: '${glitch} Square (with ${player})',
        de: '${glitch} Viereck (mit ${player})',
        fr: 'Carré ${glitch} (avec ${player})',
        ja: '${glitch} 四角 (${player})',
        cn: '${glitch} 四角 (与${player})',
        ko: '${glitch} 사각 (+ ${player})'
      },
      cross: {
        en: '${glitch} Cross (with ${player})',
        de: '${glitch} Kreuz (mit ${player})',
        fr: 'X ${glitch} (avec ${player})',
        ja: '${glitch} バツ (${player})',
        cn: '${glitch} X (与${player})',
        ko: '${glitch} X (+ ${player})'
      },
      unknown: outputs/* default.unknown */.Z.unknown
    }
  }, {
    id: 'TOP Optical Unit Location',
    type: 'MapEffect',
    netRegex: {
      location: '0[1-8]',
      flags: '00020001'
    },
    // This comes out right with playstation debuffs.
    // Let players resolve Superliminal Steel/etc first.
    delaySeconds: 5,
    durationSeconds: 4,
    suppressSeconds: 99999,
    infoText: (_data, matches, output) => {
      const dir = {
        '01': output.dirN(),
        '02': output.dirNE(),
        '03': output.dirE(),
        '04': output.dirSE(),
        '05': output.dirS(),
        '06': output.dirSW(),
        '07': output.dirW(),
        '08': output.dirNW()
      }[matches.location];
      return output.text({
        dir: dir
      });
    },
    outputStrings: {
      text: {
        en: 'Eye ${dir}',
        de: 'Auge ${dir}',
        fr: 'Œil ${dir}',
        ja: '目 ${dir}',
        cn: '眼 ${dir}',
        ko: '눈 ${dir}'
      },
      dirN: outputs/* default.dirN */.Z.dirN,
      dirNE: outputs/* default.dirNE */.Z.dirNE,
      dirE: outputs/* default.dirE */.Z.dirE,
      dirSE: outputs/* default.dirSE */.Z.dirSE,
      dirS: outputs/* default.dirS */.Z.dirS,
      dirSW: outputs/* default.dirSW */.Z.dirSW,
      dirW: outputs/* default.dirW */.Z.dirW,
      dirNW: outputs/* default.dirNW */.Z.dirNW
    }
  }, {
    id: 'TOP Spotlight',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => the_omega_protocol_getHeadmarkerId(data, matches) === the_omega_protocol_headmarkers.stack,
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        midGlitch: {
          en: 'Mid',
          de: 'Mittel',
          fr: 'Milieu',
          ja: 'ミドル',
          cn: '中',
          ko: '가까이'
        },
        remoteGlitch: {
          en: 'Far',
          de: 'Fern',
          fr: 'Loin',
          ja: 'ファー',
          cn: '远',
          ko: '멀리'
        },
        stacksOn: {
          en: '${glitch} Stacks (${player1}, ${player2})',
          de: '${glitch} Sammeln (${player1}, ${player2})',
          fr: 'Package ${glitch} (${player1}, ${player2})',
          ja: '${glitch} 頭割り (${player1}, ${player2})',
          cn: '${glitch} 分摊 (${player1}, ${player2})',
          ko: '${glitch} 쉐어 (${player1}, ${player2})'
        },
        // TODO: say who your tether partner is to swap??
        // TODO: tell the tether partner they are tethered to a stack?
        stackOnYou: outputs/* default.stackOnYou */.Z.stackOnYou,
        unknown: outputs/* default.unknown */.Z.unknown
      };
      data.spotlightStacks.push(matches.target);
      const [p1, p2] = data.spotlightStacks.sort();
      if (data.spotlightStacks.length !== 2 || p1 === undefined || p2 === undefined) return;
      const glitch = data.glitch ? {
        mid: output.midGlitch(),
        remote: output.remoteGlitch()
      }[data.glitch] : output.unknown();
      const stacksOn = output.stacksOn({
        glitch: glitch,
        player1: data.party.member(p1),
        player2: data.party.member(p2)
      });
      if (!data.spotlightStacks.includes(data.me)) return {
        infoText: stacksOn
      };
      return {
        alertText: output.stackOnYou(),
        infoText: stacksOn
      };
    }
  }, {
    id: 'TOP Optimized Meteor',
    type: 'HeadMarker',
    netRegex: {},
    condition: (data, matches) => the_omega_protocol_getHeadmarkerId(data, matches) === the_omega_protocol_headmarkers.meteor,
    alertText: (data, matches, output) => {
      data.meteorTargets.push(matches.target);
      if (data.me === matches.target) return output.meteorOnYou();
    },
    outputStrings: {
      meteorOnYou: outputs/* default.meteorOnYou */.Z.meteorOnYou
    }
  }, {
    id: 'TOP Beyond Defense',
    type: 'Ability',
    netRegex: {
      id: '7B28'
    },
    response: (data, matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        dontStack: {
          en: 'Don\'t Stack!',
          de: 'Nicht stacken!',
          fr: 'Ne vous packez pas !',
          ja: 'スタックするな！',
          cn: '分散站位！',
          ko: '쉐어 맞지 말것'
        },
        stack: outputs/* default.stackMarker */.Z.stackMarker
      };
      if (matches.target === data.me) return {
        alarmText: output.dontStack()
      };
      // Note: if you are doing uptime meteors then everybody stacks.
      // If you are not, then you'll need to ignore this as needed.
      // Note2: For P5 Delta, all remaining blues will stack for pile pitch
      if (data.deltaTethers[data.me] !== 'green') return {
        infoText: output.stack()
      };
    }
  }, {
    id: 'TOP P2 Cosmo Memory',
    type: 'StartsUsing',
    netRegex: {
      id: '7B22',
      source: 'Omega-M',
      capture: false
    },
    response: responses/* Responses.aoe */.n3.aoe()
  }, {
    id: 'TOP Sniper Cannon Fodder',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D61'
    },
    preRun: (data, matches) => data.cannonFodder[matches.target] = 'spread',
    durationSeconds: 15,
    infoText: (data, matches, output) => {
      if (data.me === matches.target) return output.spread();
    },
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread
    }
  }, {
    id: 'TOP High-Powered Sniper Cannon Fodder Collect',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D62'
    },
    run: (data, matches) => data.cannonFodder[matches.target] = 'stack'
  }, {
    id: 'TOP High-Powered Sniper Cannon Fodder',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D62',
      capture: false
    },
    delaySeconds: 0.5,
    durationSeconds: 15,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        stack: {
          en: 'Stack (w/ ${player1} or ${player2})',
          de: 'Sammeln (mit ${player1} oder ${player2})',
          fr: 'Package (avec ${player1} ou ${player2})',
          ja: 'あたまわり (${player1}, ${player2})',
          cn: '分摊 (与${player1} 或 ${player2})',
          ko: '쉐어 (+ ${player1}, ${player2})'
        },
        unmarkedStack: {
          en: 'Unmarked Stack (w/ ${player1} or ${player2})',
          de: 'Nicht markiertes Sammeln (mit ${player1} oder ${player2})',
          fr: 'Package non-marqué (avec ${player1} ou ${player2})',
          ja: '無職のあたまわり (${player1}, ${player2})',
          cn: '无点名分摊 (与${player1} 或 ${player2})',
          ko: '무징 쉐어 (+ ${player1}, ${player2})'
        },
        sameDebuffPartner: {
          en: '(same debuff as ${player})',
          de: '(selber Debuff wie ${player})',
          fr: '(même debuff que ${player})',
          ja: '(${player}と同じデバフ)',
          cn: '(与${player} 相同 debuff)',
          ko: '(${player}와 같은 디버프)'
        },
        unknown: outputs/* default.unknown */.Z.unknown
      };
      const myBuff = data.cannonFodder[data.me];
      if (myBuff === 'spread') return;
      const oppositeBuff = myBuff === 'stack' ? undefined : 'stack';
      const opposites = [];
      let partner = output.unknown();
      for (const name of data.party?.partyNames ?? []) {
        if (name === data.me) continue;
        if (data.cannonFodder[name] === myBuff) partner = name;
        if (data.cannonFodder[name] === oppositeBuff) opposites.push(name);
      }
      const partnerText = output.sameDebuffPartner({
        player: data.party.member(partner)
      });
      const [p1, p2] = opposites.sort().map(x => data.party.member(x));
      if (myBuff === 'stack') return {
        alertText: output.stack({
          player1: p1,
          player2: p2
        }),
        infoText: partnerText
      };
      return {
        alertText: output.unmarkedStack({
          player1: p1,
          player2: p2
        }),
        infoText: partnerText
      };
    }
  }, {
    id: 'TOP Code Smell Collector',
    type: 'GainsEffect',
    // D6C Synchronization Code Smell (stack)
    // D6D Overflow Code Smell (defamation)
    // D6E Underflow Code Smell (red)
    // D6F Performance Code Smell (blue)
    // D71 Remote Code Smell (far tethers)
    // DAF Local Code Smell (near tethers)
    // DC9 Local Regression (near tethers)
    // DCA Remote Regression (far tethers)
    // DC4 Critical Synchronization Bug (stack)
    // DC5 Critical Overflow Bug (defamation)
    // DC6 Critical Underflow Bug (red)
    // D65 Critical Performance Bug (blue)
    netRegex: {
      effectId: ['D6D', 'D6E', 'D6F']
    },
    run: (data, matches) => {
      const isDefamation = matches.effectId === 'D6D';
      const isRed = matches.effectId === 'D6E';
      const isBlue = matches.effectId === 'D6F';
      if (isDefamation) data.smellDefamation.push(matches.target);else if (isRed) data.smellRot[matches.target] = 'red';else if (isBlue) data.smellRot[matches.target] = 'blue';
    }
  }, {
    id: 'TOP Code Smell Defamation Color',
    type: 'GainsEffect',
    netRegex: {
      effectId: 'D6D',
      capture: false
    },
    delaySeconds: 0.5,
    suppressSeconds: 1,
    infoText: (data, _matches, output) => {
      let rotColor;
      if (data.smellDefamation.length !== 2) {
        console.error(`Defamation: missing person: ${JSON.stringify(data.smellDefamation)}, ${JSON.stringify(data.smellRot)}`);
      }
      for (const target of data.smellDefamation) {
        const color = data.smellRot[target];
        if (color === undefined) {
          console.error(`Defamation: missing color: ${JSON.stringify(data.smellDefamation)}, ${JSON.stringify(data.smellRot)}`);
          continue;
        }
        if (rotColor === undefined) {
          rotColor = color;
          continue;
        }
        if (rotColor !== color) {
          console.error(`Defamation: conflicting color: ${JSON.stringify(data.smellDefamation)}, ${JSON.stringify(data.smellRot)}`);
          rotColor = undefined;
          break;
        }
      }
      data.defamationColor = rotColor;
      if (rotColor === 'red') return output.red();else if (rotColor === 'blue') return output.blue();
      return output.unknown();
    },
    outputStrings: {
      red: {
        en: 'Red is Defamation',
        de: 'Rot hat Ehrenstrafe',
        fr: 'Rouge a Diffamation',
        ja: '赤',
        cn: '红毒大圈',
        ko: '빨강 광역'
      },
      blue: {
        en: 'Blue is Defamation',
        de: 'Blau hat Ehrenstrafe',
        fr: 'Bleu a Diffamation',
        ja: '青',
        cn: '蓝毒大圈',
        ko: '파랑 광역'
      },
      unknown: {
        en: '??? is Defamation',
        de: '??? Ehrenstrafe',
        fr: '??? a Diffamation',
        ja: '???',
        cn: '???大圈',
        ko: '??? 광역'
      }
    }
  }, {
    id: 'TOP Latent Defect Tower',
    type: 'StartsUsing',
    netRegex: {
      id: '7B6F',
      source: 'Omega',
      capture: false
    },
    infoText: (data, _matches, output) => {
      const myColor = data.bugRot[data.me];
      if (myColor === undefined) return;
      if (data.defamationColor === myColor) return output.colorTowerDefamation({
        color: output[myColor]()
      });else if (myColor) return output.colorTower({
        color: output[myColor]()
      });
    },
    outputStrings: {
      colorTower: {
        en: '${color} Tower Stack',
        de: '${color} Turm versammeln',
        fr: 'Package tour ${color}',
        ja: '${color}塔',
        cn: '${color} 塔分摊',
        ko: '${color} 장판 쉐어'
      },
      colorTowerDefamation: {
        en: '${color} Tower Defamation',
        de: '${color} Turm Ehrenstrafe',
        fr: 'Diffamation tour ${color}',
        ja: '${color}塔',
        cn: '${color} 塔大圈',
        ko: '${color} 장판 광역'
      },
      red: {
        en: 'Red',
        de: 'Rot',
        fr: 'Rouge',
        ja: '赤',
        cn: '红',
        ko: '빨강'
      },
      blue: {
        en: 'Blue',
        de: 'Blau',
        fr: 'Bleue',
        ja: '青',
        cn: '蓝',
        ko: '파랑'
      }
    }
  }, {
    id: 'TOP Rot Collect',
    type: 'GainsEffect',
    // D65 Critical Performance Bug (blue)
    // DC6 Critical Underflow Bug (red)
    // Debuffs last 27s
    netRegex: {
      effectId: ['D65', 'DC6']
    },
    condition: (data, matches) => {
      data.bugRot[matches.target] = matches.effectId === 'D65' ? 'blue' : 'red';
      return matches.target === data.me && data.latentDefectCount !== 3;
    }
  }, {
    id: 'TOP Rot Pass/Get',
    type: 'Ability',
    // 7B5F Cascading Latent Defect (Red Tower)
    // 7B60 Latent Performance Defect (Blue Tower)
    // These casts go off 1 second after Latent Defect and go off regardless if someone soaks it
    netRegex: {
      id: ['7B5F', '7B60'],
      source: 'Omega',
      capture: false
    },
    condition: data => data.latentDefectCount < 3,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        passRot: {
          en: 'Pass Rot',
          de: 'Bug weitergeben',
          fr: 'Donnez le debuff',
          ja: '受け渡し',
          cn: '不接毒',
          ko: '디버프 건네기'
        },
        getRot: {
          en: 'Get Rot',
          de: 'Bug nehmen',
          fr: 'Prenez le debuff',
          ja: 'デバフもらう',
          cn: '接毒',
          ko: '디버프 받기'
        }
      };
      if (data.bugRot[data.me]) return {
        infoText: output.passRot()
      };
      return {
        alertText: output.getRot()
      };
    },
    run: data => {
      data.bugRot = {};
      data.latentDefectCount = data.latentDefectCount + 1;
    }
  }, {
    id: 'TOP Latent Defect Tether Towers',
    type: 'GainsEffect',
    // D71 Remote Code Smell (blue)
    // DAF Local Code Smell(red/green)
    // Using Code Smell as the regressions come ~8.75s after Latent Defect
    // Debuffs are 23, 44, 65, and 86s
    // TODO: Possibly include direction?
    netRegex: {
      effectId: ['D71', 'DAF']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 8.75,
    alertText: (data, matches, output) => {
      const regression = matches.effectId === 'DAF' ? 'local' : 'remote';
      const defamation = data.defamationColor;
      if (defamation === undefined) return;
      const defamationTowerColor = defamation === 'red' ? output.red() : output.blue();
      const stackTowerColor = defamation === 'red' ? output.blue() : output.red();
      if (regression === 'remote') return output.farTether({
        color: stackTowerColor
      });
      if (parseFloat(matches.duration) < 80) return output.nearTether({
        color: defamationTowerColor
      });
      return output.finalTowerNear({
        color: stackTowerColor
      });
    },
    outputStrings: {
      farTether: {
        en: 'Stack by ${color} Tower',
        de: 'Beim ${color}en Turm versammeln',
        fr: 'Package sur tour ${color}',
        ja: '${color}の間でペア',
        cn: '在 ${color} 塔分摊',
        ko: '${color} 장판 사이에서 쉐어'
      },
      nearTether: {
        en: 'Outside ${color} Towers',
        de: 'Auserhalb vom ${color}en Turm',
        fr: 'À l\'extérieur de la tour ${color}',
        ja: '${color}の外へ',
        cn: '站 ${color} 塔外',
        ko: '${color} 장판 바깥쪽으로'
      },
      finalTowerNear: {
        en: 'Between ${color} Towers',
        de: 'Zwischen den ${color}en Türmen',
        fr: 'Entre les tours ${color}',
        ja: '${color}の間へ',
        cn: '站 ${color} 塔之间',
        ko: '${color} 장판 사이로'
      },
      red: {
        en: 'Red',
        de: 'Rot',
        fr: 'Rouge(s)',
        ja: '赤',
        cn: '红',
        ko: '빨강'
      },
      blue: {
        en: 'Blue',
        de: 'Blau',
        fr: 'Bleue(s)',
        ja: '青',
        cn: '蓝',
        ko: '파랑'
      }
    }
  }, {
    id: 'TOP P3 Regression Collect',
    type: 'GainsEffect',
    // DC9 Local Regression (red/green)
    // DCA Remote Regression (blue)
    netRegex: {
      effectId: ['DC9', 'DCA']
    },
    run: (data, matches) => {
      data.regression[matches.target] = matches.effectId === 'DC9' ? 'local' : 'remote';
    }
  }, {
    id: 'TOP P3 Second Regression Break Tether',
    type: 'GainsEffect',
    // DC9 Local Regression (red/green)
    // DCA Remote Regression (blue)
    // Debuffs last 10s
    // Ideally first patch that breaks is blue, else this will not work
    // Will call out if has not broken yet and it is safe to break, if by end
    // of delay and first tether has not broken, it will not call
    netRegex: {
      effectId: ['DC9', 'DCA']
    },
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 6,
    alertText: (data, _matches, output) => {
      if (data.patchVulnCount % 2 === 1 && data.regression[data.me] === 'local' || data.patchVulnCount === 7 && data.regression[data.me] === 'remote') return output.breakTether();
    },
    outputStrings: {
      breakTether: {
        en: 'Break Tether',
        de: 'Verbindung brechen',
        fr: 'Cassez le lien',
        ja: '線切る',
        cn: '扯断连线',
        ko: '선 끊기'
      }
    }
  }, {
    id: 'TOP P3 Regression Cleanup',
    type: 'LosesEffect',
    // DC9 Local Regression (red/green)
    // DCA Remote Regression (blue)
    netRegex: {
      effectId: ['DC9', 'DCA']
    },
    run: (data, matches) => delete data.regression[matches.target]
  }, {
    id: 'TOP Regression Break Counter',
    type: 'GainsEffect',
    // DBC Magic Vulnerability Up from Patch, lasts 0.96s
    // TODO: Clean this up for P5 Tethers?
    netRegex: {
      effectId: 'DBC'
    },
    preRun: data => data.patchVulnCount = data.patchVulnCount + 1,
    delaySeconds: (_data, matches) => parseFloat(matches.duration),
    suppressSeconds: 1,
    run: data => {
      // Clear count for later phases
      if (data.patchVulnCount === 8) data.patchVulnCount = 0;
    }
  }, {
    id: 'TOP Rot Spread',
    type: 'GainsEffect',
    // D65 Critical Performance Bug (blue)
    // DC6 Critical Underflow Bug (red)
    // Debuffs last 27s
    netRegex: {
      effectId: ['D65', 'DC6']
    },
    // TODO: should we have a "Watch Rot" call if you don't get it?
    // (with some suppression due to inconsistent rot pickup timings etc)
    condition: conditions/* default.targetIsYou */.Z.targetIsYou(),
    delaySeconds: (_data, matches) => parseFloat(matches.duration) - 3,
    infoText: (_data, _matches, output) => output.spread(),
    run: (data, matches) => delete data.bugRot[matches.target],
    outputStrings: {
      spread: outputs/* default.spread */.Z.spread
    }
  }, {
    id: 'TOP Oversampled Wave Cannon East',
    type: 'StartsUsing',
    netRegex: {
      id: '7B6B',
      source: 'Omega',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'East Monitors',
        de: 'Östliche Bildschirme',
        fr: 'Moniteurs Est',
        ja: '検知左',
        cn: '左 (西) 小电视',
        ko: '오른쪽 모니터'
      }
    }
  }, {
    id: 'TOP Oversampled Wave Cannon West',
    type: 'StartsUsing',
    netRegex: {
      id: '7B6C',
      source: 'Omega',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'West Monitors',
        de: 'Westliche Bildschirme',
        fr: 'Moniteurs Ouest',
        ja: '検知右',
        cn: '右 (东) 小电视',
        ko: '왼쪽 모니터'
      }
    }
  }, {
    id: 'TOP Oversampled Wave Cannon Loading',
    type: 'GainsEffect',
    // D7C = Oversampled Wave Cannon Loading (facing right)
    // D7D = Oversampled Wave Cannon Loading (facing left)
    netRegex: {
      effectId: ['D7C', 'D7D']
    },
    preRun: (data, matches) => data.monitorPlayers.push(matches),
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        // TODO: should we get all of these player's positions,
        // assuming there's a N/S conga line?
        monitorOnYou: {
          en: 'Monitor (w/${player1}, ${player2})',
          de: 'Bildschirm (w/${player1}, ${player2})',
          fr: 'Moniteur (avec ${player1}, ${player2})',
          ja: '検知 (${player1}, ${player2})',
          cn: '小电视点名 (与${player1}, ${player2})',
          ko: '모니터 (+ ${player1}, ${player2})'
        },
        unmarked: {
          en: 'Unmarked',
          de: 'Unmarkiert',
          fr: 'Sans marque',
          ja: '無職',
          cn: '无点名',
          ko: '무징'
        }
      };
      if (data.monitorPlayers.length !== 3) return;
      const players = data.monitorPlayers.map(x => x.target).sort();
      data.monitorPlayers = [];
      if (players.includes(data.me)) {
        const [p1, p2] = players.filter(x => x !== data.me).map(x => data.party.member(x));
        return {
          alertText: output.monitorOnYou({
            player1: p1,
            player2: p2
          })
        };
      }
      return {
        infoText: output.unmarked()
      };
    }
  }, {
    id: 'TOP Wave Cannon Stack Collector',
    type: 'Ability',
    netRegex: {
      id: '5779',
      source: 'Omega'
    },
    // Store full matches here in case somebody has a N/S priority system
    // they want to implement themselves in the stack trigger.
    run: (data, matches) => data.waveCannonStacks.push(matches)
  }, {
    id: 'TOP Wave Cannon Stack',
    type: 'Ability',
    netRegex: {
      id: '5779',
      source: 'Omega',
      capture: false
    },
    delaySeconds: 0.3,
    suppressSeconds: 1,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        stacks: {
          en: 'Stacks (${player1}, ${player2})',
          de: 'Sammeln (${player1}, ${player2})',
          fr: 'Package (${player1}, ${player2})',
          ja: 'あたまわり (${player1}, ${player2})',
          cn: '分摊 (${player1}, ${player2})',
          ko: '쉐어징 (${player1}, ${player2})'
        },
        stackOnYou: {
          en: 'Stack on You (w/${player})',
          de: 'Auf DIR sammeln (w/${player})',
          fr: 'Package sur VOUS (avec ${player})',
          ja: '自分にマーカー (${player})',
          cn: '分摊点名 (与${player})',
          ko: '쉐어징 대상자 (+ ${player})'
        }
      };
      const [m1, m2] = data.waveCannonStacks;
      if (data.waveCannonStacks.length !== 2 || m1 === undefined || m2 === undefined) return;
      const [p1, p2] = [m1.target, m2.target].sort();
      const onYou = p1 === data.me || p2 === data.me;
      if (onYou) {
        const otherPerson = p1 === data.me ? p2 : p1;
        return {
          alertText: output.stackOnYou({
            player: data.party.member(otherPerson)
          })
        };
      }
      return {
        infoText: output.stacks({
          player1: data.party.member(p1),
          player2: data.party.member(p2)
        })
      };
    },
    run: (data, _matches) => data.waveCannonStacks = []
  }, {
    id: 'TOP Delta Tethers',
    type: 'GainsEffect',
    // D70 Local Code Smell (red/green)
    // DB0 Remote Code Smell (blue)
    netRegex: {
      effectId: ['D70', 'DB0']
    },
    preRun: (data, matches) => {
      data.deltaTethers[matches.target] = matches.effectId === 'D70' ? 'green' : 'blue';
    },
    infoText: (data, matches, output) => {
      if (matches.target !== data.me) return;
      if (matches.effectId === 'D70') return output.nearTether();
      return output.farTether();
    },
    outputStrings: {
      farTether: {
        en: 'Blue Tether',
        de: 'Blaue Verbindung',
        fr: 'Lien Bleu',
        ja: '青線',
        cn: '蓝线',
        ko: '파란색 선'
      },
      nearTether: {
        en: 'Green Tether',
        de: 'Grüne Verbindung',
        fr: 'Lien Vert',
        ja: '緑線',
        cn: '绿线',
        ko: '초록색 선'
      }
    }
  }, {
    id: 'TOP Swivel Cannon',
    // 7B95 Swivel Cannon Left-ish
    // 7B94 Swivel Cannon Right-ish
    // 9.7s cast
    type: 'StartsUsing',
    netRegex: {
      id: ['7B94', '7B95'],
      source: 'Omega'
    },
    durationSeconds: (_data, matches) => parseFloat(matches.castTime),
    infoText: (_data, matches, output) => {
      const isLeft = matches.id === '7B95';
      // The eye is always clockwise to the beetle
      return isLeft ? output.awayFromEye() : output.towardsEye();
    },
    outputStrings: {
      awayFromEye: {
        en: 'Away from Eye',
        de: 'Weg vom Auge',
        fr: 'Éloignez-vous de l\'Œil',
        ja: '目から離れる',
        cn: '远离眼睛',
        ko: '눈에서 멀리 떨어지기'
      },
      towardsEye: {
        en: 'Towards Eye',
        de: 'Geh zu dem Auge',
        fr: 'Allez vers l\'Œil',
        ja: '目に近づく',
        cn: '靠近眼睛',
        ko: '눈 쪽으로'
      }
    }
  }, {
    id: 'TOP P5 Trio Debuff Collector',
    type: 'GainsEffect',
    netRegex: {
      effectId: ['D72', 'D73']
    },
    run: (data, matches) => {
      // This is cleaned up on phase change.
      if (matches.effectId === 'D72') data.trioDebuff[matches.target] = 'near';
      if (matches.effectId === 'D73') data.trioDebuff[matches.target] = 'distant';
    }
  }, {
    id: 'TOP P5 Delta Debuffs',
    type: 'Ability',
    // This is on the Oversampled Wave Cannon ability when there is roughly ~13s left on debuffs.
    netRegex: {
      id: '7B6D',
      capture: false
    },
    condition: data => data.phase === 'delta',
    durationSeconds: 8,
    suppressSeconds: 5,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        ...nearDistantOutputStrings,
        unmarkedBlue: {
          // Probably near baits, but you never know.
          en: 'Unmarked Blue',
          de: 'Blau ohne Debuff',
          fr: 'Bleu sans debuff',
          ja: 'デバフなしの青線',
          cn: '无点名蓝',
          ko: '디버프 없는 파란색 선'
        }
      };
      const myDebuff = data.trioDebuff[data.me];
      if (myDebuff === 'near') return {
        alertText: output.near()
      };
      if (myDebuff === 'distant') return {
        alertText: output.distant()
      };
      const myColor = data.deltaTethers[data.me];
      if (myColor === undefined) return;

      // TODO: should we call anything out for greens here??
      if (myColor === 'blue') return {
        infoText: output.unmarkedBlue()
      };
    }
  }, {
    id: 'TOP Sigma Omega-M Location',
    // Same NPC that casts Sigma Version teleports to card/intercard
    type: 'Ability',
    netRegex: {
      id: '8014',
      source: 'Omega-M'
    },
    delaySeconds: 5.4,
    durationSeconds: 26,
    // Display until Discharger
    suppressSeconds: 1,
    promise: async (data, matches) => {
      data.combatantData = [];
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.sourceId, 16)]
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      const m = data.combatantData.pop();
      if (m === undefined) {
        console.error(`Sigma Omega-M Location: missing m: ${JSON.stringify(data.combatantData)}`);
        return;
      }
      // Calculate combatant position in an all 8 cards/intercards
      const matchedPositionTo8Dir = combatant => {
        // Positions are moved up 100 and right 100
        const y = combatant.PosY - 100;
        const x = combatant.PosX - 100;

        // During Sigma, Omega-M teleports to one of the 8 cardinals + numerical
        // slop on a radius=20 circle.
        // N = (100, 80), E = (120, 100), S = (100, 120), W = (80, 100)
        // NE = (114.14, 85.86), SE = (114.14, 114.14), SW = (85.86, 114.14), NW = (85.86, 85.86)
        //
        // Map NW = 0, N = 1, ..., W = 7

        return Math.round(5 - 4 * Math.atan2(x, y) / Math.PI) % 8;
      };
      const dir = matchedPositionTo8Dir(m);
      const dirs = {
        0: output.northwest(),
        1: output.north(),
        2: output.northeast(),
        3: output.east(),
        4: output.southeast(),
        5: output.south(),
        6: output.southwest(),
        7: output.west()
      };
      return output.mLocation({
        dir: dirs[dir] ?? output.unknown()
      });
    },
    outputStrings: {
      north: outputs/* default.north */.Z.north,
      northeast: outputs/* default.northeast */.Z.northeast,
      east: outputs/* default.east */.Z.east,
      southeast: outputs/* default.southeast */.Z.southeast,
      south: outputs/* default.south */.Z.south,
      southwest: outputs/* default.southwest */.Z.southwest,
      west: outputs/* default.west */.Z.west,
      northwest: outputs/* default.northwest */.Z.northwest,
      unknown: outputs/* default.unknown */.Z.unknown,
      mLocation: {
        en: '${dir} M',
        de: '${dir} M',
        fr: '${dir} M',
        ja: '${dir} 男',
        cn: '${dir} 男人',
        ko: '${dir} M'
      }
    }
  }, {
    id: 'TOP P5 Sigma Debuffs',
    type: 'Ability',
    // This is on the Storage Violation damage, with roughly ~24s on debuffs.
    netRegex: {
      id: '7B04',
      capture: false
    },
    condition: data => data.phase === 'sigma',
    durationSeconds: data => data.trioDebuff[data.me] === undefined ? 5 : 16,
    suppressSeconds: 5,
    response: (data, _matches, output) => {
      // cactbot-builtin-response
      output.responseOutputStrings = {
        ...nearDistantOutputStrings,
        noDebuff: {
          en: '(no debuff)',
          de: '(kein Debuff)',
          fr: '(sans debuff)',
          ja: '(デバフなし)',
          cn: '(无 Debuff)',
          ko: '(디버프 없음)'
        }
      };
      const myDebuff = data.trioDebuff[data.me];
      if (myDebuff === 'near') return {
        alertText: output.near()
      };
      if (myDebuff === 'distant') return {
        alertText: output.distant()
      };
      return {
        infoText: output.noDebuff()
      };
    }
  }, {
    id: 'TOP Sigma Superliminal/Blizzard',
    // Omega-M casts Superliminal/Blizzard
    // Track from Discharger (7B2E)
    type: 'Ability',
    netRegex: {
      id: '7B2E',
      source: 'Omega-M'
    },
    // TODO: temporarily disabled as it is returning inconsistent results even with longer delay.
    // See: https://github.com/quisquous/cactbot/issues/5335
    condition: data => data.phase === 'sigma',
    delaySeconds: 8,
    suppressSeconds: 1,
    promise: async (data, matches) => {
      data.combatantData = [];
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [parseInt(matches.sourceId, 16)]
      })).combatants;
    },
    alertText: (data, _matches, output) => {
      const f = data.combatantData.pop();
      if (f === undefined) {
        console.error(`Sigma Superliminal/Blizzard: missing f: ${JSON.stringify(data.combatantData)}`);
        return;
      }
      if (f.WeaponId === 4) return output.superliminalSteel();
      return output.optimizedBlizzard();
    },
    outputStrings: {
      superliminalSteel: {
        en: 'Follow Laser, Move In',
        de: 'Laser folgen, rein gehen',
        fr: 'Suivez le laser, aller dedans',
        ja: 'レーザー方面の中へ',
        cn: '跟随激光，穿进辣翅',
        ko: '레이저 따라서 안으로'
      },
      optimizedBlizzard: {
        en: 'Wait First',
        de: 'Zuerst warten',
        fr: 'Attendez d\'abord',
        ja: 'まってから移動',
        cn: '先等十字',
        ko: '기다렸다가 이동'
      }
    }
  }, {
    id: 'TOP P5 Omega Debuffs',
    // First In Line: ~32s duration, ~12s left after 2nd dodge
    // Second In Line: ~50s duration, ~15s left after final bounce
    type: 'GainsEffect',
    netRegex: {
      effectId: ['D72', 'D73']
    },
    condition: (data, matches) => data.phase === 'omega' && matches.target === data.me,
    delaySeconds: (_data, matches) => parseFloat(matches.duration) > 40 ? 35 : 20,
    durationSeconds: 8,
    alertText: (_data, matches, output) => {
      if (matches.effectId === 'D72') return output.near();
      if (matches.effectId === 'D73') return output.distant();
    },
    outputStrings: nearDistantOutputStrings
  }, {
    id: 'TOP P5 Omega Tether Detector',
    type: 'Tether',
    netRegex: {
      id: '0059',
      capture: false
    },
    condition: data => data.phase === 'omega',
    suppressSeconds: 30,
    run: data => data.seenOmegaTethers = true
  }, {
    id: 'TOP P5 Omega Tether Bait',
    type: 'GainsEffect',
    // Quickening Dynamis
    netRegex: {
      effectId: 'D74',
      count: '03'
    },
    condition: (data, matches) => {
      if (data.phase !== 'omega' || data.seenOmegaTethers) return false;
      return matches.target === data.me;
    },
    durationSeconds: 8,
    alarmText: (_data, _matches, output) => output.baitTethers(),
    outputStrings: {
      baitTethers: {
        en: 'Bait Tethers',
        de: 'Verbindung ködern',
        fr: 'Attirez les liens',
        ja: '線取り',
        cn: '接线',
        ko: '선 가져가기'
      }
    }
  }, {
    id: 'TOP Omega Pre-Safe Spot',
    // The combatants appear around the start of this cast, but the WeaponIds
    // don't switch until ~2.7s after the ability goes off.
    type: 'Ability',
    netRegex: {
      id: '8015',
      source: 'Omega-M',
      capture: false
    },
    delaySeconds: 4,
    durationSeconds: 5.5,
    suppressSeconds: 1,
    promise: async data => {
      data.combatantData = [];
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants'
      })).combatants;
      // Sort highest ID to lowest ID
      const sortCombatants = (a, b) => (b.ID ?? 0) - (a.ID ?? 0);
      data.combatantData = data.combatantData.sort(sortCombatants);
    },
    infoText: (data, _matches, output) => {
      // The higher id is first set
      const omegaMNPCId = 15721;
      const omegaFNPCId = 15722;
      const findOmegaF = combatant => combatant.BNpcID === omegaFNPCId;
      const findOmegaM = combatant => combatant.BNpcID === omegaMNPCId;
      const f = data.combatantData.filter(findOmegaF).shift();
      const m = data.combatantData.filter(findOmegaM).shift();
      if (f === undefined || m === undefined) {
        console.error(`Omega Safe Spots: missing m/f: ${JSON.stringify(data.combatantData)}`);
        return;
      }
      const isFIn = f.WeaponId === 4;
      const isMIn = m.WeaponId === 4;
      if (!isFIn && !isMIn && data.triggerSetConfig.staffSwordDodge === 'mid') {
        const eastWestSwordStaffDir = staffSwordMidHelper(true, f.PosX, f.PosY, output);
        const northSouthSwordStaffDir = staffSwordMidHelper(false, f.PosX, f.PosY, output);
        return output.staffSwordMid({
          northSouth: northSouthSwordStaffDir,
          eastWest: eastWestSwordStaffDir
        });
      }

      // The combatants only spawn in these intercards:
      // 92.93, 92.93 (NW)      107.07, 92.93 (NE)
      // 92.93, 107.07 (SW)     107.07, 107.07 (SE)
      // They will either spawn NW/SE first or NE/SW
      // Boss cleave is unknown at this time, so call both sides
      const pos1 = !isMIn && isFIn ? f.PosY : m.PosY;
      const pos2 = !isMIn && isFIn ? f.PosX : m.PosX;
      const northSouthDir = pos1 < 100 ? output.dirN() : output.dirS();
      const eastWestDir = pos2 < 100 ? output.dirW() : output.dirE();
      if (isFIn) {
        if (isMIn) return output.legsShield({
          northSouth: northSouthDir,
          eastWest: eastWestDir
        });
        return output.legsSword({
          northSouth: northSouthDir,
          eastWest: eastWestDir
        });
      }
      if (isMIn) return output.staffShield({
        northSouth: northSouthDir,
        eastWest: eastWestDir
      });
      return output.staffSwordFar({
        northSouth: northSouthDir,
        eastWest: eastWestDir
      });
    },
    outputStrings: {
      legsSword: {
        en: 'Close ${northSouth} or ${eastWest}',
        de: 'Nahe ${northSouth} oder ${eastWest}',
        fr: 'Proche ${northSouth} ou ${eastWest}',
        ja: '内 ${northSouth}/${eastWest}',
        cn: '靠近 ${northSouth} 或 ${eastWest}',
        ko: '${northSouth}/${eastWest} 가까이'
      },
      legsShield: {
        en: 'Close ${northSouth} or ${eastWest}',
        de: 'Nahe ${northSouth} oder ${eastWest}',
        fr: 'Proche ${northSouth} ou ${eastWest}',
        ja: '内 ${northSouth}/${eastWest}',
        cn: '靠近 ${northSouth} 或 ${eastWest}',
        ko: '${northSouth}/${eastWest} 가까이'
      },
      staffShield: {
        en: 'In ${northSouth} or ${eastWest}',
        de: 'Rein ${northSouth} oder ${eastWest}',
        fr: 'Intérieur ${northSouth} ou ${eastWest}',
        ja: '外 ${northSouth}/${eastWest}',
        cn: '进 ${northSouth} 或 ${eastWest}',
        ko: '${northSouth}/${eastWest} 중간'
      },
      staffSwordFar: {
        en: 'Far ${northSouth} or ${eastWest}',
        de: 'Entfernt von ${northSouth} oder ${eastWest}',
        fr: 'Loin ${northSouth} ou ${eastWest}',
        ja: '遠 ${northSouth}/${eastWest}',
        cn: '远 ${northSouth} 或 ${eastWest}',
        ko: '${northSouth}/${eastWest} 멀리'
      },
      staffSwordMid: {
        en: 'Mid ${northSouth} or ${eastWest}',
        de: 'Mittig ${northSouth} oder ${eastWest}',
        fr: 'Milieu ${northSouth} ou ${eastWest}',
        ja: '外 ${northSouth}/${eastWest}',
        cn: '中 ${northSouth} 或 ${eastWest}',
        ko: '${northSouth}/${eastWest} 중간'
      },
      dirN: outputs/* default.dirN */.Z.dirN,
      dirE: outputs/* default.dirE */.Z.dirE,
      dirS: outputs/* default.dirS */.Z.dirS,
      dirW: outputs/* default.dirW */.Z.dirW,
      dirNNW: outputs/* default.dirNNW */.Z.dirNNW,
      dirNNE: outputs/* default.dirNNE */.Z.dirNNE,
      dirENE: outputs/* default.dirENE */.Z.dirENE,
      dirESE: outputs/* default.dirESE */.Z.dirESE,
      dirSSE: outputs/* default.dirSSE */.Z.dirSSE,
      dirSSW: outputs/* default.dirSSW */.Z.dirSSW,
      dirWSW: outputs/* default.dirWSW */.Z.dirWSW,
      dirWNW: outputs/* default.dirWNW */.Z.dirWNW
    }
  }, {
    id: 'TOP Omega Safe Spots',
    // 7B9B Diffuse Wave Cannon (North/South), is followed up with 7B78
    // 7B9C Diffuse Wave Cannon (East/West), is followed up with 7B77
    type: 'StartsUsing',
    netRegex: {
      id: ['7B9B', '7B9C'],
      source: 'Omega'
    },
    durationSeconds: (_data, matches) => parseFloat(matches.castTime),
    alertText: (data, matches, output) => {
      // The higher id is first set
      const omegaMNPCId = 15721;
      const omegaFNPCId = 15722;
      const findOmegaF = combatant => combatant.BNpcID === omegaFNPCId;
      const findOmegaM = combatant => combatant.BNpcID === omegaMNPCId;
      const [f1, f2] = data.combatantData.filter(findOmegaF);
      const [m1, m2] = data.combatantData.filter(findOmegaM);
      if (f1 === undefined || f2 === undefined || m1 === undefined || m2 === undefined) {
        console.error(`Omega Safe Spots: missing m/f: ${JSON.stringify(data.combatantData)}`);
        return;
      }
      const isF1In = f1.WeaponId === 4;
      const isF2In = f2.WeaponId === 4;
      const isM1In = m1.WeaponId === 4;
      const isM2In = m2.WeaponId === 4;
      const isFirstEastWest = matches.id === '7B9B';
      const isSecondEastWest = !isFirstEastWest;
      let pos1;
      let pos2;
      if (data.triggerSetConfig.staffSwordDodge === 'far') {
        if (isFirstEastWest) {
          // Dodge by Omega-M for everything except sword + legs.
          pos1 = !isM1In && isF1In ? f1.PosX : m1.PosX;
          pos2 = !isM2In && isF2In ? f2.PosY : m2.PosY;
        } else {
          pos1 = !isM1In && isF1In ? f1.PosY : m1.PosY;
          pos2 = !isM2In && isF2In ? f2.PosX : m2.PosX;
        }
      } else {
        if (isFirstEastWest) {
          // Dodge by Omega-F for sword and Omega-M for shield.
          pos1 = !isM1In ? f1.PosX : m1.PosX;
          pos2 = !isM2In ? f2.PosY : m2.PosY;
        } else {
          pos1 = !isM1In ? f1.PosY : m1.PosY;
          pos2 = !isM2In ? f2.PosX : m2.PosX;
        }
      }

      // The combatants only spawn in these intercards:
      // 92.93, 92.93 (NW)      107.07, 92.93 (NE)
      // 92.93, 107.07 (SW)     107.07, 107.07 (SE)
      // They will either spawn NW/SE first or NE/SW
      // Boss cleave tells if it is actually east/west or north/south
      let dir1;
      let dir2;
      let rotate;
      if (isFirstEastWest) {
        dir1 = pos1 < 100 ? output.dirW() : output.dirE();
        dir2 = pos2 < 100 ? output.dirN() : output.dirS();
        const isLeftRotation = pos1 < 100 && pos2 < 100 || pos1 > 100 && pos2 > 100;
        rotate = isLeftRotation ? 'left' : 'right';
      } else {
        dir1 = pos1 < 100 ? output.dirN() : output.dirS();
        dir2 = pos2 < 100 ? output.dirW() : output.dirE();
        const isRightRotation = pos1 < 100 && pos2 < 100 || pos1 > 100 && pos2 > 100;
        rotate = isRightRotation ? 'right' : 'left';
      }
      data.omegaDodgeRotation = rotate;
      let firstSpot;
      if (isF1In) {
        if (isM1In) firstSpot = output.legsShield({
          dir: dir1
        });else firstSpot = output.legsSword({
          dir: dir1
        });
      } else {
        if (isM1In) {
          firstSpot = output.staffShield({
            dir: dir1
          });
        } else if (data.triggerSetConfig.staffSwordDodge === 'far') {
          firstSpot = output.staffSwordFar({
            dir: dir1
          });
        } else {
          const staffMidDir1 = staffSwordMidHelper(isFirstEastWest, f1.PosX, f1.PosY, output);
          firstSpot = output.staffSwordMid({
            dir: staffMidDir1
          });
        }
      }
      let secondSpot;
      if (isF2In) {
        if (isM2In) secondSpot = output.legsShield({
          dir: dir2
        });else secondSpot = output.legsSword({
          dir: dir2
        });
      } else {
        if (isM2In) {
          secondSpot = output.staffShield({
            dir: dir2
          });
        } else if (data.triggerSetConfig.staffSwordDodge === 'far') {
          secondSpot = output.staffSwordFar({
            dir: dir2
          });
        } else {
          const staffMidDir2 = staffSwordMidHelper(isSecondEastWest, f2.PosX, f2.PosY, output);
          secondSpot = output.staffSwordMid({
            dir: staffMidDir2
          });
        }
      }
      const rotateStr = rotate === 'right' ? output.rotateRight() : output.rotateLeft();
      return output.safeSpots({
        first: firstSpot,
        rotate: rotateStr,
        second: secondSpot
      });
    },
    outputStrings: {
      safeSpots: {
        en: '${first} => ${rotate} => ${second}',
        de: '${first} => ${rotate} => ${second}',
        fr: '${first} => ${rotate} => ${second}',
        ja: '${first} => ${rotate} => ${second}',
        cn: '${first} => ${rotate} => ${second}',
        ko: '${first} => ${rotate} => ${second}'
      },
      rotateRight: {
        en: 'Right',
        de: 'Rechts',
        fr: 'Droite',
        ja: '右',
        cn: '右',
        ko: '오른쪽'
      },
      rotateLeft: {
        en: 'Left',
        de: 'Links',
        fr: 'Gauche',
        ja: '左',
        cn: '左',
        ko: '왼쪽'
      },
      // The two legs are split in case somebody wants a "go to M" or "go to F" style call.
      legsSword: {
        en: 'Close ${dir}',
        de: 'Nahe ${dir}',
        fr: 'Proche ${dir}',
        ja: '内 ${dir}',
        cn: '靠近 ${dir}',
        ko: '${dir} 가까이'
      },
      legsShield: {
        en: 'Close ${dir}',
        de: 'Nahe ${dir}',
        fr: 'Proche ${dir}',
        ja: '内 ${dir}',
        cn: '靠近 ${dir}',
        ko: '${dir} 가까이'
      },
      staffShield: {
        en: 'Mid ${dir}',
        de: 'Mittig ${dir}',
        fr: 'Milieu ${dir}',
        ja: '外 ${dir}',
        cn: '中 ${dir}',
        ko: '${dir} 중간'
      },
      staffSwordFar: {
        en: 'Far ${dir}',
        de: 'Entfernt von ${dir}',
        fr: 'Loin ${dir}',
        ja: '遠 ${dir}',
        cn: '远 ${dir}',
        ko: '${dir} 멀리'
      },
      staffSwordMid: {
        en: 'Mid ${dir}',
        de: 'Mittig ${dir}',
        fr: 'Milieu ${dir}',
        ja: '外 ${dir}',
        cn: '中 ${dir}',
        ko: '${dir} 중간'
      },
      dirN: outputs/* default.dirN */.Z.dirN,
      dirE: outputs/* default.dirE */.Z.dirE,
      dirS: outputs/* default.dirS */.Z.dirS,
      dirW: outputs/* default.dirW */.Z.dirW,
      dirNNW: outputs/* default.dirNNW */.Z.dirNNW,
      dirNNE: outputs/* default.dirNNE */.Z.dirNNE,
      dirENE: outputs/* default.dirENE */.Z.dirENE,
      dirESE: outputs/* default.dirESE */.Z.dirESE,
      dirSSE: outputs/* default.dirSSE */.Z.dirSSE,
      dirSSW: outputs/* default.dirSSW */.Z.dirSSW,
      dirWSW: outputs/* default.dirWSW */.Z.dirWSW,
      dirWNW: outputs/* default.dirWNW */.Z.dirWNW
    }
  }, {
    id: 'TOP Omega Safe Spot 2 Reminder',
    // 7B9B Diffuse Wave Cannon (North/South), is followed up with 7B78
    // 7B9C Diffuse Wave Cannon (East/West), is followed up with 7B77
    type: 'StartsUsing',
    netRegex: {
      id: ['7B9B', '7B9C'],
      source: 'Omega'
    },
    delaySeconds: (_data, matches) => parseFloat(matches.castTime),
    alertText: (data, matches, output) => {
      // The lower id is second set
      const omegaMNPCId = 15721;
      const omegaFNPCId = 15722;
      const findOmegaF = combatant => combatant.BNpcID === omegaFNPCId;
      const findOmegaM = combatant => combatant.BNpcID === omegaMNPCId;
      const f = data.combatantData.filter(findOmegaF).pop();
      const m = data.combatantData.filter(findOmegaM).pop();
      if (f === undefined || m === undefined) {
        console.error(`Omega Safe Spot 2 Reminder: missing m/f: ${JSON.stringify(data.combatantData)}`);
        return;
      }
      const isFIn = f.WeaponId === 4;
      const isMIn = m.WeaponId === 4;
      const isFirstEastWest = matches.id === '7B9B';
      const isSecondEastWest = !isFirstEastWest;
      const rotateStr = data.omegaDodgeRotation === 'right' ? output.rotateRight() : output.rotateLeft();
      if (!isFIn && !isMIn && data.triggerSetConfig.staffSwordDodge === 'mid') {
        const staffMidDir1 = staffSwordMidHelper(isSecondEastWest, f.PosX, f.PosY, output);
        return output.staffSwordMid({
          rotate: rotateStr,
          dir: staffMidDir1
        });
      }

      // The combatants only spawn in these intercards:
      // 92.93, 92.93 (NW)      107.07, 92.93 (NE)
      // 92.93, 107.07 (SW)     107.07, 107.07 (SE)
      // They will either spawn NW/SE first or NE/SW
      // Boss cleave tells if it is actually east/west or north/south
      let dir1;
      if (isSecondEastWest) {
        // East or West Safe, look for male side
        // Check for Sword/Shield to know if to go to Male or Female
        const pos = !isMIn && isFIn ? f.PosX : m.PosX;
        dir1 = pos < 100 ? output.dirW() : output.dirE();
      } else {
        // North or South Safe
        const pos = !isMIn && isFIn ? f.PosY : m.PosY;
        dir1 = pos < 100 ? output.dirN() : output.dirS();
      }
      if (isFIn) {
        if (isMIn) return output.legsShield({
          rotate: rotateStr,
          dir: dir1
        });
        return output.legsSword({
          rotate: rotateStr,
          dir: dir1
        });
      }
      if (isMIn) return output.staffShield({
        rotate: rotateStr,
        dir: dir1
      });
      return output.staffSwordFar({
        rotate: rotateStr,
        dir: dir1
      });
    },
    outputStrings: {
      rotateRight: {
        en: 'Right',
        de: 'Rechts',
        fr: 'Droite',
        ja: '右',
        cn: '右',
        ko: '오른쪽'
      },
      rotateLeft: {
        en: 'Left',
        de: 'Links',
        fr: 'Gauche',
        ja: '左',
        cn: '左',
        ko: '왼쪽'
      },
      legsSword: {
        en: '${rotate} => Close ${dir}',
        de: '${rotate} => Nahe ${dir}',
        fr: '${rotate} => Proche ${dir}',
        ja: '${rotate} => 内 ${dir}',
        cn: '${rotate} => 靠近 ${dir}',
        ko: '${rotate} => ${dir} 가까이'
      },
      legsShield: {
        en: '${rotate} => Close ${dir}',
        de: '${rotate} => Nahe ${dir}',
        fr: '${rotate} => Proche ${dir}',
        ja: '${rotate} => 内 ${dir}',
        cn: '${rotate} => 靠近 ${dir}',
        ko: '${rotate} => ${dir} 가까이'
      },
      staffShield: {
        en: '${rotate} => Mid ${dir}',
        de: '${rotate} => Mittig ${dir}',
        fr: '${rotate} => Milieu ${dir}',
        ja: '${rotate} => 外 ${dir}',
        cn: '${rotate} => 中 ${dir}',
        ko: '${rotate} => ${dir} 중간'
      },
      staffSwordFar: {
        en: '${rotate} => Far ${dir}',
        de: '${rotate} => Entfernt ${dir}',
        fr: '${rotate} => Loin ${dir}',
        ja: '${rotate} => 遠 ${dir}',
        cn: '${rotate} => 远 ${dir}',
        ko: '${rotate} => ${dir} 멀리'
      },
      staffSwordMid: {
        en: '${rotate} => Mid ${dir}',
        de: '${rotate} => Mittig ${dir}',
        fr: '${rotate} => Milieu ${dir}',
        ja: '${rotate} => 外 ${dir}',
        cn: '${rotate} => 中 ${dir}',
        ko: '${rotate} => ${dir} 중간'
      },
      dirN: outputs/* default.dirN */.Z.dirN,
      dirE: outputs/* default.dirE */.Z.dirE,
      dirS: outputs/* default.dirS */.Z.dirS,
      dirW: outputs/* default.dirW */.Z.dirW,
      dirNNW: outputs/* default.dirNNW */.Z.dirNNW,
      dirNNE: outputs/* default.dirNNE */.Z.dirNNE,
      dirENE: outputs/* default.dirENE */.Z.dirENE,
      dirESE: outputs/* default.dirESE */.Z.dirESE,
      dirSSE: outputs/* default.dirSSE */.Z.dirSSE,
      dirSSW: outputs/* default.dirSSW */.Z.dirSSW,
      dirWSW: outputs/* default.dirWSW */.Z.dirWSW,
      dirWNW: outputs/* default.dirWNW */.Z.dirWNW
    }
  }, {
    id: 'TOP P6 Cosmo Memory',
    type: 'StartsUsing',
    netRegex: {
      id: '7BA1',
      source: 'Alpha Omega',
      capture: false
    },
    condition: data => data.role === 'tank',
    alarmText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'TANK LB!!',
        de: 'TANK LB!!',
        fr: 'LB TANK !!',
        ja: 'タンクLB!!',
        cn: '坦克LB！！',
        ko: '탱리밋!!'
      }
    }
  }, {
    id: 'TOP Cosmo Arrow In/Out Collect',
    type: 'StartsUsing',
    // Sometimes cast by Omega, sometimes by Alpha Omega
    netRegex: {
      id: '7BA3',
      capture: false
    },
    run: data => {
      // This will overcount but get reset after
      data.cosmoArrowCount = data.cosmoArrowCount + 1;
    }
  }, {
    id: 'TOP Cosmo Arrow In/Out First',
    type: 'StartsUsing',
    // Sometimes cast by Omega, sometimes by Alpha Omega
    netRegex: {
      id: '7BA3',
      capture: false
    },
    delaySeconds: 0.1,
    durationSeconds: 7,
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      data.cosmoArrowExaCount = 1;
      if (data.cosmoArrowCount === 2) {
        data.cosmoArrowIn = true;
        return output.inFirst();
      }
      data.cosmoArrowIn = false;
      return output.outFirst();
    },
    outputStrings: {
      inFirst: {
        en: 'In First',
        de: 'Zuerst rein',
        fr: 'Intérieur en 1er',
        ja: '内側から',
        cn: '先进',
        ko: '안 먼저'
      },
      outFirst: {
        en: 'Out First',
        de: 'Zuerst raus',
        fr: 'Extérieur en 1er',
        ja: '外側から',
        cn: '先出',
        ko: '밖 먼저'
      }
    }
  }, {
    id: 'TOP Cosmo Arrow In/Out Wait',
    type: 'Ability',
    // Sometimes cast by Omega, sometimes by Alpha Omega
    netRegex: {
      id: '7BA3',
      capture: false
    },
    suppressSeconds: 5,
    infoText: (data, _matches, output) => {
      if (data.cosmoArrowIn) return output.inWait2();
      return output.outWait2();
    },
    outputStrings: {
      inWait2: {
        en: 'In => Wait 2',
        de: 'Rein => Warte 2',
        fr: 'Intérieur => Attendez 2',
        ja: '内 => 待機 2',
        cn: '进 => 等 2',
        ko: '안 => 대기 2번'
      },
      outWait2: {
        en: 'Out => Wait 2',
        de: 'Raus => Warte 2',
        fr: 'Extérieur => Attendez 2',
        ja: '外 => 待機 2',
        cn: '出 => 等 2',
        ko: '밖 => 대기 2번'
      }
    }
  }, {
    id: 'TOP Cosmo Arrow Dodges',
    type: 'Ability',
    netRegex: {
      id: '7BA4',
      source: 'Alpha Omega',
      capture: false
    },
    preRun: data => data.cosmoArrowExaCount = data.cosmoArrowExaCount + 1,
    durationSeconds: data => {
      if (data.cosmoArrowExaCount === 3 && data.cosmoArrowIn) return 5;
      return 3;
    },
    suppressSeconds: 1,
    // Only capture 1 in the set of casts
    infoText: (data, _matches, output) => {
      if (data.cosmoArrowIn) {
        switch (data.cosmoArrowExaCount) {
          case 3:
            return output.outWait2();
          case 5:
            return output.SidesIn();
          case 6:
            return output.in();
        }
        // No callout
        return;
      }
      switch (data.cosmoArrowExaCount) {
        case 3:
        case 5:
          return output.in();
        case 4:
          return output.SidesOut();
      }
    },
    run: data => {
      if (data.cosmoArrowExaCount === 7) {
        data.cosmoArrowExaCount = 0;
        data.cosmoArrowCount = 0;
      }
    },
    outputStrings: {
      in: outputs/* default.in */.Z["in"],
      inWait2: {
        en: 'In => Wait 2',
        de: 'Rein => Warte 2',
        fr: 'Intérieur => Attendez 2',
        ja: '内 => 待機 2',
        cn: '进 => 等 2',
        ko: '안 => 대기 2번'
      },
      outWait2: {
        en: 'Out => Wait 2',
        de: 'Raus => Warte 2',
        fr: 'Extérieur => Attendez 2',
        ja: '外 => 待機 2',
        cn: '出 => 等 2',
        ko: '밖 => 대기 2번'
      },
      SidesIn: outputs/* default.moveAway */.Z.moveAway,
      SidesOut: {
        en: 'Sides + Out',
        de: 'Seien + Raus',
        fr: 'Côtés + Extérieur',
        ja: '横 + 外へ',
        cn: '两侧 + 出',
        ko: '옆 + 밖으로'
      }
    }
  }, {
    id: 'TOP Cosmo Dive',
    type: 'StartsUsing',
    netRegex: {
      id: '7BA6',
      source: 'Alpha Omega',
      capture: false
    },
    durationSeconds: 5,
    alertText: (data, _matches, output) => {
      if (data.role === 'tank') return output.cosmoDiveTank();
      return output.cosmoDiveParty();
    },
    outputStrings: {
      // Yes, these are also tankbusters, but mit is so tight in this phase
      // that everybody needs to know that already, and so just call positioning.
      cosmoDiveTank: {
        en: 'Tanks Near (party far)',
        de: 'Tanks nahe (Gruppe entfernt)',
        fr: 'Tanks proche (groupe éloigné)',
        ja: 'タンク内側 (パーティー離れる)',
        cn: '坦克靠近 (人群远离)',
        ko: '탱커 가까이 (본대 멀리)'
      },
      cosmoDiveParty: {
        en: 'Party Far (tanks near)',
        de: 'Gruppe entfernt (Tanks nahe)',
        fr: 'Groupe éloigné (Tanks proche)',
        ja: 'パーティー離れる (タンク内側)',
        cn: '人群远离 (坦克靠近)',
        ko: '본대 멀리 (탱커 가까이)'
      }
    }
  }, {
    id: 'TOP Unlimited Wave Cannon',
    type: 'StartsUsing',
    netRegex: {
      id: '7BAC',
      source: 'Alpha Omega',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Middle',
        de: 'Mitte ködern',
        fr: 'Attirez au milieu',
        ja: '真ん中',
        cn: '中间诱导',
        ko: '중앙에 장판 유도'
      }
    }
  }, {
    id: 'TOP Unlimited Wave Cannon Collect',
    // Invisible NPCs cast Wave Cannon from starting position of the Exaflares
    // Data from ACT can be innacurate, use OverlayPlugin
    // These casts start 1 second after each other
    type: 'StartsUsing',
    netRegex: {
      id: '7BAD',
      source: 'Alpha Omega'
    },
    run: (data, matches) => {
      // Cleanup collector if second set
      if (data.waveCannonFlares.length === 4) data.waveCannonFlares = [];
      data.waveCannonFlares.push(parseInt(matches.sourceId, 16));
    }
  }, {
    id: 'TOP Unlimited Wave Cannon Dodges',
    // As low as 1.2s delay works consistently on low latency, but 1.5s works for more players
    type: 'StartsUsing',
    netRegex: {
      id: '7BAC',
      source: 'Alpha Omega',
      capture: false
    },
    delaySeconds: 1.5,
    durationSeconds: 10.6,
    // Time until 3rd puddle
    promise: async data => {
      if (data.waveCannonFlares.length < 2) {
        console.error(`TOP Unlimited Wave Cannon Dodge: Expected at least 2 casts, Got: ${JSON.stringify(data.waveCannonFlares.length)}`);
      }
      data.combatantData = [];
      data.combatantData = (await (0,overlay_plugin_api/* callOverlayHandler */.ae)({
        call: 'getCombatants',
        ids: [...data.waveCannonFlares]
      })).combatants;
    },
    infoText: (data, _matches, output) => {
      if (data.combatantData.length < 2) {
        console.error(`TOP Unlimited Wave Cannon Dodge: Expected at least 2 Wave Cannons, Got: ${JSON.stringify(data.combatantData)}`);
        return;
      }
      const firstWaveCannon = data.combatantData.filter(combatant => combatant.ID === data.waveCannonFlares[0])[0];
      const secondWaveCannon = data.combatantData.filter(combatant => combatant.ID === data.waveCannonFlares[1])[0];
      if (firstWaveCannon === undefined || secondWaveCannon === undefined) {
        console.error(`TOP Unlimited Wave Cannon Dodge: Failed to retreive combatant Data: ${JSON.stringify(data.combatantData)}`);
        return;
      }

      // Collect Exaflare position
      const first = [firstWaveCannon.PosX - 100, firstWaveCannon.PosY - 100];
      const second = [secondWaveCannon.PosX - 100, secondWaveCannon.PosY - 100];
      if (first[0] === undefined || first[1] === undefined || second[0] === undefined || second[1] === undefined) {
        console.error(`TOP Unlimited Wave Cannon Dodge: missing coordinates`);
        return;
      }

      // Compute atan2 of determinant and dot product to get rotational direction
      // Note: X and Y are flipped due to Y axis being reversed
      const getRotation = (x1, y1, x2, y2) => {
        return Math.atan2(y1 * x2 - x1 * y2, y1 * y2 + x1 * x2);
      };

      // Get rotation of first and second exaflares
      const rotation = getRotation(first[0], first[1], second[0], second[1]);

      // Get location to dodge to by looking at first exaflare position
      // Calculate combatant position in an all 8 cards/intercards
      const matchedPositionTo8Dir = combatant => {
        // Positions are moved up 100 and right 100
        const y = combatant.PosY - 100;
        const x = combatant.PosX - 100;

        // During Unlimited Wave Cannon, 4 Wave Cannons spawn in order around the map
        // N = (100, 76), E = (124, 100), S = (100, 124), W = (76, 100)
        // NE = (116.97, 83.03), SE = (116.97, 116.97), SW = (83.03, 116.97), NW = (83.03, 83.03)
        //
        // Map NW = 0, N = 1, ..., W = 7

        return Math.round(5 - 4 * Math.atan2(x, y) / Math.PI) % 8;
      };
      const dir = matchedPositionTo8Dir(firstWaveCannon);
      const dirs = {
        0: output.northwest(),
        1: output.north(),
        2: output.northeast(),
        3: output.east(),
        4: output.southeast(),
        5: output.south(),
        6: output.southwest(),
        7: output.west()
      };
      const startDir = rotation < 0 ? (dir - 1 + 8) % 8 : (dir + 1) % 8;
      const start = dirs[startDir] ?? output.unknown();
      if (rotation < 0) {
        return output.directions({
          start: start,
          rotation: output.clockwise()
        });
      }
      if (rotation > 0) {
        return output.directions({
          start: start,
          rotation: output.counterclock()
        });
      }
    },
    outputStrings: {
      directions: {
        en: '${start} => ${rotation}',
        de: '${start} => ${rotation}',
        fr: '${start} => ${rotation}',
        ja: '${start} => ${rotation}',
        cn: '${start} => ${rotation}',
        ko: '${start} => ${rotation}'
      },
      north: outputs/* default.north */.Z.north,
      northeast: outputs/* default.northeast */.Z.northeast,
      east: outputs/* default.east */.Z.east,
      southeast: outputs/* default.southeast */.Z.southeast,
      south: outputs/* default.south */.Z.south,
      southwest: outputs/* default.southwest */.Z.southwest,
      west: outputs/* default.west */.Z.west,
      northwest: outputs/* default.northwest */.Z.northwest,
      unknown: outputs/* default.unknown */.Z.unknown,
      clockwise: {
        en: 'Clockwise',
        de: 'Im Uhrzeigersinn',
        fr: 'Horaire',
        ja: '時計回り',
        cn: '顺时针',
        ko: '시계방향'
      },
      counterclock: {
        en: 'Counterclockwise',
        de: 'Gegen den Uhrzeigersinn',
        fr: 'Anti-horaire',
        ja: '反時計回り',
        cn: '逆时针',
        ko: '반시계방향'
      }
    }
  }, {
    id: 'TOP Wave Cannon Wild Charge',
    type: 'StartsUsing',
    netRegex: {
      id: '7BA9',
      source: 'Alpha Omega',
      capture: false
    },
    delaySeconds: 5,
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Line Charge',
        de: 'Linien Ansturm',
        fr: 'Ruée en ligne',
        ja: '直線あたまわり',
        cn: '直线分摊',
        ko: '직선 쉐어'
      }
    }
  }, {
    id: 'TOP Cosmo Meteor',
    type: 'StartsUsing',
    netRegex: {
      id: '7BB0',
      source: 'Alpha Omega',
      capture: false
    },
    alertText: (_data, _matches, output) => output.text(),
    outputStrings: {
      text: {
        en: 'Bait Middle',
        de: 'Mitte ködern',
        fr: 'Attirez au milieu',
        ja: '真ん中',
        cn: '中间诱导',
        ko: '중앙에 장판 유도'
      }
    }
  }],
  timelineReplace: [{
    'locale': 'de',
    'replaceSync': {
      'Alpha Omega': 'Alpha-Omega',
      'Cosmo Meteor': 'Kosmosmeteor',
      '(?<!Alpha )Omega(?!-)': 'Omega',
      'Omega-F': 'Omega-W',
      'Omega-M': 'Omega-M',
      'Optical Unit': 'Optikmodul',
      'Rear Power Unit': 'hinter(?:e|er|es|en) Antriebseinheit',
      'Left Arm Unit': 'link(?:e|er|es|en) Arm',
      'Right Arm Unit': 'recht(?:e|er|es|en) Arm',
      'Rocket Punch': 'Raketenschlag'
    },
    'replaceText': {
      'Archive Peripheral': 'Archiv-Peripherie',
      'Atomic Ray': 'Atomstrahlung',
      'Beyond Defense': 'Schildkombo S',
      'Beyond Strength': 'Schildkombo G',
      'Blaster': 'Blaster',
      'Blind Faith': 'Blindes Vertrauen',
      'Colossal Blow': 'Kolossaler Hieb',
      'Condensed Wave Cannon Kyrios': 'Hochleistungswellenkanone P',
      'Cosmo Arrow': 'Kosmospfeil',
      'Cosmo Dive': 'Kosmossturz',
      'Cosmo Memory': 'Kosmosspeicher',
      'Cosmo Meteor': 'Kosmosmeteor',
      'Critical Error': 'Schwerer Ausnahmefehler',
      'Diffuse Wave Cannon(?! Kyrios)': 'Streuende Wellenkanone',
      'Diffuse Wave Cannon Kyrios': 'Streuende Wellenkanone P',
      'Discharger': 'Entlader',
      'Efficient Bladework': 'Effiziente Klingenführung',
      'Explosion': 'Explosion',
      'Firewall': 'Sicherungssystem',
      'Flame Thrower': 'Flammensturm',
      'Flash Gale': 'Blitzwind',
      'Guided Missile Kyrios': 'Lenkrakete P',
      'Hello, Distant World': 'Hallo, Welt: Fern',
      'Hello, Near World': 'Hallo, Welt: Nah',
      'Hello, World': 'Hallo, Welt!',
      'High-powered Sniper Cannon': 'Wellengeschütz „Pfeil +”',
      'Hyper Pulse': 'Hyper-Impuls',
      'Ion Efflux': 'Ionenstrom',
      'Laser Shower': 'Laserschauer',
      'Latent Defect': 'Latenter Bug',
      'Left Arm Unit': 'link(?:e|er|es|en) Arm',
      'Limitless Synergy': 'Synergieprogramm LB',
      'Magic Number': 'Magische Zahl',
      'Optical Laser': 'Optischer Laser F',
      'Optimized Bladedance': 'Omega-Schwertertanz',
      'Optimized Blizzard III': 'Omega-Eisga',
      'Optimized Fire III': 'Omega-Feuga',
      'Optimized Meteor': 'Omega-Meteor',
      'Optimized Passage of Arms': 'Optimierter Waffengang',
      'Optimized Sagittarius Arrow': 'Omega-Choral der Pfeile',
      'Oversampled Wave Cannon': 'Fokussierte Wellenkanone',
      'Pantokrator': 'Pantokrator',
      'Party Synergy': 'Synergieprogramm PT',
      'Patch': 'Regression',
      'Peripheral Synthesis': 'Ausdruck',
      'Pile Pitch': 'Neigungsstoß',
      'Program Loop': 'Programmschleife',
      'Rear Lasers': 'Hintere Laser',
      'Right Arm Unit': 'recht(?:e|er|es|en) Arm',
      'Run: \\*\\*\\*\\*mi\\* \\(Delta Version\\)': 'Ausführen: XXXXmiX (Delta)',
      'Run: \\*\\*\\*\\*mi\\* \\(Omega Version\\)': 'Ausführen: XXXXmiX (Omega)',
      'Run: \\*\\*\\*\\*mi\\* \\(Sigma Version\\)': 'Ausführen: XXXXmiX (Sigma)',
      '(?<! )Sniper Cannon': 'Wellengeschütz „Pfeil”',
      'Solar Ray': 'Sonnenstrahl',
      'Spotlight': 'Scheinwerfer',
      'Storage Violation': 'Speicherverletzung S',
      'Subject Simulation F': 'Transformation W',
      'Superliminal Steel': 'Klingenkombo B',
      'Swivel Cannon': 'Rotierende Wellenkanone',
      'Synthetic Shield': 'Synthetischer Schild',
      // This is currently a mistranslated in German as 'Effiziente Klingenführung'
      'Unlimited Wave Cannon': 'Wellenkanone: Grenzwertüberschreitung',
      '(?<! )Wave Cannon(?! Kyrios)': 'Wellenkanone',
      '(?<! )Wave Cannon Kyrios': 'Wellenkanone P',
      'Wave Repeater': 'Schnellfeuer-Wellenkanone'
    }
  }, {
    'locale': 'fr',
    'replaceSync': {
      'Alpha Omega': 'Alpha-Oméga',
      'Cosmo Meteor': 'Cosmométéore',
      '(?<!Alpha )Omega(?!-)': 'Oméga',
      'Omega-F': 'Oméga-F',
      'Omega-M': 'Oméga-M',
      'Optical Unit': 'unité optique',
      'Rear Power Unit': 'unité arrière',
      'Left Arm Unit': 'unité bras gauche',
      'Right Arm Unit': 'unité bras droit',
      'Rocket Punch': 'Astéropoing'
    },
    'replaceText': {
      'Archive Peripheral': 'Périphérique d\'archivage',
      'Atomic Ray': 'Rayon atomique',
      'Beyond Defense': 'Combo bouclier S',
      'Beyond Strength': 'Combo bouclier G',
      'Blaster': 'Électrochoc',
      'Blind Faith': 'Confiance aveugle',
      'Colossal Blow': 'Coup colossal',
      'Condensed Wave Cannon Kyrios': 'Canon plasma surchargé P',
      'Cosmo Arrow': 'Cosmoflèche',
      'Cosmo Dive': 'Cosmoplongeon',
      'Cosmo Memory': 'Cosmomémoire',
      'Cosmo Meteor': 'Cosmométéore',
      'Critical Error': 'Erreur critique',
      'Diffuse Wave Cannon(?! Kyrios)': 'Canon plasma diffuseur',
      'Diffuse Wave Cannon Kyrios': 'Canon plasma diffuseur P',
      'Discharger': 'Déchargeur',
      'Efficient Bladework': 'Lame active',
      'Explosion': 'Explosion',
      'Firewall': 'Programme protecteur',
      'Flame Thrower': 'Crache-flammes',
      'Flash Gale': 'Vent subit',
      'Guided Missile Kyrios': 'Missile guidé P',
      'Hello, Distant World': 'Bonjour, le monde : distance',
      'Hello, Near World': 'Bonjour, le monde : proximité',
      'Hello, World': 'Bonjour, le monde',
      'High-powered Sniper Cannon': 'Canon plasma longue portée surchargé',
      'Hyper Pulse': 'Hyperpulsion',
      'Ion Efflux': 'Fuite d\'ions',
      'Laser Shower': 'Pluie de lasers',
      'Latent Defect': 'Bogue latent',
      'Left Arm Unit': 'unité bras gauche',
      'Limitless Synergy': 'Programme synergique LB',
      'Magic Number': 'Nombre magique',
      'Optical Laser': 'Laser optique F',
      'Optimized Bladedance': 'Danse de la lame Oméga',
      'Optimized Blizzard III': 'Méga Glace Oméga',
      'Optimized Fire III': 'Méga Feu Oméga',
      'Optimized Meteor': 'Météore Oméga',
      'Optimized Passage of Arms': 'Passe d\'armes Oméga',
      'Optimized Sagittarius Arrow': 'Flèche du sagittaire Oméga',
      'Oversampled Wave Cannon': 'Canon plasma chercheur',
      'Pantokrator': 'Pantokrator',
      'Party Synergy': 'Programme synergique PT',
      'Patch': 'Bogue intentionnel',
      'Peripheral Synthesis': 'Impression',
      'Pile Pitch': 'Lancement de pieu',
      'Program Loop': 'Boucle de programme',
      'Rear Lasers': 'Lasers arrière',
      'Right Arm Unit': 'unité bras droit',
      'Run: \\*\\*\\*\\*mi\\* \\(Delta Version\\)': 'Exécution : ****mi* Delta',
      'Run: \\*\\*\\*\\*mi\\* \\(Omega Version\\)': 'Exécution : ****mi* Oméga',
      'Run: \\*\\*\\*\\*mi\\* \\(Sigma Version\\)': 'Exécution : ****mi* Sigma',
      '(?<! )Sniper Cannon': 'Canon plasma longue portée',
      'Solar Ray': 'Rayon solaire',
      'Spotlight': 'Phare',
      'Storage Violation': 'Corruption de données S',
      'Subject Simulation F': 'Transformation F',
      'Superliminal Steel': 'Combo lame B',
      'Swivel Cannon': 'Canon plasma rotatif',
      'Synthetic Shield': 'Bouclier optionnel',
      'Unlimited Wave Cannon': 'Canon plasma : Dépassement de limites',
      '(?<! )Wave Cannon(?! Kyrios)': 'Canon plasma',
      '(?<! )Wave Cannon Kyrios': 'Canon plasma P',
      'Wave Repeater': 'Canon plasma automatique'
    }
  }, {
    'locale': 'ja',
    'replaceSync': {
      'Alpha Omega': 'アルファオメガ',
      'Cosmo Meteor': 'コスモメテオ',
      '(?<!Alpha )Omega(?!-)': 'オメガ',
      'Omega-F': 'オメガF',
      'Omega-M': 'オメガM',
      'Optical Unit': 'オプチカルユニット',
      'Rear Power Unit': 'リアユニット',
      'Left Arm Unit': 'レフトアームユニット',
      'Right Arm Unit': 'ライトアームユニット',
      'Rocket Punch': 'ロケットパンチ'
    },
    'replaceText': {
      'Archive Peripheral': 'アーカイブアーム',
      'Atomic Ray': 'アトミックレイ',
      'Beyond Defense': 'シールドコンボS',
      'Beyond Strength': 'シールドコンボG',
      'Blaster': 'ブラスター',
      'Blind Faith': 'ブラインド・フェイス',
      'Colossal Blow': 'コロッサスブロー',
      'Condensed Wave Cannon Kyrios': '高出力波動砲P',
      'Cosmo Arrow': 'コスモアロー',
      'Cosmo Dive': 'コスモダイブ',
      'Cosmo Memory': 'コスモメモリー',
      'Cosmo Meteor': 'コスモメテオ',
      'Critical Error': 'クリティカルエラー',
      'Diffuse Wave Cannon(?! Kyrios)': '拡散波動砲',
      'Diffuse Wave Cannon Kyrios': '拡散波動砲P',
      'Discharger': 'ディスチャージャー',
      'Efficient Bladework': 'ソードアクション',
      'Explosion': '爆発',
      'Firewall': 'ガードプログラム',
      'Flame Thrower': '火炎放射',
      'Flash Gale': 'フラッシュウィンド',
      'Guided Missile Kyrios': '誘導ミサイルP',
      'Hello, Distant World': 'ハロー・ワールド：ファー',
      'Hello, Near World': 'ハロー・ワールド：ニア',
      'Hello, World': 'ハロー・ワールド',
      'High-powered Sniper Cannon': '狙撃式高出力波動砲',
      'Hyper Pulse': 'ハイパーパルス',
      'Ion Efflux': 'イオンエフラクス',
      'Laser Shower': 'レーザーシャワー',
      'Latent Defect': 'レイテントバグ',
      'Left Arm Unit': 'レフトアームユニット',
      'Limitless Synergy': '連携プログラムLB',
      'Magic Number': 'マジックナンバー',
      'Optical Laser': 'オプチカルレーザーF',
      'Optimized Bladedance': 'ブレードダンス・オメガ',
      'Optimized Blizzard III': 'ブリザガ・オメガ',
      'Optimized Fire III': 'ファイラ・オメガ',
      'Optimized Meteor': 'メテオ・オメガ',
      'Optimized Passage of Arms': 'パッセージ・オブ・オメガ',
      'Optimized Sagittarius Arrow': 'サジタリウスアロー・オメガ',
      'Oversampled Wave Cannon': '検知式波動砲',
      'Pantokrator': 'パントクラトル',
      'Party Synergy': '連携プログラムPT',
      'Patch': 'エンバグ',
      'Peripheral Synthesis': 'プリントアウト',
      'Pile Pitch': 'パイルピッチ',
      'Program Loop': 'サークルプログラム',
      'Rear Lasers': 'リアレーザー',
      'Right Arm Unit': 'ライトアームユニット',
      'Run: \\*\\*\\*\\*mi\\* \\(Delta Version\\)': 'コード：＊＊＊ミ＊【デルタ】',
      'Run: \\*\\*\\*\\*mi\\* \\(Omega Version\\)': 'コード：＊＊＊ミ＊【オメガ】',
      'Run: \\*\\*\\*\\*mi\\* \\(Sigma Version\\)': 'コード：＊＊＊ミ＊【シグマ】',
      '(?<! )Sniper Cannon': '狙撃式波動砲',
      'Solar Ray': 'ソーラレイ',
      'Spotlight': 'スポットライト',
      'Storage Violation': '記憶汚染除去S',
      'Subject Simulation F': 'トランスフォームF',
      'Superliminal Steel': 'ブレードコンボB',
      'Swivel Cannon': '旋回式波動砲',
      'Synthetic Shield': 'シールドオプション',
      'Unlimited Wave Cannon': '波動砲：リミッターカット',
      '(?<! )Wave Cannon(?! Kyrios)': '波動砲',
      '(?<! )Wave Cannon Kyrios': '波動砲P',
      'Wave Repeater': '速射式波動砲'
    }
  }, {
    'locale': 'cn',
    'replaceSync': {
      'Alpha Omega': '阿尔法欧米茄',
      'Cosmo Meteor': '宇宙流星',
      '(?<!Alpha )Omega(?!-)': '欧米茄',
      'Omega-F': '欧米茄F',
      'Omega-M': '欧米茄M',
      'Optical Unit': '视觉组',
      'Rear Power Unit': '尾部组',
      'Left Arm Unit': '左臂组',
      'Right Arm Unit': '右臂组',
      'Rocket Punch': '火箭飞拳'
    },
    'replaceText': {
      'Archive Peripheral': '手臂归档',
      'Atomic Ray': '原子射线',
      'Beyond Defense': '盾连击S',
      'Beyond Strength': '盾连击G',
      'Blaster': '冲击波',
      'Blind Faith': '盲信',
      'Colossal Blow': '巨能爆散',
      'Condensed Wave Cannon Kyrios': '大功率波动炮P',
      'Cosmo Arrow': '宇宙天箭',
      'Cosmo Dive': '宇宙龙炎',
      'Cosmo Memory': '宇宙记忆',
      'Cosmo Meteor': '宇宙流星',
      'Critical Error': '严重错误',
      'Diffuse Wave Cannon(?! Kyrios)': '扩散波动炮',
      'Diffuse Wave Cannon Kyrios': '扩散波动炮P',
      'Discharger': '能量放出',
      'Efficient Bladework': '剑击',
      'Explosion': '爆炸',
      'Firewall': '防御程序',
      'Flame Thrower': '火炎放射',
      'Flash Gale': '闪光风',
      'Guided Missile Kyrios': '跟踪导弹P',
      'Hello, Distant World': '你好，远处世界',
      'Hello, Near World': '你好，近处世界',
      'Hello, World': '你好，世界',
      'High-powered Sniper Cannon': '狙击式大功率波动炮”',
      'Hyper Pulse': '超能脉冲',
      'Ion Efflux': '离子流出',
      'Laser Shower': '激光骤雨',
      'Latent Defect': '潜在错误',
      'Left Arm Unit': '左臂组',
      'Limitless Synergy': '协作程序LB',
      'Magic Number': '魔数',
      'Optical Laser': '光学射线F',
      'Optimized Bladedance': '欧米茄刀光剑舞',
      'Optimized Blizzard III': '欧米茄冰封',
      'Optimized Fire III': '欧米茄烈炎',
      'Optimized Meteor': '欧米茄陨石流星',
      'Optimized Passage of Arms': '欧米茄武装戍卫',
      'Optimized Sagittarius Arrow': '欧米茄射手天箭',
      'Oversampled Wave Cannon': '探测式波动炮',
      'Pantokrator': '全能之主',
      'Party Synergy': '协作程序PT',
      'Patch': '补丁',
      'Peripheral Synthesis': '生成外设',
      'Pile Pitch': '能量投射',
      'Program Loop': '循环程序',
      'Rear Lasers': '背环激光',
      'Right Arm Unit': '右臂组',
      'Run: \\*\\*\\*\\*mi\\* \\(Delta Version\\)': '代码：＊能＊（德尔塔）',
      'Run: \\*\\*\\*\\*mi\\* \\(Omega Version\\)': '代码：＊能＊（欧米茄）',
      'Run: \\*\\*\\*\\*mi\\* \\(Sigma Version\\)': '代码：＊能＊（西格玛）',
      '(?<! )Sniper Cannon': '狙击式波动炮”',
      'Solar Ray': '太阳射线',
      'Spotlight': '聚光灯',
      'Storage Violation': '清除记忆污染S',
      'Subject Simulation F': '变形F',
      'Superliminal Steel': '剑连击B',
      'Swivel Cannon': '回旋式波动炮',
      'Synthetic Shield': '合成盾',
      'Unlimited Wave Cannon': '波动炮：限制解除',
      '(?<! )Wave Cannon(?! Kyrios)': '波动炮',
      '(?<! )Wave Cannon Kyrios': '波动炮P',
      'Wave Repeater': '速射式波动炮'
    }
  }, {
    'locale': 'ko',
    'replaceSync': {
      'Alpha Omega': '알파 오메가',
      'Cosmo Meteor': '세계의 메테오',
      '(?<!Alpha )Omega(?!-)': '오메가',
      'Omega-F': '오메가 F',
      'Omega-M': '오메가 M',
      'Optical Unit': '광학 유닛',
      'Rear Power Unit': '후면 유닛',
      'Left Arm Unit': '왼팔 유닛',
      'Right Arm Unit': '오른팔 유닛',
      'Rocket Punch': '로켓 주먹'
    },
    'replaceText': {
      '\\(stacks\\)': '(쉐어)',
      '\\(Wild Charge\\)': '(쉐어)',
      'Baits': '유도',
      'Far': '멀리',
      'Near(?! World)': '가까이',
      'Flare': '플레어',
      'Puddle': '장판',
      'Stack(?!s)': '쉐어',
      'Archive Peripheral': '기록 보존 장치',
      'Atomic Ray': '원자 파동',
      'Beyond Defense': '방패 연격 S',
      'Beyond Strength': '방패 연격 G',
      'Blaster': '블래스터',
      'Blind Faith': '맹목적인 믿음',
      'Blue Screen': '블루 스크린',
      'Colossal Blow': '광역 폭파',
      'Condensed Wave Cannon Kyrios': '고출력 파동포 P',
      'Cosmo Arrow': '세계의 화살',
      'Cosmo Dive': '세계의 강하',
      'Cosmo Memory': '세계의 기억',
      'Cosmo Meteor': '세계의 메테오',
      'Critical Error': '치명적인 오류',
      'Diffuse Wave Cannon(?! Kyrios)': '확산 파동포',
      'Diffuse Wave Cannon Kyrios': '확산 파동포 P',
      'Discharger': '방출',
      'Efficient Bladework': '검격',
      'Explosion': '폭발',
      'Firewall': '방어 프로그램',
      'Flame Thrower': '화염방사',
      'Flash Gale': '순간 강풍',
      'Guided Missile Kyrios': '유도 미사일 P',
      'Hello, Distant World': '헬로 월드: 원거리',
      'Hello, Near World': '헬로 월드: 근거리',
      'Hello, World': '헬로 월드',
      'High-powered Sniper Cannon': '저격식 고출력 파동포',
      'Hyper Pulse': '초파동 광선',
      'Ion Efflux': '이온 유출',
      'Laser Shower': '레이저 세례',
      'Latent Defect': '잠재적 오류',
      'Left Arm Unit': '왼팔 유닛',
      'Limitless Synergy': '연계 프로그램[리미트]',
      'Magic Number': '매직 넘버',
      'Optical Laser': '광학 레이저 F',
      'Optimized Bladedance': '쾌검난무: 오메가',
      'Optimized Blizzard III': '블리자가: 오메가',
      'Optimized Fire III': '파이라: 오메가',
      'Optimized Meteor': '메테오: 오메가',
      'Optimized Passage of Arms': '오메가의 결의',
      'Optimized Sagittarius Arrow': '궁수자리 화살: 오메가',
      'Oversampled Wave Cannon': '감지식 파동포',
      'Pantokrator': '전지전능',
      'Party Synergy': '연계 프로그램[파티]',
      'Patch': '연쇄 오류',
      'Peripheral Synthesis': '출력',
      'Pile Pitch': '에너지 투사',
      'Program Loop': '순환 프로그램',
      'Rear Lasers': '후면 레이저',
      'Right Arm Unit': '오른팔 유닛',
      'Run: \\*\\*\\*\\*mi\\*(?! \\()': '코드: ＊＊미＊',
      'Run: \\*\\*\\*\\*mi\\* \\(Delta Version\\)': '코드: ＊＊미＊[델타]',
      'Run: \\*\\*\\*\\*mi\\* \\(Omega Version\\)': '코드: ＊＊미＊[오메가]',
      'Run: \\*\\*\\*\\*mi\\* \\(Sigma Version\\)': '코드: ＊＊미＊[시그마]',
      '(?<! )Sniper Cannon': '저격식 파동포',
      'Solar Ray': '태양 광선',
      'Spotlight': '집중 조명',
      'Storage Violation': '기억 오염 제거 S',
      'Subject Simulation F': '형태 변경 F',
      'Superliminal Steel': '칼날 연격 B',
      'Swivel Cannon': '선회식 파동포',
      'Synthetic Shield': '방패 장착',
      'Unlimited Wave Cannon': '파동포: 리미터 해제',
      '(?<! )Wave Cannon(?! Kyrios)': '파동포',
      '(?<! )Wave Cannon Kyrios': '파동포 P',
      'Wave Repeater': '속사식 파동포'
    }
  }]
};
/* harmony default export */ const the_omega_protocol = (the_omega_protocol_triggerSet);
;// CONCATENATED MODULE: ./ui/raidboss/data/06-ew/ultimate/the_omega_protocol.txt
const ultimate_the_omega_protocol_namespaceObject = "### The Omega Protocol\r\n# -p 7B03:15 7B40:206.4 7B13:400 7B47:600 7B7C:700 7F72:1100\r\n# -ii 7BFD 7B0A 7E70 7B0C 7B41 7E6B 7B3F 7BFE 7BFF 7B14 7B15 7B16 7B17 7B1C 7B1D 7B1E 7B2B 7B2C 7B39 7B20 7F75 7B36 7B37 7B35 7B43 7B28 7B32 7B23 7B24 7B49 7B4C 7C00  7B5F 7B60 7B5A 7B5B 7B6D 7B56 7B57 7AFB 7EF9 7C01 7B8B 7BAE 7E51 7B7D 7B7E 7B80 7B90 7B74 7C02 7B79 7E76 7B99\r\n# -it \"Omega\" \"Omega-M\" \"Omega-F\"\r\n\r\nhideall \"--Reset--\"\r\nhideall \"--sync--\"\r\n\r\n0.0 \"--Reset--\" ActorControl { command: \"4000000F\" } window 0,100000 jump 0\r\n\r\n### P1: Beetle\r\n0.0 \"--sync--\" InCombat { inGameCombat: \"1\" } window 0,1\r\n\r\n11.0 \"--sync--\" StartsUsing { id: \"7B03\", source: \"Omega\" } window 20,20\r\n15.0 \"Program Loop\" Ability { id: \"7B03\", source: \"Omega\" }\r\n21.0 \"--sync--\" StartsUsing { id: \"7B07\", source: \"Omega\" }\r\n29.0 \"--sync--\" Ability { id: \"7B07\", source: \"Omega\" }\r\n29.1 \"Storage Violation 1\" Ability { id: \"7B04\", source: \"Omega\" }\r\n29.1 \"Blaster 1\" Ability { id: \"7B08\", source: \"Omega\" }\r\n38.1 \"Storage Violation 2\" Ability { id: \"7B04\", source: \"Omega\" }\r\n38.1 \"Blaster 2\" Ability { id: \"7B08\", source: \"Omega\" }\r\n47.1 \"Storage Violation 3\" Ability { id: \"7B04\", source: \"Omega\" }\r\n47.1 \"Blaster 3\" Ability { id: \"7B08\", source: \"Omega\" }\r\n56.1 \"Storage Violation 4\" Ability { id: \"7B04\", source: \"Omega\" }\r\n56.1 \"Blaster 4\" Ability { id: \"7B09\", source: \"Omega\" }\r\n\r\n64.2 \"--sync--\" StartsUsing { id: \"7B0B\", source: \"Omega\" } window 20,20\r\n69.2 \"Pantokrator\" Ability { id: \"7B0B\", source: \"Omega\" }\r\n75.3 \"Flame Thrower\" Ability { id: \"7B0D\", source: \"Omega\" } duration 25.6\r\n81.3 \"Condensed Wave Cannon Kyrios 1\" Ability { id: \"7B0F\", source: \"Omega\" }\r\n81.3 \"Guided Missile Kyrios 1\" Ability { id: \"7B0E\", source: \"Omega\" }\r\n87.3 \"Condensed Wave Cannon Kyrios 2\" Ability { id: \"7B0F\", source: \"Omega\" }\r\n87.3 \"Guided Missile Kyrios 2\" Ability { id: \"7B0E\", source: \"Omega\" }\r\n93.3 \"Condensed Wave Cannon Kyrios 3\" Ability { id: \"7B0F\", source: \"Omega\" }\r\n93.3 \"Guided Missile Kyrios 3\" Ability { id: \"7B0E\", source: \"Omega\" }\r\n99.3 \"Condensed Wave Cannon Kyrios 4\" Ability { id: \"7B0F\", source: \"Omega\" }\r\n99.3 \"Guided Missile Kyrios 4\" Ability { id: \"7B0E\", source: \"Omega\" }\r\n\r\n108.0 \"Diffuse Wave Cannon Kyrios x5\" duration 8 #Ability { id: \"7B10\", source: \"Omega\" }\r\n108.0 \"Wave Cannon Kyrios 1\" Ability { id: \"7B11\", source: \"Omega\" }\r\n116.8 \"Wave Cannon Kyrios 2\" Ability { id: \"7B11\", source: \"Omega\" }\r\n\r\n122.7 \"--sync--\" StartsUsing { id: \"7AF8\", source: \"Omega\" } window 20,20\r\n127.7 \"Atomic Ray Enrage\" Ability { id: \"7AF8\", source: \"Omega\" }\r\n\r\n\r\n### P2: M/F\r\n200.0 \"--sync--\" MapEffect { flags: \"00020001\", location: \"0A\" } window 200,0\r\n202.3 \"--targetable--\"\r\n203.4 \"--sync--\" StartsUsing { id: \"7B40\", source: \"Omega\" } window 210,5 # extra sync due to map effect sync\r\n206.4 \"Firewall\" Ability { id: \"7B40\", source: \"Omega\" }\r\n214.5 \"Solar Ray\" Ability { id: \"7E6A\", source: \"Omega\" }\r\n\r\n# Party Synergy\r\n230.9 \"Party Synergy\" Ability { id: \"7B3E\", source: \"Omega\" } window 20,20\r\n233.9 \"--untargetable--\"\r\n240.5 \"--sync--\" Ability { id: \"7B1B\", source: \"Omega\" }\r\n241.3 \"Superliminal Steel/Optimized Blizzard III\" Ability { id: [\"7B2A\", \"7B2D\"], source: \"Omega-F\" }\r\n241.3 \"Efficient Bladework/Beyond Strength\" Ability { id: [\"7B25\", \"7B26\"], source: \"Omega-M\" }\r\n247.7 \"Optimized Fire III\" Ability { id: \"7B2F\", source: \"Omega\" }\r\n248.0 \"Optical Laser\" Ability { id: \"7B21\", source: \"Optical Unit\" }\r\n250.8 \"--sync--\" Ability { id: \"7B1F\", source: \"Omega\" }\r\n254.9 \"Discharger\" Ability { id: \"7B2E\", source: \"Omega\" }\r\n259.1 \"Spotlight x2\" Ability { id: \"7B30\", source: \"Omega-M\" }\r\n259.1 \"Efficient Bladework\" Ability { id: \"7B26\", source: \"Omega-M\" }\r\n\r\n# Limitless Synergy\r\n262.1 \"--targetable--\"\r\n272.2 \"Synthetic Shield\" Ability { id: \"7E71\", source: \"Omega\" }\r\n282.4 \"Limitless Synergy\" Ability { id: \"7B38\", source: \"Omega\" } window 20,20\r\n285.5 \"--sync--\" Ability { id: \"7B42\", source: \"Omega\" }\r\n287.4 \"Optimized Passage of Arms\" Ability { id: \"7B44\", source: \"Omega\" }\r\n288.6 \"Synthetic Shield\" Ability { id: \"7E71\", source: \"Omega-M\" }\r\n295.6 \"Optimized Bladedance x2\" Ability { id: \"7B34\", source: \"Omega-M\" }\r\n295.7 \"Optimized Sagittarius Arrow\" Ability { id: \"7B33\", source: \"Omega-M\" }\r\n306.7 \"Beyond Defense\" Ability { id: \"7B27\", source: \"Omega-M\" }\r\n309.7 \"Optimized Meteor\" Ability { id: \"7B31\", source: \"Omega-F\" }\r\n310.0 \"Pile Pitch\" Ability { id: \"7B29\", source: \"Omega-M\" }\r\n318.8 \"Cosmo Memory\" Ability { id: \"7B22\", source: \"Omega-M\" }\r\n\r\n# 60 second cast, starting at same time of Passage of Arms\r\n347.4 \"Laser Shower Enrage\" Ability { id: \"7B45\", source: \"Omega\" }\r\n\r\n\r\n### P3: \"Final\" Omega\r\n400.0 \"--sync--\" Ability { id: \"7B13\", source: \"Omega\" } window 400,0\r\n409.3 \"--sync--\" Ability { id: \"7B4A\", source: \"Omega\" }\r\n412.3 \"--sync--\" Ability { id: \"7B4B\", source: \"Omega\" }\r\n414.3 \"Wave Repeater 1\" Ability { id: \"7B4F\", source: \"Omega\" }\r\n416.4 \"Wave Repeater 2\" Ability { id: \"7B50\", source: \"Omega\" }\r\n418.4 \"Wave Repeater 3\" Ability { id: \"7B51\", source: \"Omega\" }\r\n420.4 \"Wave Repeater 4\" Ability { id: \"7B52\", source: \"Omega\" }\r\n422.4 \"Wave Repeater 1\" Ability { id: \"7B4F\", source: \"Omega\" }\r\n424.5 \"Wave Repeater 2\" Ability { id: \"7B50\", source: \"Omega\" }\r\n426.4 \"Colossal Blow\" Ability { id: \"7B4E\", source: [\"Left Arm Unit\", \"Right Arm Unit\"] } window 1,1\r\n426.6 \"Wave Repeater 3\" Ability { id: \"7B51\", source: \"Omega\" }\r\n# sniper cannon times are a little sloppy and have inconsistent actor names\r\n427.3 \"High-powered Sniper Cannon x2\" #Ability { id: \"7B54\", source: \"Omega\" }\r\n428.4 \"Sniper Cannon x4\" #Ability { id: \"7B53\", source: \"Omega\" }\r\n428.7 \"Wave Repeater 4\" Ability { id: \"7B52\", source: \"Omega\" }\r\n428.9 \"Colossal Blow\" Ability { id: \"7B4E\", source: [\"Left Arm Unit\", \"Right Arm Unit\"] } window 1,1\r\n\r\n432.3 \"--targetable--\"\r\n436.3 \"--sync--\" StartsUsing { id: \"7B55\", source: \"Omega\" } window 40,40\r\n\r\n441.3 \"Hello, World\" Ability { id: \"7B55\", source: \"Omega\" }\r\n# Most of the damage comes in 7B56 Critical Synchronization Bug,\r\n# and 7B57 Critical Overflow Bug which is 1s after latent defect\r\n# (and patch, obviously).  There's also a ton of other Latent X\r\n# abilities here.  All of these are skipped for noise reasons.\r\n\r\n455.4 \"--sync--\" StartsUsing { id: \"7B6F\", source: \"Omega\" }\r\n464.4 \"Latent Defect 1\" Ability { id: \"7B6F\", source: \"Omega\" }\r\n# people break both patches here whenever, so don't sync these times\r\n# this time is roughly when people break the first one.\r\n466.9 \"Patch x2\" #Ability { id: \"7B63\", source: \"Omega\" }\r\n\r\n476.4 \"--sync--\" StartsUsing { id: \"7B6F\", source: \"Omega\" }\r\n485.4 \"Latent Defect 2\" Ability { id: \"7B6F\", source: \"Omega\" }\r\n487.9 \"Patch x2\" #Ability { id: \"7B63\", source: \"Omega\" }\r\n\r\n497.5 \"--sync--\" StartsUsing { id: \"7B6F\", source: \"Omega\" }\r\n506.5 \"Latent Defect 3\" Ability { id: \"7B6F\", source: \"Omega\" }\r\n509.0 \"Patch x2\" #Ability { id: \"7B63\", source: \"Omega\" }\r\n\r\n518.8 \"--sync--\" StartsUsing { id: \"7B6F\", source: \"Omega\" }\r\n527.5 \"Patch\" #Ability { id: \"7B63\", source: \"Omega\" }\r\n527.8 \"Latent Defect 4\" Ability { id: \"7B6F\", source: \"Omega\" }\r\n533.5 \"Patch\" #Ability { id: \"7B63\", source: \"Omega\" }\r\n\r\n542.1 \"--sync--\" StartsUsing { id: \"7B64\", source: \"Omega\" } window 30,30\r\n550.1 \"Critical Error\" Ability { id: \"7B64\", source: \"Omega\" }\r\n\r\n560.2 \"--sync--\" Ability { id: \"7B46\", source: \"Omega\" }\r\n571.4 \"Oversampled Wave Cannon\" Ability { id: [\"7B6B\", \"7B6C\"], source: \"Omega\" }\r\n577.4 \"--sync--\" StartsUsing { id: \"7B48\", source: \"Omega\" } window 50,50\r\n587.4 \"Ion Efflux Enrage\" Ability { id: \"7B48\", source: \"Omega\" }\r\n\r\n\r\n### P4: Blue Screen\r\n600.0 \"--sync--\" Ability { id: \"7B47\", source: \"Omega\" } window 600,0\r\n600.0 \"--untargetable--\"\r\n607.1 \"--sync--\" Ability { id: \"7B7A\", source: \"Omega\" }\r\n607.1 \"--targetable--\"\r\n615.2 \"--sync--\" Ability { id: \"7B46\", source: \"Omega\" }\r\n619.0 \"--sync--\" Ability { id: \"5779\", source: \"Omega\" }\r\n621.4 \"Wave Cannon A\" Ability { id: \"7B81\", source: \"Omega\" }\r\n626.7 \"Wave Cannon B\" Ability { id: \"7F16\", source: \"Omega\" }\r\n627.0 \"Wave Cannon (stacks)\" Ability { id: \"7B7F\", source: \"Omega\" }\r\n\r\n629.1 \"--sync--\" Ability { id: \"5779\", source: \"Omega\" }\r\n629.4 \"Wave Repeater 1\" Ability { id: \"7B4F\", source: \"Omega\" }\r\n631.5 \"Wave Repeater 2\" Ability { id: \"7B50\", source: \"Omega\" }\r\n631.5 \"Wave Cannon A\" Ability { id: \"7F16\", source: \"Omega\" }\r\n633.5 \"Wave Repeater 3\" Ability { id: \"7B51\", source: \"Omega\" }\r\n635.5 \"Wave Repeater 4\" Ability { id: \"7B52\", source: \"Omega\" }\r\n636.6 \"Wave Cannon B\" Ability { id: \"7B82\", source: \"Omega\" }\r\n636.8 \"Wave Cannon (stacks)\" Ability { id: \"7B7F\", source: \"Omega\" }\r\n\r\n639.0 \"--sync--\" Ability { id: \"5779\", source: \"Omega\" }\r\n641.6 \"Wave Cannon A\" Ability { id: \"7B83\", source: \"Omega\" }\r\n646.6 \"Wave Repeater 1\" Ability { id: \"7B4F\", source: \"Omega\" }\r\n646.7 \"Wave Cannon B\" Ability { id: \"7B84\", source: \"Omega\" }\r\n646.9 \"Wave Cannon (stacks)\" Ability { id: \"7B7F\", source: \"Omega\" }\r\n648.6 \"Wave Repeater 2\" Ability { id: \"7B50\", source: \"Omega\" }\r\n650.6 \"Wave Repeater 3\" Ability { id: \"7B51\", source: \"Omega\" }\r\n652.6 \"Wave Repeater 4\" Ability { id: \"7B52\", source: \"Omega\" }\r\n661.6 \"Blue Screen Enrage\" Ability { id: \"7B7B\", source: \"Omega\" }\r\n661.6 \"--untargetable--\"\r\n\r\n\r\n### P5: Run: Dynamis\r\n# Blue Screen DPS check passed\r\n700.0 \"--sync--\" Ability { id: \"7B7C\", source: \"Omega\" } window 700,0\r\n706.0 \"--sync--\" Ability { id: \"7B86\", source: \"Omega-F\" }\r\n706.0 \"--sync--\" Ability { id: \"7B85\", source: \"Omega-M\" }\r\n\r\n# Delta Version\r\n715.6 \"--targetable--\"\r\n723.6 \"Solar Ray 1\" Ability { id: \"81AC\", source: \"Omega-M\" }\r\n726.8 \"Solar Ray 2\" Ability { id: \"7B01\", source: \"Omega-M\" }\r\n733.9 \"--sync--\" Ability { id: \"7B42\", source: \"Omega-M\" }\r\n740.0 \"Run: ****mi* (Delta Version)\" Ability { id: \"7B88\", source: \"Omega-M\" }\r\n743.0 \"--untargetable--\"\r\n750.2 \"Peripheral Synthesis\" Ability { id: \"7B8C\", source: \"Omega\" }\r\n753.2 \"Archive Peripheral\" Ability { id: \"7F76\", source: \"Omega\" }\r\n761.2 \"Patch\" #Ability { id: \"7B63\", source: \"Omega-M\" }\r\n763.2 \"Optical Laser\" Ability { id: \"7B21\", source: \"Optical Unit\" }\r\n764.9 \"Patch\" #Ability { id: \"7B63\", source: \"Omega-M\" }\r\n766.4 \"Explosion\" Ability { id: \"7AFA\", source: \"Rocket Punch\" }\r\n768.5 \"Beyond Defense\" Ability { id: \"7B27\", source: \"Omega-M\" }\r\n771.1 \"Hyper Pulse\" Ability { id: \"7B70\", source: \"Right Arm Unit\" }\r\n771.8 \"Hyper Pulse\" #Ability { id: \"7B71\", source: \"Right Arm Unit\" }\r\n772.4 \"Hyper Pulse\" #Ability { id: \"7B71\", source: \"Right Arm Unit\" }\r\n773.0 \"Hyper Pulse\" #Ability { id: \"7B71\", source: \"Right Arm Unit\" }\r\n773.6 \"Hyper Pulse\" #Ability { id: \"7B71\", source: \"Right Arm Unit\" }\r\n773.6 \"Oversampled Wave Cannon\" Ability { id: \"7B6D\", source: \"Omega\" }\r\n774.0 \"Pile Pitch\" Ability { id: \"7B29\", source: \"Omega-M\" }\r\n774.0 \"Hyper Pulse\" #Ability { id: \"7B71\", source: \"Right Arm Unit\" }\r\n782.0 \"Patch\" #Ability { id: \"7B63\", source: \"Omega-M\" }\r\n784.0 \"Patch\" #Ability { id: \"7B63\", source: \"Omega-M\" }\r\n786.4 \"Swivel Cannon\" Ability { id: [\"7B94\", \"7B95\"], source: \"Omega\" }\r\n787.0 \"Hello, Distant World 1\" Ability { id: \"8110\", source: \"Omega-M\" }\r\n787.0 \"Hello, Near World 1\" Ability { id: \"7B89\", source: \"Omega-M\" }\r\n788.0 \"Hello, Distant World 2\" #Ability { id: \"8111\", source: \"Omega-M\" }\r\n788.0 \"Hello, Near World 2\" #Ability { id: \"7B8A\", source: \"Omega-M\" }\r\n789.0 \"Hello, Distant World 3\" #Ability { id: \"8111\", source: \"Omega-M\" }\r\n789.0 \"Hello, Near World 3\" #Ability { id: \"7B8A\", source: \"Omega-M\" }\r\n\r\n# Sigma Version\r\n791.1 \"--targetable--\"\r\n805.2 \"Solar Ray 1\" Ability { id: \"81AC\", source: \"Omega-M\" }\r\n808.5 \"Solar Ray 2\" Ability { id: \"7B01\", source: \"Omega-M\" }\r\n815.6 \"--sync--\" Ability { id: \"7B42\", source: \"Omega-M\" }\r\n821.7 \"Run: ****mi* (Sigma Version)\" Ability { id: \"8014\", source: \"Omega-M\" }\r\n824.7 \"--untargetable--\"\r\n\r\n839.0 \"Subject Simulation F\" Ability { id: \"7F2F\", source: \"Omega-M\" }\r\n840.0 \"--sync--\" Ability { id: \"7B14\", source: \"Omega-M\" }\r\n840.4 \"Program Loop\" Ability { id: \"7B98\", source: \"Omega\" }\r\n841.1 \"--sync--\" Ability { id: \"7B16\", source: \"Omega-M\" }\r\n843.8 \"Hyper Pulse\" Ability { id: \"7B72\", source: \"Right Arm Unit\" }\r\n844.0 \"Wave Cannon\" Ability { id: \"7B73\", source: \"Omega\" }\r\n845.1 \"--sync--\" Ability { id: \"7F30\", source: \"Omega-M\" }\r\n848.7 \"--sync--\" Ability { id: \"7B15\", source: \"Omega\" }\r\n849.3 \"--sync--\" Ability { id: \"7B20\", source: \"Omega-M\" }\r\n851.3 \"--sync--\" Ability { id: \"7B43\", source: \"Omega-M\" }\r\n\r\n852.4 \"Discharger\" Ability { id: \"7B2E\", source: \"Omega-M\" }\r\n856.4 \"Storage Violation x5 / Storage Violation x6\" Ability { id: \"7B0[45]\", source: \"Omega\" }\r\n\r\n870.6 \"Rear Lasers x14\" Ability { id: \"7B8F\", source: \"Rear Power Unit\" } duration 7.8\r\n873.7 \"Superliminal Steel/Optimized Blizzard III\" Ability { id: [\"7B2A\", \"7B2D\"], source: \"Omega-M\" }\r\n880.6 \"Hello, Near World 1\" Ability { id: \"7B89\", source: \"Omega-F\" }\r\n880.6 \"Hello, Distant World 1\" Ability { id: \"8110\", source: \"Omega-F\" }\r\n880.6 \"Hyper Pulse\" Ability { id: \"7B72\", source: \"Right Arm Unit\" }\r\n881.6 \"Hello, Near World 2\" #Ability { id: \"7B8A\", source: \"Omega-F\" }\r\n881.6 \"Hello, Distant World 2\" #Ability { id: \"8111\", source: \"Omega-F\" }\r\n882.6 \"Hello, Near World 3\" #Ability { id: \"7B8A\", source: \"Omega-F\" }\r\n882.6 \"Hello, Distant World 3\" #Ability { id: \"8111\", source: \"Omega-F\" }\r\n\r\n# Omega Version\r\n885.3 \"--targetable--\"\r\n887.3 \"--sync--\" Ability { id: \"7C02\", source: \"Omega-M\" }\r\n894.3 \"Solar Ray 1\" Ability { id: \"81AD\", source: \"Omega-M\" }\r\n897.4 \"Solar Ray 2\" Ability { id: \"7B02\", source: \"Omega-M\" }\r\n904.6 \"--sync--\" Ability { id: \"7B43\", source: \"Omega-M\" }\r\n910.7 \"Run: ****mi* (Omega Version)\" Ability { id: \"8015\", source: \"Omega-M\" }\r\n927.8 \"Diffuse Wave Cannon\" Ability { id: [\"7B9B\", \"7B9C\"], source: \"Omega\" }\r\n# 928.8 \"Superliminal Steel\" Ability { id: \"7B2A\", source: \"Omega-F\" }\r\n# 928.8 \"Beyond Strength\" Ability { id: \"7B25\", source: \"Omega-M\" }\r\n931.9 \"Diffuse Wave Cannon\" Ability { id: [\"7B78\", \"7B77\"], source: \"Omega\" }\r\n# 932.7 \"Optimized Blizzard III\" Ability { id: \"7B2D\", source: \"Omega-F\" }\r\n# 932.7 \"Beyond Strength\" Ability { id: \"7B25\", source: \"Omega-M\" }\r\n935.6 \"--untargetable--\"\r\n\r\n945.4 \"Hello, Distant World 1\" Ability { id: \"8110\", source: \"Omega-F\" }\r\n945.4 \"Hello, Near World 1\" Ability { id: \"7B89\", source: \"Omega-F\" }\r\n945.8 \"Oversampled Wave Cannon\" Ability { id: \"7B6D\", source: \"Omega\" }\r\n946.4 \"Hello, Distant World 2\" #Ability { id: \"8111\", source: \"Omega-F\" }\r\n946.4 \"Hello, Near World 2\" #Ability { id: \"7B8A\", source: \"Omega-F\" }\r\n947.4 \"Hello, Distant World 3\" #Ability { id: \"8111\", source: \"Omega-F\" }\r\n947.4 \"Hello, Near World 3\" #Ability { id: \"7B8A\", source: \"Omega-F\" }\r\n\r\n961.6 \"Blaster x2\" Ability { id: \"7E75\", source: \"Omega-F\" }\r\n963.4 \"Hello, Distant World 1\" Ability { id: \"8110\", source: \"Omega-F\" }\r\n963.4 \"Hello, Near World 1\" Ability { id: \"7B89\", source: \"Omega-F\" }\r\n964.4 \"Hello, Distant World 2\" #Ability { id: \"8111\", source: \"Omega-F\" }\r\n964.4 \"Hello, Near World 2\" #Ability { id: \"7B8A\", source: \"Omega-F\" }\r\n965.4 \"Hello, Distant World 3\" #Ability { id: \"8111\", source: \"Omega-F\" }\r\n965.4 \"Hello, Near World 3\" #Ability { id: \"7B8A\", source: \"Omega-F\" }\r\n\r\n967.7 \"--targetable--\"\r\n976.8 \"Solar Ray 1\" Ability { id: \"81AD\", source: \"Omega-M\" }\r\n979.9 \"Solar Ray 2\" Ability { id: \"7B02\", source: \"Omega-M\" }\r\n988.2 \"--sync--\" Ability { id: \"7B43\", source: \"Omega-M\" }\r\n998.5 \"Blind Faith\" Ability { id: \"7B87\", source: \"Omega-M\" }\r\n999.7 \"Blind Faith Enrage\" Ability { id: \"7F73\", source: \"Omega-F\" }\r\n\r\n\r\n### P6: Alpha Omega\r\n# Blind Faith DPS check passed\r\n1100.0 \"--sync--\" Ability { id: \"7F72\", source: \"Omega-F\" } window 1100,0\r\n\r\n1154.7 \"--targetable--\"\r\n# LB3 Check\r\n1167.8 \"Cosmo Memory\" Ability { id: \"7BA1\", source: \"Alpha Omega\" }\r\n1171.9 \"--sync--\" Ability { id: \"7C03\", source: \"Alpha Omega\" }\r\n1172.8 \"Flash Gale 1\" Ability { id: \"7DDF\", source: \"Omega-F\" }\r\n1175.1 \"--sync--\" Ability { id: \"7C03\", source: \"Alpha Omega\" }\r\n1176.0 \"Flash Gale 2\" Ability { id: \"7DDF\", source: \"Alpha Omega\" }\r\n\r\n1182.2 \"Cosmo Arrow\" Ability { id: \"7BA2\", source: \"Alpha Omega\" } duration 14\r\n1196.9 \"Cosmo Dive\" Ability { id: \"7BA6\", source: \"Alpha Omega\" }\r\n1199.3 \"Cosmo Dive Far\" #Ability { id: \"7BA8\", source: \"Alpha Omega\" }\r\n1199.3 \"Cosmo Dive Near x2\" #Ability { id: \"7BA7\", source: \"Alpha Omega\" }\r\n1206.1 \"--sync--\" Ability { id: \"7C03\", source: \"Alpha Omega\" }\r\n1207.0 \"Flash Gale 1\" Ability { id: \"7DDF\", source: \"Alpha Omega\" }\r\n1209.3 \"--sync--\" Ability { id: \"7C03\", source: \"Alpha Omega\" }\r\n1210.2 \"Flash Gale 2\" Ability { id: \"7DDF\", source: \"Alpha Omega\" }\r\n\r\n1215.4 \"Unlimited Wave Cannon\" Ability { id: \"7BAC\", source: \"Alpha Omega\" }\r\n1223.4 \"Wave Cannon Puddle 1\" #Ability { id: \"7BAF\", source: \"Alpha Omega\" }\r\n1225.2 \"Wave Cannon Puddle 2\" #Ability { id: \"7BAF\", source: \"Alpha Omega\" }\r\n1227.1 \"Wave Cannon Puddle 3\" #Ability { id: \"7BAF\", source: \"Alpha Omega\" }\r\n1229.0 \"Wave Cannon Puddle 4\" #Ability { id: \"7BAF\", source: \"Alpha Omega\" }\r\n1230.9 \"Wave Cannon Puddle 5\" #Ability { id: \"7BAF\", source: \"Alpha Omega\" }\r\n1232.9 \"Wave Cannon Puddle 6\" #Ability { id: \"7BAF\", source: \"Alpha Omega\" }\r\n1236.0 \"Wave Cannon 1\" #Ability { id: \"7BAB\", source: \"Alpha Omega\" }\r\n1238.0 \"Wave Cannon 2\" #Ability { id: \"7BAB\", source: \"Alpha Omega\" }\r\n1243.9 \"--sync--\" Ability { id: \"7BA9\", source: \"Alpha Omega\" }\r\n1244.3 \"Wave Cannon (Wild Charge)\" #Ability { id: \"7BAA\", source: \"Alpha Omega\" }\r\n1248.4 \"--sync--\" Ability { id: \"7C03\", source: \"Alpha Omega\" }\r\n1249.3 \"Flash Gale 1\" Ability { id: \"7DDF\", source: \"Alpha Omega\" }\r\n1251.6 \"--sync--\" Ability { id: \"7C03\", source: \"Alpha Omega\" }\r\n1252.5 \"Flash Gale 2\" Ability { id: \"7DDF\", source: \"Alpha Omega\" }\r\n\r\n1258.7 \"Cosmo Arrow\" Ability { id: \"7BA2\", source: \"Alpha Omega\" } duration 14\r\n1269.9 \"Wave Cannon 1\" #Ability { id: \"7BAB\", source: \"Alpha Omega\" }\r\n1271.9 \"Wave Cannon 2\" #Ability { id: \"7BAB\", source: \"Alpha Omega\" }\r\n1277.8 \"--sync--\" Ability { id: \"7BA9\", source: \"Alpha Omega\" }\r\n1278.2 \"Wave Cannon (Wild Charge)\" #Ability { id: \"7BAA\", source: \"Alpha Omega\" }\r\n1282.3 \"--sync--\" Ability { id: \"7C03\", source: \"Alpha Omega\" }\r\n1283.2 \"Flash Gale 1\" Ability { id: \"7DDF\", source: \"Alpha Omega\" }\r\n1285.5 \"--sync--\" Ability { id: \"7C03\", source: \"Alpha Omega\" }\r\n1286.4 \"Flash Gale 2\" Ability { id: \"7DDF\", source: \"Alpha Omega\" }\r\n\r\n1291.7 \"Unlimited Wave Cannon\" Ability { id: \"7BAC\", source: \"Alpha Omega\" }\r\n1299.7 \"Wave Cannon Puddle 1\" #Ability { id: \"7BAF\", source: \"Alpha Omega\" }\r\n1301.5 \"Wave Cannon Puddle 2\" #Ability { id: \"7BAF\", source: \"Alpha Omega\" }\r\n1303.4 \"Wave Cannon Puddle 3\" #Ability { id: \"7BAF\", source: \"Alpha Omega\" }\r\n1305.3 \"Wave Cannon Puddle 4\" #Ability { id: \"7BAF\", source: \"Alpha Omega\" }\r\n1307.2 \"Wave Cannon Puddle 5\" #Ability { id: \"7BAF\", source: \"Alpha Omega\" }\r\n1309.2 \"Wave Cannon Puddle 6\" #Ability { id: \"7BAF\", source: \"Alpha Omega\" }\r\n1310.0 \"Cosmo Dive\" Ability { id: \"7BA6\", source: \"Alpha Omega\" }\r\n1312.4 \"Cosmo Dive Far\" #Ability { id: \"7BA8\", source: \"Alpha Omega\" }\r\n1312.4 \"Cosmo Dive Near x2\" #Ability { id: \"7BA7\", source: \"Alpha Omega\" }\r\n1319.2 \"--sync--\" Ability { id: \"7C03\", source: \"Alpha Omega\" }\r\n1320.1 \"Flash Gale 1\" Ability { id: \"7DDF\", source: \"Alpha Omega\" }\r\n1322.4 \"--sync--\" Ability { id: \"7C03\", source: \"Alpha Omega\" }\r\n1323.2 \"Flash Gale 2\" Ability { id: \"7DDF\", source: \"Alpha Omega\" }\r\n\r\n# Range/Caster Brilliant Dynamis Checks\r\n1331.6 \"Cosmo Meteor\" Ability { id: \"7BB0\", source: \"Alpha Omega\" }\r\n1335.6 \"Cosmo Meteor Baits\" Ability { id: \"7BB2\", source: \"Alpha Omega\" }\r\n\r\n1336.7 \"Cosmo Meteor 1 x4\" #Ability { id: \"7FBB\", source: \"Alpha Omega\" }\r\n1337.7 \"Cosmo Meteor 2 x4\" #Ability { id: \"7FBB\", source: \"Alpha Omega\" }\r\n# TODO: Adjust targetable\r\n1339.3 \"--adds targetable--\"\r\n1342.7 \"Cosmo Meteor 1 x4\" #Ability { id: \"7FBB\", source: \"Alpha Omega\" }\r\n1343.7 \"Cosmo Meteor 2 x4\" #Ability { id: \"7FBB\", source: \"Alpha Omega\" }\r\n\r\n1354.7 \"Cosmo Meteor Stack\" Ability { id: \"7BB3\", source: \"Alpha Omega\" }\r\n1354.7 \"Cosmo Meteor Flare x3\" Ability { id: \"7BB4\", source: \"Alpha Omega\" }\r\n1355.7 \"Cosmo Meteor\" Ability { id: \"7BB1\", source: \"Alpha Omega\" }\r\n1357.0 \"Cosmo Meteor Enrage\" Ability { id: \"7BB5\", source: \"Cosmo Meteor\" }\r\n\r\n# Tank 1 and Healer 1 Brilliant Dynamis Checks\r\n1361.7 \"--sync--\" StartsUsing { id: \"7BB6\", source: \"Alpha Omega\" } window 5,5\r\n1366.7 \"Magic Number\" Ability { id: \"7BB6\", source: \"Alpha Omega\" }\r\n\r\n# Tank 2 and Healer 2 Brilliant Dynamis Checks\r\n1377.8 \"--sync--\" StartsUsing { id: \"7BB6\", source: \"Alpha Omega\" } window 5,5\r\n1382.8 \"Magic Number\" Ability { id: \"7BB6\", source: \"Alpha Omega\" }\r\n\r\n1391.9 \"--sync--\" StartsUsing { id: \"7BA0\", source: \"Alpha Omega\" } window 50,50\r\n# The cast bar and logs say \"16 seconds\" but it appears to be ~30s in practice.\r\n1421.9 \"Run: ****mi* Enrage\" Ability { id: \"7BA0\", source: \"Alpha Omega\" }\r\n";
;// CONCATENATED MODULE: ./ui/raidboss/data/raidboss_manifest.txt




















































































































































































































































































































































































































































































































































































































/* harmony default export */ const raidboss_manifest = ({'00-misc/general.ts': general,'00-misc/test.ts': test,'00-misc/test.txt': _00_misc_test_namespaceObject,'00-misc/the_masked_carnivale.ts': the_masked_carnivale,'02-arr/alliance/the_world_of_darkness.ts': the_world_of_darkness,'02-arr/dungeon/amdapor_keep.ts': amdapor_keep,'02-arr/dungeon/amdapor_keep_hard.ts': amdapor_keep_hard,'02-arr/dungeon/aurum_vale.ts': aurum_vale,'02-arr/dungeon/brayfloxs_longstop.ts': brayfloxs_longstop,'02-arr/dungeon/cutters_cry.ts': cutters_cry,'02-arr/dungeon/halatali_hard.ts': halatali_hard,'02-arr/dungeon/haukke_manor.ts': haukke_manor,'02-arr/dungeon/haukke_manor_hard.ts': haukke_manor_hard,'02-arr/dungeon/hullbreaker_isle.ts': hullbreaker_isle,'02-arr/dungeon/pharos_sirius.ts': pharos_sirius,'02-arr/dungeon/sastasha_hard.ts': sastasha_hard,'02-arr/dungeon/snowcloak.ts': snowcloak,'02-arr/dungeon/the_lost_city_of_amdapor.ts': the_lost_city_of_amdapor,'02-arr/dungeon/the_stone_vigil.ts': the_stone_vigil,'02-arr/dungeon/the_stone_vigil_hard.ts': the_stone_vigil_hard,'02-arr/dungeon/the_sunken_temple_of_quarn.ts': the_sunken_temple_of_quarn,'02-arr/dungeon/the_sunken_temple_of_quarn_hard.ts': the_sunken_temple_of_quarn_hard,'02-arr/dungeon/the_tam_tara_depocraft_hard.ts': the_tam_tara_depocraft_hard,'02-arr/dungeon/the_wanderers_palace_hard.ts': the_wanderers_palace_hard,'02-arr/raid/t1.ts': t1,'02-arr/raid/t10.ts': t10,'02-arr/raid/t10.txt': raid_t10_namespaceObject,'02-arr/raid/t11.ts': t11,'02-arr/raid/t11.txt': raid_t11_namespaceObject,'02-arr/raid/t12.ts': t12,'02-arr/raid/t12.txt': raid_t12_namespaceObject,'02-arr/raid/t13.ts': t13,'02-arr/raid/t13.txt': raid_t13_namespaceObject,'02-arr/raid/t2.ts': t2,'02-arr/raid/t4.ts': t4,'02-arr/raid/t4.txt': raid_t4_namespaceObject,'02-arr/raid/t5.ts': t5,'02-arr/raid/t5.txt': raid_t5_namespaceObject,'02-arr/raid/t6.ts': t6,'02-arr/raid/t6.txt': raid_t6_namespaceObject,'02-arr/raid/t7.ts': t7,'02-arr/raid/t7.txt': raid_t7_namespaceObject,'02-arr/raid/t8.ts': t8,'02-arr/raid/t8.txt': raid_t8_namespaceObject,'02-arr/raid/t9.ts': t9,'02-arr/raid/t9.txt': raid_t9_namespaceObject,'02-arr/trial/ifrit-nm.ts': ifrit_nm,'02-arr/trial/ifrit-nm.txt': trial_ifrit_nm_namespaceObject,'02-arr/trial/levi-ex.ts': levi_ex,'02-arr/trial/levi-ex.txt': trial_levi_ex_namespaceObject,'02-arr/trial/shiva-ex.ts': shiva_ex,'02-arr/trial/shiva-ex.txt': trial_shiva_ex_namespaceObject,'02-arr/trial/shiva-hm.ts': shiva_hm,'02-arr/trial/shiva-hm.txt': trial_shiva_hm_namespaceObject,'02-arr/trial/titan-ex.ts': titan_ex,'02-arr/trial/titan-ex.txt': trial_titan_ex_namespaceObject,'02-arr/trial/titan-hm.ts': titan_hm,'02-arr/trial/titan-hm.txt': trial_titan_hm_namespaceObject,'02-arr/trial/titan-nm.ts': titan_nm,'02-arr/trial/titan-nm.txt': trial_titan_nm_namespaceObject,'02-arr/trial/ultima-ex.ts': ultima_ex,'02-arr/trial/ultima-ex.txt': trial_ultima_ex_namespaceObject,'03-hw/alliance/dun_scaith.ts': dun_scaith,'03-hw/alliance/dun_scaith.txt': alliance_dun_scaith_namespaceObject,'03-hw/alliance/weeping_city.ts': weeping_city,'03-hw/alliance/weeping_city.txt': alliance_weeping_city_namespaceObject,'03-hw/deepdungeon/the_palace_of_the_dead_floors_001-010.ts': the_palace_of_the_dead_floors_001_010,'03-hw/deepdungeon/the_palace_of_the_dead_floors_011-020.ts': the_palace_of_the_dead_floors_011_020,'03-hw/deepdungeon/the_palace_of_the_dead_floors_021-030.ts': the_palace_of_the_dead_floors_021_030,'03-hw/deepdungeon/the_palace_of_the_dead_floors_031-040.ts': the_palace_of_the_dead_floors_031_040,'03-hw/deepdungeon/the_palace_of_the_dead_floors_041-050.ts': the_palace_of_the_dead_floors_041_050,'03-hw/deepdungeon/the_palace_of_the_dead_floors_051-060.ts': the_palace_of_the_dead_floors_051_060,'03-hw/deepdungeon/the_palace_of_the_dead_floors_061-070.ts': the_palace_of_the_dead_floors_061_070,'03-hw/deepdungeon/the_palace_of_the_dead_floors_071-080.ts': the_palace_of_the_dead_floors_071_080,'03-hw/deepdungeon/the_palace_of_the_dead_floors_081-090.ts': the_palace_of_the_dead_floors_081_090,'03-hw/deepdungeon/the_palace_of_the_dead_floors_091-100.ts': the_palace_of_the_dead_floors_091_100,'03-hw/deepdungeon/the_palace_of_the_dead_floors_101-110.ts': the_palace_of_the_dead_floors_101_110,'03-hw/deepdungeon/the_palace_of_the_dead_floors_111-120.ts': the_palace_of_the_dead_floors_111_120,'03-hw/deepdungeon/the_palace_of_the_dead_floors_121-130.ts': the_palace_of_the_dead_floors_121_130,'03-hw/deepdungeon/the_palace_of_the_dead_floors_131-140.ts': the_palace_of_the_dead_floors_131_140,'03-hw/deepdungeon/the_palace_of_the_dead_floors_141-150.ts': the_palace_of_the_dead_floors_141_150,'03-hw/deepdungeon/the_palace_of_the_dead_floors_151-160.ts': the_palace_of_the_dead_floors_151_160,'03-hw/deepdungeon/the_palace_of_the_dead_floors_161-170.ts': the_palace_of_the_dead_floors_161_170,'03-hw/deepdungeon/the_palace_of_the_dead_floors_171-180.ts': the_palace_of_the_dead_floors_171_180,'03-hw/deepdungeon/the_palace_of_the_dead_floors_181-190.ts': the_palace_of_the_dead_floors_181_190,'03-hw/deepdungeon/the_palace_of_the_dead_floors_191-200.ts': the_palace_of_the_dead_floors_191_200,'03-hw/deepdungeon/the_palace_of_the_dead_general.ts': the_palace_of_the_dead_general,'03-hw/dungeon/aetherochemical_research_facility.ts': aetherochemical_research_facility,'03-hw/dungeon/aetherochemical_research_facility.txt': dungeon_aetherochemical_research_facility_namespaceObject,'03-hw/dungeon/baelsars_wall.ts': baelsars_wall,'03-hw/dungeon/baelsars_wall.txt': dungeon_baelsars_wall_namespaceObject,'03-hw/dungeon/fractal_continuum.ts': fractal_continuum,'03-hw/dungeon/fractal_continuum.txt': dungeon_fractal_continuum_namespaceObject,'03-hw/dungeon/gubal_library_hard.ts': gubal_library_hard,'03-hw/dungeon/gubal_library_hard.txt': dungeon_gubal_library_hard_namespaceObject,'03-hw/dungeon/sohm_al.ts': sohm_al,'03-hw/dungeon/sohm_al.txt': dungeon_sohm_al_namespaceObject,'03-hw/dungeon/sohm_al_hard.ts': sohm_al_hard,'03-hw/dungeon/sohm_al_hard.txt': dungeon_sohm_al_hard_namespaceObject,'03-hw/dungeon/the_lost_city_of_amdapor_hard.ts': the_lost_city_of_amdapor_hard,'03-hw/dungeon/the_lost_city_of_amdapor_hard.txt': dungeon_the_lost_city_of_amdapor_hard_namespaceObject,'03-hw/dungeon/the_vault.ts': the_vault,'03-hw/dungeon/the_vault.txt': dungeon_the_vault_namespaceObject,'03-hw/dungeon/xelphatol.ts': xelphatol,'03-hw/dungeon/xelphatol.txt': dungeon_xelphatol_namespaceObject,'03-hw/map/the_aquapolis.ts': the_aquapolis,'03-hw/pvp/shatter.ts': shatter,'03-hw/raid/a10n.ts': a10n,'03-hw/raid/a10n.txt': raid_a10n_namespaceObject,'03-hw/raid/a10s.ts': a10s,'03-hw/raid/a10s.txt': raid_a10s_namespaceObject,'03-hw/raid/a11s.ts': a11s,'03-hw/raid/a11s.txt': raid_a11s_namespaceObject,'03-hw/raid/a12n.ts': a12n,'03-hw/raid/a12n.txt': raid_a12n_namespaceObject,'03-hw/raid/a12s.ts': a12s,'03-hw/raid/a12s.txt': raid_a12s_namespaceObject,'03-hw/raid/a1s.ts': a1s,'03-hw/raid/a1s.txt': raid_a1s_namespaceObject,'03-hw/raid/a2s.ts': a2s,'03-hw/raid/a2s.txt': raid_a2s_namespaceObject,'03-hw/raid/a3n.ts': a3n,'03-hw/raid/a3n.txt': raid_a3n_namespaceObject,'03-hw/raid/a3s.ts': a3s,'03-hw/raid/a3s.txt': raid_a3s_namespaceObject,'03-hw/raid/a4s.ts': a4s,'03-hw/raid/a4s.txt': raid_a4s_namespaceObject,'03-hw/raid/a5s.ts': a5s,'03-hw/raid/a5s.txt': raid_a5s_namespaceObject,'03-hw/raid/a6n.ts': a6n,'03-hw/raid/a6n.txt': raid_a6n_namespaceObject,'03-hw/raid/a6s.ts': a6s,'03-hw/raid/a6s.txt': raid_a6s_namespaceObject,'03-hw/raid/a7s.ts': a7s,'03-hw/raid/a7s.txt': raid_a7s_namespaceObject,'03-hw/raid/a8n.ts': a8n,'03-hw/raid/a8n.txt': raid_a8n_namespaceObject,'03-hw/raid/a8s.ts': a8s,'03-hw/raid/a8s.txt': raid_a8s_namespaceObject,'03-hw/raid/a9s.ts': a9s,'03-hw/raid/a9s.txt': raid_a9s_namespaceObject,'03-hw/trial/bismarck-ex.ts': bismarck_ex,'03-hw/trial/ravana-ex.ts': ravana_ex,'03-hw/trial/ravana-ex.txt': trial_ravana_ex_namespaceObject,'03-hw/trial/sephirot-ex.ts': sephirot_ex,'03-hw/trial/sephirot-ex.txt': trial_sephirot_ex_namespaceObject,'03-hw/trial/sephirot.ts': sephirot,'03-hw/trial/sophia-ex.ts': sophia_ex,'03-hw/trial/sophia-ex.txt': trial_sophia_ex_namespaceObject,'03-hw/trial/thordan-ex.ts': thordan_ex,'03-hw/trial/thordan-ex.txt': trial_thordan_ex_namespaceObject,'03-hw/trial/zurvan-ex.ts': zurvan_ex,'03-hw/trial/zurvan-ex.txt': trial_zurvan_ex_namespaceObject,'04-sb/alliance/orbonne_monastery.ts': orbonne_monastery,'04-sb/alliance/orbonne_monastery.txt': alliance_orbonne_monastery_namespaceObject,'04-sb/alliance/ridorana_lighthouse.ts': ridorana_lighthouse,'04-sb/alliance/ridorana_lighthouse.txt': alliance_ridorana_lighthouse_namespaceObject,'04-sb/alliance/royal_city_of_rabanastre.ts': royal_city_of_rabanastre,'04-sb/alliance/royal_city_of_rabanastre.txt': alliance_royal_city_of_rabanastre_namespaceObject,'04-sb/deepdungeon/heaven-on-high_floors_01-10.ts': heaven_on_high_floors_01_10,'04-sb/deepdungeon/heaven-on-high_floors_11-20.ts': heaven_on_high_floors_11_20,'04-sb/deepdungeon/heaven-on-high_floors_21-30.ts': heaven_on_high_floors_21_30,'04-sb/deepdungeon/heaven-on-high_floors_31-40.ts': heaven_on_high_floors_31_40,'04-sb/deepdungeon/heaven-on-high_floors_41-50.ts': heaven_on_high_floors_41_50,'04-sb/deepdungeon/heaven-on-high_floors_51-60.ts': heaven_on_high_floors_51_60,'04-sb/deepdungeon/heaven-on-high_floors_61-70.ts': heaven_on_high_floors_61_70,'04-sb/deepdungeon/heaven-on-high_floors_71-80.ts': heaven_on_high_floors_71_80,'04-sb/deepdungeon/heaven-on-high_floors_81-90.ts': heaven_on_high_floors_81_90,'04-sb/deepdungeon/heaven-on-high_floors_91-100.ts': heaven_on_high_floors_91_100,'04-sb/deepdungeon/heaven-on-high_general.ts': heaven_on_high_general,'04-sb/dungeon/ala_mhigo.ts': ala_mhigo,'04-sb/dungeon/ala_mhigo.txt': dungeon_ala_mhigo_namespaceObject,'04-sb/dungeon/bardams_mettle.ts': bardams_mettle,'04-sb/dungeon/bardams_mettle.txt': dungeon_bardams_mettle_namespaceObject,'04-sb/dungeon/castrum_abania.ts': castrum_abania,'04-sb/dungeon/castrum_abania.txt': dungeon_castrum_abania_namespaceObject,'04-sb/dungeon/doma_castle.ts': doma_castle,'04-sb/dungeon/doma_castle.txt': dungeon_doma_castle_namespaceObject,'04-sb/dungeon/drowned_city_of_skalla.ts': drowned_city_of_skalla,'04-sb/dungeon/drowned_city_of_skalla.txt': dungeon_drowned_city_of_skalla_namespaceObject,'04-sb/dungeon/fractal_continuum_hard.ts': fractal_continuum_hard,'04-sb/dungeon/fractal_continuum_hard.txt': dungeon_fractal_continuum_hard_namespaceObject,'04-sb/dungeon/ghimlyt_dark.ts': ghimlyt_dark,'04-sb/dungeon/ghimlyt_dark.txt': dungeon_ghimlyt_dark_namespaceObject,'04-sb/dungeon/ghimlyt_dark64.ts': ghimlyt_dark64,'04-sb/dungeon/ghimlyt_dark64.txt': dungeon_ghimlyt_dark64_namespaceObject,'04-sb/dungeon/hells_lid.ts': hells_lid,'04-sb/dungeon/hells_lid.txt': dungeon_hells_lid_namespaceObject,'04-sb/dungeon/kugane_castle.ts': kugane_castle,'04-sb/dungeon/kugane_castle.txt': dungeon_kugane_castle_namespaceObject,'04-sb/dungeon/shisui_of_the_violet_tides.ts': shisui_of_the_violet_tides,'04-sb/dungeon/shisui_of_the_violet_tides.txt': dungeon_shisui_of_the_violet_tides_namespaceObject,'04-sb/dungeon/sirensong_sea.ts': sirensong_sea,'04-sb/dungeon/sirensong_sea.txt': dungeon_sirensong_sea_namespaceObject,'04-sb/dungeon/st_mocianne_hard.ts': st_mocianne_hard,'04-sb/dungeon/st_mocianne_hard.txt': dungeon_st_mocianne_hard_namespaceObject,'04-sb/dungeon/swallows_compass.ts': swallows_compass,'04-sb/dungeon/swallows_compass.txt': dungeon_swallows_compass_namespaceObject,'04-sb/dungeon/temple_of_the_fist.ts': temple_of_the_fist,'04-sb/dungeon/temple_of_the_fist.txt': dungeon_temple_of_the_fist_namespaceObject,'04-sb/dungeon/the_burn.ts': the_burn,'04-sb/dungeon/the_burn.txt': dungeon_the_burn_namespaceObject,'04-sb/dungeon/the_burn64.ts': the_burn64,'04-sb/dungeon/the_burn64.txt': dungeon_the_burn64_namespaceObject,'04-sb/eureka/eureka_anemos.ts': eureka_anemos,'04-sb/eureka/eureka_hydatos.ts': eureka_hydatos,'04-sb/eureka/eureka_hydatos.txt': eureka_eureka_hydatos_namespaceObject,'04-sb/eureka/eureka_pagos.ts': eureka_pagos,'04-sb/eureka/eureka_pyros.ts': eureka_pyros,'04-sb/hunts/yanxia.ts': yanxia,'04-sb/map/the_hidden_canals_of_uznair.ts': the_hidden_canals_of_uznair,'04-sb/map/the_lost_canals_of_uznair.ts': the_lost_canals_of_uznair,'04-sb/map/the_shifting_altars_of_uznair.ts': the_shifting_altars_of_uznair,'04-sb/raid/o10n.ts': o10n,'04-sb/raid/o10n.txt': raid_o10n_namespaceObject,'04-sb/raid/o10s.ts': o10s,'04-sb/raid/o10s.txt': raid_o10s_namespaceObject,'04-sb/raid/o11n.ts': o11n,'04-sb/raid/o11n.txt': raid_o11n_namespaceObject,'04-sb/raid/o11s.ts': o11s,'04-sb/raid/o11s.txt': raid_o11s_namespaceObject,'04-sb/raid/o12n.ts': o12n,'04-sb/raid/o12n.txt': raid_o12n_namespaceObject,'04-sb/raid/o12s.ts': o12s,'04-sb/raid/o12s.txt': raid_o12s_namespaceObject,'04-sb/raid/o1n.ts': o1n,'04-sb/raid/o1n.txt': raid_o1n_namespaceObject,'04-sb/raid/o1s.ts': o1s,'04-sb/raid/o1s.txt': raid_o1s_namespaceObject,'04-sb/raid/o2n.ts': o2n,'04-sb/raid/o2n.txt': raid_o2n_namespaceObject,'04-sb/raid/o2s.ts': o2s,'04-sb/raid/o2s.txt': raid_o2s_namespaceObject,'04-sb/raid/o3n.ts': o3n,'04-sb/raid/o3n.txt': raid_o3n_namespaceObject,'04-sb/raid/o3s.ts': o3s,'04-sb/raid/o3s.txt': raid_o3s_namespaceObject,'04-sb/raid/o4n.ts': o4n,'04-sb/raid/o4n.txt': raid_o4n_namespaceObject,'04-sb/raid/o4s.ts': o4s,'04-sb/raid/o4s.txt': raid_o4s_namespaceObject,'04-sb/raid/o5n.ts': o5n,'04-sb/raid/o5n.txt': raid_o5n_namespaceObject,'04-sb/raid/o5s.ts': o5s,'04-sb/raid/o5s.txt': raid_o5s_namespaceObject,'04-sb/raid/o6n.ts': o6n,'04-sb/raid/o6n.txt': raid_o6n_namespaceObject,'04-sb/raid/o6s.ts': o6s,'04-sb/raid/o6s.txt': raid_o6s_namespaceObject,'04-sb/raid/o7n.ts': o7n,'04-sb/raid/o7n.txt': raid_o7n_namespaceObject,'04-sb/raid/o7s.ts': o7s,'04-sb/raid/o7s.txt': raid_o7s_namespaceObject,'04-sb/raid/o8n.ts': o8n,'04-sb/raid/o8n.txt': raid_o8n_namespaceObject,'04-sb/raid/o8s.ts': o8s,'04-sb/raid/o8s.txt': raid_o8s_namespaceObject,'04-sb/raid/o9n.ts': o9n,'04-sb/raid/o9n.txt': raid_o9n_namespaceObject,'04-sb/raid/o9s.ts': o9s,'04-sb/raid/o9s.txt': raid_o9s_namespaceObject,'04-sb/trial/byakko-ex.ts': byakko_ex,'04-sb/trial/byakko-ex.txt': trial_byakko_ex_namespaceObject,'04-sb/trial/byakko.ts': byakko,'04-sb/trial/byakko.txt': trial_byakko_namespaceObject,'04-sb/trial/lakshmi-ex.ts': lakshmi_ex,'04-sb/trial/lakshmi-ex.txt': trial_lakshmi_ex_namespaceObject,'04-sb/trial/lakshmi.ts': lakshmi,'04-sb/trial/lakshmi.txt': trial_lakshmi_namespaceObject,'04-sb/trial/rathalos-ex.ts': rathalos_ex,'04-sb/trial/rathalos.ts': rathalos,'04-sb/trial/seiryu-ex.ts': seiryu_ex,'04-sb/trial/seiryu-ex.txt': trial_seiryu_ex_namespaceObject,'04-sb/trial/seiryu.ts': seiryu,'04-sb/trial/seiryu.txt': trial_seiryu_namespaceObject,'04-sb/trial/shinryu-ex.ts': shinryu_ex,'04-sb/trial/shinryu-ex.txt': trial_shinryu_ex_namespaceObject,'04-sb/trial/shinryu.ts': shinryu,'04-sb/trial/shinryu.txt': trial_shinryu_namespaceObject,'04-sb/trial/susano-ex.ts': susano_ex,'04-sb/trial/susano-ex.txt': trial_susano_ex_namespaceObject,'04-sb/trial/susano.ts': susano,'04-sb/trial/susano.txt': trial_susano_namespaceObject,'04-sb/trial/suzaku-ex.ts': suzaku_ex,'04-sb/trial/suzaku-ex.txt': trial_suzaku_ex_namespaceObject,'04-sb/trial/suzaku.ts': suzaku,'04-sb/trial/suzaku.txt': trial_suzaku_namespaceObject,'04-sb/trial/tsukuyomi-ex.ts': tsukuyomi_ex,'04-sb/trial/tsukuyomi-ex.txt': trial_tsukuyomi_ex_namespaceObject,'04-sb/trial/tsukuyomi.ts': tsukuyomi,'04-sb/trial/tsukuyomi.txt': trial_tsukuyomi_namespaceObject,'04-sb/trial/yojimbo.ts': yojimbo,'04-sb/trial/yojimbo.txt': trial_yojimbo_namespaceObject,'04-sb/ultimate/ultima_weapon_ultimate.ts': ultima_weapon_ultimate,'04-sb/ultimate/ultima_weapon_ultimate.txt': ultimate_ultima_weapon_ultimate_namespaceObject,'04-sb/ultimate/unending_coil_ultimate.ts': unending_coil_ultimate,'04-sb/ultimate/unending_coil_ultimate.txt': ultimate_unending_coil_ultimate_namespaceObject,'05-shb/alliance/the_copied_factory.ts': the_copied_factory,'05-shb/alliance/the_copied_factory.txt': alliance_the_copied_factory_namespaceObject,'05-shb/alliance/the_puppets_bunker.ts': the_puppets_bunker,'05-shb/alliance/the_puppets_bunker.txt': alliance_the_puppets_bunker_namespaceObject,'05-shb/alliance/the_tower_at_paradigms_breach.ts': the_tower_at_paradigms_breach,'05-shb/alliance/the_tower_at_paradigms_breach.txt': alliance_the_tower_at_paradigms_breach_namespaceObject,'05-shb/dungeon/akadaemia_anyder.ts': akadaemia_anyder,'05-shb/dungeon/akadaemia_anyder.txt': dungeon_akadaemia_anyder_namespaceObject,'05-shb/dungeon/amaurot.ts': amaurot,'05-shb/dungeon/amaurot.txt': dungeon_amaurot_namespaceObject,'05-shb/dungeon/anamnesis_anyder.ts': anamnesis_anyder,'05-shb/dungeon/anamnesis_anyder.txt': dungeon_anamnesis_anyder_namespaceObject,'05-shb/dungeon/dohn_mheg.ts': dohn_mheg,'05-shb/dungeon/dohn_mheg.txt': dungeon_dohn_mheg_namespaceObject,'05-shb/dungeon/heroes_gauntlet.ts': heroes_gauntlet,'05-shb/dungeon/heroes_gauntlet.txt': dungeon_heroes_gauntlet_namespaceObject,'05-shb/dungeon/holminster_switch.ts': holminster_switch,'05-shb/dungeon/holminster_switch.txt': dungeon_holminster_switch_namespaceObject,'05-shb/dungeon/malikahs_well.ts': malikahs_well,'05-shb/dungeon/malikahs_well.txt': dungeon_malikahs_well_namespaceObject,'05-shb/dungeon/matoyas_relict.ts': matoyas_relict,'05-shb/dungeon/matoyas_relict.txt': dungeon_matoyas_relict_namespaceObject,'05-shb/dungeon/mt_gulg.ts': mt_gulg,'05-shb/dungeon/mt_gulg.txt': dungeon_mt_gulg_namespaceObject,'05-shb/dungeon/paglthan.ts': paglthan,'05-shb/dungeon/paglthan.txt': dungeon_paglthan_namespaceObject,'05-shb/dungeon/qitana_ravel.ts': qitana_ravel,'05-shb/dungeon/qitana_ravel.txt': dungeon_qitana_ravel_namespaceObject,'05-shb/dungeon/the_grand_cosmos.ts': the_grand_cosmos,'05-shb/dungeon/the_grand_cosmos.txt': dungeon_the_grand_cosmos_namespaceObject,'05-shb/dungeon/twinning.ts': twinning,'05-shb/dungeon/twinning.txt': dungeon_twinning_namespaceObject,'05-shb/etc/the_diadem.ts': the_diadem,'05-shb/eureka/bozjan_southern_front.ts': bozjan_southern_front,'05-shb/eureka/bozjan_southern_front.txt': eureka_bozjan_southern_front_namespaceObject,'05-shb/eureka/delubrum_reginae.ts': delubrum_reginae,'05-shb/eureka/delubrum_reginae.txt': eureka_delubrum_reginae_namespaceObject,'05-shb/eureka/delubrum_reginae_savage.ts': delubrum_reginae_savage,'05-shb/eureka/delubrum_reginae_savage.txt': eureka_delubrum_reginae_savage_namespaceObject,'05-shb/eureka/zadnor.ts': zadnor,'05-shb/eureka/zadnor.txt': eureka_zadnor_namespaceObject,'05-shb/hunts/amh_araeng.ts': amh_araeng,'05-shb/hunts/il_mheg.ts': il_mheg,'05-shb/hunts/kholusia.ts': kholusia,'05-shb/hunts/lakeland.ts': lakeland,'05-shb/hunts/ss_rank.ts': ss_rank,'05-shb/hunts/the_raktika_greatwood.ts': the_raktika_greatwood,'05-shb/hunts/the_tempest.ts': the_tempest,'05-shb/map/the_dungeons_of_lyhe_ghiah.ts': the_dungeons_of_lyhe_ghiah,'05-shb/map/the_shifting_oubliettes_of_lyhe_ghiah.ts': the_shifting_oubliettes_of_lyhe_ghiah,'05-shb/raid/e10n.ts': e10n,'05-shb/raid/e10n.txt': raid_e10n_namespaceObject,'05-shb/raid/e10s.ts': e10s,'05-shb/raid/e10s.txt': raid_e10s_namespaceObject,'05-shb/raid/e11n.ts': e11n,'05-shb/raid/e11n.txt': raid_e11n_namespaceObject,'05-shb/raid/e11s.ts': e11s,'05-shb/raid/e11s.txt': raid_e11s_namespaceObject,'05-shb/raid/e12n.ts': e12n,'05-shb/raid/e12n.txt': raid_e12n_namespaceObject,'05-shb/raid/e12s.ts': e12s,'05-shb/raid/e12s.txt': raid_e12s_namespaceObject,'05-shb/raid/e1n.ts': e1n,'05-shb/raid/e1n.txt': raid_e1n_namespaceObject,'05-shb/raid/e1s.ts': e1s,'05-shb/raid/e1s.txt': raid_e1s_namespaceObject,'05-shb/raid/e2n.ts': e2n,'05-shb/raid/e2n.txt': raid_e2n_namespaceObject,'05-shb/raid/e2s.ts': e2s,'05-shb/raid/e2s.txt': raid_e2s_namespaceObject,'05-shb/raid/e3n.ts': e3n,'05-shb/raid/e3n.txt': raid_e3n_namespaceObject,'05-shb/raid/e3s.ts': e3s,'05-shb/raid/e3s.txt': raid_e3s_namespaceObject,'05-shb/raid/e4n.ts': e4n,'05-shb/raid/e4n.txt': raid_e4n_namespaceObject,'05-shb/raid/e4s.ts': e4s,'05-shb/raid/e4s.txt': raid_e4s_namespaceObject,'05-shb/raid/e5n.ts': e5n,'05-shb/raid/e5n.txt': raid_e5n_namespaceObject,'05-shb/raid/e5s.ts': e5s,'05-shb/raid/e5s.txt': raid_e5s_namespaceObject,'05-shb/raid/e6n.ts': e6n,'05-shb/raid/e6n.txt': raid_e6n_namespaceObject,'05-shb/raid/e6s.ts': e6s,'05-shb/raid/e6s.txt': raid_e6s_namespaceObject,'05-shb/raid/e7n.ts': e7n,'05-shb/raid/e7n.txt': raid_e7n_namespaceObject,'05-shb/raid/e7s.ts': e7s,'05-shb/raid/e7s.txt': raid_e7s_namespaceObject,'05-shb/raid/e8n.ts': e8n,'05-shb/raid/e8n.txt': raid_e8n_namespaceObject,'05-shb/raid/e8s.ts': e8s,'05-shb/raid/e8s.txt': raid_e8s_namespaceObject,'05-shb/raid/e9n.ts': e9n,'05-shb/raid/e9n.txt': raid_e9n_namespaceObject,'05-shb/raid/e9s.ts': e9s,'05-shb/raid/e9s.txt': raid_e9s_namespaceObject,'05-shb/trial/diamond_weapon-ex.ts': diamond_weapon_ex,'05-shb/trial/diamond_weapon-ex.txt': trial_diamond_weapon_ex_namespaceObject,'05-shb/trial/diamond_weapon.ts': diamond_weapon,'05-shb/trial/diamond_weapon.txt': trial_diamond_weapon_namespaceObject,'05-shb/trial/emerald_weapon-ex.ts': emerald_weapon_ex,'05-shb/trial/emerald_weapon-ex.txt': trial_emerald_weapon_ex_namespaceObject,'05-shb/trial/emerald_weapon.ts': emerald_weapon,'05-shb/trial/emerald_weapon.txt': trial_emerald_weapon_namespaceObject,'05-shb/trial/hades-ex.ts': hades_ex,'05-shb/trial/hades-ex.txt': trial_hades_ex_namespaceObject,'05-shb/trial/hades.ts': hades,'05-shb/trial/hades.txt': trial_hades_namespaceObject,'05-shb/trial/innocence-ex.ts': innocence_ex,'05-shb/trial/innocence-ex.txt': trial_innocence_ex_namespaceObject,'05-shb/trial/innocence.ts': innocence,'05-shb/trial/innocence.txt': trial_innocence_namespaceObject,'05-shb/trial/levi-un.ts': levi_un,'05-shb/trial/levi-un.txt': trial_levi_un_namespaceObject,'05-shb/trial/ruby_weapon-ex.ts': ruby_weapon_ex,'05-shb/trial/ruby_weapon-ex.txt': trial_ruby_weapon_ex_namespaceObject,'05-shb/trial/ruby_weapon.ts': ruby_weapon,'05-shb/trial/ruby_weapon.txt': trial_ruby_weapon_namespaceObject,'05-shb/trial/shiva-un.ts': shiva_un,'05-shb/trial/shiva-un.txt': trial_shiva_un_namespaceObject,'05-shb/trial/titan-un.ts': titan_un,'05-shb/trial/titan-un.txt': trial_titan_un_namespaceObject,'05-shb/trial/titania-ex.ts': titania_ex,'05-shb/trial/titania-ex.txt': trial_titania_ex_namespaceObject,'05-shb/trial/titania.ts': titania,'05-shb/trial/titania.txt': trial_titania_namespaceObject,'05-shb/trial/varis-ex.ts': varis_ex,'05-shb/trial/varis-ex.txt': trial_varis_ex_namespaceObject,'05-shb/trial/wol-ex.ts': wol_ex,'05-shb/trial/wol-ex.txt': trial_wol_ex_namespaceObject,'05-shb/trial/wol.ts': wol,'05-shb/trial/wol.txt': trial_wol_namespaceObject,'05-shb/ultimate/the_epic_of_alexander.ts': the_epic_of_alexander,'05-shb/ultimate/the_epic_of_alexander.txt': ultimate_the_epic_of_alexander_namespaceObject,'06-ew/alliance/aglaia.ts': aglaia,'06-ew/alliance/aglaia.txt': alliance_aglaia_namespaceObject,'06-ew/alliance/euphrosyne.ts': euphrosyne,'06-ew/alliance/euphrosyne.txt': alliance_euphrosyne_namespaceObject,'06-ew/alliance/thaleia.ts': thaleia,'06-ew/alliance/thaleia.txt': alliance_thaleia_namespaceObject,'06-ew/deepdungeon/eureka_orthos_floors_01-10.ts': eureka_orthos_floors_01_10,'06-ew/deepdungeon/eureka_orthos_floors_11-20.ts': eureka_orthos_floors_11_20,'06-ew/deepdungeon/eureka_orthos_floors_21-30.ts': eureka_orthos_floors_21_30,'06-ew/deepdungeon/eureka_orthos_floors_31-40.ts': eureka_orthos_floors_31_40,'06-ew/deepdungeon/eureka_orthos_floors_41-50.ts': eureka_orthos_floors_41_50,'06-ew/deepdungeon/eureka_orthos_floors_51-60.ts': eureka_orthos_floors_51_60,'06-ew/deepdungeon/eureka_orthos_floors_61-70.ts': eureka_orthos_floors_61_70,'06-ew/deepdungeon/eureka_orthos_floors_71-80.ts': eureka_orthos_floors_71_80,'06-ew/deepdungeon/eureka_orthos_floors_81-90.ts': eureka_orthos_floors_81_90,'06-ew/deepdungeon/eureka_orthos_floors_91-100.ts': eureka_orthos_floors_91_100,'06-ew/deepdungeon/eureka_orthos_general.ts': eureka_orthos_general,'06-ew/dungeon/aetherfont.ts': aetherfont,'06-ew/dungeon/aetherfont.txt': dungeon_aetherfont_namespaceObject,'06-ew/dungeon/aloalo_island.ts': aloalo_island,'06-ew/dungeon/aloalo_island.txt': dungeon_aloalo_island_namespaceObject,'06-ew/dungeon/alzadaals_legacy.ts': alzadaals_legacy,'06-ew/dungeon/alzadaals_legacy.txt': dungeon_alzadaals_legacy_namespaceObject,'06-ew/dungeon/another_aloalo_island-savage.ts': another_aloalo_island_savage,'06-ew/dungeon/another_aloalo_island-savage.txt': dungeon_another_aloalo_island_savage_namespaceObject,'06-ew/dungeon/another_aloalo_island.ts': another_aloalo_island,'06-ew/dungeon/another_aloalo_island.txt': dungeon_another_aloalo_island_namespaceObject,'06-ew/dungeon/another_mount_rokkon-savage.ts': another_mount_rokkon_savage,'06-ew/dungeon/another_mount_rokkon-savage.txt': dungeon_another_mount_rokkon_savage_namespaceObject,'06-ew/dungeon/another_mount_rokkon.ts': another_mount_rokkon,'06-ew/dungeon/another_mount_rokkon.txt': dungeon_another_mount_rokkon_namespaceObject,'06-ew/dungeon/another_sildihn_subterrane-savage.ts': another_sildihn_subterrane_savage,'06-ew/dungeon/another_sildihn_subterrane-savage.txt': dungeon_another_sildihn_subterrane_savage_namespaceObject,'06-ew/dungeon/another_sildihn_subterrane.ts': another_sildihn_subterrane,'06-ew/dungeon/another_sildihn_subterrane.txt': dungeon_another_sildihn_subterrane_namespaceObject,'06-ew/dungeon/ktisis_hyperboreia.ts': ktisis_hyperboreia,'06-ew/dungeon/ktisis_hyperboreia.txt': dungeon_ktisis_hyperboreia_namespaceObject,'06-ew/dungeon/lapis_manalis.ts': lapis_manalis,'06-ew/dungeon/lapis_manalis.txt': dungeon_lapis_manalis_namespaceObject,'06-ew/dungeon/mount_rokkon.ts': mount_rokkon,'06-ew/dungeon/mount_rokkon.txt': dungeon_mount_rokkon_namespaceObject,'06-ew/dungeon/smileton.ts': smileton,'06-ew/dungeon/smileton.txt': dungeon_smileton_namespaceObject,'06-ew/dungeon/stigma_dreamscape.ts': stigma_dreamscape,'06-ew/dungeon/stigma_dreamscape.txt': dungeon_stigma_dreamscape_namespaceObject,'06-ew/dungeon/the_aitiascope.ts': the_aitiascope,'06-ew/dungeon/the_aitiascope.txt': dungeon_the_aitiascope_namespaceObject,'06-ew/dungeon/the_dead_ends.ts': the_dead_ends,'06-ew/dungeon/the_dead_ends.txt': dungeon_the_dead_ends_namespaceObject,'06-ew/dungeon/the_fell_court_of_troia.ts': the_fell_court_of_troia,'06-ew/dungeon/the_fell_court_of_troia.txt': dungeon_the_fell_court_of_troia_namespaceObject,'06-ew/dungeon/the_lunar_subterrane.ts': the_lunar_subterrane,'06-ew/dungeon/the_lunar_subterrane.txt': dungeon_the_lunar_subterrane_namespaceObject,'06-ew/dungeon/the_sildihn_subterrane.ts': the_sildihn_subterrane,'06-ew/dungeon/the_sildihn_subterrane.txt': dungeon_the_sildihn_subterrane_namespaceObject,'06-ew/dungeon/the_tower_of_babil.ts': the_tower_of_babil,'06-ew/dungeon/the_tower_of_babil.txt': dungeon_the_tower_of_babil_namespaceObject,'06-ew/dungeon/the_tower_of_zot.ts': the_tower_of_zot,'06-ew/dungeon/the_tower_of_zot.txt': dungeon_the_tower_of_zot_namespaceObject,'06-ew/dungeon/vanaspati.ts': vanaspati,'06-ew/dungeon/vanaspati.txt': dungeon_vanaspati_namespaceObject,'06-ew/hunts/elpis.ts': elpis,'06-ew/hunts/garlemald.ts': garlemald,'06-ew/hunts/labyrinthos.ts': labyrinthos,'06-ew/hunts/mare_lamentorum.ts': mare_lamentorum,'06-ew/hunts/ss_rank.ts': hunts_ss_rank,'06-ew/hunts/thavnair.ts': thavnair,'06-ew/hunts/ultima_thule.ts': ultima_thule,'06-ew/map/the_excitatron_6000.ts': the_excitatron_6000,'06-ew/map/the_shifting_gymnasion_agonon.ts': the_shifting_gymnasion_agonon,'06-ew/raid/p10n.ts': p10n,'06-ew/raid/p10n.txt': raid_p10n_namespaceObject,'06-ew/raid/p10s.ts': p10s,'06-ew/raid/p10s.txt': raid_p10s_namespaceObject,'06-ew/raid/p11n.ts': p11n,'06-ew/raid/p11n.txt': raid_p11n_namespaceObject,'06-ew/raid/p11s.ts': p11s,'06-ew/raid/p11s.txt': raid_p11s_namespaceObject,'06-ew/raid/p12n.ts': p12n,'06-ew/raid/p12n.txt': raid_p12n_namespaceObject,'06-ew/raid/p12s.ts': p12s,'06-ew/raid/p12s.txt': raid_p12s_namespaceObject,'06-ew/raid/p1n.ts': p1n,'06-ew/raid/p1n.txt': raid_p1n_namespaceObject,'06-ew/raid/p1s.ts': p1s,'06-ew/raid/p1s.txt': raid_p1s_namespaceObject,'06-ew/raid/p2n.ts': p2n,'06-ew/raid/p2n.txt': raid_p2n_namespaceObject,'06-ew/raid/p2s.ts': p2s,'06-ew/raid/p2s.txt': raid_p2s_namespaceObject,'06-ew/raid/p3n.ts': p3n,'06-ew/raid/p3n.txt': raid_p3n_namespaceObject,'06-ew/raid/p3s.ts': p3s,'06-ew/raid/p3s.txt': raid_p3s_namespaceObject,'06-ew/raid/p4n.ts': p4n,'06-ew/raid/p4n.txt': raid_p4n_namespaceObject,'06-ew/raid/p4s.ts': p4s,'06-ew/raid/p4s.txt': raid_p4s_namespaceObject,'06-ew/raid/p5n.ts': p5n,'06-ew/raid/p5n.txt': raid_p5n_namespaceObject,'06-ew/raid/p5s.ts': p5s,'06-ew/raid/p5s.txt': raid_p5s_namespaceObject,'06-ew/raid/p6n.ts': p6n,'06-ew/raid/p6n.txt': raid_p6n_namespaceObject,'06-ew/raid/p6s.ts': p6s,'06-ew/raid/p6s.txt': raid_p6s_namespaceObject,'06-ew/raid/p7n.ts': p7n,'06-ew/raid/p7n.txt': raid_p7n_namespaceObject,'06-ew/raid/p7s.ts': p7s,'06-ew/raid/p7s.txt': raid_p7s_namespaceObject,'06-ew/raid/p8n.ts': p8n,'06-ew/raid/p8n.txt': raid_p8n_namespaceObject,'06-ew/raid/p8s.ts': p8s,'06-ew/raid/p8s.txt': raid_p8s_namespaceObject,'06-ew/raid/p9n.ts': p9n,'06-ew/raid/p9n.txt': raid_p9n_namespaceObject,'06-ew/raid/p9s.ts': p9s,'06-ew/raid/p9s.txt': raid_p9s_namespaceObject,'06-ew/trial/asura.ts': asura,'06-ew/trial/asura.txt': trial_asura_namespaceObject,'06-ew/trial/barbariccia-ex.ts': barbariccia_ex,'06-ew/trial/barbariccia-ex.txt': trial_barbariccia_ex_namespaceObject,'06-ew/trial/barbariccia.ts': barbariccia,'06-ew/trial/barbariccia.txt': trial_barbariccia_namespaceObject,'06-ew/trial/endsinger-ex.ts': endsinger_ex,'06-ew/trial/endsinger-ex.txt': trial_endsinger_ex_namespaceObject,'06-ew/trial/endsinger.ts': endsinger,'06-ew/trial/endsinger.txt': trial_endsinger_namespaceObject,'06-ew/trial/golbez-ex.ts': golbez_ex,'06-ew/trial/golbez-ex.txt': trial_golbez_ex_namespaceObject,'06-ew/trial/golbez.ts': golbez,'06-ew/trial/golbez.txt': trial_golbez_namespaceObject,'06-ew/trial/hydaelyn-ex.ts': hydaelyn_ex,'06-ew/trial/hydaelyn-ex.txt': trial_hydaelyn_ex_namespaceObject,'06-ew/trial/hydaelyn.ts': hydaelyn,'06-ew/trial/hydaelyn.txt': trial_hydaelyn_namespaceObject,'06-ew/trial/rubicante-ex.ts': rubicante_ex,'06-ew/trial/rubicante-ex.txt': trial_rubicante_ex_namespaceObject,'06-ew/trial/rubicante.ts': rubicante,'06-ew/trial/rubicante.txt': trial_rubicante_namespaceObject,'06-ew/trial/sephirot-un.ts': sephirot_un,'06-ew/trial/sephirot-un.txt': trial_sephirot_un_namespaceObject,'06-ew/trial/sophia-un.ts': sophia_un,'06-ew/trial/sophia-un.txt': trial_sophia_un_namespaceObject,'06-ew/trial/thordan-un.ts': thordan_un,'06-ew/trial/thordan-un.txt': trial_thordan_un_namespaceObject,'06-ew/trial/ultima-un.ts': ultima_un,'06-ew/trial/ultima-un.txt': trial_ultima_un_namespaceObject,'06-ew/trial/zeromus-ex.ts': zeromus_ex,'06-ew/trial/zeromus-ex.txt': trial_zeromus_ex_namespaceObject,'06-ew/trial/zeromus.ts': zeromus,'06-ew/trial/zeromus.txt': trial_zeromus_namespaceObject,'06-ew/trial/zodiark-ex.ts': zodiark_ex,'06-ew/trial/zodiark-ex.txt': trial_zodiark_ex_namespaceObject,'06-ew/trial/zodiark.ts': zodiark,'06-ew/trial/zodiark.txt': trial_zodiark_namespaceObject,'06-ew/trial/zurvan-un.ts': zurvan_un,'06-ew/trial/zurvan-un.txt': trial_zurvan_un_namespaceObject,'06-ew/ultimate/dragonsongs_reprise_ultimate.ts': dragonsongs_reprise_ultimate,'06-ew/ultimate/dragonsongs_reprise_ultimate.txt': ultimate_dragonsongs_reprise_ultimate_namespaceObject,'06-ew/ultimate/the_omega_protocol.ts': the_omega_protocol,'06-ew/ultimate/the_omega_protocol.txt': ultimate_the_omega_protocol_namespaceObject,});

/***/ })

}]);